"use strict";
const electron = require("electron");
const path = require("path");
const child_process = require("child_process");
const fs = require("fs");
const os = require("os");
const url = require("node:url");
function _interopNamespaceDefault(e) {
  const n = Object.create(null, { [Symbol.toStringTag]: { value: "Module" } });
  if (e) {
    for (const k in e) {
      if (k !== "default") {
        const d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: () => e[k]
        });
      }
    }
  }
  n.default = e;
  return Object.freeze(n);
}
const path__namespace = /* @__PURE__ */ _interopNamespaceDefault(path);
const fs__namespace = /* @__PURE__ */ _interopNamespaceDefault(fs);
const os__namespace = /* @__PURE__ */ _interopNamespaceDefault(os);
const obj = {
  "服务正在下载中……": {
    en: "Service download is in progress ......",
    "zh-HANT": "服務正在下載中……",
    fr: "Téléchargement du service en cours ......",
    ru: "'Идет загрузка сервиса ......",
    es: "'Descarga de servicio en curso ......",
    ar: "جاري تنزيل الخدمة ...",
    eo: "La servo elŝutas..."
  },
  "服务下载已取消": {
    en: "Service download has been cancelled",
    "zh-HANT": "服務下載已取消",
    fr: "Le téléchargement du service a été annulé",
    ru: "Загрузка услуги была отменена",
    es: "La descarga del servicio ha sido cancelada",
    ar: "تم إلغاء تنزيل الخدمة",
    eo: "Serva elŝuto nuligita"
  },
  "服务已下载": {
    en: "Service has been downloaded",
    "zh-HANT": "服務已下載",
    fr: "Le service a été téléchargé",
    ru: "Услуга была загружена",
    es: "El servicio se ha descargado",
    ar: "الخدمة التي تم تنزيلها",
    eo: "servo elŝutita"
  },
  "，正准备安装相关的依赖，请允许安装": {
    en: ", is preparing to install the relevant dependencies, please allow installation",
    "zh-HANT": "，正準備安裝相關的依賴，請允許安裝",
    fr: "Veuillez permettre l'installation des dépendances pertinentes pendant qu'elles sont préparées.",
    ru: "Пожалуйста, разрешите установку соответствующих зависимостей по мере их подготовки",
    es: "Por favor, permita la instalación de las dependencias pertinentes mientras se preparan",
    ar: "، تستعد لتثبيت التبعيات ذات الصلة ، يرجى السماح بالتثبيت",
    eo: ", prepariĝas por instali rilatajn dependecojn, bonvolu permesi la instaladon"
  },
  "自动搜索": {
    en: "Auto search",
    "zh-HANT": "自動搜索",
    fr: "Recherche automatique",
    ru: "Автоматический поиск",
    es: "Búsqueda automática",
    ar: "البحث التلقائي",
    eo: "Aŭtomata Serĉo"
  },
  "截屏搜索": {
    en: "Screenshot search",
    "zh-HANT": "截屏搜索",
    fr: "Recherche sur l'écran",
    ru: "Поиск по экрану",
    es: "Búsqueda en pantalla",
    ar: "البحث عن لقطة شاشة",
    eo: "Serĉo de ekrankopio"
  },
  "选中搜索": {
    en: "Selected search",
    "zh-HANT": "選中搜索",
    fr: "Sélectionner la recherche",
    ru: "Выберите поиск",
    es: "Seleccione la búsqueda",
    ar: "تحقق من البحث",
    eo: "Kontrolu serĉon"
  },
  "剪贴板搜索": {
    en: "Clipboard search",
    "zh-HANT": "剪貼板搜索",
    fr: "Recherche dans le presse-papiers",
    ru: "Поиск в буфере обмена",
    es: "Búsqueda en el portapapeles",
    ar: "البحث في الحافظة",
    eo: "serĉo de tondujo"
  },
  "失焦关闭": {
    en: "Out of focus off",
    "zh-HANT": "失焦關閉",
    fr: "Désactivation de la mise au point",
    ru: "Выключение фокуса",
    es: "Desenfoque apagado",
    ar: "خارج التركيز",
    eo: "Malfokusa for"
  },
  "主页面": {
    en: "Main Page",
    "zh-HANT": "主頁面",
    fr: "Page principale",
    ru: "Главная страница",
    es: "Página principal",
    ar: "الصفحة الرئيسية",
    eo: "hejmpaĝo"
  },
  "浏览器打开": {
    en: "Browser open",
    "zh-HANT": "瀏覽器打開",
    fr: "Navigateur ouvert",
    ru: "Браузер открыт",
    es: "Navegador abierto",
    ar: "المتصفح مفتوح",
    eo: "retumilo malfermita"
  },
  "设置": {
    en: "Settings",
    "zh-HANT": "設置",
    fr: "Paramètres",
    ru: "Настройки",
    es: "Ajustes",
    ar: "اقامة",
    eo: "agordi"
  },
  "教程帮助": {
    en: "Tutorial help",
    "zh-HANT": "教程幫助",
    fr: "Tutoriels d'aide",
    ru: "Помощь в обучении",
    es: "Ayuda de los tutoriales",
    ar: "تعليمات البرنامج التعليمي",
    eo: "lernilo helpo"
  },
  "重启": {
    en: "Reboot",
    "zh-HANT": "重啟",
    fr: "Redémarrer",
    ru: "Перезапустить",
    es: "Reiniciar",
    ar: "اعادة التشغيل",
    eo: "rekomenci"
  },
  "退出": {
    en: "Exit",
    "zh-HANT": "退出",
    fr: "Sortie",
    ru: "Выход",
    es: "Salida",
    ar: "استقال",
    eo: "ĉesi"
  },
  "已经在后台启动": {
    en: "Already started in background",
    "zh-HANT": "已經在後台啟動",
    fr: "Déjà commencé en arrière-plan",
    ru: "Уже начался в фоновом режиме",
    es: "Ya ha comenzado en el fondo",
    ar: "بدأت بالفعل في الخلفية",
    eo: "jam komencita en la fono"
  },
  "服务未下载": {
    en: "Service not downloaded",
    "zh-HANT": "服務未下載",
    fr: "Service non téléchargé",
    ru: "Сервис не загружен",
    es: "Servicio no descargado",
    ar: "لم يتم تنزيل الخدمة",
    eo: "Servo ne elŝutita"
  },
  "离线OCR 服务未安装": {
    en: "Offline OCR service is not installed",
    "zh-HANT": "離線OCR 服務未安裝",
    fr: "Le service OCR hors ligne n'est pas installé",
    ru: "Автономная служба OCR не установлена",
    es: "El servicio OCR offline no está instalado",
    ar: "لم يتم تثبيت خدمة OCR دون اتصال",
    eo: "Senreta OCR-servo ne estas instalita"
  },
  "需要下载才能使用": {
    en: "Need to download to use",
    "zh-HANT": "需要下載才能使用",
    fr: "Doit être téléchargé pour fonctionner",
    ru: "Необходимо загрузить для работы",
    es: "Es necesario descargarlo para que funcione",
    ar: "يتطلب التنزيل للاستخدام",
    eo: "Necesas elŝuto por uzi"
  },
  "不再提示": {
    en: "No more prompts",
    "zh-HANT": "不再提示",
    fr: "Plus de message d'alerte",
    ru: "Больше не запрашивается",
    es: "Ya no se le pide que lo haga",
    ar: "لا تذكر مرة أخرى",
    eo: "Ne rememorigu"
  },
  "下载(约": {
    en: "Download (approx.",
    "zh-HANT": "下載(約",
    fr: "Téléchargement (environ)",
    ru: "Загрузка (приблизительно)",
    es: "Descarga (aprox.)",
    ar: "تنزيل (تقريبًا.",
    eo: "elŝutu (ĉ."
  },
  "前往 设置": {
    en: "Go to Settings",
    "zh-HANT": "前往 設置",
    fr: "Allez dans les paramètres",
    ru: 'Перейдите в раздел "Настройки',
    es: "Ir a Ajustes",
    ar: "اذهب للاعدادات",
    eo: "iru al agordoj"
  },
  "取消": {
    en: "Cancel",
    "zh-HANT": "取消",
    fr: "Annuler",
    ru: "Отмена",
    es: "Cancelar",
    ar: "يلغي",
    eo: "Nuligi"
  },
  "服务需要升级": {
    en: "Service needs to be upgraded",
    "zh-HANT": "服務需要升級",
    fr: "Le service doit être amélioré",
    ru: "Сервис нуждается в модернизации",
    es: "Hay que mejorar el servicio",
    ar: "الخدمة بحاجة إلى ترقية",
    eo: "Servo devas esti ĝisdatigita"
  },
  "离线OCR 服务版本较旧": {
    en: "Older version of offline OCR service",
    "zh-HANT": "離線OCR 服務版本較舊",
    fr: "La version du service OCR hors ligne est ancienne",
    ru: "Версия автономной службы OCR устарела",
    es: "La versión del servicio OCR sin conexión es antigua",
    ar: "إصدار خدمة OCR في وضع عدم الاتصال أقدم",
    eo: "Senreta OCR-servo versio estas pli malnova"
  },
  "服务下载失败": {
    en: "Service download failed",
    "zh-HANT": "服務下載失敗",
    fr: "Échec du téléchargement du service",
    ru: "Загрузка службы не удалась",
    es: "Fallo en la descarga del servicio",
    ar: "فشل تنزيل الخدمة",
    eo: "Serva elŝuto malsukcesis"
  },
  "离线OCR 服务版本下载失败": {
    en: "Offline OCR service version download failed",
    "zh-HANT": "離線OCR 服務版本下載失敗",
    fr: "Le téléchargement de la version hors ligne du service OCR a échoué.",
    ru: "Загрузка автономной версии службы OCR не удалась",
    es: "La descarga de la versión del servicio OCR sin conexión ha fallado",
    ar: "فشل تنزيل إصدار خدمة OCR في وضع عدم الاتصال",
    eo: "Senreta OCR-servo-elŝuto malsukcesis"
  },
  "请前往网站手动下载": {
    en: "Please go to the website to download manually",
    "zh-HANT": "請前往網站手動下載",
    fr: "Veuillez vous rendre sur le site web pour télécharger manuellement",
    ru: "Пожалуйста, перейдите на веб-сайт для загрузки вручную",
    es: "Por favor, vaya al sitio web para descargar manualmente",
    ar: "يرجى الذهاب إلى موقع الويب للتنزيل يدويًا",
    eo: "Bonvolu iri al la retejo por elŝuti permane"
  },
  "警告": {
    en: "Warning",
    "zh-HANT": "警告",
    fr: "Avertissement",
    ru: "Предупреждение",
    es: "Advertencia",
    ar: "تحذير",
    eo: "averti"
  },
  "无法识别二维码": {
    en: "QR code not recognised",
    "zh-HANT": "無法識別二維碼",
    fr: "Le code QR n'est pas reconnu",
    ru: "QR-код не распознан",
    es: "Código QR no reconocido",
    ar: "لم يتم التعرف على رمز الاستجابة السريعة",
    eo: "QR-kodo ne rekonita"
  },
  "请尝试重新识别": {
    en: "Please try to re-identify",
    "zh-HANT": "請嘗試重新識別",
    fr: "Veuillez essayer de ré-identifier",
    ru: "Пожалуйста, попробуйте повторно идентифицировать",
    es: "Por favor, intente reidentificar",
    ar: "يرجى محاولة إعادة تحديد الهوية",
    eo: "Bonvolu provi re-identigi"
  },
  "选择要打开应用的位置": {
    en: "Select where you want to open the app",
    "zh-HANT": "選擇要打開應用的位置",
    fr: "Sélectionnez l'emplacement où vous souhaitez ouvrir l'application.",
    ru: "Выберите место, где вы хотите открыть приложение",
    es: "Seleccione la ubicación en la que desea abrir la aplicación",
    ar: "اختر مكان فتح التطبيق",
    eo: "Elektu kie malfermi la apon"
  },
  "选择要保存的位置": {
    en: "Select a location to save to",
    "zh-HANT": "選擇要保存的位置",
    fr: "Sélectionnez l'endroit où vous voulez l'enregistrer",
    ru: "Выберите место сохранения",
    es: "Selecciona dónde quieres guardarlo",
    ar: "اختر مكان الحفظ",
    eo: "Elektu kie konservi"
  },
  "图像": {
    en: "Image",
    "zh-HANT": "圖像",
    fr: "Image",
    ru: "Изображение",
    es: "Imagen",
    ar: "صورة",
    eo: "bildo"
  },
  "保存图像失败": {
    en: "Failed to save image",
    "zh-HANT": "保存圖像失敗",
    fr: "Échec de la sauvegarde de l'image",
    ru: "Не удалось сохранить изображение",
    es: "Fallo al guardar la imagen",
    ar: "فشل حفظ الصورة",
    eo: "Malsukcesis konservi bildon"
  },
  "用户已取消保存": {
    en: "User has cancelled the save",
    "zh-HANT": "用戶已取消保存",
    fr: "L'utilisateur a annulé la sauvegarde",
    ru: "Пользователь отменил сохранение",
    es: "El usuario ha cancelado la grabación",
    ar: "ألغى المستخدم الحفظ",
    eo: "Uzanto nuligis konservadon"
  },
  "FFmpeg 位置错误": {
    en: "FFmpeg location error",
    "zh-HANT": "FFmpeg 位置錯誤",
    fr: "Erreur d'emplacement FFmpeg",
    ru: "Ошибка местоположения FFmpeg",
    es: "Error de ubicación de FFmpeg",
    ar: "خطأ موقع FFmpeg",
    eo: "FFmpeg-loka eraro"
  },
  "FFmpeg 位置错误，请在设置里更正": {
    en: "FFmpeg location is wrong, please correct it in settings",
    "zh-HANT": "FFmpeg 位置錯誤，請在設置裡更正",
    fr: "L'emplacement FFmpeg est incorrect, veuillez le corriger dans les paramètres",
    ru: "Неверное местоположение FFmpeg, исправьте его в настройках.",
    es: "La ubicación de FFmpeg es incorrecta, corríjala en la configuración",
    ar: "موقع FFmpeg خاطئ ، يرجى تصحيحه في الإعدادات",
    eo: "FFmpeg-loko estas malĝusta, bonvolu korekti ĝin en agordoj"
  },
  "FFmpeg 未下载": {
    en: "FFmpeg not downloading",
    "zh-HANT": "FFmpeg 未下載",
    fr: "FFmpeg ne se télécharge pas",
    ru: "FFmpeg не скачивается",
    es: "FFmpeg no se descarga",
    ar: "لا يتم تحميل FFmpeg",
    eo: "FFmpeg ne elŝutas"
  },
  "解压并填写路径到设置": {
    en: "Unzip and fill in the path to the settings",
    "zh-HANT": "解壓並填寫路徑到設置",
    fr: "Décompressez et remplissez le chemin vers les paramètres",
    ru: "Разархивировать и указать путь к настройкам",
    es: "Descomprima y complete la ruta a la configuración",
    ar: "قم بفك الضغط واملأ المسار إلى الإعدادات",
    eo: "Malfermu kaj plenigu la vojon al la agordoj"
  },
  "视频": {
    en: "Video",
    "zh-HANT": "視頻",
    fr: "Vidéo",
    ru: "Видео",
    es: "Vídeo",
    ar: "فيديو",
    eo: "video"
  },
  "保存视频失败": {
    en: "Failed to save video",
    "zh-HANT": "保存視頻失敗",
    fr: "Échec de la sauvegarde de la vidéo",
    ru: "Не удалось сохранить видео",
    es: "No se ha podido guardar el vídeo",
    ar: "فشل حفظ الفيديو",
    eo: "Malsukcesis konservi videon"
  },
  "错误": {
    en: "Error",
    "zh-HANT": "錯誤",
    fr: "Erreur",
    ru: "Ошибка",
    es: "Error",
    ar: "خطأ",
    eo: "eraro"
  },
  "已恢复默认设置，部分设置需要重启": {
    en: "Default settings have been restored, some settings need to be rebooted",
    "zh-HANT": "已恢復默認設置，部分設置需要重啟",
    fr: "Les paramètres par défaut ont été restaurés, certains paramètres doivent être redémarrés.",
    ru: "Настройки по умолчанию были восстановлены, некоторые настройки необходимо перезагрузить",
    es: "Se han restaurado los ajustes por defecto, algunos ajustes necesitan ser reiniciados",
    ar: "تمت استعادة الإعدادات الافتراضية ، تتطلب بعض الإعدادات إعادة التشغيل",
    eo: "Defaŭltaj agordoj estis restarigitaj, iuj agordoj postulas rekomencon"
  },
  "生效": {
    en: "Effective",
    "zh-HANT": "生效",
    fr: "Efficace",
    ru: "Эффективный",
    es: "Efectivo",
    ar: "حيز التنفيذ",
    eo: "efiki"
  },
  "稍后": {
    en: "Later",
    "zh-HANT": "稍後",
    fr: "Plus tard",
    ru: "Позже",
    es: "Más tarde",
    ar: "في وقت لاحق",
    eo: "poste"
  },
  "关于": {
    en: "About",
    "zh-HANT": "關於",
    fr: "À propos de",
    ru: "О сайте",
    es: "Acerca de",
    ar: "حول",
    eo: "pri"
  },
  "服务": {
    en: "Services",
    "zh-HANT": "服務",
    fr: "Services",
    ru: "Услуги",
    es: "Servicios",
    ar: "تخدم",
    eo: "Servi"
  },
  "隐藏": {
    en: "Hide",
    "zh-HANT": "隱藏",
    fr: "Cacher",
    ru: "Скрыть",
    es: "Ocultar",
    ar: "يخفي",
    eo: "kaŝi"
  },
  "隐藏其他": {
    en: "Hide other",
    "zh-HANT": "隱藏其他",
    fr: "Cacher autre",
    ru: "Скрыть Другое",
    es: "Ocultar Otros",
    ar: "اخفاء البعض",
    eo: "kaŝi alian"
  },
  "全部显示": {
    en: "Show all",
    "zh-HANT": "全部顯示",
    fr: "Afficher tous",
    ru: "Показать все",
    es: "Mostrar todo",
    ar: "عرض الكل",
    eo: "montri ĉiujn"
  },
  "文件": {
    en: "File",
    "zh-HANT": "文件",
    fr: "Documents",
    ru: "Документы",
    es: "Documentos",
    ar: "وثيقة",
    eo: "dokumento"
  },
  "保存到历史记录": {
    en: "Save to history",
    "zh-HANT": "保存到歷史記錄",
    fr: "Sauvegarder dans l'historique",
    ru: "Сохранить в истории",
    es: "Guardar en el historial",
    ar: "حفظ في التاريخ",
    eo: "konservi al la historio"
  },
  "其他编辑器打开": {
    en: "Open with other editor",
    "zh-HANT": "其他編輯器打開",
    fr: "Autres éditeurs ouverts",
    ru: "Другие редакторы открыты",
    es: "Otros editores abiertos",
    ar: "يفتح المحررون الآخرون",
    eo: "aliaj redaktiloj malfermiĝas"
  },
  "打开方式...": {
    en: "Open as...",
    "zh-HANT": "打開方式...",
    fr: "Ouvrir par...",
    ru: "Открыто...",
    es: "Abierto por...",
    ar: "مفتوح ل...",
    eo: "Malfermita al..."
  },
  "关闭": {
    en: "Close",
    "zh-HANT": "關閉",
    fr: "Fermer",
    ru: "Закрыть",
    es: "Cerrar",
    ar: "إنهاء",
    eo: "fermo"
  },
  "编辑": {
    en: "Edit",
    "zh-HANT": "編輯",
    fr: "Rédacteurs en chef",
    ru: "Редакция",
    es: "Editores",
    ar: "تعديل",
    eo: "redakti"
  },
  "打开链接": {
    en: "Open link",
    "zh-HANT": "打開鏈接",
    fr: "Ouvrir le lien",
    ru: "Открытая ссылка",
    es: "Abrir enlace",
    ar: "افتح الرابط",
    eo: "malferma ligilo"
  },
  "搜索": {
    en: "Search",
    "zh-HANT": "搜索",
    fr: "Recherche",
    ru: "Поиск",
    es: "Busque en",
    ar: "بحث",
    eo: "serĉi"
  },
  "翻译": {
    en: "Translate",
    "zh-HANT": "翻譯",
    fr: "Traduire",
    ru: "Перевести",
    es: "Traducir",
    ar: "يترجم",
    eo: "traduki"
  },
  "撤销": {
    en: "Undo",
    "zh-HANT": "撤銷",
    fr: "Annuler",
    ru: "Отменить",
    es: "Deshacer",
    ar: "سحب او إبطال",
    eo: "revoki"
  },
  "重做": {
    en: "Redo",
    "zh-HANT": "重做",
    fr: "Refaire",
    ru: "Redo",
    es: "Rehacer",
    ar: "إعادة",
    eo: "refari"
  },
  "剪切": {
    en: "Cut",
    "zh-HANT": "剪切",
    fr: "Coupez",
    ru: "Вырезать",
    es: "Cortar",
    ar: "يقطع",
    eo: "tranĉi"
  },
  "复制": {
    en: "Copy",
    "zh-HANT": "複製",
    fr: "Copie",
    ru: "Копировать",
    es: "Copiar",
    ar: "ينسخ",
    eo: "kopio"
  },
  "粘贴": {
    en: "Paste",
    "zh-HANT": "粘貼",
    fr: "Pâte",
    ru: "Паста",
    es: "Pegar",
    ar: "معجون",
    eo: "pasti"
  },
  "删除": {
    en: "Delete",
    "zh-HANT": "刪除",
    fr: "Supprimer",
    ru: "Удалить",
    es: "Borrar",
    ar: "حذف",
    eo: "forigi"
  },
  "全选": {
    en: "Select All",
    "zh-HANT": "全選",
    fr: "Sélectionner tout",
    ru: "Выбрать все",
    es: "Seleccionar todo",
    ar: "اختر الكل",
    eo: "elekti ĉiujn"
  },
  "自动删除换行": {
    en: "Auto Delete Line Feed",
    "zh-HANT": "自動刪除換行",
    fr: "Suppression automatique des sauts de ligne",
    ru: "Автоматическое удаление перевода строки",
    es: "Borrar el avance de línea automáticamente",
    ar: "إزالة الأسطر الجديدة تلقائيًا",
    eo: "Aŭtomate forigu novliniojn"
  },
  "查找": {
    en: "Find",
    "zh-HANT": "查找",
    fr: "Trouvez",
    ru: "Найти",
    es: "Encuentre",
    ar: "تجد",
    eo: "trovi"
  },
  "替换": {
    en: "Replace",
    "zh-HANT": "替換",
    fr: "Remplacer",
    ru: "Заменить",
    es: "Sustituir",
    ar: "يحل محل",
    eo: "anstataŭigi"
  },
  "自动换行": {
    en: "Auto Line Feed",
    "zh-HANT": "自動換行",
    fr: "Alimentation automatique des lignes",
    ru: "Автоматическая подача строк",
    es: "Alimentación automática de líneas",
    ar: "التفاف النص",
    eo: "vortvolvaĵo"
  },
  "拼写检查": {
    en: "Spell check",
    "zh-HANT": "拼寫檢查",
    fr: "Vérification des sorts",
    ru: "Проверка заклинаний",
    es: "Corregir la ortografía",
    ar: "التدقيق الإملائي",
    eo: "Literuma Kontrolo"
  },
  "朗读": {
    en: "Read aloud",
    "zh-HANT": "朗讀",
    fr: "Lire à haute voix",
    ru: "Читайте вслух",
    es: "Leer en voz alta",
    ar: "اقرأ بصوت عالي",
    eo: "laŭtlegi"
  },
  "开始朗读": {
    en: "Start reading aloud",
    "zh-HANT": "開始朗讀",
    fr: "Commencez à lire à haute voix",
    ru: "Начните читать вслух",
    es: "Empezar a leer en voz alta",
    ar: "بدء القراءة",
    eo: "komencu legi"
  },
  "停止朗读": {
    en: "Stop reading aloud",
    "zh-HANT": "停止朗讀",
    fr: "Arrêtez de lire à haute voix",
    ru: "Перестаньте читать вслух",
    es: "Dejar de leer en voz alta",
    ar: "التوقف عن القراءة",
    eo: "ĉesu legi"
  },
  "浏览器": {
    en: "Browser",
    "zh-HANT": "瀏覽器",
    fr: "Navigateur",
    ru: "Браузер",
    es: "Navegador",
    ar: "المتصفح",
    eo: "retumilo"
  },
  "后退": {
    en: "Back",
    "zh-HANT": "後退",
    fr: "Dos",
    ru: "Назад",
    es: "Volver",
    ar: "الى الخلف",
    eo: "reen"
  },
  "前进": {
    en: "Forward",
    "zh-HANT": "前進",
    fr: "Aller de l'avant",
    ru: "Идти вперед",
    es: "Avanzar",
    ar: "إنطلق",
    eo: "antaŭeniri"
  },
  "刷新": {
    en: "Refresh",
    "zh-HANT": "刷新",
    fr: "Rafraîchir",
    ru: "Обновить",
    es: "Actualizar",
    ar: "تحديث",
    eo: "refreŝigi"
  },
  "停止加载": {
    en: "Stop loading",
    "zh-HANT": "停止加載",
    fr: "Arrêter le chargement",
    ru: "Остановить загрузку",
    es: "Detener la carga",
    ar: "توقف عن التحميل",
    eo: "ĉesu ŝarĝi"
  },
  "视图": {
    en: "View",
    "zh-HANT": "視圖",
    fr: "Voir",
    ru: "Посмотреть",
    es: "Ver",
    ar: "رأي",
    eo: "vido"
  },
  "重新加载": {
    en: "Reload",
    "zh-HANT": "重新加載",
    fr: "Rechargez",
    ru: "Перезагрузка",
    es: "Recarga",
    ar: "إعادة تحميل",
    eo: "Reŝargi"
  },
  "强制重载": {
    en: "Force Reload",
    "zh-HANT": "強制重載",
    fr: "Recharge forcée",
    ru: "Принудительная перезагрузка",
    es: "Recarga forzada",
    ar: "إعادة تحميل القوة",
    eo: "Forto reŝargi"
  },
  "开发者工具": {
    en: "Developer Tools",
    "zh-HANT": "開發者工具",
    fr: "Outils pour les développeurs",
    ru: "Инструменты разработчика",
    es: "Herramientas para desarrolladores",
    ar: "ادوات المطورين",
    eo: "programiloj"
  },
  "历史记录": {
    en: "History",
    "zh-HANT": "歷史記錄",
    fr: "Histoire",
    ru: "История",
    es: "Historia",
    ar: "سجل التاريخ",
    eo: "historia rekordo"
  },
  "实际大小": {
    en: "Actual size",
    "zh-HANT": "實際大小",
    fr: "Taille réelle",
    ru: "Фактический размер",
    es: "Tamaño real",
    ar: "الحجم الأصلي",
    eo: "reala grandeco"
  },
  "放大": {
    en: "Zoom In",
    "zh-HANT": "放大",
    fr: "Zoom avant",
    ru: "Увеличить",
    es: "Acercarse",
    ar: "تكبير",
    eo: "pligrandigi"
  },
  "缩小": {
    en: "Zoom out",
    "zh-HANT": "縮小",
    fr: "Zoom arrière",
    ru: "Уменьшить масштаб",
    es: "Alejar el zoom",
    ar: "تصغير",
    eo: "malzomi"
  },
  "全屏": {
    en: "Full screen",
    "zh-HANT": "全屏",
    fr: "Plein écran",
    ru: "Во весь экран",
    es: "Pantalla completa",
    ar: "شاشة كاملة",
    eo: "plenekrane"
  },
  "窗口": {
    en: "Window",
    "zh-HANT": "窗口",
    fr: "Fenêtre",
    ru: "Окно",
    es: "Ventana",
    ar: "نافذة او شباك",
    eo: "fenestro"
  },
  "最小化": {
    en: "Minimise",
    "zh-HANT": "最小化",
    fr: "Réduire au minimum",
    ru: "Минимизировать",
    es: "Minimizar",
    ar: "قلل",
    eo: "minimumigi"
  },
  "置于最前面": {
    en: "Place at top",
    "zh-HANT": "置於最前面",
    fr: "Place au sommet",
    ru: "Место на вершине",
    es: "Colocar en la parte superior",
    ar: "احضره الى الامام",
    eo: "alporti al la fronto"
  },
  "帮助": {
    en: "Help",
    "zh-HANT": "幫助",
    fr: "Aide",
    ru: "Помощь",
    es: "Ayuda",
    ar: "يساعد",
    eo: "helpo"
  },
  "保存图像成功": {
    en: "Saved image successfully",
    "zh-HANT": "保存圖像成功",
    fr: "Sauvegarder l'image avec succès",
    ru: "Успешное сохранение изображения",
    es: "Guardar la imagen con éxito",
    ar: "احفظ الصورة بنجاح",
    eo: "Konservu la bildon sukcese"
  },
  "已保存图像到": {
    en: "Saved image to",
    "zh-HANT": "已保存圖像到",
    fr: "Sauvegarde des images dans",
    ru: "Сохранение изображений в",
    es: "Imágenes guardadas en",
    ar: "تم حفظ الصورة في",
    eo: "Bildo konservita al"
  },
  "eSearch - 主页面": {
    en: "eSearch - Main",
    "zh-HANT": "eSearch - 主页面",
    fr: "eSearch - écran principal",
    ru: "eSearch - Главный экран",
    es: "eSearch - pantalla principal",
    ar: "البحث الإلكتروني - الواجهة الرئيسية",
    eo: "eSearch - ĉefa interfaco"
  },
  "eSearch - 截屏": {
    en: "eSearch - Screen capture",
    "zh-HANT": "eSearch - 截屏",
    fr: "eSearch - Capture d'écran",
    ru: "eSearch - Скриншот",
    es: "eSearch - Captura de pantalla",
    ar: "البحث الإلكتروني - لقطة شاشة",
    eo: "eSearch - Ekrankopio"
  },
  "eSearch - 设置": {
    en: "eSearch - Setting",
    "zh-HANT": "eSearch - 設置",
    fr: "eSearch - Paramètres",
    ru: "eSearch - Настройки",
    es: "eSearch - Configuración",
    ar: "البحث الإلكتروني - الإعدادات",
    eo: "eSearch - Agordoj"
  },
  "eSearch - 帮助": {
    en: "eSearch - Help",
    "zh-HANT": "eSearch - 幫助",
    fr: "eSearch - Aide",
    ru: "eSearch - Помощь",
    es: "eSearch - Ayuda",
    ar: "البحث الإلكتروني - مساعدة",
    eo: "eSearch - Helpo"
  },
  "eSearch - 浏览器": {
    en: "eSearch - Browser",
    "zh-HANT": "eSearch - 瀏覽器",
    fr: "eSearch - Navigateur",
    ru: "eSearch - Браузер",
    es: "eSearch - Navegador",
    ar: "البحث الإلكتروني - المتصفح",
    eo: "eSearch - Retumilo"
  },
  "eSearch - ding": {
    en: "eSearch - ding",
    "zh-HANT": "eSearch - ding",
    fr: "eSearch - ding",
    ru: "eSearch - ding",
    es: "eSearch - ding",
    ar: "البحث الإلكتروني - دينغ",
    eo: "eSearch - ding"
  },
  "eSearch - 录屏": {
    en: "eSearch - Recorder",
    "zh-HANT": "eSearch - 錄屏",
    fr: "eSearch - Écran d'enregistrement",
    ru: "eSearch - экран записи",
    es: "eSearch - Pantalla de registro",
    ar: "البحث الإلكتروني - تسجيل الشاشة",
    eo: "eSearch - Ekranregistrado"
  },
  "上一个匹配": {
    en: "Previous match",
    "zh-HANT": "上一個匹配",
    fr: "Match précédent",
    ru: "Предыдущий матч",
    es: "Partido anterior",
    ar: "المباراة السابقة",
    eo: "antaŭa matĉo"
  },
  "下一个匹配": {
    en: "Next match",
    "zh-HANT": "下一個匹配",
    fr: "Prochain match",
    ru: "Следующий матч",
    es: "Próximo partido",
    ar: "المباراة القادمة",
    eo: "sekva matĉo"
  },
  "启动": {
    en: "Boot",
    "zh-HANT": "啟動",
    fr: "Démarrage",
    ru: "Стартап",
    es: "Inicio",
    ar: ".بدء",
    eo: "starti"
  },
  "开机自启动": {
    en: "Boot-up",
    "zh-HANT": "開機自啟動",
    fr: "Démarrage",
    ru: "Загрузка",
    es: "Arranque",
    ar: "بدء تلقائي",
    eo: "Aŭtomata starto"
  },
  "启动提示": {
    en: "Boot prompt",
    "zh-HANT": "啟動提示",
    fr: "Invite de démarrage",
    ru: "Подсказка при запуске",
    es: "Indicación de puesta en marcha",
    ar: "موجه بدء التشغيل",
    eo: "startpromeso"
  },
  "启动时系统通知提示启动": {
    en: "System notification to start at boot",
    "zh-HANT": "啟動時系統通知提示啟動",
    fr: "Notification du système au démarrage",
    ru: "Системное уведомление при загрузке",
    es: "Notificación del sistema para el arranque",
    ar: "يطالب إعلام النظام بالبدء عند بدء التشغيل",
    eo: "Sistema sciigo petas komenci ĉe ekfunkciigo"
  },
  "语言": {
    en: "Language",
    "zh-HANT": "語言",
    fr: "Langue",
    ru: "Язык",
    es: "Idioma",
    ar: "لغة",
    eo: "lingvo"
  },
  "使用系统语言": {
    en: "Use system language",
    "zh-HANT": "使用系統語言",
    fr: "Utiliser le langage du système",
    ru: "Используйте системный язык",
    es: "Utilizar el lenguaje del sistema",
    ar: "استخدم لغة النظام",
    eo: "Uzu sisteman lingvon"
  },
  "重启软件以生效": {
    en: "Restart software to take effect",
    "zh-HANT": "重啟軟件以生效",
    fr: "Redémarrez le logiciel pour prendre effet",
    ru: "Перезапустите программу, чтобы изменения вступили в силу.",
    es: "Reinicie el software para que surta efecto",
    ar: "أعد تشغيل البرنامج ليصبح ساري المفعول",
    eo: "Rekomencu la programaron por efiki"
  },
  "快捷键": {
    en: "Shortcuts",
    "zh-HANT": "快捷鍵",
    fr: "Touches de raccourci",
    ru: "Клавиши быстрого доступа",
    es: "Teclas de acceso rápido",
    ar: "مفتاح تشغيل سريع",
    eo: "varma klavo"
  },
  "全局": {
    en: "Global",
    "zh-HANT": "全局",
    fr: "Global",
    ru: "Глобальный",
    es: "Global",
    ar: "عالمي",
    eo: "tutmonda"
  },
  "截屏": {
    en: "Screenshot",
    "zh-HANT": "截屏",
    fr: "Capture d'écran",
    ru: "Скриншот",
    es: "Captura de pantalla",
    ar: "لقطة شاشة",
    eo: "ekrankopio"
  },
  "自动识别": {
    en: "Automatic Identification",
    "zh-HANT": "自動識別",
    fr: "Identification automatique",
    ru: "Автоматическая идентификация",
    es: "Identificación automática",
    ar: "تحديد تلقائي",
    eo: "Aŭtomata Identigo"
  },
  "复制颜色": {
    en: "copy color",
    "zh-HANT": "複製顏色",
    fr: "Copier la couleur",
    ru: "копировать цвет",
    es: "Copiar color",
    ar: "نسخ اللون",
    eo: "Kopiu Koloron"
  },
  "主搜索功能": {
    en: "Main search function",
    "zh-HANT": "主搜索功能",
    fr: "Fonction de recherche principale",
    ru: "Основная функция поиска",
    es: "Función de búsqueda principal",
    ar: "وظيفة البحث الرئيسية",
    eo: "ĉefa serĉfunkcio"
  },
  "自动搜索排除": {
    en: "Automatic search exclusion",
    "zh-HANT": "自動搜索排除",
    fr: "Exclusion automatique de la recherche",
    ru: "Автоматическое исключение из поиска",
    es: "Exclusión automática de la búsqueda",
    ar: "استبعاد البحث التلقائي",
    eo: "Aŭtomata serĉa ekskludo"
  },
  "若选中的文字符合文本框的规则，将使用截屏搜索而不是选择搜索": {
    en: "If the selected text matches the rules of the text box, a screenshot search will be used instead of a select search",
    "zh-HANT": "若選中的文字符合文本框的規則，將使用截屏搜索而不是選擇搜索",
    fr: "Si le texte sélectionné correspond aux règles de la zone de texte, une recherche par capture d'écran sera utilisée au lieu d'une recherche par sélection.",
    ru: "Если выделенный текст соответствует правилам текстового поля, вместо поиска по выделению будет использоваться поиск по снимку экрана",
    es: "Si el texto seleccionado coincide con las reglas del cuadro de texto, se utilizará una búsqueda por pantalla en lugar de una búsqueda por selección",
    ar: "سيتم استخدام البحث عن لقطة الشاشة بدلاً من البحث عن التحديد إذا كان النص المحدد يطابق قواعد مربع النص",
    eo: "Ekrankopio serĉo estos uzata anstataŭ elekta serĉo se la elektita teksto kongruas kun la reguloj de la tekstkesto"
  },
  "换行新建项目，支持正则表达式": {
    en: "New item with line feed, regular expression support",
    "zh-HANT": "換行新建項目，支持正則表達式",
    fr: "Nouvel élément dans le fil d'actualité, prise en charge des expressions régulières",
    ru: "Новый элемент в ленте строк, поддерживаются регулярные выражения",
    es: "Nuevo elemento en la línea de alimentación, expresiones regulares compatibles",
    ar: "عنصر جديد في سطر جديد ، يدعم التعبيرات العادية",
    eo: "Nova linio, subtenas regulajn esprimojn"
  },
  "使用选区内容": {
    en: "Using the contents of a selection",
    "zh-HANT": "使用選區內容",
    fr: "Utilisation du contenu de la sélection",
    ru: "Использование содержания выбора",
    es: "Uso del contenido de la selección",
    ar: "استخدم محتوى التحديد",
    eo: "Uzu elektan enhavon"
  },
  "全局样式": {
    en: "Global styles",
    "zh-HANT": "全局樣式",
    fr: "Styles mondiaux",
    ru: "Глобальные стили",
    es: "Estilos globales",
    ar: "النمط العالمي",
    eo: "tutmonda stilo"
  },
  "毛玻璃效果": {
    en: "Glass effect",
    "zh-HANT": "毛玻璃效果",
    fr: "Effet verre",
    ru: "Эффект стекла",
    es: "Efecto cristal",
    ar: "بلوري تأثير الزجاج",
    eo: "frosta vitra efiko"
  },
  "模糊": {
    en: "Blur",
    "zh-HANT": "模糊",
    fr: "Flou",
    ru: "Пятно",
    es: "Desenfoque",
    ar: "غامض",
    eo: "Svaga"
  },
  "不透明度": {
    en: "Opacity",
    "zh-HANT": "不透明度",
    fr: "Opacité",
    ru: "Непрозрачность",
    es: "Opacidad",
    ar: "العتامة",
    eo: "Opakeco"
  },
  "深色模式": {
    en: "Dark mode",
    "zh-HANT": "深色模式",
    fr: "Mode sombre",
    ru: "Темный режим",
    es: "Modo oscuro",
    ar: "الوضع المظلم",
    eo: "malhela reĝimo"
  },
  "跟随系统": {
    en: "Following system",
    "zh-HANT": "跟隨系統",
    fr: "Suivre le système",
    ru: "Система слежения",
    es: "Sistema de seguimiento",
    ar: "اتبع النظام",
    eo: "sekvu la sistemon"
  },
  "浅色": {
    en: "Light",
    "zh-HANT": "淺色",
    fr: "Couleurs claires",
    ru: "Светлые цвета",
    es: "Colores claros",
    ar: "لون فاتح",
    eo: "hela koloro"
  },
  "深色": {
    en: "Dark",
    "zh-HANT": "深色",
    fr: "Dark",
    ru: "Темный",
    es: "Oscuro",
    ar: "مظلم",
    eo: "malhela"
  },
  "全局缩放": {
    en: "Global zoom",
    "zh-HANT": "全局縮放",
    fr: "Zoom global",
    ru: "Глобальное масштабирование",
    es: "Zoom global",
    ar: "تكبير عالمي",
    eo: "Tutmonda zomo"
  },
  "字体": {
    en: "Font",
    "zh-HANT": "字體",
    fr: "Polices de caractères",
    ru: "Шрифты",
    es: "Fuentes",
    ar: "الخط",
    eo: "tiparo"
  },
  "主要字体": {
    en: "Main fonts",
    "zh-HANT": "主要字體",
    fr: "Polices primaires",
    ru: "Основные шрифты",
    es: "Fuentes primarias",
    ar: "الخط الرئيسي",
    eo: "ĉefa tiparo"
  },
  "（适用于主页面等文字字体）": {
    en: "(for text fonts such as main interface)",
    "zh-HANT": "（適用於主页面等文字字體）",
    fr: "(pour les polices de texte telles que l'interface principale)",
    ru: "(для текстовых шрифтов, например, для основного интерфейса)",
    es: "(para fuentes de texto como la interfaz principal)",
    ar: "(قابل للتطبيق على خطوط النص مثل الواجهة الرئيسية)",
    eo: "(Aplikebla al tekstaj tiparoj kiel la ĉefa interfaco)"
  },
  "等宽字体": {
    en: "Equal width fonts",
    "zh-HANT": "等寬字體",
    fr: "Polices à largeur égale",
    ru: "Шрифты одинаковой ширины",
    es: "Fuentes de igual anchura",
    ar: "خط أحادي المسافة",
    eo: "Monospacigita tiparo"
  },
  "（适用于截屏时数字、颜色代码等字体）": {
    en: "(for fonts such as numbers, colour codes, etc. when taking screenshots)",
    "zh-HANT": "（適用於截屏時數字、顏色代碼等字體）",
    fr: "(pour les polices de caractères telles que les chiffres, les codes de couleur, etc. lors de captures d'écran)",
    ru: "(для шрифтов, таких как цифры, цветовые коды и т.д. при создании скриншотов)",
    es: "(para fuentes como números, códigos de color, etc. al realizar capturas de pantalla)",
    ar: "(ينطبق على الخطوط مثل الأرقام ورموز الألوان وما إلى ذلك عند التقاط لقطات الشاشة)",
    eo: "(Aplikebla al tiparoj kiel nombroj, kolorkodoj, ktp. kiam oni prenas ekrankopiojn)"
  },
  "工具栏": {
    en: "Toolbar",
    "zh-HANT": "工具欄",
    fr: "Barre d'outils",
    ru: "Панель инструментов",
    es: "Barra de herramientas",
    ar: "شريط الأدوات",
    eo: "ilobreto"
  },
  "工具栏跟随": {
    en: "Toolbar follow",
    "zh-HANT": "工具欄跟隨",
    fr: "Suivi de la barre d'outils",
    ru: "Следуйте за панелью инструментов",
    es: "Seguir la barra de herramientas",
    ar: "متابعة شريط الأدوات",
    eo: "Ilobreto sekvas"
  },
  "展示内容优先": {
    en: "Priority for displaying content",
    "zh-HANT": "展示內容優先",
    fr: "Afficher le contenu en premier",
    ru: "Отображение содержимого в первую очередь",
    es: "Mostrar primero el contenido",
    ar: "اعرض المحتوى أولاً",
    eo: "Montru enhavon unue"
  },
  "效率优先": {
    en: "Efficiency first",
    "zh-HANT": "效率優先",
    fr: "L'efficacité d'abord",
    ru: "Эффективность превыше всего",
    es: "La eficiencia es lo primero",
    ar: "الكفاءة أولا",
    eo: "Efikeco unue"
  },
  "按钮大小": {
    en: "Button size",
    "zh-HANT": "按鈕大小",
    fr: "Taille du bouton",
    ru: "Размер кнопки",
    es: "Tamaño del botón",
    ar: "حجم الزر",
    eo: "grandeco de butono"
  },
  "按钮": {
    en: "Button",
    "zh-HANT": "按鈕",
    fr: "Boutons",
    ru: "Кнопки",
    es: "Botones",
    ar: "زر",
    eo: "butonon"
  },
  "图标比例": {
    en: "Icon scale",
    "zh-HANT": "圖標比例",
    fr: "Échelle d'icônes",
    ru: "Шкала значков",
    es: "Escala de iconos",
    ar: "مقياس الأيقونة",
    eo: "Ikono-skalo"
  },
  "取色器": {
    en: "Colour picker",
    "zh-HANT": "取色器",
    fr: "Sélecteur de couleurs",
    ru: "Выбор цвета",
    es: "Seleccionador de colores",
    ar: "أداة انتقاء اللون",
    eo: "kolorigilo"
  },
  "大小": {
    en: "Size",
    "zh-HANT": "大小",
    fr: "Taille",
    ru: "Размер",
    es: "Tamaño",
    ar: "بحجم",
    eo: "grandeco"
  },
  "取色器大小": {
    en: "Color picker size",
    "zh-HANT": "取色器大小",
    fr: "Taille du sélecteur de couleurs",
    ru: "Размер устройства выбора цвета",
    es: "Tamaño del selector de color",
    ar: "حجم منتقي الألوان",
    eo: "grandeco de kolorelektanto"
  },
  "像素大小": {
    en: "Pixel size",
    "zh-HANT": "像素大小",
    fr: "Taille du pixel",
    ru: "Размер пикселя",
    es: "Tamaño de los píxeles",
    ar: "حجم بكسل",
    eo: "piksela grandeco"
  },
  "默认格式": {
    en: "Default format",
    "zh-HANT": "默認格式",
    fr: "Format par défaut",
    ru: "Формат по умолчанию",
    es: "Formato por defecto",
    ar: "التنسيق الافتراضي",
    eo: "Defaŭlta formato"
  },
  "框选": {
    en: "Boxed",
    "zh-HANT": "框選",
    fr: "Choix du cadre",
    ru: "Выбор рамы",
    es: "Selección de marcos",
    ar: "اختيار الإطار",
    eo: "elekto de kadro"
  },
  "框选颜色": {
    en: "Box color",
    "zh-HANT": "框選顏色",
    fr: "Couleur du cadre",
    ru: "Цвет рамы",
    es: "Color del marco",
    ar: "لون الصندوق",
    eo: "skatolo koloro"
  },
  "遮罩颜色": {
    en: "Mask color",
    "zh-HANT": "遮罩顏色",
    fr: "Couleur du masque",
    ru: "Цвет маски",
    es: "Color de la máscara",
    ar: "لون القناع",
    eo: "masko koloro"
  },
  "选区颜色": {
    en: "Selection color",
    "zh-HANT": "選區顏色",
    fr: "Couleur de sélection",
    ru: "Цвет выбора",
    es: "Selección de color",
    ar: "لون الدائرة الانتخابية",
    eo: "balotdistriktokoloro"
  },
  "光标": {
    en: "Cursor",
    "zh-HANT": "光標",
    fr: "Curseur",
    ru: "Курсор",
    es: "Cursor",
    ar: "المؤشر",
    eo: "kursoro"
  },
  "以(0,0)为起点": {
    en: "Starting at (0,0)",
    "zh-HANT": "以(0,0)為起點",
    fr: "Commencez à (0,0)",
    ru: "Начало в точке (0,0)",
    es: "Comienza en (0,0)",
    ar: "يبدأ من (0،0)",
    eo: "Komencu je (0,0)"
  },
  "以(1,1)为起点": {
    en: "Starting at (1,1)",
    "zh-HANT": "以(1,1)為起點",
    fr: "Commencez à (1,1)",
    ru: "Начните с (1,1)",
    es: "Comienza en (1,1)",
    ar: "تبدأ من (1،1)",
    eo: "Komencu je (1,1)"
  },
  "大小坐标": {
    en: "Size coordinates",
    "zh-HANT": "大小坐標",
    fr: "Coordonnées de taille",
    ru: "Координаты размера",
    es: "Coordenadas de tamaño",
    ar: "إحداثيات الحجم",
    eo: "grandeco koordinatoj"
  },
  "显示四角坐标": {
    en: "Display quadrangular coordinates",
    "zh-HANT": "顯示四角坐標",
    fr: "Afficher les coordonnées aux quatre coins",
    ru: "Показать координаты во всех четырех углах",
    es: "Mostrar coordenadas en las cuatro esquinas",
    ar: "اعرض إحداثيات الزوايا الأربع",
    eo: "Montru la koordinatojn de la kvar anguloj"
  },
  "（截屏框选附近除了框选大小，还会加上左上角和右下角坐标）": {
    en: "(screenshot boxed near will add top-left and bottom-right coordinates in addition to the boxed size)",
    "zh-HANT": "（截屏框選附近除了框選大小，還會加上左上角和右下角坐標）",
    fr: "(la capture d'écran encadrée à proximité ajoutera les coordonnées en haut à gauche et en bas à droite en plus de la taille encadrée)",
    ru: "(скриншот в рамке рядом добавит левую верхнюю и правую нижнюю координаты в дополнение к размеру рамки)",
    es: "(captura de pantalla recuadrada cerca de las coordenadas de la esquina superior izquierda e inferior derecha, además del tamaño recuadrado)",
    ar: "(بالإضافة إلى حجم تحديد الإطار ، ستتم إضافة إحداثيات الزاوية اليسرى العلوية والزاوية اليمنى السفلية بالقرب من اختيار إطار لقطة الشاشة)",
    eo: "(Krom la grandeco de la kadra elekto, la koordinatoj de la supra maldekstra angulo kaj la malsupra dekstra angulo estos aldonitaj proksime de la kadra elekto de la ekrankopio)"
  },
  "框选后默认操作": {
    en: "Default action after frame",
    "zh-HANT": "框選後默認操作",
    fr: "Action par défaut après le cadrage",
    ru: "Действие по умолчанию после кадрирования",
    es: "Acción por defecto tras el encuadre",
    ar: "الإجراء الافتراضي بعد تحديد المربع",
    eo: "Defaŭlta ago post elekto de skatolo"
  },
  "框选完鼠标松开一瞬间，执行操作": {
    en: "Action to be performed the moment the mouse is released after framing",
    "zh-HANT": "框選完鼠標鬆開一瞬間，執行操作",
    fr: "L'action est exécutée au moment où l'on relâche la souris après le cadrage.",
    ru: "Действие выполняется в момент отпускания мыши после установки рамки",
    es: "La acción se realiza en el momento en que se suelta el ratón después de encuadrar",
    ar: "بعد تحديد المربع ، حرر الماوس للحظة لتنفيذ العملية",
    eo: "Post kiam la skatolo estas elektita, liberigu la muson por momento por efektivigi la operacion"
  },
  "无": {
    en: "None",
    "zh-HANT": "無",
    fr: "Aucun",
    ru: "Нет",
    es: "Ninguno",
    ar: "لا أحد",
    eo: "neniu"
  },
  "OCR(文字识别)": {
    en: "OCR (text recognition)",
    "zh-HANT": "OCR(文字識別)",
    fr: "OCR (reconnaissance de texte)",
    ru: "OCR (распознавание текста)",
    es: "OCR (reconocimiento de texto)",
    ar: "التعرف الضوئي على الحروف (التعرف على النص)",
    eo: "OCR (Teksto-Rekono)"
  },
  "以图搜图": {
    en: "Search by image",
    "zh-HANT": "以圖搜圖",
    fr: "Recherche par image",
    ru: "Поиск по изображению",
    es: "Buscar por imagen",
    ar: "البحث بالصور",
    eo: "Serĉu laŭ bildo"
  },
  "QR码": {
    en: "QR code",
    "zh-HANT": "QR碼",
    fr: "Code QR",
    ru: "QR-код",
    es: "Código QR",
    ar: "رمز الاستجابة السريعة",
    eo: "QR-kodo"
  },
  "标记": {
    en: "Marker",
    "zh-HANT": "標記",
    fr: "Marqueur",
    ru: "Маркер",
    es: "Marcador",
    ar: "علامة",
    eo: "marko"
  },
  "其他应用打开": {
    en: "Open in other apps",
    "zh-HANT": "其他應用打開",
    fr: "Ouvrir dans d'autres applications",
    ru: "Открыть в других приложениях",
    es: "Abrir en otras aplicaciones",
    ar: "افتح تطبيقات أخرى",
    eo: "Malfermu aliajn apojn"
  },
  "放在屏幕上": {
    en: "Place on screen",
    "zh-HANT": "放在屏幕上",
    fr: "Placez sur l'écran",
    ru: "Разместить на экране",
    es: "Colocar en la pantalla",
    ar: "وضعها على الشاشة",
    eo: "meti sur ekranon"
  },
  "保存": {
    en: "Save",
    "zh-HANT": "保存",
    fr: "Sauvez",
    ru: "Сохранить",
    es: "Guardar",
    ar: "حفظ",
    eo: "savi"
  },
  "自动框选": {
    en: "Automatically frame",
    "zh-HANT": "自動框選",
    fr: "Cadrage automatique",
    ru: "Автоматическое кадрирование",
    es: "Encuadre automático",
    ar: "اختيار الإطار التلقائي",
    eo: "Aŭtomata kadro-elekto"
  },
  "使用OpenCV自动识别边缘轮廓（测试版）": {
    en: "Automatic edge contour recognition using OpenCV (beta)",
    "zh-HANT": "使用OpenCV自動識別邊緣輪廓（測試版）",
    fr: "Reconnaissance automatique des contours des bords à l'aide d'OpenCV (beta)",
    ru: "Автоматическое распознавание контуров краев с помощью OpenCV (бета-версия)",
    es: "Reconocimiento automático del contorno de los bordes con OpenCV (beta)",
    ar: "التعرف تلقائيًا على حدود الحواف باستخدام OpenCV (تجريبي)",
    eo: "Aŭtomate identigu randajn konturojn kun OpenCV (beta)"
  },
  "启用自动框选": {
    en: "Enable auto-framing",
    "zh-HANT": "啟用自動框選",
    fr: "Activer le cadrage automatique",
    ru: "Включить автоматическое кадрирование",
    es: "Activar el encuadre automático",
    ar: "تمكين تحديد الشاشة الاسمية تلقائيًا",
    eo: "Ebligu aŭtomatan elekton de markezo"
  },
  "边缘识别高级设置": {
    en: "Advanced settings for edge recognition",
    "zh-HANT": "邊緣識別高級設置",
    fr: "Paramètres avancés pour la reconnaissance des bords",
    ru: "Расширенные настройки для распознавания краев",
    es: "Ajustes avanzados para el reconocimiento de bordes",
    ar: "الإعدادات المتقدمة للتعرف على الحواف",
    eo: "Altnivelaj agordoj pri rekono de randoj"
  },
  "最小阈值": {
    en: "Minimum threshold",
    "zh-HANT": "最小閾值",
    fr: "Seuil Min",
    ru: "Минимальный порог",
    es: "Umbral mínimo",
    ar: "عتبة الحد الأدنى",
    eo: "minimuma sojlo"
  },
  "最大阈值": {
    en: "Maximum threshold",
    "zh-HANT": "最大閾值",
    fr: "Seuil maximum",
    ru: "Максимальный порог",
    es: "Umbral máximo",
    ar: "الحد الأقصى",
    eo: "maksimuma sojlo"
  },
  "图像编辑": {
    en: "Image editing",
    "zh-HANT": "圖像編輯",
    fr: "Traitement des images",
    ru: "Редактирование изображений",
    es: "Edición de imágenes",
    ar: "تعديل الصوره",
    eo: "redaktado de bildoj"
  },
  "默认属性": {
    en: "Default properties",
    "zh-HANT": "默認屬性",
    fr: "Propriétés par défaut",
    ru: "Свойства по умолчанию",
    es: "Propiedades por defecto",
    ar: "الخصائص الافتراضية",
    eo: "defaŭltaj propraĵoj"
  },
  "填充颜色": {
    en: "Fill color",
    "zh-HANT": "填充顏色",
    fr: "Couleur de remplissage",
    ru: "Цвет заливки",
    es: "Color de relleno",
    ar: "لون التعبئة",
    eo: "plenigi koloron"
  },
  "边框颜色": {
    en: "Border color",
    "zh-HANT": "邊框顏色",
    fr: "Couleur de la bordure",
    ru: "Цвет границы",
    es: "Color del borde",
    ar: "لون الحدود",
    eo: "randkoloro"
  },
  "边框宽度": {
    en: "Border width",
    "zh-HANT": "邊框寬度",
    fr: "Largeur de la bordure",
    ru: "Ширина границы",
    es: "Anchura de los bordes",
    ar: "عرض الحدود",
    eo: "limlarĝo"
  },
  "画笔颜色": {
    en: "Brush color",
    "zh-HANT": "畫筆顏色",
    fr: "Couleur du pinceau",
    ru: "Цвет кисти",
    es: "Color del pincel",
    ar: "لون الفرشاة",
    eo: "peniko koloro"
  },
  "画笔粗细": {
    en: "Brush thickness",
    "zh-HANT": "畫筆粗細",
    fr: "Épaisseur de la brosse",
    ru: "Толщина кисти",
    es: "Grosor de la brocha",
    ar: "سمك الفرشاة",
    eo: "Broso dikeco"
  },
  "复制偏移": {
    en: "Copy offset",
    "zh-HANT": "複製偏移",
    fr: "Décalage de la copie",
    ru: "Смещение копирования",
    es: "Desplazamiento de la copia",
    ar: "نسخة تعويض",
    eo: "kopio ofseto"
  },
  "复制完一个元素后，为了分辨，可以让其偏移": {
    en: "After copying an element, you can offset it to distinguish",
    "zh-HANT": "複製完一個元素後，為了分辨，可以讓其偏移",
    fr: "Après avoir copié un élément, il peut être décalé pour distinguer",
    ru: "После копирования элемента он может быть смещен для различения",
    es: "Después de copiar un elemento, se puede compensar para distinguir",
    ar: "بعد نسخ عنصر للتمييز ، يمكن تعويضه",
    eo: "Post kopiado de elemento, por distingi, ĝi povas esti kompensita"
  },
  "x轴": {
    en: "X-axis",
    "zh-HANT": "x軸",
    fr: "Axe x",
    ru: "ось x",
    es: "eje x",
    ar: "المحور السيني",
    eo: "x-akso"
  },
  "y轴": {
    en: "Y-axis",
    "zh-HANT": "y軸",
    fr: "axe y",
    ru: "ось y",
    es: "eje y",
    ar: "المحور ص",
    eo: "y-akso"
  },
  "贴图": {
    en: "Sticker",
    "zh-HANT": "貼圖",
    fr: "Autocollant",
    ru: "текстура",
    es: "textura",
    ar: "نَسِيج",
    eo: "teksturo"
  },
  "窗口变换": {
    en: "Window transformation",
    "zh-HANT": "窗口變換",
    fr: "Transformation des fenêtres",
    ru: "оконное преобразование",
    es: "transformación de ventana",
    ar: "نافذة التحويل",
    eo: "fenestro transformo"
  },
  "变换使用 CSS 代码": {
    en: "Change using CSS code",
    "zh-HANT": "變換使用 CSS 代碼",
    fr: "Changer en utilisant le code CSS",
    ru: "Преобразование с помощью кода CSS",
    es: "Transforma usando código CSS",
    ar: "التحويل باستخدام كود CSS",
    eo: "Transformu uzante CSS-kodon"
  },
  "快速截屏": {
    en: "Quick screenshot",
    "zh-HANT": "快速截屏",
    fr: "Copie d'écran rapide",
    ru: "Быстрый снимок экрана",
    es: "Captura de pantalla rápida",
    ar: "خذ لقطة شاشة سريعة",
    eo: "Prenu rapidan ekrankopio"
  },
  "保存到": {
    en: "Save to",
    "zh-HANT": "保存到",
    fr: "Sauvegarder à",
    ru: "Сохранить в",
    es: "Guardar en",
    ar: "حفظ في",
    eo: "Konservu al"
  },
  "剪贴板": {
    en: "Clipboard",
    "zh-HANT": "剪貼板",
    fr: "presse-papiers",
    ru: "буфер обмена",
    es: "portapapeles",
    ar: "الحافظة",
    eo: "tondujo"
  },
  "目录": {
    en: "Directory",
    "zh-HANT": "目錄",
    fr: "répertoire",
    ru: "каталог",
    es: "directorio",
    ar: "جدول المحتويات",
    eo: "Enhavtabelo"
  },
  "获取保存路径": {
    en: "Get save path",
    "zh-HANT": "獲取保存路徑",
    fr: "Obtenir le chemin de sauvegarde",
    ru: "Получить путь сохранения",
    es: "Obtener la ruta de guardado",
    ar: "الحصول على حفظ المسار",
    eo: "akiri konservan vojon"
  },
  "录屏": {
    en: "Record screen",
    "zh-HANT": "錄屏",
    fr: "Enregistrer des captures d'écran",
    ru: "Запись скриншотов",
    es: "Grabación de capturas de pantalla",
    ar: "تسجيل الشاشة",
    eo: "ekranregistrado"
  },
  "凡是麦克风和摄像头，都应该当成开着的": {
    en: "You should always treat every microphone and camera as that were live microphone and live camera",
    "zh-HANT": "凡是麥克風和攝像頭，都應該當成開著的",
    fr: "Vous devez toujours traiter chaque microphone et chaque caméra comme s'il s'agissait d'un microphone et d'une caméra en direct",
    ru: "Вы всегда должны относиться к каждому микрофону и камере как к живому микрофону и живой камере",
    es: "Siempre debe tratar cada micrófono y cámara como si fueran un micrófono en vivo y una cámara en vivo",
    ar: "يجب أن تتعامل دائمًا مع كل ميكروفون وكاميرا على أنها ميكروفون مباشر وكاميرا حية",
    eo: "Vi ĉiam devus trakti ĉiun mikrofonon kaj fotilon kiel tio estis viva mikrofono kaj viva fotilo"
  },
  "自动录制": {
    en: "Auto record",
    "zh-HANT": "自動錄製",
    fr: "Enregistrement automatique",
    ru: "Автоматическая запись",
    es: "Grabación automática",
    ar: "التسجيل التلقائي",
    eo: "aŭtomata registrado"
  },
  "开启自动录制": {
    en: "Enable auto-recording",
    "zh-HANT": "開啟自動錄製",
    fr: "Activer l'enregistrement automatique",
    ru: "Включите автоматическую запись",
    es: "Activar la grabación automática",
    ar: "قم بتشغيل التسجيل التلقائي",
    eo: "Ŝaltu aŭtomatan registradon"
  },
  "录制": {
    en: "Record",
    "zh-HANT": "錄製",
    fr: "Enregistrement",
    ru: "Запись",
    es: "Grabación",
    ar: "سجل",
    eo: "rekordon"
  },
  "视频比特率": {
    en: "Video bitrate",
    "zh-HANT": "視頻比特率",
    fr: "Débit binaire vidéo",
    ru: "Скорость передачи видеоданных",
    es: "Tasa de bits de vídeo",
    ar: "معدل بت الفيديو",
    eo: "videobitrapideco"
  },
  "提示": {
    en: "hint",
    "zh-HANT": "提示",
    fr: "indice",
    ru: "намекать",
    es: "insinuación",
    ar: "ملحوظة",
    eo: "aludo"
  },
  "开启键盘按键提示": {
    en: "Enable keyboard key hints",
    "zh-HANT": "開啟鍵盤按鍵提示",
    fr: "Activer les raccourcis clavier",
    ru: "Включить подсказки клавиш клавиатуры",
    es: "Encienda el indicador del botón del teclado",
    ar: "تفعيل تلميحات مفاتيح لوحة المفاتيح",
    eo: "Ebligu klavarajn sugestojn"
  },
  "开启鼠标按键提示": {
    en: "Enable mouse button hints",
    "zh-HANT": "開啟鼠標按鍵提示",
    fr: "Activer les astuces du bouton de la souris",
    ru: "Включить подсказки кнопок мыши",
    es: "Gire la solicitud del botón del mouse",
    ar: "تمكين تلميحات زر الماوس",
    eo: "Ebligu musbutonajn sugestojn"
  },
  "开启光标提示": {
    en: "Enable cursor hints",
    "zh-HANT": "開啟光標提示",
    fr: "Activer les conseils de curseur",
    ru: "Включить подсказки курсора",
    es: "Enciende el cursor",
    ar: "تفعيل تلميحات المؤشر",
    eo: "Ebligu kursorajn sugestojn"
  },
  "光标提示样式": {
    en: "cursor hint style",
    "zh-HANT": "光標提示樣式",
    fr: "style d'indication du curseur",
    ru: "стиль подсказки курсора",
    es: "estilo de sugerencia de cursor",
    ar: "نمط تلميح المؤشر",
    eo: "kursora sugesta stilo"
  },
  "高级": {
    en: "Advanced",
    "zh-HANT": "高級",
    fr: "Avancé",
    ru: "Расширенный",
    es: "Avanzado",
    ar: "المتقدمة",
    eo: "progresinta"
  },
  "摄像头": {
    en: "Camera",
    "zh-HANT": "攝像頭",
    fr: "Appareil photo",
    ru: "Камера",
    es: "Cámara",
    ar: "آلة تصوير",
    eo: "Fotilo"
  },
  "默认开启": {
    en: "Default on",
    "zh-HANT": "默認開啟",
    fr: "Activé par défaut",
    ru: "Включено по умолчанию",
    es: "Activado por defecto",
    ar: "قيد التشغيل افتراضيًا",
    eo: "Enŝaltita defaŭlte"
  },
  "记录开启状态": {
    en: "Record on status",
    "zh-HANT": "記錄開啟狀態",
    fr: "Enregistrement sur",
    ru: "Запись на",
    es: "Grabación en",
    ar: "سجل على الوضع",
    eo: "registri pri stato"
  },
  "镜像": {
    en: "Mirror",
    "zh-HANT": "鏡像",
    fr: "miroir",
    ru: "зеркало",
    es: "espejo",
    ar: "مرآة",
    eo: "spegulo"
  },
  "音频": {
    en: "Audio",
    "zh-HANT": "音頻",
    fr: "Audio",
    ru: "Аудио",
    es: "Audio",
    ar: "صوتي",
    eo: "audio"
  },
  "转换": {
    en: "Convert",
    "zh-HANT": "轉換",
    fr: "convertir",
    ru: "конвертировать",
    es: "convertir",
    ar: "يتحول",
    eo: "konverti"
  },
  "使用 FFmpeg 对录制的视频进行转换工作": {
    en: "Convert recorded video with FFmpeg",
    "zh-HANT": "使用 FFmpeg 對錄製的視頻進行轉換工作",
    fr: "Convertir une vidéo enregistrée avec FFmpeg",
    ru: "Конвертируйте записанное видео с помощью FFmpeg",
    es: "Convierte videos grabados con FFmpeg",
    ar: "تحويل الفيديو المسجل مع FFmpeg",
    eo: "Konverti registritan videon per FFmpeg"
  },
  "下载 FFmpeg": {
    en: "Download FFmpeg",
    "zh-HANT": "下載 FFmpeg",
    fr: "Télécharger FFmpeg",
    ru: "Скачать FFmpeg",
    es: "Descargar FFmpeg",
    ar: "تنزيل FFmpeg",
    eo: "Elŝutu FFmpeg"
  },
  "FFmpeg 位置": {
    en: "FFmpeg location",
    "zh-HANT": "FFmpeg 位置",
    fr: "Emplacement FFmpeg",
    ru: "Местоположение FFmpeg",
    es: "Ubicación de FFmpeg",
    ar: "موقع FFmpeg",
    eo: "FFmpeg-loko"
  },
  "自动转换": {
    en: "Automatic conversion",
    "zh-HANT": "自動轉換",
    fr: "conversion automatique",
    ru: "автоматическое преобразование",
    es: "conversión automática",
    ar: "التحويل التلقائي",
    eo: "aŭtomata konvertiĝo"
  },
  "开启自动转换": {
    en: "Turn on automatic conversion",
    "zh-HANT": "開啟自動轉換",
    fr: "Activer la conversion automatique",
    ru: "Включите автоматическую конвертацию",
    es: "Activar conversión automática",
    ar: "قم بتشغيل التحويل التلقائي",
    eo: "Ŝaltu aŭtomatan konvertiĝon"
  },
  "输出格式": {
    en: "Output format",
    "zh-HANT": "輸出格式",
    fr: "format de sortie",
    ru: "Выходной формат",
    es: "formato de salida",
    ar: "تنسيق الإخراج",
    eo: "eligo formato"
  },
  "码率": {
    en: "Code rate",
    "zh-HANT": "碼率",
    fr: "taux de code",
    ru: "кодовая скорость",
    es: "tasa de código",
    ar: "معدل الكود",
    eo: "koda indico"
  },
  "帧率": {
    en: "Frame rate",
    "zh-HANT": "幀率",
    fr: "Fréquence d'images",
    ru: "Частота кадров",
    es: "Velocidad de fotogramas",
    ar: "معدل الإطار",
    eo: "framfrekvenco"
  },
  "其他参数": {
    en: "Other parameters",
    "zh-HANT": "其他參數",
    fr: "Autres paramètres",
    ru: "Другие параметры",
    es: "Otros parámetros",
    ar: "معلمات أخرى",
    eo: "Aliaj parametroj"
  },
  "高质量 Gif": {
    en: "High Quality Gif",
    "zh-HANT": "高質量 Gif",
    fr: "GIF de haute qualité",
    ru: "Высококачественный GIF",
    es: "Gif de alta calidad",
    ar: "جودة عالية Gif",
    eo: "Altkvalita GIF"
  },
  "（转换时速度会很慢）": {
    en: "(It will be slow when converting)",
    "zh-HANT": "（轉換時速度會很慢）",
    fr: "(Ce sera lent lors de la conversion)",
    ru: "(Скорость будет очень медленной при преобразовании)",
    es: "(Será lento al convertir)",
    ar: "(سيكون بطيئا عند التحويل)",
    eo: "(La rapideco estos tre malrapida kiam la konvertiĝo)"
  },
  "文件名称": {
    en: "File name",
    "zh-HANT": "文件名稱",
    fr: "Nom du fichier",
    ru: "Имя файла",
    es: "Nombre del archivo",
    ar: "اسم الملف",
    eo: "dosiernomo"
  },
  "预览:": {
    en: "Preview:",
    "zh-HANT": "預覽:",
    fr: "Avant-première :",
    ru: "Предварительный просмотр:",
    es: "Previsualización:",
    ar: "معاينة:",
    eo: "Antaŭrigardo:"
  },
  "时间代码": {
    en: "Timecode",
    "zh-HANT": "時間代碼",
    fr: "Code temporel",
    ru: "Временной код",
    es: "Código de tiempo",
    ar: "رمز الوقت",
    eo: "tempokodo"
  },
  "四位数年": {
    en: "Four-digit year",
    "zh-HANT": "四位數年",
    fr: "Année à quatre chiffres",
    ru: "Четырехзначный год",
    es: "Año de cuatro dígitos",
    ar: "أربعة أرقام سنة",
    eo: "kvarcifera jaro"
  },
  "末两位年": {
    en: "Last two digit year",
    "zh-HANT": "末兩位年",
    fr: "Deux derniers chiffres de l'année",
    ru: "Последние две цифры год",
    es: "Dos últimos dígitos año",
    ar: "خلال العامين الماضيين",
    eo: "lastaj du jaroj"
  },
  "月": {
    en: "Month",
    "zh-HANT": "月",
    fr: "Mois",
    ru: "Месяц",
    es: "Mes",
    ar: "القمر",
    eo: "luno"
  },
  "日": {
    en: "Day",
    "zh-HANT": "日",
    fr: "Jour",
    ru: "День",
    es: "Día",
    ar: "يوم",
    eo: "tago"
  },
  "星期": {
    en: "Week",
    "zh-HANT": "星期",
    fr: "Jour de la semaine",
    ru: "День недели",
    es: "Día de la semana",
    ar: "أسبوع",
    eo: "Semajno"
  },
  "24小时制小时": {
    en: "24-hour hour",
    "zh-HANT": "24小時制小時",
    fr: "24 heures par heure",
    ru: "24 часа в сутки",
    es: "24 horas por hora",
    ar: "ساعة بنظام 24 ساعة",
    eo: "24-hora horloĝo"
  },
  "12小时制小时": {
    en: "12-hour hour",
    "zh-HANT": "12小時制小時",
    fr: "12 heures horaires",
    ru: "12 почасовых часов",
    es: "12 horas por hora",
    ar: "12 ساعة",
    eo: "12-hora horloĝo"
  },
  "分": {
    en: "Minutes",
    "zh-HANT": "分",
    fr: "Minute",
    ru: "Минута",
    es: "Minuta",
    ar: "اللحظة",
    eo: "Minuto"
  },
  "秒": {
    en: "Seconds",
    "zh-HANT": "秒",
    fr: "Secondes",
    ru: "Секунды",
    es: "Segundos",
    ar: "ثانيا",
    eo: "dua"
  },
  "毫秒": {
    en: "Milliseconds",
    "zh-HANT": "毫秒",
    fr: "millisecondes",
    ru: "миллисекунды",
    es: "milisegundos",
    ar: "ميلي ثانية",
    eo: "milisekundo"
  },
  "jpg质量": {
    en: "Jpg quality",
    "zh-HANT": "jpg質量",
    fr: "qualité jpg",
    ru: "качество jpg",
    es: "calidad jpg",
    ar: "جودة jpg",
    eo: "jpg kvalito"
  },
  "编辑器": {
    en: "Editor",
    "zh-HANT": "編輯器",
    fr: "Rédacteur en chef",
    ru: "Редактор",
    es: "Editor",
    ar: "محرر",
    eo: "redaktisto"
  },
  "字体大小": {
    en: "Font size",
    "zh-HANT": "字體大小",
    fr: "Taille de la police",
    ru: "Размер шрифта",
    es: "Tamaño de letra",
    ar: "حجم الخط",
    eo: "tiparo grandeco"
  },
  "记住主页面字体大小": {
    en: "Remember main interface font size",
    "zh-HANT": "記住主页面字體大小",
    fr: "Se souvenir de la taille de la police de l'écran principal",
    ru: "Запомнить размер шрифта главного экрана",
    es: "Recordar el tamaño de letra de la pantalla principal",
    ar: "تذكر حجم خط الواجهة الرئيسية",
    eo: "Memoru la ĉefinterfacan tiparograndon"
  },
  "样式": {
    en: "Style",
    "zh-HANT": "樣式",
    fr: "Style",
    ru: "Стиль",
    es: "Estilo",
    ar: "نمط",
    eo: "stilo"
  },
  "Tab制表符宽度": {
    en: "Tab tab width",
    "zh-HANT": "Tab製表符寬度",
    fr: "Onglet Largeur de l'onglet",
    ru: "Ширина вкладки",
    es: "Ancho de la pestaña",
    ar: "عرض الجدولة",
    eo: "Larĝo de langeto"
  },
  "光标动画时间": {
    en: "Cursor animation time",
    "zh-HANT": "光標動畫時間",
    fr: "Temps d'animation du curseur",
    ru: "Время анимации курсора",
    es: "Tiempo de animación del cursor",
    ar: "وقت حركة المؤشر",
    eo: "Kursoro kuraĝigo tempo"
  },
  "更多": {
    en: "More",
    "zh-HANT": "更多",
    fr: "Plus de",
    ru: "Подробнее",
    es: "Más",
    ar: "أكثر",
    eo: "Pli"
  },
  "行号": {
    en: "Line number",
    "zh-HANT": "行號",
    fr: "Numéro de ligne",
    ru: "Номер строки",
    es: "Número de línea",
    ar: "رقم السطر",
    eo: "linio nombro"
  },
  "自动": {
    en: "Auto",
    "zh-HANT": "自動",
    fr: "Auto",
    ru: "Авто",
    es: "Auto",
    ar: "تلقائي",
    eo: "aŭtomata"
  },
  "（识屏或直接打开主页面，若文字为一行，则自动搜索）": {
    en: "(Sense screen or open main window directly, if text is one line, then search automatically)",
    "zh-HANT": "（識屏或直接打開主页面，若文字為一行，則自動搜索）",
    fr: "(Sens de l'écran ou ouverture directe de la fenêtre principale, si le texte est d'une ligne, recherche automatique)",
    ru: "(Sense screen или открыть главное окно напрямую, если текст состоит из одной строки, поиск выполняется автоматически)",
    es: "(Sentir la pantalla o abrir directamente la ventana principal, si el texto es de una línea, buscar automáticamente)",
    ar: "(تعرف على الشاشة أو افتح النافذة الرئيسية مباشرة ، إذا كان النص سطرًا واحدًا ، فسيتم البحث تلقائيًا)",
    eo: "(Lernu la ekranon aŭ malfermu la ĉefan fenestron rekte, se la teksto estas unu linio, ĝi aŭtomate serĉos)"
  },
  "自动打开链接": {
    en: "Auto open link",
    "zh-HANT": "自動打開鏈接",
    fr: "Ouverture automatique des liens",
    ru: "Автоматическое открытие ссылки",
    es: "Abrir automáticamente el enlace",
    ar: "فتح الروابط تلقائيًا",
    eo: "Aŭtomate malfermu ligilojn"
  },
  "自动搜索中文占比": {
    en: "Automatically search for Chinese percentage",
    "zh-HANT": "自動搜索中文佔比",
    fr: "Recherche automatique en chinois en pourcentage",
    ru: "Автопоиск на китайском языке в процентах",
    es: "Porcentaje de búsqueda automática en chino",
    ar: "البحث التلقائي عن نسبة الصينيين",
    eo: "Aŭtomate serĉu la proporcion de la ĉina"
  },
  "（在中英混合中，数值越小，则整段文字越容易被程序认为是中文主要）": {
    en: "(In mixed Chinese and English, the smaller the value, the more likely the whole paragraph will be considered by the program to be rimarily in Chinese)",
    "zh-HANT": "（在中英混合中，數值越小，則整段文字越容易被程序認為是中文主要）",
    fr: "(en cas de mélange de chinois et d'anglais, plus la valeur est petite, plus il est probable que le programme considère que le paragraphe entier est principalement en chinois)",
    ru: "(при смешанном китайском и английском языках, чем меньше значение, тем больше вероятность того, что весь абзац будет рассматриваться программой как написанный преимущественно на китайском языке)",
    es: "(en caso de mezcla de chino e inglés, cuanto menor sea el valor, más probable será que el programa considere que todo el párrafo está principalmente en chino)",
    ar: "(في اللغة الصينية-الإنجليزية المختلطة ، كلما كانت القيمة أصغر ، كلما كان البرنامج يعتبر فقرة النص بأكملها أسهل)",
    eo: "(En la ĉina-angla miksita, ju pli malgranda la valoro, des pli facile la tuta alineo de teksto estas konsiderata de la programo kiel ĉina)"
  },
  "文字搜索引擎": {
    en: "Text search engine",
    "zh-HANT": "文字搜索引擎",
    fr: "Moteur de recherche de texte",
    ru: "Система поиска текста",
    es: "Motor de búsqueda de texto",
    ar: "محرك البحث عن النص",
    eo: "teksta serĉilo"
  },
  "搜索引擎": {
    en: "Search engines",
    "zh-HANT": "搜索引擎",
    fr: "Moteur de recherche",
    ru: "Поисковая система",
    es: "Motor de búsqueda",
    ar: "محرك البحث",
    eo: "serĉilo"
  },
  "翻译引擎": {
    en: "Translation engines",
    "zh-HANT": "翻譯引擎",
    fr: "Moteurs de traduction",
    ru: "Системы перевода",
    es: "Motores de traducción",
    ar: "محرك الترجمة",
    eo: "tradukmotoro"
  },
  "默认引擎": {
    en: "Default engine",
    "zh-HANT": "默認引擎",
    fr: "Moteur par défaut",
    ru: "Двигатель по умолчанию",
    es: "Motor por defecto",
    ar: "المحرك الافتراضي",
    eo: "defaŭlta motoro"
  },
  "记住引擎选择": {
    en: "Remember engine selection",
    "zh-HANT": "記住引擎選擇",
    fr: "Se souvenir de la sélection du moteur",
    ru: "Помните о выборе двигателя",
    es: "Recuerde la selección del motor",
    ar: "تذكر اختيار المحرك",
    eo: "Memoru la elekton de motoro"
  },
  "图像搜索引擎": {
    en: "Image search engine",
    "zh-HANT": "圖像搜索引擎",
    fr: "Moteur de recherche d'images",
    ru: "Система поиска изображений",
    es: "Motor de búsqueda de imágenes",
    ar: "محرك البحث عن الصور",
    eo: "bilda serĉilo"
  },
  "浏览器中打开": {
    en: "Open in browser",
    "zh-HANT": "瀏覽器中打開",
    fr: "Ouvrir dans le navigateur",
    ru: "Открыть в браузере",
    es: "Abrir en el navegador",
    ar: "فتح في المتصفح",
    eo: "malfermu en retumilo"
  },
  "（点击搜索或翻译按钮后，将在系统默认浏览器打开搜索结果，否则在一个新的软件窗口打开）": {
    en: "(When you click the search or translate button, the search results will open in the system default browser, otherwise they will open in a new software window)",
    "zh-HANT": "（點擊搜索或翻譯按鈕後，將在系統默認瀏覽器打開搜索結果，否則在一個新的軟件窗口打開）",
    fr: "(Lorsque le bouton de recherche ou de traduction est cliqué, les résultats de la recherche s'ouvrent dans le navigateur par défaut du système, sinon ils s'ouvrent dans une nouvelle fenêtre du logiciel)",
    ru: "(При нажатии на кнопку поиска или перевода результаты поиска открываются в браузере системы по умолчанию, в противном случае они открываются в новом окне программы)",
    es: "(Al hacer clic en el botón de búsqueda o de traducción, los resultados de la búsqueda se abrirán en el navegador predeterminado del sistema; de lo contrario, se abrirán en una nueva ventana de software)",
    ar: "(بعد النقر فوق زر البحث أو الترجمة ، سيتم فتح نتيجة البحث في متصفح النظام الافتراضي ، وإلا سيتم فتحها في نافذة برنامج جديدة)",
    eo: "(Post klakado de la serĉo aŭ traduki butonon, la serĉrezulto estos malfermita en la sistema defaŭlta retumilo, alie ĝi estos malfermita en nova programara fenestro)"
  },
  "浏览器打开后自动关闭标签页": {
    en: "Automatically close tabs after browser opens",
    "zh-HANT": "瀏覽器打開後自動關閉標籤頁",
    fr: "Fermer automatiquement les onglets après l'ouverture du navigateur",
    ru: "Автоматически закрывать вкладки после открытия браузера",
    es: "Cerrar pestañas automáticamente después de que se abra el navegador",
    ar: "إغلاق علامات التبويب تلقائيًا بعد فتح المتصفح",
    eo: "Aŭtomate fermu langetojn post la retumilo malfermiĝas"
  },
  "标签缩小": {
    en: "Tab shrink",
    "zh-HANT": "標籤縮小",
    fr: "Réduction de l'onglet",
    ru: "Вкладка сжимается",
    es: "Reducción de pestañas",
    ar: "تقليص علامة التبويب",
    eo: "Tab ŝrumpas"
  },
  "（标签将只显示图标，悬浮查看标题，中键或右键关闭）": {
    en: "(The label will only display the icon, hover to view the title, middle click or right click to close)",
    "zh-HANT": "（標籤將只顯示圖標，懸浮查看標題，中鍵或右鍵關閉）",
    fr: "(L'étiquette n'affichera que l'icône, survolez pour afficher le titre, cliquez avec le bouton du milieu ou cliquez avec le bouton droit pour fermer)",
    ru: "(Ярлык будет отображать только значок, наведите курсор, чтобы просмотреть заголовок, щелкните средней кнопкой мыши или щелкните правой кнопкой мыши, чтобы закрыть)",
    es: "(La etiqueta solo mostrará el ícono, desplace el cursor para ver el título, haga clic con el botón central o haga clic con el botón derecho para cerrar)",
    ar: "(ستعرض التسمية الرمز فقط ، قم بالمرور لعرض العنوان ، أو النقر بزر الماوس الأيمن أو النقر بزر الماوس الأيمن للإغلاق)",
    eo: "(La etikedo nur montros la ikonon, ŝvebu por vidi la titolon, mezklakon aŭ dekstren por fermi)"
  },
  "标签图标灰度": {
    en: "Label icon grayscale",
    "zh-HANT": "標籤圖標灰度",
    fr: "Icône d'étiquette en niveaux de gris",
    ru: "Значок метки в оттенках серого",
    es: "Icono de etiqueta en escala de grises",
    ar: "رمز التسمية بتدرج الرمادي",
    eo: "Etikedikono grizskalo"
  },
  "（标签图标将以灰度图片展示，减少多余颜色的干扰）": {
    en: "(The label icon will be displayed as a grayscale image to reduce the interference of redundant colors)",
    "zh-HANT": "（標籤圖標將以灰度圖片展示，減少多餘顏色的干擾）",
    fr: "(L'icône de l'étiquette sera affichée sous forme d'image en niveaux de gris pour réduire l'interférence des couleurs redondantes)",
    ru: "(Значок метки будет отображаться в виде изображения в градациях серого, чтобы уменьшить интерференцию избыточных цветов)",
    es: "(El ícono de la etiqueta se mostrará como una imagen en escala de grises para reducir la interferencia de colores redundantes)",
    ar: "(سيتم عرض أيقونة الملصق كصورة ذات تدرج رمادي لتقليل تداخل الألوان الزائدة عن الحاجة)",
    eo: "(La etikedikono estos montrata kiel grizskala bildo por redukti la interferon de superfluaj koloroj)"
  },
  "标签页透明填充": {
    en: "Transparent padding for tabs",
    "zh-HANT": "標籤頁透明填充",
    fr: "Rembourrage transparent pour les onglets",
    ru: "Прозрачные отступы для вкладок",
    es: "Acolchado transparente para pestañas",
    ar: "حشوة شفافة لعلامات التبويب",
    eo: "Travidebla remburaĵo por langetoj"
  },
  "（某些透明背景的标签页将填充颜色，否则透明显示，可看见窗口后内容）": {
    en: "(Some tabs with a transparent background will be filled with color, otherwise they will be displayed transparently, and the content behind the window can be seen)",
    "zh-HANT": "（某些透明背景的標籤頁將填充顏色，否則透明顯示，可看見窗口後內容）",
    fr: "(Certains onglets avec un fond transparent seront remplis de couleur, sinon ils seront affichés de manière transparente et le contenu derrière la fenêtre sera visible)",
    ru: "(Некоторые вкладки с прозрачным фоном будут заполнены цветом, иначе они будут отображаться прозрачно, и будет видно содержимое за окном)",
    es: "(Algunas pestañas con un fondo transparente se rellenarán con color; de lo contrario, se mostrarán de forma transparente y se podrá ver el contenido detrás de la ventana)",
    ar: "(سيتم ملء بعض علامات التبويب ذات الخلفية الشفافة بالألوان ، وإلا فسيتم عرضها بشفافية ويمكن رؤية المحتوى الموجود خلف النافذة)",
    eo: "(Kelkaj langetoj kun travidebla fono estos plenigitaj per koloro, alie ili estos montrataj travideble, kaj la enhavo malantaŭ la fenestro videblas)"
  },
  "文字识别（OCR）": {
    en: "Text recognition (OCR)",
    "zh-HANT": "文字識別（OCR）",
    fr: "Reconnaissance de texte (OCR)",
    ru: "Распознавание текста (OCR)",
    es: "Reconocimiento de textos (OCR)",
    ar: "التعرف على الحروف (OCR)",
    eo: "Karaktera Rekono (OCR)"
  },
  "离线OCR": {
    en: "Offline OCR",
    "zh-HANT": "離線OCR",
    fr: "OCR hors ligne",
    ru: "Автономное распознавание текста",
    es: "OCR fuera de línea",
    ar: "التعرف الضوئي على الحروف في وضع عدم الاتصال",
    eo: "Senkonekta OCR"
  },
  "百度": {
    en: "Baidu",
    "zh-HANT": "百度",
    fr: "Baidu",
    ru: "Baidu",
    es: "Baidu",
    ar: "Baidu",
    eo: "Baidu"
  },
  "有道": {
    en: "Youdao",
    "zh-HANT": "有道",
    fr: "Youdao",
    ru: "Youdao",
    es: "Youdao",
    ar: "Youdao",
    eo: "Youdao"
  },
  "离线时切换离线OCR": {
    en: "Switch offline OCR when offline",
    "zh-HANT": "離線時切換離線OCR",
    fr: "Commutation de l'OCR en mode hors ligne",
    ru: "Переключение автономного распознавания текста в автономном режиме",
    es: "Cambiar el OCR fuera de línea cuando está desconectado",
    ar: "تبديل OCR في وضع عدم الاتصال عند عدم الاتصال بالإنترنت",
    eo: "Ŝaltigu eksterrete OCR kiam eksterrete"
  },
  "OCR检测": {
    en: "OCR detection",
    "zh-HANT": "OCR檢測",
    fr: "Détection OCR",
    ru: "Обнаружение OCR",
    es: "Detección de OCR",
    ar: "كشف التعرف الضوئي على الحروف",
    eo: "OCR-detekto"
  },
  "（每次启动时都提示OCR服务是否安装或开启）": {
    en: "(prompt for OCR service to be installed or turned on at each startup)",
    "zh-HANT": "（每次啟動時都提示OCR服務是否安裝或開啟）",
    fr: "(demande d'installation ou d'activation du service ROC à chaque démarrage)",
    ru: "(запрашивает установку или включение службы OCR при каждом запуске)",
    es: "(pide que se instale o active el servicio OCR en cada inicio)",
    ar: "(في كل مرة تبدأ ، سيُطلب منك ما إذا كانت خدمة OCR مثبتة أم ممكّنة)",
    eo: "(Ĉiufoje kiam vi komencas, vi estos demandita ĉu la OCR-servo estas instalita aŭ ebligita)"
  },
  "det模型": {
    en: "det model",
    "zh-HANT": "det模型",
    fr: "modèle détaché",
    ru: "детальная модель",
    es: "modelo det",
    ar: "نموذج ديت",
    eo: "det modelo"
  },
  "rec模型": {
    en: "rec model",
    "zh-HANT": "rec模型",
    fr: "modèle récréatif",
    ru: "модель rec",
    es: "modelo rec",
    ar: "نموذج تفصيل",
    eo: "rec modelo"
  },
  "字典": {
    en: "Dictionary",
    "zh-HANT": "字典",
    fr: "dictionnaire",
    ru: "словарь",
    es: "diccionario",
    ar: "قاموس",
    eo: "vortaro"
  },
  "位置": {
    en: "Location",
    "zh-HANT": "位置",
    fr: "emplacement",
    ru: "местоположение",
    es: "ubicación",
    ar: "موقع",
    eo: "Loko"
  },
  "下载离线OCR": {
    en: "Download offline OCR",
    "zh-HANT": "下載離線OCR",
    fr: "Télécharger l'OCR hors ligne",
    ru: "Скачать автономный OCR",
    es: "Descargar OCR sin conexión",
    ar: "تنزيل Offline OCR",
    eo: "Elŝutu Senkonekta OCR"
  },
  "删除离线OCR": {
    en: "Felete offline OCR",
    "zh-HANT": "刪除離線OCR",
    fr: "Supprimer l'OCR hors ligne",
    ru: "Удаление автономного OCR",
    es: "Eliminar el OCR fuera de línea",
    ar: "حذف OCR في وضع عدم الاتصال",
    eo: "Forigu eksterrete OCR"
  },
  "在线OCR": {
    en: "Online OCR",
    "zh-HANT": "在線OCR",
    fr: "OCR en ligne",
    ru: "Онлайн OCR",
    es: "OCR en línea",
    ar: "التعرف الضوئي على الحروف عبر الإنترنت",
    eo: "Enreta OCR"
  },
  "类型：": {
    en: "Type:",
    "zh-HANT": "類型：",
    fr: "Type.",
    ru: "Тип.",
    es: "Tipo.",
    ar: "يكتب:",
    eo: "tajpu:"
  },
  "位置版不起实质效果，但可以扩充免费使用次数:)": {
    en: "Location version does not have a substantial effect, but can be expanded for free usage :)",
    "zh-HANT": "位置版不起實質效果，但可以擴充免費使用次數:)",
    fr: "La version localisée n'a pas d'effet substantiel, mais peut être étendue pour une utilisation libre :)",
    ru: "Версия Location не имеет существенного эффекта, но может быть расширена для бесплатного использования :)",
    es: "La versión de localización no tiene un efecto sustancial, pero puede ampliarse para su uso gratuito :)",
    ar: "ليس لإصدار الموقع أي تأثير حقيقي ، ولكن يمكنه زيادة عدد الاستخدامات المجانية :)",
    eo: "La loka versio ne havas realan efikon, sed povas pligrandigi la nombron da senpagaj uzoj :)"
  },
  "高精度版": {
    en: "High-precision version",
    "zh-HANT": "高精度版",
    fr: "Version haute précision",
    ru: "Высокоточное исполнение",
    es: "Versión de alta precisión",
    ar: "نسخة عالية الدقة",
    eo: "Altpreciza versio"
  },
  "高精度含位置版": {
    en: "High-precision version with location",
    "zh-HANT": "高精度含位置版",
    fr: "Version haute précision avec localisation",
    ru: "Высокоточная версия с указанием местоположения",
    es: "Versión de alta precisión con localización",
    ar: "دقة عالية مع إصدار الموقف",
    eo: "Alta precizeco kun pozicia versio"
  },
  "标准版": {
    en: "Standard",
    "zh-HANT": "標準版",
    fr: "Version standard",
    ru: "Стандартная версия",
    es: "Versión estándar",
    ar: "الإصدار القياسي",
    eo: "Norma Eldono"
  },
  "标准含位置版": {
    en: "Standard with location",
    "zh-HANT": "標準含位置版",
    fr: "Standard avec position",
    ru: "Стандарт с положением",
    es: "Estándar con posición",
    ar: "قياسي مع إصدار الموقع",
    eo: "Norma kun loka versio"
  },
  "手写文字": {
    en: "Handwritten text",
    "zh-HANT": "手寫文字",
    fr: "Texte manuscrit",
    ru: "Рукописный текст",
    es: "Texto escrito a mano",
    ar: "نص مكتوب بخط اليد",
    eo: "manskribita teksto"
  },
  "公式": {
    en: "Formula",
    "zh-HANT": "公式",
    fr: "Formules",
    ru: "Формулы",
    es: "Fórmulas",
    ar: "معادلة",
    eo: "formulo"
  },
  "API Key：": {
    en: "API Key:",
    "zh-HANT": "API Key：",
    fr: "Clé API.",
    ru: "API Key.",
    es: "Clave API.",
    ar: "مفتاح API:",
    eo: "API Ŝlosilo:"
  },
  "Secret Key：": {
    en: "Secret Key:",
    "zh-HANT": "Secret Key：",
    fr: "Clé secrète.",
    ru: "Секретный ключ.",
    es: "Llave secreta.",
    ar: "المفتاح السري:",
    eo: "Sekreta Ŝlosilo:"
  },
  "应用ID：": {
    en: "App ID:",
    "zh-HANT": "應用ID：",
    fr: "ID de la demande.",
    ru: "ID приложения.",
    es: "Identificación de la solicitud.",
    ar: "معرف التطبيق:",
    eo: "App ID:"
  },
  "应用秘钥：": {
    en: "App Secret Key:",
    "zh-HANT": "應用秘鑰：",
    fr: "Clé secrète de l'application.",
    ru: "Секретный ключ приложения.",
    es: "Clave secreta de la aplicación.",
    ar: "مفتاح التطبيق:",
    eo: "Aplika ŝlosilo:"
  },
  "保留截屏记录": {
    en: "Keep screenshots",
    "zh-HANT": "保留截屏記錄",
    fr: "Conserver les captures d'écran",
    ru: "Сохранять скриншоты",
    es: "Conservar las capturas de pantalla",
    ar: "احتفظ بسجل من لقطات الشاشة",
    eo: "Konservu rekordon de ekrankopioj"
  },
  "不勾选将不限次数保留": {
    en: "Uncheck to keep unlimited times",
    "zh-HANT": "不勾選將不限次數保留",
    fr: "Conserver autant de fois que vous le souhaitez sans cocher la case.",
    ru: "Сохранять сколько угодно раз, не устанавливая флажок",
    es: "Retener tantas veces como quiera sin marcar la casilla",
    ar: "قم بإلغاء التحديد للاحتفاظ بأوقات غير محدودة",
    eo: "Malmarku por konservi senlimajn tempojn"
  },
  "只保留": {
    en: "Keep only",
    "zh-HANT": "只保留",
    fr: "A conserver uniquement",
    ru: "Сохранять только",
    es: "Conservar sólo",
    ar: "احتفظ بها فقط",
    eo: "konservi nur"
  },
  "次记录": {
    en: "record",
    "zh-HANT": "次記錄",
    fr: "Heures enregistrées",
    ru: "Зарегистрированное время",
    es: "Tiempos registrados",
    ar: "سجل الوقت",
    eo: "temporekordo"
  },
  "清空所有截屏记录": {
    en: "Clear all screenshots",
    "zh-HANT": "清空所有截屏記錄",
    fr: "Effacer toutes les captures d'écran",
    ru: "Очистить все скриншоты",
    es: "Borrar todas las capturas de pantalla",
    ar: "مسح كافة لقطات الشاشة",
    eo: "Forigi ĉiujn ekrankopiojn"
  },
  "保留历史记录": {
    en: "Keep history",
    "zh-HANT": "保留歷史記錄",
    fr: "Conserver l'historique",
    ru: "Вести историю",
    es: "Mantener la historia",
    ar: "احتفظ بالتاريخ",
    eo: "konservi historion"
  },
  "自动清除历史记录": {
    en: "Automatically clear history",
    "zh-HANT": "自動清除歷史記錄",
    fr: "Effacer automatiquement l'historique",
    ru: "Очистить историю автоматически",
    es: "Borrar el historial automáticamente",
    ar: "محو السجل تلقائيًا",
    eo: "Aŭtomate malplenigi historion"
  },
  "天": {
    en: "days",
    "zh-HANT": "天",
    fr: "jours",
    ru: "дней",
    es: "días",
    ar: "سماء",
    eo: "ĉielo"
  },
  "小时": {
    en: "hours",
    "zh-HANT": "小時",
    fr: "heures",
    ru: "часы",
    es: "horas",
    ar: "ساعة",
    eo: "Horo"
  },
  "清空所有文字记录": {
    en: "Clear all text records",
    "zh-HANT": "清空所有文字記錄",
    fr: "Effacer tous les enregistrements de texte",
    ru: "Очистить все текстовые записи",
    es: "Borrar todos los registros de texto",
    ar: "امسح كافة السجلات النصية",
    eo: "Forigi ĉiujn tekstajn registrojn"
  },
  "日期格式": {
    en: "Date format",
    "zh-HANT": "日期格式",
    fr: "Format de la date",
    ru: "Формат даты",
    es: "Formato de la fecha",
    ar: "صيغة التاريخ",
    eo: "data formato"
  },
  "代理": {
    en: "Proxy",
    "zh-HANT": "代理",
    fr: "Proxy",
    ru: "Прокси",
    es: "Proxy",
    ar: "التمثيل",
    eo: "aktorado"
  },
  "开启代理": {
    en: "Proxy on",
    "zh-HANT": "開啟代理",
    fr: "Activer les proxies",
    ru: "Включите прокси-серверы",
    es: "Activar los proxies",
    ar: "تمكين الوكيل",
    eo: "ebligi prokurilon"
  },
  "pac文件：": {
    en: "Pac file:",
    "zh-HANT": "pac文件：",
    fr: "fichier pac.",
    ru: "pac file.",
    es: "archivo pac.",
    ar: "ملف pac:",
    eo: "pac dosiero:"
  },
  "代理规则：": {
    en: "Proxy rules:",
    "zh-HANT": "代理規則：",
    fr: "Règles de procuration.",
    ru: "Правила доверенности.",
    es: "Normas de representación.",
    ar: "قواعد الوكيل:",
    eo: "Prokuraj reguloj:"
  },
  "排除规则：": {
    en: "Exclusion rules:",
    "zh-HANT": "排除規則：",
    fr: "Règles d'exclusion.",
    ru: "Правила исключения.",
    es: "Normas de exclusión.",
    ar: "قواعد الاستبعاد:",
    eo: "Reguloj pri ekskludo:"
  },
  "自动关闭窗口": {
    en: "Autoclose window",
    "zh-HANT": "自動關閉窗口",
    fr: "Fenêtre à fermeture automatique",
    ru: "Автоматическое закрытие окна",
    es: "Ventana de cierre automático",
    ar: "أغلق النافذة تلقائيًا",
    eo: "Aŭtomate fermu la fenestron"
  },
  "失去焦点后自动关闭": {
    en: "Autoclose when focus is lost",
    "zh-HANT": "失去焦點後自動關閉",
    fr: "Fermeture automatique après perte de la mise au point",
    ru: "Автоматическое закрытие после потери фокуса",
    es: "Cierre automático tras perder el enfoque",
    ar: "إغلاق تلقائي بعد فقدان التركيز",
    eo: "Aŭtomata fermo post perdo de fokuso"
  },
  "高级设置": {
    en: "Advanced settings",
    "zh-HANT": "高級設置",
    fr: "Paramètres avancés",
    ru: "Дополнительные настройки",
    es: "Configuración avanzada",
    ar: "إعدادات متقدمة",
    eo: "altnivelaj agordoj"
  },
  "直接编辑设置源文件，更多自定义设置": {
    en: "Edit settings source file directly, more custom settings",
    "zh-HANT": "直接編輯設置源文件，更多自定義設置",
    fr: "Modification directe du fichier source des paramètres, plus de paramètres personnalisés",
    ru: "Редактирование исходного файла настроек напрямую, больше пользовательских настроек",
    es: "Editar directamente el archivo de origen de los ajustes, más ajustes personalizados",
    ar: "قم بتحرير ملفات مصدر الإعدادات مباشرة ، والمزيد من الإعدادات المخصصة",
    eo: "Redaktu agordojn fontdosierojn rekte, pli kutimajn agordojn"
  },
  "（需要JSON知识）": {
    en: "(JSON knowledge required)",
    "zh-HANT": "（需要JSON知識）",
    fr: "(connaissance de JSON requise)",
    ru: "(Требуется знание JSON)",
    es: "(Se requieren conocimientos de JSON)",
    ar: "(مطلوب معرفة JSON)",
    eo: "(JSON-scio bezonata)"
  },
  "打开设置源文件": {
    en: "Open settings source file",
    "zh-HANT": "打開設置源文件",
    fr: "Ouvrir le fichier source des paramètres",
    ru: "Открыть исходный файл настроек",
    es: "Abrir el archivo fuente de configuración",
    ar: "افتح ملف مصدر الإعدادات",
    eo: "Malfermu la agordan fontdosieron"
  },
  "恢复默认设置": {
    en: "Restore default settings",
    "zh-HANT": "恢復默認設置",
    fr: "Restaurer les paramètres par défaut",
    ru: "Восстановление настроек по умолчанию",
    es: "Restaurar la configuración por defecto",
    ar: "استعادة الإعدادات الافتراضية",
    eo: "restarigi defaŭltajn agordojn"
  },
  "不保存本次设置值": {
    en: "Do not save this setting",
    "zh-HANT": "不保存本次設置值",
    fr: "Ne pas sauvegarder cette valeur de réglage",
    ru: "Не сохранять это значение настройки",
    es: "No guardar este valor de ajuste",
    ar: "لا تحفظ الإعدادات الحالية",
    eo: "Ne konservu la nunajn agordojn"
  },
  "（若不清楚刚才更改了什么设置，请选中）": {
    en: "(Check if you're not sure what settings you just changed)",
    "zh-HANT": "（若不清楚剛才更改了什麼設置，請選中）",
    fr: "(vérifiez si vous n'êtes pas sûr des paramètres que vous venez de modifier)",
    ru: "(проверьте, если вы не уверены, какие настройки вы только что изменили)",
    es: "(compruebe si no está seguro de la configuración que acaba de cambiar)",
    ar: "(إذا كنت لا تعرف الإعداد الذي قمت بتغييره للتو ، فيرجى التحقق منه)",
    eo: "(Se vi ne scias, kian agordon vi ĵus ŝanĝis, bonvolu kontroli ĝin)"
  },
  "硬件加速": {
    en: "Hardware acceleration",
    "zh-HANT": "硬件加速",
    fr: "Accélération matérielle",
    ru: "Аппаратное ускорение",
    es: "Aceleración por hardware",
    ar: "تسريع الأجهزة",
    eo: "Aparataro Akcelo"
  },
  "启用硬件加速": {
    en: "Enable hardware acceleration",
    "zh-HANT": "啟用硬件加速",
    fr: "Activer l'accélération matérielle",
    ru: "Включить аппаратное ускорение",
    es: "Activar la aceleración por hardware",
    ar: "تفعيل تسريع الأجهزة",
    eo: "Ebligu aparatan akcelon"
  },
  "（如果可用，且更改需要重启软件生效）": {
    en: "(if available and changes require a software restart to take effect)",
    "zh-HANT": "（如果可用，且更改需要重啟軟件生效）",
    fr: "(si disponible et si les changements nécessitent un redémarrage du logiciel pour prendre effet)",
    ru: "(если доступно и изменения требуют перезапуска программного обеспечения для вступления в силу)",
    es: "(si está disponible y los cambios requieren un reinicio del software para que surtan efecto)",
    ar: "(إذا كان ذلك متاحًا ، وتتطلب التغييرات إعادة تشغيل البرنامج حتى تصبح سارية المفعول)",
    eo: "(se disponeblas, kaj ŝanĝoj postulas rekomencon de programaro por efiki)"
  },
  "检查更新": {
    en: "Check for updates",
    "zh-HANT": "檢查更新",
    fr: "Vérifier les mises à jour",
    ru: "Проверьте наличие обновлений",
    es: "Comprobar las actualizaciones",
    ar: "تحقق من وجود تحديثات",
    eo: "Kontrolu ĝisdatigojn"
  },
  "启用检查更新": {
    en: "Enable check for updates",
    "zh-HANT": "啟用檢查更新",
    fr: "Activer la vérification des mises à jour",
    ru: "Включить проверку наличия обновлений",
    es: "Activar la comprobación de actualizaciones",
    ar: "تمكين التحقق من وجود تحديثات",
    eo: "Ebligu kontrolon pri ĝisdatigoj"
  },
  "（仅在周末检查，且只在设置打开时检查）": {
    en: "(only check on weekends and only when settings are turned on)",
    "zh-HANT": "（僅在周末檢查，且只在設置打開時檢查）",
    fr: "(vérifié uniquement le week-end et uniquement lorsque les paramètres sont activés)",
    ru: "(проверяется только по выходным и только при включенных настройках)",
    es: "(sólo se comprueba los fines de semana y sólo cuando la configuración está activada)",
    ar: "(يتم التحقق منه فقط في عطلات نهاية الأسبوع ، وفقط عندما تكون الإعدادات قيد التشغيل)",
    eo: "(nur kontrolita semajnfine, kaj nur kiam la agordoj estas ŝaltitaj)"
  },
  "位置信息": {
    en: "Location information",
    "zh-HANT": "位置信息",
    fr: "Informations sur la localisation",
    ru: "Информация о местоположении",
    es: "Información sobre la ubicación",
    ar: "معلومات الموقع",
    eo: "informoj pri loko"
  },
  "版本信息": {
    en: "Version information",
    "zh-HANT": "版本信息",
    fr: "Informations sur la version",
    ru: "Информация о версии",
    es: "Información sobre la versión",
    ar: "معلومات الإصدار",
    eo: "Versio Informoj"
  },
  "运行目录：": {
    en: "Operational directory:",
    "zh-HANT": "運行目錄：",
    fr: "Répertoire opérationnel.",
    ru: "Оперативный справочник.",
    es: "Directorio operativo.",
    ar: "دليل التشغيل:",
    eo: "ruli dosierujon:"
  },
  "配置目录：": {
    en: "Configuration Directory:",
    "zh-HANT": "配置目錄：",
    fr: "Répertoire de configuration.",
    ru: "Каталог конфигурации.",
    es: "Directorio de configuración.",
    ar: "دليل التكوين:",
    eo: "Agorda dosierujo:"
  },
  "OCR 目录：": {
    en: "OCR Directory:",
    "zh-HANT": "OCR 目錄：",
    fr: "Répertoire OCR.",
    ru: "Каталог OCR.",
    es: "Directorio OCR.",
    ar: "دليل OCR:",
    eo: "OCR-dosierujo:"
  },
  "临时目录：": {
    en: "Temporary directory:",
    "zh-HANT": "臨時目錄：",
    fr: "Répertoire temporaire.",
    ru: "Временная директория.",
    es: "Directorio temporal.",
    ar: "دليل مؤقت:",
    eo: "Provizora dosierujo:"
  },
  "文字记录：": {
    en: "Text records:",
    "zh-HANT": "文字記錄：",
    fr: "Enregistrements de texte.",
    ru: "Текстовые записи.",
    es: "Registros de texto.",
    ar: "نص:",
    eo: "Transskribaĵo:"
  },
  "截屏记录：": {
    en: "Screenshot records:",
    "zh-HANT": "截屏記錄：",
    fr: "Enregistrements des captures d'écran.",
    ru: "Скриншоты записей.",
    es: "Registros de pantalla.",
    ar: "سجل لقطة الشاشة:",
    eo: "Rekordo de ekrankopio:"
  },
  "本机系统内核:": {
    en: "Local system kernel:",
    "zh-HANT": "本機系統內核:",
    fr: "Noyau du système local :",
    ru: "Ядро локальной системы:",
    es: "Núcleo del sistema local:",
    ar: "نواة النظام الأصلي:",
    eo: "Denaska sistema kerno:"
  },
  "识屏 · 搜索": {
    en: "Screen recognition · Search",
    "zh-HANT": "識屏 · 搜索",
    fr: "Connaître son écran - Recherche",
    ru: "Знай свой экран - Поиск",
    es: "Conozca su pantalla - Búsqueda",
    ar: "التعرف على الشاشة · بحث",
    eo: "Ekranrekono · Serĉi"
  },
  "有新版本:": {
    en: "New version available:",
    "zh-HANT": "有新版本:",
    fr: "Nouvelle version disponible :",
    ru: "Доступна новая версия:",
    es: "Nueva versión disponible:",
    ar: "هناك إصدارات جديدة:",
    eo: "Estas novaj versioj:"
  },
  "暂无更新": {
    en: "No updates available at this time",
    "zh-HANT": "暫無更新",
    fr: "Aucune mise à jour pour le moment",
    ru: "На данный момент обновлений нет",
    es: "No hay actualizaciones en este momento",
    ar: "لا يوجد تحديث حتى الان",
    eo: "Ankoraŭ neniu ĝisdatigo"
  },
  "项目主页:": {
    en: "Project home page:",
    "zh-HANT": "項目主頁:",
    fr: "Page d'accueil du projet :",
    ru: "Домашняя страница проекта:",
    es: "Página de inicio del proyecto:",
    ar: "الصفحة الرئيسية للمشروع:",
    eo: "Hejmpaĝo de la Projekto:"
  },
  "更新日志": {
    en: "Update Log",
    "zh-HANT": "更新日誌",
    fr: "Journal des mises à jour",
    ru: "Журнал обновления",
    es: "Registro de actualización",
    ar: "التغيير",
    eo: "Ŝanĝprotokolo"
  },
  "错误报告与建议": {
    en: "Bug reports and suggestions",
    "zh-HANT": "錯誤報告與建議",
    fr: "Rapports de bogue et suggestions",
    ru: "Сообщения об ошибках и предложения",
    es: "Informes de errores y sugerencias",
    ar: "تقارير الشوائب والاقتراحات",
    eo: "Cimraportoj kaj sugestoj"
  },
  "本软件遵循": {
    en: "This software follows",
    "zh-HANT": "本軟件遵循",
    fr: "Ce logiciel suit",
    ru: "Это программное обеспечение следует",
    es: "Este software sigue",
    ar: "هذا البرنامج يتبع",
    eo: "Ĉi tiu programaro sekvas la"
  },
  "本软件基于": {
    en: "This software is based on",
    "zh-HANT": "本軟件基於",
    fr: "Ce logiciel est basé sur",
    ru: "Это программное обеспечение основано на",
    es: "Este software se basa en",
    ar: "يعتمد هذا البرنامج على",
    eo: "Ĉi tiu programaro baziĝas sur"
  },
  "这些软件": {
    en: "these software",
    "zh-HANT": "這些軟件",
    fr: "Ces logiciels",
    ru: "Эти программы",
    es: "Estos programas informáticos",
    ar: "هذه البرامج",
    eo: "ĉi tiuj programaroj"
  }
};
var language = "";
var l2l = {
  "zh-CN": "zh-HANS",
  "zh-SG": "zh-HANS",
  "zh-TW": "zh-HANT",
  "zh-HK": "zh-HANT",
  "en-GB": "en",
  "en-UK": "en",
  "fr-BE": "fr",
  "fr-CA": "fr",
  "fr-CH": "fr",
  "fr-FR": "fr",
  "fr-LU": "fr",
  "fr-MC": "fr",
  "ru-RU": "ru",
  "es-AR": "es",
  "es-BO": "es",
  "es-CL": "es",
  "es-CO": "es",
  "es-CR": "es",
  "es-DO": "es",
  "es-EC": "es",
  "es-ES": "es",
  "es-ES": "es",
  "es-GT": "es",
  "es-HN": "es",
  "es-MX": "es",
  "es-NI": "es",
  "es-PA": "es",
  "es-PE": "es",
  "es-PR": "es",
  "es-PY": "es",
  "es-SV": "es",
  "es-UY": "es",
  "es-VE": "es",
  "ar-AE": "ar",
  "ar-BH": "ar",
  "ar-DZ": "ar",
  "ar-EG": "ar",
  "ar-IQ": "ar",
  "ar-JO": "ar",
  "ar-KW": "ar",
  "ar-LB": "ar",
  "ar-LY": "ar",
  "ar-MA": "ar",
  "ar-OM": "ar",
  "ar-QA": "ar",
  "ar-SA": "ar",
  "ar-SY": "ar",
  "ar-TN": "ar",
  "ar-YE": "ar"
};
function lan(lan2) {
  language = lan2;
}
function t(text) {
  if (l2l[language] == "zh-HANS")
    return text;
  return obj?.[text]?.[language] || obj?.[text]?.[l2l[language]] || text;
}
function format(fmt, date) {
  let ret;
  const opt = {
    YYYY: date.getFullYear() + "",
    YY: date.getFullYear() % 1e3 + "",
    MM: (date.getMonth() + 1 + "").padStart(2, "0"),
    M: date.getMonth() + 1 + "",
    DD: (date.getDate() + "").padStart(2, "0"),
    D: date.getDate() + "",
    d: date.getDay() + "",
    HH: (date.getHours() + "").padStart(2, "0"),
    H: date.getHours() + "",
    hh: (date.getHours() % 12 + "").padStart(2, "0"),
    h: date.getHours() % 12 + "",
    mm: (date.getMinutes() + "").padStart(2, "0"),
    m: date.getMinutes() + "",
    ss: (date.getSeconds() + "").padStart(2, "0"),
    s: date.getSeconds() + "",
    S: date.getMilliseconds() + ""
  };
  for (let k in opt) {
    ret = new RegExp(`${k}`, "g");
    fmt = fmt.replace(ret, `${opt[k]}`);
  }
  return fmt;
}
const Store = require("electron-store");
const runPath = path__namespace.join(path__namespace.resolve(__dirname, ""), "../../");
try {
  var userDataPath = fs__namespace.readFileSync(path__namespace.join(runPath, "preload_config")).toString().trim();
  if (userDataPath) {
    if (electron.app.isPackaged) {
      userDataPath = path__namespace.join(runPath, "../../", userDataPath);
    } else {
      userDataPath = path__namespace.join(runPath, userDataPath);
    }
    electron.app.setPath("userData", userDataPath);
  }
} catch (e) {
}
electron.ipcMain.on("run_path", (event) => {
  event.returnValue = runPath;
});
var store = new Store();
var dev;
if (process.argv.includes("-d") || false) {
  dev = true;
} else {
  dev = false;
}
function rendererPath(window, fileName, q) {
  if (!q) {
    q = { query: { config_path: electron.app.getPath("userData") } };
  } else if (!q.query) {
    q.query = { config_path: electron.app.getPath("userData") };
  } else {
    q.query["config_path"] = electron.app.getPath("userData");
  }
  if (!electron.app.isPackaged && process.env["ELECTRON_RENDERER_URL"]) {
    let mainUrl = `${process.env["ELECTRON_RENDERER_URL"]}/${fileName}`;
    let x2 = new url.URL(mainUrl);
    if (q) {
      if (q.search)
        x2.search = q.search;
      if (q.query) {
        for (let i in q.query) {
          x2.searchParams.set(i, q.query[i]);
        }
      }
      if (q.hash)
        x2.hash = q.hash;
    }
    window.loadURL(x2.toString());
  } else {
    window.loadFile(path__namespace.join(__dirname, "../renderer", fileName), q);
  }
}
if (!store.get("硬件加速")) {
  electron.app.disableHardwareAcceleration();
}
electron.ipcMain.on("autostart", (event, m, v) => {
  if (m == "set") {
    if (process.platform == "linux") {
      if (v) {
        child_process.exec("mkdir ~/.config/autostart");
        child_process.exec(`cp ${runPath}/assets/e-search.desktop ~/.config/autostart/`);
      } else {
        child_process.exec("rm ~/.config/autostart/e-search.desktop");
      }
    } else {
      electron.app.setLoginItemSettings({ openAtLogin: v });
    }
  } else {
    if (process.platform == "linux") {
      child_process.exec("test -e ~/.config/autostart/e-search.desktop", (error, _stdout, _stderr) => {
        error ? event.sender.send("开机启动状态", false) : event.sender.send("开机启动状态", true);
      });
    } else {
      event.sender.send("开机启动状态", electron.app.getLoginItemSettings().openAtLogin);
    }
  }
});
async function copyText(callback) {
  var oClipboard = electron.clipboard.readText();
  if (process.platform == "darwin") {
    child_process.exec(
      `osascript -e 'tell application "System Events"' -e 'delay 0.1' -e 'key code 8 using command down' -e 'end tell'`
    );
  } else if (process.platform == "win32") {
    child_process.exec(`"${path__namespace.join(runPath, "lib/copy.exe")}"`);
  } else if (process.platform == "linux") {
    child_process.exec(store.get("主搜索功能.linux_copy") || "xdotool key ctrl+c");
  }
  setTimeout(() => {
    let t2 = electron.clipboard.readText();
    let v = "";
    if (oClipboard != t2)
      v = t2;
    for (let i of store.get("主搜索功能.自动搜索排除")) {
      if (t2.match(i)) {
        v = "";
        break;
      }
    }
    callback(v);
    electron.clipboard.writeText(oClipboard);
  }, 300);
}
function autoOpen() {
  copyText((t2) => {
    if (t2) {
      createMainWindow("editor.html", [t2]);
    } else {
      fullScreen();
    }
  });
}
function openSelection() {
  copyText((t2) => {
    if (t2)
      createMainWindow("editor.html", [t2]);
  });
}
function openClipBoard() {
  var t2 = electron.clipboard.readText(
    process.platform == "linux" && store.get("主搜索功能.剪贴板选区搜索") ? "selection" : "clipboard"
  );
  createMainWindow("editor.html", [t2]);
}
var firstOpen = true;
const isFirstInstance = electron.app.requestSingleInstanceLock();
if (!isFirstInstance) {
  firstOpen = false;
  electron.app.quit();
} else {
  electron.app.on("second-instance", (_event, commanLine, _workingDirectory) => {
    argRun(commanLine);
  });
}
function argRun(c) {
  if (c.includes("-d"))
    dev = true;
  switch (true) {
    case c.includes("-a"):
      autoOpen();
      break;
    case c.includes("-c"):
      fullScreen();
      break;
    case c.includes("-s"):
      openSelection();
      break;
    case c.includes("-b"):
      openClipBoard();
      break;
    case c.includes("-g"):
      createMainWindow("editor.html", [""]);
      break;
    case c.includes("-q"):
      quickClip();
      break;
    case c.includes("-t"):
      createMainWindow("editor.html", [c[c.findIndex((t2) => t2 === "-t") + 1]]);
      break;
    default:
      for (let i of c) {
        if (i.match(/(\.png)|(\.jpg)|(\.svg)$/i)) {
          fullScreen(i);
          break;
        }
      }
      break;
  }
}
async function rmR(dir_path) {
  fs__namespace.rm(dir_path, { recursive: true }, (err) => {
    if (err)
      console.error(err);
  });
}
var contextMenu, tray;
electron.app.commandLine.appendSwitch("enable-experimental-web-platform-features", "enable");
electron.app.whenReady().then(() => {
  electron.crashReporter.start({ uploadToServer: false });
  if (store.get("首次运行") === void 0)
    setDefaultSetting();
  fix_setting_tree();
  lan(store.get("语言.语言"));
  Store.initRenderer();
  tray = process.platform == "linux" ? new electron.Tray(`${runPath}/assets/logo/32x32.png`) : new electron.Tray(`${runPath}/assets/logo/16x16.png`);
  contextMenu = electron.Menu.buildFromTemplate([
    {
      label: `${t("自动识别")}`,
      click: () => {
        autoOpen();
      }
    },
    {
      label: t("截屏搜索"),
      click: () => {
        setTimeout(() => {
          fullScreen();
        }, store.get("主搜索功能.截屏搜索延迟"));
      }
    },
    {
      label: t("选中搜索"),
      click: () => {
        openSelection();
      }
    },
    {
      label: t("剪贴板搜索"),
      click: () => {
        openClipBoard();
      }
    },
    {
      type: "separator"
    },
    {
      label: t("OCR(文字识别)"),
      click: () => {
        sendCaptureEvent(null, "ocr");
      }
    },
    {
      label: t("以图搜图"),
      click: () => {
        sendCaptureEvent(null, "image_search");
      }
    },
    {
      type: "separator"
    },
    {
      label: t("浏览器打开"),
      type: "checkbox",
      checked: store.get("浏览器中打开"),
      click: (i) => {
        store.set("浏览器中打开", i.checked);
      }
    },
    {
      type: "separator"
    },
    {
      label: t("主页面"),
      click: () => {
        createMainWindow("editor.html", [""]);
      }
    },
    {
      label: t("设置"),
      click: () => {
        Store.initRenderer();
        createMainWindow("setting.html");
      }
    },
    {
      label: t("教程帮助"),
      click: () => {
        createMainWindow("help.html");
      }
    },
    {
      type: "separator"
    },
    {
      label: t("重启"),
      click: () => {
        electron.app.relaunch();
        electron.app.exit(0);
      }
    },
    {
      label: t("退出"),
      click: () => {
        electron.app.quit();
      }
    }
  ]);
  if (store.get("点击托盘自动截图")) {
    tray.on("click", () => {
      fullScreen();
    });
    tray.on("right-click", () => {
      tray.popUpContextMenu(contextMenu);
    });
  } else {
    tray.setContextMenu(contextMenu);
  }
  if (firstOpen && store.get("启动提示"))
    new electron.Notification({
      title: electron.app.name,
      body: `${electron.app.name} ${t("已经在后台启动")}`,
      icon: `${runPath}/assets/logo/64x64.png`
    }).show();
  const 快捷键函数 = {
    自动识别: autoOpen,
    截屏搜索: fullScreen,
    选中搜索: openSelection,
    剪贴板搜索: openClipBoard,
    快速截屏: quickClip,
    主页面: createMainWindow.bind(void 0, "editor.html", [""])
  };
  electron.ipcMain.on("快捷键", (event, arg) => {
    var [name, key] = arg;
    try {
      try {
        electron.globalShortcut.unregister(store.get(`快捷键.${name}.key`));
      } catch {
      }
      let ok = false;
      if (key) {
        ok = electron.globalShortcut.register(key, () => {
          快捷键函数[arg[0]]();
        });
      }
      store.set(`快捷键.${name}.key`, key === "" || ok ? key : "");
      event.sender.send("状态", name, key ? ok : true);
    } catch (error) {
      event.sender.send("状态", name, false);
      store.set(`快捷键.${name}.key`, "");
    }
  });
  var 快捷键 = store.get("快捷键");
  for (let k in 快捷键) {
    var m = 快捷键[k];
    try {
      if (m.key)
        electron.globalShortcut.register(m.key, () => {
          快捷键函数[k]();
        });
    } catch (error) {
      delete 快捷键[k].key;
      store.set(`快捷键`, 快捷键);
    }
  }
  if (!fs__namespace.existsSync(os__namespace.tmpdir() + "/eSearch"))
    fs__namespace.mkdir(os__namespace.tmpdir() + "/eSearch", () => {
    });
  createClipWindow();
  electron.nativeTheme.themeSource = store.get("全局.深色模式");
  const template = [
    // { role: 'appMenu' }
    ...isMac ? [
      {
        label: electron.app.name,
        submenu: [
          { label: `${t("关于")} ${electron.app.name}`, role: "about" },
          { type: "separator" },
          {
            label: t("设置"),
            click: () => {
              createMainWindow("setting.html");
            },
            accelerator: "CmdOrCtrl+,"
          },
          { type: "separator" },
          { label: t("服务"), role: "services" },
          { type: "separator" },
          { label: `${t("隐藏")} ${electron.app.name}`, role: "hide" },
          { label: t("隐藏其他"), role: "hideOthers" },
          { label: t("全部显示"), role: "unhide" },
          { type: "separator" },
          { label: `退出 ${electron.app.name}`, role: "quit" }
        ]
      }
    ] : [],
    // { role: 'fileMenu' }
    {
      label: t("文件"),
      submenu: [
        {
          label: t("保存到历史记录"),
          click: (_i, w) => {
            mainEdit(w, "save");
          },
          accelerator: "CmdOrCtrl+S"
        },
        { type: "separator" },
        ...isMac ? [] : [
          {
            label: t("设置"),
            click: () => {
              createMainWindow("setting.html");
            },
            accelerator: "CmdOrCtrl+,"
          },
          { type: "separator" }
        ],
        {
          label: t("其他编辑器打开"),
          click: (_i, w) => {
            mainEdit(w, "edit_on_other");
          }
        },
        {
          label: t("打开方式..."),
          click: (_i, w) => {
            mainEdit(w, "choose_editer");
          }
        },
        { type: "separator" },
        { label: t("关闭"), role: "close" }
      ]
    },
    // { role: 'editMenu' }
    {
      label: t("编辑"),
      submenu: [
        {
          label: t("打开链接"),
          click: (_i, w) => {
            mainEdit(w, "link");
          },
          accelerator: "CmdOrCtrl+Shift+L"
        },
        {
          label: t("搜索"),
          click: (_i, w) => {
            mainEdit(w, "search");
          },
          accelerator: "CmdOrCtrl+Shift+S"
        },
        {
          label: t("翻译"),
          click: (_i, w) => {
            mainEdit(w, "translate");
          },
          accelerator: "CmdOrCtrl+Shift+T"
        },
        { type: "separator" },
        {
          label: t("撤销"),
          click: (_i, w) => {
            mainEdit(w, "undo");
            w.webContents.undo();
          },
          accelerator: "CmdOrCtrl+Z"
        },
        {
          label: t("重做"),
          click: (_i, w) => {
            mainEdit(w, "redo");
            w.webContents.redo();
          },
          accelerator: isMac ? "Cmd+Shift+Z" : "Ctrl+Y"
        },
        { type: "separator" },
        {
          label: t("剪切"),
          click: (_i, w) => {
            mainEdit(w, "cut");
            w.webContents.cut();
          },
          accelerator: "CmdOrCtrl+X"
        },
        {
          label: t("复制"),
          click: (_i, w) => {
            mainEdit(w, "copy");
            w.webContents.copy();
          },
          accelerator: "CmdOrCtrl+C"
        },
        {
          label: t("粘贴"),
          click: (_i, w) => {
            mainEdit(w, "paste");
            w.webContents.paste();
          },
          accelerator: "CmdOrCtrl+V"
        },
        {
          label: t("删除"),
          click: (_i, w) => {
            mainEdit(w, "delete");
            w.webContents.delete();
          }
        },
        {
          label: t("全选"),
          click: (_i, w) => {
            mainEdit(w, "select_all");
            w.webContents.selectAll();
          },
          accelerator: "CmdOrCtrl+A"
        },
        {
          label: t("自动删除换行"),
          click: (_i, w) => {
            mainEdit(w, "delete_enter");
          }
        },
        { type: "separator" },
        {
          label: t("查找"),
          click: (_i, w) => {
            mainEdit(w, "show_find");
          },
          accelerator: "CmdOrCtrl+F"
        },
        {
          label: t("替换"),
          click: (_i, w) => {
            mainEdit(w, "show_find");
          },
          accelerator: isMac ? "CmdOrCtrl+Option+F" : "CmdOrCtrl+H"
        },
        { type: "separator" },
        {
          label: t("自动换行"),
          click: (_i, w) => {
            mainEdit(w, "wrap");
          }
        },
        {
          label: t("拼写检查"),
          click: (_i, w) => {
            mainEdit(w, "spellcheck");
          }
        },
        { type: "separator" },
        ...isMac ? [
          {
            label: t("朗读"),
            submenu: [
              { label: t("开始朗读"), role: "startSpeaking" },
              { label: t("停止朗读"), role: "stopSpeaking" }
            ]
          }
        ] : []
      ]
    },
    {
      label: t("浏览器"),
      submenu: [
        {
          label: t("后退"),
          click: (_i, w) => {
            viewEvents(w, "back");
          },
          accelerator: isMac ? "Command+[" : "Alt+Left"
        },
        {
          label: t("前进"),
          click: (_i, w) => {
            viewEvents(w, "forward");
          },
          accelerator: isMac ? "Command+]" : "Alt+Right"
        },
        {
          label: t("刷新"),
          click: (_i, w) => {
            viewEvents(w, "reload");
          },
          accelerator: "F5"
        },
        {
          label: t("停止加载"),
          click: (_i, w) => {
            viewEvents(w, "stop");
          },
          accelerator: "Esc"
        },
        {
          label: t("浏览器打开"),
          click: (_i, w) => {
            viewEvents(w, "browser");
          }
        },
        {
          label: t("保存到历史记录"),
          click: (_i, w) => {
            viewEvents(w, "add_history");
          },
          accelerator: "CmdOrCtrl+D"
        },
        {
          label: t("开发者工具"),
          click: (_i, w) => {
            viewEvents(w, "dev");
          }
        }
      ]
    },
    // { role: 'viewMenu' }
    {
      label: t("视图"),
      submenu: [
        { label: t("重新加载"), role: "reload" },
        { label: t("强制重载"), role: "forceReload" },
        { label: t("开发者工具"), role: "toggleDevTools" },
        { type: "separator" },
        {
          label: t("历史记录"),
          click: (_i, w) => {
            mainEdit(w, "show_history");
          },
          accelerator: "CmdOrCtrl+Shift+H"
        },
        { type: "separator" },
        { label: t("实际大小"), role: "resetZoom", accelerator: "" },
        { label: t("放大"), role: "zoomIn" },
        { label: t("缩小"), role: "zoomOut" },
        { type: "separator" },
        { label: t("全屏"), role: "togglefullscreen" }
      ]
    },
    // { role: 'windowMenu' }
    {
      label: t("窗口"),
      submenu: [
        { label: t("最小化"), role: "minimize" },
        { label: t("关闭"), role: "close" },
        ...isMac ? [
          { type: "separator" },
          { label: t("置于最前面"), role: "front" },
          { type: "separator" },
          { label: t("窗口"), role: "window" }
        ] : []
      ]
    },
    {
      label: t("帮助"),
      role: "help",
      submenu: [
        {
          label: t("教程帮助"),
          click: () => {
            createMainWindow("help.html");
          }
        },
        { type: "separator" },
        {
          label: t("关于"),
          click: () => {
            createMainWindow("setting.html", null, true);
          }
        }
      ]
    }
  ];
  const menu = electron.Menu.buildFromTemplate(template);
  electron.Menu.setApplicationMenu(menu);
});
electron.app.on("will-quit", () => {
  electron.globalShortcut.unregisterAll();
  rmR(path__namespace.join(os__namespace.tmpdir(), "eSearch"));
});
var theIcon = null;
if (process.platform == "win32") {
  theIcon = path__namespace.join(runPath, "assets/logo/icon.ico");
} else {
  theIcon = path__namespace.join(runPath, "assets/logo/1024x1024.png");
}
var clipWindow = null;
var clipWindowLoaded = false;
function createClipWindow() {
  clipWindow = new electron.BrowserWindow({
    icon: theIcon,
    width: electron.screen.getPrimaryDisplay().workAreaSize.width,
    height: electron.screen.getPrimaryDisplay().workAreaSize.height,
    show: false,
    alwaysOnTop: !dev,
    // 为了方便调试，调试模式就不居上了
    fullscreenable: true,
    transparent: true,
    frame: false,
    resizable: process.platform == "linux",
    // gnome下为false时无法全屏
    skipTaskbar: true,
    autoHideMenuBar: true,
    movable: false,
    enableLargerThanScreen: true,
    // mac
    hasShadow: false,
    webPreferences: {
      nodeIntegration: true,
      contextIsolation: false
    }
  });
  if (!dev)
    clipWindow.setAlwaysOnTop(true, "screen-saver");
  rendererPath(clipWindow, "capture.html");
  clipWindow.webContents.on("did-finish-load", () => {
    clipWindow.webContents.setZoomFactor(store.get("全局.缩放") || 1);
    if (clipWindowLoaded)
      return;
    clipWindowLoaded = true;
    if (firstOpen)
      argRun(process.argv);
  });
  if (dev)
    clipWindow.webContents.openDevTools();
  clipWindow.webContents.on("render-process-gone", (_e, d) => {
    console.log(d);
  });
  electron.ipcMain.on("clip_main_b", (event, type, arg) => {
    switch (type) {
      case "window-close":
        exitFullScreen();
        isLongStart = false;
        break;
      case "ocr":
        ocr(event, arg);
        break;
      case "search":
        imageSearch(event, arg);
        break;
      case "QR":
        if (arg != "nothing") {
          createMainWindow("editor.html", [arg]);
        } else {
          electron.dialog.showMessageBox({
            title: t("警告"),
            message: `${t("无法识别二维码")}
${t("请尝试重新识别")}`,
            icon: `${runPath}/assets/logo/warning.png`
          });
        }
        break;
      case "open":
        electron.dialog.showOpenDialog({
          title: t("选择要打开应用的位置")
        }).then((x2) => {
          console.log(x2);
          event.sender.send("open_path", x2.filePaths[0]);
        });
        break;
      case "save":
        var savedPath = store.get("保存.保存路径.图片") || "";
        exitFullScreen();
        electron.dialog.showSaveDialog({
          title: t("选择要保存的位置"),
          defaultPath: path__namespace.join(savedPath, `${getFileName()}.${arg}`),
          filters: [{ name: t("图像"), extensions: [arg] }]
        }).then((x2) => {
          event.sender.send("save_path", x2.filePath);
          if (x2.filePath)
            ;
          else {
            new electron.Notification({
              title: `${electron.app.name} ${t("保存图像失败")}`,
              body: t("用户已取消保存"),
              icon: `${runPath}/assets/logo/64x64.png`
            }).show();
            clipWindow.show();
            clipWindow.setSimpleFullScreen(true);
          }
        });
        break;
      case "ding":
        createDingWindow(arg[0], arg[1], arg[2], arg[3], arg[4], arg[5], arg[6]);
        break;
      case "mac_app":
        exitFullScreen();
        electron.dialog.showOpenDialog({
          defaultPath: "/Applications"
        }).then((x2) => {
          if (x2.canceled) {
            clipWindow.show();
            clipWindow.setSimpleFullScreen(true);
          }
          event.sender.send("mac_app_path", x2.canceled, x2.filePaths);
        });
        break;
      case "ok_save":
        noti(arg);
        store.set("保存.保存路径.图片", path__namespace.dirname(arg));
        break;
      case "record":
        createRecorderWindow(arg.rect, { id: arg.id, w: arg.w, h: arg.h, r: arg.ratio });
        break;
      case "long_s":
        isLongStart = true;
        longWin(arg);
        break;
      case "long_e":
        isLongStart = false;
        break;
      case "new_version":
        var notification = new electron.Notification({
          title: `${electron.app.name} ${t("有新版本：")}${arg.v}`,
          body: `${t("点击下载")}`,
          icon: `${runPath}/assets/logo/64x64.png`
        });
        notification.on("click", () => {
          electron.shell.openExternal(arg.url);
        });
        notification.show();
        break;
      case "get_mouse":
        event.returnValue = electron.screen.getCursorScreenPoint();
        break;
    }
  });
}
function fullScreen(imgPath) {
  let nearestScreen = electron.screen.getDisplayNearestPoint(electron.screen.getCursorScreenPoint());
  if (imgPath) {
    console.log(imgPath);
    fs__namespace.readFile(imgPath, (err, data) => {
      if (err)
        console.error(err);
      let p = electron.nativeImage.createFromBuffer(data);
      let s = p.getSize();
      sendCaptureEvent([
        {
          image: data,
          width: s.width,
          height: s.height,
          scaleFactor: 1,
          isPrimary: true,
          main: true,
          id: null
        }
      ]);
    });
  } else {
    sendCaptureEvent();
  }
  clipWindow.setBounds({ x: nearestScreen.bounds.x, y: nearestScreen.bounds.y });
  clipWindow.show();
  clipWindow.setSimpleFullScreen(true);
}
function sendCaptureEvent(data, type) {
  clipWindow.webContents.send("reflash", data, electron.screen.getAllDisplays(), electron.screen.getCursorScreenPoint(), type);
}
function exitFullScreen() {
  clipWindow.setSimpleFullScreen(false);
  clipWindow.hide();
}
function reload_clip() {
  exitFullScreen();
  if (clipWindow && !clipWindow.isDestroyed() && !clipWindow.isVisible())
    clipWindow.reload();
}
var ocrEvent;
function ocr(event, arg) {
  createMainWindow("editor.html", ["ocr", ...arg]);
  ocrEvent = event;
}
var imageSearchEvent;
function imageSearch(event, arg) {
  createMainWindow("editor.html", ["image", arg[0], arg[1]]);
  imageSearchEvent = event;
}
var recording = false;
const recorderWinW = 240;
const recorderWinH = 24;
var recorder;
function createRecorderWindow(rect, screenx) {
  let s = electron.screen.getDisplayNearestPoint(electron.screen.getCursorScreenPoint());
  let ratio = s.scaleFactor;
  let p = { x: electron.screen.getCursorScreenPoint().x * ratio, y: electron.screen.getCursorScreenPoint().y * ratio };
  rect = rect.map((v) => v / ratio);
  let hx = s.bounds.x + rect[0] + rect[2] / 2, hy = s.bounds.y + rect[1] + rect[3] / 2, w = recorderWinW, h = recorderWinH, sw = s.bounds.x + s.bounds.width * ratio, sh = s.bounds.y + s.bounds.height * ratio;
  let x2 = p.x <= hx ? s.bounds.x + rect[0] : s.bounds.x + rect[0] + rect[2] - w, y = p.y <= hy ? s.bounds.y + rect[1] - h - 8 : s.bounds.y + rect[1] + rect[3] + 8;
  x2 = x2 < s.bounds.x ? s.bounds.x : x2;
  x2 = x2 + w > sw ? sw - w : x2;
  y = y < s.bounds.y ? s.bounds.y : y;
  y = y + h > sh ? sh - h : y;
  x2 = Math.round(x2);
  y = Math.round(y);
  recorder = new electron.BrowserWindow({
    icon: theIcon,
    x: x2,
    y,
    width: w,
    height: h,
    transparent: true,
    frame: false,
    autoHideMenuBar: true,
    resizable: process.platform == "linux",
    titleBarStyle: "hiddenInset",
    webPreferences: {
      nodeIntegration: true,
      contextIsolation: false,
      sandbox: false
    }
  });
  rendererPath(recorder, "recorder.html");
  if (dev)
    recorder.webContents.openDevTools();
  recorder.setAlwaysOnTop(true, "screen-saver");
  recorder.on("close", () => {
    store.set("录屏.大小.x", recorder.getBounds().x);
    store.set("录屏.大小.y", recorder.getBounds().y);
    reload_clip();
    clipWindow.setIgnoreMouseEvents(false);
  });
  recorder.on("resize", () => {
    if (recorder.isResizable()) {
      store.set("录屏.大小.width", recorder.getBounds().width);
      store.set("录屏.大小.height", recorder.getBounds().height);
    }
  });
  recorder.webContents.on("did-finish-load", () => {
    electron.desktopCapturer.getSources({ types: ["screen"] }).then((sources) => {
      let dId = "";
      sources.forEach((s2) => {
        if (s2.display_id == screenx.id)
          dId = s2.id;
      });
      if (!dId)
        dId = sources[0].id;
      recorder.webContents.send("record", "init", dId, rect, screenx.w, screenx.h, screenx.r);
    });
  });
  electron.globalShortcut.register("Super+R", () => {
    if (!recorder.isDestroyed()) {
      recorder.webContents.send("record", "start_stop");
    }
  });
  clipWindow.setIgnoreMouseEvents(true);
  function mouse() {
    if (clipWindow.isDestroyed())
      return;
    if (!recording || recorder.isDestroyed()) {
      clipWindow.setIgnoreMouseEvents(false);
      return;
    }
    let nowXY = electron.screen.getCursorScreenPoint();
    clipWindow.webContents.send("record", "mouse", { x: nowXY.x - s.bounds.x, y: nowXY.y - s.bounds.y });
    setTimeout(mouse, 10);
  }
  recording = true;
  if (store.get("录屏.提示.光标.开启"))
    mouse();
}
electron.ipcMain.on("record", (_event, type, arg) => {
  switch (type) {
    case "stop":
      reload_clip();
      recording = false;
      break;
    case "start":
      break;
    case "ff":
      var savedPath = store.get("保存.保存路径.视频") || "";
      electron.dialog.showSaveDialog({
        title: t("选择要保存的位置"),
        defaultPath: path__namespace.join(savedPath, `${getFileName()}.${arg.格式}`),
        filters: [{ name: t("视频"), extensions: null }]
      }).then(async (x2) => {
        if (x2.filePath) {
          let fpath = x2.filePath;
          if (!fpath.includes(".")) {
            fpath += `.${arg.格式}`;
          }
          recorder.webContents.send("ff", "save_path", fpath);
        } else {
          new electron.Notification({
            title: `${electron.app.name} ${t("保存视频失败")}`,
            body: t("用户已取消保存"),
            icon: `${runPath}/assets/logo/64x64.png`
          }).show();
        }
      });
      break;
    case "close":
      recorder.close();
      reload_clip();
      break;
    case "min":
      recorder.minimize();
      break;
    case "camera":
      switch (arg) {
        case 0:
          recorder.setBounds({
            width: store.get("录屏.大小.width") || 800,
            height: store.get("录屏.大小.height") || 600,
            x: recorder.getBounds().x,
            y: recorder.getBounds().y
          });
          recorder.setResizable(true);
          break;
        case 1:
          recorder.setResizable(false);
          recorder.setBounds({
            width: recorderWinW,
            height: recorderWinH,
            x: recorder.getBounds().x,
            y: recorder.getBounds().y
          });
          break;
        case 2:
          recorder.setBounds({
            width: Math.max(store.get("录屏.大小.width"), 300) || 800,
            height: Math.max(store.get("录屏.大小.height"), 500) || 600
          });
          recorder.setAlwaysOnTop(false);
          recorder.setResizable(true);
          recorder.center();
          break;
      }
      break;
  }
});
electron.ipcMain.on("setting", async (event, arg, arg1, arg2) => {
  switch (arg) {
    case "save_err":
      console.log("保存设置失败");
      break;
    case "reload_main":
      if (clipWindow && !clipWindow.isDestroyed() && !clipWindow.isVisible())
        clipWindow.reload();
      contextMenu.items[8].checked = store.get("浏览器中打开");
      tray.popUpContextMenu(contextMenu);
      tray.closeContextMenu();
      break;
    case "set_default_setting":
      store.clear();
      setDefaultSetting();
      var resolve = await electron.dialog.showMessageBox({
        title: t("重启"),
        message: `${t("已恢复默认设置，部分设置需要重启")} ${electron.app.name} ${t("生效")}`,
        buttons: [t("重启"), t("稍后")],
        defaultId: 0,
        cancelId: 1
      });
      if (resolve.response == 0) {
        electron.app.relaunch();
        electron.app.exit(0);
      }
      break;
    case "reload":
      electron.app.relaunch();
      electron.app.exit(0);
      break;
    case "clear":
      let ses = electron.session.defaultSession;
      if (arg1 == "storage") {
        ses.clearStorageData().then(() => {
          event.sender.send("setting", "storage", true);
        }).catch(() => {
          event.sender.send("setting", "storage", false);
        });
      } else {
        Promise.all([
          ses.clearAuthCache(),
          ses.clearCache(),
          ses.clearCodeCaches({}),
          ses.clearHostResolverCache()
        ]).then(() => {
          event.sender.send("setting", "cache", true);
        }).catch(() => {
          event.sender.send("setting", "cache", false);
        });
      }
      break;
    case "open_dialog":
      electron.dialog.showOpenDialog(arg1).then((x2) => {
        event.sender.send("setting", arg, arg2, x2);
      });
      break;
    case "move_user_data":
      if (!arg1)
        return;
      const toPath = path__namespace.resolve(arg1);
      const prePath = electron.app.getPath("userData");
      fs__namespace.mkdirSync(toPath, { recursive: true });
      if (process.platform == "win32") {
        child_process.exec(`xcopy ${prePath}\\** ${toPath} /Y /s`);
      } else {
        child_process.exec(`cp -r ${prePath}/** ${toPath}`);
      }
  }
});
var isLongStart = false;
function longWin(rect) {
  clipWindow.setIgnoreMouseEvents(true);
  function mouse() {
    if (!isLongStart) {
      clipWindow.setIgnoreMouseEvents(false);
      return;
    }
    if (clipWindow.isDestroyed())
      return;
    let nowXY = electron.screen.getCursorScreenPoint();
    let ratio = electron.screen.getPrimaryDisplay().scaleFactor;
    if (rect[0] + rect[2] - 16 <= nowXY.x * ratio && nowXY.x * ratio <= rect[0] + rect[2] && rect[1] + rect[3] - 16 <= nowXY.y * ratio && nowXY.y * ratio <= rect[1] + rect[3]) {
      clipWindow.setIgnoreMouseEvents(false);
    } else {
      clipWindow.setIgnoreMouseEvents(true);
    }
    setTimeout(mouse, 10);
  }
  mouse();
}
const isMac = process.platform === "darwin";
var dingwindowList = {};
function createDingWindow(x2, y, w, h, img, screenId, screens) {
  if (Object.keys(dingwindowList).length == 0) {
    let screenL = screens;
    const id = (/* @__PURE__ */ new Date()).getTime();
    for (let i of screenL) {
      let dingWindow = dingwindowList[i.id] = new electron.BrowserWindow({
        icon: theIcon,
        transparent: true,
        frame: false,
        alwaysOnTop: true,
        skipTaskbar: true,
        autoHideMenuBar: true,
        enableLargerThanScreen: true,
        // mac
        hasShadow: false,
        webPreferences: {
          nodeIntegration: true,
          contextIsolation: false
        },
        x: i.x,
        y: i.y,
        width: i.width,
        height: i.height
      });
      rendererPath(dingWindow, "ding.html");
      if (dev)
        dingWindow.webContents.openDevTools();
      dingWindow.webContents.on("did-finish-load", () => {
        dingWindow.webContents.setZoomFactor(store.get("全局.缩放") || 1);
        dingWindow.webContents.send("screen_id", i.id);
        dingWindow.webContents.send("img", screenId, id, x2, y, w, h, img);
      });
      dingwindowList[i.id].setIgnoreMouseEvents(true);
      dingWindow.setAlwaysOnTop(true, "screen-saver");
    }
  } else {
    const id = (/* @__PURE__ */ new Date()).getTime();
    for (let i in dingwindowList) {
      dingwindowList[i].webContents.send("img", screenId, id, x2, y, w, h, img);
    }
  }
  function dingClickThrough() {
    let nowXY = electron.screen.getCursorScreenPoint();
    for (let i in dingwindowList) {
      try {
        let b = dingwindowList[i].getBounds();
        dingwindowList[i].webContents.send("mouse", nowXY.x - b.x, nowXY.y - b.y);
      } catch (error) {
      }
    }
    setTimeout(dingClickThrough, 10);
  }
  dingClickThrough();
}
electron.ipcMain.on("ding_ignore", (_event, id, v) => {
  if (dingwindowList[id])
    dingwindowList[id].setIgnoreMouseEvents(v);
});
electron.ipcMain.on("ding_event", (_event, type, id, screen_id, more) => {
  if (type == "close" && more) {
    for (let i in dingwindowList) {
      dingwindowList[i].close();
      delete dingwindowList[i];
    }
    return;
  }
  for (let i in dingwindowList) {
    dingwindowList[i].webContents.send("ding", type, id, screen_id, more);
  }
});
electron.ipcMain.on("ding_edit", (_event, img_path) => {
  fullScreen(img_path);
});
var mainWindowL = {};
var ocrRunWindow;
var imageSearchWindow;
async function createMainWindow(webPage, t2, about) {
  var windowName = (/* @__PURE__ */ new Date()).getTime();
  var [w, h, m] = store.get("主页面大小");
  let vr = electron.screen.getDisplayNearestPoint(electron.screen.getCursorScreenPoint()).bounds, px = electron.screen.getCursorScreenPoint().x, py = electron.screen.getCursorScreenPoint().y;
  let x2 = px > vr.x + vr.width / 2 ? px - w : px, y = py > vr.y + vr.height / 2 ? py - h : py;
  var mainWindow = mainWindowL[windowName] = new electron.BrowserWindow({
    x: Math.max(vr.x, x2),
    y: Math.max(vr.y, y),
    width: w,
    height: h,
    minWidth: 800,
    backgroundColor: electron.nativeTheme.shouldUseDarkColors ? "#0f0f0f" : "#ffffff",
    icon: theIcon,
    webPreferences: {
      nodeIntegration: true,
      contextIsolation: false,
      webSecurity: false
    },
    show: t2?.[0] != "image" && t2?.[0] != "ocr"
    // 一般情况下true，识图和ocr为false
  });
  if (m)
    mainWindow.maximize();
  rendererPath(mainWindow, webPage || "editor.html");
  await mainWindow.webContents.session.setProxy(store.get("代理"));
  if (dev)
    mainWindow.webContents.openDevTools();
  if (t2?.[0] == "image") {
    imageSearchWindow = mainWindow;
  } else if (t2?.[0] == "ocr") {
    ocrRunWindow = mainWindow;
    ocrRunWindow.webContents.once("render-process-gone", (_e, d) => {
      ocrEvent.sender.send("ocr_back", d.reason);
    });
  }
  mainWindow.webContents.on("did-finish-load", () => {
    if (t2?.[0] != "image" && t2?.[0] != "ocr")
      mainWindow.show();
    mainWindow.webContents.setZoomFactor(store.get("全局.缩放") || 1);
    t2 = t2 || [""];
    mainWindow.webContents.send("text", windowName, t2);
    if (webPage == "setting.html") {
      mainWindow.webContents.send("about", about);
      mainWindow.webContents.send("setting", mainWindow.id);
    }
    if (mainWindow.html) {
      mainWindow.webContents.send("html", mainWindow.html);
    }
  });
  mainWindow.on("close", () => {
    store.set("主页面大小", [
      mainWindow.getNormalBounds().width,
      mainWindow.getNormalBounds().height,
      mainWindow.isMaximized()
    ]);
    for (let i of mainWindow.getBrowserViews()) {
      i?.webContents?.destroy();
    }
  });
  mainWindow.on("closed", () => {
    delete mainWindowL[windowName];
  });
  mainWindow.on("resize", () => {
    setTimeout(() => {
      var [w2, h2] = mainWindow.getContentSize();
      for (let i of mainWindow.getBrowserViews()) {
        if (i.getBounds().width != 0)
          i.setBounds({ x: 0, y: 0, width: w2, height: h2 - 48 });
      }
    }, 0);
  });
  return windowName;
}
electron.ipcMain.on("main_win", (e, arg, arg1) => {
  switch (arg) {
    case "close":
      electron.BrowserWindow.fromWebContents(e.sender).close();
      break;
    case "ocr":
      ocrEvent.sender.send("ocr_back", arg1);
      ocrRunWindow.show();
      ocrRunWindow = null;
      break;
    case "image_search":
      imageSearchEvent.sender.send("search_back", "ok");
      imageSearchWindow.show();
      imageSearchWindow = null;
      break;
  }
});
function mainEdit(window, m) {
  window.webContents.send("edit", m);
}
var searchWindowL = {};
electron.ipcMain.on("open_url", (_event, window_name, url2) => {
  createBrowser(window_name, url2);
});
async function createBrowser(windowName, url2) {
  if (!windowName)
    windowName = await createMainWindow("editor.html");
  let mainWindow = mainWindowL[windowName];
  if (mainWindow.isDestroyed())
    return;
  minViews(mainWindow);
  var view = (/* @__PURE__ */ new Date()).getTime();
  let security = true;
  for (let i of store.get("nocors")) {
    if (url2.includes(i)) {
      security = false;
      break;
    }
  }
  var searchView = searchWindowL[view] = new electron.BrowserView({ webPreferences: { webSecurity: security } });
  await searchView.webContents.session.setProxy(store.get("代理"));
  mainWindowL[windowName].addBrowserView(searchView);
  searchView.webContents.loadURL(url2);
  var [w, h] = mainWindow.getContentSize();
  searchView.setBounds({ x: 0, y: 0, width: w, height: h - 48 });
  mainWindow.setContentSize(w, h + 1);
  mainWindow.setContentSize(w, h);
  searchView.webContents.setWindowOpenHandler(({ url: url3 }) => {
    createBrowser(windowName, url3);
    return { action: "deny" };
  });
  if (dev)
    searchView.webContents.openDevTools();
  if (!mainWindow.isDestroyed())
    mainWindow.webContents.send("url", view, "new", url2);
  searchView.webContents.on("page-title-updated", (_event, title) => {
    if (!mainWindow.isDestroyed())
      mainWindow.webContents.send("url", view, "title", title);
  });
  searchView.webContents.on("page-favicon-updated", (_event, favlogo) => {
    if (!mainWindow.isDestroyed())
      mainWindow.webContents.send("url", view, "icon", favlogo);
  });
  searchView.webContents.on("did-navigate", (_event, url3) => {
    if (!mainWindow.isDestroyed())
      mainWindow.webContents.send("url", view, "url", url3);
  });
  searchView.webContents.on("did-start-loading", () => {
    if (!mainWindow.isDestroyed())
      mainWindow.webContents.send("url", view, "load", true);
  });
  searchView.webContents.on("did-stop-loading", () => {
    if (!mainWindow.isDestroyed())
      mainWindow.webContents.send("url", view, "load", false);
  });
  searchView.webContents.on("did-fail-load", (_event, err_code, err_des) => {
    rendererPath(searchView.webContents, "browser_bg.html", {
      query: { type: "did-fail-load", err_code: String(err_code), err_des }
    });
    if (dev)
      searchView.webContents.openDevTools();
  });
  searchView.webContents.on("render-process-gone", () => {
    rendererPath(searchView.webContents, "browser_bg.html", { query: { type: "render-process-gone" } });
    if (dev)
      searchView.webContents.openDevTools();
  });
  searchView.webContents.on("unresponsive", () => {
    rendererPath(searchView.webContents, "browser_bg.html", { query: { type: "unresponsive" } });
    if (dev)
      searchView.webContents.openDevTools();
  });
  searchView.webContents.on("responsive", () => {
    searchView.webContents.loadURL(url2);
  });
  searchView.webContents.on("certificate-error", () => {
    rendererPath(searchView.webContents, "browser_bg.html", { query: { type: "certificate-error" } });
    if (dev)
      searchView.webContents.openDevTools();
  });
}
function viewEvents(w, arg) {
  w.webContents.send("view_events", arg);
}
electron.ipcMain.on("tab_view", (e, id, arg, arg2) => {
  let mainWindow = electron.BrowserWindow.fromWebContents(e.sender);
  let searchWindow = searchWindowL[id];
  switch (arg) {
    case "close":
      mainWindow.removeBrowserView(searchWindow);
      searchWindow.webContents.destroy();
      delete searchWindowL[id];
      break;
    case "top":
      if (!mainWindow)
        return;
      mainWindow.setTopBrowserView(searchWindow);
      minViews(mainWindow);
      searchWindow.setBounds({
        x: 0,
        y: 0,
        width: mainWindow.getContentBounds().width,
        height: mainWindow.getContentBounds().height - 48
      });
      break;
    case "back":
      searchWindow.webContents.goBack();
      break;
    case "forward":
      searchWindow.webContents.goForward();
      break;
    case "stop":
      searchWindow.webContents.stop();
      break;
    case "reload":
      searchWindow.webContents.reload();
      break;
    case "home":
      minViews(mainWindow);
      break;
    case "save_html":
      mainWindow["html"] = arg2;
      minViews(mainWindow);
      break;
    case "dev":
      searchWindow.webContents.openDevTools();
      break;
  }
});
function minViews(mainWindow) {
  for (let v of mainWindow.getBrowserViews()) {
    v.setBounds({ x: 0, y: 0, width: 0, height: 0 });
  }
}
function getFileName() {
  var saveNameTime = format(store.get("保存名称.时间"), /* @__PURE__ */ new Date()).replace("\\", "");
  var fileName = store.get("保存名称.前缀") + saveNameTime + store.get("保存名称.后缀");
  return fileName;
}
function quickClip() {
  if (clipWindow.webContents)
    clipWindow.webContents.send("quick");
}
function noti(filePath) {
  var notification = new electron.Notification({
    title: `${electron.app.name} ${t("保存图像成功")}`,
    body: `${t("已保存图像到")} ${filePath}`,
    icon: `${runPath}/assets/logo/64x64.png`
  });
  notification.on("click", () => {
    electron.shell.showItemInFolder(filePath);
  });
  notification.show();
}
electron.ipcMain.on("get_save_path", (event, path2) => {
  if (!path2)
    path2 = electron.app.getPath("pictures");
  electron.dialog.showOpenDialog({
    title: t("选择要保存的位置"),
    defaultPath: path2,
    properties: ["openDirectory"]
  }).then((x2) => {
    if (x2.filePaths[0])
      event.sender.send("get_save_path", x2.filePaths[0] + "/");
  });
});
electron.ipcMain.on("theme", (_e, v) => {
  electron.nativeTheme.themeSource = v;
  store.set("全局.深色模式", v);
});
var defaultSetting = {
  首次运行: false,
  设置版本: electron.app.getVersion(),
  启动提示: true,
  语言: {},
  快捷键: {
    自动识别: {
      key: "Alt+C"
    },
    截屏搜索: {},
    选中搜索: {},
    剪贴板搜索: {},
    快速截屏: {},
    主页面: {}
  },
  点击托盘自动截图: process.platform != "linux",
  其他快捷键: {
    关闭: "Escape",
    OCR: "Enter",
    以图搜图: "",
    QR码: "",
    图像编辑: isMac ? "Command+D" : "Control+D",
    其他应用打开: "",
    放在屏幕上: "",
    录屏: "",
    长截屏: "",
    复制: isMac ? "Command+C" : "Control+C",
    保存: isMac ? "Command+S" : "Control+S",
    复制颜色: "K",
    line: "",
    circle: "",
    rect: "",
    polyline: "",
    polygon: "",
    text: "",
    number: "",
    arrow: ""
  },
  主搜索功能: {
    自动搜索排除: [],
    剪贴板选区搜索: true,
    截屏搜索延迟: 0
  },
  全局: {
    模糊: 25,
    缩放: 1,
    不透明度: 0.4,
    深色模式: "system",
    图标颜色: ["", "", "", ""]
  },
  工具栏: {
    按钮大小: 60,
    按钮图标比例: 0.7,
    初始位置: { left: "10px", top: "100px" },
    功能: ["close", "ocr", "search", "QR", "draw", "open", "ding", "record", "long", "copy", "save"]
  },
  字体: {
    主要字体: "",
    等宽字体: "",
    记住: false,
    大小: 16
  },
  编辑器: {
    自动换行: true,
    拼写检查: false,
    行号: true
  },
  工具栏跟随: "展示内容优先",
  自动搜索: true,
  遮罩颜色: "#0008",
  选区颜色: "#0000",
  鼠标跟随栏: {
    显示: true
  },
  取色器: { 像素大小: 10, 大小: 15, 显示: true, 默认格式: "HEX" },
  显示四角坐标: true,
  框选: {
    自动框选: {
      开启: false,
      图像识别: false,
      最小阈值: 50,
      最大阈值: 150
    },
    记忆: { 开启: false, rects: {} }
  },
  图像编辑: {
    默认属性: {
      填充颜色: "#fff",
      边框颜色: "#333",
      边框宽度: 1,
      画笔颜色: "#333",
      画笔粗细: 2
    },
    复制偏移: {
      x: 10,
      y: 10
    },
    形状属性: {},
    记忆: {
      画笔: "",
      形状: ""
    }
  },
  OCR: {
    类型: "默认",
    离线切换: true,
    记住: false
  },
  离线OCR: [["默认", "默认/ppocr_det.onnx", "默认/ppocr_rec.onnx", "默认/ppocr_keys_v1.txt"]],
  离线OCR配置: {
    node: false
  },
  在线OCR: {
    baidu: {
      url: "",
      id: "",
      secret: ""
    },
    youdao: {
      id: "",
      secret: ""
    }
  },
  以图搜图: {
    引擎: "baidu",
    记住: false
  },
  自动打开链接: false,
  自动搜索中文占比: 0.2,
  浏览器中打开: false,
  浏览器: {
    标签页: {
      自动关闭: true,
      小: false,
      灰度: false
    }
  },
  保存: {
    默认格式: "png",
    保存路径: { 图片: "", 视频: "" },
    快速保存: false
  },
  保存名称: { 前缀: "eSearch-", 时间: "YYYY-MM-DD-HH-mm-ss-S", 后缀: "" },
  jpg质量: 1,
  框选后默认操作: "no",
  快速截屏: { 模式: "clip", 路径: "" },
  搜索引擎: [
    ["Google", "https://www.google.com/search?q=%s"],
    ["百度", "https://www.baidu.com/s?wd=%s"],
    ["必应", "https://cn.bing.com/search?q=%s"],
    ["Yandex", "https://yandex.com/search/?text=%s"]
  ],
  翻译引擎: [
    ["Google", "https://translate.google.com.hk/?op=translate&text=%s"],
    ["Deepl", "https://www.deepl.com/translator#any/any/%s"],
    ["金山词霸", "http://www.iciba.com/word?w=%s"],
    ["百度", "https://fanyi.baidu.com/#auto/auto/%s"],
    ["腾讯", "https://fanyi.qq.com/?text=%s"],
    ["翻译树", "https://fanyishu.netlify.app/?text=%s"]
  ],
  引擎: {
    记住: false,
    默认搜索引擎: "百度",
    默认翻译引擎: "Google"
  },
  nocors: ["https://yuansou.netlify.app/"],
  历史记录设置: {
    保留历史记录: true,
    自动清除历史记录: false,
    d: 14,
    h: 0
  },
  ding_dock: [0, 0],
  贴图: {
    窗口: {
      变换: `transform: rotateY(180deg);`,
      双击: "归位"
    }
  },
  代理: {
    mode: "direct",
    pacScript: "",
    proxyRules: "",
    proxyBypassRules: ""
  },
  主页面大小: [800, 600, false],
  关闭窗口: {
    失焦: { 主页面: false }
  },
  时间格式: "MM/DD hh:mm:ss",
  硬件加速: true,
  更新: {
    检查更新: true,
    频率: "setting",
    dev: false,
    上次更新时间: 0
  },
  录屏: {
    自动录制: 3,
    视频比特率: 2.5,
    摄像头: {
      默认开启: false,
      记住开启状态: false,
      镜像: false,
      背景: {
        模式: "none",
        模糊: 40,
        imgUrl: "",
        videoUrl: "",
        fit: "contain"
      }
    },
    音频: {
      默认开启: false,
      记住开启状态: false
    },
    转换: {
      自动转换: false,
      格式: "webm",
      码率: 2.5,
      帧率: 30,
      其他: "",
      高质量gif: false,
      分段: 10
    },
    提示: {
      键盘: {
        开启: false
      },
      鼠标: {
        开启: false
      },
      光标: {
        开启: false,
        样式: "width: 24px;\nheight: 24px;\nborder-radius: 50%;\nbackground-color: #ff08;"
      }
    }
  },
  插件: { 加载前: [], 加载后: [] }
};
try {
  defaultSetting.保存.保存路径.图片 = electron.app.getPath("pictures");
  defaultSetting.保存.保存路径.视频 = electron.app.getPath("videos");
} catch (e) {
  console.error(e);
}
function setDefaultSetting() {
  for (let i in defaultSetting) {
    if (i == "语言") {
      store.set(i, { 语言: electron.app.getLocale() || "zh-HANS" });
    } else {
      store.set(i, defaultSetting[i]);
    }
  }
}
function fix_setting_tree() {
  if (store.get("设置版本") == electron.app.getVersion())
    return;
  var tree = "defaultSetting";
  walk(tree);
  function walk(path) {
    var x = eval(path);
    if (Object.keys(x).length == 0) {
      path = path.slice(tree.length + 1);
      if (store.get(path) === void 0)
        store.set(path, x);
    } else {
      for (let i in x) {
        var c_path = path + "." + i;
        if (x[i].constructor === Object) {
          walk(c_path);
        } else {
          c_path = c_path.slice(tree.length + 1);
          if (store.get(c_path) === void 0)
            store.set(c_path, x[i]);
        }
      }
    }
  }
}
