(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(function () {
      return (root.cv = factory());
    });
  } else if (typeof module === 'object' && module.exports) {
    // Node. Does not work with strict CommonJS, but
    // only CommonJS-like environments that support module.exports,
    // like Node.
    module.exports = factory();
  } else {
    // Browser globals
    root.cv = factory();
  }
}(this, function () {
  var cv = function(cv) {
  cv = cv || {};
  var Module = cv;

var Module;if(!Module)Module=(typeof cv!=="undefined"?cv:null)||{};var moduleOverrides={};for(var key in Module){if(Module.hasOwnProperty(key)){moduleOverrides[key]=Module[key]}}var ENVIRONMENT_IS_WEB=false;var ENVIRONMENT_IS_WORKER=false;var ENVIRONMENT_IS_NODE=false;var ENVIRONMENT_IS_SHELL=false;if(Module["ENVIRONMENT"]){if(Module["ENVIRONMENT"]==="WEB"){ENVIRONMENT_IS_WEB=true}else if(Module["ENVIRONMENT"]==="WORKER"){ENVIRONMENT_IS_WORKER=true}else if(Module["ENVIRONMENT"]==="NODE"){ENVIRONMENT_IS_NODE=true}else if(Module["ENVIRONMENT"]==="SHELL"){ENVIRONMENT_IS_SHELL=true}else{throw new Error("The provided Module['ENVIRONMENT'] value is not valid. It must be one of: WEB|WORKER|NODE|SHELL.")}}else{ENVIRONMENT_IS_WEB=typeof window==="object";ENVIRONMENT_IS_WORKER=typeof importScripts==="function";ENVIRONMENT_IS_NODE=typeof process==="object"&&typeof require==="function"&&!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_WORKER;ENVIRONMENT_IS_SHELL=!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_NODE&&!ENVIRONMENT_IS_WORKER}if(ENVIRONMENT_IS_NODE){if(!Module["print"])Module["print"]=console.log;if(!Module["printErr"])Module["printErr"]=console.warn;var nodeFS;var nodePath;Module["read"]=function shell_read(filename,binary){if(!nodeFS)nodeFS=require("fs");if(!nodePath)nodePath=require("path");filename=nodePath["normalize"](filename);var ret=nodeFS["readFileSync"](filename);return binary?ret:ret.toString()};Module["readBinary"]=function readBinary(filename){var ret=Module["read"](filename,true);if(!ret.buffer){ret=new Uint8Array(ret)}assert(ret.buffer);return ret};Module["load"]=function load(f){globalEval(read(f))};if(!Module["thisProgram"]){if(process["argv"].length>1){Module["thisProgram"]=process["argv"][1].replace(/\\/g,"/")}else{Module["thisProgram"]="unknown-program"}}Module["arguments"]=process["argv"].slice(2);if(typeof module!=="undefined"){module["exports"]=Module}process["on"]("uncaughtException",(function(ex){if(!(ex instanceof ExitStatus)){throw ex}}));Module["inspect"]=(function(){return"[Emscripten Module object]"})}else if(ENVIRONMENT_IS_SHELL){if(!Module["print"])Module["print"]=print;if(typeof printErr!="undefined")Module["printErr"]=printErr;if(typeof read!="undefined"){Module["read"]=read}else{Module["read"]=function shell_read(){throw"no read() available"}}Module["readBinary"]=function readBinary(f){if(typeof readbuffer==="function"){return new Uint8Array(readbuffer(f))}var data=read(f,"binary");assert(typeof data==="object");return data};if(typeof scriptArgs!="undefined"){Module["arguments"]=scriptArgs}else if(typeof arguments!="undefined"){Module["arguments"]=arguments}if(typeof quit==="function"){Module["quit"]=(function(status,toThrow){quit(status)})}}else if(ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER){Module["read"]=function shell_read(url){var xhr=new XMLHttpRequest;xhr.open("GET",url,false);xhr.send(null);return xhr.responseText};if(ENVIRONMENT_IS_WORKER){Module["readBinary"]=function readBinary(url){var xhr=new XMLHttpRequest;xhr.open("GET",url,false);xhr.responseType="arraybuffer";xhr.send(null);return new Uint8Array(xhr.response)}}Module["readAsync"]=function readAsync(url,onload,onerror){var xhr=new XMLHttpRequest;xhr.open("GET",url,true);xhr.responseType="arraybuffer";xhr.onload=function xhr_onload(){if(xhr.status==200||xhr.status==0&&xhr.response){onload(xhr.response)}else{onerror()}};xhr.onerror=onerror;xhr.send(null)};if(typeof arguments!="undefined"){Module["arguments"]=arguments}if(typeof console!=="undefined"){if(!Module["print"])Module["print"]=function shell_print(x){console.log(x)};if(!Module["printErr"])Module["printErr"]=function shell_printErr(x){console.warn(x)}}else{var TRY_USE_DUMP=false;if(!Module["print"])Module["print"]=TRY_USE_DUMP&&typeof dump!=="undefined"?(function(x){dump(x)}):(function(x){})}if(ENVIRONMENT_IS_WORKER){Module["load"]=importScripts}if(typeof Module["setWindowTitle"]==="undefined"){Module["setWindowTitle"]=(function(title){document.title=title})}}else{throw"Unknown runtime environment. Where are we?"}function globalEval(x){eval.call(null,x)}if(!Module["load"]&&Module["read"]){Module["load"]=function load(f){globalEval(Module["read"](f))}}if(!Module["print"]){Module["print"]=(function(){})}if(!Module["printErr"]){Module["printErr"]=Module["print"]}if(!Module["arguments"]){Module["arguments"]=[]}if(!Module["thisProgram"]){Module["thisProgram"]="./this.program"}if(!Module["quit"]){Module["quit"]=(function(status,toThrow){throw toThrow})}Module.print=Module["print"];Module.printErr=Module["printErr"];Module["preRun"]=[];Module["postRun"]=[];for(var key in moduleOverrides){if(moduleOverrides.hasOwnProperty(key)){Module[key]=moduleOverrides[key]}}moduleOverrides=undefined;var Runtime={setTempRet0:(function(value){tempRet0=value;return value}),getTempRet0:(function(){return tempRet0}),stackSave:(function(){return STACKTOP}),stackRestore:(function(stackTop){STACKTOP=stackTop}),getNativeTypeSize:(function(type){switch(type){case"i1":case"i8":return 1;case"i16":return 2;case"i32":return 4;case"i64":return 8;case"float":return 4;case"double":return 8;default:{if(type[type.length-1]==="*"){return Runtime.QUANTUM_SIZE}else if(type[0]==="i"){var bits=parseInt(type.substr(1));assert(bits%8===0);return bits/8}else{return 0}}}}),getNativeFieldSize:(function(type){return Math.max(Runtime.getNativeTypeSize(type),Runtime.QUANTUM_SIZE)}),STACK_ALIGN:16,prepVararg:(function(ptr,type){if(type==="double"||type==="i64"){if(ptr&7){assert((ptr&7)===4);ptr+=4}}else{assert((ptr&3)===0)}return ptr}),getAlignSize:(function(type,size,vararg){if(!vararg&&(type=="i64"||type=="double"))return 8;if(!type)return Math.min(size,8);return Math.min(size||(type?Runtime.getNativeFieldSize(type):0),Runtime.QUANTUM_SIZE)}),dynCall:(function(sig,ptr,args){if(args&&args.length){return Module["dynCall_"+sig].apply(null,[ptr].concat(args))}else{return Module["dynCall_"+sig].call(null,ptr)}}),functionPointers:[],addFunction:(function(func){for(var i=0;i<Runtime.functionPointers.length;i++){if(!Runtime.functionPointers[i]){Runtime.functionPointers[i]=func;return 2*(1+i)}}throw"Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS."}),removeFunction:(function(index){Runtime.functionPointers[(index-2)/2]=null}),warnOnce:(function(text){if(!Runtime.warnOnce.shown)Runtime.warnOnce.shown={};if(!Runtime.warnOnce.shown[text]){Runtime.warnOnce.shown[text]=1;Module.printErr(text)}}),funcWrappers:{},getFuncWrapper:(function(func,sig){assert(sig);if(!Runtime.funcWrappers[sig]){Runtime.funcWrappers[sig]={}}var sigCache=Runtime.funcWrappers[sig];if(!sigCache[func]){if(sig.length===1){sigCache[func]=function dynCall_wrapper(){return Runtime.dynCall(sig,func)}}else if(sig.length===2){sigCache[func]=function dynCall_wrapper(arg){return Runtime.dynCall(sig,func,[arg])}}else{sigCache[func]=function dynCall_wrapper(){return Runtime.dynCall(sig,func,Array.prototype.slice.call(arguments))}}}return sigCache[func]}),getCompilerSetting:(function(name){throw"You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work"}),stackAlloc:(function(size){var ret=STACKTOP;STACKTOP=STACKTOP+size|0;STACKTOP=STACKTOP+15&-16;return ret}),staticAlloc:(function(size){var ret=STATICTOP;STATICTOP=STATICTOP+size|0;STATICTOP=STATICTOP+15&-16;return ret}),dynamicAlloc:(function(size){var ret=HEAP32[DYNAMICTOP_PTR>>2];var end=(ret+size+15|0)&-16;HEAP32[DYNAMICTOP_PTR>>2]=end;if(end>=TOTAL_MEMORY){var success=enlargeMemory();if(!success){HEAP32[DYNAMICTOP_PTR>>2]=ret;return 0}}return ret}),alignMemory:(function(size,quantum){var ret=size=Math.ceil(size/(quantum?quantum:16))*(quantum?quantum:16);return ret}),makeBigInt:(function(low,high,unsigned){var ret=unsigned?+(low>>>0)+ +(high>>>0)*+4294967296:+(low>>>0)+ +(high|0)*+4294967296;return ret}),GLOBAL_BASE:8,QUANTUM_SIZE:4,__dummy__:0};Module["Runtime"]=Runtime;var ABORT=0;var EXITSTATUS=0;function assert(condition,text){if(!condition){abort("Assertion failed: "+text)}}function getCFunc(ident){var func=Module["_"+ident];if(!func){try{func=eval("_"+ident)}catch(e){}}assert(func,"Cannot call unknown function "+ident+" (perhaps LLVM optimizations or closure removed it?)");return func}var cwrap,ccall;((function(){var JSfuncs={"stackSave":(function(){Runtime.stackSave()}),"stackRestore":(function(){Runtime.stackRestore()}),"arrayToC":(function(arr){var ret=Runtime.stackAlloc(arr.length);writeArrayToMemory(arr,ret);return ret}),"stringToC":(function(str){var ret=0;if(str!==null&&str!==undefined&&str!==0){var len=(str.length<<2)+1;ret=Runtime.stackAlloc(len);stringToUTF8(str,ret,len)}return ret})};var toC={"string":JSfuncs["stringToC"],"array":JSfuncs["arrayToC"]};ccall=function ccallFunc(ident,returnType,argTypes,args,opts){var func=getCFunc(ident);var cArgs=[];var stack=0;if(args){for(var i=0;i<args.length;i++){var converter=toC[argTypes[i]];if(converter){if(stack===0)stack=Runtime.stackSave();cArgs[i]=converter(args[i])}else{cArgs[i]=args[i]}}}var ret=func.apply(null,cArgs);if(returnType==="string")ret=Pointer_stringify(ret);if(stack!==0){if(opts&&opts.async){EmterpreterAsync.asyncFinalizers.push((function(){Runtime.stackRestore(stack)}));return}Runtime.stackRestore(stack)}return ret};var sourceRegex=/^function\s*[a-zA-Z$_0-9]*\s*\(([^)]*)\)\s*{\s*([^*]*?)[\s;]*(?:return\s*(.*?)[;\s]*)?}$/;function parseJSFunc(jsfunc){var parsed=jsfunc.toString().match(sourceRegex).slice(1);return{arguments:parsed[0],body:parsed[1],returnValue:parsed[2]}}var JSsource=null;function ensureJSsource(){if(!JSsource){JSsource={};for(var fun in JSfuncs){if(JSfuncs.hasOwnProperty(fun)){JSsource[fun]=parseJSFunc(JSfuncs[fun])}}}}cwrap=function cwrap(ident,returnType,argTypes){argTypes=argTypes||[];var cfunc=getCFunc(ident);var numericArgs=argTypes.every((function(type){return type==="number"}));var numericRet=returnType!=="string";if(numericRet&&numericArgs){return cfunc}var argNames=argTypes.map((function(x,i){return"$"+i}));var funcstr="(function("+argNames.join(",")+") {";var nargs=argTypes.length;if(!numericArgs){ensureJSsource();funcstr+="var stack = "+JSsource["stackSave"].body+";";for(var i=0;i<nargs;i++){var arg=argNames[i],type=argTypes[i];if(type==="number")continue;var convertCode=JSsource[type+"ToC"];funcstr+="var "+convertCode.arguments+" = "+arg+";";funcstr+=convertCode.body+";";funcstr+=arg+"=("+convertCode.returnValue+");"}}var cfuncname=parseJSFunc((function(){return cfunc})).returnValue;funcstr+="var ret = "+cfuncname+"("+argNames.join(",")+");";if(!numericRet){var strgfy=parseJSFunc((function(){return Pointer_stringify})).returnValue;funcstr+="ret = "+strgfy+"(ret);"}if(!numericArgs){ensureJSsource();funcstr+=JSsource["stackRestore"].body.replace("()","(stack)")+";"}funcstr+="return ret})";return eval(funcstr)}}))();Module["ccall"]=ccall;Module["cwrap"]=cwrap;function setValue(ptr,value,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":HEAP8[ptr>>0]=value;break;case"i8":HEAP8[ptr>>0]=value;break;case"i16":HEAP16[ptr>>1]=value;break;case"i32":HEAP32[ptr>>2]=value;break;case"i64":tempI64=[value>>>0,(tempDouble=value,+Math_abs(tempDouble)>=+1?tempDouble>+0?(Math_min(+Math_floor(tempDouble/+4294967296),+4294967295)|0)>>>0:~~+Math_ceil((tempDouble- +(~~tempDouble>>>0))/+4294967296)>>>0:0)],HEAP32[ptr>>2]=tempI64[0],HEAP32[ptr+4>>2]=tempI64[1];break;case"float":HEAPF32[ptr>>2]=value;break;case"double":HEAPF64[ptr>>3]=value;break;default:abort("invalid type for setValue: "+type)}}Module["setValue"]=setValue;function getValue(ptr,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":return HEAP8[ptr>>0];case"i8":return HEAP8[ptr>>0];case"i16":return HEAP16[ptr>>1];case"i32":return HEAP32[ptr>>2];case"i64":return HEAP32[ptr>>2];case"float":return HEAPF32[ptr>>2];case"double":return HEAPF64[ptr>>3];default:abort("invalid type for setValue: "+type)}return null}Module["getValue"]=getValue;var ALLOC_NORMAL=0;var ALLOC_STACK=1;var ALLOC_STATIC=2;var ALLOC_DYNAMIC=3;var ALLOC_NONE=4;Module["ALLOC_NORMAL"]=ALLOC_NORMAL;Module["ALLOC_STACK"]=ALLOC_STACK;Module["ALLOC_STATIC"]=ALLOC_STATIC;Module["ALLOC_DYNAMIC"]=ALLOC_DYNAMIC;Module["ALLOC_NONE"]=ALLOC_NONE;function allocate(slab,types,allocator,ptr){var zeroinit,size;if(typeof slab==="number"){zeroinit=true;size=slab}else{zeroinit=false;size=slab.length}var singleType=typeof types==="string"?types:null;var ret;if(allocator==ALLOC_NONE){ret=ptr}else{ret=[typeof _malloc==="function"?_malloc:Runtime.staticAlloc,Runtime.stackAlloc,Runtime.staticAlloc,Runtime.dynamicAlloc][allocator===undefined?ALLOC_STATIC:allocator](Math.max(size,singleType?1:types.length))}if(zeroinit){var ptr=ret,stop;assert((ret&3)==0);stop=ret+(size&~3);for(;ptr<stop;ptr+=4){HEAP32[ptr>>2]=0}stop=ret+size;while(ptr<stop){HEAP8[ptr++>>0]=0}return ret}if(singleType==="i8"){if(slab.subarray||slab.slice){HEAPU8.set(slab,ret)}else{HEAPU8.set(new Uint8Array(slab),ret)}return ret}var i=0,type,typeSize,previousType;while(i<size){var curr=slab[i];if(typeof curr==="function"){curr=Runtime.getFunctionIndex(curr)}type=singleType||types[i];if(type===0){i++;continue}if(type=="i64")type="i32";setValue(ret+i,curr,type);if(previousType!==type){typeSize=Runtime.getNativeTypeSize(type);previousType=type}i+=typeSize}return ret}Module["allocate"]=allocate;function getMemory(size){if(!staticSealed)return Runtime.staticAlloc(size);if(!runtimeInitialized)return Runtime.dynamicAlloc(size);return _malloc(size)}Module["getMemory"]=getMemory;function Pointer_stringify(ptr,length){if(length===0||!ptr)return"";var hasUtf=0;var t;var i=0;while(1){t=HEAPU8[ptr+i>>0];hasUtf|=t;if(t==0&&!length)break;i++;if(length&&i==length)break}if(!length)length=i;var ret="";if(hasUtf<128){var MAX_CHUNK=1024;var curr;while(length>0){curr=String.fromCharCode.apply(String,HEAPU8.subarray(ptr,ptr+Math.min(length,MAX_CHUNK)));ret=ret?ret+curr:curr;ptr+=MAX_CHUNK;length-=MAX_CHUNK}return ret}return Module["UTF8ToString"](ptr)}Module["Pointer_stringify"]=Pointer_stringify;function AsciiToString(ptr){var str="";while(1){var ch=HEAP8[ptr++>>0];if(!ch)return str;str+=String.fromCharCode(ch)}}Module["AsciiToString"]=AsciiToString;function stringToAscii(str,outPtr){return writeAsciiToMemory(str,outPtr,false)}Module["stringToAscii"]=stringToAscii;var UTF8Decoder=typeof TextDecoder!=="undefined"?new TextDecoder("utf8"):undefined;function UTF8ArrayToString(u8Array,idx){var endPtr=idx;while(u8Array[endPtr])++endPtr;if(endPtr-idx>16&&u8Array.subarray&&UTF8Decoder){return UTF8Decoder.decode(u8Array.subarray(idx,endPtr))}else{var u0,u1,u2,u3,u4,u5;var str="";while(1){u0=u8Array[idx++];if(!u0)return str;if(!(u0&128)){str+=String.fromCharCode(u0);continue}u1=u8Array[idx++]&63;if((u0&224)==192){str+=String.fromCharCode((u0&31)<<6|u1);continue}u2=u8Array[idx++]&63;if((u0&240)==224){u0=(u0&15)<<12|u1<<6|u2}else{u3=u8Array[idx++]&63;if((u0&248)==240){u0=(u0&7)<<18|u1<<12|u2<<6|u3}else{u4=u8Array[idx++]&63;if((u0&252)==248){u0=(u0&3)<<24|u1<<18|u2<<12|u3<<6|u4}else{u5=u8Array[idx++]&63;u0=(u0&1)<<30|u1<<24|u2<<18|u3<<12|u4<<6|u5}}}if(u0<65536){str+=String.fromCharCode(u0)}else{var ch=u0-65536;str+=String.fromCharCode(55296|ch>>10,56320|ch&1023)}}}}Module["UTF8ArrayToString"]=UTF8ArrayToString;function UTF8ToString(ptr){return UTF8ArrayToString(HEAPU8,ptr)}Module["UTF8ToString"]=UTF8ToString;function stringToUTF8Array(str,outU8Array,outIdx,maxBytesToWrite){if(!(maxBytesToWrite>0))return 0;var startIdx=outIdx;var endIdx=outIdx+maxBytesToWrite-1;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){if(outIdx>=endIdx)break;outU8Array[outIdx++]=u}else if(u<=2047){if(outIdx+1>=endIdx)break;outU8Array[outIdx++]=192|u>>6;outU8Array[outIdx++]=128|u&63}else if(u<=65535){if(outIdx+2>=endIdx)break;outU8Array[outIdx++]=224|u>>12;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=2097151){if(outIdx+3>=endIdx)break;outU8Array[outIdx++]=240|u>>18;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=67108863){if(outIdx+4>=endIdx)break;outU8Array[outIdx++]=248|u>>24;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else{if(outIdx+5>=endIdx)break;outU8Array[outIdx++]=252|u>>30;outU8Array[outIdx++]=128|u>>24&63;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}}outU8Array[outIdx]=0;return outIdx-startIdx}Module["stringToUTF8Array"]=stringToUTF8Array;function stringToUTF8(str,outPtr,maxBytesToWrite){return stringToUTF8Array(str,HEAPU8,outPtr,maxBytesToWrite)}Module["stringToUTF8"]=stringToUTF8;function lengthBytesUTF8(str){var len=0;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){++len}else if(u<=2047){len+=2}else if(u<=65535){len+=3}else if(u<=2097151){len+=4}else if(u<=67108863){len+=5}else{len+=6}}return len}Module["lengthBytesUTF8"]=lengthBytesUTF8;var UTF16Decoder=typeof TextDecoder!=="undefined"?new TextDecoder("utf-16le"):undefined;function demangle(func){var __cxa_demangle_func=Module["___cxa_demangle"]||Module["__cxa_demangle"];if(__cxa_demangle_func){try{var s=func.substr(1);var len=lengthBytesUTF8(s)+1;var buf=_malloc(len);stringToUTF8(s,buf,len);var status=_malloc(4);var ret=__cxa_demangle_func(buf,0,0,status);if(getValue(status,"i32")===0&&ret){return Pointer_stringify(ret)}}catch(e){}finally{if(buf)_free(buf);if(status)_free(status);if(ret)_free(ret)}return func}Runtime.warnOnce("warning: build with  -s DEMANGLE_SUPPORT=1  to link in libcxxabi demangling");return func}function demangleAll(text){var regex=/__Z[\w\d_]+/g;return text.replace(regex,(function(x){var y=demangle(x);return x===y?x:x+" ["+y+"]"}))}function jsStackTrace(){var err=new Error;if(!err.stack){try{throw new Error(0)}catch(e){err=e}if(!err.stack){return"(no stack trace available)"}}return err.stack.toString()}function stackTrace(){var js=jsStackTrace();if(Module["extraStackTrace"])js+="\n"+Module["extraStackTrace"]();return demangleAll(js)}Module["stackTrace"]=stackTrace;var WASM_PAGE_SIZE=65536;var ASMJS_PAGE_SIZE=16777216;var MIN_TOTAL_MEMORY=16777216;function alignUp(x,multiple){if(x%multiple>0){x+=multiple-x%multiple}return x}var HEAP,buffer,HEAP8,HEAPU8,HEAP16,HEAPU16,HEAP32,HEAPU32,HEAPF32,HEAPF64;function updateGlobalBuffer(buf){Module["buffer"]=buffer=buf}function updateGlobalBufferViews(){Module["HEAP8"]=HEAP8=new Int8Array(buffer);Module["HEAP16"]=HEAP16=new Int16Array(buffer);Module["HEAP32"]=HEAP32=new Int32Array(buffer);Module["HEAPU8"]=HEAPU8=new Uint8Array(buffer);Module["HEAPU16"]=HEAPU16=new Uint16Array(buffer);Module["HEAPU32"]=HEAPU32=new Uint32Array(buffer);Module["HEAPF32"]=HEAPF32=new Float32Array(buffer);Module["HEAPF64"]=HEAPF64=new Float64Array(buffer)}var STATIC_BASE,STATICTOP,staticSealed;var STACK_BASE,STACKTOP,STACK_MAX;var DYNAMIC_BASE,DYNAMICTOP_PTR;STATIC_BASE=STATICTOP=STACK_BASE=STACKTOP=STACK_MAX=DYNAMIC_BASE=DYNAMICTOP_PTR=0;staticSealed=false;function abortOnCannotGrowMemory(){abort("Cannot enlarge memory arrays. Either (1) compile with  -s TOTAL_MEMORY=X  with X higher than the current value "+TOTAL_MEMORY+", (2) compile with  -s ALLOW_MEMORY_GROWTH=1  which allows increasing the size at runtime but prevents some optimizations, (3) set Module.TOTAL_MEMORY to a higher value before the program runs, or (4) if you want malloc to return NULL (0) instead of this abort, compile with  -s ABORTING_MALLOC=0 ")}if(!Module["reallocBuffer"])Module["reallocBuffer"]=(function(size){var ret;try{if(ArrayBuffer.transfer){ret=ArrayBuffer.transfer(buffer,size)}else{var oldHEAP8=HEAP8;ret=new ArrayBuffer(size);var temp=new Int8Array(ret);temp.set(oldHEAP8)}}catch(e){return false}var success=_emscripten_replace_memory(ret);if(!success)return false;return ret});function enlargeMemory(){var PAGE_MULTIPLE=Module["usingWasm"]?WASM_PAGE_SIZE:ASMJS_PAGE_SIZE;var LIMIT=2147483648-PAGE_MULTIPLE;if(HEAP32[DYNAMICTOP_PTR>>2]>LIMIT){return false}var OLD_TOTAL_MEMORY=TOTAL_MEMORY;TOTAL_MEMORY=Math.max(TOTAL_MEMORY,MIN_TOTAL_MEMORY);while(TOTAL_MEMORY<HEAP32[DYNAMICTOP_PTR>>2]){if(TOTAL_MEMORY<=536870912){TOTAL_MEMORY=alignUp(2*TOTAL_MEMORY,PAGE_MULTIPLE)}else{TOTAL_MEMORY=Math.min(alignUp((3*TOTAL_MEMORY+2147483648)/4,PAGE_MULTIPLE),LIMIT)}}var replacement=Module["reallocBuffer"](TOTAL_MEMORY);if(!replacement||replacement.byteLength!=TOTAL_MEMORY){TOTAL_MEMORY=OLD_TOTAL_MEMORY;return false}updateGlobalBuffer(replacement);updateGlobalBufferViews();return true}var byteLength;try{byteLength=Function.prototype.call.bind(Object.getOwnPropertyDescriptor(ArrayBuffer.prototype,"byteLength").get);byteLength(new ArrayBuffer(4))}catch(e){byteLength=(function(buffer){return buffer.byteLength})}var TOTAL_STACK=Module["TOTAL_STACK"]||5242880;var TOTAL_MEMORY=Module["TOTAL_MEMORY"]||134217728;if(TOTAL_MEMORY<TOTAL_STACK)Module.printErr("TOTAL_MEMORY should be larger than TOTAL_STACK, was "+TOTAL_MEMORY+"! (TOTAL_STACK="+TOTAL_STACK+")");if(Module["buffer"]){buffer=Module["buffer"]}else{{buffer=new ArrayBuffer(TOTAL_MEMORY)}}updateGlobalBufferViews();function getTotalMemory(){return TOTAL_MEMORY}HEAP32[0]=1668509029;HEAP16[1]=25459;if(HEAPU8[2]!==115||HEAPU8[3]!==99)throw"Runtime error: expected the system to be little-endian!";Module["HEAP"]=HEAP;Module["buffer"]=buffer;Module["HEAP8"]=HEAP8;Module["HEAP16"]=HEAP16;Module["HEAP32"]=HEAP32;Module["HEAPU8"]=HEAPU8;Module["HEAPU16"]=HEAPU16;Module["HEAPU32"]=HEAPU32;Module["HEAPF32"]=HEAPF32;Module["HEAPF64"]=HEAPF64;function callRuntimeCallbacks(callbacks){while(callbacks.length>0){var callback=callbacks.shift();if(typeof callback=="function"){callback();continue}var func=callback.func;if(typeof func==="number"){if(callback.arg===undefined){Module["dynCall_v"](func)}else{Module["dynCall_vi"](func,callback.arg)}}else{func(callback.arg===undefined?null:callback.arg)}}}var __ATPRERUN__=[];var __ATINIT__=[];var __ATMAIN__=[];var __ATEXIT__=[];var __ATPOSTRUN__=[];var runtimeInitialized=false;var runtimeExited=false;function preRun(){if(Module["preRun"]){if(typeof Module["preRun"]=="function")Module["preRun"]=[Module["preRun"]];while(Module["preRun"].length){addOnPreRun(Module["preRun"].shift())}}callRuntimeCallbacks(__ATPRERUN__)}function ensureInitRuntime(){if(runtimeInitialized)return;runtimeInitialized=true;callRuntimeCallbacks(__ATINIT__)}function preMain(){callRuntimeCallbacks(__ATMAIN__)}function exitRuntime(){callRuntimeCallbacks(__ATEXIT__);runtimeExited=true}function postRun(){if(Module["postRun"]){if(typeof Module["postRun"]=="function")Module["postRun"]=[Module["postRun"]];while(Module["postRun"].length){addOnPostRun(Module["postRun"].shift())}}callRuntimeCallbacks(__ATPOSTRUN__)}function addOnPreRun(cb){__ATPRERUN__.unshift(cb)}Module["addOnPreRun"]=addOnPreRun;function addOnInit(cb){__ATINIT__.unshift(cb)}Module["addOnInit"]=addOnInit;function addOnPreMain(cb){__ATMAIN__.unshift(cb)}Module["addOnPreMain"]=addOnPreMain;function addOnExit(cb){__ATEXIT__.unshift(cb)}Module["addOnExit"]=addOnExit;function addOnPostRun(cb){__ATPOSTRUN__.unshift(cb)}Module["addOnPostRun"]=addOnPostRun;function intArrayFromString(stringy,dontAddNull,length){var len=length>0?length:lengthBytesUTF8(stringy)+1;var u8array=new Array(len);var numBytesWritten=stringToUTF8Array(stringy,u8array,0,u8array.length);if(dontAddNull)u8array.length=numBytesWritten;return u8array}Module["intArrayFromString"]=intArrayFromString;function intArrayToString(array){var ret=[];for(var i=0;i<array.length;i++){var chr=array[i];if(chr>255){chr&=255}ret.push(String.fromCharCode(chr))}return ret.join("")}Module["intArrayToString"]=intArrayToString;function writeStringToMemory(string,buffer,dontAddNull){Runtime.warnOnce("writeStringToMemory is deprecated and should not be called! Use stringToUTF8() instead!");var lastChar,end;if(dontAddNull){end=buffer+lengthBytesUTF8(string);lastChar=HEAP8[end]}stringToUTF8(string,buffer,Infinity);if(dontAddNull)HEAP8[end]=lastChar}Module["writeStringToMemory"]=writeStringToMemory;function writeArrayToMemory(array,buffer){HEAP8.set(array,buffer)}Module["writeArrayToMemory"]=writeArrayToMemory;function writeAsciiToMemory(str,buffer,dontAddNull){for(var i=0;i<str.length;++i){HEAP8[buffer++>>0]=str.charCodeAt(i)}if(!dontAddNull)HEAP8[buffer>>0]=0}Module["writeAsciiToMemory"]=writeAsciiToMemory;if(!Math["imul"]||Math["imul"](4294967295,5)!==-5)Math["imul"]=function imul(a,b){var ah=a>>>16;var al=a&65535;var bh=b>>>16;var bl=b&65535;return al*bl+(ah*bl+al*bh<<16)|0};Math.imul=Math["imul"];if(!Math["clz32"])Math["clz32"]=(function(x){x=x>>>0;for(var i=0;i<32;i++){if(x&1<<31-i)return i}return 32});Math.clz32=Math["clz32"];if(!Math["trunc"])Math["trunc"]=(function(x){return x<0?Math.ceil(x):Math.floor(x)});Math.trunc=Math["trunc"];var Math_abs=Math.abs;var Math_cos=Math.cos;var Math_sin=Math.sin;var Math_tan=Math.tan;var Math_acos=Math.acos;var Math_asin=Math.asin;var Math_atan=Math.atan;var Math_atan2=Math.atan2;var Math_exp=Math.exp;var Math_log=Math.log;var Math_sqrt=Math.sqrt;var Math_ceil=Math.ceil;var Math_floor=Math.floor;var Math_pow=Math.pow;var Math_imul=Math.imul;var Math_fround=Math.fround;var Math_round=Math.round;var Math_min=Math.min;var Math_clz32=Math.clz32;var Math_trunc=Math.trunc;var runDependencies=0;var runDependencyWatcher=null;var dependenciesFulfilled=null;function getUniqueRunDependency(id){return id}function addRunDependency(id){runDependencies++;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}}Module["addRunDependency"]=addRunDependency;function removeRunDependency(id){runDependencies--;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}if(runDependencies==0){if(runDependencyWatcher!==null){clearInterval(runDependencyWatcher);runDependencyWatcher=null}if(dependenciesFulfilled){var callback=dependenciesFulfilled;dependenciesFulfilled=null;callback()}}}Module["removeRunDependency"]=removeRunDependency;Module["preloadedImages"]={};Module["preloadedAudios"]={};var ASM_CONSTS=[];STATIC_BASE=Runtime.GLOBAL_BASE;STATICTOP=STATIC_BASE+5694112;__ATINIT__.push({func:(function(){__GLOBAL__I_000101()})},{func:(function(){__GLOBAL__sub_I_bindings_stdout_sajjad_ZBOX_ID88_ID89_ID90_18140_mHXJkG_ii()})},{func:(function(){__GLOBAL__sub_I_persistenc_stdout_sajjad_ZBOX_ID88_ID89_ID90_14771_dTJ5vw_ii()})},{func:(function(){__GLOBAL__sub_I_system_stdout_sajjad_ZBOX_ID88_ID89_ID90_18069_ku7LVV_ii()})},{func:(function(){__GLOBAL__sub_I_umatrix_stdout_sajjad_ZBOX_ID88_ID89_ID90_14943_RiHQee_ii()})},{func:(function(){__GLOBAL__sub_I_color_stdout_sajjad_ZBOX_ID88_ID89_ID90_15060_1vwvIh_ii()})},{func:(function(){__GLOBAL__sub_I_histogram_stdout_sajjad_ZBOX_ID88_ID89_ID90_15407_4w9Dw7_ii()})},{func:(function(){__GLOBAL__sub_I_imgwarp_stdout_sajjad_ZBOX_ID88_ID89_ID90_15452_bOwam9_ii()})},{func:(function(){__GLOBAL__sub_I_haar_stdout_sajjad_ZBOX_ID88_ID89_ID90_15944_tWdK1p_ii()})},{func:(function(){__GLOBAL__sub_I_hog_stdout_sajjad_ZBOX_ID88_ID89_ID90_15935_Hps2Hq_ii()})},{func:(function(){__GLOBAL__sub_I_loadsave_stdout_sajjad_ZBOX_ID88_ID89_ID90_32009_2MzGIi_ii()})},{func:(function(){__GLOBAL__sub_I_bind_cpp()})},{func:(function(){__GLOBAL__sub_I_iostream_cpp()})});allocate([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,192,11,177,162,10,240,111,63,32,224,31,224,31,224,239,63,136,103,16,107,42,224,127,63,240,7,252,1,127,192,239,63,118,10,129,95,71,220,135,63,18,250,1,170,28,161,239,63,227,3,252,176,168,192,143,63,32,248,129,31,248,129,239,63,116,165,70,67,164,206,147,63,181,219,160,172,16,99,239,63,26,177,213,7,27,185,151,63,113,66,74,158,101,68,239,63,151,145,175,39,192,159,155,63,181,10,35,68,246,37,239,63,0,51,120,14,155,130,159,63,8,31,124,240,193,7,239,63,127,217,35,137,217,176,161,63,2,142,69,248,199,233,238,63,95,189,254,185,135,158,163,63,192,236,1,179,7,204,238,63,212,228,200,175,91,138,165,63,235,1,186,122,128,174,238,63,252,220,50,246,88,116,167,63,103,183,240,171,49,145,238,63,235,227,200,14,131,92,169,63,228,80,151,165,26,116,238,63,190,113,25,113,221,66,171,63,116,229,1,201,58,87,238,63,82,11,219,138,107,39,173,63,115,26,220,121,145,58,238,63,166,98,17,192,48,10,175,63,30,30,30,30,30,30,238,63,113,228,152,53,152,117,176,63,30,224,1,30,224,1,238,63,224,122,163,238,54,101,177,63,138,134,248,227,214,229,237,63,22,20,10,47,246,83,178,63,202,29,160,220,1,202,237,63,208,209,27,150,215,65,179,63,219,129,185,118,96,174,237,63,240,70,166,190,220,46,180,63,138,127,30,35,242,146,237,63,63,24,6,63,7,27,181,63,52,44,184,84,182,119,237,63,195,80,55,169,88,6,182,63,178,114,117,128,172,92,237,63,75,107,229,138,210,240,182,63,29,212,65,29,212,65,237,63,204,18,123,109,118,218,183,63,26,91,252,163,44,39,237,63,32,155,49,214,69,195,184,63,116,192,110,143,181,12,237,63,172,51,32,70,66,171,185,63,198,191,68,92,110,242,236,63,99,213,74,58,109,146,186,63,11,155,3,137,86,216,236,63,161,237,176,43,200,120,187,63,231,203,1,150,109,190,236,63,67,199,91,143,84,94,188,63,145,225,94,5,179,164,236,63,93,179,108,214,19,67,189,63,66,138,251,90,38,139,236,63,229,242,42,110,7,39,190,63,28,199,113,28,199,113,236,63,166,98,17,192,48,10,191,63,134,73,13,209,148,88,236,63,186,234,219,49,145,236,191,63,240,248,195,1,143,63,236,63,110,89,202,18,21,103,192,63,28,160,46,57,181,38,236,63,89,142,208,124,126,215,192,63,224,192,129,3,7,14,236,63,172,66,103,132,133,71,193,63,139,141,134,238,131,245,235,63,160,103,47,213,42,183,193,63,247,6,148,137,43,221,235,63,203,90,10,25,111,38,194,63,123,62,136,101,253,196,235,63,35,245,31,248,82,149,194,63,208,186,193,20,249,172,235,63,210,127,228,24,215,3,195,63,35,255,24,43,30,149,235,63,116,143,30,32,252,113,195,63,139,51,218,61,108,125,235,63,41,198,236,176,194,223,195,63,5,238,190,227,226,101,235,63,30,125,203,108,43,77,196,63,79,27,232,180,129,78,235,63,229,85,154,243,54,186,196,63,206,6,216,74,72,55,235,63,55,180,161,227,229,38,197,63,217,128,108,64,54,32,235,63,133,32,152,217,56,147,197,63,164,34,217,49,75,9,235,63,211,147,167,112,48,255,197,63,40,175,161,188,134,242,234,63,80,173,114,66,205,106,198,63,94,144,148,127,232,219,234,63,28,210,25,231,15,214,198,63,27,112,197,26,112,197,234,63,164,55,64,245,248,64,199,63,253,235,135,47,29,175,234,63,9,217,16,2,137,171,199,63,190,99,106,96,239,152,234,63,234,87,67,161,192,21,200,63,89,225,48,81,230,130,234,63,16,201,32,101,160,127,200,63,109,26,208,166,1,109,234,63,64,109,136,222,40,233,200,63,74,138,104,7,65,87,234,63,180,86,244,156,90,82,201,63,26,164,65,26,164,65,234,63,131,251,125,46,54,187,201,63,160,28,197,135,42,44,234,63,99,181,226,31,188,35,202,63,2,75,122,249,211,22,234,63,24,47,136,252,236,139,202,63,26,160,1,26,160,1,234,63,242,191,128,78,201,243,202,63,217,51,16,149,142,236,233,63,164,181,143,158,81,91,203,63,45,104,107,23,159,215,233,63,214,140,45,116,134,194,203,63,2,161,228,78,209,194,233,63,192,24,140,85,104,41,204,63,218,16,85,234,36,174,233,63,33,154,154,199,247,143,204,63,154,153,153,153,153,153,233,63,220,197,9,78,53,246,204,63,255,192,142,13,47,133,233,63,145,187,79,107,33,92,205,63,114,184,12,248,228,112,233,63,125,236,171,160,188,193,205,63,174,119,227,11,187,92,233,63,229,242,42,110,7,39,206,63,224,233,214,252,176,72,233,63,95,90,170,82,2,140,206,63,230,44,155,127,198,52,233,63,54,89,220,203,173,240,206,63,41,226,208,73,251,32,233,63,55,123,75,86,10,85,207,63,213,144,1,18,79,13,233,63,42,62,94,109,24,185,207,63,250,24,156,143,193,249,232,63,28,80,173,69,108,14,208,63,63,55,241,122,82,230,232,63,64,208,180,148,37,64,208,63,211,24,48,141,1,211,232,63,13,89,205,95,184,113,208,63,58,255,98,128,206,191,232,63,227,144,115,226,36,163,208,63,170,243,107,15,185,172,232,63,75,183,154,87,107,212,208,63,156,137,1,246,192,153,232,63,213,74,174,249,139,5,209,63,74,176,171,240,229,134,232,63,176,168,147,2,135,54,209,63,185,146,192,188,39,116,232,63,14,166,171,171,92,103,209,63,24,134,97,24,134,97,232,63,111,35,212,45,13,152,209,63,20,6,120,194,0,79,232,63,250,153,105,193,152,200,209,63,221,190,178,122,151,60,232,63,242,162,72,158,255,248,209,63,160,164,130,1,74,42,232,63,101,121,207,251,65,41,210,63,24,24,24,24,24,24,232,63,57,118,223,16,96,89,210,63,6,24,96,128,1,6,232,63,163,134,222,19,90,137,210,63,64,127,1,253,5,244,231,63,36,157,184,58,48,185,210,63,29,79,90,81,37,226,231,63,48,29,225,186,226,232,210,63,244,5,125,65,95,208,231,63,132,65,84,201,113,24,211,63,124,1,46,146,179,190,231,63,84,125,152,154,221,71,211,63,195,236,224,8,34,173,231,63,90,216,191,98,38,119,211,63,139,57,182,107,170,155,231,63,233,69,105,85,76,166,211,63,200,164,120,129,76,138,231,63,15,247,193,165,79,213,211,63,13,198,154,17,8,121,231,63,227,167,134,134,48,4,212,63,177,169,52,228,220,103,231,63,19,232,4,42,239,50,212,63,109,117,1,194,202,86,231,63,194,94,28,194,139,97,212,63,70,23,93,116,209,69,231,63,208,9,64,128,6,144,212,63,141,254,65,197,240,52,231,63,160,120,119,149,95,190,212,63,188,222,70,127,40,36,231,63,105,2,96,50,151,236,212,63,9,124,156,109,120,19,231,63,45,248,45,135,173,26,213,63,112,129,11,92,224,2,231,63,98,210,173,195,162,72,213,63,23,96,242,22,96,242,230,63,108,90,69,23,119,118,213,63,199,55,67,107,247,225,230,63,225,207,244,176,42,164,213,63,97,200,129,38,166,209,230,63,202,9,88,191,189,209,213,63,23,108,193,22,108,193,230,63,211,147,167,112,48,255,213,63,61,26,163,10,73,177,230,63,149,199,185,242,130,44,214,63,144,114,83,209,60,161,230,63,242,225,3,115,181,89,214,63,192,208,136,58,71,145,230,63,174,20,155,30,200,134,214,63,23,104,129,22,104,129,230,63,61,148,53,34,187,179,214,63,26,103,1,54,159,113,230,63,227,161,43,170,142,224,214,63,249,34,81,106,236,97,230,63,53,146,120,226,66,13,215,63,163,74,59,133,79,82,230,63,6,208,187,246,215,57,215,63,100,33,11,89,200,66,230,63,206,219,57,18,78,102,215,63,222,192,138,184,86,51,230,63,162,71,221,95,165,146,215,63,64,98,1,119,250,35,230,63,191,175,55,10,222,190,215,63,148,174,49,104,179,20,230,63,195,175,130,59,248,234,215,63,6,22,88,96,129,5,230,63,149,212,160,29,244,22,216,63,252,45,41,52,100,246,229,63,23,139,30,218,209,66,216,63,231,21,208,184,91,231,229,63,160,11,51,154,145,110,216,63,165,226,236,195,103,216,229,63,90,66,193,134,51,154,216,63,87,16,147,43,136,201,229,63,138,180,88,200,183,197,216,63,145,250,71,198,188,186,229,63,199,98,54,135,30,241,216,63,192,90,1,107,5,172,229,63,61,168,69,235,103,28,217,63,170,204,35,241,97,157,229,63,250,22,33,28,148,71,217,63,237,88,129,48,210,142,229,63,88,81,19,65,163,114,217,63,96,5,88,1,86,128,229,63,138,224,23,129,149,157,217,63,58,107,80,60,237,113,229,63,98,8,220,2,107,200,217,63,226,82,124,186,151,99,229,63,75,152,191,236,35,243,217,63,85,85,85,85,85,85,229,63,149,185,213,100,192,29,218,63,254,130,187,230,37,71,229,63,10,187,229,144,64,72,218,63,235,15,244,72,9,57,229,63,234,217,107,150,164,114,218,63,75,5,168,86,255,42,229,63,73,8,154,154,236,156,218,63,21,248,226,234,7,29,229,63,228,176,88,194,24,199,218,63,197,196,17,225,34,15,229,63,107,120,71,50,41,241,218,63,21,80,1,21,80,1,229,63,91,252,189,14,30,27,219,63,155,76,221,98,143,243,228,63,98,143,204,123,247,68,219,63,57,5,47,167,224,229,228,63,93,243,60,157,181,110,219,63,76,44,220,190,67,216,228,63,251,16,147,150,88,152,219,63,110,175,37,135,184,202,228,63,10,173,13,139,224,193,219,63,225,143,166,221,62,189,228,63,123,27,167,157,77,235,219,63,91,191,82,160,214,175,228,63,38,240,21,241,159,20,220,63,74,1,118,173,127,162,228,63,77,173,205,167,215,61,220,63,103,208,178,227,57,149,228,63,247,111,255,227,244,102,220,63,128,72,1,34,5,136,228,63,33,154,154,199,247,143,220,63,123,20,174,71,225,122,228,63,201,122,77,116,224,184,220,63,102,96,89,52,206,109,228,63,235,243,133,11,175,225,220,63,154,207,245,199,203,96,228,63,100,30,114,174,99,10,221,63,202,118,199,226,217,83,228,63,213,235,0,126,254,50,221,63,251,217,98,101,248,70,228,63,131,198,226,154,127,91,221,63,77,238,171,48,39,58,228,63,62,47,138,37,231,131,221,63,135,31,213,37,102,45,228,63,84,89,44,62,53,172,221,63,81,89,94,38,181,32,228,63,160,196,193,4,106,212,221,63,20,20,20,20,20,20,228,63,181,213,6,153,133,252,221,63,102,101,14,209,130,7,228,63,38,108,124,26,136,36,222,63,251,19,176,63,1,251,227,63,4,119,104,168,113,76,222,63,7,175,165,66,143,238,227,63,135,135,214,97,66,116,222,63,2,169,228,188,44,226,227,63,245,97,152,101,250,155,222,63,198,117,170,145,217,213,227,63,192,140,70,210,153,195,222,63,231,171,123,164,149,201,227,63,244,221,64,198,32,235,222,63,85,41,35,217,96,189,227,63,236,6,175,95,143,18,223,63,20,59,177,19,59,177,227,63,91,30,129,188,229,57,223,63,34,200,122,56,36,165,227,63,172,40,112,250,35,97,223,63,99,127,24,44,28,153,227,63,194,158,254,54,74,136,223,63,142,8,102,211,34,141,227,63,30,243,120,143,88,175,223,63,20,56,129,19,56,129,227,63,113,21,246,32,79,214,223,63,238,69,201,209,91,117,227,63,152,244,87,8,46,253,223,63,72,7,222,243,141,105,227,63,138,255,37,177,250,17,224,63,248,42,159,95,206,93,227,63,254,208,165,165,82,37,224,63,193,120,43,251,28,82,227,63,59,99,206,239,158,56,224,63,70,19,224,172,121,70,227,63,210,38,169,157,223,75,224,63,178,188,87,91,228,58,227,63,156,69,38,189,20,95,224,63,250,29,106,237,92,47,227,63,64,223,28,92,62,114,224,63,191,16,43,74,227,35,227,63,14,69,75,136,92,133,224,63,182,235,233,88,119,24,227,63,32,53,87,79,111,152,224,63,144,209,48,1,25,13,227,63,209,20,206,190,118,171,224,63,96,2,196,42,200,1,227,63,130,42,37,228,114,190,224,63,104,47,161,189,132,246,226,63,183,214,185,204,99,209,224,63,75,209,254,161,78,235,226,63,139,204,209,133,73,228,224,63,151,128,75,192,37,224,226,63,125,73,155,28,36,247,224,63,160,80,45,1,10,213,226,63,150,76,45,158,243,9,225,63,160,44,129,77,251,201,226,63,248,204,135,23,184,28,225,63,17,55,90,142,249,190,226,63,188,239,147,149,113,47,225,63,64,43,1,173,4,180,226,63,68,61,36,37,32,66,225,63,5,193,243,146,28,169,226,63,233,213,244,210,195,84,225,63,158,18,228,41,65,158,226,63,14,166,171,171,92,103,225,63,165,4,184,91,114,147,226,63,160,153,216,187,234,121,225,63,19,176,136,18,176,136,226,63,6,207,245,15,110,140,225,63,77,206,161,56,250,125,226,63,110,201,103,180,230,158,225,63,53,39,129,184,80,115,226,63,158,162,125,181,84,177,225,63,39,1,214,124,179,104,226,63,36,60,113,31,184,195,225,63,241,146,128,112,34,94,226,63,3,112,103,254,16,214,225,63,178,119,145,126,157,83,226,63,208,64,112,94,95,232,225,63,146,36,73,146,36,73,226,63,76,9,135,75,163,250,225,63,91,96,23,151,183,62,226,63,109,171,146,209,220,12,226,63,223,188,154,120,86,52,226,63,235,190,101,252,11,31,226,63,42,18,160,34,1,42,226,63,66,191,190,215,48,49,226,63,120,251,33,129,183,31,226,63,51,57,72,111,75,67,226,63,230,85,72,128,121,21,226,63,203,247,152,206,91,85,226,63,217,192,103,12,71,11,226,63,223,48,52,1,98,103,226,63,18,32,1,18,32,1,226,63,26,177,137,18,94,121,226,63,112,31,193,125,4,247,225,63,130,7,246,13,80,139,226,63,76,184,127,60,244,236,225,63,138,176,194,254,55,157,226,63,116,184,63,59,239,226,225,63,173,64,38,240,21,175,226,63,189,74,46,103,245,216,225,63,139,142,68,237,233,192,226,63,29,129,162,173,6,207,225,63,157,220,46,1,180,210,226,63,89,224,28,252,34,197,225,63,104,2,228,54,116,228,226,63,41,237,70,64,74,187,225,63,70,149,80,153,42,246,226,63,227,186,242,103,124,177,225,63,190,16,79,51,215,7,227,63,150,123,26,97,185,167,225,63,106,254,167,15,122,25,227,63,158,17,224,25,1,158,225,63,113,29,18,57,19,43,227,63,156,162,140,128,83,148,225,63,148,137,50,186,162,60,227,63,219,43,144,131,176,138,225,63,211,225,156,157,40,78,227,63,18,24,129,17,24,129,225,63,160,110,211,237,164,95,227,63,132,214,27,25,138,119,225,63,181,71,71,181,23,113,227,63,121,115,66,137,6,110,225,63,126,121,88,254,128,130,227,63,1,50,252,80,141,100,225,63,25,42,86,211,224,147,227,63,13,39,117,95,30,91,225,63,249,189,126,62,55,165,227,63,201,213,253,163,185,81,225,63,34,252,255,73,132,182,227,63,59,205,10,14,95,72,225,63,5,50,247,255,199,199,227,63,36,71,52,141,14,63,225,63,250,86,113,106,2,217,227,63,17,200,53,17,200,53,225,63,91,47,107,147,51,234,227,63,172,192,237,137,139,44,225,63,66,111,209,132,91,251,227,63,51,48,93,231,88,35,225,63,233,220,128,72,122,12,228,63,38,72,167,25,48,26,225,63,174,114,70,232,143,29,228,63,17,17,17,17,17,17,225,63,191,128,223,109,156,46,228,63,128,16,1,190,251,7,225,63,103,206,249,226,159,63,228,63,17,240,254,16,240,254,224,63,10,187,51,81,154,80,228,63,162,37,179,250,237,245,224,63,194,94,28,194,139,97,228,63,144,156,230,107,245,236,224,63,173,170,51,63,116,114,228,63,17,96,130,85,6,228,224,63,223,136,234,209,83,131,228,63,150,70,143,168,32,219,224,63,7,252,162,131,42,148,228,63,58,158,53,86,68,210,224,63,187,62,176,93,248,164,228,63,59,218,188,79,113,201,224,63,115,226,86,105,189,181,228,63,113,65,139,134,167,192,224,63,57,238,204,175,121,198,228,63,200,157,37,236,230,183,224,63,0,253,57,58,45,215,228,63,181,236,46,114,47,175,224,63,176,91,183,17,216,231,228,63,167,16,104,10,129,166,224,63,232,38,80,63,122,248,228,63,96,131,175,166,219,157,224,63,107,104,1,204,19,9,229,63,84,9,1,57,63,149,224,63,70,52,186,192,164,25,229,63,226,101,117,179,171,140,224,63,170,197,91,38,45,42,229,63,132,16,66,8,33,132,224,63,124,155,185,5,173,58,229,63,226,234,184,41,159,123,224,63,151,148,153,103,36,75,229,63,198,247,71,10,38,115,224,63,205,11,180,84,147,91,229,63,251,18,121,156,181,106,224,63,153,243,179,213,249,107,229,63,252,169,241,210,77,98,224,63,144,241,54,243,87,124,229,63,134,117,114,160,238,89,224,63,137,121,205,181,173,140,229,63,4,52,215,247,151,81,224,63,125,232,250,37,251,156,229,63,197,100,22,204,73,73,224,63,44,159,53,76,64,173,229,63,16,4,65,16,4,65,224,63,115,28,231,48,125,189,229,63,252,71,130,183,198,56,224,63,100,23,108,220,177,205,229,63,26,94,31,181,145,48,224,63,35,153,20,87,222,221,229,63,233,41,119,252,100,40,224,63,117,22,36,169,2,238,229,63,8,4,2,129,64,32,224,63,24,137,209,218,30,254,229,63,55,122,81,54,36,24,224,63,216,136,71,244,50,14,230,63,16,16,16,16,16,16,224,63,239,57,250,254,66,46,230,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,74,0,0,252,2,0,0,253,2,0,0,3,0,0,0,200,0,0,0,201,0,0,0,43,0,0,0,3,0,0,0,199,0,0,0,45,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,77,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,74,0,0,4,3,0,0,5,3,0,0,3,0,0,0,200,0,0,0,201,0,0,0,43,0,0,0,3,0,0,0,202,0,0,0,45,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,77,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,75,0,0,15,3,0,0,16,3,0,0,3,0,0,0,200,0,0,0,201,0,0,0,43,0,0,0,3,0,0,0,209,0,0,0,45,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,77,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,192,11,177,162,10,240,111,63,32,224,31,224,31,224,239,63,136,103,16,107,42,224,127,63,240,7,252,1,127,192,239,63,118,10,129,95,71,220,135,63,18,250,1,170,28,161,239,63,227,3,252,176,168,192,143,63,32,248,129,31,248,129,239,63,116,165,70,67,164,206,147,63,181,219,160,172,16,99,239,63,26,177,213,7,27,185,151,63,113,66,74,158,101,68,239,63,151,145,175,39,192,159,155,63,181,10,35,68,246,37,239,63,0,51,120,14,155,130,159,63,8,31,124,240,193,7,239,63,127,217,35,137,217,176,161,63,2,142,69,248,199,233,238,63,95,189,254,185,135,158,163,63,192,236,1,179,7,204,238,63,212,228,200,175,91,138,165,63,235,1,186,122,128,174,238,63,252,220,50,246,88,116,167,63,103,183,240,171,49,145,238,63,235,227,200,14,131,92,169,63,228,80,151,165,26,116,238,63,190,113,25,113,221,66,171,63,116,229,1,201,58,87,238,63,82,11,219,138,107,39,173,63,115,26,220,121,145,58,238,63,166,98,17,192,48,10,175,63,30,30,30,30,30,30,238,63,113,228,152,53,152,117,176,63,30,224,1,30,224,1,238,63,224,122,163,238,54,101,177,63,138,134,248,227,214,229,237,63,22,20,10,47,246,83,178,63,202,29,160,220,1,202,237,63,208,209,27,150,215,65,179,63,219,129,185,118,96,174,237,63,240,70,166,190,220,46,180,63,138,127,30,35,242,146,237,63,63,24,6,63,7,27,181,63,52,44,184,84,182,119,237,63,195,80,55,169,88,6,182,63,178,114,117,128,172,92,237,63,75,107,229,138,210,240,182,63,29,212,65,29,212,65,237,63,204,18,123,109,118,218,183,63,26,91,252,163,44,39,237,63,32,155,49,214,69,195,184,63,116,192,110,143,181,12,237,63,172,51,32,70,66,171,185,63,198,191,68,92,110,242,236,63,99,213,74,58,109,146,186,63,11,155,3,137,86,216,236,63,161,237,176,43,200,120,187,63,231,203,1,150,109,190,236,63,67,199,91,143,84,94,188,63,145,225,94,5,179,164,236,63,93,179,108,214,19,67,189,63,66,138,251,90,38,139,236,63,229,242,42,110,7,39,190,63,28,199,113,28,199,113,236,63,166,98,17,192,48,10,191,63,134,73,13,209,148,88,236,63,186,234,219,49,145,236,191,63,240,248,195,1,143,63,236,63,110,89,202,18,21,103,192,63,28,160,46,57,181,38,236,63,89,142,208,124,126,215,192,63,224,192,129,3,7,14,236,63,172,66,103,132,133,71,193,63,139,141,134,238,131,245,235,63,160,103,47,213,42,183,193,63,247,6,148,137,43,221,235,63,203,90,10,25,111,38,194,63,123,62,136,101,253,196,235,63,35,245,31,248,82,149,194,63,208,186,193,20,249,172,235,63,210,127,228,24,215,3,195,63,35,255,24,43,30,149,235,63,116,143,30,32,252,113,195,63,139,51,218,61,108,125,235,63,41,198,236,176,194,223,195,63,5,238,190,227,226,101,235,63,30,125,203,108,43,77,196,63,79,27,232,180,129,78,235,63,229,85,154,243,54,186,196,63,206,6,216,74,72,55,235,63,55,180,161,227,229,38,197,63,217,128,108,64,54,32,235,63,133,32,152,217,56,147,197,63,164,34,217,49,75,9,235,63,211,147,167,112,48,255,197,63,40,175,161,188,134,242,234,63,80,173,114,66,205,106,198,63,94,144,148,127,232,219,234,63,28,210,25,231,15,214,198,63,27,112,197,26,112,197,234,63,164,55,64,245,248,64,199,63,253,235,135,47,29,175,234,63,9,217,16,2,137,171,199,63,190,99,106,96,239,152,234,63,234,87,67,161,192,21,200,63,89,225,48,81,230,130,234,63,16,201,32,101,160,127,200,63,109,26,208,166,1,109,234,63,64,109,136,222,40,233,200,63,74,138,104,7,65,87,234,63,180,86,244,156,90,82,201,63,26,164,65,26,164,65,234,63,131,251,125,46,54,187,201,63,160,28,197,135,42,44,234,63,99,181,226,31,188,35,202,63,2,75,122,249,211,22,234,63,24,47,136,252,236,139,202,63,26,160,1,26,160,1,234,63,242,191,128,78,201,243,202,63,217,51,16,149,142,236,233,63,164,181,143,158,81,91,203,63,45,104,107,23,159,215,233,63,214,140,45,116,134,194,203,63,2,161,228,78,209,194,233,63,192,24,140,85,104,41,204,63,218,16,85,234,36,174,233,63,33,154,154,199,247,143,204,63,154,153,153,153,153,153,233,63,220,197,9,78,53,246,204,63,255,192,142,13,47,133,233,63,145,187,79,107,33,92,205,63,114,184,12,248,228,112,233,63,125,236,171,160,188,193,205,63,174,119,227,11,187,92,233,63,229,242,42,110,7,39,206,63,224,233,214,252,176,72,233,63,95,90,170,82,2,140,206,63,230,44,155,127,198,52,233,63,54,89,220,203,173,240,206,63,41,226,208,73,251,32,233,63,55,123,75,86,10,85,207,63,213,144,1,18,79,13,233,63,42,62,94,109,24,185,207,63,250,24,156,143,193,249,232,63,28,80,173,69,108,14,208,63,63,55,241,122,82,230,232,63,64,208,180,148,37,64,208,63,211,24,48,141,1,211,232,63,13,89,205,95,184,113,208,63,58,255,98,128,206,191,232,63,227,144,115,226,36,163,208,63,170,243,107,15,185,172,232,63,75,183,154,87,107,212,208,63,156,137,1,246,192,153,232,63,213,74,174,249,139,5,209,63,74,176,171,240,229,134,232,63,176,168,147,2,135,54,209,63,185,146,192,188,39,116,232,63,14,166,171,171,92,103,209,63,24,134,97,24,134,97,232,63,111,35,212,45,13,152,209,63,20,6,120,194,0,79,232,63,250,153,105,193,152,200,209,63,221,190,178,122,151,60,232,63,242,162,72,158,255,248,209,63,160,164,130,1,74,42,232,63,101,121,207,251,65,41,210,63,24,24,24,24,24,24,232,63,57,118,223,16,96,89,210,63,6,24,96,128,1,6,232,63,163,134,222,19,90,137,210,63,64,127,1,253,5,244,231,63,36,157,184,58,48,185,210,63,29,79,90,81,37,226,231,63,48,29,225,186,226,232,210,63,244,5,125,65,95,208,231,63,132,65,84,201,113,24,211,63,124,1,46,146,179,190,231,63,84,125,152,154,221,71,211,63,195,236,224,8,34,173,231,63,90,216,191,98,38,119,211,63,139,57,182,107,170,155,231,63,233,69,105,85,76,166,211,63,200,164,120,129,76,138,231,63,15,247,193,165,79,213,211,63,13,198,154,17,8,121,231,63,227,167,134,134,48,4,212,63,177,169,52,228,220,103,231,63,19,232,4,42,239,50,212,63,109,117,1,194,202,86,231,63,194,94,28,194,139,97,212,63,70,23,93,116,209,69,231,63,208,9,64,128,6,144,212,63,141,254,65,197,240,52,231,63,160,120,119,149,95,190,212,63,188,222,70,127,40,36,231,63,105,2,96,50,151,236,212,63,9,124,156,109,120,19,231,63,45,248,45,135,173,26,213,63,112,129,11,92,224,2,231,63,98,210,173,195,162,72,213,63,23,96,242,22,96,242,230,63,108,90,69,23,119,118,213,63,199,55,67,107,247,225,230,63,225,207,244,176,42,164,213,63,97,200,129,38,166,209,230,63,202,9,88,191,189,209,213,63,23,108,193,22,108,193,230,63,211,147,167,112,48,255,213,63,61,26,163,10,73,177,230,63,149,199,185,242,130,44,214,63,144,114,83,209,60,161,230,63,242,225,3,115,181,89,214,63,192,208,136,58,71,145,230,63,174,20,155,30,200,134,214,63,23,104,129,22,104,129,230,63,61,148,53,34,187,179,214,63,26,103,1,54,159,113,230,63,227,161,43,170,142,224,214,63,249,34,81,106,236,97,230,63,53,146,120,226,66,13,215,63,163,74,59,133,79,82,230,63,6,208,187,246,215,57,215,63,100,33,11,89,200,66,230,63,206,219,57,18,78,102,215,63,222,192,138,184,86,51,230,63,162,71,221,95,165,146,215,63,64,98,1,119,250,35,230,63,191,175,55,10,222,190,215,63,148,174,49,104,179,20,230,63,195,175,130,59,248,234,215,63,6,22,88,96,129,5,230,63,149,212,160,29,244,22,216,63,252,45,41,52,100,246,229,63,23,139,30,218,209,66,216,63,231,21,208,184,91,231,229,63,160,11,51,154,145,110,216,63,165,226,236,195,103,216,229,63,90,66,193,134,51,154,216,63,87,16,147,43,136,201,229,63,138,180,88,200,183,197,216,63,145,250,71,198,188,186,229,63,199,98,54,135,30,241,216,63,192,90,1,107,5,172,229,63,61,168,69,235,103,28,217,63,170,204,35,241,97,157,229,63,250,22,33,28,148,71,217,63,237,88,129,48,210,142,229,63,88,81,19,65,163,114,217,63,96,5,88,1,86,128,229,63,138,224,23,129,149,157,217,63,58,107,80,60,237,113,229,63,98,8,220,2,107,200,217,63,226,82,124,186,151,99,229,63,75,152,191,236,35,243,217,63,85,85,85,85,85,85,229,63,149,185,213,100,192,29,218,63,254,130,187,230,37,71,229,63,10,187,229,144,64,72,218,63,235,15,244,72,9,57,229,63,234,217,107,150,164,114,218,63,75,5,168,86,255,42,229,63,73,8,154,154,236,156,218,63,21,248,226,234,7,29,229,63,228,176,88,194,24,199,218,63,197,196,17,225,34,15,229,63,107,120,71,50,41,241,218,63,21,80,1,21,80,1,229,63,91,252,189,14,30,27,219,63,155,76,221,98,143,243,228,63,98,143,204,123,247,68,219,63,57,5,47,167,224,229,228,63,93,243,60,157,181,110,219,63,76,44,220,190,67,216,228,63,251,16,147,150,88,152,219,63,110,175,37,135,184,202,228,63,10,173,13,139,224,193,219,63,225,143,166,221,62,189,228,63,123,27,167,157,77,235,219,63,91,191,82,160,214,175,228,63,38,240,21,241,159,20,220,63,74,1,118,173,127,162,228,63,77,173,205,167,215,61,220,63,103,208,178,227,57,149,228,63,247,111,255,227,244,102,220,63,128,72,1,34,5,136,228,63,33,154,154,199,247,143,220,63,123,20,174,71,225,122,228,63,201,122,77,116,224,184,220,63,102,96,89,52,206,109,228,63,235,243,133,11,175,225,220,63,154,207,245,199,203,96,228,63,100,30,114,174,99,10,221,63,202,118,199,226,217,83,228,63,213,235,0,126,254,50,221,63,251,217,98,101,248,70,228,63,131,198,226,154,127,91,221,63,77,238,171,48,39,58,228,63,62,47,138,37,231,131,221,63,135,31,213,37,102,45,228,63,84,89,44,62,53,172,221,63,81,89,94,38,181,32,228,63,160,196,193,4,106,212,221,63,20,20,20,20,20,20,228,63,181,213,6,153,133,252,221,63,102,101,14,209,130,7,228,63,38,108,124,26,136,36,222,63,251,19,176,63,1,251,227,63,4,119,104,168,113,76,222,63,7,175,165,66,143,238,227,63,135,135,214,97,66,116,222,63,2,169,228,188,44,226,227,63,245,97,152,101,250,155,222,63,198,117,170,145,217,213,227,63,192,140,70,210,153,195,222,63,231,171,123,164,149,201,227,63,244,221,64,198,32,235,222,63,85,41,35,217,96,189,227,63,236,6,175,95,143,18,223,63,20,59,177,19,59,177,227,63,91,30,129,188,229,57,223,63,34,200,122,56,36,165,227,63,172,40,112,250,35,97,223,63,99,127,24,44,28,153,227,63,194,158,254,54,74,136,223,63,142,8,102,211,34,141,227,63,30,243,120,143,88,175,223,63,20,56,129,19,56,129,227,63,113,21,246,32,79,214,223,63,238,69,201,209,91,117,227,63,152,244,87,8,46,253,223,63,72,7,222,243,141,105,227,63,138,255,37,177,250,17,224,63,248,42,159,95,206,93,227,63,254,208,165,165,82,37,224,63,193,120,43,251,28,82,227,63,59,99,206,239,158,56,224,63,70,19,224,172,121,70,227,63,210,38,169,157,223,75,224,63,178,188,87,91,228,58,227,63,156,69,38,189,20,95,224,63,250,29,106,237,92,47,227,63,64,223,28,92,62,114,224,63,191,16,43,74,227,35,227,63,14,69,75,136,92,133,224,63,182,235,233,88,119,24,227,63,32,53,87,79,111,152,224,63,144,209,48,1,25,13,227,63,209,20,206,190,118,171,224,63,96,2,196,42,200,1,227,63,130,42,37,228,114,190,224,63,104,47,161,189,132,246,226,63,183,214,185,204,99,209,224,63,75,209,254,161,78,235,226,63,139,204,209,133,73,228,224,63,151,128,75,192,37,224,226,63,125,73,155,28,36,247,224,63,160,80,45,1,10,213,226,63,150,76,45,158,243,9,225,63,160,44,129,77,251,201,226,63,248,204,135,23,184,28,225,63,17,55,90,142,249,190,226,63,188,239,147,149,113,47,225,63,64,43,1,173,4,180,226,63,68,61,36,37,32,66,225,63,5,193,243,146,28,169,226,63,233,213,244,210,195,84,225,63,158,18,228,41,65,158,226,63,14,166,171,171,92,103,225,63,165,4,184,91,114,147,226,63,160,153,216,187,234,121,225,63,19,176,136,18,176,136,226,63,6,207,245,15,110,140,225,63,77,206,161,56,250,125,226,63,110,201,103,180,230,158,225,63,53,39,129,184,80,115,226,63,158,162,125,181,84,177,225,63,39,1,214,124,179,104,226,63,36,60,113,31,184,195,225,63,241,146,128,112,34,94,226,63,3,112,103,254,16,214,225,63,178,119,145,126,157,83,226,63,208,64,112,94,95,232,225,63,146,36,73,146,36,73,226,63,76,9,135,75,163,250,225,63,91,96,23,151,183,62,226,63,109,171,146,209,220,12,226,63,223,188,154,120,86,52,226,63,235,190,101,252,11,31,226,63,42,18,160,34,1,42,226,63,66,191,190,215,48,49,226,63,120,251,33,129,183,31,226,63,51,57,72,111,75,67,226,63,230,85,72,128,121,21,226,63,203,247,152,206,91,85,226,63,217,192,103,12,71,11,226,63,223,48,52,1,98,103,226,63,18,32,1,18,32,1,226,63,26,177,137,18,94,121,226,63,112,31,193,125,4,247,225,63,130,7,246,13,80,139,226,63,76,184,127,60,244,236,225,63,138,176,194,254,55,157,226,63,116,184,63,59,239,226,225,63,173,64,38,240,21,175,226,63,189,74,46,103,245,216,225,63,139,142,68,237,233,192,226,63,29,129,162,173,6,207,225,63,157,220,46,1,180,210,226,63,89,224,28,252,34,197,225,63,104,2,228,54,116,228,226,63,41,237,70,64,74,187,225,63,70,149,80,153,42,246,226,63,227,186,242,103,124,177,225,63,190,16,79,51,215,7,227,63,150,123,26,97,185,167,225,63,106,254,167,15,122,25,227,63,158,17,224,25,1,158,225,63,113,29,18,57,19,43,227,63,156,162,140,128,83,148,225,63,148,137,50,186,162,60,227,63,219,43,144,131,176,138,225,63,211,225,156,157,40,78,227,63,18,24,129,17,24,129,225,63,160,110,211,237,164,95,227,63,132,214,27,25,138,119,225,63,181,71,71,181,23,113,227,63,121,115,66,137,6,110,225,63,126,121,88,254,128,130,227,63,1,50,252,80,141,100,225,63,25,42,86,211,224,147,227,63,13,39,117,95,30,91,225,63,249,189,126,62,55,165,227,63,201,213,253,163,185,81,225,63,34,252,255,73,132,182,227,63,59,205,10,14,95,72,225,63,5,50,247,255,199,199,227,63,36,71,52,141,14,63,225,63,250,86,113,106,2,217,227,63,17,200,53,17,200,53,225,63,91,47,107,147,51,234,227,63,172,192,237,137,139,44,225,63,66,111,209,132,91,251,227,63,51,48,93,231,88,35,225,63,233,220,128,72,122,12,228,63,38,72,167,25,48,26,225,63,174,114,70,232,143,29,228,63,17,17,17,17,17,17,225,63,191,128,223,109,156,46,228,63,128,16,1,190,251,7,225,63,103,206,249,226,159,63,228,63,17,240,254,16,240,254,224,63,10,187,51,81,154,80,228,63,162,37,179,250,237,245,224,63,194,94,28,194,139,97,228,63,144,156,230,107,245,236,224,63,173,170,51,63,116,114,228,63,17,96,130,85,6,228,224,63,223,136,234,209,83,131,228,63,150,70,143,168,32,219,224,63,7,252,162,131,42,148,228,63,58,158,53,86,68,210,224,63,187,62,176,93,248,164,228,63,59,218,188,79,113,201,224,63,115,226,86,105,189,181,228,63,113,65,139,134,167,192,224,63,57,238,204,175,121,198,228,63,200,157,37,236,230,183,224,63,0,253,57,58,45,215,228,63,181,236,46,114,47,175,224,63,176,91,183,17,216,231,228,63,167,16,104,10,129,166,224,63,232,38,80,63,122,248,228,63,96,131,175,166,219,157,224,63,107,104,1,204,19,9,229,63,84,9,1,57,63,149,224,63,70,52,186,192,164,25,229,63,226,101,117,179,171,140,224,63,170,197,91,38,45,42,229,63,132,16,66,8,33,132,224,63,124,155,185,5,173,58,229,63,226,234,184,41,159,123,224,63,151,148,153,103,36,75,229,63,198,247,71,10,38,115,224,63,205,11,180,84,147,91,229,63,251,18,121,156,181,106,224,63,153,243,179,213,249,107,229,63,252,169,241,210,77,98,224,63,144,241,54,243,87,124,229,63,134,117,114,160,238,89,224,63,137,121,205,181,173,140,229,63,4,52,215,247,151,81,224,63,125,232,250,37,251,156,229,63,197,100,22,204,73,73,224,63,44,159,53,76,64,173,229,63,16,4,65,16,4,65,224,63,115,28,231,48,125,189,229,63,252,71,130,183,198,56,224,63,100,23,108,220,177,205,229,63,26,94,31,181,145,48,224,63,35,153,20,87,222,221,229,63,233,41,119,252,100,40,224,63,117,22,36,169,2,238,229,63,8,4,2,129,64,32,224,63,24,137,209,218,30,254,229,63,55,122,81,54,36,24,224,63,216,136,71,244,50,14,230,63,16,16,16,16,16,16,224,63,239,57,250,254,66,46,230,63,0,0,0,0,0,0,224,63,156,253,1,0,174,77,2,0,156,253,1,0,190,77,2,0,156,253,1,0,209,77,2,0,156,253,1,0,66,78,2,0,104,254,1,0,22,78,2,0,0,0,0,0,1,0,0,0,200,33,0,0,0,0,0,0,104,254,1,0,242,77,2,0,0,0,0,0,1,0,0,0,208,33,0,0,0,0,0,0,48,254,1,0,103,78,2,0,0,0,0,0,232,33,0,0,48,254,1,0,140,78,2,0,1,0,0,0,232,33,0,0,156,253,1,0,201,78,2,0,104,254,1,0,11,79,2,0,0,0,0,0,1,0,0,0,200,33,0,0,0,0,0,0,104,254,1,0,231,78,2,0,0,0,0,0,1,0,0,0,40,34,0,0,0,0,0,0,48,254,1,0,55,79,2,0,0,0,0,0,64,34,0,0,48,254,1,0,92,79,2,0,1,0,0,0,64,34,0,0,104,254,1,0,183,79,2,0,0,0,0,0,1,0,0,0,200,33,0,0,0,0,0,0,104,254,1,0,147,79,2,0,0,0,0,0,1,0,0,0,120,34,0,0,0,0,0,0,48,254,1,0,227,79,2,0,0,0,0,0,144,34,0,0,48,254,1,0,8,80,2,0,1,0,0,0,144,34,0,0,104,254,1,0,115,80,2,0,0,0,0,0,1,0,0,0,200,33,0,0,0,0,0,0,104,254,1,0,63,80,2,0,0,0,0,0,1,0,0,0,200,34,0,0,0,0,0,0,48,254,1,0,175,80,2,0,0,0,0,0,224,34,0,0,48,254,1,0,228,80,2,0,1,0,0,0,224,34,0,0,156,253,1,0,26,81,2,0,104,254,1,0,88,81,2,0,0,0,0,0,1,0,0,0,200,33,0,0,0,0,0,0,104,254,1,0,42,81,2,0,0,0,0,0,1,0,0,0,32,35,0,0,0,0,0,0,48,254,1,0,142,81,2,0,0,0,0,0,56,35,0,0,48,254,1,0,189,81,2,0,1,0,0,0,56,35,0,0,156,253,1,0,237,81,2,0,104,254,1,0,42,82,2,0,0,0,0,0,1,0,0,0,200,33,0,0,0,0,0,0,104,254,1,0,247,81,2,0,0,0,0,0,1,0,0,0,120,35,0,0,0,0,0,0,48,254,1,0,101,82,2,0,0,0,0,0,144,35,0,0,48,254,1,0,153,82,2,0,1,0,0,0,144,35,0,0,156,253,1,0,206,82,2,0,104,254,1,0,33,83,2,0,0,0,0,0,1,0,0,0,200,33,0,0,0,0,0,0,104,254,1,0,221,82,2,0,0,0,0,0,1,0,0,0,208,35,0,0,0,0,0,0,48,254,1,0,115,83,2,0,0,0,0,0,232,35,0,0,48,254,1,0,184,83,2,0,1,0,0,0,232,35,0,0,104,254,1,0,49,84,2,0,0,0,0,0,1,0,0,0,200,33,0,0,0,0,0,0,104,254,1,0,254,83,2,0,0,0,0,0,1,0,0,0,32,36,0,0,0,0,0,0,48,254,1,0,108,84,2,0,0,0,0,0,56,36,0,0,48,254,1,0,160,84,2,0,1,0,0,0,56,36,0,0,104,254,1,0,6,85,2,0,0,0,0,0,1,0,0,0,200,33,0,0,0,0,0,0,104,254,1,0,213,84,2,0,0,0,0,0,1,0,0,0,112,36,0,0,0,0,0,0,48,254,1,0,63,85,2,0,0,0,0,0,136,36,0,0,48,254,1,0,113,85,2,0,1,0,0,0,136,36,0,0,156,253,1,0,164,85,2,0,104,254,1,0,243,85,2,0,0,0,0,0,1,0,0,0,200,33,0,0,0,0,0,0,104,254,1,0,177,85,2,0,0,0,0,0,1,0,0,0,200,36,0,0,0,0,0,0,48,254,1,0,67,86,2,0,0,0,0,0,224,36,0,0,48,254,1,0,134,86,2,0,1,0,0,0,224,36,0,0,48,254,1,0,202,86,2,0,0,0,0,0,112,35,0,0,48,254,1,0,213,86,2,0,1,0,0,0,112,35,0,0,156,253,1,0,225,86,2,0,156,253,1,0,18,87,2,0,196,253,1,0,1,87,2,0,64,37,0,0,0,0,0,0,196,253,1,0,240,86,2,0,72,37,0,0,0,0,0,0,156,253,1,0,55,87,2,0,156,253,1,0,86,87,2,0,156,253,1,0,117,87,2,0,156,253,1,0,148,87,2,0,156,253,1,0,179,87,2,0,156,253,1,0,210,87,2,0,156,253,1,0,241,87,2,0,156,253,1,0,38,88,2,0,156,253,1,0,86,88,2,0,156,253,1,0,110,88,2,0,156,253,1,0,129,88,2,0,156,253,1,0,144,88,2,0,156,253,1,0,172,88,2,0,156,253,1,0,197,88,2,0,156,253,1,0,18,89,2,0,104,254,1,0,211,88,2,0,0,0,0,0,1,0,0,0,216,37,0,0,0,0,0,0,156,253,1,0,56,89,2,0,76,254,1,0,89,89,2,0,76,254,1,0,102,89,2,0,104,254,1,0,191,91,2,0,0,0,0,0,1,0,0,0,200,33,0,0,0,0,0,0,104,254,1,0,155,91,2,0,0,0,0,0,1,0,0,0,16,38,0,0,0,0,0,0,48,254,1,0,68,92,2,0,0,0,0,0,152,74,0,0,48,254,1,0,95,92,2,0,1,0,0,0,152,74,0,0,156,253,1,0,123,92,2,0,48,254,1,0,159,92,2,0,0,0,0,0,136,71,0,0,48,254,1,0,181,92,2,0,1,0,0,0,136,71,0,0,156,253,1,0,219,92,2,0,196,253,1,0,12,93,2,0,16,40,0,0,0,0,0,0,48,254,1,0,40,93,2,0,0,0,0,0,144,38,0,0,48,254,1,0,69,93,2,0,1,0,0,0,144,38,0,0,196,253,1,0,99,93,2,0,144,38,0,0,0,0,0,0,48,254,1,0,131,93,2,0,0,0,0,0,192,38,0,0,48,254,1,0,164,93,2,0,1,0,0,0,192,38,0,0,156,253,1,0,198,93,2,0,196,253,1,0,251,93,2,0,16,40,0,0,0,0,0,0,48,254,1,0,7,94,2,0,0,0,0,0,248,38,0,0,48,254,1,0,20,94,2,0,1,0,0,0,248,38,0,0,156,253,1,0,34,94,2,0,48,254,1,0,65,94,2,0,0,0,0,0,16,40,0,0,48,254,1,0,82,94,2,0,1,0,0,0,16,40,0,0,48,254,1,0,100,94,2,0,0,0,0,0,232,74,0,0,48,254,1,0,117,94,2,0,1,0,0,0,232,74,0,0,48,254,1,0,135,94,2,0,0,0,0,0,0,75,0,0,48,254,1,0,161,94,2,0,1,0,0,0,0,75,0,0,156,253,1,0,188,94,2,0,156,253,1,0,223,94,2,0,48,254,1,0,248,94,2,0,0,0,0,0,152,39,0,0,48,254,1,0,18,95,2,0,1,0,0,0,152,39,0,0,48,254,1,0,125,95,2,0,0,0,0,0,184,74,0,0,48,254,1,0,153,95,2,0,1,0,0,0,184,74,0,0,156,253,1,0,182,95,2,0,48,254,1,0,219,95,2,0,0,0,0,0,48,75,0,0,48,254,1,0,230,95,2,0,1,0,0,0,48,75],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE);allocate([156,253,1,0,242,95,2,0,156,253,1,0,31,97,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,192,0,0,0,0,0,0,224,193,0,0,0,224,255,255,239,199,255,255,255,255,255,255,239,255,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,192,95,64,0,0,0,0,224,255,239,64,0,0,0,0,192,255,223,64,0,0,192,255,255,255,223,65,0,0,0,224,255,255,239,71,255,255,255,255,255,255,239,127,0,0,0,0,0,0,0,0,156,253,1,0,116,111,2,0,196,253,1,0,166,121,2,0,152,40,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,205,59,127,102,158,160,230,63,204,59,127,102,158,160,230,63,70,141,50,207,107,144,237,63,99,169,174,166,226,125,216,63,176,92,247,207,151,98,239,63,10,166,105,60,184,248,200,63,38,37,209,163,141,216,239,63,44,180,41,188,166,23,185,63,126,109,121,227,33,246,239,63,21,216,13,241,101,31,169,63,13,205,132,96,136,253,239,63,127,102,163,247,85,33,153,63,219,146,155,22,98,255,239,63,135,199,222,252,209,33,137,63,146,138,142,133,216,255,239,63,118,0,103,254,240,33,121,63,2,29,98,33,246,255,239,63,195,164,204,190,248,33,105,63,230,110,88,136,253,255,239,63,66,71,230,174,250,33,89,63,52,26,22,98,255,255,239,63,55,179,236,42,251,33,73,63,117,134,133,216,255,255,239,63,248,78,238,73,251,33,57,63,156,97,33,246,255,255,239,63,2,181,174,81,251,33,41,63,103,88,136,253,255,255,239,63,245,207,158,83,251,33,25,63,26,22,98,255,255,255,239,63,106,215,26,84,251,33,9,63,134,133,216,255,255,255,239,63,72,217,57,84,251,33,249,62,98,33,246,255,255,255,239,63,78,152,65,84,251,33,233,62,88,136,253,255,255,255,239,63,136,124,67,84,251,33,217,62,22,98,255,255,255,255,239,63,196,216,67,84,251,33,201,62,134,216,255,255,255,255,239,63,0,53,68,84,251,33,185,62,33,246,255,255,255,255,239,63,136,124,67,84,251,33,169,62,136,253,255,255,255,255,239,63,136,124,67,84,251,33,153,62,98,255,255,255,255,255,239,63,103,94,70,84,251,33,137,62,217,255,255,255,255,255,239,63,169,154,64,84,251,33,121,62,246,255,255,255,255,255,239,63,36,34,76,84,251,33,105,62,254,255,255,255,255,255,239,63,36,34,76,84,251,33,89,62,255,255,255,255,255,255,239,63,58,4,30,84,251,33,73,62,0,0,0,0,0,0,240,63,15,64,122,84,251,33,57,62,0,0,0,0,0,0,240,63,15,64,122,84,251,33,41,62,196,253,1,0,68,123,2,0,192,42,0,0,0,0,0,0,156,253,1,0,91,123,2,0,196,253,1,0,107,123,2,0,192,42,0,0,0,0,0,0,196,253,1,0,66,124,2,0,152,40,0,0,0,0,0,0,196,253,1,0,136,124,2,0,248,42,0,0,0,0,0,0,156,253,1,0,154,124,2,0,196,253,1,0,170,124,2,0,248,42,0,0,0,0,0,0,196,253,1,0,173,127,2,0,80,48,0,0,0,0,0,0,196,253,1,0,26,128,2,0,80,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,44,180,41,188,166,23,185,63,10,166,105,60,184,248,200,63,5,159,213,46,6,148,210,63,99,169,174,166,226,125,216,63,59,246,6,56,93,43,222,63,200,104,174,57,59,199,225,63,214,29,9,37,243,76,228,63,204,59,127,102,158,160,230,63,65,23,21,107,128,188,232,63,163,161,14,41,102,155,234,63,176,189,128,241,178,56,236,63,70,141,50,207,107,144,237,63,219,45,198,86,65,159,238,63,176,92,247,207,151,98,239,63,37,37,209,163,141,216,239,63,0,0,0,0,0,0,240,63,38,37,209,163,141,216,239,63,176,92,247,207,151,98,239,63,219,45,198,86,65,159,238,63,70,141,50,207,107,144,237,63,177,189,128,241,178,56,236,63,165,161,14,41,102,155,234,63,66,23,21,107,128,188,232,63,205,59,127,102,158,160,230,63,214,29,9,37,243,76,228,63,200,104,174,57,59,199,225,63,63,246,6,56,93,43,222,63,101,169,174,166,226,125,216,63,6,159,213,46,6,148,210,63,23,166,105,60,184,248,200,63,60,180,41,188,166,23,185,63,159,113,189,255,249,165,161,60,43,180,41,188,166,23,185,191,14,166,105,60,184,248,200,191,1,159,213,46,6,148,210,191,97,169,174,166,226,125,216,191,59,246,6,56,93,43,222,191,198,104,174,57,59,199,225,191,212,29,9,37,243,76,228,191,204,59,127,102,158,160,230,191,62,23,21,107,128,188,232,191,163,161,14,41,102,155,234,191,176,189,128,241,178,56,236,191,68,141,50,207,107,144,237,191,218,45,198,86,65,159,238,191,175,92,247,207,151,98,239,191,38,37,209,163,141,216,239,191,0,0,0,0,0,0,240,191,38,37,209,163,141,216,239,191,176,92,247,207,151,98,239,191,219,45,198,86,65,159,238,191,69,141,50,207,107,144,237,191,177,189,128,241,178,56,236,191,165,161,14,41,102,155,234,191,64,23,21,107,128,188,232,191,206,59,127,102,158,160,230,191,218,29,9,37,243,76,228,191,200,104,174,57,59,199,225,191,64,246,6,56,93,43,222,191,110,169,174,166,226,125,216,191,8,159,213,46,6,148,210,191,27,166,105,60,184,248,200,191,37,180,41,188,166,23,185,191,49,244,70,62,15,206,131,63,71,85,215,212,68,5,132,63,150,24,1,83,20,61,132,63,240,209,204,101,127,117,132,63,186,20,239,190,135,174,132,63,248,121,213,20,47,232,132,63,157,202,179,34,119,34,133,63,157,78,145,168,97,93,133,63,12,65,86,107,240,152,133,63,195,105,217,52,37,213,133,63,241,220,237,211,1,18,134,63,251,224,112,28,136,79,134,63,26,251,87,231,185,141,134,63,41,35,191,18,153,204,134,63,3,31,247,129,39,12,135,63,238,5,148,29,103,76,135,63,113,236,123,211,89,141,135,63,28,185,245,150,1,207,135,63,164,34,184,96,96,17,136,63,192,215,248,46,120,84,136,63,87,209,123,5,75,152,136,63,90,207,162,237,218,220,136,63,197,0,125,246,41,34,137,63,87,215,214,52,58,104,137,63,85,7,74,195,13,175,137,63,241,179,77,194,166,246,137,63,199,200,70,88,7,63,138,63,236,128,152,177,49,136,138,63,15,28,181,0,40,210,138,63,43,194,46,126,236,28,139,63,87,150,200,104,129,104,139,63,34,249,135,5,233,180,139,63,22,251,197,159,37,2,140,63,215,255,64,137,57,80,140,63,117,146,46,26,39,159,140,63,103,107,77,177,240,238,140,63,204,168,247,179,152,63,141,63,114,57,53,142,33,145,141,63,62,123,206,178,141,227,141,63,105,13,95,155,223,54,142,63,71,215,104,200,25,139,142,63,18,68,103,193,62,224,142,63,77,180,226,20,81,54,143,63,95,37,132,88,83,141,143,63,249,15,41,41,72,229,143,63,242,190,123,21,25,31,144,63,223,43,185,4,10,76,144,63,173,245,198,59,120,121,144,63,177,85,226,23,101,167,144,63,92,20,22,250,209,213,144,63,48,35,69,71,192,4,145,63,65,84,53,104,49,52,145,63,151,47,154,201,38,100,145,63,190,230,31,220,161,148,145,63,229,102,118,20,164,197,145,63,208,137,92,235,46,247,145,63,8,102,171,221,67,41,146,63,142,190,97,108,228,91,146,63,109,146,175,28,18,143,146,63,136,204,1,120,206,194,146,63,5,20,14,12,27,247,146,63,151,189,222,106,249,43,147,63,33,222,222,42,107,97,147,63,249,126,230,230,113,151,147,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,191,156,253,1,0,228,158,2,0,196,253,1,0,67,150,2,0,64,47,0,0,0,0,0,0,196,253,1,0,215,149,2,0,64,47,0,0,0,0,0,0,196,253,1,0,45,150,2,0,64,47,0,0,0,0,0,0,196,253,1,0,197,151,2,0,64,47,0,0,0,0,0,0,196,253,1,0,176,154,2,0,64,47,0,0,0,0,0,0,196,253,1,0,231,152,2,0,64,47,0,0,0,0,0,0,196,253,1,0,102,155,2,0,64,47,0,0,0,0,0,0,196,253,1,0,240,158,2,0,64,47,0,0,0,0,0,0,196,253,1,0,127,159,2,0,64,47,0,0,0,0,0,0,156,253,1,0,118,163,2,0,196,253,1,0,64,161,2,0,240,47,0,0,0,0,0,0,156,253,1,0,97,161,2,0,196,253,1,0,22,162,2,0,216,47,0,0,0,0,0,0,56,0,0,0,0,0,0,0,232,78,0,0,35,0,0,0,36,0,0,0,200,255,255,255,200,255,255,255,232,78,0,0,37,0,0,0,38,0,0,0,196,253,1,0,13,181,2,0,168,78,0,0,0,0,0,0,196,253,1,0,79,181,2,0,232,78,0,0,0,0,0,0,156,253,1,0,21,182,2,0,156,253,1,0,124,205,2,0,196,253,1,0,22,184,2,0,152,40,0,0,0,0,0,0,60,0,0,0,0,0,0,0,184,78,0,0,50,0,0,0,51,0,0,0,196,255,255,255,196,255,255,255,184,78,0,0,52,0,0,0,53,0,0,0,196,253,1,0,144,191,2,0,184,78,0,0,0,0,0,0,196,253,1,0,3,232,2,0,80,48,0,0,0,0,0,0,196,253,1,0,42,233,2,0,192,83,0,0,0,0,0,0,156,253,1,0,124,237,2,0,104,254,1,0,127,10,3,0,0,0,0,0,1,0,0,0,200,48,0,0,0,0,0,0,196,253,1,0,34,31,3,0,80,48,0,0,0,0,0,0,196,253,1,0,176,31,3,0,80,48,0,0,0,0,0,0,196,253,1,0,68,33,3,0,152,40,0,0,0,0,0,0,196,253,1,0,13,37,3,0,248,38,0,0,0,0,0,0,196,253,1,0,78,34,3,0,152,40,0,0,0,0,0,0,196,253,1,0,181,34,3,0,80,48,0,0,0,0,0,0,196,253,1,0,231,34,3,0,152,40,0,0,0,0,0,0,196,253,1,0,78,35,3,0,80,48,0,0,0,0,0,0,196,253,1,0,128,35,3,0,152,40,0,0,0,0,0,0,196,253,1,0,233,35,3,0,80,48,0,0,0,0,0,0,196,253,1,0,29,36,3,0,152,40,0,0,0,0,0,0,196,253,1,0,132,36,3,0,80,48,0,0,0,0,0,0,196,253,1,0,215,37,3,0,80,48,0,0,0,0,0,0,196,253,1,0,145,38,3,0,80,48,0,0,0,0,0,0,196,253,1,0,73,39,3,0,80,48,0,0,0,0,0,0,196,253,1,0,73,40,3,0,80,48,0,0,0,0,0,0,196,253,1,0,72,41,3,0,80,48,0,0,0,0,0,0,196,253,1,0,82,42,3,0,80,48,0,0,0,0,0,0,196,253,1,0,255,42,3,0,80,48,0,0,0,0,0,0,196,253,1,0,170,43,3,0,80,48,0,0,0,0,0,0,196,253,1,0,178,44,3,0,80,48,0,0,0,0,0,0,196,253,1,0,111,45,3,0,80,48,0,0,0,0,0,0,196,253,1,0,42,46,3,0,80,48,0,0,0,0,0,0,196,253,1,0,35,47,3,0,80,48,0,0,0,0,0,0,196,253,1,0,27,48,3,0,80,48,0,0,0,0,0,0,196,253,1,0,34,49,3,0,80,48,0,0,0,0,0,0,196,253,1,0,233,49,3,0,80,48,0,0,0,0,0,0,196,253,1,0,174,50,3,0,80,48,0,0,0,0,0,0,196,253,1,0,197,51,3,0,80,48,0,0,0,0,0,0,196,253,1,0,140,52,3,0,80,48,0,0,0,0,0,0,196,253,1,0,81,53,3,0,80,48,0,0,0,0,0,0,196,253,1,0,100,54,3,0,80,48,0,0,0,0,0,0,196,253,1,0,36,55,3,0,80,48,0,0,0,0,0,0,196,253,1,0,226,55,3,0,80,48,0,0,0,0,0,0,196,253,1,0,236,56,3,0,80,48,0,0,0,0,0,0,196,253,1,0,172,57,3,0,80,48,0,0,0,0,0,0,196,253,1,0,106,58,3,0,80,48,0,0,0,0,0,0,196,253,1,0,142,59,3,0,80,48,0,0,0,0,0,0,196,253,1,0,42,60,3,0,80,48,0,0,0,0,0,0,196,253,1,0,198,60,3,0,80,48,0,0,0,0,0,0,196,253,1,0,98,61,3,0,80,48,0,0,0,0,0,0,196,253,1,0,102,62,3,0,80,48,0,0,0,0,0,0,196,253,1,0,2,63,3,0,80,48,0,0,0,0,0,0,196,253,1,0,158,63,3,0,80,48,0,0,0,0,0,0,196,253,1,0,58,64,3,0,80,48,0,0,0,0,0,0,196,253,1,0,62,65,3,0,80,48,0,0,0,0,0,0,196,253,1,0,218,65,3,0,80,48,0,0,0,0,0,0,196,253,1,0,66,67,3,0,80,48,0,0,0,0,0,0,196,253,1,0,70,68,3,0,80,48,0,0,0,0,0,0,196,253,1,0,213,69,3,0,80,48,0,0,0,0,0,0,196,253,1,0,113,70,3,0,80,48,0,0,0,0,0,0,196,253,1,0,26,71,3,0,80,48,0,0,0,0,0,0,196,253,1,0,182,71,3,0,80,48,0,0,0,0,0,0,196,253,1,0,136,72,3,0,80,48,0,0,0,0,0,0,196,253,1,0,178,72,3,0,80,48,0,0,0,0,0,0,196,253,1,0,220,72,3,0,80,48,0,0,0,0,0,0,196,253,1,0,6,73,3,0,80,48,0,0,0,0,0,0,196,253,1,0,48,73,3,0,80,48,0,0,0,0,0,0,196,253,1,0,88,73,3,0,80,48,0,0,0,0,0,0,196,253,1,0,128,73,3,0,80,48,0,0,0,0,0,0,196,253,1,0,168,73,3,0,80,48,0,0,0,0,0,0,196,253,1,0,74,74,3,0,80,48,0,0,0,0,0,0,196,253,1,0,111,74,3,0,80,48,0,0,0,0,0,0,196,253,1,0,148,74,3,0,80,48,0,0,0,0,0,0,196,253,1,0,183,74,3,0,80,48,0,0,0,0,0,0,196,253,1,0,86,75,3,0,80,48,0,0,0,0,0,0,196,253,1,0,126,75,3,0,80,48,0,0,0,0,0,0,196,253,1,0,166,75,3,0,80,48,0,0,0,0,0,0,196,253,1,0,206,75,3,0,80,48,0,0,0,0,0,0,196,253,1,0,112,76,3,0,80,48,0,0,0,0,0,0,196,253,1,0,157,76,3,0,80,48,0,0,0,0,0,0,196,253,1,0,202,76,3,0,80,48,0,0,0,0,0,0,196,253,1,0,247,76,3,0,80,48,0,0,0,0,0,0,196,253,1,0,36,77,3,0,80,48,0,0,0,0,0,0,196,253,1,0,81,77,3,0,80,48,0,0,0,0,0,0,196,253,1,0,126,77,3,0,80,48,0,0,0,0,0,0,196,253,1,0,169,77,3,0,80,48,0,0,0,0,0,0,196,253,1,0,212,77,3,0,80,48,0,0,0,0,0,0,196,253,1,0,255,77,3,0,80,48,0,0,0,0,0,0,196,253,1,0,42,78,3,0,80,48,0,0,0,0,0,0,196,253,1,0,85,78,3,0,80,48,0,0,0,0,0,0,196,253,1,0,122,79,3,0,80,48,0,0,0,0,0,0,196,253,1,0,148,80,3,0,80,48,0,0,0,0,0,0,196,253,1,0,4,85,3,0,80,48,0,0,0,0,0,0,196,253,1,0,80,85,3,0,80,48,0,0,0,0,0,0,196,253,1,0,154,85,3,0,80,48,0,0,0,0,0,0,196,253,1,0,227,85,3,0,80,48,0,0,0,0,0,0,196,253,1,0,56,86,3,0,80,48,0,0,0,0,0,0,196,253,1,0,224,86,3,0,80,48,0,0,0,0,0,0,196,253,1,0,49,87,3,0,80,48,0,0,0,0,0,0,196,253,1,0,128,87,3,0,80,48,0,0,0,0,0,0,196,253,1,0,206,87,3,0,80,48,0,0,0,0,0,0,196,253,1,0,40,88,3,0,80,48,0,0,0,0,0,0,196,253,1,0,12,91,3,0,152,40,0,0,0,0,0,0,196,253,1,0,96,97,3,0,80,48,0,0,0,0,0,0,196,253,1,0,171,97,3,0,80,48,0,0,0,0,0,0,196,253,1,0,246,97,3,0,80,48,0,0,0,0,0,0,196,253,1,0,53,98,3,0,80,48,0,0,0,0,0,0,196,253,1,0,116,98,3,0,80,48,0,0,0,0,0,0,196,253,1,0,180,98,3,0,80,48,0,0,0,0,0,0,196,253,1,0,219,102,3,0,80,48,0,0,0,0,0,0,196,253,1,0,239,102,3,0,80,48,0,0,0,0,0,0,156,253,1,0,43,112,3,0,156,253,1,0,64,112,3,0,156,253,1,0,88,112,3,0,156,253,1,0,61,114,3,0,196,253,1,0,158,115,3,0,152,40,0,0,0,0,0,0,196,253,1,0,75,116,3,0,72,55,0,0,0,0,0,0,196,253,1,0,108,116,3,0,152,40,0,0,0,0,0,0,196,253,1,0,193,116,3,0,72,55,0,0,0,0,0,0,196,253,1,0,226,116,3,0,152,40,0,0,0,0,0,0,196,253,1,0,55,117,3,0,72,55,0,0,0,0,0,0,196,253,1,0,88,117,3,0,152,40,0,0,0,0,0,0,196,253,1,0,173,117,3,0,72,55,0,0,0,0,0,0,196,253,1,0,206,117,3,0,152,40,0,0,0,0,0,0,196,253,1,0,35,118,3,0,72,55,0,0,0,0,0,0,196,253,1,0,68,118,3,0,152,40,0,0,0,0,0,0,196,253,1,0,153,118,3,0,72,55,0,0,0,0,0,0,196,253,1,0,186,118,3,0,152,40,0,0,0,0,0,0,196,253,1,0,15,119,3,0,72,55,0,0,0,0,0,0,196,253,1,0,48,119,3,0,152,40,0,0,0,0,0,0,196,253,1,0,133,119,3,0,72,55,0,0,0,0,0,0,196,253,1,0,166,119,3,0,152,40,0,0,0,0,0,0,196,253,1,0,251,119,3,0,72,55,0,0,0,0,0,0,196,253,1,0,28,120,3,0,152,40,0,0,0,0,0,0,196,253,1,0,113,120,3,0,72,55,0,0,0,0,0,0,196,253,1,0,146,120,3,0,152,40,0,0,0,0,0,0,196,253,1,0,99,121,3,0,72,55,0,0,0,0,0,0,196,253,1,0,142,121,3,0,184,56,0,0,0,0,0,0,196,253,1,0,195,121,3,0,152,40,0,0,0,0,0,0,196,253,1,0,44,122,3,0,72,55,0,0,0,0,0,0,196,253,1,0,87,122,3,0,232,56,0,0,0,0,0,0,196,253,1,0,93,123,3,0,152,40,0,0,0,0,0,0,196,253,1,0,27,124,3,0,80,55,0,0,0,0,0,0,196,253,1,0,79,124,3,0,24,57,0,0,0,0,0,0,196,253,1,0,135,124,3,0,152,40,0,0,0,0,0,0,196,253,1,0,243,124,3,0,80,55,0,0,0,0,0,0,196,253,1,0,39,125,3,0,72,57,0,0,0,0,0,0,196,253,1,0,95,125,3,0,152,40,0,0,0,0,0,0,196,253,1,0,203,125,3,0,80,55,0,0,0,0,0,0,196,253,1,0,255,125,3,0,120,57,0,0,0,0,0,0,196,253,1,0,55,126,3,0,152,40,0,0,0,0,0,0,196,253,1,0,163,126,3,0,80,55,0,0,0,0,0,0,196,253,1,0,215,126,3,0,168,57,0,0,0,0,0,0,196,253,1,0,15,127,3,0,152,40,0,0,0,0,0,0,196,253,1,0,123,127,3,0,80,55,0,0,0,0,0,0,196,253,1,0,175,127,3,0,216,57,0,0,0,0,0,0,196,253,1,0,66,128,3,0,152,40,0,0,0,0,0,0,196,253,1,0,174,128,3,0,80,55,0,0,0,0,0,0,196,253,1,0,226,128,3,0,8,58,0,0,0,0,0,0,196,253,1,0,26,129,3,0,152,40,0,0,0,0,0,0,196,253,1,0,134,129,3,0,80,55,0,0,0,0,0,0,196,253,1,0,186,129,3,0,56,58,0,0,0,0,0,0,196,253,1,0,242,129,3,0,152,40,0,0,0,0,0,0,196,253,1,0,94,130,3,0,80,55,0,0,0,0,0,0,196,253,1,0,146,130,3,0,104,58,0,0,0,0,0,0,196,253,1,0,202,130,3,0,152,40,0,0,0,0,0,0,196,253,1,0,54,131,3,0,80,55,0,0,0,0,0,0,196,253,1,0,106,131,3,0,152,58,0,0,0,0,0,0,196,253,1,0,162,131,3,0,152,40,0,0,0,0,0,0,196,253,1,0,24,132,3,0,80,55,0,0,0,0,0,0,196,253,1,0,86,132,3,0,200,58,0,0,0,0,0,0,196,253,1,0,152,132,3,0,152,40,0,0,0,0,0,0,196,253,1,0,57,133,3,0,80,55,0,0,0,0,0,0,196,253,1,0,118,133,3,0,24,59,0,0,0,0,0,0,196,253,1,0,188,133,3,0,248,58,0,0,0,0,0,0,196,253,1,0,253,133,3,0,152,40,0,0,0,0,0,0,196,253,1,0,119,134,3,0,80,55,0,0,0,0,0,0,196,253,1,0,180,134,3,0,88,59,0,0,0,0,0,0,196,253,1,0,250,134,3,0,56,59,0,0,0,0,0,0,196,253,1,0,59,135,3,0,152,40,0,0,0,0,0,0,196,253,1,0,182,135,3,0,216,58,0,0,0,0,0,0,196,253,1,0,253,135,3,0,152,40,0,0,0,0,0,0,196,253,1,0,101,136,3,0,152,40,0,0,0,0,0,0,196,253,1,0,205,136,3,0,152,40,0,0,0,0,0,0,196,253,1,0,53,137,3,0,152,40,0,0,0,0,0,0,196,253,1,0,157,137,3,0,152,40,0,0,0,0,0,0,196,253,1,0,5,138,3,0,152,40,0,0,0,0,0,0,196,253,1,0,109,138,3,0,152,40,0,0,0,0,0,0,196,253,1,0,213,138,3,0,152,40,0,0,0,0,0,0,196,253,1,0,61,139,3,0,152,40,0,0,0,0,0,0,196,253,1,0,254,139,3,0,152,40,0,0,0,0,0,0,196,253,1,0,49,141,3,0,152,40,0,0,0,0,0,0,196,253,1,0,195,141,3,0,88,55,0,0,0,0,0,0,196,253,1,0,243,141,3,0,152,40,0,0,0,0,0,0,196,253,1,0,87,142,3,0,88,55,0,0,0,0,0,0,196,253,1,0,135,142,3,0,152,40,0,0,0,0,0,0,196,253,1,0,235,142,3,0,88,55,0,0,0,0,0,0,196,253,1,0,27,143,3,0,152,40,0,0,0,0,0,0,196,253,1,0,127,143,3,0,88,55,0,0,0,0,0,0,196,253,1,0,175,143,3,0,152,40,0,0,0,0,0,0,196,253,1,0,19,144,3,0,88,55,0,0,0,0,0,0,196,253,1,0,67,144,3,0,152,40,0,0,0,0,0,0,196,253,1,0,167,144,3,0,88,55,0,0,0,0,0,0,196,253,1,0,215,144,3,0,152,40,0,0,0,0,0,0,196,253,1,0,59,145,3,0,88,55,0,0,0,0,0,0,196,253,1,0,107,145,3,0,152,40,0,0,0,0,0,0,196,253,1,0,207,145,3,0,88,55,0,0,0,0,0,0,196,253,1,0,255,145,3,0,152,40,0,0,0,0,0,0,196,253,1,0,99,146,3,0,88,55,0,0,0,0,0,0,196,253,1,0,147,146,3,0,152,40,0,0,0,0,0,0,196,253,1,0,247,146,3,0,88,55,0,0,0,0,0,0,196,253,1,0,39,147,3,0,152,40,0,0,0,0,0,0,196,253,1,0,139,147,3,0,88,55,0,0,0,0,0,0,196,253,1,0,187,147,3,0,152,40,0,0,0,0,0,0,196,253,1,0,31,148,3,0,88,55,0,0,0,0,0,0,196,253,1,0,79,148,3,0,152,40,0,0,0,0,0,0,196,253,1,0,179,148,3,0,88,55,0,0,0,0,0,0,196,253,1,0,150,201,4,0,80,48,0,0,0,0,0,0,196,253,1,0,176,201,4,0,80,48,0,0,0,0,0,0,196,253,1,0,62,205,4,0,152,40,0,0,0,0,0,0,196,253,1,0,31,208,4,0,80,48,0,0,0,0,0,0,196,253,1,0,172,208,4,0,80,48,0,0,0,0,0,0,196,253,1,0,227,209,4,0,80,48,0,0,0,0,0,0,196,253,1,0,229,214,4,0,152,40,0,0,0,0,0,0,196,253,1,0,81,215,4,0,72,55,0,0,0,0,0,0,196,253,1,0,137,215,4,0,152,40,0,0,0,0,0,0,196,253,1,0,245,215,4,0,72,55,0,0,0,0,0,0,196,253,1,0,45,216,4,0,152,40,0,0,0,0,0,0,196,253,1,0,153,216,4,0,72,55,0,0,0,0,0,0,196,253,1,0,209,216,4,0,152,40,0,0,0,0,0,0,196,253,1,0,61,217,4,0,72,55,0,0,0,0,0,0,196,253,1,0,117,217,4,0,152,40,0,0,0,0,0,0,196,253,1,0,225,217,4,0,72,55,0,0,0,0,0,0,196,253,1,0,25,218,4,0,152,40,0,0,0,0,0,0,196,253,1,0,133,218,4,0,72,55,0,0,0,0,0,0,196,253,1,0,189,218,4,0,152,40,0,0,0,0,0,0,196,253,1,0,41,219,4,0,72,55,0,0,0,0,0,0,196,253,1,0,97,219,4,0,152,40,0,0,0,0,0,0,196,253,1,0,205,219,4,0,72,55,0,0,0,0,0,0,196,253,1,0,5,220,4,0,152,40,0,0,0,0,0,0,196,253,1,0,113,220,4,0,72,55,0,0,0,0,0,0,196,253,1,0,169,220,4,0,152,40,0,0,0,0,0,0,196,253,1,0,21,221,4,0,72,55,0,0,0,0,0,0,196,253,1,0,103,221,4,0,152,40,0,0,0,0,0,0,196,253,1,0,217,221,4,0,80,55,0,0,0,0,0,0,196,253,1,0,23,222,4,0,152,40,0,0,0,0,0,0,196,253,1,0,137,222,4,0,80,55,0,0,0,0,0,0,196,253,1,0,199,222,4,0,152,40,0,0,0,0,0,0,196,253,1,0,57,223,4,0,80,55,0,0,0,0,0,0,196,253,1,0,119,223,4,0,152,40,0,0,0,0,0,0,196,253,1,0,233,223,4,0,80,55,0,0,0,0,0,0,196,253,1,0,39,224,4,0,152,40,0,0,0,0,0,0,196,253,1,0,153,224,4,0,80,55,0,0,0,0,0,0,196,253,1,0,215,224,4,0,152,40,0,0,0,0,0,0,196,253,1,0,73,225,4,0,80,55,0,0,0,0,0,0,196,253,1,0,135,225,4,0,152,40,0,0,0,0,0,0,196,253,1,0,249,225,4,0,80,55,0,0,0,0,0,0,196,253,1,0,55,226,4,0,152,40,0,0,0,0,0,0,196,253,1,0,169,226,4,0,80,55,0,0,0,0,0,0,196,253,1,0,231,226,4,0,152,40,0,0,0,0,0,0,196,253,1,0,89,227,4,0,80,55,0,0,0,0,0,0,196,253,1,0,151,227,4,0,152,40,0,0,0,0,0,0,196,253,1,0,9,228,4,0,80,55,0,0,0,0,0,0,196,253,1,0,217,228,4,0,152,40,0,0,0,0,0,0,196,253,1,0,95,229,4,0,88,55,0,0,0,0,0,0,196,253,1,0,145,229,4,0,152,40,0,0,0,0,0,0,196,253,1,0,247,229,4,0,88,55,0,0,0,0,0,0,196,253,1,0,41,230,4,0,152,40,0,0,0,0,0,0,196,253,1,0,143,230,4,0,88,55,0,0,0,0,0,0,196,253,1,0,193,230,4,0,152,40,0,0,0,0,0,0,196,253,1,0,39,231,4,0,88,55,0,0,0,0,0,0,196,253,1,0,89,231,4,0,152,40,0,0,0,0,0,0,196,253,1,0,191,231,4,0,88,55,0,0,0,0,0,0,196,253,1,0,241,231,4,0,152,40,0,0,0,0,0,0,196,253,1,0,87,232,4,0,88,55,0,0,0,0,0,0,196,253,1,0,137,232,4,0,152,40,0,0,0,0,0,0,196,253,1,0,239,232,4,0,88,55,0,0,0,0,0,0,196,253,1,0,33,233,4,0,152,40,0,0,0,0,0,0,196,253,1,0,135,233,4,0,88,55,0,0,0,0,0,0,196,253,1,0,185,233,4,0,152,40,0,0,0,0,0,0,196,253,1,0,31,234,4,0,88,55,0,0,0,0,0,0,196,253,1,0,81,234,4,0,152,40,0,0,0,0,0,0,196,253,1,0,183,234,4,0,88,55,0,0,0,0,0,0,196,253,1,0,14,240,4,0,80,48,0,0,0,0,0,0,196,253,1,0,163,240,4,0,80,48,0,0,0,0,0,0,196,253,1,0,15,241,4,0,80,48,0,0,0,0,0,0,196,253,1,0,123,241,4,0,80,48,0,0,0,0,0,0,196,253,1,0,231,241,4,0,80,48,0,0,0,0,0,0,196,253,1,0,96,242,4,0,80,48,0,0,0,0,0,0,196,253,1,0,228,242,4,0,80,48,0,0,0,0,0,0,196,253,1,0,104,243,4,0,80,48,0,0,0,0,0,0,196,253,1,0,236,243,4,0,80,48,0,0,0,0,0,0,196,253,1,0,112,244,4,0,80,48,0,0,0,0,0,0,196,253,1,0,4,245,4,0,80,48,0,0,0,0,0,0,196,253,1,0,118,245,4,0,80,48,0,0,0,0,0,0,196,253,1,0,232,245,4,0,80,48,0,0,0,0,0,0,196,253,1,0,90,246,4,0,80,48,0,0,0,0,0,0,196,253,1,0,204,246,4,0,80,48,0,0,0,0,0,0,196,253,1,0,75,247,4,0,80,48,0,0,0,0,0,0,196,253,1,0,105,247,4,0,80,48,0,0,0,0,0,0,196,253,1,0,135,247,4,0,80,48,0,0,0,0,0,0,196,253,1,0,165,247,4,0,80,48,0,0,0,0,0,0,196,253,1,0,195,247,4,0,80,48,0,0,0,0,0,0,196,253,1,0,225,247,4,0,80,48,0,0,0,0,0,0,196,253,1,0,32,248,4,0,80,48,0,0,0,0,0,0,196,253,1,0,103,248,4,0,80,48,0,0,0,0,0,0,196,253,1,0,192,248,4,0,80,48,0,0,0,0,0,0,196,253,1,0,25,249,4,0,80,48,0,0,0,0,0,0,196,253,1,0,114,249,4,0,80,48,0,0,0,0,0,0,196,253,1,0,201,255,4,0,152,40,0,0,0,0,0,0,196,253,1,0,14,0,5,0,72,55,0,0,0,0,0,0,196,253,1,0,31,0,5,0,152,40,0,0,0,0,0,0,196,253,1,0,100,0,5,0,72,55,0,0,0,0,0,0,196,253,1,0,117,0,5,0,152,40,0,0,0,0,0,0,196,253,1,0,186,0,5,0,72,55,0,0,0,0,0,0,196,253,1,0,203,0,5,0,152,40,0,0,0,0,0,0,196,253,1,0,16,1,5,0,72,55,0,0,0,0,0,0,196,253,1,0,33,1,5,0,152,40,0,0,0,0,0,0,196,253,1,0,102,1,5,0,72,55,0,0,0,0,0,0,196,253,1,0,119,1,5,0,152,40,0,0,0,0,0,0,196,253,1,0,188,1,5,0,72,55,0,0,0,0,0,0,196,253,1,0,205,1,5,0,152,40,0,0,0,0,0,0,196,253,1,0,18,2,5,0,72,55,0,0,0,0,0,0,196,253,1,0,35,2,5,0,152,40,0,0,0,0,0,0,196,253,1,0,104,2,5,0,72,55,0,0,0,0,0,0,196,253,1,0,121,2,5,0,152,40,0,0,0,0,0,0,196,253,1,0,190,2,5,0,72,55,0,0,0,0,0,0,196,253,1,0,207,2,5,0,152,40,0,0,0,0,0,0,196,253,1,0,20,3,5,0,72,55,0,0,0,0,0,0,196,253,1,0,221,3,5,0,152,40,0,0,0,0,0,0,196,253,1,0,57,4,5,0,80,55,0,0,0,0,0,0,196,253,1,0,77,4,5,0,152,40,0,0,0,0,0,0,196,253,1,0,149,4,5,0,80,55,0,0,0,0,0,0,196,253,1,0,169,4,5,0,152,40,0,0,0,0,0,0,196,253,1,0,241,4,5,0,80,55,0,0,0,0,0,0,196,253,1,0,5,5,5,0,152,40,0,0,0,0,0,0,196,253,1,0,77,5,5,0,80,55,0,0,0,0,0,0,196,253,1,0,97,5,5,0,152,40,0,0,0,0,0,0,196,253,1,0,169,5,5,0,80,55,0,0,0,0,0,0,196,253,1,0,189,5,5,0,152,40,0,0,0,0,0,0,196,253,1,0,5,6,5,0,80,55,0,0,0,0,0,0,196,253,1,0,25,6,5,0,152,40,0,0,0,0,0,0,196,253,1,0,97,6,5,0,80,55,0,0,0,0,0,0,196,253,1,0,117,6,5,0,152,40,0,0,0,0,0,0,196,253,1,0,189,6,5,0,80,55,0,0,0,0,0,0,196,253,1,0,209,6,5,0,152,40,0,0,0,0,0,0,196,253,1,0,25,7,5,0,80,55,0,0,0,0,0,0,196,253,1,0,45,7,5,0,152,40,0,0,0,0,0,0,196,253,1,0,117,7,5,0,80,55,0,0,0,0,0,0,196,253,1,0,137,7,5,0,152,40,0,0,0,0,0,0,196,253,1,0,209,7,5,0,80,55,0,0,0,0,0,0,196,253,1,0,229,7,5,0,152,40,0,0,0,0,0,0,196,253,1,0,45,8,5,0,80,55,0,0,0,0,0,0,196,253,1,0,22,12,5,0,80,48,0,0,0,0,0,0,196,253,1,0,57,12,5,0,80,48,0,0,0,0,0,0,196,253,1,0,84,20,5,0,80,48,0,0,0,0,0,0,156,253,1,0,142,27,5,0,196,253,1,0,131,26,5,0,152,40,0,0,0,0,0,0,196,253,1,0,32,30,5,0,120,70,0,0,0,0,0,0,196,253,1,0,225,28,5,0,152,40,0,0,0,0,0,0,196,253,1,0,48,29,5,0,152,40,0,0,0,0,0,0,196,253,1,0,170,29,5,0,152,40,0,0,0,0,0,0,196,253,1,0,122,31,5,0,120,70,0,0,0,0,0,0,196,253,1,0,63,30,5,0,152,40,0,0,0,0,0,0,196,253,1,0,135,30,5,0,152,40,0,0,0,0,0,0,196,253,1,0,0,31,5,0,152,40,0,0,0,0,0,0,196,253,1,0,146,40,5,0,64,71,0,0,0,0,0,0,196,253,1,0,16,36,5,0,80,48,0,0,0,0,0,0,196,253,1,0,94,39,5,0,152,40,0,0,0,0,0,0,196,253,1,0,175,40,5,0,16,40,0,0,0,0,0,0,196,253,1,0,64,41,5,0,152,40,0,0,0,0,0,0,196,253,1,0,113,55,5,0,80,48,0,0,0,0,0,0,196,253,1,0,250,55,5,0,80,48,0,0,0,0,0,0,156,253,1,0,212,56,5,0,156,253,1,0,51,65,5,0,196,253,1,0,90,57,5,0,80,48,0,0,0,0,0,0,196,253,1,0,216,61,5,0,80,48,0,0,0,0,0,0,196,253,1,0,180,69,5,0,192,38,0,0,0,0,0,0,196,253,1,0,92,68,5,0,80,48,0,0,0,0,0,0,196,253,1,0,216,69,5,0,152,40,0,0,0,0,0,0,196,253,1,0,69,78,5,0,80,48,0,0,0,0,0,0,196,253,1,0,52,79,5,0,152,40,0,0,0,0,0,0,196,253,1,0,23,83,5,0,16,72,0,0,0,0,0,0,196,253,1,0,71,83,5,0,32,72,0,0,0,0,0,0,196,253,1,0,101,83,5,0,16,40,0,0,0,0,0,0,196,253,1,0,159,84,5,0,152,40,0,0,0,0,0,0,196,253,1,0,99,86,5,0,80,72,0,0,0,0,0,0,196,253,1,0,145,86,5,0,96,72,0,0,0,0,0,0,196,253,1,0,173,86,5,0,16,40,0,0,0,0,0,0,196,253,1,0,58,87,5,0,152,40,0,0,0,0,0,0,196,253,1,0,128,87,5,0,152,40,0,0,0,0,0,0,196,253,1,0,198,87,5,0,152,40,0,0,0,0,0,0,196,253,1,0,12,88,5,0,152,40,0,0,0,0,0,0,196,253,1,0,82,88,5,0,152,40,0,0,0,0,0,0,196,253,1,0,158,88,5,0,152,40,0,0,0,0,0,0,196,253,1,0,234,88,5,0,152,40,0,0,0,0,0,0,196,253,1,0,49,89,5,0,152,40,0,0,0,0,0,0,196,253,1,0,120,89,5,0,152,40,0,0,0,0,0,0,196,253,1,0,190,89,5,0,152,40,0,0,0,0,0,0,196,253,1,0,4,90,5,0,152,40,0,0,0,0,0,0,196,253,1,0,74,90,5,0,152,40,0,0,0,0,0,0,196,253,1,0,90,91,5,0,168,78,0,0,0,0,0,0,196,253,1,0,127,93,5,0,120,74,0,0,0,0,0,0,196,253,1,0,177,93,5,0,128,74,0,0,0,0,0,0,196,253,1,0,213,93,5,0,120,74,0,0,0,0,0,0,196,253,1,0,183,94,5,0,128,74,0,0,0,0,0,0,196,253,1,0,113,96,5,0,120,74,0,0,0,0,0,0,196,253,1,0,164,96,5,0,128,74,0,0,0,0,0,0,196,253,1,0,15,97,5,0,120,74,0,0,0,0,0,0,196,253,1,0,239,96,5,0,184,48,0,0,0,0,0,0,196,253,1,0,122,97,5,0,128,74,0,0,0,0,0,0,196,253,1,0,167,98,5,0,120,74,0,0,0,0,0,0,196,253,1,0,42,99,5,0,128,74,0,0,0,0,0,0,196,253,1,0,60,99,5,0,120,74,0,0,0,0,0,0,196,253,1,0,119,99,5,0,128,74,0,0,0,0,0,0,156,253,1,0,40,100,5,0,196,253,1,0,238,99,5,0,184,48,0,0,0,0,0,0,156,253,1,0,62,100,5,0,196,253,1,0,81,100,5,0,16,74,0,0,0,0,0,0,196,253,1,0,101,100,5,0,48,74,0,0,0,0,0,0,196,253,1,0,121,100,5,0,40,74,0,0,0,0,0,0,196,253,1,0,141,100,5,0,80,74,0,0,0,0,0,0,156,253,1,0,103,102,5,0,156,253,1,0,138,102,5,0,156,253,1,0,1,103,5,0,196,253,1,0,239,105,5,0,152,74,0,0,0,0,0,0,196,253,1,0,213,105,5,0,232,74,0,0,0,0,0,0,196,253,1,0,13,106,5,0,152,40,0,0,0,0,0,0,196,253,1,0,109,108,5,0,232,74,0,0,0,0,0,0,196,253,1,0,255,108,5,0,152,40,0,0,0,0,0,0,196,253,1,0,182,109,5,0,184,74,0,0,0,0,0,0,104,254,1,0,231,112,5,0,0,0,0,0,1,0,0,0,16,40,0,0,3,216,255,255,196,253,1,0,49,114,5,0,16,40,0,0,0,0,0,0,196,253,1,0,41,115,5,0,0,75,0,0,0,0,0,0,196,253,1,0,229,114,5,0,152,40,0,0,0,0,0,0,196,253,1,0,205,117,5,0,232,74,0,0,0,0,0,0,196,253,1,0,32,120,5,0,48,75,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,74,0,0,17,3,0,0,18,3,0,0,3,0,0,0,200,0,0,0,201,0,0,0,43,0,0,0,3,0,0,0,218,0,0,0,45,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,77,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,196,253,1,0,47,120,5,0,152,40,0,0,0,0,0,0,49,244,70,62,15,206,131,63,254,130,43,101,71,21,87,64,0,0,0,0,0,0,144,63,0,0,0,0,0,0,240,63,97,128,119,62,154,44,240,63,116,133,21,211,176,89,240,63,200,155,117,24,69,135,240,63,15,137,249,108,88,181,240,63,162,209,211,50,236,227,240,63,81,91,18,208,1,19,241,63,224,45,169,174,154,66,241,63,123,81,125,60,184,114,241,63,117,203,111,235,91,163,241,63,170,185,104,49,135,212,241,63,214,140,98,136,59,6,242,63,56,98,117,110,122,56,242,63,221,124,226,101,69,107,242,63,225,222,31,245,157,158,242,63,11,3,228,166,133,210,242,63,21,183,49,10,254,6,243,63,255,22,100,178,8,60,243,63,203,169,58,55,167,113,243,63,247,159,229,52,219,167,243,63,34,52,18,76,166,222,243,63,42,46,247,33,10,22,244,63,45,137,97,96,8,78,244,63,208,60,193,181,162,134,244,63,39,42,54,213,218,191,244,63,167,44,157,118,178,249,244,63,130,79,157,86,43,52,245,63,218,39,181,54,71,111,245,63,41,84,72,221,7,171,245,63,72,33,173,21,111,231,245,63,133,85,58,176,126,36,246,63,37,34,85,130,56,98,246,63,205,59,127,102,158,160,246,63,47,26,101,60,178,223,246,63,116,95,236,232,117,31,247,63,201,103,66,86,235,95,247,63,135,1,235,115,20,161,247,63,98,78,207,54,243,226,247,63,19,206,76,153,137,37,248,63,237,146,68,155,217,104,248,63,219,160,42,66,229,172,248,63,54,119,21,153,174,241,248,63,229,197,205,176,55,55,249,63,80,78,222,159,130,125,249,63,144,240,163,130,145,196,249,63,101,229,93,123,102,12,250,63,93,37,62,178,3,85,250,63,191,253,121,85,107,158,250,63,173,211,90,153,159,232,250,63,251,21,79,184,162,51,251,63,71,94,251,242,118,127,251,63,210,193,75,144,30,204,251,63,156,82,133,221,155,25,252,63,75,209,87,46,241,103,252,63,105,144,239,220,32,183,252,63,124,137,7,74,45,7,253,63,135,164,251,220,24,88,253,63,133,50,219,3,230,169,253,63,95,155,123,51,151,252,253,63,246,63,139,231,46,80,254,63,218,144,164,162,175,164,254,63,39,90,97,238,27,250,254,63,64,69,110,91,118,80,255,63,216,144,158,129,193,167,255,63,239,57,250,254,66,46,230,63,0,0,0,0,0,0,240,63,239,97,72,177,80,49,246,63,202,111,77,145,174,231,244,63,170,17,108,239,98,208,242,63,0,0,0,0,0,0,240,63,59,191,167,192,105,36,233,63,187,32,199,123,122,81,225,63,93,171,114,222,85,168,209,63,104,254,1,0,16,152,5,0,0,0,0,0,1,0,0,0,216,37,0,0,0,0,0,0,104,254,1,0,209,151,5,0,0,0,0,0,1,0,0,0,216,37,0,0,0,0,0,0,156,253,1,0,178,151,5,0,156,253,1,0,147,151,5,0,156,253,1,0,116,151,5,0,156,253,1,0,85,151,5,0,156,253,1,0,54,151,5,0,196,253,1,0,125,163,5,0,144,78,0,0,0,0,0,0,156,253,1,0,107,163,5,0,196,253,1,0,167,163,5,0,144,78,0,0,0,0,0,0,156,253,1,0,209,163,5,0,156,253,1,0,2,164,5,0,104,254,1,0,51,164,5,0,0,0,0,0,1,0,0,0,128,78,0,0,3,244,255,255,104,254,1,0,98,164,5,0,0,0,0,0,1,0,0,0,152,78,0,0,3,244,255,255,104,254,1,0,145,164,5,0,0,0,0,0,1,0,0,0,128,78,0,0,3,244,255,255,104,254,1,0,192,164,5,0,0,0,0,0,1,0,0,0,152,78,0,0,3,244,255,255,196,253,1,0,239,164,5,0,176,78,0,0,0,0,0,0,196,253,1,0,8,165,5,0,168,78,0,0,0,0,0,0,196,253,1,0,71,165,5,0,176,78,0,0,0,0,0,0,196,253,1,0,95,165,5,0,168,78,0,0,0,0,0,0,196,253,1,0,119,165,5,0,104,79,0,0,0,0,0,0,196,253,1,0,139,165,5,0,184,83,0,0,0,0,0,0,196,253,1,0,161,165,5,0,104,79,0,0,0,0,0,0,104,254,1,0,219,165,5,0,0,0,0,0,2,0,0,0,104,79,0,0,2,0,0,0,168,79,0,0,0,0,0,0,104,254,1,0,31,166,5,0,0,0,0,0,1,0,0,0,192,79,0,0,0,0,0,0,156,253,1,0,53,166,5,0,104,254,1,0,78,166,5,0,0,0,0,0,2,0,0,0,104,79,0,0,2,0,0,0,232,79,0,0,0,0,0,0,104,254,1,0,146,166,5,0,0,0,0,0,1,0,0,0,192,79,0,0,0,0,0,0,104,254,1,0,182,166,5],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+10240);allocate([2,0,0,0,104,79,0,0,2,0,0,0,32,80,0,0,0,0,0,0,104,254,1,0,250,166,5,0,0,0,0,0,1,0,0,0,56,80,0,0,0,0,0,0,156,253,1,0,16,167,5,0,104,254,1,0,41,167,5,0,0,0,0,0,2,0,0,0,104,79,0,0,2,0,0,0,96,80,0,0,0,0,0,0,104,254,1,0,109,167,5,0,0,0,0,0,1,0,0,0,56,80,0,0,0,0,0,0,104,254,1,0,195,168,5,0,0,0,0,0,3,0,0,0,104,79,0,0,2,0,0,0,160,80,0,0,2,0,0,0,168,80,0,0,0,8,0,0,156,253,1,0,42,169,5,0,156,253,1,0,8,169,5,0,104,254,1,0,61,169,5,0,0,0,0,0,3,0,0,0,104,79,0,0,2,0,0,0,160,80,0,0,2,0,0,0,216,80,0,0,0,8,0,0,156,253,1,0,130,169,5,0,104,254,1,0,164,169,5,0,0,0,0,0,2,0,0,0,104,79,0,0,2,0,0,0,0,81,0,0,0,8,0,0,156,253,1,0,233,169,5,0,104,254,1,0,254,169,5,0,0,0,0,0,2,0,0,0,104,79,0,0,2,0,0,0,0,81,0,0,0,8,0,0,104,254,1,0,67,170,5,0,0,0,0,0,2,0,0,0,104,79,0,0,2,0,0,0,72,81,0,0,2,0,0,0,156,253,1,0,95,170,5,0,104,254,1,0,116,170,5,0,0,0,0,0,2,0,0,0,104,79,0,0,2,0,0,0,72,81,0,0,2,0,0,0,104,254,1,0,144,170,5,0,0,0,0,0,2,0,0,0,104,79,0,0,2,0,0,0,72,81,0,0,2,0,0,0,104,254,1,0,172,170,5,0,0,0,0,0,2,0,0,0,104,79,0,0,2,0,0,0,72,81,0,0,2,0,0,0,104,254,1,0,215,170,5,0,0,0,0,0,2,0,0,0,104,79,0,0,2,0,0,0,208,81,0,0,0,0,0,0,156,253,1,0,29,171,5,0,104,254,1,0,65,171,5,0,0,0,0,0,2,0,0,0,104,79,0,0,2,0,0,0,248,81,0,0,0,0,0,0,156,253,1,0,135,171,5,0,104,254,1,0,166,171,5,0,0,0,0,0,2,0,0,0,104,79,0,0,2,0,0,0,32,82,0,0,0,0,0,0,156,253,1,0,236,171,5,0,104,254,1,0,5,172,5,0,0,0,0,0,2,0,0,0,104,79,0,0,2,0,0,0,72,82,0,0,0,0,0,0,156,253,1,0,75,172,5,0,104,254,1,0,100,172,5,0,0,0,0,0,2,0,0,0,104,79,0,0,2,0,0,0,112,82,0,0,2,0,0,0,156,253,1,0,121,172,5,0,104,254,1,0,16,173,5,0,0,0,0,0,2,0,0,0,104,79,0,0,2,0,0,0,112,82,0,0,2,0,0,0,196,253,1,0,145,172,5,0,168,82,0,0,0,0,0,0,104,254,1,0,180,172,5,0,0,0,0,0,2,0,0,0,104,79,0,0,2,0,0,0,200,82,0,0,2,0,0,0,156,253,1,0,215,172,5,0,196,253,1,0,238,172,5,0,168,82,0,0,0,0,0,0,104,254,1,0,37,173,5,0,0,0,0,0,2,0,0,0,104,79,0,0,2,0,0,0,200,82,0,0,2,0,0,0,104,254,1,0,71,173,5,0,0,0,0,0,2,0,0,0,104,79,0,0,2,0,0,0,200,82,0,0,2,0,0,0,104,254,1,0,105,173,5,0,0,0,0,0,2,0,0,0,104,79,0,0,2,0,0,0,200,82,0,0,2,0,0,0,196,253,1,0,140,173,5,0,104,79,0,0,0,0,0,0,104,254,1,0,162,173,5,0,0,0,0,0,2,0,0,0,104,79,0,0,2,0,0,0,112,83,0,0,2,0,0,0,156,253,1,0,180,173,5,0,104,254,1,0,201,173,5,0,0,0,0,0,2,0,0,0,104,79,0,0,2,0,0,0,112,83,0,0,2,0,0,0,196,253,1,0,219,173,5,0,104,79,0,0,0,0,0,0,196,253,1,0,240,173,5,0,104,79,0,0,0,0,0,0,156,253,1,0,5,174,5,0,156,253,1,0,175,174,5,0,196,253,1,0,15,175,5,0,216,83,0,0,0,0,0,0,196,253,1,0,188,174,5,0,232,83,0,0,0,0,0,0,156,253,1,0,221,174,5,0,196,253,1,0,234,174,5,0,200,83,0,0,0,0,0,0,196,253,1,0,241,175,5,0,192,83,0,0,0,0,0,0,196,253,1,0,1,176,5,0,0,84,0,0,0,0,0,0,196,253,1,0,54,176,5,0,216,83,0,0,0,0,0,0,196,253,1,0,18,176,5,0,32,84,0,0,0,0,0,0,196,253,1,0,88,176,5,0,216,83,0,0,0,0,0,0,20,254,1,0,128,176,5,0,20,254,1,0,130,176,5,0,20,254,1,0,133,176,5,0,20,254,1,0,135,176,5,0,20,254,1,0,137,176,5,0,20,254,1,0,139,176,5,0,20,254,1,0,141,176,5,0,20,254,1,0,202,17,2,0,20,254,1,0,143,176,5,0,20,254,1,0,145,176,5,0,20,254,1,0,6,182,5,0,20,254,1,0,147,176,5,0,20,254,1,0,71,195,4,0,20,254,1,0,149,176,5,0,196,253,1,0,151,176,5,0,216,83,0,0,0,0,0,0,196,253,1,0,184,176,5,0,200,83,0,0,0,0,0,0,80,84,0,0,144,84,0,0,80,84,0,0,152,84,0,0,80,84,0,0,176,33,0,0,80,84,0,0,184,33,0,0,80,84,0,0,192,33,0,0,80,84,0,0,144,84,0,0,0,34,0,0,80,84,0,0,0,34,0,0,144,84,0,0,80,84,0,0,0,34,0,0,152,84,0,0,144,84,0,0,152,84,0,0,16,34,0,0,32,34,0,0,232,33,0,0,152,84,0,0,96,84,0,0,232,33,0,0,152,84,0,0,144,84,0,0,88,34,0,0,80,84,0,0,88,34,0,0,176,84,0,0,80,84,0,0,88,34,0,0,152,84,0,0,176,84,0,0,152,84,0,0,104,34,0,0,32,34,0,0,64,34,0,0,152,84,0,0,96,84,0,0,64,34,0,0,152,84,0,0,176,84,0,0,168,34,0,0,80,84,0,0,168,34,0,0,184,84,0,0,80,84,0,0,168,34,0,0,152,84,0,0,184,84,0,0,152,84,0,0,184,34,0,0,32,34,0,0,144,34,0,0,152,84,0,0,96,84,0,0,144,34,0,0,152,84,0,0,184,84,0,0,248,34,0,0,80,84,0,0,248,34,0,0,24,35,0,0,80,84,0,0,248,34,0,0,152,84,0,0,24,35,0,0,152,84,0,0,8,35,0,0,32,34,0,0,224,34,0,0,152,84,0,0,96,84,0,0,224,34,0,0,152,84,0,0,24,35,0,0,80,35,0,0,80,84,0,0,80,35,0,0,112,35,0,0,80,84,0,0,80,35,0,0,152,84,0,0,112,35,0,0,152,84,0,0,96,35,0,0,32,34,0,0,56,35,0,0,152,84,0,0,96,84,0,0,56,35,0,0,152,84,0,0,112,35,0,0,168,35,0,0,80,84,0,0,168,35,0,0,200,35,0,0,80,84,0,0,168,35,0,0,152,84,0,0,200,35,0,0,152,84,0,0,184,35,0,0,32,34,0,0,144,35,0,0,152,84,0,0,96,84,0,0,144,35,0,0,152,84,0,0,200,35,0,0,0,36,0,0,80,84,0,0,0,36,0,0,144,35,0,0,80,84,0,0,0,36,0,0,152,84,0,0,144,35,0,0,152,84,0,0,16,36,0,0,32,34,0,0,232,35,0,0,152,84,0,0,96,84,0,0,232,35,0,0,152,84,0,0,144,35,0,0,80,36,0,0,80,84,0,0,80,36,0,0,192,33,0,0,80,84,0,0,80,36,0,0,152,84,0,0,192,33,0,0,152,84,0,0,96,36,0,0,32,34,0,0,56,36,0,0,152,84,0,0,96,84,0,0,56,36,0,0,152,84,0,0,192,33,0,0,160,36,0,0,80,84,0,0,160,36,0,0,192,36,0,0,80,84,0,0,160,36,0,0,152,84,0,0,192,36,0,0,152,84,0,0,176,36,0,0,32,34,0,0,136,36,0,0,152,84,0,0,96,84,0,0,136,36,0,0,152,84,0,0,192,36,0,0,248,36,0,0,80,84,0,0,248,36,0,0,136,36,0,0,80,84,0,0,248,36,0,0,152,84,0,0,136,36,0,0,152,84,0,0,8,37,0,0,32,34,0,0,224,36,0,0,152,84,0,0,96,84,0,0,224,36,0,0,152,84,0,0,136,36,0,0,24,37,0,0,24,37,0,0,112,35,0,0,24,37,0,0,56,37,0,0,144,84,0,0,24,37,0,0,144,84,0,0,144,84,0,0,144,84,0,0,24,37,0,0,144,84,0,0,144,84,0,0,144,84,0,0,88,37,0,0,24,37,0,0,144,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,152,84,0,0,112,35,0,0,144,84,0,0,144,84,0,0,144,84,0,0,112,35,0,0,56,37,0,0,144,84,0,0,152,84,0,0,40,37,0,0,144,84,0,0,40,37,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,184,84,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,184,84,0,0,112,35,0,0,40,37,0,0,144,84,0,0,80,84,0,0,24,37,0,0,144,84,0,0,144,84,0,0,144,84,0,0,80,84,0,0,24,37,0,0,56,37,0,0,144,84,0,0,112,35,0,0,40,37,0,0,144,84,0,0,144,84,0,0,112,35,0,0,40,37,0,0,160,37,0,0,80,84,0,0,112,35,0,0,112,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,96,84,0,0,40,37,0,0,152,84,0,0,40,37,0,0,144,84,0,0,112,35,0,0,40,37,0,0,184,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,184,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,40,37,0,0,192,33,0,0,80,84,0,0,112,35,0,0,88,37,0,0,80,84,0,0,112,35,0,0,88,37,0,0,112,35,0,0,56,37,0,0,112,35,0,0,32,34,0,0,112,35,0,0,144,84,0,0,32,34,0,0,112,35,0,0,144,84,0,0,144,84,0,0,104,84,0,0,24,37,0,0,144,84,0,0,104,84,0,0,24,37,0,0,144,84,0,0,144,84,0,0,104,84,0,0,24,37,0,0,144,84,0,0,144,84,0,0,144,84,0,0,112,84,0,0,24,37,0,0,144,84,0,0,112,84,0,0,24,37,0,0,144,84,0,0,144,84,0,0,112,84,0,0,24,37,0,0,144,84,0,0,144,84,0,0,144,84,0,0,128,84,0,0,24,37,0,0,144,84,0,0,128,84,0,0,24,37,0,0,144,84,0,0,144,84,0,0,128,84,0,0,24,37,0,0,144,84,0,0,144,84,0,0,144,84,0,0,136,84,0,0,24,37,0,0,144,84,0,0,136,84,0,0,24,37,0,0,144,84,0,0,144,84,0,0,136,84,0,0,24,37,0,0,144,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,24,37,0,0,144,84,0,0,144,84,0,0,24,37,0,0,144,84,0,0,144,84,0,0,144,84,0,0,24,37,0,0,144,84,0,0,144,84,0,0,144,84,0,0,176,84,0,0,24,37,0,0,144,84,0,0,176,84,0,0,24,37,0,0,144,84,0,0,144,84,0,0,176,84,0,0,24,37,0,0,144,84,0,0,144,84,0,0,144,84,0,0,184,84,0,0,24,37,0,0,144,84,0,0,144,84,0,0,144,84,0,0,184,84,0,0,24,37,0,0,144,84,0,0,184,84,0,0,24,37,0,0,144,84,0,0,144,84,0,0,32,34,0,0,184,33,0,0,192,33,0,0,184,33,0,0,184,37,0,0,184,33,0,0,184,48,0,0,144,84,0,0,200,37,0,0,112,35,0,0,192,37,0,0,112,35,0,0,112,35,0,0,192,37,0,0,112,35,0,0,88,37,0,0,144,84,0,0,144,84,0,0,32,34,0,0,112,35,0,0,192,33,0,0,168,37,0,0,224,37,0,0,80,84,0,0,112,35,0,0,112,35,0,0,184,84,0,0,184,84,0,0,144,84,0,0,96,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,184,84,0,0,184,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,184,84,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,184,84,0,0,184,84,0,0,96,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,184,84,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,56,37,0,0,184,84,0,0,184,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,56,37,0,0,184,84,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,56,37,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,184,84,0,0,184,84,0,0,184,84,0,0,184,84,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,184,84,0,0,184,84,0,0,184,84,0,0,184,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,184,84,0,0,184,84,0,0,184,84,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,184,84,0,0,184,84,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,184,84,0,0,184,84,0,0,144,84,0,0,184,84,0,0,184,84,0,0,184,84,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,184,84,0,0,184,84,0,0,144,84,0,0,184,84,0,0,184,84,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,184,84,0,0,184,84,0,0,144,84,0,0,184,84,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,184,84,0,0,184,84,0,0,144,84,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,184,84,0,0,184,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,184,84,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,144,84,0,0,184,84,0,0,184,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,144,84,0,0,184,84,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,144,84,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,184,84,0,0,184,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,184,84,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,184,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,80,84,0,0,112,35,0,0,184,84,0,0,112,35,0,0,184,84,0,0,184,84,0,0,112,35,0,0,144,84,0,0,80,84,0,0,112,35,0,0,184,84,0,0,112,35,0,0,184,84,0,0,184,84,0,0,112,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,184,84,0,0,96,84,0,0,184,84,0,0,112,35,0,0,96,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,184,84,0,0,184,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,56,37,0,0,24,35,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,56,37,0,0,24,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,56,37,0,0,192,33,0,0,112,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,56,37,0,0,24,35,0,0,96,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,56,37,0,0,24,35,0,0,96,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,56,37,0,0,24,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,56,37,0,0,80,84,0,0,56,35,0,0,32,34,0,0,112,35,0,0,112,35,0,0,32,34,0,0,184,84,0,0,80,84,0,0,56,35,0,0,32,34,0,0,112,35,0,0,112,35,0,0,32,34,0,0,32,34,0,0,96,84,0,0,80,84,0,0,56,35,0,0,32,34,0,0,112,35,0,0,112,35,0,0,32,34,0,0,32,34,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,184,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,184,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,56,37,0,0,144,84,0,0,168,37,0,0,144,84,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,56,37,0,0,144,84,0,0,168,37,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,56,37,0,0,144,84,0,0,168,37,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,56,37,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,56,37,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,96,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,80,84,0,0,112,35,0,0,24,35,0,0,144,84,0,0,88,37,0,0,144,84,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,24,35,0,0,144,84,0,0,88,37,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,24,35,0,0,144,84,0,0,88,37,0,0,144,84,0,0,80,84,0,0,112,35,0,0,24,35,0,0,144,84,0,0,88,37,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,144,84,0,0,184,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,144,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,144,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,184,84,0,0,112,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,96,84,0,0,96,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,96,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,88,37,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,184,84,0,0,144,84,0,0,144,84,0,0,112,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,24,35,0,0,144,84,0,0,144,84,0,0,88,37,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,24,35,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,24,35,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,24,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,184,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,184,84,0,0,80,84,0,0,184,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,80,84,0,0,184,84,0,0,112,35,0,0,112,35,0,0,80,84,0,0,112,35,0,0,56,35,0,0,144,84,0,0,88,37,0,0,144,84,0,0,144,84,0,0,112,35,0,0,144,84,0,0,24,35,0,0,80,84,0,0,112,35,0,0,56,35,0,0,144,84,0,0,88,37,0,0,144,84,0,0,144,84,0,0,112,35,0,0,144,84,0,0,80,84,0,0,112,35,0,0,56,35,0,0,144,84,0,0,88,37,0,0,144,84,0,0,144,84,0,0,112,35,0,0,80,84,0,0,112,35,0,0,56,35,0,0,144,84,0,0,88,37,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,56,35,0,0,144,84,0,0,88,37,0,0,144,84,0,0,80,84,0,0,112,35,0,0,56,35,0,0,144,84,0,0,88,37,0,0,80,84,0,0,112,35,0,0,144,35,0,0,112,35,0,0,88,37,0,0,144,84,0,0,80,84,0,0,112,35,0,0,144,35,0,0,112,35,0,0,88,37,0,0,80,84,0,0,112,35,0,0,144,35,0,0,112,35,0,0,80,84,0,0,112,35,0,0,144,35,0,0,112,35,0,0,144,35,0,0,32,34,0,0,112,35,0,0,88,37,0,0,88,37,0,0,32,34,0,0,144,84,0,0,80,84,0,0,112,35,0,0,144,35,0,0,112,35,0,0,144,35,0,0,32,34,0,0,112,35,0,0,88,37,0,0,88,37,0,0,32,34,0,0,80,84,0,0,112,35,0,0,144,35,0,0,112,35,0,0,144,35,0,0,32,34,0,0,112,35,0,0,88,37,0,0,88,37,0,0,80,84,0,0,112,35,0,0,144,35,0,0,112,35,0,0,144,35,0,0,32,34,0,0,112,35,0,0,88,37,0,0,80,84,0,0,112,35,0,0,144,35,0,0,112,35,0,0,144,35,0,0,32,34,0,0,112,35,0,0,96,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,96,84,0,0,112,35,0,0,112,35,0,0,80,84,0,0,112,35,0,0,24,35,0,0,56,37,0,0,184,84,0,0,184,84,0,0,184,84,0,0,88,37,0,0,144,84,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,24,35,0,0,56,37,0,0,184,84,0,0,184,84,0,0,184,84,0,0,88,37,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,24,35,0,0,56,37,0,0,184,84,0,0,184,84,0,0,184,84,0,0,88,37,0,0,144,84,0,0,80,84,0,0,112,35,0,0,24,35,0,0,56,37,0,0,184,84,0,0,184,84,0,0,184,84,0,0,88,37,0,0,80,84,0,0,112,35,0,0,184,33,0,0,88,37,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,184,33,0,0,88,37,0,0,144,84,0,0,80,84,0,0,112,35,0,0,184,33,0,0,88,37,0,0,80,84,0,0,24,35,0,0,56,37,0,0,144,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,224,34,0,0,112,35,0,0,112,35,0,0,112,35,0,0,96,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,112,35,0,0,24,35,0,0,184,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,112,35,0,0,24,35,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,112,35,0,0,24,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,112,35,0,0,80,84,0,0,112,35,0,0,56,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,24,35,0,0,80,84,0,0,112,35,0,0,56,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,184,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,144,84,0,0,168,37,0,0,112,35,0,0,184,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,144,84,0,0,168,37,0,0,184,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,144,84,0,0,184,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,184,33,0,0,112,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,184,84,0,0,112,35,0,0,184,84,0,0,112,35,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,184,84,0,0,112,35,0,0,184,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,176,33,0,0,184,84,0,0,184,84,0,0,112,35,0,0,144,84,0,0,56,37,0,0,24,35,0,0,112,35,0,0,144,84,0,0,56,37,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,184,84,0,0,184,84,0,0,112,35,0,0,144,84,0,0,96,84,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,184,84,0,0,184,84,0,0,112,35,0,0,144,84,0,0,96,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,184,84,0,0,184,84,0,0,112,35,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,184,84,0,0,184,84,0,0,112,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,184,84,0,0,184,84,0,0,112,35,0,0,144,84,0,0,144,84,0,0,96,84,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,184,84,0,0,184,84,0,0,112,35,0,0,144,84,0,0,144,84,0,0,96,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,184,84,0,0,184,84,0,0,112,35,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,192,33,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,192,33,0,0,112,35,0,0,112,35,0,0,144,84,0,0,80,84,0,0,56,36,0,0,232,33,0,0,144,84,0,0,184,84,0,0,80,84,0,0,56,36,0,0,232,33,0,0,144,84,0,0,80,84,0,0,56,35,0,0,112,35,0,0,96,84,0,0,224,37,0,0,112,35,0,0,40,38,0,0,32,34,0,0,96,84,0,0,224,37,0,0,112,35,0,0,40,38,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,56,37,0,0,144,84,0,0,112,35,0,0,112,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,184,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,184,84,0,0,112,35,0,0,112,35,0,0,96,84,0,0,112,35,0,0,184,84,0,0,112,35,0,0,144,84,0,0,112,35,0,0,168,37,0,0,144,84,0,0,144,84,0,0,112,35,0,0,184,84,0,0,112,35,0,0,144,84,0,0,112,35,0,0,168,37,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,24,35,0,0,24,35,0,0,88,37,0,0,144,84,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,24,35,0,0,24,35,0,0,88,37,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,24,35,0,0,24,35,0,0,88,37,0,0,144,84,0,0,80,84,0,0,112,35,0,0,24,35,0,0,24,35,0,0,88,37,0,0,184,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,144,84,0,0,112,35,0,0,88,37,0,0,112,35,0,0,112,35,0,0,88,37,0,0,112,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,80,84,0,0,56,35,0,0,56,35,0,0,32,34,0,0,208,37,0,0,112,35,0,0,96,84,0,0,208,37,0,0,112,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,112,35,0,0,24,35,0,0,144,84,0,0,144,84,0,0,88,37,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,112,35,0,0,24,35,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,112,35,0,0,24,35,0,0,144,84,0,0,184,84,0,0,112,35,0,0,144,84,0,0,112,35,0,0,184,84,0,0,112,35,0,0,144,84,0,0,184,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,112,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,184,84,0,0,184,84,0,0,144,84,0,0,144,84,0,0,112,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,184,84,0,0,184,84,0,0,144,84,0,0,144,84,0,0,184,84,0,0,112,35,0,0,176,33,0,0,96,84,0,0,80,84,0,0,112,35,0,0,184,84,0,0,112,35,0,0,80,84,0,0,112,35,0,0,224,37,0,0,24,35,0,0,144,84,0,0,184,84,0,0,88,37,0,0,144,84,0,0,144,84,0,0,96,84,0,0,80,84,0,0,112,35,0,0,224,37,0,0,24,35,0,0,144,84,0,0,184,84,0,0,88,37,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,224,37,0,0,24,35,0,0,144,84,0,0,184,84,0,0,88,37,0,0,144,84,0,0,80,84,0,0,112,35,0,0,224,37,0,0,24,35,0,0,144,84,0,0,184,84,0,0,88,37,0,0,80,84,0,0,112,35,0,0,112,35,0,0,56,37,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,56,37,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,88,37,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,144,84,0,0,80,84,0,0,112,35,0,0,144,84,0,0,144,84,0,0,112,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,112,35,0,0,112,35,0,0,24,35,0,0,184,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,112,35,0,0,112,35,0,0,24,35,0,0,184,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,112,35,0,0,112,35,0,0,24,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,144,84,0,0,112,35,0,0,112,35,0,0,80,84,0,0,112,35,0,0,80,84,0,0,144,84,0,0,96,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,144,84,0,0,96,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,80,84,0,0,112,35,0,0,56,35,0,0,184,84,0,0,112,35,0,0,112,35,0,0,184,84,0,0,184,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,112,35,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,56,37,0,0,144,84,0,0,144,84,0,0,88,37,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,56,37,0,0,144,84,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,56,37,0,0,144,84,0,0,80,84,0,0,112,35,0,0,112,35,0,0,112,35,0,0,56,37,0,0,96,38,0,0,248,37,0,0,96,38,0,0,96,84,0,0,136,71,0,0,224,37,0,0,224,37,0,0,96,84,0,0,136,71,0,0,224,37,0,0,104,38,0,0,104,38,0,0,56,37,0,0,56,37,0,0,56,37,0,0,56,37,0,0,144,84,0,0,144,84,0,0,184,84,0,0,144,84,0,0,184,84,0,0,96,84,0,0,144,84,0,0,96,84,0,0,104,38,0,0,136,38,0,0,64,34,0,0,80,84,0,0,136,71,0,0,112,35,0,0,80,84,0,0,136,71,0,0,112,35,0,0,56,36,0,0,144,34,0,0,184,84,0,0,56,37,0,0,56,37,0,0,184,84,0,0,184,84,0,0,96,84,0,0,80,84,0,0,136,71,0,0,112,35,0,0,56,36,0,0,144,34,0,0,184,84,0,0,56,37,0,0,56,37,0,0,184,84,0,0,184,84,0,0,80,84,0,0,136,71,0,0,112,35,0,0,56,36,0,0,144,34,0,0,184,84,0,0,56,37,0,0,56,37,0,0,184,84,0,0,80,84,0,0,136,71,0,0,112,35,0,0,56,36,0,0,144,34,0,0,184,84,0,0,56,37,0,0,56,37,0,0,80,84,0,0,136,71,0,0,112,35,0,0,56,36,0,0,144,34,0,0,184,84,0,0,56,37,0,0,80,84,0,0,136,71,0,0,112,35,0,0,56,36,0,0,144,34,0,0,184,84,0,0,80,84,0,0,136,71,0,0,112,35,0,0,56,36,0,0,144,34,0,0,80,84,0,0,144,38,0,0,112,35,0,0,112,35,0,0,184,84,0,0,80,84,0,0,144,38,0,0,112,35,0,0,112,35,0,0,80,84,0,0,144,38,0,0,112,35,0,0,240,38,0,0,144,84,0,0,184,84,0,0,96,84,0,0,240,38,0,0,144,84,0,0,184,84,0,0,240,38,0,0,144,84,0,0,240,38,0,0,80,84,0,0,192,38,0,0,112,35,0,0,112,35,0,0,184,84,0,0,80,84,0,0,192,38,0,0,112,35,0,0,112,35,0,0,80,84,0,0,248,38,0,0,56,37,0,0,40,39,0,0,184,84,0,0,56,37,0,0,40,39,0,0,184,84,0,0,40,39,0,0,80,84,0,0,8,39,0,0,80,84,0,0,248,38,0,0,184,84,0,0,56,37,0,0,24,39,0,0,184,84,0,0,24,39,0,0,80,84,0,0,248,38,0,0,112,35,0,0,112,35,0,0,224,37,0,0,232,74,0,0,80,84,0,0,232,74,0,0,112,35,0,0,144,35,0,0,112,35,0,0,80,84,0,0,232,74,0,0,112,35,0,0,144,35,0,0,80,84,0,0,232,74,0,0,112,35,0,0,144,35,0,0,112,35,0,0,80,84,0,0,232,74,0,0,112,35,0,0,112,35,0,0,144,35,0,0,112,35,0,0,96,84,0,0,80,84,0,0,232,74,0,0,112,35,0,0,112,35,0,0,144,35,0,0,112,35,0,0,96,84,0,0,96,39,0,0,144,39,0,0,224,37,0,0,80,84,0,0,0,75,0,0,112,35,0,0,112,35,0,0,136,36,0,0,112,35,0,0,80,84,0,0,0,75,0,0,112,35,0,0,112,35,0,0,136,36,0,0,96,84,0,0,152,39,0,0,224,37,0,0,80,84,0,0,152,39,0,0,112,35,0,0,56,36,0,0,232,33,0,0,184,84,0,0,144,84,0,0,144,84,0,0,56,37,0,0,56,37,0,0,80,84,0,0,152,39,0,0,112,35,0,0,56,36,0,0,232,33,0,0,184,84,0,0,144,84,0,0,144,84,0,0,56,37,0,0,80,84,0,0,152,39,0,0,112,35,0,0,56,36,0,0,232,33,0,0,184,84,0,0,144,84,0,0,144,84,0,0,80,84,0,0,152,39,0,0,112,35,0,0,56,36,0,0,232,33,0,0,184,84,0,0,144,84,0,0,80,84,0,0,152,39,0,0,112,35,0,0,56,36,0,0,232,33,0,0,184,84,0,0,80,84,0,0,152,39,0,0,112,35,0,0,56,36,0,0,232,33,0,0,160,39,0,0,160,39,0,0,136,38,0,0,80,84,0,0,152,39,0,0,112,35,0,0,56,36,0,0,232,33,0,0,144,34,0,0,184,84,0,0,144,84,0,0,144,84,0,0,56,37,0,0,56,37,0,0,96,84,0,0,80,84,0,0,152,39,0,0,112,35,0,0,56,36,0,0,232,33,0,0,144,34,0,0,184,84,0,0,144,84,0,0,144,84,0,0,56,37,0,0,56,37,0,0,80,84,0,0,152,39,0,0,112,35,0,0,56,36,0,0,232,33,0,0,144,34,0,0,184,84,0,0,144,84,0,0,144,84,0,0,56,37,0,0,80,84,0,0,152,39,0,0,112,35,0,0,56,36,0,0,232,33,0,0,144,34,0,0,184,84,0,0,144,84,0,0,144,84,0,0,80,84,0,0,152,39,0,0,112,35,0,0,56,36,0,0,232,33,0,0,144,34,0,0,184,84,0,0,144,84,0,0,80,84,0,0,152,39,0,0,112,35,0,0,56,36,0,0,232,33,0,0,144,34,0,0,184,84,0,0,80,84,0,0,152,39,0,0,112,35,0,0,56,36,0,0,232,33,0,0,144,34,0,0,96,84,0,0,176,39,0,0,80,84,0,0,152,39,0,0,112,35,0,0,56,36,0,0,184,84,0,0,144,84,0,0,144,84,0,0,56,37,0,0,56,37,0,0,80,84,0,0,152,39,0,0,112,35,0,0,56,36,0,0,184,84,0,0,144,84,0,0,144,84,0,0,56,37,0,0,80,84,0,0,152,39,0,0,112,35,0,0,56,36,0,0,184,84,0,0,144,84,0,0,144,84,0,0,80,84,0,0,152,39,0,0,112,35,0,0,56,36,0,0,184,84,0,0,144,84,0,0,80,84,0,0,152,39,0,0,112,35,0,0,56,36,0,0,184,84,0,0,80,84,0,0,152,39,0,0,112,35,0,0,56,36,0,0,96,84,0,0,208,39,0,0,144,84,0,0,208,39,0,0,224,39,0,0,144,84,0,0,96,84,0,0,144,84,0,0,224,39,0,0,144,84,0,0,96,84,0,0,224,39,0,0,144,84,0,0,224,39,0,0,80,84,0,0,184,74,0,0,96,84,0,0,80,84,0,0,184,74,0,0,144,84,0,0,144,84,0,0,248,39,0,0,80,84,0,0,48,75,0,0,144,84,0,0,8,40,0,0,144,84,0,0,176,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,8,40,0,0,144,84,0,0,176,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,8,40,0,0,144,84,0,0,176,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,8,40,0,0,144,84,0,0,176,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,8,40,0,0,144,84,0,0,176,84,0,0,144,84,0,0,144,84,0,0,144,84,0,0,8,40,0,0,144,84,0,0,176,84,0,0,144,84,0,0,144,84,0,0,8,40,0,0,144,84,0,0,176,84,0,0,144,84,0,0,8,40,0,0,144,84,0,0,176,84,0,0,8,40,0,0,144,84,0,0,8,40,0,0,184,84,0,0,248,39,0,0,80,84,0,0,48,75,0,0,184,84,0,0,0,0,0,0,16,40,0,0,1,0,0,0,2,0,0,0,3,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,3,0,0,0,4,0,0,0,96,191,13,0,84,96,2,0,141,96,2,0,69,0,0,0,1,0,0,0,100,191,13,0,192,96,2,0,141,96,2,0,60,0,0,0,1,0,0,0,104,191,13,0,251,96,2,0,141,96,2,0,55,0,0,0,1,0,0,0,108,191,13,0,47,97,2,0,141,96,2,0,50,0,0,0,1,0,0,0,112,191,13,0,74,97,2,0,141,96,2,0,75,0,0,0,1,0,0,0,116,191,13,0,20,99,2,0,248,97,2,0,116,1,0,0,1,0,0,0,120,191,13,0,90,99,2,0,248,97,2,0,124,1,0,0,1,0,0,0,124,191,13,0,159,99,2,0,248,97,2,0,132,1,0,0,1,0,0,0,128,191,13,0,229,99,2,0,248,97,2,0,140,1,0,0,1,0,0,0,132,191,13,0,31,100,2,0,248,97,2,0,148,1,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,136,191,13,0,81,100,2,0,248,97,2,0,155,1,0,0,1,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,140,191,13,0,131,100,2,0,248,97,2,0,162,1,0,0,1,0,0,0,144,191,13,0,189,100,2,0,248,97,2,0,170,1,0,0,1,0,0,0,148,191,13,0,220,102,2,0,248,97,2,0,156,3,0,0,1,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,152,191,13,0,31,103,2,0,248,97,2,0,164,3,0,0,1,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,0,0,0,0,156,191,13,0,103,103,2,0,248,97,2,0,224,3,0,0,1,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,0,0,0,0,160,191,13,0,157,103,2,0,248,97,2,0,21,4,0,0,1,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,0,0,0,0,164,191,13,0,225,103,2,0,248,97,2,0,30,4,0,0,1,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,0,0,0,0,168,191,13,0,35,104,2,0,248,97,2,0,38,4,0,0,1,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+20484);allocate([55,0,0,0,56,0,0,0,0,0,0,0,172,191,13,0,89,104,2,0,248,97,2,0,67,4,0,0,1,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,0,0,0,0,176,191,13,0,161,105,2,0,248,97,2,0,207,4,0,0,1,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,0,0,0,0,180,191,13,0,198,106,2,0,248,97,2,0,217,6,0,0,1,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,0,0,0,0,184,191,13,0,63,107,2,0,14,107,2,0,144,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,188,191,13,0,165,107,2,0,14,107,2,0,244,0,0,0,1,0,0,0,196,191,13,0,34,109,2,0,14,107,2,0,69,1,0,0,1,0,0,0,5,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,0,0,0,0,192,191,13,0,204,108,2,0,14,107,2,0,57,2,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,200,191,13,0,87,109,2,0,14,107,2,0,217,1,0,0,1,0,0,0,204,191,13,0,156,109,2,0,14,107,2,0,235,2,0,0,1,0,0,0,208,191,13,0,33,110,2,0,14,107,2,0,12,3,0,0,1,0,0,0,212,191,13,0,162,110,2,0,14,107,2,0,126,3,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,8,0,0,0,1,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,0,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,0,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,16,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,0,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,31,0,0,0,39,0,0,0,0,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,191,13,0,232,110,2,0,14,107,2,0,198,19,0,0,1,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,0,0,0,0,220,191,13,0,52,111,2,0,14,107,2,0,87,20,0,0,1,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,0,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,0,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,0,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,0,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,0,0,0,0,89,0,0,0,90,0,0,0,91,0,0,0,92,0,0,0,93,0,0,0,94,0,0,0,95,0,0,0,0,0,0,0,96,0,0,0,97,0,0,0,98,0,0,0,99,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,191,13,0,178,111,2,0,14,107,2,0,127,22,0,0,1,0,0,0,0,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,0,0,0,0,107,0,0,0,0,0,0,0,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,0,0,228,191,13,0,90,112,2,0,9,112,2,0,255,0,0,0,1,0,0,0,236,191,13,0,6,113,2,0,9,112,2,0,115,1,0,0,1,0,0,0,232,191,13,0,218,112,2,0,9,112,2,0,162,1,0,0,1,0,0,0,240,191,13,0,203,113,2,0,9,112,2,0,251,1,0,0,1,0,0,0,244,191,13,0,0,114,2,0,9,112,2,0,219,2,0,0,1,0,0,0,248,191,13,0,99,114,2,0,9,112,2,0,83,3,0,0,1,0,0,0,252,191,13,0,79,115,2,0,9,112,2,0,146,4,0,0,1,0,0,0,0,0,0,0,200,42,0,0,1,0,0,0,4,0,0,0,5,0,0,0,0,0,0,0,176,42,0,0,2,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,160,40,0,0,8,0,0,0,9,0,0,0,10,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,0,0,0,0,0,43,0,0,1,0,0,0,11,0,0,0,12,0,0,0,0,0,0,0,232,42,0,0,2,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,216,42,0,0,8,0,0,0,15,0,0,0,16,0,0,0,0,192,13,0,205,125,2,0,23,122,2,0,253,12,0,0,1,0,0,0,4,192,13,0,60,126,2,0,23,122,2,0,212,13,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,12,0,0,0,15,0,0,0,16,0,0,0,18,0,0,0,20,0,0,0,24,0,0,0,25,0,0,0,27,0,0,0,30,0,0,0,32,0,0,0,36,0,0,0,40,0,0,0,45,0,0,0,48,0,0,0,50,0,0,0,54,0,0,0,60,0,0,0,64,0,0,0,72,0,0,0,75,0,0,0,80,0,0,0,81,0,0,0,90,0,0,0,96,0,0,0,100,0,0,0,108,0,0,0,120,0,0,0,125,0,0,0,128,0,0,0,135,0,0,0,144,0,0,0,150,0,0,0,160,0,0,0,162,0,0,0,180,0,0,0,192,0,0,0,200,0,0,0,216,0,0,0,225,0,0,0,240,0,0,0,243,0,0,0,250,0,0,0,0,1,0,0,14,1,0,0,32,1,0,0,44,1,0,0,64,1,0,0,68,1,0,0,104,1,0,0,119,1,0,0,128,1,0,0,144,1,0,0,149,1,0,0,176,1,0,0,194,1,0,0,224,1,0,0,230,1,0,0,244,1,0,0,0,2,0,0,28,2,0,0,64,2,0,0,88,2,0,0,113,2,0,0,128,2,0,0,136,2,0,0,163,2,0,0,208,2,0,0,217,2,0,0,238,2,0,0,0,3,0,0,32,3,0,0,42,3,0,0,96,3,0,0,132,3,0,0,192,3,0,0,204,3,0,0,232,3,0,0,0,4,0,0,56,4,0,0,101,4,0,0,128,4,0,0,176,4,0,0,191,4,0,0,226,4,0,0,0,5,0,0,16,5,0,0,70,5,0,0,160,5,0,0,178,5,0,0,220,5,0,0,0,6,0,0,64,6,0,0,84,6,0,0,192,6,0,0,8,7,0,0,83,7,0,0,128,7,0,0,152,7,0,0,208,7,0,0,233,7,0,0,0,8,0,0,112,8,0,0,139,8,0,0,202,8,0,0,0,9,0,0,96,9,0,0,126,9,0,0,196,9,0,0,0,10,0,0,32,10,0,0,140,10,0,0,64,11,0,0,100,11,0,0,184,11,0,0,0,12,0,0,53,12,0,0,128,12,0,0,168,12,0,0,47,13,0,0,128,13,0,0,16,14,0,0,61,14,0,0,166,14,0,0,0,15,0,0,48,15,0,0,160,15,0,0,210,15,0,0,0,16,0,0,224,16,0,0,22,17,0,0,148,17,0,0,0,18,0,0,192,18,0,0,252,18,0,0,136,19,0,0,0,20,0,0,64,20,0,0,24,21,0,0,249,21,0,0,128,22,0,0,200,22,0,0,112,23,0,0,187,23,0,0,0,24,0,0,106,24,0,0,0,25,0,0,80,25,0,0,161,25,0,0,94,26,0,0,0,27,0,0,32,28,0,0,122,28,0,0,76,29,0,0,0,30,0,0,96,30,0,0,64,31,0,0,164,31,0,0,0,32,0,0,192,33,0,0,44,34,0,0,40,35,0,0,0,36,0,0,159,36,0,0,128,37,0,0,248,37,0,0,16,39,0,0,141,39,0,0,0,40,0,0,128,40,0,0,48,42,0,0,183,42,0,0,242,43,0,0,0,45,0,0,144,45,0,0,224,46,0,0,118,47,0,0,0,48,0,0,212,48,0,0,0,50,0,0,160,50,0,0,66,51,0,0,188,52,0,0,0,54,0,0,64,56,0,0,244,56,0,0,152,58,0,0,0,60,0,0,192,60,0,0,9,61,0,0,128,62,0,0,72,63,0,0,0,64,0,0,235,65,0,0,128,67,0,0,88,68,0,0,80,70,0,0,49,71,0,0,0,72,0,0,62,73,0,0,0,75,0,0,240,75,0,0,227,76,0,0,32,78,0,0,26,79,0,0,0,80,0,0,0,81,0,0,96,84,0,0,110,85,0,0,228,87,0,0,0,90,0,0,32,91,0,0,192,93,0,0,236,94,0,0,0,96,0,0,168,97,0,0,0,100,0,0,64,101,0,0,132,102,0,0,120,105,0,0,0,108,0,0,221,109,0,0,128,112,0,0,232,113,0,0,48,117,0,0,167,118,0,0,0,120,0,0,128,121,0,0,18,122,0,0,0,125,0,0,144,126,0,0,0,128,0,0,37,128,0,0,214,131,0,0,0,135,0,0,176,136,0,0,160,140,0,0,98,142,0,0,0,144,0,0,124,146,0,0,0,150,0,0,224,151,0,0,198,153,0,0,64,156,0,0,52,158,0,0,0,160,0,0,0,162,0,0,192,168,0,0,220,170,0,0,200,175,0,0,0,180,0,0,64,182,0,0,27,183,0,0,128,187,0,0,216,189,0,0,0,192,0,0,80,195,0,0,193,197,0,0,0,200,0,0,128,202,0,0,8,205,0,0,240,210,0,0,147,213,0,0,0,216,0,0,186,219,0,0,0,225,0,0,208,227,0,0,169,230,0,0,96,234,0,0,78,237,0,0,0,240,0,0,0,243,0,0,36,244,0,0,0,250,0,0,32,253,0,0,0,0,1,0,74,0,1,0,172,7,1,0,0,14,1,0,96,17,1,0,64,25,1,0,196,28,1,0,0,32,1,0,248,36,1,0,0,44,1,0,192,47,1,0,45,49,1,0,140,51,1,0,128,56,1,0,104,60,1,0,0,64,1,0,0,68,1,0,151,73,1,0,128,81,1,0,184,85,1,0,144,95,1,0,245,99,1,0,0,104,1,0,128,108,1,0,54,110,1,0,0,119,1,0,176,123,1,0,0,128,1,0,111,128,1,0,160,134,1,0,130,139,1,0,0,144,1,0,0,149,1,0,16,154,1,0,224,165,1,0,38,171,1,0,0,176,1,0,116,183,1,0,0,194,1,0,160,199,1,0,82,205,1,0,192,212,1,0,156,218,1,0,0,224,1,0,0,230,1,0,72,232,1,0,0,244,1,0,64,250,1,0,0,0,2,0,148,0,2,0,88,15,2,0,0,28,2,0,192,34,2,0,81,37,2,0,128,50,2,0,136,57,2,0,0,64,2,0,240,73,2,0,67,81,2,0,0,88,2,0,128,95,2,0,90,98,2,0,24,103,2,0,0,113,2,0,208,120,2,0,0,128,2,0,185,128,2,0,0,136,2,0,46,147,2,0,0,163,2,0,112,171,2,0,251,179,2,0,32,191,2,0,234,199,2,0,0,208,2,0,0,217,2,0,108,220,2,0,0,238,2,0,96,247,2,0,0,0,3,0,222,0,3,0,64,13,3,0,4,23,3,0,0,32,3,0,0,42,3,0,32,52,3,0,192,75,3,0,76,86,3,0,0,96,3,0,232,110,3,0,0,132,3,0,64,143,3,0,135,147,3,0,164,154,3,0,128,169,3,0,56,181,3,0,0,192,3,0,0,204,3,0,144,208,3,0,197,220,3,0,0,232,3,0,128,244,3,0,0,0,4,0,40,1,4,0,176,30,4,0,223,43,4,0,0,56,4,0,128,69,4,0,162,74,4,0,0,101,4,0,16,115,4,0,0,128,4,0,77,129,4,0,224,147,4,0,134,162,4,0,0,176,4,0,0,191,4,0,180,196,4,0,48,206,4,0,0,226,4,0,160,241,4,0,0,0,5,0,114,1,5,0,0,16,5,0,92,38,5,0,0,70,5,0,224,86,5,0,246,103,5,0,64,126,5,0,212,143,5,0,0,160,5,0,0,178,5,0,216,184,5,0,0,220,5,0,192,238,5,0,225,245,5,0,0,0,6,0,188,1,6,0,128,26,6,0,8,46,6,0,0,64,6,0,0,84,6,0,64,104,6,0,243,111,6,0,128,151,6,0,152,172,6,0,0,192,6,0,208,221,6,0,201,243,6,0,0,8,7,0,128,30,7,0,14,39,7,0,72,53,7,0,0,83,7,0,112,106,7,0,0,128,7,0,43,130,7,0,0,152,7,0,32,161,7,0,138,185,7,0,0,208,7,0,0,233,7,0,0,0,8,0,80,2,8,0,241,27,8,0,96,61,8,0,190,87,8,0,0,112,8,0,0,139,8,0,68,149,8,0,0,202,8,0,32,230,8,0,0,0,9,0,154,2,9,0,192,39,9,0,12,69,9,0,0,96,9,0,0,126,9,0,104,137,9,0,96,156,9,0,0,196,9,0,64,227,9,0,0,0,10,0,228,2,10,0,0,32,10,0,184,76,10,0,0,140,10,0,192,173,10,0,149,186,10,0,236,207,10,0,128,252,10,0,168,31,11,0,0,64,11,0,0,100,11,0,176,113,11,0,79,150,11,0,0,184,11,0,128,221,11,0,194,235,11,0,0,0,12,0,120,3,12,0,0,53,12,0,16,92,12,0,0,128,12,0,157,131,12,0,0,168,12,0,128,208,12,0,230,223,12,0,0,47,13,0,48,89,13,0,0,128,13,0,231,131,13,0,160,187,13,0,146,231,13,0,0,16,14,0,0,61,14,0,28,78,14,0,144,106,14,0,0,166,14,0,224,212,14,0,0,0,15,0,86,4,15,0,0,48,15,0,64,66,15,0,20,115,15,0,0,160,15,0,0,210,15,0,0,0,16,0,160,4,16,0,226,55,16,0,192,122,16,0,124,175,16,0,0,224,16,0,0,22,17,0,136,42,17,0,0,148,17,0,64,204,17,0,163,225,17,0,0,0,18,0,52,5,18,0,128,79,18,0,24,138,18,0,0,192,18,0,0,252,18,0,208,18,19,0,192,56,19,0,217,79,19,0,0,136,19,0,128,198,19,0,0,0,20,0,200,5,20,0,0,64,20,0,112,153,20,0,91,219,20,0,0,24,21,0,128,91,21,0,42,117,21,0,216,159,21,0,0,249,21,0,80,63,22,0,0,128,22,0,129,134,22,0,0,200,22,0,96,227,22,0,158,44,23,0,0,112,23,0,0,187,23,0,132,215,23,0,0,0,24,0,240,6,24,0,211,83,24,0,0,106,24,0,32,184,24,0,0,0,25,0,58,7,25,0,0,80,25,0,0,161,25,0,204,191,25,0,0,94,26,0,96,178,26,0,0,0,27,0,206,7,27,0,64,119,27,0,36,207,27,0,0,32,28,0,0,122,28,0,56,156,28,0,32,213,28,0,0,76,29,0,192,169,29,0,101,205,29,0,0,0,30,0,172,8,30,0,0,96,30,0,128,132,30,0,40,230,30,0,0,64,31,0,0,164,31,0,0,0,32,0,64,9,32,0,191,47,32,0,196,111,32,0,128,245,32,0,248,94,33,0,0,192,33,0,0,44,34,0,16,85,34,0,237,194,34,0,0,40,35,0,128,152,35,0,70,195,35,0,0,0,36,0,104,10,36,0,0,159,36,0,48,20,37,0,0,128,37,0,215,138,37,0,0,248,37,0,160,37,38,0,128,113,38,0,178,159,38,0,0,16,39,0,0,141,39,0,0,0,40,0,144,11,40,0,0,128,40,0,181,139,40,0,224,50,41,0,182,182,41,0,0,48,42,0,0,183,42,0,84,234,42,0,176,63,43,0,0,242,43,0,160,126,44,0,0,0,45,0,2,13,45,0,0,144,45,0,192,198,45,0,60,89,46,0,0,224,46,0,0,118,47,0,8,175,47,0,0,0,48,0,224,13,48,0,166,167,48,0,0,212,48,0,64,112,49,0,0,0,50,0,116,14,50,0,0,160,50,0,0,66,51,0,152,127,51,0,0,188,52,0,192,100,53,0,233,164,53,0,0,0,54,0,156,15,54,0,128,238,54,0,72,158,55,0,0,64,56,0,0,244,56,0,112,56,57,0,64,170,57,0,139,239,57,0,0,152,58,0,128,83,59,0,202,154,59,0,0,0,60,0,88,17,60,0,0,192,60,0,0,9,61,0,80,204,61,0,0,128,62,0,17,146,62,0,0,72,63,0,0,0,64,0,128,18,64,0,126,95,64,0,136,223,64,0,0,235,65,0,240,189,66,0,0,128,67,0,131,147,67,0,0,88,68,0,32,170,68,0,218,133,69,0,0,80,70,0,0,49,71,0,140,134,71,0,0,0,72,0,208,20,72,0,121,251,72,0,0,62,73,0,96,40,74,0,0,0,75,0,174,21,75,0,0,240,75,0,64,75,76,0,0,227,76,0,100,63,77,0,0,32,78,0,0,26,79,0,0,0,80,0,32,23,80,0,0,0,81,0,106,23,81,0,192,101,82,0,108,109,83,0,0,96,84,0,0,110,85,0,168,212,85,0,96,127,86,0,0,228,87,0,64,253,88,0,47,104,89,0,0,0,90,0,4,26,90,0,0,32,91,0,128,141,91,0,120,178,92,0,0,192,93,0,0,236,94,0,16,94,95,0,0,0,96,0,192,27,96,0,61,143,96,0,76,79,97,0,0,168,97,0,128,224,98,0,0,0,100,0,232,28,100,0,0,64,101,0,0,132,102,0,48,255,102,0,199,72,104,0,0,120,105,0,128,201,106,0,210,73,107,0,0,0,108,0,56,31,108,0,0,221,109,0,144,60,111,0,0,128,112,0,133,160,112,0,0,232,113,0,224,112,114,0,128,84,115,0,22,223,115,0,0,48,117,0,0,167,118,0,148,53,119,0,0,0,120,0,176,34,120,0,0,128,121,0,31,163,121,0,0,18,122,0,160,152,123,0,0,0,125,0,34,36,125,0,0,144,126,0,0,0,128,0,0,37,128,0,252,190,128,0,16,191,129,0,0,214,131,0,224,123,133,0,0,0,135,0,6,39,135,0,0,176,136,0,64,84,137,0,180,11,139,0,0,160,140,0,0,98,142,0,24,13,143,0,0,0,144,0,160,41,144,0,242,246,145,0,0,124,146,0,192,80,148,0,249,2,149,0,0,0,150,0,92,43,150,0,0,224,151,0,128,150,152,0,0,198,153,0,200,126,154,0,0,64,156,0,0,52,158,0,0,0,160,0,64,46,160,0,187,238,160,0,0,0,162,0,212,46,162,0,128,203,164,0,216,218,166,0,0,192,168,0,0,220,170,0,80,169,171,0,192,254,172,0,161,206,173,0,0,200,175,0,128,250,177,0,94,208,178,0,0,0,180,0,8,52,180,0,0,64,182,0,0,27,183,0,240,100,185,0,0,128,187,0,51,182,187,0,0,216,189,0,32,188,190,0,0,0,192,0,128,55,192,0,122,30,193,0,152,158,194,0,0,80,195,0,0,193,197,0,0,0,200,0,208,57,200,0,0,128,202,0,137,186,202,0,0,8,205,0,96,254,205,0,142,145,208,0,0,240,210,0,0,147,213,0,164,147,214,0,0,0,216,0,112,62,216,0,0,186,219,0,32,121,222,0,0,0,225,0,10,65,225,0,0,208,227,0,192,225,228,0,0,169,230,0,44,190,231,0,0,96,234,0,0,78,237,0,40,107,238,0,0,0,240,0,96,69,240,0,0,0,243,0,62,70,243,0,0,36,244,0,64,49,247,0,0,0,250,0,68,72,250,0,0,32,253,0,0,0,0,1,0,74,0,1,248,125,1,1,32,126,3,1,0,172,7,1,192,247,10,1,141,56,12,1,0,0,14,1,12,78,14,1,0,96,17,1,128,168,18,1,104,23,22,1,0,64,25,1,0,196,28,1,48,26,30,1,0,0,32,1,64,83,32,1,183,173,33,1,228,237,35,1,0,248,36,1,128,161,40,1,242,5,42,1,0,0,44,1,184,86,44,1,0,192,47,1,0,45,49,1,0,140,51,1,144,253,52,1,0,128,56,1,85,218,56,1,0,104,60,1,0,0,64,1,128,92,64,1,118,221,65,1,0,0,68,1,168,93,68,1,0,151,73,1,176,181,77,1,0,128,81,1,143,225,81,1,0,184,85,1,160,82,87,1,128,253,89,1,66,157,91,1,0,144,95,1,0,245,99,1,188,160,101,1,0,0,104,1,16,104,104,1,0,128,108,1,93,233,108,1,0,54,110,1,224,201,114,1,0,0,119,1,102,108,119,1,0,176,123,1,64,120,125,1,0,0,128,1,0,111,128,1,244,60,130,1,48,61,133,1,0,160,134,1,0,130,139,1,0,0,144,1,160,115,144,1,0,0,149,1,18,117,149,1,0,16,154,1,192,252,155,1,28,35,161,1,0,224,165,1,0,38,171,1,72,39,173,1,0,0,176,1,224,124,176,1,0,116,183,1,64,242,188,1,235,8,191,1,0,0,194,1,20,130,194,1,0,160,199,1,128,195,201,1,0,82,205,1,88,124,207,1,0,192,212,1,0,156,218,1,80,214,220,1,0,0,224,1,192,138,224,1,49,204,226,1,0,0,230,1,124,140,230,1,0,72,232,1,128,98,238,1,0,0,244,1,136,144,244,1,0,64,250,1,0,0,0,2,0,148,0,2,240,251,2,2,64,252,6,2,227,107,9,2,0,88,15,2,128,239,21,2,26,113,24,2,0,0,28,2,24,156,28,2,0,192,34,2,0,81,37,2,208,46,44,2,0,128,50,2,153,34,51,2,0,136,57,2,96,52,60,2,0,0,64,2,128,166,64,2,110,91,67,2,200,219,71,2,0,240,73,2,0,67,81,2,228,11,84,2,0,0,88,2,112,173,88,2,0,128,95,2,155,47,96,2,0,90,98,2,0,24,103,2,32,251,105,2,0,0,113,2,170,180,113,2,0,208,120,2,0,0,128,2,0,185,128,2,236,186,131,2,0,0,136,2,80,187,136,2,0,46,147,2,96,107,155,2,0,0,163,2,30,195,163,2,0,112,171,2,64,165,174,2,0,251,179,2,132,58,183,2,0,32,191,2,0,234,199,2,120,65,203,2,0,0,208,2,32,208,208,2,0,0,217,2,186,210,217,2,0,108,220,2,192,147,229,2,221,14,233,2,0,0,238,2,204,216,238,2,0,96,247,2,128,240,250,2,0,0,0,3,0,222,0,3,232,121,4,3,96,122,10,3,0,64,13,3,0,4,23,3,0,0,32,3,64,231,32,3,167,169,36,3,0,0,42,3,36,234,42,3,0,32,52,3,128,249,55,3,56,70,66,3,0,192,75,3,0,76,86,3,144,78,90,3,0,0,96,3,192,249,96,3,37,9,101,3,0,232,110,3,128,228,121,3,214,17,126,3,0,0,132,3,40,4,133,3,0,64,143,3,0,135,147,3,0,164,154,3,176,248,158,3,0,128,169,3,255,142,170,3,0,56,181,3,160,172,185,3,0,0,192,3,128,21,193,3,98,152,197,3,0,0,204,3,248,24,205,3,0,144,208,3,0,197,220,3,0,0,232,3,16,33,233,3,0,128,244,3,173,164,245,3,0,0,0,4,0,40,1,4,224,247,5,4,128,248,13,4,198,215,18,4,0,176,30,4,0,223,43,4,52,226,48,4,0,0,56,4,48,56,57,4,0,128,69,4,0,162,74,4,160,93,88,4,0,0,101,4,50,69,102,4,0,16,115,4,192,104,120,4,0,0,128,4,0,77,129,4,220,182,134,4,144,183,143,4,0,224,147,4,0,134,162,4,200,23,168,4,0,0,176,4,224,90,177,4,0,0,191,4,54,95,192,4,0,180,196,4,0,48,206,4,64,246,211,4,0,0,226,4,84,105,227,4,0,160,241,4,0,0,0,5,0,114,1,5,216,117,7,5,0,0,16,5,160,118,17,5,0,92,38,5,192,214,54,5,193,26,61,5,0,0,70,5,60,134,71,5,0,224,86,5,128,74,93,5,0,246,103,5,8,117,110,5,0,64,126,5,0,212,143,5,240,130,150,5,0,0,160,5,64,160,161,5,147,100,168,5,0,0,178,5,116,165,179,5,0,216,184,5,128,39,203,5,186,29,210,5,0,0,220,5,152,177,221,5,0,192,238,5,0,225,245,5,0,0,0,6,0,188,1,6,208,243,8,6,192,244,20,6,0,128,26,6,169,67,28,6,0,8,46,6,0,0,64,6,128,206,65,6,78,83,73,6,0,0,84,6,72,212,85,6,0,64,104,6,0,243,111,6,112,140,132,6,0,128,151,6,203,103,153,6,0,152,172,6,32,157,180,6,0,0,192,6,128,243,193,6,74,18,202,6,0,208,221,6,0,201,243,6,172,35,252,6,0,0,8,7,80,8,10,7,0,128,30,7,209,142,32,7,0,14,39,7,0,72,53,7,96,241,61,7,0,0,83,7,254,29,85,7,0,112,106,7,64,89,115,7,0,0,128,7,0,43,130,7,196,48,139,7,0,0,152,7,240,49,154,7,0,32,161,7,0,138,185,7,0,0,208,7,32,66,210,7,0,0,233,7,90,73,235,7,0,0,0,8,0,80,2,8,192,239,11,8,0,241,27,8,140,175,37,8,0,96,61,8,0,190,87,8,104,196,97,8,0,0,112,8,96,112,114,8,0,0,139,8,0,68,149,8,64,187,176,8,151,44,187,8,0,0,202,8,100,138,204,8,0,32,230,8,128,209,240,8,0,0,0,9,0,154,2,9,184,109,13,9,32,111,31,9,0,192,39,9,0,12,69,9,144,47,80,9,0,0,96,9,192,181,98,9,245,252,109,9,0,0,126,9,108,190,128,9,0,104,137,9,0,96,156,9,128,236,167,9,0,0,196,9,168,210,198,9,0,64,227,9,0,0,0,10,0,228,2,10,176,235,14,10,0,0,32,10,64,237,34,10,111,27,47,10,0,184,76,10,128,173,109,10,130,53,122,10,0,0,140,10,120,12,143,10,0,192,173,10,0,149,186,10,0,236,207,10,16,234,220,10,0,128,252,10,253,172,255,10,0,168,31,11,224,5,45,11,0,0,64,11,128,64,67,11,38,201,80,11,0,0,100,11,232,74,103,11,0,176,113,11,0,79,150,11,116,59,164,11,0,0,184,11,48,99,187,11,0,128,221,11,7,238,224,11,0,194,235,11,0,0,0,12,0,120,3,12,160,231,17,12,128,233,41,12,0,0,53,12,82,135,56,12,0,16,92,12,0,0,128,12,0,157,131,12,156,166,146,12,0,0,168,12,144,168,171,12,0,128,208,12,0,230,223,12,224,24,9,13,0,0,47,13,150,207,50,13,0,48,89,13,64,58,105,13,0,0,128,13,0,231,131,13,148,36,148,13,0,160,187,13,0,146,231,13,88,71,248,13,0,0,16,14,160,16,20,14,0,0,61,14,162,29,65,14,0,28,78,14,0,144,106,14,192,226,123,14,81,74,141,14,0,0,166,14,252,59,170,14,0,224,212,14,128,178,230,14,0,0,0,15,0,86,4,15,136,97,22,15,0,0,48,15,224,99,52,15,0,64,66,15,0,20,115,15,0,0,160,15,64,132,164,15,67,80,183,15,0,0,210,15,180,146,214,15,0,0,0,16,0,160,4,16,128,223,23,16,0,226,55,16,24,95,75,16,0,192,122,16,0,124,175,16,208,136,195,16,0,0,224,16,192,224,228,16,185,45,249,16,0,0,22,17,0,136,42,17,128,118,97,17,46,89,118,17,0,0,148,17,200,20,153,17,0,64,204,17,0,163,225,17,0,0,0,18,0,52,5,18,112,219,26,18,64,222,62,18,0,128,79,18,251,202,84,18,0,24,138,18,32,95,160,18,0,0,192,18,128,107,197,18,234,249,219,18,0,0,252,18,216,124,1,19,0,208,18,19,0,192,56,19,0,217,79,19,0,0,136,19,80,165,141,19,0,128,198,19,97,55,204,19,0,0,0,20,0,200,5,20,96,215,29,20,0,0,64,20,128,218,69,20,222,54,94,20,0,112,153,20,0,91,219,20,4,107,244,20,0,0,24,21,240,24,30,21,0,128,91,21,0,42,117,21,0,216,159,21,32,212,185,21,0,0,249,21,250,89,255,21,0,80,63,22,192,11,90,22,0,0,128,22,0,129,134,22,76,146,161,22,0,0,200,22,208,149,206,22,0,96,227,22,0,158,44,23,232,118,72,23,0,0,112,23,96,198,118,23,0,0,187,23,14,220,193,23,0,132,215,23,0,0,0,24,0,240,6,24,64,207,35,24,0,211,83,24,0,0,106,24,164,14,113,24,0,32,184,24,0,0,0,25,0,58,7,25,56,77,37,25,0,0,80,25,32,81,87,25,0,0,161,25,0,204,191,25,192,49,18,26,197,133,49,26,0,0,94,26,44,159,101,26,0,96,178,26,128,116,210,26,0,0,0,27,0,206,7,27,40,73,40,27,0,64,119,27,0,36,207,27,176,142,240,27,0,0,32,28,64,33,40,28,223,246,73,28,0,0,122,28,68,59,130,28,0,56,156,28,0,32,213,28,128,197,247,28,162,148,26,29,0,0,76,29,248,119,84,29,0,192,169,29,0,101,205,29,0,0,0,30,0,172,8,30,16,195,44,30,0,0,96,30,192,199,104,30,0,128,132,30,77,82,141,30,0,40,230,30,0,0,64,31,128,8,73,31,134,160,110,31,0,0,164,31,104,37,173,31,0,0,0,32,0,64,9,32,0,191,47,32,0,196,111,32,48,190,150,32,0,128,245,32,247,6,255,32,0,248,94,33,160,17,135,33,0,0,192,33,128,193,201,33,114,91,242,33,0,0,44,34,0,16,85,34,0,237,194,34,92,178,236,34,0,0,40,35,144,41,50,35,0,128,152,35,21,202,162,35,0,70,195,35,0,0,0,36,0,104,10,36,224,182,53,36,128,188,125,36,0,0,159,36,246,149,169,36,0,48,20,37,64,190,64,37,0,0,128,37,0,215,138,37,212,243,183,37,0,0,248,37,176,249,2,38,0,160,37,38,0,128,113,38,0,178,159,38,0,0,16,39,160,74,27,39,0,0,141,39,194,110,152,39,0,0,0,40,0,144,11,40,192,174,59,40,0,0,128,40,0,181,139,40,188,109,188,40,0,224,50,41,0,182,182,41,8,214,232,41,0,0,48,42,224,49,60,42,0,0,183,42,0,84,234,42,0,176,63,43,64,168,115,43,243,222,167,43,0,0,242,43,244,179,254,43,0,160,126,44,128,23,180,44,0,0,0,45,0,2,13,45,152,36,67,45,0,0,144,45,160,43,157,45,0,192,198,45,0,60,89,46,208,237,144,46,0,0,224,46,192,140,237,46,201,240,37,47,0,0,118,47,28,184,131,47,0,8,175,47,0,0,0,48,0,224,13,48,128,158,71,48,0,166,167,48,0,0,212,48,72,29,226,48,0,64,112,49,0,0,0,50,0,116,14,50,112,154,74,50,0,0,160,50,64,162,174,50,43,137,235,50,0,0,66,51,0,152,127,51,128,99,36,52,138,11,99,52,0,0,188,52,88,62,203,52,0,192,100,53,0,233,164,53,0,0,0,54,0,156,15,54,80,146,80,54,0,128,238,54,241,96,254,54,0,72,158,55,96,29,225,55,0,0,64,56,128,66,80,56,190,237,147,56,0,0,244,56,136,118,4,57,0,112,56,57,0,64,170,57,0,139,239,57,68,41,53,58,0,0,152,58,240,239,168,58,0,128,83,59,35,166,100,59,0,202,154,59,0,0,0,60,0,88,17,60,32,134,89,60,0,0,192,60,128,143,209,60,0,0,9,61,154,164,26,61,0,80,204,61,0,0,128,62,0,17,146,62,12,65,221,62,0,0,72,63,208,74,90,63,0,0,0,64,0,128,18,64,0,126,95,64,0,136,223,64,96,124,45,65,0,0,235,65,238,13,254,65,0,240,189,66,64,35,14,67,0,0,128,67,0,131,147,67,228,182,228,67,0,0,88,68,0,32,170,68,0,218,133,69,184,100,217,69,0,0,80,70,32,83,100,70,0,0,49,71,42,148,69,71,0,140,134,71,0,0,0,72,0,208,20,72,192,109,107,72,149,115,194,72,0,121,251,72,0,0,62,73,236,43,83,73,0,96,40,74,128,124,129,74,0,0,0,75,0,174,21,75,168,231,111,75,0,0,240,75,96,243,5,76,0,64,75,76,0,0,227,76,0,100,63,77,0,0,32,78,64,149,54,78,79,145,148,78,0,0,26,79,132,221,48,79,0,0,0,80,0,32,23,80,128,93,119,80,0,0,0,81,0,106,23,81,120,219,120,81,0,192,101,82,0,108,109,83,16,172,209,83,0,0,96,84,192,99,120,84,157,228,221,84,0,0,110,85,0,168,212,85,0,96,127,86,128,80,231,86,230,189,79,87,0,0,228,87,232,103,253,87,0,64,253,88,0,47,104,89,0,0,0,90,0,4,26,90,48,73,134,90,0,0,32,91,64,87,58,91,0,128,141,91,231,246,167,91,0,120,178,92,160,219,33,93,0,0,192,93,128,25,219,93,146,225,75,94,0,0,236,94,56,112,7,95,0,16,94,95,0,0,0,96,0,192,27,96,0,61,143,96,0,76,79,97,0,0,168,97,144,58,196,97,0,128,224,98,229,20,253,98,0,0,0,100,0,232,28,100,224,52,149,100,0,0,64,101,128,68,93,101,86,18,215,101,0,0,132,102,0,48,255,102,0,199,72,104,20,23,198,104,0,0,120,105,176,124,150,105,0,128,201,106,0,210,73,107,0,0,0,108,0,56,31,108,160,36,161,108,0,0,221,109,226,193,252,109,0,144,60,111,192,58,194,111,0,0,128,112,0,133,160,112,124,219,39,113,0,0,232,113,16,237,8,114,0,224,112,114,0,128,84,115,0,22,223,115,136,82,106,116,0,0,48,117,224,223,81,117,0,0,167,118,70,76,201,118,0,148,53,119,0,0,0,120,0,176,34,120,64,12,179,120,0,0,128,121,0,31,163,121,0,0,18,122,52,73,53,122,0,160,152,123,0,0,0,125,0,34,36,125,24,130,186,125,0,0,144,126,160,149,180,126,16,192,13,0,134,128,2,0,175,126,2,0,233,0,0,0,1,0,0,0,12,192,13,0,58,128,2,0,175,126,2,0,105,0,0,0,1,0,0,0,0,0,0,0,32,43,0,0,17,0,0,0,18,0,0,0,5,0,0,0,0,0,0,0,16,43,0,0,17,0,0,0,19,0,0,0,6,0,0,0,8,192,13,0,203,127,2,0,175,126,2,0,77,0,0,0,1,0,0,0,20,192,13,0,94,129,2,0,228,128,2,0,237,2,0,0,1,0,0,0,32,192,13,0,145,131,2,0,228,128,2,0,59,3,0,0,1,0,0,0,28,192,13,0,60,131,2,0,228,128,2,0,213,5,0,0,1,0,0,0,24,192,13,0,242,129,2,0,228,128,2,0,103,5,0,0,1,0,0,0,36,192,13,0,139,132,2,0,228,128,2,0,63,4,0,0,1,0,0,0,40,192,13,0,196,132,2,0,222,132,2,0,104,0,0,0,1,0,0,0,44,192,13,0,97,133,2,0,222,132,2,0,147,0,0,0,1,0,0,0,48,192,13,0,232,133,2,0,222,132,2,0,13,1,0,0,1,0,0,0,52,192,13,0,171,134,2,0,222,132,2,0,50,2,0,0,1,0,0,0,56,192,13,0,252,134,2,0,222,132,2,0,153,2,0,0,1,0,0,0,60,192,13,0,38,135,2,0,222,132,2,0,186,2,0,0,1,0,0,0,64,192,13,0,80,135,2,0,222,132,2,0,180,4,0,0,1,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,68,192,13,0,126,135,2,0,222,132,2,0,75,5,0,0,1,0,0,0,72,192,13,0,191,135,2,0,222,132,2,0,45,6,0,0,1,0,0,0,76,192,13,0,202,136,2,0,222,132,2,0,202,6,0,0,1,0,0,0,80,192,13,0,121,137,2,0,222,132,2,0,93,7,0,0,1,0,0,0,84,192,13,0,172,137,2,0,6,138,2,0,187,0,0,0,1,0,0,0,88,192,13,0,67,138,2,0,6,138,2,0,193,0,0,0,1,0,0,0,92,192,13,0,160,138,2,0,6,138,2,0,206,0,0,0,1,0,0,0,96,192,13,0,245,138,2,0,6,138,2,0,231,0,0,0,1,0,0,0,100,192,13,0,77,139,2,0,6,138,2,0,1,1,0,0,1,0,0,0,104,192,13,0,145,139,2,0,6,138,2,0,22,1,0,0,1,0,0,0,108,192,13,0,215,139,2,0,6,138,2,0,39,1,0,0,1,0,0,0,112,192,13,0,24,140,2,0,6,138,2,0,60,1,0,0,1,0,0,0,116,192,13,0,91,140,2,0,6,138,2,0,225,1,0,0,1,0,0,0,120,192,13,0,155,140,2,0,6,138,2,0,253,2,0,0,1,0,0,0,124,192,13,0,221,140,2,0,6,138,2,0,187,4,0,0,1,0,0,0,0,0,0,0,0,0,0,187,128,192,13,0,29,141,2,0,6,138,2,0,77,5,0,0,1,0,0,0,132,192,13,0,95,141,2,0,171,141,2,0,16,0,0,0,1,0,0,0,136,192,13,0,236,141,2,0,171,141,2,0,26,0,0,0,1,0,0,0,140,192,13,0,59,142,2,0,171,141,2,0,44,0,0,0,1,0,0,0,144,192,13,0,130,142,2,0,171,141,2,0,56,0,0,0,1,0,0,0,148,192,13,0,204,142,2,0,171,141,2,0,69,0,0,0,1,0,0,0,152,192,13,0,2,143,2,0,171,141,2,0,81,0,0,0,1,0,0,0,156,192,13,0,58,143,2,0,171,141,2,0,93,0,0,0,1,0,0,0,160,192,13,0,109,143,2,0,171,141,2,0,104,0,0,0,1,0,0,0,164,192,13,0,162,143,2,0,171,141,2,0,114,0,0,0,1,0,0,0,168,192,13,0,212,143,2,0,171,141,2,0,125,0,0,0,1,0,0,0,172,192,13,0,8,144,2,0,171,141,2,0,136,0,0,0,1,0,0,0,176,192,13,0,58,144,2,0,171,141,2,0,147,0,0,0,1,0,0,0,196,192,13,0,217,144,2,0,169,144,2,0,131,3,0,0,1,0,0,0,200,192,13,0,19,147,2,0,169,144,2,0,67,8,0,0,1,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,0,0,0,0,204,192,13,0,139,147,2,0,169,144,2,0,247,8,0,0,1,0,0,0,208,192,13,0,3,148,2,0,169,144,2,0,187,9,0,0,1,0,0,0,212,192,13,0,210,148,2,0,169,144,2,0,145,11,0,0,1,0,0,0,216,192,13,0,75,149,2,0,169,144,2,0,50,13,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,220,192,13,0,113,149,2,0,168,149,2,0,101,2,0,0,1,0,0,0,72,156,0,0,0,0,0,0,72,47,0,0,20,0,0,0,21,0,0,0,1,0,0,0,16,0,0,0,3,0,0,0,17,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,16,0,0,0,17,0,0,0,22,0,0,0,23,0,0,0,18,0,0,0,2,0,0,0,56,157,0,0,196,156,0,0,0,0,0,0,88,47,0,0,20,0,0,0,22,0,0,0,3,0,0,0,24,0,0,0,3,0,0,0,17,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,16,0,0,0,17,0,0,0,25,0,0,0,23,0,0,0,18,0,0,0,2,0,0,0,0,0,0,0,104,47,0,0,20,0,0,0,23,0,0,0,4,0,0,0,26,0,0,0,3,0,0,0,17,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,16,0,0,0,17,0,0,0,25,0,0,0,23,0,0,0,18,0,0,0,2,0,0,0,8,160,0,0,124,158,0,0,184,157,0,0,0,0,0,0,120,47,0,0,20,0,0,0,24,0,0,0,5,0,0,0,27,0,0,0,3,0,0,0,17,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,28,0,0,0,19,0,0,0,29,0,0,0,21,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,16,0,0,0,19,0,0,0,25,0,0,0,23,0,0,0,18,0,0,0,2,0,0,0,224,192,13,0,87,150,2,0,168,149,2,0,31,6,0,0,1,0,0,0,228,192,13,0,168,150,2,0,168,149,2,0,22,6,0,0,1,0,0,0,232,192,13,0,0,151,2,0,168,149,2,0,3,6,0,0,1,0,0,0,236,192,13,0,101,151,2,0,168,149,2,0,240,5,0,0,1,0,0,0,0,0,0,0,136,47,0,0,20,0,0,0,25,0,0,0,6,0,0,0,30,0,0,0,3,0,0,0,17,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,18,0,0,0,31,0,0,0,20,0,0,0,32,0,0,0,1,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,20,0,0,0,21,0,0,0,25,0,0,0,23,0,0,0,18,0,0,0,2,0,0,0,240,192,13,0,215,151,2,0,168,149,2,0,64,5,0,0,1,0,0,0,252,192,13,0,247,152,2,0,168,149,2,0,74,5,0,0,1,0,0,0,28,159,0,0,0,0,0,0,152,47,0,0,20,0,0,0,26,0,0,0,7,0,0,0,33,0,0,0,3,0,0,0,17,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,1,0,0,0,4,0,0,0,2,0,0,0,3,0,0,0,16,0,0,0,17,0,0,0,25,0,0,0,23,0,0,0,18,0,0,0,2,0,0,0,244,192,13,0,41,152,2,0,168,149,2,0,149,5,0,0,1,0,0,0,248,192,13,0,126,152,2,0,168,149,2,0,136,5,0,0,1,0,0,0,0,193,13,0,67,153,2,0,168,149,2,0,53,5,0,0,1,0,0,0,4,193,13,0,154,153,2,0,168,149,2,0,43,5,0,0,1,0,0,0,8,193,13,0,243,153,2,0,168,149,2,0,33,5,0,0,1,0,0,0,12,193,13,0,84,154,2,0,168,149,2,0,24,5,0,0,1,0,0,0,0,0,0,0,168,47,0,0,20],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+30724);allocate([27,0,0,0,8,0,0,0,34,0,0,0,3,0,0,0,17,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,1,0,0,0,5,0,0,0,2,0,0,0,1,0,0,0,16,0,0,0,22,0,0,0,25,0,0,0,23,0,0,0,18,0,0,0,2,0,0,0,16,193,13,0,195,154,2,0,168,149,2,0,214,5,0,0,1,0,0,0,20,193,13,0,17,155,2,0,168,149,2,0,206,5,0,0,1,0,0,0,24,193,13,0,116,155,2,0,168,149,2,0,35,2,0,0,1,0,0,0,28,193,13,0,192,155,2,0,168,149,2,0,25,2,0,0,1,0,0,0,32,193,13,0,6,156,2,0,168,149,2,0,15,2,0,0,1,0,0,0,36,193,13,0,87,156,2,0,168,149,2,0,229,1,0,0,1,0,0,0,40,193,13,0,189,156,2,0,168,149,2,0,219,1,0,0,1,0,0,0,44,193,13,0,16,157,2,0,168,149,2,0,166,1,0,0,1,0,0,0,48,193,13,0,120,157,2,0,168,149,2,0,156,1,0,0,1,0,0,0,52,193,13,0,211,157,2,0,168,149,2,0,123,1,0,0,1,0,0,0,56,193,13,0,51,158,2,0,168,149,2,0,113,1,0,0,1,0,0,0,60,193,13,0,137,158,2,0,168,149,2,0,80,1,0,0,1,0,0,0,0,0,0,0,184,47,0,0,20,0,0,0,28,0,0,0,9,0,0,0,35,0,0,0,3,0,0,0,17,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,16,0,0,0,17,0,0,0,25,0,0,0,23,0,0,0,18,0,0,0,2,0,0,0,0,0,0,0,200,47,0,0,20,0,0,0,29,0,0,0,10,0,0,0,36,0,0,0,3,0,0,0,17,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,1,0,0,0,6,0,0,0,2,0,0,0,1,0,0,0,16,0,0,0,17,0,0,0,25,0,0,0,23,0,0,0,18,0,0,0,2,0,0,0,64,193,13,0,0,159,2,0,168,149,2,0,112,6,0,0,1,0,0,0,108,161,0,0,72,193,13,0,152,159,2,0,168,149,2,0,196,4,0,0,1,0,0,0,76,193,13,0,182,159,2,0,168,149,2,0,132,6,0,0,1,0,0,0,80,193,13,0,213,159,2,0,168,149,2,0,141,6,0,0,1,0,0,0,84,193,13,0,249,159,2,0,168,149,2,0,151,6,0,0,1,0,0,0,88,193,13,0,44,160,2,0,168,149,2,0,166,6,0,0,1,0,0,0,92,193,13,0,93,160,2,0,168,149,2,0,175,6,0,0,1,0,0,0,96,193,13,0,138,160,2,0,168,149,2,0,193,6,0,0,1,0,0,0,100,193,13,0,186,160,2,0,168,149,2,0,202,6,0,0,1,0,0,0,104,193,13,0,230,160,2,0,168,149,2,0,220,6,0,0,1,0,0,0,108,193,13,0,21,161,2,0,168,149,2,0,229,6,0,0,1,0,0,0,0,0,0,0,224,47,0,0,2,0,0,0,3,0,0,0,7,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,124,193,13,0,193,162,2,0,158,161,2,0,132,0,0,0,1,0,0,0,0,0,0,0,248,47,0,0,33,0,0,0,34,0,0,0,1,0,0,0,1,0,0,0,8,0,0,0,23,0,0,0,9,0,0,0,113,0,0,0,114,0,0,0,1,0,0,0,11,0,0,0,128,193,13,0,206,174,2,0,158,161,2,0,184,13,0,0,1,0,0,0,0,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,28,0,0,0,0,0,0,0,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,33,0,0,0,0,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,132,193,13,0,18,175,2,0,158,161,2,0,141,4,0,0,1,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,136,193,13,0,137,176,2,0,158,161,2,0,251,11,0,0,1,0,0,0,140,193,13,0,192,176,2,0,158,161,2,0,31,12,0,0,1,0,0,0,144,193,13,0,67,177,2,0,158,161,2,0,40,12,0,0,5,0,0,0,148,193,13,0,122,177,2,0,158,161,2,0,76,12,0,0,1,0,0,0,152,193,13,0,191,177,2,0,158,161,2,0,127,12,0,0,1,0,0,0,156,193,13,0,252,177,2,0,158,161,2,0,174,12,0,0,1,0,0,0,160,193,13,0,74,178,2,0,158,161,2,0,232,13,0,0,1,0,0,0,164,193,13,0,243,178,2,0,158,161,2,0,144,15,0,0,1,0,0,0,168,193,13,0,43,179,2,0,106,179,2,0,112,0,0,0,1,0,0,0,172,193,13,0,161,179,2,0,106,179,2,0,123,0,0,0,1,0,0,0,176,193,13,0,226,179,2,0,106,179,2,0,212,0,0,0,1,0,0,0,180,193,13,0,40,180,2,0,106,179,2,0,221,0,0,0,1,0,0,0,184,193,13,0,112,180,2,0,106,179,2,0,77,1,0,0,1,0,0,0,188,193,13,0,189,180,2,0,106,179,2,0,87,1,0,0,1,0,0,0,56,0,0,0,0,0,0,0,64,48,0,0,39,0,0,0,40,0,0,0,200,255,255,255,200,255,255,255,64,48,0,0,41,0,0,0,42,0,0,0,0,0,0,0,48,48,0,0,43,0,0,0,44,0,0,0,10,0,0,0,1,0,0,0,19,0,0,0,37,0,0,0,4,0,0,0,5,0,0,0,2,0,0,0,6,0,0,0,7,0,0,0,12,0,0,0,3,0,0,0,13,0,0,0,248,165,0,0,20,48,0,0,40,48,0,0,12,166,0,0,0,0,0,0,88,48,0,0,45,0,0,0,46,0,0,0,2,0,0,0,8,0,0,0,47,0,0,0,11,0,0,0,236,193,13,0,44,205,2,0,90,182,2,0,245,26,0,0,1,0,0,0,0,0,0,0,96,48,0,0,8,0,0,0,48,0,0,0,49,0,0,0,60,0,0,0,0,0,0,0,152,48,0,0,54,0,0,0,55,0,0,0,196,255,255,255,196,255,255,255,152,48,0,0,56,0,0,0,57,0,0,0,184,166,0,0,124,48,0,0,144,48,0,0,204,166,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,0,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,240,199,13,0,216,222,2,0,94,221,2,0,249,2,0,0,1,0,0,0,244,199,13,0,17,223,2,0,94,221,2,0,0,3,0,0,1,0,0,0,248,199,13,0,145,224,2,0,99,224,2,0,158,4,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,252,199,13,0,189,224,2,0,99,224,2,0,75,5,0,0,1,0,0,0,14,0,0,0,14,0,0,0,15,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,0,0,0,0,0,200,13,0,4,225,2,0,99,224,2,0,205,5,0,0,1,0,0,0,4,200,13,0,146,225,2,0,99,224,2,0,71,7,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,8,200,13,0,71,226,2,0,99,224,2,0,145,10,0,0,1,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,0,0,0,0,12,200,13,0,175,226,2,0,99,224,2,0,213,10,0,0,1,0,0,0,16,200,13,0,179,229,2,0,99,224,2,0,109,12,0,0,1,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,0,0,0,0,20,200,13,0,196,230,2,0,99,224,2,0,42,14,0,0,1,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,0,0,0,0,24,200,13,0,27,232,2,0,99,224,2,0,172,15,0,0,1,0,0,0,0,0,0,0,168,48,0,0,17,0,0,0,58,0,0,0,12,0,0,0,28,200,13,0,138,232,2,0,183,232,2,0,14,0,0,0,1,0,0,0,32,200,13,0,238,232,2,0,183,232,2,0,22,0,0,0,1,0,0,0,0,0,0,0,184,48,0,0,59,0,0,0,60,0,0,0,9,0,0,0,0,0,0,0,200,48,0,0,61,0,0,0,62,0,0,0,1,0,0,0,1,0,0,0,117,208,86,0,0,0,0,0,208,48,0,0,63,0,0,0,64,0,0,0,10,0,0,0,13,0,0,0,0,0,0,195,0,0,254,194,0,0,252,194,0,0,250,194,0,0,248,194,0,0,246,194,0,0,244,194,0,0,242,194,0,0,240,194,0,0,238,194,0,0,236,194,0,0,234,194,0,0,232,194,0,0,230,194,0,0,228,194,0,0,226,194,0,0,224,194,0,0,222,194,0,0,220,194,0,0,218,194,0,0,216,194,0,0,214,194,0,0,212,194,0,0,210,194,0,0,208,194,0,0,206,194,0,0,204,194,0,0,202,194,0,0,200,194,0,0,198,194,0,0,196,194,0,0,194,194,0,0,192,194,0,0,190,194,0,0,188,194,0,0,186,194,0,0,184,194,0,0,182,194,0,0,180,194,0,0,178,194,0,0,176,194,0,0,174,194,0,0,172,194,0,0,170,194,0,0,168,194,0,0,166,194,0,0,164,194,0,0,162,194,0,0,160,194,0,0,158,194,0,0,156,194,0,0,154,194,0,0,152,194,0,0,150,194,0,0,148,194,0,0,146,194,0,0,144,194,0,0,142,194,0,0,140,194,0,0,138,194,0,0,136,194,0,0,134,194,0,0,132,194,0,0,130,194,0,0,128,194,0,0,124,194,0,0,120,194,0,0,116,194,0,0,112,194,0,0,108,194,0,0,104,194,0,0,100,194,0,0,96,194,0,0,92,194,0,0,88,194,0,0,84,194,0,0,80,194,0,0,76,194,0,0,72,194,0,0,68,194,0,0,64,194,0,0,60,194,0,0,56,194,0,0,52,194,0,0,48,194,0,0,44,194,0,0,40,194,0,0,36,194,0,0,32,194,0,0,28,194,0,0,24,194,0,0,20,194,0,0,16,194,0,0,12,194,0,0,8,194,0,0,4,194,0,0,0,194,0,0,248,193,0,0,240,193,0,0,232,193,0,0,224,193,0,0,216,193,0,0,208,193,0,0,200,193,0,0,192,193,0,0,184,193,0,0,176,193,0,0,168,193,0,0,160,193,0,0,152,193,0,0,144,193,0,0,136,193,0,0,128,193,0,0,112,193,0,0,96,193,0,0,80,193,0,0,64,193,0,0,48,193,0,0,32,193,0,0,16,193,0,0,0,193,0,0,224,192,0,0,192,192,0,0,160,192,0,0,128,192,0,0,64,192,0,0,0,192,0,0,128,191,0,0,0,0,0,0,128,63,0,0,0,64,0,0,64,64,0,0,128,64,0,0,160,64,0,0,192,64,0,0,224,64,0,0,0,65,0,0,16,65,0,0,32,65,0,0,48,65,0,0,64,65,0,0,80,65,0,0,96,65,0,0,112,65,0,0,128,65,0,0,136,65,0,0,144,65,0,0,152,65,0,0,160,65,0,0,168,65,0,0,176,65,0,0,184,65,0,0,192,65,0,0,200,65,0,0,208,65,0,0,216,65,0,0,224,65,0,0,232,65,0,0,240,65,0,0,248,65,0,0,0,66,0,0,4,66,0,0,8,66,0,0,12,66,0,0,16,66,0,0,20,66,0,0,24,66,0,0,28,66,0,0,32,66,0,0,36,66,0,0,40,66,0,0,44,66,0,0,48,66,0,0,52,66,0,0,56,66,0,0,60,66,0,0,64,66,0,0,68,66,0,0,72,66,0,0,76,66,0,0,80,66,0,0,84,66,0,0,88,66,0,0,92,66,0,0,96,66,0,0,100,66,0,0,104,66,0,0,108,66,0,0,112,66,0,0,116,66,0,0,120,66,0,0,124,66,0,0,128,66,0,0,130,66,0,0,132,66,0,0,134,66,0,0,136,66,0,0,138,66,0,0,140,66,0,0,142,66,0,0,144,66,0,0,146,66,0,0,148,66,0,0,150,66,0,0,152,66,0,0,154,66,0,0,156,66,0,0,158,66,0,0,160,66,0,0,162,66,0,0,164,66,0,0,166,66,0,0,168,66,0,0,170,66,0,0,172,66,0,0,174,66,0,0,176,66,0,0,178,66,0,0,180,66,0,0,182,66,0,0,184,66,0,0,186,66,0,0,188,66,0,0,190,66,0,0,192,66,0,0,194,66,0,0,196,66,0,0,198,66,0,0,200,66,0,0,202,66,0,0,204,66,0,0,206,66,0,0,208,66,0,0,210,66,0,0,212,66,0,0,214,66,0,0,216,66,0,0,218,66,0,0,220,66,0,0,222,66,0,0,224,66,0,0,226,66,0,0,228,66,0,0,230,66,0,0,232,66,0,0,234,66,0,0,236,66,0,0,238,66,0,0,240,66,0,0,242,66,0,0,244,66,0,0,246,66,0,0,248,66,0,0,250,66,0,0,252,66,0,0,254,66,0,0,0,67,0,0,1,67,0,0,2,67,0,0,3,67,0,0,4,67,0,0,5,67,0,0,6,67,0,0,7,67,0,0,8,67,0,0,9,67,0,0,10,67,0,0,11,67,0,0,12,67,0,0,13,67,0,0,14,67,0,0,15,67,0,0,16,67,0,0,17,67,0,0,18,67,0,0,19,67,0,0,20,67,0,0,21,67,0,0,22,67,0,0,23,67,0,0,24,67,0,0,25,67,0,0,26,67,0,0,27,67,0,0,28,67,0,0,29,67,0,0,30,67,0,0,31,67,0,0,32,67,0,0,33,67,0,0,34,67,0,0,35,67,0,0,36,67,0,0,37,67,0,0,38,67,0,0,39,67,0,0,40,67,0,0,41,67,0,0,42,67,0,0,43,67,0,0,44,67,0,0,45,67,0,0,46,67,0,0,47,67,0,0,48,67,0,0,49,67,0,0,50,67,0,0,51,67,0,0,52,67,0,0,53,67,0,0,54,67,0,0,55,67,0,0,56,67,0,0,57,67,0,0,58,67,0,0,59,67,0,0,60,67,0,0,61,67,0,0,62,67,0,0,63,67,0,0,64,67,0,0,65,67,0,0,66,67,0,0,67,67,0,0,68,67,0,0,69,67,0,0,70,67,0,0,71,67,0,0,72,67,0,0,73,67,0,0,74,67,0,0,75,67,0,0,76,67,0,0,77,67,0,0,78,67,0,0,79,67,0,0,80,67,0,0,81,67,0,0,82,67,0,0,83,67,0,0,84,67,0,0,85,67,0,0,86,67,0,0,87,67,0,0,88,67,0,0,89,67,0,0,90,67,0,0,91,67,0,0,92,67,0,0,93,67,0,0,94,67,0,0,95,67,0,0,96,67,0,0,97,67,0,0,98,67,0,0,99,67,0,0,100,67,0,0,101,67,0,0,102,67,0,0,103,67,0,0,104,67,0,0,105,67,0,0,106,67,0,0,107,67,0,0,108,67,0,0,109,67,0,0,110,67,0,0,111,67,0,0,112,67,0,0,113,67,0,0,114,67,0,0,115,67,0,0,116,67,0,0,117,67,0,0,118,67,0,0,119,67,0,0,120,67,0,0,121,67,0,0,122,67,0,0,123,67,0,0,124,67,0,0,125,67,0,0,126,67,0,0,127,67,192,204,13,0,35,18,3,0,96,14,3,0,47,3,0,0,1,0,0,0,188,204,13,0,226,17,3,0,96,14,3,0,142,3,0,0,1,0,0,0,196,204,13,0,76,18,3,0,96,14,3,0,207,3,0,0,1,0,0,0,25,27,3,0,25,27,3,0,153,226,86,0,153,226,86,0,30,27,3,0,34,27,3,0,30,27,3,0,38,27,3,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,3,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,3,0,0,0,2,0,0,0,1,0,0,0,228,204,13,0,232,29,3,0,87,29,3,0,166,2,0,0,1,0,0,0,0,205,13,0,197,31,3,0,61,30,3,0,201,3,0,0,1,0,0,0,0,0,0,0,248,48,0,0,65,0,0,0,66,0,0,0,14,0,0,0,236,204,13,0,60,31,3,0,61,30,3,0,22,4,0,0,0,0,0,0,232,204,13,0,50,31,3,0,61,30,3,0,41,4,0,0,0,0,0,128,0,0,0,0,232,48,0,0,17,0,0,0,67,0,0,0,15,0,0,0,252,204,13,0,108,31,3,0,61,30,3,0,97,1,0,0,1,0,0,0,248,204,13,0,99,31,3,0,61,30,3,0,107,1,0,0,0,0,0,0,244,204,13,0,89,31,3,0,61,30,3,0,119,1,0,0,0,0,0,128,240,204,13,0,78,31,3,0,61,30,3,0,235,2,0,0,0,0,0,128,12,205,13,0,182,32,3,0,61,30,3,0,49,4,0,0,1,0,0,0,8,205,13,0,60,31,3,0,61,30,3,0,94,4,0,0,0,0,0,0,4,205,13,0,50,31,3,0,61,30,3,0,113,4,0,0,0,0,0,128,0,0,0,0,24,49,0,0,68,0,0,0,69,0,0,0,3,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,3,0,0,0,4,0,0,0,34,0,0,0,1,0,0,0,1,0,0,0,16,0,0,0,17,0,0,0,70,0,0,0,0,0,0,0,8,49,0,0,8,0,0,0,71,0,0,0,72,0,0,0,16,205,13,0,182,36,3,0,11,34,3,0,102,1,0,0,1,0,0,0,0,0,0,0,152,49,0,0,73,0,0,0,74,0,0,0,18,0,0,0,0,0,0,0,136,49,0,0,8,0,0,0,75,0,0,0,76,0,0,0,0,0,0,0,120,49,0,0,77,0,0,0,78,0,0,0,19,0,0,0,0,0,0,0,104,49,0,0,8,0,0,0,79,0,0,0,80,0,0,0,0,0,0,0,88,49,0,0,81,0,0,0,82,0,0,0,20,0,0,0,0,0,0,0,72,49,0,0,8,0,0,0,83,0,0,0,84,0,0,0,0,0,0,0,56,49,0,0,85,0,0,0,86,0,0,0,21,0,0,0,0,0,0,0,40,49,0,0,8,0,0,0,87,0,0,0,88,0,0,0,60,205,13,0,118,39,3,0,165,37,3,0,15,39,0,0,1,0,0,0,0,0,0,0,200,49,0,0,17,0,0,0,89,0,0,0,22,0,0,0,0,0,0,0,184,49,0,0,17,0,0,0,90,0,0,0,23,0,0,0,0,0,0,0,168,49,0,0,17,0,0,0,91,0,0,0,24,0,0,0,48,205,13,0,42,37,3,0,165,37,3,0,45,1,0,0,1,0,0,0,52,205,13,0,4,38,3,0,165,37,3,0,45,1,0,0,1,0,0,0,56,205,13,0,190,38,3,0,165,37,3,0,45,1,0,0,1,0,0,0,68,205,13,0,119,40,3,0,165,37,3,0,78,39,0,0,1,0,0,0,0,0,0,0,216,49,0,0,17,0,0,0,92,0,0,0,25,0,0,0,64,205,13,0,215,39,3,0,165,37,3,0,45,1,0,0,1,0,0,0,76,205,13,0,118,41,3,0,165,37,3,0,91,39,0,0,1,0,0,0,0,0,0,0,232,49,0,0,17,0,0,0,93,0,0,0,26,0,0,0,72,205,13,0,214,40,3,0,165,37,3,0,45,1,0,0,1,0,0,0,92,205,13,0,216,43,3,0,165,37,3,0,104,39,0,0,1,0,0,0,35,19,0,0,145,37,0,0,76,7,0,0,0,0,0,0,24,50,0,0,17,0,0,0,94,0,0,0,27,0,0,0,0,0,0,0,8,50,0,0,17,0,0,0,95,0,0,0,28,0,0,0,135,22,153,62,162,69,22,63,213,120,233,61,0,0,0,0,248,49,0,0,17,0,0,0,96,0,0,0,29,0,0,0,80,205,13,0,213,41,3,0,165,37,3,0,45,1,0,0,1,0,0,0,84,205,13,0,128,42,3,0,165,37,3,0,45,1,0,0,1,0,0,0,88,205,13,0,45,43,3,0,165,37,3,0,45,1,0,0,1,0,0,0,108,205,13,0,88,46,3,0,165,37,3,0,153,39,0,0,1,0,0,0,0,0,0,0,72,50,0,0,17,0,0,0,97,0,0,0,30,0,0,0,0,0,0,0,56,50,0,0,17,0,0,0,98,0,0,0,31,0,0,0,0,0,0,0,40,50,0,0,17,0,0,0,99,0,0,0,32,0,0,0,96,205,13,0,53,44,3,0,165,37,3,0,45,1,0,0,1,0,0,0,100,205,13,0,224,44,3,0,165,37,3,0,45,1,0,0,1,0,0,0,104,205,13,0,157,45,3,0,165,37,3,0,45,1,0,0,1,0,0,0,116,205,13,0,82,47,3,0,165,37,3,0,198,39,0,0,1,0,0,0,0,0,0,0,88,50,0,0,17,0,0,0,100,0,0,0,33,0,0,0,112,205,13,0,175,46,3,0,165,37,3,0,45,1,0,0,1,0,0,0,124,205,13,0,74,48,3,0,165,37,3,0,210,39,0,0,1,0,0,0,0,0,0,0,104,50,0,0,17,0,0,0,101,0,0,0,34,0,0,0,120,205,13,0,167,47,3,0,165,37,3,0,45,1,0,0,1,0,0,0,140,205,13,0,224,50,3,0,165,37,3,0,222,39,0,0,1,0,0,0,35,19,0,0,145,37,0,0,76,7,0,0,162,45,0,0,25,36,0,0,35,19,0,0,145,37,0,0,76,7,0,0,33,56,0,0,125,31,0,0,0,0,0,0,152,50,0,0,17,0,0,0,102,0,0,0,35,0,0,0,35,19,0,0,145,37,0,0,76,7,0,0,162,45,0,0,25,36,0,0,35,19,0,0,145,37,0,0,76,7,0,0,33,56,0,0,125,31,0,0,0,0,0,0,136,50,0,0,17,0,0,0,103,0,0,0,36,0,0,0,135,22,153,62,162,69,22,63,213,120,233,61,43,135,54,63,78,98,16,63,135,22,153,62,162,69,22,63,213,120,233,61,18,131,96,63,109,231,251,62,0,0,0,0,120,50,0,0,17,0,0,0,104,0,0,0,37,0,0,0,128,205,13,0,159,48,3,0,165,37,3,0,45,1,0,0,1,0,0,0,132,205,13,0,84,49,3,0,165,37,3,0,45,1,0,0,1,0,0,0,136,205,13,0,27,50,3,0,165,37,3,0,45,1,0,0,1,0,0,0,156,205,13,0,131,53,3,0,165,37,3,0,19,40,0,0,1,0,0,0,203,89,0,0,78,210,255,255,252,233,255,255,121,113,0,0,246,72,0,0,209,218,255,255,184,230,255,255,12,130,0,0,0,0,0,0,200,50,0,0,17,0,0,0,105,0,0,0,38,0,0,0,203,89,0,0,78,210,255,255,252,233,255,255,121,113,0,0,246,72,0,0,209,218,255,255,184,230,255,255,12,130,0,0,0,0,0,0,184,50,0,0,17,0,0,0,106,0,0,0,39,0,0,0,129,149,179,63,180,200,54,191,197,32,176,190,170,241,226,63,133,235,145,63,106,188,20,191,113,61,202,190,74,12,2,64,0,0,0,0,168,50,0,0,17,0,0,0,107,0,0,0,40,0,0,0,144,205,13,0,66,51,3,0,165,37,3,0,45,1,0,0,1,0,0,0,148,205,13,0,247,51,3,0,165,37,3,0,45,1,0,0,1,0,0,0,152,205,13,0,190,52,3,0,165,37,3,0,45,1,0,0,1,0,0,0,172,205,13,0,17,56,3,0,165,37,3,0,73,40,0,0,1,0,0,0,0,0,0,0,248,50,0,0,17,0,0,0,108,0,0,0,41,0,0,0,0,0,0,0,232,50,0,0,17,0,0,0,109,0,0,0,42,0,0,0,0,0,0,0,216,50,0,0,17,0,0,0,110,0,0,0,43,0,0,0,160,205,13,0,229,53,3,0,165,37,3,0,45,1,0,0,1,0,0,0,164,205,13,0,147,54,3,0,165,37,3,0,45,1,0,0,1,0,0,0,168,205,13,0,83,55,3,0,165,37,3,0,45,1,0,0,1,0,0,0,188,205,13,0,153,58,3,0,165,37,3,0,123,40,0,0,1,0,0,0,0,0,0,0,40,51,0,0,17,0,0,0,111,0,0,0,44,0,0,0,0,0,0,0,24,51,0,0,17,0,0,0,112,0,0,0,45,0,0,0,0,0,0,0,8,51,0,0,17,0,0,0,113,0,0,0,46,0,0,0,176,205,13,0,109,56,3,0,165,37,3,0,45,1,0,0,1,0,0,0,180,205,13,0,27,57,3,0,165,37,3,0,45,1,0,0,1,0,0,0,184,205,13,0,219,57,3,0,165,37,3,0,45,1,0,0,1,0,0,0,208,217,13,0,142,61,3,0,165,37,3,0,174,40,0,0,1,0,0,0,0,0,0,0,104,51,0,0,17,0,0,0,114,0,0,0,47,0,0,0,0,0,0,0,88,51,0,0,17,0,0,0,115,0,0,0,48,0,0,0,0,0,0,0,72,51,0,0,17,0,0,0,116,0,0,0,49,0,0,0,0,0,0,0,56,51,0,0,17,0,0,0,117,0,0,0,50,0,0,0,192,205,13,0,30,59,3,0,165,37,3,0,45,1,0,0,1,0,0,0,196,205,13,0,186,59,3,0,165,37,3,0,45,1,0,0,1,0,0,0,200,205,13,0,86,60,3,0,165,37,3,0,45,1,0,0,1,0,0,0,204,217,13,0,242,60,3,0,165,37,3,0,45,1,0,0,1,0,0,0,228,217,13,0,102,64,3,0,165,37,3,0,5,41,0,0,1,0,0,0,0,0,0,0,168,51,0,0,17,0,0,0,118,0,0,0,51,0,0,0,0,0,0,0,152,51,0,0,17,0,0,0,119,0,0,0,52,0,0,0,0,0,0,0,136,51,0,0,17,0,0,0,120,0,0,0,53,0,0,0,0,0,0,0,120,51,0,0,17,0,0,0,121,0,0,0,54,0,0,0,212,217,13,0,246,61,3,0,165,37,3,0,45,1,0,0,1,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,3,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,216,217,13,0,146,62,3,0,165,37,3,0,45,1,0,0,1,0,0,0,220,217,13,0,46,63,3,0,165,37,3,0,45,1,0,0,1,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,3,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,224,217,13,0,202,63,3,0,165,37,3,0,45,1,0,0,1,0,0,0,112,218,24,0,253,68,3,0,165,37,3,0,96,41,0,0,1,0,0,0,0,0,0,0,232,51,0,0,17,0,0,0,122,0,0,0,55,0,0,0,0,0,0,0,216,51,0,0,17,0,0,0,123,0,0,0,56,0,0,0,0,0,0,0,200,51,0,0,17,0,0,0,124,0,0,0,57,0,0,0,0,0,0,0,184,51,0,0,17,0,0,0,125,0,0,0,58,0,0,0,236,89,14,0,206,64,3,0,165,37,3,0,45,1,0,0,1,0,0,0,12,90,14,0,106,65,3,0,165,37,3,0,45,1,0,0,1,0,0,0,104,218,24,0,210,66,3,0,165,37,3,0,45,1,0,0,1,0,0,0,108,218,24,0,214,67,3,0,165,37,3,0,45,1,0,0,1,0,0,0,3,0,0,0,148,218,24,0,226,71,3,0,165,37,3,0,193,41,0,0,1,0,0,0,0,0,0,0,40,52,0,0,17,0,0,0,126,0,0,0,59,0,0,0,0,0,0,0,24,52,0,0,17,0,0,0,127,0,0,0,60,0,0,0,0,0,0,0,8,52,0,0,17,0,0,0,128,0,0,0,61,0,0,0,0,0,0,0,248,51,0,0,17,0,0,0,129,0,0,0,62,0,0,0,116,218,24,0,101,69,3,0,165,37,3,0,45,1,0,0,1,0,0,0,136,218,24,0,1,70,3,0,165,37,3,0,45,1,0,0,1,0,0,0,140,218,24,0,170,70,3,0,165,37,3,0,45,1,0,0,1,0,0,0,144,218,24,0,70,71,3,0,165,37,3,0,45,1,0,0,1,0,0,0,152,218,24,0,208,73,3,0,165,37,3,0,32,42,0,0,1,0,0,0,0,0,0,0,168,52,0,0,17,0,0,0,130,0,0,0,63,0,0,0,0,0,0,0,152,52,0,0,17,0,0,0,131,0,0,0,64,0,0,0,0,0,0,0,136,52,0,0,17,0,0,0,132,0,0,0,65,0,0,0,0,0,0,0,120,52,0,0,17,0,0,0,133,0,0,0,66,0,0,0,0,0,0,0,104,52,0,0,17,0,0,0,134,0,0,0,67,0,0,0,0,0,0,0,88,52,0,0,17,0,0,0,135,0,0,0,68,0,0,0,0,0,0,0,72,52,0,0,17,0,0,0,136,0,0,0,69,0,0,0,0,0,0,0,56,52,0,0,17,0,0,0,137,0,0,0,70,0,0,0,156,218,24,0,218,74,3,0,165,37,3,0,56,42,0,0,1,0,0,0,0,0,0,0,232,52,0,0,17,0,0,0,138,0,0,0,71,0,0,0,0,0,0,0,216,52,0,0,17,0,0,0,139,0,0,0,72,0,0,0,0,0,0,0,200,52,0,0,17,0,0,0,140,0,0,0,73,0,0,0,0,0,0,0,184,52,0,0,17,0,0,0,141,0,0,0,74,0,0,0,160,218,24,0,246,75,3,0,165,37,3,0,83,42,0,0,1,0,0,0,0,0,0,0,40,53,0,0,17,0,0,0,142,0,0,0,75,0,0,0,0,0,0,0,24,53,0,0,17,0,0,0,143,0,0,0,76,0,0,0,0,0,0,0,8,53,0,0,17,0,0,0,144,0,0,0,77,0,0,0,0,0,0,0,248,52,0,0,17,0,0,0,145,0,0,0,78,0,0,0,164,218,24,0,128,78,3,0,165,37,3,0,102,42,0,0,1,0,0,0,0,0,0,0,232,53,0,0,17,0,0,0,146,0,0,0,79,0,0,0,0,0,0,0,216,53,0,0,17,0,0,0,147,0,0,0,80,0,0,0,0,0,0,0,200,53,0,0,17,0,0,0,148,0,0,0,81,0,0,0,0,0,0,0,184,53,0,0,17,0,0,0,149,0,0,0,82,0,0,0,0,0,0,0,168,53,0,0,17,0,0,0,150,0,0,0,83,0,0,0,0,0,0,0,152,53,0,0,17,0,0,0,151,0,0,0,84,0,0,0,0,0,0,0,136,53,0,0,17,0,0,0,152,0,0,0,85,0,0,0,0,0,0,0,120,53,0,0,17,0,0,0,153,0,0,0,86,0,0,0,0,0,0,0,104,53,0,0,17,0,0,0,154,0,0,0,87,0,0,0,0,0,0,0,88,53,0,0,17,0,0,0,155,0,0,0,88,0,0,0,0,0,0,0,72,53,0,0,17,0,0,0,156,0,0,0,89,0,0,0,0,0,0,0,56,53,0,0,17,0,0,0,157,0,0,0,90,0,0,0,172,218,24,0,171,79,3,0,165,37,3,0,128,42,0,0,1,0,0,0,0,0,0,0,248,53,0,0,17,0,0,0,158,0,0,0,91,0,0,0,168,218,24,0,233,78,3,0,165,37,3,0,45,1,0,0,1,0,0,0,180,218,24,0,197,80,3,0,165,37,3,0,148,42,0,0,1,0,0,0,0,0,0,0,8,54,0,0,17,0,0,0,159,0,0,0,92,0,0,0,176,218,24,0,3,80,3,0,165,37,3,0,45,1,0,0,1,0,0,0,184,218,24,0,21,83,3,0,165,37,3,0,244,42,0,0,1,0,0,0,0,0,0,0,40,54,0,0,17,0,0,0,160,0,0,0,93,0,0,0,0,0,0,0,24,54,0,0,17,0,0,0,161,0,0,0,94,0,0,0,0,0,0,0,88,54,0,0,17,0,0,0,162,0,0,0,95,0,0,0,0,0,0,0,72,54,0,0,17,0,0,0,163,0,0,0,96,0,0,0,0,0,0,0,56,54,0,0,17,0,0,0,164,0,0,0,97,0,0,0,0,0,0,0,120,54,0,0,17,0,0,0,165,0,0,0,98,0,0,0,0,0,0,0,104,54,0,0,17,0,0,0,166,0,0,0,99,0,0,0,0,0,0,0,168,54,0,0,17,0,0,0,167,0,0,0,100,0,0,0,0,0,0,0,152,54,0,0,17,0,0,0,168,0,0,0,101,0,0,0,0,0,0,0,136,54,0,0,17,0,0,0,169,0,0,0,102,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,184,54,0,0,8,0,0,0,170,0,0,0,171,0,0,0,188,218,24,0,86,92,3,0,153,88,3,0,96,7,0,0,1,0,0,0,192,218,24,0,177,92,3,0,153,88,3,0,152,7,0,0,1,0,0,0,196,218,24,0,161,93,3,0,45,93,3,0,131,0,0,0,1,0,0,0,200,218,24,0,64,94,3,0,45,93,3,0,14,1,0,0,1,0,0,0,204,218,24,0,73,95,3,0,22,95,3,0,56,2,0,0,1,0,0,0,208,218,24,0,140,95,3,0,22,95,3,0,140,2,0,0,1,0,0,0,212,218,24,0,244,98,3,0,247,95,3,0,82,6,0,0,1,0,0,0,0,0,0,0,0,0,0,63,0,0,128,62,171,170,42,62,0,0,0,62,205,204,204,61,171,170,170,61,40,73,146,61,0,0,128,61,0,0,0,0,200,54,0,0,172,0,0,0,173,0,0,0,103,0,0,0,0,0,0,0,216,54,0,0,174,0,0,0,175,0,0,0,104,0,0,0,0,0,0,0,232,54,0,0,176,0,0,0,177,0,0,0,105,0,0,0,0,0,0,0,248,54,0,0,178,0,0,0,179,0,0,0,106,0,0,0,0,0,0,0,8,55,0,0,180,0,0,0,181,0,0,0,107,0,0,0,0,0,0,0,24,55,0,0,182,0,0,0,183,0,0,0,108,0,0,0,216,218,24,0,1,100,3,0,60,99,3,0,160,1,0,0,1,0,0,0,220,218,24,0,82,100,3,0,60,99,3,0,209,1,0,0,1,0,0,0,224,218,24,0,159,100,3,0,60,99,3,0,7,3,0,0,1,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,128,63,0,0,128,192,0,0,128,63,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,193,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,228,218,24,0,6,103,3,0,65,101,3,0,203,2,0,0,1,0,0,0,0,0,0,0,56,55,0,0,17,0,0,0,184,0,0,0,109,0,0,0,0,0,0,0,40,55,0,0,17,0,0,0,185,0,0,0,110,0,0,0,236,218,24,0,45,104,3,0,65,101,3,0,89,3,0,0,1,0,0,0,232,218,24,0,243,103,3,0,65,101,3,0,172,2,0,0,1,0,0,0,240,218,24,0,112,104,3,0,160,104,3,0,96,0,0,0,1,0,0,0,244,218,24,0,8,105,3,0,160,104,3,0,200,3,0,0,1,0,0,0,0,0,0,0,86,248,142,60,199,242,14,61,70,94,86,61,127,220,142,61,176,126,178,61,10,19,214,61,157,150,249,61,101,131,14,62,94,48,32,62,213,208,49,62,111,99,67,62,206,230,84,62,149,89,102,62,96,186,119,62,237,131,132,62,88,32,141,62,190,177,149,62,122,55,158,62,224,176,166,62,66,29,175,62,255,123,183,62,112,204,191,62,232,13,200,62,200,63,208,62,109,97,216,62,45,114,224,62,113,113,232,62,149,94,240,62,247,56,248,62,0,0,0,63,137,217,3,63,203,168,7,63,118,109,11,63,68,39,15,63,231,213,18,63,25,121,22,63,140,16,26,63,254,155,29,63,36,27,33,63,186,141,36,63,124,243,39,63,37,76,43,63,114,151,46,63,34,213,49,63,244,4,53,63,167,38,56,63,255,57,59,63,189,62,62,63,166,52,65,63,124,27,68,63,10,243,70,63,19,187,73,63,96,115,76,63,189,27,79,63,242,179,81,63,207,59,84,63,30,179,86,63,174,25,89,63,81,111,91,63,215,179,93,63,20,231,95,63,219,8,98,63,1,25,100,63,93,23,102,63,202,3,104,63,30,222,105,63,54,166,107,63,237,91,109,63,32,255,110,63,178,143,112,63,130,13,114,63,112,120,115,63,100,208,116,63,63,21,118,63,234,70,119,63,77,101,120,63,82,112,121,63,226,103,122,63,236,75,123,63,93,28,124,63,36,217,124,63,54,130,125,63,130,23,126,63,253,152,126,63,158,6,127,63,92,96,127,63,47,166,127,63,19,216,127,63,5,246,127,63,0,0,128,63,5,246,127,63,19,216,127,63,47,166,127,63,92,96,127,63,158,6,127,63,253,152,126,63,130,23,126,63,54,130,125,63,36,217,124,63,93,28,124,63,236,75,123,63,226,103,122,63,82,112,121,63,77,101,120,63,234,70,119,63,63,21,118,63,100,208,116,63,112,120,115,63,130,13,114,63,178,143,112,63,32,255,110,63,237,91,109,63,54,166,107,63,30,222,105,63,202,3,104,63,93,23,102,63,1,25,100,63,219,8,98,63,20,231,95,63,215,179,93,63,81,111,91,63,174,25,89,63,30,179,86,63,207,59,84,63,242,179,81,63,189,27,79,63,96,115,76,63,19,187,73,63,10,243,70,63,124,27,68,63,166,52,65,63,189,62,62,63,255,57,59,63,167,38,56,63,244,4,53,63,34,213,49,63,114,151,46,63,37,76,43,63,124,243,39,63,186,141,36,63,36,27,33,63,254,155,29,63,140,16,26,63,25,121,22,63,231,213,18,63,68,39,15,63,118,109,11,63,203,168,7,63,137,217,3,63,0,0,0,63,247,56,248,62,149,94,240,62,113,113,232,62,45,114,224,62,109,97,216,62,200,63,208,62,232,13,200,62,112,204,191,62,255,123,183,62,66,29,175,62,224,176,166,62,122,55,158,62,190,177,149,62,88,32,141,62,237,131,132,62,96,186,119,62,149,89,102,62,206,230,84,62,111,99,67,62,213,208,49,62,94,48,32,62,101,131,14,62,157,150,249,61,10,19,214,61,176,126,178,61,127,220,142,61,70,94,86,61,199,242,14,61,86,248,142,60,0,0,0,0,86,248,142,188,199,242,14,189,70,94,86,189,127,220,142,189,176,126,178,189,10,19,214,189,157,150,249,189,101,131,14,190,94,48,32,190,213,208,49,190,111,99,67,190,206,230,84,190,149,89,102,190,96,186,119,190,237,131,132,190,88,32,141,190,190,177,149,190,122,55,158,190,224,176,166,190,66,29,175,190,255,123,183,190,112,204,191,190,232,13,200,190,200,63,208,190,109,97,216,190,45,114,224,190,113,113,232,190,149,94,240,190,247,56,248,190,0,0,0,191,137,217,3,191,203,168,7,191,118,109,11,191,68,39,15,191,231,213,18,191,25,121,22,191,140,16,26,191,254,155,29,191,36,27,33,191,186,141,36,191,124,243,39,191,37,76,43,191,114,151,46,191,34,213,49,191,244,4,53,191,167,38,56,191,255,57,59,191,189,62,62,191,166,52,65,191,124,27,68,191,10,243,70,191,19,187,73,191,96,115,76,191,189,27,79,191,242,179,81,191,207,59,84,191,30,179,86,191,174,25,89,191,81,111,91,191,215,179,93,191,20,231,95,191,219,8,98,191,1,25,100,191,93,23,102,191,202,3,104,191,30,222,105,191,54,166,107,191,237,91,109,191,32,255,110,191,178,143,112,191,130,13,114,191,112,120,115,191,100,208,116,191,63,21,118,191,234,70,119,191,77,101,120,191,82,112,121,191,226,103,122,191,236,75,123,191,93,28,124,191,36,217,124,191,54,130,125,191,130,23,126,191,253,152,126,191,158,6,127,191,92,96,127,191,47,166,127,191,19,216,127,191,5,246,127,191,0,0,128,191,5,246,127,191,19,216,127,191,47,166,127,191,92,96,127,191,158,6,127,191,253,152,126,191,130,23,126,191,54,130,125,191,36,217,124,191,93,28,124,191,236,75,123,191,226,103,122,191,82,112,121,191,77,101,120,191,234,70,119,191,63,21,118,191,100,208,116,191,112,120,115,191,130,13,114,191,178,143,112,191,32,255,110,191,237,91,109,191,54,166,107,191,30,222,105,191,202,3,104,191,93,23,102,191,1,25,100,191,219,8,98,191,20,231,95,191,215,179,93,191,81,111,91,191,174,25,89,191,30,179,86,191,207,59,84,191,242,179,81,191,189,27,79,191,96,115,76,191,19,187,73,191,10,243,70,191,124,27,68,191,166,52,65,191,189,62,62,191,255,57,59,191,167,38,56,191,244,4,53,191,34,213,49,191,114,151,46,191,37,76,43,191,124,243,39,191,186,141,36,191,36,27,33,191,254,155,29,191,140,16,26,191,25,121,22,191,231,213,18,191,68,39,15,191,118,109,11,191,203,168,7,191,137,217,3,191,0,0,0,191,247,56,248,190,149,94,240,190,113,113,232,190,45,114,224,190,109,97,216,190,200,63,208,190,232,13,200,190,112,204,191,190,255,123,183,190,66,29,175,190,224,176,166,190,122,55,158,190,190,177,149,190,88,32,141,190,237,131,132,190,96,186,119,190,149,89,102,190,206,230,84,190,111,99,67,190,213,208,49,190,94,48,32,190,101,131,14,190,157,150,249,189,10,19,214,189,176,126,178,189,127,220,142,189,70,94,86,189,199,242,14,189,86,248,142,188,0,0,0,128,86,248,142,60,199,242,14,61,70,94,86,61,127,220,142,61,176,126,178,61,10,19,214,61,157,150,249,61,101,131,14,62,94,48,32,62,213,208,49,62,111,99,67,62,206,230,84,62,149,89,102,62,96,186,119,62,237,131,132,62,88,32,141,62,190,177,149,62,122,55,158,62,224,176,166,62,66,29,175,62,255,123,183,62,112,204,191,62,232,13,200,62,200,63,208,62,109,97,216,62,45,114,224,62],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+40964);allocate([113,113,232,62,149,94,240,62,247,56,248,62,0,0,0,63,137,217,3,63,203,168,7,63,118,109,11,63,68,39,15,63,231,213,18,63,25,121,22,63,140,16,26,63,254,155,29,63,36,27,33,63,186,141,36,63,124,243,39,63,37,76,43,63,114,151,46,63,34,213,49,63,244,4,53,63,167,38,56,63,255,57,59,63,189,62,62,63,166,52,65,63,124,27,68,63,10,243,70,63,19,187,73,63,96,115,76,63,189,27,79,63,242,179,81,63,207,59,84,63,30,179,86,63,174,25,89,63,81,111,91,63,215,179,93,63,20,231,95,63,219,8,98,63,1,25,100,63,93,23,102,63,202,3,104,63,30,222,105,63,54,166,107,63,237,91,109,63,32,255,110,63,178,143,112,63,130,13,114,63,112,120,115,63,100,208,116,63,63,21,118,63,234,70,119,63,77,101,120,63,82,112,121,63,226,103,122,63,236,75,123,63,93,28,124,63,36,217,124,63,54,130,125,63,130,23,126,63,253,152,126,63,158,6,127,63,92,96,127,63,47,166,127,63,19,216,127,63,5,246,127,63,0,0,128,63,248,218,24,0,8,106,3,0,160,104,3,0,18,7,0,0,1,0,0,0,168,0,0,0,177,0,0,0,185,0,0,0,194,0,0,0,202,0,0,0,210,0,0,0,218,0,0,0,224,0,0,0,231,0,0,0,236,0,0,0,241,0,0,0,246,0,0,0,249,0,0,0,252,0,0,0,254,0,0,0,254,0,0,0,254,0,0,0,254,0,0,0,252,0,0,0,249,0,0,0,246,0,0,0,241,0,0,0,236,0,0,0,231,0,0,0,224,0,0,0,218,0,0,0,210,0,0,0,202,0,0,0,194,0,0,0,185,0,0,0,177,0,0,0,168,0,0,0,158,0,0,0,149,0,0,0,140,0,0,0,131,0,0,0,122,0,0,0,114,0,0,0,105,0,0,0,97,0,0,0,89,0,0,0,82,0,0,0,75,0,0,0,68,0,0,0,62,0,0,0,56,0,0,0,50,0,0,0,45,0,0,0,40,0,0,0,36,0,0,0,32,0,0,0,28,0,0,0,25,0,0,0,22,0,0,0,19,0,0,0,16,0,0,0,14,0,0,0,12,0,0,0,11,0,0,0,9,0,0,0,8,0,0,0,7,0,0,0,5,0,0,0,5,0,0,0,252,218,24,0,122,106,3,0,160,104,3,0,57,7,0,0,1,0,0,0,0,219,24,0,32,107,3,0,160,104,3,0,102,7,0,0,1,0,0,0,4,219,24,0,218,107,3,0,160,104,3,0,134,7,0,0,1,0,0,0,8,219,24,0,139,108,3,0,160,104,3,0,164,7,0,0,1,0,0,0,12,219,24,0,255,108,3,0,160,104,3,0,226,8,0,0,1,0,0,0,69,17,0,0,199,0,0,0,214,0,0,0,217,0,0,0,233,0,0,0,219,0,0,0,197,0,0,0,234,0,0,0,216,0,0,0,221,0,0,0,222,0,0,0,228,0,0,0,225,0,0,0,211,0,0,0,224,0,0,0,210,0,0,0,220,0,0,0,200,0,0,0,201,0,0,0,202,0,0,0,203,0,0,0,204,0,0,0,205,0,0,0,206,0,0,0,207,0,0,0,208,0,0,0,209,0,0,0,212,0,0,0,213,0,0,0,191,0,0,0,226,0,0,0,192,0,0,0,215,0,0,0,190,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,193,0,0,0,84,0,0,0,194,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,151,0,0,0,152,0,0,0,153,0,0,0,154,0,0,0,155,0,0,0,156,0,0,0,157,0,0,0,158,0,0,0,159,0,0,0,160,0,0,0,161,0,0,0,162,0,0,0,163,0,0,0,164,0,0,0,165,0,0,0,166,0,0,0,167,0,0,0,168,0,0,0,169,0,0,0,170,0,0,0,171,0,0,0,172,0,0,0,173,0,0,0,174,0,0,0,175,0,0,0,176,0,0,0,195,0,0,0,223,0,0,0,196,0,0,0,88,0,0,0,69,16,0,0,199,0,0,0,214,0,0,0,217,0,0,0,233,0,0,0,219,0,0,0,197,0,0,0,234,0,0,0,216,0,0,0,221,0,0,0,222,0,0,0,228,0,0,0,225,0,0,0,211,0,0,0,224,0,0,0,210,0,0,0,220,0,0,0,200,0,0,0,201,0,0,0,202,0,0,0,203,0,0,0,204,0,0,0,205,0,0,0,206,0,0,0,207,0,0,0,208,0,0,0,209,0,0,0,212,0,0,0,213,0,0,0,191,0,0,0,226,0,0,0,192,0,0,0,215,0,0,0,190,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,193,0,0,0,84,0,0,0,194,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,123,0,0,0,124,0,0,0,125,0,0,0,126,0,0,0,195,0,0,0,223,0,0,0,196,0,0,0,88,0,0,0,201,55,0,0,151,8,0,0,204,10,0,0,218,10,0,0,222,10,0,0,209,10,0,0,223,10,0,0,208,10,0,0,217,10,0,0,211,10,0,0,212,10,0,0,171,8,0,0,184,8,0,0,163,8,0,0,183,8,0,0,162,8,0,0,172,8,0,0,190,10,0,0,191,10,0,0,192,10,0,0,193,10,0,0,194,10,0,0,195,10,0,0,196,10,0,0,197,10,0,0,198,10,0,0,199,10,0,0,164,8,0,0,165,8,0,0,193,8,0,0,190,8,0,0,194,8,0,0,205,10,0,0,225,8,0,0,3,8,0,0,4,8,0,0,5,8,0,0,6,8,0,0,7,8,0,0,8,8,0,0,9,8,0,0,10,8,0,0,11,8,0,0,12,8,0,0,13,8,0,0,14,8,0,0,15,8,0,0,16,8,0,0,17,8,0,0,18,8,0,0,19,8,0,0,20,8,0,0,21,8,0,0,22,8,0,0,23,8,0,0,24,8,0,0,25,8,0,0,26,8,0,0,27,8,0,0,28,8,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,103,8,0,0,104,8,0,0,105,8,0,0,106,8,0,0,107,8,0,0,108,8,0,0,109,8,0,0,110,8,0,0,111,8,0,0,112,8,0,0,113,8,0,0,114,8,0,0,115,8,0,0,116,8,0,0,117,8,0,0,118,8,0,0,119,8,0,0,120,8,0,0,121,8,0,0,122,8,0,0,123,8,0,0,124,8,0,0,125,8,0,0,126,8,0,0,127,8,0,0,128,8,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,201,48,0,0,151,8,0,0,166,8,0,0,169,8,0,0,227,8,0,0,226,8,0,0,223,8,0,0,224,8,0,0,168,8,0,0,173,8,0,0,174,8,0,0,171,8,0,0,184,8,0,0,163,8,0,0,183,8,0,0,162,8,0,0,172,8,0,0,152,8,0,0,153,8,0,0,154,8,0,0,155,8,0,0,156,8,0,0,157,8,0,0,158,8,0,0,159,8,0,0,160,8,0,0,161,8,0,0,164,8,0,0,165,8,0,0,193,8,0,0,190,8,0,0,194,8,0,0,167,8,0,0,225,8,0,0,209,7,0,0,210,7,0,0,211,7,0,0,212,7,0,0,213,7,0,0,214,7,0,0,215,7,0,0,216,7,0,0,217,7,0,0,218,7,0,0,219,7,0,0,220,7,0,0,221,7,0,0,222,7,0,0,223,7,0,0,224,7,0,0,225,7,0,0,226,7,0,0,227,7,0,0,228,7,0,0,229,7,0,0,230,7,0,0,231,7,0,0,232,7,0,0,233,7,0,0,234,7,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,53,8,0,0,54,8,0,0,55,8,0,0,56,8,0,0,57,8,0,0,58,8,0,0,59,8,0,0,60,8,0,0,61,8,0,0,62,8,0,0,63,8,0,0,64,8,0,0,65,8,0,0,66,8,0,0,67,8,0,0,68,8,0,0,69,8,0,0,70,8,0,0,71,8,0,0,72,8,0,0,73,8,0,0,74,8,0,0,75,8,0,0,76,8,0,0,77,8,0,0,78,8,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,241,10,0,0,242,10,0,0,243,10,0,0,244,10,0,0,245,10,0,0,246,10,0,0,247,10,0,0,248,10,0,0,249,10,0,0,250,10,0,0,251,10,0,0,252,10,0,0,253,10,0,0,254,10,0,0,255,10,0,0,0,11,0,0,1,11,0,0,2,11,0,0,3,11,0,0,4,11,0,0,5,11,0,0,6,11,0,0,7,11,0,0,8,11,0,0,9,11,0,0,10,11,0,0,11,11,0,0,12,11,0,0,13,11,0,0,14,11,0,0,15,11,0,0,16,11,0,0,85,11,0,0,86,11,0,0,87,11,0,0,88,11,0,0,89,11,0,0,90,11,0,0,91,11,0,0,92,11,0,0,93,11,0,0,94,11,0,0,95,11,0,0,96,11,0,0,97,11,0,0,98,11,0,0,99,11,0,0,100,11,0,0,101,11,0,0,102,11,0,0,103,11,0,0,104,11,0,0,105,11,0,0,106,11,0,0,107,11,0,0,108,11,0,0,109,11,0,0,110,11,0,0,111,11,0,0,112,11,0,0,113,11,0,0,114,11,0,0,115,11,0,0,116,11,0,0,201,23,0,0,151,8,0,0,192,12,0,0,206,12,0,0,210,12,0,0,197,12,0,0,161,12,0,0,196,12,0,0,205,12,0,0,199,12,0,0,200,12,0,0,151,12,0,0,153,12,0,0,189,12,0,0,152,12,0,0,188,12,0,0,198,12,0,0,178,12,0,0,179,12,0,0,180,12,0,0,181,12,0,0,182,12,0,0,183,12,0,0,184,12,0,0,185,12,0,0,186,12,0,0,187,12,0,0,190,12,0,0,191,12,0,0,158,12,0,0,154,12,0,0,159,12,0,0,193,12,0,0,162,12,0,0,235,11,0,0,236,11,0,0,237,11,0,0,238,11,0,0,239,11,0,0,240,11,0,0,241,11,0,0,242,11,0,0,243,11,0,0,244,11,0,0,245,11,0,0,246,11,0,0,247,11,0,0,16,8,0,0,249,11,0,0,250,11,0,0,251,11,0,0,252,11,0,0,253,11,0,0,254,11,0,0,255,11,0,0,0,12,0,0,1,12,0,0,2,12,0,0,3,12,0,0,4,12,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,79,12,0,0,80,12,0,0,81,12,0,0,82,12,0,0,83,12,0,0,84,12,0,0,85,12,0,0,86,12,0,0,87,12,0,0,88,12,0,0,89,12,0,0,90,12,0,0,91,12,0,0,92,12,0,0,93,12,0,0,94,12,0,0,95,12,0,0,96,12,0,0,97,12,0,0,98,12,0,0,99,12,0,0,100,12,0,0,101,12,0,0,102,12,0,0,103,12,0,0,104,12,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,201,16,0,0,151,8,0,0,142,12,0,0,156,12,0,0,160,12,0,0,147,12,0,0,161,12,0,0,146,12,0,0,155,12,0,0,149,12,0,0,150,12,0,0,151,12,0,0,153,12,0,0,139,12,0,0,152,12,0,0,138,12,0,0,148,12,0,0,128,12,0,0,129,12,0,0,130,12,0,0,131,12,0,0,132,12,0,0,133,12,0,0,134,12,0,0,135,12,0,0,136,12,0,0,137,12,0,0,140,12,0,0,141,12,0,0,158,12,0,0,154,12,0,0,159,12,0,0,143,12,0,0,162,12,0,0,185,11,0,0,186,11,0,0,187,11,0,0,188,11,0,0,189,11,0,0,190,11,0,0,191,11,0,0,192,11,0,0,193,11,0,0,194,11,0,0,195,11,0,0,196,11,0,0,197,11,0,0,222,7,0,0,199,11,0,0,200,11,0,0,201,11,0,0,202,11,0,0,203,11,0,0,204,11,0,0,205,11,0,0,206,11,0,0,207,11,0,0,208,11,0,0,209,11,0,0,210,11,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,29,12,0,0,30,12,0,0,31,12,0,0,32,12,0,0,33,12,0,0,34,12,0,0,35,12,0,0,36,12,0,0,37,12,0,0,38,12,0,0,39,12,0,0,40,12,0,0,41,12,0,0,42,12,0,0,43,12,0,0,44,12,0,0,45,12,0,0,46,12,0,0,47,12,0,0,48,12,0,0,49,12,0,0,50,12,0,0,51,12,0,0,52,12,0,0,53,12,0,0,54,12,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,118,17,0,0,175,4,0,0,190,4,0,0,193,4,0,0,251,4,0,0,250,4,0,0,247,4,0,0,248,4,0,0,192,4,0,0,197,4,0,0,198,4,0,0,195,4,0,0,208,4,0,0,187,4,0,0,207,4,0,0,186,4,0,0,196,4,0,0,176,4,0,0,177,4,0,0,178,4,0,0,179,4,0,0,180,4,0,0,181,4,0,0,182,4,0,0,183,4,0,0,184,4,0,0,185,4,0,0,188,4,0,0,189,4,0,0,217,4,0,0,214,4,0,0,218,4,0,0,191,4,0,0,249,4,0,0,27,4,0,0,28,4,0,0,29,4,0,0,30,4,0,0,31,4,0,0,32,4,0,0,33,4,0,0,34,4,0,0,35,4,0,0,36,4,0,0,37,4,0,0,38,4,0,0,39,4,0,0,40,4,0,0,41,4,0,0,42,4,0,0,43,4,0,0,44,4,0,0,45,4,0,0,46,4,0,0,47,4,0,0,48,4,0,0,49,4,0,0,50,4,0,0,51,4,0,0,52,4,0,0,199,4,0,0,60,4,0,0,200,4,0,0,223,4,0,0,74,2,0,0,225,4,0,0,127,4,0,0,128,4,0,0,129,4,0,0,130,4,0,0,131,4,0,0,132,4,0,0,133,4,0,0,134,4,0,0,135,4,0,0,136,4,0,0,137,4,0,0,138,4,0,0,139,4,0,0,140,4,0,0,141,4,0,0,142,4,0,0,143,4,0,0,144,4,0,0,145,4,0,0,146,4,0,0,147,4,0,0,148,4,0,0,149,4,0,0,150,4,0,0,151,4,0,0,152,4,0,0,201,4,0,0,205,4,0,0,202,4,0,0,222,4,0,0,118,16,0,0,175,4,0,0,190,4,0,0,193,4,0,0,251,4,0,0,250,4,0,0,247,4,0,0,248,4,0,0,192,4,0,0,197,4,0,0,198,4,0,0,195,4,0,0,208,4,0,0,187,4,0,0,207,4,0,0,186,4,0,0,196,4,0,0,176,4,0,0,177,4,0,0,178,4,0,0,179,4,0,0,180,4,0,0,181,4,0,0,182,4,0,0,183,4,0,0,184,4,0,0,185,4,0,0,188,4,0,0,165,8,0,0,217,4,0,0,214,4,0,0,218,4,0,0,191,4,0,0,249,4,0,0,233,3,0,0,234,3,0,0,235,3,0,0,236,3,0,0,237,3,0,0,238,3,0,0,239,3,0,0,240,3,0,0,241,3,0,0,242,3,0,0,243,3,0,0,244,3,0,0,245,3,0,0,246,3,0,0,247,3,0,0,248,3,0,0,249,3,0,0,250,3,0,0,251,3,0,0,252,3,0,0,253,3,0,0,254,3,0,0,255,3,0,0,0,4,0,0,1,4,0,0,2,4,0,0,199,4,0,0,60,4,0,0,200,4,0,0,223,4,0,0,74,2,0,0,225,4,0,0,77,4,0,0,78,4,0,0,79,4,0,0,80,4,0,0,81,4,0,0,82,4,0,0,83,4,0,0,84,4,0,0,85,4,0,0,86,4,0,0,87,4,0,0,88,4,0,0,89,4,0,0,90,4,0,0,91,4,0,0,92,4,0,0,93,4,0,0,94,4,0,0,95,4,0,0,96,4,0,0,97,4,0,0,98,4,0,0,99,4,0,0,100,4,0,0,101,4,0,0,102,4,0,0,201,4,0,0,205,4,0,0,202,4,0,0,222,4,0,0,201,23,0,0,151,8,0,0,204,10,0,0,218,10,0,0,222,10,0,0,209,10,0,0,223,10,0,0,208,10,0,0,217,10,0,0,211,10,0,0,212,10,0,0,171,8,0,0,184,8,0,0,163,8,0,0,183,8,0,0,162,8,0,0,172,8,0,0,190,10,0,0,191,10,0,0,192,10,0,0,193,10,0,0,194,10,0,0,195,10,0,0,196,10,0,0,197,10,0,0,198,10,0,0,199,10,0,0,164,8,0,0,165,8,0,0,193,8,0,0,190,8,0,0,194,8,0,0,167,8,0,0,225,8,0,0,247,9,0,0,248,9,0,0,249,9,0,0,250,9,0,0,251,9,0,0,252,9,0,0,253,9,0,0,254,9,0,0,255,9,0,0,0,10,0,0,1,10,0,0,2,10,0,0,3,10,0,0,4,10,0,0,5,10,0,0,6,10,0,0,7,10,0,0,8,10,0,0,9,10,0,0,10,10,0,0,11,10,0,0,12,10,0,0,13,10,0,0,14,10,0,0,15,10,0,0,16,10,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,74,2,0,0,201,8,0,0,91,10,0,0,92,10,0,0,93,10,0,0,94,10,0,0,95,10,0,0,96,10,0,0,97,10,0,0,98,10,0,0,99,10,0,0,100,10,0,0,101,10,0,0,102,10,0,0,103,10,0,0,104,10,0,0,105,10,0,0,106,10,0,0,107,10,0,0,108,10,0,0,109,10,0,0,110,10,0,0,111,10,0,0,112,10,0,0,113,10,0,0,114,10,0,0,115,10,0,0,116,10,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,201,17,0,0,151,8,0,0,202,2,0,0,205,2,0,0,221,2,0,0,207,2,0,0,185,2,0,0,222,2,0,0,204,2,0,0,209,2,0,0,210,2,0,0,216,2,0,0,213,2,0,0,199,2,0,0,212,2,0,0,198,2,0,0,208,2,0,0,188,2,0,0,189,2,0,0,190,2,0,0,191,2,0,0,192,2,0,0,193,2,0,0,194,2,0,0,195,2,0,0,196,2,0,0,197,2,0,0,200,2,0,0,201,2,0,0,179,2,0,0,214,2,0,0,180,2,0,0,203,2,0,0,178,2,0,0,39,2,0,0,40,2,0,0,41,2,0,0,42,2,0,0,43,2,0,0,44,2,0,0,45,2,0,0,46,2,0,0,47,2,0,0,48,2,0,0,49,2,0,0,50,2,0,0,51,2,0,0,52,2,0,0,53,2,0,0,54,2,0,0,55,2,0,0,56,2,0,0,57,2,0,0,58,2,0,0,59,2,0,0,60,2,0,0,61,2,0,0,62,2,0,0,63,2,0,0,64,2,0,0,181,2,0,0,72,2,0,0,182,2,0,0,199,8,0,0,74,2,0,0,201,8,0,0,139,2,0,0,140,2,0,0,141,2,0,0,142,2,0,0,143,2,0,0,144,2,0,0,145,2,0,0,146,2,0,0,147,2,0,0,148,2,0,0,149,2,0,0,150,2,0,0,151,2,0,0,152,2,0,0,153,2,0,0,154,2,0,0,155,2,0,0,156,2,0,0,157,2,0,0,158,2,0,0,159,2,0,0,160,2,0,0,161,2,0,0,162,2,0,0,163,2,0,0,164,2,0,0,183,2,0,0,211,2,0,0,184,2,0,0,198,8,0,0,201,16,0,0,151,8,0,0,154,10,0,0,168,10,0,0,172,10,0,0,159,10,0,0,173,10,0,0,158,10,0,0,167,10,0,0,161,10,0,0,162,10,0,0,163,10,0,0,165,10,0,0,151,10,0,0,164,10,0,0,150,10,0,0,160,10,0,0,140,10,0,0,141,10,0,0,142,10,0,0,143,10,0,0,144,10,0,0,145,10,0,0,146,10,0,0,147,10,0,0,148,10,0,0,149,10,0,0,152,10,0,0,153,10,0,0,170,10,0,0,166,10,0,0,171,10,0,0,155,10,0,0,174,10,0,0,197,9,0,0,198,9,0,0,199,9,0,0,200,9,0,0,201,9,0,0,202,9,0,0,203,9,0,0,204,9,0,0,205,9,0,0,206,9,0,0,207,9,0,0,208,9,0,0,209,9,0,0,210,9,0,0,211,9,0,0,212,9,0,0,213,9,0,0,214,9,0,0,215,9,0,0,216,9,0,0,217,9,0,0,218,9,0,0,219,9,0,0,220,9,0,0,221,9,0,0,222,9,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,41,10,0,0,42,10,0,0,43,10,0,0,44,10,0,0,45,10,0,0,46,10,0,0,47,10,0,0,48,10,0,0,49,10,0,0,50,10,0,0,51,10,0,0,52,10,0,0,53,10,0,0,54,10,0,0,55,10,0,0,56,10,0,0,57,10,0,0,58,10,0,0,59,10,0,0,60,10,0,0,61,10,0,0,62,10,0,0,63,10,0,0,64,10,0,0,65,10,0,0,66,10,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,201,16,0,0,151,8,0,0,202,2,0,0,205,2,0,0,221,2,0,0,207,2,0,0,185,2,0,0,222,2,0,0,204,2,0,0,209,2,0,0,210,2,0,0,216,2,0,0,213,2,0,0,199,2,0,0,212,2,0,0,198,2,0,0,208,2,0,0,188,2,0,0,189,2,0,0,190,2,0,0,191,2,0,0,192,2,0,0,193,2,0,0,194,2,0,0,195,2,0,0,196,2,0,0,197,2,0,0,200,2,0,0,201,2,0,0,179,2,0,0,214,2,0,0,180,2,0,0,203,2,0,0,178,2,0,0,245,1,0,0,246,1,0,0,247,1,0,0,248,1,0,0,249,1,0,0,250,1,0,0,251,1,0,0,252,1,0,0,253,1,0,0,254,1,0,0,255,1,0,0,0,2,0,0,1,2,0,0,2,2,0,0,3,2,0,0,4,2,0,0,5,2,0,0,6,2,0,0,7,2,0,0,8,2,0,0,9,2,0,0,10,2,0,0,11,2,0,0,12,2,0,0,13,2,0,0,14,2,0,0,181,2,0,0,72,2,0,0,182,2,0,0,199,8,0,0,74,2,0,0,201,8,0,0,89,2,0,0,90,2,0,0,91,2,0,0,92,2,0,0,93,2,0,0,94,2,0,0,95,2,0,0,96,2,0,0,97,2,0,0,98,2,0,0,99,2,0,0,100,2,0,0,101,2,0,0,102,2,0,0,103,2,0,0,104,2,0,0,105,2,0,0,106,2,0,0,107,2,0,0,108,2,0,0,109,2,0,0,110,2,0,0,111,2,0,0,112,2,0,0,113,2,0,0,114,2,0,0,183,2,0,0,211,2,0,0,184,2,0,0,198,8,0,0,16,219,24,0,92,110,3,0,160,104,3,0,170,9,0,0,1,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,20,219,24,0,188,111,3,0,27,111,3,0,107,1,0,0,1,0,0,0,0,0,0,0,72,55,0,0,186,0,0,0,187,0,0,0,1,0,0,0,0,0,0,0,80,55,0,0,188,0,0,0,189,0,0,0,1,0,0,0,190,0,0,0,0,0,0,0,88,55,0,0,191,0,0,0,192,0,0,0,1,0,0,0,193,0,0,0,0,0,0,0,96,55,0,0,194,0,0,0,195,0,0,0,3,0,0,0,4,0,0,0,29,0,0,0,26,0,0,0,24,219,24,0,204,112,3,0,153,112,3,0,130,1,0,0,1,0,0,0,0,0,0,0,216,56,0,0,8,0,0,0,196,0,0,0,197,0,0,0,0,0,0,0,168,56,0,0,8,0,0,0,198,0,0,0,199,0,0,0,0,0,0,0,136,56,0,0,8,0,0,0,200,0,0,0,201,0,0,0,0,0,0,0,104,56,0,0,8,0,0,0,202,0,0,0,203,0,0,0,0,0,0,0,72,56,0,0,8,0,0,0,204,0,0,0,205,0,0,0,0,0,0,0,40,56,0,0,8,0,0,0,206,0,0,0,207,0,0,0,0,0,0,0,8,56,0,0,8,0,0,0,208,0,0,0,209,0,0,0,0,0,0,0,232,55,0,0,8,0,0,0,210,0,0,0,211,0,0,0,0,0,0,0,200,55,0,0,8,0,0,0,212,0,0,0,213,0,0,0,0,0,0,0,168,55,0,0,8,0,0,0,214,0,0,0,215,0,0,0,0,0,0,0,136,55,0,0,8,0,0,0,216,0,0,0,217,0,0,0,0,0,0,0,104,55,0,0,8,0,0,0,218,0,0,0,219,0,0,0,0,0,0,0,120,55,0,0,220,0,0,0,221,0,0,0,27,0,0,0,0,0,0,0,152,55,0,0,222,0,0,0,223,0,0,0,28,0,0,0,0,0,0,0,184,55,0,0,224,0,0,0,225,0,0,0,29,0,0,0,0,0,0,0,216,55,0,0,226,0,0,0,227,0,0,0,30,0,0,0,0,0,0,0,248,55,0,0,228,0,0,0,229,0,0,0,31,0,0,0,0,0,0,0,24,56,0,0,230,0,0,0,231,0,0,0,32,0,0,0,0,0,0,0,56,56,0,0,232,0,0,0,233,0,0,0,33,0,0,0,0,0,0,0,88,56,0,0,234,0,0,0,235,0,0,0,34,0,0,0,0,0,0,0,120,56,0,0,236,0,0,0,237,0,0,0,35,0,0,0,0,0,0,0,152,56,0,0,238,0,0,0,239,0,0,0,36,0,0,0,0,0,0,0,200,56,0,0,240,0,0,0,241,0,0,0,37,0,0,0,0,0,0,0,184,56,0,0,240,0,0,0,242,0,0,0,38,0,0,0,0,0,0,0,248,56,0,0,243,0,0,0,244,0,0,0,39,0,0,0,0,0,0,0,232,56,0,0,243,0,0,0,245,0,0,0,40,0,0,0,0,0,0,0,8,60,0,0,8,0,0,0,246,0,0,0,247,0,0,0,0,0,0,0,248,59,0,0,8,0,0,0,248,0,0,0,249,0,0,0,0,0,0,0,232,59,0,0,8,0,0,0,250,0,0,0,251,0,0,0,0,0,0,0,216,59,0,0,8,0,0,0,252,0,0,0,253,0,0,0,0,0,0,0,200,59,0,0,8,0,0,0,254,0,0,0,255,0,0,0,0,0,0,0,184,59,0,0,8,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,168,59,0,0,8,0,0,0,2,1,0,0,3,1,0,0,0,0,0,0,152,59,0,0,8,0,0,0,4,1,0,0,5,1,0,0,0,0,0,0,136,59,0,0,8,0,0,0,6,1,0,0,7,1,0,0,0,0,0,0,104,59,0,0,8,0,0,0,8,1,0,0,9,1,0,0,0,0,0,0,40,59,0,0,8,0,0,0,10,1,0,0,11,1,0,0,0,0,0,0,232,58,0,0,8,0,0,0,12,1,0,0,13,1,0,0,0,0,0,0,184,58,0,0,8,0,0,0,14,1,0,0,15,1,0,0,0,0,0,0,136,58,0,0,8,0,0,0,16,1,0,0,17,1,0,0,0,0,0,0,88,58,0,0,8,0,0,0,18,1,0,0,19,1,0,0,0,0,0,0,40,58,0,0,8,0,0,0,20,1,0,0,21,1,0,0,0,0,0,0,248,57,0,0,8,0,0,0,22,1,0,0,23,1,0,0,0,0,0,0,200,57,0,0,8,0,0,0,24,1,0,0,25,1,0,0,0,0,0,0,152,57,0,0,8,0,0,0,26,1,0,0,27,1,0,0,0,0,0,0,104,57,0,0,8,0,0,0,28,1,0,0,29,1,0,0,0,0,0,0,56,57,0,0,8,0,0,0,30,1,0,0,31,1,0,0,0,0,0,0,8,57,0,0,8,0,0,0,32,1,0,0,33,1,0,0,0,0,0,0,40,57,0,0,34,1,0,0,35,1,0,0,20,0,0,0,190,0,0,0,0,0,0,0,24,57,0,0,34,1,0,0,36,1,0,0,21,0,0,0,190,0,0,0,0,0,0,0,88,57,0,0,37,1,0,0,38,1,0,0,22,0,0,0,190,0,0,0,0,0,0,0,72,57,0,0,37,1,0,0,39,1,0,0,23,0,0,0,190,0,0,0,0,0,0,0,136,57,0,0,40,1,0,0,41,1,0,0,24,0,0,0,190,0,0,0,0,0,0,0,120,57,0,0,40,1,0,0,42,1,0,0,25,0,0,0,190,0,0,0,0,0,0,0,184,57,0,0,43,1,0,0,44,1,0,0,26,0,0,0,190,0,0,0,0,0,0,0,168,57,0,0,43,1,0,0,45,1,0,0,27,0,0,0,190,0,0,0,0,0,0,0,232,57,0,0,46,1,0,0,47,1,0,0,28,0,0,0,190,0,0,0,0,0,0,0,216,57,0,0,46,1,0,0,48,1,0,0,29,0,0,0,190,0,0,0,0,0,0,0,24,58,0,0,49,1,0,0,50,1,0,0,30,0,0,0,190,0,0,0,0,0,0,0,8,58,0,0,49,1,0,0,51,1,0,0,31,0,0,0,190,0,0,0,0,0,0,0,72,58,0,0,52,1,0,0,53,1,0,0,32,0,0,0,190,0,0,0,0,0,0,0,56,58,0,0,52,1,0,0,54,1,0,0,33,0,0,0,190,0,0,0,0,0,0,0,120,58,0,0,55,1,0,0,56,1,0,0,34,0,0,0,190,0,0,0,0,0,0,0,104,58,0,0,55,1,0,0,57,1,0,0,35,0,0,0,190,0,0,0,0,0,0,0,168,58,0,0,58,1,0,0,59,1,0,0,36,0,0,0,190,0,0,0,0,0,0,0,152,58,0,0,58,1,0,0,60,1,0,0,37,0,0,0,190,0,0,0,0,0,0,0,216,58,0,0,61,1,0,0,62,1,0,0,38,0,0,0,190,0,0,0,0,0,0,0,200,58,0,0,61,1,0,0,63,1,0,0,39,0,0,0,190,0,0,0,0,0,0,0,8,59,0,0,64,1,0,0,65,1,0,0,40,0,0,0,190,0,0,0,0,0,0,0,248,58,0,0,64,1,0,0,66,1,0,0,41,0,0,0,190,0,0,0,0,0,0,0,24,59,0,0,64,1,0,0,67,1,0,0,42,0,0,0,190,0,0,0,0,0,0,0,72,59,0,0,68,1,0,0,69,1,0,0,43,0,0,0,190,0,0,0,0,0,0,0,56,59,0,0,68,1,0,0,70,1,0,0,44,0,0,0,190,0,0,0,0,0,0,0,88,59,0,0,68,1,0,0,71,1,0,0,45,0,0,0,190,0,0,0,0,0,0,0,120,59,0,0,61,1,0,0,72,1,0,0,46,0,0,0,190,0,0,0,0,0,0,0,24,60,0,0,8,0,0,0,73,1,0,0,74,1,0,0,0,0,0,0,168,61,0,0,8,0,0,0,75,1,0,0,76,1,0,0,0,0,0,0,136,61,0,0,8,0,0,0,77,1,0,0,78,1,0,0,0,0,0,0,104,61,0,0,8,0,0,0,79,1,0,0,80,1,0,0,0,0,0,0,72,61,0,0,8,0,0,0,81,1,0,0,82,1,0,0,0,0,0,0,40,61,0,0,8,0,0,0,83,1,0,0,84,1,0,0,0,0,0,0,8,61,0,0,8,0,0,0,85,1,0,0,86,1,0,0,0,0,0,0,232,60,0,0,8,0,0,0,87,1,0,0,88,1,0,0,0,0,0,0,200,60,0,0,8,0,0,0,89,1,0,0,90,1,0,0,0,0,0,0,168,60,0,0,8,0,0,0,91,1,0,0,92,1,0,0,0,0,0,0,136,60,0,0,8,0,0,0,93,1,0,0,94,1,0,0,0,0,0,0,104,60,0,0,8,0,0,0,95,1,0,0,96,1,0,0,0,0,0,0,72,60,0,0,8,0,0,0,97,1,0,0,98,1,0,0,0,0,0,0,40,60,0,0,8,0,0,0,99,1,0,0,100,1,0,0,0,0,0,0,56,60,0,0,101,1,0,0,102,1,0,0,8,0,0,0,193,0,0,0,0,0,0,0,88,60,0,0,103,1,0,0,104,1,0,0,9,0,0,0,193,0,0,0,0,0,0,0,120,60,0,0,105,1,0,0,106,1,0,0,10,0,0,0,193,0,0,0,0,0,0,0,152,60,0,0,107,1,0,0,108,1,0,0,11,0,0,0,193,0,0,0,0,0,0,0,184,60,0,0,109,1,0,0,110,1,0,0,12,0,0,0,193,0,0,0,0,0,0,0,216,60,0,0,111,1,0,0,112,1,0,0,13,0,0,0,193,0,0,0,0,0,0,0,248,60,0,0,113,1,0,0,114,1,0,0,14,0,0,0,193,0,0,0,0,0,0,0,24,61,0,0,115,1,0,0,116,1,0,0,15,0,0,0,193,0,0,0,0,0,0,0,56,61,0,0,117,1,0,0,118,1,0,0,16,0,0,0,193,0,0,0,0,0,0,0,88,61,0,0,119,1,0,0,120,1,0,0,17,0,0,0,193,0,0,0,0,0,0,0,120,61,0,0,121,1,0,0,122,1,0,0,18,0,0,0,193,0,0,0,0,0,0,0,152,61,0,0,123,1,0,0,124,1,0,0,19,0,0,0,193,0,0,0,0,0,0,0,184,61,0,0,125,1,0,0,126,1,0,0,20,0,0,0,193,0,0,0,28,219,24,0,246,148,3,0,153,112,3,0,33,19,0,0,1,0,0,0,32,219,24,0,203,149,3,0,153,112,3,0,64,19,0,0,1,0,0,0,36,219,24,0,153,150,3,0,42,150,3,0,97,0,0,0,1,0,0,0,40,219,24,0,162,153,3,0,29,151,3,0,21,2,0,0,1,0,0,0,153,226,86,0,5,154,3,0,22,154,3,0,53,154,3,0,76,154,3,0,100,154,3,0,122,154,3,0,139,154,3,0,169,154,3,0,186,154,3,0,193,154,3,0,208,154,3,0,225,154,3,0,237,154,3,0,3,155,3,0,20,155,3,0,49,155,3,0,69,155,3,0,103,155,3,0,128,155,3,0,155,155,3,0,167,155,3,0,186,155,3,0,198,155,3,0,220,155,3,0,232,155,3,0,246,155,3,0,5,154,3,0,22,154,3,0,7,156,3,0,19,156,3,0,100,154,3,0,246,155,3,0,169,154,3,0,36,156,3,0,186,154,3,0,208,154,3,0,75,156,3,0,237,154,3,0,3,155,3,0,87,156,3,0,20,155,3,0,109,156,3,0,49,155,3,0,126,156,3,0,155,155,3,0,145,156,3,0,175,156,3,0,220,155,3,0,201,156,3,0,225,156,3,0,252,156,3,0,13,157,3,0,46,157,3,0,75,157,3,0,99,157,3,0,121,157,3,0,138,157,3,0,169,157,3,0,186,157,3,0,193,157,3,0,210,157,3,0,227,157,3,0,239,157,3,0,5,158,3,0,22,158,3,0,55,158,3,0,77,158,3,0,129,158,3,0,162,158,3,0,189,158,3,0,201,158,3,0,220,158,3,0,232,158,3,0,254,158,3,0,10,159,3,0,24,159,3,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,35,159,3,0,52,159,3,0,59,159,3,0,71,159,3,0,78,159,3,0,85,159,3,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,100,159,3,0,126,159,3,0,152,159,3,0,173,159,3,0,199,159,3,0,220,159,3,0,238,159,3,0,14,160,3,0,34,160,3,0,52,160,3,0,76,160,3,0,186,154,3,0,93,160,3,0,130,160,3,0,150,160,3,0,171,160,3,0,197,160,3,0,223,160,3,0,239,160,3,0,10,161,3,0,28,161,3,0,48,161,3,0,60,161,3,0,82,161,3,0,94,161,3,0,112,161,3,0,123,161,3,0,148,161,3,0,185,161,3,0,211,161,3,0,242,161,3,0,16,162,3,0,48,162,3,0,80,162,3,0,119,162,3,0,134,162,3,0,159,162,3,0,177,162,3,0,210,162,3,0,228,162,3,0,150,160,3,0,15,163,3,0,38,163,3,0,61,163,3,0,84,163,3,0,98,163,3,0,121,163,3,0,152,163,3,0,176,163,3,0,204,163,3,0,234,163,3,0,10,164,3,0,33,164,3,0,52,164,3,0,84,164,3,0,109,164,3,0,133,164,3,0,167,164,3,0,195,164,3,0,225,164,3,0,1,165,3,0,26,165,3,0,39,165,3,0,88,165,3,0,150,160,3,0,122,165,3,0,154,165,3,0,180,165,3,0,204,165,3,0,231,165,3,0,249,165,3,0,27,166,3,0,52,166,3,0,92,166,3,0,128,166,3,0,164,166,3,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,189,166,3,0,218,166,3,0,244,166,3,0,22,167,3,0,52,167,3,0,153,226,86,0,153,226,86,0,77,167,3,0,135,167,3,0,144,167,3,0,153,167,3,0,164,167,3,0,175,167,3,0,200,167,3,0,225,167,3,0,17,168,3,0,20,168,3,0,23,168,3,0,48,168,3,0,57,168,3,0,76,168,3,0,106,168,3,0,120,168,3,0,148,168,3,0,177,168,3,0,189,168,3,0,227,168,3,0,0,169,3,0,13,169,3,0,28,169,3,0,52,169,3,0,78,169,3,0,101,169,3,0,135,169,3,0,142,169,3,0,154,169,3,0,175,169,3,0,207,169,3,0,214,169,3,0,229,169,3,0,244,169,3,0,251,169,3,0,2,170,3,0,14,170,3,0,26,170,3,0,38,170,3,0,55,170,3,0,68,170,3,0,83,170,3,0,98,170,3,0,112,170,3,0,134,170,3,0,177,170,3,0,215,170,3,0,153,226,86,0,252,170,3,0,20,171,3,0,82,171,3,0,153,226,86,0,89,171,3,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,102,171,3,0,153,226,86,0,188,171,3,0,153,226,86,0,242,171,3,0,153,226,86,0,2,172,3,0,153,226,86,0,15,172,3,0,153,226,86,0,69,172,3,0,76,172,3,0,153,226,86,0,88,172,3,0,178,172,3,0,20,173,3,0,113,173,3,0,233,173,3,0,124,174,3,0,45,175,3,0,209,175,3,0,95,176,3,0,232,176,3,0,22,177,3,0,125,177,3,0,203,177,3,0,59,178,3,0,150,178,3,0,172,178,3,0,153,226,86,0,207,178,3,0,250,178,3,0,37,179,3,0,69,179,3,0,101,179,3,0,153,226,86,0,133,179,3,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,150,179,3,0,167,179,3,0,214,179,3,0,253,179,3,0,29,180,3,0,51,180,3,0,68,180,3,0,114,180,3,0,131,180,3,0,138,180,3,0,161,180,3,0,178,180,3,0,190,180,3,0,212,180,3,0,229,180,3,0,18,181,3,0,46,181,3,0,96,181,3,0,129,181,3,0,172,181,3,0,184,181,3,0,207,181,3,0,219,181,3,0,241,181,3,0,253,181,3,0,11,182,3,0,150,179,3,0,167,179,3,0,28,182,3,0,40,182,3,0,29,180,3,0,11,182,3,0,114,180,3,0,57,182,3,0,131,180,3,0,161,180,3,0,107,182,3,0,190,180,3,0,212,180,3,0,119,182,3,0,229,180,3,0,136,182,3,0,18,181,3,0,153,182,3,0,172,181,3,0,172,182,3,0,210,182,3,0,252,182,3,0,8,183,3,0,44,183,3,0,79,183,3,0,120,183,3,0,202,183,3,0,251,183,3,0,66,184,3,0,123,184,3,0,178,184,3,0,237,184,3,0,57,185,3],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+51204);allocate([108,185,3,0,159,185,3,0,236,185,3,0,39,186,3,0,128,186,3,0,192,186,3,0,251,186,3,0,58,187,3,0,123,187,3,0,200,187,3,0,1,188,3,0,51,188,3,0,117,188,3,0,182,188,3,0,230,188,3,0,46,189,3,0,122,189,3,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,203,189,3,0,220,189,3,0,227,189,3,0,239,189,3,0,246,189,3,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,3,190,3,0,39,190,3,0,75,190,3,0,106,190,3,0,142,190,3,0,179,190,3,0,197,190,3,0,243,190,3,0,9,191,3,0,27,191,3,0,51,191,3,0,131,180,3,0,68,191,3,0,105,191,3,0,127,191,3,0,164,191,3,0,200,191,3,0,236,191,3,0,254,191,3,0,35,192,3,0,53,192,3,0,75,192,3,0,87,192,3,0,109,192,3,0,121,192,3,0,141,192,3,0,158,192,3,0,206,192,3,0,11,193,3,0,45,193,3,0,94,193,3,0,132,193,3,0,178,193,3,0,216,193,3,0,15,194,3,0,34,194,3,0,71,194,3,0,89,194,3,0,130,194,3,0,158,194,3,0,215,194,3,0,252,194,3,0,21,195,3,0,60,195,3,0,97,195,3,0,113,195,3,0,146,195,3,0,189,195,3,0,217,195,3,0,1,196,3,0,47,196,3,0,92,196,3,0,139,196,3,0,168,196,3,0,216,196,3,0,251,196,3,0,44,197,3,0,100,197,3,0,158,197,3,0,190,197,3,0,230,197,3,0,39,198,3,0,76,198,3,0,141,198,3,0,187,198,3,0,234,198,3,0,25,199,3,0,79,199,3,0,110,199,3,0,142,199,3,0,173,199,3,0,211,199,3,0,245,199,3,0,38,200,3,0,78,200,3,0,124,200,3,0,171,200,3,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,216,200,3,0,13,201,3,0,45,201,3,0,91,201,3,0,133,201,3,0,153,226,86,0,153,226,86,0,166,201,3,0,254,201,3,0,7,202,3,0,16,202,3,0,33,202,3,0,50,202,3,0,83,202,3,0,116,202,3,0,20,168,3,0,179,202,3,0,182,202,3,0,219,202,3,0,230,202,3,0,5,203,3,0,38,203,3,0,52,203,3,0,89,203,3,0,138,203,3,0,150,203,3,0,211,203,3,0,4,204,3,0,17,204,3,0,36,204,3,0,60,204,3,0,90,204,3,0,108,204,3,0,150,204,3,0,157,204,3,0,169,204,3,0,198,204,3,0,251,204,3,0,2,205,3,0,25,205,3,0,48,205,3,0,55,205,3,0,62,205,3,0,74,205,3,0,86,205,3,0,98,205,3,0,115,205,3,0,128,205,3,0,145,205,3,0,162,205,3,0,180,205,3,0,202,205,3,0,17,206,3,0,71,206,3,0,124,206,3,0,136,206,3,0,148,206,3,0,157,206,3,0,192,206,3,0,255,206,3,0,51,207,3,0,89,207,3,0,181,207,3,0,29,208,3,0,153,226,86,0,153,226,86,0,153,226,86,0,134,208,3,0,170,208,3,0,202,208,3,0,219,208,3,0,13,209,3,0,61,209,3,0,87,209,3,0,107,209,3,0,130,209,3,0,157,209,3,0,180,209,3,0,195,209,3,0,208,209,3,0,223,209,3,0,238,209,3,0,25,210,3,0,68,210,3,0,131,210,3,0,171,210,3,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,231,210,3,0,238,210,3,0,245,210,3,0,252,210,3,0,3,211,3,0,10,211,3,0,17,211,3,0,153,226,86,0,24,211,3,0,31,211,3,0,38,211,3,0,45,211,3,0,153,226,86,0,52,211,3,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,59,211,3,0,78,211,3,0,97,211,3,0,116,211,3,0,135,211,3,0,146,211,3,0,157,211,3,0,168,211,3,0,179,211,3,0,226,211,3,0,17,212,3,0,64,212,3,0,111,212,3,0,154,212,3,0,193,212,3,0,153,226,86,0,244,212,3,0,5,213,3,0,16,213,3,0,28,213,3,0,45,213,3,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,62,213,3,0,99,213,3,0,112,213,3,0,123,213,3,0,136,213,3,0,161,213,3,0,173,213,3,0,185,213,3,0,153,226,86,0,153,226,86,0,202,213,3,0,10,214,3,0,58,214,3,0,89,214,3,0,120,214,3,0,151,214,3,0,182,214,3,0,153,226,86,0,153,226,86,0,153,226,86,0,222,214,3,0,247,214,3,0,12,215,3,0,38,215,3,0,70,215,3,0,107,215,3,0,128,215,3,0,157,215,3,0,221,215,3,0,241,215,3,0,51,216,3,0,165,216,3,0,81,217,3,0,159,217,3,0,221,217,3,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,248,217,3,0,5,218,3,0,26,218,3,0,55,218,3,0,62,213,3,0,92,218,3,0,137,218,3,0,206,218,3,0,19,219,3,0,120,219,3,0,188,219,3,0,253,219,3,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,58,220,3,0,90,220,3,0,156,220,3,0,204,220,3,0,254,220,3,0,38,221,3,0,74,221,3,0,142,221,3,0,189,221,3,0,211,221,3,0,248,221,3,0,39,222,3,0,65,222,3,0,117,222,3,0,154,222,3,0,217,222,3,0,8,223,3,0,99,223,3,0,168,223,3,0,232,223,3,0,6,224,3,0,44,224,3,0,71,224,3,0,113,224,3,0,150,224,3,0,186,224,3,0,58,220,3,0,90,220,3,0,216,224,3,0,242,224,3,0,254,220,3,0,186,224,3,0,142,221,3,0,13,225,3,0,189,221,3,0,248,221,3,0,96,225,3,0,65,222,3,0,117,222,3,0,123,225,3,0,154,222,3,0,185,225,3,0,217,222,3,0,222,225,3,0,232,223,3,0,3,226,3,0,66,226,3,0,113,224,3,0,141,226,3,0,202,226,3,0,13,227,3,0,45,227,3,0,109,227,3,0,159,227,3,0,209,227,3,0,249,227,3,0,29,228,3,0,93,228,3,0,140,228,3,0,162,228,3,0,199,228,3,0,246,228,3,0,16,229,3,0,68,229,3,0,105,229,3,0,168,229,3,0,213,229,3,0,46,230,3,0,111,230,3,0,167,230,3,0,197,230,3,0,235,230,3,0,6,231,3,0,48,231,3,0,85,231,3,0,121,231,3,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,151,231,3,0,158,231,3,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,170,231,3,0,232,231,3,0,31,232,3,0,79,232,3,0,139,232,3,0,190,232,3,0,228,232,3,0,52,233,3,0,103,233,3,0,136,233,3,0,180,233,3,0,227,233,3,0,249,233,3,0,73,234,3,0,124,234,3,0,179,234,3,0,239,234,3,0,38,235,3,0,79,235,3,0,131,235,3,0,158,235,3,0,209,235,3,0,236,235,3,0,22,236,3,0,59,236,3,0,102,236,3,0,132,236,3,0,194,236,3,0,14,237,3,0,51,237,3,0,127,237,3,0,179,237,3,0,235,237,3,0,29,238,3,0,98,238,3,0,124,238,3,0,173,238,3,0,201,238,3,0,250,238,3,0,30,239,3,0,99,239,3,0,154,239,3,0,190,239,3,0,246,239,3,0,45,240,3,0,71,240,3,0,119,240,3,0,187,240,3,0,220,240,3,0,18,241,3,0,88,241,3,0,150,241,3,0,211,241,3,0,255,241,3,0,66,242,3,0,112,242,3,0,157,242,3,0,223,242,3,0,22,243,3,0,73,243,3,0,124,243,3,0,184,243,3,0,215,243,3,0,47,244,3,0,99,239,3,0,111,244,3,0,178,244,3,0,231,244,3,0,18,245,3,0,66,245,3,0,97,245,3,0,71,240,3,0,161,245,3,0,233,245,3,0,51,246,3,0,119,246,3,0,170,246,3,0,243,246,3,0,40,247,3,0,89,247,3,0,177,247,3,0,5,248,3,0,153,226,86,0,27,248,3,0,68,248,3,0,136,248,3,0,201,248,3,0,153,226,86,0,153,226,86,0,153,226,86,0,245,248,3,0,76,249,3,0,149,249,3,0,221,249,3,0,84,250,3,0,202,250,3,0,153,226,86,0,242,250,3,0,245,250,3,0,248,250,3,0,47,251,3,0,66,251,3,0,134,251,3,0,210,251,3,0,234,251,3,0,41,252,3,0,112,252,3,0,153,252,3,0,251,252,3,0,66,253,3,0,79,253,3,0,96,253,3,0,120,253,3,0,148,253,3,0,177,253,3,0,234,253,3,0,246,253,3,0,12,254,3,0,33,254,3,0,50,254,3,0,57,254,3,0,89,254,3,0,121,254,3,0,143,254,3,0,165,254,3,0,214,254,3,0,7,255,3,0,16,255,3,0,25,255,3,0,32,255,3,0,44,255,3,0,51,255,3,0,63,255,3,0,80,255,3,0,97,255,3,0,109,255,3,0,122,255,3,0,151,255,3,0,163,255,3,0,180,255,3,0,197,255,3,0,206,255,3,0,215,255,3,0,234,255,3,0,253,255,3,0,40,0,4,0,72,0,4,0,88,0,4,0,102,0,4,0,116,0,4,0,144,0,4,0,161,0,4,0,178,0,4,0,195,0,4,0,153,226,86,0,212,0,4,0,235,0,4,0,2,1,4,0,25,1,4,0,48,1,4,0,76,1,4,0,101,1,4,0,126,1,4,0,151,1,4,0,176,1,4,0,249,1,4,0,20,2,4,0,39,2,4,0,91,2,4,0,170,2,4,0,223,2,4,0,18,3,4,0,99,3,4,0,157,3,4,0,223,3,4,0,245,3,4,0,67,4,4,0,122,4,4,0,204,4,4,0,153,226,86,0,226,4,4,0,18,5,4,0,80,5,4,0,124,5,4,0,171,5,4,0,219,5,4,0,10,6,4,0,61,6,4,0,113,6,4,0,163,6,4,0,214,6,4,0,254,6,4,0,42,7,4,0,64,7,4,0,132,7,4,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,200,7,4,0,237,7,4,0,18,8,4,0,58,8,4,0,98,8,4,0,120,8,4,0,142,8,4,0,193,8,4,0,244,8,4,0,36,9,4,0,84,9,4,0,108,9,4,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,172,9,4,0,204,9,4,0,34,10,4,0,98,10,4,0,156,10,4,0,196,10,4,0,232,10,4,0,53,11,4,0,100,11,4,0,122,11,4,0,161,11,4,0,208,11,4,0,234,11,4,0,30,12,4,0,67,12,4,0,154,12,4,0,209,12,4,0,78,13,4,0,163,13,4,0,231,13,4,0,5,14,4,0,49,14,4,0,76,14,4,0,118,14,4,0,155,14,4,0,191,14,4,0,172,9,4,0,204,9,4,0,221,14,4,0,247,14,4,0,156,10,4,0,191,14,4,0,53,11,4,0,18,15,4,0,100,11,4,0,161,11,4,0,125,15,4,0,234,11,4,0,30,12,4,0,152,15,4,0,67,12,4,0,214,15,4,0,154,12,4,0,251,15,4,0,231,13,4,0,32,16,4,0,95,16,4,0,118,14,4,0,186,16,4,0,7,17,4,0,90,17,4,0,122,17,4,0,200,17,4,0,12,18,4,0,70,18,4,0,110,18,4,0,146,18,4,0,228,18,4,0,19,19,4,0,41,19,4,0,82,19,4,0,129,19,4,0,155,19,4,0,207,19,4,0,244,19,4,0,71,20,4,0,122,20,4,0,241,20,4,0,64,21,4,0,134,21,4,0,164,21,4,0,212,21,4,0,239,21,4,0,25,22,4,0,62,22,4,0,98,22,4,0,128,22,4,0,213,22,4,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,16,23,4,0,23,23,4,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,35,23,4,0,111,23,4,0,174,23,4,0,230,23,4,0,42,24,4,0,103,24,4,0,145,24,4,0,5,25,4,0,56,25,4,0,89,25,4,0,137,25,4,0,184,25,4,0,206,25,4,0,30,26,4,0,81,26,4,0,152,26,4,0,220,26,4,0,27,27,4,0,70,27,4,0,134,27,4,0,165,27,4,0,216,27,4,0,243,27,4,0,29,28,4,0,66,28,4,0,107,28,4,0,137,28,4,0,215,28,4,0,69,29,4,0,123,29,4,0,210,29,4,0,16,30,4,0,78,30,4,0,140,30,4,0,227,30,4,0,1,31,4,0,56,31,4,0,100,31,4,0,153,31,4,0,198,31,4,0,29,32,4,0,92,32,4,0,132,32,4,0,193,32,4,0,5,33,4,0,35,33,4,0,96,33,4,0,169,33,4,0,214,33,4,0,24,34,4,0,110,34,4,0,186,34,4,0,255,34,4,0,49,35,4,0,130,35,4,0,182,35,4,0,251,35,4,0,79,36,4,0,138,36,4,0,189,36,4,0,252,36,4,0,60,37,4,0,95,37,4,0,195,37,4,0,29,32,4,0,11,38,4,0,92,38,4,0,155,38,4,0,206,38,4,0,6,39,4,0,41,39,4,0,113,39,4,0,165,39,4,0,245,39,4,0,71,40,4,0,151,40,4,0,210,40,4,0,35,41,4,0,96,41,4,0,160,41,4,0,4,42,4,0,107,42,4,0,153,226,86,0,129,42,4,0,178,42,4,0,6,43,4,0,87,43,4,0,153,226,86,0,153,226,86,0,141,43,4,0,230,43,4,0,109,44,4,0,210,44,4,0,58,45,4,0,225,45,4,0,139,46,4,0,153,226,86,0,20,168,3,0,179,202,3,0,179,46,4,0,2,47,4,0,23,47,4,0,111,47,4,0,203,47,4,0,227,47,4,0,46,48,4,0,141,48,4,0,200,48,4,0,66,49,4,0,4,204,3,0,161,49,4,0,36,204,3,0,178,49,4,0,206,49,4,0,235,49,4,0,42,50,4,0,54,50,4,0,169,204,3,0,76,50,4,0,251,204,3,0,18,8,4,0,58,8,4,0,98,8,4,0,120,8,4,0,142,8,4,0,193,8,4,0,93,50,4,0,102,50,4,0,48,205,3,0,111,50,4,0,55,205,3,0,62,205,3,0,123,50,4,0,140,50,4,0,86,205,3,0,157,50,4,0,180,50,4,0,74,205,3,0,209,50,4,0,226,50,4,0,254,201,3,0,7,202,3,0,243,50,4,0,6,51,4,0,25,51,4,0,68,51,4,0,116,51,4,0,132,51,4,0,146,51,4,0,160,51,4,0,145,205,3,0,128,205,3,0,196,51,4,0,213,51,4,0,230,51,4,0,249,51,4,0,20,52,4,0,47,52,4,0,74,52,4,0,101,52,4,0,133,52,4,0,154,52,4,0,175,52,4,0,196,52,4,0,217,52,4,0,48,53,4,0,75,53,4,0,108,9,4,0,94,53,4,0,193,53,4,0,246,53,4,0,53,54,4,0,150,54,4,0,4,55,4,0,180,205,3,0,86,55,4,0,176,55,4,0,232,55,4,0,79,56,4,0,153,226,86,0,101,56,4,0,176,56,4,0,4,57,4,0,56,57,4,0,111,57,4,0,171,57,4,0,224,57,4,0,25,58,4,0,110,58,4,0,179,58,4,0,238,58,4,0,30,59,4,0,82,59,4,0,104,59,4,0,200,59,4,0,40,60,4,0,65,60,4,0,90,60,4,0,115,60,4,0,153,226,86,0,140,60,4,0,218,60,4,0,61,61,4,0,117,61,4,0,209,61,4,0,48,62,4,0,138,62,4,0,217,62,4,0,17,63,4,0,76,63,4,0,141,63,4,0,207,63,4,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,41,64,4,0,64,64,4,0,99,64,4,0,134,64,4,0,134,64,4,0,201,64,4,0,8,65,4,0,40,65,4,0,72,65,4,0,120,65,4,0,152,65,4,0,184,65,4,0,17,66,4,0,65,66,4,0,235,66,4,0,172,67,4,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,41,64,4,0,64,64,4,0,99,64,4,0,224,67,4,0,134,64,4,0,201,64,4,0,8,65,4,0,40,65,4,0,72,65,4,0,120,65,4,0,152,65,4,0,31,68,4,0,99,68,4,0,65,66,4,0,147,68,4,0,56,69,4,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,217,69,4,0,254,69,4,0,40,70,4,0,96,70,4,0,152,70,4,0,178,70,4,0,204,70,4,0,23,71,4,0,98,71,4,0,162,71,4,0,226,71,4,0,252,71,4,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,107,72,4,0,143,72,4,0,227,72,4,0,47,73,4,0,109,73,4,0,157,73,4,0,195,73,4,0,27,74,4,0,67,74,4,0,83,74,4,0,123,74,4,0,163,74,4,0,189,74,4,0,235,74,4,0,15,75,4,0,95,75,4,0,147,75,4,0,241,75,4,0,49,76,4,0,135,76,4,0,163,76,4,0,211,76,4,0,237,76,4,0,27,77,4,0,57,77,4,0,89,77,4,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,125,77,4,0,199,77,4,0,79,78,4,0,161,78,4,0,247,78,4,0,87,79,4,0,177,79,4,0,25,80,4,0,133,80,4,0,199,80,4,0,11,81,4,0,125,81,4,0,205,81,4,0,43,82,4,0,117,82,4,0,185,82,4,0,33,83,4,0,119,83,4,0,245,83,4,0,61,84,4,0,136,84,4,0,212,84,4,0,28,85,4,0,106,85,4,0,209,85,4,0,35,86,4,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,122,86,4,0,192,86,4,0,6,87,4,0,70,87,4,0,140,87,4,0,212,87,4,0,1,88,4,0,95,88,4,0,143,88,4,0,189,88,4,0,235,88,4,0,67,74,4,0,19,89,4,0,99,89,4,0,147,89,4,0,219,89,4,0,33,90,4,0,103,90,4,0,143,90,4,0,237,90,4,0,11,91,4,0,59,91,4,0,85,91,4,0,131,91,4,0,161,91,4,0,193,91,4,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,229,91,4,0,37,92,4,0,82,92,4,0,126,92,4,0,190,92,4,0,236,92,4,0,34,93,4,0,108,93,4,0,165,93,4,0,202,93,4,0,249,93,4,0,51,94,4,0,84,94,4,0,170,94,4,0,232,94,4,0,34,95,4,0,91,95,4,0,159,95,4,0,205,95,4,0,248,95,4,0,30,96,4,0,82,96,4,0,127,96,4,0,196,96,4,0,20,97,4,0,82,97,4,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,20,168,3,0,179,202,3,0,156,97,4,0,237,97,4,0,5,98,4,0,71,98,4,0,161,98,4,0,194,98,4,0,37,99,4,0,156,99,4,0,179,99,4,0,56,100,4,0,175,100,4,0,207,100,4,0,253,100,4,0,59,101,4,0,135,101,4,0,181,101,4,0,35,102,4,0,81,102,4,0,127,102,4,0,10,103,4,0,109,103,4,0,125,103,4,0,173,103,4,0,221,103,4,0,36,104,4,0,52,104,4,0,82,104,4,0,112,104,4,0,133,104,4,0,173,104,4,0,232,104,4,0,252,104,4,0,16,105,4,0,74,105,4,0,198,105,4,0,105,106,4,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,20,168,3,0,179,202,3,0,207,106,4,0,34,107,4,0,62,107,4,0,144,107,4,0,242,107,4,0,5,108,4,0,80,108,4,0,171,108,4,0,228,108,4,0,94,109,4,0,185,109,4,0,198,109,4,0,215,109,4,0,237,109,4,0,9,110,4,0,41,110,4,0,108,110,4,0,125,110,4,0,142,110,4,0,251,110,4,0,75,111,4,0,82,111,4,0,122,111,4,0,162,111,4,0,55,205,3,0,62,205,3,0,74,205,3,0,179,111,4,0,191,111,4,0,213,111,4,0,254,201,3,0,7,202,3,0,242,111,4,0,8,112,4,0,150,54,4,0,193,53,4,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,172,9,4,0,71,112,4,0,204,9,4,0,221,14,4,0,130,112,4,0,156,10,4,0,185,112,4,0,64,113,4,0,152,113,4,0,199,113,4,0,9,114,4,0,90,114,4,0,234,11,4,0,53,11,4,0,67,12,4,0,214,15,4,0,154,12,4,0,34,10,4,0,231,13,4,0,137,114,4,0,182,114,4,0,118,14,4,0,17,115,4,0,64,115,4,0,115,115,4,0,167,115,4,0,229,115,4,0,32,116,4,0,107,116,4,0,162,116,4,0,239,116,4,0,95,117,4,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,35,23,4,0,180,117,4,0,18,118,4,0,88,118,4,0,114,118,4,0,42,24,4,0,155,118,4,0,10,119,4,0,92,119,4,0,139,119,4,0,205,119,4,0,20,120,4,0,61,120,4,0,113,120,4,0,81,26,4,0,160,120,4,0,152,26,4,0,174,23,4,0,197,120,4,0,227,120,4,0,12,121,4,0,29,28,4,0,110,121,4,0,151,121,4,0,202,121,4,0,254,121,4,0,54,122,4,0,105,122,4,0,172,122,4,0,219,122,4,0,30,123,4,0,126,123,4,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,201,123,4,0,7,124,4,0,148,124,4,0,221,124,4,0,77,125,4,0,219,125,4,0,83,126,4,0,195,126,4,0,76,127,4,0,143,127,4,0,226,127,4,0,87,128,4,0,176,128,4,0,27,129,4,0,94,129,4,0,199,129,4,0,48,130,4,0,196,130,4,0,84,131,4,0,171,131,4,0,12,132,4,0,93,132,4,0,152,132,4,0,247,132,4,0,83,133,4,0,166,133,4,0,201,123,4,0,7,124,4,0,237,133,4,0,70,134,4,0,77,125,4,0,166,133,4,0,195,126,4,0,107,134,4,0,76,127,4,0,226,127,4,0,16,135,4,0,176,128,4,0,27,129,4,0,73,135,4,0,94,129,4,0,245,135,4,0,199,129,4,0,116,136,4,0,171,131,4,0,179,136,4,0,37,137,4,0,247,132,4,0,183,137,4,0,79,138,4,0,188,138,4,0,254,138,4,0,139,139,4,0,220,139,4,0,78,140,4,0,215,140,4,0,79,141,4,0,201,141,4,0,82,142,4,0,149,142,4,0,236,142,4,0,102,143,4,0,186,143,4,0,46,144,4,0,120,144,4,0,229,144,4,0,80,145,4,0,230,145,4,0,114,146,4,0,201,146,4,0,37,147,4,0,124,147,4,0,185,147,4,0,28,148,4,0,120,148,4,0,208,148,4,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,13,149,4,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,47,149,4,0,151,149,4,0,239,149,4,0,50,150,4,0,146,150,4,0,225,150,4,0,42,151,4,0,212,151,4,0,70,152,4,0,145,152,4,0,221,152,4,0,69,153,4,0,123,153,4,0,41,154,4,0,155,154,4,0,244,154,4,0,97,155,4,0,198,155,4,0,19,156,4],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+61444);allocate([102,156,4,0,144,156,4,0,222,156,4,0,20,157,4,0,98,157,4,0,180,157,4,0,252,157,4,0,67,158,4,0,170,158,4,0,44,159,4,0,138,159,4,0,255,159,4,0,95,160,4,0,196,160,4,0,20,161,4,0,143,161,4,0,194,161,4,0,43,162,4,0,97,162,4,0,177,162,4,0,250,162,4,0,155,154,4,0,125,163,4,0,195,163,4,0,28,164,4,0,131,164,4,0,181,164,4,0,3,165,4,0,118,165,4,0,188,165,4,0,35,166,4,0,141,166,4,0,237,166,4,0,80,167,4,0,147,167,4,0,1,168,4,0,66,168,4,0,154,168,4,0,8,169,4,0,84,169,4,0,150,169,4,0,236,169,4,0,71,170,4,0,120,170,4,0,235,170,4,0,59,171,4,0,148,171,4,0,15,172,4,0,120,172,4,0,178,172,4,0,13,173,4,0,57,173,4,0,137,173,4,0,194,173,4,0,30,174,4,0,129,174,4,0,223,174,4,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,40,175,4,0,155,175,4,0,240,175,4,0,91,176,4,0,204,176,4,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,20,168,3,0,179,202,3,0,28,177,4,0,125,177,4,0,174,177,4,0,37,178,4,0,183,178,4,0,232,178,4,0,81,179,4,0,215,179,4,0,40,180,4,0,190,180,4,0,175,100,4,0,207,100,4,0,253,100,4,0,59,101,4,0,68,181,4,0,132,181,4,0,35,102,4,0,81,102,4,0,232,181,4,0,118,182,4,0,109,103,4,0,227,182,4,0,24,183,4,0,221,103,4,0,36,104,4,0,52,104,4,0,82,104,4,0,112,104,4,0,133,104,4,0,173,104,4,0,232,104,4,0,252,104,4,0,16,105,4,0,77,183,4,0,213,183,4,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,20,168,3,0,179,202,3,0,89,184,4,0,202,184,4,0,239,184,4,0,83,185,4,0,207,185,4,0,235,185,4,0,72,186,4,0,191,186,4,0,8,187,4,0,201,187,4,0,64,188,4,0,96,188,4,0,139,188,4,0,201,188,4,0,18,189,4,0,82,189,4,0,196,189,4,0,239,189,4,0,26,190,4,0,166,190,4,0,11,191,4,0,27,191,4,0,89,191,4,0,151,191,4,0,36,104,4,0,52,104,4,0,82,104,4,0,222,191,4,0,243,191,4,0,27,192,4,0,232,104,4,0,252,104,4,0,86,192,4,0,144,192,4,0,24,193,4,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,153,226,86,0,0,0,0,0,48,219,24,0,115,197,4,0,226,193,4,0,165,5,0,0,1,0,0,0,52,219,24,0,83,198,4,0,226,193,4,0,233,6,0,0,1,0,0,0,56,219,24,0,32,199,4,0,226,193,4,0,54,8,0,0,1,0,0,0,60,219,24,0,39,200,4,0,226,193,4,0,147,9,0,0,1,0,0,0,64,219,24,0,28,201,4,0,226,193,4,0,201,9,0,0,1,0,0,0,68,219,24,0,207,201,4,0,226,193,4,0,71,15,0,0,1,0,0,0,0,0,0,0,216,61,0,0,17,0,0,0,127,1,0,0,111,0,0,0,0,0,0,0,200,61,0,0,17,0,0,0,128,1,0,0,112,0,0,0,72,219,24,0,192,202,4,0,69,202,4,0,85,3,0,0,1,0,0,0,76,219,24,0,116,203,4,0,69,202,4,0,106,3,0,0,1,0,0,0,0,0,0,0,232,61,0,0,8,0,0,0,129,1,0,0,130,1,0,0,80,219,24,0,122,205,4,0,69,202,4,0,46,5,0,0,1,0,0,0,84,27,30,0,82,208,4,0,14,206,4,0,157,6,0,0,1,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,22,0,0,0,23,0,0,0,0,0,0,0,24,0,0,0,25,0,0,0,0,0,0,0,26,0,0,0,0,0,0,0,27,0,0,0,28,0,0,0,0,0,0,0,29,0,0,0,30,0,0,0,0,0,0,0,31,0,0,0,0,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,34,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,248,61,0,0,17,0,0,0,131,1,0,0,113,0,0,0,0,0,0,0,8,62,0,0,132,1,0,0,133,1,0,0,114,0,0,0,88,27,30,0,138,209,4,0,14,206,4,0,113,10,0,0,1,0,0,0,0,0,0,0,24,62,0,0,134,1,0,0,135,1,0,0,115,0,0,0,92,27,30,0,101,210,4,0,14,206,4,0,160,11,0,0,1,0,0,0,96,27,30,0,195,210,4,0,14,206,4,0,2,12,0,0,1,0,0,0,100,27,30,0,252,210,4,0,14,206,4,0,47,12,0,0,1,0,0,0,104,27,30,0,117,212,4,0,6,212,4,0,85,2,0,0,1,0,0,0,108,27,30,0,28,213,4,0,226,212,4,0,46,0,0,0,1,0,0,0,112,27,30,0,252,213,4,0,148,213,4,0,144,2,0,0,1,0,0,0,116,27,30,0,38,214,4,0,148,213,4,0,254,2,0,0,1,0,0,0,0,0,0,0,88,63,0,0,186,0,0,0,136,1,0,0,48,0,0,0,0,0,0,0,72,63,0,0,8,0,0,0,137,1,0,0,138,1,0,0,0,0,0,0,56,63,0,0,186,0,0,0,139,1,0,0,49,0,0,0,0,0,0,0,40,63,0,0,8,0,0,0,140,1,0,0,141,1,0,0,0,0,0,0,24,63,0,0,186,0,0,0,142,1,0,0,50,0,0,0,0,0,0,0,8,63,0,0,8,0,0,0,143,1,0,0,144,1,0,0,0,0,0,0,248,62,0,0,186,0,0,0,145,1,0,0,51,0,0,0,0,0,0,0,232,62,0,0,8,0,0,0,146,1,0,0,147,1,0,0,0,0,0,0,216,62,0,0,186,0,0,0,148,1,0,0,52,0,0,0,0,0,0,0,200,62,0,0,8,0,0,0,149,1,0,0,150,1,0,0,0,0,0,0,184,62,0,0,186,0,0,0,151,1,0,0,53,0,0,0,0,0,0,0,168,62,0,0,8,0,0,0,152,1,0,0,153,1,0,0,0,0,0,0,152,62,0,0,186,0,0,0,154,1,0,0,54,0,0,0,0,0,0,0,136,62,0,0,8,0,0,0,155,1,0,0,156,1,0,0,0,0,0,0,120,62,0,0,186,0,0,0,157,1,0,0,55,0,0,0,0,0,0,0,104,62,0,0,8,0,0,0,158,1,0,0,159,1,0,0,0,0,0,0,88,62,0,0,186,0,0,0,160,1,0,0,56,0,0,0,0,0,0,0,72,62,0,0,8,0,0,0,161,1,0,0,162,1,0,0,0,0,0,0,56,62,0,0,186,0,0,0,163,1,0,0,57,0,0,0,0,0,0,0,40,62,0,0,8,0,0,0,164,1,0,0,165,1,0,0,0,0,0,0,152,64,0,0,188,0,0,0,166,1,0,0,47,0,0,0,190,0,0,0,0,0,0,0,136,64,0,0,8,0,0,0,167,1,0,0,168,1,0,0,0,0,0,0,120,64,0,0,188,0,0,0,169,1,0,0,48,0,0,0,190,0,0,0,0,0,0,0,104,64,0,0,8,0,0,0,170,1,0,0,171,1,0,0,0,0,0,0,88,64,0,0,188,0,0,0,172,1,0,0,49,0,0,0,190,0,0,0,0,0,0,0,72,64,0,0,8,0,0,0,173,1,0,0,174,1,0,0,0,0,0,0,56,64,0,0,188,0,0,0,175,1,0,0,50,0,0,0,190,0,0,0,0,0,0,0,40,64,0,0,8,0,0,0,176,1,0,0,177,1,0,0,0,0,0,0,24,64,0,0,188,0,0,0,178,1,0,0,51,0,0,0,190,0,0,0,0,0,0,0,8,64,0,0,8,0,0,0,179,1,0,0,180,1,0,0,0,0,0,0,248,63,0,0,188,0,0,0,181,1,0,0,52,0,0,0,190,0,0,0,0,0,0,0,232,63,0,0,8,0,0,0,182,1,0,0,183,1,0,0,0,0,0,0,216,63,0,0,188,0,0,0,184,1,0,0,53,0,0,0,190,0,0,0,0,0,0,0,200,63,0,0,8,0,0,0,185,1,0,0,186,1,0,0,0,0,0,0,184,63,0,0,188,0,0,0,187,1,0,0,54,0,0,0,190,0,0,0,0,0,0,0,168,63,0,0,8,0,0,0,188,1,0,0,189,1,0,0,0,0,0,0,152,63,0,0,188,0,0,0,190,1,0,0,55,0,0,0,190,0,0,0,0,0,0,0,136,63,0,0,8,0,0,0,191,1,0,0,192,1,0,0,0,0,0,0,120,63,0,0,188,0,0,0,193,1,0,0,56,0,0,0,190,0,0,0,0,0,0,0,104,63,0,0,8,0,0,0,194,1,0,0,195,1,0,0,0,0,0,0,200,65,0,0,8,0,0,0,196,1,0,0,197,1,0,0,0,0,0,0,168,65,0,0,8,0,0,0,198,1,0,0,199,1,0,0,0,0,0,0,136,65,0,0,8,0,0,0,200,1,0,0,201,1,0,0,0,0,0,0,104,65,0,0,8,0,0,0,202,1,0,0,203,1,0,0,0,0,0,0,72,65,0,0,8,0,0,0,204,1,0,0,205,1,0,0,0,0,0,0,40,65,0,0,8,0,0,0,206,1,0,0,207,1,0,0,0,0,0,0,8,65,0,0,8,0,0,0,208,1,0,0,209,1,0,0,0,0,0,0,232,64,0,0,8,0,0,0,210,1,0,0,211,1,0,0,0,0,0,0,200,64,0,0,8,0,0,0,212,1,0,0,213,1,0,0,0,0,0,0,168,64,0,0,8,0,0,0,214,1,0,0,215,1,0,0,0,0,0,0,184,64,0,0,216,1,0,0,217,1,0,0,36,0,0,0,193,0,0,0,0,0,0,0,216,64,0,0,218,1,0,0,219,1,0,0,37,0,0,0,193,0,0,0,0,0,0,0,248,64,0,0,220,1,0,0,221,1,0,0,38,0,0,0,193,0,0,0,0,0,0,0,24,65,0,0,222,1,0,0,223,1,0,0,39,0,0,0,193,0,0,0,0,0,0,0,56,65,0,0,224,1,0,0,225,1,0,0,40,0,0,0,193,0,0,0,0,0,0,0,88,65,0,0,226,1,0,0,227,1,0,0,41,0,0,0,193,0,0,0,0,0,0,0,120,65,0,0,228,1,0,0,229,1,0,0,42,0,0,0,193,0,0,0,0,0,0,0,152,65,0,0,230,1,0,0,231,1,0,0,43,0,0,0,193,0,0,0,0,0,0,0,184,65,0,0,232,1,0,0,233,1,0,0,44,0,0,0,193,0,0,0,0,0,0,0,216,65,0,0,234,1,0,0,235,1,0,0,45,0,0,0,193,0,0,0,124,27,30,0,251,235,4,0,151,214,4,0,97,7,0,0,1,0,0,0,120,27,30,0,159,235,4,0,151,214,4,0,29,7,0,0,1,0,0,0,128,27,30,0,80,236,4,0,151,214,4,0,107,7,0,0,1,0,0,0,132,27,30,0,211,236,4,0,151,214,4,0,251,7,0,0,1,0,0,0,136,27,30,0,40,238,4,0,90,237,4,0,60,5,0,0,1,0,0,0,140,27,30,0,7,239,4,0,90,237,4,0,170,5,0,0,1,0,0,0,144,27,30,0,137,249,4,0,142,239,4,0,131,11,0,0,1,0,0,0,57,0,0,0,0,0,0,0,58,0,0,0,59,0,0,0,0,0,0,0,60,0,0,0,61,0,0,0,0,0,0,0,46,0,0,0,0,0,0,0,47,0,0,0,48,0,0,0,0,0,0,0,49,0,0,0,50,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,79,0,0,0,80,0,0,0,0,0,0,0,81,0,0,0,82,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,84,0,0,0,85,0,0,0,0,0,0,0,86,0,0,0,87,0,0,0,0,0,0,0,88,0,0,0,0,0,0,0,89,0,0,0,90,0,0,0,0,0,0,0,91,0,0,0,92,0,0,0,0,0,0,0,0,0,0,0,232,65,0,0,236,1,0,0,237,1,0,0,116,0,0,0,0,0,0,0,248,65,0,0,238,1,0,0,239,1,0,0,117,0,0,0,0,0,0,0,8,66,0,0,240,1,0,0,241,1,0,0,118,0,0,0,0,0,0,0,24,66,0,0,242,1,0,0,243,1,0,0,119,0,0,0,0,0,0,0,40,66,0,0,244,1,0,0,245,1,0,0,120,0,0,0,0,0,0,0,56,66,0,0,246,1,0,0,247,1,0,0,121,0,0,0,0,0,0,0,72,66,0,0,248,1,0,0,249,1,0,0,122,0,0,0,0,0,0,0,88,66,0,0,250,1,0,0,251,1,0,0,123,0,0,0,0,0,0,0,104,66,0,0,252,1,0,0,253,1,0,0,124,0,0,0,0,0,0,0,120,66,0,0,254,1,0,0,255,1,0,0,125,0,0,0,0,0,0,0,136,66,0,0,0,2,0,0,1,2,0,0,126,0,0,0,0,0,0,0,152,66,0,0,2,2,0,0,3,2,0,0,127,0,0,0,0,0,0,0,168,66,0,0,4,2,0,0,5,2,0,0,128,0,0,0,0,0,0,0,184,66,0,0,6,2,0,0,7,2,0,0,129,0,0,0,0,0,0,0,200,66,0,0,8,2,0,0,9,2,0,0,130,0,0,0,0,0,0,0,216,66,0,0,17,0,0,0,10,2,0,0,131,0,0,0,0,0,0,0,232,66,0,0,17,0,0,0,11,2,0,0,132,0,0,0,0,0,0,0,248,66,0,0,17,0,0,0,12,2,0,0,133,0,0,0,0,0,0,0,8,67,0,0,17,0,0,0,13,2,0,0,134,0,0,0,0,0,0,0,24,67,0,0,17,0,0,0,14,2,0,0,135,0,0,0,0,0,0,0,40,67,0,0,15,2,0,0,16,2,0,0,136,0,0,0,0,0,0,0,56,67,0,0,17,2,0,0,18,2,0,0,137,0,0,0,0,0,0,0,72,67,0,0,19,2,0,0,20,2,0,0,138,0,0,0,0,0,0,0,88,67,0,0,21,2,0,0,22,2,0,0,139,0,0,0,0,0,0,0,104,67,0,0,23,2,0,0,24,2,0,0,140,0,0,0,0,0,0,0,120,67,0,0,25,2,0,0,26,2,0,0,141,0,0,0,148,27,30,0,81,250,4,0,142,239,4,0,213,12,0,0,1,0,0,0,152,27,30,0,17,251,4,0,217,250,4,0,93,1,0,0,1,0,0,0,156,27,30,0,12,252,4,0,186,251,4,0,90,0,0,0,1,0,0,0,160,27,30,0,176,252,4,0,121,252,4,0,208,0,0,0,1,0,0,0,164,27,30,0,246,252,4,0,121,252,4,0,23,1,0,0,1,0,0,0,168,27,30,0,84,253,4,0,121,252,4,0,58,1,0,0,1,0,0,0,172,27,30,0,226,253,4,0,121,252,4,0,91,1,0,0,1,0,0,0,176,27,30,0,91,254,4,0,121,252,4,0,233,3,0,0,1,0,0,0,0,0,0,0,184,68,0,0,186,0,0,0,27,2,0,0,58,0,0,0,0,0,0,0,168,68,0,0,8,0,0,0,28,2,0,0,29,2,0,0,0,0,0,0,152,68,0,0,186,0,0,0,30,2,0,0,59,0,0,0,0,0,0,0,136,68,0,0,8,0,0,0,31,2,0,0,32,2,0,0,0,0,0,0,120,68,0,0,186,0,0,0,33,2,0,0,60,0,0,0,0,0,0,0,104,68,0,0,8,0,0,0,34,2,0,0,35,2,0,0,0,0,0,0,88,68,0,0,186,0,0,0,36,2,0,0,61,0,0,0,0,0,0,0,72,68,0,0,8,0,0,0,37,2,0,0,38,2,0,0,0,0,0,0,56,68,0,0,186,0,0,0,39,2,0,0,62,0,0,0,0,0,0,0,40,68,0,0,8,0,0,0,40,2,0,0,41,2,0,0,0,0,0,0,24,68,0,0,186,0,0,0,42,2,0,0,63,0,0,0,0,0,0,0,8,68,0,0,8,0,0,0,43,2,0,0,44,2,0,0,0,0,0,0,248,67,0,0,186,0,0,0,45,2,0,0,64,0,0,0,0,0,0,0,232,67,0,0,8,0,0,0,46,2,0,0,47,2,0,0,0,0,0,0,216,67,0,0,186,0,0,0,48,2,0,0,65,0,0,0,0,0,0,0,200,67,0,0,8,0,0,0,49,2,0,0,50,2,0,0,0,0,0,0,184,67,0,0,186,0,0,0,51,2,0,0,66,0,0,0,0,0,0,0,168,67,0,0,8,0,0,0,52,2,0,0,53,2,0,0,0,0,0,0,152,67,0,0,186,0,0,0,54,2,0,0,67,0,0,0,0,0,0,0,136,67,0,0,8,0,0,0,55,2,0,0,56,2,0,0,0,0,0,0,56,70,0,0,57,2,0,0,58,2,0,0,62,0,0,0,59,2,0,0,0,0,0,0,40,70,0,0,8,0,0,0,60,2,0,0,61,2,0,0,0,0,0,0,24,70,0,0,62,2,0,0,63,2,0,0,63,0,0,0,64,2,0,0,0,0,0,0,8,70,0,0,8,0,0,0,65,2,0,0,66,2,0,0,0,0,0,0,248,69,0,0,67,2,0,0,68,2,0,0,64,0,0,0,69,2,0,0,0,0,0,0,232,69,0,0,8,0,0,0,70,2,0,0,71,2,0,0,0,0,0,0,216,69,0,0,72,2,0,0,73,2,0,0,65,0,0,0,74,2,0,0,0,0,0,0,200,69,0,0,8,0,0,0,75,2,0,0,76,2,0,0,0,0,0,0,184,69,0,0,77,2,0,0,78,2,0,0,66,0,0,0,79,2,0,0,0,0,0,0,168,69,0,0,8,0,0,0,80,2,0,0,81,2,0,0,0,0,0,0,152,69,0,0,82,2,0,0,83,2,0,0,67,0,0,0,84,2,0,0,0,0,0,0,136,69,0,0,8,0,0,0,85,2,0,0,86,2,0,0,0,0,0,0,120,69,0,0,87,2,0,0,88,2,0,0,68,0,0,0,89,2,0,0,0,0,0,0,104,69,0,0,8,0,0,0,90,2,0,0,91,2,0,0,0,0,0,0,88,69,0,0,92,2,0,0,93,2,0,0,69,0,0,0,94,2,0,0,0,0,0,0,72,69,0,0,8,0,0,0,95,2,0,0,96,2,0,0,0,0,0,0,56,69,0,0,97,2,0,0,98,2,0,0,70,0,0,0,99,2,0,0,0,0,0,0,40,69,0,0,8,0,0,0,100,2,0,0,101,2,0,0,0,0,0,0,24,69,0,0,102,2,0,0,103,2,0,0,71,0,0,0,104,2,0,0,0,0,0,0,8,69,0,0,8,0,0,0,105,2,0,0,106,2,0,0,0,0,0,0,248,68,0,0,107,2,0,0,108,2,0,0,72,0,0,0,109,2,0,0,0,0,0,0,232,68,0,0,8,0,0,0,110,2,0,0,111,2,0,0,0,0,0,0,216,68,0,0,112,2,0,0,113,2,0,0,73,0,0,0,114,2,0,0,0,0,0,0,200,68,0,0,8,0,0,0,115,2,0,0,116,2,0,0,180,27,30,0,65,8,5,0,78,255,4,0,250,5,0,0,1,0,0,0,184,27,30,0,138,8,5,0,78,255,4,0,42,6,0,0,1,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,62,0,0,0,63,0,0,128,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,61,0,0,128,62,0,0,192,62,0,0,128,62,0,0,128,61,0,0,0,0,0,0,0,0,0,0,0,61,0,0,224,61,0,0,96,62,0,0,144,62,0,0,96,62,0,0,224,61,0,0,0,61,188,27,30,0,89,9,5,0,78,255,4,0,28,8,0,0,1,0,0,0,192,27,30,0,77,10,5,0,78,255,4,0,37,12,0,0,1,0,0,0,196,27,30,0,91,12,5,0,78,255,4,0,55,15,0,0,1,0,0,0,0,0,0,0,88,70,0,0,17,0,0,0,117,2,0,0,142,0,0,0,0,0,0,0,72,70,0,0,17,0,0,0,118,2,0,0,143,0,0,0,200,27,30,0,230,12,5,0,176,12,5,0,241,1,0,0,1,0,0,0,204,27,30,0,53,13,5,0,176,12,5,0,32,2,0,0,1,0,0,0,208,27,30,0,101,13,5,0,176,12,5,0,39,2,0,0,1,0,0,0,212,27,30,0,84,19,5,0,66,17,5,0,68,4,0,0,1,0,0,0,216,27,30,0,107,20,5,0,219,19,5,0,110,5,0,0,1,0,0,0,0,0,0,0,104,70,0,0,119,2,0,0,120,2,0,0,144,0,0,0,220,27,30,0,53,21,5,0,219,19,5,0,237,5,0,0,1,0,0,0,224,27,30,0,251,24,5,0,187,22,5,0,204,0,0,0,1,0,0,0,0,0,0,0,120,70,0,0,121,2,0,0,122,2,0,0,4,0,0,0,145,0,0,0,11,0,0,0,5,0,0,0,6,0,0,0,146,0,0,0,123,2,0,0,1,0,0,0,19,0,0,0,35,0,0,0,124,2,0,0,228,27,30,0,254,26,5,0,82,27,5,0,230,1,0,0,1,0,0,0,0,0,0,0,128,70,0,0,8,0,0,0,125,2,0,0,126,2,0,0,0,0,0,0,144,70,0,0,127,2,0,0,128,2,0,0,7,0,0,0,147,0,0,0,12,0,0,0,5,0,0,0,8,0,0,0,146,0,0,0,123,2,0,0,2,0,0,0,19,0,0,0,36,0,0,0,129,2,0,0,232,27,30,0,166,27,5,0,82,27,5,0,167,2,0,0,1,0,0,0,236,27,30,0,36,28,5,0,82,27,5,0,123,2,0,0,1,0,0,0,0,0,0,0,160,70,0,0,8,0,0,0,130,2,0,0,131,2,0,0,0,0,0,0,192,70,0,0,8,0,0,0,132,2,0,0,133,2,0,0,0,0,0,0,176,70,0,0,8,0,0,0,134,2,0,0,135,2,0,0,0,0,0,0,208,70,0,0,136,2,0,0,137,2,0,0,9,0,0,0,148,0,0,0,13,0,0,0,5,0,0,0,10,0,0,0,146,0,0,0,123,2,0,0,1,0,0,0,20,0,0,0,37,0,0,0,138,2,0,0,0,0,0,0,224,70,0,0,8,0,0,0,139,2,0,0,140,2,0,0,0,0,0,0,0,71,0,0,8,0,0,0,141,2,0,0,142,2,0,0,0,0,0,0,240,70,0,0,8,0,0,0,143,2,0,0,144,2,0,0,0,0,0,0,16,71,0,0,145,2,0,0,146,2,0,0,3,0,0,0,1,0,0,0,149,0,0,0,14,0,0,0,3,0,0,0,4,0,0,0,21,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,15,0,0,0,150,0,0,0,16,0,0,0,17,0,0,0,151,0,0,0,152,0,0,0,24,28,30,0,60,37,5,0,82,27,5,0,94,5,0,0,1,0,0,0,248,27,30,0,206,32,5,0,82,27,5,0,123,1,0,0,1,0,0,0,240,27,30,0,198,31,5,0,82,27,5,0,108,1,0,0,1,0,0,0,244,27,30,0,104,32,5,0,82,27,5,0,63,0,0,0,1,0,0,0,20,28,30,0,48,36,5,0,82,27,5,0,223,4,0,0,1,0,0,0,0,0,0,0,32,71,0,0,147,2,0,0,148,2,0,0,153,0,0,0,16,28,30,0,193,35,5,0,82,27,5,0,234,3,0,0,1,0,0,0,12,28,30,0,105,35,5,0,82,27,5,0,164,3,0,0,1,0,0,0,252,27,30,0,52,33,5,0,165,28,5,0,22,2,0,0,1,0,0,0,0,28,30,0,174,33,5,0,165,28,5,0,236,1,0,0,1,0,0,0,4,28,30,0,90,34,5,0,165,28,5,0,105,2,0,0,1,0,0,0,8,28,30,0,237,34,5,0,165,28,5,0,66,2,0,0,1,0,0,0,32,28,30,0,90,38,5,0,82,27,5,0,141,5,0,0,1,0,0,0,28,28,30,0,11,38,5,0,82,27,5,0,115,1,0,0,1,0,0,0,36,28,30,0,230,38,5,0,82,27,5,0,128,5,0,0,1,0,0,0,0,0,0,0,48,71,0,0,8,0,0,0,149,2,0,0,150,2,0,0,40,28,30,0,204,40,5,0,82,27,5,0,131,1,0,0,1,0,0,0,0,0,0,0,80,71,0,0,8,0,0,0,151,2,0,0,152,2,0,0,44,28,30,0,187,41,5,0,82,27,5,0,160,6,0,0,1,0,0,0,48,28,30,0,39,42,5,0,82,27,5,0,174,6,0,0,1,0,0,0,52,28,30,0,167,42,5,0,82,27,5,0,191,6,0,0,1,0,0,0,60,28,30,0,67,54,5,0,158,43,5,0,157,3,0,0,1,0,0,0,72,28,30,0,38,56,5,0,158,43,5,0,195,4,0,0,1,0,0,0,0,0,0,0,96,71,0,0,17,0,0,0,153,2,0,0,154,0,0,0,64,28,30,0,20,55,5,0,158,43,5,0,118,4,0,0,1,0,0,0,0,0,0,0,112,71,0,0,154,2,0,0,155,2,0,0,155,0,0,0,68,28,30,0,159,55,5,0,158,43,5,0,194,3,0,0,1,0,0,0,0,0,0,0,128,71,0,0,156,2,0,0,157,2,0,0,51,0,0,0,156,0,0,0,0,0,0,0,136,71,0,0,158,2,0,0,159,2,0,0,157,0,0,0,22,0,0,0,38,0,0,0,11,0,0,0,39,0,0,0,158,0,0,0,74,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,75,0,0,0,1,0,0,0,1,0,0,0,84,28,30,0,112,57,5,0,40,57,5,0,82,14,0,0,1,0,0,0,0,0,0,0,144,71,0,0,160,2,0,0,161,2,0,0,159,0,0,0,80,28,30,0,227,56,5,0,40,57,5,0,182,13,0,0,1,0,0,0,88,28,30,0,38,59,5,0,40,57,5,0,226,13,0,0,1,0,0,0,92,28,30,0,80,60,5,0,40,57,5,0,239,0,0,0,1,0,0,0,96,28,30,0,185,60,5,0,40,57,5,0,64,8,0,0,1,0,0,0,104,28,30,0,234,61,5,0,40,57,5,0,9,8,0,0,1,0,0,0,0,0,0,0,160,71,0,0,162,2,0,0,163,2,0,0,160,0,0,0,100,28,30,0,109,61,5,0,40,57,5,0,202,14,0,0,1,0,0,0,108,28,30,0,131,62,5,0,40,57,5,0,237,6,0,0,1,0,0,0,112,28,30,0,73,63,5,0,40,57,5,0,124,6,0,0,1,0,0,0,116,28,30,0,228,63,5,0,40,57,5,0,57,6,0,0,1,0,0,0,0,187,13,0,60,133,91,61,105,191,22,190,2,153,98,189,108,247,79,61,246,123,236,61,167,217,46,189,62,226,61,61,57,250,95,189,212,151,168,61,35,124,213,61,136,247,187,188,168,158,53,60,147,226,97,60,59,62,229,61,79,209,79,60,24,169,174,61,149,54,129,189,240,173,5,62,38,231,165,61,19,100,85,189,154,195,48,189,193,79,191,61,81,255,225,61,15,146,155,189,76,255,97,189,6,230,54,189,19,114,241,60,66,152,58,61,65,71,105,187,217,33,160,61,168,84,158,61,18,154,161,61,195,227,126,61,40,89,184,61,26,104,18,189,208,217,11,61,93,138,104,61,160,134,67,189,86,118,25,61,50,58,16,189,138,114,142,61,23,168,29,189,94,104,44,60,232,56,142,60,25,146,222,61,48,45,179,61,33,25,88,59,61,96,223,61,226,18,162,61,158,217,212,61,161,93,171,60,17,114,237,61,236,252,6,62,68,84,202,61,23,168,91,61,71,37,138,189,4,202,229,187,53,239,171,59,152,142,4,61,71,172,102,60,194,224,180,60,128,219,207,60,177,72,58,61,179,120,147,61,81,51,0,61,72,128,128,189,73,155,172,60,190,51,119,61,192,222,176,61,41,126,148,59,40,174,179,60,10,56,189,60,116,18,100,61,159,175,216,188,243,55,54,61,22,115,232,60,125,210,183,61,99,190,54,61,182,208,183,61,13,229,153,61,235,252,188,60,210,50,213,61,174,108,130,61,189,113,115,61,27,55,150,59,51,211,85,61,176,184,136,61,249,46,171,61,189,118,137,61,18,84,134,61,23,254,32,189,43,17,22,188,31,148,113,189,77,185,230,60,254,31,78,61,63,222,138,61,58,89,10,61,73,193,31,186,241,14,147,188,138,157,252,188,195,101,85,188,236,125,243,188,194,56,1,60,97,108,16,189,197,25,36,187,177,214,86,61,86,124,241,61,186,143,177,188,134,15,89,61,120,255,135,61,224,151,84,61,44,140,7,188,73,121,248,60,160,75,111,61,138,106,131,187,176,213,204,187,146,37,112,61,119,248,201,188,55,50,99,61,112,131,168,189,36,39,148,189,151,19,62,61,38,88,86,188,162,78,205,188,91,3,254,60,230,26,63,189,56,17,60,189,116,168,241,60,104,54,119,61,163,225,183,60,11,39,139,188,123,102,42,60,181,84,57,60,104,252,93,61,38,131,174,188,138,4,49,189,99,32,22,189,106,144,56,60,4,134,213,188,109,139,182,188,10,201,184,188,45,97,12,189,146,1,254,187,175,193,125,189,2,158,6,60,249,75,195,61,243,245,23,189,179,46,142,189,24,75,21,62,111,40,95,189,111,107,168,188,104,105,107,61,83,226,227,60,227,242,144,189,143,26,84,189,14,150,213,189,104,26,230,189,217,49,154,61,131,208,154,189,209,243,179,189,185,111,244,60,80,135,218,60,161,117,98,60,57,64,147,188,220,169,0,189,94,224,171,188,8,235,184,61,33,245,74,61,218,122,12,62,186,15,233,61,101,244,235,58,184,127,59,189,210,161,145,186,226,244,193,189,219,124,237,189,42,226,55,61,158,41,146,60,0,25,73,59,8,208,220,61,17,135,92,59,89,14,222,189,116,78,152,189,28,194,215,189,189,237,152,188,204,110,36,62,200,60,166,187,61,243,47,189,202,125,193,187,233,129,16,60,28,142,116,188,208,255,77,189,89,217,3,190,106,97,102,58,215,135,84,188,1,128,155,189,113,161,218,188,73,223,53,186,30,40,197,60,193,68,145,188,107,238,29,189,202,193,112,189,97,132,5,61,31,88,3,62,75,223,128,61,220,150,134,187,126,53,225,61,178,101,90,60,243,27,171,60,76,96,37,61,199,110,85,189,253,236,158,61,2,15,131,61,92,153,107,189,249,226,205,189,239,179,153,61,123,74,175,188,138,36,147,60,241,157,25,59,108,95,44,189,172,161,150,61,165,159,80,61,8,127,245,188,80,201,181,188,47,111,9,61,222,253,52,61,239,149,100,189,200,86,78,189,29,75,58,189,3,5,98,60,215,46,176,60,241,191,179,188,98,28,12,190,99,216,95,61,236,187,131,60,30,118,89,61,202,141,64,61,14,59,175,58,76,38,155,61,83,32,197,61,91,64,18,60,75,241,230,188,124,141,222,61,240,223,12,189,115,64,145,189,175,244,117,189,3,49,222,188,170,210,231,187,204,26,134,188,9,5,91,60,0,57,211,189,62,249,72,61,11,205,106,189,225,186,223,188,129,194,42,60,31,209,170,189,196,255,22,61,150,50,122,61,19,184,88,60,108,240,159,189,218,156,26,61,128,206,11,189,179,182,121,189,82,135,44,189,151,121,163,189,154,29,165,186,201,124,249,188,70,150,74,188,33,71,129,189,72,46,68,61,41,128,60,189,237,165,175,61,225,134,206,60,245,200,244,60,31,62,211,61,235,150,144,61,87,41,57,61,213,80,53,189,215,158,6,62,92,193,171,61,190,82,177,60,183,30,11,187,54,254,22,189,187,250,169,188,8,224,28,189,217,197,122,188,68,87,220,60,92,11,243,61,96,138,119,189,42,38,228,188,72,150,67,189,89,213,71,61,77,17,130,61,130,37,15,61,56,107,112,60,98,133,154,58,149,99,51,61,37,124,5,59,6,37,34,189,204,191,47,188,243,237,210,59,41,121,245,60,165,5,12,189,158,150,160,188,6,191,71,188,65,50,143,187,232,217,208,188,80,201,216,60,71,188,133,188,198,217,211,59,117,21,158,188,68,221,156,59,59,66,75,61,108,5,28,61,82,205,148,61,81,218,107,61,10,65,25,189,209,13,135,60,217,125,10,188,194,181,35,61,121,163,167,189,56,45,216,60,30,238,36,189,252,215,224,188,243,196,38,189,122,192,137,58,108,51,66,189,54,229,137,189,176,156,14,60,246,156,179,188,44,104,177,58,100,109,250,188,51,193,243,188,35,145,236,188,252,92,70,188,196,198,69,189,68,173,185,189,146,45,204,189,8,32,22,189,47,208,104,186,104,207,139,189,1,224,152,188,144,150,20,189,225,187,102,188,164,137,153,60,106,13,170,188,14,75,187,61,11,76,17,189,87,13,93,61,130,253,43,61,177,78,85,60,134,159,10,189,127,229,249,189,178,229,139,61,117,49,24,189,46,155,28,60,251,179,165,59,0,206,103,61,179,11,128,59,78,18,230,60,113,5,98,189,43,7,24,189,28,74,232,188,237,15,53,189,255,18,41,188,37,75,154,60,174,47,11,188,255,231,192,189,243,249,79,188,8,196,174,188,56,181,208,189,104,167,160,189,188,172,31,59,151,56,134,187,165,6,69,60,150,36,132,189,30,246,216,189,120,233,201,188,8,51,180,188,110,151,151,189,7,55,149,61,11,168,104,58,251,116,35,60,132,188,10,60,96,203,24,61,232,252,237,188,39,93,18,61,43,247,51,189,111,14,246,189,149,28,2,61,197,227,52,187,231,175,221,61,50,132,80,61,228,98,88,187,43,223,81,189,107,104,165,59,165,0,104,189,167,106,196,187,228,205,90,189,239,28,72,188,205,145,83,60,117,125,34,60,184,12,248,187,157,171,125,189,24,41,19,187,50,210,162,60,37,98,165,188,235,219,142,189,254,50,135,189,252,45,9,189,174,122,182,189,15,24,10,189,115,177,151,189,246,40,184,188,197,79,124,189,250,6,54,59,138,109,106,189,171,76,68,189,216,250,153,61,188,183,53,59,95,133,44,61,61,254,253,60,138,52,88,61,209,251,33,61,34,82,246,188,111,196,29,189,239,192,228,188,27,140,235,188,138,226,122,60,187,39,179,60,189,1,163,188,9,73,36,59,72,25,210,189,39,6,68,189,79,133,236,188,238,90,124,59,143,58,54,60,246,219,7,60,159,140,69,189,163,119,56,189,173,22,24,189,74,29,143,189,182,83,225,189,208,109,48,187,112,252,242,58,179,134,114,189,31,16,122,189,139,56,173,189,89,115,57,189,253,100,105,58,21,164,112,189,22,8,48,187,199,89,130,188,205,194,20,61,5,0,97,61,193,130,149,61,246,80,181,59,145,20,131,61,235,93,151,60,233,213,188,187,124,132,3,189,14,81,139,59,101,31,63,60,93,224,189,186,112,160,184,60,101,234,9,189,14,4,143,61,17,99,138,187,47,184,17,188,66,174,162,189,26,251,84,61,62,110,120,61,206,78,41,61,103,201,188,58,61,78,196,189,56,101,34,189,239,88,45,61,233,101,143,60,16,211,55,189,19,243,248,187,80,193,164,60,123,110,63,61,128,140,184,61,53,41,161,189,98,203,63,189,30,21,80,189,188,222,130,187,88,252,90,189,134,226,49,60,190,109,19,189,123,93,145,189,177,120,17,61,202,147,219,60,159,49,14,61,67,171,146,60,117,26,96,61,59,159,29,60,249,66,2,189,4,53,112,61,133,236,190,60,131,201,133,60,43,15,102,189,142,211,209,189,97,7,170,189,135,83,149,61,54,152,161,188,176,153,214,188,22,153,203,188,210,139,61,189,234,26,195,58,108,220,97,61,187,55,80,188,101,167,159,188,242,135,130,61,213,228,76,61,10,144,246,188,45,143,15,60,136,176,202,188,247,122,97,189,76,28,228,58,8,140,8,189,151,218,121,60,180,223,238,61,156,119,173,186,83,87,135,189,66,242,104,61,66,193,52,186,2,82,52,189,81,138,193,61,13,246,44,189,251,149,91,189,120,199,145,60,51,212,209,60,12,211,226,189,57,209,15,188,138,36,52,188,125,150,212,189,54,60,254,60,151,128,172,188,7,249,150,189,42,207,82,61,46,181,216,61,249,126,176,189,225,235,236,188,37,242,50,60,255,1,21,62,205,2,19,187,127,78,110,189,198,92,151,189,14,134,105,61,159,121,4,62,211,64,76,189,46,137,208,61,56,249,77,61,246,40,0,62,164,231,187,61,143,44,131,61,199,151,121,60,151,192,193,61,171,32,122,61,20,24,18,190,105,193,239,188,237,70,226,60,137,73,177,60,15,67,123,186,12,81,45,189,236,16,202,189,3,10,49,61,189,132,112,61,253,50,70,189,22,107,129,61,41,50,200,60,214,188,19,189,126,205,25,60,209,183,47,61,190,84,40,188,146,13,167,61,92,57,179,61,88,20,7,190,209,179,5,60,12,236,109,188,32,226,241,60,238,27,20,61,2,14,9,187,145,12,184,60,189,21,197,61,162,194,192,61,159,152,239,188,21,14,160,189,234,121,180,188,26,193,4,187,110,92,51,60,202,79,108,188,240,136,232,60,216,89,243,61,9,208,238,59,167,226,211,189,142,218,154,61,130,232,167,188,78,140,145,59,116,214,131,60,123,108,72,189,107,94,179,189,234,119,251,187,98,128,181,61,111,199,121,61,40,120,134,61,250,46,240,59,154,192,17,61,134,177,30,189,61,252,203,188,239,171,138,189,39,142,203,61,131,170,46,188,4,151,98,60,198,71,149,189,93,214,244,59,227,134,217,61,219,209,235,188,36,66,195,60,39,33,6,189,78,16,175,60,231,44,29,61,7,201,200,60,103,255,47,189,141,43,237,188,134,53,90,61,117,153,117,60,129,191,76,61,234,125,4,62,115,88,192,61,249,208,47,61,180,151,9,189,89,117,139,189,79,115,56,60,228,13,49,62,216,133,12,189,112,27,128,189,194,135,148,188,129,42,240,61,136,252,122,189,60,185,177,189,209,124,12,189,35,229,63,61,88,37,167,61,188,242,16,61,86,59,150,60,33,223,231,61,236,154,5,61,106,175,69,189,163,142,143,60,136,41,147,188,96,80,214,189,215,75,88,187,13,124,112,57,66,195,110,60,224,187,174,188,64,59,213,188,132,196,33,188,204,14,47,61,188,77,172,188,236,183,163,189,165,55,214,60,217,252,172,188,52,164,142,189,132,195,9,190,1,136,140,189,64,171,199,187,87,253,168,61,59,223,31,62,27,145,33,59,59,143,17,60,90,27,42,189,100,85,168,60,89,47,88,61,156,243,252,188,234,208,230,60,116,188,14,62,22,125,156,61,109,150,20,189,48,255,246,188,158,138,37,189,122,239,94,188,250,16,127,189,179,80,224,188,228,8,11,62,166,3,28,62,227,228,92,189,48,226,228,189,70,182,176,60,230,214,59,60,222,166,87,189,181,17,135,189,97,54,225,188,59,234,241,61,239,55,50,62,122,95,123,189,234,89,225,189,24,115,93,188,131,6,143,188,126,170,175,189,101,22,55,189,66,27,122,189,139,67,216,61,208,15,85,62,39,231,187,189,236,5,58,58,117,156,18,61,251,195,147,61,79,1,182,60,135,186,149,60,238,143,1,188,108,12,116,60,52,175,20,62,220,153,131,189,54,249,244,60,210,42,236,186,88,160,101,188,131,217,42,189,163,212,114,187,77,44,186,189,245,251,194,61,251,39,181,61,75,59,217,188,106,33,247,188,110,234,209,60,82,249,17,61,98,97,28,189,134,216,106,60,93,228,184,60,185,72,235,60,40,40,36,60,72,175,129,189,124,179,49,61,162,101,143,61,18,191,64,189,39,228,149,189,174,124,215,60,141,121,254,60,118,40,136,61,126,128,223,61,171,152,133,188,149,105,238,60,214,42,237,60,22,170,164,61,66,187,142,61,180,55,139,61,108,112,199,59,1,130,136,59,193,209,182,61,166,227,255,188,42,50,221,60,66,124,63,60,2,169,133,188,207,16,151,59,155,124,11,60,226,43,17,189,18,79,18,61,100,211,140,59,130,99,161,188,52,37,16,188,135,197,196,61,93,1,125,60,13,183,32,189,10,174,149,61,240,68,120,61,106,20,10,57,220,199,2,188,38,140,196,60,113,55,121,189,224,189,224,188,5,71,96,189,240,55,41,189,191,206,17,61,42,75,250,60,47,61,244,60,243,43,24,62,53,188,144,60,132,70,241,60,192,161,72,61,59,64,40,60,190,84,230,60,94,79,169,61,108,209,223,60,155,200,74,188,22,217,240,61,133,187,27,61,73,145,7,189,163,4,172,59,162,144,201,188,210,123,220,60,250,46,93,61,194,136,207,189,20,198,130,61,84,238,148,188,54,25,185,60,9,91,18,61,55,220,42,60,148,31,42,189,59,154,37,189,68,164,134,60,197,135,170,61,200,229,241,57,105,107,89,189,101,210,174,189,139,10,211,186,127,64,177,188,154,23,146,188,58,23,30,61,162,14,174,61,103,84,141,188,135,164,176,61,236,45,225,61,73,245,187,61,208,11,174,61,161,153,156,61,206,147,100,61,32,167,220,60,157,188,204,61,163,194,185,61,84,139,136,61,244,142,112,61,170,36,184,188,89,45,159,61,241,31,254,61,212,82,1,62,134,185,92,186,182,30,114,60,48,184,187,61,128,143,67,187,206,110,132,189,150,136,144,189,199,177,91,57,113,15,181,60,130,217,176,188,232,45,176,189,124,44,187,188,213,175,131,59,62,189,28,60,121,230,169,188,242,218,61,189,11,217,248,187,13,172,97,188,88,192,58,189,38,9,8,190,36,151,177,189,28,175,21,189,102,63,59,60,9,172,6,61,196,239,51,189,152,157,123,61,9,92,53,62,168,176,212,61,12,196,89,60,100,47,206,61,52,254,254,61,178,93,55,189,147,83,185,61,109,250,59,61,255,183,228,61,110,223,175,61,187,71,67,61,8,35,219,58,163,80,193,60,181,2,28,189,86,13,0,61,244,52,157,188,125,109,105,189,254,191,193,188,129,130,133,189,134,89,101,189,86,90,145,189,2,62,7,189,95,75,65,189,38,59,210,188,176,239,88,60,78,11,189,189,219,6,98,189,246,9,65,189,86,123,10,189,108,157,137,189,179,248,65,60,248,2,191,189,96,149,134,60,163,59,27,61,85,200,216,187,132,171,159,61,235,104,148,61,160,197,64,61,79,184,206,188,27,1,139,188,25,64,165,189,114,6,119,61,29,152,215,61,165,104,135,189,121,231,243,60,195,199,214,60,115,200,156,60,76,168,173,189,174,123,129,189,142,246,10,190,37,143,156,189,187,174,24,60,229,201,165,189,98,218,208,189,40,40,85,189,217,135,103,60,158,192,159,189,224,109,154,188,201,202,153,189,138,151,207,189,129,127,85,189,138,167,203,189,240,30,175,186,148,229,129,189,70,39,43,189,242,105,253,189,200,14,232,188,128,29,120,189,183,204,110,61,87,188,155,61,145,90,132,189,22,121,3,60,53,41,237,61,79,144,252,61,91,19,162,60,121,129,50,187,149,165,111,61,124,119,63,189,88,221,82,61,97,15,44,187,253,119,230,61,145,159,202,61,18,102,200,61,218,215,62,189,57,159,52,188,67,104,143,189,51,11,253,60,118,43,210,188,125,28,157,189,62,10,80,59,171,216,220,189,194,149,189,188,53,29,227,189,227,229,39,188,178,67,255,60,247,91,75,189,87,237,186,60,210,57,180,59,61,154,172,189,37,97,22,190,192,25,158,189,1,161,8,190,108,93,57,189,3,11,203,189,79,20,212,60,7,26,14,61,203,9,63,61,199,95,239,61,129,147,197,61,57,94,222,61,249,91,109,188,59,30,48,61,100,130,138,189,212,169,174,58,94,193,18,62,91,31,155,61,80,185,187,61,233,113,104,61,132,242,231,61,185,73,53,188,167,238,168,60,163,53,235,189,96,112,153,189,148,164,234,188,35,0,81,188,54,65,142,189,192,225,206,189,39,125,40,189,94,111,181,188,0,185,80,188,206,50,153,189,14,48,216,189,210,25,156,189,242,143,204,189,190,147,234,189,6,70,247,189,40,198,192,189,180,92,146,189,231,18,38,189,31,247,122,189,172,229,44,61,219,115,157,61],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+71684);allocate([209,231,39,61,56,173,1,62,181,92,22,62,47,215,94,62,101,66,0,62,214,189,60,62,95,27,218,186,103,212,27,59,158,211,108,60,229,190,15,61,8,121,217,60,160,162,140,60,151,30,92,61,206,47,241,60,254,233,231,61,138,96,115,188,10,0,132,188,166,53,243,186,223,246,139,188,0,166,94,189,143,44,89,189,16,119,87,61,231,193,18,189,243,194,179,185,194,91,178,58,153,179,53,189,83,50,45,189,212,102,6,61,187,126,96,189,178,217,208,189,168,149,147,189,21,250,219,189,117,230,193,188,208,128,210,61,2,21,52,187,214,207,4,189,76,38,189,60,124,80,232,60,131,241,211,61,188,128,72,62,38,246,209,61,98,168,164,61,162,83,98,61,89,176,7,190,141,104,19,190,38,131,77,59,3,188,10,189,40,149,18,60,170,111,93,61,155,246,162,187,14,211,66,188,205,84,148,57,202,206,31,189,165,166,72,189,70,81,177,60,72,147,98,188,9,150,151,188,12,35,153,60,123,181,200,188,249,187,187,60,18,221,167,61,252,138,7,61,174,179,217,189,242,169,202,60,8,232,90,61,203,0,197,188,16,220,4,189,75,241,181,187,115,11,164,189,63,82,230,60,249,126,45,61,36,74,152,60,124,202,72,61,169,164,107,188,219,40,122,188,224,117,167,60,155,39,77,189,192,214,45,61,214,227,155,61,113,197,74,61,8,154,118,189,167,153,139,187,183,124,6,62,12,185,107,188,41,119,160,188,2,166,37,189,5,119,254,189,146,90,58,59,87,141,78,189,217,206,186,189,99,161,240,59,153,72,192,61,161,171,241,61,252,194,154,59,39,157,145,59,246,135,163,189,199,4,20,189,168,242,55,61,42,8,184,188,150,188,63,61,132,170,86,61,228,183,176,60,121,142,60,189,201,68,68,188,19,46,225,188,195,122,11,62,18,121,180,61,52,201,159,189,26,103,159,59,5,250,130,188,140,216,39,60,156,221,13,189,101,195,188,188,153,6,178,189,10,76,136,61,139,252,108,61,254,112,1,190,50,7,189,60,30,69,150,61,243,30,154,61,29,127,74,61,228,149,183,188,180,90,204,189,104,91,20,62,116,144,134,189,89,225,160,189,15,218,231,60,23,213,10,186,102,71,63,189,112,33,242,189,174,206,250,189,40,88,29,190,27,59,243,188,10,113,165,61,119,94,10,62,237,162,235,61,143,45,66,61,140,114,97,60,236,188,111,189,98,244,123,188,216,246,98,189,107,17,204,60,191,44,235,188,232,45,226,60,27,21,116,62,114,214,100,62,145,19,211,61,219,179,141,189,17,129,207,189,190,212,78,190,26,118,78,189,48,19,139,62,156,95,189,62,225,216,176,62,108,248,148,62,118,105,103,61,125,253,40,61,114,184,153,61,149,72,224,188,19,48,10,188,144,230,150,61,75,124,135,60,145,146,192,189,55,21,196,189,45,142,113,60,49,254,145,189,117,192,13,189,255,68,234,61,158,211,12,62,41,198,130,189,88,60,129,189,89,70,6,60,55,7,238,61,163,133,165,59,84,180,155,189,139,32,137,61,222,180,131,62,160,24,185,61,42,151,147,62,65,208,6,62,204,154,89,189,74,20,175,188,107,254,12,189,198,29,128,189,249,186,31,61,250,82,60,62,139,52,133,62,204,55,10,61,199,104,152,60,191,90,67,62,198,246,57,62,73,52,97,59,239,197,248,188,231,141,73,62,231,34,181,62,97,173,127,62,237,255,3,189,174,86,148,62,17,161,220,62,207,149,157,62,20,78,191,60,5,74,202,189,137,138,224,187,210,50,183,61,18,237,166,189,211,194,228,60,166,5,126,62,205,139,49,62,43,65,127,61,187,167,213,189,175,135,42,190,128,37,7,190,7,186,174,189,39,87,69,190,197,156,10,190,89,189,99,62,230,205,200,62,41,46,136,62,26,203,73,188,163,125,38,60,138,2,9,62,175,34,246,61,231,198,70,189,208,26,162,189,247,24,144,61,37,25,126,59,53,244,122,189,94,193,25,190,253,154,233,189,222,60,175,189,26,39,152,189,203,5,37,190,223,79,7,62,49,138,131,62,61,97,105,61,46,136,140,61,59,143,197,187,94,46,2,188,38,151,68,61,242,29,137,61,206,216,157,188,219,53,126,61,242,188,9,62,106,177,130,189,53,138,67,187,153,169,14,189,104,17,247,59,113,144,31,61,191,201,234,61,213,205,136,60,59,161,7,60,29,124,245,187,143,223,239,189,238,31,218,189,38,12,212,189,255,142,76,189,207,179,72,186,253,180,247,60,144,240,66,189,27,143,149,189,174,151,110,189,148,184,6,190,235,230,217,189,97,151,70,190,211,66,204,189,226,45,162,189,166,214,242,57,153,96,45,186,247,87,34,62,87,85,175,61,243,224,156,189,19,39,164,189,253,122,124,189,128,56,154,60,83,87,63,186,250,25,140,61,201,112,29,61,129,157,79,62,55,147,97,62,146,100,172,187,138,247,109,60,241,171,129,189,191,180,234,60,122,101,104,61,13,70,249,61,235,43,29,61,198,161,17,61,91,37,218,188,116,137,210,189,135,168,133,189,141,163,226,189,58,21,184,189,95,236,206,189,243,203,4,60,62,12,195,59,151,113,214,60,1,188,139,188,173,48,223,189,53,241,163,189,181,217,230,189,54,93,125,189,15,2,122,189,97,212,130,60,131,161,114,189,79,187,192,61,93,18,106,62,5,171,5,61,249,181,138,61,91,100,184,189,144,196,38,60,111,62,158,60,113,181,176,61,237,74,106,188,118,91,224,61,140,28,42,62,23,112,199,188,148,148,7,189,65,136,45,189,104,163,70,60,213,137,201,187,1,108,142,61,17,3,247,60,45,120,146,60,201,223,227,60,234,200,99,189,53,215,18,188,215,161,75,189,133,207,153,61,93,110,145,60,12,64,113,61,170,117,163,189,79,104,21,61,211,254,116,187,48,41,182,189,194,172,131,189,1,61,165,189,23,34,18,61,226,15,146,189,52,142,236,187,228,236,195,189,80,39,55,62,49,178,24,62,184,147,169,60,81,128,77,189,112,127,76,189,73,160,128,60,180,228,202,189,12,57,132,61,98,249,28,62,131,185,64,62,138,104,239,61,107,22,65,188,13,73,182,188,106,21,156,188,203,90,210,61,158,59,238,187,45,226,238,61,49,133,23,62,26,43,159,61,236,155,196,60,132,158,91,189,118,158,161,188,12,121,97,60,57,9,138,61,221,163,133,189,84,139,106,61,27,4,197,188,213,140,15,190,162,251,169,188,222,80,61,189,209,11,64,189,199,230,150,188,85,41,158,61,43,198,70,189,19,131,122,60,194,27,73,190,158,136,221,61,122,122,27,61,167,59,193,189,35,133,163,189,241,149,10,189,25,242,226,61,247,72,183,60,211,20,2,62,134,83,93,62,118,27,239,60,136,218,152,59,190,106,210,189,65,211,70,189,117,244,98,187,206,50,177,61,88,114,184,60,170,88,197,61,81,238,47,62,5,230,189,189,85,189,240,57,137,22,240,189,38,16,250,189,240,52,31,190,21,212,147,61,241,255,88,189,139,211,26,61,215,250,82,61,28,190,27,189,168,138,30,61,203,42,28,190,179,26,178,189,48,155,165,188,18,182,40,61,38,108,27,190,168,61,129,60,219,231,209,61,19,198,245,59,228,12,141,60,138,219,139,189,60,105,196,188,165,37,135,189,62,217,48,189,185,43,165,189,49,113,218,59,29,138,8,61,0,71,145,61,123,146,168,61,40,183,134,189,60,49,137,189,96,8,143,189,201,72,133,189,129,216,16,190,220,13,196,188,170,209,132,61,193,182,16,60,77,118,189,61,123,199,154,189,173,146,79,189,169,173,200,189,97,72,137,189,187,239,15,190,183,244,4,61,239,141,0,62,223,79,144,60,38,235,4,62,89,50,39,189,127,218,243,189,110,175,23,190,227,142,171,189,181,222,249,189,104,80,76,61,90,45,94,61,124,27,128,187,214,90,5,61,12,59,2,190,182,207,152,189,102,162,105,189,134,58,142,188,160,97,164,189,130,146,94,189,146,217,140,188,147,113,236,60,58,55,145,60,58,171,187,189,34,123,106,59,86,118,207,189,119,101,217,188,8,136,166,189,15,157,29,189,135,203,71,186,184,216,132,61,150,122,73,62,23,125,73,189,43,146,144,189,145,249,70,189,182,200,42,188,33,146,170,189,12,237,21,61,61,108,23,189,117,138,75,61,108,199,168,61,243,38,0,190,233,200,122,189,184,155,25,189,189,248,213,59,232,220,209,189,31,102,210,60,44,10,148,59,59,244,24,189,167,88,57,188,182,173,93,189,247,34,105,58,235,185,253,189,33,23,116,189,70,85,254,189,167,248,123,189,209,182,149,189,138,3,200,60,132,215,143,61,198,150,154,189,87,123,70,186,143,147,185,189,92,39,166,189,85,186,141,189,50,94,28,60,102,222,71,188,138,244,158,58,238,166,17,188,171,44,170,189,28,122,58,189,234,243,219,189,209,26,105,189,127,159,14,190,104,227,184,61,75,220,26,62,134,22,2,61,39,230,53,62,53,248,172,57,118,5,83,61,76,155,201,189,203,13,194,189,5,138,175,189,82,80,38,62,54,0,70,62,64,124,12,60,165,0,235,61,34,196,116,188,62,80,9,61,236,160,183,189,95,62,190,188,18,51,218,60,73,46,95,61,232,222,16,189,152,171,147,189,189,105,139,189,35,185,255,188,206,253,114,189,251,249,48,190,108,139,34,190,100,3,75,189,65,89,131,60,7,170,253,189,226,29,14,62,65,213,91,62,218,87,10,62,106,246,86,62,224,41,181,61,94,248,165,61,99,197,25,61,45,78,249,61,75,100,227,61,157,248,217,61,191,194,14,62,35,101,238,61,213,106,23,62,155,152,71,60,130,45,62,60,217,82,17,61,132,27,180,61,200,226,138,188,154,137,157,189,48,173,168,189,238,142,222,59,115,100,201,188,188,90,5,62,63,82,224,61,31,227,201,61,211,251,65,61,188,81,50,189,30,96,27,190,108,87,55,190,1,6,214,189,235,102,9,190,137,216,135,189,219,219,1,189,14,16,140,189,89,115,232,189,209,7,143,189,93,106,67,62,42,68,52,62,199,82,158,61,142,67,205,61,13,131,186,62,202,218,144,62,120,238,1,62,23,63,35,62,170,5,16,62,249,105,229,189,46,11,15,190,178,31,186,189,199,116,16,190,142,155,81,61,122,150,44,187,216,18,221,189,247,248,198,189,0,121,88,189,112,66,128,60,245,19,78,61,218,202,143,61,51,187,242,188,214,191,144,60,76,172,170,61,200,137,3,189,76,152,160,59,56,114,84,61,99,172,78,189,128,29,197,189,255,237,206,188,68,167,141,61,84,227,70,60,252,121,90,61,104,9,13,189,236,239,205,189,144,215,128,189,180,225,177,59,115,142,206,187,189,250,185,60,58,251,144,188,27,23,6,61,194,163,158,61,209,163,254,59,88,126,78,61,58,3,135,60,25,46,190,188,198,94,203,189,150,233,187,188,213,180,166,60,205,122,170,189,63,73,174,61,159,229,24,189,88,105,132,189,65,82,121,189,159,22,12,62,160,228,234,189,199,152,31,189,229,72,146,189,175,92,47,59,79,20,21,189,113,181,201,189,213,146,225,189,192,22,51,62,241,85,52,62,20,199,36,190,21,117,148,189,84,97,128,60,215,32,115,62,137,171,154,61,176,106,128,189,189,146,149,189,149,67,130,62,129,22,45,62,187,75,167,189,178,59,114,189,180,245,33,189,151,103,223,59,227,0,102,189,242,144,149,189,79,95,249,189,163,165,253,61,25,37,98,62,186,12,99,189,99,152,7,189,28,196,106,61,155,126,71,62,82,131,36,61,214,185,132,189,181,255,252,189,152,212,63,62,77,63,197,189,182,54,229,189,195,11,254,61,140,122,32,62,201,46,69,62,106,36,223,61,55,234,10,61,158,114,5,190,101,122,102,189,45,216,184,189,9,125,112,62,46,102,142,62,163,213,136,62,60,154,148,61,131,160,41,62,8,66,101,62,158,100,152,61,116,18,87,190,9,98,165,189,81,237,25,190,30,217,143,61,206,168,222,61,57,236,57,62,117,46,77,62,25,250,10,62,126,8,244,189,167,251,227,189,147,79,65,190,2,209,120,61,83,186,82,62,113,56,254,61,53,251,32,61,150,97,149,62,212,13,151,62,183,159,142,62,65,192,147,188,128,117,42,62,190,78,69,62,49,180,155,60,51,214,118,61,40,148,26,59,154,75,127,60,186,198,221,60,199,31,233,61,199,227,247,61,137,11,32,61,44,242,61,61,255,191,184,61,177,29,244,61,129,230,109,187,6,224,181,60,196,178,211,61,235,174,49,62,76,20,251,61,185,99,66,62,63,37,33,62,86,44,62,60,8,129,138,188,147,43,126,186,40,189,147,61,149,81,62,60,168,239,54,62,247,188,122,62,199,117,58,62,24,158,78,62,127,162,116,61,86,118,18,188,17,206,189,188,181,212,19,62,79,136,16,62,91,35,98,61,28,31,130,61,213,214,67,190,205,96,208,61,185,154,150,62,23,106,135,62,129,98,191,61,47,130,28,62,250,185,74,62,117,218,232,61,239,71,2,190,75,25,91,190,190,131,164,188,101,124,134,189,208,41,136,188,120,66,33,189,143,184,67,61,238,129,77,61,211,86,188,188,92,239,78,190,237,252,130,189,208,130,12,62,52,219,102,62,239,116,24,62,151,233,177,61,232,176,138,62,218,229,164,62,231,86,200,61,146,173,61,190,33,117,48,190,250,164,42,188,201,49,36,61,17,5,44,61,72,129,165,189,113,210,25,189,203,0,69,189,125,229,85,189,94,77,94,190,72,163,135,189,5,71,241,60,15,111,60,189,246,73,87,189,231,180,172,189,252,80,233,60,55,249,14,61,233,194,7,60,91,84,226,189,209,151,229,189,40,179,163,188,75,238,91,189,164,164,181,189,199,129,64,190,221,174,94,189,203,70,77,189,215,253,93,189,229,250,123,189,226,192,221,189,210,10,50,61,175,127,36,61,208,43,121,60,60,79,249,189,127,229,71,189,81,116,52,188,154,39,5,61,182,38,118,189,197,141,252,188,115,4,188,188,143,109,140,189,148,183,179,189,241,164,115,190,4,229,187,189,132,217,98,189,75,253,48,189,240,49,243,189,62,237,44,189,120,165,120,189,128,180,67,60,147,177,213,60,12,108,31,189,96,155,134,188,156,40,213,188,119,227,85,188,58,145,32,61,125,105,133,189,94,162,56,60,50,176,205,187,133,211,222,188,79,4,228,189,120,46,7,61,155,123,196,60,99,26,39,61,34,92,216,189,182,95,116,61,52,211,67,60,219,58,2,189,47,168,138,188,92,11,125,189,166,220,150,60,202,147,180,187,178,181,139,189,95,189,2,189,201,125,195,189,61,67,248,60,224,139,72,189,24,196,238,188,125,5,8,190,201,237,67,189,14,45,199,59,8,126,109,188,192,201,8,190,214,103,198,189,132,129,230,188,204,209,70,60,54,49,136,61,86,10,167,188,121,196,8,62,28,52,117,61,245,139,21,188,16,79,64,190,231,156,245,189,150,227,129,189,101,114,73,60,26,75,146,61,5,103,219,61,86,9,227,61,122,137,134,61,46,48,242,188,222,202,38,190,64,75,15,190,2,196,83,188,14,0,29,61,130,253,186,61,69,85,80,189,247,21,102,61,132,155,31,189,103,169,128,189,190,80,235,189,130,16,18,190,186,145,57,189,116,236,130,60,169,193,187,61,156,108,177,61,216,25,72,61,11,41,107,189,107,242,154,189,54,122,47,190,67,149,214,188,153,246,202,188,3,131,219,60,128,4,238,61,123,252,179,61,109,238,30,62,51,231,64,61,237,128,56,61,42,47,209,189,173,196,251,189,23,115,69,189,167,168,96,189,121,52,96,61,136,116,150,61,253,113,100,61,220,35,168,189,237,215,13,61,61,167,86,190,192,247,190,189,118,178,120,59,162,45,20,61,56,113,43,62,207,140,144,61,97,255,208,61,47,43,139,189,20,142,83,59,30,234,0,190,59,43,51,190,103,65,170,60,107,148,157,189,155,138,249,61,13,67,184,61,118,87,68,61,177,33,233,189,24,202,164,189,146,171,131,190,132,127,165,189,57,14,223,59,109,12,240,188,40,216,71,187,237,116,227,189,29,153,61,189,248,47,160,189,250,90,252,59,126,223,209,189,50,167,158,58,35,173,82,62,103,192,4,189,210,28,10,60,79,116,159,60,161,70,68,188,136,76,21,190,169,104,45,61,243,176,135,187,230,159,140,189,216,55,199,188,211,137,10,190,58,2,165,58,124,252,233,189,13,71,48,189,217,214,138,188,192,76,106,61,113,64,36,190,216,39,227,60,83,54,97,61,77,181,25,190,187,181,109,60,109,137,192,60,76,43,48,189,104,211,74,189,26,59,94,62,36,102,1,189,115,213,160,188,202,179,58,62,54,176,5,189,100,14,61,187,151,13,130,60,146,173,254,186,98,135,159,189,20,116,63,61,38,253,204,187,191,205,182,61,145,169,90,62,248,144,77,60,9,92,143,189,123,242,114,189,52,93,154,188,137,98,48,189,61,139,241,61,236,101,29,61,46,8,32,189,240,218,102,61,3,2,200,189,20,92,172,188,43,252,14,60,121,52,224,188,20,102,81,189,33,12,46,62,78,35,242,60,168,138,171,60,48,83,172,61,0,162,8,189,201,43,20,189,229,231,109,189,92,179,181,189,109,214,239,60,119,163,138,62,32,214,120,61,160,39,153,61,6,127,28,62,28,23,32,189,16,248,80,189,177,249,27,188,197,9,6,189,213,231,178,189,54,85,156,61,187,39,147,189,26,188,13,62,196,0,160,61,97,28,4,190,7,208,96,189,177,51,103,189,134,201,6,189,87,16,229,189,16,170,25,61,122,221,116,189,3,128,187,189,63,185,103,61,82,72,49,189,202,175,249,188,46,135,103,188,249,129,208,189,182,193,98,188,59,40,78,62,32,205,123,188,187,125,156,189,14,241,113,61,61,108,160,189,217,168,121,188,71,167,153,189,135,199,193,189,74,188,25,190,219,91,36,62,5,194,184,61,41,136,173,61,149,179,10,61,103,86,187,189,115,208,187,189,155,12,174,189,145,174,81,189,177,160,213,189,160,168,42,60,226,19,251,188,156,73,191,61,212,16,132,61,205,247,30,189,22,52,76,189,161,125,23,190,32,255,84,189,82,173,175,188,166,223,35,61,201,96,254,61,240,175,151,188,16,159,40,189,88,197,244,189,94,216,71,189,25,163,178,189,39,39,173,189,2,12,216,189,195,112,230,61,168,126,220,61,217,160,68,62,80,10,123,61,8,5,224,188,113,240,180,189,6,20,46,190,32,87,17,189,175,170,175,187,45,241,169,61,8,255,147,61,211,206,43,61,150,58,63,61,31,46,15,60,8,244,142,61,140,134,103,61,115,210,112,61,13,236,202,60,17,210,200,60,65,164,254,61,163,98,101,61,105,8,141,61,74,59,30,61,239,194,152,61,112,122,185,60,132,4,117,60,252,237,129,61,228,60,142,61,97,46,240,60,65,3,240,61,131,113,57,61,195,11,5,61,40,126,8,59,234,126,167,60,234,138,233,61,148,73,48,61,150,252,131,61,35,31,75,61,203,103,167,61,130,61,189,61,3,124,72,61,131,143,184,60,17,96,135,188,204,97,155,61,66,100,120,61,156,228,14,62,128,38,227,60,244,67,145,61,248,26,174,61,222,94,139,60,16,118,185,61,37,30,171,62,37,122,78,62,123,34,201,61,19,216,162,61,121,19,178,61,160,163,2,190,212,252,13,190,203,95,135,189,177,251,224,189,14,139,11,61,135,230,54,188,112,33,149,189,218,128,10,190,168,135,3,190,139,108,183,61,167,213,187,61,207,176,206,61,88,119,111,62,25,150,176,62,173,201,202,61,82,20,164,60,30,164,252,61,87,198,155,61,179,145,24,190,57,25,32,190,129,2,133,189,89,57,144,188,110,112,11,61,50,66,7,190,250,212,247,189,33,86,59,190,232,148,41,190,110,231,178,60,123,126,225,188,191,146,148,60,234,230,163,60,160,65,88,60,152,117,164,61,243,248,71,60,66,115,67,59,125,38,86,188,26,139,116,61,93,241,90,189,167,134,10,189,150,204,33,188,95,175,140,189,82,17,34,61,45,159,254,188,220,208,106,189,61,246,177,60,76,98,42,61,212,55,44,59,93,38,69,61,6,172,191,61,185,21,6,188,240,70,141,60,103,176,208,188,202,117,75,189,209,209,195,188,94,255,135,61,146,40,129,189,247,94,58,60,224,240,100,61,187,181,168,189,26,29,201,60,187,160,250,188,162,96,183,189,148,81,140,61,182,65,147,61,130,222,155,189,39,251,0,60,34,192,0,188,117,11,118,61,102,154,56,188,187,67,59,187,110,127,67,189,36,106,154,60,244,168,25,62,173,98,128,189,221,241,162,188,234,131,58,60,254,105,179,61,86,226,30,61,218,107,30,188,254,26,164,189,190,94,131,61,68,78,95,188,115,24,187,189,90,200,143,60,249,168,54,61,154,166,197,61,31,207,85,61,16,208,15,187,18,35,144,189,152,254,130,188,143,45,6,62,172,49,204,188,222,43,41,188,195,214,237,188,65,224,55,61,152,221,82,61,182,56,152,60,166,36,239,188,55,248,169,61,103,5,60,189,59,60,33,190,121,183,185,189,220,128,243,188,114,247,4,62,208,143,100,62,39,113,120,62,244,51,21,61,5,139,97,189,119,64,47,59,189,10,29,189,142,21,132,61,124,19,29,61,13,88,28,61,121,51,128,62,96,42,175,62,189,15,166,62,125,195,64,62,237,31,176,189,203,55,52,190,163,216,28,190,123,5,203,189,44,248,233,188,205,71,89,189,157,130,139,186,59,6,136,189,89,202,153,189,207,193,111,60,205,169,154,189,176,190,56,189,239,97,10,188,57,45,145,60,137,162,38,61,238,210,79,62,150,247,32,62,190,247,105,61,0,164,134,62,108,24,22,62,46,131,125,60,50,246,78,189,210,250,30,189,47,149,107,188,167,240,73,189,74,4,240,61,142,196,118,62,236,132,135,62,246,75,162,62,1,236,206,61,77,161,51,188,174,248,95,188,184,37,47,62,4,120,77,62,154,99,47,59,165,249,66,188,145,104,59,62,112,188,193,61,60,52,130,189,93,149,132,189,145,193,97,60,163,120,205,189,102,215,130,189,93,75,121,59,114,51,126,61,50,243,211,61,251,60,137,62,255,1,6,60,117,151,189,188,130,24,25,60,2,98,188,61,128,201,22,61,75,190,15,188,230,226,197,189,134,120,222,188,169,70,10,62,130,142,183,61,39,79,215,187,1,31,3,189,181,249,145,62,127,84,164,62,235,145,61,62,87,185,17,190,111,219,15,190,176,18,147,189,214,159,175,189,38,100,177,189,53,87,50,190,1,190,69,58,215,113,101,61,74,29,11,62,244,45,75,189,45,222,157,189,188,166,218,61,120,136,52,189,85,164,147,189,74,16,22,61,115,56,148,62,36,146,210,62,149,114,140,62,151,81,141,189,77,229,91,190,115,134,31,190,135,63,72,190,28,191,27,190,244,202,230,189,55,225,151,61,162,120,66,62,139,131,137,62,215,237,159,60,190,198,38,60,49,239,176,60,124,65,162,187,144,235,50,189,25,69,2,190,193,174,136,189,200,234,230,189,243,197,52,61,215,124,100,61,155,156,31,61,152,20,18,61,116,130,112,189,223,78,151,189,165,247,55,190,227,132,175,189,220,101,28,190,149,172,118,189,92,91,143,189,64,81,223,187,15,232,128,61,177,173,43,186,46,235,56,188,150,145,187,188,126,160,70,61,122,155,41,61,200,128,114,62,196,242,20,62,151,4,163,60,206,109,246,61,133,237,125,59,142,117,197,187,87,121,114,189,89,68,251,188,97,126,159,189,44,229,221,61,254,110,176,60,221,143,226,60,151,214,34,61,132,129,249,189,105,181,72,189,192,146,203,189,130,43,132,189,183,223,12,190,133,109,24,189,95,158,231,60,39,58,50,189,124,57,156,60,104,158,210,189,108,74,104,189,200,96,220,189,134,25,197,189,70,231,195,189,54,151,85,188,150,91,252,60,199,20,104,60,62,117,111,61,193,235,177,187,231,212,126,61,34,0,8,189,148,24,139,189,159,54,109,189,24,153,3,62,75,128,25,62,44,221,20,61,76,13,18,62,113,95,49,61,80,34,78,61,230,174,102,189,34,147,131,60,94,179,51,61,16,208,100,62,242,255,32,62,66,64,64,189,136,76,246,60,171,186,37,187,154,49,106,61,112,53,154,189,56,91,233,188,18,172,140,189,205,5,148,187,175,108,132,61,243,28,115,189,0,182,64,189,90,208,150,189,35,97,70,61,84,111,9,190,86,124,200,189,38,7,210,189,119,195,15,61,138,159,66,61,246,143,28,189,26,124,199,61,203,22,67,61,109,99,33,61,34,164,169,189,13,165,195,61,2,99,78,61,52,176,89,62,5,146,197,61,95,194,4,61,70,171,83,61,70,3,61,61,73,92,49,61,140,224,218,188,244,51,128,189,77,146,188,188,138,207,64,62,180,129,215,61,19,171,48,61,82,226,136,60,36,123,172,189,179,33,114,61,80,187,216,189,113,225,70,189,88,127,171,189,48,64,159,61,19,132,24,61,199,186,246,189,159,93,159,59,212,119,215,189,16,151,134,61,30,45,154,189,30,241,4,189,84,30,202,189,237,255,238,188,182,82,59,190,1,170,23,62,201,100,23,60,149,96,50,189,6,180,185,60,75,39,243,189,253,132,36,189,52,218,231,60,195,204,102,62,154,151,82,62,194,6,43,62,97,186,184,61,77,25,85,60,168,229,199,61,226,143,22,189,73,141,158,188,203,52,141,189,50,108,165,61,250,11,67,62,165,172,231,61,251,46,40,61,14,29,229,189,12,167,48,61,253,239,61,190,76,41,231,189,199,28,180,189,182,64,170,60,51,160,28,190,119,203,241,61,81,192,52,188,83,139,35,190,247,106,176,60,10,79,86,189,68,232,221,189,49,113,14,190,150,131,114,61,150,79,207,189,150,149,78,62,153,124,186,61,186,30,154,188,190,196,195,61,69,155,24,189,39,100,193,189,38,243,199,189,102,204,111,61,179,184,169,61,156,76,4,62,40,3,176,61,151,182,35,187,239,122,196,60,28,27,186,59,244,242,128,189,20,13,5,190,138,239,29,61,6,113,84,61,86,0,222,61,185,118,10,189,226,149,1,190,44,40,93,189,28,183,152,189,254,254,65,189,216,41,208,189,91,133,153,61,134,103,166,61,107,204,156,61,163,200,76,189,237,78,3,190,78,138,157,189,108,200,231,189,4,192,186,189,107,75,105,189,192,146,214,61,224,244,152,61,150,136,133,60,196,58,3,188,79,205,134,189,68,159,36,189,215,207,63,189,89,74,156,188,186,59,225,189,211,43,73,61,39,28,240,60,113,240,43,61,146,128,108,189,3,14,198,189,203,63,19,189,211,89,11,189,235,106,146,189,82,101,216,189,69,29,217,61,121,219,129,61,11,208,120,188,218,109,195,187,192,56,156,189,133,50,103,187,127,220,219,188,193,60,210,189,196,156,219,188,22,78,39,62,109,61,254,60,20,43,188,60,12,17,133,60,226,212,221,189,252,148,189,188,119,50,68,189,152,137,98,189,229,83,132,189,112,237,214,61,224,43,62,61,244,128,155,189,191,221,125,189,238,46,185,189,140,213,108,188,227,9,48,189,101,165,230,189,206,24,234,189,122,7,2,61,63,161,22,189,128,207,242,188,83,96,135,189,79,28,8,190,215,145,144,189,118,239,172,189,14,80,216,188,129,38,146,189,184,198,58,61,0,52,111,60,190,53,56,62,201,171,53,61,21,71,255,189,165,51,235,188,139,52,220,189,247,1,11,189,203,75,27,189,178,192,208,60,87,61,160,60,82,19,69,62,213,251,14,62,58,219,113,189,108,14,152,189,66,60,213,189,237,20,202,58,209,62,147,60,120,98,5,62,124,69,58,61,89,229,105,189,238,19,219,189,192,33,10,190,82,113,133,189,137,54,131,189,149,225,133,187,41,248,90,188,135,241,50,61,92,153,230,189,250,137,105,189,72,129,132,189,60,240,170,189,192,171,42,189,172,98,109,189,182,232,168,189,210,55,107,189,39,26,173,61,165,57,9,189,252,41,15,62,11,180,7,62,116,111,155,61,65,107,154,61,99,243,248,61,47,116,67,62,164,30,26,62,62,154,89,62,70,122,17,62,147,190,84,60,190,148,152,61,143,84,134,61,68,79,139,60,238,217,56,61,62,147,45,62,56,40,210,61,91,213,39,62,186,124,97,61,35,112,13,189,137,150,176,61,65,135,162,61,28,222,34,61,236,203,166,60,125,173,129,59,169,209,5,61,12,4,28,62,216,148,84,60,136,19,166,189,67,157,102,60,11,104,144,59,67,54,27,190,233,70,233,189,147,88,153,189,10,3,0,188,35,62,225,188,230,131,208,189,201,219,12,62,16,111,15,62,186,15,10,62,100,227,140,62,157,93,175,62,206,117,156,61,111,220,148,61,30,255,74,62,2,59,37,62,63,122,43,189,197,232,2,190,231,166,201,189,206,205,1,61,204,191,224,61,182,33,26,190,83,157,182,189,179,51,146,189,5,31,42,189,231,239,204,59,82,135,79,60,143,184,215,61,30,141,2,62,182,29,27,62,49,132,117,60,85,37,129,61,33,84,76,188,26,200,179,189,123,36,175,189,101,215,244,189,199,242,173,189,98,179,237,188,213,47,196,188,229,126,9,190,154,94,226,189,127,151,19,190,128,174,27,190,104,185,34,61,21,26,195,185,212,17,44,189,168,16,122,61,57,14,156,60,3,61,53,188,147,94,238,187,185,23,121,188,141,122,144,58,253,183,74,189,183,27,164,189,204,116,187,59,55,89,172,61,26,152,133,189,173,20,22,61,193,249,218,188,102,29,247,189,15,163,23,189,142,7,118,61,240,107,133,60,134,110,202,187,115,199,167,61,249,227,95,187,0,39,235,60,73,220,109,61,57,41,75,61,223,41,61,61,78,197,72,189,112,171,216,189,130,82,186,60,154,54,247,61,111,137,18,59,196,90,201,61,205,98,247,188,186,1,229,189,164,52,75,189,82,182,204,60,129,42,24,189,150,174,132,188,235,141,216,60,22,2,250,187,1,30,236,188,88,178,127,189,46,217,172,189,71,226,147,61,7,196,148,61,41,217,127,60,69,75,253,60,74,250,139,60,4,136,27,189,176,197,80,187,48,10,133,60,122,183,231,188,252,26,231,61,11,98,173,186,22,111,159,189,114,164,147,189,133,32,10,61,189,236,248,61,78,159,186,60,160,21,88,189,135,41,157,188,167,2,5,62,248,46,94,61,92,32,191,60,92,7,37,61,149,206,253,61,182,119,194,61,218,55,188,61,234,134,162,61,93,168,15,60,159,153,47,62,57,122,11,188,4,18,164,189,25,48,139,189,80,21,72,61,18,60,54,60,146,119,160,189,84,124,150,186,252,238,12,189,18,21,233,60,206,154,157,61,183,200,144,189,83,181,60,188,129,230,11,188,38,55,136,188,71,141,42,189,102,52,93,61,254,56,234,60,173,91,239,60,172,237,76,61,51,178,224,187,86,190,133,188,190,86,159,61,239,151,37,61,49,77,71,188,108,135,108,59,197,123,129,189,13,231,194,61,93,220,3,62,159,201,30,188,200,242,40,60,159,53,84,61,115,34,25,188,91,184,134,188,23,161,70,189,33,230,49,189,191,87,215,61,139,203,164,61,239,9,61,189,254,213,34,189,111,99,115,188,142,28,6,62,112,179,120,188,172,151,134,189,182,130,36,189,211,136,151,60,151,219,199,60,170,55,165,61,113,37,229,58,243,117,144,61,173,159,180,61,180,147,166,187,99,41,134,189,138,74,169,189,199,88,159,189,29,34,110,60,83,87,179,189,150,166,51,60,198,193,14,188,243,15,207,61,53,79,198,60,63,99,137,189,217,122,164,60,155,91,194,59,208,35,93,61,142,97,154,61,104,223,167,60,128,182,183,60,30,75,36,61,66,228,189,186,238,85,137,187,217,104,130,61,55,94,205,60,236,111,199,60,8,210,112,61,37,213,6,188,193,143,75,188,143,13,45,61,103,195,143,188,217,11,116,61,236,107,28,61,127,241,149,188,69,126,48,189,25,34,53,189,219,73,199,188,175,137,185,60,209,135,5,59,30,31,68,60,107,212,53,61,231,57,249,61,47,145,19,61,63,238,212,188,227,232,1,187,199,162,167,60,15,49,216,188,90,170,250,186,141,44,191,189,233,65,19,189,68,231,33,188,147,65,140,189,188,33,63,189,187,228,203,189,158,75,44,189,69,188,213,60,114,238,20,60,145,50,146,189,236,105,221,185,59,185,144,60,251,205,225,60,19,89,86,60,164,1,38,61,210,149,195,60,160,157,90,61,8,218,204,60,44,155,75,189,81,85,255,189,227,68,52,62,228,2,251,61,217,217,153,189,93,157,14,60,31,95,105,189,86,138,20,189,63,160,15,188,180,100,70,188,50,145,193,189,2,105,153,61,213,126,164,188,122,166,219,188,219,94,132,189,219,160,120,188,16,112,240,59,66,243,198,59,185,207,190,189,203,103,59,189,123,204,7,62,95,243,29,62,30,167,135,188,59,29,227,188,152,199,86,189,119,10,193,188,214,167,192,188,70,34,209,189,228,209,3,190,101,253,20,62,13,52,0,62,21,198,143,59,52,12,229,60,193,198,83,61,53,230,188,61,73,65,113,61,8,179,194,60,43,133,227,188,148,179,194,61,84,201,190,60,107,12,190,188,121,214,3,189,76,82,122,188,61,147,38,188,236,28,219,188,58,107,82,61,148,65,162,60,192,7,134,61,220,11,143,188,127,41,40,60,228,226,127,60,18,238,80,58,97,175,155,61,238,61,156,60,238,143,252,188,91,62,117,189,205,74,189,61,32,11,21,62,188,181,41,60,89,84,253,60,35,216,195,189,146,190,27,189,240,89,207,60,186,68,252,60,50,108,145,189,36,109,8,61,81,94,48,187,138,189,1,61,174,80,107,61,122,134,5,61,137,178,250,58,148,217,2,61,181,87,151,61,169,16,180,60,141,84,156,61,181,226,6,61,86,113,186,189,78,65,65,61,39,247,121,61,131,87,36,188,189,217,191,59,98,117,121,188,223,87,190,60,115,196,216,61,56,212,142,59,177,45,122,61,195,96,112,61,108,57,255,188,84,3,71,60,7,116,175,61,246,20,129,59,112,143,206,188,0,249,246,186,18,245,166,60,132,83,36,186,92,153,72,61,48,85,47,189,26,106,69,189,145,34,69,189,39,195,109,188,200,244,80,61,241,163,19,188,12,142,8,189,188,122,32,61,242,226,43,61,76,206,47,61,24,40,230,60,149,188,245,60,9,44,39,61,206,25,21,60,226,184,198,61,189,147,212,61,85,104,192,60,179,233,154,187,34,81,40,60,227,11,213,61,31,59,247,61,236,14,201,61,77,250,213,188,137,7,21,61,74,132,113,61,124,69,71,61,202,91,68,61,22,5,31,189,25,168,242,188,163,65,72,188,202,197,38,61,142,131,157,60,7,108,187,188,155,84,8,61,252,75,152,60,246,212,184,61,154,212,27,61,72,100,105,188,224,12,160,60,124,150,205,60,79,228,10,189,186,254,103,189,204,130,134,188,236,142,111,61,119,10,62,61,218,98,171,60,124,55,4,62,53,246,75,62,34,131,158,61,6,213,237,187,198,231,38,61,150,106,2,61,253,132,182,58,224,16,106,188,243,209,152,60,92,175,174,61,252,185,10,62,13,42,229,61,132,203,35,61,126,29,196,61,53,138,215,188,105,166,13,189,52,143,66,189,18,168,120,189,128,160,154,59,128,2,132,61,5,181,200,188,143,157,96,189,171,194,62,189,57,91,166,188,122,146,14,189,45,119,192,189,244,16,131,189,228,212,147,188,50,69,184,59,110,216,217,187,104,124,133,189,89,34,228,59,34,98,152,188,193,232,45,189,139,161,111,189,41,156,84,187,214,181,157,61,80,61,231,61,65,57,203,61,250,89,243,188,174,16,101,61,58,46,69,61,235,238,200,189,218,166,191,189,140,48,6,189,61,190,85,61,119,161,41,61,94,197,128,59,170,190,78,189,103,110,35,62,183,240,60,61,94,27,255,188,63,119,62,189,146,28,5,189,97,181,198,188,213,151,48,189,20,113,48,61,242,140,192,189,181,67,66,189,128,137,77,188,104,36,135,189,79,184,95,59,163,54,102,189,197,151,238,187,96,177,117,189,25,31,6,189,9,20,151,189,230,17,81,59,142,95,158,189,193,55,110,61,29,110,202,188,165,184,29,61,139,181,13,62,208,177,29,62,111,212,141,60,115,22,114,188,10,219,212,61,197,88,83,61,63,97,159,188,249,99,12,189,197,93,71,189,0,47,189,61,92,206,219,61,196,175,120,61,204,3,94,188,243,22,151,60,221,146,14,189,251,130,27,189,94,26,98,57,124,212,94,189,34,209,154,60,33,125,108,188,171,163,213,188,89,174,240,188,252,224,222,60,122,29,127,189,11,97,243,188,106,86,12,189,102,141,210,189,93,5,138,189,251,33,86,189,55,163,9,61,131,251,230,189,217,170,142,189,37,184,14,190,69,63,21,60,167,33,132,57,206,123,133,187,52,31,252,61,139,88,191,61,48,142,149,61,24,250,3,61,251,69,154,61,15,86,27,61,103,49,76,189,63,213,147,60,93,181,220,60,240,12,10,62,87,119,60,61,212,56,40,61,115,78,174,61,74,52,252,61,160,103,88,60,113,155,78,61,76,48,181,187,64,43,184,189,67,67,184,188,19,144,167,189,242,134,124,61,245,99,5,189,193,33,47,188,123,214,88,188,125,38,245,189,232,21,61,189,129,147,247,189,136,127,138,189,153,179,177,189,180,199,131,189,161,52,145,60,141,29,14,61,242,198,223,189,127,229,246,60,216,171,15,62,28,44,37,62,36,44,56,62,203,13,231,61,224,170,215,61,209,100,182,61,50,99,158,61,84,30,137,61,215,122,175,60,66,222,131,61,36,151,200,61,114,81,107,61,71,112,228,60,114,174,215,60,161,140,163,61,114,59,139,59,25,235,10,60,122,128,219,188,6,72,173,187,151,40,177,188,235,104,153,189,197,252,168,189,134,121,168,188,178,33,40,188,2,97,151,186,250,235,22,186,67,172,147,189,6,239,149,189,61,5,72,189,116,44,223,189,94,34,153,189,82,153,181,189,33,224,188,189,182,188,223,189,175,156,213,189,62,227,162,61,79,192,226,60,4,86,233,61,114,77,64,62,189,183,7,61,166,156,175,60,214,178,111,61,10,251,10,187,108,15,119,187,128,66,227,60,210,247,255,188,120,12,112,60,15,98,132,60,16,13,100,188,91,100,52,189,220,254,94,189,36,95,22,190,21,197,25,190,51,181,56,61,33,210,169,58,13,27,101,60,90,205,101,61,34,109,71,189,127,167,67,189,43,214,5,188,205,208,22,187,117,75,187,188,133,107,245,61,68,165,64,189,14,133,180,189,141,88,155,189,11,45,221,189,227,98,4,189,4,93,119,60,103,99,70,189,226,133,34,189,40,100,196,61,122,154,93,60,242,229,110,188,246,42,44,60,81,243,248,188,87,194,131,60,195,196,146,58,81,232,76,188,79,146,59,59,11,130,49,61,49,138,21,190,247,117,159,188,189,171,190,188,155,180,161,188,137,179,162,61,18,60,182,188,198,64,137,189,21,102,14,61,115,162,235,61,143,59,222,188,243,103,136,188,139,88,129,61,87,14,168,189,20,53,152,61,171,89,73,61,67,10,55,189,254,47,116,188,207,143,151,61,71,156,238,189,219,254,80,61,209,189,58,61,42,82,114,189,11,15,181,61,184,20,130,188,192,121,24,190,107,237,160,61,152,238,64,61,47,114,92,189,130,40,150,189,108,165,19,189,216,221,31,62,188,171,156,61,75,24,116,189,171,117,227,188,23,77,227,61,169,246,25,61,221,36,54,189,55,16,74,61,212,115,92,60,131,190,141,61,175,212,150,61,115,14,98,61,180,136,237,60,103,4,192,61,227,106,215,61,150,13,53,189,96,230,156,60,201,143,105,187,160,94,21,62,203,168,210,61,122,156,50,189,52,73,2,190,103,226,185,61,255,187,227,61,179,49,119,189,232,35,198,61,35,14,183,61,203,181,144,61,164,64,213,60,227,161,191,59,90,145,114,189,158,35,253,61,248,186,107,59,122,129,68,59,171,119,23,61,83,94,167,60,64,192,42,61,131,24,40,60,178,209,94,188,186,37,131,188,171,112,211,60,234,207,190,60,255,92,67,59,150,130,133,60,62,60,136,61,179,216,111,61,246,190,74,60,201,133,84,188,40,79,144,60,151,133,80,61,106,33,134,61,102,73,53,189,184,98,31,59,12,105,73,59,65,199,136,61,254,72,48,189,218,86,49,60,31,161,132,189,175,6,39,61,206,207,254,61,174,181,168,61,2,12,152,61,242,137,38,61,239,108,141,61,200,182,195,61,127,77,2,62,0,169,174,188,176,94,174,61,125,5,43,189,20,122,218,188,129,120,155,60,69,225,7,61,181,231,26,60,86,254,74,188,214,197,45,189,68,145,104,188,65,54,17,189,215,244,199,188,203,217,177,61,254,143,44,61,224,193,201,60,184,3,53,188,57,102,164,187,17,56,243,60,5,201,212,60,9,135,128,188,19,238,56,61,185,214,142,61,58,145,177,61,243,214,139,61,45,177,209,61,145,109,93,61,216,28,134,61,243,43,26,189,248,209,95,60,19,201,144,61,249,178,91,61,239,135,68,61,94,191,239,61,242,231,95,61,52,33,153,188,213,238,129,61,238,124,254,60,158,178,172,61,81,216,168,188,3,131,28,61,46,209,226,187,69,222,209,59,71,94,80,188,50,127,144,56,48,4,58,61,56,156,155,188,5,161,77,189,127,213,245,60,157,167,50,60,125,66,148,59,250,212,210,60,131,169,195,188,252,12,44,189,168,120,226,58,193,223,116,189,82,222,222,188,51,161,134,61,144,31,61,60,190,91,79,60,116,15,151,61,102,180,22,188,72,72,73,189,240,16,174,60,123,52,132,61,73,29,51,61,81,148,7,189,109,177,19,61,114,47,222,187,44,99,25,60,191,41,143,60,137,51,131,189,103,135,139,189,192,126,165,61,186,148,227,188,143,18,224,60,81,240,130,61,215,60,136,61,150,135,104,61,148,242,176,61,80,197,248,187,118,228,164,188,168,50,66,189,65,191,135,188,30,18,133,188,171,60,99,61,226,230,24,187,151,129,55,60,176,138,123,61,134,183,128,189,158,214,178,189,7,189,190,189,118,207,46,189,202,169,182,59,15,3,69,61,243,75,145,60,28,21,176,59,132,252,23,62,185,251,128,189,126,114,240,188,200,92,234,61,127,51,78,189,25,77,185,59,232,27,170,60,164,131,59,189,216,249,65,189,41,146,242,60,38,156,190,189,66,245,52,189,58,100,76,189,48,98,33,189,72,250,85,60,217,93,128,61,55,245,25,61,97,67,173,61,252,233,13,62,213,41,71,61,0,110,129,189,98,166,103,189,110,124,154,60,22,148,6,189,113,25,10,61,190,50,144,189,60,229,56,189,173,23,100,60,241,157,167,61,174,19,148,189,80,136,195,60,50,246,178,60,213,118,213,60,45,103,41,188,236,89,24,60,21,114,251,59,176,137,27,62,144,127,169,60,184,112,199,189,186,38,182,189,157,26,159,189,52,15,191,60,59,188,145,188,235,123,5,189,17,139,167,189,182,239,173,189,13,156,187,60,243,209,232,189,68,151,17,189,205,180,57,189,175,107,234,188,111,231,138,61,195,95,54,60,165,0,201,60,209,69,2,62,182,147,165,61,121,198,19,189,243,183,53,60,218,192,68,61,143,242,14,189,184,62,11,61,60,188,104,189,119,211,12,60,61,55,140,187,78,86,4,61,66,6,85,188,159,22,42,188,161,104,162,189,164,126,8,60,117,43,188,60,149,14,86,188,143,36,154,188,135,197,52,61,38,178,106,61,190,18,26,189,135,29,159,60,188,170,215,58,148,28,28,189,38,166,43,61,46,96,25,190,212,233,56,189,255,43,70,60,113,16,179,187,47,240,134,188,117,10,250,59,56,125,153,189,88,88,172,61,102,54,205,61,149,73,73,188,236,56,134,61,52,136,58,61,130,152,161,61,73,33,249,60,64,134,143,60,200,149,188,61,181,77,196,185,231,13,216,61,216,249,63,61,135,57,155,60,36,52,217,188,205,111,142,187,30,145,178,59,13,170,108,60,224,238,112,61,51,170,8,189,76,147,60,61,150,168,213,189,178,155,157,60,67,247,150,60,196,66,140,188,200,22,182,188,18,61,64,61,181,18,126,189,172,1,105,188,251,213,178,61,50,210,157,189,62,254,217,60,67,35,48,189,202,84,253,188,89,127,17,189,34,130,154,188,101,250,75,189,149,1,32,61,35,197,60,61,115,105,75,61,125,31,47,61,195,78,61,189,227,89,217,188,168,105,12,60,1,70,29,61,42,86,110,61,24,245,30,61,155,193,144,185,29,7,252,60,60,208,5,189,81,36,92,189,134,63,76,61,44,230,26,188,58,189,18,61,150,98,45,187,26,218,140,186,53,172,242,60,193,8,115,188,19,191,250,60,35,145,200,60,230,49,151,60],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+81924);allocate([101,120,6,61,69,197,16,189,187,156,49,188,247,91,55,188,146,244,242,186,122,226,27,186,175,88,54,189,23,131,67,59,226,117,128,61,78,76,176,188,121,133,72,187,124,179,79,189,193,246,122,60,41,45,82,60,127,165,83,61,80,9,27,60,147,65,91,187,139,86,234,61,187,4,32,189,184,49,47,187,116,109,251,60,84,210,57,188,180,158,241,60,150,235,235,60,138,236,29,61,16,88,13,189,251,62,187,61,80,172,176,188,164,213,120,61,252,205,126,189,229,78,159,60,35,3,219,59,200,84,136,189,84,171,14,60,236,142,13,61,100,107,199,60,81,138,7,190,99,23,43,189,57,139,169,188,221,255,46,60,101,166,118,60,199,244,153,189,164,96,123,187,82,254,128,189,103,8,236,188,155,39,6,190,200,229,147,189,86,9,190,187,198,117,12,188,16,238,26,61,199,70,226,60,104,113,74,61,176,140,240,188,7,141,196,61,233,102,157,60,160,231,121,61,166,24,68,189,178,7,98,188,135,142,242,187,160,223,181,188,236,62,87,188,76,202,254,59,135,215,251,61,58,216,240,60,121,54,19,61,210,130,159,189,129,167,57,188,97,91,209,57,235,117,121,189,220,214,55,188,241,147,153,187,109,83,156,61,202,55,138,189,208,6,103,189,171,174,87,189,61,162,58,188,7,17,133,188,216,39,65,189,66,19,52,188,214,203,43,60,39,73,87,59,4,252,109,189,182,177,157,189,190,108,8,189,109,108,43,61,24,123,14,61,171,97,186,60,114,206,188,60,142,63,218,59,175,160,224,61,154,81,194,187,88,255,70,189,226,41,44,189,202,206,190,189,115,228,200,187,167,116,208,188,160,214,95,60,6,127,22,60,140,69,151,188,38,75,102,189,166,103,35,189,114,244,159,189,105,132,226,59,239,5,116,61,116,204,31,189,69,199,128,60,236,155,67,188,35,231,225,187,97,104,253,188,34,106,41,189,189,7,128,188,133,154,60,189,80,184,234,60,14,188,177,189,13,103,4,189,214,187,91,189,93,192,108,188,102,112,143,189,112,142,177,189,195,43,57,189,107,17,47,61,7,99,255,60,59,112,167,61,255,32,49,60,55,168,130,61,99,235,125,61,32,200,234,60,11,92,193,60,133,188,137,61,237,17,5,189,28,162,25,188,28,73,169,61,168,250,183,188,133,243,81,61,65,145,152,188,79,170,161,60,146,99,163,188,94,150,220,189,166,68,2,61,77,75,84,59,172,122,175,188,99,85,46,189,168,1,67,61,19,109,47,61,64,217,102,61,140,66,153,188,162,241,98,61,85,65,249,188,190,110,110,60,60,201,135,189,194,92,111,189,102,45,25,189,57,117,199,189,151,230,3,189,225,51,102,189,113,156,212,189,107,142,151,61,240,216,137,59,55,120,5,61,20,115,12,59,181,203,81,61,145,201,80,188,16,92,195,60,173,192,129,61,17,232,161,189,102,136,171,61,0,197,161,189,110,75,133,189,43,172,204,188,120,218,133,61,20,162,34,61,180,132,72,61,39,159,63,188,160,11,35,189,41,191,104,61,252,180,114,61,136,1,63,188,41,139,162,189,21,102,44,189,120,143,90,60,86,94,185,61,31,210,206,61,24,201,34,189,210,245,74,60,186,162,153,189,17,186,21,189,202,48,48,189,228,194,188,61,136,12,243,57,55,144,233,60,105,136,175,60,65,121,6,57,106,231,235,60,66,52,175,189,37,51,70,189,195,156,166,61,160,201,107,189,68,167,103,60,150,99,13,61,46,145,135,189,199,28,250,188,217,158,242,60,193,60,151,189,96,18,58,60,208,109,88,61,77,75,159,189,26,165,172,188,136,194,97,189,162,248,9,190,0,59,248,60,191,170,137,61,6,185,126,189,182,170,110,189,102,24,128,61,190,56,237,60,156,80,136,188,99,73,20,189,236,19,132,188,37,126,191,186,81,127,15,62,151,212,18,188,77,33,5,189,184,236,93,59,160,134,45,59,88,157,9,61,30,151,197,188,236,63,45,189,120,113,218,61,42,78,213,192,11,181,150,62,143,85,202,189,106,161,4,190,65,73,161,61,240,105,198,62,33,231,133,62,9,113,21,62,101,252,123,61,60,75,168,62,124,153,104,62,218,31,136,189,212,155,177,189,58,205,66,61,223,140,218,61,226,57,27,61,170,69,228,61,23,239,199,188,175,10,156,62,229,100,130,62,20,203,141,189,93,24,169,61,83,203,22,62,123,104,167,62,25,118,24,62,204,98,98,61,123,49,180,189,42,0,134,62,118,226,18,62,215,164,219,60,217,237,115,62,46,173,70,62,210,197,102,61,197,203,211,188,39,21,13,189,224,99,32,190,34,25,82,62,212,73,182,61,157,42,15,190,223,25,205,189,161,243,26,189,193,115,239,188,209,231,99,189,14,47,8,61,44,68,135,188,72,248,30,62,37,64,125,62,145,95,255,189,194,77,70,189,90,217,126,189,214,84,70,62,126,225,149,59,1,165,97,61,2,159,191,61,178,188,43,62,91,154,43,62,176,201,154,60,152,108,92,62,109,26,251,61,141,98,185,61,29,170,137,189,162,210,72,189,243,2,204,189,120,155,119,62,67,87,194,189,91,122,52,190,129,92,226,58,74,179,9,190,176,229,213,61,143,168,80,61,214,57,166,61,134,198,147,61,138,33,249,61,73,16,46,59,12,144,152,190,8,203,8,190,112,65,118,189,129,120,189,189,246,152,72,189,129,147,173,189,5,111,56,190,140,16,30,189,36,181,176,61,5,222,9,190,93,165,219,189,81,20,8,62,14,244,16,62,68,105,127,62,73,102,5,62,146,3,246,188,44,240,149,61,141,156,5,188,86,70,163,60,40,209,146,61,82,73,157,57,229,242,159,188,161,248,177,188,71,232,39,189,178,217,177,189,44,157,143,61,54,203,117,62,245,219,135,62,223,250,48,61,144,193,42,62,182,75,187,61,14,131,121,61,244,111,23,189,193,116,186,189,117,148,163,61,69,14,97,62,126,229,33,62,42,254,15,190,140,49,48,189,49,152,255,61,2,213,191,61,183,94,211,61,64,76,194,61,174,242,164,61,29,4,13,62,106,107,36,62,228,74,45,190,244,24,101,60,213,119,158,62,195,46,138,187,140,74,106,189,207,18,132,189,20,117,102,60,44,214,184,62,16,174,128,62,106,218,165,189,60,249,52,189,81,164,123,61,210,28,25,189,142,90,161,189,8,229,253,60,162,207,135,61,125,89,26,61,22,251,27,62,76,196,187,189,151,198,143,61,165,21,95,62,222,60,21,61,28,152,156,189,91,238,204,59,10,101,193,189,126,139,30,62,48,186,188,188,37,176,73,190,91,121,201,188,135,191,54,62,141,94,77,189,49,35,60,189,14,248,124,186,29,118,223,61,131,23,61,61,173,50,35,190,249,192,14,188,135,49,41,61,146,235,198,61,21,86,106,189,123,76,132,189,175,8,158,61,31,101,52,62,72,164,13,62,130,169,134,61,7,240,214,189,58,232,146,60,110,134,11,62,138,5,62,188,105,138,64,61,102,247,164,61,30,136,140,61,191,98,173,61,28,97,17,189,214,2,187,189,149,158,41,189,186,188,121,61,61,183,208,189,226,146,163,189,182,20,176,189,254,215,185,188,228,103,163,61,199,213,200,189,101,167,95,189,165,104,37,61,172,1,154,62,129,176,3,62,146,61,194,61,216,45,66,61,160,137,208,61,141,67,125,61,69,13,38,190,87,118,81,190,45,9,16,189,5,197,207,61,181,82,136,188,181,84,222,188,14,158,9,190,205,62,15,188,234,146,209,61,13,56,235,61,222,1,30,60,88,169,128,61,255,8,115,62,9,223,43,62,188,91,89,61,173,78,78,188,113,198,48,61,124,15,23,59,63,31,133,61,4,116,31,189,160,193,166,188,206,255,27,62,141,12,50,61,91,125,245,188,62,234,47,189,204,10,5,61,112,67,140,61,21,0,227,189,124,127,227,189,197,85,229,61,100,202,7,187,112,65,182,187,27,213,169,61,106,106,217,59,82,127,221,189,41,151,198,60,10,20,177,189,244,112,66,190,98,75,143,188,11,13,68,62,173,193,251,187,5,220,3,190,183,183,27,189,159,142,7,190,179,67,188,61,168,55,163,61,54,148,218,189,47,223,250,187,206,227,48,62,67,169,61,60,78,236,33,60,44,131,170,61,21,56,217,188,221,6,21,62,65,158,29,62,190,106,5,190,142,30,223,189,157,244,254,61,54,204,80,187,20,203,205,189,57,39,118,60,110,219,119,189,239,89,215,60,150,150,177,189,123,17,45,190,242,180,156,61,232,244,92,62,210,255,50,61,41,205,6,190,81,49,78,188,182,15,57,189,238,9,242,189,79,87,119,190,219,78,43,190,111,183,164,188,250,40,163,188,173,138,208,189,38,85,219,189,198,20,44,188,233,16,56,61,121,59,66,62,113,84,94,62,172,196,60,189,5,78,54,61,90,130,76,62,238,120,19,189,82,128,24,190,238,206,90,60,190,80,160,189,96,116,249,60,225,155,102,61,208,152,201,188,88,113,170,61,245,215,203,61,115,131,33,189,143,54,14,190,89,162,179,59,78,151,197,188,216,214,15,190,195,242,135,189,31,187,139,188,65,183,23,60,154,149,109,189,121,91,233,188,196,90,124,189,244,51,245,59,193,27,34,190,177,77,26,190,63,169,54,189,174,73,215,189,252,113,59,189,207,219,216,187,91,10,200,188,131,19,241,189,41,118,244,189,225,41,52,190,157,132,146,189,110,196,243,61,195,17,228,61,167,116,48,61,197,231,14,61,91,120,190,61,187,123,0,60,181,250,106,61,92,228,222,189,67,198,163,189,132,128,108,62,245,132,165,60,171,236,59,60,6,128,202,61,158,123,207,61,115,133,247,188,124,154,147,188,204,236,115,189,215,104,217,189,83,32,179,60,158,98,21,189,199,241,163,61,162,156,40,61,146,36,168,189,84,26,241,61,236,161,253,60,43,79,96,189,171,61,172,189,151,60,62,190,244,26,123,189,54,3,28,189,93,197,226,189,82,44,135,190,200,7,157,61,95,236,157,189,140,242,12,190,1,104,20,61,92,85,142,62,40,153,156,60,190,165,220,61,134,117,19,62,108,118,164,61,102,50,92,62,250,99,106,62,142,234,148,61,115,71,159,61,164,26,246,61,120,67,154,61,150,120,128,61,191,213,250,61,157,188,72,189,177,222,40,62,75,89,38,62,145,241,40,61,220,13,34,60,134,89,200,189,228,131,30,189,30,163,188,188,12,205,245,189,167,62,80,62,248,111,126,62,203,103,25,62,37,150,20,189,99,154,169,189,192,5,185,189,255,90,222,188,214,2,155,189,172,255,163,190,111,18,3,186,38,198,18,190,23,71,133,189,39,108,63,190,24,122,4,62,96,115,238,61,77,15,58,62,198,134,46,62,8,116,214,62,5,139,235,62,55,221,170,62,32,12,108,62,0,225,67,61,175,33,56,189,172,112,139,189,21,139,15,62,58,150,55,189,215,52,175,61,186,103,189,61,1,190,219,189,91,206,5,190,141,150,83,190,238,179,234,61,186,191,162,190,126,1,157,189,235,110,30,61,236,219,89,62,42,142,131,188,8,144,1,190,72,135,39,190,156,50,87,62,142,145,204,61,23,102,1,190,125,151,242,61,232,45,158,60,141,9,177,188,69,161,197,189,30,252,228,189,253,76,77,190,82,72,18,62,8,85,106,62,196,233,180,190,92,115,55,190,170,70,239,61,34,57,129,62,56,245,1,189,118,166,64,190,95,208,34,190,88,230,197,62,73,128,250,61,143,251,86,62,98,189,201,62,200,210,183,62,179,124,133,62,76,108,46,62,169,46,96,60,176,4,18,190,92,31,214,188,241,155,66,188,167,33,26,190,204,41,65,61,82,67,219,189,34,226,22,190,140,49,64,190,221,125,62,190,137,10,85,190,36,124,111,61,168,142,149,189,188,59,114,190,228,103,163,189,166,185,21,190,194,223,111,189,91,150,207,189,151,2,146,189,53,153,145,189,59,115,239,61,99,237,111,62,102,18,157,62,159,203,164,62,143,194,117,62,221,9,150,61,67,113,71,188,125,234,216,60,52,130,77,61,50,29,42,62,46,115,106,62,25,144,125,61,13,55,32,62,11,239,82,62,226,34,247,61,80,252,24,61,201,233,43,62,219,135,148,62,52,128,215,62,109,116,78,188,40,101,66,62,148,221,156,62,201,114,242,61,226,200,195,189,123,49,148,189,8,173,7,190,39,164,101,190,166,11,1,190,182,18,186,60,143,109,145,62,77,104,82,61,235,1,115,186,29,148,112,189,128,181,170,189,227,164,16,190,114,20,64,190,118,136,79,190,119,77,72,61,237,131,124,62,222,59,226,62,166,94,175,62,73,44,137,61,239,115,92,62,36,181,64,62,145,242,147,189,45,35,85,190,154,93,247,188,152,106,54,62,204,69,12,62,239,168,49,189,193,113,57,190,129,9,188,61,53,238,237,61,6,187,1,190,182,243,197,190,31,128,188,62,230,205,137,62,93,79,180,189,54,30,236,188,86,98,190,61,68,107,197,60,240,223,60,61,134,255,52,62,0,28,11,62,104,232,255,61,128,40,72,62,231,113,24,189,239,58,43,62,247,120,65,62,45,64,91,61,34,81,136,189,40,238,8,62,98,132,144,189,238,91,237,61,236,23,28,62,7,154,239,189,15,126,226,189,22,77,55,190,217,118,218,60,234,236,164,61,164,197,153,61,102,46,144,189,56,192,76,60,173,252,178,60,75,30,15,190,73,99,180,188,117,57,197,189,154,6,133,189,52,129,2,190,144,50,98,188,65,212,221,189,45,9,32,62,188,118,25,62,145,123,58,188,90,41,132,61,187,241,238,60,73,103,224,60,67,199,142,61,181,108,29,62,47,135,29,61,74,64,108,62,81,247,129,62,87,205,115,61,127,137,56,189,98,188,102,60,115,158,145,61,58,203,140,61,103,96,196,61,93,26,191,59,66,93,20,62,163,234,215,60,132,243,137,189,174,215,52,189,204,123,252,189,101,28,163,188,158,66,174,59,114,168,223,61,222,199,81,187,128,11,178,188,0,111,17,62,138,6,137,189,67,231,245,189,149,42,65,190,92,87,76,60,216,125,71,189,195,154,74,188,141,67,61,190,30,163,44,62,251,201,136,62,131,107,110,61,64,163,52,189,76,55,9,61,233,215,54,62,79,30,214,61,74,182,250,61,215,51,164,61,102,103,49,62,215,217,152,62,34,109,131,61,208,182,90,61,114,134,50,62,18,135,108,62,206,170,239,61,88,59,42,62,108,63,105,62,49,9,247,61,232,50,53,62,181,169,58,188,0,30,177,189,229,126,7,188,97,195,83,61,195,12,29,190,17,255,112,189,223,22,108,189,37,59,118,189,220,217,215,60,86,154,36,190,189,54,27,189,148,246,70,189,36,38,40,61,58,36,181,188,74,65,119,61,99,155,84,61,142,143,38,62,237,215,13,62,201,142,77,189,142,147,194,187,66,6,146,61,30,192,2,62,83,90,127,61,152,221,19,62,79,175,148,61,207,50,75,62,213,32,124,62,117,31,160,189,242,37,20,189,73,131,155,61,1,219,65,61,187,214,94,188,137,152,178,61,83,5,163,60,56,48,185,60,123,189,123,188,201,115,189,189,199,41,154,61,4,86,238,189,23,217,78,61,167,205,56,61,138,144,42,62,2,155,147,61,149,71,119,61,176,232,6,62,145,240,45,190,144,47,33,189,174,128,66,189,46,2,35,189,42,55,81,190,43,217,177,60,181,140,4,62,0,115,173,188,247,147,49,62,114,252,144,189,24,11,131,189,27,185,142,61,86,70,131,189,206,80,252,189,185,79,142,188,187,213,83,190,46,227,134,61,8,227,231,61,86,102,202,60,59,27,146,189,108,36,137,189,250,69,201,189,223,223,128,189,0,82,155,61,97,27,113,60,157,190,158,60,63,226,7,62,115,241,151,189,169,105,183,189,76,168,160,189,75,58,74,190,61,213,49,190,70,97,87,61,225,179,53,61,97,140,232,61,44,182,201,61,226,120,158,61,182,157,54,188,25,55,69,190,166,97,40,190,131,165,58,61,194,162,82,62,79,120,73,61,241,130,168,189,105,28,10,62,115,243,61,62,155,58,15,61,102,220,244,189,75,35,230,189,213,180,235,189,37,91,93,189,67,58,60,190,229,242,159,189,141,69,67,62,178,161,187,61,78,126,139,59,44,125,40,189,36,182,123,189,126,253,16,190,3,124,71,190,14,17,247,189,93,55,165,60,183,155,224,61,246,7,138,61,206,168,121,188,109,226,116,190,245,130,135,190,199,158,61,190,186,187,78,61,21,86,170,60,24,35,18,61,219,24,187,60,160,55,85,189,11,10,3,190,60,134,231,189,226,229,105,190,104,61,132,190,193,224,90,189,48,132,156,61,255,178,123,61,111,45,115,62,248,27,109,59,179,210,100,189,184,92,221,189,74,13,237,188,86,183,58,61,57,99,88,61,146,206,192,186,151,253,186,60,110,250,115,61,101,223,213,189,163,61,158,189,152,247,88,190,250,42,89,190,114,251,229,60,38,85,155,61,45,62,133,60,156,195,37,62,87,180,9,62,27,100,18,60,164,198,68,189,31,248,152,61,15,123,161,59,245,19,206,188,195,128,69,62,69,100,152,61,31,18,158,62,167,232,136,62,32,240,192,61,149,16,172,187,47,51,44,61,159,173,3,189,208,100,127,60,12,120,129,62,94,130,51,62,1,136,187,60,44,68,167,61,50,115,129,61,110,135,38,62,156,23,71,62,220,128,111,62,35,75,134,62,148,106,63,62,156,49,172,61,115,161,146,190,150,37,90,190,195,40,72,189,47,167,84,190,150,33,46,190,28,64,63,60,196,96,190,189,177,105,69,190,233,12,140,190,25,114,108,62,25,145,136,62,17,27,164,62,179,36,152,62,206,84,12,63,189,30,156,62,26,223,7,62,221,68,125,62,116,150,89,62,97,254,138,190,249,131,17,190,191,41,44,187,254,38,244,189,213,118,3,62,56,246,204,61,162,122,107,189,193,167,249,189,170,98,106,190,162,37,79,62,238,177,204,190,113,30,190,190,170,69,196,189,89,78,130,189,125,63,37,190,252,82,159,190,162,239,150,190,212,238,119,62,117,34,65,60,199,187,195,61,188,33,165,62,242,7,3,63,135,80,165,62,124,99,160,62,175,125,49,62,175,151,38,59,83,35,244,188,187,71,166,62,193,255,166,190,45,92,174,190,95,155,13,190,228,46,66,187,74,152,233,189,10,47,193,190,137,152,226,190,114,139,89,62,54,63,254,187,67,169,61,188,184,200,45,62,124,12,158,62,112,123,162,62,119,21,10,63,169,106,170,62,233,211,106,61,245,161,139,189,59,226,208,61,146,179,136,62,133,153,86,62,62,34,182,62,34,171,187,61,223,82,46,62,92,56,0,62,234,93,140,62,20,209,143,61,213,4,209,60,45,148,76,61,224,45,16,186,128,14,51,61,75,63,17,190,9,193,170,60,231,252,4,62,129,95,131,62,27,18,215,61,46,230,23,62,67,199,46,62,51,221,235,60,182,160,151,61,13,226,35,62,30,110,207,62,114,24,124,62,81,78,180,62,126,1,45,62,233,152,99,62,140,100,135,62,44,14,135,61,192,235,179,60,164,197,153,189,214,173,190,61,0,202,223,60,53,121,202,61,83,202,107,61,228,106,164,189,7,121,61,62,135,251,160,62,68,222,170,62,49,209,0,62,160,255,150,62,14,162,197,62,132,215,94,62,225,235,59,190,139,167,142,190,61,124,25,187,222,232,227,188,7,125,9,190,83,231,169,190,242,235,7,188,105,27,255,61,29,1,92,61,170,239,188,190,60,162,194,189,249,103,86,62,18,247,216,62,84,87,190,62,172,230,217,61,12,35,189,62,157,161,248,62,244,191,108,62,113,3,14,190,100,203,178,190,173,135,143,189,137,126,237,60,161,45,167,189,119,191,202,190,97,80,22,190,127,21,224,188,195,213,129,61,6,131,139,190,239,202,110,61,120,41,173,62,207,217,226,61,35,159,87,189,218,117,111,190,161,218,224,188,109,114,248,60,68,78,31,62,217,39,192,189,12,92,158,60,14,17,247,61,31,45,206,59,11,66,217,189,1,246,113,190,190,80,16,190,121,92,180,189,53,238,205,188,128,101,85,190,146,233,208,188,17,167,19,62,204,13,70,189,7,98,217,189,210,56,156,190,231,197,233,189,207,74,186,61,213,203,167,62,153,215,17,61,52,15,192,189,102,188,45,59,220,47,47,190,106,165,64,190,202,196,93,190,147,30,86,190,162,212,94,189,37,235,32,62,0,254,105,189,49,93,136,61,104,66,19,60,229,183,40,61,188,33,13,61,40,68,160,189,195,101,85,61,144,46,182,188,86,45,137,61,83,174,240,189,181,194,148,189,75,6,128,61,0,227,25,61,66,179,107,189,133,237,159,190,237,185,12,61,134,57,1,189,86,42,40,59,29,90,84,190,11,179,144,189,25,229,153,188,239,143,55,189,208,241,81,188,169,77,156,189,105,30,160,61,179,153,195,60,151,198,239,61,182,157,182,60,171,90,82,190,115,133,119,189,87,176,141,188,208,43,158,187,213,94,164,190,195,187,188,189,140,19,31,61,164,228,149,61,65,68,138,189,145,66,217,60,90,18,48,62,200,211,178,61,161,74,13,61,232,160,11,189,168,29,30,62,18,159,123,189,77,161,243,59,64,133,227,189,17,143,196,189,60,132,113,60,241,127,7,190,163,205,241,188,151,197,68,190,237,17,202,61,18,21,170,60,152,76,53,62,210,29,132,189,85,249,94,189,88,88,112,189,34,136,243,186,220,159,43,62,176,230,128,60,134,145,94,61,198,250,134,60,169,218,62,62,164,196,46,188,184,4,96,61,168,200,1,62,40,73,87,60,254,10,185,61,137,208,8,190,99,152,147,188,40,72,28,190,101,25,226,60,95,7,14,190,28,236,77,189,197,229,56,61,61,41,243,189,238,36,194,61,165,160,43,190,162,153,199,61,49,154,21,188,212,183,76,62,93,253,88,189,156,253,33,62,136,218,54,62,100,93,220,189,29,115,30,60,241,45,172,189,147,229,36,189,241,155,82,190,132,184,210,61,17,224,100,62,38,229,46,61,75,201,242,61,208,70,174,188,101,82,227,61,10,216,30,190,185,226,226,60,54,145,25,190,49,40,83,61,252,81,4,190,71,176,49,62,162,126,151,61,3,149,65,190,253,103,13,189,240,109,218,189,36,9,66,188,63,30,74,190,205,173,96,62,255,151,59,62,203,243,96,189,21,111,20,62,218,146,21,61,125,236,174,189,83,145,106,190,183,40,19,190,213,177,74,189,170,100,32,62,51,25,14,188,84,170,132,189,249,163,168,61,78,43,21,62,65,215,62,59,246,41,87,190,27,185,238,189,73,157,160,61,181,53,98,62,185,110,138,189,72,27,71,61,88,230,173,61,234,148,135,189,68,110,230,189,80,254,94,190,41,63,169,189,206,167,142,188,151,202,107,62,131,221,144,189,72,81,135,61,18,108,92,62,195,186,145,61,102,160,178,189,177,22,79,190,183,67,67,188,41,231,203,61,192,232,50,62,43,193,130,189,175,235,247,189,145,99,107,60,222,228,7,62,91,206,165,187,255,121,122,190,113,1,56,190,45,236,9,190,183,95,190,60,51,192,69,190,18,165,157,189,32,96,173,188,125,4,254,186,237,186,39,190,21,57,228,189,35,105,87,190,120,94,42,190,54,90,14,61,9,110,36,60,72,139,179,188,237,74,139,61,245,244,177,189,218,228,128,190,163,202,136,190,235,30,25,61,56,245,129,59,191,129,9,61,100,36,27,190,65,97,208,60,219,247,168,188,175,237,157,190,112,176,175,190,98,244,188,189,79,33,215,188,198,51,232,188,124,154,19,61,95,13,16,61,201,147,4,62,157,70,250,61,127,75,128,60,6,157,144,189,169,49,193,189,216,71,135,189,166,70,40,189,43,247,34,62,126,225,149,61,192,94,225,61,135,168,50,62,164,226,159,61,112,207,115,188,249,248,4,60,144,106,88,60,234,90,155,61,173,76,72,62,51,112,128,61,254,43,139,61,174,154,103,61,15,154,29,190,166,38,17,190,24,149,148,189,106,79,9,61,65,14,202,188,246,182,9,62,153,242,161,61,122,196,8,62,196,148,104,62,251,229,147,60,15,123,161,59,206,56,45,62,105,110,133,61,159,200,147,61,71,202,6,62,130,58,197,61,24,93,94,61,191,156,217,61,47,196,234,61,50,202,243,61,38,228,3,63,7,94,125,62,201,233,75,62,65,11,89,62,144,158,2,62,210,224,150,190,63,145,71,190,56,192,76,189,193,225,229,189,35,18,5,188,11,96,202,187,3,178,23,61,148,21,227,189,30,253,127,190,169,23,28,62,125,64,112,62,41,5,29,62,57,213,178,62,77,220,46,63,57,242,32,62,54,174,255,61,209,7,203,61,209,231,131,61,146,92,126,190,254,12,31,190,85,18,217,188,55,26,192,188,180,233,72,61,224,218,233,189,9,196,235,59,157,17,53,190,114,252,192,190,49,121,187,62,171,65,56,190,123,18,24,190,92,4,198,59,16,33,46,62,248,109,200,61,92,62,210,189,21,87,133,190,65,215,126,62,60,161,23,61,46,228,241,189,189,26,160,61,195,212,70,62,94,102,88,62,182,186,188,62,233,240,184,62,33,34,5,62,220,215,193,61,127,218,104,62,214,84,54,190,211,18,235,189,129,152,4,188,60,160,108,62,36,9,66,188,181,136,200,189,175,205,166,190,187,72,17,62,50,57,245,61,14,245,107,190,95,121,240,189,12,201,233,189,45,64,27,61,54,90,238,61,8,6,96,62,143,168,208,189,159,146,115,61,247,59,244,61,221,40,50,60,171,208,0,189,77,102,60,61,98,158,245,61,69,42,140,62,36,151,159,62,221,9,134,62,3,124,71,62,17,254,173,62,30,50,117,62,213,91,131,61,45,235,158,61,106,190,202,61,148,250,18,62,79,8,61,62,241,160,25,61,230,231,102,62,25,230,196,61,41,232,22,190,45,210,84,190,145,239,50,190,196,237,176,189,166,129,31,189,39,104,35,62,75,59,181,189,85,161,129,186,216,127,221,61,68,23,212,188,142,234,148,189,169,247,212,60,179,235,222,187,158,237,177,189,177,249,56,188,149,212,137,190,152,221,211,189,208,208,255,189,170,67,238,189,161,218,16,62,171,207,85,62,54,33,45,61,137,178,135,62,164,55,4,63,45,208,94,62,163,92,154,188,135,108,160,190,90,103,44,190,87,10,65,61,148,77,185,61,22,250,224,189,171,176,153,188,157,185,87,62,126,2,144,62,122,140,50,189,186,221,11,189,129,122,115,190,73,20,10,190,235,112,148,189,89,165,212,189,34,26,29,61,79,3,158,62,87,147,23,62,9,223,59,189,127,217,253,189,175,235,87,190,144,16,133,189,179,183,20,189,1,105,63,189,246,8,181,188,53,38,196,61,228,159,209,62,104,92,120,61,123,133,133,189,153,73,84,61,105,56,229,60,17,111,29,188,64,252,12,190,33,149,194,189,67,4,156,188,93,136,53,62,54,228,31,60,227,168,188,189,129,235,138,188,153,18,9,190,182,134,242,189,84,59,3,189,207,158,203,187,213,35,173,189,58,3,131,61,158,209,150,189,248,166,41,62,241,47,226,61,181,194,52,61,22,190,62,61,182,72,90,61,81,48,99,189,11,38,126,60,214,111,190,62,38,172,109,62,26,162,138,188,241,242,212,61,158,235,187,189,130,143,193,59,79,30,86,62,30,54,33,62,226,0,250,60,249,47,128,62,90,69,127,61,182,103,22,61,126,229,193,61,80,197,141,60,198,54,41,188,11,209,161,189,79,120,137,60,82,68,230,189,193,28,125,61,146,65,46,61,153,215,1,190,47,110,35,188,44,125,104,189,24,39,62,61,149,98,71,190,157,190,14,190,210,139,26,189,222,199,33,62,202,53,133,188,78,156,252,61,181,24,108,62,49,153,170,61,132,72,134,188,135,252,115,61,213,91,131,188,144,164,132,189,253,130,109,62,90,99,32,62,212,186,13,61,130,31,21,62,235,57,41,61,146,116,13,61,213,145,163,60,51,168,182,189,84,25,70,188,111,159,157,62,141,122,88,62,164,139,205,188,150,206,23,190,61,125,4,190,42,31,130,61,187,127,140,189,167,36,139,189,54,201,15,189,88,228,87,62,209,174,130,61,105,138,128,61,185,23,184,189,98,76,250,188,243,85,114,60,29,146,90,189,12,231,26,189,255,91,73,190,210,109,9,60,128,70,169,189,70,125,18,62,77,134,131,61,174,240,142,61,253,159,67,62,60,80,199,61,57,240,234,188,226,57,155,61,185,85,160,62,153,158,176,61,94,160,84,62,46,228,145,60,178,161,251,61,223,249,101,62,177,107,43,62,97,168,195,188,39,74,66,61,178,44,176,62,58,64,64,62,252,113,11,62,196,35,17,62,13,169,130,61,61,70,57,61,124,101,158,189,176,3,103,187,130,0,41,190,165,216,209,188,158,7,151,189,178,98,40,62,52,128,55,60,195,101,21,190,201,255,228,188,21,230,125,189,235,82,35,189,156,51,18,190,193,170,26,62,115,159,28,189,233,181,89,61,231,0,161,61,192,64,176,61,180,3,206,61,126,30,3,62,152,107,145,189,246,181,238,189,155,114,85,62,142,63,81,61,221,95,157,61,13,251,189,60,169,161,173,189,216,42,65,188,184,90,23,62,143,224,70,189,46,85,233,189,149,15,145,62,52,132,67,62,41,8,190,61,226,61,7,61,165,216,17,190,71,230,17,190,146,204,202,189,150,4,40,189,28,37,47,189,145,44,80,62,154,8,91,189,202,196,45,61,232,47,100,62,29,4,157,188,74,95,8,190,47,108,141,190,86,16,3,189,189,53,240,61,72,24,54,62,64,166,117,189,129,152,132,189,171,178,239,189,172,54,31,190,233,214,203,189,86,15,40,62,54,148,218,188,117,31,192,189,149,186,116,62,73,48,213,187,102,73,0,60,29,204,134,61,202,135,80,190,196,177,206,189,51,194,91,189,146,232,5,190,221,66,215,60,136,245,6,62,122,28,6,61,12,61,2,62,68,253,238,61,42,253,36,190,104,62,143,190,165,73,129,190,76,226,44,187,163,91,47,61,127,50,198,61,58,122,252,189,69,212,132,61,115,75,43,188,196,8,97,190,48,19,117,190,69,188,213,189,122,168,109,189,229,122,91,189,41,206,209,60,44,17,168,59,244,167,205,189,130,60,59,189,131,21,71,190,23,102,1,190,13,26,250,188,137,149,81,61,91,36,93,62,38,138,48,62,27,13,96,189,121,117,62,190,52,133,142,190,117,87,70,190,13,27,37,189,231,198,116,59,124,155,254,187,238,10,253,61,73,190,66,62,84,87,158,189,252,112,240,61,120,13,90,62,189,58,71,60,106,250,236,56,67,229,223,60,218,170,36,61,62,94,8,61,91,180,96,62,28,152,60,62,100,201,132,62,101,86,159,62,103,14,169,61,147,24,68,189,24,153,160,189,254,15,48,60,173,52,169,61,108,181,159,62,103,126,157,62,99,42,125,59,138,89,175,60,166,43,216,188,117,85,160,188,149,155,168,60,34,28,115,189,34,110,206,60,155,203,133,62,113,198,176,61,140,15,19,62,195,187,220,61,36,151,127,59,37,235,64,190,60,244,29,189,31,46,217,189,95,40,0,190,241,45,44,188,32,69,93,61,237,240,119,62,3,237,142,62,23,184,92,62,84,169,177,62,225,183,225,62,158,38,115,62,17,198,111,62,88,113,154,62,185,251,44,62,205,91,85,190,113,228,1,190,143,25,40,60,73,216,247,61,9,249,128,189,37,119,88,189,93,50,78,61,36,71,122,189,84,112,136,190,85,132,219,61,24,150,15,62,174,100,143,62,48,102,147,62,207,19,191,62,251,59,27,62,45,181,94,60,21,200,236,61,242,119,111,60,75,60,144,190,161,76,115,190,155,61,240,189,57,155,14,184,79,5,12,190,80,252,72,190,83,5,195,189,68,81,0,190,95,67,128,190,191,124,114,62,128,14,147,189,195,70,25,189,210,140,69,61,59,168,164,62,126,81,130,61,112,237,196,60,84,168,238,188,207,134,108,62,126,114,36,62,61,15,30,190,170,102,86,188,209,177,163,189,225,237,193,61,138,61,36,62,147,144,56,62,1,193,92,61,188,90,206,61,113,199,147,62,43,110,28,61,120,13,58,62,194,49,107,62,112,93,225,62,98,216,129,61,189,141,205,59,20,237,170,60,110,105,173,62,106,50,131,62,204,236,51,189,155,200,236,61,180,1,88,59,226,35,50,62,22,163,174,60,130,172,39,189,159,146,243,189,211,193,58,62,137,149,113,62,217,10,90,189,220,160,118,188,249,246,206,189,36,66,195,61,197,89,81,61,7,183,37,62,66,150,5,61,235,82,35,62,88,57,148,61,114,135,205,60,42,139,194,60,20,206,238,60,162,39,37,62,156,21,241,189,4,61,20,189,212,16,53,190,231,228,37,190,160,250,103,62,244,106,160,189,155,115,48,61,115,16,244,189,238,178,95,61,116,152,207,189,18,46,132,189,129,36,236,189,1,106,10,62,192,5,153,62,174,211,200,61,7,38,183,61,101,169,245,187,173,20,226,61,79,32,236,188,41,174,170,60,203,191,22,189,190,107,0,62,44,183,68,62,223,107,72,189,125,62,74,59,92,255,46,188,68,251,152,61,252,57,133,188,174,188,196,61,136,218,118,61,231,115,238,187,116,122,14,62,246,35,165,189,62,7,22,61,45,63,176,61,129,37,7,62,39,135,175,61,11,68,207,60,47,133,103,62,231,110,71,62,145,210,44,61,98,162,33,190,89,22,140,189,69,216,16,190,195,185,230,189,204,69,156,189,112,124,141,189,229,38,234,189,255,231,208,189,154,93,7,62,81,77,137,189,165,103,218,61,56,189,75,62,27,188,47,62,45,64,43,62,120,40,10,189,77,45,219,188,125,65,171,61,200,11,25,62,109,111,55,187,61,185,166,185,168,143,64,60,208,240,134,61,61,10,183,189,219,51,75,189,10,248,101,62,194,190,93,62,177,251,14,189,67,60,146,188,215,132,180,189,56,190,246,59,209,8,118,62,149,14,150,61,14,77,89,60,223,135,51,62,149,243,69,60,103,127,192,61,91,97,122,60,251,201,216,61,220,41,221,61,143,84,159,61,174,242,196,189,255,8,163,189,114,22,54,62,53,207,17,62,97,140,8,61,229,242,159,189,74,38,167,189,187,123,64,189,87,206,14,62,119,17,166,60,214,59,252,189,183,121,51,62,3,124,215,61,196,208,106,61,158,179,165,61,144,162,78,188,103,210,198,189,19,15,168,61,10,19,198,189,3,233,130,189,174,186,78,62,243,61,3,62,163,145,15,189,117,0,4,189,118,140,139,189,216,100,237,189,78,185,194,61,112,36,176,189,252,83,138,189,243,29,252,60,5,253,5,61,154,36,182,61,109,143,94,61,114,23,33,189,94,132,233,189,201,202,47,62,141,8,230,189,152,222,94,190,61,128,133,61,100,172,118,61,67,201,68,62,219,167,99,61,234,64,6,190,87,205,19,190,183,93,104,61,237,40,14,189,74,38,167,189,143,139,10,190,216,244,32,186,37,144,178,61,143,111,111,60,4,171,138,61,13,140,220,61,223,50,103,62,118,197,172,61,34,252,11,188,231,141,83,61,147,30,70,189,54,148,26,189,13,171,120,189,187,238,45,59,69,187,138,60,167,59,175,61,165,192,130,188,162,209,157,188,27,241,228,61,250,125,127,61,18,222,78,62,181,110,67,61,223,25,45,61,67,199,142,61,47,190,120,62,62,117,172,60,117,30,149,189,126,169,31,190,79,144,216,188,83,231,17,61,10,104,162,189,183,210,235,188,161,244,69,189,161,128,173,61,1,19,120,189,31,133,171,189,71,3,40,190,21,225,38,189,150,147,176,189,55,51,122,60,81,134,170,187,32,98,131,188,143,169,59,61,213,146,78,189,3,8,159,189,216,214,239,61,117,119,29,60,123,49,20,188,159,117,13,188,205,206,98,189,254,15,176,189,117,177,233,60,219,50,96,189,134,31,44,190,36,15,52,62,237,211,145,61,20,91,193,188,95,68,27,61,113,116,149,187,240,106,185,188,27,155,253,61,247,120,193,61,21,87,149,189,115,217,8,190,121,230,101,188,27,46,18,190,2,45,221,188,223,49,76,190,7,98,89,60,206,111,104,62,57,69,71,61,122,23,47,190,166,96,77,189,30,27,1,60,226,117,125,61,119,73,156,60,216,126,50,189,164,55,28,189,174,12,10,62,209,148,93,61,154,66,167,189,5,21,53,62,195,71,68,61,112,94,28,189,134,118,78,61,182,129,219,189,74,153,20,189,239,172,221,60,193,26,167,61,192,207,56,187,188,91,185,61,109,141,8,189,185,0,116,189,115,156,91,60,102,131,204,189,137,67,150,61,35,132,175,62,34,84,201,61,39,136,26,190,230,146,170,188,228,78,105,189,57,125,61,61,212,209,49,189,160,253,24,190,26,52,4,190,184,145,50,188,192,32,105,188,141,68,56,190,157,131,231,189,245,158,74,189,174,43,134,189,244,222,184,61,233,71,67,188,155,232,179,61,177,48,196,61,81,162,21,62,35,19,208,61,17,225,159,61,165,190,172,189,217,205,204,189,15,240,164,188,2,126,77,189,163,115,126,61,156,220,111,60,200,209,156,60,29,174,21,61,36,68,57,62,152,251,100,188,169,189,136,189,85,222,142,186,214,55,144,189,121,144,158,187,222,33,197,186,12,62,13,61,175,33,56,189,31,45,78,189,215,135,181,189,13,250,50,190,102,188,237,189,109,112,82,190,158,96,127,60,242,119,47,189,127,104,198,189,42,142,19,190,210,229,77,189,228,132,73,190,105,138,224,61,98,246,138,62,205,230,49,62,206,83,221,61,5,49,32,62,104,121,254,61,208,38,199,61,240,107,116,62,66,233,171,61,113,114,223,61,135,80,101,62,222,204,136,62,130,86,224,60,94,130,211,60,90,18,0,62,181,249,191,61,48,73,37,61,56,74,30,61,125,145,80,188,64,133,19,62,45,206,88,61,141,183,21,188,97,109,172,61,88,30,36,62,101,111,41,189,33,206,67,60,174,184,248,189,88,140,218,189,145,212,66,189,223,138,68,61,184,172,130,190,181,226,155,189,92,27,202,61,29,119,26,190,27,161,47,190,33,89,32,190,125,236,110,61,42,254,63,62,24,119,211,62,80,228,13,63,129,150,190,62,84,167,115,62,21,31,255,61,81,250,226,61,155,29,41,60,25,170,50,190,6,128,138,189,28,178,1,187,201,87,18,62,10,73,38,61,1,20,163,60,91,176,212,60,47,134,50,189,87,66,247,189,197,171,204,61,36,125,186,61,12,62,125,62,159,32,81,62,197,29,47,189,172,115,140,189,82,183,243,189,25,232,218,60,5,194,14,61,238,149,121,189,12,62,205,188,106,132,190,189,59,226,16,189,87,206,110,190,112,67,76,189,205,92,32,189,115,130,182,188,243,229,133,189,67,5,17,193,0,0,0,0,176,71,0,0,164,2,0,0,165,2,0,0,3,0,0,0,161,0,0,0,162,0,0,0,1,0,0,0,3,0,0,0,4,0,0,0,1,0,0,0,163,0,0,0,18,0,0,0,164,0,0,0,19,0,0,0,165,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,4,0,0,0,5,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,20,0,0,0,166,0,0,0,21,0,0,0,167,0,0,0,9,0,0,0,9,0,0,0,120,28,30,0,148,66,5,0,91,66,5,0,114,3,0,0,1,0,0,0,124,28,30,0,252,66,5,0,91,66,5,0,114,3,0,0,1,0,0,0,128,28,30,0,100,67,5,0,91,66,5,0,114,3,0,0,1,0,0,0,132,28,30,0,212,67,5,0,91,66,5,0,114,3,0,0,1,0,0,0,136,28,30,0,156,68,5,0,91,66,5,0,74,3,0,0,1,0,0,0,0,0,0,0,192,71,0,0,17,0,0,0,166,2,0,0,168,0,0,0,0,0,0,0,208,71,0,0,8,0,0,0,167,2,0,0,168,2,0,0,140,28,30,0,179,70,5,0,92,70,5,0,46,0,0,0,1,0,0,0,144,28,30,0,235,70,5,0,92,70,5,0,113,0,0,0,1,0,0,0,0,0,0,0,224,71,0,0,17,0,0,0,169,2,0,0,169,0,0,0,148,28,30,0,246,77,5,0,194,77,5,0,183,0,0,0,1,0,0,0,152,28,30,0,210,78,5,0,194,77,5,0,191,2,0,0,1,0,0,0,0,0,0,0,0,72,0,0,1,0,0,0,170,2,0,0,3,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,3,0,0,0,4,0,0,0,52,0,0,0,170,0,0,0,171,0,0,0,22,0,0,0,172,0,0,0,173,0,0,0,174,0,0,0,23,0,0,0,175,0,0,0,10,0,0,0,10,0,0,0,0,0,0,0,240,71,0,0,8,0,0,0,171,2,0,0,172,2,0,0,156,28,30,0,126,82,5,0,194,77,5,0,203,4,0,0,1,0,0,0,160,28,30,0,94,84,5,0,194,77,5,0,212,5,0,0,1,0,0,0,168,28,30,0,197,86,5,0,117,85,5,0,165,4,0,0,1,0,0,0,0,0,0,0,64,72,0,0,1,0,0,0,173,2,0,0,3,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,3,0,0,0,4,0,0,0,38,0,0,0,174,2,0,0,24,0,0,0,176,0,0,0,11,0,0,0,11,0,0,0,25,0,0,0,177,0,0,0,26,0,0,0,178,0,0,0,27,0,0,0,179,0,0,0,28,0,0,0,180,0,0,0,12,0,0,0,12,0,0,0,29,0,0,0,181,0,0,0,0,0,0,0,48,72,0,0,8,0,0,0,175,2,0,0,176,2,0,0,164,28,30,0,242,85,5,0,117,85,5,0,75,4,0,0,1,0,0,0,41,92,15,62,41,92,15,62,102,247,228,62,102,247,228,62,102,247,228,62,0,0,0,0,32,73,0,0,8,0,0,0,177,2,0,0,178,2,0,0,0,0,0,0,16,73,0,0,8,0,0,0,179,2,0,0,180,2,0,0,0,0,0,0,0,73,0,0,8,0,0,0,181,2,0,0,182,2,0,0,0,0,0,0,240,72,0,0,8,0,0,0,183,2,0,0,184,2,0,0,0,0,0,0,224,72,0,0,8,0,0,0,185,2,0,0,186,2,0,0,0,0,0,0,208,72,0,0,8,0,0,0,187,2,0,0,188,2,0,0,0,0,0,0,192,72,0,0,8,0,0,0,189,2,0,0,190,2,0,0,0,0,0,0,176,72,0,0,8,0,0,0,191,2,0,0,192,2,0,0,0,0,0,0,160,72,0,0,8,0,0,0,193,2,0,0,194,2,0,0,0,0,0,0,144,72,0,0,8,0,0,0,195,2,0,0,196,2,0,0,0,0,0,0,128,72,0,0,8,0,0,0,197,2,0,0,198,2,0,0,0,0,0,0,112,72,0,0,8,0,0,0,199,2,0,0,200,2,0,0,196,28,30,0,251,91,5,0,182,90,5,0,73,3,0,0,1,0,0,0,0,0,0,0,48,73,0,0,201,2,0,0,202,2,0,0,10,0,0,0,1,0,0,0,76,0,0,0,39,0,0,0,4,0,0,0,5,0,0,0,2,0,0,0,30,0,0,0,7,0,0,0,23,0,0,0,3,0,0,0,24,0,0,0,200,28,30,0,148,92,5,0,182,90,5,0,107,3,0,0,1,0,0,0,0,0,0,0,64,73,0,0,203,2,0,0,204,2,0,0,31,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,32,0,0,0,28,0,0,0,33,0,0,0,34,0,0,0,29,0,0,0,182,0,0,0,0,0,0,0,80,73,0,0,205,2,0,0,206,2,0,0,30,0,0,0,31,0,0,0,32,0,0,0,12,0,0,0,183,0,0,0,184,0,0,0,207,2,0,0,0,0,0,0,96,73,0,0,208,2,0,0,209,2,0,0,31,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,35,0,0,0,33,0,0,0,33,0,0,0,36,0,0,0,34,0,0,0,185,0,0,0,0,0,0,0,112,73,0,0,210,2,0,0,211,2,0,0,35,0,0,0,31,0,0,0,32,0,0,0,13,0,0,0,183,0,0,0,186,0,0,0,207,2,0,0,0,0,0,0,128,73,0,0,212,2,0,0,213,2,0,0,31,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,37,0,0,0,36,0,0,0,33,0,0,0,34,0,0,0,29,0,0,0,187,0,0,0,0,0,0,0,144,73,0,0,214,2,0,0,215,2,0,0,30,0,0,0,31,0,0,0,32,0,0,0,14,0,0,0,183,0,0,0,188,0,0,0,207,2,0,0,0,0,0,0,160,73,0,0,216,2,0,0,217,2,0,0,31,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,38],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+92164);allocate([37,0,0,0,33,0,0,0,39,0,0,0,38,0,0,0,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,66,76,65,67,75,65,78,68,87,72,73,84,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,71,82,65,89,83,67,65,76,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,71,82,65,89,83,67,65,76,69,95,65,76,80,72,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,82,71,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,29,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,5,0,0,0,82,71,66,95,65,76,80,72,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,176,73,0,0,59,0,0,0,218,2,0,0,9,0,0,0,2,0,0,0,69,78,68,72,68,82,0,0,0,0,0,0,3,0,0,0,72,69,73,71,72,84,0,0,0,0,0,0,4,0,0,0,87,73,68,84,72,0,0,0,0,0,0,0,5,0,0,0,68,69,80,84,72,0,0,0,0,0,0,0,6,0,0,0,77,65,88,86,65,76,0,0,0,0,0,0,7,0,0,0,84,85,80,76,84,89,80,69,0,0,0,0,0,0,0,0,192,73,0,0,219,2,0,0,220,2,0,0,39,0,0,0,31,0,0,0,32,0,0,0,15,0,0,0,183,0,0,0,190,0,0,0,207,2,0,0,0,0,0,0,208,73,0,0,221,2,0,0,222,2,0,0,31,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,40,0,0,0,40,0,0,0,33,0,0,0,41,0,0,0,41,0,0,0,191,0,0,0,0,0,0,0,224,73,0,0,223,2,0,0,224,2,0,0,42,0,0,0,31,0,0,0,32,0,0,0,16,0,0,0,183,0,0,0,192,0,0,0,207,2,0,0,0,0,0,0,240,73,0,0,225,2,0,0,226,2,0,0,31,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,42,0,0,0,43,0,0,0,33,0,0,0,34,0,0,0,29,0,0,0,193,0,0,0,0,0,0,0,0,74,0,0,227,2,0,0,228,2,0,0,30,0,0,0,31,0,0,0,32,0,0,0,17,0,0,0,183,0,0,0,194,0,0,0,207,2,0,0,0,0,0,0,16,74,0,0,229,2,0,0,230,2,0,0,44,0,0,0,45,0,0,0,231,2,0,0,232,2,0,0,233,2,0,0,234,2,0,0,0,0,0,0,24,74,0,0,59,0,0,0,235,2,0,0,9,0,0,0,0,0,0,0,40,74,0,0,236,2,0,0,237,2,0,0,46,0,0,0,47,0,0,0,238,2,0,0,239,2,0,0,240,2,0,0,241,2,0,0,0,0,0,0,48,74,0,0,229,2,0,0,242,2,0,0,44,0,0,0,45,0,0,0,231,2,0,0,232,2,0,0,233,2,0,0,234,2,0,0,0,0,0,0,64,74,0,0,229,2,0,0,243,2,0,0,44,0,0,0,45,0,0,0,231,2,0,0,232,2,0,0,233,2,0,0,234,2,0,0,0,0,0,0,80,74,0,0,236,2,0,0,244,2,0,0,46,0,0,0,47,0,0,0,238,2,0,0,239,2,0,0,240,2,0,0,241,2,0,0,0,0,0,0,96,74,0,0,236,2,0,0,245,2,0,0,46,0,0,0,47,0,0,0,238,2,0,0,239,2,0,0,240,2,0,0,241,2,0,0,0,0,0,0,120,74,0,0,246,2,0,0,247,2,0,0,31,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,1,0,0,0,1,0,0,0,33,0,0,0,34,0,0,0,29,0,0,0,195,0,0,0,0,0,0,0,128,74,0,0,248,2,0,0,249,2,0,0,30,0,0,0,31,0,0,0,32,0,0,0,1,0,0,0,183,0,0,0,196,0,0,0,207,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,74,0,0,250,2,0,0,251,2,0,0,3,0,0,0,197,0,0,0,198,0,0,0,43,0,0,0,3,0,0,0,199,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,77,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,44,0,0,0,204,28,30,0,25,103,5,0,129,103,5,0,193,0,0,0,1,0,0,0,208,28,30,0,231,103,5,0,129,103,5,0,53,1,0,0,1,0,0,0,168,153,1,0,56,16,0,0,120,75,0,0,120,75,0,0,56,16,0,0,168,153,1,0,56,16,0,0,120,75,0,0,120,75,0,0,56,16,0,0,0,0,0,0,168,74,0,0,8,0,0,0,254,2,0,0,255,2,0,0,212,28,30,0,238,106,5,0,141,106,5,0,94,0,0,0,1,0,0,0,168,16,0,0,120,75,0,0,120,75,0,0,168,16,0,0,216,28,30,0,136,108,5,0,203,108,5,0,152,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,74,0,0,0,3,0,0,1,3,0,0,3,0,0,0,200,0,0,0,201,0,0,0,43,0,0,0,3,0,0,0,202,0,0,0,46,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,77,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,203,0,0,0,47,0,0,0,204,0,0,0,48,0,0,0,205,0,0,0,49,0,0,0,0,0,0,0,200,74,0,0,8,0,0,0,2,3,0,0,3,3,0,0,220,28,30,0,83,109,5,0,203,108,5,0,201,1,0,0,1,0,0,0,176,154,1,0,168,16,0,0,120,75,0,0,120,75,0,0,168,16,0,0,176,154,1,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,0,0,0,0,3,0,0,0,1,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,3,0,0,0,255,255,255,255,2,0,0,0,254,255,255,255,1,0,0,0,253,255,255,255,0,0,0,0,253,255,255,255,255,255,255,255,253,255,255,255,254,255,255,255,254,255,255,255,253,255,255,255,255,255,255,255,253,255,255,255,0,0,0,0,253,255,255,255,1,0,0,0,254,255,255,255,2,0,0,0,255,255,255,255,3,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,255,255,255,255,1,0,0,0,254,255,255,255,0,0,0,0,254,255,255,255,255,255,255,255,254,255,255,255,254,255,255,255,255,255,255,255,254,255,255,255,0,0,0,0,254,255,255,255,1,0,0,0,255,255,255,255,2,0,0,0,224,28,30,0,102,110,5,0,45,110,5,0,152,0,0,0,1,0,0,0,228,28,30,0,46,111,5,0,45,110,5,0,123,0,0,0,1,0,0,0,232,28,30,0,162,111,5,0,45,110,5,0,109,0,0,0,1,0,0,0,236,28,30,0,23,112,5,0,45,110,5,0,78,0,0,0,1,0,0,0,240,28,30,0,137,112,5,0,45,110,5,0,63,0,0,0,1,0,0,0,244,28,30,0,47,113,5,0,247,112,5,0,159,0,0,0,1,0,0,0,0,0,0,0,0,75,0,0,6,3,0,0,7,3,0,0,8,3,0,0,206,0,0,0,207,0,0,0,50,0,0,0,3,0,0,0,4,0,0,0,208,0,0,0,1,0,0,0,9,3,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,16,75,0,0,6,3,0,0,10,3,0,0,8,3,0,0,206,0,0,0,207,0,0,0,50,0,0,0,3,0,0,0,4,0,0,0,208,0,0,0,51,0,0,0,9,3,0,0,40,0,0,0,78,0,0,0,1,0,0,0,0,0,0,0,32,75,0,0,8,0,0,0,11,3,0,0,12,3,0,0,0,29,30,0,231,116,5,0,249,113,5,0,58,2,0,0,1,0,0,0,252,28,30,0,142,116,5,0,249,113,5,0,89,2,0,0,1,0,0,0,248,28,30,0,25,116,5,0,249,113,5,0,121,2,0,0,1,0,0,0,40,17,0,0,120,75,0,0,120,75,0,0,40,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,75,0,0,13,3,0,0,14,3,0,0,3,0,0,0,200,0,0,0,201,0,0,0,43,0,0,0,3,0,0,0,209,0,0,0,45,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,79,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,210,0,0,0,55,0,0,0,13,0,0,0,13,0,0,0,211,0,0,0,56,0,0,0,212,0,0,0,57,0,0,0,213,0,0,0,58,0,0,0,214,0,0,0,59,0,0,0,215,0,0,0,60,0,0,0,216,0,0,0,61,0,0,0,217,0,0,0,62,0,0,0,4,29,30,0,176,119,5,0,247,117,5,0,192,3,0,0,1,0,0,0,8,0,0,0,253,255,255,255,9,0,0,0,5,0,0,0,4,0,0,0,2,0,0,0,7,0,0,0,244,255,255,255,245,255,255,255,9,0,0,0,248,255,255,255,2,0,0,0,7,0,0,0,244,255,255,255,12,0,0,0,243,255,255,255,2,0,0,0,243,255,255,255,2,0,0,0,12,0,0,0,1,0,0,0,249,255,255,255,1,0,0,0,6,0,0,0,254,255,255,255,246,255,255,255,254,255,255,255,252,255,255,255,243,255,255,255,243,255,255,255,245,255,255,255,248,255,255,255,243,255,255,255,253,255,255,255,244,255,255,255,247,255,255,255,10,0,0,0,4,0,0,0,11,0,0,0,9,0,0,0,243,255,255,255,248,255,255,255,248,255,255,255,247,255,255,255,245,255,255,255,7,0,0,0,247,255,255,255,12,0,0,0,7,0,0,0,7,0,0,0,12,0,0,0,6,0,0,0,252,255,255,255,251,255,255,255,253,255,255,255,0,0,0,0,243,255,255,255,2,0,0,0,244,255,255,255,253,255,255,255,247,255,255,255,0,0,0,0,249,255,255,255,5,0,0,0,12,0,0,0,250,255,255,255,12,0,0,0,255,255,255,255,253,255,255,255,6,0,0,0,254,255,255,255,12,0,0,0,250,255,255,255,243,255,255,255,252,255,255,255,248,255,255,255,11,0,0,0,243,255,255,255,12,0,0,0,248,255,255,255,4,0,0,0,7,0,0,0,5,0,0,0,1,0,0,0,5,0,0,0,253,255,255,255,10,0,0,0,253,255,255,255,3,0,0,0,249,255,255,255,6,0,0,0,12,0,0,0,248,255,255,255,249,255,255,255,250,255,255,255,254,255,255,255,254,255,255,255,11,0,0,0,255,255,255,255,246,255,255,255,243,255,255,255,12,0,0,0,248,255,255,255,10,0,0,0,249,255,255,255,3,0,0,0,251,255,255,255,253,255,255,255,252,255,255,255,2,0,0,0,253,255,255,255,7,0,0,0,246,255,255,255,244,255,255,255,250,255,255,255,11,0,0,0,5,0,0,0,244,255,255,255,6,0,0,0,249,255,255,255,5,0,0,0,250,255,255,255,7,0,0,0,255,255,255,255,1,0,0,0,0,0,0,0,4,0,0,0,251,255,255,255,9,0,0,0,11,0,0,0,11,0,0,0,243,255,255,255,4,0,0,0,7,0,0,0,4,0,0,0,12,0,0,0,2,0,0,0,255,255,255,255,4,0,0,0,4,0,0,0,252,255,255,255,244,255,255,255,254,255,255,255,7,0,0,0,248,255,255,255,251,255,255,255,249,255,255,255,246,255,255,255,4,0,0,0,11,0,0,0,9,0,0,0,12,0,0,0,0,0,0,0,248,255,255,255,1,0,0,0,243,255,255,255,243,255,255,255,254,255,255,255,248,255,255,255,2,0,0,0,253,255,255,255,254,255,255,255,254,255,255,255,3,0,0,0,250,255,255,255,9,0,0,0,252,255,255,255,247,255,255,255,8,0,0,0,12,0,0,0,10,0,0,0,7,0,0,0,0,0,0,0,9,0,0,0,1,0,0,0,3,0,0,0,7,0,0,0,251,255,255,255,11,0,0,0,246,255,255,255,243,255,255,255,250,255,255,255,245,255,255,255,0,0,0,0,10,0,0,0,7,0,0,0,12,0,0,0,1,0,0,0,250,255,255,255,253,255,255,255,250,255,255,255,12,0,0,0,10,0,0,0,247,255,255,255,12,0,0,0,252,255,255,255,243,255,255,255,8,0,0,0,248,255,255,255,244,255,255,255,243,255,255,255,0,0,0,0,248,255,255,255,252,255,255,255,3,0,0,0,3,0,0,0,7,0,0,0,8,0,0,0,5,0,0,0,7,0,0,0,10,0,0,0,249,255,255,255,255,255,255,255,7,0,0,0,1,0,0,0,244,255,255,255,3,0,0,0,246,255,255,255,5,0,0,0,6,0,0,0,2,0,0,0,252,255,255,255,3,0,0,0,246,255,255,255,243,255,255,255,0,0,0,0,243,255,255,255,5,0,0,0,243,255,255,255,249,255,255,255,244,255,255,255,12,0,0,0,243,255,255,255,3,0,0,0,245,255,255,255,8,0,0,0,249,255,255,255,12,0,0,0,252,255,255,255,7,0,0,0,6,0,0,0,246,255,255,255,12,0,0,0,8,0,0,0,247,255,255,255,255,255,255,255,249,255,255,255,250,255,255,255,254,255,255,255,251,255,255,255,0,0,0,0,12,0,0,0,244,255,255,255,5,0,0,0,249,255,255,255,5,0,0,0,3,0,0,0,246,255,255,255,8,0,0,0,243,255,255,255,249,255,255,255,249,255,255,255,252,255,255,255,5,0,0,0,253,255,255,255,254,255,255,255,255,255,255,255,249,255,255,255,2,0,0,0,9,0,0,0,5,0,0,0,245,255,255,255,245,255,255,255,243,255,255,255,251,255,255,255,243,255,255,255,255,255,255,255,6,0,0,0,0,0,0,0,255,255,255,255,5,0,0,0,253,255,255,255,5,0,0,0,2,0,0,0,252,255,255,255,243,255,255,255,252,255,255,255,12,0,0,0,247,255,255,255,250,255,255,255,247,255,255,255,6,0,0,0,244,255,255,255,246,255,255,255,248,255,255,255,252,255,255,255,10,0,0,0,2,0,0,0,12,0,0,0,253,255,255,255,7,0,0,0,12,0,0,0,12,0,0,0,12,0,0,0,249,255,255,255,243,255,255,255,250,255,255,255,5,0,0,0,252,255,255,255,9,0,0,0,253,255,255,255,4,0,0,0,7,0,0,0,255,255,255,255,12,0,0,0,2,0,0,0,249,255,255,255,6,0,0,0,251,255,255,255,1,0,0,0,243,255,255,255,11,0,0,0,244,255,255,255,5,0,0,0,253,255,255,255,7,0,0,0,254,255,255,255,250,255,255,255,7,0,0,0,248,255,255,255,12,0,0,0,249,255,255,255,243,255,255,255,249,255,255,255,245,255,255,255,244,255,255,255,1,0,0,0,253,255,255,255,12,0,0,0,12,0,0,0,2,0,0,0,250,255,255,255,3,0,0,0,0,0,0,0,252,255,255,255,3,0,0,0,254,255,255,255,243,255,255,255,255,255,255,255,243,255,255,255,1,0,0,0,9,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,250,255,255,255,1,0,0,0,255,255,255,255,3,0,0,0,12,0,0,0,9,0,0,0,1,0,0,0,12,0,0,0,6,0,0,0,255,255,255,255,247,255,255,255,255,255,255,255,3,0,0,0,243,255,255,255,243,255,255,255,246,255,255,255,5,0,0,0,7,0,0,0,7,0,0,0,10,0,0,0,12,0,0,0,12,0,0,0,251,255,255,255,12,0,0,0,9,0,0,0,6,0,0,0,3,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,243,255,255,255,6,0,0,0,10,0,0,0,2,0,0,0,244,255,255,255,2,0,0,0,3,0,0,0,3,0,0,0,8,0,0,0,4,0,0,0,250,255,255,255,2,0,0,0,6,0,0,0,12,0,0,0,243,255,255,255,9,0,0,0,244,255,255,255,10,0,0,0,3,0,0,0,248,255,255,255,4,0,0,0,249,255,255,255,9,0,0,0,245,255,255,255,12,0,0,0,252,255,255,255,250,255,255,255,1,0,0,0,12,0,0,0,2,0,0,0,248,255,255,255,6,0,0,0,247,255,255,255,7,0,0,0,252,255,255,255,2,0,0,0,3,0,0,0,3,0,0,0,254,255,255,255,6,0,0,0,3,0,0,0,11,0,0,0,0,0,0,0,3,0,0,0,253,255,255,255,8,0,0,0,248,255,255,255,7,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,245,255,255,255,251,255,255,255,250,255,255,255,252,255,255,255,246,255,255,255,11,0,0,0,251,255,255,255,10,0,0,0,251,255,255,255,248,255,255,255,253,255,255,255,12,0,0,0,246,255,255,255,5,0,0,0,247,255,255,255,0,0,0,0,8,0,0,0,255,255,255,255,12,0,0,0,250,255,255,255,4,0,0,0,250,255,255,255,6,0,0,0,245,255,255,255,246,255,255,255,12,0,0,0,248,255,255,255,7,0,0,0,4,0,0,0,254,255,255,255,6,0,0,0,7,0,0,0,254,255,255,255,0,0,0,0,254,255,255,255,12,0,0,0,251,255,255,255,248,255,255,255,251,255,255,255,2,0,0,0,7,0,0,0,250,255,255,255,10,0,0,0,12,0,0,0,247,255,255,255,243,255,255,255,248,255,255,255,248,255,255,255,251,255,255,255,243,255,255,255,251,255,255,255,254,255,255,255,8,0,0,0,248,255,255,255,9,0,0,0,243,255,255,255,247,255,255,255,245,255,255,255,247,255,255,255,0,0,0,0,1,0,0,0,248,255,255,255,1,0,0,0,254,255,255,255,7,0,0,0,252,255,255,255,9,0,0,0,1,0,0,0,254,255,255,255,1,0,0,0,255,255,255,255,252,255,255,255,11,0,0,0,250,255,255,255,12,0,0,0,245,255,255,255,244,255,255,255,247,255,255,255,250,255,255,255,4,0,0,0,3,0,0,0,7,0,0,0,7,0,0,0,12,0,0,0,5,0,0,0,5,0,0,0,10,0,0,0,8,0,0,0,0,0,0,0,252,255,255,255,2,0,0,0,8,0,0,0,247,255,255,255,12,0,0,0,251,255,255,255,243,255,255,255,0,0,0,0,7,0,0,0,2,0,0,0,12,0,0,0,255,255,255,255,2,0,0,0,1,0,0,0,7,0,0,0,5,0,0,0,11,0,0,0,7,0,0,0,247,255,255,255,3,0,0,0,5,0,0,0,6,0,0,0,248,255,255,255,243,255,255,255,252,255,255,255,248,255,255,255,9,0,0,0,251,255,255,255,9,0,0,0,253,255,255,255,253,255,255,255,252,255,255,255,249,255,255,255,253,255,255,255,244,255,255,255,6,0,0,0,5,0,0,0,8,0,0,0,0,0,0,0,249,255,255,255,6,0,0,0,250,255,255,255,12,0,0,0,243,255,255,255,6,0,0,0,251,255,255,255,254,255,255,255,1,0,0,0,246,255,255,255,3,0,0,0,10,0,0,0,4,0,0,0,1,0,0,0,8,0,0,0,252,255,255,255,254,255,255,255,254,255,255,255,2,0,0,0,243,255,255,255,2,0,0,0,244,255,255,255,12,0,0,0,12,0,0,0,254,255,255,255,243,255,255,255,0,0,0,0,250,255,255,255,4,0,0,0,1,0,0,0,9,0,0,0,3,0,0,0,250,255,255,255,246,255,255,255,253,255,255,255,251,255,255,255,253,255,255,255,243,255,255,255,255,255,255,255,1,0,0,0,7,0,0,0,5,0,0,0,12,0,0,0,245,255,255,255,4,0,0,0,254,255,255,255,5,0,0,0,249,255,255,255,243,255,255,255,9,0,0,0,247,255,255,255,251,255,255,255,7,0,0,0,1,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,248,255,255,255,7,0,0,0,6,0,0,0,249,255,255,255,252,255,255,255,249,255,255,255,1,0,0,0,248,255,255,255,11,0,0,0,249,255,255,255,248,255,255,255,243,255,255,255,6,0,0,0,244,255,255,255,248,255,255,255,2,0,0,0,4,0,0,0,3,0,0,0,9,0,0,0,10,0,0,0,251,255,255,255,12,0,0,0,3,0,0,0,250,255,255,255,251,255,255,255,250,255,255,255,7,0,0,0,8,0,0,0,253,255,255,255,9,0,0,0,248,255,255,255,2,0,0,0,244,255,255,255,2,0,0,0,8,0,0,0,245,255,255,255,254,255,255,255,246,255,255,255,3,0,0,0,244,255,255,255,243,255,255,255,249,255,255,255,247,255,255,255,245,255,255,255,0,0,0,0,246,255,255,255,251,255,255,255,5,0,0,0,253,255,255,255,11,0,0,0,8,0,0,0,254,255,255,255,243,255,255,255,255,255,255,255,12,0,0,0,255,255,255,255,248,255,255,255,0,0,0,0,9,0,0,0,243,255,255,255,245,255,255,255,244,255,255,255,251,255,255,255,246,255,255,255,254,255,255,255,246,255,255,255,11,0,0,0,253,255,255,255,9,0,0,0,254,255,255,255,243,255,255,255,2,0,0,0,253,255,255,255,3,0,0,0,2,0,0,0,247,255,255,255,243,255,255,255,252,255,255,255,0,0,0,0,252,255,255,255,6,0,0,0,253,255,255,255,246,255,255,255,252,255,255,255,12,0,0,0,254,255,255,255,249,255,255,255,250,255,255,255,245,255,255,255,252,255,255,255,9,0,0,0,6,0,0,0,253,255,255,255,6,0,0,0,11,0,0,0,243,255,255,255,11,0,0,0,251,255,255,255,5,0,0,0,11,0,0,0,11,0,0,0,12,0,0,0,6,0,0,0,7,0,0,0,251,255,255,255,12,0,0,0,254,255,255,255,255,255,255,255,12,0,0,0,0,0,0,0,7,0,0,0,252,255,255,255,248,255,255,255,253,255,255,255,254,255,255,255,249,255,255,255,1,0,0,0,250,255,255,255,7,0,0,0,243,255,255,255,244,255,255,255,248,255,255,255,243,255,255,255,249,255,255,255,254,255,255,255,250,255,255,255,248,255,255,255,248,255,255,255,5,0,0,0,250,255,255,255,247,255,255,255,251,255,255,255,255,255,255,255,252,255,255,255,5,0,0,0,243,255,255,255,7,0,0,0,248,255,255,255,10,0,0,0,1,0,0,0,5,0,0,0,5,0,0,0,243,255,255,255,1,0,0,0,0,0,0,0,10,0,0,0,243,255,255,255,9,0,0,0,12,0,0,0,10,0,0,0,255,255,255,255,5,0,0,0,248,255,255,255,10,0,0,0,247,255,255,255,255,255,255,255,11,0,0,0,1,0,0,0,243,255,255,255,247,255,255,255,253,255,255,255,250,255,255,255,2,0,0,0,255,255,255,255,246,255,255,255,1,0,0,0,12,0,0,0,243,255,255,255,1,0,0,0,248,255,255,255,246,255,255,255,8,0,0,0,245,255,255,255,10,0,0,0,250,255,255,255,2,0,0,0,243,255,255,255,3,0,0,0,250,255,255,255,7,0,0,0,243,255,255,255,12,0,0,0,247,255,255,255,246,255,255,255,246,255,255,255,251,255,255,255,249,255,255,255,246,255,255,255,248,255,255,255,248,255,255,255,243,255,255,255,4,0,0,0,250,255,255,255,8,0,0,0,5,0,0,0,3,0,0,0,12,0,0,0,8,0,0,0,243,255,255,255,252,255,255,255,2,0,0,0,253,255,255,255,253,255,255,255,5,0,0,0,243,255,255,255,10,0,0,0,244,255,255,255,4,0,0,0,243,255,255,255,5,0,0,0,255,255,255,255,247,255,255,255,9,0,0,0,252,255,255,255,3,0,0,0,0,0,0,0,3,0,0,0,3,0,0,0,247,255,255,255,244,255,255,255,1,0,0,0,250,255,255,255,1,0,0,0,3,0,0,0,2,0,0,0,4,0,0,0,248,255,255,255,246,255,255,255,246,255,255,255,246,255,255,255,9,0,0,0,8,0,0,0,243,255,255,255,12,0,0,0,12,0,0,0,248,255,255,255,244,255,255,255,250,255,255,255,251,255,255,255,2,0,0,0,2,0,0,0,3,0,0,0,7,0,0,0,10,0,0,0,6,0,0,0,11,0,0,0,248,255,255,255,6,0,0,0,8,0,0,0,8,0,0,0,244,255,255,255,249,255,255,255,10,0,0,0,250,255,255,255,5,0,0,0,253,255,255,255,247,255,255,255,253,255,255,255,9,0,0,0,255,255,255,255,243,255,255,255,255,255,255,255,5,0,0,0,253,255,255,255,249,255,255,255,253,255,255,255,4,0,0,0,248,255,255,255,254,255,255,255,248,255,255,255,3,0,0,0,4,0,0,0,2,0,0,0,12,0,0,0,12,0,0,0,2,0,0,0,251,255,255,255,3,0,0,0,11,0,0,0,6,0,0,0,247,255,255,255,11,0,0,0,243,255,255,255,3,0,0,0,255,255,255,255,7,0,0,0,12,0,0,0,11,0,0,0,255,255,255,255,12,0,0,0,4,0,0,0,253,255,255,255,0,0,0,0,253,255,255,255,6,0,0,0,4,0,0,0,245,255,255,255,4,0,0,0,12,0,0,0,2,0,0,0,252,255,255,255,2,0,0,0,1,0,0,0,246,255,255,255,250,255,255,255,248,255,255,255,1,0,0,0,243,255,255,255,7,0,0,0,245,255,255,255,1,0,0,0,243,255,255,255,12,0,0,0,245,255,255,255,243,255,255,255,6,0,0,0,0,0,0,0,11,0,0,0,243,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,4,0,0,0,243,255,255,255,3,0,0,0,247,255,255,255,254,255,255,255,247,255,255,255,8,0,0,0,250,255,255,255,253,255,255,255,243,255,255,255,250,255,255,255,248,255,255,255,254,255,255,255,5,0,0,0,247,255,255,255,8,0,0,0,10,0,0,0,2,0,0,0,7,0,0,0,3,0,0,0,247,255,255,255,255,255,255,255,250,255,255,255,255,255,255,255,255,255,255,255,9,0,0,0,5,0,0,0,11,0,0,0,254,255,255,255,11,0,0,0,253,255,255,255,12,0,0,0,248,255,255,255,3,0,0,0,0,0,0,0,3,0,0,0,5,0,0,0,255,255,255,255,4,0,0,0,0,0,0,0,10,0,0,0,3,0,0,0,250,255,255,255,4,0,0,0,5,0,0,0,243,255,255,255,0,0,0,0,246,255,255,255,5,0,0,0,5,0,0,0,8,0,0,0,12,0,0,0,11,0,0,0,8,0,0,0,9,0,0,0,9,0,0,0,250,255,255,255,7,0,0,0,252,255,255,255,8,0,0,0,244,255,255,255,246,255,255,255,4,0,0,0,246,255,255,255,9,0,0,0,7,0,0,0,3,0,0,0,12,0,0,0,4,0,0,0,9,0,0,0,249,255,255,255,10,0,0,0,254,255,255,255,7,0,0,0,0,0,0,0,12,0,0,0,254,255,255,255,255,255,255,255,250,255,255,255,0,0,0,0,245,255,255,255,232,157,1,0,40,17,0,0,120,75,0,0,120,75,0,0,40,17,0,0,232,157,1,0,0,0,0,0,184,75,0,0,8,0,0,0,19,3,0,0,20,3,0,0,0,124,5,0,16,124,5,0,153,226,86,0,27,124,5,0,38,124,5,0,51,124,5,0,62,124,5,0,82,124,5,0,95,124,5,0,153,226,86,0,0,0,0,0,150,48,7,119,44,97,14,238,186,81,9,153,25,196,109,7,143,244,106,112,53,165,99,233,163,149,100,158,50,136,219,14,164,184,220,121,30,233,213,224,136,217,210,151,43,76,182,9,189,124,177,126,7,45,184,231,145,29,191,144,100,16,183,29,242,32,176,106,72,113,185,243,222,65,190,132,125,212,218,26,235,228,221,109,81,181,212,244,199,133,211,131,86,152,108,19,192,168,107,100,122,249,98,253,236,201,101,138,79,92,1,20,217,108,6,99,99,61,15,250,245,13,8,141,200,32,110,59,94,16,105,76,228,65,96,213,114,113,103,162,209,228,3,60,71,212,4,75,253,133,13,210,107,181,10,165,250,168,181,53,108,152,178,66,214,201,187,219,64,249,188,172,227,108,216,50,117,92,223,69,207,13,214,220,89,61,209,171,172,48,217,38,58,0,222,81,128,81,215,200,22,97,208,191,181,244,180,33,35,196,179,86,153,149,186,207,15,165,189,184,158,184,2,40,8,136,5,95,178,217,12,198,36,233,11,177,135,124,111,47,17,76,104,88,171,29,97,193,61,45,102,182,144,65,220,118,6,113,219,1,188,32,210,152,42,16,213,239,137,133,177,113,31,181,182,6,165,228,191,159,51,212,184,232,162,201,7,120,52,249,0,15,142,168,9,150,24,152,14,225,187,13,106,127,45,61,109,8,151,108,100,145,1,92,99,230,244,81,107,107,98,97,108,28,216,48,101,133,78,0,98,242,237,149,6,108,123,165,1,27,193,244,8,130,87,196,15,245,198,217,176,101,80,233,183,18,234,184,190,139,124,136,185,252,223,29,221,98,73,45,218,21,243,124,211,140,101,76,212,251,88,97,178,77,206,81,181,58,116,0,188,163,226,48,187,212,65,165,223,74,215,149,216,61,109,196,209,164,251,244,214,211,106,233,105,67,252,217,110,52,70,136,103,173,208,184,96,218,115,45,4,68,229,29,3,51,95,76,10,170,201,124,13,221,60,113,5,80,170,65,2,39,16,16,11,190,134,32,12,201,37,181,104,87,179,133,111,32,9,212,102,185,159,228,97,206,14,249,222,94,152,201,217,41,34,152,208,176,180,168,215,199,23,61,179,89,129,13,180,46,59,92,189,183,173,108,186,192,32,131,184,237,182,179,191,154,12,226,182,3,154,210,177,116,57,71,213,234,175,119,210,157,21,38,219,4,131,22,220,115,18,11,99,227,132,59,100,148,62,106,109,13,168,90,106,122,11,207,14,228,157,255,9,147,39,174,0,10,177,158,7,125,68,147,15,240,210,163,8,135,104,242,1,30,254,194,6,105,93,87,98,247,203,103,101,128,113,54,108,25,231,6,107,110,118,27,212,254,224,43,211,137,90,122,218,16,204,74,221,103,111,223,185,249,249,239,190,142,67,190,183,23,213,142,176,96,232,163,214,214,126,147,209,161,196,194,216,56,82,242,223,79,241,103,187,209,103,87,188,166,221,6,181,63,75,54,178,72,218,43,13,216,76,27,10,175,246,74,3,54,96,122,4,65,195,239,96,223,85,223,103,168,239,142,110,49,121,190,105,70,140,179,97,203,26,131,102,188,160,210,111,37,54,226,104,82,149,119,12,204,3,71,11,187,185,22,2,34,47,38,5,85,190,59,186,197,40,11,189,178,146,90,180,43,4,106,179,92,167,255,215,194,49,207,208,181,139,158,217,44,29,174,222,91,176,194,100,155,38,242,99,236,156,163,106,117,10,147,109,2,169,6,9,156,63,54,14,235,133,103,7,114,19,87,0,5,130,74,191,149,20,122,184,226,174,43,177,123,56,27,182,12,155,142,210,146,13,190,213,229,183,239,220,124,33,223,219,11,212,210,211,134,66,226,212,241,248,179,221,104,110,131,218,31,205,22,190,129,91,38,185,246,225,119,176,111,119,71,183,24,230,90,8,136,112,106,15,255,202,59,6,102,92,11,1,17,255,158,101,143,105,174,98,248,211,255,107,97,69,207,108,22,120,226,10,160,238,210,13,215,84,131,4,78,194,179,3,57,97,38,103,167,247,22,96,208,77,71,105,73,219,119,110,62,74,106,209,174,220,90,214,217,102,11,223,64,240,59,216,55,83,174,188,169,197,158,187,222,127,207,178,71,233,255,181,48,28,242,189,189,138,194,186,202,48,147,179,83,166,163,180,36,5,54,208,186,147,6,215,205,41,87,222,84,191,103,217,35,46,122,102,179,184,74,97,196,2,27,104,93,148,43,111,42,55,190,11,180,161,142,12,195,27,223,5,90,141,239,2,45,0,0,0,0,65,49,27,25,130,98,54,50,195,83,45,43,4,197,108,100,69,244,119,125,134,167,90,86,199,150,65,79,8,138,217,200,73,187,194,209,138,232,239,250,203,217,244,227,12,79,181,172,77,126,174,181,142,45,131,158,207,28,152,135,81,18,194,74,16,35,217,83,211,112,244,120,146,65,239,97,85,215,174,46,20,230,181,55,215,181,152,28,150,132,131,5,89,152,27,130,24,169,0,155,219,250,45,176,154,203,54,169,93,93,119,230,28,108,108,255,223,63,65,212,158,14,90,205,162,36,132,149,227,21,159,140,32,70,178,167,97,119,169,190,166,225,232,241,231,208,243,232,36,131,222,195,101,178,197,218,170,174,93,93,235,159,70,68,40,204,107,111,105,253,112,118,174,107,49,57,239,90,42,32,44,9,7,11,109,56,28,18,243,54,70,223,178,7,93,198,113,84,112,237,48,101,107,244,247,243,42,187,182,194,49,162,117,145,28,137,52,160,7,144,251,188,159,23,186,141,132,14,121,222,169,37,56,239,178,60,255,121,243,115,190,72,232,106,125,27,197,65,60,42,222,88,5,79,121,240,68,126,98,233,135,45,79,194,198,28,84,219,1,138,21,148,64,187,14,141,131,232,35,166,194,217,56,191,13,197,160,56,76,244,187,33,143,167,150,10,206,150,141,19,9,0,204,92,72,49,215,69,139,98,250,110,202,83,225,119,84,93,187,186,21,108,160,163,214,63,141,136,151,14,150,145,80,152,215,222,17,169,204,199,210,250,225,236,147,203,250,245,92,215,98,114,29,230,121,107,222,181,84,64,159,132,79,89,88,18,14,22,25,35,21,15,218,112,56,36,155,65,35,61,167,107,253,101,230,90,230,124,37,9,203,87,100,56,208,78,163,174,145,1,226,159,138,24,33,204,167,51,96,253,188,42,175,225,36,173,238,208,63,180,45,131,18,159,108,178,9,134,171,36,72,201,234,21,83,208,41,70,126,251,104,119,101,226,246,121,63,47,183,72,36,54,116,27,9,29,53,42,18,4,242,188,83,75,179,141,72,82,112,222,101,121,49,239,126,96,254,243,230,231,191,194,253,254,124,145,208,213,61,160,203,204,250,54,138,131,187,7,145,154,120,84,188,177,57,101,167,168,75,152,131,59,10,169,152,34,201,250,181,9,136,203,174,16,79,93,239,95,14,108,244,70,205,63,217,109,140,14,194,116,67,18,90,243,2,35,65,234,193,112,108,193,128,65,119,216,71,215,54,151,6,230,45,142,197,181,0,165,132,132,27,188,26,138,65,113,91,187,90,104,152,232,119,67,217,217,108,90,30,79,45,21,95,126,54,12,156,45,27,39,221,28,0,62,18,0,152,185,83,49,131,160,144,98,174,139,209,83,181,146,22,197,244,221,87,244,239,196,148,167,194,239,213,150,217,246,233,188,7,174,168,141,28,183,107,222,49,156,42,239,42,133,237,121,107,202,172,72,112,211,111,27,93,248,46,42,70,225,225,54,222,102,160,7,197,127,99,84,232,84,34,101,243,77,229,243,178,2,164,194,169,27,103,145,132,48,38,160,159,41,184,174,197,228,249,159,222,253,58,204,243,214,123,253,232,207,188,107,169,128,253,90,178,153,62,9,159,178,127,56,132,171,176,36,28,44,241,21,7,53,50,70,42,30,115,119,49,7,180,225,112,72,245,208,107,81,54,131,70,122,119,178,93,99,78,215,250,203,15,230,225,210,204,181,204,249,141,132,215,224,74,18,150,175,11,35,141,182,200,112,160,157,137,65,187,132,70,93,35,3,7,108,56,26,196,63,21,49,133,14,14,40,66,152,79,103,3,169,84,126,192,250,121,85,129,203,98,76,31,197,56,129,94,244,35,152,157,167,14,179,220,150,21,170,27,0,84,229,90,49,79,252,153,98,98,215,216,83,121,206,23,79,225,73,86,126,250,80,149,45,215,123,212,28,204,98,19,138,141,45,82,187,150,52,145,232,187,31,208,217,160,6,236,243,126,94,173,194,101,71,110,145,72,108,47,160,83,117,232,54,18,58,169,7,9,35,106,84,36,8,43,101,63,17,228,121,167,150,165,72,188,143,102,27,145,164,39,42,138,189,224,188,203,242,161,141,208,235,98,222,253,192,35,239,230,217,189,225,188,20,252,208,167,13,63,131,138,38,126,178,145,63,185,36,208,112,248,21,203,105,59,70,230,66,122,119,253,91,181,107,101,220,244,90,126,197,55,9,83,238,118,56,72,247,177,174,9,184,240,159,18,161,51,204,63,138,114,253,36,147,0,0,0,0,55,106,194,1,110,212,132,3,89,190,70,2,220,168,9,7,235,194,203,6,178,124,141,4,133,22,79,5,184,81,19,14,143,59,209,15,214,133,151,13,225,239,85,12,100,249,26,9,83,147,216,8,10,45,158,10,61,71,92,11,112,163,38,28,71,201,228,29,30,119,162,31,41,29,96,30,172,11,47,27,155,97,237,26,194,223,171,24,245,181,105,25,200,242,53,18,255,152,247,19,166,38,177,17,145,76,115,16,20,90,60,21,35,48,254,20,122,142,184,22,77,228,122,23,224,70,77,56,215,44,143,57,142,146,201,59,185,248,11,58,60,238,68,63,11,132,134,62,82,58,192,60,101,80,2,61,88,23,94,54,111,125,156,55,54,195,218,53,1,169,24,52,132,191,87,49,179,213,149,48,234,107,211,50,221,1,17,51,144,229,107,36,167,143,169,37,254,49,239,39,201,91,45,38,76,77,98,35,123,39,160,34,34,153,230,32,21,243,36,33,40,180,120,42,31,222,186,43,70,96,252,41,113,10,62,40,244,28,113,45,195,118,179,44,154,200,245,46,173,162,55,47,192,141,154,112,247,231,88,113,174,89,30,115,153,51,220,114,28,37,147,119,43,79,81,118,114,241,23,116,69,155,213,117,120,220,137,126,79,182,75,127,22,8,13,125,33,98,207,124,164,116,128,121],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+102404);allocate([147,30,66,120,202,160,4,122,253,202,198,123,176,46,188,108,135,68,126,109,222,250,56,111,233,144,250,110,108,134,181,107,91,236,119,106,2,82,49,104,53,56,243,105,8,127,175,98,63,21,109,99,102,171,43,97,81,193,233,96,212,215,166,101,227,189,100,100,186,3,34,102,141,105,224,103,32,203,215,72,23,161,21,73,78,31,83,75,121,117,145,74,252,99,222,79,203,9,28,78,146,183,90,76,165,221,152,77,152,154,196,70,175,240,6,71,246,78,64,69,193,36,130,68,68,50,205,65,115,88,15,64,42,230,73,66,29,140,139,67,80,104,241,84,103,2,51,85,62,188,117,87,9,214,183,86,140,192,248,83,187,170,58,82,226,20,124,80,213,126,190,81,232,57,226,90,223,83,32,91,134,237,102,89,177,135,164,88,52,145,235,93,3,251,41,92,90,69,111,94,109,47,173,95,128,27,53,225,183,113,247,224,238,207,177,226,217,165,115,227,92,179,60,230,107,217,254,231,50,103,184,229,5,13,122,228,56,74,38,239,15,32,228,238,86,158,162,236,97,244,96,237,228,226,47,232,211,136,237,233,138,54,171,235,189,92,105,234,240,184,19,253,199,210,209,252,158,108,151,254,169,6,85,255,44,16,26,250,27,122,216,251,66,196,158,249,117,174,92,248,72,233,0,243,127,131,194,242,38,61,132,240,17,87,70,241,148,65,9,244,163,43,203,245,250,149,141,247,205,255,79,246,96,93,120,217,87,55,186,216,14,137,252,218,57,227,62,219,188,245,113,222,139,159,179,223,210,33,245,221,229,75,55,220,216,12,107,215,239,102,169,214,182,216,239,212,129,178,45,213,4,164,98,208,51,206,160,209,106,112,230,211,93,26,36,210,16,254,94,197,39,148,156,196,126,42,218,198,73,64,24,199,204,86,87,194,251,60,149,195,162,130,211,193,149,232,17,192,168,175,77,203,159,197,143,202,198,123,201,200,241,17,11,201,116,7,68,204,67,109,134,205,26,211,192,207,45,185,2,206,64,150,175,145,119,252,109,144,46,66,43,146,25,40,233,147,156,62,166,150,171,84,100,151,242,234,34,149,197,128,224,148,248,199,188,159,207,173,126,158,150,19,56,156,161,121,250,157,36,111,181,152,19,5,119,153,74,187,49,155,125,209,243,154,48,53,137,141,7,95,75,140,94,225,13,142,105,139,207,143,236,157,128,138,219,247,66,139,130,73,4,137,181,35,198,136,136,100,154,131,191,14,88,130,230,176,30,128,209,218,220,129,84,204,147,132,99,166,81,133,58,24,23,135,13,114,213,134,160,208,226,169,151,186,32,168,206,4,102,170,249,110,164,171,124,120,235,174,75,18,41,175,18,172,111,173,37,198,173,172,24,129,241,167,47,235,51,166,118,85,117,164,65,63,183,165,196,41,248,160,243,67,58,161,170,253,124,163,157,151,190,162,208,115,196,181,231,25,6,180,190,167,64,182,137,205,130,183,12,219,205,178,59,177,15,179,98,15,73,177,85,101,139,176,104,34,215,187,95,72,21,186,6,246,83,184,49,156,145,185,180,138,222,188,131,224,28,189,218,94,90,191,237,52,152,190,0,0,0,0,101,103,188,184,139,200,9,170,238,175,181,18,87,151,98,143,50,240,222,55,220,95,107,37,185,56,215,157,239,40,180,197,138,79,8,125,100,224,189,111,1,135,1,215,184,191,214,74,221,216,106,242,51,119,223,224,86,16,99,88,159,87,25,80,250,48,165,232,20,159,16,250,113,248,172,66,200,192,123,223,173,167,199,103,67,8,114,117,38,111,206,205,112,127,173,149,21,24,17,45,251,183,164,63,158,208,24,135,39,232,207,26,66,143,115,162,172,32,198,176,201,71,122,8,62,175,50,160,91,200,142,24,181,103,59,10,208,0,135,178,105,56,80,47,12,95,236,151,226,240,89,133,135,151,229,61,209,135,134,101,180,224,58,221,90,79,143,207,63,40,51,119,134,16,228,234,227,119,88,82,13,216,237,64,104,191,81,248,161,248,43,240,196,159,151,72,42,48,34,90,79,87,158,226,246,111,73,127,147,8,245,199,125,167,64,213,24,192,252,109,78,208,159,53,43,183,35,141,197,24,150,159,160,127,42,39,25,71,253,186,124,32,65,2,146,143,244,16,247,232,72,168,61,88,20,155,88,63,168,35,182,144,29,49,211,247,161,137,106,207,118,20,15,168,202,172,225,7,127,190,132,96,195,6,210,112,160,94,183,23,28,230,89,184,169,244,60,223,21,76,133,231,194,209,224,128,126,105,14,47,203,123,107,72,119,195,162,15,13,203,199,104,177,115,41,199,4,97,76,160,184,217,245,152,111,68,144,255,211,252,126,80,102,238,27,55,218,86,77,39,185,14,40,64,5,182,198,239,176,164,163,136,12,28,26,176,219,129,127,215,103,57,145,120,210,43,244,31,110,147,3,247,38,59,102,144,154,131,136,63,47,145,237,88,147,41,84,96,68,180,49,7,248,12,223,168,77,30,186,207,241,166,236,223,146,254,137,184,46,70,103,23,155,84,2,112,39,236,187,72,240,113,222,47,76,201,48,128,249,219,85,231,69,99,156,160,63,107,249,199,131,211,23,104,54,193,114,15,138,121,203,55,93,228,174,80,225,92,64,255,84,78,37,152,232,246,115,136,139,174,22,239,55,22,248,64,130,4,157,39,62,188,36,31,233,33,65,120,85,153,175,215,224,139,202,176,92,51,59,182,89,237,94,209,229,85,176,126,80,71,213,25,236,255,108,33,59,98,9,70,135,218,231,233,50,200,130,142,142,112,212,158,237,40,177,249,81,144,95,86,228,130,58,49,88,58,131,9,143,167,230,110,51,31,8,193,134,13,109,166,58,181,164,225,64,189,193,134,252,5,47,41,73,23,74,78,245,175,243,118,34,50,150,17,158,138,120,190,43,152,29,217,151,32,75,201,244,120,46,174,72,192,192,1,253,210,165,102,65,106,28,94,150,247,121,57,42,79,151,150,159,93,242,241,35,229,5,25,107,77,96,126,215,245,142,209,98,231,235,182,222,95,82,142,9,194,55,233,181,122,217,70,0,104,188,33,188,208,234,49,223,136,143,86,99,48,97,249,214,34,4,158,106,154,189,166,189,7,216,193,1,191,54,110,180,173,83,9,8,21,154,78,114,29,255,41,206,165,17,134,123,183,116,225,199,15,205,217,16,146,168,190,172,42,70,17,25,56,35,118,165,128,117,102,198,216,16,1,122,96,254,174,207,114,155,201,115,202,34,241,164,87,71,150,24,239,169,57,173,253,204,94,17,69,6,238,77,118,99,137,241,206,141,38,68,220,232,65,248,100,81,121,47,249,52,30,147,65,218,177,38,83,191,214,154,235,233,198,249,179,140,161,69,11,98,14,240,25,7,105,76,161,190,81,155,60,219,54,39,132,53,153,146,150,80,254,46,46,153,185,84,38,252,222,232,158,18,113,93,140,119,22,225,52,206,46,54,169,171,73,138,17,69,230,63,3,32,129,131,187,118,145,224,227,19,246,92,91,253,89,233,73,152,62,85,241,33,6,130,108,68,97,62,212,170,206,139,198,207,169,55,126,56,65,127,214,93,38,195,110,179,137,118,124,214,238,202,196,111,214,29,89,10,177,161,225,228,30,20,243,129,121,168,75,215,105,203,19,178,14,119,171,92,161,194,185,57,198,126,1,128,254,169,156,229,153,21,36,11,54,160,54,110,81,28,142,167,22,102,134,194,113,218,62,44,222,111,44,73,185,211,148,240,129,4,9,149,230,184,177,123,73,13,163,30,46,177,27,72,62,210,67,45,89,110,251,195,246,219,233,166,145,103,81,31,169,176,204,122,206,12,116,148,97,185,102,241,6,5,222,0,0,0,0,119,7,48,150,238,14,97,44,153,9,81,186,7,109,196,25,112,106,244,143,233,99,165,53,158,100,149,163,14,219,136,50,121,220,184,164,224,213,233,30,151,210,217,136,9,182,76,43,126,177,124,189,231,184,45,7,144,191,29,145,29,183,16,100,106,176,32,242,243,185,113,72,132,190,65,222,26,218,212,125,109,221,228,235,244,212,181,81,131,211,133,199,19,108,152,86,100,107,168,192,253,98,249,122,138,101,201,236,20,1,92,79,99,6,108,217,250,15,61,99,141,8,13,245,59,110,32,200,76,105,16,94,213,96,65,228,162,103,113,114,60,3,228,209,75,4,212,71,210,13,133,253,165,10,181,107,53,181,168,250,66,178,152,108,219,187,201,214,172,188,249,64,50,216,108,227,69,223,92,117,220,214,13,207,171,209,61,89,38,217,48,172,81,222,0,58,200,215,81,128,191,208,97,22,33,180,244,181,86,179,196,35,207,186,149,153,184,189,165,15,40,2,184,158,95,5,136,8,198,12,217,178,177,11,233,36,47,111,124,135,88,104,76,17,193,97,29,171,182,102,45,61,118,220,65,144,1,219,113,6,152,210,32,188,239,213,16,42,113,177,133,137,6,182,181,31,159,191,228,165,232,184,212,51,120,7,201,162,15,0,249,52,150,9,168,142,225,14,152,24,127,106,13,187,8,109,61,45,145,100,108,151,230,99,92,1,107,107,81,244,28,108,97,98,133,101,48,216,242,98,0,78,108,6,149,237,27,1,165,123,130,8,244,193,245,15,196,87,101,176,217,198,18,183,233,80,139,190,184,234,252,185,136,124,98,221,29,223,21,218,45,73,140,211,124,243,251,212,76,101,77,178,97,88,58,181,81,206,163,188,0,116,212,187,48,226,74,223,165,65,61,216,149,215,164,209,196,109,211,214,244,251,67,105,233,106,52,110,217,252,173,103,136,70,218,96,184,208,68,4,45,115,51,3,29,229,170,10,76,95,221,13,124,201,80,5,113,60,39,2,65,170,190,11,16,16,201,12,32,134,87,104,181,37,32,111,133,179,185,102,212,9,206,97,228,159,94,222,249,14,41,217,201,152,176,208,152,34,199,215,168,180,89,179,61,23,46,180,13,129,183,189,92,59,192,186,108,173,237,184,131,32,154,191,179,182,3,182,226,12,116,177,210,154,234,213,71,57,157,210,119,175,4,219,38,21,115,220,22,131,227,99,11,18,148,100,59,132,13,109,106,62,122,106,90,168,228,14,207,11,147,9,255,157,10,0,174,39,125,7,158,177,240,15,147,68,135,8,163,210,30,1,242,104,105,6,194,254,247,98,87,93,128,101,103,203,25,108,54,113,110,107,6,231,254,212,27,118,137,211,43,224,16,218,122,90,103,221,74,204,249,185,223,111,142,190,239,249,23,183,190,67,96,176,142,213,214,214,163,232,161,209,147,126,56,216,194,196,79,223,242,82,209,187,103,241,166,188,87,103,63,181,6,221,72,178,54,75,216,13,43,218,175,10,27,76,54,3,74,246,65,4,122,96,223,96,239,195,168,103,223,85,49,110,142,239,70,105,190,121,203,97,179,140,188,102,131,26,37,111,210,160,82,104,226,54,204,12,119,149,187,11,71,3,34,2,22,185,85,5,38,47,197,186,59,190,178,189,11,40,43,180,90,146,92,179,106,4,194,215,255,167,181,208,207,49,44,217,158,139,91,222,174,29,155,100,194,176,236,99,242,38,117,106,163,156,2,109,147,10,156,9,6,169,235,14,54,63,114,7,103,133,5,0,87,19,149,191,74,130,226,184,122,20,123,177,43,174,12,182,27,56,146,210,142,155,229,213,190,13,124,220,239,183,11,219,223,33,134,211,210,212,241,212,226,66,104,221,179,248,31,218,131,110,129,190,22,205,246,185,38,91,111,176,119,225,24,183,71,119,136,8,90,230,255,15,106,112,102,6,59,202,17,1,11,92,143,101,158,255,248,98,174,105,97,107,255,211,22,108,207,69,160,10,226,120,215,13,210,238,78,4,131,84,57,3,179,194,167,103,38,97,208,96,22,247,73,105,71,77,62,110,119,219,174,209,106,74,217,214,90,220,64,223,11,102,55,216,59,240,169,188,174,83,222,187,158,197,71,178,207,127,48,181,255,233,189,189,242,28,202,186,194,138,83,179,147,48,36,180,163,166,186,208,54,5,205,215,6,147,84,222,87,41,35,217,103,191,179,102,122,46,196,97,74,184,93,104,27,2,42,111,43,148,180,11,190,55,195,12,142,161,90,5,223,27,45,2,239,141,0,0,0,0,25,27,49,65,50,54,98,130,43,45,83,195,100,108,197,4,125,119,244,69,86,90,167,134,79,65,150,199,200,217,138,8,209,194,187,73,250,239,232,138,227,244,217,203,172,181,79,12,181,174,126,77,158,131,45,142,135,152,28,207,74,194,18,81,83,217,35,16,120,244,112,211,97,239,65,146,46,174,215,85,55,181,230,20,28,152,181,215,5,131,132,150,130,27,152,89,155,0,169,24,176,45,250,219,169,54,203,154,230,119,93,93,255,108,108,28,212,65,63,223,205,90,14,158,149,132,36,162,140,159,21,227,167,178,70,32,190,169,119,97,241,232,225,166,232,243,208,231,195,222,131,36,218,197,178,101,93,93,174,170,68,70,159,235,111,107,204,40,118,112,253,105,57,49,107,174,32,42,90,239,11,7,9,44,18,28,56,109,223,70,54,243,198,93,7,178,237,112,84,113,244,107,101,48,187,42,243,247,162,49,194,182,137,28,145,117,144,7,160,52,23,159,188,251,14,132,141,186,37,169,222,121,60,178,239,56,115,243,121,255,106,232,72,190,65,197,27,125,88,222,42,60,240,121,79,5,233,98,126,68,194,79,45,135,219,84,28,198,148,21,138,1,141,14,187,64,166,35,232,131,191,56,217,194,56,160,197,13,33,187,244,76,10,150,167,143,19,141,150,206,92,204,0,9,69,215,49,72,110,250,98,139,119,225,83,202,186,187,93,84,163,160,108,21,136,141,63,214,145,150,14,151,222,215,152,80,199,204,169,17,236,225,250,210,245,250,203,147,114,98,215,92,107,121,230,29,64,84,181,222,89,79,132,159,22,14,18,88,15,21,35,25,36,56,112,218,61,35,65,155,101,253,107,167,124,230,90,230,87,203,9,37,78,208,56,100,1,145,174,163,24,138,159,226,51,167,204,33,42,188,253,96,173,36,225,175,180,63,208,238,159,18,131,45,134,9,178,108,201,72,36,171,208,83,21,234,251,126,70,41,226,101,119,104,47,63,121,246,54,36,72,183,29,9,27,116,4,18,42,53,75,83,188,242,82,72,141,179,121,101,222,112,96,126,239,49,231,230,243,254,254,253,194,191,213,208,145,124,204,203,160,61,131,138,54,250,154,145,7,187,177,188,84,120,168,167,101,57,59,131,152,75,34,152,169,10,9,181,250,201,16,174,203,136,95,239,93,79,70,244,108,14,109,217,63,205,116,194,14,140,243,90,18,67,234,65,35,2,193,108,112,193,216,119,65,128,151,54,215,71,142,45,230,6,165,0,181,197,188,27,132,132,113,65,138,26,104,90,187,91,67,119,232,152,90,108,217,217,21,45,79,30,12,54,126,95,39,27,45,156,62,0,28,221,185,152,0,18,160,131,49,83,139,174,98,144,146,181,83,209,221,244,197,22,196,239,244,87,239,194,167,148,246,217,150,213,174,7,188,233,183,28,141,168,156,49,222,107,133,42,239,42,202,107,121,237,211,112,72,172,248,93,27,111,225,70,42,46,102,222,54,225,127,197,7,160,84,232,84,99,77,243,101,34,2,178,243,229,27,169,194,164,48,132,145,103,41,159,160,38,228,197,174,184,253,222,159,249,214,243,204,58,207,232,253,123,128,169,107,188,153,178,90,253,178,159,9,62,171,132,56,127,44,28,36,176,53,7,21,241,30,42,70,50,7,49,119,115,72,112,225,180,81,107,208,245,122,70,131,54,99,93,178,119,203,250,215,78,210,225,230,15,249,204,181,204,224,215,132,141,175,150,18,74,182,141,35,11,157,160,112,200,132,187,65,137,3,35,93,70,26,56,108,7,49,21,63,196,40,14,14,133,103,79,152,66,126,84,169,3,85,121,250,192,76,98,203,129,129,56,197,31,152,35,244,94,179,14,167,157,170,21,150,220,229,84,0,27,252,79,49,90,215,98,98,153,206,121,83,216,73,225,79,23,80,250,126,86,123,215,45,149,98,204,28,212,45,141,138,19,52,150,187,82,31,187,232,145,6,160,217,208,94,126,243,236,71,101,194,173,108,72,145,110,117,83,160,47,58,18,54,232,35,9,7,169,8,36,84,106,17,63,101,43,150,167,121,228,143,188,72,165,164,145,27,102,189,138,42,39,242,203,188,224,235,208,141,161,192,253,222,98,217,230,239,35,20,188,225,189,13,167,208,252,38,138,131,63,63,145,178,126,112,208,36,185,105,203,21,248,66,230,70,59,91,253,119,122,220,101,107,181,197,126,90,244,238,83,9,55,247,72,56,118,184,9,174,177,161,18,159,240,138,63,204,51,147,36,253,114,0,0,0,0,1,194,106,55,3,132,212,110,2,70,190,89,7,9,168,220,6,203,194,235,4,141,124,178,5,79,22,133,14,19,81,184,15,209,59,143,13,151,133,214,12,85,239,225,9,26,249,100,8,216,147,83,10,158,45,10,11,92,71,61,28,38,163,112,29,228,201,71,31,162,119,30,30,96,29,41,27,47,11,172,26,237,97,155,24,171,223,194,25,105,181,245,18,53,242,200,19,247,152,255,17,177,38,166,16,115,76,145,21,60,90,20,20,254,48,35,22,184,142,122,23,122,228,77,56,77,70,224,57,143,44,215,59,201,146,142,58,11,248,185,63,68,238,60,62,134,132,11,60,192,58,82,61,2,80,101,54,94,23,88,55,156,125,111,53,218,195,54,52,24,169,1,49,87,191,132,48,149,213,179,50,211,107,234,51,17,1,221,36,107,229,144,37,169,143,167,39,239,49,254,38,45,91,201,35,98,77,76,34,160,39,123,32,230,153,34,33,36,243,21,42,120,180,40,43,186,222,31,41,252,96,70,40,62,10,113,45,113,28,244,44,179,118,195,46,245,200,154,47,55,162,173,112,154,141,192,113,88,231,247,115,30,89,174,114,220,51,153,119,147,37,28,118,81,79,43,116,23,241,114,117,213,155,69,126,137,220,120,127,75,182,79,125,13,8,22,124,207,98,33,121,128,116,164,120,66,30,147,122,4,160,202,123,198,202,253,108,188,46,176,109,126,68,135,111,56,250,222,110,250,144,233,107,181,134,108,106,119,236,91,104,49,82,2,105,243,56,53,98,175,127,8,99,109,21,63,97,43,171,102,96,233,193,81,101,166,215,212,100,100,189,227,102,34,3,186,103,224,105,141,72,215,203,32,73,21,161,23,75,83,31,78,74,145,117,121,79,222,99,252,78,28,9,203,76,90,183,146,77,152,221,165,70,196,154,152,71,6,240,175,69,64,78,246,68,130,36,193,65,205,50,68,64,15,88,115,66,73,230,42,67,139,140,29,84,241,104,80,85,51,2,103,87,117,188,62,86,183,214,9,83,248,192,140,82,58,170,187,80,124,20,226,81,190,126,213,90,226,57,232,91,32,83,223,89,102,237,134,88,164,135,177,93,235,145,52,92,41,251,3,94,111,69,90,95,173,47,109,225,53,27,128,224,247,113,183,226,177,207,238,227,115,165,217,230,60,179,92,231,254,217,107,229,184,103,50,228,122,13,5,239,38,74,56,238,228,32,15,236,162,158,86,237,96,244,97,232,47,226,228,233,237,136,211,235,171,54,138,234,105,92,189,253,19,184,240,252,209,210,199,254,151,108,158,255,85,6,169,250,26,16,44,251,216,122,27,249,158,196,66,248,92,174,117,243,0,233,72,242,194,131,127,240,132,61,38,241,70,87,17,244,9,65,148,245,203,43,163,247,141,149,250,246,79,255,205,217,120,93,96,216,186,55,87,218,252,137,14,219,62,227,57,222,113,245,188,223,179,159,139,221,245,33,210,220,55,75,229,215,107,12,216,214,169,102,239,212,239,216,182,213,45,178,129,208,98,164,4,209,160,206,51,211,230,112,106,210,36,26,93,197,94,254,16,196,156,148,39,198,218,42,126,199,24,64,73,194,87,86,204,195,149,60,251,193,211,130,162,192,17,232,149,203,77,175,168,202,143,197,159,200,201,123,198,201,11,17,241,204,68,7,116,205,134,109,67,207,192,211,26,206,2,185,45,145,175,150,64,144,109,252,119,146,43,66,46,147,233,40,25,150,166,62,156,151,100,84,171,149,34,234,242,148,224,128,197,159,188,199,248,158,126,173,207,156,56,19,150,157,250,121,161,152,181,111,36,153,119,5,19,155,49,187,74,154,243,209,125,141,137,53,48,140,75,95,7,142,13,225,94,143,207,139,105,138,128,157,236,139,66,247,219,137,4,73,130,136,198,35,181,131,154,100,136,130,88,14,191,128,30,176,230,129,220,218,209,132,147,204,84,133,81,166,99,135,23,24,58,134,213,114,13,169,226,208,160,168,32,186,151,170,102,4,206,171,164,110,249,174,235,120,124,175,41,18,75,173,111,172,18,172,173,198,37,167,241,129,24,166,51,235,47,164,117,85,118,165,183,63,65,160,248,41,196,161,58,67,243,163,124,253,170,162,190,151,157,181,196,115,208,180,6,25,231,182,64,167,190,183,130,205,137,178,205,219,12,179,15,177,59,177,73,15,98,176,139,101,85,187,215,34,104,186,21,72,95,184,83,246,6,185,145,156,49,188,222,138,180,189,28,224,131,191,90,94,218,190,152,52,237,0,0,0,0,184,188,103,101,170,9,200,139,18,181,175,238,143,98,151,87,55,222,240,50,37,107,95,220,157,215,56,185,197,180,40,239,125,8,79,138,111,189,224,100,215,1,135,1,74,214,191,184,242,106,216,221,224,223,119,51,88,99,16,86,80,25,87,159,232,165,48,250,250,16,159,20,66,172,248,113,223,123,192,200,103,199,167,173,117,114,8,67,205,206,111,38,149,173,127,112,45,17,24,21,63,164,183,251,135,24,208,158,26,207,232,39,162,115,143,66,176,198,32,172,8,122,71,201,160,50,175,62,24,142,200,91,10,59,103,181,178,135,0,208,47,80,56,105,151,236,95,12,133,89,240,226,61,229,151,135,101,134,135,209,221,58,224,180,207,143,79,90,119,51,40,63,234,228,16,134,82,88,119,227,64,237,216,13,248,81,191,104,240,43,248,161,72,151,159,196,90,34,48,42,226,158,87,79,127,73,111,246,199,245,8,147,213,64,167,125,109,252,192,24,53,159,208,78,141,35,183,43,159,150,24,197,39,42,127,160,186,253,71,25,2,65,32,124,16,244,143,146,168,72,232,247,155,20,88,61,35,168,63,88,49,29,144,182,137,161,247,211,20,118,207,106,172,202,168,15,190,127,7,225,6,195,96,132,94,160,112,210,230,28,23,183,244,169,184,89,76,21,223,60,209,194,231,133,105,126,128,224,123,203,47,14,195,119,72,107,203,13,15,162,115,177,104,199,97,4,199,41,217,184,160,76,68,111,152,245,252,211,255,144,238,102,80,126,86,218,55,27,14,185,39,77,182,5,64,40,164,176,239,198,28,12,136,163,129,219,176,26,57,103,215,127,43,210,120,145,147,110,31,244,59,38,247,3,131,154,144,102,145,47,63,136,41,147,88,237,180,68,96,84,12,248,7,49,30,77,168,223,166,241,207,186,254,146,223,236,70,46,184,137,84,155,23,103,236,39,112,2,113,240,72,187,201,76,47,222,219,249,128,48,99,69,231,85,107,63,160,156,211,131,199,249,193,54,104,23,121,138,15,114,228,93,55,203,92,225,80,174,78,84,255,64,246,232,152,37,174,139,136,115,22,55,239,22,4,130,64,248,188,62,39,157,33,233,31,36,153,85,120,65,139,224,215,175,51,92,176,202,237,89,182,59,85,229,209,94,71,80,126,176,255,236,25,213,98,59,33,108,218,135,70,9,200,50,233,231,112,142,142,130,40,237,158,212,144,81,249,177,130,228,86,95,58,88,49,58,167,143,9,131,31,51,110,230,13,134,193,8,181,58,166,109,189,64,225,164,5,252,134,193,23,73,41,47,175,245,78,74,50,34,118,243,138,158,17,150,152,43,190,120,32,151,217,29,120,244,201,75,192,72,174,46,210,253,1,192,106,65,102,165,247,150,94,28,79,42,57,121,93,159,150,151,229,35,241,242,77,107,25,5,245,215,126,96,231,98,209,142,95,222,182,235,194,9,142,82,122,181,233,55,104,0,70,217,208,188,33,188,136,223,49,234,48,99,86,143,34,214,249,97,154,106,158,4,7,189,166,189,191,1,193,216,173,180,110,54,21,8,9,83,29,114,78,154,165,206,41,255,183,123,134,17,15,199,225,116,146,16,217,205,42,172,190,168,56,25,17,70,128,165,118,35,216,198,102,117,96,122,1,16,114,207,174,254,202,115,201,155,87,164,241,34,239,24,150,71,253,173,57,169,69,17,94,204,118,77,238,6,206,241,137,99,220,68,38,141,100,248,65,232,249,47,121,81,65,147,30,52,83,38,177,218,235,154,214,191,179,249,198,233,11,69,161,140,25,240,14,98,161,76,105,7,60,155,81,190,132,39,54,219,150,146,153,53,46,46,254,80,38,84,185,153,158,232,222,252,140,93,113,18,52,225,22,119,169,54,46,206,17,138,73,171,3,63,230,69,187,131,129,32,227,224,145,118,91,92,246,19,73,233,89,253,241,85,62,152,108,130,6,33,212,62,97,68,198,139,206,170,126,55,169,207,214,127,65,56,110,195,38,93,124,118,137,179,196,202,238,214,89,29,214,111,225,161,177,10,243,20,30,228,75,168,121,129,19,203,105,215,171,119,14,178,185,194,161,92,1,126,198,57,156,169,254,128,36,21,153,229,54,160,54,11,142,28,81,110,134,102,22,167,62,218,113,194,44,111,222,44,148,211,185,73,9,4,129,240,177,184,230,149,163,13,73,123,27,177,46,30,67,210,62,72,251,110,89,45,233,219,246,195,81,103,145,166,204,176,169,31,116,12,206,122,102,185,97,148,222,5,6,241,0,0,0,0,0,0,0,0,48,0,0,0,4,0,4,0,8,0,4,0,49,0,0,0,4,0,5,0,16,0,8,0,49,0,0,0,4,0,6,0,32,0,32,0,49,0,0,0,4,0,4,0,16,0,16,0,50,0,0,0,8,0,16,0,32,0,32,0,50,0,0,0,8,0,16,0,128,0,128,0,50,0,0,0,8,0,32,0,128,0,0,1,50,0,0,0,32,0,128,0,2,1,0,4,50,0,0,0,32,0,2,1,2,1,0,16,50,0,0,0,162,8,2,0,80,208,1,0,1,1,0,0,30,1,0,0,15,0,0,0,42,8,2,0,216,207,1,0,0,0,0,0,30,0,0,0,15,0,0,0,0,0,0,0,140,207,1,0,0,0,0,0,19,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,4,0,0,0,5,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,11,0,0,0,12,0,0,0,12,0,0,0,13,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,5,0,0,0,5,0,0,0,5,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,10,0,0,0,12,0,0,0,14,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,32,0,0,0,40,0,0,0,48,0,0,0,56,0,0,0,64,0,0,0,80,0,0,0,96,0,0,0,112,0,0,0,128,0,0,0,160,0,0,0,192,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,6,0,0,0,8,0,0,0,12,0,0,0,16,0,0,0,24,0,0,0,32,0,0,0,48,0,0,0,64,0,0,0,96,0,0,0,128,0,0,0,192,0,0,0,0,1,0,0,128,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,6,0,0,0,8,0,0,0,12,0,0,0,16,0,0,0,24,0,0,0,32,0,0,0,48,0,0,0,64,0,0,0,96,0,0,16,0,0,0,11,0,0,0,10,0,0,0,16,0,0,0,24,0,0,0,40,0,0,0,51,0,0,0,61,0,0,0,12,0,0,0,12,0,0,0,14,0,0,0,19,0,0,0,26,0,0,0,58,0,0,0,60,0,0,0,55,0,0,0,14,0,0,0,13,0,0,0,16,0,0,0,24,0,0,0,40,0,0,0,57,0,0,0,69,0,0,0,56,0,0,0,14,0,0,0,17,0,0,0,22,0,0,0,29,0,0,0,51,0,0,0,87,0,0,0,80,0,0,0,62,0,0,0,18,0,0,0,22,0,0,0,37,0,0,0,56,0,0,0,68,0,0,0,109,0,0,0,103,0,0,0,77,0,0,0,24,0,0,0,35,0,0,0,55,0,0,0,64,0,0,0,81,0,0,0,104,0,0,0,113,0,0,0,92,0,0,0,49,0,0,0,64,0,0,0,78,0,0,0,87,0,0,0,103,0,0,0,121,0,0,0,120,0,0,0,101,0,0,0,72,0,0,0,92,0,0,0,95,0,0,0,98,0,0,0,112,0,0,0,100,0,0,0,103,0,0,0,99,0,0,0,17,0,0,0,18,0,0,0,24,0,0,0,47,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,18,0,0,0,21,0,0,0,26,0,0,0,66,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,24,0,0,0,26,0,0,0,56,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,47,0,0,0,66,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,99,0,0,0,47,129,5,0,69,129,5,0,101,129,5,0,138,129,5,0,164,129,5,0,195,129,5,0,216,129,5,0,245,129,5,0,31,130,5,0,95,130,5,0,126,130,5,0,149,130,5,0,171,130,5,0,191,130,5,0,252,130,5,0,44,131,5,0,72,131,5,0,107,131,5,0,162,131,5,0,217,131,5,0,240,131,5,0,16,132,5,0,58,132,5,0,135,132,5,0,162,132,5,0,205,132,5,0,233,132,5,0,14,133,5,0,52,133,5,0,89,133,5,0,108,133,5,0,129,133,5,0,148,133,5,0,167,133,5,0,204,133,5,0,225,133,5,0,245,133,5,0,22,134,5,0,44,134,5,0,91,134,5,0,131,134,5,0,164,134,5,0,197,134,5,0,244,134,5,0,5,135,5,0,33,135,5,0,95,135,5,0,134,135,5,0,173,135,5,0,193,135,5,0,239,135,5,0,23,136,5,0,51,136,5,0,88,136,5,0,122,136,5,0,164,136,5,0,207,136,5,0,237,136,5,0,27,137,5,0,67,137,5,0,106,137,5,0,149,137,5,0,194,137,5,0,242,137,5,0,28,138,5,0,73,138,5,0,108,138,5,0,138,138,5,0,168,138,5,0,222,138,5,0,8,139,5,0,39,139,5,0,74,139,5,0,113,139,5,0,134,139,5,0,154,139,5,0,207,139,5,0,222,139,5,0,28,140,5,0,94,140,5,0,136,140,5,0,180,140,5,0,219,140,5,0,247,140,5,0,34,141,5,0,61,141,5,0,81,141,5,0,104,141,5,0,117,141,5,0,157,141,5,0,210,141,5,0,14,142,5,0,60,142,5,0,93,142,5,0,132,142,5,0,157,142,5,0,197,142,5,0,232,142,5,0,0,143,5,0,36,143,5,0,73,143,5,0,79,143,5,0,136,143,5,0,194,143,5,0,225,143,5,0,240,143,5,0,13,144,5,0,43,144,5,0,72,144,5,0,97,144,5,0,122,144,5,0,188,144,5,0,246,144,5,0,44,145,5,0,96,145,5,0,116,145,5,0,139,145,5,0,177,145,5,0,216,145,5,0,26,146,5,0,86,146,5,0,135,146,5,0,171,146,5,0,217,146,5,0,244,146,5,0,44,147,5,0,87,147,5,0,0,0,0,0,64,6,0,0,128,62,0,0,0,0,0,0,136,19,0,0,1,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,16,0,0,0,9,0,0,0,2,0,0,0,3,0,0,0,10,0,0,0,17,0,0,0,24,0,0,0,32,0,0,0,25,0,0,0,18,0,0,0,11,0,0,0,4,0,0,0,5,0,0,0,12,0,0,0,19,0,0,0,26,0,0,0,33,0,0,0,40,0,0,0,48,0,0,0,41,0,0,0,34,0,0,0,27,0,0,0,20,0,0,0,13,0,0,0,6,0,0,0,7,0,0,0,14,0,0,0,21,0,0,0,28,0,0,0,35,0,0,0,42,0,0,0,49,0,0,0,56,0,0,0,57,0,0,0,50,0,0,0,43,0,0,0,36,0,0,0,29,0,0,0,22,0,0,0,15,0,0,0,23,0,0,0,30,0,0,0,37,0,0,0,44,0,0,0,51,0,0,0,58,0,0,0,59,0,0,0,52,0,0,0,45,0,0,0,38,0,0,0,31,0,0,0,39,0,0,0,46,0,0,0,53,0,0,0,60,0,0,0,61,0,0,0,54,0,0,0,47,0,0,0,55,0,0,0,62,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,16,0,0,0,9,0,0,0,2,0,0,0,3,0,0,0,10,0,0,0,17,0,0,0,24,0,0,0,32,0,0,0,25,0,0,0,18,0,0,0,11,0,0,0,4,0,0,0,5,0,0,0,12,0,0,0,19,0,0,0,26,0,0,0,33,0,0,0,40,0,0,0,48,0,0,0,41,0,0,0,34,0,0,0,27,0,0,0,20,0,0,0,13,0,0,0,6,0,0,0,14,0,0,0,21,0,0,0,28,0,0,0,35,0,0,0,42,0,0,0,49,0,0,0,50,0,0,0,43,0,0,0,36,0,0,0,29,0,0,0,22,0,0,0,30,0,0,0,37,0,0,0,44,0,0,0,51,0,0,0,52,0,0,0,45,0,0,0,38,0,0,0,46,0,0,0,53,0,0,0,54,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,16,0,0,0,9,0,0,0,2,0,0,0,3,0,0,0,10,0,0,0,17,0,0,0,24,0,0,0,32,0,0,0,25,0,0,0,18,0,0,0,11,0,0,0,4,0,0,0,5,0,0,0,12,0,0,0,19,0,0,0,26,0,0,0,33,0,0,0,40,0,0,0,41,0,0,0,34,0,0,0,27,0,0,0,20,0,0,0,13,0,0,0,21,0,0,0,28,0,0,0,35,0,0,0,42,0,0,0,43,0,0,0,36,0,0,0,29,0,0,0,37,0,0,0,44,0,0,0,45,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,16,0,0,0,9,0,0,0,2,0,0,0,3,0,0,0,10,0,0,0,17,0,0,0,24,0,0,0,32,0,0,0,25,0,0,0,18,0,0,0,11,0,0,0,4,0,0,0,12,0,0,0,19,0,0,0,26,0,0,0,33,0,0,0,34,0,0,0,27,0,0,0,20,0,0,0,28,0,0,0,35,0,0,0,36,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,16,0,0,0,9,0,0,0,2,0,0,0,3,0,0,0,10,0,0,0,17,0,0,0,24,0,0,0,25,0,0,0,18,0,0,0,11,0,0,0,19,0,0,0,26,0,0,0,27,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,16,0,0,0,9,0,0,0,2,0,0,0,10,0,0,0,17,0,0,0,18,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,2,0,0,0,4,0,0,0,6,0,0,0,3,0,0,0,7,0,0,0,8,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,4,0,0,0,7,0,0,0,12,0,0,0,3,0,0,0,8,0,0,0,11,0,0,0,13,0,0,0,9,0,0,0,10,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,14,0,0,0,2,0,0,0,4,0,0,0,7,0,0,0,13,0,0,0,15,0,0,0,3,0,0,0,8,0,0,0,12,0,0,0,16,0,0,0,21,0,0,0,9,0,0,0,11,0,0,0,17,0,0,0,20,0,0,0,22,0,0,0,10,0,0,0,18,0,0,0,19,0,0,0,23,0,0,0,24,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,14,0,0,0,15,0,0,0,2,0,0,0,4,0,0,0,7,0,0,0,13,0,0,0,16,0,0,0,25,0,0,0,3,0,0,0,8,0,0,0,12,0,0,0,17,0,0,0,24,0,0,0,26,0,0,0,9,0,0,0,11,0,0,0,18,0,0,0,23,0,0,0,27,0,0,0,32,0,0,0,10,0,0,0,19,0,0,0,22,0,0,0,28,0,0,0,31,0,0,0,33,0,0,0,20,0,0,0,21,0,0,0,29,0,0,0,30,0,0,0,34,0,0,0,35,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,14,0,0,0,15,0,0,0,27,0,0,0,2,0,0,0,4,0,0,0,7,0,0,0,13,0,0,0,16,0,0,0,26,0,0,0,28,0,0,0,3,0,0,0,8,0,0,0,12,0,0,0,17,0,0,0,25,0,0,0,29,0,0,0,38,0,0,0,9,0,0,0,11,0,0,0,18,0,0,0,24,0,0,0,30,0,0,0,37,0,0,0,39,0,0,0,10,0,0,0,19,0,0,0,23,0,0,0,31,0,0,0,36,0,0,0,40,0,0,0,45,0,0,0,20,0,0,0,22,0,0,0,32,0,0,0,35,0,0,0,41,0,0,0,44,0,0,0,46,0,0,0,21,0,0,0,33,0,0,0,34,0,0,0,42,0,0,0,43,0,0,0,47,0,0,0,48,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,14,0,0,0,15,0,0,0,27,0,0,0,28,0,0,0,2,0,0,0,4,0,0,0,7,0,0,0,13,0,0,0,16,0,0,0,26,0,0,0,29,0,0,0,42,0,0,0,3,0,0,0,8,0,0,0,12,0,0,0,17,0,0,0,25,0,0,0,30,0,0,0,41,0,0,0,43,0,0,0,9,0,0,0,11,0,0,0,18,0,0,0,24,0,0,0,31,0,0,0,40,0,0,0,44,0,0,0,53,0,0,0,10,0,0,0,19,0,0,0,23,0,0,0,32,0,0,0,39,0,0,0,45,0,0,0,52,0,0,0,54,0,0,0,20,0,0,0,22,0,0,0,33,0,0,0,38,0,0,0,46,0,0,0,51,0,0,0,55,0,0,0,60,0,0,0,21,0,0,0,34,0,0,0,37,0,0,0,47,0,0,0,50,0,0,0,56,0,0,0,59,0,0,0,61,0,0,0,35,0,0,0,36,0,0,0,48,0,0,0,49,0,0,0,57,0,0,0,58,0,0,0,62,0,0,0,63,0,0,0,0,0,0,0,1,0,0,0,3,0,0,0,7,0,0,0,15,0,0,0,31,0,0,0,63,0,0,0,127,0,0,0,255,0,0,0,255,1,0,0,255,3,0,0,255,7,0,0,255,15,0,0,255,31,0,0,255,63,0,0,255,127,0,0,129,1,29,90,14,2,134,37,16,3,20,17,18,4,11,8,20,5,216,3,23,6,218,1,25,7,229,0,28,8,111,0,30,9,54,0,33,10,26,0,35,11,13,0,9,12,6,0,10,13,3,0,12,13,1,0,143,15,127,90,36,16,37,63,38,17,242,44,39,18,124,32,40,19,185,23,42,20,130,17,43,21,239,12,45,22,161,9,46,23,47,7,48,24,92,5,49,25,6,4,51,26,3,3,52,27,64,2,54,28,177,1,56,29,68,1,57,30,245,0,59,31,183,0,60,32,138,0,62,33,104,0,63,34,78,0,32,35,59,0,33,9,44,0,165,37,225,90,64,38,76,72,65,39,13,58,67,40,241,46,68,41,31,38,69,42,51,31,70,43,168,25,72,44,24,21,73,45,119,17,74,46,116,14,75,47,251,11,77,48,248,9,78,49,97,8,79,50,6,7,48,51,205,5,50,52,222,4,50,53,15,4,51,54,99,3,52,55,212,2,53,56,92,2,54,57,248,1,55,58,164,1,56,59,96,1,57,60,37,1,58,61,246,0,59,62,203,0,61,63,171,0,61,32,143,0,193,65,18,91,80,66,4,77,81,67,44,65,82,68,216,55,83,69,232,47,84,70,60,41,86,71,121,35,87,72,223,30,87,73,169,26,72,74,78,23,72,75,36,20,74,76,156,17,74,77,107,15,75,78,81,13,77,79,182,11,77,48,64,10,208,81,50,88,88,82,28,77,89,83,142,67,90,84,221,59,91,85,238,52,92,86,174,46,93,87,154,41,86,71,22,37,216,89,112,85,95,90,169,76,96,91,217,68,97,92,34,62,99,93,36,56,99,94,180,50,93,86,23,46,223,96,168,86,101,97,70,79,102,98,229,71,103,99,207,65,104,100,61,60,99,93,94,55,105,102,49,82,106,103,15,76,107,104,57,70,103,99,94,65,233,106,39,86,108,107,231,80,109,103,133,75,110,109,151,85,111,107,79,80,238,111,16,90,112,109,34,85,240,111,235,89,113,113,29,90,240,223,1,0,5,0,0,0,0,0,0,0,0,0,0,0,63],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+112644);allocate([18,0,0,0,19,0,0,0,136,218,86,0,0,4,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,31,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,223,1,0,104,225,1,0,5,0,0,0,0,0,0,0,0,0,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,19,0,0,0,144,222,86,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,225,1,0,9,0,0,0,0,0,0,0,0,0,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,19,0,0,0,152,222,86,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,76,227,1,0,20,0,0,0,67,46,85,84,70,45,56,0,0,0,0,0,0,0,0,0,0,0,0,0,222,18,4,149,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,48,227,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5,95,112,137,0,255,9,47,15,32,230,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,89,0,0,0,90,0,0,0,91,0,0,0,92,0,0,0,93,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,89,0,0,0,90,0,0,0,123,0,0,0,124,0,0,0,125,0,0,0,126,0,0,0,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,162,14,2,0,40,236,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,97,0,0,0,98,0,0,0,99,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,91,0,0,0,92,0,0,0,93,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,97,0,0,0,98,0,0,0,99,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,123,0,0,0,124,0,0,0,125,0,0,0,126,0,0,0,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,78,0,0,21,3,0,0,22,3,0,0,0,0,0,0,168,78,0,0,23,3,0,0,24,3,0,0,10,0,0,0,1,0,0,0,80,0,0,0,39,0,0,0,4,0,0,0,5,0,0,0,2,0,0,0,30,0,0,0,7,0,0,0,23,0,0,0,3,0,0,0,24,0,0,0,0,0,0,0,176,78,0,0,25,3,0,0,26,3,0,0,219,0,0,0,23,0,0,0,81,0,0,0,47,0,0,0,64,0,0,0,65,0,0,0,24,0,0,0,66,0,0,0,67,0,0,0,51,0,0,0,25,0,0,0,52,0,0,0,8,0,0,0,0,0,0,0,184,78,0,0,50,0,0,0,51,0,0,0,248,255,255,255,248,255,255,255,184,78,0,0,52,0,0,0,53,0,0,0,196,240,1,0,216,240,1,0,8,0,0,0,0,0,0,0,208,78,0,0,27,3,0,0,28,3,0,0,248,255,255,255,248,255,255,255,208,78,0,0,29,3,0,0,30,3,0,0,244,240,1,0,8,241,1,0,4,0,0,0,0,0,0,0,232,78,0,0,35,0,0,0,36,0,0,0,252,255,255,255,252,255,255,255,232,78,0,0,37,0,0,0,38,0,0,0,36,241,1,0,56,241,1,0,4,0,0,0,0,0,0,0,0,79,0,0,31,3,0,0,32,3,0,0,252,255,255,255,252,255,255,255,0,79,0,0,33,3,0,0,34,3,0,0,84,241,1,0,104,241,1,0,0,0,0,0,24,79,0,0,35,3,0,0,36,3,0,0,220,0,0,0,23,0,0,0,81,0,0,0,47,0,0,0,68,0,0,0,65,0,0,0,24,0,0,0,66,0,0,0,67,0,0,0,51,0,0,0,26,0,0,0,53,0,0,0,0,0,0,0,40,79,0,0,37,3,0,0,38,3,0,0,221,0,0,0,1,0,0,0,80,0,0,0,39,0,0,0,69,0,0,0,5,0,0,0,2,0,0,0,30,0,0,0,7,0,0,0,23,0,0,0,27,0,0,0,54,0,0,0,0,0,0,0,56,79,0,0,39,3,0,0,40,3,0,0,222,0,0,0,23,0,0,0,81,0,0,0,47,0,0,0,64,0,0,0,65,0,0,0,24,0,0,0,70,0,0,0,71,0,0,0,55,0,0,0,25,0,0,0,52,0,0,0,0,0,0,0,72,79,0,0,41,3,0,0,42,3,0,0,223,0,0,0,1,0,0,0,80,0,0,0,39,0,0,0,4,0,0,0,5,0,0,0,2,0,0,0,72,0,0,0,73,0,0,0,56,0,0,0,3,0,0,0,24,0,0,0,0,0,0,0,88,79,0,0,43,3,0,0,44,3,0,0,45,3,0,0,30,0,0,0,48,0,0,0,28,0,0,0,0,0,0,0,120,79,0,0,46,3,0,0,47,3,0,0,45,3,0,0,31,0,0,0,49,0,0,0,29,0,0,0,0,0,0,0,136,79,0,0,48,3,0,0,49,3,0,0,45,3,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,0,0,0,0,200,79,0,0,50,3,0,0,51,3,0,0,45,3,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,0,0,0,0,0,80,0,0,52,3,0,0,53,3,0,0,45,3,0,0,32,0,0,0,33,0,0,0,52,0,0,0,34,0,0,0,53,0,0,0,1,0,0,0,2,0,0,0,35,0,0,0,0,0,0,0,64,80,0,0,54,3,0,0,55,3,0,0,45,3,0,0,36,0,0,0,37,0,0,0,54,0,0,0,38,0,0,0,55,0,0,0,3,0,0,0,4,0,0,0,39,0,0,0,0,0,0,0,120,80,0,0,56,3,0,0,57,3,0,0,45,3,0,0,74,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,2,0,0,0,248,255,255,255,120,80,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,0,0,0,0,176,80,0,0,58,3,0,0,59,3,0,0,45,3,0,0,82,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,3,0,0,0,248,255,255,255,176,80,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,89,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,224,80,0,0,60,3,0,0,61,3,0,0,45,3,0,0,1,0,0,0,0,0,0,0,8,81,0,0,62,3,0,0,63,3,0,0,45,3,0,0,2,0,0,0,0,0,0,0,40,81,0,0,64,3,0,0,65,3,0,0,45,3,0,0,90,0,0,0,91,0,0,0,224,0,0,0,225,0,0,0,226,0,0,0,227,0,0,0,92,0,0,0,228,0,0,0,229,0,0,0,0,0,0,0,80,81,0,0,66,3,0,0,67,3,0,0,45,3,0,0,93,0,0,0,94,0,0,0,230,0,0,0,231,0,0,0,232,0,0,0,233,0,0,0,95,0,0,0,234,0,0,0,235,0,0,0,0,0,0,0,112,81,0,0,68,3,0,0,69,3,0,0,45,3,0,0,96,0,0,0,97,0,0,0,236,0,0,0,237,0,0,0,238,0,0,0,239,0,0,0,98,0,0,0,240,0,0,0,241,0,0,0,0,0,0,0,144,81,0,0,70,3,0,0,71,3,0,0,45,3,0,0,99,0,0,0,100,0,0,0,242,0,0,0,243,0,0,0,244,0,0,0,245,0,0,0,101,0,0,0,246,0,0,0,247,0,0,0,0,0,0,0,176,81,0,0,72,3,0,0,73,3,0,0,45,3,0,0,3,0,0,0,4,0,0,0,0,0,0,0,216,81,0,0,74,3,0,0,75,3,0,0,45,3,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,82,0,0,76,3,0,0,77,3,0,0,45,3,0,0,1,0,0,0,66,0,0,0,0,0,0,0,40,82,0,0,78,3,0,0,79,3,0,0,45,3,0,0,2,0,0,0,67,0,0,0,0,0,0,0,80,82,0,0,80,3,0,0,81,3,0,0,45,3,0,0,30,0,0,0,82,0,0,0,248,0,0,0,0,0,0,0,120,82,0,0,82,3,0,0,83,3,0,0,45,3,0,0,31,0,0,0,83,0,0,0,249,0,0,0,0,0,0,0,208,82,0,0,84,3,0,0,85,3,0,0,45,3,0,0,4,0,0,0,5,0,0,0,40,0,0,0,102,0,0,0,103,0,0,0,41,0,0,0,104,0,0,0,0,0,0,0,152,82,0,0,84,3,0,0,86,3,0,0,45,3,0,0,4,0,0,0,5,0,0,0,40,0,0,0,102,0,0,0,103,0,0,0,41,0,0,0,104,0,0,0,0,0,0,0,0,83,0,0,87,3,0,0,88,3,0,0,45,3,0,0,6,0,0,0,7,0,0,0,42,0,0,0,105,0,0,0,106,0,0,0,43,0,0,0,107,0,0,0,0,0,0,0,64,83,0,0,89,3,0,0,90,3,0,0,45,3,0,0,0,0,0,0,80,83,0,0,91,3,0,0,92,3,0,0,45,3,0,0,57,0,0,0,32,0,0,0,58,0,0,0,33,0,0,0,59,0,0,0,5,0,0,0,34,0,0,0,44,0,0,0,0,0,0,0,152,83,0,0,93,3,0,0,94,3,0,0,45,3,0,0,108,0,0,0,109,0,0,0,250,0,0,0,251,0,0,0,252,0,0,0,0,0,0,0,168,83,0,0,95,3,0,0,96,3,0,0,45,3,0,0,110,0,0,0,111,0,0,0,253,0,0,0,254,0,0,0,255,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,104,79,0,0,84,3,0,0,97,3,0,0,45,3,0,0,0,0,0,0,120,83,0,0,84,3,0,0,98,3,0,0,45,3,0,0,35,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,60,0,0,0,36,0,0,0,61,0,0,0,37,0,0,0,62,0,0,0,9,0,0,0,38,0,0,0,45,0,0,0,0,0,0,0,224,82,0,0,84,3,0,0,99,3,0,0,45,3,0,0,8,0,0,0,9,0,0,0,46,0,0,0,112,0,0,0,113,0,0,0,47,0,0,0,114,0,0,0,0,0,0,0,32,83,0,0,84,3,0,0,100,3,0,0,45,3,0,0,10,0,0,0,11,0,0,0,48,0,0,0,115,0,0,0,116,0,0,0,49,0,0,0,117,0,0,0,0,0,0,0,168,82,0,0,84,3,0,0,101,3,0,0,45,3,0,0,4,0,0,0,5,0,0,0,40,0,0,0,102,0,0,0,103,0,0,0,41,0,0,0,104,0,0,0,0,0,0,0,168,80,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,0,0,0,0,216,80,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,89,0,0,0,2,0,0,0,166,174,5,0,0,0,0,0,200,83,0,0,102,3,0,0,103,3,0,0,104,3,0,0,105,3,0,0,39,0,0,0,84,0,0,0,68,0,0,0,50,0,0,0,0,0,0,0,240,83,0,0,102,3,0,0,106,3,0,0,104,3,0,0,105,3,0,0,39,0,0,0,85,0,0,0,69,0,0,0,51,0,0,0,0,0,0,0,0,84,0,0,107,3,0,0,108,3,0,0,118,0,0,0,0,0,0,0,16,84,0,0,107,3,0,0,109,3,0,0,118,0,0,0,0,0,0,0,64,84,0,0,102,3,0,0,110,3,0,0,104,3,0,0,105,3,0,0,40,0,0,0,0,0,0,0,48,84,0,0,102,3,0,0,111,3,0,0,104,3,0,0,105,3,0,0,41,0,0,0,0,0,0,0,192,84,0,0,102,3,0,0,112,3,0,0,104,3,0,0,105,3,0,0,42,0,0,0,0,0,0,0,208,84,0,0,102,3,0,0,113,3,0,0,104,3,0,0,105,3,0,0,39,0,0,0,86,0,0,0,70,0,0,0,52,0,0,0,96,7,0,0,0,8,80,0,0,8,16,0,20,8,115,0,18,7,31,0,0,8,112,0,0,8,48,0,0,9,192,0,16,7,10,0,0,8,96,0,0,8,32,0,0,9,160,0,0,8,0,0,0,8,128,0,0,8,64,0,0,9,224,0,16,7,6,0,0,8,88,0,0,8,24,0,0,9,144,0,19,7,59,0,0,8,120,0,0,8,56,0,0,9,208,0,17,7,17,0,0,8,104,0,0,8,40,0,0,9,176,0,0,8,8,0,0,8,136,0,0,8,72,0,0,9,240,0,16,7,4,0,0,8,84,0,0,8,20,0,21,8,227,0,19,7,43,0,0,8,116,0,0,8,52,0,0,9,200,0,17,7,13,0,0,8,100,0,0,8,36,0,0,9,168,0,0,8,4,0,0,8,132,0,0,8,68,0,0,9,232,0,16,7,8,0,0,8,92,0,0,8,28,0,0,9,152,0,20,7,83,0,0,8,124,0,0,8,60,0,0,9,216,0,18,7,23,0,0,8,108,0,0,8,44,0,0,9,184,0,0,8,12,0,0,8,140,0,0,8,76,0,0,9,248,0,16,7,3,0,0,8,82,0,0,8,18,0,21,8,163,0,19,7,35,0,0,8,114,0,0,8,50,0,0,9,196,0,17,7,11,0,0,8,98,0,0,8,34,0,0,9,164,0,0,8,2,0,0,8,130,0,0,8,66,0,0,9,228,0,16,7,7,0,0,8,90,0,0,8,26,0,0,9,148,0,20,7,67,0,0,8,122,0,0,8,58,0,0,9,212,0,18,7,19,0,0,8,106,0,0,8,42,0,0,9,180,0,0,8,10,0,0,8,138,0,0,8,74,0,0,9,244,0,16,7,5,0,0,8,86,0,0,8,22,0,64,8,0,0,19,7,51,0,0,8,118,0,0,8,54,0,0,9,204,0,17,7,15,0,0,8,102,0,0,8,38,0,0,9,172,0,0,8,6,0,0,8,134,0,0,8,70,0,0,9,236,0,16,7,9,0,0,8,94,0,0,8,30,0,0,9,156,0,20,7,99,0,0,8,126,0,0,8,62,0,0,9,220,0,18,7,27,0,0,8,110,0,0,8,46,0,0,9,188,0,0,8,14,0,0,8,142,0,0,8,78,0,0,9,252,0,96,7,0,0,0,8,81,0,0,8,17,0,21,8,131,0,18,7,31,0,0,8,113,0,0,8,49,0,0,9,194,0,16,7,10,0,0,8,97,0,0,8,33,0,0,9,162,0,0,8,1,0,0,8,129,0,0,8,65,0,0,9,226,0,16,7,6,0,0,8,89,0,0,8,25,0,0,9,146,0,19,7,59,0,0,8,121,0,0,8,57,0,0,9,210,0,17,7,17,0,0,8,105,0,0,8,41,0,0,9,178,0,0,8,9,0,0,8,137,0,0,8,73,0,0,9,242,0,16,7,4,0,0,8,85,0,0,8,21,0,16,8,2,1,19,7,43,0,0,8,117,0,0,8,53,0,0,9,202,0,17,7,13,0,0,8,101,0,0,8,37,0,0,9,170,0,0,8,5,0,0,8,133,0,0,8,69,0,0,9,234,0,16,7,8,0,0,8,93,0,0,8,29,0,0,9,154,0,20,7,83,0,0,8,125,0,0,8,61,0,0,9,218,0,18,7,23,0,0,8,109,0,0,8,45,0,0,9,186,0,0,8,13,0,0,8,141,0,0,8,77,0,0,9,250,0,16,7,3,0,0,8,83,0,0,8,19,0,21,8,195,0,19,7,35,0,0,8,115,0,0,8,51,0,0,9,198,0,17,7,11,0,0,8,99,0,0,8,35,0,0,9,166,0,0,8,3,0,0,8,131,0,0,8,67,0,0,9,230,0,16,7,7,0,0,8,91,0,0,8,27,0,0,9,150,0,20,7,67,0,0,8,123,0,0,8,59,0,0,9,214,0,18,7,19,0,0,8,107,0,0,8,43,0,0,9,182,0,0,8,11,0,0,8,139,0,0,8,75,0,0,9,246,0,16,7,5,0,0,8,87,0,0,8,23,0,64,8,0,0,19,7,51,0,0,8,119,0,0,8,55,0,0,9,206,0,17,7,15,0,0,8,103,0,0,8,39,0,0,9,174,0,0,8,7,0,0,8,135,0,0,8,71,0,0,9,238,0,16,7,9,0,0,8,95,0,0,8,31,0,0,9,158,0,20,7,99,0,0,8,127,0,0,8,63,0,0,9,222,0,18,7,27,0,0,8,111,0,0,8,47,0,0,9,190,0,0,8,15,0,0,8,143,0,0,8,79,0,0,9,254,0,96,7,0,0,0,8,80,0,0,8,16,0,20,8,115,0,18,7,31,0,0,8,112,0,0,8,48,0,0,9,193,0,16,7,10,0,0,8,96,0,0,8,32,0,0,9,161,0,0,8,0,0,0,8,128,0,0,8,64,0,0,9,225,0,16,7,6,0,0,8,88,0,0,8,24,0,0,9,145,0,19,7,59,0,0,8,120,0,0,8,56,0,0,9,209,0,17,7,17,0,0,8,104,0,0,8,40,0,0,9,177,0,0,8,8,0,0,8,136,0,0,8,72,0,0,9,241,0,16,7,4,0,0,8,84,0,0,8,20,0,21,8,227,0,19,7,43,0,0,8,116,0,0,8,52,0,0,9,201,0,17,7,13,0,0,8,100,0,0,8,36,0,0,9,169,0,0,8,4,0,0,8,132,0,0,8,68,0,0,9,233,0,16,7,8,0,0,8,92,0,0,8,28,0,0,9,153,0,20,7,83,0,0,8,124,0,0,8,60,0,0,9,217,0,18,7,23,0,0,8,108,0,0,8,44,0,0,9,185,0,0,8,12,0,0,8,140,0,0,8,76,0,0,9,249,0,16,7,3,0,0,8,82,0,0,8,18,0,21,8,163,0,19,7,35,0,0,8,114,0,0,8,50,0,0,9,197,0,17,7,11,0,0,8,98,0,0,8,34,0,0,9,165,0,0,8,2,0,0,8,130,0,0,8,66,0,0,9,229,0,16,7,7,0,0,8,90,0,0,8,26,0,0,9,149,0,20,7,67,0,0,8,122,0,0,8,58,0,0,9,213,0,18,7,19,0,0,8,106,0,0,8,42,0,0,9,181,0,0,8,10,0,0,8,138,0,0,8,74,0,0,9,245,0,16,7,5,0,0,8,86,0,0,8,22,0,64,8,0,0,19,7,51,0,0,8,118,0,0,8,54,0,0,9,205,0,17,7,15,0,0,8,102,0,0,8,38,0,0,9,173,0,0,8,6,0,0,8,134,0,0,8,70,0,0,9,237,0,16,7,9,0,0,8,94,0,0,8,30,0,0,9,157,0,20,7,99,0,0,8,126,0,0,8,62,0,0,9,221,0,18,7,27,0,0,8,110,0,0,8,46,0,0,9,189,0,0,8,14,0,0,8,142,0,0,8,78,0,0,9,253,0,96,7,0,0,0,8,81,0,0,8,17,0,21,8,131,0,18,7,31,0,0,8,113,0,0,8,49,0,0,9,195,0,16,7,10,0,0,8,97,0,0,8,33,0,0,9,163,0,0,8,1,0,0,8,129,0,0,8,65,0,0,9,227,0,16,7,6,0,0,8,89,0,0,8,25,0,0,9,147,0,19,7,59,0,0,8,121,0,0,8,57,0,0,9,211,0,17,7,17,0,0,8,105,0,0,8,41,0,0,9,179,0,0,8,9,0,0,8,137,0,0,8,73,0,0,9,243,0,16,7,4,0,0,8,85,0,0,8,21,0,16,8,2,1,19,7,43,0,0,8,117,0,0,8,53,0,0,9,203,0,17,7,13,0,0,8,101,0,0,8,37,0,0,9,171,0,0,8,5,0,0,8,133,0,0,8,69,0,0,9,235,0,16,7,8,0,0,8,93,0,0,8,29,0,0,9,155,0,20,7,83,0,0,8,125,0,0,8,61,0,0,9,219,0,18,7,23,0,0,8,109,0,0,8,45,0,0,9,187,0,0,8,13,0,0,8,141,0,0,8,77,0,0,9,251,0,16,7,3,0,0,8,83,0,0,8,19,0,21,8,195,0,19,7,35,0,0,8,115,0,0,8,51,0,0,9,199,0,17,7,11,0,0,8,99,0,0,8,35,0,0,9,167,0,0,8,3,0,0,8,131,0,0,8,67,0,0,9,231,0,16,7,7,0,0,8,91,0,0,8,27,0,0,9,151,0,20,7,67,0,0,8,123,0,0,8,59,0,0,9,215,0,18,7,19,0,0,8,107,0,0,8,43,0,0,9,183,0,0,8,11,0,0,8,139,0,0,8,75,0,0,9,247,0,16,7,5,0,0,8,87,0,0,8,23,0,64,8,0,0,19,7,51,0,0,8,119,0,0,8,55,0,0,9,207,0,17,7,15,0,0,8,103,0,0,8,39,0,0,9,175,0,0,8,7,0,0,8,135,0,0,8,71,0,0,9,239,0,16,7,9,0,0,8,95,0,0,8,31,0,0,9,159,0,20,7,99,0,0,8,127,0,0,8,63,0,0,9,223,0,18,7,27,0,0,8,111,0,0,8,47,0,0,9,191,0,0,8,15,0,0,8,143,0,0,8,79,0,0,9,255,0,16,5,1,0,23,5,1,1,19,5,17,0,27,5,1,16,17,5,5,0,25,5,1,4,21,5,65,0,29,5,1,64,16,5,3,0,24,5,1,2,20,5,33,0,28,5,1,32,18,5,9,0,26,5,1,8,22,5,129,0,64,5,0,0,16,5,2,0,23,5,129,1,19,5,25,0,27,5,1,24,17,5,7,0,25,5,1,6,21,5,97,0,29,5,1,96,16,5,4,0,24,5,1,3,20,5,49,0,28,5,1,48,18,5,13,0,26,5,1,12,22,5,193,0,64,5,0,0,16,0,17,0,18,0,0,0,8,0,7,0,9,0,6,0,10,0,5,0,11,0,4,0,12,0,3,0,13,0,2,0,14,0,1,0,15,0,1,0,2,0,3,0,4,0,5,0,7,0,9,0,13,0,17,0,25,0,33,0,49,0,65,0,97,0,129,0,193,0,1,1,129,1,1,2,1,3,1,4,1,6,1,8,1,12,1,16,1,24,1,32,1,48,1,64,1,96,0,0,0,0,3,0,4,0,5,0,6,0,7,0,8,0,9,0,10,0,11,0,13,0,15,0,17,0,19,0,23,0,27,0,31,0,35,0,43,0,51,0,59,0,67,0,83,0,99,0,115,0,131,0,163,0,195,0,227,0,2,1,0,0,0,0,16,0,16,0,16,0,16,0,17,0,17,0,18,0,18,0,19,0,19,0,20,0,20,0,21,0,21,0,22,0,22,0,23,0,23,0,24,0,24,0,25,0,25,0,26,0,26,0,27,0,27,0,28,0,28,0,29,0,29,0,64,0,64,0,16,0,16,0,16,0,16,0,16,0,16,0,16,0,16,0,17,0,17,0,17,0,17,0,18,0,18,0,18,0,18,0,19,0,19,0,19,0,19],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+122892);allocate([20,0,20,0,20,0,20,0,21,0,21,0,21,0,21,0,16,0,72,0,78,0,0,0,5,0,16,0,5,0,8,0,5,0,24,0,5,0,4,0,5,0,20,0,5,0,12,0,5,0,28,0,5,0,2,0,5,0,18,0,5,0,10,0,5,0,26,0,5,0,6,0,5,0,22,0,5,0,14,0,5,0,30,0,5,0,1,0,5,0,17,0,5,0,9,0,5,0,25,0,5,0,5,0,5,0,21,0,5,0,13,0,5,0,29,0,5,0,3,0,5,0,19,0,5,0,11,0,5,0,27,0,5,0,7,0,5,0,23,0,5,0,12,0,8,0,140,0,8,0,76,0,8,0,204,0,8,0,44,0,8,0,172,0,8,0,108,0,8,0,236,0,8,0,28,0,8,0,156,0,8,0,92,0,8,0,220,0,8,0,60,0,8,0,188,0,8,0,124,0,8,0,252,0,8,0,2,0,8,0,130,0,8,0,66,0,8,0,194,0,8,0,34,0,8,0,162,0,8,0,98,0,8,0,226,0,8,0,18,0,8,0,146,0,8,0,82,0,8,0,210,0,8,0,50,0,8,0,178,0,8,0,114,0,8,0,242,0,8,0,10,0,8,0,138,0,8,0,74,0,8,0,202,0,8,0,42,0,8,0,170,0,8,0,106,0,8,0,234,0,8,0,26,0,8,0,154,0,8,0,90,0,8,0,218,0,8,0,58,0,8,0,186,0,8,0,122,0,8,0,250,0,8,0,6,0,8,0,134,0,8,0,70,0,8,0,198,0,8,0,38,0,8,0,166,0,8,0,102,0,8,0,230,0,8,0,22,0,8,0,150,0,8,0,86,0,8,0,214,0,8,0,54,0,8,0,182,0,8,0,118,0,8,0,246,0,8,0,14,0,8,0,142,0,8,0,78,0,8,0,206,0,8,0,46,0,8,0,174,0,8,0,110,0,8,0,238,0,8,0,30,0,8,0,158,0,8,0,94,0,8,0,222,0,8,0,62,0,8,0,190,0,8,0,126,0,8,0,254,0,8,0,1,0,8,0,129,0,8,0,65,0,8,0,193,0,8,0,33,0,8,0,161,0,8,0,97,0,8,0,225,0,8,0,17,0,8,0,145,0,8,0,81,0,8,0,209,0,8,0,49,0,8,0,177,0,8,0,113,0,8,0,241,0,8,0,9,0,8,0,137,0,8,0,73,0,8,0,201,0,8,0,41,0,8,0,169,0,8,0,105,0,8,0,233,0,8,0,25,0,8,0,153,0,8,0,89,0,8,0,217,0,8,0,57,0,8,0,185,0,8,0,121,0,8,0,249,0,8,0,5,0,8,0,133,0,8,0,69,0,8,0,197,0,8,0,37,0,8,0,165,0,8,0,101,0,8,0,229,0,8,0,21,0,8,0,149,0,8,0,85,0,8,0,213,0,8,0,53,0,8,0,181,0,8,0,117,0,8,0,245,0,8,0,13,0,8,0,141,0,8,0,77,0,8,0,205,0,8,0,45,0,8,0,173,0,8,0,109,0,8,0,237,0,8,0,29,0,8,0,157,0,8,0,93,0,8,0,221,0,8,0,61,0,8,0,189,0,8,0,125,0,8,0,253,0,8,0,19,0,9,0,19,1,9,0,147,0,9,0,147,1,9,0,83,0,9,0,83,1,9,0,211,0,9,0,211,1,9,0,51,0,9,0,51,1,9,0,179,0,9,0,179,1,9,0,115,0,9,0,115,1,9,0,243,0,9,0,243,1,9,0,11,0,9,0,11,1,9,0,139,0,9,0,139,1,9,0,75,0,9,0,75,1,9,0,203,0,9,0,203,1,9,0,43,0,9,0,43,1,9,0,171,0,9,0,171,1,9,0,107,0,9,0,107,1,9,0,235,0,9,0,235,1,9,0,27,0,9,0,27,1,9,0,155,0,9,0,155,1,9,0,91,0,9,0,91,1,9,0,219,0,9,0,219,1,9,0,59,0,9,0,59,1,9,0,187,0,9,0,187,1,9,0,123,0,9,0,123,1,9,0,251,0,9,0,251,1,9,0,7,0,9,0,7,1,9,0,135,0,9,0,135,1,9,0,71,0,9,0,71,1,9,0,199,0,9,0,199,1,9,0,39,0,9,0,39,1,9,0,167,0,9,0,167,1,9,0,103,0,9,0,103,1,9,0,231,0,9,0,231,1,9,0,23,0,9,0,23,1,9,0,151,0,9,0,151,1,9,0,87,0,9,0,87,1,9,0,215,0,9,0,215,1,9,0,55,0,9,0,55,1,9,0,183,0,9,0,183,1,9,0,119,0,9,0,119,1,9,0,247,0,9,0,247,1,9,0,15,0,9,0,15,1,9,0,143,0,9,0,143,1,9,0,79,0,9,0,79,1,9,0,207,0,9,0,207,1,9,0,47,0,9,0,47,1,9,0,175,0,9,0,175,1,9,0,111,0,9,0,111,1,9,0,239,0,9,0,239,1,9,0,31,0,9,0,31,1,9,0,159,0,9,0,159,1,9,0,95,0,9,0,95,1,9,0,223,0,9,0,223,1,9,0,63,0,9,0,63,1,9,0,191,0,9,0,191,1,9,0,127,0,9,0,127,1,9,0,255,0,9,0,255,1,9,0,0,0,7,0,64,0,7,0,32,0,7,0,96,0,7,0,16,0,7,0,80,0,7,0,48,0,7,0,112,0,7,0,8,0,7,0,72,0,7,0,40,0,7,0,104,0,7,0,24,0,7,0,88,0,7,0,56,0,7,0,120,0,7,0,4,0,7,0,68,0,7,0,36,0,7,0,100,0,7,0,20,0,7,0,84,0,7,0,52,0,7,0,116,0,7,0,3,0,8,0,131,0,8,0,67,0,8,0,195,0,8,0,35,0,8,0,163,0,8,0,99,0,8,0,227,0,8,0,0,64,197,88,159,83,66,75,0,64,73,50,163,34,168,17,197,88,33,123,252,115,98,104,197,88,191,69,11,48,126,24,159,83,252,115,65,109,84,98,159,83,179,65,65,45,18,23,66,75,98,104,84,98,126,88,66,75,33,59,186,40,195,20,0,64,197,88,159,83,66,75,0,64,73,50,163,34,168,17,73,50,191,69,179,65,33,59,73,50,130,39,55,27,224,13,163,34,11,48,65,45,186,40,163,34,55,27,191,18,142,9,168,17,126,24,18,23,195,20,168,17,224,13,142,9,223,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,3,32,2,32,2,32,2,32,2,32,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,1,96,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,4,192,4,192,4,192,4,192,4,192,4,192,4,192,8,213,8,213,8,213,8,213,8,213,8,213,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,4,192,4,192,4,192,4,192,4,192,4,192,8,214,8,214,8,214,8,214,8,214,8,214,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,4,192,4,192,4,192,4,192,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,117,115,104,0,73,110,116,86,101,99,116,111,114,0,70,108,111,97,116,86,101,99,116,111,114,0,68,111,117,98,108,101,86,101,99,116,111,114,0,80,111,105,110,116,86,101,99,116,111,114,0,77,97,116,86,101,99,116,111,114,0,75,101,121,80,111,105,110,116,86,101,99,116,111,114,0,75,101,121,80,111,105,110,116,86,101,99,116,111,114,86,101,99,116,111,114,0,82,101,99,116,86,101,99,116,111,114,0,68,77,97,116,99,104,86,101,99,116,111,114,0,68,77,97,116,99,104,86,101,99,116,111,114,86,101,99,116,111,114,0,101,121,101,0,111,110,101,115,0,122,101,114,111,115,0,109,97,116,83,105,122,101,0,115,116,101,112,0,100,97,116,97,56,83,0,100,97,116,97,49,54,85,0,100,97,116,97,49,54,83,0,100,97,116,97,51,50,83,0,100,97,116,97,51,50,70,0,100,97,116,97,54,52,70,0,101,108,101,109,83,105,122,101,0,101,108,101,109,83,105,122,101,49,0,99,104,97,110,110,101,108,115,0,114,111,119,0,114,111,119,82,97,110,103,101,0,99,111,108,82,97,110,103,101,0,115,116,101,112,49,0,99,108,111,110,101,0,100,101,112,116,104,0,99,111,108,0,109,117,108,0,105,110,118,0,116,0,112,116,114,0,117,99,104,97,114,80,116,114,0,99,104,97,114,80,116,114,0,115,104,111,114,116,80,116,114,0,117,115,104,111,114,116,80,116,114,0,105,110,116,80,116,114,0,102,108,111,97,116,80,116,114,0,100,111,117,98,108,101,80,116,114,0,99,104,97,114,65,116,0,117,99,104,97,114,65,116,0,115,104,111,114,116,65,116,0,117,115,104,111,114,116,65,116,0,105,110,116,65,116,0,102,108,111,97,116,65,116,0,100,111,117,98,108,101,65,116,0,82,97,110,103,101,0,101,110,100,0,84,101,114,109,67,114,105,116,101,114,105,97,0,109,97,120,67,111,117,110,116,0,101,112,115,105,108,111,110,0,35,116,121,112,101,0,82,101,99,116,0,82,101,99,116,50,102,0,82,111,116,97,116,101,100,82,101,99,116,0,99,101,110,116,101,114,0,97,110,103,108,101,0,114,111,116,97,116,101,100,82,101,99,116,80,111,105,110,116,115,0,114,111,116,97,116,101,100,82,101,99,116,66,111,117,110,100,105,110,103,82,101,99,116,0,114,111,116,97,116,101,100,82,101,99,116,66,111,117,110,100,105,110,103,82,101,99,116,50,102,0,83,99,97,108,97,114,0,77,105,110,77,97,120,76,111,99,0,109,105,110,86,97,108,0,109,97,120,86,97,108,0,109,105,110,76,111,99,0,109,97,120,76,111,99,0,67,105,114,99,108,101,0,114,97,100,105,117,115,0,77,111,109,101,110,116,115,0,109,48,48,0,109,49,48,0,109,48,49,0,109,50,48,0,109,49,49,0,109,48,50,0,109,51,48,0,109,50,49,0,109,49,50,0,109,48,51,0,109,117,50,48,0,109,117,49,49,0,109,117,48,50,0,109,117,51,48,0,109,117,50,49,0,109,117,49,50,0,109,117,48,51,0,110,117,50,48,0,110,117,49,49,0,110,117,48,50,0,110,117,51,48,0,110,117,50,49,0,110,117,49,50,0,110,117,48,51,0,69,120,99,101,112,116,105,111,110,0,99,111,100,101,0,109,115,103,0,101,120,99,101,112,116,105,111,110,70,114,111,109,80,116,114,0,109,111,114,112,104,111,108,111,103,121,68,101,102,97,117,108,116,66,111,114,100,101,114,86,97,108,117,101,0,67,86,95,77,65,84,95,68,69,80,84,72,0,67,97,109,83,104,105,102,116,0,103,101,116,66,117,105,108,100,73,110,102,111,114,109,97,116,105,111,110,0,67,86,95,56,85,67,49,0,67,86,95,56,85,67,50,0,67,86,95,56,85,67,51,0,67,86,95,56,85,67,52,0,67,86,95,56,83,67,49,0,67,86,95,56,83,67,50,0,67,86,95,56,83,67,51,0,67,86,95,56,83,67,52,0,67,86,95,49,54,85,67,49,0,67,86,95,49,54,85,67,50,0,67,86,95,49,54,85,67,51,0,67,86,95,49,54,85,67,52,0,67,86,95,49,54,83,67,49,0,67,86,95,49,54,83,67,50,0,67,86,95,49,54,83,67,51,0,67,86,95,49,54,83,67,52,0,67,86,95,51,50,83,67,49,0,67,86,95,51,50,83,67,50,0,67,86,95,51,50,83,67,51,0,67,86,95,51,50,83,67,52,0,67,86,95,51,50,70,67,49,0,67,86,95,51,50,70,67,50,0,67,86,95,51,50,70,67,51,0,67,86,95,51,50,70,67,52,0,67,86,95,54,52,70,67,49,0,67,86,95,54,52,70,67,50,0,67,86,95,54,52,70,67,51,0,67,86,95,54,52,70,67,52,0,67,86,95,56,85,0,67,86,95,56,83,0,67,86,95,49,54,85,0,67,86,95,49,54,83,0,67,86,95,51,50,83,0,67,86,95,51,50,70,0,67,86,95,54,52,70,0,73,78,84,95,77,73,78,0,73,78,84,95,77,65,88,0,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,80,97,114,97,109,115,0,79,82,66,95,72,65,82,82,73,83,95,83,67,79,82,69,0,79,82,66,95,70,65,83,84,95,83,67,79,82,69,0,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,84,89,80,69,95,53,95,56,0,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,84,89,80,69,95,55,95,49,50,0,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,84,89,80,69,95,57,95,49,54,0,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,84,72,82,69,83,72,79,76,68,0,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,78,79,78,77,65,88,95,83,85,80,80,82,69,83,83,73,79,78,0,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,70,65,83,84,95,78,0,68,77,97,116,99,104,0,100,105,115,116,97,110,99,101,0,105,109,103,73,100,120,0,113,117,101,114,121,73,100,120,0,116,114,97,105,110,73,100,120,0,75,101,121,80,111,105,110,116,0,112,116,0,114,101,115,112,111,110,115,101,0,111,99,116,97,118,101,0,99,108,97,115,115,95,105,100,0,67,97,110,110,121,49,0,71,97,117,115,115,105,97,110,66,108,117,114,0,72,111,117,103,104,67,105,114,99,108,101,115,0,72,111,117,103,104,76,105,110,101,115,0,72,111,117,103,104,76,105,110,101,115,80,0,76,97,112,108,97,99,105,97,110,0,83,99,104,97,114,114,0,83,111,98,101,108,0,97,98,115,100,105,102,102,0,97,100,100,87,101,105,103,104,116,101,100,0,98,105,116,119,105,115,101,95,97,110,100,0,98,105,116,119,105,115,101,95,110,111,116,0,98,105,116,119,105,115,101,95,111,114,0,98,105,116,119,105,115,101,95,120,111,114,0,98,108,117,114,0,98,111,117,110,100,105,110,103,82,101,99,116,0,98,111,120,70,105,108,116,101,114,0,99,97,108,99,79,112,116,105,99,97,108,70,108,111,119,70,97,114,110,101,98,97,99,107,0,99,97,108,99,79,112,116,105,99,97,108,70,108,111,119,80,121,114,76,75,0,99,111,114,110,101,114,72,97,114,114,105,115,0,99,111,114,110,101,114,77,105,110,69,105,103,101,110,86,97,108,0,100,105,108,97,116,101,0,100,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,87,105,116,104,76,97,98,101,108,115,0,100,105,118,105,100,101,0,100,105,118,105,100,101,49,0,101,108,108,105,112,115,101,49,0,101,108,108,105,112,115,101,50,80,111,108,121,0,101,114,111,100,101,0,102,105,108,116,101,114,50,68,0,103,101,116,79,112,116,105,109,97,108,68,70,84,83,105,122,101,0,103,101,116,82,111,116,97,116,105,111,110,77,97,116,114,105,120,50,68,0,103,111,111,100,70,101,97,116,117,114,101,115,84,111,84,114,97,99,107,49,0,105,109,100,101,99,111,100,101,0,105,110,116,101,103,114,97,108,50,0,109,97,120,0,109,105,110,0,109,105,110,65,114,101,97,82,101,99,116,0,109,117,108,116,105,112,108,121,0,110,111,114,109,49,0,112,117,116,84,101,120,116,0,114,97,110,100,110,0,114,97,110,100,117,0,115,101,116,82,78,71,83,101,101,100,0,115,113,114,116,0,115,117,98,116,114,97,99,116,0,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,0,80,116,114,60,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,62,0,72,79,71,68,101,115,99,114,105,112,116,111,114,0,108,111,97,100,0,103,101,116,68,101,102,97,117,108,116,80,101,111,112,108,101,68,101,116,101,99,116,111,114,0,103,101,116,68,97,105,109,108,101,114,80,101,111,112,108,101,68,101,116,101,99,116,111,114,0,115,118,109,68,101,116,101,99,116,111,114,0,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,0,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,0,80,116,114,60,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,62,0,67,76,65,72,69,0,115,101,116,84,105,108,101,115,71,114,105,100,83,105,122,101,0,99,111,108,108,101,99,116,71,97,114,98,97,103,101,0,115,101,116,67,108,105,112,76,105,109,105,116,0,103,101,116,84,105,108,101,115,71,114,105,100,83,105,122,101,0,103,101,116,67,108,105,112,76,105,109,105,116,0,80,116,114,60,67,76,65,72,69,62,0,65,108,103,111,114,105,116,104,109,0,103,101,116,68,101,102,97,117,108,116,78,97,109,101,0,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,0,109,97,116,99,104,0,80,116,114,60,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,62,0,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,0,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,50,0,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,51,0,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,0,103,101,116,78,111,110,109,97,120,83,117,112,112,114,101,115,115,105,111,110,0,103,101,116,84,104,114,101,115,104,111,108,100,0,103,101,116,84,121,112,101,0,115,101,116,78,111,110,109,97,120,83,117,112,112,114,101,115,115,105,111,110,0,115,101,116,84,104,114,101,115,104,111,108,100,0,115,101,116,84,121,112,101,0,80,116,114,60,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,62,0,79,82,66,0,103,101,116,77,97,120,70,101,97,116,117,114,101,115,0,115,101,116,69,100,103,101,84,104,114,101,115,104,111,108,100,0,115,101,116,70,105,114,115,116,76,101,118,101,108,0,103,101,116,70,97,115,116,84,104,114,101,115,104,111,108,100,0,115,101,116,77,97,120,70,101,97,116,117,114,101,115,0,103,101,116,87,84,65,95,75,0,103,101,116,78,76,101,118,101,108,115,0,115,101,116,78,76,101,118,101,108,115,0,115,101,116,70,97,115,116,84,104,114,101,115,104,111,108,100,0,103,101,116,83,99,97,108,101,70,97,99,116,111,114,0,115,101,116,80,97,116,99,104,83,105,122,101,0,115,101,116,87,84,65,95,75,0,115,101,116,83,99,97,108,101,70,97,99,116,111,114,0,103,101,116,80,97,116,99,104,83,105,122,101,0,103,101,116,69,100,103,101,84,104,114,101,115,104,111,108,100,0,103,101,116,70,105,114,115,116,76,101,118,101,108,0,103,101,116,83,99,111,114,101,84,121,112,101,0,115,101,116,83,99,111,114,101,84,121,112,101,0,80,116,114,60,79,82,66,62,0,65,67,67,69,83,83,95,70,65,83,84,0,65,67,67,69,83,83,95,77,65,83,75,0,65,67,67,69,83,83,95,82,69,65,68,0,65,67,67,69,83,83,95,82,87,0,65,67,67,69,83,83,95,87,82,73,84,69,0,65,68,65,80,84,73,86,69,95,84,72,82,69,83,72,95,71,65,85,83,83,73,65,78,95,67,0,65,68,65,80,84,73,86,69,95,84,72,82,69,83,72,95,77,69,65,78,95,67,0,65,75,65,90,69,95,68,69,83,67,82,73,80,84,79,82,95,75,65,90,69,0,65,75,65,90,69,95,68,69,83,67,82,73,80,84,79,82,95,75,65,90,69,95,85,80,82,73,71,72,84,0,65,75,65,90,69,95,68,69,83,67,82,73,80,84,79,82,95,77,76,68,66,0,65,75,65,90,69,95,68,69,83,67,82,73,80,84,79,82,95,77,76,68,66,95,85,80,82,73,71,72,84,0,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,65,71,65,83,84,95,53,95,56,0,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,65,71,65,83,84,95,55,95,49,50,100,0,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,65,71,65,83,84,95,55,95,49,50,115,0,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,78,79,78,77,65,88,95,83,85,80,80,82,69,83,83,73,79,78,0,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,79,65,83,84,95,57,95,49,54,0,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,84,72,82,69,83,72,79,76,68,0,66,79,82,68,69,82,95,67,79,78,83,84,65,78,84,0,66,79,82,68,69,82,95,68,69,70,65,85,76,84,0,66,79,82,68,69,82,95,73,83,79,76,65,84,69,68,0,66,79,82,68,69,82,95,82,69,70,76,69,67,84,0,66,79,82,68,69,82,95,82,69,70,76,69,67,84,49,48,49,0,66,79,82,68,69,82,95,82,69,70,76,69,67,84,95,49,48,49,0,66,79,82,68,69,82,95,82,69,80,76,73,67,65,84,69,0,66,79,82,68,69,82,95,84,82,65,78,83,80,65,82,69,78,84,0,66,79,82,68,69,82,95,87,82,65,80,0,67,65,83,67,65,68,69,95,68,79,95,67,65,78,78,89,95,80,82,85,78,73,78,71,0,67,65,83,67,65,68,69,95,68,79,95,82,79,85,71,72,95,83,69,65,82,67,72,0,67,65,83,67,65,68,69,95,70,73,78,68,95,66,73,71,71,69,83,84,95,79,66,74,69,67,84,0,67,65,83,67,65,68,69,95,83,67,65,76,69,95,73,77,65,71,69,0,67,67,76,95,68,69,70,65,85,76,84,0,67,67,76,95,71,82,65,78,65,0,67,67,76,95,87,85,0,67,67,95,83,84,65,84,95,65,82,69,65,0,67,67,95,83,84,65,84,95,72,69,73,71,72,84,0,67,67,95,83,84,65,84,95,76,69,70,84,0,67,67,95,83,84,65,84,95,77,65,88,0,67,67,95,83,84,65,84,95,84,79,80,0,67,67,95,83,84,65,84,95,87,73,68,84,72,0,67,72,65,73,78,95,65,80,80,82,79,88,95,78,79,78,69,0,67,72,65,73,78,95,65,80,80,82,79,88,95,83,73,77,80,76,69,0,67,72,65,73,78,95,65,80,80,82,79,88,95,84,67,56,57,95,75,67,79,83,0,67,72,65,73,78,95,65,80,80,82,79,88,95,84,67,56,57,95,76,49,0,67,77,80,95,69,81,0,67,77,80,95,71,69,0,67,77,80,95,71,84,0,67,77,80,95,76,69,0,67,77,80,95,76,84,0,67,77,80,95,78,69,0,67,79,76,79,82,77,65,80,95,65,85,84,85,77,78,0,67,79,76,79,82,77,65,80,95,66,79,78,69,0,67,79,76,79,82,77,65,80,95,67,79,79,76,0,67,79,76,79,82,77,65,80,95,72,79,84,0,67,79,76,79,82,77,65,80,95,72,83,86,0,67,79,76,79,82,77,65,80,95,74,69,84,0,67,79,76,79,82,77,65,80,95,79,67,69,65,78,0,67,79,76,79,82,77,65,80,95,80,65,82,85,76,65,0,67,79,76,79,82,77,65,80,95,80,73,78,75,0,67,79,76,79,82,77,65,80,95,82,65,73,78,66,79,87,0,67,79,76,79,82,77,65,80,95,83,80,82,73,78,71,0,67,79,76,79,82,77,65,80,95,83,85,77,77,69,82,0,67,79,76,79,82,77,65,80,95,87,73,78,84,69,82,0,67,79,76,79,82,95,66,71,82,50,66,71,82,53,53,53,0,67,79,76,79,82,95,66,71,82,50,66,71,82,53,54,53,0,67,79,76,79,82,95,66,71,82,50,66,71,82,65,0,67,79,76,79,82,95,66,71,82,50,71,82,65,89,0,67,79,76,79,82,95,66,71,82,50,72,76,83,0,67,79,76,79,82,95,66,71,82,50,72,76,83,95,70,85,76,76,0,67,79,76,79,82,95,66,71,82,50,72,83,86,0,67,79,76,79,82,95,66,71,82,50,72,83,86,95,70,85,76,76,0,67,79,76,79,82,95,66,71,82,50,76,97,98,0,67,79,76,79,82,95,66,71,82,50,76,117,118,0,67,79,76,79,82,95,66,71,82,50,82,71,66,0,67,79,76,79,82,95,66,71,82,50,82,71,66,65,0,67,79,76,79,82,95,66,71,82,50,88,89,90,0,67,79,76,79,82,95,66,71,82,50,89,67,114,67,98,0,67,79,76,79,82,95,66,71,82,50,89,85,86,0,67,79,76,79,82,95,66,71,82,50,89,85,86,95,73,52,50,48,0,67,79,76,79,82,95,66,71,82,50,89,85,86,95,73,89,85,86,0,67,79,76,79,82,95,66,71,82,50,89,85,86,95,89,86,49,50,0,67,79,76,79,82,95,66,71,82,53,53,53,50,66,71,82,0,67,79,76,79,82,95,66,71,82,53,53,53,50,66,71,82,65,0,67,79,76,79,82,95,66,71,82,53,53,53,50,71,82,65,89,0,67,79,76,79,82,95,66,71,82,53,53,53,50,82,71,66,0,67,79,76,79,82,95,66,71,82,53,53,53,50,82,71,66,65,0,67,79,76,79,82,95,66,71,82,53,54,53,50,66,71,82,0,67,79,76,79,82,95,66,71,82,53,54,53,50,66,71,82,65,0,67,79,76,79,82,95,66,71,82,53,54,53,50,71,82,65,89,0,67,79,76,79,82,95,66,71,82,53,54,53,50,82,71,66,0,67,79,76,79,82,95,66,71,82,53,54,53,50,82,71,66,65,0,67,79,76,79,82,95,66,71,82,65,50,66,71,82,0,67,79,76,79,82,95,66,71,82,65,50,66,71,82,53,53,53,0,67,79,76,79,82,95,66,71,82,65,50,66,71,82,53,54,53,0,67,79,76,79,82,95,66,71,82,65,50,71,82,65,89,0,67,79,76,79,82,95,66,71,82,65,50,82,71,66,0,67,79,76,79,82,95,66,71,82,65,50,82,71,66,65,0,67,79,76,79,82,95,66,71,82,65,50,89,85,86,95,73,52,50,48,0,67,79,76,79,82,95,66,71,82,65,50,89,85,86,95,73,89,85,86,0,67,79,76,79,82,95,66,71,82,65,50,89,85,86,95,89,86,49,50,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,66,71,82,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,66,71,82,65,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,66,71,82,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,66,71,82,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,71,82,65,89,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,82,71,66,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,82,71,66,65,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,82,71,66,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,82,71,66,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,66,71,82,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,66,71,82,65,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,66,71,82,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,66,71,82,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,71,82,65,89,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,82,71,66,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,82,71,66,65,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,82,71,66,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,82,71,66,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,66,71,82,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,66,71,82,65,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,66,71,82,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,66,71,82,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,71,82,65,89,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,82,71,66,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,82,71,66,65,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,82,71,66,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,82,71,66,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,66,71,82,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,66,71,82,65,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,66,71,82,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,66,71,82,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,71,82,65,89,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,82,71,66,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,82,71,66,65,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,82,71,66,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,82,71,66,95,86,78,71,0,67,79,76,79,82,95,67,79,76,79,82,67,86,84,95,77,65,88,0,67,79,76,79,82,95,71,82,65,89,50,66,71,82,0,67,79,76,79,82,95,71,82,65,89,50,66,71,82,53,53,53,0,67,79,76,79,82,95,71,82,65,89,50,66,71,82,53,54,53,0,67,79,76,79,82,95,71,82,65,89,50,66,71,82,65,0,67,79,76,79,82,95,71,82,65,89,50,82,71,66,0,67,79,76,79,82,95,71,82,65,89,50,82,71,66,65,0,67,79,76,79,82,95,72,76,83,50,66,71,82,0,67,79,76,79,82,95,72,76,83,50,66,71,82,95,70,85,76,76,0,67,79,76,79,82,95,72,76,83,50,82,71,66,0,67,79,76,79,82,95,72,76,83,50,82,71,66,95,70,85,76,76,0,67,79,76,79,82,95,72,83,86,50,66,71,82,0,67,79,76,79,82,95,72,83,86,50,66,71,82,95,70,85,76,76,0,67,79,76,79,82,95,72,83,86,50,82,71,66,0,67,79,76,79,82,95,72,83,86,50,82,71,66,95,70,85,76,76,0,67,79,76,79,82,95,76,66,71,82,50,76,97,98,0,67,79,76,79,82,95,76,66,71,82,50,76,117,118,0,67,79,76,79,82,95,76,82,71,66,50,76,97,98,0,67,79,76,79,82,95,76,82,71,66,50,76,117,118,0,67,79,76,79,82,95,76,97,98,50,66,71,82,0,67,79,76,79,82,95,76,97,98,50,76,66,71,82,0,67,79,76,79,82,95,76,97,98,50,76,82,71,66,0,67,79,76,79,82,95,76,97,98,50,82,71,66,0,67,79,76,79,82,95,76,117,118,50,66,71,82,0,67,79,76,79,82,95,76,117,118,50,76,66,71,82,0,67,79,76,79,82,95,76,117,118,50,76,82,71,66,0,67,79,76,79,82,95,76,117,118,50,82,71,66,0,67,79,76,79,82,95,82,71,66,50,66,71,82,0,67,79,76,79,82,95,82,71,66,50,66,71,82,53,53,53,0,67,79,76,79,82,95,82,71,66,50,66,71,82,53,54,53,0,67,79,76,79,82,95,82,71,66,50,66,71,82,65,0,67,79,76,79,82,95,82,71,66,50,71,82,65,89,0,67,79,76,79,82,95,82,71,66,50,72,76,83,0,67,79,76,79,82,95,82,71,66,50,72,76,83,95,70,85,76,76,0,67,79,76,79,82,95,82,71,66,50,72,83,86,0,67,79,76,79,82,95,82,71,66,50,72,83,86,95,70,85,76,76,0,67,79,76,79,82,95,82,71,66,50,76,97,98,0,67,79,76,79,82,95,82,71,66,50,76,117,118,0,67,79,76,79,82,95,82,71,66,50,82,71,66,65,0,67,79,76,79,82,95,82,71,66,50,88,89,90,0,67,79,76,79,82,95,82,71,66,50,89,67,114,67,98,0,67,79,76,79,82,95,82,71,66,50,89,85,86,0,67,79,76,79,82,95,82,71,66,50,89,85,86,95,73,52,50,48,0,67,79,76,79,82,95,82,71,66,50,89,85,86,95,73,89,85,86,0,67,79,76,79,82,95,82,71,66,50,89,85,86,95,89,86,49,50,0,67,79,76,79,82,95,82,71,66,65,50,66,71,82,0,67,79,76,79,82,95,82,71,66,65,50,66,71,82,53,53,53,0,67,79,76,79,82,95,82,71,66,65,50,66,71,82,53,54,53,0,67,79,76,79,82,95,82,71,66,65,50,66,71,82,65,0,67,79,76,79,82,95,82,71,66,65,50,71,82,65,89,0,67,79,76,79,82,95,82,71,66,65,50,82,71,66,0,67,79,76,79,82,95,82,71,66,65,50,89,85,86,95,73,52,50,48,0,67,79,76,79,82,95,82,71,66,65,50,89,85,86,95,73,89,85,86,0,67,79,76,79,82,95,82,71,66,65,50,89,85,86,95,89,86,49,50,0,67,79,76,79,82,95,82,71,66,65,50,109,82,71,66,65,0,67,79,76,79,82,95,88,89,90,50,66,71,82,0,67,79,76,79,82,95,88,89,90,50,82,71,66,0,67,79,76,79,82,95,89,67,114,67,98,50,66,71,82,0,67,79,76,79,82,95,89,67,114,67,98,50,82,71,66,0,67,79,76,79,82,95,89,85,86,50,66,71,82,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,52,50,48,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,50,82,71,66,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,66,71,82,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,66,71,82,65,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,71,82,65,89,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,82,71,66,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,82,71,66,65,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,66,71,82,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,66,71,82,65,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,71,82,65,89,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,82,71,66,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,82,71,66,65,0,67,79,76,79,82,95,109,82,71,66,65,50,82,71,66,65,0,67,79,78,84,79,85,82,83,95,77,65,84,67,72,95,73,49,0,67,79,78,84,79,85,82,83,95,77,65,84,67,72,95,73,50,0,67,79,78,84,79,85,82,83,95,77,65,84,67,72,95,73,51,0,67,79,86,65,82,95,67,79,76,83,0,67,79,86,65,82,95,78,79,82,77,65,76,0,67,79,86,65,82,95,82,79,87,83,0,67,79,86,65,82,95,83,67,65,76,69,0,67,79,86,65,82,95,83,67,82,65,77,66,76,69,68,0,67,79,86,65,82,95,85,83,69,95,65,86,71,0,68,67,84,95,73,78,86,69,82,83,69,0,68,67,84,95,82,79,87,83,0,68,69,67,79,77,80,95,67,72,79,76,69,83,75,89,0,68,69,67,79,77,80,95,69,73,71,0,68,69,67,79,77,80,95,76,85,0,68,69,67,79,77,80,95,78,79,82,77,65,76,0,68,69,67,79,77,80,95,81,82,0,68,69,67,79,77,80,95,83,86,68,0,68,70,84,95,67,79,77,80,76,69,88,95,73,78,80,85,84,0,68,70,84,95,67,79,77,80,76,69,88,95,79,85,84,80,85,84,0,68,70,84,95,73,78,86,69,82,83,69,0,68,70,84,95,82,69,65,76,95,79,85,84,80,85,84,0,68,70,84,95,82,79,87,83,0,68,70,84,95,83,67,65,76,69,0,68,73,83,84,95,67,0,68,73,83,84,95,70,65,73,82,0,68,73,83,84,95,72,85,66,69,82,0,68,73,83,84,95,76,49,0,68,73,83,84,95,76,49,50,0,68,73,83,84,95,76,50,0,68,73,83,84,95,76,65,66,69,76,95,67,67,79,77,80,0,68,73,83,84,95,76,65,66,69,76,95,80,73,88,69,76,0,68,73,83,84,95,77,65,83,75,95,51,0,68,73,83,84,95,77,65,83,75,95,53,0,68,73,83,84,95,77,65,83,75,95,80,82,69,67,73,83,69,0,68,73,83,84,95,85,83,69,82,0,68,73,83,84,95,87,69,76,83,67,72,0,68,101,115,99,114,105,112,116],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+133132);allocate([111,114,77,97,116,99,104,101,114,95,66,82,85,84,69,70,79,82,67,69,0,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,95,66,82,85,84,69,70,79,82,67,69,95,72,65,77,77,73,78,71,0,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,95,66,82,85,84,69,70,79,82,67,69,95,72,65,77,77,73,78,71,76,85,84,0,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,95,66,82,85,84,69,70,79,82,67,69,95,76,49,0,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,95,66,82,85,84,69,70,79,82,67,69,95,83,76,50,0,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,95,70,76,65,78,78,66,65,83,69,68,0,68,114,97,119,77,97,116,99,104,101,115,70,108,97,103,115,95,68,69,70,65,85,76,84,0,68,114,97,119,77,97,116,99,104,101,115,70,108,97,103,115,95,68,82,65,87,95,79,86,69,82,95,79,85,84,73,77,71,0,68,114,97,119,77,97,116,99,104,101,115,70,108,97,103,115,95,68,82,65,87,95,82,73,67,72,95,75,69,89,80,79,73,78,84,83,0,68,114,97,119,77,97,116,99,104,101,115,70,108,97,103,115,95,78,79,84,95,68,82,65,87,95,83,73,78,71,76,69,95,80,79,73,78,84,83,0,69,86,69,78,84,95,70,76,65,71,95,65,76,84,75,69,89,0,69,86,69,78,84,95,70,76,65,71,95,67,84,82,76,75,69,89,0,69,86,69,78,84,95,70,76,65,71,95,76,66,85,84,84,79,78,0,69,86,69,78,84,95,70,76,65,71,95,77,66,85,84,84,79,78,0,69,86,69,78,84,95,70,76,65,71,95,82,66,85,84,84,79,78,0,69,86,69,78,84,95,70,76,65,71,95,83,72,73,70,84,75,69,89,0,69,86,69,78,84,95,76,66,85,84,84,79,78,68,66,76,67,76,75,0,69,86,69,78,84,95,76,66,85,84,84,79,78,68,79,87,78,0,69,86,69,78,84,95,76,66,85,84,84,79,78,85,80,0,69,86,69,78,84,95,77,66,85,84,84,79,78,68,66,76,67,76,75,0,69,86,69,78,84,95,77,66,85,84,84,79,78,68,79,87,78,0,69,86,69,78,84,95,77,66,85,84,84,79,78,85,80,0,69,86,69,78,84,95,77,79,85,83,69,72,87,72,69,69,76,0,69,86,69,78,84,95,77,79,85,83,69,77,79,86,69,0,69,86,69,78,84,95,77,79,85,83,69,87,72,69,69,76,0,69,86,69,78,84,95,82,66,85,84,84,79,78,68,66,76,67,76,75,0,69,86,69,78,84,95,82,66,85,84,84,79,78,68,79,87,78,0,69,86,69,78,84,95,82,66,85,84,84,79,78,85,80,0,70,73,76,76,69,68,0,70,76,79,79,68,70,73,76,76,95,70,73,88,69,68,95,82,65,78,71,69,0,70,76,79,79,68,70,73,76,76,95,77,65,83,75,95,79,78,76,89,0,70,79,78,84,95,72,69,82,83,72,69,89,95,67,79,77,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,67,79,77,80,76,69,88,95,83,77,65,76,76,0,70,79,78,84,95,72,69,82,83,72,69,89,95,68,85,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,80,76,65,73,78,0,70,79,78,84,95,72,69,82,83,72,69,89,95,83,67,82,73,80,84,95,67,79,77,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,83,67,82,73,80,84,95,83,73,77,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,83,73,77,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,84,82,73,80,76,69,88,0,70,79,78,84,95,73,84,65,76,73,67,0,70,105,108,101,78,111,100,101,95,69,77,80,84,89,0,70,105,108,101,78,111,100,101,95,70,76,79,65,84,0,70,105,108,101,78,111,100,101,95,70,76,79,87,0,70,105,108,101,78,111,100,101,95,73,78,84,0,70,105,108,101,78,111,100,101,95,77,65,80,0,70,105,108,101,78,111,100,101,95,78,65,77,69,68,0,70,105,108,101,78,111,100,101,95,78,79,78,69,0,70,105,108,101,78,111,100,101,95,82,69,65,76,0,70,105,108,101,78,111,100,101,95,82,69,70,0,70,105,108,101,78,111,100,101,95,83,69,81,0,70,105,108,101,78,111,100,101,95,83,84,82,0,70,105,108,101,78,111,100,101,95,83,84,82,73,78,71,0,70,105,108,101,78,111,100,101,95,84,89,80,69,95,77,65,83,75,0,70,105,108,101,78,111,100,101,95,85,83,69,82,0,70,105,108,101,83,116,111,114,97,103,101,95,65,80,80,69,78,68,0,70,105,108,101,83,116,111,114,97,103,101,95,66,65,83,69,54,52,0,70,105,108,101,83,116,111,114,97,103,101,95,70,79,82,77,65,84,95,65,85,84,79,0,70,105,108,101,83,116,111,114,97,103,101,95,70,79,82,77,65,84,95,74,83,79,78,0,70,105,108,101,83,116,111,114,97,103,101,95,70,79,82,77,65,84,95,77,65,83,75,0,70,105,108,101,83,116,111,114,97,103,101,95,70,79,82,77,65,84,95,88,77,76,0,70,105,108,101,83,116,111,114,97,103,101,95,70,79,82,77,65,84,95,89,65,77,76,0,70,105,108,101,83,116,111,114,97,103,101,95,73,78,83,73,68,69,95,77,65,80,0,70,105,108,101,83,116,111,114,97,103,101,95,77,69,77,79,82,89,0,70,105,108,101,83,116,111,114,97,103,101,95,78,65,77,69,95,69,88,80,69,67,84,69,68,0,70,105,108,101,83,116,111,114,97,103,101,95,82,69,65,68,0,70,105,108,101,83,116,111,114,97,103,101,95,85,78,68,69,70,73,78,69,68,0,70,105,108,101,83,116,111,114,97,103,101,95,86,65,76,85,69,95,69,88,80,69,67,84,69,68,0,70,105,108,101,83,116,111,114,97,103,101,95,87,82,73,84,69,0,70,105,108,101,83,116,111,114,97,103,101,95,87,82,73,84,69,95,66,65,83,69,54,52,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,67,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,67,83,86,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,68,69,70,65,85,76,84,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,77,65,84,76,65,66,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,78,85,77,80,89,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,80,89,84,72,79,78,0,71,67,95,66,71,68,0,71,67,95,69,86,65,76,0,71,67,95,70,71,68,0,71,67,95,73,78,73,84,95,87,73,84,72,95,77,65,83,75,0,71,67,95,73,78,73,84,95,87,73,84,72,95,82,69,67,84,0,71,67,95,80,82,95,66,71,68,0,71,67,95,80,82,95,70,71,68,0,71,69,77,77,95,49,95,84,0,71,69,77,77,95,50,95,84,0,71,69,77,77,95,51,95,84,0,72,73,83,84,67,77,80,95,66,72,65,84,84,65,67,72,65,82,89,89,65,0,72,73,83,84,67,77,80,95,67,72,73,83,81,82,0,72,73,83,84,67,77,80,95,67,72,73,83,81,82,95,65,76,84,0,72,73,83,84,67,77,80,95,67,79,82,82,69,76,0,72,73,83,84,67,77,80,95,72,69,76,76,73,78,71,69,82,0,72,73,83,84,67,77,80,95,73,78,84,69,82,83,69,67,84,0,72,73,83,84,67,77,80,95,75,76,95,68,73,86,0,72,79,71,68,101,115,99,114,105,112,116,111,114,95,68,69,70,65,85,76,84,95,78,76,69,86,69,76,83,0,72,79,71,68,101,115,99,114,105,112,116,111,114,95,76,50,72,121,115,0,72,79,85,71,72,95,71,82,65,68,73,69,78,84,0,72,79,85,71,72,95,77,85,76,84,73,95,83,67,65,76,69,0,72,79,85,71,72,95,80,82,79,66,65,66,73,76,73,83,84,73,67,0,72,79,85,71,72,95,83,84,65,78,68,65,82,68,0,72,97,109,109,105,110,103,95,110,111,114,109,84,121,112,101,0,73,77,82,69,65,68,95,65,78,89,67,79,76,79,82,0,73,77,82,69,65,68,95,65,78,89,68,69,80,84,72,0,73,77,82,69,65,68,95,67,79,76,79,82,0,73,77,82,69,65,68,95,71,82,65,89,83,67,65,76,69,0,73,77,82,69,65,68,95,73,71,78,79,82,69,95,79,82,73,69,78,84,65,84,73,79,78,0,73,77,82,69,65,68,95,76,79,65,68,95,71,68,65,76,0,73,77,82,69,65,68,95,82,69,68,85,67,69,68,95,67,79,76,79,82,95,50,0,73,77,82,69,65,68,95,82,69,68,85,67,69,68,95,67,79,76,79,82,95,52,0,73,77,82,69,65,68,95,82,69,68,85,67,69,68,95,67,79,76,79,82,95,56,0,73,77,82,69,65,68,95,82,69,68,85,67,69,68,95,71,82,65,89,83,67,65,76,69,95,50,0,73,77,82,69,65,68,95,82,69,68,85,67,69,68,95,71,82,65,89,83,67,65,76,69,95,52,0,73,77,82,69,65,68,95,82,69,68,85,67,69,68,95,71,82,65,89,83,67,65,76,69,95,56,0,73,77,82,69,65,68,95,85,78,67,72,65,78,71,69,68,0,73,77,87,82,73,84,69,95,74,80,69,71,95,67,72,82,79,77,65,95,81,85,65,76,73,84,89,0,73,77,87,82,73,84,69,95,74,80,69,71,95,76,85,77,65,95,81,85,65,76,73,84,89,0,73,77,87,82,73,84,69,95,74,80,69,71,95,79,80,84,73,77,73,90,69,0,73,77,87,82,73,84,69,95,74,80,69,71,95,80,82,79,71,82,69,83,83,73,86,69,0,73,77,87,82,73,84,69,95,74,80,69,71,95,81,85,65,76,73,84,89,0,73,77,87,82,73,84,69,95,74,80,69,71,95,82,83,84,95,73,78,84,69,82,86,65,76,0,73,77,87,82,73,84,69,95,80,65,77,95,70,79,82,77,65,84,95,66,76,65,67,75,65,78,68,87,72,73,84,69,0,73,77,87,82,73,84,69,95,80,65,77,95,70,79,82,77,65,84,95,71,82,65,89,83,67,65,76,69,0,73,77,87,82,73,84,69,95,80,65,77,95,70,79,82,77,65,84,95,71,82,65,89,83,67,65,76,69,95,65,76,80,72,65,0,73,77,87,82,73,84,69,95,80,65,77,95,70,79,82,77,65,84,95,78,85,76,76,0,73,77,87,82,73,84,69,95,80,65,77,95,70,79,82,77,65,84,95,82,71,66,0,73,77,87,82,73,84,69,95,80,65,77,95,70,79,82,77,65,84,95,82,71,66,95,65,76,80,72,65,0,73,77,87,82,73,84,69,95,80,65,77,95,84,85,80,76,69,84,89,80,69,0,73,77,87,82,73,84,69,95,80,78,71,95,66,73,76,69,86,69,76,0,73,77,87,82,73,84,69,95,80,78,71,95,67,79,77,80,82,69,83,83,73,79,78,0,73,77,87,82,73,84,69,95,80,78,71,95,83,84,82,65,84,69,71,89,0,73,77,87,82,73,84,69,95,80,78,71,95,83,84,82,65,84,69,71,89,95,68,69,70,65,85,76,84,0,73,77,87,82,73,84,69,95,80,78,71,95,83,84,82,65,84,69,71,89,95,70,73,76,84,69,82,69,68,0,73,77,87,82,73,84,69,95,80,78,71,95,83,84,82,65,84,69,71,89,95,70,73,88,69,68,0,73,77,87,82,73,84,69,95,80,78,71,95,83,84,82,65,84,69,71,89,95,72,85,70,70,77,65,78,95,79,78,76,89,0,73,77,87,82,73,84,69,95,80,78,71,95,83,84,82,65,84,69,71,89,95,82,76,69,0,73,77,87,82,73,84,69,95,80,88,77,95,66,73,78,65,82,89,0,73,77,87,82,73,84,69,95,87,69,66,80,95,81,85,65,76,73,84,89,0,73,78,84,69,82,83,69,67,84,95,70,85,76,76,0,73,78,84,69,82,83,69,67,84,95,78,79,78,69,0,73,78,84,69,82,83,69,67,84,95,80,65,82,84,73,65,76,0,73,78,84,69,82,95,65,82,69,65,0,73,78,84,69,82,95,66,73,84,83,0,73,78,84,69,82,95,66,73,84,83,50,0,73,78,84,69,82,95,67,85,66,73,67,0,73,78,84,69,82,95,76,65,78,67,90,79,83,52,0,73,78,84,69,82,95,76,73,78,69,65,82,0,73,78,84,69,82,95,77,65,88,0,73,78,84,69,82,95,78,69,65,82,69,83,84,0,73,78,84,69,82,95,84,65,66,95,83,73,90,69,0,73,78,84,69,82,95,84,65,66,95,83,73,90,69,50,0,75,65,90,69,95,68,73,70,70,95,67,72,65,82,66,79,78,78,73,69,82,0,75,65,90,69,95,68,73,70,70,95,80,77,95,71,49,0,75,65,90,69,95,68,73,70,70,95,80,77,95,71,50,0,75,65,90,69,95,68,73,70,70,95,87,69,73,67,75,69,82,84,0,75,77,69,65,78,83,95,80,80,95,67,69,78,84,69,82,83,0,75,77,69,65,78,83,95,82,65,78,68,79,77,95,67,69,78,84,69,82,83,0,75,77,69,65,78,83,95,85,83,69,95,73,78,73,84,73,65,76,95,76,65,66,69,76,83,0,76,73,78,69,95,52,0,76,73,78,69,95,56,0,76,73,78,69,95,65,65,0,76,83,68,95,82,69,70,73,78,69,95,65,68,86,0,76,83,68,95,82,69,70,73,78,69,95,78,79,78,69,0,76,83,68,95,82,69,70,73,78,69,95,83,84,68,0,77,65,82,75,69,82,95,67,82,79,83,83,0,77,65,82,75,69,82,95,68,73,65,77,79,78,68,0,77,65,82,75,69,82,95,83,81,85,65,82,69,0,77,65,82,75,69,82,95,83,84,65,82,0,77,65,82,75,69,82,95,84,73,76,84,69,68,95,67,82,79,83,83,0,77,65,82,75,69,82,95,84,82,73,65,78,71,76,69,95,68,79,87,78,0,77,65,82,75,69,82,95,84,82,73,65,78,71,76,69,95,85,80,0,77,79,82,80,72,95,66,76,65,67,75,72,65,84,0,77,79,82,80,72,95,67,76,79,83,69,0,77,79,82,80,72,95,67,82,79,83,83,0,77,79,82,80,72,95,68,73,76,65,84,69,0,77,79,82,80,72,95,69,76,76,73,80,83,69,0,77,79,82,80,72,95,69,82,79,68,69,0,77,79,82,80,72,95,71,82,65,68,73,69,78,84,0,77,79,82,80,72,95,72,73,84,77,73,83,83,0,77,79,82,80,72,95,79,80,69,78,0,77,79,82,80,72,95,82,69,67,84,0,77,79,82,80,72,95,84,79,80,72,65,84,0,77,79,84,73,79,78,95,65,70,70,73,78,69,0,77,79,84,73,79,78,95,69,85,67,76,73,68,69,65,78,0,77,79,84,73,79,78,95,72,79,77,79,71,82,65,80,72,89,0,77,79,84,73,79,78,95,84,82,65,78,83,76,65,84,73,79,78,0,77,97,116,95,65,85,84,79,95,83,84,69,80,0,77,97,116,95,67,79,78,84,73,78,85,79,85,83,95,70,76,65,71,0,77,97,116,95,68,69,80,84,72,95,77,65,83,75,0,77,97,116,95,77,65,71,73,67,95,77,65,83,75,0,77,97,116,95,77,65,71,73,67,95,86,65,76,0,77,97,116,95,83,85,66,77,65,84,82,73,88,95,70,76,65,71,0,77,97,116,95,84,89,80,69,95,77,65,83,75,0,78,79,82,77,95,72,65,77,77,73,78,71,0,78,79,82,77,95,72,65,77,77,73,78,71,50,0,78,79,82,77,95,73,78,70,0,78,79,82,77,95,76,49,0,78,79,82,77,95,76,50,0,78,79,82,77,95,76,50,83,81,82,0,78,79,82,77,95,77,73,78,77,65,88,0,78,79,82,77,95,82,69,76,65,84,73,86,69,0,78,79,82,77,95,84,89,80,69,95,77,65,83,75,0,79,80,84,70,76,79,87,95,70,65,82,78,69,66,65,67,75,95,71,65,85,83,83,73,65,78,0,79,80,84,70,76,79,87,95,76,75,95,71,69,84,95,77,73,78,95,69,73,71,69,78,86,65,76,83,0,79,80,84,70,76,79,87,95,85,83,69,95,73,78,73,84,73,65,76,95,70,76,79,87,0,79,82,66,95,107,66,121,116,101,115,0,80,67,65,95,68,65,84,65,95,65,83,95,67,79,76,0,80,67,65,95,68,65,84,65,95,65,83,95,82,79,87,0,80,67,65,95,85,83,69,95,65,86,71,0,80,82,79,74,95,83,80,72,69,82,73,67,65,76,95,69,81,82,69,67,84,0,80,82,79,74,95,83,80,72,69,82,73,67,65,76,95,79,82,84,72,79,0,80,97,114,97,109,95,65,76,71,79,82,73,84,72,77,0,80,97,114,97,109,95,66,79,79,76,69,65,78,0,80,97,114,97,109,95,70,76,79,65,84,0,80,97,114,97,109,95,73,78,84,0,80,97,114,97,109,95,77,65,84,0,80,97,114,97,109,95,77,65,84,95,86,69,67,84,79,82,0,80,97,114,97,109,95,82,69,65,76,0,80,97,114,97,109,95,83,84,82,73,78,71,0,80,97,114,97,109,95,85,67,72,65,82,0,80,97,114,97,109,95,85,73,78,84,54,52,0,80,97,114,97,109,95,85,78,83,73,71,78,69,68,95,73,78,84,0,81,84,95,67,72,69,67,75,66,79,88,0,81,84,95,70,79,78,84,95,66,76,65,67,75,0,81,84,95,70,79,78,84,95,66,79,76,68,0,81,84,95,70,79,78,84,95,68,69,77,73,66,79,76,68,0,81,84,95,70,79,78,84,95,76,73,71,72,84,0,81,84,95,70,79,78,84,95,78,79,82,77,65,76,0,81,84,95,78,69,87,95,66,85,84,84,79,78,66,65,82,0,81,84,95,80,85,83,72,95,66,85,84,84,79,78,0,81,84,95,82,65,68,73,79,66,79,88,0,81,84,95,83,84,89,76,69,95,73,84,65,76,73,67,0,81,84,95,83,84,89,76,69,95,78,79,82,77,65,76,0,81,84,95,83,84,89,76,69,95,79,66,76,73,81,85,69,0,82,69,68,85,67,69,95,65,86,71,0,82,69,68,85,67,69,95,77,65,88,0,82,69,68,85,67,69,95,77,73,78,0,82,69,68,85,67,69,95,83,85,77,0,82,69,84,82,95,67,67,79,77,80,0,82,69,84,82,95,69,88,84,69,82,78,65,76,0,82,69,84,82,95,70,76,79,79,68,70,73,76,76,0,82,69,84,82,95,76,73,83,84,0,82,69,84,82,95,84,82,69,69,0,82,78,71,95,78,79,82,77,65,76,0,82,78,71,95,85,78,73,70,79,82,77,0,82,79,84,65,84,69,95,49,56,48,0,82,79,84,65,84,69,95,57,48,95,67,76,79,67,75,87,73,83,69,0,82,79,84,65,84,69,95,57,48,95,67,79,85,78,84,69,82,67,76,79,67,75,87,73,83,69,0,83,79,76,86,69,76,80,95,77,85,76,84,73,0,83,79,76,86,69,76,80,95,83,73,78,71,76,69,0,83,79,76,86,69,76,80,95,85,78,66,79,85,78,68,69,68,0,83,79,76,86,69,76,80,95,85,78,70,69,65,83,73,66,76,69,0,83,79,82,84,95,65,83,67,69,78,68,73,78,71,0,83,79,82,84,95,68,69,83,67,69,78,68,73,78,71,0,83,79,82,84,95,69,86,69,82,89,95,67,79,76,85,77,78,0,83,79,82,84,95,69,86,69,82,89,95,82,79,87,0,83,86,68,95,70,85,76,76,95,85,86,0,83,86,68,95,77,79,68,73,70,89,95,65,0,83,86,68,95,78,79,95,85,86,0,83,112,97,114,115,101,77,97,116,95,72,65,83,72,95,66,73,84,0,83,112,97,114,115,101,77,97,116,95,72,65,83,72,95,83,67,65,76,69,0,83,112,97,114,115,101,77,97,116,95,77,65,71,73,67,95,86,65,76,0,83,112,97,114,115,101,77,97,116,95,77,65,88,95,68,73,77,0,83,117,98,100,105,118,50,68,95,78,69,88,84,95,65,82,79,85,78,68,95,68,83,84,0,83,117,98,100,105,118,50,68,95,78,69,88,84,95,65,82,79,85,78,68,95,76,69,70,84,0,83,117,98,100,105,118,50,68,95,78,69,88,84,95,65,82,79,85,78,68,95,79,82,71,0,83,117,98,100,105,118,50,68,95,78,69,88,84,95,65,82,79,85,78,68,95,82,73,71,72,84,0,83,117,98,100,105,118,50,68,95,80,82,69,86,95,65,82,79,85,78,68,95,68,83,84,0,83,117,98,100,105,118,50,68,95,80,82,69,86,95,65,82,79,85,78,68,95,76,69,70,84,0,83,117,98,100,105,118,50,68,95,80,82,69,86,95,65,82,79,85,78,68,95,79,82,71,0,83,117,98,100,105,118,50,68,95,80,82,69,86,95,65,82,79,85,78,68,95,82,73,71,72,84,0,83,117,98,100,105,118,50,68,95,80,84,76,79,67,95,69,82,82,79,82,0,83,117,98,100,105,118,50,68,95,80,84,76,79,67,95,73,78,83,73,68,69,0,83,117,98,100,105,118,50,68,95,80,84,76,79,67,95,79,78,95,69,68,71,69,0,83,117,98,100,105,118,50,68,95,80,84,76,79,67,95,79,85,84,83,73,68,69,95,82,69,67,84,0,83,117,98,100,105,118,50,68,95,80,84,76,79,67,95,86,69,82,84,69,88,0,84,72,82,69,83,72,95,66,73,78,65,82,89,0,84,72,82,69,83,72,95,66,73,78,65,82,89,95,73,78,86,0,84,72,82,69,83,72,95,77,65,83,75,0,84,72,82,69,83,72,95,79,84,83,85,0,84,72,82,69,83,72,95,84,79,90,69,82,79,0,84,72,82,69,83,72,95,84,79,90,69,82,79,95,73,78,86,0,84,72,82,69,83,72,95,84,82,73,65,78,71,76,69,0,84,72,82,69,83,72,95,84,82,85,78,67,0,84,77,95,67,67,79,69,70,70,0,84,77,95,67,67,79,69,70,70,95,78,79,82,77,69,68,0,84,77,95,67,67,79,82,82,0,84,77,95,67,67,79,82,82,95,78,79,82,77,69,68,0,84,77,95,83,81,68,73,70,70,0,84,77,95,83,81,68,73,70,70,95,78,79,82,77,69,68,0,84,101,114,109,67,114,105,116,101,114,105,97,95,67,79,85,78,84,0,84,101,114,109,67,114,105,116,101,114,105,97,95,69,80,83,0,84,101,114,109,67,114,105,116,101,114,105,97,95,77,65,88,95,73,84,69,82,0,85,77,97,116,68,97,116,97,95,65,83,89,78,67,95,67,76,69,65,78,85,80,0,85,77,97,116,68,97,116,97,95,67,79,80,89,95,79,78,95,77,65,80,0,85,77,97,116,68,97,116,97,95,68,69,86,73,67,69,95,67,79,80,89,95,79,66,83,79,76,69,84,69,0,85,77,97,116,68,97,116,97,95,68,69,86,73,67,69,95,77,69,77,95,77,65,80,80,69,68,0,85,77,97,116,68,97,116,97,95,72,79,83,84,95,67,79,80,89,95,79,66,83,79,76,69,84,69,0,85,77,97,116,68,97,116,97,95,84,69,77,80,95,67,79,80,73,69,68,95,85,77,65,84,0,85,77,97,116,68,97,116,97,95,84,69,77,80,95,85,77,65,84,0,85,77,97,116,68,97,116,97,95,85,83,69,82,95,65,76,76,79,67,65,84,69,68,0,85,77,97,116,95,65,85,84,79,95,83,84,69,80,0,85,77,97,116,95,67,79,78,84,73,78,85,79,85,83,95,70,76,65,71,0,85,77,97,116,95,68,69,80,84,72,95,77,65,83,75,0,85,77,97,116,95,77,65,71,73,67,95,77,65,83,75,0,85,77,97,116,95,77,65,71,73,67,95,86,65,76,0,85,77,97,116,95,83,85,66,77,65,84,82,73,88,95,70,76,65,71,0,85,77,97,116,95,84,89,80,69,95,77,65,83,75,0,85,83,65,71,69,95,65,76,76,79,67,65,84,69,95,68,69,86,73,67,69,95,77,69,77,79,82,89,0,85,83,65,71,69,95,65,76,76,79,67,65,84,69,95,72,79,83,84,95,77,69,77,79,82,89,0,85,83,65,71,69,95,65,76,76,79,67,65,84,69,95,83,72,65,82,69,68,95,77,69,77,79,82,89,0,85,83,65,71,69,95,68,69,70,65,85,76,84,0,87,65,82,80,95,70,73,76,76,95,79,85,84,76,73,69,82,83,0,87,65,82,80,95,73,78,86,69,82,83,69,95,77,65,80,0,87,73,78,68,79,87,95,65,85,84,79,83,73,90,69,0,87,73,78,68,79,87,95,70,82,69,69,82,65,84,73,79,0,87,73,78,68,79,87,95,70,85,76,76,83,67,82,69,69,78,0,87,73,78,68,79,87,95,71,85,73,95,69,88,80,65,78,68,69,68,0,87,73,78,68,79,87,95,71,85,73,95,78,79,82,77,65,76,0,87,73,78,68,79,87,95,75,69,69,80,82,65,84,73,79,0,87,73,78,68,79,87,95,78,79,82,77,65,76,0,87,73,78,68,79,87,95,79,80,69,78,71,76,0,87,78,68,95,80,82,79,80,95,65,83,80,69,67,84,95,82,65,84,73,79,0,87,78,68,95,80,82,79,80,95,65,85,84,79,83,73,90,69,0,87,78,68,95,80,82,79,80,95,70,85,76,76,83,67,82,69,69,78,0,87,78,68,95,80,82,79,80,95,79,80,69,78,71,76,0,87,78,68,95,80,82,79,80,95,86,73,83,73,66,76,69,0,95,73,110,112,117,116,65,114,114,97,121,95,67,85,68,65,95,71,80,85,95,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,67,85,68,65,95,72,79,83,84,95,77,69,77,0,95,73,110,112,117,116,65,114,114,97,121,95,69,88,80,82,0,95,73,110,112,117,116,65,114,114,97,121,95,70,73,88,69,68,95,83,73,90,69,0,95,73,110,112,117,116,65,114,114,97,121,95,70,73,88,69,68,95,84,89,80,69,0,95,73,110,112,117,116,65,114,114,97,121,95,75,73,78,68,95,77,65,83,75,0,95,73,110,112,117,116,65,114,114,97,121,95,75,73,78,68,95,83,72,73,70,84,0,95,73,110,112,117,116,65,114,114,97,121,95,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,77,65,84,88,0,95,73,110,112,117,116,65,114,114,97,121,95,78,79,78,69,0,95,73,110,112,117,116,65,114,114,97,121,95,79,80,69,78,71,76,95,66,85,70,70,69,82,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,65,82,82,65,89,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,65,82,82,65,89,95,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,66,79,79,76,95,86,69,67,84,79,82,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,86,69,67,84,79,82,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,86,69,67,84,79,82,95,67,85,68,65,95,71,80,85,95,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,86,69,67,84,79,82,95,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,86,69,67,84,79,82,95,85,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,86,69,67,84,79,82,95,86,69,67,84,79,82,0,95,73,110,112,117,116,65,114,114,97,121,95,85,77,65,84,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,49,54,83,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,49,54,85,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,51,50,70,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,51,50,83,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,54,52,70,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,56,83,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,56,85,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,65,76,76,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,65,76,76,95,66,85,84,95,56,83,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,70,76,84,0,95,95,85,77,65,84,95,85,83,65,71,69,95,70,76,65,71,83,95,51,50,66,73,84,0,66,97,100,65,108,105,103,110,0,66,97,100,65,108,112,104,97,67,104,97,110,110,101,108,0,66,97,100,67,79,73,0,66,97,100,67,97,108,108,66,97,99,107,0,66,97,100,68,97,116,97,80,116,114,0,66,97,100,68,101,112,116,104,0,66,97,100,73,109,97,103,101,83,105,122,101,0,66,97,100,77,111,100,101,108,79,114,67,104,83,101,113,0,66,97,100,78,117,109,67,104,97,110,110,101,108,49,85,0,66,97,100,78,117,109,67,104,97,110,110,101,108,115,0,66,97,100,79,102,102,115,101,116,0,66,97,100,79,114,100,101,114,0,66,97,100,79,114,105,103,105,110,0,66,97,100,82,79,73,83,105,122,101,0,66,97,100,83,116,101,112,0,66,97,100,84,105,108,101,83,105,122,101,0,71,112,117,65,112,105,67,97,108,108,69,114,114,111,114,0,71,112,117,78,111,116,83,117,112,112,111,114,116,101,100,0,72,101,97,100,101,114,73,115,78,117,108,108,0,77,97,115,107,73,115,84,105,108,101,100,0,79,112,101,110,67,76,65,112,105,67,97,108,108,69,114,114,111,114,0,79,112,101,110,67,76,68,111,117,98,108,101,78,111,116,83,117,112,112,111,114,116,101,100,0,79,112,101,110,67,76,73,110,105,116,69,114,114,111,114,0,79,112,101,110,67,76,78,111,65,77,68,66,108,97,115,70,102,116,0,79,112,101,110,71,108,65,112,105,67,97,108,108,69,114,114,111,114,0,79,112,101,110,71,108,78,111,116,83,117,112,112,111,114,116,101,100,0,83,116,115,65,115,115,101,114,116,0,83,116,115,65,117,116,111,84,114,97,99,101,0,83,116,115,66,97,99,107,84,114,97,99,101,0,83,116,115,66,97,100,65,114,103,0,83,116,115,66,97,100,70,108,97,103,0,83,116,115,66,97,100,70,117,110,99,0,83,116,115,66,97,100,77,97,115,107,0,83,116,115,66,97,100,77,101,109,66,108,111,99,107,0,83,116,115,66,97,100,80,111,105,110,116,0,83,116,115,66,97,100,83,105,122,101,0,83,116,115,68,105,118,66,121,90,101,114,111,0,83,116,115,69,114,114,111,114,0,83,116,115,70,105,108,116,101,114,79,102,102,115,101,116,69,114,114,0,83,116,115,70,105,108,116,101,114,83,116,114,117,99,116,67,111,110,116,101,110,116,69,114,114,0,83,116,115,73,110,112,108,97,99,101,78,111,116,83,117,112,112,111,114,116,101,100,0,83,116,115,73,110,116,101,114,110,97,108,0,83,116,115,75,101,114,110,101,108,83,116,114,117,99,116,67,111,110,116,101,110,116,69,114,114,0,83,116,115,78,111,67,111,110,118,0,83,116,115,78,111,77,101,109,0,83,116,115,78,111,116,73,109,112,108,101,109,101,110,116,101,100,0,83,116,115,78,117,108,108,80,116,114,0,83,116,115,79,98,106,101,99,116,78,111,116,70,111,117,110,100,0,83,116,115,79,107,0,83,116,115,79,117,116,79,102,82,97,110,103,101,0,83,116,115,80,97,114,115,101,69,114,114,111,114,0,83,116,115,85,110,109,97,116,99,104,101,100,70,111,114,109,97,116,115,0,83,116,115,85,110,109,97,116,99,104,101,100,83,105,122,101,115,0,83,116,115,85,110,115,117,112,112,111,114,116,101,100,70,111,114,109,97,116,0,83,116,115,86,101,99,76,101,110,103,116,104,69,114,114,0,70,76,65,71,83,95,69,88,80,65,78,68,95,83,65,77,69,95,78,65,77,69,83,0,70,76,65,71,83,95,77,65,80,80,73,78,71,0,70,76,65,71,83,95,78,79,78,69,0,73,77,80,76,95,73,80,80,0,73,77,80,76,95,79,80,69,78,67,76,0,73,77,80,76,95,80,76,65,73,78,0,84,89,80,69,95,70,85,78,0,84,89,80,69,95,71,69,78,69,82,65,76,0,84,89,80,69,95,77,65,82,75,69,82,0,84,89,80,69,95,87,82,65,80,80,69,82,0,78,50,99,118,54,80,111,105,110,116,95,73,102,69,69,0,78,50,99,118,49,49,82,111,116,97,116,101,100,82,101,99,116,69,0,78,50,99,118,53,82,101,99,116,95,73,105,69,69,0,112,117,115,104,95,98,97,99,107,0,103,101,116,0,115,101,116,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,118,101,99,116,111,114,95,98,97,115,101,95,99,111,109,109,111,110,73,76,98,49,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,0,105,105,0,118,0,118,105,0,118,105,105,105,0,118,105,105,105,105,0,105,105,105,0,78,49,48,101,109,115,99,114,105,112,116,101,110,51,118,97,108,69,0,105,105,105,105,0,105,105,105,105,105,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,102,78,83,95,57,97,108,108,111,99,97,116,111,114,73,102,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,102,78,83,95,57,97,108,108,111,99,97,116,111,114,73,102,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,102,78,83,95,57,97,108,108,111,99,97,116,111,114,73,102,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,102,78,83,95,57,97,108,108,111,99,97,116,111,114,73,102,69,69,69,69,0,118,105,105,102,0,118,105,105,105,102,0,105,105,105,105,102,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,100,78,83,95,57,97,108,108,111,99,97,116,111,114,73,100,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,100,78,83,95,57,97,108,108,111,99,97,116,111,114,73,100,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,100,78,83,95,57,97,108,108,111,99,97,116,111,114,73,100,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,100,78,83,95,57,97,108,108,111,99,97,116,111,114,73,100,69,69,69,69,0,118,105,105,100,0,118,105,105,105,100,0,105,105,105,105,100,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,51,77,97,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,51,77,97,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,51,77,97,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,51,77,97,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,50,99,118,51,77,97,116,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,50,99,118,56,75,101,121,80,111,105,110,116,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,48,95,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,78,83,51,95,73,83,53,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,83,95,54,118,101,99,116,111,114,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,78,83,52,95,73,83,54,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,48,95,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,78,83,51,95,73,83,53,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,48,95,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,78,83,51,95,73,83,53,95,69,69,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,53,82,101,99,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,53,82,101,99,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,53,82,101,99,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,53,82,101,99,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,68,77,97,116,99,104,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,54,68,77,97,116,99,104,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,68,77,97,116,99,104,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,68,77,97,116,99,104,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,68,77,97,116,99,104,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,48,95,73,78,50,99,118,54,68,77,97,116,99,104,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,78,83,51,95,73,83,53,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,83,95,54,118,101,99,116,111,114,73,78,50,99,118,54,68,77,97,116,99,104,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,78,83,52,95,73,83,54,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,48,95,73,78,50,99,118,54,68,77,97,116,99,104,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,78,83,51,95,73,83,53,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,48,95,73,78,50,99,118,54,68,77,97,116,99,104,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,78,83,51,95,73,83,53,95,69,69,69,69,0,80,78,50,99,118,51,77,97,116,69,0,80,75,78,50,99,118,51,77,97,116,69,0,78,50,99,118,53,83,105,122,101,95,73,105,69,69,0,78,50,99,118,55,83,99,97,108,97,114,95,73,100,69,69,0,78,50,99,118,51,86,101,99,73,100,76,105,52,69,69,69,0,78,50,99,118,52,77,97,116,120,73,100,76,105,52,69,76,105,49,69,69,69,0,105,105,105,105,105,105,0,105,105,105,105,105,105,105,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,104,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,99,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,116,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,115,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,105,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,102,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,100,69,69,0,118,105,105,105],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+143372);allocate([105,100,100,0,118,105,105,105,105,100,0,118,105,105,105,105,105,0,78,50,99,118,53,82,97,110,103,101,69,0,100,105,105,105,0,102,105,105,105,0,102,105,105,105,105,0,102,105,105,105,105,105,0,100,105,105,105,105,105,0,100,105,105,105,105,0,78,50,99,118,49,50,84,101,114,109,67,114,105,116,101,114,105,97,69,0,100,105,105,0,78,50,99,118,53,83,105,122,101,95,73,102,69,69,0,102,105,105,0,78,50,99,118,53,82,101,99,116,95,73,102,69,69,0,78,49,51,98,105,110,100,105,110,103,95,117,116,105,108,115,57,77,105,110,77,97,120,76,111,99,69,0,78,49,51,98,105,110,100,105,110,103,95,117,116,105,108,115,54,67,105,114,99,108,101,69,0,78,50,99,118,55,77,111,109,101,110,116,115,69,0,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,78,83,116,51,95,95,50,50,49,95,95,98,97,115,105,99,95,115,116,114,105,110,103,95,99,111,109,109,111,110,73,76,98,49,69,69,69,0,78,50,99,118,49,56,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,54,80,97,114,97,109,115,69,0,78,50,99,118,51,79,82,66,85,116,95,69,0,78,50,99,118,49,57,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,85,116,95,69,0,108,101,110,103,116,104,0,118,105,105,105,100,100,105,105,0,118,105,105,105,100,100,105,0,118,105,105,105,100,100,0,118,105,105,105,105,100,100,105,0,118,105,105,105,105,100,100,100,100,105,105,0,118,105,105,105,105,100,100,100,100,105,0,118,105,105,105,105,100,100,100,100,0,118,105,105,105,105,100,100,100,0,118,105,105,105,100,100,105,100,100,100,100,0,118,105,105,105,100,100,105,100,100,100,0,118,105,105,105,100,100,105,100,100,0,118,105,105,105,100,100,105,100,0,118,105,105,105,105,105,100,100,105,0,118,105,105,105,105,105,100,100,0,118,105,105,105,105,105,100,0,118,105,105,105,105,105,105,100,100,105,0,118,105,105,105,105,105,105,100,100,0,118,105,105,105,105,105,105,100,0,118,105,105,105,105,105,105,0,118,105,105,105,105,105,105,105,100,100,105,0,118,105,105,105,105,105,105,105,100,100,0,118,105,105,105,105,105,105,105,100,0,118,105,105,105,105,105,105,105,0,118,105,105,105,100,105,105,105,100,0,118,105,105,100,105,100,100,105,105,0,118,105,105,100,105,100,100,105,0,118,105,105,105,100,105,0,118,105,105,105,105,105,105,105,105,0,118,105,105,105,105,100,105,105,105,105,100,105,0,118,105,105,105,105,105,105,105,105,105,105,105,100,0,118,105,105,105,105,105,105,105,105,105,105,105,0,118,105,105,105,105,105,105,105,105,105,105,0,118,105,105,105,105,105,105,105,105,105,0,105,105,105,105,105,105,105,105,0,118,105,105,105,105,105,100,105,0,118,105,105,105,105,100,105,0,118,105,100,105,105,105,0,118,105,100,105,105,0,118,105,105,105,105,100,100,100,105,105,105,105,0,118,105,105,105,105,100,100,100,105,105,105,0,118,105,105,105,105,100,100,100,105,105,0,118,105,105,105,105,100,100,100,105,0,118,105,105,105,105,105,105,100,105,0,100,105,105,105,105,105,105,105,0,100,105,105,105,105,105,105,0,118,105,105,105,100,105,100,105,105,0,118,105,105,105,100,105,100,105,0,105,105,105,100,100,0,118,105,105,105,105,100,100,105,105,105,100,0,118,105,105,105,105,100,100,105,105,105,0,118,105,105,105,105,100,100,105,105,0,118,105,105,105,105,100,100,105,105,105,105,100,0,118,105,105,105,105,100,100,105,105,105,105,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,104,78,83,95,57,97,108,108,111,99,97,116,111,114,73,104,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,104,78,83,95,57,97,108,108,111,99,97,116,111,114,73,104,69,69,69,69,0,100,105,105,105,105,105,105,105,105,0,100,105,105,105,105,100,0,118,105,105,105,100,100,105,105,105,0,118,105,105,100,105,0,118,105,105,105,105,105,100,105,105,105,105,0,118,105,105,105,105,105,100,105,105,105,0,118,105,105,105,105,105,100,105,105,0,118,105,105,105,105,105,105,105,100,105,0,118,105,105,0,100,105,105,105,100,100,105,0,80,78,50,99,118,49,56,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,69,0,80,75,78,50,99,118,49,56,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,49,56,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,69,69,69,0,80,78,50,99,118,49,51,72,79,71,68,101,115,99,114,105,112,116,111,114,69,0,80,75,78,50,99,118,49,51,72,79,71,68,101,115,99,114,105,112,116,111,114,69,0,105,105,105,105,105,105,105,105,100,105,100,105,105,105,0,78,50,99,118,54,83,116,114,105,110,103,69,0,118,105,105,105,105,105,100,105,105,100,100,105,0,118,105,105,105,105,105,100,105,105,100,100,0,118,105,105,105,105,105,100,105,105,100,0,78,50,99,118,50,48,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,69,0,80,78,50,99,118,50,48,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,69,0,80,75,78,50,99,118,50,48,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,69,0,78,50,99,118,50,52,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,69,0,80,78,50,99,118,50,52,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,69,0,80,75,78,50,99,118,50,52,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,69,0,78,50,99,118,51,80,116,114,73,78,83,95,50,52,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,69,69,69,0,105,105,105,100,105,0,105,105,105,100,0,78,50,99,118,53,67,76,65,72,69,69,0,80,78,50,99,118,53,67,76,65,72,69,69,0,80,75,78,50,99,118,53,67,76,65,72,69,69,0,78,50,99,118,51,80,116,114,73,78,83,95,53,67,76,65,72,69,69,69,69,0,105,105,100,105,0,105,105,100,0,80,78,50,99,118,57,65,108,103,111,114,105,116,104,109,69,0,80,75,78,50,99,118,57,65,108,103,111,114,105,116,104,109,69,0,80,78,50,99,118,57,70,101,97,116,117,114,101,50,68,69,0,80,75,78,50,99,118,57,70,101,97,116,117,114,101,50,68,69,0,80,78,50,99,118,49,55,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,69,0,80,75,78,50,99,118,49,55,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,49,55,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,69,69,69,0,78,50,99,118,49,55,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,69,0,80,78,50,99,118,49,55,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,69,0,80,75,78,50,99,118,49,55,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,69,0,118,105,105,105,105,105,105,100,105,105,105,105,105,0,118,105,105,105,105,105,105,100,105,105,105,105,0,118,105,105,105,105,105,105,100,105,105,105,0,118,105,105,105,105,105,105,100,105,105,0,118,105,105,105,105,100,105,105,105,105,0,118,105,105,105,105,100,105,105,105,0,118,105,105,105,105,100,105,105,0,80,78,50,99,118,49,57,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,0,80,75,78,50,99,118,49,57,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,49,57,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,69,69,0,80,78,50,99,118,51,79,82,66,69,0,80,75,78,50,99,118,51,79,82,66,69,0,78,50,99,118,51,80,116,114,73,78,83,95,51,79,82,66,69,69,69,0,105,105,105,102,105,105,105,105,105,105,105,0,105,105,105,102,105,105,105,105,105,105,0,105,105,105,102,105,105,105,105,105,0,105,105,105,102,105,105,105,105,0,105,105,105,102,105,105,105,0,105,105,105,102,105,105,0,105,105,105,102,105,0,105,105,105,102,0,109,121,95,111,98,106,101,99,116,0,118,105,114,116,117,97,108,32,99,118,58,58,83,116,114,105,110,103,32,99,118,58,58,65,108,103,111,114,105,116,104,109,58,58,103,101,116,68,101,102,97,117,108,116,78,97,109,101,40,41,32,99,111,110,115,116,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,97,108,103,111,114,105,116,104,109,46,99,112,112,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,65,108,103,111,114,105,116,104,109,58,58,115,97,118,101,40,99,111,110,115,116,32,99,118,58,58,83,116,114,105,110,103,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,99,118,58,58,65,108,103,111,114,105,116,104,109,58,58,126,65,108,103,111,114,105,116,104,109,40,41,0,78,50,99,118,57,65,108,103,111,114,105,116,104,109,69,0,99,118,58,58,65,108,103,111,114,105,116,104,109,58,58,65,108,103,111,114,105,116,104,109,40,41,0,118,111,105,100,32,99,118,58,58,65,108,103,111,114,105,116,104,109,58,58,119,114,105,116,101,70,111,114,109,97,116,40,99,118,58,58,70,105,108,101,83,116,111,114,97,103,101,32,38,41,32,99,111,110,115,116,0,70,97,105,108,101,100,32,116,111,32,97,108,108,111,99,97,116,101,32,37,108,108,117,32,98,121,116,101,115,0,79,117,116,79,102,77,101,109,111,114,121,69,114,114,111,114,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,97,108,108,111,99,46,99,112,112,0,99,111,110,118,101,114,116,65,110,100,85,110,114,111,108,108,83,99,97,108,97,114,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,97,114,105,116,104,109,46,99,112,112,0,84,104,101,32,111,112,101,114,97,116,105,111,110,32,105,115,32,110,101,105,116,104,101,114,32,39,97,114,114,97,121,32,111,112,32,97,114,114,97,121,39,32,40,119,104,101,114,101,32,97,114,114,97,121,115,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,116,121,112,101,41,44,32,110,111,114,32,39,97,114,114,97,121,32,111,112,32,115,99,97,108,97,114,39,44,32,110,111,114,32,39,115,99,97,108,97,114,32,111,112,32,97,114,114,97,121,39,0,98,105,110,97,114,121,95,111,112,0,112,115,114,99,49,45,62,115,97,109,101,83,105,122,101,40,42,112,115,114,99,50,41,32,38,38,32,116,121,112,101,49,32,61,61,32,116,121,112,101,50,0,40,109,116,121,112,101,32,61,61,32,48,32,124,124,32,109,116,121,112,101,32,61,61,32,49,41,32,38,38,32,95,109,97,115,107,46,115,97,109,101,83,105,122,101,40,42,112,115,114,99,49,41,0,118,111,105,100,32,99,118,58,58,98,105,116,119,105,115,101,95,97,110,100,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,98,105,116,119,105,115,101,95,111,114,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,98,105,116,119,105,115,101,95,120,111,114,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,98,105,116,119,105,115,101,95,110,111,116,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,109,97,120,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,109,105,110,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,109,97,120,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,99,118,58,58,77,97,116,32,38,41,0,118,111,105,100,32,99,118,58,58,109,105,110,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,99,118,58,58,77,97,116,32,38,41,0,84,104,101,32,111,112,101,114,97,116,105,111,110,32,105,115,32,110,101,105,116,104,101,114,32,39,97,114,114,97,121,32,111,112,32,97,114,114,97,121,39,32,40,119,104,101,114,101,32,97,114,114,97,121,115,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,116,104,101,32,115,97,109,101,32,110,117,109,98,101,114,32,111,102,32,99,104,97,110,110,101,108,115,41,44,32,110,111,114,32,39,97,114,114,97,121,32,111,112,32,115,99,97,108,97,114,39,44,32,110,111,114,32,39,115,99,97,108,97,114,32,111,112,32,97,114,114,97,121,39,0,97,114,105,116,104,109,95,111,112,0,116,121,112,101,50,32,61,61,32,54,32,38,38,32,40,115,122,50,46,104,101,105,103,104,116,32,61,61,32,49,32,124,124,32,115,122,50,46,104,101,105,103,104,116,32,61,61,32,52,41,0,87,104,101,110,32,116,104,101,32,105,110,112,117,116,32,97,114,114,97,121,115,32,105,110,32,97,100,100,47,115,117,98,116,114,97,99,116,47,109,117,108,116,105,112,108,121,47,100,105,118,105,100,101,32,102,117,110,99,116,105,111,110,115,32,104,97,118,101,32,100,105,102,102,101,114,101,110,116,32,116,121,112,101,115,44,32,116,104,101,32,111,117,116,112,117,116,32,97,114,114,97,121,32,116,121,112,101,32,109,117,115,116,32,98,101,32,101,120,112,108,105,99,105,116,108,121,32,115,112,101,99,105,102,105,101,100,0,40,109,116,121,112,101,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,109,116,121,112,101,32,61,61,32,40,40,40,49,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,41,32,38,38,32,95,109,97,115,107,46,115,97,109,101,83,105,122,101,40,42,112,115,114,99,49,41,0,118,111,105,100,32,99,118,58,58,97,100,100,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,115,117,98,116,114,97,99,116,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,97,98,115,100,105,102,102,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,109,117,108,116,105,112,108,121,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,100,105,118,105,100,101,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,100,105,118,105,100,101,40,100,111,117,98,108,101,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,97,100,100,87,101,105,103,104,116,101,100,40,73,110,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,73,110,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,111,112,32,61,61,32,67,77,80,95,76,84,32,124,124,32,111,112,32,61,61,32,67,77,80,95,76,69,32,124,124,32,111,112,32,61,61,32,67,77,80,95,69,81,32,124,124,32,111,112,32,61,61,32,67,77,80,95,78,69,32,124,124,32,111,112,32,61,61,32,67,77,80,95,71,69,32,124,124,32,111,112,32,61,61,32,67,77,80,95,71,84,0,99,111,109,112,97,114,101,0,84,104,101,32,111,112,101,114,97,116,105,111,110,32,105,115,32,110,101,105,116,104,101,114,32,39,97,114,114,97,121,32,111,112,32,97,114,114,97,121,39,32,40,119,104,101,114,101,32,97,114,114,97,121,115,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,116,104,101,32,115,97,109,101,32,116,121,112,101,41,44,32,110,111,114,32,39,97,114,114,97,121,32,111,112,32,115,99,97,108,97,114,39,44,32,110,111,114,32,39,115,99,97,108,97,114,32,111,112,32,97,114,114,97,121,39,0,118,111,105,100,32,99,118,58,58,99,111,109,112,97,114,101,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,84,104,101,32,108,111,119,101,114,32,98,111,117,110,100,97,114,121,32,105,115,32,110,101,105,116,104,101,114,32,97,110,32,97,114,114,97,121,32,111,102,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,115,97,109,101,32,116,121,112,101,32,97,115,32,115,114,99,44,32,110,111,114,32,97,32,115,99,97,108,97,114,0,105,110,82,97,110,103,101,0,84,104,101,32,117,112,112,101,114,32,98,111,117,110,100,97,114,121,32,105,115,32,110,101,105,116,104,101,114,32,97,110,32,97,114,114,97,121,32,111,102,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,115,97,109,101,32,116,121,112,101,32,97,115,32,115,114,99,44,32,110,111,114,32,97,32,115,99,97,108,97,114,0,108,98,83,99,97,108,97,114,32,61,61,32,117,98,83,99,97,108,97,114,0,108,98,46,116,121,112,101,40,41,32,61,61,32,117,98,46,116,121,112,101,40,41,0,118,111,105,100,32,99,118,58,58,105,110,82,97,110,103,101,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,115,112,108,105,116,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,99,111,110,118,101,114,116,46,99,112,112,0,118,111,105,100,32,99,118,58,58,115,112,108,105,116,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,99,118,58,58,77,97,116,32,42,41,0,33,95,109,118,46,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,95,109,118,46,101,109,112,116,121,40,41,32,124,124,32,95,109,118,46,116,121,112,101,40,41,32,61,61,32,109,46,100,101,112,116,104,40,41,0,118,111,105,100,32,99,118,58,58,115,112,108,105,116,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,109,118,32,38,38,32,110,32,62,32,48,0,109,101,114,103,101,0,109,118,91,105,93,46,115,105,122,101,32,61,61,32,109,118,91,48,93,46,115,105,122,101,32,38,38,32,109,118,91,105,93,46,100,101,112,116,104,40,41,32,61,61,32,100,101,112,116,104,0,48,32,60,32,99,110,32,38,38,32,99,110,32,60,61,32,53,49,50,0,115,114,99,32,38,38,32,110,115,114,99,115,32,62,32,48,32,38,38,32,100,115,116,32,38,38,32,110,100,115,116,115,32,62,32,48,32,38,38,32,102,114,111,109,84,111,32,38,38,32,110,112,97,105,114,115,32,62,32,48,0,109,105,120,67,104,97,110,110,101,108,115,0,106,32,60,32,110,115,114,99,115,32,38,38,32,115,114,99,91,106,93,46,100,101,112,116,104,40,41,32,61,61,32,100,101,112,116,104,0,105,49,32,62,61,32,48,32,38,38,32,106,32,60,32,110,100,115,116,115,32,38,38,32,100,115,116,91,106,93,46,100,101,112,116,104,40,41,32,61,61,32,100,101,112,116,104,0,118,111,105,100,32,99,118,58,58,109,105,120,67,104,97,110,110,101,108,115,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,42,44,32,115,105,122,101,95,116,44,32,99,118,58,58,77,97,116,32,42,44,32,115,105,122,101,95,116,44,32,99,111,110,115,116,32,105,110,116,32,42,44,32,115,105,122,101,95,116,41,0,118,111,105,100,32,99,118,58,58,109,101,114,103,101,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,42,44,32,115,105,122,101,95,116,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,109,101,114,103,101,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,110,115,114,99,32,62,32,48,32,38,38,32,110,100,115,116,32,62,32,48,0,118,111,105,100,32,99,118,58,58,109,105,120,67,104,97,110,110,101,108,115,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,99,111,110,115,116,32,105,110,116,32,42,44,32,115,105,122,101,95,116,41,0,102,114,111,109,84,111,46,115,105,122,101,40,41,37,50,32,61,61,32,48,32,38,38,32,110,115,114,99,32,62,32,48,32,38,38,32,110,100,115,116,32,62,32,48,0,118,111,105,100,32,99,118,58,58,109,105,120,67,104,97,110,110,101,108,115,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,41,0,48,32,60,61,32,99,111,105,32,38,38,32,99,111,105,32,60,32,99,110,0,101,120,116,114,97,99,116,67,104,97,110,110,101,108,0,118,111,105,100,32,99,118,58,58,101,120,116,114,97,99,116,67,104,97,110,110,101,108,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,99,111,110,118,101,114,116,83,99,97,108,101,65,98,115,0,118,111,105,100,32,99,118,58,58,99,111,110,118,101,114,116,83,99,97,108,101,65,98,115,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,41,0,99,111,110,118,101,114,116,84,111,0,118,111,105,100,32,99,118,58,58,77,97,116,58,58,99,111,110,118,101,114,116,84,111,40,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,41,32,99,111,110,115,116,0,78,50,99,118,54,100,101,116,97,105,108,56,80,116,114,79,119,110,101,114,69,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,110,111,114,109,32,116,121,112,101,0,110,111,114,109,97,108,105,122,101,0,118,111,105,100,32,99,118,58,58,110,111,114,109,97,108,105,122,101,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,73,110,112,117,116,65,114,114,97,121,41,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,99,111,112,121,46,99,112,112,0,100,115,116,46,117,32,33,61,32,48,76,0,100,105,109,115,32,62,61,32,48,32,38,38,32,100,105,109,115,32,60,32,51,50,0,118,111,105,100,32,99,118,58,58,77,97,116,58,58,99,111,112,121,84,111,40,79,117,116,112,117,116,65,114,114,97,121,41,32,99,111,110,115,116,0,109,97,115,107,46,100,101,112,116,104,40,41,32,61,61,32,48,32,38,38,32,40,109,99,110,32,61,61,32,49,32,124,124,32,109,99,110,32,61,61,32,99,110,41,0,115,105,122,101,40,41,32,61,61,32,109,97,115,107,46,115,105,122,101,40,41,0,115,122,32,60,61,32,115,105,122,101,111,102,40,115,99,97,108,97,114,41,0,99,118,58,58,77,97,116,32,38,99,118,58,58,77,97,116,58,58,111,112,101,114,97,116,111,114,61,40,99,111,110,115,116,32,83,99,97,108,97,114,32,38,41,0,118,111,105,100,32,99,118,58,58,77,97,116,58,58,99,111,112,121,84,111,40,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,32,99,111,110,115,116,0,99,104,101,99,107,83,99,97,108,97,114,40,118,97,108,117,101,44,32,116,121,112,101,40,41,44,32,95,118,97,108,117,101,46,107,105,110,100,40,41,44,32,95,73,110,112,117,116,65,114,114,97,121,58,58,77,65,84,32,41,0,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,40,109,97,115,107,46,100,101,112,116,104,40,41,32,61,61,32,48,32,38,38,32,40,109,99,110,32,61,61,32,49,32,124,124,32,109,99,110,32,61,61,32,99,110,41,32,38,38,32,115,105,122,101,32,61,61,32,109,97,115,107,46,115,105,122,101,41,0,99,118,58,58,77,97,116,32,38,99,118,58,58,77,97,116,58,58,115,101,116,84,111,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,102,108,105,112,0,118,111,105,100,32,99,118,58,58,102,108,105,112,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,95,115,114,99,46,103,101,116,79,98,106,40,41,32,33,61,32,95,100,115,116,46,103,101,116,79,98,106,40,41,0,114,101,112,101,97,116,0,110,121,32,62,32,48,32,38,38,32,110,120,32,62,32,48,0,118,111,105,100,32,99,118,58,58,114,101,112,101,97,116,40,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,98,111,114,100,101,114,73,110,116,101,114,112,111,108,97,116,101,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,98,111,114,100,101,114,32,116,121,112,101,0,116,111,112,32,62,61,32,48,32,38,38,32,98,111,116,116,111,109,32,62,61,32,48,32,38,38,32,108,101,102,116,32,62,61,32,48,32,38,38,32,114,105,103,104,116,32,62,61,32,48,0,99,111,112,121,77,97,107,101,66,111,114,100,101,114,0,118,97,108,117,101,91,48,93,32,61,61,32,118,97,108,117,101,91,49,93,32,38,38,32,118,97,108,117,101,91,48,93,32,61,61,32,118,97,108,117,101,91,50,93,32,38,38,32,118,97,108,117,101,91,48,93,32,61,61,32,118,97,108,117,101,91,51,93,0,118,111,105,100,32,99,118,58,58,99,111,112,121,77,97,107,101,66,111,114,100,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,41,0,109,97,115,107,97,114,114,32,61,61,32,48,0,99,118,67,111,112,121,0,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,100,115,116,46,100,101,112,116,104,40,41,32,38,38,32,115,114,99,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,0,40,99,111,105,49,32,33,61,32,48,32,124,124,32,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,41,32,38,38,32,40,99,111,105,50,32,33,61,32,48,32,124,124,32,100,115,116,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,41,0,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,100,115,116,46,99,104,97,110,110,101,108,115,40,41,0,105,99,118,73,110,105,116,77,101,109,83,116,111,114,97,103,101,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,100,97,116,97,115,116,114,117,99,116,115,46,99,112,112,0,99,118,67,114,101,97,116,101,67,104,105,108,100,77,101,109,83,116,111,114,97,103,101,0,99,118,82,101,108,101,97,115,101,77,101,109,83,116,111,114,97,103,101,0,99,118,67,108,101,97,114,77,101,109,83,116,111,114,97,103,101,0,99,118,83,97,118,101,77,101,109,83,116,111,114,97,103,101,80,111,115,0,99,118,82,101,115,116,111,114,101,77,101,109,83,116,111,114,97,103,101,80,111,115,0,99,118,77,101,109,83,116,111,114,97,103,101,65,108,108,111,99,0,84,111,111,32,108,97,114,103,101,32,109,101,109,111,114,121,32,98,108,111,99,107,32,105,115,32,114,101,113,117,101,115,116,101,100,0,114,101,113,117,101,115,116,101,100,32,115,105,122,101,32,105,115,32,110,101,103,97,116,105,118,101,32,111,114,32,116,111,111,32,98,105,103,0,105,99,118,71,111,78,101,120,116,77,101,109,66,108,111,99,107,0,99,118,67,114,101,97,116,101,83,101,113,0,83,112,101,99,105,102,105,101,100,32,101,108,101,109,101,110,116,32,115,105,122,101,32,100,111,101,115,110,39,116,32,109,97,116,99,104,32,116,111,32,116,104,101,32,115,105,122,101,32,111,102,32,116,104,101,32,115,112,101,99,105,102,105,101,100,32,101,108,101,109,101,110,116,32,116,121,112,101,32,40,116,114,121,32,116,111,32,117,115,101,32,48,32,102,111,114,32,101,108,101,109,101,110,116,32,116,121,112,101,41,0,99,118,83,101,116,83,101,113,66,108,111,99,107,83,105,122,101,0,83,116,111,114,97,103,101,32,98,108,111,99,107,32,115,105,122,101,32,105,115,32,116,111,111,32,115,109,97,108,108,32,116,111,32,102,105,116,32,116,104,101,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,115,0,0,1,255,2,255,255,255,3,255,255,255,255,255,255,255,4,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,5,99,118,67,118,116,83,101,113,84,111,65,114,114,97,121,0,99,118,83,101,116,83,101,113,82,101,97,100,101,114,80,111,115,0,99,118,83,116,97,114,116,82,101,97,100,83,101,113,0,99,118,77,97,107,101,83,101,113,72,101,97,100,101,114,70,111,114,65,114,114,97,121,0,69,108,101,109,101,110,116,32,115,105,122,101,32,100,111,101,115,110,39,116,32,109,97,116,99,104,32,116,111,32,116,104,101,32,115,105,122,101,32,111,102,32,112,114,101,100,101,102,105,110,101,100,32,101,108,101,109,101,110,116,32,116,121,112,101,32,40,116,114,121,32,116,111,32,117,115,101,32,48,32,102,111,114,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,32,116,121,112,101,41,0,99,118,83,116,97,114,116,65,112,112,101,110,100,84,111,83,101,113,0,99,118,83,116,97,114,116,87,114,105,116,101,83,101,113,0,99,118,70,108,117,115,104,83,101,113,87,114,105,116,101,114,0,99,118,69,110,100,87,114,105,116,101,83,101,113,0,99,118,67,114,101,97,116,101,83,101,113,66,108,111,99,107,0,105,99,118,71,114,111,119,83,101,113,0,84,104,101,32,115,101,113,117,101,110,99,101,32,104,97,115,32,78,85,76,76,32,115,116,111,114,97,103,101,32,112,111,105,110,116,101,114,0,99,118,67,104,97,110,103,101,83,101,113,66,108,111,99,107,0,99,118,71,101,116,83,101,113,82,101,97,100,101,114,80,111,115,0,99,118,83,101,113,80,117,115,104,0,99,118,83,101,113,80,111,112,0,78,85,76,76,32,115,101,113,117,101,110,99,101,32,112,111,105,110,116,101,114,0,99,118,83,101,113,80,117,115,104,77,117,108,116,105,0,110,117,109,98,101,114,32,111,102,32,114,101,109,111,118,101,100,32,101,108,101,109,101,110,116,115,32,105,115,32,110,101,103,97,116,105,118,101,0,99,118,83,101,113,80,111,112,77,117,108,116,105,0,99,118,67,108,101,97,114,83,101,113,0,73,110,118,97,108,105,100,32,115,101,113,117,101,110,99,101,32,104,101,97,100,101,114,0,99,118,83,101,113,83,108,105,99,101,0,66,97,100,32,115,101,113,117,101,110,99,101,32,115,108,105,99,101,0,66,97,100,32,105,110,112,117,116,32,115,101,113,117,101,110,99,101,0,99,118,83,101,113,83,111,114,116,0,78,117,108,108,32,99,111,109,112,97,114,101,32,102,117,110,99,116,105,111,110,0,99,118,67,114,101,97,116,101,83,101,116,0,99,118,83,101,116,65,100,100,0,99,118,67,114,101,97,116,101,71,114,97,112,104,0,99,118,71,114,97,112,104,65,100,100,86,116,120,0,99,118,70,105,110,100,71,114,97,112,104,69,100,103,101,66,121,80,116,114,0,103,114,97,112,104,32,112,111,105,110,116,101,114,32,105,115,32,78,85,76,76,0,99,118,71,114,97,112,104,65,100,100,69,100,103,101,66,121,80,116,114,0,118,101,114,116,101,120,32,112,111,105,110,116,101,114,115,32,99,111,105,110,115,105,100,101,32,40,111,114,32,115,101,116,32,116,111,32,78,85,76,76,41,0,73,110,118,97,108,105,100,32,103,114,97,112,104,32,112,111,105,110,116,101,114,0,99,118,67,108,111,110,101,71,114,97,112,104,0,99,118,84,114,101,101,84,111,78,111,100,101,83,101,113,0,99,118,73,110,105,116,84,114,101,101,78,111,100,101,73,116,101,114,97,116,111,114,0,99,118,78,101,120,116,84,114,101,101,78,111,100,101,0,99,118,73,110,115,101,114,116,78,111,100,101,73,110,116,111,84,114,101,101,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,53,79,99,118,68,102,116,66,97,115,105,99,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,99,46,102,97,99,116,111,114,115,91,48,93,32,61,61,32,99,46,102,97,99,116,111,114,115,91,99,46,110,102,45,49,93,0,68,70,84,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,100,120,116,46,99,112,112,0,0,128,64,192,32,160,96,224,16,144,80,208,48,176,112,240,8,136,72,200,40,168,104,232,24,152,88,216,56,184,120,248,4,132,68,196,36,164,100,228,20,148,84,212,52,180,116,244,12,140,76,204,44,172,108,236,28,156,92,220,60,188,124,252,2,130,66,194,34,162,98,226,18,146,82,210,50,178,114,242,10,138,74,202,42,170,106,234,26,154,90,218,58,186,122,250,6,134,70,198,38,166,102,230,22,150,86,214,54,182,118,246,14,142,78,206,46,174,110,238,30,158,94,222,62,190,126,254,1,129,65,193,33,161,97,225,17,145,81,209,49,177,113,241,9,137,73,201,41,169,105,233,25,153,89,217,57,185,121,249,5,133,69,197,37,165,101,229,21,149,85,213,53,181,117,245,13,141,77,205,45,173,109,237,29,157,93,221,61,189,125,253,3,131,67,195,35,163,99,227,19,147,83,211,51,179,115,243,11,139,75,203,43,171,107,235,27,155,91,219,59,187,123,251,7,135,71,199,39,167,103,231,23,151,87,215,55,183,119,247,15,143,79,207,47,175,111,239,31,159,95,223,63,191,127,255,78,50,99,118,49,53,79,99,118,68,102,116,66,97,115,105,99,73,109,112,108,69,0,78,50,99,118,51,104,97,108,53,68,70,84,49,68,69,0,78,50,99,118,49,54,82,101,112,108,97,99,101,109,101,110,116,68,70,84,49,68,69,0,84,104,105,115,32,109,111,100,101,32,40,117,115,105,110,103,32,110,111,110,122,101,114,111,95,114,111,119,115,32,119,105,116,104,32,97,32,115,105,110,103,108,101,45,99,111,108,117,109,110,32,109,97,116,114,105,120,41,32,98,114,101,97,107,115,32,116,104,101,32,102,117,110,99,116,105,111,110,39,115,32,108,111,103,105,99,44,32,115,111,32,105,116,32,105,115,32,112,114,111,104,105,98,105,116,101,100,46,10,70,111,114,32,102,97,115,116,32,99,111,110,118,111,108,117,116,105,111,110,47,99,111,114,114,101,108,97,116,105,111,110,32,117,115,101,32,50,45,99,111,108,117,109,110,32,109,97,116,114,105,120,32,111,114,32,115,105,110,103,108,101,45,114,111,119,32,109,97,116,114,105,120,32,105,110,115,116,101,97,100,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,79,99,118,68,102,116,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,49,48,79,99,118,68,102,116,73,109,112,108,69,0,78,50,99,118,51,104,97,108,53,68,70,84,50,68,69,0,78,50,99,118,49,54,82,101,112,108,97,99,101,109,101,110,116,68,70,84,50,68,69,0,116,121,112,101,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,116,121,112,101,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,116,121,112,101,32,61,61,32,40,40,40,54,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,116,121,112,101,32,61,61,32,40,40,40,54,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,0,100,102,116,0,33,40,40,102,108,97,103,115,32,38,32,68,70,84,95,67,79,77,80,76,69,88,95,73,78,80,85,84,41,32,38,38,32,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,33,61,32,50,41,0,118,111,105,100,32,99,118,58,58,100,102,116,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,41,0,116,121,112,101,32,61,61,32,115,114,99,66,46,116,121,112,101,40,41,32,38,38,32,115,114,99,65,46,115,105,122,101,40,41,32,61,61,32,115,114,99,66,46,115,105,122,101,40,41,0,109,117,108,83,112,101,99,116,114,117,109,115,0,118,111,105,100,32,99,118,58,58,109,117,108,83,112,101,99,116,114,117,109,115,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,98,111,111,108,41,0,100,97,116,97,48,46,100,105,109,115,32,60,61,32,50,32,38,38,32,116,121,112,101,32,61,61,32,53,32,38,38,32,75,32,62,32,48,0,107,109,101,97,110,115,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,107,109,101,97,110,115,46,99,112,112,0,78,32,62,61,32,75,0,40,98,101,115,116,95,108,97,98,101,108,115,46,99,111,108,115,32,61,61,32,49,32,124,124,32,98,101,115,116,95,108,97,98,101,108,115,46,114,111,119,115,32,61,61,32,49,41,32,38,38,32,98,101,115,116,95,108,97,98,101,108,115,46,99,111,108,115,42,98,101,115,116,95,108,97,98,101,108,115,46,114,111,119,115,32,61,61,32,78,32,38,38,32,98,101,115,116,95,108,97,98,101,108,115,46,116,121,112,101,40,41,32,61,61,32,52,32,38,38,32,98,101,115,116,95,108,97,98,101,108,115,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,40,117,110,115,105,103,110,101,100,41,108,97,98,101,108,115,91,105,93,32,60,32,40,117,110,115,105,103,110,101,100,41,75,0,99,111,117,110,116,101,114,115,91,107,93,32,33,61,32,48,0,78,50,99,118,50,50,75,77,101,97,110,115,68,105,115,116,97,110,99,101,67,111,109,112,117,116,101,114,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,75,77,101,97,110,115,80,80,68,105,115,116,97,110,99,101,67,111,109,112,117,116,101,114,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+153612);allocate([99,111,110,115,116,0,78,50,99,118,50,52,75,77,101,97,110,115,80,80,68,105,115,116,97,110,99,101,67,111,109,112,117,116,101,114,69,0,118,111,105,100,32,99,118,58,58,103,101,110,101,114,97,116,101,67,101,110,116,101,114,115,80,80,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,99,118,58,58,77,97,116,32,38,44,32,105,110,116,44,32,99,118,58,58,82,78,71,32,38,44,32,105,110,116,41,0,100,111,117,98,108,101,32,99,118,58,58,107,109,101,97,110,115,40,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,99,118,58,58,84,101,114,109,67,114,105,116,101,114,105,97,44,32,105,110,116,44,32,105,110,116,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,108,97,112,97,99,107,46,99,112,112,0,33,109,97,116,46,101,109,112,116,121,40,41,0,100,101,116,101,114,109,105,110,97,110,116,0,109,97,116,46,114,111,119,115,32,61,61,32,109,97,116,46,99,111,108,115,32,38,38,32,40,116,121,112,101,32,61,61,32,53,32,124,124,32,116,121,112,101,32,61,61,32,54,41,0,100,111,117,98,108,101,32,99,118,58,58,100,101,116,101,114,109,105,110,97,110,116,40,73,110,112,117,116,65,114,114,97,121,41,0,116,121,112,101,32,61,61,32,53,32,124,124,32,116,121,112,101,32,61,61,32,54,0,105,110,118,101,114,116,0,109,32,61,61,32,110,0,109,101,116,104,111,100,32,61,61,32,68,69,67,79,77,80,95,76,85,32,124,124,32,109,101,116,104,111,100,32,61,61,32,68,69,67,79,77,80,95,67,72,79,76,69,83,75,89,0,115,114,99,46,114,111,119,115,32,61,61,32,115,114,99,46,99,111,108,115,0,101,105,103,101,110,0,98,111,111,108,32,99,118,58,58,101,105,103,101,110,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,119,46,116,121,112,101,40,41,32,61,61,32,117,46,116,121,112,101,40,41,32,38,38,32,117,46,116,121,112,101,40,41,32,61,61,32,118,116,46,116,121,112,101,40,41,32,38,38,32,117,46,100,97,116,97,32,38,38,32,118,116,46,100,97,116,97,32,38,38,32,119,46,100,97,116,97,0,98,97,99,107,83,117,98,115,116,0,117,46,99,111,108,115,32,62,61,32,110,109,32,38,38,32,118,116,46,114,111,119,115,32,62,61,32,110,109,32,38,38,32,40,119,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,110,109,44,32,49,41,32,124,124,32,119,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,110,109,41,32,124,124,32,119,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,118,116,46,114,111,119,115,44,32,117,46,99,111,108,115,41,41,0,114,104,115,46,100,97,116,97,32,61,61,32,48,32,124,124,32,40,114,104,115,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,32,38,38,32,114,104,115,46,114,111,119,115,32,61,61,32,109,41,0,95,83,86,68,99,111,109,112,117,116,101,0,115,116,97,116,105,99,32,118,111,105,100,32,99,118,58,58,83,86,68,58,58,99,111,109,112,117,116,101,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,100,111,117,98,108,101,32,99,118,58,58,105,110,118,101,114,116,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,116,121,112,101,32,61,61,32,95,115,114,99,50,46,116,121,112,101,40,41,32,38,38,32,40,116,121,112,101,32,61,61,32,53,32,124,124,32,116,121,112,101,32,61,61,32,54,41,0,115,111,108,118,101,0,40,109,101,116,104,111,100,32,33,61,32,68,69,67,79,77,80,95,76,85,32,38,38,32,109,101,116,104,111,100,32,33,61,32,68,69,67,79,77,80,95,67,72,79,76,69,83,75,89,41,32,124,124,32,105,115,95,110,111,114,109,97,108,32,124,124,32,115,114,99,46,114,111,119,115,32,61,61,32,115,114,99,46,99,111,108,115,0,84,104,101,32,102,117,110,99,116,105,111,110,32,99,97,110,32,110,111,116,32,115,111,108,118,101,32,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,98,111,111,108,32,99,118,58,58,115,111,108,118,101,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,102,108,111,97,116,32,99,118,58,58,99,117,98,101,82,111,111,116,40,102,108,111,97,116,41,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,104,102,117,110,99,115,46,99,112,112,0,115,114,99,49,46,115,105,122,101,40,41,32,61,61,32,115,114,99,50,46,115,105,122,101,40,41,32,38,38,32,116,121,112,101,32,61,61,32,115,114,99,50,46,116,121,112,101,40,41,32,38,38,32,40,100,101,112,116,104,32,61,61,32,53,32,124,124,32,100,101,112,116,104,32,61,61,32,54,41,0,118,111,105,100,32,99,118,58,58,109,97,103,110,105,116,117,100,101,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,88,46,115,105,122,101,32,61,61,32,89,46,115,105,122,101,32,38,38,32,116,121,112,101,32,61,61,32,89,46,116,121,112,101,40,41,32,38,38,32,40,100,101,112,116,104,32,61,61,32,53,32,124,124,32,100,101,112,116,104,32,61,61,32,54,41,0,99,97,114,116,84,111,80,111,108,97,114,0,118,111,105,100,32,99,118,58,58,99,97,114,116,84,111,80,111,108,97,114,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,98,111,111,108,41,0,40,100,101,112,116,104,32,61,61,32,53,32,124,124,32,100,101,112,116,104,32,61,61,32,54,41,32,38,38,32,40,115,114,99,49,46,101,109,112,116,121,40,41,32,124,124,32,115,114,99,49,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,41,0,112,111,108,97,114,84,111,67,97,114,116,0,77,97,103,46,101,109,112,116,121,40,41,32,124,124,32,65,110,103,108,101,46,115,105,122,101,32,61,61,32,77,97,103,46,115,105,122,101,0,118,111,105,100,32,99,118,58,58,112,111,108,97,114,84,111,67,97,114,116,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,98,111,111,108,41,0,101,120,112,0,118,111,105,100,32,99,118,58,58,101,120,112,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,108,111,103,0,118,111,105,100,32,99,118,58,58,108,111,103,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,112,111,119,0,118,111,105,100,32,99,118,58,58,112,111,119,40,73,110,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,115,113,114,116,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,95,97,46,100,101,112,116,104,40,41,32,61,61,32,53,0,112,97,116,99,104,78,97,78,115,0,118,111,105,100,32,99,118,58,58,112,97,116,99,104,78,97,78,115,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,41,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,100,115,116,46,116,121,112,101,40,41,32,38,38,32,115,114,99,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,0,99,118,80,111,119,0,99,116,121,112,101,32,61,61,32,53,32,124,124,32,99,116,121,112,101,32,61,61,32,54,0,115,111,108,118,101,67,117,98,105,99,0,40,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,110,48,44,32,49,41,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,110,48,43,49,44,32,49,41,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,110,48,41,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,110,48,43,49,41,41,0,105,110,116,32,99,118,58,58,115,111,108,118,101,67,117,98,105,99,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,40,40,99,116,121,112,101,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,62,61,32,53,32,38,38,32,40,40,40,40,99,116,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,60,61,32,50,0,115,111,108,118,101,80,111,108,121,0,99,111,101,102,102,115,48,46,114,111,119,115,32,61,61,32,49,32,124,124,32,99,111,101,102,102,115,48,46,99,111,108,115,32,61,61,32,49,0,100,111,117,98,108,101,32,99,118,58,58,115,111,108,118,101,80,111,108,121,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,102,97,115,116,65,116,97,110,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,44,32,98,111,111,108,41,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,104,102,117,110,99,115,95,99,111,114,101,46,115,105,109,100,46,104,112,112,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,102,97,115,116,65,116,97,110,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,44,32,98,111,111,108,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,109,97,103,110,105,116,117,100,101,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,109,97,103,110,105,116,117,100,101,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,105,110,118,83,113,114,116,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,105,110,118,83,113,114,116,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,115,113,114,116,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,115,113,114,116,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,101,120,112,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,101,120,112,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,108,111,103,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,108,111,103,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,102,97,115,116,65,116,97,110,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,44,32,98,111,111,108,41,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,104,102,117,110,99,115,95,99,111,114,101,46,100,105,115,112,97,116,99,104,46,99,112,112,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,102,97,115,116,65,116,97,110,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,44,32,98,111,111,108,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,109,97,103,110,105,116,117,100,101,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,109,97,103,110,105,116,117,100,101,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,105,110,118,83,113,114,116,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,105,110,118,83,113,114,116,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,115,113,114,116,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,115,113,114,116,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,101,120,112,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,101,120,112,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,108,111,103,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,108,111,103,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,41,0,116,121,112,101,32,61,61,32,40,40,40,54,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,0,103,101,109,109,73,109,112,108,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,109,117,108,46,99,112,112,0,118,111,105,100,32,99,118,58,58,103,101,109,109,73,109,112,108,40,99,118,58,58,77,97,116,44,32,99,118,58,58,77,97,116,44,32,100,111,117,98,108,101,44,32,99,118,58,58,77,97,116,44,32,100,111,117,98,108,101,44,32,99,118,58,58,77,97,116,44,32,105,110,116,41,0,116,121,112,101,32,61,61,32,66,46,116,121,112,101,40,41,0,103,101,109,109,0,40,116,121,112,101,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,116,121,112,101,32,61,61,32,40,40,40,54,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,116,121,112,101,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,116,121,112,101,32,61,61,32,40,40,40,54,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,41,0,97,95,115,105,122,101,46,119,105,100,116,104,32,61,61,32,108,101,110,0,97,95,115,105,122,101,46,104,101,105,103,104,116,32,61,61,32,108,101,110,0,67,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,0,40,40,40,102,108,97,103,115,38,71,69,77,77,95,51,95,84,41,32,61,61,32,48,32,38,38,32,67,46,114,111,119,115,32,61,61,32,100,95,115,105,122,101,46,104,101,105,103,104,116,32,38,38,32,67,46,99,111,108,115,32,61,61,32,100,95,115,105,122,101,46,119,105,100,116,104,41,32,124,124,32,40,40,102,108,97,103,115,38,71,69,77,77,95,51,95,84,41,32,33,61,32,48,32,38,38,32,67,46,114,111,119,115,32,61,61,32,100,95,115,105,122,101,46,119,105,100,116,104,32,38,38,32,67,46,99,111,108,115,32,61,61,32,100,95,115,105,122,101,46,104,101,105,103,104,116,41,41,0,115,99,110,32,61,61,32,109,46,99,111,108,115,32,124,124,32,115,99,110,32,43,32,49,32,61,61,32,109,46,99,111,108,115,0,116,114,97,110,115,102,111,114,109,0,118,111,105,100,32,99,118,58,58,116,114,97,110,115,102,111,114,109,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,115,99,110,32,43,32,49,32,61,61,32,109,46,99,111,108,115,0,112,101,114,115,112,101,99,116,105,118,101,84,114,97,110,115,102,111,114,109,0,100,101,112,116,104,32,61,61,32,53,32,124,124,32,100,101,112,116,104,32,61,61,32,54,0,118,111,105,100,32,99,118,58,58,112,101,114,115,112,101,99,116,105,118,101,84,114,97,110,115,102,111,114,109,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,116,121,112,101,32,61,61,32,95,115,114,99,50,46,116,121,112,101,40,41,0,115,99,97,108,101,65,100,100,0,115,114,99,49,46,115,105,122,101,32,61,61,32,115,114,99,50,46,115,105,122,101,0,118,111,105,100,32,99,118,58,58,115,99,97,108,101,65,100,100,40,73,110,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,109,117,108,84,114,97,110,115,112,111,115,101,100,0,100,101,108,116,97,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,40,100,101,108,116,97,46,114,111,119,115,32,61,61,32,115,114,99,46,114,111,119,115,32,124,124,32,100,101,108,116,97,46,114,111,119,115,32,61,61,32,49,41,0,40,100,101,108,116,97,46,99,111,108,115,32,61,61,32,115,114,99,46,99,111,108,115,32,124,124,32,100,101,108,116,97,46,99,111,108,115,32,61,61,32,49,41,0,118,111,105,100,32,99,118,58,58,109,117,108,84,114,97,110,115,112,111,115,101,100,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,98,111,111,108,44,32,73,110,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,109,97,116,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,40,41,0,100,111,116,0,109,97,116,46,115,105,122,101,32,61,61,32,115,105,122,101,0,100,111,117,98,108,101,32,99,118,58,58,77,97,116,58,58,100,111,116,40,73,110,112,117,116,65,114,114,97,121,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,105,110,116,32,99,118,58,58,77,97,116,79,112,58,58,116,121,112,101,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,111,112,46,99,112,112,0,78,50,99,118,49,49,77,97,116,79,112,95,83,111,108,118,101,69,0,40,40,40,40,95,116,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,61,61,32,101,46,97,46,99,104,97,110,110,101,108,115,40,41,0,97,115,115,105,103,110,0,78,50,99,118,49,52,77,97,116,79,112,95,73,100,101,110,116,105,116,121,69,0,78,50,99,118,49,50,77,97,116,79,112,95,73,110,118,101,114,116,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,71,69,77,77,58,58,116,114,97,110,115,112,111,115,101,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,71,69,77,77,58,58,109,117,108,116,105,112,108,121,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,100,111,117,98,108,101,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,71,69,77,77,58,58,115,117,98,116,114,97,99,116,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,71,69,77,77,58,58,97,100,100,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,78,50,99,118,49,48,77,97,116,79,112,95,71,69,77,77,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,65,100,100,69,120,58,58,116,114,97,110,115,112,111,115,101,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,66,105,110,58,58,100,105,118,105,100,101,40,100,111,117,98,108,101,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,66,105,110,58,58,109,117,108,116,105,112,108,121,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,100,111,117,98,108,101,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,85,110,107,110,111,119,110,32,111,112,101,114,97,116,105,111,110,0,78,50,99,118,57,77,97,116,79,112,95,66,105,110,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,65,100,100,69,120,58,58,97,98,115,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,65,100,100,69,120,58,58,100,105,118,105,100,101,40,100,111,117,98,108,101,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,65,100,100,69,120,58,58,109,117,108,116,105,112,108,121,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,100,111,117,98,108,101,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,65,100,100,69,120,58,58,115,117,98,116,114,97,99,116,40,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,65,100,100,69,120,58,58,97,100,100,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,78,50,99,118,49,49,77,97,116,79,112,95,65,100,100,69,120,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,84,58,58,116,114,97,110,115,112,111,115,101,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,84,58,58,109,117,108,116,105,112,108,121,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,100,111,117,98,108,101,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,78,50,99,118,55,77,97,116,79,112,95,84,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,58,58,116,114,97,110,115,112,111,115,101,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,58,58,97,98,115,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,58,58,100,105,118,105,100,101,40,100,111,117,98,108,101,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,58,58,100,105,118,105,100,101,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,100,111,117,98,108,101,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,58,58,109,117,108,116,105,112,108,121,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,100,111,117,98,108,101,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,58,58,109,117,108,116,105,112,108,121,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,100,111,117,98,108,101,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,58,58,115,117,98,116,114,97,99,116,40,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,58,58,115,117,98,116,114,97,99,116,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,58,58,97,100,100,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,58,58,97,100,100,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,78,50,99,118,53,77,97,116,79,112,69,0,78,50,99,118,57,77,97,116,79,112,95,67,109,112,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,73,110,105,116,105,97,108,105,122,101,114,58,58,109,117,108,116,105,112,108,121,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,100,111,117,98,108,101,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,73,110,118,97,108,105,100,32,109,97,116,114,105,120,32,105,110,105,116,105,97,108,105,122,101,114,32,116,121,112,101,0,78,50,99,118,49,55,77,97,116,79,112,95,73,110,105,116,105,97,108,105,122,101,114,69,0,105,110,116,32,99,118,58,58,77,97,116,69,120,112,114,58,58,116,121,112,101,40,41,32,99,111,110,115,116,0,99,118,58,58,77,97,116,69,120,112,114,32,99,118,58,58,77,97,116,58,58,116,40,41,32,99,111,110,115,116,0,99,118,58,58,77,97,116,69,120,112,114,32,99,118,58,58,77,97,116,58,58,105,110,118,40,105,110,116,41,32,99,111,110,115,116,0,99,118,58,58,77,97,116,69,120,112,114,32,99,118,58,58,77,97,116,58,58,109,117,108,40,73,110,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,41,32,99,111,110,115,116,0,115,116,97,116,105,99,32,99,118,58,58,77,97,116,69,120,112,114,32,99,118,58,58,77,97,116,58,58,122,101,114,111,115,40,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,115,116,97,116,105,99,32,99,118,58,58,77,97,116,69,120,112,114,32,99,118,58,58,77,97,116,58,58,122,101,114,111,115,40,83,105,122,101,44,32,105,110,116,41,0,115,116,97,116,105,99,32,99,118,58,58,77,97,116,69,120,112,114,32,99,118,58,58,77,97,116,58,58,111,110,101,115,40,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,115,116,97,116,105,99,32,99,118,58,58,77,97,116,69,120,112,114,32,99,118,58,58,77,97,116,58,58,111,110,101,115,40,83,105,122,101,44,32,105,110,116,41,0,115,116,97,116,105,99,32,99,118,58,58,77,97,116,69,120,112,114,32,99,118,58,58,77,97,116,58,58,101,121,101,40,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,115,116,97,116,105,99,32,99,118,58,58,77,97,116,69,120,112,114,32,99,118,58,58,77,97,116,58,58,101,121,101,40,83,105,122,101,44,32,105,110,116,41,0,78,50,99,118,50,53,68,117,109,109,121,66,117,102,102,101,114,80,111,111,108,67,111,110,116,114,111,108,108,101,114,69,0,78,50,99,118,50,48,66,117,102,102,101,114,80,111,111,108,67,111,110,116,114,111,108,108,101,114,69,0,115,122,91,105,93,32,60,61,32,40,115,105,122,101,95,116,41,48,120,55,102,102,102,102,102,102,102,0,99,111,112,121,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,114,105,120,46,99,112,112,0,117,45,62,117,114,101,102,99,111,117,110,116,32,61,61,32,48,0,100,101,97,108,108,111,99,97,116,101,0,117,45,62,114,101,102,99,111,117,110,116,32,61,61,32,48,0,116,111,116,97,108,32,60,61,32,115,116,101,112,91,105,93,0,97,108,108,111,99,97,116,101,0,78,50,99,118,49,53,83,116,100,77,97,116,65,108,108,111,99,97,116,111,114,69,0,95,97,114,114,97,121,115,32,38,38,32,40,95,112,116,114,115,32,124,124,32,95,112,108,97,110,101,115,41,0,110,97,114,114,97,121,115,32,60,61,32,49,48,48,48,0,97,114,114,97,121,115,91,105,93,32,33,61,32,48,0,65,46,115,105,122,101,32,61,61,32,97,114,114,97,121,115,91,105,48,93,45,62,115,105,122,101,0,65,46,115,116,101,112,91,100,45,49,93,32,61,61,32,65,46,101,108,101,109,83,105,122,101,40,41,0,83,116,101,112,32,109,117,115,116,32,98,101,32,97,32,109,117,108,116,105,112,108,101,32,111,102,32,101,115,122,49,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,65,108,108,111,99,97,116,111,114,58,58,99,111,112,121,40,99,118,58,58,85,77,97,116,68,97,116,97,32,42,44,32,99,118,58,58,85,77,97,116,68,97,116,97,32,42,44,32,105,110,116,44,32,99,111,110,115,116,32,115,105,122,101,95,116,32,42,44,32,99,111,110,115,116,32,115,105,122,101,95,116,32,42,44,32,99,111,110,115,116,32,115,105,122,101,95,116,32,42,44,32,99,111,110,115,116,32,115,105,122,101,95,116,32,42,44,32,99,111,110,115,116,32,115,105,122,101,95,116,32,42,44,32,98,111,111,108,41,32,99,111,110,115,116,0,117,112,108,111,97,100,0,100,111,119,110,108,111,97,100,0,78,50,99,118,49,50,77,97,116,65,108,108,111,99,97,116,111,114,69,0,100,105,109,115,32,60,61,32,50,0,100,105,97,103,0,40,105,110,116,41,110,101,108,101,109,115,32,62,61,32,48,0,114,101,115,101,114,118,101,0,67,79,73,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,116,104,101,32,102,117,110,99,116,105,111,110,0,99,118,97,114,114,84,111,77,97,116,0,105,109,103,45,62,100,97,116,97,79,114,100,101,114,32,61,61,32,48,0,105,112,108,73,109,97,103,101,84,111,77,97,116,0,105,109,103,45,62,100,97,116,97,79,114,100,101,114,32,61,61,32,48,32,124,124,32,105,109,103,45,62,114,111,105,45,62,99,111,105,32,33,61,32,48,0,116,111,116,97,108,32,62,32,48,32,38,38,32,40,40,40,40,40,115,101,113,45,62,102,108,97,103,115,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,60,60,32,40,40,40,40,115,105,122,101,111,102,40,115,105,122,101,95,116,41,47,52,43,49,41,42,49,54,51,56,52,124,48,120,51,97,53,48,41,32,62,62,32,40,40,115,101,113,45,62,102,108,97,103,115,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,42,50,41,32,38,32,51,41,41,32,61,61,32,101,115,122,0,85,110,107,110,111,119,110,32,97,114,114,97,121,32,116,121,112,101,0,100,105,109,115,32,60,61,32,50,32,38,38,32,115,116,101,112,91,48,93,32,62,32,48,0,108,111,99,97,116,101,82,79,73,0,97,100,106,117,115,116,82,79,73,0,105,32,60,32,48,0,103,101,116,77,97,116,95,0,48,32,60,61,32,105,32,38,38,32,105,32,60,32,40,105,110,116,41,118,118,46,115,105,122,101,40,41,0,48,32,60,61,32,105,32,38,38,32,105,32,60,32,40,105,110,116,41,118,46,115,105,122,101,40,41,0,48,32,60,61,32,105,32,38,38,32,105,32,60,32,115,122,46,104,101,105,103,104,116,0,89,111,117,32,115,104,111,117,108,100,32,101,120,112,108,105,99,105,116,108,121,32,99,97,108,108,32,109,97,112,72,111,115,116,47,117,110,109,97,112,72,111,115,116,32,109,101,116,104,111,100,115,32,102,111,114,32,111,103,108,58,58,66,117,102,102,101,114,32,111,98,106,101,99,116,0,89,111,117,32,115,104,111,117,108,100,32,101,120,112,108,105,99,105,116,108,121,32,99,97,108,108,32,100,111,119,110,108,111,97,100,32,109,101,116,104,111,100,32,102,111,114,32,99,117,100,97,58,58,71,112,117,77,97,116,32,111,98,106,101,99,116,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,97,114,114,97,121,32,116,121,112,101,0,40,102,108,97,103,115,32,38,32,70,73,88,69,68,95,84,89,80,69,41,32,33,61,32,48,0,105,32,60,32,40,105,110,116,41,118,118,46,115,105,122,101,40,41,0,105,32,60,32,115,122,46,104,101,105,103,104,116,0,33,102,105,120,101,100,84,121,112,101,40,41,32,38,38,32,33,102,105,120,101,100,83,105,122,101,40,41,0,40,40,109,116,121,112,101,41,32,38,32,40,40,49,32,60,60,32,51,41,42,53,49,50,32,45,32,49,41,41,32,61,61,32,109,46,116,121,112,101,40,41,0,109,46,100,105,109,115,32,61,61,32,100,0,109,46,115,105,122,101,91,106,93,32,61,61,32,115,105,122,101,115,91,106,93,0,109,116,121,112,101,32,61,61,32,116,121,112,101,48,32,124,124,32,40,40,40,40,40,109,116,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,61,61,32,49,32,38,38,32,40,40,49,32,60,60,32,116,121,112,101,48,41,32,38,32,102,105,120,101,100,68,101,112,116,104,77,97,115,107,41,32,33,61,32,48,41,0,100,32,61,61,32,50,32,38,38,32,40,40,115,105,122,101,115,91,48,93,32,61,61,32,115,122,46,104,101,105,103,104,116,32,38,38,32,115,105,122,101,115,91,49,93,32,61,61,32,115,122,46,119,105,100,116,104,41,32,124,124,32,40,97,108,108,111,119,84,114,97,110,115,112,111,115,101,100,32,38,38,32,115,105,122,101,115,91,48,93,32,61,61,32,115,122,46,119,105,100,116,104,32,38,38,32,115,105,122,101,115,91,49,93,32,61,61,32,115,122,46,104,101,105,103,104,116,41,41,0,100,32,61,61,32,50,32,38,38,32,115,122,46,97,114,101,97,40,41,32,61,61,32,115,105,122,101,115,91,48,93,42,115,105,122,101,115,91,49,93,0,100,32,61,61,32,50,32,38,38,32,40,115,105,122,101,115,91,48,93,32,61,61,32,49,32,124,124,32,115,105,122,101,115,91,49,93,32,61,61,32,49,32,124,124,32,115,105,122,101,115,91,48,93,42,115,105,122,101,115,91,49,93,32,61,61,32,48,41],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+163852);allocate([33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,108,101,110,32,61,61,32,118,118,46,115,105,122,101,40,41,0,109,116,121,112,101,32,61,61,32,116,121,112,101,48,32,124,124,32,40,40,40,40,40,109,116,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,61,61,32,40,40,40,40,116,121,112,101,48,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,38,38,32,40,40,49,32,60,60,32,116,121,112,101,48,41,32,38,32,102,105,120,101,100,68,101,112,116,104,77,97,115,107,41,32,33,61,32,48,41,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,108,101,110,32,61,61,32,40,40,115,116,100,58,58,118,101,99,116,111,114,60,117,99,104,97,114,62,42,41,118,41,45,62,115,105,122,101,40,41,32,47,32,101,115,122,0,86,101,99,116,111,114,115,32,119,105,116,104,32,101,108,101,109,101,110,116,32,115,105,122,101,32,37,100,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,46,32,80,108,101,97,115,101,44,32,109,111,100,105,102,121,32,79,117,116,112,117,116,65,114,114,97,121,58,58,99,114,101,97,116,101,40,41,10,0,99,114,101,97,116,101,40,41,32,99,97,108,108,101,100,32,102,111,114,32,116,104,101,32,109,105,115,115,105,110,103,32,111,117,116,112,117,116,32,97,114,114,97,121,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,108,101,110,32,61,61,32,108,101,110,48,0,118,91,106,93,46,101,109,112,116,121,40,41,0,105,32,60,32,40,105,110,116,41,118,46,115,105,122,101,40,41,0,108,101,110,32,61,61,32,108,101,110,48,0,114,101,115,104,97,112,101,0,95,99,110,32,62,61,32,48,32,38,38,32,95,110,101,119,110,100,105,109,115,32,62,32,48,32,38,38,32,95,110,101,119,110,100,105,109,115,32,60,61,32,51,50,32,38,38,32,95,110,101,119,115,122,0,95,99,110,32,60,61,32,53,49,50,0,95,110,101,119,115,122,91,105,93,32,62,61,32,48,0,67,111,112,121,32,100,105,109,101,110,115,105,111,110,32,40,119,104,105,99,104,32,104,97,115,32,122,101,114,111,32,115,105,122,101,41,32,105,115,32,110,111,116,32,112,114,101,115,101,110,116,32,105,110,32,115,111,117,114,99,101,32,109,97,116,114,105,120,0,82,101,113,117,101,115,116,101,100,32,97,110,100,32,115,111,117,114,99,101,32,109,97,116,114,105,99,101,115,32,104,97,118,101,32,100,105,102,102,101,114,101,110,116,32,99,111,117,110,116,32,111,102,32,101,108,101,109,101,110,116,115,0,82,101,115,104,97,112,105,110,103,32,111,102,32,110,45,100,105,109,101,110,115,105,111,110,97,108,32,110,111,110,45,99,111,110,116,105,110,117,111,117,115,32,109,97,116,114,105,99,101,115,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,121,101,116,0,95,115,114,99,46,100,105,109,115,40,41,32,60,61,32,50,32,38,38,32,101,115,122,32,60,61,32,51,50,0,116,114,97,110,115,112,111,115,101,0,115,114,99,46,115,105,122,101,40,41,32,61,61,32,100,115,116,46,115,105,122,101,40,41,32,38,38,32,40,115,114,99,46,99,111,108,115,32,61,61,32,49,32,124,124,32,115,114,99,46,114,111,119,115,32,61,61,32,49,41,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,46,111,112,101,114,97,116,111,114,40,41,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,77,97,116,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,85,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,46,111,112,101,114,97,116,111,114,40,41,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,85,77,97,116,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,71,112,117,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,71,112,117,77,97,116,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,111,103,108,58,58,66,117,102,102,101,114,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,111,103,108,58,58,66,117,102,102,101,114,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,72,111,115,116,77,101,109,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,72,111,115,116,77,101,109,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,0,114,101,108,101,97,115,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,46,111,112,101,114,97,116,111,114,40,41,40,41,32,61,61,32,95,115,122,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,85,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,46,111,112,101,114,97,116,111,114,40,41,40,41,32,61,61,32,95,115,122,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,71,112,117,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,95,115,122,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,111,103,108,58,58,66,117,102,102,101,114,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,95,115,122,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,72,111,115,116,77,101,109,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,95,115,122,0,100,105,109,115,0,118,111,105,100,32,99,118,58,58,116,114,97,110,115,112,111,115,101,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,99,110,32,60,61,32,52,0,115,99,97,108,97,114,84,111,82,97,119,68,97,116,97,0,118,111,105,100,32,99,118,58,58,115,99,97,108,97,114,84,111,82,97,119,68,97,116,97,40,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,118,111,105,100,32,42,44,32,105,110,116,44,32,105,110,116,41,0,103,101,116,77,97,116,86,101,99,116,111,114,0,103,101,116,85,77,97,116,86,101,99,116,111,114,0,116,111,116,97,108,0,101,109,112,116,121,0,40,115,105,122,101,95,116,41,105,32,60,32,118,118,46,115,105,122,101,40,41,0,105,115,67,111,110,116,105,110,117,111,117,115,0,105,32,62,32,48,32,38,38,32,105,32,60,32,115,122,46,104,101,105,103,104,116,0,103,101,116,77,97,116,82,101,102,0,107,32,61,61,32,83,84,68,95,86,69,67,84,79,82,95,77,65,84,32,124,124,32,107,32,61,61,32,83,84,68,95,65,82,82,65,89,95,77,65,84,0,99,108,101,97,114,0,99,104,101,99,107,83,99,97,108,97,114,40,118,97,108,117,101,44,32,116,121,112,101,40,41,44,32,97,114,114,46,107,105,110,100,40,41,44,32,95,73,110,112,117,116,65,114,114,97,121,58,58,67,85,68,65,95,71,80,85,95,77,65,84,41,0,115,101,116,84,111,0,115,114,99,91,105,93,46,100,105,109,115,32,60,61,32,50,32,38,38,32,115,114,99,91,105,93,46,114,111,119,115,32,61,61,32,115,114,99,91,48,93,46,114,111,119,115,32,38,38,32,115,114,99,91,105,93,46,116,121,112,101,40,41,32,61,61,32,115,114,99,91,48,93,46,116,121,112,101,40,41,0,104,99,111,110,99,97,116,0,118,111,105,100,32,99,118,58,58,104,99,111,110,99,97,116,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,42,44,32,115,105,122,101,95,116,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,104,99,111,110,99,97,116,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,115,114,99,91,105,93,46,100,105,109,115,32,60,61,32,50,32,38,38,32,115,114,99,91,105,93,46,99,111,108,115,32,61,61,32,115,114,99,91,48,93,46,99,111,108,115,32,38,38,32,115,114,99,91,105,93,46,116,121,112,101,40,41,32,61,61,32,115,114,99,91,48,93,46,116,121,112,101,40,41,0,118,99,111,110,99,97,116,0,118,111,105,100,32,99,118,58,58,118,99,111,110,99,97,116,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,42,44,32,115,105,122,101,95,116,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,118,99,111,110,99,97,116,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,95,109,46,100,105,109,115,40,41,32,60,61,32,50,0,115,101,116,73,100,101,110,116,105,116,121,0,118,111,105,100,32,99,118,58,58,115,101,116,73,100,101,110,116,105,116,121,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,41,0,116,114,97,99,101,0,99,118,58,58,83,99,97,108,97,114,32,99,118,58,58,116,114,97,99,101,40,73,110,112,117,116,65,114,114,97,121,41,0,109,46,100,105,109,115,32,60,61,32,50,32,38,38,32,109,46,114,111,119,115,32,61,61,32,109,46,99,111,108,115,0,99,111,109,112,108,101,116,101,83,121,109,109,0,118,111,105,100,32,99,118,58,58,99,111,109,112,108,101,116,101,83,121,109,109,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,98,111,111,108,41,0,95,115,114,99,46,100,105,109,115,40,41,32,60,61,32,50,0,114,101,100,117,99,101,0,111,112,32,61,61,32,48,32,124,124,32,111,112,32,61,61,32,50,32,124,124,32,111,112,32,61,61,32,51,32,124,124,32,111,112,32,61,61,32,49,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,105,110,112,117,116,32,97,110,100,32,111,117,116,112,117,116,32,97,114,114,97,121,32,102,111,114,109,97,116,115,0,118,111,105,100,32,99,118,58,58,114,101,100,117,99,101,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,105,110,116,32,99,118,58,58,104,97,108,58,58,76,85,51,50,102,40,102,108,111,97,116,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,102,108,111,97,116,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,41,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,114,105,120,95,100,101,99,111,109,112,46,99,112,112,0,105,110,116,32,99,118,58,58,104,97,108,58,58,76,85,54,52,102,40,100,111,117,98,108,101,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,100,111,117,98,108,101,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,41,0,98,111,111,108,32,99,118,58,58,104,97,108,58,58,67,104,111,108,101,115,107,121,51,50,102,40,102,108,111,97,116,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,102,108,111,97,116,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,41,0,98,111,111,108,32,99,118,58,58,104,97,108,58,58,67,104,111,108,101,115,107,121,54,52,102,40,100,111,117,98,108,101,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,100,111,117,98,108,101,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,41,0,105,110,116,32,99,118,58,58,104,97,108,58,58,81,82,51,50,102,40,102,108,111,97,116,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,102,108,111,97,116,32,42,44,32,115,105,122,101,95,116,44,32,102,108,111,97,116,32,42,41,0,105,110,116,32,99,118,58,58,104,97,108,58,58,81,82,54,52,102,40,100,111,117,98,108,101,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,32,42,44,32,115,105,122,101,95,116,44,32,100,111,117,98,108,101,32,42,41,0,78,83,116,51,95,95,50,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,79,80,69,78,67,86,95,79,80,69,78,67,76,95,70,79,82,67,69,0,84,104,101,32,108,105,98,114,97,114,121,32,105,115,32,99,111,109,112,105,108,101,100,32,119,105,116,104,111,117,116,32,79,112,101,110,71,76,32,115,117,112,112,111,114,116,0,116,104,114,111,119,95,110,111,95,111,103,108,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,111,112,101,110,103,108,46,99,112,112,0,78,50,99,118,49,54,80,97,114,97,108,108,101,108,76,111,111,112,66,111,100,121,69,0,78,85,76,76,32,100,111,117,98,108,101,32,112,111,105,110,116,101,114,32,116,111,32,102,105,108,101,32,115,116,111,114,97,103,101,0,105,99,118,67,108,111,115,101,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,112,101,114,115,105,115,116,101,110,99,101,46,99,112,112,0,60,47,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,10,0,125,10,0,84,104,101,32,115,116,111,114,97,103,101,32,105,115,32,110,111,116,32,111,112,101,110,101,100,0,105,99,118,80,117,116,115,0,73,110,118,97,108,105,100,32,112,111,105,110,116,101,114,32,116,111,32,102,105,108,101,32,115,116,111,114,97,103,101,0,99,118,69,110,100,87,114,105,116,101,83,116,114,117,99,116,0,84,104,101,32,102,105,108,101,32,115,116,111,114,97,103,101,32,105,115,32,111,112,101,110,101,100,32,102,111,114,32,114,101,97,100,105,110,103,0,85,110,101,120,112,101,99,116,101,100,32,101,114,114,111,114,44,32,117,110,97,98,108,101,32,116,111,32,100,101,116,101,114,109,105,110,101,32,116,104,101,32,66,97,115,101,54,52,32,115,116,97,116,101,46,0,115,119,105,116,99,104,95,116,111,95,66,97,115,101,54,52,95,115,116,97,116,101,0,85,110,101,120,112,101,99,116,101,100,32,101,114,114,111,114,44,32,117,110,97,98,108,101,32,116,111,32,115,119,105,116,99,104,32,116,111,32,116,104,105,115,32,115,116,97,116,101,46,0,34,0,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,48,49,50,51,52,53,54,55,56,57,43,47,0,66,97,115,101,54,52,87,114,105,116,101,114,0,66,97,115,101,54,52,67,111,110,116,101,120,116,69,109,105,116,116,101,114,0,34,36,98,97,115,101,54,52,36,0,98,105,110,97,114,121,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,49,51,67,118,70,105,108,101,83,116,111,114,97,103,101,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,98,97,115,101,54,52,0,78,85,76,76,32,111,114,32,101,109,112,116,121,32,102,105,108,101,110,97,109,101,0,78,85,76,76,32,111,114,32,101,109,112,116,121,32,98,117,102,102,101,114,0,99,118,79,112,101,110,70,105,108,101,83,116,111,114,97,103,101,0,67,86,95,83,84,79,82,65,71,69,95,65,80,80,69,78,68,32,97,110,100,32,67,86,95,83,84,79,82,65,71,69,95,77,69,77,79,82,89,32,97,114,101,32,110,111,116,32,99,117,114,114,101,110,116,108,121,32,99,111,109,112,97,116,105,98,108,101,0,65,112,112,101,110,100,105,110,103,32,100,97,116,97,32,116,111,32,99,111,109,112,114,101,115,115,101,100,32,102,105,108,101,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,97,43,116,0,119,116,0,114,116,0,85,84,70,45,49,54,0,117,116,102,45,49,54,0,85,116,102,45,49,54,0,85,84,70,45,49,54,32,88,77,76,32,101,110,99,111,100,105,110,103,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,33,32,85,115,101,32,56,45,98,105,116,32,101,110,99,111,100,105,110,103,10,0,115,116,114,108,101,110,40,101,110,99,111,100,105,110,103,41,32,60,32,49,48,48,48,0,60,63,120,109,108,32,118,101,114,115,105,111,110,61,34,49,46,48,34,32,101,110,99,111,100,105,110,103,61,34,37,115,34,63,62,10,0,60,63,120,109,108,32,118,101,114,115,105,111,110,61,34,49,46,48,34,63,62,10,0,60,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,10,0,60,47,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,60,47,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,32,105,110,32,116,104,101,32,101,110,100,32,111,102,32,102,105,108,101,46,10,0,114,43,116,0,32,60,33,45,45,32,114,101,115,117,109,101,100,32,45,45,62,0,37,89,65,77,76,58,49,46,48,10,45,45,45,10,0,46,46,46,10,45,45,45,10,0,123,10,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,39,125,39,32,105,110,32,116,104,101,32,101,110,100,32,111,102,32,102,105,108,101,46,10,0,37,89,65,77,76,0,60,63,120,109,108,0,73,110,112,117,116,32,102,105,108,101,32,105,115,32,101,109,112,116,121,0,85,110,115,117,112,112,111,114,116,101,100,32,102,105,108,101,32,115,116,111,114,97,103,101,32,102,111,114,109,97,116,0,37,115,40,37,100,41,58,32,37,115,0,86,97,108,105,100,32,88,77,76,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,39,60,63,120,109,108,32,46,46,46,63,62,39,0,105,99,118,88,77,76,80,97,114,115,101,0,111,112,101,110,99,118,95,115,116,111,114,97,103,101,0,60,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,32,116,97,103,32,105,115,32,109,105,115,115,105,110,103,0,60,47,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,32,116,97,103,32,105,115,32,109,105,115,115,105,110,103,0,45,45,45,0,37,89,65,77,76,58,49,46,0,37,89,65,77,76,32,49,46,0,85,110,115,117,112,112,111,114,116,101,100,32,89,65,77,76,32,118,101,114,115,105,111,110,32,40,105,116,32,109,117,115,116,32,98,101,32,49,46,120,41,0,105,99,118,89,77,76,80,97,114,115,101,0,73,110,118,97,108,105,100,32,111,114,32,117,110,115,117,112,112,111,114,116,101,100,32,115,121,110,116,97,120,0,84,104,101,32,89,65,77,76,32,115,116,114,101,97,109,115,32,109,117,115,116,32,115,116,97,114,116,32,119,105,116,104,32,39,45,45,45,39,44,32,101,120,99,101,112,116,32,116,104,101,32,102,105,114,115,116,32,111,110,101,0,79,110,108,121,32,99,111,108,108,101,99,116,105,111,110,115,32,97,115,32,89,65,77,76,32,115,116,114,101,97,109,115,32,97,114,101,32,115,117,112,112,111,114,116,101,100,32,98,121,32,116,104,105,115,32,112,97,114,115,101,114,0,108,101,102,116,45,98,114,97,99,101,32,111,102,32,116,111,112,32,108,101,118,101,108,32,105,115,32,109,105,115,115,105,110,103,0,105,99,118,74,83,79,78,80,97,114,115,101,0,85,110,101,120,112,101,99,116,101,100,32,69,110,100,45,79,102,45,70,105,108,101,0,112,116,114,32,105,115,32,78,85,76,76,0,105,99,118,74,83,79,78,80,97,114,115,101,83,101,113,0,39,91,39,32,45,32,108,101,102,116,45,98,114,97,99,101,32,111,102,32,115,101,113,32,105,115,32,109,105,115,115,105,110,103,0,85,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,39,93,39,32,45,32,114,105,103,104,116,45,98,114,97,99,101,32,111,102,32,115,101,113,32,105,115,32,109,105,115,115,105,110,103,0,105,99,118,74,83,79,78,80,97,114,115,101,86,97,108,117,101,0,36,98,97,115,101,54,52,36,0,39,34,39,32,45,32,114,105,103,104,116,45,113,117,111,116,101,32,111,102,32,115,116,114,105,110,103,32,105,115,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,62,0,0,0,63,52,53,54,55,56,57,58,59,60,61,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,0,0,0,0,0,0,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,0,0,0,0,73,110,118,97,108,105,100,32,96,100,116,96,32,105,110,32,66,97,115,101,54,52,32,104,101,97,100,101,114,0,73,110,118,97,108,105,100,32,66,97,115,101,54,52,32,100,97,116,97,46,0,66,121,116,101,32,115,105,122,101,32,110,111,116,32,109,97,116,99,104,32,101,108,101,109,101,109,116,32,115,105,122,101,0,85,110,114,101,99,111,103,110,105,122,101,100,32,66,97,115,101,54,52,32,104,101,97,100,101,114,0,39,92,117,88,88,88,88,39,32,99,117,114,114,101,110,116,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,73,110,118,97,108,105,100,32,101,115,99,97,112,101,32,99,104,97,114,97,99,116,101,114,0,73,110,118,97,108,105,100,32,110,117,109,101,114,105,99,32,118,97,108,117,101,32,40,105,110,99,111,110,115,105,115,116,101,110,116,32,101,120,112,108,105,99,105,116,32,116,121,112,101,32,115,112,101,99,105,102,105,99,97,116,105,111,110,63,41,0,110,117,108,108,0,86,97,108,117,101,32,39,110,117,108,108,39,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,116,104,105,115,32,112,97,114,115,101,114,0,85,110,114,101,99,111,103,110,105,122,101,100,32,118,97,108,117,101,0,66,97,100,32,102,111,114,109,97,116,32,111,102,32,102,108,111,97,116,105,110,103,45,112,111,105,110,116,32,99,111,110,115,116,97,110,116,0,105,99,118,80,114,111,99,101,115,115,83,112,101,99,105,97,108,68,111,117,98,108,101,0,115,114,99,0,66,105,110,97,114,121,84,111,67,118,83,101,113,67,111,110,118,101,114,116,111,114,0,109,97,107,101,95,102,117,110,99,115,0,33,34,116,121,112,101,32,110,111,116,32,115,117,112,112,111,114,116,34,0,33,34,116,121,112,101,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,34,0,105,115,115,46,101,111,102,40,41,0,98,105,110,97,114,121,95,116,111,95,102,117,110,99,115,46,115,105,122,101,40,41,0,78,83,116,51,95,95,50,49,57,98,97,115,105,99,95,105,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,73,110,118,97,108,105,100,32,100,97,116,97,32,116,121,112,101,32,115,112,101,99,105,102,105,99,97,116,105,111,110,0,105,99,118,68,101,99,111,100,101,70,111,114,109,97,116,0,117,99,119,115,105,102,100,114,0,84,111,111,32,108,111,110,103,32,100,97,116,97,32,116,121,112,101,32,115,112,101,99,105,102,105,99,97,116,105,111,110,0,102,108,117,115,104,0,100,115,116,95,99,117,114,32,43,32,108,101,110,32,60,32,100,115,116,95,101,110,100,0,102,108,117,115,104,40,41,0,105,99,118,74,83,79,78,80,97,114,115,101,77,97,112,0,39,123,39,32,45,32,108,101,102,116,45,98,114,97,99,101,32,111,102,32,109,97,112,32,105,115,32,109,105,115,115,105,110,103,0,75,101,121,32,109,117,115,116,32,101,110,100,32,119,105,116,104,32,39,34,39,0,105,99,118,74,83,79,78,80,97,114,115,101,75,101,121,0,77,105,115,115,105,110,103,32,39,58,39,32,98,101,116,119,101,101,110,32,107,101,121,32,97,110,100,32,118,97,108,117,101,0,75,101,121,32,105,115,32,101,109,112,116,121,0,116,121,112,101,95,105,100,0,34,116,121,112,101,95,105,100,34,32,115,104,111,117,108,100,32,98,101,32,111,102,32,116,121,112,101,32,115,116,114,105,110,103,0,39,125,39,32,45,32,114,105,103,104,116,45,98,114,97,99,101,32,111,102,32,109,97,112,32,105,115,32,109,105,115,115,105,110,103,0,99,118,71,101,116,70,105,108,101,78,111,100,101,0,78,117,108,108,32,107,101,121,32,101,108,101,109,101,110,116,0,109,97,112,95,110,111,100,101,32,33,61,32,48,76,0,84,104,101,32,110,111,100,101,32,105,115,32,110,101,105,116,104,101,114,32,97,32,109,97,112,32,110,111,114,32,97,110,32,101,109,112,116,121,32,99,111,108,108,101,99,116,105,111,110,0,68,117,112,108,105,99,97,116,101,100,32,107,101,121,0,83,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,32,115,104,111,117,108,100,32,110,111,116,32,104,97,118,101,32,110,97,109,101,32,40,117,115,101,32,60,95,62,60,47,95,62,41,0,105,99,118,70,83,67,114,101,97,116,101,67,111,108,108,101,99,116,105,111,110,0,78,111,116,32,115,117,112,112,111,114,116,101,100,32,101,115,99,97,112,101,32,99,104,97,114,97,99,116,101,114,0,105,99,118,74,83,79,78,83,107,105,112,83,112,97,99,101,115,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,105,110,32,116,104,101,32,115,116,114,101,97,109,0,60,116,97,103,58,121,97,109,108,46,111,114,103,44,50,48,48,50,58,0,69,109,112,116,121,32,116,121,112,101,32,110,97,109,101,0,105,99,118,89,77,76,80,97,114,115,101,86,97,108,117,101,0,115,116,114,0,115,101,113,0,109,97,112,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,0,84,111,111,32,108,111,110,103,32,115,116,114,105,110,103,32,108,105,116,101,114,97,108,0,84,104,101,32,119,114,111,110,103,32,99,108,111,115,105,110,103,32,98,114,97,99,107,101,116,0,77,105,115,115,105,110,103,32,44,32,98,101,116,119,101,101,110,32,116,104,101,32,101,108,101,109,101,110,116,115,0,67,111,109,112,108,101,120,32,107,101,121,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,77,117,108,116,105,45,108,105,110,101,32,116,101,120,116,32,108,105,116,101,114,97,108,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,66,108,111,99,107,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,115,32,109,117,115,116,32,98,101,32,112,114,101,99,101,100,101,100,32,119,105,116,104,32,39,45,39,0,73,110,99,111,114,114,101,99,116,32,105,110,100,101,110,116,97,116,105,111,110,0,75,101,121,32,109,97,121,32,110,111,116,32,115,116,97,114,116,32,119,105,116,104,32,39,45,39,0,105,99,118,89,77,76,80,97,114,115,101,75,101,121,0,77,105,115,115,105,110,103,32,39,58,39,0,65,110,32,101,109,112,116,121,32,107,101,121,0,85,110,101,120,112,101,99,116,101,100,32,101,110,100,32,111,102,32,108,105,110,101,0,105,99,118,89,77,76,71,101,116,77,117,108,116,105,108,105,110,101,83,116,114,105,110,103,67,111,110,116,101,110,116,0,105,99,118,89,77,76,80,97,114,115,101,66,97,115,101,54,52,0,105,99,118,89,77,76,83,107,105,112,83,112,97,99,101,115,0,84,111,111,32,108,111,110,103,32,115,116,114,105,110,103,32,111,114,32,97,32,108,97,115,116,32,115,116,114,105,110,103,32,119,47,111,32,110,101,119,108,105,110,101,0,84,97,98,115,32,97,114,101,32,112,114,111,104,105,98,105,116,101,100,32,105,110,32,89,65,77,76,33,0,68,105,114,101,99,116,105,118,101,32,116,97,103,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,104,101,114,101,0,105,99,118,88,77,76,80,97,114,115,101,86,97,108,117,101,0,69,109,112,116,121,32,116,97,103,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,77,97,112,32,101,108,101,109,101,110,116,32,115,104,111,117,108,100,32,104,97,118,101,32,97,32,110,97,109,101,0,77,105,115,109,97,116,99,104,101,100,32,99,108,111,115,105,110,103,32,116,97,103,0,84,104,101,114,101,32,115,104,111,117,108,100,32,98,101,32,115,112,97,99,101,32,98,101,116,119,101,101,110,32,108,105,116,101,114,97,108,115,0,76,105,116,101,114,97,108,32,34,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,119,105,116,104,105,110,32,97,32,115,116,114,105,110,103,46,32,85,115,101,32,38,113,117,111,116,59,0,67,108,111,115,105,110,103,32,34,32,105,115,32,101,120,112,101,99,116,101,100,0,76,105,116,101,114,97,108,32,39,32,111,114,32,62,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,46,32,85,115,101,32,38,97,112,111,115,59,32,111,114,32,38,103,116,59,0,73,110,118,97,108,105,100,32,110,117,109,101,114,105,99,32,118,97,108,117,101,32,105,110,32,116,104,101,32,115,116,114,105,110,103,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,105,110,32,116,104,101,32,115,121,109,98,111,108,32,101,110,116,105,116,121,32,110,97,109,101,0,108,116,0,103,116,0,97,109,112,0,97,112,111,115,0,113,117,111,116,0,84,104,101,32,97,99,116,117,97,108,32,116,121,112,101,32,105,115,32,100,105,102,102,101,114,101,110,116,32,102,114,111,109,32,116,104,101,32,115,112,101,99,105,102,105,101,100,32,116,121,112,101,0,105,99,118,88,77,76,71,101,116,77,117,108,116,105,108,105,110,101,83,116,114,105,110,103,67,111,110,116,101,110,116,0,105,99,118,88,77,76,80,97,114,115,101,66,97,115,101,54,52,0,100,97,116,97,32,115,105,122,101,32,110,111,116,32,109,97,116,99,104,101,115,32,101,108,101,109,101,109,116,32,115,105,122,101,0,80,114,101,108,105,109,105,110,97,114,121,32,101,110,100,32,111,102,32,116,104,101,32,115,116,114,101,97,109,0,105,99,118,88,77,76,80,97,114,115,101,84,97,103,0,84,97,103,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,39,60,39,0,85,110,107,110,111,119,110,32,116,97,103,32,116,121,112,101,0,78,97,109,101,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,97,32,108,101,116,116,101,114,32,111,114,32,117,110,100,101,114,115,99,111,114,101,0,67,108,111,115,105,110,103,32,116,97,103,32,115,104,111,117,108,100,32,110,111,116,32,99,111,110,116,97,105,110,32,97,110,121,32,97,116,116,114,105,98,117,116,101,115,0,65,116,116,114,105,98,117,116,101,32,110,97,109,101,32,115,104,111,117,108,100,32,98,101,32,102,111,108,108,111,119,101,100,32,98,121,32,39,61,39,0,65,116,116,114,105,98,117,116,101,32,118,97,108,117,101,32,115,104,111,117,108,100,32,98,101,32,112,117,116,32,105,110,116,111,32,115,105,110,103,108,101,32,111,114,32,100,111,117,98,108,101,32,113,117,111,116,101,115,0,73,110,118,97,108,105,100,32,99,108,111,115,105,110,103,32,116,97,103,32,102,111,114,32,60,63,120,109,108,32,46,46,46,0,84,104,101,114,101,32,115,104,111,117,108,100,32,98,101,32,115,112,97,99,101,32,98,101,116,119,101,101,110,32,97,116,116,114,105,98,117,116,101,115,0,67,111,109,109,101,110,116,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,104,101,114,101,0,105,99,118,88,77,76,83,107,105,112,83,112,97,99,101,115,0,46,46,46,10,0,45,45,45,10,0,10,60,33,45,45,32,110,101,120,116,32,115,116,114,101,97,109,32,45,45,62,10,0,78,117,108,108,32,99,111,109,109,101,110,116,0,105,99,118,89,77,76,87,114,105,116,101,67,111,109,109,101,110,116,0,105,99,118,74,83,79,78,87,114,105,116,101,67,111,109,109,101,110,116,0,105,99,118,88,77,76,87,114,105,116,101,67,111,109,109,101,110,116,0,68,111,117,98,108,101,32,104,121,112,104,101,110,32,39,45,45,39,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,116,104,101,32,99,111,109,109,101,110,116,115,0,60,33,45,45,32,37,115,32,45,45,62,0,60,33,45,45,0,78,117,108,108,32,115,116,114,105,110,103,32,112,111,105,110,116,101,114,0,105,99,118,89,77,76,87,114,105,116,101,83,116,114,105,110,103,0,84,104,101,32,119,114,105,116,116,101,110,32,115,116,114,105,110,103,32,105,115,32,116,111,111,32,108,111,110,103,0,120,37,48,50,120,0,65,116,32,112,114,101,115,101,110,116,44,32,111,117,116,112,117,116,32,66,97,115,101,54,52,32,100,97,116,97,32,111,110,108,121,46,0,105,99,118,89,77,76,87,114,105,116,101,0,65,110,32,97,116,116,101,109,112,116,32,116,111,32,97,100,100,32,101,108,101,109,101,110,116,32,119,105,116,104,111,117,116,32,97,32,107,101,121,32,116,111,32,97,32,109,97,112,44,32,111,114,32,97,100,100,32,101,108,101,109,101,110,116,32,119,105,116,104,32,107,101,121,32,116,111,32,115,101,113,117,101,110,99,101,0,84,104,101,32,107,101,121,32,105,115,32,97,110,32,101,109,112,116,121,0,84,104,101,32,107,101,121,32,105,115,32,116,111,111,32,108,111,110,103,0,75,101,121,32,109,117,115,116,32,115,116,97,114,116,32,119,105,116,104,32,97,32,108,101,116,116,101,114,32,111,114,32,95,0,75,101,121,32,110,97,109,101,115,32,109,97,121,32,111,110,108,121,32,99,111,110,116,97,105,110,32,97,108,112,104,97,110,117,109,101,114,105,99,32,99,104,97,114,97,99,116,101,114,115,32,91,97,45,122,65,45,90,48,45,57,93,44,32,39,45,39,44,32,39,95,39,32,97,110,100,32,39,32,39,0,105,99,118,74,83,79,78,87,114,105,116,101,83,116,114,105,110,103,0,105,99,118,74,83,79,78,87,114,105,116,101,0,105,99,118,88,77,76,87,114,105,116,101,83,116,114,105,110,103,0,35,120,37,48,50,120,0,67,117,114,114,101,110,116,108,121,32,111,110,108,121,32,66,97,115,101,54,52,32,100,97,116,97,32,105,115,32,97,108,108,111,119,101,100,46,0,105,99,118,88,77,76,87,114,105,116,101,83,99,97,108,97,114,0,101,108,101,109,101,110,116,115,32,119,105,116,104,32,107,101,121,115,32,99,97,110,32,110,111,116,32,98,101,32,119,114,105,116,116,101,110,32,116,111,32,115,101,113,117,101,110,99,101,0,105,99,118,88,77,76,87,114,105,116,101,84,97,103,0,65,32,115,105,110,103,108,101,32,95,32,105,115,32,97,32,114,101,115,101,114,118,101,100,32,116,97,103,32,110,97,109,101,0,95,0,67,108,111,115,105,110,103,32,116,97,103,32,115,104,111,117,108,100,32,110,111,116,32,105,110,99,108,117,100,101,32,97,110,121,32,97,116,116,114,105,98,117,116,101,115,0,75,101,121,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,97,32,108,101,116,116,101,114,32,111,114,32,95,0,75,101,121,32,110,97,109,101,32,109,97,121,32,111,110,108,121,32,99,111,110,116,97,105,110,32,97,108,112,104,97,110,117,109,101,114,105,99,32,99,104,97,114,97,99,116,101,114,115,32,91,97,45,122,65,45,90,48,45,57,93,44,32,39,45,39,32,97,110,100,32,39,95,39,0,37,100,46,0,37,46,49,54,101,0,46,78,97,110,0,45,46,73,110,102,0,46,73,110,102,0,69,110,100,87,114,105,116,101,83,116,114,117,99,116,32,119,47,111,32,109,97,116,99,104,105,110,103,32,83,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,0,105,99,118,89,77,76,69,110,100,87,114,105,116,101,83,116,114,117,99,116,0,105,99,118,74,83,79,78,69,110,100,87,114,105,116,101,83,116,114,117,99,116,0,65,110,32,101,120,116,114,97,32,99,108,111,115,105,110,103,32,116,97,103,0,105,99,118,88,77,76,69,110,100,87,114,105,116,101,83,116,114,117,99,116,0,83,111,109,101,32,99,111,108,108,101,99,116,105,111,110,32,116,121,112,101,32,45,32,67,86,95,78,79,68,69,95,83,69,81,32,111,114,32,67,86,95,78,79,68,69,95,77,65,80,44,32,109,117,115,116,32,98,101,32,115,112,101,99,105,102,105,101,100,0,105,99,118,89,77,76,83,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,0,33,33,98,105,110,97,114,121,32,124,0,33,33,37,115,32,37,99,0,33,33,37,115,0,105,99,118,74,83,79,78,83,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,0,83,111,109,101,32,99,111,108,108,101,99,116,105,111,110,32,116,121,112,101,58,32,67,86,95,78,79,68,69,95,83,69,81,32,111,114,32,67,86,95,78,79,68,69,95,77,65,80,32,109,117,115,116,32,98,101,32,115,112,101,99,105,102,105,101,100,0,105,99,118,88,77,76,83,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,0,105,99,118,71,101,116,115,0,99,118,82,101,108,101,97,115,101,70,105,108,101,83,116,111,114,97,103,101,0,118,105,114,116,117,97,108,32,98,111,111,108,32,99,118,58,58,70,105,108,101,83,116,111,114,97,103,101,58,58,111,112,101,110,40,99,111,110,115,116,32,99,118,58,58,83,116,114,105,110,103,32,38,44,32,105,110,116,44,32,99,111,110,115,116,32,99,118,58,58,83,116,114,105,110,103,32,38,41,0,78,50,99,118,49,49,70,105,108,101,83,116,111,114,97,103,101,69,0,111,112,101,110,99,118,45,115,101,113,117,101,110,99,101,0,111,112,101,110,99,118,45,115,101,113,117,101,110,99,101,45,116,114,101,101,0,111,112,101,110,99,118,45,103,114,97,112,104,0,111,112,101,110,99,118,45,115,112,97,114,115,101,45,109,97,116,114,105,120,0,111,112,101,110,99,118,45,105,109,97,103,101,0,111,112,101,110,99,118,45,109,97,116,114,105,120,0,111,112,101,110,99,118,45,110,100,45,109,97,116,114,105,120,0,115,105,122,101,115,0,105,0,37,100,37,99,0,100,116,0,100,97,116,97,0,99,118,87,114,105,116,101,83,116,114,105,110,103,0,99,118,87,114,105,116,101,82,97,119,68,97,116,97,0,78,101,103,97,116,105,118,101,32,110,117,109,98,101,114,32,111,102,32,101,108,101,109,101,110,116,115,0,78,117,108,108,32,100,97,116,97,32,112,111,105,110,116,101,114,0,37,46,56,101,0,99,118,87,114,105,116,101,82,97,119,68,97,116,97,66,97,115,101,54,52,0,66,97,115,101,54,52,32,115,104,111,117,108,100,32,110,111,116,32,98,101,32,117,115,101,100,32,97,116,32,112,114,101,115,101,110,116,46,0,82,97,119,68,97,116,97,84,111,66,105,110,97,114,121,67,111,110,118,101,114,116,111,114,0,33,100,116,46,101,109,112,116,121,40,41,0,108,101,110,32,62,32,48,0,109,97,107,101,95,116,111,95,98,105,110,97,114,121,95,102,117,110,99,115,0,73,110,118,97,108,105,100,32,39,100,116,39,46,0,99,104,101,99,107,95,100,116,0,39,100,116,39,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,46,0,98,117,102,102,101,114,46,115,105,122,101,40,41,32,60,32,72,69,65,68,69,82,95,83,73,90,69,0,109,97,107,101,95,98,97,115,101,54,52,95,104,101,97,100,101,114,0,99,118,83,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,0,102,115,45,62,105,115,95,119,114,105,116,101,95,115,116,114,117,99,116,95,100,101,108,97,121,101,100,32,61,61,32,102,97,108,115,101,0,109,97,107,101,95,119,114,105,116,101,95,115,116,114,117,99,116,95,100,101,108,97,121,101,100,0,109,117,115,116,32,115,101,116,32,39,115,116,114,117,99,116,95,102,108,97,103,115,32,124,61,32,67,86,95,78,79,68,69,95,83,69,81,39,32,105,102,32,117,115,105,110,103,32,66,97,115,101,54,52,46,0,102,117,110,99,116,105,111,110,32,39,99,118,83,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,39,32,99,97,108,108,115,32,99,97,110,110,111,116,32,98,101,32,110,101,115,116,101,100,32,105,102,32,117,115,105,110,103,32,66,97,115,101,54,52,46,0,65,116,32,116,104],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+174092);allocate([101,32,101,110,100,32,111,102,32,116,104,101,32,111,117,116,112,117,116,32,66,97,115,101,54,52,44,32,96,99,118,69,110,100,87,114,105,116,101,83,116,114,117,99,116,96,32,105,115,32,110,101,101,100,101,100,46,0,83,111,109,101,32,111,102,32,101,115,115,101,110,116,105,97,108,32,109,97,116,114,105,120,32,97,116,116,114,105,98,117,116,101,115,32,97,114,101,32,97,98,115,101,110,116,0,105,99,118,82,101,97,100,77,97,116,78,68,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,116,104,101,32,109,97,116,114,105,120,32,100,105,109,101,110,115,105,111,110,97,108,105,116,121,0,84,104,101,32,109,97,116,114,105,120,32,100,97,116,97,32,105,115,32,110,111,116,32,102,111,117,110,100,32,105,110,32,102,105,108,101,32,115,116,111,114,97,103,101,0,84,104,101,32,109,97,116,114,105,120,32,115,105,122,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,111,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,111,114,101,100,32,101,108,101,109,101,110,116,115,0,84,111,111,32,99,111,109,112,108,101,120,32,102,111,114,109,97,116,32,102,111,114,32,116,104,101,32,109,97,116,114,105,120,0,105,99,118,68,101,99,111,100,101,83,105,109,112,108,101,70,111,114,109,97,116,0,78,117,108,108,32,112,111,105,110,116,101,114,115,32,116,111,32,115,111,117,114,99,101,32,102,105,108,101,32,110,111,100,101,32,111,114,32,100,101,115,116,105,110,97,116,105,111,110,32,97,114,114,97,121,0,99,118,82,101,97,100,82,97,119,68,97,116,97,0,99,118,82,101,97,100,82,97,119,68,97,116,97,83,108,105,99,101,0,78,117,108,108,32,112,111,105,110,116,101,114,32,116,111,32,114,101,97,100,101,114,32,111,114,32,100,101,115,116,105,110,97,116,105,111,110,32,97,114,114,97,121,0,84,104,101,32,114,101,97,100,101,100,32,115,101,113,117,101,110,99,101,32,105,115,32,97,32,115,99,97,108,97,114,44,32,116,104,117,115,32,108,101,110,32,109,117,115,116,32,98,101,32,49,0,84,104,101,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,32,105,115,32,110,111,116,32,97,32,110,117,109,101,114,105,99,97,108,32,115,99,97,108,97,114,0,84,104,101,32,115,101,113,117,101,110,99,101,32,115,108,105,99,101,32,100,111,101,115,32,110,111,116,32,102,105,116,32,97,110,32,105,110,116,101,103,101,114,32,110,117,109,98,101,114,32,111,102,32,114,101,99,111,114,100,115,0,99,118,83,116,97,114,116,82,101,97,100,82,97,119,68,97,116,97,0,78,117,108,108,32,112,111,105,110,116,101,114,32,116,111,32,115,111,117,114,99,101,32,102,105,108,101,32,110,111,100,101,32,111,114,32,114,101,97,100,101,114,0,84,104,101,32,102,105,108,101,32,110,111,100,101,32,115,104,111,117,108,100,32,98,101,32,97,32,110,117,109,101,114,105,99,97,108,32,115,99,97,108,97,114,32,111,114,32,97,32,115,101,113,117,101,110,99,101,0,99,118,71,101,116,70,105,108,101,78,111,100,101,66,121,78,97,109,101,0,78,117,108,108,32,101,108,101,109,101,110,116,32,110,97,109,101,0,114,111,119,115,0,99,111,108,115,0,99,118,87,114,105,116,101,73,110,116,0,105,99,118,82,101,97,100,77,97,116,0,73,109,97,103,101,115,32,119,105,116,104,32,112,108,97,110,97,114,32,100,97,116,97,32,108,97,121,111,117,116,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,105,99,118,87,114,105,116,101,73,109,97,103,101,0,116,111,112,45,108,101,102,116,0,98,111,116,116,111,109,45,108,101,102,116,0,111,114,105,103,105,110,0,112,108,97,110,97,114,0,105,110,116,101,114,108,101,97,118,101,100,0,108,97,121,111,117,116,0,114,111,105,0,120,0,121,0,99,111,105,0,83,111,109,101,32,111,102,32,101,115,115,101,110,116,105,97,108,32,105,109,97,103,101,32,97,116,116,114,105,98,117,116,101,115,32,97,114,101,32,97,98,115,101,110,116,0,105,99,118,82,101,97,100,73,109,97,103,101,0,79,110,108,121,32,105,110,116,101,114,108,101,97,118,101,100,32,105,109,97,103,101,115,32,99,97,110,32,98,101,32,114,101,97,100,0,84,104,101,32,105,109,97,103,101,32,100,97,116,97,32,105,115,32,110,111,116,32,102,111,117,110,100,32,105,110,32,102,105,108,101,32,115,116,111,114,97,103,101,0,105,99,118,82,101,97,100,83,112,97,114,115,101,77,97,116,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,112,97,114,115,101,32,109,97,116,114,105,120,32,100,105,109,101,110,115,105,111,110,97,108,105,116,121,0,83,112,97,114,115,101,32,109,97,116,114,105,120,32,100,97,116,97,32,105,115,32,99,111,114,114,117,112,116,101,100,0,111,114,105,101,110,116,101,100,0,102,108,97,103,115,0,118,101,114,116,101,120,95,99,111,117,110,116,0,118,101,114,116,101,120,95,100,116,0,101,100,103,101,95,99,111,117,110,116,0,101,100,103,101,95,100,116,0,50,105,102,37,115,0,118,101,114,116,105,99,101,115,0,101,100,103,101,115,0,104,101,97,100,101,114,95,100,116,0,84,104,101,32,115,105,122,101,32,111,102,32,104,101,97,100,101,114,32,99,97,108,99,117,108,97,116,101,100,32,102,114,111,109,32,34,104,101,97,100,101,114,95,100,116,34,32,105,115,32,103,114,101,97,116,101,114,32,116,104,97,110,32,104,101,97,100,101,114,95,115,105,122,101,0,105,99,118,87,114,105,116,101,72,101,97,100,101,114,68,97,116,97,0,99,111,108,111,114,0,37,117,105,0,37,117,117,0,104,101,97,100,101,114,95,117,115,101,114,95,100,97,116,97,0,84,104,101,32,115,105,122,101,32,111,102,32,101,108,101,109,101,110,116,32,99,97,108,99,117,108,97,116,101,100,32,102,114,111,109,32,34,100,116,34,32,97,110,100,32,116,104,101,32,101,108,101,109,95,115,105,122,101,32,100,111,32,110,111,116,32,109,97,116,99,104,0,105,99,118,71,101,116,70,111,114,109,97,116,0,83,105,122,101,32,111,102,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,32,40,101,108,101,109,95,115,105,122,101,41,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,32,119,105,116,104,32,115,101,113,45,62,102,108,97,103,115,0,83,111,109,101,32,111,102,32,101,115,115,101,110,116,105,97,108,32,103,114,97,112,104,32,97,116,116,114,105,98,117,116,101,115,32,97,114,101,32,97,98,115,101,110,116,0,105,99,118,82,101,97,100,71,114,97,112,104,0,84,104,101,32,115,101,113,117,101,110,99,101,32,102,108,97,103,115,32,97,114,101,32,105,110,118,97,108,105,100,0,79,110,101,32,111,102,32,34,104,101,97,100,101,114,95,100,116,34,32,97,110,100,32,34,104,101,97,100,101,114,95,117,115,101,114,95,100,97,116,97,34,32,105,115,32,116,104,101,114,101,44,32,119,104,105,108,101,32,116,104,101,32,111,116,104,101,114,32,105,115,32,110,111,116,0,71,114,97,112,104,32,101,100,103,101,115,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,50,32,105,110,116,101,103,101,114,115,32,97,110,100,32,97,32,102,108,111,97,116,0,37,100,102,37,115,0,78,111,32,101,100,103,101,115,32,100,97,116,97,0,78,111,32,118,101,114,116,105,99,101,115,32,100,97,116,97,0,83,111,109,101,32,111,102,32,115,116,111,114,101,100,32,118,101,114,116,101,120,32,105,110,100,105,99,101,115,32,97,114,101,32,111,117,116,32,111,102,32,114,97,110,103,101,0,68,117,112,108,105,99,97,116,101,100,32,101,100,103,101,32,104,97,115,32,111,99,99,117,114,101,100,0,78,85,76,76,32,100,111,117,98,108,101,32,112,111,105,110,116,101,114,0,105,99,118,82,101,108,101,97,115,101,71,114,97,112,104,0,115,101,113,117,101,110,99,101,115,0,111,112,101,110,99,118,45,115,101,113,117,101,110,99,101,45,116,114,101,101,32,105,110,115,116,97,110,99,101,32,115,104,111,117,108,100,32,99,111,110,116,97,105,110,32,97,32,102,105,101,108,100,32,34,115,101,113,117,101,110,99,101,115,34,32,116,104,97,116,32,115,104,111,117,108,100,32,98,101,32,97,32,115,101,113,117,101,110,99,101,0,105,99,118,82,101,97,100,83,101,113,84,114,101,101,0,108,101,118,101,108,0,65,108,108,32,116,104,101,32,115,101,113,117,101,110,99,101,32,116,114,101,101,32,110,111,100,101,115,32,115,104,111,117,108,100,32,99,111,110,116,97,105,110,32,34,108,101,118,101,108,34,32,102,105,101,108,100,0,99,118,82,101,97,100,0,84,104,101,32,110,111,100,101,32,100,111,101,115,32,110,111,116,32,114,101,112,114,101,115,101,110,116,32,97,32,117,115,101,114,32,111,98,106,101,99,116,32,40,117,110,107,110,111,119,110,32,116,121,112,101,63,41,0,73,110,118,97,108,105,100,32,116,121,112,101,32,105,110,102,111,0,99,118,82,101,103,105,115,116,101,114,84,121,112,101,0,83,111,109,101,32,111,102,32,114,101,113,117,105,114,101,100,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,115,32,40,105,115,95,105,110,115,116,97,110,99,101,44,32,114,101,108,101,97,115,101,44,32,114,101,97,100,32,111,114,32,119,114,105,116,101,41,32,97,114,101,32,78,85,76,76,0,84,121,112,101,32,110,97,109,101,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,97,32,108,101,116,116,101,114,32,111,114,32,95,0,84,121,112,101,32,110,97,109,101,32,115,104,111,117,108,100,32,99,111,110,116,97,105,110,32,111,110,108,121,32,108,101,116,116,101,114,115,44,32,100,105,103,105,116,115,44,32,45,32,97,110,100,32,95,0,114,101,99,117,114,115,105,118,101,0,32,104,111,108,101,0,32,99,117,114,118,101,0,32,117,110,116,121,112,101,100,0,99,111,117,110,116,0,83,111,109,101,32,111,102,32,101,115,115,101,110,116,105,97,108,32,115,101,113,117,101,110,99,101,32,97,116,116,114,105,98,117,116,101,115,32,97,114,101,32,97,98,115,101,110,116,0,105,99,118,82,101,97,100,83,101,113,0,99,117,114,118,101,0,99,108,111,115,101,100,0,104,111,108,101,0,117,110,116,121,112,101,100,0,79,110,108,121,32,111,110,101,32,111,102,32,34,104,101,97,100,101,114,95,117,115,101,114,95,100,97,116,97,34,44,32,34,114,101,99,116,34,32,97,110,100,32,34,111,114,105,103,105,110,34,32,116,97,103,115,32,109,97,121,32,111,99,99,117,114,0,84,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,111,114,101,100,32,101,108,101,109,101,110,116,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,111,32,34,99,111,117,110,116,34,0,105,99,118,82,101,108,101,97,115,101,83,101,113,0,46,103,122,0,73,110,118,97,108,105,100,32,102,105,108,101,110,97,109,101,0,103,101,116,68,101,102,97,117,108,116,79,98,106,101,99,116,78,97,109,101,0,99,118,71,101,116,82,111,111,116,70,105,108,101,78,111,100,101,0,99,118,87,114,105,116,101,82,101,97,108,0,99,118,87,114,105,116,101,67,111,109,109,101,110,116,0,99,118,82,101,108,101,97,115,101,0,85,110,107,110,111,119,110,32,111,98,106,101,99,116,32,116,121,112,101,0,114,101,108,101,97,115,101,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,78,85,76,76,0,99,118,87,114,105,116,101,0,78,117,108,108,32,112,111,105,110,116,101,114,32,116,111,32,116,104,101,32,119,114,105,116,116,101,110,32,111,98,106,101,99,116,0,85,110,107,110,111,119,110,32,111,98,106,101,99,116,0,84,104,101,32,111,98,106,101,99,116,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,119,114,105,116,101,32,102,117,110,99,116,105,111,110,0,110,111,100,101,32,33,61,32,48,76,0,99,118,76,111,97,100,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,116,104,101,47,97,110,32,111,98,106,101,99,116,32,105,110,32,102,105,108,101,32,115,116,111,114,97,103,101,0,78,85,76,76,32,109,101,109,111,114,121,32,115,116,111,114,97,103,101,32,105,115,32,112,97,115,115,101,100,32,45,32,116,104,101,32,108,111,97,100,101,100,32,100,121,110,97,109,105,99,32,115,116,114,117,99,116,117,114,101,32,99,97,110,32,110,111,116,32,98,101,32,115,116,111,114,101,100,0,69,120,116,114,97,32,99,108,111,115,105,110,103,32,39,37,99,39,0,84,104,101,32,99,108,111,115,105,110,103,32,39,37,99,39,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,111,112,101,110,105,110,103,32,39,37,99,39,0,73,110,99,111,114,114,101,99,116,32,101,108,101,109,101,110,116,32,110,97,109,101,32,37,115,0,73,110,118,97,108,105,100,32,102,115,46,115,116,97,116,101,0,108,101,110,32,37,32,101,108,101,109,83,105,122,101,32,61,61,32,48,0,119,114,105,116,101,82,97,119,0,101,108,101,109,95,115,105,122,101,32,62,32,48,0,114,101,97,100,82,97,119,0,95,112,97,114,97,109,49,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,40,95,112,97,114,97,109,49,46,114,111,119,115,32,61,61,32,49,32,124,124,32,95,112,97,114,97,109,49,46,99,111,108,115,32,61,61,32,49,41,32,38,38,32,40,95,112,97,114,97,109,49,46,114,111,119,115,32,43,32,95,112,97,114,97,109,49,46,99,111,108,115,32,45,32,49,32,61,61,32,99,110,32,124,124,32,95,112,97,114,97,109,49,46,114,111,119,115,32,43,32,95,112,97,114,97,109,49,46,99,111,108,115,32,45,32,49,32,61,61,32,49,32,124,124,32,40,95,112,97,114,97,109,49,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,52,41,32,38,38,32,95,112,97,114,97,109,49,46,116,121,112,101,40,41,32,61,61,32,54,32,38,38,32,99,110,32,60,61,32,52,41,41,0,102,105,108,108,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,114,97,110,100,46,99,112,112,0,95,112,97,114,97,109,50,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,40,40,40,95,112,97,114,97,109,50,46,114,111,119,115,32,61,61,32,49,32,124,124,32,95,112,97,114,97,109,50,46,99,111,108,115,32,61,61,32,49,41,32,38,38,32,40,95,112,97,114,97,109,50,46,114,111,119,115,32,43,32,95,112,97,114,97,109,50,46,99,111,108,115,32,45,32,49,32,61,61,32,99,110,32,124,124,32,95,112,97,114,97,109,50,46,114,111,119,115,32,43,32,95,112,97,114,97,109,50,46,99,111,108,115,32,45,32,49,32,61,61,32,49,32,124,124,32,40,95,112,97,114,97,109,49,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,52,41,32,38,38,32,95,112,97,114,97,109,49,46,116,121,112,101,40,41,32,61,61,32,54,32,38,38,32,99,110,32,60,61,32,52,41,41,41,32,124,124,32,40,95,112,97,114,97,109,50,46,114,111,119,115,32,61,61,32,99,110,32,38,38,32,95,112,97,114,97,109,50,46,99,111,108,115,32,61,61,32,99,110,32,38,38,32,100,105,115,116,116,121,112,101,32,61,61,32,78,79,82,77,65,76,41,41,0,115,99,97,108,101,70,117,110,99,32,33,61,32,48,0,85,110,107,110,111,119,110,32,100,105,115,116,114,105,98,117,116,105,111,110,32,116,121,112,101,0,118,111,105,100,32,99,118,58,58,114,97,110,100,117,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,114,97,110,100,110,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,0,1,1,2,1,2,2,3,1,2,2,3,2,3,3,4,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,4,5,5,6,5,6,6,7,5,6,6,7,6,7,7,8,99,110,32,60,61,32,52,32,38,38,32,102,117,110,99,32,33,61,32,48,0,115,117,109,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,115,116,97,116,46,99,112,112,0,99,118,58,58,83,99,97,108,97,114,32,99,118,58,58,115,117,109,40,73,110,112,117,116,65,114,114,97,121,41,0,99,111,117,110,116,78,111,110,90,101,114,111,0,105,110,116,32,99,118,58,58,99,111,117,110,116,78,111,110,90,101,114,111,40,73,110,112,117,116,65,114,114,97,121,41,0,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,48,0,109,101,97,110,0,99,118,58,58,83,99,97,108,97,114,32,99,118,58,58,109,101,97,110,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,109,101,97,110,83,116,100,68,101,118,0,100,115,116,46,116,121,112,101,40,41,32,61,61,32,54,32,38,38,32,100,115,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,40,100,115,116,46,99,111,108,115,32,61,61,32,49,32,124,124,32,100,115,116,46,114,111,119,115,32,61,61,32,49,41,32,38,38,32,100,99,110,32,62,61,32,99,110,0,118,111,105,100,32,99,118,58,58,109,101,97,110,83,116,100,68,101,118,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,40,99,110,32,61,61,32,49,32,38,38,32,40,95,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,95,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,48,41,41,32,124,124,32,40,99,110,32,62,32,49,32,38,38,32,95,109,97,115,107,46,101,109,112,116,121,40,41,32,38,38,32,33,109,105,110,73,100,120,32,38,38,32,33,109,97,120,73,100,120,41,0,109,105,110,77,97,120,73,100,120,0,118,111,105,100,32,99,118,58,58,109,105,110,77,97,120,73,100,120,40,73,110,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,32,42,44,32,105,110,116,32,42,44,32,73,110,112,117,116,65,114,114,97,121,41,0,95,105,109,103,46,100,105,109,115,40,41,32,60,61,32,50,0,109,105,110,77,97,120,76,111,99,0,118,111,105,100,32,99,118,58,58,109,105,110,77,97,120,76,111,99,40,73,110,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,80,111,105,110,116,32,42,44,32,80,111,105,110,116,32,42,44,32,73,110,112,117,116,65,114,114,97,121,41,0,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,73,78,70,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,49,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,50,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,50,83,81,82,32,124,124,32,40,40,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,72,65,77,77,73,78,71,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,72,65,77,77,73,78,71,50,41,32,38,38,32,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,48,41,0,110,111,114,109,0,0,1,1,1,1,2,2,2,1,2,2,2,1,2,2,2,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,100,111,117,98,108,101,32,99,118,58,58,110,111,114,109,40,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,73,110,112,117,116,65,114,114,97,121,41,0,95,115,114,99,49,46,115,97,109,101,83,105,122,101,40,95,115,114,99,50,41,32,38,38,32,95,115,114,99,49,46,116,121,112,101,40,41,32,61,61,32,95,115,114,99,50,46,116,121,112,101,40,41,0,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,73,78,70,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,49,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,50,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,50,83,81,82,32,124,124,32,40,40,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,72,65,77,77,73,78,71,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,72,65,77,77,73,78,71,50,41,32,38,38,32,115,114,99,49,46,116,121,112,101,40,41,32,61,61,32,48,41,0,100,111,117,98,108,101,32,99,118,58,58,110,111,114,109,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,73,110,112,117,116,65,114,114,97,121,41,0,116,121,112,101,32,61,61,32,115,114,99,50,46,116,121,112,101,40,41,32,38,38,32,115,114,99,49,46,99,111,108,115,32,61,61,32,115,114,99,50,46,99,111,108,115,32,38,38,32,40,116,121,112,101,32,61,61,32,53,32,124,124,32,116,121,112,101,32,61,61,32,48,41,0,98,97,116,99,104,68,105,115,116,97,110,99,101,0,95,110,105,100,120,46,110,101,101,100,101,100,40,41,32,61,61,32,40,75,32,62,32,48,41,0,40,116,121,112,101,32,61,61,32,48,32,38,38,32,100,116,121,112,101,32,61,61,32,52,41,32,124,124,32,100,116,121,112,101,32,61,61,32,53,0,75,32,61,61,32,49,32,38,38,32,117,112,100,97,116,101,32,61,61,32,48,32,38,38,32,109,97,115,107,46,101,109,112,116,121,40,41,0,84,104,101,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,116,121,112,101,61,37,100,44,32,100,116,121,112,101,61,37,100,32,97,110,100,32,110,111,114,109,84,121,112,101,61,37,100,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,78,50,99,118,49,54,66,97,116,99,104,68,105,115,116,73,110,118,111,107,101,114,69,0,118,111,105,100,32,99,118,58,58,98,97,116,99,104,68,105,115,116,97,110,99,101,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,98,111,111,108,41,0,105,110,116,32,99,118,58,58,104,97,108,58,58,110,111,114,109,72,97,109,109,105,110,103,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,105,110,116,41,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,115,116,97,116,46,100,105,115,112,97,116,99,104,46,99,112,112,0,105,110,116,32,99,118,58,58,104,97,108,58,58,110,111,114,109,72,97,109,109,105,110,103,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,105,110,116,41,0,78,50,99,118,57,69,120,99,101,112,116,105,111,110,69,0,107,101,121,95,32,61,61,32,45,49,0,126,84,76,83,68,97,116,97,67,111,110,116,97,105,110,101,114,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,115,121,115,116,101,109,46,99,112,112,0,115,116,97,116,117,115,0,101,114,114,111,114,0,85,110,107,110,111,119,110,32,37,115,32,99,111,100,101,32,37,100,0,79,112,101,110,71,76,32,65,80,73,32,99,97,108,108,0,78,111,32,79,112,101,110,71,76,32,115,117,112,112,111,114,116,0,71,112,117,32,65,80,73,32,99,97,108,108,0,78,111,32,67,85,68,65,32,115,117,112,112,111,114,116,0,65,115,115,101,114,116,105,111,110,32,102,97,105,108,101,100,0,77,101,109,111,114,121,32,98,108,111,99,107,32,104,97,115,32,98,101,101,110,32,99,111,114,114,117,112,116,101,100,0,84,104,101,32,102,117,110,99,116,105,111,110,47,102,101,97,116,117,114,101,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,80,97,114,115,105,110,103,32,101,114,114,111,114,0,66,97,100,32,116,121,112,101,32,111,102,32,109,97,115,107,32,97,114,103,117,109,101,110,116,0,66,97,100,32,112,97,114,97,109,101,116,101,114,32,111,102,32,116,121,112,101,32,67,118,80,111,105,110,116,0,66,97,100,32,102,108,97,103,32,40,112,97,114,97,109,101,116,101,114,32,111,114,32,115,116,114,117,99,116,117,114,101,32,102,105,101,108,100,41,0,66,97,100,32,110,117,109,98,101,114,32,111,102,32,99,104,97,110,110,101,108,115,0,73,110,112,117,116,32,67,79,73,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,85,110,115,117,112,112,111,114,116,101,100,32,102,111,114,109,97,116,32,111,114,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,102,111,114,109,97,116,115,0,79,110,101,32,111,102,32,97,114,103,117,109,101,110,116,115,39,32,118,97,108,117,101,115,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,0,83,105,122,101,115,32,111,102,32,105,110,112,117,116,32,97,114,103,117,109,101,110,116,115,32,100,111,32,110,111,116,32,109,97,116,99,104,0,70,111,114,109,97,116,115,32,111,102,32,105,110,112,117,116,32,97,114,103,117,109,101,110,116,115,32,100,111,32,110,111,116,32,109,97,116,99,104,0,73,110,112,117,116,32,105,109,97,103,101,32,100,101,112,116,104,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,102,117,110,99,116,105,111,110,0,82,101,113,117,101,115,116,101,100,32,111,98,106,101,99,116,32,119,97,115,32,110,111,116,32,102,111,117,110,100,0,73,110,112,108,97,99,101,32,111,112,101,114,97,116,105,111,110,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,73,109,97,103,101,32,115,116,101,112,32,105,115,32,119,114,111,110,103,0,68,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,111,99,99,117,114,114,101,100,0,78,117,108,108,32,112,111,105,110,116,101,114,0,73,110,99,111,114,114,101,99,116,32,115,105,122,101,32,111,102,32,105,110,112,117,116,32,97,114,114,97,121,0,65,117,116,111,116,114,97,99,101,32,99,97,108,108,0,73,116,101,114,97,116,105,111,110,115,32,100,111,32,110,111,116,32,99,111,110,118,101,114,103,101,0,66,97,100,32,97,114,103,117,109,101,110,116,0,73,110,115,117,102,102,105,99,105,101,110,116,32,109,101,109,111,114,121,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,0,85,110,115,112,101,99,105,102,105,101,100,32,101,114,114,111,114,0,66,97,99,107,116,114,97,99,101,0,78,111,32,69,114,114,111,114,0,117,110,107,110,111,119,110,32,102,117,110,99,116,105,111,110,0,79,112,101,110,67,86,32,69,114,114,111,114,58,32,37,115,32,40,37,115,41,32,105,110,32,37,115,44,32,102,105,108,101,32,37,115,44,32,108,105,110,101,32,37,100,0,37,115,58,37,100,58,32,101,114,114,111,114,58,32,40,37,100,41,32,37,115,32,105,110,32,102,117,110,99,116,105,111,110,32,37,115,10,0,37,115,58,37,100,58,32,101,114,114,111,114,58,32,40,37,100,41,32,37,115,10,0,108,101,110,32,62,61,32,48,32,38,38,32,34,67,104,101,99,107,32,102,111,114,109,97,116,32,115,116,114,105,110,103,32,102,111,114,32,101,114,114,111,114,115,34,0,102,111,114,109,97,116,0,78,50,99,118,49,54,84,76,83,68,97,116,97,67,111,110,116,97,105,110,101,114,69,0,79,80,69,78,67,86,95,68,85,77,80,95,67,79,78,70,73,71,0,10,71,101,110,101,114,97,108,32,99,111,110,102,105,103,117,114,97,116,105,111,110,32,102,111,114,32,79,112,101,110,67,86,32,51,46,51,46,49,45,100,101,118,32,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,10,32,32,86,101,114,115,105,111,110,32,99,111,110,116,114,111,108,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,51,46,51,46,49,45,49,45,103,50,49,99,56,101,54,100,45,100,105,114,116,121,10,10,32,32,80,108,97,116,102,111,114,109,58,10,32,32,32,32,84,105,109,101,115,116,97,109,112,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,50,48,49,55,45,49,49,45,48,49,84,48,56,58,48,53,58,52,51,90,10,32,32,32,32,72,111,115,116,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,76,105,110,117,120,32,52,46,52,46,48,45,57,55,45,103,101,110,101,114,105,99,32,120,56,54,95,54,52,10,32,32,32,32,84,97,114,103,101,116,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,69,109,115,99,114,105,112,116,101,110,32,49,32,120,56,54,10,32,32,32,32,67,77,97,107,101,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,51,46,53,46,50,10,32,32,32,32,67,77,97,107,101,32,103,101,110,101,114,97,116,111,114,58,32,32,32,32,32,32,32,32,32,32,32,32,32,85,110,105,120,32,77,97,107,101,102,105,108,101,115,10,32,32,32,32,67,77,97,107,101,32,98,117,105,108,100,32,116,111,111,108,58,32,32,32,32,32,32,32,32,32,32,32,32,47,117,115,114,47,98,105,110,47,109,97,107,101,10,32,32,32,32,67,111,110,102,105,103,117,114,97,116,105,111,110,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,82,101,108,101,97,115,101,10,10,32,32,67,80,85,47,72,87,32,102,101,97,116,117,114,101,115,58,10,32,32,32,32,66,97,115,101,108,105,110,101,58,10,10,32,32,67,47,67,43,43,58,10,32,32,32,32,66,117,105,108,116,32,97,115,32,100,121,110,97,109,105,99,32,108,105,98,115,63,58,32,32,32,32,32,32,78,79,10,32,32,32,32,67,43,43,32,67,111,109,112,105,108,101,114,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,47,104,111,109,101,47,115,97,106,106,97,100,47,101,109,115,100,107,45,112,111,114,116,97,98,108,101,47,101,109,115,99,114,105,112,116,101,110,47,105,110,99,111,109,105,110,103,47,101,109,43,43,32,32,40,118,101,114,32,52,46,48,46,48,41,10,32,32,32,32,67,43,43,32,102,108,97,103,115,32,40,82,101,108,101,97,115,101,41,58,32,32,32,32,32,32,32,32,32,45,102,80,73,67,32,32,32,45,102,115,105,103,110,101,100,45,99,104,97,114,32,45,87,32,45,87,97,108,108,32,45,87,101,114,114,111,114,61,114,101,116,117,114,110,45,116,121,112,101,32,45,87,101,114,114,111,114,61,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,101,114,114,111,114,61,97,100,100,114,101,115,115,32,45,87,101,114,114,111,114,61,115,101,113,117,101,110,99,101,45,112,111,105,110,116,32,45,87,102,111,114,109,97,116,32,45,87,101,114,114,111,114,61,102,111,114,109,97,116,45,115,101,99,117,114,105,116,121,32,45,87,109,105,115,115,105,110,103,45,100,101,99,108,97,114,97,116,105,111,110,115,32,45,87,109,105,115,115,105,110,103,45,112,114,111,116,111,116,121,112,101,115,32,45,87,115,116,114,105,99,116,45,112,114,111,116,111,116,121,112,101,115,32,45,87,117,110,100,101,102,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,112,111,105,110,116,101,114,45,97,114,105,116,104,32,45,87,115,104,97,100,111,119,32,45,87,115,105,103,110,45,112,114,111,109,111,32,45,87,117,110,105,110,105,116,105,97,108,105,122,101,100,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,110,111,45,110,97,114,114,111,119,105,110,103,32,45,87,110,111,45,100,101,108,101,116,101,45,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,110,111,45,117,110,110,97,109,101,100,45,116,121,112,101,45,116,101,109,112,108,97,116,101,45,97,114,103,115,32,45,87,110,111,45,99,111,109,109,101,110,116,32,45,87,110,111,45,105,109,112,108,105,99,105,116,45,102,97,108,108,116,104,114,111,117,103,104,32,45,102,100,105,97,103,110,111,115,116,105,99,115,45,115,104,111,119,45,111,112,116,105,111,110,32,45,112,116,104,114,101,97,100,32,45,81,117,110,117,115,101,100,45,97,114,103,117,109,101,110,116,115,32,45,109,97,114,99,104,61,105,54,56,54,32,45,102,111,109,105,116,45,102,114,97,109,101,45,112,111,105,110,116,101,114,32,45,102,102,117,110,99,116,105,111,110,45,115,101,99,116,105,111,110,115,32,32,45,102,118,105,115,105,98,105,108,105,116,121,61,104,105,100,100,101,110,32,45,102,118,105,115,105,98,105,108,105,116,121,45,105,110,108,105,110,101,115,45,104,105,100,100,101,110,32,45,68,78,68,69,66,85,71,32,45,79,50,32,32,45,68,78,68,69,66,85,71,10,32,32,32,32,67,43,43,32,102,108,97,103,115,32,40,68,101,98,117,103,41,58,32,32,32,32,32,32,32,32,32,32,32,45,102,80,73,67,32,32,32,45,102,115,105,103,110,101,100,45,99,104,97,114,32,45,87,32,45,87,97,108,108,32,45,87,101,114,114,111,114,61,114,101,116,117,114,110,45,116,121,112,101,32,45,87,101,114,114,111,114,61,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,101,114,114,111,114,61,97,100,100,114,101,115,115,32,45,87,101,114,114,111,114,61,115,101,113,117,101,110,99,101,45,112,111,105,110,116,32,45,87,102,111,114,109,97,116,32,45,87,101,114,114,111,114,61,102,111,114,109,97,116,45,115,101,99,117,114,105,116,121,32,45,87,109,105,115,115,105,110,103,45,100,101,99,108,97,114,97,116,105,111,110,115,32,45,87,109,105,115,115,105,110,103,45,112,114,111,116,111,116,121,112,101,115,32,45,87,115,116,114,105,99,116,45,112,114,111,116,111,116,121,112,101,115,32,45,87,117,110,100,101,102,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,112,111,105,110,116,101,114,45,97,114,105,116,104,32,45,87,115,104,97,100,111,119,32,45,87,115,105,103,110,45,112,114,111,109,111,32,45,87,117,110,105,110,105,116,105,97,108,105,122,101,100,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,110,111,45,110,97,114,114,111,119,105,110,103,32,45,87,110,111,45,100,101,108,101,116,101,45,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,110,111,45,117,110,110,97,109,101,100,45,116,121,112,101,45,116,101,109,112,108,97,116,101,45,97,114,103,115,32,45,87,110,111,45,99,111,109,109,101,110,116,32,45,87,110,111,45,105,109,112,108,105,99,105,116,45,102,97,108,108,116,104,114,111,117,103,104,32,45,102,100,105,97,103,110,111,115,116,105,99,115,45,115,104,111,119,45,111,112,116,105,111,110,32,45,112,116,104,114,101,97,100,32,45,81,117,110,117,115,101,100,45,97,114,103,117,109,101,110,116,115,32,45,109,97,114,99,104,61,105,54,56,54,32,45,102,111,109,105,116,45,102,114,97,109,101,45,112,111,105,110,116,101,114,32,45,102,102,117,110,99,116,105,111,110,45,115,101,99,116,105,111,110,115,32,32,45,102,118,105,115,105,98,105,108,105,116,121,61,104,105,100,100,101,110,32,45,102,118,105,115,105,98,105,108,105,116,121,45,105,110,108,105,110,101,115,45,104,105,100,100,101,110,32,45,103,32,32,45,79,48,32,45,68,68,69,66,85,71,32,45,68,95,68,69,66,85,71,10,32,32,32,32,67,32,67,111,109,112,105,108,101,114,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,47,104,111,109,101,47,115,97,106,106,97,100,47,101,109,115,100,107,45,112,111,114,116,97,98,108,101,47,101,109,115,99,114,105,112,116,101,110,47,105,110,99,111,109,105,110,103,47,101,109,99,99,10,32,32,32,32,67,32,102,108,97,103,115,32,40,82,101,108,101,97,115,101,41,58,32,32,32,32,32,32,32,32,32,32,32,45,102,80,73,67,32,32,32,45,102,115,105,103,110,101,100,45,99,104,97,114,32,45,87,32,45,87,97,108,108,32,45,87,101,114,114,111,114,61,114,101,116,117,114,110,45,116,121,112,101,32,45,87,101,114,114,111,114,61,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,101,114,114,111,114,61,97,100,100,114,101,115,115,32,45,87,101,114,114,111,114,61,115,101,113,117,101,110,99,101,45,112,111,105,110,116,32,45,87,102,111,114,109,97,116,32,45,87,101,114,114,111,114,61,102,111,114,109,97,116,45,115,101,99,117,114,105,116,121,32,45,87,109,105,115,115,105,110,103,45,100,101,99,108,97,114,97,116,105,111,110,115,32,45,87,109,105,115,115,105,110,103,45,112,114,111,116,111,116,121,112,101,115,32,45,87,115,116,114,105,99,116,45,112,114,111,116,111,116,121,112,101,115,32,45,87,117,110,100,101,102,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,112,111,105,110,116,101,114,45,97,114,105,116,104,32,45,87,115,104,97,100,111,119,32,45,87,115,105,103,110,45,112,114,111,109,111,32,45,87,117,110,105,110,105,116,105,97,108,105,122,101,100,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,110,111,45,110,97,114,114,111,119,105,110,103,32,45,87,110,111,45,100,101,108,101,116,101,45,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,110,111,45,117,110,110,97,109,101,100,45,116,121,112,101,45,116,101,109,112,108,97,116,101,45,97,114,103,115,32,45,87,110,111,45,99,111,109,109,101,110,116,32,45,87,110,111,45,105,109,112,108,105,99,105,116,45,102,97,108,108,116,104,114,111,117,103,104,32,45,102,100,105,97,103,110,111,115,116,105,99,115,45,115,104,111,119,45,111,112,116,105,111,110,32,45,112,116,104,114,101,97,100,32,45,81,117,110,117,115,101,100,45,97,114,103,117,109,101,110,116,115,32,45,109,97,114,99,104,61,105,54,56,54,32,45,102,111,109,105,116,45,102,114,97,109,101,45,112,111,105,110,116,101,114,32,45,102,102,117,110,99,116,105,111,110,45,115,101,99,116,105,111,110,115,32,32,45,102,118,105,115,105,98,105,108,105,116,121,61,104,105,100,100,101,110,32,45,102,118,105,115,105,98,105,108,105,116,121,45,105,110,108,105,110,101,115,45,104,105,100,100,101,110,32,45,68,78,68,69,66,85,71,32,45,79,50,32,32,45,68,78,68,69,66,85,71,10,32,32,32,32,67,32,102,108,97,103,115,32,40,68,101,98,117,103,41,58,32,32,32,32,32,32,32,32,32,32,32,32,32,45],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+184332);allocate([102,80,73,67,32,32,32,45,102,115,105,103,110,101,100,45,99,104,97,114,32,45,87,32,45,87,97,108,108,32,45,87,101,114,114,111,114,61,114,101,116,117,114,110,45,116,121,112,101,32,45,87,101,114,114,111,114,61,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,101,114,114,111,114,61,97,100,100,114,101,115,115,32,45,87,101,114,114,111,114,61,115,101,113,117,101,110,99,101,45,112,111,105,110,116,32,45,87,102,111,114,109,97,116,32,45,87,101,114,114,111,114,61,102,111,114,109,97,116,45,115,101,99,117,114,105,116,121,32,45,87,109,105,115,115,105,110,103,45,100,101,99,108,97,114,97,116,105,111,110,115,32,45,87,109,105,115,115,105,110,103,45,112,114,111,116,111,116,121,112,101,115,32,45,87,115,116,114,105,99,116,45,112,114,111,116,111,116,121,112,101,115,32,45,87,117,110,100,101,102,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,112,111,105,110,116,101,114,45,97,114,105,116,104,32,45,87,115,104,97,100,111,119,32,45,87,115,105,103,110,45,112,114,111,109,111,32,45,87,117,110,105,110,105,116,105,97,108,105,122,101,100,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,110,111,45,110,97,114,114,111,119,105,110,103,32,45,87,110,111,45,100,101,108,101,116,101,45,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,110,111,45,117,110,110,97,109,101,100,45,116,121,112,101,45,116,101,109,112,108,97,116,101,45,97,114,103,115,32,45,87,110,111,45,99,111,109,109,101,110,116,32,45,87,110,111,45,105,109,112,108,105,99,105,116,45,102,97,108,108,116,104,114,111,117,103,104,32,45,102,100,105,97,103,110,111,115,116,105,99,115,45,115,104,111,119,45,111,112,116,105,111,110,32,45,112,116,104,114,101,97,100,32,45,81,117,110,117,115,101,100,45,97,114,103,117,109,101,110,116,115,32,45,109,97,114,99,104,61,105,54,56,54,32,45,102,111,109,105,116,45,102,114,97,109,101,45,112,111,105,110,116,101,114,32,45,102,102,117,110,99,116,105,111,110,45,115,101,99,116,105,111,110,115,32,32,45,102,118,105,115,105,98,105,108,105,116,121,61,104,105,100,100,101,110,32,45,102,118,105,115,105,98,105,108,105,116,121,45,105,110,108,105,110,101,115,45,104,105,100,100,101,110,32,45,103,32,32,45,79,48,32,45,68,68,69,66,85,71,32,45,68,95,68,69,66,85,71,10,32,32,32,32,76,105,110,107,101,114,32,102,108,97,103,115,32,40,82,101,108,101,97,115,101,41,58,32,32,32,32,32,32,45,79,50,10,32,32,32,32,76,105,110,107,101,114,32,102,108,97,103,115,32,40,68,101,98,117,103,41,58,10,32,32,32,32,99,99,97,99,104,101,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,89,69,83,10,32,32,32,32,80,114,101,99,111,109,112,105,108,101,100,32,104,101,97,100,101,114,115,58,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,69,120,116,114,97,32,100,101,112,101,110,100,101,110,99,105,101,115,58,32,32,32,32,32,32,32,32,32,32,115,116,100,99,43,43,10,32,32,32,32,51,114,100,112,97,114,116,121,32,100,101,112,101,110,100,101,110,99,105,101,115,58,32,32,32,32,32,32,32,122,108,105,98,32,108,105,98,106,112,101,103,10,10,32,32,79,112,101,110,67,86,32,109,111,100,117,108,101,115,58,10,32,32,32,32,84,111,32,98,101,32,98,117,105,108,116,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,99,111,114,101,32,105,109,103,112,114,111,99,32,111,98,106,100,101,116,101,99,116,32,118,105,100,101,111,32,105,109,103,99,111,100,101,99,115,32,104,105,103,104,103,117,105,32,102,101,97,116,117,114,101,115,50,100,32,106,115,10,32,32,32,32,68,105,115,97,98,108,101,100,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,99,97,108,105,98,51,100,32,102,108,97,110,110,32,109,108,32,112,104,111,116,111,32,115,104,97,112,101,32,115,116,105,116,99,104,105,110,103,32,115,117,112,101,114,114,101,115,32,118,105,100,101,111,105,111,32,118,105,100,101,111,115,116,97,98,32,119,111,114,108,100,10,32,32,32,32,68,105,115,97,98,108,101,100,32,98,121,32,100,101,112,101,110,100,101,110,99,121,58,32,32,32,32,32,32,45,10,32,32,32,32,85,110,97,118,97,105,108,97,98,108,101,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,99,117,100,97,97,114,105,116,104,109,32,99,117,100,97,98,103,115,101,103,109,32,99,117,100,97,99,111,100,101,99,32,99,117,100,97,102,101,97,116,117,114,101,115,50,100,32,99,117,100,97,102,105,108,116,101,114,115,32,99,117,100,97,105,109,103,112,114,111,99,32,99,117,100,97,108,101,103,97,99,121,32,99,117,100,97,111,98,106,100,101,116,101,99,116,32,99,117,100,97,111,112,116,102,108,111,119,32,99,117,100,97,115,116,101,114,101,111,32,99,117,100,97,119,97,114,112,105,110,103,32,99,117,100,101,118,32,106,97,118,97,32,112,121,116,104,111,110,50,32,112,121,116,104,111,110,51,32,116,115,32,118,105,122,10,10,32,32,71,85,73,58,32,10,32,32,32,32,81,84,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,71,84,75,43,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,71,84,104,114,101,97,100,32,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,71,116,107,71,108,69,120,116,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,79,112,101,110,71,76,32,115,117,112,112,111,114,116,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,86,84,75,32,115,117,112,112,111,114,116,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,10,32,32,77,101,100,105,97,32,73,47,79,58,32,10,32,32,32,32,90,76,105,98,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,98,117,105,108,100,32,40,118,101,114,32,49,46,50,46,56,41,10,32,32,32,32,74,80,69,71,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,98,117,105,108,100,32,40,118,101,114,32,57,48,41,10,32,32,32,32,87,69,66,80,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,80,78,71,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,84,73,70,70,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,74,80,69,71,32,50,48,48,48,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,79,112,101,110,69,88,82,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,71,68,65,76,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,71,68,67,77,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,10,32,32,86,105,100,101,111,32,73,47,79,58,10,32,32,32,32,68,67,49,51,57,52,32,49,46,120,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,68,67,49,51,57,52,32,50,46,120,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,70,70,77,80,69,71,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,32,32,97,118,99,111,100,101,99,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,32,32,97,118,102,111,114,109,97,116,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,32,32,97,118,117,116,105,108,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,32,32,115,119,115,99,97,108,101,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,32,32,97,118,114,101,115,97,109,112,108,101,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,71,83,116,114,101,97,109,101,114,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,79,112,101,110,78,73,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,79,112,101,110,78,73,32,80,114,105,109,101,83,101,110,115,111,114,32,77,111,100,117,108,101,115,58,32,32,78,79,10,32,32,32,32,79,112,101,110,78,73,50,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,80,118,65,80,73,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,71,105,103,69,86,105,115,105,111,110,83,68,75,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,65,114,97,118,105,115,32,83,68,75,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,85,110,105,67,97,112,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,85,110,105,67,97,112,32,117,99,105,108,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,86,52,76,47,86,52,76,50,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,47,78,79,10,32,32,32,32,88,73,77,69,65,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,88,105,110,101,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,73,110,116,101,108,32,77,101,100,105,97,32,83,68,75,58,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,103,80,104,111,116,111,50,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,10,32,32,80,97,114,97,108,108,101,108,32,102,114,97,109,101,119,111,114,107,58,32,32,32,32,32,32,32,32,32,32,32,32,110,111,110,101,10,10,32,32,79,116,104,101,114,32,116,104,105,114,100,45,112,97,114,116,121,32,108,105,98,114,97,114,105,101,115,58,10,32,32,32,32,85,115,101,32,73,110,116,101,108,32,73,80,80,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,85,115,101,32,73,110,116,101,108,32,73,80,80,32,73,87,58,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,85,115,101,32,86,65,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,85,115,101,32,73,110,116,101,108,32,86,65,45,65,80,73,47,79,112,101,110,67,76,58,32,32,32,32,32,78,79,10,32,32,32,32,85,115,101,32,76,97,112,97,99,107,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,85,115,101,32,69,105,103,101,110,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,85,115,101,32,67,117,100,97,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,85,115,101,32,79,112,101,110,67,76,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,85,115,101,32,79,112,101,110,86,88,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,85,115,101,32,99,117,115,116,111,109,32,72,65,76,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,10,32,32,80,121,116,104,111,110,32,50,58,10,32,32,32,32,73,110,116,101,114,112,114,101,116,101,114,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,47,117,115,114,47,98,105,110,47,112,121,116,104,111,110,50,46,55,32,40,118,101,114,32,50,46,55,46,49,50,41,10,10,32,32,80,121,116,104,111,110,32,51,58,10,32,32,32,32,73,110,116,101,114,112,114,101,116,101,114,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,47,117,115,114,47,98,105,110,47,112,121,116,104,111,110,51,32,40,118,101,114,32,51,46,53,46,50,41,10,10,32,32,80,121,116,104,111,110,32,40,102,111,114,32,98,117,105,108,100,41,58,32,32,32,32,32,32,32,32,32,32,32,32,47,117,115,114,47,98,105,110,47,112,121,116,104,111,110,50,46,55,10,10,32,32,74,97,118,97,58,10,32,32,32,32,97,110,116,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,47,117,115,114,47,98,105,110,47,97,110,116,32,40,118,101,114,32,49,46,57,46,54,41,10,32,32,32,32,74,78,73,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,74,97,118,97,32,119,114,97,112,112,101,114,115,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,74,97,118,97,32,116,101,115,116,115,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,10,32,32,77,97,116,108,97,98,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,10,32,32,84,101,115,116,115,32,97,110,100,32,115,97,109,112,108,101,115,58,10,32,32,32,32,84,101,115,116,115,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,80,101,114,102,111,114,109,97,110,99,101,32,116,101,115,116,115,58,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,67,47,67,43,43,32,69,120,97,109,112,108,101,115,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,10,32,32,73,110,115,116,97,108,108,32,112,97,116,104,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,98,117,105,108,100,95,106,115,47,105,110,115,116,97,108,108,10,10,32,32,99,118,99,111,110,102,105,103,46,104,32,105,115,32,105,110,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,98,117,105,108,100,95,106,115,10,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,10,10,0,10,79,112,101,110,67,86,32,98,117,105,108,100,32,99,111,110,102,105,103,117,114,97,116,105,111,110,32,105,115,58,10,37,115,10,0,77,77,88,0,83,83,69,0,83,83,69,50,0,83,83,69,51,0,83,83,83,69,51,0,83,83,69,52,46,49,0,83,83,69,52,46,50,0,80,79,80,67,78,84,0,70,80,49,54,0,65,86,88,0,65,86,88,50,0,70,77,65,51,0,65,86,88,53,49,50,70,0,65,86,88,53,49,50,66,87,0,65,86,88,53,49,50,67,68,0,65,86,88,53,49,50,68,81,0,65,86,88,53,49,50,69,82,0,65,86,88,53,49,50,73,70,77,65,0,65,86,88,53,49,50,80,70,0,65,86,88,53,49,50,86,66,77,73,0,65,86,88,53,49,50,86,76,0,78,69,79,78,0,86,83,88,0,79,80,69,78,67,86,95,67,80,85,95,68,73,83,65,66,76,69,0,102,101,97,116,117,114,101,46,115,105,122,101,40,41,32,62,32,48,0,114,101,97,100,83,101,116,116,105,110,103,115,0,79,80,69,78,67,86,58,32,84,114,121,105,110,103,32,116,111,32,100,105,115,97,98,108,101,32,98,97,115,101,108,105,110,101,32,67,80,85,32,102,101,97,116,117,114,101,58,32,39,37,115,39,46,32,84,104,105,115,32,104,97,115,32,118,101,114,121,32,108,105,109,105,116,101,100,32,101,102,102,101,99,116,44,32,98,101,99,97,117,115,101,32,99,111,100,101,32,111,112,116,105,109,105,122,97,116,105,111,110,115,32,102,111,114,32,116,104,105,115,32,102,101,97,116,117,114,101,32,97,114,101,32,101,120,101,99,117,116,101,100,32,117,110,99,111,110,100,105,116,105,111,110,97,108,108,121,32,105,110,32,116,104,101,32,109,111,115,116,32,99,97,115,101,115,46,10,0,85,110,107,110,111,119,110,32,102,101,97,116,117,114,101,0,79,80,69,78,67,86,58,32,84,114,121,105,110,103,32,116,111,32,100,105,115,97,98,108,101,32,117,110,97,118,97,105,108,97,98,108,101,32,67,80,85,32,102,101,97,116,117,114,101,32,111,110,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,58,32,39,37,115,39,46,10,0,79,80,69,78,67,86,58,32,84,114,121,105,110,103,32,116,111,32,100,105,115,97,98,108,101,32,117,110,107,110,111,119,110,32,67,80,85,32,102,101,97,116,117,114,101,58,32,39,37,115,39,46,10,0,107,101,121,95,32,33,61,32,45,49,32,38,38,32,34,67,97,110,39,116,32,102,101,116,99,104,32,100,97,116,97,32,102,114,111,109,32,116,101,114,109,105,110,97,116,101,100,32,84,76,83,32,99,111,110,116,97,105,110,101,114,46,34,0,103,101,116,68,97,116,97,0,116,108,115,83,108,111,116,115,83,105,122,101,32,62,32,115,108,111,116,73,100,120,0,115,101,116,68,97,116,97,0,112,116,104,114,101,97,100,95,115,101,116,115,112,101,99,105,102,105,99,40,116,108,115,75,101,121,44,32,112,68,97,116,97,41,32,61,61,32,48,0,83,101,116,68,97,116,97,0,112,116,104,114,101,97,100,95,107,101,121,95,100,101,108,101,116,101,40,116,108,115,75,101,121,41,32,61,61,32,48,0,126,84,108,115,65,98,115,116,114,97,99,116,105,111,110,0,112,116,104,114,101,97,100,95,107,101,121,95,99,114,101,97,116,101,40,38,116,108,115,75,101,121,44,32,48,76,41,32,61,61,32,48,0,84,108,115,65,98,115,116,114,97,99,116,105,111,110,0,116,108,115,83,108,111,116,115,83,105,122,101,32,61,61,32,116,108,115,83,108,111,116,115,46,115,105,122,101,40,41,0,114,101,108,101,97,115,101,83,108,111,116,0,78,50,99,118,55,84,76,83,68,97,116,97,73,78,83,95,49,49,67,111,114,101,84,76,83,68,97,116,97,69,69,69,0,114,101,115,101,114,118,101,83,108,111,116,0,79,80,69,78,67,86,95,84,69,77,80,95,80,65,84,72,0,47,116,109,112,47,95,95,111,112,101,110,99,118,95,116,101,109,112,46,88,88,88,88,88,88,0,95,95,111,112,101,110,99,118,95,116,101,109,112,46,88,88,88,88,88,88,0,49,0,84,114,117,101,0,84,82,85,69,0,48,0,70,97,108,115,101,0,70,65,76,83,69,0,73,110,118,97,108,105,100,32,118,97,108,117,101,32,102,111,114,32,37,115,32,112,97,114,97,109,101,116,101,114,58,32,37,115,0,103,101,116,67,111,110,102,105,103,117,114,97,116,105,111,110,80,97,114,97,109,101,116,101,114,66,111,111,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,109,97,112,99,111,117,110,116,32,61,61,32,48,0,126,85,77,97,116,68,97,116,97,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,117,109,97,116,114,105,120,46,99,112,112,0,48,32,60,61,32,95,100,105,109,115,32,38,38,32,95,100,105,109,115,32,60,61,32,51,50,0,115,101,116,83,105,122,101,0,115,32,62,61,32,48,0,84,104,101,32,116,111,116,97,108,32,109,97,116,114,105,120,32,115,105,122,101,32,100,111,101,115,32,110,111,116,32,102,105,116,32,116,111,32,34,115,105,122,101,95,116,34,32,116,121,112,101,0,100,97,116,97,32,61,61,32,100,97,116,97,115,116,97,114,116,0,103,101,116,85,77,97,116,0,97,108,108,111,99,97,116,101,100,0,109,46,100,105,109,115,32,60,61,32,50,0,85,77,97,116,0,48,32,60,61,32,114,111,105,46,120,32,38,38,32,48,32,60,61,32,114,111,105,46,119,105,100,116,104,32,38,38,32,114,111,105,46,120,32,43,32,114,111,105,46,119,105,100,116,104,32,60,61,32,109,46,99,111,108,115,32,38,38,32,48,32,60,61,32,114,111,105,46,121,32,38,38,32,48,32,60,61,32,114,111,105,46,104,101,105,103,104,116,32,38,38,32,114,111,105,46,121,32,43,32,114,111,105,46,104,101,105,103,104,116,32,60,61,32,109,46,114,111,119,115,0,48,32,60,61,32,100,32,38,38,32,100,32,60,61,32,51,50,32,38,38,32,95,115,105,122,101,115,0,117,32,33,61,32,48,0,115,116,101,112,91,100,105,109,115,45,49,93,32,61,61,32,40,115,105,122,101,95,116,41,40,40,40,40,40,102,108,97,103,115,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,60,60,32,40,40,40,40,115,105,122,101,111,102,40,115,105,122,101,95,116,41,47,52,43,49,41,42,49,54,51,56,52,124,48,120,51,97,53,48,41,32,62,62,32,40,40,102,108,97,103,115,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,42,50,41,32,38,32,51,41,41,0,109,46,100,105,109,115,32,62,61,32,50,0,48,32,60,61,32,95,114,111,119,82,97,110,103,101,46,115,116,97,114,116,32,38,38,32,95,114,111,119,82,97,110,103,101,46,115,116,97,114,116,32,60,61,32,95,114,111,119,82,97,110,103,101,46,101,110,100,32,38,38,32,95,114,111,119,82,97,110,103,101,46,101,110,100,32,60,61,32,109,46,114,111,119,115,0,48,32,60,61,32,95,99,111,108,82,97,110,103,101,46,115,116,97,114,116,32,38,38,32,95,99,111,108,82,97,110,103,101,46,115,116,97,114,116,32,60,61,32,95,99,111,108,82,97,110,103,101,46,101,110,100,32,38,38,32,95,99,111,108,82,97,110,103,101,46,101,110,100,32,60,61,32,109,46,99,111,108,115,0,114,97,110,103,101,115,0,114,32,61,61,32,82,97,110,103,101,58,58,97,108,108,40,41,32,124,124,32,40,48,32,60,61,32,114,46,115,116,97,114,116,32,38,38,32,114,46,115,116,97,114,116,32,60,32,114,46,101,110,100,32,38,38,32,114,46,101,110,100,32,60,61,32,109,46,115,105,122,101,91,105,93,41,0,99,104,97,110,110,101,108,115,40,41,32,61,61,32,40,40,40,40,100,116,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,0,99,111,112,121,84,111,0,100,115,116,46,117,0,117,45,62,100,97,116,97,32,33,61,32,48,32,38,38,32,34,69,114,114,111,114,32,109,97,112,112,105,110,103,32,111,102,32,85,77,97,116,32,116,111,32,104,111,115,116,32,109,101,109,111,114,121,46,34,0,103,101,116,77,97,116,0,118,111,105,100,32,99,118,58,58,85,77,97,116,58,58,99,111,110,118,101,114,116,84,111,40,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,41,32,99,111,110,115,116,0,118,111,105,100,32,99,118,58,58,85,77,97,116,58,58,99,111,112,121,84,111,40,79,117,116,112,117,116,65,114,114,97,121,41,32,99,111,110,115,116,0,99,118,58,58,85,77,97,116,32,38,99,118,58,58,85,77,97,116,58,58,115,101,116,84,111,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,97,114,114,97,121,46,99,112,112,0,68,97,116,97,32,105,115,32,97,108,114,101,97,100,121,32,97,108,108,111,99,97,116,101,100,0,99,118,67,114,101,97,116,101,68,97,116,97,0,84,111,111,32,98,105,103,32,98,117,102,102,101,114,32,105,115,32,97,108,108,111,99,97,116,101,100,0,79,118,101,114,102,108,111,119,32,102,111,114,32,105,109,97,103,101,83,105,122,101,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,114,32,117,110,115,117,112,112,111,114,116,101,100,32,97,114,114,97,121,32,116,121,112,101,0,78,111,110,45,112,111,115,105,116,105,118,101,32,119,105,100,116,104,32,111,114,32,104,101,105,103,104,116,0,99,118,67,114,101,97,116,101,77,97,116,72,101,97,100,101,114,0,73,110,118,97,108,105,100,32,109,97,116,114,105,120,32,116,121,112,101,0,99,118,73,110,105,116,77,97,116,72,101,97,100,101,114,0,78,111,110,45,112,111,115,105,116,105,118,101,32,99,111,108,115,32,111,114,32,114,111,119,115,0,99,118,82,101,108,101,97,115,101,77,97,116,0,66,97,100,32,67,118,77,97,116,32,104,101,97,100,101,114,0,99,118,67,108,111,110,101,77,97,116,0,78,85,76,76,32,109,97,116,114,105,120,32,104,101,97,100,101,114,32,112,111,105,110,116,101,114,0,99,118,73,110,105,116,77,97,116,78,68,72,101,97,100,101,114,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,100,97,116,97,32,116,121,112,101,0,78,85,76,76,32,60,115,105,122,101,115,62,32,112,111,105,110,116,101,114,0,110,111,110,45,112,111,115,105,116,105,118,101,32,111,114,32,116,111,111,32,108,97,114,103,101,32,110,117,109,98,101,114,32,111,102,32,100,105,109,101,110,115,105,111,110,115,0,111,110,101,32,111,102,32,100,105,109,101,115,105,111,110,32,115,105,122,101,115,32,105,115,32,110,111,110,45,112,111,115,105,116,105,118,101,0,84,104,101,32,97,114,114,97,121,32,105,115,32,116,111,111,32,98,105,103,0,99,118,67,114,101,97,116,101,77,97,116,78,68,72,101,97,100,101,114,0,66,97,100,32,67,118,77,97,116,78,68,32,104,101,97,100,101,114,0,99,118,67,108,111,110,101,77,97,116,78,68,0,115,114,99,45,62,100,105,109,115,32,60,61,32,51,50,0,95,100,115,116,46,100,97,116,97,32,61,61,32,100,97,116,97,48,0,73,110,99,111,114,114,101,99,116,32,110,117,109,98,101,114,32,111,102,32,97,114,114,97,121,115,0,99,118,73,110,105,116,78,65,114,114,97,121,73,116,101,114,97,116,111,114,0,83,111,109,101,32,111,102,32,114,101,113,117,105,114,101,100,32,97,114,114,97,121,32,112,111,105,110,116,101,114,115,32,105,115,32,78,85,76,76,0,73,116,101,114,97,116,111,114,32,112,111,105,110,116,101,114,32,105,115,32,78,85,76,76,0,73,116,101,114,97,116,111,114,32,119,105,116,104,32,109,97,115,107,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,67,79,73,32,115,101,116,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,104,101,114,101,0,78,117,109,98,101,114,32,111,102,32,100,105,109,101,110,115,105,111,110,115,32,105,115,32,116,104,101,32,115,97,109,101,32,102,111,114,32,97,108,108,32,97,114,114,97,121,115,0,68,97,116,97,32,116,121,112,101,32,105,115,32,110,111,116,32,116,104,101,32,115,97,109,101,32,102,111,114,32,97,108,108,32,97,114,114,97,121,115,0,78,117,109,98,101,114,32,111,102,32,99,104,97,110,110,101,108,115,32,105,115,32,110,111,116,32,116,104,101,32,115,97,109,101,32,102,111,114,32,97,108,108,32,97,114,114,97,121,115,0,68,101,112,116,104,32,105,115,32,110,111,116,32,116,104,101,32,115,97,109,101,32,102,111,114,32,97,108,108,32,97,114,114,97,121,115,0,68,105,109,101,110,115,105,111,110,32,115,105,122,101,115,32,97,114,101,32,116,104,101,32,115,97,109,101,32,102,111,114,32,97,108,108,32,97,114,114,97,121,115,0,78,85,76,76,32,97,114,114,97,121,32,112,111,105,110,116,101,114,32,105,115,32,112,97,115,115,101,100,0,99,118,71,101,116,77,97,116,78,68,0,84,104,101,32,109,97,116,114,105,120,32,104,97,115,32,78,85,76,76,32,100,97,116,97,32,112,111,105,110,116,101,114,0,85,110,114,101,99,111,103,110,105,122,101,100,32,111,114,32,117,110,115,117,112,112,111,114,116,101,100,32,97,114,114,97,121,32,116,121,112,101,0,73,110,112,117,116,32,97,114,114,97,121,32,104,97,115,32,78,85,76,76,32,100,97,116,97,32,112,111,105,110,116,101,114,0,99,118,71,101,116,77,97,116,0,84,104,101,32,105,109,97,103,101,32,104,97,115,32,78,85,76,76,32,100,97,116,97,32,112,111,105,110,116,101,114,0,73,109,97,103,101,115,32,119,105,116,104,32,112,108,97,110,97,114,32,100,97,116,97,32,108,97,121,111,117,116,32,115,104,111,117,108,100,32,98,101,32,117,115,101,100,32,119,105,116,104,32,67,79,73,32,115,101,108,101,99,116,101,100,0,84,104,101,32,105,109,97,103,101,32,105,115,32,105,110,116,101,114,108,101,97,118,101,100,32,97,110,100,32,104,97,115,32,111,118,101,114,32,67,86,95,67,78,95,77,65,88,32,99,104,97,110,110,101,108,115,0,80,105,120,101,108,32,111,114,100,101,114,32,115,104,111,117,108,100,32,98,101,32,117,115,101,100,32,119,105,116,104,32,99,111,105,32,61,61,32,48,0,79,110,108,121,32,99,111,110,116,105,110,117,111,117,115,32,110,68,32,97,114,114,97,121,115,32,97,114,101,32,115,117,112,112,111,114,116,101,100,32,104,101,114,101,0,99,118,67,114,101,97,116,101,83,112,97,114,115,101,77,97,116,0,98,97,100,32,110,117,109,98,101,114,32,111,102,32,100,105,109,101,110,115,105,111,110,115,0,99,118,82,101,108,101,97,115,101,83,112,97,114,115,101,77,97,116,0,73,110,118,97,108,105,100,32,115,112,97,114,115,101,32,97,114,114,97,121,32,104,101,97,100,101,114,0,99,118,67,108,111,110,101,83,112,97,114,115,101,77,97,116,0,73,110,118,97,108,105,100,32,115,112,97,114,115,101,32,109,97,116,114,105,120,32,104,101,97,100,101,114,0,99,118,73,110,105,116,83,112,97,114,115,101,77,97,116,73,116,101,114,97,116,111,114,0,78,85,76,76,32,105,116,101,114,97,116,111,114,32,112,111,105,110,116,101,114,0,99,118,82,101,108,101,97,115,101,68,97,116,97,0,105,110,100,101,120,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,0,99,118,80,116,114,50,68,0,67,79,73,32,109,117,115,116,32,98,101,32,110,111,110,45,110,117,108,108,32,105,110,32,99,97,115,101,32,111,102,32,112,108,97,110,97,114,32,105,109,97,103,101,115,0,40,40,67,118,83,112,97,114,115,101,77,97,116,42,41,97,114,114,41,45,62,100,105,109,115,32,61,61,32,50,0,79,110,101,32,111,102,32,105,110,100,105,99,101,115,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,0,105,99,118,71,101,116,78,111,100,101,80,116,114,0,99,118,71,101,116,69,108,101,109,84,121,112,101,0,99,118,71,101,116,68,105,109,115,0,65,114,114,97,121,32,115,104,111,117,108,100,32,98,101,32,67,118,77,97,116,32,111,114,32,73,112,108,73,109,97,103,101,0,99,118,71,101,116,83,105,122,101,0,78,85,76,76,32,112,111,105,110,116,101,114,32,116,111,32,105,110,100,105,99,101,115,0,99,118,80,116,114,78,68,0,84,104,101,32,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,32,105,115,32,110,111,116,32,100,105,118,105,115,105,98,108,101,32,98,121,32,116,104,101,32,110,101,119,32,110,117,109,98,101,114,32,111,102,32,114,111,119,115,0,99,118,82,101,115,104,97,112,101,0,84,104,101,32,109,97,116,114,105,120,32,105,115,32,110,111,116,32,99,111,110,116,105,110,117,111,117,115,44,32,116,104,117,115,32,105,116,115,32,110,117,109,98,101,114,32,111,102,32,114,111,119,115,32,99,97,110,32,110,111,116,32,98,101,32,99,104,97,110,103,101,100,0,66,97,100,32,110,101,119,32,110,117,109,98,101,114,32,111,102,32,114,111,119,115,0,84,104,101,32,116,111,116,97,108,32,119,105,100,116,104,32,105,115,32,110,111,116,32,100,105,118,105,115,105,98,108,101,32,98,121,32,116,104,101,32,110,101,119,32,110,117,109,98,101,114,32,111,102,32,99,104,97,110,110,101,108,115,0,110,117,108,108,32,112,111,105,110,116,101,114,32,116,111,32,104,101,97,100,101,114,0,99,118,73,110,105,116,73,109,97,103,101,72,101,97,100,101,114,0,66,97,100,32,105,110,112,117,116,32,114,111,105,0,85,110,115,117,112,112,111,114,116,101,100,32,102,111,114,109,97,116,0,66,97,100,32,105,110,112,117,116,32,111,114,105,103,105,110,0,66,97,100,32,105,110,112,117,116,32,97,108,105,103,110,0,71,82,65,89,0,82,71,66,0,66,71,82,0,66,71,82,65,0,99,118,82,101,108,101,97,115,101,73,109,97,103,101,0,99,118,83,101,116,73,109,97,103,101,82,79,73,0,114,101,99,116,46,119,105,100,116,104,32,62,61,32,48,32,38,38,32,114,101,99,116,46,104,101,105,103,104,116,32,62,61,32,48,32,38,38,32,114,101,99,116,46,120,32,60,32,105,109,97,103,101,45,62,119,105,100,116,104,32,38,38,32,114,101,99,116,46,121,32,60,32,105,109,97,103,101,45,62,104,101,105,103,104,116,32,38,38,32,114,101,99,116,46,120,32,43,32,114,101,99,116,46,119,105,100,116,104,32,62,61,32,40,105,110,116,41,40,114,101,99,116,46,119,105,100,116,104,32,62,32,48,41,32,38,38,32,114,101,99,116,46,121,32,43,32,114,101,99,116,46,104,101,105,103,104,116,32,62,61,32,40,105,110,116,41,40,114,101,99,116,46,104,101,105,103,104,116,32,62,32,48,41,0,99,118,83,101,116,73,109,97,103,101,67,79,73,0,99,118,71,101,116,73,109,97,103,101,67,79,73,0,66,97,100,32,105,109,97,103,101,32,104,101,97,100,101,114,0,99,118,67,108,111,110,101,73,109,97,103,101,0,84,104,101,32,108,105,98,114,97,114,121,32,105,115,32,99,111,109,112,105,108,101,100,32,119,105,116,104,111,117,116,32,67,85,68,65,32,115,117,112,112,111,114,116,0,116,104,114,111,119,95,110,111,95,99,117,100,97,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,112,114,105,118,97,116,101,46,99,117,100,97,46,104,112,112,0,40,40,40,40,99,104,97,105,110,41,45,62,102,108,97,103,115,32,38,32,40,40,40,49,32,60,60,32,50,41,32,45,32,49,41,60,60,49,50,41,32,41,32,61,61,32,40,49,32,60,60,32,49,50,41,32,38,38,32,40,99,104,97,105,110,41,45,62,101,108,101,109,95,115,105,122,101,32,61,61,32,49,41,32,38,38,32,40,40,40,99,104,97,105,110,41,45,62,102,108,97,103,115,32,38,32,40,49,32,60,60,32,40,50,32,43,32,49,50,41,41,41,32,33,61,32,48,41,41,0,105,99,118,65,112,112,114,111,120,105,109,97,116,101,67,104,97,105,110,84,67,56,57,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,97,112,112,114,111,120,46,99,112,112,0,104,101,97,100,101,114,95,115,105,122,101,32,62,61,32,40,105,110,116,41,115,105,122,101,111,102,40,67,118,67,111,110,116,111,117,114,41,0,110,112,111,105,110,116,115,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,52,32,124,124,32,100,101,112,116,104,32,61,61,32,53,41,0,97,112,112,114,111,120,80,111,108,121,68,80,0,118,111,105,100,32,99,118,58,58,97,112,112,114,111,120,80,111,108,121,68,80,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,98,111,111,108,41,0,95,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,48,0,67,97,110,110,121,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,97,110,110,121,46,99,112,112,0,40,95,100,115,116,46,103,101,116,79,98,106,40,41,32,33,61,32,95,115,114,99,46,103,101,116,79,98,106,40,41,32,124,124,32,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,41,32,38,38,32,34,73,110,112,108,97,99,101,32,112,97,114,97,109,101,116,101,114,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,34,0,65,112,101,114,116,117,114,101,32,115,105,122,101,32,115,104,111,117,108,100,32,98,101,32,111,100,100,32,98,101,116,119,101,101,110,32,51,32,97,110,100,32,55,0,78,50,99,118,57,102,105,110,97,108,80,97,115,115,69,0,102,105,110,97,108,80,97,115,115,0,103,108,111,98,97,108,95,104,121,115,116,101,114,101,115,105,115,0,104,121,115,116,101,114,101,115,105,115,0,109,97,103,110,105,116,117,100,101,0,103,114,97,100,105,101,110,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,112,97,114,97,108,108,101,108,67,97,110,110,121,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,0,78,50,99,118,49,51,112,97,114,97,108,108,101,108,67,97,110,110,121,69,0,118,111,105,100,32,99,118,58,58,67,97,110,110,121,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,98,111,111,108,41,0,95,100,120,46,100,105,109,115,40,41,32,61],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+194572);allocate([61,32,50,0,95,100,120,46,116,121,112,101,40,41,32,61,61,32,40,40,40,51,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,95,100,120,46,116,121,112,101,40,41,32,61,61,32,40,40,40,51,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,51,41,45,49,41,32,60,60,32,51,41,41,0,95,100,121,46,116,121,112,101,40,41,32,61,61,32,95,100,120,46,116,121,112,101,40,41,0,95,100,120,46,115,97,109,101,83,105,122,101,40,95,100,121,41,0,118,111,105,100,32,99,118,58,58,67,97,110,110,121,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,98,111,111,108,41,0,115,114,99,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,32,38,38,32,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,48,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,48,0,99,118,67,97,110,110,121,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,48,67,76,65,72,69,95,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,50,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,108,97,104,101,46,99,112,112,0,85,110,115,117,112,112,111,114,116,101,100,32,116,121,112,101,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,67,76,65,72,69,95,73,110,116,101,114,112,111,108,97,116,105,111,110,95,66,111,100,121,73,116,76,105,48,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,67,76,65,72,69,95,73,110,116,101,114,112,111,108,97,116,105,111,110,95,66,111,100,121,73,116,76,105,48,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,67,76,65,72,69,95,73,110,116,101,114,112,111,108,97,116,105,111,110,95,66,111,100,121,73,104,76,105,48,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,67,76,65,72,69,95,73,110,116,101,114,112,111,108,97,116,105,111,110,95,66,111,100,121,73,104,76,105,48,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,56,67,76,65,72,69,95,67,97,108,99,76,117,116,95,66,111,100,121,73,116,76,105,54,53,53,51,54,69,76,105,48,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,56,67,76,65,72,69,95,67,97,108,99,76,117,116,95,66,111,100,121,73,116,76,105,54,53,53,51,54,69,76,105,48,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,56,67,76,65,72,69,95,67,97,108,99,76,117,116,95,66,111,100,121,73,104,76,105,50,53,54,69,76,105,48,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,56,67,76,65,72,69,95,67,97,108,99,76,117,116,95,66,111,100,121,73,104,76,105,50,53,54,69,76,105,48,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,40,97,110,111,110,121,109,111,117,115,32,110,97,109,101,115,112,97,99,101,41,58,58,67,76,65,72,69,95,73,109,112,108,58,58,97,112,112,108,121,40,99,118,58,58,73,110,112,117,116,65,114,114,97,121,44,32,99,118,58,58,79,117,116,112,117,116,65,114,114,97,121,41,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,48,67,76,65,72,69,95,73,109,112,108,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,82,71,66,60,102,108,111,97,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,82,71,66,60,102,108,111,97,116,62,93,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,108,111,114,46,99,112,112,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,55,82,71,66,50,82,71,66,73,102,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,82,71,66,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,82,71,66,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,55,82,71,66,50,82,71,66,73,116,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,82,71,66,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,82,71,66,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,55,82,71,66,50,82,71,66,73,104,69,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,66,71,82,116,111,66,71,82,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,82,71,66,53,120,53,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,82,71,66,53,120,53,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,48,82,71,66,50,82,71,66,53,120,53,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,66,71,82,116,111,66,71,82,53,120,53,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,105,110,116,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,53,120,53,50,82,71,66,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,53,120,53,50,82,71,66,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,48,82,71,66,53,120,53,50,82,71,66,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,66,71,82,53,120,53,116,111,66,71,82,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,105,110,116,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,71,114,97,121,60,102,108,111,97,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,71,114,97,121,60,102,108,111,97,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,82,71,66,50,71,114,97,121,73,102,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,71,114,97,121,60,117,115,104,111,114,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,71,114,97,121,60,117,115,104,111,114,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,82,71,66,50,71,114,97,121,73,116,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,71,114,97,121,60,117,99,104,97,114,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,71,114,97,121,60,117,99,104,97,114,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,82,71,66,50,71,114,97,121,73,104,69,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,66,71,82,116,111,71,114,97,121,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,71,114,97,121,50,82,71,66,60,102,108,111,97,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,71,114,97,121,50,82,71,66,60,102,108,111,97,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,71,114,97,121,50,82,71,66,73,102,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,71,114,97,121,50,82,71,66,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,71,114,97,121,50,82,71,66,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,71,114,97,121,50,82,71,66,73,116,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,71,114,97,121,50,82,71,66,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,71,114,97,121,50,82,71,66,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,71,114,97,121,50,82,71,66,73,104,69,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,71,114,97,121,116,111,66,71,82,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,53,120,53,50,71,114,97,121,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,53,120,53,50,71,114,97,121,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,82,71,66,53,120,53,50,71,114,97,121,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,66,71,82,53,120,53,116,111,71,114,97,121,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,71,114,97,121,50,82,71,66,53,120,53,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,71,114,97,121,50,82,71,66,53,120,53,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,71,114,97,121,50,82,71,66,53,120,53,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,71,114,97,121,116,111,66,71,82,53,120,53,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,89,67,114,67,98,95,102,60,102,108,111,97,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,89,67,114,67,98,95,102,60,102,108,111,97,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,82,71,66,50,89,67,114,67,98,95,102,73,102,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,89,67,114,67,98,95,105,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,89,67,114,67,98,95,105,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,82,71,66,50,89,67,114,67,98,95,105,73,116,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,89,67,114,67,98,95,105,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,89,67,114,67,98,95,105,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,82,71,66,50,89,67,114,67,98,95,105,73,104,69,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,66,71,82,116,111,89,85,86,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,98,111,111,108,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,89,67,114,67,98,50,82,71,66,95,102,60,102,108,111,97,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,89,67,114,67,98,50,82,71,66,95,102,60,102,108,111,97,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,89,67,114,67,98,50,82,71,66,95,102,73,102,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,89,67,114,67,98,50,82,71,66,95,105,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,89,67,114,67,98,50,82,71,66,95,105,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,89,67,114,67,98,50,82,71,66,95,105,73,116,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,89,67,114,67,98,50,82,71,66,95,105,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,89,67,114,67,98,50,82,71,66,95,105,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,89,67,114,67,98,50,82,71,66,95,105,73,104,69,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,89,85,86,116,111,66,71,82,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,98,111,111,108,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,88,89,90,95,102,60,102,108,111,97,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,88,89,90,95,102,60,102,108,111,97,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,88,89,90,95,102,73,102,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,88,89,90,95,105,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,88,89,90,95,105,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,88,89,90,95,105,73,116,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,88,89,90,95,105,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,88,89,90,95,105,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,88,89,90,95,105,73,104,69,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,66,71,82,116,111,88,89,90,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,88,89,90,50,82,71,66,95,102,60,102,108,111,97,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,88,89,90,50,82,71,66,95,102,60,102,108,111,97,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,88,89,90,50,82,71,66,95,102,73,102,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,88,89,90,50,82,71,66,95,105,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,88,89,90,50,82,71,66,95,105,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,88,89,90,50,82,71,66,95,105,73,116,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,88,89,90,50,82,71,66,95,105,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,88,89,90,50,82,71,66,95,105,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,88,89,90,50,82,71,66,95,105,73,104,69,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,88,89,90,116,111,66,71,82,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,41,0,104,114,97,110,103,101,32,61,61,32,49,56,48,32,124,124,32,104,114,97,110,103,101,32,61,61,32,50,53,54,0,82,71,66,50,72,83,86,95,98,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,72,76,83,95,102,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,72,76,83,95,102,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,72,76,83,95,102,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,72,76,83,95,98,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,72,76,83,95,98,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,72,76,83,95,98,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,72,83,86,95,102,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,72,83,86,95,102,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,72,83,86,95,102,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,72,83,86,95,98,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,72,83,86,95,98,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,72,83,86,95,98,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,66,71,82,116,111,72,83,86,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,98,111,111,108,44,32,98,111,111,108,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,72,76,83,50,82,71,66,95,102,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,72,76,83,50,82,71,66,95,102,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,72,76,83,50,82,71,66,95,102,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,72,76,83,50,82,71,66,95,98,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,72,76,83,50,82,71,66,95,98,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,72,76,83,50,82,71,66,95,98,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,72,83,86,50,82,71,66,95,102,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,72,83,86,50,82,71,66,95,102,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,72,83,86,50,82,71,66,95,102,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,72,83,86,50,82,71,66,95,98,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,72,83,86,50,82,71,66,95,98,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,72,83,86,50,82,71,66,95,98,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,72,83,86,116,111,66,71,82,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,98,111,111,108,44,32,98,111,111,108,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,76,117,118,95,102,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,76,117,118,95,102,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,76,117,118,95,102,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,76,117,118,95,98,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,76,117,118,95,98,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,76,117,118,95,98,69,69,69,0,99,111,101,102,102,115,91,105,42,51,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,43,49,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,43,50,93,32,62,61,32,48,32,38,38,32,115,111,102,116,102,108,111,97,116,40,99,111,101,102,102,115,91,105,42,51,93,41,32,43,32,115,111,102,116,102,108,111,97,116,40,99,111,101,102,102,115,91,105,42,51,43,49,93,41,32,43,32,115,111,102,116,102,108,111,97,116,40,99,111,101,102,102,115,91,105,42,51,43,50,93,41,32,60,32,115,111,102,116,102,108,111,97,116,40,49,46,53,102,41,0,82,71,66,50,76,117,118,102,108,111,97,116,0,119,104,105,116,101,80,116,91,49,93,32,61,61,32,115,111,102,116,100,111,117,98,108,101,58,58,111,110,101,40,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,76,97,98,95,102,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,76,97,98,95,102,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,76,97,98,95,102,69,69,69,0,99,91,48,93,32,62,61,32,48,32,38,38,32,99,91,49,93,32,62,61,32,48,32,38,38,32,99,91,50,93,32,62,61,32,48,32,38,38,32,99,91,48,93,32,43,32,99,91,49,93,32,43,32,99,91,50,93,32,60,32,115,111,102,116,102,108,111,97,116,40,40,105,110,116,41,76,65,66,95,67,66,82,84,95,84,65,66,95,83,73,90,69,41,0,82,71,66,50,76,97,98,95,102,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,76,97,98,95,98,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,76,97,98,95,98,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,76,97,98,95,98,69,69,69,0,99,111,101,102,102,115,91,105,42,51,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,43,49,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,43,50,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,93,32,43,32,99,111,101,102,102,115,91,105,42,51,43,49,93,32,43,32,99,111,101,102,102,115,91,105,42,51,43,50,93,32,60,32,50,42,40,49,32,60,60,32,120,121,122,95,115,104,105,102,116,41,0,82,71,66,50,76,97,98,95,98,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,66,71,82,116,111,76,97,98,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,98,111,111,108,44,32,98,111,111,108,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,76,117,118,50,82,71,66,95,102,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,76,117,118,50,82,71,66,95,102,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,76,117,118,50,82,71,66,95,102,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,76,117,118,50,82,71,66,95,98,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,76,117,118,50,82,71,66,95,98,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,76,117,118,50,82,71,66,95,98,69,69,69,0,76,117,118,50,82,71,66,102,108,111,97,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,76,97,98,50,82,71,66,95,102,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,76,97,98,50,82,71,66,95,102,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,76,97,98,50,82,71,66,95,102,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,76,97,98,50,82,71,66,95,98,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,76,97,98,50,82,71,66,95,98,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,76,97,98,50,82,71,66,95,98,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,76,97,98,116,111,66,71,82,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+204812);allocate([99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,98,111,111,108,44,32,98,111,111,108,41,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,99,111,108,111,114,32,99,111,110,118,101,114,115,105,111,110,32,99,111,100,101,0,99,118,116,84,119,111,80,108,97,110,101,89,85,86,116,111,66,71,82,0,78,50,99,118,50,52,89,85,86,52,50,48,115,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,69,69,0,78,50,99,118,50,52,89,85,86,52,50,48,115,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,69,69,0,78,50,99,118,50,52,89,85,86,52,50,48,115,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,52,89,85,86,52,50,48,115,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,69,69,0,78,50,99,118,50,50,89,85,86,52,50,48,115,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,69,69,0,78,50,99,118,50,50,89,85,86,52,50,48,115,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,69,69,0,78,50,99,118,50,50,89,85,86,52,50,48,115,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,50,89,85,86,52,50,48,115,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,84,119,111,80,108,97,110,101,89,85,86,116,111,66,71,82,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,105,110,116,41,0,99,118,116,84,104,114,101,101,80,108,97,110,101,89,85,86,116,111,66,71,82,0,78,50,99,118,50,51,89,85,86,52,50,48,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,48,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,48,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,48,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,84,104,114,101,101,80,108,97,110,101,89,85,86,116,111,66,71,82,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,105,110,116,41,0,99,118,116,66,71,82,116,111,84,104,114,101,101,80,108,97,110,101,89,85,86,0,78,50,99,118,50,50,82,71,66,56,56,56,116,111,89,85,86,52,50,48,112,73,110,118,111,107,101,114,73,76,105,50,69,76,105,50,69,69,69,0,78,50,99,118,50,50,82,71,66,56,56,56,116,111,89,85,86,52,50,48,112,73,110,118,111,107,101,114,73,76,105,48,69,76,105,50,69,69,69,0,78,50,99,118,50,50,82,71,66,56,56,56,116,111,89,85,86,52,50,48,112,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,69,69,0,78,50,99,118,50,50,82,71,66,56,56,56,116,111,89,85,86,52,50,48,112,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,66,71,82,116,111,84,104,114,101,101,80,108,97,110,101,89,85,86,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,105,110,116,41,0,99,118,116,79,110,101,80,108,97,110,101,89,85,86,116,111,66,71,82,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,76,105,48,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,76,105,48,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,76,105,48,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,76,105,48,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,79,110,101,80,108,97,110,101,89,85,86,116,111,66,71,82,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,105,110,116,44,32,105,110,116,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,65,50,109,82,71,66,65,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,65,50,109,82,71,66,65,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,48,82,71,66,65,50,109,82,71,66,65,73,104,69,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,82,71,66,65,116,111,77,117,108,116,105,112,108,105,101,100,82,71,66,65,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,109,82,71,66,65,50,82,71,66,65,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,109,82,71,66,65,50,82,71,66,65,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,48,109,82,71,66,65,50,82,71,66,65,73,104,69,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,77,117,108,116,105,112,108,105,101,100,82,71,66,65,116,111,82,71,66,65,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,41,0,100,101,112,116,104,32,61,61,32,48,32,124,124,32,100,101,112,116,104,32,61,61,32,50,32,124,124,32,100,101,112,116,104,32,61,61,32,53,0,99,118,116,67,111,108,111,114,0,115,99,110,32,61,61,32,51,32,124,124,32,115,99,110,32,61,61,32,52,0,40,115,99,110,32,61,61,32,51,32,124,124,32,115,99,110,32,61,61,32,52,41,32,38,38,32,100,101,112,116,104,32,61,61,32,48,0,40,100,99,110,32,61,61,32,51,32,124,124,32,100,99,110,32,61,61,32,52,41,32,38,38,32,115,99,110,32,61,61,32,50,32,38,38,32,100,101,112,116,104,32,61,61,32,48,0,115,99,110,32,61,61,32,50,32,38,38,32,100,101,112,116,104,32,61,61,32,48,0,115,99,110,32,61,61,32,49,32,38,38,32,100,101,112,116,104,32,61,61,32,48,0,115,99,110,32,61,61,32,51,32,38,38,32,40,100,99,110,32,61,61,32,51,32,124,124,32,100,99,110,32,61,61,32,52,41,0,40,115,99,110,32,61,61,32,51,32,124,124,32,115,99,110,32,61,61,32,52,41,32,38,38,32,40,100,101,112,116,104,32,61,61,32,48,32,124,124,32,100,101,112,116,104,32,61,61,32,53,41,0,115,99,110,32,61,61,32,51,32,38,38,32,40,100,99,110,32,61,61,32,51,32,124,124,32,100,99,110,32,61,61,32,52,41,32,38,38,32,40,100,101,112,116,104,32,61,61,32,48,32,124,124,32,100,101,112,116,104,32,61,61,32,53,41,0,100,99,110,32,61,61,32,51,32,124,124,32,100,99,110,32,61,61,32,52,0,115,122,46,119,105,100,116,104,32,37,32,50,32,61,61,32,48,32,38,38,32,115,122,46,104,101,105,103,104,116,32,37,32,51,32,61,61,32,48,32,38,38,32,100,101,112,116,104,32,61,61,32,48,0,115,122,46,119,105,100,116,104,32,37,32,50,32,61,61,32,48,32,38,38,32,115,122,46,104,101,105,103,104,116,32,37,32,50,32,61,61,32,48,0,115,99,110,32,61,61,32,52,32,38,38,32,100,99,110,32,61,61,32,52,32,38,38,32,100,101,112,116,104,32,61,61,32,48,0,118,111,105,100,32,99,118,58,58,99,118,116,67,111,108,111,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,41,0,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,100,115,116,46,100,101,112,116,104,40,41,0,99,118,67,118,116,67,111,108,111,114,0,100,115,116,46,100,97,116,97,32,61,61,32,100,115,116,48,46,100,97,116,97,0,116,104,101,32,116,121,112,101,32,111,102,32,108,97,98,101,108,115,32,109,117,115,116,32,98,101,32,49,54,117,32,111,114,32,51,50,115,0,99,111,110,110,101,99,116,101,100,67,111,109,112,111,110,101,110,116,115,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,46,99,112,112,0,76,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,73,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,99,111,110,110,101,99,116,101,100,67,111,109,112,111,110,101,110,116,115,95,115,117,98,49,0,99,99,108,116,121,112,101,32,61,61,32,67,67,76,95,71,82,65,78,65,32,124,124,32,99,99,108,116,121,112,101,32,61,61,32,67,67,76,95,87,85,32,124,124,32,99,99,108,116,121,112,101,32,61,61,32,67,67,76,95,68,69,70,65,85,76,84,0,105,68,101,112,116,104,32,61,61,32,48,32,124,124,32,105,68,101,112,116,104,32,61,61,32,49,0,117,110,115,117,112,112,111,114,116,101,100,32,108,97,98,101,108,47,105,109,97,103,101,32,116,121,112,101,0,105,109,103,46,114,111,119,115,32,61,61,32,105,109,103,76,97,98,101,108,115,46,114,111,119,115,0,105,109,103,46,99,111,108,115,32,61,61,32,105,109,103,76,97,98,101,108,115,46,99,111,108,115,0,99,111,110,110,101,99,116,105,118,105,116,121,32,61,61,32,56,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,50,49,76,97,98,101,108,105,110,103,71,114,97,110,97,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,52,78,111,79,112,69,69,49,48,83,101,99,111,110,100,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,50,49,76,97,98,101,108,105,110,103,71,114,97,110,97,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,52,78,111,79,112,69,69,57,70,105,114,115,116,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,52,78,111,79,112,69,69,49,48,83,101,99,111,110,100,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,52,78,111,79,112,69,69,50,50,70,105,114,115,116,83,99,97,110,52,67,111,110,110,101,99,116,105,118,105,116,121,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,52,78,111,79,112,69,69,50,50,70,105,114,115,116,83,99,97,110,56,67,111,110,110,101,99,116,105,118,105,116,121,69,0,105,109,103,76,97,98,101,108,115,46,114,111,119,115,32,61,61,32,105,109,103,46,114,111,119,115,0,105,109,103,76,97,98,101,108,115,46,99,111,108,115,32,61,61,32,105,109,103,46,99,111,108,115,0,99,111,110,110,101,99,116,101,100,67,111,109,112,111,110,101,110,116,115,87,105,116,104,83,116,97,116,115,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,50,49,76,97,98,101,108,105,110,103,71,114,97,110,97,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,57,67,67,83,116,97,116,115,79,112,69,69,49,48,83,101,99,111,110,100,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,50,49,76,97,98,101,108,105,110,103,71,114,97,110,97,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,57,67,67,83,116,97,116,115,79,112,69,69,57,70,105,114,115,116,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,57,67,67,83,116,97,116,115,79,112,69,69,49,48,83,101,99,111,110,100,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,57,67,67,83,116,97,116,115,79,112,69,69,50,50,70,105,114,115,116,83,99,97,110,52,67,111,110,110,101,99,116,105,118,105,116,121,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,57,67,67,83,116,97,116,115,79,112,69,69,50,50,70,105,114,115,116,83,99,97,110,56,67,111,110,110,101,99,116,105,118,105,116,121,69,0,99,118,83,116,97,114,116,82,101,97,100,67,104,97,105,110,80,111,105,110,116,115,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,110,116,111,117,114,115,46,99,112,112,0,99,118,83,116,97,114,116,70,105,110,100,67,111,110,116,111,117,114,115,95,73,109,112,108,0,91,83,116,97,114,116,93,70,105,110,100,67,111,110,116,111,117,114,115,32,115,117,112,112,111,114,116,115,32,111,110,108,121,32,67,86,95,56,85,67,49,32,105,109,97,103,101,115,32,119,104,101,110,32,109,111,100,101,32,33,61,32,67,86,95,82,69,84,82,95,70,76,79,79,68,70,73,76,76,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,111,114,116,115,32,67,86,95,51,50,83,67,49,32,105,109,97,103,101,115,32,111,110,108,121,0,115,116,101,112,32,62,61,32,48,0,115,105,122,101,46,104,101,105,103,104,116,32,62,61,32,49,0,99,118,70,105,110,100,78,101,120,116,67,111,110,116,111,117,114,0,115,99,97,110,110,101,114,45,62,105,109,103,95,115,116,101,112,32,62,61,32,48,0,112,116,114,32,33,61,32,48,76,0,105,99,118,84,114,97,99,101,67,111,110,116,111,117,114,95,51,50,115,0,105,99,118,84,114,97,99,101,67,111,110,116,111,117,114,0,112,97,114,95,105,110,102,111,32,33,61,32,48,0,105,99,118,70,101,116,99,104,67,111,110,116,111,117,114,0,105,99,118,70,101,116,99,104,67,111,110,116,111,117,114,69,120,95,51,50,115,0,105,99,118,70,101,116,99,104,67,111,110,116,111,117,114,69,120,0,99,118,69,110,100,70,105,110,100,67,111,110,116,111,117,114,115,0,78,85,76,76,32,100,111,117,98,108,101,32,67,118,83,101,113,32,112,111,105,110,116,101,114,0,99,118,70,105,110,100,67,111,110,116,111,117,114,115,95,73,109,112,108,0,78,111,110,122,101,114,111,32,111,102,102,115,101,116,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,67,86,95,76,73,78,75,95,82,85,78,83,32,121,101,116,0,78,85,76,76,32,115,116,111,114,97,103,101,32,112,111,105,110,116,101,114,0,105,99,118,70,105,110,100,67,111,110,116,111,117,114,115,73,110,73,110,116,101,114,118,97,108,0,67,111,110,116,111,117,114,32,104,101,97,100,101,114,32,115,105,122,101,32,109,117,115,116,32,98,101,32,62,61,32,115,105,122,101,111,102,40,67,118,67,111,110,116,111,117,114,41,0,73,110,112,117,116,32,97,114,114,97,121,32,109,117,115,116,32,98,101,32,56,117,67,49,32,111,114,32,56,115,67,49,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,49,50,67,118,77,101,109,83,116,111,114,97,103,101,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,40,95,99,111,110,116,111,117,114,115,46,107,105,110,100,40,41,32,61,61,32,95,73,110,112,117,116,65,114,114,97,121,58,58,83,84,68,95,86,69,67,84,79,82,95,86,69,67,84,79,82,32,124,124,32,95,99,111,110,116,111,117,114,115,46,107,105,110,100,40,41,32,61,61,32,95,73,110,112,117,116,65,114,114,97,121,58,58,83,84,68,95,86,69,67,84,79,82,95,77,65,84,32,124,124,32,95,99,111,110,116,111,117,114,115,46,107,105,110,100,40,41,32,61,61,32,95,73,110,112,117,116,65,114,114,97,121,58,58,83,84,68,95,86,69,67,84,79,82,95,85,77,65,84,41,0,102,105,110,100,67,111,110,116,111,117,114,115,0,95,99,111,110,116,111,117,114,115,46,101,109,112,116,121,40,41,32,124,124,32,40,95,99,111,110,116,111,117,114,115,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,50,32,38,38,32,95,99,111,110,116,111,117,114,115,46,100,101,112,116,104,40,41,32,61,61,32,52,41,0,99,105,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,118,111,105,100,32,99,118,58,58,102,105,110,100,67,111,110,116,111,117,114,115,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,80,111,105,110,116,41,0,118,111,105,100,32,99,118,58,58,102,105,110,100,67,111,110,116,111,117,114,115,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,105,110,116,44,32,105,110,116,44,32,80,111,105,110,116,41,0,95,112,111,105,110,116,115,46,103,101,116,79,98,106,40,41,32,33,61,32,95,104,117,108,108,46,103,101,116,79,98,106,40,41,0,99,111,110,118,101,120,72,117,108,108,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,110,118,104,117,108,108,46,99,112,112,0,116,111,116,97,108,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,53,32,124,124,32,100,101,112,116,104,32,61,61,32,52,41,0,112,111,105,110,116,115,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,118,111,105,100,32,99,118,58,58,99,111,110,118,101,120,72,117,108,108,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,98,111,111,108,44,32,98,111,111,108,41,0,110,112,111,105,110,116,115,32,62,61,32,48,0,99,111,110,118,101,120,105,116,121,68,101,102,101,99,116,115,0,104,112,111,105,110,116,115,32,62,32,48,0,48,32,60,61,32,104,99,117,114,114,32,38,38,32,104,99,117,114,114,32,60,32,110,112,111,105,110,116,115,0,48,32,60,61,32,104,110,101,120,116,32,38,38,32,104,110,101,120,116,32,60,32,110,112,111,105,110,116,115,0,118,111,105,100,32,99,118,58,58,99,111,110,118,101,120,105,116,121,68,101,102,101,99,116,115,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,105,115,67,111,110,116,111,117,114,67,111,110,118,101,120,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,99,111,114,110,101,114,69,105,103,101,110,86,97,108,115,86,101,99,115,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,114,110,101,114,46,99,112,112,0,118,111,105,100,32,99,118,58,58,99,111,114,110,101,114,77,105,110,69,105,103,101,110,86,97,108,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,99,111,114,110,101,114,72,97,114,114,105,115,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,100,101,112,116,104,32,61,61,32,48,32,124,124,32,100,101,112,116,104,32,61,61,32,50,0,100,101,109,111,115,97,105,99,105,110,103,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,100,101,109,111,115,97,105,99,105,110,103,46,99,112,112,0,115,99,110,32,61,61,32,49,32,38,38,32,100,99,110,32,61,61,32,49,0,66,97,121,101,114,45,62,71,114,97,121,32,100,101,109,111,115,97,105,99,105,110,103,32,111,110,108,121,32,115,117,112,112,111,114,116,115,32,56,117,32,97,110,100,32,49,54,117,32,116,121,112,101,115,0,115,99,110,32,61,61,32,49,32,38,38,32,40,100,99,110,32,61,61,32,51,32,124,124,32,100,99,110,32,61,61,32,52,41,0,66,97,121,101,114,45,62,82,71,66,32,100,101,109,111,115,97,105,99,105,110,103,32,111,110,108,121,32,115,117,112,112,111,114,116,115,32,56,117,32,97,110,100,32,49,54,117,32,116,121,112,101,115,0,115,99,110,32,61,61,32,49,32,38,38,32,100,99,110,32,61,61,32,51,0,66,97,121,101,114,45,62,82,71,66,32,69,100,103,101,45,65,119,97,114,101,32,100,101,109,111,115,97,105,99,105,110,103,32,111,110,108,121,32,99,117,114,114,101,110,116,108,121,32,115,117,112,112,111,114,116,115,32,56,117,32,97,110,100,32,49,54,117,32,116,121,112,101,115,0,85,110,107,110,111,119,110,32,47,32,117,110,115,117,112,112,111,114,116,101,100,32,99,111,108,111,114,32,99,111,110,118,101,114,115,105,111,110,32,99,111,100,101,0,78,50,99,118,50,57,66,97,121,101,114,50,82,71,66,95,69,100,103,101,65,119,97,114,101,95,84,95,73,110,118,111,107,101,114,73,116,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,116,69,69,69,69,0,78,50,99,118,50,57,66,97,121,101,114,50,82,71,66,95,69,100,103,101,65,119,97,114,101,95,84,95,73,110,118,111,107,101,114,73,104,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,104,69,69,69,69,0,78,50,99,118,49,55,66,97,121,101,114,50,82,71,66,95,73,110,118,111,107,101,114,73,116,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,116,69,69,69,69,0,78,50,99,118,49,55,66,97,121,101,114,50,82,71,66,95,73,110,118,111,107,101,114,73,104,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,104,69,69,69,69,0,78,50,99,118,49,56,66,97,121,101,114,50,71,114,97,121,95,73,110,118,111,107,101,114,73,116,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,116,69,69,69,69,0,78,50,99,118,49,56,66,97,121,101,114,50,71,114,97,121,95,73,110,118,111,107,101,114,73,104,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,104,69,69,69,69,0,118,111,105,100,32,99,118,58,58,100,101,109,111,115,97,105,99,105,110,103,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,41,0,103,101,116,83,111,98,101,108,75,101,114,110,101,108,115,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,100,101,114,105,118,46,99,112,112,0,84,104,101,32,107,101,114,110,101,108,32,115,105,122,101,32,109,117,115,116,32,98,101,32,111,100,100,32,97,110,100,32,110,111,116,32,108,97,114,103,101,114,32,116,104,97,110,32,51,49,0,100,120,32,62,61,32,48,32,38,38,32,100,121,32,62,61,32,48,32,38,38,32,100,120,43,100,121,32,62,32,48,0,107,115,105,122,101,32,62,32,111,114,100,101,114,0,103,101,116,83,99,104,97,114,114,75,101,114,110,101,108,115,0,100,120,32,62,61,32,48,32,38,38,32,100,121,32,62,61,32,48,32,38,38,32,100,120,43,100,121,32,61,61,32,49,0,118,111,105,100,32,99,118,58,58,83,111,98,101,108,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,83,99,104,97,114,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,76,97,112,108,97,99,105,97,110,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,115,114,99,46,115,105,122,101,40,41,32,61,61,32,100,115,116,46,115,105,122,101,40,41,32,38,38,32,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,100,115,116,46,99,104,97,110,110,101,108,115,40,41,0,99,118,83,111,98,101,108,0,100,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,100,105,115,116,114,97,110,115,102,111,114,109,46,99,112,112,0,108,97,98,101,108,84,121,112,101,32,61,61,32,68,73,83,84,95,76,65,66,69,76,95,80,73,88,69,76,32,124,124,32,108,97,98,101,108,84,121,112,101,32,61,61,32,68,73,83,84,95,76,65,66,69,76,95,67,67,79,77,80,0,77,97,115,107,32,115,105,122,101,32,115,104,111,117,108,100,32,98,101,32,51,32,111,114,32,53,32,111,114,32,48,32,40,112,114,101,99,105,115,101,41,0,116,114,117,101,68,105,115,116,84,114,97,110,115,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,100,105,115,116,84,121,112,101,32,61,61,32,67,86,95,68,73,83,84,95,67,32,124,124,32,100,105,115,116,84,121,112,101,32,61,61,32,67,86,95,68,73,83,84,95,76,49,32,124,124,32,100,105,115,116,84,121,112,101,32,61,61,32,67,86,95,68,73,83,84,95,76,50,0,85,110,107,110,111,119,110,32,109,101,116,114,105,99,32,116,121,112,101,0,103,101,116,68,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,77,97,115,107,0,78,50,99,118,49,50,68,84,82,111,119,73,110,118,111,107,101,114,69,0,78,50,99,118,49,53,68,84,67,111,108,117,109,110,73,110,118,111,107,101,114,69,0,118,111,105,100,32,99,118,58,58,100,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,100,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,95,76,49,95,56,85,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,100,105,115,116,97,110,99,101,65,84,83,95,76,49,95,56,117,0,118,111,105,100,32,99,118,58,58,100,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,95,76,49,95,56,85,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,100,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,98,111,111,108,32,99,118,58,58,99,108,105,112,76,105,110,101,40,83,105,122,101,50,108,44,32,80,111,105,110,116,50,108,32,38,44,32,80,111,105,110,116,50,108,32,38,41,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,100,114,97,119,105,110,103,46,99,112,112,0,99,111,110,110,101,99,116,105,118,105,116,121,32,61,61,32,56,32,124,124,32,99,111,110,110,101,99,116,105,118,105,116,121,32,61,61,32,52,0,76,105,110,101,73,116,101,114,97,116,111,114,0,118,111,105,100,32,99,118,58,58,101,108,108,105,112,115,101,50,80,111,108,121,40,80,111,105,110,116,50,100,44,32,83,105,122,101,50,100,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,115,116,100,58,58,118,101,99,116,111,114,60,80,111,105,110,116,50,100,62,32,38,41,0,48,32,60,61,32,116,104,105,99,107,110,101,115,115,32,38,38,32,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,0,108,105,110,101,0,48,32,60,61,32,115,104,105,102,116,32,38,38,32,115,104,105,102,116,32,60,61,32,88,89,95,83,72,73,70,84,0,48,32,60,61,32,115,104,105,102,116,32,38,38,32,115,104,105,102,116,32,60,61,32,88,89,95,83,72,73,70,84,32,38,38,32,116,104,105,99,107,110,101,115,115,32,62,61,32,48,0,80,111,108,121,76,105,110,101,0,181,181,181,182,182,183,184,185,187,188,190,192,194,196,198,201,203,206,209,211,214,218,221,224,227,231,235,238,242,246,250,254,118,111,105,100,32,99,118,58,58,108,105,110,101,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,44,32,80,111,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,0,114,101,99,116,97,110,103,108,101,0,118,111,105,100,32,99,118,58,58,114,101,99,116,97,110,103,108,101,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,44,32,80,111,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,114,97,100,105,117,115,32,62,61,32,48,32,38,38,32,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,32,38,38,32,48,32,60,61,32,115,104,105,102,116,32,38,38,32,115,104,105,102,116,32,60,61,32,88,89,95,83,72,73,70,84,0,99,105,114,99,108,101,0,118,111,105,100,32,99,118,58,58,99,105,114,99,108,101,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,44,32,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,97,120,101,115,46,119,105,100,116,104,32,62,61,32,48,32,38,38,32,97,120,101,115,46,104,101,105,103,104,116,32,62,61,32,48,32,38,38,32,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,32,38,38,32,48,32,60,61,32,115,104,105,102,116,32,38,38,32,115,104,105,102,116,32,60,61,32,88,89,95,83,72,73,70,84,0,101,108,108,105,112,115,101,0,118,111,105,100,32,99,118,58,58,101,108,108,105,112,115,101,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,44,32,83,105,122,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,98,111,120,46,115,105,122,101,46,119,105,100,116,104,32,62,61,32,48,32,38,38,32,98,111,120,46,115,105,122,101,46,104,101,105,103,104,116,32,62,61,32,48,32,38,38,32,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,0,118,111,105,100,32,99,118,58,58,101,108,108,105,112,115,101,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,99,111,110,115,116,32,99,118,58,58,82,111,116,97,116,101,100,82,101,99,116,32,38,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,105,110,116,44,32,105,110,116,41,0,85,110,107,110,111,119,110,32,102,111,110,116,32,116,121,112,101,0,103,101,116,70,111,110,116,68,97,116,97,0,118,111,105,100,32,99,118,58,58,112,117,116,84,101,120,116,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,99,111,110,115,116,32,99,118,58,58,83,116,114,105,110,103,32,38,44,32,80,111,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,83,99,97,108,97,114,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,41,0,48,32,60,61,32,99,111,110,116,111,117,114,73,100,120,32,38,38,32,99,111,110,116,111,117,114,73,100,120,32,60,32,40,105,110,116,41,108,97,115,116,0,100,114,97,119,67,111,110,116,111,117,114,115,0,110,112,111,105,110,116,115,32,62,32,48,0,104,105,101,114,97,114,99,104,121,46,116,111,116,97,108,40,41,32,61,61,32,110,99,111,110,116,111,117,114,115,32,38,38,32,104,105,101,114,97,114,99,104,121,46,116,121,112,101,40,41,32,61,61,32,40,40,40,52,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,52,41,45,49,41,32,60,60,32,51,41,41,0,99,118,68,114,97,119,67,111,110,116,111,117,114,115,0,114,101,97,100,101,114,46,112,116,114,32,33,61,32,48,76,0,101,108,101,109,95,116,121,112,101,32,61,61,32,40,40,40,52,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,0,118,111,105,100,32,99,118,58,58,100,114,97,119,67,111,110,116,111,117,114,115,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,105,110,116,44,32,105,110,116,44,32,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,80,111,105,110,116,41,0,113,117,97,108,105,116,121,76,101,118,101,108,32,62,32,48,32,38,38,32,109,105,110,68,105,115,116,97,110,99,101,32,62,61,32,48,32,38,38,32,109,97,120,67,111,114,110,101,114,115,32,62,61,32,48,0,103,111,111,100,70,101,97,116,117,114,101,115,84,111,84,114,97,99,107,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,102,101,97,116,117,114,101,115,101,108,101,99,116,46,99,112,112,0,95,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,40,95,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,38,38,32,95,109,97,115,107,46,115,97,109,101,83,105,122,101,40,95,105,109,97,103,101,41,41,0,118,111,105,100,32,99,118,58,58,103,111,111,100,70,101,97,116,117,114,101,115,84,111,84,114,97,99,107,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,73,110,112,117,116,65,114,114,97,121,44,32,105],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+215052);allocate([110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,100,111,117,98,108,101,41,0,78,50,99,118,49,51,66,97,115,101,82,111,119,70,105,108,116,101,114,69,0,78,50,99,118,49,54,66,97,115,101,67,111,108,117,109,110,70,105,108,116,101,114,69,0,78,50,99,118,49,48,66,97,115,101,70,105,108,116,101,114,69,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,115,114,99,84,121,112,101,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,100,115,116,84,121,112,101,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,102,105,108,116,101,114,46,99,112,112,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,70,105,108,116,101,114,69,110,103,105,110,101,58,58,97,112,112,108,121,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,99,118,58,58,77,97,116,32,38,44,32,99,111,110,115,116,32,83,105,122,101,32,38,44,32,99,111,110,115,116,32,80,111,105,110,116,32,38,41,0,119,104,111,108,101,83,105,122,101,46,119,105,100,116,104,32,62,32,48,32,38,38,32,119,104,111,108,101,83,105,122,101,46,104,101,105,103,104,116,32,62,32,48,0,112,114,111,99,101,101,100,0,115,114,99,32,38,38,32,100,115,116,32,38,38,32,99,111,117,110,116,32,62,32,48,0,115,114,99,89,32,62,61,32,115,116,97,114,116,89,0,100,115,116,89,32,60,61,32,114,111,105,46,104,101,105,103,104,116,0,114,111,105,46,120,32,62,61,32,48,32,38,38,32,114,111,105,46,121,32,62,61,32,48,32,38,38,32,114,111,105,46,119,105,100,116,104,32,62,61,32,48,32,38,38,32,114,111,105,46,104,101,105,103,104,116,32,62,61,32,48,32,38,38,32,114,111,105,46,120,32,43,32,114,111,105,46,119,105,100,116,104,32,60,61,32,119,104,111,108,101,83,105,122,101,46,119,105,100,116,104,32,38,38,32,114,111,105,46,121,32,43,32,114,111,105,46,104,101,105,103,104,116,32,60,61,32,119,104,111,108,101,83,105,122,101,46,104,101,105,103,104,116,0,115,116,97,114,116,0,99,111,110,115,116,86,97,108,32,33,61,32,48,76,0,78,50,99,118,49,50,70,105,108,116,101,114,69,110,103,105,110,101,69,0,99,111,108,117,109,110,66,111,114,100,101,114,84,121,112,101,32,33,61,32,66,79,82,68,69,82,95,87,82,65,80,0,105,110,105,116,0,114,111,119,70,105,108,116,101,114,32,38,38,32,99,111,108,117,109,110,70,105,108,116,101,114,0,98,117,102,84,121,112,101,32,61,61,32,115,114,99,84,121,112,101,0,48,32,60,61,32,97,110,99,104,111,114,46,120,32,38,38,32,97,110,99,104,111,114,46,120,32,60,32,107,115,105,122,101,46,119,105,100,116,104,32,38,38,32,48,32,60,61,32,97,110,99,104,111,114,46,121,32,38,38,32,97,110,99,104,111,114,46,121,32,60,32,107,115,105,122,101,46,104,101,105,103,104,116,0,95,107,101,114,110,101,108,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,103,101,116,75,101,114,110,101,108,84,121,112,101,0,99,110,32,61,61,32,40,40,40,40,98,117,102,84,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,38,38,32,100,100,101,112,116,104,32,62,61,32,115,116,100,58,58,109,97,120,40,115,100,101,112,116,104,44,32,52,41,32,38,38,32,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,100,100,101,112,116,104,0,103,101,116,76,105,110,101,97,114,82,111,119,70,105,108,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,100,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,68,97,116,97,84,121,112,101,60,68,84,62,58,58,116,121,112,101,32,38,38,32,40,107,101,114,110,101,108,46,114,111,119,115,32,61,61,32,49,32,124,124,32,107,101,114,110,101,108,46,99,111,108,115,32,61,61,32,49,41,0,82,111,119,70,105,108,116,101,114,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,100,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,102,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,102,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,102,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,102,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,115,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,115,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,115,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,115,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,116,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,116,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,116,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,116,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,104,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,104,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,104,105,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,105,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,56,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,73,102,102,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,40,115,121,109,109,101,116,114,121,84,121,112,101,32,38,32,40,75,69,82,78,69,76,95,83,89,77,77,69,84,82,73,67,65,76,32,124,32,75,69,82,78,69,76,95,65,83,89,77,77,69,84,82,73,67,65,76,41,41,32,33,61,32,48,32,38,38,32,116,104,105,115,45,62,107,115,105,122,101,32,60,61,32,53,0,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,102,102,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,49,56,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,73,102,102,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,56,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,73,104,105,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,105,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,49,56,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,73,104,105,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,0,99,110,32,61,61,32,40,40,40,40,98,117,102,84,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,38,38,32,115,100,101,112,116,104,32,62,61,32,115,116,100,58,58,109,97,120,40,100,100,101,112,116,104,44,32,52,41,32,38,38,32,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,115,100,101,112,116,104,0,103,101,116,76,105,110,101,97,114,67,111,108,117,109,110,70,105,108,116,101,114,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,98,117,102,102,101,114,32,102,111,114,109,97,116,32,40,61,37,100,41,44,32,97,110,100,32,100,101,115,116,105,110,97,116,105,111,110,32,102,111,114,109,97,116,32,40,61,37,100,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,40,115,121,109,109,101,116,114,121,84,121,112,101,32,38,32,40,75,69,82,78,69,76,95,83,89,77,77,69,84,82,73,67,65,76,32,124,32,75,69,82,78,69,76,95,65,83,89,77,77,69,84,82,73,67,65,76,41,41,32,33,61,32,48,0,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,68,97,116,97,84,121,112,101,60,83,84,62,58,58,116,121,112,101,32,38,38,32,40,107,101,114,110,101,108,46,114,111,119,115,32,61,61,32,49,32,124,124,32,107,101,114,110,101,108,46,99,111,108,115,32,61,61,32,49,41,0,67,111,108,117,109,110,70,105,108,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,116,104,105,115,45,62,107,115,105,122,101,32,61,61,32,51,0,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,99,110,32,61,61,32,40,40,40,40,95,100,115,116,84,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,0,99,114,101,97,116,101,83,101,112,97,114,97,98,108,101,76,105,110,101,97,114,70,105,108,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,70,105,108,116,101,114,69,110,103,105,110,101,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,107,116,121,112,101,32,61,61,32,48,32,124,124,32,107,116,121,112,101,32,61,61,32,52,32,124,124,32,107,116,121,112,101,32,61,61,32,53,32,124,124,32,107,116,121,112,101,32,61,61,32,54,0,112,114,101,112,114,111,99,101,115,115,50,68,75,101,114,110,101,108,0,99,110,32,61,61,32,40,40,40,40,100,115,116,84,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,38,38,32,100,100,101,112,116,104,32,62,61,32,115,100,101,112,116,104,0,103,101,116,76,105,110,101,97,114,70,105,108,116,101,114,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,115,111,117,114,99,101,32,102,111,114,109,97,116,32,40,61,37,100,41,44,32,97,110,100,32,100,101,115,116,105,110,97,116,105,111,110,32,102,111,114,109,97,116,32,40,61,37,100,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,100,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,95,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,68,97,116,97,84,121,112,101,60,75,84,62,58,58,116,121,112,101,0,70,105,108,116,101,114,50,68,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,100,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,99,114,101,97,116,101,76,105,110,101,97,114,70,105,108,116,101,114,0,118,111,105,100,32,99,118,58,58,102,105,108,116,101,114,50,68,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,73,110,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,107,101,114,110,101,108,88,46,116,121,112,101,40,41,32,61,61,32,107,101,114,110,101,108,89,46,116,121,112,101,40,41,32,38,38,32,40,107,101,114,110,101,108,88,46,99,111,108,115,32,61,61,32,49,32,124,124,32,107,101,114,110,101,108,88,46,114,111,119,115,32,61,61,32,49,41,32,38,38,32,40,107,101,114,110,101,108,89,46,99,111,108,115,32,61,61,32,49,32,124,124,32,107,101,114,110,101,108,89,46,114,111,119,115,32,61,61,32,49,41,0,115,101,112,70,105,108,116,101,114,50,68,0,118,111,105,100,32,99,118,58,58,115,101,112,70,105,108,116,101,114,50,68,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,103,101,111,109,101,116,114,121,46,99,112,112,0,116,111,116,97,108,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,52,32,124,124,32,100,101,112,116,104,32,61,61,32,53,41,0,112,111,105,110,116,80,111,108,121,103,111,110,84,101,115,116,0,100,111,117,98,108,101,32,99,118,58,58,112,111,105,110,116,80,111,108,121,103,111,110,84,101,115,116,40,73,110,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,50,102,44,32,98,111,111,108,41,0,95,109,111,100,101,108,32,109,117,115,116,32,104,97,118,101,32,67,86,95,54,52,70,67,49,32,116,121,112,101,44,32,114,111,119,115,32,61,61,32,49,32,97,110,100,32,99,111,108,115,32,61,61,32,49,51,42,99,111,109,112,111,110,101,110,116,115,67,111,117,110,116,0,71,77,77,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,103,114,97,98,99,117,116,46,99,112,112,0,100,116,114,109,32,62,32,115,116,100,58,58,110,117,109,101,114,105,99,95,108,105,109,105,116,115,60,100,111,117,98,108,101,62,58,58,101,112,115,105,108,111,110,40,41,0,99,97,108,99,73,110,118,101,114,115,101,67,111,118,65,110,100,68,101,116,101,114,109,0,99,111,118,68,101,116,101,114,109,115,91,99,105,93,32,62,32,115,116,100,58,58,110,117,109,101,114,105,99,95,108,105,109,105,116,115,60,100,111,117,98,108,101,62,58,58,101,112,115,105,108,111,110,40,41,0,105,109,97,103,101,32,105,115,32,101,109,112,116,121,0,103,114,97,98,67,117,116,0,105,109,97,103,101,32,109,117,115,116,32,104,97,118,101,32,67,86,95,56,85,67,51,32,116,121,112,101,0,33,98,103,100,83,97,109,112,108,101,115,46,101,109,112,116,121],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+225292);allocate([40,41,32,38,38,32,33,102,103,100,83,97,109,112,108,101,115,46,101,109,112,116,121,40,41,0,105,110,105,116,71,77,77,115,0,105,62,61,48,32,38,38,32,105,60,40,105,110,116,41,118,116,99,115,46,115,105,122,101,40,41,0,105,110,83,111,117,114,99,101,83,101,103,109,101,110,116,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,103,99,103,114,97,112,104,46,104,112,112,0,109,105,110,87,101,105,103,104,116,32,62,32,48,0,109,97,120,70,108,111,119,0,97,100,100,69,100,103,101,115,0,106,62,61,48,32,38,38,32,106,60,40,105,110,116,41,118,116,99,115,46,115,105,122,101,40,41,0,119,62,61,48,32,38,38,32,114,101,118,119,62,61,48,0,105,32,33,61,32,106,0,97,100,100,84,101,114,109,87,101,105,103,104,116,115,0,109,97,115,107,32,105,115,32,101,109,112,116,121,0,99,104,101,99,107,77,97,115,107,0,109,97,115,107,32,109,117,115,116,32,104,97,118,101,32,67,86,95,56,85,67,49,32,116,121,112,101,0,109,97,115,107,32,109,117,115,116,32,104,97,118,101,32,97,115,32,109,97,110,121,32,114,111,119,115,32,97,110,100,32,99,111,108,115,32,97,115,32,105,109,103,0,109,97,115,107,32,101,108,101,109,101,110,116,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,101,113,117,97,108,32,71,67,95,66,71,68,32,111,114,32,71,67,95,70,71,68,32,111,114,32,71,67,95,80,82,95,66,71,68,32,111,114,32,71,67,95,80,82,95,70,71,68,0,118,111,105,100,32,99,118,58,58,103,114,97,98,67,117,116,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,82,101,99,116,44,32,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,41,0,77,87,82,77,78,86,32,82,77,86,86,32,80,83,84,83,0,77,87,79,77,79,86,32,79,77,83,77,85,78,85,80,83,81,32,79,81,83,81,85,82,85,85,83,86,79,86,0,77,88,86,78,84,77,82,77,80,78,79,80,79,83,80,85,82,86,84,86,86,85,0,77,87,79,77,79,86,32,79,77,82,77,84,78,85,80,85,83,84,85,82,86,79,86,0,77,87,79,77,79,86,32,79,77,85,77,32,79,81,83,81,32,79,86,85,86,0,77,86,79,77,79,86,32,79,77,85,77,32,79,81,83,81,0,77,88,86,78,84,77,82,77,80,78,79,80,79,83,80,85,82,86,84,86,86,85,86,82,32,83,82,86,82,0,77,87,79,77,79,86,32,85,77,85,86,32,79,81,85,81,0,80,84,82,77,82,86,0,78,85,83,77,83,84,82,86,80,86,79,84,79,83,0,77,87,79,77,79,86,32,85,77,79,83,32,81,81,85,86,0,77,86,79,77,79,86,32,79,86,85,86,0,76,88,78,77,78,86,32,78,77,82,86,32,86,77,82,86,32,86,77,86,86,0,77,87,79,77,79,86,32,79,77,85,86,32,85,77,85,86,0,77,88,82,77,80,78,79,80,79,83,80,85,82,86,83,86,85,85,86,83,86,80,85,78,83,77,82,77,0,77,87,79,77,79,86,32,79,77,83,77,85,78,85,81,83,82,79,82,0,77,88,82,77,80,78,79,80,79,83,80,85,82,86,83,86,85,85,86,83,86,80,85,78,83,77,82,77,32,83,84,86,87,0,77,87,79,77,79,86,32,79,77,83,77,85,78,85,81,83,82,79,82,32,82,82,85,86,0,77,87,85,78,83,77,81,77,79,78,79,79,80,80,84,82,85,83,85,85,83,86,81,86,79,85,0,77,87,82,77,82,86,32,78,77,86,77,0,77,88,79,77,79,83,80,85,82,86,83,86,85,85,86,83,86,77,0,77,87,78,77,82,86,32,86,77,82,86,0,76,88,78,77,80,86,32,82,77,80,86,32,82,77,84,86,32,86,77,84,86,0,77,87,79,77,85,86,32,85,77,79,86,0,77,87,78,77,82,81,82,86,32,86,77,82,81,0,77,87,85,77,79,86,32,79,77,85,77,32,79,86,85,86,0,77,86,79,77,79,86,32,79,77,85,77,0,77,87,82,77,78,86,32,82,77,86,86,32,78,86,86,86,0,77,88,82,77,80,78,79,80,79,83,80,85,82,86,83,86,85,85,86,83,86,80,85,78,83,77,82,77,32,81,81,84,82,32,84,81,81,82,0,77,87,82,77,78,86,32,82,77,86,86,0,77,87,79,77,85,77,32,80,81,84,82,32,84,81,80,82,32,79,86,85,86,0,77,87,79,77,79,86,32,85,77,85,86,32,79,77,85,77,0,77,87,79,77,82,81,79,86,32,79,77,85,77,32,79,86,85,86,0,77,87,78,79,78,78,79,77,80,77,81,78,82,80,82,86,32,86,79,86,78,85,77,84,77,83,78,82,80,0,76,88,82,77,82,86,32,80,79,78,80,78,83,80,84,84,84,86,83,86,80,84,79,80,79,0,76,88,82,77,82,86,32,78,79,79,80,79,83,81,84,83,84,85,83,85,80,86,79,0,77,88,79,86,81,86,79,82,79,80,80,78,82,77,83,77,85,78,86,80,86,82,84,86,86,86,0,77,87,83,77,77,86,32,83,77,85,86,32,79,83,84,83,0,77,87,81,77,78,86,32,81,77,84,77,86,78,86,80,83,81,80,81,32,83,81,85,82,85,84,84,85,82,86,78,86,0,76,88,86,80,85,78,84,77,82,77,80,78,79,79,78,81,78,83,79,85,80,86,82,86,84,85,85,84,0,77,88,81,77,78,86,32,81,77,85,77,86,79,86,81,85,84,84,85,82,86,78,86,0,77,86,81,77,78,86,32,81,77,86,77,32,80,81,83,81,32,78,86,83,86,0,77,86,81,77,78,86,32,81,77,86,77,32,80,81,83,81,0,76,88,86,80,85,78,84,77,82,77,80,78,79,79,78,81,78,83,79,85,80,86,82,86,84,85,85,83,82,83,0,77,88,81,77,78,86,32,87,77,84,86,32,80,81,85,81,0,80,85,84,77,81,86,0,79,86,85,77,83,83,82,85,81,86,80,86,79,85,79,84,0,77,86,81,77,78,86,32,86,77,79,83,32,82,81,84,86,0,78,86,82,77,79,86,32,79,86,84,86,0,76,89,80,77,77,86,32,80,77,81,86,32,88,77,81,86,32,88,77,85,86,0,77,88,81,77,78,86,32,81,77,84,86,32,87,77,84,86,0,76,88,82,77,80,78,79,79,78,81,78,83,79,85,80,86,82,86,84,85,85,84,86,82,86,80,85,78,84,77,82,77,0,77,87,81,77,78,86,32,81,77,85,77,86,78,86,80,85,81,83,82,80,82,0,76,88,82,77,80,78,79,79,78,81,78,83,79,85,80,86,82,86,84,85,85,84,86,82,86,80,85,78,84,77,82,77,32,81,86,80,85,80,84,81,83,82,83,83,84,84,86,85,87,86,87,0,77,87,81,77,78,86,32,81,77,85,77,86,78,86,80,85,81,83,82,80,82,32,81,82,82,85,83,86,84,86,85,85,0,77,87,86,78,84,77,82,77,80,78,80,80,81,81,84,82,85,83,85,85,83,86,80,86,78,85,0,77,86,83,77,80,86,32,80,77,86,77,0,76,88,80,77,78,83,78,85,79,86,82,86,84,85,85,83,87,77,0,77,87,79,77,81,86,32,87,77,81,86,0,75,88,78,77,78,86,32,83,77,78,86,32,83,77,83,86,32,88,77,83,86,0,78,87,81,77,84,86,32,87,77,78,86,0,78,87,81,77,83,81,81,86,32,87,77,83,81,0,77,87,81,77,87,77,78,86,84,86,0,76,88,78,77,82,86,32,86,77,82,86,32,78,77,86,77,0,77,87,78,76,86,88,0,76,88,82,79,78,85,32,82,79,86,85,0,77,87,78,86,86,86,0,80,86,82,77,85,81,0,77,87,77,77,79,75,81,75,84,77,86,77,87,75,0,78,87,81,80,84,80,85,81,85,86,32,85,82,81,83,80,84,80,85,81,86,83,86,85,85,0,77,87,79,77,79,86,32,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,0,77,87,85,81,83,80,82,80,80,81,79,83,80,85,82,86,83,86,85,85,0,77,87,85,77,85,86,32,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,0,77,87,79,83,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,86,0,78,86,85,78,84,77,83,77,82,78,82,86,32,80,80,84,80,0,77,87,85,80,85,86,84,88,82,89,80,89,32,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,0,77,87,79,77,79,86,32,79,83,80,81,82,80,84,81,85,83,85,86,0,80,84,82,76,81,77,82,78,83,77,82,76,32,82,80,82,86,0,80,85,83,76,82,77,83,78,84,77,83,76,32,83,80,83,88,82,89,81,89,80,88,0,78,87,80,77,80,86,32,85,80,80,84,32,82,83,85,86,0,75,89,77,80,77,86,32,77,83,78,81,79,80,80,80,81,81,82,83,82,86,32,82,83,83,81,84,80,85,80,86,81,87,83,87,86,0,77,87,79,80,79,86,32,79,83,80,81,82,80,84,81,85,83,85,86,0,77,87,82,80,80,81,79,83,80,85,82,86,84,85,85,83,84,81,82,80,0,77,87,79,80,79,89,32,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,0,77,87,85,80,85,89,32,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,0,78,86,80,80,80,86,32,80,83,81,81,83,80,84,80,0,78,87,85,81,84,80,81,80,80,81,80,82,81,83,84,83,85,84,85,85,84,86,81,86,80,85,0,78,86,82,77,82,85,83,86,84,86,85,85,32,80,80,84,80,0,77,87,85,80,85,86,32,79,80,79,83,80,85,82,86,84,85,85,83,0,78,86,79,80,82,86,32,85,80,82,86,0,76,88,78,80,80,86,32,82,80,80,86,32,82,80,84,86,32,86,80,84,86,0,77,87,79,80,85,86,32,85,80,79,86,0,77,87,79,80,82,86,32,85,80,82,86,81,88,80,89,79,89,0,77,87,79,80,85,80,79,86,85,86,0,77,88,86,80,85,83,84,85,82,86,80,85,79,83,80,81,82,80,84,81,85,85,86,86,0,77,87,79,84,81,86,83,86,84,85,84,83,83,82,80,81,82,81,84,80,85,79,85,78,84,77,82,77,81,78,80,80,79,84,78,89,0,77,88,78,81,79,80,81,80,82,81,82,83,81,87,32,86,80,85,82,83,84,81,87,80,89,0,77,87,84,78,83,77,82,77,81,78,81,79,82,80,84,81,85,83,84,85,82,86,80,85,79,83,80,81,82,80,0,78,87,85,81,83,80,81,80,80,81,80,82,81,83,32,83,83,81,83,80,84,80,85,81,86,83,86,85,85,0,78,87,84,77,83,78,83,79,84,80,32,85,80,83,80,81,81,80,83,80,85,81,86,83,87,83,88,82,89,81,89,0,76,88,78,81,79,80,80,80,81,81,81,83,80,86,32,81,83,82,81,84,80,85,80,86,81,86,83,85,86,84,89,0,76,88,78,81,79,80,80,80,81,81,81,85,82,86,83,86,84,85,85,83,86,80,86,78,85,77,84,77,83,78,83,80,84,82,85,83,87,84,0,79,86,82,80,81,83,81,85,82,86,83,86,84,85,0,77,87,81,80,79,86,32,85,80,84,80,82,81,80,83,32,80,83,81,85,83,86,84,86,0,77,87,79,77,80,77,81,78,82,80,85,86,32,82,80,79,86,0,76,89,80,80,77,89,32,85,80,84,83,83,85,81,86,80,86,79,85,79,83,32,84,83,84,85,85,86,86,86,87,85,0,77,87,78,80,79,80,79,86,32,85,80,84,83,82,85,79,86,0,78,87,84,77,83,78,83,79,84,80,32,85,80,83,80,81,81,81,82,82,83,84,83,32,83,83,81,84,80,85,80,86,81,87,83,88,83,89,82,90,81,90,0,77,88,79,81,81,80,86,80,32,81,80,81,82,80,86,32,84,80,84,82,85,86,0,77,87,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,78,89,0,77,88,86,80,82,80,80,81,79,83,80,85,82,86,84,85,85,83,84,81,82,80,0,77,88,79,81,81,80,86,80,32,83,80,82,86,0,75,88,77,81,78,80,79,80,80,81,80,85,81,86,83,86,84,85,85,83,86,80,0,77,88,80,80,79,81,79,83,80,85,82,86,83,86,85,85,86,83,86,81,85,80,84,80,83,81,82,83,81,89,0,77,87,79,80,80,80,81,81,83,88,84,89,85,89,32,85,80,84,82,80,87,79,89,0,75,89,84,77,82,89,32,77,81,78,80,79,80,80,81,80,85,81,86,84,86,85,85,86,83,87,80,0,76,88,79,80,78,82,78,84,79,86,81,86,82,84,82,82,32,85,80,86,82,86,84,85,86,83,86,82,84,0,76,87,84,83,83,81,81,80,79,81,78,83,79,85,81,86,83,85,84,83,32,85,80,84,83,84,85,85,86,86,86,0,77,87,81,77,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,0,77,87,85,81,83,80,82,80,80,81,79,83,80,85,82,86,84,86,0,76,87,84,83,83,81,81,80,79,81,78,83,79,85,81,86,83,85,84,83,32,86,77,84,83,84,85,85,86,86,86,0,77,87,79,83,84,83,85,82,85,81,83,80,82,80,80,81,79,83,80,85,82,86,84,86,0,79,86,86,77,85,77,84,78,83,80,81,86,80,88,79,89,78,89,32,81,80,85,80,0,77,88,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,32,86,80,84,86,83,88,82,89,80,89,79,88,0,77,86,81,77,78,86,32,79,83,80,81,81,80,83,80,84,81,84,82,83,84,83,85,84,86,85,86,0,80,85,83,77,83,78,84,78,84,77,83,77,32,81,80,82,80,83,81,83,82,82,84,82,85,83,86,84,86,0,79,85,83,77,83,78,84,78,84,77,83,77,32,81,80,82,80,83,81,83,82,82,86,81,88,80,89,79,89,78,88,0,78,86,82,77,79,86,32,85,80,84,80,82,81,80,83,32,80,83,81,85,83,86,84,86,0,79,84,83,77,81,83,81,85,82,86,83,86,0,74,89,75,80,76,80,77,81,77,83,76,86,32,77,83,78,81,79,80,81,80,82,81,82,83,81,86,32,82,83,83,81,84,80,86,80,87,81,87,82,86,84,86,85,87,86,88,86,0,77,87,78,80,79,80,80,81,80,83,79,86,32,80,83,81,81,82,80,84,80,85,81,85,82,84,84,84,85,85,86,86,86,0,77,88,78,80,79,80,80,81,80,83,78,89,32,80,83,81,85,83,86,85,85,86,83,85,81,83,80,81,81,80,83,0,77,88,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,32,86,80,83,89,0,77,86,79,80,80,80,81,81,81,83,80,86,32,85,81,84,80,83,80,82,81,81,83,0,78,86,84,81,83,80,81,80,80,81,80,82,81,83,82,83,83,84,83,85,82,86,80,86,79,85,0,78,85,83,77,81,83,81,85,82,86,83,86,32,80,80,84,80,0,77,87,78,80,79,80,80,81,80,82,79,84,79,85,80,86,82,86,83,85,84,83,32,85,80,84,83,84,85,85,86,86,86,0,77,87,78,80,79,80,80,81,80,82,79,84,79,85,80,86,82,86,84,85,85,82,85,80,0,75,89,76,80,77,80,78,81,78,82,77,84,77,85,78,86,80,86,81,85,82,83,83,80,32,82,83,82,85,83,86,85,86,86,85,87,82,87,80,0,77,87,79,81,80,80,81,80,82,81,82,85,83,86,84,86,85,85,32,86,81,85,80,84,80,83,81,81,85,80,86,79,86,78,85,0,77,87,78,80,79,80,80,81,80,82,79,84,79,85,80,86,82,86,83,85,84,83,32,85,80,83,86,82,88,81,89,79,89,78,88,0,78,86,85,80,79,86,32,80,81,81,80,83,80,84,81,32,80,85,81,86,83,86,84,85,0,77,87,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,85,80,84,78,82,77,81,77,0,77,87,85,81,83,80,82,80,80,81,79,83,80,85,82,86,83,86,85,85,32,79,83,83,83,0,77,87,82,77,81,78,80,80,79,83,79,86,80,87,82,87,83,86,84,84,85,81,85,78,84,77,82,77,32,80,82,84,82,0,77,87,84,77,81,89,32,82,80,80,81,79,83,80,85,82,86,83,86,85,85,86,83,85,81,83,80,82,80,0,77,87,85,81,83,80,81,80,79,81,79,83,80,84,82,85,83,86,83,87,82,88,81,88,0,75,89,84,80,84,83,85,84,86,84,87,83,87,81,86,79,85,78,83,77,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,83,87,85,86,32,84,81,83,80,81,80,80,81,80,83,81,84,83,84,84,83,0,77,87,85,78,79,82,85,86,0,77,87,79,78,85,82,79,86,0,79,85,84,75,81,75,81,89,84,89,0,79,85,80,75,83,75,83,89,80,89,0,79,85,84,75,83,76,82,78,82,79,83,81,81,82,83,83,82,85,82,86,83,88,84,89,0,79,85,80,75,81,76,82,78,82,79,81,81,83,82,81,83,82,85,82,86,81,88,80,89,0,76,89,80,77,81,78,81,79,80,80,79,80,78,79,78,78,79,77,80,77,83,78,85,78,87,77,78,86,32,85,83,84,84,84,85,85,86,86,86,87,85,87,84,86,83,85,83,0,80,84,0,78,86,0,77,87,82,77,80,78,79,80,79,83,80,85,82,86,84,85,85,83,85,80,84,78,82,77,0,77,87,80,79,82,77,82,86,0,77,87,79,78,81,77,83,77,85,78,85,80,84,82,79,86,85,86,0,77,87,79,78,81,77,83,77,85,78,85,80,83,81,32,82,81,83,81,85,82,85,85,83,86,81,86,79,85,0,77,87,83,77,83,86,32,83,77,78,83,86,83,0,77,87,80,77,79,81,81,80,82,80,84,81,85,83,84,85,82,86,81,86,79,85,32,80,77,84,77,0,77,87,84,77,82,77,80,78,79,80,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,0,77,87,85,77,81,86,32,79,77,85,77,0,77,87,81,77,79,78,79,80,81,81,83,81,85,80,85,78,83,77,81,77,32,81,81,79,82,79,85,81,86,83,86,85,85,85,82,83,81,0,77,87,85,80,84,82,82,83,80,82,79,80,80,78,82,77,84,78,85,80,85,83,84,85,82,86,80,86,0,80,85,82,85,82,86,83,86,83,85,82,85,0,80,85,83,86,82,86,82,85,83,85,83,87,82,89,0,80,85,82,80,82,81,83,81,83,80,82,80,32,82,85,82,86,83,86,83,85,82,85,0,80,85,82,80,82,81,83,81,83,80,82,80,32,83,86,82,86,82,85,83,85,83,87,82,89,0,80,85,82,77,82,82,32,83,77,83,82,32,82,85,82,86,83,86,83,85,82,85,0,78,87,80,78,82,77,83,77,85,78,85,80,82,81,82,82,83,82,83,81,85,80,32,82,85,82,86,83,86,83,85,82,85,0,80,84,82,77,82,81,0,78,86,80,77,80,81,32,84,77,84,81,0,78,86,81,77,80,78,80,80,81,81,83,81,84,80,84,78,83,77,81,77,0,77,87,82,75,82,88,32,85,78,83,77,81,77,79,78,79,80,81,81,84,82,85,83,85,85,83,86,81,86,79,85,0,77,87,86,76,78,88,0,79,85,84,75,82,78,81,81,81,83,82,86,84,89,0,79,85,80,75,82,78,83,81,83,83,82,86,80,89,0,80,84,82,75,82,89,0,76,88,78,82,86,82,0,76,88,82,78,82,86,32,78,82,86,82,0,76,88,78,80,86,80,32,78,84,86,84,0,77,87,79,79,85,85,32,85,79,79,85,0,77,87,82,79,82,85,32,79,80,85,84,32,85,80,79,84,0,80,85,82,81,82,82,83,82,83,81,82,81,0,80,85,83,77,82,79,82,81,83,81,83,80,82,80,0,80,85,83,78,82,78,82,77,83,77,83,79,82,81,0,76,88,83,79,86,82,83,85,32,78,82,86,82,0,77,88,81,76,81,89,32,84,76,84,89,32,79,81,86,81,32,79,84,86,84,0,76,88,86,82,85,82,84,83,83,85,82,86,79,86,78,85,78,83,79,82,82,81,83,80,83,78,82,77,80,77,79,78,79,80,81,83,83,85,85,86,86,86,0,76,88,78,78,79,81,79,83,78,86,32,86,78,85,81,85,83,86,86,32,78,78,81,79,83,79,86,78,32,78,86,81,85,83,85,86,86,0,76,89,82,81,81,80,79,80,78,81,78,83,79,84,81,84,82,83,83,81,84,80,86,80,87,81,87,83,86,84,84,84,83,83,82,81,0,72,92,78,82,77,81,76,82,77,83,78,82,32,86,82,87,81,88,82,87,83,86,82,0,72,92,77,80,76,81,76,82,77,83,78,83,79,82,79,81,78,80,77,80,32,77,81,77,82,78,82,78,81,77,81,32,87,80,86,81,86,82,87,83,88,83,89,82,89,81,88,80,87,80,32,87,81,87,82,88,82,88,81,87,81,0,73,91,75,82,89,82,0,72,92,82,85,74,80,82,84,90,80,82,85,0,70,94,73,83,74,81,76,80,78,80,80,81,84,84,86,85,88,85,90,84,91,81,32,73,83,74,80,76,79,78,79,80,80,84,83,86,84,88,84,90,83,91,81,32,73,89,74,87,76,86,78,86,80,87,84,90,86,91,88,91,90,90,91,87,32,73,89,74,86,76,85,78,85,80,86,84,89,86,90,88,90,90,89,91,87,0,70,94,73,83,74,81,76,80,78,80,80,81,84,84,86,85,88,85,90,84,91,81,32,73,83,74,80,76,79,78,79,80,80,84,83,86,84,88,84,90,83,91,81,32,73,87,91,87,32,73,91,91,91,0,67,97,71,79,93,79,88,73,32,76,91,71,85,93,85,0,68,96,70,94,94,94,94,70,70,70,70,94,0,75,89,81,86,79,85,78,83,78,81,79,79,81,78,83,78,85,79,86,81,86,83,85,85,83,86,81,86,32,83,86,86,83,32,81,86,86,81,32,79,85,85,79,32,78,83,83,78,32,78,81,81,78,0,72,92,73,82,91,82,0,72,92,73,82,91,82,32,73,81,91,81,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,79,86,79,87,78,87,78,86,79,85,81,84,84,84,86,85,87,87,86,89,84,90,81,91,79,92,78,94,78,97,32,84,84,85,85,86,87,85,89,84,90,32,78,96,79,95,80,95,83,96,86,96,87,95,32,80,95,83,97,86,97,87,95,87,94,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,79,86,79,87,78,87,78,86,79,85,81,84,84,84,86,85,87,87,86,89,84,90,32,84,84,85,85,86,87,85,89,84,90,32,82,90,84,90,86,91,87,93,87,94,86,96,84,97,81,97,79,96,78,95,78,94,79,94,79,95,32,84,90,85,91,86,93,86,94,85,96,84,97,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,86,86,86,87,87,87,87,86,86,85,84,84,82,84,80,85,79,86,78,89,78,94,79,96,81,97,84,97,86,96,87,94,87,92,86,90,84,89,81,89,78,91,32,82,84,80,86,79,89,79,94,80,96,81,97,32,84,97,85,96,86,94,86,92,85,90,84,89,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,81,84,79,85,78,87,79,89,81,90,84,90,86,89,87,87,86,85,84,84,81,84,32,81,84,80,85,79,87,80,89,81,90,32,84,90,85,89,86,87,85,85,84,84,32,81,90,79,91,78,93,78,94,79,96,81,97,84,97,86,96,87,94,87,93,86,91,84,90,32,81,90,80,91,79,93,79,94,80,96,81,97,32,84,97,85,96,86,94,86,93,85,91,84,90,0,76,89,79,69,79,70,78,70,78,69,79,68,81,67,84,67,86,68,87,70,86,72,84,73,81,74,79,75,78,77,78,80,32,84,67,85,68,86,70,85,72,84,73,32,78,79,79,78,80,78,83,79,86,79,87,78,32,80,78,83,80,86,80,87,78,87,77,32,77,82,88,82,32,79,86,79,87,78,87,78,86,79,85,81,84,84,84,86,85,87,87,86,89,84,90,32,84,84,85,85,86,87,85,89,84,90,32,82,90,84,90,86,91,87,93,87,94,86,96,84,97,81,97,79,96,78,95,78,94,79,94,79,95,32,84,90,85,91,86,93,86,94,85,96,84,97,0,76,89,79,69,79,70,78,70,78,69,79,68,81,67,84,67,86,68,87,70,86,72,84,73,32,84,67,85,68,86,70,85,72,84,73,32,82,73,84,73,86,74,87,76,87,77,86,79,84,80,81,80,79,79,78,78,78,77,79,77,79,78,32,84,73,85,74,86,76,86,77,85,79,84,80,32,77,82,88,82,32,81,84,79,85,78,87,79,89,81,90,84,90,86,89,87,87,86,85,84,84,81,84,32,81,84,80,85,79,87,80,89,81,90,32,84,90,85,89,86,87,85,85,84,84,32,81,90,79,91,78,93,78,94,79,96,81,97,84,97,86,96,87,94,87,93,86,91,84,90,32,81,90,80,91,79,93,79,94,80,96,81,97,32,84,97,85,96,86,94,86,93,85,91,84,90,0,76,89,79,67,78,73,32,79,67,86,67,32,79,68,83,68,86,67,32,78,73,79,72,81,71,84,71,86,72,87,74,87,77,86,79,84,80,81,80,79,79,78,78,78,77,79,77,79,78,32,84,71,85,72,86,74,86,77,85,79,84,80,32,77,82,88,82,32,81,84,79,85,78,87,79,89,81,90,84,90,86,89,87,87,86,85,84,84,81,84,32,81,84,80,85,79,87,80,89,81,90,32,84,90,85,89,86,87,85,85,84,84,32,81,90,79,91,78,93,78,94,79,96,81,97,84,97,86,96,87,94,87,93,86,91,84,90,32,81,90,80,91,79,93,79,94,80,96,81,97,32,84,97,85,96,86,94,86,93,85,91,84,90,0,76,89,78,67,78,71,32,86,69,82,76,80,80,32,87,67,84,73,81,80,32,78,69,80,67,82,67,85,69,32,78,69,80,68,82,68,85,69,86,69,32,77,82,88,82,32,81,84,79,85,78,87,79,89,81,90,84,90,86,89,87,87,86,85,84,84,81,84,32,81,84,80,85,79,87,80,89,81,90,32,84,90,85,89,86,87,85,85,84,84,32,81,90,79,91,78,93,78,94,79,96,81,97,84,97,86,96,87,94,87,93,86,91,84,90,32,81,90,80,91,79,93,79,94,80,96,81,97,32,84,97,85,96,86,94,86,93,85,91,84,90,0,76,89,79,67,78,73,32,79,67,86,67,32,79,68,83,68,86,67,32,78,73,79,72,81,71,84,71,86,72,87,74,87,77,86,79,84,80,81,80,79,79,78,78,78,77,79,77,79,78,32,84,71,85,72,86,74,86,77,85,79,84,80,32,77,82,88,82,32,86,86,86,87,87,87,87,86,86,85,84,84,82,84,80,85,79,86,78,89,78,94,79,96,81,97,84,97,86,96,87,94,87,92,86,90,84,89,81,89,78,91,32,82,84,80,86,79,89,79,94,80,96,81,97,32,84,97,85,96,86,94,86,92,85,90,84,89,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,83,86,83,97,32,84,84,84,97,32,84,84,77,93,88,93,32,81,97,86,97,0,76,89,79,69,79,70,78,70,78,69,79,68,81,67,84,67,86,68,87,70,86,72,84,73,32,84,67,85,68,86,70,85,72,84,73,32,82,73,84,73,86,74,87,76,87,77,86,79,84,80,81,80,79,79,78,78,78,77,79,77,79,78,32,84,73,85,74,86,76,86,77,85,79,84,80,32,77,82,88,82,32,83,86,83,97,32,84,84,84,97,32,84,84,77,93,88,93,32,81,97,86,97,0,70,94,89,88,87,90,85,91,82,91,80,90,77,88,75,87,73,87,72,88,72,90,73,91,75,91,77,90,79,87,80,85,82,81,84,75,87,71,89,70,90,70,91,71,92,72,91,73,90,72,91,71,91,70,90,70,89,70,87,71,86,72,84,76,82,80,80,86,78,90,77,90,32,79,80,85,80,0,69,94,80,91,77,90,74,88,72,85,71,82,71,79,72,76,74,73,77,71,80,70,84,70,87,71,89,73,91,76,92,79,92,82,91,85,89,88,86,90,83,91,80,91,32,78,74,78,87,32,79,74,79,87,32,76,74,83,74,86,75,87,77,87,78,86,80,83,81,79,81,32,83,74,85,75,86,77,86,78,85,80,83,81,32,76,87,81,87,32,83,81,84,82,85,86,86,87,87,87,88,86,32,83,81,85,82,86,86,87,87,0,69,94,80,91,77,90,74,88,72,85,71,82,71,79,72,76,74,73,77,71,80,70,84,70,87,71,89,73,91,76,92,79,92,82,91,85,89,88,86,90,83,91,80,91,32,85,75,86,74,86,78,85,75,83,74,80,74,78,75,77,76,76,79,76,82,77,85,78,86,80,87,83,87,85,86,86,84,32,80,74,78,76,77,79,77,82,78,85,80,87,0,69,95,73,77,91,77,32,73,82,91,82,32,73,87,91,87,32,75,91,89,73,0,67,97,72,81,71,82,72,83,73,82,72,81,32,82,81,81,82,82,83,83,82,82,81,32,92,81,91,82,92,83,93,82,92,81,0,69,95,78,87,76,84,73,82,76,80,78,77,32,76,80,74,82,76,84,32,74,82,90,82,32,86,87,88,84,91,82,88,80,86,77,32,88,80,90,82,88,84,0,74,90,87,78,84,76,82,73,80,76,77,78,32,80,76,82,74,84,76,32,82,74,82,90,32,87,86,84,88,82,91,80,88,77,86,32,80,88,82,90,84,88,0,70,94,90,74,83,74,79,75,77,76,75,78,74,81,74,83,75,86,77,88,79,89,83,90,90,90,32,83,70,83,94,0,70,94,74,74,81,74,85,75,87,76,89,78,90,81,90,83,89,86,87,88,85,89,81,90,74,90,32,81,70,81,94,0,70,94,74,74,81,74,85,75,87,76,89,78,90,81,90,83,89,86,87,88,85,89,81,90,74,90,32,79,82,90,82,0,72,92,76,66,76,91,32,82,66,82,91,32,88,66,88,91,0,73,91,82,70,74,91,32,82,70,90,91,32,77,84,87,84,0,71,92,75,70,75,91,32,75,70,84,70,87,71,88,72,89,74,89,76,88,78,87,79,84,80,32,75,80,84,80,87,81,88,82,89,84,89,87,88,89,87,90,84,91,75,91,0,72,93,90,75,89,73,87,71,85,70,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,85,91,87,90,89,88,90,86,0,71,92,75,70,75,91,32,75,70,82,70,85,71,87,73,88,75,89,78,89,83,88,86,87,88,85,90,82,91,75,91,0,72,91,76,70,76,91,32,76,70,89,70,32,76,80,84,80,32,76,91,89,91,0,72,90,76,70,76,91,32,76,70,89,70,32,76,80,84,80,0,72,93,90,75,89,73,87,71,85,70,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,85,91,87,90,89,88,90,86,90,83,32,85,83,90,83,0,71,93,75,70,75,91,32,89,70,89,91,32,75,80,89,80,0,78,86,82,70,82,91,0,74,90,86,70,86,86,85,89,84,90,82,91,80,91,78,90,77,89,76,86,76,84,0,71,92,75,70,75,91,32,89,70,75,84,32,80,79,89,91,0,72,89,76,70,76,91,32,76,91,88,91,0,70,94,74,70,74,91,32,74,70,82,91,32,90,70,82,91,32,90,70,90,91,0,71,93,75,70,75,91,32,75,70,89,91,32,89,70,89,91,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,0,71,92,75,70,75,91,32,75,70,84,70,87,71,88,72,89,74,89,77,88,79,87,80,84,81,75,81,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,32,83,87,89,93,0,71,92,75,70,75,91,32,75,70,84,70,87,71,88,72,89,74,89,76,88,78,87,79,84,80,75,80,32,82,80,89,91,0,72,92,89,73,87,71,84,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,85,81,87,82,88,83,89,85,89,88,87,90,84,91,80,91,77,90,75,88,0,74,90,82,70,82,91,32,75,70,89,70,0,71,93,75,70,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,70,0,73,91,74,70,82,91,32,90,70,82,91,0,70,94,72,70,77,91,32,82,70,77,91,32,82,70,87,91,32,92,70,87,91,0,72,92,75,70,89,91,32,89,70,75,91,0,73,91,74,70,82,80,82,91,32,90,70,82,80,0,72,92,89,70,75,91,32,75,70,89,70,32,75,91,89,91,0,72,89,76,70,76,91,32,76,70,88,70,0,73,91,82,70,74,91,32,82,70,90,91,32,74,91,90,91,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,32,79,80,85,80,0,73,91,82,70,74,91,32,82,70,90,91,0,73,91,75,70,89,70,32,79,80,85,80,32,75,91,89,91,0,71,93,75,70,75,91,32,89,70,89,91,32,75,70,89,70,0,73,91,75,70,82,80,75,91,32,75,70,89,70,32,75,91,89,91,0,73,91,75,75,75,73,76,71,77,70,79,70,80,71,81,73,82,77,82,91,32,89,75,89,73,88,71,87,70,85,70,84,71,83,73,82,77,0,72,92,82,70,82,91,32,80,75,77,76,76,77,75,79,75,82,76,84,77,85,80,86,84,86,87,85,88,84,89,82,89,79,88,77,87,76,84,75,80,75,0,72,92,75,70,89,91,32,75,91,89,70,0,71,93,82,70,82,91,32,73,76,74,76,75,77,76,81,77,83,78,84,81,85,83,85,86,84,87,83,88,81,89,77,90,76,91,76,0,72,92,75,91,79,91,76,84,75,80,75,76,76,73,78,71,81,70,83,70,86,71,88,73,89,76,89,80,88,84,85,91,89,91,0,71,91,71,91,73,90,76,87,79,83,83,76,86,70,86,91,85,88,83,85,81,83,78,81,76,81,75,82,75,84,76,86,78,88,81,90,84,91,89,91,0,70,93,83,72,84,73,84,76,83,80,82,83,81,85,79,88,77,90,75,91,74,91,73,90,73,87,74,82,75,79,76,77,78,74,80,72,82,71,85,70,88,70,90,71,91,73,91,75,90,77,89,78,87,79,84,80,32,83,80,84,80,87,81,88,82,89,84,89,87,88,89,87,90,85,91,82,91,80,90,79,88,0,72,92,84,76,84,77,85,78,87,78,89,77,90,75,90,73,89,71,87,70,84,70,81,71,79,73,77,76,76,78,75,82,75,86,76,89,77,90,79,91,81,91,84,90,86,88,87,86,0,71,94,84,70,82,71,81,73,80,77,79,83,78,86,77,88,75,90,73,91,71,91,70,90,70,88,71,87,73,87,75,88,77,90,80,91,83,91,86,90,88,88,90,84,91,79,91,75,90,72,89,71,87,70,84,70,82,72,82,74,83,77,85,80,87,82,90,84,92,85,0,72,92,86,74,86,75,87,76,89,76,90,75,90,73,89,71,86,70,82,70,79,71,78,73,78,76,79,78,80,79,83,80,80,80,77,81,76,82,75,84,75,87,76,89,77,90,80,91,83,91,86,90,88,88,89,86,0,72,92,82,76,80,76,78,75,77,73,78,71,81,70,84,70,88,71,91,71,93,70,32,88,71,86,78,84,84,82,88,80,90,78,91,76,91,74,90,73,88,73,86,74,85,76,85,78,86,32,81,80,90,80,0,71,94,71,91,73,90,77,86,80,81,81,78,82,74,82,71,81,70,80,70,79,71,78,73,78,76,79,78,81,79,85,79,88,78,89,77,90,75,90,81,89,86,88,88,86,90,83,91,79,91,76,90,74,88,73,86,73,84,0,70,94,77,77,75,76,74,74,74,73,75,71,77,70,78,70,80,71,81,73,81,75,80,79,78,85,76,89,74,91,72,91,71,90,71,88,32,77,82,86,79,88,78,91,76,93,74,94,72,94,71,93,70,92,70,90,72,88,76,86,82,85,87,85,90,86,91,87,91,89,90,90,89,92,86,0,73,90,87,86,85,84,83,81,82,79,81,76,81,73,82,71,83,70,85,70,86,71,87,73,87,76,86,81,84,86,83,88,81,90,79,91,77,91,75,90,74,88,74,86,75,85,77,85,79,86,0,74,89,84,94,82,91,80,86,79,80,79,74,80,71,82,70,84,70,85,71,86,74,86,77,85,82,82,91,80,97,79,100,78,102,76,103,75,102,75,100,76,97,78,94,80,92,83,90,87,88,0,70,94,77,77,75,76,74,74,74,73,75,71,77,70,78,70,80,71,81,73,81,75,80,79,78,85,76,89,74,91,72,91,71,90,71,88,32,94,73,94,71,93,70,92,70,90,71,88,73,86,76,84,78,82,79,80,79,32,82,79,83,81,83,88,84,90,85,91,86,91,88,90,89,89,91,86,0,73,92,77,82,79,82,83,81,86,79,88,77,89,75,89,72,88,70,86,70,85,71,84,73,83,78,82,83,81,86,80,88,78,90,76,91,74,91,73,90,73,88,74,87,76,87,78,88,81,90,84,91,86,91,89,90,91,88,0,64,97,69,77,67,76,66,74,66,73,67,71,69,70,70,70,72,71,73,73,73,75,72,80,71,84,69,91,32,71,84,74,76,76,72,77,71,79,70,80,70,82,71,83,73,83,75,82,80,81,84,79,91,32,81,84,84,76,86,72,87,71,89,70,90,70,92,71,93,73,93,75,92,80,90,87,90,90,91,91,92,91,94,90,95,89,97,86,0,69,93,74,77,72,76,71,74,71,73,72,71,74,70,75,70,77,71,78,73,78,75,77,80,76,84,74,91,32,76,84,79,76,81,72,82,71,84,70,86,70,88,71,89,73,89,75,88,80,86,87,86,90,87,91,88,91,90,90,91,89,93,86,0,72,93,84,70,81,71,79,73,77,76,76,78,75,82,75,86,76,89,77,90,79,91,81,91,84,90,86,88,88,85,89,83,90,79,90,75,89,72,88,71,86,70,84,70,82,72,82,75,83,78,85,81,87,83,90,85,92,86,0,70,95,83,72,84,73,84,76,83,80,82,83,81,85,79,88,77,90,75,91,74,91,73,90,73,87,74,82,75,79,76,77,78,74,80,72,82,71,85,70,90,70,92,71,93,72,94,74,94,77,93,79,92,80,90,81,87,81,85,80,84,79,0,72,94,85,76,84,78,83,79,81,80,79,80,78,78,78,76,79,73,81,71,84,70,87,70,89,71,90,73,90,77,89,80,87,83,83,87,80,89,78,90,75,91,73,91,72,90,72,88,73,87,75,87,77,88,80,90,83,91,86,91,89,90,91,88,0,70,95,83,72,84,73,84,76,83,80,82,83,81,85,79,88,77,90,75,91,74,91,73,90,73,87,74,82,75,79,76,77,78,74,80,72,82,71,85,70,89,70,91,71,92,72,93,74,93,77,92,79,91,80,89,81,86,81,83,80,84,81,85,83,85,88,86,90,88,91,90,90,91,89,93,86,0,72,92,72,91,74,90,76,88,79,84,81,81,83,77,84,74,84,71,83,70,82,70,81,71,80,73,80,75,81,77,83,79,86,81,88,83,89,85,89,87,88,89,87,90,84,91,80,91,77,90,75,88,74,86,74,84,0,72,91,82,76,80,76,78,75,77,73,78,71,81,70,84,70,88,71,91,71,93,70,32,88,71,86,78,84,84,82,88,80,90,78,91,76,91,74,90,73,88,73,86,74,85,76,85,78,86,0,69,93,74,77,72,76,71,74,71,73,72,71,74,70,75,70,77,71,78,73,78,75,77,79,76,82,75,86,75,88,76,90,78,91,80,91,82,90,83,89,85,85,88,77,90,70,32,88,77,87,81,86,87,86,90,87,91,88,91,90,90,91,89,93,86,0,70,93,75,77,73,76,72,74,72,73,73,71,75,70,76,70,78,71,79,73,79,75,78,79,77,82,76,86,76,89,77,91,79,91,81,90,84,87,86,84,88,80,89,77,90,73,90,71,89,70,88,70,87,71,86,73,86,75,87,78,89,80,91,81,0,67,95,72,77,70,76,69,74,69,73,70,71,72,70,73,70,75,71,76,73,76,76,75,91,32,85,70,75,91,32,85,70,83,91,32,97,70,95,71,92,74,89,78,86,84,83,91,0,70,94,78,76,76,76,75,75,75,73,76,71,78,70,80,70,82,71,83,73,83,76,81,85,81,88,82,90,84,91,86,91,88,90,89,88,89,86,88,85,86,85,32,93,73,93,71,92,70,90,70,88,71,86,73,84,76,80,85,78,88,76,90,74,91,72,91,71,90,71,88,0,70,93,75,77,73,76,72,74,72,73,73,71,75,70,76,70,78,71,79,73,79,75,78,79,77,82,76,86,76,88,77,90,78,91,80,91,82,90,84,88,86,85,87,83,89,77,32,91,70,89,77,86,87,84,93,82,98,80,102,78,103,77,102,77,100,78,97,80,94,83,91,86,89,91,86,0,72,93,85,76,84,78,83,79,81,80,79,80,78,78,78,76,79,73,81,71,84,70,87,70,89,71,90,73,90,77,89,80,87,84,84,87,80,90,78,91,75,91,74,90,74,88,75,87,78,87,80,88,81,89,82,91,82,94,81,97,80,99,78,102,76,103,75,102,75,100,76,97,78,94,81,91,84,89,90,86,0,73,91,74,70,82,91,32,90,70,82,91,32,74,70,90,70,0,71,93,73,76,91,98,0,69,95,82,74,73,90,32,82,74,91,90,0,73,91,74,91,90,91,0,73,91,74,91,90,91,90,90,74,90,74,91,0,73,92,88,77,88,91,32,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,72,91,76,70,76,91,32,76,80,78,78,80,77,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,80,91,78,90,76,88,0,73,91,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,73,92,88,70,88,91,32,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,73,91,76,83,88,83,88,81,87,79,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,77,89,87,70,85,70,83,71,82,74,82,91,32,79,77,86,77,0,73,92,88,77,88,93,87,96,86,97,84,98,81,98,79,97,32,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,73,92,77,70,77,91,32,77,81,80,78,82,77,85,77,87,78,88,81,88,91,0,78,86,81,70,82,71,83,70,82,69,81,70,32,82,77,82,91,0,77,87,82,70,83,71,84,70,83,69,82,70,32,83,77,83,94,82,97,80,98,78,98,0,73,90,77,70,77,91,32,87,77,77,87,32,81,83,88,91,0,67,97,71,77,71,91,32,71,81,74,78,76,77,79,77,81,78,82,81,82,91,32,82,81,85,78,87,77,90,77,92,78,93,81,93,91,0,73,92,77,77,77,91,32,77,81,80,78,82,77,85,77,87,78,88,81,88,91,0,73,92,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,89,85,89,83,88,80,86,78,84,77,81,77,0,72,91,76,77,76,98,32,76,80,78,78,80,77,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,80,91,78,90,76,88,0,73,92,88,77,88,98,32,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,75,88,79,77,79,91,32,79,83,80,80,82,78,84,77,87,77,0,74,91,88,80,87,78,84,77,81,77,78,78,77,80,78,82,80,83,85,84,87,85],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+235532);allocate([88,87,88,88,87,90,84,91,81,91,78,90,77,88,0,77,89,82,70,82,87,83,90,85,91,87,91,32,79,77,86,77,0,73,92,77,77,77,87,78,90,80,91,83,91,85,90,88,87,32,88,77,88,91,0,74,90,76,77,82,91,32,88,77,82,91,0,71,93,74,77,78,91,32,82,77,78,91,32,82,77,86,91,32,90,77,86,91,0,74,91,77,77,88,91,32,88,77,77,91,0,74,90,76,77,82,91,32,88,77,82,91,80,95,78,97,76,98,75,98,0,74,91,88,77,77,91,32,77,77,88,77,32,77,91,88,91,0,72,93,81,77,79,78,77,80,76,82,75,85,75,88,76,90,78,91,80,91,82,90,85,87,87,84,89,80,90,77,32,81,77,83,77,84,78,85,80,87,88,88,90,89,91,90,91,0,73,92,85,70,83,71,81,73,79,77,78,80,77,84,76,90,75,98,32,85,70,87,70,89,72,89,75,88,77,87,78,85,79,82,79,32,82,79,84,80,86,82,87,84,87,87,86,89,85,90,83,91,81,91,79,90,78,89,77,86,0,73,92,74,80,76,78,78,77,79,77,81,78,82,79,83,82,83,86,82,91,32,90,77,89,80,88,82,82,91,80,95,79,98,0,73,91,84,77,81,77,79,78,77,80,76,83,76,86,77,89,78,90,80,91,82,91,84,90,86,88,87,85,87,82,86,79,84,77,82,75,81,73,81,71,82,70,84,70,86,71,88,73,0,74,90,87,79,86,78,84,77,81,77,79,78,79,80,80,82,83,83,32,83,83,79,84,77,86,77,88,78,90,80,91,83,91,85,90,87,88,0,74,89,84,70,82,71,81,72,81,73,82,74,85,75,88,75,32,88,75,84,77,81,79,78,82,77,85,77,87,78,89,80,91,83,93,84,95,84,97,83,98,81,98,80,96,0,72,92,73,81,74,79,76,77,78,77,79,78,79,80,78,84,76,91,32,78,84,80,80,82,78,84,77,86,77,88,79,88,82,87,87,84,98,0,71,92,72,81,73,79,75,77,77,77,78,78,78,80,77,85,77,88,78,90,79,91,81,91,83,90,85,87,86,85,87,82,88,77,88,74,87,71,85,70,83,70,82,72,82,74,83,77,85,80,87,82,90,84,0,76,87,82,77,80,84,79,88,79,90,80,91,82,91,84,89,85,87,0,73,91,79,77,75,91,32,89,78,88,77,87,77,85,78,81,82,79,83,78,83,32,78,83,80,84,81,85,83,90,84,91,85,91,86,90,0,74,90,75,70,77,70,79,71,80,72,88,91,32,82,77,76,91,0,72,93,79,77,73,98,32,78,81,77,86,77,89,79,91,81,91,83,90,85,88,87,84,32,89,77,87,84,86,88,86,90,87,91,89,91,91,89,92,87,0,73,91,76,77,79,77,78,83,77,88,76,91,32,89,77,88,80,87,82,85,85,82,88,79,90,76,91,0,74,90,84,70,82,71,81,72,81,73,82,74,85,75,88,75,32,85,75,82,76,80,77,79,79,79,81,81,83,84,84,86,84,32,84,84,80,85,78,86,77,88,77,90,79,92,83,94,84,95,84,97,82,98,80,98,0,74,91,82,77,80,78,78,80,77,83,77,86,78,89,79,90,81,91,83,91,85,90,87,88,88,85,88,82,87,79,86,78,84,77,82,77,0,71,93,80,77,76,91,32,85,77,86,83,87,88,88,91,32,73,80,75,78,78,77,91,77,0,73,91,77,83,77,86,78,89,79,90,81,91,83,91,85,90,87,88,88,85,88,82,87,79,86,78,84,77,82,77,80,78,78,80,77,83,73,98,0,73,93,91,77,81,77,79,78,77,80,76,83,76,86,77,89,78,90,80,91,82,91,84,90,86,88,87,85,87,82,86,79,85,78,83,77,0,72,92,83,77,80,91,32,74,80,76,78,79,77,90,77,0,72,92,73,81,74,79,76,77,78,77,79,78,79,80,77,86,77,89,79,91,81,91,84,90,86,88,88,84,89,80,89,77,0,71,93,79,78,77,79,75,81,74,84,74,87,75,89,76,90,78,91,81,91,84,90,87,88,89,85,90,82,90,79,88,77,86,77,84,79,82,83,80,88,77,98,0,73,91,75,77,77,77,79,79,85,96,87,98,89,98,32,90,77,89,79,87,82,77,93,75,96,74,98,0,70,93,86,70,78,98,32,71,81,72,79,74,77,76,77,77,78,77,80,76,85,76,88,77,90,79,91,81,91,84,90,86,88,88,85,90,80,91,77,0,70,93,78,77,76,78,74,81,73,84,73,87,74,90,75,91,77,91,79,90,81,87,32,82,83,81,87,82,90,83,91,85,91,87,90,89,87,90,84,90,81,89,78,88,77,0,76,92,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,86,82,85,87,85,90,86,91,87,91,89,90,90,89,92,86,0,77,91,77,86,79,83,82,78,83,76,84,73,84,71,83,70,81,71,80,73,79,77,78,84,78,90,79,91,80,91,82,90,84,88,85,85,85,82,86,86,87,87,89,87,91,86,0,77,88,84,84,84,83,83,82,81,82,79,83,78,84,77,86,77,88,78,90,80,91,83,91,86,89,88,86,0,76,92,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,90,70,32,86,82,85,87,85,90,86,91,87,91,89,90,90,89,92,86,0,78,88,79,89,81,88,82,87,83,85,83,83,82,82,81,82,79,83,78,85,78,88,79,90,81,91,83,91,85,90,86,89,88,86,0,79,87,79,86,83,81,85,78,86,76,87,73,87,71,86,70,84,71,83,73,81,81,78,90,75,97,74,100,74,102,75,103,77,102,78,99,79,90,80,91,82,91,84,90,85,89,87,86,0,76,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,89,32,86,82,84,89,80,100,79,102,77,103,76,102,76,100,77,97,80,94,83,92,85,91,88,89,91,86,0,77,92,77,86,79,83,82,78,83,76,84,73,84,71,83,70,81,71,80,73,79,77,78,83,77,91,32,77,91,78,88,79,86,81,83,83,82,85,82,86,83,86,85,85,88,85,90,86,91,87,91,89,90,90,89,92,86,0,80,87,83,77,83,78,84,78,84,77,83,77,32,80,86,82,82,80,88,80,90,81,91,82,91,84,90,85,89,87,86,0,80,87,83,77,83,78,84,78,84,77,83,77,32,80,86,82,82,76,100,75,102,73,103,72,102,72,100,73,97,76,94,79,92,81,91,84,89,87,86,0,77,91,77,86,79,83,82,78,83,76,84,73,84,71,83,70,81,71,80,73,79,77,78,83,77,91,32,77,91,78,88,79,86,81,83,83,82,85,82,86,83,86,85,84,86,81,86,32,81,86,83,87,84,90,85,91,86,91,88,90,89,89,91,86,0,79,87,79,86,81,83,84,78,85,76,86,73,86,71,85,70,83,71,82,73,81,77,80,84,80,90,81,91,82,91,84,90,85,89,87,86,0,69,94,69,86,71,83,73,82,74,83,74,84,73,88,72,91,32,73,88,74,86,76,83,78,82,80,82,81,83,81,84,80,88,79,91,32,80,88,81,86,83,83,85,82,87,82,88,83,88,85,87,88,87,90,88,91,89,91,91,90,92,89,94,86,0,74,92,74,86,76,83,78,82,79,83,79,84,78,88,77,91,32,78,88,79,86,81,83,83,82,85,82,86,83,86,85,85,88,85,90,86,91,87,91,89,90,90,89,92,86,0,76,90,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,89,85,87,85,85,84,83,82,82,81,83,81,85,82,87,84,88,87,88,89,87,90,86,0,75,90,75,86,77,83,78,81,77,85,71,103,32,77,85,78,83,80,82,82,82,84,83,85,85,85,87,84,89,83,90,81,91,32,77,90,79,91,82,91,85,90,87,89,90,86,0,76,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,32,86,82,85,85,83,90,80,97,79,100,79,102,80,103,82,102,83,99,83,92,85,91,88,89,91,86,0,77,90,77,86,79,83,80,81,80,83,83,83,84,84,84,86,83,89,83,90,84,91,85,91,87,90,88,89,90,86,0,78,89,78,86,80,83,81,81,81,83,83,86,84,88,84,90,82,91,32,78,90,80,91,84,91,86,90,87,89,89,86,0,79,88,79,86,81,83,83,79,32,86,70,80,88,80,90,81,91,83,91,85,90,86,89,88,86,32,80,78,87,78,0,76,91,76,86,78,82,76,88,76,90,77,91,79,91,81,90,83,88,85,85,32,86,82,84,88,84,90,85,91,86,91,88,90,89,89,91,86,0,76,91,76,86,78,82,77,87,77,90,78,91,79,91,82,90,84,88,85,85,85,82,32,85,82,86,86,87,87,89,87,91,86,0,73,94,76,82,74,84,73,87,73,89,74,91,76,91,78,90,80,88,32,82,82,80,88,80,90,81,91,83,91,85,90,87,88,88,85,88,82,32,88,82,89,86,90,87,92,87,94,86,0,74,90,74,86,76,83,78,82,80,82,81,83,81,90,82,91,85,91,88,89,90,86,32,87,83,86,82,84,82,83,83,79,90,78,91,76,91,75,90,0,76,91,76,86,78,82,76,88,76,90,77,91,79,91,81,90,83,88,85,85,32,86,82,80,100,79,102,77,103,76,102,76,100,77,97,80,94,83,92,85,91,88,89,91,86,0,76,90,76,86,78,83,80,82,82,82,84,84,84,86,83,88,81,90,78,91,80,92,81,94,81,97,80,100,79,102,77,103,76,102,76,100,77,97,80,94,83,92,87,89,90,86,0,74,92,75,91,78,90,81,88,83,86,85,83,87,79,88,75,88,73,87,71,85,70,83,71,82,72,81,74,80,79,80,84,81,88,82,90,84,91,86,91,88,90,89,89,0,73,91,87,85,87,82,86,79,85,78,83,77,81,77,79,78,77,80,76,83,76,86,77,89,78,90,80,91,82,91,84,90,86,88,87,85,88,80,88,75,87,72,86,71,84,70,82,70,80,71,78,73,0,74,90,87,78,85,77,82,77,80,78,78,80,77,83,77,86,78,89,79,90,81,91,84,91,86,90,32,77,84,85,84,0,74,91,84,70,82,71,80,74,79,76,78,79,77,84,77,88,78,90,79,91,81,91,83,90,85,87,86,85,87,82,88,77,88,73,87,71,86,70,84,70,32,78,80,87,80,0,72,92,86,70,78,98,32,81,77,78,78,76,80,75,83,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,82,88,80,86,78,83,77,81,77,0,73,91,88,79,87,78,84,77,81,77,78,78,77,79,76,81,76,83,77,85,79,87,83,90,84,92,84,94,83,95,81,95,0,68,97,87,78,86,76,84,75,81,75,79,76,78,77,77,79,77,82,78,84,79,85,81,86,84,86,86,85,87,83,32,87,75,87,83,88,85,89,86,91,86,92,85,93,83,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,84,91,87,90,89,89,0,70,94,90,73,74,82,90,91,0,70,94,74,73,90,82,74,91,0,75,89,79,66,79,98,32,79,66,86,66,32,79,98,86,98,0,75,89,85,66,85,98,32,78,66,85,66,32,78,98,85,98,0,75,89,84,66,81,69,80,72,80,74,81,77,83,79,83,80,79,82,83,84,83,85,81,87,80,90,80,92,81,95,84,98,0,75,89,80,66,83,69,84,72,84,74,83,77,81,79,81,80,85,82,81,84,81,85,83,87,84,90,84,92,83,95,80,98,0,70,94,91,70,89,71,86,72,83,72,80,71,78,70,76,70,74,71,73,73,73,75,75,77,77,77,79,76,80,74,80,72,78,70,32,91,70,73,91,32,89,84,87,84,85,85,84,87,84,89,86,91,88,91,90,90,91,88,91,86,89,84,0,74,90,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,0,72,92,78,74,80,73,83,70,83,91,0,72,92,76,75,76,74,77,72,78,71,80,70,84,70,86,71,87,72,88,74,88,76,87,78,85,81,75,91,89,91,0,72,92,77,70,88,70,82,78,85,78,87,79,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,0,72,92,85,70,75,84,90,84,32,85,70,85,91,0,72,92,87,70,77,70,76,79,77,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,0,72,92,88,73,87,71,84,70,82,70,79,71,77,74,76,79,76,84,77,88,79,90,82,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,82,78,79,79,77,81,76,84,0,72,92,89,70,79,91,32,75,70,89,70,0,72,92,80,70,77,71,76,73,76,75,77,77,79,78,83,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,84,76,82,78,80,81,79,85,78,87,77,88,75,88,73,87,71,84,70,80,70,0,72,92,88,77,87,80,85,82,82,83,81,83,78,82,76,80,75,77,75,76,76,73,78,71,81,70,82,70,85,71,87,73,88,77,88,82,87,87,85,90,82,91,80,91,77,90,76,88,0,77,87,82,89,81,90,82,91,83,90,82,89,0,77,87,83,90,82,91,81,90,82,89,83,90,83,92,82,94,81,95,0,77,87,82,77,81,78,82,79,83,78,82,77,32,82,89,81,90,82,91,83,90,82,89,0,77,87,82,77,81,78,82,79,83,78,82,77,32,83,90,82,91,81,90,82,89,83,90,83,92,82,94,81,95,0,77,87,82,70,82,84,32,82,89,81,90,82,91,83,90,82,89,0,73,91,76,75,76,74,77,72,78,71,80,70,84,70,86,71,87,72,88,74,88,76,87,78,86,79,82,81,82,84,32,82,89,81,90,82,91,83,90,82,89,0,78,86,82,70,82,77,0,74,90,78,70,78,77,32,86,70,86,77,0,75,89,81,70,79,71,78,73,78,75,79,77,81,78,83,78,85,77,86,75,86,73,85,71,83,70,81,70,0,72,92,80,66,80,95,32,84,66,84,95,32,89,73,87,71,84,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,85,81,87,82,88,83,89,85,89,88,87,90,84,91,80,91,77,90,75,88,0,71,93,91,66,73,98,0,75,89,86,66,84,68,82,71,80,75,79,80,79,84,80,89,82,93,84,96,86,98,0,75,89,78,66,80,68,82,71,84,75,85,80,85,84,84,89,82,93,80,96,78,98,0,78,86,82,66,82,98,0,69,95,73,82,91,82,0,69,95,82,73,82,91,32,73,82,91,82,0,69,95,73,79,91,79,32,73,85,91,85,0,71,93,75,75,89,89,32,89,75,75,89,0,74,90,82,76,82,88,32,77,79,87,85,32,87,79,77,85,0,77,87,82,81,81,82,82,83,83,82,82,81,0,77,87,83,70,82,71,81,73,81,75,82,76,83,75,82,74,0,77,87,82,72,81,71,82,70,83,71,83,73,82,75,81,76,0,69,95,85,77,88,80,91,82,88,84,85,87,32,73,82,91,82,0,71,93,79,70,79,98,32,85,70,85,98,32,74,81,90,81,32,74,87,90,87,0,69,95,92,79,92,78,91,77,90,77,89,78,88,80,86,85,84,88,82,90,80,91,76,91,74,90,73,89,72,87,72,85,73,83,74,82,81,78,82,77,83,75,83,73,82,71,80,70,78,71,77,73,77,75,78,78,80,81,85,88,87,90,89,91,91,91,92,90,92,89,0,71,93,73,73,74,75,75,79,75,85,74,89,73,91,32,91,73,90,75,89,79,89,85,90,89,91,91,32,73,73,75,74,79,75,85,75,89,74,91,73,32,73,91,75,90,79,89,85,89,89,90,91,91,0,70,95,92,81,91,79,89,78,87,78,85,79,84,80,81,84,80,85,78,86,76,86,74,85,73,83,73,81,74,79,76,78,78,78,80,79,81,80,84,84,85,85,87,86,89,86,91,85,92,83,92,81,0,75,89,79,66,79,91,32,85,66,85,91,0,70,94,82,66,82,91,32,73,91,91,91,0,70,94,91,66,73,91,91,91,0,69,95,82,73,81,74,82,75,83,74,82,73,32,73,89,72,90,73,91,74,90,73,89,32,91,89,90,90,91,91,92,90,91,89,0,70,94,82,72,78,76,75,80,74,83,74,85,75,87,77,88,79,88,81,87,82,85,32,82,72,86,76,89,80,90,83,90,85,89,87,87,88,85,88,83,87,82,85,32,82,85,81,89,80,92,32,82,85,83,89,84,92,32,80,92,84,92,0,70,94,82,78,81,75,80,73,78,72,77,72,75,73,74,75,74,79,75,82,76,84,78,87,82,92,32,82,78,83,75,84,73,86,72,87,72,89,73,90,75,90,79,89,82,88,84,86,87,82,92,0,70,94,82,71,80,74,76,79,73,82,32,82,71,84,74,88,79,91,82,32,73,82,76,85,80,90,82,93,32,91,82,88,85,84,90,82,93,0,70,94,82,84,84,87,86,88,88,88,90,87,91,85,91,83,90,81,88,80,86,80,83,81,32,83,81,85,79,86,77,86,75,85,73,83,72,81,72,79,73,78,75,78,77,79,79,81,81,32,81,81,78,80,76,80,74,81,73,83,73,85,74,87,76,88,78,88,80,87,82,84,32,82,84,81,89,80,92,32,82,84,83,89,84,92,32,80,92,84,92,0,70,94,82,82,82,91,81,92,32,82,86,81,92,32,82,73,81,72,79,72,78,73,78,75,79,78,82,82,32,82,73,83,72,85,72,86,73,86,75,85,78,82,82,32,82,82,78,79,76,78,74,78,73,79,73,81,74,82,32,82,82,86,79,88,78,90,78,91,79,91,81,90,82,32,82,82,78,85,76,86,74,86,73,85,73,83,74,82,32,82,82,86,85,88,86,90,86,91,85,91,83,90,82,0,70,94,73,83,74,83,76,84,77,86,77,88,76,90,32,73,83,73,82,74,81,76,81,77,82,78,84,78,87,77,89,76,90,32,82,71,80,73,79,76,79,79,81,85,81,88,80,90,82,92,32,82,71,84,73,85,76,85,79,83,85,83,88,84,90,82,92,32,91,83,91,82,90,81,88,81,87,82,86,84,86,87,87,89,88,90,32,91,83,90,83,88,84,87,86,87,88,88,90,32,75,86,89,86,0,80,83,83,82,82,83,81,83,80,82,80,81,81,80,82,80,83,81,83,83,82,85,81,86,32,81,81,81,82,82,82,82,81,81,81,0,80,84,81,80,80,81,80,83,81,84,83,84,84,83,84,81,83,80,81,80,32,82,81,81,82,82,83,83,82,82,81,0,78,86,80,79,84,85,32,84,79,80,85,32,78,82,86,82,0,77,87,82,75,81,77,79,80,77,82,32,82,75,83,77,85,80,87,82,32,82,77,79,81,32,82,77,85,81,32,82,79,80,81,32,82,79,84,81,32,81,81,83,81,32,77,82,87,82,0,77,87,77,82,77,81,78,79,79,78,81,77,83,77,85,78,86,79,87,81,87,82,32,80,78,84,78,32,79,79,85,79,32,78,80,86,80,32,78,81,86,81,32,77,82,87,82,0,76,82,76,70,76,82,82,82,76,70,32,76,73,80,81,32,76,76,79,82,32,76,79,77,81,0,77,87,82,75,81,77,79,80,77,82,32,82,75,83,77,85,80,87,82,0,77,87,87,82,87,81,86,79,85,78,83,77,81,77,79,78,78,79,77,81,77,82,0,71,93,93,82,93,80,92,77,90,74,87,72,84,71,80,71,77,72,74,74,72,77,71,80,71,82,0,77,87,77,82,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,82,0,76,88,76,80,78,82,81,83,83,83,86,82,88,80,0,82,85,82,85,84,84,85,82,84,80,82,79,0,82,86,82,82,85,80,86,78,86,76,85,75,84,75,0,78,82,82,82,79,80,78,78,78,76,79,75,80,75,0,77,87,87,72,86,71,84,70,81,70,79,71,78,72,77,74,77,76,78,78,79,79,85,83,86,84,87,86,87,88,86,90,85,91,83,92,80,92,78,91,77,90,0,71,93,73,87,72,86,71,84,71,81,72,79,73,78,75,77,77,77,79,78,80,79,84,85,85,86,87,87,89,87,91,86,92,85,93,83,93,80,92,78,91,77,0,71,93,82,82,84,85,85,86,87,87,89,87,91,86,92,85,93,83,93,81,92,79,91,78,89,77,87,77,85,78,84,79,80,85,79,86,77,87,75,87,73,86,72,85,71,83,71,81,72,79,73,78,75,77,77,77,79,78,80,79,82,82,0,72,92,75,70,75,91,32,72,70,91,70,81,80,91,90,32,90,86,91,89,92,91,32,90,86,90,89,32,87,89,90,89,32,87,89,90,90,92,91,0,75,89,85,65,82,66,80,67,78,69,76,72,75,76,75,82,76,85,78,87,81,88,83,88,86,87,88,85,89,82,32,75,80,76,77,78,75,81,74,83,74,86,75,88,77,89,80,89,86,88,90,86,93,84,95,82,96,79,97,0,62,102,62,82,102,82,0,68,96,68,96,96,68,0,82,82,82,62,82,102,0,68,96,68,68,96,96,0,68,96,68,82,96,82,0,70,94,70,89,94,75,0,75,89,75,94,89,70,0,75,89,75,70,89,94,0,70,94,70,75,94,89,0,75,89,75,82,89,82,0,77,87,77,87,87,77,0,77,87,77,77,87,87,0,68,96,68,79,71,81,75,83,80,84,84,84,89,83,93,81,96,79,0,80,85,85,68,83,71,81,75,80,80,80,84,81,89,83,93,85,96,0,79,84,79,68,81,71,83,75,84,80,84,84,83,89,81,93,79,96,0,68,96,68,85,71,83,75,81,80,80,84,80,89,81,93,83,96,85,0,75,89,82,74,89,78,75,86,82,90,0,74,90,74,82,78,75,86,89,90,82,0,75,89,75,86,75,78,89,86,89,78,0,74,90,76,88,74,80,90,84,88,76,0,74,90,74,93,76,93,79,92,81,91,84,88,85,86,86,83,86,79,85,76,84,74,83,73,81,73,80,74,79,76,78,79,78,83,79,86,80,88,83,91,85,92,88,93,90,93,0,73,93,93,90,93,88,92,85,91,83,88,80,86,79,83,78,79,78,76,79,74,80,73,81,73,83,74,84,76,85,79,86,83,86,86,85,88,84,91,81,92,79,93,76,93,74,0,74,90,90,71,88,71,85,72,83,73,80,76,79,78,78,81,78,85,79,88,80,90,81,91,83,91,84,90,85,88,86,85,86,81,85,78,84,76,81,73,79,72,76,71,74,71,0,71,91,71,74,71,76,72,79,73,81,76,84,78,85,81,86,85,86,88,85,90,84,91,83,91,81,90,80,88,79,85,78,81,78,78,79,76,80,73,83,72,85,71,88,71,90,0,69,91,69,80,70,82,72,84,74,85,77,86,81,86,85,85,88,83,90,80,91,78,90,76,87,76,83,77,81,78,78,80,76,83,75,86,75,89,76,92,77,94,0,69,89,69,84,72,86,75,87,80,87,83,86,86,84,88,81,89,78,89,76,88,75,86,75,83,76,80,78,78,81,77,84,77,89,78,92,80,95,0,79,85,81,79,79,81,79,83,81,85,83,85,85,83,85,81,83,79,81,79,32,81,80,80,81,80,83,81,84,83,84,84,83,84,81,83,80,81,80,32,82,81,81,82,82,83,83,82,82,81,0,68,96,68,82,74,82,32,79,82,85,82,32,90,82,96,82,0,68,96,68,85,68,79,96,79,96,85,0,74,90,82,68,74,82,32,82,68,90,82,0,68,96,68,82,96,82,32,74,89,90,89,32,80,96,84,96,0,68,96,68,82,96,82,32,68,82,82,98,32,96,82,82,98,0,75,89,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,83,89,81,88,78,86,76,83,75,81,75,0,76,88,76,76,76,88,88,88,88,76,76,76,0,75,89,82,74,75,86,89,86,82,74,0,76,88,82,72,76,82,82,92,88,82,82,72,0,74,90,82,73,80,79,74,79,79,83,77,89,82,85,87,89,85,83,90,79,84,79,82,73,0,75,89,82,75,82,89,32,75,82,89,82,0,77,87,77,77,87,87,32,87,77,77,87,0,77,87,82,76,82,88,32,77,79,87,85,32,87,79,77,85,0,78,86,81,78,79,79,78,81,78,83,79,85,81,86,83,86,85,85,86,83,86,81,85,79,83,78,81,78,32,79,81,79,83,32,80,80,80,84,32,81,79,81,85,32,82,79,82,85,32,83,79,83,85,32,84,80,84,84,32,85,81,85,83,0,78,86,78,78,78,86,86,86,86,78,78,78,32,79,79,79,85,32,80,79,80,85,32,81,79,81,85,32,82,79,82,85,32,83,79,83,85,32,84,79,84,85,32,85,79,85,85,0,77,87,82,76,77,85,87,85,82,76,32,82,79,79,84,32,82,79,85,84,32,82,82,81,84,32,82,82,83,84,0,76,85,76,82,85,87,85,77,76,82,32,79,82,84,85,32,79,82,84,79,32,82,82,84,83,32,82,82,84,81,0,77,87,82,88,87,79,77,79,82,88,32,82,85,85,80,32,82,85,79,80,32,82,82,83,80,32,82,82,81,80,0,79,88,88,82,79,77,79,87,88,82,32,85,82,80,79,32,85,82,80,85,32,82,82,80,81,32,82,82,80,83,0,76,88,82,76,78,87,88,80,76,80,86,87,82,76,32,82,82,82,76,32,82,82,76,80,32,82,82,78,87,32,82,82,86,87,32,82,82,88,80,0,77,87,82,76,82,88,32,79,79,85,79,32,77,85,79,87,81,88,83,88,85,87,87,85,0,76,88,82,76,82,88,32,76,81,77,79,87,79,88,81,32,80,87,84,87,0,75,89,77,78,87,88,32,87,78,77,88,32,79,76,76,79,75,81,32,85,76,88,79,89,81,0,73,91,78,73,73,91,32,86,73,91,91,32,77,77,91,91,32,87,77,73,91,32,78,73,86,73,32,77,77,87,77,0,73,91,82,71,82,86,32,77,74,87,80,32,87,74,77,80,32,73,86,76,92,32,91,86,88,92,32,73,86,91,86,32,76,92,88,92,0,71,91,77,74,83,86,32,75,80,83,76,32,71,92,91,92,91,82,71,92,0,76,88,80,76,80,80,76,80,76,84,80,84,80,88,84,88,84,84,88,84,88,80,84,80,84,76,80,76,0,75,89,89,80,88,78,86,76,83,75,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,84,32,89,80,87,78,85,77,83,77,81,78,80,79,79,81,79,83,80,85,81,86,83,87,85,87,87,86,89,84,0,75,89,82,74,75,86,89,86,82,74,32,82,90,89,78,75,78,82,90,0,71,93,80,73,80,71,81,70,83,70,84,71,84,73,32,71,90,72,88,74,86,75,84,76,80,76,75,77,74,79,73,85,73,87,74,88,75,88,80,89,84,90,86,92,88,93,90,32,71,90,93,90,32,81,90,80,91,81,92,83,92,84,91,83,90,0,74,90,82,77,82,83,32,82,83,81,92,32,82,83,83,92,32,81,92,83,92,32,82,77,81,74,80,72,78,71,32,81,74,78,71,32,82,77,83,74,84,72,86,71,32,83,74,86,71,32,82,77,78,75,76,75,74,77,32,80,76,76,76,74,77,32,82,77,86,75,88,75,90,77,32,84,76,88,76,90,77,32,82,77,80,78,79,79,79,82,32,82,77,80,79,79,82,32,82,77,84,78,85,79,85,82,32,82,77,84,79,85,82,0,74,90,82,73,82,75,32,82,78,82,80,32,82,83,82,85,32,82,89,81,92,32,82,89,83,92,32,81,92,83,92,32,82,71,81,73,80,74,32,82,71,83,73,84,74,32,80,74,82,73,84,74,32,82,75,80,78,78,79,77,78,32,82,75,84,78,86,79,87,78,32,78,79,80,79,82,78,84,79,86,79,32,82,80,80,83,78,84,76,84,75,82,75,83,76,84,32,82,80,84,83,86,84,88,84,89,82,89,83,88,84,32,78,84,80,84,82,83,84,84,86,84,32,82,85,80,88,79,89,77,90,76,90,75,89,74,87,74,89,76,90,32,82,85,84,88,85,89,87,90,88,90,89,89,90,87,90,89,88,90,32,77,90,79,90,82,89,85,90,87,90,0,74,90,82,89,81,92,32,82,89,83,92,32,81,92,83,92,32,82,89,85,90,88,90,90,88,90,85,89,84,87,84,89,82,90,79,89,77,87,76,85,77,86,74,85,72,83,71,81,71,79,72,78,74,79,77,77,76,75,77,74,79,75,82,77,84,75,84,74,85,74,88,76,90,79,90,82,89,0,74,90,82,89,81,92,32,82,89,83,92,32,81,92,83,92,32,82,89,86,88,86,86,88,85,88,82,90,81,90,76,89,73,88,72,86,72,84,71,80,71,78,72,76,72,75,73,74,76,74,81,76,82,76,85,78,86,78,88,82,89,0,73,91,73,80,75,82,32,76,75,78,80,32,82,71,82,79,32,88,75,86,80,32,91,80,89,82,0,81,83,82,81,81,82,82,83,83,82,82,81,0,80,84,81,80,80,81,80,83,81,84,83,84,84,83,84,81,83,80,81,80,0,78,86,81,78,79,79,78,81,78,83,79,85,81,86,83,86,85,85,86,83,86,81,85,79,83,78,81,78,0,77,87,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,81,86,79,85,78,83,77,81,77,0,71,93,80,71,77,72,74,74,72,77,71,80,71,84,72,87,74,90,77,92,80,93,84,93,87,92,90,90,92,87,93,84,93,80,92,77,90,74,87,72,84,71,80,71,0,65,99,80,65,76,66,74,67,71,69,69,71,67,74,66,76,65,80,65,84,66,88,67,90,69,93,71,95,74,97,76,98,80,99,84,99,88,98,90,97,93,95,95,93,97,90,98,88,99,84,99,80,98,76,97,74,95,71,93,69,90,67,88,66,84,65,80,65,0,60,104,80,60,75,61,71,63,68,65,65,68,63,71,61,75,60,80,60,84,61,89,63,93,65,96,68,99,71,101,75,103,80,104,84,104,89,103,93,101,96,99,99,96,101,93,103,89,104,84,104,80,103,75,101,71,99,68,96,65,93,63,89,61,84,60,80,60,0,41,123,79,41,73,42,69,43,64,45,59,48,55,51,51,55,48,59,45,64,43,69,42,73,41,79,41,85,42,91,43,95,45,100,48,105,51,109,55,113,59,116,64,119,69,121,73,122,79,123,85,123,91,122,95,121,100,119,105,116,109,113,113,109,116,105,119,100,121,95,122,91,123,85,123,79,122,73,121,69,119,64,116,59,113,55,109,51,105,48,100,45,95,43,91,42,85,41,79,41,0,62,102,82,65,80,67,77,68,74,68,71,67,69,65,62,72,64,74,65,77,65,90,66,93,68,95,71,96,77,96,80,97,82,99,32,82,65,84,67,87,68,90,68,93,67,95,65,102,72,100,74,99,77,99,90,98,93,96,95,93,96,87,96,84,97,82,99,0,65,99,82,65,80,67,77,68,74,68,71,67,69,65,66,71,65,75,65,80,66,84,68,88,71,92,76,96,82,99,32,82,65,84,67,87,68,90,68,93,67,95,65,98,71,99,75,99,80,98,84,96,88,93,92,88,96,82,99,32,66,72,98,72,0,72,91,87,80,86,81,87,82,88,81,88,80,86,78,84,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,76,98,88,70,0,75,89,82,75,77,88,32,82,78,86,88,32,82,75,87,88,32,79,84,84,84,32,75,88,80,88,32,84,88,89,88,0,74,90,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,78,86,80,83,81,32,83,75,85,76,86,78,85,80,83,81,32,79,81,83,81,86,82,87,84,87,85,86,87,83,88,76,88,32,83,81,85,82,86,84,86,85,85,87,83,88,0,75,89,86,76,87,75,87,79,86,76,84,75,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,87,85,32,81,75,79,77,78,80,78,83,79,86,81,88,0,74,90,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,77,88,80,88,83,87,86,86,87,83,88,76,88,32,83,75,85,76,86,77,87,80,87,83,86,86,85,87,83,88,0,74,89,78,75,78,88,32,79,75,79,88,32,83,79,83,83,32,76,75,86,75,86,79,85,75,32,79,81,83,81,32,76,88,86,88,86,84,85,88,0,74,88,78,75,78,88,32,79,75,79,88,32,83,79,83,83,32,76,75,86,75,86,79,85,75,32,79,81,83,81,32,76,88,81,88,0,75,91,86,76,87,75,87,79,86,76,84,75,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,32,81,75,79,77,78,80,78,83,79,86,81,88,32,84,88,85,87,86,85,32,86,83,86,88,32,87,83,87,88,32,84,83,89,83,0,74,91,78,75,78,88,32,79,75,79,88,32,86,75,86,88,32,87,75,87,88,32,76,75,81,75,32,84,75,89,75,32,79,81,86,81,32,76,88,81,88,32,84,88,89,88,0,78,87,82,75,82,88,32,83,75,83,88,32,80,75,85,75,32,80,88,85,88,0,76,88,83,75,83,85,82,87,81,88,32,84,75,84,85,83,87,81,88,80,88,78,87,77,85,78,84,79,85,78,86,32,81,75,86,75,0,74,90,78,75,78,88,32,79,75,79,88,32,87,75,79,83,32,81,81,86,88,32,82,81,87,88,32,76,75,81,75,32,84,75,89,75,32,76,88,81,88,32,84,88,89,88,0,75,88,79,75,79,88,32,80,75,80,88,32,77,75,82,75,32,77,88,87,88,87,84,86,88,0,73,92,77,75,77,88,32,78,78,82,88,32,78,75,82,85,32,87,75,82,88,32,87,75,87,88,32,88,75,88,88,32,75,75,78,75,32,87,75,90,75,32,75,88,79,88,32,85,88,90,88,0,74,90,78,75,78,88,32,79,77,86,88,32,79,75,86,86,32,86,75,86,88,32,76,75,79,75,32,84,75,88,75,32,76,88,80,88,0,75,90,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,87,86,88,83,88,80,87,77,86,76,84,75,81,75,32,81,75,79,77,78,80,78,83,79,86,81,88,32,84,88,86,86,87,83,87,80,86,77,84,75,0,74,89,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,78,87,79,86,81,83,82,79,82,32,83,75,85,76,86,78,86,79,85,81,83,82,32,76,88,81,88,0,75,90,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,87,86,88,83,88,80,87,77,86,76,84,75,81,75,32,81,75,79,77,78,80,78,83,79,86,81,88,32,84,88,86,86,87,83,87,80,86,77,84,75,32,80,87,80,85,81,84,83,84,84,85,85,90,86,91,87,91,88,90,32,84,85,85,88,86,90,87,91,0,74,90,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,78,87,79,86,81,83,82,79,82,32,83,75,85,76,86,78,86,79,85,81,83,82,32,76,88,81,88,32,83,82,84,83,85,87,86,88,87,88,88,87,32,83,82,85,83,86,87,87,88,0,75,90,86,77,87,75,87,79,86,77,85,76,83,75,81,75,79,76,78,77,78,79,79,80,81,81,84,82,86,83,87,84,32,78,78,79,79,81,80,84,81,86,82,87,83,87,86,86,87,84,88,82,88,80,87,79,86,78,84,78,88,79,86,0,75,90,82,75,82,88,32,83,75,83,88,32,78,75,77,79,77,75,88,75,88,79,87,75,32,80,88,85,88,0,74,91,78,75,78,85,79,87,81,88,84,88,86,87,87,85,87,75,32,79,75,79,85,80,87,81,88,32,76,75,81,75,32,85,75,89,75,0,75,89,77,75,82,88,32,78,75,82,85,32,87,75,82,88,32,75,75,80,75,32,84,75,89,75,0,73,91,76,75,79,88,32,77,75,79,84,32,82,75,79,88,32,82,75,85,88,32,83,75,85,84,32,88,75,85,88,32,74,75,79,75,32,86,75,90,75,0,75,90,78,75,86,88,32,79,75,87,88,32,87,75,78,88,32,76,75,81,75,32,84,75,89,75,32,76,88,81,88,32,84,88,89,88,0,76,89,78,75,82,82,82,88,32,79,75,83,82,32,87,75,83,82,83,88,32,76,75,81,75,32,84,75,89,75,32,80,88,85,88,0,76,89,86,75,78,88,32,87,75,79,88,32,79,75,78,79,78,75,87,75,32,78,88,87,88,87,84,86,88,0,75,88,79,75,79,88,32,80,75,80,88,32,77,75,87,75,87,79,86,75,32,77,88,82,88,0,75,89,82,75,76,88,32,82,77,87,88,32,82,75,88,88,32,77,87,86,87,32,76,88,88,88,0,75,90,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,87,86,88,83,88,80,87,77,86,76,84,75,81,75,32,81,75,79,77,78,80,78,83,79,86,81,88,32,84,88,86,86,87,83,87,80,86,77,84,75,32,81,79,81,84,32,84,79,84,84,32,81,81,84,81,32,81,82,84,82,0,75,89,82,75,77,88,32,82,78,86,88,32,82,75,87,88,32,75,88,80,88,32,84,88,89,88,0,74,90,77,74,76,77,32,88,74,87,77,32,80,80,79,83,32,85,80,84,83,32,77,86,76,89,32,88,86,87,89,32,77,75,87,75,32,77,76,87,76,32,80,81,84,81,32,80,82,84,82,32,77,87,87,87,32,77,88,87,88,0,74,91,78,75,78,88,32,79,75,79,88,32,86,75,86,88,32,87,75,87,88,32,76,75,89,75,32,76,88,81,88,32,84,88,89,88,0,75,91,77,75,82,81,32,78,75,83,81,77,88,32,77,75,87,75,88,79,86,75,32,78,87,87,87,32,77,88,87,88,88,84,86,88,0,75,90,77,79,78,76,79,75,80,75,81,76,82,79,82,88,32,88,79,87,76,86,75,85,75,84,76,83,79,83,88,32,77,79,78,77,79,76,80,76,81,77,82,79,32,88,79,87,77,86,76,85,76,84,77,83,79,32,80,88,85,88,0,75,90,82,75,82,88,32,83,75,83,88,32,81,78,78,79,77,81,77,82,78,84,81,85,84,85,87,84,88,82,88,81,87,79,84,78,81,78,32,81,78,79,79,78,81,78,82,79,84,81,85,32,84,85,86,84,87,82,87,81,86,79,84,78,32,80,75,85,75,32,80,88,85,88,0,74,91,82,75,82,88,32,83,75,83,88,32,76,80,77,79,78,79,79,83,81,85,32,84,85,86,83,87,79,88,79,89,80,32,77,79,78,82,79,84,81,85,84,85,86,84,87,82,88,79,32,80,75,85,75,32,80,88,85,88,0,75,90,77,86,78,88,81,88,77,82,77,79,78,77,79,76,81,75,84,75,86,76,87,77,88,79,88,82,84,88,87,88,88,86,32,79,85,78,82,78,79,79,77,81,75,32,84,75,86,77,87,79,87,82,86,85,32,78,87,80,87,32,85,87,87,87,0,75,89,84,75,75,88,32,83,77,84,88,32,84,75,85,88,32,78,84,84,84,32,73,88,78,88,32,82,88,87,88,0,74,89,80,75,76,88,32,81,75,77,88,32,78,75,85,75,87,76,87,78,86,80,83,81,32,85,75,86,76,86,78,85,80,83,81,32,79,81,82,81,84,82,85,83,85,85,84,87,81,88,74,88,32,82,81,84,83,84,85,83,87,81,88,0,75,88,86,76,87,76,88,75,87,78,86,76,84,75,82,75,80,76,79,77,78,79,77,82,77,85,78,87,80,88,82,88,84,87,85,85,32,82,75,80,77,79,79,78,82,78,86,80,88,0,74,89,80,75,76,88,32,81,75,77,88,32,78,75,84,75,86,76,87,78,87,81,86,84,85,86,84,87,81,88,74,88,32,84,75,85,76,86,78,86,81,85,84,84,86,83,87,81,88,0,74,89,80,75,76,88,32,81,75,77,88,32,83,79,82,83,32,78,75,88,75,87,78,87,75,32,79,81,82,81,32,74,88,84,88,85,85,83,88,0,74,88,80,75,76,88,32,81,75,77,88,32,83,79,82,83,32,78,75,88,75,87,78,87,75,32,79,81,82,81,32,74,88,79,88,0,75,89,86,76,87,76,88,75,87,78,86,76,84,75,82,75,80,76,79,77,78,79,77,82,77,85,78,87,80,88,82,88,84,87,85,86,86,83,32,82,75,80,77,79,79,78,82,78,86,80,88,32,82,88,84,86,85,83,32,83,83,88,83,0,74,91,80,75,76,88,32,81,75,77,88,32,88,75,84,88,32,89,75,85,88,32,78,75,83,75,32,86,75,91,75,32,79,81,86,81,32,74,88,79,88,32,82,88,87,88,0,78,87,84,75,80,88,32,85,75,81,88,32,82,75,87,75,32,78,88,83,88,0,76,88,85,75,82,85,81,87,80,88,32,86,75,83,85,82,87,80,88,79,88,77,87,76,85,77,84,78,85,77,86,32,83,75,88,75,0,74,90,80,75,76,88,32,81,75,77,88,32,89,75,79,82,32,82,80,84,88,32,83,80,85,88,32,78,75,83,75,32,86,75,91,75,32,74,88,79,88,32,82,88,87,88,0,75,88,81,75,77,88,32,82,75,78,88,32,79,75,84,75,32,75,88,85,88,86,85,84,88,0,73,92,79,75,75,88,32,79,77,80,88,32,80,75,81,86,32,89,75,80,88,32,89,75,85,88,32,90,75,86,88,32,77,75,80,75,32,89,75,92,75,32,73,88,77,88,32,83,88,88,88,0,74,90,80,75,76,88,32,80,75,84,88,32,81,75,84,85,32,88,75,84,88,32,78,75,81,75,32,86,75,90,75,32,74,88,78,88,0,75,89,82,75,80,76,79,77,78,79,77,82,77,85,78,87,80,88,82,88,84,87,85,86,86,84,87,81,87,78,86,76,84,75,82,75,32,82,75,80,77,79,79,78,82,78,86,80,88,32,82,88,84,86,85,84,86,81,86,77,84,75,0,74,89,80,75,76,88,32,81,75,77,88,32,78,75,85,75,87,76,88,77,88,79,87,81,84,82,79,82,32,85,75,87,77,87,79,86,81,84,82,32,74,88,79,88,0,75,89,82,75,80,76,79,77,78,79,77,82,77,85,78,87,80,88,82,88,84,87,85,86,86,84,87,81,87,78,86,76,84,75,82,75,32,82,75,80,77,79,79,78,82,78,86,80,88,32,82,88,84,86,85,84,86,81,86,77,84,75,32,79,87,79,86,80,85,81,85,82,86,82,90,83,91,84,91,85,90,32,82,86,83,90,84,91,0,74,90,80,75,76,88,32,81,75,77,88,32,78,75,85,75,87,76,88,77,88,79,87,81,84,82,79,82,32,85,75,87,77,87,79,86,81,84,82,32,83,82,84,87,85,88,86,88,87,87,32,83,82,84,83,85,87,86,88,32,74,88,79,88,0,75,90,87,76,88,76,89,75,88,78,87,76,85,75,82,75,80,76,79,77,79,79,80,80,85,83,86,84,32,79,78,80,79,85,82,86,83,86,86,85,87,83,88,80,88,78,87,77,85,76,88,77,87,78,87,0,75,90,84,75,80,88,32,85,75,81,88,32,80,75,78,78,79,75,90,75,89,78,89,75,32,78,88,83,88,0,74,91,80,75,77,85,77,87,79,88,83,88,85,87,86,85,89,75,32,81,75,78,85,78,87,79,88,32,78,75,83,75,32,87,75,91,75,0,75,89,79,75,80,88,32,80,75,81,86,32,89,75,80,88,32,77,75,82,75,32,86,75,91,75,0,73,91,78,75,77,88,32,79,75,78,86,32,84,75,77,88,32,84,75,83,88,32,85,75,84,86,32,90,75,83,88,32,76,75,81,75,32,88,75,92,75,0,75,90,80,75,84,88,32,81,75,85,88,32,89,75,76,88,32,78,75,83,75,32,86,75,91,75,32,74,88,79,88,32,82,88,87,88,0,76,89,80,75,82,81,80,88,32,81,75,83,81,32,89,75,83,81,81,88,32,78,75,83,75,32,86,75,91,75,32,78,88,83,88,0,76,89,88,75,76,88,32,89,75,77,88,32,81,75,79,78,80,75,89,75,32,76,88,85,88,86,85,84,88,0,75,90,77,72,88,92,0,74,90,82,77,76,87,32,82,77,88,87,0,76,90,81,79,80,80,80,81,79,81,79,80,81,79,84,79,86,81,86,87,87,88,88,88,32,84,79,85,81,85,87,87,88,32,85,82,82,83,80,84,79,85,79,87,80,88,83,88,84,87,85,85,32,82,83,80,85,80,87,81,88,0,74,89,78,75,78,88,32,79,75,79,88,32,79,82,80,80,82,79,84,79,86,80,87,82,87,85,86,87,84,88,82,88,80,87,79,85,32,84,79,85,80,86,82,86],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+245772);allocate([85,85,87,84,88,32,76,75,79,75,0,76,88,86,81,85,81,85,82,86,82,86,81,85,80,83,79,81,79,79,80,78,82,78,85,79,87,81,88,83,88,85,87,86,86,32,81,79,80,80,79,82,79,85,80,87,81,88,0,76,91,86,75,86,88,32,87,75,87,88,32,86,82,85,80,83,79,81,79,79,80,78,82,78,85,79,87,81,88,83,88,85,87,86,85,32,81,79,80,80,79,82,79,85,80,87,81,88,32,84,75,87,75,32,86,88,89,88,0,76,88,79,83,86,83,86,82,85,80,83,79,81,79,79,80,78,82,78,85,79,87,81,88,83,88,85,87,86,86,32,85,83,85,81,83,79,32,81,79,80,80,79,82,79,85,80,87,81,88,0,76,87,84,75,85,76,85,77,86,77,86,76,84,75,82,75,80,77,80,88,32,82,75,81,77,81,88,32,78,79,83,79,32,78,88,83,88,0,76,89,81,79,79,81,79,83,81,85,83,85,85,83,85,81,83,79,81,79,32,81,79,80,81,80,83,81,85,32,83,85,84,83,84,81,83,79,32,84,80,85,79,86,79,32,80,84,79,85,79,88,80,89,84,89,86,90,32,79,87,80,88,84,88,86,89,86,91,84,92,80,92,78,91,78,89,80,88,0,74,91,78,75,78,88,32,79,75,79,88,32,79,82,80,80,82,79,84,79,86,80,87,82,87,88,32,84,79,85,80,86,82,86,88,32,76,75,79,75,32,76,88,81,88,32,84,88,89,88,0,78,87,82,75,82,76,83,76,83,75,82,75,32,82,79,82,88,32,83,79,83,88,32,80,79,83,79,32,80,88,85,88,0,78,87,83,75,83,76,84,76,84,75,83,75,32,83,79,83,90,82,92,32,84,79,84,90,82,92,80,92,79,91,79,90,80,90,80,91,79,91,32,81,79,84,79,0,74,90,78,75,78,88,32,79,75,79,88,32,87,79,79,85,32,82,83,86,88,32,83,83,87,88,32,76,75,79,75,32,84,79,89,79,32,76,88,81,88,32,84,88,89,88,0,78,87,82,75,82,88,32,83,75,83,88,32,80,75,83,75,32,80,88,85,88,0,70,95,74,79,74,88,32,75,79,75,88,32,75,82,76,80,78,79,80,79,82,80,83,82,83,88,32,80,79,81,80,82,82,82,88,32,83,82,84,80,86,79,88,79,90,80,91,82,91,88,32,88,79,89,80,90,82,90,88,32,72,79,75,79,32,72,88,77,88,32,80,88,85,88,32,88,88,93,88,0,74,91,78,79,78,88,32,79,79,79,88,32,79,82,80,80,82,79,84,79,86,80,87,82,87,88,32,84,79,85,80,86,82,86,88,32,76,79,79,79,32,76,88,81,88,32,84,88,89,88,0,76,89,81,79,79,80,78,82,78,85,79,87,81,88,84,88,86,87,87,85,87,82,86,80,84,79,81,79,32,81,79,80,80,79,82,79,85,80,87,81,88,32,84,88,85,87,86,85,86,82,85,80,84,79,0,74,89,78,79,78,92,32,79,79,79,92,32,79,82,80,80,82,79,84,79,86,80,87,82,87,85,86,87,84,88,82,88,80,87,79,85,32,84,79,85,80,86,82,86,85,85,87,84,88,32,76,79,79,79,32,76,92,81,92,0,75,89,85,79,85,92,32,86,79,86,92,32,85,82,84,80,82,79,80,79,78,80,77,82,77,85,78,87,80,88,82,88,84,87,85,85,32,80,79,79,80,78,82,78,85,79,87,80,88,32,83,92,88,92,0,75,88,79,79,79,88,32,80,79,80,88,32,80,82,81,80,83,79,85,79,86,80,86,81,85,81,85,80,86,80,32,77,79,80,79,32,77,88,82,88,0,76,89,84,79,85,80,85,81,86,81,86,80,84,79,81,79,79,80,79,82,81,83,84,84,86,85,32,79,81,81,82,84,83,86,84,86,87,84,88,81,88,79,87,79,86,80,86,80,87,81,88,0,76,87,80,75,80,86,82,88,84,88,85,87,85,86,32,81,75,81,86,82,88,32,78,79,84,79,0,74,91,78,79,78,85,79,87,81,88,83,88,85,87,86,85,32,79,79,79,85,80,87,81,88,32,86,79,86,88,32,87,79,87,88,32,76,79,79,79,32,84,79,87,79,32,86,88,89,88,0,75,89,78,79,82,88,32,79,79,82,86,32,86,79,82,88,32,76,79,81,79,32,84,79,88,79,0,73,91,76,79,79,88,32,77,79,79,85,32,82,79,79,88,32,82,79,85,88,32,83,79,85,85,32,88,79,85,88,32,74,79,79,79,32,86,79,90,79,0,75,89,78,79,85,88,32,79,79,86,88,32,86,79,78,88,32,76,79,81,79,32,84,79,88,79,32,76,88,80,88,32,83,88,88,88,0,75,89,78,79,82,88,32,79,79,82,86,32,86,79,82,88,80,91,78,92,77,92,76,91,76,90,77,90,77,91,76,91,32,76,79,81,79,32,84,79,88,79,0,76,88,85,79,78,88,32,86,79,79,88,32,79,79,78,81,78,79,86,79,32,78,88,86,88,86,86,85,88,0,75,91,81,79,79,80,78,81,77,83,77,85,78,87,80,88,81,88,83,87,85,85,87,82,88,79,32,81,79,79,81,78,83,78,85,79,87,80,88,32,81,79,83,79,85,80,87,87,88,88,32,83,79,84,80,86,87,88,88,89,88,0,75,88,82,75,80,77,79,79,77,85,75,92,32,81,76,80,78,78,84,76,92,32,82,75,84,75,86,76,86,78,85,80,82,81,32,84,75,85,76,85,78,84,80,82,81,32,82,81,84,82,85,84,85,86,84,87,82,88,81,88,79,87,78,84,32,82,81,83,82,84,84,84,86,82,88,0,75,89,76,81,78,79,80,79,82,80,83,83,83,88,82,92,32,76,81,78,80,80,80,82,81,83,83,32,87,79,86,82,83,88,81,92,0,75,89,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,86,84,86,82,85,80,82,78,81,76,81,75,82,74,84,74,85,75,86,77,32,81,79,79,81,78,83,78,86,80,88,32,82,88,84,86,85,84,85,81,83,79,32,81,76,82,75,84,75,86,77,0,76,88,86,80,84,79,81,79,79,80,79,81,80,82,82,83,32,81,79,80,80,80,81,82,83,32,82,83,79,84,78,85,78,87,80,88,83,88,85,87,32,82,83,80,84,79,85,79,87,80,88,0,76,87,82,75,81,76,81,77,83,78,86,78,86,77,83,78,80,79,79,80,78,82,78,84,79,86,80,87,82,88,83,89,83,91,82,92,80,92,79,91,32,83,78,81,79,80,80,79,82,79,84,80,86,82,88,0,73,89,74,82,75,80,76,79,78,79,79,80,79,81,77,88,32,77,79,78,80,78,81,76,88,32,79,81,80,80,82,79,84,79,86,80,86,82,83,92,32,84,79,85,80,85,82,82,92,0,73,89,74,83,75,81,76,80,78,80,79,81,79,86,80,88,32,77,80,78,81,78,85,79,87,80,88,81,88,83,87,84,86,85,84,86,81,86,78,85,76,84,75,82,75,81,76,81,78,82,80,85,82,87,83,32,81,88,83,86,84,84,85,81,85,78,84,75,0,78,87,82,79,80,86,80,87,81,88,83,88,85,87,86,85,32,83,79,81,86,81,87,82,88,0,75,89,79,79,76,88,32,80,79,77,88,32,85,79,86,80,87,80,86,79,84,79,82,81,79,82,32,79,82,80,83,82,87,84,88,86,87,87,85,32,79,82,81,83,83,87,84,88,0,76,88,76,75,78,75,80,76,87,88,32,78,75,79,76,86,88,32,82,80,77,88,32,82,80,78,88,0,75,90,79,79,75,92,32,80,79,76,92,32,78,85,78,87,79,88,81,88,83,87,84,86,32,86,79,84,86,84,87,85,88,87,88,88,87,89,85,32,87,79,85,86,85,87,86,88,0,74,89,78,79,77,88,32,79,79,78,85,77,88,32,86,82,86,79,87,79,86,82,84,85,81,87,78,88,77,88,32,76,79,79,79,0,77,88,82,75,81,76,81,77,83,78,86,78,32,84,78,81,79,80,80,80,82,82,83,85,83,32,84,78,82,79,81,80,81,82,82,83,32,83,83,80,84,79,85,79,87,81,88,83,89,84,90,84,91,83,92,81,92,32,83,83,81,84,80,85,80,87,81,88,0,75,88,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,86,84,86,82,85,80,83,79,81,79,32,81,79,79,81,78,83,78,86,80,88,32,82,88,84,86,85,84,85,81,83,79,0,73,90,80,80,77,88,32,80,80,78,88,32,84,80,83,88,32,84,80,84,88,32,75,81,77,79,88,79,32,75,81,77,80,88,80,0,74,88,83,79,81,79,79,80,78,81,77,83,74,92,32,81,79,79,81,78,83,75,92,32,83,79,85,80,86,82,86,84,85,86,84,87,82,88,80,88,78,87,77,85,32,83,79,85,81,85,84,84,86,82,88,0,75,91,89,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,86,84,86,82,85,80,89,80,32,81,79,79,81,78,83,78,86,80,88,32,82,88,84,86,85,84,85,81,83,79,0,75,90,83,80,81,88,32,83,80,82,88,32,77,81,79,79,88,79,32,77,81,79,80,88,80,0,74,88,75,82,76,80,77,79,79,79,80,80,80,82,79,85,79,87,80,88,32,78,79,79,80,79,82,78,85,78,87,80,88,81,88,83,87,85,85,86,82,86,79,85,79,86,80,0,75,90,79,80,78,81,77,83,77,85,78,87,80,88,82,88,85,87,87,85,88,82,88,80,87,79,85,79,84,80,83,82,82,85,79,92,32,77,85,78,86,80,87,82,87,85,86,87,84,88,82,32,88,81,87,80,85,80,83,82,32,82,85,81,88,80,92,0,75,88,77,79,78,79,80,80,83,91,84,92,32,78,79,79,80,82,91,84,92,85,92,32,86,79,84,82,78,89,76,92,0,73,91,84,75,81,92,32,85,75,80,92,32,74,82,75,80,76,79,78,79,79,80,79,86,80,87,83,87,85,86,87,84,32,77,79,78,80,78,84,79,87,80,88,83,88,85,87,87,84,88,82,89,79,0,74,90,78,80,80,80,80,79,78,80,77,81,76,83,76,85,77,87,78,88,80,88,81,87,82,85,83,82,32,76,85,78,87,80,87,82,85,32,82,82,82,87,83,88,85,88,87,86,88,84,88,82,87,80,86,79,86,80,87,80,32,82,85,83,87,85,87,87,86,0,75,90,86,79,84,86,84,87,85,88,87,88,88,87,89,85,32,87,79,85,86,85,87,86,88,32,85,83,85,81,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,86,32,81,79,79,81,78,83,78,86,80,88,0,74,88,79,75,77,82,32,80,75,78,82,78,86,80,88,32,78,82,79,80,81,79,83,79,85,80,86,82,86,84,85,86,84,87,82,88,80,88,78,87,77,85,77,82,32,83,79,85,81,85,84,84,86,82,88,32,77,75,80,75,0,75,88,85,80,85,81,86,81,85,80,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,32,81,79,79,81,78,83,78,86,80,88,0,75,90,87,75,84,86,84,87,85,88,87,88,88,87,89,85,32,88,75,85,86,85,87,86,88,32,85,83,85,81,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,86,32,81,79,79,81,78,83,78,86,80,88,32,85,75,88,75,0,75,87,78,85,82,84,84,83,85,82,85,80,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,32,81,79,79,81,78,83,78,86,80,88,0,77,88,87,75,88,76,88,75,86,75,84,76,83,78,80,89,79,91,78,92,32,86,75,85,76,84,78,81,89,80,91,78,92,76,92,76,91,77,92,32,80,79,86,79,0,75,89,86,79,84,86,83,89,82,91,32,87,79,85,86,84,89,82,91,80,92,77,92,76,91,77,91,78,92,32,85,83,85,81,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,86,32,81,79,79,81,78,83,78,86,80,88,0,75,90,80,75,76,88,32,81,75,77,88,32,79,81,80,80,82,79,84,79,86,80,86,82,85,85,85,87,86,88,32,84,79,85,80,85,82,84,85,84,87,85,88,87,88,88,87,89,85,32,78,75,81,75,0,77,87,83,75,83,76,84,76,84,75,83,75,32,78,82,79,80,80,79,82,79,83,80,83,82,82,85,82,87,83,88,32,81,79,82,80,82,82,81,85,81,87,82,88,84,88,85,87,86,85,0,77,87,84,75,84,76,85,76,85,75,84,75,32,79,82,80,80,81,79,83,79,84,80,84,82,82,89,81,91,79,92,77,92,77,91,78,92,32,82,79,83,80,83,82,81,89,80,91,79,92,0,75,88,80,75,76,88,32,81,75,77,88,32,86,80,85,81,86,81,86,80,85,79,84,79,82,81,80,82,79,82,32,79,82,80,83,81,87,82,88,84,88,85,87,86,85,32,79,82,81,83,82,87,83,88,32,78,75,81,75,0,78,86,83,75,80,86,80,87,81,88,83,88,84,87,85,85,32,84,75,81,86,81,87,82,88,32,81,75,84,75,0,70,94,71,82,72,80,73,79,75,79,76,80,76,81,74,88,32,74,79,75,80,75,81,73,88,32,76,81,77,80,79,79,81,79,83,80,83,81,81,88,32,81,79,82,80,82,81,80,88,32,83,81,84,80,86,79,88,79,90,80,90,82,89,85,89,87,90,88,32,88,79,89,80,89,82,88,85,88,87,89,88,91,88,92,87,93,85,0,74,91,75,82,76,80,77,79,79,79,80,80,80,81,78,88,32,78,79,79,80,79,81,77,88,32,80,81,81,80,83,79,85,79,87,80,87,82,86,85,86,87,87,88,32,85,79,86,80,86,82,85,85,85,87,86,88,88,88,89,87,90,85,0,74,89,75,82,76,80,77,79,79,79,80,80,80,81,77,92,32,78,79,79,80,79,81,76,92,32,80,81,82,79,84,79,86,80,87,82,87,84,86,86,85,87,83,88,81,88,79,86,79,84,32,84,79,86,81,86,84,85,86,83,88,32,74,92,79,92,0,75,89,86,79,82,92,32,87,79,83,92,32,85,83,85,81,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,86,32,81,79,79,81,78,83,78,86,80,88,32,80,92,85,92,0,76,88,77,82,78,80,79,79,81,79,82,80,82,81,80,88,32,80,79,81,80,81,81,79,88,32,82,81,83,80,85,79,86,79,87,80,87,81,86,81,87,80,0,76,89,86,80,86,81,87,81,86,80,84,79,81,79,79,80,79,82,81,83,84,84,86,85,32,79,81,81,82,84,83,86,84,86,87,84,88,81,88,79,87,78,86,79,86,79,87,0,78,87,83,75,80,86,80,87,81,88,83,88,84,87,85,85,32,84,75,81,86,81,87,82,88,32,80,79,85,79,0,73,90,74,82,75,80,76,79,78,79,79,80,79,82,78,85,78,87,79,88,32,77,79,78,80,78,82,77,85,77,87,79,88,81,88,83,87,84,86,32,86,79,84,86,84,87,85,88,87,88,88,87,89,85,32,87,79,85,86,85,87,86,88,0,72,92,73,82,74,80,75,79,77,79,78,80,78,82,77,85,77,87,78,88,32,76,79,77,80,77,82,76,85,76,87,78,88,79,88,81,87,82,86,32,84,79,82,86,82,87,84,88,32,85,79,83,86,83,87,84,88,85,88,87,87,89,85,90,82,90,79,89,79,90,80,0,74,90,77,82,78,80,80,79,82,79,83,80,83,82,32,81,79,82,80,82,82,81,85,80,87,78,88,77,88,76,87,76,86,77,86,76,87,32,88,80,87,81,88,81,88,80,87,79,86,79,84,80,83,82,82,85,82,87,83,88,32,81,85,81,87,82,88,84,88,86,87,87,85,0,73,89,74,82,75,80,76,79,78,79,79,80,79,82,78,85,78,87,79,88,32,77,79,78,80,78,82,77,85,77,87,79,88,81,88,83,87,84,86,32,86,79,84,86,83,89,82,91,32,87,79,85,86,84,89,82,91,80,92,77,92,76,91,77,91,78,92,0,75,89,87,79,87,80,86,81,78,86,77,87,77,88,32,78,81,79,79,82,79,85,81,32,79,80,82,80,85,81,86,81,32,78,86,79,86,82,87,85,87,32,79,86,82,88,85,88,86,86,0,72,91,82,75,83,76,83,77,84,77,84,76,82,75,79,75,77,76,76,78,76,88,32,79,75,78,76,77,78,77,88,32,88,75,89,76,89,77,90,77,90,76,88,75,86,75,84,77,84,88,32,86,75,85,77,85,88,32,74,79,87,79,32,74,88,79,88,32,82,88,87,88,0,74,91,85,75,86,76,87,76,87,75,81,75,79,76,78,78,78,88,32,81,75,80,76,79,78,79,88,32,86,79,86,88,32,87,79,87,88,32,76,79,87,79,32,76,88,81,88,32,84,88,89,88,0,74,91,87,75,81,75,79,76,78,78,78,88,32,81,75,80,76,79,78,79,88,32,85,75,86,76,86,88,32,87,75,87,88,32,76,79,86,79,32,76,88,81,88,32,84,88,89,88,0,70,95,80,75,81,76,81,77,82,77,82,76,80,75,77,75,75,76,74,78,74,88,32,77,75,76,76,75,78,75,88,32,89,75,90,76,91,76,91,75,85,75,83,76,82,78,82,88,32,85,75,84,76,83,78,83,88,32,90,79,90,88,32,91,79,91,88,32,72,79,91,79,32,72,88,77,88,32,80,88,85,88,32,88,88,93,88,0,70,95,80,75,81,76,81,77,82,77,82,76,80,75,77,75,75,76,74,78,74,88,32,77,75,76,76,75,78,75,88,32,91,75,85,75,83,76,82,78,82,88,32,85,75,84,76,83,78,83,88,32,89,75,90,76,90,88,32,91,75,91,88,32,72,79,90,79,32,72,88,77,88,32,80,88,85,88,32,88,88,93,88,0,78,87,82,79,82,88,32,83,79,83,88,32,80,79,83,79,32,80,88,85,88,0,76,88,86,80,84,79,82,79,80,80,79,81,78,83,78,85,79,87,81,88,83,88,85,87,32,82,79,80,81,79,83,79,86,81,88,32,79,83,83,83,0,76,89,83,75,81,76,80,77,79,79,78,82,78,85,79,87,80,88,82,88,84,87,85,86,86,84,87,81,87,78,86,76,85,75,83,75,32,83,75,81,77,80,79,79,83,79,86,80,88,32,82,88,84,86,85,84,86,80,86,77,85,75,32,79,81,86,81,0,75,90,84,75,81,92,32,85,75,80,92,32,81,79,78,80,77,82,77,85,78,87,81,88,84,88,87,87,88,85,88,82,87,80,84,79,81,79,32,81,79,79,80,78,82,78,85,79,87,81,88,32,84,88,86,87,87,85,87,82,86,80,84,79,0,76,88,85,80,86,82,86,81,85,80,83,79,81,79,79,80,78,82,78,84,79,86,82,88,32,81,79,79,81,79,84,80,86,82,88,83,89,83,91,82,92,80,92,0,73,91,86,75,87,76,88,76,86,75,83,75,81,76,80,77,79,79,76,89,75,91,74,92,32,83,75,81,77,80,79,77,89,76,91,74,92,72,92,72,91,73,92,32,90,75,91,76,91,75,89,75,87,76,86,78,83,89,82,91,81,92,32,89,75,88,76,87,78,84,89,83,91,81,92,79,92,79,91,80,92,32,76,79,89,79,0,73,90,86,75,87,76,88,76,88,75,83,75,81,76,80,77,79,79,76,89,75,91,74,92,32,83,75,81,77,80,79,77,89,76,91,74,92,72,92,72,91,73,92,32,86,79,84,86,84,87,85,88,87,88,88,87,89,85,32,87,79,85,86,85,87,86,88,32,76,79,87,79,0,73,90,86,75,87,76,32,88,75,83,75,81,76,80,77,79,79,76,89,75,91,74,92,32,83,75,81,77,80,79,77,89,76,91,74,92,72,92,72,91,73,92,32,87,75,84,86,84,87,85,88,87,88,88,87,89,85,32,88,75,85,86,85,87,86,88,32,76,79,86,79,0,70,94,83,75,84,76,84,77,32,85,76,83,75,80,75,78,76,77,77,76,79,73,89,72,91,71,92,32,80,75,78,77,77,79,74,89,73,91,71,92,69,92,69,91,70,92,32,90,75,91,76,92,76,92,75,87,75,85,76,32,84,77,83,79,80,89,79,91,78,92,32,87,75,85,77,84,79,81,89,80,91,78,92,76,92,76,91,77,92,32,90,79,88,86,88,87,89,88,91,88,92,87,93,85,32,91,79,89,86,89,87,90,88,32,73,79,91,79,0,70,94,83,75,84,76,84,77,32,85,76,83,75,80,75,78,76,77,77,76,79,73,89,72,91,71,92,32,80,75,78,77,77,79,74,89,73,91,71,92,69,92,69,91,70,92,32,90,75,91,76,32,92,75,87,75,85,76,32,84,77,83,79,80,89,79,91,78,92,32,87,75,85,77,84,79,81,89,80,91,78,92,76,92,76,91,77,92,32,91,75,88,86,88,87,89,88,91,88,92,87,93,85,32,92,75,89,86,89,87,90,88,32,73,79,90,79,0,77,87,78,82,79,80,80,79,82,79,83,80,83,82,82,85,82,87,83,88,32,81,79,82,80,82,82,81,85,81,87,82,88,84,88,85,87,86,85,0,79,85,0,76,88,0,76,89,81,75,79,76,78,79,78,84,79,87,81,88,84,88,86,87,87,84,87,79,86,76,84,75,81,75,32,81,75,80,76,79,79,79,84,80,87,81,88,32,84,88,85,87,86,84,86,79,85,76,84,75,0,76,89,80,78,83,75,83,88,32,82,76,82,88,32,79,88,86,88,0,76,89,79,77,79,78,78,78,78,77,79,76,81,75,84,75,86,76,87,78,86,80,84,81,81,82,79,83,78,85,78,88,32,84,75,85,76,86,78,85,80,84,81,32,78,87,79,86,80,86,83,87,86,87,87,86,32,80,86,83,88,86,88,87,86,87,85,0,76,89,79,77,79,78,78,78,78,77,79,76,81,75,84,75,86,76,87,78,86,80,84,81,32,84,75,85,76,86,78,85,80,84,81,32,82,81,84,81,86,82,87,84,87,85,86,87,84,88,81,88,79,87,78,86,78,85,79,85,79,86,32,84,81,85,82,86,84,86,85,85,87,84,88,0,76,89,83,77,83,88,32,84,75,84,88,32,84,75,77,84,88,84,32,81,88,86,88,0,76,89,79,75,78,81,32,79,75,86,75,32,79,76,83,76,86,75,32,78,81,79,80,81,79,84,79,86,80,87,82,87,85,86,87,84,88,81,88,79,87,78,86,78,85,79,85,79,86,32,84,79,85,80,86,82,86,85,85,87,84,88,0,76,89,86,77,86,78,87,78,87,77,86,76,84,75,82,75,80,76,79,77,78,80,78,85,79,87,81,88,84,88,86,87,87,85,87,83,86,81,84,80,81,80,78,82,32,82,75,80,77,79,80,79,85,80,87,81,88,32,84,88,85,87,86,85,86,83,85,81,84,80,0,76,89,78,75,78,79,32,86,77,82,84,80,88,32,87,75,84,81,81,88,32,78,77,80,75,82,75,85,77,32,78,77,80,76,82,76,85,77,86,77,0,76,89,81,75,79,76,78,78,79,80,81,81,84,81,86,80,87,78,86,76,84,75,81,75,32,81,75,80,76,79,78,80,80,81,81,32,84,81,85,80,86,78,85,76,84,75,32,81,81,79,82,78,84,78,85,79,87,81,88,84,88,86,87,87,85,87,84,86,82,84,81,32,81,81,80,82,79,84,79,85,80,87,81,88,32,84,88,85,87,86,85,86,84,85,82,84,81,0,76,89,79,86,79,85,78,85,78,86,79,87,81,88,83,88,85,87,86,86,87,83,87,78,86,76,84,75,81,75,79,76,78,78,78,80,79,82,81,83,84,83,87,81,32,83,88,85,86,86,83,86,78,85,76,84,75,32,81,75,80,76,79,78,79,80,80,82,81,83,0,78,86,82,86,81,87,82,88,83,87,82,86,0,78,86,83,87,82,88,81,87,82,86,83,87,83,89,81,91,0,78,86,82,79,81,80,82,81,83,80,82,79,32,82,86,81,87,82,88,83,87,82,86,0,78,86,82,79,81,80,82,81,83,80,82,79,32,83,87,82,88,81,87,82,86,83,87,83,89,81,91,0,78,86,82,75,81,76,82,83,83,76,82,75,32,82,76,82,79,32,82,86,81,87,82,88,83,87,82,86,0,76,89,78,78,79,78,79,79,78,79,78,78,79,76,81,75,84,75,86,76,87,78,87,79,86,81,83,82,82,83,82,84,83,84,32,84,75,86,77,86,80,85,81,83,82,32,82,87,82,88,83,88,83,87,82,87,0,79,86,82,75,82,80,32,83,75,82,80,0,76,88,79,75,79,80,32,80,75,79,80,32,85,75,85,80,32,86,75,85,80,0,77,87,81,75,80,76,80,78,81,79,83,79,84,78,84,76,83,75,81,75,0,77,87,82,74,82,80,32,79,75,85,79,32,85,75,79,79,0,75,90,88,72,77,92,0,77,87,85,72,83,74,81,77,80,80,80,84,81,87,83,90,85,92,32,83,74,82,76,81,80,81,84,82,88,83,90,0,77,87,79,72,81,74,83,77,84,80,84,84,83,87,81,90,79,92,32,81,74,82,76,83,80,83,84,82,88,81,90,0,77,87,80,72,80,92,32,81,72,81,92,32,80,72,85,72,32,80,92,85,92,0,77,87,83,72,83,92,32,84,72,84,92,32,79,72,84,72,32,79,92,84,92,0,76,87,83,72,82,73,81,75,81,77,82,79,82,80,80,82,82,84,82,85,81,87,81,89,82,91,83,92,32,82,73,81,77,32,81,75,82,79,32,82,85,81,89,32,81,87,82,91,0,77,88,81,72,82,73,83,75,83,77,82,79,82,80,84,82,82,84,82,85,83,87,83,89,82,91,81,92,32,82,73,83,77,32,83,75,82,79,32,82,85,83,89,32,83,87,82,91,0,77,87,84,72,80,82,84,92,0,77,87,80,72,84,82,80,92,0,79,85,82,72,82,92,0,77,87,80,72,80,92,32,84,72,84,92,0,73,91,76,82,88,82,0,73,91,82,76,82,88,32,76,82,88,82,0,74,90,82,77,82,88,32,77,82,87,82,32,77,88,87,88,0,74,90,82,77,82,88,32,77,77,87,77,32,77,82,87,82,0,74,90,77,77,87,87,32,87,77,77,87,0,78,86,82,81,81,82,82,83,83,82,82,81,0,73,91,82,76,81,77,82,78,83,77,82,76,32,76,82,88,82,32,82,86,81,87,82,88,83,87,82,86,0,73,91,76,80,88,80,32,76,84,88,84,0,73,91,87,76,77,88,32,76,80,88,80,32,76,84,88,84,0,73,91,76,78,88,78,32,76,82,88,82,32,76,86,88,86,0,74,90,87,76,77,82,87,88,0,74,90,77,76,87,82,77,88,0,74,90,87,75,77,79,87,83,32,77,84,87,84,32,77,88,87,88,0,74,90,77,75,87,79,77,83,32,77,84,87,84,32,77,88,87,88,0,72,91,89,85,87,85,85,84,84,83,82,80,81,79,79,78,78,78,76,79,75,81,75,82,76,84,78,85,79,85,81,84,82,83,84,80,85,79,87,78,89,78,0,74,90,76,84,76,82,77,80,79,80,85,83,87,83,88,82,32,76,82,77,81,79,81,85,84,87,84,88,82,88,80,0,74,90,77,83,82,80,87,83,32,77,83,82,81,87,83,0,78,86,83,75,80,79,32,83,75,84,76,80,79,0,78,86,81,75,84,79,32,81,75,80,76,84,79,0,76,88,78,75,79,77,81,78,83,78,85,77,86,75,32,78,75,79,78,81,79,83,79,85,78,86,75,0,78,86,83,76,82,77,81,76,82,75,83,76,83,78,81,80,0,78,86,83,75,81,77,81,79,82,80,83,79,82,78,81,79,0,78,86,81,76,82,77,83,76,82,75,81,76,81,78,83,80,0,78,86,81,75,83,77,83,79,82,80,81,79,82,78,83,79,0,74,90,87,77,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,87,87,0,74,90,77,77,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,77,0,74,90,77,77,83,77,85,78,86,79,87,81,87,83,86,85,85,86,83,87,77,87,0,74,90,77,87,77,81,78,79,79,78,81,77,83,77,85,78,86,79,87,81,87,87,0,74,90,87,77,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,87,87,32,77,82,85,82,0,73,91,84,79,85,80,88,82,85,84,84,85,32,85,80,87,82,85,84,32,76,82,87,82,0,77,87,82,77,82,88,32,79,80,80,79,82,76,84,79,85,80,32,80,79,82,77,84,79,0,73,91,80,79,79,80,76,82,79,84,80,85,32,79,80,77,82,79,84,32,77,82,88,82,0,77,87,82,76,82,87,32,79,84,80,85,82,88,84,85,85,84,32,80,85,82,87,84,85,0,75,89,86,83,85,80,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,86,84,87,81,87,78,86,76,84,75,81,75,80,76,81,76,82,75,32,81,79,79,81,78,83,78,86,80,88,32,82,88,84,86,85,84,86,81,86,78,85,76,84,75,0,74,90,76,75,82,88,32,77,75,82,86,32,88,75,82,88,32,76,75,88,75,32,78,76,87,76,0,71,91,73,79,76,79,82,87,32,75,79,82,88,32,91,70,82,88,0,73,91,88,73,88,74,89,74,89,73,88,72,86,72,84,74,83,76,82,79,81,85,80,89,79,91,32,85,73,84,75,83,79,82,85,81,88,80,90,78,92,76,92,75,91,75,90,76,90,76,91,0,73,91,88,73,88,74,89,74,89,73,88,72,86,72,84,74,83,76,82,79,81,85,80,89,79,91,32,85,73,84,75,83,79,82,85,81,88,80,90,78,92,76,92,75,91,75,90,76,90,76,91,32,81,78,79,79,78,81,78,83,79,85,81,86,83,86,85,85,86,83,86,81,85,79,83,78,81,78,0,72,92,90,82,89,84,87,85,86,85,84,84,83,83,81,80,80,79,78,78,77,78,75,79,74,81,74,82,75,84,77,85,78,85,80,84,81,83,83,80,84,79,86,78,87,78,89,79,90,81,90,82,0,74,90,88,75,76,88,32,79,75,80,76,80,78,79,79,77,79,76,78,76,76,77,75,79,75,83,76,86,76,88,75,32,85,84,84,85,84,87,85,88,87,88,88,87,88,85,87,84,85,84,0,74,91,89,80,88,80,88,81,89,81,89,80,88,79,87,79,86,80,85,84,84,86,83,87,81,88,79,88,77,87,76,86,76,84,77,83,79,82,82,80,83,78,83,76,82,75,80,75,79,76,79,78,80,81,85,87,87,88,88,88,89,87,32,79,88,77,86,77,84,79,82,32,79,78,80,80,86,87,87,88,0,74,91,85,80,83,79,81,79,80,81,80,82,81,84,83,84,85,83,32,85,79,85,83,86,84,88,84,89,82,89,81,88,78,86,76,83,75,82,75,79,76,77,78,76,81,76,82,77,85,79,87,82,88,83,88,86,87,0,75,90,81,72,81,92,32,84,72,84,92,32,87,76,86,76,86,77,87,77,87,76,85,75,80,75,78,76,78,78,79,80,86,83,87,84,32,78,78,79,79,86,82,87,84,87,86,86,87,84,88,81,88,79,87,78,86,78,85,79,85,79,86,78,86,0,75,89,80,75,80,91,32,84,75,84,91,32,77,81,87,81,32,77,85,87,85,0,76,88,84,76,83,76,83,77,84,77,84,76,83,75,81,75,80,76,80,78,81,80,84,82,85,83,32,80,78,81,79,84,81,85,83,85,85,83,87,32,81,80,79,82,79,84,80,86,83,88,84,89,32,79,84,80,85,83,87,84,89,84,91,83,92,81,92,80,91,80,90,81,90,81,91,80,91,0,76,88,82,75,81,76,82,77,83,76,82,75,32,82,77,82,81,32,82,81,81,83,82,86,83,83,82,81,32,82,86,82,92,32,80,79,79,78,78,79,79,80,80,79,84,79,85,78,86,79,85,80,84,79,0,76,88,82,77,83,76,82,75,81,76,82,77,82,81,81,82,83,85,82,86,32,82,81,83,82,81,85,82,86,82,90,81,91,82,92,83,91,82,90,32,80,79,79,78,78,79,79,80,80,79,84,79,85,78,86,79,85,80,84,79,32,80,88,79,87,78,88,79,89,80,88,84,88,85,87,86,88,85,89,84,88,0,76,89,86,75,86,88,32,78,75,86,75,32,81,81,86,81,32,78,88,86,88,0,72,92,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,83,89,81,88,78,86,76,83,75,81,75,32,82,81,81,82,82,83,83,82,82,81,0,76,89,81,75,80,76,80,77,81,78,32,84,75,85,76,85,77,84,78,32,82,78,80,79,79,81,79,82,80,84,82,85,83,85,85,84,86,82,86,81,85,79,83,78,82,78,32,82,85,82,89,32,83,85,83,89,32,79,87,86,87,0,76,89,82,75,80,76,79,78,79,79,80,81,82,82,83,82,85,81,86,79,86,78,85,76,83,75,82,75,32,82,82,82,88,32,83,82,83,88,32,79,85,86,85,0,72,92,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,83,89,81,88,78,86,76,83,75,81,75,32,82,75,82,89,32,75,82,89,82,0,74,89,82,82,80,81,79,81,77,82,76,84,76,85,77,87,79,88,80,88,82,87,83,85,83,84,82,82,32,87,77,82,82,32,82,77,87,77,87,82,32,82,77,86,78,87,82,0,74,90,76,76,77,75,79,75,81,76,82,78,82,80,81,82,80,83,78,84,32,79,75,80,76,81,78,81,81,80,83,32,86,75,85,88,32,87,75,84,88,32,78,84,88,84,0,74,89,78,75,78,85,32,79,75,78,82,32,78,82,79,80,81,79,83,79,85,80,86,81,86,84,84,86,84,88,85,89,86,89,87,88,32,83,79,85,81,85,84,84,86,32,76,75,79,75,0,76,89,79,78,82,75,82,81,32,86,78,83,75,83,81,32,82,81,80,82,79,84,79,85,80,87,82,88,83,88,85,87,86,85,86,84,85,82,83,81,32,82,84,82,85,83,85,83,84,82,84,0,74,90,82,75,82,89,32,77,75,77,80,78,82,80,83,84,83,86,82,87,80,87,75,32,76,77,77,75,78,77,32,81,77,82,75,83,77,32,86,77,87,75,88,77,32,79,86,85,86,0,74,89,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,78,87,79,86,81,83,82,79,82,32,83,75,85,76,86,78,86,79,85,81,83,82,32,76,88,86,88,86,85,85,88,0,76,89,87,75,84,75,81,76,79,78,78,81,78,83,79,86,81,88,84,89,87,89,32,87,75,84,76,82,78,81,81,81,83,82,86,84,88,87,89,0,74,90,82,82,80,81,79,81,77,82,76,84,76,85,77,87,79,88,80,88,82,87,83,85,83,84,82,82,32,83,76,81,81,32,87,77,82,82,32,88,81,83,83,0,75,89,80,77,84,87,32,84,77,80,87,32,77,80,87,84,32,87,80,77,84,0,74,91,79,85,77,85,76,86,76,88,77,89,79,89,80,88,80,86,78,84,77,82,77,79,78,77,79,76,81,75,84,75,86,76,87,77,88,79,88,82,87,84,85,86,85,88,86,89,88,89,89,88,89,86,88,85,86,85,32,78,77,80,76,85,76,87,77,0,74,91,79,79,77,79,76,78,76,76,77,75,79,75,80,76,80,78,78,80,77,82,77,85,78,87,79,88,81,89,84,89,86,88,87,87,88,85,88,82,87,80,85,78,85,76,86,75,88,75,89,76,89,78,88,79,86,79,32,78,87,80,88,85,88,87,87,0,70,94,75,72,75,92,32,76,72,76,92,32,88,72,88,92,32,89,72,89,92,32,72,72,92,72,32,72,92,79,92,32,85,92,92,92,0,72,93,75,72,82,81,74,92,32,74,72,81,81,32,74,72,89,72,90,77,88,72,32,75,91,88,91,32,74,92,89,92,90,87,88,92,0,75,89,86,66,84,68,82,71,80,75,79,80,79,84,80,89,82,93,84,96,86,98,32,84,68,82,72,81,75,80,80,80,84,81,89,82,92,84,96,0,75,89,78,66,80,68,82,71,84,75,85,80,85,84,84,89,82,93,80,96,78,98,32,80,68,82,72,83,75,84,80,84,84,83,89,82,92,80,96,0,75,89,79,66,79,98,32,80,66,80,98,32,79,66,86,66,32,79,98,86,98,0,75,89,84,66,84,98,32,85,66,85,98,32,78,66,85,66,32,78,98,85,98,0,74,89,84,66,81,69,80,72,80,74,81,77,83,79,83,80,79,82,83,84,83,85,81,87,80,90,80,92,81,95,84,98,32,82,68,81,71,81,75,82,78,32,82,86,81,89,81,93,82,96,0,75,90,80,66,83,69,84,72,84,74,83,77,81,79,81,80,85,82,81,84,81,85,83,87,84,90,84,92,83,95,80,98,32,82,68,83,71,83,75,82,78,32,82,86,83,89,83,93,82,96,0,75,89,85,64,82,67,80,70,79,73,79,76,80,79,83,86,84,89,84,92,83,95,82,97,32,82,67,81,69,80,72,80,75,81,78,84,85,85,88,85,91,84,94,82,97,79,100,0,75,89,79,64,82,67,84,70,85,73,85,76,84,79,81,86,80,89,80,92,81,95,82,97,32,82,67,83,69,84,72,84,75,83,78,80,85,79,88,79,91,80,94,82,97,85,100,0,65,88,67,82,71,82,82,96,32,71,83,82,97,32,70,83,82,98,32,88,58,82,98,0,70,94,91,67,90,68,91,69,92,68,92,67,91,66,89,66,87,67,85,69,84,71,83,74,82,78,80,90,79,94,78,96,32,86,68,85,70,84,74,82,86,81,90,80,93,79,95,77,97,75,98,73,98,72,97,72,96,73,95,74,96,73,97,0,72,92,82,70,75,91,32,82,70,89,91,32,82,73,88,91,32,77,85,86,85,32,73,91,79,91,32,85,91,91,91,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,85,70,88,71,89,72,90,74,90,76,89,78,88,79,85,80,32,85,70,87,71,88,72,89,74,89,76,88,78,87,79,85,80,32,77,80,85,80,88,81,89,82,90,84,90,87,89,89,88,90,85,91,73,91,32,85,80,87,81,88,82,89,84,89,87,88,89,87,90,85,91,0,71,92,88,73,89,76,89,70,88,73,86,71,83,70,81,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,32,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,83,70,86,71,88,73,89,75,90,78,90,83,89,86,88,88,86,90,83,91,73,91,32,83,70,85,71,87,73,88,75,89,78,89,83,88,86,87,88,85,90,83,91,0,71,92,76,70,76,91,32,77,70,77,91,32,83,76,83,84,32,73,70,89,70,89,76,88,70,32,77,80,83,80,32,73,91,89,91,89,85,88,91,0,71,91,76,70,76,91,32,77,70,77,91,32,83,76,83,84,32,73,70,89,70,89,76,88,70,32,77,80,83,80,32,73,91,80,91,0,71,94,88,73,89,76,89,70,88,73,86,71,83,70,81,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,81,91,83,91,86,90,88,88,32,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,32,88,83,88,91,32,89,83,89,91,32,85,83,92,83,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,79,70,32,85,70,92,70,32,76,80,88,80,32,72,91,79,91,32,85,91,92,91,0,77,88,82,70,82,91,32,83,70,83,91,32,79,70,86,70,32,79,91,86,91,0,75,90,85,70,85,87,84,90,82,91,80,91,78,90,77,88,77,86,78,85,79,86,78,87,32,84,70,84,87,83,90,82,91,32,81,70,88,70,0,70,92,75,70,75,91,32,76,70,76,91,32,89,70,76,83,32,81,79,89,91,32,80,79,88,91,32,72,70,79,70,32,85,70,91,70,32,72,91,79,91,32,85,91,91,91,0,73,91,78,70,78,91,32,79,70,79,91,32,75,70,82,70,32,75,91,90,91,90,85,89,91,0,70,95,75,70,75,91,32,76,70,82,88,32,75,70,82,91,32,89,70,82,91,32,89,70,89,91,32,90,70,90,91,32,72,70,76,70,32,89,70,93,70,32,72,91,78,91,32,86,91,93,91,0,71,94,76,70,76,91,32,77,70,89,89,32,77,72,89,91,32,89,70,89,91,32,73,70,77,70,32,86,70,92,70,32,73,91,79,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,81,70,79,71,77,73,76,75,75,79,75,82,76,86,77,88,79,90,81,91,32,83,91,85,90,87,88,88,86,89,82,89,79,88,75,87,73,85,71,83,70,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,85,70,88,71,89,72,90,74,90,77,89,79,88,80,85,81,77,81,32,85,70,87,71,88,72,89,74,89,77,88,79,87,80,85,81,32,73,91,80,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,81,70,79,71,77,73,76,75,75,79,75,82,76,86,77,88,79,90,81,91,32,83,91,85,90,87,88,88,86,89,82,89,79,88,75,87,73,85,71,83,70,32,78,89,78,88,79,86,81,85,82,85,84,86,85,88,86,95,87,96,89,96,90,94,90,93,32,85,88,86,92,87,94,88,95,89,95,90,94,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,85,70,88,71,89,72,90,74,90,76,89,78,88,79,85,80,77,80,32,85,70,87,71,88,72,89,74,89,76,88,78,87,79,85,80,32,73,91,80,91,32,82,80,84,81,85,82,88,89,89,90,90,90,91,89,32,84,81,85,83,87,90,88,91,90,91,91,89,91,88,0,72,92,88,73,89,70,89,76,88,73,86,71,83,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,85,81,87,82,89,84,32,75,75,77,77,79,78,85,80,87,81,88,82,89,84,89,88,87,90,84,91,81,91,78,90,76,88,75,85,75,91,76,88,0,73,92,82,70,82,91,32,83,70,83,91,32,76,70,75,76,75,70,90,70,90,76,89,70,32,79,91,86,91,0,70,94,75,70,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,70,32,76,70,76,85,77,88,79,90,81,91,32,72,70,79,70,32,86,70,92,70,0,72,92,75,70,82,91,32,76,70,82,88,32,89,70,82,91,32,73,70,79,70,32,85,70,91,70,0,70,94,74,70,78,91,32,75,70,78,86,32,82,70,78,91,32,82,70,86,91,32,83,70,86,86,32,90,70,86,91,32,71,70,78,70,32,87,70,93,70,0,72,92,75,70,88,91,32,76,70,89,91,32,89,70,75,91,32,73,70,79,70,32,85,70,91,70,32,73,91,79,91,32,85,91,91,91,0,72,93,75,70,82,81,82,91,32,76,70,83,81,83,91,32,90,70,83,81,32,73,70,79,70,32,86,70,92,70,32,79,91,86,91,0,72,92,88,70,75,91,32,89,70,76,91,32,76,70,75,76,75,70,89,70,32,75,91,89,91,89,85,88,91,0,73,91,78,70,78,91,32,79,70,79,91,32,75,70,90,70,90,76,89,70,32,75,91,82,91,0,72,92,82,70,74,91,32,82,70,90,91,32,82,73,89,91,32,75,90,89,90,32,74,91,90,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,81,70,79,71,77,73,76,75,75,79,75,82,76,86,77,88,79,90,81,91,32,83,91,85,90,87,88,88,86,89,82,89,79,88,75,87,73,85,71,83,70,32,79,77,79,84,32,85,77,85,84,32,79,80,85,80,32,79,81,85,81,0,72,92,82,70,75,91,32,82,70,89,91,32,82,73,88,91,32,73,91,79,91,32,85,91,91,91,0,71,93,75,69,74,74,32,90,69,89,74,32,79,78,78,83,32,86,78,85,83,32,75,87,74,92,32,90,87,89,92,32,75,71,89,71,32,75,72,89,72,32,79,80,85,80,32,79,81,85,81,32,75,89,89,89,32,75,90,89,90,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,92,70,32,72,91,79,91,32,85,91,92,91,0,72,93,75,70,82,80,74,91,32,74,70,81,80,32,74,70,89,70,90,76,88,70,32,75,90],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+256012);allocate([88,90,32,74,91,89,91,90,85,88,91,0,73,92,75,75,75,73,76,71,77,70,79,70,80,71,81,73,82,77,82,91,32,75,73,77,71,79,71,81,73,32,90,75,90,73,89,71,88,70,86,70,85,71,84,73,83,77,83,91,32,90,73,88,71,86,71,84,73,32,79,91,86,91,0,72,93,82,70,82,91,32,83,70,83,91,32,80,75,77,76,76,77,75,79,75,82,76,84,77,85,80,86,85,86,88,85,89,84,90,82,90,79,89,77,88,76,85,75,80,75,32,80,75,78,76,77,77,76,79,76,82,77,84,78,85,80,86,32,85,86,87,85,88,84,89,82,89,79,88,77,87,76,85,75,32,79,70,86,70,32,79,91,86,91,0,71,94,82,70,82,91,32,83,70,83,91,32,73,77,74,76,76,77,77,81,78,83,79,84,81,85,32,74,76,75,77,76,81,77,83,78,84,81,85,84,85,87,84,88,83,89,81,90,77,91,76,32,84,85,86,84,87,83,88,81,89,77,91,76,92,77,32,79,70,86,70,32,79,91,86,91,0,71,93,74,88,75,91,79,91,77,87,75,83,74,80,74,76,75,73,77,71,80,70,84,70,87,71,89,73,90,76,90,80,89,83,87,87,85,91,89,91,90,88,32,77,87,76,84,75,80,75,76,76,73,78,71,80,70,32,84,70,86,71,88,73,89,76,89,80,88,84,87,87,32,75,90,78,90,32,86,90,89,90,0,72,92,85,70,72,91,32,85,70,86,91,32,84,72,85,91,32,76,85,85,85,32,70,91,76,91,32,82,91,88,91,0,70,94,79,70,73,91,32,80,70,74,91,32,76,70,87,70,90,71,91,73,91,75,90,78,89,79,86,80,32,87,70,89,71,90,73,90,75,89,78,88,79,86,80,32,77,80,86,80,88,81,89,83,89,85,88,88,86,90,82,91,70,91,32,86,80,87,81,88,83,88,85,87,88,85,90,82,91,0,72,93,90,72,91,72,92,70,91,76,91,74,90,72,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,80,91,83,91,85,90,87,88,88,86,32,84,70,82,71,80,73,78,76,77,79,76,83,76,86,77,89,78,90,80,91,0,70,93,79,70,73,91,32,80,70,74,91,32,76,70,85,70,88,71,89,72,90,75,90,79,89,83,87,87,85,89,83,90,79,91,70,91,32,85,70,87,71,88,72,89,75,89,79,88,83,86,87,84,89,82,90,79,91,0,70,93,79,70,73,91,32,80,70,74,91,32,84,76,82,84,32,76,70,91,70,90,76,90,70,32,77,80,83,80,32,70,91,85,91,87,86,84,91,0,70,92,79,70,73,91,32,80,70,74,91,32,84,76,82,84,32,76,70,91,70,90,76,90,70,32,77,80,83,80,32,70,91,77,91,0,72,94,90,72,91,72,92,70,91,76,91,74,90,72,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,80,91,82,91,85,90,87,88,89,84,32,84,70,82,71,80,73,78,76,77,79,76,83,76,86,77,89,78,90,80,91,32,82,91,84,90,86,88,88,84,32,85,84,92,84,0,69,95,78,70,72,91,32,79,70,73,91,32,91,70,85,91,32,92,70,86,91,32,75,70,82,70,32,88,70,95,70,32,76,80,88,80,32,69,91,76,91,32,82,91,89,91,0,76,89,85,70,79,91,32,86,70,80,91,32,82,70,89,70,32,76,91,83,91,0,73,91,88,70,83,87,82,89,81,90,79,91,77,91,75,90,74,88,74,86,75,85,76,86,75,87,32,87,70,82,87,81,89,79,91,32,84,70,91,70,0,70,93,79,70,73,91,32,80,70,74,91,32,93,70,76,83,32,83,79,87,91,32,82,79,86,91,32,76,70,83,70,32,89,70,95,70,32,70,91,77,91,32,83,91,89,91,0,72,92,81,70,75,91,32,82,70,76,91,32,78,70,85,70,32,72,91,87,91,89,85,86,91,0,69,96,78,70,72,91,32,78,70,79,91,32,79,70,80,89,32,92,70,79,91,32,92,70,86,91,32,93,70,87,91,32,75,70,79,70,32,92,70,96,70,32,69,91,75,91,32,83,91,90,91,0,70,95,79,70,73,91,32,79,70,86,88,32,79,73,86,91,32,92,70,86,91,32,76,70,79,70,32,89,70,95,70,32,70,91,76,91,0,71,93,83,70,80,71,78,73,76,76,75,79,74,83,74,86,75,89,76,90,78,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,83,70,32,83,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,78,91,32,81,91,83,90,85,88,87,85,88,82,89,78,89,75,88,72,86,70,0,70,93,79,70,73,91,32,80,70,74,91,32,76,70,88,70,91,71,92,73,92,75,91,78,89,80,85,81,77,81,32,88,70,90,71,91,73,91,75,90,78,88,80,85,81,32,70,91,77,91,0,71,93,83,70,80,71,78,73,76,76,75,79,74,83,74,86,75,89,76,90,78,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,83,70,32,83,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,78,91,32,81,91,83,90,85,88,87,85,88,82,89,78,89,75,88,72,86,70,32,76,89,76,88,77,86,79,85,80,85,82,86,83,88,83,95,84,96,86,96,87,94,87,93,32,83,88,84,94,85,95,86,95,87,94,0,70,94,79,70,73,91,32,80,70,74,91,32,76,70,87,70,90,71,91,73,91,75,90,78,89,79,86,80,77,80,32,87,70,89,71,90,73,90,75,89,78,88,79,86,80,32,82,80,84,81,85,82,86,90,87,91,89,91,90,89,90,88,32,85,82,87,89,88,90,89,90,90,89,32,70,91,77,91,0,71,94,90,72,91,72,92,70,91,76,91,74,90,72,89,71,86,70,82,70,79,71,77,73,77,75,78,77,79,78,86,82,88,84,32,77,75,79,77,86,81,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,85,73,91,74,89,75,89,0,72,93,85,70,79,91,32,86,70,80,91,32,79,70,76,76,78,70,93,70,92,76,92,70,32,76,91,83,91,0,70,95,78,70,75,81,74,85,74,88,75,90,78,91,82,91,85,90,87,88,88,85,92,70,32,79,70,76,81,75,85,75,88,76,90,78,91,32,75,70,82,70,32,89,70,95,70,0,72,92,78,70,79,91,32,79,70,80,89,32,92,70,79,91,32,76,70,82,70,32,88,70,94,70,0,69,95,77,70,75,91,32,78,70,76,89,32,85,70,75,91,32,85,70,83,91,32,86,70,84,89,32,93,70,83,91,32,74,70,81,70,32,90,70,96,70,0,71,93,78,70,85,91,32,79,70,86,91,32,92,70,72,91,32,76,70,82,70,32,88,70,94,70,32,70,91,76,91,32,82,91,88,91,0,72,93,78,70,82,80,79,91,32,79,70,83,80,80,91,32,93,70,83,80,32,76,70,82,70,32,89,70,95,70,32,76,91,83,91,0,71,93,91,70,72,91,32,92,70,73,91,32,79,70,76,76,78,70,92,70,32,72,91,86,91,88,85,85,91,0,72,92,75,73,76,75,88,87,89,89,89,91,32,76,76,88,88,32,75,73,75,75,76,77,88,89,89,91,32,80,80,76,84,75,86,75,88,76,90,75,91,32,75,86,77,90,32,76,84,76,86,77,88,77,90,75,91,32,83,83,88,78,32,86,73,86,76,87,78,89,78,89,76,87,75,86,73,32,86,73,87,76,89,78,0,72,92,81,73,75,91,32,83,73,89,91,32,82,73,88,91,32,77,85,86,85,32,73,91,79,91,32,85,91,91,91,32,81,66,79,67,78,69,78,71,79,73,81,74,83,74,85,73,86,71,86,69,85,67,83,66,81,66,0,71,93,73,66,91,98,0,70,94,82,74,73,90,32,82,74,91,90,0,73,93,78,79,78,80,77,80,77,79,78,78,80,77,84,77,86,78,87,79,88,81,88,88,89,90,90,91,32,87,79,87,88,88,90,90,91,91,91,32,87,81,86,82,80,83,77,84,76,86,76,88,77,90,80,91,83,91,85,90,87,88,32,80,83,78,84,77,86,77,88,78,90,80,91,0,71,92,76,70,76,91,32,77,70,77,91,32,77,80,79,78,81,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,81,91,79,90,77,88,32,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,32,73,70,77,70,0,72,91,87,80,86,81,87,82,88,81,88,80,86,78,84,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,0,72,93,87,70,87,91,32,88,70,88,91,32,87,80,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,85,90,87,88,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,84,70,88,70,32,87,91,91,91,0,72,91,76,83,88,83,88,81,87,79,86,78,84,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,87,83,87,80,86,78,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,0,75,88,85,71,84,72,85,73,86,72,86,71,85,70,83,70,81,71,80,73,80,91,32,83,70,82,71,81,73,81,91,32,77,77,85,77,32,77,91,84,91,0,73,92,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,81,86,79,85,78,83,77,81,77,32,79,78,78,80,78,84,79,86,32,85,86,86,84,86,80,85,78,32,86,79,87,78,89,77,89,78,87,78,32,78,85,77,86,76,88,76,89,77,91,80,92,85,92,88,93,89,94,32,76,89,77,90,80,91,85,91,88,92,89,94,89,95,88,97,85,98,79,98,76,97,75,95,75,94,76,92,79,91,0,71,93,76,70,76,91,32,77,70,77,91,32,77,80,79,78,82,77,84,77,87,78,88,80,88,91,32,84,77,86,78,87,80,87,91,32,73,70,77,70,32,73,91,80,91,32,84,91,91,91,0,77,88,82,70,81,71,82,72,83,71,82,70,32,82,77,82,91,32,83,77,83,91,32,79,77,83,77,32,79,91,86,91,0,77,88,83,70,82,71,83,72,84,71,83,70,32,84,77,84,95,83,97,81,98,79,98,78,97,78,96,79,95,80,96,79,97,32,83,77,83,95,82,97,81,98,32,80,77,84,77,0,71,92,76,70,76,91,32,77,70,77,91,32,87,77,77,87,32,82,83,88,91,32,81,83,87,91,32,73,70,77,70,32,84,77,90,77,32,73,91,80,91,32,84,91,90,91,0,77,88,82,70,82,91,32,83,70,83,91,32,79,70,83,70,32,79,91,86,91,0,66,99,71,77,71,91,32,72,77,72,91,32,72,80,74,78,77,77,79,77,82,78,83,80,83,91,32,79,77,81,78,82,80,82,91,32,83,80,85,78,88,77,90,77,93,78,94,80,94,91,32,90,77,92,78,93,80,93,91,32,68,77,72,77,32,68,91,75,91,32,79,91,86,91,32,90,91,97,91,0,71,93,76,77,76,91,32,77,77,77,91,32,77,80,79,78,82,77,84,77,87,78,88,80,88,91,32,84,77,86,78,87,80,87,91,32,73,77,77,77,32,73,91,80,91,32,84,91,91,91,0,72,92,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,81,77,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,83,91,85,90,87,88,88,85,88,83,87,80,85,78,83,77,0,71,92,76,77,76,98,32,77,77,77,98,32,77,80,79,78,81,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,81,91,79,90,77,88,32,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,32,73,77,77,77,32,73,98,80,98,0,72,92,87,77,87,98,32,88,77,88,98,32,87,80,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,85,90,87,88,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,84,98,91,98,0,73,90,78,77,78,91,32,79,77,79,91,32,79,83,80,80,82,78,84,77,87,77,88,78,88,79,87,80,86,79,87,78,32,75,77,79,77,32,75,91,82,91,0,74,91,87,79,88,77,88,81,87,79,86,78,84,77,80,77,78,78,77,79,77,81,78,82,80,83,85,85,87,86,88,87,32,77,80,78,81,80,82,85,84,87,85,88,86,88,89,87,90,85,91,81,91,79,90,78,89,77,87,77,91,78,89,0,75,90,80,70,80,87,81,90,83,91,85,91,87,90,88,88,32,81,70,81,87,82,90,83,91,32,77,77,85,77,0,71,93,76,77,76,88,77,90,80,91,82,91,85,90,87,88,32,77,77,77,88,78,90,80,91,32,87,77,87,91,32,88,77,88,91,32,73,77,77,77,32,84,77,88,77,32,87,91,91,91,0,73,91,76,77,82,91,32,77,77,82,89,32,88,77,82,91,32,74,77,80,77,32,84,77,90,77,0,70,94,74,77,78,91,32,75,77,78,88,32,82,77,78,91,32,82,77,86,91,32,83,77,86,88,32,90,77,86,91,32,71,77,78,77,32,87,77,93,77,0,72,92,76,77,87,91,32,77,77,88,91,32,88,77,76,91,32,74,77,80,77,32,84,77,90,77,32,74,91,80,91,32,84,91,90,91,0,72,91,76,77,82,91,32,77,77,82,89,32,88,77,82,91,80,95,78,97,76,98,75,98,74,97,75,96,76,97,32,74,77,80,77,32,84,77,90,77,0,73,91,87,77,76,91,32,88,77,77,91,32,77,77,76,81,76,77,88,77,32,76,91,88,91,88,87,87,91,0,71,94,81,77,78,78,76,80,75,82,74,85,74,88,75,90,78,91,80,91,82,90,85,87,87,84,89,80,90,77,32,81,77,79,78,77,80,76,82,75,85,75,88,76,90,78,91,32,81,77,83,77,85,78,86,80,88,88,89,90,90,91,32,83,77,84,78,85,80,87,88,88,90,90,91,91,91,0,71,92,84,70,81,71,79,73,77,77,76,80,75,84,74,90,73,98,32,84,70,82,71,80,73,78,77,77,80,76,84,75,90,74,98,32,84,70,86,70,88,71,89,72,89,75,88,77,87,78,84,79,80,79,32,86,70,88,72,88,75,87,77,86,78,84,79,32,80,79,84,80,86,82,87,84,87,87,86,89,85,90,82,91,80,91,78,90,77,89,76,86,32,80,79,83,80,85,82,86,84,86,87,85,89,84,90,82,91,0,72,92,73,80,75,78,77,77,79,77,81,78,82,79,83,82,83,86,82,90,79,98,32,74,79,76,78,80,78,82,79,32,90,77,89,80,88,82,83,89,80,94,78,98,32,89,77,88,80,87,82,83,89,0,73,92,86,78,84,77,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,87,88,84,88,81,87,79,83,74,82,72,82,70,83,69,85,69,87,70,89,72,32,82,77,80,78,78,81,77,84,77,88,78,90,32,82,91,84,90,86,87,87,84,87,80,86,78,84,75,83,73,83,71,84,70,86,70,89,72,0,73,91,88,80,86,78,84,77,80,77,78,78,78,80,80,82,83,83,32,80,77,79,78,79,80,81,82,83,83,32,83,83,78,84,76,86,76,88,77,90,80,91,83,91,85,90,87,88,32,83,83,79,84,77,86,77,88,78,90,80,91,0,73,91,84,70,82,71,81,72,81,73,82,74,85,75,90,75,90,74,87,75,83,77,80,79,77,82,76,85,76,87,77,89,80,91,83,93,84,95,84,97,83,98,81,98,80,97,32,85,76,81,79,78,82,77,85,77,87,78,89,80,91,0,71,93,72,81,73,79,75,77,78,77,79,78,79,80,78,84,76,91,32,77,77,78,78,78,80,77,84,75,91,32,78,84,80,80,82,78,84,77,86,77,88,78,89,79,89,82,88,87,85,98,32,86,77,88,79,88,82,87,87,84,98,0,70,93,71,81,72,79,74,77,77,77,78,78,78,80,77,85,77,88,78,90,79,91,32,76,77,77,78,77,80,76,85,76,88,77,90,79,91,81,91,83,90,85,88,87,85,88,82,89,77,89,73,88,71,86,70,84,70,82,72,82,74,83,77,85,80,87,82,90,84,32,83,90,85,87,86,85,87,82,88,77,88,73,87,71,86,70,0,76,88,82,77,80,84,79,88,79,90,80,91,83,91,85,89,86,87,32,83,77,81,84,80,88,80,90,81,91,0,72,92,78,77,74,91,32,79,77,75,91,32,88,77,89,78,90,78,89,77,87,77,85,78,81,82,79,83,77,83,32,79,83,81,84,83,90,84,91,32,79,83,80,84,82,90,83,91,85,91,87,90,89,87,0,72,92,75,70,77,70,79,71,80,72,81,74,87,88,88,90,89,91,32,77,70,79,72,80,74,86,88,87,90,89,91,90,91,32,82,77,74,91,32,82,77,75,91,0,70,93,77,77,71,98,32,78,77,72,98,32,77,80,76,86,76,89,78,91,80,91,82,90,84,88,86,85,32,88,77,85,88,85,90,86,91,89,91,91,89,92,87,32,89,77,86,88,86,90,87,91,0,72,92,78,77,76,91,32,79,77,78,83,77,88,76,91,32,89,77,88,81,86,85,32,90,77,89,80,88,82,86,85,84,87,81,89,79,90,76,91,32,75,77,79,77,0,73,90,84,70,82,71,81,72,81,73,82,74,85,75,88,75,32,85,75,81,76,79,77,78,79,78,81,80,83,83,84,86,84,32,85,75,82,76,80,77,79,79,79,81,81,83,83,84,32,83,84,79,85,77,86,76,88,76,90,78,92,83,94,84,95,84,97,82,98,80,98,32,83,84,80,85,78,86,77,88,77,90,79,92,83,94,0,73,91,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,87,88,84,88,81,87,79,86,78,84,77,82,77,32,82,77,80,78,78,81,77,84,77,88,78,90,32,82,91,84,90,86,87,87,84,87,80,86,78,0,71,93,80,78,76,91,32,80,78,77,91,32,86,78,86,91,32,86,78,87,91,32,73,80,75,78,78,77,91,77,32,73,80,75,79,78,78,91,78,0,72,91,76,86,77,89,78,90,80,91,82,91,85,90,87,87,88,84,88,81,87,79,86,78,84,77,82,77,79,78,77,81,76,84,72,98,32,82,91,84,90,86,87,87,84,87,80,86,78,32,82,77,80,78,78,81,77,84,73,98,0,72,93,91,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,84,90,86,87,87,84,87,81,86,79,85,78,83,77,32,81,77,79,78,77,81,76,84,76,88,77,90,32,81,91,83,90,85,87,86,84,86,80,85,78,32,85,78,91,78,0,72,92,83,78,80,91,32,83,78,81,91,32,74,80,76,78,79,77,90,77,32,74,80,76,79,79,78,90,78,0,72,92,73,81,74,79,76,77,79,77,80,78,80,80,78,86,78,89,80,91,32,78,77,79,78,79,80,77,86,77,89,78,90,80,91,81,91,84,90,86,88,88,85,89,82,89,79,88,77,87,78,88,79,89,82,32,88,85,89,79,0,71,93,79,78,77,79,75,81,74,84,74,87,75,89,76,90,78,91,81,91,84,90,87,88,89,85,90,82,90,79,88,77,86,77,84,79,82,83,80,88,77,98,32,74,87,76,89,78,90,81,90,84,89,87,87,89,85,32,90,79,88,78,86,78,84,80,82,83,80,89,78,98,0,73,91,75,77,77,77,79,78,80,80,85,95,86,97,87,98,32,77,77,78,78,79,80,84,95,85,97,87,98,89,98,32,90,77,89,79,87,82,77,93,75,96,74,98,0,70,93,85,70,79,98,32,86,70,78,98,32,71,81,72,79,74,77,77,77,78,78,78,80,77,85,77,88,79,90,82,90,84,89,87,86,89,83,32,76,77,77,78,77,80,76,85,76,88,77,90,79,91,82,91,84,90,86,88,88,85,89,83,91,77,0,70,93,74,81,76,79,79,78,78,77,76,78,74,81,73,84,73,87,74,90,75,91,77,91,79,90,81,87,82,84,32,73,87,74,89,75,90,77,90,79,89,81,87,32,81,84,81,87,82,90,83,91,85,91,87,90,89,87,90,84,90,81,89,78,88,77,87,78,89,79,90,81,32,81,87,82,89,83,90,85,90,87,89,89,87,0,72,93,88,77,86,84,85,88,85,90,86,91,89,91,91,89,92,87,32,89,77,87,84,86,88,86,90,87,91,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,83,90,85,87,86,84,32,81,77,79,78,77,81,76,84,76,88,77,90,0,72,91,80,70,76,83,76,86,77,89,78,90,32,81,70,77,83,32,77,83,78,80,80,78,82,77,84,77,86,78,87,79,88,81,88,84,87,87,85,90,82,91,80,91,78,90,77,87,77,83,32,86,78,87,80,87,84,86,87,84,90,82,91,32,77,70,81,70,0,73,91,87,80,87,81,88,81,88,80,87,78,85,77,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,87,32,82,77,80,78,78,81,77,84,77,88,78,90,0,72,93,90,70,86,84,85,88,85,90,86,91,89,91,91,89,92,87,32,91,70,87,84,86,88,86,90,87,91,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,83,90,85,87,86,84,32,81,77,79,78,77,81,76,84,76,88,77,90,32,87,70,91,70,0,73,91,77,86,81,85,84,84,87,82,88,80,87,78,85,77,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,88,32,82,77,80,78,78,81,77,84,77,88,78,90,0,75,90,90,71,89,72,90,73,91,72,91,71,90,70,88,70,86,71,85,72,84,74,83,77,80,91,79,95,78,97,32,88,70,86,72,85,74,84,78,82,87,81,91,80,94,79,96,78,97,76,98,74,98,73,97,73,96,74,95,75,96,74,97,32,79,77,89,77,0,72,92,89,77,85,91,84,94,82,97,79,98,76,98,74,97,73,96,73,95,74,94,75,95,74,96,32,88,77,84,91,83,94,81,97,79,98,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,83,90,85,87,86,84,32,81,77,79,78,77,81,76,84,76,88,77,90,0,72,93,80,70,74,91,32,81,70,75,91,32,77,84,79,80,81,78,83,77,85,77,87,78,88,79,88,81,86,87,86,90,87,91,32,85,77,87,79,87,81,85,87,85,90,86,91,89,91,91,89,92,87,32,77,70,81,70,0,76,89,85,70,84,71,85,72,86,71,85,70,32,77,81,78,79,80,77,83,77,84,78,84,81,82,87,82,90,83,91,32,82,77,83,78,83,81,81,87,81,90,82,91,85,91,87,89,88,87,0,76,89,86,70,85,71,86,72,87,71,86,70,32,78,81,79,79,81,77,84,77,85,78,85,81,82,91,81,94,80,96,79,97,77,98,75,98,74,97,74,96,75,95,76,96,75,97,32,83,77,84,78,84,81,81,91,80,94,79,96,77,98,0,72,92,80,70,74,91,32,81,70,75,91,32,88,78,87,79,88,80,89,79,89,78,88,77,87,77,85,78,81,82,79,83,77,83,32,79,83,81,84,83,90,84,91,32,79,83,80,84,82,90,83,91,85,91,87,90,89,87,32,77,70,81,70,0,77,89,85,70,81,84,80,88,80,90,81,91,84,91,86,89,87,87,32,86,70,82,84,81,88,81,90,82,91,32,82,70,86,70,0,65,98,66,81,67,79,69,77,72,77,73,78,73,80,72,84,70,91,32,71,77,72,78,72,80,71,84,69,91,32,72,84,74,80,76,78,78,77,80,77,82,78,83,79,83,81,80,91,32,80,77,82,79,82,81,79,91,32,82,84,84,80,86,78,88,77,90,77,92,78,93,79,93,81,91,87,91,90,92,91,32,90,77,92,79,92,81,90,87,90,90,91,91,94,91,96,89,97,87,0,70,93,71,81,72,79,74,77,77,77,78,78,78,80,77,84,75,91,32,76,77,77,78,77,80,76,84,74,91,32,77,84,79,80,81,78,83,77,85,77,87,78,88,79,88,81,86,87,86,90,87,91,32,85,77,87,79,87,81,85,87,85,90,86,91,89,91,91,89,92,87,0,71,92,72,81,73,79,75,77,78,77,79,78,79,80,78,84,74,98,32,77,77,78,78,78,80,77,84,73,98,32,78,84,79,81,81,78,83,77,85,77,87,78,88,79,89,81,89,84,88,87,86,90,83,91,81,91,79,90,78,87,78,84,32,87,78,88,80,88,84,87,87,85,90,83,91,32,70,98,77,98,0,72,92,88,77,82,98,32,89,77,83,98,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,83,90,85,87,86,84,32,81,77,79,78,77,81,76,84,76,88,77,90,32,79,98,86,98,0,73,90,74,81,75,79,77,77,80,77,81,78,81,80,80,84,78,91,32,79,77,80,78,80,80,79,84,77,91,32,80,84,82,80,84,78,86,77,88,77,89,78,89,79,88,80,87,79,88,78,0,74,91,88,79,88,80,89,80,89,79,88,78,85,77,82,77,79,78,78,79,78,81,79,82,86,86,87,87,32,78,80,79,81,86,85,87,86,87,89,86,90,83,91,80,91,77,90,76,89,76,88,77,88,77,89,0,75,89,84,70,80,84,79,88,79,90,80,91,83,91,85,89,86,87,32,85,70,81,84,80,88,80,90,81,91,32,78,77,87,77,0,70,93,71,81,72,79,74,77,77,77,78,78,78,81,76,87,76,89,78,91,32,76,77,77,78,77,81,75,87,75,89,76,90,78,91,80,91,82,90,84,88,86,84,32,88,77,86,84,85,88,85,90,86,91,89,91,91,89,92,87,32,89,77,87,84,86,88,86,90,87,91,0,72,92,73,81,74,79,76,77,79,77,80,78,80,81,78,87,78,89,80,91,32,78,77,79,78,79,81,77,87,77,89,78,90,80,91,81,91,84,90,86,88,88,85,89,81,89,77,88,77,89,79,0,67,96,68,81,69,79,71,77,74,77,75,78,75,81,73,87,73,89,75,91,32,73,77,74,78,74,81,72,87,72,89,73,90,75,91,77,91,79,90,81,88,82,86,32,84,77,82,86,82,89,83,90,85,91,87,91,89,90,91,88,92,86,93,82,93,77,92,77,93,79,32,85,77,83,86,83,89,85,91,0,72,92,75,81,77,78,79,77,82,77,83,79,83,82,32,81,77,82,79,82,82,81,86,80,88,78,90,76,91,75,91,74,90,74,89,75,88,76,89,75,90,32,81,86,81,89,82,91,85,91,87,90,89,87,32,89,78,88,79,89,80,90,79,90,78,89,77,88,77,86,78,84,80,83,82,82,86,82,89,83,91,0,71,92,72,81,73,79,75,77,78,77,79,78,79,81,77,87,77,89,79,91,32,77,77,78,78,78,81,76,87,76,89,77,90,79,91,81,91,83,90,85,88,87,84,32,90,77,86,91,85,94,83,97,80,98,77,98,75,97,74,96,74,95,75,94,76,95,75,96,32,89,77,85,91,84,94,82,97,80,98,0,72,92,89,77,88,79,86,81,78,87,76,89,75,91,32,76,81,77,79,79,77,82,77,86,79,32,77,79,79,78,82,78,86,79,88,79,32,76,89,78,89,82,90,85,90,87,89,32,78,89,82,91,85,91,87,89,88,87,0,71,94,86,71,85,72,86,73,87,72,87,71,85,70,82,70,79,71,77,73,76,76,76,91,32,82,70,80,71,78,73,77,76,77,91,32,92,71,91,72,92,73,93,72,93,71,92,70,90,70,88,71,87,73,87,91,32,90,70,89,71,88,73,88,91,32,73,77,91,77,32,73,91,80,91,32,84,91,91,91,0,71,93,87,71,86,72,87,73,88,72,87,71,85,70,82,70,79,71,77,73,76,76,76,91,32,82,70,80,71,78,73,77,76,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,88,77,32,73,91,80,91,32,84,91,91,91,0,71,93,86,71,85,72,86,73,87,72,87,71,85,70,32,88,70,82,70,79,71,77,73,76,76,76,91,32,82,70,80,71,78,73,77,76,77,91,32,87,72,87,91,32,88,70,88,91,32,73,77,87,77,32,73,91,80,91,32,84,91,91,91,0,66,99,82,71,81,72,82,73,83,72,82,71,80,70,77,70,74,71,72,73,71,76,71,91,32,77,70,75,71,73,73,72,76,72,91,32,93,71,92,72,93,73,94,72,93,71,91,70,88,70,85,71,83,73,82,76,82,91,32,88,70,86,71,84,73,83,76,83,91,32,93,77,93,91,32,94,77,94,91,32,68,77,94,77,32,68,91,75,91,32,79,91,86,91,32,90,91,97,91,0,66,99,82,71,81,72,82,73,83,72,82,71,80,70,77,70,74,71,72,73,71,76,71,91,32,77,70,75,71,73,73,72,76,72,91,32,92,71,91,72,92,73,93,72,93,71,91,70,32,94,70,88,70,85,71,83,73,82,76,82,91,32,88,70,86,71,84,73,83,76,83,91,32,93,72,93,91,32,94,70,94,91,32,68,77,93,77,32,68,91,75,91,32,79,91,86,91,32,90,91,97,91,0,77,88,82,77,82,91,32,83,77,83,91,32,79,77,83,77,32,79,91,86,91,0,73,90,87,78,85,77,82,77,79,78,77,80,76,83,76,86,77,89,78,90,81,91,84,91,86,90,32,82,77,80,78,78,80,77,83,77,86,78,89,79,90,81,91,32,77,84,85,84,0,73,92,84,70,81,71,79,74,78,76,77,79,76,84,76,88,77,90,79,91,81,91,84,90,86,87,87,85,88,82,89,77,89,73,88,71,86,70,84,70,32,84,70,82,71,80,74,79,76,78,79,77,84,77,88,78,90,79,91,32,81,91,83,90,85,87,86,85,87,82,88,77,88,73,87,71,86,70,32,78,80,87,80,0,71,93,85,70,79,98,32,86,70,78,98,32,81,77,77,78,75,80,74,83,74,86,75,88,77,90,80,91,83,91,87,90,89,88,90,85,90,82,89,80,87,78,84,77,81,77,32,81,77,78,78,76,80,75,83,75,86,76,88,78,90,80,91,32,83,91,86,90,88,88,89,85,89,82,88,80,86,78,84,77,0,73,91,84,77,86,78,88,80,88,79,87,78,84,77,81,77,78,78,77,79,76,81,76,83,77,85,79,87,83,90,32,81,77,79,78,78,79,77,81,77,83,78,85,83,90,84,92,84,94,83,95,81,95,0,71,93,76,77,75,78,74,80,74,82,75,85,79,89,80,91,32,74,82,75,84,79,88,80,91,80,93,79,96,77,98,76,98,75,97,74,95,74,92,75,88,77,84,79,81,82,78,84,77,86,77,89,78,90,80,90,84,89,88,87,90,85,91,84,91,83,90,83,88,84,87,85,88,84,89,32,86,77,88,78,89,80,89,84,88,88,87,90,0,69,95,89,71,88,72,89,73,90,72,89,71,87,70,84,70,81,71,79,73,78,75,77,78,76,82,74,91,73,95,72,97,32,84,70,82,71,80,73,79,75,78,78,76,87,75,91,74,94,73,96,72,97,70,98,68,98,67,97,67,96,68,95,69,96,68,97,32,95,71,94,72,95,73,96,72,96,71,95,70,93,70,91,71,90,72,89,74,88,77,85,91,84,95,83,97,32,93,70,91,72,90,74,89,78,87,87,86,91,85,94,84,96,83,97,81,98,79,98,78,97,78,96,79,95,80,96,79,97,32,73,77,94,77,0,70,94,91,71,90,72,91,73,92,72,91,71,88,70,85,70,82,71,80,73,79,75,78,78,77,82,75,91,74,95,73,97,32,85,70,83,71,81,73,80,75,79,78,77,87,76,91,75,94,74,96,73,97,71,98,69,98,68,97,68,96,69,95,70,96,69,97,32,89,77,87,84,86,88,86,90,87,91,90,91,92,89,93,87,32,90,77,88,84,87,88,87,90,88,91,32,74,77,90,77,0,70,94,89,71,88,72,89,73,90,72,90,71,88,70,32,92,70,85,70,82,71,80,73,79,75,78,78,77,82,75,91,74,95,73,97,32,85,70,83,71,81,73,80,75,79,78,77,87,76,91,75,94,74,96,73,97,71,98,69,98,68,97,68,96,69,95,70,96,69,97,32,91,70,87,84,86,88,86,90,87,91,90,91,92,89,93,87,32,92,70,88,84,87,88,87,90,88,91,32,74,77,89,77,0,64,99,84,71,83,72,84,73,85,72,84,71,82,70,79,70,76,71,74,73,73,75,72,78,71,82,69,91,68,95,67,97,32,79,70,77,71,75,73,74,75,73,78,71,87,70,91,69,94,68,96,67,97,65,98,63,98,62,97,62,96,63,95,64,96,63,97,32,96,71,95,72,96,73,97,72,96,71,93,70,90,70,87,71,85,73,84,75,83,78,82,82,80,91,79,95,78,97,32,90,70,88,71,86,73,85,75,84,78,82,87,81,91,80,94,79,96,78,97,76,98,74,98,73,97,73,96,74,95,75,96,74,97,32,94,77,92,84,91,88,91,90,92,91,95,91,97,89,98,87,32,95,77,93,84,92,88,92,90,93,91,32,68,77,95,77,0,64,99,84,71,83,72,84,73,85,72,84,71,82,70,79,70,76,71,74,73,73,75,72,78,71,82,69,91,68,95,67,97,32,79,70,77,71,75,73,74,75,73,78,71,87,70,91,69,94,68,96,67,97,65,98,63,98,62,97,62,96,63,95,64,96,63,97,32,94,71,93,72,94,73,95,72,95,71,93,70,32,97,70,90,70,87,71,85,73,84,75,83,78,82,82,80,91,79,95,78,97,32,90,70,88,71,86,73,85,75,84,78,82,87,81,91,80,94,79,96,78,97,76,98,74,98,73,97,73,96,74,95,75,96,74,97,32,96,70,92,84,91,88,91,90,92,91,95,91,97,89,98,87,32,97,70,93,84,92,88,92,90,93,91,32,68,77,94,77,0,76,89,77,81,78,79,80,77,83,77,84,78,84,81,82,87,82,90,83,91,32,82,77,83,78,83,81,81,87,81,90,82,91,85,91,87,89,88,87,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,32,81,70,79,71,78,72,77,74,76,79,76,82,77,87,78,89,79,90,81,91,32,83,91,85,90,86,89,87,87,88,82,88,79,87,74,86,72,85,71,83,70,0,72,92,78,74,80,73,83,70,83,91,32,82,71,82,91,32,78,91,87,91,0,72,92,76,74,77,75,76,76,75,75,75,74,76,72,77,71,80,70,84,70,87,71,88,72,89,74,89,76,88,78,85,80,80,82,78,83,76,85,75,88,75,91,32,84,70,86,71,87,72,88,74,88,76,87,78,84,80,80,82,32,75,89,76,88,78,88,83,90,86,90,88,89,89,88,32,78,88,83,91,87,91,88,90,89,88,89,86,0,72,92,76,74,77,75,76,76,75,75,75,74,76,72,77,71,80,70,84,70,87,71,88,73,88,76,87,78,84,79,81,79,32,84,70,86,71,87,73,87,76,86,78,84,79,32,84,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,86,76,85,77,86,76,87,32,87,81,88,84,88,87,87,89,86,90,84,91,0,72,92,84,72,84,91,32,85,70,85,91,32,85,70,74,85,90,85,32,81,91,88,91,0,72,92,77,70,75,80,32,75,80,77,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,75,86,76,85,77,86,76,87,32,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,32,77,70,87,70,32,77,71,82,71,87,70,0,72,92,87,73,86,74,87,75,88,74,88,73,87,71,85,70,82,70,79,71,77,73,76,75,75,79,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,82,78,79,79,77,81,76,84,32,82,70,80,71,78,73,77,75,76,79,76,85,77,88,79,90,81,91,32,83,91,85,90,87,88,88,85,88,84,87,81,85,79,83,78,0,72,92,75,70,75,76,32,75,74,76,72,78,70,80,70,85,73,87,73,88,72,89,70,32,76,72,78,71,80,71,85,73,32,89,70,89,73,88,76,84,81,83,83,82,86,82,91,32,88,76,83,81,82,83,81,86,81,91,0,72,92,80,70,77,71,76,73,76,76,77,78,80,79,84,79,87,78,88,76,88,73,87,71,84,70,80,70,32,80,70,78,71,77,73,77,76,78,78,80,79,32,84,79,86,78,87,76,87,73,86,71,84,70,32,80,79,77,80,76,81,75,83,75,87,76,89,77,90,80,91,84,91,87,90,88,89,89,87,89,83,88,81,87,80,84,79,32,80,79,78,80,77,81,76,83,76,87,77,89,78,90,80,91,32,84,91,86,90,87,89,88,87,88,83,87,81,86,80,84,79,0,72,92,88,77,87,80,85,82,82,83,81,83,78,82,76,80,75,77,75,76,76,73,78,71,81,70,83,70,86,71,88,73,89,76,89,82,88,86,87,88,85,90,82,91,79,91,77,90,76,88,76,87,77,86,78,87,77,88,32,81,83,79,82,77,80,76,77,76,76,77,73,79,71,81,70,32,83,70,85,71,87,73,88,76,88,82,87,86,86,88,84,90,82,91,0,77,87,82,91,81,90,82,89,83,90,83,92,82,94,81,95,0,77,87,82,77,81,78,82,79,83,78,82,77,32,82,91,81,90,82,89,83,90,83,92,82,94,81,95,0,77,87,82,70,81,72,82,84,83,72,82,70,32,82,72,82,78,32,82,89,81,90,82,91,83,90,82,89,0,73,91,77,74,78,75,77,76,76,75,76,74,77,72,78,71,80,70,83,70,86,71,87,72,88,74,88,76,87,78,86,79,82,81,82,84,32,83,70,85,71,86,72,87,74,87,76,86,78,84,80,32,82,89,81,90,82,91,83,90,82,89,0,78,86,82,70,81,77,32,83,70,81,77,0,74,90,78,70,77,77,32,79,70,77,77,32,86,70,85,77,32,87,70,85,77,0,74,90,82,70,82,82,32,77,73,87,79,32,87,73,77,79,0,75,89,85,66,78,82,85,98,0,75,89,79,66,86,82,79,98,0,75,89,79,66,79,98,32,85,66,85,98,0,70,94,82,74,82,91,32,74,82,90,82,32,74,91,90,91,0,70,94,82,74,82,91,32,74,74,90,74,32,74,82,90,82,0,77,87,81,81,81,83,83,83,83,81,81,81,32,82,81,82,83,32,81,82,83,82,0,69,95,82,73,81,74,82,75,83,74,82,73,32,73,82,91,82,32,82,89,81,90,82,91,83,90,82,89,0,69,95,89,73,75,91,32,73,79,91,79,32,73,85,91,85,0,69,95,73,77,91,77,32,73,82,91,82,32,73,87,91,87,0,70,94,90,70,74,77,90,84,32,74,86,90,86,32,74,91,90,91,0,70,94,74,70,90,77,74,84,32,74,86,90,86,32,74,91,90,91,0,70,95,91,87,89,87,87,86,85,84,82,80,81,79,79,78,77,78,75,79,74,81,74,83,75,85,77,86,79,86,81,85,82,84,85,80,87,78,89,77,91,77,0,70,94,73,85,73,83,74,80,76,79,78,79,80,80,84,83,86,84,88,84,90,83,91,81,32,73,83,74,81,76,80,78,80,80,81,84,84,86,85,88,85,90,84,91,81,91,79,0,71,93,74,84,82,79,90,84,32,74,84,82,80,90,84,0,76,88,84,70,79,76,32,84,70,85,71,79,76,0,76,88,80,70,85,76,32,80,70,79,71,85,76,0,72,92,75,70,76,72,78,74,81,75,83,75,86,74,88,72,89,70,32,75,70,76,73,78,75,81,76,83,76,86,75,88,73,89,70,0,77,87,82,72,83,71,82,70,81,71,81,73,82,75,83,76,0,77,87,81,70,82,71,83,73,83,75,82,76,81,75,82,74,0,69,91,72,77,76,77,82,89,32,75,77,82,91,32,91,66,82,91,0,70,94,90,74,83,74,79,75,77,76,75,78,74,81,74,83,75,86,77,88,79,89,83,90,90,90,0,70,94,74,74,74,81,75,85,76,87,78,89,81,90,83,90,86,89,88,87,89,85,90,81,90,74,0,70,94,74,74,81,74,85,75,87,76,89,78,90,81,90,83,89,86,87,88,85,89,81,90,74,90,0,70,94,74,90,74,83,75,79,76,77,78,75,81,74,83,74,86,75,88,77,89,79,90,83,90,90,0,70,94,90,74,83,74,79,75,77,76,75,78,74,81,74,83,75,86,77,88,79,89,83,90,90,90,32,74,82,86,82,0,69,95,88,80,91,82,88,84,32,85,77,90,82,85,87,32,73,82,90,82,0,74,90,80,76,82,73,84,76,32,77,79,82,74,87,79,32,82,74,82,91,0,69,95,76,80,73,82,76,84,32,79,77,74,82,79,87,32,74,82,91,82,0,74,90,80,88,82,91,84,88,32,77,85,82,90,87,85,32,82,73,82,90,0,73,92,88,82,87,79,86,78,84,77,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,88,88,85,89,80,89,75,88,72,87,71,85,70,82,70,80,71,79,72,79,73,80,73,80,72,32,82,77,80,78,78,81,77,84,77,88,78,90,32,82,91,84,90,86,88,87,85,88,80,88,75,87,72,85,70,0,72,92,74,70,82,91,32,75,70,82,89,32,90,70,82,91,32,74,70,90,70,32,75,71,89,71,0,65,98,68,77,73,77,82,89,32,72,78,82,91,32,98,58,82,91,0,70,94,91,67,90,68,91,69,92,68,92,67,91,66,89,66,87,67,85,69,84,71,83,74,82,78,80,90,79,94,78,96,32,86,68,85,70,84,74,82,86,81,90,80,93,79,95,77,97,75,98,73,98,72,97,72,96,73,95,74,96,73,97,32,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,83,89,81,88,78,86,76,83,75,81,75,0,70,95,92,83,91,85,89,86,87,86,85,85,84,84,81,80,80,79,78,78,76,78,74,79,73,81,73,83,74,85,76,86,78,86,80,85,81,84,84,80,85,79,87,78,89,78,91,79,92,81,92,83,0,70,94,91,70,73,91,32,78,70,80,72,80,74,79,76,77,77,75,77,73,75,73,73,74,71,76,70,78,70,80,71,83,72,86,72,89,71,91,70,32,87,84,85,85,84,87,84,89,86,91,88,91,90,90,91,88,91,86,89,84,87,84,0,70,95,91,78,90,79,91,80,92,79,92,78,91,77,90,77,89,78,88,80,86,85,84,88,82,90,80,91,77,91,74,90,73,88,73,85,74,83,80,79,82,77,83,75,83,73,82,71,80,70,78,71,77,73,77,75,78,78,80,81,85,88,87,90,90,91,91,91,92,90,92,89,32,77,91,75,90,74,88,74,85,75,83,77,81,32,77,75,78,77,86,88,88,90,90,91,0,69,96,87,78,86,76,84,75,81,75,79,76,78,77,77,80,77,83,78,85,80,86,83,86,85,85,86,83,32,81,75,79,77,78,80,78,83,79,85,80,86,32,87,75,86,83,86,85,88,86,90,86,92,84,93,81,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,84,91,87,90,89,89,90,88,32,88,75,87,83,87,85,88,86,0,72,92,80,66,80,95,32,84,66,84,95,32,88,73,87,74,88,75,89,74,89,73,87,71,84,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,85,81,87,82,89,84,32,75,75,77,77,79,78,85,80,87,81,88,82,89,84,89,88,87,90,84,91,80,91,77,90,75,88,75,87,76,86,77,87,76,88,0,74,90,85,73,84,74,85,75,86,74,86,73,85,71,83,70,81,70,79,71,78,73,78,75,79,77,81,79,86,82,32,79,77,84,80,86,82,87,84,87,86,86,88,84,90,32,80,78,78,80,77,82,77,84,78,86,80,88,85,91,32,78,86,83,89,85,91,86,93,86,95,85,97,83,98,81,98,79,97,78,95,78,94,79,93,80,94,79,95,0,74,90,82,70,81,72,82,74,83,72,82,70,32,82,70,82,98,32,82,81,81,84,82,98,83,84,82,81,32,76,77,78,78,80,77,78,76,76,77,32,76,77,88,77,32,84,77,86,78,88,77,86,76,84,77,0,74,90,82,70,81,72,82,74,83,72,82,70,32,82,70,82,84,32,82,80,81,82,83,86,82,88,81,86,83,82,82,80,32,82,84,82,98,32,82,94,81,96,82,98],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+266252);allocate([83,96,82,94,32,76,77,78,78,80,77,78,76,76,77,32,76,77,88,77,32,84,77,86,78,88,77,86,76,84,77,32,76,91,78,92,80,91,78,90,76,91,32,76,91,88,91,32,84,91,86,92,88,91,86,90,84,91,0,73,92,88,70,88,91,32,75,70,88,70,32,80,80,88,80,32,75,91,88,91,0,69,96,81,70,78,71,75,73,73,76,72,79,72,82,73,85,75,88,78,90,81,91,84,91,87,90,90,88,92,85,93,82,93,79,92,76,90,73,87,71,84,70,81,70,32,82,79,81,80,81,81,82,82,83,82,84,81,84,80,83,79,82,79,32,82,80,82,81,83,81,83,80,82,80,0,74,91,80,70,78,71,79,73,81,74,32,80,70,79,71,79,73,32,85,70,87,71,86,73,84,74,32,85,70,86,71,86,73,32,81,74,79,75,78,76,77,78,77,81,78,83,79,84,81,85,84,85,86,84,87,83,88,81,88,78,87,76,86,75,84,74,81,74,32,82,85,82,91,32,83,85,83,91,32,78,88,87,88,0,73,92,82,70,79,71,77,73,76,76,76,77,77,80,79,82,82,83,83,83,86,82,88,80,89,77,89,76,88,73,86,71,83,70,82,70,32,82,83,82,91,32,83,83,83,91,32,78,87,87,87,0,68,96,80,70,77,71,74,73,72,76,71,79,71,83,72,86,74,89,77,91,80,92,84,92,87,91,90,89,92,86,93,83,93,79,92,76,90,73,87,71,84,70,80,70,32,82,70,82,92,32,71,81,93,81,0,71,96,80,77,77,78,75,80,74,83,74,84,75,87,77,89,80,90,81,90,84,89,86,87,87,84,87,83,86,80,84,78,81,77,80,77,32,93,71,87,71,91,72,85,78,32,93,71,93,77,92,73,86,79,32,92,72,86,78,0,70,92,73,73,74,71,76,70,79,70,81,71,82,73,82,76,81,79,80,81,78,83,75,85,32,79,70,80,71,81,73,81,77,80,80,78,83,32,86,70,84,91,32,87,70,83,91,32,75,85,89,85,0,73,92,77,70,77,85,32,78,70,77,81,32,77,81,78,79,79,78,81,77,84,77,87,78,88,80,88,82,87,84,85,86,32,84,77,86,78,87,80,87,82,84,88,84,90,85,91,87,91,89,89,32,75,70,78,70,0,73,92,82,78,79,79,77,81,76,84,76,85,77,88,79,90,82,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,82,78,32,82,72,78,74,82,70,82,78,32,83,72,87,74,83,70,83,78,32,82,83,81,84,81,85,82,86,83,86,84,85,84,84,83,83,82,83,32,82,84,82,85,83,85,83,84,82,84,0,71,94,81,72,82,70,82,91,32,84,72,83,70,83,91,32,74,72,75,70,75,77,76,80,78,82,81,83,82,83,32,77,72,76,70,76,78,77,81,32,91,72,90,70,90,77,89,80,87,82,84,83,83,83,32,88,72,89,70,89,78,88,81,32,78,87,87,87,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,85,70,88,71,89,72,90,74,90,77,89,79,88,80,85,81,77,81,32,85,70,87,71,88,72,89,74,89,77,88,79,87,80,85,81,32,73,91,89,91,89,86,88,91,0,72,91,89,71,85,71,81,72,78,74,76,77,75,80,75,83,76,86,78,89,81,91,85,92,89,92,32,89,71,86,72,83,74,81,77,80,80,80,83,81,86,83,89,86,91,89,92,0,70,95,79,81,77,81,75,82,74,83,73,85,73,87,74,89,75,90,77,91,79,91,81,90,82,89,83,87,83,85,82,83,81,82,79,81,32,83,72,80,81,32,90,74,82,82,32,92,81,83,84,0,72,92,79,75,85,89,32,85,75,79,89,32,75,79,89,85,32,89,79,75,85,0,70,94,78,86,76,85,75,85,73,86,72,88,72,89,73,91,75,92,76,92,78,91,79,89,79,88,78,86,75,82,74,79,74,77,75,74,77,72,80,71,84,71,87,72,89,74,90,77,90,79,89,82,86,86,85,88,85,89,86,91,88,92,89,92,91,91,92,89,92,88,91,86,89,85,88,85,86,86,32,74,77,75,75,77,73,80,72,84,72,87,73,89,75,90,77,0,70,94,78,77,76,78,75,78,73,77,72,75,72,74,73,72,75,71,76,71,78,72,79,74,79,75,78,77,75,81,74,84,74,86,75,89,77,91,80,92,84,92,87,91,89,89,90,86,90,84,89,81,86,77,85,75,85,74,86,72,88,71,89,71,91,72,92,74,92,75,91,77,89,78,88,78,86,77,32,74,86,75,88,77,90,80,91,84,91,87,90,89,88,90,86,0,73,91,75,89,89,75,32,81,76,85,76,89,75,88,79,88,83,32,85,76,88,76,88,79,0,73,91,89,75,75,89,32,76,81,76,85,75,89,79,88,83,88,32,76,85,76,88,79,88,0,73,91,89,89,75,75,32,83,76,79,76,75,75,76,79,76,83,32,79,76,76,76,76,79,0,73,91,75,75,89,89,32,81,88,85,88,89,89,88,85,88,81,32,85,88,88,88,88,85,0,70,95,74,77,73,76,73,74,74,72,76,71,78,71,80,72,81,73,82,75,83,80,32,73,74,75,72,77,72,79,73,80,74,81,76,82,80,82,91,32,91,77,92,76,92,74,91,72,89,71,87,71,85,72,84,73,83,75,82,80,32,92,74,90,72,88,72,86,73,85,74,84,76,83,80,83,91,0,70,94,73,71,74,75,75,77,77,79,80,80,84,80,87,79,89,77,90,75,91,71,32,73,71,74,74,75,76,77,78,80,79,84,79,87,78,89,76,90,74,91,71,32,80,79,78,80,77,81,76,83,76,86,77,88,79,90,81,91,83,91,85,90,87,88,88,86,88,83,87,81,86,80,84,79,32,80,80,78,81,77,83,77,86,78,89,32,86,89,87,86,87,83,86,81,84,80,0,70,94,77,74,77,86,32,78,75,78,85,32,86,75,86,85,32,87,74,87,86,32,73,71,75,73,77,74,80,75,84,75,87,74,89,73,91,71,32,73,89,75,87,77,86,80,85,84,85,87,86,89,87,91,89,0,70,94,91,73,76,73,74,74,73,76,73,78,74,80,76,81,78,81,80,80,81,78,81,76,80,74,91,74,32,73,77,74,79,75,80,77,81,32,81,77,80,75,79,74,77,73,32,73,88,88,88,90,87,91,85,91,83,90,81,88,80,86,80,84,81,83,83,83,85,84,87,73,87,32,91,84,90,82,89,81,87,80,32,83,84,84,86,85,87,87,88,0,70,93,79,85,77,84,76,84,74,85,73,87,73,88,74,90,76,91,77,91,79,90,80,88,80,87,79,85,74,80,73,78,73,75,74,73,76,72,79,71,83,71,87,72,89,74,90,76,90,79,89,82,86,85,85,87,85,89,86,91,88,91,89,90,90,88,32,77,83,75,80,74,78,74,75,75,73,76,72,32,83,71,86,72,88,74,89,76,89,79,88,82,86,85,0,71,95,72,75,75,72,77,75,77,86,32,74,73,76,76,76,86,32,77,75,80,72,82,75,82,85,32,79,73,81,76,81,85,32,82,75,85,72,87,75,87,91,32,84,73,86,76,86,91,32,87,75,90,72,91,74,92,77,92,80,91,83,90,85,88,87,85,89,80,91,32,89,73,90,74,91,77,91,80,90,83,89,85,87,87,84,89,80,91,0,70,94,73,83,77,83,76,82,75,79,75,77,76,74,78,72,81,71,83,71,86,72,88,74,89,77,89,79,88,82,87,83,91,83,32,73,84,79,84,77,82,76,79,76,77,77,74,79,72,81,71,32,83,71,85,72,87,74,88,77,88,79,87,82,85,84,91,84,32,75,88,89,88,32,75,89,89,89,0,70,95,71,76,74,73,77,76,77,88,32,73,74,76,77,76,88,32,77,76,80,73,83,76,83,88,32,79,74,82,77,82,88,32,83,76,86,73,89,76,89,87,91,89,32,85,74,88,77,88,88,90,90,93,87,0,71,93,90,73,74,89,32,90,73,87,74,81,74,32,88,75,85,75,81,74,32,90,73,89,76,89,82,32,88,75,88,78,89,82,32,81,82,74,82,32,80,83,77,83,74,82,32,81,82,81,89,32,80,83,80,86,81,89,0,70,94,72,79,74,75,79,85,32,74,77,79,87,82,80,87,80,90,79,91,77,91,75,90,73,88,72,87,72,85,73,84,75,84,77,85,80,86,82,87,85,87,88,85,90,32,87,72,86,73,85,75,85,77,87,81,88,84,88,87,87,89,85,90,0,70,94,73,79,76,76,80,78,32,75,77,79,79,82,76,85,78,32,81,77,84,79,87,76,89,78,32,86,77,88,79,91,76,32,73,85,76,82,80,84,32,75,83,79,85,82,82,85,84,32,81,83,84,85,87,82,89,84,32,86,83,88,85,91,82,0,70,94,74,72,78,74,80,76,81,79,81,82,80,85,78,87,74,89,32,74,72,77,73,79,74,81,76,82,79,32,82,82,81,85,79,87,77,88,74,89,32,90,72,87,73,85,74,83,76,82,79,32,82,82,83,85,85,87,87,88,90,89,32,90,72,86,74,84,76,83,79,83,82,84,85,86,87,90,89,32,73,80,91,80,32,73,81,91,81,0,78,86,81,81,81,83,83,83,83,81,81,81,32,81,81,83,83,32,83,81,81,83,0,74,90,77,80,81,82,84,84,86,86,87,89,87,91,86,93,85,94,32,77,81,83,84,32,77,82,80,83,84,85,86,87,87,89,0,74,90,87,75,86,77,84,79,80,81,77,82,32,83,80,77,83,32,85,70,86,71,87,73,87,75,86,78,84,80,81,82,77,84,0,72,92,83,77,79,78,76,80,75,82,75,84,76,86,78,87,81,87,85,86,88,84,89,82,89,80,88,78,86,77,83,77,32,88,78,83,77,32,86,77,81,78,76,80,32,79,78,75,82,32,76,86,81,87,32,78,87,83,86,88,84,32,85,86,89,82,0,74,91,83,77,80,78,78,80,77,82,77,84,78,86,80,87,82,87,85,86,87,84,88,82,88,80,87,78,85,77,83,77,32,79,80,85,77,32,78,82,86,78,32,77,84,87,79,32,78,85,88,80,32,79,86,87,82,32,80,87,86,84,0,74,90,79,71,79,94,32,85,70,85,93,32,77,78,87,76,32,77,79,87,77,32,77,87,87,85,32,77,88,87,86,0,74,90,78,70,78,88,32,86,76,86,94,32,78,78,86,76,32,78,79,86,77,32,78,87,86,85,32,78,88,86,86,0,74,90,78,66,78,87,32,78,78,81,76,84,76,86,77,87,79,87,81,86,83,83,85,81,86,78,87,32,78,78,81,77,84,77,86,78,32,85,77,86,79,86,81,85,83,83,85,0,69,95,72,73,72,76,32,92,73,92,76,32,72,73,92,73,32,72,74,92,74,32,72,75,92,75,32,72,76,92,76,0,74,90,77,78,77,81,32,87,78,87,81,32,77,78,87,78,32,77,79,87,79,32,77,80,87,80,32,77,81,87,81,0,74,90,77,76,87,88,32,77,76,79,78,81,79,84,79,86,78,87,77,87,75,85,75,85,77,84,79,32,79,78,84,79,32,81,79,87,77,32,86,75,86,78,32,85,76,87,76,32,87,88,85,86,83,85,80,85,78,86,77,87,77,89,79,89,79,87,80,85,32,85,86,80,85,32,83,85,77,87,32,78,86,78,89,32,77,88,79,88,0,74,90,80,79,79,77,79,75,77,75,77,77,78,78,80,79,83,79,85,78,87,76,32,78,75,78,78,32,77,76,79,76,32,77,77,83,79,32,80,79,85,78,32,87,76,87,89,0,65,94,71,102,72,102,73,101,73,100,72,99,71,99,70,100,70,102,71,104,73,105,75,105,78,104,80,102,81,100,82,96,82,85,81,59,81,52,82,47,83,45,85,44,86,44,88,45,89,47,89,51,88,54,87,56,85,59,80,63,74,67,72,69,70,72,69,74,68,78,68,82,69,86,71,89,74,91,78,92,82,92,86,91,88,90,90,87,91,84,91,80,90,77,89,75,87,73,84,72,80,72,77,73,75,75,74,78,74,82,75,85,77,87,32,71,100,71,101,72,101,72,100,71,100,32,85,59,81,63,76,67,73,70,71,73,70,75,69,78,69,82,70,86,71,88,74,91,32,82,92,85,91,87,90,89,87,90,84,90,80,89,77,88,75,86,73,84,72,0,69,102,78,83,79,85,81,86,83,86,85,85,86,83,86,81,85,79,83,78,81,78,79,79,78,80,77,83,77,86,78,89,80,91,83,92,86,92,89,91,91,89,92,87,93,84,93,80,92,77,90,74,88,73,85,72,82,72,79,73,77,74,75,76,73,79,72,83,72,88,73,93,75,97,77,99,80,101,84,102,89,102,93,101,96,99,98,97,32,75,76,74,78,73,82,73,88,74,92,76,96,78,98,81,100,85,101,89,101,93,100,95,99,98,97,32,80,79,84,79,32,79,80,85,80,32,78,81,86,81,32,78,82,86,82,32,78,83,86,83,32,79,84,85,84,32,80,85,84,85,32,97,76,97,78,99,78,99,76,97,76,32,98,76,98,78,32,97,77,99,77,32,97,86,97,88,99,88,99,86,97,86,32,98,86,98,88,32,97,87,99,87,0,68,96,72,64,72,100,32,77,64,77,100,32,87,64,87,100,32,92,64,92,100,32,77,77,87,75,32,77,78,87,76,32,77,79,87,77,32,77,87,87,85,32,77,88,87,86,32,77,89,87,87,0,72,92,80,77,77,78,76,79,75,81,75,83,76,85,77,86,80,87,84,87,87,86,88,85,89,83,89,81,88,79,87,78,84,77,80,77,32,77,78,76,80,76,83,77,85,78,86,80,87,32,87,86,88,84,88,81,87,79,86,78,84,77,0,74,90,81,67,86,77,82,84,82,85,32,85,76,81,83,32,84,73,84,75,80,82,82,85,85,89,32,87,92,85,89,83,88,81,88,79,89,78,91,78,93,79,95,82,97,32,87,92,85,90,83,89,79,89,79,93,80,95,82,97,32,83,88,80,90,78,93,0,74,90,80,79,79,77,79,75,77,75,77,77,78,78,80,79,83,79,85,78,87,76,32,78,75,78,78,32,77,76,79,76,32,77,77,83,79,32,80,79,85,78,32,87,76,83,89,0,73,106,78,81,79,79,81,78,83,78,85,79,86,81,86,83,85,85,83,86,81,86,79,85,78,84,77,81,77,78,78,75,80,73,83,72,87,72,91,73,94,75,96,78,97,82,97,87,96,91,95,93,93,96,90,99,86,102,81,105,77,107,32,87,72,90,73,93,75,95,78,96,82,96,87,95,91,94,93,92,96,89,99,84,103,81,105,32,80,79,84,79,32,79,80,85,80,32,78,81,86,81,32,78,82,86,82,32,78,83,86,83,32,79,84,85,84,32,80,85,84,85,32,101,76,101,78,103,78,103,76,101,76,32,102,76,102,78,32,101,77,103,77,32,101,86,101,88,103,88,103,86,101,86,32,102,86,102,88,32,101,87,103,87,0,68,96,72,62,72,102,32,73,62,73,102,32,77,62,77,102,32,81,66,83,66,83,68,81,68,81,65,82,63,84,62,87,62,89,63,91,65,92,68,92,73,91,76,89,78,87,79,85,79,83,78,82,76,81,78,79,81,78,82,79,83,81,86,82,88,83,86,85,85,87,85,89,86,91,88,92,91,92,96,91,99,89,101,87,102,84,102,82,101,81,99,81,96,83,96,83,98,81,98,32,82,66,82,68,32,81,67,83,67,32,89,63,90,65,91,68,91,73,90,76,89,78,32,82,76,82,78,80,81,78,82,80,83,82,86,82,88,32,89,86,90,88,91,91,91,96,90,99,89,101,32,82,96,82,98,32,81,97,83,97,0,65,99,72,66,72,98,32,73,66,73,98,32,91,66,91,98,32,92,66,92,98,32,68,66,96,66,32,68,98,77,98,32,87,98,96,98,0,66,97,71,66,81,80,70,98,32,70,66,80,80,32,69,66,80,81,32,69,66,92,66,94,73,91,66,32,71,97,92,97,32,70,98,92,98,94,91,91,98,0,73,91,88,43,85,49,82,56,80,61,79,65,78,70,77,78,77,86,78,94,79,99,80,103,82,108,85,115,88,121,32,85,49,83,54,81,60,80,64,79,70,78,78,78,86,79,94,80,100,81,104,83,110,85,115,0,73,91,76,43,79,49,82,56,84,61,85,65,86,70,87,78,87,86,86,94,85,99,84,103,82,108,79,115,76,121,32,79,49,81,54,83,60,84,64,85,70,86,78,86,86,85,94,84,100,83,104,81,110,79,115,0,73,91,77,43,77,82,77,121,32,78,43,78,82,78,121,32,77,43,88,43,32,77,121,88,121,0,73,91,86,43,86,82,86,121,32,87,43,87,82,87,121,32,76,43,87,43,32,76,121,87,121,0,72,91,86,43,82,49,80,53,79,58,79,62,80,66,84,74,84,76,83,78,82,79,77,82,82,85,83,86,84,88,84,90,80,98,79,102,79,106,80,111,82,115,86,121,32,84,46,82,50,81,53,80,58,80,62,81,67,82,70,32,82,94,81,97,80,102,80,106,81,111,82,114,84,118,0,73,92,78,43,82,49,84,53,85,58,85,62,84,66,80,74,80,76,81,78,82,79,87,82,82,85,81,86,80,88,80,90,84,98,85,102,85,106,84,111,82,115,78,121,32,80,46,82,50,83,53,84,58,84,62,83,67,82,70,32,82,94,83,97,84,102,84,106,83,111,82,114,80,118,0,73,91,86,46,83,49,81,52,79,56,78,61,78,67,79,73,80,77,83,88,84,92,85,98,85,103,84,108,83,111,81,115,32,83,49,81,53,80,56,79,61,79,66,80,72,81,76,84,87,85,91,86,97,86,103,85,108,83,112,81,115,78,118,0,73,91,78,46,81,49,83,52,85,56,86,61,86,67,85,73,84,77,81,88,80,92,79,98,79,103,80,108,81,111,83,115,32,81,49,83,53,84,56,85,61,85,66,84,72,83,76,80,87,79,91,78,97,78,103,79,108,81,112,83,115,86,118,0,55,90,58,82,65,82,82,111,32,64,82,81,111,32,63,82,82,114,32,90,34,86,74,82,114,0,67,97,93,46,92,46,91,47,91,48,92,49,93,49,94,48,94,46,93,44,91,43,89,43,87,44,85,46,84,48,83,51,82,58,81,74,81,106,80,115,79,118,32,92,47,92,48,93,48,93,47,92,47,32,82,58,82,106,32,85,46,84,49,83,58,83,90,82,106,81,113,80,116,79,118,77,120,75,121,73,121,71,120,70,118,70,116,71,115,72,115,73,116,73,117,72,118,71,118,32,71,116,71,117,72,117,72,116,71,116,0,72,92,82,70,74,91,32,82,73,75,91,74,91,32,82,73,89,91,90,91,32,82,70,90,91,32,77,85,87,85,32,76,86,88,86,0,72,92,76,70,76,91,32,77,71,77,90,32,76,70,84,70,87,71,88,72,89,74,89,77,88,79,87,80,84,81,32,77,71,84,71,87,72,88,74,88,77,87,79,84,80,32,77,80,84,80,87,81,88,82,89,84,89,87,88,89,87,90,84,91,76,91,32,77,81,84,81,87,82,88,84,88,87,87,89,84,90,77,90,0,72,93,90,75,89,73,87,71,85,70,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,85,91,87,90,89,88,90,86,32,90,75,89,75,88,73,87,72,85,71,81,71,79,72,77,75,76,78,76,83,77,86,79,89,81,90,85,90,87,89,88,88,89,86,90,86,0,72,93,76,70,76,91,32,77,71,77,90,32,76,70,83,70,86,71,88,73,89,75,90,78,90,83,89,86,88,88,86,90,83,91,76,91,32,77,71,83,71,86,72,87,73,88,75,89,78,89,83,88,86,87,88,86,89,83,90,77,90,0,73,92,77,70,77,91,32,78,71,78,90,32,77,70,89,70,32,78,71,89,71,89,70,32,78,80,84,80,84,81,32,78,81,84,81,32,78,90,89,90,89,91,32,77,91,89,91,0,73,91,77,70,77,91,32,78,71,78,91,77,91,32,77,70,89,70,32,78,71,89,71,89,70,32,78,80,84,80,84,81,32,78,81,84,81,0,72,93,90,75,89,73,87,71,85,70,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,85,91,87,90,89,88,90,86,90,82,85,82,32,90,75,89,75,88,73,87,72,85,71,81,71,79,72,78,73,77,75,76,78,76,83,77,86,78,88,79,89,81,90,85,90,87,89,88,88,89,86,89,83,85,83,85,82,0,71,93,75,70,75,91,32,75,70,76,70,76,91,75,91,32,89,70,88,70,88,91,89,91,32,89,70,89,91,32,76,80,88,80,32,76,81,88,81,0,78,87,82,70,82,91,83,91,32,82,70,83,70,83,91,0,74,91,86,70,86,86,85,89,83,90,81,90,79,89,78,86,77,86,32,86,70,87,70,87,86,86,89,85,90,83,91,81,91,79,90,78,89,77,86,0,72,93,76,70,76,91,77,91,32,76,70,77,70,77,91,32,90,70,89,70,77,82,32,90,70,77,83,32,80,79,89,91,90,91,32,81,79,90,91,0,73,90,77,70,77,91,32,77,70,78,70,78,90,32,78,90,89,90,89,91,32,77,91,89,91,0,70,94,74,70,74,91,32,75,75,75,91,74,91,32,75,75,82,91,32,74,70,82,88,32,90,70,82,88,32,89,75,82,91,32,89,75,89,91,90,91,32,90,70,90,91,0,71,93,75,70,75,91,32,76,73,76,91,75,91,32,76,73,89,91,32,75,70,88,88,32,88,70,88,88,32,88,70,89,70,89,91,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,32,81,71,78,72,76,75,75,78,75,83,76,86,78,89,81,90,83,90,86,89,88,86,89,83,89,78,88,75,86,72,83,71,81,71,0,72,92,76,70,76,91,32,77,71,77,91,76,91,32,76,70,85,70,87,71,88,72,89,74,89,77,88,79,87,80,85,81,77,81,32,77,71,85,71,87,72,88,74,88,77,87,79,85,80,77,80,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,32,81,71,78,72,76,75,75,78,75,83,76,86,78,89,81,90,83,90,86,89,88,86,89,83,89,78,88,75,86,72,83,71,81,71,32,83,88,88,93,89,93,32,83,88,84,88,89,93,0,72,92,76,70,76,91,32,77,71,77,91,76,91,32,76,70,84,70,87,71,88,72,89,74,89,77,88,79,87,80,84,81,77,81,32,77,71,84,71,87,72,88,74,88,77,87,79,84,80,77,80,32,82,81,88,91,89,91,32,83,81,89,91,0,72,92,89,73,87,71,84,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,84,81,86,82,87,83,88,85,88,88,87,89,84,90,80,90,78,89,77,88,75,88,32,89,73,87,73,86,72,84,71,80,71,77,72,76,73,76,75,77,77,79,78,84,80,86,81,88,83,89,85,89,88,87,90,84,91,80,91,77,90,75,88,0,74,91,82,71,82,91,32,83,71,83,91,82,91,32,76,70,89,70,89,71,32,76,70,76,71,89,71,0,71,93,75,70,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,70,32,75,70,76,70,76,85,77,88,78,89,81,90,83,90,86,89,87,88,88,85,88,70,89,70,0,72,92,74,70,82,91,32,74,70,75,70,82,88,32,90,70,89,70,82,88,32,90,70,82,91,0,69,95,71,70,77,91,32,71,70,72,70,77,88,32,82,70,77,88,32,82,73,77,91,32,82,73,87,91,32,82,70,87,88,32,93,70,92,70,87,88,32,93,70,87,91,0,72,92,75,70,88,91,89,91,32,75,70,76,70,89,91,32,89,70,88,70,75,91,32,89,70,76,91,75,91,0,73,92,75,70,82,80,82,91,83,91,32,75,70,76,70,83,80,32,90,70,89,70,82,80,32,90,70,83,80,83,91,0,72,92,88,70,75,91,32,89,70,76,91,32,75,70,89,70,32,75,70,75,71,88,71,32,76,90,89,90,89,91,32,75,91,89,91,0,69,92,88,70,86,72,84,75,81,80,79,83,76,87,73,90,71,91,69,91,68,90,68,88,69,87,70,88,69,89,32,88,70,87,74,85,84,84,91,32,88,70,85,91,32,84,91,84,89,83,86,82,84,80,82,78,81,76,81,75,82,75,84,76,87,79,90,82,91,86,91,88,90,0,70,94,85,71,84,72,83,74,81,79,79,85,78,87,76,90,74,91,32,84,72,83,75,81,83,80,86,79,88,77,90,74,91,72,91,71,90,71,88,72,87,73,88,72,89,32,79,76,78,78,77,79,75,79,74,78,74,76,75,74,77,72,79,71,82,70,88,70,90,71,91,73,91,75,90,77,88,78,84,79,82,79,32,88,70,89,71,90,73,90,75,89,77,88,78,32,84,79,87,80,88,81,89,83,89,86,88,89,87,90,85,91,83,91,82,90,82,88,83,85,32,84,79,86,80,87,81,88,83,88,86,87,89,85,91,0,72,93,75,72,74,74,74,76,75,78,78,79,81,79,85,78,87,77,89,75,90,73,90,71,89,70,87,70,84,71,81,74,79,77,77,81,76,85,76,88,77,90,80,91,82,91,85,90,87,88,88,86,88,84,87,82,85,82,83,83,82,85,32,87,70,85,71,82,74,80,77,78,81,77,85,77,88,78,90,80,91,0,70,93,85,71,84,72,83,74,81,79,79,85,78,87,76,90,74,91,32,84,72,83,75,81,83,80,86,79,88,77,90,74,91,72,91,71,90,71,88,72,87,74,87,76,88,78,90,80,91,83,91,85,90,87,88,89,84,90,79,90,76,89,73,87,71,85,70,80,70,77,71,75,73,74,75,74,77,75,78,77,78,78,77,79,75,0,73,92,87,73,86,74,86,76,87,77,89,77,90,75,90,73,89,71,87,70,84,70,82,71,81,72,80,74,80,76,81,78,83,79,32,84,70,82,72,81,74,81,77,83,79,32,83,79,81,79,78,80,76,82,75,84,75,87,76,89,77,90,79,91,82,91,85,90,87,88,88,86,88,84,87,82,85,82,83,83,82,85,32,81,79,79,80,77,82,76,84,76,88,77,90,0,71,92,87,72,86,74,84,79,82,85,81,87,79,90,77,91,32,81,76,80,78,78,79,76,79,75,77,75,75,76,73,78,71,81,70,91,70,88,71,87,72,86,75,84,83,83,86,82,88,80,90,77,91,75,91,73,90,72,89,72,88,73,87,74,88,73,89,32,83,70,87,71,88,71,32,79,83,80,82,82,81,86,81,88,80,90,77,88,84,0,71,93,74,73,73,75,73,77,74,79,76,80,79,80,82,79,84,78,87,75,88,72,88,71,87,70,86,70,84,71,82,73,81,75,80,78,80,81,81,83,83,84,85,84,87,83,89,81,90,79,32,87,70,85,71,83,73,82,75,81,78,81,82,83,84,32,90,79,89,83,87,87,85,89,83,90,79,91,76,91,74,90,73,88,73,87,74,86,75,87,74,88,32,89,83,87,86,85,88,82,90,79,91,0,70,94,76,76,75,75,75,73,76,71,79,70,82,70,79,81,77,87,76,89,75,90,73,91,71,91,70,90,70,88,71,87,72,88,71,89,32,82,70,79,79,78,82,76,87,75,89,73,91,32,74,84,75,83,77,82,86,79,88,78,91,76,93,74,94,72,94,71,93,70,92,70,90,71,88,74,87,76,85,82,84,86,84,89,86,91,87,91,89,90,91,88,32,92,70,90,72,88,76,86,82,85,86,85,89,86,91,0,73,89,87,72,85,75,83,80,81,85,80,87,78,90,76,91,32,89,76,87,78,84,79,81,79,79,78,78,76,78,74,79,72,81,71,85,70,89,70,87,72,86,74,84,80,82,86,81,88,79,90,76,91,74,91,73,90,73,88,74,87,75,88,74,89,0,73,90,89,70,87,72,85,75,83,80,80,89,78,93,32,89,77,87,79,84,80,81,80,79,79,78,77,78,75,79,73,81,71,85,70,89,70,87,73,86,75,83,84,81,88,80,90,78,93,77,94,75,95,74,94,74,92,75,90,77,88,79,87,82,86,86,85,0,70,94,76,76,75,75,75,73,77,71,80,70,82,70,79,81,77,87,76,89,75,90,73,91,71,91,70,90,70,88,71,87,72,88,71,89,32,82,70,79,79,78,82,76,87,75,89,73,91,32,90,71,87,75,85,77,83,78,80,79,32,93,71,92,72,93,73,94,72,94,71,93,70,92,70,90,71,87,76,86,77,84,78,80,79,32,80,79,83,80,84,82,85,89,86,91,32,80,79,82,80,83,82,84,89,86,91,87,91,89,90,91,88,0,73,91,77,73,76,75,76,77,77,79,79,80,82,80,85,79,87,78,90,75,91,72,91,71,90,70,89,70,87,71,86,72,84,75,80,85,79,87,77,90,75,91,32,86,72,84,76,82,83,81,86,80,88,78,90,75,91,73,91,72,90,72,88,73,87,75,87,77,88,80,90,82,91,85,91,87,90,89,88,0,68,96,82,70,78,79,75,85,73,88,71,90,69,91,67,91,66,90,66,88,67,87,68,88,67,89,32,82,70,80,77,79,81,78,86,78,90,80,91,32,82,70,81,74,80,79,79,86,79,90,80,91,32,91,70,87,79,82,88,80,91,32,91,70,89,77,88,81,87,86,87,90,89,91,90,91,92,90,94,88,32,91,70,90,74,89,79,88,86,88,90,89,91,0,71,94,82,70,81,74,79,80,77,85,76,87,74,90,72,91,70,91,69,90,69,88,70,87,71,88,70,89,32,82,70,82,75,83,86,84,91,32,82,70,83,75,84,86,84,91,32,96,71,95,72,96,73,97,72,97,71,96,70,94,70,92,71,90,74,89,76,87,81,85,87,84,91,0,72,93,83,70,81,71,79,73,77,76,76,78,75,82,75,86,76,89,77,90,79,91,81,91,84,90,86,88,88,85,89,83,90,79,90,75,89,72,88,71,87,71,85,72,83,74,81,78,80,83,80,86,32,81,71,79,74,77,78,76,82,76,86,77,89,79,91,0,70,93,85,71,84,72,83,74,81,79,79,85,78,87,76,90,74,91,32,84,72,83,75,81,83,80,86,79,88,77,90,74,91,72,91,71,90,71,88,72,87,73,88,72,89,32,79,76,78,78,77,79,75,79,74,78,74,76,75,74,77,72,79,71,82,70,86,70,89,71,90,72,91,74,91,77,90,79,89,80,86,81,84,81,82,80,32,86,70,88,71,89,72,90,74,90,77,89,79,88,80,86,81,0,72,93,85,74,85,76,84,78,83,79,81,80,79,80,78,78,78,76,79,73,81,71,84,70,87,70,89,71,90,73,90,77,89,80,87,83,83,87,80,89,78,90,75,91,73,91,72,90,72,88,73,87,75,87,77,88,80,90,83,91,86,91,88,90,90,88,32,87,70,88,71,89,73,89,77,88,80,86,83,83,86,79,89,75,91,0,70,94,85,71,84,72,83,74,81,79,79,85,78,87,76,90,74,91,32,84,72,83,75,81,83,80,86,79,88,77,90,74,91,72,91,71,90,71,88,72,87,73,88,72,89,32,79,76,78,78,77,79,75,79,74,78,74,76,75,74,77,72,79,71,82,70,87,70,90,71,91,73,91,75,90,77,89,78,86,79,82,79,32,87,70,89,71,90,73,90,75,89,77,88,78,86,79,32,82,79,85,80,86,82,87,89,88,91,32,82,79,84,80,85,82,86,89,88,91,89,91,91,90,93,88,0,72,92,78,73,77,75,77,77,78,79,80,80,83,80,86,79,88,78,91,75,92,72,92,71,91,70,90,70,88,71,87,72,86,74,85,77,83,84,82,87,80,90,78,91,32,86,74,85,78,84,85,83,88,81,90,78,91,75,91,73,90,72,88,72,87,73,86,74,87,73,88,0,73,91,89,72,88,74,86,79,84,85,83,87,81,90,79,91,32,83,76,82,78,80,79,78,79,77,77,77,75,78,73,80,71,83,70,92,70,90,71,89,72,88,75,86,83,85,86,84,88,82,90,79,91,77,91,75,90,74,89,74,88,75,87,76,88,75,89,32,85,70,89,71,90,71,0,71,93,72,74,74,71,76,70,77,70,79,72,79,75,78,78,75,86,75,89,76,91,32,77,70,78,72,78,75,75,83,74,86,74,89,76,91,78,91,80,90,83,87,85,84,86,82,32,90,70,86,82,85,86,85,89,87,91,88,91,90,90,92,88,32,91,70,87,82,86,86,86,89,87,91,0,71,92,72,74,74,71,76,70,77,70,79,72,79,75,78,79,76,86,76,89,77,91,32,77,70,78,72,78,75,76,82,75,86,75,89,77,91,78,91,81,90,84,87,86,84,88,80,89,77,90,73,90,71,89,70,88,70,87,71,86,73,86,76,87,78,89,80,91,81,93,81,0,70,93,73,76,72,76,71,75,71,73,72,71,74,70,78,70,77,72,76,76,75,85,74,91,32,76,76,76,85,75,91,32,86,70,84,72,82,76,79,85,77,89,75,91,32,86,70,85,72,84,76,83,85,82,91,32,84,76,84,85,83,91,32,96,70,94,71,92,73,90,76,87,85,85,89,83,91,0,72,92,80,75,79,76,77,76,76,75,76,73,77,71,79,70,81,70,83,71,84,73,84,76,83,80,81,85,79,88,77,90,74,91,72,91,71,90,71,88,72,87,73,88,72,89,32,81,70,82,71,83,73,83,76,82,80,80,85,78,88,76,90,74,91,32,93,71,92,72,93,73,94,72,94,71,93,70,91,70,89,71,87,73,85,76,83,80,82,85,82,88,83,90,84,91,85,91,87,90,89,88,0,71,93,74,74,76,71,78,70,79,70,81,71,81,73,79,79,79,82,80,84,32,79,70,80,71,80,73,78,79,78,82,80,84,82,84,85,83,87,81,89,78,90,76,32,92,70,90,76,87,84,85,88,32,93,70,91,76,89,81,87,85,85,88,83,90,80,91,76,91,74,90,73,88,73,87,74,86,75,87,74,88,0,71,92,90,72,89,74,87,79,86,82,85,84,83,87,81,89,79,90,76,91,32,83,76,82,78,80,79,78,79,77,77,77,75,78,73,80,71,83,70,93,70,91,71,90,72,89,75,88,79,86,85,84,88,81,90,76,91,72,91,71,90,71,88,72,87,74,87,76,88,79,90,81,91,84,91,87,90,89,88,32,86,70,90,71,91,71,0,72,92,87,77,87,91,88,91,32,87,77,88,77,88,91,32,87,80,85,78,83,77,80,77,78,78,76,80,75,83,75,85,76,88,78,90,80,91,83,91,85,90,87,88,32,87,80,83,78,80,78,78,79,77,80,76,83,76,85,77,88,78,89,80,90,83,90,87,88,0,72,92,76,70,76,91,77,91,32,76,70,77,70,77,91,32,77,80,79,78,81,77,84,77,86,78,88,80,89,83,89,85,88,88,86,90,84,91,81,91,79,90,77,88,32,77,80,81,78,84,78,86,79,87,80,88,83,88,85,87,88,86,89,84,90,81,90,77,88,0,73,91,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,32,88,80,87,81,86,79,84,78,81,78,79,79,78,80,77,83,77,85,78,88,79,89,81,90,84,90,86,89,87,87,88,88,0,72,92,87,70,87,91,88,91,32,87,70,88,70,88,91,32,87,80,85,78,83,77,80,77,78,78,76,80,75,83,75,85,76,88,78,90,80,91,83,91,85,90,87,88,32,87,80,83,78,80,78,78,79,77,80,76,83,76,85,77,88,78,89,80,90,83,90,87,88,0,73,91,77,84,88,84,88,81,87,79,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,32,77,83,87,83,87,81,86,79,84,78,81,78,79,79,78,80,77,83,77,85,78,88,79,89,81,90,84,90,86,89,87,87,88,88,0,76,90,87,70,85,70,83,71,82,74,82,91,83,91,32,87,70,87,71,85,71,83,72,32,84,71,83,74,83,91,32,79,77,86,77,86,78,32,79,77,79,78,86,78,0,72,92,88,77,87,77,87,92,86,95,85,96,83,97,81,97,79,96,78,95,76,95,32,88,77,88,92,87,95,85,97,83,98,80,98,78,97,76,95,32,87,80,85,78,83,77,80,77,78,78,76,80,75,83,75,85,76,88,78,90,80,91,83,91,85,90,87,88,32,87,80,83,78,80,78,78,79,77,80,76,83,76,85,77,88,78,89,80,90,83,90,87,88,0,72,92,76,70,76,91,77,91,32,76,70,77,70,77,91,32,77,81,80,78,82,77,85,77,87,78,88,81,88,91,32,77,81,80,79,82,78,84,78,86,79,87,81,87,91,88,91,0,78,87,82,70,81,71,81,72,82,73,83,73,84,72,84,71,83,70,82,70,32,82,71,82,72,83,72,83,71,82,71,32,82,77,82,91,83,91,32,82,77,83,77,83,91,0,78,87,82,70,81,71,81,72,82,73,83,73,84,72,84,71,83,70,82,70,32,82,71,82,72,83,72,83,71,82,71,32,82,77,82,98,83,98,32,82,77,83,77,83,98,0,72,91,76,70,76,91,77,91,32,76,70,77,70,77,91,32,88,77,87,77,77,87,32,88,77,77,88,32,80,84,86,91,88,91,32,81,83,88,91,0,67,98,71,77,71,91,72,91,32,71,77,72,77,72,91,32,72,81,75,78,77,77,80,77,82,78,83,81,83,91,32,72,81,75,79,77,78,79,78,81,79,82,81,82,91,83,91,32,83,81,86,78,88,77,91,77,93,78,94,81,94,91,32,83,81,86,79,88,78,90,78,92,79,93,81,93,91,94,91,0,72,92,76,77,76,91,77,91,32,76,77,77,77,77,91,32,77,81,80,78,82,77,85,77,87,78,88,81,88,91,32,77,81,80,79,82,78,84,78,86,79,87,81,87,91,88,91,0,73,92,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,89,85,89,83,88,80,86,78,84,77,81,77,32,81,78,79,79,78,80,77,83,77,85,78,88,79,89,81,90,84,90,86,89,87,88,88,85,88,83,87,80,86,79,84,78,81,78,0,72,92,76,77,76,98,77,98,32,76,77,77,77,77,98,32,77,80,79,78,81,77,84,77,86,78,88,80,89,83,89,85,88,88,86,90,84,91,81,91,79,90,77,88,32,77,80,81,78,84,78,86,79,87,80,88,83,88,85,87,88,86,89,84,90,81,90,77,88,0,72,92,87,77,87,98,88,98,32,87,77,88,77,88,98,32,87,80,85,78,83,77,80,77,78,78,76,80,75,83,75,85,76,88,78,90,80,91,83,91,85,90,87,88,32,87,80,83,78,80,78,78,79,77,80,76,83,76,85,77,88,78,89,80,90,83,90,87,88,0,75,89,79,77,79,91,80,91,32,79,77,80,77,80,91,32,80,83,81,80,83,78,85,77,88,77,32,80,83,81,81,83,79,85,78,88,78,88,77,0,74,91,88,80,87,78,84,77,81,77,78,78,77,80,78,82,80,83,85,85,87,86,32,86,85,87,87,87,88,86,90,32,87,89,84,90,81,90,78,89,32,79,90,78,88,77,88,32,88,80,87,80,86,78,32,87,79,84,78,81,78,78,79,32,79,78,78,80,79,82,32,78,81,80,82,85,84,87,85,88,87,88,88,87,90,84,91,81,91,78,90,77,88,0,77,88,82,70,82,91,83,91,32,82,70,83,70,83,91,32,79,77,86,77,86,78,32,79,77,79,78,86,78,0,72,92,76,77,76,87,77,90,79,91,82,91,84,90,87,87,32,76,77,77,77,77,87,78,89,80,90,82,90,84,89,87,87,32,87,77,87,91,88,91,32,87,77,88,77,88,91,0,74,90,76,77,82,91,32,76,77,77,77,82,89,32,88,77,87,77,82,89,32,88,77,82,91,0,70,94,73,77,78,91,32,73,77,74,77,78,88,32,82,77,78,88,32,82,80,78,91,32,82,80,86,91,32,82,77,86,88,32,91,77,90,77,86,88,32,91,77,86,91,0,73,91,76,77,87,91,88,91,32,76,77,77,77,88,91,32,88,77,87,77,76,91,32,88,77,77,91,76,91,0,74,90,76,77,82,91,32,76,77,77,77,82,89,32,88,77,87,77,82,89,78,98,32,88,77,82,91,79,98,78,98,0,73,91,86,78,76,91,32,88,77,78,90,32,76,77,88,77,32,76,77,76,78,86,78,32,78,90,88,90,88,91,32,76,91,88,91,0,75,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,32,80,82,78,84,77,86,77,89,79,91,32,86,82,84,88,84,90,86,91,88,90,89,89,91,86,32,87,82,85,88,85,90,86,91,0,76,90,76,86,78,83,80,79,32,83,70,77,88,77,90,79,91,80,91,82,90,84,88,85,85,85,82,86,86,87,87,88,87,90,86,32,84,70,78,88,78,90,79,91,0,76,88,84,83,83,84,84,84,84,83,83,82,81,82,79,83,78,84,77,86,77,88,78,90,80,91,83,91,86,89,88,86,32,81,82,79,84,78,86,78,89,80,91,0,75,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,32,80,82,78,84,77,86,77,89,79,91,32,90,70,84,88,84,90,86,91,88,90,89,89,91,86,32,91,70,85,88,85,90,86,91,0,76,88,79,89,81,88,82,87,83,85,83,83,82,82,81,82,79,83,78,84,77,86,77,88,78,90,80,91,83,91,86,89,88,86,32,81,82,79,84,78,86,78,89,80,91,0,79,88,82,82,85,79,87,76,88,73,88,71,87,70,85,71,84,73,75,100,75,102,76,103,78,102,79,99,80,90,81,91,83,91,85,90,86,89,88,86,32,84,73,83,78,82,82,79,91,77,96,75,100,0,75,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,32,80,82,78,84,77,86,77,89,79,91,32,86,82,80,100,32,87,82,84,91,82,96,80,100,79,102,77,103,76,102,76,100,77,97,79,95,82,93,86,91,89,89,91,86,0,76,91,76,86,78,83,80,79,32,83,70,76,91,32,84,70,77,91,32,79,85,81,83,83,82,84,82,86,83,86,85,85,88,85,90,86,91,32,84,82,85,83,85,85,84,88,84,90,86,91,88,90,89,89,91,86,0,78,86,83,76,82,77,83,78,84,77,83,76,32,81,82,79,88,79,90,81,91,83,90,84,89,86,86,32,82,82,80,88,80,90,81,91,0,78,86,83,76,82,77,83,78,84,77,83,76,32,81,82,75,100,32,82,82,79,91,77,96,75,100,74,102,72,103,71,102,71,100,72,97,74,95,77,93,81,91,84,89,86,86,0,76,90,76,86,78,83,80,79,32,83,70,76,91,32,84,70,77,91,32,85,82,85,83,86,83,85,82,84,82,82,84,79,85,32,79,85,82,86,83,90,84,91,32,79,85,81,86,82,90,84,91,85,91,88,89,90,86,0,78,86,78,86,80,83,82,79,32,85,70,79,88,79,90,81,91,83,90,84,89,86,86,32,86,70,80,88,80,90,81,91,0,69,94,69,86,71,83,73,82,75,83,75,85,73,91,32,73,82,74,83,74,85,72,91,32,75,85,77,83,79,82,80,82,82,83,82,85,80,91,32,80,82,81,83,81,85,79,91,32,82,85,84,83,86,82,87,82,89,83,89,85,88,88,88,90,89,91,32,87,82,88,83,88,85,87,88,87,90,89,91,91,90,92,89,94,86,0,73,91,73,86,75,83,77,82,79,83,79,85,77,91,32,77,82,78,83,78,85,76,91,32,79,85,81,83,83,82,84,82,86,83,86,85,85,88,85,90,86,91,32,84,82,85,83,85,85,84,88,84,90,86,91,88,90,89,89,91,86,0,75,89,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,89,85,87,85,85,84,83,82,82,81,83,81,85,82,87,84,88,86,88,88,87,89,86,32,80,82,78,84,77,86,77,89,79,91,0,76,91,76,86,78,83,80,79,32,81,76,72,103,32,82,76,73,103,32,79,85,81,83,83,82,84,82,86,83,86,85,85,88,85,90,86,91,32,84,82,85,83,85,85,84,88,84,90,86,91,88,90,89,89,91,86,0,75,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,32,80,82,78,84,77,86,77,89,79,91,32,86,82,80,100,80,102,81,103,83,102,84,99,84,91,86,91,89,89,91,86,32,87,82,84,91,82,96,80,100,0,76,90,76,86,78,83,80,82,82,83,82,85,80,91,32,80,82,81,83,81,85,79,91,32,82,85,84,83,86,82,87,82,86,85,32,86,82,86,85,87,87,88,87,90,86,0,78,90,78,86,80,83,81,81,81,83,84,85,85,87,85,89,84,90,82,91,32,81,83,83,85,84,87,84,89,82,91,32,78,90,80,91,85,91,88,89,90,86,0,78,86,78,86,80,83,82,79,32,85,70,79,88,79,90,81,91,83,90,84,89,86,86,32,86,70,80,88],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+276492);allocate([80,90,81,91,32,80,78,86,78,0,75,91,78,82,76,88,76,90,78,91,79,91,81,90,83,88,85,85,32,79,82,77,88,77,90,78,91,32,86,82,84,88,84,90,86,91,88,90,89,89,91,86,32,87,82,85,88,85,90,86,91,0,75,90,78,82,77,84,76,87,76,90,78,91,79,91,82,90,84,88,85,85,85,82,32,79,82,78,84,77,87,77,90,78,91,32,85,82,86,86,87,87,88,87,90,86,0,72,93,76,82,74,84,73,87,73,90,75,91,76,91,78,90,80,88,32,77,82,75,84,74,87,74,90,75,91,32,82,82,80,88,80,90,82,91,83,91,85,90,87,88,88,85,88,82,32,83,82,81,88,81,90,82,91,32,88,82,89,86,90,87,91,87,93,86,0,74,90,74,86,76,83,78,82,80,82,81,83,81,85,80,88,79,90,77,91,76,91,75,90,75,89,76,89,75,90,32,87,83,86,84,87,84,87,83,86,82,85,82,83,83,82,85,81,88,81,90,82,91,85,91,88,89,90,86,32,81,83,82,85,32,83,83,81,85,32,80,88,81,90,32,81,88,79,90,0,75,91,78,82,76,88,76,90,78,91,79,91,81,90,83,88,85,85,32,79,82,77,88,77,90,78,91,32,86,82,80,100,32,87,82,84,91,82,96,80,100,79,102,77,103,76,102,76,100,77,97,79,95,82,93,86,91,89,89,91,86,0,76,89,76,86,78,83,80,82,82,82,84,83,84,86,83,88,80,90,78,91,32,82,82,83,83,83,86,82,88,80,90,32,78,91,80,92,81,94,81,97,80,100,78,102,76,103,75,102,75,100,76,97,79,94,82,92,86,89,89,86,32,78,91,79,92,80,94,80,97,79,100,78,102,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,32,79,71,77,74,76,79,76,82,77,87,79,90,32,78,89,81,90,83,90,86,89,32,85,90,87,87,88,82,88,79,87,74,85,71,32,86,72,83,71,81,71,78,72,0,72,92,78,74,80,73,83,70,83,91,32,78,74,78,75,80,74,82,72,82,91,83,91,0,72,92,76,75,76,74,77,72,78,71,80,70,84,70,86,71,87,72,88,74,88,76,87,78,85,81,76,91,32,76,75,77,75,77,74,78,72,80,71,84,71,86,72,87,74,87,76,86,78,84,81,75,91,32,76,90,89,90,89,91,32,75,91,89,91,0,72,92,77,70,88,70,81,79,32,77,70,77,71,87,71,32,87,70,80,79,32,81,78,83,78,86,79,88,81,89,84,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,76,87,32,80,79,83,79,86,80,88,83,32,84,79,87,81,88,84,88,85,87,88,84,90,32,88,86,86,89,83,90,80,90,77,89,76,87,32,79,90,76,88,0,72,92,85,73,85,91,86,91,32,86,70,86,91,32,86,70,75,86,90,86,32,85,73,76,86,32,76,85,90,85,90,86,0,72,92,77,70,76,79,32,78,71,77,78,32,77,70,87,70,87,71,32,78,71,87,71,32,77,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,76,87,32,76,79,77,79,79,78,83,78,86,79,88,82,32,84,78,87,80,88,83,88,85,87,88,84,90,32,88,86,86,89,83,90,80,90,77,89,76,87,32,79,90,76,88,0,72,92,86,71,87,73,88,73,87,71,84,70,82,70,79,71,77,74,76,79,76,84,77,88,79,90,82,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,82,78,79,79,77,81,32,87,72,84,71,82,71,79,72,32,80,71,78,74,77,79,77,84,78,88,81,90,32,77,86,79,89,82,90,83,90,86,89,88,86,32,84,90,87,88,88,85,88,84,87,81,84,79,32,88,83,86,80,83,79,82,79,79,80,77,83,32,81,79,78,81,77,84,0,72,92,75,70,89,70,79,91,32,75,70,75,71,88,71,32,88,70,78,91,79,91,0,72,92,80,70,77,71,76,73,76,75,77,77,78,78,80,79,84,80,86,81,87,82,88,84,88,87,87,89,84,90,80,90,77,89,76,87,76,84,77,82,78,81,80,80,84,79,86,78,87,77,88,75,88,73,87,71,84,70,80,70,32,78,71,77,73,77,75,78,77,80,78,84,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,84,76,82,78,80,80,79,84,78,86,77,87,75,87,73,86,71,32,87,72,84,71,80,71,77,72,32,76,88,79,90,32,85,90,88,88,0,72,92,87,80,85,82,82,83,81,83,78,82,76,80,75,77,75,76,76,73,78,71,81,70,82,70,85,71,87,73,88,77,88,82,87,87,85,90,82,91,80,91,77,90,76,88,77,88,78,90,32,87,77,86,80,83,82,32,87,78,85,81,82,82,81,82,78,81,76,78,32,80,82,77,80,76,77,76,76,77,73,80,71,32,76,75,78,72,81,71,82,71,85,72,87,75,32,83,71,86,73,87,77,87,82,86,87,84,90,32,85,89,82,90,80,90,77,89,0,77,88,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,77,88,84,90,83,91,82,91,81,90,81,89,82,88,83,88,84,89,84,92,83,94,81,95,32,82,89,82,90,83,90,83,89,82,89,32,83,91,84,92,32,84,90,83,94,0,77,88,82,77,81,78,81,79,82,80,83,80,84,79,84,78,83,77,82,77,32,82,78,82,79,83,79,83,78,82,78,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,77,88,82,77,81,78,81,79,82,80,83,80,84,79,84,78,83,77,82,77,32,82,78,82,79,83,79,83,78,82,78,32,84,90,83,91,82,91,81,90,81,89,82,88,83,88,84,89,84,92,83,94,81,95,32,82,89,82,90,83,90,83,89,82,89,32,83,91,84,92,32,84,90,83,94,0,77,88,82,70,82,84,83,84,32,82,70,83,70,83,84,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,73,92,76,75,76,74,77,72,78,71,81,70,84,70,87,71,88,72,89,74,89,76,88,78,87,79,85,80,82,81,32,76,75,77,75,77,74,78,72,81,71,84,71,87,72,88,74,88,76,87,78,85,79,82,80,32,77,73,80,71,32,85,71,88,73,32,88,77,84,80,32,82,80,82,84,83,84,83,80,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,77,88,84,70,82,71,81,73,81,76,82,77,83,77,84,76,84,75,83,74,82,74,81,75,32,82,75,82,76,83,76,83,75,82,75,32,82,71,81,75,32,81,73,82,74,0,77,88,84,72,83,73,82,73,81,72,81,71,82,70,83,70,84,71,84,74,83,76,81,77,32,82,71,82,72,83,72,83,71,82,71,32,83,73,84,74,32,84,72,83,76,0,70,95,92,77,90,77,88,78,87,80,85,86,84,88,83,89,81,90,77,90,75,89,74,87,74,85,75,83,76,82,81,79,83,77,84,75,84,73,83,71,81,70,80,70,78,71,77,73,77,75,78,78,80,81,85,87,88,90,90,91,92,91,32,92,77,92,78,90,78,87,80,32,90,77,88,80,86,86,85,88,83,90,81,91,77,91,75,90,74,89,73,87,73,85,74,83,76,81,81,78,82,77,83,75,83,73,82,71,32,83,72,81,71,80,71,78,72,32,79,71,78,73,78,75,79,78,81,81,86,87,88,89,90,90,92,90,92,91,0,73,92,82,66,82,95,83,95,32,82,66,83,66,83,95,32,87,73,89,73,87,71,84,70,81,70,78,71,76,73,76,75,77,77,78,78,86,82,87,83,88,85,88,87,87,89,84,90,81,90,79,89,78,88,32,87,73,86,72,84,71,81,71,78,72,77,73,77,75,78,77,86,81,88,83,89,85,89,87,88,89,87,90,84,91,81,91,78,90,76,88,78,88,32,88,88,85,90,0,71,94,91,66,73,98,74,98,32,91,66,92,66,74,98,0,75,89,85,66,83,68,81,71,79,75,78,80,78,84,79,89,81,93,83,96,85,98,86,98,32,85,66,86,66,84,68,82,71,80,75,79,80,79,84,80,89,82,93,84,96,86,98,0,75,89,78,66,80,68,82,71,84,75,85,80,85,84,84,89,82,93,80,96,78,98,79,98,32,78,66,79,66,81,68,83,71,85,75,86,80,86,84,85,89,83,93,81,96,79,98,0,74,90,82,70,81,71,83,81,82,82,32,82,70,82,82,32,82,70,83,71,81,81,82,82,32,77,73,78,73,86,79,87,79,32,77,73,87,79,32,77,73,77,74,87,78,87,79,32,87,73,86,73,78,79,77,79,32,87,73,77,79,32,87,73,87,74,77,78,77,79,0,70,95,74,81,91,81,91,82,32,74,81,74,82,91,82,0,70,95,82,73,82,90,83,90,32,82,73,83,73,83,90,32,74,81,91,81,91,82,32,74,81,74,82,91,82,0,70,95,74,77,91,77,91,78,32,74,77,74,78,91,78,32,74,85,91,85,91,86,32,74,85,74,86,91,86,0,78,87,83,70,82,71,82,77,32,83,71,82,77,32,83,70,84,71,82,77,0,73,91,78,70,77,71,77,77,32,78,71,77,77,32,78,70,79,71,77,77,32,87,70,86,71,86,77,32,87,71,86,77,32,87,70,88,71,86,77,0,75,89,81,70,79,71,78,73,78,75,79,77,81,78,83,78,85,77,86,75,86,73,85,71,83,70,81,70,32,81,70,78,73,79,77,83,78,86,75,85,71,81,70,32,83,70,79,71,78,75,81,78,85,77,86,73,83,70,0,70,94,90,73,74,82,90,91,32,90,73,90,74,76,82,90,90,90,91,0,70,94,74,73,90,82,74,91,32,74,73,74,74,88,82,74,90,74,91,0,71,94,79,70,79,98,80,98,32,79,70,80,70,80,98,32,85,70,85,98,86,98,32,85,70,86,70,86,98,32,74,80,91,80,91,81,32,74,80,74,81,91,81,32,74,87,91,87,91,88,32,74,87,74,88,91,88,0,70,94,91,70,89,71,86,72,83,72,80,71,78,70,76,70,74,71,73,73,73,75,75,77,77,77,79,76,80,74,80,72,78,70,32,91,70,72,91,73,91,32,91,70,92,70,73,91,32,89,84,87,84,85,85,84,87,84,89,86,91,88,91,90,90,91,88,91,86,89,84,32,78,70,74,71,73,75,77,77,80,74,78,70,32,76,70,73,73,75,77,79,76,80,72,76,70,32,89,84,85,85,84,89,88,91,91,88,89,84,32,87,84,84,87,86,91,90,90,91,86,87,84,0,69,96,87,77,84,75,81,75,79,76,78,77,77,79,77,82,78,84,79,85,81,86,84,86,87,84,32,87,77,84,76,81,76,79,77,78,79,78,82,79,84,81,85,84,85,87,84,32,86,75,86,83,87,85,89,86,90,86,92,85,93,83,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,85,91,89,90,32,86,75,87,75,87,83,88,85,90,86,32,89,86,91,85,92,83,92,79,91,76,90,74,89,73,87,72,84,71,81,71,78,72,76,73,75,74,74,76,73,79,73,82,74,85,75,87,76,88,78,89,81,90,85,90,89,89,89,90,0,69,95,74,80,76,79,78,79,80,80,83,84,84,85,86,86,88,86,90,85,91,83,91,81,90,79,88,78,86,78,84,79,83,80,80,84,78,85,76,85,74,84,32,90,80,88,79,86,79,84,80,81,84,80,85,78,86,76,86,74,85,73,83,73,81,74,79,76,78,78,78,80,79,81,80,84,84,86,85,88,85,90,84,32,75,79,74,81,74,83,75,85,32,89,85,90,83,90,81,89,79,0,72,93,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,79,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,84,70,32,84,70,82,71,80,73,78,76,77,79,76,83,76,86,77,89,79,91,32,81,91,83,90,85,88,87,85,88,82,89,78,89,75,88,72,86,70,0,72,93,84,74,79,91,32,86,70,80,91,32,86,70,83,73,80,75,78,76,32,85,73,81,75,78,76,0,72,93,79,74,80,75,79,76,78,75,78,74,79,72,80,71,83,70,86,70,89,71,90,73,90,75,89,77,87,79,84,81,80,83,77,85,75,87,73,91,32,86,70,88,71,89,73,89,75,88,77,86,79,80,83,32,74,89,75,88,77,88,82,90,85,90,87,89,88,87,32,77,88,82,91,85,91,87,90,88,87,0,72,93,79,74,80,75,79,76,78,75,78,74,79,72,80,71,83,70,86,70,89,71,90,73,90,75,89,77,86,79,83,80,32,86,70,88,71,89,73,89,75,88,77,86,79,32,81,80,83,80,86,81,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,86,75,85,76,86,75,87,32,83,80,85,81,86,82,87,84,87,87,86,89,85,90,83,91,0,72,93,88,71,82,91,32,89,70,83,91,32,89,70,74,85,90,85,0,72,93,81,70,76,80,32,81,70,91,70,32,81,71,86,71,91,70,32,76,80,77,79,80,78,83,78,86,79,87,80,88,82,88,85,87,88,85,90,82,91,79,91,76,90,75,89,74,87,74,86,75,85,76,86,75,87,32,83,78,85,79,86,80,87,82,87,85,86,88,84,90,82,91,0,72,93,89,73,88,74,89,75,90,74,90,73,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,87,76,89,77,90,79,91,82,91,85,90,87,88,88,86,88,83,87,81,86,80,84,79,81,79,79,80,77,82,76,84,32,84,70,82,71,80,73,78,76,77,79,76,83,76,88,77,90,32,82,91,84,90,86,88,87,86,87,82,86,80,0,72,93,78,70,76,76,32,91,70,90,73,88,76,83,82,81,85,80,87,79,91,32,88,76,82,82,80,85,79,87,78,91,32,77,73,80,70,82,70,87,73,32,78,72,80,71,82,71,87,73,89,73,90,72,91,70,0,72,93,83,70,80,71,79,72,78,74,78,77,79,79,81,80,84,80,88,79,89,78,90,76,90,73,89,71,86,70,83,70,32,83,70,81,71,80,72,79,74,79,77,80,79,81,80,32,84,80,87,79,88,78,89,76,89,73,88,71,86,70,32,81,80,77,81,75,83,74,85,74,88,75,90,78,91,82,91,86,90,87,89,88,87,88,84,87,82,86,81,84,80,32,81,80,78,81,76,83,75,85,75,88,76,90,78,91,32,82,91,85,90,86,89,87,87,87,83,86,81,0,72,93,89,77,88,79,86,81,84,82,81,82,79,81,78,80,77,78,77,75,78,73,80,71,83,70,86,70,88,71,89,72,90,74,90,78,89,82,88,85,86,88,84,90,81,91,78,91,76,90,75,88,75,87,76,86,77,87,76,88,32,79,81,78,79,78,75,79,73,81,71,83,70,32,88,71,89,73,89,78,88,82,87,85,85,88,83,90,81,91,0,77,88,80,89,79,90,80,91,81,90,80,89,0,77,88,80,91,79,90,80,89,81,90,81,91,80,93,78,95,0,77,88,83,77,82,78,83,79,84,78,83,77,32,80,89,79,90,80,91,81,90,0,77,88,83,77,82,78,83,79,84,78,83,77,32,80,91,79,90,80,89,81,90,81,91,80,93,78,95,0,77,88,85,70,84,71,82,83,32,85,71,82,83,32,85,70,86,71,82,83,32,80,89,79,90,80,91,81,90,80,89,0,72,93,79,74,80,75,79,76,78,75,78,74,79,72,80,71,83,70,87,70,90,71,91,73,91,75,90,77,89,78,83,80,81,81,81,83,82,84,84,84,32,87,70,89,71,90,73,90,75,89,77,88,78,86,79,32,80,89,79,90,80,91,81,90,80,89,0,77,88,86,70,84,72,83,74,83,75,84,76,85,75,84,74,0,77,88,85,72,84,71,85,70,86,71,86,72,85,74,83,76,0,69,95,92,78,91,79,92,80,93,79,93,78,92,77,91,77,89,78,87,80,82,88,80,90,78,91,75,91,72,90,71,88,71,86,72,84,73,83,75,82,80,80,82,79,84,77,85,75,85,73,84,71,82,70,80,71,79,73,79,76,80,82,81,85,83,88,85,90,87,91,89,91,90,89,90,88,32,75,91,73,90,72,88,72,86,73,84,74,83,80,80,32,79,76,80,81,81,84,83,87,85,89,87,90,89,90,90,89,0,72,93,84,66,76,95,32,89,66,81,95,32,90,74,89,75,90,76,91,75,91,74,90,72,89,71,86,70,82,70,79,71,77,73,77,75,78,77,79,78,86,82,88,84,32,77,75,79,77,86,81,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,86,75,85,76,86,75,87,0,71,93,95,66,69,98,0,75,90,90,66,86,69,83,72,81,75,79,79,78,84,78,88,79,93,80,96,81,98,32,86,69,83,73,81,77,80,80,79,85,79,90,80,95,81,98,0,74,89,83,66,84,68,85,71,86,76,86,80,85,85,83,89,81,92,78,95,74,98,32,83,66,84,69,85,74,85,79,84,84,83,87,81,91,78,95,0,74,91,84,70,84,82,32,79,73,89,79,32,89,73,79,79,0,78,87,85,70,83,77,32,86,70,83,77,0,73,91,80,70,78,77,32,81,70,78,77,32,89,70,87,77,32,90,70,87,77,0,75,90,83,70,81,71,80,73,80,75,81,77,83,78,85,78,87,77,88,75,88,73,87,71,85,70,83,70,0,72,93,83,70,76,98,32,89,70,82,98,32,76,81,90,81,32,75,87,89,87,0,69,95,94,70,92,71,88,72,85,72,81,71,79,70,77,70,75,71,74,73,74,75,76,77,78,77,80,76,81,74,81,72,79,70,32,94,70,70,91,32,88,84,86,84,84,85,83,87,83,89,85,91,87,91,89,90,90,88,90,86,88,84,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,89,70,89,76,88,70,32,77,80,85,80,88,81,89,82,90,84,90,87,89,89,88,90,85,91,73,91,32,85,80,87,81,88,82,89,84,89,87,88,89,87,90,85,91,0,70,94,78,70,78,76,77,84,76,88,75,90,74,91,32,88,70,88,91,32,89,70,89,91,32,75,70,92,70,32,71,91,92,91,32,71,91,71,98,32,72,91,71,98,32,91,91,92,98,32,92,91,92,98,0,67,98,82,70,82,91,32,83,70,83,91,32,79,70,86,70,32,71,71,72,72,71,73,70,72,70,71,71,70,72,70,73,71,74,73,75,77,76,79,78,80,87,80,89,79,90,77,91,73,92,71,93,70,94,70,95,71,95,72,94,73,93,72,94,71,32,78,80,76,81,75,83,74,88,73,90,72,91,32,78,80,77,81,76,83,75,88,74,90,73,91,71,91,70,90,69,88,32,87,80,89,81,90,83,91,88,92,90,93,91,32,87,80,88,81,89,83,90,88,91,90,92,91,94,91,95,90,96,88,32,79,91,86,91,0,72,92,76,73,75,70,75,76,76,73,78,71,80,70,84,70,87,71,88,73,88,76,87,78,84,79,81,79,32,84,70,86,71,87,73,87,76,86,78,84,79,32,84,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,79,91,77,90,76,89,75,87,75,86,76,85,77,86,76,87,32,87,81,88,84,88,87,87,89,86,90,84,91,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,79,70,32,85,70,92,70,32,88,72,76,89,32,72,91,79,91,32,85,91,92,91,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,79,70,32,85,70,92,70,32,88,72,76,89,32,72,91,79,91,32,85,91,92,91,32,78,64,78,63,77,63,77,64,78,66,80,67,84,67,86,66,87,64,0,70,94,75,70,75,91,32,76,70,76,91,32,72,70,79,70,32,76,80,83,80,85,79,86,77,87,73,88,71,89,70,90,70,91,71,91,72,90,73,89,72,90,71,32,83,80,85,81,86,83,87,88,88,90,89,91,32,83,80,84,81,85,83,86,88,87,90,88,91,90,91,91,90,92,88,32,72,91,79,91,0,69,94,77,70,77,76,76,84,75,88,74,90,73,91,72,91,71,90,71,89,72,88,73,89,72,90,32,88,70,88,91,32,89,70,89,91,32,74,70,92,70,32,85,91,92,91,0,72,93,75,70,82,86,32,76,70,83,86,32,90,70,83,86,81,89,80,90,78,91,77,91,76,90,76,89,77,88,78,89,77,90,32,73,70,79,70,32,86,70,92,70,0,70,95,82,70,82,91,32,83,70,83,91,32,79,70,86,70,32,80,73,76,74,74,76,73,79,73,82,74,85,76,87,80,88,85,88,89,87,91,85,92,82,92,79,91,76,89,74,85,73,80,73,32,80,73,77,74,75,76,74,79,74,82,75,85,77,87,80,88,32,85,88,88,87,90,85,91,82,91,79,90,76,88,74,85,73,32,79,91,86,91,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,79,70,32,85,70,92,70,32,72,91,92,91,32,91,91,92,98,32,92,91,92,98,0,70,93,75,70,75,81,76,83,79,84,82,84,85,83,87,81,32,76,70,76,81,77,83,79,84,32,87,70,87,91,32,88,70,88,91,32,72,70,79,70,32,84,70,91,70,32,84,91,91,91,0,66,99,71,70,71,91,32,72,70,72,91,32,82,70,82,91,32,83,70,83,91,32,93,70,93,91,32,94,70,94,91,32,68,70,75,70,32,79,70,86,70,32,90,70,97,70,32,68,91,97,91,0,66,99,71,70,71,91,32,72,70,72,91,32,82,70,82,91,32,83,70,83,91,32,93,70,93,91,32,94,70,94,91,32,68,70,75,70,32,79,70,86,70,32,90,70,97,70,32,68,91,97,91,32,96,91,97,98,32,97,91,97,98,0,70,96,80,70,80,91,32,81,70,81,91,32,73,70,72,76,72,70,84,70,32,81,80,88,80,91,81,92,82,93,84,93,87,92,89,91,90,88,91,77,91,32,88,80,90,81,91,82,92,84,92,87,91,89,90,90,88,91,0,67,97,72,70,72,91,32,73,70,73,91,32,69,70,76,70,32,73,80,80,80,83,81,84,82,85,84,85,87,84,89,83,90,80,91,69,91,32,80,80,82,81,83,82,84,84,84,87,83,89,82,90,80,91,32,91,70,91,91,32,92,70,92,91,32,88,70,95,70,32,88,91,95,91,0,72,93,77,70,77,91,32,78,70,78,91,32,74,70,81,70,32,78,80,85,80,88,81,89,82,90,84,90,87,89,89,88,90,85,91,74,91,32,85,80,87,81,88,82,89,84,89,87,88,89,87,90,85,91,0,72,93,76,73,75,70,75,76,76,73,78,71,81,70,83,70,86,71,88,73,89,75,90,78,90,83,89,86,88,88,86,90,83,91,80,91,77,90,76,89,75,87,75,86,76,85,77,86,76,87,32,83,70,85,71,87,73,88,75,89,78,89,83,88,86,87,88,85,90,83,91,32,80,80,89,80,0,67,98,72,70,72,91,32,73,70,73,91,32,69,70,76,70,32,69,91,76,91,32,86,70,83,71,81,73,80,75,79,79,79,82,80,86,81,88,83,90,86,91,88,91,91,90,93,88,94,86,95,82,95,79,94,75,93,73,91,71,88,70,86,70,32,86,70,84,71,82,73,81,75,80,79,80,82,81,86,82,88,84,90,86,91,32,88,91,90,90,92,88,93,86,94,82,94,79,93,75,92,73,90,71,88,70,32,73,80,79,80,0,71,93,87,70,87,91,32,88,70,88,91,32,91,70,79,70,76,71,75,72,74,74,74,76,75,78,76,79,79,80,87,80,32,79,70,77,71,76,72,75,74,75,76,76,78,77,79,79,80,32,82,80,80,81,79,82,76,89,75,90,74,90,73,89,32,80,81,79,83,77,90,76,91,74,91,73,89,73,88,32,84,91,91,91,0,72,92,88,70,87,71,81,73,78,75,76,78,75,81,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,81,77,78,78,76,80,75,83,32,88,70,87,72,85,73,81,74,78,76,76,78,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,83,91,85,90,87,88,88,85,88,83,87,80,85,78,83,77,0,72,92,77,77,77,91,32,78,77,78,91,32,74,77,85,77,88,78,89,80,89,81,88,83,85,84,32,85,77,87,78,88,80,88,81,87,83,85,84,32,78,84,85,84,88,85,89,87,89,88,88,90,85,91,74,91,32,85,84,87,85,88,87,88,88,87,90,85,91,0,72,90,77,77,77,91,32,78,77,78,91,32,74,77,88,77,88,82,87,77,32,74,91,81,91,0,70,93,78,77,78,81,77,87,76,90,75,91,32,87,77,87,91,32,88,77,88,91,32,75,77,91,77,32,73,91,72,96,72,91,91,91,91,96,90,91,0,69,96,82,77,82,91,32,83,77,83,91,32,79,77,86,77,32,74,78,73,79,72,78,73,77,74,77,75,78,77,82,78,83,80,84,85,84,87,83,88,82,90,78,91,77,92,77,93,78,92,79,91,78,32,80,84,78,85,77,86,75,90,74,91,32,80,84,78,86,76,90,75,91,73,91,72,90,71,88,32,85,84,87,85,88,86,90,90,91,91,32,85,84,87,86,89,90,90,91,92,91,93,90,94,88,32,79,91,86,91,0,73,91,77,79,76,77,76,81,77,79,78,78,80,77,84,77,87,78,88,80,88,81,87,83,84,84,32,84,77,86,78,87,80,87,81,86,83,84,84,32,81,84,84,84,87,85,88,87,88,88,87,90,84,91,80,91,77,90,76,88,76,87,77,86,78,87,77,88,32,84,84,86,85,87,87,87,88,86,90,84,91,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,73,91,80,91,32,84,91,91,91,32,87,78,77,90,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,73,91,80,91,32,84,91,91,91,32,87,78,77,90,32,79,71,79,70,78,70,78,71,79,73,81,74,83,74,85,73,86,71,0,72,92,77,77,77,91,32,78,77,78,91,32,74,77,81,77,32,78,84,80,84,83,83,84,82,86,78,87,77,88,77,89,78,88,79,87,78,32,80,84,83,85,84,86,86,90,87,91,32,80,84,82,85,83,86,85,90,86,91,88,91,89,90,90,88,32,74,91,81,91,0,71,93,78,77,78,81,77,87,76,90,75,91,74,91,73,90,74,89,75,90,32,87,77,87,91,32,88,77,88,91,32,75,77,91,77,32,84,91,91,91,0,71,94,76,77,76,91,32,76,77,82,91,32,77,77,82,89,32,88,77,82,91,32,88,77,88,91,32,89,77,89,91,32,73,77,77,77,32,88,77,92,77,32,73,91,79,91,32,85,91,92,91,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,77,84,87,84,32,73,91,80,91,32,84,91,91,91,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,91,77,32,73,91,80,91,32,84,91,91,91,0,73,92,82,77,82,91,32,83,77,83,91,32,77,77,76,82,76,77,89,77,89,82,88,77,32,79,91,86,91,0,73,91,76,77,82,91,32,77,77,82,89,32,88,77,82,91,80,95,78,97,76,98,75,98,74,97,75,96,76,97,32,74,77,80,77,32,84,77,90,77,0,72,93,82,70,82,98,32,83,70,83,98,32,79,70,83,70,32,82,80,81,78,80,77,78,77,76,78,75,81,75,87,76,90,78,91,80,91,81,90,82,88,32,78,77,77,78,76,81,76,87,77,90,78,91,32,87,77,88,78,89,81,89,87,88,90,87,91,32,83,80,84,78,85,77,87,77,89,78,90,81,90,87,89,90,87,91,85,91,84,90,83,88,32,79,98,86,98,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,73,91,91,91,91,96,90,91,0,71,93,76,77,76,84,77,86,80,87,82,87,85,86,87,84,32,77,77,77,84,78,86,80,87,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,84,91,91,91,0,67,98,72,77,72,91,32,73,77,73,91,32,82,77,82,91,32,83,77,83,91,32,92,77,92,91,32,93,77,93,91,32,69,77,76,77,32,79,77,86,77,32,89,77,96,77,32,69,91,96,91,0,67,98,72,77,72,91,32,73,77,73,91,32,82,77,82,91,32,83,77,83,91,32,92,77,92,91,32,93,77,93,91,32,69,77,76,77,32,79,77,86,77,32,89,77,96,77,32,69,91,96,91,96,96,95,91,0,72,93,81,77,81,91,32,82,77,82,91,32,76,77,75,82,75,77,85,77,32,82,84,86,84,89,85,90,87,90,88,89,90,86,91,78,91,32,86,84,88,85,89,87,89,88,88,90,86,91,0,69,95,74,77,74,91,32,75,77,75,91,32,71,77,78,77,32,75,84,79,84,82,85,83,87,83,88,82,90,79,91,71,91,32,79,84,81,85,82,87,82,88,81,90,79,91,32,89,77,89,91,32,90,77,90,91,32,86,77,93,77,32,86,91,93,91,0,74,91,79,77,79,91,32,80,77,80,91,32,76,77,83,77,32,80,84,84,84,87,85,88,87,88,88,87,90,84,91,76,91,32,84,84,86,85,87,87,87,88,86,90,84,91,0,73,92,77,79,76,77,76,81,77,79,78,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,78,90,76,88,76,87,77,86,78,87,77,88,32,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,32,82,84,88,84,0,68,97,73,77,73,91,32,74,77,74,91,32,70,77,77,77,32,70,91,77,91,32,86,77,83,78,81,80,80,83,80,85,81,88,83,90,86,91,88,91,91,90,93,88,94,85,94,83,93,80,91,78,88,77,86,77,32,86,77,84,78,82,80,81,83,81,85,82,88,84,90,86,91,32,88,91,90,90,92,88,93,85,93,83,92,80,90,78,88,77,32,74,84,80,84,0,71,92,86,77,86,91,32,87,77,87,91,32,90,77,79,77,76,78,75,80,75,81,76,83,79,84,86,84,32,79,77,77,78,76,80,76,81,77,83,79,84,32,84,84,81,85,80,86,78,90,77,91,32,84,84,82,85,81,86,79,90,78,91,76,91,75,90,74,88,32,83,91,90,91,0,72,92,82,70,75,90,32,81,73,87,91,32,82,73,88,91,32,82,70,89,91,32,77,85,86,85,32,73,91,79,91,32,84,91,91,91,32,75,90,74,91,32,75,90,77,91,32,87,90,85,91,32,87,89,86,91,32,88,89,90,91,0,71,93,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,85,70,88,71,89,72,90,74,90,76,89,78,88,79,85,80,32,88,72,89,74,89,76,88,78,32,85,70,87,71,88,73,88,77,87,79,85,80,32,78,80,85,80,88,81,89,82,90,84,90,87,89,89,88,90,85,91,73,91,32,88,82,89,84,89,87,88,89,32,85,80,87,81,88,83,88,88,87,90,85,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,71,92,88,73,89,70,89,76,88,73,86,71,84,70,81,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,81,91,84,91,86,90,88,88,89,86,32,77,73,76,75,75,78,75,83,76,86,77,88,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,0,71,93,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,83,70,86,71,88,73,89,75,90,78,90,83,89,86,88,88,86,90,83,91,73,91,32,87,73,88,75,89,78,89,83,88,86,87,88,32,83,70,85,71,87,74,88,78,88,83,87,87,85,90,83,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,71,92,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,89,70,89,76,32,78,80,84,80,32,84,76,84,84,32,73,91,89,91,89,85,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,84,70,89,71,32,86,70,89,72,32,87,70,89,73,32,88,70,89,76,32,84,76,83,80,84,84,32,84,78,82,80,84,82,32,84,79,80,80,84,81,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,32,84,91,89,90,32,86,91,89,89,32,87,91,89,88,32,88,91,89,85,0,71,91,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,89,70,89,76,32,78,80,84,80,32,84,76,84,84,32,73,91,81,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,84,70,89,71,32,86,70,89,72,32,87,70,89,73,32,88,70,89,76,32,84,76,83,80,84,84,32,84,78,82,80,84,82,32,84,79,80,80,84,81,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,71,94,88,73,89,70,89,76,88,73,86,71,84,70,81,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,81,91,84,91,86,90,88,90,89,91,89,83,32,77,73,76,75,75,78,75,83,76,86,77,88,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,32,88,84,88,89,32,87,83,87,89,86,90,32,84,83,92,83,32,85,83,87,84,32,86,83,87,85,32,90,83,89,85,32,91,83,89,84,0,70,94,75,70,75,91,32,76,71,76,90,32,77,70,77,91,32,87,70,87,91,32,88,71,88,90,32,89,70,89,91,32,72,70,80,70,32,84,70,92,70,32,77,80,87,80,32,72,91,80,91,32,84,91,92,91,32,73,70,75,71,32,74,70,75,72,32,78,70,77,72,32,79,70,77,71,32,85,70,87,71,32,86,70,87,72,32,90,70,89,72,32,91,70,89,71,32,75,90,73,91,32,75,89,74,91,32,77,89,78,91,32,77,90,79,91,32,87,90,85,91,32,87,89,86,91,32,89,89,90,91,32,89,90,91,91,0,76,88,81,70,81,91,32,82,71,82,90,32,83,70,83,91,32,78,70,86,70,32,78,91,86,91,32,79,70,81,71,32,80,70,81,72,32,84,70,83,72,32,85,70,83,71,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,74,90,83,70,83,87,82,90,81,91,32,84,71,84,87,83,90,32,85,70,85,87,84,90,81,91,79,91,77,90,76,88,76,86,77,85,78,85,79,86,79,87,78,88,77,88,32,77,86,77,87,78,87,78,86,77,86,32,80,70,88,70,32,81,70,83,71,32,82,70,83,72,32,86,70,85,72,32,87,70,85,71,0,70,92,75,70,75,91,32,76,71,76,90,32,77,70,77,91,32,88,71,77,82,32,80,80,87,91,32,81,80,88,91,32,81,78,89,91,32,72,70,80,70,32,85,70,91,70,32,72,91,80,91,32,84,91,91,91,32,73,70,75,71,32,74,70,75,72,32,78,70,77,72,32,79,70,77,71,32,87,70,88,71,32,90,70,88,71,32,75,90,73,91,32,75,89,74,91,32,77,89,78,91,32,77,90,79,91,32,87,89,85,91,32,87,89,90,91,0,73,91,78,70,78,91,32,79,71,79,90,32,80,70,80,91,32,75,70,83,70,32,75,91,90,91,90,85,32,76,70,78,71,32,77,70,78,72,32,81,70,80,72,32,82,70,80,71,32,78,90,76,91,32,78,89,77,91,32,80,89,81,91,32,80,90,82,91,32,85,91,90,90,32,87,91,90,89,32,88,91,90,88,32,89,91,90,85,0,69,95,74,70,74,90,32,74,70,81,91,32,75,70,81,88,32,76,70,82,88,32,88,70,81,91,32,88,70,88,91,32,89,71,89,90,32,90,70,90,91,32,71,70,76,70,32,88,70,93,70,32,71,91,77,91,32,85,91,93,91,32,72,70,74,71,32,91,70,90,72,32,92,70,90,71,32,74,90,72,91,32,74,90,76,91,32,88,90,86,91,32,88,89,87,91,32,90,89,91,91,32,90,90,92,91,0,70,94,75,70,75,90,32,75,70,89,91,32,76,70,88,88,32,77,70,89,88,32,89,71,89,91,32,72,70,77,70,32,86,70,92,70,32,72,91,78,91,32,73,70,75,71,32,87,70,89,71,32,91,70,89,71,32,75,90,73,91,32,75,90,77,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,77,73,76,75,75,78,75,83,76,86,77,88,32,87,88,88,86,89,83,89,78,88,75,87,73,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,32,83,91,85,90,87,87,88,83,88,78,87,74,85,71,83,70,0,71,93,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,85,70,88,71,89,72,90,74,90,77,89,79,88,80,85,81,78,81,32,88,72,89,74,89,77,88,79,32,85,70,87,71,88,73,88,78,87,80,85,81,32,73,91,81,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,77,73,76,75,75,78,75,83,76,86,77,88,32,87,88,88,86,89,83,89,78,88,75,87,73,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,32,83,91,85,90,87,87,88,83,88,78,87,74,85,71,83,70,32,78,88,79,86,81,85,82,85,84,86,85,88,86,94,87,96,89,96,90,94,90,92,32,86,92,87,94,88,95,89,95,32,85,88,87,93,88,94,89,94,90,93,0,71,93,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,85,70,88,71,89,72,90,74,90,76,89,78,88,79,85,80,78,80,32,88,72,89,74,89,76,88,78,32,85,70,87,71,88,73,88,77,87,79,85,80,32,82,80,84,81,85,83,87,89,88,91,90,91,91,89,91,87,32,87,87,88,89,89,90,90,90,32,84,81,85,82,88,88,89,89,90,89,91,88,32,73,91,81,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,72,92,88,73,89,70,89,76,88,73,86,71,83,70,80,70,77,71,75,73,75,76,76,78,79,80,85,82,87,83,88,85,88,88,87,90,32,76,76,77,78,79,79,85,81,87,82,88,84,32,77,71,76,73,76,75,77,77,79,78,85,80,88,82,89,84,89,87,88,89,87,90,84,91,81,91,78,90,76,88,75,85,75,91,76,88,0,72,92,74,70,74,76,32,81,70,81,91,32,82,71,82,90,32,83,70,83,91,32,90,70,90,76,32,74,70,90,70,32,78,91,86,91,32,75,70,74,76,32,76,70,74,73,32,77,70,74,72,32,79,70,74,71,32,85,70,90,71,32,87,70,90,72,32,88,70,90,73,32,89,70,90,76,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,70,94,75,70,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,71,32,76,71,76,86,77,88,32,77,70,77,86,78,89,79,90,81,91,32,72,70,80,70,32,86,70,92,70,32,73,70,75,71,32,74,70,75,72,32,78,70,77,72,32,79,70,77,71,32,87,70,89,71,32,91,70,89,71,0,72,92,75,70,82,91,32,76,70,82,88,82,91,32,77,70,83,88,32,89,71,82,91,32,73,70,80,70,32,85,70,91,70,32,74,70,76,72,32,78,70,77,72,32,79,70,77,71,32,87,70,89,71,32,90,70,89,71,0,70,94,74,70,78,91,32,75,70,78,86,78,91,32,76,70,79,86,32,82,70,79,86,78,91,32,82,70,86,91,32,83,70,86,86,86,91,32,84,70,87,86,32,90,71,87,86,86,91,32,71,70,79,70,32,82,70,84,70,32,87,70,93,70,32,72,70,75,71,32,73,70,75,72,32,77,70,76,72,32,78,70,76,71,32,88,70,90,71,32,92,70,90,71,0,72,92,75,70,87,91,32,76,70,88,91,32,77,70,89,91,32,88,71,76,90,32,73,70,80,70,32,85,70,91,70,32,73,91,79,91,32,84,91,91,91,32,74,70,77,72,32,78,70,77,72,32,79,70,77,71,32,86,70,88,71,32,90,70,88,71,32,76,90,74,91,32,76,90,78,91,32,87,90,85,91,32,87,89,86,91,32,87,89,90,91,0,71,93,74,70,81,81,81,91,32,75,70,82,81,82,90,32,76,70,83,81,83,91,32,89,71,83,81,32,72,70,79,70,32,86,70,92,70,32,78,91,86,91,32,73,70,75,71,32,78,70,76,71,32,87,70,89,71,32,91,70,89,71,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,72,92,89,70,75,70,75,76,32,87,70,75,91,32,88,70,76,91,32,89,70,77,91,32,75,91,89,91,89,85,32,76,70,75,76,32,77,70,75,73,32,78,70,75,72,32,80,70,75,71,32,84,91,89,90,32,86,91,89,89,32,87,91,89,88,32,88,91,89,85,0,73,91,78,70,78,91,32,79,71,79,90,32,80,70,80,91,32,75,70,90,70,90,76,32,75,91,83,91,32,76,70,78,71,32,77,70,78,72,32,81,70,80,72,32,82,70,80,71,32,85,70,90,71,32,87,70,90,72,32,88,70,90,73,32,89,70,90,76,32,78,89,77,91,32,78,90,76,91,32,80,89,81,91,32,80,90,82,91,0,72,92,82,70,74,91,32,81,73,88,91,32,82,73,89,91,32,82,70,90,91,32,75,89,88,89,32,75,90,88,90,32,74,91,90,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,77,73,76,75,75,78,75,83,76,86,77,88,32,87,88,88,86,89,83,89,78,88,75,87,73,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,32,83,91,85,90,87,87,88,83,88,78,87,74,85,71,83,70,32,79,77,79,84,32,85,77,85,84,32,79,80,85,80,32,79,81,85,81,32,79,78,80,80,32,79,79,81,80,32,85,78,84,80,32,85,79,83,80,32,80,81,79,83,32,81,81,79,82,32,83,81,85,82,32,84,81,85,83,0,72,92,82,70,75,90,32,81,73,87,91,32,82,73,88,91,32,82,70,89,91,32,73,91,79,91,32,84,91,91,91,32,75,90,74,91,32,75,90,77,91,32,87,90,85,91,32,87,89,86,91,32,88,89,90,91,0,71,93,74,69,74,76,32,90,69,90,76,32,79,77,79,84,32,85,77,85,84,32,74,85,74,92,32,90,85,90,92,32,74,71,90,71,32,74,72,90,72,32,74,73,90,73,32,79,80,85,80,32,79,81,85,81,32,74,88,90,88,32,74,89,90,89,32,74,90,90,90,32,74,70,77,72,32,90,70,87,72,32,75,73,74,75,32,76,73,74,74,32,88,73,90,74,32,89,73,90,75,32,79,78,80,80,32,79,79,81,80,32,85,78,84,80,32,85,79,83,80,32,80,81,79,83,32,81,81,79,82,32,83,81,85,82,32,84,81,85,83,32,74,86,75,88,32,74,87,76,88,32,90,87,88,88,32,90,86,89,88,32,77,89,74,91,32,87,89,90,91,0,70,94,75,70,75,91,32,76,71,76,90,32,77,70,77,91,32,87,70,87,91,32,88,71,88,90,32,89,70,89,91],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+286732);allocate([32,72,70,92,70,32,72,91,80,91,32,84,91,92,91,32,73,70,75,71,32,74,70,75,72,32,78,70,77,72,32,79,70,77,71,32,85,70,87,71,32,86,70,87,72,32,90,70,89,72,32,91,70,89,71,32,75,90,73,91,32,75,89,74,91,32,77,89,78,91,32,77,90,79,91,32,87,90,85,91,32,87,89,86,91,32,89,89,90,91,32,89,90,91,91,0,71,93,73,70,80,80,81,81,32,74,70,81,80,32,75,70,82,80,73,91,32,73,70,89,70,90,76,89,73,87,70,32,86,70,89,72,32,84,70,89,71,32,75,89,89,89,32,74,90,89,90,32,73,91,89,91,90,85,89,88,87,89,0,72,92,74,77,75,73,76,71,77,70,79,70,80,71,81,73,82,77,32,76,72,77,71,79,71,80,72,32,74,77,75,74,77,72,79,72,80,73,81,77,81,91,32,82,77,82,91,32,90,77,89,74,87,72,85,72,84,73,83,77,83,91,32,88,72,87,71,85,71,84,72,32,90,77,89,73,88,71,87,70,85,70,84,71,83,73,82,77,32,78,91,86,91,32,81,89,80,91,32,81,90,79,91,32,83,90,85,91,32,83,89,84,91,0,71,93,81,70,81,91,32,82,71,82,90,32,83,70,83,91,32,78,70,86,70,32,78,91,86,91,32,79,70,81,71,32,80,70,81,72,32,84,70,83,72,32,85,70,83,71,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,32,79,75,76,76,75,77,74,79,74,82,75,84,76,85,79,86,85,86,88,85,89,84,90,82,90,79,89,77,88,76,85,75,79,75,32,76,77,75,79,75,82,76,84,32,88,84,89,82,89,79,88,77,32,79,75,77,76,76,79,76,82,77,85,79,86,32,85,86,87,85,88,82,88,79,87,76,85,75,0,70,94,81,70,81,91,32,82,71,82,90,32,83,70,83,91,32,78,70,86,70,32,78,91,86,91,32,79,70,81,71,32,80,70,81,72,32,84,70,83,72,32,85,70,83,71,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,32,72,77,73,77,74,78,75,81,76,83,77,84,80,85,84,85,87,84,88,83,89,81,90,78,91,77,92,77,32,76,82,75,78,74,76,73,76,75,78,32,72,77,73,75,74,75,75,76,76,80,77,83,78,84,80,85,32,89,78,91,76,90,76,89,78,88,82,32,84,85,86,84,87,83,88,80,89,76,90,75,91,75,92,77,0,71,93,78,89,75,89,74,87,75,91,79,91,77,86,75,82,74,79,74,76,75,73,77,71,80,70,84,70,87,71,89,73,90,76,90,79,89,82,87,86,85,91,89,91,90,87,89,89,86,89,32,76,83,75,79,75,76,76,73,32,88,73,89,76,89,79,88,83,32,79,91,77,85,76,80,76,75,77,72,78,71,80,70,32,84,70,86,71,87,72,88,75,88,80,87,85,85,91,32,75,90,78,90,32,86,90,89,90,0,72,92,85,70,73,90,32,83,74,84,91,32,84,72,85,90,32,85,70,85,72,86,89,86,91,32,76,85,84,85,32,70,91,76,91,32,81,91,88,91,32,73,90,71,91,32,73,90,75,91,32,84,90,82,91,32,84,89,83,91,32,86,89,87,91,0,70,94,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,76,70,87,70,90,71,91,73,91,75,90,78,89,79,86,80,32,89,71,90,73,90,75,89,78,88,79,32,87,70,88,71,89,73,89,75,88,78,86,80,32,78,80,86,80,88,81,89,83,89,85,88,88,86,90,82,91,70,91,32,87,81,88,83,88,85,87,88,85,90,32,86,80,87,82,87,85,86,88,84,90,82,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,72,93,90,72,91,72,92,70,91,76,91,74,90,72,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,80,91,83,91,85,90,87,88,88,86,32,81,72,79,74,78,76,77,79,76,83,76,87,77,89,32,84,70,82,71,80,74,79,76,78,79,77,83,77,88,78,90,80,91,0,70,93,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,76,70,85,70,88,71,89,72,90,75,90,79,89,83,87,87,85,89,83,90,79,91,70,91,32,87,71,88,72,89,75,89,79,88,83,86,87,84,89,32,85,70,87,72,88,75,88,79,87,83,85,87,82,90,79,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,70,93,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,85,76,83,84,32,76,70,91,70,90,76,32,78,80,84,80,32,70,91,85,91,87,86,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,87,70,90,71,32,88,70,90,72,32,89,70,90,73,32,90,70,90,76,32,85,76,83,80,83,84,32,84,78,82,80,83,82,32,84,79,81,80,83,81,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,32,80,91,85,90,32,82,91,85,89,32,85,89,87,86,0,70,92,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,85,76,83,84,32,76,70,91,70,90,76,32,78,80,84,80,32,70,91,78,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,87,70,90,71,32,88,70,90,72,32,89,70,90,73,32,90,70,90,76,32,85,76,83,80,83,84,32,84,78,82,80,83,82,32,84,79,81,80,83,81,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,72,94,90,72,91,72,92,70,91,76,91,74,90,72,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,80,91,82,91,85,90,87,88,89,84,32,81,72,79,74,78,76,77,79,76,83,76,87,77,89,32,86,88,87,87,88,84,32,84,70,82,71,80,74,79,76,78,79,77,83,77,88,78,90,80,91,32,82,91,84,90,86,87,87,84,32,84,84,92,84,32,85,84,87,85,32,86,84,87,87,32,90,84,88,86,32,91,84,88,85,0,69,95,78,70,72,91,32,79,70,73,91,32,80,70,74,91,32,90,70,84,91,32,91,70,85,91,32,92,70,86,91,32,75,70,83,70,32,87,70,95,70,32,76,80,88,80,32,69,91,77,91,32,81,91,89,91,32,76,70,79,71,32,77,70,78,72,32,81,70,79,72,32,82,70,79,71,32,88,70,91,71,32,89,70,90,72,32,93,70,91,72,32,94,70,91,71,32,73,90,70,91,32,73,89,71,91,32,74,89,75,91,32,73,90,76,91,32,85,90,82,91,32,85,89,83,91,32,86,89,87,91,32,85,90,88,91,0,75,89,84,70,78,91,32,85,70,79,91,32,86,70,80,91,32,81,70,89,70,32,75,91,83,91,32,82,70,85,71,32,83,70,84,72,32,87,70,85,72,32,88,70,85,71,32,79,90,76,91,32,79,89,77,91,32,80,89,81,91,32,79,90,82,91,0,73,92,87,70,82,87,81,89,79,91,32,88,70,84,83,83,86,82,88,32,89,70,85,83,83,88,81,90,79,91,77,91,75,90,74,88,74,86,75,85,76,85,77,86,77,87,76,88,75,88,32,75,86,75,87,76,87,76,86,75,86,32,84,70,92,70,32,85,70,88,71,32,86,70,87,72,32,90,70,88,72,32,91,70,88,71,0,70,93,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,92,71,77,82,32,81,79,85,91,32,82,79,86,91,32,83,78,87,90,32,76,70,84,70,32,89,70,95,70,32,70,91,78,91,32,82,91,89,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,90,70,92,71,32,94,70,92,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,32,85,90,83,91,32,85,89,84,91,32,86,89,88,91,0,72,92,81,70,75,91,32,82,70,76,91,32,83,70,77,91,32,78,70,86,70,32,72,91,87,91,89,85,32,79,70,82,71,32,80,70,81,72,32,84,70,82,72,32,85,70,82,71,32,76,90,73,91,32,76,89,74,91,32,77,89,78,91,32,76,90,79,91,32,82,91,87,90,32,84,91,88,88,32,86,91,89,85,0,68,96,77,70,71,90,32,77,71,78,89,78,91,32,78,70,79,89,32,79,70,80,88,32,91,70,80,88,78,91,32,91,70,85,91,32,92,70,86,91,32,93,70,87,91,32,74,70,79,70,32,91,70,96,70,32,68,91,74,91,32,82,91,90,91,32,75,70,77,71,32,76,70,77,72,32,94,70,92,72,32,95,70,92,71,32,71,90,69,91,32,71,90,73,91,32,86,90,83,91,32,86,89,84,91,32,87,89,88,91,32,86,90,89,91,0,70,95,79,70,73,90,32,79,70,86,91,32,80,70,86,88,32,81,70,87,88,32,92,71,87,88,86,91,32,76,70,81,70,32,89,70,95,70,32,70,91,76,91,32,77,70,80,71,32,78,70,80,72,32,90,70,92,71,32,94,70,92,71,32,73,90,71,91,32,73,90,75,91,0,71,93,83,70,80,71,78,73,76,76,75,79,74,83,74,86,75,89,76,90,78,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,83,70,32,79,73,77,76,76,79,75,83,75,87,76,89,32,85,88,87,85,88,82,89,78,89,74,88,72,32,83,70,81,71,79,74,78,76,77,79,76,83,76,88,77,90,78,91,32,81,91,83,90,85,87,86,85,87,82,88,78,88,73,87,71,86,70,0,70,93,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,76,70,88,70,91,71,92,73,92,75,91,78,89,80,85,81,77,81,32,90,71,91,73,91,75,90,78,88,80,32,88,70,89,71,90,73,90,75,89,78,87,80,85,81,32,70,91,78,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,71,93,83,70,80,71,78,73,76,76,75,79,74,83,74,86,75,89,76,90,78,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,83,70,32,79,73,77,76,76,79,75,83,75,87,76,89,32,85,88,87,85,88,82,89,78,89,74,88,72,32,83,70,81,71,79,74,78,76,77,79,76,83,76,88,77,90,78,91,32,81,91,83,90,85,87,86,85,87,82,88,78,88,73,87,71,86,70,32,76,88,77,86,79,85,80,85,82,86,83,88,84,93,85,94,86,94,87,93,32,84,94,85,95,86,95,32,83,88,83,95,84,96,86,96,87,93,87,92,0,70,94,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,76,70,87,70,90,71,91,73,91,75,90,78,89,79,86,80,78,80,32,89,71,90,73,90,75,89,78,88,79,32,87,70,88,71,89,73,89,75,88,78,86,80,32,82,80,84,81,85,82,87,88,88,89,89,89,90,88,32,87,89,88,90,89,90,32,85,82,86,90,87,91,89,91,90,88,90,87,32,70,91,78,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,71,94,90,72,91,72,92,70,91,76,91,74,90,72,89,71,86,70,82,70,79,71,77,73,77,76,78,78,80,80,86,83,87,85,87,88,86,90,32,78,76,79,78,86,82,87,84,32,79,71,78,73,78,75,79,77,85,80,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,85,73,91,74,89,75,89,0,71,93,84,70,78,91,32,85,70,79,91,32,86,70,80,91,32,77,70,75,76,32,93,70,92,76,32,77,70,93,70,32,75,91,83,91,32,78,70,75,76,32,80,70,76,73,32,82,70,77,71,32,89,70,92,71,32,90,70,92,72,32,91,70,92,73,32,92,70,92,76,32,79,90,76,91,32,79,89,77,91,32,80,89,81,91,32,79,90,82,91,0,70,95,78,70,75,81,74,85,74,88,75,90,78,91,82,91,85,90,87,88,88,85,92,71,32,79,70,76,81,75,85,75,89,76,90,32,80,70,77,81,76,85,76,89,78,91,32,75,70,83,70,32,89,70,95,70,32,76,70,79,71,32,77,70,78,72,32,81,70,79,72,32,82,70,79,71,32,90,70,92,71,32,94,70,92,71,0,72,92,78,70,78,72,79,89,79,91,32,79,71,80,88,32,80,70,81,87,32,91,71,79,91,32,76,70,83,70,32,88,70,94,70,32,77,70,78,72,32,81,70,80,72,32,82,70,79,71,32,89,70,91,71,32,93,70,91,71,0,69,95,77,70,77,72,75,89,75,91,32,78,71,76,88,32,79,70,77,87,32,85,70,77,87,75,91,32,85,70,85,72,83,89,83,91,32,86,71,84,88,32,87,70,85,87,32,93,71,85,87,83,91,32,74,70,82,70,32,85,70,87,70,32,90,70,96,70,32,75,70,78,71,32,76,70,77,72,32,80,70,78,73,32,81,70,78,71,32,91,70,93,71,32,95,70,93,71,0,71,93,78,70,84,91,32,79,70,85,91,32,80,70,86,91,32,91,71,73,90,32,76,70,83,70,32,88,70,94,70,32,70,91,76,91,32,81,91,88,91,32,77,70,79,72,32,81,70,80,72,32,82,70,80,71,32,89,70,91,71,32,93,70,91,71,32,73,90,71,91,32,73,90,75,91,32,84,90,82,91,32,84,89,83,91,32,85,89,87,91,0,71,93,77,70,81,80,78,91,32,78,70,82,80,79,91,32,79,70,83,80,80,91,32,92,71,83,80,32,75,70,82,70,32,89,70,95,70,32,75,91,83,91,32,76,70,78,71,32,80,70,79,72,32,81,70,78,71,32,90,70,92,71,32,94,70,92,71,32,79,90,76,91,32,79,89,77,91,32,80,89,81,91,32,79,90,82,91,0,71,93,90,70,72,91,32,91,70,73,91,32,92,70,74,91,32,92,70,78,70,76,76,32,72,91,86,91,88,85,32,79,70,76,76,32,80,70,77,73,32,82,70,78,71,32,82,91,86,90,32,84,91,87,88,32,85,91,88,85,0,72,92,74,70,82,91,32,75,70,82,88,32,76,70,83,88,32,74,70,90,70,82,91,32,76,71,89,71,32,76,72,89,72,0,73,93,78,80,78,79,79,79,79,81,77,81,77,79,78,78,80,77,84,77,86,78,87,79,88,81,88,88,89,90,90,91,32,86,79,87,81,87,88,88,90,32,84,77,85,78,86,80,86,88,87,90,90,91,91,91,32,86,82,85,83,80,84,77,85,76,87,76,88,77,90,80,91,83,91,85,90,86,88,32,78,85,77,87,77,88,78,90,32,85,83,81,84,79,85,78,87,78,88,79,90,80,91,0,71,92,76,70,76,91,77,90,79,90,32,77,71,77,89,32,73,70,78,70,78,90,32,78,80,79,78,81,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,81,91,79,90,78,88,32,87,80,88,82,88,86,87,88,32,83,77,85,78,86,79,87,82,87,86,86,89,85,90,83,91,32,74,70,76,71,32,75,70,76,72,0,72,91,87,81,87,80,86,80,86,82,88,82,88,80,86,78,84,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,77,80,76,82,76,86,77,88,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,0,72,93,86,70,86,91,91,91,32,87,71,87,90,32,83,70,88,70,88,91,32,86,80,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,85,90,86,88,32,77,80,76,82,76,86,77,88,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,84,70,86,71,32,85,70,86,72,32,88,89,89,91,32,88,90,90,91,0,72,91,77,83,88,83,88,81,87,79,86,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,87,82,87,81,86,79,32,77,80,76,82,76,86,77,88,32,86,83,86,80,85,78,83,77,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,0,75,89,87,72,87,71,86,71,86,73,88,73,88,71,87,70,84,70,82,71,81,72,80,75,80,91,32,82,72,81,75,81,90,32,84,70,83,71,82,73,82,91,32,77,77,86,77,32,77,91,85,91,32,80,90,78,91,32,80,89,79,91,32,82,89,83,91,32,82,90,84,91,0,73,92,88,78,89,79,90,78,89,77,88,77,86,78,85,79,32,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,81,86,79,85,78,83,77,81,77,32,79,79,78,81,78,83,79,85,32,85,85,86,83,86,81,85,79,32,81,77,80,78,79,80,79,84,80,86,81,87,32,83,87,84,86,85,84,85,80,84,78,83,77,32,78,85,77,86,76,88,76,89,77,91,78,92,81,93,85,93,88,94,89,95,32,78,91,81,92,85,92,88,93,32,76,89,77,90,80,91,85,91,88,92,89,94,89,95,88,97,85,98,79,98,76,97,75,95,75,94,76,92,79,91,32,79,98,77,97,76,95,76,94,77,92,79,91,0,71,94,76,70,76,91,32,77,71,77,90,32,73,70,78,70,78,91,32,78,81,79,79,80,78,82,77,85,77,87,78,88,79,89,82,89,91,32,87,79,88,82,88,90,32,85,77,86,78,87,81,87,91,32,73,91,81,91,32,84,91,92,91,32,74,70,76,71,32,75,70,76,72,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,32,87,90,85,91,32,87,89,86,91,32,89,89,90,91,32,89,90,91,91,0,76,88,81,70,81,72,83,72,83,70,81,70,32,82,70,82,72,32,81,71,83,71,32,81,77,81,91,32,82,78,82,90,32,78,77,83,77,83,91,32,78,91,86,91,32,79,77,81,78,32,80,77,81,79,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,75,88,82,70,82,72,84,72,84,70,82,70,32,83,70,83,72,32,82,71,84,71,32,82,77,82,94,81,97,80,98,32,83,78,83,93,82,96,32,79,77,84,77,84,93,83,96,82,97,80,98,77,98,76,97,76,95,78,95,78,97,77,97,77,96,32,80,77,82,78,32,81,77,82,79,0,71,93,76,70,76,91,32,77,71,77,90,32,73,70,78,70,78,91,32,87,78,78,87,32,82,83,89,91,32,82,84,88,91,32,81,84,87,91,32,84,77,91,77,32,73,91,81,91,32,84,91,91,91,32,74,70,76,71,32,75,70,76,72,32,85,77,87,78,32,90,77,87,78,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,32,87,89,85,91,32,86,89,90,91,0,76,88,81,70,81,91,32,82,71,82,90,32,78,70,83,70,83,91,32,78,91,86,91,32,79,70,81,71,32,80,70,81,72,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,65,99,70,77,70,91,32,71,78,71,90,32,67,77,72,77,72,91,32,72,81,73,79,74,78,76,77,79,77,81,78,82,79,83,82,83,91,32,81,79,82,82,82,90,32,79,77,80,78,81,81,81,91,32,83,81,84,79,85,78,87,77,90,77,92,78,93,79,94,82,94,91,32,92,79,93,82,93,90,32,90,77,91,78,92,81,92,91,32,67,91,75,91,32,78,91,86,91,32,89,91,97,91,32,68,77,70,78,32,69,77,70,79,32,70,90,68,91,32,70,89,69,91,32,72,89,73,91,32,72,90,74,91,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,32,92,90,90,91,32,92,89,91,91,32,94,89,95,91,32,94,90,96,91,0,71,94,76,77,76,91,32,77,78,77,90,32,73,77,78,77,78,91,32,78,81,79,79,80,78,82,77,85,77,87,78,88,79,89,82,89,91,32,87,79,88,82,88,90,32,85,77,86,78,87,81,87,91,32,73,91,81,91,32,84,91,92,91,32,74,77,76,78,32,75,77,76,79,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,32,87,90,85,91,32,87,89,86,91,32,89,89,90,91,32,89,90,91,91,0,72,92,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,81,77,32,77,80,76,82,76,86,77,88,32,87,88,88,86,88,82,87,80,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,83,91,85,90,86,89,87,86,87,82,86,79,85,78,83,77,0,71,92,76,77,76,98,32,77,78,77,97,32,73,77,78,77,78,98,32,78,80,79,78,81,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,81,91,79,90,78,88,32,87,80,88,82,88,86,87,88,32,83,77,85,78,86,79,87,82,87,86,86,89,85,90,83,91,32,73,98,81,98,32,74,77,76,78,32,75,77,76,79,32,76,97,74,98,32,76,96,75,98,32,78,96,79,98,32,78,97,80,98,0,72,92,86,78,86,98,32,87,79,87,97,32,85,78,87,78,88,77,88,98,32,86,80,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,85,90,86,88,32,77,80,76,82,76,86,77,88,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,83,98,91,98,32,86,97,84,98,32,86,96,85,98,32,88,96,89,98,32,88,97,90,98,0,73,90,78,77,78,91,32,79,78,79,90,32,75,77,80,77,80,91,32,87,79,87,78,86,78,86,80,88,80,88,78,87,77,85,77,83,78,81,80,80,83,32,75,91,83,91,32,76,77,78,78,32,77,77,78,79,32,78,90,76,91,32,78,89,77,91,32,80,89,81,91,32,80,90,82,91,0,74,91,87,79,88,77,88,81,87,79,86,78,84,77,80,77,78,78,77,79,77,81,78,83,80,84,85,85,87,86,88,89,32,78,78,77,81,32,78,82,80,83,85,84,87,85,32,88,86,87,90,32,77,79,78,81,80,82,85,83,87,84,88,86,88,89,87,90,85,91,81,91,79,90,78,89,77,87,77,91,78,89,0,75,90,80,72,80,86,81,89,82,90,84,91,86,91,88,90,89,88,32,81,72,81,87,82,89,32,80,72,82,70,82,87,83,90,84,91,32,77,77,86,77,0,71,94,76,77,76,86,77,89,78,90,80,91,83,91,85,90,86,89,87,87,32,77,78,77,87,78,89,32,73,77,78,77,78,87,79,90,80,91,32,87,77,87,91,92,91,32,88,78,88,90,32,84,77,89,77,89,91,32,74,77,76,78,32,75,77,76,79,32,89,89,90,91,32,89,90,91,91,0,73,91,76,77,82,91,32,77,77,82,89,32,78,77,83,89,32,88,78,83,89,82,91,32,74,77,81,77,32,84,77,90,77,32,75,77,78,79,32,80,77,78,78,32,86,77,88,78,32,89,77,88,78,0,70,94,74,77,78,91,32,75,77,78,88,32,76,77,79,88,32,82,77,79,88,78,91,32,82,77,86,91,32,83,77,86,88,32,82,77,84,77,87,88,32,90,78,87,88,86,91,32,71,77,79,77,32,87,77,93,77,32,72,77,75,78,32,78,77,76,78,32,88,77,90,78,32,92,77,90,78,0,72,92,76,77,86,91,32,77,77,87,91,32,78,77,88,91,32,87,78,77,90,32,74,77,81,77,32,84,77,90,77,32,74,91,80,91,32,83,91,90,91,32,75,77,77,78,32,80,77,78,78,32,85,77,87,78,32,89,77,87,78,32,77,90,75,91,32,77,90,79,91,32,86,90,84,91,32,87,90,89,91,0,72,91,76,77,82,91,32,77,77,82,89,32,78,77,83,89,32,88,78,83,89,80,95,78,97,76,98,74,98,73,97,73,95,75,95,75,97,74,97,74,96,32,74,77,81,77,32,84,77,90,77,32,75,77,78,79,32,80,77,78,78,32,86,77,88,78,32,89,77,88,78,0,73,91,86,77,76,91,32,87,77,77,91,32,88,77,78,91,32,88,77,76,77,76,81,32,76,91,88,91,88,87,32,77,77,76,81,32,78,77,76,80,32,79,77,76,79,32,81,77,76,78,32,83,91,88,90,32,85,91,88,89,32,86,91,88,88,32,87,91,88,87,0,71,94,91,77,90,81,89,84,87,88,85,90,82,91,80,91,77,90,75,88,74,85,74,83,75,80,77,78,80,77,82,77,85,78,86,79,87,81,89,88,90,90,91,91,92,91,32,90,77,89,81,88,84,87,86,85,89,84,90,82,91,32,76,88,75,86,75,82,76,80,32,80,91,78,90,77,89,76,86,76,82,77,79,78,78,80,77,32,82,77,84,78,85,79,86,81,88,88,89,90,91,91,0,71,92,81,70,78,71,77,72,76,74,75,78,75,98,32,78,72,77,74,76,78,76,97,32,81,70,79,71,78,73,77,78,77,98,32,81,70,83,70,86,71,87,72,88,74,88,76,87,78,86,79,83,80,32,80,80,84,80,87,81,88,82,89,84,89,87,88,89,87,90,84,91,81,91,79,90,78,89,77,87,32,86,72,87,74,87,76,86,78,32,87,82,88,84,88,87,87,89,32,83,70,85,71,86,73,86,77,85,79,83,80,32,84,80,86,81,87,83,87,88,86,90,84,91,32,75,98,77,98,0,70,92,72,82,73,78,75,77,77,77,79,78,80,79,81,82,82,89,83,98,32,73,79,75,78,77,78,79,79,80,80,32,72,82,73,80,75,79,77,79,79,80,80,81,81,84,82,89,82,97,32,88,77,87,80,86,82,84,85,83,87,82,91,81,98,32,89,77,87,81,32,90,77,89,79,87,82,84,86,83,88,82,91,32,88,77,90,77,32,81,98,83,98,0,72,92,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,80,76,78,75,77,74,77,72,78,71,80,70,83,70,87,72,32,77,80,76,83,76,85,77,88,32,87,88,88,85,88,83,87,80,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,83,91,85,90,86,89,87,86,87,82,86,79,85,78,79,75,78,74,78,73,79,72,81,71,84,71,87,72,0,73,91,83,77,85,78,86,79,87,79,86,78,83,77,81,77,77,78,76,79,76,81,77,82,81,83,32,83,83,81,83,77,84,75,86,75,88,77,90,80,91,83,91,86,90,88,88,87,88,86,90,32,78,78,77,79,77,81,78,82,32,77,85,76,86,76,88,77,89,32,81,77,79,78,78,79,78,81,79,82,81,83,32,81,83,78,84,77,86,77,88,78,90,80,91,0,73,91,81,72,82,71,82,70,81,70,80,71,80,73,81,74,84,75,88,75,89,75,89,74,88,74,85,75,83,76,80,78,78,80,77,82,76,85,76,87,77,89,78,90,80,91,83,92,85,93,86,95,86,97,85,98,83,98,82,97,82,96,83,96,83,97,32,80,79,79,80,78,82,77,85,77,87,78,89,79,90,32,85,75,82,77,81,78,79,81,78,84,78,87,79,89,81,91,83,92,0,71,93,74,77,75,78,76,80,76,91,32,75,77,76,78,77,80,77,90,32,72,80,73,78,74,77,76,77,77,78,78,80,78,91,32,85,77,86,78,87,81,87,98,32,87,79,88,82,88,97,32,78,81,79,79,80,78,82,77,85,77,87,78,88,79,89,82,89,98,32,76,91,78,91,32,87,98,89,98,0,70,93,73,77,74,78,75,80,75,84,76,87,77,89,78,90,81,91,83,91,86,90,87,89,88,87,89,82,89,79,88,74,86,71,84,70,82,70,80,71,79,73,79,75,80,77,83,79,86,80,91,81,32,74,77,75,78,76,80,76,84,77,87,78,89,32,86,89,87,87,88,82,88,79,87,74,86,72,84,71,32,71,80,72,78,73,77,75,77,76,78,77,80,77,84,78,88,79,90,81,91,32,83,91,85,90,86,88,87,83,87,78,86,74,85,72,83,71,81,71,79,73,0,75,90,78,77,79,78,80,80,80,88,81,90,83,91,85,91,87,90,88,88,32,79,77,80,78,81,80,81,88,82,90,32,76,80,77,78,78,77,80,77,81,78,82,80,82,88,83,90,84,91,0,71,93,74,77,75,78,76,80,76,91,32,75,77,76,78,77,80,77,90,32,72,80,73,78,74,77,76,77,77,78,78,80,78,91,32,83,79,85,78,87,78,88,79,88,80,90,80,90,78,88,77,86,77,84,78,81,81,79,84,78,87,32,88,78,89,79,89,80,32,80,83,81,83,87,89,89,89,90,88,32,84,87,87,90,89,90,32,82,84,85,90,86,91,88,91,89,90,90,88,32,76,91,78,91,0,72,92,74,71,75,70,77,70,79,71,81,73,88,88,89,90,90,91,32,79,72,80,73,87,88,88,89,32,77,70,78,71,79,73,86,88,88,90,90,91,91,91,32,82,77,74,90,74,91,75,91,82,77,0,71,93,75,77,75,98,32,76,78,76,97,32,77,77,77,98,32,86,77,86,88,87,90,88,91,90,91,91,90,92,88,32,87,78,87,88,88,90,89,91,32,88,77,88,88,89,90,90,91,32,77,88,78,90,80,91,82,91,84,90,85,89,86,87,32,75,77,77,77,32,86,77,88,77,32,75,98,77,98,0,71,93,74,77,75,78,76,80,77,84,78,91,32,75,77,76,78,77,80,78,84,79,90,32,72,80,73,78,74,77,76,77,77,78,78,80,79,84,80,90,32,86,86,87,84,88,81,88,77,89,77,90,78,89,81,88,83,86,86,84,88,81,90,78,91,32,88,82,89,79,89,77,0,74,90,80,71,83,70,82,70,80,71,79,72,79,73,80,74,83,75,86,76,87,75,86,74,83,75,80,76,78,77,77,79,77,81,78,82,80,83,83,84,86,85,87,84,86,83,83,84,79,85,77,86,76,88,76,90,77,91,79,92,83,93,85,94,86,95,86,97,84,98,82,98,79,97,80,97,82,98,32,79,77,78,79,78,81,79,82,32,78,86,77,88,77,90,78,91,32,86,75,83,75,81,76,80,77,79,79,79,81,81,83,83,84,32,86,84,83,84,80,85,79,86,78,88,78,90,80,92,83,93,0,71,93,73,81,74,79,75,78,77,77,91,77,32,75,79,77,78,90,78,32,73,81,74,80,76,79,91,79,32,79,79,78,90,77,91,76,90,77,87,79,79,32,85,79,86,90,87,91,88,90,87,87,85,79,32,91,77,91,79,32,79,79,77,90,32,85,79,87,90,0,71,92,81,77,78,78,76,80,75,84,75,98,32,77,80,76,84,76,97,32,81,77,79,78,78,79,77,83,77,98,32,77,87,78,89,79,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,81,77,32,87,88,88,86,88,82,87,80,32,83,91,85,90,86,89,87,86,87,82,86,79,85,78,83,77,32,75,98,77,98,0,71,93,80,77,77,78,75,80,74,83,74,85,75,88,77,90,80,91,82,91,85,90,87,88,88,85,88,83,87,80,85,78,82,77,32,76,80,75,82,75,86,76,88,32,86,88,87,86,87,82,86,80,32,80,77,78,78,77,79,76,82,76,86,77,89,78,90,80,91,32,82,91,84,90,85,89,86,86,86,82,85,79,84,78,82,77,32,82,77,90,79,91,78,91,77,80,77,32,82,77,90,78,0,72,92,74,81,75,79,76,78,78,77,90,77,32,76,79,78,78,89,78,32,74,81,75,80,77,79,90,79,32,82,79,81,90,82,91,83,90,82,79,32,90,77,90,79,32,82,79,82,90,0,71,92,74,77,75,78,76,80,76,85,77,88,79,90,81,91,83,91,85,90,87,88,88,86,89,82,89,78,88,77,87,77,88,80,88,83,87,87,85,90,32,75,77,76,78,77,80,77,85,78,88,32,87,77,88,78,88,79,32,72,80,73,78,74,77,76,77,77,78,78,80,78,86,79,89,81,91,0,71,93,82,81,81,78,80,77,78,77,76,78,75,79,74,82,74,85,75,88,77,90,80,91,84,91,87,90,89,88,90,85,90,82,89,79,88,78,86,77,84,77,83,78,82,81,32,76,79,75,82,75,85,76,88,32,88,88,89,85,89,82,88,79,32,78,77,77,78,76,81,76,86,77,89,78,90,80,91,32,84,91,86,90,87,89,88,86,88,81,87,78,86,77,32,82,81,81,98,32,82,81,82,97,32,82,81,83,98,32,81,98,83,98,0,72,92,76,77,77,78,78,80,84,95,86,97,88,98,90,98,91,97,32,78,79,79,80,85,95,86,96,32,73,78,74,77,76,77,78,78,80,80,86,95,87,97,88,98,32,86,83,88,80,89,77,90,77,89,79,86,83,78,92,75,96,74,98,75,98,76,95,78,92,0,70,93,72,78,73,78,74,80,74,85,75,88,77,90,80,91,84,91,86,90,88,88,89,86,90,82,90,78,89,77,88,77,89,80,89,83,88,87,86,90,32,74,78,75,80,75,85,76,88,32,88,77,89,78,89,79,32,71,80,72,78,73,77,74,77,75,78,76,80,76,86,77,89,78,90,80,91,32,81,70,83,98,32,82,71,82,97,32,83,70,81,98,32,81,70,83,70,32,81,98,83,98,0,70,94,78,77,76,78,74,80,73,83,73,87,74,89,75,90,77,91,79,91,81,90,82,89,83,87,83,84,82,83,81,84,81,87,82,89,83,90,85,91,87,91,89,90,90,89,91,87,91,83,90,80,88,78,86,77,32,75,80,74,83,74,87,75,89,32,82,84,82,88,32,89,89,90,87,90,83,89,80,32,78,77,76,79,75,82,75,87,76,90,77,91,32,87,91,88,90,89,87,89,82,88,79,86,77,0,71,93,87,77,85,84,85,88,86,90,87,91,89,91,91,89,92,87,32,88,77,86,84,86,90,32,87,77,89,77,87,84,86,88,32,85,84,85,81,84,78,82,77,80,77,77,78,75,81,74,84,74,86,75,89,76,90,78,91,80,91,82,90,83,89,84,87,85,84,32,78,78,76,81,75,84,75,87,76,89,32,80,77,78,79,77,81,76,84,76,87,77,90,78,91,0,73,92,80,70,78,77,77,83,77,87,78,89,79,90,81,91,83,91,86,90,88,87,89,84,89,82,88,79,87,78,85,77,83,77,81,78,80,79,79,81,78,84,32,81,70,79,77,78,81,78,87,79,90,32,86,89,87,87,88,84,88,81,87,79,32,77,70,82,70,80,77,78,84,32,83,91,85,89,86,87,87,84,87,81,86,78,85,77,32,78,70,81,71,32,79,70,80,72,0,73,91,87,81,87,80,86,80,86,82,88,82,88,80,87,78,85,77,82,77,79,78,77,81,76,84,76,86,77,89,78,90,80,91,82,91,85,90,87,87,32,79,79,78,81,77,84,77,87,78,89,32,82,77,80,79,79,81,78,84,78,87,79,90,80,91,0,71,93,89,70,86,81,85,85,85,88,86,90,87,91,89,91,91,89,92,87,32,90,70,87,81,86,85,86,90,32,86,70,91,70,87,84,86,88,32,85,84,85,81,84,78,82,77,80,77,77,78,75,81,74,84,74,86,75,89,76,90,78,91,80,91,82,90,83,89,84,87,85,84,32,77,79,76,81,75,84,75,87,76,89,32,80,77,78,79,77,81,76,84,76,87,77,90,78,91,32,87,70,90,71,32,88,70,89,72,0,73,91,77,86,81,85,84,84,87,82,88,80,87,78,85,77,82,77,79,78,77,81,76,84,76,86,77,89,78,90,80,91,82,91,85,90,87,88,32,79,79,78,81,77,84,77,87,78,89,32,82,77,80,79,79,81,78,84,78,87,79,90,80,91,0,74,90,90,72,90,71,89,71,89,73,91,73,91,71,90,70,88,70,86,71,84,73,83,75,82,78,81,82,79,91,78,94,77,96,75,98,32,84,74,83,77,82,82,80,91,79,94,32,88,70,86,72,85,74,84,77,83,82,81,90,80,93,79,95,77,97,75,98,73,98,72,97,72,95,74,95,74,97,73,97,73,96,32,78,77,89,77,0,72,93,88,77,84,91,83,94,81,97,79,98,32,89,77,85,91,83,95,32,88,77,90,77,86,91,84,95,82,97,79,98,76,98,74,97,73,96,73,94,75,94,75,96,74,96,74,95,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,86,76,89,77,90,79,91,81,91,83,90,84,89,85,87,86,84,32,78,79,77,81,76,84,76,87,77,89,32,81,77,79,79,78,81,77,84,77,87,78,90,79,91,0,71,93,79,70,73,91,75,91,32,80,70,74,91,32,76,70,81,70,75,91,32,77,84,79,80,81,78,83,77,85,77,87,78,88,80,88,83,86,88,32,87,78,87,82,86,86,86,90,32,87,80,85,85,85,88,86,90,87,91,89,91,91,89,92,87,32,77,70,80,71,32,78,70,79,72,0,75,88,84,70,84,72,86,72,86,70,84,70,32,85,70,85,72,32,84,71,86,71,32,76,81,77,79,79,77,81,77,82,78,83,80,83,83,81,88,32,82,78,82,82,81,86,81,90,32,82,80,80,85,80,88,81,90,82,91,84,91,86,89,87,87,0,75,88,85,70,85,72,87,72,87,70,85,70,32,86,70,86,72,32,85,71,87,71,32,77,81,78,79,80,77,82,77,83,78,84,80,84,83,82,90,81,93,80,95,78,97,76,98,74,98,73,97,73,95,75,95,75,97,74,97,74,96,32,83,78,83,83,81,90,80,93,79,95,32,83,80,82,84,80,91,79,94,78,96,76,98,0,71,93,79,70,73,91,75,91,32,80,70,74,91,32,76,70,81,70,75,91,32,89,79,89,78,88,78,88,80,90,80,90,78,89,77,87,77,85,78,81,82,79,83,32,77,83,79,83,81,84,82,85,84,89,85,90,87,90,32,81,85,83,89,84,90,32,79,83,80,84,82,90,83,91,85,91,87,90,89,87,32,77,70,80,71,32,78,70,79,72,0,76,88,84,70,81,81,80,85,80,88,81,90,82,91,84,91,86,89,87,87,32,85,70,82,81,81,85,81,90,32,81,70,86,70,82,84,81,88,32,82,70,85,71,32,83,70,84,72,0,64,99,65,81,66,79,68,77,70,77,71,78,72,80,72,83,70,91,32,71,78,71,83,69,91,32,71,80,70,84,68,91,70,91,32,72,83,74,80,76,78,78,77,80,77,82,78,83,80,83,83,81,91,32,82,78,82,83,80,91,32,82,80,81,84,79,91,81,91,32,83,83,85,80,87,78,89,77,91,77,93,78,94,80,94,83,92,88,32,93,78,93,82,92,86,92,90,32,93,80,91,85,91,88,92,90,93,91,95,91,97,89,98,87,0,70,94,71,81,72,79,74,77,76,77,77,78,78,80,78,83,76,91,32,77,78,77,83,75,91,32,77,80,76,84,74,91,76,91,32,78,83,80,80,82,78,84,77,86,77,88,78,89,80,89,83,87,88,32,88,78,88,82,87,86,87,90,32,88,80,86,85,86,88,87,90,88,91,90,91,92,89,93,87,0,72,92,81,77,78,78,76,81,75,84,75,86,76,89,77,90,80,91,83,91,86,90,88,87,89,84,89,82,88,79,87,78,84,77,81,77,32,78,79,77,81,76,84,76,87,77,89,32,86,89,87,87,88,84,88,81,87,79,32,81,77,79,79,78,81,77,84,77,87,78,90,80,91,32,83,91,85,89,86,87,87,84,87,81,86,78,84,77,0,71,93,72,81,73,79,75,77,77,77,78,78,79,80,79,83,78,87,75,98,32,78,78,78,83,77,87,74,98,32,78,80,77,84,73,98,32,79,84,80,81,81,79,82,78,84,77,86,77,88,78,89,79,90,82,90,84,89,87,87,90,84,91,82,91,80,90,79,87,79,84,32,88,79,89,81,89,84,88,87,87,89,32,86,77,87,78,88,81,88,84,87,87,86,89,84,91,32,70,98,78,98,32,74,97,71,98,32,74,96,72,98,32,75,96,76,98,32,74,97,77,98,0,71,92,87,77,81,98,32,88,77,82,98,32,87,77,89,77,83,98,32,85,84,85,81,84,78,82,77,80,77,77,78,75,81,74,84,74,86,75,89,76,90,78,91,80,91,82,90,83,89,84,87,85,84,32,77,79,76,81,75,84,75,87,76,89,32,80,77,78,79,77,81,76,84,76,87,77,90,78,91,32,78,98,86,98,32,82,97,79,98,32,82,96,80,98,32,83,96,84,98,32,82,97,85,98,0,73,91,74,81,75,79,77,77,79,77,80,78,81,80,81,84,79,91,32,80,78,80,84,78,91,32,80,80,79,84,77,91,79,91,32,89,79,89,78,88,78,88,80,90,80,90,78,89,77,87,77,85,78,83,80,81,84,0,74,91,88,80,88,79,87,79,87,81,89,81,89,79,88,78,85,77,82,77,79,78,78,79,78,81,79,83,81,84,84,85,86,86,87,88,32,79,78,78,81,32,79,82,81,83,84,84,86,85,32,87,86,86,90,32,78,79,79,81,81,82,84,83,86,84,87,86,87,88,86,90,83,91,80,91,77,90,76,89,76,87,78,87,78,89,77,89,77,88,0,75,89,84,70,81,81,80,85,80,88,81,90,82,91,84,91,86,89,87,87,32,85,70,82,81,81,85,81,90,32,84,70,86,70,82,84,81,88,32,78,77,88,77,0,70,94,71,81,72,79,74,77,76,77,77,78,78,80,78,83,76,88,32,77,78,77,82,76,86,76,90,32,77,80,75,85,75,88,76,90,78,91,80,91,82,90,84,88,86,85,32,88,77,86,85,86,88,87,90,88,91,90,91,92,89,93,87,32,89,77,87,85,87,90,32,88,77,90,77,88,84,87,88,0,72,92,73,81,74,79,76,77,78,77,79,78,80,80,80,83,78,88,32,79,78,79,82,78,86,78,90,32,79,80,77,85,77,88,78,90,80,91,82,91,84,90,86,88,88,85,89,81,89,77,88,77,88,78,89,80,0,67,97,68,81,69,79,71,77,73,77,74,78,75,80,75,83,73,88,32,74,78,74,82,73,86,73,90,32,74,80,72,85,72,88,73,90,75,91,77,91,79,90,81,88,82,85,32,84,77,82,85,82,88,83,90,85,91,87,91,89,90,91,88,93,85,94,81,94,77,93,77,93,78,94,80,32,85,77,83,85,83,90,32,84,77,86,77,84,84,83,88,0,71,93,74,81,76,78,78,77,80,77,82,78,83,80,83,82,32,80,77,81,78,81,82,80,86,79,88,77,90,75,91,73,91,72,90,72,88,74,88,74,90,73,90,73,89,32,82,79,82,82,81,86,81,89,32,90,79,90,78,89,78,89,80,91,80,91,78,90,77,88,77,86,78,84,80,83,82,82,86,82,90,83,91,32,80,86,80,88,81,90,83,91,85,91,87,90,89,87,0,71,93,72,81,73,79,75,77,77,77,78,78,79,80,79,83,77,88,32,78,78,78,82,77,86,77,90,32,78,80,76,85,76,88,77,90,79,91,81,91,83,90,85,88,87,84,32,89,77,85,91,84,94,82,97,80,98,32,90,77,86,91,84,95,32,89,77,91,77,87,91,85,95,83,97,80,98,77,98,75,97,74,96,74,94,76,94,76,96,75,96,75,95,0,72,92,89,77,88,79,86,81,78,87,76,89,75,91,32,88,79,79,79,77,80,76,82,32,86,79,82,78,79,78,78,79,32,86,79,82,77,79,77,77,79,76,82,32,76,89,85,89,87,88,88,86,32,78,89,82,90,85,90,86,89,32,78,89,82,91,85,91,87,89,88,86,0,72,92,87,81,86,79,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,87,89,88,87,89,83,89,78,88,74,87,72,86,71,83,70,81,70,78,71,77,72,78,72,79,71,81,70,32,77,80,76,82,76,86,77,88,32,86,89,87,87,88,83,88,78,87,74,86,72,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,83,91,85,90,86,88,87,84,87,77,86,73,85,71,83,70,0,73,91,85,77,87,78,88,79,89,79,88,78,85,77,82,77,79,78,77,80,76,83,76,85,77,88,79,90,82,91,85,91,88,90,89,89,88,89,87,90,85,91,32,78,80,77,83,77,85,78,88,32,82,77,80,78,79,79,78,82,78,86,79,89,80,90,82,91,32,78,84,84,85,85,84,84,83,78,84,32,78,84,84,84,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+296972);allocate([32,78,72,77,74,76,78,76,83,77,87,78,89,32,86,89,87,87,88,83,88,78,87,74,86,72,32,81,70,79,71,78,73,77,78,77,83,78,88,79,90,81,91,32,83,91,85,90,86,88,87,83,87,78,86,73,85,71,83,70,32,76,80,88,81,32,76,81,88,80,0,71,93,80,77,77,78,75,80,74,83,74,85,75,88,77,90,80,91,84,91,87,90,89,88,90,85,90,83,89,80,87,78,84,77,80,77,32,76,80,75,83,75,85,76,88,32,88,88,89,85,89,83,88,80,32,80,77,78,78,77,79,76,82,76,86,77,89,78,90,80,91,84,91,86,90,87,89,88,86,88,82,87,79,86,78,84,77,32,81,70,83,98,32,82,71,82,97,32,83,70,81,98,32,81,70,83,70,32,81,98,83,98,0,72,92,84,77,86,78,88,80,89,80,89,79,87,78,84,77,80,77,77,78,76,79,75,81,75,83,76,85,78,87,80,88,82,89,83,90,84,92,84,94,83,95,81,95,79,94,80,94,81,95,32,77,79,76,81,76,83,77,85,79,87,32,80,77,78,78,77,80,77,83,78,85,82,89,32,89,80,88,79,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,32,78,72,77,74,76,78,76,83,77,87,78,89,32,86,89,87,87,88,83,88,78,87,74,86,72,32,81,70,79,71,78,73,77,78,77,83,78,88,79,90,81,91,32,83,91,85,90,86,88,87,83,87,78,86,73,85,71,83,70,0,72,92,81,72,81,91,32,82,72,82,90,32,83,70,83,91,32,83,70,80,73,78,74,32,77,91,87,91,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,72,92,76,74,76,75,77,75,77,74,76,74,32,76,73,77,73,78,74,78,75,77,76,76,76,75,75,75,74,76,72,77,71,80,70,84,70,87,71,88,72,89,74,89,76,88,78,85,80,80,82,78,83,76,85,75,88,75,91,32,87,72,88,74,88,76,87,78,32,84,70,86,71,87,74,87,76,86,78,84,80,80,82,32,75,89,76,88,78,88,83,89,87,89,89,88,32,78,88,83,90,87,90,88,89,32,78,88,83,91,87,91,88,90,89,88,89,86,0,72,92,76,74,76,75,77,75,77,74,76,74,32,76,73,77,73,78,74,78,75,77,76,76,76,75,75,75,74,76,72,77,71,80,70,84,70,87,71,88,73,88,76,87,78,84,79,32,86,71,87,73,87,76,86,78,32,83,70,85,71,86,73,86,76,85,78,83,79,32,81,79,84,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,86,76,85,77,85,78,86,78,87,77,88,76,88,32,87,82,88,84,88,87,87,89,32,83,79,85,80,86,81,87,84,87,87,86,90,84,91,32,76,86,76,87,77,87,77,86,76,86,0,72,92,83,73,83,91,32,84,72,84,90,32,85,70,85,91,32,85,70,74,85,90,85,32,80,91,88,91,32,83,90,81,91,32,83,89,82,91,32,85,89,86,91,32,85,90,87,91,0,72,92,77,70,75,80,77,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,75,86,76,85,77,85,78,86,78,87,77,88,76,88,32,87,80,88,82,88,86,87,88,32,83,77,85,78,86,79,87,82,87,86,86,89,85,90,83,91,32,76,86,76,87,77,87,77,86,76,86,32,77,70,87,70,32,77,71,85,71,32,77,72,81,72,85,71,87,70,0,72,92,86,73,86,74,87,74,87,73,86,73,32,87,72,86,72,85,73,85,74,86,75,87,75,88,74,88,73,87,71,85,70,82,70,79,71,77,73,76,75,75,79,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,81,78,79,79,78,80,77,82,32,78,73,77,75,76,79,76,85,77,88,78,89,32,87,88,88,86,88,83,87,81,32,82,70,80,71,79,72,78,74,77,78,77,85,78,88,79,90,81,91,32,83,91,85,90,86,89,87,86,87,83,86,80,85,79,83,78,0,72,92,75,70,75,76,32,89,70,89,73,88,76,84,81,83,83,82,87,82,91,32,83,82,82,84,81,87,81,91,32,88,76,83,81,81,84,80,87,80,91,82,91,32,75,74,76,72,78,70,80,70,85,73,87,73,88,72,89,70,32,77,72,78,71,80,71,82,72,32,75,74,76,73,78,72,80,72,85,73,0,72,92,80,70,77,71,76,73,76,76,77,78,80,79,84,79,87,78,88,76,88,73,87,71,84,70,80,70,32,78,71,77,73,77,76,78,78,32,86,78,87,76,87,73,86,71,32,80,70,79,71,78,73,78,76,79,78,80,79,32,84,79,85,78,86,76,86,73,85,71,84,70,32,80,79,77,80,76,81,75,83,75,87,76,89,77,90,80,91,84,91,87,90,88,89,89,87,89,83,88,81,87,80,84,79,32,77,81,76,83,76,87,77,89,32,87,89,88,87,88,83,87,81,32,80,79,78,80,77,83,77,87,78,90,80,91,32,84,91,86,90,87,87,87,83,86,80,84,79,0,72,92,77,87,77,88,78,88,78,87,77,87,32,87,79,86,81,85,82,83,83,81,83,78,82,76,80,75,77,75,76,76,73,78,71,81,70,83,70,86,71,88,73,89,76,89,82,88,86,87,88,85,90,82,91,79,91,77,90,76,88,76,87,77,86,78,86,79,87,79,88,78,89,77,89,32,77,80,76,78,76,75,77,73,32,86,72,87,73,88,76,88,82,87,86,86,88,32,81,83,79,82,78,81,77,78,77,75,78,72,79,71,81,70,32,83,70,85,71,86,73,87,76,87,83,86,87,85,89,84,90,82,91,0,77,88,82,70,81,71,81,73,82,81,32,82,70,82,84,83,84,32,82,70,83,70,83,84,32,83,70,84,71,84,73,83,81,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,73,92,77,75,77,74,78,74,78,76,76,76,76,74,77,72,78,71,80,70,84,70,87,71,88,72,89,74,89,76,88,78,87,79,83,81,32,87,72,88,73,88,77,87,78,32,84,70,86,71,87,73,87,77,86,79,85,80,32,82,81,82,84,83,84,83,81,82,81,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,69,95,91,79,91,78,90,78,90,80,92,80,92,78,91,77,90,77,89,78,88,80,86,85,84,88,82,90,80,91,76,91,74,90,73,88,73,85,74,83,80,79,82,77,83,75,83,73,82,71,80,70,78,71,77,73,77,76,78,79,80,82,84,87,87,90,89,91,91,91,92,89,92,88,32,75,90,74,88,74,85,75,83,76,82,32,82,77,83,73,32,83,75,82,71,32,78,71,77,75,32,78,78,80,81,84,86,87,89,89,90,32,78,91,76,90,75,88,75,85,76,83,80,79,32,77,73,78,77,81,81,85,86,88,89,90,90,91,90,92,89,0,72,92,80,66,80,95,32,84,66,84,95,32,88,75,88,74,87,74,87,76,89,76,89,74,88,72,87,71,84,70,80,70,77,71,75,73,75,76,76,78,79,80,85,82,87,83,88,85,88,88,87,90,32,76,76,77,78,79,79,85,81,87,82,88,84,32,77,71,76,73,76,75,77,77,79,78,85,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,85,77,85,77,87,76,87,76,86,0,75,89,85,66,83,68,81,71,79,75,78,80,78,84,79,89,81,93,83,96,85,98,32,81,72,80,75,79,79,79,85,80,89,81,92,32,83,68,82,70,81,73,80,79,80,85,81,91,82,94,83,96,0,75,89,79,66,81,68,83,71,85,75,86,80,86,84,85,89,83,93,81,96,79,98,32,83,72,84,75,85,79,85,85,84,89,83,92,32,81,68,82,70,83,73,84,79,84,85,83,91,82,94,81,96,0,70,94,91,70,89,71,86,72,83,72,80,71,78,70,76,70,74,71,73,73,73,75,75,77,77,77,79,76,80,74,80,72,78,70,32,91,70,72,91,32,91,70,73,91,32,91,70,74,91,32,89,84,87,84,85,85,84,87,84,89,86,91,88,91,90,90,91,88,91,86,89,84,32,79,71,76,70,73,73,74,76,77,77,80,74,79,71,32,78,70,74,71,73,75,32,75,77,79,76,80,72,32,90,85,87,84,84,87,85,90,88,91,91,88,90,85,32,89,84,85,85,84,89,32,86,91,90,90,91,86,32,72,91,74,91,0,69,96,86,78,85,76,83,75,81,75,79,76,78,77,77,79,77,82,78,84,79,85,81,86,83,86,85,85,86,83,32,79,77,78,79,78,82,79,84,32,81,75,80,76,79,79,79,82,80,85,81,86,32,86,75,86,83,87,85,89,86,90,86,92,85,93,82,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,84,91,87,90,89,89,88,89,87,90,32,87,76,87,83,88,85,32,86,75,88,75,88,83,89,85,90,86,0,72,93,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,79,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,84,70,32,81,72,79,74,78,76,77,79,76,83,76,87,77,89,32,84,89,86,87,87,85,88,82,89,78,89,74,88,72,32,84,70,82,71,80,74,79,76,78,79,77,83,77,88,78,90,79,91,32,81,91,83,90,85,87,86,85,87,82,88,78,88,73,87,71,86,70,0,72,93,84,74,79,91,81,91,32,87,70,85,74,80,91,32,87,70,81,91,32,87,70,84,73,81,75,79,76,32,84,74,82,75,79,76,0,72,93,79,75,79,74,80,74,80,76,78,76,78,74,79,72,80,71,83,70,86,70,89,71,90,73,90,75,89,77,87,79,77,85,75,87,73,91,32,88,71,89,73,89,75,88,77,86,79,83,81,32,86,70,87,71,88,73,88,75,87,77,85,79,77,85,32,74,89,75,88,77,88,82,89,87,89,88,88,32,77,88,82,90,87,90,32,77,88,82,91,85,91,87,90,88,88,88,87,0,72,93,79,75,79,74,80,74,80,76,78,76,78,74,79,72,80,71,83,70,86,70,89,71,90,73,90,75,89,77,88,78,86,79,83,80,32,88,71,89,73,89,75,88,77,87,78,32,86,70,87,71,88,73,88,75,87,77,85,79,83,80,32,81,80,83,80,86,81,87,82,88,84,88,87,87,89,85,90,82,91,79,91,76,90,75,89,74,87,74,85,76,85,76,87,75,87,75,86,32,86,82,87,84,87,87,86,89,32,83,80,85,81,86,83,86,87,85,89,84,90,82,91,0,72,93,87,74,82,91,84,91,32,90,70,88,74,83,91,32,90,70,84,91,32,90,70,74,85,90,85,0,72,93,81,70,76,80,32,81,70,91,70,32,81,71,89,71,32,80,72,85,72,89,71,91,70,32,76,80,77,79,80,78,83,78,86,79,87,80,88,82,88,85,87,88,85,90,81,91,78,91,76,90,75,89,74,87,74,85,76,85,76,87,75,87,75,86,32,86,80,87,82,87,85,86,88,84,90,32,83,78,85,79,86,81,86,85,85,88,83,90,81,91,0,72,93,89,74,89,73,88,73,88,75,90,75,90,73,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,79,91,82,91,85,90,87,88,88,86,88,83,87,81,86,80,84,79,81,79,79,80,78,81,77,83,32,80,73,78,76,77,79,76,83,76,87,77,89,32,86,88,87,86,87,83,86,81,32,84,70,82,71,80,74,79,76,78,79,77,83,77,88,78,90,79,91,32,82,91,84,90,85,89,86,86,86,82,85,80,84,79,0,72,93,78,70,76,76,32,91,70,90,73,88,76,84,81,82,84,81,87,80,91,32,82,83,80,87,79,91,32,88,76,82,82,80,85,79,87,78,91,80,91,32,77,73,80,70,82,70,87,73,32,79,71,82,71,87,73,32,77,73,79,72,82,72,87,73,89,73,90,72,91,70,0,72,93,83,70,80,71,79,72,78,74,78,77,79,79,81,80,84,80,87,79,89,78,90,76,90,73,89,71,87,70,83,70,32,85,70,80,71,32,80,72,79,74,79,78,80,79,32,79,79,82,80,32,83,80,87,79,32,88,78,89,76,89,73,88,71,32,89,71,85,70,32,83,70,81,72,80,74,80,78,81,80,32,84,80,86,79,87,78,88,76,88,72,87,70,32,81,80,77,81,75,83,74,85,74,88,75,90,78,91,82,91,86,90,87,89,88,87,88,84,87,82,86,81,84,80,32,82,80,77,81,32,78,81,76,83,75,85,75,88,76,90,32,75,90,80,91,86,90,32,86,89,87,87,87,84,86,82,32,86,81,83,80,32,81,80,79,81,77,83,76,85,76,88,77,90,78,91,32,82,91,84,90,85,89,86,87,86,83,85,81,84,80,0,72,93,88,78,87,80,86,81,84,82,81,82,79,81,78,80,77,78,77,75,78,73,80,71,83,70,86,70,88,71,89,72,90,75,90,78,89,82,88,85,86,88,84,90,81,91,78,91,76,90,75,88,75,86,77,86,77,88,76,88,76,87,32,79,80,78,78,78,75,79,73,32,88,72,89,74,89,78,88,82,87,85,85,88,32,81,82,80,81,79,79,79,75,80,72,81,71,83,70,32,86,70,87,71,88,73,88,78,87,82,86,85,85,87,83,90,81,91,0,77,88,80,88,79,89,79,90,80,91,81,91,82,90,82,89,81,88,80,88,32,80,89,80,90,81,90,81,89,80,89,0,77,88,81,91,80,91,79,90,79,89,80,88,81,88,82,89,82,91,81,93,80,94,78,95,32,80,89,80,90,81,90,81,89,80,89,32,81,91,81,92,80,94,0,77,88,83,77,82,78,82,79,83,80,84,80,85,79,85,78,84,77,83,77,32,83,78,83,79,84,79,84,78,83,78,32,80,88,79,89,79,90,80,91,81,91,82,90,82,89,81,88,80,88,32,80,89,80,90,81,90,81,89,80,89,0,77,88,83,77,82,78,82,79,83,80,84,80,85,79,85,78,84,77,83,77,32,83,78,83,79,84,79,84,78,83,78,32,81,91,80,91,79,90,79,89,80,88,81,88,82,89,82,91,81,93,80,94,78,95,32,80,89,80,90,81,90,81,89,80,89,32,81,91,81,92,80,94,0,77,88,86,70,85,70,84,71,82,84,32,86,71,85,71,82,84,32,86,71,86,72,82,84,32,86,70,87,71,87,72,82,84,32,80,88,79,89,79,90,80,91,81,91,82,90,82,89,81,88,80,88,32,80,89,80,90,81,90,81,89,80,89,0,72,93,79,75,79,74,80,74,80,76,78,76,78,74,79,72,80,71,83,70,87,70,90,71,91,73,91,75,90,77,89,78,87,79,83,80,81,81,81,83,83,84,84,84,32,85,70,90,71,32,89,71,90,73,90,75,89,77,88,78,86,79,32,87,70,88,71,89,73,89,75,88,77,87,78,83,80,82,81,82,83,83,84,32,80,88,79,89,79,90,80,91,81,91,82,90,82,89,81,88,80,88,32,80,89,80,90,81,90,81,89,80,89,0,77,88,87,70,85,71,84,72,83,74,83,76,84,77,85,77,86,76,86,75,85,74,84,74,32,85,71,84,73,84,74,32,84,75,84,76,85,76,85,75,84,75,0,77,88,86,73,85,73,84,72,84,71,85,70,86,70,87,71,87,73,86,75,85,76,83,77,32,85,71,85,72,86,72,86,71,85,71,32,86,73,86,74,85,76,0,69,95,92,79,92,78,91,78,91,80,93,80,93,78,92,77,91,77,89,78,87,80,82,88,80,90,78,91,75,91,72,90,71,88,71,86,72,84,73,83,75,82,80,80,82,79,84,77,85,75,85,73,84,71,82,70,80,71,79,73,79,76,80,82,81,85,82,87,84,90,86,91,88,91,89,89,89,88,32,76,91,72,90,32,73,90,72,88,72,86,73,84,74,83,76,82,32,80,80,81,83,84,89,86,90,32,75,91,74,90,73,88,73,86,74,84,75,83,77,82,82,79,32,79,76,80,79,81,82,83,86,85,89,87,90,88,90,89,89,0,72,93,84,66,76,95,32,89,66,81,95,32,90,75,90,74,89,74,89,76,91,76,91,74,90,72,89,71,86,70,82,70,79,71,77,73,77,76,78,78,80,80,86,83,87,85,87,88,86,90,32,78,76,79,78,86,82,87,84,32,79,71,78,73,78,75,79,77,85,80,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,85,76,85,76,87,75,87,75,86,0,71,94,95,66,69,98,70,98,32,95,66,96,66,70,98,0,74,90,90,66,88,67,85,69,82,72,80,75,78,79,77,83,77,88,78,92,79,95,81,98,32,83,72,81,75,79,79,78,84,78,92,32,90,66,87,68,84,71,82,74,81,76,80,79,79,83,78,92,32,78,84,79,93,80,96,81,98,0,74,90,83,66,85,69,86,72,87,76,87,81,86,85,84,89,82,92,79,95,76,97,74,98,32,86,72,86,80,85,85,83,89,81,92,32,83,66,84,68,85,71,86,80,32,86,72,85,81,84,85,83,88,82,90,80,93,77,96,74,98,0,74,91,84,70,83,71,85,81,84,82,32,84,70,84,82,32,84,70,85,71,83,81,84,82,32,79,73,80,73,88,79,89,79,32,79,73,89,79,32,79,73,79,74,89,78,89,79,32,89,73,88,73,80,79,79,79,32,89,73,79,79,32,89,73,89,74,79,78,79,79,0,77,87,85,70,84,71,82,77,32,85,71,82,77,32,85,70,86,71,82,77,0,72,92,80,70,79,71,77,77,32,80,71,77,77,32,80,70,81,71,77,77,32,90,70,89,71,87,77,32,90,71,87,77,32,90,70,91,71,87,77,0,75,90,83,70,81,71,80,73,80,75,81,77,83,78,85,78,87,77,88,75,88,73,87,71,85,70,83,70,32,83,70,80,73,81,77,85,78,88,75,87,71,83,70,32,85,70,81,71,80,75,83,78,87,77,88,73,85,70,0,71,94,83,70,75,98,76,98,32,83,70,84,70,76,98,32,89,70,81,98,82,98,32,89,70,90,70,82,98,32,75,80,92,80,92,81,32,75,80,75,81,92,81,32,73,87,90,87,90,88,32,73,87,73,88,90,88,0,69,94,94,70,92,71,88,72,85,72,81,71,79,70,77,70,75,71,74,73,74,75,76,77,78,77,80,76,81,74,81,72,79,70,32,94,70,69,91,32,94,70,70,91,32,94,70,71,91,32,88,84,86,84,84,85,83,87,83,89,85,91,87,91,89,90,90,88,90,86,88,84,32,80,71,77,70,74,73,75,76,78,77,81,74,80,71,32,79,70,75,71,74,75,32,76,77,80,76,81,72,32,89,85,86,84,83,87,84,90,87,91,90,88,89,85,32,88,84,84,85,83,89,32,85,91,89,90,90,86,32,69,91,71,91,0,69,96,85,81,85,78,84,76,82,75,80,75,78,76,77,77,76,80,76,83,77,85,79,86,81,86,83,85,84,84,85,81,32,79,76,78,77,77,80,77,83,78,85,32,82,75,80,76,79,77,78,80,78,83,79,85,80,86,32,86,75,85,81,85,83,86,85,88,86,90,86,92,85,93,82,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,84,91,87,90,89,89,88,89,87,90,32,87,75,86,81,86,83,87,85,32,86,75,88,75,87,81,87,83,88,85,90,86,0,111,112,101,110,99,118,45,104,105,115,116,0,68,101,115,116,105,110,97,116,105,111,110,32,100,111,117,98,108,101,32,112,111,105,110,116,101,114,32,105,115,32,78,85,76,76,0,99,118,67,111,112,121,72,105,115,116,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,104,105,115,116,111,103,114,97,109,46,99,112,112,0,73,110,118,97,108,105,100,32,104,105,115,116,111,103,114,97,109,32,104,101,97,100,101,114,91,115,93,0,78,85,76,76,32,114,97,110,103,101,115,32,112,111,105,110,116,101,114,0,99,118,83,101,116,72,105,115,116,66,105,110,82,97,110,103,101,115,0,73,110,118,97,108,105,100,32,104,105,115,116,111,103,114,97,109,32,104,101,97,100,101,114,0,79,110,101,32,111,102,32,60,114,97,110,103,101,115,62,32,101,108,101,109,101,110,116,115,32,105,115,32,78,85,76,76,0,66,105,110,32,114,97,110,103,101,115,32,115,104,111,117,108,100,32,103,111,32,105,110,32,97,115,99,101,110,116,105,110,103,32,111,114,100,101,114,0,78,117,109,98,101,114,32,111,102,32,100,105,109,101,110,115,105,111,110,115,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,0,99,118,67,114,101,97,116,101,72,105,115,116,0,78,117,108,108,32,60,115,105,122,101,115,62,32,112,111,105,110,116,101,114,0,73,110,118,97,108,105,100,32,104,105,115,116,111,103,114,97,109,32,116,121,112,101,0,116,121,112,101,0,105,115,95,117,110,105,102,111,114,109,0,104,97,118,101,95,114,97,110,103,101,115,0,109,97,116,0,98,105,110,115,0,116,104,114,101,115,104,0,102,0,69,120,112,101,99,116,101,100,32,67,118,77,97,116,78,68,0,105,99,118,82,101,97,100,72,105,115,116,0,85,110,107,110,111,119,110,32,72,105,115,116,111,103,114,97,109,32,116,121,112,101,0,39,116,104,114,101,115,104,39,32,110,111,100,101,32,105,115,32,109,105,115,115,105,110,103,0,99,118,82,101,108,101,97,115,101,72,105,115,116,0,100,105,109,115,32,62,32,48,32,38,38,32,104,105,115,116,83,105,122,101,0,99,97,108,99,72,105,115,116,0,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,69,105,116,104,101,114,32,114,97,110,103,101,115,44,32,101,105,116,104,101,114,32,117,110,105,102,111,114,109,32,114,97,110,103,101,115,32,115,104,111,117,108,100,32,98,101,32,112,114,111,118,105,100,101,100,0,99,97,108,99,72,105,115,116,95,0,99,97,108,99,72,105,115,116,76,111,111,107,117,112,84,97,98,108,101,115,95,56,117,0,99,104,97,110,110,101,108,115,32,33,61,32,48,32,124,124,32,110,105,109,97,103,101,115,32,61,61,32,100,105,109,115,0,104,105,115,116,80,114,101,112,97,114,101,73,109,97,103,101,115,0,105,109,97,103,101,115,91,106,93,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,99,32,62,61,32,48,0,106,32,60,32,110,105,109,97,103,101,115,0,105,109,97,103,101,115,91,106,93,46,115,105,122,101,40,41,32,61,61,32,105,109,115,105,122,101,32,38,38,32,105,109,97,103,101,115,91,106,93,46,100,101,112,116,104,40,41,32,61,61,32,100,101,112,116,104,0,109,97,115,107,46,115,105,122,101,40,41,32,61,61,32,105,109,115,105,122,101,32,38,38,32,109,97,115,107,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,114,97,110,103,101,115,91,105,93,32,38,38,32,114,97,110,103,101,115,91,105,93,91,48,93,32,60,32,114,97,110,103,101,115,91,105,93,91,49,93,0,114,97,110,103,101,115,91,105,93,91,107,93,32,60,32,114,97,110,103,101,115,91,105,93,91,107,43,49,93,0,118,111,105,100,32,99,118,58,58,99,97,108,99,72,105,115,116,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,42,44,32,105,110,116,44,32,99,111,110,115,116,32,105,110,116,32,42,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,99,111,110,115,116,32,105,110,116,32,42,44,32,99,111,110,115,116,32,102,108,111,97,116,32,42,42,44,32,98,111,111,108,44,32,98,111,111,108,41,0,110,105,109,97,103,101,115,32,62,32,48,32,38,38,32,100,105,109,115,32,62,32,48,0,114,115,122,32,61,61,32,100,105,109,115,42,50,32,124,124,32,40,114,115,122,32,61,61,32,48,32,38,38,32,105,109,97,103,101,115,46,100,101,112,116,104,40,48,41,32,61,61,32,48,41,0,99,115,122,32,61,61,32,48,32,124,124,32,99,115,122,32,61,61,32,100,105,109,115,0,118,111,105,100,32,99,118,58,58,99,97,108,99,72,105,115,116,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,102,108,111,97,116,62,32,38,44,32,98,111,111,108,41,0,100,105,109,115,32,62,32,48,32,38,38,32,33,104,105,115,116,46,101,109,112,116,121,40,41,0,99,97,108,99,66,97,99,107,80,114,111,106,101,99,116,0,99,97,108,99,66,97,99,107,80,114,111,106,95,0,118,111,105,100,32,99,118,58,58,99,97,108,99,66,97,99,107,80,114,111,106,101,99,116,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,42,44,32,105,110,116,44,32,99,111,110,115,116,32,105,110,116,32,42,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,99,111,110,115,116,32,102,108,111,97,116,32,42,42,44,32,100,111,117,98,108,101,44,32,98,111,111,108,41,0,72,48,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,110,105,109,97,103,101,115,32,62,32,48,0,114,115,122,32,61,61,32,100,105,109,115,42,50,32,124,124,32,40,114,115,122,32,61,61,32,50,32,38,38,32,95,49,100,41,32,124,124,32,40,114,115,122,32,61,61,32,48,32,38,38,32,105,109,97,103,101,115,46,100,101,112,116,104,40,48,41,32,61,61,32,48,41,0,99,115,122,32,61,61,32,48,32,124,124,32,99,115,122,32,61,61,32,100,105,109,115,32,124,124,32,40,99,115,122,32,61,61,32,49,32,38,38,32,95,49,100,41,0,118,111,105,100,32,99,118,58,58,99,97,108,99,66,97,99,107,80,114,111,106,101,99,116,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,102,108,111,97,116,62,32,38,44,32,100,111,117,98,108,101,41,0,72,49,46,116,121,112,101,40,41,32,61,61,32,72,50,46,116,121,112,101,40,41,32,38,38,32,72,49,46,100,101,112,116,104,40,41,32,61,61,32,53,0,99,111,109,112,97,114,101,72,105,115,116,0,105,116,46,112,108,97,110,101,115,91,48,93,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,105,116,46,112,108,97,110,101,115,91,49,93,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,100,111,117,98,108,101,32,99,118,58,58,99,111,109,112,97,114,101,72,105,115,116,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,101,113,117,97,108,105,122,101,72,105,115,116,0,50,51,69,113,117,97,108,105,122,101,72,105,115,116,76,117,116,95,73,110,118,111,107,101,114,0,50,56,69,113,117,97,108,105,122,101,72,105,115,116,67,97,108,99,72,105,115,116,95,73,110,118,111,107,101,114,0,118,111,105,100,32,99,118,58,58,101,113,117,97,108,105,122,101,72,105,115,116,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,105,109,103,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,72,111,117,103,104,76,105,110,101,115,83,68,105,118,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,104,111,117,103,104,46,99,112,112,0,108,105,110,101,115,77,97,120,32,62,32,48,0,72,111,117,103,104,76,105,110,101,115,83,116,97,110,100,97,114,100,0,109,97,120,95,116,104,101,116,97,32,109,117,115,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,109,105,110,95,116,104,101,116,97,0,118,111,105,100,32,99,118,58,58,72,111,117,103,104,76,105,110,101,115,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,41,0,105,109,97,103,101,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,72,111,117,103,104,76,105,110,101,115,80,114,111,98,97,98,105,108,105,115,116,105,99,0,118,111,105,100,32,99,118,58,58,72,111,117,103,104,76,105,110,101,115,80,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,41,0,78,85,76,76,32,100,101,115,116,105,110,97,116,105,111,110,0,68,101,115,116,105,110,97,116,105,111,110,32,105,115,32,110,111,116,32,67,118,77,101,109,83,116,111,114,97,103,101,42,32,110,111,114,32,67,118,77,97,116,42,0,105,115,83,116,111,114,97,103,101,79,114,77,97,116,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,112,114,101,99,111,109,112,46,104,112,112,0,84,104,101,32,100,101,115,116,105,110,97,116,105,111,110,32,109,97,116,114,105,120,32,115,104,111,117,108,100,32,98,101,32,99,111,110,116,105,110,117,111,117,115,32,97,110,100,32,104,97,118,101,32,97,32,115,105,110,103,108,101,32,114,111,119,32,111,114,32,97,32,115,105,110,103,108,101,32,99,111,108,117,109,110,0,85,110,114,101,99,111,103,110,105,122,101,100,32,109,101,116,104,111,100,32,105,100,0,84,104,101,32,115,111,117,114,99,101,32,105,109,97,103,101,32,109,117,115,116,32,98,101,32,56,45,98,105,116,44,32,115,105,110,103,108,101,45,99,104,97,110,110,101,108,0,99,118,72,111,117,103,104,67,105,114,99,108,101,115,0,100,112,44,32,109,105,110,95,100,105,115,116,44,32,99,97,110,110,121,95,116,104,114,101,115,104,111,108,100,32,97,110,100,32,97,99,99,95,116,104,114,101,115,104,111,108,100,32,109,117,115,116,32,98,101,32,97,108,108,32,112,111,115,105,116,105,118,101,32,110,117,109,98,101,114,115,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,53,67,118,77,97,116,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,118,111,105,100,32,99,118,58,58,72,111,117,103,104,67,105,114,99,108,101,115,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,41,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,105,110,116,101,114,112,111,108,97,116,105,111,110,32,116,121,112,101,0,105,110,105,116,73,110,116,101,114,84,97,98,50,68,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,105,109,103,119,97,114,112,46,99,112,112,0,105,110,105,116,73,110,116,101,114,84,97,98,49,68,0,95,109,97,112,49,46,115,105,122,101,40,41,46,97,114,101,97,40,41,32,62,32,48,0,114,101,109,97,112,0,95,109,97,112,50,46,101,109,112,116,121,40,41,32,124,124,32,40,95,109,97,112,50,46,115,105,122,101,40,41,32,61,61,32,95,109,97,112,49,46,115,105,122,101,40,41,41,0,100,115,116,46,99,111,108,115,32,60,32,48,120,55,102,102,102,32,38,38,32,100,115,116,46,114,111,119,115,32,60,32,48,120,55,102,102,102,32,38,38,32,115,114,99,46,99,111,108,115,32,60,32,48,120,55,102,102,102,32,38,38,32,115,114,99,46,114,111,119,115,32,60,32,48,120,55,102,102,102,0,110,110,102,117,110,99,32,33,61,32,48,0,95,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,60,61,32,52,0,105,102,117,110,99,32,33,61,32,48,0,40,40,109,97,112,49,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,109,97,112,49,46,116,121,112,101,40,41,32,61,61,32,40,40,40,51,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,41,32,38,38,32,109,97,112,50,46,101,109,112,116,121,40,41,41,32,124,124,32,40,109,97,112,49,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,38,38,32,109,97,112,50,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,41,0,78,50,99,118,49,50,82,101,109,97,112,73,110,118,111,107,101,114,69,0,115,115,105,122,101,46,97,114,101,97,40,41,32,62,32,48,0,114,101,109,97,112,66,105,108,105,110,101,97,114,0,118,111,105,100,32,99,118,58,58,114,101,109,97,112,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,41,0,78,50,99,118,49,55,87,97,114,112,65,102,102,105,110,101,73,110,118,111,107,101,114,69,0,95,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,60,61,32,52,32,124,124,32,40,105,110,116,101,114,112,111,108,97,116,105,111,110,32,33,61,32,73,78,84,69,82,95,76,65,78,67,90,79,83,52,32,38,38,32,105,110,116,101,114,112,111,108,97,116,105,111,110,32,33,61,32,73,78,84,69,82,95,67,85,66,73,67,41,0,119,97,114,112,65,102,102,105,110,101,0,115,114,99,46,99,111,108,115,32,62,32,48,32,38,38,32,115,114,99,46,114,111,119,115,32,62,32,48,0,40,77,48,46,116,121,112,101,40,41,32,61,61,32,53,32,124,124,32,77,48,46,116,121,112,101,40,41,32,61,61,32,54,41,32,38,38,32,77,48,46,114,111,119,115,32,61,61,32,50,32,38,38,32,77,48,46,99,111,108,115,32,61,61,32,51,0,118,111,105,100,32,99,118,58,58,119,97,114,112,65,102,102,105,110,101,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,83,105,122,101,44,32,105,110,116,44,32,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,41,0,78,50,99,118,50,50,87,97,114,112,80,101,114,115,112,101,99,116,105,118,101,73,110,118,111,107,101,114,69,0,95,115,114,99,46,116,111,116,97,108,40,41,32,62,32,48,0,119,97,114,112,80,101,114,115,112,101,99,116,105,118,101,0,40,77,48,46,116,121,112,101,40,41,32,61,61,32,53,32,124,124,32,77,48,46,116,121,112,101,40,41,32,61,61,32,54,41,32,38,38,32,77,48,46,114,111,119,115,32,61,61,32,51,32,38,38,32,77,48,46,99,111,108,115,32,61,61,32,51,0,118,111,105,100,32,99,118,58,58,119,97,114,112,80,101,114,115,112,101,99,116,105,118,101,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,83,105,122,101,44,32,105,110,116,44,32,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,41,0,99,118,58,58,77,97,116,32,99,118,58,58,103,101,116,82,111,116,97,116,105,111,110,77,97,116,114,105,120,50,68,40,80,111,105,110,116,50,102,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,41,0,99,118,58,58,77,97,116,32,99,118,58,58,103,101,116,80,101,114,115,112,101,99,116,105,118,101,84,114,97,110,115,102,111,114,109,40,99,111,110,115,116,32,80,111,105,110,116,50,102,32,42,44,32,99,111,110,115,116,32,80,111,105,110,116,50,102,32,42,41,0,115,114,99,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,53,41,32,61,61,32,52,32,38,38,32,100,115,116,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,53,41,32,61,61,32,52,0,103,101,116,80,101,114,115,112,101,99,116,105,118,101,84,114,97,110,115,102,111,114,109,0,115,114,99,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,53,41,32,61,61,32,51,32,38,38,32,100,115,116,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,53,41,32,61,61,32,51,0,103,101,116,65,102,102,105,110,101,84,114,97,110,115,102,111,114,109,0,110,112,111,105,110,116,115,50,32,62,61,32,48,32,124,124,32,110,112,111,105,110,116,115,51,32,62,61,32,48,0,102,105,116,76,105,110,101,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,108,105,110,101,102,105,116,46,99,112,112,0,85,110,107,110,111,119,110,32,100,105,115,116,97,110,99,101,32,116,121,112,101,0,102,105,116,76,105,110,101,50,68,0,85,110,107,110,111,119,110,32,100,105,115,116,97,110,99,101,0,102,105,116,76,105,110,101,51,68,0,118,111,105,100,32,99,118,58,58,102,105,116,76,105,110,101,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,41,0,85,110,107,110,111,119,110,32,99,111,109,112,97,114,105,115,111,110,32,109,101,116,104,111,100,0,109,97,116,99,104,83,104,97,112,101,115,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,109,97,116,99,104,99,111,110,116,111,117,114,115,46,99,112,112,0,100,111,117,98,108,101,32,99,118,58,58,109,97,116,99,104,83,104,97,112,101,115,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,100,111,117,98,108,101,41,0,99,111,110,116,111,117,114,46,100,101,112,116,104,40,41,32,61,61,32,52,32,124,124,32,99,111,110,116,111,117,114,46,100,101,112,116,104,40,41,32,61,61,32,53,0,99,111,110,116,111,117,114,77,111,109,101,110,116,115,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,109,111,109,101,110,116,115,46,99,112,112,0,73,110,118,97,108,105,100,32,105,109,97,103,101,32,116,121,112,101,32,40,109,117,115,116,32,98,101,32,115,105,110,103,108,101,45,99,104,97,110,110,101,108,41,0,109,111,109,101,110,116,115,0,99,118,58,58,77,111,109,101,110,116,115,32,99,118,58,58,109,111,109,101,110,116,115,40,73,110,112,117,116,65,114,114,97,121,44,32,98,111,111,108,41,0,118,111,105,100,32,99,118,58,58,72,117,77,111,109,101,110,116,115,40,99,111,110,115,116,32,99,118,58,58,77,111,109,101,110,116,115,32,38,44,32,100,111,117,98,108,101,32,42,41,0,111,112,32,61,61,32,77,79,82,80,72,95,69,82,79,68,69,32,124,124,32,111,112,32,61,61,32,77,79,82,80,72,95,68,73,76,65,84,69,0,103,101,116,77,111,114,112,104,111,108,111,103,121,82,111,119,70,105,108,116,101,114,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,109,111,114,112,104,46,99,112,112,0,85,110,115,117,112,112,111,114,116,101,100,32,100,97,116,97,32,116,121,112,101,32,40,61,37,100,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+307212);allocate([102,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,103,101,116,77,111,114,112,104,111,108,111,103,121,67,111,108,117,109,110,70,105,108,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,97,110,99,104,111,114,46,105,110,115,105,100,101,40,82,101,99,116,40,48,44,32,48,44,32,107,115,105,122,101,46,119,105,100,116,104,44,32,107,115,105,122,101,46,104,101,105,103,104,116,41,41,0,110,111,114,109,97,108,105,122,101,65,110,99,104,111,114,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,102,105,108,116,101,114,101,110,103,105,110,101,46,104,112,112,0,103,101,116,77,111,114,112,104,111,108,111,103,121,70,105,108,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,95,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,48,0,77,111,114,112,104,70,105,108,116,101,114,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,100,101,112,116,104,32,61,61,32,48,32,124,124,32,100,101,112,116,104,32,61,61,32,50,32,124,124,32,100,101,112,116,104,32,61,61,32,51,32,124,124,32,100,101,112,116,104,32,61,61,32,53,32,124,124,32,100,101,112,116,104,32,61,61,32,54,0,99,114,101,97,116,101,77,111,114,112,104,111,108,111,103,121,70,105,108,116,101,114,0,115,104,97,112,101,32,61,61,32,77,79,82,80,72,95,82,69,67,84,32,124,124,32,115,104,97,112,101,32,61,61,32,77,79,82,80,72,95,67,82,79,83,83,32,124,124,32,115,104,97,112,101,32,61,61,32,77,79,82,80,72,95,69,76,76,73,80,83,69,0,103,101,116,83,116,114,117,99,116,117,114,105,110,103,69,108,101,109,101,110,116,0,118,111,105,100,32,99,118,58,58,109,111,114,112,104,79,112,40,105,110,116,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,41,0,118,111,105,100,32,99,118,58,58,101,114,111,100,101,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,41,0,118,111,105,100,32,99,118,58,58,100,105,108,97,116,101,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,41,0,109,111,114,112,104,111,108,111,103,121,69,120,0,117,110,107,110,111,119,110,32,109,111,114,112,104,111,108,111,103,105,99,97,108,32,111,112,101,114,97,116,105,111,110,0,118,111,105,100,32,99,118,58,58,109,111,114,112,104,111,108,111,103,121,69,120,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,73,110,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,41,0,98,111,114,100,101,114,84,121,112,101,32,33,61,32,66,79,82,68,69,82,95,67,79,78,83,84,65,78,84,0,112,121,114,68,111,119,110,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,112,121,114,97,109,105,100,115,46,99,112,112,0,33,95,115,114,99,46,101,109,112,116,121,40,41,0,112,121,114,68,111,119,110,95,0,115,115,105,122,101,46,119,105,100,116,104,32,62,32,48,32,38,38,32,115,115,105,122,101,46,104,101,105,103,104,116,32,62,32,48,32,38,38,32,115,116,100,58,58,97,98,115,40,100,115,105,122,101,46,119,105,100,116,104,42,50,32,45,32,115,115,105,122,101,46,119,105,100,116,104,41,32,60,61,32,50,32,38,38,32,115,116,100,58,58,97,98,115,40,100,115,105,122,101,46,104,101,105,103,104,116,42,50,32,45,32,115,115,105,122,101,46,104,101,105,103,104,116,41,32,60,61,32,50,0,118,111,105,100,32,99,118,58,58,112,121,114,68,111,119,110,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,99,111,110,115,116,32,83,105,122,101,32,38,44,32,105,110,116,41,0,98,111,114,100,101,114,84,121,112,101,32,61,61,32,66,79,82,68,69,82,95,68,69,70,65,85,76,84,0,112,121,114,85,112,0,115,116,100,58,58,97,98,115,40,100,115,105,122,101,46,119,105,100,116,104,32,45,32,115,115,105,122,101,46,119,105,100,116,104,42,50,41,32,61,61,32,100,115,105,122,101,46,119,105,100,116,104,32,37,32,50,32,38,38,32,115,116,100,58,58,97,98,115,40,100,115,105,122,101,46,104,101,105,103,104,116,32,45,32,115,115,105,122,101,46,104,101,105,103,104,116,42,50,41,32,61,61,32,100,115,105,122,101,46,104,101,105,103,104,116,32,37,32,50,0,112,121,114,85,112,95,0,118,111,105,100,32,99,118,58,58,112,121,114,85,112,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,99,111,110,115,116,32,83,105,122,101,32,38,44,32,105,110,116,41,0,40,100,115,116,95,119,105,100,116,104,32,42,32,100,115,116,95,104,101,105,103,104,116,32,62,32,48,41,32,124,124,32,40,105,110,118,95,115,99,97,108,101,95,120,32,62,32,48,32,38,38,32,105,110,118,95,115,99,97,108,101,95,121,32,62,32,48,41,0,114,101,115,105,122,101,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,114,101,115,105,122,101,46,99,112,112,0,100,115,105,122,101,46,97,114,101,97,40,41,32,62,32,48,0,102,117,110,99,32,33,61,32,48,0,102,117,110,99,32,33,61,32,48,32,38,38,32,99,110,32,60,61,32,52,0,85,110,107,110,111,119,110,32,105,110,116,101,114,112,111,108,97,116,105,111,110,32,109,101,116,104,111,100,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,100,100,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,100,100,102,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,107,115,105,122,101,32,60,61,32,77,65,88,95,69,83,73,90,69,0,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,102,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,102,102,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,115,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,115,102,102,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,116,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,116,102,102,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,104,105,115,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,104,105,115,78,83,95,49,49,70,105,120,101,100,80,116,67,97,115,116,73,105,104,76,105,50,50,69,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,100,100,102,76,105,49,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,100,100,102,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,102,102,102,76,105,49,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,102,102,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,115,102,102,76,105,49,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,115,102,102,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,116,102,102,76,105,49,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,116,102,102,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,104,105,115,76,105,50,48,52,56,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,104,105,115,78,83,95,49,49,70,105,120,101,100,80,116,67,97,115,116,73,105,104,76,105,50,50,69,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,100,100,102,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,100,100,102,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,102,102,102,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,102,102,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,115,102,102,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,115,102,102,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,116,102,102,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,116,102,102,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,104,105,115,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,104,105,115,78,83,95,49,49,70,105,120,101,100,80,116,67,97,115,116,73,105,104,76,105,50,50,69,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,100,100,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,102,102,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,115,102,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,116,102,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,104,102,69,69,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,100,100,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,100,100,69,69,69,69,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,102,102,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,102,102,69,69,69,69,0,99,110,32,61,61,32,52,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,115,102,78,83,95,49,55,82,101,115,105,122,101,65,114,101,97,70,97,115,116,86,101,99,73,115,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,115,115,69,69,69,69,69,69,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,116,102,78,83,95,49,55,82,101,115,105,122,101,65,114,101,97,70,97,115,116,86,101,99,73,116,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,116,116,69,69,69,69,69,69,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,104,105,78,83,95,49,55,82,101,115,105,122,101,65,114,101,97,70,97,115,116,86,101,99,73,104,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,104,104,69,69,69,69,69,69,0,78,50,99,118,49,53,114,101,115,105,122,101,78,78,73,110,118,111,107,101,114,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,114,101,115,105,122,101,40,105,110,116,44,32,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,115,115,105,122,101,46,119,105,100,116,104,32,62,32,48,32,38,38,32,115,115,105,122,101,46,104,101,105,103,104,116,32,62,32,48,0,100,115,105,122,101,46,97,114,101,97,40,41,32,62,32,48,32,124,124,32,40,105,110,118,95,115,99,97,108,101,95,120,32,62,32,48,32,38,38,32,105,110,118,95,115,99,97,108,101,95,121,32,62,32,48,41,0,118,111,105,100,32,99,118,58,58,114,101,115,105,122,101,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,83,105,122,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,100,115,116,46,116,121,112,101,40,41,0,99,118,82,101,115,105,122,101,0,111,114,105,101,110,116,97,116,105,111,110,32,33,61,32,48,0,114,111,116,97,116,105,110,103,67,97,108,105,112,101,114,115,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,114,111,116,99,97,108,105,112,101,114,115,46,99,112,112,0,99,118,58,58,82,111,116,97,116,101,100,82,101,99,116,32,99,118,58,58,109,105,110,65,114,101,97,82,101,99,116,40,73,110,112,117,116,65,114,114,97,121,41,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,51,41,45,49,41,32,60,60,32,51,41,41,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,40,40,40,52,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,119,97,116,101,114,115,104,101,100,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,115,101,103,109,101,110,116,97,116,105,111,110,46,99,112,112,0,115,114,99,46,115,105,122,101,40,41,32,61,61,32,100,115,116,46,115,105,122,101,40,41,0,118,111,105,100,32,99,118,58,58,119,97,116,101,114,115,104,101,100,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,41,0,99,111,117,110,116,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,53,32,124,124,32,100,101,112,116,104,32,61,61,32,52,41,0,109,105,110,69,110,99,108,111,115,105,110,103,67,105,114,99,108,101,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,115,104,97,112,101,100,101,115,99,114,46,99,112,112,0,118,111,105,100,32,99,118,58,58,109,105,110,69,110,99,108,111,115,105,110,103,67,105,114,99,108,101,40,73,110,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,50,102,32,38,44,32,102,108,111,97,116,32,38,41,0,97,114,99,76,101,110,103,116,104,0,100,111,117,98,108,101,32,99,118,58,58,97,114,99,76,101,110,103,116,104,40,73,110,112,117,116,65,114,114,97,121,44,32,98,111,111,108,41,0,110,112,111,105,110,116,115,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,53,32,124,124,32,100,101,112,116,104,32,61,61,32,52,41,0,99,111,110,116,111,117,114,65,114,101,97,0,100,111,117,98,108,101,32,99,118,58,58,99,111,110,116,111,117,114,65,114,101,97,40,73,110,112,117,116,65,114,114,97,121,44,32,98,111,111,108,41,0,110,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,53,32,124,124,32,100,101,112,116,104,32,61,61,32,52,41,0,102,105,116,69,108,108,105,112,115,101,0,84,104,101,114,101,32,115,104,111,117,108,100,32,98,101,32,97,116,32,108,101,97,115,116,32,53,32,112,111,105,110,116,115,32,116,111,32,102,105,116,32,116,104,101,32,101,108,108,105,112,115,101,0,99,118,58,58,82,111,116,97,116,101,100,82,101,99,116,32,99,118,58,58,102,105,116,69,108,108,105,112,115,101,40,73,110,112,117,116,65,114,114,97,121,41,0,112,111,105,110,116,83,101,116,66,111,117,110,100,105,110,103,82,101,99,116,0,105,109,103,46,100,101,112,116,104,40,41,32,60,61,32,49,32,38,38,32,105,109,103,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,109,97,115,107,66,111,117,110,100,105,110,103,82,101,99,116,0,99,118,58,58,82,101,99,116,32,99,118,58,58,98,111,117,110,100,105,110,103,82,101,99,116,40,73,110,112,117,116,65,114,114,97,121,41,0,85,110,115,117,112,112,111,114,116,101,100,32,115,101,113,117,101,110,99,101,32,116,121,112,101,0,99,118,66,111,117,110,100,105,110,103,82,101,99,116,0,84,104,101,32,105,109,97,103,101,47,109,97,116,114,105,120,32,102,111,114,109,97,116,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,116,104,101,32,102,117,110,99,116,105,111,110,0,40,40,40,40,115,117,109,84,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,61,61,32,40,40,40,40,115,114,99,84,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,0,103,101,116,82,111,119,83,117,109,70,105,108,116,101,114,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,115,109,111,111,116,104,46,99,112,112,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,115,111,117,114,99,101,32,102,111,114,109,97,116,32,40,61,37,100,41,44,32,97,110,100,32,98,117,102,102,101,114,32,102,111,114,109,97,116,32,40,61,37,100,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,100,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+317452);allocate([111,119,83,117,109,73,100,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,102,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,102,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,115,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,115,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,105,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,105,105,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,115,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,115,105,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,116,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,116,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,116,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,116,105,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,104,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,104,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,104,116,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,104,116,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,104,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,104,105,69,69,0,40,40,40,40,115,117,109,84,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,61,61,32,40,40,40,40,100,115,116,84,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,0,103,101,116,67,111,108,117,109,110,83,117,109,70,105,108,116,101,114,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,115,117,109,32,102,111,114,109,97,116,32,40,61,37,100,41,44,32,97,110,100,32,100,101,115,116,105,110,97,116,105,111,110,32,102,111,114,109,97,116,32,40,61,37,100,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,100,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,115,117,109,67,111,117,110,116,32,61,61,32,107,115,105,122,101,45,49,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,100,102,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,102,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,102,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,102,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,105,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,100,115,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,115,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,115,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,115,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,100,116,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,116,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,116,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,116,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,100,104,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,104,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,116,104,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,116,104,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,104,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,104,69,69,0,118,111,105,100,32,99,118,58,58,98,111,120,70,105,108,116,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,83,105,122,101,44,32,80,111,105,110,116,44,32,98,111,111,108,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,98,108,117,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,83,105,122,101,44,32,80,111,105,110,116,44,32,105,110,116,41,0,107,116,121,112,101,32,61,61,32,53,32,124,124,32,107,116,121,112,101,32,61,61,32,54,0,103,101,116,71,97,117,115,115,105,97,110,75,101,114,110,101,108,0,107,115,105,122,101,46,119,105,100,116,104,32,62,32,48,32,38,38,32,107,115,105,122,101,46,119,105,100,116,104,32,37,32,50,32,61,61,32,49,32,38,38,32,107,115,105,122,101,46,104,101,105,103,104,116,32,62,32,48,32,38,38,32,107,115,105,122,101,46,104,101,105,103,104,116,32,37,32,50,32,61,61,32,49,0,99,114,101,97,116,101,71,97,117,115,115,105,97,110,75,101,114,110,101,108,115,0,118,111,105,100,32,99,118,58,58,71,97,117,115,115,105,97,110,66,108,117,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,83,105,122,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,40,107,115,105,122,101,32,37,32,50,32,61,61,32,49,41,32,38,38,32,40,95,115,114,99,48,46,100,105,109,115,40,41,32,60,61,32,50,32,41,0,109,101,100,105,97,110,66,108,117,114,0,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,48,32,38,38,32,40,99,110,32,61,61,32,49,32,124,124,32,99,110,32,61,61,32,51,32,124,124,32,99,110,32,61,61,32,52,41,0,99,110,32,62,32,48,32,38,38,32,99,110,32,60,61,32,52,0,109,101,100,105,97,110,66,108,117,114,95,56,117,95,79,109,0,109,101,100,105,97,110,66,108,117,114,95,56,117,95,79,49,0,107,32,60,32,49,54,0,98,32,60,32,49,54,0,118,111,105,100,32,99,118,58,58,109,101,100,105,97,110,66,108,117,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,40,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,51,41,45,49,41,32,60,60,32,51,41,41,41,32,38,38,32,115,114,99,46,100,97,116,97,32,33,61,32,100,115,116,46,100,97,116,97,0,98,105,108,97,116,101,114,97,108,70,105,108,116,101,114,95,56,117,0,40,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,51,41,45,49,41,32,60,60,32,51,41,41,41,32,38,38,32,115,114,99,46,100,97,116,97,32,33,61,32,100,115,116,46,100,97,116,97,0,98,105,108,97,116,101,114,97,108,70,105,108,116,101,114,95,51,50,102,0,66,105,108,97,116,101,114,97,108,32,102,105,108,116,101,114,105,110,103,32,105,115,32,111,110,108,121,32,105,109,112,108,101,109,101,110,116,101,100,32,102,111,114,32,56,117,32,97,110,100,32,51,50,102,32,105,109,97,103,101,115,0,98,105,108,97,116,101,114,97,108,70,105,108,116,101,114,0,99,110,32,61,61,32,51,0,78,50,99,118,50,55,66,105,108,97,116,101,114,97,108,70,105,108,116,101,114,95,51,50,102,95,73,110,118,111,107,101,114,69,0,78,50,99,118,50,54,66,105,108,97,116,101,114,97,108,70,105,108,116,101,114,95,56,117,95,73,110,118,111,107,101,114,69,0,118,111,105,100,32,99,118,58,58,98,105,108,97,116,101,114,97,108,70,105,108,116,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,105,110,116,101,103,114,97,108,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,115,117,109,112,105,120,101,108,115,46,99,112,112,0,118,111,105,100,32,99,118,58,58,105,110,116,101,103,114,97,108,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,105,110,116,101,103,114,97,108,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,105,110,116,101,103,114,97,108,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,41,0,115,117,109,46,100,97,116,97,32,61,61,32,115,117,109,48,46,100,97,116,97,32,38,38,32,115,113,115,117,109,46,100,97,116,97,32,61,61,32,115,113,115,117,109,48,46,100,97,116,97,32,38,38,32,116,105,108,116,101,100,46,100,97,116,97,32,61,61,32,116,105,108,116,101,100,48,46,100,97,116,97,0,99,118,73,110,116,101,103,114,97,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,105,109,103,46,100,105,109,115,32,60,61,32,50,32,38,38,32,116,101,109,112,108,46,100,105,109,115,32,60,61,32,50,32,38,38,32,99,111,114,114,46,100,105,109,115,32,60,61,32,50,0,99,114,111,115,115,67,111,114,114,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,116,101,109,112,108,109,97,116,99,104,46,99,112,112,0,100,101,112,116,104,32,61,61,32,116,100,101,112,116,104,32,124,124,32,116,100,101,112,116,104,32,61,61,32,53,0,99,111,114,114,115,105,122,101,46,104,101,105,103,104,116,32,60,61,32,105,109,103,46,114,111,119,115,32,43,32,116,101,109,112,108,46,114,111,119,115,32,45,32,49,32,38,38,32,99,111,114,114,115,105,122,101,46,119,105,100,116,104,32,60,61,32,105,109,103,46,99,111,108,115,32,43,32,116,101,109,112,108,46,99,111,108,115,32,45,32,49,0,99,99,110,32,61,61,32,49,32,124,124,32,100,101,108,116,97,32,61,61,32,48,0,116,104,101,32,105,110,112,117,116,32,97,114,114,97,121,115,32,97,114,101,32,116,111,111,32,98,105,103,0,67,86,95,84,77,95,83,81,68,73,70,70,32,60,61,32,109,101,116,104,111,100,32,38,38,32,109,101,116,104,111,100,32,60,61,32,67,86,95,84,77,95,67,67,79,69,70,70,95,78,79,82,77,69,68,0,109,97,116,99,104,84,101,109,112,108,97,116,101,77,97,115,107,0,40,100,101,112,116,104,32,61,61,32,48,32,124,124,32,100,101,112,116,104,32,61,61,32,53,41,32,38,38,32,116,121,112,101,32,61,61,32,95,116,101,109,112,108,46,116,121,112,101,40,41,32,38,38,32,95,105,109,103,46,100,105,109,115,40,41,32,60,61,32,50,0,109,97,116,99,104,84,101,109,112,108,97,116,101,0,95,105,109,103,46,115,105,122,101,40,41,46,104,101,105,103,104,116,32,60,61,32,95,116,101,109,112,108,46,115,105,122,101,40,41,46,104,101,105,103,104,116,32,38,38,32,95,105,109,103,46,115,105,122,101,40,41,46,119,105,100,116,104,32,60,61,32,95,116,101,109,112,108,46,115,105,122,101,40,41,46,119,105,100,116,104,0,115,113,115,117,109,46,100,97,116,97,32,33,61,32,48,76,0,99,111,109,109,111,110,95,109,97,116,99,104,84,101,109,112,108,97,116,101,0,115,117,109,46,100,97,116,97,32,33,61,32,48,76,0,118,111,105,100,32,99,118,58,58,109,97,116,99,104,84,101,109,112,108,97,116,101,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,73,110,112,117,116,65,114,114,97,121,41,0,97,117,116,111,109,97,116,105,99,95,116,104,114,101,115,104,32,33,61,32,40,67,86,95,84,72,82,69,83,72,95,79,84,83,85,32,124,32,67,86,95,84,72,82,69,83,72,95,84,82,73,65,78,71,76,69,41,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,116,104,114,101,115,104,46,99,112,112,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,116,104,114,101,115,104,71,101,110,101,114,105,99,0,78,50,99,118,49,53,84,104,114,101,115,104,111,108,100,82,117,110,110,101,114,69,0,100,111,117,98,108,101,32,99,118,58,58,116,104,114,101,115,104,111,108,100,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,97,100,97,112,116,105,118,101,84,104,114,101,115,104,111,108,100,0,98,108,111,99,107,83,105,122,101,32,37,32,50,32,61,61,32,49,32,38,38,32,98,108,111,99,107,83,105,122,101,32,62,32,49,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,97,100,97,112,116,105,118,101,32,116,104,114,101,115,104,111,108,100,32,109,101,116,104,111,100,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,116,104,114,101,115,104,111,108,100,32,116,121,112,101,0,118,111,105,100,32,99,118,58,58,97,100,97,112,116,105,118,101,84,104,114,101,115,104,111,108,100,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,41,0,115,114,99,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,32,38,38,32,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,100,115,116,46,99,104,97,110,110,101,108,115,40,41,32,38,38,32,40,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,100,115,116,46,100,101,112,116,104,40,41,32,124,124,32,100,115,116,46,100,101,112,116,104,40,41,32,61,61,32,48,41,0,99,118,84,104,114,101,115,104,111,108,100,0,109,49,116,121,112,101,32,61,61,32,40,40,40,51,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,109,49,116,121,112,101,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,109,49,116,121,112,101,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,0,105,110,105,116,85,110,100,105,115,116,111,114,116,82,101,99,116,105,102,121,77,97,112,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,117,110,100,105,115,116,111,114,116,46,99,112,112,0,65,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,51,44,51,41,32,38,38,32,65,46,115,105,122,101,40,41,32,61,61,32,82,46,115,105,122,101,40,41,0,65,114,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,51,44,51,41,32,124,124,32,65,114,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,52,44,32,51,41,0,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,52,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,52,44,32,49,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,53,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,53,44,32,49,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,56,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,56,44,32,49,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,49,50,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,50,44,32,49,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,49,52,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,52,44,32,49,41,0,109,49,32,33,61,32,48,76,32,38,38,32,109,50,32,33,61,32,48,76,0,109,49,102,32,33,61,32,48,76,32,38,38,32,109,50,102,32,33,61,32,48,76,0,100,115,116,46,100,97,116,97,32,33,61,32,115,114,99,46,100,97,116,97,0,117,110,100,105,115,116,111,114,116,0,118,111,105,100,32,99,118,58,58,117,110,100,105,115,116,111,114,116,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,97,114,114,32,33,61,32,48,32,38,38,32,99,111,110,116,111,117,114,95,104,101,97,100,101,114,32,33,61,32,48,32,38,38,32,98,108,111,99,107,32,33,61,32,48,0,99,118,80,111,105,110,116,83,101,113,70,114,111,109,77,97,116,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,117,116,105,108,115,46,99,112,112,0,73,110,112,117,116,32,97,114,114,97,121,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,109,97,116,114,105,120,0,84,104,101,32,109,97,116,114,105,120,32,99,97,110,32,110,111,116,32,98,101,32,99,111,110,118,101,114,116,101,100,32,116,111,32,112,111,105,110,116,32,115,101,113,117,101,110,99,101,32,98,101,99,97,117,115,101,32,111,102,32,105,110,97,112,112,114,111,112,114,105,97,116,101,32,101,108,101,109,101,110,116,32,116,121,112,101,0,84,104,101,32,109,97,116,114,105,120,32,99,111,110,118,101,114,116,101,100,32,116,111,32,112,111,105,110,116,32,115,101,113,117,101,110,99,101,32,109,117,115,116,32,98,101,32,49,45,100,105,109,101,110,115,105,111,110,97,108,32,97,110,100,32,99,111,110,116,105,110,117,111,117,115,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,54,70,101,97,116,117,114,101,69,118,97,108,117,97,116,111,114,57,83,99,97,108,101,68,97,116,97,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,56,95,69,69,69,69,0,118,105,114,116,117,97,108,32,98,111,111,108,32,99,118,58,58,70,101,97,116,117,114,101,69,118,97,108,117,97,116,111,114,58,58,115,101,116,73,109,97,103,101,40,73,110,112,117,116,65,114,114,97,121,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,102,108,111,97,116,62,32,38,41,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,111,98,106,100,101,116,101,99,116,47,115,114,99,47,99,97,115,99,97,100,101,100,101,116,101,99,116,46,99,112,112,0,78,50,99,118,49,54,70,101,97,116,117,114,101,69,118,97,108,117,97,116,111,114,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,97,97,114,69,118,97,108,117,97,116,111,114,58,58,99,111,109,112,117,116,101,79,112,116,70,101,97,116,117,114,101,115,40,41,0,115,113,115,117,109,46,117,32,61,61,32,117,32,38,38,32,115,113,115,117,109,46,115,105,122,101,40,41,32,61,61,32,115,46,115,122,105,32,38,38,32,115,113,115,117,109,46,116,121,112,101,40,41,61,61,52,0,99,111,109,112,117,116,101,67,104,97,110,110,101,108,115,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,97,97,114,69,118,97,108,117,97,116,111,114,58,58,99,111,109,112,117,116,101,67,104,97,110,110,101,108,115,40,105,110,116,44,32,73,110,112,117,116,65,114,114,97,121,41,0,48,32,60,61,32,115,99,97,108,101,73,100,120,32,38,38,32,115,99,97,108,101,73,100,120,32,60,32,40,105,110,116,41,115,99,97,108,101,68,97,116,97,45,62,115,105,122,101,40,41,0,103,101,116,83,99,97,108,101,68,97,116,97,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,111,98,106,100,101,116,101,99,116,47,115,114,99,47,99,97,115,99,97,100,101,100,101,116,101,99,116,46,104,112,112,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,51,72,97,97,114,69,118,97,108,117,97,116,111,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,110,32,62,32,48,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,51,72,97,97,114,69,118,97,108,117,97,116,111,114,49,48,79,112,116,70,101,97,116,117,114,101,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,56,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,51,72,97,97,114,69,118,97,108,117,97,116,111,114,55,70,101,97,116,117,114,101,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,56,95,69,69,69,69,0,78,50,99,118,49,51,72,97,97,114,69,118,97,108,117,97,116,111,114,69,0,115,101,116,87,105,110,100,111,119,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,76,66,80,69,118,97,108,117,97,116,111,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,50,76,66,80,69,118,97,108,117,97,116,111,114,49,48,79,112,116,70,101,97,116,117,114,101,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,56,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,50,76,66,80,69,118,97,108,117,97,116,111,114,55,70,101,97,116,117,114,101,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,56,95,69,69,69,69,0,114,101,99,116,0,78,50,99,118,49,50,76,66,80,69,118,97,108,117,97,116,111,114,69,0,115,99,97,108,101,70,97,99,116,111,114,32,62,32,49,32,38,38,32,95,105,109,97,103,101,46,100,101,112,116,104,40,41,32,61,61,32,48,0,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,0,118,111,105,100,32,99,118,58,58,103,114,111,117,112,82,101,99,116,97,110,103,108,101,115,40,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,105,110,116,44,32,100,111,117,98,108,101,41,0,110,111,100,101,115,91,114,111,111,116,93,91,80,65,82,69,78,84,93,32,60,32,48,0,112,97,114,116,105,116,105,111,110,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,111,112,101,114,97,116,105,111,110,115,46,104,112,112,0,118,111,105,100,32,99,118,58,58,103,114,111,117,112,82,101,99,116,97,110,103,108,101,115,40,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,42,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,42,41,0,118,111,105,100,32,99,118,58,58,103,114,111,117,112,82,101,99,116,97,110,103,108,101,115,40,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,38,44,32,105,110,116,44,32,100,111,117,98,108,101,41,0,105,110,116,32,99,118,58,58,112,114,101,100,105,99,116,67,97,116,101,103,111,114,105,99,97,108,40,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,32,38,44,32,80,116,114,60,99,118,58,58,70,101,97,116,117,114,101,69,118,97,108,117,97,116,111,114,62,32,38,44,32,100,111,117,98,108,101,32,38,41,32,91,70,69,118,97,108,32,61,32,99,118,58,58,76,66,80,69,118,97,108,117,97,116,111,114,93,0,105,110,116,32,99,118,58,58,112,114,101,100,105,99,116,79,114,100,101,114,101,100,40,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,32,38,44,32,80,116,114,60,99,118,58,58,70,101,97,116,117,114,101,69,118,97,108,117,97,116,111,114,62,32,38,44,32,100,111,117,98,108,101,32,38,41,32,91,70,69,118,97,108,32,61,32,99,118,58,58,72,97,97,114,69,118,97,108,117,97,116,111,114,93,0,33,99,97,115,99,97,100,101,46,100,97,116,97,46,115,116,117,109,112,115,46,101,109,112,116,121,40,41,0,112,114,101,100,105,99,116,67,97,116,101,103,111,114,105,99,97,108,83,116,117,109,112,0,105,110,116,32,99,118,58,58,112,114,101,100,105,99,116,67,97,116,101,103,111,114,105,99,97,108,83,116,117,109,112,40,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,32,38,44,32,80,116,114,60,99,118,58,58,70,101,97,116,117,114,101,69,118,97,108,117,97,116,111,114,62,32,38,44,32,100,111,117,98,108,101,32,38,41,32,91,70,69,118,97,108,32,61,32,99,118,58,58,76,66,80,69,118,97,108,117,97,116,111,114,93,0,112,114,101,100,105,99,116,79,114,100,101,114,101,100,83,116,117,109,112,0,105,110,116,32,99,118,58,58,112,114,101,100,105,99,116,79,114,100,101,114,101,100,83,116,117,109,112,40,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,32,38,44,32,80,116,114,60,99,118,58,58,70,101,97,116,117,114,101,69,118,97,108,117,97,116,111,114,62,32,38,44,32,100,111,117,98,108,101,32,38,41,32,91,70,69,118,97,108,32,61,32,99,118,58,58,72,97,97,114,69,118,97,108,117,97,116,111,114,93,0,105,110,116,32,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,58,58,114,117,110,65,116,40,80,116,114,60,99,118,58,58,70,101,97,116,117,114,101,69,118,97,108,117,97,116,111,114,62,32,38,44,32,80,111,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,32,38,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,110,118,111,107,101,114,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,0,78,50,99,118,50,52,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,110,118,111,107,101,114,69,0,118,111,105,100,32,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,58,58,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,78,111,71,114,111,117,112,105,110,103,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,38,44,32,100,111,117,98,108,101,44,32,83,105,122,101,44,32,83,105,122,101,44,32,98,111,111,108,41,0,33,95,115,101,113,32,124,124,32,95,115,101,113,45,62,101,108,101,109,95,115,105,122,101,32,61,61,32,115,105,122,101,111,102,40,95,84,112,41,0,83,101,113,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,99,111,114,101,95,99,46,104,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,58,58,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,38,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,83,105,122,101,44,32,83,105,122,101,44,32,98,111,111,108,41,0,115,99,97,108,101,70,97,99,116,111,114,32,62,32,49,32,38,38,32,105,109,97,103,101,46,100,101,112,116,104,40,41,32,61,61,32,48,0,118,111,105,100,32,99,118,58,58,103,114,111,117,112,82,101,99,116,97,110,103,108,101,115,40,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,44,32,105,110,116,44,32,100,111,117,98,108,101,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,58,58,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,83,105,122,101,44,32,83,105,122,101,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,58,58,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,83,105,122,101,44,32,83,105,122,101,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,50,51,67,118,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,102,101,97,116,117,114,101,115,0,115,116,97,103,101,84,121,112,101,0,66,79,79,83,84,0,102,101,97,116,117,114,101,84,121,112,101,0,72,65,65,82,0,76,66,80,0,72,79,71,0,72,79,71,32,99,97,115,99,97,100,101,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,51,46,48,0,119,105,100,116,104,0,104,101,105,103,104,116,0,111,114,105,103],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+327692);allocate([87,105,110,83,105,122,101,46,104,101,105,103,104,116,32,62,32,48,32,38,38,32,111,114,105,103,87,105,110,83,105,122,101,46,119,105,100,116,104,32,62,32,48,0,102,101,97,116,117,114,101,80,97,114,97,109,115,0,109,97,120,67,97,116,67,111,117,110,116,0,115,116,97,103,101,84,104,114,101,115,104,111,108,100,0,119,101,97,107,67,108,97,115,115,105,102,105,101,114,115,0,105,110,116,101,114,110,97,108,78,111,100,101,115,0,108,101,97,102,86,97,108,117,101,115,0,78,50,99,118,50,49,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,69,0,78,50,99,118,50,49,66,97,115,101,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,69,0,118,111,105,100,32,99,118,58,58,103,114,111,117,112,82,101,99,116,97,110,103,108,101,115,95,109,101,97,110,115,104,105,102,116,40,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,38,44,32,100,111,117,98,108,101,44,32,83,105,122,101,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,49,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,97,45,62,115,105,122,101,40,41,32,61,61,32,110,0,99,108,105,112,79,98,106,101,99,116,115,0,98,45,62,115,105,122,101,40,41,32,61,61,32,110,0,118,111,105,100,32,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,58,58,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,83,105,122,101,44,32,83,105,122,101,41,0,118,111,105,100,32,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,58,58,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,83,105,122,101,44,32,83,105,122,101,41,0,118,111,105,100,32,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,58,58,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,38,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,83,105,122,101,44,32,83,105,122,101,44,32,98,111,111,108,41,0,111,112,101,110,99,118,45,104,97,97,114,45,99,108,97,115,115,105,102,105,101,114,0,78,117,109,98,101,114,32,111,102,32,115,116,97,103,101,115,32,115,104,111,117,108,100,32,98,101,32,112,111,115,105,116,105,118,101,0,105,99,118,67,114,101,97,116,101,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,111,98,106,100,101,116,101,99,116,47,115,114,99,47,104,97,97,114,46,99,112,112,0,115,105,122,101,0,115,116,97,103,101,115,0,115,116,97,103,101,32,37,100,0,116,114,101,101,115,0,116,114,101,101,32,37,100,0,110,111,100,101,32,37,100,0,114,111,111,116,32,110,111,100,101,0,102,101,97,116,117,114,101,0,114,101,99,116,115,0,116,105,108,116,101,100,0,116,104,114,101,115,104,111,108,100,0,108,101,102,116,95,110,111,100,101,0,108,101,102,116,95,118,97,108,0,114,105,103,104,116,95,110,111,100,101,0,114,105,103,104,116,95,118,97,108,0,115,116,97,103,101,95,116,104,114,101,115,104,111,108,100,0,112,97,114,101,110,116,0,110,101,120,116,0,73,110,118,97,108,105,100,32,115,116,97,103,101,115,32,110,111,100,101,0,105,99,118,82,101,97,100,72,97,97,114,67,108,97,115,115,105,102,105,101,114,0,115,105,122,101,32,110,111,100,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,101,113,117,101,110,99,101,46,0,73,110,118,97,108,105,100,32,115,105,122,101,32,110,111,100,101,58,32,119,105,100,116,104,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,0,73,110,118,97,108,105,100,32,115,105,122,101,32,110,111,100,101,58,32,104,101,105,103,104,116,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,0,73,110,118,97,108,105,100,32,115,116,97,103,101,32,37,100,0,84,114,101,101,115,32,110,111,100,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,101,113,117,101,110,99,101,46,32,40,115,116,97,103,101,32,37,100,41,0,84,114,101,101,32,110,111,100,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,101,113,117,101,110,99,101,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,41,0,84,114,101,101,32,110,111,100,101,32,37,100,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,109,97,112,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,41,0,70,101,97,116,117,114,101,32,110,111,100,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,109,97,112,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,82,101,99,116,115,32,110,111,100,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,101,113,117,101,110,99,101,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,82,101,99,116,32,37,100,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,101,113,117,101,110,99,101,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,120,32,99,111,111,114,100,105,110,97,116,101,32,109,117,115,116,32,98,101,32,110,111,110,45,110,101,103,97,116,105,118,101,32,105,110,116,101,103,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,44,32,114,101,99,116,32,37,100,41,0,121,32,99,111,111,114,100,105,110,97,116,101,32,109,117,115,116,32,98,101,32,110,111,110,45,110,101,103,97,116,105,118,101,32,105,110,116,101,103,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,44,32,114,101,99,116,32,37,100,41,0,119,105,100,116,104,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,32,97,110,100,32,40,120,32,43,32,119,105,100,116,104,41,32,109,117,115,116,32,110,111,116,32,101,120,99,101,101,100,32,119,105,110,100,111,119,32,119,105,100,116,104,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,44,32,114,101,99,116,32,37,100,41,0,104,101,105,103,104,116,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,32,97,110,100,32,40,121,32,43,32,104,101,105,103,104,116,41,32,109,117,115,116,32,110,111,116,32,101,120,99,101,101,100,32,119,105,110,100,111,119,32,104,101,105,103,104,116,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,44,32,114,101,99,116,32,37,100,41,0,119,101,105,103,104,116,32,109,117,115,116,32,98,101,32,114,101,97,108,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,44,32,114,101,99,116,32,37,100,41,0,116,105,108,116,101,100,32,109,117,115,116,32,98,101,32,48,32,111,114,32,49,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,116,104,114,101,115,104,111,108,100,32,109,117,115,116,32,98,101,32,114,101,97,108,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,108,101,102,116,32,110,111,100,101,32,109,117,115,116,32,98,101,32,118,97,108,105,100,32,110,111,100,101,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,108,101,102,116,32,110,111,100,101,32,111,114,32,108,101,102,116,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,115,112,101,99,105,102,105,101,100,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,108,101,102,116,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,114,101,97,108,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,84,114,101,101,32,115,116,114,117,99,116,117,114,101,32,105,115,32,98,114,111,107,101,110,58,32,116,111,111,32,109,97,110,121,32,118,97,108,117,101,115,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,114,105,103,104,116,32,110,111,100,101,32,109,117,115,116,32,98,101,32,118,97,108,105,100,32,110,111,100,101,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,114,105,103,104,116,32,110,111,100,101,32,111,114,32,114,105,103,104,116,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,115,112,101,99,105,102,105,101,100,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,114,105,103,104,116,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,114,101,97,108,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,84,114,101,101,32,115,116,114,117,99,116,117,114,101,32,105,115,32,98,114,111,107,101,110,58,32,116,111,111,32,102,101,119,32,118,97,108,117,101,115,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,41,0,115,116,97,103,101,32,116,104,114,101,115,104,111,108,100,32,109,117,115,116,32,98,101,32,114,101,97,108,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,41,0,112,97,114,101,110,116,32,109,117,115,116,32,98,101,32,105,110,116,101,103,101,114,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,41,0,110,101,120,116,32,109,117,115,116,32,98,101,32,105,110,116,101,103,101,114,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,41,0,73,110,118,97,108,105,100,32,99,108,97,115,115,105,102,105,101,114,32,112,111,105,110,116,101,114,0,99,118,83,101,116,73,109,97,103,101,115,70,111,114,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,0,83,99,97,108,101,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,0,67,79,73,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,65,108,108,32,105,110,116,101,103,114,97,108,32,105,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,0,79,110,108,121,32,40,51,50,115,44,32,54,52,102,44,32,51,50,115,41,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,40,115,117,109,44,115,113,115,117,109,44,116,105,108,116,101,100,95,115,117,109,41,32,102,111,114,109,97,116,115,32,105,115,32,97,108,108,111,119,101,100,0,83,117,109,32,97,110,100,32,116,105,108,116,101,100,95,115,117,109,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,116,114,105,100,101,32,40,115,116,101,112,44,32,119,105,100,116,104,83,116,101,112,41,0,105,99,118,67,114,101,97,116,101,72,105,100,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,0,104,105,100,95,99,97,115,99,97,100,101,32,104,97,115,32,98,101,101,110,32,97,108,114,101,97,100,121,32,99,114,101,97,116,101,100,0,78,101,103,97,116,105,118,101,32,110,117,109,98,101,114,32,111,102,32,99,97,115,99,97,100,101,32,115,116,97,103,101,115,0,104,101,97,100,101,114,32,111,102,32,116,104,101,32,115,116,97,103,101,32,99,108,97,115,115,105,102,105,101,114,32,35,37,100,32,105,115,32,105,110,118,97,108,105,100,32,40,104,97,115,32,110,117,108,108,32,112,111,105,110,116,101,114,115,32,111,114,32,110,111,110,45,112,111,115,105,116,105,118,101,32,99,108,97,115,115,102,105,101,114,32,99,111,117,110,116,41,0,114,101,99,116,97,110,103,108,101,32,35,37,100,32,111,102,32,116,104,101,32,99,108,97,115,115,105,102,105,101,114,32,35,37,100,32,111,102,32,116,104,101,32,115,116,97,103,101,32,99,108,97,115,115,105,102,105,101,114,32,35,37,100,32,105,115,32,110,111,116,32,105,110,115,105,100,101,32,116,104,101,32,114,101,102,101,114,101,110,99,101,32,40,111,114,105,103,105,110,97,108,41,32,99,97,115,99,97,100,101,32,119,105,110,100,111,119,0,73,110,118,97,108,105,100,32,99,97,115,99,97,100,101,32,112,111,105,110,116,101,114,0,99,118,82,117,110,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,83,117,109,0,72,105,100,100,101,110,32,99,97,115,99,97,100,101,32,104,97,115,32,110,111,116,32,98,101,101,110,32,99,114,101,97,116,101,100,46,10,85,115,101,32,99,118,83,101,116,73,109,97,103,101,115,70,111,114,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,0,105,110,116,32,99,118,82,117,110,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,40,99,111,110,115,116,32,67,118,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,32,42,44,32,67,118,80,111,105,110,116,44,32,105,110,116,41,0,73,110,118,97,108,105,100,32,99,108,97,115,115,105,102,105,101,114,32,99,97,115,99,97,100,101,0,99,118,72,97,97,114,68,101,116,101,99,116,79,98,106,101,99,116,115,70,111,114,82,79,67,0,78,117,108,108,32,115,116,111,114,97,103,101,32,112,111,105,110,116,101,114,0,79,110,108,121,32,56,45,98,105,116,32,105,109,97,103,101,115,32,97,114,101,32,115,117,112,112,111,114,116,101,100,0,115,99,97,108,101,32,102,97,99,116,111,114,32,109,117,115,116,32,98,101,32,62,32,49,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,97,97,114,68,101,116,101,99,116,79,98,106,101,99,116,115,95,83,99,97,108,101,67,97,115,99,97,100,101,95,73,110,118,111,107,101,114,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,0,78,50,99,118,51,56,72,97,97,114,68,101,116,101,99,116,79,98,106,101,99,116,115,95,83,99,97,108,101,67,97,115,99,97,100,101,95,73,110,118,111,107,101,114,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,97,97,114,68,101,116,101,99,116,79,98,106,101,99,116,115,95,83,99,97,108,101,73,109,97,103,101,95,73,110,118,111,107,101,114,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,0,78,50,99,118,51,54,72,97,97,114,68,101,116,101,99,116,79,98,106,101,99,116,115,95,83,99,97,108,101,73,109,97,103,101,95,73,110,118,111,107,101,114,69,0,67,118,83,101,113,32,42,99,118,72,97,97,114,68,101,116,101,99,116,79,98,106,101,99,116,115,70,111,114,82,79,67,40,99,111,110,115,116,32,67,118,65,114,114,32,42,44,32,67,118,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,32,42,44,32,67,118,77,101,109,83,116,111,114,97,103,101,32,42,44,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,38,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,67,118,83,105,122,101,44,32,67,118,83,105,122,101,44,32,98,111,111,108,41,0,78,50,99,118,56,72,79,71,67,97,99,104,101,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,79,71,67,111,110,102,73,110,118,111,107,101,114,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,111,98,106,100,101,116,101,99,116,47,115,114,99,47,104,111,103,46,99,112,112,0,78,50,99,118,49,52,72,79,71,67,111,110,102,73,110,118,111,107,101,114,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,79,71,68,101,115,99,114,105,112,116,111,114,58,58,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,82,79,73,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,99,118,58,58,82,101,99,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,68,101,116,101,99,116,105,111,110,82,79,73,62,32,38,44,32,100,111,117,98,108,101,44,32,105,110,116,41,32,99,111,110,115,116,0,112,116,46,120,32,37,32,99,97,99,104,101,83,116,114,105,100,101,46,119,105,100,116,104,32,61,61,32,48,32,38,38,32,112,116,46,121,32,37,32,99,97,99,104,101,83,116,114,105,100,101,46,104,101,105,103,104,116,32,61,61,32,48,0,103,101,116,66,108,111,99,107,0,98,108,111,99,107,83,105,122,101,46,119,105,100,116,104,32,37,32,99,101,108,108,83,105,122,101,46,119,105,100,116,104,32,61,61,32,48,32,38,38,32,98,108,111,99,107,83,105,122,101,46,104,101,105,103,104,116,32,37,32,99,101,108,108,83,105,122,101,46,104,101,105,103,104,116,32,61,61,32,48,0,103,101,116,68,101,115,99,114,105,112,116,111,114,83,105,122,101,0,40,119,105,110,83,105,122,101,46,119,105,100,116,104,32,45,32,98,108,111,99,107,83,105,122,101,46,119,105,100,116,104,41,32,37,32,98,108,111,99,107,83,116,114,105,100,101,46,119,105,100,116,104,32,61,61,32,48,32,38,38,32,40,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,45,32,98,108,111,99,107,83,105,122,101,46,104,101,105,103,104,116,41,32,37,32,98,108,111,99,107,83,116,114,105,100,101,46,104,101,105,103,104,116,32,61,61,32,48,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,79,71,68,101,115,99,114,105,112,116,111,114,58,58,100,101,116,101,99,116,82,79,73,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,99,118,58,58,80,111,105,110,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,99,118,58,58,80,111,105,110,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,38,44,32,100,111,117,98,108,101,44,32,99,118,58,58,83,105,122,101,44,32,99,118,58,58,83,105,122,101,41,32,99,111,110,115,116,0,105,109,103,46,116,121,112,101,40,41,32,61,61,32,48,32,124,124,32,105,109,103,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,51,41,45,49,41,32,60,60,32,51,41,41,0,99,111,109,112,117,116,101,71,114,97,100,105,101,110,116,0,40,117,110,115,105,103,110,101,100,41,104,105,100,120,32,60,32,40,117,110,115,105,103,110,101,100,41,110,98,105,110,115,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,79,71,68,101,115,99,114,105,112,116,111,114,58,58,99,111,109,112,117,116,101,71,114,97,100,105,101,110,116,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,99,118,58,58,77,97,116,32,38,44,32,99,118,58,58,77,97,116,32,38,44,32,83,105,122,101,44,32,83,105,122,101,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,79,71,68,101,115,99,114,105,112,116,111,114,58,58,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,100,111,117,98,108,101,44,32,83,105,122,101,44,32,83,105,122,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,98,111,111,108,41,32,99,111,110,115,116,0,114,101,99,116,76,105,115,116,46,115,105,122,101,40,41,32,61,61,32,119,101,105,103,104,116,115,46,115,105,122,101,40,41,0,103,114,111,117,112,82,101,99,116,97,110,103,108,101,115,0,118,111,105,100,32,99,118,58,58,72,79,71,68,101,115,99,114,105,112,116,111,114,58,58,103,114,111,117,112,82,101,99,116,97,110,103,108,101,115,40,115,116,100,58,58,118,101,99,116,111,114,60,99,118,58,58,82,101,99,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,38,44,32,105,110,116,44,32,100,111,117,98,108,101,41,32,99,111,110,115,116,0,78,50,99,118,49,48,72,79,71,73,110,118,111,107,101,114,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,79,71,68,101,115,99,114,105,112,116,111,114,58,58,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,38,44,32,100,111,117,98,108,101,44,32,83,105,122,101,44,32,83,105,122,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,98,111,111,108,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,79,71,68,101,115,99,114,105,112,116,111,114,58,58,100,101,116,101,99,116,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,80,111,105,110,116,62,32,38,44,32,100,111,117,98,108,101,44,32,83,105,122,101,44,32,83,105,122,101,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,80,111,105,110,116,62,32,38,41,32,99,111,110,115,116,0,112,116,48,46,120,32,37,32,99,97,99,104,101,83,116,114,105,100,101,46,119,105,100,116,104,32,61,61,32,48,32,38,38,32,112,116,48,46,121,32,37,32,99,97,99,104,101,83,116,114,105,100,101,46,104,101,105,103,104,116,32,61,61,32,48,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,79,71,68,101,115,99,114,105,112,116,111,114,58,58,100,101,116,101,99,116,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,80,111,105,110,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,38,44,32,100,111,117,98,108,101,44,32,83,105,122,101,44,32,83,105,122,101,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,80,111,105,110,116,62,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,79,71,68,101,115,99,114,105,112,116,111,114,58,58,99,111,109,112,117,116,101,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,102,108,111,97,116,62,32,38,44,32,83,105,122,101,44,32,83,105,122,101,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,80,111,105,110,116,62,32,38,41,32,99,111,110,115,116,0,123,111,112,101,110,99,118,45,111,98,106,101,99,116,45,100,101,116,101,99,116,111,114,45,104,111,103,0,119,105,110,83,105,122,101,0,98,108,111,99,107,83,105,122,101,0,98,108,111,99,107,83,116,114,105,100,101,0,110,98,105,110,115,0,100,101,114,105,118,65,112,101,114,116,117,114,101,0,104,105,115,116,111,103,114,97,109,78,111,114,109,84,121,112,101,0,76,50,72,121,115,84,104,114,101,115,104,111,108,100,0,103,97,109,109,97,67,111,114,114,101,99,116,105,111,110,0,110,108,101,118,101,108,115,0,115,105,103,110,101,100,71,114,97,100,105,101,110,116,0,83,86,77,68,101,116,101,99,116,111,114,0,99,101,108,108,83,105,122,101,0,119,105,110,83,105,103,109,97,0,99,104,101,99,107,68,101,116,101,99,116,111,114,83,105,122,101,40,41,0,115,101,116,83,86,77,68,101,116,101,99,116,111,114,0,78,50,99,118,49,51,72,79,71,68,101,115,99,114,105,112,116,111,114,69,0,111,112,101,110,99,118,45,111,98,106,101,99,116,45,100,101,116,101,99,116,111,114,45,104,111,103,0,102,114,97,109,101,84,121,112,101,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,102,114,97,109,101,84,121,112,101,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,51,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,102,114,97,109,101,84,121,112,101,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,102,114,97,109,101,84,121,112,101,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,51,41,45,49,41,32,60,60,32,51,41,41,0,103,101,116,66,97,99,107,103,114,111,117,110,100,73,109,97,103,101,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,98,103,102,103,95,103,97,117,115,115,109,105,120,50,46,99,112,112,0,118,111,105,100,32,99,118,58,58,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,73,109,112,108,58,58,103,101,116,66,97,99,107,103,114,111,117,110,100,73,109,97,103,101,95,105,110,116,101,114,110,40,79,117,116,112,117,116,65,114,114,97,121,41,32,99,111,110,115,116,32,91,84,32,61,32,102,108,111,97,116,44,32,67,78,32,61,32,51,93,0,118,111,105,100,32,99,118,58,58,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,73,109,112,108,58,58,103,101,116,66,97,99,107,103,114,111,117,110,100,73,109,97,103,101,95,105,110,116,101,114,110,40,79,117,116,112,117,116,65,114,114,97,121,41,32,99,111,110,115,116,32,91,84,32,61,32,102,108,111,97,116,44,32,67,78,32,61,32,49,93,0,118,111,105,100,32,99,118,58,58,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,73,109,112,108,58,58,103,101,116,66,97,99,107,103,114,111,117,110,100,73,109,97,103,101,95,105,110,116,101,114,110,40,79,117,116,112,117,116,65,114,114,97,121,41,32,99,111,110,115,116,32,91,84,32,61,32,117,110,115,105,103,110,101,100,32,99,104,97,114,44,32,67,78,32,61,32,51,93,0,118,111,105,100,32,99,118,58,58,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,73,109,112,108,58,58,103,101,116,66,97,99,107,103,114,111,117,110,100,73,109,97,103,101,95,105,110,116,101,114,110,40,79,117,116,112,117,116,65,114,114,97,121,41,32,99,111,110,115,116,32,91,84,32,61,32,117,110,115,105,103,110,101,100,32,99,104,97,114,44,32,67,78,32,61,32,49,93,0,108,101,97,114,110,105,110,103,82,97,116,101,32,62,61,32,48,0,97,112,112,108,121,0,78,50,99,118,49,49,77,79,71,50,73,110,118,111,107,101,114,69,0,110,99,104,97,110,110,101,108,115,32,60,61,32,53,49,50,0,105,110,105,116,105,97,108,105,122,101,0,110,109,105,120,116,117,114,101,115,32,60,61,32,50,53,53,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,73,109,112,108,58,58,97,112,112,108,121,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,41,0,110,97,109,101,0,40,83,116,114,105,110,103,41,102,110,91,34,110,97,109,101,34,93,32,61,61,32,110,97,109,101,95,0,114,101,97,100,0,104,105,115,116,111,114,121,0,110,109,105,120,116,117,114,101,115,0,98,97,99,107,103,114,111,117,110,100,82,97,116,105,111,0,118,97,114,84,104,114,101,115,104,111,108,100,0,118,97,114,84,104,114,101,115,104,111,108,100,71,101,110,0,118,97,114,73,110,105,116,0,118,97,114,77,105,110,0,118,97,114,77,97,120,0,99,111,109,112,108,101,120,105,116,121,82,101,100,117,99,116,105,111,110,84,104,114,101,115,104,111,108,100,0,100,101,116,101,99,116,83,104,97,100,111,119,115,0,115,104,97,100,111,119,86,97,108,117,101,0,115,104,97,100,111,119,84,104,114,101,115,104,111,108,100,0,78,50,99,118,50,56,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,56,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,46,77,79,71,50,0,99,110,32,61,61,32,49,0,109,101,97,110,83,104,105,102,116,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,99,97,109,115,104,105,102,116,46,99,112,112,0,73,110,112,117,116,32,119,105,110,100,111,119,32,104,97,115,32,110,111,110,45,112,111,115,105,116,105,118,101,32,115,105,122,101,115,0,105,110,116,32,99,118,58,58,109,101,97,110,83,104,105,102,116,40,73,110,112,117,116,65,114,114,97,121,44,32,82,101,99,116,32,38,44,32,99,118,58,58,84,101,114,109,67,114,105,116,101,114,105,97,41,0,99,118,58,58,82,111,116,97,116,101,100,82,101,99,116,32,99,118,58,58,67,97,109,83,104,105,102,116,40,73,110,112,117,116,65,114,114,97,121,44,32,82,101,99,116,32,38,44,32,99,118,58,58,84,101,114,109,67,114,105,116,101,114,105,97,41,0,33,115,114,99,46,101,109,112,116,121,40,41,0,102,105,110,100,84,114,97,110,115,102,111,114,109,69,67,67,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,101,99,99,46,99,112,112,0,33,100,115,116,46,101,109,112,116,121,40,41,0,73,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,56,117,67,49,32,111,114,32,51,50,102,67,49,32,116,121,112,101,0,119,97,114,112,77,97,116,114,105,120,32,109,117,115,116,32,98,101,32,115,105,110,103,108,101,45,99,104,97,110,110,101,108,32,102,108,111,97,116,105,110,103,45,112,111,105,110,116,32,109,97,116,114,105,120,0,109,97,112,46,99,111,108,115,32,61,61,32,51,0,109,97,112,46,114,111,119,115,32,61,61,32,50,32,124,124,32,109,97,112,46,114,111,119,115,32,61,61,51,0,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,65,70,70,73,78,69,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,72,79,77,79,71,82,65,80,72,89,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,69,85,67,76,73,68,69,65,78,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,84,82,65,78,83,76,65,84,73,79,78,0,109,97,112,46,114,111,119,115,32,61,61,51,0,99,114,105,116,101,114,105,97,46,116,121,112,101,32,38,32,84,101,114,109,67,114,105,116,101,114,105,97,58,58,67,79,85,78,84,32,124,124,32,99,114,105,116,101,114,105,97,46,116,121,112,101,32,38,32,84,101,114,109,67,114,105,116,101,114,105,97,58,58,69,80,83,0,115,114,99,49,46,115,105,122,101,40,41,32,61,61,32,115,114,99,50,46,115,105,122,101,40,41,0,105,109,97,103,101,95,106,97,99,111,98,105,97,110,95,97,102,102,105,110,101,95,69,67,67,0,115,114,99,49,46,115,105,122,101,40,41,32,61,61,32,115,114,99,51,46,115,105,122,101,40,41,0,115,114,99,49,46,115,105,122,101,40,41,32,61,61,32,115,114,99,52,46,115,105,122,101,40,41,0,115,114,99,49,46,114,111,119,115,32,61,61,32,100,115,116,46,114,111,119,115,0,100,115,116,46,99,111,108,115,32,61,61,32,40,54,42,115,114,99,49,46,99,111,108,115,41,0,100,115,116,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,105,109,97,103,101,95,106,97,99,111,98,105,97,110,95,104,111,109,111,95,69,67,67,0,100,115,116,46,99,111,108,115,32,61,61,32,40,115,114,99,49,46,99,111,108,115,42,56,41,0,115,114,99,53,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,115,114,99,49,46,115,105,122,101,40,41,61,61,115,114,99,50,46,115,105,122,101,40,41,0,105,109,97,103,101,95,106,97,99,111,98,105,97,110,95,116,114,97,110,115,108,97,116,105,111,110,95,69,67,67,0,100,115,116,46,99,111,108,115,32,61,61,32,40,115,114,99,49,46,99,111,108,115,42,50,41,0,105,109,97,103,101,95,106,97,99,111,98,105,97,110,95,101,117,99,108,105,100,101,97,110,95,69,67,67,0,115,114,99,49,46,115,105,122,101,40,41,61,61,115,114,99,51,46,115,105,122,101,40,41,0,115,114,99,49,46,115,105,122,101,40,41,61,61,115,114,99,52,46,115,105,122,101,40,41,0,100,115,116,46,99,111,108,115,32,61,61,32,40,115,114,99,49,46,99,111,108,115,42,51,41,0,78,97,78,32,101,110,99,111,117,110,116,101,114,101,100,46,0,84,104,101,32,97,108,103,111,114,105,116,104,109,32,115,116,111,112,112,101,100,32,98,101,102,111,114,101,32,105,116,115,32,99,111,110,118,101,114,103,101,110,99,101,46,32,84,104,101,32,99,111,114,114,101,108,97,116,105,111,110,32,105,115,32,103,111,105,110,103,32,116,111,32,98,101,32,109,105,110,105,109,105,122,101,100,46,32,73,109,97,103,101,115,32,109,97,121,32,98,101,32,117,110,99,111,114,114,101,108,97,116,101,100,32,111,114,32,110,111,110,45,111,118,101,114,108,97,112,112,101,100,0,109,97,112,95,109,97,116,114,105,120,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,117,112,100,97,116,101,95,119,97,114,112,105,110,103,95,109,97,116,114,105,120,95,69,67,67,0,117,112,100,97,116,101,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,84,82,65,78,83,76,65,84,73,79,78,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,69,85,67,76,73,68,69,65,78,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,65,70,70,73,78,69,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,72,79,77,79,71,82,65,80,72,89,0,109,97,112,95,109,97,116,114,105,120,46,114,111,119,115,32,61,61,32,51,32,38,38,32,117,112,100,97,116,101,46,114,111,119,115,32,61,61,32,56,0,109,97,112,95,109,97,116,114,105,120,46,114,111,119,115,32,61,61,32,50,32,38,38,32,117,112,100,97,116,101,46,114,111,119,115,32,61,61,32,54,0,109,97,112,95,109,97,116,114,105,120,46,114,111,119,115,32,61,61,32,50,32,38,38,32,117,112,100,97,116,101,46,114,111,119,115,32,61,61,32,51,0,109,97,112,95,109,97,116,114,105,120,46,114,111,119,115,32,61,61,32,50,32,38,38,32,117,112,100,97,116,101,46,114,111,119,115,32,61,61,32,50,0,117,112,100,97,116,101,46,99,111,108,115,32,61,61,32,49,0,109,97,112,95,109,97,116,114,105,120,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,117,112,100,97,116,101,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,115,114,99,49,46,114,111,119,115,32,61,61,32,115,114,99,50,46,114,111,119,115,0,112,114,111,106,101,99,116,95,111,110,116,111,95,106,97,99,111,98,105,97,110,95,69,67,67,0,40,115,114,99,49,46,99,111,108,115,32,37,32,115,114,99,50,46,99,111,108,115,41,32,61,61,32,48,0,100,115,116,46,99,111,108,115,32,61,61,32,100,115,116,46,114,111,119,115,0,115,116,97,116,117,115,32,33,61,32,48,76,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,108,107,112,121,114,97,109,105,100,46,99,112,112,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,101,116,97,105,108,58,58,76,75,84,114,97,99,107,101,114,73,110,118,111,107,101,114,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,0,78,50,99,118,54,100,101,116,97,105,108,49,54,76,75,84,114,97,99,107,101,114,73,110,118,111,107,101,114,69,0,105,109,103,46,100,101,112,116,104,40,41,32,61,61,32,48,32,38,38,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,62,32,50,32,38,38,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,62,32,50,0,98,117,105,108,100,79,112,116,105,99,97,108,70,108,111,119,80,121,114,97,109,105,100,0,100,101,112,116,104,32,61,61,32,48,0,99,97,108,99,83,104,97,114,114,68,101,114,105,118,0,105,110,116,32,99,118,58,58,98,117,105,108,100,79,112,116,105,99,97,108,70,108,111,119,80,121,114,97,109,105,100,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,83,105,122,101,44,32,105,110,116,44,32,98,111,111,108,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,54,83,112,97,114,115,101,80,121,114,76,75,79,112,116,105,99,97,108,70,108,111,119,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,109,97,120,76,101,118,101,108,32,62,61,32,48,32,38,38,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,62,32,50,32,38,38,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,62,32,50,0,40,110,112,111,105,110,116,115,32,61,32,112,114,101,118,80,116,115,77,97,116,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,53,44,32,116,114,117,101,41,41,32,62,61,32,48,0,110,101,120,116,80,116,115,77,97,116,46,99,104,101,99],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+337932);allocate([107,86,101,99,116,111,114,40,50,44,32,53,44,32,116,114,117,101,41,32,61,61,32,110,112,111,105,110,116,115,0,115,116,97,116,117,115,77,97,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,101,114,114,77,97,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,108,101,118,101,108,115,49,32,62,61,32,48,0,111,102,115,46,120,32,62,61,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,38,38,32,111,102,115,46,121,32,62,61,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,38,38,32,111,102,115,46,120,32,43,32,112,114,101,118,80,121,114,91,108,118,108,83,116,101,112,49,93,46,99,111,108,115,32,43,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,60,61,32,102,117,108,108,83,105,122,101,46,119,105,100,116,104,32,38,38,32,111,102,115,46,121,32,43,32,112,114,101,118,80,121,114,91,108,118,108,83,116,101,112,49,93,46,114,111,119,115,32,43,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,60,61,32,102,117,108,108,83,105,122,101,46,104,101,105,103,104,116,0,108,101,118,101,108,115,50,32,62,61,32,48,0,111,102,115,46,120,32,62,61,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,38,38,32,111,102,115,46,121,32,62,61,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,38,38,32,111,102,115,46,120,32,43,32,110,101,120,116,80,121,114,91,108,118,108,83,116,101,112,50,93,46,99,111,108,115,32,43,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,60,61,32,102,117,108,108,83,105,122,101,46,119,105,100,116,104,32,38,38,32,111,102,115,46,121,32,43,32,110,101,120,116,80,121,114,91,108,118,108,83,116,101,112,50,93,46,114,111,119,115,32,43,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,60,61,32,102,117,108,108,83,105,122,101,46,104,101,105,103,104,116,0,112,114,101,118,80,121,114,91,108,101,118,101,108,32,42,32,108,118,108,83,116,101,112,49,93,46,115,105,122,101,40,41,32,61,61,32,110,101,120,116,80,121,114,91,108,101,118,101,108,32,42,32,108,118,108,83,116,101,112,50,93,46,115,105,122,101,40,41,0,112,114,101,118,80,121,114,91,108,101,118,101,108,32,42,32,108,118,108,83,116,101,112,49,93,46,116,121,112,101,40,41,32,61,61,32,110,101,120,116,80,121,114,91,108,101,118,101,108,32,42,32,108,118,108,83,116,101,112,50,93,46,116,121,112,101,40,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,40,97,110,111,110,121,109,111,117,115,32,110,97,109,101,115,112,97,99,101,41,58,58,83,112,97,114,115,101,80,121,114,76,75,79,112,116,105,99,97,108,70,108,111,119,73,109,112,108,58,58,99,97,108,99,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,78,50,99,118,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,54,83,112,97,114,115,101,80,121,114,76,75,79,112,116,105,99,97,108,70,108,111,119,73,109,112,108,69,0,78,50,99,118,50,50,83,112,97,114,115,101,80,121,114,76,75,79,112,116,105,99,97,108,70,108,111,119,69,0,78,50,99,118,49,55,83,112,97,114,115,101,79,112,116,105,99,97,108,70,108,111,119,69,0,66,111,116,104,32,105,110,112,117,116,32,105,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,0,101,115,116,105,109,97,116,101,82,105,103,105,100,84,114,97,110,115,102,111,114,109,0,66,111,116,104,32,105,110,112,117,116,32,105,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,100,97,116,97,32,116,121,112,101,0,99,110,32,61,61,32,49,32,124,124,32,99,110,32,61,61,32,51,32,124,124,32,99,110,32,61,61,32,52,0,66,111,116,104,32,105,110,112,117,116,32,105,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,101,105,116,104,101,114,32,56,117,67,49,32,111,114,32,56,117,67,51,32,116,121,112,101,0,77,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,103,101,116,82,84,77,97,116,114,105,120,0,99,118,58,58,77,97,116,32,99,118,58,58,101,115,116,105,109,97,116,101,82,105,103,105,100,84,114,97,110,115,102,111,114,109,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,98,111,111,108,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,70,97,114,110,101,98,97,99,107,79,112,116,105,99,97,108,70,108,111,119,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,112,114,101,118,48,46,115,105,122,101,40,41,32,61,61,32,110,101,120,116,48,46,115,105,122,101,40,41,32,38,38,32,112,114,101,118,48,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,110,101,120,116,48,46,99,104,97,110,110,101,108,115,40,41,32,38,38,32,112,114,101,118,48,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,112,121,114,83,99,97,108,101,95,32,60,32,49,0,99,97,108,99,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,111,112,116,102,108,111,119,103,102,46,99,112,112,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,70,97,114,110,101,98,97,99,107,80,111,108,121,69,120,112,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,40,97,110,111,110,121,109,111,117,115,32,110,97,109,101,115,112,97,99,101,41,58,58,70,97,114,110,101,98,97,99,107,79,112,116,105,99,97,108,70,108,111,119,73,109,112,108,58,58,99,97,108,99,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,41,0,78,50,99,118,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,70,97,114,110,101,98,97,99,107,79,112,116,105,99,97,108,70,108,111,119,73,109,112,108,69,0,78,50,99,118,50,48,70,97,114,110,101,98,97,99,107,79,112,116,105,99,97,108,70,108,111,119,69,0,78,50,99,118,49,54,68,101,110,115,101,79,112,116,105,99,97,108,70,108,111,119,69,0,118,111,105,100,32,99,118,58,58,99,97,108,99,79,112,116,105,99,97,108,70,108,111,119,70,97,114,110,101,98,97,99,107,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,80,65,77,69,110,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,80,65,77,68,101,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,80,120,77,69,110,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,80,120,77,68,101,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,117,110,82,97,115,116,101,114,69,110,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,117,110,82,97,115,116,101,114,68,101,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,74,112,101,103,69,110,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,74,112,101,103,68,101,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,72,100,114,69,110,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,72,100,114,68,101,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,66,109,112,69,110,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,66,109,112,68,101,99,111,100,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,115,105,122,101,46,119,105,100,116,104,32,62,32,48,0,118,97,108,105,100,97,116,101,73,110,112,117,116,73,109,97,103,101,83,105,122,101,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,99,111,100,101,99,115,47,115,114,99,47,108,111,97,100,115,97,118,101,46,99,112,112,0,115,105,122,101,46,119,105,100,116,104,32,60,61,32,40,49,60,60,50,48,41,0,115,105,122,101,46,104,101,105,103,104,116,32,62,32,48,0,115,105,122,101,46,104,101,105,103,104,116,32,60,61,32,40,49,60,60,50,48,41,0,112,105,120,101,108,115,32,60,61,32,40,49,60,60,51,48,41,0,101,110,99,111,100,101,114,45,62,105,115,70,111,114,109,97,116,83,117,112,112,111,114,116,101,100,40,48,41,0,78,50,99,118,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,54,66,121,116,101,83,116,114,101,97,109,66,117,102,102,101,114,69,0,33,98,117,102,46,101,109,112,116,121,40,41,32,38,38,32,98,117,102,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,105,109,100,101,99,111,100,101,95,0,102,97,105,108,101,100,32,116,111,32,119,114,105,116,101,32,105,109,97,103,101,32,100,97,116,97,32,116,111,32,116,101,109,112,111,114,97,114,121,32,102,105,108,101,0,117,110,97,98,108,101,32,116,111,32,114,101,109,111,118,101,32,116,101,109,112,111,114,97,114,121,32,102,105,108,101,58,0,99,118,58,58,77,97,116,32,99,118,58,58,105,109,100,101,99,111,100,101,40,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,99,104,97,110,110,101,108,115,32,61,61,32,49,32,124,124,32,99,104,97,110,110,101,108,115,32,61,61,32,51,32,124,124,32,99,104,97,110,110,101,108,115,32,61,61,32,52,0,105,109,101,110,99,111,100,101,0,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,101,110,99,111,100,101,114,32,102,111,114,32,116,104,101,32,115,112,101,99,105,102,105,101,100,32,101,120,116,101,110,115,105,111,110,0,102,32,33,61,32,48,0,98,111,111,108,32,99,118,58,58,105,109,101,110,99,111,100,101,40,99,111,110,115,116,32,99,118,58,58,83,116,114,105,110,103,32,38,44,32,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,117,99,104,97,114,62,32,38,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,41,0,40,115,105,122,101,95,116,41,115,122,32,60,32,95,115,114,99,46,115,105,122,101,40,41,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,99,111,100,101,99,115,47,115,114,99,47,103,114,102,109,116,95,98,109,112,46,99,112,112,0,73,110,118,97,108,105,100,47,117,110,115,117,112,112,111,114,116,101,100,32,109,111,100,101,0,99,108,114,117,115,101,100,32,62,61,32,48,32,38,38,32,99,108,114,117,115,101,100,32,60,61,32,50,53,54,0,78,50,99,118,49,48,66,109,112,68,101,99,111,100,101,114,69,0,87,105,110,100,111,119,115,32,98,105,116,109,97,112,32,40,42,46,98,109,112,59,42,46,100,105,98,41,0,66,77,0,78,50,99,118,49,48,66,109,112,69,110,99,111,100,101,114,69,0,35,63,82,71,66,69,0,35,63,82,65,68,73,65,78,67,69,0,78,50,99,118,49,48,72,100,114,68,101,99,111,100,101,114,69,0,82,97,100,105,97,110,99,101,32,72,68,82,32,40,42,46,104,100,114,59,42,46,112,105,99,41,0,105,110,112,117,116,95,105,109,103,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,51,32,124,124,32,105,110,112,117,116,95,105,109,103,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,119,114,105,116,101,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,99,111,100,101,99,115,47,115,114,99,47,103,114,102,109,116,95,104,100,114,46,99,112,112,0,112,97,114,97,109,115,46,101,109,112,116,121,40,41,32,124,124,32,112,97,114,97,109,115,91,48,93,32,61,61,32,72,68,82,95,78,79,78,69,32,124,124,32,112,97,114,97,109,115,91,48,93,32,61,61,32,72,68,82,95,82,76,69,0,78,50,99,118,49,48,72,100,114,69,110,99,111,100,101,114,69,0,255,216,255,0,255,196,1,162,0,0,1,5,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,1,0,3,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,16,0,2,1,3,3,2,4,3,5,5,4,4,0,0,1,125,1,2,3,0,4,17,5,18,33,49,65,6,19,81,97,7,34,113,20,50,129,145,161,8,35,66,177,193,21,82,209,240,36,51,98,114,130,9,10,22,23,24,25,26,37,38,39,40,41,42,52,53,54,55,56,57,58,67,68,69,70,71,72,73,74,83,84,85,86,87,88,89,90,99,100,101,102,103,104,105,106,115,116,117,118,119,120,121,122,131,132,133,134,135,136,137,138,146,147,148,149,150,151,152,153,154,162,163,164,165,166,167,168,169,170,178,179,180,181,182,183,184,185,186,194,195,196,197,198,199,200,201,202,210,211,212,213,214,215,216,217,218,225,226,227,228,229,230,231,232,233,234,241,242,243,244,245,246,247,248,249,250,17,0,2,1,2,4,4,3,4,7,5,4,4,0,1,2,119,0,1,2,3,17,4,5,33,49,6,18,65,81,7,97,113,19,34,50,129,8,20,66,145,161,177,193,9,35,51,82,240,21,98,114,209,10,22,36,52,225,37,241,23,24,25,26,38,39,40,41,42,53,54,55,56,57,58,67,68,69,70,71,72,73,74,83,84,85,86,87,88,89,90,99,100,101,102,103,104,105,106,115,116,117,118,119,120,121,122,130,131,132,133,134,135,136,137,138,146,147,148,149,150,151,152,153,154,162,163,164,165,166,167,168,169,170,178,179,180,181,182,183,184,185,186,194,195,196,197,198,199,200,201,202,210,211,212,213,214,215,216,217,218,226,227,228,229,230,231,232,233,234,242,243,244,245,246,247,248,249,250,78,50,99,118,49,49,74,112,101,103,68,101,99,111,100,101,114,69,0,74,80,69,71,32,102,105,108,101,115,32,40,42,46,106,112,101,103,59,42,46,106,112,103,59,42,46,106,112,101,41,0,78,50,99,118,49,49,74,112,101,103,69,110,99,111,100,101,114,69,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,99,111,100,101,99,115,47,115,114,99,47,103,114,102,109,116,95,112,97,109,46,99,112,112,0,78,50,99,118,50,52,82,66,83,95,66,65,68,95,72,69,65,68,69,82,95,69,120,99,101,112,116,105,111,110,69,0,78,50,99,118,49,48,80,65,77,68,101,99,111,100,101,114,69,0,80,111,114,116,97,98,108,101,32,97,114,98,105,116,114,97,114,121,32,102,111,114,109,97,116,32,40,42,46,112,97,109,41,0,87,73,68,84,72,32,37,100,10,0,72,69,73,71,72,84,32,37,100,10,0,68,69,80,84,72,32,37,100,10,0,77,65,88,86,65,76,32,37,100,10,0,84,85,80,76,84,89,80,69,32,37,115,10,0,78,50,99,118,49,48,80,65,77,69,110,99,111,100,101,114,69,0,109,95,109,97,120,118,97,108,32,60,32,50,53,54,0,114,101,97,100,68,97,116,97,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,99,111,100,101,99,115,47,115,114,99,47,103,114,102,109,116,95,112,120,109,46,99,112,112,0,40,40,109,95,116,121,112,101,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,61,61,32,48,0,109,95,98,112,112,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,118,97,108,32,60,61,32,48,120,55,102,102,102,102,102,102,102,32,38,38,32,34,80,88,77,58,32,82,101,97,100,78,117,109,98,101,114,40,41,58,32,114,101,115,117,108,116,32,105,115,32,116,111,111,32,108,97,114,103,101,34,0,82,101,97,100,78,117,109,98,101,114,0,80,88,77,58,32,85,110,101,120,112,101,99,116,101,100,32,99,111,100,101,32,105,110,32,82,101,97,100,78,117,109,98,101,114,40,41,58,32,48,120,37,120,32,40,37,100,41,0,73,110,118,97,108,105,100,32,104,101,97,100,101,114,0,114,101,97,100,72,101,97,100,101,114,0,78,50,99,118,49,48,80,120,77,68,101,99,111,100,101,114,69,0,80,111,114,116,97,98,108,101,32,105,109,97,103,101,32,102,111,114,109,97,116,32,40,42,46,112,98,109,59,42,46,112,103,109,59,42,46,112,112,109,59,42,46,112,120,109,59,42,46,112,110,109,41,0,80,37,99,10,35,32,71,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,67,86,32,37,115,10,37,100,32,37,100,10,37,100,10,0,51,46,51,46,49,45,100,101,118,0,37,32,52,100,0,37,32,54,100,0,78,50,99,118,49,48,80,120,77,69,110,99,111,100,101,114,69,0,78,50,99,118,49,54,83,117,110,82,97,115,116,101,114,68,101,99,111,100,101,114,69,0,83,117,110,32,114,97,115,116,101,114,32,102,105,108,101,115,32,40,42,46,115,114,59,42,46,114,97,115,41,0,89,166,106,149,0,78,50,99,118,49,54,83,117,110,82,97,115,116,101,114,69,110,99,111,100,101,114,69,0,85,110,101,120,112,101,99,116,101,100,32,101,110,100,32,111,102,32,105,110,112,117,116,32,115,116,114,101,97,109,0,114,101,97,100,66,108,111,99,107,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,99,111,100,101,99,115,47,115,114,99,47,98,105,116,115,116,114,109,46,99,112,112,0,78,50,99,118,50,51,82,66,83,95,84,72,82,79,87,95,69,79,83,95,69,120,99,101,112,116,105,111,110,69,0,98,117,102,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,111,112,101,110,0,114,98,0,78,50,99,118,49,49,82,66,97,115,101,83,116,114,101,97,109,69,0,119,98,0,78,50,99,118,49,49,87,66,97,115,101,83,116,114,101,97,109,69,0,78,50,99,118,49,50,82,76,66,121,116,101,83,116,114,101,97,109,69,0,78,50,99,118,49,50,82,77,66,121,116,101,83,116,114,101,97,109,69,0,78,50,99,118,49,50,87,76,66,121,116,101,83,116,114,101,97,109,69,0,78,50,99,118,49,50,87,77,66,121,116,101,83,116,114,101,97,109,69,0,99,117,114,114,101,110,116,32,60,32,109,95,101,110,100,0,103,101,116,66,121,116,101,0,82,71,66,69,0,35,63,37,115,10,0,71,65,77,77,65,61,37,103,10,0,69,88,80,79,83,85,82,69,61,37,103,10,0,70,79,82,77,65,84,61,51,50,45,98,105,116,95,114,108,101,95,114,103,98,101,10,10,0,45,89,32,37,100,32,43,88,32,37,100,10,0,82,71,66,69,32,114,101,97,100,32,101,114,114,111,114,0,114,103,98,101,95,101,114,114,111,114,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,99,111,100,101,99,115,47,115,114,99,47,114,103,98,101,46,99,112,112,0,82,71,66,69,32,119,114,105,116,101,32,101,114,114,111,114,0,82,71,66,69,32,98,97,100,32,102,105,108,101,32,102,111,114,109,97,116,58,32,0,82,71,66,69,32,101,114,114,111,114,58,32,10,0,70,79,82,77,65,84,61,51,50,45,98,105,116,95,114,108,101,95,114,103,98,101,10,0,71,65,77,77,65,61,37,103,0,69,88,80,79,83,85,82,69,61,37,103,0,10,0,109,105,115,115,105,110,103,32,98,108,97,110,107,32,108,105,110,101,32,97,102,116,101,114,32,70,79,82,77,65,84,32,115,112,101,99,105,102,105,101,114,0,109,105,115,115,105,110,103,32,70,79,82,77,65,84,32,115,112,101,99,105,102,105,101,114,0,45,89,32,37,100,32,43,88,32,37,100,0,109,105,115,115,105,110,103,32,105,109,97,103,101,32,115,105,122,101,32,115,112,101,99,105,102,105,101,114,0,119,114,111,110,103,32,115,99,97,110,108,105,110,101,32,119,105,100,116,104,0,117,110,97,98,108,101,32,116,111,32,97,108,108,111,99,97,116,101,32,98,117,102,102,101,114,32,115,112,97,99,101,0,98,97,100,32,115,99,97,110,108,105,110,101,32,100,97,116,97,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,54,69,120,105,102,80,97,114,115,105,110,103,69,114,114,111,114,69,0,78,50,99,118,49,54,66,97,115,101,73,109,97,103,101,68,101,99,111,100,101,114,69,0,82,97,119,32,105,109,97,103,101,32,101,110,99,111,100,101,114,32,101,114,114,111,114,58,32,0,116,104,114,111,119,79,110,69,114,111,114,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,99,111,100,101,99,115,47,115,114,99,47,103,114,102,109,116,95,98,97,115,101,46,99,112,112,0,78,50,99,118,49,54,66,97,115,101,73,109,97,103,101,69,110,99,111,100,101,114,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,73,109,112,108,58,58,102,105,110,100,66,108,111,98,115,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,67,101,110,116,101,114,62,32,38,41,32,99,111,110,115,116,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,98,108,111,98,100,101,116,101,99,116,111,114,46,99,112,112,0,66,108,111,98,32,100,101,116,101,99,116,111,114,32,111,110,108,121,32,115,117,112,112,111,114,116,115,32,56,45,98,105,116,32,105,109,97,103,101,115,33,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,73,109,112,108,58,58,100,101,116,101,99,116,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,99,118,58,58,75,101,121,80,111,105,110,116,62,32,38,44,32,73,110,112,117,116,65,114,114,97,121,41,0,46,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,0,116,104,114,101,115,104,111,108,100,83,116,101,112,0,109,105,110,84,104,114,101,115,104,111,108,100,0,109,97,120,84,104,114,101,115,104,111,108,100,0,109,105,110,82,101,112,101,97,116,97,98,105,108,105,116,121,0,109,105,110,68,105,115,116,66,101,116,119,101,101,110,66,108,111,98,115,0,102,105,108,116,101,114,66,121,67,111,108,111,114,0,98,108,111,98,67,111,108,111,114,0,102,105,108,116,101,114,66,121,65,114,101,97,0,109,105,110,65,114,101,97,0,109,97,120,65,114,101,97,0,102,105,108,116,101,114,66,121,67,105,114,99,117,108,97,114,105,116,121,0,109,105,110,67,105,114,99,117,108,97,114,105,116,121,0,109,97,120,67,105,114,99,117,108,97,114,105,116,121,0,102,105,108,116,101,114,66,121,73,110,101,114,116,105,97,0,109,105,110,73,110,101,114,116,105,97,82,97,116,105,111,0,109,97,120,73,110,101,114,116,105,97,82,97,116,105,111,0,102,105,108,116,101,114,66,121,67,111,110,118,101,120,105,116,121,0,109,105,110,67,111,110,118,101,120,105,116,121,0,109,97,120,67,111,110,118,101,120,105,116,121,0,78,111,32,101,108,101,109,101,110,116,32,110,97,109,101,32,104,97,115,32,98,101,101,110,32,103,105,118,101,110,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,112,101,114,115,105,115,116,101,110,99,101,46,104,112,112,0,78,50,99,118,49,56,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,69,0,78,50,99,118,50,50,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,50,83,105,109,112,108,101,66,108,111,98,68,101,116,101,99,116,111,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,73,110,99,111,114,114,101,99,116,32,116,121,112,101,32,111,102,32,105,110,112,117,116,32,105,109,97,103,101,46,10,0,100,114,97,119,75,101,121,112,111,105,110,116,115,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,100,114,97,119,46,99,112,112,0,33,111,117,116,73,109,97,103,101,46,101,109,112,116,121,40,41,0,33,105,109,103,46,101,109,112,116,121,40,41,0,95,100,114,97,119,75,101,121,112,111,105,110,116,0,118,111,105,100,32,99,118,58,58,100,114,97,119,75,101,121,112,111,105,110,116,115,40,73,110,112,117,116,65,114,114,97,121,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,75,101,121,80,111,105,110,116,62,32,38,44,32,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,105,110,116,41,0,109,97,116,99,104,101,115,77,97,115,107,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,115,32,109,97,116,99,104,101,115,49,116,111,50,0,100,114,97,119,77,97,116,99,104,101,115,0,105,49,32,62,61,32,48,32,38,38,32,105,49,32,60,32,115,116,97,116,105,99,95,99,97,115,116,60,105,110,116,62,40,107,101,121,112,111,105,110,116,115,49,46,115,105,122,101,40,41,41,0,105,50,32,62,61,32,48,32,38,38,32,105,50,32,60,32,115,116,97,116,105,99,95,99,97,115,116,60,105,110,116,62,40,107,101,121,112,111,105,110,116,115,50,46,115,105,122,101,40,41,41,0,111,117,116,73,109,103,32,104,97,115,32,115,105,122,101,32,108,101,115,115,32,116,104,97,110,32,110,101,101,100,32,116,111,32,100,114,97,119,32,105,109,103,49,32,97,110,100,32,105,109,103,50,32,116,111,103,101,116,104,101,114,0,95,112,114,101,112,97,114,101,73,109,103,65,110,100,68,114,97,119,75,101,121,112,111,105,110,116,115,0,46,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,0,78,50,99,118,49,57,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,0,118,111,105,100,32,99,118,58,58,70,65,83,84,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,75,101,121,80,111,105,110,116,62,32,38,44,32,105,110,116,44,32,98,111,111,108,44,32,105,110,116,41,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,102,97,115,116,46,99,112,112,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,52,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,73,109,112,108,58,58,100,101,116,101,99,116,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,75,101,121,80,111,105,110,116,62,32,38,44,32,73,110,112,117,116,65,114,114,97,121,41,0,78,50,99,118,50,52,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,73,109,112,108,69,0,112,105,120,101,108,32,38,38,32,111,102,102,115,101,116,115,0,109,97,107,101,79,102,102,115,101,116,115,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,102,97,115,116,95,115,99,111,114,101,46,99,112,112,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,102,101,97,116,117,114,101,50,100,46,99,112,112,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,70,101,97,116,117,114,101,50,68,58,58,100,101,116,101,99,116,65,110,100,67,111,109,112,117,116,101,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,75,101,121,80,111,105,110,116,62,32,38,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,98,111,111,108,41,0,107,101,121,112,111,105,110,116,115,46,115,105,122,101,40,41,32,61,61,32,110,105,109,97,103,101,115,0,99,111,109,112,117,116,101,0,95,100,101,115,99,114,105,112,116,111,114,115,46,107,105,110,100,40,41,32,61,61,32,95,73,110,112,117,116,65,114,114,97,121,58,58,83,84,68,95,86,69,67,84,79,82,95,77,65,84,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,70,101,97,116,117,114,101,50,68,58,58,99,111,109,112,117,116,101,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,115,116,100,58,58,118,101,99,116,111,114,60,115,116,100,58,58,118,101,99,116,111,114,60,75,101,121,80,111,105,110,116,62,32,62,32,38,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,70,101,97,116,117,114,101,50,68,58,58,99,111,109,112,117,116,101,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,75,101,121,80,111,105,110,116,62,32,38,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,109,97,115,107,115,46,115,105,122,101,40,41,32,61,61,32,110,105,109,97,103,101,115,0,100,101,116,101,99,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,70,101,97,116,117,114,101,50,68,58,58,100,101,116,101,99,116,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,115,116,100,58,58,118,101,99,116,111,114,60,115,116,100,58,58,118,101,99,116,111,114,60,75,101,121,80,111,105,110,116,62,32,62,32,38,44,32,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,70,101,97,116,117,114,101,50,68,58,58,100,101,116,101,99,116,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,75,101,121,80,111,105,110,116,62,32,38,44,32,73,110,112,117,116,65,114,114,97,121,41,0,70,101,97,116,117,114,101,50,68,0,78,50,99,118,57,70,101,97,116,117,114,101,50,68,69,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,107,101,121,112,111,105,110,116,46,99,112,112,0,115,116,97,116,105,99,32,118,111,105,100,32,99,118,58,58,75,101,121,80,111,105,110,116,115,70,105,108,116,101,114,58,58,114,117,110,66,121,80,105,120,101,108,115,77,97,115,107,40,115,116,100,58,58,118,101,99,116,111,114,60,75,101,121,80,111,105,110,116,62,32,38,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,41,0,95,100,101,115,99,114,105,112,116,111,114,115,46,105,115,85,77,97,116,40,41,32,124,124,32,95,100,101,115,99,114,105,112,116,111,114,115,46,105,115,85,77,97,116,86,101,99,116,111,114,40,41,32,124,124,32,95,100,101,115,99,114,105,112,116,111,114,115,46,105,115,77,97,116,40,41,32,124,124,32,95,100,101,115,99,114,105,112,116,111,114,115,46,105,115,77,97,116,86,101,99,116,111,114,40,41,0,97,100,100,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,109,97,116,99,104,101,114,115,46,99,112,112,0,78,50,99,118,49,55,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,69,0,95,113,117,101,114,121,68,101,115,99,114,105,112,116,111,114,115,46,116,121,112,101,40,41,32,61,61,32,116,114,97,105,110,68,101,115,99,84,121,112,101,0,114,97,100,105,117,115,77,97,116,99,104,73,109,112,108,0,107,110,110,77,97,116,99,104,73,109,112,108,0,40,105,110,116,54,52,41,105,109,103,67,111,117,110,116,42,73,77,71,73,68,88,95,79,78,69,32,60,32,48,120,55,102,102,102,102,102,102,102,0,116,114,97,105,110,68,101,115,99,67,111,108,108,101,99,116,105,111,110,91,105,73,100,120,93,46,114,111,119,115,32,60,32,73,77,71,73,68,88,95,79,78,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,66,70,77,97,116,99,104,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,57,66,70,77,97,116,99,104,101,114,69,0,107,110,110,77,97,116,99,104,101,115,91,105,93,46,115,105,122,101,40,41,32,60,61,32,49,0,99,111,110,118,101,114,116,77,97,116,99,104,101,115,0,107,110,110,32,62,32,48,0,107,110,110,77,97,116,99,104,0,109,97,115,107,115,46,115,105,122,101,40,41,32,61,61,32,105,109,97,103,101,67,111,117,110,116,0,99,104,101,99,107,77,97,115,107,115,0,109,97,115,107,115,91,105,93,46,114,111,119,115,32,61,61,32,113,117,101,114,121,68,101,115,99,114,105,112,116,111,114,115,67,111,117,110,116,32,38,38,32,109,97,115,107,115,91,105,93,46,99,111,108,115,32,61,61,32,114,111,119,115,32,38,38,32,109,97,115,107,115,91,105,93,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,118,111,105,100,32,99,118,58,58,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,58,58,107,110,110,77,97,116,99,104,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,115,116,100,58,58,118,101,99,116,111,114,60,68,77,97,116,99,104,62,32,62,32,38,44,32,105,110,116,44,32,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,98,111,111,108,41,0,118,111,105,100,32,99,118,58,58,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,58,58,109,97,116,99,104,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,68,77,97,116,99,104,62,32,38,44,32,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,118,111,105,100,32,99,118,58,58,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,58,58,109,97,116,99,104,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,68,77,97,116,99,104,62,32,38,44,32,73,110,112,117,116,65,114,114,97,121,41,32,99,111,110,115,116,0,66,114,117,116,101,70,111,114,99,101,0,66,114,117,116,101,70,111,114,99,101,45,83,76,50,0,66,114,117,116,101,70,111,114,99,101,45,76,49,0,66,114,117,116,101,70,111,114,99,101,45,72,97,109,109,105,110,103,0,66,114,117,116,101,70,111,114,99,101,45,72,97,109,109,105,110,103,76,85,84,0,66,114,117,116,101,70,111,114,99,101,45,72,97,109,109,105,110,103,40,50,41,0,85,110,107,110,111,119,110,32,109,97,116,99,104,101,114,32,110,97,109,101,0,99,114,101,97,116,101,0,78,50,99,118,51,79,82,66,69,0,112,97,116,99,104,83,105,122,101,32,62,61,32,50,0,100,101,116,101,99,116,65,110,100,67,111,109,112,117,116,101,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,111,114,98,46,99,112,112,0,108,101,118,101,108,32,62,61,32,48,0,105,109,103,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,38,38,32,98,108,111,99,107,83,105,122,101,42,98,108,111,99,107,83,105,122,101,32,60,61,32,50,48,52,56,0,72,97,114,114,105,115,82,101,115,112,111,110,115,101,115,0,48,32,60,61,32,108,101,118,101,108,0,119,116,97,95,107,32,61,61,32,50,32,124,124,32,119,116,97,95,107,32,61,61,32,51,32,124,124,32,119,116,97,95,107,32,61,61,32,52,0,87,114,111,110,103,32,119,116,97,95,107,46,32,73,116,32,99,97,110,32,98,101,32,111,110,108,121,32,50,44,32,51,32,111,114,32,52,46,0,99,111,109,112,117,116,101,79,114,98,68,101,115,99,114,105,112,116,111,114,115,0,97,108,108,111,99,97,116,111,114,60,84,62,58,58,97,108,108,111,99,97,116,101,40,115,105,122,101,95,116,32,110,41,32,39,110,39,32,101,120,99,101,101,100,115,32,109,97,120,105,109,117,109,32,115,117,112,112,111,114,116,101,100,32,115,105,122,101,0,116,111,116,97,108,40,41,32,61,61,32,48,32,124,124,32,100,97,116,97,32,33,61,32,48,76,0,77,97,116,0,47,104,111,109,101,47,115,97,106,106,97,100,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,109,97,116,46,105,110,108,46,104,112,112,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,79,82,66,95,73,109,112,108,58,58,100,101,116,101,99,116,65,110,100,67,111,109,112,117,116,101,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,75,101,121,80,111,105,110,116,62,32,38,44,32,79,117,116,112,117,116,65],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+348172);allocate([114,114,97,121,44,32,98,111,111,108,41,0,78,50,99,118,56,79,82,66,95,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,79,82,66,95,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,115,0,37,115,37,115,37,115,0,58,32,0,117,110,101,120,112,101,99,116,101,100,32,101,110,100,32,111,102,32,102,105,108,101,0,105,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,105,110,102,108,97,116,101,32,115,116,114,101,97,109,32,99,111,114,114,117,112,116,0,99,111,109,112,114,101,115,115,101,100,32,100,97,116,97,32,101,114,114,111,114,0,114,101,113,117,101,115,116,101,100,32,108,101,110,103,116,104,32,100,111,101,115,32,110,111,116,32,102,105,116,32,105,110,32,105,110,116,0,105,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,100,101,102,108,97,116,101,32,115,116,114,101,97,109,32,99,111,114,114,117,112,116,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,49,46,50,46,56,0,105,110,99,111,114,114,101,99,116,32,104,101,97,100,101,114,32,99,104,101,99,107,0,117,110,107,110,111,119,110,32,99,111,109,112,114,101,115,115,105,111,110,32,109,101,116,104,111,100,0,105,110,118,97,108,105,100,32,119,105,110,100,111,119,32,115,105,122,101,0,117,110,107,110,111,119,110,32,104,101,97,100,101,114,32,102,108,97,103,115,32,115,101,116,0,104,101,97,100,101,114,32,99,114,99,32,109,105,115,109,97,116,99,104,0,105,110,118,97,108,105,100,32,98,108,111,99,107,32,116,121,112,101,0,105,110,118,97,108,105,100,32,115,116,111,114,101,100,32,98,108,111,99,107,32,108,101,110,103,116,104,115,0,116,111,111,32,109,97,110,121,32,108,101,110,103,116,104,32,111,114,32,100,105,115,116,97,110,99,101,32,115,121,109,98,111,108,115,0,105,110,118,97,108,105,100,32,99,111,100,101,32,108,101,110,103,116,104,115,32,115,101,116,0,105,110,118,97,108,105,100,32,98,105,116,32,108,101,110,103,116,104,32,114,101,112,101,97,116,0,105,110,118,97,108,105,100,32,99,111,100,101,32,45,45,32,109,105,115,115,105,110,103,32,101,110,100,45,111,102,45,98,108,111,99,107,0,105,110,118,97,108,105,100,32,108,105,116,101,114,97,108,47,108,101,110,103,116,104,115,32,115,101,116,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,115,32,115,101,116,0,105,110,99,111,114,114,101,99,116,32,100,97,116,97,32,99,104,101,99,107,0,105,110,99,111,114,114,101,99,116,32,108,101,110,103,116,104,32,99,104,101,99,107,0,105,110,118,97,108,105,100,32,108,105,116,101,114,97,108,47,108,101,110,103,116,104,32,99,111,100,101,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,32,99,111,100,101,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,32,116,111,111,32,102,97,114,32,98,97,99,107,0,110,101,101,100,32,100,105,99,116,105,111,110,97,114,121,0,115,116,114,101,97,109,32,101,110,100,0,102,105,108,101,32,101,114,114,111,114,0,115,116,114,101,97,109,32,101,114,114,111,114,0,100,97,116,97,32,101,114,114,111,114,0,105,110,115,117,102,102,105,99,105,101,110,116,32,109,101,109,111,114,121,0,98,117,102,102,101,114,32,101,114,114,111,114,0,105,110,99,111,109,112,97,116,105,98,108,101,32,118,101,114,115,105,111,110,0,0,1,2,3,4,4,5,5,6,6,6,6,7,7,7,7,8,8,8,8,8,8,8,8,9,9,9,9,9,9,9,9,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,0,0,16,17,18,18,19,19,20,20,20,20,21,21,21,21,22,22,22,22,22,22,22,22,23,23,23,23,23,23,23,23,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,0,1,2,3,4,5,6,7,8,8,9,9,10,10,11,11,12,12,12,12,13,13,13,13,14,14,14,14,15,15,15,15,16,16,16,16,16,16,16,16,17,17,17,17,17,17,17,17,18,18,18,18,18,18,18,18,19,19,19,19,19,19,19,19,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,28,16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15,0,0,1,5,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,0,0,2,1,3,3,2,4,3,5,5,4,4,0,0,1,125,1,2,3,0,4,17,5,18,33,49,65,6,19,81,97,7,34,113,20,50,129,145,161,8,35,66,177,193,21,82,209,240,36,51,98,114,130,9,10,22,23,24,25,26,37,38,39,40,41,42,52,53,54,55,56,57,58,67,68,69,70,71,72,73,74,83,84,85,86,87,88,89,90,99,100,101,102,103,104,105,106,115,116,117,118,119,120,121,122,131,132,133,134,135,136,137,138,146,147,148,149,150,151,152,153,154,162,163,164,165,166,167,168,169,170,178,179,180,181,182,183,184,185,186,194,195,196,197,198,199,200,201,202,210,211,212,213,214,215,216,217,218,225,226,227,228,229,230,231,232,233,234,241,242,243,244,245,246,247,248,249,250,0,0,3,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,0,0,2,1,2,4,4,3,4,7,5,4,4,0,1,2,119,0,1,2,3,17,4,5,33,49,6,18,65,81,7,97,113,19,34,50,129,8,20,66,145,161,177,193,9,35,51,82,240,21,98,114,209,10,22,36,52,225,37,241,23,24,25,26,38,39,40,41,42,53,54,55,56,57,58,67,68,69,70,71,72,73,74,83,84,85,86,87,88,89,90,99,100,101,102,103,104,105,106,115,116,117,118,119,120,121,122,130,131,132,133,134,135,136,137,138,146,147,148,149,150,151,152,153,154,162,163,164,165,166,167,168,169,170,178,179,180,181,182,183,184,185,186,194,195,196,197,198,199,200,201,202,210,211,212,213,214,215,216,217,218,226,227,228,229,230,231,232,233,234,242,243,244,245,246,247,248,249,250,83,79,83,0,76,83,69,0,66,111,103,117,115,32,109,101,115,115,97,103,101,32,99,111,100,101,32,37,100,0,65,76,73,71,78,95,84,89,80,69,32,105,115,32,119,114,111,110,103,44,32,112,108,101,97,115,101,32,102,105,120,0,77,65,88,95,65,76,76,79,67,95,67,72,85,78,75,32,105,115,32,119,114,111,110,103,44,32,112,108,101,97,115,101,32,102,105,120,0,66,111,103,117,115,32,98,117,102,102,101,114,32,99,111,110,116,114,111,108,32,109,111,100,101,0,73,110,118,97,108,105,100,32,99,111,109,112,111,110,101,110,116,32,73,68,32,37,100,32,105,110,32,83,79,83,0,73,110,118,97,108,105,100,32,99,114,111,112,32,114,101,113,117,101,115,116,0,68,67,84,32,99,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,114,97,110,103,101,0,68,67,84,32,115,99,97,108,101,100,32,98,108,111,99,107,32,115,105,122,101,32,37,100,120,37,100,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,67,111,109,112,111,110,101,110,116,32,105,110,100,101,120,32,37,100,58,32,109,105,115,109,97,116,99,104,105,110,103,32,115,97,109,112,108,105,110,103,32,114,97,116,105,111,32,37,100,58,37,100,44,32,37,100,58,37,100,44,32,37,99,0,66,111,103,117,115,32,72,117,102,102,109,97,110,32,116,97,98,108,101,32,100,101,102,105,110,105,116,105,111,110,0,66,111,103,117,115,32,105,110,112,117,116,32,99,111,108,111,114,115,112,97,99,101,0,66,111,103,117,115,32,74,80,69,71,32,99,111,108,111,114,115,112,97,99,101,0,66,111,103,117,115,32,109,97,114,107,101,114,32,108,101,110,103,116,104,0,87,114,111,110,103,32,74,80,69,71,32,108,105,98,114,97,114,121,32,118,101,114,115,105,111,110,58,32,108,105,98,114,97,114,121,32,105,115,32,37,100,44,32,99,97,108,108,101,114,32,101,120,112,101,99,116,115,32,37,100,0,83,97,109,112,108,105,110,103,32,102,97,99,116,111,114,115,32,116,111,111,32,108,97,114,103,101,32,102,111,114,32,105,110,116,101,114,108,101,97,118,101,100,32,115,99,97,110,0,73,110,118,97,108,105,100,32,109,101,109,111,114,121,32,112,111,111,108,32,99,111,100,101,32,37,100,0,85,110,115,117,112,112,111,114,116,101,100,32,74,80,69,71,32,100,97,116,97,32,112,114,101,99,105,115,105,111,110,32,37,100,0,73,110,118,97,108,105,100,32,112,114,111,103,114,101,115,115,105,118,101,32,112,97,114,97,109,101,116,101,114,115,32,83,115,61,37,100,32,83,101,61,37,100,32,65,104,61,37,100,32,65,108,61,37,100,0,73,110,118,97,108,105,100,32,112,114,111,103,114,101,115,115,105,118,101,32,112,97,114,97,109,101,116,101,114,115,32,97,116,32,115,99,97,110,32,115,99,114,105,112,116,32,101,110,116,114,121,32,37,100,0,66,111,103,117,115,32,115,97,109,112,108,105,110,103,32,102,97,99,116,111,114,115,0,73,110,118,97,108,105,100,32,115,99,97,110,32,115,99,114,105,112,116,32,97,116,32,101,110,116,114,121,32,37,100,0,73,109,112,114,111,112,101,114,32,99,97,108,108,32,116,111,32,74,80,69,71,32,108,105,98,114,97,114,121,32,105,110,32,115,116,97,116,101,32,37,100,0,74,80,69,71,32,112,97,114,97,109,101,116,101,114,32,115,116,114,117,99,116,32,109,105,115,109,97,116,99,104,58,32,108,105,98,114,97,114,121,32,116,104,105,110,107,115,32,115,105,122,101,32,105,115,32,37,117,44,32,99,97,108,108,101,114,32,101,120,112,101,99,116,115,32,37,117,0,66,111,103,117,115,32,118,105,114,116,117,97,108,32,97,114,114,97,121,32,97,99,99,101,115,115,0,66,117,102,102,101,114,32,112,97,115,115,101,100,32,116,111,32,74,80,69,71,32,108,105,98,114,97,114,121,32,105,115,32,116,111,111,32,115,109,97,108,108,0,83,117,115,112,101,110,115,105,111,110,32,110,111,116,32,97,108,108,111,119,101,100,32,104,101,114,101,0,67,67,73,82,54,48,49,32,115,97,109,112,108,105,110,103,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,32,121,101,116,0,84,111,111,32,109,97,110,121,32,99,111,108,111,114,32,99,111,109,112,111,110,101,110,116,115,58,32,37,100,44,32,109,97,120,32,37,100,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,108,111,114,32,99,111,110,118,101,114,115,105,111,110,32,114,101,113,117,101,115,116,0,66,111,103,117,115,32,68,65,67,32,105,110,100,101,120,32,37,100,0,66,111,103,117,115,32,68,65,67,32,118,97,108,117,101,32,48,120,37,120,0,66,111,103,117,115,32,68,72,84,32,105,110,100,101,120,32,37,100,0,66,111,103,117,115,32,68,81,84,32,105,110,100,101,120,32,37,100,0,69,109,112,116,121,32,74,80,69,71,32,105,109,97,103,101,32,40,68,78,76,32,110,111,116,32,115,117,112,112,111,114,116,101,100,41,0,82,101,97,100,32,102,114,111,109,32,69,77,83,32,102,97,105,108,101,100,0,87,114,105,116,101,32,116,111,32,69,77,83,32,102,97,105,108,101,100,0,68,105,100,110,39,116,32,101,120,112,101,99,116,32,109,111,114,101,32,116,104,97,110,32,111,110,101,32,115,99,97,110,0,73,110,112,117,116,32,102,105,108,101,32,114,101,97,100,32,101,114,114,111,114,0,79,117,116,112,117,116,32,102,105,108,101,32,119,114,105,116,101,32,101,114,114,111,114,32,45,45,45,32,111,117,116,32,111,102,32,100,105,115,107,32,115,112,97,99,101,63,0,70,114,97,99,116,105,111,110,97,108,32,115,97,109,112,108,105,110,103,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,32,121,101,116,0,72,117,102,102,109,97,110,32,99,111,100,101,32,115,105,122,101,32,116,97,98,108,101,32,111,118,101,114,102,108,111,119,0,77,105,115,115,105,110,103,32,72,117,102,102,109,97,110,32,99,111,100,101,32,116,97,98,108,101,32,101,110,116,114,121,0,77,97,120,105,109,117,109,32,115,117,112,112,111,114,116,101,100,32,105,109,97,103,101,32,100,105,109,101,110,115,105,111,110,32,105,115,32,37,117,32,112,105,120,101,108,115,0,69,109,112,116,121,32,105,110,112,117,116,32,102,105,108,101,0,80,114,101,109,97,116,117,114,101,32,101,110,100,32,111,102,32,105,110,112,117,116,32,102,105,108,101,0,67,97,110,110,111,116,32,116,114,97,110,115,99,111,100,101,32,100,117,101,32,116,111,32,109,117,108,116,105,112,108,101,32,117,115,101,32,111,102,32,113,117,97,110,116,105,122,97,116,105,111,110,32,116,97,98,108,101,32,37,100,0,83,99,97,110,32,115,99,114,105,112,116,32,100,111,101,115,32,110,111,116,32,116,114,97,110,115,109,105,116,32,97,108,108,32,100,97,116,97,0,73,110,118,97,108,105,100,32,99,111,108,111,114,32,113,117,97,110,116,105,122,97,116,105,111,110,32,109,111,100,101,32,99,104,97,110,103,101,0,78,111,116,32,105,109,112,108,101,109,101,110,116,101,100,32,121,101,116,0,82,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,119,97,115,32,111,109,105,116,116,101,100,32,97,116,32,99,111,109,112,105,108,101,32,116,105,109,101,0,65,114,105,116,104,109,101,116,105,99,32,116,97,98,108,101,32,48,120,37,48,50,120,32,119,97,115,32,110,111,116,32,100,101,102,105,110,101,100,0,66,97,99,107,105,110,103,32,115,116,111,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,72,117,102,102,109,97,110,32,116,97,98,108,101,32,48,120,37,48,50,120,32,119,97,115,32,110,111,116,32,100,101,102,105,110,101,100,0,74,80,69,71,32,100,97,116,97,115,116,114,101,97,109,32,99,111,110,116,97,105,110,115,32,110,111,32,105,109,97,103,101,0,81,117,97,110,116,105,122,97,116,105,111,110,32,116,97,98,108,101,32,48,120,37,48,50,120,32,119,97,115,32,110,111,116,32,100,101,102,105,110,101,100,0,78,111,116,32,97,32,74,80,69,71,32,102,105,108,101,58,32,115,116,97,114,116,115,32,119,105,116,104,32,48,120,37,48,50,120,32,48,120,37,48,50,120,0,73,110,115,117,102,102,105,99,105,101,110,116,32,109,101,109,111,114,121,32,40,99,97,115,101,32,37,100,41,0,67,97,110,110,111,116,32,113,117,97,110,116,105,122,101,32,109,111,114,101,32,116,104,97,110,32,37,100,32,99,111,108,111,114,32,99,111,109,112,111,110,101,110,116,115,0,67,97,110,110,111,116,32,113,117,97,110,116,105,122,101,32,116,111,32,102,101,119,101,114,32,116,104,97,110,32,37,100,32,99,111,108,111,114,115,0,67,97,110,110,111,116,32,113,117,97,110,116,105,122,101,32,116,111,32,109,111,114,101,32,116,104,97,110,32,37,100,32,99,111,108,111,114,115,0,73,110,118,97,108,105,100,32,74,80,69,71,32,102,105,108,101,32,115,116,114,117,99,116,117,114,101,58,32,37,115,32,98,101,102,111,114,101,32,83,79,70,0,73,110,118,97,108,105,100,32,74,80,69,71,32,102,105,108,101,32,115,116,114,117,99,116,117,114,101,58,32,116,119,111,32,83,79,70,32,109,97,114,107,101,114,115,0,73,110,118,97,108,105,100,32,74,80,69,71,32,102,105,108,101,32,115,116,114,117,99,116,117,114,101,58,32,109,105,115,115,105,110,103,32,83,79,83,32,109,97,114,107,101,114,0,85,110,115,117,112,112,111,114,116,101,100,32,74,80,69,71,32,112,114,111,99,101,115,115,58,32,83,79,70,32,116,121,112,101,32,48,120,37,48,50,120,0,73,110,118,97,108,105,100,32,74,80,69,71,32,102,105,108,101,32,115,116,114,117,99,116,117,114,101,58,32,116,119,111,32,83,79,73,32,109,97,114,107,101,114,115,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,116,101,109,112,111,114,97,114,121,32,102,105,108,101,32,37,115,0,82,101,97,100,32,102,97,105,108,101,100,32,111,110,32,116,101,109,112,111,114,97,114,121,32,102,105,108,101,0,83,101,101,107,32,102,97,105,108,101,100,32,111,110,32,116,101,109,112,111,114,97,114,121,32,102,105,108,101,0,87,114,105,116,101,32,102,97,105,108,101,100,32,111,110,32,116,101,109,112,111,114,97,114,121,32,102,105,108,101,32,45,45,45,32,111,117,116,32,111,102,32,100,105,115,107,32,115,112,97,99,101,63,0,65,112,112,108,105,99,97,116,105,111,110,32,116,114,97,110,115,102,101,114,114,101,100,32,116,111,111,32,102,101,119,32,115,99,97,110,108,105,110,101,115,0,85,110,115,117,112,112,111,114,116,101,100,32,109,97,114,107,101,114,32,116,121,112,101,32,48,120,37,48,50,120,0,86,105,114,116,117,97,108,32,97,114,114,97,121,32,99,111,110,116,114,111,108,108,101,114,32,109,101,115,115,101,100,32,117,112,0,73,109,97,103,101,32,116,111,111,32,119,105,100,101,32,102,111,114,32,116,104,105,115,32,105,109,112,108,101,109,101,110,116,97,116,105,111,110,0,82,101,97,100,32,102,114,111,109,32,88,77,83,32,102,97,105,108,101,100,0,87,114,105,116,101,32,116,111,32,88,77,83,32,102,97,105,108,101,100,0,67,111,112,121,114,105,103,104,116,32,40,67,41,32,50,48,49,51,44,32,84,104,111,109,97,115,32,71,46,32,76,97,110,101,44,32,71,117,105,100,111,32,86,111,108,108,98,101,100,105,110,103,0,57,32,32,49,51,45,74,97,110,45,50,48,49,51,0,67,97,117,116,105,111,110,58,32,113,117,97,110,116,105,122,97,116,105,111,110,32,116,97,98,108,101,115,32,97,114,101,32,116,111,111,32,99,111,97,114,115,101,32,102,111,114,32,98,97,115,101,108,105,110,101,32,74,80,69,71,0,65,100,111,98,101,32,65,80,80,49,52,32,109,97,114,107,101,114,58,32,118,101,114,115,105,111,110,32,37,100,44,32,102,108,97,103,115,32,48,120,37,48,52,120,32,48,120,37,48,52,120,44,32,116,114,97,110,115,102,111,114,109,32,37,100,0,85,110,107,110,111,119,110,32,65,80,80,48,32,109,97,114,107,101,114,32,40,110,111,116,32,74,70,73,70,41,44,32,108,101,110,103,116,104,32,37,117,0,85,110,107,110,111,119,110,32,65,80,80,49,52,32,109,97,114,107,101,114,32,40,110,111,116,32,65,100,111,98,101,41,44,32,108,101,110,103,116,104,32,37,117,0,68,101,102,105,110,101,32,65,114,105,116,104,109,101,116,105,99,32,84,97,98,108,101,32,48,120,37,48,50,120,58,32,48,120,37,48,50,120,0,68,101,102,105,110,101,32,72,117,102,102,109,97,110,32,84,97,98,108,101,32,48,120,37,48,50,120,0,68,101,102,105,110,101,32,81,117,97,110,116,105,122,97,116,105,111,110,32,84,97,98,108,101,32,37,100,32,32,112,114,101,99,105,115,105,111,110,32,37,100,0,68,101,102,105,110,101,32,82,101,115,116,97,114,116,32,73,110,116,101,114,118,97,108,32,37,117,0,70,114,101,101,100,32,69,77,83,32,104,97,110,100,108,101,32,37,117,0,79,98,116,97,105,110,101,100,32,69,77,83,32,104,97,110,100,108,101,32,37,117,0,69,110,100,32,79,102,32,73,109,97,103,101,0,32,32,32,32,32,32,32,32,37,51,100,32,37,51,100,32,37,51,100,32,37,51,100,32,37,51,100,32,37,51,100,32,37,51,100,32,37,51,100,0,74,70,73,70,32,65,80,80,48,32,109,97,114,107,101,114,58,32,118,101,114,115,105,111,110,32,37,100,46,37,48,50,100,44,32,100,101,110,115,105,116,121,32,37,100,120,37,100,32,32,37,100,0,87,97,114,110,105,110,103,58,32,116,104,117,109,98,110,97,105,108,32,105,109,97,103,101,32,115,105,122,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,100,97,116,97,32,108,101,110,103,116,104,32,37,117,0,74,70,73,70,32,101,120,116,101,110,115,105,111,110,32,109,97,114,107,101,114,58,32,116,121,112,101,32,48,120,37,48,50,120,44,32,108,101,110,103,116,104,32,37,117,0,32,32,32,32,119,105,116,104,32,37,100,32,120,32,37,100,32,116,104,117,109,98,110,97,105,108,32,105,109,97,103,101,0,77,105,115,99,101,108,108,97,110,101,111,117,115,32,109,97,114,107,101,114,32,48,120,37,48,50,120,44,32,108,101,110,103,116,104,32,37,117,0,85,110,101,120,112,101,99,116,101,100,32,109,97,114,107,101,114,32,48,120,37,48,50,120,0,32,32,32,32,32,32,32,32,37,52,117,32,37,52,117,32,37,52,117,32,37,52,117,32,37,52,117,32,37,52,117,32,37,52,117,32,37,52,117,0,81,117,97,110,116,105,122,105,110,103,32,116,111,32,37,100,32,61,32,37,100,42,37,100,42,37,100,32,99,111,108,111,114,115,0,81,117,97,110,116,105,122,105,110,103,32,116,111,32,37,100,32,99,111,108,111,114,115,0,83,101,108,101,99,116,101,100,32,37,100,32,99,111,108,111,114,115,32,102,111,114,32,113,117,97,110,116,105,122,97,116,105,111,110,0,65,116,32,109,97,114,107,101,114,32,48,120,37,48,50,120,44,32,114,101,99,111,118,101,114,121,32,97,99,116,105,111,110,32,37,100,0,82,83,84,37,100,0,83,109,111,111,116,104,105,110,103,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,119,105,116,104,32,110,111,110,115,116,97,110,100,97,114,100,32,115,97,109,112,108,105,110,103,32,114,97,116,105,111,115,0,83,116,97,114,116,32,79,102,32,70,114,97,109,101,32,48,120,37,48,50,120,58,32,119,105,100,116,104,61,37,117,44,32,104,101,105,103,104,116,61,37,117,44,32,99,111,109,112,111,110,101,110,116,115,61,37,100,0,32,32,32,32,67,111,109,112,111,110,101,110,116,32,37,100,58,32,37,100,104,120,37,100,118,32,113,61,37,100,0,83,116,97,114,116,32,111,102,32,73,109,97,103,101,0,83,116,97,114,116,32,79,102,32,83,99,97,110,58,32,37,100,32,99,111,109,112,111,110,101,110,116,115,0,32,32,32,32,67,111,109,112,111,110,101,110,116,32,37,100,58,32,100,99,61,37,100,32,97,99,61,37,100,0,32,32,83,115,61,37,100,44,32,83,101,61,37,100,44,32,65,104,61,37,100,44,32,65,108,61,37,100,0,67,108,111,115,101,100,32,116,101,109,112,111,114,97,114,121,32,102,105,108,101,32,37,115,0,79,112,101,110,101,100,32,116,101,109,112,111,114,97,114,121,32,102,105,108,101,32,37,115,0,74,70,73,70,32,101,120,116,101,110,115,105,111,110,32,109,97,114,107,101,114,58,32,74,80,69,71,45,99,111,109,112,114,101,115,115,101,100,32,116,104,117,109,98,110,97,105,108,32,105,109,97,103,101,44,32,108,101,110,103,116,104,32,37,117,0,74,70,73,70,32,101,120,116,101,110,115,105,111,110,32,109,97,114,107,101,114,58,32,112,97,108,101,116,116,101,32,116,104,117,109,98,110,97,105,108,32,105,109,97,103,101,44,32,108,101,110,103,116,104,32,37,117,0,74,70,73,70,32,101,120,116,101,110,115,105,111,110,32,109,97,114,107,101,114,58,32,82,71,66,32,116,104,117,109,98,110,97,105,108,32,105,109,97,103,101,44,32,108,101,110,103,116,104,32,37,117,0,85,110,114,101,99,111,103,110,105,122,101,100,32,99,111,109,112,111,110,101,110,116,32,73,68,115,32,37,100,32,37,100,32,37,100,44,32,97,115,115,117,109,105,110,103,32,89,67,98,67,114,0,70,114,101,101,100,32,88,77,83,32,104,97,110,100,108,101,32,37,117,0,79,98,116,97,105,110,101,100,32,88,77,83,32,104,97,110,100,108,101,32,37,117,0,85,110,107,110,111,119,110,32,65,100,111,98,101,32,99,111,108,111,114,32,116,114,97,110,115,102,111,114,109,32,99,111,100,101,32,37,100,0,67,111,114,114,117,112,116,32,74,80,69,71,32,100,97,116,97,58,32,98,97,100,32,97,114,105,116,104,109,101,116,105,99,32,99,111,100,101,0,73,110,99,111,110,115,105,115,116,101,110,116,32,112,114,111,103,114,101,115,115,105,111,110,32,115,101,113,117,101,110,99,101,32,102,111,114,32,99,111,109,112,111,110,101,110,116,32,37,100,32,99,111,101,102,102,105,99,105,101,110,116,32,37,100,0,67,111,114,114,117,112,116,32,74,80,69,71,32,100,97,116,97,58,32,37,117,32,101,120,116,114,97,110,101,111,117,115,32,98,121,116,101,115,32,98,101,102,111,114,101,32,109,97,114,107,101,114,32,48,120,37,48,50,120,0,67,111,114,114,117,112,116,32,74,80,69,71,32,100,97,116,97,58,32,112,114,101,109,97,116,117,114,101,32,101,110,100,32,111,102,32,100,97,116,97,32,115,101,103,109,101,110,116,0,67,111,114,114,117,112,116,32,74,80,69,71,32,100,97,116,97,58,32,98,97,100,32,72,117,102,102,109,97,110,32,99,111,100,101,0,87,97,114,110,105,110,103,58,32,117,110,107,110,111,119,110,32,74,70,73,70,32,114,101,118,105,115,105,111,110,32,110,117,109,98,101,114,32,37,100,46,37,48,50,100,0,80,114,101,109,97,116,117,114,101,32,101,110,100,32,111,102,32,74,80,69,71,32,102,105,108,101,0,67,111,114,114,117,112,116,32,74,80,69,71,32,100,97,116,97,58,32,102,111,117,110,100,32,109,97,114,107,101,114,32,48,120,37,48,50,120,32,105,110,115,116,101,97,100,32,111,102,32,82,83,84,37,100,0,73,110,118,97,108,105,100,32,83,79,83,32,112,97,114,97,109,101,116,101,114,115,32,102,111,114,32,115,101,113,117,101,110,116,105,97,108,32,74,80,69,71,0,65,112,112,108,105,99,97,116,105,111,110,32,116,114,97,110,115,102,101,114,114,101,100,32,116,111,111,32,109,97,110,121,32,115,99,97,110,108,105,110,101,115,0,37,115,10,0,74,80,69,71,77,69,77,0,37,108,100,37,99,0,0,192,48,240,12,204,60,252,3,195,51,243,15,207,63,255,128,64,176,112,140,76,188,124,131,67,179,115,143,79,191,127,32,224,16,208,44,236,28,220,35,227,19,211,47,239,31,223,160,96,144,80,172,108,156,92,163,99,147,83,175,111,159,95,8,200,56,248,4,196,52,244,11,203,59,251,7,199,55,247,136,72,184,120,132,68,180,116,139,75,187,123,135,71,183,119,40,232,24,216,36,228,20,212,43,235,27,219,39,231,23,215,168,104,152,88,164,100,148,84,171,107,155,91,167,103,151,87,2,194,50,242,14,206,62,254,1,193,49,241,13,205,61,253,130,66,178,114,142,78,190,126,129,65,177,113,141,77,189,125,34,226,18,210,46,238,30,222,33,225,17,209,45,237,29,221,162,98,146,82,174,110,158,94,161,97,145,81,173,109,157,93,10,202,58,250,6,198,54,246,9,201,57,249,5,197,53,245,138,74,186,122,134,70,182,118,137,73,185,121,133,69,181,117,42,234,26,218,38,230,22,214,41,233,25,217,37,229,21,213,170,106,154,90,166,102,150,86,169,105,153,89,165,101,149,85,115,116,100,58,58,98,97,115,105,99,95,115,116,114,105,110,103,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,0,115,116,100,58,58,119,115,116,114,105,110,103,0,101,109,115,99,114,105,112,116,101,110,58,58,118,97,108,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,99,104,97,114,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,115,105,103,110,101,100,32,99,104,97,114,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,115,104,111,114,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,105,110,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,110,115,105,103,110,101,100,32,105,110,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,108,111,110,103,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,110,115,105,103,110,101,100,32,108,111,110,103,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,105,110,116,56,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,105,110,116,56,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,105,110,116,49,54,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,105,110,116,49,54,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,105,110,116,51,50,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,105,110,116,51,50,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,102,108,111,97,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,100,111,117,98,108,101,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,108,111,110,103,32,100,111,117,98,108,101,62,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,101,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,109,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,108,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,106,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,97,69,69,0,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,104,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,104,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,104,69,69,69,69,0,88,88,88,88,88,88,0,84,33,34,25,13,1,2,3,17,75,28,12,16,4,11,29,18,30,39,104,110,111,112,113,98,32,5,6,15,19,20,21,26,8,22,7,40,36,23,24,9,10,14,27,31,37,35,131,130,125,38,42,43,60,61,62,63,67,71,74,77,88,89,90,91,92,93,94,95,96,97,99,100,101,102,103,105,106,107,108,114,115,116,121,122,123,124,0,73,108,108,101,103,97,108,32,98,121,116,101,32,115,101,113,117,101,110,99,101,0,68,111,109,97,105,110,32,101,114,114,111,114,0,82,101,115,117,108,116,32,110,111,116,32,114,101,112,114,101,115,101,110,116,97,98,108,101,0,78,111,116,32,97,32,116,116,121,0,80,101,114,109,105,115,115,105,111,110,32,100,101,110,105,101,100,0,79,112,101,114,97,116,105,111,110,32,110,111,116,32,112,101,114,109,105,116,116,101,100,0,78,111,32,115,117,99,104,32,102,105,108,101,32,111,114,32,100,105,114,101,99,116,111,114,121,0,78,111,32,115,117,99,104,32,112,114,111,99,101,115,115,0,70,105,108,101,32,101,120,105,115,116,115,0,86,97,108,117,101,32,116,111,111,32,108,97,114,103,101,32,102,111,114,32,100,97,116,97,32,116,121,112,101,0,78,111,32,115,112,97,99,101,32,108,101,102,116,32,111,110,32,100,101,118,105,99,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,115,111,117,114,99,101,32,98,117,115,121,0,73,110,116,101,114,114,117,112,116,101,100,32,115,121,115,116,101,109,32,99,97,108,108,0,82,101,115,111,117,114,99,101,32,116,101,109,112,111,114,97,114,105,108,121,32,117,110,97,118,97,105,108,97,98,108,101,0,73,110,118,97,108,105,100,32,115,101,101,107,0,67,114,111,115,115,45,100,101,118,105,99,101,32,108,105,110,107,0,82,101,97,100,45,111,110,108,121,32,102,105,108,101,32,115,121,115,116,101,109,0,68,105,114,101,99,116,111,114,121,32,110,111,116,32,101,109,112,116,121,0,67,111,110,110,101,99,116,105,111,110,32,114,101,115,101,116,32,98,121,32,112,101,101,114,0,79,112,101,114,97,116,105,111,110,32,116,105,109,101,100,32,111,117,116,0,67,111,110,110,101,99,116,105,111,110,32,114,101,102,117,115,101,100,0,72,111,115,116,32,105,115,32,100,111,119,110,0,72,111,115,116,32,105,115,32,117,110,114,101,97,99,104,97,98,108,101,0,65,100,100,114,101,115,115,32,105,110,32,117,115,101,0,66,114,111,107,101,110,32,112,105,112,101,0,73,47,79,32,101,114,114,111,114,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,32,111,114,32,97,100,100,114,101,115,115,0,66,108,111,99,107,32,100,101,118,105,99,101,32,114,101,113,117,105,114,101,100,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,0,78,111,116,32,97,32,100,105,114,101,99,116,111,114,121,0,73,115,32,97,32,100,105,114,101,99,116,111,114,121,0,84,101,120,116,32,102,105,108,101,32,98,117,115,121,0,69,120,101,99,32,102,111,114,109,97,116,32,101,114,114,111,114,0,73,110,118,97,108,105,100,32,97,114,103,117,109,101,110,116,0,65,114,103,117,109,101,110,116,32,108,105,115,116,32,116,111,111,32,108,111,110,103,0,83,121,109,98,111,108,105,99,32,108,105,110,107,32,108,111,111,112,0,70,105,108,101,110,97,109,101,32,116,111,111,32,108,111,110,103,0,84,111,111,32,109,97,110,121,32,111,112,101,110,32,102,105,108,101,115,32,105,110,32,115,121,115,116,101,109,0,78,111,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,115,32,97,118,97,105,108,97,98,108,101,0,66,97,100,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,0,78,111,32,99,104,105,108,100,32,112,114,111,99,101,115,115,0,66,97,100,32,97,100,100,114,101,115,115,0,70,105,108,101,32,116,111,111,32,108,97,114,103,101,0,84,111,111,32,109,97,110,121,32,108,105,110,107,115,0,78,111,32,108,111,99,107,115,32,97,118,97,105,108,97,98,108,101,0,82,101,115,111,117,114,99,101,32,100,101,97,100,108,111,99,107,32,119,111,117,108,100,32,111,99,99,117,114,0,83,116,97,116,101,32,110,111,116,32,114,101,99,111,118,101,114,97,98,108,101,0,80,114,101,118,105,111,117,115,32,111,119,110,101,114,32,100,105,101,100,0,79,112,101,114,97,116,105,111,110,32,99,97,110,99,101,108,101,100,0,70,117,110,99,116,105,111,110,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,78,111,32,109,101,115,115,97,103,101,32,111,102,32,100,101,115,105,114,101,100,32,116,121,112,101,0,73,100,101,110,116,105,102,105,101,114,32,114,101,109,111,118,101,100,0,68,101,118,105,99,101,32,110,111,116,32,97,32,115,116,114,101,97,109,0,78,111,32,100,97,116,97,32,97,118,97,105,108,97,98,108,101,0,68,101,118,105,99,101,32,116,105,109,101,111,117,116,0,79,117,116,32,111,102,32,115,116,114,101,97,109,115,32,114,101,115,111,117,114,99,101,115,0,76,105,110,107,32,104,97,115,32,98,101,101,110,32,115,101,118,101,114,101,100,0,80,114,111,116,111,99,111,108,32,101,114,114,111,114,0,66,97,100,32,109,101,115,115,97,103,101,0,70,105,108,101,32,100,101,115,99,114,105,112,116,111,114,32,105,110,32,98,97,100,32,115,116,97,116,101,0,78,111,116,32,97,32,115,111,99,107,101,116,0,68,101,115,116,105,110,97,116,105,111,110,32,97,100,100,114,101,115,115,32,114,101,113,117,105,114,101,100,0,77,101,115,115,97,103,101,32,116,111,111,32,108,97,114,103,101,0,80,114,111,116,111,99,111,108,32,119,114,111,110,103,32,116,121,112,101,32,102,111,114,32,115,111,99,107,101,116,0,80,114,111,116,111,99,111,108,32,110,111,116,32,97,118,97,105,108,97,98,108,101,0,80,114,111,116,111,99,111,108,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,83,111,99,107,101,116,32,116,121,112,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,78,111,116,32,115,117,112,112,111,114,116,101,100,0,80,114,111,116,111,99,111,108,32,102,97,109,105,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,65,100,100,114,101,115,115,32,102,97,109,105,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,112,114,111,116,111,99,111,108,0,65,100,100,114,101,115,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,0,78,101,116,119,111,114,107,32,105,115,32,100,111,119,110,0,78,101,116,119,111,114,107,32,117,110,114,101,97,99,104,97,98,108,101,0,67,111,110,110,101,99,116,105,111,110,32,114,101,115,101,116,32,98,121,32,110,101,116,119,111,114,107,0,67,111,110,110,101,99,116,105,111,110,32,97,98,111,114,116,101,100,0,78,111,32,98,117,102,102,101,114,32,115,112,97,99,101,32,97,118,97,105,108,97,98,108,101,0,83,111,99,107,101,116,32,105,115,32,99,111,110,110,101,99,116,101,100,0,83,111,99,107,101,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,67,97,110,110,111,116,32,115,101,110,100,32,97,102,116,101,114,32,115,111,99,107,101,116,32,115,104,117,116,100,111,119,110,0,79,112,101,114,97,116,105,111,110,32,97,108,114,101,97,100,121,32,105,110,32,112,114,111,103,114,101,115,115,0,79,112,101,114,97,116,105,111,110,32,105,110,32,112,114,111,103,114,101,115,115,0,83,116,97,108,101,32,102,105,108,101,32,104,97,110,100,108,101,0,82,101,109,111,116,101,32,73,47,79,32,101,114,114,111,114,0,81,117,111,116,97,32,101,120,99,101,101,100,101,100,0,78,111,32,109,101,100,105,117,109,32,102,111,117,110,100,0,87,114,111,110,103,32,109,101,100,105,117,109,32,116,121,112,101,0,78,111,32,101,114,114,111,114,32,105,110,102,111,114,109,97,116,105,111,110,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,1,2,3,4,5,6,7,8,9,255,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+358412);allocate([34,35,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,1,2,4,7,3,6,5,0,17,0,10,0,17,17,17,0,0,0,0,5,0,0,0,0,0,0,9,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,15,10,17,17,17,3,10,7,0,1,19,9,11,11,0,0,9,6,11,0,0,11,0,6,17,0,0,0,17,17,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,10,10,17,17,17,0,10,0,0,2,0,9,11,0,0,0,9,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,4,13,0,0,0,0,9,14,0,0,0,0,0,14,0,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,15,0,0,0,0,9,16,0,0,0,0,0,16,0,0,16,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,10,0,0,0,0,9,11,0,0,0,0,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,45,43,32,32,32,48,88,48,120,0,40,110,117,108,108,41,0,45,48,88,43,48,88,32,48,88,45,48,120,43,48,120,32,48,120,0,105,110,102,0,73,78,70,0,78,65,78,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,105,110,102,105,110,105,116,121,0,110,97,110,0,114,119,97,0,47,116,109,112,47,116,109,112,102,105,108,101,95,88,88,88,88,88,88,0,119,43,0,76,67,95,65,76,76,0,76,67,95,67,84,89,80,69,0,0,0,0,76,67,95,78,85,77,69,82,73,67,0,0,76,67,95,84,73,77,69,0,0,0,0,0,76,67,95,67,79,76,76,65,84,69,0,0,76,67,95,77,79,78,69,84,65,82,89,0,76,67,95,77,69,83,83,65,71,69,83,0,76,65,78,71,0,67,46,85,84,70,45,56,0,80,79,83,73,88,0,77,85,83,76,95,76,79,67,80,65,84,72,0,78,83,116,51,95,95,50,56,105,111,115,95,98,97,115,101,69,0,78,83,116,51,95,95,50,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,78,83,116,51,95,95,50,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,78,83,116,51,95,95,50,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,78,83,116,51,95,95,50,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,78,83,116,51,95,95,50,55,99,111,108,108,97,116,101,73,99,69,69,0,78,83,116,51,95,95,50,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,78,83,116,51,95,95,50,55,99,111,108,108,97,116,101,73,119,69,69,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,37,112,0,67,0,78,83,116,51,95,95,50,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,78,83,116,51,95,95,50,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,78,83,116,51,95,95,50,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,37,112,0,0,0,0,76,0,37,0,0,0,0,0,78,83,116,51,95,95,50,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,78,83,116,51,95,95,50,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,78,83,116,51,95,95,50,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,37,72,58,37,77,58,37,83,0,37,109,47,37,100,47,37,121,0,37,73,58,37,77,58,37,83,32,37,112,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,65,77,0,80,77,0,74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,77,97,114,99,104,0,65,112,114,105,108,0,77,97,121,0,74,117,110,101,0,74,117,108,121,0,65,117,103,117,115,116,0,83,101,112,116,101,109,98,101,114,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,68,101,99,101,109,98,101,114,0,74,97,110,0,70,101,98,0,77,97,114,0,65,112,114,0,74,117,110,0,74,117,108,0,65,117,103,0,83,101,112,0,79,99,116,0,78,111,118,0,68,101,99,0,83,117,110,100,97,121,0,77,111,110,100,97,121,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,84,104,117,114,115,100,97,121,0,70,114,105,100,97,121,0,83,97,116,117,114,100,97,121,0,83,117,110,0,77,111,110,0,84,117,101,0,87,101,100,0,84,104,117,0,70,114,105,0,83,97,116,0,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,37,72,58,37,77,37,72,58,37,77,58,37,83,37,72,58,37,77,58,37,83,78,83,116,51,95,95,50,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,78,83,116,51,95,95,50,57,116,105,109,101,95,98,97,115,101,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,48,95,95,116,105,109,101,95,112,117,116,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,95,98,97,115,101,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,48,49,50,51,52,53,54,55,56,57,0,37,76,102,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,48,49,50,51,52,53,54,55,56,57,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,37,46,48,76,102,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,78,83,116,51,95,95,50,56,109,101,115,115,97,103,101,115,73,99,69,69,0,78,83,116,51,95,95,50,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,78,83,116,51,95,95,50,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,78,83,116,51,95,95,50,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,78,83,116,51,95,95,50,56,109,101,115,115,97,103,101,115,73,119,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,78,83,116,51,95,95,50,53,99,116,121,112,101,73,99,69,69,0,78,83,116,51,95,95,50,49,48,99,116,121,112,101,95,98,97,115,101,69,0,78,83,116,51,95,95,50,53,99,116,121,112,101,73,119,69,69,0,78,83,116,51,95,95,50,56,110,117,109,112,117,110,99,116,73,99,69,69,0,78,83,116,51,95,95,50,56,110,117,109,112,117,110,99,116,73,119,69,69,0,78,83,116,51,95,95,50,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,101,120,99,101,112,116,105,111,110,32,111,102,32,116,121,112,101,32,37,115,58,32,37,115,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,101,120,99,101,112,116,105,111,110,32,111,102,32,116,121,112,101,32,37,115,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,102,111,114,101,105,103,110,32,101,120,99,101,112,116,105,111,110,0,116,101,114,109,105,110,97,116,105,110,103,0,117,110,99,97,117,103,104,116,0,83,116,57,101,120,99,101,112,116,105,111,110,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,83,116,57,116,121,112,101,95,105,110,102,111,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,112,116,104,114,101,97,100,95,111,110,99,101,32,102,97,105,108,117,114,101,32,105,110,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,95,102,97,115,116,40,41,0,99,97,110,110,111,116,32,99,114,101,97,116,101,32,112,116,104,114,101,97,100,32,107,101,121,32,102,111,114,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,40,41,0,99,97,110,110,111,116,32,122,101,114,111,32,111,117,116,32,116,104,114,101,97,100,32,118,97,108,117,101,32,102,111,114,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,40,41,0,116,101,114,109,105,110,97,116,101,95,104,97,110,100,108,101,114,32,117,110,101,120,112,101,99,116,101,100,108,121,32,114,101,116,117,114,110,101,100,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,57,95,95,112,111,105,110,116,101,114,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,112,98,97,115,101,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,51,95,95,102,117,110,100,97,109,101,110,116,97,108,95,116,121,112,101,95,105,110,102,111,69,0,118,0,68,110,0,98,0,99,0,104,0,97,0,115,0,105,0,106,0,109,0,100,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,101,110,117,109,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,32,99,111,110,115,116,0,32,118,111,108,97,116,105,108,101,0,32,114,101,115,116,114,105,99,116,0,32,99,111,109,112,108,101,120,0,32,105,109,97,103,105,110,97,114,121,0,32,91,0,32,40,0,41,0,40,0,38,38,0,111,98,106,99,95,111,98,106,101,99,116,60,0,42,0,38,0,111,98,106,99,112,114,111,116,111,0,32,0,60,0,62,0,32,118,101,99,116,111,114,91,0,93,0,112,105,120,101,108,32,118,101,99,116,111,114,91,0,38,61,0,61,0,44,0,126,0,58,58,0,100,101,108,101,116,101,91,93,32,0,100,101,108,101,116,101,32,0,47,0,47,61,0,94,0,94,61,0,61,61,0,62,61,0,41,91,0,60,61,0,60,60,0,60,60,61,0,45,0,45,61,0,42,61,0,45,45,0,41,45,45,0,33,61,0,33,0,124,124,0,124,0,124,61,0,45,62,42,0,43,0,43,61,0,43,43,0,41,43,43,0,41,32,63,32,40,0,41,32,58,32,40,0,37,0,37,61,0,62,62,0,62,62,61,0,116,104,114,111,119,0,116,104,114,111,119,32,0,116,121,112,101,105,100,40,0,115,105,122,101,111,102,46,46,46,40,0,44,32,0,115,105,122,101,111,102,32,40,0,115,116,97,116,105,99,95,99,97,115,116,60,0,62,40,0,114,101,105,110,116,101,114,112,114,101,116,95,99,97,115,116,60,0,45,62,0,110,111,101,120,99,101,112,116,32,40,0,91,93,32,0,41,32,0,46,0,46,42,0,115,116,100,58,58,0,111,112,101,114,97,116,111,114,38,38,0,111,112,101,114,97,116,111,114,38,0,111,112,101,114,97,116,111,114,38,61,0,111,112,101,114,97,116,111,114,61,0,111,112,101,114,97,116,111,114,40,41,0,111,112,101,114,97,116,111,114,44,0,111,112,101,114,97,116,111,114,126,0,111,112,101,114,97,116,111,114,32,0,111,112,101,114,97,116,111,114,32,100,101,108,101,116,101,91,93,0,111,112,101,114,97,116,111,114,42,0,111,112,101,114,97,116,111,114,47,0,111,112,101,114,97,116,111,114,47,61,0,111,112,101,114,97,116,111,114,94,0,111,112,101,114,97,116,111,114,94,61,0,111,112,101,114,97,116,111,114,61,61,0,111,112,101,114,97,116,111,114,62,61,0,111,112,101,114,97,116,111,114,62,0,111,112,101,114,97,116,111,114,91,93,0,111,112,101,114,97,116,111,114,60,61,0,111,112,101,114,97,116,111,114,34,34,32,0,111,112,101,114,97,116,111,114,60,60,0,111,112,101,114,97,116,111,114,60,60,61,0,111,112,101,114,97,116,111,114,60,0,111,112,101,114,97,116,111,114,45,0,111,112,101,114,97,116,111,114,45,61,0,111,112,101,114,97,116,111,114,42,61,0,111,112,101,114,97,116,111,114,45,45,0,111,112,101,114,97,116,111,114,32,110,101,119,91,93,0,111,112,101,114,97,116,111,114,33,61,0,111,112,101,114,97,116,111,114,33,0,111,112,101,114,97,116,111,114,32,110,101,119,0,111,112,101,114,97,116,111,114,124,124,0,111,112,101,114,97,116,111,114,124,0,111,112,101,114,97,116,111,114,124,61,0,111,112,101,114,97,116,111,114,45,62,42,0,111,112,101,114,97,116,111,114,43,0,111,112,101,114,97,116,111,114,43,61,0,111,112,101,114,97,116,111,114,43,43,0,111,112,101,114,97,116,111,114,45,62,0,111,112,101,114,97,116,111,114,63,0,111,112,101,114,97,116,111,114,37,0,111,112,101,114,97,116,111,114,37,61,0,111,112,101,114,97,116,111,114,62,62,0,111,112,101,114,97,116,111,114,62,62,61,0,111,112,101,114,97,116,111,114,32,100,101,108,101,116,101,0,39,117,110,110,97,109,101,100,0,39,108,97,109,98,100,97,39,40,0,115,116,100,58,58,115,116,114,105,110,103,0,115,116,100,58,58,98,97,115,105,99,95,115,116,114,105,110,103,60,99,104,97,114,44,32,115,116,100,58,58,99,104,97,114,95,116,114,97,105,116,115,60,99,104,97,114,62,44,32,115,116,100,58,58,97,108,108,111,99,97,116,111,114,60,99,104,97,114,62,32,62,0,98,97,115,105,99,95,115,116,114,105,110,103,0,115,116,100,58,58,105,115,116,114,101,97,109,0,115,116,100,58,58,98,97,115,105,99,95,105,115,116,114,101,97,109,60,99,104,97,114,44,32,115,116,100,58,58,99,104,97,114,95,116,114,97,105,116,115,60,99,104,97,114,62,32,62,0,98,97,115,105,99,95,105,115,116,114,101,97,109,0,115,116,100,58,58,111,115,116,114,101,97,109,0,115,116,100,58,58,98,97,115,105,99,95,111,115,116,114,101,97,109,60,99,104,97,114,44,32,115,116,100,58,58,99,104,97,114,95,116,114,97,105,116,115,60,99,104,97,114,62,32,62,0,98,97,115,105,99,95,111,115,116,114,101,97,109,0,115,116,100,58,58,105,111,115,116,114,101,97,109,0,115,116,100,58,58,98,97,115,105,99,95,105,111,115,116,114,101,97,109,60,99,104,97,114,44,32,115,116,100,58,58,99,104,97,114,95,116,114,97,105,116,115,60,99,104,97,114,62,32,62,0,98,97,115,105,99,95,105,111,115,116,114,101,97,109,0,100,121,110,97,109,105,99,95,99,97,115,116,60,0,41,40,0,99,111,110,115,116,95,99,97,115,116,60,0,97,108,105,103,110,111,102,32,40,0,102,112,0,119,99,104,97,114,95,116,0,102,97,108,115,101,0,116,114,117,101,0,99,104,97,114,0,115,105,103,110,101,100,32,99,104,97,114,0,117,110,115,105,103,110,101,100,32,99,104,97,114,0,115,104,111,114,116,0,117,110,115,105,103,110,101,100,32,115,104,111,114,116,0,117,0,108,0,117,108,0,108,108,0,117,108,108,0,95,95,105,110,116,49,50,56,0,117,110,115,105,103,110,101,100,32,95,95,105,110,116,49,50,56,0,37,76,97,76,0,37,97,0,37,97,102,0,100,101,99,108,116,121,112,101,40,0,115,116,100,58,58,97,108,108,111,99,97,116,111,114,0,115,116,100,58,58,98,97,115,105,99,95,115,116,114,105,110,103,0,58,58,115,116,114,105,110,103,32,108,105,116,101,114,97,108,0,115,116,100,0,95,71,76,79,66,65,76,95,95,78,0,40,97,110,111,110,121,109,111,117,115,32,110,97,109,101,115,112,97,99,101,41,0,32,62,0,84,95,0,105,100,0,58,58,42,0,32,38,0,32,38,38,0,32,91,93,0,118,111,105,100,0,98,111,111,108,0,105,110,116,0,117,110,115,105,103,110,101,100,32,105,110,116,0,108,111,110,103,0,117,110,115,105,103,110,101,100,32,108,111,110,103,0,108,111,110,103,32,108,111,110,103,0,102,108,111,97,116,0,108,111,110,103,32,100,111,117,98,108,101,0,95,95,102,108,111,97,116,49,50,56,0,46,46,46,0,100,101,99,105,109,97,108,54,52,0,100,101,99,105,109,97,108,49,50,56,0,100,101,99,105,109,97,108,51,50,0,100,101,99,105,109,97,108,49,54,0,99,104,97,114,51,50,95,116,0,99,104,97,114,49,54,95,116,0,97,117,116,111,0,115,116,100,58,58,110,117,108,108,112,116,114,95,116,0,100,111,117,98,108,101,0,117,110,115,105,103,110,101,100,32,108,111,110,103,32,108,111,110,103,0,95,98,108,111,99,107,95,105,110,118,111,107,101,0,105,110,118,111,99,97,116,105,111,110,32,102,117,110,99,116,105,111,110,32,102,111,114,32,98,108,111,99,107,32,105,110,32,0,118,116,97,98,108,101,32,102,111,114,32,0,86,84,84,32,102,111,114,32,0,116,121,112,101,105,110,102,111,32,102,111,114,32,0,116,121,112,101,105,110,102,111,32,110,97,109,101,32,102,111,114,32,0,99,111,118,97,114,105,97,110,116,32,114,101,116,117,114,110,32,116,104,117,110,107,32,116,111,32,0,99,111,110,115,116,114,117,99,116,105,111,110,32,118,116,97,98,108,101,32,102,111,114,32,0,45,105,110,45,0,118,105,114,116,117,97,108,32,116,104,117,110,107,32,116,111,32,0,110,111,110,45,118,105,114,116,117,97,108,32,116,104,117,110,107,32,116,111,32,0,103,117,97,114,100,32,118,97,114,105,97,98,108,101,32,102,111,114,32,0,114,101,102,101,114,101,110,99,101,32,116,101,109,112,111,114,97,114,121,32,102,111,114,32,0],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+368652);var tempDoublePtr=STATICTOP;STATICTOP+=16;function _atexit(func,arg){__ATEXIT__.unshift({func:func,arg:arg})}function ___cxa_atexit(){return _atexit.apply(null,arguments)}var emval_symbols={};function embind_init_charCodes(){var codes=new Array(256);for(var i=0;i<256;++i){codes[i]=String.fromCharCode(i)}embind_charCodes=codes}var embind_charCodes=undefined;function readLatin1String(ptr){var ret="";var c=ptr;while(HEAPU8[c]){ret+=embind_charCodes[HEAPU8[c++]]}return ret}function getStringOrSymbol(address){var symbol=emval_symbols[address];if(symbol===undefined){return readLatin1String(address)}else{return symbol}}var emval_free_list=[];var emval_handle_array=[{},{value:undefined},{value:null},{value:true},{value:false}];function count_emval_handles(){var count=0;for(var i=5;i<emval_handle_array.length;++i){if(emval_handle_array[i]!==undefined){++count}}return count}function get_first_emval(){for(var i=5;i<emval_handle_array.length;++i){if(emval_handle_array[i]!==undefined){return emval_handle_array[i]}}return null}function init_emval(){Module["count_emval_handles"]=count_emval_handles;Module["get_first_emval"]=get_first_emval}function __emval_register(value){switch(value){case undefined:{return 1};case null:{return 2};case true:{return 3};case false:{return 4};default:{var handle=emval_free_list.length?emval_free_list.pop():emval_handle_array.length;emval_handle_array[handle]={refcount:1,value:value};return handle}}}function __emval_new_cstring(v){return __emval_register(getStringOrSymbol(v))}Module["_i64Subtract"]=_i64Subtract;Module["_i64Add"]=_i64Add;var emval_methodCallers=[];function __emval_addMethodCaller(caller){var id=emval_methodCallers.length;emval_methodCallers.push(caller);return id}var registeredTypes={};function getTypeName(type){var ptr=___getTypeName(type);var rv=readLatin1String(ptr);_free(ptr);return rv}var char_0=48;var char_9=57;function makeLegalFunctionName(name){if(undefined===name){return"_unknown"}name=name.replace(/[^a-zA-Z0-9_]/g,"$");var f=name.charCodeAt(0);if(f>=char_0&&f<=char_9){return"_"+name}else{return name}}function createNamedFunction(name,body){name=makeLegalFunctionName(name);return(new Function("body","return function "+name+"() {\n"+'    "use strict";'+"    return body.apply(this, arguments);\n"+"};\n"))(body)}function extendError(baseErrorType,errorName){var errorClass=createNamedFunction(errorName,(function(message){this.name=errorName;this.message=message;var stack=(new Error(message)).stack;if(stack!==undefined){this.stack=this.toString()+"\n"+stack.replace(/^Error(:[^\n]*)?\n/,"")}}));errorClass.prototype=Object.create(baseErrorType.prototype);errorClass.prototype.constructor=errorClass;errorClass.prototype.toString=(function(){if(this.message===undefined){return this.name}else{return this.name+": "+this.message}});return errorClass}var BindingError=undefined;function throwBindingError(message){throw new BindingError(message)}function requireRegisteredType(rawType,humanName){var impl=registeredTypes[rawType];if(undefined===impl){throwBindingError(humanName+" has unknown type "+getTypeName(rawType))}return impl}function __emval_lookupTypes(argCount,argTypes,argWireTypes){var a=new Array(argCount);for(var i=0;i<argCount;++i){a[i]=requireRegisteredType(HEAP32[(argTypes>>2)+i],"parameter "+i)}return a}function new_(constructor,argumentList){if(!(constructor instanceof Function)){throw new TypeError("new_ called with constructor type "+typeof constructor+" which is not a function")}var dummy=createNamedFunction(constructor.name||"unknownFunctionName",(function(){}));dummy.prototype=constructor.prototype;var obj=new dummy;var r=constructor.apply(obj,argumentList);return r instanceof Object?r:obj}function __emval_get_method_caller(argCount,argTypes){var types=__emval_lookupTypes(argCount,argTypes);var retType=types[0];var signatureName=retType.name+"_$"+types.slice(1).map((function(t){return t.name})).join("_")+"$";var params=["retType"];var args=[retType];var argsList="";for(var i=0;i<argCount-1;++i){argsList+=(i!==0?", ":"")+"arg"+i;params.push("argType"+i);args.push(types[1+i])}var functionName=makeLegalFunctionName("methodCaller_"+signatureName);var functionBody="return function "+functionName+"(handle, name, destructors, args) {\n";var offset=0;for(var i=0;i<argCount-1;++i){functionBody+="    var arg"+i+" = argType"+i+".readValueFromPointer(args"+(offset?"+"+offset:"")+");\n";offset+=types[i+1]["argPackAdvance"]}functionBody+="    var rv = handle[name]("+argsList+");\n";for(var i=0;i<argCount-1;++i){if(types[i+1]["deleteObject"]){functionBody+="    argType"+i+".deleteObject(arg"+i+");\n"}}if(!retType.isVoid){functionBody+="    return retType.toWireType(destructors, rv);\n"}functionBody+="};\n";params.push(functionBody);var invokerFunction=new_(Function,params).apply(null,args);return __emval_addMethodCaller(invokerFunction)}function __ZSt18uncaught_exceptionv(){return!!__ZSt18uncaught_exceptionv.uncaught_exception}var EXCEPTIONS={last:0,caught:[],infos:{},deAdjust:(function(adjusted){if(!adjusted||EXCEPTIONS.infos[adjusted])return adjusted;for(var ptr in EXCEPTIONS.infos){var info=EXCEPTIONS.infos[ptr];if(info.adjusted===adjusted){return ptr}}return adjusted}),addRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];info.refcount++}),decRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];assert(info.refcount>0);info.refcount--;if(info.refcount===0&&!info.rethrown){if(info.destructor){Module["dynCall_vi"](info.destructor,ptr)}delete EXCEPTIONS.infos[ptr];___cxa_free_exception(ptr)}}),clearRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];info.refcount=0})};function ___resumeException(ptr){if(!EXCEPTIONS.last){EXCEPTIONS.last=ptr}throw ptr+" - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch."}function ___cxa_find_matching_catch(){var thrown=EXCEPTIONS.last;if(!thrown){return(Runtime.setTempRet0(0),0)|0}var info=EXCEPTIONS.infos[thrown];var throwntype=info.type;if(!throwntype){return(Runtime.setTempRet0(0),thrown)|0}var typeArray=Array.prototype.slice.call(arguments);var pointer=Module["___cxa_is_pointer_type"](throwntype);if(!___cxa_find_matching_catch.buffer)___cxa_find_matching_catch.buffer=_malloc(4);HEAP32[___cxa_find_matching_catch.buffer>>2]=thrown;thrown=___cxa_find_matching_catch.buffer;for(var i=0;i<typeArray.length;i++){if(typeArray[i]&&Module["___cxa_can_catch"](typeArray[i],throwntype,thrown)){thrown=HEAP32[thrown>>2];info.adjusted=thrown;return(Runtime.setTempRet0(typeArray[i]),thrown)|0}}thrown=HEAP32[thrown>>2];return(Runtime.setTempRet0(throwntype),thrown)|0}function ___cxa_throw(ptr,type,destructor){EXCEPTIONS.infos[ptr]={ptr:ptr,adjusted:ptr,type:type,destructor:destructor,refcount:0,caught:false,rethrown:false};EXCEPTIONS.last=ptr;if(!("uncaught_exception"in __ZSt18uncaught_exceptionv)){__ZSt18uncaught_exceptionv.uncaught_exception=1}else{__ZSt18uncaught_exceptionv.uncaught_exception++}throw ptr+" - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch."}Module["_pthread_mutex_unlock"]=_pthread_mutex_unlock;Module["_pthread_mutex_lock"]=_pthread_mutex_lock;Module["_memset"]=_memset;var awaitingDependencies={};var typeDependencies={};var InternalError=undefined;function throwInternalError(message){throw new InternalError(message)}function whenDependentTypesAreResolved(myTypes,dependentTypes,getTypeConverters){myTypes.forEach((function(type){typeDependencies[type]=dependentTypes}));function onComplete(typeConverters){var myTypeConverters=getTypeConverters(typeConverters);if(myTypeConverters.length!==myTypes.length){throwInternalError("Mismatched type converter count")}for(var i=0;i<myTypes.length;++i){registerType(myTypes[i],myTypeConverters[i])}}var typeConverters=new Array(dependentTypes.length);var unregisteredTypes=[];var registered=0;dependentTypes.forEach((function(dt,i){if(registeredTypes.hasOwnProperty(dt)){typeConverters[i]=registeredTypes[dt]}else{unregisteredTypes.push(dt);if(!awaitingDependencies.hasOwnProperty(dt)){awaitingDependencies[dt]=[]}awaitingDependencies[dt].push((function(){typeConverters[i]=registeredTypes[dt];++registered;if(registered===unregisteredTypes.length){onComplete(typeConverters)}}))}}));if(0===unregisteredTypes.length){onComplete(typeConverters)}}function registerType(rawType,registeredInstance,options){options=options||{};if(!("argPackAdvance"in registeredInstance)){throw new TypeError("registerType registeredInstance requires argPackAdvance")}var name=registeredInstance.name;if(!rawType){throwBindingError('type "'+name+'" must have a positive integer typeid pointer')}if(registeredTypes.hasOwnProperty(rawType)){if(options.ignoreDuplicateRegistrations){return}else{throwBindingError("Cannot register type '"+name+"' twice")}}registeredTypes[rawType]=registeredInstance;delete typeDependencies[rawType];if(awaitingDependencies.hasOwnProperty(rawType)){var callbacks=awaitingDependencies[rawType];delete awaitingDependencies[rawType];callbacks.forEach((function(cb){cb()}))}}function simpleReadValueFromPointer(pointer){return this["fromWireType"](HEAPU32[pointer>>2])}function __embind_register_std_string(rawType,name){name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":(function(value){var length=HEAPU32[value>>2];var a=new Array(length);for(var i=0;i<length;++i){a[i]=String.fromCharCode(HEAPU8[value+4+i])}_free(value);return a.join("")}),"toWireType":(function(destructors,value){if(value instanceof ArrayBuffer){value=new Uint8Array(value)}function getTAElement(ta,index){return ta[index]}function getStringElement(string,index){return string.charCodeAt(index)}var getElement;if(value instanceof Uint8Array){getElement=getTAElement}else if(value instanceof Uint8ClampedArray){getElement=getTAElement}else if(value instanceof Int8Array){getElement=getTAElement}else if(typeof value==="string"){getElement=getStringElement}else{throwBindingError("Cannot pass non-string to std::string")}var length=value.length;var ptr=_malloc(4+length);HEAPU32[ptr>>2]=length;for(var i=0;i<length;++i){var charCode=getElement(value,i);if(charCode>255){_free(ptr);throwBindingError("String has UTF-16 code units that do not fit in 8 bits")}HEAPU8[ptr+4+i]=charCode}if(destructors!==null){destructors.push(_free,ptr)}return ptr}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:(function(ptr){_free(ptr)})})}function __embind_register_std_wstring(rawType,charSize,name){name=readLatin1String(name);var getHeap,shift;if(charSize===2){getHeap=(function(){return HEAPU16});shift=1}else if(charSize===4){getHeap=(function(){return HEAPU32});shift=2}registerType(rawType,{name:name,"fromWireType":(function(value){var HEAP=getHeap();var length=HEAPU32[value>>2];var a=new Array(length);var start=value+4>>shift;for(var i=0;i<length;++i){a[i]=String.fromCharCode(HEAP[start+i])}_free(value);return a.join("")}),"toWireType":(function(destructors,value){var HEAP=getHeap();var length=value.length;var ptr=_malloc(4+length*charSize);HEAPU32[ptr>>2]=length;var start=ptr+4>>shift;for(var i=0;i<length;++i){HEAP[start+i]=value.charCodeAt(i)}if(destructors!==null){destructors.push(_free,ptr)}return ptr}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:(function(ptr){_free(ptr)})})}function _pthread_mutex_init(){}function __emval_decref(handle){if(handle>4&&0===--emval_handle_array[handle].refcount){emval_handle_array[handle]=undefined;emval_free_list.push(handle)}}function _embind_repr(v){if(v===null){return"null"}var t=typeof v;if(t==="object"||t==="array"||t==="function"){return v.toString()}else{return""+v}}function getShiftFromSize(size){switch(size){case 1:return 0;case 2:return 1;case 4:return 2;case 8:return 3;default:throw new TypeError("Unknown type size: "+size)}}function integerReadValueFromPointer(name,shift,signed){switch(shift){case 0:return signed?function readS8FromPointer(pointer){return HEAP8[pointer]}:function readU8FromPointer(pointer){return HEAPU8[pointer]};case 1:return signed?function readS16FromPointer(pointer){return HEAP16[pointer>>1]}:function readU16FromPointer(pointer){return HEAPU16[pointer>>1]};case 2:return signed?function readS32FromPointer(pointer){return HEAP32[pointer>>2]}:function readU32FromPointer(pointer){return HEAPU32[pointer>>2]};default:throw new TypeError("Unknown integer type: "+name)}}function __embind_register_integer(primitiveType,name,size,minRange,maxRange){name=readLatin1String(name);if(maxRange===-1){maxRange=4294967295}var shift=getShiftFromSize(size);var fromWireType=(function(value){return value});if(minRange===0){var bitshift=32-8*size;fromWireType=(function(value){return value<<bitshift>>>bitshift})}var isUnsignedType=name.indexOf("unsigned")!=-1;registerType(primitiveType,{name:name,"fromWireType":fromWireType,"toWireType":(function(destructors,value){if(typeof value!=="number"&&typeof value!=="boolean"){throw new TypeError('Cannot convert "'+_embind_repr(value)+'" to '+this.name)}if(value<minRange||value>maxRange){throw new TypeError('Passing a number "'+_embind_repr(value)+'" from JS side to C/C++ side to an argument of type "'+name+'", which is outside the valid range ['+minRange+", "+maxRange+"]!")}return isUnsignedType?value>>>0:value|0}),"argPackAdvance":8,"readValueFromPointer":integerReadValueFromPointer(name,shift,minRange!==0),destructorFunction:null})}var structRegistrations={};function runDestructors(destructors){while(destructors.length){var ptr=destructors.pop();var del=destructors.pop();del(ptr)}}function __embind_finalize_value_object(structType){var reg=structRegistrations[structType];delete structRegistrations[structType];var rawConstructor=reg.rawConstructor;var rawDestructor=reg.rawDestructor;var fieldRecords=reg.fields;var fieldTypes=fieldRecords.map((function(field){return field.getterReturnType})).concat(fieldRecords.map((function(field){return field.setterArgumentType})));whenDependentTypesAreResolved([structType],fieldTypes,(function(fieldTypes){var fields={};fieldRecords.forEach((function(field,i){var fieldName=field.fieldName;var getterReturnType=fieldTypes[i];var getter=field.getter;var getterContext=field.getterContext;var setterArgumentType=fieldTypes[i+fieldRecords.length];var setter=field.setter;var setterContext=field.setterContext;fields[fieldName]={read:(function(ptr){return getterReturnType["fromWireType"](getter(getterContext,ptr))}),write:(function(ptr,o){var destructors=[];setter(setterContext,ptr,setterArgumentType["toWireType"](destructors,o));runDestructors(destructors)})}}));return[{name:reg.name,"fromWireType":(function(ptr){var rv={};for(var i in fields){rv[i]=fields[i].read(ptr)}rawDestructor(ptr);return rv}),"toWireType":(function(destructors,o){for(var fieldName in fields){if(!(fieldName in o)){throw new TypeError("Missing field")}}var ptr=rawConstructor();for(fieldName in fields){fields[fieldName].write(ptr,o[fieldName])}if(destructors!==null){destructors.push(rawDestructor,ptr)}return ptr}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:rawDestructor}]}))}var PTHREAD_SPECIFIC={};var PTHREAD_SPECIFIC_NEXT_KEY=1;var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};function _pthread_key_create(key,destructor){if(key==0){return ERRNO_CODES.EINVAL}HEAP32[key>>2]=PTHREAD_SPECIFIC_NEXT_KEY;PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY]=0;PTHREAD_SPECIFIC_NEXT_KEY++;return 0}function __emval_take_value(type,argv){type=requireRegisteredType(type,"_emval_take_value");var v=type["readValueFromPointer"](argv);return __emval_register(v)}Module["_saveSetjmp"]=_saveSetjmp;var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};function ___setErrNo(value){if(Module["___errno_location"])HEAP32[Module["___errno_location"]()>>2]=value;return value}var PATH={splitPath:(function(filename){var splitPathRe=/^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;return splitPathRe.exec(filename).slice(1)}),normalizeArray:(function(parts,allowAboveRoot){var up=0;for(var i=parts.length-1;i>=0;i--){var last=parts[i];if(last==="."){parts.splice(i,1)}else if(last===".."){parts.splice(i,1);up++}else if(up){parts.splice(i,1);up--}}if(allowAboveRoot){for(;up--;up){parts.unshift("..")}}return parts}),normalize:(function(path){var isAbsolute=path.charAt(0)==="/",trailingSlash=path.substr(-1)==="/";path=PATH.normalizeArray(path.split("/").filter((function(p){return!!p})),!isAbsolute).join("/");if(!path&&!isAbsolute){path="."}if(path&&trailingSlash){path+="/"}return(isAbsolute?"/":"")+path}),dirname:(function(path){var result=PATH.splitPath(path),root=result[0],dir=result[1];if(!root&&!dir){return"."}if(dir){dir=dir.substr(0,dir.length-1)}return root+dir}),basename:(function(path){if(path==="/")return"/";var lastSlash=path.lastIndexOf("/");if(lastSlash===-1)return path;return path.substr(lastSlash+1)}),extname:(function(path){return PATH.splitPath(path)[3]}),join:(function(){var paths=Array.prototype.slice.call(arguments,0);return PATH.normalize(paths.join("/"))}),join2:(function(l,r){return PATH.normalize(l+"/"+r)}),resolve:(function(){var resolvedPath="",resolvedAbsolute=false;for(var i=arguments.length-1;i>=-1&&!resolvedAbsolute;i--){var path=i>=0?arguments[i]:FS.cwd();if(typeof path!=="string"){throw new TypeError("Arguments to path.resolve must be strings")}else if(!path){return""}resolvedPath=path+"/"+resolvedPath;resolvedAbsolute=path.charAt(0)==="/"}resolvedPath=PATH.normalizeArray(resolvedPath.split("/").filter((function(p){return!!p})),!resolvedAbsolute).join("/");return(resolvedAbsolute?"/":"")+resolvedPath||"."}),relative:(function(from,to){from=PATH.resolve(from).substr(1);to=PATH.resolve(to).substr(1);function trim(arr){var start=0;for(;start<arr.length;start++){if(arr[start]!=="")break}var end=arr.length-1;for(;end>=0;end--){if(arr[end]!=="")break}if(start>end)return[];return arr.slice(start,end-start+1)}var fromParts=trim(from.split("/"));var toParts=trim(to.split("/"));var length=Math.min(fromParts.length,toParts.length);var samePartsLength=length;for(var i=0;i<length;i++){if(fromParts[i]!==toParts[i]){samePartsLength=i;break}}var outputParts=[];for(var i=samePartsLength;i<fromParts.length;i++){outputParts.push("..")}outputParts=outputParts.concat(toParts.slice(samePartsLength));return outputParts.join("/")})};var TTY={ttys:[],init:(function(){}),shutdown:(function(){}),register:(function(dev,ops){TTY.ttys[dev]={input:[],output:[],ops:ops};FS.registerDevice(dev,TTY.stream_ops)}),stream_ops:{open:(function(stream){var tty=TTY.ttys[stream.node.rdev];if(!tty){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}stream.tty=tty;stream.seekable=false}),close:(function(stream){stream.tty.ops.flush(stream.tty)}),flush:(function(stream){stream.tty.ops.flush(stream.tty)}),read:(function(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.get_char){throw new FS.ErrnoError(ERRNO_CODES.ENXIO)}var bytesRead=0;for(var i=0;i<length;i++){var result;try{result=stream.tty.ops.get_char(stream.tty)}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}if(result===undefined&&bytesRead===0){throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}if(result===null||result===undefined)break;bytesRead++;buffer[offset+i]=result}if(bytesRead){stream.node.timestamp=Date.now()}return bytesRead}),write:(function(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.put_char){throw new FS.ErrnoError(ERRNO_CODES.ENXIO)}for(var i=0;i<length;i++){try{stream.tty.ops.put_char(stream.tty,buffer[offset+i])}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}}if(length){stream.node.timestamp=Date.now()}return i})},default_tty_ops:{get_char:(function(tty){if(!tty.input.length){var result=null;if(ENVIRONMENT_IS_NODE){var BUFSIZE=256;var buf=new Buffer(BUFSIZE);var bytesRead=0;var isPosixPlatform=process.platform!="win32";var fd=process.stdin.fd;if(isPosixPlatform){var usingDevice=false;try{fd=fs.openSync("/dev/stdin","r");usingDevice=true}catch(e){}}try{bytesRead=fs.readSync(fd,buf,0,BUFSIZE,null)}catch(e){if(e.toString().indexOf("EOF")!=-1)bytesRead=0;else throw e}if(usingDevice){fs.closeSync(fd)}if(bytesRead>0){result=buf.slice(0,bytesRead).toString("utf-8")}else{result=null}}else if(typeof window!="undefined"&&typeof window.prompt=="function"){result=window.prompt("Input: ");if(result!==null){result+="\n"}}else if(typeof readline=="function"){result=readline();if(result!==null){result+="\n"}}if(!result){return null}tty.input=intArrayFromString(result,true)}return tty.input.shift()}),put_char:(function(tty,val){if(val===null||val===10){Module["print"](UTF8ArrayToString(tty.output,0));tty.output=[]}else{if(val!=0)tty.output.push(val)}}),flush:(function(tty){if(tty.output&&tty.output.length>0){Module["print"](UTF8ArrayToString(tty.output,0));tty.output=[]}})},default_tty1_ops:{put_char:(function(tty,val){if(val===null||val===10){Module["printErr"](UTF8ArrayToString(tty.output,0));tty.output=[]}else{if(val!=0)tty.output.push(val)}}),flush:(function(tty){if(tty.output&&tty.output.length>0){Module["printErr"](UTF8ArrayToString(tty.output,0));tty.output=[]}})}};var MEMFS={ops_table:null,mount:(function(mount){return MEMFS.createNode(null,"/",16384|511,0)}),createNode:(function(parent,name,mode,dev){if(FS.isBlkdev(mode)||FS.isFIFO(mode)){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(!MEMFS.ops_table){MEMFS.ops_table={dir:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,lookup:MEMFS.node_ops.lookup,mknod:MEMFS.node_ops.mknod,rename:MEMFS.node_ops.rename,unlink:MEMFS.node_ops.unlink,rmdir:MEMFS.node_ops.rmdir,readdir:MEMFS.node_ops.readdir,symlink:MEMFS.node_ops.symlink},stream:{llseek:MEMFS.stream_ops.llseek}},file:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:{llseek:MEMFS.stream_ops.llseek,read:MEMFS.stream_ops.read,write:MEMFS.stream_ops.write,allocate:MEMFS.stream_ops.allocate,mmap:MEMFS.stream_ops.mmap,msync:MEMFS.stream_ops.msync}},link:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,readlink:MEMFS.node_ops.readlink},stream:{}},chrdev:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:FS.chrdev_stream_ops}}}var node=FS.createNode(parent,name,mode,dev);if(FS.isDir(node.mode)){node.node_ops=MEMFS.ops_table.dir.node;node.stream_ops=MEMFS.ops_table.dir.stream;node.contents={}}else if(FS.isFile(node.mode)){node.node_ops=MEMFS.ops_table.file.node;node.stream_ops=MEMFS.ops_table.file.stream;node.usedBytes=0;node.contents=null}else if(FS.isLink(node.mode)){node.node_ops=MEMFS.ops_table.link.node;node.stream_ops=MEMFS.ops_table.link.stream}else if(FS.isChrdev(node.mode)){node.node_ops=MEMFS.ops_table.chrdev.node;node.stream_ops=MEMFS.ops_table.chrdev.stream}node.timestamp=Date.now();if(parent){parent.contents[name]=node}return node}),getFileDataAsRegularArray:(function(node){if(node.contents&&node.contents.subarray){var arr=[];for(var i=0;i<node.usedBytes;++i)arr.push(node.contents[i]);return arr}return node.contents}),getFileDataAsTypedArray:(function(node){if(!node.contents)return new Uint8Array;if(node.contents.subarray)return node.contents.subarray(0,node.usedBytes);return new Uint8Array(node.contents)}),expandFileStorage:(function(node,newCapacity){if(node.contents&&node.contents.subarray&&newCapacity>node.contents.length){node.contents=MEMFS.getFileDataAsRegularArray(node);node.usedBytes=node.contents.length}if(!node.contents||node.contents.subarray){var prevCapacity=node.contents?node.contents.length:0;if(prevCapacity>=newCapacity)return;var CAPACITY_DOUBLING_MAX=1024*1024;newCapacity=Math.max(newCapacity,prevCapacity*(prevCapacity<CAPACITY_DOUBLING_MAX?2:1.125)|0);if(prevCapacity!=0)newCapacity=Math.max(newCapacity,256);var oldContents=node.contents;node.contents=new Uint8Array(newCapacity);if(node.usedBytes>0)node.contents.set(oldContents.subarray(0,node.usedBytes),0);return}if(!node.contents&&newCapacity>0)node.contents=[];while(node.contents.length<newCapacity)node.contents.push(0)}),resizeFileStorage:(function(node,newSize){if(node.usedBytes==newSize)return;if(newSize==0){node.contents=null;node.usedBytes=0;return}if(!node.contents||node.contents.subarray){var oldContents=node.contents;node.contents=new Uint8Array(new ArrayBuffer(newSize));if(oldContents){node.contents.set(oldContents.subarray(0,Math.min(newSize,node.usedBytes)))}node.usedBytes=newSize;return}if(!node.contents)node.contents=[];if(node.contents.length>newSize)node.contents.length=newSize;else while(node.contents.length<newSize)node.contents.push(0);node.usedBytes=newSize}),node_ops:{getattr:(function(node){var attr={};attr.dev=FS.isChrdev(node.mode)?node.id:1;attr.ino=node.id;attr.mode=node.mode;attr.nlink=1;attr.uid=0;attr.gid=0;attr.rdev=node.rdev;if(FS.isDir(node.mode)){attr.size=4096}else if(FS.isFile(node.mode)){attr.size=node.usedBytes}else if(FS.isLink(node.mode)){attr.size=node.link.length}else{attr.size=0}attr.atime=new Date(node.timestamp);attr.mtime=new Date(node.timestamp);attr.ctime=new Date(node.timestamp);attr.blksize=4096;attr.blocks=Math.ceil(attr.size/attr.blksize);return attr}),setattr:(function(node,attr){if(attr.mode!==undefined){node.mode=attr.mode}if(attr.timestamp!==undefined){node.timestamp=attr.timestamp}if(attr.size!==undefined){MEMFS.resizeFileStorage(node,attr.size)}}),lookup:(function(parent,name){throw FS.genericErrors[ERRNO_CODES.ENOENT]}),mknod:(function(parent,name,mode,dev){return MEMFS.createNode(parent,name,mode,dev)}),rename:(function(old_node,new_dir,new_name){if(FS.isDir(old_node.mode)){var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(new_node){for(var i in new_node.contents){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}}}delete old_node.parent.contents[old_node.name];old_node.name=new_name;new_dir.contents[new_name]=old_node;old_node.parent=new_dir}),unlink:(function(parent,name){delete parent.contents[name]}),rmdir:(function(parent,name){var node=FS.lookupNode(parent,name);for(var i in node.contents){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}delete parent.contents[name]}),readdir:(function(node){var entries=[".",".."];for(var key in node.contents){if(!node.contents.hasOwnProperty(key)){continue}entries.push(key)}return entries}),symlink:(function(parent,newname,oldpath){var node=MEMFS.createNode(parent,newname,511|40960,0);node.link=oldpath;return node}),readlink:(function(node){if(!FS.isLink(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return node.link})},stream_ops:{read:(function(stream,buffer,offset,length,position){var contents=stream.node.contents;if(position>=stream.node.usedBytes)return 0;var size=Math.min(stream.node.usedBytes-position,length);assert(size>=0);if(size>8&&contents.subarray){buffer.set(contents.subarray(position,position+size),offset)}else{for(var i=0;i<size;i++)buffer[offset+i]=contents[position+i]}return size}),write:(function(stream,buffer,offset,length,position,canOwn){if(!length)return 0;var node=stream.node;node.timestamp=Date.now();if(buffer.subarray&&(!node.contents||node.contents.subarray)){if(canOwn){node.contents=buffer.subarray(offset,offset+length);node.usedBytes=length;return length}else if(node.usedBytes===0&&position===0){node.contents=new Uint8Array(buffer.subarray(offset,offset+length));node.usedBytes=length;return length}else if(position+length<=node.usedBytes){node.contents.set(buffer.subarray(offset,offset+length),position);return length}}MEMFS.expandFileStorage(node,position+length);if(node.contents.subarray&&buffer.subarray)node.contents.set(buffer.subarray(offset,offset+length),position);else{for(var i=0;i<length;i++){node.contents[position+i]=buffer[offset+i]}}node.usedBytes=Math.max(node.usedBytes,position+length);return length}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){position+=stream.node.usedBytes}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position}),allocate:(function(stream,offset,length){MEMFS.expandFileStorage(stream.node,offset+length);stream.node.usedBytes=Math.max(stream.node.usedBytes,offset+length)}),mmap:(function(stream,buffer,offset,length,position,prot,flags){if(!FS.isFile(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}var ptr;var allocated;var contents=stream.node.contents;if(!(flags&2)&&(contents.buffer===buffer||contents.buffer===buffer.buffer)){allocated=false;ptr=contents.byteOffset}else{if(position>0||position+length<stream.node.usedBytes){if(contents.subarray){contents=contents.subarray(position,position+length)}else{contents=Array.prototype.slice.call(contents,position,position+length)}}allocated=true;ptr=_malloc(length);if(!ptr){throw new FS.ErrnoError(ERRNO_CODES.ENOMEM)}buffer.set(contents,ptr)}return{ptr:ptr,allocated:allocated}}),msync:(function(stream,buffer,offset,length,mmapFlags){if(!FS.isFile(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}if(mmapFlags&2){return 0}var bytesWritten=MEMFS.stream_ops.write(stream,buffer,0,length,offset,false);return 0})}};var IDBFS={dbs:{},indexedDB:(function(){if(typeof indexedDB!=="undefined")return indexedDB;var ret=null;if(typeof window==="object")ret=window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB;assert(ret,"IDBFS used, but indexedDB not supported");return ret}),DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:(function(mount){return MEMFS.mount.apply(null,arguments)}),syncfs:(function(mount,populate,callback){IDBFS.getLocalSet(mount,(function(err,local){if(err)return callback(err);IDBFS.getRemoteSet(mount,(function(err,remote){if(err)return callback(err);var src=populate?remote:local;var dst=populate?local:remote;IDBFS.reconcile(src,dst,callback)}))}))}),getDB:(function(name,callback){var db=IDBFS.dbs[name];if(db){return callback(null,db)}var req;try{req=IDBFS.indexedDB().open(name,IDBFS.DB_VERSION)}catch(e){return callback(e)}if(!req){return callback("Unable to connect to IndexedDB")}req.onupgradeneeded=(function(e){var db=e.target.result;var transaction=e.target.transaction;var fileStore;if(db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)){fileStore=transaction.objectStore(IDBFS.DB_STORE_NAME)}else{fileStore=db.createObjectStore(IDBFS.DB_STORE_NAME)}if(!fileStore.indexNames.contains("timestamp")){fileStore.createIndex("timestamp","timestamp",{unique:false})}});req.onsuccess=(function(){db=req.result;IDBFS.dbs[name]=db;callback(null,db)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),getLocalSet:(function(mount,callback){var entries={};function isRealDir(p){return p!=="."&&p!==".."}function toAbsolute(root){return(function(p){return PATH.join2(root,p)})}var check=FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));while(check.length){var path=check.pop();var stat;try{stat=FS.stat(path)}catch(e){return callback(e)}if(FS.isDir(stat.mode)){check.push.apply(check,FS.readdir(path).filter(isRealDir).map(toAbsolute(path)))}entries[path]={timestamp:stat.mtime}}return callback(null,{type:"local",entries:entries})}),getRemoteSet:(function(mount,callback){var entries={};IDBFS.getDB(mount.mountpoint,(function(err,db){if(err)return callback(err);var transaction=db.transaction([IDBFS.DB_STORE_NAME],"readonly");transaction.onerror=(function(e){callback(this.error);e.preventDefault()});var store=transaction.objectStore(IDBFS.DB_STORE_NAME);var index=store.index("timestamp");index.openKeyCursor().onsuccess=(function(event){var cursor=event.target.result;if(!cursor){return callback(null,{type:"remote",db:db,entries:entries})}entries[cursor.primaryKey]={timestamp:cursor.key};cursor.continue()})}))}),loadLocalEntry:(function(path,callback){var stat,node;try{var lookup=FS.lookupPath(path);node=lookup.node;stat=FS.stat(path)}catch(e){return callback(e)}if(FS.isDir(stat.mode)){return callback(null,{timestamp:stat.mtime,mode:stat.mode})}else if(FS.isFile(stat.mode)){node.contents=MEMFS.getFileDataAsTypedArray(node);return callback(null,{timestamp:stat.mtime,mode:stat.mode,contents:node.contents})}else{return callback(new Error("node type not supported"))}}),storeLocalEntry:(function(path,entry,callback){try{if(FS.isDir(entry.mode)){FS.mkdir(path,entry.mode)}else if(FS.isFile(entry.mode)){FS.writeFile(path,entry.contents,{encoding:"binary",canOwn:true})}else{return callback(new Error("node type not supported"))}FS.chmod(path,entry.mode);FS.utime(path,entry.timestamp,entry.timestamp)}catch(e){return callback(e)}callback(null)}),removeLocalEntry:(function(path,callback){try{var lookup=FS.lookupPath(path);var stat=FS.stat(path);if(FS.isDir(stat.mode)){FS.rmdir(path)}else if(FS.isFile(stat.mode)){FS.unlink(path)}}catch(e){return callback(e)}callback(null)}),loadRemoteEntry:(function(store,path,callback){var req=store.get(path);req.onsuccess=(function(event){callback(null,event.target.result)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),storeRemoteEntry:(function(store,path,entry,callback){var req=store.put(entry,path);req.onsuccess=(function(){callback(null)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),removeRemoteEntry:(function(store,path,callback){var req=store.delete(path);req.onsuccess=(function(){callback(null)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),reconcile:(function(src,dst,callback){var total=0;var create=[];Object.keys(src.entries).forEach((function(key){var e=src.entries[key];var e2=dst.entries[key];if(!e2||e.timestamp>e2.timestamp){create.push(key);total++}}));var remove=[];Object.keys(dst.entries).forEach((function(key){var e=dst.entries[key];var e2=src.entries[key];if(!e2){remove.push(key);total++}}));if(!total){return callback(null)}var completed=0;var db=src.type==="remote"?src.db:dst.db;var transaction=db.transaction([IDBFS.DB_STORE_NAME],"readwrite");var store=transaction.objectStore(IDBFS.DB_STORE_NAME);function done(err){if(err){if(!done.errored){done.errored=true;return callback(err)}return}if(++completed>=total){return callback(null)}}transaction.onerror=(function(e){done(this.error);e.preventDefault()});create.sort().forEach((function(path){if(dst.type==="local"){IDBFS.loadRemoteEntry(store,path,(function(err,entry){if(err)return done(err);IDBFS.storeLocalEntry(path,entry,done)}))}else{IDBFS.loadLocalEntry(path,(function(err,entry){if(err)return done(err);IDBFS.storeRemoteEntry(store,path,entry,done)}))}}));remove.sort().reverse().forEach((function(path){if(dst.type==="local"){IDBFS.removeLocalEntry(path,done)}else{IDBFS.removeRemoteEntry(store,path,done)}}))})};var NODEFS={isWindows:false,staticInit:(function(){NODEFS.isWindows=!!process.platform.match(/^win/)}),mount:(function(mount){assert(ENVIRONMENT_IS_NODE);return NODEFS.createNode(null,"/",NODEFS.getMode(mount.opts.root),0)}),createNode:(function(parent,name,mode,dev){if(!FS.isDir(mode)&&!FS.isFile(mode)&&!FS.isLink(mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node=FS.createNode(parent,name,mode);node.node_ops=NODEFS.node_ops;node.stream_ops=NODEFS.stream_ops;return node}),getMode:(function(path){var stat;try{stat=fs.lstatSync(path);if(NODEFS.isWindows){stat.mode=stat.mode|(stat.mode&146)>>1}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return stat.mode}),realPath:(function(node){var parts=[];while(node.parent!==node){parts.push(node.name);node=node.parent}parts.push(node.mount.opts.root);parts.reverse();return PATH.join.apply(null,parts)}),flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:(function(flags){flags&=~2097152;flags&=~2048;flags&=~32768;flags&=~524288;if(flags in NODEFS.flagsToPermissionStringMap){return NODEFS.flagsToPermissionStringMap[flags]}else{throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}}),node_ops:{getattr:(function(node){var path=NODEFS.realPath(node);var stat;try{stat=fs.lstatSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}if(NODEFS.isWindows&&!stat.blksize){stat.blksize=4096}if(NODEFS.isWindows&&!stat.blocks){stat.blocks=(stat.size+stat.blksize-1)/stat.blksize|0}return{dev:stat.dev,ino:stat.ino,mode:stat.mode,nlink:stat.nlink,uid:stat.uid,gid:stat.gid,rdev:stat.rdev,size:stat.size,atime:stat.atime,mtime:stat.mtime,ctime:stat.ctime,blksize:stat.blksize,blocks:stat.blocks}}),setattr:(function(node,attr){var path=NODEFS.realPath(node);try{if(attr.mode!==undefined){fs.chmodSync(path,attr.mode);node.mode=attr.mode}if(attr.timestamp!==undefined){var date=new Date(attr.timestamp);fs.utimesSync(path,date,date)}if(attr.size!==undefined){fs.truncateSync(path,attr.size)}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),lookup:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);var mode=NODEFS.getMode(path);return NODEFS.createNode(parent,name,mode)}),mknod:(function(parent,name,mode,dev){var node=NODEFS.createNode(parent,name,mode,dev);var path=NODEFS.realPath(node);try{if(FS.isDir(node.mode)){fs.mkdirSync(path,node.mode)}else{fs.writeFileSync(path,"",{mode:node.mode})}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return node}),rename:(function(oldNode,newDir,newName){var oldPath=NODEFS.realPath(oldNode);var newPath=PATH.join2(NODEFS.realPath(newDir),newName);try{fs.renameSync(oldPath,newPath)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),unlink:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);try{fs.unlinkSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),rmdir:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);try{fs.rmdirSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),readdir:(function(node){var path=NODEFS.realPath(node);try{return fs.readdirSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),symlink:(function(parent,newName,oldPath){var newPath=PATH.join2(NODEFS.realPath(parent),newName);try{fs.symlinkSync(oldPath,newPath)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),readlink:(function(node){var path=NODEFS.realPath(node);try{path=fs.readlinkSync(path);path=NODEJS_PATH.relative(NODEJS_PATH.resolve(node.mount.opts.root),path);return path}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}})},stream_ops:{open:(function(stream){var path=NODEFS.realPath(stream.node);try{if(FS.isFile(stream.node.mode)){stream.nfd=fs.openSync(path,NODEFS.flagsToPermissionString(stream.flags))}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),close:(function(stream){try{if(FS.isFile(stream.node.mode)&&stream.nfd){fs.closeSync(stream.nfd)}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),read:(function(stream,buffer,offset,length,position){if(length===0)return 0;var nbuffer=new Buffer(length);var res;try{res=fs.readSync(stream.nfd,nbuffer,0,length,position)}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}if(res>0){for(var i=0;i<res;i++){buffer[offset+i]=nbuffer[i]}}return res}),write:(function(stream,buffer,offset,length,position){var nbuffer=new Buffer(buffer.subarray(offset,offset+length));var res;try{res=fs.writeSync(stream.nfd,nbuffer,0,length,position)}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}return res}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){try{var stat=fs.fstatSync(stream.nfd);position+=stat.size}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position})}};var WORKERFS={DIR_MODE:16895,FILE_MODE:33279,reader:null,mount:(function(mount){assert(ENVIRONMENT_IS_WORKER);if(!WORKERFS.reader)WORKERFS.reader=new FileReaderSync;var root=WORKERFS.createNode(null,"/",WORKERFS.DIR_MODE,0);var createdParents={};function ensureParent(path){var parts=path.split("/");var parent=root;for(var i=0;i<parts.length-1;i++){var curr=parts.slice(0,i+1).join("/");if(!createdParents[curr]){createdParents[curr]=WORKERFS.createNode(parent,parts[i],WORKERFS.DIR_MODE,0)}parent=createdParents[curr]}return parent}function base(path){var parts=path.split("/");return parts[parts.length-1]}Array.prototype.forEach.call(mount.opts["files"]||[],(function(file){WORKERFS.createNode(ensureParent(file.name),base(file.name),WORKERFS.FILE_MODE,0,file,file.lastModifiedDate)}));(mount.opts["blobs"]||[]).forEach((function(obj){WORKERFS.createNode(ensureParent(obj["name"]),base(obj["name"]),WORKERFS.FILE_MODE,0,obj["data"])}));(mount.opts["packages"]||[]).forEach((function(pack){pack["metadata"].files.forEach((function(file){var name=file.filename.substr(1);WORKERFS.createNode(ensureParent(name),base(name),WORKERFS.FILE_MODE,0,pack["blob"].slice(file.start,file.end))}))}));return root}),createNode:(function(parent,name,mode,dev,contents,mtime){var node=FS.createNode(parent,name,mode);node.mode=mode;node.node_ops=WORKERFS.node_ops;node.stream_ops=WORKERFS.stream_ops;node.timestamp=(mtime||new Date).getTime();assert(WORKERFS.FILE_MODE!==WORKERFS.DIR_MODE);if(mode===WORKERFS.FILE_MODE){node.size=contents.size;node.contents=contents}else{node.size=4096;node.contents={}}if(parent){parent.contents[name]=node}return node}),node_ops:{getattr:(function(node){return{dev:1,ino:undefined,mode:node.mode,nlink:1,uid:0,gid:0,rdev:undefined,size:node.size,atime:new Date(node.timestamp),mtime:new Date(node.timestamp),ctime:new Date(node.timestamp),blksize:4096,blocks:Math.ceil(node.size/4096)}}),setattr:(function(node,attr){if(attr.mode!==undefined){node.mode=attr.mode}if(attr.timestamp!==undefined){node.timestamp=attr.timestamp}}),lookup:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}),mknod:(function(parent,name,mode,dev){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),rename:(function(oldNode,newDir,newName){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),unlink:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),rmdir:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),readdir:(function(node){var entries=[".",".."];for(var key in node.contents){if(!node.contents.hasOwnProperty(key)){continue}entries.push(key)}return entries}),symlink:(function(parent,newName,oldPath){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),readlink:(function(node){throw new FS.ErrnoError(ERRNO_CODES.EPERM)})},stream_ops:{read:(function(stream,buffer,offset,length,position){if(position>=stream.node.size)return 0;var chunk=stream.node.contents.slice(position,position+length);var ab=WORKERFS.reader.readAsArrayBuffer(chunk);buffer.set(new Uint8Array(ab),offset);return chunk.size}),write:(function(stream,buffer,offset,length,position){throw new FS.ErrnoError(ERRNO_CODES.EIO)}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){position+=stream.node.size}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position})}};STATICTOP+=16;STATICTOP+=16;STATICTOP+=16;var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,trackingDelegate:{},tracking:{openFlags:{READ:1,WRITE:2}},ErrnoError:null,genericErrors:{},filesystems:null,syncFSRequests:0,handleFSError:(function(e){if(!(e instanceof FS.ErrnoError))throw e+" : "+stackTrace();return ___setErrNo(e.errno)}),lookupPath:(function(path,opts){path=PATH.resolve(FS.cwd(),path);opts=opts||{};if(!path)return{path:"",node:null};var defaults={follow_mount:true,recurse_count:0};for(var key in defaults){if(opts[key]===undefined){opts[key]=defaults[key]}}if(opts.recurse_count>8){throw new FS.ErrnoError(ERRNO_CODES.ELOOP)}var parts=PATH.normalizeArray(path.split("/").filter((function(p){return!!p})),false);var current=FS.root;var current_path="/";for(var i=0;i<parts.length;i++){var islast=i===parts.length-1;if(islast&&opts.parent){break}current=FS.lookupNode(current,parts[i]);current_path=PATH.join2(current_path,parts[i]);if(FS.isMountpoint(current)){if(!islast||islast&&opts.follow_mount){current=current.mounted.root}}if(!islast||opts.follow){var count=0;while(FS.isLink(current.mode)){var link=FS.readlink(current_path);current_path=PATH.resolve(PATH.dirname(current_path),link);var lookup=FS.lookupPath(current_path,{recurse_count:opts.recurse_count});current=lookup.node;if(count++>40){throw new FS.ErrnoError(ERRNO_CODES.ELOOP)}}}}return{path:current_path,node:current}}),getPath:(function(node){var path;while(true){if(FS.isRoot(node)){var mount=node.mount.mountpoint;if(!path)return mount;return mount[mount.length-1]!=="/"?mount+"/"+path:mount+path}path=path?node.name+"/"+path:node.name;node=node.parent}}),hashName:(function(parentid,name){var hash=0;for(var i=0;i<name.length;i++){hash=(hash<<5)-hash+name.charCodeAt(i)|0}return(parentid+hash>>>0)%FS.nameTable.length}),hashAddNode:(function(node){var hash=FS.hashName(node.parent.id,node.name);node.name_next=FS.nameTable[hash];FS.nameTable[hash]=node}),hashRemoveNode:(function(node){var hash=FS.hashName(node.parent.id,node.name);if(FS.nameTable[hash]===node){FS.nameTable[hash]=node.name_next}else{var current=FS.nameTable[hash];while(current){if(current.name_next===node){current.name_next=node.name_next;break}current=current.name_next}}}),lookupNode:(function(parent,name){var err=FS.mayLookup(parent);if(err){throw new FS.ErrnoError(err,parent)}var hash=FS.hashName(parent.id,name);for(var node=FS.nameTable[hash];node;node=node.name_next){var nodeName=node.name;if(node.parent.id===parent.id&&nodeName===name){return node}}return FS.lookup(parent,name)}),createNode:(function(parent,name,mode,rdev){if(!FS.FSNode){FS.FSNode=(function(parent,name,mode,rdev){if(!parent){parent=this}this.parent=parent;this.mount=parent.mount;this.mounted=null;this.id=FS.nextInode++;this.name=name;this.mode=mode;this.node_ops={};this.stream_ops={};this.rdev=rdev});FS.FSNode.prototype={};var readMode=292|73;var writeMode=146;Object.defineProperties(FS.FSNode.prototype,{read:{get:(function(){return(this.mode&readMode)===readMode}),set:(function(val){val?this.mode|=readMode:this.mode&=~readMode})},write:{get:(function(){return(this.mode&writeMode)===writeMode}),set:(function(val){val?this.mode|=writeMode:this.mode&=~writeMode})},isFolder:{get:(function(){return FS.isDir(this.mode)})},isDevice:{get:(function(){return FS.isChrdev(this.mode)})}})}var node=new FS.FSNode(parent,name,mode,rdev);FS.hashAddNode(node);return node}),destroyNode:(function(node){FS.hashRemoveNode(node)}),isRoot:(function(node){return node===node.parent}),isMountpoint:(function(node){return!!node.mounted}),isFile:(function(mode){return(mode&61440)===32768}),isDir:(function(mode){return(mode&61440)===16384}),isLink:(function(mode){return(mode&61440)===40960}),isChrdev:(function(mode){return(mode&61440)===8192}),isBlkdev:(function(mode){return(mode&61440)===24576}),isFIFO:(function(mode){return(mode&61440)===4096}),isSocket:(function(mode){return(mode&49152)===49152}),flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:(function(str){var flags=FS.flagModes[str];if(typeof flags==="undefined"){throw new Error("Unknown file open mode: "+str)}return flags}),flagsToPermissionString:(function(flag){var perms=["r","w","rw"][flag&3];if(flag&512){perms+="w"}return perms}),nodePermissions:(function(node,perms){if(FS.ignorePermissions){return 0}if(perms.indexOf("r")!==-1&&!(node.mode&292)){return ERRNO_CODES.EACCES}else if(perms.indexOf("w")!==-1&&!(node.mode&146)){return ERRNO_CODES.EACCES}else if(perms.indexOf("x")!==-1&&!(node.mode&73)){return ERRNO_CODES.EACCES}return 0}),mayLookup:(function(dir){var err=FS.nodePermissions(dir,"x");if(err)return err;if(!dir.node_ops.lookup)return ERRNO_CODES.EACCES;return 0}),mayCreate:(function(dir,name){try{var node=FS.lookupNode(dir,name);return ERRNO_CODES.EEXIST}catch(e){}return FS.nodePermissions(dir,"wx")}),mayDelete:(function(dir,name,isdir){var node;try{node=FS.lookupNode(dir,name)}catch(e){return e.errno}var err=FS.nodePermissions(dir,"wx");if(err){return err}if(isdir){if(!FS.isDir(node.mode)){return ERRNO_CODES.ENOTDIR}if(FS.isRoot(node)||FS.getPath(node)===FS.cwd()){return ERRNO_CODES.EBUSY}}else{if(FS.isDir(node.mode)){return ERRNO_CODES.EISDIR}}return 0}),mayOpen:(function(node,flags){if(!node){return ERRNO_CODES.ENOENT}if(FS.isLink(node.mode)){return ERRNO_CODES.ELOOP}else if(FS.isDir(node.mode)){if(FS.flagsToPermissionString(flags)!=="r"||flags&512){return ERRNO_CODES.EISDIR}}return FS.nodePermissions(node,FS.flagsToPermissionString(flags))}),MAX_OPEN_FDS:4096,nextfd:(function(fd_start,fd_end){fd_start=fd_start||0;fd_end=fd_end||FS.MAX_OPEN_FDS;for(var fd=fd_start;fd<=fd_end;fd++){if(!FS.streams[fd]){return fd}}throw new FS.ErrnoError(ERRNO_CODES.EMFILE)}),getStream:(function(fd){return FS.streams[fd]}),createStream:(function(stream,fd_start,fd_end){if(!FS.FSStream){FS.FSStream=(function(){});FS.FSStream.prototype={};Object.defineProperties(FS.FSStream.prototype,{object:{get:(function(){return this.node}),set:(function(val){this.node=val})},isRead:{get:(function(){return(this.flags&2097155)!==1})},isWrite:{get:(function(){return(this.flags&2097155)!==0})},isAppend:{get:(function(){return this.flags&1024})}})}var newStream=new FS.FSStream;for(var p in stream){newStream[p]=stream[p]}stream=newStream;var fd=FS.nextfd(fd_start,fd_end);stream.fd=fd;FS.streams[fd]=stream;return stream}),closeStream:(function(fd){FS.streams[fd]=null}),chrdev_stream_ops:{open:(function(stream){var device=FS.getDevice(stream.node.rdev);stream.stream_ops=device.stream_ops;if(stream.stream_ops.open){stream.stream_ops.open(stream)}}),llseek:(function(){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)})},major:(function(dev){return dev>>8}),minor:(function(dev){return dev&255}),makedev:(function(ma,mi){return ma<<8|mi}),registerDevice:(function(dev,ops){FS.devices[dev]={stream_ops:ops}}),getDevice:(function(dev){return FS.devices[dev]}),getMounts:(function(mount){var mounts=[];var check=[mount];while(check.length){var m=check.pop();mounts.push(m);check.push.apply(check,m.mounts)}return mounts}),syncfs:(function(populate,callback){if(typeof populate==="function"){callback=populate;populate=false}FS.syncFSRequests++;if(FS.syncFSRequests>1){console.log("warning: "+FS.syncFSRequests+" FS.syncfs operations in flight at once, probably just doing extra work")}var mounts=FS.getMounts(FS.root.mount);var completed=0;function doCallback(err){assert(FS.syncFSRequests>0);FS.syncFSRequests--;return callback(err)}function done(err){if(err){if(!done.errored){done.errored=true;return doCallback(err)}return}if(++completed>=mounts.length){doCallback(null)}}mounts.forEach((function(mount){if(!mount.type.syncfs){return done(null)}mount.type.syncfs(mount,populate,done)}))}),mount:(function(type,opts,mountpoint){var root=mountpoint==="/";var pseudo=!mountpoint;var node;if(root&&FS.root){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}else if(!root&&!pseudo){var lookup=FS.lookupPath(mountpoint,{follow_mount:false});mountpoint=lookup.path;node=lookup.node;if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}}var mount={type:type,opts:opts,mountpoint:mountpoint,mounts:[]};var mountRoot=type.mount(mount);mountRoot.mount=mount;mount.root=mountRoot;if(root){FS.root=mountRoot}else if(node){node.mounted=mount;if(node.mount){node.mount.mounts.push(mount)}}return mountRoot}),unmount:(function(mountpoint){var lookup=FS.lookupPath(mountpoint,{follow_mount:false});if(!FS.isMountpoint(lookup.node)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node=lookup.node;var mount=node.mounted;var mounts=FS.getMounts(mount);Object.keys(FS.nameTable).forEach((function(hash){var current=FS.nameTable[hash];while(current){var next=current.name_next;if(mounts.indexOf(current.mount)!==-1){FS.destroyNode(current)}current=next}}));node.mounted=null;var idx=node.mount.mounts.indexOf(mount);assert(idx!==-1);node.mount.mounts.splice(idx,1)}),lookup:(function(parent,name){return parent.node_ops.lookup(parent,name)}),mknod:(function(path,mode,dev){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);if(!name||name==="."||name===".."){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var err=FS.mayCreate(parent,name);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.mknod){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return parent.node_ops.mknod(parent,name,mode,dev)}),create:(function(path,mode){mode=mode!==undefined?mode:438;mode&=4095;mode|=32768;return FS.mknod(path,mode,0)}),mkdir:(function(path,mode){mode=mode!==undefined?mode:511;mode&=511|512;mode|=16384;return FS.mknod(path,mode,0)}),mkdirTree:(function(path,mode){var dirs=path.split("/");var d="";for(var i=0;i<dirs.length;++i){if(!dirs[i])continue;d+="/"+dirs[i];try{FS.mkdir(d,mode)}catch(e){if(e.errno!=ERRNO_CODES.EEXIST)throw e}}}),mkdev:(function(path,mode,dev){if(typeof dev==="undefined"){dev=mode;mode=438}mode|=8192;return FS.mknod(path,mode,dev)}),symlink:(function(oldpath,newpath){if(!PATH.resolve(oldpath)){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}var lookup=FS.lookupPath(newpath,{parent:true});var parent=lookup.node;if(!parent){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}var newname=PATH.basename(newpath);var err=FS.mayCreate(parent,newname);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.symlink){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return parent.node_ops.symlink(parent,newname,oldpath)}),rename:(function(old_path,new_path){var old_dirname=PATH.dirname(old_path);var new_dirname=PATH.dirname(new_path);var old_name=PATH.basename(old_path);var new_name=PATH.basename(new_path);var lookup,old_dir,new_dir;try{lookup=FS.lookupPath(old_path,{parent:true});old_dir=lookup.node;lookup=FS.lookupPath(new_path,{parent:true});new_dir=lookup.node}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(!old_dir||!new_dir)throw new FS.ErrnoError(ERRNO_CODES.ENOENT);if(old_dir.mount!==new_dir.mount){throw new FS.ErrnoError(ERRNO_CODES.EXDEV)}var old_node=FS.lookupNode(old_dir,old_name);var relative=PATH.relative(old_path,new_dirname);if(relative.charAt(0)!=="."){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}relative=PATH.relative(new_path,old_dirname);if(relative.charAt(0)!=="."){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(old_node===new_node){return}var isdir=FS.isDir(old_node.mode);var err=FS.mayDelete(old_dir,old_name,isdir);if(err){throw new FS.ErrnoError(err)}err=new_node?FS.mayDelete(new_dir,new_name,isdir):FS.mayCreate(new_dir,new_name);if(err){throw new FS.ErrnoError(err)}if(!old_dir.node_ops.rename){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(old_node)||new_node&&FS.isMountpoint(new_node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(new_dir!==old_dir){err=FS.nodePermissions(old_dir,"w");if(err){throw new FS.ErrnoError(err)}}try{if(FS.trackingDelegate["willMovePath"]){FS.trackingDelegate["willMovePath"](old_path,new_path)}}catch(e){console.log("FS.trackingDelegate['willMovePath']('"+old_path+"', '"+new_path+"') threw an exception: "+e.message)}FS.hashRemoveNode(old_node);try{old_dir.node_ops.rename(old_node,new_dir,new_name)}catch(e){throw e}finally{FS.hashAddNode(old_node)}try{if(FS.trackingDelegate["onMovePath"])FS.trackingDelegate["onMovePath"](old_path,new_path)}catch(e){console.log("FS.trackingDelegate['onMovePath']('"+old_path+"', '"+new_path+"') threw an exception: "+e.message)}}),rmdir:(function(path){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);var node=FS.lookupNode(parent,name);var err=FS.mayDelete(parent,name,true);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.rmdir){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}try{if(FS.trackingDelegate["willDeletePath"]){FS.trackingDelegate["willDeletePath"](path)}}catch(e){console.log("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: "+e.message)}parent.node_ops.rmdir(parent,name);FS.destroyNode(node);try{if(FS.trackingDelegate["onDeletePath"])FS.trackingDelegate["onDeletePath"](path)}catch(e){console.log("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: "+e.message)}}),readdir:(function(path){var lookup=FS.lookupPath(path,{follow:true});var node=lookup.node;if(!node.node_ops.readdir){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}return node.node_ops.readdir(node)}),unlink:(function(path){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);var node=FS.lookupNode(parent,name);var err=FS.mayDelete(parent,name,false);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.unlink){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}try{if(FS.trackingDelegate["willDeletePath"]){FS.trackingDelegate["willDeletePath"](path)}}catch(e){console.log("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: "+e.message)}parent.node_ops.unlink(parent,name);FS.destroyNode(node);try{if(FS.trackingDelegate["onDeletePath"])FS.trackingDelegate["onDeletePath"](path)}catch(e){console.log("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: "+e.message)}}),readlink:(function(path){var lookup=FS.lookupPath(path);var link=lookup.node;if(!link){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!link.node_ops.readlink){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return PATH.resolve(FS.getPath(link.parent),link.node_ops.readlink(link))}),stat:(function(path,dontFollow){var lookup=FS.lookupPath(path,{follow:!dontFollow});var node=lookup.node;if(!node){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!node.node_ops.getattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return node.node_ops.getattr(node)}),lstat:(function(path){return FS.stat(path,true)}),chmod:(function(path,mode,dontFollow){var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}node.node_ops.setattr(node,{mode:mode&4095|node.mode&~4095,timestamp:Date.now()})}),lchmod:(function(path,mode){FS.chmod(path,mode,true)}),fchmod:(function(fd,mode){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}FS.chmod(stream.node,mode)}),chown:(function(path,uid,gid,dontFollow){var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}node.node_ops.setattr(node,{timestamp:Date.now()})}),lchown:(function(path,uid,gid){FS.chown(path,uid,gid,true)}),fchown:(function(fd,uid,gid){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}FS.chown(stream.node,uid,gid)}),truncate:(function(path,len){if(len<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:true});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!FS.isFile(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var err=FS.nodePermissions(node,"w");if(err){throw new FS.ErrnoError(err)}node.node_ops.setattr(node,{size:len,timestamp:Date.now()})}),ftruncate:(function(fd,len){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}FS.truncate(stream.node,len)}),utime:(function(path,atime,mtime){var lookup=FS.lookupPath(path,{follow:true});var node=lookup.node;node.node_ops.setattr(node,{timestamp:Math.max(atime,mtime)})}),open:(function(path,flags,mode,fd_start,fd_end){if(path===""){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}flags=typeof flags==="string"?FS.modeStringToFlags(flags):flags;mode=typeof mode==="undefined"?438:mode;if(flags&64){mode=mode&4095|32768}else{mode=0}var node;if(typeof path==="object"){node=path}else{path=PATH.normalize(path);try{var lookup=FS.lookupPath(path,{follow:!(flags&131072)});node=lookup.node}catch(e){}}var created=false;if(flags&64){if(node){if(flags&128){throw new FS.ErrnoError(ERRNO_CODES.EEXIST)}}else{node=FS.mknod(path,mode,0);created=true}}if(!node){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(FS.isChrdev(node.mode)){flags&=~512}if(flags&65536&&!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}if(!created){var err=FS.mayOpen(node,flags);if(err){throw new FS.ErrnoError(err)}}if(flags&512){FS.truncate(node,0)}flags&=~(128|512);var stream=FS.createStream({node:node,path:FS.getPath(node),flags:flags,seekable:true,position:0,stream_ops:node.stream_ops,ungotten:[],error:false},fd_start,fd_end);if(stream.stream_ops.open){stream.stream_ops.open(stream)}if(Module["logReadFiles"]&&!(flags&1)){if(!FS.readFiles)FS.readFiles={};if(!(path in FS.readFiles)){FS.readFiles[path]=1;Module["printErr"]("read file: "+path)}}try{if(FS.trackingDelegate["onOpenFile"]){var trackingFlags=0;if((flags&2097155)!==1){trackingFlags|=FS.tracking.openFlags.READ}if((flags&2097155)!==0){trackingFlags|=FS.tracking.openFlags.WRITE}FS.trackingDelegate["onOpenFile"](path,trackingFlags)}}catch(e){console.log("FS.trackingDelegate['onOpenFile']('"+path+"', flags) threw an exception: "+e.message)}return stream}),close:(function(stream){if(stream.getdents)stream.getdents=null;try{if(stream.stream_ops.close){stream.stream_ops.close(stream)}}catch(e){throw e}finally{FS.closeStream(stream.fd)}}),llseek:(function(stream,offset,whence){if(!stream.seekable||!stream.stream_ops.llseek){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}stream.position=stream.stream_ops.llseek(stream,offset,whence);stream.ungotten=[];return stream.position}),read:(function(stream,buffer,offset,length,position){if(length<0||position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===1){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(FS.isDir(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!stream.stream_ops.read){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var seeking=true;if(typeof position==="undefined"){position=stream.position;seeking=false}else if(!stream.seekable){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}var bytesRead=stream.stream_ops.read(stream,buffer,offset,length,position);if(!seeking)stream.position+=bytesRead;return bytesRead}),write:(function(stream,buffer,offset,length,position,canOwn){if(length<0||position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(FS.isDir(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!stream.stream_ops.write){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if(stream.flags&1024){FS.llseek(stream,0,2)}var seeking=true;if(typeof position==="undefined"){position=stream.position;seeking=false}else if(!stream.seekable){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}var bytesWritten=stream.stream_ops.write(stream,buffer,offset,length,position,canOwn);if(!seeking)stream.position+=bytesWritten;try{if(stream.path&&FS.trackingDelegate["onWriteToFile"])FS.trackingDelegate["onWriteToFile"](stream.path)}catch(e){console.log("FS.trackingDelegate['onWriteToFile']('"+path+"') threw an exception: "+e.message)}return bytesWritten}),allocate:(function(stream,offset,length){if(offset<0||length<=0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(!FS.isFile(stream.node.mode)&&!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}if(!stream.stream_ops.allocate){throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP)}stream.stream_ops.allocate(stream,offset,length)}),mmap:(function(stream,buffer,offset,length,position,prot,flags){if((stream.flags&2097155)===1){throw new FS.ErrnoError(ERRNO_CODES.EACCES)}if(!stream.stream_ops.mmap){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}return stream.stream_ops.mmap(stream,buffer,offset,length,position,prot,flags)}),msync:(function(stream,buffer,offset,length,mmapFlags){if(!stream||!stream.stream_ops.msync){return 0}return stream.stream_ops.msync(stream,buffer,offset,length,mmapFlags)}),munmap:(function(stream){return 0}),ioctl:(function(stream,cmd,arg){if(!stream.stream_ops.ioctl){throw new FS.ErrnoError(ERRNO_CODES.ENOTTY)}return stream.stream_ops.ioctl(stream,cmd,arg)}),readFile:(function(path,opts){opts=opts||{};opts.flags=opts.flags||"r";opts.encoding=opts.encoding||"binary";if(opts.encoding!=="utf8"&&opts.encoding!=="binary"){throw new Error('Invalid encoding type "'+opts.encoding+'"')}var ret;var stream=FS.open(path,opts.flags);var stat=FS.stat(path);var length=stat.size;var buf=new Uint8Array(length);FS.read(stream,buf,0,length,0);if(opts.encoding==="utf8"){ret=UTF8ArrayToString(buf,0)}else if(opts.encoding==="binary"){ret=buf}FS.close(stream);return ret}),writeFile:(function(path,data,opts){opts=opts||{};opts.flags=opts.flags||"w";opts.encoding=opts.encoding||"utf8";if(opts.encoding!=="utf8"&&opts.encoding!=="binary"){throw new Error('Invalid encoding type "'+opts.encoding+'"')}var stream=FS.open(path,opts.flags,opts.mode);if(opts.encoding==="utf8"){var buf=new Uint8Array(lengthBytesUTF8(data)+1);var actualNumBytes=stringToUTF8Array(data,buf,0,buf.length);FS.write(stream,buf,0,actualNumBytes,0,opts.canOwn)}else if(opts.encoding==="binary"){FS.write(stream,data,0,data.length,0,opts.canOwn)}FS.close(stream)}),cwd:(function(){return FS.currentPath}),chdir:(function(path){var lookup=FS.lookupPath(path,{follow:true});if(lookup.node===null){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!FS.isDir(lookup.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}var err=FS.nodePermissions(lookup.node,"x");if(err){throw new FS.ErrnoError(err)}FS.currentPath=lookup.path}),createDefaultDirectories:(function(){FS.mkdir("/tmp");FS.mkdir("/home");FS.mkdir("/home/web_user")}),createDefaultDevices:(function(){FS.mkdir("/dev");FS.registerDevice(FS.makedev(1,3),{read:(function(){return 0}),write:(function(stream,buffer,offset,length,pos){return length})});FS.mkdev("/dev/null",FS.makedev(1,3));TTY.register(FS.makedev(5,0),TTY.default_tty_ops);TTY.register(FS.makedev(6,0),TTY.default_tty1_ops);FS.mkdev("/dev/tty",FS.makedev(5,0));FS.mkdev("/dev/tty1",FS.makedev(6,0));var random_device;if(typeof crypto!=="undefined"){var randomBuffer=new Uint8Array(1);random_device=(function(){crypto.getRandomValues(randomBuffer);return randomBuffer[0]})}else if(ENVIRONMENT_IS_NODE){random_device=(function(){return require("crypto").randomBytes(1)[0]})}else{random_device=(function(){return Math.random()*256|0})}FS.createDevice("/dev","random",random_device);FS.createDevice("/dev","urandom",random_device);FS.mkdir("/dev/shm");FS.mkdir("/dev/shm/tmp")}),createSpecialDirectories:(function(){FS.mkdir("/proc");FS.mkdir("/proc/self");FS.mkdir("/proc/self/fd");FS.mount({mount:(function(){var node=FS.createNode("/proc/self","fd",16384|511,73);node.node_ops={lookup:(function(parent,name){var fd=+name;var stream=FS.getStream(fd);if(!stream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);var ret={parent:null,mount:{mountpoint:"fake"},node_ops:{readlink:(function(){return stream.path})}};ret.parent=ret;return ret})};return node})},{},"/proc/self/fd")}),createStandardStreams:(function(){if(Module["stdin"]){FS.createDevice("/dev","stdin",Module["stdin"])}else{FS.symlink("/dev/tty","/dev/stdin")}if(Module["stdout"]){FS.createDevice("/dev","stdout",null,Module["stdout"])}else{FS.symlink("/dev/tty","/dev/stdout")}if(Module["stderr"]){FS.createDevice("/dev","stderr",null,Module["stderr"])}else{FS.symlink("/dev/tty1","/dev/stderr")}var stdin=FS.open("/dev/stdin","r");assert(stdin.fd===0,"invalid handle for stdin ("+stdin.fd+")");var stdout=FS.open("/dev/stdout","w");assert(stdout.fd===1,"invalid handle for stdout ("+stdout.fd+")");var stderr=FS.open("/dev/stderr","w");assert(stderr.fd===2,"invalid handle for stderr ("+stderr.fd+")")}),ensureErrnoError:(function(){if(FS.ErrnoError)return;FS.ErrnoError=function ErrnoError(errno,node){this.node=node;this.setErrno=(function(errno){this.errno=errno;for(var key in ERRNO_CODES){if(ERRNO_CODES[key]===errno){this.code=key;break}}});this.setErrno(errno);this.message=ERRNO_MESSAGES[errno]};FS.ErrnoError.prototype=new Error;FS.ErrnoError.prototype.constructor=FS.ErrnoError;[ERRNO_CODES.ENOENT].forEach((function(code){FS.genericErrors[code]=new FS.ErrnoError(code);FS.genericErrors[code].stack="<generic error, no stack>"}))}),staticInit:(function(){FS.ensureErrnoError();FS.nameTable=new Array(4096);FS.mount(MEMFS,{},"/");FS.createDefaultDirectories();FS.createDefaultDevices();FS.createSpecialDirectories();FS.filesystems={"MEMFS":MEMFS,"IDBFS":IDBFS,"NODEFS":NODEFS,"WORKERFS":WORKERFS}}),init:(function(input,output,error){assert(!FS.init.initialized,"FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)");FS.init.initialized=true;FS.ensureErrnoError();Module["stdin"]=input||Module["stdin"];Module["stdout"]=output||Module["stdout"];Module["stderr"]=error||Module["stderr"];FS.createStandardStreams()}),quit:(function(){FS.init.initialized=false;var fflush=Module["_fflush"];if(fflush)fflush(0);for(var i=0;i<FS.streams.length;i++){var stream=FS.streams[i];if(!stream){continue}FS.close(stream)}}),getMode:(function(canRead,canWrite){var mode=0;if(canRead)mode|=292|73;if(canWrite)mode|=146;return mode}),joinPath:(function(parts,forceRelative){var path=PATH.join.apply(null,parts);if(forceRelative&&path[0]=="/")path=path.substr(1);return path}),absolutePath:(function(relative,base){return PATH.resolve(base,relative)}),standardizePath:(function(path){return PATH.normalize(path)}),findObject:(function(path,dontResolveLastLink){var ret=FS.analyzePath(path,dontResolveLastLink);if(ret.exists){return ret.object}else{___setErrNo(ret.error);return null}}),analyzePath:(function(path,dontResolveLastLink){try{var lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});path=lookup.path}catch(e){}var ret={isRoot:false,exists:false,error:0,name:null,path:null,object:null,parentExists:false,parentPath:null,parentObject:null};try{var lookup=FS.lookupPath(path,{parent:true});ret.parentExists=true;ret.parentPath=lookup.path;ret.parentObject=lookup.node;ret.name=PATH.basename(path);lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});ret.exists=true;ret.path=lookup.path;ret.object=lookup.node;ret.name=lookup.node.name;ret.isRoot=lookup.path==="/"}catch(e){ret.error=e.errno}return ret}),createFolder:(function(parent,name,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(canRead,canWrite);return FS.mkdir(path,mode)}),createPath:(function(parent,path,canRead,canWrite){parent=typeof parent==="string"?parent:FS.getPath(parent);var parts=path.split("/").reverse();while(parts.length){var part=parts.pop();if(!part)continue;var current=PATH.join2(parent,part);try{FS.mkdir(current)}catch(e){}parent=current}return current}),createFile:(function(parent,name,properties,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(canRead,canWrite);return FS.create(path,mode)}),createDataFile:(function(parent,name,data,canRead,canWrite,canOwn){var path=name?PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name):parent;var mode=FS.getMode(canRead,canWrite);var node=FS.create(path,mode);if(data){if(typeof data==="string"){var arr=new Array(data.length);for(var i=0,len=data.length;i<len;++i)arr[i]=data.charCodeAt(i);data=arr}FS.chmod(node,mode|146);var stream=FS.open(node,"w");FS.write(stream,data,0,data.length,0,canOwn);FS.close(stream);FS.chmod(node,mode)}return node}),createDevice:(function(parent,name,input,output){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(!!input,!!output);if(!FS.createDevice.major)FS.createDevice.major=64;var dev=FS.makedev(FS.createDevice.major++,0);FS.registerDevice(dev,{open:(function(stream){stream.seekable=false}),close:(function(stream){if(output&&output.buffer&&output.buffer.length){output(10)}}),read:(function(stream,buffer,offset,length,pos){var bytesRead=0;for(var i=0;i<length;i++){var result;try{result=input()}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}if(result===undefined&&bytesRead===0){throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}if(result===null||result===undefined)break;bytesRead++;buffer[offset+i]=result}if(bytesRead){stream.node.timestamp=Date.now()}return bytesRead}),write:(function(stream,buffer,offset,length,pos){for(var i=0;i<length;i++){try{output(buffer[offset+i])}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}}if(length){stream.node.timestamp=Date.now()}return i})});return FS.mkdev(path,mode,dev)}),createLink:(function(parent,name,target,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);return FS.symlink(target,path)}),forceLoadFile:(function(obj){if(obj.isDevice||obj.isFolder||obj.link||obj.contents)return true;var success=true;if(typeof XMLHttpRequest!=="undefined"){throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.")}else if(Module["read"]){try{obj.contents=intArrayFromString(Module["read"](obj.url),true);obj.usedBytes=obj.contents.length}catch(e){success=false}}else{throw new Error("Cannot load without read() or XMLHttpRequest.")}if(!success)___setErrNo(ERRNO_CODES.EIO);return success}),createLazyFile:(function(parent,name,url,canRead,canWrite){function LazyUint8Array(){this.lengthKnown=false;this.chunks=[]}LazyUint8Array.prototype.get=function LazyUint8Array_get(idx){if(idx>this.length-1||idx<0){return undefined}var chunkOffset=idx%this.chunkSize;var chunkNum=idx/this.chunkSize|0;return this.getter(chunkNum)[chunkOffset]};LazyUint8Array.prototype.setDataGetter=function LazyUint8Array_setDataGetter(getter){this.getter=getter};LazyUint8Array.prototype.cacheLength=function LazyUint8Array_cacheLength(){var xhr=new XMLHttpRequest;xhr.open("HEAD",url,false);xhr.send(null);if(!(xhr.status>=200&&xhr.status<300||xhr.status===304))throw new Error("Couldn't load "+url+". Status: "+xhr.status);var datalength=Number(xhr.getResponseHeader("Content-length"));var header;var hasByteServing=(header=xhr.getResponseHeader("Accept-Ranges"))&&header==="bytes";var usesGzip=(header=xhr.getResponseHeader("Content-Encoding"))&&header==="gzip";var chunkSize=1024*1024;if(!hasByteServing)chunkSize=datalength;var doXHR=(function(from,to){if(from>to)throw new Error("invalid range ("+from+", "+to+") or no bytes requested!");if(to>datalength-1)throw new Error("only "+datalength+" bytes available! programmer error!");var xhr=new XMLHttpRequest;xhr.open("GET",url,false);if(datalength!==chunkSize)xhr.setRequestHeader("Range","bytes="+from+"-"+to);if(typeof Uint8Array!="undefined")xhr.responseType="arraybuffer";if(xhr.overrideMimeType){xhr.overrideMimeType("text/plain; charset=x-user-defined")}xhr.send(null);if(!(xhr.status>=200&&xhr.status<300||xhr.status===304))throw new Error("Couldn't load "+url+". Status: "+xhr.status);if(xhr.response!==undefined){return new Uint8Array(xhr.response||[])}else{return intArrayFromString(xhr.responseText||"",true)}});var lazyArray=this;lazyArray.setDataGetter((function(chunkNum){var start=chunkNum*chunkSize;var end=(chunkNum+1)*chunkSize-1;end=Math.min(end,datalength-1);if(typeof lazyArray.chunks[chunkNum]==="undefined"){lazyArray.chunks[chunkNum]=doXHR(start,end)}if(typeof lazyArray.chunks[chunkNum]==="undefined")throw new Error("doXHR failed!");return lazyArray.chunks[chunkNum]}));if(usesGzip||!datalength){chunkSize=datalength=1;datalength=this.getter(0).length;chunkSize=datalength;console.log("LazyFiles on gzip forces download of the whole file when length is accessed")}this._length=datalength;this._chunkSize=chunkSize;this.lengthKnown=true};if(typeof XMLHttpRequest!=="undefined"){if(!ENVIRONMENT_IS_WORKER)throw"Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc";var lazyArray=new LazyUint8Array;Object.defineProperties(lazyArray,{length:{get:(function(){if(!this.lengthKnown){this.cacheLength()}return this._length})},chunkSize:{get:(function(){if(!this.lengthKnown){this.cacheLength()}return this._chunkSize})}});var properties={isDevice:false,contents:lazyArray}}else{var properties={isDevice:false,url:url}}var node=FS.createFile(parent,name,properties,canRead,canWrite);if(properties.contents){node.contents=properties.contents}else if(properties.url){node.contents=null;node.url=properties.url}Object.defineProperties(node,{usedBytes:{get:(function(){return this.contents.length})}});var stream_ops={};var keys=Object.keys(node.stream_ops);keys.forEach((function(key){var fn=node.stream_ops[key];stream_ops[key]=function forceLoadLazyFile(){if(!FS.forceLoadFile(node)){throw new FS.ErrnoError(ERRNO_CODES.EIO)}return fn.apply(null,arguments)}}));stream_ops.read=function stream_ops_read(stream,buffer,offset,length,position){if(!FS.forceLoadFile(node)){throw new FS.ErrnoError(ERRNO_CODES.EIO)}var contents=stream.node.contents;if(position>=contents.length)return 0;var size=Math.min(contents.length-position,length);assert(size>=0);if(contents.slice){for(var i=0;i<size;i++){buffer[offset+i]=contents[position+i]}}else{for(var i=0;i<size;i++){buffer[offset+i]=contents.get(position+i)}}return size};node.stream_ops=stream_ops;return node}),createPreloadedFile:(function(parent,name,url,canRead,canWrite,onload,onerror,dontCreateFile,canOwn,preFinish){Browser.init();var fullname=name?PATH.resolve(PATH.join2(parent,name)):parent;var dep=getUniqueRunDependency("cp "+fullname);function processData(byteArray){function finish(byteArray){if(preFinish)preFinish();if(!dontCreateFile){FS.createDataFile(parent,name,byteArray,canRead,canWrite,canOwn)}if(onload)onload();removeRunDependency(dep)}var handled=false;Module["preloadPlugins"].forEach((function(plugin){if(handled)return;if(plugin["canHandle"](fullname)){plugin["handle"](byteArray,fullname,finish,(function(){if(onerror)onerror();removeRunDependency(dep)}));handled=true}}));if(!handled)finish(byteArray)}addRunDependency(dep);if(typeof url=="string"){Browser.asyncLoad(url,(function(byteArray){processData(byteArray)}),onerror)}else{processData(url)}}),indexedDB:(function(){return window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB}),DB_NAME:(function(){return"EM_FS_"+window.location.pathname}),DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:(function(paths,onload,onerror){onload=onload||(function(){});onerror=onerror||(function(){});var indexedDB=FS.indexedDB();try{var openRequest=indexedDB.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return onerror(e)}openRequest.onupgradeneeded=function openRequest_onupgradeneeded(){console.log("creating db");var db=openRequest.result;db.createObjectStore(FS.DB_STORE_NAME)};openRequest.onsuccess=function openRequest_onsuccess(){var db=openRequest.result;var transaction=db.transaction([FS.DB_STORE_NAME],"readwrite");var files=transaction.objectStore(FS.DB_STORE_NAME);var ok=0,fail=0,total=paths.length;function finish(){if(fail==0)onload();else onerror()}paths.forEach((function(path){var putRequest=files.put(FS.analyzePath(path).object.contents,path);putRequest.onsuccess=function putRequest_onsuccess(){ok++;if(ok+fail==total)finish()};putRequest.onerror=function putRequest_onerror(){fail++;if(ok+fail==total)finish()}}));transaction.onerror=onerror};openRequest.onerror=onerror}),loadFilesFromDB:(function(paths,onload,onerror){onload=onload||(function(){});onerror=onerror||(function(){});var indexedDB=FS.indexedDB();try{var openRequest=indexedDB.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return onerror(e)}openRequest.onupgradeneeded=onerror;openRequest.onsuccess=function openRequest_onsuccess(){var db=openRequest.result;try{var transaction=db.transaction([FS.DB_STORE_NAME],"readonly")}catch(e){onerror(e);return}var files=transaction.objectStore(FS.DB_STORE_NAME);var ok=0,fail=0,total=paths.length;function finish(){if(fail==0)onload();else onerror()}paths.forEach((function(path){var getRequest=files.get(path);getRequest.onsuccess=function getRequest_onsuccess(){if(FS.analyzePath(path).exists){FS.unlink(path)}FS.createDataFile(PATH.dirname(path),PATH.basename(path),getRequest.result,true,true,true);ok++;if(ok+fail==total)finish()};getRequest.onerror=function getRequest_onerror(){fail++;if(ok+fail==total)finish()}}));transaction.onerror=onerror};openRequest.onerror=onerror})};var SYSCALLS={DEFAULT_POLLMASK:5,mappings:{},umask:511,calculateAt:(function(dirfd,path){if(path[0]!=="/"){var dir;if(dirfd===-100){dir=FS.cwd()}else{var dirstream=FS.getStream(dirfd);if(!dirstream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);dir=dirstream.path}path=PATH.join2(dir,path)}return path}),doStat:(function(func,path,buf){try{var stat=func(path)}catch(e){if(e&&e.node&&PATH.normalize(path)!==PATH.normalize(FS.getPath(e.node))){return-ERRNO_CODES.ENOTDIR}throw e}HEAP32[buf>>2]=stat.dev;HEAP32[buf+4>>2]=0;HEAP32[buf+8>>2]=stat.ino;HEAP32[buf+12>>2]=stat.mode;HEAP32[buf+16>>2]=stat.nlink;HEAP32[buf+20>>2]=stat.uid;HEAP32[buf+24>>2]=stat.gid;HEAP32[buf+28>>2]=stat.rdev;HEAP32[buf+32>>2]=0;HEAP32[buf+36>>2]=stat.size;HEAP32[buf+40>>2]=4096;HEAP32[buf+44>>2]=stat.blocks;HEAP32[buf+48>>2]=stat.atime.getTime()/1e3|0;HEAP32[buf+52>>2]=0;HEAP32[buf+56>>2]=stat.mtime.getTime()/1e3|0;HEAP32[buf+60>>2]=0;HEAP32[buf+64>>2]=stat.ctime.getTime()/1e3|0;HEAP32[buf+68>>2]=0;HEAP32[buf+72>>2]=stat.ino;return 0}),doMsync:(function(addr,stream,len,flags){var buffer=new Uint8Array(HEAPU8.subarray(addr,addr+len));FS.msync(stream,buffer,0,len,flags)}),doMkdir:(function(path,mode){path=PATH.normalize(path);if(path[path.length-1]==="/")path=path.substr(0,path.length-1);FS.mkdir(path,mode,0);return 0}),doMknod:(function(path,mode,dev){switch(mode&61440){case 32768:case 8192:case 24576:case 4096:case 49152:break;default:return-ERRNO_CODES.EINVAL}FS.mknod(path,mode,dev);return 0}),doReadlink:(function(path,buf,bufsize){if(bufsize<=0)return-ERRNO_CODES.EINVAL;var ret=FS.readlink(path);var len=Math.min(bufsize,lengthBytesUTF8(ret));var endChar=HEAP8[buf+len];stringToUTF8(ret,buf,bufsize+1);HEAP8[buf+len]=endChar;return len}),doAccess:(function(path,amode){if(amode&~7){return-ERRNO_CODES.EINVAL}var node;var lookup=FS.lookupPath(path,{follow:true});node=lookup.node;var perms="";if(amode&4)perms+="r";if(amode&2)perms+="w";if(amode&1)perms+="x";if(perms&&FS.nodePermissions(node,perms)){return-ERRNO_CODES.EACCES}return 0}),doDup:(function(path,flags,suggestFD){var suggest=FS.getStream(suggestFD);if(suggest)FS.close(suggest);return FS.open(path,flags,0,suggestFD,suggestFD).fd}),doReadv:(function(stream,iov,iovcnt,offset){var ret=0;for(var i=0;i<iovcnt;i++){var ptr=HEAP32[iov+i*8>>2];var len=HEAP32[iov+(i*8+4)>>2];var curr=FS.read(stream,HEAP8,ptr,len,offset);if(curr<0)return-1;ret+=curr;if(curr<len)break}return ret}),doWritev:(function(stream,iov,iovcnt,offset){var ret=0;for(var i=0;i<iovcnt;i++){var ptr=HEAP32[iov+i*8>>2];var len=HEAP32[iov+(i*8+4)>>2];var curr=FS.write(stream,HEAP8,ptr,len,offset);if(curr<0)return-1;ret+=curr}return ret}),varargs:0,get:(function(varargs){SYSCALLS.varargs+=4;var ret=HEAP32[SYSCALLS.varargs-4>>2];return ret}),getStr:(function(){var ret=Pointer_stringify(SYSCALLS.get());return ret}),getStreamFromFD:(function(){var stream=FS.getStream(SYSCALLS.get());if(!stream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);return stream}),getSocketFromFD:(function(){var socket=SOCKFS.getSocket(SYSCALLS.get());if(!socket)throw new FS.ErrnoError(ERRNO_CODES.EBADF);return socket}),getSocketAddress:(function(allowNull){var addrp=SYSCALLS.get(),addrlen=SYSCALLS.get();if(allowNull&&addrp===0)return null;var info=__read_sockaddr(addrp,addrlen);if(info.errno)throw new FS.ErrnoError(info.errno);info.addr=DNS.lookup_addr(info.addr)||info.addr;return info}),get64:(function(){var low=SYSCALLS.get(),high=SYSCALLS.get();if(low>=0)assert(high===0);else assert(high===-1);return low}),getZero:(function(){assert(SYSCALLS.get()===0)})};function ___syscall91(which,varargs){SYSCALLS.varargs=varargs;try{var addr=SYSCALLS.get(),len=SYSCALLS.get();var info=SYSCALLS.mappings[addr];if(!info)return 0;if(len===info.len){var stream=FS.getStream(info.fd);SYSCALLS.doMsync(addr,stream,len,info.flags);FS.munmap(stream);SYSCALLS.mappings[addr]=null;if(info.allocated){_free(info.malloc)}}return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function _pthread_mutexattr_destroy(){}function _emscripten_set_main_loop_timing(mode,value){Browser.mainLoop.timingMode=mode;Browser.mainLoop.timingValue=value;if(!Browser.mainLoop.func){return 1}if(mode==0){Browser.mainLoop.scheduler=function Browser_mainLoop_scheduler_setTimeout(){var timeUntilNextTick=Math.max(0,Browser.mainLoop.tickStartTime+value-_emscripten_get_now())|0;setTimeout(Browser.mainLoop.runner,timeUntilNextTick)};Browser.mainLoop.method="timeout"}else if(mode==1){Browser.mainLoop.scheduler=function Browser_mainLoop_scheduler_rAF(){Browser.requestAnimationFrame(Browser.mainLoop.runner)};Browser.mainLoop.method="rAF"}else if(mode==2){if(!window["setImmediate"]){var setImmediates=[];var emscriptenMainLoopMessageId="setimmediate";function Browser_setImmediate_messageHandler(event){if(event.source===window&&event.data===emscriptenMainLoopMessageId){event.stopPropagation();setImmediates.shift()()}}window.addEventListener("message",Browser_setImmediate_messageHandler,true);window["setImmediate"]=function Browser_emulated_setImmediate(func){setImmediates.push(func);if(ENVIRONMENT_IS_WORKER){if(Module["setImmediates"]===undefined)Module["setImmediates"]=[];Module["setImmediates"].push(func);window.postMessage({target:emscriptenMainLoopMessageId})}else window.postMessage(emscriptenMainLoopMessageId,"*")}}Browser.mainLoop.scheduler=function Browser_mainLoop_scheduler_setImmediate(){window["setImmediate"](Browser.mainLoop.runner)};Browser.mainLoop.method="immediate"}return 0}function _emscripten_get_now(){abort()}function _emscripten_set_main_loop(func,fps,simulateInfiniteLoop,arg,noSetTiming){Module["noExitRuntime"]=true;assert(!Browser.mainLoop.func,"emscripten_set_main_loop: there can only be one main loop function at once: call emscripten_cancel_main_loop to cancel the previous one before setting a new one with different parameters.");Browser.mainLoop.func=func;Browser.mainLoop.arg=arg;var browserIterationFunc;if(typeof arg!=="undefined"){browserIterationFunc=(function(){Module["dynCall_vi"](func,arg)})}else{browserIterationFunc=(function(){Module["dynCall_v"](func)})}var thisMainLoopId=Browser.mainLoop.currentlyRunningMainloop;Browser.mainLoop.runner=function Browser_mainLoop_runner(){if(ABORT)return;if(Browser.mainLoop.queue.length>0){var start=Date.now();var blocker=Browser.mainLoop.queue.shift();blocker.func(blocker.arg);if(Browser.mainLoop.remainingBlockers){var remaining=Browser.mainLoop.remainingBlockers;var next=remaining%1==0?remaining-1:Math.floor(remaining);if(blocker.counted){Browser.mainLoop.remainingBlockers=next}else{next=next+.5;Browser.mainLoop.remainingBlockers=(8*remaining+next)/9}}console.log('main loop blocker "'+blocker.name+'" took '+(Date.now()-start)+" ms");Browser.mainLoop.updateStatus();if(thisMainLoopId<Browser.mainLoop.currentlyRunningMainloop)return;setTimeout(Browser.mainLoop.runner,0);return}if(thisMainLoopId<Browser.mainLoop.currentlyRunningMainloop)return;Browser.mainLoop.currentFrameNumber=Browser.mainLoop.currentFrameNumber+1|0;if(Browser.mainLoop.timingMode==1&&Browser.mainLoop.timingValue>1&&Browser.mainLoop.currentFrameNumber%Browser.mainLoop.timingValue!=0){Browser.mainLoop.scheduler();return}else if(Browser.mainLoop.timingMode==0){Browser.mainLoop.tickStartTime=_emscripten_get_now()}if(Browser.mainLoop.method==="timeout"&&Module.ctx){Module.printErr("Looks like you are rendering without using requestAnimationFrame for the main loop. You should use 0 for the frame rate in emscripten_set_main_loop in order to use requestAnimationFrame, as that can greatly improve your frame rates!");Browser.mainLoop.method=""}Browser.mainLoop.runIter(browserIterationFunc);if(thisMainLoopId<Browser.mainLoop.currentlyRunningMainloop)return;if(typeof SDL==="object"&&SDL.audio&&SDL.audio.queueNewAudioData)SDL.audio.queueNewAudioData();Browser.mainLoop.scheduler()};if(!noSetTiming){if(fps&&fps>0)_emscripten_set_main_loop_timing(0,1e3/fps);else _emscripten_set_main_loop_timing(1,1);Browser.mainLoop.scheduler()}if(simulateInfiniteLoop){throw"SimulateInfiniteLoop"}}var Browser={mainLoop:{scheduler:null,method:"",currentlyRunningMainloop:0,func:null,arg:0,timingMode:0,timingValue:0,currentFrameNumber:0,queue:[],pause:(function(){Browser.mainLoop.scheduler=null;Browser.mainLoop.currentlyRunningMainloop++}),resume:(function(){Browser.mainLoop.currentlyRunningMainloop++;var timingMode=Browser.mainLoop.timingMode;var timingValue=Browser.mainLoop.timingValue;var func=Browser.mainLoop.func;Browser.mainLoop.func=null;_emscripten_set_main_loop(func,0,false,Browser.mainLoop.arg,true);_emscripten_set_main_loop_timing(timingMode,timingValue);Browser.mainLoop.scheduler()}),updateStatus:(function(){if(Module["setStatus"]){var message=Module["statusMessage"]||"Please wait...";var remaining=Browser.mainLoop.remainingBlockers;var expected=Browser.mainLoop.expectedBlockers;if(remaining){if(remaining<expected){Module["setStatus"](message+" ("+(expected-remaining)+"/"+expected+")")}else{Module["setStatus"](message)}}else{Module["setStatus"]("")}}}),runIter:(function(func){if(ABORT)return;if(Module["preMainLoop"]){var preRet=Module["preMainLoop"]();if(preRet===false){return}}try{func()}catch(e){if(e instanceof ExitStatus){return}else{if(e&&typeof e==="object"&&e.stack)Module.printErr("exception thrown: "+[e,e.stack]);throw e}}if(Module["postMainLoop"])Module["postMainLoop"]()})},isFullscreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:(function(){if(!Module["preloadPlugins"])Module["preloadPlugins"]=[];if(Browser.initted)return;Browser.initted=true;try{new Blob;Browser.hasBlobConstructor=true}catch(e){Browser.hasBlobConstructor=false;console.log("warning: no blob constructor, cannot create blobs with mimetypes")}Browser.BlobBuilder=typeof MozBlobBuilder!="undefined"?MozBlobBuilder:typeof WebKitBlobBuilder!="undefined"?WebKitBlobBuilder:!Browser.hasBlobConstructor?console.log("warning: no BlobBuilder"):null;Browser.URLObject=typeof window!="undefined"?window.URL?window.URL:window.webkitURL:undefined;if(!Module.noImageDecoding&&typeof Browser.URLObject==="undefined"){console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");Module.noImageDecoding=true}var imagePlugin={};imagePlugin["canHandle"]=function imagePlugin_canHandle(name){return!Module.noImageDecoding&&/\.(jpg|jpeg|png|bmp)$/i.test(name)};imagePlugin["handle"]=function imagePlugin_handle(byteArray,name,onload,onerror){var b=null;if(Browser.hasBlobConstructor){try{b=new Blob([byteArray],{type:Browser.getMimetype(name)});if(b.size!==byteArray.length){b=new Blob([(new Uint8Array(byteArray)).buffer],{type:Browser.getMimetype(name)})}}catch(e){Runtime.warnOnce("Blob constructor present but fails: "+e+"; falling back to blob builder")}}if(!b){var bb=new Browser.BlobBuilder;bb.append((new Uint8Array(byteArray)).buffer);b=bb.getBlob()}var url=Browser.URLObject.createObjectURL(b);var img=new Image;img.onload=function img_onload(){assert(img.complete,"Image "+name+" could not be decoded");var canvas=document.createElement("canvas");canvas.width=img.width;canvas.height=img.height;var ctx=canvas.getContext("2d");ctx.drawImage(img,0,0);Module["preloadedImages"][name]=canvas;Browser.URLObject.revokeObjectURL(url);if(onload)onload(byteArray)};img.onerror=function img_onerror(event){console.log("Image "+url+" could not be decoded");if(onerror)onerror()};img.src=url};Module["preloadPlugins"].push(imagePlugin);var audioPlugin={};audioPlugin["canHandle"]=function audioPlugin_canHandle(name){return!Module.noAudioDecoding&&name.substr(-4)in{".ogg":1,".wav":1,".mp3":1}};audioPlugin["handle"]=function audioPlugin_handle(byteArray,name,onload,onerror){var done=false;function finish(audio){if(done)return;done=true;Module["preloadedAudios"][name]=audio;if(onload)onload(byteArray)}function fail(){if(done)return;done=true;Module["preloadedAudios"][name]=new Audio;if(onerror)onerror()}if(Browser.hasBlobConstructor){try{var b=new Blob([byteArray],{type:Browser.getMimetype(name)})}catch(e){return fail()}var url=Browser.URLObject.createObjectURL(b);var audio=new Audio;audio.addEventListener("canplaythrough",(function(){finish(audio)}),false);audio.onerror=function audio_onerror(event){if(done)return;console.log("warning: browser could not fully decode audio "+name+", trying slower base64 approach");function encode64(data){var BASE="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";var PAD="=";var ret="";var leftchar=0;var leftbits=0;for(var i=0;i<data.length;i++){leftchar=leftchar<<8|data[i];leftbits+=8;while(leftbits>=6){var curr=leftchar>>leftbits-6&63;leftbits-=6;ret+=BASE[curr]}}if(leftbits==2){ret+=BASE[(leftchar&3)<<4];ret+=PAD+PAD}else if(leftbits==4){ret+=BASE[(leftchar&15)<<2];ret+=PAD}return ret}audio.src="data:audio/x-"+name.substr(-3)+";base64,"+encode64(byteArray);finish(audio)};audio.src=url;Browser.safeSetTimeout((function(){finish(audio)}),1e4)}else{return fail()}};Module["preloadPlugins"].push(audioPlugin);function pointerLockChange(){Browser.pointerLock=document["pointerLockElement"]===Module["canvas"]||document["mozPointerLockElement"]===Module["canvas"]||document["webkitPointerLockElement"]===Module["canvas"]||document["msPointerLockElement"]===Module["canvas"]}var canvas=Module["canvas"];if(canvas){canvas.requestPointerLock=canvas["requestPointerLock"]||canvas["mozRequestPointerLock"]||canvas["webkitRequestPointerLock"]||canvas["msRequestPointerLock"]||(function(){});canvas.exitPointerLock=document["exitPointerLock"]||document["mozExitPointerLock"]||document["webkitExitPointerLock"]||document["msExitPointerLock"]||(function(){});canvas.exitPointerLock=canvas.exitPointerLock.bind(document);document.addEventListener("pointerlockchange",pointerLockChange,false);document.addEventListener("mozpointerlockchange",pointerLockChange,false);document.addEventListener("webkitpointerlockchange",pointerLockChange,false);document.addEventListener("mspointerlockchange",pointerLockChange,false);if(Module["elementPointerLock"]){canvas.addEventListener("click",(function(ev){if(!Browser.pointerLock&&Module["canvas"].requestPointerLock){Module["canvas"].requestPointerLock();ev.preventDefault()}}),false)}}}),createContext:(function(canvas,useWebGL,setInModule,webGLContextAttributes){if(useWebGL&&Module.ctx&&canvas==Module.canvas)return Module.ctx;var ctx;var contextHandle;if(useWebGL){var contextAttributes={antialias:false,alpha:false};if(webGLContextAttributes){for(var attribute in webGLContextAttributes){contextAttributes[attribute]=webGLContextAttributes[attribute]}}contextHandle=GL.createContext(canvas,contextAttributes);if(contextHandle){ctx=GL.getContext(contextHandle).GLctx}}else{ctx=canvas.getContext("2d")}if(!ctx)return null;if(setInModule){if(!useWebGL)assert(typeof GLctx==="undefined","cannot set in module if GLctx is used, but we are a non-GL context that would replace it");Module.ctx=ctx;if(useWebGL)GL.makeContextCurrent(contextHandle);Module.useWebGL=useWebGL;Browser.moduleContextCreatedCallbacks.forEach((function(callback){callback()}));Browser.init()}return ctx}),destroyContext:(function(canvas,useWebGL,setInModule){}),fullscreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullscreen:(function(lockPointer,resizeCanvas,vrDevice){Browser.lockPointer=lockPointer;Browser.resizeCanvas=resizeCanvas;Browser.vrDevice=vrDevice;if(typeof Browser.lockPointer==="undefined")Browser.lockPointer=true;if(typeof Browser.resizeCanvas==="undefined")Browser.resizeCanvas=false;if(typeof Browser.vrDevice==="undefined")Browser.vrDevice=null;var canvas=Module["canvas"];function fullscreenChange(){Browser.isFullscreen=false;var canvasContainer=canvas.parentNode;if((document["fullscreenElement"]||document["mozFullScreenElement"]||document["msFullscreenElement"]||document["webkitFullscreenElement"]||document["webkitCurrentFullScreenElement"])===canvasContainer){canvas.exitFullscreen=document["exitFullscreen"]||document["cancelFullScreen"]||document["mozCancelFullScreen"]||document["msExitFullscreen"]||document["webkitCancelFullScreen"]||(function(){});canvas.exitFullscreen=canvas.exitFullscreen.bind(document);if(Browser.lockPointer)canvas.requestPointerLock();Browser.isFullscreen=true;if(Browser.resizeCanvas)Browser.setFullscreenCanvasSize()}else{canvasContainer.parentNode.insertBefore(canvas,canvasContainer);canvasContainer.parentNode.removeChild(canvasContainer);if(Browser.resizeCanvas)Browser.setWindowedCanvasSize()}if(Module["onFullScreen"])Module["onFullScreen"](Browser.isFullscreen);if(Module["onFullscreen"])Module["onFullscreen"](Browser.isFullscreen);Browser.updateCanvasDimensions(canvas)}if(!Browser.fullscreenHandlersInstalled){Browser.fullscreenHandlersInstalled=true;document.addEventListener("fullscreenchange",fullscreenChange,false);document.addEventListener("mozfullscreenchange",fullscreenChange,false);document.addEventListener("webkitfullscreenchange",fullscreenChange,false);document.addEventListener("MSFullscreenChange",fullscreenChange,false)}var canvasContainer=document.createElement("div");canvas.parentNode.insertBefore(canvasContainer,canvas);canvasContainer.appendChild(canvas);canvasContainer.requestFullscreen=canvasContainer["requestFullscreen"]||canvasContainer["mozRequestFullScreen"]||canvasContainer["msRequestFullscreen"]||(canvasContainer["webkitRequestFullscreen"]?(function(){canvasContainer["webkitRequestFullscreen"](Element["ALLOW_KEYBOARD_INPUT"])}):null)||(canvasContainer["webkitRequestFullScreen"]?(function(){canvasContainer["webkitRequestFullScreen"](Element["ALLOW_KEYBOARD_INPUT"])}):null);if(vrDevice){canvasContainer.requestFullscreen({vrDisplay:vrDevice})}else{canvasContainer.requestFullscreen()}}),requestFullScreen:(function(lockPointer,resizeCanvas,vrDevice){Module.printErr("Browser.requestFullScreen() is deprecated. Please call Browser.requestFullscreen instead.");Browser.requestFullScreen=(function(lockPointer,resizeCanvas,vrDevice){return Browser.requestFullscreen(lockPointer,resizeCanvas,vrDevice)});return Browser.requestFullscreen(lockPointer,resizeCanvas,vrDevice)}),nextRAF:0,fakeRequestAnimationFrame:(function(func){var now=Date.now();if(Browser.nextRAF===0){Browser.nextRAF=now+1e3/60}else{while(now+2>=Browser.nextRAF){Browser.nextRAF+=1e3/60}}var delay=Math.max(Browser.nextRAF-now,0);setTimeout(func,delay)}),requestAnimationFrame:function requestAnimationFrame(func){if(typeof window==="undefined"){Browser.fakeRequestAnimationFrame(func)}else{if(!window.requestAnimationFrame){window.requestAnimationFrame=window["requestAnimationFrame"]||window["mozRequestAnimationFrame"]||window["webkitRequestAnimationFrame"]||window["msRequestAnimationFrame"]||window["oRequestAnimationFrame"]||Browser.fakeRequestAnimationFrame}window.requestAnimationFrame(func)}},safeCallback:(function(func){return(function(){if(!ABORT)return func.apply(null,arguments)})}),allowAsyncCallbacks:true,queuedAsyncCallbacks:[],pauseAsyncCallbacks:(function(){Browser.allowAsyncCallbacks=false}),resumeAsyncCallbacks:(function(){Browser.allowAsyncCallbacks=true;if(Browser.queuedAsyncCallbacks.length>0){var callbacks=Browser.queuedAsyncCallbacks;Browser.queuedAsyncCallbacks=[];callbacks.forEach((function(func){func()}))}}),safeRequestAnimationFrame:(function(func){return Browser.requestAnimationFrame((function(){if(ABORT)return;if(Browser.allowAsyncCallbacks){func()}else{Browser.queuedAsyncCallbacks.push(func)}}))}),safeSetTimeout:(function(func,timeout){Module["noExitRuntime"]=true;return setTimeout((function(){if(ABORT)return;if(Browser.allowAsyncCallbacks){func()}else{Browser.queuedAsyncCallbacks.push(func)}}),timeout)}),safeSetInterval:(function(func,timeout){Module["noExitRuntime"]=true;return setInterval((function(){if(ABORT)return;if(Browser.allowAsyncCallbacks){func()}}),timeout)}),getMimetype:(function(name){return{"jpg":"image/jpeg","jpeg":"image/jpeg","png":"image/png","bmp":"image/bmp","ogg":"audio/ogg","wav":"audio/wav","mp3":"audio/mpeg"}[name.substr(name.lastIndexOf(".")+1)]}),getUserMedia:(function(func){if(!window.getUserMedia){window.getUserMedia=navigator["getUserMedia"]||navigator["mozGetUserMedia"]}window.getUserMedia(func)}),getMovementX:(function(event){return event["movementX"]||event["mozMovementX"]||event["webkitMovementX"]||0}),getMovementY:(function(event){return event["movementY"]||event["mozMovementY"]||event["webkitMovementY"]||0}),getMouseWheelDelta:(function(event){var delta=0;switch(event.type){case"DOMMouseScroll":delta=event.detail;break;case"mousewheel":delta=event.wheelDelta;break;case"wheel":delta=event["deltaY"];break;default:throw"unrecognized mouse wheel event: "+event.type}return delta}),mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,touches:{},lastTouches:{},calculateMouseEvent:(function(event){if(Browser.pointerLock){if(event.type!="mousemove"&&"mozMovementX"in event){Browser.mouseMovementX=Browser.mouseMovementY=0}else{Browser.mouseMovementX=Browser.getMovementX(event);Browser.mouseMovementY=Browser.getMovementY(event)}if(typeof SDL!="undefined"){Browser.mouseX=SDL.mouseX+Browser.mouseMovementX;Browser.mouseY=SDL.mouseY+Browser.mouseMovementY}else{Browser.mouseX+=Browser.mouseMovementX;Browser.mouseY+=Browser.mouseMovementY}}else{var rect=Module["canvas"].getBoundingClientRect();var cw=Module["canvas"].width;var ch=Module["canvas"].height;var scrollX=typeof window.scrollX!=="undefined"?window.scrollX:window.pageXOffset;var scrollY=typeof window.scrollY!=="undefined"?window.scrollY:window.pageYOffset;if(event.type==="touchstart"||event.type==="touchend"||event.type==="touchmove"){var touch=event.touch;if(touch===undefined){return}var adjustedX=touch.pageX-(scrollX+rect.left);var adjustedY=touch.pageY-(scrollY+rect.top);adjustedX=adjustedX*(cw/rect.width);adjustedY=adjustedY*(ch/rect.height);var coords={x:adjustedX,y:adjustedY};if(event.type==="touchstart"){Browser.lastTouches[touch.identifier]=coords;Browser.touches[touch.identifier]=coords}else if(event.type==="touchend"||event.type==="touchmove"){var last=Browser.touches[touch.identifier];if(!last)last=coords;Browser.lastTouches[touch.identifier]=last;Browser.touches[touch.identifier]=coords}return}var x=event.pageX-(scrollX+rect.left);var y=event.pageY-(scrollY+rect.top);x=x*(cw/rect.width);y=y*(ch/rect.height);Browser.mouseMovementX=x-Browser.mouseX;Browser.mouseMovementY=y-Browser.mouseY;Browser.mouseX=x;Browser.mouseY=y}}),asyncLoad:(function(url,onload,onerror,noRunDep){var dep=!noRunDep?getUniqueRunDependency("al "+url):"";Module["readAsync"](url,(function(arrayBuffer){assert(arrayBuffer,'Loading data file "'+url+'" failed (no arrayBuffer).');onload(new Uint8Array(arrayBuffer));if(dep)removeRunDependency(dep)}),(function(event){if(onerror){onerror()}else{throw'Loading data file "'+url+'" failed.'}}));if(dep)addRunDependency(dep)}),resizeListeners:[],updateResizeListeners:(function(){var canvas=Module["canvas"];Browser.resizeListeners.forEach((function(listener){listener(canvas.width,canvas.height)}))}),setCanvasSize:(function(width,height,noUpdates){var canvas=Module["canvas"];Browser.updateCanvasDimensions(canvas,width,height);if(!noUpdates)Browser.updateResizeListeners()}),windowedWidth:0,windowedHeight:0,setFullscreenCanvasSize:(function(){if(typeof SDL!="undefined"){var flags=HEAPU32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2];flags=flags|8388608;HEAP32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2]=flags}Browser.updateResizeListeners()}),setWindowedCanvasSize:(function(){if(typeof SDL!="undefined"){var flags=HEAPU32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2];flags=flags&~8388608;HEAP32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2]=flags}Browser.updateResizeListeners()}),updateCanvasDimensions:(function(canvas,wNative,hNative){if(wNative&&hNative){canvas.widthNative=wNative;canvas.heightNative=hNative}else{wNative=canvas.widthNative;hNative=canvas.heightNative}var w=wNative;var h=hNative;if(Module["forcedAspectRatio"]&&Module["forcedAspectRatio"]>0){if(w/h<Module["forcedAspectRatio"]){w=Math.round(h*Module["forcedAspectRatio"])}else{h=Math.round(w/Module["forcedAspectRatio"])}}if((document["fullscreenElement"]||document["mozFullScreenElement"]||document["msFullscreenElement"]||document["webkitFullscreenElement"]||document["webkitCurrentFullScreenElement"])===canvas.parentNode&&typeof screen!="undefined"){var factor=Math.min(screen.width/w,screen.height/h);w=Math.round(w*factor);h=Math.round(h*factor)}if(Browser.resizeCanvas){if(canvas.width!=w)canvas.width=w;if(canvas.height!=h)canvas.height=h;if(typeof canvas.style!="undefined"){canvas.style.removeProperty("width");canvas.style.removeProperty("height")}}else{if(canvas.width!=wNative)canvas.width=wNative;if(canvas.height!=hNative)canvas.height=hNative;if(typeof canvas.style!="undefined"){if(w!=wNative||h!=hNative){canvas.style.setProperty("width",w+"px","important");canvas.style.setProperty("height",h+"px","important")}else{canvas.style.removeProperty("width");canvas.style.removeProperty("height")}}}}),wgetRequests:{},nextWgetRequestHandle:0,getNextWgetRequestHandle:(function(){var handle=Browser.nextWgetRequestHandle;Browser.nextWgetRequestHandle++;return handle})};function ___syscall54(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),op=SYSCALLS.get();switch(op){case 21505:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return 0};case 21506:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return 0};case 21519:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;var argp=SYSCALLS.get();HEAP32[argp>>2]=0;return 0};case 21520:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return-ERRNO_CODES.EINVAL};case 21531:{var argp=SYSCALLS.get();return FS.ioctl(stream,op,argp)};case 21523:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return 0};default:abort("bad ioctl syscall "+op)}}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}var tupleRegistrations={};function requireFunction(signature,rawFunction){signature=readLatin1String(signature);function makeDynCaller(dynCall){var args=[];for(var i=1;i<signature.length;++i){args.push("a"+i)}var name="dynCall_"+signature+"_"+rawFunction;var body="return function "+name+"("+args.join(", ")+") {\n";body+="    return dynCall(rawFunction"+(args.length?", ":"")+args.join(", ")+");\n";body+="};\n";return(new Function("dynCall","rawFunction",body))(dynCall,rawFunction)}var fp;if(Module["FUNCTION_TABLE_"+signature]!==undefined){fp=Module["FUNCTION_TABLE_"+signature][rawFunction]}else if(typeof FUNCTION_TABLE!=="undefined"){fp=FUNCTION_TABLE[rawFunction]}else{var dc=Module["asm"]["dynCall_"+signature];if(dc===undefined){dc=Module["asm"]["dynCall_"+signature.replace(/f/g,"d")];if(dc===undefined){throwBindingError("No dynCall invoker for signature: "+signature)}}fp=makeDynCaller(dc)}if(typeof fp!=="function"){throwBindingError("unknown function pointer with signature "+signature+": "+rawFunction)}return fp}function __embind_register_value_array(rawType,name,constructorSignature,rawConstructor,destructorSignature,rawDestructor){tupleRegistrations[rawType]={name:readLatin1String(name),rawConstructor:requireFunction(constructorSignature,rawConstructor),rawDestructor:requireFunction(destructorSignature,rawDestructor),elements:[]}}Module["_bitshift64Ashr"]=_bitshift64Ashr;Module["_bitshift64Lshr"]=_bitshift64Lshr;function upcastPointer(ptr,ptrClass,desiredClass){while(ptrClass!==desiredClass){if(!ptrClass.upcast){throwBindingError("Expected null or instance of "+desiredClass.name+", got an instance of "+ptrClass.name)}ptr=ptrClass.upcast(ptr);ptrClass=ptrClass.baseClass}return ptr}function constNoSmartPtrRawPointerToWireType(destructors,handle){if(handle===null){if(this.isReference){throwBindingError("null is not a valid "+this.name)}return 0}if(!handle.$$){throwBindingError('Cannot pass "'+_embind_repr(handle)+'" as a '+this.name)}if(!handle.$$.ptr){throwBindingError("Cannot pass deleted object as a pointer of type "+this.name)}var handleClass=handle.$$.ptrType.registeredClass;var ptr=upcastPointer(handle.$$.ptr,handleClass,this.registeredClass);return ptr}function genericPointerToWireType(destructors,handle){if(handle===null){if(this.isReference){throwBindingError("null is not a valid "+this.name)}if(this.isSmartPointer){var ptr=this.rawConstructor();if(destructors!==null){destructors.push(this.rawDestructor,ptr)}return ptr}else{return 0}}if(!handle.$$){throwBindingError('Cannot pass "'+_embind_repr(handle)+'" as a '+this.name)}if(!handle.$$.ptr){throwBindingError("Cannot pass deleted object as a pointer of type "+this.name)}if(!this.isConst&&handle.$$.ptrType.isConst){throwBindingError("Cannot convert argument of type "+(handle.$$.smartPtrType?handle.$$.smartPtrType.name:handle.$$.ptrType.name)+" to parameter type "+this.name)}var handleClass=handle.$$.ptrType.registeredClass;var ptr=upcastPointer(handle.$$.ptr,handleClass,this.registeredClass);if(this.isSmartPointer){if(undefined===handle.$$.smartPtr){throwBindingError("Passing raw pointer to smart pointer is illegal")}switch(this.sharingPolicy){case 0:if(handle.$$.smartPtrType===this){ptr=handle.$$.smartPtr}else{throwBindingError("Cannot convert argument of type "+(handle.$$.smartPtrType?handle.$$.smartPtrType.name:handle.$$.ptrType.name)+" to parameter type "+this.name)}break;case 1:ptr=handle.$$.smartPtr;break;case 2:if(handle.$$.smartPtrType===this){ptr=handle.$$.smartPtr}else{var clonedHandle=handle["clone"]();ptr=this.rawShare(ptr,__emval_register((function(){clonedHandle["delete"]()})));if(destructors!==null){destructors.push(this.rawDestructor,ptr)}}break;default:throwBindingError("Unsupporting sharing policy")}}return ptr}function nonConstNoSmartPtrRawPointerToWireType(destructors,handle){if(handle===null){if(this.isReference){throwBindingError("null is not a valid "+this.name)}return 0}if(!handle.$$){throwBindingError('Cannot pass "'+_embind_repr(handle)+'" as a '+this.name)}if(!handle.$$.ptr){throwBindingError("Cannot pass deleted object as a pointer of type "+this.name)}if(handle.$$.ptrType.isConst){throwBindingError("Cannot convert argument of type "+handle.$$.ptrType.name+" to parameter type "+this.name)}var handleClass=handle.$$.ptrType.registeredClass;var ptr=upcastPointer(handle.$$.ptr,handleClass,this.registeredClass);return ptr}function RegisteredPointer_getPointee(ptr){if(this.rawGetPointee){ptr=this.rawGetPointee(ptr)}return ptr}function RegisteredPointer_destructor(ptr){if(this.rawDestructor){this.rawDestructor(ptr)}}function RegisteredPointer_deleteObject(handle){if(handle!==null){handle["delete"]()}}function downcastPointer(ptr,ptrClass,desiredClass){if(ptrClass===desiredClass){return ptr}if(undefined===desiredClass.baseClass){return null}var rv=downcastPointer(ptr,ptrClass,desiredClass.baseClass);if(rv===null){return null}return desiredClass.downcast(rv)}var registeredPointers={};function getInheritedInstanceCount(){return Object.keys(registeredInstances).length}function getLiveInheritedInstances(){var rv=[];for(var k in registeredInstances){if(registeredInstances.hasOwnProperty(k)){rv.push(registeredInstances[k])}}return rv}var deletionQueue=[];function flushPendingDeletes(){while(deletionQueue.length){var obj=deletionQueue.pop();obj.$$.deleteScheduled=false;obj["delete"]()}}var delayFunction=undefined;function setDelayFunction(fn){delayFunction=fn;if(deletionQueue.length&&delayFunction){delayFunction(flushPendingDeletes)}}function init_embind(){Module["getInheritedInstanceCount"]=getInheritedInstanceCount;Module["getLiveInheritedInstances"]=getLiveInheritedInstances;Module["flushPendingDeletes"]=flushPendingDeletes;Module["setDelayFunction"]=setDelayFunction}var registeredInstances={};function getBasestPointer(class_,ptr){if(ptr===undefined){throwBindingError("ptr should not be undefined")}while(class_.baseClass){ptr=class_.upcast(ptr);class_=class_.baseClass}return ptr}function getInheritedInstance(class_,ptr){ptr=getBasestPointer(class_,ptr);return registeredInstances[ptr]}function makeClassHandle(prototype,record){if(!record.ptrType||!record.ptr){throwInternalError("makeClassHandle requires ptr and ptrType")}var hasSmartPtrType=!!record.smartPtrType;var hasSmartPtr=!!record.smartPtr;if(hasSmartPtrType!==hasSmartPtr){throwInternalError("Both smartPtrType and smartPtr must be specified")}record.count={value:1};return Object.create(prototype,{$$:{value:record}})}function RegisteredPointer_fromWireType(ptr){var rawPointer=this.getPointee(ptr);if(!rawPointer){this.destructor(ptr);return null}var registeredInstance=getInheritedInstance(this.registeredClass,rawPointer);if(undefined!==registeredInstance){if(0===registeredInstance.$$.count.value){registeredInstance.$$.ptr=rawPointer;registeredInstance.$$.smartPtr=ptr;return registeredInstance["clone"]()}else{var rv=registeredInstance["clone"]();this.destructor(ptr);return rv}}function makeDefaultHandle(){if(this.isSmartPointer){return makeClassHandle(this.registeredClass.instancePrototype,{ptrType:this.pointeeType,ptr:rawPointer,smartPtrType:this,smartPtr:ptr})}else{return makeClassHandle(this.registeredClass.instancePrototype,{ptrType:this,ptr:ptr})}}var actualType=this.registeredClass.getActualType(rawPointer);var registeredPointerRecord=registeredPointers[actualType];if(!registeredPointerRecord){return makeDefaultHandle.call(this)}var toType;if(this.isConst){toType=registeredPointerRecord.constPointerType}else{toType=registeredPointerRecord.pointerType}var dp=downcastPointer(rawPointer,this.registeredClass,toType.registeredClass);if(dp===null){return makeDefaultHandle.call(this)}if(this.isSmartPointer){return makeClassHandle(toType.registeredClass.instancePrototype,{ptrType:toType,ptr:dp,smartPtrType:this,smartPtr:ptr})}else{return makeClassHandle(toType.registeredClass.instancePrototype,{ptrType:toType,ptr:dp})}}function init_RegisteredPointer(){RegisteredPointer.prototype.getPointee=RegisteredPointer_getPointee;RegisteredPointer.prototype.destructor=RegisteredPointer_destructor;RegisteredPointer.prototype["argPackAdvance"]=8;RegisteredPointer.prototype["readValueFromPointer"]=simpleReadValueFromPointer;RegisteredPointer.prototype["deleteObject"]=RegisteredPointer_deleteObject;RegisteredPointer.prototype["fromWireType"]=RegisteredPointer_fromWireType}function RegisteredPointer(name,registeredClass,isReference,isConst,isSmartPointer,pointeeType,sharingPolicy,rawGetPointee,rawConstructor,rawShare,rawDestructor){this.name=name;this.registeredClass=registeredClass;this.isReference=isReference;this.isConst=isConst;this.isSmartPointer=isSmartPointer;this.pointeeType=pointeeType;this.sharingPolicy=sharingPolicy;this.rawGetPointee=rawGetPointee;this.rawConstructor=rawConstructor;this.rawShare=rawShare;this.rawDestructor=rawDestructor;if(!isSmartPointer&&registeredClass.baseClass===undefined){if(isConst){this["toWireType"]=constNoSmartPtrRawPointerToWireType;this.destructorFunction=null}else{this["toWireType"]=nonConstNoSmartPtrRawPointerToWireType;this.destructorFunction=null}}else{this["toWireType"]=genericPointerToWireType}}function __embind_register_smart_ptr(rawType,rawPointeeType,name,sharingPolicy,getPointeeSignature,rawGetPointee,constructorSignature,rawConstructor,shareSignature,rawShare,destructorSignature,rawDestructor){name=readLatin1String(name);rawGetPointee=requireFunction(getPointeeSignature,rawGetPointee);rawConstructor=requireFunction(constructorSignature,rawConstructor);rawShare=requireFunction(shareSignature,rawShare);rawDestructor=requireFunction(destructorSignature,rawDestructor);whenDependentTypesAreResolved([rawType],[rawPointeeType],(function(pointeeType){pointeeType=pointeeType[0];var registeredPointer=new RegisteredPointer(name,pointeeType.registeredClass,false,false,true,pointeeType,sharingPolicy,rawGetPointee,rawConstructor,rawShare,rawDestructor);return[registeredPointer]}))}Module["_pthread_cond_broadcast"]=_pthread_cond_broadcast;function craftInvokerFunction(humanName,argTypes,classType,cppInvokerFunc,cppTargetFunc){var argCount=argTypes.length;if(argCount<2){throwBindingError("argTypes array size mismatch! Must at least get return value and 'this' types!")}var isClassMethodFunc=argTypes[1]!==null&&classType!==null;var argsList="";var argsListWired="";for(var i=0;i<argCount-2;++i){argsList+=(i!==0?", ":"")+"arg"+i;argsListWired+=(i!==0?", ":"")+"arg"+i+"Wired"}var invokerFnBody="return function "+makeLegalFunctionName(humanName)+"("+argsList+") {\n"+"if (arguments.length !== "+(argCount-2)+") {\n"+"throwBindingError('function "+humanName+" called with ' + arguments.length + ' arguments, expected "+(argCount-2)+" args!');\n"+"}\n";var needsDestructorStack=false;for(var i=1;i<argTypes.length;++i){if(argTypes[i]!==null&&argTypes[i].destructorFunction===undefined){needsDestructorStack=true;break}}if(needsDestructorStack){invokerFnBody+="var destructors = [];\n"}var dtorStack=needsDestructorStack?"destructors":"null";var args1=["throwBindingError","invoker","fn","runDestructors","retType","classParam"];var args2=[throwBindingError,cppInvokerFunc,cppTargetFunc,runDestructors,argTypes[0],argTypes[1]];if(isClassMethodFunc){invokerFnBody+="var thisWired = classParam.toWireType("+dtorStack+", this);\n"}for(var i=0;i<argCount-2;++i){invokerFnBody+="var arg"+i+"Wired = argType"+i+".toWireType("+dtorStack+", arg"+i+"); // "+argTypes[i+2].name+"\n";args1.push("argType"+i);args2.push(argTypes[i+2])}if(isClassMethodFunc){argsListWired="thisWired"+(argsListWired.length>0?", ":"")+argsListWired}var returns=argTypes[0].name!=="void";invokerFnBody+=(returns?"var rv = ":"")+"invoker(fn"+(argsListWired.length>0?", ":"")+argsListWired+");\n";if(needsDestructorStack){invokerFnBody+="runDestructors(destructors);\n"}else{for(var i=isClassMethodFunc?1:2;i<argTypes.length;++i){var paramName=i===1?"thisWired":"arg"+(i-2)+"Wired";if(argTypes[i].destructorFunction!==null){invokerFnBody+=paramName+"_dtor("+paramName+"); // "+argTypes[i].name+"\n";args1.push(paramName+"_dtor");args2.push(argTypes[i].destructorFunction)}}}if(returns){invokerFnBody+="var ret = retType.fromWireType(rv);\n"+"return ret;\n"}else{}invokerFnBody+="}\n";args1.push(invokerFnBody);var invokerFunction=new_(Function,args1).apply(null,args2);return invokerFunction}function ensureOverloadTable(proto,methodName,humanName){if(undefined===proto[methodName].overloadTable){var prevFunc=proto[methodName];proto[methodName]=(function(){if(!proto[methodName].overloadTable.hasOwnProperty(arguments.length)){throwBindingError("Function '"+humanName+"' called with an invalid number of arguments ("+arguments.length+") - expects one of ("+proto[methodName].overloadTable+")!")}return proto[methodName].overloadTable[arguments.length].apply(this,arguments)});proto[methodName].overloadTable=[];proto[methodName].overloadTable[prevFunc.argCount]=prevFunc}}function heap32VectorToArray(count,firstElement){var array=[];for(var i=0;i<count;i++){array.push(HEAP32[(firstElement>>2)+i])}return array}var UnboundTypeError=undefined;function throwUnboundTypeError(message,types){var unboundTypes=[];var seen={};function visit(type){if(seen[type]){return}if(registeredTypes[type]){return}if(typeDependencies[type]){typeDependencies[type].forEach(visit);return}unboundTypes.push(type);seen[type]=true}types.forEach(visit);throw new UnboundTypeError(message+": "+unboundTypes.map(getTypeName).join([", "]))}function __embind_register_class_class_function(rawClassType,methodName,argCount,rawArgTypesAddr,invokerSignature,rawInvoker,fn){var rawArgTypes=heap32VectorToArray(argCount,rawArgTypesAddr);methodName=readLatin1String(methodName);rawInvoker=requireFunction(invokerSignature,rawInvoker);whenDependentTypesAreResolved([],[rawClassType],(function(classType){classType=classType[0];var humanName=classType.name+"."+methodName;function unboundTypesHandler(){throwUnboundTypeError("Cannot call "+humanName+" due to unbound types",rawArgTypes)}var proto=classType.registeredClass.constructor;if(undefined===proto[methodName]){unboundTypesHandler.argCount=argCount-1;proto[methodName]=unboundTypesHandler}else{ensureOverloadTable(proto,methodName,humanName);proto[methodName].overloadTable[argCount-1]=unboundTypesHandler}whenDependentTypesAreResolved([],rawArgTypes,(function(argTypes){var invokerArgsArray=[argTypes[0],null].concat(argTypes.slice(1));var func=craftInvokerFunction(humanName,invokerArgsArray,null,rawInvoker,fn);if(undefined===proto[methodName].overloadTable){proto[methodName]=func}else{proto[methodName].overloadTable[argCount-1]=func}return[]}));return[]}))}var _environ=STATICTOP;STATICTOP+=16;function ___buildEnvironment(env){var MAX_ENV_VALUES=64;var TOTAL_ENV_SIZE=1024;var poolPtr;var envPtr;if(!___buildEnvironment.called){___buildEnvironment.called=true;ENV["USER"]=ENV["LOGNAME"]="web_user";ENV["PATH"]="/";ENV["PWD"]="/";ENV["HOME"]="/home/web_user";ENV["LANG"]="C";ENV["_"]=Module["thisProgram"];poolPtr=allocate(TOTAL_ENV_SIZE,"i8",ALLOC_STATIC);envPtr=allocate(MAX_ENV_VALUES*4,"i8*",ALLOC_STATIC);HEAP32[envPtr>>2]=poolPtr;HEAP32[_environ>>2]=envPtr}else{envPtr=HEAP32[_environ>>2];poolPtr=HEAP32[envPtr>>2]}var strings=[];var totalSize=0;for(var key in env){if(typeof env[key]==="string"){var line=key+"="+env[key];strings.push(line);totalSize+=line.length}}if(totalSize>TOTAL_ENV_SIZE){throw new Error("Environment size exceeded TOTAL_ENV_SIZE!")}var ptrSize=4;for(var i=0;i<strings.length;i++){var line=strings[i];writeAsciiToMemory(line,poolPtr);HEAP32[envPtr+i*ptrSize>>2]=poolPtr;poolPtr+=line.length+1}HEAP32[envPtr+strings.length*ptrSize>>2]=0}var ENV={};function _getenv(name){if(name===0)return 0;name=Pointer_stringify(name);if(!ENV.hasOwnProperty(name))return 0;if(_getenv.ret)_free(_getenv.ret);_getenv.ret=allocate(intArrayFromString(ENV[name]),"i8",ALLOC_NORMAL);return _getenv.ret}function __isLeapYear(year){return year%4===0&&(year%100!==0||year%400===0)}function __arraySum(array,index){var sum=0;for(var i=0;i<=index;sum+=array[i++]);return sum}var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date,days){var newDate=new Date(date.getTime());while(days>0){var leap=__isLeapYear(newDate.getFullYear());var currentMonth=newDate.getMonth();var daysInCurrentMonth=(leap?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR)[currentMonth];if(days>daysInCurrentMonth-newDate.getDate()){days-=daysInCurrentMonth-newDate.getDate()+1;newDate.setDate(1);if(currentMonth<11){newDate.setMonth(currentMonth+1)}else{newDate.setMonth(0);newDate.setFullYear(newDate.getFullYear()+1)}}else{newDate.setDate(newDate.getDate()+days);return newDate}}return newDate}function _strftime(s,maxsize,format,tm){var tm_zone=HEAP32[tm+40>>2];var date={tm_sec:HEAP32[tm>>2],tm_min:HEAP32[tm+4>>2],tm_hour:HEAP32[tm+8>>2],tm_mday:HEAP32[tm+12>>2],tm_mon:HEAP32[tm+16>>2],tm_year:HEAP32[tm+20>>2],tm_wday:HEAP32[tm+24>>2],tm_yday:HEAP32[tm+28>>2],tm_isdst:HEAP32[tm+32>>2],tm_gmtoff:HEAP32[tm+36>>2],tm_zone:tm_zone?Pointer_stringify(tm_zone):""};var pattern=Pointer_stringify(format);var EXPANSION_RULES_1={"%c":"%a %b %d %H:%M:%S %Y","%D":"%m/%d/%y","%F":"%Y-%m-%d","%h":"%b","%r":"%I:%M:%S %p","%R":"%H:%M","%T":"%H:%M:%S","%x":"%m/%d/%y","%X":"%H:%M:%S"};for(var rule in EXPANSION_RULES_1){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_1[rule])}var WEEKDAYS=["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];var MONTHS=["January","February","March","April","May","June","July","August","September","October","November","December"];function leadingSomething(value,digits,character){var str=typeof value==="number"?value.toString():value||"";while(str.length<digits){str=character[0]+str}return str}function leadingNulls(value,digits){return leadingSomething(value,digits,"0")}function compareByDay(date1,date2){function sgn(value){return value<0?-1:value>0?1:0}var compare;if((compare=sgn(date1.getFullYear()-date2.getFullYear()))===0){if((compare=sgn(date1.getMonth()-date2.getMonth()))===0){compare=sgn(date1.getDate()-date2.getDate())}}return compare}function getFirstWeekStartDate(janFourth){switch(janFourth.getDay()){case 0:return new Date(janFourth.getFullYear()-1,11,29);case 1:return janFourth;case 2:return new Date(janFourth.getFullYear(),0,3);case 3:return new Date(janFourth.getFullYear(),0,2);case 4:return new Date(janFourth.getFullYear(),0,1);case 5:return new Date(janFourth.getFullYear()-1,11,31);case 6:return new Date(janFourth.getFullYear()-1,11,30)}}function getWeekBasedYear(date){var thisDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);var janFourthThisYear=new Date(thisDate.getFullYear(),0,4);var janFourthNextYear=new Date(thisDate.getFullYear()+1,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);if(compareByDay(firstWeekStartThisYear,thisDate)<=0){if(compareByDay(firstWeekStartNextYear,thisDate)<=0){return thisDate.getFullYear()+1}else{return thisDate.getFullYear()}}else{return thisDate.getFullYear()-1}}var EXPANSION_RULES_2={"%a":(function(date){return WEEKDAYS[date.tm_wday].substring(0,3)}),"%A":(function(date){return WEEKDAYS[date.tm_wday]}),"%b":(function(date){return MONTHS[date.tm_mon].substring(0,3)}),"%B":(function(date){return MONTHS[date.tm_mon]}),"%C":(function(date){var year=date.tm_year+1900;return leadingNulls(year/100|0,2)}),"%d":(function(date){return leadingNulls(date.tm_mday,2)}),"%e":(function(date){return leadingSomething(date.tm_mday,2," ")}),"%g":(function(date){return getWeekBasedYear(date).toString().substring(2)}),"%G":(function(date){return getWeekBasedYear(date)}),"%H":(function(date){return leadingNulls(date.tm_hour,2)}),"%I":(function(date){var twelveHour=date.tm_hour;if(twelveHour==0)twelveHour=12;else if(twelveHour>12)twelveHour-=12;return leadingNulls(twelveHour,2)}),"%j":(function(date){return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900)?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,date.tm_mon-1),3)}),"%m":(function(date){return leadingNulls(date.tm_mon+1,2)}),"%M":(function(date){return leadingNulls(date.tm_min,2)}),"%n":(function(){return"\n"}),"%p":(function(date){if(date.tm_hour>=0&&date.tm_hour<12){return"AM"}else{return"PM"}}),"%S":(function(date){return leadingNulls(date.tm_sec,2)}),"%t":(function(){return"\t"}),"%u":(function(date){var day=new Date(date.tm_year+1900,date.tm_mon+1,date.tm_mday,0,0,0,0);return day.getDay()||7}),"%U":(function(date){var janFirst=new Date(date.tm_year+1900,0,1);var firstSunday=janFirst.getDay()===0?janFirst:__addDays(janFirst,7-janFirst.getDay());var endDate=new Date(date.tm_year+1900,date.tm_mon,date.tm_mday);if(compareByDay(firstSunday,endDate)<0){var februaryFirstUntilEndMonth=__arraySum(__isLeapYear(endDate.getFullYear())?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,endDate.getMonth()-1)-31;var firstSundayUntilEndJanuary=31-firstSunday.getDate();var days=firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();return leadingNulls(Math.ceil(days/7),2)}return compareByDay(firstSunday,janFirst)===0?"01":"00"}),"%V":(function(date){var janFourthThisYear=new Date(date.tm_year+1900,0,4);var janFourthNextYear=new Date(date.tm_year+1901,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);var endDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);if(compareByDay(endDate,firstWeekStartThisYear)<0){return"53"}if(compareByDay(firstWeekStartNextYear,endDate)<=0){return"01"}var daysDifference;if(firstWeekStartThisYear.getFullYear()<date.tm_year+1900){daysDifference=date.tm_yday+32-firstWeekStartThisYear.getDate()}else{daysDifference=date.tm_yday+1-firstWeekStartThisYear.getDate()}return leadingNulls(Math.ceil(daysDifference/7),2)}),"%w":(function(date){var day=new Date(date.tm_year+1900,date.tm_mon+1,date.tm_mday,0,0,0,0);return day.getDay()}),"%W":(function(date){var janFirst=new Date(date.tm_year,0,1);var firstMonday=janFirst.getDay()===1?janFirst:__addDays(janFirst,janFirst.getDay()===0?1:7-janFirst.getDay()+1);var endDate=new Date(date.tm_year+1900,date.tm_mon,date.tm_mday);if(compareByDay(firstMonday,endDate)<0){var februaryFirstUntilEndMonth=__arraySum(__isLeapYear(endDate.getFullYear())?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,endDate.getMonth()-1)-31;var firstMondayUntilEndJanuary=31-firstMonday.getDate();var days=firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();return leadingNulls(Math.ceil(days/7),2)}return compareByDay(firstMonday,janFirst)===0?"01":"00"}),"%y":(function(date){return(date.tm_year+1900).toString().substring(2)}),"%Y":(function(date){return date.tm_year+1900}),"%z":(function(date){var off=date.tm_gmtoff;var ahead=off>=0;off=Math.abs(off)/60;off=off/60*100+off%60;return(ahead?"+":"-")+String("0000"+off).slice(-4)}),"%Z":(function(date){return date.tm_zone}),"%%":(function(){return"%"})};for(var rule in EXPANSION_RULES_2){if(pattern.indexOf(rule)>=0){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_2[rule](date))}}var bytes=intArrayFromString(pattern,false);if(bytes.length>maxsize){return 0}writeArrayToMemory(bytes,s);return bytes.length-1}function _strftime_l(s,maxsize,format,tm){return _strftime(s,maxsize,format,tm)}function __emval_allocateDestructors(destructorsRef){var destructors=[];HEAP32[destructorsRef>>2]=__emval_register(destructors);return destructors}function requireHandle(handle){if(!handle){throwBindingError("Cannot use deleted val. handle = "+handle)}return emval_handle_array[handle].value}function __emval_call_void_method(caller,handle,methodName,args){caller=emval_methodCallers[caller];handle=requireHandle(handle);methodName=getStringOrSymbol(methodName);caller(handle,methodName,null,args)}function ___map_file(pathname,size){___setErrNo(ERRNO_CODES.EPERM);return-1}function __emval_run_destructors(handle){var destructors=emval_handle_array[handle].value;runDestructors(destructors);__emval_decref(handle)}function _emscripten_memcpy_big(dest,src,num){HEAPU8.set(HEAPU8.subarray(src,src+num),dest);return dest}Module["_memcpy"]=_memcpy;var _llvm_pow_f64=Math_pow;function __embind_finalize_value_array(rawTupleType){var reg=tupleRegistrations[rawTupleType];delete tupleRegistrations[rawTupleType];var elements=reg.elements;var elementsLength=elements.length;var elementTypes=elements.map((function(elt){return elt.getterReturnType})).concat(elements.map((function(elt){return elt.setterArgumentType})));var rawConstructor=reg.rawConstructor;var rawDestructor=reg.rawDestructor;whenDependentTypesAreResolved([rawTupleType],elementTypes,(function(elementTypes){elements.forEach((function(elt,i){var getterReturnType=elementTypes[i];var getter=elt.getter;var getterContext=elt.getterContext;var setterArgumentType=elementTypes[i+elementsLength];var setter=elt.setter;var setterContext=elt.setterContext;elt.read=(function(ptr){return getterReturnType["fromWireType"](getter(getterContext,ptr))});elt.write=(function(ptr,o){var destructors=[];setter(setterContext,ptr,setterArgumentType["toWireType"](destructors,o));runDestructors(destructors)})}));return[{name:reg.name,"fromWireType":(function(ptr){var rv=new Array(elementsLength);for(var i=0;i<elementsLength;++i){rv[i]=elements[i].read(ptr)}rawDestructor(ptr);return rv}),"toWireType":(function(destructors,o){if(elementsLength!==o.length){throw new TypeError("Incorrect number of tuple elements for "+reg.name+": expected="+elementsLength+", actual="+o.length)}var ptr=rawConstructor();for(var i=0;i<elementsLength;++i){elements[i].write(ptr,o[i])}if(destructors!==null){destructors.push(rawDestructor,ptr)}return ptr}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:rawDestructor}]}))}Module["_sbrk"]=_sbrk;Module["_memmove"]=_memmove;function ___gxx_personality_v0(){}var cttz_i8=allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0],"i8",ALLOC_STATIC);Module["_llvm_cttz_i32"]=_llvm_cttz_i32;Module["___udivmoddi4"]=___udivmoddi4;Module["___uremdi3"]=___uremdi3;function _pthread_cond_wait(){return 0}Module["_llvm_bswap_i32"]=_llvm_bswap_i32;function __embind_register_memory_view(rawType,dataTypeIndex,name){var typeMapping=[Int8Array,Uint8Array,Int16Array,Uint16Array,Int32Array,Uint32Array,Float32Array,Float64Array];var TA=typeMapping[dataTypeIndex];function decodeMemoryView(handle){handle=handle>>2;var heap=HEAPU32;var size=heap[handle];var data=heap[handle+1];return new TA(heap["buffer"],data,size)}name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":decodeMemoryView,"argPackAdvance":8,"readValueFromPointer":decodeMemoryView},{ignoreDuplicateRegistrations:true})}function validateThis(this_,classType,humanName){if(!(this_ instanceof Object)){throwBindingError(humanName+' with invalid "this": '+this_)}if(!(this_ instanceof classType.registeredClass.constructor)){throwBindingError(humanName+' incompatible with "this" of type '+this_.constructor.name)}if(!this_.$$.ptr){throwBindingError("cannot call emscripten binding method "+humanName+" on deleted object")}return upcastPointer(this_.$$.ptr,this_.$$.ptrType.registeredClass,classType.registeredClass)}function __embind_register_class_property(classType,fieldName,getterReturnType,getterSignature,getter,getterContext,setterArgumentType,setterSignature,setter,setterContext){fieldName=readLatin1String(fieldName);getter=requireFunction(getterSignature,getter);whenDependentTypesAreResolved([],[classType],(function(classType){classType=classType[0];var humanName=classType.name+"."+fieldName;var desc={get:(function(){throwUnboundTypeError("Cannot access "+humanName+" due to unbound types",[getterReturnType,setterArgumentType])}),enumerable:true,configurable:true};if(setter){desc.set=(function(){throwUnboundTypeError("Cannot access "+humanName+" due to unbound types",[getterReturnType,setterArgumentType])})}else{desc.set=(function(v){throwBindingError(humanName+" is a read-only property")})}Object.defineProperty(classType.registeredClass.instancePrototype,fieldName,desc);whenDependentTypesAreResolved([],setter?[getterReturnType,setterArgumentType]:[getterReturnType],(function(types){var getterReturnType=types[0];var desc={get:(function(){var ptr=validateThis(this,classType,humanName+" getter");return getterReturnType["fromWireType"](getter(getterContext,ptr))}),enumerable:true};if(setter){setter=requireFunction(setterSignature,setter);var setterArgumentType=types[1];desc.set=(function(v){var ptr=validateThis(this,classType,humanName+" setter");var destructors=[];setter(setterContext,ptr,setterArgumentType["toWireType"](destructors,v));runDestructors(destructors)})}Object.defineProperty(classType.registeredClass.instancePrototype,fieldName,desc);return[]}));return[]}))}function ___syscall40(which,varargs){SYSCALLS.varargs=varargs;try{var path=SYSCALLS.getStr();FS.rmdir(path);return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function __emval_incref(handle){if(handle>4){emval_handle_array[handle].refcount+=1}}function _pthread_mutexattr_settype(){}function __embind_register_value_object(rawType,name,constructorSignature,rawConstructor,destructorSignature,rawDestructor){structRegistrations[rawType]={name:readLatin1String(name),rawConstructor:requireFunction(constructorSignature,rawConstructor),rawDestructor:requireFunction(destructorSignature,rawDestructor),fields:[]}}function __embind_register_bool(rawType,name,size,trueValue,falseValue){var shift=getShiftFromSize(size);name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":(function(wt){return!!wt}),"toWireType":(function(destructors,o){return o?trueValue:falseValue}),"argPackAdvance":8,"readValueFromPointer":(function(pointer){var heap;if(size===1){heap=HEAP8}else if(size===2){heap=HEAP16}else if(size===4){heap=HEAP32}else{throw new TypeError("Unknown boolean type size: "+name)}return this["fromWireType"](heap[pointer>>shift])}),destructorFunction:null})}function __embind_register_void(rawType,name){name=readLatin1String(name);registerType(rawType,{isVoid:true,name:name,"argPackAdvance":0,"fromWireType":(function(){return undefined}),"toWireType":(function(destructors,o){return undefined})})}function __emval_new_array(){return __emval_register([])}Module["_bitshift64Shl"]=_bitshift64Shl;function _abort(){Module["abort"]()}function __emval_as(handle,returnType,destructorsRef){handle=requireHandle(handle);returnType=requireRegisteredType(returnType,"emval::as");var destructors=[];var rd=__emval_register(destructors);HEAP32[destructorsRef>>2]=rd;return returnType["toWireType"](destructors,handle)}function _pthread_mutex_destroy(){}function _pthread_once(ptr,func){if(!_pthread_once.seen)_pthread_once.seen={};if(ptr in _pthread_once.seen)return;Module["dynCall_v"](func);_pthread_once.seen[ptr]=1}Module["___divdi3"]=___divdi3;function __embind_register_value_object_field(structType,fieldName,getterReturnType,getterSignature,getter,getterContext,setterArgumentType,setterSignature,setter,setterContext){structRegistrations[structType].fields.push({fieldName:readLatin1String(fieldName),getterReturnType:getterReturnType,getter:requireFunction(getterSignature,getter),getterContext:getterContext,setterArgumentType:setterArgumentType,setter:requireFunction(setterSignature,setter),setterContext:setterContext})}function ClassHandle_isAliasOf(other){if(!(this instanceof ClassHandle)){return false}if(!(other instanceof ClassHandle)){return false}var leftClass=this.$$.ptrType.registeredClass;var left=this.$$.ptr;var rightClass=other.$$.ptrType.registeredClass;var right=other.$$.ptr;while(leftClass.baseClass){left=leftClass.upcast(left);leftClass=leftClass.baseClass}while(rightClass.baseClass){right=rightClass.upcast(right);rightClass=rightClass.baseClass}return leftClass===rightClass&&left===right}function shallowCopyInternalPointer(o){return{count:o.count,deleteScheduled:o.deleteScheduled,preservePointerOnDelete:o.preservePointerOnDelete,ptr:o.ptr,ptrType:o.ptrType,smartPtr:o.smartPtr,smartPtrType:o.smartPtrType}}function throwInstanceAlreadyDeleted(obj){function getInstanceTypeName(handle){return handle.$$.ptrType.registeredClass.name}throwBindingError(getInstanceTypeName(obj)+" instance already deleted")}function ClassHandle_clone(){if(!this.$$.ptr){throwInstanceAlreadyDeleted(this)}if(this.$$.preservePointerOnDelete){this.$$.count.value+=1;return this}else{var clone=Object.create(Object.getPrototypeOf(this),{$$:{value:shallowCopyInternalPointer(this.$$)}});clone.$$.count.value+=1;clone.$$.deleteScheduled=false;return clone}}function runDestructor(handle){var $$=handle.$$;if($$.smartPtr){$$.smartPtrType.rawDestructor($$.smartPtr)}else{$$.ptrType.registeredClass.rawDestructor($$.ptr)}}function ClassHandle_delete(){if(!this.$$.ptr){throwInstanceAlreadyDeleted(this)}if(this.$$.deleteScheduled&&!this.$$.preservePointerOnDelete){throwBindingError("Object already scheduled for deletion")}this.$$.count.value-=1;var toDelete=0===this.$$.count.value;if(toDelete){runDestructor(this)}if(!this.$$.preservePointerOnDelete){this.$$.smartPtr=undefined;this.$$.ptr=undefined}}function ClassHandle_isDeleted(){return!this.$$.ptr}function ClassHandle_deleteLater(){if(!this.$$.ptr){throwInstanceAlreadyDeleted(this)}if(this.$$.deleteScheduled&&!this.$$.preservePointerOnDelete){throwBindingError("Object already scheduled for deletion")}deletionQueue.push(this);if(deletionQueue.length===1&&delayFunction){delayFunction(flushPendingDeletes)}this.$$.deleteScheduled=true;return this}function init_ClassHandle(){ClassHandle.prototype["isAliasOf"]=ClassHandle_isAliasOf;ClassHandle.prototype["clone"]=ClassHandle_clone;ClassHandle.prototype["delete"]=ClassHandle_delete;ClassHandle.prototype["isDeleted"]=ClassHandle_isDeleted;ClassHandle.prototype["deleteLater"]=ClassHandle_deleteLater}function ClassHandle(){}function exposePublicSymbol(name,value,numArguments){if(Module.hasOwnProperty(name)){if(undefined===numArguments||undefined!==Module[name].overloadTable&&undefined!==Module[name].overloadTable[numArguments]){throwBindingError("Cannot register public name '"+name+"' twice")}ensureOverloadTable(Module,name,name);if(Module.hasOwnProperty(numArguments)){throwBindingError("Cannot register multiple overloads of a function with the same number of arguments ("+numArguments+")!")}Module[name].overloadTable[numArguments]=value}else{Module[name]=value;if(undefined!==numArguments){Module[name].numArguments=numArguments}}}function RegisteredClass(name,constructor,instancePrototype,rawDestructor,baseClass,getActualType,upcast,downcast){this.name=name;this.constructor=constructor;this.instancePrototype=instancePrototype;this.rawDestructor=rawDestructor;this.baseClass=baseClass;this.getActualType=getActualType;this.upcast=upcast;this.downcast=downcast;this.pureVirtualFunctions=[]}function replacePublicSymbol(name,value,numArguments){if(!Module.hasOwnProperty(name)){throwInternalError("Replacing nonexistant public symbol")}if(undefined!==Module[name].overloadTable&&undefined!==numArguments){Module[name].overloadTable[numArguments]=value}else{Module[name]=value;Module[name].argCount=numArguments}}function __embind_register_class(rawType,rawPointerType,rawConstPointerType,baseClassRawType,getActualTypeSignature,getActualType,upcastSignature,upcast,downcastSignature,downcast,name,destructorSignature,rawDestructor){name=readLatin1String(name);getActualType=requireFunction(getActualTypeSignature,getActualType);if(upcast){upcast=requireFunction(upcastSignature,upcast)}if(downcast){downcast=requireFunction(downcastSignature,downcast)}rawDestructor=requireFunction(destructorSignature,rawDestructor);var legalFunctionName=makeLegalFunctionName(name);exposePublicSymbol(legalFunctionName,(function(){throwUnboundTypeError("Cannot construct "+name+" due to unbound types",[baseClassRawType])}));whenDependentTypesAreResolved([rawType,rawPointerType,rawConstPointerType],baseClassRawType?[baseClassRawType]:[],(function(base){base=base[0];var baseClass;var basePrototype;if(baseClassRawType){baseClass=base.registeredClass;basePrototype=baseClass.instancePrototype}else{basePrototype=ClassHandle.prototype}var constructor=createNamedFunction(legalFunctionName,(function(){if(Object.getPrototypeOf(this)!==instancePrototype){throw new BindingError("Use 'new' to construct "+name)}if(undefined===registeredClass.constructor_body){throw new BindingError(name+" has no accessible constructor")}var body=registeredClass.constructor_body[arguments.length];if(undefined===body){throw new BindingError("Tried to invoke ctor of "+name+" with invalid number of parameters ("+arguments.length+") - expected ("+Object.keys(registeredClass.constructor_body).toString()+") parameters instead!")}return body.apply(this,arguments)}));var instancePrototype=Object.create(basePrototype,{constructor:{value:constructor}});constructor.prototype=instancePrototype;var registeredClass=new RegisteredClass(name,constructor,instancePrototype,rawDestructor,baseClass,getActualType,upcast,downcast);var referenceConverter=new RegisteredPointer(name,registeredClass,true,false,false);var pointerConverter=new RegisteredPointer(name+"*",registeredClass,false,false,false);var constPointerConverter=new RegisteredPointer(name+" const*",registeredClass,false,true,false);registeredPointers[rawType]={pointerType:pointerConverter,constPointerType:constPointerConverter};replacePublicSymbol(legalFunctionName,constructor);return[referenceConverter,pointerConverter,constPointerConverter]}))}function ___lock(){}function ___unlock(){}function _pthread_mutexattr_init(){}function _pthread_getspecific(key){return PTHREAD_SPECIFIC[key]||0}function _pthread_key_delete(key){if(key in PTHREAD_SPECIFIC){delete PTHREAD_SPECIFIC[key];return 0}return ERRNO_CODES.EINVAL}function __emval_get_property(handle,key){handle=requireHandle(handle);key=requireHandle(key);return __emval_register(handle[key])}function __exit(status){Module["exit"](status)}function _exit(status){__exit(status)}function _pthread_setspecific(key,value){if(!(key in PTHREAD_SPECIFIC)){return ERRNO_CODES.EINVAL}PTHREAD_SPECIFIC[key]=value;return 0}function __embind_register_value_array_element(rawTupleType,getterReturnType,getterSignature,getter,getterContext,setterArgumentType,setterSignature,setter,setterContext){tupleRegistrations[rawTupleType].elements.push({getterReturnType:getterReturnType,getter:requireFunction(getterSignature,getter),getterContext:getterContext,setterArgumentType:setterArgumentType,setter:requireFunction(setterSignature,setter),setterContext:setterContext})}function ___cxa_allocate_exception(size){return _malloc(size)}function ___cxa_pure_virtual(){ABORT=true;throw"Pure virtual function called!"}Module["_testSetjmp"]=_testSetjmp;function _longjmp(env,value){Module["setThrew"](env,value||1);throw"longjmp"}function floatReadValueFromPointer(name,shift){switch(shift){case 2:return(function(pointer){return this["fromWireType"](HEAPF32[pointer>>2])});case 3:return(function(pointer){return this["fromWireType"](HEAPF64[pointer>>3])});default:throw new TypeError("Unknown float type: "+name)}}function __embind_register_float(rawType,name,size){var shift=getShiftFromSize(size);name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":(function(value){return value}),"toWireType":(function(destructors,value){if(typeof value!=="number"&&typeof value!=="boolean"){throw new TypeError('Cannot convert "'+_embind_repr(value)+'" to '+this.name)}return value}),"argPackAdvance":8,"readValueFromPointer":floatReadValueFromPointer(name,shift),destructorFunction:null})}function ___syscall10(which,varargs){SYSCALLS.varargs=varargs;try{var path=SYSCALLS.getStr();FS.unlink(path);return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function _emscripten_get_now_is_monotonic(){return ENVIRONMENT_IS_NODE||typeof dateNow!=="undefined"||(ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER)&&self["performance"]&&self["performance"]["now"]}function _clock_gettime(clk_id,tp){var now;if(clk_id===0){now=Date.now()}else if(clk_id===1&&_emscripten_get_now_is_monotonic()){now=_emscripten_get_now()}else{___setErrNo(ERRNO_CODES.EINVAL);return-1}HEAP32[tp>>2]=now/1e3|0;HEAP32[tp+4>>2]=now%1e3*1e3*1e3|0;return 0}function ___clock_gettime(){return _clock_gettime.apply(null,arguments)}function __embind_register_function(name,argCount,rawArgTypesAddr,signature,rawInvoker,fn){var argTypes=heap32VectorToArray(argCount,rawArgTypesAddr);name=readLatin1String(name);rawInvoker=requireFunction(signature,rawInvoker);exposePublicSymbol(name,(function(){throwUnboundTypeError("Cannot call "+name+" due to unbound types",argTypes)}),argCount-1);whenDependentTypesAreResolved([],argTypes,(function(argTypes){var invokerArgsArray=[argTypes[0],null].concat(argTypes.slice(1));replacePublicSymbol(name,craftInvokerFunction(name,invokerArgsArray,null,rawInvoker,fn),argCount-1);return[]}))}function __embind_register_emval(rawType,name){name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":(function(handle){var rv=emval_handle_array[handle].value;__emval_decref(handle);return rv}),"toWireType":(function(destructors,value){return __emval_register(value)}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:null})}function __embind_register_constant(name,type,value){name=readLatin1String(name);whenDependentTypesAreResolved([],[type],(function(type){type=type[0];Module[name]=type["fromWireType"](value);return[]}))}function ___cxa_begin_catch(ptr){var info=EXCEPTIONS.infos[ptr];if(info&&!info.caught){info.caught=true;__ZSt18uncaught_exceptionv.uncaught_exception--}if(info)info.rethrown=false;EXCEPTIONS.caught.push(ptr);EXCEPTIONS.addRef(EXCEPTIONS.deAdjust(ptr));return ptr}function ___syscall3(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),buf=SYSCALLS.get(),count=SYSCALLS.get();return FS.read(stream,HEAP8,buf,count)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall5(which,varargs){SYSCALLS.varargs=varargs;try{var pathname=SYSCALLS.getStr(),flags=SYSCALLS.get(),mode=SYSCALLS.get();var stream=FS.open(pathname,flags,mode);return stream.fd}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall4(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),buf=SYSCALLS.get(),count=SYSCALLS.get();return FS.write(stream,HEAP8,buf,count)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall6(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD();FS.close(stream);return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}Module["___udivdi3"]=___udivdi3;Module["___muldsi3"]=___muldsi3;Module["___muldi3"]=___muldi3;function __embind_register_class_constructor(rawClassType,argCount,rawArgTypesAddr,invokerSignature,invoker,rawConstructor){var rawArgTypes=heap32VectorToArray(argCount,rawArgTypesAddr);invoker=requireFunction(invokerSignature,invoker);whenDependentTypesAreResolved([],[rawClassType],(function(classType){classType=classType[0];var humanName="constructor "+classType.name;if(undefined===classType.registeredClass.constructor_body){classType.registeredClass.constructor_body=[]}if(undefined!==classType.registeredClass.constructor_body[argCount-1]){throw new BindingError("Cannot register multiple constructors with identical number of parameters ("+(argCount-1)+") for class '"+classType.name+"'! Overload resolution is currently only performed using the parameter count, not actual type info!")}classType.registeredClass.constructor_body[argCount-1]=function unboundTypeHandler(){throwUnboundTypeError("Cannot construct "+classType.name+" due to unbound types",rawArgTypes)};whenDependentTypesAreResolved([],rawArgTypes,(function(argTypes){classType.registeredClass.constructor_body[argCount-1]=function constructor_body(){if(arguments.length!==argCount-1){throwBindingError(humanName+" called with "+arguments.length+" arguments, expected "+(argCount-1))}var destructors=[];var args=new Array(argCount);args[0]=rawConstructor;for(var i=1;i<argCount;++i){args[i]=argTypes[i]["toWireType"](destructors,arguments[i-1])}var ptr=invoker.apply(null,args);runDestructors(destructors);return argTypes[0]["fromWireType"](ptr)};return[]}));return[]}))}function ___syscall140(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),offset_high=SYSCALLS.get(),offset_low=SYSCALLS.get(),result=SYSCALLS.get(),whence=SYSCALLS.get();var offset=offset_low;FS.llseek(stream,offset,whence);HEAP32[result>>2]=stream.position;if(stream.getdents&&offset===0&&whence===0)stream.getdents=null;return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function __embind_register_class_function(rawClassType,methodName,argCount,rawArgTypesAddr,invokerSignature,rawInvoker,context,isPureVirtual){var rawArgTypes=heap32VectorToArray(argCount,rawArgTypesAddr);methodName=readLatin1String(methodName);rawInvoker=requireFunction(invokerSignature,rawInvoker);whenDependentTypesAreResolved([],[rawClassType],(function(classType){classType=classType[0];var humanName=classType.name+"."+methodName;if(isPureVirtual){classType.registeredClass.pureVirtualFunctions.push(methodName)}function unboundTypesHandler(){throwUnboundTypeError("Cannot call "+humanName+" due to unbound types",rawArgTypes)}var proto=classType.registeredClass.instancePrototype;var method=proto[methodName];if(undefined===method||undefined===method.overloadTable&&method.className!==classType.name&&method.argCount===argCount-2){unboundTypesHandler.argCount=argCount-2;unboundTypesHandler.className=classType.name;proto[methodName]=unboundTypesHandler}else{ensureOverloadTable(proto,methodName,humanName);proto[methodName].overloadTable[argCount-2]=unboundTypesHandler}whenDependentTypesAreResolved([],rawArgTypes,(function(argTypes){var memberFunction=craftInvokerFunction(humanName,argTypes,classType,rawInvoker,context);if(undefined===proto[methodName].overloadTable){memberFunction.argCount=argCount-2;proto[methodName]=memberFunction}else{proto[methodName].overloadTable[argCount-2]=memberFunction}return[]}));return[]}))}function ___syscall146(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),iov=SYSCALLS.get(),iovcnt=SYSCALLS.get();return SYSCALLS.doWritev(stream,iov,iovcnt)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall221(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),cmd=SYSCALLS.get();switch(cmd){case 0:{var arg=SYSCALLS.get();if(arg<0){return-ERRNO_CODES.EINVAL}var newStream;newStream=FS.open(stream.path,stream.flags,0,arg);return newStream.fd};case 1:case 2:return 0;case 3:return stream.flags;case 4:{var arg=SYSCALLS.get();stream.flags|=arg;return 0};case 12:case 12:{var arg=SYSCALLS.get();var offset=0;HEAP16[arg+offset>>1]=2;return 0};case 13:case 14:case 13:case 14:return 0;case 16:case 8:return-ERRNO_CODES.EINVAL;case 9:___setErrNo(ERRNO_CODES.EINVAL);return-1;default:{return-ERRNO_CODES.EINVAL}}}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall145(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),iov=SYSCALLS.get(),iovcnt=SYSCALLS.get();return SYSCALLS.doReadv(stream,iov,iovcnt)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}var ___dso_handle=STATICTOP;STATICTOP+=16;embind_init_charCodes();init_emval();BindingError=Module["BindingError"]=extendError(Error,"BindingError");InternalError=Module["InternalError"]=extendError(Error,"InternalError");FS.staticInit();__ATINIT__.unshift((function(){if(!Module["noFSInit"]&&!FS.init.initialized)FS.init()}));__ATMAIN__.push((function(){FS.ignorePermissions=false}));__ATEXIT__.push((function(){FS.quit()}));Module["FS_createFolder"]=FS.createFolder;Module["FS_createPath"]=FS.createPath;Module["FS_createDataFile"]=FS.createDataFile;Module["FS_createPreloadedFile"]=FS.createPreloadedFile;Module["FS_createLazyFile"]=FS.createLazyFile;Module["FS_createLink"]=FS.createLink;Module["FS_createDevice"]=FS.createDevice;Module["FS_unlink"]=FS.unlink;__ATINIT__.unshift((function(){TTY.init()}));__ATEXIT__.push((function(){TTY.shutdown()}));if(ENVIRONMENT_IS_NODE){var fs=require("fs");var NODEJS_PATH=require("path");NODEFS.staticInit()}Module["requestFullScreen"]=function Module_requestFullScreen(lockPointer,resizeCanvas,vrDevice){Module.printErr("Module.requestFullScreen is deprecated. Please call Module.requestFullscreen instead.");Module["requestFullScreen"]=Module["requestFullscreen"];Browser.requestFullScreen(lockPointer,resizeCanvas,vrDevice)};Module["requestFullscreen"]=function Module_requestFullscreen(lockPointer,resizeCanvas,vrDevice){Browser.requestFullscreen(lockPointer,resizeCanvas,vrDevice)};Module["requestAnimationFrame"]=function Module_requestAnimationFrame(func){Browser.requestAnimationFrame(func)};Module["setCanvasSize"]=function Module_setCanvasSize(width,height,noUpdates){Browser.setCanvasSize(width,height,noUpdates)};Module["pauseMainLoop"]=function Module_pauseMainLoop(){Browser.mainLoop.pause()};Module["resumeMainLoop"]=function Module_resumeMainLoop(){Browser.mainLoop.resume()};Module["getUserMedia"]=function Module_getUserMedia(){Browser.getUserMedia()};Module["createContext"]=function Module_createContext(canvas,useWebGL,setInModule,webGLContextAttributes){return Browser.createContext(canvas,useWebGL,setInModule,webGLContextAttributes)};if(ENVIRONMENT_IS_NODE){_emscripten_get_now=function _emscripten_get_now_actual(){var t=process["hrtime"]();return t[0]*1e3+t[1]/1e6}}else if(typeof dateNow!=="undefined"){_emscripten_get_now=dateNow}else if(typeof self==="object"&&self["performance"]&&typeof self["performance"]["now"]==="function"){_emscripten_get_now=(function(){return self["performance"]["now"]()})}else if(typeof performance==="object"&&typeof performance["now"]==="function"){_emscripten_get_now=(function(){return performance["now"]()})}else{_emscripten_get_now=Date.now}init_RegisteredPointer();init_embind();UnboundTypeError=Module["UnboundTypeError"]=extendError(Error,"UnboundTypeError");___buildEnvironment(ENV);init_ClassHandle();DYNAMICTOP_PTR=allocate(1,"i32",ALLOC_STATIC);STACK_BASE=STACKTOP=Runtime.alignMemory(STATICTOP);STACK_MAX=STACK_BASE+TOTAL_STACK;DYNAMIC_BASE=Runtime.alignMemory(STACK_MAX);HEAP32[DYNAMICTOP_PTR>>2]=DYNAMIC_BASE;staticSealed=true;function invoke_iiiiiid(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiiiid"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddd(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiddd"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidiii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiidiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidiid(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiidiid"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiii(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiidddiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddi(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiddi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddddi(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiddddi"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidiii(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viidiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiiiiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidddd(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiidddd"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iidi(index,a1,a2,a3){try{return Module["dynCall_iidi"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddidd(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiddidd"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vidi(index,a1,a2,a3){try{Module["dynCall_vidi"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddii(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiddii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddid(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiddid"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidi(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiidi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddidddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiddidddd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiddiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiiiidd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiddiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiiiidi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiddii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidii(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiidii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidd(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiidd"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_di(index,a1){try{return Module["dynCall_di"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiiidiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiidiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiddiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiddiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vdii(index,a1,a2,a3){try{Module["dynCall_vdii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_diiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_dii(index,a1,a2){try{return Module["dynCall_dii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiddiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiddiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiidiidd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){try{Module["dynCall_viiiiiiiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiii(index,a1,a2,a3,a4){try{return Module["dynCall_iiiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiidiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidddi(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiidddi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiidiidd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiid(index,a1,a2,a3,a4){try{return Module["dynCall_iiiid"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddiii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiddiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiiiididiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){try{return Module["dynCall_iiiiiiiididiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiidddiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidiiid(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viidiiid"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiidiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidiiii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viidiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiiddi(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_diiiddi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiididii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiididii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_diiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidiiid(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiidiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiddddii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiidiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{return Module["dynCall_iiidiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiddddii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiidiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiiidi"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiidddii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidd(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiidd"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidi(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiidi"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiidiiii(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_iiidiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddiddd(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiddiddd"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiddi(index,a1,a2,a3,a4,a5){try{return Module["dynCall_diiddi"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diii(index,a1,a2,a3){try{return Module["dynCall_diii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddd(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiddd"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddidddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiddidddd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){try{Module["dynCall_viiiiiiiiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddidd(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiddidd"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiidiiiidi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiddiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddi(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiddi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiii(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiid(index,a1,a2,a3,a4){try{Module["dynCall_viiid"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidddd(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiidddd"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidii(index,a1,a2,a3,a4,a5){try{Module["dynCall_viidii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiid(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiiiid"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidddi(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiidddi"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiii(index,a1,a2,a3,a4){try{Module["dynCall_viiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiii(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viidiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vid(index,a1,a2){try{Module["dynCall_vid"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiidi(index,a1,a2,a3,a4){try{return Module["dynCall_iiidi"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiidd(index,a1,a2,a3,a4){try{return Module["dynCall_iiidd"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vii(index,a1,a2){try{Module["dynCall_vii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiid(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiiid"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiddddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidd(index,a1,a2,a3,a4){try{Module["dynCall_viidd"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidi(index,a1,a2,a3,a4){try{Module["dynCall_viidi"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiidiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiid(index,a1,a2,a3,a4){try{return Module["dynCall_diiid"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidddii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiidddii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiidddiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiii(index,a1,a2,a3,a4){try{return Module["dynCall_diiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiidiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiidii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddiddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiddiddd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iid(index,a1,a2){try{return Module["dynCall_iid"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddid(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiddid"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viididdi(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viididdi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iii(index,a1,a2){try{return Module["dynCall_iii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddi(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiddi"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiididi(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiididi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vdiii(index,a1,a2,a3,a4){try{Module["dynCall_vdiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiidii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiiidii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiidddiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viii(index,a1,a2,a3){try{Module["dynCall_viii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_v(index){try{Module["dynCall_v"](index)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viid(index,a1,a2,a3){try{Module["dynCall_viid"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viidiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiidiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vi(index,a1){try{Module["dynCall_vi"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiidiiiidi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_ii(index,a1){try{return Module["dynCall_ii"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vididdi(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_vididdi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiiidd"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vidii(index,a1,a2,a3,a4){try{Module["dynCall_vidii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidi(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiidi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiddiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viidiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiii(index,a1,a2,a3){try{return Module["dynCall_iiii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viididii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viididii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiddii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiid(index,a1,a2,a3){try{return Module["dynCall_iiid"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiidii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiiii(index,a1,a2,a3,a4,a5){try{return Module["dynCall_diiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiiid(index,a1,a2,a3,a4,a5){try{return Module["dynCall_diiiid"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){try{return Module["dynCall_iiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14){try{return Module["dynCall_iiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiidiii(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiidiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiidiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{return Module["dynCall_iiidiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_i(index){try{return Module["dynCall_i"](index)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiidii(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiidii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiiiii(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_diiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_iiidiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vididdii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_vididdii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){try{Module["dynCall_viiiiiidiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viididi(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viididi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viididdii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viididdii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiidiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidd(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiidd"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vidiii(index,a1,a2,a3,a4,a5){try{Module["dynCall_vidiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}Module.asmGlobalArg={"Math":Math,"Int8Array":Int8Array,"Int16Array":Int16Array,"Int32Array":Int32Array,"Uint8Array":Uint8Array,"Uint16Array":Uint16Array,"Uint32Array":Uint32Array,"Float32Array":Float32Array,"Float64Array":Float64Array,"NaN":NaN,"Infinity":Infinity,"byteLength":byteLength};Module.asmLibraryArg={"abort":abort,"assert":assert,"enlargeMemory":enlargeMemory,"getTotalMemory":getTotalMemory,"abortOnCannotGrowMemory":abortOnCannotGrowMemory,"invoke_iiiiiid":invoke_iiiiiid,"invoke_viiiiddd":invoke_viiiiddd,"invoke_viiiidiii":invoke_viiiidiii,"invoke_viiiiiddi":invoke_viiiiiddi,"invoke_viiidiii":invoke_viiidiii,"invoke_viiiidiid":invoke_viiiidiid,"invoke_iiiiiii":invoke_iiiiiii,"invoke_viiiidddiiii":invoke_viiiidddiiii,"invoke_viiiiddi":invoke_viiiiddi,"invoke_viiiddddi":invoke_viiiddddi,"invoke_viidiii":invoke_viidiii,"invoke_viiiiiiiiiii":invoke_viiiiiiiiiii,"invoke_viiiiiiiiiid":invoke_viiiiiiiiiid,"invoke_viiidddd":invoke_viiidddd,"invoke_iidi":invoke_iidi,"invoke_viiddidd":invoke_viiddidd,"invoke_vidi":invoke_vidi,"invoke_viiddii":invoke_viiddii,"invoke_viiddid":invoke_viiddid,"invoke_viiiiidi":invoke_viiiiidi,"invoke_viiddidddd":invoke_viiddidddd,"invoke_viiiiddiiii":invoke_viiiiddiiii,"invoke_viiiiiiidd":invoke_viiiiiiidd,"invoke_viiiiddiiid":invoke_viiiiddiiid,"invoke_viiiiiiidi":invoke_viiiiiiidi,"invoke_viiiddii":invoke_viiiddii,"invoke_viiidii":invoke_viiidii,"invoke_viiiiidd":invoke_viiiiidd,"invoke_di":invoke_di,"invoke_viiiiiidiiii":invoke_viiiiiidiiii,"invoke_viiiidiiddi":invoke_viiiidiiddi,"invoke_viiiiddiiiid":invoke_viiiiddiiiid,"invoke_viiiiddiii":invoke_viiiiddiii,"invoke_vdii":invoke_vdii,"invoke_diiiiiii":invoke_diiiiiii,"invoke_dii":invoke_dii,"invoke_viiiddiiii":invoke_viiiddiiii,"invoke_viiiddiiid":invoke_viiiddiiid,"invoke_viiiidiidd":invoke_viiiidiidd,"invoke_viiiiiiiiiiddi":invoke_viiiiiiiiiiddi,"invoke_iiiii":invoke_iiiii,"invoke_viiiiidiiiii":invoke_viiiiidiiiii,"invoke_viiidddi":invoke_viiidddi,"invoke_viiiiidiidd":invoke_viiiiidiidd,"invoke_iiiid":invoke_iiiid,"invoke_iiiiiiii":invoke_iiiiiiii,"invoke_viiddiii":invoke_viiddiii,"invoke_iiiiiiiididiii":invoke_iiiiiiiididiii,"invoke_viiidddiii":invoke_viiidddiii,"invoke_viidiiid":invoke_viidiiid,"invoke_viiiidiiii":invoke_viiiidiiii,"invoke_viidiiii":invoke_viidiiii,"invoke_diiiddi":invoke_diiiddi,"invoke_viiididii":invoke_viiididii,"invoke_diiiiiiii":invoke_diiiiiiii,"invoke_viiidiiid":invoke_viiidiiid,"invoke_viiiddddii":invoke_viiiddddii,"invoke_iiidiiiiiii":invoke_iiidiiiiiii,"invoke_viiiiid":invoke_viiiiid,"invoke_viiiiddddii":invoke_viiiiddddii,"invoke_viiiiii":invoke_viiiiii,"invoke_viiidiiii":invoke_viiidiiii,"invoke_viiiiiidi":invoke_viiiiiidi,"invoke_viiiiiidiii":invoke_viiiiiidiii,"invoke_viiiidddii":invoke_viiiidddii,"invoke_viiidd":invoke_viiidd,"invoke_viiidi":invoke_viiidi,"invoke_iiidiiii":invoke_iiidiiii,"invoke_viiddiddd":invoke_viiddiddd,"invoke_viiiiiiiiii":invoke_viiiiiiiiii,"invoke_diiddi":invoke_diiddi,"invoke_diii":invoke_diii,"invoke_viiiddd":invoke_viiiddd,"invoke_viiiddidddd":invoke_viiiddidddd,"invoke_viiiiiiiiiiid":invoke_viiiiiiiiiiid,"invoke_viiiddidd":invoke_viiiddidd,"invoke_viiidiiiidi":invoke_viiidiiiidi,"invoke_viiiddiiiid":invoke_viiiddiiiid,"invoke_viiiddi":invoke_viiiddi,"invoke_iiiiii":invoke_iiiiii,"invoke_viiid":invoke_viiid,"invoke_viiiidddd":invoke_viiiidddd,"invoke_viidii":invoke_viidii,"invoke_iiiiid":invoke_iiiiid,"invoke_viiiidddi":invoke_viiiidddi,"invoke_viiii":invoke_viiii,"invoke_viiiii":invoke_viiiii,"invoke_viidiiiiiii":invoke_viidiiiiiii,"invoke_vid":invoke_vid,"invoke_iiidi":invoke_iiidi,"invoke_iiidd":invoke_iiidd,"invoke_vii":invoke_vii,"invoke_viiiid":invoke_viiiid,"invoke_viiiiddddi":invoke_viiiiddddi,"invoke_viidd":invoke_viidd,"invoke_viidi":invoke_viidi,"invoke_viiidiiddi":invoke_viiidiiddi,"invoke_diiid":invoke_diiid,"invoke_viiidddii":invoke_viiidddii,"invoke_viiiiiiii":invoke_viiiiiiii,"invoke_viiidddiiii":invoke_viiidddiiii,"invoke_viiiiiiid":invoke_viiiiiiid,"invoke_diiii":invoke_diiii,"invoke_viiiiidiiddi":invoke_viiiiidiiddi,"invoke_viiiiidii":invoke_viiiiidii,"invoke_viiiddiddd":invoke_viiiddiddd,"invoke_iid":invoke_iid,"invoke_viiiddid":invoke_viiiddid,"invoke_viiiiiii":invoke_viiiiiii,"invoke_viididdi":invoke_viididdi,"invoke_viiiiiid":invoke_viiiiiid,"invoke_viiiiiiiii":invoke_viiiiiiiii,"invoke_iii":invoke_iii,"invoke_viiddi":invoke_viiddi,"invoke_viiididi":invoke_viiididi,"invoke_vdiii":invoke_vdiii,"invoke_viiiiiidii":invoke_viiiiiidii,"invoke_viiiidddiii":invoke_viiiidddiii,"invoke_viii":invoke_viii,"invoke_v":invoke_v,"invoke_viid":invoke_viid,"invoke_viidiiiii":invoke_viidiiiii,"invoke_viiiiidiiii":invoke_viiiiidiiii,"invoke_vi":invoke_vi,"invoke_viiiidiiiidi":invoke_viiiidiiiidi,"invoke_ii":invoke_ii,"invoke_viiiiiiiddi":invoke_viiiiiiiddi,"invoke_vididdi":invoke_vididdi,"invoke_viiiiiidd":invoke_viiiiiidd,"invoke_vidii":invoke_vidii,"invoke_viiiidi":invoke_viiiidi,"invoke_viiiddiii":invoke_viiiddiii,"invoke_viidiiiiii":invoke_viidiiiiii,"invoke_iiii":invoke_iiii,"invoke_viididii":invoke_viididii,"invoke_viiiiddii":invoke_viiiiddii,"invoke_iiid":invoke_iiid,"invoke_viiiidii":invoke_viiiidii,"invoke_diiiii":invoke_diiiii,"invoke_diiiid":invoke_diiiid,"invoke_iiiiiiiiiiiii":invoke_iiiiiiiiiiiii,"invoke_iiiiiiiiiiiiiii":invoke_iiiiiiiiiiiiiii,"invoke_viiiiiiddi":invoke_viiiiiiddi,"invoke_iiidiii":invoke_iiidiii,"invoke_iiidiiiiii":invoke_iiidiiiiii,"invoke_i":invoke_i,"invoke_iiidii":invoke_iiidii,"invoke_diiiiii":invoke_diiiiii,"invoke_iiidiiiii":invoke_iiidiiiii,"invoke_vididdii":invoke_vididdii,"invoke_viiiiiidiiiii":invoke_viiiiiidiiiii,"invoke_viiiiidiii":invoke_viiiiidiii,"invoke_viididi":invoke_viididi,"invoke_iiiiiiiii":invoke_iiiiiiiii,"invoke_viididdii":invoke_viididdii,"invoke_viiiiidiid":invoke_viiiiidiid,"invoke_viiiidd":invoke_viiiidd,"invoke_vidiii":invoke_vidiii,"___syscall221":___syscall221,"floatReadValueFromPointer":floatReadValueFromPointer,"simpleReadValueFromPointer":simpleReadValueFromPointer,"__emval_call_void_method":__emval_call_void_method,"throwInternalError":throwInternalError,"get_first_emval":get_first_emval,"whenDependentTypesAreResolved":whenDependentTypesAreResolved,"constNoSmartPtrRawPointerToWireType":constNoSmartPtrRawPointerToWireType,"getLiveInheritedInstances":getLiveInheritedInstances,"__ZSt18uncaught_exceptionv":__ZSt18uncaught_exceptionv,"ClassHandle":ClassHandle,"_longjmp":_longjmp,"getShiftFromSize":getShiftFromSize,"__emval_get_property":__emval_get_property,"__addDays":__addDays,"_emscripten_set_main_loop_timing":_emscripten_set_main_loop_timing,"_pthread_key_delete":_pthread_key_delete,"___cxa_begin_catch":___cxa_begin_catch,"_emscripten_memcpy_big":_emscripten_memcpy_big,"runDestructor":runDestructor,"throwInstanceAlreadyDeleted":throwInstanceAlreadyDeleted,"__embind_register_std_string":__embind_register_std_string,"init_RegisteredPointer":init_RegisteredPointer,"RegisteredPointer_destructor":RegisteredPointer_destructor,"getStringOrSymbol":getStringOrSymbol,"flushPendingDeletes":flushPendingDeletes,"_pthread_mutexattr_settype":_pthread_mutexattr_settype,"makeClassHandle":makeClassHandle,"__isLeapYear":__isLeapYear,"__embind_register_class_constructor":__embind_register_class_constructor,"___cxa_atexit":___cxa_atexit,"__embind_finalize_value_array":__embind_finalize_value_array,"__emval_allocateDestructors":__emval_allocateDestructors,"init_ClassHandle":init_ClassHandle,"__embind_register_constant":__embind_register_constant,"___syscall140":___syscall140,"ClassHandle_clone":ClassHandle_clone,"___syscall145":___syscall145,"___syscall146":___syscall146,"_emscripten_get_now_is_monotonic":_emscripten_get_now_is_monotonic,"throwBindingError":throwBindingError,"__emval_incref":__emval_incref,"___cxa_find_matching_catch":___cxa_find_matching_catch,"__embind_register_value_object_field":__embind_register_value_object_field,"embind_init_charCodes":embind_init_charCodes,"__emval_as":__emval_as,"___setErrNo":___setErrNo,"readLatin1String":readLatin1String,"__embind_register_bool":__embind_register_bool,"___resumeException":___resumeException,"createNamedFunction":createNamedFunction,"__embind_register_class_property":__embind_register_class_property,"__embind_register_emval":__embind_register_emval,"___buildEnvironment":___buildEnvironment,"__embind_finalize_value_object":__embind_finalize_value_object,"__emval_decref":__emval_decref,"_pthread_once":_pthread_once,"__embind_register_class":__embind_register_class,"___syscall91":___syscall91,"__emval_addMethodCaller":__emval_addMethodCaller,"heap32VectorToArray":heap32VectorToArray,"__emval_lookupTypes":__emval_lookupTypes,"_emscripten_get_now":_emscripten_get_now,"___syscall10":___syscall10,"__emval_run_destructors":__emval_run_destructors,"ClassHandle_delete":ClassHandle_delete,"___syscall3":___syscall3,"_clock_gettime":_clock_gettime,"___syscall6":___syscall6,"___syscall5":___syscall5,"ensureOverloadTable":ensureOverloadTable,"new_":new_,"downcastPointer":downcastPointer,"_exit":_exit,"replacePublicSymbol":replacePublicSymbol,"init_embind":init_embind,"_llvm_pow_f64":_llvm_pow_f64,"ClassHandle_deleteLater":ClassHandle_deleteLater,"___syscall54":___syscall54,"RegisteredPointer_deleteObject":RegisteredPointer_deleteObject,"ClassHandle_isDeleted":ClassHandle_isDeleted,"__embind_register_integer":__embind_register_integer,"___cxa_allocate_exception":___cxa_allocate_exception,"__emval_take_value":__emval_take_value,"__embind_register_value_object":__embind_register_value_object,"getTypeName":getTypeName,"___clock_gettime":___clock_gettime,"_strftime":_strftime,"__embind_register_class_function":__embind_register_class_function,"throwUnboundTypeError":throwUnboundTypeError,"craftInvokerFunction":craftInvokerFunction,"_getenv":_getenv,"runDestructors":runDestructors,"requireRegisteredType":requireRegisteredType,"makeLegalFunctionName":makeLegalFunctionName,"_pthread_key_create":_pthread_key_create,"upcastPointer":upcastPointer,"init_emval":init_emval,"shallowCopyInternalPointer":shallowCopyInternalPointer,"nonConstNoSmartPtrRawPointerToWireType":nonConstNoSmartPtrRawPointerToWireType,"__embind_register_value_array":__embind_register_value_array,"_abort":_abort,"requireHandle":requireHandle,"_embind_repr":_embind_repr,"validateThis":validateThis,"exposePublicSymbol":exposePublicSymbol,"RegisteredPointer_fromWireType":RegisteredPointer_fromWireType,"___cxa_pure_virtual":___cxa_pure_virtual,"__emval_get_method_caller":__emval_get_method_caller,"_pthread_getspecific":_pthread_getspecific,"_pthread_cond_wait":_pthread_cond_wait,"___lock":___lock,"RegisteredClass":RegisteredClass,"__embind_register_memory_view":__embind_register_memory_view,"getInheritedInstance":getInheritedInstance,"___syscall40":___syscall40,"setDelayFunction":setDelayFunction,"___gxx_personality_v0":___gxx_personality_v0,"extendError":extendError,"___syscall4":___syscall4,"__embind_register_value_array_element":__embind_register_value_array_element,"__emval_new_array":__emval_new_array,"__embind_register_void":__embind_register_void,"__embind_register_smart_ptr":__embind_register_smart_ptr,"__embind_register_function":__embind_register_function,"_pthread_mutexattr_destroy":_pthread_mutexattr_destroy,"_strftime_l":_strftime_l,"RegisteredPointer_getPointee":RegisteredPointer_getPointee,"__emval_register":__emval_register,"__embind_register_std_wstring":__embind_register_std_wstring,"ClassHandle_isAliasOf":ClassHandle_isAliasOf,"__exit":__exit,"RegisteredPointer":RegisteredPointer,"__arraySum":__arraySum,"__embind_register_class_class_function":__embind_register_class_class_function,"_pthread_mutex_destroy":_pthread_mutex_destroy,"getBasestPointer":getBasestPointer,"getInheritedInstanceCount":getInheritedInstanceCount,"__embind_register_float":__embind_register_float,"integerReadValueFromPointer":integerReadValueFromPointer,"___unlock":___unlock,"_emscripten_set_main_loop":_emscripten_set_main_loop,"_pthread_mutexattr_init":_pthread_mutexattr_init,"_pthread_setspecific":_pthread_setspecific,"genericPointerToWireType":genericPointerToWireType,"registerType":registerType,"___cxa_throw":___cxa_throw,"__emval_new_cstring":__emval_new_cstring,"count_emval_handles":count_emval_handles,"requireFunction":requireFunction,"_atexit":_atexit,"_pthread_mutex_init":_pthread_mutex_init,"___map_file":___map_file,"DYNAMICTOP_PTR":DYNAMICTOP_PTR,"tempDoublePtr":tempDoublePtr,"ABORT":ABORT,"STACKTOP":STACKTOP,"STACK_MAX":STACK_MAX,"cttz_i8":cttz_i8,"___dso_handle":___dso_handle};// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer) {
"almost asm";var a=global.Int8Array;var b=new a(buffer);var c=global.Int16Array;var d=new c(buffer);var e=global.Int32Array;var f=new e(buffer);var g=global.Uint8Array;var h=new g(buffer);var i=global.Uint16Array;var j=new i(buffer);var k=global.Uint32Array;var l=new k(buffer);var m=global.Float32Array;var n=new m(buffer);var o=global.Float64Array;var p=new o(buffer);var q=global.byteLength;var r=env.DYNAMICTOP_PTR|0;var s=env.tempDoublePtr|0;var t=env.ABORT|0;var u=env.STACKTOP|0;var v=env.STACK_MAX|0;var w=env.cttz_i8|0;var x=env.___dso_handle|0;var y=0;var z=0;var A=0;var B=0;var C=global.NaN,D=global.Infinity;var E=0,F=0,G=0,H=0,I=0.0;var J=0;var K=global.Math.floor;var L=global.Math.abs;var M=global.Math.sqrt;var N=global.Math.pow;var O=global.Math.cos;var P=global.Math.sin;var Q=global.Math.tan;var R=global.Math.acos;var S=global.Math.asin;var T=global.Math.atan;var U=global.Math.atan2;var V=global.Math.exp;var W=global.Math.log;var X=global.Math.ceil;var Y=global.Math.imul;var Z=global.Math.min;var _=global.Math.max;var $=global.Math.clz32;var aa=env.abort;var ba=env.assert;var ca=env.enlargeMemory;var da=env.getTotalMemory;var ea=env.abortOnCannotGrowMemory;var fa=env.invoke_iiiiiid;var ga=env.invoke_viiiiddd;var ha=env.invoke_viiiidiii;var ia=env.invoke_viiiiiddi;var ja=env.invoke_viiidiii;var ka=env.invoke_viiiidiid;var la=env.invoke_iiiiiii;var ma=env.invoke_viiiidddiiii;var na=env.invoke_viiiiddi;var oa=env.invoke_viiiddddi;var pa=env.invoke_viidiii;var qa=env.invoke_viiiiiiiiiii;var ra=env.invoke_viiiiiiiiiid;var sa=env.invoke_viiidddd;var ta=env.invoke_iidi;var ua=env.invoke_viiddidd;var va=env.invoke_vidi;var wa=env.invoke_viiddii;var xa=env.invoke_viiddid;var ya=env.invoke_viiiiidi;var za=env.invoke_viiddidddd;var Aa=env.invoke_viiiiddiiii;var Ba=env.invoke_viiiiiiidd;var Ca=env.invoke_viiiiddiiid;var Da=env.invoke_viiiiiiidi;var Ea=env.invoke_viiiddii;var Fa=env.invoke_viiidii;var Ga=env.invoke_viiiiidd;var Ha=env.invoke_di;var Ia=env.invoke_viiiiiidiiii;var Ja=env.invoke_viiiidiiddi;var Ka=env.invoke_viiiiddiiiid;var La=env.invoke_viiiiddiii;var Ma=env.invoke_vdii;var Na=env.invoke_diiiiiii;var Oa=env.invoke_dii;var Pa=env.invoke_viiiddiiii;var Qa=env.invoke_viiiddiiid;var Ra=env.invoke_viiiidiidd;var Sa=env.invoke_viiiiiiiiiiddi;var Ta=env.invoke_iiiii;var Ua=env.invoke_viiiiidiiiii;var Va=env.invoke_viiidddi;var Wa=env.invoke_viiiiidiidd;var Xa=env.invoke_iiiid;var Ya=env.invoke_iiiiiiii;var Za=env.invoke_viiddiii;var _a=env.invoke_iiiiiiiididiii;var $a=env.invoke_viiidddiii;var ab=env.invoke_viidiiid;var bb=env.invoke_viiiidiiii;var cb=env.invoke_viidiiii;var db=env.invoke_diiiddi;var eb=env.invoke_viiididii;var fb=env.invoke_diiiiiiii;var gb=env.invoke_viiidiiid;var hb=env.invoke_viiiddddii;var ib=env.invoke_iiidiiiiiii;var jb=env.invoke_viiiiid;var kb=env.invoke_viiiiddddii;var lb=env.invoke_viiiiii;var mb=env.invoke_viiidiiii;var nb=env.invoke_viiiiiidi;var ob=env.invoke_viiiiiidiii;var pb=env.invoke_viiiidddii;var qb=env.invoke_viiidd;var rb=env.invoke_viiidi;var sb=env.invoke_iiidiiii;var tb=env.invoke_viiddiddd;var ub=env.invoke_viiiiiiiiii;var vb=env.invoke_diiddi;var wb=env.invoke_diii;var xb=env.invoke_viiiddd;var yb=env.invoke_viiiddidddd;var zb=env.invoke_viiiiiiiiiiid;var Ab=env.invoke_viiiddidd;var Bb=env.invoke_viiidiiiidi;var Cb=env.invoke_viiiddiiiid;var Db=env.invoke_viiiddi;var Eb=env.invoke_iiiiii;var Fb=env.invoke_viiid;var Gb=env.invoke_viiiidddd;var Hb=env.invoke_viidii;var Ib=env.invoke_iiiiid;var Jb=env.invoke_viiiidddi;var Kb=env.invoke_viiii;var Lb=env.invoke_viiiii;var Mb=env.invoke_viidiiiiiii;var Nb=env.invoke_vid;var Ob=env.invoke_iiidi;var Pb=env.invoke_iiidd;var Qb=env.invoke_vii;var Rb=env.invoke_viiiid;var Sb=env.invoke_viiiiddddi;var Tb=env.invoke_viidd;var Ub=env.invoke_viidi;var Vb=env.invoke_viiidiiddi;var Wb=env.invoke_diiid;var Xb=env.invoke_viiidddii;var Yb=env.invoke_viiiiiiii;var Zb=env.invoke_viiidddiiii;var _b=env.invoke_viiiiiiid;var $b=env.invoke_diiii;var ac=env.invoke_viiiiidiiddi;var bc=env.invoke_viiiiidii;var cc=env.invoke_viiiddiddd;var dc=env.invoke_iid;var ec=env.invoke_viiiddid;var fc=env.invoke_viiiiiii;var gc=env.invoke_viididdi;var hc=env.invoke_viiiiiid;var ic=env.invoke_viiiiiiiii;var jc=env.invoke_iii;var kc=env.invoke_viiddi;var lc=env.invoke_viiididi;var mc=env.invoke_vdiii;var nc=env.invoke_viiiiiidii;var oc=env.invoke_viiiidddiii;var pc=env.invoke_viii;var qc=env.invoke_v;var rc=env.invoke_viid;var sc=env.invoke_viidiiiii;var tc=env.invoke_viiiiidiiii;var uc=env.invoke_vi;var vc=env.invoke_viiiidiiiidi;var wc=env.invoke_ii;var xc=env.invoke_viiiiiiiddi;var yc=env.invoke_vididdi;var zc=env.invoke_viiiiiidd;var Ac=env.invoke_vidii;var Bc=env.invoke_viiiidi;var Cc=env.invoke_viiiddiii;var Dc=env.invoke_viidiiiiii;var Ec=env.invoke_iiii;var Fc=env.invoke_viididii;var Gc=env.invoke_viiiiddii;var Hc=env.invoke_iiid;var Ic=env.invoke_viiiidii;var Jc=env.invoke_diiiii;var Kc=env.invoke_diiiid;var Lc=env.invoke_iiiiiiiiiiiii;var Mc=env.invoke_iiiiiiiiiiiiiii;var Nc=env.invoke_viiiiiiddi;var Oc=env.invoke_iiidiii;var Pc=env.invoke_iiidiiiiii;var Qc=env.invoke_i;var Rc=env.invoke_iiidii;var Sc=env.invoke_diiiiii;var Tc=env.invoke_iiidiiiii;var Uc=env.invoke_vididdii;var Vc=env.invoke_viiiiiidiiiii;var Wc=env.invoke_viiiiidiii;var Xc=env.invoke_viididi;var Yc=env.invoke_iiiiiiiii;var Zc=env.invoke_viididdii;var _c=env.invoke_viiiiidiid;var $c=env.invoke_viiiidd;var ad=env.invoke_vidiii;var bd=env.___syscall221;var cd=env.floatReadValueFromPointer;var dd=env.simpleReadValueFromPointer;var ed=env.__emval_call_void_method;var fd=env.throwInternalError;var gd=env.get_first_emval;var hd=env.whenDependentTypesAreResolved;var id=env.constNoSmartPtrRawPointerToWireType;var jd=env.getLiveInheritedInstances;var kd=env.__ZSt18uncaught_exceptionv;var ld=env.ClassHandle;var md=env._longjmp;var nd=env.getShiftFromSize;var od=env.__emval_get_property;var pd=env.__addDays;var qd=env._emscripten_set_main_loop_timing;var rd=env._pthread_key_delete;var sd=env.___cxa_begin_catch;var td=env._emscripten_memcpy_big;var ud=env.runDestructor;var vd=env.throwInstanceAlreadyDeleted;var wd=env.__embind_register_std_string;var xd=env.init_RegisteredPointer;var yd=env.RegisteredPointer_destructor;var zd=env.getStringOrSymbol;var Ad=env.flushPendingDeletes;var Bd=env._pthread_mutexattr_settype;var Cd=env.makeClassHandle;var Dd=env.__isLeapYear;var Ed=env.__embind_register_class_constructor;var Fd=env.___cxa_atexit;var Gd=env.__embind_finalize_value_array;var Hd=env.__emval_allocateDestructors;var Id=env.init_ClassHandle;var Jd=env.__embind_register_constant;var Kd=env.___syscall140;var Ld=env.ClassHandle_clone;var Md=env.___syscall145;var Nd=env.___syscall146;var Od=env._emscripten_get_now_is_monotonic;var Pd=env.throwBindingError;var Qd=env.__emval_incref;var Rd=env.___cxa_find_matching_catch;var Sd=env.__embind_register_value_object_field;var Td=env.embind_init_charCodes;var Ud=env.__emval_as;var Vd=env.___setErrNo;var Wd=env.readLatin1String;var Xd=env.__embind_register_bool;var Yd=env.___resumeException;var Zd=env.createNamedFunction;var _d=env.__embind_register_class_property;var $d=env.__embind_register_emval;var ae=env.___buildEnvironment;var be=env.__embind_finalize_value_object;var ce=env.__emval_decref;var de=env._pthread_once;var ee=env.__embind_register_class;var fe=env.___syscall91;var ge=env.__emval_addMethodCaller;var he=env.heap32VectorToArray;var ie=env.__emval_lookupTypes;var je=env._emscripten_get_now;var ke=env.___syscall10;var le=env.__emval_run_destructors;var me=env.ClassHandle_delete;var ne=env.___syscall3;var oe=env._clock_gettime;var pe=env.___syscall6;var qe=env.___syscall5;var re=env.ensureOverloadTable;var se=env.new_;var te=env.downcastPointer;var ue=env._exit;var ve=env.replacePublicSymbol;var we=env.init_embind;var xe=env._llvm_pow_f64;var ye=env.ClassHandle_deleteLater;var ze=env.___syscall54;var Ae=env.RegisteredPointer_deleteObject;var Be=env.ClassHandle_isDeleted;var Ce=env.__embind_register_integer;var De=env.___cxa_allocate_exception;var Ee=env.__emval_take_value;var Fe=env.__embind_register_value_object;var Ge=env.getTypeName;var He=env.___clock_gettime;var Ie=env._strftime;var Je=env.__embind_register_class_function;var Ke=env.throwUnboundTypeError;var Le=env.craftInvokerFunction;var Me=env._getenv;var Ne=env.runDestructors;var Oe=env.requireRegisteredType;var Pe=env.makeLegalFunctionName;var Qe=env._pthread_key_create;var Re=env.upcastPointer;var Se=env.init_emval;var Te=env.shallowCopyInternalPointer;var Ue=env.nonConstNoSmartPtrRawPointerToWireType;var Ve=env.__embind_register_value_array;var We=env._abort;var Xe=env.requireHandle;var Ye=env._embind_repr;var Ze=env.validateThis;var _e=env.exposePublicSymbol;var $e=env.RegisteredPointer_fromWireType;var af=env.___cxa_pure_virtual;var bf=env.__emval_get_method_caller;var cf=env._pthread_getspecific;var df=env._pthread_cond_wait;var ef=env.___lock;var ff=env.RegisteredClass;var gf=env.__embind_register_memory_view;var hf=env.getInheritedInstance;var jf=env.___syscall40;var kf=env.setDelayFunction;var lf=env.___gxx_personality_v0;var mf=env.extendError;var nf=env.___syscall4;var of=env.__embind_register_value_array_element;var pf=env.__emval_new_array;var qf=env.__embind_register_void;var rf=env.__embind_register_smart_ptr;var sf=env.__embind_register_function;var tf=env._pthread_mutexattr_destroy;var uf=env._strftime_l;var vf=env.RegisteredPointer_getPointee;var wf=env.__emval_register;var xf=env.__embind_register_std_wstring;var yf=env.ClassHandle_isAliasOf;var zf=env.__exit;var Af=env.RegisteredPointer;var Bf=env.__arraySum;var Cf=env.__embind_register_class_class_function;var Df=env._pthread_mutex_destroy;var Ef=env.getBasestPointer;var Ff=env.getInheritedInstanceCount;var Gf=env.__embind_register_float;var Hf=env.integerReadValueFromPointer;var If=env.___unlock;var Jf=env._emscripten_set_main_loop;var Kf=env._pthread_mutexattr_init;var Lf=env._pthread_setspecific;var Mf=env.genericPointerToWireType;var Nf=env.registerType;var Of=env.___cxa_throw;var Pf=env.__emval_new_cstring;var Qf=env.count_emval_handles;var Rf=env.requireFunction;var Sf=env._atexit;var Tf=env._pthread_mutex_init;var Uf=env.___map_file;var Vf=0.0;function Wf(newBuffer){if(q(newBuffer)&16777215||q(newBuffer)<=16777215||q(newBuffer)>2147483648)return false;b=new a(newBuffer);d=new c(newBuffer);f=new e(newBuffer);h=new g(newBuffer);j=new i(newBuffer);l=new k(newBuffer);n=new m(newBuffer);p=new o(newBuffer);buffer=newBuffer;return true}
// EMSCRIPTEN_START_FUNCS
function Ti(a){a=a|0;var b=0;b=u;u=u+a|0;u=u+15&-16;return b|0}function Ui(){return u|0}function Vi(a){a=a|0;u=a}function Wi(a,b){a=a|0;b=b|0;u=a;v=b}function Xi(a,b){a=a|0;b=b|0;if(!y){y=a;z=b}}function Yi(a){a=a|0;J=a}function Zi(){return J|0}function _i(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=NYa(56)|0;$i(f,a,b,c,d,e);return f|0}function $i(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=u;u=u+16|0;j=i;f[a>>2]=e&4095|1124007936;f[a+4>>2]=2;k=a+8|0;f[k>>2]=c;l=a+12|0;f[l>>2]=d;f[a+16>>2]=g;m=a+20|0;f[m>>2]=g;n=a+24|0;o=a+28|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[a+40>>2]=k;p=a+48|0;q=a+44|0;f[q>>2]=p;f[a+52>>2]=0;f[p>>2]=0;if((Y(d,c)|0)!=0&(g|0)==0){f[j>>2]=0;f[j+4>>2]=0;r=c$(j,26)|0;s=358223;t=r+26|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-215,j,358250,358254,500);d$(j);v=f[l>>2]|0}else v=d;d=e&7;l=(e>>>3&511)+1<<(47696>>>(d<<1)&3);e=Y(v,l)|0;if(!h){w=e;x=16384;y=f[a>>2]|0;z=y|x;f[a>>2]=z;A=f[q>>2]|0;f[A>>2]=w;B=A+4|0;f[B>>2]=l;C=f[m>>2]|0;D=f[k>>2]|0;E=Y(D,w)|0;F=C+E|0;f[o>>2]=F;G=0-w|0;H=F+G|0;I=H+e|0;f[n>>2]=I;u=i;return}v=(f[k>>2]|0)==1?e:h;if((v>>>0)%((1212424721>>>(d<<2)&15)>>>0)|0|0){f[j>>2]=0;f[j+4>>2]=0;r=c$(j,31)|0;s=172705;t=r+31|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-13,j,358250,358254,516);d$(j)}w=v;x=(v|0)==(e|0)?16384:0;y=f[a>>2]|0;z=y|x;f[a>>2]=z;A=f[q>>2]|0;f[A>>2]=w;B=A+4|0;f[B>>2]=l;C=f[m>>2]|0;D=f[k>>2]|0;E=Y(D,w)|0;F=C+E|0;f[o>>2]=F;G=0-w|0;H=F+G|0;I=H+e|0;f[n>>2]=I;u=i;return}function aj(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0;g=u;u=u+16|0;h=g;i=h+8|0;f[i>>2]=0;f[i+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;WJ(a,h,c,d,e);u=g;return}function bj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=e+8|0;f[g>>2]=0;f[g+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;WJ(a,e,c,1.0,0.0);u=d;return}function cj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=g+8|0;f[h>>2]=0;f[h+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;WJ(a,g,c,d,0.0);u=e;return}function dj(a,b){a=a|0;b=b|0;var c=0;c=f[b+40>>2]|0;b=f[c>>2]|0;f[a>>2]=f[c+4>>2];f[a+4>>2]=b;return}function ej(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+224|0;g=e;XQ(g,b,c,d);f[a>>2]=1124007936;d=a+8|0;c=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[c>>2]=d;d=a+48|0;f[a+44>>2]=d;f[d>>2]=0;f[a+52>>2]=0;d=f[g>>2]|0;Ah[f[(f[d>>2]|0)+12>>2]&255](d,g,a,-1);fj(g);u=e;return}function fj(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+120|0;c=a+156|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+136|0;b=a+124|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+160>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+164>>2]|0;if((b|0)!=(a+168|0))ZF(b);b=a+64|0;d=a+100|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+80|0;b=a+68|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+104>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+108>>2]|0;if((b|0)!=(a+112|0))ZF(b);b=a+8|0;c=a+44|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+24|0;b=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+48>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+52>>2]|0;if((b|0)==(a+56|0))return;ZF(b);return}function gj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+240|0;e=d;g=d+224|0;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];ZQ(e,g,c);f[a>>2]=1124007936;c=a+8|0;g=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[g>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;c=f[e>>2]|0;Ah[f[(f[c>>2]|0)+12>>2]&255](c,e,a,-1);fj(e);u=d;return}function hj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+224|0;g=e;_Q(g,b,c,d);f[a>>2]=1124007936;d=a+8|0;c=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[c>>2]=d;d=a+48|0;f[a+44>>2]=d;f[d>>2]=0;f[a+52>>2]=0;d=f[g>>2]|0;Ah[f[(f[d>>2]|0)+12>>2]&255](d,g,a,-1);fj(g);u=e;return}function ij(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+240|0;e=d;g=d+224|0;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];$Q(e,g,c);f[a>>2]=1124007936;c=a+8|0;g=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[g>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;c=f[e>>2]|0;Ah[f[(f[c>>2]|0)+12>>2]&255](c,e,a,-1);fj(e);u=d;return}function jj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;e=+YO(a,d);u=c;return +e}function kj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+240|0;g=e;h=e+224|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;WQ(g,b,h,d);f[a>>2]=1124007936;h=a+8|0;b=a+40|0;c=a+4|0;i=c+36|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(i|0));f[b>>2]=h;h=a+48|0;f[a+44>>2]=h;f[h>>2]=0;f[a+52>>2]=0;h=f[g>>2]|0;Ah[f[(f[h>>2]|0)+12>>2]&255](h,g,a,-1);fj(g);u=e;return}function lj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+224|0;d=c;UQ(d,b);f[a>>2]=1124007936;b=a+8|0;e=a+40|0;g=a+4|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=b;b=a+48|0;f[a+44>>2]=b;f[b>>2]=0;f[a+52>>2]=0;b=f[d>>2]|0;Ah[f[(f[b>>2]|0)+12>>2]&255](b,d,a,-1);fj(d);u=c;return}function mj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+224|0;e=d;VQ(e,b,c);f[a>>2]=1124007936;c=a+8|0;b=a+40|0;g=a+4|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[b>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;c=f[e>>2]|0;Ah[f[(f[c>>2]|0)+12>>2]&255](c,e,a,-1);fj(e);u=d;return}function nj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[d>>2]=33619968;f[d+4>>2]=b;eL(a,d);u=c;return}function oj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=e+8|0;f[h>>2]=0;f[h+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;fL(a,e,g);u=d;return}function pj(a,b,c){a=a|0;b=b|0;c=c|0;HR(a,b,c);return}function qj(a,b){a=a|0;b=b|0;HR(a,b,0);return}function rj(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d>>2]=-1056833530;f[d+4>>2]=b;f[d+8>>2]=1;f[d+12>>2]=4;hL(a,d,fT()|0)|0;u=c;return}function sj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e>>2]=-1056833530;f[e+4>>2]=b;f[e+8>>2]=1;f[e+12>>2]=4;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;hL(a,e,g)|0;u=d;return}function tj(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;dU(b,d);b=pf()|0;f[a>>2]=b;xs(b,135330,d);xs(b,135330,d+8|0);xs(b,135330,d+16|0);xs(b,135330,d+24|0);u=c;return}function uj(a,b){a=a|0;b=b|0;eU(a,b);return}function vj(a,b){a=a|0;b=b|0;fU(a,b);return}function wj(a){a=a|0;return a&7|0}function xj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=a+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;yZ(e,a,a+8|0,a+16|0,a+24|0,g);u=d;return}function yj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;yZ(d,a,a+8|0,a+16|0,a+24|0,fT()|0);u=c;return}function zj(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;n[a>>2]=0.0;n[a+4>>2]=0.0;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;kna(d,a,a+8|0);u=c;return}function Aj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+64|0;g=e;h=e+32|0;i=e+16|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];f[g+8>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];_ua(h,i,c,g);g=pf()|0;f[a>>2]=g;ys(g,135330,h);zs(g,135330,c);u=e;return}function Bj(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g;i=g+16|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];e=Zua(i,d,h)|0;i=pf()|0;f[a>>2]=i;if((b[374936]|0)==0?u1a(374936)|0:0){c=bf(2,21768)|0;f[225239]=c}c=f[225239]|0;f[h>>2]=e;ed(c|0,i|0,135330,h|0);zs(f[a>>2]|0,135330,d);u=g;return}function Cj(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=f[c+4>>2]|0;e=f[c+8>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(e>>>0>4294967279)WYa(a);if(e>>>0<11){b[a+11>>0]=e;if(!e){g=a;h=g+e|0;b[h>>0]=0;return}else i=a}else{c=e+16&-16;j=NYa(c)|0;f[a>>2]=j;f[a+8>>2]=c|-2147483648;f[a+4>>2]=e;i=j}K1a(i|0,d|0,e|0)|0;g=i;h=g+e|0;b[h>>0]=0;return}function Dj(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=a+4|0;d$(d);a=c+11|0;e=b[a>>0]|0;g=e<<24>>24<0?f[c+4>>2]|0:e&255;if(!g)return;e=c$(d,g)|0;K1a(e|0,((b[a>>0]|0)<0?f[c>>2]|0:c)|0,g|0)|0;return}function Ej(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=b;f[a>>2]=43428;b=f[c+4>>2]|0;f[a+4>>2]=b;f[a+8>>2]=f[c+8>>2];if(b|0){d=b+-4|0;f[d>>2]=(f[d>>2]|0)+1}f[a+12>>2]=f[c+12>>2];d=f[c+16>>2]|0;f[a+16>>2]=d;f[a+20>>2]=f[c+20>>2];if(d|0){b=d+-4|0;f[b>>2]=(f[b>>2]|0)+1}b=f[c+24>>2]|0;f[a+24>>2]=b;f[a+28>>2]=f[c+28>>2];if(b|0){d=b+-4|0;f[d>>2]=(f[d>>2]|0)+1}d=f[c+32>>2]|0;f[a+32>>2]=d;f[a+36>>2]=f[c+36>>2];if(!d){e=a+40|0;g=c+40|0;h=f[g>>2]|0;f[e>>2]=h;return}b=d+-4|0;f[b>>2]=(f[b>>2]|0)+1;e=a+40|0;g=c+40|0;h=f[g>>2]|0;f[e>>2]=h;return}function Fj(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=Q$()|0;d=f[c>>2]|0;e=f[c+4>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(e>>>0>4294967279)WYa(a);if(e>>>0<11){b[a+11>>0]=e;if(!e){g=a;h=g+e|0;b[h>>0]=0;return}else i=a}else{c=e+16&-16;j=NYa(c)|0;f[a>>2]=j;f[a+8>>2]=c|-2147483648;f[a+4>>2]=e;i=j}K1a(i|0,d|0,e|0)|0;g=i;h=g+e|0;b[h>>0]=0;return}function Gj(a){a=a|0;var b=0;Hj(135335);Ij(135345);Jj(135357);Kj(135370);Lj(135382);Mj(135392);Nj(135407);Oj(135428);Pj(135439);Qj(135452);ee(9072,9496,9512,0,151218,119,151221,0,151221,0,358250,151223,882);Ed(9072,1,22456,151218,120,1);Ed(9072,2,22460,151237,63,121);Ed(9072,3,22468,151260,43,64);Ed(9072,4,22480,151265,10,44);Ed(9072,5,22496,153384,50,11);Ed(9072,6,22516,153391,68,51);Cf(9072,135471,4,22540,151265,12,53);Cf(9072,135471,3,22556,151260,45,41);Cf(9072,135475,4,22540,151265,12,54);Cf(9072,135475,3,22556,151260,45,42);Cf(9072,135480,4,22540,151265,12,55);Cf(9072,135480,3,22556,151260,45,43);a=NYa(4)|0;f[a>>2]=8;b=NYa(4)|0;f[b>>2]=8;_d(9072,185118,21648,151237,65,a|0,21648,151226,44,b|0);b=NYa(4)|0;f[b>>2]=12;a=NYa(4)|0;f[a>>2]=12;_d(9072,185123,21648,151237,65,b|0,21648,151226,44,a|0);a=NYa(4)|0;f[a>>2]=256;_d(9072,135486,8736,151237,66,a|0,0,0,0,0);a=NYa(4)|0;f[a>>2]=257;_d(9072,135494,8736,151237,66,a|0,0,0,0,0);a=NYa(4)|0;f[a>>2]=258;_d(9072,183826,8736,151237,66,a|0,0,0,0,0);a=NYa(4)|0;f[a>>2]=259;_d(9072,135499,8736,151237,66,a|0,0,0,0,0);a=NYa(4)|0;f[a>>2]=260;_d(9072,135506,8736,151237,66,a|0,0,0,0,0);a=NYa(4)|0;f[a>>2]=261;_d(9072,135514,8736,151237,66,a|0,0,0,0,0);a=NYa(4)|0;f[a>>2]=262;_d(9072,135522,8736,151237,66,a|0,0,0,0,0);a=NYa(4)|0;f[a>>2]=263;_d(9072,135530,8736,151237,66,a|0,0,0,0,0);a=NYa(4)|0;f[a>>2]=264;_d(9072,135538,8736,151237,66,a|0,0,0,0,0);a=NYa(8)|0;f[a>>2]=122;f[a+4>>2]=0;Je(9072,135546,2,22568,151237,67,a|0,0);a=NYa(8)|0;f[a>>2]=123;f[a+4>>2]=0;Je(9072,135555,2,22568,151237,67,a|0,0);a=NYa(8)|0;f[a>>2]=124;f[a+4>>2]=0;Je(9072,135565,2,22576,151237,68,a|0,0);a=NYa(4)|0;f[a>>2]=1;Je(9072,159530,6,22584,153616,1,a|0,0);a=NYa(4)|0;f[a>>2]=45;Je(9072,159530,4,22608,151231,56,a|0,0);a=NYa(4)|0;f[a>>2]=2;Je(9072,159530,5,22624,153624,3,a|0,0);a=NYa(8)|0;f[a>>2]=125;f[a+4>>2]=0;Je(9072,175976,2,22568,151237,67,a|0,0);a=NYa(8)|0;f[a>>2]=46;f[a+4>>2]=0;Je(9072,135574,3,22644,151260,46,a|0,0);a=NYa(8)|0;f[a>>2]=57;f[a+4>>2]=0;Je(9072,357830,5,22656,153631,71,a|0,0);a=NYa(8)|0;f[a>>2]=47;f[a+4>>2]=0;Je(9072,357830,4,22676,151231,58,a|0,0);a=NYa(8)|0;f[a>>2]=59;f[a+4>>2]=0;Je(9072,135578,4,22692,151265,13,a|0,0);a=NYa(8)|0;f[a>>2]=48;f[a+4>>2]=0;Je(9072,135578,3,22708,151260,47,a|0,0);a=NYa(4)|0;f[a>>2]=265;Je(9072,201110,3,22720,151226,49,a|0,0);a=NYa(4)|0;f[a>>2]=50;Je(9072,201110,4,22732,151231,60,a|0,0);a=NYa(8)|0;f[a>>2]=126;f[a+4>>2]=0;Je(9072,312091,2,22576,151237,68,a|0,0);a=NYa(8)|0;f[a>>2]=127;f[a+4>>2]=0;Je(9072,175982,2,22748,151237,69,a|0,0);a=NYa(8)|0;f[a>>2]=61;f[a+4>>2]=0;Je(9072,135587,4,22692,151265,13,a|0,0);a=NYa(8)|0;f[a>>2]=51;f[a+4>>2]=0;Je(9072,135587,3,22708,151260,47,a|0,0);a=NYa(8)|0;f[a>>2]=70;f[a+4>>2]=0;Je(9072,135596,3,22756,151260,48,a|0,0);a=NYa(8)|0;f[a>>2]=266;f[a+4>>2]=0;Je(9072,135602,2,22768,151237,71,a|0,0);a=NYa(8)|0;f[a>>2]=128;f[a+4>>2]=0;Je(9072,135608,2,22576,151237,68,a|0,0);a=NYa(8)|0;f[a>>2]=52;f[a+4>>2]=0;Je(9072,135614,3,22644,151260,46,a|0,0);a=NYa(4)|0;f[a>>2]=3;Je(9072,169270,3,22776,153650,8,a|0,0);a=NYa(4)|0;f[a>>2]=3;Je(9072,135618,4,22788,151609,1,a|0,0);a=NYa(4)|0;f[a>>2]=53;Je(9072,135622,3,22804,151260,49,a|0,0);a=NYa(4)|0;f[a>>2]=267;Je(9072,135626,2,22816,151237,72,a|0,0);a=NYa(8)|0;f[a>>2]=54;f[a+4>>2]=0;Je(9072,185267,3,22824,151260,50,a|0,0);a=NYa(4)|0;f[a>>2]=55;Je(9072,172948,3,22804,151260,49,a|0,0);a=NYa(4)|0;f[a>>2]=268;Je(9072,172948,2,22816,151237,72,a|0,0);a=NYa(8)|0;f[a>>2]=129;f[a+4>>2]=0;Je(9072,176010,2,22748,151237,69,a|0,0);a=NYa(4)|0;f[a>>2]=269;Je(9072,176170,3,22836,151226,56,a|0,0);a=NYa(4)|0;f[a>>2]=57;Je(9072,176170,4,22848,151231,62,a|0,0);a=NYa(4)|0;f[a>>2]=270;Je(9072,338897,2,22864,151237,73,a|0,0);a=NYa(4)|0;f[a>>2]=58;Je(9072,135628,3,22872,151260,51,a|0,0);a=NYa(4)|0;f[a>>2]=63;Je(9072,135628,4,22884,151265,14,a|0,0);a=NYa(4)|0;f[a>>2]=58;Je(9072,135632,3,22872,151260,51,a|0,0);a=NYa(4)|0;f[a>>2]=63;Je(9072,135632,4,22884,151265,14,a|0,0);a=NYa(4)|0;f[a>>2]=59;Je(9072,135641,3,22872,151260,51,a|0,0);a=NYa(4)|0;f[a>>2]=64;Je(9072,135641,4,22884,151265,14,a|0,0);a=NYa(4)|0;f[a>>2]=60;Je(9072,135649,3,22872,151260,51,a|0,0);a=NYa(4)|0;f[a>>2]=65;Je(9072,135649,4,22884,151265,14,a|0,0);a=NYa(4)|0;f[a>>2]=61;Je(9072,135658,3,22872,151260,51,a|0,0);a=NYa(4)|0;f[a>>2]=66;Je(9072,135658,4,22884,151265,14,a|0,0);a=NYa(4)|0;f[a>>2]=62;Je(9072,135668,3,22872,151260,51,a|0,0);a=NYa(4)|0;f[a>>2]=67;Je(9072,135668,4,22884,151265,14,a|0,0);a=NYa(4)|0;f[a>>2]=63;Je(9072,135675,3,22872,151260,51,a|0,0);a=NYa(4)|0;f[a>>2]=68;Je(9072,135675,4,22884,151265,14,a|0,0);a=NYa(4)|0;f[a>>2]=64;Je(9072,135684,3,22872,151260,51,a|0,0);a=NYa(4)|0;f[a>>2]=69;Je(9072,135684,4,22884,151265,14,a|0,0);a=NYa(8)|0;f[a>>2]=74;f[a+4>>2]=0;Je(9072,135694,3,22900,151260,52,a|0,0);a=NYa(8)|0;f[a>>2]=53;f[a+4>>2]=0;Je(9072,135694,4,22912,151265,15,a|0,0);a=NYa(8)|0;f[a>>2]=16;f[a+4>>2]=0;Je(9072,135694,5,22928,153384,52,a|0,0);a=NYa(8)|0;f[a>>2]=75;f[a+4>>2]=0;Je(9072,135701,3,22948,151260,54,a|0,0);a=NYa(8)|0;f[a>>2]=55;f[a+4>>2]=0;Je(9072,135701,4,22960,151265,17,a|0,0);a=NYa(8)|0;f[a>>2]=18;f[a+4>>2]=0;Je(9072,135701,5,22976,153384,53,a|0,0);a=NYa(8)|0;f[a>>2]=76;f[a+4>>2]=0;Je(9072,135709,3,22996,151260,56,a|0,0);a=NYa(8)|0;f[a>>2]=57;f[a+4>>2]=0;Je(9072,135709,4,23008,151265,19,a|0,0);a=NYa(8)|0;f[a>>2]=20;f[a+4>>2]=0;Je(9072,135709,5,23024,153384,54,a|0,0);a=NYa(8)|0;f[a>>2]=77;f[a+4>>2]=0;Je(9072,135717,3,23044,151260,58,a|0,0);a=NYa(8)|0;f[a>>2]=59;f[a+4>>2]=0;Je(9072,135717,4,23056,151265,21,a|0,0);a=NYa(8)|0;f[a>>2]=22;f[a+4>>2]=0;Je(9072,135717,5,23072,153384,55,a|0,0);a=NYa(8)|0;f[a>>2]=78;f[a+4>>2]=0;Je(9072,135726,3,23092,151260,60,a|0,0);a=NYa(8)|0;f[a>>2]=61;f[a+4>>2]=0;Je(9072,135726,4,23104,151265,23,a|0,0);a=NYa(8)|0;f[a>>2]=24;f[a+4>>2]=0;Je(9072,135726,5,23120,153384,56,a|0,0);a=NYa(8)|0;f[a>>2]=79;f[a+4>>2]=0;Je(9072,135732,3,23140,153655,9,a|0,0);a=NYa(8)|0;f[a>>2]=62;f[a+4>>2]=0;Je(9072,135732,4,23152,153660,1,a|0,0);a=NYa(8)|0;f[a>>2]=25;f[a+4>>2]=0;Je(9072,135732,5,23168,153666,1,a|0,0);a=NYa(8)|0;f[a>>2]=26;f[a+4>>2]=0;Je(9072,135740,5,23188,153673,2,a|0,0);a=NYa(8)|0;f[a>>2]=80;f[a+4>>2]=0;Je(9072,135740,3,23208,153650,10,a|0,0);a=NYa(8)|0;f[a>>2]=63;f[a+4>>2]=0;Je(9072,135740,4,23220,153680,2,a|0,0);Fe(9632,135749,183816,2,151223,883);a=NYa(4)|0;f[a>>2]=0;b=NYa(4)|0;f[b>>2]=0;Sd(9632,225832,21648,151237,81,a|0,21648,151226,65,b|0);b=NYa(4)|0;f[b>>2]=4;a=NYa(4)|0;f[a>>2]=4;Sd(9632,135755,21648,151237,81,b|0,21648,151226,65,a|0);be(9632);Fe(9640,135759,183816,3,151223,884);a=NYa(4)|0;f[a>>2]=0;b=NYa(4)|0;f[b>>2]=0;Sd(9640,312091,21648,151237,82,a|0,21648,151226,66,b|0);b=NYa(4)|0;f[b>>2]=4;a=NYa(4)|0;f[a>>2]=4;Sd(9640,135772,21648,151237,82,b|0,21648,151226,66,a|0);a=NYa(4)|0;f[a>>2]=8;b=NYa(4)|0;f[b>>2]=8;Sd(9640,135781,21688,153706,4,a|0,21688,151598,1,b|0);be(9640);Fe(9528,135789,183816,4,151223,885);b=NYa(4)|0;f[b>>2]=0;a=NYa(4)|0;f[a>>2]=0;Sd(9528,337923,21648,151237,83,b|0,21648,151226,67,a|0);a=NYa(4)|0;f[a>>2]=4;b=NYa(4)|0;f[b>>2]=4;Sd(9528,337929,21648,151237,83,a|0,21648,151226,67,b|0);be(9528);Fe(9648,135789,183816,5,151223,886);b=NYa(4)|0;f[b>>2]=0;a=NYa(4)|0;f[a>>2]=0;Sd(9648,337923,21680,153725,5,b|0,21680,151426,2,a|0);a=NYa(4)|0;f[a>>2]=4;b=NYa(4)|0;f[b>>2]=4;Sd(9648,337929,21680,153725,5,a|0,21680,151426,2,b|0);be(9648);Fe(8984,135789,183816,6,151223,887);b=NYa(4)|0;f[b>>2]=0;a=NYa(4)|0;f[a>>2]=0;Sd(8984,185271,21648,151237,84,b|0,21648,151226,68,a|0);a=NYa(4)|0;f[a>>2]=4;b=NYa(4)|0;f[b>>2]=4;Sd(8984,185273,21648,151237,84,a|0,21648,151226,68,b|0);be(8984);Fe(8624,135789,183816,7,151223,888);b=NYa(4)|0;f[b>>2]=0;a=NYa(4)|0;f[a>>2]=0;Sd(8624,185271,21680,153725,6,b|0,21680,151426,3,a|0);a=NYa(4)|0;f[a>>2]=4;b=NYa(4)|0;f[b>>2]=4;Sd(8624,185273,21680,153725,6,a|0,21680,151426,3,b|0);be(8624);Fe(8640,135795,183816,8,151223,889);b=NYa(4)|0;f[b>>2]=0;a=NYa(4)|0;f[a>>2]=0;Sd(8640,185271,21648,151237,85,b|0,21648,151226,69,a|0);a=NYa(4)|0;f[a>>2]=4;b=NYa(4)|0;f[b>>2]=4;Sd(8640,185273,21648,151237,85,a|0,21648,151226,69,b|0);b=NYa(4)|0;f[b>>2]=8;a=NYa(4)|0;f[a>>2]=8;Sd(8640,337923,21648,151237,85,b|0,21648,151226,69,a|0);a=NYa(4)|0;f[a>>2]=12;b=NYa(4)|0;f[b>>2]=12;Sd(8640,337929,21648,151237,85,a|0,21648,151226,69,b|0);be(8640);Fe(9656,135800,183816,9,151223,890);b=NYa(4)|0;f[b>>2]=0;a=NYa(4)|0;f[a>>2]=0;Sd(9656,185271,21680,153725,7,b|0,21680,151426,4,a|0);a=NYa(4)|0;f[a>>2]=4;b=NYa(4)|0;f[b>>2]=4;Sd(9656,185273,21680,153725,7,a|0,21680,151426,4,b|0);b=NYa(4)|0;f[b>>2]=8;a=NYa(4)|0;f[a>>2]=8;Sd(9656,337923,21680,153725,7,b|0,21680,151426,4,a|0);a=NYa(4)|0;f[a>>2]=12;b=NYa(4)|0;f[b>>2]=12;Sd(9656,337929,21680,153725,7,a|0,21680,151426,4,b|0);be(9656);Fe(8632,135807,183816,10,151223,891);b=NYa(4)|0;f[b>>2]=0;a=NYa(4)|0;f[a>>2]=0;Sd(8632,135819,8624,151237,86,b|0,8624,151226,70,a|0);a=NYa(4)|0;f[a>>2]=8;b=NYa(4)|0;f[b>>2]=8;Sd(8632,338897,9648,151237,87,a|0,9648,151226,71,b|0);b=NYa(4)|0;f[b>>2]=16;a=NYa(4)|0;f[a>>2]=16;Sd(8632,135826,21680,153725,8,b|0,21680,151426,5,a|0);be(8632);sf(135832,2,23236,151237,88,271);sf(135850,2,23244,151237,89,272);sf(135874,2,23252,151237,90,273);Ve(9560,135900,183816,11,151223,892);of(9560,21688,153706,9,0,21688,151598,6,0);of(9560,21688,153706,9,1,21688,151598,6,1);of(9560,21688,153706,9,2,21688,151598,6,2);of(9560,21688,153706,9,3,21688,151598,6,3);Gd(9560);Fe(9664,135907,183816,12,151223,893);a=NYa(4)|0;f[a>>2]=0;b=NYa(4)|0;f[b>>2]=0;Sd(9664,135917,21688,153706,10,a|0,21688,151598,7,b|0);b=NYa(4)|0;f[b>>2]=8;a=NYa(4)|0;f[a>>2]=8;Sd(9664,135924,21688,153706,10,b|0,21688,151598,7,a|0);a=NYa(4)|0;f[a>>2]=16;b=NYa(4)|0;f[b>>2]=16;Sd(9664,135931,8984,151237,91,a|0,8984,151226,72,b|0);b=NYa(4)|0;f[b>>2]=24;a=NYa(4)|0;f[a>>2]=24;Sd(9664,135938,8984,151237,91,b|0,8984,151226,72,a|0);be(9664);Fe(9672,135945,183816,13,151223,894);a=NYa(4)|0;f[a>>2]=0;b=NYa(4)|0;f[b>>2]=0;Sd(9672,135819,8624,151237,92,a|0,8624,151226,73,b|0);b=NYa(4)|0;f[b>>2]=8;a=NYa(4)|0;f[a>>2]=8;Sd(9672,135952,21680,153725,11,b|0,21680,151426,8,a|0);be(9672);Fe(9680,135959,183816,14,151223,895);a=NYa(4)|0;f[a>>2]=0;b=NYa(4)|0;f[b>>2]=0;Sd(9680,135967,21688,153706,12,a|0,21688,151598,9,b|0);b=NYa(4)|0;f[b>>2]=8;a=NYa(4)|0;f[a>>2]=8;Sd(9680,135971,21688,153706,12,b|0,21688,151598,9,a|0);a=NYa(4)|0;f[a>>2]=16;b=NYa(4)|0;f[b>>2]=16;Sd(9680,135975,21688,153706,12,a|0,21688,151598,9,b|0);b=NYa(4)|0;f[b>>2]=24;a=NYa(4)|0;f[a>>2]=24;Sd(9680,135979,21688,153706,12,b|0,21688,151598,9,a|0);a=NYa(4)|0;f[a>>2]=32;b=NYa(4)|0;f[b>>2]=32;Sd(9680,135983,21688,153706,12,a|0,21688,151598,9,b|0);b=NYa(4)|0;f[b>>2]=40;a=NYa(4)|0;f[a>>2]=40;Sd(9680,135987,21688,153706,12,b|0,21688,151598,9,a|0);a=NYa(4)|0;f[a>>2]=48;b=NYa(4)|0;f[b>>2]=48;Sd(9680,135991,21688,153706,12,a|0,21688,151598,9,b|0);b=NYa(4)|0;f[b>>2]=56;a=NYa(4)|0;f[a>>2]=56;Sd(9680,135995,21688,153706,12,b|0,21688,151598,9,a|0);a=NYa(4)|0;f[a>>2]=64;b=NYa(4)|0;f[b>>2]=64;Sd(9680,135999,21688,153706,12,a|0,21688,151598,9,b|0);b=NYa(4)|0;f[b>>2]=72;a=NYa(4)|0;f[a>>2]=72;Sd(9680,136003,21688,153706,12,b|0,21688,151598,9,a|0);a=NYa(4)|0;f[a>>2]=80;b=NYa(4)|0;f[b>>2]=80;Sd(9680,136007,21688,153706,12,a|0,21688,151598,9,b|0);b=NYa(4)|0;f[b>>2]=88;a=NYa(4)|0;f[a>>2]=88;Sd(9680,136012,21688,153706,12,b|0,21688,151598,9,a|0);a=NYa(4)|0;f[a>>2]=96;b=NYa(4)|0;f[b>>2]=96;Sd(9680,136017,21688,153706,12,a|0,21688,151598,9,b|0);b=NYa(4)|0;f[b>>2]=104;a=NYa(4)|0;f[a>>2]=104;Sd(9680,136022,21688,153706,12,b|0,21688,151598,9,a|0);a=NYa(4)|0;f[a>>2]=112;b=NYa(4)|0;f[b>>2]=112;Sd(9680,136027,21688,153706,12,a|0,21688,151598,9,b|0);b=NYa(4)|0;f[b>>2]=120;a=NYa(4)|0;f[a>>2]=120;Sd(9680,136032,21688,153706,12,b|0,21688,151598,9,a|0);a=NYa(4)|0;f[a>>2]=128;b=NYa(4)|0;f[b>>2]=128;Sd(9680,136037,21688,153706,12,a|0,21688,151598,9,b|0);b=NYa(4)|0;f[b>>2]=136;a=NYa(4)|0;f[a>>2]=136;Sd(9680,136042,21688,153706,12,b|0,21688,151598,9,a|0);a=NYa(4)|0;f[a>>2]=144;b=NYa(4)|0;f[b>>2]=144;Sd(9680,136047,21688,153706,12,a|0,21688,151598,9,b|0);b=NYa(4)|0;f[b>>2]=152;a=NYa(4)|0;f[a>>2]=152;Sd(9680,136052,21688,153706,12,b|0,21688,151598,9,a|0);a=NYa(4)|0;f[a>>2]=160;b=NYa(4)|0;f[b>>2]=160;Sd(9680,136057,21688,153706,12,a|0,21688,151598,9,b|0);b=NYa(4)|0;f[b>>2]=168;a=NYa(4)|0;f[a>>2]=168;Sd(9680,136062,21688,153706,12,b|0,21688,151598,9,a|0);a=NYa(4)|0;f[a>>2]=176;b=NYa(4)|0;f[b>>2]=176;Sd(9680,136067,21688,153706,12,a|0,21688,151598,9,b|0);b=NYa(4)|0;f[b>>2]=184;a=NYa(4)|0;f[a>>2]=184;Sd(9680,136072,21688,153706,12,b|0,21688,151598,9,a|0);be(9680);Fe(12472,136077,183816,15,151223,896);a=NYa(4)|0;f[a>>2]=12;b=NYa(4)|0;f[b>>2]=12;Sd(12472,136087,21648,151237,93,a|0,21648,151226,74,b|0);b=NYa(4)|0;f[b>>2]=274;a=NYa(4)|0;f[a>>2]=275;Sd(12472,136092,9696,151237,94,b|0,9696,151226,75,a|0);be(12472);sf(136096,2,23260,151237,95,276);sf(326758,2,23268,151237,96,277);sf(189093,3,23276,151260,64,76);sf(189093,2,23288,151237,97,278);sf(136113,1,23296,151218,130,897);sf(136142,2,23300,151237,98,131);sf(136155,4,23308,151265,27,70);sf(345682,4,23308,151265,27,71);sf(136164,1,23324,151218,132,898);Jd(136184,21648,0);Jd(136192,21648,8);Jd(136200,21648,16);Jd(136208,21648,24);Jd(136216,21648,1);Jd(136224,21648,9);Jd(136232,21648,17);Jd(136240,21648,25);Jd(136248,21648,2);Jd(136257,21648,10);Jd(136266,21648,18);Jd(136275,21648,26);Jd(136284,21648,3);Jd(136293,21648,11);Jd(136302,21648,19);Jd(136311,21648,27);Jd(136320,21648,4);Jd(136329,21648,12);Jd(136338,21648,20);Jd(136347,21648,28);Jd(136356,21648,5);Jd(136365,21648,13);Jd(136374,21648,21);Jd(136383,21648,29);Jd(136392,21648,6);Jd(136401,21648,14);Jd(136410,21648,22);Jd(136419,21648,30);Jd(136428,21648,0);Jd(136434,21648,1);Jd(136440,21648,2);Jd(136447,21648,3);Jd(136454,21648,4);Jd(136461,21648,5);Jd(136468,21648,6);Jd(136475,21648,-2147483648);Jd(136483,21648,2147483647);Fe(9720,136491,183816,16,151223,899);a=NYa(4)|0;f[a>>2]=0;b=NYa(4)|0;f[b>>2]=0;Sd(9720,354400,21680,153725,13,a|0,21680,151426,10,b|0);b=NYa(4)|0;f[b>>2]=4;a=NYa(4)|0;f[a>>2]=4;Sd(9720,354414,21680,153725,13,b|0,21680,151426,10,a|0);a=NYa(4)|0;f[a>>2]=8;b=NYa(4)|0;f[b>>2]=8;Sd(9720,354427,21680,153725,13,a|0,21680,151426,10,b|0);b=NYa(4)|0;f[b>>2]=12;a=NYa(4)|0;f[a>>2]=12;Sd(9720,354440,21656,151237,99,b|0,21656,151226,77,a|0);a=NYa(4)|0;f[a>>2]=16;b=NYa(4)|0;f[b>>2]=16;Sd(9720,354457,21680,153725,13,a|0,21680,151426,10,b|0);b=NYa(4)|0;f[b>>2]=20;a=NYa(4)|0;f[a>>2]=20;Sd(9720,354477,21600,151237,100,b|0,21600,151226,78,a|0);a=NYa(4)|0;f[a>>2]=21;b=NYa(4)|0;f[b>>2]=21;Sd(9720,354491,21616,151237,101,a|0,21616,151226,79,b|0);b=NYa(4)|0;f[b>>2]=22;a=NYa(4)|0;f[a>>2]=22;Sd(9720,354501,21600,151237,100,b|0,21600,151226,78,a|0);a=NYa(4)|0;f[a>>2]=24;b=NYa(4)|0;f[b>>2]=24;Sd(9720,354514,21680,153725,13,a|0,21680,151426,10,b|0);b=NYa(4)|0;f[b>>2]=28;a=NYa(4)|0;f[a>>2]=28;Sd(9720,354522,21680,153725,13,b|0,21680,151426,10,a|0);a=NYa(4)|0;f[a>>2]=32;b=NYa(4)|0;f[b>>2]=32;Sd(9720,354530,21600,151237,100,a|0,21600,151226,78,b|0);b=NYa(4)|0;f[b>>2]=36;a=NYa(4)|0;f[a>>2]=36;Sd(9720,354550,21680,153725,13,b|0,21680,151426,10,a|0);a=NYa(4)|0;f[a>>2]=40;b=NYa(4)|0;f[b>>2]=40;Sd(9720,354565,21680,153725,13,a|0,21680,151426,10,b|0);b=NYa(4)|0;f[b>>2]=44;a=NYa(4)|0;f[a>>2]=44;Sd(9720,354580,21600,151237,100,b|0,21600,151226,78,a|0);a=NYa(4)|0;f[a>>2]=48;b=NYa(4)|0;f[b>>2]=48;Sd(9720,354596,21680,153725,13,a|0,21680,151426,10,b|0);b=NYa(4)|0;f[b>>2]=52;a=NYa(4)|0;f[a>>2]=52;Sd(9720,354612,21680,153725,13,b|0,21680,151426,10,a|0);a=NYa(4)|0;f[a>>2]=56;b=NYa(4)|0;f[b>>2]=56;Sd(9720,354628,21600,151237,100,a|0,21600,151226,78,b|0);b=NYa(4)|0;f[b>>2]=60;a=NYa(4)|0;f[a>>2]=60;Sd(9720,354646,21680,153725,13,b|0,21680,151426,10,a|0);a=NYa(4)|0;f[a>>2]=64;b=NYa(4)|0;f[b>>2]=64;Sd(9720,354659,21680,153725,13,a|0,21680,151426,10,b|0);be(9720);Jd(136516,9728,0);Jd(136533,9728,1);Jd(136548,9736,0);Jd(136577,9736,1);Jd(136607,9736,2);Jd(136637,9736,1e4);Jd(136667,9736,10001);Jd(136706,9736,10002);Fe(9408,136733,183816,17,151223,900);b=NYa(4)|0;f[b>>2]=12;a=NYa(4)|0;f[a>>2]=12;Sd(9408,136740,21680,153725,14,b|0,21680,151426,11,a|0);a=NYa(4)|0;f[a>>2]=8;b=NYa(4)|0;f[b>>2]=8;Sd(9408,136749,21648,151237,102,a|0,21648,151226,80,b|0);b=NYa(4)|0;f[b>>2]=0;a=NYa(4)|0;f[a>>2]=0;Sd(9408,136756,21648,151237,102,b|0,21648,151226,80,a|0);a=NYa(4)|0;f[a>>2]=4;b=NYa(4)|0;f[b>>2]=4;Sd(9408,136765,21648,151237,102,a|0,21648,151226,80,b|0);be(9408);Fe(9160,136774,183816,18,151223,901);b=NYa(4)|0;f[b>>2]=0;a=NYa(4)|0;f[a>>2]=0;Sd(9160,136783,8624,151237,103,b|0,8624,151226,81,a|0);a=NYa(4)|0;f[a>>2]=8;b=NYa(4)|0;f[b>>2]=8;Sd(9160,338897,21680,153725,15,a|0,21680,151426,12,b|0);b=NYa(4)|0;f[b>>2]=12;a=NYa(4)|0;f[a>>2]=12;Sd(9160,135826,21680,153725,15,b|0,21680,151426,12,a|0);a=NYa(4)|0;f[a>>2]=16;b=NYa(4)|0;f[b>>2]=16;Sd(9160,136786,21680,153725,15,a|0,21680,151426,12,b|0);b=NYa(4)|0;f[b>>2]=20;a=NYa(4)|0;f[a>>2]=20;Sd(9160,136795,21648,151237,104,b|0,21648,151226,82,a|0);a=NYa(4)|0;f[a>>2]=24;b=NYa(4)|0;f[b>>2]=24;Sd(9160,136802,21648,151237,104,a|0,21648,151226,82,b|0);be(9160);return}function Hj(a){a=a|0;ee(8680,8704,8720,0,151218,133,151221,0,151221,0,a|0,151223,902);Ed(8680,1,21776,151218,134,19);a=NYa(8)|0;f[a>>2]=279;f[a+4>>2]=0;Je(8680,151008,3,21780,151226,83,a|0,0);a=NYa(8)|0;f[a>>2]=84;f[a+4>>2]=0;Je(8680,323463,4,21792,151231,72,a|0,0);a=NYa(8)|0;f[a>>2]=135;f[a+4>>2]=0;Je(8680,338897,2,21808,151237,105,a|0,0);a=NYa(4)|0;f[a>>2]=85;Je(8680,151018,3,21816,151260,65,a|0,0);a=NYa(4)|0;f[a>>2]=66;Je(8680,151022,4,21828,151265,28,a|0,0);return}function Ij(a){a=a|0;ee(8768,8792,8808,0,151218,136,151221,0,151221,0,a|0,151223,903);Ed(8768,1,21844,151218,137,20);a=NYa(8)|0;f[a>>2]=280;f[a+4>>2]=0;Je(8768,151008,3,21848,151426,13,a|0,0);a=NYa(8)|0;f[a>>2]=86;f[a+4>>2]=0;Je(8768,323463,4,21860,151431,4,a|0,0);a=NYa(8)|0;f[a>>2]=138;f[a+4>>2]=0;Je(8768,338897,2,21876,151237,106,a|0,0);a=NYa(4)|0;f[a>>2]=87;Je(8768,151018,3,21884,151260,67,a|0,0);a=NYa(4)|0;f[a>>2]=68;Je(8768,151022,4,21896,151437,2,a|0,0);return}function Jj(a){a=a|0;ee(8848,8872,8888,0,151218,139,151221,0,151221,0,a|0,151223,904);Ed(8848,1,21912,151218,140,21);a=NYa(8)|0;f[a>>2]=281;f[a+4>>2]=0;Je(8848,151008,3,21916,151598,14,a|0,0);a=NYa(8)|0;f[a>>2]=88;f[a+4>>2]=0;Je(8848,323463,4,21928,151603,5,a|0,0);a=NYa(8)|0;f[a>>2]=141;f[a+4>>2]=0;Je(8848,338897,2,21944,151237,107,a|0,0);a=NYa(4)|0;f[a>>2]=89;Je(8848,151018,3,21952,151260,69,a|0,0);a=NYa(4)|0;f[a>>2]=70;Je(8848,151022,4,21964,151609,3,a|0,0);return}function Kj(a){a=a|0;ee(8928,8952,8968,0,151218,142,151221,0,151221,0,a|0,151223,905);Ed(8928,1,21980,151218,143,22);a=NYa(8)|0;f[a>>2]=282;f[a+4>>2]=0;Je(8928,151008,3,21984,151226,90,a|0,0);a=NYa(8)|0;f[a>>2]=91;f[a+4>>2]=0;Je(8928,323463,4,21996,151231,73,a|0,0);a=NYa(8)|0;f[a>>2]=144;f[a+4>>2]=0;Je(8928,338897,2,22012,151237,108,a|0,0);a=NYa(4)|0;f[a>>2]=92;Je(8928,151018,3,22020,151260,71,a|0,0);a=NYa(4)|0;f[a>>2]=72;Je(8928,151022,4,22032,151265,29,a|0,0);return}function Lj(a){a=a|0;ee(9016,9040,9056,0,151218,145,151221,0,151221,0,a|0,151223,906);Ed(9016,1,22048,151218,146,23);a=NYa(8)|0;f[a>>2]=283;f[a+4>>2]=0;Je(9016,151008,3,22052,151226,93,a|0,0);a=NYa(8)|0;f[a>>2]=94;f[a+4>>2]=0;Je(9016,323463,4,22064,151231,74,a|0,0);a=NYa(8)|0;f[a>>2]=147;f[a+4>>2]=0;Je(9016,338897,2,22080,151237,109,a|0,0);a=NYa(4)|0;f[a>>2]=95;Je(9016,151018,3,22088,151260,73,a|0,0);a=NYa(4)|0;f[a>>2]=74;Je(9016,151022,4,22100,151265,30,a|0,0);return}function Mj(a){a=a|0;ee(9104,9128,9144,0,151218,148,151221,0,151221,0,a|0,151223,907);Ed(9104,1,22116,151218,149,24);a=NYa(8)|0;f[a>>2]=284;f[a+4>>2]=0;Je(9104,151008,3,22120,151226,96,a|0,0);a=NYa(8)|0;f[a>>2]=97;f[a+4>>2]=0;Je(9104,323463,4,22132,151231,75,a|0,0);a=NYa(8)|0;f[a>>2]=150;f[a+4>>2]=0;Je(9104,338897,2,22148,151237,110,a|0,0);a=NYa(4)|0;f[a>>2]=98;Je(9104,151018,3,22156,151260,75,a|0,0);a=NYa(4)|0;f[a>>2]=76;Je(9104,151022,4,22168,151265,31,a|0,0);return}function Nj(a){a=a|0;ee(9192,9216,9232,0,151218,151,151221,0,151221,0,a|0,151223,908);Ed(9192,1,22184,151218,152,25);a=NYa(8)|0;f[a>>2]=285;f[a+4>>2]=0;Je(9192,151008,3,22188,151226,99,a|0,0);a=NYa(8)|0;f[a>>2]=100;f[a+4>>2]=0;Je(9192,323463,4,22200,151231,76,a|0,0);a=NYa(8)|0;f[a>>2]=153;f[a+4>>2]=0;Je(9192,338897,2,22216,151237,111,a|0,0);a=NYa(4)|0;f[a>>2]=101;Je(9192,151018,3,22224,151260,77,a|0,0);a=NYa(4)|0;f[a>>2]=78;Je(9192,151022,4,22236,151265,32,a|0,0);return}function Oj(a){a=a|0;ee(9272,9296,9312,0,151218,154,151221,0,151221,0,a|0,151223,909);Ed(9272,1,22252,151218,155,26);a=NYa(8)|0;f[a>>2]=286;f[a+4>>2]=0;Je(9272,151008,3,22256,151226,102,a|0,0);a=NYa(8)|0;f[a>>2]=103;f[a+4>>2]=0;Je(9272,323463,4,22268,151231,77,a|0,0);a=NYa(8)|0;f[a>>2]=156;f[a+4>>2]=0;Je(9272,338897,2,22284,151237,112,a|0,0);a=NYa(4)|0;f[a>>2]=104;Je(9272,151018,3,22292,151260,79,a|0,0);a=NYa(4)|0;f[a>>2]=80;Je(9272,151022,4,22304,151265,33,a|0,0);return}function Pj(a){a=a|0;ee(9352,9376,9392,0,151218,157,151221,0,151221,0,a|0,151223,910);Ed(9352,1,22320,151218,158,27);a=NYa(8)|0;f[a>>2]=287;f[a+4>>2]=0;Je(9352,151008,3,22324,151226,105,a|0,0);a=NYa(8)|0;f[a>>2]=106;f[a+4>>2]=0;Je(9352,323463,4,22336,151231,78,a|0,0);a=NYa(8)|0;f[a>>2]=159;f[a+4>>2]=0;Je(9352,338897,2,22352,151237,113,a|0,0);a=NYa(4)|0;f[a>>2]=107;Je(9352,151018,3,22360,151260,81,a|0,0);a=NYa(4)|0;f[a>>2]=82;Je(9352,151022,4,22372,151265,34,a|0,0);return}function Qj(a){a=a|0;ee(9440,9464,9480,0,151218,160,151221,0,151221,0,a|0,151223,911);Ed(9440,1,22388,151218,161,28);a=NYa(8)|0;f[a>>2]=288;f[a+4>>2]=0;Je(9440,151008,3,22392,151226,108,a|0,0);a=NYa(8)|0;f[a>>2]=109;f[a+4>>2]=0;Je(9440,323463,4,22404,151231,79,a|0,0);a=NYa(8)|0;f[a>>2]=162;f[a+4>>2]=0;Je(9440,338897,2,22420,151237,114,a|0,0);a=NYa(4)|0;f[a>>2]=110;Je(9440,151018,3,22428,151260,83,a|0,0);a=NYa(4)|0;f[a>>2]=84;Je(9440,151022,4,22440,151265,35,a|0,0);return}function Rj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+224|0;g=e;aR(g,b,c,d);f[a>>2]=1124007936;d=a+8|0;c=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[c>>2]=d;d=a+48|0;f[a+44>>2]=d;f[d>>2]=0;f[a+52>>2]=0;d=f[g>>2]|0;Ah[f[(f[d>>2]|0)+12>>2]&255](d,g,a,-1);fj(g);u=e;return}function Sj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+240|0;e=d;g=d+224|0;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];bR(e,g,c);f[a>>2]=1124007936;c=a+8|0;g=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[g>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;c=f[e>>2]|0;Ah[f[(f[c>>2]|0)+12>>2]&255](c,e,a,-1);fj(e);u=d;return}function Tj(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;g=pf()|0;f[a>>2]=g;h=c+4|0;if((f[h>>2]|0)<=0){u=d;return}i=c+40|0;c=g;g=0;while(1){j=(f[i>>2]|0)+(g<<2)|0;if((b[374896]|0)==0?u1a(374896)|0:0){k=bf(2,21728)|0;f[225234]=k}k=f[225234]|0;f[e>>2]=f[j>>2];ed(k|0,c|0,135330,e|0);k=g+1|0;if((k|0)>=(f[h>>2]|0))break;c=f[a>>2]|0;g=k}u=d;return}function Uj(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;g=pf()|0;f[a>>2]=g;h=c+4|0;if((f[h>>2]|0)<=0){u=d;return}i=c+44|0;c=g;g=0;while(1){j=(f[i>>2]|0)+(g<<2)|0;if((b[374904]|0)==0?u1a(374904)|0:0){k=bf(2,21736)|0;f[225235]=k}k=f[225235]|0;f[e>>2]=f[j>>2];ed(k|0,c|0,135330,e|0);k=g+1|0;if((k|0)>=(f[h>>2]|0))break;c=f[a>>2]|0;g=k}u=d;return}function Vj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=Y(l,g)|0;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=Ee(9576,d|0)|0;f[a>>2]=g;u=c;return}function Wj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=Y(l,g)|0;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=Ee(9584,d|0)|0;f[a>>2]=g;u=c;return}function Xj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=(Y(l,g)|0)>>>1;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=Ee(9592,d|0)|0;f[a>>2]=g;u=c;return}function Yj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=(Y(l,g)|0)>>>1;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=Ee(9600,d|0)|0;f[a>>2]=g;u=c;return}function Zj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=(Y(l,g)|0)>>>2;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=Ee(9608,d|0)|0;f[a>>2]=g;u=c;return}function _j(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=(Y(l,g)|0)>>>2;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=Ee(9616,d|0)|0;f[a>>2]=g;u=c;return}function $j(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=(Y(l,g)|0)>>>3;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=Ee(9624,d|0)|0;f[a>>2]=g;u=c;return}function ak(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;if((b|0)<=0){c=0;return c|0}c=f[(f[a+44>>2]|0)+(b+-1<<2)>>2]|0;return c|0}function bk(a){a=a|0;return 1212424721>>>(f[a>>2]<<2&28)&15|0}function ck(a){a=a|0;return ((f[a>>2]|0)>>>3&511)+1|0}function dk(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if((b|0)<3){c=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;return c|0}d=f[a+40>>2]|0;a=0;e=1;while(1){g=Y(f[d+(a<<2)>>2]|0,e)|0;a=a+1|0;if((a|0)>=(b|0)){c=g;break}else e=g}return c|0}function ek(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=c;f[e+4>>2]=c+1;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;DR(a,b,e,g);u=d;return}function fk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=d&4095;if(((((f[a+4>>2]|0)<3?(f[a+8>>2]|0)==(b|0):0)?(f[a+12>>2]|0)==(c|0):0)?(f[a>>2]&4095|0)==(h|0):0)?f[a+16>>2]|0:0){u=e;return}f[g>>2]=b;f[g+4>>2]=c;AR(a,2,g,h);u=e;return}function gk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[b+4>>2]|0;h=f[b>>2]|0;b=c&4095;if(((((f[a+4>>2]|0)<3?(f[a+8>>2]|0)==(g|0):0)?(f[a+12>>2]|0)==(h|0):0)?(f[a>>2]&4095|0)==(b|0):0)?f[a+16>>2]|0:0){u=d;return}f[e>>2]=g;f[e+4>>2]=h;AR(a,2,e,b);u=d;return}function hk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e+8|0;h=e;f[g>>2]=c;f[g+4>>2]=d;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;DR(a,b,g,h);u=e;return}function ik(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=-2147483648;f[e+4>>2]=2147483647;DR(a,b,c,e);u=d;return}function jk(a){a=a|0;return f[a>>2]&4095|0}function kk(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;if(!(f[a+16>>2]|0))return 1;b=f[a+4>>2]|0;if((b|0)<3){c=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;d=(c|0)==0;e=(b|0)==0;g=d|e;return g|0}h=f[a+40>>2]|0;a=0;i=1;while(1){j=Y(f[h+(a<<2)>>2]|0,i)|0;a=a+1|0;if((a|0)==(b|0)){c=j;break}else i=j}d=(c|0)==0;e=(b|0)==0;g=d|e;return g|0}function lk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e+8|0;h=e;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;f[h>>2]=c;f[h+4>>2]=d;DR(a,b,g,h);u=e;return}function mk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=-2147483648;f[e+4>>2]=2147483647;DR(a,b,e,c);u=d;return}function nk(a,b){a=a|0;b=b|0;return ((f[(f[a+44>>2]|0)+(b<<2)>>2]|0)>>>0)/((1212424721>>>(f[a>>2]<<2&28)&15)>>>0)|0|0}function ok(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=1124007936;e=a+8|0;g=a+40|0;h=a+4|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+48|0;f[a+44>>2]=e;f[e>>2]=0;f[a+52>>2]=0;e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[d>>2]=33619968;f[d+4>>2]=a;eL(b,d);u=c;return}function pk(a){a=a|0;return f[a>>2]&7|0}function qk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=-2147483648;f[e+4>>2]=2147483647;f[g>>2]=c;f[g+4>>2]=c+1;DR(a,b,e,g);u=d;return}function rk(a,b,c){a=a|0;b=b|0;c=c|0;FR(a,b,c);return}function sk(a){a=a|0;return (f[a>>2]&16384|0)!=0|0}function tk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=Ee(9576,e|0)|0;f[a>>2]=h;u=d;return}function uk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=Ee(9576,g|0)|0;f[a>>2]=j;u=e;return}function vk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=Ee(9584,e|0)|0;f[a>>2]=h;u=d;return}function wk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=Ee(9584,g|0)|0;f[a>>2]=j;u=e;return}function xk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=Ee(9600,e|0)|0;f[a>>2]=h;u=d;return}function yk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=Ee(9600,g|0)|0;f[a>>2]=j;u=e;return}function zk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=Ee(9592,e|0)|0;f[a>>2]=h;u=d;return}function Ak(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=Ee(9592,g|0)|0;f[a>>2]=j;u=e;return}function Bk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=Ee(9608,e|0)|0;f[a>>2]=h;u=d;return}function Ck(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=Ee(9608,g|0)|0;f[a>>2]=j;u=e;return}function Dk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=Ee(9616,e|0)|0;f[a>>2]=h;u=d;return}function Ek(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=Ee(9616,g|0)|0;f[a>>2]=j;u=e;return}function Fk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=Ee(9624,e|0)|0;f[a>>2]=h;u=d;return}function Gk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=Ee(9624,g|0)|0;f[a>>2]=j;u=e;return}function Hk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0))|0;return g|0}}g=c+b|0;return g|0}function Ik(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+c|0}function Jk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Kk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0))|0;return g|0}}g=c+b|0;return g|0}function Lk(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+c|0}function Mk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Nk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0)<<1)|0;return g|0}}g=c+(b<<1)|0;return g|0}function Ok(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+(c<<1)|0}function Pk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Qk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0)<<1)|0;return g|0}}g=c+(b<<1)|0;return g|0}function Rk(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+(c<<1)|0}function Sk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Tk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0)<<2)|0;return g|0}}g=c+(b<<2)|0;return g|0}function Uk(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+(c<<2)|0}function Vk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Wk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0)<<2)|0;return g|0}}g=c+(b<<2)|0;return g|0}function Xk(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+(c<<2)|0}function Yk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Zk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function _k(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0)<<3)|0;return g|0}}g=c+(b<<3)|0;return g|0}function $k(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+(c<<3)|0}function al(a){a=a|0;p[a>>3]=1797693134862315708145274.0e284;p[a+8>>3]=1797693134862315708145274.0e284;p[a+16>>3]=1797693134862315708145274.0e284;p[a+24>>3]=1797693134862315708145274.0e284;return}function bl(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;n1(i,j,c,d,e,g);u=h;return}function cl(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;n1(h,i,c,d,e,0);u=g;return}function dl(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;n1(g,h,c,d,3,0);u=e;return}function el(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;b=k+8|0;f[b>>2]=0;f[b+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=c;F1(i,j,k,d,e,g);u=h;return}function fl(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;F1(h,i,j,d,e,0);u=g;return}function gl(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+24|0;j=h+8|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];Hpa(i,j,k,d,e,g);u=h;return}function hl(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+24|0;i=g+8|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];Hpa(h,i,j,d,e,4);u=g;return}function il(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+24|0;h=e+8|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];Hpa(g,h,i,d,0.0,4);u=e;return}function jl(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=+h;i=i|0;j=j|0;var k=0,l=0,m=0;k=u;u=u+32|0;l=k+16|0;m=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;a=m+8|0;f[a>>2]=0;f[a+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=b;jga(l,m,c,d,e,g,h,i,j);u=k;return}function kl(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=+h;i=i|0;var j=0,k=0,l=0;j=u;u=u+32|0;k=j+16|0;l=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;jga(k,l,c,d,e,g,h,i,0);u=j;return}function ll(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;jga(j,k,c,d,e,g,h,0,0);u=i;return}function ml(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;jga(i,j,c,d,e,g,100.0,0,0);u=h;return}function nl(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;jga(h,i,c,d,e,100.0,100.0,0,0);u=g;return}function ol(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;h=+h;i=+i;j=+j;var k=0,l=0,m=0;k=u;u=u+32|0;l=k+16|0;m=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;a=m+8|0;f[a>>2]=0;f[a+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=b;Wfa(l,m,c,d,e,g,h,i,j);u=k;return}function pl(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;h=+h;i=+i;var j=0,k=0,l=0;j=u;u=u+32|0;k=j+16|0;l=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;Wfa(k,l,c,d,e,g,h,i,3.141592653589793);u=j;return}function ql(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;Wfa(j,k,c,d,e,g,h,0.0,3.141592653589793);u=i;return}function rl(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;Wfa(i,j,c,d,e,g,0.0,0.0,3.141592653589793);u=h;return}function sl(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;Wfa(h,i,c,d,e,0.0,0.0,0.0,3.141592653589793);u=g;return}function tl(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;ega(j,k,c,d,e,g,h);u=i;return}function ul(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;ega(i,j,c,d,e,g,0.0);u=h;return}function vl(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;ega(h,i,c,d,e,0.0,0.0);u=g;return}function wl(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;d8(j,k,c,d,e,g,h);u=i;return}function xl(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;d8(i,j,c,d,e,g,4);u=h;return}function yl(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;d8(h,i,c,d,e,0.0,4);u=g;return}function zl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;d8(g,h,c,d,1.0,0.0,4);u=e;return}function Al(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;d8(e,g,c,1,1.0,0.0,4);u=d;return}function Bl(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;i=i|0;var j=0,k=0,l=0;j=u;u=u+32|0;k=j+16|0;l=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;c8(k,l,c,d,e,g,h,i);u=j;return}function Cl(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;c8(j,k,c,d,e,g,h,4);u=i;return}function Dl(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;c8(i,j,c,d,e,g,0.0,4);u=h;return}function El(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;c8(h,i,c,d,e,1.0,0.0,4);u=g;return}function Fl(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=+i;j=j|0;var k=0,l=0,m=0;k=u;u=u+32|0;l=k+16|0;m=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;a=m+8|0;f[a>>2]=0;f[a+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=b;b8(l,m,c,d,e,g,h,i,j);u=k;return}function Gl(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=+i;var j=0,k=0,l=0;j=u;u=u+32|0;k=j+16|0;l=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;b8(k,l,c,d,e,g,h,i,4);u=j;return}function Hl(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;b8(j,k,c,d,e,g,h,0.0,4);u=i;return}function Il(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;b8(i,j,c,d,e,g,1.0,0.0,4);u=h;return}function Jl(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;b8(h,i,c,d,e,3,1.0,0.0,4);u=g;return}function Kl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;wH(e,g,h);u=d;return}function Ll(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;lqa(j,k,c,d,e,g,h);u=i;return}function Ml(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;TG(h,i,j,k,e);u=g;return}function Nl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;TG(g,h,i,j,-1);u=e;return}function Ol(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;TG(e,g,h,fT()|0,-1);u=d;return}function Pl(a,b,c,d,e,g,h){a=a|0;b=+b;c=c|0;d=+d;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;c=l+8|0;f[c>>2]=0;f[c+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=g;hI(j,b,k,d,e,l,h);u=i;return}function Ql(a,b,c,d,e,g){a=a|0;b=+b;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;c=k+8|0;f[c>>2]=0;f[c+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=g;hI(i,b,j,d,e,k,-1);u=h;return}function Rl(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;k1(g,h,c,d);u=e;return}function Sl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;e=+ona(d,b);u=c;return +e}function Tl(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;Kpa(i,j,c,d,e,g);u=h;return}function Ul(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;Kpa(h,i,c,d,e,4);u=g;return}function Vl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;bG(g,h,i,j);u=e;return}function Wl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;bG(e,g,h,fT()|0);u=d;return}function Xl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;lG(e,g,h);u=d;return}function Yl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;lG(d,e,fT()|0);u=c;return}function Zl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;fG(g,h,i,j);u=e;return}function _l(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;fG(e,g,h,fT()|0);u=d;return}function $l(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;iG(g,h,i,j);u=e;return}function am(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;iG(e,g,h,fT()|0);u=d;return}function bm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g+8|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];Epa(h,i,j,k,e);u=g;return}function cm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e+8|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];Epa(g,h,i,j,4);u=e;return}function dm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d+8|0;i=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];f[i>>2]=-1;f[i+4>>2]=-1;Epa(e,g,h,i,4);u=d;return}function em(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;rna(a,d);u=c;return}function fm(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];Dpa(j,k,c,l,m,g,h);u=i;return}function gm(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h+8|0;l=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];Dpa(i,j,c,k,l,g,4);u=h;return}function hm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g+8|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];Dpa(h,i,c,j,k,1,4);u=g;return}function im(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e+8|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[j>>2]=-1;f[j+4>>2]=-1;Dpa(g,h,c,i,j,1,4);u=e;return}function jm(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+32|0;l=h+40|0;m=h+16|0;n=h+4|0;o=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=17104896;f[i+4>>2]=a;a=f[b>>2]|0;f[k>>2]=a;Qd(a|0);km(j,k);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;c=m+8|0;f[c>>2]=0;f[c+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=d;d=f[e>>2]|0;f[o>>2]=d;Qd(d|0);lm(n,o);Pfa(i,j,l,m,n,g);m=f[n>>2]|0;if(m|0){l=n+4|0;n=f[l>>2]|0;if((n|0)!=(m|0))f[l>>2]=n+(~((n+-4-m|0)>>>2)<<2);PYa(m)}ce(f[o>>2]|0);o=f[j>>2]|0;if(!o){p=f[k>>2]|0;ce(p|0);u=h;return}m=j+4|0;j=f[m>>2]|0;if((j|0)!=(o|0))f[m>>2]=j+(~((j+-4-o|0)>>>2)<<2);PYa(o);p=f[k>>2]|0;ce(p|0);u=h;return}function km(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;e=c+8|0;g=f[b>>2]|0;h=Pf(153988)|0;i=od(g|0,h|0)|0;ce(h|0);j=+Ud(i|0,21656,d|0);le(f[d>>2]|0);h=~~j>>>0;ce(i|0);f[a>>2]=0;i=a+4|0;f[i>>2]=0;f[a+8>>2]=0;if(!h){u=c;return}g=a+8|0;k=0;do{l=f[b>>2]|0;f[d>>2]=k;m=Ee(21656,d|0)|0;n=od(l|0,m|0)|0;ce(m|0);j=+Ud(n|0,21648,d|0);le(f[d>>2]|0);m=~~j;f[e>>2]=m;l=f[i>>2]|0;if(l>>>0<(f[g>>2]|0)>>>0){f[l>>2]=m;f[i>>2]=l+4}else Ly(a,e);ce(n|0);k=k+1|0}while(k>>>0<h>>>0);u=c;return}function lm(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,o=0,p=0.0;c=u;u=u+16|0;d=c;e=c+8|0;g=f[b>>2]|0;h=Pf(153988)|0;i=od(g|0,h|0)|0;ce(h|0);j=+Ud(i|0,21656,d|0);le(f[d>>2]|0);h=~~j>>>0;ce(i|0);f[a>>2]=0;i=a+4|0;f[i>>2]=0;f[a+8>>2]=0;if(!h){u=c;return}g=a+8|0;k=0;do{l=f[b>>2]|0;f[d>>2]=k;m=Ee(21656,d|0)|0;o=od(l|0,m|0)|0;ce(m|0);j=+Ud(o|0,21680,d|0);le(f[d>>2]|0);p=j;n[e>>2]=p;m=f[i>>2]|0;if(m>>>0<(f[g>>2]|0)>>>0){n[m>>2]=p;f[i>>2]=m+4}else My(a,e);ce(o|0);k=k+1|0}while(k>>>0<h>>>0);u=c;return}function mm(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=u;u=u+112|0;j=i+88|0;k=i+72|0;l=i+48|0;m=i+56|0;n=i+32|0;o=i+20|0;p=i+4|0;q=i+8|0;r=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=17104896;f[j+4>>2]=a;a=f[b>>2]|0;f[l>>2]=a;Qd(a|0);km(k,l);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=c;c=n+8|0;f[c>>2]=0;f[c+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=d;d=f[e>>2]|0;f[p>>2]=d;Qd(d|0);km(o,p);d=f[g>>2]|0;f[r>>2]=d;Qd(d|0);lm(q,r);Nfa(j,k,m,n,o,q,h);h=f[q>>2]|0;if(h|0){n=q+4|0;q=f[n>>2]|0;if((q|0)!=(h|0))f[n>>2]=q+(~((q+-4-h|0)>>>2)<<2);PYa(h)}ce(f[r>>2]|0);r=f[o>>2]|0;if(r|0){h=o+4|0;o=f[h>>2]|0;if((o|0)!=(r|0))f[h>>2]=o+(~((o+-4-r|0)>>>2)<<2);PYa(r)}ce(f[p>>2]|0);p=f[k>>2]|0;if(!p){s=f[l>>2]|0;ce(s|0);u=i;return}r=k+4|0;k=f[r>>2]|0;if((k|0)!=(p|0))f[r>>2]=k+(~((k+-4-p|0)>>>2)<<2);PYa(p);s=f[l>>2]|0;ce(s|0);u=i;return}function nm(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=u;u=u+112|0;i=h+88|0;j=h+72|0;k=h+48|0;l=h+56|0;m=h+32|0;n=h+20|0;o=h+4|0;p=h+8|0;q=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=17104896;f[i+4>>2]=a;a=f[b>>2]|0;f[k>>2]=a;Qd(a|0);km(j,k);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;c=m+8|0;f[c>>2]=0;f[c+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=d;d=f[e>>2]|0;f[o>>2]=d;Qd(d|0);km(n,o);d=f[g>>2]|0;f[q>>2]=d;Qd(d|0);lm(p,q);Nfa(i,j,l,m,n,p,0);m=f[p>>2]|0;if(m|0){l=p+4|0;p=f[l>>2]|0;if((p|0)!=(m|0))f[l>>2]=p+(~((p+-4-m|0)>>>2)<<2);PYa(m)}ce(f[q>>2]|0);q=f[n>>2]|0;if(q|0){m=n+4|0;n=f[m>>2]|0;if((n|0)!=(q|0))f[m>>2]=n+(~((n+-4-q|0)>>>2)<<2);PYa(q)}ce(f[o>>2]|0);o=f[j>>2]|0;if(!o){r=f[k>>2]|0;ce(r|0);u=h;return}q=j+4|0;j=f[q>>2]|0;if((j|0)!=(o|0))f[q>>2]=j+(~((j+-4-o|0)>>>2)<<2);PYa(o);r=f[k>>2]|0;ce(r|0);u=h;return}function om(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;var l=0,m=0,n=0,o=0;l=u;u=u+48|0;m=l+32|0;n=l+16|0;o=l;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=a;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=b;b=o+8|0;f[b>>2]=0;f[b+4>>2]=0;f[o>>2]=50397184;f[o+4>>2]=c;xva(m,n,o,d,e,g,h,i,j,k);u=l;return}function pm(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;m=u;u=u+128|0;n=m;o=m+104|0;p=m+88|0;q=m+72|0;r=m+56|0;s=m+40|0;t=m+24|0;v=m+16|0;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=a;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=b;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=c;c=r+8|0;f[c>>2]=0;f[c+4>>2]=0;f[r>>2]=50397184;f[r+4>>2]=d;d=s+8|0;f[d>>2]=0;f[d+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=e;e=t+8|0;f[e>>2]=0;f[e+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=g;f[v>>2]=f[h>>2];f[v+4>>2]=f[h+4>>2];f[n>>2]=f[j>>2];f[n+4>>2]=f[j+4>>2];f[n+8>>2]=f[j+8>>2];f[n+12>>2]=f[j+12>>2];tva(o,p,q,r,s,t,v,i,n,k,l);u=m;return}function qm(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;l=u;u=u+128|0;m=l;n=l+104|0;o=l+88|0;p=l+72|0;q=l+56|0;r=l+40|0;s=l+24|0;t=l+16|0;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=a;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=b;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=c;c=q+8|0;f[c>>2]=0;f[c+4>>2]=0;f[q>>2]=50397184;f[q+4>>2]=d;d=r+8|0;f[d>>2]=0;f[d+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=e;e=s+8|0;f[e>>2]=0;f[e+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=g;f[t>>2]=f[h>>2];f[t+4>>2]=f[h+4>>2];f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];f[m+8>>2]=f[j+8>>2];f[m+12>>2]=f[j+12>>2];tva(n,o,p,q,r,s,t,i,m,k,.0001);u=l;return}function rm(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=u;u=u+128|0;l=k;m=k+104|0;n=k+88|0;o=k+72|0;p=k+56|0;q=k+40|0;r=k+24|0;s=k+16|0;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=a;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=b;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=c;c=p+8|0;f[c>>2]=0;f[c+4>>2]=0;f[p>>2]=50397184;f[p+4>>2]=d;d=q+8|0;f[d>>2]=0;f[d+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=e;e=r+8|0;f[e>>2]=0;f[e+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=g;f[s>>2]=f[h>>2];f[s+4>>2]=f[h+4>>2];f[l>>2]=f[j>>2];f[l+4>>2]=f[j+4>>2];f[l+8>>2]=f[j+8>>2];f[l+12>>2]=f[j+12>>2];tva(m,n,o,p,q,r,s,i,l,0,.0001);u=k;return}function sm(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;j=u;u=u+144|0;k=j+16|0;l=j+120|0;m=j+104|0;n=j+88|0;o=j+72|0;q=j+56|0;r=j+40|0;s=j+32|0;t=j;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=b;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=c;c=o+8|0;f[c>>2]=0;f[c+4>>2]=0;f[o>>2]=50397184;f[o+4>>2]=d;d=q+8|0;f[d>>2]=0;f[d+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=e;e=r+8|0;f[e>>2]=0;f[e+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=g;f[s>>2]=f[h>>2];f[s+4>>2]=f[h+4>>2];f[t>>2]=3;f[t+4>>2]=30;p[t+8>>3]=.01;f[k>>2]=f[t>>2];f[k+4>>2]=f[t+4>>2];f[k+8>>2]=f[t+8>>2];f[k+12>>2]=f[t+12>>2];tva(l,m,n,o,q,r,s,i,k,0,.0001);u=j;return}function tm(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;i=u;u=u+144|0;j=i+16|0;k=i+120|0;l=i+104|0;m=i+88|0;n=i+72|0;o=i+56|0;q=i+40|0;r=i+32|0;s=i;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=c;c=n+8|0;f[c>>2]=0;f[c+4>>2]=0;f[n>>2]=50397184;f[n+4>>2]=d;d=o+8|0;f[d>>2]=0;f[d+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=e;e=q+8|0;f[e>>2]=0;f[e+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=g;f[r>>2]=f[h>>2];f[r+4>>2]=f[h+4>>2];f[s>>2]=3;f[s+4>>2]=30;p[s+8>>3]=.01;f[j>>2]=f[s>>2];f[j+4>>2]=f[s+4>>2];f[j+8>>2]=f[s+8>>2];f[j+12>>2]=f[s+12>>2];tva(k,l,m,n,o,q,r,3,j,0,.0001);u=i;return}function um(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;h=u;u=u+144|0;i=h+16|0;j=h+120|0;k=h+104|0;l=h+88|0;m=h+72|0;n=h+56|0;o=h+40|0;q=h+32|0;r=h;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;c=m+8|0;f[c>>2]=0;f[c+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=d;d=n+8|0;f[d>>2]=0;f[d+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=e;e=o+8|0;f[e>>2]=0;f[e+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=g;f[q>>2]=21;f[q+4>>2]=21;f[r>>2]=3;f[r+4>>2]=30;p[r+8>>3]=.01;f[i>>2]=f[r>>2];f[i+4>>2]=f[r+4>>2];f[i+8>>2]=f[r+8>>2];f[i+12>>2]=f[r+12>>2];tva(j,k,l,m,n,o,q,3,i,0,.0001);u=h;return}function vm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;c=k+8|0;f[c>>2]=0;f[c+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=d;kN(h,i,j,k,e);u=g;return}function wm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;c=j+8|0;f[c>>2]=0;f[c+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=d;kN(g,h,i,j,0);u=e;return}function xm(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+32|0;j=i+8|0;k=i;l=j+8|0;f[l>>2]=0;f[l+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];O8(j,k,c,d,e,g,h);u=i;return}function ym(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+8|0;j=h;k=i+8|0;f[k>>2]=0;f[k+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=a;f[j>>2]=f[b>>2];f[j+4>>2]=f[b+4>>2];O8(i,j,c,d,e,g,0);u=h;return}function zm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+32|0;h=g+8|0;i=g;j=h+8|0;f[j>>2]=0;f[j+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;f[i>>2]=f[b>>2];f[i+4>>2]=f[b+4>>2];O8(h,i,c,d,e,8,0);u=g;return}function Am(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+8|0;h=e;i=g+8|0;f[i>>2]=0;f[i+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=a;f[h>>2]=f[b>>2];f[h+4>>2]=f[b+4>>2];O8(g,h,c,d,1,8,0);u=e;return}function Bm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;pI(g,h,i,d);u=e;return}function Cm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;h=+Qfa(e,g,c);u=d;return +h}function Dm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;b=h6(g,h,c,d)|0;u=e;return b|0}function Em(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;b=h6(e,g,c,4)|0;u=d;return b|0}function Fm(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;b=h6(d,e,8,4)|0;u=c;return b|0}function Gm(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+64|0;i=h+48|0;j=h+32|0;k=h+16|0;l=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;b=k+8|0;f[b>>2]=0;f[b+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=c;c=l+8|0;f[c>>2]=0;f[c+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=d;d=C6(i,j,k,l,e,g)|0;u=h;return d|0}function Hm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;c=k+8|0;f[c>>2]=0;f[c+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=d;d=C6(h,i,j,k,e,4)|0;u=g;return d|0}function Im(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;c=j+8|0;f[c>>2]=0;f[c+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=d;d=C6(g,h,i,j,8,4)|0;u=e;return d|0}function Jm(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;e=+pna(d,b);u=c;return +e}function Km(a){a=a|0;var b=0,c=0,d=0.0;b=u;u=u+16|0;c=b;f[c+8>>2]=0;f[c+12>>2]=0;f[c>>2]=16842752;f[c+4>>2]=a;d=+pna(c,0);u=b;return +d}function Lm(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;OJ(g,h,c,d);u=e;return}function Mm(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;OJ(e,g,c,0.0);u=d;return}function Nm(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;OJ(d,e,1.0,0.0);u=c;return}function Om(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;i7(g,h,c,d);u=e;return}function Pm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;i7(e,g,c,1);u=d;return}function Qm(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;i7(d,e,0,1);u=c;return}function Rm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;v7(e,g,h);u=d;return}function Sm(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=u;u=u+32|0;k=j+16|0;l=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;mL(k,l,c,d,e,g,h,i);u=j;return}function Tm(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+64|0;j=i+48|0;k=i+32|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;mL(j,k,c,d,e,g,h,l);u=i;return}function Um(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;A7(i,j,c,d,e,g);u=h;return}function Vm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;A7(h,i,c,d,e,4);u=g;return}function Wm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;y7(h,i,c,d,e);u=g;return}function Xm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;y7(g,h,c,d,4);u=e;return}function Ym(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;y7(e,g,c,3,4);u=d;return}function Zm(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[c+8>>2]=0;f[c+12>>2]=0;f[c>>2]=16842752;f[c+4>>2]=a;a=bZ(c)|0;u=b;return a|0}function _m(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f6(g,h,c,d);u=e;return}function $m(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f6(e,g,c,0);u=d;return}function an(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;B7(g,h,c,d);u=e;return}function bn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;B7(e,g,c,0);u=d;return}function cn(a){a=a|0;var b=0,c=0,d=0.0;b=u;u=u+16|0;c=b;f[c+8>>2]=0;f[c+12>>2]=0;f[c>>2]=16842752;f[c+4>>2]=a;d=+ZM(c);u=b;return +d}function dn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;PM(g,h,c,d);u=e;return}function en(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;PM(e,g,c,0);u=d;return}function fn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;PM(d,e,0,0);u=c;return}function gn(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];dka(j,k,l,m,e,g,h);u=i;return}function hn(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+40|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];p[m>>3]=1797693134862315708145274.0e284;p[m+8>>3]=1797693134862315708145274.0e284;p[m+16>>3]=1797693134862315708145274.0e284;p[m+24>>3]=1797693134862315708145274.0e284;dka(i,j,k,l,e,g,m);u=h;return}function jn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+72|0;i=g+56|0;j=g+40|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];p[l>>3]=1797693134862315708145274.0e284;p[l+8>>3]=1797693134862315708145274.0e284;p[l+16>>3]=1797693134862315708145274.0e284;p[l+24>>3]=1797693134862315708145274.0e284;dka(h,i,j,k,e,0,l);u=g;return}function kn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+96|0;g=e+72|0;h=e+56|0;i=e+40|0;j=e+32|0;k=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];p[k>>3]=1797693134862315708145274.0e284;p[k+8>>3]=1797693134862315708145274.0e284;p[k+16>>3]=1797693134862315708145274.0e284;p[k+24>>3]=1797693134862315708145274.0e284;dka(g,h,i,j,1,0,k);u=e;return}function ln(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+96|0;e=d+72|0;g=d+56|0;h=d+40|0;i=d+32|0;j=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;f[i>>2]=-1;f[i+4>>2]=-1;p[j>>3]=1797693134862315708145274.0e284;p[j+8>>3]=1797693134862315708145274.0e284;p[j+16>>3]=1797693134862315708145274.0e284;p[j+24>>3]=1797693134862315708145274.0e284;dka(e,g,h,i,1,0,j);u=d;return}function mn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;k8(h,i,c,d,e);u=g;return}function nn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;k8(g,h,c,d,5);u=e;return}function on(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;b=k+8|0;f[b>>2]=0;f[b+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=c;f8(i,j,k,d,e,g);u=h;return}function pn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;f8(h,i,j,d,e,0);u=g;return}function qn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;TH(h,i,j,d,e);u=g;return}function rn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;TH(g,h,i,d,-1);u=e;return}function sn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;TH(e,g,h,1.0,-1);u=d;return}function tn(a,b,c,d){a=+a;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;$H(a,g,h,d);u=e;return}function un(a,b,c){a=+a;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;$H(a,e,g,-1);u=d;return}function vn(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=u;u=u+64|0;l=k+40|0;m=k+24|0;n=k+8|0;o=k;p=l+8|0;f[p>>2]=0;f[p+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=a;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=17104896;f[m+4>>2]=b;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=h;f[o>>2]=f[j>>2];f[o+4>>2]=f[j+4>>2];T8(l,m,c,d,e,g,n,i,o);u=k;return}function wn(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=u;u=u+64|0;k=j+40|0;l=j+24|0;m=j+8|0;n=j;o=k+8|0;f[o>>2]=0;f[o+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=a;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=17104896;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=h;f[n>>2]=0;f[n+4>>2]=0;T8(k,l,c,d,e,g,m,i,n);u=j;return}function xn(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;n=j+8|0;f[n>>2]=0;f[n+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=17104896;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=h;f[m>>2]=0;f[m+4>>2]=0;T8(j,k,c,d,e,g,l,2147483647,m);u=i;return}function yn(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+48|0;i=h+24|0;j=h+8|0;k=h;l=i+8|0;f[l>>2]=0;f[l+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=a;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=17104896;f[j+4>>2]=b;b=fT()|0;f[k>>2]=0;f[k+4>>2]=0;T8(i,j,c,d,e,g,b,2147483647,k);u=h;return}function zn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+48|0;h=g+24|0;i=g+8|0;j=g;k=h+8|0;f[k>>2]=0;f[k+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=17104896;f[i+4>>2]=b;b=fT()|0;f[j>>2]=0;f[j+4>>2]=0;T8(h,i,c,d,e,8,b,2147483647,j);u=g;return}function An(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+48|0;g=e+24|0;h=e+8|0;i=e;j=g+8|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=17104896;f[h+4>>2]=b;b=fT()|0;f[i>>2]=0;f[i+4>>2]=0;T8(g,h,c,d,1,8,b,2147483647,i);u=e;return}function Bn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=c;BAa(h,b,i,d,e);u=g;return}function Cn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=c;BAa(g,b,h,d,0);u=e;return}function Dn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+64|0;e=d+48|0;g=d+32|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=c;p[h>>3]=-1.0;p[h+8>>3]=-1.0;p[h+16>>3]=-1.0;p[h+24>>3]=-1.0;BAa(e,b,g,h,0);u=d;return}function En(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;l=u;u=u+96|0;m=l+72|0;n=l+56|0;o=l+40|0;p=l+16|0;q=l+24|0;r=l+4|0;s=l;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=a;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=c;c=f[e>>2]|0;f[p>>2]=c;Qd(c|0);Fn(o,p);c=q+8|0;f[c>>2]=0;f[c+4>>2]=0;f[q>>2]=50397184;f[q+4>>2]=g;g=f[j>>2]|0;f[s>>2]=g;Qd(g|0);Gn(r,s);DAa(m,b,n,d,o,q,h,i,r,k);k=f[r>>2]|0;if(k|0){i=r+4|0;if((f[i>>2]|0)!=(k|0))f[i>>2]=k;PYa(k)}ce(f[s>>2]|0);s=f[o>>2]|0;if(!s){t=f[p>>2]|0;ce(t|0);u=l;return}k=o+4|0;o=f[k>>2]|0;if((o|0)!=(s|0))f[k>>2]=o+(~((o+-16-s|0)>>>4)<<4);PYa(s);t=f[p>>2]|0;ce(t|0);u=l;return}function Fn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,n=0;c=u;u=u+32|0;d=c;e=c+8|0;g=f[b>>2]|0;h=Pf(153988)|0;i=od(g|0,h|0)|0;ce(h|0);j=+Ud(i|0,21656,d|0);le(f[d>>2]|0);h=~~j>>>0;ce(i|0);f[a>>2]=0;i=a+4|0;f[i>>2]=0;f[a+8>>2]=0;if(!h){u=c;return}g=a+8|0;k=0;do{l=f[b>>2]|0;f[d>>2]=k;m=Ee(21656,d|0)|0;n=od(l|0,m|0)|0;ce(m|0);j=+Ud(n|0,9408,d|0);m=f[d>>2]|0;l=~~j>>>0;f[e>>2]=f[l>>2];f[e+4>>2]=f[l+4>>2];f[e+8>>2]=f[l+8>>2];f[e+12>>2]=f[l+12>>2];le(m|0);m=f[i>>2]|0;if(m>>>0<(f[g>>2]|0)>>>0){f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];f[m+8>>2]=f[e+8>>2];f[m+12>>2]=f[e+12>>2];f[i>>2]=(f[i>>2]|0)+16}else Ny(a,e);ce(n|0);k=k+1|0}while(k>>>0<h>>>0);u=c;return}function Gn(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;h=Pf(153988)|0;i=od(g|0,h|0)|0;ce(h|0);j=+Ud(i|0,21656,e|0);le(f[e>>2]|0);h=~~j>>>0;ce(i|0);f[a>>2]=0;i=a+4|0;f[i>>2]=0;f[a+8>>2]=0;if(!h){u=d;return}g=a+8|0;k=0;while(1){l=f[c>>2]|0;f[e>>2]=k;m=Ee(21656,e|0)|0;n=od(l|0,m|0)|0;ce(m|0);j=+Ud(n|0,21608,e|0);le(f[e>>2]|0);m=~~j;l=f[i>>2]|0;o=f[g>>2]|0;p=o;if(l>>>0>=o>>>0){o=f[a>>2]|0;q=l-o|0;r=q+1|0;s=o;if((r|0)<0){t=7;break}v=p-o|0;p=v<<1;w=v>>>0<1073741823?(p>>>0<r>>>0?r:p):2147483647;if(!w)x=0;else x=NYa(w)|0;p=x+q|0;b[p>>0]=m;r=p+(0-q)|0;if((q|0)>0)K1a(r|0,s|0,q|0)|0;f[a>>2]=r;f[i>>2]=p+1;f[g>>2]=x+w;if(o|0)PYa(s)}else{b[l>>0]=m;f[i>>2]=(f[i>>2]|0)+1}ce(n|0);k=k+1|0;if(k>>>0>=h>>>0){t=3;break}}if((t|0)==3){u=d;return}else if((t|0)==7)gXa(a)}function Hn(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=u;u=u+96|0;l=k+72|0;m=k+56|0;n=k+40|0;o=k+16|0;p=k+24|0;q=k+4|0;r=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=c;c=f[e>>2]|0;f[o>>2]=c;Qd(c|0);Fn(n,o);c=p+8|0;f[c>>2]=0;f[c+4>>2]=0;f[p>>2]=50397184;f[p+4>>2]=g;g=f[j>>2]|0;f[r>>2]=g;Qd(g|0);Gn(q,r);DAa(l,b,m,d,n,p,h,i,q,0);i=f[q>>2]|0;if(i|0){h=q+4|0;if((f[h>>2]|0)!=(i|0))f[h>>2]=i;PYa(i)}ce(f[r>>2]|0);r=f[n>>2]|0;if(!r){s=f[o>>2]|0;ce(s|0);u=k;return}i=n+4|0;n=f[i>>2]|0;if((n|0)!=(r|0))f[i>>2]=n+(~((n+-16-r|0)>>>4)<<4);PYa(r);s=f[o>>2]|0;ce(s|0);u=k;return}function In(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=u;u=u+80|0;k=j+64|0;l=j+48|0;m=j+32|0;n=j+12|0;o=j+16|0;p=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;c=f[e>>2]|0;f[n>>2]=c;Qd(c|0);Fn(m,n);c=o+8|0;f[c>>2]=0;f[c+4>>2]=0;f[o>>2]=50397184;f[o+4>>2]=g;f[p>>2]=0;g=p+4|0;f[g>>2]=0;f[p+8>>2]=0;DAa(k,b,l,d,m,o,h,i,p,0);i=f[p>>2]|0;if(i|0){if((f[g>>2]|0)!=(i|0))f[g>>2]=i;PYa(i)}i=f[m>>2]|0;if(!i){q=f[n>>2]|0;ce(q|0);u=j;return}g=m+4|0;m=f[g>>2]|0;if((m|0)!=(i|0))f[g>>2]=m+(~((m+-16-i|0)>>>4)<<4);PYa(i);q=f[n>>2]|0;ce(q|0);u=j;return}function Jn(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;i=u;u=u+112|0;j=i+96|0;k=i+80|0;l=i+64|0;m=i+44|0;n=i+48|0;o=i;q=i+32|0;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;c=f[e>>2]|0;f[m>>2]=c;Qd(c|0);Fn(l,m);c=n+8|0;f[c>>2]=0;f[c+4>>2]=0;f[n>>2]=50397184;f[n+4>>2]=g;p[o>>3]=-1.0;p[o+8>>3]=-1.0;p[o+16>>3]=-1.0;p[o+24>>3]=-1.0;f[q>>2]=0;g=q+4|0;f[g>>2]=0;f[q+8>>2]=0;DAa(j,b,k,d,l,n,h,o,q,0);o=f[q>>2]|0;if(o|0){if((f[g>>2]|0)!=(o|0))f[g>>2]=o;PYa(o)}o=f[l>>2]|0;if(!o){r=f[m>>2]|0;ce(r|0);u=i;return}g=l+4|0;l=f[g>>2]|0;if((l|0)!=(o|0))f[g>>2]=l+(~((l+-16-o|0)>>>4)<<4);PYa(o);r=f[m>>2]|0;ce(r|0);u=i;return}function Kn(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;h=u;u=u+144|0;i=h+128|0;j=h+112|0;k=h+96|0;l=h+76|0;m=h+80|0;n=h+32|0;o=h;q=h+64|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;c=f[e>>2]|0;f[l>>2]=c;Qd(c|0);Fn(k,l);c=m+8|0;f[c>>2]=0;f[c+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=g;p[n>>3]=-1.0;p[n+8>>3]=-1.0;p[n+16>>3]=-1.0;p[n+24>>3]=-1.0;p[o>>3]=-1.0;p[o+8>>3]=-1.0;p[o+16>>3]=-1.0;p[o+24>>3]=-1.0;f[q>>2]=0;g=q+4|0;f[g>>2]=0;f[q+8>>2]=0;DAa(i,b,j,d,k,m,n,o,q,0);o=f[q>>2]|0;if(o|0){if((f[g>>2]|0)!=(o|0))f[g>>2]=o;PYa(o)}o=f[k>>2]|0;if(!o){r=f[l>>2]|0;ce(r|0);u=h;return}g=k+4|0;k=f[g>>2]|0;if((k|0)!=(o|0))f[g>>2]=k+(~((k+-16-o|0)>>>4)<<4);PYa(o);r=f[l>>2]|0;ce(r|0);u=h;return}function Ln(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;c=bN(e,g,h)|0;u=d;return c|0}function Mn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;b=bN(d,e,fT()|0)|0;u=c;return b|0}function Nn(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=u;u=u+32|0;m=l+16|0;n=l+8|0;o=l;p=m+8|0;f[p>>2]=0;f[p+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=a;f[n>>2]=f[b>>2];f[n+4>>2]=f[b+4>>2];f[o>>2]=f[c>>2];f[o+4>>2]=f[c+4>>2];P8(m,n,o,d,e,g,h,i,j,k);u=l;return}function On(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=u;u=u+32|0;l=k+16|0;m=k+8|0;n=k;o=l+8|0;f[o>>2]=0;f[o+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=a;f[m>>2]=f[b>>2];f[m+4>>2]=f[b+4>>2];f[n>>2]=f[c>>2];f[n+4>>2]=f[c+4>>2];P8(l,m,n,d,e,g,h,i,j,0);u=k;return}function Pn(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;j=u;u=u+32|0;k=j+16|0;l=j+8|0;m=j;n=k+8|0;f[n>>2]=0;f[n+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=a;f[l>>2]=f[b>>2];f[l+4>>2]=f[b+4>>2];f[m>>2]=f[c>>2];f[m+4>>2]=f[c+4>>2];P8(k,l,m,d,e,g,h,i,8,0);u=j;return}function Qn(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;m=j+8|0;f[m>>2]=0;f[m+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];P8(j,k,l,d,e,g,h,1,8,0);u=i;return}function Rn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+16|0;h=g;i=h+8|0;f[i>>2]=0;f[i+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;Q8(h,b,c,d,e);u=g;return}function Sn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=g+8|0;f[h>>2]=0;f[h+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=a;Q8(g,b,c,d,8);u=e;return}function Tn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=e+8|0;f[g>>2]=0;f[g+4>>2]=0;f[e>>2]=50397184;f[e+4>>2]=a;Q8(e,b,c,1,8);u=d;return}function Un(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0;i=u;u=u+16|0;j=i+8|0;k=i;f[j>>2]=f[a>>2];f[j+4>>2]=f[a+4>>2];f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];n8(j,k,c,d,e,g,h);u=i;return}function Vn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;Rfa(d,e);u=c;return}function Wn(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];bka(j,k,l,m,e,g,h);u=i;return}function Xn(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+40|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];p[m>>3]=1797693134862315708145274.0e284;p[m+8>>3]=1797693134862315708145274.0e284;p[m+16>>3]=1797693134862315708145274.0e284;p[m+24>>3]=1797693134862315708145274.0e284;bka(i,j,k,l,e,g,m);u=h;return}function Yn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+72|0;i=g+56|0;j=g+40|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];p[l>>3]=1797693134862315708145274.0e284;p[l+8>>3]=1797693134862315708145274.0e284;p[l+16>>3]=1797693134862315708145274.0e284;p[l+24>>3]=1797693134862315708145274.0e284;bka(h,i,j,k,e,0,l);u=g;return}function Zn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+96|0;g=e+72|0;h=e+56|0;i=e+40|0;j=e+32|0;k=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];p[k>>3]=1797693134862315708145274.0e284;p[k+8>>3]=1797693134862315708145274.0e284;p[k+16>>3]=1797693134862315708145274.0e284;p[k+24>>3]=1797693134862315708145274.0e284;bka(g,h,i,j,1,0,k);u=e;return}function _n(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+96|0;e=d+72|0;g=d+56|0;h=d+40|0;i=d+32|0;j=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;f[i>>2]=-1;f[i+4>>2]=-1;p[j>>3]=1797693134862315708145274.0e284;p[j+8>>3]=1797693134862315708145274.0e284;p[j+16>>3]=1797693134862315708145274.0e284;p[j+24>>3]=1797693134862315708145274.0e284;bka(e,g,h,i,1,0,j);u=d;return}function $n(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;uva(a,g,h,d);u=e;return}function ao(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;mN(d,e);u=c;return}function bo(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=d;f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];hfa(j,k,c,l,m,g,h);u=i;return}function co(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+64|0;i=h+40|0;j=h+24|0;k=h+8|0;l=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];hfa(i,j,c,k,l,g,4);u=h;return}function eo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+40|0;i=g+24|0;j=g+8|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];hfa(h,i,c,j,k,0.0,4);u=g;return}function fo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+40|0;h=e+24|0;i=e+8|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=d;f[j>>2]=-1;f[j+4>>2]=-1;hfa(g,h,c,i,j,0.0,4);u=e;return}function go(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+64|0;i=h+40|0;j=h+24|0;k=h+8|0;l=h;m=i+8|0;f[m>>2]=0;f[m+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33882112;f[j+4>>2]=b;b=k+8|0;f[b>>2]=0;f[b+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=c;f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];g7(i,j,k,d,e,l);u=h;return}function ho(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+64|0;h=g+40|0;i=g+24|0;j=g+8|0;k=g;l=h+8|0;f[l>>2]=0;f[l+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33882112;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;f[k>>2]=0;f[k+4>>2]=0;g7(h,i,j,d,e,k);u=g;return}function io(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0.0;h=u;u=u+80|0;i=h;j=h+64|0;k=h+48|0;l=h+32|0;m=h+16|0;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;b=l+8|0;f[b>>2]=0;f[b+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=c;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=g;f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];n=+$ua(j,k,l,d,i,m);u=h;return +n}function jo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0;g=u;u=u+80|0;h=g+16|0;i=g+64|0;j=g+48|0;k=g+32|0;l=g;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;b=k+8|0;f[b>>2]=0;f[b+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=c;f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];f[l+8>>2]=f[e+8>>2];f[l+12>>2]=f[e+12>>2];e=fT()|0;f[h>>2]=f[l>>2];f[h+4>>2]=f[l+4>>2];f[h+8>>2]=f[l+8>>2];f[h+12>>2]=f[l+12>>2];m=+$ua(i,j,k,d,h,e);u=g;return +m}function ko(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0.0;e=u;u=u+80|0;g=e+16|0;h=e+64|0;i=e+48|0;j=e+32|0;k=e;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=c;f[k>>2]=3;f[k+4>>2]=50;p[k+8>>3]=.001;c=fT()|0;f[g>>2]=f[k>>2];f[g+4>>2]=f[k+4>>2];f[g+8>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];l=+$ua(h,i,j,d,g,c);u=e;return +l}function lo(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0.0;d=u;u=u+80|0;e=d+16|0;g=d+64|0;h=d+48|0;i=d+32|0;j=d;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=c;f[j>>2]=3;f[j+4>>2]=50;p[j+8>>3]=.001;c=fT()|0;f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];k=+$ua(g,h,i,2,e,c);u=d;return +k}function mo(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;qna(a,d);u=c;return}function no(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;aha(i,j,c,d,e,g);u=h;return}function oo(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;iL(e,g,c);u=d;return}function po(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+48|0;k=i+32|0;l=i+16|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=d;d=m+8|0;f[d>>2]=0;f[d+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=g;jO(j,k,c,l,e,m,h);u=i;return}function qo(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+64|0;i=h+48|0;j=h+32|0;k=h+16|0;l=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;d=l+8|0;f[d>>2]=0;f[d+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=g;jO(i,j,c,k,e,l,0);u=h;return}function ro(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;$ga(a,e,g);u=d;return}function so(a){a=a|0;return RM(a)|0}function to(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;_ga(a,e,g);u=d;return}function uo(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];Xga(a,g,c,d);u=e;return}function vo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e+8|0;h=e;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];f[h>>2]=f[d>>2];f[h+4>>2]=f[d+4>>2];$ja(a,b,g,h);u=e;return}function wo(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];f[g>>2]=-1;f[g+4>>2]=-1;$ja(a,b,e,g);u=d;return}function xo(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;j=+j;var k=0,l=0,m=0,n=0;k=u;u=u+48|0;l=k+32|0;m=k+16|0;n=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;a=m+8|0;f[a>>2]=0;f[a+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=b;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=g;f9(l,m,c,d,e,n,h,i,j);u=k;return}function yo(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+48|0;k=j+32|0;l=j+16|0;m=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=g;f9(k,l,c,d,e,m,h,i,.04);u=j;return}function zo(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=g;f9(j,k,c,d,e,l,h,0,.04);u=i;return}function Ao(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=g;f9(i,j,c,d,e,k,3,0,.04);u=h;return}function Bo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f9(h,i,c,d,e,fT()|0,3,0,.04);u=g;return}function Co(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;var l=0,m=0,n=0,o=0;l=u;u=u+48|0;m=l+32|0;n=l+16|0;o=l;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=a;a=n+8|0;f[a>>2]=0;f[a+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=b;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=g;Y8(m,n,c,d,e,o,h,i,j,k);u=l;return}function Do(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;k=u;u=u+48|0;l=k+32|0;m=k+16|0;n=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;a=m+8|0;f[a>>2]=0;f[a+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=b;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=g;Y8(l,m,c,d,e,n,h,i,j,.04);u=k;return}function Eo(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+48|0;k=j+32|0;l=j+16|0;m=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=g;Y8(k,l,c,d,e,m,h,i,0,.04);u=j;return}function Fo(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+80|0;j=i+64|0;k=i+48|0;l=i+16|0;m=i+32|0;n=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=b;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[l+8>>2]=f[c+8>>2];f[l+12>>2]=f[c+12>>2];c=m+8|0;f[c>>2]=0;f[c+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=d;d=n+8|0;f[d>>2]=0;f[d+4>>2]=0;f[n>>2]=50397184;f[n+4>>2]=e;ofa(j,k,l,m,n,g,h);u=i;return}function Go(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+80|0;i=h+64|0;j=h+48|0;k=h+16|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=b;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];f[k+8>>2]=f[c+8>>2];f[k+12>>2]=f[c+12>>2];c=l+8|0;f[c>>2]=0;f[c+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=d;d=m+8|0;f[d>>2]=0;f[d+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=e;ofa(i,j,k,l,m,g,2);u=h;return}function Ho(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;Csa(a,b,c,d);return}function Io(a,b,c){a=a|0;b=b|0;c=c|0;Csa(a,b,c,.2);return}function Jo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=17104896;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;hT(d,e);u=c;return}function Ko(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;zwa(a,e,c);u=d;return}function Lo(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g+4|0;k=g;f[h>>2]=0;f[h+4>>2]=0;l=a+11|0;m=b[l>>0]|0;n=m<<24>>24<0?f[a+4>>2]|0:m&255;if(n|0){m=c$(h,n)|0;K1a(m|0,((b[l>>0]|0)<0?f[a>>2]|0:a)|0,n|0)|0}f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;c=f[e>>2]|0;f[k>>2]=c;Qd(c|0);km(j,k);c=Fwa(h,i,d,j)|0;d=f[j>>2]|0;if(!d){o=f[k>>2]|0;ce(o|0);d$(h);u=g;return c|0}i=j+4|0;j=f[i>>2]|0;if((j|0)!=(d|0))f[i>>2]=j+(~((j+-4-d|0)>>>2)<<2);PYa(d);o=f[k>>2]|0;ce(o|0);d$(h);u=g;return c|0}function Mo(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g>>2]=0;f[g+4>>2]=0;j=a+11|0;k=b[j>>0]|0;l=k<<24>>24<0?f[a+4>>2]|0:k&255;if(l|0){k=c$(g,l)|0;K1a(k|0,((b[j>>0]|0)<0?f[a>>2]|0:a)|0,l|0)|0}f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;f[i>>2]=0;c=i+4|0;f[c>>2]=0;f[i+8>>2]=0;l=Fwa(g,h,d,i)|0;d=f[i>>2]|0;if(!d){d$(g);u=e;return l|0}i=f[c>>2]|0;if((i|0)!=(d|0))f[c>>2]=i+(~((i+-4-d|0)>>>2)<<2);PYa(d);d$(g);u=e;return l|0}function No(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;c=j+8|0;f[c>>2]=0;f[c+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=d;xI(g,h,i,j);u=e;return}function Oo(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=u;u=u+112|0;k=j+88|0;l=j+72|0;m=j+56|0;n=j+40|0;o=j+16|0;p=j+24|0;q=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=c;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=d;f[o>>2]=f[e>>2];f[o+4>>2]=f[e+4>>2];e=p+8|0;f[e>>2]=0;f[e+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=h;h=q+8|0;f[h>>2]=0;f[h+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=i;oqa(k,l,m,n,o,g,p,q);u=j;return}function Po(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;bqa(e,g,c);u=d;return}function Qo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;bqa(d,e,-1);u=c;return}function Ro(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;cqa(h,i,j,d,e);u=g;return}function So(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;cqa(g,h,i,d,-1);u=e;return}function To(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;cqa(e,g,h,-1,-1);u=d;return}function Uo(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;h=+_M(e,g,c);u=d;return +h}function Vo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;g=+_M(d,e,0);u=c;return +g}function Wo(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[c+8>>2]=0;f[c+12>>2]=0;f[c>>2]=16842752;f[c+4>>2]=a;a=x7(c)|0;u=b;return a|0}function Xo(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0;i=u;u=u+64|0;j=i;k=i+48|0;l=i+32|0;m=i+16|0;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=c;c=m+8|0;f[c>>2]=0;f[c+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=h;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];f[j+8>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];n=+SM(k,b,l,j,e,g,m);u=i;return +n}function Yo(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0.0;h=u;u=u+64|0;i=h+16|0;j=h+48|0;k=h+32|0;l=h;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=c;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];f[l+8>>2]=f[d+8>>2];f[l+12>>2]=f[d+12>>2];d=fT()|0;f[i>>2]=f[l>>2];f[i+4>>2]=f[l+4>>2];f[i+8>>2]=f[l+8>>2];f[i+12>>2]=f[l+12>>2];m=+SM(j,b,k,i,e,g,d);u=h;return +m}function Zo(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;m=j+8|0;f[m>>2]=0;f[m+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];t8(j,k,l,d,e,g,h);u=i;return}function _o(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;l=i+8|0;f[l>>2]=0;f[l+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=a;f[j>>2]=f[b>>2];f[j+4>>2]=f[b+4>>2];f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];t8(i,j,k,d,e,g,0);u=h;return}function $o(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;k=h+8|0;f[k>>2]=0;f[k+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;f[i>>2]=f[b>>2];f[i+4>>2]=f[b+4>>2];f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];t8(h,i,j,d,e,8,0);u=g;return}function ap(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;j=g+8|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=a;f[h>>2]=f[b>>2];f[h+4>>2]=f[b+4>>2];f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];t8(g,h,i,d,1,8,0);u=e;return}function bp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;nN(d,e);u=c;return}function cp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;jN(e,g,h);u=d;return}function dp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0.0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;i=+iha(g,h,c,d);u=e;return +i}function ep(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=e;fqa(h,i,j,d,k);u=g;return}function fp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;fqa(g,h,i,d,fT()|0);u=e;return}function gp(a,b,c){a=a|0;b=b|0;c=c|0;RG(a,b,c);return}function hp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;hZ(a,e,g);u=d;return}function ip(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;hZ(a,d,fT()|0);u=c;return}function jp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;iZ(g,h,i,j);u=e;return}function kp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;iZ(e,g,h,fT()|0);u=d;return}function lp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;Ipa(e,g,c);u=d;return}function mp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=17104896;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;NI(d,e);u=c;return}function np(a,b,c){a=a|0;b=b|0;c=c|0;SG(a,b,c);return}function op(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;hna(a,d);u=c;return}function pp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d+4|0;i=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=17104896;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=50659328;f[g+4>>2]=b;b=f[c>>2]|0;f[i>>2]=b;Qd(b|0);km(h,i);SI(e,g,h);g=f[h>>2]|0;if(!g){j=f[i>>2]|0;ce(j|0);u=d;return}e=h+4|0;h=f[e>>2]|0;if((h|0)!=(g|0))f[e>>2]=h+(~((h+-4-g|0)>>>2)<<2);PYa(g);j=f[i>>2]|0;ce(j|0);u=d;return}function qp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;kha(a,e,c);u=d;return}function rp(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;kha(a,d,0);u=c;return}function sp(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;j=u;u=u+64|0;k=j+40|0;l=j+24|0;m=j+8|0;n=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=d;f[n>>2]=f[e>>2];f[n+4>>2]=f[e+4>>2];eka(k,l,c,m,n,g,h,i);u=j;return}function tp(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+96|0;j=i+72|0;k=i+56|0;l=i+40|0;m=i+32|0;n=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=d;f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];p[n>>3]=1797693134862315708145274.0e284;p[n+8>>3]=1797693134862315708145274.0e284;p[n+16>>3]=1797693134862315708145274.0e284;p[n+24>>3]=1797693134862315708145274.0e284;eka(j,k,c,l,m,g,h,n);u=i;return}function up(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+40|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];p[m>>3]=1797693134862315708145274.0e284;p[m+8>>3]=1797693134862315708145274.0e284;p[m+16>>3]=1797693134862315708145274.0e284;p[m+24>>3]=1797693134862315708145274.0e284;eka(i,j,c,k,l,g,0,m);u=h;return}function vp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+72|0;i=g+56|0;j=g+40|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];p[l>>3]=1797693134862315708145274.0e284;p[l+8>>3]=1797693134862315708145274.0e284;p[l+16>>3]=1797693134862315708145274.0e284;p[l+24>>3]=1797693134862315708145274.0e284;eka(h,i,c,j,k,1,0,l);u=g;return}function wp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+96|0;g=e+72|0;h=e+56|0;i=e+40|0;j=e+32|0;k=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=d;f[j>>2]=-1;f[j+4>>2]=-1;p[k>>3]=1797693134862315708145274.0e284;p[k+8>>3]=1797693134862315708145274.0e284;p[k+16>>3]=1797693134862315708145274.0e284;p[k+24>>3]=1797693134862315708145274.0e284;eka(g,h,c,i,j,1,0,k);u=e;return}function xp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;LH(h,i,j,d,e);u=g;return}function yp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;LH(g,h,i,d,-1);u=e;return}function zp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;LH(e,g,h,1.0,-1);u=d;return}function Ap(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;h=+zZ(e,b,g);u=d;return +h}function Bp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;e=+zZ(d,b,fT()|0);u=c;return +e}function Cp(a){a=a|0;var b=0,c=0,d=0.0;b=u;u=u+16|0;c=b;f[c+8>>2]=0;f[c+12>>2]=0;f[c>>2]=16842752;f[c+4>>2]=a;d=+zZ(c,4,fT()|0);u=b;return +d}function Dp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0.0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=d;j=+e_(g,h,c,i);u=e;return +j}function Ep(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;h=+e_(e,g,c,fT()|0);u=d;return +h}function Fp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;g=+e_(d,e,4,fT()|0);u=c;return +g}function Gp(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=h;TK(j,k,c,d,e,g,l);u=i;return}function Hp(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=b;TK(i,j,c,d,e,g,fT()|0);u=h;return}function Ip(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=b;TK(h,i,c,d,e,-1,fT()|0);u=g;return}function Jp(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=b;TK(g,h,c,d,4,-1,fT()|0);u=e;return}function Kp(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=b;TK(e,g,c,0.0,4,-1,fT()|0);u=d;return}function Lp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=50397184;f[e+4>>2]=b;TK(d,e,1.0,0.0,4,-1,fT()|0);u=c;return}function Mp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;zO(e,g,h);u=d;return}function Np(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+8|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];h=+jfa(e,g,c);u=d;return +h}function Op(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;c=k+8|0;f[c>>2]=0;f[c+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=d;lN(h,i,j,k,e);u=g;return}function Pp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;c=j+8|0;f[c>>2]=0;f[c+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=d;lN(g,h,i,j,0);u=e;return}function Qp(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;oN(e,b,g);u=d;return}function Rp(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0;l=u;u=u+64|0;m=l+48|0;n=l+40|0;o=l+32|0;q=l;r=m+8|0;f[r>>2]=0;f[r+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=a;f[n>>2]=0;f[n+4>>2]=0;a=c+11|0;r=b[a>>0]|0;s=r<<24>>24<0?f[c+4>>2]|0:r&255;if(s|0){r=c$(n,s)|0;K1a(r|0,((b[a>>0]|0)<0?f[c>>2]|0:c)|0,s|0)|0}f[o>>2]=f[d>>2];f[o+4>>2]=f[d+4>>2];p[q>>3]=+p[h>>3];p[q+8>>3]=+p[h+8>>3];p[q+16>>3]=+p[h+16>>3];p[q+24>>3]=+p[h+24>>3];R8(m,n,o,e,g,q,i,j,k);d$(n);u=l;return}function Sp(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0;k=u;u=u+64|0;l=k+48|0;m=k+40|0;n=k+32|0;o=k;q=l+8|0;f[q>>2]=0;f[q+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=a;f[m>>2]=0;f[m+4>>2]=0;a=c+11|0;q=b[a>>0]|0;r=q<<24>>24<0?f[c+4>>2]|0:q&255;if(r|0){q=c$(m,r)|0;K1a(q|0,((b[a>>0]|0)<0?f[c>>2]|0:c)|0,r|0)|0}f[n>>2]=f[d>>2];f[n+4>>2]=f[d+4>>2];p[o>>3]=+p[h>>3];p[o+8>>3]=+p[h+8>>3];p[o+16>>3]=+p[h+16>>3];p[o+24>>3]=+p[h+24>>3];R8(l,m,n,e,g,o,i,j,0);d$(m);u=k;return}function Tp(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0;j=u;u=u+64|0;k=j+48|0;l=j+40|0;m=j+32|0;n=j;o=k+8|0;f[o>>2]=0;f[o+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=a;f[l>>2]=0;f[l+4>>2]=0;a=c+11|0;o=b[a>>0]|0;q=o<<24>>24<0?f[c+4>>2]|0:o&255;if(q|0){o=c$(l,q)|0;K1a(o|0,((b[a>>0]|0)<0?f[c>>2]|0:c)|0,q|0)|0}f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];p[n>>3]=+p[h>>3];p[n+8>>3]=+p[h+8>>3];p[n+16>>3]=+p[h+16>>3];p[n+24>>3]=+p[h+24>>3];R8(k,l,m,e,g,n,i,8,0);d$(l);u=j;return}function Up(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+64|0;j=i+48|0;k=i+40|0;l=i+32|0;m=i;n=j+8|0;f[n>>2]=0;f[n+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k>>2]=0;f[k+4>>2]=0;a=c+11|0;n=b[a>>0]|0;o=n<<24>>24<0?f[c+4>>2]|0:n&255;if(o|0){n=c$(k,o)|0;K1a(n|0,((b[a>>0]|0)<0?f[c>>2]|0:c)|0,o|0)|0}f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];p[m>>3]=+p[h>>3];p[m+8>>3]=+p[h+8>>3];p[m+16>>3]=+p[h+16>>3];p[m+24>>3]=+p[h+24>>3];R8(j,k,l,e,g,m,1,8,0);d$(k);u=i;return}function Vp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;fka(g,h,c,d);u=e;return}function Wp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;fka(e,g,c,4);u=d;return}function Xp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+48|0;d=c+24|0;e=c+8|0;g=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;f[g>>2]=0;f[g+4>>2]=0;fka(d,e,g,4);u=c;return}function Yp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;lka(g,h,c,d);u=e;return}function Zp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;lka(e,g,c,4);u=d;return}function _p(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+48|0;d=c+24|0;e=c+8|0;g=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;f[g>>2]=0;f[g+4>>2]=0;lka(d,e,g,4);u=c;return}function $p(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;i=e+8|0;f[i>>2]=0;f[i+4>>2]=0;f[e>>2]=50397184;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;QY(e,g,h);u=d;return}function aq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;i=e+8|0;f[i>>2]=0;f[i+4>>2]=0;f[e>>2]=50397184;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;PY(e,g,h);u=d;return}function bq(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;m=j+8|0;f[m>>2]=0;f[m+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];N8(j,k,l,d,e,g,h);u=i;return}function cq(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;l=i+8|0;f[l>>2]=0;f[l+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=a;f[j>>2]=f[b>>2];f[j+4>>2]=f[b+4>>2];f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];N8(i,j,k,d,e,g,0);u=h;return}function dq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;k=h+8|0;f[k>>2]=0;f[k+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;f[i>>2]=f[b>>2];f[i+4>>2]=f[b+4>>2];f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];N8(h,i,j,d,e,8,0);u=g;return}function eq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;j=g+8|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=a;f[h>>2]=f[b>>2];f[h+4>>2]=f[b+4>>2];f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];N8(g,h,i,d,1,8,0);u=e;return}function fq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;nT(h,i,c,d,e);u=g;return}function gq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;nT(g,h,c,d,-1);u=e;return}function hq(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+48|0;k=i+32|0;l=i+16|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=d;mga(j,k,l,m,e,g,h);u=i;return}function iq(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+80|0;j=h+64|0;k=h+48|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=d;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;mga(i,j,k,l,e,g,m);u=h;return}function jq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+80|0;i=g+64|0;j=g+48|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;mga(h,i,j,k,e,0,l);u=g;return}function kq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=d;kL(g,b,c,h);u=e;return}function lq(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+24|0;j=h+8|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];fna(i,j,k,d,e,g);u=h;return}function mq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+24|0;i=g+8|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];fna(h,i,j,d,e,1);u=g;return}function nq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+24|0;h=e+8|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];fna(g,h,i,d,0.0,1);u=e;return}function oq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+24|0;g=d+8|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];fna(e,g,h,0.0,0.0,1);u=d;return}function pq(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=u;u=u+80|0;k=j+56|0;l=j+40|0;m=j+24|0;n=j+8|0;o=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=d;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=e;f[o>>2]=f[g>>2];f[o+4>>2]=f[g+4>>2];ifa(k,l,c,m,n,o,h,i);u=j;return}function qq(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+80|0;j=i+56|0;k=i+40|0;l=i+24|0;m=i+8|0;n=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=d;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=e;f[n>>2]=f[g>>2];f[n+4>>2]=f[g+4>>2];ifa(j,k,c,l,m,n,h,4);u=i;return}function rq(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+80|0;i=h+56|0;j=h+40|0;k=h+24|0;l=h+8|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=e;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];ifa(i,j,c,k,l,m,0.0,4);u=h;return}function sq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+80|0;h=g+56|0;i=g+40|0;j=g+24|0;k=g+8|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=e;f[l>>2]=-1;f[l+4>>2]=-1;ifa(h,i,c,j,k,l,0.0,4);u=g;return}function tq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[d>>2]=50397184;f[d+4>>2]=a;kT(d,b);u=c;return}function uq(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+48|0;c=b+32|0;d=b;e=c+8|0;f[e>>2]=0;f[e+4>>2]=0;f[c>>2]=50397184;f[c+4>>2]=a;p[d>>3]=1.0;a=d+8|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;kT(c,d);u=b;return}function vq(a){a=a|0;OY(a);return}function wq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;c=hN(g,h,i,d)|0;u=e;return c|0}function xq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;c=hN(e,g,h,0)|0;u=d;return c|0}function yq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;h=+BN(e,g,c);u=d;return +h}function zq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;g=+BN(d,e,300);u=c;return +g}function Aq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33882112;f[e+4>>2]=b;GI(d,e);u=c;return}function Bq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;wN(d,e);u=c;return}function Cq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;hH(h,i,j,k,e);u=g;return}function Dq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;hH(g,h,i,j,-1);u=e;return}function Eq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;hH(e,g,h,fT()|0,-1);u=d;return}function Fq(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var g=0,h=0,i=0,j=0.0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;j=+gqa(h,i,c,d,e);u=g;return +j}function Gq(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;lT(a,d);u=c;return}function Hq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;kO(e,g,h);u=d;return}function Iq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;mS(d,e);u=c;return}function Jq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+80|0;h=g+64|0;i=g+48|0;j=g+32|0;k=g+16|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=e;tqa(h,i,j,k,l);u=g;return}function Kq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;tqa(g,h,i,j,fT()|0);u=e;return}function Lq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=17104896;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;jT(d,e);u=c;return}function Mq(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];Qga(j,k,l,m,e,g,h);u=i;return}function Nq(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+40|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;Qga(i,j,k,l,e,g,m);u=h;return}function Oq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+72|0;i=g+56|0;j=g+40|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;Qga(h,i,j,k,e,0,l);u=g;return}function Pq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+96|0;g=e+72|0;h=e+56|0;i=e+40|0;j=e+32|0;k=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;Qga(g,h,i,j,1,0,k);u=e;return}function Qq(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];Wga(j,k,l,m,e,g,h);u=i;return}function Rq(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+40|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;Wga(i,j,k,l,e,g,m);u=h;return}function Sq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+72|0;i=g+56|0;j=g+40|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;Wga(h,i,j,k,e,0,l);u=g;return}function Tq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+96|0;g=e+72|0;h=e+56|0;i=e+40|0;j=e+32|0;k=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;Wga(g,h,i,j,1,0,k);u=e;return}function Uq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=50397184;f[e+4>>2]=b;ina(d,e);u=c;return}function Vq(a,b){a=a|0;b=b|0;yAa(a,b);return}function Wq(a){a=a|0;var b=0,c=0;b=u;u=u+80|0;c=b;xAa(c);yAa(a,c);u=b;return}function Xq(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e+8|0;h=e;i=f[(f[a>>2]|0)+20>>2]|0;f[g>>2]=0;f[g+4>>2]=0;j=c+11|0;k=b[j>>0]|0;l=k<<24>>24<0?f[c+4>>2]|0:k&255;if(l|0){k=c$(g,l)|0;K1a(k|0,((b[j>>0]|0)<0?f[c>>2]|0:c)|0,l|0)|0}f[h>>2]=0;f[h+4>>2]=0;l=d+11|0;c=b[l>>0]|0;j=c<<24>>24<0?f[d+4>>2]|0:c&255;if(!j){m=ui[i&127](a,g,h)|0;d$(h);d$(g);u=e;return m|0}c=c$(h,j)|0;K1a(c|0,((b[l>>0]|0)<0?f[d>>2]|0:d)|0,j|0)|0;m=ui[i&127](a,g,h)|0;d$(h);d$(g);u=e;return m|0}function Yq(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d+8|0;g=d;h=f[(f[a>>2]|0)+20>>2]|0;f[e>>2]=0;f[e+4>>2]=0;i=c+11|0;j=b[i>>0]|0;k=j<<24>>24<0?f[c+4>>2]|0:j&255;if(k|0){j=c$(e,k)|0;K1a(j|0,((b[i>>0]|0)<0?f[c>>2]|0:c)|0,k|0)|0}f[g>>2]=0;f[g+4>>2]=0;k=ui[h&127](a,e,g)|0;d$(g);d$(e);u=d;return k|0}function Zq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=f[(f[a>>2]|0)+8>>2]|0;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;Gh[e&511](a,d);u=c;return}function _q(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=u;u=u+32|0;m=l+16|0;n=l+8|0;o=l;p=f[(f[a>>2]|0)+44>>2]|0;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=b;f[n>>2]=f[g>>2];f[n+4>>2]=f[g+4>>2];f[o>>2]=f[h>>2];f[o+4>>2]=f[h+4>>2];zg[p&3](a,m,c,d,e,n,o,i,j,k);u=l;return}function $q(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;j=+j;var k=0,l=0,m=0,n=0,o=0;k=u;u=u+32|0;l=k+16|0;m=k+8|0;n=k;o=f[(f[a>>2]|0)+44>>2]|0;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=b;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[n>>2]=f[h>>2];f[n+4>>2]=f[h+4>>2];zg[o&3](a,l,c,d,e,m,n,i,j,0);u=k;return}function ar(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;var j=0,k=0,l=0,m=0,n=0;j=u;u=u+32|0;k=j+16|0;l=j+8|0;m=j;n=f[(f[a>>2]|0)+44>>2]|0;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];f[m>>2]=f[h>>2];f[m+4>>2]=f[h+4>>2];zg[n&3](a,k,c,d,e,l,m,i,2.0,0);u=j;return}function br(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;m=f[(f[a>>2]|0)+44>>2]|0;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k>>2]=f[g>>2];f[k+4>>2]=f[g+4>>2];f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];zg[m&3](a,j,c,d,e,k,l,1.05,2.0,0);u=i;return}function cr(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;l=f[(f[a>>2]|0)+44>>2]|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];f[k>>2]=0;f[k+4>>2]=0;zg[l&3](a,i,c,d,e,j,k,1.05,2.0,0);u=h;return}function dr(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;k=f[(f[a>>2]|0)+44>>2]|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i>>2]=0;f[i+4>>2]=0;f[j>>2]=0;f[j+4>>2]=0;zg[k&3](a,h,c,d,e,i,j,1.05,2.0,0);u=g;return}function er(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;j=f[(f[a>>2]|0)+44>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h>>2]=0;f[h+4>>2]=0;f[i>>2]=0;f[i+4>>2]=0;zg[j&3](a,g,c,d,0.0,h,i,1.05,2.0,0);u=e;return}function fr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e;i=f[(f[a>>2]|0)+32>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;vh[i&63](a,g,h,d);u=e;return}function gr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=f[(f[a>>2]|0)+32>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;vh[h&63](a,e,g,-1.0);u=d;return}function hr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;e=f[(f[a>>2]|0)+36>>2]|0;g=d+8|0;f[g>>2]=0;f[g+4>>2]=0;f[d>>2]=33619968;f[d+4>>2]=b;Gh[e&511](a,d);u=c;return}function ir(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;Vua(a,b,c,d);return}function jr(a,b,c){a=a|0;b=b|0;c=+c;Vua(a,b,c,1);return}function kr(a,b){a=a|0;b=b|0;Vua(a,b,16.0,1);return}function lr(a){a=a|0;Vua(a,500,16.0,1);return}function mr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e;i=f[(f[a>>2]|0)+32>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;vh[i&63](a,g,h,d);u=e;return}function nr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=f[(f[a>>2]|0)+32>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;vh[h&63](a,e,g,-1.0);u=d;return}function or(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=f[(f[a>>2]|0)+44>>2]|0;f[d>>2]=f[b>>2];f[d+4>>2]=f[b+4>>2];Gh[e&511](a,d);u=c;return}function pr(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];I1(a,b,e);u=d;return}function qr(a,b){a=a|0;b=+b;var c=0,d=0;c=u;u=u+16|0;d=c;f[d>>2]=8;f[d+4>>2]=8;I1(a,b,d);u=c;return}function rr(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[c>>2]=8;f[c+4>>2]=8;I1(a,40.0,c);u=b;return}function sr(a,b){a=a|0;b=+b;Dh[f[(f[a>>2]|0)+36>>2]&31](a,b);return}function tr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=f[(f[a>>2]|0)+32>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;fi[h&255](a,e,g);u=d;return}function ur(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;Gh[f[(f[c>>2]|0)+28>>2]&511](e,c);c=f[e>>2]|0;g=f[e+4>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(g>>>0>4294967279)WYa(a);if(g>>>0<11){b[a+11>>0]=g;if(!g){h=a;i=h+g|0;b[i>>0]=0;d$(e);u=d;return}else j=a}else{k=g+16&-16;l=NYa(k)|0;f[a>>2]=l;f[a+8>>2]=k|-2147483648;f[a+4>>2]=g;j=l}K1a(j|0,c|0,g|0)|0;h=j;i=h+g|0;b[i>>0]=0;d$(e);u=d;return}function vr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e;i=f[(f[a>>2]|0)+32>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=d;Ah[i&255](a,g,c,h);u=e;return}function wr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=f[(f[a>>2]|0)+32>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;b=fT()|0;Ah[g&255](a,e,c,b);u=d;return}function xr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e;i=f[(f[a>>2]|0)+40>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=d;Ah[i&255](a,g,c,h);u=e;return}function yr(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;l=f[(f[a>>2]|0)+48>>2]|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;c=k+8|0;f[c>>2]=0;f[c+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=e;bh[l&255](a,i,j,d,k,g);u=h;return}function zr(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;k=f[(f[a>>2]|0)+48>>2]|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;c=j+8|0;f[c>>2]=0;f[c+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=e;bh[k&255](a,h,i,d,j,0);u=g;return}function Ar(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;g=c+11|0;h=b[g>>0]|0;i=h<<24>>24<0?f[c+4>>2]|0:h&255;if(!i){bCa(a,e);d$(e);u=d;return}h=c$(e,i)|0;K1a(h|0,((b[g>>0]|0)<0?f[c>>2]|0:c)|0,i|0)|0;bCa(a,e);d$(e);u=d;return}function Br(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=e;ZBa(a,h,i,d,j);u=g;return}function Cr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;ZBa(a,g,h,d,fT()|0);u=e;return}function Dr(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;g=c+11|0;h=b[g>>0]|0;i=h<<24>>24<0?f[c+4>>2]|0:h&255;if(!i){j=Qsa(a,e)|0;d$(e);u=d;return j|0}h=c$(e,i)|0;K1a(h|0,((b[g>>0]|0)<0?f[c>>2]|0:c)|0,i|0)|0;j=Qsa(a,e)|0;d$(e);u=d;return j|0}function Er(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;k=u;u=u+32|0;l=k+16|0;m=k+8|0;n=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=b;f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];f[n>>2]=f[j>>2];f[n+4>>2]=f[j+4>>2];Xsa(a,l,c,d,e,g,h,m,n);u=k;return}function Fr(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+32|0;k=j+16|0;l=j+8|0;m=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l>>2]=f[i>>2];f[l+4>>2]=f[i+4>>2];f[m>>2]=0;f[m+4>>2]=0;Xsa(a,k,c,d,e,g,h,l,m);u=j;return}function Gr(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k>>2]=0;f[k+4>>2]=0;f[l>>2]=0;f[l+4>>2]=0;Xsa(a,j,c,d,e,g,h,k,l);u=i;return}function Hr(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j>>2]=0;f[j+4>>2]=0;f[k>>2]=0;f[k+4>>2]=0;Xsa(a,i,c,d,e,g,0,j,k);u=h;return}function Ir(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i>>2]=0;f[i+4>>2]=0;f[j>>2]=0;f[j+4>>2]=0;Xsa(a,h,c,d,e,3,0,i,j);u=g;return}function Jr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h>>2]=0;f[h+4>>2]=0;f[i>>2]=0;f[i+4>>2]=0;Xsa(a,g,c,d,1.1,3,0,h,i);u=e;return}function Kr(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0;m=u;u=u+32|0;n=m+16|0;o=m+8|0;p=m;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=b;f[o>>2]=f[j>>2];f[o+4>>2]=f[j+4>>2];f[p>>2]=f[k>>2];f[p+4>>2]=f[k+4>>2];Ysa(a,n,c,d,e,g,h,i,o,p,l);u=m;return}function Lr(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0;l=u;u=u+32|0;m=l+16|0;n=l+8|0;o=l;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=b;f[n>>2]=f[j>>2];f[n+4>>2]=f[j+4>>2];f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];Ysa(a,m,c,d,e,g,h,i,n,o,0);u=l;return}function Mr(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;k=u;u=u+32|0;l=k+16|0;m=k+8|0;n=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=b;f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];f[n>>2]=0;f[n+4>>2]=0;Ysa(a,l,c,d,e,g,h,i,m,n,0);u=k;return}function Nr(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+32|0;k=j+16|0;l=j+8|0;m=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l>>2]=0;f[l+4>>2]=0;f[m>>2]=0;f[m+4>>2]=0;Ysa(a,k,c,d,e,g,h,i,l,m,0);u=j;return}function Or(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k>>2]=0;f[k+4>>2]=0;f[l>>2]=0;f[l+4>>2]=0;Ysa(a,j,c,d,e,g,h,0,k,l,0);u=i;return}function Pr(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j>>2]=0;f[j+4>>2]=0;f[k>>2]=0;f[k+4>>2]=0;Ysa(a,i,c,d,e,g,3,0,j,k,0);u=h;return}function Qr(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i>>2]=0;f[i+4>>2]=0;f[j>>2]=0;f[j+4>>2]=0;Ysa(a,h,c,d,e,1.1,3,0,i,j,0);u=g;return}function Rr(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+32|0;k=j+16|0;l=j+8|0;m=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];Wsa(a,k,c,d,e,g,l,m);u=j;return}function Sr(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[l>>2]=0;f[l+4>>2]=0;Wsa(a,j,c,d,e,g,k,l);u=i;return}function Tr(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j>>2]=0;f[j+4>>2]=0;f[k>>2]=0;f[k+4>>2]=0;Wsa(a,i,c,d,e,g,j,k);u=h;return}function Ur(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i>>2]=0;f[i+4>>2]=0;f[j>>2]=0;f[j+4>>2]=0;Wsa(a,h,c,d,e,0,i,j);u=g;return}function Vr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h>>2]=0;f[h+4>>2]=0;f[i>>2]=0;f[i+4>>2]=0;Wsa(a,g,c,d,3,0,h,i);u=e;return}function Wr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g>>2]=0;f[g+4>>2]=0;f[h>>2]=0;f[h+4>>2]=0;Wsa(a,e,c,1.1,3,0,g,h);u=d;return}function Xr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;NAa(a,b,c,d);return}function Yr(a,b,c){a=a|0;b=b|0;c=c|0;NAa(a,b,c,2);return}function Zr(a,b){a=a|0;b=b|0;NAa(a,b,1,2);return}function _r(a){a=a|0;NAa(a,10,1,2);return}function $r(a,b){a=a|0;b=b|0;Gh[f[(f[a>>2]|0)+72>>2]&511](a,b);return}function as(a,b){a=a|0;b=b|0;Gh[f[(f[a>>2]|0)+64>>2]&511](a,b);return}function bs(a,b){a=a|0;b=b|0;Gh[f[(f[a>>2]|0)+80>>2]&511](a,b);return}function cs(a,b){a=a|0;b=b|0;Gh[f[(f[a>>2]|0)+88>>2]&511](a,b);return}function ds(a,b){a=a|0;b=b|0;Gh[f[(f[a>>2]|0)+96>>2]&511](a,b);return}function es(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;GCa(a,b,c,d,e,f,g,h,i,j);return}function fs(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;GCa(a,b,c,d,e,f,g,h,i,20);return}function gs(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;GCa(a,b,c,d,e,f,g,h,31,20);return}function hs(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;GCa(a,b,c,d,e,f,g,0,31,20);return}function is(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;GCa(a,b,c,d,e,f,2,0,31,20);return}function js(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;GCa(a,b,c,d,e,0,2,0,31,20);return}function ks(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;GCa(a,b,c,d,31,0,2,0,31,20);return}function ls(a,b,c){a=a|0;b=b|0;c=+c;GCa(a,b,c,8,31,0,2,0,31,20);return}function ms(a,b){a=a|0;b=b|0;GCa(a,b,1.2000000476837158,8,31,0,2,0,31,20);return}function ns(a){a=a|0;GCa(a,500,1.2000000476837158,8,31,0,2,0,31,20);return}function os(a,b){a=a|0;b=b|0;Gh[f[(f[a>>2]|0)+64>>2]&511](a,b);return}function ps(a,b){a=a|0;b=b|0;Gh[f[(f[a>>2]|0)+80>>2]&511](a,b);return}function qs(a,b){a=a|0;b=b|0;Gh[f[(f[a>>2]|0)+128>>2]&511](a,b);return}function rs(a,b){a=a|0;b=b|0;Gh[f[(f[a>>2]|0)+120>>2]&511](a,b);return}function ss(a,b){a=a|0;b=b|0;Gh[f[(f[a>>2]|0)+104>>2]&511](a,b);return}function ts(a,b){a=a|0;b=+b;Dh[f[(f[a>>2]|0)+72>>2]&31](a,b);return}function us(a,b){a=a|0;b=b|0;Gh[f[(f[a>>2]|0)+112>>2]&511](a,b);return}function vs(a){a=a|0;var b=0;sf(204343,7,23328,153995,1,1);sf(204343,6,23356,154004,1,1);sf(204343,5,23380,154012,2,1);sf(136811,7,23400,154019,1,2);sf(136811,6,23428,153616,2,3);sf(136818,7,23452,154019,2,3);sf(136818,6,23480,153616,3,4);sf(136818,5,23504,153624,4,6);sf(136831,10,23524,154028,1,1);sf(136831,9,23564,154040,1,1);sf(136831,8,23600,154051,1,1);sf(136831,7,23632,154061,1,1);sf(136831,6,22584,153616,4,5);sf(136844,10,23660,154070,1,1);sf(136844,9,23700,154082,1,1);sf(136844,8,23736,154093,1,1);sf(136844,7,23768,154103,1,1);sf(136844,6,23356,154004,1,2);sf(136855,8,23736,154093,1,2);sf(136855,7,23768,154103,1,2);sf(136855,6,23356,154004,1,3);sf(136867,8,23796,154112,1,3);sf(136867,7,23828,154122,1,5);sf(136867,6,23856,154131,1,5);sf(136867,5,23880,153631,72,80);sf(136867,4,22608,151231,81,111);sf(136877,9,23900,154139,1,2);sf(136877,8,23936,154150,1,2);sf(136877,7,23968,154160,1,2);sf(136877,6,23996,154169,87,73);sf(136884,10,24020,154177,1,2);sf(136884,9,24060,154189,1,2);sf(136884,8,24096,154200,1,2);sf(136884,7,24128,154210,53,88);sf(136884,6,23996,154169,87,74);sf(136890,4,24156,151231,82,112);sf(332974,8,24172,154219,1,1);sf(356853,6,24204,154169,89,75);sf(356853,5,24228,153631,76,83);sf(356853,4,24156,151231,82,113);sf(136898,8,24248,154229,1,1);sf(136898,7,24280,154239,1,1);sf(204251,5,24308,154248,1,7);sf(326892,3,24328,153650,11,16);sf(330750,7,24340,154019,4,4);sf(330750,6,22584,153616,4,6);sf(136910,5,24228,153631,76,84);sf(136910,4,24156,151231,82,114);sf(136922,4,22732,151231,85,115);sf(136922,3,22720,151226,116,289);sf(136934,5,24228,153631,76,86);sf(136934,4,24156,151231,82,117);sf(136945,5,24228,153631,76,87);sf(136945,4,24156,151231,82,118);sf(136957,6,24368,154169,90,77);sf(136957,5,24392,153631,78,88);sf(136957,4,24412,151231,89,119);sf(136962,2,24428,151237,115,290);sf(136975,8,24436,154255,122,54);sf(136975,7,24468,154210,55,91);sf(136975,6,24496,154169,92,79);sf(136975,5,24520,153631,80,90);sf(313090,7,24540,154160,3,3);sf(312249,8,24568,154255,123,56);sf(312249,7,24600,154210,57,93);sf(136985,11,24628,154265,1,1);sf(137010,12,24672,154278,1,1);sf(137010,11,24720,154292,1,2);sf(137010,10,24764,154305,3,93);sf(137010,9,24804,154317,94,124);sf(137010,8,24840,154255,125,58);sf(137010,7,24872,154210,59,94);sf(165340,6,24900,154169,95,81);sf(165340,5,24924,153631,82,91);sf(224025,8,24944,154255,126,60);sf(224025,7,24976,154210,61,96);sf(224025,6,25004,154169,97,83);sf(224025,5,25028,153631,84,92);sf(157965,5,25048,153631,85,93);sf(313557,4,25068,153680,3,12);sf(218028,5,25084,153384,57,36);sf(218028,4,25104,151265,37,85);sf(218028,3,25120,151260,86,116);sf(218819,7,25132,154328,7,69);sf(218819,6,25160,153391,70,58);sf(218819,5,25184,153384,59,38);sf(326984,3,24328,153650,11,17);sf(326984,2,25204,153706,18,14);sf(159448,5,23380,154012,2,2);sf(159448,4,25212,151603,7,15);sf(159448,3,22720,151226,116,291);sf(220450,5,25228,153631,86,94);sf(220450,4,25248,151231,95,120);sf(220450,3,22720,151226,116,292);sf(220647,4,24156,151231,82,121);sf(160507,9,25264,154317,95,127);sf(160507,8,25300,154255,128,62);sf(137031,7,25332,154337,1,2);sf(137031,6,23856,154131,1,6);sf(137044,6,23996,154169,87,87);sf(137044,5,23880,153631,72,96);sf(137044,4,22608,151231,81,122);sf(188592,2,25360,151237,117,163);sf(217412,5,23880,153631,72,97);sf(217412,4,22608,151231,81,123);sf(221163,5,23880,153631,72,98);sf(221163,4,22608,151231,81,124);sf(164129,2,25204,153706,18,15);sf(163219,5,23880,153631,72,99);sf(163219,4,22608,151231,81,125);sf(163219,3,22720,151226,116,293);sf(137062,8,25368,154255,129,63);sf(137062,7,25400,154210,64,98);sf(137062,6,25428,154169,99,88);sf(137062,5,25452,153631,89,100);sf(137062,4,22732,151231,85,126);sf(222511,6,23996,154169,87,90);sf(222511,5,23880,153631,72,101);sf(137069,7,25472,154210,65,100);sf(137069,6,25500,154169,101,91);sf(137097,6,25524,154346,3,2);sf(137097,5,25548,153624,7,8);sf(137097,4,24156,151231,82,127);sf(137104,5,25568,154354,1,1);sf(137104,4,25588,154361,4,1);sf(224652,10,25604,154305,4,96);sf(224652,9,25644,154317,97,130);sf(224652,8,25680,154255,131,66);sf(224652,7,25712,154210,67,102);sf(224652,6,25740,154169,103,92);sf(224652,5,25764,153631,93,102);sf(354943,6,25784,154169,104,94);sf(354943,5,25808,153631,95,103);sf(354943,4,25828,151231,104,128);sf(355210,11,25844,154292,2,5);sf(355210,10,25888,154305,6,98);sf(355210,9,25928,154317,99,132);sf(355210,8,25964,154255,133,68);sf(355210,7,25996,154210,69,105);sf(164332,4,26024,151265,39,87);sf(164332,3,26040,151260,88,118);sf(224210,11,26052,154367,1,1);sf(224210,10,26096,154380,1,1);sf(224210,9,26136,154392,1,1);sf(224210,8,26172,154403,1,1);sf(137112,6,26204,154169,106,96);sf(137112,5,26228,153631,97,105);sf(137112,4,26248,151231,106,129);sf(137121,8,26264,154255,134,70);sf(313737,3,22720,151226,116,294);sf(137134,8,25368,154255,129,71);sf(137134,7,25400,154210,64,107);sf(137134,6,25428,154169,99,98);sf(137134,5,25452,153631,89,107);sf(137134,4,22732,151231,85,130);sf(349096,4,26296,151265,40,108);sf(165624,3,22720,151226,116,295);sf(137140,8,26312,154413,1,2);sf(137140,7,26344,154160,4,4);sf(137140,6,26372,154169,108,99);sf(137140,5,26396,153631,100,109);sf(220140,7,26416,154210,72,109);sf(220140,6,26444,154169,110,101);sf(345915,7,26468,154423,1,1);sf(345915,6,26496,154432,2,3);sf(345915,5,26520,153673,4,4);sf(345915,4,26540,153680,5,13);sf(327074,2,26556,151237,119,296);sf(316414,7,23632,154061,1,2);sf(160251,4,22608,151231,81,131);sf(168245,8,26564,154440,1,1);sf(168245,7,26596,154450,1,1);sf(316364,3,26624,151260,89,132);sf(137149,2,23300,151237,98,164);sf(316283,3,26624,151260,89,133);sf(137167,4,26636,154459,1,3);sf(322441,4,26652,151265,41,110);sf(322441,3,26668,151260,90,134);sf(225031,10,26680,154465,1,1);sf(225031,9,26720,154477,1,1);sf(225031,8,26756,154488,1,2);sf(225031,7,26788,154019,5,5);sf(225031,6,22584,153616,4,7);sf(137187,11,26816,154498,1,1);sf(137187,10,26860,154511,1,1);sf(137187,9,26900,154477,2,2);sf(235486,8,26936,154255,135,73);sf(235486,7,26968,154210,74,111);sf(343389,5,26996,153624,8,9);sf(343389,4,27016,151231,111,135);sf(176257,3,27032,151226,136,297);sf(137208,3,22804,151260,91,137);sf(351313,5,27044,153384,60,42);sf(351313,4,27064,151265,43,92);sf(158263,5,27080,153631,102,112);sf(333475,9,27100,154317,100,136);sf(330919,4,22608,151231,81,138);sf(330919,3,22720,151226,116,298);sf(137217,6,25500,154169,101,103);sf(137217,5,27136,153631,104,113);sf(137217,4,27156,151231,114,139);sf(164248,4,27172,153680,6,14);sf(164248,3,27188,153650,15,19);sf(220799,2,27200,151237,120,165);sf(163496,8,27208,154603,1,2);sf(163496,7,27240,154423,3,3);sf(223624,8,27268,154255,137,75);sf(223624,7,27300,154210,76,112);sf(223624,6,27328,154169,113,105);sf(223624,5,27352,153631,106,115);sf(165666,3,22720,151226,116,299);sf(204633,4,24156,151231,82,140);sf(316630,5,27372,154613,1,1);sf(332474,6,27392,154169,114,107);sf(332474,5,25048,153631,85,116);sf(137227,4,24156,151231,82,141);sf(188671,3,27416,151260,93,142);sf(188671,2,27428,151237,121,300);sf(188720,5,27436,153631,108,117);sf(188720,4,27156,151231,114,143);sf(330188,4,22608,151231,81,144);sf(158689,3,27032,151226,136,301);sf(137231,4,24156,151231,82,145);sf(137235,2,26556,151237,119,302);sf(158827,4,27456,151231,118,146);sf(316916,3,27472,151260,94,147);sf(316916,2,27484,151237,122,303);sf(322726,9,27492,154317,101,138);sf(322726,8,27528,154255,139,77);sf(322726,7,27560,154210,78,115);sf(322726,6,26372,154169,108,109);sf(322726,5,26396,153631,100,119);sf(137247,6,25524,154346,3,3);sf(137247,5,25548,153624,7,10);sf(137247,4,24156,151231,82,148);sf(189358,4,27588,153680,7,16);sf(189358,3,27604,153650,17,20);sf(189358,2,25204,153706,18,16);sf(137256,5,27616,153673,5,8);sf(137256,4,25068,153680,3,18);sf(137256,3,22776,153650,19,21);sf(159656,8,27636,154620,3,1);sf(159656,7,27668,153995,3,2);sf(159656,6,23356,154004,1,4);sf(159656,5,23380,154012,2,4);sf(159656,4,25212,151603,7,16);sf(159656,3,22720,151226,116,304);sf(168797,4,22732,151231,85,149);sf(235144,4,27696,153680,9,20);sf(165497,6,24900,154169,95,110);sf(165497,5,24924,153631,82,120);sf(165708,4,27712,154630,8,1);sf(137262,10,27728,154636,1,2);sf(137262,9,27768,154648,1,2);sf(137262,8,27804,154659,2,1);sf(137262,7,27836,154337,3,4);sf(322898,5,27864,153631,111,121);sf(322898,4,27884,151231,122,150);sf(322898,3,22720,151226,116,305);sf(323202,5,27864,153631,111,123);sf(323202,4,27884,151231,122,151);sf(323202,3,22720,151226,116,306);sf(137270,4,27900,151231,124,152);sf(137276,4,27900,151231,124,153);sf(223856,8,27268,154255,137,79);sf(223856,7,27300,154210,76,116);sf(223856,6,27328,154169,113,112);sf(223856,5,27352,153631,106,125);sf(176777,6,23996,154169,87,113);sf(176777,5,23880,153631,72,126);sf(314985,8,27916,154255,140,80);sf(314985,7,27948,154210,81,117);sf(314985,6,27976,154169,118,114);sf(160331,5,28e3,153631,115,127);sf(323463,7,23452,154019,2,6);sf(323463,6,23480,153616,3,8);sf(323463,5,23504,153624,4,11);sf(323463,4,24412,151231,89,154);sf(234943,9,28020,154669,1,2);sf(234943,8,28056,154200,2,5);sf(234943,7,28088,154210,82,119);sf(234943,6,28116,154169,120,116);sf(176563,3,22836,151226,155,307);sf(176563,2,28140,154680,308,912);sf(137282,2,28148,154680,309,913);sf(164850,5,28156,153384,61,44);sf(164850,4,28176,151265,45,95);sf(166216,4,27172,153680,6,21);sf(166216,3,27188,153650,15,22);sf(158472,3,28192,151226,156,310);sf(137293,3,22720,151226,116,311);sf(137298,6,24204,154169,89,117);sf(137298,5,24228,153631,76,128);sf(137298,4,24156,151231,82,157);sf(338971,6,28204,154684,1,1);sf(176630,2,27428,151237,121,312);sf(168713,4,22732,151231,85,158);sf(174867,3,22720,151226,116,313);sf(334065,6,28228,154169,121,118);sf(334065,5,28252,153631,119,129);sf(176443,3,27032,151226,136,314);sf(315679,8,28272,154255,141,83);sf(315679,7,28304,154210,84,122);sf(315679,6,28332,154169,123,120);sf(315679,5,28356,153631,121,130);sf(315922,8,28272,154255,141,85);sf(315922,7,28304,154210,84,124);sf(315922,6,28332,154169,123,122);sf(315922,5,28356,153631,121,131);sf(326576,3,22720,151226,116,315);ee(19096,9792,9808,19176,151218,166,151218,167,151218,168,137307,151223,914);Ed(19096,2,28376,151237,123,316);Ed(19096,1,28384,151218,169,915);rf(9824,19096,137326,0,151218,170,183816,29,151218,171,151223,916);ee(18312,9832,9848,0,151218,172,151221,0,151221,0,137350,151223,917);a=NYa(4)|0;f[a>>2]=96;Je(18312,137364,4,28388,151265,46,a|0,0);a=NYa(4)|0;f[a>>2]=124;Je(18312,137364,3,28404,151260,97,a|0,0);Ed(18312,1,28416,151218,173,30);Ed(18312,13,28420,154828,1,1);Ed(18312,2,28472,151237,125,174);Cf(18312,137369,1,28480,151218,175,918);Cf(18312,137394,1,28480,151218,175,919);a=NYa(4)|0;f[a>>2]=317;Je(18312,344356,3,28484,151226,159,a|0,0);a=NYa(4)|0;f[a>>2]=2;Je(18312,335797,11,28496,154856,1,a|0,0);a=NYa(4)|0;f[a>>2]=1;Je(18312,335797,10,28540,154869,1,a|0,0);a=NYa(4)|0;f[a>>2]=1;Je(18312,335797,9,28580,154881,1,a|0,0);a=NYa(4)|0;f[a>>2]=2;Je(18312,335797,8,28616,154659,3,a|0,0);a=NYa(4)|0;f[a>>2]=5;Je(18312,335797,7,28648,154337,4,a|0,0);a=NYa(4)|0;f[a>>2]=9;Je(18312,335797,6,28676,154131,5,a|0,0);a=NYa(4)|0;f[a>>2]=132;Je(18312,335797,5,28700,153631,123,a|0,0);a=NYa(4)|0;f[a>>2]=4;b=NYa(4)|0;f[b>>2]=4;_d(18312,344184,9528,151237,126,a|0,9528,151226,160,b|0);b=NYa(4)|0;f[b>>2]=12;a=NYa(4)|0;f[a>>2]=12;_d(18312,344192,9528,151237,126,b|0,9528,151226,160,a|0);a=NYa(4)|0;f[a>>2]=20;b=NYa(4)|0;f[b>>2]=20;_d(18312,344202,9528,151237,126,a|0,9528,151226,160,b|0);b=NYa(4)|0;f[b>>2]=28;a=NYa(4)|0;f[a>>2]=28;_d(18312,344318,9528,151237,126,b|0,9528,151226,160,a|0);a=NYa(4)|0;f[a>>2]=36;b=NYa(4)|0;f[b>>2]=36;_d(18312,344214,21648,151237,127,a|0,21648,151226,161,b|0);b=NYa(4)|0;f[b>>2]=40;a=NYa(4)|0;f[a>>2]=40;_d(18312,344220,21648,151237,127,b|0,21648,151226,161,a|0);a=NYa(4)|0;f[a>>2]=48;b=NYa(4)|0;f[b>>2]=48;_d(18312,344327,21688,153706,23,a|0,21688,151598,17,b|0);b=NYa(4)|0;f[b>>2]=56;a=NYa(4)|0;f[a>>2]=56;_d(18312,344234,21648,151237,127,b|0,21648,151226,161,a|0);a=NYa(4)|0;f[a>>2]=64;b=NYa(4)|0;f[b>>2]=64;_d(18312,344252,21688,153706,23,a|0,21688,151598,17,b|0);b=NYa(4)|0;f[b>>2]=72;a=NYa(4)|0;f[a>>2]=72;_d(18312,344267,21600,151237,128,b|0,21600,151226,162,a|0);a=NYa(4)|0;f[a>>2]=76;b=NYa(4)|0;f[b>>2]=76;_d(18312,137419,8768,151237,129,a|0,8768,151226,163,b|0);b=NYa(4)|0;f[b>>2]=140;a=NYa(4)|0;f[a>>2]=140;_d(18312,344283,21648,151237,127,b|0,21648,151226,161,a|0);a=NYa(4)|0;f[a>>2]=144;b=NYa(4)|0;f[b>>2]=144;_d(18312,344291,21600,151237,128,a|0,21600,151226,162,b|0);ee(9872,9888,9904,10256,151218,176,151218,177,151218,178,137431,151223,920);b=NYa(4)|0;f[b>>2]=12;Je(9872,345174,5,28720,153624,10,b|0,0);b=NYa(4)|0;f[b>>2]=164;Je(9872,345174,4,28740,151231,133,b|0,0);b=NYa(4)|0;f[b>>2]=318;Je(9872,344648,3,28756,151226,165,b|0,0);ee(9920,9936,9952,9872,151218,179,151218,180,151218,181,137452,151223,921);Ed(9920,4,28768,155120,1,9);Ed(9920,3,28784,155126,1,18);Ed(9920,2,28796,151237,130,319);Ed(9920,1,28804,151218,182,922);b=NYa(4)|0;f[b>>2]=13;Je(9920,345174,5,28808,153624,11,b|0,0);b=NYa(4)|0;f[b>>2]=166;Je(9920,345174,4,28828,151231,134,b|0,0);rf(9968,9920,137477,0,151218,183,183816,31,151218,184,151223,923);ee(9976,9992,10008,10256,151218,185,151218,186,151218,187,137507,151223,924);b=NYa(4)|0;f[b>>2]=320;Je(9976,137513,3,28844,151226,167,b|0,0);Ed(9976,3,28856,155192,1,2);Ed(9976,2,28868,155197,1,14);Ed(9976,1,28876,151218,188,925);b=NYa(8)|0;f[b>>2]=52;f[b+4>>2]=1;Je(9976,137530,2,28880,154680,321,b|0,1);b=NYa(4)|0;f[b>>2]=15;Je(9976,137545,3,28888,151598,19,b|0,0);b=NYa(8)|0;f[b>>2]=48;f[b+4>>2]=1;Je(9976,137558,2,28900,151237,131,b|0,1);b=NYa(8)|0;f[b>>2]=40;f[b+4>>2]=1;Je(9976,137575,2,28908,153706,24,b|0,1);b=NYa(4)|0;f[b>>2]=168;Je(9976,345174,4,28916,151231,135,b|0,0);rf(10024,9976,137588,0,151218,189,183816,32,151218,190,151223,926);ee(10256,10032,10048,0,151218,191,151221,0,151221,0,137599,151223,927);ee(19176,10064,10080,10256,151218,192,151218,193,151218,194,356573,151223,928);b=NYa(4)|0;f[b>>2]=322;Je(19176,137609,2,28932,151237,132,b|0,0);b=NYa(4)|0;f[b>>2]=136;Je(19176,356368,5,28940,153631,124,b|0,0);b=NYa(4)|0;f[b>>2]=169;Je(19176,356368,4,28960,151231,137,b|0,0);b=NYa(4)|0;f[b>>2]=138;Je(19176,356083,5,28976,153631,125,b|0,0);b=NYa(4)|0;f[b>>2]=125;Je(19176,357862,7,28996,154210,86,b|0,0);b=NYa(4)|0;f[b>>2]=126;Je(19176,357862,6,29024,154169,126,b|0,0);b=NYa(8)|0;f[b>>2]=20;f[b+4>>2]=1;Je(19176,175982,2,29048,151237,133,b|0,0);ee(19200,10096,10112,10256,151218,195,151218,196,151218,197,137624,151223,929);Ed(19200,2,29056,151237,134,323);b=NYa(4)|0;f[b>>2]=127;Je(19200,137642,6,29064,154169,127,b|0,0);b=NYa(4)|0;f[b>>2]=139;Je(19200,137642,5,29088,153631,128,b|0,0);rf(10128,19200,137648,0,151218,198,183816,33,151218,199,151223,930);ee(10136,10144,10160,0,151218,200,151221,0,151221,0,137671,151223,931);b=NYa(4)|0;f[b>>2]=135;Je(10136,137364,3,29108,151260,98,b|0,0);b=NYa(4)|0;f[b>>2]=3;Je(10136,137689,10,29120,154636,2,b|0,0);b=NYa(4)|0;f[b>>2]=3;Je(10136,137689,9,29160,154648,2,b|0,0);b=NYa(4)|0;f[b>>2]=3;Je(10136,137689,8,29196,154659,4,b|0,0);b=NYa(4)|0;f[b>>2]=6;Je(10136,137689,7,29228,154337,5,b|0,0);b=NYa(4)|0;f[b>>2]=12;Je(10136,137689,6,29256,154131,6,b|0,0);b=NYa(4)|0;f[b>>2]=140;Je(10136,137689,5,29280,153631,129,b|0,0);Ed(10136,1,29300,151218,201,34);Ed(10136,2,29304,151237,136,202);b=NYa(4)|0;f[b>>2]=2;Je(10136,137707,12,29312,155437,1,b|0,0);b=NYa(4)|0;f[b>>2]=3;Je(10136,137707,11,29360,155451,1,b|0,0);b=NYa(4)|0;f[b>>2]=3;Je(10136,137707,10,29404,155464,1,b|0,0);b=NYa(4)|0;f[b>>2]=5;Je(10136,137707,9,29444,155476,1,b|0,0);b=NYa(4)|0;f[b>>2]=6;Je(10136,137707,8,29480,154413,3,b|0,0);b=NYa(4)|0;f[b>>2]=7;Je(10136,137707,7,29512,154160,6,b|0,0);b=NYa(4)|0;f[b>>2]=130;Je(10136,137707,6,29540,154169,128,b|0,0);b=NYa(8)|0;f[b>>2]=203;f[b+4>>2]=0;Je(10136,175982,2,29564,151237,137,b|0,0);b=NYa(4)|0;f[b>>2]=2;Je(10136,335797,9,29572,155487,4,b|0,0);b=NYa(4)|0;f[b>>2]=2;Je(10136,335797,8,29608,155498,4,b|0,0);b=NYa(4)|0;f[b>>2]=2;Je(10136,335797,7,29640,155508,4,b|0,0);b=NYa(4)|0;f[b>>2]=4;Je(10136,335797,6,29668,154346,7,b|0,0);b=NYa(4)|0;f[b>>2]=14;Je(10136,335797,5,29692,153624,13,b|0,0);b=NYa(4)|0;f[b>>2]=170;Je(10136,335797,4,29712,151231,141,b|0,0);ee(19128,10176,10192,19176,151218,204,151218,205,151218,206,137725,151223,932);b=NYa(8)|0;f[b>>2]=76;f[b+4>>2]=1;Je(19128,137745,2,29728,151237,138,b|0,1);b=NYa(8)|0;f[b>>2]=68;f[b+4>>2]=1;Je(19128,137766,2,29736,151237,139,b|0,1);Ed(19128,4,29744,151265,47,142);Ed(19128,3,29760,151260,99,171);Ed(19128,2,29772,151237,140,324);Ed(19128,1,29780,151218,207,933);b=NYa(8)|0;f[b>>2]=84;f[b+4>>2]=1;Je(19128,137779,2,29736,151237,139,b|0,1);b=NYa(4)|0;f[b>>2]=325;Je(19128,137787,3,29784,151226,172,b|0,0);b=NYa(4)|0;f[b>>2]=326;Je(19128,137808,3,29796,151226,173,b|0,0);b=NYa(4)|0;f[b>>2]=327;Je(19128,137821,3,29796,151226,173,b|0,0);rf(10208,19128,137829,0,151218,208,183816,35,151218,209,151223,934);ee(19248,10216,10232,19176,151218,210,151218,211,151218,212,137854,151223,935);b=NYa(8)|0;f[b>>2]=68;f[b+4>>2]=1;Je(19248,137858,2,29808,151237,141,b|0,1);b=NYa(4)|0;f[b>>2]=328;Je(19248,137873,3,29816,151226,174,b|0,0);b=NYa(4)|0;f[b>>2]=329;Je(19248,137890,3,29816,151226,174,b|0,0);Ed(19248,10,29828,155654,1,1);Ed(19248,9,29868,155666,1,1);Ed(19248,8,29904,155677,1,1);Ed(19248,7,29936,155687,1,1);Ed(19248,6,29964,155696,1,1);Ed(19248,5,29988,155704,1,1);Ed(19248,4,30008,155711,2,10);Ed(19248,3,30024,155717,2,20);Ed(19248,2,30036,151237,142,330);Ed(19248,1,30044,151218,213,936);b=NYa(8)|0;f[b>>2]=132;f[b+4>>2]=1;Je(19248,137904,2,29808,151237,141,b|0,1);b=NYa(4)|0;f[b>>2]=331;Je(19248,137921,3,29816,151226,174,b|0,0);b=NYa(8)|0;f[b>>2]=108;f[b+4>>2]=1;Je(19248,137936,2,29808,151237,141,b|0,1);b=NYa(8)|0;f[b>>2]=84;f[b+4>>2]=1;Je(19248,137945,2,29808,151237,141,b|0,1);b=NYa(4)|0;f[b>>2]=332;Je(19248,137956,3,29816,151226,174,b|0,0);b=NYa(4)|0;f[b>>2]=333;Je(19248,137967,3,29816,151226,174,b|0,0);b=NYa(8)|0;f[b>>2]=76;f[b+4>>2]=1;Je(19248,137984,2,30048,153706,25,b|0,1);b=NYa(4)|0;f[b>>2]=334;Je(19248,137999,3,29816,151226,174,b|0,0);b=NYa(4)|0;f[b>>2]=335;Je(19248,138012,3,29816,151226,174,b|0,0);b=NYa(4)|0;f[b>>2]=16;Je(19248,138021,3,30056,151598,21,b|0,0);b=NYa(8)|0;f[b>>2]=124;f[b+4>>2]=1;Je(19248,138036,2,29808,151237,141,b|0,1);b=NYa(8)|0;f[b>>2]=92;f[b+4>>2]=1;Je(19248,138049,2,29808,151237,141,b|0,1);b=NYa(8)|0;f[b>>2]=100;f[b+4>>2]=1;Je(19248,138066,2,29808,151237,141,b|0,1);b=NYa(8)|0;f[b>>2]=116;f[b+4>>2]=1;Je(19248,138080,2,29808,151237,141,b|0,1);b=NYa(4)|0;f[b>>2]=336;Je(19248,138093,3,29816,151226,174,b|0,0);rf(10248,19248,138106,0,151218,214,183816,36,151218,215,151223,937);Jd(138115,21648,67108864);Jd(138127,21648,50331648);Jd(138139,21648,16777216);Jd(138151,21648,50331648);Jd(138161,21648,33554432);Jd(138174,21648,1);Jd(138201,21648,0);Jd(138224,21648,3);Jd(138246,21648,2);Jd(138276,21648,5);Jd(138298,21648,4);Jd(138328,21648,0);Jd(138359,21648,1);Jd(138392,21648,2);Jd(138425,21648,10001);Jd(138465,21648,3);Jd(138496,21648,1e4);Jd(138527,21648,0);Jd(138543,21648,4);Jd(138558,21648,16);Jd(138574,21648,2);Jd(138589,21648,4);Jd(138607,21648,4);Jd(138626,21648,1);Jd(138643,21648,5);Jd(138662,21648,3);Jd(138674,21648,1);Jd(138699,21648,8);Jd(138723,21648,4);Jd(138751,21648,2);Jd(138771,21648,-1);Jd(138783,21648,1);Jd(138793,21648,0);Jd(138800,21648,4);Jd(138813,21648,3);Jd(138828,21648,0);Jd(138841,21648,5);Jd(138853,21648,1);Jd(138865,21648,2);Jd(138879,21648,1);Jd(138897,21648,2);Jd(138917,21648,4);Jd(138940,21648,3);Jd(138961,21648,0);Jd(138968,21648,2);Jd(138975,21648,1);Jd(138982,21648,4);Jd(138989,21648,3);Jd(138996,21648,5);Jd(139003,21648,0);Jd(139019,21648,1);Jd(139033,21648,8);Jd(139047,21648,11);Jd(139060,21648,9);Jd(139073,21648,2);Jd(139086,21648,5);Jd(139101,21648,12);Jd(139117,21648,10);Jd(139131,21648,4);Jd(139148,21648,7);Jd(139164,21648,6);Jd(139180,21648,3);Jd(139196,21648,22);Jd(139213,21648,12);Jd(139230,21648,0);Jd(139245,21648,6);Jd(139260,21648,52);Jd(139274,21648,68);Jd(139293,21648,40);Jd(139307,21648,66);Jd(139326,21648,44);Jd(139340,21648,50);Jd(139354,21648,4);Jd(139368,21648,2);Jd(139383,21648,32);Jd(139397,21648,36);Jd(139413,21648,82);Jd(139427,21648,128);Jd(139446,21648,128);Jd(139465,21648,132);Jd(139484,21648,24);Jd(139501,21648,28);Jd(139519,21648,31);Jd(139537,21648,25);Jd(139554,21648,29);Jd(139572,21648,14);Jd(139589,21648,18);Jd(139607,21648,21);Jd(139625,21648,15);Jd(139642,21648,19);Jd(139660,21648,1);Jd(139675,21648,26);Jd(139693,21648,16);Jd(139711,21648,10);Jd(139727,21648,3);Jd(139742,21648,5);Jd(139758,21648,130);Jd(139778,21648,130);Jd(139798,21648,134);Jd(139818,21648,46);Jd(139836,21648,139);Jd(139855,21648,135);Jd(139876,21648,62);Jd(139898,21648,86);Jd(139917,21648,48);Jd(139935,21648,141);Jd(139954,21648,137);Jd(139975,21648,64);Jd(139997,21648,47);Jd(140015,21648,140);Jd(140034,21648,136);Jd(140055,21648,63);Jd(140077,21648,87);Jd(140096,21648,49);Jd(140114,21648,142);Jd(140133,21648,138);Jd(140154,21648,65);Jd(140176,21648,49);Jd(140194,21648,142);Jd(140213,21648,138);Jd(140234,21648,65);Jd(140256,21648,89);Jd(140275,21648,47);Jd(140293,21648,140);Jd(140312,21648,136);Jd(140333,21648,63);Jd(140355,21648,48);Jd(140373,21648,141);Jd(140392,21648,137);Jd(140413,21648,64);Jd(140435,21648,88);Jd(140454,21648,46);Jd(140472,21648,139);Jd(140491,21648,135);Jd(140512,21648,62);Jd(140534,21648,143);Jd(140553,21648,8);Jd(140568,21648,30);Jd(140586,21648,20);Jd(140604,21648,9);Jd(140620,21648,8);Jd(140635,21648,9);Jd(140651,21648,60);Jd(140665,21648,72);Jd(140684,21648,61);Jd(140698,21648,73);Jd(140717,21648,54);Jd(140731,21648,70);Jd(140750,21648,55);Jd(140764,21648,71);Jd(140783,21648,74);Jd(140798,21648,76);Jd(140813,21648,75);Jd(140828,21648,77);Jd(140843,21648,56);Jd(140857,21648,78);Jd(140872,21648,79);Jd(140887,21648,57);Jd(140901,21648,58);Jd(140915,21648,80);Jd(140930,21648,81);Jd(140945,21648,59);Jd(140959,21648,4);Jd(140973,21648,23);Jd(140990,21648,13);Jd(141007,21648,2);Jd(141022,21648,7);Jd(141037,21648,53);Jd(141051,21648,69);Jd(141070,21648,41);Jd(141084,21648,67);Jd(141103,21648,45);Jd(141117,21648,51);Jd(141131,21648,0);Jd(141146,21648,33);Jd(141160,21648,37);Jd(141176,21648,83);Jd(141190,21648,127);Jd(141209,21648,127);Jd(141228,21648,131);Jd(141247,21648,3);Jd(141262,21648,27);Jd(141280,21648,17);Jd(141298,21648,5);Jd(141314,21648,11);Jd(141330,21648,1);Jd(141345,21648,129);Jd(141365,21648,129);Jd(141385,21648,133);Jd(141405,21648,125);Jd(141422,21648,34);Jd(141436,21648,35);Jd(141450,21648,38);Jd(141466,21648,39);Jd(141482,21648,84);Jd(141496,21648,105);Jd(141516,21648,105);Jd(141536,21648,95);Jd(141556,21648,97);Jd(141576,21648,112);Jd(141596,21648,112);Jd(141616,21648,112);Jd(141636,21648,120);Jd(141656,21648,120);Jd(141676,21648,120);Jd(141696,21648,103);Jd(141716,21648,122);Jd(141736,21648,101);Jd(141755,21648,101);Jd(141774,21648,91);Jd(141793,21648,93);Jd(141812,21648,108);Jd(141831,21648,108);Jd(141850,21648,108);Jd(141869,21648,116);Jd(141888,21648,116);Jd(141907,21648,116);Jd(141926,21648,99);Jd(141945,21648,118);Jd(141964,21648,106);Jd(141983,21648,106);Jd(142003,21648,106);Jd(142023,21648,106);Jd(142043,21648,106);Jd(142063,21648,123);Jd(142083,21648,123);Jd(142103,21648,123);Jd(142123,21648,124);Jd(142143,21648,124);Jd(142163,21648,124);Jd(142183,21648,106);Jd(142203,21648,124);Jd(142223,21648,85);Jd(142237,21648,104);Jd(142257,21648,104);Jd(142277,21648,94);Jd(142297,21648,96);Jd(142317,21648,111);Jd(142337,21648,111);Jd(142357,21648,111);Jd(142377,21648,119);Jd(142397,21648,119);Jd(142417,21648,119);Jd(142437,21648,102);Jd(142457,21648,121);Jd(142477,21648,100);Jd(142496,21648,100);Jd(142515,21648,90);Jd(142534,21648,92);Jd(142553,21648,107);Jd(142572,21648,107);Jd(142591,21648,107);Jd(142610,21648,115);Jd(142629,21648,115);Jd(142648,21648,115);Jd(142667,21648,98);Jd(142686,21648,117);Jd(142705,21648,99);Jd(142723,21648,103);Jd(142742,21648,106);Jd(142761,21648,98);Jd(142779,21648,102);Jd(142798,21648,93);Jd(142817,21648,97);Jd(142837,21648,106);Jd(142857,21648,92);Jd(142876,21648,96);Jd(142896,21648,126);Jd(142913,21648,1);Jd(142931,21648,2);Jd(142949,21648,3);Jd(142967,21648,16);Jd(142978,21648,1);Jd(142991,21648,8);Jd(143002,21648,4);Jd(143014,21648,0);Jd(143030,21648,2);Jd(143044,21648,1);Jd(143056,21648,4);Jd(143065,21648,3);Jd(143081,21648,2);Jd(143092,21648,0);Jd(143102,21648,16);Jd(143116,21648,4);Jd(143126,21648,1);Jd(143137,21648,64);Jd(143155,21648,16);Jd(143174,21648,1);Jd(143186,21648,32);Jd(143202,21648,4);Jd(143211,21648,2);Jd(143221,21648,3);Jd(143228,21648,5);Jd(143238,21648,7);Jd(143249,21648,1);Jd(143257,21648,4);Jd(143266,21648,2);Jd(143274,21648,0);Jd(143291,21648,1);Jd(143308,21648,3);Jd(143320,21648,5);Jd(143332,21648,0);Jd(143350,21648,-1);Jd(143360,21648,6);Jd(143372,21648,2);Jd(143401,21648,4);Jd(143438,21648,5);Jd(143478,21648,3);Jd(143510,21648,6);Jd(143543,21648,1);Jd(143572,21648,0);Jd(143597,21648,1);Jd(143631,21648,4);Jd(143668,21648,2);Jd(143708,21648,32);Jd(143726,21648,8);Jd(143745,21648,1);Jd(143764,21648,4);Jd(143783,21648,2);Jd(143802,21648,16);Jd(143822,21648,7);Jd(143842,21648,1);Jd(143860,21648,4);Jd(143876,21648,9);Jd(143896,21648,3);Jd(143914,21648,6);Jd(143930,21648,11);Jd(143948,21648,0);Jd(143964,21648,10);Jd(143981,21648,8);Jd(144001,21648,2);Jd(144019,21648,5);Jd(144035,21648,-1);Jd(144042,21648,65536);Jd(144064,21648,131072);Jd(144084,21648,3);Jd(144105,21648,5);Jd(144132,21648,2);Jd(144152,21648,1);Jd(144171,21648,7);Jd(144199,21648,6);Jd(144227,21648,0);Jd(144248,21648,4);Jd(144269,21648,16);Jd(136706,21648,10002);Jd(136667,21648,10001);Jd(136637,21648,1e4);Jd(136548,21648,0);Jd(136577,21648,1);Jd(136607,21648,2);Jd(144281,21648,32);Jd(144296,21648,2);Jd(144311,21648,8);Jd(144325,21648,1);Jd(144338,21648,6);Jd(144351,21648,64);Jd(144366,21648,0);Jd(144380,21648,2);Jd(144394,21648,4);Jd(144407,21648,5);Jd(144420,21648,3);Jd(144433,21648,3);Jd(144449,21648,7);Jd(144468,21648,16);Jd(144482,21648,2);Jd(144501,21648,64);Jd(144520,21648,0);Jd(144544,21648,24);Jd(144568,21648,56);Jd(144592,21648,8);Jd(144615,21648,16);Jd(144639,21648,4);Jd(144662,21648,4);Jd(144681,21648,2);Jd(144707,21648,0);Jd(144724,21648,0);Jd(144746,21648,1);Jd(144773,21648,1);Jd(144791,21648,65);Jd(144816,21648,5);Jd(144832,21648,2);Jd(144850,21648,0);Jd(144872,21648,1);Jd(144893,21648,4);Jd(144913,21648,3);Jd(144934,21648,0);Jd(144941,21648,2);Jd(144949,21648,1);Jd(144956,21648,1);Jd(144974,21648,0);Jd(144992,21648,2);Jd(145002,21648,3);Jd(145012,21648,1);Jd(145021,21648,2);Jd(145030,21648,4);Jd(145039,21648,3);Jd(145061,21648,1);Jd(145076,21648,4);Jd(145095,21648,0);Jd(145110,21648,3);Jd(145128,21648,2);Jd(145146,21648,5);Jd(145161,21648,64);Jd(145191,21648,0);Jd(145211,21648,3);Jd(145226,21648,2);Jd(145244,21648,1);Jd(145264,21648,0);Jd(145279,21648,6);Jd(145296,21648,4);Jd(145312,21648,2);Jd(145328,21648,1);Jd(145341,21648,0);Jd(145358,21648,128);Jd(145384,21648,8);Jd(145401,21648,17);Jd(145424,21648,33);Jd(145447,21648,65);Jd(145470,21648,16);Jd(145497,21648,32);Jd(145524,21648,64);Jd(145551,21648,-1);Jd(145568,21648,6);Jd(145596,21648,5);Jd(145622,21648,3);Jd(145644,21648,2);Jd(145669,21648,1);Jd(145690,21648,4);Jd(145716,21648,1);Jd(145749,21648,2);Jd(145778,21648,3);Jd(145813,21648,0);Jd(145837,21648,4);Jd(145860,21648,5);Jd(145889,21648,128);Jd(145911,21648,18);Jd(145931,21648,16);Jd(145955,21648,17);Jd(145976,21648,0);Jd(146005,21648,1);Jd(146035,21648,4);Jd(146062,21648,2);Jd(146096,21648,3);Jd(146121,21648,32);Jd(146140,21648,64);Jd(146161,21648,2);Jd(146176,21648,0);Jd(146191,21648,1);Jd(146209,21648,3);Jd(146220,21648,5);Jd(146231,21648,10);Jd(146243,21648,2);Jd(146255,21648,4);Jd(146270,21648,1);Jd(146283,21648,7);Jd(146293,21648,0);Jd(146307,21648,32);Jd(146322,21648,1024);Jd(146338,21648,3);Jd(146360,21648,0);Jd(146376,21648,1);Jd(146392,21648,2);Jd(146411,21648,2);Jd(146429,21648,0);Jd(146451,21648,1);Jd(146477,21648,4);Jd(146484,21648,8);Jd(146491,21648,16);Jd(146499,21648,2);Jd(146514,21648,0);Jd(146530,21648,1);Jd(146545,21648,0);Jd(146558,21648,3);Jd(146573,21648,4);Jd(146587,21648,2);Jd(146599,21648,1);Jd(146619,21648,6);Jd(146640,21648,5);Jd(146659,21648,6);Jd(146674,21648,3);Jd(146686,21648,1);Jd(146698,21648,1);Jd(146711,21648,2);Jd(146725,21648,0);Jd(146737,21648,4);Jd(146752,21648,7);Jd(146766,21648,2);Jd(146777,21648,0);Jd(146788,21648,5);Jd(146801,21648,2);Jd(146815,21648,1);Jd(146832,21648,3);Jd(146850,21648,0);Jd(146869,21648,0);Jd(146883,21648,16384);Jd(146903,21656,7);Jd(146918,21656,-65536);Jd(146933,21648,1124007936);Jd(146947,21648,32768);Jd(146966,21656,4095);Jd(146980,21648,6);Jd(146993,21648,7);Jd(147007,21648,1);Jd(147016,21648,2);Jd(147024,21648,4);Jd(147032,21648,5);Jd(147043,21648,32);Jd(147055,21648,8);Jd(147069,21648,7);Jd(147084,21648,256);Jd(147111,21648,8);Jd(147140,21648,4);Jd(136533,21648,1);Jd(136516,21648,0);Jd(147165,21648,32);Jd(147176,21648,1);Jd(147192,21648,0);Jd(147208,21648,2);Jd(147220,21648,1);Jd(147242,21648,0);Jd(147263,21648,6);Jd(147279,21648,1);Jd(147293,21648,7);Jd(147305,21648,0);Jd(147315,21648,4);Jd(147325,21648,5);Jd(147342,21648,2);Jd(147353,21648,3);Jd(147366,21648,11);Jd(147378,21648,9);Jd(147391,21648,8);Jd(147410,21648,1);Jd(147422,21648,87);Jd(147436,21648,75);Jd(147449,21648,63);Jd(147466,21648,25);Jd(147480,21648,50);Jd(147495,21648,1024);Jd(147512,21648,0);Jd(147527,21648,2);Jd(147539,21648,1);Jd(147555,21648,0);Jd(147571,21648,2);Jd(147588,21648,1);Jd(147599,21648,2);Jd(147610,21648,3);Jd(147621,21648,0);Jd(147632,21648,2);Jd(147643,21648,0);Jd(147657,21648,4);Jd(147672,21648,1);Jd(147682,21648,3);Jd(147692,21648,1);Jd(147703,21648,0);Jd(147715,21648,1);Jd(147726,21648,0);Jd(147746,21648,2);Jd(147773,21648,1);Jd(147787,21648,0);Jd(147802,21648,-2);Jd(147820,21648,-1);Jd(147839,21648,0);Jd(147854,21648,16);Jd(147870,21648,1);Jd(147888,21648,0);Jd(147903,21648,4);Jd(147915,21648,1);Jd(147928,21648,2);Jd(147938,21656,-2147483648);Jd(147957,21656,1540483477);Jd(147978,21656,1123876864);Jd(147998,21656,32);Jd(148016,21648,34);Jd(148041,21648,19);Jd(148067,21648,0);Jd(148092,21648,49);Jd(148119,21648,51);Jd(148144,21648,32);Jd(148170,21648,17);Jd(148195,21648,2);Jd(148222,21648,-2);Jd(148243,21648,0);Jd(148265,21648,2);Jd(148288,21648,-1);Jd(148316,21648,1);Jd(148338,21648,0);Jd(148352,21648,1);Jd(148370,21648,7);Jd(148382,21648,8);Jd(148394,21648,3);Jd(148408,21648,4);Jd(148426,21648,16);Jd(148442,21648,2);Jd(148455,21648,4);Jd(148465,21648,5);Jd(148482,21648,2);Jd(148491,21648,3);Jd(148507,21648,0);Jd(148517,21648,1);Jd(148534,21648,1);Jd(148553,21648,2);Jd(148570,21648,1);Jd(148592,21648,128);Jd(148615,21648,1);Jd(148636,21648,4);Jd(148666,21648,64);Jd(148693,21648,2);Jd(148721,21648,24);Jd(148747,21648,8);Jd(148766,21648,32);Jd(148790,21648,0);Jd(148805,21648,16384);Jd(148826,21656,7);Jd(148842,21656,-65536);Jd(148858,21648,1124007936);Jd(148873,21648,32768);Jd(148893,21656,4095);Jd(148908,21648,2);Jd(148937,21648,1);Jd(148964,21648,4);Jd(148993,21648,0);Jd(149007,21648,8);Jd(149026,21648,16);Jd(149043,21648,1);Jd(149059,21648,256);Jd(149076,21648,1);Jd(149094,21648,0);Jd(149114,21648,16);Jd(149132,21648,0);Jd(149149,21648,0);Jd(149163,21648,4096);Jd(149177,21648,2);Jd(149199,21648,1);Jd(149217,21648,0);Jd(149237,21648,3);Jd(149253,21648,4);Jd(149270,21648,589824);Jd(149295,21648,524288);Jd(149321,21648,393216);Jd(149338,21648,1073741824);Jd(149361,21648,-2147483648);Jd(149384,21648,2031616);Jd(149406,21648,16);Jd(149429,21648,65536);Jd(149445,21648,131072);Jd(149462,21648,0);Jd(149479,21648,458752);Jd(149505,21648,917504);Jd(149527,21648,983040);Jd(149553,21648,786432);Jd(149581,21648,196608);Jd(149604,21648,851968);Jd(149640,21648,327680);Jd(149667,21648,720896);Jd(149695,21648,262144);Jd(149725,21648,655360);Jd(149742,21648,8);Jd(149770,21648,4);Jd(149798,21648,32);Jd(149826,21648,16);Jd(149854,21648,64);Jd(149882,21648,2);Jd(149909,21648,1);Jd(149936,21648,127);Jd(149964,21648,125);Jd(149999,21648,96);Jd(150027,21648,2147483647);Jd(150052,21648,-21);Jd(150061,21648,-18);Jd(150077,21648,-24);Jd(150084,21648,-22);Jd(150096,21648,-12);Jd(150107,21648,-17);Jd(150116,21648,-10);Jd(150129,21648,-14);Jd(150145,21648,-16);Jd(150161,21648,-15);Jd(150176,21648,-11);Jd(150186,21648,-19);Jd(150195,21648,-20);Jd(150205,21648,-25);Jd(150216,21648,-13);Jd(150224,21648,-23);Jd(150236,21648,-217);Jd(150252,21648,-216);Jd(150268,21648,-9);Jd(150281,21648,-26);Jd(150293,21648,-220);Jd(150312,21648,-221);Jd(150337,21648,-222);Jd(150353,21648,-223);Jd(150372,21648,-219);Jd(150391,21648,-218);Jd(150410,21648,-215);Jd(150420,21648,-8);Jd(150433,21648,-1);Jd(150446,21648,-5);Jd(150456,21648,-206);Jd(150467,21648,-6);Jd(150478,21648,-208);Jd(150489,21648,-214);Jd(150504,21648,-207);Jd(150516,21648,-201);Jd(150527,21648,-202);Jd(150540,21648,-2);Jd(150549,21648,-31);Jd(150568,21648,-29);Jd(150594,21648,-203);Jd(150617,21648,-3);Jd(150629,21648,-30);Jd(150655,21648,-7);Jd(150665,21648,-4);Jd(150674,21648,-213);Jd(150692,21648,-27);Jd(150703,21648,-204);Jd(150721,21648,0);Jd(150727,21648,-211);Jd(150741,21648,-212);Jd(150755,21648,-205);Jd(150775,21648,-209);Jd(150793,21648,-210);Jd(150814,21648,-28);Jd(150830,21648,2);Jd(150854,21648,1);Jd(150868,21648,0);Jd(150879,21648,1);Jd(150888,21648,2);Jd(150900,21648,0);Jd(150911,21648,3);Jd(150920,21648,0);Jd(150933,21648,1);Jd(150945,21648,2);return}function ws(a){a=a|0;sd(a|0)|0;WZa()}function xs(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;if((b[374912]|0)==0?u1a(374912)|0:0){h=bf(2,21744)|0;f[225236]=h}h=f[225236]|0;i=NYa(8)|0;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[g>>2]=i;ed(h|0,a|0,c|0,g|0);u=e;return}function ys(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;if((b[374920]|0)==0?u1a(374920)|0:0){h=bf(2,21752)|0;f[225237]=h}h=f[225237]|0;i=NYa(20)|0;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[i+8>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];f[i+16>>2]=f[d+16>>2];f[g>>2]=i;ed(h|0,a|0,c|0,g|0);u=e;return}function zs(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;if((b[374928]|0)==0?u1a(374928)|0:0){h=bf(2,21760)|0;f[225238]=h}h=f[225238]|0;i=NYa(16)|0;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[i+8>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];f[g>>2]=i;ed(h|0,a|0,c|0,g|0);u=e;return}function As(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){Fs(a,b);return}else{f[d>>2]=f[b>>2];f[c>>2]=d+4;return}}function Bs(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e-g>>2;i=e;if(h>>>0<b>>>0){Gs(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b<<2)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~((i+-4-h|0)>>>2)<<2);return}function Cs(a){a=a|0;return (f[a+4>>2]|0)-(f[a>>2]|0)>>2|0}function Ds(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;if((f[b+4>>2]|0)-g>>2>>>0<=c>>>0){h=1;f[a>>2]=h;u=d;return}f[e>>2]=f[g+(c<<2)>>2];h=Ee(21648,e|0)|0;f[a>>2]=h;u=d;return}function Es(a,b,c){a=a|0;b=b|0;c=c|0;f[(f[a>>2]|0)+(b<<2)>>2]=f[c>>2];return 1}function Fs(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)gXa(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;PYa(d);return}function Gs(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;i=h;if(e-h>>2>>>0>=b>>>0){j=i;k=b;while(1){f[j>>2]=f[c>>2];k=k+-1|0;if(!k)break;else j=j+4|0}f[g>>2]=i+(b<<2);return}i=f[a>>2]|0;j=h-i|0;h=j>>2;k=h+b|0;if(k>>>0>1073741823)gXa(a);l=e-i|0;e=l>>1;m=l>>2>>>0<536870911?(e>>>0<k>>>0?k:e):1073741823;do if(m)if(m>>>0>1073741823){e=De(8)|0;UYa(e,358155);f[e>>2]=130560;Of(e|0,21520,875)}else{n=NYa(m<<2)|0;break}else n=0;while(0);e=n+(h<<2)|0;k=n+(m<<2)|0;m=e;n=b;while(1){f[m>>2]=f[c>>2];n=n+-1|0;if(!n)break;else m=m+4|0}m=e+(0-h<<2)|0;if((j|0)>0)K1a(m|0,i|0,j|0)|0;f[a>>2]=m;f[g>>2]=e+(b<<2);f[d>>2]=k;if(!i)return;PYa(i);return}function Hs(a){a=a|0;return 8680}function Is(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}PYa(a);return}function Js(){var a=0;a=NYa(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function Ks(a){a=a|0;return Gi[a&63]()|0}function Ls(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;f[e>>2]=c;Gh[i&511](a,e);u=d;return}function Ms(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;f[g>>2]=d;fi[j&255](a,c,g);u=e;return}function Ns(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=mi[e&255](a)|0;return g|0}else{e=f[(f[a>>2]|0)+c>>2]|0;g=mi[e&255](a)|0;return g|0}return 0}function Os(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;fi[f[a>>2]&255](e,b,c);Qd(f[e>>2]|0);c=f[e>>2]|0;ce(c|0);u=d;return c|0}function Ps(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;f[g>>2]=d;d=ui[h&127](b,c,g)|0;u=e;return d|0}function Qs(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){Vs(a,b);return}else{f[d>>2]=f[b>>2];f[c>>2]=d+4;return}}function Rs(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e-g>>2;i=e;if(h>>>0<b>>>0){Ws(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b<<2)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~((i+-4-h|0)>>>2)<<2);return}function Ss(a){a=a|0;return (f[a+4>>2]|0)-(f[a>>2]|0)>>2|0}function Ts(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;if((f[b+4>>2]|0)-g>>2>>>0<=c>>>0){h=1;f[a>>2]=h;u=d;return}f[e>>2]=f[g+(c<<2)>>2];h=Ee(21680,e|0)|0;f[a>>2]=h;u=d;return}function Us(a,b,c){a=a|0;b=b|0;c=c|0;f[(f[a>>2]|0)+(b<<2)>>2]=f[c>>2];return 1}function Vs(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)gXa(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;PYa(d);return}function Ws(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>2>>>0>=b>>>0){i=h+(b<<2)|0;j=h;k=b;while(1){f[j>>2]=f[c>>2];k=k+-1|0;if(!k)break;else j=j+4|0}f[g>>2]=i;return}i=f[a>>2]|0;j=h-i|0;h=j>>2;k=h+b|0;if(k>>>0>1073741823)gXa(a);l=e-i|0;e=l>>1;m=l>>2>>>0<536870911?(e>>>0<k>>>0?k:e):1073741823;do if(m)if(m>>>0>1073741823){e=De(8)|0;UYa(e,358155);f[e>>2]=130560;Of(e|0,21520,875)}else{n=NYa(m<<2)|0;break}else n=0;while(0);e=n+(h<<2)|0;l=n+(m<<2)|0;m=e;o=b;while(1){f[m>>2]=f[c>>2];o=o+-1|0;if(!o)break;else m=m+4|0}m=e+(0-h<<2)|0;if((j|0)>0)K1a(m|0,i|0,j|0)|0;f[a>>2]=m;f[g>>2]=n+(k<<2);f[d>>2]=l;if(!i)return;PYa(i);return}function Xs(a){a=a|0;return 8768}function Ys(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}PYa(a);return}function Zs(){var a=0;a=NYa(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function _s(a){a=a|0;return Gi[a&63]()|0}function $s(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;n[e>>2]=c;Gh[i&511](a,e);u=d;return}function at(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;n[g>>2]=d;fi[j&255](a,c,g);u=e;return}function bt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=mi[e&255](a)|0;return g|0}else{e=f[(f[a>>2]|0)+c>>2]|0;g=mi[e&255](a)|0;return g|0}return 0}function ct(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;fi[f[a>>2]&255](e,b,c);Qd(f[e>>2]|0);c=f[e>>2]|0;ce(c|0);u=d;return c|0}function dt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;n[g>>2]=d;a=ui[h&127](b,c,g)|0;u=e;return a|0}function et(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){jt(a,b);return}else{p[d>>3]=+p[b>>3];f[c>>2]=d+8;return}}function ft(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e-g>>3;i=e;if(h>>>0<b>>>0){kt(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b<<3)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~((i+-8-h|0)>>>3)<<3);return}function gt(a){a=a|0;return (f[a+4>>2]|0)-(f[a>>2]|0)>>3|0}function ht(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;if((f[b+4>>2]|0)-g>>3>>>0<=c>>>0){h=1;f[a>>2]=h;u=d;return}p[e>>3]=+p[g+(c<<3)>>3];h=Ee(21688,e|0)|0;f[a>>2]=h;u=d;return}function it(a,b,c){a=a|0;b=b|0;c=c|0;p[(f[a>>2]|0)+(b<<3)>>3]=+p[c>>3];return 1}function jt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)gXa(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;p[k>>3]=+p[b>>3];b=k+(0-g<<3)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;PYa(d);return}function kt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;i=h;if(e-h>>3>>>0>=b>>>0){j=i;k=b;while(1){p[j>>3]=+p[c>>3];k=k+-1|0;if(!k)break;else j=j+8|0}f[g>>2]=i+(b<<3);return}i=f[a>>2]|0;j=h-i|0;h=j>>3;k=h+b|0;if(k>>>0>536870911)gXa(a);l=e-i|0;e=l>>2;m=l>>3>>>0<268435455?(e>>>0<k>>>0?k:e):536870911;do if(m)if(m>>>0>536870911){e=De(8)|0;UYa(e,358155);f[e>>2]=130560;Of(e|0,21520,875)}else{n=NYa(m<<3)|0;break}else n=0;while(0);e=n+(h<<3)|0;k=n+(m<<3)|0;m=e;n=b;while(1){p[m>>3]=+p[c>>3];n=n+-1|0;if(!n)break;else m=m+8|0}m=e+(0-h<<3)|0;if((j|0)>0)K1a(m|0,i|0,j|0)|0;f[a>>2]=m;f[g>>2]=e+(b<<3);f[d>>2]=k;if(!i)return;PYa(i);return}function lt(a){a=a|0;return 8848}function mt(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);PYa(b)}PYa(a);return}function nt(){var a=0;a=NYa(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function ot(a){a=a|0;return Gi[a&63]()|0}function pt(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;p[e>>3]=c;Gh[i&511](a,e);u=d;return}function qt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;p[g>>3]=d;fi[j&255](a,c,g);u=e;return}function rt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=mi[e&255](a)|0;return g|0}else{e=f[(f[a>>2]|0)+c>>2]|0;g=mi[e&255](a)|0;return g|0}return 0}function st(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;fi[f[a>>2]&255](e,b,c);Qd(f[e>>2]|0);c=f[e>>2]|0;ce(c|0);u=d;return c|0}function tt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;p[g>>3]=d;a=ui[h&127](b,c,g)|0;u=e;return a|0}function ut(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){zt(a,b);return}else{f[d>>2]=f[b>>2];f[d+4>>2]=f[b+4>>2];f[c>>2]=d+8;return}}function vt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e-g>>3;i=e;if(h>>>0<b>>>0){At(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b<<3)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~((i+-8-h|0)>>>3)<<3);return}function wt(a){a=a|0;return (f[a+4>>2]|0)-(f[a>>2]|0)>>3|0}function xt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;h=g;if((f[b+4>>2]|0)-g>>3>>>0<=c>>>0){i=1;f[a>>2]=i;u=d;return}g=NYa(8)|0;f[g>>2]=f[h+(c<<3)>>2];f[g+4>>2]=f[h+(c<<3)+4>>2];f[e>>2]=g;i=Ee(8984,e|0)|0;f[a>>2]=i;u=d;return}function yt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[a>>2]|0;f[d+(b<<3)>>2]=f[c>>2];f[d+(b<<3)+4>>2]=f[c+4>>2];return 1}function zt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)gXa(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>2;m=k>>3>>>0<268435455?(l>>>0<h>>>0?h:l):536870911;do if(m)if(m>>>0>536870911){l=De(8)|0;UYa(l,358155);f[l>>2]=130560;Of(l|0,21520,875)}else{n=NYa(m<<3)|0;break}else n=0;while(0);l=n+(g<<3)|0;h=n+(m<<3)|0;f[l>>2]=f[b>>2];f[n+(g<<3)+4>>2]=f[b+4>>2];b=l+8|0;if((j|0)==(i|0))o=l;else{g=j+-8-e|0;n=l;m=j;while(1){j=m;m=m+-8|0;f[n+-8>>2]=f[m>>2];f[n+-4>>2]=f[j+-4>>2];if((m|0)==(i|0))break;else n=n+-8|0}o=l+(~(g>>>3)<<3)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;PYa(e);return}function At(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;i=h;if(e-h>>3>>>0>=b>>>0){j=c+4|0;k=i;l=b;while(1){f[k>>2]=f[c>>2];f[k+4>>2]=f[j>>2];l=l+-1|0;if(!l)break;else k=k+8|0}f[g>>2]=i+(b<<3);return}k=f[a>>2]|0;l=h-k>>3;h=l+b|0;j=k;if(h>>>0>536870911)gXa(a);m=e-k|0;e=m>>2;n=m>>3>>>0<268435455?(e>>>0<h>>>0?h:e):536870911;do if(n)if(n>>>0>536870911){e=De(8)|0;UYa(e,358155);f[e>>2]=130560;Of(e|0,21520,875)}else{o=NYa(n<<3)|0;break}else o=0;while(0);e=o+(l<<3)|0;l=o+(n<<3)|0;n=c+4|0;o=e;h=b;while(1){f[o>>2]=f[c>>2];f[o+4>>2]=f[n>>2];h=h+-1|0;if(!h)break;else o=o+8|0}o=l;l=e+(b<<3)|0;if((i|0)==(j|0)){p=e;q=k}else{b=i+-8-k|0;k=e;h=i;while(1){i=h;h=h+-8|0;f[k+-8>>2]=f[h>>2];f[k+-4>>2]=f[i+-4>>2];if((h|0)==(j|0))break;else k=k+-8|0}p=e+(~(b>>>3)<<3)|0;q=f[a>>2]|0}f[a>>2]=p;f[g>>2]=l;f[d>>2]=o;if(!q)return;PYa(q);return}function Bt(a){a=a|0;return 8928}function Ct(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);PYa(b)}PYa(a);return}function Dt(){var a=0;a=NYa(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function Et(a){a=a|0;return Gi[a&63]()|0}function Ft(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){g=d;Gh[g&511](a,c);return}else{g=f[(f[a>>2]|0)+d>>2]|0;Gh[g&511](a,c);return}}function Gt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1)){h=e;fi[h&255](a,c,d);return}else{h=f[(f[a>>2]|0)+e>>2]|0;fi[h&255](a,c,d);return}}function Ht(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=mi[e&255](a)|0;return g|0}else{e=f[(f[a>>2]|0)+c>>2]|0;g=mi[e&255](a)|0;return g|0}return 0}function It(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;fi[f[a>>2]&255](e,b,c);Qd(f[e>>2]|0);c=f[e>>2]|0;ce(c|0);u=d;return c|0}function Jt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ui[f[a>>2]&127](b,c,d)|0}function Kt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){Pt(a,b);return}f[d>>2]=f[b>>2];a=d+4|0;e=b+4|0;f[a>>2]=f[e>>2];g=d+8|0;f[g>>2]=f[b+8>>2];f[d+12>>2]=f[b+12>>2];f[d+16>>2]=f[b+16>>2];f[d+20>>2]=f[b+20>>2];f[d+24>>2]=f[b+24>>2];f[d+28>>2]=f[b+28>>2];f[d+32>>2]=f[b+32>>2];h=f[b+36>>2]|0;f[d+36>>2]=h;f[d+40>>2]=g;g=d+48|0;i=d+44|0;f[i>>2]=g;f[g>>2]=0;f[d+52>>2]=0;if(h|0){g=h+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[e>>2]|0)<3){e=f[b+44>>2]|0;g=f[i>>2]|0;f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2]}else{f[a>>2]=0;BR(d,b)}f[c>>2]=(f[c>>2]|0)+56;return}function Lt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=(e-g|0)/56|0;i=e;if(h>>>0<b>>>0){St(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b*56|0)|0;if((i|0)==(h|0))return;else j=i;do{i=j+-56|0;f[d>>2]=i;b=j+-20|0;g=f[b>>2]|0;if(g|0?(c=g+12|0,g=f[c>>2]|0,f[c>>2]=g+-1,(g|0)==1):0)CR(i);f[b>>2]=0;b=j+-40|0;i=j+-52|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[i>>2]|0)>0){b=f[j+-16>>2]|0;g=0;do{f[b+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[i>>2]|0))}i=f[j+-12>>2]|0;if((i|0)!=(j+-8|0))ZF(i);j=f[d>>2]|0}while((j|0)!=(h|0));return}function Mt(a){a=a|0;return ((f[a+4>>2]|0)-(f[a>>2]|0)|0)/56|0|0}function Nt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;if((((f[b+4>>2]|0)-g|0)/56|0)>>>0<=c>>>0){h=1;f[a>>2]=h;u=d;return}b=au(g+(c*56|0)|0)|0;f[e>>2]=b;h=Ee(9072,e|0)|0;f[a>>2]=h;u=d;return}function Ot(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=f[a>>2]|0;a=d+(b*56|0)|0;if((a|0)==(c|0))return 1;e=c+36|0;g=f[e>>2]|0;if(g|0){h=g+12|0;f[h>>2]=(f[h>>2]|0)+1}h=d+(b*56|0)+36|0;g=f[h>>2]|0;if(g|0?(i=g+12|0,g=f[i>>2]|0,f[i>>2]=g+-1,(g|0)==1):0)CR(a);f[h>>2]=0;g=d+(b*56|0)+16|0;i=d+(b*56|0)+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){j=f[d+(b*56|0)+40>>2]|0;k=0;do{f[j+(k<<2)>>2]=0;k=k+1|0;l=f[i>>2]|0}while((k|0)<(l|0));f[a>>2]=f[c>>2];if((l|0)<3)m=12;else m=14}else{f[a>>2]=f[c>>2];m=12}if((m|0)==12){l=f[c+4>>2]|0;if((l|0)<3){f[i>>2]=l;f[d+(b*56|0)+8>>2]=f[c+8>>2];f[d+(b*56|0)+12>>2]=f[c+12>>2];l=f[c+44>>2]|0;i=f[d+(b*56|0)+44>>2]|0;f[i>>2]=f[l>>2];f[i+4>>2]=f[l+4>>2]}else m=14}if((m|0)==14)BR(a,c);f[g>>2]=f[c+16>>2];f[d+(b*56|0)+20>>2]=f[c+20>>2];f[d+(b*56|0)+24>>2]=f[c+24>>2];f[d+(b*56|0)+28>>2]=f[c+28>>2];f[d+(b*56|0)+32>>2]=f[c+32>>2];f[h>>2]=f[e>>2];return 1}function Pt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+32|0;d=c;e=f[a>>2]|0;g=((f[a+4>>2]|0)-e|0)/56|0;h=g+1|0;if(h>>>0>76695844)gXa(a);i=((f[a+8>>2]|0)-e|0)/56|0;e=i<<1;j=i>>>0<38347922?(e>>>0<h>>>0?h:e):76695844;f[d+12>>2]=0;f[d+16>>2]=a+8;do if(j)if(j>>>0>76695844){e=De(8)|0;UYa(e,358155);f[e>>2]=130560;Of(e|0,21520,875)}else{k=NYa(j*56|0)|0;break}else k=0;while(0);f[d>>2]=k;e=k+(g*56|0)|0;h=d+8|0;f[h>>2]=e;f[d+4>>2]=e;f[d+12>>2]=k+(j*56|0);f[e>>2]=f[b>>2];j=k+(g*56|0)+4|0;i=b+4|0;l=f[i>>2]|0;f[j>>2]=l;m=k+(g*56|0)+8|0;f[m>>2]=f[b+8>>2];f[k+(g*56|0)+12>>2]=f[b+12>>2];f[k+(g*56|0)+16>>2]=f[b+16>>2];f[k+(g*56|0)+20>>2]=f[b+20>>2];f[k+(g*56|0)+24>>2]=f[b+24>>2];f[k+(g*56|0)+28>>2]=f[b+28>>2];f[k+(g*56|0)+32>>2]=f[b+32>>2];n=f[b+36>>2]|0;f[k+(g*56|0)+36>>2]=n;f[k+(g*56|0)+40>>2]=m;m=k+(g*56|0)+48|0;o=k+(g*56|0)+44|0;f[o>>2]=m;f[m>>2]=0;f[k+(g*56|0)+52>>2]=0;if(!n)p=l;else{l=n+12|0;f[l>>2]=(f[l>>2]|0)+1;p=f[i>>2]|0}if((p|0)<3){p=f[b+44>>2]|0;i=f[o>>2]|0;f[i>>2]=f[p>>2];f[i+4>>2]=f[p+4>>2];q=f[h>>2]|0;r=q+56|0;f[h>>2]=r;Qt(a,d);Rt(d);u=c;return}else{f[j>>2]=0;BR(e,b);q=f[h>>2]|0;r=q+56|0;f[h>>2]=r;Qt(a,d);Rt(d);u=c;return}}function Qt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=f[a>>2]|0;d=a+4|0;e=f[d>>2]|0;g=b+4|0;if((e|0)==(c|0)){h=g;i=a;j=f[g>>2]|0;k=c;f[i>>2]=j;f[h>>2]=k;l=b+8|0;m=f[d>>2]|0;n=f[l>>2]|0;f[d>>2]=n;f[l>>2]=m;o=a+8|0;p=b+12|0;q=f[o>>2]|0;r=f[p>>2]|0;f[o>>2]=r;f[p>>2]=q;s=f[h>>2]|0;f[b>>2]=s;return}t=f[g>>2]|0;u=e;do{e=t+-56|0;v=u;u=u+-56|0;f[e>>2]=f[u>>2];w=t+-52|0;x=v+-52|0;f[w>>2]=f[x>>2];y=t+-48|0;f[y>>2]=f[v+-48>>2];f[t+-44>>2]=f[v+-44>>2];f[t+-40>>2]=f[v+-40>>2];f[t+-36>>2]=f[v+-36>>2];f[t+-32>>2]=f[v+-32>>2];f[t+-28>>2]=f[v+-28>>2];f[t+-24>>2]=f[v+-24>>2];z=f[v+-20>>2]|0;f[t+-20>>2]=z;f[t+-16>>2]=y;y=t+-8|0;A=t+-12|0;f[A>>2]=y;f[y>>2]=0;f[t+-4>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[v+-12>>2]|0;v=f[A>>2]|0;f[v>>2]=f[x>>2];f[v+4>>2]=f[x+4>>2]}else{f[w>>2]=0;BR(e,u)}t=(f[g>>2]|0)+-56|0;f[g>>2]=t}while((u|0)!=(c|0));h=g;i=a;j=t;k=f[a>>2]|0;f[i>>2]=j;f[h>>2]=k;l=b+8|0;m=f[d>>2]|0;n=f[l>>2]|0;f[d>>2]=n;f[l>>2]=m;o=a+8|0;p=b+12|0;q=f[o>>2]|0;r=f[p>>2]|0;f[o>>2]=r;f[p>>2]=q;s=f[h>>2]|0;f[b>>2]=s;return}function Rt(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=f[a+4>>2]|0;c=a+8|0;d=f[c>>2]|0;if((d|0)!=(b|0)){e=d;do{d=e+-56|0;f[c>>2]=d;g=e+-20|0;h=f[g>>2]|0;if(h|0?(i=h+12|0,h=f[i>>2]|0,f[i>>2]=h+-1,(h|0)==1):0)CR(d);f[g>>2]=0;g=e+-40|0;d=e+-52|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[d>>2]|0)>0){g=f[e+-16>>2]|0;h=0;do{f[g+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[d>>2]|0))}d=f[e+-12>>2]|0;if((d|0)!=(e+-8|0))ZF(d);e=f[c>>2]|0}while((e|0)!=(b|0))}b=f[a>>2]|0;if(!b)return;PYa(b);return}function St(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+32|0;e=d;g=f[a+8>>2]|0;h=a+4|0;i=f[h>>2]|0;if(((g-i|0)/56|0)>>>0>=b>>>0){j=c+4|0;k=c+8|0;l=c+12|0;m=c+16|0;n=c+20|0;o=c+24|0;p=c+28|0;q=c+32|0;r=c+36|0;s=c+44|0;t=i;v=b;do{f[t>>2]=f[c>>2];w=t+4|0;f[w>>2]=f[j>>2];x=t+8|0;f[x>>2]=f[k>>2];f[t+12>>2]=f[l>>2];f[t+16>>2]=f[m>>2];f[t+20>>2]=f[n>>2];f[t+24>>2]=f[o>>2];f[t+28>>2]=f[p>>2];f[t+32>>2]=f[q>>2];y=f[r>>2]|0;f[t+36>>2]=y;f[t+40>>2]=x;x=t+48|0;z=t+44|0;f[z>>2]=x;f[x>>2]=0;f[t+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[j>>2]|0)<3){x=f[s>>2]|0;y=f[z>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2]}else{f[w>>2]=0;BR(t,c)}t=(f[h>>2]|0)+56|0;f[h>>2]=t;v=v+-1|0}while((v|0)!=0);u=d;return}v=f[a>>2]|0;t=(i-v|0)/56|0;i=t+b|0;if(i>>>0>76695844)gXa(a);h=(g-v|0)/56|0;v=h<<1;g=h>>>0<38347922?(v>>>0<i>>>0?i:v):76695844;f[e+12>>2]=0;f[e+16>>2]=a+8;do if(g)if(g>>>0>76695844){v=De(8)|0;UYa(v,358155);f[v>>2]=130560;Of(v|0,21520,875)}else{A=NYa(g*56|0)|0;break}else A=0;while(0);f[e>>2]=A;v=A+(t*56|0)|0;t=e+8|0;f[t>>2]=v;f[e+4>>2]=v;f[e+12>>2]=A+(g*56|0);g=c+4|0;A=c+8|0;i=c+12|0;h=c+16|0;s=c+20|0;j=c+24|0;r=c+28|0;q=c+32|0;p=c+36|0;o=c+44|0;n=v;v=b;do{f[n>>2]=f[c>>2];b=n+4|0;f[b>>2]=f[g>>2];m=n+8|0;f[m>>2]=f[A>>2];f[n+12>>2]=f[i>>2];f[n+16>>2]=f[h>>2];f[n+20>>2]=f[s>>2];f[n+24>>2]=f[j>>2];f[n+28>>2]=f[r>>2];f[n+32>>2]=f[q>>2];l=f[p>>2]|0;f[n+36>>2]=l;f[n+40>>2]=m;m=n+48|0;k=n+44|0;f[k>>2]=m;f[m>>2]=0;f[n+52>>2]=0;if(l|0){m=l+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[g>>2]|0)<3){m=f[o>>2]|0;l=f[k>>2]|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2]}else{f[b>>2]=0;BR(n,c)}n=(f[t>>2]|0)+56|0;f[t>>2]=n;v=v+-1|0}while((v|0)!=0);Qt(a,e);Rt(e);u=d;return}function Tt(a){a=a|0;return 9016}function Ut(a){a=a|0;if(!a)return;Vt(a);PYa(a);return}function Vt(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a>>2]|0;if(!b)return;c=a+4|0;d=f[c>>2]|0;if((d|0)==(b|0))e=b;else{g=d;do{d=g+-56|0;f[c>>2]=d;h=g+-20|0;i=f[h>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)CR(d);f[h>>2]=0;h=g+-40|0;d=g+-52|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[d>>2]|0)>0){h=f[g+-16>>2]|0;i=0;do{f[h+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[d>>2]|0))}d=f[g+-12>>2]|0;if((d|0)!=(g+-8|0))ZF(d);g=f[c>>2]|0}while((g|0)!=(b|0));e=f[a>>2]|0}PYa(e);return}function Wt(){var a=0;a=NYa(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function Xt(a){a=a|0;return Gi[a&63]()|0}function Yt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){g=d;Gh[g&511](a,c);return}else{g=f[(f[a>>2]|0)+d>>2]|0;Gh[g&511](a,c);return}}function Zt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1)){h=e;fi[h&255](a,c,d);return}else{h=f[(f[a>>2]|0)+e>>2]|0;fi[h&255](a,c,d);return}}function _t(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=mi[e&255](a)|0;return g|0}else{e=f[(f[a>>2]|0)+c>>2]|0;g=mi[e&255](a)|0;return g|0}return 0}function $t(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;fi[f[a>>2]&255](e,b,c);Qd(f[e>>2]|0);c=f[e>>2]|0;ce(c|0);u=d;return c|0}function au(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=NYa(56)|0;f[b>>2]=f[a>>2];c=b+4|0;d=a+4|0;e=f[d>>2]|0;f[c>>2]=e;g=b+8|0;f[g>>2]=f[a+8>>2];f[b+12>>2]=f[a+12>>2];f[b+16>>2]=f[a+16>>2];f[b+20>>2]=f[a+20>>2];f[b+24>>2]=f[a+24>>2];f[b+28>>2]=f[a+28>>2];f[b+32>>2]=f[a+32>>2];h=f[a+36>>2]|0;f[b+36>>2]=h;f[b+40>>2]=g;g=b+48|0;i=b+44|0;f[i>>2]=g;f[g>>2]=0;f[b+52>>2]=0;if(!h)j=e;else{e=h+12|0;f[e>>2]=(f[e>>2]|0)+1;j=f[d>>2]|0}if((j|0)<3){j=f[a+44>>2]|0;d=f[i>>2]|0;f[d>>2]=f[j>>2];f[d+4>>2]=f[j+4>>2];return b|0}else{f[c>>2]=0;BR(b,a);return b|0}return 0}function bu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ui[f[a>>2]&127](b,c,d)|0}function cu(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){hu(a,b);return}else{f[d>>2]=f[b>>2];f[d+4>>2]=f[b+4>>2];a=d+8|0;d=b+8|0;f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];f[a+8>>2]=f[d+8>>2];f[a+12>>2]=f[d+12>>2];f[a+16>>2]=f[d+16>>2];f[c>>2]=(f[c>>2]|0)+28;return}}function du(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=(e-g|0)/28|0;i=e;if(h>>>0<b>>>0){iu(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b*28|0)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~(((i+-28-h|0)>>>0)/28|0)*28|0);return}function eu(a){a=a|0;return ((f[a+4>>2]|0)-(f[a>>2]|0)|0)/28|0|0}function fu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;h=g;if((((f[b+4>>2]|0)-g|0)/28|0)>>>0<=c>>>0){i=1;f[a>>2]=i;u=d;return}g=NYa(28)|0;f[g>>2]=f[h+(c*28|0)>>2];f[g+4>>2]=f[h+(c*28|0)+4>>2];b=g+8|0;j=h+(c*28|0)+8|0;f[b>>2]=f[j>>2];f[b+4>>2]=f[j+4>>2];f[b+8>>2]=f[j+8>>2];f[b+12>>2]=f[j+12>>2];f[b+16>>2]=f[j+16>>2];f[e>>2]=g;i=Ee(9160,e|0)|0;f[a>>2]=i;u=d;return}function gu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[a>>2]|0;f[d+(b*28|0)>>2]=f[c>>2];f[d+(b*28|0)+4>>2]=f[c+4>>2];a=d+(b*28|0)+8|0;b=c+8|0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];return 1}function hu(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/28|0;h=g+1|0;i=e;j=d;if(h>>>0>153391689)gXa(a);k=a+8|0;l=((f[k>>2]|0)-e|0)/28|0;e=l<<1;m=l>>>0<76695844?(e>>>0<h>>>0?h:e):153391689;do if(m)if(m>>>0>153391689){e=De(8)|0;UYa(e,358155);f[e>>2]=130560;Of(e|0,21520,875)}else{n=NYa(m*28|0)|0;break}else n=0;while(0);e=n+(g*28|0)|0;h=e;l=n+(m*28|0)|0;f[e>>2]=f[b>>2];f[n+(g*28|0)+4>>2]=f[b+4>>2];m=n+(g*28|0)+8|0;g=b+8|0;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[m+8>>2]=f[g+8>>2];f[m+12>>2]=f[g+12>>2];f[m+16>>2]=f[g+16>>2];g=e+28|0;if((j|0)==(i|0)){o=h;p=d}else{d=e;e=j;j=h;do{h=e;e=e+-28|0;f[d+-28>>2]=f[e>>2];f[d+-24>>2]=f[h+-24>>2];m=d+-20|0;b=h+-20|0;f[m>>2]=f[b>>2];f[m+4>>2]=f[b+4>>2];f[m+8>>2]=f[b+8>>2];f[m+12>>2]=f[b+12>>2];f[m+16>>2]=f[b+16>>2];d=j+-28|0;j=d}while((e|0)!=(i|0));o=j;p=f[a>>2]|0}f[a>>2]=o;f[c>>2]=g;f[k>>2]=l;if(!p)return;PYa(p);return}function iu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/28|0)>>>0>=b>>>0){i=c+4|0;j=c+8|0;k=h;l=b;do{f[k>>2]=f[c>>2];f[k+4>>2]=f[i>>2];m=k+8|0;f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];f[m+8>>2]=f[j+8>>2];f[m+12>>2]=f[j+12>>2];f[m+16>>2]=f[j+16>>2];k=(f[g>>2]|0)+28|0;f[g>>2]=k;l=l+-1|0}while((l|0)!=0);return}l=f[a>>2]|0;k=(h-l|0)/28|0;h=k+b|0;if(h>>>0>153391689)gXa(a);j=(e-l|0)/28|0;l=j<<1;e=j>>>0<76695844?(l>>>0<h>>>0?h:l):153391689;do if(e)if(e>>>0>153391689){l=De(8)|0;UYa(l,358155);f[l>>2]=130560;Of(l|0,21520,875)}else{n=NYa(e*28|0)|0;break}else n=0;while(0);l=n+(k*28|0)|0;k=l;h=n+(e*28|0)|0;e=c+4|0;n=c+8|0;j=l;i=b;b=k;do{f[j>>2]=f[c>>2];f[j+4>>2]=f[e>>2];m=j+8|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];f[m+12>>2]=f[n+12>>2];f[m+16>>2]=f[n+16>>2];j=b+28|0;b=j;i=i+-1|0}while((i|0)!=0);i=h;h=f[a>>2]|0;j=f[g>>2]|0;if((j|0)==(h|0)){o=k;p=h}else{n=l;l=j;j=k;do{k=l;l=l+-28|0;f[n+-28>>2]=f[l>>2];f[n+-24>>2]=f[k+-24>>2];e=n+-20|0;c=k+-20|0;f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];f[e+8>>2]=f[c+8>>2];f[e+12>>2]=f[c+12>>2];f[e+16>>2]=f[c+16>>2];n=j+-28|0;j=n}while((l|0)!=(h|0));o=j;p=f[a>>2]|0}f[a>>2]=o;f[g>>2]=b;f[d>>2]=i;if(!p)return;PYa(p);return}function ju(a){a=a|0;return 9104}function ku(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~(((d+-28-b|0)>>>0)/28|0)*28|0);PYa(b)}PYa(a);return}function lu(){var a=0;a=NYa(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function mu(a){a=a|0;return Gi[a&63]()|0}function nu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){g=d;Gh[g&511](a,c);return}else{g=f[(f[a>>2]|0)+d>>2]|0;Gh[g&511](a,c);return}}function ou(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1)){h=e;fi[h&255](a,c,d);return}else{h=f[(f[a>>2]|0)+e>>2]|0;fi[h&255](a,c,d);return}}function pu(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=mi[e&255](a)|0;return g|0}else{e=f[(f[a>>2]|0)+c>>2]|0;g=mi[e&255](a)|0;return g|0}return 0}function qu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;fi[f[a>>2]&255](e,b,c);Qd(f[e>>2]|0);c=f[e>>2]|0;ce(c|0);u=d;return c|0}function ru(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ui[f[a>>2]&127](b,c,d)|0}function su(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){xu(a,b);return}else{yu(d,b);f[c>>2]=(f[c>>2]|0)+12;return}}function tu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=(e-g|0)/12|0;i=e;if(h>>>0<b>>>0){zu(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b*12|0)|0;if((i|0)==(h|0))return;else j=i;while(1){i=j+-12|0;f[d>>2]=i;b=f[i>>2]|0;if(!b)k=i;else{i=j+-8|0;g=f[i>>2]|0;if((g|0)!=(b|0))f[i>>2]=g+(~(((g+-28-b|0)>>>0)/28|0)*28|0);PYa(b);k=f[d>>2]|0}if((k|0)==(h|0))break;else j=k}return}function uu(a){a=a|0;return ((f[a+4>>2]|0)-(f[a>>2]|0)|0)/12|0|0}function vu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;if((((f[b+4>>2]|0)-g|0)/12|0)>>>0>c>>>0){b=NYa(12)|0;yu(b,g+(c*12|0)|0);f[e>>2]=b;b=Ee(9104,e|0)|0;f[a>>2]=b;u=d;return}else{f[a>>2]=1;u=d;return}}function wu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=(f[a>>2]|0)+(b*12|0)|0;if((d|0)==(c|0))return 1;Ju(d,f[c>>2]|0,f[c+4>>2]|0);return 1}function xu(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/12|0;g=e+1|0;if(g>>>0>357913941)gXa(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/12|0;d=i<<1;j=i>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(j)if(j>>>0>357913941){d=De(8)|0;UYa(d,358155);f[d>>2]=130560;Of(d|0,21520,875)}else{k=NYa(j*12|0)|0;break}else k=0;while(0);d=k+(e*12|0)|0;e=d;g=k+(j*12|0)|0;yu(d,b);b=d+12|0;j=f[a>>2]|0;k=f[c>>2]|0;if((k|0)==(j|0)){l=e;m=j;n=j}else{i=d;d=k;k=e;do{e=i+-12|0;o=d;d=d+-12|0;f[e>>2]=0;p=i+-8|0;f[p>>2]=0;f[i+-4>>2]=0;f[e>>2]=f[d>>2];e=o+-8|0;f[p>>2]=f[e>>2];p=o+-4|0;f[i+-4>>2]=f[p>>2];f[p>>2]=0;f[e>>2]=0;f[d>>2]=0;i=k+-12|0;k=i}while((d|0)!=(j|0));l=k;m=f[a>>2]|0;n=f[c>>2]|0}f[a>>2]=l;f[c>>2]=b;f[h>>2]=g;g=m;if((n|0)!=(g|0)){h=n;do{n=h;h=h+-12|0;b=f[h>>2]|0;if(b|0){c=n+-8|0;n=f[c>>2]|0;if((n|0)!=(b|0))f[c>>2]=n+(~(((n+-28-b|0)>>>0)/28|0)*28|0);PYa(b)}}while((h|0)!=(g|0))}if(!m)return;PYa(m);return}function yu(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=(e|0)/28|0;if(!e)return;if(g>>>0>153391689)gXa(a);h=NYa(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g*28|0);g=f[b>>2]|0;b=f[d>>2]|0;if((g|0)==(b|0))return;d=h;h=g;do{f[d>>2]=f[h>>2];f[d+4>>2]=f[h+4>>2];g=d+8|0;a=h+8|0;f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];f[g+8>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[g+16>>2]=f[a+16>>2];h=h+28|0;d=(f[c>>2]|0)+28|0;f[c>>2]=d}while((h|0)!=(b|0));return}function zu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/12|0)>>>0>=b>>>0){i=h;j=b;do{yu(i,c);i=(f[g>>2]|0)+12|0;f[g>>2]=i;j=j+-1|0}while((j|0)!=0);return}j=f[a>>2]|0;i=(h-j|0)/12|0;h=i+b|0;if(h>>>0>357913941)gXa(a);k=(e-j|0)/12|0;j=k<<1;e=k>>>0<178956970?(j>>>0<h>>>0?h:j):357913941;do if(e)if(e>>>0>357913941){j=De(8)|0;UYa(j,358155);f[j>>2]=130560;Of(j|0,21520,875)}else{l=NYa(e*12|0)|0;break}else l=0;while(0);j=l+(i*12|0)|0;i=j;h=l+(e*12|0)|0;e=j;l=b;b=i;do{yu(e,c);e=b+12|0;b=e;l=l+-1|0}while((l|0)!=0);l=f[a>>2]|0;e=f[g>>2]|0;if((e|0)==(l|0)){m=i;n=l;o=l}else{c=j;j=e;e=i;do{i=c+-12|0;k=j;j=j+-12|0;f[i>>2]=0;p=c+-8|0;f[p>>2]=0;f[c+-4>>2]=0;f[i>>2]=f[j>>2];i=k+-8|0;f[p>>2]=f[i>>2];p=k+-4|0;f[c+-4>>2]=f[p>>2];f[p>>2]=0;f[i>>2]=0;f[j>>2]=0;c=e+-12|0;e=c}while((j|0)!=(l|0));m=e;n=f[a>>2]|0;o=f[g>>2]|0}f[a>>2]=m;f[g>>2]=b;f[d>>2]=h;h=n;if((o|0)!=(h|0)){d=o;do{o=d;d=d+-12|0;b=f[d>>2]|0;if(b|0){g=o+-8|0;o=f[g>>2]|0;if((o|0)!=(b|0))f[g>>2]=o+(~(((o+-28-b|0)>>>0)/28|0)*28|0);PYa(b)}}while((d|0)!=(h|0))}if(!n)return;PYa(n);return}function Au(a){a=a|0;return 9192}function Bu(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)==(b|0))e=b;else{g=d;while(1){d=g+-12|0;f[c>>2]=d;h=f[d>>2]|0;if(!h)i=d;else{d=g+-8|0;j=f[d>>2]|0;if((j|0)!=(h|0))f[d>>2]=j+(~(((j+-28-h|0)>>>0)/28|0)*28|0);PYa(h);i=f[c>>2]|0}if((i|0)==(b|0))break;else g=i}e=f[a>>2]|0}PYa(e)}PYa(a);return}function Cu(){var a=0;a=NYa(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function Du(a){a=a|0;return Gi[a&63]()|0}function Eu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){g=d;Gh[g&511](a,c);return}else{g=f[(f[a>>2]|0)+d>>2]|0;Gh[g&511](a,c);return}}function Fu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1)){h=e;fi[h&255](a,c,d);return}else{h=f[(f[a>>2]|0)+e>>2]|0;fi[h&255](a,c,d);return}}function Gu(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=mi[e&255](a)|0;return g|0}else{e=f[(f[a>>2]|0)+c>>2]|0;g=mi[e&255](a)|0;return g|0}return 0}function Hu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;fi[f[a>>2]&255](e,b,c);Qd(f[e>>2]|0);c=f[e>>2]|0;ce(c|0);u=d;return c|0}function Iu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ui[f[a>>2]&127](b,c,d)|0}function Ju(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=(c-b|0)/28|0;e=a+8|0;g=f[e>>2]|0;h=f[a>>2]|0;i=h;if(d>>>0<=((g-h|0)/28|0)>>>0){j=a+4|0;k=((f[j>>2]|0)-h|0)/28|0;l=d>>>0>k>>>0;m=b+(k*28|0)|0;k=l?m:c;if((k|0)==(b|0))n=i;else{o=b;p=i;while(1){f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];q=p+8|0;r=o+8|0;f[q>>2]=f[r>>2];f[q+4>>2]=f[r+4>>2];f[q+8>>2]=f[r+8>>2];f[q+12>>2]=f[r+12>>2];f[q+16>>2]=f[r+16>>2];o=o+28|0;r=p+28|0;if((o|0)==(k|0)){n=r;break}else p=r}}if(!l){l=f[j>>2]|0;if((l|0)==(n|0))return;f[j>>2]=l+(~(((l+-28-n|0)>>>0)/28|0)*28|0);return}if((k|0)==(c|0))return;k=f[j>>2]|0;n=m;do{f[k>>2]=f[n>>2];f[k+4>>2]=f[n+4>>2];m=k+8|0;l=n+8|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];f[m+8>>2]=f[l+8>>2];f[m+12>>2]=f[l+12>>2];f[m+16>>2]=f[l+16>>2];n=n+28|0;k=(f[j>>2]|0)+28|0;f[j>>2]=k}while((n|0)!=(c|0));return}n=h;if(!h)s=g;else{g=a+4|0;k=f[g>>2]|0;if((k|0)!=(i|0))f[g>>2]=k+(~(((k+-28-h|0)>>>0)/28|0)*28|0);PYa(n);f[e>>2]=0;f[g>>2]=0;f[a>>2]=0;s=0}if(d>>>0>153391689)gXa(a);g=(s|0)/28|0;s=g<<1;n=g>>>0<76695844?(s>>>0<d>>>0?d:s):153391689;if(n>>>0>153391689)gXa(a);s=NYa(n*28|0)|0;d=a+4|0;f[d>>2]=s;f[a>>2]=s;f[e>>2]=s+(n*28|0);if((b|0)==(c|0))return;n=s;s=b;do{f[n>>2]=f[s>>2];f[n+4>>2]=f[s+4>>2];b=n+8|0;e=s+8|0;f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];f[b+8>>2]=f[e+8>>2];f[b+12>>2]=f[e+12>>2];f[b+16>>2]=f[e+16>>2];s=s+28|0;n=(f[d>>2]|0)+28|0;f[d>>2]=n}while((s|0)!=(c|0));return}function Ku(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){Pu(a,b);return}else{f[d>>2]=f[b>>2];f[d+4>>2]=f[b+4>>2];f[d+8>>2]=f[b+8>>2];f[d+12>>2]=f[b+12>>2];f[c>>2]=d+16;return}}function Lu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e-g>>4;i=e;if(h>>>0<b>>>0){Qu(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b<<4)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~((i+-16-h|0)>>>4)<<4);return}function Mu(a){a=a|0;return (f[a+4>>2]|0)-(f[a>>2]|0)>>4|0}function Nu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;h=g;if((f[b+4>>2]|0)-g>>4>>>0<=c>>>0){i=1;f[a>>2]=i;u=d;return}g=NYa(16)|0;f[g>>2]=f[h+(c<<4)>>2];f[g+4>>2]=f[h+(c<<4)+4>>2];f[g+8>>2]=f[h+(c<<4)+8>>2];f[g+12>>2]=f[h+(c<<4)+12>>2];f[e>>2]=g;i=Ee(8640,e|0)|0;f[a>>2]=i;u=d;return}function Ou(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[a>>2]|0;f[d+(b<<4)>>2]=f[c>>2];f[d+(b<<4)+4>>2]=f[c+4>>2];f[d+(b<<4)+8>>2]=f[c+8>>2];f[d+(b<<4)+12>>2]=f[c+12>>2];return 1}function Pu(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)gXa(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=De(8)|0;UYa(l,358155);f[l>>2]=130560;Of(l|0,21520,875)}else{n=NYa(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;f[l>>2]=f[b>>2];f[n+(g<<4)+4>>2]=f[b+4>>2];f[n+(g<<4)+8>>2]=f[b+8>>2];f[n+(g<<4)+12>>2]=f[b+12>>2];b=l+16|0;if((j|0)==(i|0))o=l;else{g=j+-16-e|0;n=l;m=j;while(1){j=m;m=m+-16|0;f[n+-16>>2]=f[m>>2];f[n+-12>>2]=f[j+-12>>2];f[n+-8>>2]=f[j+-8>>2];f[n+-4>>2]=f[j+-4>>2];if((m|0)==(i|0))break;else n=n+-16|0}o=l+(~(g>>>4)<<4)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;PYa(e);return}function Qu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;i=h;if(e-h>>4>>>0>=b>>>0){j=c+4|0;k=c+8|0;l=c+12|0;m=i;n=b;while(1){f[m>>2]=f[c>>2];f[m+4>>2]=f[j>>2];f[m+8>>2]=f[k>>2];f[m+12>>2]=f[l>>2];n=n+-1|0;if(!n)break;else m=m+16|0}f[g>>2]=i+(b<<4);return}m=f[a>>2]|0;n=h-m>>4;h=n+b|0;l=m;if(h>>>0>268435455)gXa(a);k=e-m|0;e=k>>3;j=k>>4>>>0<134217727?(e>>>0<h>>>0?h:e):268435455;do if(j)if(j>>>0>268435455){e=De(8)|0;UYa(e,358155);f[e>>2]=130560;Of(e|0,21520,875)}else{o=NYa(j<<4)|0;break}else o=0;while(0);e=o+(n<<4)|0;n=o+(j<<4)|0;j=c+4|0;o=c+8|0;h=c+12|0;k=e;p=b;while(1){f[k>>2]=f[c>>2];f[k+4>>2]=f[j>>2];f[k+8>>2]=f[o>>2];f[k+12>>2]=f[h>>2];p=p+-1|0;if(!p)break;else k=k+16|0}k=n;n=e+(b<<4)|0;if((i|0)==(l|0)){q=e;r=m}else{b=i+-16-m|0;m=e;p=i;while(1){i=p;p=p+-16|0;f[m+-16>>2]=f[p>>2];f[m+-12>>2]=f[i+-12>>2];f[m+-8>>2]=f[i+-8>>2];f[m+-4>>2]=f[i+-4>>2];if((p|0)==(l|0))break;else m=m+-16|0}q=e+(~(b>>>4)<<4)|0;r=f[a>>2]|0}f[a>>2]=q;f[g>>2]=n;f[d>>2]=k;if(!r)return;PYa(r);return}function Ru(a){a=a|0;return 9272}function Su(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-16-b|0)>>>4)<<4);PYa(b)}PYa(a);return}function Tu(){var a=0;a=NYa(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function Uu(a){a=a|0;return Gi[a&63]()|0}function Vu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){g=d;Gh[g&511](a,c);return}else{g=f[(f[a>>2]|0)+d>>2]|0;Gh[g&511](a,c);return}}function Wu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1)){h=e;fi[h&255](a,c,d);return}else{h=f[(f[a>>2]|0)+e>>2]|0;fi[h&255](a,c,d);return}}function Xu(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=mi[e&255](a)|0;return g|0}else{e=f[(f[a>>2]|0)+c>>2]|0;g=mi[e&255](a)|0;return g|0}return 0}function Yu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;fi[f[a>>2]&255](e,b,c);Qd(f[e>>2]|0);c=f[e>>2]|0;ce(c|0);u=d;return c|0}function Zu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ui[f[a>>2]&127](b,c,d)|0}function _u(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){dv(a,b);return}else{f[d>>2]=f[b>>2];f[d+4>>2]=f[b+4>>2];f[d+8>>2]=f[b+8>>2];f[d+12>>2]=f[b+12>>2];f[c>>2]=(f[c>>2]|0)+16;return}}function $u(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e-g>>4;i=e;if(h>>>0<b>>>0){ev(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b<<4)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~((i+-16-h|0)>>>4)<<4);return}function av(a){a=a|0;return (f[a+4>>2]|0)-(f[a>>2]|0)>>4|0}function bv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;if((f[b+4>>2]|0)-g>>4>>>0<=c>>>0){h=1;f[a>>2]=h;u=d;return}b=g+(c<<4)|0;c=NYa(16)|0;f[c>>2]=f[b>>2];f[c+4>>2]=f[b+4>>2];f[c+8>>2]=f[b+8>>2];f[c+12>>2]=f[b+12>>2];f[e>>2]=c;h=Ee(9408,e|0)|0;f[a>>2]=h;u=d;return}function cv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=(f[a>>2]|0)+(b<<4)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];f[d+8>>2]=f[c+8>>2];f[d+12>>2]=f[c+12>>2];return 1}function dv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)gXa(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;PYa(d);return}function ev(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>4>>>0>=b>>>0){i=h;j=b;do{f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];f[i+8>>2]=f[c+8>>2];f[i+12>>2]=f[c+12>>2];i=(f[g>>2]|0)+16|0;f[g>>2]=i;j=j+-1|0}while((j|0)!=0);return}j=f[a>>2]|0;i=h-j>>4;h=i+b|0;if(h>>>0>268435455)gXa(a);k=e-j|0;j=k>>3;e=k>>4>>>0<134217727?(j>>>0<h>>>0?h:j):268435455;do if(e)if(e>>>0>268435455){j=De(8)|0;UYa(j,358155);f[j>>2]=130560;Of(j|0,21520,875)}else{l=NYa(e<<4)|0;break}else l=0;while(0);j=l+(i<<4)|0;i=l+(e<<4)|0;e=j;l=b;b=j;do{f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];f[e+8>>2]=f[c+8>>2];f[e+12>>2]=f[c+12>>2];e=b+16|0;b=e;l=l+-1|0}while((l|0)!=0);l=f[a>>2]|0;e=(f[g>>2]|0)-l|0;c=j+(0-(e>>4)<<4)|0;if((e|0)>0)K1a(c|0,l|0,e|0)|0;f[a>>2]=c;f[g>>2]=b;f[d>>2]=i;if(!l)return;PYa(l);return}function fv(a){a=a|0;return 9352}function gv(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-16-b|0)>>>4)<<4);PYa(b)}PYa(a);return}function hv(){var a=0;a=NYa(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function iv(a){a=a|0;return Gi[a&63]()|0}function jv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){g=d;Gh[g&511](a,c);return}else{g=f[(f[a>>2]|0)+d>>2]|0;Gh[g&511](a,c);return}}function kv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1)){h=e;fi[h&255](a,c,d);return}else{h=f[(f[a>>2]|0)+e>>2]|0;fi[h&255](a,c,d);return}}function lv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=mi[e&255](a)|0;return g|0}else{e=f[(f[a>>2]|0)+c>>2]|0;g=mi[e&255](a)|0;return g|0}return 0}function mv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;fi[f[a>>2]&255](e,b,c);Qd(f[e>>2]|0);c=f[e>>2]|0;ce(c|0);u=d;return c|0}function nv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ui[f[a>>2]&127](b,c,d)|0}function ov(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){tv(a,b);return}else{uv(d,b);f[c>>2]=(f[c>>2]|0)+12;return}}function pv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=(e-g|0)/12|0;i=e;if(h>>>0<b>>>0){vv(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b*12|0)|0;if((i|0)==(h|0))return;else j=i;while(1){i=j+-12|0;f[d>>2]=i;b=f[i>>2]|0;if(!b)k=i;else{i=j+-8|0;g=f[i>>2]|0;if((g|0)!=(b|0))f[i>>2]=g+(~((g+-16-b|0)>>>4)<<4);PYa(b);k=f[d>>2]|0}if((k|0)==(h|0))break;else j=k}return}function qv(a){a=a|0;return ((f[a+4>>2]|0)-(f[a>>2]|0)|0)/12|0|0}function rv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;if((((f[b+4>>2]|0)-g|0)/12|0)>>>0>c>>>0){b=NYa(12)|0;uv(b,g+(c*12|0)|0);f[e>>2]=b;b=Ee(9352,e|0)|0;f[a>>2]=b;u=d;return}else{f[a>>2]=1;u=d;return}}function sv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=(f[a>>2]|0)+(b*12|0)|0;if((d|0)==(c|0))return 1;Fv(d,f[c>>2]|0,f[c+4>>2]|0);return 1}function tv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/12|0;g=e+1|0;if(g>>>0>357913941)gXa(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/12|0;d=i<<1;j=i>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(j)if(j>>>0>357913941){d=De(8)|0;UYa(d,358155);f[d>>2]=130560;Of(d|0,21520,875)}else{k=NYa(j*12|0)|0;break}else k=0;while(0);d=k+(e*12|0)|0;e=d;g=k+(j*12|0)|0;uv(d,b);b=d+12|0;j=f[a>>2]|0;k=f[c>>2]|0;if((k|0)==(j|0)){l=e;m=j;n=j}else{i=d;d=k;k=e;do{e=i+-12|0;o=d;d=d+-12|0;f[e>>2]=0;p=i+-8|0;f[p>>2]=0;f[i+-4>>2]=0;f[e>>2]=f[d>>2];e=o+-8|0;f[p>>2]=f[e>>2];p=o+-4|0;f[i+-4>>2]=f[p>>2];f[p>>2]=0;f[e>>2]=0;f[d>>2]=0;i=k+-12|0;k=i}while((d|0)!=(j|0));l=k;m=f[a>>2]|0;n=f[c>>2]|0}f[a>>2]=l;f[c>>2]=b;f[h>>2]=g;g=m;if((n|0)!=(g|0)){h=n;do{n=h;h=h+-12|0;b=f[h>>2]|0;if(b|0){c=n+-8|0;n=f[c>>2]|0;if((n|0)!=(b|0))f[c>>2]=n+(~((n+-16-b|0)>>>4)<<4);PYa(b)}}while((h|0)!=(g|0))}if(!m)return;PYa(m);return}function uv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>4;if(!g)return;if(g>>>0>268435455)gXa(a);h=NYa(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<4);g=f[b>>2]|0;b=(f[d>>2]|0)-g|0;if((b|0)<=0)return;K1a(h|0,g|0,b|0)|0;f[c>>2]=h+(b>>>4<<4);return}function vv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/12|0)>>>0>=b>>>0){i=h;j=b;do{uv(i,c);i=(f[g>>2]|0)+12|0;f[g>>2]=i;j=j+-1|0}while((j|0)!=0);return}j=f[a>>2]|0;i=(h-j|0)/12|0;h=i+b|0;if(h>>>0>357913941)gXa(a);k=(e-j|0)/12|0;j=k<<1;e=k>>>0<178956970?(j>>>0<h>>>0?h:j):357913941;do if(e)if(e>>>0>357913941){j=De(8)|0;UYa(j,358155);f[j>>2]=130560;Of(j|0,21520,875)}else{l=NYa(e*12|0)|0;break}else l=0;while(0);j=l+(i*12|0)|0;i=j;h=l+(e*12|0)|0;e=j;l=b;b=i;do{uv(e,c);e=b+12|0;b=e;l=l+-1|0}while((l|0)!=0);l=f[a>>2]|0;e=f[g>>2]|0;if((e|0)==(l|0)){m=i;n=l;o=l}else{c=j;j=e;e=i;do{i=c+-12|0;k=j;j=j+-12|0;f[i>>2]=0;p=c+-8|0;f[p>>2]=0;f[c+-4>>2]=0;f[i>>2]=f[j>>2];i=k+-8|0;f[p>>2]=f[i>>2];p=k+-4|0;f[c+-4>>2]=f[p>>2];f[p>>2]=0;f[i>>2]=0;f[j>>2]=0;c=e+-12|0;e=c}while((j|0)!=(l|0));m=e;n=f[a>>2]|0;o=f[g>>2]|0}f[a>>2]=m;f[g>>2]=b;f[d>>2]=h;h=n;if((o|0)!=(h|0)){d=o;do{o=d;d=d+-12|0;b=f[d>>2]|0;if(b|0){g=o+-8|0;o=f[g>>2]|0;if((o|0)!=(b|0))f[g>>2]=o+(~((o+-16-b|0)>>>4)<<4);PYa(b)}}while((d|0)!=(h|0))}if(!n)return;PYa(n);return}function wv(a){a=a|0;return 9440}function xv(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)==(b|0))e=b;else{g=d;while(1){d=g+-12|0;f[c>>2]=d;h=f[d>>2]|0;if(!h)i=d;else{d=g+-8|0;j=f[d>>2]|0;if((j|0)!=(h|0))f[d>>2]=j+(~((j+-16-h|0)>>>4)<<4);PYa(h);i=f[c>>2]|0}if((i|0)==(b|0))break;else g=i}e=f[a>>2]|0}PYa(e)}PYa(a);return}function yv(){var a=0;a=NYa(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function zv(a){a=a|0;return Gi[a&63]()|0}function Av(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){g=d;Gh[g&511](a,c);return}else{g=f[(f[a>>2]|0)+d>>2]|0;Gh[g&511](a,c);return}}function Bv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1)){h=e;fi[h&255](a,c,d);return}else{h=f[(f[a>>2]|0)+e>>2]|0;fi[h&255](a,c,d);return}}function Cv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=mi[e&255](a)|0;return g|0}else{e=f[(f[a>>2]|0)+c>>2]|0;g=mi[e&255](a)|0;return g|0}return 0}function Dv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;fi[f[a>>2]&255](e,b,c);Qd(f[e>>2]|0);c=f[e>>2]|0;ce(c|0);u=d;return c|0}function Ev(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ui[f[a>>2]&127](b,c,d)|0}function Fv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>4;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>4>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>4;o=h>>>0>n>>>0;p=o?b+(n<<4)|0:c;c=p;n=c-e|0;e=n>>4;if(e|0)M1a(k|0,b|0,n|0)|0;n=l+(e<<4)|0;if(o){o=d-c|0;if((o|0)<=0)return;K1a(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>4<<4);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-16-n|0)>>>4)<<4);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-16-k|0)>>>4)<<4);PYa(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>268435455)gXa(a);j=q>>3;n=q>>4>>>0<134217727?(j>>>0<h>>>0?h:j):268435455;if(n>>>0>268435455)gXa(a);j=NYa(n<<4)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<4);if((g|0)<=0)return;K1a(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>4<<4);return}function Gv(a){a=a|0;return 9072}function Hv(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=a+36|0;c=f[b>>2]|0;if(c|0?(d=c+12|0,c=f[d>>2]|0,f[d>>2]=c+-1,(c|0)==1):0)CR(a);f[b>>2]=0;b=a+16|0;c=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[c>>2]|0)>0){b=f[a+40>>2]|0;d=0;do{f[b+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[c>>2]|0))}c=f[a+44>>2]|0;if((c|0)!=(a+48|0))ZF(c);PYa(a);return}function Iv(){var a=0,b=0,c=0,d=0,e=0;a=NYa(56)|0;f[a>>2]=1124007936;b=a+8|0;c=a+40|0;d=a+4|0;e=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));f[c>>2]=b;b=a+48|0;f[a+44>>2]=b;f[b>>2]=0;f[a+52>>2]=0;return a|0}function Jv(a){a=a|0;return Gi[a&63]()|0}function Kv(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=NYa(56)|0;f[b>>2]=f[a>>2];c=b+4|0;d=a+4|0;e=f[d>>2]|0;f[c>>2]=e;g=b+8|0;f[g>>2]=f[a+8>>2];f[b+12>>2]=f[a+12>>2];f[b+16>>2]=f[a+16>>2];f[b+20>>2]=f[a+20>>2];f[b+24>>2]=f[a+24>>2];f[b+28>>2]=f[a+28>>2];f[b+32>>2]=f[a+32>>2];h=f[a+36>>2]|0;f[b+36>>2]=h;f[b+40>>2]=g;g=b+48|0;i=b+44|0;f[i>>2]=g;f[g>>2]=0;f[b+52>>2]=0;if(!h)j=e;else{e=h+12|0;f[e>>2]=(f[e>>2]|0)+1;j=f[d>>2]|0}if((j|0)<3){j=f[a+44>>2]|0;d=f[i>>2]|0;f[d>>2]=f[j>>2];f[d+4>>2]=f[j+4>>2];return b|0}else{f[c>>2]=0;BR(b,a);return b|0}return 0}function Lv(a,b){a=a|0;b=b|0;return mi[a&255](b)|0}function Mv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c;e=NYa(56)|0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=f[b>>2]|0;f[e>>2]=1124007936;b=e+8|0;i=e+40|0;j=e+4|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=b;b=e+48|0;f[e+44>>2]=b;f[b>>2]=0;f[e+52>>2]=0;f[d>>2]=h;f[d+4>>2]=g;AR(e,2,d,a&4095);u=c;return e|0}function Nv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=f[b>>2];f[e+4>>2]=f[b+4>>2];f[g>>2]=c;c=$h[a&255](e,g)|0;u=d;return c|0}function Ov(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;g=NYa(56)|0;h=f[a>>2]|0;a=f[b>>2]|0;b=f[c>>2]|0;f[g>>2]=1124007936;c=g+8|0;i=g+40|0;j=g+4|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=c;c=g+48|0;f[g+44>>2]=c;f[c>>2]=0;f[g+52>>2]=0;f[e>>2]=h;f[e+4>>2]=a;AR(g,2,e,b&4095);u=d;return g|0}function Pv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e+8|0;h=e+4|0;i=e;f[g>>2]=b;f[h>>2]=c;f[i>>2]=d;d=ui[a&127](g,h,i)|0;u=e;return d|0}function Qv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;h=NYa(56)|0;i=f[a>>2]|0;a=f[b>>2]|0;b=f[c>>2]|0;f[h>>2]=1124007936;c=h+8|0;j=h+40|0;k=h+4|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=c;c=h+48|0;f[h+44>>2]=c;f[c>>2]=0;f[h+52>>2]=0;f[g>>2]=i;f[g+4>>2]=a;AR(h,2,g,b&4095);gL(h,d)|0;u=e;return h|0}function Rv(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g+8|0;i=g+4|0;j=g;f[h>>2]=b;f[i>>2]=c;f[j>>2]=d;d=Jg[a&63](h,i,j,e)|0;u=g;return d|0}function Sv(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return uh[a&63](b,c,d,e,f)|0}function Tv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+64|0;g=e;Ah[a&255](g,b,c,d);d=NYa(56)|0;f[d>>2]=f[g>>2];c=g+4|0;b=f[c>>2]|0;f[d+4>>2]=b;a=d+8|0;h=g+8|0;f[a>>2]=f[h>>2];f[d+12>>2]=f[g+12>>2];i=g+16|0;f[d+16>>2]=f[i>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];j=g+36|0;f[d+36>>2]=f[j>>2];k=d+40|0;f[k>>2]=a;a=d+44|0;l=d+48|0;f[a>>2]=l;m=d+52|0;f[m>>2]=0;f[l>>2]=0;n=g+44|0;if((b|0)<3){b=f[n>>2]|0;f[l>>2]=f[b>>2];f[m>>2]=f[b+4>>2];o=b}else{f[a>>2]=f[n>>2];a=g+40|0;f[k>>2]=f[a>>2];k=g+48|0;f[n>>2]=k;f[a>>2]=h;o=k}f[g>>2]=1124007936;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[c+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(g+48|0)){u=e;return d|0}ZF(o);u=e;return d|0}function Uv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d+8|0;g=d;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];fi[a&255](e,g,c);c=NYa(56)|0;f[c>>2]=f[e>>2];g=e+4|0;a=f[g>>2]|0;f[c+4>>2]=a;b=c+8|0;h=e+8|0;f[b>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];i=e+16|0;f[c+16>>2]=f[i>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=b;b=c+44|0;l=c+48|0;f[b>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((a|0)<3){a=f[n>>2]|0;f[l>>2]=f[a>>2];f[m>>2]=f[a+4>>2];o=a}else{f[b>>2]=f[n>>2];b=e+40|0;f[k>>2]=f[b>>2];k=e+48|0;f[n>>2]=k;f[b>>2]=h;o=k}f[e>>2]=1124007936;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}ZF(o);u=d;return c|0}function Vv(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function Wv(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function Xv(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Gh[f[a>>2]&511](d,b);Qd(f[d>>2]|0);b=f[d>>2]|0;ce(b|0);u=c;return b|0}function Yv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=mi[e&255](a)|0;return g|0}else{e=f[(f[a>>2]|0)+c>>2]|0;g=mi[e&255](a)|0;return g|0}return 0}function Zv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=mi[e&255](a)|0;return g|0}else{e=f[(f[a>>2]|0)+c>>2]|0;g=mi[e&255](a)|0;return g|0}return 0}function _v(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;gh[f[a>>2]&15](b,c,d,e,g);return}function $v(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fi[f[a>>2]&255](b,c,d);return}function aw(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;vh[f[a>>2]&63](b,c,d,e);return}function bw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;fi[i&255](e,a,c);c=NYa(56)|0;f[c>>2]=f[e>>2];a=e+4|0;i=f[a>>2]|0;f[c+4>>2]=i;g=c+8|0;h=e+8|0;f[g>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];b=e+16|0;f[c+16>>2]=f[b>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=g;g=c+44|0;l=c+48|0;f[g>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((i|0)<3){i=f[n>>2]|0;f[l>>2]=f[i>>2];f[m>>2]=f[i+4>>2];o=i}else{f[g>>2]=f[n>>2];g=e+40|0;f[k>>2]=f[g>>2];k=e+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[e>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}ZF(o);u=d;return c|0}function cw(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1)){i=g;Ah[i&255](a,c,d,e);return}else{i=f[(f[a>>2]|0)+g>>2]|0;Ah[i&255](a,c,d,e);return}}function dw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];fi[j&255](a,g,d);u=e;return}function ew(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+64|0;g=e;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;Ah[j&255](g,a,c,d);d=NYa(56)|0;f[d>>2]=f[g>>2];c=g+4|0;a=f[c>>2]|0;f[d+4>>2]=a;j=d+8|0;h=g+8|0;f[j>>2]=f[h>>2];f[d+12>>2]=f[g+12>>2];i=g+16|0;f[d+16>>2]=f[i>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];b=g+36|0;f[d+36>>2]=f[b>>2];k=d+40|0;f[k>>2]=j;j=d+44|0;l=d+48|0;f[j>>2]=l;m=d+52|0;f[m>>2]=0;f[l>>2]=0;n=g+44|0;if((a|0)<3){a=f[n>>2]|0;f[l>>2]=f[a>>2];f[m>>2]=f[a+4>>2];o=a}else{f[j>>2]=f[n>>2];j=g+40|0;f[k>>2]=f[j>>2];k=g+48|0;f[n>>2]=k;f[j>>2]=h;o=k}f[g>>2]=1124007936;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[c+28>>2]=0;f[b>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(g+48|0)){u=e;return d|0}ZF(o);u=e;return d|0}function fw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;fi[i&255](e,a,c);c=NYa(56)|0;f[c>>2]=f[e>>2];a=e+4|0;i=f[a>>2]|0;f[c+4>>2]=i;g=c+8|0;h=e+8|0;f[g>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];b=e+16|0;f[c+16>>2]=f[b>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=g;g=c+44|0;l=c+48|0;f[g>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((i|0)<3){i=f[n>>2]|0;f[l>>2]=f[i>>2];f[m>>2]=f[i+4>>2];o=i}else{f[g>>2]=f[n>>2];g=e+40|0;f[k>>2]=f[g>>2];k=e+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[e>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}ZF(o);u=d;return c|0}function gw(a,b,c){a=a|0;b=b|0;c=c|0;Gh[f[a>>2]&511](b,c);return}function hw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fi[f[a>>2]&255](b,c,d);return}function iw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=mi[e&255](a)|0;return g|0}else{e=f[(f[a>>2]|0)+c>>2]|0;g=mi[e&255](a)|0;return g|0}return 0}function jw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){g=d;h=$h[g&255](a,c)|0;return h|0}else{g=f[(f[a>>2]|0)+d>>2]|0;h=$h[g&255](a,c)|0;return h|0}return 0}function kw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+64|0;d=c;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;Gh[h&511](d,a);a=NYa(56)|0;f[a>>2]=f[d>>2];h=d+4|0;e=f[h>>2]|0;f[a+4>>2]=e;g=a+8|0;b=d+8|0;f[g>>2]=f[b>>2];f[a+12>>2]=f[d+12>>2];i=d+16|0;f[a+16>>2]=f[i>>2];f[a+20>>2]=f[d+20>>2];f[a+24>>2]=f[d+24>>2];f[a+28>>2]=f[d+28>>2];f[a+32>>2]=f[d+32>>2];j=d+36|0;f[a+36>>2]=f[j>>2];k=a+40|0;f[k>>2]=g;g=a+44|0;l=a+48|0;f[g>>2]=l;m=a+52|0;f[m>>2]=0;f[l>>2]=0;n=d+44|0;if((e|0)<3){e=f[n>>2]|0;f[l>>2]=f[e>>2];f[m>>2]=f[e+4>>2];o=e}else{f[g>>2]=f[n>>2];g=d+40|0;f[k>>2]=f[g>>2];k=d+48|0;f[n>>2]=k;f[g>>2]=b;o=k}f[d>>2]=1124007936;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(d+48|0)){u=c;return a|0}ZF(o);u=c;return a|0}function lw(a,b,c){a=a|0;b=b|0;c=c|0;return +(+Eg[f[a>>2]&31](b,c))}function mw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+64|0;g=e;vh[f[a>>2]&63](g,b,c,d);c=NYa(56)|0;f[c>>2]=f[g>>2];b=g+4|0;a=f[b>>2]|0;f[c+4>>2]=a;h=c+8|0;i=g+8|0;f[h>>2]=f[i>>2];f[c+12>>2]=f[g+12>>2];j=g+16|0;f[c+16>>2]=f[j>>2];f[c+20>>2]=f[g+20>>2];f[c+24>>2]=f[g+24>>2];f[c+28>>2]=f[g+28>>2];f[c+32>>2]=f[g+32>>2];k=g+36|0;f[c+36>>2]=f[k>>2];l=c+40|0;f[l>>2]=h;h=c+44|0;m=c+48|0;f[h>>2]=m;n=c+52|0;f[n>>2]=0;f[m>>2]=0;o=g+44|0;if((a|0)<3){a=f[o>>2]|0;f[m>>2]=f[a>>2];f[n>>2]=f[a+4>>2];p=a}else{f[h>>2]=f[o>>2];h=g+40|0;f[l>>2]=f[h>>2];l=g+48|0;f[o>>2]=l;f[h>>2]=i;p=l}f[g>>2]=1124007936;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[k>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((p|0)==(g+48|0)){u=e;return c|0}ZF(p);u=e;return c|0}function nw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d;fi[f[a>>2]&255](e,b,c);c=NYa(56)|0;f[c>>2]=f[e>>2];b=e+4|0;a=f[b>>2]|0;f[c+4>>2]=a;g=c+8|0;h=e+8|0;f[g>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];i=e+16|0;f[c+16>>2]=f[i>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=g;g=c+44|0;l=c+48|0;f[g>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((a|0)<3){a=f[n>>2]|0;f[l>>2]=f[a>>2];f[m>>2]=f[a+4>>2];o=a}else{f[g>>2]=f[n>>2];g=e+40|0;f[k>>2]=f[g>>2];k=e+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[e>>2]=1124007936;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}ZF(o);u=d;return c|0}function ow(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+64|0;d=c;Gh[f[a>>2]&511](d,b);b=NYa(56)|0;f[b>>2]=f[d>>2];a=d+4|0;e=f[a>>2]|0;f[b+4>>2]=e;g=b+8|0;h=d+8|0;f[g>>2]=f[h>>2];f[b+12>>2]=f[d+12>>2];i=d+16|0;f[b+16>>2]=f[i>>2];f[b+20>>2]=f[d+20>>2];f[b+24>>2]=f[d+24>>2];f[b+28>>2]=f[d+28>>2];f[b+32>>2]=f[d+32>>2];j=d+36|0;f[b+36>>2]=f[j>>2];k=b+40|0;f[k>>2]=g;g=b+44|0;l=b+48|0;f[g>>2]=l;m=b+52|0;f[m>>2]=0;f[l>>2]=0;n=d+44|0;if((e|0)<3){e=f[n>>2]|0;f[l>>2]=f[e>>2];f[m>>2]=f[e+4>>2];o=e}else{f[g>>2]=f[n>>2];g=d+40|0;f[k>>2]=f[g>>2];k=d+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[d>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(d+48|0)){u=c;return b|0}ZF(o);u=c;return b|0}function pw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;fi[i&255](e,a,c);c=NYa(56)|0;f[c>>2]=f[e>>2];a=e+4|0;i=f[a>>2]|0;f[c+4>>2]=i;g=c+8|0;h=e+8|0;f[g>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];b=e+16|0;f[c+16>>2]=f[b>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=g;g=c+44|0;l=c+48|0;f[g>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((i|0)<3){i=f[n>>2]|0;f[l>>2]=f[i>>2];f[m>>2]=f[i+4>>2];o=i}else{f[g>>2]=f[n>>2];g=e+40|0;f[k>>2]=f[g>>2];k=e+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[e>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}ZF(o);u=d;return c|0}function qw(a,b,c){a=a|0;b=b|0;c=c|0;Gh[f[a>>2]&511](b,c);return}function rw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fi[f[a>>2]&255](b,c,d);return}function sw(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Gh[f[a>>2]&511](d,b);b=NYa(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function tw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;fi[f[a>>2]&255](e,b,c);Qd(f[e>>2]|0);c=f[e>>2]|0;ce(c|0);u=d;return c|0}function uw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;Ah[f[a>>2]&255](g,b,c,d);Qd(f[g>>2]|0);d=f[g>>2]|0;ce(d|0);u=e;return d|0}function vw(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=c+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=$h[h&255](a,d)|0;return b[e>>0]|0}function ww(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=c+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=ui[i&127](a,d,e)|0;return b[g>>0]|0}function xw(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=f[a>>2]|0;i=f[a+4>>2]|0;a=c+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;h=Jg[j&63](a,d,e,g)|0;return b[h>>0]|0}function yw(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=c+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=$h[h&255](a,d)|0;return b[e>>0]|0}function zw(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=c+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=ui[i&127](a,d,e)|0;return b[g>>0]|0}function Aw(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=f[a>>2]|0;i=f[a+4>>2]|0;a=c+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;h=Jg[j&63](a,d,e,g)|0;return b[h>>0]|0}function Bw(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=$h[h&255](a,c)|0;return d[e>>1]|0}function Cw(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=ui[i&127](a,c,e)|0;return d[g>>1]|0}function Dw(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;h=Jg[j&63](a,c,e,g)|0;return d[h>>1]|0}function Ew(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=$h[h&255](a,c)|0;return d[e>>1]|0}function Fw(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=ui[i&127](a,c,e)|0;return d[g>>1]|0}function Gw(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;h=Jg[j&63](a,c,e,g)|0;return d[h>>1]|0}function Hw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1))g=d;else g=f[(f[a>>2]|0)+d>>2]|0;d=$h[g&255](a,c)|0;return f[d>>2]|0}function Iw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=ui[h&127](a,c,d)|0;return f[e>>2]|0}function Jw(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=Jg[i&63](a,c,d,e)|0;return f[g>>2]|0}function Kw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1))g=d;else g=f[(f[a>>2]|0)+d>>2]|0;d=$h[g&255](a,c)|0;return +(+n[d>>2])}function Lw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=ui[h&127](a,c,d)|0;return +(+n[e>>2])}function Mw(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=Jg[i&63](a,c,d,e)|0;return +(+n[g>>2])}function Nw(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=Jg[i&63](a,c,d,e)|0;return +(+p[g>>3])}function Ow(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1))g=d;else g=f[(f[a>>2]|0)+d>>2]|0;d=$h[g&255](a,c)|0;return +(+p[d>>3])}function Pw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=ui[h&127](a,c,d)|0;return +(+p[e>>3])}function Qw(){var a=0;a=NYa(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function Rw(a){a=a|0;if(!a)return;PYa(a);return}function Sw(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function Tw(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function Uw(){var a=0;a=NYa(16)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;return a|0}function Vw(a){a=a|0;if(!a)return;PYa(a);return}function Ww(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function Xw(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function Yw(a,b){a=a|0;b=b|0;return +(+p[b+(f[a>>2]|0)>>3])}function Zw(a,b,c){a=a|0;b=b|0;c=+c;p[b+(f[a>>2]|0)>>3]=c;return}function _w(){var a=0;a=NYa(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function $w(a){a=a|0;if(!a)return;PYa(a);return}function ax(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function bx(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function cx(){var a=0;a=NYa(8)|0;n[a>>2]=0.0;n[a+4>>2]=0.0;return a|0}function dx(a){a=a|0;if(!a)return;PYa(a);return}function ex(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function fx(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function gx(){var a=0;a=NYa(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function hx(a){a=a|0;if(!a)return;PYa(a);return}function ix(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function jx(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function kx(){var a=0;a=NYa(8)|0;n[a>>2]=0.0;n[a+4>>2]=0.0;return a|0}function lx(a){a=a|0;if(!a)return;PYa(a);return}function mx(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function nx(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function ox(){var a=0;a=NYa(16)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;return a|0}function px(a){a=a|0;if(!a)return;PYa(a);return}function qx(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function rx(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function sx(){var a=0;a=NYa(16)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;return a|0}function tx(a){a=a|0;if(!a)return;PYa(a);return}function ux(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function vx(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function wx(){var a=0;a=NYa(20)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;return a|0}function xx(a){a=a|0;if(!a)return;PYa(a);return}function yx(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=NYa(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function zx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function Ax(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=NYa(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function Bx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function Cx(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function Dx(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function Ex(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Gh[a&511](d,b);Qd(f[d>>2]|0);b=f[d>>2]|0;ce(b|0);u=c;return b|0}function Fx(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Gh[a&511](d,b);b=NYa(16)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];f[b+12>>2]=f[d+12>>2];u=c;return b|0}function Gx(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Gh[a&511](d,b);b=NYa(16)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];f[b+12>>2]=f[d+12>>2];u=c;return b|0}function Hx(){var a=0;a=NYa(32)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;return a|0}function Ix(a){a=a|0;if(!a)return;PYa(a);return}function Jx(a,b){a=a|0;b=b|0;return +(+p[b+(a<<3)>>3])}function Kx(a,b,c){a=a|0;b=b|0;c=+c;p[b+(a<<3)>>3]=c;return}function Lx(){var a=0;a=NYa(32)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;return a|0}function Mx(a){a=a|0;if(!a)return;PYa(a);return}function Nx(a,b){a=a|0;b=b|0;return +(+p[b+(f[a>>2]|0)>>3])}function Ox(a,b,c){a=a|0;b=b|0;c=+c;p[b+(f[a>>2]|0)>>3]=c;return}function Px(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=NYa(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function Qx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function Rx(){var a=0;a=NYa(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function Sx(a){a=a|0;if(!a)return;PYa(a);return}function Tx(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=NYa(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function Ux(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function Vx(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function Wx(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function Xx(){var a=0;a=NYa(192)|0;jha(a);return a|0}function Yx(a){a=a|0;if(!a)return;PYa(a);return}function Zx(a,b){a=a|0;b=b|0;return +(+p[b+(f[a>>2]|0)>>3])}function _x(a,b,c){a=a|0;b=b|0;c=+c;p[b+(f[a>>2]|0)>>3]=c;return}function $x(){var a=0;a=NYa(44)|0;v$(a);return a|0}function ay(a){a=a|0;if(!a)return;ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function by(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function cy(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function dy(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;Gh[f[a>>2]&511](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=dKa(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;K1a(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}PYa(h);u=d;return c|0}function ey(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;a=d+4|0;i=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(i>>>0>4294967279)WYa(g);if(i>>>0<11){b[g+11>>0]=i;if(!i)j=g;else{k=g;l=6}}else{d=i+16&-16;m=NYa(d)|0;f[g>>2]=m;f[g+8>>2]=d|-2147483648;f[g+4>>2]=i;k=m;l=6}if((l|0)==6){K1a(k|0,a|0,i|0)|0;j=k}b[j+i>>0]=0;Gh[h&511](c,g);if((b[g+11>>0]|0)>=0){u=e;return}PYa(f[g>>2]|0);u=e;return}function fy(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+48|0;d=c;Gh[a&511](d,b);b=NYa(44)|0;f[b>>2]=43428;a=f[d+4>>2]|0;f[b+4>>2]=a;f[b+8>>2]=f[d+8>>2];if(a|0){e=a+-4|0;f[e>>2]=(f[e>>2]|0)+1}f[b+12>>2]=f[d+12>>2];e=f[d+16>>2]|0;f[b+16>>2]=e;f[b+20>>2]=f[d+20>>2];if(e|0){a=e+-4|0;f[a>>2]=(f[a>>2]|0)+1}a=f[d+24>>2]|0;f[b+24>>2]=a;f[b+28>>2]=f[d+28>>2];if(a|0){e=a+-4|0;f[e>>2]=(f[e>>2]|0)+1}e=f[d+32>>2]|0;f[b+32>>2]=e;f[b+36>>2]=f[d+36>>2];if(!e){g=b+40|0;h=d+40|0;i=f[h>>2]|0;f[g>>2]=i;e$(d);u=c;return b|0}a=e+-4|0;f[a>>2]=(f[a>>2]|0)+1;g=b+40|0;h=d+40|0;i=f[h>>2]|0;f[g>>2]=i;e$(d);u=c;return b|0}function gy(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Gh[a&511](d,b);b=NYa(12)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];u=c;return b|0}function hy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+32|0;e=d;fi[a&255](e,b,c);c=NYa(32)|0;f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];f[c+12>>2]=f[e+12>>2];f[c+16>>2]=f[e+16>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];u=d;return c|0}function iy(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;Gh[a&511](d,b);b=NYa(32)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];f[b+12>>2]=f[d+12>>2];f[b+16>>2]=f[d+16>>2];f[b+20>>2]=f[d+20>>2];f[b+24>>2]=f[d+24>>2];f[b+28>>2]=f[d+28>>2];u=c;return b|0}function jy(a){a=a|0;var b=0,c=0;b=u;u=u+32|0;c=b;ki[a&2047](c);a=NYa(32)|0;p[a>>3]=+p[c>>3];p[a+8>>3]=+p[c+8>>3];p[a+16>>3]=+p[c+16>>3];p[a+24>>3]=+p[c+24>>3];u=b;return a|0}function ky(a,b){a=a|0;b=b|0;return mi[a&255](b)|0}function ly(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e;h=e+16|0;f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];f[g+8>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];Ah[a&255](h,b,c,g);Qd(f[h>>2]|0);g=f[h>>2]|0;ce(g|0);u=e;return g|0}function my(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;ki[a&2047](d);a=b[d+11>>0]|0;e=a<<24>>24<0;g=e?f[d+4>>2]|0:a&255;a=dKa(g+4|0)|0;f[a>>2]=g;h=f[d>>2]|0;K1a(a+4|0,(e?h:d)|0,g|0)|0;if(!e){u=c;return a|0}PYa(h);u=c;return a|0}function ny(){var a=0;a=NYa(68)|0;xAa(a);return a|0}function oy(a){a=a|0;if(!a)return;PYa(a);return}function py(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function qy(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function ry(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function sy(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function ty(a,c){a=a|0;c=c|0;return (b[c+(f[a>>2]|0)>>0]|0)!=0|0}function uy(a,c,d){a=a|0;c=c|0;d=d|0;b[c+(f[a>>2]|0)>>0]=d&1;return}function vy(a,c){a=a|0;c=c|0;return b[c+(f[a>>2]|0)>>0]|0}function wy(a,c,d){a=a|0;c=c|0;d=d|0;b[c+(f[a>>2]|0)>>0]=d;return}function xy(){var a=0;a=NYa(16)|0;f[a>>2]=-1;f[a+4>>2]=-1;f[a+8>>2]=-1;n[a+12>>2]=3402823466385288598117041.0e14;return a|0}function yy(a){a=a|0;if(!a)return;PYa(a);return}function zy(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function Ay(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function By(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function Cy(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function Dy(){var a=0;a=NYa(28)|0;n[a>>2]=0.0;n[a+4>>2]=0.0;n[a+8>>2]=0.0;n[a+12>>2]=-1.0;n[a+16>>2]=0.0;f[a+20>>2]=0;f[a+24>>2]=-1;return a|0}function Ey(a){a=a|0;if(!a)return;PYa(a);return}function Fy(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=NYa(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function Gy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function Hy(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function Iy(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function Jy(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function Ky(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function Ly(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)gXa(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;PYa(d);return}function My(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)gXa(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;PYa(d);return}function Ny(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)gXa(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;PYa(d);return}function Oy(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;mg[a&3](b,c,d,e,f,g);return}function Py(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;ai[a&7](b,c,d,e,f);return}function Qy(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;Jh[a&7](b,c,d,e);return}function Ry(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;th[a&7](b,c,d,e,f,g);return}function Sy(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;gh[a&15](b,c,d,e,f);return}function Ty(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];th[a&7](b,c,j,e,g,h);u=i;return}function Uy(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;var h=0,i=0;h=u;u=u+16|0;i=h;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];gh[a&15](b,c,i,e,g);u=h;return}function Vy(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=f[d>>2];f[h+4>>2]=f[d+4>>2];vh[a&63](b,c,h,e);u=g;return}function Wy(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;j=j|0;Zg[a&1](b,c,d,e,f,g,h,i,j);return}function Xy(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;eg[a&1](b,c,d,e,f,g,h,i);return}function Yy(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;ig[a&1](b,c,d,e,f,g,h);return}function Zy(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;nh[a&3](b,c,d,e,f,g);return}function _y(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;gh[a&15](b,c,d,e,f);return}function $y(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;j=+j;pg[a&1](b,c,d,e,f,g,h,i,j);return}function az(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;jh[a&1](b,c,d,e,f,g,h,i);return}function bz(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;kg[a&3](b,c,d,e,f,g,h);return}function cz(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;ng[a&3](b,c,d,e,f,g);return}function dz(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;dg[a&7](b,c,d,e,f,g,h);return}function ez(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;Ri[a&7](b,c,d,e,f,g);return}function fz(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;Hh[a&15](b,c,d,e,f);return}function gz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ah[a&255](b,c,d,e);return}function hz(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fi[a&255](b,c,d);return}function iz(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;_f[a&3](b,c,d,e,f,g,h,i);return}function jz(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;wg[a&3](b,c,d,e,f,g,h);return}function kz(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;$g[a&7](b,c,d,e,f,g);return}function lz(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Bh[a&255](b,c,d,e,f);return}function mz(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;j=j|0;Di[a&3](b,c,d,e,f,g,h,i,j);return}function nz(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;pi[a&3](b,c,d,e,f,g,h,i);return}function oz(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;Zh[a&7](b,c,d,e,f,g,h);return}function pz(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;bh[a&255](b,c,d,e,f,g);return}function qz(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fi[a&255](b,c,d);return}function rz(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=+h;Sg[a&1](b,c,d,e,f,g,h);return}function sz(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Bh[a&255](b,c,d,e,f);return}function tz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ah[a&255](b,c,d,e);return}function uz(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;h=h|0;Ki[a&1](b,c,d,e,f,g,h);return}function vz(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;oi[a&1](b,c,d,e,f,g);return}function wz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;Kh[a&15](b,c,d,e);return}function xz(a,b,c){a=a|0;b=b|0;c=c|0;return +(+Eg[a&31](b,c))}function yz(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;th[a&7](b,c,d,e,f,g);return}function zz(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fi[a&255](b,c,d);return}function Az(a,b,c){a=a|0;b=b|0;c=c|0;Gh[a&511](b,c);return}function Bz(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+8|0;j=h;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];Bh[a&255](b,c,i,j,g);u=h;return}function Cz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+16|0;h=g+8|0;i=g;f[h>>2]=f[d>>2];f[h+4>>2]=f[d+4>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];Ah[a&255](b,c,h,i);u=g;return}function Dz(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];fi[a&255](b,c,g);u=e;return}function Ez(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Gh[a&511](d,b);b=NYa(16)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];f[b+12>>2]=f[d+12>>2];u=c;return b|0}function Fz(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=u;u=u+16|0;k=j+8|0;l=j;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];Xh[a&127](b,c,d,k,l,h,i);u=j;return}function Gz(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0;i=u;u=u+16|0;j=i+8|0;k=i;f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[k>>2]=f[g>>2];f[k+4>>2]=f[g+4>>2];bh[a&255](b,c,d,j,k,h);u=i;return}function Hz(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+8|0;j=h;f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];Bh[a&255](b,c,d,i,j);u=h;return}function Iz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];Ah[a&255](b,c,d,h);u=g;return}function Jz(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0;i=u;u=u+16|0;j=i+4|0;k=i;f[j>>2]=c;f[k>>2]=g;$g[a&7](b,j,d,e,k,h);ce(f[k>>2]|0);ce(f[j>>2]|0);u=i;return}function Kz(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+16|0;k=j+8|0;l=j+4|0;m=j;f[k>>2]=c;f[l>>2]=g;f[m>>2]=h;Xh[a&127](b,k,d,e,l,m,i);ce(f[m>>2]|0);ce(f[l>>2]|0);ce(f[k>>2]|0);u=j;return}function Lz(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+16|0;j=i+8|0;k=i+4|0;l=i;f[j>>2]=c;f[k>>2]=g;f[l>>2]=h;bh[a&255](b,j,d,e,k,l);ce(f[l>>2]|0);ce(f[k>>2]|0);ce(f[j>>2]|0);u=i;return}function Mz(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;rh[a&1](b,c,d,e,f,g,h,i,j,k);return}function Nz(a,b,c,d,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=+m;var n=0,o=0,p=0;n=u;u=u+32|0;o=n;p=n+16|0;f[p>>2]=f[i>>2];f[p+4>>2]=f[i+4>>2];f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];f[o+8>>2]=f[k+8>>2];f[o+12>>2]=f[k+12>>2];hg[a&1](b,c,d,e,g,h,p,j,o,l,m);u=n;return}function Oz(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0;m=u;u=u+32|0;n=m;o=m+16|0;f[o>>2]=f[i>>2];f[o+4>>2]=f[i+4>>2];f[n>>2]=f[k>>2];f[n+4>>2]=f[k+4>>2];f[n+8>>2]=f[k+8>>2];f[n+12>>2]=f[k+12>>2];kh[a&7](b,c,d,e,g,h,o,j,n,l);u=m;return}function Pz(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;l=u;u=u+32|0;m=l;n=l+16|0;f[n>>2]=f[i>>2];f[n+4>>2]=f[i+4>>2];f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2];f[m+8>>2]=f[k+8>>2];f[m+12>>2]=f[k+12>>2];_h[a&127](b,c,d,e,g,h,n,j,m);u=l;return}function Qz(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0;k=u;u=u+16|0;l=k;f[l>>2]=f[i>>2];f[l+4>>2]=f[i+4>>2];Oh[a&255](b,c,d,e,g,h,l,j);u=k;return}function Rz(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[i>>2];f[k+4>>2]=f[i+4>>2];Xh[a&127](b,c,d,e,g,h,k);u=j;return}function Sz(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;bh[a&255](b,c,d,e,f,g);return}function Tz(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Bh[a&255](b,c,d,e,f);return}function Uz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ah[a&255](b,c,d,e);return}function Vz(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];Xh[a&127](b,k,d,e,g,h,i);u=j;return}function Wz(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];bh[a&255](b,j,d,e,g,h);u=i;return}function Xz(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];Bh[a&255](b,i,d,e,g);u=h;return}function Yz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];Ah[a&255](b,h,d,e);u=g;return}function Zz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ah[a&255](b,c,d,e);return}function _z(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+mh[a&31](b,c,d))}function $z(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Jg[a&63](b,c,d,e)|0}function aA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ui[a&127](b,c,d)|0}function bA(a,b,c){a=a|0;b=b|0;c=c|0;return $h[a&255](b,c)|0}function cA(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return bg[a&127](b,c,d,e,f,g)|0}function dA(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return uh[a&63](b,c,d,e,f)|0}function eA(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Jg[a&63](b,c,d,e)|0}function fA(a,b){a=a|0;b=b|0;return +(+xg[a&31](b))}function gA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;hi[a&31](b,c,d);return}function hA(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ah[a&255](b,c,d,e);return}function iA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fi[a&255](b,c,d);return}function jA(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Oh[a&255](b,c,d,e,f,g,h,i);return}function kA(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Xh[a&127](b,c,d,e,f,g,h);return}function lA(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;ri[a&7](b,c,d,e,f,g);return}function mA(a,b){a=a|0;b=b|0;return mi[a&255](b)|0}function nA(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];Xh[a&127](b,c,d,k,g,h,i);u=j;return}function oA(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];bh[a&255](b,c,d,j,g,h);u=i;return}function pA(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];Bh[a&255](b,c,d,i,g);u=h;return}function qA(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];Ah[a&255](b,c,d,h);u=g;return}function rA(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;bh[a&255](b,c,d,e,f,g);return}function sA(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Bh[a&255](b,c,d,e,f);return}function tA(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;hh[a&7](b,c,d,e,f);return}function uA(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;vh[a&63](b,c,d,e);return}function vA(a,b,c,d,e){a=a|0;b=+b;c=c|0;d=d|0;e=e|0;ci[a&1](b,c,d,e);return}function wA(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;Cg[a&1](b,c,d);return}function xA(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0;l=u;u=u+16|0;m=l;f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2];_h[a&127](b,c,d,e,g,h,i,j,m);u=l;return}function yA(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Oh[a&255](b,c,d,e,f,g,h,i);return}function zA(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Xh[a&127](b,c,d,e,f,g,h);return}function AA(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;bh[a&255](b,c,d,e,f,g);return}function BA(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Bh[a&255](b,c,d,e,f);return}function CA(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ah[a&255](b,c,d,e);return}function DA(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Bh[a&255](b,c,d,e,f);return}function EA(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ah[a&255](b,c,d,e);return}function FA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fi[a&255](b,c,d);return}function GA(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0;m=u;u=u+16|0;n=m+4|0;o=m;f[n>>2]=g;f[o>>2]=k;kh[a&7](b,c,d,e,n,h,i,j,o,l);ce(f[o>>2]|0);ce(f[n>>2]|0);u=m;return}function HA(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;l=u;u=u+16|0;m=l+4|0;n=l;f[m>>2]=g;f[n>>2]=k;_h[a&127](b,c,d,e,m,h,i,j,n);ce(f[n>>2]|0);ce(f[m>>2]|0);u=l;return}function IA(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0;k=u;u=u+16|0;l=k;f[l>>2]=g;Oh[a&255](b,c,d,e,l,h,i,j);ce(f[l>>2]|0);u=k;return}function JA(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=g;Xh[a&127](b,c,d,e,k,h,i);ce(f[k>>2]|0);u=j;return}function KA(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=g;bh[a&255](b,c,d,e,j,h);ce(f[j>>2]|0);u=i;return}function LA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ui[a&127](b,c,d)|0}function MA(a,b,c){a=a|0;b=b|0;c=c|0;return $h[a&255](b,c)|0}function NA(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0;m=u;u=u+16|0;n=m+8|0;o=m;f[n>>2]=f[c>>2];f[n+4>>2]=f[c+4>>2];f[o>>2]=f[d>>2];f[o+4>>2]=f[d+4>>2];Ph[a&1](b,n,o,e,g,h,i,j,k,l);u=m;return}function OA(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;l=u;u=u+16|0;m=l+8|0;n=l;f[m>>2]=f[c>>2];f[m+4>>2]=f[c+4>>2];f[n>>2]=f[d>>2];f[n+4>>2]=f[d+4>>2];Rg[a&1](b,m,n,e,g,h,i,j,k);u=l;return}function PA(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=i|0;j=j|0;var k=0,l=0,m=0;k=u;u=u+16|0;l=k+8|0;m=k;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];Nh[a&1](b,l,m,e,g,h,i,j);u=k;return}function QA(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=i|0;var j=0,k=0,l=0;j=u;u=u+16|0;k=j+8|0;l=j;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];Lg[a&1](b,k,l,e,g,h,i);u=j;return}function RA(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Bh[a&255](b,c,d,e,f);return}function SA(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ah[a&255](b,c,d,e);return}function TA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fi[a&255](b,c,d);return}function UA(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=u;u=u+16|0;k=j+8|0;l=j;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];Xh[a&127](k,l,d,e,g,h,i);u=j;return}function VA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+64|0;g=e;Ah[a&255](g,b,c,d);d=NYa(56)|0;f[d>>2]=f[g>>2];c=g+4|0;b=f[c>>2]|0;f[d+4>>2]=b;a=d+8|0;h=g+8|0;f[a>>2]=f[h>>2];f[d+12>>2]=f[g+12>>2];i=g+16|0;f[d+16>>2]=f[i>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];j=g+36|0;f[d+36>>2]=f[j>>2];k=d+40|0;f[k>>2]=a;a=d+44|0;l=d+48|0;f[a>>2]=l;m=d+52|0;f[m>>2]=0;f[l>>2]=0;n=g+44|0;if((b|0)<3){b=f[n>>2]|0;f[l>>2]=f[b>>2];f[m>>2]=f[b+4>>2];o=b}else{f[a>>2]=f[n>>2];a=g+40|0;f[k>>2]=f[a>>2];k=g+48|0;f[n>>2]=k;f[a>>2]=h;o=k}f[g>>2]=1124007936;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[c+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(g+48|0)){u=e;return d|0}ZF(o);u=e;return d|0}function WA(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[g>>2];f[k+4>>2]=f[g+4>>2];og[a&7](b,c,d,e,k,h,i);u=j;return}function XA(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];$g[a&7](b,c,d,e,j,h);u=i;return}function YA(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;f[i>>2]=f[g>>2];f[i+4>>2]=f[g+4>>2];Bh[a&255](b,c,d,e,i);u=h;return}function ZA(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ah[a&255](b,c,d,e);return}function _A(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];bh[a&255](b,c,d,e,g,j);u=i;return}function $A(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Bh[a&255](b,c,d,e,f);return}function aB(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0;i=u;u=u+16|0;j=i;f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];f[j+8>>2]=f[g+8>>2];f[j+12>>2]=f[g+12>>2];k=+Ii[a&3](b,c,d,e,j,h);u=i;return +k}function bB(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0.0;h=u;u=u+16|0;i=h;f[i>>2]=f[g>>2];f[i+4>>2]=f[g+4>>2];f[i+8>>2]=f[g+8>>2];f[i+12>>2]=f[g+12>>2];j=+zi[a&7](b,c,d,e,i);u=h;return +j}function cB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return +(+Rh[a&15](b,c,d,e))}function dB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+mh[a&31](b,c,d))}function eB(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;Gh[a&511](d,b);b=NYa(20)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];f[b+12>>2]=f[d+12>>2];f[b+16>>2]=f[d+16>>2];u=c;return b|0}function fB(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;h=h|0;vi[a&1](b,c,d,e,f,g,h);return}function gB(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;Ni[a&1](b,c,d,e,f,g);return}function hB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d;fi[a&255](e,b,c);c=NYa(56)|0;f[c>>2]=f[e>>2];b=e+4|0;a=f[b>>2]|0;f[c+4>>2]=a;g=c+8|0;h=e+8|0;f[g>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];i=e+16|0;f[c+16>>2]=f[i>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=g;g=c+44|0;l=c+48|0;f[g>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((a|0)<3){a=f[n>>2]|0;f[l>>2]=f[a>>2];f[m>>2]=f[a+4>>2];o=a}else{f[g>>2]=f[n>>2];g=e+40|0;f[k>>2]=f[g>>2];k=e+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[e>>2]=1124007936;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}ZF(o);u=d;return c|0}function iB(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+64|0;g=e+8|0;h=e;f[h>>2]=f[b>>2];f[h+4>>2]=f[b+4>>2];Jh[a&7](g,h,c,d);h=NYa(56)|0;f[h>>2]=f[g>>2];a=g+4|0;b=f[a>>2]|0;f[h+4>>2]=b;i=h+8|0;j=g+8|0;f[i>>2]=f[j>>2];f[h+12>>2]=f[g+12>>2];k=g+16|0;f[h+16>>2]=f[k>>2];f[h+20>>2]=f[g+20>>2];f[h+24>>2]=f[g+24>>2];f[h+28>>2]=f[g+28>>2];f[h+32>>2]=f[g+32>>2];l=g+36|0;f[h+36>>2]=f[l>>2];m=h+40|0;f[m>>2]=i;i=h+44|0;n=h+48|0;f[i>>2]=n;o=h+52|0;f[o>>2]=0;f[n>>2]=0;p=g+44|0;if((b|0)<3){b=f[p>>2]|0;f[n>>2]=f[b>>2];f[o>>2]=f[b+4>>2];q=b}else{f[i>>2]=f[p>>2];i=g+40|0;f[m>>2]=f[i>>2];m=g+48|0;f[p>>2]=m;f[i>>2]=j;q=m}f[g>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[l>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((q|0)==(g+48|0)){u=e;return h|0}ZF(q);u=e;return h|0}function jB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+80|0;g=e+16|0;h=e+8|0;i=e;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];Ah[a&255](g,b,h,i);i=NYa(56)|0;f[i>>2]=f[g>>2];h=g+4|0;b=f[h>>2]|0;f[i+4>>2]=b;a=i+8|0;d=g+8|0;f[a>>2]=f[d>>2];f[i+12>>2]=f[g+12>>2];c=g+16|0;f[i+16>>2]=f[c>>2];f[i+20>>2]=f[g+20>>2];f[i+24>>2]=f[g+24>>2];f[i+28>>2]=f[g+28>>2];f[i+32>>2]=f[g+32>>2];j=g+36|0;f[i+36>>2]=f[j>>2];k=i+40|0;f[k>>2]=a;a=i+44|0;l=i+48|0;f[a>>2]=l;m=i+52|0;f[m>>2]=0;f[l>>2]=0;n=g+44|0;if((b|0)<3){b=f[n>>2]|0;f[l>>2]=f[b>>2];f[m>>2]=f[b+4>>2];o=b}else{f[a>>2]=f[n>>2];a=g+40|0;f[k>>2]=f[a>>2];k=g+48|0;f[n>>2]=k;f[a>>2]=d;o=k}f[g>>2]=1124007936;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[j>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((o|0)==(g+48|0)){u=e;return i|0}ZF(o);u=e;return i|0}function kB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d+8|0;g=d;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];fi[a&255](e,b,g);g=NYa(56)|0;f[g>>2]=f[e>>2];b=e+4|0;a=f[b>>2]|0;f[g+4>>2]=a;c=g+8|0;h=e+8|0;f[c>>2]=f[h>>2];f[g+12>>2]=f[e+12>>2];i=e+16|0;f[g+16>>2]=f[i>>2];f[g+20>>2]=f[e+20>>2];f[g+24>>2]=f[e+24>>2];f[g+28>>2]=f[e+28>>2];f[g+32>>2]=f[e+32>>2];j=e+36|0;f[g+36>>2]=f[j>>2];k=g+40|0;f[k>>2]=c;c=g+44|0;l=g+48|0;f[c>>2]=l;m=g+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((a|0)<3){a=f[n>>2]|0;f[l>>2]=f[a>>2];f[m>>2]=f[a+4>>2];o=a}else{f[c>>2]=f[n>>2];c=e+40|0;f[k>>2]=f[c>>2];k=e+48|0;f[n>>2]=k;f[c>>2]=h;o=k}f[e>>2]=1124007936;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(e+48|0)){u=d;return g|0}ZF(o);u=d;return g|0}function lB(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=+j;Gg[a&1](b,c,d,e,f,g,h,i,j);return}function mB(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;si[a&3](b,c,d,e,f,g,h,i);return}function nB(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;ug[a&3](b,c,d,e,f,g,h);return}function oB(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;th[a&7](b,c,d,e,f,g);return}function pB(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;sh[a&1](b,c,d,e,f,g,h,i,j,k);return}function qB(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;Fg[a&1](b,c,d,e,f,g,h,i,j);return}function rB(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;si[a&3](b,c,d,e,f,g,h,i);return}function sB(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];f[k+8>>2]=f[d+8>>2];f[k+12>>2]=f[d+12>>2];Xh[a&127](b,c,k,e,g,h,i);u=j;return}function tB(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];f[j+8>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];bh[a&255](b,c,j,e,g,h);u=i;return}function uB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;vh[a&63](b,c,d,e);return}function vB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fi[a&255](b,c,d);return}function wB(a,b,c){a=a|0;b=b|0;c=c|0;Gh[a&511](b,c);return}function xB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d;fi[a&255](e,b,c);c=NYa(56)|0;f[c>>2]=f[e>>2];b=e+4|0;a=f[b>>2]|0;f[c+4>>2]=a;g=c+8|0;h=e+8|0;f[g>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];i=e+16|0;f[c+16>>2]=f[i>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=g;g=c+44|0;l=c+48|0;f[g>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((a|0)<3){a=f[n>>2]|0;f[l>>2]=f[a>>2];f[m>>2]=f[a+4>>2];o=a}else{f[g>>2]=f[n>>2];g=e+40|0;f[k>>2]=f[g>>2];k=e+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[e>>2]=1124007936;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}ZF(o);u=d;return c|0}function yB(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=u;u=u+16|0;i=h+4|0;j=h;k=c+4|0;l=f[c>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(l>>>0>4294967279)WYa(i);if(l>>>0<11){b[i+11>>0]=l;if(!l)m=i;else{n=i;o=6}}else{c=l+16&-16;p=NYa(c)|0;f[i>>2]=p;f[i+8>>2]=c|-2147483648;f[i+4>>2]=l;n=p;o=6}if((o|0)==6){K1a(n|0,k|0,l|0)|0;m=n}b[m+l>>0]=0;f[j>>2]=g;g=Jg[a&63](i,d,e,j)|0;ce(f[j>>2]|0);if((b[i+11>>0]|0)>=0){u=h;return g|0}PYa(f[i>>2]|0);u=h;return g|0}function zB(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;i=c+4|0;j=f[c>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(j>>>0>4294967279)WYa(h);if(j>>>0<11){b[h+11>>0]=j;if(!j)k=h;else{l=h;m=6}}else{c=j+16&-16;n=NYa(c)|0;f[h>>2]=n;f[h+8>>2]=c|-2147483648;f[h+4>>2]=j;l=n;m=6}if((m|0)==6){K1a(l|0,i|0,j|0)|0;k=l}b[k+j>>0]=0;j=ui[a&127](h,d,e)|0;if((b[h+11>>0]|0)>=0){u=g;return j|0}PYa(f[h>>2]|0);u=g;return j|0}function AB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ah[a&255](b,c,d,e);return}function BB(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0;k=u;u=u+16|0;l=k;f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];Oh[a&255](b,c,d,e,l,h,i,j);u=k;return}function CB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ah[a&255](b,c,d,e);return}function DB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fi[a&255](b,c,d);return}function EB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+mh[a&31](b,c,d))}function FB(a,b,c){a=a|0;b=b|0;c=c|0;return +(+Eg[a&31](b,c))}function GB(a,b){a=a|0;b=b|0;return mi[a&255](b)|0}function HB(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0;j=u;u=u+16|0;k=j;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];f[k+8>>2]=f[e+8>>2];f[k+12>>2]=f[e+12>>2];l=+Dg[a&3](b,c,d,k,g,h,i);u=j;return +l}function IB(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0;i=u;u=u+16|0;j=i;f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[j+8>>2]=f[e+8>>2];f[j+12>>2]=f[e+12>>2];k=+Ii[a&3](b,c,d,j,g,h);u=i;return +k}function JB(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=u;u=u+16|0;k=j+8|0;l=j;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];Xh[a&127](b,k,l,e,g,h,i);u=j;return}function KB(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0;i=u;u=u+16|0;j=i+8|0;k=i;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];bh[a&255](b,j,k,e,g,h);u=i;return}function LB(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+8|0;j=h;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];Bh[a&255](b,i,j,e,g);u=h;return}function MB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+16|0;h=g+8|0;i=g;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];Ah[a&255](b,h,i,e);u=g;return}function NB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return +(+Mh[a&1](b,c,d,e))}function OB(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Bh[a&255](b,c,d,e,f);return}function PB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+32|0;e=d;fi[a&255](e,b,c);c=NYa(32)|0;p[c>>3]=+p[e>>3];p[c+8>>3]=+p[e+8>>3];p[c+16>>3]=+p[e+16>>3];p[c+24>>3]=+p[e+24>>3];u=d;return c|0}function QB(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;Gh[a&511](d,b);b=NYa(32)|0;p[b>>3]=+p[d>>3];p[b+8>>3]=+p[d+8>>3];p[b+16>>3]=+p[d+16>>3];p[b+24>>3]=+p[d+24>>3];u=c;return b|0}function RB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ah[a&255](b,c,d,e);return}function SB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=d;fi[a&255](b,c,g);ce(f[g>>2]|0);u=e;return}function TB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+192|0;e=d;fi[a&255](e,b,c);c=NYa(192)|0;K1a(c|0,e|0,192)|0;u=d;return c|0}function UB(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+192|0;d=c;Gh[a&511](d,b);b=NYa(192)|0;K1a(b|0,d|0,192)|0;u=c;return b|0}function VB(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0;k=u;u=u+16|0;l=k;f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];Oh[a&255](b,c,d,e,l,h,i,j);u=k;return}function WB(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[g>>2];f[k+4>>2]=f[g+4>>2];Xh[a&127](b,c,d,e,k,h,i);u=j;return}function XB(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];bh[a&255](b,c,d,e,j,h);u=i;return}function YB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+mh[a&31](b,c,d))}function ZB(a,b,c){a=a|0;b=b|0;c=c|0;return +(+Eg[a&31](b,c))}function _B(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return +(+Rh[a&15](b,c,d,e))}function $B(a,b,c){a=a|0;b=b|0;c=c|0;return +(+Eg[a&31](b,c))}function aC(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;Pg[a&1](b,c,d,e,f,g,h);return}function bC(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;mg[a&3](b,c,d,e,f,g);return}function cC(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0.0;e=u;u=u+16|0;g=e;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];h=+mh[a&31](b,g,d);u=e;return +h}function dC(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;lg[a&3](b,c,d);return}function eC(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;m=u;u=u+64|0;n=m+40|0;o=m+32|0;q=m;r=d+4|0;s=f[d>>2]|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;if(s>>>0>4294967279)WYa(n);if(s>>>0<11){b[n+11>>0]=s;if(!s)t=n;else{v=n;w=6}}else{d=s+16&-16;x=NYa(d)|0;f[n>>2]=x;f[n+8>>2]=d|-2147483648;f[n+4>>2]=s;v=x;w=6}if((w|0)==6){K1a(v|0,r|0,s|0)|0;t=v}b[t+s>>0]=0;f[o>>2]=f[e>>2];f[o+4>>2]=f[e+4>>2];p[q>>3]=+p[i>>3];p[q+8>>3]=+p[i+8>>3];p[q+16>>3]=+p[i+16>>3];p[q+24>>3]=+p[i+24>>3];Tg[a&7](c,n,o,g,h,q,j,k,l);if((b[n+11>>0]|0)>=0){u=m;return}PYa(f[n>>2]|0);u=m;return}function fC(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0;l=u;u=u+64|0;m=l+40|0;n=l+32|0;o=l;q=d+4|0;r=f[d>>2]|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;if(r>>>0>4294967279)WYa(m);if(r>>>0<11){b[m+11>>0]=r;if(!r)s=m;else{t=m;v=6}}else{d=r+16&-16;w=NYa(d)|0;f[m>>2]=w;f[m+8>>2]=d|-2147483648;f[m+4>>2]=r;t=w;v=6}if((v|0)==6){K1a(t|0,q|0,r|0)|0;s=t}b[s+r>>0]=0;f[n>>2]=f[e>>2];f[n+4>>2]=f[e+4>>2];p[o>>3]=+p[i>>3];p[o+8>>3]=+p[i+8>>3];p[o+16>>3]=+p[i+16>>3];p[o+24>>3]=+p[i+24>>3];Zf[a&7](c,m,n,g,h,o,j,k);if((b[m+11>>0]|0)>=0){u=l;return}PYa(f[m>>2]|0);u=l;return}function gC(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0;k=u;u=u+64|0;l=k+40|0;m=k+32|0;n=k;o=d+4|0;q=f[d>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;if(q>>>0>4294967279)WYa(l);if(q>>>0<11){b[l+11>>0]=q;if(!q)r=l;else{s=l;t=6}}else{d=q+16&-16;v=NYa(d)|0;f[l>>2]=v;f[l+8>>2]=d|-2147483648;f[l+4>>2]=q;s=v;t=6}if((t|0)==6){K1a(s|0,o|0,q|0)|0;r=s}b[r+q>>0]=0;f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];p[n>>3]=+p[i>>3];p[n+8>>3]=+p[i+8>>3];p[n+16>>3]=+p[i+16>>3];p[n+24>>3]=+p[i+24>>3];yi[a&7](c,l,m,g,h,n,j);if((b[l+11>>0]|0)>=0){u=k;return}PYa(f[l>>2]|0);u=k;return}function hC(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;j=u;u=u+64|0;k=j+40|0;l=j+32|0;m=j;n=d+4|0;o=f[d>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(o>>>0>4294967279)WYa(k);if(o>>>0<11){b[k+11>>0]=o;if(!o)q=k;else{r=k;s=6}}else{d=o+16&-16;t=NYa(d)|0;f[k>>2]=t;f[k+8>>2]=d|-2147483648;f[k+4>>2]=o;r=t;s=6}if((s|0)==6){K1a(r|0,n|0,o|0)|0;q=r}b[q+o>>0]=0;f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];p[m>>3]=+p[i>>3];p[m+8>>3]=+p[i+8>>3];p[m+16>>3]=+p[i+16>>3];p[m+24>>3]=+p[i+24>>3];ri[a&7](c,k,l,g,h,m);if((b[k+11>>0]|0)>=0){u=j;return}PYa(f[k>>2]|0);u=j;return}function iC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ah[a&255](b,c,d,e);return}function jC(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fi[a&255](b,c,d);return}function kC(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fi[a&255](b,c,d);return}function lC(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Xh[a&127](b,c,d,e,f,g,h);return}function mC(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;bh[a&255](b,c,d,e,f,g);return}function nC(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Bh[a&255](b,c,d,e,f);return}function oC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ah[a&255](b,c,d,e);return}function pC(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;var k=0,l=0;k=u;u=u+16|0;l=k;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];dh[a&3](b,c,d,e,g,l,i,j);u=k;return}function qC(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];Zh[a&7](b,c,d,e,g,k,i);u=j;return}function rC(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];bh[a&255](b,c,d,e,g,j);u=i;return}function sC(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Bh[a&255](b,c,d,e,f);return}function tC(a,b,c){a=a|0;b=b|0;c=c|0;Gh[a&511](b,c);return}function uC(a,b){a=a|0;b=b|0;ki[a&2047](b);return}function vC(a,b){a=a|0;b=b|0;ki[a&2047](b);return}function wC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Jg[a&63](b,c,d,e)|0}function xC(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ui[a&127](b,c,d)|0}function yC(a,b,c){a=a|0;b=b|0;c=c|0;Gh[a&511](b,c);return}function zC(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;return +(+lh[a&1](b,c,d,e,f))}function AC(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Bh[a&255](b,c,d,e,f);return}function BC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ah[a&255](b,c,d,e);return}function CC(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];Xh[a&127](b,c,d,k,g,h,i);u=j;return}function DC(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];bh[a&255](b,c,d,j,g,h);u=i;return}function EC(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];Bh[a&255](b,c,d,i,g);u=h;return}function FC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];Ah[a&255](b,c,d,h);u=g;return}function GC(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function HC(a){a=a|0;if(!a)return;ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function IC(a){a=a|0;return a|0}function JC(a){a=a|0;return a|0}function KC(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Gh[a&511](d,b);b=NYa(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function LC(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;ki[a&2047](c);a=NYa(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function MC(a){a=a|0;return f[a+4>>2]|0}function NC(){var a=0;a=NYa(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function OC(a){a=a|0;return 0}function PC(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)ki[f[(f[b>>2]|0)+8>>2]&2047](b);PYa(a);return}function QC(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function RC(a){a=a|0;if(!a)return;ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function SC(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+32|0;h=g+12|0;i=g;j=f[a>>2]|0;a=d+4|0;k=f[d>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(k>>>0>4294967279)WYa(h);if(k>>>0<11){b[h+11>>0]=k;if(!k)l=h;else{m=h;n=6}}else{d=k+16&-16;o=NYa(d)|0;f[h>>2]=o;f[h+8>>2]=d|-2147483648;f[h+4>>2]=k;m=o;n=6}if((n|0)==6){K1a(m|0,a|0,k|0)|0;l=m}b[l+k>>0]=0;k=e+4|0;l=f[e>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(l>>>0>4294967279)WYa(i);if(l>>>0<11){b[i+11>>0]=l;if(!l)p=i;else{q=i;n=12}}else{e=l+16&-16;m=NYa(e)|0;f[i>>2]=m;f[i+8>>2]=e|-2147483648;f[i+4>>2]=l;q=m;n=12}if((n|0)==12){K1a(q|0,k|0,l|0)|0;p=q}b[p+l>>0]=0;l=ui[j&127](c,h,i)|0;if((b[i+11>>0]|0)<0)PYa(f[i>>2]|0);if((b[h+11>>0]|0)>=0){u=g;return l|0}PYa(f[h>>2]|0);u=g;return l|0}function TC(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;a=d+4|0;i=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(i>>>0>4294967279)WYa(g);if(i>>>0<11){b[g+11>>0]=i;if(!i)j=g;else{k=g;l=6}}else{d=i+16&-16;m=NYa(d)|0;f[g>>2]=m;f[g+8>>2]=d|-2147483648;f[g+4>>2]=i;k=m;l=6}if((l|0)==6){K1a(k|0,a|0,i|0)|0;j=k}b[j+i>>0]=0;i=$h[h&255](c,g)|0;if((b[g+11>>0]|0)>=0){u=e;return i|0}PYa(f[g>>2]|0);u=e;return i|0}function UC(){var a=0,c=0;a=NYa(152)|0;f[a>>2]=77656;f[a+4>>2]=64;f[a+8>>2]=128;f[a+12>>2]=16;f[a+16>>2]=16;f[a+20>>2]=8;f[a+24>>2]=8;f[a+28>>2]=8;f[a+32>>2]=8;f[a+36>>2]=9;f[a+40>>2]=1;p[a+48>>3]=-1.0;f[a+56>>2]=0;p[a+64>>3]=.2;b[a+72>>0]=1;f[a+76>>2]=0;f[a+80>>2]=0;f[a+84>>2]=0;f[a+88>>2]=1124007936;c=a+92|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[a+120>>2]=a+96;c=a+128|0;f[a+124>>2]=c;f[a+132>>2]=0;f[c>>2]=0;n[a+136>>2]=-1.0;f[a+140>>2]=64;b[a+144>>0]=0;return a|0}function VC(a){a=a|0;return Gi[a&63]()|0}function WC(a,c,d,e,g,h,i,j,k,l,m,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;o=o|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0;q=NYa(152)|0;r=f[a>>2]|0;s=f[a+4>>2]|0;a=f[c>>2]|0;t=f[c+4>>2]|0;c=f[d>>2]|0;u=f[d+4>>2]|0;d=f[e>>2]|0;v=f[e+4>>2]|0;e=f[g>>2]|0;g=f[h>>2]|0;w=+p[i>>3];i=f[j>>2]|0;x=+p[k>>3];k=b[l>>0]|0;l=f[m>>2]|0;m=b[o>>0]|0;f[q>>2]=77656;f[q+4>>2]=r;f[q+8>>2]=s;f[q+12>>2]=a;f[q+16>>2]=t;f[q+20>>2]=c;f[q+24>>2]=u;f[q+28>>2]=d;f[q+32>>2]=v;f[q+36>>2]=e;f[q+40>>2]=g;p[q+48>>3]=w;f[q+56>>2]=i;p[q+64>>3]=x;b[q+72>>0]=k;f[q+76>>2]=0;f[q+80>>2]=0;f[q+84>>2]=0;f[q+88>>2]=1124007936;k=q+92|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[q+120>>2]=q+96;k=q+128|0;f[q+124>>2]=k;f[q+132>>2]=0;f[k>>2]=0;n[q+136>>2]=-1.0;f[q+140>>2]=l;b[q+144>>0]=m;return q|0}function XC(a,c,d,e,g,h,i,j,k,l,m,n,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;l=+l;m=m|0;n=n|0;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;q=u;u=u+80|0;r=q+56|0;s=q+48|0;t=q+40|0;v=q+32|0;w=q+28|0;x=q+24|0;y=q+8|0;z=q+20|0;A=q;B=q+65|0;C=q+16|0;D=q+64|0;f[r>>2]=f[c>>2];f[r+4>>2]=f[c+4>>2];f[s>>2]=f[d>>2];f[s+4>>2]=f[d+4>>2];f[t>>2]=f[e>>2];f[t+4>>2]=f[e+4>>2];f[v>>2]=f[g>>2];f[v+4>>2]=f[g+4>>2];f[w>>2]=h;f[x>>2]=i;p[y>>3]=j;f[z>>2]=k;p[A>>3]=l;b[B>>0]=m&1;f[C>>2]=n;b[D>>0]=o&1;o=Bi[a&1](r,s,t,v,w,x,y,z,A,B,C,D)|0;u=q;return o|0}function YC(a){a=a|0;var b=0;b=NYa(152)|0;_C(b,a);return b|0}function ZC(a,b){a=a|0;b=b|0;return mi[a&255](b)|0}function _C(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=77656;e=a+4|0;f[a+76>>2]=0;f[a+80>>2]=0;f[a+84>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;f[a+88>>2]=1124007936;e=a+92|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[a+120>>2]=a+96;e=a+128|0;f[a+124>>2]=e;f[a+132>>2]=0;f[e>>2]=0;e=f[19419]|0;f[d>>2]=0;f[d+4>>2]=0;ui[e&127](a,b,d)|0;d$(d);u=c;return}function $C(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;ki[a&2047](c);a=NYa(12)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];u=b;return a|0}function aD(a,b,c){a=a|0;b=b|0;c=c|0;Gh[f[a>>2]&511](b,c);return}function bD(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=+j;k=+k;l=l|0;var m=0,n=0,o=0,p=0;m=u;u=u+16|0;n=m+8|0;o=m;p=f[a>>2]|0;f[n>>2]=f[h>>2];f[n+4>>2]=f[h+4>>2];f[o>>2]=f[i>>2];f[o+4>>2]=f[i+4>>2];zg[p&3](b,c,d,e,g,n,o,j,k,l);u=m;return}function cD(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=+j;k=+k;var l=0,m=0,n=0,o=0;l=u;u=u+16|0;m=l+8|0;n=l;o=f[a>>2]|0;f[m>>2]=f[h>>2];f[m+4>>2]=f[h+4>>2];f[n>>2]=f[i>>2];f[n+4>>2]=f[i+4>>2];Hg[o&1](b,c,d,e,g,m,n,j,k);u=l;return}function dD(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=+j;var k=0,l=0,m=0,n=0;k=u;u=u+16|0;l=k+8|0;m=k;n=f[a>>2]|0;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];ag[n&1](b,c,d,e,g,l,m,j);u=k;return}function eD(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+16|0;k=j+8|0;l=j;m=f[a>>2]|0;f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[l>>2]=f[i>>2];f[l+4>>2]=f[i+4>>2];yi[m&7](b,c,d,e,g,k,l);u=j;return}function fD(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0;i=u;u=u+16|0;j=i;k=f[a>>2]|0;f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];ri[k&7](b,c,d,e,g,j);u=i;return}function gD(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;Hh[f[a>>2]&15](b,c,d,e,g);return}function hD(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ah[f[a>>2]&255](b,c,d,e);return}function iD(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=NYa(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function jD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function kD(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function lD(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function mD(a,b){a=a|0;b=b|0;return +(+p[b+(f[a>>2]|0)>>3])}function nD(a,b,c){a=a|0;b=b|0;c=+c;p[b+(f[a>>2]|0)>>3]=c;return}function oD(a,c){a=a|0;c=c|0;return (b[c+(f[a>>2]|0)>>0]|0)!=0|0}function pD(a,c,d){a=a|0;c=c|0;d=d|0;b[c+(f[a>>2]|0)>>0]=d&1;return}function qD(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=NYa(12)|0;sD(a,c);return a|0}function rD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;if((d|0)==(c|0))return;tD(d,f[c>>2]|0,f[c+4>>2]|0);return}function sD(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>2;if(!g)return;if(g>>>0>1073741823)gXa(a);h=NYa(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<2);g=f[b>>2]|0;b=(f[d>>2]|0)-g|0;if((b|0)<=0)return;K1a(h|0,g|0,b|0)|0;f[c>>2]=h+(b>>>2<<2);return}function tD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>2;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>2>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>2;o=h>>>0>n>>>0;p=o?b+(n<<2)|0:c;c=p;n=c-e|0;e=n>>2;if(e|0)M1a(k|0,b|0,n|0)|0;n=l+(e<<2)|0;if(o){o=d-c|0;if((o|0)<=0)return;K1a(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>2<<2);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-4-n|0)>>>2)<<2);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-4-k|0)>>>2)<<2);PYa(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>1073741823)gXa(a);j=q>>1;n=q>>2>>>0<536870911?(j>>>0<h>>>0?h:j):1073741823;if(n>>>0>1073741823)gXa(a);j=NYa(n<<2)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<2);if((g|0)<=0)return;K1a(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>2<<2);return}function uD(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function vD(a){a=a|0;if(!a)return;ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function wD(a){a=a|0;return a|0}function xD(a){a=a|0;return a|0}function yD(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;vh[f[a>>2]&63](b,c,d,e);return}function zD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fi[f[a>>2]&255](b,c,d);return}function AD(a,b,c){a=a|0;b=b|0;c=c|0;Gh[f[a>>2]&511](b,c);return}function BD(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function CD(a){a=a|0;if(!a)return;ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function DD(a){a=a|0;return a|0}function ED(a){a=a|0;return a|0}function FD(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;Kh[a&15](g,b,c,d);d=NYa(8)|0;f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];u=e;return d|0}function GD(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;d=u;u=u+16|0;e=d;hi[a&31](e,b,c);b=NYa(8)|0;f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];u=d;return b|0}function HD(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Gh[a&511](d,b);b=NYa(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function ID(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;ki[a&2047](c);a=NYa(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function JD(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;vh[f[a>>2]&63](b,c,d,e);return}function KD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fi[f[a>>2]&255](b,c,d);return}function LD(a){a=a|0;return f[a+4>>2]|0}function MD(){var a=0;a=NYa(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function ND(a){a=a|0;return 0}function OD(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)ki[f[(f[b>>2]|0)+8>>2]&2047](b);PYa(a);return}function PD(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function QD(a){a=a|0;if(!a)return;ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function RD(a){a=a|0;return a|0}function SD(a){a=a|0;return a|0}function TD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];Gh[g&511](b,e);u=d;return}function UD(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=d+8|0;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];lg[a&3](e,b,g);g=NYa(8)|0;f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];u=d;return g|0}function VD(a,b){a=a|0;b=+b;var c=0,d=0;c=u;u=u+16|0;d=c;Dh[a&31](d,b);a=NYa(8)|0;f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return a|0}function WD(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;ki[a&2047](c);a=NYa(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function XD(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;ki[e&2047](a);return}else{e=f[(f[a>>2]|0)+c>>2]|0;ki[e&2047](a);return}}function YD(a,b,c){a=a|0;b=b|0;c=+c;Dh[f[a>>2]&31](b,c);return}function ZD(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;Gh[h&511](d,a);a=NYa(8)|0;f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return a|0}function _D(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=+xg[e&31](a);return +g}else{e=f[(f[a>>2]|0)+c>>2]|0;g=+xg[e&31](a);return +g}return +(0.0)}function $D(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fi[f[a>>2]&255](b,c,d);return}function aE(a){a=a|0;return f[a+4>>2]|0}function bE(){var a=0;a=NYa(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function cE(a){a=a|0;return 0}function dE(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)ki[f[(f[b>>2]|0)+8>>2]&2047](b);PYa(a);return}function eE(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function fE(a){a=a|0;if(!a)return;ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function gE(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function hE(a){a=a|0;if(!a)return;ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function iE(a){a=a|0;var b=0;if(!a){b=0;return b|0}b=a+(f[(f[a>>2]|0)+-40>>2]|0)|0;return b|0}function jE(a){a=a|0;var b=0;if(!a){b=0;return b|0}b=OZa(a,10256,19176,-1)|0;return b|0}function kE(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;Gh[f[a>>2]&511](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=dKa(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;K1a(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}PYa(h);u=d;return c|0}function lE(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ah[f[a>>2]&255](b,c,d,e);return}function mE(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fi[f[a>>2]&255](b,c,d);return}function nE(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ah[f[a>>2]&255](b,c,d,e);return}function oE(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;bh[f[a>>2]&255](b,c,d,e,g,h);return}function pE(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;Bh[f[a>>2]&255](b,c,d,e,g);return}function qE(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=mi[e&255](a)|0;return g|0}else{e=f[(f[a>>2]|0)+c>>2]|0;g=mi[e&255](a)|0;return g|0}return 0}function rE(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function sE(a){a=a|0;if(!a)return;ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function tE(a){a=a|0;return a|0}function uE(a){a=a|0;return a|0}function vE(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+32|0;e=d;g=d+8|0;h=c+4|0;i=f[c>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(i>>>0>4294967279)WYa(g);if(i>>>0<11){b[g+11>>0]=i;if(!i)j=g;else{k=g;l=6}}else{c=i+16&-16;m=NYa(c)|0;f[g>>2]=m;f[g+8>>2]=c|-2147483648;f[g+4>>2]=i;k=m;l=6}if((l|0)==6){K1a(k|0,h|0,i|0)|0;j=k}b[j+i>>0]=0;Gh[a&511](e,g);a=NYa(8)|0;f[a>>2]=f[e>>2];f[a+4>>2]=f[e+4>>2];i=e;f[i>>2]=0;f[i+4>>2]=0;if((b[g+11>>0]|0)>=0){u=d;return a|0}PYa(f[g>>2]|0);u=d;return a|0}function wE(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;Bh[f[a>>2]&255](b,c,d,e,g);return}function xE(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ah[f[a>>2]&255](b,c,d,e);return}function yE(a){a=a|0;return f[a+4>>2]|0}function zE(){var a=0;a=NYa(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function AE(a){a=a|0;return 0}function BE(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)ki[f[(f[b>>2]|0)+8>>2]&2047](b);PYa(a);return}function CE(a){a=a|0;return 10136}function DE(a){a=a|0;if(!a)return;Tsa(a);PYa(a);return}function EE(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;a=d+4|0;i=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(i>>>0>4294967279)WYa(g);if(i>>>0<11){b[g+11>>0]=i;if(!i)j=g;else{k=g;l=6}}else{d=i+16&-16;m=NYa(d)|0;f[g>>2]=m;f[g+8>>2]=d|-2147483648;f[g+4>>2]=i;k=m;l=6}if((l|0)==6){K1a(k|0,a|0,i|0)|0;j=k}b[j+i>>0]=0;i=$h[h&255](c,g)|0;if((b[g+11>>0]|0)>=0){u=e;return i|0}PYa(f[g>>2]|0);u=e;return i|0}function FE(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0;l=u;u=u+16|0;m=l+8|0;n=l;o=f[a>>2]|0;f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];f[n>>2]=f[k>>2];f[n+4>>2]=f[k+4>>2];Tg[o&7](b,c,d,e,g,h,i,m,n);u=l;return}function GE(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;k=u;u=u+16|0;l=k;m=f[a>>2]|0;f[l>>2]=f[j>>2];f[l+4>>2]=f[j+4>>2];Zf[m&7](b,c,d,e,g,h,i,l);u=k;return}function HE(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;yi[f[a>>2]&7](b,c,d,e,g,h,i);return}function IE(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;ri[f[a>>2]&7](b,c,d,e,g,h);return}function JE(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;Hh[f[a>>2]&15](b,c,d,e,g);return}function KE(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ah[f[a>>2]&255](b,c,d,e);return}function LE(){var a=0;a=NYa(8)|0;Osa(a);return a|0}function ME(a){a=a|0;return Gi[a&63]()|0}function NE(a){a=a|0;var b=0;b=NYa(8)|0;Psa(b,a);return b|0}function OE(a,b){a=a|0;b=b|0;return mi[a&255](b)|0}function PE(a,b,c,d,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0;n=u;u=u+16|0;o=n+8|0;p=n;q=f[a>>2]|0;f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];Kg[q&3](b,c,d,e,g,h,i,j,o,p,m);u=n;return}function QE(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0;m=u;u=u+16|0;n=m+8|0;o=m;p=f[a>>2]|0;f[n>>2]=f[k>>2];f[n+4>>2]=f[k+4>>2];f[o>>2]=f[l>>2];f[o+4>>2]=f[l+4>>2];ji[p&3](b,c,d,e,g,h,i,j,n,o);u=m;return}function RE(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;l=u;u=u+16|0;m=l;n=f[a>>2]|0;f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2];Mi[n&3](b,c,d,e,g,h,i,j,m);u=l;return}function SE(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;Th[f[a>>2]&7](b,c,d,e,g,h,i,j);return}function TE(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;og[f[a>>2]&7](b,c,d,e,g,h,i);return}function UE(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;$g[f[a>>2]&7](b,c,d,e,g,h);return}function VE(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;Bh[f[a>>2]&255](b,c,d,e,g);return}function WE(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=mi[e&255](a)|0;return g|0}else{e=f[(f[a>>2]|0)+c>>2]|0;g=mi[e&255](a)|0;return g|0}return 0}function XE(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;k=u;u=u+16|0;l=k+8|0;m=k;n=f[a>>2]|0;f[l>>2]=f[i>>2];f[l+4>>2]=f[i+4>>2];f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];ch[n&3](b,c,d,e,g,h,l,m);u=k;return}function YE(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=u;u=u+16|0;k=j;l=f[a>>2]|0;f[k>>2]=f[i>>2];f[k+4>>2]=f[i+4>>2];$f[l&3](b,c,d,e,g,h,k);u=j;return}function ZE(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;vg[f[a>>2]&3](b,c,d,e,g,h);return}function _E(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;hh[f[a>>2]&7](b,c,d,e,g);return}function $E(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;vh[f[a>>2]&63](b,c,d,e);return}function aF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fi[f[a>>2]&255](b,c,d);return}function bF(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function cF(a){a=a|0;if(!a)return;ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function dF(a){a=a|0;return a|0}function eF(a){a=a|0;return a|0}function fF(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=mi[e&255](a)|0;return g|0}else{e=f[(f[a>>2]|0)+c>>2]|0;g=mi[e&255](a)|0;return g|0}return 0}function gF(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=mi[e&255](a)|0;return g|0}else{e=f[(f[a>>2]|0)+c>>2]|0;g=mi[e&255](a)|0;return g|0}return 0}function hF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;Ah[a&255](g,b,c,d);d=NYa(8)|0;f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];u=e;return d|0}function iF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;fi[a&255](e,b,c);c=NYa(8)|0;f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];u=d;return c|0}function jF(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Gh[a&511](d,b);b=NYa(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function kF(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;ki[a&2047](c);a=NYa(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function lF(a,b,c){a=a|0;b=b|0;c=c|0;Gh[f[a>>2]&511](b,c);return}function mF(a,b,c){a=a|0;b=b|0;c=c|0;Gh[f[a>>2]&511](b,c);return}function nF(a){a=a|0;return f[a+4>>2]|0}function oF(){var a=0;a=NYa(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function pF(a){a=a|0;return 0}function qF(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)ki[f[(f[b>>2]|0)+8>>2]&2047](b);PYa(a);return}function rF(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function sF(a){a=a|0;if(!a)return;ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function tF(a){a=a|0;return a|0}function uF(a){a=a|0;return a|0}function vF(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=mi[e&255](a)|0;return g|0}else{e=f[(f[a>>2]|0)+c>>2]|0;g=mi[e&255](a)|0;return g|0}return 0}function wF(a,b,c){a=a|0;b=b|0;c=c|0;Gh[f[a>>2]&511](b,c);return}function xF(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0;l=u;u=u+16|0;m=l;Ch[a&1](m,b,c,d,e,g,h,i,j,k);k=NYa(8)|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2];u=l;return k|0}function yF(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0;k=u;u=u+16|0;l=k;ti[a&1](l,b,c,d,e,g,h,i,j);j=NYa(8)|0;f[j>>2]=f[l>>2];f[j+4>>2]=f[l+4>>2];u=k;return j|0}function zF(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;ii[a&1](k,b,c,d,e,g,h,i);i=NYa(8)|0;f[i>>2]=f[k>>2];f[i+4>>2]=f[k+4>>2];u=j;return i|0}function AF(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;Ug[a&1](j,b,c,d,e,g,h);h=NYa(8)|0;f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];u=i;return h|0}function BF(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;fg[a&1](i,b,c,d,e,g);g=NYa(8)|0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];u=h;return g|0}function CF(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;xh[a&1](h,b,c,d,e);e=NYa(8)|0;f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];u=g;return e|0}function DF(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;Kh[a&15](g,b,c,d);d=NYa(8)|0;f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];u=e;return d|0}function EF(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;d=u;u=u+16|0;e=d;hi[a&31](e,b,c);b=NYa(8)|0;f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];u=d;return b|0}function FF(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Gh[a&511](d,b);b=NYa(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function GF(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;ki[a&2047](c);a=NYa(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function HF(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=+xg[e&31](a);return +g}else{e=f[(f[a>>2]|0)+c>>2]|0;g=+xg[e&31](a);return +g}return +(0.0)}function IF(a,b,c){a=a|0;b=b|0;c=+c;Dh[f[a>>2]&31](b,c);return}function JF(a){a=a|0;return f[a+4>>2]|0}function KF(){var a=0;a=NYa(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function LF(a){a=a|0;return 0}function MF(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)ki[f[(f[b>>2]|0)+8>>2]&2047](b);PYa(a);return}function NF(){Gj(0);vs(0);return}function OF(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[a>>2]=30076;_$(c,30148);if(!(f[c+4>>2]|0)){u=b;return}u=b;return}function PF(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[a>>2]=30076;_$(c,30148);if(!(f[c+4>>2]|0)){PYa(a);u=b;return}PYa(a);u=b;return}function QF(a){a=a|0;return}function RF(a,b){a=a|0;b=b|0;return}function SF(a,b){a=a|0;b=b|0;return}function TF(a){a=a|0;return 0}function UF(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+64|0;e=d+56|0;g=d+48|0;h=d+8|0;i=d;_$(g,30128);f[e>>2]=0;f[e+4>>2]=0;VX(h,c,1,e);d$(e);Gh[f[(f[a>>2]|0)+28>>2]&511](i,a);c=YX(h,i)|0;f[e>>2]=0;f[e+4>>2]=0;j=c$(e,1)|0;b[j>>0]=123;YX(c,e)|0;d$(e);d$(i);Gh[f[(f[a>>2]|0)+12>>2]&511](a,h);f[e>>2]=0;f[e+4>>2]=0;a=c$(e,1)|0;b[a>>0]=125;YX(h,e)|0;d$(e);dV(h);if(!(f[g+4>>2]|0)){u=d;return}u=d;return}function VF(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;_$(d,30108);f[a>>2]=0;f[a+4>>2]=0;e=c$(a,9)|0;a=155722;g=e+9|0;do{b[e>>0]=b[a>>0]|0;e=e+1|0;a=a+1|0}while((e|0)<(g|0));if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function WF(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[a>>2]=30076;_$(c,30168);if(!(f[c+4>>2]|0)){u=b;return}u=b;return}function XF(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;a=u;u=u+16|0;d=a+8|0;e=a;_$(e,30188);f[d>>2]=0;f[d+4>>2]=0;g=c$(d,6)|0;b[g>>0]=b[191861]|0;b[g+1>>0]=b[191862]|0;b[g+2>>0]=b[191863]|0;b[g+3>>0]=b[191864]|0;b[g+4>>0]=b[191865]|0;b[g+5>>0]=b[191866]|0;g=YX(c,d)|0;d$(d);if(mi[f[(f[g>>2]|0)+12>>2]&255](g)|0){c=g+32|0;if((f[c>>2]|0)==6){f[d>>2]=0;f[d+4>>2]=0;h=c$(d,30)|0;i=354672;j=h+30|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-2,d,373532,354703,1186);d$(d)}eY(g,g+12|0,3);if(f[c>>2]&4|0)f[c>>2]=6}if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function YF(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+32|0;c=b;d=b+16|0;e=b+8|0;f[e>>2]=0;if(!(jKa(e,64,a)|0)){g=f[e>>2]|0;if(g|0){h=g;u=b;return h|0}}else f[e>>2]=0;e=c;f[e>>2]=a;f[e+4>>2]=0;p$(d,156035,c);j$(-4,d,156065,156082,55);d$(d);h=0;u=b;return h|0}function ZF(a){a=a|0;eKa(a);return}function _F(a){a=a|0;return YF(a)|0}function $F(a){a=a|0;eKa(a);return}function aG(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16|0;h=g;i=g+8|0;j=f[a+4>>2]|0;if((j|0)<3)k=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{l=f[a+40>>2]|0;m=0;n=1;while(1){o=Y(f[l+(m<<2)>>2]|0,n)|0;m=m+1|0;if((m|0)==(j|0)){k=o;break}else n=o}}n=c>>>3&511;j=n+1|0;m=c&7;l=j<<(47696>>>(m<<1)&3);o=VI(f[a>>2]&7,c)|0;c=f[a+16>>2]|0;a=(k|0)<=(n|0);f[h>>2]=a?k:j;f[h+4>>2]=1;Oh[o&255](c,1,0,1,d,1,h,0);if(a){if((k|0)!=1){f[i>>2]=0;f[i+4>>2]=0;k=c$(i,8)|0;a=k;b[a>>0]=115;b[a+1>>0]=99;b[a+2>>0]=110;b[a+3>>0]=32;a=k+4|0;b[a>>0]=61;b[a+1>>0]=61;b[a+2>>0]=32;b[a+3>>0]=49;j$(-215,i,156129,156152,68);d$(i)}i=1212424721>>>(m<<2)&15;if(i>>>0<l>>>0){m=i;do{b[d+m>>0]=b[d+(m-i)>>0]|0;m=m+1|0}while((m|0)!=(l|0))}}m=Y(l,e)|0;if(l>>>0<m>>>0)p=l;else{u=g;return}do{b[d+p>>0]=b[d+(p-l)>>0]|0;p=p+1|0}while((p|0)!=(m|0));u=g;return}function bG(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e+8|0;h=e;_$(g,30208);f[h>>2]=102;dG(a,b,c,d,h,1,9);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function cG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;eG(a,b,c,d,e,f,g,h);return}function dG(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;j=u;u=u+1440|0;k=j+1376|0;l=j+1368|0;m=j+1352|0;n=j+1360|0;o=j+312|0;q=j+256|0;r=j;s=j+184|0;t=j+128|0;v=j+104|0;w=j+88|0;x=j+56|0;y=j+248|0;z=j+240|0;A=a;B=c;C=NS(a)|0;D=NS(c)|0;E=RR(a,-1)|0;F=E&7;G=(E>>>3&511)+1|0;H=RR(c,-1)|0;I=H&7;K=(H>>>3&511)+1|0;L=nS(a,-1)|0;M=nS(c,-1)|0;N=(L|0)<3;if(N)QR(l,a,-1);else{f[l>>2]=0;f[l+4>>2]=0}L=(M|0)<3;if(L)QR(m,c,-1);else{f[m>>2]=0;f[m+4>>2]=0}M=XS(e)|0;if(((C|0)==(D|0)&(N&L)?(L=f[l>>2]|0,N=f[l+4>>2]|0,(L|0)==(f[m>>2]|0)?(N|0)==(f[m+4>>2]|0):0):0)?!((E|0)!=(H|0)|M^1):0){f[n>>2]=L;f[n+4>>2]=N;KS(d,n,E,-1,0,0);if(h){O=G<<(47696>>>(E<<1&14)&3);P=g}else{O=G;P=g+(F<<2)|0}n=f[P>>2]|0;do if((NS(a)|0)==65536){P=f[a+4>>2]|0;f[k>>2]=f[P>>2];N=k+4|0;L=P+4|0;f[N>>2]=f[L>>2];Q=k+8|0;f[Q>>2]=f[P+8>>2];f[k+12>>2]=f[P+12>>2];f[k+16>>2]=f[P+16>>2];f[k+20>>2]=f[P+20>>2];f[k+24>>2]=f[P+24>>2];f[k+28>>2]=f[P+28>>2];f[k+32>>2]=f[P+32>>2];R=f[P+36>>2]|0;f[k+36>>2]=R;f[k+40>>2]=Q;Q=k+48|0;S=k+44|0;f[S>>2]=Q;f[Q>>2]=0;f[k+52>>2]=0;if(R|0){Q=R+12|0;f[Q>>2]=(f[Q>>2]|0)+1}if((f[L>>2]|0)<3){L=f[P+44>>2]|0;Q=f[S>>2]|0;f[Q>>2]=f[L>>2];f[Q+4>>2]=f[L+4>>2];break}else{f[N>>2]=0;BR(k,P);break}}else OR(k,a,-1);while(0);do if((NS(c)|0)==65536){P=f[c+4>>2]|0;f[o>>2]=f[P>>2];N=o+4|0;L=P+4|0;f[N>>2]=f[L>>2];Q=o+8|0;f[Q>>2]=f[P+8>>2];f[o+12>>2]=f[P+12>>2];f[o+16>>2]=f[P+16>>2];f[o+20>>2]=f[P+20>>2];f[o+24>>2]=f[P+24>>2];f[o+28>>2]=f[P+28>>2];f[o+32>>2]=f[P+32>>2];S=f[P+36>>2]|0;f[o+36>>2]=S;f[o+40>>2]=Q;Q=o+48|0;R=o+44|0;f[R>>2]=Q;f[Q>>2]=0;f[o+52>>2]=0;if(S|0){Q=S+12|0;f[Q>>2]=(f[Q>>2]|0)+1}if((f[L>>2]|0)<3){L=f[P+44>>2]|0;Q=f[R>>2]|0;f[Q>>2]=f[L>>2];f[Q+4>>2]=f[L+4>>2];break}else{f[N>>2]=0;BR(o,P);break}}else OR(o,c,-1);while(0);do if((NS(d)|0)==65536){P=f[d+4>>2]|0;f[q>>2]=f[P>>2];N=q+4|0;L=P+4|0;f[N>>2]=f[L>>2];Q=q+8|0;f[Q>>2]=f[P+8>>2];f[q+12>>2]=f[P+12>>2];f[q+16>>2]=f[P+16>>2];f[q+20>>2]=f[P+20>>2];f[q+24>>2]=f[P+24>>2];f[q+28>>2]=f[P+28>>2];f[q+32>>2]=f[P+32>>2];R=f[P+36>>2]|0;f[q+36>>2]=R;f[q+40>>2]=Q;Q=q+48|0;S=q+44|0;f[S>>2]=Q;f[Q>>2]=0;f[q+52>>2]=0;if(R|0){Q=R+12|0;f[Q>>2]=(f[Q>>2]|0)+1}if((f[L>>2]|0)<3){L=f[P+44>>2]|0;Q=f[S>>2]|0;f[Q>>2]=f[L>>2];f[Q+4>>2]=f[L+4>>2];T=q;break}else{f[N>>2]=0;BR(q,P);T=q;break}}else{OR(q,d,-1);T=q}while(0);P=f[k>>2]|0;N=f[o>>2]|0;L=f[T>>2]|0;T=f[k+12>>2]|0;Q=f[k+8>>2]|0;S=W1a(Q|0,((Q|0)<0)<<31>>31|0,T|0,((T|0)<0)<<31>>31|0)|0;if((P&16384&N&L|0)!=0?(S|0)==(S|0)&(((S|0)<0)<<31>>31|0)==(J|0):0){U=S;V=1}else{U=T;V=Q}Q=Y(U,O)|0;O=k+16|0;U=k+44|0;T=k+48|0;S=o+16|0;L=o+44|0;N=o+48|0;P=q+16|0;R=q+44|0;W=q+48|0;_h[n&127](f[O>>2]|0,f[T>>2]|0,f[S>>2]|0,f[N>>2]|0,f[P>>2]|0,f[W>>2]|0,Q,V,0);V=q+36|0;Q=f[V>>2]|0;if(Q|0?(n=Q+12|0,Q=f[n>>2]|0,f[n>>2]=Q+-1,(Q|0)==1):0)CR(q);f[V>>2]=0;V=q+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[V>>2]|0)>0){P=f[q+40>>2]|0;Q=0;do{f[P+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[V>>2]|0))}V=f[R>>2]|0;if((V|0)!=(W|0))ZF(V);V=o+36|0;W=f[V>>2]|0;if(W|0?(R=W+12|0,W=f[R>>2]|0,f[R>>2]=W+-1,(W|0)==1):0)CR(o);f[V>>2]=0;V=o+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[V>>2]|0)>0){S=f[o+40>>2]|0;W=0;do{f[S+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[V>>2]|0))}V=f[L>>2]|0;if((V|0)!=(N|0))ZF(V);V=k+36|0;N=f[V>>2]|0;if(N|0?(L=N+12|0,N=f[L>>2]|0,f[L>>2]=N+-1,(N|0)==1):0)CR(k);f[V>>2]=0;V=k+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[V>>2]|0)>0){O=f[k+40>>2]|0;N=0;do{f[O+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[V>>2]|0))}V=f[U>>2]|0;if((V|0)!=(T|0))ZF(V);u=j;return}a:do if((i|0)==12){X=G;Z=F;_=1;$=A;aa=B;ba=E}else{V=(C|0)==131072;T=(D|0)==131072;if(((T&1)+(V&1)|0)!=1?(E|0)==(H|0)&(TS(a,c)|0):0){if(TS(a,c)|0){X=G;Z=F;_=0;$=A;aa=B;ba=E;break}f[k>>2]=0;f[k+4>>2]=0;ca=c$(k,41)|0;da=156341;ea=ca+41|0;do{b[ca>>0]=b[da>>0]|0;ca=ca+1|0;da=da+1|0}while((ca|0)<(ea|0));j$(-215,k,156331,156152,230);d$(k);X=G;Z=F;_=0;$=A;aa=B;ba=E;break}b:do if((nS(a,-1)|0)<=2?YS(a,-1)|0:0){QR(k,a,-1);U=f[k>>2]|0;N=(U|0)==1;if(N){if(!((C|0)!=131072&T)){fa=f[k+4>>2]|0;ga=71}}else if(!((C|0)!=131072&T|(f[k+4>>2]|0)!=1)){fa=1;ga=71}do if((ga|0)==71){O=(fa|0)==1;if(!((U|0)==(K|0)&O|N&(O|(fa|0)==(K|0)))){if(!(N&(fa|0)==4))break;if(!(K>>>0<5&(RR(a,-1)|0)==6))break b}O=f[l>>2]|0;L=l+4|0;W=f[L>>2]|0;f[l>>2]=f[m>>2];S=m+4|0;f[L>>2]=f[S>>2];f[m>>2]=O;f[S>>2]=W;X=K;Z=I;_=1;$=B;aa=A;ba=H;break a}while(0)}while(0);do if((nS(c,-1)|0)<=2?YS(c,-1)|0:0){QR(k,c,-1);T=f[k>>2]|0;N=(T|0)==1;if(N){if(!(V&(D|0)!=131072)){ha=f[k+4>>2]|0;ga=83}}else if(!(V&(D|0)!=131072|(f[k+4>>2]|0)!=1)){ha=1;ga=83}if((ga|0)==83){U=(ha|0)==1;if((T|0)==(G|0)&U|N&(U|(ha|0)==(G|0))){X=G;Z=F;_=1;$=A;aa=B;ba=E;break a}if(N&(ha|0)==4)if(G>>>0<5&(RR(c,-1)|0)==6){X=G;Z=F;_=1;$=A;aa=B;ba=E;break a}else break}}while(0);f[k>>2]=0;f[k+4>>2]=0;K1a(c$(k,130)|0,156200,130)|0;j$(-209,k,156331,156152,225);d$(k);X=G;Z=F;_=1;$=A;aa=B;ba=E}while(0);E=(ba>>>3&511)+1<<(47696>>>(ba<<1&14)&3);f[k>>2]=E;B=((E+1023|0)>>>0)/(E>>>0)|0;if(!M){if((RR(e,-1)|0|1|0)==1?(E=$,TS(e,E)|0):0)ia=E;else{f[o>>2]=0;f[o+4>>2]=0;ca=c$(o,52)|0;da=156383;ea=ca+52|0;do{b[ca>>0]=b[da>>0]|0;ca=ca+1|0;da=da+1|0}while((ca|0)<(ea|0));j$(-215,o,156331,156152,241);d$(o);ia=$}da=cL(f[k>>2]|0)|0;if(TS(d,ia)|0){ja=ia;ka=da;la=(RR(d,-1)|0)!=(ba|0)}else{ja=ia;ka=da;la=1}}else{ja=$;ka=0;la=0}$=o+8|0;f[o>>2]=$;da=o+4|0;f[da>>2]=1032;bT(d,ja,ba);if(!(M|la^1)){p[r>>3]=0.0;f[q>>2]=-1056833530;f[q+4>>2]=r;f[q+8>>2]=1;f[q+12>>2]=1;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;eT(d,q,s)}do if((NS(ja)|0)==65536){la=f[ja+4>>2]|0;f[q>>2]=f[la>>2];ba=q+4|0;ia=la+4|0;f[ba>>2]=f[ia>>2];ca=q+8|0;f[ca>>2]=f[la+8>>2];f[q+12>>2]=f[la+12>>2];f[q+16>>2]=f[la+16>>2];f[q+20>>2]=f[la+20>>2];f[q+24>>2]=f[la+24>>2];f[q+28>>2]=f[la+28>>2];f[q+32>>2]=f[la+32>>2];ea=f[la+36>>2]|0;f[q+36>>2]=ea;f[q+40>>2]=ca;ca=q+48|0;E=q+44|0;f[E>>2]=ca;f[ca>>2]=0;f[q+52>>2]=0;if(ea|0){ca=ea+12|0;f[ca>>2]=(f[ca>>2]|0)+1}if((f[ia>>2]|0)<3){ia=f[la+44>>2]|0;ca=f[E>>2]|0;f[ca>>2]=f[ia>>2];f[ca+4>>2]=f[ia+4>>2];break}else{f[ba>>2]=0;BR(q,la);break}}else OR(q,ja,-1);while(0);ja=aa;do if((NS(ja)|0)==65536){aa=f[ja+4>>2]|0;f[r>>2]=f[aa>>2];la=r+4|0;ba=aa+4|0;f[la>>2]=f[ba>>2];ia=r+8|0;f[ia>>2]=f[aa+8>>2];f[r+12>>2]=f[aa+12>>2];f[r+16>>2]=f[aa+16>>2];f[r+20>>2]=f[aa+20>>2];f[r+24>>2]=f[aa+24>>2];f[r+28>>2]=f[aa+28>>2];f[r+32>>2]=f[aa+32>>2];ca=f[aa+36>>2]|0;f[r+36>>2]=ca;f[r+40>>2]=ia;ia=r+48|0;E=r+44|0;f[E>>2]=ia;f[ia>>2]=0;f[r+52>>2]=0;if(ca|0){ia=ca+12|0;f[ia>>2]=(f[ia>>2]|0)+1}if((f[ba>>2]|0)<3){ba=f[aa+44>>2]|0;ia=f[E>>2]|0;f[ia>>2]=f[ba>>2];f[ia+4>>2]=f[ba+4>>2];break}else{f[la>>2]=0;BR(r,aa);break}}else OR(r,ja,-1);while(0);do if((NS(d)|0)==65536){ja=f[d+4>>2]|0;f[s>>2]=f[ja>>2];aa=s+4|0;la=ja+4|0;f[aa>>2]=f[la>>2];ba=s+8|0;f[ba>>2]=f[ja+8>>2];f[s+12>>2]=f[ja+12>>2];f[s+16>>2]=f[ja+16>>2];f[s+20>>2]=f[ja+20>>2];f[s+24>>2]=f[ja+24>>2];f[s+28>>2]=f[ja+28>>2];f[s+32>>2]=f[ja+32>>2];ia=f[ja+36>>2]|0;f[s+36>>2]=ia;f[s+40>>2]=ba;ba=s+48|0;E=s+44|0;f[E>>2]=ba;f[ba>>2]=0;f[s+52>>2]=0;if(ia|0){ba=ia+12|0;f[ba>>2]=(f[ba>>2]|0)+1}if((f[la>>2]|0)<3){la=f[ja+44>>2]|0;ba=f[E>>2]|0;f[ba>>2]=f[la>>2];f[ba+4>>2]=f[la+4>>2];break}else{f[aa>>2]=0;BR(s,ja);break}}else OR(s,d,-1);while(0);do if((NS(e)|0)==65536){d=f[e+4>>2]|0;f[t>>2]=f[d>>2];ja=t+4|0;aa=d+4|0;f[ja>>2]=f[aa>>2];la=t+8|0;f[la>>2]=f[d+8>>2];f[t+12>>2]=f[d+12>>2];f[t+16>>2]=f[d+16>>2];f[t+20>>2]=f[d+20>>2];f[t+24>>2]=f[d+24>>2];f[t+28>>2]=f[d+28>>2];f[t+32>>2]=f[d+32>>2];ba=f[d+36>>2]|0;f[t+36>>2]=ba;f[t+40>>2]=la;la=t+48|0;E=t+44|0;f[E>>2]=la;f[la>>2]=0;f[t+52>>2]=0;if(ba|0){la=ba+12|0;f[la>>2]=(f[la>>2]|0)+1}if((f[aa>>2]|0)<3){aa=f[d+44>>2]|0;la=f[E>>2]|0;f[la>>2]=f[aa>>2];f[la+4>>2]=f[aa+4>>2];break}else{f[ja>>2]=0;BR(t,d);break}}else OR(t,e,-1);while(0);e=h?f[k>>2]|0:X;X=f[(h?g:g+(Z<<2)|0)>>2]|0;if(_){f[v>>2]=q;f[v+4>>2]=s;f[v+8>>2]=t;f[v+12>>2]=0;bU(x,v,w,-1);_=f[x+20>>2]|0;Z=B>>>0<_>>>0?B:_;g=(Y(Y(f[k>>2]|0,M?1:2)|0,Z)|0)+32|0;if((f[da>>2]|0)>>>0<g>>>0){h=f[o>>2]|0;if((h|0)!=($|0)){if(h|0)QYa(h);f[o>>2]=$;f[da>>2]=1032}f[da>>2]=g;if(g>>>0>1032){h=OYa(g)|0;f[o>>2]=h;ma=h}else ma=$}else{f[da>>2]=g;ma=f[o>>2]|0}g=ma+(Y(f[k>>2]|0,Z)|0)+15&-16;aG(r,f[q>>2]&4095,ma,Z);h=x+16|0;d=w+4|0;ja=w+8|0;aa=z+4|0;c:do if(!_){la=0;while(1){if(la>>>0>=(f[h>>2]|0)>>>0)break c;tR(x)|0;la=la+1|0}}else{la=0;while(1){if(la>>>0>=(f[h>>2]|0)>>>0)break c;E=f[w>>2]|0;if(M){ba=E;ia=f[d>>2]|0;ca=0;do{ea=_-ca|0;A=ea>>>0>Z>>>0?Z:ea;ea=Y(A,e)|0;_h[X&127](ba,0,ma,0,ia,0,ea,1,0);ea=Y(f[k>>2]|0,A)|0;ba=(f[w>>2]|0)+ea|0;f[w>>2]=ba;ia=(f[d>>2]|0)+ea|0;f[d>>2]=ia;ca=ca+Z|0}while(_>>>0>ca>>>0)}else{ca=E;ia=0;do{ba=_-ia|0;ea=ba>>>0>Z>>>0?Z:ba;ba=Y(ea,e)|0;_h[X&127](ca,0,ma,0,g,0,ba,1,0);ba=f[ja>>2]|0;A=f[d>>2]|0;f[z>>2]=ea;f[aa>>2]=1;Oh[ka&255](g,0,ba,0,A,0,z,k);f[ja>>2]=(f[ja>>2]|0)+ea;A=Y(f[k>>2]|0,ea)|0;ca=(f[w>>2]|0)+A|0;f[w>>2]=ca;f[d>>2]=(f[d>>2]|0)+A;ia=ia+Z|0}while(_>>>0>ia>>>0)}tR(x)|0;la=la+1|0}}while(0)}else{f[v>>2]=q;f[v+4>>2]=r;f[v+8>>2]=s;f[v+12>>2]=t;f[v+16>>2]=0;bU(x,v,w,-1);v=f[x+20>>2]|0;if((Y(v,e)|0)<0)na=2147483647/(e|0)|0;else na=v;do if(!M){_=B>>>0<na>>>0?B:na;Z=Y(f[k>>2]|0,_)|0;if((f[da>>2]|0)>>>0>=Z>>>0){f[da>>2]=Z;oa=_;pa=f[o>>2]|0;break}d=f[o>>2]|0;if((d|0)!=($|0)){if(d|0)QYa(d);f[o>>2]=$;f[da>>2]=1032}f[da>>2]=Z;if(Z>>>0>1032){d=OYa(Z)|0;f[o>>2]=d;oa=_;pa=d}else{oa=_;pa=$}}else{oa=na;pa=0}while(0);na=x+16|0;B=(v|0)==0;_=w+4|0;d=w+8|0;Z=w+12|0;ja=y+4|0;z=0;while(1){if(z>>>0>=(f[na>>2]|0)>>>0)break;d:do if(!B){g=f[w>>2]|0;aa=f[_>>2]|0;if(!M){ma=g;h=aa;la=0;while(1){ia=v-la|0;ca=ia>>>0>oa>>>0?oa:ia;ia=Y(ca,e)|0;_h[X&127](ma,0,h,0,pa,0,ia,1,0);ia=f[Z>>2]|0;E=f[d>>2]|0;f[y>>2]=ca;f[ja>>2]=1;Oh[ka&255](pa,0,ia,0,E,0,y,k);f[Z>>2]=(f[Z>>2]|0)+ca;E=Y(f[k>>2]|0,ca)|0;ma=(f[w>>2]|0)+E|0;f[w>>2]=ma;h=(f[_>>2]|0)+E|0;f[_>>2]=h;f[d>>2]=(f[d>>2]|0)+E;la=la+oa|0;if(v>>>0<=la>>>0)break d}}la=g;h=aa;ma=f[d>>2]|0;E=0;do{ca=v-E|0;ia=ca>>>0>oa>>>0?oa:ca;ca=Y(ia,e)|0;_h[X&127](la,0,h,0,ma,0,ca,1,0);ca=Y(f[k>>2]|0,ia)|0;la=(f[w>>2]|0)+ca|0;f[w>>2]=la;h=(f[_>>2]|0)+ca|0;f[_>>2]=h;ma=(f[d>>2]|0)+ca|0;f[d>>2]=ma;E=E+oa|0}while(v>>>0>E>>>0)}while(0);tR(x)|0;z=z+1|0}}z=t+36|0;x=f[z>>2]|0;if(x|0?(v=x+12|0,x=f[v>>2]|0,f[v>>2]=x+-1,(x|0)==1):0)CR(t);f[z>>2]=0;z=t+16|0;x=t+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[x>>2]|0)>0){z=f[t+40>>2]|0;v=0;do{f[z+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[x>>2]|0))}x=f[t+44>>2]|0;if((x|0)!=(t+48|0))ZF(x);x=s+36|0;t=f[x>>2]|0;if(t|0?(v=t+12|0,t=f[v>>2]|0,f[v>>2]=t+-1,(t|0)==1):0)CR(s);f[x>>2]=0;x=s+16|0;t=s+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[t>>2]|0)>0){x=f[s+40>>2]|0;v=0;do{f[x+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[t>>2]|0))}t=f[s+44>>2]|0;if((t|0)!=(s+48|0))ZF(t);t=r+36|0;s=f[t>>2]|0;if(s|0?(v=s+12|0,s=f[v>>2]|0,f[v>>2]=s+-1,(s|0)==1):0)CR(r);f[t>>2]=0;t=r+16|0;s=r+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[s>>2]|0)>0){t=f[r+40>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[s>>2]|0))}s=f[r+44>>2]|0;if((s|0)!=(r+48|0))ZF(s);s=q+36|0;r=f[s>>2]|0;do if(r|0){v=r+12|0;t=f[v>>2]|0;f[v>>2]=t+-1;if((t|0)!=1)break;CR(q)}while(0);f[s>>2]=0;s=q+16|0;r=q+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[r>>2]|0)>0){s=f[q+40>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[q+44>>2]|0;if((r|0)!=(q+48|0))ZF(r);r=f[o>>2]|0;if((r|0)!=($|0)){if(r|0)QYa(r);f[o>>2]=$;f[da>>2]=1032}u=j;return}function eG(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=j;m=f;n=a;o=d;while(1){if(k){p=0;do{b[m+p>>0]=b[o+p>>0]&b[n+p>>0];p=p+1|0}while((p|0)!=(h|0))}if(!l)break;else{l=l+-1|0;m=m+g|0;n=n+c|0;o=o+e|0}}return}o=h&-4;n=(o|0)<(h|0);m=j;j=f;f=a;a=d;while(1){d=0;do{l=d|1;k=b[a+l>>0]&b[f+l>>0];b[j+d>>0]=b[a+d>>0]&b[f+d>>0];b[j+l>>0]=k;k=d|2;l=d|3;p=b[a+l>>0]&b[f+l>>0];b[j+k>>0]=b[a+k>>0]&b[f+k>>0];b[j+l>>0]=p;d=d+4|0}while((d|0)<=(i|0));if(n){d=o;do{b[j+d>>0]=b[a+d>>0]&b[f+d>>0];d=d+1|0}while((d|0)!=(h|0))}if(!m)break;else{m=m+-1|0;j=j+g|0;f=f+c|0;a=a+e|0}}return}function fG(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e+8|0;h=e;_$(g,30228);f[h>>2]=103;dG(a,b,c,d,h,1,10);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function gG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;hG(a,b,c,d,e,f,g,h);return}function hG(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=j;m=f;n=a;o=d;while(1){if(k){p=0;do{b[m+p>>0]=b[o+p>>0]|b[n+p>>0];p=p+1|0}while((p|0)!=(h|0))}if(!l)break;else{l=l+-1|0;m=m+g|0;n=n+c|0;o=o+e|0}}return}o=h&-4;n=(o|0)<(h|0);m=j;j=f;f=a;a=d;while(1){d=0;do{l=d|1;k=b[a+l>>0]|b[f+l>>0];b[j+d>>0]=b[a+d>>0]|b[f+d>>0];b[j+l>>0]=k;k=d|2;l=d|3;p=b[a+l>>0]|b[f+l>>0];b[j+k>>0]=b[a+k>>0]|b[f+k>>0];b[j+l>>0]=p;d=d+4|0}while((d|0)<=(i|0));if(n){d=o;do{b[j+d>>0]=b[a+d>>0]|b[f+d>>0];d=d+1|0}while((d|0)!=(h|0))}if(!m)break;else{m=m+-1|0;j=j+g|0;f=f+c|0;a=a+e|0}}return}function iG(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e+8|0;h=e;_$(g,30248);f[h>>2]=104;dG(a,b,c,d,h,1,11);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function jG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;kG(a,b,c,d,e,f,g,h);return}function kG(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=j;m=f;n=a;o=d;while(1){if(k){p=0;do{b[m+p>>0]=b[o+p>>0]^b[n+p>>0];p=p+1|0}while((p|0)!=(h|0))}if(!l)break;else{l=l+-1|0;m=m+g|0;n=n+c|0;o=o+e|0}}return}o=h&-4;n=(o|0)<(h|0);m=j;j=f;f=a;a=d;while(1){d=0;do{l=d|1;k=b[a+l>>0]^b[f+l>>0];b[j+d>>0]=b[a+d>>0]^b[f+d>>0];b[j+l>>0]=k;k=d|2;l=d|3;p=b[a+l>>0]^b[f+l>>0];b[j+k>>0]=b[a+k>>0]^b[f+k>>0];b[j+l>>0]=p;d=d+4|0}while((d|0)<=(i|0));if(n){d=o;do{b[j+d>>0]=b[a+d>>0]^b[f+d>>0];d=d+1|0}while((d|0)!=(h|0))}if(!m)break;else{m=m+-1|0;j=j+g|0;f=f+c|0;a=a+e|0}}return}function lG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d+8|0;g=d;_$(e,30268);f[g>>2]=105;dG(a,a,b,c,g,1,12);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function mG(a,c,d,e,f,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=j;l=f;m=a}else return;while(1){e=0;do{b[l+e>>0]=~b[m+e>>0];e=e+1|0}while((e|0)!=(h|0));if(!k)break;else{k=k+-1|0;l=l+g|0;m=m+c|0}}return}m=h&-4;if((m|0)<(h|0)){n=j;o=f;p=a}else{l=j;j=f;f=a;while(1){a=0;do{k=a|1;e=~b[f+k>>0];b[j+a>>0]=~b[f+a>>0];b[j+k>>0]=e;e=a|2;k=a|3;d=~b[f+k>>0];b[j+e>>0]=~b[f+e>>0];b[j+k>>0]=d;a=a+4|0}while((a|0)<=(i|0));if(!l)break;else{l=l+-1|0;j=j+g|0;f=f+c|0}}return}while(1){f=0;do{j=f|1;l=~b[p+j>>0];b[o+f>>0]=~b[p+f>>0];b[o+j>>0]=l;l=f|2;j=f|3;a=~b[p+j>>0];b[o+l>>0]=~b[p+l>>0];b[o+j>>0]=a;f=f+4|0}while((f|0)<=(i|0));q=m;do{b[o+q>>0]=~b[p+q>>0];q=q+1|0}while((q|0)!=(h|0));if(!n)break;else{n=n+-1|0;o=o+g|0;p=p+c|0}}return}function nG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_$(e,30288);dG(a,b,c,fT()|0,30308,0,14);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}
function $ua(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,Q=0,R=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0.0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0.0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0,Gg=0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0,Sg=0,Tg=0,Ug=0,Vg=0,Wg=0,Xg=0,Yg=0,Zg=0,_g=0,$g=0,ah=0,bh=0,ch=0,dh=0,eh=0,fh=0,gh=0,hh=0,ih=0,jh=0,kh=0,lh=0,mh=0,nh=0,oh=0,ph=0,qh=0,rh=0,sh=0,th=0,uh=0,vh=0,wh=0,xh=0,yh=0,zh=0,Bh=0,Ch=0,Dh=0,Eh=0,Fh=0,Gh=0,Hh=0,Ih=0,Jh=0,Kh=0,Lh=0,Mh=0,Nh=0,Oh=0,Ph=0,Qh=0,Rh=0,Sh=0,Th=0,Uh=0,Vh=0,Wh=0,Xh=0,Yh=0,Zh=0,_h=0,$h=0,ai=0,bi=0,ci=0,di=0,ei=0,fi=0,gi=0,hi=0,ii=0,ji=0,ki=0,li=0,mi=0,ni=0,oi=0,pi=0,qi=0,ri=0,si=0,ti=0,ui=0,vi=0,wi=0,xi=0,yi=0,zi=0,Ai=0,Bi=0,Ci=0,Di=0,Ei=0,Fi=0,Gi=0,Hi=0,Ii=0,Ji=0,Ki=0,Li=0,Mi=0,Ni=0,Oi=0,Pi=0,Qi=0,Ri=0,Si=0,Ti=0,Ui=0,Vi=0,Wi=0,Xi=0,Yi=0,Zi=0,_i=0,$i=0,aj=0,bj=0,cj=0,dj=0,ej=0,gj=0,hj=0,ij=0,jj=0,kj=0,lj=0,mj=0,nj=0,oj=0,pj=0,qj=0,rj=0,sj=0,tj=0,uj=0,vj=0,wj=0,xj=0,yj=0,zj=0,Aj=0,Bj=0,Cj=0,Dj=0,Ej=0,Fj=0,Gj=0,Hj=0,Ij=0,Jj=0,Kj=0,Lj=0,Mj=0,Nj=0,Oj=0,Pj=0,Qj=0,Rj=0,Sj=0,Tj=0,Uj=0,Vj=0,Wj=0,Xj=0,Yj=0,Zj=0,_j=0,$j=0,ak=0,bk=0,ck=0,dk=0,ek=0,fk=0,gk=0,hk=0,ik=0,jk=0,kk=0,lk=0,mk=0,nk=0,ok=0,pk=0,qk=0,rk=0,sk=0,tk=0,uk=0,vk=0,wk=0,xk=0,yk=0,zk=0,Ak=0,Bk=0,Ck=0,Dk=0,Ek=0,Fk=0,Gk=0,Hk=0,Ik=0,Jk=0,Kk=0,Lk=0,Mk=0,Nk=0,Ok=0,Pk=0,Qk=0,Rk=0,Sk=0,Tk=0,Uk=0,Vk=0,Wk=0,Xk=0,Yk=0,Zk=0,_k=0,$k=0,al=0,bl=0,cl=0,dl=0,el=0,fl=0,gl=0,hl=0,il=0,jl=0,kl=0,ll=0,ml=0,nl=0,ol=0,pl=0,ql=0,rl=0,sl=0,tl=0,ul=0,vl=0,wl=0,xl=0,yl=0,zl=0,Al=0,Bl=0,Cl=0,Dl=0,El=0,Fl=0,Gl=0.0,Hl=0.0,Il=0,Jl=0,Kl=0.0,Ll=0.0,Ml=0.0,Nl=0.0,Ol=0,Pl=0,Ql=0,Rl=0,Sl=0,Tl=0,Ul=0,Vl=0,Wl=0,Xl=0,Yl=0,Zl=0,_l=0.0,$l=0.0,am=0.0,bm=0.0,cm=0.0,dm=0,em=0,fm=0,gm=0,hm=0.0;i=u;u=u+5568|0;j=i+3264|0;k=i+3040|0;l=i+2816|0;m=i+2592|0;o=i+2144|0;q=i+1920|0;r=i+1472|0;t=i+1248|0;v=i+1024|0;w=i+800|0;x=i+576|0;y=i+352|0;z=i+5408|0;A=i+5352|0;B=i+128|0;C=i+5296|0;D=i+5240|0;E=i+5184|0;F=i+5128|0;G=i+5072|0;H=i+5016|0;I=i+4960|0;J=i+4904|0;K=i+4848|0;N=i+4792|0;Q=i+4736|0;R=i+4680|0;T=i+4624|0;U=i+4568|0;V=i+4512|0;W=i+4456|0;X=i+4400|0;Z=i+4344|0;_=i+4288|0;$=i+5560|0;aa=i+4232|0;ba=i+5552|0;ca=i+5544|0;da=i+4176|0;ea=i+2368|0;fa=i+4120|0;ga=i+1696|0;ha=i+4064|0;ia=i+4008|0;ja=i+3992|0;ka=i+5536|0;la=i+5528|0;ma=i+3936|0;na=i+3880|0;oa=i+3824|0;pa=i+3768|0;qa=i+3712|0;ra=i+3656|0;sa=i+3600|0;ta=i+3544|0;ua=i+3488|0;va=i+5520|0;wa=i+5512|0;xa=i+5504|0;ya=i+5496|0;za=i+5488|0;Aa=i+5480|0;Ba=i+5472|0;Ca=i+5464|0;Da=i+96|0;Ea=i+64|0;Fa=i+32|0;Ga=i;do if((NS(a)|0)==65536){Ha=f[a+4>>2]|0;f[H>>2]=f[Ha>>2];Ia=H+4|0;Ja=Ha+4|0;f[Ia>>2]=f[Ja>>2];Ka=H+8|0;f[Ka>>2]=f[Ha+8>>2];f[H+12>>2]=f[Ha+12>>2];f[H+16>>2]=f[Ha+16>>2];f[H+20>>2]=f[Ha+20>>2];f[H+24>>2]=f[Ha+24>>2];f[H+28>>2]=f[Ha+28>>2];f[H+32>>2]=f[Ha+32>>2];La=f[Ha+36>>2]|0;f[H+36>>2]=La;f[H+40>>2]=Ka;Ka=H+48|0;Ma=H+44|0;f[Ma>>2]=Ka;f[Ka>>2]=0;f[H+52>>2]=0;if(La|0){Ka=La+12|0;f[Ka>>2]=(f[Ka>>2]|0)+1}if((f[Ja>>2]|0)<3){Ja=f[Ha+44>>2]|0;Ka=f[Ma>>2]|0;f[Ka>>2]=f[Ja>>2];f[Ka+4>>2]=f[Ja+4>>2];break}else{f[Ia>>2]=0;BR(H,Ha);break}}else OR(H,a,-1);while(0);do if((NS(c)|0)==65536){a=f[c+4>>2]|0;f[I>>2]=f[a>>2];Ha=I+4|0;Ia=a+4|0;f[Ha>>2]=f[Ia>>2];Ja=I+8|0;f[Ja>>2]=f[a+8>>2];f[I+12>>2]=f[a+12>>2];f[I+16>>2]=f[a+16>>2];f[I+20>>2]=f[a+20>>2];f[I+24>>2]=f[a+24>>2];f[I+28>>2]=f[a+28>>2];f[I+32>>2]=f[a+32>>2];Ka=f[a+36>>2]|0;f[I+36>>2]=Ka;f[I+40>>2]=Ja;Ja=I+48|0;Ma=I+44|0;f[Ma>>2]=Ja;f[Ja>>2]=0;f[I+52>>2]=0;if(Ka|0){Ja=Ka+12|0;f[Ja>>2]=(f[Ja>>2]|0)+1}if((f[Ia>>2]|0)<3){Ia=f[a+44>>2]|0;Ja=f[Ma>>2]|0;f[Ja>>2]=f[Ia>>2];f[Ja+4>>2]=f[Ia+4>>2];break}else{f[Ha>>2]=0;BR(I,a);break}}else OR(I,c,-1);while(0);do if((NS(d)|0)==65536){c=f[d+4>>2]|0;f[J>>2]=f[c>>2];a=J+4|0;Ha=c+4|0;f[a>>2]=f[Ha>>2];Ia=J+8|0;f[Ia>>2]=f[c+8>>2];f[J+12>>2]=f[c+12>>2];f[J+16>>2]=f[c+16>>2];f[J+20>>2]=f[c+20>>2];f[J+24>>2]=f[c+24>>2];f[J+28>>2]=f[c+28>>2];f[J+32>>2]=f[c+32>>2];Ja=f[c+36>>2]|0;f[J+36>>2]=Ja;f[J+40>>2]=Ia;Ia=J+48|0;Ma=J+44|0;f[Ma>>2]=Ia;f[Ia>>2]=0;f[J+52>>2]=0;if(Ja|0){Ia=Ja+12|0;f[Ia>>2]=(f[Ia>>2]|0)+1}if((f[Ha>>2]|0)<3){Ha=f[c+44>>2]|0;Ia=f[Ma>>2]|0;f[Ia>>2]=f[Ha>>2];f[Ia+4>>2]=f[Ha+4>>2];break}else{f[a>>2]=0;BR(J,c);break}}else OR(J,d,-1);while(0);c=H+16|0;if(f[c>>2]|0){a=f[H+4>>2]|0;if((a|0)<3)Na=Y(f[H+12>>2]|0,f[H+8>>2]|0)|0;else{Ha=f[H+40>>2]|0;Ia=0;Ma=1;while(1){Ja=Y(f[Ha+(Ia<<2)>>2]|0,Ma)|0;Ia=Ia+1|0;if((Ia|0)==(a|0)){Na=Ja;break}else Ma=Ja}}if((a|0)==0|(Na|0)==0)Oa=28}else Oa=28;if((Oa|0)==28){f[j>>2]=0;f[j+4>>2]=0;Pa=c$(j,12)|0;Qa=345902;Ra=Pa+12|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,345915,345932,325);d$(j)}Na=I+16|0;if(f[Na>>2]|0){a=f[I+4>>2]|0;if((a|0)<3)Sa=Y(f[I+12>>2]|0,f[I+8>>2]|0)|0;else{Ma=f[I+40>>2]|0;Ia=0;Ha=1;while(1){Ja=Y(f[Ma+(Ia<<2)>>2]|0,Ha)|0;Ia=Ia+1|0;if((Ia|0)==(a|0)){Sa=Ja;break}else Ha=Ja}}if((a|0)==0|(Sa|0)==0)Oa=35}else Oa=35;if((Oa|0)==35){f[j>>2]=0;f[j+4>>2]=0;Pa=c$(j,12)|0;Qa=345978;Ra=Pa+12|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,345915,345932,326);d$(j)}Sa=J+16|0;if(f[Sa>>2]|0){a=f[J+4>>2]|0;if((a|0)<3)Ta=Y(f[J+12>>2]|0,f[J+8>>2]|0)|0;else{Ha=f[J+40>>2]|0;Ia=0;Ma=1;while(1){Ja=Y(f[Ha+(Ia<<2)>>2]|0,Ma)|0;Ia=Ia+1|0;if((Ia|0)==(a|0)){Ta=Ja;break}else Ma=Ja}}if((a|0)==0|(Ta|0)==0)Oa=42}else Oa=42;if((Oa|0)==42){Ta=(e|0)==3?3:2;pS(d,Ta,3,5,-1,0,0);do if((NS(d)|0)==65536){a=f[d+4>>2]|0;f[j>>2]=f[a>>2];Ma=j+4|0;Ia=a+4|0;f[Ma>>2]=f[Ia>>2];Ha=j+8|0;f[Ha>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];Ja=j+36|0;Ka=f[a+36>>2]|0;f[Ja>>2]=Ka;f[j+40>>2]=Ha;Ha=j+48|0;La=j+44|0;f[La>>2]=Ha;f[Ha>>2]=0;f[j+52>>2]=0;if(Ka|0){Ha=Ka+12|0;f[Ha>>2]=(f[Ha>>2]|0)+1}if((f[Ia>>2]|0)<3){Ia=f[a+44>>2]|0;Ha=f[La>>2]|0;f[Ha>>2]=f[Ia>>2];f[Ha+4>>2]=f[Ia+4>>2];Ua=Ja;break}else{f[Ma>>2]=0;BR(j,a);Ua=Ja;break}}else{OR(j,d,-1);Ua=j+36|0}while(0);d=f[Ua>>2]|0;if(d|0){Ja=d+12|0;f[Ja>>2]=(f[Ja>>2]|0)+1}Ja=J+36|0;d=f[Ja>>2]|0;if(d|0?(a=d+12|0,d=f[a>>2]|0,f[a>>2]=d+-1,(d|0)==1):0)CR(J);f[Ja>>2]=0;d=J+4|0;f[Sa>>2]=0;f[Sa+4>>2]=0;f[Sa+8>>2]=0;f[Sa+12>>2]=0;if((f[d>>2]|0)>0){a=f[J+40>>2]|0;Ma=0;do{f[a+(Ma<<2)>>2]=0;Ma=Ma+1|0;Va=f[d>>2]|0}while((Ma|0)<(Va|0));f[J>>2]=f[j>>2];if((Va|0)<3)Oa=59;else Oa=61}else{f[J>>2]=f[j>>2];Oa=59}if((Oa|0)==59){Va=f[j+4>>2]|0;if((Va|0)<3){f[d>>2]=Va;f[J+8>>2]=f[j+8>>2];f[J+12>>2]=f[j+12>>2];Va=f[j+44>>2]|0;d=f[J+44>>2]|0;f[d>>2]=f[Va>>2];f[d+4>>2]=f[Va+4>>2]}else Oa=61}if((Oa|0)==61)BR(J,j);Va=j+16|0;f[Sa>>2]=f[Va>>2];f[J+20>>2]=f[j+20>>2];f[J+24>>2]=f[j+24>>2];f[J+28>>2]=f[j+28>>2];f[J+32>>2]=f[j+32>>2];d=f[Ua>>2]|0;f[Ja>>2]=d;if(d|0?(Ja=d+12|0,d=f[Ja>>2]|0,f[Ja>>2]=d+-1,(d|0)==1):0)CR(j);f[Ua>>2]=0;Ua=j+4|0;f[Va>>2]=0;f[Va+4>>2]=0;f[Va+8>>2]=0;f[Va+12>>2]=0;if((f[Ua>>2]|0)>0){Va=f[j+40>>2]|0;d=0;do{f[Va+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[Ua>>2]|0))}Ua=f[j+44>>2]|0;if((Ua|0)!=(j+48|0))ZF(Ua);aR(j,Ta,3,5);Ta=f[j>>2]|0;Ah[f[(f[Ta>>2]|0)+12>>2]&255](Ta,j,J,-1);fj(j)}Ta=f[H>>2]|0;if(!((f[I>>2]^Ta)&4095))Wa=Ta;else{f[j>>2]=0;f[j+4>>2]=0;Pa=c$(j,46)|0;Qa=349119;Ra=Pa+46|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-205,j,345915,345932,340);d$(j);Wa=f[H>>2]|0}switch(Wa&4095){case 5:case 0:break;default:{f[j>>2]=0;f[j+4>>2]=0;Pa=c$(j,35)|0;Qa=345991;Ra=Pa+35|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-210,j,345915,345932,344);d$(j)}}if((f[J>>2]&4095|0)!=5){f[j>>2]=0;f[j+4>>2]=0;Pa=c$(j,55)|0;Qa=346027;Ra=Pa+55|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-210,j,345915,345932,347);d$(j)}if((f[J+12>>2]|0)!=3){f[j>>2]=0;f[j+4>>2]=0;Pa=c$(j,13)|0;Qa=346083;Ra=Pa+13|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,345915,345932,349);d$(j)}Wa=J+8|0;if((f[Wa>>2]&-2|0)!=2){f[j>>2]=0;f[j+4>>2]=0;Pa=c$(j,29)|0;Qa=346097;Ra=Pa+29|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,345915,345932,350);d$(j)}switch(e|0){case 3:{if((f[Wa>>2]|0)!=3)Oa=84;break}case 2:case 1:case 0:break;default:{f[j>>2]=0;f[j+4>>2]=0;K1a(c$(j,132)|0,346127,132)|0;j$(-215,j,345915,345932,353);d$(j);if(!((e|0)!=3|(f[Wa>>2]|0)==3))Oa=84}}if((Oa|0)==84){f[j>>2]=0;f[j+4>>2]=0;Pa=c$(j,12)|0;Qa=346260;Ra=Pa+12|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,345915,345932,356);d$(j)}Oa=f[g>>2]|0;if(!(Oa&3)){f[j>>2]=0;f[j+4>>2]=0;Pa=c$(j,72)|0;Qa=346273;Ra=Pa+72|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,345915,345932,359);d$(j)}if(!(Oa&1))Xa=200;else Xa=f[g+4>>2]|0;if(!(Oa&2))Ya=-1.0;else Ya=+p[g+8>>3];switch(e|0){case 0:{Za=2;break}case 1:{Za=3;break}case 3:{Za=8;break}default:Za=6}g=f[H+12>>2]|0;Oa=f[H+8>>2]|0;Ta=f[I+12>>2]|0;Ua=f[I+8>>2]|0;f[K>>2]=1124007936;d=K+4|0;Va=K+8|0;Ja=K+40|0;Pa=d;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Ja>>2]=Va;Va=K+48|0;Ma=K+44|0;f[Ma>>2]=Va;f[Va>>2]=0;f[K+52>>2]=0;f[j>>2]=1;a=j+4|0;f[a>>2]=g;AR(K,2,j,5);f[N>>2]=1124007936;Ia=N+4|0;Ha=N+8|0;La=N+40|0;Pa=Ia;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[La>>2]=Ha;Ha=N+48|0;Ka=N+44|0;f[Ka>>2]=Ha;f[Ha>>2]=0;f[N+52>>2]=0;f[j>>2]=Oa;f[a>>2]=1;AR(N,2,j,5);f[Q>>2]=1124007936;_a=Q+4|0;$a=Q+8|0;ab=Q+40|0;Pa=_a;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[ab>>2]=$a;$a=Q+48|0;bb=Q+44|0;f[bb>>2]=$a;f[$a>>2]=0;f[Q+52>>2]=0;f[j>>2]=Oa;f[a>>2]=g;AR(Q,2,j,5);f[R>>2]=1124007936;cb=R+4|0;db=R+8|0;eb=R+40|0;Pa=cb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[eb>>2]=db;db=R+48|0;fb=R+44|0;f[fb>>2]=db;f[db>>2]=0;f[R+52>>2]=0;f[j>>2]=Oa;f[a>>2]=g;AR(R,2,j,5);gb=K+16|0;hb=f[gb>>2]|0;ib=N+16|0;jb=f[ib>>2]|0;if((g|0)>0){kb=0;do{n[hb+(kb<<2)>>2]=+(kb|0);kb=kb+1|0}while((kb|0)!=(g|0))}if((Oa|0)>0){kb=0;do{n[jb+(kb<<2)>>2]=+(kb|0);kb=kb+1|0}while((kb|0)!=(Oa|0))}f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=K;kb=k+8|0;f[kb>>2]=0;f[kb+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=Q;kL(j,Oa,1,k);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=N;kb=k+8|0;f[kb>>2]=0;f[kb+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=R;kL(j,1,g,k);kb=K+36|0;jb=f[kb>>2]|0;if(jb|0?(hb=jb+12|0,jb=f[hb>>2]|0,f[hb>>2]=jb+-1,(jb|0)==1):0)CR(K);f[kb>>2]=0;f[gb>>2]=0;f[gb+4>>2]=0;f[gb+8>>2]=0;f[gb+12>>2]=0;if((f[d>>2]|0)>0){jb=f[Ja>>2]|0;hb=0;do{f[jb+(hb<<2)>>2]=0;hb=hb+1|0}while((hb|0)<(f[d>>2]|0))}hb=N+36|0;jb=f[hb>>2]|0;if(jb|0?(lb=jb+12|0,jb=f[lb>>2]|0,f[lb>>2]=jb+-1,(jb|0)==1):0)CR(N);f[hb>>2]=0;f[ib>>2]=0;f[ib+4>>2]=0;f[ib+8>>2]=0;f[ib+12>>2]=0;if((f[Ia>>2]|0)>0){jb=f[La>>2]|0;lb=0;do{f[jb+(lb<<2)>>2]=0;lb=lb+1|0}while((lb|0)<(f[Ia>>2]|0))}f[T>>2]=1124007936;lb=T+4|0;jb=T+8|0;mb=T+40|0;Pa=lb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[mb>>2]=jb;nb=T+48|0;ob=T+44|0;f[ob>>2]=nb;f[nb>>2]=0;f[T+52>>2]=0;f[j>>2]=Oa;f[a>>2]=g;AR(T,2,j,5);f[U>>2]=1124007936;pb=U+4|0;qb=U+8|0;rb=U+40|0;Pa=pb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[rb>>2]=qb;qb=U+48|0;sb=U+44|0;f[sb>>2]=qb;f[qb>>2]=0;f[U+52>>2]=0;f[j>>2]=Oa;f[a>>2]=g;AR(U,2,j,5);f[V>>2]=1124007936;tb=V+4|0;ub=V+8|0;vb=V+40|0;Pa=tb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[vb>>2]=ub;ub=V+48|0;wb=V+44|0;f[wb>>2]=ub;f[ub>>2]=0;f[V+52>>2]=0;f[j>>2]=Ua;f[a>>2]=Ta;AR(V,2,j,5);f[W>>2]=1124007936;xb=W+4|0;yb=W+8|0;zb=W+40|0;Pa=xb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[zb>>2]=yb;yb=W+48|0;Ab=W+44|0;f[Ab>>2]=yb;f[yb>>2]=0;f[W+52>>2]=0;f[j>>2]=Oa;f[a>>2]=g;AR(W,2,j,5);f[X>>2]=1124007936;Bb=X+4|0;Cb=X+8|0;Db=X+40|0;Pa=Bb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Db>>2]=Cb;Cb=X+48|0;Eb=X+44|0;f[Eb>>2]=Cb;f[Cb>>2]=0;f[X+52>>2]=0;f[j>>2]=Oa;f[a>>2]=g;AR(X,2,j,0);do if((NS(h)|0)==65536){Fb=f[h+4>>2]|0;f[Z>>2]=f[Fb>>2];Gb=Z+4|0;Hb=Fb+4|0;f[Gb>>2]=f[Hb>>2];Ib=Z+8|0;f[Ib>>2]=f[Fb+8>>2];f[Z+12>>2]=f[Fb+12>>2];f[Z+16>>2]=f[Fb+16>>2];f[Z+20>>2]=f[Fb+20>>2];f[Z+24>>2]=f[Fb+24>>2];f[Z+28>>2]=f[Fb+28>>2];f[Z+32>>2]=f[Fb+32>>2];Jb=f[Fb+36>>2]|0;f[Z+36>>2]=Jb;f[Z+40>>2]=Ib;Ib=Z+48|0;Kb=Z+44|0;f[Kb>>2]=Ib;f[Ib>>2]=0;f[Z+52>>2]=0;if(Jb|0){Ib=Jb+12|0;f[Ib>>2]=(f[Ib>>2]|0)+1}if((f[Hb>>2]|0)<3){Hb=f[Fb+44>>2]|0;Ib=f[Kb>>2]|0;f[Ib>>2]=f[Hb>>2];f[Ib+4>>2]=f[Hb+4>>2];break}else{f[Gb>>2]=0;BR(Z,Fb);break}}else OR(Z,h,-1);while(0);f[_>>2]=1124007936;Fb=_+4|0;Gb=_+8|0;Hb=_+40|0;Pa=Fb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Hb>>2]=Gb;Gb=_+48|0;Ib=_+44|0;f[Ib>>2]=Gb;f[Gb>>2]=0;f[_+52>>2]=0;if(XS(h)|0){_Q(j,Ua,Ta,0);Kb=f[j>>2]|0;Ah[f[(f[Kb>>2]|0)+12>>2]&255](Kb,j,_,-1);fj(j)}else{Kb=j+8|0;f[Kb>>2]=0;f[Kb+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=_;+gqa(h,j,0.0,1.0,0)}h=j+8|0;f[h>>2]=0;f[h+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=U;WJ(H,j,f[U>>2]&4095,1.0,0.0);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=U;h=k+8|0;f[h>>2]=0;f[h+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=U;f[$>>2]=5;f[$+4>>2]=5;Hpa(j,k,$,0.0,0.0,4);f[aa>>2]=1124007936;$=aa+4|0;h=aa+8|0;Kb=aa+40|0;Pa=$;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Kb>>2]=h;h=aa+48|0;Jb=aa+44|0;f[Jb>>2]=h;f[h>>2]=0;f[aa+52>>2]=0;Lb=j+8|0;f[Lb>>2]=0;f[Lb+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=aa;WJ(_,j,5,1.0,0.0);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=aa;Lb=k+8|0;f[Lb>>2]=0;f[Lb+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=aa;f[ba>>2]=5;f[ba+4>>2]=5;Hpa(j,k,ba,0.0,0.0,4);ba=j+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=aa;WJ(aa,j,-1,.5263157894736842,0.0);ba=j+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=_;WJ(aa,j,f[_>>2]&4095,1.0,0.0);ba=j+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=aa;WJ(_,j,f[aa>>2]&4095,1.0,0.0);ba=j+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=V;WJ(I,j,f[V>>2]&4095,1.0,0.0);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=V;ba=k+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=V;f[ca>>2]=5;f[ca+4>>2]=5;Hpa(j,k,ca,0.0,0.0,4);XQ(ea,Ua,Ta,5);f[da>>2]=1124007936;ca=da+4|0;ba=da+8|0;Lb=da+40|0;Pa=ca;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Lb>>2]=ba;ba=da+48|0;Mb=da+44|0;f[Mb>>2]=ba;f[ba>>2]=0;f[da+52>>2]=0;Nb=f[ea>>2]|0;Ah[f[(f[Nb>>2]|0)+12>>2]&255](Nb,ea,da,-1);fj(ea);XQ(ga,Ua,Ta,5);f[fa>>2]=1124007936;Ta=fa+4|0;Ua=fa+8|0;ea=fa+40|0;Pa=Ta;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[ea>>2]=Ua;Ua=fa+48|0;Nb=fa+44|0;f[Nb>>2]=Ua;f[Ua>>2]=0;f[fa+52>>2]=0;Ob=f[ga>>2]|0;Ah[f[(f[Ob>>2]|0)+12>>2]&255](Ob,ga,fa,-1);fj(ga);f[ha>>2]=1124007936;ga=ha+4|0;Ob=ha+8|0;Pb=ha+40|0;Pa=ga;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Pb>>2]=Ob;Qb=ha+48|0;Rb=ha+44|0;f[Rb>>2]=Qb;f[Qb>>2]=0;f[ha+52>>2]=0;f[j>>2]=Oa;f[a>>2]=g;AR(ha,2,j,5);f[ia>>2]=1124007936;Sb=ia+4|0;Tb=ia+8|0;Ub=ia+40|0;Pa=Sb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Ub>>2]=Tb;Tb=ia+48|0;Vb=ia+44|0;f[Vb>>2]=Tb;f[Tb>>2]=0;f[ia+52>>2]=0;f[j>>2]=Oa;f[a>>2]=g;AR(ia,2,j,5);n[ja>>2]=-.5;Wb=ja+4|0;n[Wb>>2]=0.0;Xb=ja+8|0;n[Xb>>2]=.5;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=V;Yb=k+8|0;f[Yb>>2]=0;f[Yb+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=da;f[l>>2]=-1056833531;f[l+4>>2]=ja;f[l+8>>2]=3;f[l+12>>2]=1;f[ka>>2]=-1;f[ka+4>>2]=-1;hfa(j,k,-1,l,ka,0.0,4);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=V;ka=k+8|0;f[ka>>2]=0;f[ka+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=fa;f[m>>2]=f[ja>>2];f[m+4>>2]=f[Wb>>2];f[m+8>>2]=f[Xb>>2];f[l>>2]=-1056833531;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=3;f[la>>2]=-1;f[la+4>>2]=-1;hfa(j,k,-1,l,la,0.0,4);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=aa;WQ(j,da,k,1.0);la=f[j>>2]|0;Ah[f[(f[la>>2]|0)+12>>2]&255](la,j,da,-1);fj(j);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=aa;WQ(j,fa,k,1.0);la=f[j>>2]|0;Ah[f[(f[la>>2]|0)+12>>2]&255](la,j,fa,-1);fj(j);la=Y(g,Za)|0;f[ma>>2]=1124007936;Xb=ma+4|0;Wb=ma+8|0;ja=ma+40|0;Pa=Xb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[ja>>2]=Wb;ka=ma+48|0;Yb=ma+44|0;f[Yb>>2]=ka;f[ka>>2]=0;f[ma+52>>2]=0;f[j>>2]=Oa;f[a>>2]=la;AR(ma,2,j,5);f[na>>2]=1124007936;la=na+4|0;Zb=na+8|0;_b=na+40|0;Pa=la;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[_b>>2]=Zb;Zb=na+48|0;$b=na+44|0;f[$b>>2]=Zb;f[Zb>>2]=0;f[na+52>>2]=0;f[j>>2]=Za;f[a>>2]=Za;AR(na,2,j,5);f[oa>>2]=1124007936;ac=oa+4|0;bc=oa+8|0;cc=oa+40|0;Pa=ac;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[cc>>2]=bc;bc=oa+48|0;dc=oa+44|0;f[dc>>2]=bc;f[bc>>2]=0;f[oa+52>>2]=0;f[j>>2]=Za;f[a>>2]=Za;AR(oa,2,j,5);f[pa>>2]=1124007936;ec=pa+4|0;fc=pa+8|0;gc=pa+40|0;Pa=ec;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[gc>>2]=fc;fc=pa+48|0;hc=pa+44|0;f[hc>>2]=fc;f[fc>>2]=0;f[pa+52>>2]=0;f[j>>2]=Za;f[a>>2]=1;AR(pa,2,j,5);f[qa>>2]=1124007936;ic=qa+4|0;jc=qa+8|0;kc=qa+40|0;Pa=ic;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[kc>>2]=jc;jc=qa+48|0;lc=qa+44|0;f[lc>>2]=jc;f[jc>>2]=0;f[qa+52>>2]=0;f[j>>2]=Za;f[a>>2]=1;AR(qa,2,j,5);f[ra>>2]=1124007936;mc=ra+4|0;nc=ra+8|0;oc=ra+40|0;Pa=mc;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[oc>>2]=nc;nc=ra+48|0;pc=ra+44|0;f[pc>>2]=nc;f[nc>>2]=0;f[ra+52>>2]=0;f[j>>2]=Za;f[a>>2]=1;AR(ra,2,j,5);f[sa>>2]=1124007936;qc=sa+4|0;rc=sa+8|0;sc=sa+40|0;Pa=qc;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[sc>>2]=rc;rc=sa+48|0;tc=sa+44|0;f[tc>>2]=rc;f[rc>>2]=0;f[sa+52>>2]=0;f[j>>2]=Za;f[a>>2]=1;AR(sa,2,j,5);f[ta>>2]=1124007936;uc=ta+4|0;vc=ta+8|0;wc=ta+40|0;Pa=uc;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[wc>>2]=vc;xc=ta+48|0;yc=ta+44|0;f[yc>>2]=xc;f[xc>>2]=0;f[ta+52>>2]=0;f[j>>2]=Za;f[a>>2]=1;AR(ta,2,j,5);f[ua>>2]=1124007936;Za=ua+4|0;zc=ua+8|0;Ac=ua+40|0;Pa=Za;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Ac>>2]=zc;zc=ua+48|0;Bc=ua+44|0;f[Bc>>2]=zc;f[zc>>2]=0;f[ua+52>>2]=0;f[j>>2]=Oa;f[a>>2]=g;AR(ua,2,j,5);a:do if((Xa|0)<1)Cc=-1.0;else{g=(e|0)==3;a=j+8|0;Oa=j+12|0;Dc=j+4|0;Ec=k+8|0;Fc=k+4|0;Gc=l+8|0;Hc=l+12|0;Ic=l+4|0;Jc=za+4|0;Kc=j+8|0;Lc=j+12|0;Mc=j+4|0;Nc=k+8|0;Oc=k+4|0;Pc=l+8|0;Qc=l+12|0;Rc=l+4|0;Sc=Aa+4|0;Tc=j+8|0;Uc=j+12|0;Vc=j+4|0;Wc=k+8|0;Xc=k+4|0;Yc=l+8|0;Zc=l+12|0;_c=l+4|0;$c=Ba+4|0;ad=j+8|0;bd=j+12|0;cd=j+4|0;dd=k+8|0;ed=k+4|0;fd=l+8|0;gd=l+12|0;hd=l+4|0;id=Ca+4|0;jd=j+8|0;kd=j+12|0;ld=j+4|0;md=k+4|0;nd=k+8|0;od=k+12|0;pd=l+4|0;qd=l+8|0;rd=l+12|0;sd=m+8|0;td=m+12|0;ud=m+4|0;vd=j+8|0;wd=j+12|0;xd=j+4|0;yd=k+4|0;zd=k+8|0;Ad=k+12|0;Bd=l+4|0;Cd=l+8|0;Dd=l+12|0;Ed=m+8|0;Fd=m+12|0;Gd=m+4|0;Hd=j+8|0;Id=j+12|0;Jd=j+4|0;Kd=k+8|0;Ld=k+12|0;Md=k+4|0;Nd=l+8|0;Od=l+4|0;Pd=m+8|0;Qd=m+12|0;Rd=m+4|0;Sd=T+12|0;Td=j+8|0;Ud=j+12|0;Vd=j+4|0;Wd=k+8|0;Xd=k+12|0;Yd=k+4|0;Zd=l+8|0;_d=l+4|0;$d=m+8|0;ae=m+12|0;be=m+4|0;ce=j+8|0;de=j+12|0;ee=j+4|0;fe=j+8|0;ge=j+12|0;he=j+4|0;ie=j+8|0;je=j+12|0;ke=j+4|0;le=j+4|0;me=j+8|0;ne=j+12|0;oe=j+4|0;pe=j+8|0;qe=j+12|0;re=j+4|0;se=(e|0)==0;te=(e|0)==1;ue=(e|0)==2;ve=e>>>0<4;we=j+4|0;xe=ta+12|0;ye=j+4|0;ze=j+4|0;Ae=ta+16|0;Be=j+4|0;Ce=j+4|0;De=j+4|0;Ee=j+4|0;Fe=j+4|0;Ge=j+4|0;He=j+4|0;Ie=j+4|0;Je=ma+12|0;Ke=ha+12|0;Le=m+8|0;Me=m+12|0;Ne=m+4|0;Oe=j+4|0;Pe=k+4|0;Qe=o+36|0;Re=o+16|0;Se=o+4|0;Te=o+40|0;Ue=o+44|0;Ve=o+48|0;We=m+8|0;Xe=m+12|0;Ye=m+4|0;Ze=j+4|0;_e=k+4|0;$e=q+36|0;af=q+16|0;bf=q+4|0;cf=q+40|0;df=q+44|0;ef=q+48|0;ff=m+8|0;gf=m+12|0;hf=m+4|0;jf=j+4|0;kf=k+4|0;lf=r+36|0;mf=r+16|0;nf=r+4|0;of=r+40|0;pf=r+44|0;qf=r+48|0;rf=m+8|0;sf=m+12|0;tf=m+4|0;uf=j+4|0;vf=k+4|0;wf=t+36|0;xf=t+16|0;yf=t+4|0;zf=t+40|0;Af=t+44|0;Bf=t+48|0;Cf=j+4|0;Df=k+4|0;Ef=l+8|0;Ff=l+4|0;Gf=m+36|0;Hf=m+16|0;If=m+4|0;Jf=m+40|0;Kf=m+44|0;Lf=m+48|0;Mf=j+4|0;Nf=k+4|0;Of=l+8|0;Pf=l+4|0;Qf=m+36|0;Rf=m+16|0;Sf=m+4|0;Tf=m+40|0;Uf=m+44|0;Vf=m+48|0;Wf=j+4|0;Xf=j+4|0;Yf=j+4|0;Zf=j+4|0;_f=j+4|0;$f=j+4|0;ag=j+4|0;bg=q+8|0;cg=l+4|0;dg=l+8|0;eg=l+40|0;fg=l+48|0;gg=l+44|0;hg=l+52|0;ig=v+8|0;jg=o+4|0;kg=o+8|0;lg=o+40|0;mg=o+48|0;ng=o+44|0;og=o+52|0;pg=j+8|0;qg=j+12|0;rg=j+4|0;sg=k+8|0;tg=k+12|0;ug=k+4|0;vg=q+8|0;wg=q+4|0;xg=x+8|0;yg=q+4|0;zg=q+8|0;Ag=q+40|0;Bg=q+48|0;Cg=q+44|0;Dg=q+52|0;Eg=j+8|0;Fg=j+12|0;Gg=j+4|0;Hg=k+8|0;Ig=k+12|0;Jg=k+4|0;Kg=t+8|0;Lg=t+4|0;Mg=t+4|0;Ng=t+8|0;Og=t+40|0;Pg=t+48|0;Qg=t+44|0;Rg=t+52|0;Sg=v+4|0;Tg=v+8|0;Ug=v+40|0;Vg=v+48|0;Wg=v+44|0;Xg=v+52|0;Yg=j+8|0;Zg=j+12|0;_g=j+4|0;$g=k+8|0;ah=k+12|0;bh=k+4|0;ch=x+8|0;dh=x+4|0;eh=j+8|0;fh=j+12|0;gh=j+4|0;hh=k+8|0;ih=k+12|0;jh=k+4|0;kh=x+8|0;lh=x+4|0;mh=y+8|0;nh=y+12|0;oh=y+4|0;ph=j+4|0;qh=k+4|0;rh=z+36|0;sh=z+16|0;th=z+4|0;uh=z+40|0;vh=z+44|0;wh=z+48|0;xh=y+8|0;yh=y+12|0;zh=y+4|0;Bh=j+4|0;Ch=k+4|0;Dh=A+36|0;Eh=A+16|0;Fh=A+4|0;Gh=A+40|0;Hh=A+44|0;Ih=A+48|0;Jh=k+8|0;Kh=k+12|0;Lh=k+4|0;Mh=C+8|0;Nh=C+12|0;Oh=C+4|0;Ph=x+4|0;Qh=x+8|0;Rh=x+40|0;Sh=x+48|0;Th=x+44|0;Uh=x+52|0;Vh=C+8|0;Wh=C+12|0;Xh=C+4|0;Yh=j+4|0;Zh=k+4|0;_h=D+36|0;$h=D+16|0;ai=D+4|0;bi=D+40|0;ci=D+44|0;di=D+48|0;ei=o+36|0;fi=o+16|0;gi=q+36|0;hi=q+16|0;ii=C+8|0;ji=C+12|0;ki=C+4|0;li=j+4|0;mi=k+4|0;ni=E+36|0;oi=E+16|0;pi=E+4|0;qi=E+40|0;ri=E+44|0;si=E+48|0;ti=C+8|0;ui=C+12|0;vi=C+4|0;wi=j+4|0;xi=k+4|0;yi=F+36|0;zi=F+16|0;Ai=F+4|0;Bi=F+40|0;Ci=F+44|0;Di=F+48|0;Ei=C+8|0;Fi=C+12|0;Gi=C+4|0;Hi=j+4|0;Ii=k+4|0;Ji=G+36|0;Ki=G+16|0;Li=G+4|0;Mi=G+40|0;Ni=G+44|0;Oi=G+48|0;Pi=j+4|0;Qi=k+4|0;Ri=y+8|0;Si=y+4|0;Ti=C+36|0;Ui=C+16|0;Vi=C+4|0;Wi=C+40|0;Xi=C+44|0;Yi=C+48|0;Zi=j+4|0;_i=k+4|0;$i=y+8|0;aj=y+4|0;bj=C+36|0;cj=C+16|0;dj=C+4|0;ej=C+40|0;gj=C+44|0;hj=C+48|0;ij=x+36|0;jj=x+16|0;kj=v+36|0;lj=v+16|0;mj=t+36|0;nj=t+16|0;oj=l+36|0;pj=l+16|0;qj=j+4|0;rj=j+4|0;sj=j+4|0;tj=j+4|0;uj=j+4|0;vj=j+4|0;wj=j+4|0;xj=k+4|0;yj=l+8|0;zj=l+4|0;Aj=m+36|0;Bj=m+16|0;Cj=m+4|0;Dj=m+40|0;Ej=m+44|0;Fj=m+48|0;Gj=j+4|0;Hj=k+4|0;Ij=l+8|0;Jj=l+4|0;Kj=m+36|0;Lj=m+16|0;Mj=m+4|0;Nj=m+40|0;Oj=m+44|0;Pj=m+48|0;Qj=j+4|0;Rj=j+4|0;Sj=j+4|0;Tj=j+4|0;Uj=j+4|0;Vj=l+4|0;Wj=l+8|0;Xj=l+40|0;Yj=l+48|0;Zj=l+44|0;_j=l+52|0;$j=o+4|0;ak=o+8|0;bk=o+40|0;ck=o+48|0;dk=o+44|0;ek=o+52|0;fk=v+8|0;gk=v+12|0;hk=v+4|0;ik=x+8|0;jk=x+12|0;kk=x+4|0;lk=j+4|0;mk=k+4|0;nk=y+36|0;ok=y+16|0;pk=y+4|0;qk=y+40|0;rk=y+44|0;sk=y+48|0;tk=j+4|0;uk=k+4|0;vk=r+8|0;wk=r+4|0;xk=t+36|0;yk=t+16|0;zk=t+4|0;Ak=t+40|0;Bk=t+44|0;Ck=t+48|0;Dk=j+4|0;Ek=k+4|0;Fk=r+8|0;Gk=r+4|0;Hk=t+36|0;Ik=t+16|0;Jk=t+4|0;Kk=t+40|0;Lk=t+44|0;Mk=t+48|0;Nk=o+36|0;Ok=o+16|0;Pk=l+36|0;Qk=l+16|0;Rk=j+4|0;Sk=j+4|0;Tk=j+4|0;Uk=j+4|0;Vk=j+4|0;Wk=j+4|0;Xk=j+8|0;Yk=j+12|0;Zk=j+4|0;_k=k+8|0;$k=k+4|0;al=l+8|0;bl=l+12|0;cl=l+4|0;dl=va+4|0;el=j+8|0;fl=j+12|0;gl=j+4|0;hl=k+8|0;il=k+4|0;jl=l+8|0;kl=l+12|0;ll=l+4|0;ml=wa+4|0;nl=j+8|0;ol=j+12|0;pl=j+4|0;ql=k+8|0;rl=k+4|0;sl=l+8|0;tl=l+12|0;ul=l+4|0;vl=xa+4|0;wl=j+8|0;xl=j+12|0;yl=j+4|0;zl=k+8|0;Al=k+4|0;Bl=l+8|0;Cl=l+12|0;Dl=l+4|0;El=ya+4|0;Fl=1;Gl=-Ya;Hl=-1.0;while(1){if(!(+L(+(Hl-Gl))>=Ya)){Cc=Hl;break a}if(g){f[a>>2]=0;f[Oa>>2]=0;f[j>>2]=16842752;f[Dc>>2]=V;Il=Ec;f[Il>>2]=0;f[Il+4>>2]=0;f[k>>2]=33619968;f[Fc>>2]=W;f[Gc>>2]=0;f[Hc>>2]=0;f[l>>2]=16842752;f[Ic>>2]=J;Il=f[zb>>2]|0;Jl=f[Il>>2]|0;f[za>>2]=f[Il+4>>2];f[Jc>>2]=Jl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;Wga(j,k,l,za,17,0,m);f[Kc>>2]=0;f[Lc>>2]=0;f[j>>2]=16842752;f[Mc>>2]=da;Jl=Nc;f[Jl>>2]=0;f[Jl+4>>2]=0;f[k>>2]=33619968;f[Oc>>2]=ha;f[Pc>>2]=0;f[Qc>>2]=0;f[l>>2]=16842752;f[Rc>>2]=J;Jl=f[Pb>>2]|0;Il=f[Jl>>2]|0;f[Aa>>2]=f[Jl+4>>2];f[Sc>>2]=Il;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;Wga(j,k,l,Aa,17,0,m);f[Tc>>2]=0;f[Uc>>2]=0;f[j>>2]=16842752;f[Vc>>2]=fa;Il=Wc;f[Il>>2]=0;f[Il+4>>2]=0;f[k>>2]=33619968;f[Xc>>2]=ia;f[Yc>>2]=0;f[Zc>>2]=0;f[l>>2]=16842752;f[_c>>2]=J;Il=f[Ub>>2]|0;Jl=f[Il>>2]|0;f[Ba>>2]=f[Il+4>>2];f[$c>>2]=Jl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;Wga(j,k,l,Ba,17,0,m);f[ad>>2]=0;f[bd>>2]=0;f[j>>2]=16842752;f[cd>>2]=_;Jl=dd;f[Jl>>2]=0;f[Jl+4>>2]=0;f[k>>2]=33619968;f[ed>>2]=X;f[fd>>2]=0;f[gd>>2]=0;f[l>>2]=16842752;f[hd>>2]=J;Jl=f[Db>>2]|0;Il=f[Jl>>2]|0;f[Ca>>2]=f[Jl+4>>2];f[id>>2]=Il;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;Wga(j,k,l,Ca,16,0,m)}else{f[Xk>>2]=0;f[Yk>>2]=0;f[j>>2]=16842752;f[Zk>>2]=V;Il=_k;f[Il>>2]=0;f[Il+4>>2]=0;f[k>>2]=33619968;f[$k>>2]=W;f[al>>2]=0;f[bl>>2]=0;f[l>>2]=16842752;f[cl>>2]=J;Il=f[zb>>2]|0;Jl=f[Il>>2]|0;f[va>>2]=f[Il+4>>2];f[dl>>2]=Jl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;Qga(j,k,l,va,17,0,m);f[el>>2]=0;f[fl>>2]=0;f[j>>2]=16842752;f[gl>>2]=da;Jl=hl;f[Jl>>2]=0;f[Jl+4>>2]=0;f[k>>2]=33619968;f[il>>2]=ha;f[jl>>2]=0;f[kl>>2]=0;f[l>>2]=16842752;f[ll>>2]=J;Jl=f[Pb>>2]|0;Il=f[Jl>>2]|0;f[wa>>2]=f[Jl+4>>2];f[ml>>2]=Il;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;Qga(j,k,l,wa,17,0,m);f[nl>>2]=0;f[ol>>2]=0;f[j>>2]=16842752;f[pl>>2]=fa;Il=ql;f[Il>>2]=0;f[Il+4>>2]=0;f[k>>2]=33619968;f[rl>>2]=ia;f[sl>>2]=0;f[tl>>2]=0;f[l>>2]=16842752;f[ul>>2]=J;Il=f[Ub>>2]|0;Jl=f[Il>>2]|0;f[xa>>2]=f[Il+4>>2];f[vl>>2]=Jl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;Qga(j,k,l,xa,17,0,m);f[wl>>2]=0;f[xl>>2]=0;f[j>>2]=16842752;f[yl>>2]=_;Jl=zl;f[Jl>>2]=0;f[Jl+4>>2]=0;f[k>>2]=33619968;f[Al>>2]=X;f[Bl>>2]=0;f[Cl>>2]=0;f[l>>2]=16842752;f[Dl>>2]=J;Jl=f[Db>>2]|0;Il=f[Jl>>2]|0;f[ya>>2]=f[Jl+4>>2];f[El>>2]=Il;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;Qga(j,k,l,ya,16,0,m)};f[Da>>2]=0;f[Da+4>>2]=0;f[Da+8>>2]=0;f[Da+12>>2]=0;f[Da+16>>2]=0;f[Da+20>>2]=0;f[Da+24>>2]=0;f[Da+28>>2]=0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[Ea+8>>2]=0;f[Ea+12>>2]=0;f[Ea+16>>2]=0;f[Ea+20>>2]=0;f[Ea+24>>2]=0;f[Ea+28>>2]=0;f[Fa>>2]=0;f[Fa+4>>2]=0;f[Fa+8>>2]=0;f[Fa+12>>2]=0;f[Fa+16>>2]=0;f[Fa+20>>2]=0;f[Fa+24>>2]=0;f[Fa+28>>2]=0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[Ga+8>>2]=0;f[Ga+12>>2]=0;f[Ga+16>>2]=0;f[Ga+20>>2]=0;f[Ga+24>>2]=0;f[Ga+28>>2]=0;f[jd>>2]=0;f[kd>>2]=0;f[j>>2]=16842752;f[ld>>2]=W;f[k>>2]=-1040056314;f[md>>2]=Da;f[nd>>2]=1;f[od>>2]=4;f[l>>2]=-1040056314;f[pd>>2]=Ea;f[qd>>2]=1;f[rd>>2]=4;f[sd>>2]=0;f[td>>2]=0;f[m>>2]=16842752;f[ud>>2]=X;iZ(j,k,l,m);f[vd>>2]=0;f[wd>>2]=0;f[j>>2]=16842752;f[xd>>2]=U;f[k>>2]=-1040056314;f[yd>>2]=Fa;f[zd>>2]=1;f[Ad>>2]=4;f[l>>2]=-1040056314;f[Bd>>2]=Ga;f[Cd>>2]=1;f[Dd>>2]=4;f[Ed>>2]=0;f[Fd>>2]=0;f[m>>2]=16842752;f[Gd>>2]=X;iZ(j,k,l,m);f[Hd>>2]=0;f[Id>>2]=0;f[j>>2]=16842752;f[Jd>>2]=W;f[k>>2]=-1056833530;f[Md>>2]=Da;f[Kd>>2]=1;f[Ld>>2]=4;Il=Nd;f[Il>>2]=0;f[Il+4>>2]=0;f[l>>2]=33619968;f[Od>>2]=W;f[Pd>>2]=0;f[Qd>>2]=0;f[m>>2]=16842752;f[Rd>>2]=X;hH(j,k,l,m,-1);XQ(j,f[jb>>2]|0,f[Sd>>2]|0,f[T>>2]&4095);Il=f[j>>2]|0;Ah[f[(f[Il>>2]|0)+12>>2]&255](Il,j,T,-1);fj(j);f[Td>>2]=0;f[Ud>>2]=0;f[j>>2]=16842752;f[Vd>>2]=U;f[k>>2]=-1056833530;f[Yd>>2]=Fa;f[Wd>>2]=1;f[Xd>>2]=4;Il=Zd;f[Il>>2]=0;f[Il+4>>2]=0;f[l>>2]=33619968;f[_d>>2]=T;f[$d>>2]=0;f[ae>>2]=0;f[m>>2]=16842752;f[be>>2]=X;hH(j,k,l,m,-1);f[ce>>2]=0;f[de>>2]=0;f[j>>2]=16842752;f[ee>>2]=X;Kl=+(bZ(j)|0);Ll=+p[Ga>>3];Ml=+M(+(Ll*(Kl*Ll)));f[fe>>2]=0;f[ge>>2]=0;f[j>>2]=16842752;f[he>>2]=X;Ll=+(bZ(j)|0);Kl=+p[Ea>>3];Nl=+M(+(Kl*(Ll*Kl)));switch(e|0){case 2:{Il=f[Pb>>2]|0;Jl=f[Il+4>>2]|0;Ol=f[Il>>2]|0;Il=f[Ub>>2]|0;if((Ol|0)==(f[Il>>2]|0)?(Jl|0)==(f[Il+4>>2]|0):0){Pl=Jl;Ql=Ol}else{f[j>>2]=0;f[$f>>2]=0;Pa=c$(j,26)|0;Qa=346346;Ra=Pa+26|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346373,345932,167);d$(j);Ol=f[Pb>>2]|0;Pl=f[Ol+4>>2]|0;Ql=f[Ol>>2]|0}Ol=f[ab>>2]|0;if((Ql|0)==(f[Ol>>2]|0)?(Pl|0)==(f[Ol+4>>2]|0):0){Rl=Pl;Sl=Ql}else{f[j>>2]=0;f[_f>>2]=0;Pa=c$(j,26)|0;Qa=346399;Ra=Pa+26|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346373,345932,168);d$(j);Ol=f[Pb>>2]|0;Rl=f[Ol+4>>2]|0;Sl=f[Ol>>2]|0}Ol=f[eb>>2]|0;if(!((Sl|0)==(f[Ol>>2]|0)?(Rl|0)==(f[Ol+4>>2]|0):0)){f[j>>2]=0;f[Zf>>2]=0;Pa=c$(j,26)|0;Qa=346426;Ra=Pa+26|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346373,345932,169);d$(j)}if((f[Ob>>2]|0)!=(f[Wb>>2]|0)){f[j>>2]=0;f[Yf>>2]=0;Pa=c$(j,21)|0;Qa=346453;Ra=Pa+21|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346373,345932,171);d$(j)}if((f[Je>>2]|0)!=((f[Ke>>2]|0)*6|0)){f[j>>2]=0;f[Xf>>2]=0;Pa=c$(j,25)|0;Qa=346475;Ra=Pa+25|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346373,345932,172);d$(j)}if((f[ma>>2]&4095|0)!=5){f[j>>2]=0;f[Wf>>2]=0;Pa=c$(j,55)|0;Qa=346501;Ra=Pa+55|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346373,345932,174);d$(j)}Ol=f[Ke>>2]|0;f[Le>>2]=0;f[Me>>2]=0;f[m>>2]=16842752;f[Ne>>2]=Q;WQ(l,ha,m,1.0);f[j>>2]=-2147483648;f[Oe>>2]=2147483647;f[k>>2]=0;f[Pe>>2]=Ol;DR(o,ma,j,k);Jl=f[l>>2]|0;Ah[f[(f[Jl>>2]|0)+12>>2]&255](Jl,l,o,-1);Jl=f[Qe>>2]|0;do if(Jl|0){Il=Jl+12|0;Tl=f[Il>>2]|0;f[Il>>2]=Tl+-1;if((Tl|0)!=1)break;CR(o)}while(0);f[Qe>>2]=0;f[Re>>2]=0;f[Re+4>>2]=0;f[Re+8>>2]=0;f[Re+12>>2]=0;if((f[Se>>2]|0)>0){Jl=f[Te>>2]|0;Tl=0;do{f[Jl+(Tl<<2)>>2]=0;Tl=Tl+1|0}while((Tl|0)<(f[Se>>2]|0))}Tl=f[Ue>>2]|0;if((Tl|0)!=(Ve|0))ZF(Tl);fj(l);f[We>>2]=0;f[Xe>>2]=0;f[m>>2]=16842752;f[Ye>>2]=Q;WQ(l,ia,m,1.0);Tl=Ol<<1;f[j>>2]=-2147483648;f[Ze>>2]=2147483647;f[k>>2]=Ol;f[_e>>2]=Tl;DR(q,ma,j,k);Jl=f[l>>2]|0;Ah[f[(f[Jl>>2]|0)+12>>2]&255](Jl,l,q,-1);Jl=f[$e>>2]|0;do if(Jl|0){Il=Jl+12|0;Ul=f[Il>>2]|0;f[Il>>2]=Ul+-1;if((Ul|0)!=1)break;CR(q)}while(0);f[$e>>2]=0;f[af>>2]=0;f[af+4>>2]=0;f[af+8>>2]=0;f[af+12>>2]=0;if((f[bf>>2]|0)>0){Jl=f[cf>>2]|0;Ul=0;do{f[Jl+(Ul<<2)>>2]=0;Ul=Ul+1|0}while((Ul|0)<(f[bf>>2]|0))}Ul=f[df>>2]|0;if((Ul|0)!=(ef|0))ZF(Ul);fj(l);f[ff>>2]=0;f[gf>>2]=0;f[m>>2]=16842752;f[hf>>2]=R;WQ(l,ha,m,1.0);Ul=Ol*3|0;f[j>>2]=-2147483648;f[jf>>2]=2147483647;f[k>>2]=Tl;f[kf>>2]=Ul;DR(r,ma,j,k);Jl=f[l>>2]|0;Ah[f[(f[Jl>>2]|0)+12>>2]&255](Jl,l,r,-1);Jl=f[lf>>2]|0;do if(Jl|0){Il=Jl+12|0;Vl=f[Il>>2]|0;f[Il>>2]=Vl+-1;if((Vl|0)!=1)break;CR(r)}while(0);f[lf>>2]=0;f[mf>>2]=0;f[mf+4>>2]=0;f[mf+8>>2]=0;f[mf+12>>2]=0;if((f[nf>>2]|0)>0){Jl=f[of>>2]|0;Tl=0;do{f[Jl+(Tl<<2)>>2]=0;Tl=Tl+1|0}while((Tl|0)<(f[nf>>2]|0))}Tl=f[pf>>2]|0;if((Tl|0)!=(qf|0))ZF(Tl);fj(l);f[rf>>2]=0;f[sf>>2]=0;f[m>>2]=16842752;f[tf>>2]=R;WQ(l,ia,m,1.0);Tl=Ol<<2;f[j>>2]=-2147483648;f[uf>>2]=2147483647;f[k>>2]=Ul;f[vf>>2]=Tl;DR(t,ma,j,k);Jl=f[l>>2]|0;Ah[f[(f[Jl>>2]|0)+12>>2]&255](Jl,l,t,-1);Jl=f[wf>>2]|0;do if(Jl|0){Vl=Jl+12|0;Il=f[Vl>>2]|0;f[Vl>>2]=Il+-1;if((Il|0)!=1)break;CR(t)}while(0);f[wf>>2]=0;f[xf>>2]=0;f[xf+4>>2]=0;f[xf+8>>2]=0;f[xf+12>>2]=0;if((f[yf>>2]|0)>0){Jl=f[zf>>2]|0;Ul=0;do{f[Jl+(Ul<<2)>>2]=0;Ul=Ul+1|0}while((Ul|0)<(f[yf>>2]|0))}Ul=f[Af>>2]|0;if((Ul|0)!=(Bf|0))ZF(Ul);fj(l);Ul=Ol*5|0;f[j>>2]=-2147483648;f[Cf>>2]=2147483647;f[k>>2]=Tl;f[Df>>2]=Ul;DR(m,ma,j,k);Jl=Ef;f[Jl>>2]=0;f[Jl+4>>2]=0;f[l>>2]=-1040121856;f[Ff>>2]=m;eL(ha,l);Jl=f[Gf>>2]|0;do if(Jl|0){Il=Jl+12|0;Vl=f[Il>>2]|0;f[Il>>2]=Vl+-1;if((Vl|0)!=1)break;CR(m)}while(0);f[Gf>>2]=0;f[Hf>>2]=0;f[Hf+4>>2]=0;f[Hf+8>>2]=0;f[Hf+12>>2]=0;if((f[If>>2]|0)>0){Jl=f[Jf>>2]|0;Tl=0;do{f[Jl+(Tl<<2)>>2]=0;Tl=Tl+1|0}while((Tl|0)<(f[If>>2]|0))}Tl=f[Kf>>2]|0;if((Tl|0)!=(Lf|0))ZF(Tl);f[j>>2]=-2147483648;f[Mf>>2]=2147483647;f[k>>2]=Ul;f[Nf>>2]=Ol*6;DR(m,ma,j,k);Tl=Of;f[Tl>>2]=0;f[Tl+4>>2]=0;f[l>>2]=-1040121856;f[Pf>>2]=m;eL(ia,l);Tl=f[Qf>>2]|0;do if(Tl|0){Jl=Tl+12|0;Vl=f[Jl>>2]|0;f[Jl>>2]=Vl+-1;if((Vl|0)!=1)break;CR(m)}while(0);f[Qf>>2]=0;f[Rf>>2]=0;f[Rf+4>>2]=0;f[Rf+8>>2]=0;f[Rf+12>>2]=0;if((f[Sf>>2]|0)>0){Tl=f[Tf>>2]|0;Ol=0;do{f[Tl+(Ol<<2)>>2]=0;Ol=Ol+1|0}while((Ol|0)<(f[Sf>>2]|0))}Ol=f[Uf>>2]|0;if((Ol|0)!=(Vf|0))ZF(Ol);break}case 3:{Ol=f[Pb>>2]|0;Tl=f[Ol+4>>2]|0;Ul=f[Ol>>2]|0;Ol=f[Ub>>2]|0;if((Ul|0)==(f[Ol>>2]|0)?(Tl|0)==(f[Ol+4>>2]|0):0){Wl=Tl;Xl=Ul}else{f[j>>2]=0;f[vj>>2]=0;Pa=c$(j,26)|0;Qa=346346;Ra=Pa+26|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346557,345932,57);d$(j);Ul=f[Pb>>2]|0;Wl=f[Ul+4>>2]|0;Xl=f[Ul>>2]|0}Ul=f[ab>>2]|0;if((Xl|0)==(f[Ul>>2]|0)?(Wl|0)==(f[Ul+4>>2]|0):0){Yl=Wl;Zl=Xl}else{f[j>>2]=0;f[uj>>2]=0;Pa=c$(j,26)|0;Qa=346399;Ra=Pa+26|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346557,345932,58);d$(j);Ul=f[Pb>>2]|0;Yl=f[Ul+4>>2]|0;Zl=f[Ul>>2]|0}Ul=f[eb>>2]|0;if(!((Zl|0)==(f[Ul>>2]|0)?(Yl|0)==(f[Ul+4>>2]|0):0)){f[j>>2]=0;f[tj>>2]=0;Pa=c$(j,26)|0;Qa=346426;Ra=Pa+26|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346557,345932,59);d$(j)}if((f[Ob>>2]|0)!=(f[Wb>>2]|0)){f[j>>2]=0;f[sj>>2]=0;Pa=c$(j,21)|0;Qa=346453;Ra=Pa+21|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346557,345932,61);d$(j)}if((f[Je>>2]|0)!=(f[Ke>>2]<<3|0)){f[j>>2]=0;f[rj>>2]=0;Pa=c$(j,25)|0;Qa=346581;Ra=Pa+25|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346557,345932,62);d$(j)}if((f[ma>>2]&4095|0)!=5){f[j>>2]=0;f[qj>>2]=0;Pa=c$(j,55)|0;Qa=346501;Ra=Pa+55|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346557,345932,63);d$(j)}if(!(f[J>>2]&16384)){f[j>>2]=0;f[ag>>2]=0;Pa=c$(j,19)|0;Qa=346607;Ra=Pa+19|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346557,345932,65);d$(j)}Ul=f[Sa>>2]|0;Kl=+n[Ul>>2];Ll=+n[Ul+12>>2];_l=+n[Ul+4>>2];$l=+n[Ul+16>>2];am=+n[Ul+28>>2];bm=+n[Ul+8>>2];cm=+n[Ul+20>>2];Tl=f[Ke>>2]|0;LQ(k,Q,+n[Ul+24>>2]);LQ(o,R,am);DQ(j,k,o);p[q>>3]=1.0;f[bg>>2]=0;f[bg+4>>2]=0;f[bg+8>>2]=0;f[bg+12>>2]=0;f[bg+16>>2]=0;f[bg+20>>2]=0;CQ(m,j,q);f[l>>2]=1124007936;Pa=cg;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[eg>>2]=dg;f[gg>>2]=fg;f[fg>>2]=0;f[hg>>2]=0;Ul=f[m>>2]|0;Ah[f[(f[Ul>>2]|0)+12>>2]&255](Ul,m,l,-1);fj(m);fj(j);fj(o);fj(k);IQ(q,Q);NQ(k,q,Kl);LQ(t,R,_l);HQ(j,k,t);p[v>>3]=bm;f[ig>>2]=0;f[ig+4>>2]=0;f[ig+8>>2]=0;f[ig+12>>2]=0;f[ig+16>>2]=0;f[ig+20>>2]=0;GQ(r,j,v);f[o>>2]=1124007936;Pa=jg;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[lg>>2]=kg;f[ng>>2]=mg;f[mg>>2]=0;f[og>>2]=0;Ul=f[r>>2]|0;Ah[f[(f[Ul>>2]|0)+12>>2]&255](Ul,r,o,-1);fj(r);fj(j);fj(t);fj(k);fj(q);f[pg>>2]=0;f[qg>>2]=0;f[j>>2]=16842752;f[rg>>2]=o;f[sg>>2]=0;f[tg>>2]=0;f[k>>2]=16842752;f[ug>>2]=l;Ul=vg;f[Ul>>2]=0;f[Ul+4>>2]=0;f[q>>2]=33619968;f[wg>>2]=o;TH(j,k,q,1.0,-1);IQ(t,Q);NQ(k,t,Ll);LQ(v,R,$l);HQ(j,k,v);p[x>>3]=cm;f[xg>>2]=0;f[xg+4>>2]=0;f[xg+8>>2]=0;f[xg+12>>2]=0;f[xg+16>>2]=0;f[xg+20>>2]=0;GQ(w,j,x);f[q>>2]=1124007936;Pa=yg;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Ag>>2]=zg;f[Cg>>2]=Bg;f[Bg>>2]=0;f[Dg>>2]=0;Ul=f[w>>2]|0;Ah[f[(f[Ul>>2]|0)+12>>2]&255](Ul,w,q,-1);fj(w);fj(j);fj(v);fj(k);fj(t);f[Eg>>2]=0;f[Fg>>2]=0;f[j>>2]=16842752;f[Gg>>2]=q;f[Hg>>2]=0;f[Ig>>2]=0;f[k>>2]=16842752;f[Jg>>2]=l;Ul=Kg;f[Ul>>2]=0;f[Ul+4>>2]=0;f[t>>2]=33619968;f[Lg>>2]=q;TH(j,k,t,1.0,-1);f[t>>2]=1124007936;Pa=Mg;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Og>>2]=Ng;f[Qg>>2]=Pg;f[Pg>>2]=0;f[Rg>>2]=0;f[v>>2]=1124007936;Pa=Sg;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Ug>>2]=Tg;f[Wg>>2]=Vg;f[Vg>>2]=0;f[Xg>>2]=0;f[Yg>>2]=0;f[Zg>>2]=0;f[j>>2]=16842752;f[_g>>2]=ha;f[$g>>2]=0;f[ah>>2]=0;f[k>>2]=16842752;f[bh>>2]=l;Ul=ch;f[Ul>>2]=0;f[Ul+4>>2]=0;f[x>>2]=33619968;f[dh>>2]=t;TH(j,k,x,1.0,-1);f[eh>>2]=0;f[fh>>2]=0;f[j>>2]=16842752;f[gh>>2]=ia;f[hh>>2]=0;f[ih>>2]=0;f[k>>2]=16842752;f[jh>>2]=l;Ul=kh;f[Ul>>2]=0;f[Ul+4>>2]=0;f[x>>2]=33619968;f[lh>>2]=v;TH(j,k,x,1.0,-1);f[mh>>2]=0;f[nh>>2]=0;f[y>>2]=16842752;f[oh>>2]=Q;WQ(x,t,y,1.0);f[j>>2]=-2147483648;f[ph>>2]=2147483647;f[k>>2]=0;f[qh>>2]=Tl;DR(z,ma,j,k);Ul=f[x>>2]|0;Ah[f[(f[Ul>>2]|0)+12>>2]&255](Ul,x,z,-1);Ul=f[rh>>2]|0;do if(Ul|0){Ol=Ul+12|0;Vl=f[Ol>>2]|0;f[Ol>>2]=Vl+-1;if((Vl|0)!=1)break;CR(z)}while(0);f[rh>>2]=0;f[sh>>2]=0;f[sh+4>>2]=0;f[sh+8>>2]=0;f[sh+12>>2]=0;if((f[th>>2]|0)>0){Ul=f[uh>>2]|0;Vl=0;do{f[Ul+(Vl<<2)>>2]=0;Vl=Vl+1|0}while((Vl|0)<(f[th>>2]|0))}Vl=f[vh>>2]|0;if((Vl|0)!=(wh|0))ZF(Vl);fj(x);f[xh>>2]=0;f[yh>>2]=0;f[y>>2]=16842752;f[zh>>2]=Q;WQ(x,v,y,1.0);Vl=Tl<<1;f[j>>2]=-2147483648;f[Bh>>2]=2147483647;f[k>>2]=Tl;f[Ch>>2]=Vl;DR(A,ma,j,k);Ul=f[x>>2]|0;Ah[f[(f[Ul>>2]|0)+12>>2]&255](Ul,x,A,-1);Ul=f[Dh>>2]|0;do if(Ul|0){Ol=Ul+12|0;Jl=f[Ol>>2]|0;f[Ol>>2]=Jl+-1;if((Jl|0)!=1)break;CR(A)}while(0);f[Dh>>2]=0;f[Eh>>2]=0;f[Eh+4>>2]=0;f[Eh+8>>2]=0;f[Eh+12>>2]=0;if((f[Fh>>2]|0)>0){Ul=f[Gh>>2]|0;Jl=0;do{f[Ul+(Jl<<2)>>2]=0;Jl=Jl+1|0}while((Jl|0)<(f[Fh>>2]|0))}Jl=f[Hh>>2]|0;if((Jl|0)!=(Ih|0))ZF(Jl);fj(x);f[Jh>>2]=0;f[Kh>>2]=0;f[k>>2]=16842752;f[Lh>>2]=t;WQ(j,o,k,1.0);f[Mh>>2]=0;f[Nh>>2]=0;f[C>>2]=16842752;f[Oh>>2]=v;WQ(y,q,C,1.0);DQ(B,j,y);f[x>>2]=1124007936;Pa=Ph;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Rh>>2]=Qh;f[Th>>2]=Sh;f[Sh>>2]=0;f[Uh>>2]=0;Jl=f[B>>2]|0;Ah[f[(f[Jl>>2]|0)+12>>2]&255](Jl,B,x,-1);fj(B);fj(y);fj(j);f[Vh>>2]=0;f[Wh>>2]=0;f[C>>2]=16842752;f[Xh>>2]=Q;WQ(y,x,C,1.0);Jl=Tl*3|0;f[j>>2]=-2147483648;f[Yh>>2]=2147483647;f[k>>2]=Vl;f[Zh>>2]=Jl;DR(D,ma,j,k);Ul=f[y>>2]|0;Ah[f[(f[Ul>>2]|0)+12>>2]&255](Ul,y,D,-1);Ul=f[_h>>2]|0;do if(Ul|0){Ol=Ul+12|0;Il=f[Ol>>2]|0;f[Ol>>2]=Il+-1;if((Il|0)!=1)break;CR(D)}while(0);f[_h>>2]=0;f[$h>>2]=0;f[$h+4>>2]=0;f[$h+8>>2]=0;f[$h+12>>2]=0;if((f[ai>>2]|0)>0){Ul=f[bi>>2]|0;Vl=0;do{f[Ul+(Vl<<2)>>2]=0;Vl=Vl+1|0}while((Vl|0)<(f[ai>>2]|0))}Vl=f[ci>>2]|0;if((Vl|0)!=(di|0))ZF(Vl);fj(y);Vl=f[ei>>2]|0;do if(Vl|0){Ul=Vl+12|0;Il=f[Ul>>2]|0;f[Ul>>2]=Il+-1;if((Il|0)!=1)break;CR(o)}while(0);f[ei>>2]=0;f[fi>>2]=0;f[fi+4>>2]=0;f[fi+8>>2]=0;f[fi+12>>2]=0;if((f[jg>>2]|0)>0){Vl=f[lg>>2]|0;Il=0;do{f[Vl+(Il<<2)>>2]=0;Il=Il+1|0}while((Il|0)<(f[jg>>2]|0))}Il=f[gi>>2]|0;do if(Il|0){Vl=Il+12|0;Ul=f[Vl>>2]|0;f[Vl>>2]=Ul+-1;if((Ul|0)!=1)break;CR(q)}while(0);f[gi>>2]=0;f[hi>>2]=0;f[hi+4>>2]=0;f[hi+8>>2]=0;f[hi+12>>2]=0;if((f[yg>>2]|0)>0){Il=f[Ag>>2]|0;Ul=0;do{f[Il+(Ul<<2)>>2]=0;Ul=Ul+1|0}while((Ul|0)<(f[yg>>2]|0))}f[ii>>2]=0;f[ji>>2]=0;f[C>>2]=16842752;f[ki>>2]=R;WQ(y,t,C,1.0);Ul=Tl<<2;f[j>>2]=-2147483648;f[li>>2]=2147483647;f[k>>2]=Jl;f[mi>>2]=Ul;DR(E,ma,j,k);Il=f[y>>2]|0;Ah[f[(f[Il>>2]|0)+12>>2]&255](Il,y,E,-1);Il=f[ni>>2]|0;do if(Il|0){Vl=Il+12|0;Ol=f[Vl>>2]|0;f[Vl>>2]=Ol+-1;if((Ol|0)!=1)break;CR(E)}while(0);f[ni>>2]=0;f[oi>>2]=0;f[oi+4>>2]=0;f[oi+8>>2]=0;f[oi+12>>2]=0;if((f[pi>>2]|0)>0){Il=f[qi>>2]|0;Jl=0;do{f[Il+(Jl<<2)>>2]=0;Jl=Jl+1|0}while((Jl|0)<(f[pi>>2]|0))}Jl=f[ri>>2]|0;if((Jl|0)!=(si|0))ZF(Jl);fj(y);f[ti>>2]=0;f[ui>>2]=0;f[C>>2]=16842752;f[vi>>2]=R;WQ(y,v,C,1.0);Jl=Tl*5|0;f[j>>2]=-2147483648;f[wi>>2]=2147483647;f[k>>2]=Ul;f[xi>>2]=Jl;DR(F,ma,j,k);Il=f[y>>2]|0;Ah[f[(f[Il>>2]|0)+12>>2]&255](Il,y,F,-1);Il=f[yi>>2]|0;do if(Il|0){Ol=Il+12|0;Vl=f[Ol>>2]|0;f[Ol>>2]=Vl+-1;if((Vl|0)!=1)break;CR(F)}while(0);f[yi>>2]=0;f[zi>>2]=0;f[zi+4>>2]=0;f[zi+8>>2]=0;f[zi+12>>2]=0;if((f[Ai>>2]|0)>0){Il=f[Bi>>2]|0;Ul=0;do{f[Il+(Ul<<2)>>2]=0;Ul=Ul+1|0}while((Ul|0)<(f[Ai>>2]|0))}Ul=f[Ci>>2]|0;if((Ul|0)!=(Di|0))ZF(Ul);fj(y);f[Ei>>2]=0;f[Fi>>2]=0;f[C>>2]=16842752;f[Gi>>2]=R;WQ(y,x,C,1.0);Ul=Tl*6|0;f[j>>2]=-2147483648;f[Hi>>2]=2147483647;f[k>>2]=Jl;f[Ii>>2]=Ul;DR(G,ma,j,k);Il=f[y>>2]|0;Ah[f[(f[Il>>2]|0)+12>>2]&255](Il,y,G,-1);Il=f[Ji>>2]|0;do if(Il|0){Vl=Il+12|0;Ol=f[Vl>>2]|0;f[Vl>>2]=Ol+-1;if((Ol|0)!=1)break;CR(G)}while(0);f[Ji>>2]=0;f[Ki>>2]=0;f[Ki+4>>2]=0;f[Ki+8>>2]=0;f[Ki+12>>2]=0;if((f[Li>>2]|0)>0){Il=f[Mi>>2]|0;Jl=0;do{f[Il+(Jl<<2)>>2]=0;Jl=Jl+1|0}while((Jl|0)<(f[Li>>2]|0))}Jl=f[Ni>>2]|0;if((Jl|0)!=(Oi|0))ZF(Jl);fj(y);Jl=Tl*7|0;f[j>>2]=-2147483648;f[Pi>>2]=2147483647;f[k>>2]=Ul;f[Qi>>2]=Jl;DR(C,ma,j,k);Il=Ri;f[Il>>2]=0;f[Il+4>>2]=0;f[y>>2]=-1040121856;f[Si>>2]=C;eL(t,y);Il=f[Ti>>2]|0;do if(Il|0){Ol=Il+12|0;Vl=f[Ol>>2]|0;f[Ol>>2]=Vl+-1;if((Vl|0)!=1)break;CR(C)}while(0);f[Ti>>2]=0;f[Ui>>2]=0;f[Ui+4>>2]=0;f[Ui+8>>2]=0;f[Ui+12>>2]=0;if((f[Vi>>2]|0)>0){Il=f[Wi>>2]|0;Ul=0;do{f[Il+(Ul<<2)>>2]=0;Ul=Ul+1|0}while((Ul|0)<(f[Vi>>2]|0))}Ul=f[Xi>>2]|0;if((Ul|0)!=(Yi|0))ZF(Ul);f[j>>2]=-2147483648;f[Zi>>2]=2147483647;f[k>>2]=Jl;f[_i>>2]=Tl<<3;DR(C,ma,j,k);Ul=$i;f[Ul>>2]=0;f[Ul+4>>2]=0;f[y>>2]=-1040121856;f[aj>>2]=C;eL(v,y);Ul=f[bj>>2]|0;do if(Ul|0){Il=Ul+12|0;Vl=f[Il>>2]|0;f[Il>>2]=Vl+-1;if((Vl|0)!=1)break;CR(C)}while(0);f[bj>>2]=0;f[cj>>2]=0;f[cj+4>>2]=0;f[cj+8>>2]=0;f[cj+12>>2]=0;if((f[dj>>2]|0)>0){Ul=f[ej>>2]|0;Tl=0;do{f[Ul+(Tl<<2)>>2]=0;Tl=Tl+1|0}while((Tl|0)<(f[dj>>2]|0))}Tl=f[gj>>2]|0;if((Tl|0)!=(hj|0))ZF(Tl);Tl=f[ij>>2]|0;do if(Tl|0){Ul=Tl+12|0;Jl=f[Ul>>2]|0;f[Ul>>2]=Jl+-1;if((Jl|0)!=1)break;CR(x)}while(0);f[ij>>2]=0;f[jj>>2]=0;f[jj+4>>2]=0;f[jj+8>>2]=0;f[jj+12>>2]=0;if((f[Ph>>2]|0)>0){Tl=f[Rh>>2]|0;Jl=0;do{f[Tl+(Jl<<2)>>2]=0;Jl=Jl+1|0}while((Jl|0)<(f[Ph>>2]|0))}Jl=f[Th>>2]|0;if((Jl|0)!=(Sh|0))ZF(Jl);Jl=f[kj>>2]|0;do if(Jl|0){Tl=Jl+12|0;Ul=f[Tl>>2]|0;f[Tl>>2]=Ul+-1;if((Ul|0)!=1)break;CR(v)}while(0);f[kj>>2]=0;f[lj>>2]=0;f[lj+4>>2]=0;f[lj+8>>2]=0;f[lj+12>>2]=0;if((f[Sg>>2]|0)>0){Jl=f[Ug>>2]|0;Ul=0;do{f[Jl+(Ul<<2)>>2]=0;Ul=Ul+1|0}while((Ul|0)<(f[Sg>>2]|0))}Ul=f[Wg>>2]|0;if((Ul|0)!=(Vg|0))ZF(Ul);Ul=f[mj>>2]|0;do if(Ul|0){Jl=Ul+12|0;Tl=f[Jl>>2]|0;f[Jl>>2]=Tl+-1;if((Tl|0)!=1)break;CR(t)}while(0);f[mj>>2]=0;f[nj>>2]=0;f[nj+4>>2]=0;f[nj+8>>2]=0;f[nj+12>>2]=0;if((f[Mg>>2]|0)>0){Ul=f[Og>>2]|0;Tl=0;do{f[Ul+(Tl<<2)>>2]=0;Tl=Tl+1|0}while((Tl|0)<(f[Mg>>2]|0))}Tl=f[Qg>>2]|0;if((Tl|0)!=(Pg|0))ZF(Tl);Tl=f[gi>>2]|0;do if(Tl|0){Ul=Tl+12|0;Jl=f[Ul>>2]|0;f[Ul>>2]=Jl+-1;if((Jl|0)!=1)break;CR(q)}while(0);f[gi>>2]=0;f[hi>>2]=0;f[hi+4>>2]=0;f[hi+8>>2]=0;f[hi+12>>2]=0;if((f[yg>>2]|0)>0){Tl=f[Ag>>2]|0;Jl=0;do{f[Tl+(Jl<<2)>>2]=0;Jl=Jl+1|0}while((Jl|0)<(f[yg>>2]|0))}Jl=f[Cg>>2]|0;if((Jl|0)!=(Bg|0))ZF(Jl);Jl=f[ei>>2]|0;do if(Jl|0){Tl=Jl+12|0;Ul=f[Tl>>2]|0;f[Tl>>2]=Ul+-1;if((Ul|0)!=1)break;CR(o)}while(0);f[ei>>2]=0;f[fi>>2]=0;f[fi+4>>2]=0;f[fi+8>>2]=0;f[fi+12>>2]=0;if((f[jg>>2]|0)>0){Jl=f[lg>>2]|0;Ul=0;do{f[Jl+(Ul<<2)>>2]=0;Ul=Ul+1|0}while((Ul|0)<(f[jg>>2]|0))}Ul=f[ng>>2]|0;if((Ul|0)!=(mg|0))ZF(Ul);Ul=f[oj>>2]|0;do if(Ul|0){Jl=Ul+12|0;Tl=f[Jl>>2]|0;f[Jl>>2]=Tl+-1;if((Tl|0)!=1)break;CR(l)}while(0);f[oj>>2]=0;f[pj>>2]=0;f[pj+4>>2]=0;f[pj+8>>2]=0;f[pj+12>>2]=0;if((f[cg>>2]|0)>0){Ul=f[eg>>2]|0;Tl=0;do{f[Ul+(Tl<<2)>>2]=0;Tl=Tl+1|0}while((Tl|0)<(f[cg>>2]|0))}Tl=f[gg>>2]|0;if((Tl|0)!=(fg|0))ZF(Tl);break}case 0:{Tl=f[Pb>>2]|0;Ul=f[Ub>>2]|0;if(!((f[Tl>>2]|0)==(f[Ul>>2]|0)?(f[Tl+4>>2]|0)==(f[Ul+4>>2]|0):0)){f[j>>2]=0;f[Tj>>2]=0;Pa=c$(j,24)|0;Qa=346627;Ra=Pa+24|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346652,345932,193);d$(j)}if((f[Ob>>2]|0)!=(f[Wb>>2]|0)){f[j>>2]=0;f[Sj>>2]=0;Pa=c$(j,21)|0;Qa=346453;Ra=Pa+21|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346652,345932,195);d$(j)}if((f[Je>>2]|0)!=(f[Ke>>2]<<1|0)){f[j>>2]=0;f[Rj>>2]=0;Pa=c$(j,25)|0;Qa=346683;Ra=Pa+25|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346652,345932,196);d$(j)}if((f[ma>>2]&4095|0)!=5){f[j>>2]=0;f[Qj>>2]=0;Pa=c$(j,55)|0;Qa=346501;Ra=Pa+55|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346652,345932,197);d$(j)}Ul=f[Ke>>2]|0;f[j>>2]=-2147483648;f[wj>>2]=2147483647;f[k>>2]=0;f[xj>>2]=Ul;DR(m,ma,j,k);Tl=yj;f[Tl>>2]=0;f[Tl+4>>2]=0;f[l>>2]=-1040121856;f[zj>>2]=m;eL(ha,l);Tl=f[Aj>>2]|0;do if(Tl|0){Jl=Tl+12|0;Vl=f[Jl>>2]|0;f[Jl>>2]=Vl+-1;if((Vl|0)!=1)break;CR(m)}while(0);f[Aj>>2]=0;f[Bj>>2]=0;f[Bj+4>>2]=0;f[Bj+8>>2]=0;f[Bj+12>>2]=0;if((f[Cj>>2]|0)>0){Tl=f[Dj>>2]|0;Vl=0;do{f[Tl+(Vl<<2)>>2]=0;Vl=Vl+1|0}while((Vl|0)<(f[Cj>>2]|0))}Vl=f[Ej>>2]|0;if((Vl|0)!=(Fj|0))ZF(Vl);f[j>>2]=-2147483648;f[Gj>>2]=2147483647;f[k>>2]=Ul;f[Hj>>2]=Ul<<1;DR(m,ma,j,k);Vl=Ij;f[Vl>>2]=0;f[Vl+4>>2]=0;f[l>>2]=-1040121856;f[Jj>>2]=m;eL(ia,l);Vl=f[Kj>>2]|0;do if(Vl|0){Tl=Vl+12|0;Jl=f[Tl>>2]|0;f[Tl>>2]=Jl+-1;if((Jl|0)!=1)break;CR(m)}while(0);f[Kj>>2]=0;f[Lj>>2]=0;f[Lj+4>>2]=0;f[Lj+8>>2]=0;f[Lj+12>>2]=0;if((f[Mj>>2]|0)>0){Vl=f[Nj>>2]|0;Ul=0;do{f[Vl+(Ul<<2)>>2]=0;Ul=Ul+1|0}while((Ul|0)<(f[Mj>>2]|0))}Ul=f[Oj>>2]|0;if((Ul|0)!=(Pj|0))ZF(Ul);break}case 1:{Ul=f[Pb>>2]|0;Vl=f[Ul+4>>2]|0;Jl=f[Ul>>2]|0;Ul=f[Ub>>2]|0;if((Jl|0)==(f[Ul>>2]|0)?(Vl|0)==(f[Ul+4>>2]|0):0){dm=Vl;em=Jl}else{f[j>>2]=0;f[Wk>>2]=0;Pa=c$(j,24)|0;Qa=346627;Ra=Pa+24|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346709,345932,130);d$(j);Jl=f[Pb>>2]|0;dm=f[Jl+4>>2]|0;em=f[Jl>>2]|0}Jl=f[ab>>2]|0;if((em|0)==(f[Jl>>2]|0)?(dm|0)==(f[Jl+4>>2]|0):0){fm=dm;gm=em}else{f[j>>2]=0;f[Vk>>2]=0;Pa=c$(j,24)|0;Qa=346738;Ra=Pa+24|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346709,345932,131);d$(j);Jl=f[Pb>>2]|0;fm=f[Jl+4>>2]|0;gm=f[Jl>>2]|0}Jl=f[eb>>2]|0;if(!((gm|0)==(f[Jl>>2]|0)?(fm|0)==(f[Jl+4>>2]|0):0)){f[j>>2]=0;f[Uk>>2]=0;Pa=c$(j,24)|0;Qa=346763;Ra=Pa+24|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346709,345932,132);d$(j)}if((f[Ob>>2]|0)!=(f[Wb>>2]|0)){f[j>>2]=0;f[Tk>>2]=0;Pa=c$(j,21)|0;Qa=346453;Ra=Pa+21|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346709,345932,134);d$(j)}if((f[Je>>2]|0)!=((f[Ke>>2]|0)*3|0)){f[j>>2]=0;f[Sk>>2]=0;Pa=c$(j,25)|0;Qa=346788;Ra=Pa+25|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346709,345932,135);d$(j)}if((f[ma>>2]&4095|0)!=5){f[j>>2]=0;f[Rk>>2]=0;Pa=c$(j,55)|0;Qa=346501;Ra=Pa+55|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346709,345932,136);d$(j)}if(!(f[J>>2]&16384)){f[j>>2]=0;f[Uj>>2]=0;Pa=c$(j,19)|0;Qa=346607;Ra=Pa+19|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,346709,345932,138);d$(j)}Jl=f[Sa>>2]|0;cm=+n[Jl>>2];Vl=f[Ke>>2]|0;$l=+n[Jl+12>>2];LQ(k,Q,$l);JQ(j,k);Ll=cm;LQ(o,R,Ll);HQ(m,j,o);f[l>>2]=1124007936;Pa=Vj;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Xj>>2]=Wj;f[Zj>>2]=Yj;f[Yj>>2]=0;f[_j>>2]=0;Jl=f[m>>2]|0;Ah[f[(f[Jl>>2]|0)+12>>2]&255](Jl,m,l,-1);fj(m);fj(o);fj(j);fj(k);LQ(j,Q,Ll);LQ(k,R,$l);HQ(q,j,k);f[o>>2]=1124007936;Pa=$j;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[bk>>2]=ak;f[dk>>2]=ck;f[ck>>2]=0;f[ek>>2]=0;Jl=f[q>>2]|0;Ah[f[(f[Jl>>2]|0)+12>>2]&255](Jl,q,o,-1);fj(q);fj(k);fj(j);f[fk>>2]=0;f[gk>>2]=0;f[v>>2]=16842752;f[hk>>2]=l;WQ(t,ha,v,1.0);f[ik>>2]=0;f[jk>>2]=0;f[x>>2]=16842752;f[kk>>2]=o;WQ(w,ia,x,1.0);DQ(r,t,w);f[j>>2]=-2147483648;f[lk>>2]=2147483647;f[k>>2]=0;f[mk>>2]=Vl;DR(y,ma,j,k);Jl=f[r>>2]|0;Ah[f[(f[Jl>>2]|0)+12>>2]&255](Jl,r,y,-1);Jl=f[nk>>2]|0;do if(Jl|0){Ul=Jl+12|0;Tl=f[Ul>>2]|0;f[Ul>>2]=Tl+-1;if((Tl|0)!=1)break;CR(y)}while(0);f[nk>>2]=0;f[ok>>2]=0;f[ok+4>>2]=0;f[ok+8>>2]=0;f[ok+12>>2]=0;if((f[pk>>2]|0)>0){Jl=f[qk>>2]|0;Tl=0;do{f[Jl+(Tl<<2)>>2]=0;Tl=Tl+1|0}while((Tl|0)<(f[pk>>2]|0))}Tl=f[rk>>2]|0;if((Tl|0)!=(sk|0))ZF(Tl);fj(r);fj(w);fj(t);Tl=Vl<<1;f[j>>2]=-2147483648;f[tk>>2]=2147483647;f[k>>2]=Vl;f[uk>>2]=Tl;DR(t,ma,j,k);Jl=vk;f[Jl>>2]=0;f[Jl+4>>2]=0;f[r>>2]=-1040121856;f[wk>>2]=t;eL(ha,r);Jl=f[xk>>2]|0;do if(Jl|0){Ul=Jl+12|0;Il=f[Ul>>2]|0;f[Ul>>2]=Il+-1;if((Il|0)!=1)break;CR(t)}while(0);f[xk>>2]=0;f[yk>>2]=0;f[yk+4>>2]=0;f[yk+8>>2]=0;f[yk+12>>2]=0;if((f[zk>>2]|0)>0){Jl=f[Ak>>2]|0;Il=0;do{f[Jl+(Il<<2)>>2]=0;Il=Il+1|0}while((Il|0)<(f[zk>>2]|0))}Il=f[Bk>>2]|0;if((Il|0)!=(Ck|0))ZF(Il);f[j>>2]=-2147483648;f[Dk>>2]=2147483647;f[k>>2]=Tl;f[Ek>>2]=Vl*3;DR(t,ma,j,k);Il=Fk;f[Il>>2]=0;f[Il+4>>2]=0;f[r>>2]=-1040121856;f[Gk>>2]=t;eL(ia,r);Il=f[Hk>>2]|0;do if(Il|0){Jl=Il+12|0;Ul=f[Jl>>2]|0;f[Jl>>2]=Ul+-1;if((Ul|0)!=1)break;CR(t)}while(0);f[Hk>>2]=0;f[Ik>>2]=0;f[Ik+4>>2]=0;f[Ik+8>>2]=0;f[Ik+12>>2]=0;if((f[Jk>>2]|0)>0){Il=f[Kk>>2]|0;Vl=0;do{f[Il+(Vl<<2)>>2]=0;Vl=Vl+1|0}while((Vl|0)<(f[Jk>>2]|0))}Vl=f[Lk>>2]|0;if((Vl|0)!=(Mk|0))ZF(Vl);Vl=f[Nk>>2]|0;do if(Vl|0){Il=Vl+12|0;Tl=f[Il>>2]|0;f[Il>>2]=Tl+-1;if((Tl|0)!=1)break;CR(o)}while(0);f[Nk>>2]=0;f[Ok>>2]=0;f[Ok+4>>2]=0;f[Ok+8>>2]=0;f[Ok+12>>2]=0;if((f[$j>>2]|0)>0){Vl=f[bk>>2]|0;Tl=0;do{f[Vl+(Tl<<2)>>2]=0;Tl=Tl+1|0}while((Tl|0)<(f[$j>>2]|0))}Tl=f[dk>>2]|0;if((Tl|0)!=(ck|0))ZF(Tl);Tl=f[Pk>>2]|0;do if(Tl|0){Vl=Tl+12|0;Il=f[Vl>>2]|0;f[Vl>>2]=Il+-1;if((Il|0)!=1)break;CR(l)}while(0);f[Pk>>2]=0;f[Qk>>2]=0;f[Qk+4>>2]=0;f[Qk+8>>2]=0;f[Qk+12>>2]=0;if((f[Vj>>2]|0)>0){Tl=f[Xj>>2]|0;Il=0;do{f[Tl+(Il<<2)>>2]=0;Il=Il+1|0}while((Il|0)<(f[Vj>>2]|0))}Il=f[Zj>>2]|0;if((Il|0)!=(Yj|0))ZF(Il);break}default:{}}ava(ma,ma,na);VQ(j,na,0);Il=f[j>>2]|0;Ah[f[(f[Il>>2]|0)+12>>2]&255](Il,j,oa,-1);fj(j);f[ie>>2]=0;f[je>>2]=0;f[j>>2]=16842752;f[ke>>2]=W;$l=+YO(T,j);Ll=$l/(Ml*Nl);p[s>>3]=Ll;if(((f[s+4>>2]&2147483647)+((f[s>>2]|0)!=0&1)|0)>>>0>2146435072){f[j>>2]=0;f[le>>2]=0;Pa=c$(j,16)|0;Qa=346814;Ra=Pa+16|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-7,j,345915,345932,525);d$(j)}ava(ma,W,pa);ava(ma,T,qa);KQ(j,oa,pa);Il=f[j>>2]|0;Ah[f[(f[Il>>2]|0)+12>>2]&255](Il,j,ra,-1);fj(j);f[me>>2]=0;f[ne>>2]=0;f[j>>2]=16842752;f[oe>>2]=ra;Ml=Nl*Nl-+YO(pa,j);f[pe>>2]=0;f[qe>>2]=0;f[j>>2]=16842752;f[re>>2]=ra;cm=$l-+YO(qa,j);if(!(cm<=0.0))hm=Ll;else{f[j>>2]=0;f[Ie>>2]=0;K1a(c$(j,132)|0,346831,132)|0;j$(-7,j,345915,345932,540);d$(j);hm=-1.0}MQ(k,Ml/cm,T);FQ(j,k,W);Il=f[j>>2]|0;Ah[f[(f[Il>>2]|0)+12>>2]&255](Il,j,ua,-1);fj(j);fj(k);ava(ma,ua,sa);KQ(j,oa,sa);Il=f[j>>2]|0;Ah[f[(f[Il>>2]|0)+12>>2]&255](Il,j,ta,-1);fj(j);if((f[J>>2]&4095|0)!=5){f[j>>2]=0;f[He>>2]=0;Pa=c$(j,62)|0;Qa=346964;Ra=Pa+62|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,347027,345932,252);d$(j)}if((f[ta>>2]&4095|0)!=5){f[j>>2]=0;f[Ge>>2]=0;Pa=c$(j,58)|0;Qa=347053;Ra=Pa+58|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,347027,345932,253);d$(j)}if(!ve){f[j>>2]=0;f[Fe>>2]=0;K1a(c$(j,132)|0,347112,132)|0;j$(-215,j,347027,345932,256);d$(j)}Il=f[Wa>>2]|0;do if(!g){Tl=(Il|0)==2;Vl=f[vc>>2]|0;if(ue){if(Tl&(Vl|0)==6)break;f[j>>2]=0;f[Ce>>2]=0;Pa=c$(j,40)|0;Qa=347286;Ra=Pa+40|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,347027,345932,261);d$(j);break}if(te){if(Tl&(Vl|0)==3)break;f[j>>2]=0;f[De>>2]=0;Pa=c$(j,40)|0;Qa=347327;Ra=Pa+40|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,347027,345932,263);d$(j);break}else{if(Tl&(Vl|0)==2)break;f[j>>2]=0;f[Ee>>2]=0;Pa=c$(j,40)|0;Qa=347368;Ra=Pa+40|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,347027,345932,265);d$(j);break}}else{if((Il|0)==3&(f[vc>>2]|0)==8)break;f[j>>2]=0;f[we>>2]=0;Pa=c$(j,40)|0;Qa=347245;Ra=Pa+40|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,347027,345932,259);d$(j)}while(0);if((f[xe>>2]|0)!=1){f[j>>2]=0;f[Be>>2]=0;Pa=c$(j,16)|0;Qa=347409;Ra=Pa+16|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,347027,345932,267);d$(j)}if(!(f[J>>2]&16384)){f[j>>2]=0;f[ye>>2]=0;Pa=c$(j,25)|0;Qa=347426;Ra=Pa+25|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,347027,345932,269);d$(j)}if(!(f[ta>>2]&16384)){f[j>>2]=0;f[ze>>2]=0;Pa=c$(j,21)|0;Qa=347452;Ra=Pa+21|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));j$(-215,j,347027,345932,270);d$(j)}Il=f[Sa>>2]|0;Vl=f[Ae>>2]|0;if(se){Tl=Il+8|0;n[Tl>>2]=+n[Vl>>2]+ +n[Tl>>2];Tl=Il+20|0;n[Tl>>2]=+n[Vl+4>>2]+ +n[Tl>>2]}if(ue){n[Il>>2]=+n[Vl>>2]+ +n[Il>>2];Tl=Il+12|0;n[Tl>>2]=+n[Vl+4>>2]+ +n[Tl>>2];Tl=Il+4|0;n[Tl>>2]=+n[Vl+8>>2]+ +n[Tl>>2];Tl=Il+16|0;n[Tl>>2]=+n[Vl+12>>2]+ +n[Tl>>2];Tl=Il+8|0;n[Tl>>2]=+n[Vl+16>>2]+ +n[Tl>>2];Tl=Il+20|0;n[Tl>>2]=+n[Vl+20>>2]+ +n[Tl>>2]}if(g){n[Il>>2]=+n[Vl>>2]+ +n[Il>>2];Tl=Il+12|0;n[Tl>>2]=+n[Vl+4>>2]+ +n[Tl>>2];Tl=Il+24|0;n[Tl>>2]=+n[Vl+8>>2]+ +n[Tl>>2];Tl=Il+4|0;n[Tl>>2]=+n[Vl+12>>2]+ +n[Tl>>2];Tl=Il+16|0;n[Tl>>2]=+n[Vl+16>>2]+ +n[Tl>>2];Tl=Il+28|0;n[Tl>>2]=+n[Vl+20>>2]+ +n[Tl>>2];Tl=Il+8|0;n[Tl>>2]=+n[Vl+24>>2]+ +n[Tl>>2];Tl=Il+20|0;n[Tl>>2]=+n[Vl+28>>2]+ +n[Tl>>2]}if(te){Tl=Il+12|0;Ll=+n[Vl>>2]+ +S(+(+n[Tl>>2]));Ul=Il+8|0;n[Ul>>2]=+n[Vl+4>>2]+ +n[Ul>>2];Ul=Il+20|0;n[Ul>>2]=+n[Vl+8>>2]+ +n[Ul>>2];$l=+O(+Ll);n[Il+16>>2]=$l;n[Il>>2]=$l;$l=+P(+Ll);n[Tl>>2]=$l;n[Il+4>>2]=-$l}if((Fl|0)<(Xa|0)){$l=Hl;Fl=Fl+1|0;Hl=hm;Gl=$l}else{Cc=hm;break a}}}while(0);Xa=ua+36|0;j=f[Xa>>2]|0;do if(j|0){Qa=j+12|0;Pa=f[Qa>>2]|0;f[Qa>>2]=Pa+-1;if((Pa|0)!=1)break;CR(ua)}while(0);f[Xa>>2]=0;Xa=ua+16|0;f[Xa>>2]=0;f[Xa+4>>2]=0;f[Xa+8>>2]=0;f[Xa+12>>2]=0;if((f[Za>>2]|0)>0){Xa=f[Ac>>2]|0;Ac=0;do{f[Xa+(Ac<<2)>>2]=0;Ac=Ac+1|0}while((Ac|0)<(f[Za>>2]|0))}Za=f[Bc>>2]|0;if((Za|0)!=(zc|0))ZF(Za);Za=ta+36|0;zc=f[Za>>2]|0;do if(zc|0){Bc=zc+12|0;Ac=f[Bc>>2]|0;f[Bc>>2]=Ac+-1;if((Ac|0)!=1)break;CR(ta)}while(0);f[Za>>2]=0;Za=ta+16|0;f[Za>>2]=0;f[Za+4>>2]=0;f[Za+8>>2]=0;f[Za+12>>2]=0;if((f[uc>>2]|0)>0){Za=f[wc>>2]|0;wc=0;do{f[Za+(wc<<2)>>2]=0;wc=wc+1|0}while((wc|0)<(f[uc>>2]|0))}uc=f[yc>>2]|0;if((uc|0)!=(xc|0))ZF(uc);uc=sa+36|0;xc=f[uc>>2]|0;do if(xc|0){yc=xc+12|0;wc=f[yc>>2]|0;f[yc>>2]=wc+-1;if((wc|0)!=1)break;CR(sa)}while(0);f[uc>>2]=0;uc=sa+16|0;f[uc>>2]=0;f[uc+4>>2]=0;f[uc+8>>2]=0;f[uc+12>>2]=0;if((f[qc>>2]|0)>0){uc=f[sc>>2]|0;sc=0;do{f[uc+(sc<<2)>>2]=0;sc=sc+1|0}while((sc|0)<(f[qc>>2]|0))}qc=f[tc>>2]|0;if((qc|0)!=(rc|0))ZF(qc);qc=ra+36|0;rc=f[qc>>2]|0;do if(rc|0){tc=rc+12|0;sc=f[tc>>2]|0;f[tc>>2]=sc+-1;if((sc|0)!=1)break;CR(ra)}while(0);f[qc>>2]=0;qc=ra+16|0;f[qc>>2]=0;f[qc+4>>2]=0;f[qc+8>>2]=0;f[qc+12>>2]=0;if((f[mc>>2]|0)>0){qc=f[oc>>2]|0;oc=0;do{f[qc+(oc<<2)>>2]=0;oc=oc+1|0}while((oc|0)<(f[mc>>2]|0))}mc=f[pc>>2]|0;if((mc|0)!=(nc|0))ZF(mc);mc=qa+36|0;nc=f[mc>>2]|0;do if(nc|0){pc=nc+12|0;oc=f[pc>>2]|0;f[pc>>2]=oc+-1;if((oc|0)!=1)break;CR(qa)}while(0);f[mc>>2]=0;mc=qa+16|0;f[mc>>2]=0;f[mc+4>>2]=0;f[mc+8>>2]=0;f[mc+12>>2]=0;if((f[ic>>2]|0)>0){mc=f[kc>>2]|0;kc=0;do{f[mc+(kc<<2)>>2]=0;kc=kc+1|0}while((kc|0)<(f[ic>>2]|0))}ic=f[lc>>2]|0;if((ic|0)!=(jc|0))ZF(ic);ic=pa+36|0;jc=f[ic>>2]|0;do if(jc|0){lc=jc+12|0;kc=f[lc>>2]|0;f[lc>>2]=kc+-1;if((kc|0)!=1)break;CR(pa)}while(0);f[ic>>2]=0;ic=pa+16|0;f[ic>>2]=0;f[ic+4>>2]=0;f[ic+8>>2]=0;f[ic+12>>2]=0;if((f[ec>>2]|0)>0){ic=f[gc>>2]|0;gc=0;do{f[ic+(gc<<2)>>2]=0;gc=gc+1|0}while((gc|0)<(f[ec>>2]|0))}ec=f[hc>>2]|0;if((ec|0)!=(fc|0))ZF(ec);ec=oa+36|0;fc=f[ec>>2]|0;do if(fc|0){hc=fc+12|0;gc=f[hc>>2]|0;f[hc>>2]=gc+-1;if((gc|0)!=1)break;CR(oa)}while(0);f[ec>>2]=0;ec=oa+16|0;f[ec>>2]=0;f[ec+4>>2]=0;f[ec+8>>2]=0;f[ec+12>>2]=0;if((f[ac>>2]|0)>0){ec=f[cc>>2]|0;cc=0;do{f[ec+(cc<<2)>>2]=0;cc=cc+1|0}while((cc|0)<(f[ac>>2]|0))}ac=f[dc>>2]|0;if((ac|0)!=(bc|0))ZF(ac);ac=na+36|0;bc=f[ac>>2]|0;do if(bc|0){dc=bc+12|0;cc=f[dc>>2]|0;f[dc>>2]=cc+-1;if((cc|0)!=1)break;CR(na)}while(0);f[ac>>2]=0;ac=na+16|0;f[ac>>2]=0;f[ac+4>>2]=0;f[ac+8>>2]=0;f[ac+12>>2]=0;if((f[la>>2]|0)>0){ac=f[_b>>2]|0;_b=0;do{f[ac+(_b<<2)>>2]=0;_b=_b+1|0}while((_b|0)<(f[la>>2]|0))}la=f[$b>>2]|0;if((la|0)!=(Zb|0))ZF(la);la=ma+36|0;Zb=f[la>>2]|0;do if(Zb|0){$b=Zb+12|0;_b=f[$b>>2]|0;f[$b>>2]=_b+-1;if((_b|0)!=1)break;CR(ma)}while(0);f[la>>2]=0;la=ma+16|0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[Xb>>2]|0)>0){la=f[ja>>2]|0;ja=0;do{f[la+(ja<<2)>>2]=0;ja=ja+1|0}while((ja|0)<(f[Xb>>2]|0))}Xb=f[Yb>>2]|0;if((Xb|0)!=(ka|0))ZF(Xb);Xb=ia+36|0;ka=f[Xb>>2]|0;do if(ka|0){Yb=ka+12|0;ja=f[Yb>>2]|0;f[Yb>>2]=ja+-1;if((ja|0)!=1)break;CR(ia)}while(0);f[Xb>>2]=0;Xb=ia+16|0;f[Xb>>2]=0;f[Xb+4>>2]=0;f[Xb+8>>2]=0;f[Xb+12>>2]=0;if((f[Sb>>2]|0)>0){Xb=f[Ub>>2]|0;Ub=0;do{f[Xb+(Ub<<2)>>2]=0;Ub=Ub+1|0}while((Ub|0)<(f[Sb>>2]|0))}Sb=f[Vb>>2]|0;if((Sb|0)!=(Tb|0))ZF(Sb);Sb=ha+36|0;Tb=f[Sb>>2]|0;do if(Tb|0){Vb=Tb+12|0;Ub=f[Vb>>2]|0;f[Vb>>2]=Ub+-1;if((Ub|0)!=1)break;CR(ha)}while(0);f[Sb>>2]=0;Sb=ha+16|0;f[Sb>>2]=0;f[Sb+4>>2]=0;f[Sb+8>>2]=0;f[Sb+12>>2]=0;if((f[ga>>2]|0)>0){Sb=f[Pb>>2]|0;Pb=0;do{f[Sb+(Pb<<2)>>2]=0;Pb=Pb+1|0}while((Pb|0)<(f[ga>>2]|0))}ga=f[Rb>>2]|0;if((ga|0)!=(Qb|0))ZF(ga);ga=fa+36|0;Qb=f[ga>>2]|0;do if(Qb|0){Rb=Qb+12|0;Pb=f[Rb>>2]|0;f[Rb>>2]=Pb+-1;if((Pb|0)!=1)break;CR(fa)}while(0);f[ga>>2]=0;ga=fa+16|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[Ta>>2]|0)>0){ga=f[ea>>2]|0;ea=0;do{f[ga+(ea<<2)>>2]=0;ea=ea+1|0}while((ea|0)<(f[Ta>>2]|0))}Ta=f[Nb>>2]|0;if((Ta|0)!=(Ua|0))ZF(Ta);Ta=da+36|0;Ua=f[Ta>>2]|0;do if(Ua|0){Nb=Ua+12|0;ea=f[Nb>>2]|0;f[Nb>>2]=ea+-1;if((ea|0)!=1)break;CR(da)}while(0);f[Ta>>2]=0;Ta=da+16|0;f[Ta>>2]=0;f[Ta+4>>2]=0;f[Ta+8>>2]=0;f[Ta+12>>2]=0;if((f[ca>>2]|0)>0){Ta=f[Lb>>2]|0;Lb=0;do{f[Ta+(Lb<<2)>>2]=0;Lb=Lb+1|0}while((Lb|0)<(f[ca>>2]|0))}ca=f[Mb>>2]|0;if((ca|0)!=(ba|0))ZF(ca);ca=aa+36|0;ba=f[ca>>2]|0;do if(ba|0){Mb=ba+12|0;Lb=f[Mb>>2]|0;f[Mb>>2]=Lb+-1;if((Lb|0)!=1)break;CR(aa)}while(0);f[ca>>2]=0;ca=aa+16|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[$>>2]|0)>0){ca=f[Kb>>2]|0;Kb=0;do{f[ca+(Kb<<2)>>2]=0;Kb=Kb+1|0}while((Kb|0)<(f[$>>2]|0))}$=f[Jb>>2]|0;if(($|0)!=(h|0))ZF($);$=_+36|0;h=f[$>>2]|0;do if(h|0){Jb=h+12|0;Kb=f[Jb>>2]|0;f[Jb>>2]=Kb+-1;if((Kb|0)!=1)break;CR(_)}while(0);f[$>>2]=0;$=_+16|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[Fb>>2]|0)>0){$=f[Hb>>2]|0;Hb=0;do{f[$+(Hb<<2)>>2]=0;Hb=Hb+1|0}while((Hb|0)<(f[Fb>>2]|0))}Fb=f[Ib>>2]|0;if((Fb|0)!=(Gb|0))ZF(Fb);Fb=Z+36|0;Gb=f[Fb>>2]|0;do if(Gb|0){Ib=Gb+12|0;Hb=f[Ib>>2]|0;f[Ib>>2]=Hb+-1;if((Hb|0)!=1)break;CR(Z)}while(0);f[Fb>>2]=0;Fb=Z+16|0;Gb=Z+4|0;f[Fb>>2]=0;f[Fb+4>>2]=0;f[Fb+8>>2]=0;f[Fb+12>>2]=0;if((f[Gb>>2]|0)>0){Fb=f[Z+40>>2]|0;Hb=0;do{f[Fb+(Hb<<2)>>2]=0;Hb=Hb+1|0}while((Hb|0)<(f[Gb>>2]|0))}Gb=f[Z+44>>2]|0;if((Gb|0)!=(Z+48|0))ZF(Gb);Gb=X+36|0;Z=f[Gb>>2]|0;do if(Z|0){Hb=Z+12|0;Fb=f[Hb>>2]|0;f[Hb>>2]=Fb+-1;if((Fb|0)!=1)break;CR(X)}while(0);f[Gb>>2]=0;Gb=X+16|0;f[Gb>>2]=0;f[Gb+4>>2]=0;f[Gb+8>>2]=0;f[Gb+12>>2]=0;if((f[Bb>>2]|0)>0){Gb=f[Db>>2]|0;Db=0;do{f[Gb+(Db<<2)>>2]=0;Db=Db+1|0}while((Db|0)<(f[Bb>>2]|0))}Bb=f[Eb>>2]|0;if((Bb|0)!=(Cb|0))ZF(Bb);Bb=W+36|0;Cb=f[Bb>>2]|0;do if(Cb|0){Eb=Cb+12|0;Db=f[Eb>>2]|0;f[Eb>>2]=Db+-1;if((Db|0)!=1)break;CR(W)}while(0);f[Bb>>2]=0;Bb=W+16|0;f[Bb>>2]=0;f[Bb+4>>2]=0;f[Bb+8>>2]=0;f[Bb+12>>2]=0;if((f[xb>>2]|0)>0){Bb=f[zb>>2]|0;zb=0;do{f[Bb+(zb<<2)>>2]=0;zb=zb+1|0}while((zb|0)<(f[xb>>2]|0))}xb=f[Ab>>2]|0;if((xb|0)!=(yb|0))ZF(xb);xb=V+36|0;yb=f[xb>>2]|0;do if(yb|0){Ab=yb+12|0;zb=f[Ab>>2]|0;f[Ab>>2]=zb+-1;if((zb|0)!=1)break;CR(V)}while(0);f[xb>>2]=0;xb=V+16|0;f[xb>>2]=0;f[xb+4>>2]=0;f[xb+8>>2]=0;f[xb+12>>2]=0;if((f[tb>>2]|0)>0){xb=f[vb>>2]|0;vb=0;do{f[xb+(vb<<2)>>2]=0;vb=vb+1|0}while((vb|0)<(f[tb>>2]|0))}tb=f[wb>>2]|0;if((tb|0)!=(ub|0))ZF(tb);tb=U+36|0;ub=f[tb>>2]|0;do if(ub|0){wb=ub+12|0;vb=f[wb>>2]|0;f[wb>>2]=vb+-1;if((vb|0)!=1)break;CR(U)}while(0);f[tb>>2]=0;tb=U+16|0;f[tb>>2]=0;f[tb+4>>2]=0;f[tb+8>>2]=0;f[tb+12>>2]=0;if((f[pb>>2]|0)>0){tb=f[rb>>2]|0;rb=0;do{f[tb+(rb<<2)>>2]=0;rb=rb+1|0}while((rb|0)<(f[pb>>2]|0))}pb=f[sb>>2]|0;if((pb|0)!=(qb|0))ZF(pb);pb=T+36|0;qb=f[pb>>2]|0;do if(qb|0){sb=qb+12|0;rb=f[sb>>2]|0;f[sb>>2]=rb+-1;if((rb|0)!=1)break;CR(T)}while(0);f[pb>>2]=0;pb=T+16|0;f[pb>>2]=0;f[pb+4>>2]=0;f[pb+8>>2]=0;f[pb+12>>2]=0;if((f[lb>>2]|0)>0){pb=f[mb>>2]|0;mb=0;do{f[pb+(mb<<2)>>2]=0;mb=mb+1|0}while((mb|0)<(f[lb>>2]|0))}lb=f[ob>>2]|0;if((lb|0)!=(nb|0))ZF(lb);lb=R+36|0;nb=f[lb>>2]|0;do if(nb|0){ob=nb+12|0;mb=f[ob>>2]|0;f[ob>>2]=mb+-1;if((mb|0)!=1)break;CR(R)}while(0);f[lb>>2]=0;lb=R+16|0;f[lb>>2]=0;f[lb+4>>2]=0;f[lb+8>>2]=0;f[lb+12>>2]=0;if((f[cb>>2]|0)>0){lb=f[eb>>2]|0;eb=0;do{f[lb+(eb<<2)>>2]=0;eb=eb+1|0}while((eb|0)<(f[cb>>2]|0))}cb=f[fb>>2]|0;if((cb|0)!=(db|0))ZF(cb);cb=Q+36|0;db=f[cb>>2]|0;do if(db|0){fb=db+12|0;eb=f[fb>>2]|0;f[fb>>2]=eb+-1;if((eb|0)!=1)break;CR(Q)}while(0);f[cb>>2]=0;cb=Q+16|0;f[cb>>2]=0;f[cb+4>>2]=0;f[cb+8>>2]=0;f[cb+12>>2]=0;if((f[_a>>2]|0)>0){cb=f[ab>>2]|0;ab=0;do{f[cb+(ab<<2)>>2]=0;ab=ab+1|0}while((ab|0)<(f[_a>>2]|0))}_a=f[bb>>2]|0;if((_a|0)!=($a|0))ZF(_a);_a=f[hb>>2]|0;do if(_a|0){$a=_a+12|0;bb=f[$a>>2]|0;f[$a>>2]=bb+-1;if((bb|0)!=1)break;CR(N)}while(0);f[hb>>2]=0;f[ib>>2]=0;f[ib+4>>2]=0;f[ib+8>>2]=0;f[ib+12>>2]=0;if((f[Ia>>2]|0)>0){ib=f[La>>2]|0;La=0;do{f[ib+(La<<2)>>2]=0;La=La+1|0}while((La|0)<(f[Ia>>2]|0))}Ia=f[Ka>>2]|0;if((Ia|0)!=(Ha|0))ZF(Ia);Ia=f[kb>>2]|0;do if(Ia|0){Ha=Ia+12|0;Ka=f[Ha>>2]|0;f[Ha>>2]=Ka+-1;if((Ka|0)!=1)break;CR(K)}while(0);f[kb>>2]=0;f[gb>>2]=0;f[gb+4>>2]=0;f[gb+8>>2]=0;f[gb+12>>2]=0;if((f[d>>2]|0)>0){gb=f[Ja>>2]|0;Ja=0;do{f[gb+(Ja<<2)>>2]=0;Ja=Ja+1|0}while((Ja|0)<(f[d>>2]|0))}d=f[Ma>>2]|0;if((d|0)!=(Va|0))ZF(d);d=J+36|0;Va=f[d>>2]|0;do if(Va|0){Ma=Va+12|0;Ja=f[Ma>>2]|0;f[Ma>>2]=Ja+-1;if((Ja|0)!=1)break;CR(J)}while(0);f[d>>2]=0;d=J+4|0;f[Sa>>2]=0;f[Sa+4>>2]=0;f[Sa+8>>2]=0;f[Sa+12>>2]=0;if((f[d>>2]|0)>0){Sa=f[J+40>>2]|0;Va=0;do{f[Sa+(Va<<2)>>2]=0;Va=Va+1|0}while((Va|0)<(f[d>>2]|0))}d=f[J+44>>2]|0;if((d|0)!=(J+48|0))ZF(d);d=I+36|0;J=f[d>>2]|0;do if(J|0){Va=J+12|0;Sa=f[Va>>2]|0;f[Va>>2]=Sa+-1;if((Sa|0)!=1)break;CR(I)}while(0);f[d>>2]=0;d=I+4|0;f[Na>>2]=0;f[Na+4>>2]=0;f[Na+8>>2]=0;f[Na+12>>2]=0;if((f[d>>2]|0)>0){Na=f[I+40>>2]|0;J=0;do{f[Na+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[d>>2]|0))}d=f[I+44>>2]|0;if((d|0)!=(I+48|0))ZF(d);d=H+36|0;I=f[d>>2]|0;do if(I|0){J=I+12|0;Na=f[J>>2]|0;f[J>>2]=Na+-1;if((Na|0)!=1)break;CR(H)}while(0);f[d>>2]=0;d=H+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[d>>2]|0)>0){c=f[H+40>>2]|0;I=0;do{f[c+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[d>>2]|0))}d=f[H+44>>2]|0;if((d|0)==(H+48|0)){u=i;return +Cc}ZF(d);u=i;return +Cc}function ava(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;e=u;u=u+192|0;g=e+176|0;h=e+168|0;i=e+112|0;j=e+56|0;k=e;if((f[a+8>>2]|0)!=(f[c+8>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;l=c$(g,22)|0;m=347474;o=l+22|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));j$(-215,g,347497,345932,219);d$(g)}p=a+12|0;q=f[p>>2]|0;r=c+12|0;s=f[r>>2]|0;if(!((q|0)%(s|0)|0)){t=q;v=s}else{f[g>>2]=0;f[g+4>>2]=0;l=c$(g,28)|0;m=347523;o=l+28|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));j$(-215,g,347497,345932,220);d$(g);t=f[p>>2]|0;v=f[r>>2]|0}p=f[d+16>>2]|0;if((t|0)!=(v|0)){t=d+8|0;if((f[t>>2]|0)<=0){u=e;return}s=g+4|0;q=h+4|0;w=i+8|0;x=i+12|0;y=i+4|0;z=j+36|0;A=j+16|0;B=j+4|0;C=j+40|0;D=j+44|0;E=j+48|0;F=0;do{G=Y(F,v)|0;H=F;F=F+1|0;I=Y(F,v)|0;f[g>>2]=-2147483648;f[s>>2]=2147483647;f[h>>2]=G;f[q>>2]=I;DR(j,a,g,h);f[w>>2]=0;f[x>>2]=0;f[i>>2]=16842752;f[y>>2]=j;J=+YO(c,i);n[p+(H<<2)>>2]=J;H=f[z>>2]|0;if(H|0?(I=H+12|0,H=f[I>>2]|0,f[I>>2]=H+-1,(H|0)==1):0)CR(j);f[z>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[B>>2]|0)>0){H=f[C>>2]|0;I=0;do{f[H+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[B>>2]|0))}I=f[D>>2]|0;if((I|0)!=(E|0))ZF(I)}while((F|0)<(f[t>>2]|0));u=e;return}t=d+12|0;F=f[t>>2]|0;E=d+8|0;if((F|0)==(f[E>>2]|0)){K=F;L=v;M=F}else{f[g>>2]=0;f[g+4>>2]=0;l=c$(g,20)|0;m=347552;o=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));j$(-215,g,347497,345932,233);d$(g);K=f[t>>2]|0;L=f[r>>2]|0;M=f[E>>2]|0}r=(L|0)/(K|0)|0;f[i>>2]=1124007936;K=i+4|0;L=i+8|0;m=i+40|0;l=K;o=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(o|0));f[m>>2]=L;l=i+48|0;o=i+44|0;f[o>>2]=l;f[l>>2]=0;f[i+52>>2]=0;if((M|0)>0){M=g+4|0;F=h+4|0;v=j+36|0;d=i+36|0;D=i+16|0;B=j+4|0;C=j+8|0;A=j+12|0;z=i+12|0;y=j+44|0;x=j+16|0;w=j+20|0;q=i+20|0;s=j+24|0;I=i+24|0;H=j+28|0;G=i+28|0;N=j+32|0;O=i+32|0;P=j+40|0;Q=j+48|0;R=g+8|0;S=g+12|0;T=g+4|0;U=g+4|0;V=h+4|0;W=j+8|0;X=j+12|0;Z=j+4|0;_=k+36|0;$=k+16|0;aa=k+4|0;ba=k+40|0;ca=k+44|0;da=k+48|0;ea=0;do{fa=Y(ea,r)|0;ga=ea;ea=ea+1|0;ha=Y(ea,r)|0;f[g>>2]=-2147483648;f[M>>2]=2147483647;f[h>>2]=fa;f[F>>2]=ha;DR(j,a,g,h);ha=f[v>>2]|0;if(ha|0){fa=ha+12|0;f[fa>>2]=(f[fa>>2]|0)+1}fa=f[d>>2]|0;if(fa|0?(ha=fa+12|0,fa=f[ha>>2]|0,f[ha>>2]=fa+-1,(fa|0)==1):0)CR(i);f[d>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[K>>2]|0)>0){fa=f[m>>2]|0;ha=0;do{f[fa+(ha<<2)>>2]=0;ha=ha+1|0;ia=f[K>>2]|0}while((ha|0)<(ia|0));f[i>>2]=f[j>>2];if((ia|0)<3)ja=43;else ja=45}else{f[i>>2]=f[j>>2];ja=43}if((ja|0)==43){ja=0;ha=f[B>>2]|0;if((ha|0)<3){f[K>>2]=ha;f[L>>2]=f[C>>2];f[z>>2]=f[A>>2];ha=f[y>>2]|0;fa=f[o>>2]|0;f[fa>>2]=f[ha>>2];f[fa+4>>2]=f[ha+4>>2]}else ja=45}if((ja|0)==45){ja=0;BR(i,j)}f[D>>2]=f[x>>2];f[q>>2]=f[w>>2];f[I>>2]=f[s>>2];f[G>>2]=f[H>>2];f[O>>2]=f[N>>2];ha=f[v>>2]|0;f[d>>2]=ha;if(ha|0?(fa=ha+12|0,ha=f[fa>>2]|0,f[fa>>2]=ha+-1,(ha|0)==1):0)CR(j);f[v>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[B>>2]|0)>0){ha=f[P>>2]|0;fa=0;do{f[ha+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[B>>2]|0))}fa=f[y>>2]|0;if((fa|0)!=(Q|0))ZF(fa);f[R>>2]=0;f[S>>2]=0;f[g>>2]=16842752;f[T>>2]=i;J=+zZ(g,4,fT()|0);fa=f[E>>2]|0;ha=p+((Y(fa+1|0,ga)|0)<<2)|0;n[ha>>2]=J*J;if((ea|0)<(f[t>>2]|0)){ha=ea;do{ka=Y(ha,r)|0;la=ha;ha=ha+1|0;ma=Y(ha,r)|0;f[g>>2]=-2147483648;f[U>>2]=2147483647;f[h>>2]=ka;f[V>>2]=ma;DR(k,c,g,h);f[W>>2]=0;f[X>>2]=0;f[j>>2]=16842752;f[Z>>2]=k;J=+YO(i,j);ma=p+((Y(f[t>>2]|0,ga)|0)+la<<2)|0;n[ma>>2]=J;ma=f[_>>2]|0;if(ma|0?(ka=ma+12|0,ma=f[ka>>2]|0,f[ka>>2]=ma+-1,(ma|0)==1):0)CR(k);f[_>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[aa>>2]|0)>0){ma=f[ba>>2]|0;ka=0;do{f[ma+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[aa>>2]|0))}ka=f[ca>>2]|0;if((ka|0)!=(da|0))ZF(ka);ka=f[t>>2]|0;ma=p+((Y(ka,ga)|0)+la<<2)|0;na=p+((Y(ka,la)|0)+ga<<2)|0;f[na>>2]=f[ma>>2]}while((ha|0)<(ka|0));oa=f[E>>2]|0}else oa=fa}while((ea|0)<(oa|0));oa=f[d>>2]|0;if((oa|0)!=0?(ea=oa+12|0,oa=f[ea>>2]|0,f[ea>>2]=oa+-1,(oa|0)==1):0){CR(i);pa=d}else pa=d}else pa=i+36|0;f[pa>>2]=0;pa=i+16|0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[K>>2]|0)>0){pa=f[m>>2]|0;m=0;do{f[pa+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[K>>2]|0))}K=f[o>>2]|0;if((K|0)!=(l|0))ZF(K);u=e;return}function bva(a){a=a|0;PYa(a);return}function cva(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0.0,t=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0.0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0,Db=0.0,Eb=0,Fb=0.0;e=u;u=u+1200|0;g=e+1184|0;i=e+136|0;j=e+80|0;k=e+16|0;l=e+24|0;m=e;o=e+8|0;_$(g,101356);q=a+32|0;r=f[q>>2]|0;s=+(r+-1|0)*.5;t=a+36|0;v=f[t>>2]|0;w=+(v+-1|0)*.5;x=f[a+4>>2]|0;y=f[a+8>>2]|0;z=f[a+12>>2]|0;A=((f[x>>2]|0)>>>3&511)+1|0;B=A<<1;C=Y(Y(r*3|0,v)|0,A)|0;D=i+8|0;f[i>>2]=D;E=i+4|0;f[E>>2]=C;if(C>>>0>520){F=OYa(C>>>0>2147483647?-1:C<<1)|0;f[i>>2]=F;G=F}else G=D;f[k>>2]=r;f[k+4>>2]=v;CN(j,k,(A<<3)+-5|0,G,0);G=f[q>>2]|0;f[m>>2]=G;k=f[t>>2]|0;f[m+4>>2]=k;CN(l,m,(A<<4)+-5|0,(f[i>>2]|0)+((Y(Y(k,A)|0,G)|0)<<1)|0,0);G=f[c>>2]|0;k=c+4|0;if((G|0)<(f[k>>2]|0)){c=a+16|0;m=a+56|0;v=a+60|0;r=a+64|0;F=a+20|0;C=a+24|0;H=a+28|0;I=z+12|0;J=z+8|0;K=z+48|0;N=x+48|0;O=y+48|0;P=x+16|0;Q=z+16|0;R=j+16|0;S=j+44|0;T=l+16|0;U=l+44|0;V=B|1;W=a+68|0;X=a+44|0;Z=y+12|0;_=y+8|0;$=y+16|0;aa=a+48|0;a=o+4|0;ba=A<<5;ca=G;do{G=f[c>>2]|0;da=f[m>>2]|0;ea=1.0/+(1<<da|0);fa=+n[G+(ca<<3)>>2]*ea;ga=+n[G+(ca<<3)+4>>2]*ea;if((da|0)==(f[v>>2]|0))if(!(f[r>>2]&4)){ha=f[F>>2]|0;ia=fa;ja=ga}else{ka=ea;la=17}else{ka=2.0;la=17}if((la|0)==17){la=0;G=f[F>>2]|0;ha=G;ia=ka*+n[G+(ca<<3)>>2];ja=ka*+n[G+(ca<<3)+4>>2]}G=ha+(ca<<3)|0;n[G>>2]=ia;ma=ha+(ca<<3)+4|0;n[ma>>2]=ja;ea=fa-s;fa=ga-w;na=~~ea;oa=na-(+(na|0)>ea&1)|0;na=~~fa;pa=na-(+(na|0)>fa&1)|0;na=f[q>>2]|0;a:do if((((oa|0)>=(0-na|0)?(oa|0)<(f[I>>2]|0):0)?(qa=f[t>>2]|0,(pa|0)>=(0-qa|0)):0)?(pa|0)<(f[J>>2]|0):0){ga=ea-+(oa|0);ra=fa-+(pa|0);sa=1.0-ga;ta=1.0-ra;ua=wNa(sa*ta*16384.0)|0;va=wNa(ga*ta*16384.0)|0;wa=wNa(ra*sa*16384.0)|0;xa=16384-ua-va-wa|0;ya=((f[K>>2]|0)>>>0)/((1212424721>>>(f[z>>2]<<2&28)&15)>>>0)|0;za=((f[N>>2]|0)>>>0)/((1212424721>>>(f[x>>2]<<2&28)&15)>>>0)|0;Aa=((f[O>>2]|0)>>>0)/((1212424721>>>(f[y>>2]<<2&28)&15)>>>0)|0;if((qa|0)>0){Ba=Y(oa,A)|0;Ca=Y(oa,B)|0;Da=ya+B|0;Ea=ya+1|0;Fa=Da+1|0;Ga=f[P>>2]|0;Ha=f[Q>>2]|0;Ia=f[R>>2]|0;Ja=f[f[S>>2]>>2]|0;Ka=f[T>>2]|0;La=f[f[U>>2]>>2]|0;Ma=Y(na,A)|0;Na=(Ma|0)>0;Oa=qa;sa=0.0;ra=0.0;ta=0.0;Pa=0;while(1){Qa=Pa+pa|0;Ra=Ga+(Y(Qa,za)|0)+Ba|0;Sa=Ia+(Y(Ja,Pa)|0)|0;if(Na){Ta=Ka+(Y(La,Pa)|0)|0;Ua=Ha+((Y(Qa,ya)|0)<<1)+(Ca<<1)|0;ga=sa;Va=ra;Wa=ta;Qa=0;while(1){Xa=Y(h[Ra+Qa>>0]|0,ua)|0;Ya=Y(h[Ra+(Qa+A)>>0]|0,va)|0;Za=Qa+za|0;_a=Y(h[Ra+Za>>0]|0,wa)|0;$a=(Xa+256+Ya+_a+(Y(h[Ra+(Za+A)>>0]|0,xa)|0)|0)>>>9;Za=Y(d[Ua>>1]|0,ua)|0;_a=Y(d[Ua+(B<<1)>>1]|0,va)|0;Ya=Y(d[Ua+(ya<<1)>>1]|0,wa)|0;Xa=Za+8192+_a+Ya+(Y(d[Ua+(Da<<1)>>1]|0,xa)|0)>>14;Ya=Y(d[Ua+2>>1]|0,ua)|0;_a=Y(d[Ua+(V<<1)>>1]|0,va)|0;Za=Y(d[Ua+(Ea<<1)>>1]|0,wa)|0;ab=Ya+8192+_a+Za+(Y(d[Ua+(Fa<<1)>>1]|0,xa)|0)>>14;d[Sa+(Qa<<1)>>1]=$a;d[Ta>>1]=Xa;d[Ta+2>>1]=ab;ga=ga+ +(Y(Xa,Xa)|0);Va=Va+ +(Y(ab,Xa)|0);Wa=Wa+ +(Y(ab,ab)|0);Qa=Qa+1|0;if((Qa|0)>=(Ma|0))break;else{Ta=Ta+4|0;Ua=Ua+4|0}}bb=f[t>>2]|0;cb=ga;db=Va;eb=Wa}else{bb=Oa;cb=sa;db=ra;eb=ta}Pa=Pa+1|0;if((Pa|0)>=(bb|0))break;else{Oa=bb;sa=cb;ra=db;ta=eb}}fb=bb;gb=f[q>>2]|0;hb=cb;ib=db;jb=eb}else{fb=qa;gb=na;hb=0.0;ib=0.0;jb=0.0}ta=hb*9.5367431640625e-07;ra=ib*9.5367431640625e-07;sa=jb*9.5367431640625e-07;kb=sa*ta-ra*ra;lb=ta-sa;mb=(sa+ta-+M(+(ra*(ra*4.0)+lb*lb)))/+(Y(fb<<1,gb)|0);Oa=f[H>>2]|0;if(Oa|0?f[r>>2]&8|0:0)n[Oa+(ca<<2)>>2]=mb;if(kb<1.1920928955078125e-07?1:mb<+n[W>>2]){if(da|0)break;Oa=f[C>>2]|0;if(!Oa)break;b[Oa+ca>>0]=0;break}mb=1.0/kb;Oa=f[X>>2]|0;b:do if((Oa|0)>0){Pa=0-gb|0;Ma=0-fb|0;xa=(fb|0)>0;Fa=Y(gb,A)|0;wa=(Fa|0)>0;kb=0.0;lb=0.0;Ea=0;nb=ia-s;ob=ja-w;c:while(1){va=~~nb;ua=va-(+(va|0)>nb&1)|0;va=~~ob;Da=va-(+(va|0)>ob&1)|0;if((ua|0)<(Pa|0))break;if((Da|0)<(Ma|0)?1:(ua|0)>=(f[Z>>2]|0))break;if((Da|0)>=(f[_>>2]|0))break;pb=nb-+(ua|0);qb=ob-+(Da|0);rb=1.0-pb;sb=1.0-qb;va=wNa(rb*sb*16384.0)|0;ya=wNa(pb*sb*16384.0)|0;za=wNa(rb*qb*16384.0)|0;Ca=16384-va-ya-za|0;do if(xa){Ha=f[$>>2]|0;La=Y(ua,A)|0;Ka=f[R>>2]|0;Na=f[f[S>>2]>>2]|0;Ja=f[T>>2]|0;Ia=f[f[U>>2]>>2]|0;if(wa){tb=0.0;ub=0.0;vb=0}else{wb=0.0;xb=0.0;break}while(1){Ba=Ha+(Y(vb+Da|0,Aa)|0)+La|0;Ga=Ka+(Y(Na,vb)|0)|0;Ua=Ja+(Y(Ia,vb)|0)|0;qb=tb;rb=ub;Ta=0;while(1){Qa=Y(h[Ba+Ta>>0]|0,va)|0;Sa=Y(h[Ba+(Ta+A)>>0]|0,ya)|0;Ra=Ta+Aa|0;ab=Y(h[Ba+Ra>>0]|0,za)|0;Xa=Qa+256+Sa+ab+(Y(h[Ba+(Ra+A)>>0]|0,Ca)|0)>>9;Ra=Xa-(d[Ga+(Ta<<1)>>1]|0)|0;qb=qb+ +(Y(Ra,d[Ua>>1]|0)|0);rb=rb+ +(Y(Ra,d[Ua+2>>1]|0)|0);Ta=Ta+1|0;if((Ta|0)>=(Fa|0))break;else Ua=Ua+4|0}vb=vb+1|0;if((vb|0)>=(fb|0)){wb=qb;xb=rb;break}else{tb=qb;ub=rb}}}else{wb=0.0;xb=0.0}while(0);sb=wb*9.5367431640625e-07;pb=xb*9.5367431640625e-07;yb=kb;kb=mb*(ra*pb-sa*sb);zb=lb;lb=mb*(ra*sb-ta*pb);nb=nb+kb;ob=ob+lb;Ab=s+nb;Bb=w+ob;n[G>>2]=Ab;n[ma>>2]=Bb;pb=kb;sb=lb;if(pb*pb+sb*sb<=+p[aa>>3]){la=61;break b}do if((Ea|0)>0){if(!(+L(+(yb+kb))<.01))break;if(+L(+(zb+lb))<.01){la=59;break c}}while(0);Ea=Ea+1|0;if((Ea|0)>=(Oa|0)){la=61;break b}}if((la|0)==59){la=0;n[G>>2]=Ab-kb*.5;n[ma>>2]=Bb-lb*.5;la=61;break}if(!da){Ea=f[C>>2]|0;if(!Ea)la=62;else{b[Ea+ca>>0]=0;la=61}}else la=61}else la=61;while(0);if((la|0)==61){la=0;Oa=f[C>>2]|0;if(!Oa)la=62;else Cb=Oa}if((la|0)==62){la=0;f[o>>2]=0;f[a>>2]=0;Oa=c$(o,12)|0;qa=347573;Ea=Oa+12|0;do{b[Oa>>0]=b[qa>>0]|0;Oa=Oa+1|0;qa=qa+1|0}while((Oa|0)<(Ea|0));j$(-215,o,373355,347586,657);d$(o);Cb=f[C>>2]|0}qa=Cb+ca|0;if(((b[qa>>0]|0?(Oa=f[H>>2]|0,Oa|0):0)?(f[m>>2]|0)==0:0)?(f[r>>2]&8|0)==0:0){Ea=f[F>>2]|0;ta=+n[Ea+(ca<<3)>>2]-s;ra=+n[Ea+(ca<<3)+4>>2]-w;Ea=~~ta;Fa=Ea-(+(Ea|0)>ta&1)|0;Ea=~~ra;wa=Ea-(+(Ea|0)>ra&1)|0;Ea=f[q>>2]|0;do if((Fa|0)>=(0-Ea|0)){if((Fa|0)>=(f[Z>>2]|0))break;xa=f[t>>2]|0;if((wa|0)<(0-xa|0))break;if((wa|0)>=(f[_>>2]|0))break;mb=ta-+(Fa|0);sa=ra-+(wa|0);ob=1.0-mb;nb=1.0-sa;Ma=wNa(ob*nb*16384.0)|0;Pa=wNa(mb*nb*16384.0)|0;Ca=wNa(ob*sa*16384.0)|0;za=16384-Ma-Pa-Ca|0;do if((xa|0)>0){ya=f[$>>2]|0;va=Y(Fa,A)|0;Da=f[R>>2]|0;ua=f[f[S>>2]>>2]|0;Ia=Y(Ea,A)|0;if((Ia|0)>0){Db=0.0;Eb=0}else{Fb=0.0;break}while(1){Ja=ya+(Y(Eb+wa|0,Aa)|0)+va|0;Na=Da+(Y(ua,Eb)|0)|0;sa=Db;Ka=0;do{La=Y(h[Ja+Ka>>0]|0,Ma)|0;Ha=Y(h[Ja+(Ka+A)>>0]|0,Pa)|0;Ua=Ka+Aa|0;Ta=Y(h[Ja+Ua>>0]|0,Ca)|0;Ga=La+256+Ha+Ta+(Y(h[Ja+(Ua+A)>>0]|0,za)|0)>>9;sa=sa+ +L(+(+(Ga-(d[Na+(Ka<<1)>>1]|0)|0)));Ka=Ka+1|0}while((Ka|0)<(Ia|0));Eb=Eb+1|0;if((Eb|0)>=(xa|0)){Fb=sa;break}else Db=sa}}else Fb=0.0;while(0);lb=Fb/+(Y(Y(ba,xa)|0,Ea)|0);n[Oa+(ca<<2)>>2]=lb;break a}while(0);if(Cb|0)b[qa>>0]=0}}else la=22;while(0);if((la|0)==22?(la=0,(da|0)==0):0){ma=f[C>>2]|0;if(ma|0)b[ma+ca>>0]=0;ma=f[H>>2]|0;if(ma|0)n[ma+(ca<<2)>>2]=0.0}ca=ca+1|0}while((ca|0)<(f[k>>2]|0))}k=l+36|0;ca=f[k>>2]|0;if(ca|0?(H=ca+12|0,ca=f[H>>2]|0,f[H>>2]=ca+-1,(ca|0)==1):0)CR(l);f[k>>2]=0;k=l+16|0;ca=l+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[ca>>2]|0)>0){k=f[l+40>>2]|0;H=0;do{f[k+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[ca>>2]|0))}ca=f[l+44>>2]|0;if((ca|0)!=(l+48|0))ZF(ca);ca=j+36|0;l=f[ca>>2]|0;if(l|0?(H=l+12|0,l=f[H>>2]|0,f[H>>2]=l+-1,(l|0)==1):0)CR(j);f[ca>>2]=0;ca=j+16|0;l=j+4|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[l>>2]|0)>0){ca=f[j+40>>2]|0;H=0;do{f[ca+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[l>>2]|0))}l=f[j+44>>2]|0;if((l|0)!=(j+48|0))ZF(l);l=f[i>>2]|0;if((l|0)!=(D|0)){if(l|0)QYa(l);f[i>>2]=D;f[E>>2]=520}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function dva(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0;k=u;u=u+368|0;l=k+312|0;m=k+304|0;n=k+248|0;o=k+192|0;p=k+64|0;q=k+136|0;r=k+120|0;s=k+32|0;t=k;_$(m,101376);do if((NS(a)|0)==65536){v=f[a+4>>2]|0;f[n>>2]=f[v>>2];w=n+4|0;x=v+4|0;f[w>>2]=f[x>>2];y=n+8|0;f[y>>2]=f[v+8>>2];f[n+12>>2]=f[v+12>>2];f[n+16>>2]=f[v+16>>2];f[n+20>>2]=f[v+20>>2];f[n+24>>2]=f[v+24>>2];f[n+28>>2]=f[v+28>>2];f[n+32>>2]=f[v+32>>2];z=f[v+36>>2]|0;f[n+36>>2]=z;f[n+40>>2]=y;y=n+48|0;A=n+44|0;f[A>>2]=y;f[y>>2]=0;f[n+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[v+44>>2]|0;y=f[A>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];B=n;break}else{f[w>>2]=0;BR(n,v);B=n;break}}else{OR(n,a,-1);B=n}while(0);if(!(((f[B>>2]&7|0)==0?(f[d>>2]|0)>2:0)?(f[d+4>>2]|0)>2:0)){f[l>>2]=0;f[l+4>>2]=0;a=c$(l,59)|0;v=347748;w=a+59|0;do{b[a>>0]=b[v>>0]|0;a=a+1|0;v=v+1|0}while((a|0)<(w|0));j$(-215,l,347808,347586,706);d$(l)}v=g?2:1;pS(c,1,Y(v,e+1|0)|0,0,-1,1,0);a=f[B>>2]|0;w=a<<1&8176|11;do if(j?(h&16|0)==0&(a&32768|0)!=0:0){f[l>>2]=0;x=l+4|0;f[x>>2]=0;f[o>>2]=0;y=o+4|0;f[y>>2]=0;KR(n,l,o);A=f[o>>2]|0;z=f[d>>2]|0;if((A|0)<(z|0)){C=38;break}D=f[y>>2]|0;y=f[d+4>>2]|0;if((D|0)<(y|0)){C=38;break}E=n+12|0;if((z+A+(f[E>>2]|0)|0)>(f[l>>2]|0)){C=38;break}A=n+8|0;if((y+D+(f[A>>2]|0)|0)>(f[x>>2]|0)){C=38;break}x=_S(c,0)|0;if((x|0)!=(n|0)){D=n+36|0;y=f[D>>2]|0;if(y|0){z=y+12|0;f[z>>2]=(f[z>>2]|0)+1}z=x+36|0;y=f[z>>2]|0;if(y|0?(F=y+12|0,y=f[F>>2]|0,f[F>>2]=y+-1,(y|0)==1):0)CR(x);f[z>>2]=0;y=x+16|0;F=x+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[F>>2]|0)>0){G=f[x+40>>2]|0;H=0;do{f[G+(H<<2)>>2]=0;H=H+1|0;I=f[F>>2]|0}while((H|0)<(I|0));f[x>>2]=f[B>>2];if((I|0)<3)C=29;else C=31}else{f[x>>2]=f[B>>2];C=29}if((C|0)==29){H=f[n+4>>2]|0;if((H|0)<3){f[F>>2]=H;f[x+8>>2]=f[A>>2];f[x+12>>2]=f[E>>2];H=f[n+44>>2]|0;G=f[x+44>>2]|0;f[G>>2]=f[H>>2];f[G+4>>2]=f[H+4>>2]}else C=31}if((C|0)==31)BR(x,n);f[y>>2]=f[n+16>>2];f[x+20>>2]=f[n+20>>2];f[x+24>>2]=f[n+24>>2];f[x+28>>2]=f[n+28>>2];f[x+32>>2]=f[n+32>>2];f[z>>2]=f[D>>2]}}else C=38;while(0);if((C|0)==38){I=_S(c,0)|0;a=I+16|0;if(f[a>>2]|0){j=f[I+4>>2]|0;if((j|0)<3)J=Y(f[I+12>>2]|0,f[I+8>>2]|0)|0;else{H=f[I+40>>2]|0;G=0;K=1;while(1){L=Y(f[H+(G<<2)>>2]|0,K)|0;G=G+1|0;if((G|0)==(j|0)){J=L;break}else K=L}}if(!((j|0)==0|(J|0)==0)){J=f[d+4>>2]|0;j=f[d>>2]|0;LR(I,J,J,j,j)|0}}j=f[I>>2]|0;J=f[B>>2]|0;K=n+12|0;G=f[K>>2]|0;if(!((J^j)&4095)){H=f[d>>2]|0;if(!((f[I+12>>2]|0)==((H<<1)+G|0)?(f[I+8>>2]|0)==((f[d+4>>2]<<1)+(f[n+8>>2]|0)|0):0)){M=H;C=49}}else{M=f[d>>2]|0;C=49}do if((C|0)==49){H=(f[d+4>>2]<<1)+(f[n+8>>2]|0)|0;L=(M<<1)+G|0;N=J&4095;if((((f[I+4>>2]|0)<3?(f[I+8>>2]|0)==(H|0):0)?(f[I+12>>2]|0)==(L|0):0)?!((j&4095|0)!=(N|0)|(f[a>>2]|0)==0):0)break;f[l>>2]=H;f[l+4>>2]=L;AR(I,2,l,N)}while(0);if((h|0)==5){a=d+4|0;j=f[a>>2]|0;J=f[K>>2]|0;K=f[n+8>>2]|0;f[p>>2]=f[d>>2];f[p+4>>2]=j;f[p+8>>2]=J;f[p+12>>2]=K;FR(o,I,p);K=l+8|0;f[K>>2]=0;f[K+4>>2]=0;f[l>>2]=-1040121856;f[l+4>>2]=o;eL(n,l);K=o+36|0;J=f[K>>2]|0;if(J|0?(j=J+12|0,J=f[j>>2]|0,f[j>>2]=J+-1,(J|0)==1):0)CR(o);f[K>>2]=0;K=o+16|0;J=o+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[J>>2]|0)>0){K=f[o+40>>2]|0;j=0;do{f[K+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[J>>2]|0))}J=f[o+44>>2]|0;if((J|0)!=(o+48|0))ZF(J);O=a;P=d}else{f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=n;a=o+8|0;f[a>>2]=0;f[a+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=I;a=d+4|0;J=f[a>>2]|0;j=f[d>>2]|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;f[p+28>>2]=0;mL(l,o,J,J,j,j,h,p);O=a;P=d}a=0-(f[O>>2]|0)|0;O=0-(f[P>>2]|0)|0;LR(I,a,a,O,O)|0}O=n+40|0;a=f[O>>2]|0;I=f[a>>2]|0;f[o>>2]=f[a+4>>2];a=o+4|0;f[a>>2]=I;I=_S(c,0)|0;f[p>>2]=f[I>>2];P=p+4|0;j=I+4|0;f[P>>2]=f[j>>2];J=p+8|0;f[J>>2]=f[I+8>>2];K=p+12|0;f[K>>2]=f[I+12>>2];G=p+16|0;f[G>>2]=f[I+16>>2];M=p+20|0;f[M>>2]=f[I+20>>2];N=p+24|0;f[N>>2]=f[I+24>>2];L=p+28|0;f[L>>2]=f[I+28>>2];H=p+32|0;f[H>>2]=f[I+32>>2];Q=p+36|0;R=f[I+36>>2]|0;f[Q>>2]=R;S=p+40|0;f[S>>2]=J;T=p+48|0;U=p+44|0;f[U>>2]=T;f[T>>2]=0;f[p+52>>2]=0;if(R|0){V=R+12|0;f[V>>2]=(f[V>>2]|0)+1}if((f[j>>2]|0)<3){j=f[I+44>>2]|0;V=f[U>>2]|0;f[V>>2]=f[j>>2];f[V+4>>2]=f[j+4>>2]}else{f[P>>2]=0;BR(p,I)}f[q>>2]=f[p>>2];I=q+4|0;j=f[P>>2]|0;f[I>>2]=j;V=q+8|0;f[V>>2]=f[J>>2];R=q+12|0;f[R>>2]=f[K>>2];W=q+16|0;f[W>>2]=f[G>>2];X=q+20|0;f[X>>2]=f[M>>2];Z=q+24|0;f[Z>>2]=f[N>>2];_=q+28|0;f[_>>2]=f[L>>2];$=q+32|0;f[$>>2]=f[H>>2];aa=q+36|0;ba=f[Q>>2]|0;f[aa>>2]=ba;ca=q+40|0;f[ca>>2]=V;da=q+48|0;ea=q+44|0;f[ea>>2]=da;f[da>>2]=0;f[q+52>>2]=0;if(!ba)fa=j;else{j=ba+12|0;f[j>>2]=(f[j>>2]|0)+1;fa=f[P>>2]|0}if((fa|0)<3){fa=f[U>>2]|0;j=f[ea>>2]|0;f[j>>2]=f[fa>>2];f[j+4>>2]=f[fa+4>>2]}else{f[I>>2]=0;BR(q,p)}a:do if((e|0)<0)ga=e;else{fa=d+4|0;j=r+4|0;ba=r+8|0;ha=r+12|0;ia=(i|0)==5;ja=l+36|0;ka=l+16|0;la=l+4|0;ma=l+40|0;na=l+44|0;oa=l+48|0;pa=r+8|0;qa=r+12|0;ra=r+4|0;sa=s+8|0;ta=s+4|0;ua=i|16;va=w&4091;wa=l+4|0;xa=r+4|0;ya=r+8|0;za=r+12|0;Aa=l+36|0;Ba=l+4|0;Ca=l+8|0;Da=l+12|0;Ea=l+44|0;Fa=l+16|0;Ga=l+20|0;Ha=l+24|0;Ia=l+28|0;Ja=l+32|0;Ka=l+40|0;La=l+48|0;Ma=l+8|0;Na=l+12|0;Oa=l+4|0;Pa=r+8|0;Qa=r+4|0;Ra=(h|0)==5;Sa=l+8|0;Ta=l+12|0;Ua=l+4|0;Va=r+8|0;Wa=r+4|0;Xa=h|16;Ya=0;while(1){if(Ya|0){Za=_S(c,Y(Ya,v)|0)|0;_a=Za+16|0;if(f[_a>>2]|0){$a=f[Za+4>>2]|0;if(($a|0)<3)ab=Y(f[Za+12>>2]|0,f[Za+8>>2]|0)|0;else{bb=f[Za+40>>2]|0;cb=0;db=1;while(1){eb=Y(f[bb+(cb<<2)>>2]|0,db)|0;cb=cb+1|0;if((cb|0)==($a|0)){ab=eb;break}else db=eb}}if(!(($a|0)==0|(ab|0)==0)){db=f[fa>>2]|0;cb=f[d>>2]|0;LR(Za,db,db,cb,cb)|0}}cb=f[Za>>2]|0;db=f[B>>2]|0;bb=f[o>>2]|0;if(!((db^cb)&4095)){eb=f[d>>2]|0;if((f[Za+12>>2]|0)==((eb<<1)+bb|0)?(fb=f[fa>>2]|0,gb=f[a>>2]|0,(f[Za+8>>2]|0)==((fb<<1)+gb|0)):0){hb=eb;ib=fb;jb=bb;kb=gb}else{lb=eb;C=90}}else{lb=f[d>>2]|0;C=90}do if((C|0)==90){C=0;eb=f[a>>2]|0;gb=f[fa>>2]|0;fb=(gb<<1)+eb|0;mb=(lb<<1)+bb|0;nb=db&4095;if((((f[Za+4>>2]|0)<3?(f[Za+8>>2]|0)==(fb|0):0)?(f[Za+12>>2]|0)==(mb|0):0)?!((cb&4095|0)!=(nb|0)|(f[_a>>2]|0)==0):0){hb=lb;ib=gb;jb=bb;kb=eb;break}f[l>>2]=fb;f[wa>>2]=mb;AR(Za,2,l,nb);hb=f[d>>2]|0;ib=f[fa>>2]|0;jb=f[o>>2]|0;kb=f[a>>2]|0}while(0);f[r>>2]=hb;f[xa>>2]=ib;f[ya>>2]=jb;f[za>>2]=kb;FR(l,Za,r);bb=f[Aa>>2]|0;if(bb|0){_a=bb+12|0;f[_a>>2]=(f[_a>>2]|0)+1}_a=f[aa>>2]|0;if(_a|0?(bb=_a+12|0,_a=f[bb>>2]|0,f[bb>>2]=_a+-1,(_a|0)==1):0)CR(q);f[aa>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[I>>2]|0)>0){_a=f[ca>>2]|0;bb=0;do{f[_a+(bb<<2)>>2]=0;bb=bb+1|0;ob=f[I>>2]|0}while((bb|0)<(ob|0));f[q>>2]=f[l>>2];if((ob|0)<3)C=105;else C=107}else{f[q>>2]=f[l>>2];C=105}if((C|0)==105){C=0;bb=f[Ba>>2]|0;if((bb|0)<3){f[I>>2]=bb;f[V>>2]=f[Ca>>2];f[R>>2]=f[Da>>2];bb=f[Ea>>2]|0;_a=f[ea>>2]|0;f[_a>>2]=f[bb>>2];f[_a+4>>2]=f[bb+4>>2]}else C=107}if((C|0)==107){C=0;BR(q,l)}f[W>>2]=f[Fa>>2];f[X>>2]=f[Ga>>2];f[Z>>2]=f[Ha>>2];f[_>>2]=f[Ia>>2];f[$>>2]=f[Ja>>2];bb=f[Aa>>2]|0;f[aa>>2]=bb;if(bb|0?(_a=bb+12|0,bb=f[_a>>2]|0,f[_a>>2]=bb+-1,(bb|0)==1):0)CR(l);f[Aa>>2]=0;f[Fa>>2]=0;f[Fa+4>>2]=0;f[Fa+8>>2]=0;f[Fa+12>>2]=0;if((f[Ba>>2]|0)>0){bb=f[Ka>>2]|0;_a=0;do{f[bb+(_a<<2)>>2]=0;_a=_a+1|0}while((_a|0)<(f[Ba>>2]|0))}_a=f[Ea>>2]|0;if((_a|0)!=(La|0))ZF(_a);f[Ma>>2]=0;f[Na>>2]=0;f[l>>2]=16842752;f[Oa>>2]=p;_a=Pa;f[_a>>2]=0;f[_a+4>>2]=0;f[r>>2]=33619968;f[Qa>>2]=q;fka(l,r,o,4);if(!Ra){f[Sa>>2]=0;f[Ta>>2]=0;f[l>>2]=16842752;f[Ua>>2]=q;_a=Va;f[_a>>2]=0;f[_a+4>>2]=0;f[r>>2]=33619968;f[Wa>>2]=Za;_a=f[fa>>2]|0;bb=f[d>>2]|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[s+16>>2]=0;f[s+20>>2]=0;f[s+24>>2]=0;f[s+28>>2]=0;mL(l,r,_a,_a,bb,bb,Xa,s)}bb=0-(f[fa>>2]|0)|0;_a=0-(f[d>>2]|0)|0;LR(Za,bb,bb,_a,_a)|0}if(g){_a=_S(c,(Y(Ya,v)|0)+1|0)|0;bb=_a+16|0;if(f[bb>>2]|0){cb=f[_a+4>>2]|0;if((cb|0)<3)pb=Y(f[_a+12>>2]|0,f[_a+8>>2]|0)|0;else{db=f[_a+40>>2]|0;$a=0;nb=1;while(1){mb=Y(f[db+($a<<2)>>2]|0,nb)|0;$a=$a+1|0;if(($a|0)==(cb|0)){pb=mb;break}else nb=mb}}if(!((cb|0)==0|(pb|0)==0)){nb=f[fa>>2]|0;$a=f[d>>2]|0;LR(_a,nb,nb,$a,$a)|0}}$a=f[_a>>2]&4095;nb=f[o>>2]|0;if(($a|0)==(w|0)){db=f[d>>2]|0;if((f[_a+12>>2]|0)==((db<<1)+nb|0)?(Za=f[fa>>2]|0,mb=f[a>>2]|0,(f[_a+8>>2]|0)==((Za<<1)+mb|0)):0){qb=db;rb=Za;sb=nb;tb=mb}else{ub=db;C=131}}else{ub=f[d>>2]|0;C=131}do if((C|0)==131){C=0;db=f[a>>2]|0;mb=f[fa>>2]|0;Za=(mb<<1)+db|0;fb=(ub<<1)+nb|0;if((((f[_a+4>>2]|0)<3?(f[_a+8>>2]|0)==(Za|0):0)?(f[_a+12>>2]|0)==(fb|0):0)?!(($a|0)!=(va|0)|(f[bb>>2]|0)==0):0){qb=ub;rb=mb;sb=nb;tb=db;break}f[l>>2]=Za;f[wa>>2]=fb;AR(_a,2,l,va);qb=f[d>>2]|0;rb=f[fa>>2]|0;sb=f[o>>2]|0;tb=f[a>>2]|0}while(0);f[r>>2]=qb;f[j>>2]=rb;f[ba>>2]=sb;f[ha>>2]=tb;FR(l,_a,r);eva(q,l);if(!ia){f[pa>>2]=0;f[qa>>2]=0;f[r>>2]=16842752;f[ra>>2]=l;nb=sa;f[nb>>2]=0;f[nb+4>>2]=0;f[s>>2]=33619968;f[ta>>2]=_a;nb=f[fa>>2]|0;bb=f[d>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=0;f[t+20>>2]=0;f[t+24>>2]=0;f[t+28>>2]=0;mL(r,s,nb,nb,bb,bb,ua,t)}bb=0-(f[fa>>2]|0)|0;nb=0-(f[d>>2]|0)|0;LR(_a,bb,bb,nb,nb)|0;nb=f[ja>>2]|0;if(nb|0?(bb=nb+12|0,nb=f[bb>>2]|0,f[bb>>2]=nb+-1,(nb|0)==1):0)CR(l);f[ja>>2]=0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;if((f[la>>2]|0)>0){nb=f[ma>>2]|0;bb=0;do{f[nb+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[la>>2]|0))}bb=f[na>>2]|0;if((bb|0)!=(oa|0))ZF(bb)}bb=((f[o>>2]|0)+1|0)/2|0;nb=((f[a>>2]|0)+1|0)/2|0;f[o>>2]=bb;f[a>>2]=nb;if((bb|0)<=(f[d>>2]|0))break;if((nb|0)<=(f[fa>>2]|0))break;nb=f[aa>>2]|0;if(nb|0){bb=nb+12|0;f[bb>>2]=(f[bb>>2]|0)+1}bb=f[Q>>2]|0;if(bb|0?(nb=bb+12|0,bb=f[nb>>2]|0,f[nb>>2]=bb+-1,(bb|0)==1):0)CR(p);f[Q>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[P>>2]|0)>0){bb=f[S>>2]|0;nb=0;do{f[bb+(nb<<2)>>2]=0;nb=nb+1|0;vb=f[P>>2]|0}while((nb|0)<(vb|0));f[p>>2]=f[q>>2];if((vb|0)<3)C=160;else C=162}else{f[p>>2]=f[q>>2];C=160}if((C|0)==160){C=0;nb=f[I>>2]|0;if((nb|0)<3){f[P>>2]=nb;f[J>>2]=f[V>>2];f[K>>2]=f[R>>2];nb=f[ea>>2]|0;bb=f[U>>2]|0;f[bb>>2]=f[nb>>2];f[bb+4>>2]=f[nb+4>>2]}else C=162}if((C|0)==162){C=0;BR(p,q)}f[G>>2]=f[W>>2];f[M>>2]=f[X>>2];f[N>>2]=f[Z>>2];f[L>>2]=f[_>>2];f[H>>2]=f[$>>2];f[Q>>2]=f[aa>>2];if((Ya|0)<(e|0))Ya=Ya+1|0;else{ga=e;break a}}pS(c,1,Y(Ya+1|0,v)|0,0,-1,1,0);ga=Ya}while(0);v=f[aa>>2]|0;if(v|0?(c=v+12|0,v=f[c>>2]|0,f[c>>2]=v+-1,(v|0)==1):0)CR(q);f[aa>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[I>>2]|0)>0){W=f[ca>>2]|0;ca=0;do{f[W+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[I>>2]|0))}I=f[ea>>2]|0;if((I|0)!=(da|0))ZF(I);I=f[Q>>2]|0;if(I|0?(da=I+12|0,I=f[da>>2]|0,f[da>>2]=I+-1,(I|0)==1):0)CR(p);f[Q>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[P>>2]|0)>0){G=f[S>>2]|0;S=0;do{f[G+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[P>>2]|0))}P=f[U>>2]|0;if((P|0)!=(T|0))ZF(P);P=n+36|0;T=f[P>>2]|0;if(T|0?(U=T+12|0,T=f[U>>2]|0,f[U>>2]=T+-1,(T|0)==1):0)CR(n);f[P>>2]=0;P=n+16|0;T=n+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[T>>2]|0)>0){P=f[O>>2]|0;O=0;do{f[P+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[T>>2]|0))}T=f[n+44>>2]|0;if((T|0)!=(n+48|0))ZF(T);if(!(f[m+4>>2]|0)){u=k;return ga|0}u=k;return ga|0}function eva(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=u;u=u+1056|0;g=e;i=f[a+8>>2]|0;k=f[a+12>>2]|0;l=f[a>>2]|0;m=(l>>>3&511)+1|0;n=Y(m,k)|0;if(l&7|0){f[g>>2]=0;f[g+4>>2]=0;l=c$(g,10)|0;o=347832;p=l+10|0;do{b[l>>0]=b[o>>0]|0;l=l+1|0;o=o+1|0}while((l|0)<(p|0));j$(-215,g,347843,347586,60);d$(g)}o=(m<<4)+4091&4091;if(!(((((f[c+4>>2]|0)<3?(f[c+8>>2]|0)==(i|0):0)?(f[c+12>>2]|0)==(k|0):0)?(f[c>>2]&4095|0)==(o|0):0)?(f[c+16>>2]|0)!=0:0)){f[g>>2]=i;f[g+4>>2]=k;AR(c,2,g,o)}o=(Y(m,k+2|0)|0)+15&-16;l=(o<<1)+64|0;p=g+8|0;f[g>>2]=p;q=g+4|0;f[q>>2]=l;if(l>>>0>520){r=OYa(l>>>0>2147483647?-1:l<<1)|0;f[g>>2]=r;s=r}else s=p;r=s+(m<<1)+15&-16;l=r+(o<<1)|0;if((i|0)>0){o=(i|0)!=1;t=o&1;v=i+-1|0;w=o?i+-2|0:0;o=(n|0)>0;x=(k|0)>1;y=x?m:0;z=Y(m,x?k+-2|0:0)|0;k=f[a+16>>2]|0;x=f[f[a+44>>2]>>2]|0;a=f[c+16>>2]|0;A=f[f[c+44>>2]>>2]|0;c=0;do{B=k+(Y(x,(c|0)>0?c+-1|0:t)|0)|0;C=k+(Y(x,c)|0)|0;D=c;c=c+1|0;E=k+(Y(x,(D|0)<(v|0)?c:w)|0)|0;F=a+(Y(A,D)|0)|0;if(o){D=0;do{G=h[B+D>>0]|0;H=h[E+D>>0]|0;d[r+(D<<1)>>1]=((H+G|0)*3|0)+((h[C+D>>0]|0)*10|0);d[l+(D<<1)>>1]=H-G;D=D+1|0}while((D|0)!=(n|0));I=0}else I=0;do{D=I+y|0;C=I-m|0;d[r+(C<<1)>>1]=d[r+(D<<1)>>1]|0;E=I+z|0;B=I+n|0;d[r+(B<<1)>>1]=d[r+(E<<1)>>1]|0;d[l+(C<<1)>>1]=d[l+(D<<1)>>1]|0;d[l+(B<<1)>>1]=d[l+(E<<1)>>1]|0;I=I+1|0}while((I|0)!=(m|0));if(o){E=0;do{B=E+m|0;D=E-m|0;C=(((d[l+(D<<1)>>1]|0)+(d[l+(B<<1)>>1]|0)|0)*3|0)+((d[l+(E<<1)>>1]|0)*10|0)&65535;G=E<<1;d[F+(G<<1)>>1]=(j[r+(B<<1)>>1]|0)-(j[r+(D<<1)>>1]|0);d[F+((G|1)<<1)>>1]=C;E=E+1|0}while((E|0)!=(n|0))}}while((c|0)!=(i|0))}if((s|0)==(p|0)){u=e;return}QYa(s);f[g>>2]=p;f[q>>2]=520;u=e;return}function fva(a){a=a|0;PYa(a);return}function gva(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function hva(a){a=a|0;OF(a);PYa(a);return}function iva(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0.0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0;j=u;u=u+576|0;k=j+512|0;l=j+504|0;m=j+448|0;o=j+440|0;q=j+384|0;r=j+328|0;s=j+272|0;t=j+244|0;v=j+232|0;w=j+176|0;x=j+120|0;y=j+264|0;z=j+256|0;A=j+32|0;B=j+104|0;C=j;_$(l,101500);do if((NS(e)|0)==65536){D=f[e+4>>2]|0;f[m>>2]=f[D>>2];E=m+4|0;F=D+4|0;f[E>>2]=f[F>>2];G=m+8|0;f[G>>2]=f[D+8>>2];f[m+12>>2]=f[D+12>>2];f[m+16>>2]=f[D+16>>2];f[m+20>>2]=f[D+20>>2];f[m+24>>2]=f[D+24>>2];f[m+28>>2]=f[D+28>>2];f[m+32>>2]=f[D+32>>2];H=f[D+36>>2]|0;f[m+36>>2]=H;f[m+40>>2]=G;G=m+48|0;I=m+44|0;f[I>>2]=G;f[G>>2]=0;f[m+52>>2]=0;if(H|0){G=H+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[F>>2]|0)<3){F=f[D+44>>2]|0;G=f[I>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=f[F+4>>2];break}else{f[E>>2]=0;BR(m,D);break}}else OR(m,e,-1);while(0);e=a+12|0;if(!(((f[e>>2]|0)>-1?(f[a+4>>2]|0)>2:0)?(f[a+8>>2]|0)>2:0)){f[k>>2]=0;f[k+4>>2]=0;J=c$(k,56)|0;K=348056;L=J+56|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));j$(-215,k,349552,347586,1241);d$(k)}D=LS(m,2,5,1)|0;if((D|0)>-1)if(!D){oS(g);oS(h);oS(i)}else M=16;else{f[k>>2]=0;f[k+4>>2]=0;J=c$(k,51)|0;K=348113;L=J+51|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));j$(-215,k,349552,347586,1244);d$(k);M=16}if((M|0)==16){E=a+32|0;if(!(f[E>>2]&4)){F=f[m+40>>2]|0;G=f[F>>2]|0;f[o>>2]=f[F+4>>2];f[o+4>>2]=G;KS(g,o,f[m>>2]&4095,-1,1,0)}do if((NS(g)|0)==65536){o=f[g+4>>2]|0;f[q>>2]=f[o>>2];G=q+4|0;F=o+4|0;f[G>>2]=f[F>>2];I=q+8|0;f[I>>2]=f[o+8>>2];f[q+12>>2]=f[o+12>>2];f[q+16>>2]=f[o+16>>2];f[q+20>>2]=f[o+20>>2];f[q+24>>2]=f[o+24>>2];f[q+28>>2]=f[o+28>>2];f[q+32>>2]=f[o+32>>2];H=f[o+36>>2]|0;f[q+36>>2]=H;f[q+40>>2]=I;I=q+48|0;N=q+44|0;f[N>>2]=I;f[I>>2]=0;f[q+52>>2]=0;if(H|0){I=H+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[F>>2]|0)<3){F=f[o+44>>2]|0;I=f[N>>2]|0;f[I>>2]=f[F>>2];f[I+4>>2]=f[F+4>>2];break}else{f[G>>2]=0;BR(q,o);break}}else OR(q,g,-1);while(0);if((LS(q,2,5,1)|0)!=(D|0)){f[k>>2]=0;f[k+4>>2]=0;J=c$(k,45)|0;K=348165;L=J+45|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));j$(-215,k,349552,347586,1258);d$(k)}g=f[m+16>>2]|0;o=q+16|0;G=f[o>>2]|0;F=q+44|0;pS(h,D,1,0,-1,1,0);do if((NS(h)|0)==65536){I=f[h+4>>2]|0;f[r>>2]=f[I>>2];N=r+4|0;H=I+4|0;f[N>>2]=f[H>>2];O=r+8|0;f[O>>2]=f[I+8>>2];f[r+12>>2]=f[I+12>>2];f[r+16>>2]=f[I+16>>2];f[r+20>>2]=f[I+20>>2];f[r+24>>2]=f[I+24>>2];f[r+28>>2]=f[I+28>>2];f[r+32>>2]=f[I+32>>2];P=f[I+36>>2]|0;f[r+36>>2]=P;f[r+40>>2]=O;O=r+48|0;Q=r+44|0;f[Q>>2]=O;f[O>>2]=0;f[r+52>>2]=0;if(P|0){O=P+12|0;f[O>>2]=(f[O>>2]|0)+1}if((f[H>>2]|0)<3){H=f[I+44>>2]|0;O=f[Q>>2]|0;f[O>>2]=f[H>>2];f[O+4>>2]=f[H+4>>2];R=r;break}else{f[N>>2]=0;BR(r,I);R=r;break}}else{OR(r,h,-1);R=r}while(0);f[s>>2]=1124007936;h=s+4|0;I=s+8|0;N=s+40|0;J=h;L=J+36|0;do{f[J>>2]=0;J=J+4|0}while((J|0)<(L|0));f[N>>2]=I;H=s+48|0;O=s+44|0;f[O>>2]=H;f[H>>2]=0;f[s+52>>2]=0;if(!(f[R>>2]&16384)){f[k>>2]=0;f[k+4>>2]=0;J=c$(k,24)|0;K=348211;L=J+24|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));j$(-215,k,349552,347586,1265);d$(k)}R=r+16|0;Q=f[R>>2]|0;P=r+44|0;if((D|0)>0)F1a(Q|0,1,D|0)|0;if(dT(i)|0){pS(i,D,1,5,-1,1,0);do if((NS(i)|0)==65536){S=f[i+4>>2]|0;f[k>>2]=f[S>>2];T=k+4|0;U=S+4|0;f[T>>2]=f[U>>2];V=k+8|0;f[V>>2]=f[S+8>>2];f[k+12>>2]=f[S+12>>2];f[k+16>>2]=f[S+16>>2];f[k+20>>2]=f[S+20>>2];f[k+24>>2]=f[S+24>>2];f[k+28>>2]=f[S+28>>2];f[k+32>>2]=f[S+32>>2];W=k+36|0;X=f[S+36>>2]|0;f[W>>2]=X;f[k+40>>2]=V;V=k+48|0;Z=k+44|0;f[Z>>2]=V;f[V>>2]=0;f[k+52>>2]=0;if(X|0){V=X+12|0;f[V>>2]=(f[V>>2]|0)+1}if((f[U>>2]|0)<3){U=f[S+44>>2]|0;V=f[Z>>2]|0;f[V>>2]=f[U>>2];f[V+4>>2]=f[U+4>>2];_=W;break}else{f[T>>2]=0;BR(k,S);_=W;break}}else{OR(k,i,-1);_=k+36|0}while(0);i=f[_>>2]|0;if(i|0){W=i+12|0;f[W>>2]=(f[W>>2]|0)+1}W=s+36|0;i=f[W>>2]|0;if(i|0?(S=i+12|0,i=f[S>>2]|0,f[S>>2]=i+-1,(i|0)==1):0)CR(s);f[W>>2]=0;i=s+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[h>>2]|0)>0){S=f[N>>2]|0;T=0;do{f[S+(T<<2)>>2]=0;T=T+1|0;$=f[h>>2]|0}while((T|0)<($|0));f[s>>2]=f[k>>2];if(($|0)<3)M=56;else M=58}else{f[s>>2]=f[k>>2];M=56}if((M|0)==56){$=f[k+4>>2]|0;if(($|0)<3){f[h>>2]=$;f[I>>2]=f[k+8>>2];f[s+12>>2]=f[k+12>>2];I=f[k+44>>2]|0;$=f[O>>2]|0;f[$>>2]=f[I>>2];f[$+4>>2]=f[I+4>>2]}else M=58}if((M|0)==58)BR(s,k);I=k+16|0;f[i>>2]=f[I>>2];f[s+20>>2]=f[k+20>>2];f[s+24>>2]=f[k+24>>2];f[s+28>>2]=f[k+28>>2];f[s+32>>2]=f[k+32>>2];$=f[_>>2]|0;f[W>>2]=$;if($|0?(W=$+12|0,$=f[W>>2]|0,f[W>>2]=$+-1,($|0)==1):0)CR(k);f[_>>2]=0;_=k+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[_>>2]|0)>0){I=f[k+40>>2]|0;$=0;do{f[I+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[_>>2]|0))}_=f[k+44>>2]|0;if((_|0)!=(k+48|0))ZF(_);if(!(f[s>>2]&16384)){f[k>>2]=0;f[k+4>>2]=0;J=c$(k,21)|0;K=348236;L=J+21|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));j$(-215,k,349552,347586,1276);d$(k)}aa=f[i>>2]|0}else aa=0;f[t>>2]=0;i=t+4|0;f[i>>2]=0;f[t+8>>2]=0;f[v>>2]=0;_=v+4|0;f[_>>2]=0;f[v+8>>2]=0;if((NS(c)|0)==327680){PS(c,t);$=(f[i>>2]|0)-(f[t>>2]|0)|0;i=(($|0)/56|0)+-1|0;if(($|0)<=0){f[k>>2]=0;f[k+4>>2]=0;J=c$(k,12)|0;K=348258;L=J+12|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));j$(-215,k,349552,347586,1291);d$(k)}if(((i|0)%2|0|0)==1?($=f[t>>2]|0,I=f[$+56>>2]|0,(I&7|0)==3?((f[$>>2]|0)>>>2&1022|1|0)==(I>>>3&511|0):0):0){ba=(i|0)/2|0;ca=2}else{ba=i;ca=1}if((ba|0)>0){f[k>>2]=0;i=k+4|0;f[i>>2]=0;f[w>>2]=0;I=w+4|0;f[I>>2]=0;KR((f[t>>2]|0)+(ca*56|0)|0,k,w);$=f[w>>2]|0;W=f[a+4>>2]|0;do if(($|0)>=(W|0)?(T=f[I>>2]|0,S=f[a+8>>2]|0,(T|0)>=(S|0)):0){U=f[t>>2]|0;if((W+$+(f[U+(ca*56|0)+12>>2]|0)|0)>(f[k>>2]|0)){M=81;break}if((S+T+(f[U+(ca*56|0)+8>>2]|0)|0)>(f[i>>2]|0))M=81}else M=81;while(0);if((M|0)==81){f[x>>2]=0;f[x+4>>2]=0;K1a(c$(x,187)|0,348271,187)|0;j$(-215,x,349552,347586,1307);d$(x)}}if((ba|0)<(f[e>>2]|0)){f[e>>2]=ba;da=ba;ea=ca}else{da=ba;ea=ca}}else{da=-1;ea=1}if((NS(d)|0)==327680){PS(d,v);ca=(f[_>>2]|0)-(f[v>>2]|0)|0;_=((ca|0)/56|0)+-1|0;if((ca|0)<=0){f[k>>2]=0;f[k+4>>2]=0;J=c$(k,12)|0;K=348459;L=J+12|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));j$(-215,k,349552,347586,1319);d$(k)}if(((_|0)%2|0|0)==1?(ca=f[v>>2]|0,ba=f[ca+56>>2]|0,(ba&7|0)==3?((f[ca>>2]|0)>>>2&1022|1|0)==(ba>>>3&511|0):0):0){fa=(_|0)/2|0;ga=2}else{fa=_;ga=1}if((fa|0)>0){f[k>>2]=0;_=k+4|0;f[_>>2]=0;f[w>>2]=0;ba=w+4|0;f[ba>>2]=0;KR((f[v>>2]|0)+(ga*56|0)|0,k,w);ca=f[w>>2]|0;i=f[a+4>>2]|0;do if((ca|0)>=(i|0)){$=f[ba>>2]|0;W=f[a+8>>2]|0;if(($|0)<(W|0)){M=96;break}I=f[v>>2]|0;if((i+ca+(f[I+(ga*56|0)+12>>2]|0)|0)>(f[k>>2]|0)){M=96;break}if((W+$+(f[I+(ga*56|0)+8>>2]|0)|0)>(f[_>>2]|0))M=96}else M=96;while(0);if((M|0)==96){f[x>>2]=0;f[x+4>>2]=0;K1a(c$(x,187)|0,348472,187)|0;j$(-215,x,349552,347586,1335);d$(x)}}if((fa|0)<(f[e>>2]|0)){f[e>>2]=fa;ha=fa;ia=ga}else{ha=fa;ia=ga}}else{ha=-1;ia=1}if((da|0)<0){da=k+8|0;f[da>>2]=0;f[da+4>>2]=0;f[k>>2]=33882112;f[k+4>>2]=t;f[y>>2]=f[a+4>>2];f[y+4>>2]=f[a+8>>2];da=dva(c,k,y,f[e>>2]|0,0,4,0,1)|0;f[e>>2]=da}if((ha|0)<0){ha=k+8|0;f[ha>>2]=0;f[ha+4>>2]=0;f[k>>2]=33882112;f[k+4>>2]=v;f[z>>2]=f[a+4>>2];f[z+4>>2]=f[a+8>>2];ha=dva(d,k,z,f[e>>2]|0,0,4,0,1)|0;f[e>>2]=ha}ha=a+16|0;z=f[ha>>2]|0;d=a+20|0;if(!(z&1))ja=30;else{da=f[d>>2]|0;y=(da|0)>0?da:0;ja=(y|0)<100?y:100}f[d>>2]=ja;ja=a+24|0;if(!(z&2))ka=.01;else{la=+p[ja>>3];ma=la<0.0?0.0:la;ka=ma>10.0?10.0:ma}p[ja>>3]=ka*ka;f[w>>2]=1124007936;ja=w+4|0;z=w+8|0;d=w+40|0;J=ja;L=J+36|0;do{f[J>>2]=0;J=J+4|0}while((J|0)<(L|0));f[d>>2]=z;z=w+48|0;y=w+44|0;f[y>>2]=z;f[z>>2]=0;f[w+52>>2]=0;da=(ea|0)==1;if(da){c=f[t>>2]|0;ga=(f[a+4>>2]<<1)+(f[c+12>>2]|0)|0;fa=f[c>>2]<<1&4080|11;f[k>>2]=(f[a+8>>2]<<1)+(f[c+8>>2]|0);f[k+4>>2]=ga;AR(w,2,k,fa)}fa=f[e>>2]|0;if((fa|0)>-1){ga=k+4|0;c=k+8|0;_=k+40|0;ca=k+48|0;i=k+44|0;ba=k+52|0;I=a+8|0;$=a+4|0;W=w+16|0;U=B+4|0;T=B+8|0;S=B+12|0;V=A+36|0;Z=k+36|0;X=k+16|0;na=A+4|0;oa=A+8|0;pa=A+12|0;qa=k+12|0;ra=A+44|0;sa=A+16|0;ta=A+20|0;ua=k+20|0;va=A+24|0;wa=k+24|0;xa=A+28|0;ya=k+28|0;za=A+32|0;Aa=k+32|0;Ba=A+40|0;Ca=A+48|0;Da=A+8|0;Ea=A+12|0;Fa=A+4|0;Ga=B+8|0;Ha=B+4|0;Ia=x+36|0;Ja=x+16|0;Ka=x+4|0;La=x+40|0;Ma=x+44|0;Na=x+48|0;Oa=x+4|0;Pa=a+40|0;a=A+32|0;Qa=A+36|0;Ra=A+40|0;Sa=A+4|0;Ta=A+12|0;Ua=A+8|0;Va=A+16|0;Wa=A+20|0;Xa=A+24|0;Ya=A+28|0;Za=A+56|0;_a=A+60|0;$a=A+64|0;ab=A+68|0;bb=x+4|0;cb=x+4|0;db=fa;while(1){f[k>>2]=1124007936;J=ga;L=J+36|0;do{f[J>>2]=0;J=J+4|0}while((J|0)<(L|0));f[_>>2]=c;f[i>>2]=ca;f[ca>>2]=0;f[ba>>2]=0;fa=Y(db,ea)|0;do if(da){eb=f[(f[t>>2]|0)+(fa*56|0)+40>>2]|0;fb=f[eb+4>>2]|0;gb=f[eb>>2]|0;$i(x,(f[I>>2]<<1)+gb|0,(f[$>>2]<<1)+fb|0,f[w>>2]&4095,f[W>>2]|0,0);eb=f[I>>2]|0;f[B>>2]=f[$>>2];f[U>>2]=eb;f[T>>2]=fb;f[S>>2]=gb;FR(A,x,B);gb=f[V>>2]|0;if(gb|0){fb=gb+12|0;f[fb>>2]=(f[fb>>2]|0)+1}fb=f[Z>>2]|0;do if(fb|0){gb=fb+12|0;eb=f[gb>>2]|0;f[gb>>2]=eb+-1;if((eb|0)!=1)break;CR(k)}while(0);f[Z>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[ga>>2]|0)>0){fb=f[_>>2]|0;eb=0;do{f[fb+(eb<<2)>>2]=0;eb=eb+1|0;hb=f[ga>>2]|0}while((eb|0)<(hb|0));f[k>>2]=f[A>>2];if((hb|0)<3)M=123;else M=125}else{f[k>>2]=f[A>>2];M=123}do if((M|0)==123){M=0;eb=f[na>>2]|0;if((eb|0)>=3){M=125;break}f[ga>>2]=eb;f[c>>2]=f[oa>>2];f[qa>>2]=f[pa>>2];eb=f[ra>>2]|0;fb=f[i>>2]|0;f[fb>>2]=f[eb>>2];f[fb+4>>2]=f[eb+4>>2]}while(0);if((M|0)==125){M=0;BR(k,A)}f[X>>2]=f[sa>>2];f[ua>>2]=f[ta>>2];f[wa>>2]=f[va>>2];f[ya>>2]=f[xa>>2];f[Aa>>2]=f[za>>2];eb=f[V>>2]|0;f[Z>>2]=eb;do if(eb|0){fb=eb+12|0;gb=f[fb>>2]|0;f[fb>>2]=gb+-1;if((gb|0)!=1)break;CR(A)}while(0);f[V>>2]=0;f[sa>>2]=0;f[sa+4>>2]=0;f[sa+8>>2]=0;f[sa+12>>2]=0;if((f[na>>2]|0)>0){eb=f[Ba>>2]|0;gb=0;do{f[eb+(gb<<2)>>2]=0;gb=gb+1|0}while((gb|0)<(f[na>>2]|0))}gb=f[ra>>2]|0;if((gb|0)!=(Ca|0))ZF(gb);eva((f[t>>2]|0)+(fa*56|0)|0,k);f[Da>>2]=0;f[Ea>>2]=0;f[A>>2]=16842752;f[Fa>>2]=k;gb=Ga;f[gb>>2]=0;f[gb+4>>2]=0;f[B>>2]=33619968;f[Ha>>2]=x;gb=f[I>>2]|0;eb=f[$>>2]|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;f[C+16>>2]=0;f[C+20>>2]=0;f[C+24>>2]=0;f[C+28>>2]=0;mL(A,B,gb,gb,eb,eb,16,C);eb=f[Ia>>2]|0;do if(eb|0){gb=eb+12|0;fb=f[gb>>2]|0;f[gb>>2]=fb+-1;if((fb|0)!=1)break;CR(x)}while(0);f[Ia>>2]=0;f[Ja>>2]=0;f[Ja+4>>2]=0;f[Ja+8>>2]=0;f[Ja+12>>2]=0;if((f[Ka>>2]|0)>0){eb=f[La>>2]|0;fb=0;do{f[eb+(fb<<2)>>2]=0;fb=fb+1|0}while((fb|0)<(f[Ka>>2]|0))}fb=f[Ma>>2]|0;if((fb|0)!=(Na|0))ZF(fb)}else{fb=fa+1|0;eb=f[t>>2]|0;gb=eb+(fb*56|0)|0;if((k|0)==(gb|0))break;ib=eb+(fb*56|0)+36|0;jb=f[ib>>2]|0;do if(jb|0){kb=jb+12|0;f[kb>>2]=(f[kb>>2]|0)+1;kb=f[Z>>2]|0;if(!kb)break;lb=kb+12|0;kb=f[lb>>2]|0;f[lb>>2]=kb+-1;if((kb|0)!=1)break;CR(k)}while(0);f[Z>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[ga>>2]|0)>0){jb=f[_>>2]|0;kb=0;do{f[jb+(kb<<2)>>2]=0;kb=kb+1|0;mb=f[ga>>2]|0}while((kb|0)<(mb|0));f[k>>2]=f[gb>>2];if((mb|0)<3)M=153;else M=155}else{f[k>>2]=f[gb>>2];M=153}do if((M|0)==153){M=0;kb=f[eb+(fb*56|0)+4>>2]|0;if((kb|0)>=3){M=155;break}f[ga>>2]=kb;f[c>>2]=f[eb+(fb*56|0)+8>>2];f[qa>>2]=f[eb+(fb*56|0)+12>>2];kb=f[eb+(fb*56|0)+44>>2]|0;jb=f[i>>2]|0;f[jb>>2]=f[kb>>2];f[jb+4>>2]=f[kb+4>>2]}while(0);if((M|0)==155){M=0;BR(k,gb)}f[X>>2]=f[eb+(fb*56|0)+16>>2];f[ua>>2]=f[eb+(fb*56|0)+20>>2];f[wa>>2]=f[eb+(fb*56|0)+24>>2];f[ya>>2]=f[eb+(fb*56|0)+28>>2];f[Aa>>2]=f[eb+(fb*56|0)+32>>2];f[Z>>2]=f[ib>>2]}while(0);kb=f[t>>2]|0;jb=f[kb+(fa*56|0)+40>>2]|0;lb=Y(db,ia)|0;nb=f[v>>2]|0;ob=f[nb+(lb*56|0)+40>>2]|0;if((f[jb>>2]|0)==(f[ob>>2]|0)?(f[jb+4>>2]|0)==(f[ob+4>>2]|0):0){pb=kb;qb=nb}else{f[x>>2]=0;f[cb>>2]=0;J=c$(x,68)|0;K=348660;L=J+68|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));j$(-215,x,349552,347586,1378);d$(x);pb=f[t>>2]|0;qb=f[v>>2]|0}if(!((f[qb+(lb*56|0)>>2]^f[pb+(fa*56|0)>>2])&4095)){rb=pb;sb=qb}else{f[x>>2]=0;f[bb>>2]=0;J=c$(x,68)|0;K=348729;L=J+68|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));j$(-215,x,349552,347586,1379);d$(x);rb=f[t>>2]|0;sb=f[v>>2]|0}f[x>>2]=0;f[Oa>>2]=D;nb=f[$>>2]|0;kb=f[I>>2]|0;ob=f[e>>2]|0;jb=f[E>>2]|0;ka=+p[Pa>>3];f[A>>2]=101344;f[Sa>>2]=rb+(fa*56|0);f[Ta>>2]=k;f[Ua>>2]=sb+(lb*56|0);f[Va>>2]=g;f[Wa>>2]=G;f[Xa>>2]=Q;f[Ya>>2]=aa;f[a>>2]=nb;f[Qa>>2]=kb;f[Ra>>2]=f[ha>>2];f[Ra+4>>2]=f[ha+4>>2];f[Ra+8>>2]=f[ha+8>>2];f[Ra+12>>2]=f[ha+12>>2];f[Za>>2]=db;f[_a>>2]=ob;f[$a>>2]=jb;n[ab>>2]=ka;_U(x,A,-1.0);jb=f[Z>>2]|0;do if(jb|0){ob=jb+12|0;kb=f[ob>>2]|0;f[ob>>2]=kb+-1;if((kb|0)!=1)break;CR(k)}while(0);f[Z>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[ga>>2]|0)>0){jb=f[_>>2]|0;lb=0;do{f[jb+(lb<<2)>>2]=0;lb=lb+1|0}while((lb|0)<(f[ga>>2]|0))}lb=f[i>>2]|0;if((lb|0)!=(ca|0))ZF(lb);if((db|0)>0)db=db+-1|0;else break}}db=w+36|0;ca=f[db>>2]|0;do if(ca|0){i=ca+12|0;ga=f[i>>2]|0;f[i>>2]=ga+-1;if((ga|0)!=1)break;CR(w)}while(0);f[db>>2]=0;db=w+16|0;f[db>>2]=0;f[db+4>>2]=0;f[db+8>>2]=0;f[db+12>>2]=0;if((f[ja>>2]|0)>0){db=f[d>>2]|0;d=0;do{f[db+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[ja>>2]|0))}ja=f[y>>2]|0;if((ja|0)!=(z|0))ZF(ja);Vt(v);Vt(t);t=s+36|0;v=f[t>>2]|0;do if(v|0){ja=v+12|0;z=f[ja>>2]|0;f[ja>>2]=z+-1;if((z|0)!=1)break;CR(s)}while(0);f[t>>2]=0;t=s+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[h>>2]|0)>0){t=f[N>>2]|0;N=0;do{f[t+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[h>>2]|0))}h=f[O>>2]|0;if((h|0)!=(H|0))ZF(h);h=r+36|0;H=f[h>>2]|0;do if(H|0){O=H+12|0;N=f[O>>2]|0;f[O>>2]=N+-1;if((N|0)!=1)break;CR(r)}while(0);f[h>>2]=0;h=r+4|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[h>>2]|0)>0){R=f[r+40>>2]|0;H=0;do{f[R+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[h>>2]|0))}h=f[P>>2]|0;if((h|0)!=(r+48|0))ZF(h);h=q+36|0;r=f[h>>2]|0;do if(r|0){P=r+12|0;H=f[P>>2]|0;f[P>>2]=H+-1;if((H|0)!=1)break;CR(q)}while(0);f[h>>2]=0;h=q+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[h>>2]|0)>0){o=f[q+40>>2]|0;r=0;do{f[o+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[h>>2]|0))}h=f[F>>2]|0;if((h|0)!=(q+48|0))ZF(h)}h=m+36|0;q=f[h>>2]|0;if(q|0?(F=q+12|0,q=f[F>>2]|0,f[F>>2]=q+-1,(q|0)==1):0)CR(m);f[h>>2]=0;h=m+16|0;q=m+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[q>>2]|0)>0){h=f[m+40>>2]|0;F=0;do{f[h+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[q>>2]|0))}q=f[m+44>>2]|0;if((q|0)!=(m+48|0))ZF(q);if(!(f[l+4>>2]|0)){u=j;return}u=j;return}function jva(a,b){a=a|0;b=b|0;f[a>>2]=f[b+4>>2];f[a+4>>2]=f[b+8>>2];return}function kva(a,b){a=a|0;b=b|0;f[a+4>>2]=f[b>>2];f[a+8>>2]=f[b+4>>2];return}function lva(a){a=a|0;return f[a+12>>2]|0}function mva(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function nva(a,b){a=a|0;b=b|0;var c=0;c=b+16|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];return}function ova(a,b){a=a|0;b=b|0;var c=0;c=a+16|0;f[c>>2]=f[b>>2];f[c+4>>2]=f[b+4>>2];f[c+8>>2]=f[b+8>>2];f[c+12>>2]=f[b+12>>2];return}function pva(a){a=a|0;return f[a+32>>2]|0}function qva(a,b){a=a|0;b=b|0;f[a+32>>2]=b;return}function rva(a){a=a|0;return +(+p[a+40>>3])}function sva(a,b){a=a|0;b=+b;p[a+40>>3]=b;return}function tva(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;var m=0,n=0,o=0,q=0.0;m=f[h>>2]|0;n=f[h+4>>2]|0;h=f[j>>2]|0;o=f[j+4>>2]|0;q=+p[j+8>>3];j=NYa(48)|0;WF(j);f[j>>2]=101404;f[j+4>>2]=m;f[j+8>>2]=n;f[j+12>>2]=i;f[j+16>>2]=h;f[j+20>>2]=o;p[j+24>>3]=q;f[j+32>>2]=k;p[j+40>>3]=l;k=NYa(16)|0;o=k+4|0;f[o>>2]=1;f[k>>2]=101488;f[k+8>>2]=j;f[o>>2]=(f[o>>2]|0)+1;h=f[o>>2]|0;f[o>>2]=h+-1;if((h|0)==1)ki[f[(f[k>>2]|0)+8>>2]&2047](k);Xh[f[(f[j>>2]|0)+32>>2]&127](j,a,b,c,d,e,g);g=f[o>>2]|0;f[o>>2]=g+-1;if((g|0)!=1)return;ki[f[(f[k>>2]|0)+8>>2]&2047](k);return}function uva(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0;g=u;u=u+624|0;h=g+16|0;i=g+616|0;j=g+560|0;k=g+504|0;l=g+448|0;m=g+432|0;o=g+420|0;q=g+408|0;r=g+336|0;t=g+352|0;v=g+280|0;w=g+208|0;x=g+144|0;y=g+112|0;z=g+96|0;A=g+272|0;B=g+264|0;C=g+200|0;D=g+136|0;E=g+72|0;F=g+88|0;G=g;_$(i,101520);f[j>>2]=1124007936;H=j+4|0;I=j+8|0;K=j+40|0;N=H;O=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(O|0));f[K>>2]=I;P=j+48|0;Q=j+44|0;f[Q>>2]=P;f[P>>2]=0;f[j+52>>2]=0;f[h>>2]=2;f[h+4>>2]=3;AR(j,2,h,6);do if((NS(c)|0)==65536){R=f[c+4>>2]|0;f[k>>2]=f[R>>2];S=k+4|0;T=R+4|0;f[S>>2]=f[T>>2];U=k+8|0;f[U>>2]=f[R+8>>2];f[k+12>>2]=f[R+12>>2];f[k+16>>2]=f[R+16>>2];f[k+20>>2]=f[R+20>>2];f[k+24>>2]=f[R+24>>2];f[k+28>>2]=f[R+28>>2];f[k+32>>2]=f[R+32>>2];V=f[R+36>>2]|0;f[k+36>>2]=V;f[k+40>>2]=U;U=k+48|0;W=k+44|0;f[W>>2]=U;f[U>>2]=0;f[k+52>>2]=0;if(V|0){U=V+12|0;f[U>>2]=(f[U>>2]|0)+1}if((f[T>>2]|0)<3){T=f[R+44>>2]|0;U=f[W>>2]|0;f[U>>2]=f[T>>2];f[U+4>>2]=f[T+4>>2];break}else{f[S>>2]=0;BR(k,R);break}}else OR(k,c,-1);while(0);do if((NS(d)|0)==65536){c=f[d+4>>2]|0;f[l>>2]=f[c>>2];R=l+4|0;S=c+4|0;f[R>>2]=f[S>>2];T=l+8|0;f[T>>2]=f[c+8>>2];f[l+12>>2]=f[c+12>>2];f[l+16>>2]=f[c+16>>2];f[l+20>>2]=f[c+20>>2];f[l+24>>2]=f[c+24>>2];f[l+28>>2]=f[c+28>>2];f[l+32>>2]=f[c+32>>2];U=f[c+36>>2]|0;f[l+36>>2]=U;W=l+40|0;f[W>>2]=T;T=l+48|0;V=l+44|0;f[V>>2]=T;f[T>>2]=0;f[l+52>>2]=0;if(U|0){T=U+12|0;f[T>>2]=(f[T>>2]|0)+1}if((f[S>>2]|0)<3){S=f[c+44>>2]|0;T=f[V>>2]|0;f[T>>2]=f[S>>2];f[T+4>>2]=f[S+4>>2];X=W;break}else{f[R>>2]=0;BR(l,c);X=W;break}}else{OR(l,d,-1);X=l+40|0}while(0);f[m>>2]=0;d=m+4|0;f[d>>2]=0;f[m+8>>2]=0;f[o>>2]=0;W=o+4|0;f[W>>2]=0;f[o+8>>2]=0;f[q>>2]=0;c=q+4|0;f[c>>2]=0;f[q+8>>2]=0;f[r>>2]=0;R=r+4|0;f[R>>2]=0;f[r+8>>2]=0;S=k+40|0;T=f[S>>2]|0;V=f[X>>2]|0;if((f[T>>2]|0)!=(f[V>>2]|0)?1:(f[T+4>>2]|0)!=(f[V+4>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;N=c$(h,41)|0;Y=349054;O=N+41|0;do{b[N>>0]=b[Y>>0]|0;N=N+1|0;Y=Y+1|0}while((N|0)<(O|0));j$(-209,h,349096,347586,1513);d$(h)}if((f[l>>2]^f[k>>2])&4095|0){f[h>>2]=0;f[h+4>>2]=0;N=c$(h,46)|0;Y=349119;O=N+46|0;do{b[N>>0]=b[Y>>0]|0;N=N+1|0;Y=Y+1|0}while((N|0)<(O|0));j$(-205,h,349096,347586,1516);d$(h)}V=LS(k,2,-1,1)|0;do if((V|0)>0){kS(t,k,2,V);T=h+8|0;f[T>>2]=0;f[T+4>>2]=0;f[h>>2]=-2113732595;f[h+4>>2]=m;WJ(t,h,5,1.0,0.0);T=t+36|0;U=f[T>>2]|0;if(U|0?(Z=U+12|0,U=f[Z>>2]|0,f[Z>>2]=U+-1,(U|0)==1):0)CR(t);f[T>>2]=0;T=t+16|0;U=t+4|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[U>>2]|0)>0){T=f[t+40>>2]|0;Z=0;do{f[T+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[U>>2]|0))}U=f[t+44>>2]|0;if((U|0)!=(t+48|0))ZF(U);kS(v,l,2,V);U=h+8|0;f[U>>2]=0;f[U+4>>2]=0;f[h>>2]=-2113732595;f[h+4>>2]=o;WJ(v,h,5,1.0,0.0);U=v+36|0;Z=f[U>>2]|0;if(Z|0?(T=Z+12|0,Z=f[T>>2]|0,f[T>>2]=Z+-1,(Z|0)==1):0)CR(v);f[U>>2]=0;U=v+16|0;Z=v+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[Z>>2]|0)>0){U=f[v+40>>2]|0;T=0;do{f[U+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[Z>>2]|0))}Z=f[v+44>>2]|0;if((Z|0)==(v+48|0)){_=V;$=1.0}else{ZF(Z);_=V;$=1.0}}else{Z=f[k>>2]|0;if(Z&7|0){f[h>>2]=0;f[h+4>>2]=0;N=c$(h,52)|0;Y=349196;O=N+52|0;do{b[N>>0]=b[Y>>0]|0;N=N+1|0;Y=Y+1|0}while((N|0)<(O|0));j$(-210,h,349096,347586,1596);d$(h);_=V;$=1.0;break}T=Z>>>3;U=T&511;switch(T&511){case 0:case 2:case 3:break;default:{f[h>>2]=0;f[h+4>>2]=0;N=c$(h,29)|0;Y=349166;O=N+29|0;do{b[N>>0]=b[Y>>0]|0;N=N+1|0;Y=Y+1|0}while((N|0)<(O|0));j$(-215,h,349096,347586,1528);d$(h)}}Z=f[S>>2]|0;T=f[Z+4>>2]|0;aa=f[Z>>2]|0;ba=+(T|0);ca=160.0/ba;da=+(aa|0);ea=120.0/da;fa=ca<ea?ea:ca;ca=fa>1.0?fa:1.0;Z=rNa(ba*ca)|0;ga=rNa(da*ca)|0;ha=(U|0)!=0;if(ha|((Z|0)!=(T|0)|(ga|0)!=(aa|0))){f[h>>2]=1124007936;aa=h+4|0;T=h+8|0;ia=h+40|0;N=aa;O=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(O|0));f[ia>>2]=T;U=h+48|0;ja=h+44|0;f[ja>>2]=U;f[U>>2]=0;f[h+52>>2]=0;f[w>>2]=1124007936;ka=w+4|0;la=w+8|0;ma=w+40|0;N=ka;O=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(O|0));f[ma>>2]=la;na=w+48|0;oa=w+44|0;f[oa>>2]=na;f[na>>2]=0;f[w+52>>2]=0;if(ha){f[x>>2]=1124007936;pa=x+4|0;qa=x+8|0;ra=x+40|0;N=pa;O=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(O|0));f[ra>>2]=qa;ha=x+48|0;sa=x+44|0;f[sa>>2]=ha;f[ha>>2]=0;f[x+52>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=k;ta=z+8|0;f[ta>>2]=0;f[ta+4>>2]=0;f[z>>2]=33619968;f[z+4>>2]=x;f6(y,z,6,0);f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=x;ta=z+8|0;f[ta>>2]=0;f[ta+4>>2]=0;f[z>>2]=33619968;f[z+4>>2]=h;f[A>>2]=Z;f[A+4>>2]=ga;fna(y,z,A,0.0,0.0,3);f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=l;ta=z+8|0;f[ta>>2]=0;f[ta+4>>2]=0;f[z>>2]=33619968;f[z+4>>2]=x;f6(y,z,6,0);f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=x;ta=z+8|0;f[ta>>2]=0;f[ta+4>>2]=0;f[z>>2]=33619968;f[z+4>>2]=w;f[B>>2]=Z;f[B+4>>2]=ga;fna(y,z,B,0.0,0.0,3);ta=x+36|0;ua=f[ta>>2]|0;if(ua|0?(va=ua+12|0,ua=f[va>>2]|0,f[va>>2]=ua+-1,(ua|0)==1):0)CR(x);f[ta>>2]=0;ta=x+16|0;f[ta>>2]=0;f[ta+4>>2]=0;f[ta+8>>2]=0;f[ta+12>>2]=0;if((f[pa>>2]|0)>0){ta=f[ra>>2]|0;ua=0;do{f[ta+(ua<<2)>>2]=0;ua=ua+1|0}while((ua|0)<(f[pa>>2]|0))}pa=f[sa>>2]|0;if((pa|0)!=(ha|0))ZF(pa)}else{f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=k;pa=y+8|0;f[pa>>2]=0;f[pa+4>>2]=0;f[y>>2]=33619968;f[y+4>>2]=h;f[C>>2]=Z;f[C+4>>2]=ga;fna(x,y,C,0.0,0.0,3);f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=l;pa=y+8|0;f[pa>>2]=0;f[pa+4>>2]=0;f[y>>2]=33619968;f[y+4>>2]=w;f[D>>2]=Z;f[D+4>>2]=ga;fna(x,y,D,0.0,0.0,3)}pa=h+36|0;ua=f[pa>>2]|0;if(ua|0){ta=ua+12|0;f[ta>>2]=(f[ta>>2]|0)+1}ta=k+36|0;ua=f[ta>>2]|0;if(ua|0?(ra=ua+12|0,ua=f[ra>>2]|0,f[ra>>2]=ua+-1,(ua|0)==1):0)CR(k);f[ta>>2]=0;ua=k+16|0;ra=k+4|0;f[ua>>2]=0;f[ua+4>>2]=0;f[ua+8>>2]=0;f[ua+12>>2]=0;if((f[ra>>2]|0)>0){qa=f[S>>2]|0;va=0;do{f[qa+(va<<2)>>2]=0;va=va+1|0;wa=f[ra>>2]|0}while((va|0)<(wa|0));f[k>>2]=f[h>>2];if((wa|0)<3)xa=61;else xa=63}else{f[k>>2]=f[h>>2];xa=61}if((xa|0)==61){va=f[aa>>2]|0;if((va|0)<3){f[ra>>2]=va;f[k+8>>2]=f[T>>2];f[k+12>>2]=f[h+12>>2];va=f[ja>>2]|0;qa=f[k+44>>2]|0;f[qa>>2]=f[va>>2];f[qa+4>>2]=f[va+4>>2]}else xa=63}if((xa|0)==63)BR(k,h);va=h+16|0;f[ua>>2]=f[va>>2];f[k+20>>2]=f[h+20>>2];f[k+24>>2]=f[h+24>>2];f[k+28>>2]=f[h+28>>2];f[k+32>>2]=f[h+32>>2];f[ta>>2]=f[pa>>2];qa=w+36|0;ha=f[qa>>2]|0;if(ha|0){sa=ha+12|0;f[sa>>2]=(f[sa>>2]|0)+1}sa=l+36|0;ha=f[sa>>2]|0;if(ha|0?(ya=ha+12|0,ha=f[ya>>2]|0,f[ya>>2]=ha+-1,(ha|0)==1):0)CR(l);f[sa>>2]=0;ha=l+16|0;ya=l+4|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[ya>>2]|0)>0){za=f[X>>2]|0;Aa=0;do{f[za+(Aa<<2)>>2]=0;Aa=Aa+1|0;Ba=f[ya>>2]|0}while((Aa|0)<(Ba|0));f[l>>2]=f[w>>2];if((Ba|0)<3)xa=74;else xa=76}else{f[l>>2]=f[w>>2];xa=74}if((xa|0)==74){Aa=f[ka>>2]|0;if((Aa|0)<3){f[ya>>2]=Aa;f[l+8>>2]=f[la>>2];f[l+12>>2]=f[w+12>>2];Aa=f[oa>>2]|0;za=f[l+44>>2]|0;f[za>>2]=f[Aa>>2];f[za+4>>2]=f[Aa+4>>2]}else xa=76}if((xa|0)==76)BR(l,w);Aa=w+16|0;f[ha>>2]=f[Aa>>2];f[l+20>>2]=f[w+20>>2];f[l+24>>2]=f[w+24>>2];f[l+28>>2]=f[w+28>>2];f[l+32>>2]=f[w+32>>2];za=f[qa>>2]|0;f[sa>>2]=za;if(za|0?(ta=za+12|0,za=f[ta>>2]|0,f[ta>>2]=za+-1,(za|0)==1):0)CR(w);f[qa>>2]=0;f[Aa>>2]=0;f[Aa+4>>2]=0;f[Aa+8>>2]=0;f[Aa+12>>2]=0;if((f[ka>>2]|0)>0){Aa=f[ma>>2]|0;za=0;do{f[Aa+(za<<2)>>2]=0;za=za+1|0}while((za|0)<(f[ka>>2]|0))}ka=f[oa>>2]|0;if((ka|0)!=(na|0))ZF(ka);ka=f[pa>>2]|0;do if(ka|0){za=ka+12|0;Aa=f[za>>2]|0;f[za>>2]=Aa+-1;if((Aa|0)!=1)break;CR(h)}while(0);f[pa>>2]=0;f[va>>2]=0;f[va+4>>2]=0;f[va+8>>2]=0;f[va+12>>2]=0;if((f[aa>>2]|0)>0){ka=f[ia>>2]|0;na=0;do{f[ka+(na<<2)>>2]=0;na=na+1|0}while((na|0)<(f[aa>>2]|0))}aa=f[ja>>2]|0;if((aa|0)!=(U|0))ZF(aa)}aa=rNa(+(Z|0)*15.0/+(ga|0))|0;na=aa*15|0;ka=f[d>>2]|0;ia=f[m>>2]|0;va=ka-ia>>3;pa=ia;ia=ka;if(na>>>0<=va>>>0){if(na>>>0<va>>>0?(ka=pa+(na<<3)|0,(ia|0)!=(ka|0)):0)f[d>>2]=ia+(~((ia+-8-ka|0)>>>3)<<3)}else vva(m,na-va|0);va=f[W>>2]|0;ka=f[o>>2]|0;ia=va-ka>>3;pa=ka;ka=va;if(na>>>0<=ia>>>0){if(na>>>0<ia>>>0?(va=pa+(na<<3)|0,(ka|0)!=(va|0)):0)f[W>>2]=ka+(~((ka+-8-va|0)>>>3)<<3)}else vva(o,na-ia|0);ia=f[R>>2]|0;va=f[r>>2]|0;ka=ia-va|0;pa=va;va=ia;if(na>>>0<=ka>>>0){if(na>>>0<ka>>>0?(ia=pa+na|0,(va|0)!=(ia|0)):0)f[R>>2]=ia}else TR(r,na-ka|0);ka=(aa|0)>0;da=+(Z|0);ba=+(aa|0);ia=f[m>>2]|0;fa=+(ga|0);if(ka){va=0;pa=0;while(1){ea=fa*(+(va|0)+.5)/15.0;oa=0;Aa=pa;while(1){n[ia+(Aa<<3)>>2]=da*(+(oa|0)+.5)/ba;n[ia+(Aa<<3)+4>>2]=ea;oa=oa+1|0;if((oa|0)==(aa|0))break;else Aa=Aa+1|0}va=va+1|0;if((va|0)==15)break;else pa=aa+pa|0}}f[w+8>>2]=0;f[w+12>>2]=0;f[w>>2]=16842752;f[w+4>>2]=k;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=l;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=-2130509811;f[y+4>>2]=m;pa=z+8|0;f[pa>>2]=0;f[pa+4>>2]=0;f[z>>2]=-2096955379;f[z+4>>2]=o;pa=E+8|0;f[pa>>2]=0;f[pa+4>>2]=0;f[E>>2]=-2113732608;f[E+4>>2]=r;pa=fT()|0;f[F>>2]=21;f[F+4>>2]=21;f[G>>2]=1;f[G+4>>2]=40;p[G+8>>3]=.1;f[h>>2]=f[G>>2];f[h+4>>2]=f[G+4>>2];f[h+8>>2]=f[G+8>>2];f[h+12>>2]=f[G+12>>2];tva(w,x,y,z,E,pa,F,3,h,0,.0001);if(ka){pa=f[r>>2]|0;aa=0;va=0;while(1){if(!(b[pa+aa>>0]|0))Ca=va;else{if((aa|0)>(va|0)){ia=f[m>>2]|0;f[ia+(va<<3)>>2]=f[ia+(aa<<3)>>2];f[ia+(va<<3)+4>>2]=f[ia+(aa<<3)+4>>2];ia=f[o>>2]|0;f[ia+(va<<3)>>2]=f[ia+(aa<<3)>>2];f[ia+(va<<3)+4>>2]=f[ia+(aa<<3)+4>>2]}Ca=va+1|0}aa=aa+1|0;if((aa|0)>=(na|0)){Da=Ca;break}else va=Ca}}else Da=0;va=f[d>>2]|0;na=f[m>>2]|0;aa=va-na>>3;pa=na;na=va;if(Da>>>0<=aa>>>0){if(Da>>>0<aa>>>0?(va=pa+(Da<<3)|0,(na|0)!=(va|0)):0)f[d>>2]=na+(~((na+-8-va|0)>>>3)<<3)}else vva(m,Da-aa|0);aa=f[W>>2]|0;va=f[o>>2]|0;na=aa-va>>3;pa=aa;if(Da>>>0>na>>>0){vva(o,Da-na|0);_=Da;$=ca;break}if(Da>>>0<na>>>0?(na=va+(Da<<3)|0,(pa|0)!=(na|0)):0){f[W>>2]=pa+(~((pa+-8-na|0)>>>3)<<3);_=Da;$=ca}else{_=Da;$=ca}}while(0);Da=f[c>>2]|0;Ca=f[q>>2]|0;F=Da-Ca>>2;E=Ca;Ca=Da;if(_>>>0<=F>>>0){if(_>>>0<F>>>0?(Da=E+(_<<2)|0,(Ca|0)!=(Da|0)):0)f[c>>2]=Ca+(~((Ca+-4-Da|0)>>>2)<<2)}else GM(q,_-F|0);if((_|0)>=3){f[w+8>>2]=0;f[w+12>>2]=0;f[w>>2]=-2130509811;f[w+4>>2]=o;rna(h,w);F=x+4|0;Da=w+4|0;Ca=x+8|0;E=x+12|0;z=w+8|0;G=x+16|0;Ba=x+20|0;wa=y+4|0;D=y+8|0;C=y+12|0;B=y+16|0;A=y+20|0;Y=j+16|0;ba=+(_|0)*.5;V=h+8|0;v=h+12|0;h=-1;t=-1;na=0;while(1){f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[x+16>>2]=0;f[x+20>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[y+16>>2]=0;f[y+20>>2]=0;pa=f[m>>2]|0;va=f[o>>2]|0;aa=f[x>>2]|0;ka=f[F>>2]|0;ia=f[Ca>>2]|0;ga=f[E>>2]|0;Z=f[G>>2]|0;U=f[Ba>>2]|0;ja=f[y>>2]|0;Aa=f[wa>>2]|0;oa=f[D>>2]|0;za=f[C>>2]|0;ma=f[B>>2]|0;qa=f[A>>2]|0;sa=h;ha=t;la=0;a:while(1){ya=w+(la<<2)|0;ta=(la|0)>0;ua=(la|0)==2;Ea=sa;Fa=ha;T=qa;ra=ma;Ga=za;Ha=oa;Ia=Aa;Ja=ja;Ka=U;La=Z;Ma=ga;Na=ia;Oa=ka;Pa=aa;Qa=0;while(1){Ra=W1a(Ea|0,0,-130063606,0)|0;Ea=C1a(Ra|0,J|0,Fa|0,0)|0;Fa=J;Ra=(Ea>>>0)%(_>>>0)|0;f[ya>>2]=Ra;b:do if(ta){Sa=pa+(Ra<<3)|0;Ta=pa+(Ra<<3)+4|0;Ua=va+(Ra<<3)|0;Va=va+(Ra<<3)+4|0;Wa=0;while(1){Xa=f[w+(Wa<<2)>>2]|0;if((Xa|0)==(Ra|0)){Ya=T;Za=ra;_a=Ga;$a=Ha;ab=Ia;bb=Ja;cb=Ka;db=La;eb=Ma;fb=Na;gb=Oa;hb=Pa;break b}da=+L(+(+n[Sa>>2]-+n[pa+(Xa<<3)>>2]));if(da+ +L(+(+n[Ta>>2]-+n[pa+(Xa<<3)+4>>2]))<1.1920928955078125e-07){Ya=T;Za=ra;_a=Ga;$a=Ha;ab=Ia;bb=Ja;cb=Ka;db=La;eb=Ma;fb=Na;gb=Oa;hb=Pa;break b}da=+L(+(+n[Ua>>2]-+n[va+(Xa<<3)>>2]));Wa=Wa+1|0;if(da+ +L(+(+n[Va>>2]-+n[va+(Xa<<3)+4>>2]))<1.1920928955078125e-07){Ya=T;Za=ra;_a=Ga;$a=Ha;ab=Ia;bb=Ja;cb=Ka;db=La;eb=Ma;fb=Na;gb=Oa;hb=Pa;break b}if((Wa|0)>=(la|0)){xa=148;break}}}else xa=148;while(0);if((xa|0)==148){xa=0;if(!ua){ib=Pa;jb=Oa;kb=Na;lb=Ma;mb=La;nb=Ka;ob=Ja;pb=Ia;qb=Ha;rb=Ga;sb=ra;tb=T;break}Ra=f[w>>2]|0;Wa=f[pa+(Ra<<3)>>2]|0;Va=f[pa+(Ra<<3)+4>>2]|0;Ua=f[Da>>2]|0;Ta=f[pa+(Ua<<3)>>2]|0;Sa=f[pa+(Ua<<3)+4>>2]|0;Xa=f[z>>2]|0;ub=f[pa+(Xa<<3)>>2]|0;vb=f[pa+(Xa<<3)+4>>2]|0;wb=f[va+(Ra<<3)>>2]|0;xb=f[va+(Ra<<3)+4>>2]|0;Ra=f[va+(Ua<<3)>>2]|0;yb=f[va+(Ua<<3)+4>>2]|0;Ua=f[va+(Xa<<3)>>2]|0;zb=f[va+(Xa<<3)+4>>2]|0;da=(f[s>>2]=Ta,+n[s>>2]);fa=(f[s>>2]=Wa,+n[s>>2]);ea=da-fa;da=(f[s>>2]=Sa,+n[s>>2]);Ab=(f[s>>2]=Va,+n[s>>2]);Bb=da-Ab;da=(f[s>>2]=ub,+n[s>>2])-fa;fa=(f[s>>2]=vb,+n[s>>2])-Ab;Ab=(f[s>>2]=Ra,+n[s>>2]);Cb=(f[s>>2]=wb,+n[s>>2]);Db=Ab-Cb;Ab=(f[s>>2]=yb,+n[s>>2]);Eb=(f[s>>2]=xb,+n[s>>2]);Fb=Ab-Eb;Ab=(f[s>>2]=Ua,+n[s>>2])-Cb;Cb=(f[s>>2]=zb,+n[s>>2])-Eb;if(!(+L(+(ea*fa-Bb*da))<+M(+(ea*ea+Bb*Bb))*.01*+M(+(da*da+fa*fa)))?!(+L(+(Db*Cb-Fb*Ab))<+M(+(Db*Db+Fb*Fb))*.01*+M(+(Ab*Ab+Cb*Cb))):0){ib=Wa;jb=Va;kb=Ta;lb=Sa;mb=ub;nb=vb;ob=wb;pb=xb;qb=Ra;rb=yb;sb=Ua;tb=zb;break}else{Ya=zb;Za=Ua;_a=yb;$a=Ra;ab=xb;bb=wb;cb=vb;db=ub;eb=Sa;fb=Ta;gb=Va;hb=Wa}}Wa=Qa+1|0;if((Wa|0)>=500){xa=158;break a}else{T=Ya;ra=Za;Ga=_a;Ha=$a;Ia=ab;Ja=bb;Ka=cb;La=db;Ma=eb;Na=fb;Oa=gb;Pa=hb;Qa=Wa}}la=la+1|0;if((Qa|0)>499){Gb=ib;Hb=jb;Ib=kb;Jb=lb;Kb=mb;Lb=nb;Mb=ob;Nb=pb;Ob=qb;Pb=rb;Qb=sb;Rb=tb;xa=159;break}if((la|0)>=3){xa=153;break}else{aa=ib;ka=jb;ia=kb;ga=lb;Z=mb;U=nb;ja=ob;Aa=pb;oa=qb;za=rb;ma=sb;qa=tb;sa=Ea;ha=Fa}}if((xa|0)==153){xa=0;f[x>>2]=ib;f[F>>2]=jb;f[Ca>>2]=kb;f[E>>2]=lb;f[G>>2]=mb;f[Ba>>2]=nb;f[y>>2]=ob;f[wa>>2]=pb;f[D>>2]=qb;f[C>>2]=rb;f[B>>2]=sb;f[A>>2]=tb;wva(x,y,3,j,e);ha=f[Y>>2]|0;sa=f[m>>2]|0;ca=+p[ha+16>>3];la=f[o>>2]|0;Cb=+p[ha+24>>3];Ab=+p[ha+32>>3];Fb=+p[ha+40>>3];va=f[q>>2]|0;Db=+p[ha>>3];fa=+p[ha+8>>3];ha=0;pa=0;while(1){da=+n[sa+(pa<<3)>>2];Bb=+n[sa+(pa<<3)+4>>2];ea=+L(+(ca+(Db*da+fa*Bb)-+n[la+(pa<<3)>>2]));Eb=+L(+(Fb+(da*Cb+Bb*Ab)-+n[la+(pa<<3)+4>>2]));Pa=f[V>>2]|0;Oa=f[v>>2]|0;if(ea+Eb<+(((Pa|0)<(Oa|0)?Oa:Pa)|0)*.05){f[va+(ha<<2)>>2]=pa;Sb=ha+1|0}else Sb=ha;pa=pa+1|0;if((pa|0)==(_|0))break;else ha=Sb}if(+(Sb|0)>=ba){xa=161;break}}else if((xa|0)==158){xa=0;f[x>>2]=aa;f[F>>2]=ka;f[Ca>>2]=ia;f[E>>2]=ga;f[G>>2]=Z;f[Ba>>2]=U;f[y>>2]=ja;f[wa>>2]=Aa;f[D>>2]=oa;f[C>>2]=za;f[B>>2]=ma;f[A>>2]=qa;Gb=hb;Hb=gb;Ib=fb;Jb=eb;Kb=db;Lb=cb;Mb=bb;Nb=ab;Ob=$a;Pb=_a;Qb=Za;Rb=Ya;xa=159}if((xa|0)==159){xa=0;f[x>>2]=Gb;f[F>>2]=Hb;f[Ca>>2]=Ib;f[E>>2]=Jb;f[G>>2]=Kb;f[Ba>>2]=Lb;f[y>>2]=Mb;f[wa>>2]=Nb;f[D>>2]=Ob;f[C>>2]=Pb;f[B>>2]=Qb;f[A>>2]=Rb}ha=na+1|0;if((ha|0)<500){h=Ea;t=Fa;na=ha}else{xa=162;break}}do if((xa|0)==161)if((na|0)<=499){if((Sb|0)<(_|0)&(Sb|0)>0){Fa=f[q>>2]|0;t=f[m>>2]|0;Ea=f[o>>2]|0;h=0;do{Rb=f[Fa+(h<<2)>>2]|0;f[t+(h<<3)>>2]=f[t+(Rb<<3)>>2];f[t+(h<<3)+4>>2]=f[t+(Rb<<3)+4>>2];f[Ea+(h<<3)>>2]=f[Ea+(Rb<<3)>>2];f[Ea+(h<<3)+4>>2]=f[Ea+(Rb<<3)+4>>2];h=h+1|0}while((h|0)!=(Sb|0))}wva(f[m>>2]|0,f[o>>2]|0,Sb,j,e);h=f[Y>>2]|0;Ea=h+16|0;p[Ea>>3]=+p[Ea>>3]/$;Ea=h+(f[f[Q>>2]>>2]|0)+16|0;p[Ea>>3]=+p[Ea>>3]/$;f[a>>2]=f[j>>2];Ea=a+4|0;t=f[H>>2]|0;f[Ea>>2]=t;Fa=a+8|0;f[Fa>>2]=f[I>>2];f[a+12>>2]=f[j+12>>2];f[a+16>>2]=h;f[a+20>>2]=f[j+20>>2];f[a+24>>2]=f[j+24>>2];f[a+28>>2]=f[j+28>>2];f[a+32>>2]=f[j+32>>2];h=f[j+36>>2]|0;f[a+36>>2]=h;f[a+40>>2]=Fa;Fa=a+48|0;qa=a+44|0;f[qa>>2]=Fa;f[Fa>>2]=0;f[a+52>>2]=0;if(!h)Tb=t;else{t=h+12|0;f[t>>2]=(f[t>>2]|0)+1;Tb=f[H>>2]|0}if((Tb|0)<3){t=f[Q>>2]|0;h=f[qa>>2]|0;f[h>>2]=f[t>>2];f[h+4>>2]=f[t+4>>2];break}else{f[Ea>>2]=0;BR(a,j);break}}else xa=162;while(0);if((xa|0)==162){f[a>>2]=1124007936;xa=a+8|0;Tb=a+40|0;N=a+4|0;O=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(O|0));f[Tb>>2]=xa;xa=a+48|0;f[a+44>>2]=xa;f[xa>>2]=0;f[a+52>>2]=0}}else{f[a>>2]=1124007936;xa=a+8|0;Tb=a+40|0;N=a+4|0;O=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(O|0));f[Tb>>2]=xa;xa=a+48|0;f[a+44>>2]=xa;f[xa>>2]=0;f[a+52>>2]=0}a=f[r>>2]|0;if(a|0){if((f[R>>2]|0)!=(a|0))f[R>>2]=a;PYa(a)}a=f[q>>2]|0;if(a|0){q=f[c>>2]|0;if((q|0)!=(a|0))f[c>>2]=q+(~((q+-4-a|0)>>>2)<<2);PYa(a)}a=f[o>>2]|0;if(a|0){o=f[W>>2]|0;if((o|0)!=(a|0))f[W>>2]=o+(~((o+-8-a|0)>>>3)<<3);PYa(a)}a=f[m>>2]|0;if(a|0){m=f[d>>2]|0;if((m|0)!=(a|0))f[d>>2]=m+(~((m+-8-a|0)>>>3)<<3);PYa(a)}a=l+36|0;m=f[a>>2]|0;if(m|0?(d=m+12|0,m=f[d>>2]|0,f[d>>2]=m+-1,(m|0)==1):0)CR(l);f[a>>2]=0;a=l+16|0;m=l+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[m>>2]|0)>0){a=f[X>>2]|0;X=0;do{f[a+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))ZF(m);m=k+36|0;l=f[m>>2]|0;if(l|0?(X=l+12|0,l=f[X>>2]|0,f[X>>2]=l+-1,(l|0)==1):0)CR(k);f[m>>2]=0;m=k+16|0;l=k+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[l>>2]|0)>0){m=f[S>>2]|0;S=0;do{f[m+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))ZF(l);l=j+36|0;k=f[l>>2]|0;if(k|0?(S=k+12|0,k=f[S>>2]|0,f[S>>2]=k+-1,(k|0)==1):0)CR(j);f[l>>2]=0;l=j+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[H>>2]|0)>0){l=f[K>>2]|0;K=0;do{f[l+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[H>>2]|0))}H=f[Q>>2]|0;if((H|0)!=(P|0))ZF(H);if(!(f[i+4>>2]|0)){u=g;return}u=g;return}function vva(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(d-g>>3>>>0>=b>>>0){F1a(g|0,0,b<<3|0)|0;f[e>>2]=h+(b<<3);return}i=f[a>>2]|0;j=g-i>>3;g=j+b|0;k=i;if(g>>>0>536870911)gXa(a);l=d-i|0;d=l>>2;m=l>>3>>>0<268435455?(d>>>0<g>>>0?g:d):536870911;do if(m)if(m>>>0>536870911){d=De(8)|0;UYa(d,358155);f[d>>2]=130560;Of(d|0,21520,875)}else{n=NYa(m<<3)|0;break}else n=0;while(0);d=n+(j<<3)|0;j=n+(m<<3)|0;F1a(d|0,0,b<<3|0)|0;m=d+(b<<3)|0;if((h|0)==(k|0)){o=d;p=i}else{b=h+-8-i|0;i=d;n=h;do{h=i;i=i+-8|0;g=n;n=n+-8|0;f[i>>2]=f[n>>2];f[h+-4>>2]=f[g+-4>>2]}while((n|0)!=(k|0));o=d+(~(b>>>3)<<3)|0;p=f[a>>2]|0}f[a>>2]=o;f[e>>2]=m;f[c>>2]=j;if(!p)return;PYa(p);return}function wva(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0.0,J=0.0,K=0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0;h=u;u=u+608|0;i=h+104|0;j=h+56|0;k=h;l=h+552|0;m=h+496|0;o=h+440|0;q=h+424|0;r=h+408|0;s=h+392|0;if(!(f[e>>2]&16384)){f[i>>2]=0;f[i+4>>2]=0;t=c$(i,16)|0;v=349249;w=t+16|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));j$(-215,i,349266,347586,1418);d$(i)}if(g){F1a(i|0,0,288)|0;t=j;w=t+48|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));g=k+4|0;f[g>>2]=2;v=k+8|0;f[v>>2]=6;f[k+12>>2]=6;x=k+16|0;f[x>>2]=i;f[k+20>>2]=i;y=k+24|0;z=k+40|0;A=y+8|0;f[A>>2]=0;f[A+4>>2]=0;f[z>>2]=v;v=k+48|0;A=k+44|0;f[A>>2]=v;f[k>>2]=1124024326;f[v>>2]=48;f[k+52>>2]=8;f[k+28>>2]=i+288;f[y>>2]=i+288;y=l+4|0;f[y>>2]=2;B=l+8|0;f[B>>2]=6;f[l+12>>2]=1;C=l+16|0;f[C>>2]=j;f[l+20>>2]=j;D=l+24|0;E=l+40|0;F=D+8|0;f[F>>2]=0;f[F+4>>2]=0;f[E>>2]=B;B=l+48|0;F=l+44|0;f[F>>2]=B;f[l>>2]=1124024326;f[B>>2]=8;f[l+52>>2]=8;f[l+28>>2]=j+48;f[D>>2]=j+48;kS(m,e,1,6);D=i+64|0;G=+p[D>>3];H=i+8|0;I=+p[H>>3];J=+p[i>>3];K=i+16|0;L=+p[K>>3];M=i+56|0;N=+p[M>>3];if((d|0)>0){O=j+8|0;P=j+16|0;Q=j+24|0;R=j+32|0;S=j+40|0;T=J;U=I;V=L;W=N;X=G;Y=+p[j>>3];Z=+p[O>>3];_=+p[P>>3];$=+p[Q>>3];aa=+p[R>>3];ba=+p[S>>3];ca=0;do{da=+n[a+(ca<<3)>>2];T=T+da*da;ea=+n[a+(ca<<3)+4>>2];U=U+da*ea;V=V+da;W=W+ea*ea;X=X+ea;fa=+n[c+(ca<<3)>>2];Y=Y+da*fa;Z=ea*fa+Z;_=fa+_;fa=+n[c+(ca<<3)+4>>2];$=$+da*fa;aa=ea*fa+aa;ba=fa+ba;ca=ca+1|0}while((ca|0)!=(d|0));p[i>>3]=T;p[H>>3]=U;p[K>>3]=V;p[M>>3]=W;p[D>>3]=X;p[j>>3]=Y;p[O>>3]=Z;p[P>>3]=_;p[Q>>3]=$;p[R>>3]=aa;p[S>>3]=ba;ga=W;ha=V;ia=T;ja=U;ka=X}else{ga=N;ha=L;ia=J;ja=I;ka=G}p[i+48>>3]=ja;p[i+216>>3]=ja;p[i+176>>3]=ja;p[i+96>>3]=ha;p[i+264>>3]=ha;p[i+184>>3]=ha;p[i+104>>3]=ka;p[i+272>>3]=ka;p[i+232>>3]=ka;p[i+168>>3]=ia;p[i+224>>3]=ga;ga=+(d|0);p[i+112>>3]=ga;p[i+280>>3]=ga;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=l;S=r+8|0;f[S>>2]=0;f[S+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=m;hN(o,q,r,2)|0;S=m+36|0;R=f[S>>2]|0;if(R|0?(Q=R+12|0,R=f[Q>>2]|0,f[Q>>2]=R+-1,(R|0)==1):0)CR(m);f[S>>2]=0;S=m+16|0;R=m+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[R>>2]|0)>0){S=f[m+40>>2]|0;Q=0;do{f[S+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[R>>2]|0))}R=f[m+44>>2]|0;if((R|0)!=(m+48|0))ZF(R);R=l+36|0;Q=f[R>>2]|0;if(Q|0?(S=Q+12|0,Q=f[S>>2]|0,f[S>>2]=Q+-1,(Q|0)==1):0)CR(l);f[R>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[y>>2]|0)>0){C=f[E>>2]|0;E=0;do{f[C+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[y>>2]|0))}y=f[F>>2]|0;if((y|0)!=(B|0))ZF(y);y=k+36|0;B=f[y>>2]|0;if(B|0?(F=B+12|0,B=f[F>>2]|0,f[F>>2]=B+-1,(B|0)==1):0)CR(k);f[y>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[g>>2]|0)>0){x=f[z>>2]|0;z=0;do{f[x+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[g>>2]|0))}g=f[A>>2]|0;if((g|0)!=(v|0))ZF(g);u=h;return}else{t=i;w=t+128|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;t=l+4|0;f[t>>2]=2;w=l+8|0;f[w>>2]=4;f[l+12>>2]=4;g=l+16|0;f[g>>2]=i;f[l+20>>2]=i;v=l+24|0;A=l+40|0;z=v+8|0;f[z>>2]=0;f[z+4>>2]=0;f[A>>2]=w;w=l+48|0;z=l+44|0;f[z>>2]=w;f[l>>2]=1124024326;f[w>>2]=32;f[l+52>>2]=8;f[l+28>>2]=i+128;f[v>>2]=i+128;v=m+4|0;f[v>>2]=2;x=m+8|0;f[x>>2]=4;f[m+12>>2]=1;y=m+16|0;f[y>>2]=j;f[m+20>>2]=j;B=m+24|0;F=m+40|0;E=B+8|0;f[E>>2]=0;f[E+4>>2]=0;f[F>>2]=x;x=m+48|0;E=m+44|0;f[E>>2]=x;f[m>>2]=1124024326;f[x>>2]=8;f[m+52>>2]=8;f[m+28>>2]=j+32;f[B>>2]=j+32;B=o+4|0;f[B>>2]=2;C=o+8|0;f[C>>2]=4;f[o+12>>2]=1;R=o+16|0;f[R>>2]=k;f[o+20>>2]=k;Q=o+24|0;S=o+40|0;P=Q+8|0;f[P>>2]=0;f[P+4>>2]=0;f[S>>2]=C;C=o+48|0;P=o+44|0;f[P>>2]=C;f[o>>2]=1124024326;f[C>>2]=8;f[o+52>>2]=8;f[o+28>>2]=k+32;f[Q>>2]=k+32;Q=i+24|0;ga=+p[Q>>3];ia=+p[i>>3];O=i+16|0;ka=+p[O>>3];if((d|0)>0){D=j+8|0;M=j+16|0;K=j+24|0;ha=ia;ja=ka;G=ga;I=+p[j>>3];J=+p[D>>3];L=+p[M>>3];N=+p[K>>3];H=0;do{X=+n[a+(H<<3)>>2];U=+n[a+(H<<3)+4>>2];ha=ha+(X*X+U*U);ja=ja+X;G=G+U;T=+n[c+(H<<3)>>2];V=+n[c+(H<<3)+4>>2];I=I+(X*T+U*V);J=J+(X*V-U*T);L=T+L;N=V+N;H=H+1|0}while((H|0)!=(d|0));p[i>>3]=ha;p[O>>3]=ja;p[Q>>3]=G;p[j>>3]=I;p[D>>3]=J;p[M>>3]=L;p[K>>3]=N;la=ja;ma=ha;na=G}else{la=ka;ma=ia;na=ga}p[i+40>>3]=ma;ma=-na;p[i+48>>3]=ma;p[i+72>>3]=ma;p[i+64>>3]=la;p[i+56>>3]=la;p[i+104>>3]=la;la=+(d|0);p[i+120>>3]=la;p[i+80>>3]=la;p[i+96>>3]=na;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=l;f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=m;i=s+8|0;f[i>>2]=0;f[i+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=o;hN(q,r,s,2)|0;s=f[e+16>>2]|0;na=+p[k>>3];p[s+32>>3]=na;p[s>>3]=na;e=k+8|0;p[s+8>>3]=-+p[e>>3];p[s+24>>3]=+p[e>>3];p[s+16>>3]=+p[k+16>>3];p[s+40>>3]=+p[k+24>>3];k=o+36|0;s=f[k>>2]|0;if(s|0?(e=s+12|0,s=f[e>>2]|0,f[e>>2]=s+-1,(s|0)==1):0)CR(o);f[k>>2]=0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[B>>2]|0)>0){R=f[S>>2]|0;S=0;do{f[R+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[B>>2]|0))}B=f[P>>2]|0;if((B|0)!=(C|0))ZF(B);B=m+36|0;C=f[B>>2]|0;if(C|0?(P=C+12|0,C=f[P>>2]|0,f[P>>2]=C+-1,(C|0)==1):0)CR(m);f[B>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[v>>2]|0)>0){y=f[F>>2]|0;F=0;do{f[y+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[v>>2]|0))}v=f[E>>2]|0;if((v|0)!=(x|0))ZF(v);v=l+36|0;x=f[v>>2]|0;if(x|0?(E=x+12|0,x=f[E>>2]|0,f[E>>2]=x+-1,(x|0)==1):0)CR(l);f[v>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[t>>2]|0)>0){g=f[A>>2]|0;A=0;do{f[g+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[t>>2]|0))}t=f[z>>2]|0;if((t|0)!=(w|0))ZF(t);u=h;return}}function xva(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=l|0;var m=0,n=0,o=0;m=u;u=u+16|0;n=m;_$(n,101540);o=NYa(48)|0;WF(o);f[o>>2]=101568;f[o+4>>2]=g;p[o+8>>3]=e;b[o+16>>0]=0;f[o+20>>2]=h;f[o+24>>2]=i;f[o+28>>2]=j;p[o+32>>3]=k;f[o+40>>2]=l;l=NYa(16)|0;j=l+4|0;f[j>>2]=1;f[l>>2]=101680;f[l+8>>2]=o;f[j>>2]=(f[j>>2]|0)+1;i=f[j>>2]|0;f[j>>2]=i+-1;if((i|0)==1)ki[f[(f[l>>2]|0)+8>>2]&2047](l);Ah[f[(f[o>>2]|0)+32>>2]&255](o,a,c,d);d=f[j>>2]|0;f[j>>2]=d+-1;if((d|0)==1)ki[f[(f[l>>2]|0)+8>>2]&2047](l);if(!(f[n+4>>2]|0)){u=m;return}u=m;return}function yva(a){a=a|0;PYa(a);return}function zva(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Ava(a){a=a|0;OF(a);PYa(a);return}function Bva(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0.0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0.0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0.0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0.0,ud=0.0,vd=0.0,wd=0,xd=0.0,yd=0.0,zd=0.0,Ad=0,Bd=0,Cd=0,Dd=0.0,Ed=0,Fd=0.0,Gd=0.0,Hd=0.0,Id=0.0,Jd=0.0,Kd=0.0,Ld=0.0,Md=0.0,Nd=0.0,Od=0.0,Pd=0.0,Qd=0.0,Rd=0.0,Sd=0.0,Td=0.0,Ud=0,Vd=0.0,Wd=0.0,Xd=0.0,Yd=0.0,Zd=0.0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0.0,fe=0,ge=0,he=0,ie=0,je=0;g=u;u=u+7040|0;h=g+2128|0;i=g+5968|0;j=g+1064|0;k=g;l=g+4904|0;m=g+3840|0;o=g+3808|0;q=g+3752|0;r=g+3696|0;s=g+3688|0;t=g+3624|0;v=g+3560|0;w=g+3504|0;x=g+3832|0;y=g+3448|0;z=g+3824|0;A=g+3816|0;B=g+3336|0;C=g+3280|0;D=g+3224|0;E=g+3680|0;F=g+3616|0;_$(o,101692);do if((NS(c)|0)==65536){G=f[c+4>>2]|0;f[q>>2]=f[G>>2];H=q+4|0;I=G+4|0;f[H>>2]=f[I>>2];J=q+8|0;f[J>>2]=f[G+8>>2];f[q+12>>2]=f[G+12>>2];f[q+16>>2]=f[G+16>>2];f[q+20>>2]=f[G+20>>2];f[q+24>>2]=f[G+24>>2];f[q+28>>2]=f[G+28>>2];f[q+32>>2]=f[G+32>>2];K=f[G+36>>2]|0;f[q+36>>2]=K;f[q+40>>2]=J;J=q+48|0;L=q+44|0;f[L>>2]=J;f[J>>2]=0;f[q+52>>2]=0;if(K|0){J=K+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[I>>2]|0)<3){I=f[G+44>>2]|0;J=f[L>>2]|0;f[J>>2]=f[I>>2];f[J+4>>2]=f[I+4>>2];break}else{f[H>>2]=0;BR(q,G);break}}else OR(q,c,-1);while(0);do if((NS(d)|0)==65536){c=f[d+4>>2]|0;f[r>>2]=f[c>>2];G=r+4|0;H=c+4|0;f[G>>2]=f[H>>2];I=r+8|0;f[I>>2]=f[c+8>>2];f[r+12>>2]=f[c+12>>2];f[r+16>>2]=f[c+16>>2];f[r+20>>2]=f[c+20>>2];f[r+24>>2]=f[c+24>>2];f[r+28>>2]=f[c+28>>2];f[r+32>>2]=f[c+32>>2];J=f[c+36>>2]|0;f[r+36>>2]=J;L=r+40|0;f[L>>2]=I;I=r+48|0;K=r+44|0;f[K>>2]=I;f[I>>2]=0;f[r+52>>2]=0;if(J|0){I=J+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[H>>2]|0)<3){H=f[c+44>>2]|0;I=f[K>>2]|0;f[I>>2]=f[H>>2];f[I+4>>2]=f[H+4>>2];M=L;break}else{f[G>>2]=0;BR(r,c);M=L;break}}else{OR(r,d,-1);M=r+40|0}while(0);f[s>>2]=q;f[s+4>>2]=r;f[t>>2]=1124007936;d=t+4|0;L=t+8|0;c=t+40|0;G=d;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[c>>2]=L;I=t+48|0;K=t+44|0;f[K>>2]=I;f[I>>2]=0;f[t+52>>2]=0;f[v>>2]=1124007936;J=v+4|0;N=v+8|0;O=v+40|0;G=J;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[O>>2]=N;P=v+48|0;Q=v+44|0;f[Q>>2]=P;f[P>>2]=0;f[v+52>>2]=0;f[w>>2]=1124007936;R=w+4|0;S=w+8|0;T=w+40|0;G=R;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[T>>2]=S;S=w+48|0;U=w+44|0;f[U>>2]=S;f[S>>2]=0;f[w+52>>2]=0;W=f[a+4>>2]|0;X=q+40|0;Z=f[X>>2]|0;_=f[Z+4>>2]|0;$=f[Z>>2]|0;Z=f[M>>2]|0;if(((($|0)==(f[Z>>2]|0)?(_|0)==(f[Z+4>>2]|0):0)?(Z=(f[q>>2]|0)>>>3&511,(Z|0)==0?(Z|0)==((f[r>>2]|0)>>>3&511|0):0):0)?+p[a+8>>3]<1.0:0){aa=_;ba=$}else{f[h>>2]=0;f[h+4>>2]=0;G=c$(h,110)|0;ca=349441;H=G+110|0;do{b[G>>0]=b[ca>>0]|0;G=G+1|0;ca=ca+1|0}while((G|0)<(H|0));j$(-215,h,349552,349557,1114);d$(h);$=f[X>>2]|0;aa=f[$+4>>2]|0;ba=f[$>>2]|0}f[x>>2]=aa;f[x+4>>2]=ba;KS(e,x,13,-1,0,0);do if((NS(e)|0)==65536){x=f[e+4>>2]|0;f[y>>2]=f[x>>2];ba=y+4|0;aa=x+4|0;f[ba>>2]=f[aa>>2];$=y+8|0;f[$>>2]=f[x+8>>2];f[y+12>>2]=f[x+12>>2];f[y+16>>2]=f[x+16>>2];f[y+20>>2]=f[x+20>>2];f[y+24>>2]=f[x+24>>2];f[y+28>>2]=f[x+28>>2];f[y+32>>2]=f[x+32>>2];_=f[x+36>>2]|0;f[y+36>>2]=_;f[y+40>>2]=$;$=y+48|0;Z=y+44|0;f[Z>>2]=$;f[$>>2]=0;f[y+52>>2]=0;if(_|0){$=_+12|0;f[$>>2]=(f[$>>2]|0)+1}if((f[aa>>2]|0)<3){aa=f[x+44>>2]|0;$=f[Z>>2]|0;f[$>>2]=f[aa>>2];f[$+4>>2]=f[aa+4>>2];break}else{f[ba>>2]=0;BR(y,x);break}}else OR(y,e,-1);while(0);if((W|0)>0){da=+p[a+8>>3];ea=+(f[q+12>>2]|0);fa=+(f[q+8>>2]|0);e=0;ga=1.0;while(1){ga=ga*da;if(ga*ea<32.0|ga*fa<32.0){ha=e;break}x=e+1|0;if((x|0)>=(W|0)){ha=x;break}else e=x}if((ha|0)>-1){ia=ha;ja=30}else ka=y+36|0}else{ia=0;ja=30}if((ja|0)==30){ha=q+12|0;e=q+8|0;W=v+12|0;x=v+16|0;ba=i+4|0;aa=t+16|0;$=a+40|0;Z=h+8|0;_=h+12|0;la=h+4|0;ma=i+8|0;na=i+4|0;oa=z+4|0;pa=h+8|0;qa=h+4|0;ra=C+4|0;sa=C+8|0;ta=C+40|0;ua=C+48|0;va=C+44|0;wa=C+52|0;xa=D+4|0;ya=D+8|0;za=D+40|0;Aa=D+48|0;Ba=D+44|0;Ca=D+52|0;Da=h+8|0;Ea=h+4|0;Fa=h+8|0;Ga=h+12|0;Ha=h+4|0;Ia=i+8|0;Ja=i+4|0;Ka=E+4|0;La=h+8|0;Ma=h+12|0;Na=h+4|0;Oa=i+8|0;Pa=i+4|0;Qa=F+4|0;Ra=a+28|0;Sa=a+32|0;Ta=C+12|0;Ua=l+8|0;Va=l+4|0;Wa=m+8|0;Xa=m+4|0;Ya=h+4|0;Za=h+8|0;_a=h+40|0;$a=h+48|0;ab=h+44|0;bb=h+52|0;cb=i+8|0;db=i+12|0;eb=i+4|0;fb=h+16|0;gb=i+16|0;hb=i+44|0;ib=i+36|0;jb=i+4|0;kb=i+40|0;lb=i+48|0;mb=h+36|0;nb=C+16|0;ob=h+4|0;pb=B+56|0;qb=a+24|0;rb=v+36|0;sb=t+36|0;tb=t+12|0;ub=v+20|0;vb=t+20|0;wb=v+24|0;xb=t+24|0;yb=v+28|0;zb=t+28|0;Ab=v+32|0;Bb=t+32|0;Cb=D+36|0;Db=D+16|0;Eb=C+36|0;Fb=a+20|0;Gb=h+8|0;Hb=h+4|0;Ib=h+8|0;Jb=h+4|0;Kb=i+8|0;Lb=i+4|0;Mb=Kb;Nb=j+8|0;Ob=j+4|0;Pb=k+8|0;Qb=k+4|0;Rb=h+8|0;Sb=h+12|0;Tb=h+4|0;Ub=i+8|0;Vb=i+4|0;Wb=A+4|0;Xb=a+8|0;a=h+8|0;Yb=h+4|0;Zb=y+36|0;_b=y+4|0;$b=y+8|0;ac=y+12|0;bc=y+44|0;cc=y+16|0;dc=y+20|0;ec=y+24|0;fc=y+28|0;gc=y+32|0;hc=B+4|0;ic=B+8|0;jc=B+40|0;kc=B+48|0;lc=B+44|0;mc=B+52|0;nc=B+56|0;oc=B+60|0;pc=B+64|0;qc=B+96|0;rc=B+104|0;sc=B+100|0;tc=B+108|0;uc=B+56|0;vc=B+92|0;wc=B+72|0;xc=B+60|0;yc=B+96|0;zc=B+100|0;Ac=B+104|0;Bc=B+36|0;Cc=B+16|0;Dc=B+4|0;Ec=B+40|0;Fc=B+44|0;Gc=B+48|0;Hc=ia;while(1){ia=(Hc|0)>0;if(ia){fa=+p[Xb>>3];Ic=0;ga=1.0;while(1){ea=ga*fa;Ic=Ic+1|0;if((Ic|0)==(Hc|0)){Jc=ea;break}else ga=ea}}else Jc=1.0;ga=(1.0/Jc+-1.0)*.5;Ic=rNa(ga*5.0)|0|1;Kc=(Ic|0)>3?Ic:3;Ic=rNa(Jc*+(f[ha>>2]|0))|0;Lc=rNa(Jc*+(f[e>>2]|0))|0;do if(ia){if(((f[J>>2]|0)<3?(f[N>>2]|0)==(Lc|0):0)&(f[W>>2]|0)==(Ic|0)?!((f[x>>2]|0)==0?1:(f[v>>2]&4095|0)!=13):0)break;f[i>>2]=Lc;f[ba>>2]=Ic;AR(v,2,i,13)}else{Mc=f[Zb>>2]|0;if(Mc|0){Nc=Mc+12|0;f[Nc>>2]=(f[Nc>>2]|0)+1}Nc=f[rb>>2]|0;if(Nc|0?(Mc=Nc+12|0,Nc=f[Mc>>2]|0,f[Mc>>2]=Nc+-1,(Nc|0)==1):0)CR(v);f[rb>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[J>>2]|0)>0){Nc=f[O>>2]|0;Mc=0;do{f[Nc+(Mc<<2)>>2]=0;Mc=Mc+1|0;Oc=f[J>>2]|0}while((Mc|0)<(Oc|0));f[v>>2]=f[y>>2];if((Oc|0)<3)ja=50;else ja=52}else{f[v>>2]=f[y>>2];ja=50}if((ja|0)==50){ja=0;Mc=f[_b>>2]|0;if((Mc|0)<3){f[J>>2]=Mc;f[N>>2]=f[$b>>2];f[W>>2]=f[ac>>2];Mc=f[bc>>2]|0;Nc=f[Q>>2]|0;f[Nc>>2]=f[Mc>>2];f[Nc+4>>2]=f[Mc+4>>2]}else ja=52}if((ja|0)==52){ja=0;BR(v,y)}f[x>>2]=f[cc>>2];f[ub>>2]=f[dc>>2];f[wb>>2]=f[ec>>2];f[yb>>2]=f[fc>>2];f[Ab>>2]=f[gc>>2];f[rb>>2]=f[Zb>>2]}while(0);if(f[aa>>2]|0){Mc=f[d>>2]|0;if((Mc|0)<3)Pc=Y(f[tb>>2]|0,f[L>>2]|0)|0;else{Nc=f[c>>2]|0;Qc=0;Rc=1;while(1){Sc=Y(f[Nc+(Qc<<2)>>2]|0,Rc)|0;Qc=Qc+1|0;if((Qc|0)==(Mc|0)){Pc=Sc;break}else Rc=Sc}}if(!((Mc|0)==0|(Pc|0)==0)){f[Rb>>2]=0;f[Sb>>2]=0;f[h>>2]=16842752;f[Tb>>2]=t;Rc=Ub;f[Rc>>2]=0;f[Rc+4>>2]=0;f[i>>2]=33619968;f[Vb>>2]=v;f[A>>2]=Ic;f[Wb>>2]=Lc;fna(h,i,A,0.0,0.0,1);fa=1.0/+p[Xb>>3];Rc=a;f[Rc>>2]=0;f[Rc+4>>2]=0;f[h>>2]=33619968;f[Yb>>2]=v;WJ(v,h,-1,fa,0.0)}else ja=60}else ja=60;do if((ja|0)==60){ja=0;if(!(f[$>>2]&4)){XQ(h,Lc,Ic,13);Rc=f[h>>2]|0;Ah[f[(f[Rc>>2]|0)+12>>2]&255](Rc,h,v,-1);fj(h);break}else{f[Z>>2]=0;f[_>>2]=0;f[h>>2]=16842752;f[la>>2]=y;Rc=ma;f[Rc>>2]=0;f[Rc+4>>2]=0;f[i>>2]=33619968;f[na>>2]=v;f[z>>2]=Ic;f[oa>>2]=Lc;fna(h,i,z,0.0,0.0,3);Rc=pa;f[Rc>>2]=0;f[Rc+4>>2]=0;f[h>>2]=33619968;f[qa>>2]=v;WJ(v,h,-1,Jc,0.0);break}}while(0);f[B>>2]=1124007936;G=hc;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[jc>>2]=ic;f[lc>>2]=kc;f[kc>>2]=0;f[mc>>2]=0;f[nc>>2]=1124007936;G=oc;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[qc>>2]=pc;f[sc>>2]=rc;f[rc>>2]=0;f[tc>>2]=0;f[C>>2]=1124007936;G=ra;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[ta>>2]=sa;f[va>>2]=ua;f[ua>>2]=0;f[wa>>2]=0;f[D>>2]=1124007936;G=xa;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[za>>2]=ya;f[Ba>>2]=Aa;f[Aa>>2]=0;f[Ca>>2]=0;Mc=0;do{Rc=f[s+(Mc<<2)>>2]|0;Qc=Da;f[Qc>>2]=0;f[Qc+4>>2]=0;f[h>>2]=33619968;f[Ea>>2]=w;WJ(Rc,h,5,1.0,0.0);f[Fa>>2]=0;f[Ga>>2]=0;f[h>>2]=16842752;f[Ha>>2]=w;Rc=Ia;f[Rc>>2]=0;f[Rc+4>>2]=0;f[i>>2]=33619968;f[Ja>>2]=w;f[E>>2]=Kc;f[Ka>>2]=Kc;Hpa(h,i,E,ga,ga,4);f[La>>2]=0;f[Ma>>2]=0;f[h>>2]=16842752;f[Na>>2]=w;Rc=Oa;f[Rc>>2]=0;f[Rc+4>>2]=0;f[i>>2]=33619968;f[Pa>>2]=C;f[F>>2]=Ic;f[Qa>>2]=Lc;fna(h,i,F,1.0,0.0,1);Rc=B+(Mc*56|0)|0;Qc=f[Ra>>2]|0;fa=+p[Sa>>3];if((f[C>>2]&4095|0)!=5){f[h>>2]=0;f[ob>>2]=0;G=c$(h,55)|0;ca=349609;H=G+55|0;do{b[G>>0]=b[ca>>0]|0;G=G+1|0;ca=ca+1|0}while((G|0)<(H|0));j$(-215,h,349665,349557,120);d$(h)}Nc=f[Ta>>2]|0;Sc=f[sa>>2]|0;Tc=(Qc*6|0)+3|0;f[l>>2]=Ua;f[Va>>2]=Tc;if(Tc>>>0>264){Uc=OYa(Tc>>>0>1073741823?-1:Tc<<2)|0;f[l>>2]=Uc;Vc=Uc}else Vc=Ua;Uc=Qc<<1;Tc=(Nc+Uc|0)*3|0;f[m>>2]=Wa;f[Xa>>2]=Tc;if(Tc>>>0>264){Wc=OYa(Tc>>>0>1073741823?-1:Tc<<2)|0;f[m>>2]=Wc;Xc=Wc}else Xc=Wa;Wc=Vc+(Qc<<2)|0;Tc=Wc+(Uc<<2)+4|0;Yc=Tc+(Uc<<2)+4|0;Uc=Qc*3|0;Zc=Xc+(Uc<<2)|0;ea=fa<1.1920928955078125e-07?+(Qc|0)*.3:fa;_c=0-Qc|0;$c=(Qc|0)<(_c|0);if(!$c){da=ea*(ea*2.0);ea=0.0;ad=_c;while(1){bd=+V(+(+(Y(ad,0-ad|0)|0)/da));n[Wc+(ad<<2)>>2]=bd;ea=ea+bd;if((ad|0)>=(Qc|0))break;else ad=ad+1|0}da=1.0/ea;ad=_c;while(1){cd=Wc+(ad<<2)|0;fa=da*+n[cd>>2];n[cd>>2]=fa;n[Tc+(ad<<2)>>2]=+(ad|0)*fa;bd=+(Y(ad,ad)|0)*fa;n[Yc+(ad<<2)>>2]=bd;if((ad|0)<(Qc|0))ad=ad+1|0;else break}}f[h>>2]=1124007936;G=Ya;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[_a>>2]=Za;f[ab>>2]=$a;f[$a>>2]=0;f[bb>>2]=0;f[i>>2]=6;f[ba>>2]=6;AR(h,2,i,6);p[j>>3]=0.0;f[i>>2]=-1056833530;f[eb>>2]=j;f[cb>>2]=1;f[db>>2]=1;hL(h,i,fT()|0)|0;if($c){ad=f[fb>>2]|0;dd=ad;ed=ad}else{ad=f[fb>>2]|0;cd=f[f[ab>>2]>>2]|0;fd=ad+cd+8|0;gd=ad+(cd*3|0)+24|0;hd=ad+(cd*5|0)+40|0;cd=_c;while(1){da=+n[Wc+(cd<<2)>>2];ea=+(cd|0);id=_c;while(1){bd=da*+n[Wc+(id<<2)>>2];p[ad>>3]=+p[ad>>3]+bd;fa=+(id|0);jd=fa*(fa*bd);p[fd>>3]=+p[fd>>3]+jd;p[gd>>3]=+p[gd>>3]+fa*(fa*jd);p[hd>>3]=ea*(ea*jd)+ +p[hd>>3];if((id|0)<(Qc|0))id=id+1|0;else break}if((cd|0)<(Qc|0))cd=cd+1|0;else{dd=ad;ed=ad;break}}}ad=f[f[ab>>2]>>2]|0;ea=+p[dd+ad+8>>3];cd=dd+(ad<<2)|0;p[cd>>3]=ea;hd=dd+(ad*3|0)|0;p[hd>>3]=ea;p[ed+32>>3]=ea;p[ed+24>>3]=ea;p[ed+(ad<<1)+16>>3]=ea;p[cd+32>>3]=+p[hd+24>>3];ea=+p[dd+(ad*5|0)+40>>3];p[cd+24>>3]=ea;p[hd+32>>3]=ea;VQ(k,h,3);pqa(i,k);fj(k);hd=f[gb>>2]|0;cd=f[f[hb>>2]>>2]|0;ea=+p[hd+cd+8>>3];da=+p[hd+24>>3];jd=+p[hd+(cd*3|0)+24>>3];fa=+p[hd+(cd*5|0)+40>>3];cd=f[ib>>2]|0;if(cd|0?(hd=cd+12|0,cd=f[hd>>2]|0,f[hd>>2]=cd+-1,(cd|0)==1):0)CR(i);f[ib>>2]=0;f[gb>>2]=0;f[gb+4>>2]=0;f[gb+8>>2]=0;f[gb+12>>2]=0;if((f[jb>>2]|0)>0){cd=f[kb>>2]|0;hd=0;do{f[cd+(hd<<2)>>2]=0;hd=hd+1|0}while((hd|0)<(f[jb>>2]|0))}hd=f[hb>>2]|0;if((hd|0)!=(lb|0))ZF(hd);hd=f[mb>>2]|0;do if(hd|0){cd=hd+12|0;ad=f[cd>>2]|0;f[cd>>2]=ad+-1;if((ad|0)!=1)break;CR(h)}while(0);f[mb>>2]=0;f[fb>>2]=0;f[fb+4>>2]=0;f[fb+8>>2]=0;f[fb+12>>2]=0;if((f[Ya>>2]|0)>0){hd=f[_a>>2]|0;ad=0;do{f[hd+(ad<<2)>>2]=0;ad=ad+1|0}while((ad|0)<(f[Ya>>2]|0))}ad=f[ab>>2]|0;if((ad|0)!=($a|0))ZF(ad);do if((f[B+(Mc*56|0)+4>>2]|0)<3){if((f[B+(Mc*56|0)+8>>2]|0)!=(Sc|0)){ja=103;break}if((f[B+(Mc*56|0)+12>>2]|0)!=(Nc|0)){ja=103;break}if((f[Rc>>2]&4095|0)!=37){ja=103;break}if(!(f[B+(Mc*56|0)+16>>2]|0))ja=103}else ja=103;while(0);if((ja|0)==103){ja=0;f[i>>2]=Sc;f[ba>>2]=Nc;AR(Rc,2,i,37)}if((Sc|0)>0){ad=f[nb>>2]|0;hd=f[f[va>>2]>>2]|0;cd=f[B+(Mc*56|0)+16>>2]|0;gd=f[f[B+(Mc*56|0)+44>>2]>>2]|0;fd=(Nc|0)>0;_c=(Qc|0)<1;$c=(Qc|0)>0;id=Nc*3|0;kd=Sc+-1|0;ld=Qc+1|0;md=_c|fd^1;nd=0;do{bd=+n[Wc>>2];od=ad+(Y(nd,hd)|0)|0;pd=cd+(Y(nd,gd)|0)|0;do if(fd){qd=0;do{rd=qd*3|0;n[Zc+(rd<<2)>>2]=bd*+n[od+(qd<<2)>>2];n[Zc+(rd+2<<2)>>2]=0.0;n[Zc+(rd+1<<2)>>2]=0.0;qd=qd+1|0}while((qd|0)!=(Nc|0));if(md)break;else sd=1;do{td=+n[Wc+(sd<<2)>>2];ud=+n[Tc+(sd<<2)>>2];vd=+n[Yc+(sd<<2)>>2];qd=nd-sd|0;rd=ad+(Y((qd|0)>0?qd:0,hd)|0)|0;qd=sd+nd|0;wd=ad+(Y((kd|0)<(qd|0)?kd:qd,hd)|0)|0;qd=0;do{xd=+n[rd+(qd<<2)>>2];yd=+n[wd+(qd<<2)>>2];zd=xd+yd;Ad=qd*3|0;Bd=Zc+(Ad<<2)|0;Cd=Zc+(Ad+1<<2)|0;Dd=+n[Cd>>2]+ud*(yd-xd);Ed=Zc+(Ad+2<<2)|0;xd=vd*zd+ +n[Ed>>2];n[Bd>>2]=+n[Bd>>2]+td*zd;n[Cd>>2]=Dd;n[Ed>>2]=xd;qd=qd+1|0}while((qd|0)!=(Nc|0));sd=sd+1|0}while((sd|0)!=(ld|0))}while(0);if($c){od=0;do{f[Zc+(~od<<2)>>2]=f[Zc+(2-od<<2)>>2];qd=od+id|0;f[Zc+(qd<<2)>>2]=f[Zc+(qd+-3<<2)>>2];od=od+1|0}while((od|0)<(Uc|0))}a:do if(fd){td=bd;od=0;while(1){qd=od*3|0;vd=td*+n[Zc+(qd<<2)>>2];ud=td*+n[Zc+(qd+1<<2)>>2];xd=td*+n[Zc+(qd+2<<2)>>2];if(_c){Fd=vd;Gd=0.0;Hd=ud;Id=0.0;Jd=xd;Kd=0.0}else{Dd=vd;vd=0.0;zd=ud;ud=0.0;yd=xd;xd=0.0;qd=1;while(1){wd=(qd+od|0)*3|0;Ld=+n[Zc+(wd<<2)>>2];rd=(od-qd|0)*3|0;Md=+n[Zc+(rd<<2)>>2];Nd=Ld+Md;Od=+n[Wc+(qd<<2)>>2];Pd=Dd+Nd*Od;Qd=ud+Nd*+n[Yc+(qd<<2)>>2];Nd=+n[Tc+(qd<<2)>>2];Rd=vd+(Ld-Md)*Nd;Md=+n[Zc+(wd+1<<2)>>2];Ld=+n[Zc+(rd+1<<2)>>2];Sd=zd+Od*(Md+Ld);Td=xd+Nd*(Md-Ld);Ld=yd+Od*(+n[Zc+(wd+2<<2)>>2]+ +n[Zc+(rd+2<<2)>>2]);qd=qd+1|0;if((qd|0)==(ld|0)){Fd=Pd;Gd=Rd;Hd=Sd;Id=Qd;Jd=Ld;Kd=Td;break}else{Dd=Pd;vd=Rd;zd=Sd;ud=Qd;yd=Ld;xd=Td}}}qd=od*5|0;n[pd+(qd+1<<2)>>2]=ea*Gd;n[pd+(qd<<2)>>2]=ea*Hd;xd=da*Fd;n[pd+(qd+3<<2)>>2]=xd+jd*Id;n[pd+(qd+2<<2)>>2]=xd+jd*Jd;n[pd+(qd+4<<2)>>2]=fa*Kd;qd=od+1|0;if((qd|0)==(Nc|0))break a;td=+n[Wc>>2];od=qd}}while(0);nd=nd+1|0}while((nd|0)!=(Sc|0))}Sc=f[m>>2]|0;if((Sc|0)!=(Wa|0)){if(Sc|0)QYa(Sc);f[m>>2]=Wa;f[Xa>>2]=264}Sc=f[l>>2]|0;if((Sc|0)!=(Ua|0)){if(Sc|0)QYa(Sc);f[l>>2]=Ua;f[Va>>2]=264}Mc=Mc+1|0}while((Mc|0)<2);Tva(B,pb,v,D,0,f[N>>2]|0);Mc=f[qb>>2]|0;if((Mc|0)>0){Lc=Mc;Mc=0;do{Ic=f[Fb>>2]|0;Kc=(Mc|0)<(Lc+-1|0);Sc=f[W>>2]|0;nd=f[N>>2]|0;Wc=(Ic|0)/2|0;Nc=1024/(Sc|0)|0;ld=(Nc|0)<(Ic|0)?Ic:Nc;if(!(f[$>>2]&256)){ga=1.0/+(Y(Ic,Ic)|0);Nc=(((Wc<<1)+Sc|0)*5|0)+10|0;f[h>>2]=Gb;f[Hb>>2]=Nc;if(Nc>>>0>136){Zc=OYa(Nc>>>0>536870911?-1:Nc<<3)|0;f[h>>2]=Zc;Ud=Zc}else Ud=Gb;Zc=(Wc*5|0)+5|0;Nc=Ud+(Zc<<3)|0;Tc=f[Db>>2]|0;Yc=Sc*5|0;_c=(Sc|0)>0;if(_c){fa=+(Wc+2|0);fd=0;do{p[Nc+(fd<<3)>>3]=fa*+n[Tc+(fd<<2)>>2];fd=fd+1|0}while((fd|0)<(Yc|0))}fd=(Ic|0)>3;if(fd?(Uc=nd+-1|0,id=f[f[Ba>>2]>>2]|0,_c):0){$c=1;do{hd=Tc+(Y((Uc|0)<($c|0)?Uc:$c,id)|0)|0;kd=0;do{ad=Nc+(kd<<3)|0;p[ad>>3]=+p[ad>>3]+ +n[hd+(kd<<2)>>2];kd=kd+1|0}while((kd|0)<(Yc|0));$c=$c+1|0}while(($c|0)<(Wc|0))}if((nd|0)>0){$c=nd+-1|0;id=(Zc|0)>0;fa=+(Wc+2|0);Uc=Nc+8|0;kd=Nc+16|0;hd=Nc+24|0;ad=Nc+32|0;md=Tc;gd=0;cd=0;while(1){Qc=(f[x>>2]|0)+(Y(f[f[Q>>2]>>2]|0,gd)|0)|0;Rc=gd-Wc+-1|0;pd=f[f[Ba>>2]>>2]|0;od=md+(Y(pd,(Rc|0)>0?Rc:0)|0)|0;Rc=gd+Wc|0;qd=md+(Y(pd,($c|0)<(Rc|0)?$c:Rc)|0)|0;if(_c){Rc=0;do{pd=Nc+(Rc<<3)|0;p[pd>>3]=+p[pd>>3]+(+n[qd+(Rc<<2)>>2]-+n[od+(Rc<<2)>>2]);Rc=Rc+1|0}while((Rc|0)<(Yc|0))}if(id){Rc=0;do{p[Nc+(~Rc<<3)>>3]=+p[Nc+(4-Rc<<3)>>3];od=Rc+Yc|0;p[Nc+(od<<3)>>3]=+p[Nc+(od+-5<<3)>>3];Rc=Rc+1|0}while((Rc|0)!=(Zc|0))}jd=fa*+p[Nc>>3];da=fa*+p[Uc>>3];ea=fa*+p[kd>>3];bd=fa*+p[hd>>3];td=fa*+p[ad>>3];if(fd){xd=jd;yd=da;ud=ea;zd=bd;vd=td;Rc=1;while(1){od=Rc*5|0;Dd=xd+ +p[Nc+(od<<3)>>3];Td=yd+ +p[Nc+(od+1<<3)>>3];Ld=ud+ +p[Nc+(od+2<<3)>>3];Qd=zd+ +p[Nc+(od+3<<3)>>3];Sd=vd+ +p[Nc+(od+4<<3)>>3];Rc=Rc+1|0;if((Rc|0)>=(Wc|0)){Vd=Dd;Wd=Td;Xd=Ld;Yd=Qd;Zd=Sd;break}else{xd=Dd;yd=Td;ud=Ld;zd=Qd;vd=Sd}}}else{Vd=jd;Wd=da;Xd=ea;Yd=bd;Zd=td}if(_c){vd=Vd;zd=Wd;ud=Xd;yd=Yd;xd=Zd;Rc=0;do{od=(Rc+Wc|0)*5|0;qd=(Rc-Wc|0)*5|0;vd=vd+(+p[Nc+(od<<3)>>3]-+p[Nc+(qd+-5<<3)>>3]);zd=zd+(+p[Nc+(od+1<<3)>>3]-+p[Nc+(qd+-4<<3)>>3]);ud=ud+(+p[Nc+(od+2<<3)>>3]-+p[Nc+(qd+-3<<3)>>3]);yd=yd+(+p[Nc+(od+3<<3)>>3]-+p[Nc+(qd+-2<<3)>>3]);xd=xd+(+p[Nc+(od+4<<3)>>3]-+p[Nc+(qd+-1<<3)>>3]);Sd=ga*vd;Qd=ga*zd;Ld=ga*ud;Td=ga*yd;Dd=ga*xd;Rd=1.0/(Sd*Ld-Qd*Qd+.001);qd=Rc<<1;n[Qc+(qd<<2)>>2]=Rd*(Sd*Dd-Qd*Td);n[Qc+((qd|1)<<2)>>2]=Rd*(Ld*Td-Qd*Dd);Rc=Rc+1|0}while((Rc|0)!=(Sc|0))}Rc=(gd|0)==($c|0)?nd:gd-Ic|0;do if(Kc){if((Rc|0)!=(nd|0)&(Rc|0)<(cd+ld|0)){_d=cd;break}Tva(B,pb,v,D,cd,Rc);_d=Rc}else _d=cd;while(0);Rc=gd+1|0;if((Rc|0)>=(nd|0))break;md=f[Db>>2]|0;gd=Rc;cd=_d}$d=f[h>>2]|0}else $d=Ud;if(($d|0)!=(Gb|0)){if($d|0)QYa($d);f[h>>2]=Gb;f[Hb>>2]=136}}else{ga=+(Wc|0)*.3;cd=Wc<<1;gd=((cd+Sc|0)*5|0)+26|0;f[h>>2]=Ib;f[Jb>>2]=gd;if(gd>>>0>264){md=OYa(gd>>>0>1073741823?-1:gd<<2)|0;f[h>>2]=md;ae=md}else ae=Ib;md=Sc*5|0;gd=md+16|0;f[i>>2]=Kb;f[Lb>>2]=gd;if(gd>>>0>264){$c=OYa(gd>>>0>1073741823?-1:gd<<2)|0;f[i>>2]=$c;be=$c}else be=Mb;$c=Wc*5|0;gd=$c+21|0;f[j>>2]=Nb;f[Ob>>2]=gd;if(gd>>>0>264){Nc=OYa(gd>>>0>1073741823?-1:gd<<2)|0;f[j>>2]=Nc;ce=Nc}else ce=Nb;Nc=cd|1;f[k>>2]=Pb;f[Qb>>2]=Nc;if(Nc>>>0>264){cd=OYa(Nc>>>0>1073741823?-1:Nc<<2)|0;f[k>>2]=cd;de=cd}else de=Pb;cd=ae+($c+5<<2)+15&-16;Nc=be+15&-16;n[ce>>2]=1.0;gd=(Ic|0)<2;if(gd)ee=1.0;else{fa=ga*(ga*2.0);_c=1;ga=1.0;while(1){xd=+V(+(+(Y(_c,0-_c|0)|0)/fa));n[ce+(_c<<2)>>2]=xd;yd=ga+xd*2.0;if((_c|0)<(Wc|0)){_c=_c+1|0;ga=yd}else{ee=yd;break}}}ga=1.0/ee;_c=(Ic|0)<-1;if(!_c){fd=0;while(1){ad=ce+(fd<<2)|0;n[ad>>2]=ga*+n[ad>>2];if((fd|0)<(Wc|0))fd=fd+1|0;else break}}if((nd|0)>0){fd=(Sc|0)>0;ad=de+(Wc<<2)|0;hd=($c|0)>0;kd=nd+-1|0;Uc=0;Zc=0;while(1){Yc=(f[x>>2]|0)+(Y(f[f[Q>>2]>>2]|0,Uc)|0)|0;if(!_c){id=f[Db>>2]|0;Tc=f[f[Ba>>2]>>2]|0;Rc=0;while(1){Qc=Uc-Rc|0;qd=id+(Y((Qc|0)>0?Qc:0,Tc)|0)|0;f[de+(Wc-Rc<<2)>>2]=qd;qd=Rc+Uc|0;Qc=id+(Y((kd|0)<(qd|0)?kd:qd,Tc)|0)|0;f[de+(Rc+Wc<<2)>>2]=Qc;if((Wc|0)>(Rc|0))Rc=Rc+1|0;else break}}b:do if(fd){Rc=f[ad>>2]|0;if(gd){Tc=0;while(1){n[cd+(Tc<<2)>>2]=+n[Rc+(Tc<<2)>>2]*+n[ce>>2];Tc=Tc+1|0;if((Tc|0)>=(md|0))break b}}else fe=0;do{Tc=1;ga=+n[Rc+(fe<<2)>>2]*+n[ce>>2];while(1){ga=ga+(+n[(f[de+(Tc+Wc<<2)>>2]|0)+(fe<<2)>>2]+ +n[(f[de+(Wc-Tc<<2)>>2]|0)+(fe<<2)>>2])*+n[ce+(Tc<<2)>>2];if((Wc|0)<=(Tc|0))break;else Tc=Tc+1|0}n[cd+(fe<<2)>>2]=ga;fe=fe+1|0}while((fe|0)<(md|0))}while(0);if(hd){Rc=0;do{f[cd+(~Rc<<2)>>2]=f[cd+(4-Rc<<2)>>2];Tc=Rc+md|0;f[cd+(Tc<<2)>>2]=f[cd+(Tc+-5<<2)>>2];Rc=Rc+1|0}while((Rc|0)!=($c|0))}if(fd){if(gd){Rc=0;do{n[Nc+(Rc<<2)>>2]=+n[cd+(Rc<<2)>>2]*+n[ce>>2];Rc=Rc+1|0}while((Rc|0)<(md|0));ge=0}else{Rc=0;do{Tc=1;fa=+n[cd+(Rc<<2)>>2]*+n[ce>>2];while(1){id=Tc*5|0;fa=fa+ +n[ce+(Tc<<2)>>2]*(+n[cd+(Rc-id<<2)>>2]+ +n[cd+(id+Rc<<2)>>2]);if((Tc|0)>=(Wc|0))break;else Tc=Tc+1|0}n[Nc+(Rc<<2)>>2]=fa;Rc=Rc+1|0}while((Rc|0)<(md|0));ge=0}do{Rc=ge*5|0;yd=+n[Nc+(Rc<<2)>>2];xd=+n[Nc+(Rc+1<<2)>>2];ud=+n[Nc+(Rc+2<<2)>>2];zd=+n[Nc+(Rc+3<<2)>>2];vd=+n[Nc+(Rc+4<<2)>>2];td=1.0/(yd*ud-xd*xd+.001);Rc=ge<<1;n[Yc+(Rc<<2)>>2]=(yd*vd-xd*zd)*td;n[Yc+((Rc|1)<<2)>>2]=(ud*zd-xd*vd)*td;ge=ge+1|0}while((ge|0)!=(Sc|0))}Yc=(Uc|0)==(kd|0)?nd:Uc-Ic|0;do if(Kc){if((Yc|0)!=(nd|0)&(Yc|0)<(Zc+ld|0)){he=Zc;break}Tva(B,pb,v,D,Zc,Yc);he=Yc}else he=Zc;while(0);Uc=Uc+1|0;if((Uc|0)>=(nd|0))break;else Zc=he}ie=f[k>>2]|0}else ie=de;if((ie|0)!=(Pb|0)){if(ie|0)QYa(ie);f[k>>2]=Pb;f[Qb>>2]=264}Zc=f[j>>2]|0;if((Zc|0)!=(Nb|0)){if(Zc|0)QYa(Zc);f[j>>2]=Nb;f[Ob>>2]=264}Zc=f[i>>2]|0;if((Zc|0)!=(Kb|0)){if(Zc|0)QYa(Zc);f[i>>2]=Kb;f[Lb>>2]=264}Zc=f[h>>2]|0;if((Zc|0)!=(Ib|0)){if(Zc|0)QYa(Zc);f[h>>2]=Ib;f[Jb>>2]=264}}Mc=Mc+1|0;Lc=f[qb>>2]|0}while((Mc|0)<(Lc|0))}Lc=f[rb>>2]|0;if(Lc|0){Mc=Lc+12|0;f[Mc>>2]=(f[Mc>>2]|0)+1}Mc=f[sb>>2]|0;if(Mc|0?(Lc=Mc+12|0,Mc=f[Lc>>2]|0,f[Lc>>2]=Mc+-1,(Mc|0)==1):0)CR(t);f[sb>>2]=0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[d>>2]|0)>0){Mc=f[c>>2]|0;Lc=0;do{f[Mc+(Lc<<2)>>2]=0;Lc=Lc+1|0;je=f[d>>2]|0}while((Lc|0)<(je|0));f[t>>2]=f[v>>2];if((je|0)<3)ja=228;else ja=230}else{f[t>>2]=f[v>>2];ja=228}if((ja|0)==228){ja=0;Lc=f[J>>2]|0;if((Lc|0)<3){f[d>>2]=Lc;f[L>>2]=f[N>>2];f[tb>>2]=f[W>>2];Lc=f[Q>>2]|0;Mc=f[K>>2]|0;f[Mc>>2]=f[Lc>>2];f[Mc+4>>2]=f[Lc+4>>2]}else ja=230}if((ja|0)==230){ja=0;BR(t,v)}f[aa>>2]=f[x>>2];f[vb>>2]=f[ub>>2];f[xb>>2]=f[wb>>2];f[zb>>2]=f[yb>>2];f[Bb>>2]=f[Ab>>2];f[sb>>2]=f[rb>>2];Lc=f[Cb>>2]|0;if(Lc|0?(Mc=Lc+12|0,Lc=f[Mc>>2]|0,f[Mc>>2]=Lc+-1,(Lc|0)==1):0)CR(D);f[Cb>>2]=0;f[Db>>2]=0;f[Db+4>>2]=0;f[Db+8>>2]=0;f[Db+12>>2]=0;if((f[xa>>2]|0)>0){Lc=f[za>>2]|0;Mc=0;do{f[Lc+(Mc<<2)>>2]=0;Mc=Mc+1|0}while((Mc|0)<(f[xa>>2]|0))}Mc=f[Ba>>2]|0;if((Mc|0)!=(Aa|0))ZF(Mc);Mc=f[Eb>>2]|0;if(Mc|0?(Lc=Mc+12|0,Mc=f[Lc>>2]|0,f[Lc>>2]=Mc+-1,(Mc|0)==1):0)CR(C);f[Eb>>2]=0;f[nb>>2]=0;f[nb+4>>2]=0;f[nb+8>>2]=0;f[nb+12>>2]=0;if((f[ra>>2]|0)>0){Mc=f[ta>>2]|0;Lc=0;do{f[Mc+(Lc<<2)>>2]=0;Lc=Lc+1|0}while((Lc|0)<(f[ra>>2]|0))}Lc=f[va>>2]|0;if((Lc|0)!=(ua|0))ZF(Lc);Lc=f[vc>>2]|0;do if(Lc|0){Mc=Lc+12|0;Zc=f[Mc>>2]|0;f[Mc>>2]=Zc+-1;if((Zc|0)!=1)break;CR(uc)}while(0);f[vc>>2]=0;f[wc>>2]=0;f[wc+4>>2]=0;f[wc+8>>2]=0;f[wc+12>>2]=0;if((f[xc>>2]|0)>0){Lc=f[yc>>2]|0;Zc=0;do{f[Lc+(Zc<<2)>>2]=0;Zc=Zc+1|0}while((Zc|0)<(f[xc>>2]|0))}Zc=f[zc>>2]|0;if((Zc|0)!=(Ac|0))ZF(Zc);Zc=f[Bc>>2]|0;do if(Zc|0){Lc=Zc+12|0;Mc=f[Lc>>2]|0;f[Lc>>2]=Mc+-1;if((Mc|0)!=1)break;CR(B)}while(0);f[Bc>>2]=0;f[Cc>>2]=0;f[Cc+4>>2]=0;f[Cc+8>>2]=0;f[Cc+12>>2]=0;if((f[Dc>>2]|0)>0){Zc=f[Ec>>2]|0;Mc=0;do{f[Zc+(Mc<<2)>>2]=0;Mc=Mc+1|0}while((Mc|0)<(f[Dc>>2]|0))}Mc=f[Fc>>2]|0;if((Mc|0)!=(Gc|0))ZF(Mc);if(ia)Hc=Hc+-1|0;else{ka=Zb;break}}}Zb=f[ka>>2]|0;if(Zb|0?(Hc=Zb+12|0,Zb=f[Hc>>2]|0,f[Hc>>2]=Zb+-1,(Zb|0)==1):0)CR(y);f[ka>>2]=0;ka=y+16|0;Zb=y+4|0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;if((f[Zb>>2]|0)>0){ka=f[y+40>>2]|0;Hc=0;do{f[ka+(Hc<<2)>>2]=0;Hc=Hc+1|0}while((Hc|0)<(f[Zb>>2]|0))}Zb=f[y+44>>2]|0;if((Zb|0)!=(y+48|0))ZF(Zb);Zb=w+36|0;y=f[Zb>>2]|0;if(y|0?(Hc=y+12|0,y=f[Hc>>2]|0,f[Hc>>2]=y+-1,(y|0)==1):0)CR(w);f[Zb>>2]=0;Zb=w+16|0;f[Zb>>2]=0;f[Zb+4>>2]=0;f[Zb+8>>2]=0;f[Zb+12>>2]=0;if((f[R>>2]|0)>0){Zb=f[T>>2]|0;T=0;do{f[Zb+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[R>>2]|0))}R=f[U>>2]|0;if((R|0)!=(S|0))ZF(R);R=v+36|0;S=f[R>>2]|0;if(S|0?(U=S+12|0,S=f[U>>2]|0,f[U>>2]=S+-1,(S|0)==1):0)CR(v);f[R>>2]=0;R=v+16|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[J>>2]|0)>0){R=f[O>>2]|0;O=0;do{f[R+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[J>>2]|0))}J=f[Q>>2]|0;if((J|0)!=(P|0))ZF(J);J=t+36|0;P=f[J>>2]|0;if(P|0?(Q=P+12|0,P=f[Q>>2]|0,f[Q>>2]=P+-1,(P|0)==1):0)CR(t);f[J>>2]=0;J=t+16|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[d>>2]|0)>0){J=f[c>>2]|0;c=0;do{f[J+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[K>>2]|0;if((d|0)!=(I|0))ZF(d);d=r+36|0;I=f[d>>2]|0;if(I|0?(K=I+12|0,I=f[K>>2]|0,f[K>>2]=I+-1,(I|0)==1):0)CR(r);f[d>>2]=0;d=r+16|0;I=r+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[I>>2]|0)>0){d=f[M>>2]|0;M=0;do{f[d+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[I>>2]|0))}I=f[r+44>>2]|0;if((I|0)!=(r+48|0))ZF(I);I=q+36|0;r=f[I>>2]|0;do if(r|0){M=r+12|0;d=f[M>>2]|0;f[M>>2]=d+-1;if((d|0)!=1)break;CR(q)}while(0);f[I>>2]=0;I=q+16|0;r=q+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[r>>2]|0)>0){I=f[X>>2]|0;X=0;do{f[I+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[r>>2]|0))}r=f[q+44>>2]|0;if((r|0)!=(q+48|0))ZF(r);if(!(f[o+4>>2]|0)){u=g;return}u=g;return}function Cva(a){a=a|0;return}function Dva(a){a=a|0;return f[a+4>>2]|0}function Eva(a,b){a=a|0;b=b|0;f[a+4>>2]=b;return}function Fva(a){a=a|0;return +(+p[a+8>>3])}function Gva(a,b){a=a|0;b=+b;p[a+8>>3]=b;return}function Hva(a){a=a|0;return (b[a+16>>0]|0)!=0|0}function Iva(a,c){a=a|0;c=c|0;b[a+16>>0]=c&1;return}function Jva(a){a=a|0;return f[a+20>>2]|0}function Kva(a,b){a=a|0;b=b|0;f[a+20>>2]=b;return}function Lva(a){a=a|0;return f[a+24>>2]|0}function Mva(a,b){a=a|0;b=b|0;f[a+24>>2]=b;return}function Nva(a){a=a|0;return f[a+28>>2]|0}function Ova(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function Pva(a){a=a|0;return +(+p[a+32>>3])}function Qva(a,b){a=a|0;b=+b;p[a+32>>3]=b;return}function Rva(a){a=a|0;return f[a+40>>2]|0}function Sva(a,b){a=a|0;b=b|0;f[a+40>>2]=b;return}function Tva(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,V=0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0;h=u;u=u+16|0;i=h;j=f[c+12>>2]|0;k=f[c+8>>2]|0;l=f[b+16>>2]|0;m=(f[b+48>>2]|0)>>>2;if(!(((((f[d+4>>2]|0)<3?(f[d+8>>2]|0)==(k|0):0)?(f[d+12>>2]|0)==(j|0):0)?(f[d>>2]&4095|0)==37:0)?(f[d+16>>2]|0)!=0:0)){f[i>>2]=k;f[i+4>>2]=j;AR(d,2,i,37)}if((e|0)>=(g|0)){u=h;return}i=f[c+16>>2]|0;b=f[f[c+44>>2]>>2]|0;c=f[a+16>>2]|0;o=f[f[a+44>>2]>>2]|0;a=f[d+16>>2]|0;p=f[f[d+44>>2]>>2]|0;d=(j|0)>0;q=j+-1|0;r=k+-1|0;s=m+5|0;t=m+1|0;v=m+6|0;w=m+2|0;x=m+7|0;y=m+3|0;z=m+8|0;A=m+4|0;B=m+9|0;C=j+-10|0;D=k+-10|0;E=j+-5|0;F=k+-5|0;k=e;do{e=i+(Y(b,k)|0)|0;G=c+(Y(o,k)|0)|0;H=a+(Y(p,k)|0)|0;if(d){I=+(k|0);J=(k|0)<5;K=101712+(k<<2)|0;L=(k|0)<(F|0);M=101712+(r-k<<2)|0;N=(k+-5|0)>>>0>=D>>>0;O=0;do{P=O<<1;Q=+n[e+(P<<2)>>2];R=+n[e+((P|1)<<2)>>2];S=+(O|0)+Q;T=I+R;P=~~S;U=P-(+(P|0)>S&1)|0;P=~~T;V=P-(+(P|0)>T&1)|0;P=l+((Y(V,m)|0)<<2)+(U*5<<2)|0;W=S-+(U|0);S=T-+(V|0);if(U>>>0<q>>>0&V>>>0<r>>>0){T=1.0-W;X=1.0-S;Z=T*X;_=W*X;X=T*S;T=W*S;V=O*5|0;$=V;aa=Z*+n[P>>2]+_*+n[P+20>>2]+X*+n[P+(m<<2)>>2]+T*+n[P+(s<<2)>>2];ba=Z*+n[P+4>>2]+_*+n[P+24>>2]+X*+n[P+(t<<2)>>2]+T*+n[P+(v<<2)>>2];ca=(Z*+n[P+8>>2]+_*+n[P+28>>2]+X*+n[P+(w<<2)>>2]+T*+n[P+(x<<2)>>2]+ +n[G+(V+2<<2)>>2])*.5;da=(Z*+n[P+12>>2]+_*+n[P+32>>2]+X*+n[P+(y<<2)>>2]+T*+n[P+(z<<2)>>2]+ +n[G+(V+3<<2)>>2])*.5;ea=(Z*+n[P+16>>2]+_*+n[P+36>>2]+X*+n[P+(A<<2)>>2]+T*+n[P+(B<<2)>>2]+ +n[G+(V+4<<2)>>2])*.25}else{V=O*5|0;$=V;aa=0.0;ba=0.0;ca=+n[G+(V+2<<2)>>2];da=+n[G+(V+3<<2)>>2];ea=+n[G+(V+4<<2)>>2]*.5}V=$+1|0;T=R*ca+Q*ea+(+n[G+($<<2)>>2]-aa)*.5;X=Q*da+R*ea+(+n[G+(V<<2)>>2]-ba)*.5;if((O+-5|0)>>>0>=C>>>0|N){if((O|0)<5)fa=+n[101712+(O<<2)>>2];else fa=1.0;if((O|0)<(E|0))ga=1.0;else ga=+n[101712+(q-O<<2)>>2];if(J)ha=+n[K>>2];else ha=1.0;if(L)ia=1.0;else ia=+n[M>>2];R=fa*ga*ha*ia;ja=T*R;ka=X*R;la=ca*R;ma=da*R;na=ea*R}else{ja=T;ka=X;la=ca;ma=da;na=ea}X=na*na;n[H+($<<2)>>2]=la*la+X;n[H+(V<<2)>>2]=(la+ma)*na;n[H+($+2<<2)>>2]=ma*ma+X;n[H+($+3<<2)>>2]=ka*na+la*ja;n[H+($+4<<2)>>2]=ka*ma+na*ja;O=O+1|0}while((O|0)!=(j|0))}k=k+1|0}while((k|0)!=(g|0));u=h;return}function Uva(){Vva(1973420);Fd(958,1973420,x|0)|0;return}function Vva(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;b=u;u=u+16|0;c=b;d=a+4|0;e=a+12|0;g=a+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;h=NYa(1172)|0;Nwa(h);i=NYa(16)|0;j=i+4|0;f[j>>2]=1;f[i>>2]=101740;f[i+8>>2]=h;f[c>>2]=i;k=c+4|0;f[k>>2]=h;f[j>>2]=(f[j>>2]|0)+1;h=f[d>>2]|0;l=a+8|0;if((h|0)==(f[l>>2]|0))Xva(a,c);else{m=f[c>>2]|0;f[h>>2]=m;f[h+4>>2]=f[k>>2];if(!m)n=h;else{h=m+4|0;f[h>>2]=(f[h>>2]|0)+1;n=f[d>>2]|0}f[d>>2]=n+8}n=f[c>>2]|0;if(n|0?(h=n+4|0,m=f[h>>2]|0,f[h>>2]=m+-1,(m|0)==1):0)ki[f[(f[n>>2]|0)+8>>2]&2047](n);f[c>>2]=0;f[k>>2]=0;k=f[j>>2]|0;f[j>>2]=k+-1;if((k|0)==1)ki[f[(f[i>>2]|0)+8>>2]&2047](i);i=NYa(36)|0;Twa(i);k=NYa(16)|0;j=k+4|0;f[j>>2]=1;f[k>>2]=101760;f[k+8>>2]=i;f[c>>2]=k;n=c+4|0;f[n>>2]=i;f[j>>2]=(f[j>>2]|0)+1;i=f[g>>2]|0;m=a+20|0;if((i|0)==(f[m>>2]|0))Yva(e,c);else{h=f[c>>2]|0;f[i>>2]=h;f[i+4>>2]=f[n>>2];if(!h)o=i;else{i=h+4|0;f[i>>2]=(f[i>>2]|0)+1;o=f[g>>2]|0}f[g>>2]=o+8}o=f[c>>2]|0;if(o|0?(i=o+4|0,h=f[i>>2]|0,f[i>>2]=h+-1,(h|0)==1):0)ki[f[(f[o>>2]|0)+8>>2]&2047](o);f[c>>2]=0;f[n>>2]=0;n=f[j>>2]|0;f[j>>2]=n+-1;if((n|0)==1)ki[f[(f[k>>2]|0)+8>>2]&2047](k);k=NYa(108)|0;$wa(k);n=NYa(16)|0;j=n+4|0;f[j>>2]=1;f[n>>2]=101780;f[n+8>>2]=k;f[c>>2]=n;o=c+4|0;f[o>>2]=k;f[j>>2]=(f[j>>2]|0)+1;k=f[d>>2]|0;if((k|0)==(f[l>>2]|0))Xva(a,c);else{h=f[c>>2]|0;f[k>>2]=h;f[k+4>>2]=f[o>>2];if(!h)p=k;else{k=h+4|0;f[k>>2]=(f[k>>2]|0)+1;p=f[d>>2]|0}f[d>>2]=p+8}p=f[c>>2]|0;if(p|0?(k=p+4|0,h=f[k>>2]|0,f[k>>2]=h+-1,(h|0)==1):0)ki[f[(f[p>>2]|0)+8>>2]&2047](p);f[c>>2]=0;f[o>>2]=0;o=f[j>>2]|0;f[j>>2]=o+-1;if((o|0)==1)ki[f[(f[n>>2]|0)+8>>2]&2047](n);n=NYa(36)|0;fxa(n);o=NYa(16)|0;j=o+4|0;f[j>>2]=1;f[o>>2]=101800;f[o+8>>2]=n;f[c>>2]=o;p=c+4|0;f[p>>2]=n;f[j>>2]=(f[j>>2]|0)+1;n=f[g>>2]|0;if((n|0)==(f[m>>2]|0))Yva(e,c);else{h=f[c>>2]|0;f[n>>2]=h;f[n+4>>2]=f[p>>2];if(!h)q=n;else{n=h+4|0;f[n>>2]=(f[n>>2]|0)+1;q=f[g>>2]|0}f[g>>2]=q+8}q=f[c>>2]|0;if(q|0?(n=q+4|0,h=f[n>>2]|0,f[n>>2]=h+-1,(h|0)==1):0)ki[f[(f[q>>2]|0)+8>>2]&2047](q);f[c>>2]=0;f[p>>2]=0;p=f[j>>2]|0;f[j>>2]=p+-1;if((p|0)==1)ki[f[(f[o>>2]|0)+8>>2]&2047](o);o=NYa(104)|0;yxa(o);p=NYa(16)|0;j=p+4|0;f[j>>2]=1;f[p>>2]=101820;f[p+8>>2]=o;f[c>>2]=p;q=c+4|0;f[q>>2]=o;f[j>>2]=(f[j>>2]|0)+1;o=f[d>>2]|0;if((o|0)==(f[l>>2]|0))Xva(a,c);else{h=f[c>>2]|0;f[o>>2]=h;f[o+4>>2]=f[q>>2];if(!h)r=o;else{o=h+4|0;f[o>>2]=(f[o>>2]|0)+1;r=f[d>>2]|0}f[d>>2]=r+8}r=f[c>>2]|0;if(r|0?(o=r+4|0,h=f[o>>2]|0,f[o>>2]=h+-1,(h|0)==1):0)ki[f[(f[r>>2]|0)+8>>2]&2047](r);f[c>>2]=0;f[q>>2]=0;q=f[j>>2]|0;f[j>>2]=q+-1;if((q|0)==1)ki[f[(f[p>>2]|0)+8>>2]&2047](p);p=NYa(36)|0;uxa(p);q=NYa(16)|0;j=q+4|0;f[j>>2]=1;f[q>>2]=101840;f[q+8>>2]=p;f[c>>2]=q;r=c+4|0;f[r>>2]=p;f[j>>2]=(f[j>>2]|0)+1;p=f[g>>2]|0;if((p|0)==(f[m>>2]|0))Yva(e,c);else{h=f[c>>2]|0;f[p>>2]=h;f[p+4>>2]=f[r>>2];if(!h)s=p;else{p=h+4|0;f[p>>2]=(f[p>>2]|0)+1;s=f[g>>2]|0}f[g>>2]=s+8}s=f[c>>2]|0;if(s|0?(p=s+4|0,h=f[p>>2]|0,f[p>>2]=h+-1,(h|0)==1):0)ki[f[(f[s>>2]|0)+8>>2]&2047](s);f[c>>2]=0;f[r>>2]=0;r=f[j>>2]|0;f[j>>2]=r+-1;if((r|0)==1)ki[f[(f[q>>2]|0)+8>>2]&2047](q);q=NYa(1176)|0;iya(q);r=NYa(16)|0;j=r+4|0;f[j>>2]=1;f[r>>2]=101860;f[r+8>>2]=q;f[c>>2]=r;s=c+4|0;f[s>>2]=q;f[j>>2]=(f[j>>2]|0)+1;q=f[d>>2]|0;if((q|0)==(f[l>>2]|0))Xva(a,c);else{h=f[c>>2]|0;f[q>>2]=h;f[q+4>>2]=f[s>>2];if(!h)t=q;else{q=h+4|0;f[q>>2]=(f[q>>2]|0)+1;t=f[d>>2]|0}f[d>>2]=t+8}t=f[c>>2]|0;do if(t|0){q=t+4|0;h=f[q>>2]|0;f[q>>2]=h+-1;if((h|0)!=1)break;ki[f[(f[t>>2]|0)+8>>2]&2047](t)}while(0);f[c>>2]=0;f[s>>2]=0;s=f[j>>2]|0;f[j>>2]=s+-1;if((s|0)==1)ki[f[(f[r>>2]|0)+8>>2]&2047](r);r=NYa(36)|0;nya(r);s=NYa(16)|0;j=s+4|0;f[j>>2]=1;f[s>>2]=101880;f[s+8>>2]=r;f[c>>2]=s;t=c+4|0;f[t>>2]=r;f[j>>2]=(f[j>>2]|0)+1;r=f[g>>2]|0;if((r|0)==(f[m>>2]|0))Yva(e,c);else{h=f[c>>2]|0;f[r>>2]=h;f[r+4>>2]=f[t>>2];if(!h)v=r;else{r=h+4|0;f[r>>2]=(f[r>>2]|0)+1;v=f[g>>2]|0}f[g>>2]=v+8}v=f[c>>2]|0;do if(v|0){r=v+4|0;h=f[r>>2]|0;f[r>>2]=h+-1;if((h|0)!=1)break;ki[f[(f[v>>2]|0)+8>>2]&2047](v)}while(0);f[c>>2]=0;f[t>>2]=0;t=f[j>>2]|0;f[j>>2]=t+-1;if((t|0)==1)ki[f[(f[s>>2]|0)+8>>2]&2047](s);s=NYa(1172)|0;cya(s);t=NYa(16)|0;j=t+4|0;f[j>>2]=1;f[t>>2]=101900;f[t+8>>2]=s;f[c>>2]=t;v=c+4|0;f[v>>2]=s;f[j>>2]=(f[j>>2]|0)+1;s=f[d>>2]|0;if((s|0)==(f[l>>2]|0))Xva(a,c);else{h=f[c>>2]|0;f[s>>2]=h;f[s+4>>2]=f[v>>2];if(!h)w=s;else{s=h+4|0;f[s>>2]=(f[s>>2]|0)+1;w=f[d>>2]|0}f[d>>2]=w+8}w=f[c>>2]|0;do if(w|0){s=w+4|0;h=f[s>>2]|0;f[s>>2]=h+-1;if((h|0)!=1)break;ki[f[(f[w>>2]|0)+8>>2]&2047](w)}while(0);f[c>>2]=0;f[v>>2]=0;v=f[j>>2]|0;f[j>>2]=v+-1;if((v|0)==1)ki[f[(f[t>>2]|0)+8>>2]&2047](t);t=NYa(36)|0;bya(t);v=NYa(16)|0;j=v+4|0;f[j>>2]=1;f[v>>2]=101920;f[v+8>>2]=t;f[c>>2]=v;w=c+4|0;f[w>>2]=t;f[j>>2]=(f[j>>2]|0)+1;t=f[g>>2]|0;if((t|0)==(f[m>>2]|0))Yva(e,c);else{h=f[c>>2]|0;f[t>>2]=h;f[t+4>>2]=f[w>>2];if(!h)x=t;else{t=h+4|0;f[t>>2]=(f[t>>2]|0)+1;x=f[g>>2]|0}f[g>>2]=x+8}x=f[c>>2]|0;do if(x|0){t=x+4|0;h=f[t>>2]|0;f[t>>2]=h+-1;if((h|0)!=1)break;ki[f[(f[x>>2]|0)+8>>2]&2047](x)}while(0);f[c>>2]=0;f[w>>2]=0;w=f[j>>2]|0;f[j>>2]=w+-1;if((w|0)==1)ki[f[(f[v>>2]|0)+8>>2]&2047](v);v=NYa(156)|0;Oxa(v);w=NYa(16)|0;j=w+4|0;f[j>>2]=1;f[w>>2]=101940;f[w+8>>2]=v;f[c>>2]=w;x=c+4|0;f[x>>2]=v;f[j>>2]=(f[j>>2]|0)+1;v=f[d>>2]|0;if((v|0)==(f[l>>2]|0))Xva(a,c);else{a=f[c>>2]|0;f[v>>2]=a;f[v+4>>2]=f[x>>2];if(!a)y=v;else{v=a+4|0;f[v>>2]=(f[v>>2]|0)+1;y=f[d>>2]|0}f[d>>2]=y+8}y=f[c>>2]|0;do if(y|0){d=y+4|0;v=f[d>>2]|0;f[d>>2]=v+-1;if((v|0)!=1)break;ki[f[(f[y>>2]|0)+8>>2]&2047](y)}while(0);f[c>>2]=0;f[x>>2]=0;x=f[j>>2]|0;f[j>>2]=x+-1;if((x|0)==1)ki[f[(f[w>>2]|0)+8>>2]&2047](w);w=NYa(36)|0;Nxa(w);x=NYa(16)|0;j=x+4|0;f[j>>2]=1;f[x>>2]=101960;f[x+8>>2]=w;f[c>>2]=x;y=c+4|0;f[y>>2]=w;f[j>>2]=(f[j>>2]|0)+1;w=f[g>>2]|0;if((w|0)==(f[m>>2]|0))Yva(e,c);else{e=f[c>>2]|0;f[w>>2]=e;f[w+4>>2]=f[y>>2];if(!e)z=w;else{w=e+4|0;f[w>>2]=(f[w>>2]|0)+1;z=f[g>>2]|0}f[g>>2]=z+8}z=f[c>>2]|0;do if(z|0){g=z+4|0;w=f[g>>2]|0;f[g>>2]=w+-1;if((w|0)!=1)break;ki[f[(f[z>>2]|0)+8>>2]&2047](z)}while(0);f[c>>2]=0;f[y>>2]=0;y=f[j>>2]|0;f[j>>2]=y+-1;if((y|0)!=1){u=b;return}ki[f[(f[x>>2]|0)+8>>2]&2047](x);u=b;return}function Wva(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=a+12|0;c=f[b>>2]|0;if(c|0){d=a+16|0;e=f[d>>2]|0;if((e|0)==(c|0))g=c;else{h=e;do{e=h+-8|0;f[d>>2]=e;i=f[e>>2]|0;if(i|0?(j=i+4|0,k=f[j>>2]|0,f[j>>2]=k+-1,(k|0)==1):0)ki[f[(f[i>>2]|0)+8>>2]&2047](i);f[e>>2]=0;f[h+-4>>2]=0;h=f[d>>2]|0}while((h|0)!=(c|0));g=f[b>>2]|0}PYa(g)}g=f[a>>2]|0;if(!g)return;b=a+4|0;c=f[b>>2]|0;if((c|0)==(g|0))l=g;else{h=c;do{c=h+-8|0;f[b>>2]=c;d=f[c>>2]|0;if(d|0?(e=d+4|0,i=f[e>>2]|0,f[e>>2]=i+-1,(i|0)==1):0)ki[f[(f[d>>2]|0)+8>>2]&2047](d);f[c>>2]=0;f[h+-4>>2]=0;h=f[b>>2]|0}while((h|0)!=(g|0));l=f[a>>2]|0}PYa(l);return}function Xva(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)gXa(a);d=a+8|0;k=(f[d>>2]|0)-e|0;e=k>>2;l=k>>3>>>0<268435455?(e>>>0<h>>>0?h:e):536870911;do if(l)if(l>>>0>536870911){e=De(8)|0;UYa(e,358155);f[e>>2]=130560;Of(e|0,21520,875)}else{m=NYa(l<<3)|0;break}else m=0;while(0);e=m+(g<<3)|0;h=e;k=m+(l<<3)|0;l=f[b>>2]|0;f[e>>2]=l;f[m+(g<<3)+4>>2]=f[b+4>>2];if(!l){n=j;o=i}else{i=l+4|0;f[i>>2]=(f[i>>2]|0)+1;n=f[c>>2]|0;o=f[a>>2]|0}i=e+8|0;if((n|0)==(o|0)){p=h;q=n;r=n}else{l=e;e=n;n=h;do{h=e;e=e+-8|0;j=f[e>>2]|0;f[l+-8>>2]=j;f[l+-4>>2]=f[h+-4>>2];if(j|0){h=j+4|0;f[h>>2]=(f[h>>2]|0)+1}l=n+-8|0;n=l}while((e|0)!=(o|0));p=n;q=f[a>>2]|0;r=f[c>>2]|0}f[a>>2]=p;f[c>>2]=i;f[d>>2]=k;k=q;if((r|0)!=(k|0)){d=r;do{r=d;d=d+-8|0;i=f[d>>2]|0;if(i|0?(c=i+4|0,p=f[c>>2]|0,f[c>>2]=p+-1,(p|0)==1):0)ki[f[(f[i>>2]|0)+8>>2]&2047](i);f[d>>2]=0;f[r+-4>>2]=0}while((d|0)!=(k|0))}if(!q)return;PYa(q);return}function Yva(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)gXa(a);d=a+8|0;k=(f[d>>2]|0)-e|0;e=k>>2;l=k>>3>>>0<268435455?(e>>>0<h>>>0?h:e):536870911;do if(l)if(l>>>0>536870911){e=De(8)|0;UYa(e,358155);f[e>>2]=130560;Of(e|0,21520,875)}else{m=NYa(l<<3)|0;break}else m=0;while(0);e=m+(g<<3)|0;h=e;k=m+(l<<3)|0;l=f[b>>2]|0;f[e>>2]=l;f[m+(g<<3)+4>>2]=f[b+4>>2];if(!l){n=j;o=i}else{i=l+4|0;f[i>>2]=(f[i>>2]|0)+1;n=f[c>>2]|0;o=f[a>>2]|0}i=e+8|0;if((n|0)==(o|0)){p=h;q=n;r=n}else{l=e;e=n;n=h;do{h=e;e=e+-8|0;j=f[e>>2]|0;f[l+-8>>2]=j;f[l+-4>>2]=f[h+-4>>2];if(j|0){h=j+4|0;f[h>>2]=(f[h>>2]|0)+1}l=n+-8|0;n=l}while((e|0)!=(o|0));p=n;q=f[a>>2]|0;r=f[c>>2]|0}f[a>>2]=p;f[c>>2]=i;f[d>>2]=k;k=q;if((r|0)!=(k|0)){d=r;do{r=d;d=d+-8|0;i=f[d>>2]|0;if(i|0?(c=i+4|0,p=f[c>>2]|0,f[c>>2]=p+-1,(p|0)==1):0)ki[f[(f[i>>2]|0)+8>>2]&2047](i);f[d>>2]=0;f[r+-4>>2]=0}while((d|0)!=(k|0))}if(!q)return;PYa(q);return}function Zva(a){a=a|0;PYa(a);return}function _va(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function $va(a){a=a|0;PYa(a);return}function awa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function bwa(a){a=a|0;PYa(a);return}function cwa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function dwa(a){a=a|0;PYa(a);return}function ewa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function fwa(a){a=a|0;PYa(a);return}function gwa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function hwa(a){a=a|0;PYa(a);return}function iwa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function jwa(a){a=a|0;PYa(a);return}function kwa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function lwa(a){a=a|0;PYa(a);return}function mwa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function nwa(a){a=a|0;PYa(a);return}function owa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function pwa(a){a=a|0;PYa(a);return}function qwa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function rwa(a){a=a|0;PYa(a);return}function swa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function twa(a){a=a|0;PYa(a);return}function uwa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function vwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;switch(a|0){case 8:{f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;mS(d,e);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;iL(d,e,0);u=c;return}case 2:{f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;iL(d,e,1);u=c;return}case 3:{f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;iL(d,e,-1);u=c;return}case 4:{f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;iL(d,e,0);u=c;return}case 5:{f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;mS(d,e);u=c;return}case 6:{f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;mS(d,e);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;iL(d,e,1);u=c;return}case 7:{f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;mS(d,e);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;iL(d,e,-1);u=c;return}default:{u=c;return}}}function wwa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;if((g|0)>0)h=g;else{f[e>>2]=0;f[e+4>>2]=0;i=c$(e,14)|0;j=350864;k=i+14|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-215,e,350879,350902,69);d$(e);h=f[c>>2]|0}if((h|0)>=1048577){f[e>>2]=0;f[e+4>>2]=0;i=c$(e,21)|0;j=350957;k=i+21|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-215,e,350879,350902,70);d$(e)}h=c+4|0;g=f[h>>2]|0;if((g|0)>0)l=g;else{f[e>>2]=0;f[e+4>>2]=0;i=c$(e,15)|0;j=350979;k=i+15|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-215,e,350879,350902,71);d$(e);l=f[h>>2]|0}if((l|0)<1048577)m=l;else{f[e>>2]=0;f[e+4>>2]=0;i=c$(e,22)|0;j=350995;k=i+22|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-215,e,350879,350902,72);d$(e);m=f[h>>2]|0}l=f[c>>2]|0;g=W1a(m|0,((m|0)<0)<<31>>31|0,l|0,((l|0)<0)<<31>>31|0)|0;n=J;if(n>>>0<0|(n|0)==0&g>>>0<1073741825){o=l;p=m;f[a>>2]=o;q=a+4|0;f[q>>2]=p;u=d;return}f[e>>2]=0;f[e+4>>2]=0;i=c$(e,17)|0;j=351018;k=i+17|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-215,e,350879,350902,74);d$(e);o=f[c>>2]|0;p=f[h>>2]|0;f[a>>2]=o;q=a+4|0;f[q>>2]=p;u=d;return}function xwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+32|0;d=c;e=f[a>>2]|0;g=((f[a+4>>2]|0)-e|0)/56|0;h=g+1|0;if(h>>>0>76695844)gXa(a);i=((f[a+8>>2]|0)-e|0)/56|0;e=i<<1;j=i>>>0<38347922?(e>>>0<h>>>0?h:e):76695844;f[d+12>>2]=0;f[d+16>>2]=a+8;do if(j)if(j>>>0>76695844){e=De(8)|0;UYa(e,358155);f[e>>2]=130560;Of(e|0,21520,875)}else{k=NYa(j*56|0)|0;break}else k=0;while(0);f[d>>2]=k;e=k+(g*56|0)|0;h=d+8|0;f[h>>2]=e;f[d+4>>2]=e;f[d+12>>2]=k+(j*56|0);f[e>>2]=f[b>>2];j=k+(g*56|0)+4|0;i=b+4|0;l=f[i>>2]|0;f[j>>2]=l;m=k+(g*56|0)+8|0;f[m>>2]=f[b+8>>2];f[k+(g*56|0)+12>>2]=f[b+12>>2];f[k+(g*56|0)+16>>2]=f[b+16>>2];f[k+(g*56|0)+20>>2]=f[b+20>>2];f[k+(g*56|0)+24>>2]=f[b+24>>2];f[k+(g*56|0)+28>>2]=f[b+28>>2];f[k+(g*56|0)+32>>2]=f[b+32>>2];n=f[b+36>>2]|0;f[k+(g*56|0)+36>>2]=n;f[k+(g*56|0)+40>>2]=m;m=k+(g*56|0)+48|0;o=k+(g*56|0)+44|0;f[o>>2]=m;f[m>>2]=0;f[k+(g*56|0)+52>>2]=0;if(!n)p=l;else{l=n+12|0;f[l>>2]=(f[l>>2]|0)+1;p=f[i>>2]|0}if((p|0)<3){p=f[b+44>>2]|0;i=f[o>>2]|0;f[i>>2]=f[p>>2];f[i+4>>2]=f[p+4>>2];q=f[h>>2]|0;r=q+56|0;f[h>>2]=r;Qt(a,d);Rt(d);u=c;return}else{f[j>>2]=0;BR(e,b);q=f[h>>2]|0;r=q+56|0;f[h>>2]=r;Qt(a,d);Rt(d);u=c;return}}function ywa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+16|0;g=e;a:do if(d>>>0>=2?(h=QKa((c|0)==0?5694105:c,46)|0,h|0):0){i=h+1|0;h=0;while(1){if(!(NLa(b[i+h>>0]|0)|0)){j=h;break}k=h+1|0;if((k|0)<128)h=k;else{j=k;break}}h=f[493358]|0;if((f[493359]|0)!=(h|0)){k=(j|0)>0;l=(j|0)==0;m=h;h=0;b:while(1){n=f[m+(h<<3)+4>>2]|0;Gh[f[(f[n>>2]|0)+24>>2]&511](g,n);n=f[g>>2]|0;o=TKa((n|0)==0?5694105:n,40)|0;if(!o)d$(g);else{n=TKa(o+1|0,46)|0;o=(n|0)==0;if(k){if(!o){p=n;do{q=p+1|0;r=0;while(1){s=b[q+r>>0]|0;if(!(NLa(s)|0)){t=r;break}v=OKa(b[i+r>>0]|0)|0;if((v|0)!=(OKa(s)|0)){t=r;break}s=r+1|0;if((s|0)<(j|0))r=s;else{t=s;break}}if((t|0)==(j|0)?(NLa(b[q+j>>0]|0)|0)==0:0)break b;p=TKa(q+t+1|0,46)|0}while((p|0)!=0)}}else if(!o){p=n;do{if(l?(NLa(b[p+1>>0]|0)|0)==0:0)break b;p=TKa(p+2|0,46)|0}while((p|0)!=0)}d$(g)}p=h+1|0;m=f[493358]|0;if(p>>>0>=(f[493359]|0)-m>>3>>>0)break a;else h=p}m=f[(f[493358]|0)+(h<<3)+4>>2]|0;Gh[f[(f[m>>2]|0)+28>>2]&511](a,m);d$(g);u=e;return}}while(0);f[a>>2]=0;f[a+4>>2]=0;u=e;return}function zwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+64|0;e=d+56|0;g=d;_$(e,101972);do if((NS(b)|0)==65536){h=f[b+4>>2]|0;f[g>>2]=f[h>>2];i=g+4|0;j=h+4|0;f[i>>2]=f[j>>2];k=g+8|0;f[k>>2]=f[h+8>>2];f[g+12>>2]=f[h+12>>2];f[g+16>>2]=f[h+16>>2];f[g+20>>2]=f[h+20>>2];f[g+24>>2]=f[h+24>>2];f[g+28>>2]=f[h+28>>2];f[g+32>>2]=f[h+32>>2];l=f[h+36>>2]|0;f[g+36>>2]=l;f[g+40>>2]=k;k=g+48|0;m=g+44|0;f[m>>2]=k;f[k>>2]=0;f[g+52>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[h+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];break}else{f[i>>2]=0;BR(g,h);break}}else OR(g,b,-1);while(0);f[a>>2]=1124007936;b=a+4|0;h=a+8|0;i=a+40|0;j=b;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;j=a+48|0;f[a+44>>2]=j;f[j>>2]=0;f[a+52>>2]=0;Awa(g,c,2,a)|0;if(f[a+16>>2]|0){j=f[b>>2]|0;if((j|0)<3)n=Y(f[a+12>>2]|0,f[h>>2]|0)|0;else{h=f[i>>2]|0;i=0;b=1;while(1){k=Y(f[h+(i<<2)>>2]|0,b)|0;i=i+1|0;if((i|0)==(j|0)){n=k;break}else b=k}}if((c&128|0)==0&((j|0)!=0&(n|0)!=0))Bwa(g,a)}a=g+36|0;n=f[a>>2]|0;if(n|0?(j=n+12|0,n=f[j>>2]|0,f[j>>2]=n+-1,(n|0)==1):0)CR(g);f[a>>2]=0;a=g+16|0;n=g+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[n>>2]|0)>0){a=f[g+40>>2]|0;j=0;do{f[a+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[n>>2]|0))}n=f[g+44>>2]|0;if((n|0)!=(g+48|0))ZF(n);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function Awa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;g=u;u=u+160|0;h=g+104|0;i=g+96|0;j=g+80|0;k=g+24|0;l=g+16|0;m=g+8|0;n=g;o=g+88|0;p=a+16|0;if(f[p>>2]|0){q=f[a+4>>2]|0;if((q|0)<3)r=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{s=f[a+40>>2]|0;t=0;v=1;while(1){w=Y(f[s+(t<<2)>>2]|0,v)|0;t=t+1|0;if((t|0)==(q|0)){r=w;break}else v=w}}if(!(!((q|0)==0|(r|0)==0)?(f[a>>2]&16384|0)!=0:0))x=8}else x=8;if((x|0)==8){f[h>>2]=0;f[h+4>>2]=0;y=c$(h,34)|0;z=351104;A=y+34|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));j$(-215,h,351139,350902,711);d$(h)}f[i>>2]=0;f[j>>2]=0;f[k>>2]=1124007936;r=k+4|0;q=k+8|0;v=k+40|0;y=r;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[v>>2]=q;t=k+48|0;s=k+44|0;f[s>>2]=t;f[t>>2]=0;f[k+52>>2]=0;f[l>>2]=0;w=l+4|0;f[w>>2]=0;B=a+8|0;C=a+12|0;do if((Y(f[C>>2]|0,f[B>>2]|0)|0)>=1?(f[a>>2]&16384|0)!=0:0){D=f[493355]|0;if((f[493356]|0)==(D|0))E=0;else{F=D;D=0;G=0;while(1){H=f[F+(D<<3)+4>>2]|0;I=mi[f[(f[H>>2]|0)+36>>2]&255](H)|0;H=G>>>0<I>>>0?I:G;D=D+1|0;F=f[493355]|0;if(D>>>0>=(f[493356]|0)-F>>3>>>0){E=H;break}else G=H}}f[h>>2]=0;f[h+4>>2]=0;if(E|0)F1a(c$(h,E)|0,32,E|0)|0;G=Y(f[C>>2]|0,f[B>>2]|0)|0;F=f[a+4>>2]|0;if((F|0)>0)J=f[(f[a+44>>2]|0)+(F+-1<<2)>>2]|0;else J=0;F=Y(G,J)|0;G=f[h>>2]|0;K1a(((G|0)==0?5694105:G)|0,f[p>>2]|0,(F>>>0<E>>>0?F:E)|0)|0;F=f[493355]|0;a:do if((f[493356]|0)==(F|0))x=22;else{G=F;D=0;while(1){H=f[G+(D<<3)+4>>2]|0;if($h[f[(f[H>>2]|0)+40>>2]&255](H,h)|0)break;H=D+1|0;G=f[493355]|0;if(H>>>0>=(f[493356]|0)-G>>3>>>0){x=22;break a}else D=H}G=f[(f[493355]|0)+(D<<3)+4>>2]|0;Gh[f[(f[G>>2]|0)+44>>2]&511](m,G)}while(0);if((x|0)==22){f[m>>2]=0;f[m+4>>2]=0}d$(h);F=m+4|0;G=f[F>>2]|0;if(!G){K=0;L=F}else{if(!($h[f[(f[G>>2]|0)+16>>2]&255](G,a)|0)){R$(h,0);d$(l);G=f[h>>2]|0;if(!G)M=0;else{H=G+-4|0;f[H>>2]=(f[H>>2]|0)+1;M=f[h>>2]|0}f[l>>2]=M;f[w>>2]=f[h+4>>2];d$(h);H=f[l>>2]|0;G=NMa((H|0)==0?5694105:H,353339)|0;if(!G){K=0;L=F;break}H=Y(f[B>>2]|0,f[C>>2]|0)|0;I=f[a+4>>2]|0;if((I|0)>0)N=f[(f[a+44>>2]|0)+(I+-1<<2)>>2]|0;else N=0;I=Y(H,N)|0;if((xMa(f[p>>2]|0,1,I,G)|0)!=(I|0)){GMa(G)|0;f[h>>2]=0;f[h+4>>2]=0;y=c$(h,44)|0;z=351149;A=y+44|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));j$(-2,h,351139,350902,731);d$(h)}if(GMa(G)|0){f[h>>2]=0;f[h+4>>2]=0;y=c$(h,44)|0;z=351149;A=y+44|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));j$(-2,h,351139,350902,735);d$(h)}G=f[F>>2]|0;$h[f[(f[G>>2]|0)+12>>2]&255](G,l)|0}G=f[F>>2]|0;if(!(mi[f[(f[G>>2]|0)+24>>2]&255](G)|0)){G=f[m>>2]|0;if(G|0?(I=G+4|0,H=f[I>>2]|0,f[I>>2]=H+-1,(H|0)==1):0)ki[f[(f[G>>2]|0)+8>>2]&2047](G);f[m>>2]=0;f[F>>2]=0;if(!(f[w>>2]|0)){K=0;L=F;break}G=f[l>>2]|0;if(!(DMa((G|0)==0?5694105:G)|0)){K=0;L=F;break}G=HU(1974472,351194,32)|0;H=f[l>>2]|0;I=(H|0)==0?5694105:H;H=HU(G,I,xKa(I)|0)|0;bPa(h,H+(f[(f[H>>2]|0)+-12>>2]|0)|0);I=BQa(h,1975176)|0;G=$h[f[(f[I>>2]|0)+28>>2]&255](I,10)|0;CQa(h);qPa(H,G)|0;hPa(H)|0;hPa(H)|0;K=0;L=F;break}H=f[F>>2]|0;G=f[H+8>>2]|0;f[h>>2]=f[H+4>>2];f[h+4>>2]=G;wwa(n,h);G=f[F>>2]|0;H=mi[f[(f[G>>2]|0)+8>>2]&255](G)|0;do if(!(c&8)){G=H&4088;I=(c&2|0)==0?G:H;if((c&1|0)==0?(c&4|0)==0|(G|0)==0:0){O=I&7;break}O=I&7|16}else O=H;while(0);H=(d|0)==0;b:do if((d|2|0)==2){I=f[n>>2]|0;G=f[n+4>>2]|0;if(!H){P=O&4095;do if(((f[e+4>>2]|0)<3?(f[e+8>>2]|0)==(G|0):0)?(f[e+12>>2]|0)==(I|0):0){if((f[e>>2]&4095|0)!=(P|0))break;if(f[e+16>>2]|0){Q=e;break b}}while(0);f[h>>2]=G;f[h+4>>2]=I;AR(e,2,h,P);Q=e;break}D=t0(G,I,O)|0;f[j>>2]=D;JR(h,D,0,1,0,0);D=h+36|0;R=f[D>>2]|0;if(R|0){S=R+12|0;f[S>>2]=(f[S>>2]|0)+1}S=k+36|0;R=f[S>>2]|0;if(R|0?(T=R+12|0,R=f[T>>2]|0,f[T>>2]=R+-1,(R|0)==1):0)CR(k);f[S>>2]=0;R=k+16|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[r>>2]|0)>0){T=f[v>>2]|0;U=0;do{f[T+(U<<2)>>2]=0;U=U+1|0;V=f[r>>2]|0}while((U|0)<(V|0));f[k>>2]=f[h>>2];if((V|0)<3)x=59;else x=61}else{f[k>>2]=f[h>>2];x=59}if((x|0)==59){U=f[h+4>>2]|0;if((U|0)<3){f[r>>2]=U;f[q>>2]=f[h+8>>2];f[k+12>>2]=f[h+12>>2];U=f[h+44>>2]|0;T=f[s>>2]|0;f[T>>2]=f[U>>2];f[T+4>>2]=f[U+4>>2]}else x=61}if((x|0)==61)BR(k,h);U=h+16|0;f[R>>2]=f[U>>2];f[k+20>>2]=f[h+20>>2];f[k+24>>2]=f[h+24>>2];f[k+28>>2]=f[h+28>>2];f[k+32>>2]=f[h+32>>2];T=f[D>>2]|0;f[S>>2]=T;do if(T|0){I=T+12|0;G=f[I>>2]|0;f[I>>2]=G+-1;if((G|0)!=1)break;CR(h)}while(0);f[D>>2]=0;T=h+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[T>>2]|0)>0){S=f[h+40>>2]|0;R=0;do{f[S+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[T>>2]|0))}T=f[h+44>>2]|0;if((T|0)!=(h+48|0))ZF(T);Q=k}else{f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2];T=O&7;f[h>>2]=f[o>>2];f[h+4>>2]=f[o+4>>2];R=U0(h,1212424721>>>(T<<2)<<3&120|((T|0)==4|(T|2|0)==3?-2147483648:0),(O>>>3&511)+1|0)|0;f[i>>2]=R;JR(h,R,0,1,0,0);R=h+36|0;T=f[R>>2]|0;if(T|0){S=T+12|0;f[S>>2]=(f[S>>2]|0)+1}S=k+36|0;T=f[S>>2]|0;if(T|0?(U=T+12|0,T=f[U>>2]|0,f[U>>2]=T+-1,(T|0)==1):0)CR(k);f[S>>2]=0;T=k+16|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[r>>2]|0)>0){U=f[v>>2]|0;D=0;do{f[U+(D<<2)>>2]=0;D=D+1|0;W=f[r>>2]|0}while((D|0)<(W|0));f[k>>2]=f[h>>2];if((W|0)<3)x=87;else x=89}else{f[k>>2]=f[h>>2];x=87}if((x|0)==87){D=f[h+4>>2]|0;if((D|0)<3){f[r>>2]=D;f[q>>2]=f[h+8>>2];f[k+12>>2]=f[h+12>>2];D=f[h+44>>2]|0;U=f[s>>2]|0;f[U>>2]=f[D>>2];f[U+4>>2]=f[D+4>>2]}else x=89}if((x|0)==89)BR(k,h);D=h+16|0;f[T>>2]=f[D>>2];f[k+20>>2]=f[h+20>>2];f[k+24>>2]=f[h+24>>2];f[k+28>>2]=f[h+28>>2];f[k+32>>2]=f[h+32>>2];U=f[R>>2]|0;f[S>>2]=U;if(U|0?(G=U+12|0,U=f[G>>2]|0,f[G>>2]=U+-1,(U|0)==1):0)CR(h);f[R>>2]=0;U=h+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[U>>2]|0)>0){D=f[h+40>>2]|0;G=0;do{f[D+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[U>>2]|0))}U=f[h+44>>2]|0;if((U|0)!=(h+48|0))ZF(U);Q=k}while(0);U=f[F>>2]|0;G=$h[f[(f[U>>2]|0)+28>>2]&255](U,Q)|0;U=f[m>>2]|0;if(U|0?(D=U+4|0,R=f[D>>2]|0,f[D>>2]=R+-1,(R|0)==1):0)ki[f[(f[U>>2]|0)+8>>2]&2047](U);f[m>>2]=0;f[F>>2]=0;if(f[w>>2]|0?(U=f[l>>2]|0,DMa((U|0)==0?5694105:U)|0):0){U=HU(1974472,351194,32)|0;R=f[l>>2]|0;D=(R|0)==0?5694105:R;R=HU(U,D,xKa(D)|0)|0;bPa(h,R+(f[(f[R>>2]|0)+-12>>2]|0)|0);D=BQa(h,1975176)|0;U=$h[f[(f[D>>2]|0)+28>>2]&255](D,10)|0;CQa(h);qPa(R,U)|0;hPa(R)|0;hPa(R)|0}do if(G)if(H){X=f[j>>2]|0;break}else{X=(d|0)==1?f[i>>2]|0:e;break}else{V0(i);x0(j);if(e){R=e+36|0;U=f[R>>2]|0;do if(U|0){D=U+12|0;S=f[D>>2]|0;f[D>>2]=S+-1;if((S|0)!=1)break;CR(e)}while(0);f[R>>2]=0;U=e+16|0;S=e+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[S>>2]|0)>0){U=f[e+40>>2]|0;D=0;do{f[U+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[S>>2]|0));X=0}else X=0}else X=0}while(0);K=X;L=F}}else x=12;while(0);if((x|0)==12){f[m>>2]=0;x=m+4|0;f[x>>2]=0;K=0;L=x}x=f[m>>2]|0;if(x|0?(m=x+4|0,X=f[m>>2]|0,f[m>>2]=X+-1,(X|0)==1):0)ki[f[(f[x>>2]|0)+8>>2]&2047](x);f[L>>2]=0;d$(l);l=k+36|0;L=f[l>>2]|0;if(L|0?(x=L+12|0,L=f[x>>2]|0,f[x>>2]=L+-1,(L|0)==1):0)CR(k);f[l>>2]=0;l=k+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[r>>2]|0)>0){l=f[v>>2]|0;v=0;do{f[l+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[r>>2]|0))}r=f[s>>2]|0;if((r|0)==(t|0)){u=g;return K|0}ZF(r);u=g;return K|0}function Bwa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+208|0;g=e+176|0;h=e+88|0;i=e+56|0;k=e;if(!(f[a>>2]&16384)){l=1;vwa(l,c);u=e;return}m=f[a+16>>2]|0;n=f[a+4>>2]|0;if((n|0)<3)o=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{p=f[a+40>>2]|0;q=0;r=1;while(1){s=Y(f[p+(q<<2)>>2]|0,r)|0;q=q+1|0;if((q|0)==(n|0)){o=s;break}else r=s}}if((n|0)>0)t=f[(f[a+44>>2]|0)+(n+-1<<2)>>2]|0;else t=0;n=Y(t,o)|0;ePa(g);f[g>>2]=102e3;f[g+8>>2]=m;f[g+12>>2]=m;f[g+16>>2]=m+n;f[h>>2]=127172;f[h+8>>2]=127192;f[h+4>>2]=0;n=h+(f[31790]|0)|0;$Oa(n,g);f[n+72>>2]=0;f[n+76>>2]=-1;cza(i,h);if(fza(i)|0){vza(k,i,274);n=(d[k+48>>1]|0)==-1?1:j[k+50>>1]|0;m=k+12|0;if((b[m+11>>0]|0)<0)PYa(f[m>>2]|0);m=f[k>>2]|0;if(m|0){o=k+4|0;k=f[o>>2]|0;if((k|0)!=(m|0))f[o>>2]=k+(~((k+-8-m|0)>>>3)<<3);PYa(m)}v=n}else v=1;dza(i);EOa(h);WNa(g);l=v;vwa(l,c);u=e;return}function Cwa(a){a=a|0;WNa(a);return}function Dwa(a){a=a|0;WNa(a);PYa(a);return}function Ewa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;g=b+8|0;switch(e|0){case 1:{h=b+12|0;break}case 2:{h=b+16|0;break}default:h=g}e=(f[h>>2]|0)+c|0;c=f[g>>2]|0;g=c;if(e>>>0>=c>>>0?e>>>0<=(f[b+16>>2]|0)>>>0:0){f[b+12>>2]=e;b=e-g|0;i=b;j=((b|0)<0)<<31>>31}else{i=-1;j=-1}b=a;f[b>>2]=0;f[b+4>>2]=0;b=a+8|0;f[b>>2]=i;f[b+4>>2]=j;return}function Fwa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;g=u;u=u+144|0;h=g+136|0;i=g+80|0;j=g+72|0;k=g+16|0;l=g;_$(h,102056);do if((NS(c)|0)==65536){m=f[c+4>>2]|0;f[i>>2]=f[m>>2];n=i+4|0;o=m+4|0;f[n>>2]=f[o>>2];p=i+8|0;f[p>>2]=f[m+8>>2];f[i+12>>2]=f[m+12>>2];f[i+16>>2]=f[m+16>>2];f[i+20>>2]=f[m+20>>2];f[i+24>>2]=f[m+24>>2];f[i+28>>2]=f[m+28>>2];f[i+32>>2]=f[m+32>>2];q=f[m+36>>2]|0;f[i+36>>2]=q;f[i+40>>2]=p;p=i+48|0;r=i+44|0;f[r>>2]=p;f[p>>2]=0;f[i+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[m+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];s=i;break}else{f[n>>2]=0;BR(i,m);s=i;break}}else{OR(i,c,-1);s=i}while(0);switch((f[s>>2]|0)>>>3&511){case 0:case 2:case 3:break;default:{f[j>>2]=0;f[j+4>>2]=0;t=c$(j,47)|0;v=351265;w=t+47|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));j$(-215,j,351313,350902,880);d$(j)}}ywa(j,f[a>>2]|0,f[a+4>>2]|0);a=j+4|0;c=f[a>>2]|0;if(!c){f[k>>2]=0;f[k+4>>2]=0;t=c$(k,50)|0;v=351322;w=t+50|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));j$(-2,k,351313,350902,884);d$(k);x=f[a>>2]|0}else x=c;if(!($h[f[(f[x>>2]|0)+8>>2]&255](x,f[s>>2]&7)|0)){x=f[a>>2]|0;if(!($h[f[(f[x>>2]|0)+8>>2]&255](x,0)|0)){f[k>>2]=0;f[k+4>>2]=0;t=c$(k,29)|0;v=351036;w=t+29|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));j$(-215,k,351313,350902,888);d$(k)}f[k>>2]=1124007936;v=k+4|0;x=k+8|0;c=k+40|0;t=v;w=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));f[c>>2]=x;t=k+48|0;w=k+44|0;f[w>>2]=t;f[t>>2]=0;f[k+52>>2]=0;m=l+8|0;f[m>>2]=0;f[m+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=k;WJ(i,l,0,1.0,0.0);m=k+36|0;n=f[m>>2]|0;if(n|0){o=n+12|0;f[o>>2]=(f[o>>2]|0)+1}o=i+36|0;n=f[o>>2]|0;if(n|0?(p=n+12|0,n=f[p>>2]|0,f[p>>2]=n+-1,(n|0)==1):0)CR(i);f[o>>2]=0;n=i+16|0;p=i+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[p>>2]|0)>0){r=f[i+40>>2]|0;q=0;do{f[r+(q<<2)>>2]=0;q=q+1|0;y=f[p>>2]|0}while((q|0)<(y|0));f[s>>2]=f[k>>2];if((y|0)<3)z=25;else z=27}else{f[s>>2]=f[k>>2];z=25}if((z|0)==25){s=f[v>>2]|0;if((s|0)<3){f[p>>2]=s;f[i+8>>2]=f[x>>2];f[i+12>>2]=f[k+12>>2];x=f[w>>2]|0;s=f[i+44>>2]|0;f[s>>2]=f[x>>2];f[s+4>>2]=f[x+4>>2]}else z=27}if((z|0)==27)BR(i,k);z=k+16|0;f[n>>2]=f[z>>2];f[i+20>>2]=f[k+20>>2];f[i+24>>2]=f[k+24>>2];f[i+28>>2]=f[k+28>>2];f[i+32>>2]=f[k+32>>2];n=f[m>>2]|0;f[o>>2]=n;if(n|0?(o=n+12|0,n=f[o>>2]|0,f[o>>2]=n+-1,(n|0)==1):0)CR(k);f[m>>2]=0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[v>>2]|0)>0){z=f[c>>2]|0;c=0;do{f[z+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[v>>2]|0))}v=f[w>>2]|0;if((v|0)!=(t|0))ZF(v)}v=f[a>>2]|0;if($h[f[(f[v>>2]|0)+16>>2]&255](v,d)|0){v=f[a>>2]|0;t=ui[f[(f[v>>2]|0)+20>>2]&127](v,i,e)|0;v=f[a>>2]|0;ki[f[(f[v>>2]|0)+32>>2]&2047](v);if(t)A=1;else{f[k>>2]=0;f[k+4>>2]=0;t=c$(k,4)|0;b[t>>0]=99;b[t+1>>0]=111;b[t+2>>0]=100;b[t+3>>0]=101;j$(-215,k,351313,350902,899);d$(k);A=0}}else{R$(k,0);t=f[a>>2]|0;if(!($h[f[(f[t>>2]|0)+12>>2]&255](t,k)|0)){f[l>>2]=0;f[l+4>>2]=0;t=c$(l,4)|0;b[t>>0]=99;b[t+1>>0]=111;b[t+2>>0]=100;b[t+3>>0]=101;j$(-215,l,351313,350902,905);d$(l)}t=f[a>>2]|0;v=ui[f[(f[t>>2]|0)+20>>2]&127](t,i,e)|0;e=f[a>>2]|0;ki[f[(f[e>>2]|0)+32>>2]&2047](e);if(!v){f[l>>2]=0;f[l+4>>2]=0;e=c$(l,4)|0;b[e>>0]=99;b[e+1>>0]=111;b[e+2>>0]=100;b[e+3>>0]=101;j$(-215,l,351313,350902,909);d$(l)}e=f[k>>2]|0;a=NMa((e|0)==0?5694105:e,353317)|0;if(!a){f[l>>2]=0;f[l+4>>2]=0;e=c$(l,6)|0;b[e>>0]=b[351373]|0;b[e+1>>0]=b[351374]|0;b[e+2>>0]=b[351375]|0;b[e+3>>0]=b[351376]|0;b[e+4>>0]=b[351377]|0;b[e+5>>0]=b[351378]|0;j$(-215,l,351313,350902,912);d$(l)}RMa(a,0,2)|0;l=iMa(a)|0;e=d+4|0;t=f[e>>2]|0;w=f[d>>2]|0;c=t-w|0;z=w;w=t;if(l>>>0<=c>>>0){if(l>>>0<c>>>0?(t=z+l|0,(w|0)!=(t|0)):0)f[e>>2]=t}else TR(d,l-c|0);RMa(a,0,0)|0;c=f[d>>2]|0;l=MMa(c,1,(f[e>>2]|0)-c|0,a)|0;c=f[e>>2]|0;t=f[d>>2]|0;w=c-t|0;z=t;t=c;if(l>>>0<=w>>>0){if(l>>>0<w>>>0?(c=z+l|0,(t|0)!=(c|0)):0)f[e>>2]=c}else TR(d,l-w|0);GMa(a)|0;a=f[k>>2]|0;DMa((a|0)==0?5694105:a)|0;d$(k);A=v}v=f[j>>2]|0;if(v|0?(j=v+4|0,k=f[j>>2]|0,f[j>>2]=k+-1,(k|0)==1):0)ki[f[(f[v>>2]|0)+8>>2]&2047](v);v=i+36|0;k=f[v>>2]|0;if(k|0?(j=k+12|0,k=f[j>>2]|0,f[j>>2]=k+-1,(k|0)==1):0)CR(i);f[v>>2]=0;v=i+16|0;k=i+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[k>>2]|0)>0){v=f[i+40>>2]|0;j=0;do{f[v+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[k>>2]|0))}k=f[i+44>>2]|0;if((k|0)!=(i+48|0))ZF(k);if(!(f[h+4>>2]|0)){u=g;return A|0}u=g;return A|0}function Gwa(a){a=a|0;f[a>>2]=102084;oya(a+96|0);Owa(a);return}function Hwa(a){a=a|0;f[a>>2]=102084;oya(a+96|0);Owa(a);PYa(a);return}function Iwa(a){a=a|0;return f[a+12>>2]|0}function Jwa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=u;u=u+768|0;d=c;e=a+36|0;if(f[a+52>>2]|0){g=f[a+40>>2]|0;if((g|0)<3)h=Y(f[a+48>>2]|0,f[a+44>>2]|0)|0;else{i=f[a+76>>2]|0;j=0;k=1;while(1){l=Y(f[i+(j<<2)>>2]|0,k)|0;j=j+1|0;if((j|0)==(g|0)){h=l;break}else k=l}}k=a+96|0;if(!((g|0)==0|(h|0)==0))if(rya(k,e)|0){m=k;n=k}else{o=0;u=c;return o|0}else{p=k;q=k;r=9}}else{k=a+96|0;p=k;q=k;r=9}if((r|0)==9)if(qya(p,a+20|0)|0){m=p;n=q}else{o=0;u=c;return o|0}Nya(m,10);q=Rya(n)|0;p=a+1164|0;f[p>>2]=q;q=Rya(n)|0;a:do if((q|0)>35){k=Rya(n)|0;e=a+4|0;f[e>>2]=k;k=Rya(n)|0;h=a+8|0;f[h>>2]=k;k=(Rya(n)|0)>>16;g=a+1160|0;f[g>>2]=k;k=Rya(n)|0;j=a+1168|0;f[j>>2]=k;Nya(m,12);k=Rya(n)|0;Nya(m,q+-36|0);if((f[e>>2]|0)>0?(f[h>>2]|0)!=0:0){e=f[g>>2]|0;b:do switch(e|0){case 32:case 24:case 8:case 4:case 1:{c:do if(!(f[j>>2]|0)){if((e|0)>=9){s=0;r=24;break b}}else{i=e+-4|0;switch(i>>>2|i<<30|0){case 7:case 3:{r=16;break b;break}case 0:{if((f[j>>2]|0)==2)break c;else{t=h;v=0;w=0;break a}break}case 1:{if((f[j>>2]|0)==1)break c;else{t=h;v=0;w=0;break a}break}default:{t=h;v=0;w=0;break a}}}while(0);if(k>>>0<257){i=a+132|0;F1a(i|0,0,1024)|0;x=i;y=i;z=(k|0)==0?1<<e:k}else{f[d>>2]=0;f[d+4>>2]=0;i=c$(d,30)|0;l=351584;A=i+30|0;do{b[i>>0]=b[l>>0]|0;i=i+1|0;l=l+1|0}while((i|0)<(A|0));j$(-215,d,352924,351503,121);d$(d);l=a+132|0;F1a(l|0,0,1024)|0;x=l;y=l;z=k}Pya(n,x,z<<2)|0;if(Lza(y,f[g>>2]|0)|0)B=1;else{t=h;v=0;w=1;break a}break}case 16:{r=16;break}default:{t=h;v=0;w=0;break a}}while(0);if((r|0)==16){k=f[j>>2]|0;switch(k|0){case 3:case 0:{s=k;r=24;break}default:{t=h;v=0;w=0;break a}}}d:do if((r|0)==24)if((e|0)==16){switch(s|0){case 3:break;case 0:{f[g>>2]=15;B=1;break d;break}default:{B=1;break d}}k=Rya(n)|0;l=Rya(n)|0;i=(Rya(n)|0)==31;if((k|0)==31744&((l|0)==992&i)){f[g>>2]=15;B=1;break}else{B=(k|0)==63488&((l|0)==2016&i);break}}else B=1;while(0);t=h;v=(f[g>>2]|0)==32?24:16;w=B}else{t=h;v=0;w=0}}else{if((q|0)!=12){t=a+8|0;v=0;w=0;break}e=Qya(n)|0;j=a+4|0;f[j>>2]=e;e=Qya(n)|0;i=a+8|0;f[i>>2]=e;e=(Rya(n)|0)>>16;f[a+1160>>2]=e;f[a+1168>>2]=0;if((f[j>>2]|0)>0?(f[i>>2]|0)!=0:0){switch(e|0){case 32:case 24:case 8:case 4:case 1:break;default:{t=i;v=0;w=0;break a}}if((e|0)<9){j=1<<e;Pya(n,d,3<<e)|0;e=0;do{l=e*3|0;b[a+132+(e<<2)>>0]=b[d+l>>0]|0;b[a+132+(e<<2)+1>>0]=b[d+(l+1)>>0]|0;b[a+132+(e<<2)+2>>0]=b[d+(l+2)>>0]|0;e=e+1|0}while((e|0)<(j|0));t=i;v=0;w=1}else{t=i;v=0;w=1}}else{t=i;v=0;w=0}}while(0);f[a+12>>2]=v;v=f[t>>2]|0;f[a+1156>>2]=(v|0)>0&1;f[t>>2]=(v|0)>-1?v:0-v|0;if(w){o=1;u=c;return o|0}f[p>>2]=-1;f[t>>2]=-1;f[a+4>>2]=-1;sya(m);o=0;u=c;return o|0}function Kwa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0;d=u;u=u+2448|0;e=d+2176|0;g=d+2192|0;i=d+2128|0;j=d+1080|0;k=d+32|0;l=d+2168|0;m=d+16|0;n=d+2184|0;o=d+2160|0;p=d+2156|0;q=d+2152|0;r=d+2144|0;s=d+2136|0;t=d+2120|0;v=d+1072|0;w=d+24|0;x=d+8|0;y=d;z=f[c+16>>2]|0;A=wza(f[c+48>>2]|0)|0;B=(f[c>>2]&4088|0)!=0;F1a(g|0,0,256)|0;C=a+4|0;D=f[C>>2]|0;E=a+1160|0;F=f[E>>2]|0;G=(((Y((F|0)==15?16:F,D)|0)+7|0)/8|0)+3&-4;F=B?3:1;H=Y(D,F)|0;D=a+1164|0;if((f[D>>2]|0)<0){I=0;u=d;return I|0}J=a+96|0;if(!(Jya(J)|0)){I=0;u=d;return I|0}if((f[a+1156>>2]|0)==1){K=z+(Y((f[a+8>>2]|0)+-1|0,A)|0)|0;L=0-A|0}else{K=z;L=A}A=j+8|0;f[j>>2]=A;z=j+4|0;f[z>>2]=1032;M=k+8|0;f[k>>2]=M;N=k+4|0;f[N>>2]=1032;O=G+32|0;f[z>>2]=O;if(O>>>0>1032){P=OYa(O)|0;f[j>>2]=P}do if(!B){P=f[E>>2]|0;if((P|0)<9){Jza(a+132|0,g,1<<P);Q=f[N>>2]|0}else Q=1032;P=((f[C>>2]|0)*3|0)+32|0;if(Q>>>0>=P>>>0){f[N>>2]=P;R=f[k>>2]|0;break}O=f[k>>2]|0;if((O|0)!=(M|0)){if(O|0)QYa(O);f[k>>2]=M;f[N>>2]=1032}f[N>>2]=P;if(P>>>0>1032){O=OYa(P)|0;f[k>>2]=O;R=O}else R=M}else R=M;while(0);Q=f[j>>2]|0;Lya(J,f[D>>2]|0);a:do switch(f[E>>2]|0){case 1:{f[i>>2]=0;D=a+8|0;if((f[D>>2]|0)>0){O=a+132|0;P=l+4|0;if(B){S=K;while(1){Pya(J,Q,G)|0;Sza(S,Q,f[C>>2]|0,O)|0;T=(f[i>>2]|0)+1|0;f[i>>2]=T;if((T|0)<(f[D>>2]|0))S=S+L|0;else{U=1;break}}}else{S=K;while(1){Pya(J,Q,G)|0;Sza(R,Q,f[C>>2]|0,O)|0;f[l>>2]=f[C>>2];f[P>>2]=1;f[e>>2]=f[l>>2];f[e+4>>2]=f[l+4>>2];xza(R,0,S,0,e,0);T=(f[i>>2]|0)+1|0;f[i>>2]=T;if((T|0)<(f[D>>2]|0))S=S+L|0;else{U=1;break}}}}else U=1;break}case 4:{switch(f[a+1168>>2]|0){case 0:{f[i>>2]=0;S=a+8|0;if((f[S>>2]|0)<=0){U=1;break a}D=a+132|0;if(B){P=K;while(1){Pya(J,Q,G)|0;Qza(P,Q,f[C>>2]|0,D)|0;O=(f[i>>2]|0)+1|0;f[i>>2]=O;if((O|0)<(f[S>>2]|0))P=P+L|0;else{U=1;break a}}}else{P=K;while(1){Pya(J,Q,G)|0;Rza(P,Q,f[C>>2]|0,g)|0;D=(f[i>>2]|0)+1|0;f[i>>2]=D;if((D|0)<(f[S>>2]|0))P=P+L|0;else{U=1;break a}}}break}case 2:break;default:{U=0;break a}}f[m>>2]=K+H;f[i>>2]=0;P=a+132|0;S=e+4|0;D=a+8|0;O=a+132|0;T=e+4|0;V=n+1|0;W=e+1|0;X=e+2|0;Z=K;while(1){_=Qya(J)|0;$=_&255;aa=_>>8;if($|0){ba=_>>12;_=a+132+(ba<<2)|0;ca=h[_>>0]|h[_+1>>0]<<8|h[_+2>>0]<<16|h[_+3>>0]<<24;f[e>>2]=ca;_=aa&15;da=a+132+(_<<2)|0;f[T>>2]=h[da>>0]|h[da+1>>0]<<8|h[da+2>>0]<<16|h[da+3>>0]<<24;da=b[g+ba>>0]|0;b[n>>0]=da;b[V>>0]=b[g+_>>0]|0;_=Y($,F)|0;$=Z+_|0;if($>>>0>(f[m>>2]|0)>>>0){ea=37;break}if(B){b[Z>>0]=ca;b[Z+1>>0]=b[W>>0]|0;b[Z+2>>0]=b[X>>0]|0;ca=Z+F|0;if(F>>>0<_>>>0){ba=ca;fa=1;while(1){b[ba>>0]=b[e+(fa<<2)>>0]|0;b[ba+1>>0]=b[e+(fa<<2)+1>>0]|0;b[ba+2>>0]=b[e+(fa<<2)+2>>0]|0;ga=ba+F|0;if(ga>>>0<$>>>0){ba=ga;fa=fa^1}else{ha=ga;break}}}else ha=ca}else{b[Z>>0]=da;fa=Z+F|0;if(F>>>0<_>>>0){ba=fa;ga=1;while(1){b[ba>>0]=b[n+ga>>0]|0;ia=ba+F|0;if(ia>>>0<$>>>0){ba=ia;ga=ga^1}else{ha=ia;break}}}else ha=fa}Z=ha;continue}ga=f[m>>2]|0;if((aa|0)>2){if((Z+(Y(aa,F)|0)|0)>>>0>ga>>>0){ja=0;break}ba=(aa+1>>1)+1&-2;if(ba>>>0>=(f[z>>2]|0)>>>0){f[e>>2]=0;f[S>>2]=0;ka=c$(e,24)|0;la=351478;ma=ka+24|0;do{b[ka>>0]=b[la>>0]|0;ka=ka+1|0;la=la+1|0}while((ka|0)<(ma|0));j$(-215,e,352667,351503,296);d$(e)}Pya(J,Q,ba)|0;if(B){Z=Qza(Z,Q,aa,P)|0;continue}else{Z=Rza(Z,Q,aa,g)|0;continue}}else{if((aa|0)==2){fa=Oya(J)|0;Oya(J)|0;na=Y(fa,F)|0}else na=ga-Z|0;fa=f[D>>2]|0;if(B){f[o>>2]=h[O>>0]|h[O+1>>0]<<8|h[O+2>>0]<<16|h[O+3>>0]<<24;b[e>>0]=b[o>>0]|0;b[e+1>>0]=b[o+1>>0]|0;b[e+2>>0]=b[o+2>>0]|0;b[e+3>>0]=b[o+3>>0]|0;oa=Mza(Z,m,L,H,i,fa,na,e)|0}else oa=Nza(Z,m,L,H,i,fa,na,b[g>>0]|0)|0;if((f[i>>2]|0)<(f[D>>2]|0)){Z=oa;continue}else{ja=1;break}}}if((ea|0)==37)ja=0;U=ja;break}case 8:{switch(f[a+1168>>2]|0){case 0:{f[i>>2]=0;Z=a+8|0;if((f[Z>>2]|0)<=0){U=1;break a}D=a+132|0;if(B){O=K;while(1){Pya(J,Q,G)|0;Oza(O,Q,f[C>>2]|0,D)|0;P=(f[i>>2]|0)+1|0;f[i>>2]=P;if((P|0)<(f[Z>>2]|0))O=O+L|0;else{U=1;break a}}}else{O=K;while(1){Pya(J,Q,G)|0;Pza(O,Q,f[C>>2]|0,g)|0;D=(f[i>>2]|0)+1|0;f[i>>2]=D;if((D|0)<(f[Z>>2]|0))O=O+L|0;else{U=1;break a}}}break}case 1:break;default:{U=0;break a}}f[m>>2]=K+H;f[i>>2]=0;O=a+132|0;Z=e+4|0;D=a+8|0;P=a+132|0;S=K;X=0;while(1){W=Qya(J)|0;V=W&255;T=W>>8;W=f[m>>2]|0;if(V|0){fa=f[i>>2]|0;$=Y(V,F)|0;if((S+$|0)>>>0>W>>>0){pa=0;break}V=f[D>>2]|0;if(B){_=a+132+(T<<2)|0;f[p>>2]=h[_>>0]|h[_+1>>0]<<8|h[_+2>>0]<<16|h[_+3>>0]<<24;b[e>>0]=b[p>>0]|0;b[e+1>>0]=b[p+1>>0]|0;b[e+2>>0]=b[p+2>>0]|0;b[e+3>>0]=b[p+3>>0]|0;qa=Mza(S,m,L,H,i,V,$,e)|0}else qa=Nza(S,m,L,H,i,V,$,b[g+T>>0]|0)|0;$=f[i>>2]|0;if(($|0)<(f[D>>2]|0)){S=qa;X=$-fa|0;continue}else{pa=1;break}}if((T|0)>2){fa=f[i>>2]|0;if((S+(Y(T,F)|0)|0)>>>0>W>>>0){pa=0;break}$=T+1&-2;if($>>>0>=(f[z>>2]|0)>>>0){f[e>>2]=0;f[Z>>2]=0;ka=c$(e,24)|0;la=351478;ma=ka+24|0;do{b[ka>>0]=b[la>>0]|0;ka=ka+1|0;la=la+1|0}while((ka|0)<(ma|0));j$(-215,e,352667,351503,390);d$(e)}Pya(J,Q,$)|0;if(B)ra=Oza(S,Q,T,O)|0;else ra=Pza(S,Q,T,g)|0;S=ra;X=(f[i>>2]|0)-fa|0;continue}ga=W-S|0;aa=(T|0)==0;if((ga|0)<(H|0)|(X|0)!=0&aa^1){ba=f[D>>2]|0;V=f[i>>2]|0;if((T|0)==2){_=Oya(J)|0;da=Oya(J)|0;ca=Y(_,F)|0;sa=f[i>>2]|0;ta=f[D>>2]|0;ua=ca;va=da}else{sa=V;ta=ba;ua=ga;va=ba-V|0}V=Y(va,H)|0;ba=(aa?0:V)+ua|0;if((sa|0)>=(ta|0)){pa=1;break}if(B){f[q>>2]=h[P>>0]|h[P+1>>0]<<8|h[P+2>>0]<<16|h[P+3>>0]<<24;b[e>>0]=b[q>>0]|0;b[e+1>>0]=b[q+1>>0]|0;b[e+2>>0]=b[q+2>>0]|0;b[e+3>>0]=b[q+3>>0]|0;wa=Mza(S,m,L,H,i,ta,ba,e)|0}else wa=Nza(S,m,L,H,i,ta,ba,b[g>>0]|0)|0;ba=f[i>>2]|0;V=f[D>>2]|0;if((ba|0)<(V|0)){xa=ba;ya=V;za=wa}else{pa=1;break}}else{xa=f[i>>2]|0;ya=f[D>>2]|0;za=S}if((xa|0)<(ya|0)){S=za;X=0}else{pa=1;break}}U=pa;break}case 15:{f[i>>2]=0;X=a+8|0;if((f[X>>2]|0)>0){S=s+4|0;D=r+4|0;if(B){P=K;while(1){Pya(J,Q,G)|0;f[s>>2]=f[C>>2];f[S>>2]=1;f[e>>2]=f[s>>2];f[e+4>>2]=f[s+4>>2];Fza(Q,0,P,0,e);O=(f[i>>2]|0)+1|0;f[i>>2]=O;if((O|0)<(f[X>>2]|0))P=P+L|0;else{U=1;break}}}else{P=K;while(1){Pya(J,Q,G)|0;f[r>>2]=f[C>>2];f[D>>2]=1;f[e>>2]=f[r>>2];f[e+4>>2]=f[r+4>>2];Dza(Q,0,P,0,e);S=(f[i>>2]|0)+1|0;f[i>>2]=S;if((S|0)<(f[X>>2]|0))P=P+L|0;else{U=1;break}}}}else U=1;break}case 16:{f[i>>2]=0;P=a+8|0;if((f[P>>2]|0)>0){X=v+4|0;D=t+4|0;if(B){S=K;while(1){Pya(J,Q,G)|0;f[v>>2]=f[C>>2];f[X>>2]=1;f[e>>2]=f[v>>2];f[e+4>>2]=f[v+4>>2];Gza(Q,0,S,0,e);O=(f[i>>2]|0)+1|0;f[i>>2]=O;if((O|0)<(f[P>>2]|0))S=S+L|0;else{U=1;break}}}else{S=K;while(1){Pya(J,Q,G)|0;f[t>>2]=f[C>>2];f[D>>2]=1;f[e>>2]=f[t>>2];f[e+4>>2]=f[t+4>>2];Eza(Q,0,S,0,e);X=(f[i>>2]|0)+1|0;f[i>>2]=X;if((X|0)<(f[P>>2]|0))S=S+L|0;else{U=1;break}}}}else U=1;break}case 24:{f[i>>2]=0;S=a+8|0;if((f[S>>2]|0)>0){P=w+4|0;if(B){D=K;while(1){Pya(J,Q,G)|0;K1a(D|0,Q|0,(f[C>>2]|0)*3|0)|0;X=(f[i>>2]|0)+1|0;f[i>>2]=X;if((X|0)<(f[S>>2]|0))D=D+L|0;else{U=1;break}}}else{D=K;while(1){Pya(J,Q,G)|0;f[w>>2]=f[C>>2];f[P>>2]=1;f[e>>2]=f[w>>2];f[e+4>>2]=f[w+4>>2];xza(Q,0,D,0,e,0);X=(f[i>>2]|0)+1|0;f[i>>2]=X;if((X|0)<(f[S>>2]|0))D=D+L|0;else{U=1;break}}}}else U=1;break}case 32:{f[i>>2]=0;D=a+8|0;if((f[D>>2]|0)>0){S=y+4|0;P=x+4|0;if(B)Aa=K;else{X=K;while(1){Pya(J,Q,G)|0;f[x>>2]=f[C>>2];f[P>>2]=1;f[e>>2]=f[x>>2];f[e+4>>2]=f[x+4>>2];zza(Q,0,X,0,e,0);O=(f[i>>2]|0)+1|0;f[i>>2]=O;if((O|0)<(f[D>>2]|0))X=X+L|0;else{U=1;break a}}}while(1){Pya(J,Q,G)|0;switch((f[c>>2]|0)>>>3&511){case 2:{f[y>>2]=f[C>>2];f[S>>2]=1;f[e>>2]=f[y>>2];f[e+4>>2]=f[y+4>>2];Aza(Q,0,Aa,0,e,0);break}case 3:{K1a(Aa|0,Q|0,f[C>>2]<<2|0)|0;break}default:{}}X=(f[i>>2]|0)+1|0;f[i>>2]=X;if((X|0)<(f[D>>2]|0))Aa=Aa+L|0;else{U=1;break a}}}else U=1;break}default:{f[e>>2]=0;f[e+4>>2]=0;ka=c$(e,24)|0;la=351559;ma=ka+24|0;do{b[ka>>0]=b[la>>0]|0;ka=ka+1|0;la=la+1|0}while((ka|0)<(ma|0));j$(-2,e,352667,351503,492)}}while(0);e=f[k>>2]|0;if((e|0)!=(M|0)){if(e|0)QYa(e);f[k>>2]=M;f[N>>2]=1032}N=f[j>>2]|0;if((N|0)!=(A|0)){if(N|0)QYa(N);f[j>>2]=A;f[z>>2]=1032}I=U;u=d;return I|0}function Lwa(a){a=a|0;return 0}function Mwa(a,b){a=a|0;b=b|0;var c=0,d=0;b=NYa(1172)|0;Nwa(b);c=NYa(16)|0;d=c+4|0;f[d>>2]=1;f[c>>2]=101740;f[c+8>>2]=b;f[a>>2]=c;f[a+4>>2]=b;f[d>>2]=(f[d>>2]|0)+1;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1)return;ki[f[(f[c>>2]|0)+8>>2]&2047](c);return}function Nwa(a){a=a|0;var c=0,d=0;hAa(a);f[a>>2]=102084;c=a+96|0;Kya(c);f[c>>2]=104580;c=a+28|0;d$(c);d=c$(c,2)|0;b[d>>0]=66;b[d+1>>0]=77;f[a+1164>>2]=-1;b[a+92>>0]=1;f[a+1156>>2]=0;f[a+1160>>2]=0;f[a+1168>>2]=0;return}function Owa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=104740;b=a+36|0;c=a+72|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+52|0;b=a+40|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+76>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+80>>2]|0;if((b|0)==(a+84|0)){g=a+28|0;d$(g);h=a+20|0;d$(h);return}ZF(b);g=a+28|0;d$(g);h=a+20|0;d$(h);return}function Pwa(a){a=a|0;f[a>>2]=104796;d$(a+28|0);d$(a+12|0);d$(a+4|0);return}function Qwa(a){a=a|0;f[a>>2]=104796;d$(a+28|0);d$(a+12|0);d$(a+4|0);PYa(a);return}function Rwa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+1072|0;e=d+1064|0;g=d;h=d+40|0;i=f[c+12>>2]|0;j=f[c+8>>2]|0;k=(f[c>>2]|0)>>>3&511;l=k+1|0;m=Y(l,i)|0;n=m+3&-4;b[e>>0]=0;b[e+1>>0]=0;b[e+2>>0]=0;b[e+3>>0]=0;b[e+4>>0]=0;Tya(g);f[g>>2]=104660;o=a+20|0;p=f[o>>2]|0;if(!p){if(!(zya(g,a+12|0)|0)){q=0;xya(g);u=d;return q|0}}else if(!(Aya(g,p)|0)){q=0;xya(g);u=d;return q|0}p=k|0?54:1078;a=(Y(n,j)|0)+p|0;r=f[o>>2]|0;if(r|0?(o=a+271&-256,s=r+8|0,t=f[r>>2]|0,v=t,((f[s>>2]|0)-t|0)>>>0<o>>>0):0){w=r+4|0;x=(f[w>>2]|0)-t|0;y=NYa(o)|0;z=y+x|0;A=z+(0-x)|0;if((x|0)>0)K1a(A|0,v|0,x|0)|0;f[r>>2]=A;f[w>>2]=z;f[s>>2]=y+o;if(t|0)PYa(v)}Uya(g,351662,2);Wya(g,wza(a)|0);Wya(g,0);Wya(g,p);Wya(g,40);Wya(g,i);Wya(g,j);Vya(g,1);Vya(g,l<<3);Wya(g,0);Wya(g,0);Wya(g,0);Wya(g,0);Wya(g,0);Wya(g,0);if(!k){Kza(h,8,0);Uya(g,h,1024)}h=j+-1|0;if((j|0)>0){j=c+16|0;k=c+44|0;c=n-m|0;if((n|0)>(m|0)){n=h;while(1){Uya(g,(f[j>>2]|0)+(Y(f[f[k>>2]>>2]|0,n)|0)|0,m);Uya(g,e,c);if((n|0)>0)n=n+-1|0;else break}}else{n=h;while(1){Uya(g,(f[j>>2]|0)+(Y(f[f[k>>2]>>2]|0,n)|0)|0,m);if((n|0)>0)n=n+-1|0;else break}}}Bya(g);q=1;xya(g);u=d;return q|0}function Swa(a,b){a=a|0;b=b|0;var c=0,d=0;b=NYa(36)|0;Twa(b);c=NYa(16)|0;d=c+4|0;f[d>>2]=1;f[c>>2]=101760;f[c+8>>2]=b;f[a>>2]=c;f[a+4>>2]=b;f[d>>2]=(f[d>>2]|0)+1;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1)return;ki[f[(f[c>>2]|0)+8>>2]&2047](c);return}function Twa(a){a=a|0;var c=0,d=0,e=0;iAa(a);f[a>>2]=102140;c=a+4|0;d$(c);d=c$(c,28)|0;c=351633;e=d+28|0;do{b[d>>0]=b[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(e|0));b[a+24>>0]=1;return}function Uwa(a){a=a|0;f[a>>2]=102184;d$(a+96|0);Owa(a);return}function Vwa(a){a=a|0;f[a>>2]=102184;d$(a+96|0);Owa(a);PYa(a);return}function Wwa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+20>>2]|0;c=NMa((b|0)==0?5694105:b,353317)|0;b=a+104|0;f[b>>2]=c;if(!c){d=0;return d|0}e=a+4|0;g=a+8|0;_ya(c,e,g,0)|0;if((f[e>>2]|0)>=1?(f[g>>2]|0)>=1:0){d=1;return d|0}GMa(f[b>>2]|0)|0;f[b>>2]=0;d=0;return d|0}function Xwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+80|0;d=c+56|0;e=c;g=f[a+8>>2]|0;h=f[a+4>>2]|0;f[e>>2]=1124007936;i=e+4|0;j=e+8|0;k=e+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;l=e+48|0;m=e+44|0;f[m>>2]=l;f[l>>2]=0;f[e+52>>2]=0;f[d>>2]=g;f[d+4>>2]=h;AR(e,2,d,21);h=a+104|0;g=f[h>>2]|0;if(!g)if(mi[f[(f[a>>2]|0)+24>>2]&255](a)|0){n=f[h>>2]|0;o=4}else p=0;else{n=g;o=4}do if((o|0)==4){bza(n,f[e+16>>2]|0,f[e+12>>2]|0,f[j>>2]|0)|0;GMa(f[h>>2]|0)|0;f[h>>2]=0;g=f[b>>2]|0;if(!((f[e>>2]^g)&7)){a=d+8|0;f[a>>2]=0;f[a+4>>2]=0;f[d>>2]=33619968;f[d+4>>2]=b;WJ(e,d,g&4095,1.0,0.0);p=1;break}else{a=d+8|0;f[a>>2]=0;f[a+4>>2]=0;f[d>>2]=33619968;f[d+4>>2]=b;WJ(e,d,g&4095,255.0,0.0);p=1;break}}while(0);d=e+36|0;b=f[d>>2]|0;if(b|0?(h=b+12|0,b=f[h>>2]|0,f[h>>2]=b+-1,(b|0)==1):0)CR(e);f[d>>2]=0;d=e+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[i>>2]|0)>0){d=f[k>>2]|0;k=0;do{f[d+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[m>>2]|0;if((i|0)==(l|0)){u=c;return p|0}ZF(i);u=c;return p|0}function Ywa(a){a=a|0;return f[((f[a+32>>2]|0)>>>0>(f[a+100>>2]|0)>>>0?a+28|0:a+96|0)+4>>2]|0}function Zwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+32>>2]|0;if((f[b+4>>2]|0)>>>0>=c>>>0){d=f[b>>2]|0;b=(d|0)==0?5694105:d;d=f[a+28>>2]|0;if(!(yKa(b,(d|0)==0?5694105:d,c)|0)){e=1;return e|0}c=f[a+96>>2]|0;if(!(yKa(b,(c|0)==0?5694105:c,f[a+100>>2]|0)|0)){e=1;return e|0}}e=0;return e|0}function _wa(a,b){a=a|0;b=b|0;var c=0,d=0;b=NYa(108)|0;$wa(b);c=NYa(16)|0;d=c+4|0;f[d>>2]=1;f[c>>2]=101780;f[c+8>>2]=b;f[a>>2]=c;f[a+4>>2]=b;f[d>>2]=(f[d>>2]|0)+1;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1)return;ki[f[(f[c>>2]|0)+8>>2]&2047](c);return}function $wa(a){a=a|0;var c=0,d=0,e=0;hAa(a);f[a>>2]=102184;c=a+96|0;f[c>>2]=0;f[a+100>>2]=0;d=a+28|0;d$(d);e=c$(d,6)|0;b[e>>0]=b[351683]|0;b[e+1>>0]=b[351684]|0;b[e+2>>0]=b[351685]|0;b[e+3>>0]=b[351686]|0;b[e+4>>0]=b[351687]|0;b[e+5>>0]=b[351688]|0;d$(c);e=c$(c,10)|0;c=351690;d=e+10|0;do{b[e>>0]=b[c>>0]|0;e=e+1|0;c=c+1|0}while((e|0)<(d|0));f[a+104>>2]=0;f[a+12>>2]=21;return}function axa(a){a=a|0;f[a>>2]=104796;d$(a+28|0);d$(a+12|0);d$(a+4|0);return}function bxa(a){a=a|0;f[a>>2]=104796;d$(a+28|0);d$(a+12|0);d$(a+4|0);PYa(a);return}function cxa(a,b){a=a|0;b=b|0;return (b|0)!=6|0}function dxa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+112|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g>>2]=1124007936;k=g+4|0;l=g+8|0;m=g+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=g+48|0;q=g+44|0;f[q>>2]=p;f[p>>2]=0;f[g+52>>2]=0;r=f[c>>2]|0;switch(r>>>3&511){case 0:case 2:{s=r;break}default:{f[h>>2]=0;f[h+4>>2]=0;n=c$(h,54)|0;t=351746;o=n+54|0;do{b[n>>0]=b[t>>0]|0;n=n+1|0;t=t+1|0}while((n|0)<(o|0));j$(-215,h,351801,351807,128);d$(h);s=f[c>>2]|0}}if(!(s&4088)){gxa(h,3,c);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=17104896;f[i+4>>2]=h;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=g;NI(i,j);Vt(h)}else{j=h+8|0;f[j>>2]=0;f[j+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=g;eL(c,h)}if((f[g>>2]&7|0)!=5){c=h+8|0;f[c>>2]=0;f[c+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=g;WJ(g,h,21,.003921568859368563,0.0)}c=f[d>>2]|0;j=d+4|0;if((c|0)!=(f[j>>2]|0)?(f[c>>2]|0)>>>0>=2:0){f[h>>2]=0;f[h+4>>2]=0;n=c$(h,63)|0;t=351863;o=n+63|0;do{b[n>>0]=b[t>>0]|0;n=n+1|0;t=t+1|0}while((n|0)<(o|0));j$(-215,h,351801,351807,138);d$(h)}h=f[a+12>>2]|0;a=NMa((h|0)==0?5694105:h,353339)|0;if(!a)v=0;else{h=g+12|0;Yya(a,f[h>>2]|0,f[l>>2]|0,0)|0;t=f[d>>2]|0;if((t|0)!=(f[j>>2]|0)?(f[t>>2]|0)!=1:0)$ya(a,f[g+16>>2]|0,Y(f[l>>2]|0,f[h>>2]|0)|0)|0;else aza(a,f[g+16>>2]|0,f[h>>2]|0,f[l>>2]|0)|0;GMa(a)|0;v=1}a=g+36|0;l=f[a>>2]|0;if(l|0?(h=l+12|0,l=f[h>>2]|0,f[h>>2]=l+-1,(l|0)==1):0)CR(g);f[a>>2]=0;a=g+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[k>>2]|0)>0){a=f[m>>2]|0;m=0;do{f[a+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[q>>2]|0;if((k|0)==(p|0)){u=e;return v|0}ZF(k);u=e;return v|0}function exa(a,b){a=a|0;b=b|0;var c=0,d=0;b=NYa(36)|0;fxa(b);c=NYa(16)|0;d=c+4|0;f[d>>2]=1;f[c>>2]=101800;f[c+8>>2]=b;f[a>>2]=c;f[a+4>>2]=b;f[d>>2]=(f[d>>2]|0)+1;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1)return;ki[f[(f[c>>2]|0)+8>>2]&2047](c);return}function fxa(a){a=a|0;var c=0,d=0;iAa(a);f[a>>2]=102240;c=a+4|0;d$(c);a=c$(c,26)|0;c=351719;d=a+26|0;do{b[a>>0]=b[c>>0]|0;a=a+1|0;c=c+1|0}while((a|0)<(d|0));return}function gxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f[a>>2]=0;d=a+4|0;f[d>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>76695844)gXa(a);e=NYa(b*56|0)|0;f[d>>2]=e;f[a>>2]=e;f[a+8>>2]=e+(b*56|0);a=c+4|0;g=c+8|0;h=c+12|0;i=c+16|0;j=c+20|0;k=c+24|0;l=c+28|0;m=c+32|0;n=c+36|0;o=c+44|0;p=e;e=b;do{f[p>>2]=f[c>>2];b=p+4|0;f[b>>2]=f[a>>2];q=p+8|0;f[q>>2]=f[g>>2];f[p+12>>2]=f[h>>2];f[p+16>>2]=f[i>>2];f[p+20>>2]=f[j>>2];f[p+24>>2]=f[k>>2];f[p+28>>2]=f[l>>2];f[p+32>>2]=f[m>>2];r=f[n>>2]|0;f[p+36>>2]=r;f[p+40>>2]=q;q=p+48|0;s=p+44|0;f[s>>2]=q;f[q>>2]=0;f[p+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[a>>2]|0)<3){q=f[o>>2]|0;r=f[s>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2]}else{f[b>>2]=0;BR(p,c)}p=(f[d>>2]|0)+56|0;f[d>>2]=p;e=e+-1|0}while((e|0)!=0);return}function hxa(a){a=a|0;var b=0,c=0;f[a>>2]=102284;b=a+100|0;c=f[b>>2]|0;if(c|0){cFa(c);PYa(c);f[b>>2]=0}b=a+96|0;c=f[b>>2]|0;if(c|0){GMa(c)|0;f[b>>2]=0}f[a+8>>2]=0;f[a+4>>2]=0;f[a+12>>2]=-1;Owa(a);return}function ixa(a){a=a|0;hxa(a);PYa(a);return}function jxa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0;c=u;u=u+16|0;d=4;e=dKa(40)|0;f[e>>2]=0;g=c;b[g>>0]=0;h=a+100|0;i=f[h>>2]|0;if(i){y=0;uc(959,i|0);j=y;y=0;if((j|0)!=0&(z|0)!=0){k=T1a(f[j>>2]|0,e|0,d|0)|0;if(!k)md(j|0,z|0);J=z}else k=-1;if((k|0)!=1){y=0;uc(960,i|0);i=y;y=0;if((i|0)!=0&(z|0)!=0){l=T1a(f[i>>2]|0,e|0,d|0)|0;if(!l)md(i|0,z|0);J=z}else l=-1;if((l|0)!=1){f[h>>2]=0;m=5}else{n=J;o=0;p=0;q=0;r=0;s=0;t=0}}else{n=J;o=0;p=0;q=0;r=0;s=0;t=0}}else m=5;do if((m|0)==5){l=a+96|0;i=f[l>>2]|0;if(i|0){y=0;wc(234,i|0)|0;i=y;y=0;if((i|0)!=0&(z|0)!=0){v=T1a(f[i>>2]|0,e|0,d|0)|0;if(!v)md(i|0,z|0);J=z}else v=-1;if((v|0)==1){n=J;o=0;p=0;q=0;r=0;s=0;t=l;break}f[l>>2]=0}i=a+8|0;f[i>>2]=0;k=a+4|0;f[k>>2]=0;j=a+12|0;f[j>>2]=-1;y=0;w=wc(235,808)|0;x=y;y=0;if((x|0)!=0&(z|0)!=0){A=T1a(f[x>>2]|0,e|0,d|0)|0;if(!A)md(x|0,z|0);J=z}else A=-1;if((A|0)!=1){f[h>>2]=w;x=w+488|0;y=0;B=wc(236,x|0)|0;C=y;y=0;if((C|0)!=0&(z|0)!=0){D=T1a(f[C>>2]|0,e|0,d|0)|0;if(!D)md(C|0,z|0);J=z}else D=-1;if((D|0)!=1){f[w>>2]=B;f[x>>2]=961;e=G1a(w+620|0,1,e|0,d|0)|0;d=J;y=0;x=y;y=0;if((x|0)!=0&(z|0)!=0){E=T1a(f[x>>2]|0,e|0,d|0)|0;if(!E)md(x|0,z|0);J=z}else E=-1;if((E|0)==1){n=J;o=j;p=k;q=i;r=w;s=w;t=l}else{n=0;o=j;p=k;q=i;r=w;s=w;t=l}}else{n=J;o=j;p=k;q=i;r=w;s=0;t=l}}else{n=J;o=j;p=k;q=i;r=w;s=0;t=l}}while(0);while(1){if(!n){y=0;pc(197,s|0,90,488);E=y;y=0;if((E|0)!=0&(z|0)!=0){F=T1a(f[E>>2]|0,e|0,d|0)|0;if(!F)md(E|0,z|0);J=z}else F=-1;if((F|0)==1){G=t;H=s;I=r;K=q;L=p;M=o;n=J;t=G;s=H;r=I;q=K;p=L;o=M;continue}E=f[a+52>>2]|0;D=E;if(E){E=f[a+40>>2]|0;if((E|0)<3)N=Y(f[a+48>>2]|0,f[a+44>>2]|0)|0;else{A=f[a+76>>2]|0;v=0;l=1;while(1){w=Y(f[A+(v<<2)>>2]|0,l)|0;v=v+1|0;if((v|0)==(E|0)){N=w;break}else l=w}}if(!((E|0)==0|(N|0)==0)){l=r+776|0;f[r+24>>2]=l;f[r+784>>2]=962;f[r+788>>2]=237;f[r+792>>2]=382;f[r+796>>2]=163;f[r+800>>2]=962;v=r+780|0;f[v>>2]=0;f[r+804>>2]=0;f[l>>2]=D;l=Y(f[a+44>>2]|0,f[a+48>>2]|0)|0;if((E|0)>0)O=f[(f[a+80>>2]|0)+(E+-1<<2)>>2]|0;else O=0;A=Y(l,O)|0;f[v>>2]=A}else m=23}else m=23;if((m|0)==23){m=0;A=f[a+20>>2]|0;y=0;v=jc(164,((A|0)==0?5694105:A)|0,353317)|0;A=y;y=0;if((A|0)!=0&(z|0)!=0){P=T1a(f[A>>2]|0,e|0,d|0)|0;if(!P)md(A|0,z|0);J=z}else P=-1;if((P|0)==1){G=t;H=s;I=r;K=q;L=p;M=o;n=J;t=G;s=H;r=I;q=K;p=L;o=M;continue}f[t>>2]=v;if(v|0){y=0;Qb(383,s|0,v|0);v=y;y=0;if((v|0)!=0&(z|0)!=0){Q=T1a(f[v>>2]|0,e|0,d|0)|0;if(!Q)md(v|0,z|0);J=z}else Q=-1;if((Q|0)==1){G=t;H=s;I=r;K=q;L=p;M=o;n=J;t=G;s=H;r=I;q=K;p=L;o=M;continue}}}if(f[r+24>>2]|0){y=0;jc(165,s|0,1)|0;v=y;y=0;if((v|0)!=0&(z|0)!=0){R=T1a(f[v>>2]|0,e|0,d|0)|0;if(!R)md(v|0,z|0);J=z}else R=-1;if((R|0)==1){G=t;H=s;I=r;K=q;L=p;M=o;n=J;t=G;s=H;r=I;q=K;p=L;o=M;continue}f[r+48>>2]=1;v=a+16|0;f[r+52>>2]=f[v>>2];f[v>>2]=1;y=0;uc(963,s|0);v=y;y=0;if((v|0)!=0&(z|0)!=0){S=T1a(f[v>>2]|0,e|0,d|0)|0;if(!S)md(v|0,z|0);J=z}else S=-1;if((S|0)==1){G=t;H=s;I=r;K=q;L=p;M=o;n=J;t=G;s=H;r=I;q=K;p=L;o=M;continue}f[p>>2]=f[r+112>>2];f[q>>2]=f[r+116>>2];f[o>>2]=(f[r+36>>2]|0)>1?16:0;b[g>>0]=1}}if(b[g>>0]&1){m=40;break}v=f[h>>2]|0;if(v|0){y=0;uc(959,v|0);A=y;y=0;if((A|0)!=0&(z|0)!=0){T=T1a(f[A>>2]|0,e|0,d|0)|0;if(!T)md(A|0,z|0);J=z}else T=-1;if((T|0)==1){G=t;H=s;I=r;K=q;L=p;M=o;n=J;t=G;s=H;r=I;q=K;p=L;o=M;continue}y=0;uc(960,v|0);v=y;y=0;if((v|0)!=0&(z|0)!=0){U=T1a(f[v>>2]|0,e|0,d|0)|0;if(!U)md(v|0,z|0);J=z}else U=-1;if((U|0)==1){G=t;H=s;I=r;K=q;L=p;M=o;n=J;t=G;s=H;r=I;q=K;p=L;o=M;continue}f[h>>2]=0}v=f[t>>2]|0;if(!v)break;y=0;wc(234,v|0)|0;v=y;y=0;if((v|0)!=0&(z|0)!=0){V=T1a(f[v>>2]|0,e|0,d|0)|0;if(!V)md(v|0,z|0);J=z}else V=-1;if((V|0)==1){G=t;H=s;I=r;K=q;L=p;M=o;n=J;t=G;s=H;r=I;q=K;p=L;o=M}else{m=38;break}}if((m|0)==38)f[t>>2]=0;else if((m|0)==40){W=b[g>>0]|0;X=W&1;Z=X<<24>>24!=0;eKa(e|0);u=c;return Z|0}f[q>>2]=0;f[p>>2]=0;f[o>>2]=-1;W=b[g>>0]|0;X=W&1;Z=X<<24>>24!=0;eKa(e|0);u=c;return Z|0}function kxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0;d=u;u=u+320|0;e=d+24|0;g=4;i=dKa(40)|0;f[i>>2]=0;j=d+296|0;k=d+40|0;l=d+32|0;m=d+16|0;n=d+8|0;o=d;b[l>>0]=0;p=f[c+48>>2]|0;q=(f[c>>2]&4088|0)!=0;r=a+100|0;s=f[r>>2]|0;if(s){t=a+4|0;if(f[t>>2]|0){v=a+8|0;if(f[v>>2]|0){i=G1a(s+620|0,1,i|0,g|0)|0;g=J;y=0;w=y;y=0;if((w|0)!=0&(z|0)!=0){x=T1a(f[w>>2]|0,i|0,g|0)|0;if(!x)md(w|0,z|0);J=z}else x=-1;if((x|0)==1){A=v;B=t;C=J;D=s;E=6}else{A=v;B=t;C=0;D=s;E=6}}else{F=v;G=t;H=0;E=40}}else{F=0;G=t;H=0;E=40}}else{I=0;K=0;L=0;E=44}a:while(1)if((E|0)==6){E=0;if(C|0){F=A;G=B;H=D;E=40;continue}t=s+196|0;if((((f[t>>2]|0)==0?(f[s+200>>2]|0)==0:0)?(v=s+180|0,(f[v>>2]|0)==0):0)?(f[s+184>>2]|0)==0:0){x=((h[351951]|0)<<8|(h[351952]|0))+-2|0;F1a(k|0,0,256)|0;b:do if(x>>>0>16){w=x;M=4;while(1){N=b[351949+M>>0]|0;O=M+1|0;P=j;Q=351950+M|0;R=P+16|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));S=h[351949+O>>0]|0;T=h[351949+(M+2)>>0]|0;U=h[351949+(M+3)>>0]|0;V=h[351949+(M+4)>>0]|0;W=h[351949+(M+5)>>0]|0;X=h[351949+(M+6)>>0]|0;Y=h[351949+(M+7)>>0]|0;Z=h[351949+(M+8)>>0]|0;_=h[351949+(M+9)>>0]|0;$=h[351949+(M+10)>>0]|0;aa=h[351949+(M+11)>>0]|0;ba=h[351949+(M+12)>>0]|0;ca=h[351949+(M+13)>>0]|0;da=h[351949+(M+14)>>0]|0;ea=h[351949+(M+15)>>0]|0;fa=h[351949+(M+16)>>0]|0;ga=T+S+U+V+W+X+Y+Z+_+$+aa+ba+ca+da+ea+fa|0;ha=N&255;ia=M+17|0;ja=w+-17|0;if(ga>>>0>256|ja>>>0<ga>>>0)break b;if(!ga)ka=ia;else{K1a(k|0,351966+M|0,ga|0)|0;ka=S+ia+T+U+V+W+X+Y+Z+_+$+aa+ba+ca+da+ea+fa|0}w=ja-ga|0;ga=(ha&16|0)==0;ja=ha&239;fa=ga?v+(ha<<2)|0:t+(ja<<2)|0;if((ga?ha:ja)>>>0>3)break b;ja=f[fa>>2]|0;if(!ja){y=0;ha=wc(238,s|0)|0;ga=y;y=0;if((ga|0)!=0&(z|0)!=0){la=T1a(f[ga>>2]|0,i|0,g|0)|0;if(!la)md(ga|0,z|0);J=z}else la=-1;if((la|0)==1){ma=D;na=B;oa=A;C=J;D=ma;B=na;A=oa;E=6;continue a}f[fa>>2]=ha;if(!ha)break b;else pa=ha}else pa=ja;b[pa>>0]=0;P=pa+1|0;Q=j;R=P+16|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));K1a((f[fa>>2]|0)+17|0,k|0,256)|0;if(w>>>0<=16)break;else M=ka}}while(0)}t=(f[s+36>>2]|0)!=4;v=t?1:4;f[s+44>>2]=q?(t?2:4):v;x=s+120|0;f[x>>2]=q?(t?3:4):v;y=0;wc(239,D|0)|0;v=y;y=0;if((v|0)!=0&(z|0)!=0){qa=T1a(f[v>>2]|0,i|0,g|0)|0;if(!qa)md(v|0,z|0);J=z}else qa=-1;if((qa|0)==1){ma=D;na=B;oa=A;C=J;D=ma;B=na;A=oa;E=6;continue}y=0;v=Ta(f[(f[s+4>>2]|0)+8>>2]|0,s|0,1,f[B>>2]<<2|0,1)|0;t=y;y=0;if((t|0)!=0&(z|0)!=0){ra=T1a(f[t>>2]|0,i|0,g|0)|0;if(!ra)md(t|0,z|0);J=z}else ra=-1;if((ra|0)==1){ma=D;na=B;oa=A;C=J;D=ma;B=na;A=oa;E=6;continue}t=f[c+16>>2]|0;M=f[A>>2]|0;f[A>>2]=M+-1;c:do if(M|0){w=m+4|0;Q=n+4|0;P=o+4|0;if(q)sa=t;else{R=t;while(1){y=0;Ec(101,D|0,v|0,1)|0;N=y;y=0;if((N|0)!=0&(z|0)!=0){ta=T1a(f[N>>2]|0,i|0,g|0)|0;if(!ta)md(N|0,z|0);J=z}else ta=-1;if((ta|0)==1){ma=D;na=B;oa=A;C=J;D=ma;B=na;A=oa;E=6;continue a}N=f[B>>2]|0;O=f[v>>2]|0;if((f[x>>2]|0)!=1){f[o>>2]=N;f[P>>2]=1;y=0;f[e>>2]=f[o>>2];f[e+4>>2]=f[o+4>>2];Lb(135,O|0,0,R|0,0,e|0);ja=y;y=0;if((ja|0)!=0&(z|0)!=0){ua=T1a(f[ja>>2]|0,i|0,g|0)|0;if(!ua)md(ja|0,z|0);J=z}else ua=-1;if((ua|0)==1){ma=D;na=B;oa=A;C=J;D=ma;B=na;A=oa;E=6;continue a}}else K1a(R|0,O|0,N|0)|0;N=f[A>>2]|0;f[A>>2]=N+-1;if(!N)break c;else R=R+p|0}}while(1){y=0;Ec(101,D|0,v|0,1)|0;R=y;y=0;if((R|0)!=0&(z|0)!=0){va=T1a(f[R>>2]|0,i|0,g|0)|0;if(!va)md(R|0,z|0);J=z}else va=-1;if((va|0)==1){ma=D;na=B;oa=A;C=J;D=ma;B=na;A=oa;E=6;continue a}R=f[B>>2]|0;P=f[v>>2]|0;if((f[x>>2]|0)==3){f[m>>2]=R;f[w>>2]=1;y=0;f[e>>2]=f[m>>2];f[e+4>>2]=f[m+4>>2];Lb(134,P|0,0,sa|0,0,e|0);N=y;y=0;if((N|0)!=0&(z|0)!=0){wa=T1a(f[N>>2]|0,i|0,g|0)|0;if(!wa)md(N|0,z|0);J=z}else wa=-1;if((wa|0)==1){ma=D;na=B;oa=A;C=J;D=ma;B=na;A=oa;E=6;continue a}}else{f[n>>2]=R;f[Q>>2]=1;y=0;f[e>>2]=f[n>>2];f[e+4>>2]=f[n+4>>2];Lb(133,P|0,0,sa|0,0,e|0);P=y;y=0;if((P|0)!=0&(z|0)!=0){xa=T1a(f[P>>2]|0,i|0,g|0)|0;if(!xa)md(P|0,z|0);J=z}else xa=-1;if((xa|0)==1){ma=D;na=B;oa=A;C=J;D=ma;B=na;A=oa;E=6;continue a}}P=f[A>>2]|0;f[A>>2]=P+-1;if(!P)break;else sa=sa+p|0}}while(0);b[l>>0]=1;y=0;wc(240,D|0)|0;x=y;y=0;if((x|0)!=0&(z|0)!=0){ya=T1a(f[x>>2]|0,i|0,g|0)|0;if(!ya)md(x|0,z|0);J=z}else ya=-1;if((ya|0)==1){ma=D;na=B;oa=A;C=J;D=ma;B=na;A=oa;E=6;continue}F=A;G=B;H=D;E=40;continue}else if((E|0)==40){E=0;x=f[r>>2]|0;if(!x){I=F;K=G;L=H;E=44;continue}y=0;uc(959,x|0);v=y;y=0;if((v|0)!=0&(z|0)!=0){za=T1a(f[v>>2]|0,i|0,g|0)|0;if(!za)md(v|0,z|0);J=z}else za=-1;if((za|0)==1){A=F;B=G;C=J;D=H;E=6;continue}y=0;uc(960,x|0);x=y;y=0;if((x|0)!=0&(z|0)!=0){Aa=T1a(f[x>>2]|0,i|0,g|0)|0;if(!Aa)md(x|0,z|0);J=z}else Aa=-1;if((Aa|0)==1){A=F;B=G;C=J;D=H;E=6;continue}f[r>>2]=0;I=F;K=G;L=H;E=44;continue}else if((E|0)==44){E=0;Ba=a+96|0;x=f[Ba>>2]|0;if(!x){E=47;break}y=0;wc(234,x|0)|0;x=y;y=0;if((x|0)!=0&(z|0)!=0){Ca=T1a(f[x>>2]|0,i|0,g|0)|0;if(!Ca)md(x|0,z|0);J=z}else Ca=-1;if((Ca|0)==1){A=I;B=K;C=J;D=L;E=6;continue}else break}if((E|0)==47){Da=a+8|0;f[Da>>2]=0;Ea=a+4|0;f[Ea>>2]=0;Fa=a+12|0;f[Fa>>2]=-1;Ga=b[l>>0]|0;Ha=Ga&1;Ia=Ha<<24>>24!=0;eKa(i|0);u=d;return Ia|0}f[Ba>>2]=0;Da=a+8|0;f[Da>>2]=0;Ea=a+4|0;f[Ea>>2]=0;Fa=a+12|0;f[Fa>>2]=-1;Ga=b[l>>0]|0;Ha=Ga&1;Ia=Ha<<24>>24!=0;eKa(i|0);u=d;return Ia|0}function lxa(a,c){a=a|0;c=c|0;var d=0,e=0;c=NYa(104)|0;hAa(c);f[c>>2]=102284;d=c+28|0;d$(d);e=c$(d,3)|0;b[e>>0]=b[351945]|0;b[e+1>>0]=b[351946]|0;b[e+2>>0]=b[351947]|0;f[c+100>>2]=0;f[c+96>>2]=0;b[c+92>>0]=1;e=NYa(16)|0;d=e+4|0;f[d>>2]=1;f[e>>2]=101820;f[e+8>>2]=c;f[a>>2]=e;f[a+4>>2]=c;f[d>>2]=(f[d>>2]|0)+1;c=f[d>>2]|0;f[d>>2]=c+-1;if((c|0)!=1)return;ki[f[(f[e>>2]|0)+8>>2]&2047](e);return}function mxa(a){a=a|0;md((f[a>>2]|0)+132|0,1)}function nxa(a){a=a|0;return}function oxa(a){a=a|0;return 0}function pxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+24>>2]|0;a=c+4|0;d=f[a>>2]|0;e=f[c>>2]|0;if((d|0)<(b|0)){f[c+28>>2]=b-d;f[c>>2]=e+d;g=a;f[g>>2]=0;return}else{f[a>>2]=d-b;f[c>>2]=e+b;g=c+28|0;f[g>>2]=0;return}}function qxa(a){a=a|0;f[a>>2]=104796;d$(a+28|0);d$(a+12|0);d$(a+4|0);return}function rxa(a){a=a|0;f[a>>2]=104796;d$(a+28|0);d$(a+12|0);d$(a+4|0);PYa(a);return}function sxa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,mb=0;e=u;u=u+2064|0;g=e+1840|0;h=e+1832|0;i=4;j=dKa(40)|0;f[j>>2]=0;k=e+2048|0;l=e+1816|0;m=e+776|0;n=e;o=e+488|0;p=e+460|0;q=e+456|0;r=e+448|0;s=e+440|0;t=e+1848|0;v=a+28|0;y=0;uc(964,v|0);w=y;y=0;if((w|0)!=0&(z|0)!=0){x=T1a(f[w>>2]|0,j|0,i|0)|0;if(!x)md(w|0,z|0);J=z}else x=-1;do if((x|0)!=1){b[k>>0]=0;w=f[c+12>>2]|0;A=f[c+8>>2]|0;f[l>>2]=0;B=l+4|0;f[B>>2]=0;f[l+8>>2]=0;y=0;C=wc(235,4096)|0;D=y;y=0;if((D|0)!=0&(z|0)!=0){E=T1a(f[D>>2]|0,j|0,i|0)|0;if(!E)md(D|0,z|0);J=z}else E=-1;if((E|0)!=1){f[B>>2]=C;f[l>>2]=C;f[l+8>>2]=C+4096;D=C;C=4096;do{b[D>>0]=0;D=(f[B>>2]|0)+1|0;f[B>>2]=D;C=C+-1|0}while((C|0)!=0);C=m+8|0;f[m>>2]=C;D=m+4|0;f[D>>2]=1032;y=0;pc(198,n|0,90,440);F=y;y=0;if((F|0)!=0&(z|0)!=0){G=T1a(f[F>>2]|0,j|0,i|0)|0;if(!G)md(F|0,z|0);J=z}else G=-1;if((G|0)!=1){y=0;F=wc(236,o|0)|0;H=y;y=0;if((H|0)!=0&(z|0)!=0){I=T1a(f[H>>2]|0,j|0,i|0)|0;if(!I)md(H|0,z|0);J=z}else I=-1;if((I|0)!=1){f[n>>2]=F;f[o>>2]=961;F=f[a+20>>2]|0;if(!F){H=f[a+12>>2]|0;y=0;K=jc(164,((H|0)==0?5694105:H)|0,353339)|0;H=y;y=0;if((H|0)!=0&(z|0)!=0){L=T1a(f[H>>2]|0,j|0,i|0)|0;if(!L)md(H|0,z|0);J=z}else L=-1;if((L|0)==1){M=p;N=o;O=n;P=m;Q=l;R=A;S=w;T=J;U=l;V=B;W=C;X=0;Z=m;_=D;break}if(!K){$=p;aa=o;ba=n;ca=m;da=l;ea=A;fa=w;ga=l;ha=B;ia=C;ja=0;ka=0;la=m;ma=D;na=67;break}y=0;Qb(384,n|0,K|0);H=y;y=0;if((H|0)!=0&(z|0)!=0){oa=T1a(f[H>>2]|0,j|0,i|0)|0;if(!oa)md(H|0,z|0);J=z}else oa=-1;if((oa|0)==1){M=p;N=o;O=n;P=m;Q=l;R=A;S=w;T=J;U=l;V=B;W=C;X=0;Z=m;_=D;break}pa=K}else{f[p+24>>2]=F;f[p+20>>2]=l;f[n+24>>2]=p;f[p+8>>2]=965;f[p+12>>2]=241;f[p+16>>2]=966;F=f[l>>2]|0;f[p>>2]=F;f[p+4>>2]=(f[B>>2]|0)-F;pa=0}j=G1a(o+132|0,1,j|0,i|0)|0;i=J;y=0;F=y;y=0;if((F|0)!=0&(z|0)!=0){qa=T1a(f[F>>2]|0,j|0,i|0)|0;if(!qa)md(F|0,z|0);J=z}else qa=-1;if((qa|0)==1){M=p;N=o;O=n;P=m;Q=l;R=A;S=w;T=J;U=l;V=B;W=C;X=pa;Z=m;_=D}else{M=p;N=o;O=n;P=m;Q=l;R=A;S=w;T=0;U=l;V=B;W=C;X=pa;Z=m;_=D}}else{M=p;N=o;O=n;P=m;Q=l;R=A;S=w;T=J;U=l;V=B;W=C;X=0;Z=m;_=D}}else{M=p;N=o;O=n;P=m;Q=l;R=A;S=w;T=J;U=l;V=B;W=C;X=0;Z=m;_=D}}else{M=0;N=0;O=0;P=0;Q=l;R=A;S=w;T=J;U=l;V=B;W=0;X=0;Z=0;_=0}}else{M=0;N=0;O=0;P=0;Q=0;R=0;S=0;T=J;U=0;V=0;W=0;X=0;Z=0;_=0}while(0);a:while(1){if((na|0)==67){na=0;if(!(b[k>>0]&1)){y=0;Qb(f[o+12>>2]|0,n|0,t|0);l=y;y=0;if((l|0)!=0&(z|0)!=0){ra=T1a(f[l>>2]|0,j|0,i|0)|0;if(!ra)md(l|0,z|0);J=z}else ra=-1;if((ra|0)==1){M=$;N=aa;O=ba;P=ca;Q=da;R=ea;S=fa;T=J;U=ga;V=ha;W=ia;X=ja;Z=la;_=ma;continue}y=0;uc(964,v|0);l=y;y=0;if((l|0)!=0&(z|0)!=0){sa=T1a(f[l>>2]|0,j|0,i|0)|0;if(!sa)md(l|0,z|0);J=z}else sa=-1;if((sa|0)==1){M=$;N=aa;O=ba;P=ca;Q=da;R=ea;S=fa;T=J;U=ga;V=ha;W=ia;X=ja;Z=la;_=ma;continue}y=0;l=wc(244,t|0)|0;m=y;y=0;if((m|0)!=0&(z|0)!=0){ta=T1a(f[m>>2]|0,j|0,i|0)|0;if(!ta)md(m|0,z|0);J=z}else ta=-1;if((ta|0)==1){M=$;N=aa;O=ba;P=ca;Q=da;R=ea;S=fa;T=J;U=ga;V=ha;W=ia;X=ja;Z=la;_=ma;continue}if(l|0){y=0;m=jc(166,v|0,l|0)|0;p=y;y=0;if((p|0)!=0&(z|0)!=0){ua=T1a(f[p>>2]|0,j|0,i|0)|0;if(!ua)md(p|0,z|0);J=z}else ua=-1;if((ua|0)==1){M=$;N=aa;O=ba;P=ca;Q=da;R=ea;S=fa;T=J;U=ga;V=ha;W=ia;X=ja;Z=la;_=ma;continue}K1a(m|0,t|0,l|0)|0}}y=0;uc(971,n|0);l=y;y=0;if((l|0)!=0&(z|0)!=0){va=T1a(f[l>>2]|0,j|0,i|0)|0;if(!va)md(l|0,z|0);J=z}else va=-1;if((va|0)==1){M=$;N=aa;O=ba;P=ca;Q=da;R=ea;S=fa;T=J;U=ga;V=ha;W=ia;X=ja;Z=la;_=ma;continue}wa=(b[k>>0]&1)!=0;l=f[la>>2]|0;if((l|0)!=(ia|0)){if(l|0){y=0;uc(969,l|0);l=y;y=0;if((l|0)!=0&(z|0)!=0){xa=T1a(f[l>>2]|0,j|0,i|0)|0;if(!xa)md(l|0,z|0);J=z}else xa=-1;if((xa|0)==1){M=$;N=aa;O=ba;P=ca;Q=da;R=ea;S=fa;T=J;U=ga;V=ha;W=ia;X=ja;Z=la;_=ma;continue}}f[la>>2]=ia;f[ma>>2]=1032}l=f[ga>>2]|0;if(l|0){if((f[ha>>2]|0)!=(l|0))f[ha>>2]=l;y=0;uc(960,l|0);l=y;y=0;if((l|0)!=0&(z|0)!=0){ya=T1a(f[l>>2]|0,j|0,i|0)|0;if(!ya)md(l|0,z|0);J=z}else ya=-1;if((ya|0)==1){M=$;N=aa;O=ba;P=ca;Q=da;R=ea;S=fa;T=J;U=ga;V=ha;W=ia;X=ja;Z=la;_=ma;continue}}if(!ka){na=89;break}y=0;wc(234,ka|0)|0;l=y;y=0;if((l|0)!=0&(z|0)!=0){za=T1a(f[l>>2]|0,j|0,i|0)|0;if(!za)md(l|0,z|0);J=z}else za=-1;if((za|0)==1){M=$;N=aa;O=ba;P=ca;Q=da;R=ea;S=fa;T=J;U=ga;V=ha;W=ia;X=ja;Z=la;_=ma}else break}if(T|0){$=M;aa=N;ba=O;ca=P;da=Q;ea=R;fa=S;ga=U;ha=V;ia=W;ja=X;ka=X;la=Z;ma=_;na=67;continue}f[n+28>>2]=S;f[n+32>>2]=R;l=(f[c>>2]|0)>>>3;m=(l&511|0)!=0;p=m?3:1;f[n+36>>2]=p;f[n+40>>2]=m?2:1;pa=f[d+4>>2]|0;qa=f[d>>2]|0;oa=qa;b:do if((pa|0)==(qa|0)){Aa=-1;Ba=-1;Ca=0;Da=0;Ea=95;Fa=0}else{L=pa-qa>>2;a=-1;I=0;G=-1;E=0;x=0;D=95;C=0;while(1){switch(f[oa+(I<<2)>>2]|0){case 1:{F=f[oa+((I|1)<<2)>>2]|0;K=(F|0)>0?F:0;Ga=a;Ha=G;Ia=E;Ja=x;Ka=(K|0)<100?K:100;La=C;break}case 2:{Ga=a;Ha=G;Ia=E;Ja=f[oa+((I|1)<<2)>>2]|0;Ka=D;La=C;break}case 3:{Ga=a;Ha=G;Ia=f[oa+((I|1)<<2)>>2]|0;Ja=x;Ka=D;La=C;break}case 5:{K=f[oa+((I|1)<<2)>>2]|0;if((K|0)>-1){F=(K|0)<100?K:100;Ga=(a|0)<0?F:a;Ha=F;Ia=E;Ja=x;Ka=F;La=C}else{Ga=a;Ha=G;Ia=E;Ja=x;Ka=D;La=C}break}case 6:{F=f[oa+((I|1)<<2)>>2]|0;if((F|0)>-1)if((F|0)>100){Ga=100;Ha=G;Ia=E;Ja=x;Ka=D;La=C}else{Ga=(F|0)>0?F:0;Ha=G;Ia=E;Ja=x;Ka=D;La=C}else{Ga=a;Ha=G;Ia=E;Ja=x;Ka=D;La=C}break}case 4:{F=f[oa+((I|1)<<2)>>2]|0;K=(F|0)>0?F:0;Ga=a;Ha=G;Ia=E;Ja=x;Ka=D;La=(K|0)<65535?K:65535;break}default:{Ga=a;Ha=G;Ia=E;Ja=x;Ka=D;La=C}}I=I+2|0;if(I>>>0>=L>>>0){Aa=Ga;Ba=Ha;Ca=Ia;Da=Ja;Ea=Ka;Fa=La;break b}else{a=Ga;G=Ha;E=Ia;x=Ja;D=Ka;C=La}}}while(0);y=0;uc(967,n|0);oa=y;y=0;if((oa|0)!=0&(z|0)!=0){Ma=T1a(f[oa>>2]|0,j|0,i|0)|0;if(!Ma)md(oa|0,z|0);J=z}else Ma=-1;if((Ma|0)==1){Na=_;Oa=Z;Pa=X;Qa=W;Ra=V;Sa=U;Ta=S;Ua=R;Va=Q;Wa=P;Xa=O;Ya=N;Za=M;T=J;_=Na;Z=Oa;X=Pa;W=Qa;V=Ra;U=Sa;S=Ta;R=Ua;Q=Va;P=Wa;O=Xa;N=Ya;M=Za;continue}f[n+236>>2]=Fa;y=0;pc(199,n|0,Ea|0,1);oa=y;y=0;if((oa|0)!=0&(z|0)!=0){_a=T1a(f[oa>>2]|0,j|0,i|0)|0;if(!_a)md(oa|0,z|0);J=z}else _a=-1;if((_a|0)==1){Na=_;Oa=Z;Pa=X;Qa=W;Ra=V;Sa=U;Ta=S;Ua=R;Va=Q;Wa=P;Xa=O;Ya=N;Za=M;T=J;_=Na;Z=Oa;X=Pa;W=Qa;V=Ra;U=Sa;S=Ta;R=Ua;Q=Va;P=Wa;O=Xa;N=Ya;M=Za;continue}if(Da|0){y=0;uc(968,n|0);oa=y;y=0;if((oa|0)!=0&(z|0)!=0){$a=T1a(f[oa>>2]|0,j|0,i|0)|0;if(!$a)md(oa|0,z|0);J=z}else $a=-1;if(($a|0)==1){Na=_;Oa=Z;Pa=X;Qa=W;Ra=V;Sa=U;Ta=S;Ua=R;Va=Q;Wa=P;Xa=O;Ya=N;Za=M;T=J;_=Na;Z=Oa;X=Pa;W=Qa;V=Ra;U=Sa;S=Ta;R=Ua;Q=Va;P=Wa;O=Xa;N=Ya;M=Za;continue}}if(Ca|0)f[n+216>>2]=1;if((Aa|Ba|0)>-1){y=0;oa=wc(242,Ba|0)|0;qa=y;y=0;if((qa|0)!=0&(z|0)!=0){ab=T1a(f[qa>>2]|0,j|0,i|0)|0;if(!ab)md(qa|0,z|0);J=z}else ab=-1;if((ab|0)==1){Na=_;Oa=Z;Pa=X;Qa=W;Ra=V;Sa=U;Ta=S;Ua=R;Va=Q;Wa=P;Xa=O;Ya=N;Za=M;T=J;_=Na;Z=Oa;X=Pa;W=Qa;V=Ra;U=Sa;S=Ta;R=Ua;Q=Va;P=Wa;O=Xa;N=Ya;M=Za;continue}f[n+104>>2]=oa;y=0;oa=wc(242,Aa|0)|0;qa=y;y=0;if((qa|0)!=0&(z|0)!=0){bb=T1a(f[qa>>2]|0,j|0,i|0)|0;if(!bb)md(qa|0,z|0);J=z}else bb=-1;if((bb|0)==1){Na=_;Oa=Z;Pa=X;Qa=W;Ra=V;Sa=U;Ta=S;Ua=R;Va=Q;Wa=P;Xa=O;Ya=N;Za=M;T=J;_=Na;Z=Oa;X=Pa;W=Qa;V=Ra;U=Sa;S=Ta;R=Ua;Q=Va;P=Wa;O=Xa;N=Ya;M=Za;continue}f[n+108>>2]=oa;if((Ba|0)!=(Aa|0)){oa=f[n+84>>2]|0;f[oa+12>>2]=1;f[oa+8>>2]=1;f[oa+100>>2]=1;f[oa+96>>2]=1}y=0;Qb(385,n|0,1);oa=y;y=0;if((oa|0)!=0&(z|0)!=0){cb=T1a(f[oa>>2]|0,j|0,i|0)|0;if(!cb)md(oa|0,z|0);J=z}else cb=-1;if((cb|0)==1){Na=_;Oa=Z;Pa=X;Qa=W;Ra=V;Sa=U;Ta=S;Ua=R;Va=Q;Wa=P;Xa=O;Ya=N;Za=M;T=J;_=Na;Z=Oa;X=Pa;W=Qa;V=Ra;U=Sa;S=Ta;R=Ua;Q=Va;P=Wa;O=Xa;N=Ya;M=Za;continue}}y=0;Qb(386,n|0,1);oa=y;y=0;if((oa|0)!=0&(z|0)!=0){db=T1a(f[oa>>2]|0,j|0,i|0)|0;if(!db)md(oa|0,z|0);J=z}else db=-1;if((db|0)==1){Na=_;Oa=Z;Pa=X;Qa=W;Ra=V;Sa=U;Ta=S;Ua=R;Va=Q;Wa=P;Xa=O;Ya=N;Za=M;T=J;_=Na;Z=Oa;X=Pa;W=Qa;V=Ra;U=Sa;S=Ta;R=Ua;Q=Va;P=Wa;O=Xa;N=Ya;M=Za;continue}do if(m){oa=Y(p,S)|0;if((f[_>>2]|0)>>>0>=oa>>>0){f[_>>2]=oa;break}qa=f[Z>>2]|0;if((qa|0)!=(W|0)){if(qa|0){y=0;uc(969,qa|0);qa=y;y=0;if((qa|0)!=0&(z|0)!=0){eb=T1a(f[qa>>2]|0,j|0,i|0)|0;if(!eb)md(qa|0,z|0);J=z}else eb=-1;if((eb|0)==1){Na=_;Oa=Z;Pa=X;Qa=W;Ra=V;Sa=U;Ta=S;Ua=R;Va=Q;Wa=P;Xa=O;Ya=N;Za=M;T=J;_=Na;Z=Oa;X=Pa;W=Qa;V=Ra;U=Sa;S=Ta;R=Ua;Q=Va;P=Wa;O=Xa;N=Ya;M=Za;continue a}}f[Z>>2]=W;f[_>>2]=1032}f[_>>2]=oa;if(oa>>>0>1032){y=0;qa=wc(243,oa|0)|0;oa=y;y=0;if((oa|0)!=0&(z|0)!=0){fb=T1a(f[oa>>2]|0,j|0,i|0)|0;if(!fb)md(oa|0,z|0);J=z}else fb=-1;if((fb|0)==1){Na=_;Oa=Z;Pa=X;Qa=W;Ra=V;Sa=U;Ta=S;Ua=R;Va=Q;Wa=P;Xa=O;Ya=N;Za=M;T=J;_=Na;Z=Oa;X=Pa;W=Qa;V=Ra;U=Sa;S=Ta;R=Ua;Q=Va;P=Wa;O=Xa;N=Ya;M=Za;continue a}f[Z>>2]=qa}}while(0);p=f[Z>>2]|0;if((R|0)>0){m=c+16|0;qa=c+48|0;oa=r+4|0;pa=s+4|0;switch(l&511){case 2:{B=0;while(1){w=(f[m>>2]|0)+(Y(f[qa>>2]|0,B)|0)|0;f[q>>2]=w;f[r>>2]=S;f[oa>>2]=1;y=0;f[h>>2]=f[r>>2];f[h+4>>2]=f[r+4>>2];Lb(134,w|0,0,p|0,0,h|0);w=y;y=0;if((w|0)!=0&(z|0)!=0){gb=T1a(f[w>>2]|0,j|0,i|0)|0;if(!gb)md(w|0,z|0);J=z}else gb=-1;if((gb|0)==1){Na=_;Oa=Z;Pa=X;Qa=W;Ra=V;Sa=U;Ta=S;Ua=R;Va=Q;Wa=P;Xa=O;Ya=N;Za=M;T=J;_=Na;Z=Oa;X=Pa;W=Qa;V=Ra;U=Sa;S=Ta;R=Ua;Q=Va;P=Wa;O=Xa;N=Ya;M=Za;continue a}f[q>>2]=p;y=0;Ec(102,n|0,q|0,1)|0;w=y;y=0;if((w|0)!=0&(z|0)!=0){hb=T1a(f[w>>2]|0,j|0,i|0)|0;if(!hb)md(w|0,z|0);J=z}else hb=-1;if((hb|0)==1){Na=_;Oa=Z;Pa=X;Qa=W;Ra=V;Sa=U;Ta=S;Ua=R;Va=Q;Wa=P;Xa=O;Ya=N;Za=M;T=J;_=Na;Z=Oa;X=Pa;W=Qa;V=Ra;U=Sa;S=Ta;R=Ua;Q=Va;P=Wa;O=Xa;N=Ya;M=Za;continue a}B=B+1|0;if((B|0)>=(R|0))break}break}case 3:{B=0;while(1){oa=(f[m>>2]|0)+(Y(f[qa>>2]|0,B)|0)|0;f[q>>2]=oa;f[s>>2]=S;f[pa>>2]=1;y=0;f[g>>2]=f[s>>2];f[g+4>>2]=f[s+4>>2];lb(131,oa|0,0,p|0,0,g|0,2);oa=y;y=0;if((oa|0)!=0&(z|0)!=0){ib=T1a(f[oa>>2]|0,j|0,i|0)|0;if(!ib)md(oa|0,z|0);J=z}else ib=-1;if((ib|0)==1){Na=_;Oa=Z;Pa=X;Qa=W;Ra=V;Sa=U;Ta=S;Ua=R;Va=Q;Wa=P;Xa=O;Ya=N;Za=M;T=J;_=Na;Z=Oa;X=Pa;W=Qa;V=Ra;U=Sa;S=Ta;R=Ua;Q=Va;P=Wa;O=Xa;N=Ya;M=Za;continue a}f[q>>2]=p;y=0;Ec(102,n|0,q|0,1)|0;oa=y;y=0;if((oa|0)!=0&(z|0)!=0){jb=T1a(f[oa>>2]|0,j|0,i|0)|0;if(!jb)md(oa|0,z|0);J=z}else jb=-1;if((jb|0)==1){Na=_;Oa=Z;Pa=X;Qa=W;Ra=V;Sa=U;Ta=S;Ua=R;Va=Q;Wa=P;Xa=O;Ya=N;Za=M;T=J;_=Na;Z=Oa;X=Pa;W=Qa;V=Ra;U=Sa;S=Ta;R=Ua;Q=Va;P=Wa;O=Xa;N=Ya;M=Za;continue a}B=B+1|0;if((B|0)>=(R|0))break}break}default:{B=0;while(1){p=(f[m>>2]|0)+(Y(f[qa>>2]|0,B)|0)|0;f[q>>2]=p;y=0;Ec(102,n|0,q|0,1)|0;p=y;y=0;if((p|0)!=0&(z|0)!=0){kb=T1a(f[p>>2]|0,j|0,i|0)|0;if(!kb)md(p|0,z|0);J=z}else kb=-1;if((kb|0)==1){Na=_;Oa=Z;Pa=X;Qa=W;Ra=V;Sa=U;Ta=S;Ua=R;Va=Q;Wa=P;Xa=O;Ya=N;Za=M;T=J;_=Na;Z=Oa;X=Pa;W=Qa;V=Ra;U=Sa;S=Ta;R=Ua;Q=Va;P=Wa;O=Xa;N=Ya;M=Za;continue a}B=B+1|0;if((B|0)>=(R|0))break}}}}y=0;uc(970,n|0);B=y;y=0;if((B|0)!=0&(z|0)!=0){mb=T1a(f[B>>2]|0,j|0,i|0)|0;if(!mb)md(B|0,z|0);J=z}else mb=-1;if((mb|0)==1){Na=_;Oa=Z;Pa=X;Qa=W;Ra=V;Sa=U;Ta=S;Ua=R;Va=Q;Wa=P;Xa=O;Ya=N;Za=M;T=J;_=Na;Z=Oa;X=Pa;W=Qa;V=Ra;U=Sa;S=Ta;R=Ua;Q=Va;P=Wa;O=Xa;N=Ya;M=Za;continue}b[k>>0]=1;$=M;aa=N;ba=O;ca=P;da=Q;ea=R;fa=S;ga=U;ha=V;ia=W;ja=X;ka=X;la=Z;ma=_;na=67}if((na|0)==89){eKa(j|0);u=e;return wa|0}eKa(j|0);u=e;return wa|0}function txa(a,b){a=a|0;b=b|0;var c=0,d=0;b=NYa(36)|0;uxa(b);c=NYa(16)|0;d=c+4|0;f[d>>2]=1;f[c>>2]=101840;f[c+8>>2]=b;f[a>>2]=c;f[a+4>>2]=b;f[d>>2]=(f[d>>2]|0)+1;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1)return;ki[f[(f[c>>2]|0)+8>>2]&2047](c);return}function uxa(a){a=a|0;var c=0,d=0,e=0;iAa(a);f[a>>2]=102340;c=a+4|0;d$(c);d=c$(c,31)|0;c=352388;e=d+31|0;do{b[d>>0]=b[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(e|0));b[a+24>>0]=1;return}function vxa(a){a=a|0;return}function wxa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=f[a+24>>2]|0;a=b+24|0;c=f[a>>2]|0;d=c+4|0;e=f[d>>2]|0;g=f[c>>2]|0;h=e-g|0;i=b+20|0;j=f[i>>2]|0;k=(f[j+4>>2]|0)-(f[j>>2]|0)|0;l=k+h|0;m=g;g=e;if(h>>>0>=l>>>0)if(h>>>0>l>>>0?(e=m+l|0,(g|0)!=(e|0)):0){f[d>>2]=e;n=c;o=j}else{n=c;o=j}else{TR(c,k);n=f[a>>2]|0;o=f[i>>2]|0}K1a((f[n>>2]|0)+h|0,f[o>>2]|0,k|0)|0;f[b>>2]=f[f[i>>2]>>2];f[b+4>>2]=k;return 1}function xxa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=f[a+24>>2]|0;a=b+24|0;c=f[a>>2]|0;d=c+4|0;e=f[d>>2]|0;g=f[c>>2]|0;h=e-g|0;i=b+20|0;j=f[i>>2]|0;k=(f[j+4>>2]|0)-(f[j>>2]|0)-(f[b+4>>2]|0)|0;if(!k)return;b=k+h|0;l=g;g=e;if(h>>>0>=b>>>0)if(h>>>0>b>>>0?(e=l+b|0,(g|0)!=(e|0)):0){f[d>>2]=e;m=c;n=j}else{m=c;n=j}else{TR(c,k);m=f[a>>2]|0;n=f[i>>2]|0}K1a((f[m>>2]|0)+h|0,f[n>>2]|0,k|0)|0;return}function yxa(a){a=a|0;var c=0,d=0;hAa(a);f[a>>2]=102284;c=a+28|0;d$(c);d=c$(c,3)|0;b[d>>0]=b[351945]|0;b[d+1>>0]=b[351946]|0;b[d+2>>0]=b[351947]|0;f[a+100>>2]=0;f[a+96>>2]=0;b[a+92>>0]=1;return}function zxa(a){a=a|0;var b=0;f[a>>2]=102384;b=a+96|0;sya(b);oya(b);Owa(a);return}function Axa(a){a=a|0;var b=0;f[a>>2]=102384;b=a+96|0;sya(b);oya(b);Owa(a);PYa(a);return}function Bxa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0;c=u;u=u+288|0;d=c;e=c+32|0;g=c+24|0;h=c+16|0;i=a+36|0;if(f[a+52>>2]|0){j=f[a+40>>2]|0;if((j|0)<3)k=Y(f[a+48>>2]|0,f[a+44>>2]|0)|0;else{l=f[a+76>>2]|0;m=0;n=1;while(1){o=Y(f[l+(m<<2)>>2]|0,n)|0;m=m+1|0;if((m|0)==(j|0)){k=o;break}else n=o}}n=a+96|0;if(!((j|0)==0|(k|0)==0))if(rya(n,i)|0){p=n;q=n}else{r=0;u=c;return r|0}else{s=n;t=n;v=9}}else{n=a+96|0;s=n;t=n;v=9}if((v|0)==9)if(qya(s,a+20|0)|0){p=s;q=t}else{r=0;u=c;return r|0}if((Oya(q)|0)!=80){t=De(44)|0;f[d>>2]=0;f[d+4>>2]=0;w=c$(d,14)|0;x=352909;y=w+14|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[g>>2]=0;f[g+4>>2]=0;w=c$(g,10)|0;x=352924;y=w+10|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[h>>2]=0;f[h+4>>2]=0;w=c$(h,55)|0;x=352439;y=w+55|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));k$(t,-2,d,g,h,381);f[t>>2]=104120;Of(t|0,18864,59)}if((Oya(q)|0)!=55){t=De(44)|0;f[d>>2]=0;f[d+4>>2]=0;w=c$(d,14)|0;x=352909;y=w+14|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[g>>2]=0;f[g+4>>2]=0;w=c$(g,10)|0;x=352924;y=w+10|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[h>>2]=0;f[h+4>>2]=0;w=c$(h,55)|0;x=352439;y=w+55|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));k$(t,-2,d,g,h,385);f[t>>2]=104120;Of(t|0,18864,59)}switch(Oya(q)|0){case 10:case 13:break;default:{t=De(44)|0;f[d>>2]=0;f[d+4>>2]=0;w=c$(d,14)|0;x=352909;y=w+14|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[g>>2]=0;f[g+4>>2]=0;w=c$(g,10)|0;x=352924;y=w+10|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[h>>2]=0;f[h+4>>2]=0;w=c$(h,55)|0;x=352439;y=w+55|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));k$(t,-2,d,g,h,389);f[t>>2]=104120;Of(t|0,18864,59)}}t=d+1|0;s=d+2|0;n=d+3|0;i=d+4|0;k=d+5|0;j=d+6|0;m=d+7|0;l=a+8|0;o=a+4|0;z=a+136|0;A=a+132|0;B=a+140|0;C=a+152|0;D=a+148|0;E=0;F=0;G=0;H=0;I=0;a:while(1){f[d>>2]=0;f[d+4>>2]=0;b[d+8>>0]=0;do J=Oya(q)|0;while((mLa(J)|0)!=0);b:do switch(J|0){case 35:{while(1)switch(Oya(q)|0){case 10:case 13:{K=1;break b;break}default:{}}break}case 10:case 13:{K=0;break}default:{L=d;f[L>>2]=0;f[L+4>>2]=0;b[d>>0]=J;L=Oya(q)|0;if(!(mLa(L)|0)){b[t>>0]=L;M=Oya(q)|0;if(!(mLa(M)|0)){b[s>>0]=M;N=Oya(q)|0;if(!(mLa(N)|0)){b[n>>0]=N;O=Oya(q)|0;if(!(mLa(O)|0)){b[i>>0]=O;P=Oya(q)|0;if(!(mLa(P)|0)){b[k>>0]=P;Q=Oya(q)|0;if(!(mLa(Q)|0)){b[j>>0]=Q;R=Oya(q)|0;if(!(mLa(R)|0)){b[m>>0]=R;S=Oya(q)|0}else S=R}else S=Q}else S=P}else S=O}else S=N}else S=M}else S=L;if(!(mLa(S)|0)){v=39;break a}L=(aLa(104136,d,9)|0)==0;M=(aLa(104152,d,9)|0)==0;N=(aLa(104168,d,9)|0)==0;O=(aLa(104184,d,9)|0)==0;P=(aLa(104200,d,9)|0)==0;Q=(aLa(104216,d,9)|0)==0;R=Q?7:P?6:O?5:N?4:M?3:L?2:E;if(!(Q|(P|(O|(N|(L|M)))))){v=39;break a}F1a(e|0,0,255)|0;c:do switch(S|0){case 10:case 13:break;default:{do M=Oya(q)|0;while((mLa(M)|0)!=0);T=M;U=0;d:while(1){switch(T|0){case 10:case 13:{V=U;break d;break}default:{}}b[e+U>>0]=T;T=Oya(q)|0;W=U+1|0;if(W>>>0>=255){v=28;break}else U=W}if((v|0)==28){v=0;switch(T|0){case 10:case 13:break;default:{v=39;break a}}if((U|0)>-2)V=W;else break c}while(1){M=e+V|0;if(!(mLa(b[M>>0]|0)|0))break c;b[M>>0]=0;if((V|0)>0)V=V+-1|0;else break}}}while(0);switch(R|0){case 1:case 0:{X=I;Z=H;_=G;$=F;E=R;I=X;H=Z;G=_;F=$;continue a;break}case 2:{v=73;break a;break}case 3:{if(H){v=44;break a}M=lNa(e,d,0)|0;L=pKa()|0;if((M+-2147483647|0)>>>0<2&(f[L>>2]|0)==34){v=48;break a}L=pKa()|0;if((M|0)==0&(f[L>>2]|0)!=0|(f[d>>2]|0)==(e|0)){v=48;break a}f[l>>2]=M;X=I;_=G;$=F;E=3;H=1;I=X;G=_;F=$;continue a;break}case 4:{if(I){v=50;break a}M=lNa(e,d,0)|0;L=pKa()|0;if((M+-2147483647|0)>>>0<2&(f[L>>2]|0)==34){v=54;break a}L=pKa()|0;if((M|0)==0&(f[L>>2]|0)!=0|(f[d>>2]|0)==(e|0)){v=54;break a}f[o>>2]=M;Z=H;_=G;$=F;E=4;I=1;H=Z;G=_;F=$;continue a;break}case 5:{if(F){v=56;break a}M=lNa(e,d,0)|0;L=pKa()|0;if((M+-2147483647|0)>>>0<2&(f[L>>2]|0)==34){v=60;break a}L=pKa()|0;if((M|0)==0&(f[L>>2]|0)!=0|(f[d>>2]|0)==(e|0)){v=60;break a}f[z>>2]=M;X=I;Z=H;_=G;E=5;F=1;I=X;H=Z;G=_;continue a;break}case 6:{if(G){v=62;break a}M=lNa(e,d,0)|0;L=pKa()|0;if((M+-2147483647|0)>>>0<2&(f[L>>2]|0)==34){v=65;break a}L=pKa()|0;if((M|0)==0&(f[L>>2]|0)!=0|(f[d>>2]|0)==(e|0)){v=65;break a}f[A>>2]=M;if((M|0)>65535){v=67;break a}f[B>>2]=(M|0)>255?2:0;if((M|0)!=1){X=I;Z=H;$=F;E=6;G=1;I=X;H=Z;F=$;continue a}b[C>>0]=1;X=I;Z=H;$=F;E=6;G=1;I=X;H=Z;F=$;continue a;break}case 7:{if(!(aLa(102436,e,256)|0))f[D>>2]=0;if(!(aLa(102716,e,256)|0))f[D>>2]=1;if(!(aLa(102996,e,256)|0))f[D>>2]=2;if(!(aLa(103276,e,256)|0))f[D>>2]=3;if(!(aLa(103556,e,256)|0))f[D>>2]=4;if(aLa(103836,e,256)|0){X=I;Z=H;_=G;$=F;E=7;I=X;H=Z;G=_;F=$;continue a}f[D>>2]=5;X=I;Z=H;_=G;$=F;E=7;I=X;H=Z;G=_;F=$;continue a;break}default:{v=72;break a}}}}while(0);X=I;Z=H;_=G;$=F;E=K;I=X;H=Z;G=_;F=$}switch(v|0){case 39:{v=De(44)|0;f[d>>2]=0;f[d+4>>2]=0;w=c$(d,14)|0;x=352909;y=w+14|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[g>>2]=0;f[g+4>>2]=0;w=c$(g,10)|0;x=352924;y=w+10|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[h>>2]=0;f[h+4>>2]=0;w=c$(h,55)|0;x=352439;y=w+55|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));k$(v,-2,d,g,h,395);f[v>>2]=104120;Of(v|0,18864,59);break}case 44:{v=De(44)|0;f[d>>2]=0;f[d+4>>2]=0;w=c$(d,14)|0;x=352909;y=w+14|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[g>>2]=0;f[g+4>>2]=0;w=c$(g,10)|0;x=352924;y=w+10|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[h>>2]=0;f[h+4>>2]=0;w=c$(h,55)|0;x=352439;y=w+55|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));k$(v,-2,d,g,h,405);f[v>>2]=104120;Of(v|0,18864,59);break}case 48:{v=De(44)|0;f[d>>2]=0;f[d+4>>2]=0;w=c$(d,14)|0;x=352909;y=w+14|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[g>>2]=0;f[g+4>>2]=0;w=c$(g,10)|0;x=352924;y=w+10|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[h>>2]=0;f[h+4>>2]=0;w=c$(h,55)|0;x=352439;y=w+55|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));k$(v,-2,d,g,h,407);f[v>>2]=104120;Of(v|0,18864,59);break}case 50:{v=De(44)|0;f[d>>2]=0;f[d+4>>2]=0;w=c$(d,14)|0;x=352909;y=w+14|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[g>>2]=0;f[g+4>>2]=0;w=c$(g,10)|0;x=352924;y=w+10|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[h>>2]=0;f[h+4>>2]=0;w=c$(h,55)|0;x=352439;y=w+55|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));k$(v,-2,d,g,h,412);f[v>>2]=104120;Of(v|0,18864,59);break}case 54:{v=De(44)|0;f[d>>2]=0;f[d+4>>2]=0;w=c$(d,14)|0;x=352909;y=w+14|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[g>>2]=0;f[g+4>>2]=0;w=c$(g,10)|0;x=352924;y=w+10|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[h>>2]=0;f[h+4>>2]=0;w=c$(h,55)|0;x=352439;y=w+55|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));k$(v,-2,d,g,h,414);f[v>>2]=104120;Of(v|0,18864,59);break}case 56:{v=De(44)|0;f[d>>2]=0;f[d+4>>2]=0;w=c$(d,14)|0;x=352909;y=w+14|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[g>>2]=0;f[g+4>>2]=0;w=c$(g,10)|0;x=352924;y=w+10|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[h>>2]=0;f[h+4>>2]=0;w=c$(h,55)|0;x=352439;y=w+55|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));k$(v,-2,d,g,h,419);f[v>>2]=104120;Of(v|0,18864,59);break}case 60:{v=De(44)|0;f[d>>2]=0;f[d+4>>2]=0;w=c$(d,14)|0;x=352909;y=w+14|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[g>>2]=0;f[g+4>>2]=0;w=c$(g,10)|0;x=352924;y=w+10|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[h>>2]=0;f[h+4>>2]=0;w=c$(h,55)|0;x=352439;y=w+55|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));k$(v,-2,d,g,h,421);f[v>>2]=104120;Of(v|0,18864,59);break}case 62:{v=De(44)|0;f[d>>2]=0;f[d+4>>2]=0;w=c$(d,14)|0;x=352909;y=w+14|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[g>>2]=0;f[g+4>>2]=0;w=c$(g,10)|0;x=352924;y=w+10|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[h>>2]=0;f[h+4>>2]=0;w=c$(h,55)|0;x=352439;y=w+55|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));k$(v,-2,d,g,h,426);f[v>>2]=104120;Of(v|0,18864,59);break}case 65:{v=De(44)|0;f[d>>2]=0;f[d+4>>2]=0;w=c$(d,14)|0;x=352909;y=w+14|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[g>>2]=0;f[g+4>>2]=0;w=c$(g,10)|0;x=352924;y=w+10|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[h>>2]=0;f[h+4>>2]=0;w=c$(h,55)|0;x=352439;y=w+55|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));k$(v,-2,d,g,h,428);f[v>>2]=104120;Of(v|0,18864,59);break}case 67:{v=De(44)|0;f[d>>2]=0;f[d+4>>2]=0;w=c$(d,14)|0;x=352909;y=w+14|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[g>>2]=0;f[g+4>>2]=0;w=c$(g,10)|0;x=352924;y=w+10|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[h>>2]=0;f[h+4>>2]=0;w=c$(h,55)|0;x=352439;y=w+55|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));k$(v,-2,d,g,h,430);f[v>>2]=104120;Of(v|0,18864,59);break}case 72:{v=De(44)|0;f[d>>2]=0;f[d+4>>2]=0;w=c$(d,14)|0;x=352909;y=w+14|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[g>>2]=0;f[g+4>>2]=0;w=c$(g,10)|0;x=352924;y=w+10|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));f[h>>2]=0;f[h+4>>2]=0;w=c$(h,55)|0;x=352439;y=w+55|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));k$(v,-2,d,g,h,449);f[v>>2]=104120;Of(v|0,18864,59);break}case 73:{if(!(H&I&F&G)){f[a+144>>2]=-1;f[l>>2]=-1;f[o>>2]=-1;sya(p);r=0;u=c;return r|0}o=f[z>>2]|0;e:do if(!(f[D>>2]|0)){switch(o|0){case 1:break;case 3:{if((f[A>>2]|0)>=256){aa=3;break e}f[D>>2]=4;aa=3;break e;break}default:{aa=o;break e}}z=f[A>>2]|0;if((z|0)==1){f[D>>2]=1;aa=1;break}if((z|0)<256){f[D>>2]=2;aa=1}else aa=1}else aa=o;while(0);f[a+12>>2]=(aa<<3)+-8|f[B>>2]&7;B=Mya(p)|0;f[a+144>>2]=B;r=1;u=c;return r|0}}return 0}function Cxa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;e=u;u=u+3104|0;g=e+2080|0;h=e+1040|0;i=e;k=f[c+16>>2]|0;l=(f[c>>2]|0)>>>3;m=(l&511)+1|0;n=f[c+48>>2]|0;o=a+4|0;p=a+136|0;q=Y(f[p>>2]|0,f[o>>2]|0)|0;r=Y(1212424721>>>(f[a+12>>2]<<2&28)&15,q)|0;s=q<<1;t=h+8|0;f[h>>2]=t;v=h+4|0;f[v>>2]=s;if(s>>>0>1032){w=OYa(s)|0;f[h>>2]=w;x=w}else x=t;w=i+8|0;f[i>>2]=w;s=i+4|0;f[s>>2]=1032;y=a+144|0;a:do if((f[y>>2]|0)>=0?(z=a+96|0,Jya(z)|0):0){A=f[a+148>>2]|0;if(!A){B=(f[p>>2]|0)>2;C=0;D=B?2:0;E=B&1}else{C=102432+(A*280|0)|0;D=0;E=0}Lya(z,f[y>>2]|0);A=a+140|0;B=f[A>>2]|0;if(((B|0)==(f[c>>2]&7|0)?(m|0)==(f[p>>2]|0):0)?(b[a+152>>0]|0)==0:0){F=a+8|0;G=f[F>>2]|0;if((B|0)!=2){Pya(z,k,Y(G,r)|0)|0;H=1;break}if((G|0)<=0){H=1;break}if((q|0)>0){I=k;J=0}else{G=0;while(1){Pya(z,x,r)|0;G=G+1|0;if((G|0)>=(f[F>>2]|0)){H=1;break a}}}while(1){Pya(z,x,r)|0;G=0;do{B=G<<1;K=b[x+B>>0]|0;L=B|1;b[I+B>>0]=b[x+L>>0]|0;b[I+L>>0]=K;G=G+1|0}while((G|0)!=(q|0));J=J+1|0;if((J|0)>=(f[F>>2]|0)){H=1;break a}else I=I+n|0}}if(b[a+152>>0]|0){switch(l&511){case 0:break;case 2:{Kza(g,1,0);F=a+8|0;if((f[F>>2]|0)>0){M=k;N=0}else{H=1;break a}while(1){Pya(z,x,r)|0;Sza(M,x,f[o>>2]|0,g)|0;N=N+1|0;if((N|0)>=(f[F>>2]|0)){H=1;break a}else M=M+n|0}break}default:{H=1;break a}}F=f[i>>2]|0;if((f[s>>2]|0)>>>0<2)if((F|0)==(w|0))O=w;else{if(F|0)QYa(F);f[i>>2]=w;f[s>>2]=1032;O=w}else O=F;f[s>>2]=2;b[O>>0]=0;b[O+1>>0]=-1;F=a+8|0;if((f[F>>2]|0)>0){P=k;Q=0}else{H=1;break}while(1){Pya(z,x,r)|0;Tza(P,x,f[o>>2]|0,O)|0;Q=Q+1|0;if((Q|0)>=(f[F>>2]|0)){H=1;break a}else P=P+n|0}}F=a+8|0;if((f[F>>2]|0)>0){G=(C|0)==0;K=l&65535;L=C+260|0;B=C+276|0;R=C+272|0;S=C+268|0;T=C+264|0;U=(q|0)<1;V=k;W=0;while(1){Pya(z,x,r)|0;X=(f[A>>2]|0)!=2|U;if(!X){Z=0;do{_=Z<<1;$=x+_|0;aa=b[$>>0]|0;ba=x+(_|1)|0;b[$>>0]=b[ba>>0]|0;b[ba>>0]=aa;Z=Z+1|0}while((Z|0)!=(q|0))}Z=f[c>>2]|0;aa=Z&7;if(!((aa|0)!=0|X)){ba=0;do{b[x+ba>>0]=(j[x+(ba<<1)>>1]|0)>>>8;ba=ba+1|0}while((ba|0)!=(q|0))}ba=f[p>>2]|0;b:do if((m|0)==(ba|0))K1a(V|0,x|0,n|0)|0;else{if(G){X=f[o>>2]|0;switch(Z&7){case 0:{$=x+X|0;switch(K&511){case 0:{if((X|0)>0){ca=V;da=x}else break b;while(1){_=b[da>>0]|0;b[ca+2>>0]=_;b[ca+1>>0]=_;b[ca>>0]=_;da=da+ba|0;if(da>>>0>=$>>>0)break b;else ca=ca+3|0}break}case 2:{if((X|0)>0){ea=V;fa=x}else break b;while(1){b[ea>>0]=b[fa>>0]|0;b[ea+1>>0]=b[fa+E>>0]|0;b[ea+2>>0]=b[fa+D>>0]|0;fa=fa+ba|0;if(fa>>>0>=$>>>0)break b;else ea=ea+3|0}break}default:break b}break}case 2:{$=x+(X<<1)|0;switch(K&511){case 0:{if(x>>>0<$>>>0){ga=V;ha=x}else break b;while(1){_=d[ha>>1]|0;d[ga+4>>1]=_;d[ga+2>>1]=_;d[ga>>1]=_;ha=ha+(ba<<1)|0;if(ha>>>0>=$>>>0)break b;else ga=ga+6|0}break}case 2:{if(x>>>0<$>>>0){ia=V;ja=x}else break b;while(1){d[ia>>1]=d[ja>>1]|0;d[ia+2>>1]=d[ja+(E<<1)>>1]|0;d[ia+4>>1]=d[ja+(D<<1)>>1]|0;ja=ja+(ba<<1)|0;if(ja>>>0>=$>>>0)break b;else ia=ia+6|0}break}default:break b}break}default:break b}}$=f[L>>2]|0;if(!$){ka=Z;la=ba}else{if(uh[$&63](x,V,f[o>>2]|0,m,aa)|0)break;ka=f[c>>2]|0;la=f[p>>2]|0}$=f[o>>2]|0;switch(ka&7){case 0:{X=x+$|0;switch(K&511){case 0:{if(($|0)>0){ma=V;na=x}else break b;while(1){_=b[na+(f[B>>2]|0)>>0]|0;b[ma+2>>0]=_;b[ma+1>>0]=_;b[ma>>0]=_;na=na+la|0;if(na>>>0>=X>>>0)break b;else ma=ma+3|0}break}case 2:{if(($|0)>0){oa=V;pa=x}else break b;while(1){b[oa>>0]=b[pa+(f[R>>2]|0)>>0]|0;b[oa+1>>0]=b[pa+(f[S>>2]|0)>>0]|0;b[oa+2>>0]=b[pa+(f[T>>2]|0)>>0]|0;pa=pa+la|0;if(pa>>>0>=X>>>0)break b;else oa=oa+3|0}break}default:break b}break}case 2:break;default:break b}X=x+($<<1)|0;switch(K&511){case 0:{if(x>>>0>=X>>>0)break b;_=f[B>>2]|0;qa=V;ra=x;while(1){sa=d[ra+(_<<1)>>1]|0;d[qa+4>>1]=sa;d[qa+2>>1]=sa;d[qa>>1]=sa;ra=ra+(la<<1)|0;if(ra>>>0>=X>>>0)break;else qa=qa+6|0}break}case 2:{if(x>>>0>=X>>>0)break b;qa=f[R>>2]|0;ra=f[S>>2]|0;_=f[T>>2]|0;$=V;sa=x;while(1){d[$>>1]=d[sa+(qa<<1)>>1]|0;d[$+2>>1]=d[sa+(ra<<1)>>1]|0;d[$+4>>1]=d[sa+(_<<1)>>1]|0;sa=sa+(la<<1)|0;if(sa>>>0>=X>>>0)break;else $=$+6|0}break}default:break b}}while(0);W=W+1|0;if((W|0)>=(f[F>>2]|0)){H=1;break}else V=V+n|0}}else H=1}else H=0;while(0);n=f[i>>2]|0;if((n|0)!=(w|0)){if(n|0)QYa(n);f[i>>2]=w;f[s>>2]=1032}s=f[h>>2]|0;if((s|0)==(t|0)){u=e;return H|0}if(s|0)QYa(s);f[h>>2]=t;f[v>>2]=1032;u=e;return H|0}function Dxa(a){a=a|0;return 3}function Exa(a,c){a=a|0;c=c|0;var d=0;if((f[c+4>>2]|0)>>>0<=2){d=0;return d|0}a=f[c>>2]|0;if((b[a>>0]|0)!=80){d=0;return d|0}if((b[a+1>>0]|0)!=55){d=0;return d|0}d=(mLa(b[a+2>>0]|0)|0)!=0;return d|0}function Fxa(a,c){a=a|0;c=c|0;var d=0,e=0;c=NYa(156)|0;hAa(c);f[c>>2]=102384;d=c+96|0;Kya(d);f[d>>2]=104580;f[c+144>>2]=-1;b[c+92>>0]=1;b[c+152>>0]=0;f[c+148>>2]=0;f[c+132>>2]=0;f[c+136>>2]=0;f[c+140>>2]=0;d=NYa(16)|0;e=d+4|0;f[e>>2]=1;f[d>>2]=101940;f[d+8>>2]=c;f[a>>2]=d;f[a+4>>2]=c;f[e>>2]=(f[e>>2]|0)+1;c=f[e>>2]|0;f[e>>2]=c+-1;if((c|0)!=1)return;ki[f[(f[d>>2]|0)+8>>2]&2047](d);return}function Gxa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+48|0;h=g+32|0;i=g+24|0;j=g+16|0;k=g+8|0;l=g;switch(d|0){case 3:{switch(e|0){case 0:{f[i>>2]=c;f[i+4>>2]=1;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];Bza(a,0,b,0,h);m=1;u=g;return m|0}case 2:{f[j>>2]=c;f[j+4>>2]=1;f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];Cza(a,0,b,0,h);m=1;u=g;return m|0}default:{m=0;u=g;return m|0}}break}case 1:{switch(e|0){case 0:{f[k>>2]=c;f[k+4>>2]=1;f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];xza(a,0,b,0,h,2);m=1;u=g;return m|0}case 2:{f[l>>2]=c;f[l+4>>2]=1;f[h>>2]=f[l>>2];f[h+4>>2]=f[l+4>>2];yza(a,0,b,0,h,3,2);m=1;u=g;return m|0}default:{m=0;u=g;return m|0}}break}default:{m=0;u=g;return m|0}}return 0}function Hxa(a){a=a|0;e$(a);PYa(a);return}function Ixa(a){a=a|0;f[a>>2]=104796;d$(a+28|0);d$(a+12|0);d$(a+4|0);return}function Jxa(a){a=a|0;f[a>>2]=104796;d$(a+28|0);d$(a+12|0);d$(a+4|0);PYa(a);return}function Kxa(a,b){a=a|0;b=b|0;return (b|2|0)==2|0}function Lxa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=u;u=u+1120|0;g=e+32|0;h=e+24|0;i=e+16|0;j=e+8|0;k=e;l=e+1080|0;m=e+40|0;Tya(l);f[l>>2]=104660;n=f[c+12>>2]|0;o=f[c+8>>2]|0;p=c+4|0;q=f[p>>2]|0;r=c+44|0;if((q|0)>0)s=f[(f[r>>2]|0)+(q+-1<<2)>>2]|0;else s=0;q=Y(s,n)|0;s=c+16|0;t=f[s>>2]|0;v=f[d+4>>2]|0;w=f[d>>2]|0;d=w;if((v|0)==(w|0))x=0;else{y=v-w>>2;w=0;v=0;while(1){if((f[d+(v<<2)>>2]|0)==128?(z=f[d+((v|1)<<2)>>2]|0,(z|0)>0):0)A=(z|0)<6?102432+(z*280|0)|0:w;else A=w;v=v+2|0;if(v>>>0>=y>>>0){x=A;break}else w=A}}A=a+20|0;w=f[A>>2]|0;if(!w){if(!(zya(l,a+12|0)|0)){B=0;xya(l);u=e;return B|0}}else{if(!(Aya(l,w)|0)){B=0;xya(l);u=e;return B|0}w=f[A>>2]|0;A=(Y(q,o)|0)+511&-256;a=w+8|0;y=f[w>>2]|0;v=y;if(((f[a>>2]|0)-y|0)>>>0<A>>>0){d=w+4|0;z=(f[d>>2]|0)-y|0;C=NYa(A)|0;D=C+z|0;E=D+(0-z)|0;if((z|0)>0)K1a(E|0,v|0,z|0)|0;f[w>>2]=E;f[d>>2]=D;f[a>>2]=C+A;if(y|0)PYa(v)}}v=f[p>>2]|0;if((v|0)>0)F=f[(f[r>>2]|0)+(v+-1<<2)>>2]|0;else F=0;v=Y(F,n)|0;F=(v|0)>256?v:256;v=m+8|0;f[m>>2]=v;p=m+4|0;f[p>>2]=F;if(F>>>0>1032){y=OYa(F)|0;f[m>>2]=y;G=y}else G=v;b[G>>0]=80;b[G+1>>0]=55;b[G+2>>0]=10;b[G+3>>0]=0;f[k>>2]=n;n=(SLa(G+3|0,352579,k)|0)+3|0;f[j>>2]=o;k=n+(SLa(G+n|0,352589,j)|0)|0;f[i>>2]=((f[c>>2]|0)>>>3&511)+1;j=(SLa(G+k|0,352600,i)|0)+k|0;f[h>>2]=(1<<(1212424721>>>(f[c>>2]<<2&28)<<3&120))+-1;k=(SLa(G+j|0,352610,h)|0)+j|0;if(!x)H=k;else{f[g>>2]=x+4;H=(SLa(G+k|0,352621,g)|0)+k|0}k=G+H|0;H=k;b[H>>0]=69;b[H+1>>0]=78;b[H+2>>0]=68;b[H+3>>0]=72;H=k+4|0;b[H>>0]=68;b[H+1>>0]=82;b[H+2>>0]=10;b[H+3>>0]=0;Uya(l,G,xKa(G)|0);a:do switch(f[c>>2]&7){case 0:{Uya(l,t,Y(q,o)|0);break}case 2:{if((o|0)>0){if((q|0)>0)I=0;else{H=0;while(1){K1a(G|0,(f[s>>2]|0)+(Y(f[f[r>>2]>>2]|0,H)|0)|0,q|0)|0;Uya(l,G,q);H=H+1|0;if((H|0)>=(o|0))break a}}do{K1a(G|0,(f[s>>2]|0)+(Y(f[f[r>>2]>>2]|0,I)|0)|0,q|0)|0;H=0;do{k=G+H|0;g=b[k>>0]|0;x=G+(H|1)|0;b[k>>0]=b[x>>0]|0;b[x>>0]=g;H=H+2|0}while((H|0)<(q|0));Uya(l,G,q);I=I+1|0}while((I|0)<(o|0))}break}default:{}}while(0);Bya(l);o=f[m>>2]|0;if((o|0)!=(v|0)){if(o|0)QYa(o);f[m>>2]=v;f[p>>2]=1032}B=1;xya(l);u=e;return B|0}function Mxa(a,b){a=a|0;b=b|0;var c=0,d=0;b=NYa(36)|0;Nxa(b);c=NYa(16)|0;d=c+4|0;f[d>>2]=1;f[c>>2]=101960;f[c+8>>2]=b;f[a>>2]=c;f[a+4>>2]=b;f[d>>2]=(f[d>>2]|0)+1;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1)return;ki[f[(f[c>>2]|0)+8>>2]&2047](c);return}function Nxa(a){a=a|0;var c=0,d=0,e=0;iAa(a);f[a>>2]=104236;c=a+4|0;d$(c);d=c$(c,33)|0;c=352545;e=d+33|0;do{b[d>>0]=b[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(e|0));b[a+24>>0]=1;return}function Oxa(a){a=a|0;var c=0;hAa(a);f[a>>2]=102384;c=a+96|0;Kya(c);f[c>>2]=104580;f[a+144>>2]=-1;b[a+92>>0]=1;b[a+152>>0]=0;f[a+148>>2]=0;f[a+132>>2]=0;f[a+136>>2]=0;f[a+140>>2]=0;return}function Pxa(a){a=a|0;var b=0;f[a>>2]=104280;b=a+96|0;sya(b);oya(b);Owa(a);return}function Qxa(a){a=a|0;var b=0;f[a>>2]=104280;b=a+96|0;sya(b);oya(b);Owa(a);PYa(a);return}function Rxa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;c=u;u=u+32|0;d=c+16|0;e=c+8|0;g=c;h=a+36|0;if(f[a+52>>2]|0){i=f[a+40>>2]|0;if((i|0)<3)j=Y(f[a+48>>2]|0,f[a+44>>2]|0)|0;else{k=f[a+76>>2]|0;l=0;m=1;while(1){n=Y(f[k+(l<<2)>>2]|0,m)|0;l=l+1|0;if((l|0)==(i|0)){j=n;break}else m=n}}m=a+96|0;if(!((i|0)==0|(j|0)==0))if(rya(m,h)|0){o=m;p=m}else{q=0;u=c;return q|0}else{r=m;s=m;t=9}}else{m=a+96|0;r=m;s=m;t=9}if((t|0)==9)if(qya(r,a+20|0)|0){o=r;p=s}else{q=0;u=c;return q|0}if((Oya(p)|0)!=80){s=De(44)|0;f[d>>2]=0;f[d+4>>2]=0;v=c$(d,14)|0;w=352909;x=v+14|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));f[e>>2]=0;f[e+4>>2]=0;v=c$(e,10)|0;w=352924;x=v+10|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));f[g>>2]=0;f[g+4>>2]=0;v=c$(g,55)|0;w=352676;x=v+55|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));k$(s,-2,d,e,g,155);f[s>>2]=104120;Of(s|0,18864,59)}s=Oya(p)|0;switch(s|0){case 52:case 49:{y=1;break}case 53:case 50:{y=8;break}case 54:case 51:{y=24;break}default:{r=De(44)|0;f[d>>2]=0;f[d+4>>2]=0;v=c$(d,14)|0;w=352909;x=v+14|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));f[e>>2]=0;f[e+4>>2]=0;v=c$(e,10)|0;w=352924;x=v+10|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));f[g>>2]=0;f[g+4>>2]=0;v=c$(g,55)|0;w=352676;x=v+55|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));k$(r,-2,d,e,g,163);f[r>>2]=104120;Of(r|0,18864,59)}}r=a+1156|0;f[r>>2]=y;b[a+1164>>0]=(s|0)>51&1;s=a+12|0;f[s>>2]=y>>>0>8?16:0;y=Wxa(p,0)|0;t=a+4|0;f[t>>2]=y;y=Wxa(p,0)|0;m=a+8|0;f[m>>2]=y;if((f[r>>2]|0)!=1){r=Wxa(p,0)|0;f[a+1168>>2]=r;if((r|0)>65535){p=De(44)|0;f[d>>2]=0;f[d+4>>2]=0;v=c$(d,14)|0;w=352909;x=v+14|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));f[e>>2]=0;f[e+4>>2]=0;v=c$(e,10)|0;w=352924;x=v+10|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));f[g>>2]=0;f[g+4>>2]=0;v=c$(g,55)|0;w=352676;x=v+55|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));k$(p,-2,d,e,g,174);f[p>>2]=104120;Of(p|0,18864,59)}if((r|0)>255){f[s>>2]=f[s>>2]&4088|2;z=r}else z=r}else{f[a+1168>>2]=1;z=1}if((f[t>>2]|0)>0?(f[m>>2]|0)>0&(z+-1|0)>>>0<65535:0){z=Mya(o)|0;f[a+1160>>2]=z;q=1;u=c;return q|0}f[a+1160>>2]=-1;f[m>>2]=-1;f[t>>2]=-1;sya(o);q=0;u=c;return q|0}function Sxa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;e=u;u=u+3392|0;g=e+1072|0;h=e+2368|0;i=e+2112|0;k=e;l=e+1064|0;m=e+1056|0;n=e+1048|0;o=e+1040|0;p=(f[c>>2]&4088|0)!=0;q=f[c+16>>2]|0;r=a+12|0;s=f[r>>2]|0;t=1212424721>>>(s<<2&28)<<3&120;v=a+4|0;w=f[v>>2]|0;x=a+1156|0;y=(Y(Y(f[x>>2]|0,w)|0,t>>>3)|0)+7|0;z=y>>>3;A=Y((s>>>3&511)+1|0,w)|0;w=a+1160|0;if((f[w>>2]|0)<0){B=0;u=e;return B|0}s=a+96|0;if(!(Jya(s)|0)){B=0;u=e;return B|0}F1a(i|0,0,256)|0;C=(t|0)==8;if(C){D=a+1168|0;E=f[D>>2]|0;if((E|0)<256)F=E;else{f[g>>2]=0;f[g+4>>2]=0;G=c$(g,14)|0;H=352652;I=G+14|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));j$(-215,g,352667,352676,225);d$(g);F=f[D>>2]|0}D=(f[x>>2]|0)==1;if((F|0)>=0){E=D?255:0;J=0;while(1){b[i+J>>0]=((J*255|0)/(F|0)|0)^E;if((J|0)<(F|0))J=J+1|0;else break}}Kza(h,D?1:8,D)}Lya(s,f[w>>2]|0);a:do switch(f[x>>2]|0){case 1:{if(f[r>>2]&7|0){f[g>>2]=0;f[g+4>>2]=0;G=c$(g,32)|0;H=352732;I=G+32|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));j$(-215,g,352667,352676,241);d$(g)}if(b[a+1164>>0]|0){w=g+8|0;f[g>>2]=w;D=g+4|0;f[D>>2]=z;if(y>>>0>8263){J=OYa(z)|0;f[g>>2]=J;K=J}else K=w;J=a+8|0;if((f[J>>2]|0)>0){F=c+48|0;if(p){E=q;L=0;while(1){Pya(s,K,z)|0;Sza(E,K,f[v>>2]|0,h)|0;L=L+1|0;if((L|0)>=(f[J>>2]|0))break;else E=E+(f[F>>2]|0)|0}}else{E=q;L=0;while(1){Pya(s,K,z)|0;Tza(E,K,f[v>>2]|0,i)|0;L=L+1|0;if((L|0)>=(f[J>>2]|0))break;else E=E+(f[F>>2]|0)|0}}}F=f[g>>2]|0;if((F|0)!=(w|0)){if(F|0)QYa(F);f[g>>2]=w;f[D>>2]=1032}break a}F=f[v>>2]|0;E=g+8|0;f[g>>2]=E;J=g+4|0;f[J>>2]=F;if(F>>>0>1032){L=OYa(F)|0;f[g>>2]=L;M=L}else M=E;L=a+8|0;b:do if((f[L>>2]|0)>0){N=c+48|0;if(p){O=F;P=q;Q=0;while(1){if((O|0)>0){R=0;do{S=(Wxa(s,1)|0)!=0&1;b[M+R>>0]=S;R=R+1|0;S=f[v>>2]|0}while((R|0)<(S|0));T=S}else T=O;Oza(P,M,T,h)|0;R=Q+1|0;if((R|0)>=(f[L>>2]|0))break b;O=f[v>>2]|0;P=P+(f[N>>2]|0)|0;Q=R}}else{Q=F;P=q;O=0;while(1){if((Q|0)>0){R=0;do{S=(Wxa(s,1)|0)!=0&1;b[M+R>>0]=S;R=R+1|0;S=f[v>>2]|0}while((R|0)<(S|0));U=S}else U=Q;Pza(P,M,U,i)|0;R=O+1|0;if((R|0)>=(f[L>>2]|0))break b;Q=f[v>>2]|0;P=P+(f[N>>2]|0)|0;O=R}}}while(0);L=f[g>>2]|0;if((L|0)!=(E|0)){if(L|0)QYa(L);f[g>>2]=E;f[J>>2]=1032}break}case 24:case 8:{L=A<<1;F=L>>>0<z>>>0?z:L;L=k+8|0;f[k>>2]=L;D=k+4|0;f[D>>2]=F;if(F>>>0>1032){w=OYa(F)|0;f[k>>2]=w;V=w}else V=L;w=a+8|0;if((f[w>>2]|0)>0){F=a+1164|0;O=(A|0)>0;N=a+1168|0;P=c+48|0;Q=l+4|0;R=m+4|0;S=n+4|0;W=o+4|0;X=(t|0)==16;Z=(t|0)!=16;_=(A|0)<1;$=q;aa=0;while(1){if(!(b[F>>0]|0))if(O)if(C){ba=0;do{ca=Wxa(s,0)|0;da=f[N>>2]|0;b[V+ba>>0]=b[i+(ca>>>0>da>>>0?da:ca)>>0]|0;ba=ba+1|0}while((ba|0)<(A|0));ea=60}else{ba=0;do{ca=Wxa(s,0)|0;da=f[N>>2]|0;d[V+(ba<<1)>>1]=ca>>>0>da>>>0?da:ca;ba=ba+1|0}while((ba|0)<(A|0));ea=60}else ea=60;else{Pya(s,V,z)|0;if(X)if(O){ba=0;do{ca=ba<<1;da=V+ca|0;fa=b[da>>0]|0;ga=V+(ca|1)|0;b[da>>0]=b[ga>>0]|0;b[ga>>0]=fa;ba=ba+1|0}while((ba|0)!=(A|0));ea=60}else ea=60}if((ea|0)==60?(ea=0,!((f[c>>2]&7|0)!=0|Z|_)):0){ba=0;do{b[V+ba>>0]=(j[V+(ba<<1)>>1]|0)>>>8;ba=ba+1|0}while((ba|0)!=(A|0))}c:do if((f[x>>2]|0)==8){if(!p){K1a($|0,V|0,Y(1212424721>>>(f[r>>2]<<2&28)&15,f[v>>2]|0)|0)|0;break}ba=f[v>>2]|0;if(!(f[c>>2]&7)){fa=V+ba|0;if((ba|0)>0){ha=$;ia=V}else break;while(1){ga=b[ia>>0]|0;b[ha+2>>0]=ga;b[ha+1>>0]=ga;b[ha>>0]=ga;ia=ia+1|0;if(ia>>>0>=fa>>>0)break c;else ha=ha+3|0}}fa=V+(ba<<1)|0;if(V>>>0<fa>>>0){ga=$;da=V;while(1){ca=d[da>>1]|0;d[ga+4>>1]=ca;d[ga+2>>1]=ca;d[ga>>1]=ca;da=da+2|0;if(da>>>0>=fa>>>0)break;else ga=ga+6|0}}}else{ga=(f[c>>2]&7|0)==0;fa=f[v>>2]|0;if(p)if(ga){f[l>>2]=fa;f[Q>>2]=1;f[g>>2]=f[l>>2];f[g+4>>2]=f[l+4>>2];Bza(V,0,$,0,g);break}else{f[m>>2]=fa;f[R>>2]=1;f[g>>2]=f[m>>2];f[g+4>>2]=f[m+4>>2];Cza(V,0,$,0,g);break}else if(ga){f[n>>2]=fa;f[S>>2]=1;f[g>>2]=f[n>>2];f[g+4>>2]=f[n+4>>2];xza(V,0,$,0,g,2);break}else{f[o>>2]=fa;f[W>>2]=1;f[g>>2]=f[o>>2];f[g+4>>2]=f[o+4>>2];yza(V,0,$,0,g,3,2);break}}while(0);aa=aa+1|0;if((aa|0)>=(f[w>>2]|0))break;else $=$+(f[P>>2]|0)|0}ja=f[k>>2]|0}else ja=V;if((ja|0)!=(L|0)){if(ja|0)QYa(ja);f[k>>2]=L;f[D>>2]=1032}break}default:{f[g>>2]=0;f[g+4>>2]=0;G=c$(g,22)|0;H=352765;I=G+22|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));Xxa(g,352667,356)}}while(0);B=1;u=e;return B|0}function Txa(a){a=a|0;return 3}function Uxa(a,c){a=a|0;c=c|0;var d=0;if((f[c+4>>2]|0)>>>0<=2){d=0;return d|0}a=f[c>>2]|0;if((b[a>>0]|0)!=80){d=0;return d|0}if(((b[a+1>>0]|0)+-49&255)>=6){d=0;return d|0}d=(mLa(b[a+2>>0]|0)|0)!=0;return d|0}function Vxa(a,c){a=a|0;c=c|0;var d=0,e=0;c=NYa(1172)|0;hAa(c);f[c>>2]=104280;d=c+96|0;Kya(d);f[d>>2]=104580;f[c+1160>>2]=-1;b[c+92>>0]=1;f[c+1156>>2]=0;b[c+1164>>0]=0;f[c+1168>>2]=0;d=NYa(16)|0;e=d+4|0;f[e>>2]=1;f[d>>2]=101900;f[d+8>>2]=c;f[a>>2]=d;f[a+4>>2]=c;f[e>>2]=(f[e>>2]|0)+1;c=f[e>>2]|0;f[e>>2]=c+-1;if((c|0)!=1)return;ki[f[(f[d>>2]|0)+8>>2]&2047](d);return}function Wxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+16|0;e=d;g=d+8|0;h=Oya(a)|0;a:do if((h+-48|0)>>>0>9){i=h;b:while(1){j=i;while(1){if((j|0)==35)break;if(!(mLa(j)|0))break b;do k=Oya(a)|0;while((mLa(k)|0)!=0);if((k+-48|0)>>>0>9)j=k;else{l=k;break a}}c:while(1)switch(Oya(a)|0){case 10:case 13:{break c;break}default:{}}m=Oya(a)|0;if((m+-48|0)>>>0>9)i=m;else{l=m;break a}}f[e>>2]=j;f[e+4>>2]=j;p$(g,352861,e);Xxa(g,352850,80)}else l=h;while(0);h=g+4|0;if(!c){e=0;j=0;k=l;do{i=W1a(e|0,j|0,10,0)|0;m=k+-48|0;e=C1a(i|0,J|0,m|0,((m|0)<0)<<31>>31|0)|0;j=J;if(!((j|0)<0|(j|0)==0&e>>>0<2147483648)){f[g>>2]=0;f[h>>2]=0;n=c$(g,61)|0;o=352788;p=n+61|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-215,g,352850,352676,90);d$(g)}k=Oya(a)|0}while((k+-48|0)>>>0<10);q=e;u=d;return q|0}else{r=0;s=0;t=l;v=0}while(1){l=W1a(r|0,s|0,10,0)|0;e=t+-48|0;k=C1a(l|0,J|0,e|0,((e|0)<0)<<31>>31|0)|0;s=J;if(!((s|0)<0|(s|0)==0&k>>>0<2147483648)){f[g>>2]=0;f[h>>2]=0;n=c$(g,61)|0;o=352788;p=n+61|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-215,g,352850,352676,90);d$(g)}v=v+1|0;if((v|0)>=(c|0)){q=k;w=19;break}t=Oya(a)|0;if((t+-48|0)>>>0>=10){q=k;w=19;break}else r=k}if((w|0)==19){u=d;return q|0}return 0}function Xxa(a,b,c){a=a|0;b=b|0;c=c|0;j$(-2,a,b,352676,c);return}function Yxa(a){a=a|0;f[a>>2]=104796;d$(a+28|0);d$(a+12|0);d$(a+4|0);return}function Zxa(a){a=a|0;f[a>>2]=104796;d$(a+28|0);d$(a+12|0);d$(a+4|0);PYa(a);return}function _xa(a,b){a=a|0;b=b|0;return (b|2|0)==2|0}function $xa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;e=u;u=u+1184|0;g=e+64|0;i=e+56|0;k=e+48|0;l=e+40|0;m=e+32|0;n=e+24|0;o=e+16|0;p=e+8|0;q=e;r=e+1136|0;s=e+88|0;t=e+1176|0;v=e+1128|0;w=f[c+12>>2]|0;x=f[c+8>>2]|0;y=f[c>>2]|0;z=y>>>3&511;A=1212424721>>>(y<<2&28)<<3&120;y=(z|0)!=0;B=y?3:1;C=c+4|0;D=f[C>>2]|0;if((D|0)>0)E=f[(f[c+44>>2]|0)+(D+-1<<2)>>2]|0;else E=0;D=Y(E,w)|0;E=f[d+4>>2]|0;F=f[d>>2]|0;d=F;if((E|0)==(F|0))G=1;else{H=E-F>>2;F=0;E=1;while(1){if((f[d+(F<<2)>>2]|0)==32)I=(f[d+((F|1)<<2)>>2]|0)!=0;else I=E;F=F+2|0;if(F>>>0>=H>>>0){G=I;break}else E=I}}Tya(r);f[r>>2]=104660;I=a+20|0;E=f[I>>2]|0;if(!E){if(!(zya(r,a+12|0)|0)){J=0;xya(r);u=e;return J|0}}else{if(!(Aya(r,E)|0)){J=0;xya(r);u=e;return J|0}E=f[c>>2]&7|(B<<3)+-8;a=f[I>>2]|0;if(G)K=D;else{switch(E&31){case 0:{L=4;break}case 16:{L=14;break}default:L=(E|0)==2?6:20}K=Y(L,w)|0|1}L=(Y(K,x)|0)+511&-256;K=a+8|0;E=f[a>>2]|0;I=E;if(((f[K>>2]|0)-E|0)>>>0<L>>>0){H=a+4|0;F=(f[H>>2]|0)-E|0;d=NYa(L)|0;M=d+F|0;N=M+(0-F)|0;if((F|0)>0)K1a(N|0,I|0,F|0)|0;f[a>>2]=N;f[H>>2]=M;f[K>>2]=d+L;if(E|0)PYa(I)}}if(G){I=f[C>>2]|0;if((I|0)>0)O=f[(f[c+44>>2]|0)+(I+-1<<2)>>2]|0;else O=0;P=Y(O,w)|0}else P=(Y((B*6|0)+(y?2:0)|0,w)|0)+32|0;O=(P|0)>128?P:128;P=s+8|0;f[s>>2]=P;I=s+4|0;f[I>>2]=O;if(O>>>0>1032){C=OYa(O)|0;f[s>>2]=C;Q=C}else Q=P;f[g>>2]=(G?3:0)+(y?51:50);f[g+4>>2]=353046;f[g+8>>2]=w;f[g+12>>2]=x;f[g+16>>2]=(1<<A)+-1;SLa(Q,353007,g)|0;Uya(r,Q,xKa(Q)|0);if((x|0)>0){C=c+16|0;O=c+44|0;c=(z|0)==2;E=(A|0)==8;L=t+4|0;d=v+4|0;K=y|A>>>0>8;M=(A|0)==16;A=(z|0)==0;z=Y(w<<1,B)|0;H=(z|0)>0;N=Y(B,w)|0;a=(N|0)>0;F=Q;R=(w|0)>0;S=Q+(w*6|0)|0;T=Q+(w<<2)|0;U=0;do{V=(f[C>>2]|0)+(Y(f[f[O>>2]>>2]|0,U)|0)|0;if(G){do if(c)if(E){f[t>>2]=w;f[L>>2]=1;f[g>>2]=f[t>>2];f[g+4>>2]=f[t+4>>2];Bza(V,0,Q,0,g);break}else{f[v>>2]=w;f[d>>2]=1;f[g>>2]=f[v>>2];f[g+4>>2]=f[v+4>>2];Cza(V,0,Q,0,g);W=35;break}else W=35;while(0);if((W|0)==35?(W=0,M):0){if(A)K1a(Q|0,V|0,D|0)|0;if(H){X=0;do{Z=Q+X|0;_=b[Z>>0]|0;$=Q+(X|1)|0;b[Z>>0]=b[$>>0]|0;b[$>>0]=_;X=X+2|0}while((X|0)<(z|0))}}Uya(r,K?Q:V,D)}else{a:do if(y){if(E){if(a){aa=Q;ba=0}else{ca=Q;break}while(1){f[q>>2]=h[V+(ba+2)>>0];SLa(aa,353056,q)|0;f[p>>2]=h[V+(ba+1)>>0];SLa(aa+4|0,353056,p)|0;f[o>>2]=h[V+ba>>0];SLa(aa+8|0,353056,o)|0;b[aa+12>>0]=32;X=aa+14|0;b[aa+13>>0]=32;ba=ba+B|0;if((ba|0)>=(N|0)){ca=X;break a}else aa=X}}if(a){X=Q;_=0;while(1){f[n>>2]=j[V+(_+2<<1)>>1];SLa(X,353061,n)|0;f[m>>2]=j[V+(_+1<<1)>>1];SLa(X+6|0,353061,m)|0;f[l>>2]=j[V+(_<<1)>>1];SLa(X+12|0,353061,l)|0;b[X+18>>0]=32;$=X+20|0;b[X+19>>0]=32;_=_+B|0;if((_|0)>=(N|0)){ca=$;break}else X=$}}else ca=Q}else{if(E){if(R){da=Q;ea=0}else{ca=Q;break}while(1){f[k>>2]=h[V+ea>>0];SLa(da,353056,k)|0;ea=ea+1|0;if((ea|0)==(w|0)){ca=T;break a}else da=da+4|0}}if(R){X=Q;_=0;while(1){f[i>>2]=j[V+(_<<1)>>1];SLa(X,353061,i)|0;_=_+1|0;if((_|0)==(w|0)){ca=S;break}else X=X+6|0}}else ca=Q}while(0);b[ca>>0]=10;Uya(r,Q,ca+1-F|0)}U=U+1|0}while((U|0)<(x|0))}Bya(r);x=f[s>>2]|0;if((x|0)!=(P|0)){if(x|0)QYa(x);f[s>>2]=P;f[I>>2]=1032}J=1;xya(r);u=e;return J|0}function aya(a,b){a=a|0;b=b|0;var c=0,d=0;b=NYa(36)|0;bya(b);c=NYa(16)|0;d=c+4|0;f[d>>2]=1;f[c>>2]=101920;f[c+8>>2]=b;f[a>>2]=c;f[a+4>>2]=b;f[d>>2]=(f[d>>2]|0)+1;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1)return;ki[f[(f[c>>2]|0)+8>>2]&2047](c);return}function bya(a){a=a|0;var c=0,d=0,e=0;iAa(a);f[a>>2]=104336;c=a+4|0;d$(c);d=c$(c,53)|0;c=352953;e=d+53|0;do{b[d>>0]=b[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(e|0));b[a+24>>0]=1;return}function cya(a){a=a|0;var c=0;hAa(a);f[a>>2]=104280;c=a+96|0;Kya(c);f[c>>2]=104580;f[a+1160>>2]=-1;b[a+92>>0]=1;f[a+1156>>2]=0;b[a+1164>>0]=0;f[a+1168>>2]=0;return}function dya(a){a=a|0;f[a>>2]=104380;oya(a+96|0);Owa(a);return}function eya(a){a=a|0;f[a>>2]=104380;oya(a+96|0);Owa(a);PYa(a);return}function fya(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=u;u=u+768|0;d=c;e=a+96|0;if(!(qya(e,a+20|0)|0)){g=0;u=c;return g|0}Nya(e,4);h=Sya(e)|0;i=a+4|0;f[i>>2]=h;h=Sya(e)|0;j=a+8|0;f[j>>2]=h;h=Sya(e)|0;k=a+1156|0;f[k>>2]=h;l=3<<h;Nya(e,4);h=Sya(e)|0;m=a+1164|0;f[m>>2]=h;h=Sya(e)|0;n=a+1168|0;f[n>>2]=h;h=Sya(e)|0;o=a+1172|0;f[o>>2]=h;a:do if((f[i>>2]|0)>0?(f[j>>2]|0)>0:0){p=f[k>>2]|0;switch(p|0){case 32:case 24:case 8:case 1:break;default:break a}b:do if((f[m>>2]|0)>>>0>=2){switch(f[a+12>>2]|0){case 3:{break b;break}case 2:break;default:break a}if((p|0)!=8)break a}while(0);switch(f[n>>2]|0){case 0:{if(h|0)break a;q=a+132|0;F1a(q|0,0,1024)|0;r=(p|0)>8?16:0;f[a+12>>2]=r;if((r>>>3|1|0)==1)Kza(q,p,0);q=Mya(e)|0;f[a+1160>>2]=q;g=1;u=c;return g|0}case 1:break;default:break a}if((h|0)<=(l|0)&(h|0)>0&(p|0)<9){q=a+132|0;F1a(q|0,0,1024)|0;r=Pya(e,d,h)|0;if((r|0)!=(f[o>>2]|0))break;s=(r|0)/3|0;if((r|0)>2){r=s<<1;t=0;do{b[a+132+(t<<2)>>0]=b[d+(t+r)>>0]|0;b[a+132+(t<<2)+1>>0]=b[d+(t+s)>>0]|0;b[a+132+(t<<2)+2>>0]=b[d+t>>0]|0;b[a+132+(t<<2)+3>>0]=0;t=t+1|0}while((t|0)<(s|0))}s=Lza(q,f[k>>2]|0)|0;f[a+12>>2]=s?16:0;s=Mya(e)|0;f[a+1160>>2]=s;g=1;u=c;return g|0}}while(0);f[a+1160>>2]=-1;f[j>>2]=-1;f[i>>2]=-1;sya(e);g=0;u=c;return g|0}function gya(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;d=u;u=u+2400|0;e=d+2128|0;g=d+2136|0;i=d+2120|0;j=d+1072|0;k=d+24|0;l=d+8|0;m=d+2124|0;n=d+2112|0;o=d+1064|0;p=d+16|0;q=d;r=(f[c>>2]&4088|0)!=0;s=f[c+16>>2]|0;t=f[c+48>>2]|0;F1a(g|0,0,256)|0;c=a+4|0;v=f[c>>2]|0;w=a+1156|0;x=(((Y(f[w>>2]|0,v)|0)+7|0)/8|0)+1&-2;y=r?3:1;z=Y(v,y)|0;v=a+1160|0;if((f[v>>2]|0)<0){A=0;u=d;return A|0}B=a+96|0;if(!(Jya(B)|0)){A=0;u=d;return A|0}C=x+32|0;D=j+8|0;f[j>>2]=D;E=j+4|0;f[E>>2]=C;if(C>>>0>1032){F=OYa(C)|0;f[j>>2]=F;G=F}else G=D;F=((f[c>>2]|0)*3|0)+32|0;C=k+8|0;f[k>>2]=C;H=k+4|0;f[H>>2]=F;if(F>>>0>1032){I=OYa(F)|0;f[k>>2]=I;J=I}else J=C;if(!r?(f[a+1168>>2]|0)==1:0)Jza(a+132|0,g,1<<f[w>>2]);Lya(B,f[v>>2]|0);a:do switch(f[w>>2]|0){case 1:{v=(f[a+12>>2]|0)==2;f[i>>2]=0;if(!v){v=a+8|0;if((f[v>>2]|0)<=0){K=1;break a}I=a+132|0;if(r){F=s;while(1){Pya(B,G,x)|0;Sza(F,G,f[c>>2]|0,I)|0;L=(f[i>>2]|0)+1|0;f[i>>2]=L;if((L|0)<(f[v>>2]|0))F=F+t|0;else{K=1;break a}}}else{F=s;while(1){Pya(B,G,x)|0;Tza(F,G,f[c>>2]|0,g)|0;I=(f[i>>2]|0)+1|0;f[i>>2]=I;if((I|0)<(f[v>>2]|0))F=F+t|0;else{K=1;break a}}}}F=G+(((f[c>>2]|0)+7|0)/8|0)|0;v=F;I=a+132|0;L=a+8|0;if(r){M=s;while(1){N=G;while(1){O=v-N|0;P=0;while(1){Q=Oya(B)|0;if((Q|0)==128?(R=Oya(B)|0,R|0):0){S=22;break}b[N+P>>0]=Q;T=P+1|0;if((T|0)<(O|0))P=T;else{S=21;break}}if((S|0)==21){S=0;U=N+T|0}else if((S|0)==22){S=0;O=N+P|0;if((R|0)>0){Q=R+1|0;V=Oya(B)|0;if((R|0)>=(v-O|0)){K=0;break a}F1a(O|0,V&255|0,Q|0)|0;U=O+Q|0}else U=O}if(U>>>0<F>>>0)N=U;else break}Sza(M,G,f[c>>2]|0,I)|0;N=(f[i>>2]|0)+1|0;f[i>>2]=N;if((N|0)<(f[L>>2]|0))M=M+t|0;else{K=1;break}}}else{M=s;while(1){I=G;while(1){N=v-I|0;O=0;while(1){Q=Oya(B)|0;if((Q|0)==128?(W=Oya(B)|0,W|0):0){S=34;break}b[I+O>>0]=Q;X=O+1|0;if((X|0)<(N|0))O=X;else{S=33;break}}if((S|0)==33){S=0;Z=I+X|0}else if((S|0)==34){S=0;N=I+O|0;if((W|0)>0){P=W+1|0;Q=Oya(B)|0;if((W|0)>=(v-N|0)){K=0;break a}F1a(N|0,Q&255|0,P|0)|0;Z=N+P|0}else Z=N}if(Z>>>0<F>>>0)I=Z;else break}Tza(M,G,f[c>>2]|0,g)|0;I=(f[i>>2]|0)+1|0;f[i>>2]=I;if((I|0)<(f[L>>2]|0))M=M+t|0;else{K=1;break}}}break}case 8:{if((f[a+12>>2]|0)!=2){f[i>>2]=0;M=a+8|0;if((f[M>>2]|0)<=0){K=1;break a}L=a+132|0;if(r){F=s;while(1){Pya(B,G,x)|0;Oza(F,G,f[c>>2]|0,L)|0;v=(f[i>>2]|0)+1|0;f[i>>2]=v;if((v|0)<(f[M>>2]|0))F=F+t|0;else{K=1;break a}}}else{F=s;while(1){Pya(B,G,x)|0;Pza(F,G,f[c>>2]|0,g)|0;L=(f[i>>2]|0)+1|0;f[i>>2]=L;if((L|0)<(f[M>>2]|0))F=F+t|0;else{K=1;break a}}}}F=s+z|0;f[l>>2]=F;f[i>>2]=0;M=G;L=a+132|0;v=a+8|0;I=0-z|0;N=F;F=s;while(1){P=N-F|0;Q=G;while(1){V=Oya(B)|0;if((V|0)==128?(_=Oya(B)|0,_|0):0){$=_;aa=Q;break}_=Q+1|0;b[Q>>0]=V;P=P-y|0;if((P|0)<=0){$=0;aa=_;break}else Q=_}Q=aa-M|0;if((Q|0)>0){if(r)Oza(F,G,Q,L)|0;else Pza(F,G,Q,g)|0;ba=F+(Y(Q,y)|0)|0}else ba=F;if(($|0)>0){Q=Y($+1|0,y)|0;P=Oya(B)|0;_=wza(t)|0;V=f[v>>2]|0;if(r){ca=a+132+(P<<2)|0;f[m>>2]=h[ca>>0]|h[ca+1>>0]<<8|h[ca+2>>0]<<16|h[ca+3>>0]<<24;b[e>>0]=b[m>>0]|0;b[e+1>>0]=b[m+1>>0]|0;b[e+2>>0]=b[m+2>>0]|0;b[e+3>>0]=b[m+3>>0]|0;da=Mza(ba,l,_,z,i,V,Q,e)|0}else da=Nza(ba,l,_,z,i,V,Q,b[g+P>>0]|0)|0;if((f[i>>2]|0)<(f[v>>2]|0))ea=da;else{fa=1;break}}else ea=ba;P=f[l>>2]|0;if((ea|0)!=(P|0)){N=P;F=ea;continue}if(Oya(B)|0){fa=0;break}P=(f[l>>2]|0)+t|0;f[l>>2]=P;Q=(f[i>>2]|0)+1|0;f[i>>2]=Q;if((Q|0)<(f[v>>2]|0)){N=P;F=P+I|0}else{fa=1;break}}K=fa;break}case 24:{f[i>>2]=0;I=a+8|0;if((f[I>>2]|0)>0){F=a+12|0;N=n+4|0;v=o+4|0;if(r)ga=s;else{L=s;while(1){Pya(B,J,x)|0;f[o>>2]=f[c>>2];f[v>>2]=1;M=(f[F>>2]|0)==3?2:0;f[e>>2]=f[o>>2];f[e+4>>2]=f[o+4>>2];xza(J,0,L,0,e,M);M=(f[i>>2]|0)+1|0;f[i>>2]=M;if((M|0)<(f[I>>2]|0))L=L+t|0;else{K=1;break a}}}while(1){Pya(B,ga,x)|0;if((f[F>>2]|0)==3){f[n>>2]=f[c>>2];f[N>>2]=1;f[e>>2]=f[n>>2];f[e+4>>2]=f[n+4>>2];Bza(ga,0,ga,0,e)}L=(f[i>>2]|0)+1|0;f[i>>2]=L;if((L|0)<(f[I>>2]|0))ga=ga+t|0;else{K=1;break}}}else K=1;break}case 32:{f[i>>2]=0;I=a+8|0;if((f[I>>2]|0)>0){N=G+3|0;F=G+4|0;L=p+4|0;v=a+12|0;M=q+4|0;if(r){P=s;while(1){Pya(B,N,x)|0;f[p>>2]=f[c>>2];f[L>>2]=1;Q=(f[v>>2]|0)==3?2:0;f[e>>2]=f[p>>2];f[e+4>>2]=f[p+4>>2];Aza(F,0,P,0,e,Q);Q=(f[i>>2]|0)+1|0;f[i>>2]=Q;if((Q|0)<(f[I>>2]|0))P=P+t|0;else{K=1;break}}}else{P=s;while(1){Pya(B,N,x)|0;f[q>>2]=f[c>>2];f[M>>2]=1;L=(f[v>>2]|0)==3?2:0;f[e>>2]=f[q>>2];f[e+4>>2]=f[q+4>>2];zza(F,0,P,0,e,L);L=(f[i>>2]|0)+1|0;f[i>>2]=L;if((L|0)<(f[I>>2]|0))P=P+t|0;else{K=1;break}}}}else K=1;break}default:K=0}while(0);t=f[k>>2]|0;if((t|0)!=(C|0)){if(t|0)QYa(t);f[k>>2]=C;f[H>>2]=1032}H=f[j>>2]|0;if((H|0)!=(D|0)){if(H|0)QYa(H);f[j>>2]=D;f[E>>2]=1032}A=K;u=d;return A|0}function hya(a,b){a=a|0;b=b|0;var c=0,d=0;b=NYa(1176)|0;iya(b);c=NYa(16)|0;d=c+4|0;f[d>>2]=1;f[c>>2]=101860;f[c+8>>2]=b;f[a>>2]=c;f[a+4>>2]=b;f[d>>2]=(f[d>>2]|0)+1;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1)return;ki[f[(f[c>>2]|0)+8>>2]&2047](c);return}function iya(a){a=a|0;var c=0,d=0;hAa(a);f[a>>2]=104380;c=a+96|0;Kya(c);f[c>>2]=104620;f[a+1160>>2]=-1;c=a+28|0;d$(c);d=c$(c,4)|0;b[d>>0]=-1788172711;b[d+1>>0]=-1788172711>>8;b[d+2>>0]=-1788172711>>16;b[d+3>>0]=-1788172711>>24;f[a+1156>>2]=0;f[a+1164>>2]=1;f[a+1168>>2]=0;f[a+1172>>2]=0;return}function jya(a){a=a|0;f[a>>2]=104796;d$(a+28|0);d$(a+12|0);d$(a+4|0);return}function kya(a){a=a|0;f[a>>2]=104796;d$(a+28|0);d$(a+12|0);d$(a+4|0);PYa(a);return}function lya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+48|0;d=c;e=f[b+12>>2]|0;g=f[b+8>>2]|0;h=((f[b>>2]|0)>>>3&511)+1|0;i=(Y(h,e)|0)+1&-2;Tya(d);f[d>>2]=104700;if(!(zya(d,a+12|0)|0)){j=0;xya(d);u=c;return j|0}Uya(d,353138,4);Xya(d,e);Xya(d,g);Xya(d,h<<3);Xya(d,Y(i,g)|0);Xya(d,1);Xya(d,0);Xya(d,0);if((g|0)>0){h=b+16|0;e=b+44|0;b=0;do{Uya(d,(f[h>>2]|0)+(Y(f[f[e>>2]>>2]|0,b)|0)|0,i);b=b+1|0}while((b|0)<(g|0))}Bya(d);j=1;xya(d);u=c;return j|0}function mya(a,b){a=a|0;b=b|0;var c=0,d=0;b=NYa(36)|0;nya(b);c=NYa(16)|0;d=c+4|0;f[d>>2]=1;f[c>>2]=101880;f[c+8>>2]=b;f[a>>2]=c;f[a+4>>2]=b;f[d>>2]=(f[d>>2]|0)+1;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1)return;ki[f[(f[c>>2]|0)+8>>2]&2047](c);return}function nya(a){a=a|0;var c=0,d=0;iAa(a);f[a>>2]=104436;c=a+4|0;d$(c);a=c$(c,29)|0;c=353108;d=a+29|0;do{b[a>>0]=b[c>>0]|0;a=a+1|0;c=c+1|0}while((a|0)<(d|0));return}function oya(a){a=a|0;var c=0,d=0;f[a>>2]=104480;c=a+20|0;d=f[c>>2]|0;if(d|0){GMa(d)|0;f[c>>2]=0}b[a+32>>0]=0;if(!(b[a+4>>0]|0)){f[a+16>>2]=0;f[a+12>>2]=0;f[a+8>>2]=0}ki[f[(f[a>>2]|0)+24>>2]&2047](a);return}function pya(a){a=a|0;var c=0,d=0;f[a>>2]=104480;c=a+20|0;d=f[c>>2]|0;if(d|0){GMa(d)|0;f[c>>2]=0}b[a+32>>0]=0;if(!(b[a+4>>0]|0)){f[a+16>>2]=0;f[a+12>>2]=0;f[a+8>>2]=0}ki[f[(f[a>>2]|0)+24>>2]&2047](a);PYa(a);return}function qya(a,c){a=a|0;c=c|0;var d=0,e=0;ki[f[(f[a>>2]|0)+16>>2]&2047](a);ki[f[(f[a>>2]|0)+28>>2]&2047](a);d=f[c>>2]|0;c=NMa((d|0)==0?5694105:d,353317)|0;d=a+20|0;f[d>>2]=c;if(!c){e=0;return e|0}b[a+32>>0]=1;c=f[a+8>>2]|0;f[a+28>>2]=0;f[a+16>>2]=c;ki[f[(f[a>>2]|0)+20>>2]&2047](a);e=(f[d>>2]|0)!=0;return e|0}function rya(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d;ki[f[(f[a>>2]|0)+16>>2]&2047](a);g=c+16|0;h=f[g>>2]|0;if(!h){i=0;u=d;return i|0}j=c+4|0;k=f[j>>2]|0;if((k|0)<3)l=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{m=f[c+40>>2]|0;n=0;o=1;while(1){p=Y(f[m+(n<<2)>>2]|0,o)|0;n=n+1|0;if((n|0)==(k|0)){l=p;break}else o=p}}if((k|0)==0|(l|0)==0){i=0;u=d;return i|0}if(!(f[c>>2]&16384)){f[e>>2]=0;f[e+4>>2]=0;l=c$(e,18)|0;o=353293;n=l+18|0;do{b[l>>0]=b[o>>0]|0;l=l+1|0;o=o+1|0}while((l|0)<(n|0));j$(-215,e,353312,353208,134);d$(e);q=f[j>>2]|0;r=f[g>>2]|0}else{q=k;r=h}f[a+8>>2]=r;h=Y(f[c+8>>2]|0,f[c+12>>2]|0)|0;if((q|0)>0)s=f[(f[c+44>>2]|0)+(q+-1<<2)>>2]|0;else s=0;q=r+(Y(h,s)|0)|0;f[a+12>>2]=q;b[a+4>>0]=0;b[a+32>>0]=1;f[a+28>>2]=0;f[a+16>>2]=r;i=1;u=d;return i|0}function sya(a){a=a|0;var c=0,d=0;c=a+20|0;d=f[c>>2]|0;if(d|0){GMa(d)|0;f[c>>2]=0}b[a+32>>0]=0;if(b[a+4>>0]|0)return;f[a+16>>2]=0;f[a+12>>2]=0;f[a+8>>2]=0;return}function tya(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=u;u=u+32|0;d=c+16|0;e=c+8|0;g=c;h=a+28|0;i=a+16|0;j=a+8|0;k=f[j>>2]|0;l=(f[i>>2]|0)+(f[h>>2]|0)-k|0;m=a+20|0;n=f[m>>2]|0;o=k;if(!n){k=o+l|0;f[h>>2]=0;f[i>>2]=k;if(k>>>0<(f[a+12>>2]|0)>>>0){u=c;return}else{k=De(44)|0;f[d>>2]=0;f[d+4>>2]=0;p=c$(d,30)|0;q=353167;r=p+30|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));f[e>>2]=0;f[e+4>>2]=0;p=c$(e,9)|0;q=353198;r=p+9|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));f[g>>2]=0;f[g+4>>2]=0;p=c$(g,53)|0;q=353208;r=p+53|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));k$(k,-2,d,e,g,101);f[k>>2]=104520;Of(k|0,18968,59)}}else{k=(l|0)%(f[a+24>>2]|0)|0;s=l-k|0;f[h>>2]=s;f[i>>2]=o+k;RMa(n,s,0)|0;s=MMa(f[j>>2]|0,1,f[a+24>>2]|0,f[m>>2]|0)|0;m=f[j>>2]|0;f[a+12>>2]=m+s;f[i>>2]=m;if((s|0)>0){u=c;return}else{c=De(44)|0;f[d>>2]=0;f[d+4>>2]=0;p=c$(d,30)|0;q=353167;r=p+30|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));f[e>>2]=0;f[e+4>>2]=0;p=c$(e,9)|0;q=353198;r=p+9|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));f[g>>2]=0;f[g+4>>2]=0;p=c$(g,53)|0;q=353208;r=p+53|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));k$(c,-2,d,e,g,110);f[c>>2]=104520;Of(c|0,18968,59)}}}function uya(a){a=a|0;var c=0,d=0,e=0;c=a+4|0;d=a+8|0;if(b[c>>0]|0?(e=f[d>>2]|0,e|0):0)QYa(e);f[a+16>>2]=0;f[a+12>>2]=0;f[d>>2]=0;b[c>>0]=0;return}function vya(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+4|0;if(b[c>>0]|0)return;d=f[a+24>>2]|0;e=OYa((d|0)>-1?d:-1)|0;f[a+8>>2]=e;g=e+d|0;f[a+12>>2]=g;f[a+16>>2]=g;b[c>>0]=1;return}function wya(a){a=a|0;e$(a);PYa(a);return}function xya(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f[a>>2]=104540;c=a+28|0;if(b[c>>0]|0?(d=a+12|0,e=a+4|0,g=f[e>>2]|0,h=(f[d>>2]|0)-g|0,h|0):0){i=a+32|0;j=f[i>>2]|0;if(!j)xMa(g,1,h,f[a+24>>2]|0)|0;else{k=j+4|0;l=f[k>>2]|0;m=f[j>>2]|0;n=l-m|0;o=n+h|0;p=m;m=l;if(n>>>0>=o>>>0)if(n>>>0>o>>>0?(l=p+o|0,(m|0)!=(l|0)):0){o=m;do o=o+-1|0;while((o|0)!=(l|0));f[k>>2]=l;q=g;r=p}else{q=g;r=p}else{TR(j,h);q=f[e>>2]|0;r=f[f[i>>2]>>2]|0}K1a(r+n|0,q|0,h|0)|0}f[d>>2]=f[e>>2];e=a+20|0;f[e>>2]=(f[e>>2]|0)+h}h=a+24|0;e=f[h>>2]|0;if(!e){s=a+32|0;f[s>>2]=0;b[c>>0]=0;t=f[a>>2]|0;u=t+24|0;v=f[u>>2]|0;ki[v&2047](a);return}GMa(e)|0;f[h>>2]=0;s=a+32|0;f[s>>2]=0;b[c>>0]=0;t=f[a>>2]|0;u=t+24|0;v=f[u>>2]|0;ki[v&2047](a);return}function yya(a){a=a|0;xya(a);PYa(a);return}function zya(a,c){a=a|0;c=c|0;var d=0,e=0;ki[f[(f[a>>2]|0)+16>>2]&2047](a);ki[f[(f[a>>2]|0)+28>>2]&2047](a);d=f[c>>2]|0;c=NMa((d|0)==0?5694105:d,353339)|0;f[a+24>>2]=c;if(!c){e=(c|0)!=0;return e|0}b[a+28>>0]=1;f[a+20>>2]=0;f[a+12>>2]=f[a+4>>2];e=(c|0)!=0;return e|0}function Aya(a,c){a=a|0;c=c|0;ki[f[(f[a>>2]|0)+16>>2]&2047](a);ki[f[(f[a>>2]|0)+28>>2]&2047](a);f[a+32>>2]=c;b[a+28>>0]=1;f[a+20>>2]=0;f[a+12>>2]=f[a+4>>2];return 1}function Bya(a){a=a|0;var c=0,d=0,e=0;c=a+28|0;if(b[c>>0]|0)ki[f[(f[a>>2]|0)+20>>2]&2047](a);d=a+24|0;e=f[d>>2]|0;if(e|0){GMa(e)|0;f[d>>2]=0}f[a+32>>2]=0;b[c>>0]=0;return}function Cya(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=a+12|0;c=a+4|0;d=f[c>>2]|0;e=(f[b>>2]|0)-d|0;if(!e)return;g=a+32|0;h=f[g>>2]|0;if(!h)xMa(d,1,e,f[a+24>>2]|0)|0;else{i=h+4|0;j=f[i>>2]|0;k=f[h>>2]|0;l=j-k|0;m=l+e|0;n=k;k=j;if(l>>>0>=m>>>0)if(l>>>0>m>>>0?(j=n+m|0,(k|0)!=(j|0)):0){f[i>>2]=j;o=h;p=d}else{o=h;p=d}else{TR(h,e);o=f[g>>2]|0;p=f[c>>2]|0}K1a((f[o>>2]|0)+l|0,p|0,e|0)|0}f[b>>2]=f[c>>2];c=a+20|0;f[c>>2]=(f[c>>2]|0)+e;return}function Dya(a){a=a|0;var b=0,c=0;b=a+4|0;c=f[b>>2]|0;if(c|0)QYa(c);f[a+12>>2]=0;f[a+8>>2]=0;f[b>>2]=0;return}function Eya(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+4|0;c=f[b>>2]|0;d=f[a+16>>2]|0;if(!c){e=OYa((d|0)>-1?d:-1)|0;f[b>>2]=e;g=e}else g=c;f[a+8>>2]=g+d;f[a+12>>2]=g;return}function Fya(a){a=a|0;var c=0,d=0;f[a>>2]=104480;c=a+20|0;d=f[c>>2]|0;if(d|0){GMa(d)|0;f[c>>2]=0}b[a+32>>0]=0;if(!(b[a+4>>0]|0)){f[a+16>>2]=0;f[a+12>>2]=0;f[a+8>>2]=0}ki[f[(f[a>>2]|0)+24>>2]&2047](a);PYa(a);return}function Gya(a){a=a|0;var c=0,d=0;f[a>>2]=104480;c=a+20|0;d=f[c>>2]|0;if(d|0){GMa(d)|0;f[c>>2]=0}b[a+32>>0]=0;if(!(b[a+4>>0]|0)){f[a+16>>2]=0;f[a+12>>2]=0;f[a+8>>2]=0}ki[f[(f[a>>2]|0)+24>>2]&2047](a);PYa(a);return}function Hya(a){a=a|0;xya(a);PYa(a);return}function Iya(a){a=a|0;xya(a);PYa(a);return}function Jya(a){a=a|0;return (b[a+32>>0]|0)!=0|0}function Kya(a){a=a|0;var c=0;f[a>>2]=104480;c=a+8|0;f[a+28>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[a+24>>2]=32768;b[a+32>>0]=0;b[a+4>>0]=0;return}function Lya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(!(f[a+20>>2]|0)){c=0;d=b}else{e=(b|0)%(f[a+24>>2]|0)|0;c=b-e|0;d=e}e=(f[a+8>>2]|0)+d|0;f[a+28>>2]=c;f[a+16>>2]=e;return}function Mya(a){a=a|0;return (f[a+16>>2]|0)+(f[a+28>>2]|0)-(f[a+8>>2]|0)|0}function Nya(a,b){a=a|0;b=b|0;var c=0;c=a+16|0;f[c>>2]=(f[c>>2]|0)+b;return}function Oya(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;e=a+16|0;g=f[e>>2]|0;h=a+12|0;i=f[h>>2]|0;if(g>>>0<i>>>0){j=i;k=g}else{ki[f[(f[a>>2]|0)+20>>2]&2047](a);j=f[h>>2]|0;k=f[e>>2]|0}if(k>>>0<j>>>0){l=b[k>>0]|0;m=l&255;n=k+1|0;f[e>>2]=n;u=c;return m|0}f[d>>2]=0;f[d+4>>2]=0;j=c$(d,15)|0;h=353441;a=j+15|0;do{b[j>>0]=b[h>>0]|0;j=j+1|0;h=h+1|0}while((j|0)<(a|0));j$(-215,d,353457,353208,212);d$(d);l=b[k>>0]|0;m=l&255;n=k+1|0;f[e>>2]=n;u=c;return m|0}function Pya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if((c|0)<=0){d=0;return d|0}e=a+12|0;g=a+16|0;h=f[g>>2]|0;i=c;c=b;b=0;while(1){j=(f[e>>2]|0)-h|0;k=(j|0)>(i|0)?i:j;if((k|0)>0){l=h;m=k}else{do{ki[f[(f[a>>2]|0)+20>>2]&2047](a);k=f[g>>2]|0;j=(f[e>>2]|0)-k|0;n=(j|0)>(i|0)?i:j}while((n|0)<=0);l=k;m=n}K1a(c|0,l|0,m|0)|0;h=(f[g>>2]|0)+m|0;f[g>>2]=h;i=i-m|0;n=m+b|0;if((i|0)<=0){d=n;break}else{c=c+m|0;b=n}}return d|0}function Qya(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+16|0;c=f[b>>2]|0;d=c+1|0;if(d>>>0<(f[a+12>>2]|0)>>>0){e=(h[d>>0]|0)<<8|(h[c>>0]|0);f[b>>2]=c+2;g=e;return g|0}else{e=Oya(a)|0;g=(Oya(a)|0)<<8|e;return g|0}return 0}function Rya(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+16|0;c=f[b>>2]|0;d=c+3|0;if(d>>>0<(f[a+12>>2]|0)>>>0){e=(h[c+1>>0]|0)<<8|(h[c>>0]|0)|(h[c+2>>0]|0)<<16|(h[d>>0]|0)<<24;f[b>>2]=c+4;g=e;return g|0}else{e=Oya(a)|0;c=(Oya(a)|0)<<8|e;e=c|(Oya(a)|0)<<16;g=e|(Oya(a)|0)<<24;return g|0}return 0}function Sya(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+16|0;c=f[b>>2]|0;d=c+3|0;if(d>>>0<(f[a+12>>2]|0)>>>0){e=(h[c+1>>0]|0)<<16|(h[c>>0]|0)<<24|(h[c+2>>0]|0)<<8|(h[d>>0]|0);f[b>>2]=c+4;g=e;return g|0}else{e=(Oya(a)|0)<<24;c=(Oya(a)|0)<<16|e;e=c|(Oya(a)|0)<<8;g=e|(Oya(a)|0);return g|0}return 0}function Tya(a){a=a|0;f[a>>2]=104540;f[a+12>>2]=0;f[a+8>>2]=0;f[a+4>>2]=0;f[a+24>>2]=0;f[a+20>>2]=0;f[a+16>>2]=32768;b[a+28>>0]=0;f[a+32>>2]=0;return}function Uya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if(!c)return;d=a+8|0;e=a+12|0;g=c;c=b;while(1){b=f[d>>2]|0;h=f[e>>2]|0;i=b-h|0;j=(i|0)>(g|0)?g:i;if((j|0)>0){K1a(h|0,c|0,j|0)|0;i=(f[e>>2]|0)+j|0;f[e>>2]=i;k=i;l=f[d>>2]|0;m=g-j|0;n=c+j|0}else{k=h;l=b;m=g;n=c}if((k|0)==(l|0))ki[f[(f[a>>2]|0)+20>>2]&2047](a);if(!m)break;else{g=m;c=n}}return}function Vya(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+12|0;e=f[d>>2]|0;g=e+1|0;h=a+8|0;i=c&255;if(g>>>0<(f[h>>2]|0)>>>0){b[e>>0]=i;b[g>>0]=c>>>8;j=e+2|0;f[d>>2]=j;if((j|0)!=(f[h>>2]|0))return;ki[f[(f[a>>2]|0)+20>>2]&2047](a);return}f[d>>2]=g;b[e>>0]=i;i=f[d>>2]|0;if(i>>>0<(f[h>>2]|0)>>>0)k=i;else{ki[f[(f[a>>2]|0)+20>>2]&2047](a);k=f[d>>2]|0}f[d>>2]=k+1;b[k>>0]=c>>>8;if((f[d>>2]|0)>>>0<(f[h>>2]|0)>>>0)return;ki[f[(f[a>>2]|0)+20>>2]&2047](a);return}function Wya(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+12|0;e=f[d>>2]|0;g=e+3|0;h=a+8|0;i=c&255;if(g>>>0<(f[h>>2]|0)>>>0){b[e>>0]=i;b[e+1>>0]=c>>>8;b[e+2>>0]=c>>>16;b[g>>0]=c>>>24;g=e+4|0;f[d>>2]=g;if((g|0)!=(f[h>>2]|0))return;ki[f[(f[a>>2]|0)+20>>2]&2047](a);return}f[d>>2]=e+1;b[e>>0]=i;i=f[d>>2]|0;if(i>>>0<(f[h>>2]|0)>>>0)j=i;else{ki[f[(f[a>>2]|0)+20>>2]&2047](a);j=f[d>>2]|0}f[d>>2]=j+1;b[j>>0]=c>>>8;j=f[d>>2]|0;if(j>>>0<(f[h>>2]|0)>>>0)k=j;else{ki[f[(f[a>>2]|0)+20>>2]&2047](a);k=f[d>>2]|0}f[d>>2]=k+1;b[k>>0]=c>>>16;k=f[d>>2]|0;if(k>>>0<(f[h>>2]|0)>>>0)l=k;else{ki[f[(f[a>>2]|0)+20>>2]&2047](a);l=f[d>>2]|0}f[d>>2]=l+1;b[l>>0]=c>>>24;if((f[d>>2]|0)>>>0<(f[h>>2]|0)>>>0)return;ki[f[(f[a>>2]|0)+20>>2]&2047](a);return}function Xya(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+12|0;e=f[d>>2]|0;g=e+3|0;h=a+8|0;i=c>>>24&255;if(g>>>0<(f[h>>2]|0)>>>0){b[e>>0]=i;b[e+1>>0]=c>>>16;b[e+2>>0]=c>>>8;b[g>>0]=c;g=e+4|0;f[d>>2]=g;if((g|0)!=(f[h>>2]|0))return;ki[f[(f[a>>2]|0)+20>>2]&2047](a);return}f[d>>2]=e+1;b[e>>0]=i;i=f[d>>2]|0;if(i>>>0<(f[h>>2]|0)>>>0)j=i;else{ki[f[(f[a>>2]|0)+20>>2]&2047](a);j=f[d>>2]|0}f[d>>2]=j+1;b[j>>0]=c>>>16;j=f[d>>2]|0;if(j>>>0<(f[h>>2]|0)>>>0)k=j;else{ki[f[(f[a>>2]|0)+20>>2]&2047](a);k=f[d>>2]|0}f[d>>2]=k+1;b[k>>0]=c>>>8;k=f[d>>2]|0;if(k>>>0<(f[h>>2]|0)>>>0)l=k;else{ki[f[(f[a>>2]|0)+20>>2]&2047](a);l=f[d>>2]|0}f[d>>2]=l+1;b[l>>0]=c;if((f[d>>2]|0)>>>0<(f[h>>2]|0)>>>0)return;ki[f[(f[a>>2]|0)+20>>2]&2047](a);return}function Yya(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0;e=u;u=u+48|0;g=e+32|0;h=e+24|0;i=e+16|0;j=e+8|0;k=e;l=(d|0)!=0;if(l?(f[d>>2]&1|0)!=0:0)m=d+4|0;else m=353465;f[k>>2]=m;if((ULa(a,353470,k)|0)<0){Zya(1,0);o=-1;u=e;return o|0}if(l){l=f[d>>2]|0;do if(!(l&2))q=l;else{p[j>>3]=+n[d+20>>2];if((ULa(a,353476,j)|0)>=0){q=f[d>>2]|0;break}Zya(1,0);o=-1;u=e;return o|0}while(0);if(q&4|0?(p[i>>3]=+n[d+24>>2],(ULa(a,353486,i)|0)<0):0){Zya(1,0);o=-1;u=e;return o|0}}if((ULa(a,353499,h)|0)<0){Zya(1,0);o=-1;u=e;return o|0}f[g>>2]=c;f[g+4>>2]=b;if((ULa(a,353524,g)|0)>=0){o=0;u=e;return o|0}Zya(1,0);o=-1;u=e;return o|0}function Zya(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d;switch(a|0){case 0:{f[e>>2]=0;f[e+4>>2]=0;i=c$(e,15)|0;j=353537;k=i+15|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-2,e,353553,353564,88);d$(e);u=d;return}case 1:{f[e>>2]=0;f[e+4>>2]=0;i=c$(e,16)|0;j=353615;k=i+16|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-2,e,353553,353564,91);d$(e);u=d;return}case 2:{f[g>>2]=0;a=g+4|0;f[a>>2]=0;i=c$(g,22)|0;j=353632;k=i+22|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));f[h>>2]=0;l=h+4|0;f[l>>2]=0;if((c|0)!=0?(m=xKa(c)|0,(m|0)!=0):0){K1a(c$(h,m)|0,c|0,m|0)|0;n=f[l>>2]|0}else n=0;f[e>>2]=0;f[e+4>>2]=0;c$(e,n+(f[a>>2]|0)|0)|0;n=f[a>>2]|0;if(n|0)K1a(f[e>>2]|0,f[g>>2]|0,n|0)|0;n=f[l>>2]|0;if(n|0)K1a((f[e>>2]|0)+(f[a>>2]|0)|0,f[h>>2]|0,n|0)|0;j$(-2,e,353553,353564,95);d$(e);d$(h);d$(g);u=d;return}default:{f[g>>2]=0;n=g+4|0;f[n>>2]=0;i=c$(g,13)|0;j=353655;k=i+13|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));f[h>>2]=0;j=h+4|0;f[j>>2]=0;if((c|0)!=0?(i=xKa(c)|0,(i|0)!=0):0){K1a(c$(h,i)|0,c|0,i|0)|0;o=f[j>>2]|0}else o=0;f[e>>2]=0;f[e+4>>2]=0;c$(e,o+(f[n>>2]|0)|0)|0;o=f[n>>2]|0;if(o|0)K1a(f[e>>2]|0,f[g>>2]|0,o|0)|0;o=f[j>>2]|0;if(o|0)K1a((f[e>>2]|0)+(f[n>>2]|0)|0,f[h>>2]|0,o|0)|0;j$(-2,e,353553,353564,100);d$(e);d$(h);d$(g);u=d;return}}}function _ya(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+160|0;h=g+16|0;i=g+8|0;j=g;k=g+32|0;l=g+24|0;m=(e|0)!=0;if(m){f[e>>2]=0;b[e+4>>0]=0;n[e+24>>2]=1.0;n[e+20>>2]=1.0}if(!(MLa(k,128,a)|0)){Zya(0,0);o=-1;u=g;return o|0}if((b[k>>0]|0)==35?m&(b[k+1>>0]|0)==63:0){f[e>>2]=f[e>>2]|1;p=0;while(1){q=b[k+(p+2)>>0]|0;if(!(q<<24>>24)){r=p;break}if(mLa(q<<24>>24)|0){r=p;break}b[e+4+p>>0]=q;q=p+1|0;if((q|0)<15)p=q;else{r=q;break}}b[e+4+r>>0]=0}a:do if(MLa(k,128,a)|0){r=e+20|0;p=e+24|0;q=0;b:while(1){c:do if(m)while(1){d:do switch(b[k>>0]|0){case 10:{break b;break}case 35:break;default:{if(!(KKa(k,353669)|0)){s=1;break c}f[j>>2]=l;if((SMa(k,353693,j)|0)==1){f[r>>2]=f[l>>2];f[e>>2]=f[e>>2]|2;break d}f[i>>2]=l;if((SMa(k,353702,i)|0)==1){f[p>>2]=f[l>>2];f[e>>2]=f[e>>2]|4}}}while(0);if(!(MLa(k,128,a)|0))break a}else{e:while(1){switch(b[k>>0]|0){case 10:{break b;break}case 35:break;default:break e}if(!(MLa(k,128,a)|0))break a}s=(KKa(k,353669)|0)==0}while(0);if(!(MLa(k,128,a)|0))break a;else q=q|s}if(KKa(k,353714)|0){Zya(2,353716);o=-1;u=g;return o|0}if(!q){Zya(2,353758);o=-1;u=g;return o|0}if(!(MLa(k,128,a)|0)){Zya(0,0);o=-1;u=g;return o|0}f[h>>2]=d;f[h+4>>2]=c;if((SMa(k,353783,h)|0)>=2){o=0;u=g;return o|0}Zya(2,353795);o=-1;u=g;return o|0}while(0);Zya(0,0);o=-1;u=g;return o|0}function $ya(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0.0;e=u;u=u+16|0;g=e;h=e+4|0;i=h+3|0;j=h+1|0;k=h+2|0;l=c;c=d;while(1){if((c|0)<=0){m=0;o=8;break}p=+n[l+8>>2];q=+n[l+4>>2];r=+n[l>>2];s=q>p?q:p;t=s<r?r:s;s=t;if(s<1.0e-32){b[i>>0]=0;v=0;w=0;x=h;y=0}else{z=+xNa(t,g)*256.0/s;b[h>>0]=~~(p*z);v=~~(r*z)&255;w=~~(q*z)&255;x=i;y=(f[g>>2]|0)+128&255}b[j>>0]=w;b[k>>0]=v;b[x>>0]=y;if(!(xMa(h,4,1,a)|0))break;else{l=l+12|0;c=c+-1|0}}if((o|0)==8){u=e;return m|0}Zya(1,0);m=-1;u=e;return m|0}function aza(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;g=u;u=u+16|0;h=g;i=g+4|0;if((d+-8|0)>>>0>32759){j=$ya(a,c,Y(e,d)|0)|0;u=g;return j|0}k=dKa(d<<2)|0;if(!k){j=$ya(a,c,Y(e,d)|0)|0;u=g;return j|0}a:do if((e|0)>0){l=i+1|0;m=d>>>8&255;o=i+2|0;p=d&255;q=i+3|0;r=d<<1;s=d*3|0;t=h+1|0;v=c;w=e;b:while(1){x=w;w=w+-1|0;b[i>>0]=2;b[l>>0]=2;b[o>>0]=m;b[q>>0]=p;if(!(xMa(i,4,1,a)|0)){y=9;break}else{z=v;A=0}while(1){B=+n[z+8>>2];C=+n[z+4>>2];D=+n[z>>2];E=C>B?C:B;F=E<D?D:E;E=F;if(E<1.0e-32){b[q>>0]=0;G=0;H=0;I=i;J=0}else{K=+xNa(F,h)*256.0/E;b[i>>0]=~~(B*K);G=~~(D*K)&255;H=~~(C*K)&255;I=q;J=(f[h>>2]|0)+128&255}b[l>>0]=H;b[o>>0]=G;b[I>>0]=J;b[k+A>>0]=b[i>>0]|0;b[k+(A+d)>>0]=b[l>>0]|0;b[k+(A+r)>>0]=b[o>>0]|0;b[k+(A+s)>>0]=b[q>>0]|0;A=A+1|0;if((A|0)==(d|0))break;else z=z+12|0}v=v+(s<<2)|0;L=0;do{M=k+(Y(L,d)|0)|0;N=0;while(1){if((N|0)<(d|0)){O=N;P=0;while(1){O=O+P|0;Q=O+1|0;c:do if((Q|0)<(d|0)){R=b[M+O>>0]|0;S=Q;T=1;while(1){if(R<<24>>24!=(b[M+S>>0]|0)){U=T;break c}V=T+1|0;S=V+O|0;if(!((V|0)<127&(S|0)<(d|0))){U=V;break}else T=V}}else U=1;while(0);if(!((O|0)<(d|0)&(U|0)<4))break;else P=U}if((P|0)>1&(P|0)==(O-N|0)){b[h>>0]=P+128;b[t>>0]=b[M+N>>0]|0;if(!(xMa(h,2,1,a)|0)){y=33;break b}else W=O}else if((O|0)>(N|0)){Q=N;while(1){T=O-Q|0;S=(T|0)<128?T:128;b[h>>0]=S;if(!(xMa(h,1,1,a)|0)){y=34;break b}T=S+Q|0;if(!(xMa(M+Q|0,S,1,a)|0)){y=35;break b}if((O|0)>(T|0))Q=T;else{W=T;break}}}else W=N;if((U|0)>3){b[h>>0]=U+128;b[t>>0]=b[M+O>>0]|0;if(!(xMa(h,2,1,a)|0)){y=36;break b}X=W+U|0}else X=W}else X=N;if((X|0)<(d|0))N=X;else break}L=L+1|0}while((L|0)<4);if((x|0)<=1)break a}if((y|0)==9){eKa(k);Zya(1,0);j=-1;u=g;return j|0}else if((y|0)==33)Zya(1,0);else if((y|0)==34)Zya(1,0);else if((y|0)==35)Zya(1,0);else if((y|0)==36)Zya(1,0);eKa(k);j=-1;u=g;return j|0}while(0);eKa(k);j=0;u=g;return j|0}function bza(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;f=u;u=u+16|0;g=f+8|0;i=f+4|0;j=f;if((d+-8|0)>>>0>32759){k=Y(e,d)|0;a:do if((k|0)>0){l=g+3|0;m=g+1|0;o=g+2|0;p=c;q=k;while(1){if(!(MMa(g,4,1,a)|0))break;r=p+8|0;s=p+4|0;t=b[l>>0]|0;if(!(t<<24>>24)){n[p>>2]=0.0;n[s>>2]=0.0;n[r>>2]=0.0}else{v=+tNa(1.0,(t&255)+-136|0);n[r>>2]=v*+(h[g>>0]|0);n[s>>2]=v*+(h[m>>0]|0);n[p>>2]=v*+(h[o>>0]|0)}if((q|0)>1){p=p+12|0;q=q+-1|0}else{w=0;break a}}Zya(0,0);w=-1}else w=0;while(0);x=w;u=f;return x|0}b:do if((e|0)>0){w=i+1|0;k=i+2|0;q=i+3|0;p=d<<2;o=j+1|0;m=d<<1;l=d*3|0;s=c;r=e;t=0;c:while(1){if(!(MMa(i,4,1,a)|0)){y=14;break}z=b[i>>0]|0;A=b[w>>0]|0;if(!(z<<24>>24==2&A<<24>>24==2)){y=17;break}B=h[k>>0]|0;if(B&128|0){y=17;break}if((h[q>>0]|0|B<<8|0)!=(d|0)){y=30;break}if(!t){B=dKa(p)|0;if(!B){y=34;break}else C=B}else C=t;B=0;D=C;while(1){B=B+1|0;E=C+(Y(B,d)|0)|0;if(D>>>0<E>>>0){F=E;G=D;while(1){if(!(MMa(j,2,1,a)|0)){y=39;break c}H=b[j>>0]|0;I=H&255;if((H&255)<=128){if(!(H<<24>>24)){y=48;break c}if((I|0)>(F-G|0)){y=48;break c}J=G+1|0;b[G>>0]=b[o>>0]|0;K=I+-1|0;if((H&255)>1){if(!(MMa(J,K,1,a)|0)){y=53;break c}L=J+K|0}else L=J}else{J=I+-128|0;if(!J){y=44;break c}if((J|0)>(F-G|0)){y=44;break c}K=G+-128|0;H=J;J=G;while(1){b[J>>0]=b[o>>0]|0;if((H|0)>1){H=H+-1|0;J=J+1|0}else break}L=K+I|0}if(L>>>0<E>>>0)G=L;else{M=L;break}}}else M=D;if((B|0)>=4){N=s;O=0;break}else D=M}while(1){D=b[C+O>>0]|0;b[i>>0]=D;B=b[C+(O+d)>>0]|0;b[w>>0]=B;G=b[C+(O+m)>>0]|0;b[k>>0]=G;E=b[C+(O+l)>>0]|0;b[q>>0]=E;F=N+8|0;J=N+4|0;if(!(E<<24>>24)){n[N>>2]=0.0;n[J>>2]=0.0;n[F>>2]=0.0}else{v=+tNa(1.0,(E&255)+-136|0);n[F>>2]=v*+(D&255);n[J>>2]=v*+(B&255);n[N>>2]=v*+(G&255)}O=O+1|0;if((O|0)==(d|0))break;else N=N+12|0}if((r|0)>1){s=s+(l<<2)|0;r=r+-1|0;t=C}else{P=C;break b}}if((y|0)==14){eKa(t);Zya(0,0);x=-1;u=f;return x|0}else if((y|0)==17){l=s+8|0;m=s+4|0;w=b[q>>0]|0;if(!(w<<24>>24)){n[s>>2]=0.0;n[m>>2]=0.0;n[l>>2]=0.0}else{v=+tNa(1.0,(w&255)+-136|0);n[l>>2]=v*+(z&255);n[m>>2]=v*+(A&255);n[s>>2]=v*+(h[k>>0]|0)}eKa(t);m=Y(r,d)|0;d:do if((m|0)>1){l=g+3|0;w=g+1|0;o=g+2|0;p=s;G=m;while(1){B=p;p=p+12|0;G=G+-1|0;if(!(MMa(g,4,1,a)|0))break;J=B+20|0;D=B+16|0;B=b[l>>0]|0;if(!(B<<24>>24)){n[p>>2]=0.0;n[D>>2]=0.0;n[J>>2]=0.0}else{v=+tNa(1.0,(B&255)+-136|0);n[J>>2]=v*+(h[g>>0]|0);n[D>>2]=v*+(h[w>>0]|0);n[p>>2]=v*+(h[o>>0]|0)}if((G|0)<=1){Q=0;break d}}Zya(0,0);Q=-1}else Q=0;while(0);x=Q;u=f;return x|0}else if((y|0)==30){eKa(t);Zya(2,353824);x=-1;u=f;return x|0}else if((y|0)==34){Zya(3,353845);x=-1;u=f;return x|0}else if((y|0)==39){eKa(C);Zya(0,0);x=-1;u=f;return x|0}else if((y|0)==44){eKa(C);Zya(2,353877);x=-1;u=f;return x|0}else if((y|0)==48){eKa(C);Zya(2,353877);x=-1;u=f;return x|0}else if((y|0)==53){eKa(C);Zya(0,0);x=-1;u=f;return x|0}}else P=0;while(0);eKa(P);x=0;u=f;return x|0}function cza(a,b){a=a|0;b=b|0;f[a>>2]=b;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+16>>2]=a+20;f[a+28>>2]=0;return}function dza(a){a=a|0;var b=0,c=0;eza(a+16|0,f[a+20>>2]|0);b=f[a+4>>2]|0;if(!b)return;c=a+8|0;if((f[c>>2]|0)!=(b|0))f[c>>2]=b;PYa(b);return}function eza(a,c){a=a|0;c=c|0;var d=0,e=0;if(!c)return;eza(a,f[c>>2]|0);eza(a,f[c+4>>2]|0);a=c+36|0;if((b[a+11>>0]|0)<0)PYa(f[a>>2]|0);a=f[c+24>>2]|0;if(a|0){d=c+28|0;e=f[d>>2]|0;if((e|0)!=(a|0))f[d>>2]=e+(~((e+-8-a|0)>>>3)<<3);PYa(a)}PYa(c);return}function fza(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;b=u;u=u+32|0;c=b+24|0;d=b+20|0;e=b+16|0;g=b+12|0;h=b;gza(h,a);i=a+16|0;if((i|0)==(h|0)){j=h+4|0;k=a+24|0;l=f[j>>2]|0;eza(h,l);m=f[k>>2]|0;n=(m|0)!=0;u=b;return n|0}o=a+20|0;eza(i,f[o>>2]|0);p=a+24|0;f[p>>2]=0;f[i>>2]=o;f[o>>2]=0;q=f[h>>2]|0;r=h+4|0;if((q|0)==(r|0)){j=r;k=p;l=f[j>>2]|0;eza(h,l);m=f[k>>2]|0;n=(m|0)!=0;u=b;return n|0}s=o;o=a+20|0;a=q;while(1){q=a+16|0;f[g>>2]=s;f[c>>2]=f[g>>2];t=hza(i,c,d,e,q)|0;if(!(f[t>>2]|0)){v=NYa(80)|0;f[v+16>>2]=f[q>>2];iza(v+24|0,a+24|0);YYa(v+36|0,a+36|0);q=v+48|0;w=a+48|0;f[q>>2]=f[w>>2];f[q+4>>2]=f[w+4>>2];f[q+8>>2]=f[w+8>>2];f[q+12>>2]=f[w+12>>2];f[q+16>>2]=f[w+16>>2];f[q+20>>2]=f[w+20>>2];f[q+24>>2]=f[w+24>>2];f[q+28>>2]=f[w+28>>2];w=f[d>>2]|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=w;f[t>>2]=v;w=f[f[i>>2]>>2]|0;if(!w)x=v;else{f[i>>2]=w;x=f[t>>2]|0}AU(f[o>>2]|0,x);f[p>>2]=(f[p>>2]|0)+1}t=f[a+4>>2]|0;if(!t){w=a+8|0;v=f[w>>2]|0;if((f[v>>2]|0)==(a|0))y=v;else{v=w;do{w=f[v>>2]|0;v=w+8|0;q=f[v>>2]|0}while((f[q>>2]|0)!=(w|0));y=q}}else{v=t;while(1){q=f[v>>2]|0;if(!q)break;else v=q}y=v}if((y|0)==(r|0)){j=r;k=p;break}else a=y}l=f[j>>2]|0;eza(h,l);m=f[k>>2]|0;n=(m|0)!=0;u=b;return n|0}function gza(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+32|0;e=d+12|0;g=d+8|0;i=d+4|0;j=d;k=d+16|0;l=c+16|0;m=f[l>>2]|0;n=c+20|0;if((m|0)!=(n|0)){o=m;do{f[g>>2]=o;f[e>>2]=f[g>>2];o=jza(l,e)|0}while((o|0)!=(n|0))}o=f[c>>2]|0;a:do if(!(f[o+(f[(f[o>>2]|0)+-12>>2]|0)+16>>2]&2)){m=k+1|0;p=e+1|0;q=c+4|0;r=c+8|0;s=o;b:while(1){lPa(s,k,2)|0;t=f[c>>2]|0;if((f[t+4>>2]|0)<2)break a;switch(b[m>>0]|0){case -31:{v=15;break b;break}case -2:case -17:case -18:case -19:case -20:case -21:case -22:case -23:case -24:case -25:case -26:case -27:case -28:case -29:case -30:case -32:case -41:case -42:case -43:case -44:case -45:case -46:case -47:case -48:case -38:case -35:case -37:case -60:case -62:case -64:{lPa(t,e,2)|0;w=f[c>>2]|0;if((f[w+4>>2]|0)<2){v=10;break b}x=h[e>>0]<<8|h[p>>0];if(x>>>0<2){v=12;break b}y=x+-2|0;mPa(w,y,((y|0)<0)<<31>>31,1)|0;y=f[c>>2]|0;if(!(f[y+(f[(f[y>>2]|0)+-12>>2]|0)+16>>2]&5))z=y;else{v=14;break b}break}case -39:case -40:{z=t;break}default:break a}if(!(f[z+(f[(f[z>>2]|0)+-12>>2]|0)+16>>2]&2))s=z;else break a}if((v|0)==10){A=De(1)|0;Of(A|0,19056,0)}else if((v|0)==12){A=De(1)|0;Of(A|0,19056,0)}else if((v|0)==14)Of(De(1)|0,19056,0);else if((v|0)==15){lPa(t,e,2)|0;s=f[c>>2]|0;if((f[s+4>>2]|0)<2){B=De(1)|0;Of(B|0,19056,0)}m=h[e>>0]<<8|h[p>>0];if(m>>>0<7){B=De(1)|0;Of(B|0,19056,0)}y=m+-6|0;m=f[r>>2]|0;w=f[q>>2]|0;x=m-w|0;C=w;w=m;if(y>>>0<=x>>>0)if(y>>>0<x>>>0?(m=C+y|0,(w|0)!=(m|0)):0){f[r>>2]=m;D=s}else D=s;else{TR(q,y-x|0);D=f[c>>2]|0}mPa(D,6,0,1)|0;x=f[c>>2]|0;if(f[x+(f[(f[x>>2]|0)+-12>>2]|0)+16>>2]&5|0)Of(De(1)|0,19056,0);lPa(x,f[q>>2]|0,y)|0;kza(c);y=a+4|0;f[y>>2]=0;x=a+8|0;f[x>>2]=0;s=a+4|0;f[a>>2]=s;m=f[l>>2]|0;if((m|0)==(n|0)){u=d;return}w=s;s=m;while(1){m=s+16|0;f[j>>2]=w;f[e>>2]=f[j>>2];C=hza(a,e,g,i,m)|0;if(!(f[C>>2]|0)){E=NYa(80)|0;f[E+16>>2]=f[m>>2];iza(E+24|0,s+24|0);YYa(E+36|0,s+36|0);m=E+48|0;F=s+48|0;f[m>>2]=f[F>>2];f[m+4>>2]=f[F+4>>2];f[m+8>>2]=f[F+8>>2];f[m+12>>2]=f[F+12>>2];f[m+16>>2]=f[F+16>>2];f[m+20>>2]=f[F+20>>2];f[m+24>>2]=f[F+24>>2];f[m+28>>2]=f[F+28>>2];F=f[g>>2]|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=F;f[C>>2]=E;F=f[f[a>>2]>>2]|0;if(!F)G=E;else{f[a>>2]=F;G=f[C>>2]|0}AU(f[y>>2]|0,G);f[x>>2]=(f[x>>2]|0)+1}C=f[s+4>>2]|0;if(!C){F=s+8|0;E=f[F>>2]|0;if((f[E>>2]|0)==(s|0))H=E;else{E=F;do{F=f[E>>2]|0;E=F+8|0;m=f[E>>2]|0}while((f[m>>2]|0)!=(F|0));H=m}}else{E=C;while(1){m=f[E>>2]|0;if(!m)break;else E=m}H=E}if((H|0)==(n|0))break;else s=H}u=d;return}}while(0);H=a+4|0;f[H>>2]=0;G=a+8|0;f[G>>2]=0;c=a+4|0;f[a>>2]=c;D=f[l>>2]|0;if((D|0)==(n|0)){u=d;return}l=c;c=D;while(1){D=c+16|0;f[j>>2]=l;f[e>>2]=f[j>>2];B=hza(a,e,g,i,D)|0;if(!(f[B>>2]|0)){t=NYa(80)|0;f[t+16>>2]=f[D>>2];iza(t+24|0,c+24|0);YYa(t+36|0,c+36|0);D=t+48|0;v=c+48|0;f[D>>2]=f[v>>2];f[D+4>>2]=f[v+4>>2];f[D+8>>2]=f[v+8>>2];f[D+12>>2]=f[v+12>>2];f[D+16>>2]=f[v+16>>2];f[D+20>>2]=f[v+20>>2];f[D+24>>2]=f[v+24>>2];f[D+28>>2]=f[v+28>>2];v=f[g>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=v;f[B>>2]=t;v=f[f[a>>2]>>2]|0;if(!v)I=t;else{f[a>>2]=v;I=f[B>>2]|0}AU(f[H>>2]|0,I);f[G>>2]=(f[G>>2]|0)+1}B=f[c+4>>2]|0;if(!B){v=c+8|0;t=f[v>>2]|0;if((f[t>>2]|0)==(c|0))J=t;else{t=v;do{v=f[t>>2]|0;t=v+8|0;D=f[t>>2]|0}while((f[D>>2]|0)!=(v|0));J=D}}else{t=B;while(1){D=f[t>>2]|0;if(!D)break;else t=D}J=t}if((J|0)==(n|0))break;else c=J}u=d;return}function hza(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=a+4|0;h=f[b>>2]|0;b=h;if((h|0)!=(g|0)?(i=f[e>>2]|0,j=f[h+16>>2]|0,(i|0)>=(j|0)):0){if((j|0)>=(i|0)){f[c>>2]=b;f[d>>2]=b;k=d;return k|0}d=h+4|0;j=f[d>>2]|0;if(!j){l=h+8|0;m=f[l>>2]|0;if((f[m>>2]|0)==(h|0))n=m;else{m=l;do{l=f[m>>2]|0;m=l+8|0;o=f[m>>2]|0}while((f[o>>2]|0)!=(l|0));n=o}}else{m=j;while(1){j=f[m>>2]|0;if(!j)break;else m=j}n=m}if((n|0)!=(g|0)?(i|0)>=(f[n+16>>2]|0):0){m=f[g>>2]|0;if(!m){f[c>>2]=g;k=g;return k|0}j=m;m=a+4|0;while(1){o=f[j+16>>2]|0;if((i|0)<(o|0)){l=f[j>>2]|0;if(!l){p=38;break}else{q=l;r=j}}else{if((o|0)>=(i|0)){p=43;break}s=j+4|0;o=f[s>>2]|0;if(!o){p=42;break}else{q=o;r=s}}j=q;m=r}if((p|0)==38){f[c>>2]=j;k=j;return k|0}else if((p|0)==42){f[c>>2]=j;k=s;return k|0}else if((p|0)==43){f[c>>2]=j;k=m;return k|0}}if(!(f[h+4>>2]|0)){f[c>>2]=b;k=d;return k|0}else{f[c>>2]=n;k=n;return k|0}}n=f[h>>2]|0;if((h|0)!=(f[a>>2]|0)){if(!n){d=h;while(1){m=f[d+8>>2]|0;if((f[m>>2]|0)==(d|0))d=m;else{t=m;break}}}else{d=n;while(1){m=f[d+4>>2]|0;if(!m){t=d;break}else d=m}}d=f[e>>2]|0;if((f[t+16>>2]|0)>=(d|0)){e=f[g>>2]|0;if(!e){f[c>>2]=g;k=g;return k|0}g=e;e=a+4|0;while(1){a=f[g+16>>2]|0;if((d|0)<(a|0)){m=f[g>>2]|0;if(!m){p=16;break}else{u=m;v=g}}else{if((a|0)>=(d|0)){p=21;break}w=g+4|0;a=f[w>>2]|0;if(!a){p=20;break}else{u=a;v=w}}g=u;e=v}if((p|0)==16){f[c>>2]=g;k=g;return k|0}else if((p|0)==20){f[c>>2]=g;k=w;return k|0}else if((p|0)==21){f[c>>2]=g;k=e;return k|0}}else x=t}else x=b;if(!n){f[c>>2]=h;k=h;return k|0}else{h=x;f[c>>2]=h;k=h+4|0;return k|0}return 0}function iza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>3;if(!g)return;if(g>>>0>536870911)gXa(a);h=NYa(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<3);g=f[b>>2]|0;b=(f[d>>2]|0)-g|0;if((b|0)<=0)return;K1a(h|0,g|0,b|0)|0;f[c>>2]=h+(b>>>3<<3);return}function jza(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=f[c>>2]|0;c=f[d+4>>2]|0;if(!c){e=d+8|0;g=f[e>>2]|0;if((f[g>>2]|0)==(d|0))h=g;else{g=e;do{e=f[g>>2]|0;g=e+8|0;i=f[g>>2]|0}while((f[i>>2]|0)!=(e|0));h=i}}else{g=c;while(1){c=f[g>>2]|0;if(!c)break;else g=c}h=g}if((f[a>>2]|0)==(d|0))f[a>>2]=h;g=a+8|0;f[g>>2]=(f[g>>2]|0)+-1;CU(f[a+4>>2]|0,d);a=d+36|0;if((b[a+11>>0]|0)<0)PYa(f[a>>2]|0);a=f[d+24>>2]|0;if(!a){PYa(d);return h|0}g=d+28|0;c=f[g>>2]|0;if((c|0)!=(a|0))f[g>>2]=c+(~((c+-8-a|0)>>>3)<<3);PYa(a);PYa(d);return h|0}function kza(a){a=a|0;var c=0,e=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;c=u;u=u+240|0;e=c+184|0;g=c+120|0;i=c+56|0;k=c;l=f[a+4>>2]|0;m=(f[a+8>>2]|0)-l|0;n=l;switch(m|0){case 0:{f[a+28>>2]=0;o=De(1)|0;Of(o|0,19056,0);break}case 1:{p=b[n>>0]|0;q=5;break}default:{l=b[n>>0]|0;if(l<<24>>24==(b[n+1>>0]|0)){p=l;q=5}else r=0}}if((q|0)==5)r=p<<24>>24==73?73:p<<24>>24==77?77:0;f[a+28>>2]=r;if(m>>>0<=3){o=De(1)|0;Of(o|0,19056,0)}o=(r|0)==73;r=h[n+2>>0]|0;p=b[n+3>>0]|0;if(o)s=(p&255)<<8|r;else s=p&255|r<<8;if((s&65535)<<16>>16!=42){u=c;return}if(m>>>0<=7)Of(De(1)|0,19056,0);s=h[n+4>>0]|0;r=b[n+5>>0]|0;p=b[n+6>>0]|0;l=b[n+7>>0]|0;if(o)t=(r&255)<<8|s|(p&255)<<16|(l&255)<<24;else t=(r&255)<<16|s<<24|(p&255)<<8|l&255;if(m>>>0<=9)Of(De(1)|0,19056,0);m=h[n+8>>0]|0;l=b[n+9>>0]|0;if(o)v=(l&255)<<8|m;else v=l&255|m<<8;m=v&65535;if(!m){u=c;return}v=a+16|0;l=e+48|0;o=k+4|0;n=k+8|0;p=e+4|0;s=k+12|0;r=e+12|0;w=k+24|0;x=e+24|0;y=i+8|0;z=i+12|0;A=i+16|0;B=i+20|0;C=i+32|0;D=g+8|0;E=i+8|0;F=g+12|0;G=g+16|0;H=g+20|0;I=g+32|0;J=a+20|0;K=g+8|0;L=a+20|0;M=a+24|0;N=H+11|0;O=g+8|0;P=B+11|0;Q=i+8|0;R=s+11|0;S=r+11|0;T=g+16|0;U=i+16|0;V=k+8|0;W=0;X=t+2|0;while(1){lza(e,a,X);t=d[l>>1]|0;f[k>>2]=0;f[o>>2]=0;f[n>>2]=0;Y=f[e>>2]|0;Z=(f[p>>2]|0)-Y|0;_=Z>>3;if(_|0){if(_>>>0>536870911){q=26;break}$=NYa(Z)|0;f[o>>2]=$;f[k>>2]=$;f[V>>2]=$+(_<<3);if((Z|0)>0){K1a($|0,Y|0,Z|0)|0;f[o>>2]=$+(Z>>>3<<3)}}YYa(s,r);f[w>>2]=f[x>>2];f[w+4>>2]=f[x+4>>2];f[w+8>>2]=f[x+8>>2];f[w+12>>2]=f[x+12>>2];f[w+16>>2]=f[x+16>>2];f[w+20>>2]=f[x+20>>2];f[w+24>>2]=f[x+24>>2];f[w+28>>2]=f[x+28>>2];d[i>>1]=t;f[y>>2]=0;f[z>>2]=0;f[A>>2]=0;t=f[k>>2]|0;Z=(f[o>>2]|0)-t|0;$=Z>>3;if($|0){if($>>>0>536870911){q=31;break}Y=NYa(Z)|0;f[z>>2]=Y;f[y>>2]=Y;f[U>>2]=Y+($<<3);if((Z|0)>0){K1a(Y|0,t|0,Z|0)|0;f[z>>2]=Y+(Z>>>3<<3)}}YYa(B,s);f[C>>2]=f[w>>2];f[C+4>>2]=f[w+4>>2];f[C+8>>2]=f[w+8>>2];f[C+12>>2]=f[w+12>>2];f[C+16>>2]=f[w+16>>2];f[C+20>>2]=f[w+20>>2];f[C+24>>2]=f[w+24>>2];f[C+28>>2]=f[w+28>>2];f[g>>2]=j[i>>1];f[D>>2]=0;f[F>>2]=0;f[G>>2]=0;Z=f[E>>2]|0;Y=(f[z>>2]|0)-Z|0;t=Y>>3;if(t|0){if(t>>>0>536870911){q=36;break}$=NYa(Y)|0;f[F>>2]=$;f[D>>2]=$;f[T>>2]=$+(t<<3);if((Y|0)>0){K1a($|0,Z|0,Y|0)|0;f[F>>2]=$+(Y>>>3<<3)}}YYa(H,B);f[I>>2]=f[C>>2];f[I+4>>2]=f[C+4>>2];f[I+8>>2]=f[C+8>>2];f[I+12>>2]=f[C+12>>2];f[I+16>>2]=f[C+16>>2];f[I+20>>2]=f[C+20>>2];f[I+24>>2]=f[C+24>>2];f[I+28>>2]=f[C+28>>2];Y=f[J>>2]|0;do if(Y){$=f[g>>2]|0;Z=Y;t=L;while(1){_=f[Z+16>>2]|0;if(($|0)<(_|0)){aa=f[Z>>2]|0;if(!aa){q=43;break}else{ba=aa;ca=Z}}else{if((_|0)>=($|0)){q=48;break}da=Z+4|0;_=f[da>>2]|0;if(!_){q=47;break}else{ba=_;ca=da}}Z=ba;t=ca}if((q|0)==43){q=0;ea=Z;fa=Z;break}else if((q|0)==47){q=0;ea=Z;fa=da;break}else if((q|0)==48){q=0;ea=Z;fa=t;break}}else{ea=J;fa=J}while(0);if(!(f[fa>>2]|0)){Y=NYa(80)|0;f[Y+16>>2]=f[g>>2];ga=Y+24|0;f[ga>>2]=0;$=Y+28|0;f[$>>2]=0;_=Y+32|0;f[_>>2]=0;aa=f[K>>2]|0;ha=(f[F>>2]|0)-aa|0;ia=ha>>3;if(ia|0){if(ia>>>0>536870911){q=52;break}ja=NYa(ha)|0;f[$>>2]=ja;f[ga>>2]=ja;f[_>>2]=ja+(ia<<3);if((ha|0)>0){K1a(ja|0,aa|0,ha|0)|0;f[$>>2]=ja+(ha>>>3<<3)}}YYa(Y+36|0,H);ha=Y+48|0;f[ha>>2]=f[I>>2];f[ha+4>>2]=f[I+4>>2];f[ha+8>>2]=f[I+8>>2];f[ha+12>>2]=f[I+12>>2];f[ha+16>>2]=f[I+16>>2];f[ha+20>>2]=f[I+20>>2];f[ha+24>>2]=f[I+24>>2];f[ha+28>>2]=f[I+28>>2];f[Y>>2]=0;f[Y+4>>2]=0;f[Y+8>>2]=ea;f[fa>>2]=Y;ha=f[f[v>>2]>>2]|0;if(!ha)ka=Y;else{f[v>>2]=ha;ka=f[fa>>2]|0}AU(f[L>>2]|0,ka);f[M>>2]=(f[M>>2]|0)+1}if((b[N>>0]|0)<0)PYa(f[H>>2]|0);ha=f[O>>2]|0;if(ha|0){Y=f[F>>2]|0;if((Y|0)!=(ha|0))f[F>>2]=Y+(~((Y+-8-ha|0)>>>3)<<3);PYa(ha)}if((b[P>>0]|0)<0)PYa(f[B>>2]|0);ha=f[Q>>2]|0;if(ha|0){Y=f[z>>2]|0;if((Y|0)!=(ha|0))f[z>>2]=Y+(~((Y+-8-ha|0)>>>3)<<3);PYa(ha)}if((b[R>>0]|0)<0)PYa(f[s>>2]|0);ha=f[k>>2]|0;if(ha|0){Y=f[o>>2]|0;if((Y|0)!=(ha|0))f[o>>2]=Y+(~((Y+-8-ha|0)>>>3)<<3);PYa(ha)}X=X+12|0;if((b[S>>0]|0)<0)PYa(f[r>>2]|0);ha=f[e>>2]|0;if(ha|0){Y=f[p>>2]|0;if((Y|0)!=(ha|0))f[p>>2]=Y+(~((Y+-8-ha|0)>>>3)<<3);PYa(ha)}W=W+1|0;if(W>>>0>=m>>>0){q=83;break}}if((q|0)==26)gXa(k);else if((q|0)==31)gXa(y);else if((q|0)==36)gXa(D);else if((q|0)==52)gXa(ga);else if((q|0)==83){u=c;return}}function lza(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+16|0;i=g;j=a+32|0;k=a+48|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;d[k>>1]=-1;j=a+50|0;d[j>>1]=0;d[j+2>>1]=0;d[j+4>>1]=0;l=e+1|0;m=f[c+4>>2]|0;n=(f[c+8>>2]|0)-m|0;o=m;if(l>>>0>=n>>>0)Of(De(1)|0,19056,0);m=(f[c+28>>2]|0)==73;p=h[o+e>>0]|0;q=b[o+l>>0]|0;if(m)r=(q&255)<<8|p;else r=q&255|p<<8;p=r&65535;d[k>>1]=p;a:do if(p<<16>>16<296){if(p<<16>>16<272){if(p<<16>>16<270){switch(p<<16>>16){case -32104:break;case -30871:{u=g;return}default:break a}mza(i,c,e);$Ya(a+12|0,i)|0;if((b[i+11>>0]|0)<0)PYa(f[i>>2]|0);u=g;return}switch(p<<16>>16){case 270:{mza(i,c,e);$Ya(a+12|0,i)|0;if((b[i+11>>0]|0)<0)PYa(f[i>>2]|0);u=g;return}case 271:{mza(i,c,e);$Ya(a+12|0,i)|0;if((b[i+11>>0]|0)<0)PYa(f[i>>2]|0);u=g;return}default:break a}}switch(p<<16>>16){case 272:{mza(i,c,e);$Ya(a+12|0,i)|0;if((b[i+11>>0]|0)<0)PYa(f[i>>2]|0);u=g;return}case 274:{r=e+9|0;if(r>>>0>=n>>>0)Of(De(1)|0,19056,0);q=h[o+(e+8)>>0]|0;l=b[o+r>>0]|0;if(m)s=(l&255)<<8|q;else s=l&255|q<<8;d[j>>1]=s;u=g;return}case 282:{nza(i,c,e);if((a|0)!=(i|0))oza(a,f[i>>2]|0,f[i+4>>2]|0);q=f[i>>2]|0;if(q|0){l=i+4|0;r=f[l>>2]|0;if((r|0)!=(q|0))f[l>>2]=r+(~((r+-8-q|0)>>>3)<<3);PYa(q)}u=g;return}case 283:{nza(i,c,e);if((a|0)!=(i|0))oza(a,f[i>>2]|0,f[i+4>>2]|0);q=f[i>>2]|0;if(q|0){r=i+4|0;l=f[r>>2]|0;if((l|0)!=(q|0))f[r>>2]=l+(~((l+-8-q|0)>>>3)<<3);PYa(q)}u=g;return}default:break a}}else switch(p<<16>>16){case 296:{q=e+9|0;if(q>>>0>=n>>>0)Of(De(1)|0,19056,0);l=h[o+(e+8)>>0]|0;r=b[o+q>>0]|0;if(m)t=(r&255)<<8|l;else t=r&255|l<<8;d[j>>1]=t;u=g;return}case 305:{mza(i,c,e);$Ya(a+12|0,i)|0;if((b[i+11>>0]|0)<0)PYa(f[i>>2]|0);u=g;return}case 306:{mza(i,c,e);$Ya(a+12|0,i)|0;if((b[i+11>>0]|0)<0)PYa(f[i>>2]|0);u=g;return}case 318:{pza(i,c,e);if((a|0)!=(i|0))oza(a,f[i>>2]|0,f[i+4>>2]|0);l=f[i>>2]|0;if(l|0){r=i+4|0;q=f[r>>2]|0;if((q|0)!=(l|0))f[r>>2]=q+(~((q+-8-l|0)>>>3)<<3);PYa(l)}u=g;return}case 319:{qza(i,c,e);if((a|0)!=(i|0))oza(a,f[i>>2]|0,f[i+4>>2]|0);l=f[i>>2]|0;if(l|0){q=i+4|0;r=f[q>>2]|0;if((r|0)!=(l|0))f[q>>2]=r+(~((r+-8-l|0)>>>3)<<3);PYa(l)}u=g;return}case 529:{rza(i,c,e);if((a|0)!=(i|0))oza(a,f[i>>2]|0,f[i+4>>2]|0);l=f[i>>2]|0;if(l|0){r=i+4|0;q=f[r>>2]|0;if((q|0)!=(l|0))f[r>>2]=q+(~((q+-8-l|0)>>>3)<<3);PYa(l)}u=g;return}case 531:{l=e+9|0;if(l>>>0>=n>>>0)Of(De(1)|0,19056,0);q=h[o+(e+8)>>0]|0;r=b[o+l>>0]|0;if(m)v=(r&255)<<8|q;else v=r&255|q<<8;d[j>>1]=v;u=g;return}case 532:{sza(i,c,e);if((a|0)!=(i|0))oza(a,f[i>>2]|0,f[i+4>>2]|0);q=f[i>>2]|0;if(q|0){r=i+4|0;l=f[r>>2]|0;if((l|0)!=(q|0))f[r>>2]=l+(~((l+-8-q|0)>>>3)<<3);PYa(q)}u=g;return}default:break a}while(0);d[k>>1]=-1;u=g;return}function mza(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=tza(c,d+4|0)|0;if(e>>>0>4)g=tza(c,d+8|0)|0;else g=8;d=f[c+4>>2]|0;h=(f[c+8>>2]|0)-d|0;if(g>>>0>h>>>0|(g+e|0)>>>0>h>>>0)Of(De(1)|0,19056,0);h=d+g|0;g=h+e|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(e>>>0>4294967279)WYa(a);if(e>>>0<11){b[a+11>>0]=e;if(!e){i=a;b[i>>0]=0;return}else j=a}else{d=e+16&-16;c=NYa(d)|0;f[a>>2]=c;f[a+8>>2]=d|-2147483648;f[a+4>>2]=e;j=c}c=j;a=h;while(1){b[c>>0]=b[a>>0]|0;a=a+1|0;if((a|0)==(g|0))break;else c=c+1|0}i=j+e|0;b[i>>0]=0;return}function nza(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=tza(b,c+8|0)|0;c=tza(b,g)|0;h=tza(b,g+4|0)|0;f[e>>2]=c;f[e+4>>2]=h;uza(a,e);u=d;return}function oza(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=c;e=b;g=d-e|0;h=g>>3;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0>j-k>>3>>>0){m=k;if(!k)n=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-8-k|0)>>>3)<<3);PYa(m);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;n=0}if(h>>>0>536870911)gXa(a);j=n>>2;m=n>>3>>>0<268435455?(j>>>0<h>>>0?h:j):536870911;if(m>>>0>536870911)gXa(a);j=NYa(m<<3)|0;n=a+4|0;f[n>>2]=j;f[a>>2]=j;f[i>>2]=j+(m<<3);if((g|0)<=0)return;K1a(j|0,b|0,g|0)|0;f[n>>2]=j+(g>>>3<<3);return}g=a+4|0;a=f[g>>2]|0;j=a-k>>3;k=h>>>0>j>>>0;h=k?b+(j<<3)|0:c;c=a;j=a;if((h|0)==(b|0))p=l;else{a=h+-8-e|0;e=b;b=l;while(1){f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];e=e+8|0;if((e|0)==(h|0))break;else b=b+8|0}p=l+((a>>>3)+1<<3)|0}if(k){k=d-h|0;if((k|0)<=0)return;K1a(j|0,h|0,k|0)|0;f[g>>2]=(f[g>>2]|0)+(k>>>3<<3);return}else{if((c|0)==(p|0))return;f[g>>2]=c+(~((c+-8-p|0)>>>3)<<3);return}}function pza(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;f[a>>2]=0;g=a+4|0;f[g>>2]=0;f[a+8>>2]=0;h=tza(b,c+8|0)|0;c=tza(b,h)|0;i=tza(b,h+4|0)|0;f[e>>2]=c;f[e+4>>2]=i;uza(a,e);i=tza(b,h+8|0)|0;c=tza(b,h+12|0)|0;f[e>>2]=i;f[e+4>>2]=c;c=f[g>>2]|0;if((c|0)==(f[a+8>>2]|0)){uza(a,e);u=d;return}else{a=e;e=f[a+4>>2]|0;i=c;f[i>>2]=f[a>>2];f[i+4>>2]=e;f[g>>2]=(f[g>>2]|0)+8;u=d;return}}function qza(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;f[a>>2]=0;g=a+4|0;f[g>>2]=0;f[a+8>>2]=0;h=tza(b,c+8|0)|0;c=e+4|0;i=a+8|0;j=tza(b,h)|0;k=tza(b,h+4|0)|0;f[e>>2]=j;f[c>>2]=k;k=f[g>>2]|0;if((k|0)==(f[i>>2]|0))uza(a,e);else{j=e;l=f[j+4>>2]|0;m=k;f[m>>2]=f[j>>2];f[m+4>>2]=l;f[g>>2]=(f[g>>2]|0)+8}l=tza(b,h+8|0)|0;m=tza(b,h+12|0)|0;f[e>>2]=l;f[c>>2]=m;m=f[g>>2]|0;if((m|0)==(f[i>>2]|0))uza(a,e);else{l=e;j=f[l+4>>2]|0;k=m;f[k>>2]=f[l>>2];f[k+4>>2]=j;f[g>>2]=(f[g>>2]|0)+8}j=tza(b,h+16|0)|0;k=tza(b,h+20|0)|0;f[e>>2]=j;f[c>>2]=k;k=f[g>>2]|0;if((k|0)==(f[i>>2]|0))uza(a,e);else{j=e;l=f[j+4>>2]|0;m=k;f[m>>2]=f[j>>2];f[m+4>>2]=l;f[g>>2]=(f[g>>2]|0)+8}l=tza(b,h+24|0)|0;m=tza(b,h+28|0)|0;f[e>>2]=l;f[c>>2]=m;m=f[g>>2]|0;if((m|0)==(f[i>>2]|0))uza(a,e);else{l=e;j=f[l+4>>2]|0;k=m;f[k>>2]=f[l>>2];f[k+4>>2]=j;f[g>>2]=(f[g>>2]|0)+8}j=tza(b,h+32|0)|0;k=tza(b,h+36|0)|0;f[e>>2]=j;f[c>>2]=k;k=f[g>>2]|0;if((k|0)==(f[i>>2]|0))uza(a,e);else{j=e;l=f[j+4>>2]|0;m=k;f[m>>2]=f[j>>2];f[m+4>>2]=l;f[g>>2]=(f[g>>2]|0)+8}l=tza(b,h+40|0)|0;m=tza(b,h+44|0)|0;f[e>>2]=l;f[c>>2]=m;m=f[g>>2]|0;if((m|0)==(f[i>>2]|0)){uza(a,e);u=d;return}else{a=e;e=f[a+4>>2]|0;i=m;f[i>>2]=f[a>>2];f[i+4>>2]=e;f[g>>2]=(f[g>>2]|0)+8;u=d;return}}function rza(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;f[a>>2]=0;g=a+4|0;f[g>>2]=0;f[a+8>>2]=0;h=tza(b,c+8|0)|0;c=e+4|0;i=a+8|0;j=tza(b,h)|0;k=tza(b,h+4|0)|0;f[e>>2]=j;f[c>>2]=k;uza(a,e);k=tza(b,h+8|0)|0;j=tza(b,h+12|0)|0;f[e>>2]=k;f[c>>2]=j;j=f[g>>2]|0;if((j|0)==(f[i>>2]|0))uza(a,e);else{k=e;l=f[k+4>>2]|0;m=j;f[m>>2]=f[k>>2];f[m+4>>2]=l;f[g>>2]=(f[g>>2]|0)+8}l=tza(b,h+16|0)|0;m=tza(b,h+20|0)|0;f[e>>2]=l;f[c>>2]=m;m=f[g>>2]|0;if((m|0)==(f[i>>2]|0)){uza(a,e);u=d;return}else{a=e;e=f[a+4>>2]|0;i=m;f[i>>2]=f[a>>2];f[i+4>>2]=e;f[g>>2]=(f[g>>2]|0)+8;u=d;return}}function sza(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;f[a>>2]=0;g=a+4|0;f[g>>2]=0;f[a+8>>2]=0;h=tza(b,c+8|0)|0;c=e+4|0;i=a+8|0;j=tza(b,h)|0;k=tza(b,h+4|0)|0;f[e>>2]=j;f[c>>2]=k;k=f[g>>2]|0;if((k|0)==(f[i>>2]|0))uza(a,e);else{j=e;l=f[j+4>>2]|0;m=k;f[m>>2]=f[j>>2];f[m+4>>2]=l;f[g>>2]=(f[g>>2]|0)+8}l=tza(b,h+8|0)|0;m=tza(b,h+12|0)|0;f[e>>2]=l;f[c>>2]=m;m=f[g>>2]|0;if((m|0)==(f[i>>2]|0))uza(a,e);else{l=e;j=f[l+4>>2]|0;k=m;f[k>>2]=f[l>>2];f[k+4>>2]=j;f[g>>2]=(f[g>>2]|0)+8}j=tza(b,h+16|0)|0;k=tza(b,h+20|0)|0;f[e>>2]=j;f[c>>2]=k;k=f[g>>2]|0;if((k|0)==(f[i>>2]|0))uza(a,e);else{j=e;l=f[j+4>>2]|0;m=k;f[m>>2]=f[j>>2];f[m+4>>2]=l;f[g>>2]=(f[g>>2]|0)+8}l=tza(b,h+24|0)|0;m=tza(b,h+28|0)|0;f[e>>2]=l;f[c>>2]=m;m=f[g>>2]|0;if((m|0)==(f[i>>2]|0))uza(a,e);else{l=e;j=f[l+4>>2]|0;k=m;f[k>>2]=f[l>>2];f[k+4>>2]=j;f[g>>2]=(f[g>>2]|0)+8}j=tza(b,h+32|0)|0;k=tza(b,h+36|0)|0;f[e>>2]=j;f[c>>2]=k;k=f[g>>2]|0;if((k|0)==(f[i>>2]|0))uza(a,e);else{j=e;l=f[j+4>>2]|0;m=k;f[m>>2]=f[j>>2];f[m+4>>2]=l;f[g>>2]=(f[g>>2]|0)+8}l=tza(b,h+40|0)|0;m=tza(b,h+44|0)|0;f[e>>2]=l;f[c>>2]=m;m=f[g>>2]|0;if((m|0)==(f[i>>2]|0)){uza(a,e);u=d;return}else{a=e;e=f[a+4>>2]|0;i=m;f[i>>2]=f[a>>2];f[i+4>>2]=e;f[g>>2]=(f[g>>2]|0)+8;u=d;return}}function tza(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0;d=c+3|0;e=f[a+4>>2]|0;g=e;if(d>>>0>=((f[a+8>>2]|0)-e|0)>>>0)Of(De(1)|0,19056,0);e=h[g+c>>0]|0;i=b[g+(c+1)>>0]|0;if((f[a+28>>2]|0)==73){j=(i&255)<<8|e|(h[g+(c+2)>>0]|0)<<16|(h[g+d>>0]|0)<<24;return j|0}else{j=(i&255)<<16|e<<24|(h[g+(c+2)>>0]|0)<<8|(h[g+d>>0]|0);return j|0}return 0}function uza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)gXa(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;PYa(d);return}function vza(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,h=0,i=0,j=0;e=a+32|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;d[a+48>>1]=-1;e=a+50|0;d[e>>1]=0;d[e+2>>1]=0;d[e+4>>1]=0;e=b+20|0;b=f[e>>2]|0;if(!b)return;else{g=e;h=b}a:while(1){b=h;while(1){if((f[b+16>>2]|0)>=(c|0))break;i=f[b+4>>2]|0;if(!i){j=g;break a}else b=i}h=f[b>>2]|0;if(!h){j=b;break}else g=b}if((j|0)==(e|0))return;if((f[j+16>>2]|0)>(c|0))return;c=j+24|0;if((c|0)!=(a|0))oza(a,f[c>>2]|0,f[j+28>>2]|0);$Ya(a+12|0,j+36|0)|0;c=a+24|0;a=j+48|0;f[c>>2]=f[a>>2];f[c+4>>2]=f[a+4>>2];f[c+8>>2]=f[a+8>>2];f[c+12>>2]=f[a+12>>2];f[c+16>>2]=f[a+16>>2];f[c+20>>2]=f[a+20>>2];f[c+24>>2]=f[a+24>>2];f[c+28>>2]=f[a+28>>2];return}function wza(a){a=a|0;return a|0}function xza(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i|0?2:0;i=g+4|0;k=f[i>>2]|0;l=k+-1|0;f[i>>2]=l;if(!k)return;k=j^2;m=f[g>>2]|0;n=l;l=d;d=a;while(1){if((m|0)>0){a=0;o=d;do{b[l+a>>0]=(((h[o+j>>0]|0)*1868|0)+8192+((h[o+1>>0]|0)*9617|0)+((h[o+k>>0]|0)*4899|0)|0)>>>14;a=a+1|0;o=o+3|0;p=f[g>>2]|0}while((a|0)<(p|0));q=p;r=f[i>>2]|0;s=o}else{q=m;r=n;s=d}d=s+((Y(q,-3)|0)+c)|0;n=r+-1|0;f[i>>2]=n;if(!r)break;else{m=q;l=l+e|0}}return}function yza(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i|0?2:0;i=g+4|0;l=f[i>>2]|0;m=l+-1|0;f[i>>2]=m;if(!l)return;l=f[g>>2]|0;g=k^2;if((l|0)>0){n=Y(l,h)|0;o=b-n|0;b=m;m=c;c=a;while(1){a=0;p=c;while(1){d[m+(a<<1)>>1]=(((j[p+(k<<1)>>1]|0)*1868|0)+8192+((j[p+2>>1]|0)*9617|0)+((j[p+(g<<1)>>1]|0)*4899|0)|0)>>>14;a=a+1|0;if((a|0)==(l|0))break;else p=p+(h<<1)|0}if(!b)break;else{b=b+-1|0;m=m+(e<<1)|0;c=c+(n<<1)+(o<<1)|0}}}f[i>>2]=-1;return}function zza(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i|0?2:0;i=g+4|0;k=f[i>>2]|0;l=k+-1|0;f[i>>2]=l;if(!k)return;k=j^2;m=f[g>>2]|0;n=l;l=d;d=a;while(1){if((m|0)>0){a=0;o=d;do{b[l+a>>0]=(((h[o+j>>0]|0)*1868|0)+8192+((h[o+1>>0]|0)*9617|0)+((h[o+k>>0]|0)*4899|0)|0)>>>14;a=a+1|0;o=o+4|0;p=f[g>>2]|0}while((a|0)<(p|0));q=p;r=f[i>>2]|0;s=o}else{q=m;r=n;s=d}n=r+-1|0;f[i>>2]=n;if(!r)break;else{m=q;l=l+e|0;d=s+(c-(q<<2))|0}}return}function Aza(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;i=h|0?2:0;h=g+4|0;j=f[h>>2]|0;k=j+-1|0;f[h>>2]=k;if(!j)return;j=i^2;l=f[g>>2]|0;m=k;k=d;d=a;while(1){if((l|0)>0){a=k;n=d;o=0;do{p=b[n+1>>0]|0;b[a>>0]=b[n+i>>0]|0;b[a+1>>0]=p;b[a+2>>0]=b[n+j>>0]|0;o=o+1|0;a=a+3|0;n=n+4|0;q=f[g>>2]|0}while((o|0)<(q|0));r=q;s=f[h>>2]|0;t=a;u=n}else{r=l;s=m;t=k;u=d}k=t+((Y(r,-3)|0)+e)|0;m=s+-1|0;f[h>>2]=m;if(!s)break;else{l=r;d=u+(c-(r<<2))|0}}return}function Bza(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=g+4|0;i=f[h>>2]|0;j=i+-1|0;f[h>>2]=j;if(!i)return;i=f[g>>2]|0;k=j;j=a;a=d;while(1){if((i|0)>0){d=j;l=0;m=a;do{n=b[d+1>>0]|0;o=b[d+2>>0]|0;b[m+2>>0]=b[d>>0]|0;b[m+1>>0]=n;b[m>>0]=o;l=l+1|0;d=d+3|0;m=m+3|0;p=f[g>>2]|0}while((l|0)<(p|0));q=p;r=f[h>>2]|0;s=d;t=m}else{q=i;r=k;s=j;t=a}l=q*3|0;k=r+-1|0;f[h>>2]=k;if(!r)break;else{i=q;j=s+(c-l)|0;a=t+(e-l)|0}}return}function Cza(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=g+4|0;i=f[h>>2]|0;j=i+-1|0;f[h>>2]=j;if(!i)return;i=f[g>>2]|0;if((i|0)>0){g=i*3|0;k=b-g|0;b=e-g|0;e=a;a=j;j=c;while(1){c=e+(g<<1)|0;l=e;m=0;n=j;while(1){o=d[l+2>>1]|0;p=d[l+4>>1]|0;d[n+4>>1]=d[l>>1]|0;d[n+2>>1]=o;d[n>>1]=p;m=m+1|0;if((m|0)==(i|0))break;else{l=l+6|0;n=n+6|0}}if(!a)break;else{e=c+(k<<1)|0;a=a+-1|0;j=j+(g<<1)+(b<<1)|0}}}f[h>>2]=-1;return}function Dza(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0;h=g+4|0;i=f[h>>2]|0;k=i+-1|0;f[h>>2]=k;if(!i)return;i=f[g>>2]|0;l=k;k=a;a=d;while(1){if((i|0)>0){d=0;do{m=j[k+(d<<1)>>1]|0;b[a+d>>0]=(((m>>>2&248)*9617|0)+8192+((m<<3&248)*1868|0)+((m>>>7&248)*4899|0)|0)>>>14;d=d+1|0;n=f[g>>2]|0}while((d|0)<(n|0));o=f[h>>2]|0;p=n}else{o=l;p=i}l=o+-1|0;f[h>>2]=l;if(!o)break;else{i=p;k=k+c|0;a=a+e|0}}return}function Eza(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0;h=g+4|0;i=f[h>>2]|0;k=i+-1|0;f[h>>2]=k;if(!i)return;i=f[g>>2]|0;l=k;k=a;a=d;while(1){if((i|0)>0){d=0;do{m=j[k+(d<<1)>>1]|0;b[a+d>>0]=(((m>>>3&252)*9617|0)+8192+((m<<3&248)*1868|0)+((m>>>8&248)*4899|0)|0)>>>14;d=d+1|0;n=f[g>>2]|0}while((d|0)<(n|0));o=f[h>>2]|0;p=n}else{o=l;p=i}l=o+-1|0;f[h>>2]=l;if(!o)break;else{i=p;k=k+c|0;a=a+e|0}}return}function Fza(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=g+4|0;i=f[h>>2]|0;k=i+-1|0;f[h>>2]=k;if(!i)return;i=f[g>>2]|0;l=k;k=d;d=a;while(1){if((i|0)>0){a=k;m=0;do{n=j[d+(m<<1)>>1]|0;b[a>>0]=n<<3;b[a+1>>0]=n>>>2&248;b[a+2>>0]=n>>>7&248;m=m+1|0;a=a+3|0;o=f[g>>2]|0}while((m|0)<(o|0));p=o;q=f[h>>2]|0;r=a}else{p=i;q=l;r=k}k=r+((Y(p,-3)|0)+e)|0;l=q+-1|0;f[h>>2]=l;if(!q)break;else{i=p;d=d+c|0}}return}
function sLa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0;i=u;u=u+64|0;j=i+16|0;k=i;l=i+24|0;m=i+8|0;n=i+20|0;f[j>>2]=c;o=(a|0)!=0;q=l+40|0;r=q;s=l+39|0;l=m+4|0;t=c;c=0;v=0;w=0;a:while(1){do if((c|0)>-1)if((v|0)>(2147483647-c|0)){x=pKa()|0;f[x>>2]=75;y=-1;break}else{y=v+c|0;break}else y=c;while(0);x=b[t>>0]|0;if(!(x<<24>>24)){z=87;break}else{A=x;B=t}b:while(1){switch(A<<24>>24){case 37:{C=B;D=B;z=9;break b;break}case 0:{E=B;F=B;break b;break}default:{}}x=B+1|0;f[j>>2]=x;A=b[x>>0]|0;B=x}c:do if((z|0)==9)while(1){z=0;if((b[C+1>>0]|0)!=37){E=C;F=D;break c}x=D+1|0;G=C+2|0;f[j>>2]=G;if((b[G>>0]|0)==37){C=G;D=x;z=9}else{E=G;F=x;break}}while(0);x=F-t|0;if(o)vLa(a,t,x);if(x|0){t=E;c=y;v=x;continue}x=E+1|0;G=(b[x>>0]|0)+-48|0;if(G>>>0<10){H=(b[E+2>>0]|0)==36;I=H?G:-1;K=H?1:w;L=H?E+3|0:x}else{I=-1;K=w;L=x}f[j>>2]=L;x=b[L>>0]|0;H=(x<<24>>24)+-32|0;d:do if(H>>>0<32){G=x;M=0;N=L;O=H;while(1){P=1<<O;if(!(P&75913)){Q=G;R=N;S=M;break d}T=P|M;P=N+1|0;f[j>>2]=P;U=b[P>>0]|0;O=(U<<24>>24)+-32|0;if(O>>>0>=32){Q=U;R=P;S=T;break}else{G=U;M=T;N=P}}}else{Q=x;R=L;S=0}while(0);if(Q<<24>>24==42){x=R+1|0;H=(b[x>>0]|0)+-48|0;if(H>>>0<10?(b[R+2>>0]|0)==36:0){f[h+(H<<2)>>2]=10;V=1;W=R+3|0;X=f[g+((b[x>>0]|0)+-48<<3)>>2]|0}else{if(K|0){Y=-1;break}if(o){H=(f[e>>2]|0)+(4-1)&~(4-1);N=f[H>>2]|0;f[e>>2]=H+4;V=0;W=x;X=N}else{V=0;W=x;X=0}}f[j>>2]=W;x=(X|0)<0;Z=W;_=x?S|8192:S;$=V;aa=x?0-X|0:X}else{x=wLa(j)|0;if((x|0)<0){Y=-1;break}Z=f[j>>2]|0;_=S;$=K;aa=x}do if((b[Z>>0]|0)==46){if((b[Z+1>>0]|0)!=42){f[j>>2]=Z+1;x=wLa(j)|0;ba=f[j>>2]|0;ca=x;break}x=Z+2|0;N=(b[x>>0]|0)+-48|0;if(N>>>0<10?(b[Z+3>>0]|0)==36:0){f[h+(N<<2)>>2]=10;N=f[g+((b[x>>0]|0)+-48<<3)>>2]|0;H=Z+4|0;f[j>>2]=H;ba=H;ca=N;break}if($|0){Y=-1;break a}if(o){N=(f[e>>2]|0)+(4-1)&~(4-1);H=f[N>>2]|0;f[e>>2]=N+4;da=H}else da=0;f[j>>2]=x;ba=x;ca=da}else{ba=Z;ca=-1}while(0);x=ba;H=0;while(1){if(((b[x>>0]|0)+-65|0)>>>0>57){Y=-1;break a}ea=x+1|0;f[j>>2]=ea;fa=b[(b[x>>0]|0)+-65+(368836+(H*58|0))>>0]|0;ga=fa&255;if((ga+-1|0)>>>0<8){x=ea;H=ga}else break}if(!(fa<<24>>24)){Y=-1;break}N=(I|0)>-1;do if(fa<<24>>24==19)if(N){Y=-1;break a}else z=49;else{if(N){f[h+(I<<2)>>2]=ga;M=g+(I<<3)|0;G=f[M+4>>2]|0;O=k;f[O>>2]=f[M>>2];f[O+4>>2]=G;z=49;break}if(!o){Y=0;break a}xLa(k,ga,e)}while(0);if((z|0)==49?(z=0,!o):0){t=ea;c=y;v=0;w=$;continue}N=b[x>>0]|0;G=(H|0)!=0&(N&15|0)==3?N&-33:N;N=_&-65537;O=(_&8192|0)==0?_:N;e:do switch(G|0){case 110:{switch((H&255)<<24>>24){case 0:{f[f[k>>2]>>2]=y;t=ea;c=y;v=0;w=$;continue a;break}case 1:{f[f[k>>2]>>2]=y;t=ea;c=y;v=0;w=$;continue a;break}case 2:{M=f[k>>2]|0;f[M>>2]=y;f[M+4>>2]=((y|0)<0)<<31>>31;t=ea;c=y;v=0;w=$;continue a;break}case 3:{d[f[k>>2]>>1]=y;t=ea;c=y;v=0;w=$;continue a;break}case 4:{b[f[k>>2]>>0]=y;t=ea;c=y;v=0;w=$;continue a;break}case 6:{f[f[k>>2]>>2]=y;t=ea;c=y;v=0;w=$;continue a;break}case 7:{M=f[k>>2]|0;f[M>>2]=y;f[M+4>>2]=((y|0)<0)<<31>>31;t=ea;c=y;v=0;w=$;continue a;break}default:{t=ea;c=y;v=0;w=$;continue a}}break}case 112:{ha=O|8;ia=ca>>>0>8?ca:8;ja=120;z=61;break}case 88:case 120:{ha=O;ia=ca;ja=G;z=61;break}case 111:{M=k;P=f[M>>2]|0;T=f[M+4>>2]|0;M=zLa(P,T,q)|0;U=r-M|0;ka=P;la=T;ma=M;na=O;oa=(O&8|0)==0|(ca|0)>(U|0)?ca:U+1|0;pa=0;qa=369300;z=67;break}case 105:case 100:{U=k;M=f[U>>2]|0;T=f[U+4>>2]|0;if((T|0)<0){U=B1a(0,0,M|0,T|0)|0;P=J;ra=k;f[ra>>2]=U;f[ra+4>>2]=P;sa=U;ta=P;ua=1;va=369300;z=66;break e}else{sa=M;ta=T;ua=(O&2049|0)!=0&1;va=(O&2048|0)==0?((O&1|0)==0?369300:369302):369301;z=66;break e}break}case 117:{T=k;sa=f[T>>2]|0;ta=f[T+4>>2]|0;ua=0;va=369300;z=66;break}case 99:{b[s>>0]=f[k>>2];wa=s;xa=N;ya=1;za=0;Aa=369300;Ba=q;break}case 109:{T=pKa()|0;Ca=DKa(f[T>>2]|0)|0;z=71;break}case 115:{T=f[k>>2]|0;Ca=T|0?T:369310;z=71;break}case 67:{f[m>>2]=f[k>>2];f[l>>2]=0;f[k>>2]=m;Da=m;Ea=-1;z=75;break}case 83:{T=f[k>>2]|0;if(!ca){BLa(a,32,aa,0,O);Fa=0;z=84}else{Da=T;Ea=ca;z=75}break}case 65:case 71:case 70:case 69:case 97:case 103:case 102:case 101:{t=ea;c=y;v=DLa(a,+p[k>>3],aa,ca,O,G)|0;w=$;continue a;break}default:{wa=t;xa=O;ya=ca;za=0;Aa=369300;Ba=q}}while(0);f:do if((z|0)==61){z=0;G=k;H=f[G>>2]|0;x=f[G+4>>2]|0;G=yLa(H,x,q,ja&32)|0;T=(ha&8|0)==0|(H|0)==0&(x|0)==0;ka=H;la=x;ma=G;na=ha;oa=ia;pa=T?0:2;qa=T?369300:369300+(ja>>4)|0;z=67}else if((z|0)==66){z=0;ka=sa;la=ta;ma=ALa(sa,ta,q)|0;na=O;oa=ca;pa=ua;qa=va;z=67}else if((z|0)==71){z=0;T=BKa(Ca,0,ca)|0;G=(T|0)==0;wa=Ca;xa=N;ya=G?ca:T-Ca|0;za=0;Aa=369300;Ba=G?Ca+ca|0:T}else if((z|0)==75){z=0;T=0;G=0;x=Da;while(1){H=f[x>>2]|0;if(!H){Ga=T;Ha=G;break}M=CLa(n,H)|0;if((M|0)<0|M>>>0>(Ea-T|0)>>>0){Ga=T;Ha=M;break}H=M+T|0;if(Ea>>>0>H>>>0){T=H;G=M;x=x+4|0}else{Ga=H;Ha=M;break}}if((Ha|0)<0){Y=-1;break a}BLa(a,32,aa,Ga,O);if(!Ga){Fa=0;z=84}else{x=0;G=Da;while(1){T=f[G>>2]|0;if(!T){Fa=Ga;z=84;break f}M=CLa(n,T)|0;x=M+x|0;if((x|0)>(Ga|0)){Fa=Ga;z=84;break f}vLa(a,n,M);if(x>>>0>=Ga>>>0){Fa=Ga;z=84;break}else G=G+4|0}}}while(0);if((z|0)==67){z=0;N=(ka|0)!=0|(la|0)!=0;G=(oa|0)!=0|N;x=((N^1)&1)+(r-ma)|0;wa=G?ma:q;xa=(oa|0)>-1?na&-65537:na;ya=G?((oa|0)>(x|0)?oa:x):oa;za=pa;Aa=qa;Ba=q}else if((z|0)==84){z=0;BLa(a,32,aa,Fa,O^8192);t=ea;c=y;v=(aa|0)>(Fa|0)?aa:Fa;w=$;continue}x=Ba-wa|0;G=(ya|0)<(x|0)?x:ya;N=G+za|0;M=(aa|0)<(N|0)?N:aa;BLa(a,32,M,N,xa);vLa(a,Aa,za);BLa(a,48,M,N,xa^65536);BLa(a,48,G,x,0);vLa(a,wa,x);BLa(a,32,M,N,xa^8192);t=ea;c=y;v=M;w=$}g:do if((z|0)==87)if(!a)if(!w)Y=0;else{$=1;while(1){v=f[h+($<<2)>>2]|0;if(!v){Ia=$;break}xLa(g+($<<3)|0,v,e);$=$+1|0;if(($|0)>=10){Y=1;break g}}while(1){if(f[h+(Ia<<2)>>2]|0){Y=-1;break g}Ia=Ia+1|0;if((Ia|0)>=10){Y=1;break}}}else Y=y;while(0);u=i;return Y|0}function tLa(a){a=a|0;return 0}function uLa(a){a=a|0;return}function vLa(a,b,c){a=a|0;b=b|0;c=c|0;if(!(f[a>>2]&32))JLa(b,c,a)|0;return}function wLa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=f[a>>2]|0;d=(b[c>>0]|0)+-48|0;if(d>>>0<10){e=c;c=0;g=d;while(1){d=g+(c*10|0)|0;e=e+1|0;f[a>>2]=e;g=(b[e>>0]|0)+-48|0;if(g>>>0>=10){h=d;break}else c=d}}else h=0;return h|0}function xLa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0.0;a:do if(b>>>0<=20)do switch(b|0){case 9:{d=(f[c>>2]|0)+(4-1)&~(4-1);e=f[d>>2]|0;f[c>>2]=d+4;f[a>>2]=e;break a;break}case 10:{e=(f[c>>2]|0)+(4-1)&~(4-1);d=f[e>>2]|0;f[c>>2]=e+4;e=a;f[e>>2]=d;f[e+4>>2]=((d|0)<0)<<31>>31;break a;break}case 11:{d=(f[c>>2]|0)+(4-1)&~(4-1);e=f[d>>2]|0;f[c>>2]=d+4;d=a;f[d>>2]=e;f[d+4>>2]=0;break a;break}case 12:{d=(f[c>>2]|0)+(8-1)&~(8-1);e=d;g=f[e>>2]|0;h=f[e+4>>2]|0;f[c>>2]=d+8;d=a;f[d>>2]=g;f[d+4>>2]=h;break a;break}case 13:{h=(f[c>>2]|0)+(4-1)&~(4-1);d=f[h>>2]|0;f[c>>2]=h+4;h=(d&65535)<<16>>16;d=a;f[d>>2]=h;f[d+4>>2]=((h|0)<0)<<31>>31;break a;break}case 14:{h=(f[c>>2]|0)+(4-1)&~(4-1);d=f[h>>2]|0;f[c>>2]=h+4;h=a;f[h>>2]=d&65535;f[h+4>>2]=0;break a;break}case 15:{h=(f[c>>2]|0)+(4-1)&~(4-1);d=f[h>>2]|0;f[c>>2]=h+4;h=(d&255)<<24>>24;d=a;f[d>>2]=h;f[d+4>>2]=((h|0)<0)<<31>>31;break a;break}case 16:{h=(f[c>>2]|0)+(4-1)&~(4-1);d=f[h>>2]|0;f[c>>2]=h+4;h=a;f[h>>2]=d&255;f[h+4>>2]=0;break a;break}case 17:{h=(f[c>>2]|0)+(8-1)&~(8-1);i=+p[h>>3];f[c>>2]=h+8;p[a>>3]=i;break a;break}case 18:{h=(f[c>>2]|0)+(8-1)&~(8-1);i=+p[h>>3];f[c>>2]=h+8;p[a>>3]=i;break a;break}default:break a}while(0);while(0);return}function yLa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;if((a|0)==0&(c|0)==0)f=d;else{g=a;a=c;c=d;while(1){d=c+-1|0;b[d>>0]=h[369348+(g&15)>>0]|0|e;g=I1a(g|0,a|0,4)|0;a=J;if((g|0)==0&(a|0)==0){f=d;break}else c=d}}return f|0}function zLa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0;if((a|0)==0&(c|0)==0)e=d;else{f=a;a=c;c=d;while(1){d=c+-1|0;b[d>>0]=f&7|48;f=I1a(f|0,a|0,3)|0;a=J;if((f|0)==0&(a|0)==0){e=d;break}else c=d}}return e|0}function ALa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;if(c>>>0>0|(c|0)==0&a>>>0>4294967295){e=a;f=c;c=d;while(1){g=P1a(e|0,f|0,10,0)|0;c=c+-1|0;b[c>>0]=g&255|48;g=e;e=U1a(e|0,f|0,10,0)|0;if(!(f>>>0>9|(f|0)==9&g>>>0>4294967295))break;else f=J}h=c;i=e}else{h=d;i=a}if(!i)j=h;else{a=h;h=i;while(1){i=a+-1|0;b[i>>0]=(h>>>0)%10|0|48;if(h>>>0<10){j=i;break}else{a=i;h=(h>>>0)/10|0}}}return j|0}function BLa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=u;u=u+256|0;g=f;if((c|0)>(d|0)&(e&73728|0)==0){e=c-d|0;F1a(g|0,b|0,(e>>>0<256?e:256)|0)|0;if(e>>>0>255){b=c-d|0;d=e;do{vLa(a,g,256);d=d+-256|0}while(d>>>0>255);h=b&255}else h=e;vLa(a,g,h)}u=f;return}function CLa(a,b){a=a|0;b=b|0;var c=0;if(!a)c=0;else c=HLa(a,b,0)|0;return c|0}function DLa(a,c,d,e,g,i){a=a|0;c=+c;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0;j=u;u=u+560|0;k=j+8|0;l=j;m=j+524|0;n=m;o=j+512|0;f[l>>2]=0;p=o+12|0;ELa(c)|0;if((J|0)<0){q=1;r=369317;s=-c}else{q=(g&2049|0)!=0&1;r=(g&2048|0)==0?((g&1|0)==0?369318:369323):369320;s=c}ELa(s)|0;t=J&2146435072;do if(t>>>0<2146435072|(t|0)==2146435072&0<0){c=+FLa(s,l)*2.0;v=c!=0.0;if(v)f[l>>2]=(f[l>>2]|0)+-1;w=i|32;if((w|0)==97){x=i&32;y=(x|0)==0?r:r+9|0;z=q|2;A=12-e|0;do if(!(e>>>0>11|(A|0)==0)){B=A;C=8.0;do{B=B+-1|0;C=C*16.0}while((B|0)!=0);if((b[y>>0]|0)==45){D=-(C+(-c-C));break}else{D=c+C-C;break}}else D=c;while(0);A=f[l>>2]|0;B=(A|0)<0?0-A|0:A;E=ALa(B,((B|0)<0)<<31>>31,p)|0;if((E|0)==(p|0)){B=o+11|0;b[B>>0]=48;F=B}else F=E;b[F+-1>>0]=(A>>31&2)+43;A=F+-2|0;b[A>>0]=i+15;E=(e|0)<1;B=(g&8|0)==0;G=m;H=D;while(1){I=~~H;K=G+1|0;b[G>>0]=h[369348+I>>0]|x;H=(H-+(I|0))*16.0;if((K-n|0)==1?!(B&(E&H==0.0)):0){b[K>>0]=46;L=G+2|0}else L=K;if(!(H!=0.0))break;else G=L}G=L-n|0;E=p-A|0;B=(e|0)!=0&(G+-2|0)<(e|0)?e+2|0:G;x=E+z+B|0;BLa(a,32,d,x,g);vLa(a,y,z);BLa(a,48,d,x,g^65536);vLa(a,m,G);BLa(a,48,B-G|0,0,0);vLa(a,A,E);BLa(a,32,d,x,g^8192);M=x;break}x=(e|0)<0?6:e;if(v){E=(f[l>>2]|0)+-28|0;f[l>>2]=E;N=E;O=c*268435456.0}else{N=f[l>>2]|0;O=c}E=(N|0)<0?k:k+288|0;H=O;G=E;do{B=~~H>>>0;f[G>>2]=B;G=G+4|0;H=(H-+(B>>>0))*1.0e9}while(H!=0.0);if((N|0)>0){v=N;A=E;z=G;while(1){y=(v|0)<29?v:29;B=z+-4|0;if(B>>>0>=A>>>0){K=0;I=B;do{B=R1a(f[I>>2]|0,0,y|0)|0;P=C1a(B|0,J|0,K|0,0)|0;B=J;Q=P1a(P|0,B|0,1e9,0)|0;f[I>>2]=Q;K=U1a(P|0,B|0,1e9,0)|0;I=I+-4|0}while(I>>>0>=A>>>0);if(K){I=A+-4|0;f[I>>2]=K;R=I}else R=A}else R=A;I=z;while(1){if(I>>>0<=R>>>0)break;B=I+-4|0;if(!(f[B>>2]|0))I=B;else break}K=(f[l>>2]|0)-y|0;f[l>>2]=K;if((K|0)>0){v=K;A=R;z=I}else{S=K;T=R;U=I;break}}}else{S=N;T=E;U=G}if((S|0)<0){z=((x+25|0)/9|0)+1|0;A=(w|0)==102;v=S;K=T;B=U;while(1){P=0-v|0;Q=(P|0)<9?P:9;if(K>>>0<B>>>0){P=(1<<Q)+-1|0;V=1e9>>>Q;W=0;X=K;do{Z=f[X>>2]|0;f[X>>2]=(Z>>>Q)+W;W=Y(Z&P,V)|0;X=X+4|0}while(X>>>0<B>>>0);X=(f[K>>2]|0)==0?K+4|0:K;if(!W){_=X;$=B}else{f[B>>2]=W;_=X;$=B+4|0}}else{_=(f[K>>2]|0)==0?K+4|0:K;$=B}X=A?E:_;V=($-X>>2|0)>(z|0)?X+(z<<2)|0:$;v=(f[l>>2]|0)+Q|0;f[l>>2]=v;if((v|0)>=0){aa=_;ba=V;break}else{K=_;B=V}}}else{aa=T;ba=U}B=E;if(aa>>>0<ba>>>0){K=(B-aa>>2)*9|0;v=f[aa>>2]|0;if(v>>>0<10)ca=K;else{z=K;K=10;while(1){K=K*10|0;A=z+1|0;if(v>>>0<K>>>0){ca=A;break}else z=A}}}else ca=0;z=(w|0)==103;K=(x|0)!=0;v=x-((w|0)!=102?ca:0)+((K&z)<<31>>31)|0;if((v|0)<(((ba-B>>2)*9|0)+-9|0)){A=v+9216|0;v=E+4+(((A|0)/9|0)+-1024<<2)|0;G=((A|0)%9|0)+1|0;if((G|0)<9){A=10;V=G;while(1){G=A*10|0;V=V+1|0;if((V|0)==9){da=G;break}else A=G}}else da=10;A=f[v>>2]|0;V=(A>>>0)%(da>>>0)|0;w=(v+4|0)==(ba|0);if(!(w&(V|0)==0)){C=(((A>>>0)/(da>>>0)|0)&1|0)==0?9007199254740992.0:9007199254740994.0;G=(da|0)/2|0;H=V>>>0<G>>>0?.5:w&(V|0)==(G|0)?1.0:1.5;if(!q){ea=C;fa=H}else{G=(b[r>>0]|0)==45;ea=G?-C:C;fa=G?-H:H}G=A-V|0;f[v>>2]=G;if(ea+fa!=ea){V=G+da|0;f[v>>2]=V;if(V>>>0>999999999){V=aa;G=v;while(1){A=G+-4|0;f[G>>2]=0;if(A>>>0<V>>>0){w=V+-4|0;f[w>>2]=0;ga=w}else ga=V;w=(f[A>>2]|0)+1|0;f[A>>2]=w;if(w>>>0>999999999){V=ga;G=A}else{ha=ga;ia=A;break}}}else{ha=aa;ia=v}G=(B-ha>>2)*9|0;V=f[ha>>2]|0;if(V>>>0<10){ja=ha;ka=ia;la=G}else{A=G;G=10;while(1){G=G*10|0;w=A+1|0;if(V>>>0<G>>>0){ja=ha;ka=ia;la=w;break}else A=w}}}else{ja=aa;ka=v;la=ca}}else{ja=aa;ka=v;la=ca}A=ka+4|0;ma=ja;na=la;oa=ba>>>0>A>>>0?A:ba}else{ma=aa;na=ca;oa=ba}A=oa;while(1){if(A>>>0<=ma>>>0){pa=0;break}G=A+-4|0;if(!(f[G>>2]|0))A=G;else{pa=1;break}}v=0-na|0;do if(z){G=((K^1)&1)+x|0;if((G|0)>(na|0)&(na|0)>-5){qa=G+-1-na|0;ra=i+-1|0}else{qa=G+-1|0;ra=i+-2|0}G=g&8;if(!G){if(pa?(V=f[A+-4>>2]|0,(V|0)!=0):0)if(!((V>>>0)%10|0)){w=10;X=0;while(1){w=w*10|0;P=X+1|0;if((V>>>0)%(w>>>0)|0|0){sa=P;break}else X=P}}else sa=0;else sa=9;X=((A-B>>2)*9|0)+-9|0;if((ra|32|0)==102){w=X-sa|0;V=(w|0)>0?w:0;ta=0;ua=(qa|0)<(V|0)?qa:V;va=ra;break}else{V=X+na-sa|0;X=(V|0)>0?V:0;ta=0;ua=(qa|0)<(X|0)?qa:X;va=ra;break}}else{ta=G;ua=qa;va=ra}}else{ta=g&8;ua=x;va=i}while(0);x=ua|ta;B=(x|0)!=0&1;K=(va|32|0)==102;if(K){wa=0;xa=(na|0)>0?na:0}else{z=(na|0)<0?v:na;X=ALa(z,((z|0)<0)<<31>>31,p)|0;z=p;if((z-X|0)<2){V=X;while(1){w=V+-1|0;b[w>>0]=48;if((z-w|0)<2)V=w;else{ya=w;break}}}else ya=X;b[ya+-1>>0]=(na>>31&2)+43;V=ya+-2|0;b[V>>0]=va;wa=V;xa=z-V|0}V=q+1+ua+B+xa|0;BLa(a,32,d,V,g);vLa(a,r,q);BLa(a,48,d,V,g^65536);if(K){v=ma>>>0>E>>>0?E:ma;w=m+9|0;Q=w;W=m+8|0;P=v;do{I=ALa(f[P>>2]|0,0,w)|0;if((P|0)==(v|0))if((I|0)==(w|0)){b[W>>0]=48;za=W}else za=I;else if(I>>>0>m>>>0){F1a(m|0,48,I-n|0)|0;y=I;while(1){Z=y+-1|0;if(Z>>>0>m>>>0)y=Z;else{za=Z;break}}}else za=I;vLa(a,za,Q-za|0);P=P+4|0}while(P>>>0<=E>>>0);if(x|0)vLa(a,373302,1);if(P>>>0<A>>>0&(ua|0)>0){E=P;Q=ua;while(1){W=ALa(f[E>>2]|0,0,w)|0;if(W>>>0>m>>>0){F1a(m|0,48,W-n|0)|0;v=W;while(1){K=v+-1|0;if(K>>>0>m>>>0)v=K;else{Aa=K;break}}}else Aa=W;vLa(a,Aa,(Q|0)<9?Q:9);E=E+4|0;v=Q+-9|0;if(!(E>>>0<A>>>0&(Q|0)>9)){Ba=v;break}else Q=v}}else Ba=ua;BLa(a,48,Ba+9|0,9,0)}else{Q=pa?A:ma+4|0;if((ua|0)>-1){E=m+9|0;w=(ta|0)==0;P=E;x=0-n|0;v=m+8|0;I=ma;K=ua;while(1){B=ALa(f[I>>2]|0,0,E)|0;if((B|0)==(E|0)){b[v>>0]=48;Ca=v}else Ca=B;do if((I|0)==(ma|0)){B=Ca+1|0;vLa(a,Ca,1);if(w&(K|0)<1){Da=B;break}vLa(a,373302,1);Da=B}else{if(Ca>>>0<=m>>>0){Da=Ca;break}F1a(m|0,48,Ca+x|0)|0;B=Ca;while(1){z=B+-1|0;if(z>>>0>m>>>0)B=z;else{Da=z;break}}}while(0);W=P-Da|0;vLa(a,Da,(K|0)>(W|0)?W:K);B=K-W|0;I=I+4|0;if(!(I>>>0<Q>>>0&(B|0)>-1)){Ea=B;break}else K=B}}else Ea=ua;BLa(a,48,Ea+18|0,18,0);vLa(a,wa,p-wa|0)}BLa(a,32,d,V,g^8192);M=V}else{K=(i&32|0)!=0;Q=q+3|0;BLa(a,32,d,Q,g&-65537);vLa(a,r,q);vLa(a,s!=s|0.0!=0.0?(K?369373:369344):K?369336:369340,3);BLa(a,32,d,Q,g^8192);M=Q}while(0);u=j;return ((M|0)<(d|0)?d:M)|0}function ELa(a){a=+a;var b=0;p[s>>3]=a;b=f[s>>2]|0;J=f[s+4>>2]|0;return b|0}function FLa(a,b){a=+a;b=b|0;return +(+GLa(a,b))}function GLa(a,b){a=+a;b=b|0;var c=0,d=0,e=0,g=0.0,h=0,i=0.0,j=0.0;p[s>>3]=a;c=f[s>>2]|0;d=f[s+4>>2]|0;e=I1a(c|0,d|0,52)|0;switch(e&2047){case 0:{if(a!=0.0){g=+GLa(a*18446744073709551616.0,b);h=(f[b>>2]|0)+-64|0;i=g}else{h=0;i=a}f[b>>2]=h;j=i;break}case 2047:{j=a;break}default:{f[b>>2]=(e&2047)+-1022;f[s>>2]=c;f[s+4>>2]=d&-2146435073|1071644672;j=+p[s>>3]}}return +j}function HLa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;do if(a){if(c>>>0<128){b[a>>0]=c;e=1;break}d=(ILa()|0)+188|0;if(!(f[f[d>>2]>>2]|0))if((c&-128|0)==57216){b[a>>0]=c;e=1;break}else{d=pKa()|0;f[d>>2]=84;e=-1;break}if(c>>>0<2048){b[a>>0]=c>>>6|192;b[a+1>>0]=c&63|128;e=2;break}if(c>>>0<55296|(c&-8192|0)==57344){b[a>>0]=c>>>12|224;b[a+1>>0]=c>>>6&63|128;b[a+2>>0]=c&63|128;e=3;break}if((c+-65536|0)>>>0<1048576){b[a>>0]=c>>>18|240;b[a+1>>0]=c>>>12&63|128;b[a+2>>0]=c>>>6&63|128;b[a+3>>0]=c&63|128;e=4;break}else{d=pKa()|0;f[d>>2]=84;e=-1;break}}else e=1;while(0);return e|0}function ILa(){return rKa()|0}function JLa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=d+16|0;g=f[e>>2]|0;if(!g)if(!(KLa(d)|0)){h=f[e>>2]|0;i=5}else j=0;else{h=g;i=5}a:do if((i|0)==5){g=d+20|0;e=f[g>>2]|0;k=e;if((h-e|0)>>>0<c>>>0){j=ui[f[d+36>>2]&127](d,a,c)|0;break}b:do if((b[d+75>>0]|0)>-1){e=c;while(1){if(!e){l=k;m=0;n=c;o=a;break b}p=e+-1|0;if((b[a+p>>0]|0)==10)break;else e=p}p=ui[f[d+36>>2]&127](d,a,e)|0;if(p>>>0<e>>>0){j=p;break a}l=f[g>>2]|0;m=e;n=c-e|0;o=a+e|0}else{l=k;m=0;n=c;o=a}while(0);K1a(l|0,o|0,n|0)|0;f[g>>2]=(f[g>>2]|0)+n;j=m+n|0}while(0);return j|0}function KLa(a){a=a|0;var c=0,d=0,e=0;c=a+74|0;d=b[c>>0]|0;b[c>>0]=d+255|d;d=f[a>>2]|0;if(!(d&8)){f[a+8>>2]=0;f[a+4>>2]=0;c=f[a+44>>2]|0;f[a+28>>2]=c;f[a+20>>2]=c;f[a+16>>2]=c+(f[a+48>>2]|0);e=0}else{f[a>>2]=d|32;e=-1}return e|0}function LLa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=a+20|0;e=f[d>>2]|0;g=(f[a+16>>2]|0)-e|0;a=g>>>0>c>>>0?c:g;K1a(e|0,b|0,a|0)|0;f[d>>2]=(f[d>>2]|0)+a;return c|0}function MLa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;if((f[d+76>>2]|0)>-1)e=tLa(d)|0;else e=0;g=c+-1|0;i=(g|0)!=0;if((c|0)<2){c=d+74|0;j=b[c>>0]|0;b[c>>0]=j+255|j;if(e|0)uLa(d);if(i)k=0;else{b[a>>0]=0;k=a}}else{a:do if(i){j=d+4|0;c=d+8|0;l=g;m=a;while(1){n=f[j>>2]|0;o=n;p=(f[c>>2]|0)-o|0;q=BKa(n,10,p)|0;r=(q|0)==0;s=r?p:1-o+q|0;q=s>>>0<l>>>0?s:l;K1a(m|0,n|0,q|0)|0;n=(f[j>>2]|0)+q|0;f[j>>2]=n;t=m+q|0;s=l-q|0;if(!(r&(s|0)!=0)){u=t;v=17;break a}if(n>>>0>=(f[c>>2]|0)>>>0){r=nLa(d)|0;if((r|0)<0)break;else w=r}else{f[j>>2]=n+1;w=h[n>>0]|0}l=s+-1|0;s=t+1|0;b[t>>0]=w;if(!((l|0)!=0&(w&255|0)!=10)){u=s;v=17;break a}else m=s}if((t|0)!=(a|0)?(f[d>>2]&16|0)!=0:0){u=t;v=17}else x=0}else{u=a;v=17}while(0);if((v|0)==17)if(!a)x=0;else{b[u>>0]=0;x=a}if(!e)k=x;else{uLa(d);k=x}}return k|0}function NLa(a){a=a|0;return ((a+-48|0)>>>0<10|(OLa(a)|0)!=0)&1|0}function OLa(a){a=a|0;return ((a|32)+-97|0)>>>0<26|0}function PLa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;g=f[c>>2]|0;if((e|0)!=0?(i=f[e>>2]|0,(i|0)!=0):0)if(!a){j=i;k=g;l=d;m=25}else{f[e>>2]=0;n=i;o=g;p=d;q=a;m=43}else m=5;a:do if((m|0)==5){i=(QLa()|0)+188|0;e=(a|0)!=0;if(f[f[i>>2]>>2]|0)if(e){r=g;s=d;t=a;m=15;break}else{u=g;v=d;m=14;break}if(!e){w=xKa(g)|0;m=59;break}b:do if(!d)x=g;else{e=g;i=d;y=a;while(1){z=b[e>>0]|0;if(!(z<<24>>24))break;A=e+1|0;f[y>>2]=z<<24>>24&57343;z=i+-1|0;if(!z){x=A;break b}else{e=A;i=z;y=y+4|0}}f[y>>2]=0;f[c>>2]=0;w=d-i|0;m=59;break a}while(0);f[c>>2]=x;w=d;m=59}while(0);c:while(1){d:do if((m|0)==14){m=0;x=u;g=v;while(1){e=b[x>>0]|0;if(((e&255)+-1|0)>>>0<127?(x&3|0)==0:0){z=f[x>>2]|0;A=z&255;if(!((z+-16843009|z)&-2139062144)){z=x;B=g;do{z=z+4|0;B=B+-4|0;C=f[z>>2]|0}while(!((C+-16843009|C)&-2139062144|0));D=C&255;E=z;F=B}else{D=A;E=x;F=g}}else{D=e;E=x;F=g}G=D&255;if((G+-1|0)>>>0>=127)break;x=E+1|0;g=F+-1|0}g=G+-194|0;if(g>>>0>50){H=E;I=F;J=a;m=53}else{j=f[123492+(g<<2)>>2]|0;k=E+1|0;l=F;m=25;continue c}}else if((m|0)==15){m=0;e:do if(!s)K=r;else{g=r;x=s;i=t;while(1){y=b[g>>0]|0;do if(((y&255)+-1|0)>>>0<127?x>>>0>4&(g&3|0)==0:0){L=g;M=x;N=i;while(1){O=f[L>>2]|0;if((O+-16843009|O)&-2139062144|0){m=38;break}f[N>>2]=O&255;f[N+4>>2]=h[L+1>>0];f[N+8>>2]=h[L+2>>0];P=L+4|0;Q=N+16|0;f[N+12>>2]=h[L+3>>0];R=M+-4|0;if(R>>>0>4){L=P;M=R;N=Q}else{m=37;break}}if((m|0)==37){m=0;S=b[P>>0]|0;T=P;U=R;V=Q;break}else if((m|0)==38){m=0;S=O&255;T=L;U=M;V=N;break}}else{S=y;T=g;U=x;V=i}while(0);W=S&255;if((W+-1|0)>>>0>=127)break;y=T+1|0;f[V>>2]=W;x=U+-1|0;if(!x){K=y;break e}else{g=y;i=V+4|0}}i=W+-194|0;if(i>>>0>50){H=T;I=U;J=V;m=53;break d}n=f[123492+(i<<2)>>2]|0;o=T+1|0;p=U;q=V;m=43;continue c}while(0);f[c>>2]=K;w=d;m=59;continue c}else if((m|0)==25){m=0;i=(h[k>>0]|0)>>>3;if((i+-16|i+(j>>26))>>>0>7){X=j;Y=k;Z=l;_=a;m=52}else{i=k+1|0;if(j&33554432){if((b[i>>0]&-64)<<24>>24!=-128){X=j;Y=k;Z=l;_=a;m=52;break}g=k+2|0;if(!(j&524288))$=g;else{if((b[g>>0]&-64)<<24>>24!=-128){X=j;Y=k;Z=l;_=a;m=52;break}$=k+3|0}}else $=i;u=$;v=l+-1|0;m=14;continue c}}else if((m|0)==43){m=0;i=h[o>>0]|0;g=i>>>3;if((g+-16|g+(n>>26))>>>0>7){X=n;Y=o;Z=p;_=q;m=52}else{g=o+1|0;x=i+-128|n<<6;do if((x|0)<0){i=(h[g>>0]|0)+-128|0;if(i>>>0>63){aa=o+-1|0;ba=q;break d}e=o+2|0;A=i|x<<6;if((A|0)<0){i=(h[e>>0]|0)+-128|0;if(i>>>0>63){aa=o+-1|0;ba=q;break d}else{ca=i|A<<6;da=o+3|0;break}}else{ca=A;da=e}}else{ca=x;da=g}while(0);f[q>>2]=ca;r=da;s=p+-1|0;t=q+4|0;m=15;continue c}}else if((m|0)==59){m=0;return w|0}while(0);if((m|0)==52){m=0;g=Y+-1|0;if(!X){H=g;I=Z;J=_;m=53}else{aa=g;ba=_}}if((m|0)==53){m=0;if(!(b[H>>0]|0)){if(J|0){f[J>>2]=0;f[c>>2]=0}w=d-I|0;m=59;continue}else{aa=H;ba=J}}g=pKa()|0;f[g>>2]=84;if(!ba){w=-1;m=59;continue}f[c>>2]=aa;w=-1;m=59}return 0}function QLa(){return rKa()|0}function RLa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;if((f[a+76>>2]|0)>=0?(tLa(a)|0)!=0:0){b=a+4|0;c=f[b>>2]|0;if(c>>>0<(f[a+8>>2]|0)>>>0){f[b>>2]=c+1;d=h[c>>0]|0}else d=nLa(a)|0;e=d}else g=3;do if((g|0)==3){d=a+4|0;c=f[d>>2]|0;if(c>>>0<(f[a+8>>2]|0)>>>0){f[d>>2]=c+1;e=h[c>>0]|0;break}else{e=nLa(a)|0;break}}while(0);return e|0}function SLa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=c;c=TLa(a,b,e)|0;u=d;return c|0}function TLa(a,b,c){a=a|0;b=b|0;c=c|0;return qLa(a,2147483647,b,c)|0}function ULa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=c;c=rLa(a,b,e)|0;u=d;return c|0}function VLa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=a;f[e+4>>2]=b;f[e+8>>2]=c;c=oKa(nf(4,e|0)|0)|0;u=d;return c|0}function WLa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=a;f[e+4>>2]=b;f[e+8>>2]=c;c=oKa(ne(3,e|0)|0)|0;u=d;return c|0}function XLa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,E=0,F=0;switch(c|0){case 0:{e=24;g=-149;i=4;break}case 1:{e=53;g=-1074;i=4;break}case 2:{e=53;g=-1074;i=4;break}default:j=0.0}a:do if((i|0)==4){c=a+4|0;k=a+100|0;do{l=f[c>>2]|0;if(l>>>0<(f[k>>2]|0)>>>0){f[c>>2]=l+1;m=h[l>>0]|0}else m=lLa(a)|0}while((mLa(m)|0)!=0);b:do switch(m|0){case 43:case 45:{l=1-(((m|0)==45&1)<<1)|0;n=f[c>>2]|0;if(n>>>0<(f[k>>2]|0)>>>0){f[c>>2]=n+1;o=h[n>>0]|0;p=l;break b}else{o=lLa(a)|0;p=l;break b}break}default:{o=m;p=1}}while(0);l=o;n=0;while(1){if((l|32|0)!=(b[369364+n>>0]|0)){q=l;r=n;break}do if(n>>>0<7){s=f[c>>2]|0;if(s>>>0<(f[k>>2]|0)>>>0){f[c>>2]=s+1;t=h[s>>0]|0;break}else{t=lLa(a)|0;break}}else t=l;while(0);s=n+1|0;if(s>>>0<8){l=t;n=s}else{q=t;r=s;break}}c:do switch(r|0){case 8:break;case 3:{i=23;break}default:{n=(d|0)!=0;if(n&r>>>0>3)if((r|0)==8)break c;else{i=23;break c}d:do if(!r){l=q;s=0;while(1){if((l|32|0)!=(b[369373+s>>0]|0)){u=l;v=s;break d}do if(s>>>0<2){w=f[c>>2]|0;if(w>>>0<(f[k>>2]|0)>>>0){f[c>>2]=w+1;x=h[w>>0]|0;break}else{x=lLa(a)|0;break}}else x=l;while(0);w=s+1|0;if(w>>>0<3){l=x;s=w}else{u=x;v=w;break}}}else{u=q;v=r}while(0);switch(v|0){case 3:{s=f[c>>2]|0;if(s>>>0<(f[k>>2]|0)>>>0){f[c>>2]=s+1;y=h[s>>0]|0}else y=lLa(a)|0;if((y|0)==40)z=1;else{if(!(f[k>>2]|0)){j=C;break a}f[c>>2]=(f[c>>2]|0)+-1;j=C;break a}while(1){s=f[c>>2]|0;if(s>>>0<(f[k>>2]|0)>>>0){f[c>>2]=s+1;A=h[s>>0]|0}else A=lLa(a)|0;if(!((A+-48|0)>>>0<10|(A+-65|0)>>>0<26)?!((A|0)==95|(A+-97|0)>>>0<26):0)break;z=z+1|0}if((A|0)==41){j=C;break a}s=(f[k>>2]|0)==0;if(!s)f[c>>2]=(f[c>>2]|0)+-1;if(!n){l=pKa()|0;f[l>>2]=22;jLa(a,0);j=0.0;break a}if(!z){j=C;break a}else B=z;while(1){B=B+-1|0;if(!s)f[c>>2]=(f[c>>2]|0)+-1;if(!B){j=C;break a}}break}case 0:{if((u|0)==48){s=f[c>>2]|0;if(s>>>0<(f[k>>2]|0)>>>0){f[c>>2]=s+1;E=h[s>>0]|0}else E=lLa(a)|0;if((E|32|0)==120){j=+YLa(a,e,g,p,d);break a}if(!(f[k>>2]|0))F=48;else{f[c>>2]=(f[c>>2]|0)+-1;F=48}}else F=u;j=+ZLa(a,F,e,g,p,d);break a;break}default:{if(f[k>>2]|0)f[c>>2]=(f[c>>2]|0)+-1;s=pKa()|0;f[s>>2]=22;jLa(a,0);j=0.0;break a}}}}while(0);if((i|0)==23){s=(f[k>>2]|0)==0;if(!s)f[c>>2]=(f[c>>2]|0)+-1;if((d|0)!=0&r>>>0>3){n=r;do{if(!s)f[c>>2]=(f[c>>2]|0)+-1;n=n+-1|0}while(n>>>0>3)}}j=+(p|0)*D}while(0);return +j}function YLa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0.0,M=0,N=0.0,O=0.0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0.0,da=0,ea=0.0;g=a+4|0;i=f[g>>2]|0;j=a+100|0;if(i>>>0<(f[j>>2]|0)>>>0){f[g>>2]=i+1;k=h[i>>0]|0;l=0}else{k=lLa(a)|0;l=0}a:while(1){switch(k|0){case 46:{m=8;break a;break}case 48:break;default:{n=0;o=0;p=0;q=0;r=k;s=l;t=0;u=0;v=1.0;w=0;x=0.0;break a}}i=f[g>>2]|0;if(i>>>0<(f[j>>2]|0)>>>0){f[g>>2]=i+1;k=h[i>>0]|0;l=1;continue}else{k=lLa(a)|0;l=1;continue}}if((m|0)==8){k=f[g>>2]|0;if(k>>>0<(f[j>>2]|0)>>>0){f[g>>2]=k+1;y=h[k>>0]|0}else y=lLa(a)|0;if((y|0)==48){k=0;i=0;while(1){z=f[g>>2]|0;if(z>>>0<(f[j>>2]|0)>>>0){f[g>>2]=z+1;A=h[z>>0]|0}else A=lLa(a)|0;z=C1a(k|0,i|0,-1,-1)|0;B=J;if((A|0)==48){k=z;i=B}else{n=0;o=0;p=z;q=B;r=A;s=1;t=1;u=0;v=1.0;w=0;x=0.0;break}}}else{n=0;o=0;p=0;q=0;r=y;s=l;t=1;u=0;v=1.0;w=0;x=0.0}}while(1){l=r+-48|0;y=(r|0)==46;if(l>>>0>=10?!(y|((r|32)+-97|0)>>>0<6):0){C=r;break}if(y)if(!t){D=o;E=n;F=o;G=n;H=s;I=1;K=u;L=v;M=w;N=x}else{C=46;break}else{y=(r|0)>57?(r|32)+-87|0:l;do if(!((n|0)<0|(n|0)==0&o>>>0<8))if((n|0)<0|(n|0)==0&o>>>0<14){O=v*.0625;P=u;Q=O;R=w;S=x+O*+(y|0);break}else{l=(u|0)!=0|(y|0)==0;P=l?u:1;Q=v;R=w;S=l?x:x+v*.5;break}else{P=u;Q=v;R=y+(w<<4)|0;S=x}while(0);y=C1a(o|0,n|0,1,0)|0;D=p;E=q;F=y;G=J;H=1;I=t;K=P;L=Q;M=R;N=S}y=f[g>>2]|0;if(y>>>0<(f[j>>2]|0)>>>0){f[g>>2]=y+1;n=G;o=F;p=D;q=E;r=h[y>>0]|0;s=H;t=I;u=K;v=L;w=M;x=N;continue}else{n=G;o=F;p=D;q=E;r=lLa(a)|0;s=H;t=I;u=K;v=L;w=M;x=N;continue}}do if(!s){M=f[j>>2]|0;K=(M|0)!=0;if(K)f[g>>2]=(f[g>>2]|0)+-1;if(e){if(K)f[g>>2]=(f[g>>2]|0)+-1;if(!((t|0)==0|(M|0)==0))f[g>>2]=(f[g>>2]|0)+-1}else jLa(a,0);T=+(d|0)*0.0}else{M=(t|0)==0;K=M?o:p;u=M?n:q;if((n|0)<0|(n|0)==0&o>>>0<8){M=o;I=n;H=w;while(1){r=H<<4;M=C1a(M|0,I|0,1,0)|0;I=J;if(!((I|0)<0|(I|0)==0&M>>>0<8)){U=r;break}else H=r}}else U=w;if((C|32|0)==112){H=_La(a,e)|0;M=J;if((H|0)==0&(M|0)==-2147483648){if(!e){jLa(a,0);T=0.0;break}if(!(f[j>>2]|0)){V=0;W=0}else{f[g>>2]=(f[g>>2]|0)+-1;V=0;W=0}}else{V=H;W=M}}else if(!(f[j>>2]|0)){V=0;W=0}else{f[g>>2]=(f[g>>2]|0)+-1;V=0;W=0}M=R1a(K|0,u|0,2)|0;H=C1a(M|0,J|0,-32,-1)|0;M=C1a(H|0,J|0,V|0,W|0)|0;H=J;if(!U){T=+(d|0)*0.0;break}I=0-c|0;r=((I|0)<0)<<31>>31;if((H|0)>(r|0)|(H|0)==(r|0)&M>>>0>I>>>0){I=pKa()|0;f[I>>2]=34;T=+(d|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;break}I=c+-106|0;r=((I|0)<0)<<31>>31;if((H|0)<(r|0)|(H|0)==(r|0)&M>>>0<I>>>0){I=pKa()|0;f[I>>2]=34;T=+(d|0)*2.2250738585072014e-308*2.2250738585072014e-308;break}if((U|0)>-1){I=M;r=H;E=U;N=x;while(1){D=!(N>=.5);F=E<<1|(D^1)&1;L=N+(D?N:N+-1.0);D=C1a(I|0,r|0,-1,-1)|0;G=J;if((F|0)>-1){I=D;r=G;E=F;N=L}else{X=D;Y=G;Z=F;_=L;break}}}else{X=M;Y=H;Z=U;_=x}E=((b|0)<0)<<31>>31;r=B1a(32,0,c|0,((c|0)<0)<<31>>31|0)|0;I=C1a(r|0,J|0,X|0,Y|0)|0;r=J;if((E|0)>(r|0)|(E|0)==(r|0)&b>>>0>I>>>0)if((I|0)>0){$=I;m=59}else{aa=0;ba=84;m=61}else{$=b;m=59}if((m|0)==59)if(($|0)<53){aa=$;ba=84-$|0;m=61}else{ca=0.0;da=$;ea=+(d|0)}if((m|0)==61){N=+(d|0);ca=+aMa(+$La(1.0,ba),N);da=aa;ea=N}I=(Z&1|0)==0&(_!=0.0&(da|0)<32);N=ea*(I?0.0:_)+(ca+ea*+(((I&1)+Z|0)>>>0))-ca;if(!(N!=0.0)){I=pKa()|0;f[I>>2]=34}T=+cMa(N,X)}while(0);return +T}function ZLa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0.0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0,tb=0.0;i=u;u=u+512|0;j=i;k=d+c|0;l=0-k|0;m=a+4|0;n=a+100|0;o=b;b=0;a:while(1){switch(o|0){case 46:{p=6;break a;break}case 48:break;default:{q=0;r=0;s=o;t=b;v=0;break a}}w=f[m>>2]|0;if(w>>>0<(f[n>>2]|0)>>>0){f[m>>2]=w+1;o=h[w>>0]|0;b=1;continue}else{o=lLa(a)|0;b=1;continue}}if((p|0)==6){o=f[m>>2]|0;if(o>>>0<(f[n>>2]|0)>>>0){f[m>>2]=o+1;x=h[o>>0]|0}else x=lLa(a)|0;if((x|0)==48){o=0;w=0;while(1){y=C1a(o|0,w|0,-1,-1)|0;z=J;A=f[m>>2]|0;if(A>>>0<(f[n>>2]|0)>>>0){f[m>>2]=A+1;B=h[A>>0]|0}else B=lLa(a)|0;if((B|0)==48){o=y;w=z}else{q=y;r=z;s=B;t=1;v=1;break}}}else{q=0;r=0;s=x;t=b;v=1}}f[j>>2]=0;b=s+-48|0;x=(s|0)==46;b:do if(x|b>>>0<10){B=j+496|0;w=q;o=r;z=0;y=0;A=s;C=x;D=t;E=v;F=0;G=0;H=0;I=b;c:while(1){do if(C)if(!E){K=z;M=y;N=z;O=y;P=D;Q=1;R=F;S=G;T=H}else break c;else{U=C1a(z|0,y|0,1,0)|0;V=J;W=(A|0)!=48;if((G|0)>=125){if(!W){K=w;M=o;N=U;O=V;P=D;Q=E;R=F;S=G;T=H;break}f[B>>2]=f[B>>2]|1;K=w;M=o;N=U;O=V;P=D;Q=E;R=F;S=G;T=H;break}X=j+(G<<2)|0;if(!F)Z=I;else Z=A+-48+((f[X>>2]|0)*10|0)|0;f[X>>2]=Z;X=F+1|0;_=(X|0)==9;K=w;M=o;N=U;O=V;P=1;Q=E;R=_?0:X;S=(_&1)+G|0;T=W?U:H}while(0);U=f[m>>2]|0;if(U>>>0<(f[n>>2]|0)>>>0){f[m>>2]=U+1;$=h[U>>0]|0}else $=lLa(a)|0;I=$+-48|0;C=($|0)==46;if(!(C|I>>>0<10)){aa=K;ba=N;ca=M;da=O;ea=$;fa=P;ga=Q;ha=R;ia=S;ja=T;p=29;break b}else{w=K;o=M;z=N;y=O;A=$;D=P;E=Q;F=R;G=S;H=T}}ka=z;la=y;ma=w;na=o;oa=F;pa=G;qa=H;ra=(D|0)!=0;p=37}else{aa=q;ba=0;ca=r;da=0;ea=s;fa=t;ga=v;ha=0;ia=0;ja=0;p=29}while(0);do if((p|0)==29){v=(ga|0)==0;t=v?ba:aa;s=v?da:ca;v=(fa|0)!=0;if(!(v&(ea|32|0)==101))if((ea|0)>-1){ka=ba;la=da;ma=t;na=s;oa=ha;pa=ia;qa=ja;ra=v;p=37;break}else{sa=ba;ta=da;ua=t;va=s;wa=ha;xa=ia;ya=ja;za=v;p=39;break}v=_La(a,g)|0;r=J;if((v|0)==0&(r|0)==-2147483648){if(!g){jLa(a,0);Aa=0.0;break}if(!(f[n>>2]|0)){Ba=0;Ca=0}else{f[m>>2]=(f[m>>2]|0)+-1;Ba=0;Ca=0}}else{Ba=v;Ca=r}r=C1a(Ba|0,Ca|0,t|0,s|0)|0;Da=r;Ea=ba;Fa=J;Ga=da;Ha=ha;Ia=ia;Ja=ja;p=41}while(0);if((p|0)==37)if(f[n>>2]|0){f[m>>2]=(f[m>>2]|0)+-1;if(ra){Da=ma;Ea=ka;Fa=na;Ga=la;Ha=oa;Ia=pa;Ja=qa;p=41}else p=40}else{sa=ka;ta=la;ua=ma;va=na;wa=oa;xa=pa;ya=qa;za=ra;p=39}if((p|0)==39)if(za){Da=ua;Ea=sa;Fa=va;Ga=ta;Ha=wa;Ia=xa;Ja=ya;p=41}else p=40;do if((p|0)==40){ya=pKa()|0;f[ya>>2]=22;jLa(a,0);Aa=0.0}else if((p|0)==41){ya=f[j>>2]|0;if(!ya){Aa=+(e|0)*0.0;break}if(((Ga|0)<0|(Ga|0)==0&Ea>>>0<10)&((Da|0)==(Ea|0)&(Fa|0)==(Ga|0))?(c|0)>30|(ya>>>c|0)==0:0){Aa=+(e|0)*+(ya>>>0);break}ya=(d|0)/-2|0;xa=((ya|0)<0)<<31>>31;if((Fa|0)>(xa|0)|(Fa|0)==(xa|0)&Da>>>0>ya>>>0){ya=pKa()|0;f[ya>>2]=34;Aa=+(e|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;break}ya=d+-106|0;xa=((ya|0)<0)<<31>>31;if((Fa|0)<(xa|0)|(Fa|0)==(xa|0)&Da>>>0<ya>>>0){ya=pKa()|0;f[ya>>2]=34;Aa=+(e|0)*2.2250738585072014e-308*2.2250738585072014e-308;break}if(!Ha)Ka=Ia;else{if((Ha|0)<9){ya=j+(Ia<<2)|0;xa=Ha;wa=f[ya>>2]|0;do{wa=wa*10|0;xa=xa+1|0}while((xa|0)!=9);f[ya>>2]=wa}Ka=Ia+1|0}if((Ja|0)<9?(Ja|0)<=(Da|0)&(Da|0)<18:0){xa=f[j>>2]|0;if((Da|0)==9){Aa=+(e|0)*+(xa>>>0);break}if((Da|0)<9){Aa=+(e|0)*+(xa>>>0)/+(f[123892+(8-Da<<2)>>2]|0);break}D=c+27+(Y(Da,-3)|0)|0;if((D|0)>30|(xa>>>D|0)==0){Aa=+(e|0)*+(xa>>>0)*+(f[123892+(Da+-10<<2)>>2]|0);break}}xa=(Da|0)%9|0;if(!xa){La=0;Ma=0;Na=Da;Oa=Ka}else{D=(Da|0)>-1?xa:xa+9|0;xa=f[123892+(8-D<<2)>>2]|0;if(Ka){H=1e9/(xa|0)|0;G=0;F=0;o=0;w=Da;do{y=j+(o<<2)|0;z=f[y>>2]|0;ta=((z>>>0)/(xa>>>0)|0)+F|0;f[y>>2]=ta;F=Y(H,(z>>>0)%(xa>>>0)|0)|0;z=(o|0)==(G|0)&(ta|0)==0;w=z?w+-9|0:w;G=z?G+1&127:G;o=o+1|0}while((o|0)!=(Ka|0));if(!F){Pa=G;Qa=w;Ra=Ka}else{f[j+(Ka<<2)>>2]=F;Pa=G;Qa=w;Ra=Ka+1|0}}else{Pa=0;Qa=Da;Ra=0}La=Pa;Ma=0;Na=9-D+Qa|0;Oa=Ra}d:while(1){o=(Na|0)<18;xa=(Na|0)==18;H=j+(La<<2)|0;wa=Ma;ya=Oa;while(1){if(!o){if(!xa){Sa=La;Ta=wa;Ua=Na;Va=ya;break d}if((f[H>>2]|0)>>>0>=9007199){Sa=La;Ta=wa;Ua=18;Va=ya;break d}}z=0;ta=ya+127|0;Wa=ya;while(1){y=ta&127;va=j+(y<<2)|0;sa=R1a(f[va>>2]|0,0,29)|0;ua=C1a(sa|0,J|0,z|0,0)|0;sa=J;if(sa>>>0>0|(sa|0)==0&ua>>>0>1e9){za=U1a(ua|0,sa|0,1e9,0)|0;ra=P1a(ua|0,sa|0,1e9,0)|0;Xa=ra;Ya=za}else{Xa=ua;Ya=0}f[va>>2]=Xa;va=(y|0)==(La|0);Wa=(Xa|0)==0&(((y|0)!=(Wa+127&127|0)|va)^1)?y:Wa;if(va)break;else{z=Ya;ta=y+-1|0}}wa=wa+-29|0;if(Ya|0)break;else ya=Wa}ya=La+127&127;H=Wa+127&127;xa=j+((Wa+126&127)<<2)|0;if((ya|0)==(Wa|0)){f[xa>>2]=f[xa>>2]|f[j+(H<<2)>>2];Za=H}else Za=Wa;f[j+(ya<<2)>>2]=Ya;La=ya;Ma=wa;Na=Na+9|0;Oa=Za}e:while(1){D=Va+1&127;w=j+((Va+127&127)<<2)|0;G=Sa;F=Ta;ya=Ua;while(1){H=(ya|0)==18;xa=(ya|0)>27?9:1;_a=G;$a=F;while(1){o=0;while(1){ta=o+_a&127;if((ta|0)==(Va|0)){ab=2;p=88;break}z=f[j+(ta<<2)>>2]|0;ta=f[123924+(o<<2)>>2]|0;if(z>>>0<ta>>>0){ab=2;p=88;break}if(z>>>0>ta>>>0)break;ta=o+1|0;if((ta|0)<2)o=ta;else{ab=ta;p=88;break}}if((p|0)==88?(p=0,H&(ab|0)==2):0){bb=0;cb=0.0;db=Va;break e}eb=xa+$a|0;if((_a|0)==(Va|0)){_a=Va;$a=eb}else break}H=(1<<xa)+-1|0;o=1e9>>>xa;fb=_a;gb=0;ta=_a;hb=ya;do{z=j+(ta<<2)|0;y=f[z>>2]|0;va=(y>>>xa)+gb|0;f[z>>2]=va;gb=Y(y&H,o)|0;y=(ta|0)==(fb|0)&(va|0)==0;hb=y?hb+-9|0:hb;fb=y?fb+1&127:fb;ta=ta+1&127}while((ta|0)!=(Va|0));if(!gb){G=fb;F=eb;ya=hb;continue}if((D|0)!=(fb|0))break;f[w>>2]=f[w>>2]|1;G=fb;F=eb;ya=hb}f[j+(Va<<2)>>2]=gb;Sa=fb;Ta=eb;Ua=hb;Va=D}while(1){ya=bb+_a&127;F=db+1&127;if((ya|0)==(db|0)){f[j+(F+-1<<2)>>2]=0;ib=F}else ib=db;cb=cb*1.0e9+ +((f[j+(ya<<2)>>2]|0)>>>0);bb=bb+1|0;if((bb|0)==2)break;else db=ib}jb=+(e|0);kb=jb*cb;ya=$a+53|0;F=ya-d|0;G=(F|0)<(c|0);w=G?((F|0)>0?F:0):c;if((w|0)<53){lb=+aMa(+$La(1.0,105-w|0),kb);mb=+bMa(kb,+$La(1.0,53-w|0));nb=lb;ob=mb;pb=lb+(kb-mb)}else{nb=0.0;ob=0.0;pb=kb}wa=_a+2&127;if((wa|0)!=(ib|0)){ta=f[j+(wa<<2)>>2]|0;do if(ta>>>0>=5e8){if((ta|0)!=5e8){qb=jb*.75+ob;break}if((_a+3&127|0)==(ib|0)){qb=jb*.5+ob;break}else{qb=jb*.75+ob;break}}else{if((ta|0)==0?(_a+3&127|0)==(ib|0):0){qb=ob;break}qb=jb*.25+ob}while(0);if((53-w|0)>1?!(+bMa(qb,1.0)!=0.0):0)rb=qb+1.0;else rb=qb}else rb=ob;jb=pb+rb-nb;do if((ya&2147483647|0)>(-2-k|0)){ta=!(+L(+jb)>=9007199254740992.0);wa=((ta^1)&1)+$a|0;kb=ta?jb:jb*.5;if((wa+50|0)<=(l|0)?!(rb!=0.0&(G&((w|0)!=(F|0)|ta))):0){sb=wa;tb=kb;break}ta=pKa()|0;f[ta>>2]=34;sb=wa;tb=kb}else{sb=$a;tb=jb}while(0);Aa=+cMa(tb,sb)}while(0);u=i;return +Aa}function _La(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;c=a+4|0;d=f[c>>2]|0;e=a+100|0;if(d>>>0<(f[e>>2]|0)>>>0){f[c>>2]=d+1;g=h[d>>0]|0}else g=lLa(a)|0;switch(g|0){case 43:case 45:{d=(g|0)==45&1;i=f[c>>2]|0;if(i>>>0<(f[e>>2]|0)>>>0){f[c>>2]=i+1;j=h[i>>0]|0}else j=lLa(a)|0;if((b|0)!=0&(j+-48|0)>>>0>9?(f[e>>2]|0)!=0:0){f[c>>2]=(f[c>>2]|0)+-1;k=j;l=d}else{k=j;l=d}break}default:{k=g;l=0}}if((k+-48|0)>>>0>9)if(!(f[e>>2]|0)){m=-2147483648;n=0}else{f[c>>2]=(f[c>>2]|0)+-1;m=-2147483648;n=0}else{g=k;k=0;while(1){k=g+-48+(k*10|0)|0;d=f[c>>2]|0;if(d>>>0<(f[e>>2]|0)>>>0){f[c>>2]=d+1;o=h[d>>0]|0}else o=lLa(a)|0;if(!((o+-48|0)>>>0<10&(k|0)<214748364))break;else g=o}g=((k|0)<0)<<31>>31;if((o+-48|0)>>>0<10){d=k;j=g;b=o;while(1){i=W1a(d|0,j|0,10,0)|0;p=J;q=C1a(b|0,((b|0)<0)<<31>>31|0,-48,-1)|0;r=C1a(q|0,J|0,i|0,p|0)|0;p=J;i=f[c>>2]|0;if(i>>>0<(f[e>>2]|0)>>>0){f[c>>2]=i+1;s=h[i>>0]|0}else s=lLa(a)|0;if((s+-48|0)>>>0<10&((p|0)<21474836|(p|0)==21474836&r>>>0<2061584302)){d=r;j=p;b=s}else{t=r;u=p;v=s;break}}}else{t=k;u=g;v=o}o=f[e>>2]|0;if((v+-48|0)>>>0<10){v=o;while(1){g=f[c>>2]|0;if(g>>>0<v>>>0){f[c>>2]=g+1;w=v;x=h[g>>0]|0}else{g=lLa(a)|0;w=f[e>>2]|0;x=g}if((x+-48|0)>>>0<10)v=w;else{y=w;break}}}else y=o;if(y|0)f[c>>2]=(f[c>>2]|0)+-1;c=(l|0)!=0;l=B1a(0,0,t|0,u|0)|0;m=c?J:u;n=c?l:t}J=m;return n|0}function $La(a,b){a=+a;b=b|0;var c=0.0,d=0,e=0,g=0,h=0,i=0.0;if((b|0)<=1023)if((b|0)<-1022){c=a*2.2250738585072014e-308;d=b+1022|0;e=(d|0)<-1022;g=b+2044|0;h=e?((g|0)>-1022?g:-1022):d;i=e?c*2.2250738585072014e-308:c}else{h=b;i=a}else{c=a*8988465674311579538646525.0e283;e=b+-1023|0;d=(e|0)>1023;g=b+-2046|0;h=d?((g|0)<1023?g:1023):e;i=d?c*8988465674311579538646525.0e283:c}d=R1a(h+1023|0,0,52)|0;h=J;f[s>>2]=d;f[s+4>>2]=h;return +(i*+p[s>>3])}function aMa(a,b){a=+a;b=+b;return +(+fMa(a,b))}function bMa(a,b){a=+a;b=+b;return +(+dMa(a,b))}function cMa(a,b){a=+a;b=b|0;return +(+$La(a,b))}function dMa(a,b){a=+a;b=+b;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0.0;p[s>>3]=a;c=f[s>>2]|0;d=f[s+4>>2]|0;p[s>>3]=b;e=f[s>>2]|0;g=f[s+4>>2]|0;h=I1a(c|0,d|0,52)|0;i=h&2047;h=I1a(e|0,g|0,52)|0;j=h&2047;h=d&-2147483648;k=R1a(e|0,g|0,1)|0;l=J;a:do if(!((k|0)==0&(l|0)==0)?(m=eMa(b)|0,n=J&2147483647,!((i|0)==2047|(n>>>0>2146435072|(n|0)==2146435072&m>>>0>0))):0){m=R1a(c|0,d|0,1)|0;n=J;if(!(n>>>0>l>>>0|(n|0)==(l|0)&m>>>0>k>>>0))return +((m|0)==(k|0)&(n|0)==(l|0)?a*0.0:a);if(!i){n=R1a(c|0,d|0,12)|0;m=J;if((m|0)>-1|(m|0)==-1&n>>>0>4294967295){o=n;n=m;m=0;while(1){q=m+-1|0;o=R1a(o|0,n|0,1)|0;n=J;if(!((n|0)>-1|(n|0)==-1&o>>>0>4294967295)){r=q;break}else m=q}}else r=0;m=R1a(c|0,d|0,1-r|0)|0;t=m;u=J;v=r}else{t=c;u=d&1048575|1048576;v=i}if(!j){m=R1a(e|0,g|0,12)|0;o=J;if((o|0)>-1|(o|0)==-1&m>>>0>4294967295){n=m;m=o;o=0;while(1){q=o+-1|0;n=R1a(n|0,m|0,1)|0;m=J;if(!((m|0)>-1|(m|0)==-1&n>>>0>4294967295)){w=q;break}else o=q}}else w=0;o=R1a(e|0,g|0,1-w|0)|0;x=o;y=J;z=w}else{x=e;y=g&1048575|1048576;z=j}o=B1a(t|0,u|0,x|0,y|0)|0;n=J;m=(n|0)>-1|(n|0)==-1&o>>>0>4294967295;b:do if((v|0)>(z|0)){q=t;A=u;B=o;C=n;D=m;E=v;while(1){if(D)if((B|0)==0&(C|0)==0)break;else{F=B;G=C}else{F=q;G=A}H=R1a(F|0,G|0,1)|0;I=J;K=E+-1|0;L=B1a(H|0,I|0,x|0,y|0)|0;M=J;N=(M|0)>-1|(M|0)==-1&L>>>0>4294967295;if((K|0)>(z|0)){q=H;A=I;B=L;C=M;D=N;E=K}else{O=M;P=H;Q=I;R=L;S=N;T=K;break b}}U=a*0.0;break a}else{O=n;P=t;Q=u;R=o;S=m;T=v}while(0);if(S)if((R|0)==0&(O|0)==0){U=a*0.0;break}else{V=O;W=R}else{V=Q;W=P}if(V>>>0<1048576|(V|0)==1048576&W>>>0<0){m=W;o=V;n=T;while(1){E=R1a(m|0,o|0,1)|0;D=J;C=n+-1|0;if(D>>>0<1048576|(D|0)==1048576&E>>>0<0){m=E;o=D;n=C}else{X=E;Y=D;Z=C;break}}}else{X=W;Y=V;Z=T}if((Z|0)>0){n=C1a(X|0,Y|0,0,-1048576)|0;o=J;m=R1a(Z|0,0,52)|0;_=o|J;$=n|m}else{m=I1a(X|0,Y|0,1-Z|0)|0;_=J;$=m}f[s>>2]=$;f[s+4>>2]=_|h;U=+p[s>>3]}else aa=3;while(0);if((aa|0)==3){ba=a*b;U=ba/ba}return +U}function eMa(a){a=+a;var b=0;p[s>>3]=a;b=f[s>>2]|0;J=f[s+4>>2]|0;return b|0}function fMa(a,b){a=+a;b=+b;var c=0,d=0,e=0;p[s>>3]=a;c=f[s>>2]|0;d=f[s+4>>2]|0;p[s>>3]=b;e=f[s+4>>2]&-2147483648|d&2147483647;f[s>>2]=c;f[s+4>>2]=e;return +(+p[s>>3])}function gMa(a){a=a|0;var b=0,c=0,d=0;if(!(f[a>>2]&128))b=1;else b=(f[a+20>>2]|0)>>>0>(f[a+28>>2]|0)>>>0?2:1;c=ui[f[a+40>>2]&127](a,0,b)|0;if((c|0)<0)d=c;else d=c-(f[a+8>>2]|0)+(f[a+4>>2]|0)+(f[a+20>>2]|0)-(f[a+28>>2]|0)|0;return d|0}function hMa(a){a=a|0;var b=0,c=0,d=0;if((f[a+76>>2]|0)>-1){b=(tLa(a)|0)==0;c=gMa(a)|0;if(b)d=c;else d=c}else d=gMa(a)|0;return d|0}function iMa(a){a=a|0;return hMa(a)|0}function jMa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0.0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0;e=u;u=u+288|0;g=e+8|0;i=e+17|0;j=e;k=e+16|0;if((f[a+76>>2]|0)>-1)l=tLa(a)|0;else l=0;m=b[c>>0]|0;a:do if(m<<24>>24){o=a+4|0;q=a+100|0;r=a+108|0;s=a+8|0;t=i+10|0;v=i+33|0;w=g+4|0;x=i+46|0;y=i+94|0;z=i+1|0;A=i+1|0;B=0;C=m;D=0;E=c;F=0;G=0;b:while(1){c:do if(!(mLa(C&255)|0)){H=C<<24>>24==37;d:do if(H){I=E+1|0;K=b[I>>0]|0;e:do switch(K<<24>>24){case 37:{break d;break}case 42:{L=0;M=E+2|0;break}default:{N=(K&255)+-48|0;if(N>>>0<10?(b[E+2>>0]|0)==36:0){L=kMa(d,N)|0;M=E+3|0;break e}N=(f[d>>2]|0)+(4-1)&~(4-1);O=f[N>>2]|0;f[d>>2]=N+4;L=O;M=I}}while(0);I=b[M>>0]|0;K=I&255;if((K+-48|0)>>>0<10){O=K;K=M;N=0;while(1){P=(N*10|0)+-48+O|0;Q=K+1|0;R=b[Q>>0]|0;O=R&255;if((O+-48|0)>>>0>=10){S=R;T=Q;U=P;break}else{K=Q;N=P}}}else{S=I;T=M;U=0}N=S<<24>>24==109;K=(L|0)!=0;O=N?0:G;P=N?0:B;Q=N?T+1|0:T;V=K&N;N=Q+1|0;switch(b[Q>>0]|0){case 104:{R=(b[N>>0]|0)==104;W=R?Q+2|0:N;X=R?-2:-1;break}case 108:{R=(b[N>>0]|0)==108;W=R?Q+2|0:N;X=R?3:1;break}case 106:{W=N;X=3;break}case 116:case 122:{W=N;X=1;break}case 76:{W=N;X=2;break}case 110:case 112:case 67:case 83:case 91:case 99:case 115:case 88:case 71:case 70:case 69:case 65:case 103:case 102:case 101:case 97:case 120:case 117:case 111:case 105:case 100:{W=Q;X=0;break}default:{Y=P;Z=V;_=O;$=137;break b}}Q=h[W>>0]|0;N=(Q&47|0)==3;R=N?Q|32:Q;Q=N?1:X;N=R&255;switch(N<<24>>24){case 99:{aa=F;ba=(U|0)>1?U:1;break}case 91:{aa=F;ba=U;break}case 110:{lMa(L,Q,F,((F|0)<0)<<31>>31);ca=P;da=D;ea=W;fa=F;ga=O;break c;break}default:{jLa(a,0);do{ha=f[o>>2]|0;if(ha>>>0<(f[q>>2]|0)>>>0){f[o>>2]=ha+1;ia=h[ha>>0]|0}else ia=lLa(a)|0}while((mLa(ia)|0)!=0);if(!(f[q>>2]|0))ja=f[o>>2]|0;else{I=(f[o>>2]|0)+-1|0;f[o>>2]=I;ja=I}aa=(f[r>>2]|0)+F+ja-(f[s>>2]|0)|0;ba=U}}jLa(a,ba);I=f[o>>2]|0;ha=f[q>>2]|0;if(I>>>0<ha>>>0){f[o>>2]=I+1;ka=ha}else{if((lLa(a)|0)<0){Y=P;Z=V;_=O;$=137;break b}ka=f[q>>2]|0}if(ka|0)f[o>>2]=(f[o>>2]|0)+-1;f:do switch(N<<24>>24){case 91:case 99:case 115:{ha=(R|0)==99;g:do if((R|16|0)==115){F1a(z|0,-1,256)|0;b[i>>0]=0;if((R|0)==115){b[v>>0]=0;b[t>>0]=0;b[t+1>>0]=0;b[t+2>>0]=0;b[t+3>>0]=0;b[t+4>>0]=0;la=W}else la=W}else{I=W+1|0;ma=(b[I>>0]|0)==94;na=ma&1;oa=ma?W+2|0:I;F1a(A|0,ma&1|0,256)|0;b[i>>0]=0;switch(b[oa>>0]|0){case 45:{pa=x;$=64;break}case 93:{pa=y;$=64;break}default:{qa=(na^1)&255;ra=oa}}if(($|0)==64){$=0;ma=(na^1)&255;b[pa>>0]=ma;qa=ma;ra=oa+1|0}oa=ra;while(1){ma=b[oa>>0]|0;h:do switch(ma<<24>>24){case 0:{Y=P;Z=V;_=O;$=137;break b;break}case 93:{la=oa;break g;break}case 45:{na=oa+1|0;I=b[na>>0]|0;switch(I<<24>>24){case 93:case 0:{sa=45;ta=oa;break h;break}default:{}}ua=b[oa+-1>>0]|0;if((ua&255)<(I&255)){va=ua&255;do{va=va+1|0;b[i+va>>0]=qa;ua=b[na>>0]|0}while((va|0)<(ua&255|0));sa=ua;ta=na}else{sa=I;ta=na}break}default:{sa=ma;ta=oa}}while(0);b[i+((sa&255)+1)>>0]=qa;oa=ta+1|0}}while(0);oa=ha?ba+1|0:31;ma=(Q|0)==1;i:do if(ma){if(V){va=dKa(oa<<2)|0;if(!va){Y=0;Z=1;_=0;$=137;break b}else wa=va}else wa=L;f[g>>2]=0;f[w>>2]=0;va=wa;ua=0;xa=oa;j:while(1){ya=(va|0)==0;za=ua;while(1){k:while(1){Aa=f[o>>2]|0;if(Aa>>>0<(f[q>>2]|0)>>>0){f[o>>2]=Aa+1;Ba=h[Aa>>0]|0}else Ba=lLa(a)|0;if(!(b[i+(Ba+1)>>0]|0))break j;b[k>>0]=Ba;switch(mMa(j,k,1,g)|0){case -1:{Y=va;Z=V;_=0;$=137;break b;break}case -2:break;default:break k}}if(ya)Ca=za;else{f[va+(za<<2)>>2]=f[j>>2];Ca=za+1|0}if(V&(Ca|0)==(xa|0))break;else za=Ca}ya=xa<<1|1;na=fKa(va,ya<<2)|0;if(!na){Y=va;Z=1;_=0;$=137;break b}else{I=xa;va=na;xa=ya;ua=I}}if(!(nMa(g)|0)){Y=va;Z=V;_=0;$=137;break b}else{Da=va;Ea=za;Fa=0;Ga=va}}else{if(V){ua=dKa(oa)|0;if(!ua){Y=0;Z=1;_=0;$=137;break b}else{Ha=0;Ia=oa;Ja=ua}while(1){ua=Ha;do{xa=f[o>>2]|0;if(xa>>>0<(f[q>>2]|0)>>>0){f[o>>2]=xa+1;Ka=h[xa>>0]|0}else Ka=lLa(a)|0;if(!(b[i+(Ka+1)>>0]|0)){Da=0;Ea=ua;Fa=Ja;Ga=0;break i}b[Ja+ua>>0]=Ka;ua=ua+1|0}while((ua|0)!=(Ia|0));ua=Ia<<1|1;xa=fKa(Ja,ua)|0;if(!xa){Y=0;Z=1;_=Ja;$=137;break b}else{I=Ia;Ia=ua;Ja=xa;Ha=I}}}if(!L){va=ka;while(1){I=f[o>>2]|0;if(I>>>0<va>>>0){f[o>>2]=I+1;La=h[I>>0]|0}else La=lLa(a)|0;if(!(b[i+(La+1)>>0]|0)){Da=0;Ea=0;Fa=0;Ga=0;break i}va=f[q>>2]|0}}else{va=ka;I=0;while(1){xa=f[o>>2]|0;if(xa>>>0<va>>>0){f[o>>2]=xa+1;Ma=h[xa>>0]|0}else Ma=lLa(a)|0;if(!(b[i+(Ma+1)>>0]|0)){Da=0;Ea=I;Fa=L;Ga=0;break i}b[L+I>>0]=Ma;va=f[q>>2]|0;I=I+1|0}}}while(0);if(!(f[q>>2]|0))Na=f[o>>2]|0;else{oa=(f[o>>2]|0)+-1|0;f[o>>2]=oa;Na=oa}oa=Na-(f[s>>2]|0)+(f[r>>2]|0)|0;if(!oa){Oa=Da;Pa=Fa;$=139;break b}if(!((oa|0)==(ba|0)|ha^1)){Oa=Da;Pa=Fa;$=139;break b}do if(V)if(ma){f[L>>2]=Ga;break}else{f[L>>2]=Fa;break}while(0);if(ha){Qa=Da;Ra=la;Sa=Fa}else{if(Ga|0)f[Ga+(Ea<<2)>>2]=0;if(!Fa){Qa=Da;Ra=la;Sa=0;break f}b[Fa+Ea>>0]=0;Qa=Da;Ra=la;Sa=Fa}break}case 120:case 88:case 112:{Ta=16;$=125;break}case 111:{Ta=8;$=125;break}case 117:case 100:{Ta=10;$=125;break}case 105:{Ta=0;$=125;break}case 71:case 103:case 70:case 102:case 69:case 101:case 65:case 97:{Ua=+XLa(a,Q,0);if((f[r>>2]|0)==((f[s>>2]|0)-(f[o>>2]|0)|0)){Oa=P;Pa=O;$=139;break b}if(!L){Qa=P;Ra=W;Sa=O}else switch(Q|0){case 0:{n[L>>2]=Ua;Qa=P;Ra=W;Sa=O;break f;break}case 1:{p[L>>3]=Ua;Qa=P;Ra=W;Sa=O;break f;break}case 2:{p[L>>3]=Ua;Qa=P;Ra=W;Sa=O;break f;break}default:{Qa=P;Ra=W;Sa=O;break f}}break}default:{Qa=P;Ra=W;Sa=O}}while(0);do if(($|0)==125){$=0;N=kLa(a,Ta,0,-1,-1)|0;if((f[r>>2]|0)==((f[s>>2]|0)-(f[o>>2]|0)|0)){Oa=P;Pa=O;$=139;break b}if(K&(R|0)==112){f[L>>2]=N;Qa=P;Ra=W;Sa=O;break}else{lMa(L,Q,N,J);Qa=P;Ra=W;Sa=O;break}}while(0);ca=Qa;da=(K&1)+D|0;ea=Ra;fa=(f[r>>2]|0)+aa+(f[o>>2]|0)-(f[s>>2]|0)|0;ga=Sa;break c}while(0);O=E+(H&1)|0;jLa(a,0);P=f[o>>2]|0;if(P>>>0<(f[q>>2]|0)>>>0){f[o>>2]=P+1;Va=h[P>>0]|0}else Va=lLa(a)|0;if((Va|0)!=(h[O>>0]|0)){$=22;break b}ca=B;da=D;ea=O;fa=F+1|0;ga=G}else{O=E;while(1){P=O+1|0;if(!(mLa(h[P>>0]|0)|0))break;else O=P}jLa(a,0);do{H=f[o>>2]|0;if(H>>>0<(f[q>>2]|0)>>>0){f[o>>2]=H+1;Wa=h[H>>0]|0}else Wa=lLa(a)|0}while((mLa(Wa)|0)!=0);if(!(f[q>>2]|0))Xa=f[o>>2]|0;else{H=(f[o>>2]|0)+-1|0;f[o>>2]=H;Xa=H}ca=B;da=D;ea=O;fa=(f[r>>2]|0)+F+Xa-(f[s>>2]|0)|0;ga=G}while(0);E=ea+1|0;C=b[E>>0]|0;if(!(C<<24>>24)){Ya=da;break a}else{B=ca;D=da;F=fa;G=ga}}if(($|0)==22){if(f[q>>2]|0)f[o>>2]=(f[o>>2]|0)+-1;if((D|0)!=0|(Va|0)>-1){Ya=D;break}else{Za=B;_a=0;$a=G;$=138}}else if(($|0)==137){F=Z&1;if(!D){Za=Y;_a=F;$a=_;$=138}else{ab=Y;bb=F;cb=D;db=_}}else if(($|0)==139){ab=Oa;bb=V&1;cb=D;db=Pa}if(($|0)==138){ab=Za;bb=_a;cb=-1;db=$a}if(!bb)Ya=cb;else{eKa(db);eKa(ab);Ya=cb}}else Ya=0;while(0);if(l|0)uLa(a);u=e;return Ya|0}function kMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[d>>2]=f[a>>2];a=b;while(1){b=(f[d>>2]|0)+(4-1)&~(4-1);e=f[b>>2]|0;f[d>>2]=b+4;if(a>>>0>1)a=a+-1|0;else break}u=c;return e|0}function lMa(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0;a:do if(a|0)switch(c|0){case -2:{b[a>>0]=e;break a;break}case -1:{d[a>>1]=e;break a;break}case 0:{f[a>>2]=e;break a;break}case 1:{f[a>>2]=e;break a;break}case 3:{h=a;f[h>>2]=e;f[h+4>>2]=g;break a;break}default:break a}while(0);return}function mMa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+16|0;h=g;i=(e|0)==0?1974096:e;e=f[i>>2]|0;a:do if(!c)if(!e)j=0;else k=17;else{l=(a|0)==0?h:a;if(!d)j=-2;else{if(!e){m=b[c>>0]|0;if(m<<24>>24>-1){f[l>>2]=m&255;j=m<<24>>24!=0&1;break}m=(oMa()|0)+188|0;n=b[c>>0]|0;if(!(f[f[m>>2]>>2]|0)){f[l>>2]=n<<24>>24&57343;j=1;break}m=(n&255)+-194|0;if(m>>>0>50){k=17;break}n=f[123492+(m<<2)>>2]|0;m=d+-1|0;if(!m)o=n;else{p=n;q=m;r=c+1|0;k=11}}else{p=e;q=d;r=c;k=11}b:do if((k|0)==11){m=b[r>>0]|0;n=(m&255)>>>3;if((n+-16|n+(p>>26))>>>0>7){k=17;break a}else{s=m;t=p;v=q;w=r}while(1){w=w+1|0;t=(s&255)+-128|t<<6;v=v+-1|0;if((t|0)>=0)break;if(!v){o=t;break b}s=b[w>>0]|0;if((s&-64)<<24>>24!=-128){k=17;break a}}f[i>>2]=0;f[l>>2]=t;j=d-v|0;break a}while(0);f[i>>2]=o;j=-2}}while(0);if((k|0)==17){f[i>>2]=0;i=pKa()|0;f[i>>2]=84;j=-1}u=g;return j|0}function nMa(a){a=a|0;var b=0;if(!a)b=1;else b=(f[a>>2]|0)==0;return b&1|0}function oMa(){return rKa()|0}function pMa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;a:do if(!c)i=0;else{do if(d|0){j=(a|0)==0?g:a;k=b[c>>0]|0;if(k<<24>>24>-1){f[j>>2]=k&255;i=k<<24>>24!=0&1;break a}k=(qMa()|0)+188|0;l=b[c>>0]|0;if(!(f[f[k>>2]>>2]|0)){f[j>>2]=l<<24>>24&57343;i=1;break a}k=(l&255)+-194|0;if(k>>>0<=50){l=c+1|0;m=f[123492+(k<<2)>>2]|0;if(d>>>0<4?m&-2147483648>>>((d*6|0)+-6|0)|0:0)break;k=h[l>>0]|0;l=k>>>3;if((l+-16|l+(m>>26))>>>0<=7){l=k+-128|m<<6;if((l|0)>=0){f[j>>2]=l;i=2;break a}m=(h[c+2>>0]|0)+-128|0;if(m>>>0<=63){k=m|l<<6;if((k|0)>=0){f[j>>2]=k;i=3;break a}l=(h[c+3>>0]|0)+-128|0;if(l>>>0<=63){f[j>>2]=l|k<<6;i=4;break a}}}}}while(0);k=pKa()|0;f[k>>2]=84;i=-1}while(0);u=e;return i|0}function qMa(){return rKa()|0}function rMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d;g=c&255;b[e>>0]=g;i=a+16|0;j=f[i>>2]|0;if(!j)if(!(KLa(a)|0)){k=f[i>>2]|0;l=4}else m=-1;else{k=j;l=4}do if((l|0)==4){j=a+20|0;i=f[j>>2]|0;if(i>>>0<k>>>0?(n=c&255,(n|0)!=(b[a+75>>0]|0)):0){f[j>>2]=i+1;b[i>>0]=g;m=n;break}if((ui[f[a+36>>2]&127](a,e,1)|0)==1)m=h[e>>0]|0;else m=-1}while(0);u=d;return m|0}function sMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[e>>2]=f[c>>2];g=qLa(0,0,b,e)|0;if((g|0)>=0?(e=g+1|0,g=dKa(e)|0,f[a>>2]=g,(g|0)!=0):0)h=qLa(g,e,b,c)|0;else h=-1;u=d;return h|0}function tMa(){ef(1974100);return 1974108}function uMa(a){a=a|0;var b=0;if((f[a+76>>2]|0)>-1){b=(tLa(a)|0)==0;vMa(a,0,0)|0;f[a>>2]=f[a>>2]&-33;if(!b)uLa(a)}else{vMa(a,0,0)|0;f[a>>2]=f[a>>2]&-33}return}function vMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;if((c|0)==1)d=b-(f[a+8>>2]|0)+(f[a+4>>2]|0)|0;else d=b;b=a+20|0;e=a+28|0;if((f[b>>2]|0)>>>0>(f[e>>2]|0)>>>0?(ui[f[a+36>>2]&127](a,0,0)|0,(f[b>>2]|0)==0):0)g=-1;else{f[a+16>>2]=0;f[e>>2]=0;f[b>>2]=0;if((ui[f[a+40>>2]&127](a,d,c)|0)<0)g=-1;else{f[a+8>>2]=0;f[a+4>>2]=0;f[a>>2]=f[a>>2]&-17;g=0}}return g|0}function wMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+84|0;e=f[d>>2]|0;g=c+256|0;h=BKa(e,0,g)|0;i=(h|0)==0?g:h-e|0;h=i>>>0<c>>>0?i:c;K1a(b|0,e|0,h|0)|0;f[a+4>>2]=e+h;b=e+i|0;f[a+8>>2]=b;f[d>>2]=b;return h|0}function xMa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=Y(c,b)|0;g=(b|0)==0?0:c;if((f[d+76>>2]|0)>-1){c=(tLa(d)|0)==0;h=JLa(a,e,d)|0;if(c)i=h;else{uLa(d);i=h}}else i=JLa(a,e,d)|0;if((i|0)==(e|0))j=g;else j=(i>>>0)/(b>>>0)|0;return j|0}function yMa(a){a=a|0;var b=0,c=0,d=0;if((f[a+76>>2]|0)>-1){b=(tLa(a)|0)==0;c=(f[a>>2]|0)>>>4&1;if(b)d=c;else d=c}else d=(f[a>>2]|0)>>>4&1;return d|0}function zMa(a){a=a|0;var b=0,c=0;b=tMa()|0;f[a+56>>2]=f[b>>2];c=f[b>>2]|0;if(c|0)f[c+52>>2]=a;f[b>>2]=a;AMa();return a|0}function AMa(){If(1974100);return}function BMa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+16|0;g=e;a:do if(!a){h=f[c>>2]|0;i=f[h>>2]|0;if(!i)j=0;else{k=i;i=0;l=h;while(1){if(k>>>0>127){h=HLa(g,k,0)|0;if((h|0)==-1){j=-1;break a}else m=h}else m=1;h=m+i|0;l=l+4|0;k=f[l>>2]|0;if(!k){j=h;break}else i=h}}}else{b:do if(d>>>0>3){i=f[c>>2]|0;k=d;l=a;while(1){h=f[i>>2]|0;if((h+-1|0)>>>0>126){if(!h)break;n=HLa(l,h,0)|0;if((n|0)==-1){j=-1;break a}o=i;p=k-n|0;q=l+n|0}else{b[l>>0]=h;o=f[c>>2]|0;p=k+-1|0;q=l+1|0}i=o+4|0;f[c>>2]=i;if(p>>>0<=3){r=p;s=q;break b}else{k=p;l=q}}b[l>>0]=0;f[c>>2]=0;j=d-k|0;break a}else{r=d;s=a}while(0);if(r){i=f[c>>2]|0;h=r;n=s;while(1){t=f[i>>2]|0;if((t+-1|0)>>>0>126){if(!t){v=19;break}w=HLa(g,t,0)|0;if((w|0)==-1){j=-1;break a}if(h>>>0<w>>>0){v=22;break}HLa(n,f[i>>2]|0,0)|0;x=i;y=h-w|0;z=n+w|0}else{b[n>>0]=t;x=f[c>>2]|0;y=h+-1|0;z=n+1|0}i=x+4|0;f[c>>2]=i;if(!y){j=d;break a}else{h=y;n=z}}if((v|0)==19){b[n>>0]=0;f[c>>2]=0;j=d-h|0;break}else if((v|0)==22){j=d-h|0;break}}else j=d}while(0);u=e;return j|0}function CMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;do if((a|0)!=-1){if((f[c+76>>2]|0)>-1)d=tLa(c)|0;else d=0;e=c+4|0;g=f[e>>2]|0;if(!g){oLa(c)|0;h=f[e>>2]|0;i=(d|0)!=0;if(!h)j=i;else{k=h;l=i;m=7}}else{k=g;l=(d|0)!=0;m=7}if((m|0)==7)if(k>>>0>((f[c+44>>2]|0)+-8|0)>>>0){g=k+-1|0;f[e>>2]=g;b[g>>0]=a;f[c>>2]=f[c>>2]&-17;if(!l){n=a;break}uLa(c);n=a;break}else j=l;if(j){uLa(c);n=-1}else n=-1}else n=-1;while(0);return n|0}function DMa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+16|0;c=b+8|0;d=b;e=a;f[d>>2]=e;a=ke(10,d|0)|0;if((a|0)==-21){f[c>>2]=e;g=jf(40,c|0)|0}else g=a;a=oKa(g)|0;u=b;return a|0}function EMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a&255;e=a&255;if((f[c+76>>2]|0)>=0?(tLa(c)|0)!=0:0){if((e|0)!=(b[c+75>>0]|0)?(g=c+20|0,h=f[g>>2]|0,h>>>0<(f[c+16>>2]|0)>>>0):0){f[g>>2]=h+1;b[h>>0]=d;i=e}else i=rMa(c,a)|0;uLa(c);j=i}else k=3;do if((k|0)==3){if((e|0)!=(b[c+75>>0]|0)?(i=c+20|0,h=f[i>>2]|0,h>>>0<(f[c+16>>2]|0)>>>0):0){f[i>>2]=h+1;b[h>>0]=d;j=e;break}j=rMa(c,a)|0}while(0);return j|0}function FMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;if((f[a+76>>2]|0)>-1){d=(tLa(a)|0)==0;e=vMa(a,b,c)|0;if(d)g=e;else{uLa(a);g=e}}else g=vMa(a,b,c)|0;return g|0}function GMa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;if((f[a+76>>2]|0)>-1)b=tLa(a)|0;else b=0;HMa(a);c=(f[a>>2]&1|0)!=0;if(!c){d=tMa()|0;e=f[a+52>>2]|0;g=a+56|0;if(e|0)f[e+56>>2]=f[g>>2];h=f[g>>2]|0;if(h|0)f[h+52>>2]=e;if((f[d>>2]|0)==(a|0))f[d>>2]=h;AMa()}h=IMa(a)|0;d=mi[f[a+12>>2]&255](a)|0|h;h=f[a+92>>2]|0;if(h|0)eKa(h);if(c){if(b|0)uLa(a)}else eKa(a);return d|0}function HMa(a){a=a|0;var b=0,c=0,d=0;if(f[a+68>>2]|0){b=f[a+116>>2]|0;c=a+112|0;if(b|0)f[b+112>>2]=f[c>>2];a=f[c>>2]|0;if(!a)d=(KMa()|0)+232|0;else d=a+116|0;f[d>>2]=b}return}function IMa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;do if(a){if((f[a+76>>2]|0)<=-1){b=JMa(a)|0;break}c=(tLa(a)|0)==0;d=JMa(a)|0;if(c)b=d;else{uLa(a);b=d}}else{if(!(f[30808]|0))e=0;else e=IMa(f[30808]|0)|0;d=tMa()|0;c=f[d>>2]|0;if(!c)g=e;else{d=c;c=e;while(1){if((f[d+76>>2]|0)>-1)h=tLa(d)|0;else h=0;if((f[d+20>>2]|0)>>>0>(f[d+28>>2]|0)>>>0)i=JMa(d)|0|c;else i=c;if(h|0)uLa(d);d=f[d+56>>2]|0;if(!d){g=i;break}else c=i}}AMa();b=g}while(0);return b|0}function JMa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=a+20|0;c=a+28|0;if((f[b>>2]|0)>>>0>(f[c>>2]|0)>>>0?(ui[f[a+36>>2]&127](a,0,0)|0,(f[b>>2]|0)==0):0)d=-1;else{e=a+4|0;g=f[e>>2]|0;h=a+8|0;i=f[h>>2]|0;if(g>>>0<i>>>0)ui[f[a+40>>2]&127](a,g-i|0,1)|0;f[a+16>>2]=0;f[c>>2]=0;f[b>>2]=0;f[h>>2]=0;f[e>>2]=0;d=0}return d|0}function KMa(){return rKa()|0}function LMa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;if((f[a+76>>2]|0)>=0?(tLa(a)|0)!=0:0){b=a+4|0;c=f[b>>2]|0;if(c>>>0<(f[a+8>>2]|0)>>>0){f[b>>2]=c+1;d=h[c>>0]|0}else d=nLa(a)|0;e=d}else g=3;do if((g|0)==3){d=a+4|0;c=f[d>>2]|0;if(c>>>0<(f[a+8>>2]|0)>>>0){f[d>>2]=c+1;e=h[c>>0]|0;break}else{e=nLa(a)|0;break}}while(0);return e|0}function MMa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=Y(d,c)|0;h=(c|0)==0?0:d;if((f[e+76>>2]|0)>-1)i=tLa(e)|0;else i=0;d=e+74|0;j=b[d>>0]|0;b[d>>0]=j+255|j;j=e+4|0;d=f[j>>2]|0;k=(f[e+8>>2]|0)-d|0;l=k>>>0<g>>>0?k:g;if((k|0)>0){K1a(a|0,d|0,l|0)|0;f[j>>2]=d+l;m=a+l|0;n=g-l|0}else{m=a;n=g}a:do if(!n)o=13;else{a=e+32|0;l=m;d=n;while(1){if(oLa(e)|0)break;j=ui[f[a>>2]&127](e,l,d)|0;if((j+1|0)>>>0<2)break;k=d-j|0;if(!k){o=13;break a}else{l=l+j|0;d=k}}if(i|0)uLa(e);p=((g-d|0)>>>0)/(c>>>0)|0}while(0);if((o|0)==13)if(!i)p=h;else{uLa(e);p=h}return p|0}function NMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;if(BKa(369377,b[c>>0]|0,4)|0){i=OMa(c)|0;f[h>>2]=a;f[h+4>>2]=i|32768;f[h+8>>2]=438;a=oKa(qe(5,h|0)|0)|0;if((a|0)>=0){if(i&524288|0){f[g>>2]=a;f[g+4>>2]=2;f[g+8>>2]=1;bd(221,g|0)|0}g=PMa(a,c)|0;if(!g){f[e>>2]=a;pe(6,e|0)|0;j=0}else j=g}else j=0}else{g=pKa()|0;f[g>>2]=22;j=0}u=d;return j|0}function OMa(a){a=a|0;var c=0,d=0,e=0,f=0;c=(TKa(a,43)|0)==0;d=b[a>>0]|0;e=c?d<<24>>24!=114&1:2;c=(TKa(a,120)|0)==0;f=c?e:e|128;e=(TKa(a,101)|0)==0;a=e?f:f|524288;f=d<<24>>24==114?a:a|64;a=d<<24>>24==119?f|512:f;return (d<<24>>24==97?a|1024:a)|0}function PMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+64|0;e=d+40|0;g=d+24|0;h=d+16|0;i=d;j=d+56|0;k=b[c>>0]|0;if(BKa(369377,k<<24>>24,4)|0){l=dKa(1156)|0;if(!l)m=0;else{n=l;o=n+124|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));if(!(TKa(c,43)|0))f[l>>2]=k<<24>>24==114?8:4;if(!(TKa(c,101)|0))p=k;else{f[i>>2]=a;f[i+4>>2]=2;f[i+8>>2]=1;bd(221,i|0)|0;p=b[c>>0]|0}if(p<<24>>24==97){f[h>>2]=a;f[h+4>>2]=3;p=bd(221,h|0)|0;if(!(p&1024)){f[g>>2]=a;f[g+4>>2]=4;f[g+8>>2]=p|1024;bd(221,g|0)|0}g=f[l>>2]|128;f[l>>2]=g;q=g}else q=f[l>>2]|0;f[l+60>>2]=a;f[l+44>>2]=l+132;f[l+48>>2]=1024;g=l+75|0;b[g>>0]=-1;if((q&8|0)==0?(f[e>>2]=a,f[e+4>>2]=21523,f[e+8>>2]=j,(ze(54,e|0)|0)==0):0)b[g>>0]=10;f[l+32>>2]=21;f[l+36>>2]=20;f[l+40>>2]=19;f[l+12>>2]=63;if(!(f[493503]|0))f[l+76>>2]=-1;zMa(l)|0;m=l}}else{l=pKa()|0;f[l>>2]=22;m=0}u=d;return m|0}function QMa(a){a=a|0;var b=0,c=0,d=0;if((f[a+76>>2]|0)>-1){b=(tLa(a)|0)==0;c=(f[a>>2]|0)>>>5&1;if(b)d=c;else d=c}else d=(f[a>>2]|0)>>>5&1;return d|0}function RMa(a,b,c){a=a|0;b=b|0;c=c|0;return FMa(a,b,c)|0}function SMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=c;c=TMa(a,b,e)|0;u=d;return c|0}function TMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+128|0;e=d;g=e;h=g+124|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e+32>>2]=106;f[e+44>>2]=a;f[e+76>>2]=-1;f[e+84>>2]=a;a=jMa(e,b,c)|0;u=d;return a|0}function UMa(a,b,c){a=a|0;b=b|0;c=c|0;return wMa(a,b,c)|0}function VMa(a,b){a=a|0;b=b|0;var c=0;c=xKa(a)|0;return ((xMa(a,1,c,b)|0)!=(c|0))<<31>>31|0}function WMa(){var a=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+48|0;c=a+24|0;d=a+16|0;e=a;g=a+28|0;h=g;i=369381;j=h+20|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));i=g+13|0;h=g;g=0;while(1){zKa(i)|0;f[e>>2]=h;f[e+4>>2]=32962;f[e+8>>2]=384;k=oKa(qe(5,e|0)|0)|0;g=g+1|0;if((k|0)>-1){l=4;break}if((g|0)>=100){m=0;break}}if((l|0)==4){f[d>>2]=h;ke(10,d|0)|0;d=PMa(k,369401)|0;if(!d){f[c>>2]=k;pe(6,c|0)|0;m=0}else m=d}u=a;return m|0}function XMa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+1040|0;h=g+8|0;i=g;j=f[b>>2]|0;f[i>>2]=j;k=(a|0)!=0;l=k?d:256;d=k?a:h;a=j;a:do if((l|0)!=0&(j|0)!=0){m=a;n=0;o=c;p=l;q=d;while(1){r=o>>>2;s=r>>>0>=p>>>0;if(!(o>>>0>131|s)){t=m;v=n;w=o;x=p;y=q;break a}z=s?p:r;A=o-z|0;r=PLa(q,i,z,e)|0;if((r|0)==-1)break;z=(q|0)==(h|0);s=p-(z?0:r)|0;B=z?q:q+(r<<2)|0;z=r+n|0;r=f[i>>2]|0;if((s|0)!=0&(r|0)!=0){m=r;n=z;o=A;p=s;q=B}else{t=r;v=z;w=A;x=s;y=B;break a}}t=f[i>>2]|0;v=-1;w=A;x=0;y=q}else{t=a;v=0;w=c;x=l;y=d}while(0);b:do if((t|0)!=0?(x|0)!=0&(w|0)!=0:0){d=t;l=v;c=w;a=x;A=y;while(1){C=mMa(A,d,c,e)|0;if((C+2|0)>>>0<3)break;d=(f[i>>2]|0)+C|0;f[i>>2]=d;c=c-C|0;a=a+-1|0;h=l+1|0;if(!((a|0)!=0&(c|0)!=0)){D=h;break b}else{l=h;A=A+4|0}}switch(C|0){case -1:{D=-1;break b;break}case 0:{f[i>>2]=0;D=l;break b;break}default:{f[e>>2]=0;D=l;break b}}}else D=v;while(0);if(k)f[b>>2]=f[i>>2];u=g;return D|0}function YMa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+272|0;g=e+8|0;h=e;i=f[b>>2]|0;f[h>>2]=i;j=(a|0)!=0;k=j?d:256;d=j?a:g;a=i;a:do if((k|0)!=0&(i|0)!=0){l=a;m=0;n=k;o=d;p=c;while(1){q=p>>>0>=n>>>0;if(!(q|p>>>0>32)){r=l;s=m;t=n;v=o;w=p;break a}x=q?n:p;y=p-x|0;q=BMa(o,h,x,0)|0;if((q|0)==-1)break;x=(o|0)==(g|0);z=n-(x?0:q)|0;A=x?o:o+q|0;x=q+m|0;q=f[h>>2]|0;if((z|0)!=0&(q|0)!=0){l=q;m=x;n=z;o=A;p=y}else{r=q;s=x;t=z;v=A;w=y;break a}}r=f[h>>2]|0;s=-1;t=0;v=o;w=y}else{r=a;s=0;t=k;v=d;w=c}while(0);b:do if((r|0)!=0?(t|0)!=0&(w|0)!=0:0){c=r;d=s;k=t;a=v;y=w;while(1){B=HLa(a,f[c>>2]|0,0)|0;if((B+1|0)>>>0<2)break;c=(f[h>>2]|0)+4|0;f[h>>2]=c;y=y+-1|0;k=k-B|0;g=B+d|0;if(!((k|0)!=0&(y|0)!=0)){C=g;break b}else{d=g;a=a+B|0}}if(!B){f[h>>2]=0;C=d}else C=-1}else C=s;while(0);if(j)f[b>>2]=f[h>>2];u=e;return C|0}function ZMa(a,b,c){a=a|0;b=b|0;c=c|0;return mMa(0,a,b,c|0?c:1974112)|0}function _Ma(){return 123932}function $Ma(a){a=a|0;return (a+-97|0)>>>0<26|0}function aNa(){var a=0;a=(bNa()|0)+188|0;return (f[f[a>>2]>>2]|0?4:1)|0}function bNa(){return rKa()|0}function cNa(){return 125472}function dNa(a){a=a|0;var b=0;b=($Ma(a)|0)==0;return (b?a:a&95)|0}function eNa(){return 125476}function fNa(a){a=a|0;return ((a+-48|0)>>>0<10|((a|32)+-97|0)>>>0<6)&1|0}function gNa(a){a=a|0;return 0}function hNa(a){a=a|0;return 0}function iNa(a,b){a=a|0;b=b|0;return +(+jNa(a,b,1))}function jNa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0.0;d=u;u=u+128|0;e=d;g=e;h=g+124|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=e+4|0;f[g>>2]=a;h=e+8|0;f[h>>2]=-1;f[e+44>>2]=a;f[e+76>>2]=-1;jLa(e,0);i=+XLa(e,c,1);c=(f[g>>2]|0)-(f[h>>2]|0)+(f[e+108>>2]|0)|0;if(b|0)f[b>>2]=c|0?a+c|0:a;u=d;return +i}function kNa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=iLa(a,b,c,0,-2147483648)|0;return d|0}function lNa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=iLa(a,b,c,-2147483648,0)|0;return d|0}function mNa(a,b){a=a|0;b=b|0;return +(+jNa(a,b,0))}function nNa(a,b){a=a|0;b=b|0;return +(+jNa(a,b,2))}function oNa(a,b,c){a=a|0;b=b|0;c=c|0;return +(+mNa(a,b))}function pNa(a,b,c){a=a|0;b=b|0;c=c|0;return +(+iNa(a,b))}function qNa(a,b,c){a=a|0;b=b|0;c=c|0;return +(+nNa(a,b))}function rNa(a){a=+a;var b=0,c=0.0;b=hNa(32)|0;c=+sNa(a);return ~~c|0}function sNa(a){a=+a;var b=0,c=0,d=0.0,e=0.0;p[s>>3]=a;b=f[s+4>>2]|0;c=b&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){c=(b|0)<0;d=(c?4503599627370496.0:-4503599627370496.0)+((c?-4503599627370496.0:4503599627370496.0)+a);if(d==0.0)e=c?-0.0:0.0;else e=d}else e=a;return +e}function tNa(a,b){a=+a;b=b|0;return +(+$La(a,b))}function uNa(a){a=+a;var b=0,c=0,d=0,e=0.0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0,r=0.0,t=0.0;p[s>>3]=a;b=f[s>>2]|0;c=f[s+4>>2]|0;d=(c|0)<0;do if(d|c>>>0<1048576){if((b|0)==0&(c&2147483647|0)==0){e=-1.0/(a*a);break}if(d){e=(a-a)/0.0;break}else{p[s>>3]=a*18014398509481984.0;g=f[s+4>>2]|0;h=f[s>>2]|0;i=g;j=g;k=-1077;l=9;break}}else if(c>>>0<=2146435071)if((b|0)==0&0==0&(c|0)==1072693248)e=0.0;else{h=b;i=c;j=c;k=-1023;l=9}else e=a;while(0);if((l|0)==9){l=j+614242|0;f[s>>2]=h;f[s+4>>2]=(l&1048575)+1072079006;a=+p[s>>3]+-1.0;m=a*(a*.5);n=a/(a+2.0);o=n*n;q=o*o;p[s>>3]=a-m;h=f[s+4>>2]|0;f[s>>2]=0;f[s+4>>2]=h;r=+p[s>>3];t=a-r-m+n*(m+(q*(q*(q*.15313837699209373+.22222198432149784)+.3999999999940942)+o*(q*(q*(q*.14798198605116586+.1818357216161805)+.2857142874366239)+.6666666666666735)));q=r*.4342944818781689;o=+(k+(l>>>20)|0);m=o*.30102999566361177;n=m+q;e=n+(q+(m-n)+(t*.4342944818781689+(o*3.694239077158931e-13+(r+t)*2.5082946711645275e-11)))}return +e}function vNa(a){a=+a;var b=0,c=0,d=0.0,e=0.0;b=(n[s>>2]=a,f[s>>2]|0);if((b&2130706432)>>>0<=1249902592){c=(b|0)<0;d=(c?8388608.0:-8388608.0)+((c?-8388608.0:8388608.0)+a);if(d==0.0)e=c?-0.0:0.0;else e=d}else e=a;return +e}function wNa(a){a=+a;return ~~+vNa(a)|0}function xNa(a,b){a=+a;b=b|0;var c=0,d=0,e=0.0,g=0,h=0.0,i=0.0;c=(n[s>>2]=a,f[s>>2]|0);d=c>>>23;switch((d&255)<<24>>24){case 0:{if(a!=0.0){e=+xNa(a*18446744073709551616.0,b);g=(f[b>>2]|0)+-64|0;h=e}else{g=0;h=a}f[b>>2]=g;i=h;break}case -1:{i=a;break}default:{f[b>>2]=(d&255)+-126;i=(f[s>>2]=c&-2139095041|1056964608,+n[s>>2])}}return +i}function yNa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=hLa(a,b,c)|0;return d|0}function zNa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=kNa(a,b,c)|0;return d|0}function ANa(a){a=a|0;var b=0,c=0;b=(BNa()|0)+188|0;c=f[b>>2]|0;if(a|0)f[b>>2]=(a|0)==(-1|0)?1974048:a;return ((c|0)==1974048?-1:c)|0}function BNa(){return rKa()|0}function CNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+272|0;e=d+8|0;g=d;do if(!(b[c>>0]|0)){h=Me(369404)|0;if(h|0?b[h>>0]|0:0){i=h;break}h=Me(369411+(a*12|0)|0)|0;if(h|0?b[h>>0]|0:0){i=h;break}h=Me(369483)|0;if(h|0?b[h>>0]|0:0){i=h;break}i=369488}else i=c;while(0);c=0;a:while(1){switch(b[i+c>>0]|0){case 47:case 0:{j=c;break a;break}default:{}}h=c+1|0;if(h>>>0<15)c=h;else{j=h;break}}c=b[i>>0]|0;if(c<<24>>24!=46?(b[i+j>>0]|0)==0:0)if(c<<24>>24==67){k=i;l=15}else{m=i;l=16}else{k=369488;l=15}if((l|0)==15)if(!(b[k+1>>0]|0)){n=k;l=18}else{m=k;l=16}b:do if((l|0)==16)if((KKa(m,369488)|0)!=0?(KKa(m,369496)|0)!=0:0){k=f[493529]|0;if(k|0){i=k;do{if(!(KKa(m,i+8|0)|0)){o=i;break b}i=f[i+24>>2]|0}while((i|0)!=0)}ef(1974120);i=f[493529]|0;c:do if(i|0){k=i;while(1){if(!(KKa(m,k+8|0)|0))break;c=f[k+24>>2]|0;if(!c)break c;else k=c}If(1974120);o=k;break b}while(0);d:do if(((f[493504]|0)==0?(i=Me(369502)|0,(i|0)!=0):0)?(b[i>>0]|0)!=0:0){c=254-j|0;h=j+1|0;p=i;while(1){i=YKa(p,58)|0;q=b[i>>0]|0;r=((q<<24>>24!=0)<<31>>31)+(i-p)|0;if(r>>>0<c>>>0){K1a(e|0,p|0,r|0)|0;s=e+r|0;b[s>>0]=47;K1a(s+1|0,m|0,j|0)|0;b[e+(h+r)>>0]=0;t=Uf(e|0,g|0)|0;if(t|0)break;v=b[i>>0]|0}else v=q;p=i+(v<<24>>24!=0&1)|0;if(!(b[p>>0]|0)){l=41;break d}}p=dKa(28)|0;h=f[g>>2]|0;if(!p){dLa(t,h)|0;l=41;break}else{f[p>>2]=t;f[p+4>>2]=h;h=p+8|0;K1a(h|0,m|0,j|0)|0;b[h+j>>0]=0;f[p+24>>2]=f[493529];f[493529]=p;w=p;break}}else l=41;while(0);if((l|0)==41){p=dKa(28)|0;if(!p)w=p;else{f[p>>2]=f[30924];f[p+4>>2]=f[30925];h=p+8|0;K1a(h|0,m|0,j|0)|0;b[h+j>>0]=0;f[p+24>>2]=f[493529];f[493529]=p;w=p}}If(1974120);o=(a|0)==0&(w|0)==0?123696:w}else{n=m;l=18}while(0);do if((l|0)==18){if((a|0)==0?(b[n+1>>0]|0)==46:0){o=123696;break}o=0}while(0);u=d;return o|0}function DNa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return d|0}function ENa(a){a=a|0;if(FNa(a)|0)eKa(a);return}function FNa(a){a=a|0;return (a|0)!=123744&((a|0)!=0&(a|0)!=1974072)&1|0}function GNa(a,b){a=a|0;b=b|0;return -1|0}function HNa(a,b){a=a|0;b=b|0;return fNa(a)|0}function INa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=d;a:do if(!(FNa(c)|0)){g=(c|0)==0;h=0;i=0;do{j=(1<<h&a|0)!=0;if(g|j)k=CNa(h,j?b:5694105)|0;else k=f[c+(h<<2)>>2]|0;i=((k|0)!=0&1)+i|0;f[e+(h<<2)>>2]=k;h=h+1|0}while((h|0)!=6);switch(i|0){case 0:{l=1974072;break a;break}case 1:{if((f[e>>2]|0)==123696){l=123744;break a}break}default:{}}l=c}else{h=0;do{if(1<<h&a|0){g=CNa(h,b)|0;f[c+(h<<2)>>2]=g}h=h+1|0}while((h|0)!=6);l=c}while(0);u=d;return l|0}function JNa(a,b){a=a|0;b=b|0;return (a+-48|0)>>>0<10|0}function KNa(a){a=a|0;return 0}function LNa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0;d=a;a=b;a:while(1){b=a;e=a+-8|0;f=d;while(1){g=f;b:while(1){h=g;i=b-h|0;j=i>>3;k=g+8|0;switch(j|0){case 1:case 0:{break a;break}case 2:{l=5;break a;break}case 3:{l=7;break a;break}case 4:{l=8;break a;break}case 5:{l=9;break a;break}default:{}}if((i|0)<248){l=11;break a}m=g+(((j|0)/2|0)<<3)|0;if((i|0)>7992){i=(j|0)/4|0;n=ONa(g,g+(i<<3)|0,m,m+(i<<3)|0,e,c)|0}else n=MNa(g,m,e,c)|0;o=+p[g>>3];q=+p[m>>3];if(o<q){r=e;s=n;break}else t=e;while(1){t=t+-8|0;if((g|0)==(t|0))break;u=+p[t>>3];if(u<q){l=28;break b}}q=+p[e>>3];if(o<q)v=k;else{i=k;while(1){if((i|0)==(e|0))break a;w=+p[i>>3];x=i+8|0;if(o<w)break;else i=x}p[i>>3]=q;p[e>>3]=w;v=x}if((v|0)==(e|0))break a;else{y=v;z=e}while(1){A=+p[g>>3];j=y;while(1){B=+p[j>>3];C=j+8|0;if(A<B){D=z;break}else j=C}do{D=D+-8|0;E=+p[D>>3]}while(A<E);if(j>>>0>=D>>>0){g=j;continue b}p[j>>3]=E;p[D>>3]=B;y=C;z=D}}if((l|0)==28){l=0;p[g>>3]=u;p[t>>3]=o;r=t;s=n+1|0}c:do if(k>>>0<r>>>0){i=k;F=r;G=m;H=s;while(1){q=+p[G>>3];I=i;while(1){J=+p[I>>3];K=I+8|0;if(J<q)I=K;else{L=F;break}}do{L=L+-8|0;M=+p[L>>3]}while(!(M<q));if(I>>>0>L>>>0){N=I;O=G;P=H;break c}p[I>>3]=M;p[L>>3]=J;i=K;F=L;G=(G|0)==(I|0)?L:G;H=H+1|0}}else{N=k;O=m;P=s}while(0);if((N|0)!=(O|0)?(q=+p[O>>3],A=+p[N>>3],q<A):0){p[N>>3]=q;p[O>>3]=A;Q=P+1|0}else Q=P;if(!Q){R=QNa(g,N,c)|0;H=N+8|0;if(QNa(H,a,c)|0){l=45;break}if(R){f=H;continue}else S=H}else S=N+8|0;H=N;if((H-h|0)>=(b-H|0)){l=44;break}LNa(g,N,c);f=S}if((l|0)==44){l=0;LNa(S,a,c);d=g;a=N;continue}else if((l|0)==45){l=0;if(R)break;else{d=g;a=N;continue}}}if((l|0)==5){J=+p[e>>3];M=+p[g>>3];if(J<M){p[g>>3]=J;p[e>>3]=M}}else if((l|0)==7)MNa(g,k,e,c)|0;else if((l|0)==8)NNa(g,k,g+16|0,e,c)|0;else if((l|0)==9)ONa(g,k,g+16|0,g+24|0,e,c)|0;else if((l|0)==11)PNa(g,a,c);return}function MNa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0.0,g=0.0,h=0,i=0.0,j=0.0;e=+p[b>>3];f=+p[a>>3];g=+p[c>>3];d=g<e;do if(e<f){if(d){p[a>>3]=g;p[c>>3]=f;h=1;break}p[a>>3]=e;p[b>>3]=f;i=+p[c>>3];if(i<f){p[b>>3]=i;p[c>>3]=f;h=2}else h=1}else if(d){p[b>>3]=g;p[c>>3]=e;i=+p[b>>3];j=+p[a>>3];if(i<j){p[a>>3]=i;p[b>>3]=j;h=2}else h=1}else h=0;while(0);return h|0}function NNa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0.0,h=0.0,i=0;f=MNa(a,b,c,e)|0;g=+p[d>>3];h=+p[c>>3];if(g<h){p[c>>3]=g;p[d>>3]=h;d=f+1|0;h=+p[c>>3];g=+p[b>>3];if(h<g){p[b>>3]=h;p[c>>3]=g;g=+p[b>>3];h=+p[a>>3];if(g<h){p[a>>3]=g;p[b>>3]=h;i=f+3|0}else i=f+2|0}else i=d}else i=f;return i|0}function ONa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0.0,j=0;g=NNa(a,b,c,d,f)|0;h=+p[e>>3];i=+p[d>>3];if(h<i){p[d>>3]=h;p[e>>3]=i;e=g+1|0;i=+p[d>>3];h=+p[c>>3];if(i<h){p[c>>3]=i;p[d>>3]=h;d=g+2|0;h=+p[c>>3];i=+p[b>>3];if(h<i){p[b>>3]=h;p[c>>3]=i;i=+p[b>>3];h=+p[a>>3];if(i<h){p[a>>3]=i;p[b>>3]=h;j=g+4|0}else j=g+3|0}else j=d}else j=e}else j=g;return j|0}function PNa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0.0,h=0.0,i=0,j=0,k=0,l=0;d=a+16|0;MNa(a,a+8|0,d,c)|0;c=a+24|0;e=d;while(1){if((c|0)==(b|0))break;f=+p[c>>3];g=+p[e>>3];if(f<g){h=g;d=c;i=e;while(1){p[d>>3]=h;if((i|0)==(a|0)){j=a;break}k=i+-8|0;h=+p[k>>3];if(!(f<h)){j=i;break}else{l=i;i=k;d=l}}p[j>>3]=f}d=c;c=c+8|0;e=d}return}function QNa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0;d=b+-8|0;e=a+8|0;f=a+16|0;switch(b-a>>3|0){case 1:case 0:{g=1;break}case 2:{h=+p[d>>3];i=+p[a>>3];if(h<i){p[a>>3]=h;p[d>>3]=i;g=1}else g=1;break}case 3:{MNa(a,e,d,c)|0;g=1;break}case 4:{NNa(a,e,f,d,c)|0;g=1;break}case 5:{ONa(a,e,f,a+24|0,d,c)|0;g=1;break}default:{MNa(a,e,f,c)|0;c=0;e=a+24|0;d=f;while(1){if((e|0)==(b|0)){j=1;k=0;break}i=+p[e>>3];h=+p[d>>3];if(i<h){l=h;f=e;m=d;while(1){p[f>>3]=l;if((m|0)==(a|0)){n=a;break}o=m+-8|0;l=+p[o>>3];if(!(i<l)){n=m;break}else{q=m;m=o;f=q}}p[n>>3]=i;f=c+1|0;if((f|0)==8){j=0;k=(e+8|0)==(b|0);break}else r=f}else r=c;f=e;c=r;e=e+8|0;d=f}g=k|j}}return g|0}function RNa(a){a=a|0;SNa(a);return}function SNa(a){a=a|0;f[a>>2]=127024;TNa(a,0);CQa(a+28|0);eKa(f[a+32>>2]|0);eKa(f[a+36>>2]|0);eKa(f[a+48>>2]|0);eKa(f[a+60>>2]|0);return}function TNa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+32|0;d=a+36|0;e=f[a+40>>2]|0;while(1){if(!e)break;g=e+-1|0;fi[f[(f[c>>2]|0)+(g<<2)>>2]&255](b,a,f[(f[d>>2]|0)+(g<<2)>>2]|0);e=g}return}function UNa(a){a=a|0;SNa(a);PYa(a);return}function VNa(a){a=a|0;SNa(a);return}function WNa(a){a=a|0;f[a>>2]=127040;CQa(a+4|0);return}function XNa(a){a=a|0;WNa(a);PYa(a);return}function YNa(a,b){a=a|0;b=b|0;return}function ZNa(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function _Na(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;g=a;f[g>>2]=0;f[g+4>>2]=0;g=a+8|0;f[g>>2]=-1;f[g+4>>2]=-1;return}function $Na(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=a;f[d>>2]=0;f[d+4>>2]=0;d=a+8|0;f[d>>2]=-1;f[d+4>>2]=-1;return}function aOa(a){a=a|0;return 0}function bOa(a){a=a|0;return 0}function cOa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;iOa()|0;e=a+12|0;g=a+16|0;h=0;i=c;while(1){if((h|0)>=(d|0))break;c=f[e>>2]|0;j=f[g>>2]|0;if(c>>>0<j>>>0){k=j-c|0;j=d-h|0;l=(j|0)<(k|0)?j:k;kOa(i,c,l)|0;f[e>>2]=(f[e>>2]|0)+l;h=l+h|0;i=i+l|0;continue}l=mi[f[(f[a>>2]|0)+40>>2]&255](a)|0;if((l|0)==-1)break;c=lOa(l)|0;b[i>>0]=c;h=h+1|0;i=i+1|0}return h|0}function dOa(a){a=a|0;return iOa()|0}function eOa(a){a=a|0;var c=0,d=0;c=mi[f[(f[a>>2]|0)+36>>2]&255](a)|0;if((c|0)==(iOa()|0))d=iOa()|0;else{c=a+12|0;a=f[c>>2]|0;f[c>>2]=a+1;d=jOa(b[a>>0]|0)|0}return d|0}function fOa(a,b){a=a|0;b=b|0;return iOa()|0}function gOa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=iOa()|0;g=a+24|0;h=a+28|0;i=0;j=c;while(1){if((i|0)>=(d|0))break;c=f[g>>2]|0;k=f[h>>2]|0;if(c>>>0<k>>>0){l=k-c|0;k=d-i|0;m=(k|0)<(l|0)?k:l;kOa(c,j,m)|0;f[g>>2]=(f[g>>2]|0)+m;i=m+i|0;j=j+m|0;continue}m=f[(f[a>>2]|0)+52>>2]|0;c=jOa(b[j>>0]|0)|0;if(($h[m&255](a,c)|0)==(e|0))break;i=i+1|0;j=j+1|0}return i|0}function hOa(a,b){a=a|0;b=b|0;return iOa()|0}function iOa(){return -1}function jOa(a){a=a|0;return a&255|0}function kOa(a,b,c){a=a|0;b=b|0;c=c|0;if(c|0)K1a(a|0,b|0,c|0)|0;return a|0}function lOa(a){a=a|0;return a&255|0}function mOa(a){a=a|0;f[a>>2]=127104;CQa(a+4|0);return}function nOa(a){a=a|0;mOa(a);PYa(a);return}function oOa(a,b){a=a|0;b=b|0;return}function pOa(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function qOa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;g=a;f[g>>2]=0;f[g+4>>2]=0;g=a+8|0;f[g>>2]=-1;f[g+4>>2]=-1;return}function rOa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=a;f[d>>2]=0;f[d+4>>2]=0;d=a+8|0;f[d>>2]=-1;f[d+4>>2]=-1;return}function sOa(a){a=a|0;return 0}function tOa(a){a=a|0;return 0}function uOa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;AOa()|0;d=a+12|0;e=a+16|0;g=0;h=b;while(1){if((g|0)>=(c|0))break;b=f[d>>2]|0;i=f[e>>2]|0;if(b>>>0<i>>>0){j=i-b>>2;i=c-g|0;k=(i|0)<(j|0)?i:j;COa(h,b,k)|0;f[d>>2]=(f[d>>2]|0)+(k<<2);g=k+g|0;h=h+(k<<2)|0;continue}k=mi[f[(f[a>>2]|0)+40>>2]&255](a)|0;if((k|0)==-1)break;b=DOa(k)|0;f[h>>2]=b;g=g+1|0;h=h+4|0}return g|0}function vOa(a){a=a|0;return AOa()|0}function wOa(a){a=a|0;var b=0,c=0;b=mi[f[(f[a>>2]|0)+36>>2]&255](a)|0;if((b|0)==(AOa()|0))c=AOa()|0;else{b=a+12|0;a=f[b>>2]|0;f[b>>2]=a+4;c=BOa(f[a>>2]|0)|0}return c|0}function xOa(a,b){a=a|0;b=b|0;return AOa()|0}function yOa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=AOa()|0;e=a+24|0;g=a+28|0;h=0;i=b;while(1){if((h|0)>=(c|0))break;b=f[e>>2]|0;j=f[g>>2]|0;if(b>>>0<j>>>0){k=j-b>>2;j=c-h|0;l=(j|0)<(k|0)?j:k;COa(b,i,l)|0;f[e>>2]=(f[e>>2]|0)+(l<<2);h=l+h|0;i=i+(l<<2)|0;continue}l=f[(f[a>>2]|0)+52>>2]|0;b=BOa(f[i>>2]|0)|0;if(($h[l&255](a,b)|0)==(d|0))break;h=h+1|0;i=i+4|0}return h|0}function zOa(a,b){a=a|0;b=b|0;return AOa()|0}function AOa(){return -1}function BOa(a){a=a|0;return a|0}function COa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(!c)d=a;else{MKa(a,b,c)|0;d=a}return d|0}function DOa(a){a=a|0;return a|0}function EOa(a){a=a|0;IOa(a,127200);RNa(a+8|0);return}function FOa(a){a=a|0;EOa(a);PYa(a);return}function GOa(a){a=a|0;EOa(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function HOa(a){a=a|0;FOa(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function IOa(a,b){a=a|0;b=b|0;return}function JOa(a){a=a|0;NOa(a,127248);VNa(a+8|0);return}function KOa(a){a=a|0;JOa(a);PYa(a);return}function LOa(a){a=a|0;JOa(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function MOa(a){a=a|0;KOa(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function NOa(a,b){a=a|0;b=b|0;return}function OOa(a){a=a|0;SOa(a,127296);RNa(a+4|0);return}function POa(a){a=a|0;OOa(a);PYa(a);return}function QOa(a){a=a|0;OOa(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function ROa(a){a=a|0;POa(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function SOa(a,b){a=a|0;b=b|0;return}function TOa(a){a=a|0;XOa(a,127344);VNa(a+4|0);return}function UOa(a){a=a|0;TOa(a);PYa(a);return}function VOa(a){a=a|0;TOa(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function WOa(a){a=a|0;UOa(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function XOa(a,b){a=a|0;b=b|0;return}function YOa(a){a=a|0;return xKa(a)|0}function ZOa(a,c){a=a|0;c=c|0;b[a>>0]=b[c>>0]|0;return}function _Oa(a,b){a=a|0;b=b|0;f[a+16>>2]=(f[a+24>>2]|0)==0|b;return}function $Oa(a,b){a=a|0;b=b|0;var c=0;f[a+24>>2]=b;f[a+16>>2]=(b|0)==0&1;f[a+20>>2]=0;f[a+4>>2]=4098;f[a+12>>2]=0;f[a+8>>2]=6;b=a+28|0;c=a+32|0;a=c+40|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(a|0));FYa(b);return}function aPa(a,b){a=a|0;b=b|0;return (a|0)==(b|0)|0}function bPa(a,b){a=a|0;b=b|0;DYa(a,b+28|0);return}function cPa(a,b){a=a|0;b=b|0;return (a|0)==(b|0)|0}function dPa(a,b){a=a|0;b=b|0;return a<<24>>24==b<<24>>24|0}function ePa(a){a=a|0;var b=0;f[a>>2]=127040;FYa(a+4|0);b=a+8|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;return}function fPa(a){a=a|0;var b=0;f[a>>2]=127104;FYa(a+4|0);b=a+8|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;return}function gPa(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=u;u=u+16|0;h=g;b[a>>0]=0;i=c+(f[(f[c>>2]|0)+-12>>2]|0)|0;j=f[i+16>>2]|0;if(!j){k=f[i+72>>2]|0;if(k|0)hPa(k)|0;do if(!e?(k=c+(f[(f[c>>2]|0)+-12>>2]|0)|0,f[k+4>>2]&4096|0):0){bPa(h,k);k=BQa(h,1975176)|0;CQa(h);l=f[c+(f[(f[c>>2]|0)+-12>>2]|0)+24>>2]|0;m=k+8|0;k=l;n=(l|0)==0;o=k+12|0;p=k+16|0;q=l;while(1){if(n){r=0;s=0;break}t=f[o>>2]|0;if((t|0)==(f[p>>2]|0))v=mi[f[(f[q>>2]|0)+36>>2]&255](k)|0;else v=jOa(b[t>>0]|0)|0;t=aPa(v,iOa()|0)|0;w=t?0:l;if(t){r=0;s=0;break}t=w;x=t+12|0;y=f[x>>2]|0;z=t+16|0;if((y|0)==(f[z>>2]|0))A=mi[f[(f[w>>2]|0)+36>>2]&255](t)|0;else A=jOa(b[y>>0]|0)|0;if((A&255)<<24>>24<=-1){r=t;s=l;break}if(!(d[(f[m>>2]|0)+(A<<24>>24<<1)>>1]&8192)){r=t;s=l;break}y=f[x>>2]|0;if((y|0)==(f[z>>2]|0)){mi[f[(f[w>>2]|0)+40>>2]&255](t)|0;continue}else{f[x>>2]=y+1;jOa(b[y>>0]|0)|0;continue}}if(s|0){l=f[r+12>>2]|0;if((l|0)==(f[r+16>>2]|0))B=mi[f[(f[s>>2]|0)+36>>2]&255](r)|0;else B=jOa(b[l>>0]|0)|0;if(!(aPa(B,iOa()|0)|0))break}l=c+(f[(f[c>>2]|0)+-12>>2]|0)|0;_Oa(l,f[l+16>>2]|6)}while(0);b[a>>0]=(f[c+(f[(f[c>>2]|0)+-12>>2]|0)+16>>2]|0)==0&1}else _Oa(i,j|4);u=g;return}function hPa(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;if(f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0){iPa(d,a);if(b[d>>0]|0?(e=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0,(mi[f[(f[e>>2]|0)+24>>2]&255](e)|0)==-1):0){e=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;_Oa(e,f[e+16>>2]|1)}jPa(d)}u=c;return a|0}function iPa(a,c){a=a|0;c=c|0;var d=0;b[a>>0]=0;f[a+4>>2]=c;d=c+(f[(f[c>>2]|0)+-12>>2]|0)|0;if(!(f[d+16>>2]|0)){c=f[d+72>>2]|0;if(c|0)hPa(c)|0;b[a>>0]=1}return}function jPa(a){a=a|0;var b=0,c=0;b=a+4|0;a=f[b>>2]|0;c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;if((((f[c+24>>2]|0?(f[c+16>>2]|0)==0:0)?f[c+4>>2]&8192|0:0)?!(kd()|0):0)?(c=f[b>>2]|0,a=f[c+(f[(f[c>>2]|0)+-12>>2]|0)+24>>2]|0,(mi[f[(f[a>>2]|0)+24>>2]&255](a)|0)==-1):0){a=f[b>>2]|0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;_Oa(b,f[b+16>>2]|1)}return}function kPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d+20|0;g=d+16|0;h=d+12|0;i=d+8|0;j=d+24|0;k=d+4|0;l=d;gPa(j,a,0);if(b[j>>0]|0){f[k>>2]=0;bPa(l,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);j=BQa(l,1975200)|0;m=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;n=f[(f[j>>2]|0)+28>>2]|0;f[h>>2]=f[m+24>>2];f[i>>2]=0;f[g>>2]=f[h>>2];f[e>>2]=f[i>>2];bg[n&127](j,g,e,m,k,c)|0;CQa(l);l=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;_Oa(l,f[l+16>>2]|f[k>>2])}u=d;return a|0}function lPa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=a+4|0;f[h>>2]=0;gPa(g,a,1);i=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;if(b[g>>0]|0){g=f[i+24>>2]|0;j=ui[f[(f[g>>2]|0)+32>>2]&127](g,c,d)|0;f[h>>2]=j;if((j|0)!=(d|0)){d=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;_Oa(d,f[d+16>>2]|6)}}else _Oa(i,f[i+16>>2]|4);u=e;return a|0}function mPa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+32|0;h=g+16|0;i=g;j=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;_Oa(j,f[j+16>>2]&-3);gPa(h,a,1);if(b[h>>0]|0?(h=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0,bh[f[(f[h>>2]|0)+16>>2]&255](i,h,c,d,e,8),e=i+8|0,(f[e>>2]|0)==-1?(f[e+4>>2]|0)==-1:0):0){e=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;_Oa(e,f[e+16>>2]|4)}u=g;return a|0}function nPa(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;if(f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0){oPa(d,a);if(b[d>>0]|0?(e=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0,(mi[f[(f[e>>2]|0)+24>>2]&255](e)|0)==-1):0){e=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;_Oa(e,f[e+16>>2]|1)}pPa(d)}u=c;return a|0}function oPa(a,c){a=a|0;c=c|0;var d=0;b[a>>0]=0;f[a+4>>2]=c;d=c+(f[(f[c>>2]|0)+-12>>2]|0)|0;if(!(f[d+16>>2]|0)){c=f[d+72>>2]|0;if(c|0)nPa(c)|0;b[a>>0]=1}return}function pPa(a){a=a|0;var b=0,c=0;b=a+4|0;a=f[b>>2]|0;c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;if((((f[c+24>>2]|0?(f[c+16>>2]|0)==0:0)?f[c+4>>2]&8192|0:0)?!(kd()|0):0)?(c=f[b>>2]|0,a=f[c+(f[(f[c>>2]|0)+-12>>2]|0)+24>>2]|0,(mi[f[(f[a>>2]|0)+24>>2]&255](a)|0)==-1):0){a=f[b>>2]|0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;_Oa(b,f[b+16>>2]|1)}return}function qPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;iPa(e,a);do if(b[e>>0]|0){g=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0;h=g;if(g|0){i=h+24|0;j=f[i>>2]|0;if((j|0)==(f[h+28>>2]|0)){k=f[(f[g>>2]|0)+52>>2]|0;g=jOa(c)|0;l=$h[k&255](h,g)|0}else{f[i>>2]=j+1;b[j>>0]=c;l=jOa(c)|0}if(!(aPa(l,iOa()|0)|0))break}j=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;_Oa(j,f[j+16>>2]|1)}while(0);jPa(e);u=d;return a|0}function rPa(a){a=a|0;var b=0;b=a+16|0;f[b>>2]=f[b>>2]|1;return}function sPa(){uPa();return}function tPa(){return}function uPa(){vPa(0);Fd(1015,5694104,x|0)|0;return}function vPa(a){a=a|0;var b=0;a=f[30841]|0;xPa(1974808,a,1974864);f[493532]=127172;f[493534]=127192;f[493533]=0;$Oa(1974136,1974808);f[493552]=0;b=iOa()|0;f[493553]=b;yPa(1974872,a,1974928);f[493554]=127220;f[493556]=127240;f[493555]=0;$Oa(1974224,1974872);f[493574]=0;a=AOa()|0;f[493575]=a;a=f[30715]|0;zPa(1974936,a,1974984);f[493576]=127268;f[493577]=127288;$Oa(1974308,1974936);f[493595]=0;b=iOa()|0;f[493596]=b;APa(1974992,a,1975040);f[493597]=127316;f[493598]=127336;$Oa(1974392,1974992);f[493616]=0;a=AOa()|0;f[493617]=a;a=f[30809]|0;zPa(1975048,a,1975096);f[493618]=127268;f[493619]=127288;$Oa(1974476,1975048);f[493637]=0;b=iOa()|0;f[493638]=b;b=f[1974472+(f[(f[493618]|0)+-12>>2]|0)+24>>2]|0;f[493660]=127268;f[493661]=127288;$Oa(1974644,b);f[493679]=0;b=iOa()|0;f[493680]=b;APa(1975104,a,1975152);f[493639]=127316;f[493640]=127336;$Oa(1974560,1975104);f[493658]=0;a=AOa()|0;f[493659]=a;a=f[1974556+(f[(f[493639]|0)+-12>>2]|0)+24>>2]|0;f[493681]=127316;f[493682]=127336;$Oa(1974728,a);f[493700]=0;a=AOa()|0;f[493701]=a;f[1974128+(f[(f[493532]|0)+-12>>2]|0)+72>>2]=1974304;f[1974216+(f[(f[493554]|0)+-12>>2]|0)+72>>2]=1974388;a=1974472+(f[(f[493618]|0)+-12>>2]|0)+4|0;f[a>>2]=f[a>>2]|8192;a=1974556+(f[(f[493639]|0)+-12>>2]|0)+4|0;f[a>>2]=f[a>>2]|8192;f[1974472+(f[(f[493618]|0)+-12>>2]|0)+72>>2]=1974304;f[1974556+(f[(f[493639]|0)+-12>>2]|0)+72>>2]=1974388;return}function wPa(a){a=a|0;hPa(1974304)|0;nPa(1974388)|0;hPa(1974640)|0;nPa(1974724)|0;return}function xPa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;ePa(a);f[a>>2]=127552;f[a+32>>2]=c;f[a+40>>2]=d;d=iOa()|0;f[a+48>>2]=d;b[a+52>>0]=0;d=f[(f[a>>2]|0)+8>>2]|0;DYa(g,a+4|0);Gh[d&511](a,g);CQa(g);u=e;return}function yPa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;fPa(a);f[a>>2]=127488;f[a+32>>2]=c;f[a+40>>2]=d;d=AOa()|0;f[a+48>>2]=d;b[a+52>>0]=0;d=f[(f[a>>2]|0)+8>>2]|0;DYa(g,a+4|0);Gh[d&511](a,g);CQa(g);u=e;return}function zPa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;ePa(a);f[a>>2]=127424;f[a+32>>2]=c;DYa(g,a+4|0);c=BQa(g,1976968)|0;CQa(g);f[a+36>>2]=c;f[a+40>>2]=d;d=(mi[f[(f[c>>2]|0)+28>>2]&255](c)|0)&1;b[a+44>>0]=d;u=e;return}function APa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;fPa(a);f[a>>2]=127360;f[a+32>>2]=c;DYa(g,a+4|0);c=BQa(g,1976976)|0;CQa(g);f[a+36>>2]=c;f[a+40>>2]=d;d=(mi[f[(f[c>>2]|0)+28>>2]&255](c)|0)&1;b[a+44>>0]=d;u=e;return}function BPa(a){a=a|0;mOa(a);return}function CPa(a){a=a|0;BPa(a);PYa(a);return}function DPa(a,c){a=a|0;c=c|0;var d=0;mi[f[(f[a>>2]|0)+24>>2]&255](a)|0;d=BQa(c,1976976)|0;f[a+36>>2]=d;c=(mi[f[(f[d>>2]|0)+28>>2]&255](d)|0)&1;b[a+44>>0]=c;return}function EPa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=u;u=u+16|0;c=b+8|0;d=b;e=a+36|0;g=a+40|0;h=c+8|0;i=c;j=a+32|0;a:while(1){a=f[e>>2]|0;k=uh[f[(f[a>>2]|0)+20>>2]&63](a,f[g>>2]|0,c,h,d)|0;a=(f[d>>2]|0)-i|0;if((xMa(c,1,a,f[j>>2]|0)|0)!=(a|0)){l=-1;break}switch(k|0){case 1:break;case 2:{l=-1;break a;break}default:{m=4;break a}}}if((m|0)==4)l=((IMa(f[j>>2]|0)|0)!=0)<<31>>31;u=b;return l|0}function FPa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;a:do if(!(b[a+44>>0]|0)){e=0;g=c;while(1){if((e|0)>=(d|0)){h=e;break a}i=f[(f[a>>2]|0)+52>>2]|0;j=BOa(f[g>>2]|0)|0;k=$h[i&255](a,j)|0;if((k|0)==(AOa()|0)){h=e;break a}e=e+1|0;g=g+4|0}}else h=xMa(c,4,d,f[a+32>>2]|0)|0;while(0);return h|0}function GPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;do if(!(cPa(c,AOa()|0)|0)){j=DOa(c)|0;f[g>>2]=j;j=a+32|0;if(b[a+44>>0]|0){if((xMa(g,4,1,f[j>>2]|0)|0)==1){k=15;break}l=AOa()|0;break}f[h>>2]=e;m=g+4|0;n=a+36|0;o=a+40|0;p=e+8|0;q=e;r=g;while(1){s=f[n>>2]|0;t=Oi[f[(f[s>>2]|0)+12>>2]&15](s,f[o>>2]|0,r,m,i,e,p,h)|0;s=(t|0)==1;if((f[i>>2]|0)==(r|0)){k=14;break}if((t|0)==3)if((xMa(r,1,1,f[j>>2]|0)|0)==1)v=r;else{k=14;break}else{if((t|1|0)!=1){k=14;break}t=(f[h>>2]|0)-q|0;if((xMa(e,1,t,f[j>>2]|0)|0)!=(t|0)){k=14;break}v=s?f[i>>2]|0:r}if(s)r=v;else{k=13;break}}if((k|0)==13){k=15;break}else if((k|0)==14){l=AOa()|0;break}}else k=15;while(0);if((k|0)==15)l=HPa(c)|0;u=d;return l|0}function HPa(a){a=a|0;var b=0;if(cPa(a,AOa()|0)|0)b=~(AOa()|0);else b=a;return b|0}function IPa(a){a=a|0;WNa(a);return}function JPa(a){a=a|0;IPa(a);PYa(a);return}function KPa(a,c){a=a|0;c=c|0;var d=0;mi[f[(f[a>>2]|0)+24>>2]&255](a)|0;d=BQa(c,1976968)|0;f[a+36>>2]=d;c=(mi[f[(f[d>>2]|0)+28>>2]&255](d)|0)&1;b[a+44>>0]=c;return}function LPa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=u;u=u+16|0;c=b+8|0;d=b;e=a+36|0;g=a+40|0;h=c+8|0;i=c;j=a+32|0;a:while(1){a=f[e>>2]|0;k=uh[f[(f[a>>2]|0)+20>>2]&63](a,f[g>>2]|0,c,h,d)|0;a=(f[d>>2]|0)-i|0;if((xMa(c,1,a,f[j>>2]|0)|0)!=(a|0)){l=-1;break}switch(k|0){case 1:break;case 2:{l=-1;break a;break}default:{m=4;break a}}}if((m|0)==4)l=((IMa(f[j>>2]|0)|0)!=0)<<31>>31;u=b;return l|0}function MPa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;a:do if(!(b[a+44>>0]|0)){e=0;g=c;while(1){if((e|0)>=(d|0)){h=e;break a}i=f[(f[a>>2]|0)+52>>2]|0;j=jOa(b[g>>0]|0)|0;k=$h[i&255](a,j)|0;if((k|0)==(iOa()|0)){h=e;break a}e=e+1|0;g=g+1|0}}else h=xMa(c,1,d,f[a+32>>2]|0)|0;while(0);return h|0}function NPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;do if(!(aPa(c,iOa()|0)|0)){j=lOa(c)|0;b[g>>0]=j;j=a+32|0;if(b[a+44>>0]|0){if((xMa(g,1,1,f[j>>2]|0)|0)==1){k=15;break}l=iOa()|0;break}f[h>>2]=e;m=g+1|0;n=a+36|0;o=a+40|0;p=e+8|0;q=e;r=g;while(1){s=f[n>>2]|0;t=Oi[f[(f[s>>2]|0)+12>>2]&15](s,f[o>>2]|0,r,m,i,e,p,h)|0;s=(t|0)==1;if((f[i>>2]|0)==(r|0)){k=14;break}if((t|0)==3)if((xMa(r,1,1,f[j>>2]|0)|0)==1)v=r;else{k=14;break}else{if((t|1|0)!=1){k=14;break}t=(f[h>>2]|0)-q|0;if((xMa(e,1,t,f[j>>2]|0)|0)!=(t|0)){k=14;break}v=s?f[i>>2]|0:r}if(s)r=v;else{k=13;break}}if((k|0)==13){k=15;break}else if((k|0)==14){l=iOa()|0;break}}else k=15;while(0);if((k|0)==15)l=OPa(c)|0;u=d;return l|0}function OPa(a){a=a|0;var b=0;if(aPa(a,iOa()|0)|0)b=~(iOa()|0);else b=a;return b|0}function PPa(a){a=a|0;mOa(a);return}function QPa(a){a=a|0;PPa(a);PYa(a);return}function RPa(a,c){a=a|0;c=c|0;var d=0,e=0;d=BQa(c,1976976)|0;c=a+36|0;f[c>>2]=d;e=mi[f[(f[d>>2]|0)+24>>2]&255](d)|0;d=a+44|0;f[d>>2]=e;e=f[c>>2]|0;c=(mi[f[(f[e>>2]|0)+28>>2]&255](e)|0)&1;b[a+53>>0]=c;if((f[d>>2]|0)>8)WTa(369953);else return}function SPa(a){a=a|0;return VPa(a,0)|0}function TPa(a){a=a|0;return VPa(a,1)|0}function UPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;j=cPa(c,AOa()|0)|0;k=a+52|0;l=(b[k>>0]|0)!=0;m=a+48|0;do if(j)if(l)n=c;else{o=f[m>>2]|0;p=((cPa(o,AOa()|0)|0)^1)&1;b[k>>0]=p;n=o}else{if(l){o=DOa(f[m>>2]|0)|0;f[h>>2]=o;o=f[a+36>>2]|0;switch(Oi[f[(f[o>>2]|0)+12>>2]&15](o,f[a+40>>2]|0,h,h+4|0,i,e,e+8|0,g)|0){case 1:case 2:{q=10;break}case 3:{b[e>>0]=f[m>>2];f[g>>2]=e+1;q=7;break}default:q=7}a:do if((q|0)==7){o=a+32|0;while(1){p=f[g>>2]|0;if(p>>>0<=e>>>0){r=1;s=0;break a}t=p+-1|0;f[g>>2]=t;if((CMa(b[t>>0]|0,f[o>>2]|0)|0)==-1){q=10;break}}}while(0);if((q|0)==10){r=0;s=AOa()|0}if(!r){n=s;break}}f[m>>2]=c;b[k>>0]=1;n=c}while(0);u=d;return n|0}function VPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;j=a+52|0;k=a+48|0;if(b[j>>0]|0){l=f[k>>2]|0;if(c){m=AOa()|0;f[k>>2]=m;b[j>>0]=0;n=l}else n=l}else{l=f[a+44>>2]|0;j=(l|0)>1?l:1;l=a+32|0;m=0;while(1){if((m|0)>=(j|0)){o=9;break}p=RLa(f[l>>2]|0)|0;if((p|0)==-1){o=8;break}b[e+m>>0]=p;m=m+1|0}if((o|0)==8)q=AOa()|0;else if((o|0)==9){do if(!(b[a+53>>0]|0)){m=a+40|0;p=a+36|0;r=g+4|0;s=j;a:while(1){t=f[m>>2]|0;v=t;w=f[v>>2]|0;x=f[v+4>>2]|0;v=f[p>>2]|0;y=e+s|0;switch(Oi[f[(f[v>>2]|0)+16>>2]&15](v,t,e,y,h,g,r,i)|0){case 3:{o=16;break a;break}case 2:{o=18;break a;break}case 1:break;default:break a}t=f[m>>2]|0;f[t>>2]=w;f[t+4>>2]=x;if((s|0)==8){o=18;break}x=RLa(f[l>>2]|0)|0;if((x|0)==-1){o=18;break}b[y>>0]=x;s=s+1|0}if((o|0)==16)f[g>>2]=b[e>>0];else if((o|0)==18){z=AOa()|0;break}A=s;o=19}else{f[g>>2]=b[e>>0];A=j;o=19}while(0);b:do if((o|0)==19){c:do if(c){j=BOa(f[g>>2]|0)|0;f[k>>2]=j}else{j=A;do{if((j|0)<=0)break c;j=j+-1|0;i=BOa(b[e+j>>0]|0)|0}while((CMa(i,f[l>>2]|0)|0)!=-1);z=AOa()|0;break b}while(0);z=BOa(f[g>>2]|0)|0}while(0);q=z}n=q}u=d;return n|0}function WPa(a){a=a|0;WNa(a);return}function XPa(a){a=a|0;WPa(a);PYa(a);return}function YPa(a,c){a=a|0;c=c|0;var d=0,e=0;d=BQa(c,1976968)|0;c=a+36|0;f[c>>2]=d;e=mi[f[(f[d>>2]|0)+24>>2]&255](d)|0;d=a+44|0;f[d>>2]=e;e=f[c>>2]|0;c=(mi[f[(f[e>>2]|0)+28>>2]&255](e)|0)&1;b[a+53>>0]=c;if((f[d>>2]|0)>8)WTa(369953);else return}function ZPa(a){a=a|0;return aQa(a,0)|0}function _Pa(a){a=a|0;return aQa(a,1)|0}function $Pa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+32|0;e=d+16|0;g=d+4|0;h=d+8|0;i=d;j=aPa(c,iOa()|0)|0;k=a+52|0;l=(b[k>>0]|0)!=0;m=a+48|0;do if(j)if(l)n=c;else{o=f[m>>2]|0;p=((aPa(o,iOa()|0)|0)^1)&1;b[k>>0]=p;n=o}else{if(l){o=lOa(f[m>>2]|0)|0;b[h>>0]=o;o=f[a+36>>2]|0;switch(Oi[f[(f[o>>2]|0)+12>>2]&15](o,f[a+40>>2]|0,h,h+1|0,i,e,e+8|0,g)|0){case 1:case 2:{q=10;break}case 3:{b[e>>0]=f[m>>2];f[g>>2]=e+1;q=7;break}default:q=7}a:do if((q|0)==7){o=a+32|0;while(1){p=f[g>>2]|0;if(p>>>0<=e>>>0){r=1;s=0;break a}t=p+-1|0;f[g>>2]=t;if((CMa(b[t>>0]|0,f[o>>2]|0)|0)==-1){q=10;break}}}while(0);if((q|0)==10){r=0;s=iOa()|0}if(!r){n=s;break}}f[m>>2]=c;b[k>>0]=1;n=c}while(0);u=d;return n|0}function aQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;j=a+52|0;k=a+48|0;if(b[j>>0]|0){l=f[k>>2]|0;if(c){m=iOa()|0;f[k>>2]=m;b[j>>0]=0;n=l}else n=l}else{l=f[a+44>>2]|0;j=(l|0)>1?l:1;l=a+32|0;m=0;while(1){if((m|0)>=(j|0)){o=9;break}p=RLa(f[l>>2]|0)|0;if((p|0)==-1){o=8;break}b[e+m>>0]=p;m=m+1|0}if((o|0)==8)q=iOa()|0;else if((o|0)==9){do if(!(b[a+53>>0]|0)){m=a+40|0;p=a+36|0;r=g+1|0;s=j;a:while(1){t=f[m>>2]|0;v=t;w=f[v>>2]|0;x=f[v+4>>2]|0;v=f[p>>2]|0;y=e+s|0;switch(Oi[f[(f[v>>2]|0)+16>>2]&15](v,t,e,y,h,g,r,i)|0){case 3:{o=16;break a;break}case 2:{o=18;break a;break}case 1:break;default:break a}t=f[m>>2]|0;f[t>>2]=w;f[t+4>>2]=x;if((s|0)==8){o=18;break}x=RLa(f[l>>2]|0)|0;if((x|0)==-1){o=18;break}b[y>>0]=x;s=s+1|0}if((o|0)==16)b[g>>0]=b[e>>0]|0;else if((o|0)==18){z=iOa()|0;break}A=s;o=19}else{b[g>>0]=b[e>>0]|0;A=j;o=19}while(0);b:do if((o|0)==19){c:do if(c){j=jOa(b[g>>0]|0)|0;f[k>>2]=j}else{j=A;do{if((j|0)<=0)break c;j=j+-1|0;i=jOa(b[e+j>>0]|0)|0}while((CMa(i,f[l>>2]|0)|0)!=-1);z=iOa()|0;break b}while(0);z=jOa(b[g>>0]|0)|0}while(0);q=z}n=q}u=d;return n|0}function bQa(a){a=a|0;hQa(a);return}function cQa(a){a=a|0;bQa(a);PYa(a);return}function dQa(a){a=a|0;if(a|0)ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function eQa(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a=c;c=e;while(1){if((c|0)==(f|0)){g=7;break}if((a|0)==(d|0)){h=-1;break}e=b[a>>0]|0;i=b[c>>0]|0;if(e<<24>>24<i<<24>>24){h=-1;break}if(i<<24>>24<e<<24>>24){h=1;break}a=a+1|0;c=c+1|0}if((g|0)==7)h=(a|0)!=(d|0)&1;return h|0}function fQa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;g=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=e-d|0;if(h>>>0>4294967279)WYa(a);if(h>>>0<11){b[a+11>>0]=h;i=a}else{j=h+16&-16;k=NYa(j)|0;f[a>>2]=k;f[a+8>>2]=j|-2147483648;f[a+4>>2]=h;i=k}k=d;d=i;while(1){if((k|0)==(e|0))break;ZOa(d,k);k=k+1|0;d=d+1|0}b[g>>0]=0;ZOa(i+h|0,g);u=c;return}function gQa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0;a=0;e=c;while(1){if((e|0)==(d|0))break;c=(b[e>>0]|0)+(a<<4)|0;f=c&-268435456;a=(f>>>24|f)^c;e=e+1|0}return a|0}function hQa(a){a=a|0;return}function iQa(a){a=a|0;hQa(a);return}function jQa(a){a=a|0;iQa(a);PYa(a);return}function kQa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;a=b;b=d;while(1){if((b|0)==(e|0)){g=7;break}if((a|0)==(c|0)){h=-1;break}d=f[a>>2]|0;i=f[b>>2]|0;if((d|0)<(i|0)){h=-1;break}if((i|0)<(d|0)){h=1;break}a=a+4|0;b=b+4|0}if((g|0)==7)h=(a|0)!=(c|0)&1;return h|0}function lQa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;g=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=e-d>>2;if(h>>>0>1073741807)WYa(a);do if(h>>>0>=2){i=h+4&-4;if(i>>>0>1073741823)We();else{j=NYa(i<<2)|0;f[a>>2]=j;f[a+8>>2]=i|-2147483648;f[a+4>>2]=h;k=d;l=j;break}}else{b[a+8+3>>0]=h;k=d;l=a}while(0);while(1){if((k|0)==(e|0))break;nQa(l,k);k=k+4|0;l=l+4|0}f[g>>2]=0;nQa(l,g);u=c;return}function mQa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=0;d=b;while(1){if((d|0)==(c|0))break;b=(f[d>>2]|0)+(a<<4)|0;e=b&-268435456;a=(e>>>24|e)^b;d=d+4|0}return a|0}function nQa(a,b){a=a|0;b=b|0;f[a>>2]=f[b>>2];return}function oQa(a){a=a|0;hQa(a);return}function pQa(a){a=a|0;hQa(a);PYa(a);return}function qQa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;i=u;u=u+48|0;j=i+40|0;k=i+16|0;l=i+8|0;m=i+12|0;n=i+4|0;o=i;if(!(f[e+4>>2]&1)){f[l>>2]=-1;p=f[(f[a>>2]|0)+16>>2]|0;f[m>>2]=f[c>>2];f[n>>2]=f[d>>2];f[k>>2]=f[m>>2];f[j>>2]=f[n>>2];n=bg[p&127](a,k,j,e,g,l)|0;f[c>>2]=n;switch(f[l>>2]|0){case 0:{b[h>>0]=0;break}case 1:{b[h>>0]=1;break}default:{b[h>>0]=1;f[g>>2]=4}}q=f[c>>2]|0}else{bPa(j,e);l=BQa(j,1975176)|0;CQa(j);bPa(j,e);e=BQa(j,1975192)|0;CQa(j);Gh[f[(f[e>>2]|0)+24>>2]&511](k,e);Gh[f[(f[e>>2]|0)+28>>2]&511](k+12|0,e);f[o>>2]=f[d>>2];d=k+24|0;f[j>>2]=f[o>>2];o=(hRa(c,j,k,d,l,g,1)|0)==(k|0)&1;b[h>>0]=o;o=f[c>>2]|0;c=d;do{c=c+-12|0;_Ya(c)}while((c|0)!=(k|0));q=o}u=i;return q|0}function rQa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=fRa(a,j,i,d,e,g)|0;u=h;return l|0}function sQa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=dRa(a,j,i,d,e,g)|0;u=h;return l|0}function tQa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=bRa(a,j,i,d,e,g)|0;u=h;return l|0}function uQa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=$Qa(a,j,i,d,e,g)|0;u=h;return l|0}function vQa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=ZQa(a,j,i,d,e,g)|0;u=h;return l|0}function wQa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=VQa(a,j,i,d,e,g)|0;u=h;return l|0}function xQa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=TQa(a,j,i,d,e,g)|0;u=h;return l|0}function yQa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=RQa(a,j,i,d,e,g)|0;u=h;return l|0}function zQa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=MQa(a,j,i,d,e,g)|0;u=h;return l|0}function AQa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;a=u;u=u+240|0;i=a;j=a+204|0;k=a+192|0;l=a+180|0;m=a+176|0;n=a+16|0;o=a+8|0;p=a+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[k+(q<<2)>>2]=0;q=q+1|0}bPa(l,e);e=BQa(l,1975176)|0;Jg[f[(f[e>>2]|0)+32>>2]&63](e,370101,370127,j)|0;CQa(l);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;q=l+8|0;if((b[e>>0]|0)<0)r=(f[q>>2]&2147483647)+-1|0;else r=10;fZa(l,r,0);r=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=r;f[o>>2]=n;f[p>>2]=0;s=l+4|0;t=f[c>>2]|0;v=t;w=t;t=r;a:while(1){if(v){r=f[v+12>>2]|0;if((r|0)==(f[v+16>>2]|0))x=mi[f[(f[v>>2]|0)+36>>2]&255](v)|0;else x=jOa(b[r>>0]|0)|0;if(aPa(x,iOa()|0)|0){f[c>>2]=0;y=0;z=0;A=1}else{y=v;z=w;A=0}}else{y=0;z=0;A=1}r=f[d>>2]|0;do if(r){B=f[r+12>>2]|0;if((B|0)==(f[r+16>>2]|0))C=mi[f[(f[r>>2]|0)+36>>2]&255](r)|0;else C=jOa(b[B>>0]|0)|0;if(!(aPa(C,iOa()|0)|0))if(A){D=r;break}else{E=r;F=t;break a}else{f[d>>2]=0;G=22;break}}else G=22;while(0);if((G|0)==22){G=0;if(A){E=0;F=t;break}else D=0}r=b[e>>0]|0;B=r<<24>>24<0?f[s>>2]|0:r&255;if((f[m>>2]|0)==(t+B|0)){fZa(l,B<<1,0);if((b[e>>0]|0)<0)H=(f[q>>2]&2147483647)+-1|0;else H=10;fZa(l,H,0);r=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=r+B;I=r}else I=t;r=y+12|0;B=f[r>>2]|0;J=y+16|0;if((B|0)==(f[J>>2]|0))K=mi[f[(f[y>>2]|0)+36>>2]&255](y)|0;else K=jOa(b[B>>0]|0)|0;if(DQa(K&255,16,I,m,p,0,k,n,o,j)|0){E=D;F=I;break}B=f[r>>2]|0;if((B|0)==(f[J>>2]|0)){mi[f[(f[y>>2]|0)+40>>2]&255](y)|0;v=y;w=z;t=I;continue}else{f[r>>2]=B+1;jOa(b[B>>0]|0)|0;v=y;w=z;t=I;continue}}fZa(l,(f[m>>2]|0)-F|0,0);F=(b[e>>0]|0)<0?f[l>>2]|0:l;e=EQa()|0;f[i>>2]=h;if((FQa(F,e,370134,i)|0)!=1)f[g>>2]=4;if(y){i=f[y+12>>2]|0;if((i|0)==(f[y+16>>2]|0))L=mi[f[(f[z>>2]|0)+36>>2]&255](y)|0;else L=jOa(b[i>>0]|0)|0;if(aPa(L,iOa()|0)|0){f[c>>2]=0;M=1}else M=0}else M=1;do if(E){L=f[E+12>>2]|0;if((L|0)==(f[E+16>>2]|0))N=mi[f[(f[E>>2]|0)+36>>2]&255](E)|0;else N=jOa(b[L>>0]|0)|0;if(!(aPa(N,iOa()|0)|0))if(M)break;else{G=51;break}else{f[d>>2]=0;G=49;break}}else G=49;while(0);if((G|0)==49?M:0)G=51;if((G|0)==51)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;_Ya(l);_Ya(k);u=a;return g|0}function BQa(a,b){a=a|0;b=b|0;var c=0;c=f[a>>2]|0;return HQa(c,GQa(b)|0)|0}function CQa(a){a=a|0;KYa(f[a>>2]|0)|0;return}function DQa(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;m=f[e>>2]|0;n=(m|0)==(d|0);do if(n){o=(b[l+24>>0]|0)==a<<24>>24;if(!o?(b[l+25>>0]|0)!=a<<24>>24:0){p=5;break}f[e>>2]=d+1;b[d>>0]=o?43:45;f[g>>2]=0;q=0}else p=5;while(0);a:do if((p|0)==5){o=b[i+11>>0]|0;if(a<<24>>24==h<<24>>24?((o<<24>>24<0?f[i+4>>2]|0:o&255)|0)!=0:0){o=f[k>>2]|0;if((o-j|0)>=160){q=0;break}r=f[g>>2]|0;f[k>>2]=o+4;f[o>>2]=r;f[g>>2]=0;q=0;break}r=l+26|0;o=0;while(1){s=l+o|0;if((o|0)==26){t=r;break}if((b[s>>0]|0)==a<<24>>24){t=s;break}else o=o+1|0}o=t-l|0;if((o|0)>23)q=-1;else{r=370101+o|0;switch(c|0){case 10:case 8:{if((o|0)>=(c|0)){q=-1;break a}break}case 16:{if((o|0)>=22){if(n){q=-1;break a}if((m-d|0)>=3){q=-1;break a}if((b[m+-1>>0]|0)!=48){q=-1;break a}f[g>>2]=0;o=b[r>>0]|0;f[e>>2]=m+1;b[m>>0]=o;q=0;break a}break}default:{}}o=b[r>>0]|0;f[e>>2]=m+1;b[m>>0]=o;f[g>>2]=(f[g>>2]|0)+1;q=0}}while(0);return q|0}function EQa(){var a=0;if((b[900280]|0)==0?u1a(900280)|0:0){a=INa(2147483647,370137,0)|0;f[493796]=a}return f[493796]|0}function FQa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=d;d=ANa(b)|0;b=TMa(a,c,g)|0;if(d|0)ANa(d)|0;u=e;return b|0}function GQa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+48|0;c=b+32|0;d=b+24|0;e=b;g=b+16|0;f[g>>2]=1016;f[g+4>>2]=0;f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];JQa(e,c,a);if((f[a>>2]|0)!=-1){f[c>>2]=e;f[d>>2]=c;MYa(a,d,1017)}u=b;return (f[a+4>>2]|0)+-1|0}function HQa(a,b){a=a|0;b=b|0;return f[(f[a+8>>2]|0)+(b<<2)>>2]|0}function IQa(a){a=a|0;var b=0;b=f[493797]|0;f[493797]=b+1;f[a+4>>2]=b+1;return}function JQa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=f[b>>2]|0;e=f[b+4>>2]|0;f[a>>2]=c;f[a+4>>2]=d;f[a+8>>2]=e;return}function KQa(a){a=a|0;LQa(f[f[a>>2]>>2]|0);return}function LQa(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+4>>2]|0;c=f[a+8>>2]|0;d=(f[a>>2]|0)+(c>>1)|0;if(!(c&1))e=b;else e=f[(f[d>>2]|0)+b>>2]|0;ki[e&2047](d);return}function MQa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+240|0;i=a+200|0;j=a+199|0;k=a+198|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;q=a+4|0;r=a;s=a+197|0;t=a+196|0;NQa(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;fZa(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w;f[q>>2]=o;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=y;A=y;y=w;a:while(1){if(z){w=f[z+12>>2]|0;if((w|0)==(f[z+16>>2]|0))B=mi[f[(f[z>>2]|0)+36>>2]&255](z)|0;else B=jOa(b[w>>0]|0)|0;if(aPa(B,iOa()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=z;D=A;E=0}}else{C=0;D=0;E=1}w=f[d>>2]|0;do if(w){F=f[w+12>>2]|0;if((F|0)==(f[w+16>>2]|0))G=mi[f[(f[w>>2]|0)+36>>2]&255](w)|0;else G=jOa(b[F>>0]|0)|0;if(!(aPa(G,iOa()|0)|0))if(E){H=w;break}else{I=w;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=0;J=y;break}else H=0}w=b[e>>0]|0;F=w<<24>>24<0?f[x>>2]|0:w&255;if((f[n>>2]|0)==(y+F|0)){fZa(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;fZa(m,L,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w+F;M=w}else M=y;w=C+12|0;F=f[w>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=mi[f[(f[C>>2]|0)+36>>2]&255](C)|0;else O=jOa(b[F>>0]|0)|0;if(OQa(O&255,s,t,M,n,b[j>>0]|0,b[k>>0]|0,l,o,q,r,i)|0){I=H;J=M;break}F=f[w>>2]|0;if((F|0)==(f[N>>2]|0)){mi[f[(f[C>>2]|0)+40>>2]&255](C)|0;z=C;A=D;y=M;continue}else{f[w>>2]=F+1;jOa(b[F>>0]|0)|0;z=C;A=D;y=M;continue}}M=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((M<<24>>24<0?f[l+4>>2]|0:M&255)|0)==0)?(M=f[q>>2]|0,(M-o|0)<160):0){s=f[r>>2]|0;f[q>>2]=M+4;f[M>>2]=s}P=+PQa(J,f[n>>2]|0,g);p[h>>3]=P;QQa(l,o,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=mi[f[(f[D>>2]|0)+36>>2]&255](C)|0;else Q=jOa(b[q>>0]|0)|0;if(aPa(Q,iOa()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(I){Q=f[I+12>>2]|0;if((Q|0)==(f[I+16>>2]|0))S=mi[f[(f[I>>2]|0)+36>>2]&255](I)|0;else S=jOa(b[Q>>0]|0)|0;if(!(aPa(S,iOa()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;_Ya(m);_Ya(l);u=a;return g|0}function NQa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;bPa(i,c);c=BQa(i,1975176)|0;Jg[f[(f[c>>2]|0)+32>>2]&63](c,370101,370133,d)|0;d=BQa(i,1975192)|0;c=mi[f[(f[d>>2]|0)+12>>2]&255](d)|0;b[e>>0]=c;c=mi[f[(f[d>>2]|0)+16>>2]&255](d)|0;b[g>>0]=c;Gh[f[(f[d>>2]|0)+20>>2]&511](a,d);CQa(i);u=h;return}function OQa(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0;o=k;a:do if(a<<24>>24==h<<24>>24)if(b[c>>0]|0){b[c>>0]=0;k=f[g>>2]|0;f[g>>2]=k+1;b[k>>0]=46;k=b[j+11>>0]|0;if(((k<<24>>24<0?f[j+4>>2]|0:k&255)|0)!=0?(k=f[l>>2]|0,(k-o|0)<160):0){p=f[m>>2]|0;f[l>>2]=k+4;f[k>>2]=p;q=0}else q=0}else q=-1;else{if(a<<24>>24==i<<24>>24?(p=b[j+11>>0]|0,(p<<24>>24<0?f[j+4>>2]|0:p&255)|0):0){if(!(b[c>>0]|0)){q=-1;break}p=f[l>>2]|0;if((p-o|0)>=160){q=0;break}k=f[m>>2]|0;f[l>>2]=p+4;f[p>>2]=k;f[m>>2]=0;q=0;break}k=n+32|0;p=0;while(1){r=n+p|0;if((p|0)==32){s=k;break}if((b[r>>0]|0)==a<<24>>24){s=r;break}else p=p+1|0}p=s-n|0;if((p|0)>31)q=-1;else{k=b[370101+p>>0]|0;switch(p|0){case 24:case 25:{r=f[g>>2]|0;if((r|0)!=(e|0)?(b[r+-1>>0]&95)!=(b[d>>0]&127):0){q=-1;break a}f[g>>2]=r+1;b[r>>0]=k;q=0;break a;break}case 23:case 22:{b[d>>0]=80;r=f[g>>2]|0;f[g>>2]=r+1;b[r>>0]=k;q=0;break a;break}default:{r=k&95;if((((r|0)==(b[d>>0]|0)?(b[d>>0]=r|128,b[c>>0]|0):0)?(b[c>>0]=0,r=b[j+11>>0]|0,(r<<24>>24<0?f[j+4>>2]|0:r&255)|0):0)?(r=f[l>>2]|0,(r-o|0)<160):0){t=f[m>>2]|0;f[l>>2]=r+4;f[r>>2]=t}t=f[g>>2]|0;f[g>>2]=t+1;b[t>>0]=k;if((p|0)>21){q=0;break a}f[m>>2]=(f[m>>2]|0)+1;q=0;break a}}}}while(0);return q|0}function PQa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0.0,h=0,i=0,j=0.0,k=0.0,l=0,m=0.0;d=u;u=u+16|0;e=d;if((a|0)==(b|0)){f[c>>2]=4;g=0.0}else{h=pKa()|0;i=f[h>>2]|0;h=pKa()|0;f[h>>2]=0;j=+qNa(a,e,EQa()|0);a=pKa()|0;h=f[a>>2]|0;if(!h){a=pKa()|0;f[a>>2]=i}if((f[e>>2]|0)==(b|0))if((h|0)==34){k=j;l=6}else m=j;else{k=0.0;l=6}if((l|0)==6){f[c>>2]=4;m=k}g=m}u=d;return +g}function QQa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=b[a+11>>0]|0;h=g<<24>>24<0;i=a+4|0;j=f[i>>2]|0;k=g&255;do if((h?j:k)|0){if((c|0)==(d|0))l=j;else{g=c;m=d;while(1){n=m+-4|0;if(g>>>0>=n>>>0)break;o=f[g>>2]|0;f[g>>2]=f[n>>2];f[n>>2]=o;g=g+4|0;m=n}l=f[i>>2]|0}m=h?f[a>>2]|0:a;g=d+-4|0;n=m+(h?l:k)|0;o=m;m=c;while(1){p=b[o>>0]|0;q=p<<24>>24>0&p<<24>>24!=127;if(m>>>0>=g>>>0)break;if(q?(p<<24>>24|0)!=(f[m>>2]|0):0){r=10;break}o=(n-o|0)>1?o+1|0:o;m=m+4|0}if((r|0)==10){f[e>>2]=4;break}if(q?((f[g>>2]|0)+-1|0)>>>0>=p<<24>>24>>>0:0)f[e>>2]=4}while(0);return}function RQa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+240|0;i=a+200|0;j=a+199|0;k=a+198|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;q=a+4|0;r=a;s=a+197|0;t=a+196|0;NQa(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;fZa(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w;f[q>>2]=o;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=y;A=y;y=w;a:while(1){if(z){w=f[z+12>>2]|0;if((w|0)==(f[z+16>>2]|0))B=mi[f[(f[z>>2]|0)+36>>2]&255](z)|0;else B=jOa(b[w>>0]|0)|0;if(aPa(B,iOa()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=z;D=A;E=0}}else{C=0;D=0;E=1}w=f[d>>2]|0;do if(w){F=f[w+12>>2]|0;if((F|0)==(f[w+16>>2]|0))G=mi[f[(f[w>>2]|0)+36>>2]&255](w)|0;else G=jOa(b[F>>0]|0)|0;if(!(aPa(G,iOa()|0)|0))if(E){H=w;break}else{I=w;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=0;J=y;break}else H=0}w=b[e>>0]|0;F=w<<24>>24<0?f[x>>2]|0:w&255;if((f[n>>2]|0)==(y+F|0)){fZa(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;fZa(m,L,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w+F;M=w}else M=y;w=C+12|0;F=f[w>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=mi[f[(f[C>>2]|0)+36>>2]&255](C)|0;else O=jOa(b[F>>0]|0)|0;if(OQa(O&255,s,t,M,n,b[j>>0]|0,b[k>>0]|0,l,o,q,r,i)|0){I=H;J=M;break}F=f[w>>2]|0;if((F|0)==(f[N>>2]|0)){mi[f[(f[C>>2]|0)+40>>2]&255](C)|0;z=C;A=D;y=M;continue}else{f[w>>2]=F+1;jOa(b[F>>0]|0)|0;z=C;A=D;y=M;continue}}M=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((M<<24>>24<0?f[l+4>>2]|0:M&255)|0)==0)?(M=f[q>>2]|0,(M-o|0)<160):0){s=f[r>>2]|0;f[q>>2]=M+4;f[M>>2]=s}P=+SQa(J,f[n>>2]|0,g);p[h>>3]=P;QQa(l,o,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=mi[f[(f[D>>2]|0)+36>>2]&255](C)|0;else Q=jOa(b[q>>0]|0)|0;if(aPa(Q,iOa()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(I){Q=f[I+12>>2]|0;if((Q|0)==(f[I+16>>2]|0))S=mi[f[(f[I>>2]|0)+36>>2]&255](I)|0;else S=jOa(b[Q>>0]|0)|0;if(!(aPa(S,iOa()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;_Ya(m);_Ya(l);u=a;return g|0}function SQa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0.0,h=0,i=0,j=0.0,k=0.0,l=0,m=0.0;d=u;u=u+16|0;e=d;if((a|0)==(b|0)){f[c>>2]=4;g=0.0}else{h=pKa()|0;i=f[h>>2]|0;h=pKa()|0;f[h>>2]=0;j=+pNa(a,e,EQa()|0);a=pKa()|0;h=f[a>>2]|0;if(!h){a=pKa()|0;f[a>>2]=i}if((f[e>>2]|0)==(b|0))if((h|0)==34){k=j;l=6}else m=j;else{k=0.0;l=6}if((l|0)==6){f[c>>2]=4;m=k}g=m}u=d;return +g}function TQa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+240|0;i=a+200|0;j=a+199|0;k=a+198|0;l=a+184|0;m=a+172|0;o=a+168|0;p=a+8|0;q=a+4|0;r=a;s=a+197|0;t=a+196|0;NQa(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;fZa(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[o>>2]=w;f[q>>2]=p;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=y;A=y;y=w;a:while(1){if(z){w=f[z+12>>2]|0;if((w|0)==(f[z+16>>2]|0))B=mi[f[(f[z>>2]|0)+36>>2]&255](z)|0;else B=jOa(b[w>>0]|0)|0;if(aPa(B,iOa()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=z;D=A;E=0}}else{C=0;D=0;E=1}w=f[d>>2]|0;do if(w){F=f[w+12>>2]|0;if((F|0)==(f[w+16>>2]|0))G=mi[f[(f[w>>2]|0)+36>>2]&255](w)|0;else G=jOa(b[F>>0]|0)|0;if(!(aPa(G,iOa()|0)|0))if(E){H=w;break}else{I=w;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=0;J=y;break}else H=0}w=b[e>>0]|0;F=w<<24>>24<0?f[x>>2]|0:w&255;if((f[o>>2]|0)==(y+F|0)){fZa(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;fZa(m,L,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[o>>2]=w+F;M=w}else M=y;w=C+12|0;F=f[w>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=mi[f[(f[C>>2]|0)+36>>2]&255](C)|0;else O=jOa(b[F>>0]|0)|0;if(OQa(O&255,s,t,M,o,b[j>>0]|0,b[k>>0]|0,l,p,q,r,i)|0){I=H;J=M;break}F=f[w>>2]|0;if((F|0)==(f[N>>2]|0)){mi[f[(f[C>>2]|0)+40>>2]&255](C)|0;z=C;A=D;y=M;continue}else{f[w>>2]=F+1;jOa(b[F>>0]|0)|0;z=C;A=D;y=M;continue}}M=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((M<<24>>24<0?f[l+4>>2]|0:M&255)|0)==0)?(M=f[q>>2]|0,(M-p|0)<160):0){s=f[r>>2]|0;f[q>>2]=M+4;f[M>>2]=s}P=+UQa(J,f[o>>2]|0,g);n[h>>2]=P;QQa(l,p,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=mi[f[(f[D>>2]|0)+36>>2]&255](C)|0;else Q=jOa(b[q>>0]|0)|0;if(aPa(Q,iOa()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(I){Q=f[I+12>>2]|0;if((Q|0)==(f[I+16>>2]|0))S=mi[f[(f[I>>2]|0)+36>>2]&255](I)|0;else S=jOa(b[Q>>0]|0)|0;if(!(aPa(S,iOa()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;_Ya(m);_Ya(l);u=a;return g|0}function UQa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0.0,h=0,i=0,j=0.0,k=0.0,l=0,m=0.0;d=u;u=u+16|0;e=d;if((a|0)==(b|0)){f[c>>2]=4;g=0.0}else{h=pKa()|0;i=f[h>>2]|0;h=pKa()|0;f[h>>2]=0;j=+oNa(a,e,EQa()|0);a=pKa()|0;h=f[a>>2]|0;if(!h){a=pKa()|0;f[a>>2]=i}if((f[e>>2]|0)==(b|0))if((h|0)==34){k=j;l=6}else m=j;else{k=0.0;l=6}if((l|0)==6){f[c>>2]=4;m=k}g=m}u=d;return +g}function VQa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+224|0;i=a+198|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=WQa(e)|0;XQa(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;fZa(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=v;x=v;v=s;a:while(1){if(w){s=f[w+12>>2]|0;if((s|0)==(f[w+16>>2]|0))y=mi[f[(f[w>>2]|0)+36>>2]&255](w)|0;else y=jOa(b[s>>0]|0)|0;if(aPa(y,iOa()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=w;A=x;B=0}}else{z=0;A=0;B=1}s=f[d>>2]|0;do if(s){C=f[s+12>>2]|0;if((C|0)==(f[s+16>>2]|0))D=mi[f[(f[s>>2]|0)+36>>2]&255](s)|0;else D=jOa(b[C>>0]|0)|0;if(!(aPa(D,iOa()|0)|0))if(B){E=s;break}else{F=s;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=0;G=v;break}else E=0}s=b[e>>0]|0;C=s<<24>>24<0?f[t>>2]|0:s&255;if((f[m>>2]|0)==(v+C|0)){fZa(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;fZa(l,I,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s+C;K=s}else K=v;s=z+12|0;C=f[s>>2]|0;L=z+16|0;if((C|0)==(f[L>>2]|0))M=mi[f[(f[z>>2]|0)+36>>2]&255](z)|0;else M=jOa(b[C>>0]|0)|0;if(DQa(M&255,q,K,m,p,b[j>>0]|0,k,n,o,i)|0){F=E;G=K;break}C=f[s>>2]|0;if((C|0)==(f[L>>2]|0)){mi[f[(f[z>>2]|0)+40>>2]&255](z)|0;w=z;x=A;v=K;continue}else{f[s>>2]=C+1;jOa(b[C>>0]|0)|0;w=z;x=A;v=K;continue}}K=b[k+11>>0]|0;if((K<<24>>24<0?f[k+4>>2]|0:K&255)|0?(K=f[o>>2]|0,(K-n|0)<160):0){v=f[p>>2]|0;f[o>>2]=K+4;f[K>>2]=v}v=YQa(G,f[m>>2]|0,g,q)|0;q=h;f[q>>2]=v;f[q+4>>2]=J;QQa(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))N=mi[f[(f[A>>2]|0)+36>>2]&255](z)|0;else N=jOa(b[o>>0]|0)|0;if(aPa(N,iOa()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(F){N=f[F+12>>2]|0;if((N|0)==(f[F+16>>2]|0))P=mi[f[(f[F>>2]|0)+36>>2]&255](F)|0;else P=jOa(b[N>>0]|0)|0;if(!(aPa(P,iOa()|0)|0))if(O)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?O:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;_Ya(l);_Ya(k);u=a;return g|0}function WQa(a){a=a|0;var b=0;switch(f[a+4>>2]&74){case 64:{b=8;break}case 8:{b=16;break}case 0:{b=0;break}default:b=10}return b|0}function XQa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;bPa(h,c);c=BQa(h,1975176)|0;Jg[f[(f[c>>2]|0)+32>>2]&63](c,370101,370127,d)|0;d=BQa(h,1975192)|0;c=mi[f[(f[d>>2]|0)+16>>2]&255](d)|0;b[e>>0]=c;Gh[f[(f[d>>2]|0)+20>>2]&511](a,d);CQa(h);u=g;return}function YQa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+16|0;h=g;do if((a|0)==(c|0)){f[d>>2]=4;i=0;j=0}else{if((b[a>>0]|0)==45){f[d>>2]=4;i=0;j=0;break}k=pKa()|0;l=f[k>>2]|0;k=pKa()|0;f[k>>2]=0;k=yNa(a,h,e,EQa()|0)|0;m=J;n=pKa()|0;o=f[n>>2]|0;if(!o){n=pKa()|0;f[n>>2]=l}if((f[h>>2]|0)==(c|0))if((o|0)==34){p=-1;q=-1;r=8}else{s=k;t=m}else{p=0;q=0;r=8}if((r|0)==8){f[d>>2]=4;s=p;t=q}i=t;j=s}while(0);J=i;u=g;return j|0}function ZQa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+224|0;i=a+198|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=WQa(e)|0;XQa(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;fZa(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=v;x=v;v=s;a:while(1){if(w){s=f[w+12>>2]|0;if((s|0)==(f[w+16>>2]|0))y=mi[f[(f[w>>2]|0)+36>>2]&255](w)|0;else y=jOa(b[s>>0]|0)|0;if(aPa(y,iOa()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=w;A=x;B=0}}else{z=0;A=0;B=1}s=f[d>>2]|0;do if(s){C=f[s+12>>2]|0;if((C|0)==(f[s+16>>2]|0))D=mi[f[(f[s>>2]|0)+36>>2]&255](s)|0;else D=jOa(b[C>>0]|0)|0;if(!(aPa(D,iOa()|0)|0))if(B){E=s;break}else{F=s;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=0;G=v;break}else E=0}s=b[e>>0]|0;C=s<<24>>24<0?f[t>>2]|0:s&255;if((f[m>>2]|0)==(v+C|0)){fZa(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;fZa(l,I,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s+C;J=s}else J=v;s=z+12|0;C=f[s>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=mi[f[(f[z>>2]|0)+36>>2]&255](z)|0;else L=jOa(b[C>>0]|0)|0;if(DQa(L&255,q,J,m,p,b[j>>0]|0,k,n,o,i)|0){F=E;G=J;break}C=f[s>>2]|0;if((C|0)==(f[K>>2]|0)){mi[f[(f[z>>2]|0)+40>>2]&255](z)|0;w=z;x=A;v=J;continue}else{f[s>>2]=C+1;jOa(b[C>>0]|0)|0;w=z;x=A;v=J;continue}}J=b[k+11>>0]|0;if((J<<24>>24<0?f[k+4>>2]|0:J&255)|0?(J=f[o>>2]|0,(J-n|0)<160):0){v=f[p>>2]|0;f[o>>2]=J+4;f[J>>2]=v}v=_Qa(G,f[m>>2]|0,g,q)|0;f[h>>2]=v;QQa(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=mi[f[(f[A>>2]|0)+36>>2]&255](z)|0;else M=jOa(b[o>>0]|0)|0;if(aPa(M,iOa()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(F){M=f[F+12>>2]|0;if((M|0)==(f[F+16>>2]|0))O=mi[f[(f[F>>2]|0)+36>>2]&255](F)|0;else O=jOa(b[M>>0]|0)|0;if(!(aPa(O,iOa()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;_Ya(l);_Ya(k);u=a;return g|0}function _Qa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;do if((a|0)==(c|0)){f[d>>2]=4;i=0}else{if((b[a>>0]|0)==45){f[d>>2]=4;i=0;break}j=pKa()|0;k=f[j>>2]|0;j=pKa()|0;f[j>>2]=0;j=yNa(a,h,e,EQa()|0)|0;l=J;m=pKa()|0;n=f[m>>2]|0;if(!n){m=pKa()|0;f[m>>2]=k}do if((f[h>>2]|0)==(c|0))if(l>>>0>0|(l|0)==0&j>>>0>4294967295|(n|0)==34){f[d>>2]=4;o=-1;break}else{o=j;break}else{f[d>>2]=4;o=0}while(0);i=o}while(0);u=g;return i|0}function $Qa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+224|0;i=a+198|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=WQa(e)|0;XQa(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;fZa(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=v;x=v;v=s;a:while(1){if(w){s=f[w+12>>2]|0;if((s|0)==(f[w+16>>2]|0))y=mi[f[(f[w>>2]|0)+36>>2]&255](w)|0;else y=jOa(b[s>>0]|0)|0;if(aPa(y,iOa()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=w;A=x;B=0}}else{z=0;A=0;B=1}s=f[d>>2]|0;do if(s){C=f[s+12>>2]|0;if((C|0)==(f[s+16>>2]|0))D=mi[f[(f[s>>2]|0)+36>>2]&255](s)|0;else D=jOa(b[C>>0]|0)|0;if(!(aPa(D,iOa()|0)|0))if(B){E=s;break}else{F=s;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=0;G=v;break}else E=0}s=b[e>>0]|0;C=s<<24>>24<0?f[t>>2]|0:s&255;if((f[m>>2]|0)==(v+C|0)){fZa(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;fZa(l,I,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s+C;J=s}else J=v;s=z+12|0;C=f[s>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=mi[f[(f[z>>2]|0)+36>>2]&255](z)|0;else L=jOa(b[C>>0]|0)|0;if(DQa(L&255,q,J,m,p,b[j>>0]|0,k,n,o,i)|0){F=E;G=J;break}C=f[s>>2]|0;if((C|0)==(f[K>>2]|0)){mi[f[(f[z>>2]|0)+40>>2]&255](z)|0;w=z;x=A;v=J;continue}else{f[s>>2]=C+1;jOa(b[C>>0]|0)|0;w=z;x=A;v=J;continue}}J=b[k+11>>0]|0;if((J<<24>>24<0?f[k+4>>2]|0:J&255)|0?(J=f[o>>2]|0,(J-n|0)<160):0){v=f[p>>2]|0;f[o>>2]=J+4;f[J>>2]=v}v=aRa(G,f[m>>2]|0,g,q)|0;f[h>>2]=v;QQa(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=mi[f[(f[A>>2]|0)+36>>2]&255](z)|0;else M=jOa(b[o>>0]|0)|0;if(aPa(M,iOa()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(F){M=f[F+12>>2]|0;if((M|0)==(f[F+16>>2]|0))O=mi[f[(f[F>>2]|0)+36>>2]&255](F)|0;else O=jOa(b[M>>0]|0)|0;if(!(aPa(O,iOa()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;_Ya(l);_Ya(k);u=a;return g|0}function aRa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;do if((a|0)==(c|0)){f[d>>2]=4;i=0}else{if((b[a>>0]|0)==45){f[d>>2]=4;i=0;break}j=pKa()|0;k=f[j>>2]|0;j=pKa()|0;f[j>>2]=0;j=yNa(a,h,e,EQa()|0)|0;l=J;m=pKa()|0;n=f[m>>2]|0;if(!n){m=pKa()|0;f[m>>2]=k}do if((f[h>>2]|0)==(c|0))if(l>>>0>0|(l|0)==0&j>>>0>4294967295|(n|0)==34){f[d>>2]=4;o=-1;break}else{o=j;break}else{f[d>>2]=4;o=0}while(0);i=o}while(0);u=g;return i|0}function bRa(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+224|0;j=a+198|0;k=a+196|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;p=a+4|0;q=a;r=WQa(g)|0;XQa(l,g,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;g=0;while(1){if((g|0)==3)break;f[m+(g<<2)>>2]=0;g=g+1|0}g=m+11|0;s=m+8|0;if((b[g>>0]|0)<0)t=(f[s>>2]&2147483647)+-1|0;else t=10;fZa(m,t,0);t=(b[g>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=t;f[p>>2]=o;f[q>>2]=0;v=m+4|0;w=f[c>>2]|0;x=w;y=w;w=t;a:while(1){if(x){t=f[x+12>>2]|0;if((t|0)==(f[x+16>>2]|0))z=mi[f[(f[x>>2]|0)+36>>2]&255](x)|0;else z=jOa(b[t>>0]|0)|0;if(aPa(z,iOa()|0)|0){f[c>>2]=0;A=0;B=0;C=1}else{A=x;B=y;C=0}}else{A=0;B=0;C=1}t=f[e>>2]|0;do if(t){D=f[t+12>>2]|0;if((D|0)==(f[t+16>>2]|0))E=mi[f[(f[t>>2]|0)+36>>2]&255](t)|0;else E=jOa(b[D>>0]|0)|0;if(!(aPa(E,iOa()|0)|0))if(C){F=t;break}else{G=t;H=w;break a}else{f[e>>2]=0;I=19;break}}else I=19;while(0);if((I|0)==19){I=0;if(C){G=0;H=w;break}else F=0}t=b[g>>0]|0;D=t<<24>>24<0?f[v>>2]|0:t&255;if((f[n>>2]|0)==(w+D|0)){fZa(m,D<<1,0);if((b[g>>0]|0)<0)J=(f[s>>2]&2147483647)+-1|0;else J=10;fZa(m,J,0);t=(b[g>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=t+D;K=t}else K=w;t=A+12|0;D=f[t>>2]|0;L=A+16|0;if((D|0)==(f[L>>2]|0))M=mi[f[(f[A>>2]|0)+36>>2]&255](A)|0;else M=jOa(b[D>>0]|0)|0;if(DQa(M&255,r,K,n,q,b[k>>0]|0,l,o,p,j)|0){G=F;H=K;break}D=f[t>>2]|0;if((D|0)==(f[L>>2]|0)){mi[f[(f[A>>2]|0)+40>>2]&255](A)|0;x=A;y=B;w=K;continue}else{f[t>>2]=D+1;jOa(b[D>>0]|0)|0;x=A;y=B;w=K;continue}}K=b[l+11>>0]|0;if((K<<24>>24<0?f[l+4>>2]|0:K&255)|0?(K=f[p>>2]|0,(K-o|0)<160):0){w=f[q>>2]|0;f[p>>2]=K+4;f[K>>2]=w}w=cRa(H,f[n>>2]|0,h,r)|0;d[i>>1]=w;QQa(l,o,f[p>>2]|0,h);if(A){p=f[A+12>>2]|0;if((p|0)==(f[A+16>>2]|0))N=mi[f[(f[B>>2]|0)+36>>2]&255](A)|0;else N=jOa(b[p>>0]|0)|0;if(aPa(N,iOa()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(G){N=f[G+12>>2]|0;if((N|0)==(f[G+16>>2]|0))P=mi[f[(f[G>>2]|0)+36>>2]&255](G)|0;else P=jOa(b[N>>0]|0)|0;if(!(aPa(P,iOa()|0)|0))if(O)break;else{I=49;break}else{f[e>>2]=0;I=47;break}}else I=47;while(0);if((I|0)==47?O:0)I=49;if((I|0)==49)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;_Ya(m);_Ya(l);u=a;return h|0}function cRa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;do if((a|0)==(c|0)){f[d>>2]=4;i=0}else{if((b[a>>0]|0)==45){f[d>>2]=4;i=0;break}j=pKa()|0;k=f[j>>2]|0;j=pKa()|0;f[j>>2]=0;j=yNa(a,h,e,EQa()|0)|0;l=J;m=pKa()|0;n=f[m>>2]|0;if(!n){m=pKa()|0;f[m>>2]=k}do if((f[h>>2]|0)==(c|0))if(l>>>0>0|(l|0)==0&j>>>0>65535|(n|0)==34){f[d>>2]=4;o=-1;break}else{o=j&65535;break}else{f[d>>2]=4;o=0}while(0);i=o}while(0);u=g;return i|0}function dRa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+224|0;i=a+198|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=WQa(e)|0;XQa(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;fZa(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=v;x=v;v=s;a:while(1){if(w){s=f[w+12>>2]|0;if((s|0)==(f[w+16>>2]|0))y=mi[f[(f[w>>2]|0)+36>>2]&255](w)|0;else y=jOa(b[s>>0]|0)|0;if(aPa(y,iOa()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=w;A=x;B=0}}else{z=0;A=0;B=1}s=f[d>>2]|0;do if(s){C=f[s+12>>2]|0;if((C|0)==(f[s+16>>2]|0))D=mi[f[(f[s>>2]|0)+36>>2]&255](s)|0;else D=jOa(b[C>>0]|0)|0;if(!(aPa(D,iOa()|0)|0))if(B){E=s;break}else{F=s;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=0;G=v;break}else E=0}s=b[e>>0]|0;C=s<<24>>24<0?f[t>>2]|0:s&255;if((f[m>>2]|0)==(v+C|0)){fZa(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;fZa(l,I,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s+C;K=s}else K=v;s=z+12|0;C=f[s>>2]|0;L=z+16|0;if((C|0)==(f[L>>2]|0))M=mi[f[(f[z>>2]|0)+36>>2]&255](z)|0;else M=jOa(b[C>>0]|0)|0;if(DQa(M&255,q,K,m,p,b[j>>0]|0,k,n,o,i)|0){F=E;G=K;break}C=f[s>>2]|0;if((C|0)==(f[L>>2]|0)){mi[f[(f[z>>2]|0)+40>>2]&255](z)|0;w=z;x=A;v=K;continue}else{f[s>>2]=C+1;jOa(b[C>>0]|0)|0;w=z;x=A;v=K;continue}}K=b[k+11>>0]|0;if((K<<24>>24<0?f[k+4>>2]|0:K&255)|0?(K=f[o>>2]|0,(K-n|0)<160):0){v=f[p>>2]|0;f[o>>2]=K+4;f[K>>2]=v}v=eRa(G,f[m>>2]|0,g,q)|0;q=h;f[q>>2]=v;f[q+4>>2]=J;QQa(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))N=mi[f[(f[A>>2]|0)+36>>2]&255](z)|0;else N=jOa(b[o>>0]|0)|0;if(aPa(N,iOa()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(F){N=f[F+12>>2]|0;if((N|0)==(f[F+16>>2]|0))P=mi[f[(f[F>>2]|0)+36>>2]&255](F)|0;else P=jOa(b[N>>0]|0)|0;if(!(aPa(P,iOa()|0)|0))if(O)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?O:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;_Ya(l);_Ya(k);u=a;return g|0}function eRa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;if((a|0)==(b|0)){f[c>>2]=4;h=0;i=0}else{j=pKa()|0;k=f[j>>2]|0;j=pKa()|0;f[j>>2]=0;j=zNa(a,g,d,EQa()|0)|0;d=J;a=pKa()|0;l=f[a>>2]|0;if(!l){a=pKa()|0;f[a>>2]=k}if((f[g>>2]|0)==(b|0))if((l|0)==34){f[c>>2]=4;l=(d|0)>0|(d|0)==0&j>>>0>0;m=l?-1:0;n=l?2147483647:-2147483648}else{m=j;n=d}else{f[c>>2]=4;m=0;n=0}h=n;i=m}J=h;u=e;return i|0}function fRa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+224|0;i=a+198|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=WQa(e)|0;XQa(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;fZa(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=v;x=v;v=s;a:while(1){if(w){s=f[w+12>>2]|0;if((s|0)==(f[w+16>>2]|0))y=mi[f[(f[w>>2]|0)+36>>2]&255](w)|0;else y=jOa(b[s>>0]|0)|0;if(aPa(y,iOa()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=w;A=x;B=0}}else{z=0;A=0;B=1}s=f[d>>2]|0;do if(s){C=f[s+12>>2]|0;if((C|0)==(f[s+16>>2]|0))D=mi[f[(f[s>>2]|0)+36>>2]&255](s)|0;else D=jOa(b[C>>0]|0)|0;if(!(aPa(D,iOa()|0)|0))if(B){E=s;break}else{F=s;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=0;G=v;break}else E=0}s=b[e>>0]|0;C=s<<24>>24<0?f[t>>2]|0:s&255;if((f[m>>2]|0)==(v+C|0)){fZa(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;fZa(l,I,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s+C;J=s}else J=v;s=z+12|0;C=f[s>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=mi[f[(f[z>>2]|0)+36>>2]&255](z)|0;else L=jOa(b[C>>0]|0)|0;if(DQa(L&255,q,J,m,p,b[j>>0]|0,k,n,o,i)|0){F=E;G=J;break}C=f[s>>2]|0;if((C|0)==(f[K>>2]|0)){mi[f[(f[z>>2]|0)+40>>2]&255](z)|0;w=z;x=A;v=J;continue}else{f[s>>2]=C+1;jOa(b[C>>0]|0)|0;w=z;x=A;v=J;continue}}J=b[k+11>>0]|0;if((J<<24>>24<0?f[k+4>>2]|0:J&255)|0?(J=f[o>>2]|0,(J-n|0)<160):0){v=f[p>>2]|0;f[o>>2]=J+4;f[J>>2]=v}v=gRa(G,f[m>>2]|0,g,q)|0;f[h>>2]=v;QQa(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=mi[f[(f[A>>2]|0)+36>>2]&255](z)|0;else M=jOa(b[o>>0]|0)|0;if(aPa(M,iOa()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(F){M=f[F+12>>2]|0;if((M|0)==(f[F+16>>2]|0))O=mi[f[(f[F>>2]|0)+36>>2]&255](F)|0;else O=jOa(b[M>>0]|0)|0;if(!(aPa(O,iOa()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;_Ya(l);_Ya(k);u=a;return g|0}function gRa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;if((a|0)==(b|0)){f[c>>2]=4;h=0}else{i=pKa()|0;j=f[i>>2]|0;i=pKa()|0;f[i>>2]=0;i=zNa(a,g,d,EQa()|0)|0;d=J;a=pKa()|0;k=f[a>>2]|0;if(!k){a=pKa()|0;f[a>>2]=j}a:do if((f[g>>2]|0)==(b|0)){do if((k|0)==34){f[c>>2]=4;if((d|0)>0|(d|0)==0&i>>>0>0){l=2147483647;break a}}else{if((d|0)<-1|(d|0)==-1&i>>>0<2147483648){f[c>>2]=4;break}if((d|0)>0|(d|0)==0&i>>>0>2147483647){f[c>>2]=4;l=2147483647;break a}else{l=i;break a}}while(0);l=-2147483648}else{f[c>>2]=4;l=0}while(0);h=l}u=e;return h|0}function hRa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;j=u;u=u+112|0;k=j;l=(e-d|0)/12|0;if(l>>>0>100){m=dKa(l)|0;if(!m)RYa();else{n=m;o=m}}else{n=0;o=k}k=d;m=0;p=l;l=o;while(1){if((k|0)==(e|0))break;q=b[k+11>>0]|0;if(q<<24>>24<0)r=f[k+4>>2]|0;else r=q&255;if(!r){b[l>>0]=2;s=m+1|0;t=p+-1|0}else{b[l>>0]=1;s=m;t=p}k=k+12|0;m=s;p=t;l=l+1|0}l=0;t=m;m=p;a:while(1){p=f[a>>2]|0;do if(p){s=f[p+12>>2]|0;if((s|0)==(f[p+16>>2]|0))v=mi[f[(f[p>>2]|0)+36>>2]&255](p)|0;else v=jOa(b[s>>0]|0)|0;if(aPa(v,iOa()|0)|0){f[a>>2]=0;w=1;break}else{w=(f[a>>2]|0)==0;break}}else w=1;while(0);p=f[c>>2]|0;if(p){s=f[p+12>>2]|0;if((s|0)==(f[p+16>>2]|0))x=mi[f[(f[p>>2]|0)+36>>2]&255](p)|0;else x=jOa(b[s>>0]|0)|0;if(aPa(x,iOa()|0)|0){f[c>>2]=0;y=0;z=1}else{y=p;z=0}}else{y=0;z=1}A=f[a>>2]|0;if(!((m|0)!=0&(w^z)))break;p=f[A+12>>2]|0;if((p|0)==(f[A+16>>2]|0))B=mi[f[(f[A>>2]|0)+36>>2]&255](A)|0;else B=jOa(b[p>>0]|0)|0;p=B&255;if(i)C=p;else C=$h[f[(f[g>>2]|0)+12>>2]&255](g,p)|0;p=l+1|0;s=0;k=d;r=t;q=m;D=o;while(1){if((k|0)==(e|0))break;do if((b[D>>0]|0)==1){E=k+11|0;if((b[E>>0]|0)<0)F=f[k>>2]|0;else F=k;G=b[F+l>>0]|0;if(i)H=G;else H=$h[f[(f[g>>2]|0)+12>>2]&255](g,G)|0;G=q+-1|0;if(C<<24>>24!=H<<24>>24){b[D>>0]=0;I=s;J=r;K=G;break}L=b[E>>0]|0;if(L<<24>>24<0)M=f[k+4>>2]|0;else M=L&255;if((M|0)==(p|0)){b[D>>0]=2;I=1;J=r+1|0;K=G}else{I=1;J=r;K=q}}else{I=s;J=r;K=q}while(0);s=I;k=k+12|0;r=J;q=K;D=D+1|0}if(!s){l=p;t=r;m=q;continue}D=f[a>>2]|0;k=D+12|0;G=f[k>>2]|0;if((G|0)==(f[D+16>>2]|0))mi[f[(f[D>>2]|0)+40>>2]&255](D)|0;else{f[k>>2]=G+1;jOa(b[G>>0]|0)|0}if((r+q|0)>>>0>1){N=d;O=r;P=o}else{l=p;t=r;m=q;continue}while(1){if((N|0)==(e|0)){l=p;t=O;m=q;continue a}if((b[P>>0]|0)==2){G=b[N+11>>0]|0;if(G<<24>>24<0)Q=f[N+4>>2]|0;else Q=G&255;if((Q|0)!=(p|0)){b[P>>0]=0;R=O+-1|0}else R=O}else R=O;N=N+12|0;O=R;P=P+1|0}}do if(A){P=f[A+12>>2]|0;if((P|0)==(f[A+16>>2]|0))S=mi[f[(f[A>>2]|0)+36>>2]&255](A)|0;else S=jOa(b[P>>0]|0)|0;if(aPa(S,iOa()|0)|0){f[a>>2]=0;T=1;break}else{T=(f[a>>2]|0)==0;break}}else T=1;while(0);do if(y){a=f[y+12>>2]|0;if((a|0)==(f[y+16>>2]|0))U=mi[f[(f[y>>2]|0)+36>>2]&255](y)|0;else U=jOa(b[a>>0]|0)|0;if(!(aPa(U,iOa()|0)|0))if(T){V=d;W=o;break}else{X=77;break}else{f[c>>2]=0;X=41;break}}else X=41;while(0);if((X|0)==41)if(T)X=77;else{V=d;W=o}if((X|0)==77){f[h>>2]=f[h>>2]|2;V=d;W=o}while(1){if((V|0)==(e|0)){X=81;break}if((b[W>>0]|0)==2){Y=V;break}V=V+12|0;W=W+1|0}if((X|0)==81){f[h>>2]=f[h>>2]|4;Y=e}eKa(n);u=j;return Y|0}function iRa(a){a=a|0;hQa(a);return}function jRa(a){a=a|0;hQa(a);PYa(a);return}function kRa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;i=u;u=u+48|0;j=i+40|0;k=i+16|0;l=i+8|0;m=i+12|0;n=i+4|0;o=i;if(!(f[e+4>>2]&1)){f[l>>2]=-1;p=f[(f[a>>2]|0)+16>>2]|0;f[m>>2]=f[c>>2];f[n>>2]=f[d>>2];f[k>>2]=f[m>>2];f[j>>2]=f[n>>2];n=bg[p&127](a,k,j,e,g,l)|0;f[c>>2]=n;switch(f[l>>2]|0){case 0:{b[h>>0]=0;break}case 1:{b[h>>0]=1;break}default:{b[h>>0]=1;f[g>>2]=4}}q=f[c>>2]|0}else{bPa(j,e);l=BQa(j,1975208)|0;CQa(j);bPa(j,e);e=BQa(j,1975216)|0;CQa(j);Gh[f[(f[e>>2]|0)+24>>2]&511](k,e);Gh[f[(f[e>>2]|0)+28>>2]&511](k+12|0,e);f[o>>2]=f[d>>2];d=k+24|0;f[j>>2]=f[o>>2];o=(IRa(c,j,k,d,l,g,1)|0)==(k|0)&1;b[h>>0]=o;o=f[c>>2]|0;c=d;do{c=c+-12|0;qZa(c)}while((c|0)!=(k|0));q=o}u=i;return q|0}function lRa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=HRa(a,j,i,d,e,g)|0;u=h;return l|0}function mRa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=GRa(a,j,i,d,e,g)|0;u=h;return l|0}function nRa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=FRa(a,j,i,d,e,g)|0;u=h;return l|0}function oRa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=ERa(a,j,i,d,e,g)|0;u=h;return l|0}function pRa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=DRa(a,j,i,d,e,g)|0;u=h;return l|0}function qRa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=BRa(a,j,i,d,e,g)|0;u=h;return l|0}function rRa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=ARa(a,j,i,d,e,g)|0;u=h;return l|0}function sRa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=zRa(a,j,i,d,e,g)|0;u=h;return l|0}function tRa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=wRa(a,j,i,d,e,g)|0;u=h;return l|0}function uRa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;a=u;u=u+320|0;i=a;j=a+208|0;k=a+192|0;l=a+180|0;m=a+176|0;n=a+16|0;o=a+8|0;p=a+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[k+(q<<2)>>2]=0;q=q+1|0}bPa(l,e);e=BQa(l,1975208)|0;Jg[f[(f[e>>2]|0)+48>>2]&63](e,370101,370127,j)|0;CQa(l);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;q=l+8|0;if((b[e>>0]|0)<0)r=(f[q>>2]&2147483647)+-1|0;else r=10;fZa(l,r,0);r=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=r;f[o>>2]=n;f[p>>2]=0;s=l+4|0;t=f[c>>2]|0;v=t;w=t;t=r;a:while(1){if(v){r=f[v+12>>2]|0;if((r|0)==(f[v+16>>2]|0))x=mi[f[(f[v>>2]|0)+36>>2]&255](v)|0;else x=BOa(f[r>>2]|0)|0;if(cPa(x,AOa()|0)|0){f[c>>2]=0;y=0;z=0;A=1}else{y=v;z=w;A=0}}else{y=0;z=0;A=1}r=f[d>>2]|0;do if(r){B=f[r+12>>2]|0;if((B|0)==(f[r+16>>2]|0))C=mi[f[(f[r>>2]|0)+36>>2]&255](r)|0;else C=BOa(f[B>>2]|0)|0;if(!(cPa(C,AOa()|0)|0))if(A){D=r;break}else{E=r;F=t;break a}else{f[d>>2]=0;G=22;break}}else G=22;while(0);if((G|0)==22){G=0;if(A){E=0;F=t;break}else D=0}r=b[e>>0]|0;B=r<<24>>24<0?f[s>>2]|0:r&255;if((f[m>>2]|0)==(t+B|0)){fZa(l,B<<1,0);if((b[e>>0]|0)<0)H=(f[q>>2]&2147483647)+-1|0;else H=10;fZa(l,H,0);r=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=r+B;I=r}else I=t;r=y+12|0;B=f[r>>2]|0;J=y+16|0;if((B|0)==(f[J>>2]|0))K=mi[f[(f[y>>2]|0)+36>>2]&255](y)|0;else K=BOa(f[B>>2]|0)|0;if(vRa(K,16,I,m,p,0,k,n,o,j)|0){E=D;F=I;break}B=f[r>>2]|0;if((B|0)==(f[J>>2]|0)){mi[f[(f[y>>2]|0)+40>>2]&255](y)|0;v=y;w=z;t=I;continue}else{f[r>>2]=B+4;BOa(f[B>>2]|0)|0;v=y;w=z;t=I;continue}}fZa(l,(f[m>>2]|0)-F|0,0);F=(b[e>>0]|0)<0?f[l>>2]|0:l;e=EQa()|0;f[i>>2]=h;if((FQa(F,e,370134,i)|0)!=1)f[g>>2]=4;if(y){i=f[y+12>>2]|0;if((i|0)==(f[y+16>>2]|0))L=mi[f[(f[z>>2]|0)+36>>2]&255](y)|0;else L=BOa(f[i>>2]|0)|0;if(cPa(L,AOa()|0)|0){f[c>>2]=0;M=1}else M=0}else M=1;do if(E){L=f[E+12>>2]|0;if((L|0)==(f[E+16>>2]|0))N=mi[f[(f[E>>2]|0)+36>>2]&255](E)|0;else N=BOa(f[L>>2]|0)|0;if(!(cPa(N,AOa()|0)|0))if(M)break;else{G=51;break}else{f[d>>2]=0;G=49;break}}else G=49;while(0);if((G|0)==49?M:0)G=51;if((G|0)==51)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;_Ya(l);_Ya(k);u=a;return g|0}function vRa(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;m=f[e>>2]|0;n=(m|0)==(d|0);do if(n){o=(f[l+96>>2]|0)==(a|0);if(!o?(f[l+100>>2]|0)!=(a|0):0){p=5;break}f[e>>2]=d+1;b[d>>0]=o?43:45;f[g>>2]=0;q=0}else p=5;while(0);a:do if((p|0)==5){o=b[i+11>>0]|0;if((a|0)==(h|0)?((o<<24>>24<0?f[i+4>>2]|0:o&255)|0)!=0:0){o=f[k>>2]|0;if((o-j|0)>=160){q=0;break}r=f[g>>2]|0;f[k>>2]=o+4;f[o>>2]=r;f[g>>2]=0;q=0;break}r=l+104|0;o=0;while(1){s=l+(o<<2)|0;if((o|0)==26){t=r;break}if((f[s>>2]|0)==(a|0)){t=s;break}else o=o+1|0}o=t-l|0;r=o>>2;if((o|0)>92)q=-1;else{s=370101+r|0;switch(c|0){case 10:case 8:{if((r|0)>=(c|0)){q=-1;break a}break}case 16:{if((o|0)>=88){if(n){q=-1;break a}if((m-d|0)>=3){q=-1;break a}if((b[m+-1>>0]|0)!=48){q=-1;break a}f[g>>2]=0;o=b[s>>0]|0;f[e>>2]=m+1;b[m>>0]=o;q=0;break a}break}default:{}}o=b[s>>0]|0;f[e>>2]=m+1;b[m>>0]=o;f[g>>2]=(f[g>>2]|0)+1;q=0}}while(0);return q|0}function wRa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+352|0;i=a+208|0;j=a+200|0;k=a+196|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;q=a+4|0;r=a;s=a+337|0;t=a+336|0;xRa(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;fZa(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w;f[q>>2]=o;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=y;A=y;y=w;a:while(1){if(z){w=f[z+12>>2]|0;if((w|0)==(f[z+16>>2]|0))B=mi[f[(f[z>>2]|0)+36>>2]&255](z)|0;else B=BOa(f[w>>2]|0)|0;if(cPa(B,AOa()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=z;D=A;E=0}}else{C=0;D=0;E=1}w=f[d>>2]|0;do if(w){F=f[w+12>>2]|0;if((F|0)==(f[w+16>>2]|0))G=mi[f[(f[w>>2]|0)+36>>2]&255](w)|0;else G=BOa(f[F>>2]|0)|0;if(!(cPa(G,AOa()|0)|0))if(E){H=w;break}else{I=w;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=0;J=y;break}else H=0}w=b[e>>0]|0;F=w<<24>>24<0?f[x>>2]|0:w&255;if((f[n>>2]|0)==(y+F|0)){fZa(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;fZa(m,L,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w+F;M=w}else M=y;w=C+12|0;F=f[w>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=mi[f[(f[C>>2]|0)+36>>2]&255](C)|0;else O=BOa(f[F>>2]|0)|0;if(yRa(O,s,t,M,n,f[j>>2]|0,f[k>>2]|0,l,o,q,r,i)|0){I=H;J=M;break}F=f[w>>2]|0;if((F|0)==(f[N>>2]|0)){mi[f[(f[C>>2]|0)+40>>2]&255](C)|0;z=C;A=D;y=M;continue}else{f[w>>2]=F+4;BOa(f[F>>2]|0)|0;z=C;A=D;y=M;continue}}M=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((M<<24>>24<0?f[l+4>>2]|0:M&255)|0)==0)?(M=f[q>>2]|0,(M-o|0)<160):0){s=f[r>>2]|0;f[q>>2]=M+4;f[M>>2]=s}P=+PQa(J,f[n>>2]|0,g);p[h>>3]=P;QQa(l,o,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=mi[f[(f[D>>2]|0)+36>>2]&255](C)|0;else Q=BOa(f[q>>2]|0)|0;if(cPa(Q,AOa()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(I){Q=f[I+12>>2]|0;if((Q|0)==(f[I+16>>2]|0))S=mi[f[(f[I>>2]|0)+36>>2]&255](I)|0;else S=BOa(f[Q>>2]|0)|0;if(!(cPa(S,AOa()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;_Ya(m);_Ya(l);u=a;return g|0}function xRa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;bPa(h,b);b=BQa(h,1975208)|0;Jg[f[(f[b>>2]|0)+48>>2]&63](b,370101,370133,c)|0;c=BQa(h,1975216)|0;b=mi[f[(f[c>>2]|0)+12>>2]&255](c)|0;f[d>>2]=b;b=mi[f[(f[c>>2]|0)+16>>2]&255](c)|0;f[e>>2]=b;Gh[f[(f[c>>2]|0)+20>>2]&511](a,c);CQa(h);u=g;return}function yRa(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0;o=k;a:do if((a|0)==(h|0))if(b[c>>0]|0){b[c>>0]=0;k=f[g>>2]|0;f[g>>2]=k+1;b[k>>0]=46;k=b[j+11>>0]|0;if(((k<<24>>24<0?f[j+4>>2]|0:k&255)|0)!=0?(k=f[l>>2]|0,(k-o|0)<160):0){p=f[m>>2]|0;f[l>>2]=k+4;f[k>>2]=p;q=0}else q=0}else q=-1;else{if((a|0)==(i|0)?(p=b[j+11>>0]|0,(p<<24>>24<0?f[j+4>>2]|0:p&255)|0):0){if(!(b[c>>0]|0)){q=-1;break}p=f[l>>2]|0;if((p-o|0)>=160){q=0;break}k=f[m>>2]|0;f[l>>2]=p+4;f[p>>2]=k;f[m>>2]=0;q=0;break}k=n+128|0;p=0;while(1){r=n+(p<<2)|0;if((p|0)==32){s=k;break}if((f[r>>2]|0)==(a|0)){s=r;break}else p=p+1|0}p=s-n|0;k=p>>2;if((p|0)<=124){r=b[370101+k>>0]|0;switch(k|0){case 24:case 25:{k=f[g>>2]|0;if((k|0)!=(e|0)?(b[k+-1>>0]&95)!=(b[d>>0]&127):0){q=-1;break a}f[g>>2]=k+1;b[k>>0]=r;q=0;break a;break}case 23:case 22:{b[d>>0]=80;break}default:{k=r&95;if((((k|0)==(b[d>>0]|0)?(b[d>>0]=k|128,b[c>>0]|0):0)?(b[c>>0]=0,k=b[j+11>>0]|0,(k<<24>>24<0?f[j+4>>2]|0:k&255)|0):0)?(k=f[l>>2]|0,(k-o|0)<160):0){t=f[m>>2]|0;f[l>>2]=k+4;f[k>>2]=t}}}t=f[g>>2]|0;f[g>>2]=t+1;b[t>>0]=r;if((p|0)>84)q=0;else{f[m>>2]=(f[m>>2]|0)+1;q=0}}else q=-1}while(0);return q|0}function zRa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+352|0;i=a+208|0;j=a+200|0;k=a+196|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;q=a+4|0;r=a;s=a+337|0;t=a+336|0;xRa(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;fZa(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w;f[q>>2]=o;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=y;A=y;y=w;a:while(1){if(z){w=f[z+12>>2]|0;if((w|0)==(f[z+16>>2]|0))B=mi[f[(f[z>>2]|0)+36>>2]&255](z)|0;else B=BOa(f[w>>2]|0)|0;if(cPa(B,AOa()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=z;D=A;E=0}}else{C=0;D=0;E=1}w=f[d>>2]|0;do if(w){F=f[w+12>>2]|0;if((F|0)==(f[w+16>>2]|0))G=mi[f[(f[w>>2]|0)+36>>2]&255](w)|0;else G=BOa(f[F>>2]|0)|0;if(!(cPa(G,AOa()|0)|0))if(E){H=w;break}else{I=w;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=0;J=y;break}else H=0}w=b[e>>0]|0;F=w<<24>>24<0?f[x>>2]|0:w&255;if((f[n>>2]|0)==(y+F|0)){fZa(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;fZa(m,L,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w+F;M=w}else M=y;w=C+12|0;F=f[w>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=mi[f[(f[C>>2]|0)+36>>2]&255](C)|0;else O=BOa(f[F>>2]|0)|0;if(yRa(O,s,t,M,n,f[j>>2]|0,f[k>>2]|0,l,o,q,r,i)|0){I=H;J=M;break}F=f[w>>2]|0;if((F|0)==(f[N>>2]|0)){mi[f[(f[C>>2]|0)+40>>2]&255](C)|0;z=C;A=D;y=M;continue}else{f[w>>2]=F+4;BOa(f[F>>2]|0)|0;z=C;A=D;y=M;continue}}M=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((M<<24>>24<0?f[l+4>>2]|0:M&255)|0)==0)?(M=f[q>>2]|0,(M-o|0)<160):0){s=f[r>>2]|0;f[q>>2]=M+4;f[M>>2]=s}P=+SQa(J,f[n>>2]|0,g);p[h>>3]=P;QQa(l,o,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=mi[f[(f[D>>2]|0)+36>>2]&255](C)|0;else Q=BOa(f[q>>2]|0)|0;if(cPa(Q,AOa()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(I){Q=f[I+12>>2]|0;if((Q|0)==(f[I+16>>2]|0))S=mi[f[(f[I>>2]|0)+36>>2]&255](I)|0;else S=BOa(f[Q>>2]|0)|0;if(!(cPa(S,AOa()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;_Ya(m);_Ya(l);u=a;return g|0}function ARa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+352|0;i=a+208|0;j=a+200|0;k=a+196|0;l=a+184|0;m=a+172|0;o=a+168|0;p=a+8|0;q=a+4|0;r=a;s=a+337|0;t=a+336|0;xRa(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;fZa(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[o>>2]=w;f[q>>2]=p;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=y;A=y;y=w;a:while(1){if(z){w=f[z+12>>2]|0;if((w|0)==(f[z+16>>2]|0))B=mi[f[(f[z>>2]|0)+36>>2]&255](z)|0;else B=BOa(f[w>>2]|0)|0;if(cPa(B,AOa()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=z;D=A;E=0}}else{C=0;D=0;E=1}w=f[d>>2]|0;do if(w){F=f[w+12>>2]|0;if((F|0)==(f[w+16>>2]|0))G=mi[f[(f[w>>2]|0)+36>>2]&255](w)|0;else G=BOa(f[F>>2]|0)|0;if(!(cPa(G,AOa()|0)|0))if(E){H=w;break}else{I=w;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=0;J=y;break}else H=0}w=b[e>>0]|0;F=w<<24>>24<0?f[x>>2]|0:w&255;if((f[o>>2]|0)==(y+F|0)){fZa(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;fZa(m,L,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[o>>2]=w+F;M=w}else M=y;w=C+12|0;F=f[w>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=mi[f[(f[C>>2]|0)+36>>2]&255](C)|0;else O=BOa(f[F>>2]|0)|0;if(yRa(O,s,t,M,o,f[j>>2]|0,f[k>>2]|0,l,p,q,r,i)|0){I=H;J=M;break}F=f[w>>2]|0;if((F|0)==(f[N>>2]|0)){mi[f[(f[C>>2]|0)+40>>2]&255](C)|0;z=C;A=D;y=M;continue}else{f[w>>2]=F+4;BOa(f[F>>2]|0)|0;z=C;A=D;y=M;continue}}M=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((M<<24>>24<0?f[l+4>>2]|0:M&255)|0)==0)?(M=f[q>>2]|0,(M-p|0)<160):0){s=f[r>>2]|0;f[q>>2]=M+4;f[M>>2]=s}P=+UQa(J,f[o>>2]|0,g);n[h>>2]=P;QQa(l,p,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=mi[f[(f[D>>2]|0)+36>>2]&255](C)|0;else Q=BOa(f[q>>2]|0)|0;if(cPa(Q,AOa()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(I){Q=f[I+12>>2]|0;if((Q|0)==(f[I+16>>2]|0))S=mi[f[(f[I>>2]|0)+36>>2]&255](I)|0;else S=BOa(f[Q>>2]|0)|0;if(!(cPa(S,AOa()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;_Ya(m);_Ya(l);u=a;return g|0}function BRa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+304|0;i=a+200|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=WQa(e)|0;CRa(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;fZa(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=v;x=v;v=s;a:while(1){if(w){s=f[w+12>>2]|0;if((s|0)==(f[w+16>>2]|0))y=mi[f[(f[w>>2]|0)+36>>2]&255](w)|0;else y=BOa(f[s>>2]|0)|0;if(cPa(y,AOa()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=w;A=x;B=0}}else{z=0;A=0;B=1}s=f[d>>2]|0;do if(s){C=f[s+12>>2]|0;if((C|0)==(f[s+16>>2]|0))D=mi[f[(f[s>>2]|0)+36>>2]&255](s)|0;else D=BOa(f[C>>2]|0)|0;if(!(cPa(D,AOa()|0)|0))if(B){E=s;break}else{F=s;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=0;G=v;break}else E=0}s=b[e>>0]|0;C=s<<24>>24<0?f[t>>2]|0:s&255;if((f[m>>2]|0)==(v+C|0)){fZa(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;fZa(l,I,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s+C;K=s}else K=v;s=z+12|0;C=f[s>>2]|0;L=z+16|0;if((C|0)==(f[L>>2]|0))M=mi[f[(f[z>>2]|0)+36>>2]&255](z)|0;else M=BOa(f[C>>2]|0)|0;if(vRa(M,q,K,m,p,f[j>>2]|0,k,n,o,i)|0){F=E;G=K;break}C=f[s>>2]|0;if((C|0)==(f[L>>2]|0)){mi[f[(f[z>>2]|0)+40>>2]&255](z)|0;w=z;x=A;v=K;continue}else{f[s>>2]=C+4;BOa(f[C>>2]|0)|0;w=z;x=A;v=K;continue}}K=b[k+11>>0]|0;if((K<<24>>24<0?f[k+4>>2]|0:K&255)|0?(K=f[o>>2]|0,(K-n|0)<160):0){v=f[p>>2]|0;f[o>>2]=K+4;f[K>>2]=v}v=YQa(G,f[m>>2]|0,g,q)|0;q=h;f[q>>2]=v;f[q+4>>2]=J;QQa(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))N=mi[f[(f[A>>2]|0)+36>>2]&255](z)|0;else N=BOa(f[o>>2]|0)|0;if(cPa(N,AOa()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(F){N=f[F+12>>2]|0;if((N|0)==(f[F+16>>2]|0))P=mi[f[(f[F>>2]|0)+36>>2]&255](F)|0;else P=BOa(f[N>>2]|0)|0;if(!(cPa(P,AOa()|0)|0))if(O)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?O:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;_Ya(l);_Ya(k);u=a;return g|0}function CRa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;bPa(g,b);b=BQa(g,1975208)|0;Jg[f[(f[b>>2]|0)+48>>2]&63](b,370101,370127,c)|0;c=BQa(g,1975216)|0;b=mi[f[(f[c>>2]|0)+16>>2]&255](c)|0;f[d>>2]=b;Gh[f[(f[c>>2]|0)+20>>2]&511](a,c);CQa(g);u=e;return}function DRa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+304|0;i=a+200|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=WQa(e)|0;CRa(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;fZa(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=v;x=v;v=s;a:while(1){if(w){s=f[w+12>>2]|0;if((s|0)==(f[w+16>>2]|0))y=mi[f[(f[w>>2]|0)+36>>2]&255](w)|0;else y=BOa(f[s>>2]|0)|0;if(cPa(y,AOa()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=w;A=x;B=0}}else{z=0;A=0;B=1}s=f[d>>2]|0;do if(s){C=f[s+12>>2]|0;if((C|0)==(f[s+16>>2]|0))D=mi[f[(f[s>>2]|0)+36>>2]&255](s)|0;else D=BOa(f[C>>2]|0)|0;if(!(cPa(D,AOa()|0)|0))if(B){E=s;break}else{F=s;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=0;G=v;break}else E=0}s=b[e>>0]|0;C=s<<24>>24<0?f[t>>2]|0:s&255;if((f[m>>2]|0)==(v+C|0)){fZa(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;fZa(l,I,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s+C;J=s}else J=v;s=z+12|0;C=f[s>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=mi[f[(f[z>>2]|0)+36>>2]&255](z)|0;else L=BOa(f[C>>2]|0)|0;if(vRa(L,q,J,m,p,f[j>>2]|0,k,n,o,i)|0){F=E;G=J;break}C=f[s>>2]|0;if((C|0)==(f[K>>2]|0)){mi[f[(f[z>>2]|0)+40>>2]&255](z)|0;w=z;x=A;v=J;continue}else{f[s>>2]=C+4;BOa(f[C>>2]|0)|0;w=z;x=A;v=J;continue}}J=b[k+11>>0]|0;if((J<<24>>24<0?f[k+4>>2]|0:J&255)|0?(J=f[o>>2]|0,(J-n|0)<160):0){v=f[p>>2]|0;f[o>>2]=J+4;f[J>>2]=v}v=_Qa(G,f[m>>2]|0,g,q)|0;f[h>>2]=v;QQa(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=mi[f[(f[A>>2]|0)+36>>2]&255](z)|0;else M=BOa(f[o>>2]|0)|0;if(cPa(M,AOa()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(F){M=f[F+12>>2]|0;if((M|0)==(f[F+16>>2]|0))O=mi[f[(f[F>>2]|0)+36>>2]&255](F)|0;else O=BOa(f[M>>2]|0)|0;if(!(cPa(O,AOa()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;_Ya(l);_Ya(k);u=a;return g|0}function ERa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+304|0;i=a+200|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=WQa(e)|0;CRa(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;fZa(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=v;x=v;v=s;a:while(1){if(w){s=f[w+12>>2]|0;if((s|0)==(f[w+16>>2]|0))y=mi[f[(f[w>>2]|0)+36>>2]&255](w)|0;else y=BOa(f[s>>2]|0)|0;if(cPa(y,AOa()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=w;A=x;B=0}}else{z=0;A=0;B=1}s=f[d>>2]|0;do if(s){C=f[s+12>>2]|0;if((C|0)==(f[s+16>>2]|0))D=mi[f[(f[s>>2]|0)+36>>2]&255](s)|0;else D=BOa(f[C>>2]|0)|0;if(!(cPa(D,AOa()|0)|0))if(B){E=s;break}else{F=s;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=0;G=v;break}else E=0}s=b[e>>0]|0;C=s<<24>>24<0?f[t>>2]|0:s&255;if((f[m>>2]|0)==(v+C|0)){fZa(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;fZa(l,I,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s+C;J=s}else J=v;s=z+12|0;C=f[s>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=mi[f[(f[z>>2]|0)+36>>2]&255](z)|0;else L=BOa(f[C>>2]|0)|0;if(vRa(L,q,J,m,p,f[j>>2]|0,k,n,o,i)|0){F=E;G=J;break}C=f[s>>2]|0;if((C|0)==(f[K>>2]|0)){mi[f[(f[z>>2]|0)+40>>2]&255](z)|0;w=z;x=A;v=J;continue}else{f[s>>2]=C+4;BOa(f[C>>2]|0)|0;w=z;x=A;v=J;continue}}J=b[k+11>>0]|0;if((J<<24>>24<0?f[k+4>>2]|0:J&255)|0?(J=f[o>>2]|0,(J-n|0)<160):0){v=f[p>>2]|0;f[o>>2]=J+4;f[J>>2]=v}v=aRa(G,f[m>>2]|0,g,q)|0;f[h>>2]=v;QQa(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=mi[f[(f[A>>2]|0)+36>>2]&255](z)|0;else M=BOa(f[o>>2]|0)|0;if(cPa(M,AOa()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(F){M=f[F+12>>2]|0;if((M|0)==(f[F+16>>2]|0))O=mi[f[(f[F>>2]|0)+36>>2]&255](F)|0;else O=BOa(f[M>>2]|0)|0;if(!(cPa(O,AOa()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;_Ya(l);_Ya(k);u=a;return g|0}function FRa(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+304|0;j=a+200|0;k=a+196|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;p=a+4|0;q=a;r=WQa(g)|0;CRa(l,g,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;g=0;while(1){if((g|0)==3)break;f[m+(g<<2)>>2]=0;g=g+1|0}g=m+11|0;s=m+8|0;if((b[g>>0]|0)<0)t=(f[s>>2]&2147483647)+-1|0;else t=10;fZa(m,t,0);t=(b[g>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=t;f[p>>2]=o;f[q>>2]=0;v=m+4|0;w=f[c>>2]|0;x=w;y=w;w=t;a:while(1){if(x){t=f[x+12>>2]|0;if((t|0)==(f[x+16>>2]|0))z=mi[f[(f[x>>2]|0)+36>>2]&255](x)|0;else z=BOa(f[t>>2]|0)|0;if(cPa(z,AOa()|0)|0){f[c>>2]=0;A=0;B=0;C=1}else{A=x;B=y;C=0}}else{A=0;B=0;C=1}t=f[e>>2]|0;do if(t){D=f[t+12>>2]|0;if((D|0)==(f[t+16>>2]|0))E=mi[f[(f[t>>2]|0)+36>>2]&255](t)|0;else E=BOa(f[D>>2]|0)|0;if(!(cPa(E,AOa()|0)|0))if(C){F=t;break}else{G=t;H=w;break a}else{f[e>>2]=0;I=19;break}}else I=19;while(0);if((I|0)==19){I=0;if(C){G=0;H=w;break}else F=0}t=b[g>>0]|0;D=t<<24>>24<0?f[v>>2]|0:t&255;if((f[n>>2]|0)==(w+D|0)){fZa(m,D<<1,0);if((b[g>>0]|0)<0)J=(f[s>>2]&2147483647)+-1|0;else J=10;fZa(m,J,0);t=(b[g>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=t+D;K=t}else K=w;t=A+12|0;D=f[t>>2]|0;L=A+16|0;if((D|0)==(f[L>>2]|0))M=mi[f[(f[A>>2]|0)+36>>2]&255](A)|0;else M=BOa(f[D>>2]|0)|0;if(vRa(M,r,K,n,q,f[k>>2]|0,l,o,p,j)|0){G=F;H=K;break}D=f[t>>2]|0;if((D|0)==(f[L>>2]|0)){mi[f[(f[A>>2]|0)+40>>2]&255](A)|0;x=A;y=B;w=K;continue}else{f[t>>2]=D+4;BOa(f[D>>2]|0)|0;x=A;y=B;w=K;continue}}K=b[l+11>>0]|0;if((K<<24>>24<0?f[l+4>>2]|0:K&255)|0?(K=f[p>>2]|0,(K-o|0)<160):0){w=f[q>>2]|0;f[p>>2]=K+4;f[K>>2]=w}w=cRa(H,f[n>>2]|0,h,r)|0;d[i>>1]=w;QQa(l,o,f[p>>2]|0,h);if(A){p=f[A+12>>2]|0;if((p|0)==(f[A+16>>2]|0))N=mi[f[(f[B>>2]|0)+36>>2]&255](A)|0;else N=BOa(f[p>>2]|0)|0;if(cPa(N,AOa()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(G){N=f[G+12>>2]|0;if((N|0)==(f[G+16>>2]|0))P=mi[f[(f[G>>2]|0)+36>>2]&255](G)|0;else P=BOa(f[N>>2]|0)|0;if(!(cPa(P,AOa()|0)|0))if(O)break;else{I=49;break}else{f[e>>2]=0;I=47;break}}else I=47;while(0);if((I|0)==47?O:0)I=49;if((I|0)==49)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;_Ya(m);_Ya(l);u=a;return h|0}function GRa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+304|0;i=a+200|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=WQa(e)|0;CRa(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;fZa(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=v;x=v;v=s;a:while(1){if(w){s=f[w+12>>2]|0;if((s|0)==(f[w+16>>2]|0))y=mi[f[(f[w>>2]|0)+36>>2]&255](w)|0;else y=BOa(f[s>>2]|0)|0;if(cPa(y,AOa()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=w;A=x;B=0}}else{z=0;A=0;B=1}s=f[d>>2]|0;do if(s){C=f[s+12>>2]|0;if((C|0)==(f[s+16>>2]|0))D=mi[f[(f[s>>2]|0)+36>>2]&255](s)|0;else D=BOa(f[C>>2]|0)|0;if(!(cPa(D,AOa()|0)|0))if(B){E=s;break}else{F=s;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=0;G=v;break}else E=0}s=b[e>>0]|0;C=s<<24>>24<0?f[t>>2]|0:s&255;if((f[m>>2]|0)==(v+C|0)){fZa(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;fZa(l,I,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s+C;K=s}else K=v;s=z+12|0;C=f[s>>2]|0;L=z+16|0;if((C|0)==(f[L>>2]|0))M=mi[f[(f[z>>2]|0)+36>>2]&255](z)|0;else M=BOa(f[C>>2]|0)|0;if(vRa(M,q,K,m,p,f[j>>2]|0,k,n,o,i)|0){F=E;G=K;break}C=f[s>>2]|0;if((C|0)==(f[L>>2]|0)){mi[f[(f[z>>2]|0)+40>>2]&255](z)|0;w=z;x=A;v=K;continue}else{f[s>>2]=C+4;BOa(f[C>>2]|0)|0;w=z;x=A;v=K;continue}}K=b[k+11>>0]|0;if((K<<24>>24<0?f[k+4>>2]|0:K&255)|0?(K=f[o>>2]|0,(K-n|0)<160):0){v=f[p>>2]|0;f[o>>2]=K+4;f[K>>2]=v}v=eRa(G,f[m>>2]|0,g,q)|0;q=h;f[q>>2]=v;f[q+4>>2]=J;QQa(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))N=mi[f[(f[A>>2]|0)+36>>2]&255](z)|0;else N=BOa(f[o>>2]|0)|0;if(cPa(N,AOa()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(F){N=f[F+12>>2]|0;if((N|0)==(f[F+16>>2]|0))P=mi[f[(f[F>>2]|0)+36>>2]&255](F)|0;else P=BOa(f[N>>2]|0)|0;if(!(cPa(P,AOa()|0)|0))if(O)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?O:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;_Ya(l);_Ya(k);u=a;return g|0}function HRa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+304|0;i=a+200|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=WQa(e)|0;CRa(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;fZa(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=v;x=v;v=s;a:while(1){if(w){s=f[w+12>>2]|0;if((s|0)==(f[w+16>>2]|0))y=mi[f[(f[w>>2]|0)+36>>2]&255](w)|0;else y=BOa(f[s>>2]|0)|0;if(cPa(y,AOa()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=w;A=x;B=0}}else{z=0;A=0;B=1}s=f[d>>2]|0;do if(s){C=f[s+12>>2]|0;if((C|0)==(f[s+16>>2]|0))D=mi[f[(f[s>>2]|0)+36>>2]&255](s)|0;else D=BOa(f[C>>2]|0)|0;if(!(cPa(D,AOa()|0)|0))if(B){E=s;break}else{F=s;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=0;G=v;break}else E=0}s=b[e>>0]|0;C=s<<24>>24<0?f[t>>2]|0:s&255;if((f[m>>2]|0)==(v+C|0)){fZa(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;fZa(l,I,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s+C;J=s}else J=v;s=z+12|0;C=f[s>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=mi[f[(f[z>>2]|0)+36>>2]&255](z)|0;else L=BOa(f[C>>2]|0)|0;if(vRa(L,q,J,m,p,f[j>>2]|0,k,n,o,i)|0){F=E;G=J;break}C=f[s>>2]|0;if((C|0)==(f[K>>2]|0)){mi[f[(f[z>>2]|0)+40>>2]&255](z)|0;w=z;x=A;v=J;continue}else{f[s>>2]=C+4;BOa(f[C>>2]|0)|0;w=z;x=A;v=J;continue}}J=b[k+11>>0]|0;if((J<<24>>24<0?f[k+4>>2]|0:J&255)|0?(J=f[o>>2]|0,(J-n|0)<160):0){v=f[p>>2]|0;f[o>>2]=J+4;f[J>>2]=v}v=gRa(G,f[m>>2]|0,g,q)|0;f[h>>2]=v;QQa(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=mi[f[(f[A>>2]|0)+36>>2]&255](z)|0;else M=BOa(f[o>>2]|0)|0;if(cPa(M,AOa()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(F){M=f[F+12>>2]|0;if((M|0)==(f[F+16>>2]|0))O=mi[f[(f[F>>2]|0)+36>>2]&255](F)|0;else O=BOa(f[M>>2]|0)|0;if(!(cPa(O,AOa()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;_Ya(l);_Ya(k);u=a;return g|0}function IRa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;j=u;u=u+112|0;k=j;l=(e-d|0)/12|0;if(l>>>0>100){m=dKa(l)|0;if(!m)RYa();else{n=m;o=m}}else{n=0;o=k}k=d;m=0;p=l;l=o;while(1){if((k|0)==(e|0))break;q=b[k+8+3>>0]|0;if(q<<24>>24<0)r=f[k+4>>2]|0;else r=q&255;if(!r){b[l>>0]=2;s=m+1|0;t=p+-1|0}else{b[l>>0]=1;s=m;t=p}k=k+12|0;m=s;p=t;l=l+1|0}l=0;t=m;m=p;a:while(1){p=f[a>>2]|0;do if(p){s=f[p+12>>2]|0;if((s|0)==(f[p+16>>2]|0))v=mi[f[(f[p>>2]|0)+36>>2]&255](p)|0;else v=BOa(f[s>>2]|0)|0;if(cPa(v,AOa()|0)|0){f[a>>2]=0;w=1;break}else{w=(f[a>>2]|0)==0;break}}else w=1;while(0);p=f[c>>2]|0;if(p){s=f[p+12>>2]|0;if((s|0)==(f[p+16>>2]|0))x=mi[f[(f[p>>2]|0)+36>>2]&255](p)|0;else x=BOa(f[s>>2]|0)|0;if(cPa(x,AOa()|0)|0){f[c>>2]=0;y=0;z=1}else{y=p;z=0}}else{y=0;z=1}A=f[a>>2]|0;if(!((m|0)!=0&(w^z)))break;p=f[A+12>>2]|0;if((p|0)==(f[A+16>>2]|0))B=mi[f[(f[A>>2]|0)+36>>2]&255](A)|0;else B=BOa(f[p>>2]|0)|0;if(i)C=B;else C=$h[f[(f[g>>2]|0)+28>>2]&255](g,B)|0;p=l+1|0;s=0;k=d;r=t;q=m;D=o;while(1){if((k|0)==(e|0))break;do if((b[D>>0]|0)==1){E=k+8+3|0;if((b[E>>0]|0)<0)F=f[k>>2]|0;else F=k;G=f[F+(l<<2)>>2]|0;if(i)H=G;else H=$h[f[(f[g>>2]|0)+28>>2]&255](g,G)|0;G=q+-1|0;if((C|0)!=(H|0)){b[D>>0]=0;I=s;J=r;K=G;break}L=b[E>>0]|0;if(L<<24>>24<0)M=f[k+4>>2]|0;else M=L&255;if((M|0)==(p|0)){b[D>>0]=2;I=1;J=r+1|0;K=G}else{I=1;J=r;K=q}}else{I=s;J=r;K=q}while(0);s=I;k=k+12|0;r=J;q=K;D=D+1|0}if(!s){l=p;t=r;m=q;continue}D=f[a>>2]|0;k=D+12|0;G=f[k>>2]|0;if((G|0)==(f[D+16>>2]|0))mi[f[(f[D>>2]|0)+40>>2]&255](D)|0;else{f[k>>2]=G+4;BOa(f[G>>2]|0)|0}if((r+q|0)>>>0>1){N=d;O=r;P=o}else{l=p;t=r;m=q;continue}while(1){if((N|0)==(e|0)){l=p;t=O;m=q;continue a}if((b[P>>0]|0)==2){G=b[N+8+3>>0]|0;if(G<<24>>24<0)Q=f[N+4>>2]|0;else Q=G&255;if((Q|0)!=(p|0)){b[P>>0]=0;R=O+-1|0}else R=O}else R=O;N=N+12|0;O=R;P=P+1|0}}do if(A){P=f[A+12>>2]|0;if((P|0)==(f[A+16>>2]|0))S=mi[f[(f[A>>2]|0)+36>>2]&255](A)|0;else S=BOa(f[P>>2]|0)|0;if(cPa(S,AOa()|0)|0){f[a>>2]=0;T=1;break}else{T=(f[a>>2]|0)==0;break}}else T=1;while(0);do if(y){a=f[y+12>>2]|0;if((a|0)==(f[y+16>>2]|0))U=mi[f[(f[y>>2]|0)+36>>2]&255](y)|0;else U=BOa(f[a>>2]|0)|0;if(!(cPa(U,AOa()|0)|0))if(T){V=d;W=o;break}else{X=77;break}else{f[c>>2]=0;X=41;break}}else X=41;while(0);if((X|0)==41)if(T)X=77;else{V=d;W=o}if((X|0)==77){f[h>>2]=f[h>>2]|2;V=d;W=o}while(1){if((V|0)==(e|0)){X=81;break}if((b[W>>0]|0)==2){Y=V;break}V=V+12|0;W=W+1|0}if((X|0)==81){f[h>>2]=f[h>>2]|4;Y=e}eKa(n);u=j;return Y|0}function JRa(a){a=a|0;hQa(a);return}function KRa(a){a=a|0;hQa(a);PYa(a);return}function LRa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=u;u=u+16|0;i=h+4|0;j=h;if(!(f[d+4>>2]&1)){k=f[(f[a>>2]|0)+24>>2]|0;f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];l=uh[k&63](a,i,d,e,g&1)|0}else{bPa(i,d);d=BQa(i,1975192)|0;CQa(i);e=f[d>>2]|0;if(g)Gh[f[e+24>>2]&511](i,d);else Gh[f[e+28>>2]&511](i,d);d=i+11|0;e=b[d>>0]|0;if(e<<24>>24<0){m=e;n=f[i>>2]|0;o=8}else{p=e;q=i}while(1){if((o|0)==8){o=0;p=m;q=n}e=p<<24>>24<0;if((q|0)==((e?f[i>>2]|0:i)+(e?f[i+4>>2]|0:p&255)|0))break;e=b[q>>0]|0;g=f[c>>2]|0;if(g|0){a=g+24|0;k=f[a>>2]|0;if((k|0)==(f[g+28>>2]|0)){j=f[(f[g>>2]|0)+52>>2]|0;r=jOa(e)|0;s=$h[j&255](g,r)|0}else{f[a>>2]=k+1;b[k>>0]=e;s=jOa(e)|0}if(aPa(s,iOa()|0)|0)f[c>>2]=0}m=b[d>>0]|0;n=q+1|0;o=8}o=f[c>>2]|0;_Ya(i);l=o}u=h;return l|0}function MRa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+64|0;h=a;i=a+52|0;j=a+39|0;k=a+16|0;l=a+12|0;m=a+4|0;n=a+8|0;b[i>>0]=b[370352]|0;b[i+1>>0]=b[370353]|0;b[i+2>>0]=b[370354]|0;b[i+3>>0]=b[370355]|0;b[i+4>>0]=b[370356]|0;b[i+5>>0]=b[370357]|0;YRa(i+1|0,374278,1,f[d+4>>2]|0);o=EQa()|0;f[h>>2]=g;g=j+(TRa(j,13,o,i,h)|0)|0;i=URa(j,g,d)|0;bPa(h,d);ZRa(j,i,g,k,l,m,h);CQa(h);f[n>>2]=f[c>>2];c=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=KU(h,k,c,l,d,e)|0;u=a;return n|0}function NRa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+96|0;h=a+8|0;i=a;j=a+71|0;k=a+28|0;l=a+24|0;m=a+16|0;n=a+20|0;o=i;f[o>>2]=37;f[o+4>>2]=0;YRa(i+1|0,374283,1,f[c+4>>2]|0);o=EQa()|0;p=h;f[p>>2]=e;f[p+4>>2]=g;g=j+(TRa(j,23,o,i,h)|0)|0;i=URa(j,g,c)|0;bPa(h,c);ZRa(j,i,g,k,l,m,h);CQa(h);f[n>>2]=f[b>>2];b=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=KU(h,k,b,l,c,d)|0;u=a;return n|0}function ORa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+64|0;h=a;i=a+52|0;j=a+40|0;k=a+16|0;l=a+12|0;m=a+4|0;n=a+8|0;b[i>>0]=b[370352]|0;b[i+1>>0]=b[370353]|0;b[i+2>>0]=b[370354]|0;b[i+3>>0]=b[370355]|0;b[i+4>>0]=b[370356]|0;b[i+5>>0]=b[370357]|0;YRa(i+1|0,374278,0,f[d+4>>2]|0);o=EQa()|0;f[h>>2]=g;g=j+(TRa(j,12,o,i,h)|0)|0;i=URa(j,g,d)|0;bPa(h,d);ZRa(j,i,g,k,l,m,h);CQa(h);f[n>>2]=f[c>>2];c=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=KU(h,k,c,l,d,e)|0;u=a;return n|0}function PRa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+96|0;h=a+8|0;i=a;j=a+71|0;k=a+28|0;l=a+24|0;m=a+16|0;n=a+20|0;o=i;f[o>>2]=37;f[o+4>>2]=0;YRa(i+1|0,374283,0,f[c+4>>2]|0);o=EQa()|0;p=h;f[p>>2]=e;f[p+4>>2]=g;g=j+(TRa(j,23,o,i,h)|0)|0;i=URa(j,g,c)|0;bPa(h,c);ZRa(j,i,g,k,l,m,h);CQa(h);f[n>>2]=f[b>>2];b=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=KU(h,k,b,l,c,d)|0;u=a;return n|0}function QRa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;a=u;u=u+176|0;g=a+72|0;h=a+48|0;i=a+32|0;j=a+24|0;k=a+8|0;l=a;m=a+134|0;n=a+68|0;o=a+76|0;q=a+64|0;r=a+60|0;s=a+56|0;t=l;f[t>>2]=37;f[t+4>>2]=0;t=VRa(l+1|0,5694105,f[c+4>>2]|0)|0;f[n>>2]=m;v=EQa()|0;if(t){f[k>>2]=f[c+8>>2];p[k+8>>3]=e;w=TRa(m,30,v,l,k)|0}else{p[j>>3]=e;w=TRa(m,30,v,l,j)|0}if((w|0)>29){j=EQa()|0;if(t){f[i>>2]=f[c+8>>2];p[i+8>>3]=e;x=WRa(n,j,l,i)|0}else{p[h>>3]=e;x=WRa(n,j,l,h)|0}h=f[n>>2]|0;if(!h)RYa();else{y=h;z=h;A=x}}else{y=f[n>>2]|0;z=0;A=w}w=y+A|0;n=URa(y,w,c)|0;if((y|0)!=(m|0)){m=dKa(A<<1)|0;if(!m)RYa();else{B=m;C=m}}else{B=o;C=0}bPa(g,c);XRa(y,n,w,B,q,r,g);CQa(g);f[s>>2]=f[b>>2];b=f[q>>2]|0;q=f[r>>2]|0;f[g>>2]=f[s>>2];s=KU(g,B,b,q,c,d)|0;eKa(C);eKa(z);u=a;return s|0}function RRa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;a=u;u=u+176|0;g=a+72|0;h=a+48|0;i=a+32|0;j=a+24|0;k=a+8|0;l=a;m=a+134|0;n=a+68|0;o=a+76|0;q=a+64|0;r=a+60|0;s=a+56|0;t=l;f[t>>2]=37;f[t+4>>2]=0;t=VRa(l+1|0,370350,f[c+4>>2]|0)|0;f[n>>2]=m;v=EQa()|0;if(t){f[k>>2]=f[c+8>>2];p[k+8>>3]=e;w=TRa(m,30,v,l,k)|0}else{p[j>>3]=e;w=TRa(m,30,v,l,j)|0}if((w|0)>29){j=EQa()|0;if(t){f[i>>2]=f[c+8>>2];p[i+8>>3]=e;x=WRa(n,j,l,i)|0}else{p[h>>3]=e;x=WRa(n,j,l,h)|0}h=f[n>>2]|0;if(!h)RYa();else{y=h;z=h;A=x}}else{y=f[n>>2]|0;z=0;A=w}w=y+A|0;n=URa(y,w,c)|0;if((y|0)!=(m|0)){m=dKa(A<<1)|0;if(!m)RYa();else{B=m;C=m}}else{B=o;C=0}bPa(g,c);XRa(y,n,w,B,q,r,g);CQa(g);f[s>>2]=f[b>>2];b=f[q>>2]|0;q=f[r>>2]|0;f[g>>2]=f[s>>2];s=KU(g,B,b,q,c,d)|0;eKa(C);eKa(z);u=a;return s|0}function SRa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+80|0;h=a;i=a+68|0;j=a+48|0;k=a+8|0;l=a+4|0;b[i>>0]=b[370344]|0;b[i+1>>0]=b[370345]|0;b[i+2>>0]=b[370346]|0;b[i+3>>0]=b[370347]|0;b[i+4>>0]=b[370348]|0;b[i+5>>0]=b[370349]|0;m=EQa()|0;f[h>>2]=g;g=TRa(j,20,m,i,h)|0;i=j+g|0;m=URa(j,i,d)|0;bPa(h,d);n=BQa(h,1975176)|0;CQa(h);Jg[f[(f[n>>2]|0)+32>>2]&63](n,j,i,k)|0;n=k+g|0;f[l>>2]=f[c>>2];f[h>>2]=f[l>>2];l=KU(h,k,(m|0)==(i|0)?n:k+(m-j)|0,n,d,e)|0;u=a;return l|0}function TRa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=e;e=ANa(c)|0;c=qLa(a,b,d,h)|0;if(e|0)ANa(e)|0;u=g;return c|0}function URa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;a:do switch((f[d+4>>2]&176)<<24>>24){case 16:{e=b[a>>0]|0;g=a+1|0;switch(e<<24>>24){case 43:case 45:{h=g;break a;break}default:{}}if((c-a|0)>1&e<<24>>24==48){switch(b[g>>0]|0){case 88:case 120:break;default:{i=6;break a}}h=a+2|0}else i=6;break}case 32:{h=c;break}default:i=6}while(0);if((i|0)==6)h=a;return h|0}function VRa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;if(!(d&2048))e=a;else{b[a>>0]=43;e=a+1|0}if(!(d&1024))f=e;else{b[e>>0]=35;f=e+1|0}e=d&260;a=(d&16384|0)!=0;d=(e|0)==260;if(d){g=f;h=0}else{b[f>>0]=46;b[f+1>>0]=42;g=f+2|0;h=1}f=g;g=c;while(1){c=b[g>>0]|0;if(!(c<<24>>24))break;b[f>>0]=c;f=f+1|0;g=g+1|0}a:do switch(e&511){case 4:{i=a?70:102;break}case 256:{i=a?69:101;break}default:if(d){i=a?65:97;break a}else{i=a?71:103;break a}}while(0);b[f>>0]=i;return h|0}function WRa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=d;d=ANa(b)|0;b=sMa(a,c,g)|0;if(d|0)ANa(d)|0;u=e;return b|0}function XRa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=u;u=u+16|0;k=j;l=BQa(i,1975176)|0;m=BQa(i,1975192)|0;Gh[f[(f[m>>2]|0)+20>>2]&511](k,m);f[h>>2]=e;i=b[a>>0]|0;switch(i<<24>>24){case 43:case 45:{n=$h[f[(f[l>>2]|0)+28>>2]&255](l,i)|0;i=f[h>>2]|0;f[h>>2]=i+1;b[i>>0]=n;o=a+1|0;break}default:o=a}n=d;a:do if((n-o|0)>1?(b[o>>0]|0)==48:0){i=o+1|0;switch(b[i>>0]|0){case 88:case 120:break;default:{p=o;q=10;break a}}r=$h[f[(f[l>>2]|0)+28>>2]&255](l,48)|0;s=f[h>>2]|0;f[h>>2]=s+1;b[s>>0]=r;r=o+2|0;s=$h[f[(f[l>>2]|0)+28>>2]&255](l,b[i>>0]|0)|0;i=f[h>>2]|0;f[h>>2]=i+1;b[i>>0]=s;s=r;while(1){if(s>>>0>=d>>>0){t=r;v=s;break a}i=b[s>>0]|0;if(!(HNa(i,EQa()|0)|0)){t=r;v=s;break a}s=s+1|0}}else{p=o;q=10}while(0);b:do if((q|0)==10)while(1){q=0;if(p>>>0>=d>>>0){t=o;v=p;break b}s=b[p>>0]|0;if(!(JNa(s,EQa()|0)|0)){t=o;v=p;break b}p=p+1|0;q=10}while(0);p=k+11|0;o=b[p>>0]|0;s=k+4|0;r=t;i=a;c:do if((o<<24>>24<0?f[s>>2]|0:o&255)|0){d:do if((t|0)!=(v|0)){a=t;w=v;while(1){x=w+-1|0;if(a>>>0>=x>>>0)break d;y=b[a>>0]|0;b[a>>0]=b[x>>0]|0;b[x>>0]=y;a=a+1|0;w=x}}while(0);w=mi[f[(f[m>>2]|0)+16>>2]&255](m)|0;a=0;x=0;y=t;while(1){if(y>>>0>=v>>>0)break;z=b[((b[p>>0]|0)<0?f[k>>2]|0:k)+x>>0]|0;if(z<<24>>24>0&(a|0)==(z<<24>>24|0)){z=f[h>>2]|0;f[h>>2]=z+1;b[z>>0]=w;z=b[p>>0]|0;A=0;B=(x>>>0<((z<<24>>24<0?f[s>>2]|0:z&255)+-1|0)>>>0&1)+x|0}else{A=a;B=x}z=$h[f[(f[l>>2]|0)+28>>2]&255](l,b[y>>0]|0)|0;C=f[h>>2]|0;f[h>>2]=C+1;b[C>>0]=z;a=A+1|0;x=B;y=y+1|0}y=e+(r-i)|0;x=f[h>>2]|0;if((y|0)==(x|0))D=l;else{a=y;y=x;while(1){x=y+-1|0;if(a>>>0>=x>>>0){D=l;break c}w=b[a>>0]|0;b[a>>0]=b[x>>0]|0;b[x>>0]=w;a=a+1|0;y=x}}}else{Jg[f[(f[l>>2]|0)+32>>2]&63](l,t,v,f[h>>2]|0)|0;f[h>>2]=(f[h>>2]|0)+(v-r);D=l}while(0);r=v;while(1){if(r>>>0>=d>>>0){E=r;break}v=b[r>>0]|0;F=r+1|0;if(v<<24>>24==46){q=29;break}t=$h[f[(f[D>>2]|0)+28>>2]&255](l,v)|0;v=f[h>>2]|0;f[h>>2]=v+1;b[v>>0]=t;r=F}if((q|0)==29){q=mi[f[(f[m>>2]|0)+12>>2]&255](m)|0;m=f[h>>2]|0;f[h>>2]=m+1;b[m>>0]=q;E=F}Jg[f[(f[l>>2]|0)+32>>2]&63](l,E,d,f[h>>2]|0)|0;l=(f[h>>2]|0)+(n-E)|0;f[h>>2]=l;f[g>>2]=(c|0)==(d|0)?l:e+(c-i)|0;_Ya(k);u=j;return}function YRa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;if(!(e&2048))f=a;else{b[a>>0]=43;f=a+1|0}if(!(e&512)){g=f;h=c}else{b[f>>0]=35;g=f+1|0;h=c}while(1){c=b[h>>0]|0;if(!(c<<24>>24))break;b[g>>0]=c;g=g+1|0;h=h+1|0}switch(e&74){case 64:{i=111;break}case 8:{i=e&16384|0?88:120;break}default:i=d?100:117}b[g>>0]=i;return}function ZRa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;j=u;u=u+16|0;k=j;l=BQa(i,1975176)|0;m=BQa(i,1975192)|0;Gh[f[(f[m>>2]|0)+20>>2]&511](k,m);i=k+11|0;n=b[i>>0]|0;o=k+4|0;p=a;q=d;if((n<<24>>24<0?f[o>>2]|0:n&255)|0){f[h>>2]=e;n=b[a>>0]|0;switch(n<<24>>24){case 43:case 45:{r=$h[f[(f[l>>2]|0)+28>>2]&255](l,n)|0;n=f[h>>2]|0;f[h>>2]=n+1;b[n>>0]=r;s=a+1|0;break}default:s=a}a:do if((q-s|0)>1?(b[s>>0]|0)==48:0){r=s+1|0;switch(b[r>>0]|0){case 88:case 120:break;default:{t=s;break a}}n=$h[f[(f[l>>2]|0)+28>>2]&255](l,48)|0;v=f[h>>2]|0;f[h>>2]=v+1;b[v>>0]=n;n=$h[f[(f[l>>2]|0)+28>>2]&255](l,b[r>>0]|0)|0;r=f[h>>2]|0;f[h>>2]=r+1;b[r>>0]=n;t=s+2|0}else t=s;while(0);b:do if((t|0)!=(d|0)){s=t;n=d;while(1){r=n+-1|0;if(s>>>0>=r>>>0)break b;v=b[s>>0]|0;b[s>>0]=b[r>>0]|0;b[r>>0]=v;s=s+1|0;n=r}}while(0);n=mi[f[(f[m>>2]|0)+16>>2]&255](m)|0;m=0;s=0;r=t;while(1){if(r>>>0>=d>>>0)break;v=b[((b[i>>0]|0)<0?f[k>>2]|0:k)+s>>0]|0;if(v<<24>>24!=0&(m|0)==(v<<24>>24|0)){v=f[h>>2]|0;f[h>>2]=v+1;b[v>>0]=n;v=b[i>>0]|0;w=0;x=(s>>>0<((v<<24>>24<0?f[o>>2]|0:v&255)+-1|0)>>>0&1)+s|0}else{w=m;x=s}v=$h[f[(f[l>>2]|0)+28>>2]&255](l,b[r>>0]|0)|0;y=f[h>>2]|0;f[h>>2]=y+1;b[y>>0]=v;m=w+1|0;s=x;r=r+1|0}r=e+(t-p)|0;t=f[h>>2]|0;if((r|0)==(t|0))z=r;else{x=r;r=t;while(1){t=r+-1|0;if(x>>>0>=t>>>0)break;s=b[x>>0]|0;b[x>>0]=b[t>>0]|0;b[t>>0]=s;x=x+1|0;r=t}z=f[h>>2]|0}}else{Jg[f[(f[l>>2]|0)+32>>2]&63](l,a,d,e)|0;a=e+(q-p)|0;f[h>>2]=a;z=a}f[g>>2]=(c|0)==(d|0)?z:e+(c-p)|0;_Ya(k);u=j;return}function _Ra(a){a=a|0;hQa(a);return}function $Ra(a){a=a|0;hQa(a);PYa(a);return}function aSa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;i=h+4|0;j=h;if(!(f[d+4>>2]&1)){k=f[(f[a>>2]|0)+24>>2]|0;f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];l=uh[k&63](a,i,d,e,g&1)|0}else{bPa(i,d);d=BQa(i,1975216)|0;CQa(i);e=f[d>>2]|0;if(g)Gh[f[e+24>>2]&511](i,d);else Gh[f[e+28>>2]&511](i,d);d=i+8+3|0;e=b[d>>0]|0;g=f[i>>2]|0;a=i+4|0;k=g;j=e;m=e<<24>>24<0?g:i;while(1){g=j<<24>>24<0;if((m|0)==((g?k:i)+((g?f[a>>2]|0:j&255)<<2)|0))break;g=f[m>>2]|0;e=f[c>>2]|0;if(e|0){n=e+24|0;o=f[n>>2]|0;if((o|0)==(f[e+28>>2]|0)){p=f[(f[e>>2]|0)+52>>2]|0;q=BOa(g)|0;r=$h[p&255](e,q)|0}else{f[n>>2]=o+4;f[o>>2]=g;r=BOa(g)|0}if(cPa(r,AOa()|0)|0)f[c>>2]=0}k=f[i>>2]|0;j=b[d>>0]|0;m=m+4|0}m=f[c>>2]|0;qZa(i);l=m}u=h;return l|0}function bSa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+128|0;h=a;i=a+122|0;j=a+108|0;k=a+16|0;l=a+12|0;m=a+4|0;n=a+8|0;b[i>>0]=b[370352]|0;b[i+1>>0]=b[370353]|0;b[i+2>>0]=b[370354]|0;b[i+3>>0]=b[370355]|0;b[i+4>>0]=b[370356]|0;b[i+5>>0]=b[370357]|0;YRa(i+1|0,374278,1,f[d+4>>2]|0);o=EQa()|0;f[h>>2]=g;g=j+(TRa(j,13,o,i,h)|0)|0;i=URa(j,g,d)|0;bPa(h,d);lSa(j,i,g,k,l,m,h);CQa(h);f[n>>2]=f[c>>2];c=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=iSa(h,k,c,l,d,e)|0;u=a;return n|0}function cSa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+224|0;h=a+8|0;i=a;j=a+200|0;k=a+28|0;l=a+24|0;m=a+16|0;n=a+20|0;o=i;f[o>>2]=37;f[o+4>>2]=0;YRa(i+1|0,374283,1,f[c+4>>2]|0);o=EQa()|0;p=h;f[p>>2]=e;f[p+4>>2]=g;g=j+(TRa(j,23,o,i,h)|0)|0;i=URa(j,g,c)|0;bPa(h,c);lSa(j,i,g,k,l,m,h);CQa(h);f[n>>2]=f[b>>2];b=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=iSa(h,k,b,l,c,d)|0;u=a;return n|0}function dSa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+128|0;h=a;i=a+112|0;j=a+100|0;k=a+16|0;l=a+12|0;m=a+4|0;n=a+8|0;b[i>>0]=b[370352]|0;b[i+1>>0]=b[370353]|0;b[i+2>>0]=b[370354]|0;b[i+3>>0]=b[370355]|0;b[i+4>>0]=b[370356]|0;b[i+5>>0]=b[370357]|0;YRa(i+1|0,374278,0,f[d+4>>2]|0);o=EQa()|0;f[h>>2]=g;g=j+(TRa(j,12,o,i,h)|0)|0;i=URa(j,g,d)|0;bPa(h,d);lSa(j,i,g,k,l,m,h);CQa(h);f[n>>2]=f[c>>2];c=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=iSa(h,k,c,l,d,e)|0;u=a;return n|0}function eSa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+224|0;h=a+8|0;i=a;j=a+200|0;k=a+28|0;l=a+24|0;m=a+16|0;n=a+20|0;o=i;f[o>>2]=37;f[o+4>>2]=0;YRa(i+1|0,374283,0,f[c+4>>2]|0);o=EQa()|0;p=h;f[p>>2]=e;f[p+4>>2]=g;g=j+(TRa(j,23,o,i,h)|0)|0;i=URa(j,g,c)|0;bPa(h,c);lSa(j,i,g,k,l,m,h);CQa(h);f[n>>2]=f[b>>2];b=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=iSa(h,k,b,l,c,d)|0;u=a;return n|0}function fSa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;a=u;u=u+336|0;g=a+300|0;h=a+48|0;i=a+32|0;j=a+24|0;k=a+8|0;l=a;m=a+304|0;n=a+296|0;o=a+68|0;q=a+64|0;r=a+60|0;s=a+56|0;t=l;f[t>>2]=37;f[t+4>>2]=0;t=VRa(l+1|0,5694105,f[c+4>>2]|0)|0;f[n>>2]=m;v=EQa()|0;if(t){f[k>>2]=f[c+8>>2];p[k+8>>3]=e;w=TRa(m,30,v,l,k)|0}else{p[j>>3]=e;w=TRa(m,30,v,l,j)|0}if((w|0)>29){j=EQa()|0;if(t){f[i>>2]=f[c+8>>2];p[i+8>>3]=e;x=WRa(n,j,l,i)|0}else{p[h>>3]=e;x=WRa(n,j,l,h)|0}h=f[n>>2]|0;if(!h)RYa();else{y=h;z=h;A=x}}else{y=f[n>>2]|0;z=0;A=w}w=y+A|0;n=URa(y,w,c)|0;do if((y|0)!=(m|0)){x=dKa(A<<3)|0;if(!x)RYa();else{B=x;C=x;D=0;break}}else{B=0;C=o;D=1}while(0);bPa(g,c);kSa(y,n,w,C,q,r,g);CQa(g);f[s>>2]=f[b>>2];w=f[q>>2]|0;q=f[r>>2]|0;f[g>>2]=f[s>>2];s=iSa(g,C,w,q,c,d)|0;f[b>>2]=s;if(!D)eKa(B);eKa(z);u=a;return s|0}function gSa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;a=u;u=u+336|0;g=a+300|0;h=a+48|0;i=a+32|0;j=a+24|0;k=a+8|0;l=a;m=a+304|0;n=a+296|0;o=a+68|0;q=a+64|0;r=a+60|0;s=a+56|0;t=l;f[t>>2]=37;f[t+4>>2]=0;t=VRa(l+1|0,370350,f[c+4>>2]|0)|0;f[n>>2]=m;v=EQa()|0;if(t){f[k>>2]=f[c+8>>2];p[k+8>>3]=e;w=TRa(m,30,v,l,k)|0}else{p[j>>3]=e;w=TRa(m,30,v,l,j)|0}if((w|0)>29){j=EQa()|0;if(t){f[i>>2]=f[c+8>>2];p[i+8>>3]=e;x=WRa(n,j,l,i)|0}else{p[h>>3]=e;x=WRa(n,j,l,h)|0}h=f[n>>2]|0;if(!h)RYa();else{y=h;z=h;A=x}}else{y=f[n>>2]|0;z=0;A=w}w=y+A|0;n=URa(y,w,c)|0;do if((y|0)!=(m|0)){x=dKa(A<<3)|0;if(!x)RYa();else{B=x;C=x;D=0;break}}else{B=0;C=o;D=1}while(0);bPa(g,c);kSa(y,n,w,C,q,r,g);CQa(g);f[s>>2]=f[b>>2];w=f[q>>2]|0;q=f[r>>2]|0;f[g>>2]=f[s>>2];s=iSa(g,C,w,q,c,d)|0;f[b>>2]=s;if(!D)eKa(B);eKa(z);u=a;return s|0}function hSa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+192|0;h=a;i=a+176|0;j=a+156|0;k=a+4|0;l=a+152|0;b[i>>0]=b[370344]|0;b[i+1>>0]=b[370345]|0;b[i+2>>0]=b[370346]|0;b[i+3>>0]=b[370347]|0;b[i+4>>0]=b[370348]|0;b[i+5>>0]=b[370349]|0;m=EQa()|0;f[h>>2]=g;g=TRa(j,20,m,i,h)|0;i=j+g|0;m=URa(j,i,d)|0;bPa(h,d);n=BQa(h,1975208)|0;CQa(h);Jg[f[(f[n>>2]|0)+48>>2]&63](n,j,i,k)|0;n=k+(g<<2)|0;f[l>>2]=f[c>>2];f[h>>2]=f[l>>2];l=iSa(h,k,(m|0)==(i|0)?n:k+(m-j<<2)|0,n,d,e)|0;u=a;return l|0}function iSa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;i=u;u=u+16|0;j=i+12|0;k=i;l=f[a>>2]|0;a:do if(!l)m=0;else{n=e;o=c;p=n-o>>2;q=g+12|0;r=f[q>>2]|0;s=(r|0)>(p|0)?r-p|0:0;p=d;r=p-o|0;o=r>>2;if((r|0)>0?(ui[f[(f[l>>2]|0)+48>>2]&127](l,c,o)|0)!=(o|0):0){f[a>>2]=0;m=0;break}do if((s|0)>0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(s>>>0>1073741807)WYa(k);do if(s>>>0>=2){o=s+4&2147483644;if(o>>>0>1073741823)We();else{r=NYa(o<<2)|0;f[k>>2]=r;t=k+8|0;f[t>>2]=o|-2147483648;f[k+4>>2]=s;v=r;w=t+3|0;x=k;break}}else{t=k+8+3|0;b[t>>0]=s;v=k;w=t;x=k}while(0);jSa(v,s,h)|0;f[j>>2]=0;nQa(v+(s<<2)|0,j);if((ui[f[(f[l>>2]|0)+48>>2]&127](l,(b[w>>0]|0)<0?f[k>>2]|0:x,s)|0)==(s|0)){qZa(k);break}else{f[a>>2]=0;qZa(k);m=0;break a}}while(0);s=n-p|0;t=s>>2;if((s|0)>0?(ui[f[(f[l>>2]|0)+48>>2]&127](l,d,t)|0)!=(t|0):0){f[a>>2]=0;m=0;break}f[q>>2]=0;m=l}while(0);u=i;return m|0}function jSa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(!b)d=a;else{NKa(a,c,b)|0;d=a}return d|0}function kSa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;j=u;u=u+16|0;k=j;l=BQa(i,1975208)|0;m=BQa(i,1975216)|0;Gh[f[(f[m>>2]|0)+20>>2]&511](k,m);f[h>>2]=e;i=b[a>>0]|0;switch(i<<24>>24){case 43:case 45:{n=$h[f[(f[l>>2]|0)+44>>2]&255](l,i)|0;i=f[h>>2]|0;f[h>>2]=i+4;f[i>>2]=n;o=a+1|0;break}default:o=a}n=d;a:do if((n-o|0)>1?(b[o>>0]|0)==48:0){i=o+1|0;switch(b[i>>0]|0){case 88:case 120:break;default:{p=o;q=10;break a}}r=$h[f[(f[l>>2]|0)+44>>2]&255](l,48)|0;s=f[h>>2]|0;f[h>>2]=s+4;f[s>>2]=r;r=o+2|0;s=$h[f[(f[l>>2]|0)+44>>2]&255](l,b[i>>0]|0)|0;i=f[h>>2]|0;f[h>>2]=i+4;f[i>>2]=s;s=r;while(1){if(s>>>0>=d>>>0){t=r;v=s;break a}i=b[s>>0]|0;if(!(HNa(i,EQa()|0)|0)){t=r;v=s;break a}s=s+1|0}}else{p=o;q=10}while(0);b:do if((q|0)==10)while(1){q=0;if(p>>>0>=d>>>0){t=o;v=p;break b}s=b[p>>0]|0;if(!(JNa(s,EQa()|0)|0)){t=o;v=p;break b}p=p+1|0;q=10}while(0);p=k+11|0;o=b[p>>0]|0;s=k+4|0;r=t;i=a;c:do if((o<<24>>24<0?f[s>>2]|0:o&255)|0){d:do if((t|0)!=(v|0)){a=t;w=v;while(1){x=w+-1|0;if(a>>>0>=x>>>0)break d;y=b[a>>0]|0;b[a>>0]=b[x>>0]|0;b[x>>0]=y;a=a+1|0;w=x}}while(0);w=mi[f[(f[m>>2]|0)+16>>2]&255](m)|0;a=0;x=0;y=t;while(1){if(y>>>0>=v>>>0)break;z=b[p>>0]|0;A=z<<24>>24<0;B=b[(A?f[k>>2]|0:k)+x>>0]|0;if(B<<24>>24>0&(a|0)==(B<<24>>24|0)){B=f[h>>2]|0;f[h>>2]=B+4;f[B>>2]=w;C=0;D=(x>>>0<((A?f[s>>2]|0:z&255)+-1|0)>>>0&1)+x|0}else{C=a;D=x}z=$h[f[(f[l>>2]|0)+44>>2]&255](l,b[y>>0]|0)|0;A=f[h>>2]|0;f[h>>2]=A+4;f[A>>2]=z;a=C+1|0;x=D;y=y+1|0}y=e+(r-i<<2)|0;x=f[h>>2]|0;if((y|0)==(x|0)){E=l;F=y}else{a=y;y=x;while(1){w=y+-4|0;if(a>>>0>=w>>>0){E=l;F=x;break c}z=f[a>>2]|0;f[a>>2]=f[w>>2];f[w>>2]=z;a=a+4|0;y=w}}}else{Jg[f[(f[l>>2]|0)+48>>2]&63](l,t,v,f[h>>2]|0)|0;y=(f[h>>2]|0)+(v-r<<2)|0;f[h>>2]=y;E=l;F=y}while(0);r=F;F=v;while(1){if(F>>>0>=d>>>0){G=r;H=F;break}v=b[F>>0]|0;I=F+1|0;if(v<<24>>24==46){q=29;break}t=$h[f[(f[E>>2]|0)+44>>2]&255](l,v)|0;v=f[h>>2]|0;D=v+4|0;f[h>>2]=D;f[v>>2]=t;r=D;F=I}if((q|0)==29){q=mi[f[(f[m>>2]|0)+12>>2]&255](m)|0;m=f[h>>2]|0;F=m+4|0;f[h>>2]=F;f[m>>2]=q;G=F;H=I}Jg[f[(f[l>>2]|0)+48>>2]&63](l,H,d,G)|0;G=(f[h>>2]|0)+(n-H<<2)|0;f[h>>2]=G;f[g>>2]=(c|0)==(d|0)?G:e+(c-i<<2)|0;_Ya(k);u=j;return}function lSa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;j=u;u=u+16|0;k=j;l=BQa(i,1975208)|0;m=BQa(i,1975216)|0;Gh[f[(f[m>>2]|0)+20>>2]&511](k,m);i=k+11|0;n=b[i>>0]|0;o=k+4|0;p=a;q=d;if((n<<24>>24<0?f[o>>2]|0:n&255)|0){f[h>>2]=e;n=b[a>>0]|0;switch(n<<24>>24){case 43:case 45:{r=$h[f[(f[l>>2]|0)+44>>2]&255](l,n)|0;n=f[h>>2]|0;f[h>>2]=n+4;f[n>>2]=r;s=a+1|0;break}default:s=a}a:do if((q-s|0)>1?(b[s>>0]|0)==48:0){r=s+1|0;switch(b[r>>0]|0){case 88:case 120:break;default:{t=s;break a}}n=$h[f[(f[l>>2]|0)+44>>2]&255](l,48)|0;v=f[h>>2]|0;f[h>>2]=v+4;f[v>>2]=n;n=$h[f[(f[l>>2]|0)+44>>2]&255](l,b[r>>0]|0)|0;r=f[h>>2]|0;f[h>>2]=r+4;f[r>>2]=n;t=s+2|0}else t=s;while(0);b:do if((t|0)!=(d|0)){s=t;n=d;while(1){r=n+-1|0;if(s>>>0>=r>>>0)break b;v=b[s>>0]|0;b[s>>0]=b[r>>0]|0;b[r>>0]=v;s=s+1|0;n=r}}while(0);n=mi[f[(f[m>>2]|0)+16>>2]&255](m)|0;m=0;s=0;r=t;while(1){if(r>>>0>=d>>>0)break;v=b[i>>0]|0;w=v<<24>>24<0;x=b[(w?f[k>>2]|0:k)+s>>0]|0;if(x<<24>>24!=0&(m|0)==(x<<24>>24|0)){x=f[h>>2]|0;f[h>>2]=x+4;f[x>>2]=n;y=0;z=(s>>>0<((w?f[o>>2]|0:v&255)+-1|0)>>>0&1)+s|0}else{y=m;z=s}v=$h[f[(f[l>>2]|0)+44>>2]&255](l,b[r>>0]|0)|0;w=f[h>>2]|0;f[h>>2]=w+4;f[w>>2]=v;m=y+1|0;s=z;r=r+1|0}r=e+(t-p<<2)|0;t=f[h>>2]|0;if((r|0)==(t|0))A=r;else{z=r;r=t;while(1){t=r+-4|0;if(z>>>0>=t>>>0)break;s=f[z>>2]|0;f[z>>2]=f[t>>2];f[t>>2]=s;z=z+4|0;r=t}A=f[h>>2]|0}}else{Jg[f[(f[l>>2]|0)+48>>2]&63](l,a,d,e)|0;a=e+(q-p<<2)|0;f[h>>2]=a;A=a}f[g>>2]=(c|0)==(d|0)?A:e+(c-p<<2)|0;_Ya(k);u=j;return}function mSa(a){a=a|0;hQa(a);return}function nSa(a){a=a|0;hQa(a);PYa(a);return}function oSa(a){a=a|0;return 2}function pSa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=KSa(a,j,i,d,e,g,370875,370883)|0;u=h;return l|0}function qSa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+16|0;j=i+12|0;k=i+8|0;l=i+4|0;m=i;n=a+8|0;o=mi[f[(f[n>>2]|0)+20>>2]&255](n)|0;f[l>>2]=f[c>>2];f[m>>2]=f[d>>2];d=b[o+11>>0]|0;c=d<<24>>24<0;n=c?f[o>>2]|0:o;p=n+(c?f[o+4>>2]|0:d&255)|0;f[k>>2]=f[l>>2];f[j>>2]=f[m>>2];m=KSa(a,k,j,e,g,h,n,p)|0;u=i;return m|0}function rSa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;bPa(i,d);d=BQa(i,1975176)|0;CQa(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];ISa(a,g+24|0,b,i,e,d);u=h;return f[b>>2]|0}function sSa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;bPa(i,d);d=BQa(i,1975176)|0;CQa(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];JSa(a,g+16|0,b,i,e,d);u=h;return f[b>>2]|0}function tSa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;bPa(i,d);d=BQa(i,1975176)|0;CQa(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];VSa(a,g+20|0,b,i,e,d);u=h;return f[b>>2]|0}function uSa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;j=u;u=u+144|0;k=j+128|0;l=j+112|0;m=j+124|0;n=j+120|0;o=j+116|0;p=j+108|0;q=j+104|0;r=j+100|0;s=j+96|0;t=j+92|0;v=j+88|0;w=j+84|0;x=j+80|0;y=j+76|0;z=j+72|0;A=j+68|0;B=j+64|0;C=j+60|0;D=j+56|0;E=j+52|0;F=j+48|0;G=j+44|0;H=j+40|0;I=j+36|0;J=j+32|0;K=j+28|0;L=j+24|0;M=j+20|0;N=j+16|0;O=j+12|0;P=j+8|0;Q=j+4|0;R=j;f[g>>2]=0;bPa(k,e);S=BQa(k,1975176)|0;CQa(k);T=h+8|0;U=h+20|0;V=h+16|0;W=h+24|0;X=a+8|0;do switch(i<<24>>24|0){case 65:case 97:{f[m>>2]=f[d>>2];f[k>>2]=f[m>>2];ISa(a,W,c,k,g,S);Y=26;break}case 104:case 66:case 98:{f[n>>2]=f[d>>2];f[k>>2]=f[n>>2];JSa(a,V,c,k,g,S);Y=26;break}case 99:{Z=mi[f[(f[X>>2]|0)+12>>2]&255](X)|0;f[o>>2]=f[c>>2];f[p>>2]=f[d>>2];_=b[Z+11>>0]|0;$=_<<24>>24<0;aa=$?f[Z>>2]|0:Z;ba=aa+($?f[Z+4>>2]|0:_&255)|0;f[l>>2]=f[o>>2];f[k>>2]=f[p>>2];_=KSa(a,l,k,e,g,h,aa,ba)|0;f[c>>2]=_;Y=26;break}case 101:case 100:{f[q>>2]=f[d>>2];f[k>>2]=f[q>>2];LSa(a,h+12|0,c,k,g,S);Y=26;break}case 68:{f[r>>2]=f[c>>2];f[s>>2]=f[d>>2];f[l>>2]=f[r>>2];f[k>>2]=f[s>>2];_=KSa(a,l,k,e,g,h,370835,370843)|0;f[c>>2]=_;Y=26;break}case 70:{f[t>>2]=f[c>>2];f[v>>2]=f[d>>2];f[l>>2]=f[t>>2];f[k>>2]=f[v>>2];_=KSa(a,l,k,e,g,h,370843,370851)|0;f[c>>2]=_;Y=26;break}case 72:{f[w>>2]=f[d>>2];f[k>>2]=f[w>>2];MSa(a,T,c,k,g,S);Y=26;break}case 73:{f[x>>2]=f[d>>2];f[k>>2]=f[x>>2];NSa(a,T,c,k,g,S);Y=26;break}case 106:{f[y>>2]=f[d>>2];f[k>>2]=f[y>>2];OSa(a,h+28|0,c,k,g,S);Y=26;break}case 109:{f[z>>2]=f[d>>2];f[k>>2]=f[z>>2];PSa(a,V,c,k,g,S);Y=26;break}case 77:{f[A>>2]=f[d>>2];f[k>>2]=f[A>>2];QSa(a,h+4|0,c,k,g,S);Y=26;break}case 116:case 110:{f[B>>2]=f[d>>2];f[k>>2]=f[B>>2];RSa(a,c,k,g,S);Y=26;break}case 112:{f[C>>2]=f[d>>2];f[k>>2]=f[C>>2];SSa(a,T,c,k,g,S);Y=26;break}case 114:{f[D>>2]=f[c>>2];f[E>>2]=f[d>>2];f[l>>2]=f[D>>2];f[k>>2]=f[E>>2];_=KSa(a,l,k,e,g,h,370851,370862)|0;f[c>>2]=_;Y=26;break}case 82:{f[F>>2]=f[c>>2];f[G>>2]=f[d>>2];f[l>>2]=f[F>>2];f[k>>2]=f[G>>2];_=KSa(a,l,k,e,g,h,370862,370867)|0;f[c>>2]=_;Y=26;break}case 83:{f[H>>2]=f[d>>2];f[k>>2]=f[H>>2];TSa(a,h,c,k,g,S);Y=26;break}case 84:{f[I>>2]=f[c>>2];f[J>>2]=f[d>>2];f[l>>2]=f[I>>2];f[k>>2]=f[J>>2];_=KSa(a,l,k,e,g,h,370867,370875)|0;f[c>>2]=_;Y=26;break}case 119:{f[K>>2]=f[d>>2];f[k>>2]=f[K>>2];USa(a,W,c,k,g,S);Y=26;break}case 120:{_=f[(f[a>>2]|0)+20>>2]|0;f[L>>2]=f[c>>2];f[M>>2]=f[d>>2];f[l>>2]=f[L>>2];f[k>>2]=f[M>>2];ca=bg[_&127](a,l,k,e,g,h)|0;break}case 88:{_=mi[f[(f[X>>2]|0)+24>>2]&255](X)|0;f[N>>2]=f[c>>2];f[O>>2]=f[d>>2];ba=b[_+11>>0]|0;aa=ba<<24>>24<0;Z=aa?f[_>>2]|0:_;$=Z+(aa?f[_+4>>2]|0:ba&255)|0;f[l>>2]=f[N>>2];f[k>>2]=f[O>>2];ba=KSa(a,l,k,e,g,h,Z,$)|0;f[c>>2]=ba;Y=26;break}case 121:{f[P>>2]=f[d>>2];f[k>>2]=f[P>>2];VSa(a,U,c,k,g,S);Y=26;break}case 89:{f[Q>>2]=f[d>>2];f[k>>2]=f[Q>>2];WSa(a,U,c,k,g,S);Y=26;break}case 37:{f[R>>2]=f[d>>2];f[k>>2]=f[R>>2];XSa(a,c,k,g,S);Y=26;break}default:{f[g>>2]=f[g>>2]|4;Y=26}}while(0);if((Y|0)==26)ca=f[c>>2]|0;u=j;return ca|0}function vSa(a){a=a|0;if((b[900352]|0)==0?u1a(900352)|0:0){GSa();f[494012]=1975880}return f[494012]|0}function wSa(a){a=a|0;if((b[900336]|0)==0?u1a(900336)|0:0){ESa();f[493969]=1975588}return f[493969]|0}function xSa(a){a=a|0;if((b[900320]|0)==0?u1a(900320)|0:0){CSa();f[493896]=1975296}return f[493896]|0}function ySa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[900312]|0)==0?u1a(900312)|0:0){f[493821]=0;f[493822]=0;f[493823]=0;d=YOa(370593)|0;if(d>>>0>4294967279)WYa(1975284);if(d>>>0<11){b[1975295]=d;e=1975284}else{g=d+16&-16;h=NYa(g)|0;f[493821]=h;f[493823]=g|-2147483648;f[493822]=d;e=h}kOa(e,370593,d)|0;b[c>>0]=0;ZOa(e+d|0,c);Fd(1018,1975284,x|0)|0}u=a;return 1975284}function zSa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[900304]|0)==0?u1a(900304)|0:0){f[493818]=0;f[493819]=0;f[493820]=0;d=YOa(370581)|0;if(d>>>0>4294967279)WYa(1975272);if(d>>>0<11){b[1975283]=d;e=1975272}else{g=d+16&-16;h=NYa(g)|0;f[493818]=h;f[493820]=g|-2147483648;f[493819]=d;e=h}kOa(e,370581,d)|0;b[c>>0]=0;ZOa(e+d|0,c);Fd(1018,1975272,x|0)|0}u=a;return 1975272}function ASa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[900296]|0)==0?u1a(900296)|0:0){f[493815]=0;f[493816]=0;f[493817]=0;d=YOa(370572)|0;if(d>>>0>4294967279)WYa(1975260);if(d>>>0<11){b[1975271]=d;e=1975260}else{g=d+16&-16;h=NYa(g)|0;f[493815]=h;f[493817]=g|-2147483648;f[493816]=d;e=h}kOa(e,370572,d)|0;b[c>>0]=0;ZOa(e+d|0,c);Fd(1018,1975260,x|0)|0}u=a;return 1975260}function BSa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[900288]|0)==0?u1a(900288)|0:0){f[493812]=0;f[493813]=0;f[493814]=0;d=YOa(370563)|0;if(d>>>0>4294967279)WYa(1975248);if(d>>>0<11){b[1975259]=d;e=1975248}else{g=d+16&-16;h=NYa(g)|0;f[493812]=h;f[493814]=g|-2147483648;f[493813]=d;e=h}kOa(e,370563,d)|0;b[c>>0]=0;ZOa(e+d|0,c);Fd(1018,1975248,x|0)|0}u=a;return 1975248}function CSa(){var a=0,c=0;if((b[900328]|0)==0?u1a(900328)|0:0){a=1975296;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=1975584);Fd(1019,0,x|0)|0}eZa(1975296,370614)|0;eZa(1975308,370617)|0;return}function DSa(a){a=a|0;a=1975584;do{a=a+-12|0;_Ya(a)}while((a|0)!=1975296);return}function ESa(){var a=0,c=0;if((b[900344]|0)==0?u1a(900344)|0:0){a=1975588;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=1975876);Fd(1020,0,x|0)|0}eZa(1975588,370620)|0;eZa(1975600,370628)|0;eZa(1975612,370637)|0;eZa(1975624,370643)|0;eZa(1975636,370649)|0;eZa(1975648,370653)|0;eZa(1975660,370658)|0;eZa(1975672,370663)|0;eZa(1975684,370670)|0;eZa(1975696,370680)|0;eZa(1975708,370688)|0;eZa(1975720,370697)|0;eZa(1975732,370706)|0;eZa(1975744,370710)|0;eZa(1975756,370714)|0;eZa(1975768,370718)|0;eZa(1975780,370649)|0;eZa(1975792,370722)|0;eZa(1975804,370726)|0;eZa(1975816,370730)|0;eZa(1975828,370734)|0;eZa(1975840,370738)|0;eZa(1975852,370742)|0;eZa(1975864,370746)|0;return}function FSa(a){a=a|0;a=1975876;do{a=a+-12|0;_Ya(a)}while((a|0)!=1975588);return}function GSa(){var a=0,c=0;if((b[900360]|0)==0?u1a(900360)|0:0){a=1975880;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=1976048);Fd(1021,0,x|0)|0}eZa(1975880,370750)|0;eZa(1975892,370757)|0;eZa(1975904,370764)|0;eZa(1975916,370772)|0;eZa(1975928,370782)|0;eZa(1975940,370791)|0;eZa(1975952,370798)|0;eZa(1975964,370807)|0;eZa(1975976,370811)|0;eZa(1975988,370815)|0;eZa(1976e3,370819)|0;eZa(1976012,370823)|0;eZa(1976024,370827)|0;eZa(1976036,370831)|0;return}function HSa(a){a=a|0;a=1976048;do{a=a+-12|0;_Ya(a)}while((a|0)!=1975880);return}function ISa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+16|0;i=h+4|0;j=h;k=a+8|0;a=mi[f[f[k>>2]>>2]&255](k)|0;f[j>>2]=f[d>>2];f[i>>2]=f[j>>2];j=(hRa(c,i,a,a+168|0,g,e,0)|0)-a|0;if((j|0)<168)f[b>>2]=((j|0)/12|0|0)%7|0;u=h;return}function JSa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+16|0;i=h+4|0;j=h;k=a+8|0;a=mi[f[(f[k>>2]|0)+4>>2]&255](k)|0;f[j>>2]=f[d>>2];f[i>>2]=f[j>>2];j=(hRa(c,i,a,a+288|0,g,e,0)|0)-a|0;if((j|0)<288)f[b>>2]=((j|0)/12|0|0)%12|0;u=h;return}function KSa(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;l=u;u=u+16|0;m=l+12|0;n=l+8|0;o=l+4|0;p=l;bPa(m,g);q=BQa(m,1975176)|0;CQa(m);f[h>>2]=0;r=q+8|0;s=0;t=j;a:while(1){j=(t|0)!=(k|0);v=s;while(1){w=f[c>>2]|0;if(!(j&(v|0)==0)){x=w;break a}y=w;if(w){z=f[w+12>>2]|0;if((z|0)==(f[w+16>>2]|0))A=mi[f[(f[w>>2]|0)+36>>2]&255](w)|0;else A=jOa(b[z>>0]|0)|0;if(aPa(A,iOa()|0)|0){f[c>>2]=0;B=0;C=0;D=1}else{B=y;C=w;D=0}}else{B=y;C=0;D=1}y=f[e>>2]|0;w=y;do if(y){z=f[y+12>>2]|0;if((z|0)==(f[y+16>>2]|0))E=mi[f[(f[y>>2]|0)+36>>2]&255](y)|0;else E=jOa(b[z>>0]|0)|0;if(!(aPa(E,iOa()|0)|0))if(D){F=w;G=y;break}else{H=61;break a}else{f[e>>2]=0;I=0;H=16;break}}else{I=w;H=16}while(0);if((H|0)==16){H=0;if(D){H=61;break a}else{F=I;G=0}}if((ui[f[(f[q>>2]|0)+36>>2]&127](q,b[t>>0]|0,0)|0)<<24>>24==37){H=19;break}w=b[t>>0]|0;if(w<<24>>24>-1?(J=f[r>>2]|0,d[J+(w<<24>>24<<1)>>1]&8192):0){K=t;H=27;break}L=C+12|0;w=f[L>>2]|0;M=C+16|0;if((w|0)==(f[M>>2]|0))N=mi[f[(f[C>>2]|0)+36>>2]&255](C)|0;else N=jOa(b[w>>0]|0)|0;w=$h[f[(f[q>>2]|0)+12>>2]&255](q,N&255)|0;if(w<<24>>24==($h[f[(f[q>>2]|0)+12>>2]&255](q,b[t>>0]|0)|0)<<24>>24){H=57;break}f[h>>2]=4;v=4}b:do if((H|0)==19){H=0;v=t+1|0;if((v|0)==(k|0)){H=61;break a}j=ui[f[(f[q>>2]|0)+36>>2]&127](q,b[v>>0]|0,0)|0;switch(j<<24>>24){case 48:case 69:{w=t+2|0;if((w|0)==(k|0)){H=61;break a}O=v;P=ui[f[(f[q>>2]|0)+36>>2]&127](q,b[w>>0]|0,0)|0;Q=j;break}default:{O=t;P=j;Q=0}}j=f[(f[a>>2]|0)+36>>2]|0;f[o>>2]=B;f[p>>2]=F;f[n>>2]=f[o>>2];f[m>>2]=f[p>>2];w=Oi[j&15](a,n,m,g,h,i,P,Q)|0;f[c>>2]=w;R=O+2|0}else if((H|0)==27){while(1){H=0;w=K+1|0;if((w|0)==(k|0)){S=k;break}j=b[w>>0]|0;if(j<<24>>24<=-1){S=w;break}if(!(d[J+(j<<24>>24<<1)>>1]&8192)){S=w;break}else{K=w;H=27}}w=C;j=G;v=G;while(1){if(w){y=f[w+12>>2]|0;if((y|0)==(f[w+16>>2]|0))T=mi[f[(f[w>>2]|0)+36>>2]&255](w)|0;else T=jOa(b[y>>0]|0)|0;if(aPa(T,iOa()|0)|0){f[c>>2]=0;U=1;V=0}else{U=0;V=w}}else{U=1;V=0}do if(v){y=f[v+12>>2]|0;if((y|0)==(f[v+16>>2]|0))W=mi[f[(f[v>>2]|0)+36>>2]&255](v)|0;else W=jOa(b[y>>0]|0)|0;if(!(aPa(W,iOa()|0)|0))if(U^(j|0)==0){X=j;Y=j;break}else{R=S;break b}else{f[e>>2]=0;Z=0;H=43;break}}else{Z=j;H=43}while(0);if((H|0)==43){H=0;if(U){R=S;break b}else{X=Z;Y=0}}y=V+12|0;z=f[y>>2]|0;_=V+16|0;if((z|0)==(f[_>>2]|0))$=mi[f[(f[V>>2]|0)+36>>2]&255](V)|0;else $=jOa(b[z>>0]|0)|0;if(($&255)<<24>>24<=-1){R=S;break b}if(!(d[(f[r>>2]|0)+($<<24>>24<<1)>>1]&8192)){R=S;break b}z=f[y>>2]|0;if((z|0)==(f[_>>2]|0)){mi[f[(f[V>>2]|0)+40>>2]&255](V)|0;w=V;j=X;v=Y;continue}else{f[y>>2]=z+1;jOa(b[z>>0]|0)|0;w=V;j=X;v=Y;continue}}}else if((H|0)==57){H=0;v=t+1|0;j=f[L>>2]|0;if((j|0)==(f[M>>2]|0)){mi[f[(f[C>>2]|0)+40>>2]&255](C)|0;R=v;break}else{f[L>>2]=j+1;jOa(b[j>>0]|0)|0;R=v;break}}while(0);s=f[h>>2]|0;t=R}if((H|0)==61){f[h>>2]=4;x=C}if(x){C=f[x+12>>2]|0;if((C|0)==(f[x+16>>2]|0))aa=mi[f[(f[x>>2]|0)+36>>2]&255](x)|0;else aa=jOa(b[C>>0]|0)|0;if(aPa(aa,iOa()|0)|0){f[c>>2]=0;ba=1;ca=0}else{ba=0;ca=x}}else{ba=1;ca=0}x=f[e>>2]|0;do if(x){c=f[x+12>>2]|0;if((c|0)==(f[x+16>>2]|0))da=mi[f[(f[x>>2]|0)+36>>2]&255](x)|0;else da=jOa(b[c>>0]|0)|0;if(!(aPa(da,iOa()|0)|0))if(ba)break;else{H=76;break}else{f[e>>2]=0;H=74;break}}else H=74;while(0);if((H|0)==74?ba:0)H=76;if((H|0)==76)f[h>>2]=f[h>>2]|2;u=l;return ca|0}function LSa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=YSa(c,h,e,g,2)|0;g=f[e>>2]|0;if((i+-1|0)>>>0<31&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function MSa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=YSa(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<24&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function NSa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=YSa(c,h,e,g,2)|0;g=f[e>>2]|0;if((i+-1|0)>>>0<12&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function OSa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=YSa(c,h,e,g,3)|0;g=f[e>>2]|0;if((i|0)<366&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function PSa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=YSa(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<13&(g&4|0)==0)f[b>>2]=i+-1;else f[e>>2]=g|4;u=a;return}function QSa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=YSa(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<60&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function RSa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=h+8|0;a:while(1){h=f[c>>2]|0;do if(h){i=f[h+12>>2]|0;if((i|0)==(f[h+16>>2]|0))j=mi[f[(f[h>>2]|0)+36>>2]&255](h)|0;else j=jOa(b[i>>0]|0)|0;if(aPa(j,iOa()|0)|0){f[c>>2]=0;k=1;break}else{k=(f[c>>2]|0)==0;break}}else k=1;while(0);h=f[e>>2]|0;do if(h){i=f[h+12>>2]|0;if((i|0)==(f[h+16>>2]|0))l=mi[f[(f[h>>2]|0)+36>>2]&255](h)|0;else l=jOa(b[i>>0]|0)|0;if(!(aPa(l,iOa()|0)|0))if(k){m=h;break}else{n=h;break a}else{f[e>>2]=0;o=15;break}}else o=15;while(0);if((o|0)==15){o=0;if(k){n=0;break}else m=0}h=f[c>>2]|0;i=f[h+12>>2]|0;if((i|0)==(f[h+16>>2]|0))p=mi[f[(f[h>>2]|0)+36>>2]&255](h)|0;else p=jOa(b[i>>0]|0)|0;if((p&255)<<24>>24<=-1){n=m;break}if(!(d[(f[a>>2]|0)+(p<<24>>24<<1)>>1]&8192)){n=m;break}i=f[c>>2]|0;h=i+12|0;q=f[h>>2]|0;if((q|0)==(f[i+16>>2]|0)){mi[f[(f[i>>2]|0)+40>>2]&255](i)|0;continue}else{f[h>>2]=q+1;jOa(b[q>>0]|0)|0;continue}}m=f[c>>2]|0;do if(m){p=f[m+12>>2]|0;if((p|0)==(f[m+16>>2]|0))r=mi[f[(f[m>>2]|0)+36>>2]&255](m)|0;else r=jOa(b[p>>0]|0)|0;if(aPa(r,iOa()|0)|0){f[c>>2]=0;s=1;break}else{s=(f[c>>2]|0)==0;break}}else s=1;while(0);do if(n){c=f[n+12>>2]|0;if((c|0)==(f[n+16>>2]|0))t=mi[f[(f[n>>2]|0)+36>>2]&255](n)|0;else t=jOa(b[c>>0]|0)|0;if(!(aPa(t,iOa()|0)|0))if(s)break;else{o=40;break}else{f[e>>2]=0;o=38;break}}else o=38;while(0);if((o|0)==38?s:0)o=40;if((o|0)==40)f[g>>2]=f[g>>2]|2;return}function SSa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+16|0;j=i+4|0;k=i;l=a+8|0;a=mi[f[(f[l>>2]|0)+8>>2]&255](l)|0;l=b[a+11>>0]|0;if(l<<24>>24<0)m=f[a+4>>2]|0;else m=l&255;l=b[a+12+11>>0]|0;if(l<<24>>24<0)n=f[a+16>>2]|0;else n=l&255;do if((m|0)!=(0-n|0)){f[k>>2]=f[e>>2];f[j>>2]=f[k>>2];l=(hRa(d,j,a,a+24|0,h,g,0)|0)-a|0;o=f[c>>2]|0;if((o|0)==12&(l|0)==0){f[c>>2]=0;break}if((o|0)<12&(l|0)==12)f[c>>2]=o+12}else f[g>>2]=f[g>>2]|4;while(0);u=i;return}function TSa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=YSa(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<61&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function USa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=YSa(c,h,e,g,1)|0;g=f[e>>2]|0;if((i|0)<7&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function VSa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=YSa(c,h,e,g,4)|0;if(!(f[e>>2]&4)){if((i|0)<69)j=i+2e3|0;else j=(i|0)<100?i+1900|0:i;f[b>>2]=j+-1900}u=a;return}function WSa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=YSa(c,h,e,g,4)|0;if(!(f[e>>2]&4))f[b>>2]=i+-1900;u=a;return}function XSa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=f[c>>2]|0;do if(a){h=f[a+12>>2]|0;if((h|0)==(f[a+16>>2]|0))i=mi[f[(f[a>>2]|0)+36>>2]&255](a)|0;else i=jOa(b[h>>0]|0)|0;if(aPa(i,iOa()|0)|0){f[c>>2]=0;j=1;break}else{j=(f[c>>2]|0)==0;break}}else j=1;while(0);i=f[d>>2]|0;do if(i){a=f[i+12>>2]|0;if((a|0)==(f[i+16>>2]|0))k=mi[f[(f[i>>2]|0)+36>>2]&255](i)|0;else k=jOa(b[a>>0]|0)|0;if(!(aPa(k,iOa()|0)|0))if(j){l=i;m=16;break}else{n=6;m=38;break}else{f[d>>2]=0;m=14;break}}else m=14;while(0);if((m|0)==14)if(j){n=6;m=38}else{l=0;m=16}a:do if((m|0)==16){j=f[c>>2]|0;i=f[j+12>>2]|0;if((i|0)==(f[j+16>>2]|0))o=mi[f[(f[j>>2]|0)+36>>2]&255](j)|0;else o=jOa(b[i>>0]|0)|0;if((ui[f[(f[g>>2]|0)+36>>2]&127](g,o&255,0)|0)<<24>>24==37){i=f[c>>2]|0;j=i+12|0;k=f[j>>2]|0;if((k|0)==(f[i+16>>2]|0))mi[f[(f[i>>2]|0)+40>>2]&255](i)|0;else{f[j>>2]=k+1;jOa(b[k>>0]|0)|0}k=f[c>>2]|0;do if(k){j=f[k+12>>2]|0;if((j|0)==(f[k+16>>2]|0))p=mi[f[(f[k>>2]|0)+36>>2]&255](k)|0;else p=jOa(b[j>>0]|0)|0;if(aPa(p,iOa()|0)|0){f[c>>2]=0;q=1;break}else{q=(f[c>>2]|0)==0;break}}else q=1;while(0);do if(l|0){k=f[l+12>>2]|0;if((k|0)==(f[l+16>>2]|0))r=mi[f[(f[l>>2]|0)+36>>2]&255](l)|0;else r=jOa(b[k>>0]|0)|0;if(!(aPa(r,iOa()|0)|0))if(q)break a;else{n=2;m=38;break a}else{f[d>>2]=0;break}}while(0);if(q){n=2;m=38}}else{n=4;m=38}}while(0);if((m|0)==38)f[e>>2]=f[e>>2]|n;return}function YSa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;i=f[a>>2]|0;do if(i){j=f[i+12>>2]|0;if((j|0)==(f[i+16>>2]|0))k=mi[f[(f[i>>2]|0)+36>>2]&255](i)|0;else k=jOa(b[j>>0]|0)|0;if(aPa(k,iOa()|0)|0){f[a>>2]=0;l=1;break}else{l=(f[a>>2]|0)==0;break}}else l=1;while(0);k=f[c>>2]|0;do if(k){i=f[k+12>>2]|0;if((i|0)==(f[k+16>>2]|0))m=mi[f[(f[k>>2]|0)+36>>2]&255](k)|0;else m=jOa(b[i>>0]|0)|0;if(!(aPa(m,iOa()|0)|0))if(l){n=k;o=17;break}else{o=16;break}else{f[c>>2]=0;o=14;break}}else o=14;while(0);if((o|0)==14)if(l)o=16;else{n=0;o=17}a:do if((o|0)==16){f[e>>2]=f[e>>2]|6;p=0}else if((o|0)==17){l=f[a>>2]|0;k=f[l+12>>2]|0;if((k|0)==(f[l+16>>2]|0))q=mi[f[(f[l>>2]|0)+36>>2]&255](l)|0;else q=jOa(b[k>>0]|0)|0;k=q&255;if(k<<24>>24>-1?(l=g+8|0,d[(f[l>>2]|0)+(q<<24>>24<<1)>>1]&2048):0){m=(ui[f[(f[g>>2]|0)+36>>2]&127](g,k,0)|0)<<24>>24;k=f[a>>2]|0;i=k+12|0;j=f[i>>2]|0;if((j|0)==(f[k+16>>2]|0)){mi[f[(f[k>>2]|0)+40>>2]&255](k)|0;r=n;s=n;t=h;u=m}else{f[i>>2]=j+1;jOa(b[j>>0]|0)|0;r=n;s=n;t=h;u=m}while(1){v=u+-48|0;m=t+-1|0;j=f[a>>2]|0;do if(j){i=f[j+12>>2]|0;if((i|0)==(f[j+16>>2]|0))w=mi[f[(f[j>>2]|0)+36>>2]&255](j)|0;else w=jOa(b[i>>0]|0)|0;if(aPa(w,iOa()|0)|0){f[a>>2]=0;x=1;break}else{x=(f[a>>2]|0)==0;break}}else x=1;while(0);do if(s){j=f[s+12>>2]|0;if((j|0)==(f[s+16>>2]|0))y=mi[f[(f[s>>2]|0)+36>>2]&255](s)|0;else y=jOa(b[j>>0]|0)|0;if(aPa(y,iOa()|0)|0){f[c>>2]=0;z=0;A=1;B=0;break}else{z=r;A=(r|0)==0;B=r;break}}else{z=r;A=1;B=0}while(0);C=f[a>>2]|0;if(!((t|0)>1&(x^A)))break;j=f[C+12>>2]|0;if((j|0)==(f[C+16>>2]|0))D=mi[f[(f[C>>2]|0)+36>>2]&255](C)|0;else D=jOa(b[j>>0]|0)|0;j=D&255;if(j<<24>>24<=-1){p=v;break a}if(!(d[(f[l>>2]|0)+(D<<24>>24<<1)>>1]&2048)){p=v;break a}i=((ui[f[(f[g>>2]|0)+36>>2]&127](g,j,0)|0)<<24>>24)+(v*10|0)|0;j=f[a>>2]|0;k=j+12|0;E=f[k>>2]|0;if((E|0)==(f[j+16>>2]|0)){mi[f[(f[j>>2]|0)+40>>2]&255](j)|0;r=z;s=B;t=m;u=i;continue}else{f[k>>2]=E+1;jOa(b[E>>0]|0)|0;r=z;s=B;t=m;u=i;continue}}do if(C){l=f[C+12>>2]|0;if((l|0)==(f[C+16>>2]|0))F=mi[f[(f[C>>2]|0)+36>>2]&255](C)|0;else F=jOa(b[l>>0]|0)|0;if(aPa(F,iOa()|0)|0){f[a>>2]=0;G=1;break}else{G=(f[a>>2]|0)==0;break}}else G=1;while(0);do if(z){l=f[z+12>>2]|0;if((l|0)==(f[z+16>>2]|0))H=mi[f[(f[z>>2]|0)+36>>2]&255](z)|0;else H=jOa(b[l>>0]|0)|0;if(!(aPa(H,iOa()|0)|0))if(G){p=v;break a}else break;else{f[c>>2]=0;o=62;break}}else o=62;while(0);if((o|0)==62?!G:0){p=v;break}f[e>>2]=f[e>>2]|2;p=v;break}f[e>>2]=f[e>>2]|4;p=0}while(0);return p|0}function ZSa(a){a=a|0;hQa(a);return}function _Sa(a){a=a|0;hQa(a);PYa(a);return}function $Sa(a){a=a|0;return 2}function aTa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=wTa(a,j,i,d,e,g,129320,129352)|0;u=h;return l|0}function bTa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+16|0;j=i+12|0;k=i+8|0;l=i+4|0;m=i;n=a+8|0;o=mi[f[(f[n>>2]|0)+20>>2]&255](n)|0;f[l>>2]=f[c>>2];f[m>>2]=f[d>>2];d=b[o+8+3>>0]|0;c=d<<24>>24<0;n=c?f[o>>2]|0:o;p=n+((c?f[o+4>>2]|0:d&255)<<2)|0;f[k>>2]=f[l>>2];f[j>>2]=f[m>>2];m=wTa(a,k,j,e,g,h,n,p)|0;u=i;return m|0}function cTa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;bPa(i,d);d=BQa(i,1975208)|0;CQa(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];uTa(a,g+24|0,b,i,e,d);u=h;return f[b>>2]|0}function dTa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;bPa(i,d);d=BQa(i,1975208)|0;CQa(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];vTa(a,g+16|0,b,i,e,d);u=h;return f[b>>2]|0}function eTa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;bPa(i,d);d=BQa(i,1975208)|0;CQa(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];HTa(a,g+20|0,b,i,e,d);u=h;return f[b>>2]|0}function fTa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;j=u;u=u+144|0;k=j+128|0;l=j+112|0;m=j+124|0;n=j+120|0;o=j+116|0;p=j+108|0;q=j+104|0;r=j+100|0;s=j+96|0;t=j+92|0;v=j+88|0;w=j+84|0;x=j+80|0;y=j+76|0;z=j+72|0;A=j+68|0;B=j+64|0;C=j+60|0;D=j+56|0;E=j+52|0;F=j+48|0;G=j+44|0;H=j+40|0;I=j+36|0;J=j+32|0;K=j+28|0;L=j+24|0;M=j+20|0;N=j+16|0;O=j+12|0;P=j+8|0;Q=j+4|0;R=j;f[g>>2]=0;bPa(k,e);S=BQa(k,1975208)|0;CQa(k);T=h+8|0;U=h+20|0;V=h+16|0;W=h+24|0;X=a+8|0;do switch(i<<24>>24|0){case 65:case 97:{f[m>>2]=f[d>>2];f[k>>2]=f[m>>2];uTa(a,W,c,k,g,S);Y=26;break}case 104:case 66:case 98:{f[n>>2]=f[d>>2];f[k>>2]=f[n>>2];vTa(a,V,c,k,g,S);Y=26;break}case 99:{Z=mi[f[(f[X>>2]|0)+12>>2]&255](X)|0;f[o>>2]=f[c>>2];f[p>>2]=f[d>>2];_=b[Z+8+3>>0]|0;$=_<<24>>24<0;aa=$?f[Z>>2]|0:Z;ba=aa+(($?f[Z+4>>2]|0:_&255)<<2)|0;f[l>>2]=f[o>>2];f[k>>2]=f[p>>2];_=wTa(a,l,k,e,g,h,aa,ba)|0;f[c>>2]=_;Y=26;break}case 101:case 100:{f[q>>2]=f[d>>2];f[k>>2]=f[q>>2];xTa(a,h+12|0,c,k,g,S);Y=26;break}case 68:{f[r>>2]=f[c>>2];f[s>>2]=f[d>>2];f[l>>2]=f[r>>2];f[k>>2]=f[s>>2];_=wTa(a,l,k,e,g,h,129160,129192)|0;f[c>>2]=_;Y=26;break}case 70:{f[t>>2]=f[c>>2];f[v>>2]=f[d>>2];f[l>>2]=f[t>>2];f[k>>2]=f[v>>2];_=wTa(a,l,k,e,g,h,129192,129224)|0;f[c>>2]=_;Y=26;break}case 72:{f[w>>2]=f[d>>2];f[k>>2]=f[w>>2];yTa(a,T,c,k,g,S);Y=26;break}case 73:{f[x>>2]=f[d>>2];f[k>>2]=f[x>>2];zTa(a,T,c,k,g,S);Y=26;break}case 106:{f[y>>2]=f[d>>2];f[k>>2]=f[y>>2];ATa(a,h+28|0,c,k,g,S);Y=26;break}case 109:{f[z>>2]=f[d>>2];f[k>>2]=f[z>>2];BTa(a,V,c,k,g,S);Y=26;break}case 77:{f[A>>2]=f[d>>2];f[k>>2]=f[A>>2];CTa(a,h+4|0,c,k,g,S);Y=26;break}case 116:case 110:{f[B>>2]=f[d>>2];f[k>>2]=f[B>>2];DTa(a,c,k,g,S);Y=26;break}case 112:{f[C>>2]=f[d>>2];f[k>>2]=f[C>>2];ETa(a,T,c,k,g,S);Y=26;break}case 114:{f[D>>2]=f[c>>2];f[E>>2]=f[d>>2];f[l>>2]=f[D>>2];f[k>>2]=f[E>>2];_=wTa(a,l,k,e,g,h,129224,129268)|0;f[c>>2]=_;Y=26;break}case 82:{f[F>>2]=f[c>>2];f[G>>2]=f[d>>2];f[l>>2]=f[F>>2];f[k>>2]=f[G>>2];_=wTa(a,l,k,e,g,h,129268,129288)|0;f[c>>2]=_;Y=26;break}case 83:{f[H>>2]=f[d>>2];f[k>>2]=f[H>>2];FTa(a,h,c,k,g,S);Y=26;break}case 84:{f[I>>2]=f[c>>2];f[J>>2]=f[d>>2];f[l>>2]=f[I>>2];f[k>>2]=f[J>>2];_=wTa(a,l,k,e,g,h,129288,129320)|0;f[c>>2]=_;Y=26;break}case 119:{f[K>>2]=f[d>>2];f[k>>2]=f[K>>2];GTa(a,W,c,k,g,S);Y=26;break}case 120:{_=f[(f[a>>2]|0)+20>>2]|0;f[L>>2]=f[c>>2];f[M>>2]=f[d>>2];f[l>>2]=f[L>>2];f[k>>2]=f[M>>2];ca=bg[_&127](a,l,k,e,g,h)|0;break}case 88:{_=mi[f[(f[X>>2]|0)+24>>2]&255](X)|0;f[N>>2]=f[c>>2];f[O>>2]=f[d>>2];ba=b[_+8+3>>0]|0;aa=ba<<24>>24<0;Z=aa?f[_>>2]|0:_;$=Z+((aa?f[_+4>>2]|0:ba&255)<<2)|0;f[l>>2]=f[N>>2];f[k>>2]=f[O>>2];ba=wTa(a,l,k,e,g,h,Z,$)|0;f[c>>2]=ba;Y=26;break}case 121:{f[P>>2]=f[d>>2];f[k>>2]=f[P>>2];HTa(a,U,c,k,g,S);Y=26;break}case 89:{f[Q>>2]=f[d>>2];f[k>>2]=f[Q>>2];ITa(a,U,c,k,g,S);Y=26;break}case 37:{f[R>>2]=f[d>>2];f[k>>2]=f[R>>2];JTa(a,c,k,g,S);Y=26;break}default:{f[g>>2]=f[g>>2]|4;Y=26}}while(0);if((Y|0)==26)ca=f[c>>2]|0;u=j;return ca|0}function gTa(a){a=a|0;if((b[900432]|0)==0?u1a(900432)|0:0){sTa();f[494215]=1976692}return f[494215]|0}function hTa(a){a=a|0;if((b[900416]|0)==0?u1a(900416)|0:0){qTa();f[494172]=1976400}return f[494172]|0}function iTa(a){a=a|0;if((b[900400]|0)==0?u1a(900400)|0:0){oTa();f[494099]=1976108}return f[494099]|0}function jTa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[900392]|0)==0?u1a(900392)|0:0){f[494024]=0;f[494025]=0;f[494026]=0;d=nTa(128192)|0;if(d>>>0>1073741807)WYa(1976096);do if(d>>>0>=2){e=d+4&-4;if(e>>>0>1073741823)We();else{g=NYa(e<<2)|0;f[494024]=g;f[494026]=e|-2147483648;f[494025]=d;h=g;break}}else{b[1976107]=d;h=1976096}while(0);COa(h,128192,d)|0;f[c>>2]=0;nQa(h+(d<<2)|0,c);Fd(1022,1976096,x|0)|0}u=a;return 1976096}function kTa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[900384]|0)==0?u1a(900384)|0:0){f[494021]=0;f[494022]=0;f[494023]=0;d=nTa(128144)|0;if(d>>>0>1073741807)WYa(1976084);do if(d>>>0>=2){e=d+4&-4;if(e>>>0>1073741823)We();else{g=NYa(e<<2)|0;f[494021]=g;f[494023]=e|-2147483648;f[494022]=d;h=g;break}}else{b[1976095]=d;h=1976084}while(0);COa(h,128144,d)|0;f[c>>2]=0;nQa(h+(d<<2)|0,c);Fd(1022,1976084,x|0)|0}u=a;return 1976084}function lTa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[900376]|0)==0?u1a(900376)|0:0){f[494018]=0;f[494019]=0;f[494020]=0;d=nTa(128108)|0;if(d>>>0>1073741807)WYa(1976072);do if(d>>>0>=2){e=d+4&-4;if(e>>>0>1073741823)We();else{g=NYa(e<<2)|0;f[494018]=g;f[494020]=e|-2147483648;f[494019]=d;h=g;break}}else{b[1976083]=d;h=1976072}while(0);COa(h,128108,d)|0;f[c>>2]=0;nQa(h+(d<<2)|0,c);Fd(1022,1976072,x|0)|0}u=a;return 1976072}function mTa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[900368]|0)==0?u1a(900368)|0:0){f[494015]=0;f[494016]=0;f[494017]=0;d=nTa(128072)|0;if(d>>>0>1073741807)WYa(1976060);do if(d>>>0>=2){e=d+4&-4;if(e>>>0>1073741823)We();else{g=NYa(e<<2)|0;f[494015]=g;f[494017]=e|-2147483648;f[494016]=d;h=g;break}}else{b[1976071]=d;h=1976060}while(0);COa(h,128072,d)|0;f[c>>2]=0;nQa(h+(d<<2)|0,c);Fd(1022,1976060,x|0)|0}u=a;return 1976060}function nTa(a){a=a|0;return LKa(a)|0}function oTa(){var a=0,c=0;if((b[900408]|0)==0?u1a(900408)|0:0){a=1976108;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=1976396);Fd(1023,0,x|0)|0}vZa(1976108,128276)|0;vZa(1976120,128288)|0;return}function pTa(a){a=a|0;a=1976396;do{a=a+-12|0;qZa(a)}while((a|0)!=1976108);return}function qTa(){var a=0,c=0;if((b[900424]|0)==0?u1a(900424)|0:0){a=1976400;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=1976688);Fd(1024,0,x|0)|0}vZa(1976400,128300)|0;vZa(1976412,128332)|0;vZa(1976424,128368)|0;vZa(1976436,128392)|0;vZa(1976448,128416)|0;vZa(1976460,128432)|0;vZa(1976472,128452)|0;vZa(1976484,128472)|0;vZa(1976496,128500)|0;vZa(1976508,128540)|0;vZa(1976520,128572)|0;vZa(1976532,128608)|0;vZa(1976544,128644)|0;vZa(1976556,128660)|0;vZa(1976568,128676)|0;vZa(1976580,128692)|0;vZa(1976592,128416)|0;vZa(1976604,128708)|0;vZa(1976616,128724)|0;vZa(1976628,128740)|0;vZa(1976640,128756)|0;vZa(1976652,128772)|0;vZa(1976664,128788)|0;vZa(1976676,128804)|0;return}function rTa(a){a=a|0;a=1976688;do{a=a+-12|0;qZa(a)}while((a|0)!=1976400);return}function sTa(){var a=0,c=0;if((b[900440]|0)==0?u1a(900440)|0:0){a=1976692;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=1976860);Fd(1025,0,x|0)|0}vZa(1976692,128820)|0;vZa(1976704,128848)|0;vZa(1976716,128876)|0;vZa(1976728,128908)|0;vZa(1976740,128948)|0;vZa(1976752,128984)|0;vZa(1976764,129012)|0;vZa(1976776,129048)|0;vZa(1976788,129064)|0;vZa(1976800,129080)|0;vZa(1976812,129096)|0;vZa(1976824,129112)|0;vZa(1976836,129128)|0;vZa(1976848,129144)|0;return}function tTa(a){a=a|0;a=1976860;do{a=a+-12|0;qZa(a)}while((a|0)!=1976692);return}function uTa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+16|0;i=h+4|0;j=h;k=a+8|0;a=mi[f[f[k>>2]>>2]&255](k)|0;f[j>>2]=f[d>>2];f[i>>2]=f[j>>2];j=(IRa(c,i,a,a+168|0,g,e,0)|0)-a|0;if((j|0)<168)f[b>>2]=((j|0)/12|0|0)%7|0;u=h;return}function vTa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+16|0;i=h+4|0;j=h;k=a+8|0;a=mi[f[(f[k>>2]|0)+4>>2]&255](k)|0;f[j>>2]=f[d>>2];f[i>>2]=f[j>>2];j=(IRa(c,i,a,a+288|0,g,e,0)|0)-a|0;if((j|0)<288)f[b>>2]=((j|0)/12|0|0)%12|0;u=h;return}function wTa(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;j=u;u=u+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;bPa(k,d);o=BQa(k,1975208)|0;CQa(k);f[e>>2]=0;p=0;q=h;a:while(1){h=(q|0)!=(i|0);r=p;while(1){s=f[b>>2]|0;if(!(h&(r|0)==0)){t=s;break a}v=s;if(s){w=f[s+12>>2]|0;if((w|0)==(f[s+16>>2]|0))x=mi[f[(f[s>>2]|0)+36>>2]&255](s)|0;else x=BOa(f[w>>2]|0)|0;if(cPa(x,AOa()|0)|0){f[b>>2]=0;y=0;z=0;A=1}else{y=v;z=s;A=0}}else{y=v;z=0;A=1}v=f[c>>2]|0;s=v;do if(v){w=f[v+12>>2]|0;if((w|0)==(f[v+16>>2]|0))B=mi[f[(f[v>>2]|0)+36>>2]&255](v)|0;else B=BOa(f[w>>2]|0)|0;if(!(cPa(B,AOa()|0)|0))if(A){C=s;D=v;break}else{E=58;break a}else{f[c>>2]=0;F=0;E=16;break}}else{F=s;E=16}while(0);if((E|0)==16){E=0;if(A){E=58;break a}else{C=F;D=0}}if((ui[f[(f[o>>2]|0)+52>>2]&127](o,f[q>>2]|0,0)|0)<<24>>24==37){E=19;break}if(ui[f[(f[o>>2]|0)+12>>2]&127](o,8192,f[q>>2]|0)|0){G=q;E=26;break}H=z+12|0;s=f[H>>2]|0;I=z+16|0;if((s|0)==(f[I>>2]|0))J=mi[f[(f[z>>2]|0)+36>>2]&255](z)|0;else J=BOa(f[s>>2]|0)|0;s=$h[f[(f[o>>2]|0)+28>>2]&255](o,J)|0;if((s|0)==($h[f[(f[o>>2]|0)+28>>2]&255](o,f[q>>2]|0)|0)){E=54;break}f[e>>2]=4;r=4}b:do if((E|0)==19){E=0;r=q+4|0;if((r|0)==(i|0)){E=58;break a}h=ui[f[(f[o>>2]|0)+52>>2]&127](o,f[r>>2]|0,0)|0;switch(h<<24>>24){case 48:case 69:{s=q+8|0;if((s|0)==(i|0)){E=58;break a}K=r;L=ui[f[(f[o>>2]|0)+52>>2]&127](o,f[s>>2]|0,0)|0;M=h;break}default:{K=q;L=h;M=0}}h=f[(f[a>>2]|0)+36>>2]|0;f[m>>2]=y;f[n>>2]=C;f[l>>2]=f[m>>2];f[k>>2]=f[n>>2];s=Oi[h&15](a,l,k,d,e,g,L,M)|0;f[b>>2]=s;N=K+8|0}else if((E|0)==26){while(1){E=0;s=G+4|0;if((s|0)==(i|0)){O=i;break}if(ui[f[(f[o>>2]|0)+12>>2]&127](o,8192,f[s>>2]|0)|0){G=s;E=26}else{O=s;break}}s=z;h=D;r=D;while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))P=mi[f[(f[s>>2]|0)+36>>2]&255](s)|0;else P=BOa(f[v>>2]|0)|0;if(cPa(P,AOa()|0)|0){f[b>>2]=0;Q=1;R=0}else{Q=0;R=s}}else{Q=1;R=0}do if(r){v=f[r+12>>2]|0;if((v|0)==(f[r+16>>2]|0))S=mi[f[(f[r>>2]|0)+36>>2]&255](r)|0;else S=BOa(f[v>>2]|0)|0;if(!(cPa(S,AOa()|0)|0))if(Q^(h|0)==0){T=h;U=h;break}else{N=O;break b}else{f[c>>2]=0;V=0;E=41;break}}else{V=h;E=41}while(0);if((E|0)==41){E=0;if(Q){N=O;break b}else{T=V;U=0}}v=R+12|0;w=f[v>>2]|0;W=R+16|0;if((w|0)==(f[W>>2]|0))X=mi[f[(f[R>>2]|0)+36>>2]&255](R)|0;else X=BOa(f[w>>2]|0)|0;if(!(ui[f[(f[o>>2]|0)+12>>2]&127](o,8192,X)|0)){N=O;break b}w=f[v>>2]|0;if((w|0)==(f[W>>2]|0)){mi[f[(f[R>>2]|0)+40>>2]&255](R)|0;s=R;h=T;r=U;continue}else{f[v>>2]=w+4;BOa(f[w>>2]|0)|0;s=R;h=T;r=U;continue}}}else if((E|0)==54){E=0;r=q+4|0;h=f[H>>2]|0;if((h|0)==(f[I>>2]|0)){mi[f[(f[z>>2]|0)+40>>2]&255](z)|0;N=r;break}else{f[H>>2]=h+4;BOa(f[h>>2]|0)|0;N=r;break}}while(0);p=f[e>>2]|0;q=N}if((E|0)==58){f[e>>2]=4;t=z}if(t){z=f[t+12>>2]|0;if((z|0)==(f[t+16>>2]|0))Y=mi[f[(f[t>>2]|0)+36>>2]&255](t)|0;else Y=BOa(f[z>>2]|0)|0;if(cPa(Y,AOa()|0)|0){f[b>>2]=0;Z=1;_=0}else{Z=0;_=t}}else{Z=1;_=0}t=f[c>>2]|0;do if(t){b=f[t+12>>2]|0;if((b|0)==(f[t+16>>2]|0))$=mi[f[(f[t>>2]|0)+36>>2]&255](t)|0;else $=BOa(f[b>>2]|0)|0;if(!(cPa($,AOa()|0)|0))if(Z)break;else{E=73;break}else{f[c>>2]=0;E=71;break}}else E=71;while(0);if((E|0)==71?Z:0)E=73;if((E|0)==73)f[e>>2]=f[e>>2]|2;u=j;return _|0}function xTa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=KTa(c,h,e,g,2)|0;g=f[e>>2]|0;if((i+-1|0)>>>0<31&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function yTa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=KTa(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<24&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function zTa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=KTa(c,h,e,g,2)|0;g=f[e>>2]|0;if((i+-1|0)>>>0<12&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function ATa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=KTa(c,h,e,g,3)|0;g=f[e>>2]|0;if((i|0)<366&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function BTa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=KTa(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<13&(g&4|0)==0)f[b>>2]=i+-1;else f[e>>2]=g|4;u=a;return}function CTa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=KTa(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<60&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function DTa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a:while(1){a=f[b>>2]|0;do if(a){g=f[a+12>>2]|0;if((g|0)==(f[a+16>>2]|0))h=mi[f[(f[a>>2]|0)+36>>2]&255](a)|0;else h=BOa(f[g>>2]|0)|0;if(cPa(h,AOa()|0)|0){f[b>>2]=0;i=1;break}else{i=(f[b>>2]|0)==0;break}}else i=1;while(0);a=f[c>>2]|0;do if(a){g=f[a+12>>2]|0;if((g|0)==(f[a+16>>2]|0))j=mi[f[(f[a>>2]|0)+36>>2]&255](a)|0;else j=BOa(f[g>>2]|0)|0;if(!(cPa(j,AOa()|0)|0))if(i){k=a;break}else{l=a;break a}else{f[c>>2]=0;m=15;break}}else m=15;while(0);if((m|0)==15){m=0;if(i){l=0;break}else k=0}a=f[b>>2]|0;g=f[a+12>>2]|0;if((g|0)==(f[a+16>>2]|0))n=mi[f[(f[a>>2]|0)+36>>2]&255](a)|0;else n=BOa(f[g>>2]|0)|0;if(!(ui[f[(f[e>>2]|0)+12>>2]&127](e,8192,n)|0)){l=k;break}g=f[b>>2]|0;a=g+12|0;o=f[a>>2]|0;if((o|0)==(f[g+16>>2]|0)){mi[f[(f[g>>2]|0)+40>>2]&255](g)|0;continue}else{f[a>>2]=o+4;BOa(f[o>>2]|0)|0;continue}}k=f[b>>2]|0;do if(k){n=f[k+12>>2]|0;if((n|0)==(f[k+16>>2]|0))p=mi[f[(f[k>>2]|0)+36>>2]&255](k)|0;else p=BOa(f[n>>2]|0)|0;if(cPa(p,AOa()|0)|0){f[b>>2]=0;q=1;break}else{q=(f[b>>2]|0)==0;break}}else q=1;while(0);do if(l){b=f[l+12>>2]|0;if((b|0)==(f[l+16>>2]|0))r=mi[f[(f[l>>2]|0)+36>>2]&255](l)|0;else r=BOa(f[b>>2]|0)|0;if(!(cPa(r,AOa()|0)|0))if(q)break;else{m=39;break}else{f[c>>2]=0;m=37;break}}else m=37;while(0);if((m|0)==37?q:0)m=39;if((m|0)==39)f[d>>2]=f[d>>2]|2;return}function ETa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+16|0;j=i+4|0;k=i;l=a+8|0;a=mi[f[(f[l>>2]|0)+8>>2]&255](l)|0;l=b[a+8+3>>0]|0;if(l<<24>>24<0)m=f[a+4>>2]|0;else m=l&255;l=b[a+20+3>>0]|0;if(l<<24>>24<0)n=f[a+16>>2]|0;else n=l&255;do if((m|0)!=(0-n|0)){f[k>>2]=f[e>>2];f[j>>2]=f[k>>2];l=(IRa(d,j,a,a+24|0,h,g,0)|0)-a|0;o=f[c>>2]|0;if((o|0)==12&(l|0)==0){f[c>>2]=0;break}if((o|0)<12&(l|0)==12)f[c>>2]=o+12}else f[g>>2]=f[g>>2]|4;while(0);u=i;return}function FTa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=KTa(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<61&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function GTa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=KTa(c,h,e,g,1)|0;g=f[e>>2]|0;if((i|0)<7&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function HTa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=KTa(c,h,e,g,4)|0;if(!(f[e>>2]&4)){if((i|0)<69)j=i+2e3|0;else j=(i|0)<100?i+1900|0:i;f[b>>2]=j+-1900}u=a;return}function ITa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=KTa(c,h,e,g,4)|0;if(!(f[e>>2]&4))f[b>>2]=i+-1900;u=a;return}function JTa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=f[b>>2]|0;do if(a){g=f[a+12>>2]|0;if((g|0)==(f[a+16>>2]|0))h=mi[f[(f[a>>2]|0)+36>>2]&255](a)|0;else h=BOa(f[g>>2]|0)|0;if(cPa(h,AOa()|0)|0){f[b>>2]=0;i=1;break}else{i=(f[b>>2]|0)==0;break}}else i=1;while(0);h=f[c>>2]|0;do if(h){a=f[h+12>>2]|0;if((a|0)==(f[h+16>>2]|0))j=mi[f[(f[h>>2]|0)+36>>2]&255](h)|0;else j=BOa(f[a>>2]|0)|0;if(!(cPa(j,AOa()|0)|0))if(i){k=h;l=16;break}else{m=6;l=38;break}else{f[c>>2]=0;l=14;break}}else l=14;while(0);if((l|0)==14)if(i){m=6;l=38}else{k=0;l=16}a:do if((l|0)==16){i=f[b>>2]|0;h=f[i+12>>2]|0;if((h|0)==(f[i+16>>2]|0))n=mi[f[(f[i>>2]|0)+36>>2]&255](i)|0;else n=BOa(f[h>>2]|0)|0;if((ui[f[(f[e>>2]|0)+52>>2]&127](e,n,0)|0)<<24>>24==37){h=f[b>>2]|0;i=h+12|0;j=f[i>>2]|0;if((j|0)==(f[h+16>>2]|0))mi[f[(f[h>>2]|0)+40>>2]&255](h)|0;else{f[i>>2]=j+4;BOa(f[j>>2]|0)|0}j=f[b>>2]|0;do if(j){i=f[j+12>>2]|0;if((i|0)==(f[j+16>>2]|0))o=mi[f[(f[j>>2]|0)+36>>2]&255](j)|0;else o=BOa(f[i>>2]|0)|0;if(cPa(o,AOa()|0)|0){f[b>>2]=0;p=1;break}else{p=(f[b>>2]|0)==0;break}}else p=1;while(0);do if(k|0){j=f[k+12>>2]|0;if((j|0)==(f[k+16>>2]|0))q=mi[f[(f[k>>2]|0)+36>>2]&255](k)|0;else q=BOa(f[j>>2]|0)|0;if(!(cPa(q,AOa()|0)|0))if(p)break a;else{m=2;l=38;break a}else{f[c>>2]=0;break}}while(0);if(p){m=2;l=38}}else{m=4;l=38}}while(0);if((l|0)==38)f[d>>2]=f[d>>2]|m;return}function KTa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=f[a>>2]|0;do if(g){h=f[g+12>>2]|0;if((h|0)==(f[g+16>>2]|0))i=mi[f[(f[g>>2]|0)+36>>2]&255](g)|0;else i=BOa(f[h>>2]|0)|0;if(cPa(i,AOa()|0)|0){f[a>>2]=0;j=1;break}else{j=(f[a>>2]|0)==0;break}}else j=1;while(0);i=f[b>>2]|0;do if(i){g=f[i+12>>2]|0;if((g|0)==(f[i+16>>2]|0))k=mi[f[(f[i>>2]|0)+36>>2]&255](i)|0;else k=BOa(f[g>>2]|0)|0;if(!(cPa(k,AOa()|0)|0))if(j){l=i;m=17;break}else{m=16;break}else{f[b>>2]=0;m=14;break}}else m=14;while(0);if((m|0)==14)if(j)m=16;else{l=0;m=17}a:do if((m|0)==16){f[c>>2]=f[c>>2]|6;n=0}else if((m|0)==17){j=f[a>>2]|0;i=f[j+12>>2]|0;if((i|0)==(f[j+16>>2]|0))o=mi[f[(f[j>>2]|0)+36>>2]&255](j)|0;else o=BOa(f[i>>2]|0)|0;if(!(ui[f[(f[d>>2]|0)+12>>2]&127](d,2048,o)|0)){f[c>>2]=f[c>>2]|4;n=0;break}i=(ui[f[(f[d>>2]|0)+52>>2]&127](d,o,0)|0)<<24>>24;j=f[a>>2]|0;k=j+12|0;g=f[k>>2]|0;if((g|0)==(f[j+16>>2]|0)){mi[f[(f[j>>2]|0)+40>>2]&255](j)|0;p=l;q=l;r=e;s=i}else{f[k>>2]=g+4;BOa(f[g>>2]|0)|0;p=l;q=l;r=e;s=i}while(1){t=s+-48|0;i=r+-1|0;g=f[a>>2]|0;do if(g){k=f[g+12>>2]|0;if((k|0)==(f[g+16>>2]|0))u=mi[f[(f[g>>2]|0)+36>>2]&255](g)|0;else u=BOa(f[k>>2]|0)|0;if(cPa(u,AOa()|0)|0){f[a>>2]=0;v=1;break}else{v=(f[a>>2]|0)==0;break}}else v=1;while(0);do if(q){g=f[q+12>>2]|0;if((g|0)==(f[q+16>>2]|0))w=mi[f[(f[q>>2]|0)+36>>2]&255](q)|0;else w=BOa(f[g>>2]|0)|0;if(cPa(w,AOa()|0)|0){f[b>>2]=0;x=0;y=1;z=0;break}else{x=p;y=(p|0)==0;z=p;break}}else{x=p;y=1;z=0}while(0);A=f[a>>2]|0;if(!((r|0)>1&(v^y)))break;g=f[A+12>>2]|0;if((g|0)==(f[A+16>>2]|0))B=mi[f[(f[A>>2]|0)+36>>2]&255](A)|0;else B=BOa(f[g>>2]|0)|0;if(!(ui[f[(f[d>>2]|0)+12>>2]&127](d,2048,B)|0)){n=t;break a}g=((ui[f[(f[d>>2]|0)+52>>2]&127](d,B,0)|0)<<24>>24)+(t*10|0)|0;k=f[a>>2]|0;j=k+12|0;h=f[j>>2]|0;if((h|0)==(f[k+16>>2]|0)){mi[f[(f[k>>2]|0)+40>>2]&255](k)|0;p=x;q=z;r=i;s=g;continue}else{f[j>>2]=h+4;BOa(f[h>>2]|0)|0;p=x;q=z;r=i;s=g;continue}}do if(A){g=f[A+12>>2]|0;if((g|0)==(f[A+16>>2]|0))C=mi[f[(f[A>>2]|0)+36>>2]&255](A)|0;else C=BOa(f[g>>2]|0)|0;if(cPa(C,AOa()|0)|0){f[a>>2]=0;D=1;break}else{D=(f[a>>2]|0)==0;break}}else D=1;while(0);do if(x){g=f[x+12>>2]|0;if((g|0)==(f[x+16>>2]|0))E=mi[f[(f[x>>2]|0)+36>>2]&255](x)|0;else E=BOa(f[g>>2]|0)|0;if(!(cPa(E,AOa()|0)|0))if(D){n=t;break a}else break;else{f[b>>2]=0;m=60;break}}else m=60;while(0);if((m|0)==60?!D:0){n=t;break}f[c>>2]=f[c>>2]|2;n=t}while(0);return n|0}function LTa(a){a=a|0;QTa(a+8|0);hQa(a);return}function MTa(a){a=a|0;QTa(a+8|0);hQa(a);PYa(a);return}function NTa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;e=u;u=u+112|0;d=e+4|0;j=e;f[j>>2]=d+100;OTa(a+8|0,d,j,g,h,i);i=f[j>>2]|0;j=d;d=f[c>>2]|0;while(1){if((j|0)==(i|0))break;c=b[j>>0]|0;if(!d)k=0;else{h=d+24|0;g=f[h>>2]|0;if((g|0)==(f[d+28>>2]|0)){a=f[(f[d>>2]|0)+52>>2]|0;l=jOa(c)|0;m=$h[a&255](d,l)|0}else{f[h>>2]=g+1;b[g>>0]=c;m=jOa(c)|0}c=aPa(m,iOa()|0)|0;k=c?0:d}j=j+1|0;d=k}u=e;return d|0}function OTa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+16|0;j=i;b[j>>0]=37;k=j+1|0;b[k>>0]=g;l=j+2|0;b[l>>0]=h;b[j+3>>0]=0;if(h<<24>>24){b[k>>0]=h;b[l>>0]=g}g=PTa(c,f[d>>2]|0)|0;l=c+(uf(c|0,g|0,j|0,e|0,f[a>>2]|0)|0)|0;f[d>>2]=l;u=i;return}function PTa(a,b){a=a|0;b=b|0;return b-a|0}function QTa(a){a=a|0;var b=0;b=f[a>>2]|0;if((b|0)!=(EQa()|0))ENa(f[a>>2]|0);return}function RTa(a){a=a|0;QTa(a+8|0);hQa(a);return}function STa(a){a=a|0;QTa(a+8|0);hQa(a);PYa(a);return}function TTa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;d=u;u=u+416|0;c=d+8|0;i=d;f[i>>2]=c+400;UTa(a+8|0,c,i,e,g,h);h=f[i>>2]|0;i=c;c=f[b>>2]|0;while(1){if((i|0)==(h|0))break;b=f[i>>2]|0;if(!c)j=0;else{g=c+24|0;e=f[g>>2]|0;if((e|0)==(f[c+28>>2]|0)){a=f[(f[c>>2]|0)+52>>2]|0;k=BOa(b)|0;l=$h[a&255](c,k)|0}else{f[g>>2]=e+4;f[e>>2]=b;l=BOa(b)|0}b=cPa(l,AOa()|0)|0;j=b?0:c}i=i+4|0;c=j}u=d;return c|0}function UTa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+128|0;i=h+16|0;j=h+12|0;k=h;l=h+8|0;f[j>>2]=i+100;OTa(a,i,j,d,e,g);g=k;f[g>>2]=0;f[g+4>>2]=0;f[l>>2]=i;i=VTa(b,f[c>>2]|0)|0;g=ANa(f[a>>2]|0)|0;a=PLa(b,l,i,k)|0;if(g|0)ANa(g)|0;if((a|0)==-1)WTa(0);else{f[c>>2]=b+(a<<2);u=h;return}}function VTa(a,b){a=a|0;b=b|0;return b-a>>2|0}function WTa(a){a=a|0;We()}function XTa(a){a=a|0;hQa(a);return}function YTa(a){a=a|0;hQa(a);PYa(a);return}function ZTa(a){a=a|0;return 127}function _Ta(a){a=a|0;return 127}function $Ta(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function aUa(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function bUa(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function cUa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=1;gUa(a,1,45)|0;b[d>>0]=0;ZOa(a+1|0,d);u=c;return}function dUa(a){a=a|0;return 0}function eUa(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function fUa(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function gUa(a,b,c){a=a|0;b=b|0;c=c|0;if(b|0)F1a(a|0,(jOa(c)|0)&255|0,b|0)|0;return a|0}function hUa(a){a=a|0;hQa(a);return}function iUa(a){a=a|0;hQa(a);PYa(a);return}function jUa(a){a=a|0;return 127}function kUa(a){a=a|0;return 127}function lUa(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function mUa(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function nUa(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function oUa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=1;gUa(a,1,45)|0;b[d>>0]=0;ZOa(a+1|0,d);u=c;return}function pUa(a){a=a|0;return 0}function qUa(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function rUa(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function sUa(a){a=a|0;hQa(a);return}function tUa(a){a=a|0;hQa(a);PYa(a);return}function uUa(a){a=a|0;return 2147483647}function vUa(a){a=a|0;return 2147483647}function wUa(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function xUa(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function yUa(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function zUa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+8+3>>0]=1;jSa(a,1,45)|0;f[d>>2]=0;nQa(a+4|0,d);u=c;return}function AUa(a){a=a|0;return 0}function BUa(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function CUa(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function DUa(a){a=a|0;hQa(a);return}function EUa(a){a=a|0;hQa(a);PYa(a);return}function FUa(a){a=a|0;return 2147483647}function GUa(a){a=a|0;return 2147483647}function HUa(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function IUa(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function JUa(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function KUa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+8+3>>0]=1;jSa(a,1,45)|0;f[d>>2]=0;nQa(a+4|0,d);u=c;return}function LUa(a){a=a|0;return 0}function MUa(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function NUa(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function OUa(a){a=a|0;hQa(a);return}function PUa(a){a=a|0;hQa(a);PYa(a);return}function QUa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;a=u;u=u+240|0;j=a+24|0;k=a;l=a+140|0;m=a+16|0;n=a+12|0;o=a+8|0;p=a+136|0;q=a+4|0;r=a+36|0;f[m>>2]=l;s=m+4|0;f[s>>2]=1026;bPa(o,g);t=BQa(o,1975176)|0;b[p>>0]=0;f[q>>2]=f[d>>2];v=f[g+4>>2]|0;f[j>>2]=f[q>>2];if(TUa(c,j,e,o,v,h,p,t,m,n,l+100|0)|0){Jg[f[(f[t>>2]|0)+32>>2]&63](t,371400,371410,j)|0;t=f[n>>2]|0;l=f[m>>2]|0;v=t-l|0;e=l;l=t;if((v|0)>98){t=dKa(v+2|0)|0;if(!t)RYa();else{w=t;x=t}}else{w=0;x=r}if(!(b[p>>0]|0))y=x;else{b[x>>0]=45;y=x+1|0}x=j+10|0;p=j;t=l;l=y;y=e;while(1){if(y>>>0>=t>>>0)break;e=b[y>>0]|0;v=j;while(1){if((v|0)==(x|0)){z=x;break}if((b[v>>0]|0)==e<<24>>24){z=v;break}v=v+1|0}b[l>>0]=b[371400+(z-p)>>0]|0;t=f[n>>2]|0;l=l+1|0;y=y+1|0}b[l>>0]=0;f[k>>2]=i;if((SMa(r,371411,k)|0)!=1)WTa(0);if(w|0)eKa(w)}w=f[c>>2]|0;do if(w){k=f[w+12>>2]|0;if((k|0)==(f[w+16>>2]|0))A=mi[f[(f[w>>2]|0)+36>>2]&255](w)|0;else A=jOa(b[k>>0]|0)|0;if(aPa(A,iOa()|0)|0){f[c>>2]=0;B=1;break}else{B=(f[c>>2]|0)==0;break}}else B=1;while(0);A=f[d>>2]|0;do if(A){w=f[A+12>>2]|0;if((w|0)==(f[A+16>>2]|0))C=mi[f[(f[A>>2]|0)+36>>2]&255](A)|0;else C=jOa(b[w>>0]|0)|0;if(!(aPa(C,iOa()|0)|0))if(B)break;else{D=34;break}else{f[d>>2]=0;D=32;break}}else D=32;while(0);if((D|0)==32?B:0)D=34;if((D|0)==34)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;CQa(o);o=f[m>>2]|0;f[m>>2]=0;if(o|0)ki[f[s>>2]&2047](o);u=a;return h|0}function RUa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;a=u;u=u+144|0;j=a+24|0;k=a+32|0;l=a+16|0;m=a+8|0;n=a;o=a+28|0;p=a+4|0;f[l>>2]=k;q=l+4|0;f[q>>2]=1026;bPa(n,g);r=BQa(n,1975176)|0;b[o>>0]=0;s=f[d>>2]|0;f[p>>2]=s;t=f[g+4>>2]|0;f[j>>2]=f[p>>2];p=s;if(TUa(c,j,e,n,t,h,o,r,l,m,k+100|0)|0){k=i+11|0;if((b[k>>0]|0)<0){t=f[i>>2]|0;b[j>>0]=0;ZOa(t,j);f[i+4>>2]=0}else{b[j>>0]=0;ZOa(i,j);b[k>>0]=0}if(b[o>>0]|0)kZa(i,$h[f[(f[r>>2]|0)+28>>2]&255](r,45)|0);o=$h[f[(f[r>>2]|0)+28>>2]&255](r,48)|0;r=f[m>>2]|0;m=r+-1|0;k=f[l>>2]|0;while(1){if(k>>>0>=m>>>0)break;if((b[k>>0]|0)!=o<<24>>24)break;k=k+1|0}fW(i,k,r)|0}r=f[c>>2]|0;do if(r){k=f[r+12>>2]|0;if((k|0)==(f[r+16>>2]|0))v=mi[f[(f[r>>2]|0)+36>>2]&255](r)|0;else v=jOa(b[k>>0]|0)|0;if(aPa(v,iOa()|0)|0){f[c>>2]=0;w=1;break}else{w=(f[c>>2]|0)==0;break}}else w=1;while(0);do if(s){v=f[p+12>>2]|0;if((v|0)==(f[p+16>>2]|0))x=mi[f[(f[s>>2]|0)+36>>2]&255](p)|0;else x=jOa(b[v>>0]|0)|0;if(!(aPa(x,iOa()|0)|0))if(w)break;else{y=27;break}else{f[d>>2]=0;y=25;break}}else y=25;while(0);if((y|0)==25?w:0)y=27;if((y|0)==27)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;CQa(n);n=f[l>>2]|0;f[l>>2]=0;if(n|0)ki[f[q>>2]&2047](n);u=a;return h|0}function SUa(a){a=a|0;return}function TUa(a,c,e,g,i,j,k,l,m,n,o){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0;p=u;u=u+512|0;q=p+88|0;r=p+96|0;s=p+80|0;t=p+72|0;v=p+68|0;w=p+500|0;x=p+497|0;y=p+496|0;z=p+56|0;A=p+44|0;B=p+32|0;C=p+20|0;D=p+8|0;E=p+4|0;F=p;f[q>>2]=o;f[s>>2]=r;o=s+4|0;f[o>>2]=1026;f[t>>2]=r;f[v>>2]=r+400;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;r=0;while(1){if((r|0)==3)break;f[z+(r<<2)>>2]=0;r=r+1|0}f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;r=0;while(1){if((r|0)==3)break;f[A+(r<<2)>>2]=0;r=r+1|0}f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;r=0;while(1){if((r|0)==3)break;f[B+(r<<2)>>2]=0;r=r+1|0}f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;r=0;while(1){if((r|0)==3)break;f[C+(r<<2)>>2]=0;r=r+1|0}f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;r=0;while(1){if((r|0)==3)break;f[D+(r<<2)>>2]=0;r=r+1|0}UUa(e,g,w,x,y,z,A,B,C,E);f[n>>2]=f[m>>2];g=l+8|0;l=B+11|0;e=B+4|0;r=C+11|0;G=C+4|0;H=(i&512|0)!=0;i=A+11|0;I=A+4|0;J=D+11|0;K=D+4|0;L=w+3|0;M=z+11|0;N=z+4|0;O=0;P=0;a:while(1){Q=(P|0)!=0;if(O>>>0>=4){R=234;break}S=f[a>>2]|0;do if(S){T=f[S+12>>2]|0;if((T|0)==(f[S+16>>2]|0))U=mi[f[(f[S>>2]|0)+36>>2]&255](S)|0;else U=jOa(b[T>>0]|0)|0;if(aPa(U,iOa()|0)|0){f[a>>2]=0;V=1;break}else{V=(f[a>>2]|0)==0;break}}else V=1;while(0);S=f[c>>2]|0;do if(S){T=f[S+12>>2]|0;if((T|0)==(f[S+16>>2]|0))W=mi[f[(f[S>>2]|0)+36>>2]&255](S)|0;else W=jOa(b[T>>0]|0)|0;if(!(aPa(W,iOa()|0)|0))if(V){X=S;break}else{R=234;break a}else{f[c>>2]=0;R=31;break}}else R=31;while(0);if((R|0)==31){R=0;if(V){R=234;break}else X=0}S=(O|0)!=3;b:do switch(b[w+O>>0]|0){case 1:{if(S){T=f[a>>2]|0;Y=f[T+12>>2]|0;if((Y|0)==(f[T+16>>2]|0))Z=mi[f[(f[T>>2]|0)+36>>2]&255](T)|0;else Z=jOa(b[Y>>0]|0)|0;if((Z&255)<<24>>24<=-1){R=44;break a}if(!(d[(f[g>>2]|0)+(Z<<24>>24<<1)>>1]&8192)){R=44;break a}Y=f[a>>2]|0;T=Y+12|0;_=f[T>>2]|0;if((_|0)==(f[Y+16>>2]|0))$=mi[f[(f[Y>>2]|0)+40>>2]&255](Y)|0;else{f[T>>2]=_+1;$=jOa(b[_>>0]|0)|0}kZa(D,$&255);aa=X;ba=X;R=46}else ca=P;break}case 0:{if(S){aa=X;ba=X;R=46}else ca=P;break}case 3:{_=b[l>>0]|0;T=_<<24>>24<0?f[e>>2]|0:_&255;_=b[r>>0]|0;Y=_<<24>>24<0?f[G>>2]|0:_&255;if((T|0)==(0-Y|0))ca=P;else{_=(T|0)==0;T=f[a>>2]|0;da=f[T+12>>2]|0;ea=(da|0)==(f[T+16>>2]|0);if(_|(Y|0)==0){if(ea)fa=mi[f[(f[T>>2]|0)+36>>2]&255](T)|0;else fa=jOa(b[da>>0]|0)|0;Y=fa&255;if(_){if(Y<<24>>24!=(b[((b[r>>0]|0)<0?f[C>>2]|0:C)>>0]|0)){ca=P;break b}_=f[a>>2]|0;ga=_+12|0;ha=f[ga>>2]|0;if((ha|0)==(f[_+16>>2]|0))mi[f[(f[_>>2]|0)+40>>2]&255](_)|0;else{f[ga>>2]=ha+1;jOa(b[ha>>0]|0)|0}b[k>>0]=1;ha=b[r>>0]|0;ca=(ha<<24>>24<0?f[G>>2]|0:ha&255)>>>0>1?C:P;break b}if(Y<<24>>24!=(b[((b[l>>0]|0)<0?f[B>>2]|0:B)>>0]|0)){b[k>>0]=1;ca=P;break b}Y=f[a>>2]|0;ha=Y+12|0;ga=f[ha>>2]|0;if((ga|0)==(f[Y+16>>2]|0))mi[f[(f[Y>>2]|0)+40>>2]&255](Y)|0;else{f[ha>>2]=ga+1;jOa(b[ga>>0]|0)|0}ga=b[l>>0]|0;ca=(ga<<24>>24<0?f[e>>2]|0:ga&255)>>>0>1?B:P;break b}if(ea)ia=mi[f[(f[T>>2]|0)+36>>2]&255](T)|0;else ia=jOa(b[da>>0]|0)|0;da=f[a>>2]|0;T=da+12|0;ea=f[T>>2]|0;ga=(ea|0)==(f[da+16>>2]|0);if((ia&255)<<24>>24==(b[((b[l>>0]|0)<0?f[B>>2]|0:B)>>0]|0)){if(ga)mi[f[(f[da>>2]|0)+40>>2]&255](da)|0;else{f[T>>2]=ea+1;jOa(b[ea>>0]|0)|0}T=b[l>>0]|0;ca=(T<<24>>24<0?f[e>>2]|0:T&255)>>>0>1?B:P;break b}if(ga)ja=mi[f[(f[da>>2]|0)+36>>2]&255](da)|0;else ja=jOa(b[ea>>0]|0)|0;if((ja&255)<<24>>24!=(b[((b[r>>0]|0)<0?f[C>>2]|0:C)>>0]|0)){R=103;break a}ea=f[a>>2]|0;da=ea+12|0;ga=f[da>>2]|0;if((ga|0)==(f[ea+16>>2]|0))mi[f[(f[ea>>2]|0)+40>>2]&255](ea)|0;else{f[da>>2]=ga+1;jOa(b[ga>>0]|0)|0}b[k>>0]=1;ga=b[r>>0]|0;ca=(ga<<24>>24<0?f[G>>2]|0:ga&255)>>>0>1?C:P}break}case 2:{if(!(O>>>0<2|Q)?!(H|(O|0)==2&(b[L>>0]|0)!=0):0){ca=0;break b}ga=b[i>>0]|0;da=ga<<24>>24<0;ea=f[A>>2]|0;T=da?ea:A;ha=T;c:do if((O|0)!=0?(h[w+(O+-1)>>0]|0)<2:0){Y=T+(da?f[I>>2]|0:ga&255)|0;_=ha;while(1){ka=_;if((ka|0)==(Y|0))break;la=b[ka>>0]|0;if(la<<24>>24<=-1)break;if(!(d[(f[g>>2]|0)+(la<<24>>24<<1)>>1]&8192))break;_=ka+1|0}Y=_-ha|0;ka=b[J>>0]|0;la=ka<<24>>24<0;ma=la?f[K>>2]|0:ka&255;if(Y>>>0<=ma>>>0){ka=(la?f[D>>2]|0:D)+ma|0;ma=ka+(0-Y)|0;Y=T;while(1){if((ma|0)==(ka|0)){na=X;oa=ga;pa=ea;qa=X;ra=_;break c}if((b[ma>>0]|0)!=(b[Y>>0]|0)){na=X;oa=ga;pa=ea;qa=X;ra=ha;break c}ma=ma+1|0;Y=Y+1|0}}else{na=X;oa=ga;pa=ea;qa=X;ra=ha}}else{na=X;oa=ga;pa=ea;qa=X;ra=ha}while(0);d:while(1){ha=oa<<24>>24<0;ea=(ha?pa:A)+(ha?f[I>>2]|0:oa&255)|0;ha=ra;if((ha|0)==(ea|0)){sa=ea;break}ea=f[a>>2]|0;do if(ea){ga=f[ea+12>>2]|0;if((ga|0)==(f[ea+16>>2]|0))ta=mi[f[(f[ea>>2]|0)+36>>2]&255](ea)|0;else ta=jOa(b[ga>>0]|0)|0;if(aPa(ta,iOa()|0)|0){f[a>>2]=0;ua=1;break}else{ua=(f[a>>2]|0)==0;break}}else ua=1;while(0);do if(qa){ea=f[qa+12>>2]|0;if((ea|0)==(f[qa+16>>2]|0))va=mi[f[(f[qa>>2]|0)+36>>2]&255](qa)|0;else va=jOa(b[ea>>0]|0)|0;if(!(aPa(va,iOa()|0)|0))if(ua^(na|0)==0){wa=na;xa=na;break}else{sa=ha;break d}else{f[c>>2]=0;ya=0;R=132;break}}else{ya=na;R=132}while(0);if((R|0)==132){R=0;if(ua){sa=ha;break}else{wa=ya;xa=0}}ea=f[a>>2]|0;ga=f[ea+12>>2]|0;if((ga|0)==(f[ea+16>>2]|0))za=mi[f[(f[ea>>2]|0)+36>>2]&255](ea)|0;else za=jOa(b[ga>>0]|0)|0;if((za&255)<<24>>24!=(b[ha>>0]|0)){sa=ha;break}ga=f[a>>2]|0;ea=ga+12|0;T=f[ea>>2]|0;if((T|0)==(f[ga+16>>2]|0))mi[f[(f[ga>>2]|0)+40>>2]&255](ga)|0;else{f[ea>>2]=T+1;jOa(b[T>>0]|0)|0}na=wa;oa=b[i>>0]|0;pa=f[A>>2]|0;qa=xa;ra=ha+1|0}if(H?(T=b[i>>0]|0,ea=T<<24>>24<0,(sa|0)!=((ea?f[A>>2]|0:A)+(ea?f[I>>2]|0:T&255)|0)):0){R=144;break a}else ca=P;break}case 4:{T=X;ea=X;ga=0;e:while(1){da=f[a>>2]|0;do if(da){Y=f[da+12>>2]|0;if((Y|0)==(f[da+16>>2]|0))Aa=mi[f[(f[da>>2]|0)+36>>2]&255](da)|0;else Aa=jOa(b[Y>>0]|0)|0;if(aPa(Aa,iOa()|0)|0){f[a>>2]=0;Ba=1;break}else{Ba=(f[a>>2]|0)==0;break}}else Ba=1;while(0);do if(ea){da=f[ea+12>>2]|0;if((da|0)==(f[ea+16>>2]|0))Ca=mi[f[(f[ea>>2]|0)+36>>2]&255](ea)|0;else Ca=jOa(b[da>>0]|0)|0;if(!(aPa(Ca,iOa()|0)|0))if(Ba^(T|0)==0){Da=T;Ea=T;break}else{Fa=T;break e}else{f[c>>2]=0;Ga=0;R=158;break}}else{Ga=T;R=158}while(0);if((R|0)==158){R=0;if(Ba){Fa=Ga;break}else{Da=Ga;Ea=0}}da=f[a>>2]|0;ha=f[da+12>>2]|0;if((ha|0)==(f[da+16>>2]|0))Ha=mi[f[(f[da>>2]|0)+36>>2]&255](da)|0;else Ha=jOa(b[ha>>0]|0)|0;ha=Ha&255;if(ha<<24>>24>-1?(d[(f[g>>2]|0)+(Ha<<24>>24<<1)>>1]&2048)!=0:0){da=f[n>>2]|0;if((da|0)==(f[q>>2]|0)){VUa(m,n,q);Ia=f[n>>2]|0}else Ia=da;f[n>>2]=Ia+1;b[Ia>>0]=ha;Ja=ga+1|0}else{da=b[M>>0]|0;if(!(ha<<24>>24==(b[y>>0]|0)&(ga|0?((da<<24>>24<0?f[N>>2]|0:da&255)|0)!=0:0))){Fa=Da;break}da=f[t>>2]|0;if((da|0)==(f[v>>2]|0)){WUa(s,t,v);Ka=f[t>>2]|0}else Ka=da;f[t>>2]=Ka+4;f[Ka>>2]=ga;Ja=0}da=f[a>>2]|0;ha=da+12|0;Y=f[ha>>2]|0;if((Y|0)==(f[da+16>>2]|0)){mi[f[(f[da>>2]|0)+40>>2]&255](da)|0;T=Da;ea=Ea;ga=Ja;continue}else{f[ha>>2]=Y+1;jOa(b[Y>>0]|0)|0;T=Da;ea=Ea;ga=Ja;continue}}ea=f[t>>2]|0;if(ga|0?(f[s>>2]|0)!=(ea|0):0){if((ea|0)==(f[v>>2]|0)){WUa(s,t,v);La=f[t>>2]|0}else La=ea;f[t>>2]=La+4;f[La>>2]=ga}f:do if((f[E>>2]|0)>0){ea=f[a>>2]|0;do if(ea){T=f[ea+12>>2]|0;if((T|0)==(f[ea+16>>2]|0))Ma=mi[f[(f[ea>>2]|0)+36>>2]&255](ea)|0;else Ma=jOa(b[T>>0]|0)|0;if(aPa(Ma,iOa()|0)|0){f[a>>2]=0;Na=1;break}else{Na=(f[a>>2]|0)==0;break}}else Na=1;while(0);do if(Fa){ea=f[Fa+12>>2]|0;if((ea|0)==(f[Fa+16>>2]|0))Oa=mi[f[(f[Fa>>2]|0)+36>>2]&255](Fa)|0;else Oa=jOa(b[ea>>0]|0)|0;if(!(aPa(Oa,iOa()|0)|0))if(Na){Pa=Fa;break}else{R=232;break a}else{f[c>>2]=0;R=193;break}}else R=193;while(0);if((R|0)==193){R=0;if(Na){R=232;break a}else Pa=0}ea=f[a>>2]|0;T=f[ea+12>>2]|0;if((T|0)==(f[ea+16>>2]|0))Qa=mi[f[(f[ea>>2]|0)+36>>2]&255](ea)|0;else Qa=jOa(b[T>>0]|0)|0;if((Qa&255)<<24>>24!=(b[x>>0]|0)){R=232;break a}T=f[a>>2]|0;ea=T+12|0;Y=f[ea>>2]|0;if((Y|0)==(f[T+16>>2]|0)){mi[f[(f[T>>2]|0)+40>>2]&255](T)|0;Ra=Pa;Sa=Pa}else{f[ea>>2]=Y+1;jOa(b[Y>>0]|0)|0;Ra=Pa;Sa=Pa}while(1){if((f[E>>2]|0)<=0)break f;Y=f[a>>2]|0;do if(Y){ea=f[Y+12>>2]|0;if((ea|0)==(f[Y+16>>2]|0))Ta=mi[f[(f[Y>>2]|0)+36>>2]&255](Y)|0;else Ta=jOa(b[ea>>0]|0)|0;if(aPa(Ta,iOa()|0)|0){f[a>>2]=0;Ua=1;break}else{Ua=(f[a>>2]|0)==0;break}}else Ua=1;while(0);do if(Sa){Y=f[Sa+12>>2]|0;if((Y|0)==(f[Sa+16>>2]|0))Va=mi[f[(f[Sa>>2]|0)+36>>2]&255](Sa)|0;else Va=jOa(b[Y>>0]|0)|0;if(!(aPa(Va,iOa()|0)|0))if(Ua^(Ra|0)==0){Wa=Ra;Xa=Ra;break}else{R=232;break a}else{f[c>>2]=0;Ya=0;R=216;break}}else{Ya=Ra;R=216}while(0);if((R|0)==216){R=0;if(Ua){R=232;break a}else{Wa=Ya;Xa=0}}Y=f[a>>2]|0;ea=f[Y+12>>2]|0;if((ea|0)==(f[Y+16>>2]|0))Za=mi[f[(f[Y>>2]|0)+36>>2]&255](Y)|0;else Za=jOa(b[ea>>0]|0)|0;if((Za&255)<<24>>24<=-1){R=232;break a}if(!(d[(f[g>>2]|0)+(Za<<24>>24<<1)>>1]&2048)){R=232;break a}if((f[n>>2]|0)==(f[q>>2]|0))VUa(m,n,q);ea=f[a>>2]|0;Y=f[ea+12>>2]|0;if((Y|0)==(f[ea+16>>2]|0))_a=mi[f[(f[ea>>2]|0)+36>>2]&255](ea)|0;else _a=jOa(b[Y>>0]|0)|0;Y=f[n>>2]|0;f[n>>2]=Y+1;b[Y>>0]=_a;f[E>>2]=(f[E>>2]|0)+-1;Y=f[a>>2]|0;ea=Y+12|0;T=f[ea>>2]|0;if((T|0)==(f[Y+16>>2]|0)){mi[f[(f[Y>>2]|0)+40>>2]&255](Y)|0;Ra=Wa;Sa=Xa;continue}else{f[ea>>2]=T+1;jOa(b[T>>0]|0)|0;Ra=Wa;Sa=Xa;continue}}}while(0);if((f[n>>2]|0)==(f[m>>2]|0)){R=232;break a}else ca=P;break}default:ca=P}while(0);g:do if((R|0)==46)while(1){R=0;S=f[a>>2]|0;do if(S){ga=f[S+12>>2]|0;if((ga|0)==(f[S+16>>2]|0))$a=mi[f[(f[S>>2]|0)+36>>2]&255](S)|0;else $a=jOa(b[ga>>0]|0)|0;if(aPa($a,iOa()|0)|0){f[a>>2]=0;ab=1;break}else{ab=(f[a>>2]|0)==0;break}}else ab=1;while(0);do if(ba){S=f[ba+12>>2]|0;if((S|0)==(f[ba+16>>2]|0))bb=mi[f[(f[ba>>2]|0)+36>>2]&255](ba)|0;else bb=jOa(b[S>>0]|0)|0;if(!(aPa(bb,iOa()|0)|0))if(ab^(aa|0)==0){cb=aa;db=aa;break}else{ca=P;break g}else{f[c>>2]=0;eb=0;R=59;break}}else{eb=aa;R=59}while(0);if((R|0)==59){R=0;if(ab){ca=P;break g}else{cb=eb;db=0}}S=f[a>>2]|0;ga=f[S+12>>2]|0;if((ga|0)==(f[S+16>>2]|0))fb=mi[f[(f[S>>2]|0)+36>>2]&255](S)|0;else fb=jOa(b[ga>>0]|0)|0;if((fb&255)<<24>>24<=-1){ca=P;break g}if(!(d[(f[g>>2]|0)+(fb<<24>>24<<1)>>1]&8192)){ca=P;break g}ga=f[a>>2]|0;S=ga+12|0;T=f[S>>2]|0;if((T|0)==(f[ga+16>>2]|0))gb=mi[f[(f[ga>>2]|0)+40>>2]&255](ga)|0;else{f[S>>2]=T+1;gb=jOa(b[T>>0]|0)|0}kZa(D,gb&255);aa=cb;ba=db;R=46}while(0);O=O+1|0;P=ca}h:do if((R|0)==44){f[j>>2]=f[j>>2]|4;hb=0}else if((R|0)==103){f[j>>2]=f[j>>2]|4;hb=0}else if((R|0)==144){f[j>>2]=f[j>>2]|4;hb=0}else if((R|0)==232){f[j>>2]=f[j>>2]|4;hb=0}else if((R|0)==234){i:do if(Q){ca=P+11|0;O=P+4|0;db=1;j:while(1){ba=b[ca>>0]|0;if(ba<<24>>24<0)ib=f[O>>2]|0;else ib=ba&255;if(db>>>0>=ib>>>0)break i;ba=f[a>>2]|0;do if(ba){cb=f[ba+12>>2]|0;if((cb|0)==(f[ba+16>>2]|0))jb=mi[f[(f[ba>>2]|0)+36>>2]&255](ba)|0;else jb=jOa(b[cb>>0]|0)|0;if(aPa(jb,iOa()|0)|0){f[a>>2]=0;kb=1;break}else{kb=(f[a>>2]|0)==0;break}}else kb=1;while(0);ba=f[c>>2]|0;do if(ba){cb=f[ba+12>>2]|0;if((cb|0)==(f[ba+16>>2]|0))lb=mi[f[(f[ba>>2]|0)+36>>2]&255](ba)|0;else lb=jOa(b[cb>>0]|0)|0;if(!(aPa(lb,iOa()|0)|0))if(kb)break;else break j;else{f[c>>2]=0;R=253;break}}else R=253;while(0);if((R|0)==253?(R=0,kb):0)break;ba=f[a>>2]|0;cb=f[ba+12>>2]|0;if((cb|0)==(f[ba+16>>2]|0))mb=mi[f[(f[ba>>2]|0)+36>>2]&255](ba)|0;else mb=jOa(b[cb>>0]|0)|0;if((b[ca>>0]|0)<0)nb=f[P>>2]|0;else nb=P;if((mb&255)<<24>>24!=(b[nb+db>>0]|0))break;cb=db+1|0;ba=f[a>>2]|0;aa=ba+12|0;gb=f[aa>>2]|0;if((gb|0)==(f[ba+16>>2]|0)){mi[f[(f[ba>>2]|0)+40>>2]&255](ba)|0;db=cb;continue}else{f[aa>>2]=gb+1;jOa(b[gb>>0]|0)|0;db=cb;continue}}f[j>>2]=f[j>>2]|4;hb=0;break h}while(0);db=f[s>>2]|0;ca=f[t>>2]|0;if((db|0)!=(ca|0)){f[F>>2]=0;QQa(z,db,ca,F);if(!(f[F>>2]|0)){hb=1;break}else{f[j>>2]=f[j>>2]|4;hb=0;break}}else hb=1}while(0);_Ya(D);_Ya(C);_Ya(B);_Ya(A);_Ya(z);z=f[s>>2]|0;f[s>>2]=0;if(z|0)ki[f[o>>2]&2047](z);u=p;return hb|0}function UUa(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;m=u;u=u+16|0;n=m+12|0;o=m;if(a){a=BQa(c,1976896)|0;Gh[f[(f[a>>2]|0)+44>>2]&511](n,a);p=f[n>>2]|0;b[d>>0]=p;b[d+1>>0]=p>>8;b[d+2>>0]=p>>16;b[d+3>>0]=p>>24;Gh[f[(f[a>>2]|0)+32>>2]&511](o,a);p=k+11|0;if((b[p>>0]|0)<0){q=f[k>>2]|0;b[n>>0]=0;ZOa(q,n);f[k+4>>2]=0;r=k}else{b[n>>0]=0;ZOa(k,n);b[p>>0]=0;r=k}dZa(k,0);f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}_Ya(o);Gh[f[(f[a>>2]|0)+28>>2]&511](o,a);r=j+11|0;if((b[r>>0]|0)<0){p=f[j>>2]|0;b[n>>0]=0;ZOa(p,n);f[j+4>>2]=0;s=j}else{b[n>>0]=0;ZOa(j,n);b[r>>0]=0;s=j}dZa(j,0);f[s>>2]=f[o>>2];f[s+4>>2]=f[o+4>>2];f[s+8>>2]=f[o+8>>2];s=0;while(1){if((s|0)==3)break;f[o+(s<<2)>>2]=0;s=s+1|0}_Ya(o);s=mi[f[(f[a>>2]|0)+12>>2]&255](a)|0;b[e>>0]=s;s=mi[f[(f[a>>2]|0)+16>>2]&255](a)|0;b[g>>0]=s;Gh[f[(f[a>>2]|0)+20>>2]&511](o,a);s=h+11|0;if((b[s>>0]|0)<0){r=f[h>>2]|0;b[n>>0]=0;ZOa(r,n);f[h+4>>2]=0;t=h}else{b[n>>0]=0;ZOa(h,n);b[s>>0]=0;t=h}dZa(h,0);f[t>>2]=f[o>>2];f[t+4>>2]=f[o+4>>2];f[t+8>>2]=f[o+8>>2];t=0;while(1){if((t|0)==3)break;f[o+(t<<2)>>2]=0;t=t+1|0}_Ya(o);Gh[f[(f[a>>2]|0)+24>>2]&511](o,a);t=i+11|0;if((b[t>>0]|0)<0){s=f[i>>2]|0;b[n>>0]=0;ZOa(s,n);f[i+4>>2]=0;v=i}else{b[n>>0]=0;ZOa(i,n);b[t>>0]=0;v=i}dZa(i,0);f[v>>2]=f[o>>2];f[v+4>>2]=f[o+4>>2];f[v+8>>2]=f[o+8>>2];v=0;while(1){if((v|0)==3)break;f[o+(v<<2)>>2]=0;v=v+1|0}_Ya(o);w=mi[f[(f[a>>2]|0)+36>>2]&255](a)|0}else{a=BQa(c,1976888)|0;Gh[f[(f[a>>2]|0)+44>>2]&511](n,a);c=f[n>>2]|0;b[d>>0]=c;b[d+1>>0]=c>>8;b[d+2>>0]=c>>16;b[d+3>>0]=c>>24;Gh[f[(f[a>>2]|0)+32>>2]&511](o,a);c=k+11|0;if((b[c>>0]|0)<0){d=f[k>>2]|0;b[n>>0]=0;ZOa(d,n);f[k+4>>2]=0;x=k}else{b[n>>0]=0;ZOa(k,n);b[c>>0]=0;x=k}dZa(k,0);f[x>>2]=f[o>>2];f[x+4>>2]=f[o+4>>2];f[x+8>>2]=f[o+8>>2];x=0;while(1){if((x|0)==3)break;f[o+(x<<2)>>2]=0;x=x+1|0}_Ya(o);Gh[f[(f[a>>2]|0)+28>>2]&511](o,a);x=j+11|0;if((b[x>>0]|0)<0){k=f[j>>2]|0;b[n>>0]=0;ZOa(k,n);f[j+4>>2]=0;y=j}else{b[n>>0]=0;ZOa(j,n);b[x>>0]=0;y=j}dZa(j,0);f[y>>2]=f[o>>2];f[y+4>>2]=f[o+4>>2];f[y+8>>2]=f[o+8>>2];y=0;while(1){if((y|0)==3)break;f[o+(y<<2)>>2]=0;y=y+1|0}_Ya(o);y=mi[f[(f[a>>2]|0)+12>>2]&255](a)|0;b[e>>0]=y;y=mi[f[(f[a>>2]|0)+16>>2]&255](a)|0;b[g>>0]=y;Gh[f[(f[a>>2]|0)+20>>2]&511](o,a);y=h+11|0;if((b[y>>0]|0)<0){g=f[h>>2]|0;b[n>>0]=0;ZOa(g,n);f[h+4>>2]=0;z=h}else{b[n>>0]=0;ZOa(h,n);b[y>>0]=0;z=h}dZa(h,0);f[z>>2]=f[o>>2];f[z+4>>2]=f[o+4>>2];f[z+8>>2]=f[o+8>>2];z=0;while(1){if((z|0)==3)break;f[o+(z<<2)>>2]=0;z=z+1|0}_Ya(o);Gh[f[(f[a>>2]|0)+24>>2]&511](o,a);z=i+11|0;if((b[z>>0]|0)<0){h=f[i>>2]|0;b[n>>0]=0;ZOa(h,n);f[i+4>>2]=0;A=i}else{b[n>>0]=0;ZOa(i,n);b[z>>0]=0;A=i}dZa(i,0);f[A>>2]=f[o>>2];f[A+4>>2]=f[o+4>>2];f[A+8>>2]=f[o+8>>2];A=0;while(1){if((A|0)==3)break;f[o+(A<<2)>>2]=0;A=A+1|0}_Ya(o);w=mi[f[(f[a>>2]|0)+36>>2]&255](a)|0}f[l>>2]=w;u=m;return}function VUa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+4|0;e=(f[d>>2]|0)!=1026;g=f[a>>2]|0;h=(f[c>>2]|0)-g|0;i=h>>>0<2147483647?h<<1:-1;h=(i|0)==0?1:i;i=(f[b>>2]|0)-g|0;j=fKa(e?g:0,h)|0;if(!j)RYa();if(!e){e=f[a>>2]|0;f[a>>2]=j;if(!e)k=j;else{ki[f[d>>2]&2047](e);k=f[a>>2]|0}}else{f[a>>2]=j;k=j}f[d>>2]=1027;f[b>>2]=k+i;f[c>>2]=(f[a>>2]|0)+h;return}function WUa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+4|0;e=(f[d>>2]|0)!=1026;g=f[a>>2]|0;h=(f[c>>2]|0)-g|0;i=h>>>0<2147483647?h<<1:-1;h=(i|0)==0?4:i;i=(f[b>>2]|0)-g>>2;j=fKa(e?g:0,h)|0;if(!j)RYa();if(!e){e=f[a>>2]|0;f[a>>2]=j;if(!e)k=j;else{ki[f[d>>2]&2047](e);k=f[a>>2]|0}}else{f[a>>2]=j;k=j}f[d>>2]=1027;f[b>>2]=k+(i<<2);f[c>>2]=(f[a>>2]|0)+(h>>>2<<2);return}function XUa(a){a=a|0;hQa(a);return}function YUa(a){a=a|0;hQa(a);PYa(a);return}function ZUa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;a=u;u=u+576|0;j=a+424|0;k=a;l=a+24|0;m=a+16|0;n=a+12|0;o=a+8|0;p=a+564|0;q=a+4|0;r=a+464|0;f[m>>2]=l;s=m+4|0;f[s>>2]=1026;bPa(o,g);t=BQa(o,1975208)|0;b[p>>0]=0;f[q>>2]=f[d>>2];v=f[g+4>>2]|0;f[j>>2]=f[q>>2];if($Ua(c,j,e,o,v,h,p,t,m,n,l+400|0)|0){Jg[f[(f[t>>2]|0)+48>>2]&63](t,371510,371520,j)|0;t=f[n>>2]|0;l=f[m>>2]|0;v=t-l|0;e=l;l=t;if((v|0)>392){t=dKa((v>>>2)+2|0)|0;if(!t)RYa();else{w=t;x=t}}else{w=0;x=r}if(!(b[p>>0]|0))y=x;else{b[x>>0]=45;y=x+1|0}x=j+40|0;p=j;t=l;l=y;y=e;while(1){if(y>>>0>=t>>>0)break;e=f[y>>2]|0;v=j;while(1){if((v|0)==(x|0)){z=x;break}if((f[v>>2]|0)==(e|0)){z=v;break}v=v+4|0}b[l>>0]=b[371510+(z-p>>2)>>0]|0;t=f[n>>2]|0;l=l+1|0;y=y+4|0}b[l>>0]=0;f[k>>2]=i;if((SMa(r,371411,k)|0)!=1)WTa(0);if(w|0)eKa(w)}w=f[c>>2]|0;do if(w){k=f[w+12>>2]|0;if((k|0)==(f[w+16>>2]|0))A=mi[f[(f[w>>2]|0)+36>>2]&255](w)|0;else A=BOa(f[k>>2]|0)|0;if(cPa(A,AOa()|0)|0){f[c>>2]=0;B=1;break}else{B=(f[c>>2]|0)==0;break}}else B=1;while(0);A=f[d>>2]|0;do if(A){w=f[A+12>>2]|0;if((w|0)==(f[A+16>>2]|0))C=mi[f[(f[A>>2]|0)+36>>2]&255](A)|0;else C=BOa(f[w>>2]|0)|0;if(!(cPa(C,AOa()|0)|0))if(B)break;else{D=34;break}else{f[d>>2]=0;D=32;break}}else D=32;while(0);if((D|0)==32?B:0)D=34;if((D|0)==34)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;CQa(o);o=f[m>>2]|0;f[m>>2]=0;if(o|0)ki[f[s>>2]&2047](o);u=a;return h|0}function _Ua(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;a=u;u=u+432|0;j=a+424|0;k=a+24|0;l=a+16|0;m=a+8|0;n=a;o=a+428|0;p=a+4|0;f[l>>2]=k;q=l+4|0;f[q>>2]=1026;bPa(n,g);r=BQa(n,1975208)|0;b[o>>0]=0;s=f[d>>2]|0;f[p>>2]=s;t=f[g+4>>2]|0;f[j>>2]=f[p>>2];p=s;if($Ua(c,j,e,n,t,h,o,r,l,m,k+400|0)|0){k=i+8+3|0;if((b[k>>0]|0)<0){t=f[i>>2]|0;f[j>>2]=0;nQa(t,j);f[i+4>>2]=0}else{f[j>>2]=0;nQa(i,j);b[k>>0]=0}if(b[o>>0]|0)yZa(i,$h[f[(f[r>>2]|0)+44>>2]&255](r,45)|0);o=$h[f[(f[r>>2]|0)+44>>2]&255](r,48)|0;r=f[m>>2]|0;m=r+-4|0;k=f[l>>2]|0;while(1){if(k>>>0>=m>>>0)break;if((f[k>>2]|0)!=(o|0))break;k=k+4|0}aVa(i,k,r)|0}r=f[c>>2]|0;do if(r){k=f[r+12>>2]|0;if((k|0)==(f[r+16>>2]|0))v=mi[f[(f[r>>2]|0)+36>>2]&255](r)|0;else v=BOa(f[k>>2]|0)|0;if(cPa(v,AOa()|0)|0){f[c>>2]=0;w=1;break}else{w=(f[c>>2]|0)==0;break}}else w=1;while(0);do if(s){v=f[p+12>>2]|0;if((v|0)==(f[p+16>>2]|0))x=mi[f[(f[s>>2]|0)+36>>2]&255](p)|0;else x=BOa(f[v>>2]|0)|0;if(!(cPa(x,AOa()|0)|0))if(w)break;else{y=27;break}else{f[d>>2]=0;y=25;break}}else y=25;while(0);if((y|0)==25?w:0)y=27;if((y|0)==27)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;CQa(n);n=f[l>>2]|0;f[l>>2]=0;if(n|0)ki[f[q>>2]&2047](n);u=a;return h|0}function $Ua(a,c,d,e,g,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0;o=u;u=u+512|0;p=o+96|0;q=o+104|0;r=o+88|0;s=o+80|0;t=o+76|0;v=o+504|0;w=o+72|0;x=o+68|0;y=o+56|0;z=o+44|0;A=o+32|0;B=o+20|0;C=o+8|0;D=o+4|0;E=o;f[p>>2]=n;f[r>>2]=q;n=r+4|0;f[n>>2]=1026;f[s>>2]=q;f[t>>2]=q+400;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[y+(q<<2)>>2]=0;q=q+1|0}f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[z+(q<<2)>>2]=0;q=q+1|0}f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[A+(q<<2)>>2]=0;q=q+1|0}f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[B+(q<<2)>>2]=0;q=q+1|0}f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[C+(q<<2)>>2]=0;q=q+1|0}cVa(d,e,v,w,x,y,z,A,B,D);f[m>>2]=f[l>>2];e=A+8+3|0;d=A+4|0;q=B+8+3|0;F=B+4|0;G=(g&512|0)!=0;g=z+8+3|0;H=z+4|0;I=C+8+3|0;J=C+4|0;K=v+3|0;L=y+11|0;M=y+4|0;N=0;O=0;a:while(1){P=(O|0)!=0;if(N>>>0>=4){Q=229;break}R=f[a>>2]|0;do if(R){S=f[R+12>>2]|0;if((S|0)==(f[R+16>>2]|0))T=mi[f[(f[R>>2]|0)+36>>2]&255](R)|0;else T=BOa(f[S>>2]|0)|0;if(cPa(T,AOa()|0)|0){f[a>>2]=0;U=1;break}else{U=(f[a>>2]|0)==0;break}}else U=1;while(0);R=f[c>>2]|0;do if(R){S=f[R+12>>2]|0;if((S|0)==(f[R+16>>2]|0))V=mi[f[(f[R>>2]|0)+36>>2]&255](R)|0;else V=BOa(f[S>>2]|0)|0;if(!(cPa(V,AOa()|0)|0))if(U){W=R;break}else{Q=229;break a}else{f[c>>2]=0;Q=31;break}}else Q=31;while(0);if((Q|0)==31){Q=0;if(U){Q=229;break}else W=0}R=(N|0)!=3;b:do switch(b[v+N>>0]|0){case 1:{if(R){S=f[a>>2]|0;X=f[S+12>>2]|0;if((X|0)==(f[S+16>>2]|0))Y=mi[f[(f[S>>2]|0)+36>>2]&255](S)|0;else Y=BOa(f[X>>2]|0)|0;if(!(ui[f[(f[k>>2]|0)+12>>2]&127](k,8192,Y)|0)){Q=43;break a}X=f[a>>2]|0;S=X+12|0;Z=f[S>>2]|0;if((Z|0)==(f[X+16>>2]|0))_=mi[f[(f[X>>2]|0)+40>>2]&255](X)|0;else{f[S>>2]=Z+4;_=BOa(f[Z>>2]|0)|0}yZa(C,_);$=W;aa=W;Q=45}else ba=O;break}case 0:{if(R){$=W;aa=W;Q=45}else ba=O;break}case 3:{Z=b[e>>0]|0;S=Z<<24>>24<0?f[d>>2]|0:Z&255;Z=b[q>>0]|0;X=Z<<24>>24<0?f[F>>2]|0:Z&255;if((S|0)==(0-X|0))ba=O;else{Z=(S|0)==0;S=f[a>>2]|0;ca=f[S+12>>2]|0;da=(ca|0)==(f[S+16>>2]|0);if(Z|(X|0)==0){if(da)ea=mi[f[(f[S>>2]|0)+36>>2]&255](S)|0;else ea=BOa(f[ca>>2]|0)|0;if(Z){if((ea|0)!=(f[((b[q>>0]|0)<0?f[B>>2]|0:B)>>2]|0)){ba=O;break b}Z=f[a>>2]|0;X=Z+12|0;fa=f[X>>2]|0;if((fa|0)==(f[Z+16>>2]|0))mi[f[(f[Z>>2]|0)+40>>2]&255](Z)|0;else{f[X>>2]=fa+4;BOa(f[fa>>2]|0)|0}b[j>>0]=1;fa=b[q>>0]|0;ba=(fa<<24>>24<0?f[F>>2]|0:fa&255)>>>0>1?B:O;break b}if((ea|0)!=(f[((b[e>>0]|0)<0?f[A>>2]|0:A)>>2]|0)){b[j>>0]=1;ba=O;break b}fa=f[a>>2]|0;X=fa+12|0;Z=f[X>>2]|0;if((Z|0)==(f[fa+16>>2]|0))mi[f[(f[fa>>2]|0)+40>>2]&255](fa)|0;else{f[X>>2]=Z+4;BOa(f[Z>>2]|0)|0}Z=b[e>>0]|0;ba=(Z<<24>>24<0?f[d>>2]|0:Z&255)>>>0>1?A:O;break b}if(da)ga=mi[f[(f[S>>2]|0)+36>>2]&255](S)|0;else ga=BOa(f[ca>>2]|0)|0;ca=f[a>>2]|0;S=ca+12|0;da=f[S>>2]|0;Z=(da|0)==(f[ca+16>>2]|0);if((ga|0)==(f[((b[e>>0]|0)<0?f[A>>2]|0:A)>>2]|0)){if(Z)mi[f[(f[ca>>2]|0)+40>>2]&255](ca)|0;else{f[S>>2]=da+4;BOa(f[da>>2]|0)|0}S=b[e>>0]|0;ba=(S<<24>>24<0?f[d>>2]|0:S&255)>>>0>1?A:O;break b}if(Z)ha=mi[f[(f[ca>>2]|0)+36>>2]&255](ca)|0;else ha=BOa(f[da>>2]|0)|0;if((ha|0)!=(f[((b[q>>0]|0)<0?f[B>>2]|0:B)>>2]|0)){Q=101;break a}da=f[a>>2]|0;ca=da+12|0;Z=f[ca>>2]|0;if((Z|0)==(f[da+16>>2]|0))mi[f[(f[da>>2]|0)+40>>2]&255](da)|0;else{f[ca>>2]=Z+4;BOa(f[Z>>2]|0)|0}b[j>>0]=1;Z=b[q>>0]|0;ba=(Z<<24>>24<0?f[F>>2]|0:Z&255)>>>0>1?B:O}break}case 2:{if(!(N>>>0<2|P)?!(G|(N|0)==2&(b[K>>0]|0)!=0):0){ba=0;break b}Z=b[g>>0]|0;ca=f[z>>2]|0;da=Z<<24>>24<0?ca:z;c:do if((N|0)!=0?(h[v+(N+-1)>>0]|0)<2:0){S=Z;X=ca;fa=da;while(1){ia=S<<24>>24<0;ja=fa;if((ja|0)==((ia?X:z)+((ia?f[H>>2]|0:S&255)<<2)|0)){ka=S;la=X;break}if(!(ui[f[(f[k>>2]|0)+12>>2]&127](k,8192,f[ja>>2]|0)|0)){Q=108;break}S=b[g>>0]|0;X=f[z>>2]|0;fa=ja+4|0}if((Q|0)==108){Q=0;ka=b[g>>0]|0;la=f[z>>2]|0}X=ka<<24>>24<0?la:z;S=X;ja=fa-S>>2;ia=b[I>>0]|0;ma=ia<<24>>24<0;na=ma?f[J>>2]|0:ia&255;if(ja>>>0>na>>>0){oa=W;pa=ka;qa=la;ra=W;sa=S}else{ia=(ma?f[C>>2]|0:C)+(na<<2)|0;na=ia+(0-ja<<2)|0;ja=X;while(1){if((na|0)==(ia|0)){oa=W;pa=ka;qa=la;ra=W;sa=fa;break c}if((f[na>>2]|0)!=(f[ja>>2]|0)){oa=W;pa=ka;qa=la;ra=W;sa=S;break c}na=na+4|0;ja=ja+4|0}}}else{oa=W;pa=Z;qa=ca;ra=W;sa=da}while(0);d:while(1){da=pa<<24>>24<0;ca=(da?qa:z)+((da?f[H>>2]|0:pa&255)<<2)|0;da=sa;if((da|0)==(ca|0)){ta=ca;break}ca=f[a>>2]|0;do if(ca){Z=f[ca+12>>2]|0;if((Z|0)==(f[ca+16>>2]|0))ua=mi[f[(f[ca>>2]|0)+36>>2]&255](ca)|0;else ua=BOa(f[Z>>2]|0)|0;if(cPa(ua,AOa()|0)|0){f[a>>2]=0;va=1;break}else{va=(f[a>>2]|0)==0;break}}else va=1;while(0);do if(ra){ca=f[ra+12>>2]|0;if((ca|0)==(f[ra+16>>2]|0))wa=mi[f[(f[ra>>2]|0)+36>>2]&255](ra)|0;else wa=BOa(f[ca>>2]|0)|0;if(!(cPa(wa,AOa()|0)|0))if(va^(oa|0)==0){xa=oa;ya=oa;break}else{ta=da;break d}else{f[c>>2]=0;za=0;Q=129;break}}else{za=oa;Q=129}while(0);if((Q|0)==129){Q=0;if(va){ta=da;break}else{xa=za;ya=0}}ca=f[a>>2]|0;Z=f[ca+12>>2]|0;if((Z|0)==(f[ca+16>>2]|0))Aa=mi[f[(f[ca>>2]|0)+36>>2]&255](ca)|0;else Aa=BOa(f[Z>>2]|0)|0;if((Aa|0)!=(f[da>>2]|0)){ta=da;break}Z=f[a>>2]|0;ca=Z+12|0;ja=f[ca>>2]|0;if((ja|0)==(f[Z+16>>2]|0))mi[f[(f[Z>>2]|0)+40>>2]&255](Z)|0;else{f[ca>>2]=ja+4;BOa(f[ja>>2]|0)|0}oa=xa;pa=b[g>>0]|0;qa=f[z>>2]|0;ra=ya;sa=da+4|0}if(G?(ja=b[g>>0]|0,ca=ja<<24>>24<0,(ta|0)!=((ca?f[z>>2]|0:z)+((ca?f[H>>2]|0:ja&255)<<2)|0)):0){Q=141;break a}else ba=O;break}case 4:{ja=W;ca=W;Z=0;e:while(1){na=f[a>>2]|0;do if(na){S=f[na+12>>2]|0;if((S|0)==(f[na+16>>2]|0))Ba=mi[f[(f[na>>2]|0)+36>>2]&255](na)|0;else Ba=BOa(f[S>>2]|0)|0;if(cPa(Ba,AOa()|0)|0){f[a>>2]=0;Ca=1;break}else{Ca=(f[a>>2]|0)==0;break}}else Ca=1;while(0);do if(ca){na=f[ca+12>>2]|0;if((na|0)==(f[ca+16>>2]|0))Da=mi[f[(f[ca>>2]|0)+36>>2]&255](ca)|0;else Da=BOa(f[na>>2]|0)|0;if(!(cPa(Da,AOa()|0)|0))if(Ca^(ja|0)==0){Ea=ja;Fa=ja;break}else{Ga=ja;break e}else{f[c>>2]=0;Ha=0;Q=155;break}}else{Ha=ja;Q=155}while(0);if((Q|0)==155){Q=0;if(Ca){Ga=Ha;break}else{Ea=Ha;Fa=0}}na=f[a>>2]|0;da=f[na+12>>2]|0;if((da|0)==(f[na+16>>2]|0))Ia=mi[f[(f[na>>2]|0)+36>>2]&255](na)|0;else Ia=BOa(f[da>>2]|0)|0;if(ui[f[(f[k>>2]|0)+12>>2]&127](k,2048,Ia)|0){da=f[m>>2]|0;if((da|0)==(f[p>>2]|0)){dVa(l,m,p);Ja=f[m>>2]|0}else Ja=da;f[m>>2]=Ja+4;f[Ja>>2]=Ia;Ka=Z+1|0}else{da=b[L>>0]|0;if(!((Ia|0)==(f[x>>2]|0)&(Z|0?((da<<24>>24<0?f[M>>2]|0:da&255)|0)!=0:0))){Ga=Ea;break}da=f[s>>2]|0;if((da|0)==(f[t>>2]|0)){WUa(r,s,t);La=f[s>>2]|0}else La=da;f[s>>2]=La+4;f[La>>2]=Z;Ka=0}da=f[a>>2]|0;na=da+12|0;S=f[na>>2]|0;if((S|0)==(f[da+16>>2]|0)){mi[f[(f[da>>2]|0)+40>>2]&255](da)|0;ja=Ea;ca=Fa;Z=Ka;continue}else{f[na>>2]=S+4;BOa(f[S>>2]|0)|0;ja=Ea;ca=Fa;Z=Ka;continue}}ca=f[s>>2]|0;if(Z|0?(f[r>>2]|0)!=(ca|0):0){if((ca|0)==(f[t>>2]|0)){WUa(r,s,t);Ma=f[s>>2]|0}else Ma=ca;f[s>>2]=Ma+4;f[Ma>>2]=Z}f:do if((f[D>>2]|0)>0){ca=f[a>>2]|0;do if(ca){ja=f[ca+12>>2]|0;if((ja|0)==(f[ca+16>>2]|0))Na=mi[f[(f[ca>>2]|0)+36>>2]&255](ca)|0;else Na=BOa(f[ja>>2]|0)|0;if(cPa(Na,AOa()|0)|0){f[a>>2]=0;Oa=1;break}else{Oa=(f[a>>2]|0)==0;break}}else Oa=1;while(0);do if(Ga){ca=f[Ga+12>>2]|0;if((ca|0)==(f[Ga+16>>2]|0))Pa=mi[f[(f[Ga>>2]|0)+36>>2]&255](Ga)|0;else Pa=BOa(f[ca>>2]|0)|0;if(!(cPa(Pa,AOa()|0)|0))if(Oa){Qa=Ga;break}else{Q=227;break a}else{f[c>>2]=0;Q=189;break}}else Q=189;while(0);if((Q|0)==189){Q=0;if(Oa){Q=227;break a}else Qa=0}ca=f[a>>2]|0;ja=f[ca+12>>2]|0;if((ja|0)==(f[ca+16>>2]|0))Ra=mi[f[(f[ca>>2]|0)+36>>2]&255](ca)|0;else Ra=BOa(f[ja>>2]|0)|0;if((Ra|0)!=(f[w>>2]|0)){Q=227;break a}ja=f[a>>2]|0;ca=ja+12|0;S=f[ca>>2]|0;if((S|0)==(f[ja+16>>2]|0)){mi[f[(f[ja>>2]|0)+40>>2]&255](ja)|0;Sa=Qa;Ta=Qa}else{f[ca>>2]=S+4;BOa(f[S>>2]|0)|0;Sa=Qa;Ta=Qa}while(1){if((f[D>>2]|0)<=0)break f;S=f[a>>2]|0;do if(S){ca=f[S+12>>2]|0;if((ca|0)==(f[S+16>>2]|0))Ua=mi[f[(f[S>>2]|0)+36>>2]&255](S)|0;else Ua=BOa(f[ca>>2]|0)|0;if(cPa(Ua,AOa()|0)|0){f[a>>2]=0;Va=1;break}else{Va=(f[a>>2]|0)==0;break}}else Va=1;while(0);do if(Ta){S=f[Ta+12>>2]|0;if((S|0)==(f[Ta+16>>2]|0))Wa=mi[f[(f[Ta>>2]|0)+36>>2]&255](Ta)|0;else Wa=BOa(f[S>>2]|0)|0;if(!(cPa(Wa,AOa()|0)|0))if(Va^(Sa|0)==0){Xa=Sa;Ya=Sa;break}else{Q=227;break a}else{f[c>>2]=0;Za=0;Q=212;break}}else{Za=Sa;Q=212}while(0);if((Q|0)==212){Q=0;if(Va){Q=227;break a}else{Xa=Za;Ya=0}}S=f[a>>2]|0;ca=f[S+12>>2]|0;if((ca|0)==(f[S+16>>2]|0))_a=mi[f[(f[S>>2]|0)+36>>2]&255](S)|0;else _a=BOa(f[ca>>2]|0)|0;if(!(ui[f[(f[k>>2]|0)+12>>2]&127](k,2048,_a)|0)){Q=227;break a}if((f[m>>2]|0)==(f[p>>2]|0))dVa(l,m,p);ca=f[a>>2]|0;S=f[ca+12>>2]|0;if((S|0)==(f[ca+16>>2]|0))$a=mi[f[(f[ca>>2]|0)+36>>2]&255](ca)|0;else $a=BOa(f[S>>2]|0)|0;S=f[m>>2]|0;f[m>>2]=S+4;f[S>>2]=$a;f[D>>2]=(f[D>>2]|0)+-1;S=f[a>>2]|0;ca=S+12|0;ja=f[ca>>2]|0;if((ja|0)==(f[S+16>>2]|0)){mi[f[(f[S>>2]|0)+40>>2]&255](S)|0;Sa=Xa;Ta=Ya;continue}else{f[ca>>2]=ja+4;BOa(f[ja>>2]|0)|0;Sa=Xa;Ta=Ya;continue}}}while(0);if((f[m>>2]|0)==(f[l>>2]|0)){Q=227;break a}else ba=O;break}default:ba=O}while(0);g:do if((Q|0)==45)while(1){Q=0;R=f[a>>2]|0;do if(R){Z=f[R+12>>2]|0;if((Z|0)==(f[R+16>>2]|0))ab=mi[f[(f[R>>2]|0)+36>>2]&255](R)|0;else ab=BOa(f[Z>>2]|0)|0;if(cPa(ab,AOa()|0)|0){f[a>>2]=0;bb=1;break}else{bb=(f[a>>2]|0)==0;break}}else bb=1;while(0);do if(aa){R=f[aa+12>>2]|0;if((R|0)==(f[aa+16>>2]|0))cb=mi[f[(f[aa>>2]|0)+36>>2]&255](aa)|0;else cb=BOa(f[R>>2]|0)|0;if(!(cPa(cb,AOa()|0)|0))if(bb^($|0)==0){db=$;eb=$;break}else{ba=O;break g}else{f[c>>2]=0;fb=0;Q=58;break}}else{fb=$;Q=58}while(0);if((Q|0)==58){Q=0;if(bb){ba=O;break g}else{db=fb;eb=0}}R=f[a>>2]|0;Z=f[R+12>>2]|0;if((Z|0)==(f[R+16>>2]|0))gb=mi[f[(f[R>>2]|0)+36>>2]&255](R)|0;else gb=BOa(f[Z>>2]|0)|0;if(!(ui[f[(f[k>>2]|0)+12>>2]&127](k,8192,gb)|0)){ba=O;break g}Z=f[a>>2]|0;R=Z+12|0;ja=f[R>>2]|0;if((ja|0)==(f[Z+16>>2]|0))hb=mi[f[(f[Z>>2]|0)+40>>2]&255](Z)|0;else{f[R>>2]=ja+4;hb=BOa(f[ja>>2]|0)|0}yZa(C,hb);$=db;aa=eb;Q=45}while(0);N=N+1|0;O=ba}h:do if((Q|0)==43){f[i>>2]=f[i>>2]|4;ib=0}else if((Q|0)==101){f[i>>2]=f[i>>2]|4;ib=0}else if((Q|0)==141){f[i>>2]=f[i>>2]|4;ib=0}else if((Q|0)==227){f[i>>2]=f[i>>2]|4;ib=0}else if((Q|0)==229){i:do if(P){ba=O+8+3|0;N=O+4|0;eb=1;j:while(1){aa=b[ba>>0]|0;if(aa<<24>>24<0)jb=f[N>>2]|0;else jb=aa&255;if(eb>>>0>=jb>>>0)break i;aa=f[a>>2]|0;do if(aa){db=f[aa+12>>2]|0;if((db|0)==(f[aa+16>>2]|0))kb=mi[f[(f[aa>>2]|0)+36>>2]&255](aa)|0;else kb=BOa(f[db>>2]|0)|0;if(cPa(kb,AOa()|0)|0){f[a>>2]=0;lb=1;break}else{lb=(f[a>>2]|0)==0;break}}else lb=1;while(0);aa=f[c>>2]|0;do if(aa){db=f[aa+12>>2]|0;if((db|0)==(f[aa+16>>2]|0))mb=mi[f[(f[aa>>2]|0)+36>>2]&255](aa)|0;else mb=BOa(f[db>>2]|0)|0;if(!(cPa(mb,AOa()|0)|0))if(lb)break;else break j;else{f[c>>2]=0;Q=248;break}}else Q=248;while(0);if((Q|0)==248?(Q=0,lb):0)break;aa=f[a>>2]|0;db=f[aa+12>>2]|0;if((db|0)==(f[aa+16>>2]|0))nb=mi[f[(f[aa>>2]|0)+36>>2]&255](aa)|0;else nb=BOa(f[db>>2]|0)|0;if((b[ba>>0]|0)<0)ob=f[O>>2]|0;else ob=O;if((nb|0)!=(f[ob+(eb<<2)>>2]|0))break;db=eb+1|0;aa=f[a>>2]|0;$=aa+12|0;hb=f[$>>2]|0;if((hb|0)==(f[aa+16>>2]|0)){mi[f[(f[aa>>2]|0)+40>>2]&255](aa)|0;eb=db;continue}else{f[$>>2]=hb+4;BOa(f[hb>>2]|0)|0;eb=db;continue}}f[i>>2]=f[i>>2]|4;ib=0;break h}while(0);eb=f[r>>2]|0;ba=f[s>>2]|0;if((eb|0)!=(ba|0)){f[E>>2]=0;QQa(y,eb,ba,E);if(!(f[E>>2]|0)){ib=1;break}else{f[i>>2]=f[i>>2]|4;ib=0;break}}else ib=1}while(0);qZa(C);qZa(B);qZa(A);qZa(z);_Ya(y);y=f[r>>2]|0;f[r>>2]=0;if(y|0)ki[f[n>>2]&2047](y);u=o;return ib|0}function aVa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e+12|0;h=e;i=a+8|0;j=i+3|0;k=b[j>>0]|0;l=k<<24>>24<0;if(l){m=(f[i>>2]&2147483647)+-1|0;n=f[a+4>>2]|0}else{m=1;n=k&255}i=d-c>>2;do if(i|0){if(l){o=f[a>>2]|0;p=o;q=o;r=f[a+4>>2]|0}else{p=a;q=a;r=k&255}if(bVa(c,p,q+(r<<2)|0)|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(i>>>0>1073741807)WYa(h);do if(i>>>0>=2){o=i+4&-4;if(o>>>0>1073741823)We();else{s=NYa(o<<2)|0;f[h>>2]=s;f[h+8>>2]=o|-2147483648;f[h+4>>2]=i;t=c;v=s;break}}else{b[h+8+3>>0]=i;t=c;v=h}while(0);while(1){if((t|0)==(d|0))break;nQa(v,t);t=t+4|0;v=v+4|0}f[g>>2]=0;nQa(v,g);s=b[h+8+3>>0]|0;o=s<<24>>24<0;xZa(a,o?f[h>>2]|0:h,o?f[h+4>>2]|0:s&255)|0;qZa(h);break}s=n+i|0;if((m-n|0)>>>0<i>>>0)wZa(a,m,s-m|0,n,n,0,0);if((b[j>>0]|0)<0)w=f[a>>2]|0;else w=a;o=c;x=w+(n<<2)|0;while(1){if((o|0)==(d|0))break;nQa(x,o);o=o+4|0;x=x+4|0}f[g>>2]=0;nQa(x,g);if((b[j>>0]|0)<0){f[a+4>>2]=s;break}else{b[j>>0]=s;break}}while(0);u=e;return a|0}function bVa(a,b,c){a=a|0;b=b|0;c=c|0;return b>>>0<=a>>>0&a>>>0<c>>>0|0}function cVa(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;m=u;u=u+16|0;n=m+12|0;o=m;if(a){a=BQa(c,1976912)|0;Gh[f[(f[a>>2]|0)+44>>2]&511](n,a);p=f[n>>2]|0;b[d>>0]=p;b[d+1>>0]=p>>8;b[d+2>>0]=p>>16;b[d+3>>0]=p>>24;Gh[f[(f[a>>2]|0)+32>>2]&511](o,a);p=k+8+3|0;if((b[p>>0]|0)<0){q=f[k>>2]|0;f[n>>2]=0;nQa(q,n);f[k+4>>2]=0}else{f[n>>2]=0;nQa(k,n);b[p>>0]=0}uZa(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];p=0;while(1){if((p|0)==3)break;f[o+(p<<2)>>2]=0;p=p+1|0}qZa(o);Gh[f[(f[a>>2]|0)+28>>2]&511](o,a);p=j+8+3|0;if((b[p>>0]|0)<0){q=f[j>>2]|0;f[n>>2]=0;nQa(q,n);f[j+4>>2]=0}else{f[n>>2]=0;nQa(j,n);b[p>>0]=0}uZa(j,0);f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[j+8>>2]=f[o+8>>2];p=0;while(1){if((p|0)==3)break;f[o+(p<<2)>>2]=0;p=p+1|0}qZa(o);p=mi[f[(f[a>>2]|0)+12>>2]&255](a)|0;f[e>>2]=p;p=mi[f[(f[a>>2]|0)+16>>2]&255](a)|0;f[g>>2]=p;Gh[f[(f[a>>2]|0)+20>>2]&511](o,a);p=h+11|0;if((b[p>>0]|0)<0){q=f[h>>2]|0;b[n>>0]=0;ZOa(q,n);f[h+4>>2]=0;r=h}else{b[n>>0]=0;ZOa(h,n);b[p>>0]=0;r=h}dZa(h,0);f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}_Ya(o);Gh[f[(f[a>>2]|0)+24>>2]&511](o,a);r=i+8+3|0;if((b[r>>0]|0)<0){p=f[i>>2]|0;f[n>>2]=0;nQa(p,n);f[i+4>>2]=0}else{f[n>>2]=0;nQa(i,n);b[r>>0]=0}uZa(i,0);f[i>>2]=f[o>>2];f[i+4>>2]=f[o+4>>2];f[i+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}qZa(o);s=mi[f[(f[a>>2]|0)+36>>2]&255](a)|0}else{a=BQa(c,1976904)|0;Gh[f[(f[a>>2]|0)+44>>2]&511](n,a);c=f[n>>2]|0;b[d>>0]=c;b[d+1>>0]=c>>8;b[d+2>>0]=c>>16;b[d+3>>0]=c>>24;Gh[f[(f[a>>2]|0)+32>>2]&511](o,a);c=k+8+3|0;if((b[c>>0]|0)<0){d=f[k>>2]|0;f[n>>2]=0;nQa(d,n);f[k+4>>2]=0}else{f[n>>2]=0;nQa(k,n);b[c>>0]=0}uZa(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];k=0;while(1){if((k|0)==3)break;f[o+(k<<2)>>2]=0;k=k+1|0}qZa(o);Gh[f[(f[a>>2]|0)+28>>2]&511](o,a);k=j+8+3|0;if((b[k>>0]|0)<0){c=f[j>>2]|0;f[n>>2]=0;nQa(c,n);f[j+4>>2]=0}else{f[n>>2]=0;nQa(j,n);b[k>>0]=0}uZa(j,0);f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[j+8>>2]=f[o+8>>2];j=0;while(1){if((j|0)==3)break;f[o+(j<<2)>>2]=0;j=j+1|0}qZa(o);j=mi[f[(f[a>>2]|0)+12>>2]&255](a)|0;f[e>>2]=j;j=mi[f[(f[a>>2]|0)+16>>2]&255](a)|0;f[g>>2]=j;Gh[f[(f[a>>2]|0)+20>>2]&511](o,a);j=h+11|0;if((b[j>>0]|0)<0){g=f[h>>2]|0;b[n>>0]=0;ZOa(g,n);f[h+4>>2]=0;t=h}else{b[n>>0]=0;ZOa(h,n);b[j>>0]=0;t=h}dZa(h,0);f[t>>2]=f[o>>2];f[t+4>>2]=f[o+4>>2];f[t+8>>2]=f[o+8>>2];t=0;while(1){if((t|0)==3)break;f[o+(t<<2)>>2]=0;t=t+1|0}_Ya(o);Gh[f[(f[a>>2]|0)+24>>2]&511](o,a);t=i+8+3|0;if((b[t>>0]|0)<0){h=f[i>>2]|0;f[n>>2]=0;nQa(h,n);f[i+4>>2]=0}else{f[n>>2]=0;nQa(i,n);b[t>>0]=0}uZa(i,0);f[i>>2]=f[o>>2];f[i+4>>2]=f[o+4>>2];f[i+8>>2]=f[o+8>>2];i=0;while(1){if((i|0)==3)break;f[o+(i<<2)>>2]=0;i=i+1|0}qZa(o);s=mi[f[(f[a>>2]|0)+36>>2]&255](a)|0}f[l>>2]=s;u=m;return}function dVa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+4|0;e=(f[d>>2]|0)!=1026;g=f[a>>2]|0;h=(f[c>>2]|0)-g|0;i=h>>>0<2147483647?h<<1:-1;h=(i|0)==0?4:i;i=(f[b>>2]|0)-g>>2;j=fKa(e?g:0,h)|0;if(!j)RYa();if(!e){e=f[a>>2]|0;f[a>>2]=j;if(!e)k=j;else{ki[f[d>>2]&2047](e);k=f[a>>2]|0}}else{f[a>>2]=j;k=j}f[d>>2]=1027;f[b>>2]=k+(i<<2);f[c>>2]=(f[a>>2]|0)+(h>>>2<<2);return}function eVa(a){a=a|0;hQa(a);return}function fVa(a){a=a|0;hQa(a);PYa(a);return}function gVa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;a=u;u=u+384|0;i=a+8|0;j=a;k=a+284|0;l=a+72|0;m=a+184|0;n=a+68|0;o=a+180|0;q=a+177|0;r=a+176|0;s=a+56|0;t=a+44|0;v=a+32|0;w=a+28|0;x=a+76|0;y=a+24|0;z=a+16|0;A=a+20|0;f[l>>2]=k;p[i>>3]=h;B=pLa(k,100,371616,i)|0;if(B>>>0>99){k=EQa()|0;p[j>>3]=h;C=WRa(l,k,371616,j)|0;j=f[l>>2]|0;if(!j)RYa();k=dKa(C)|0;if(!k)RYa();else{D=k;E=k;F=j;G=C}}else{D=m;E=0;F=0;G=B}bPa(n,e);B=BQa(n,1975176)|0;m=f[l>>2]|0;Jg[f[(f[B>>2]|0)+32>>2]&63](B,m,m+G|0,D)|0;if(!G)H=0;else H=(b[f[l>>2]>>0]|0)==45;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[s+(l<<2)>>2]=0;l=l+1|0}f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[t+(l<<2)>>2]=0;l=l+1|0}f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[v+(l<<2)>>2]=0;l=l+1|0}iVa(d,H,n,o,q,r,s,t,v,w);d=f[w>>2]|0;if((G|0)>(d|0)){w=b[v+11>>0]|0;l=b[t+11>>0]|0;I=1;J=l<<24>>24<0?f[t+4>>2]|0:l&255;K=(w<<24>>24<0?f[v+4>>2]|0:w&255)+(G-d<<1)|0}else{w=b[v+11>>0]|0;l=b[t+11>>0]|0;I=2;J=w<<24>>24<0?f[v+4>>2]|0:w&255;K=l<<24>>24<0?f[t+4>>2]|0:l&255}l=J+d+K+I|0;if(l>>>0>100){I=dKa(l)|0;if(!I)RYa();else{L=I;M=I}}else{L=0;M=x}jVa(M,y,z,f[e+4>>2]|0,D,D+G|0,B,H,o,b[q>>0]|0,b[r>>0]|0,s,t,v,d);f[A>>2]=f[c>>2];c=f[y>>2]|0;y=f[z>>2]|0;f[i>>2]=f[A>>2];A=KU(i,M,c,y,e,g)|0;if(L|0)eKa(L);_Ya(v);_Ya(t);_Ya(s);CQa(n);if(E|0)eKa(E);if(F|0)eKa(F);u=a;return A|0}function hVa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;a=u;u=u+176|0;i=a+56|0;j=a+52|0;k=a+164|0;l=a+161|0;m=a+160|0;n=a+40|0;o=a+28|0;p=a+16|0;q=a+12|0;r=a+60|0;s=a+8|0;t=a+4|0;v=a;bPa(j,e);w=BQa(j,1975176)|0;x=h+11|0;y=b[x>>0]|0;z=y<<24>>24<0;A=h+4|0;if(!((z?f[A>>2]|0:y&255)|0))B=0;else{y=b[(z?f[h>>2]|0:h)>>0]|0;B=y<<24>>24==($h[f[(f[w>>2]|0)+28>>2]&255](w,45)|0)<<24>>24};f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[n+(y<<2)>>2]=0;y=y+1|0}f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[o+(y<<2)>>2]=0;y=y+1|0}f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[p+(y<<2)>>2]=0;y=y+1|0}iVa(d,B,j,k,l,m,n,o,p,q);d=b[x>>0]|0;x=d<<24>>24<0;y=x?f[A>>2]|0:d&255;d=f[q>>2]|0;if((y|0)>(d|0)){q=b[p+11>>0]|0;A=b[o+11>>0]|0;C=1;D=(q<<24>>24<0?f[p+4>>2]|0:q&255)+(y-d<<1)|0;E=A<<24>>24<0?f[o+4>>2]|0:A&255}else{A=b[p+11>>0]|0;q=b[o+11>>0]|0;C=2;D=q<<24>>24<0?f[o+4>>2]|0:q&255;E=A<<24>>24<0?f[p+4>>2]|0:A&255}A=E+d+D+C|0;if(A>>>0>100){C=dKa(A)|0;if(!C)RYa();else{F=C;G=C}}else{F=0;G=r}r=x?f[h>>2]|0:h;jVa(G,s,t,f[e+4>>2]|0,r,r+y|0,w,B,k,b[l>>0]|0,b[m>>0]|0,n,o,p,d);f[v>>2]=f[c>>2];c=f[s>>2]|0;s=f[t>>2]|0;f[i>>2]=f[v>>2];v=KU(i,G,c,s,e,g)|0;if(F|0)eKa(F);_Ya(p);_Ya(o);_Ya(n);CQa(j);u=a;return v|0}function iVa(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;m=u;u=u+16|0;n=m+12|0;o=m;if(a){a=BQa(d,1976896)|0;if(c){Gh[f[(f[a>>2]|0)+44>>2]&511](n,a);p=f[n>>2]|0;b[e>>0]=p;b[e+1>>0]=p>>8;b[e+2>>0]=p>>16;b[e+3>>0]=p>>24;Gh[f[(f[a>>2]|0)+32>>2]&511](o,a);p=k+11|0;if((b[p>>0]|0)<0){q=f[k>>2]|0;b[n>>0]=0;ZOa(q,n);f[k+4>>2]=0;r=k}else{b[n>>0]=0;ZOa(k,n);b[p>>0]=0;r=k}dZa(k,0);f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}_Ya(o);s=a}else{Gh[f[(f[a>>2]|0)+40>>2]&511](n,a);r=f[n>>2]|0;b[e>>0]=r;b[e+1>>0]=r>>8;b[e+2>>0]=r>>16;b[e+3>>0]=r>>24;Gh[f[(f[a>>2]|0)+28>>2]&511](o,a);r=k+11|0;if((b[r>>0]|0)<0){p=f[k>>2]|0;b[n>>0]=0;ZOa(p,n);f[k+4>>2]=0;t=k}else{b[n>>0]=0;ZOa(k,n);b[r>>0]=0;t=k}dZa(k,0);f[t>>2]=f[o>>2];f[t+4>>2]=f[o+4>>2];f[t+8>>2]=f[o+8>>2];t=0;while(1){if((t|0)==3)break;f[o+(t<<2)>>2]=0;t=t+1|0}_Ya(o);s=a}t=mi[f[(f[a>>2]|0)+12>>2]&255](a)|0;b[g>>0]=t;t=mi[f[(f[a>>2]|0)+16>>2]&255](a)|0;b[h>>0]=t;Gh[f[(f[s>>2]|0)+20>>2]&511](o,a);t=i+11|0;if((b[t>>0]|0)<0){r=f[i>>2]|0;b[n>>0]=0;ZOa(r,n);f[i+4>>2]=0;v=i}else{b[n>>0]=0;ZOa(i,n);b[t>>0]=0;v=i}dZa(i,0);f[v>>2]=f[o>>2];f[v+4>>2]=f[o+4>>2];f[v+8>>2]=f[o+8>>2];v=0;while(1){if((v|0)==3)break;f[o+(v<<2)>>2]=0;v=v+1|0}_Ya(o);Gh[f[(f[s>>2]|0)+24>>2]&511](o,a);s=j+11|0;if((b[s>>0]|0)<0){v=f[j>>2]|0;b[n>>0]=0;ZOa(v,n);f[j+4>>2]=0;w=j}else{b[n>>0]=0;ZOa(j,n);b[s>>0]=0;w=j}dZa(j,0);f[w>>2]=f[o>>2];f[w+4>>2]=f[o+4>>2];f[w+8>>2]=f[o+8>>2];w=0;while(1){if((w|0)==3)break;f[o+(w<<2)>>2]=0;w=w+1|0}_Ya(o);x=mi[f[(f[a>>2]|0)+36>>2]&255](a)|0}else{a=BQa(d,1976888)|0;if(c){Gh[f[(f[a>>2]|0)+44>>2]&511](n,a);c=f[n>>2]|0;b[e>>0]=c;b[e+1>>0]=c>>8;b[e+2>>0]=c>>16;b[e+3>>0]=c>>24;Gh[f[(f[a>>2]|0)+32>>2]&511](o,a);c=k+11|0;if((b[c>>0]|0)<0){d=f[k>>2]|0;b[n>>0]=0;ZOa(d,n);f[k+4>>2]=0;y=k}else{b[n>>0]=0;ZOa(k,n);b[c>>0]=0;y=k}dZa(k,0);f[y>>2]=f[o>>2];f[y+4>>2]=f[o+4>>2];f[y+8>>2]=f[o+8>>2];y=0;while(1){if((y|0)==3)break;f[o+(y<<2)>>2]=0;y=y+1|0}_Ya(o);z=a}else{Gh[f[(f[a>>2]|0)+40>>2]&511](n,a);y=f[n>>2]|0;b[e>>0]=y;b[e+1>>0]=y>>8;b[e+2>>0]=y>>16;b[e+3>>0]=y>>24;Gh[f[(f[a>>2]|0)+28>>2]&511](o,a);y=k+11|0;if((b[y>>0]|0)<0){e=f[k>>2]|0;b[n>>0]=0;ZOa(e,n);f[k+4>>2]=0;A=k}else{b[n>>0]=0;ZOa(k,n);b[y>>0]=0;A=k}dZa(k,0);f[A>>2]=f[o>>2];f[A+4>>2]=f[o+4>>2];f[A+8>>2]=f[o+8>>2];A=0;while(1){if((A|0)==3)break;f[o+(A<<2)>>2]=0;A=A+1|0}_Ya(o);z=a}A=mi[f[(f[a>>2]|0)+12>>2]&255](a)|0;b[g>>0]=A;A=mi[f[(f[a>>2]|0)+16>>2]&255](a)|0;b[h>>0]=A;Gh[f[(f[z>>2]|0)+20>>2]&511](o,a);A=i+11|0;if((b[A>>0]|0)<0){h=f[i>>2]|0;b[n>>0]=0;ZOa(h,n);f[i+4>>2]=0;B=i}else{b[n>>0]=0;ZOa(i,n);b[A>>0]=0;B=i}dZa(i,0);f[B>>2]=f[o>>2];f[B+4>>2]=f[o+4>>2];f[B+8>>2]=f[o+8>>2];B=0;while(1){if((B|0)==3)break;f[o+(B<<2)>>2]=0;B=B+1|0}_Ya(o);Gh[f[(f[z>>2]|0)+24>>2]&511](o,a);z=j+11|0;if((b[z>>0]|0)<0){B=f[j>>2]|0;b[n>>0]=0;ZOa(B,n);f[j+4>>2]=0;C=j}else{b[n>>0]=0;ZOa(j,n);b[z>>0]=0;C=j}dZa(j,0);f[C>>2]=f[o>>2];f[C+4>>2]=f[o+4>>2];f[C+8>>2]=f[o+8>>2];C=0;while(1){if((C|0)==3)break;f[o+(C<<2)>>2]=0;C=C+1|0}_Ya(o);x=mi[f[(f[a>>2]|0)+36>>2]&255](a)|0}f[l>>2]=x;u=m;return}function jVa(a,c,e,g,h,i,j,k,l,m,n,o,p,q,r){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;f[e>>2]=a;s=q+11|0;t=q+4|0;u=p+11|0;v=p+4|0;w=(g&512|0)==0;x=j+8|0;y=(r|0)>0;z=o+11|0;A=o+4|0;B=h;h=0;while(1){if((h|0)==4)break;a:do switch(b[l+h>>0]|0){case 0:{f[c>>2]=f[e>>2];C=B;break}case 1:{f[c>>2]=f[e>>2];D=$h[f[(f[j>>2]|0)+28>>2]&255](j,32)|0;E=f[e>>2]|0;f[e>>2]=E+1;b[E>>0]=D;C=B;break}case 3:{D=b[s>>0]|0;E=D<<24>>24<0;if(!((E?f[t>>2]|0:D&255)|0))C=B;else{D=b[(E?f[q>>2]|0:q)>>0]|0;E=f[e>>2]|0;f[e>>2]=E+1;b[E>>0]=D;C=B}break}case 2:{D=b[u>>0]|0;E=D<<24>>24<0;F=E?f[v>>2]|0:D&255;if(w|(F|0)==0)C=B;else{D=E?f[p>>2]|0:p;E=D+F|0;F=f[e>>2]|0;G=D;while(1){if((G|0)==(E|0))break;b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}f[e>>2]=F;C=B}break}case 4:{G=f[e>>2]|0;E=k?B+1|0:B;D=E;while(1){if(D>>>0>=i>>>0)break;H=b[D>>0]|0;if(H<<24>>24<=-1)break;if(!(d[(f[x>>2]|0)+(H<<24>>24<<1)>>1]&2048))break;D=D+1|0}if(y){F=D;H=r;while(1){I=(H|0)>0;if(!(F>>>0>E>>>0&I))break;J=F+-1|0;K=b[J>>0]|0;L=f[e>>2]|0;f[e>>2]=L+1;b[L>>0]=K;F=J;H=H+-1|0}if(I)M=$h[f[(f[j>>2]|0)+28>>2]&255](j,48)|0;else M=0;J=H;while(1){N=f[e>>2]|0;f[e>>2]=N+1;if((J|0)<=0)break;b[N>>0]=M;J=J+-1|0}b[N>>0]=m;O=F}else O=D;b:do if((O|0)==(E|0)){J=$h[f[(f[j>>2]|0)+28>>2]&255](j,48)|0;H=f[e>>2]|0;f[e>>2]=H+1;b[H>>0]=J}else{J=b[z>>0]|0;H=J<<24>>24<0;if(!((H?f[A>>2]|0:J&255)|0)){P=O;Q=-1;R=0;S=0}else{P=O;Q=b[(H?f[o>>2]|0:o)>>0]|0;R=0;S=0}while(1){if((P|0)==(E|0))break b;if((S|0)==(Q|0)){H=f[e>>2]|0;f[e>>2]=H+1;b[H>>0]=n;H=R+1|0;J=b[z>>0]|0;K=J<<24>>24<0;if(H>>>0<(K?f[A>>2]|0:J&255)>>>0){J=b[(K?f[o>>2]|0:o)+H>>0]|0;T=J<<24>>24==127?-1:J<<24>>24;U=H;V=0}else{T=S;U=H;V=0}}else{T=Q;U=R;V=S}H=P+-1|0;J=b[H>>0]|0;K=f[e>>2]|0;f[e>>2]=K+1;b[K>>0]=J;P=H;Q=T;R=U;S=V+1|0}}while(0);D=f[e>>2]|0;if((G|0)==(D|0))C=E;else{F=G;H=D;while(1){D=H+-1|0;if(F>>>0>=D>>>0){C=E;break a}J=b[F>>0]|0;b[F>>0]=b[D>>0]|0;b[D>>0]=J;F=F+1|0;H=D}}break}default:C=B}while(0);B=C;h=h+1|0}h=b[s>>0]|0;s=h<<24>>24<0;C=s?f[t>>2]|0:h&255;if(C>>>0>1){h=s?f[q>>2]|0:q;q=h+C|0;C=f[e>>2]|0;s=h;while(1){h=s+1|0;if((h|0)==(q|0))break;b[C>>0]=b[h>>0]|0;C=C+1|0;s=h}f[e>>2]=C}switch((g&176)<<24>>24){case 32:{f[c>>2]=f[e>>2];break}case 16:break;default:f[c>>2]=a}return}function kVa(a){a=a|0;hQa(a);return}function lVa(a){a=a|0;hQa(a);PYa(a);return}function mVa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;a=u;u=u+1008|0;i=a+8|0;j=a;k=a+896|0;l=a+888|0;m=a+488|0;n=a+480|0;o=a+892|0;q=a+476|0;r=a+472|0;s=a+460|0;t=a+448|0;v=a+436|0;w=a+432|0;x=a+32|0;y=a+24|0;z=a+16|0;A=a+20|0;f[l>>2]=k;p[i>>3]=h;B=pLa(k,100,371616,i)|0;if(B>>>0>99){k=EQa()|0;p[j>>3]=h;C=WRa(l,k,371616,j)|0;j=f[l>>2]|0;if(!j)RYa();k=dKa(C<<2)|0;if(!k)RYa();else{D=k;E=k;F=j;G=C}}else{D=m;E=0;F=0;G=B}bPa(n,e);B=BQa(n,1975208)|0;m=f[l>>2]|0;Jg[f[(f[B>>2]|0)+48>>2]&63](B,m,m+G|0,D)|0;if(!G)H=0;else H=(b[f[l>>2]>>0]|0)==45;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[s+(l<<2)>>2]=0;l=l+1|0}f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[t+(l<<2)>>2]=0;l=l+1|0}f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[v+(l<<2)>>2]=0;l=l+1|0}oVa(d,H,n,o,q,r,s,t,v,w);d=f[w>>2]|0;if((G|0)>(d|0)){w=b[v+8+3>>0]|0;l=b[t+8+3>>0]|0;I=1;J=l<<24>>24<0?f[t+4>>2]|0:l&255;K=(w<<24>>24<0?f[v+4>>2]|0:w&255)+(G-d<<1)|0}else{w=b[v+8+3>>0]|0;l=b[t+8+3>>0]|0;I=2;J=w<<24>>24<0?f[v+4>>2]|0:w&255;K=l<<24>>24<0?f[t+4>>2]|0:l&255}l=J+d+K+I|0;if(l>>>0>100){I=dKa(l<<2)|0;if(!I)RYa();else{L=I;M=I}}else{L=0;M=x}pVa(M,y,z,f[e+4>>2]|0,D,D+(G<<2)|0,B,H,o,f[q>>2]|0,f[r>>2]|0,s,t,v,d);f[A>>2]=f[c>>2];c=f[y>>2]|0;y=f[z>>2]|0;f[i>>2]=f[A>>2];A=iSa(i,M,c,y,e,g)|0;if(L|0)eKa(L);qZa(v);qZa(t);_Ya(s);CQa(n);if(E|0)eKa(E);if(F|0)eKa(F);u=a;return A|0}function nVa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;a=u;u=u+480|0;i=a+468|0;j=a+464|0;k=a+472|0;l=a+460|0;m=a+456|0;n=a+444|0;o=a+432|0;p=a+420|0;q=a+416|0;r=a+16|0;s=a+8|0;t=a+4|0;v=a;bPa(j,e);w=BQa(j,1975208)|0;x=h+8+3|0;y=b[x>>0]|0;z=y<<24>>24<0;A=h+4|0;if(!((z?f[A>>2]|0:y&255)|0))B=0;else{y=f[(z?f[h>>2]|0:h)>>2]|0;B=(y|0)==($h[f[(f[w>>2]|0)+44>>2]&255](w,45)|0)};f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[n+(y<<2)>>2]=0;y=y+1|0}f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[o+(y<<2)>>2]=0;y=y+1|0}f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[p+(y<<2)>>2]=0;y=y+1|0}oVa(d,B,j,k,l,m,n,o,p,q);d=b[x>>0]|0;x=d<<24>>24<0;y=x?f[A>>2]|0:d&255;d=f[q>>2]|0;if((y|0)>(d|0)){q=b[p+8+3>>0]|0;A=b[o+8+3>>0]|0;C=1;D=(q<<24>>24<0?f[p+4>>2]|0:q&255)+(y-d<<1)|0;E=A<<24>>24<0?f[o+4>>2]|0:A&255}else{A=b[p+8+3>>0]|0;q=b[o+8+3>>0]|0;C=2;D=q<<24>>24<0?f[o+4>>2]|0:q&255;E=A<<24>>24<0?f[p+4>>2]|0:A&255}A=E+d+D+C|0;if(A>>>0>100){C=dKa(A<<2)|0;if(!C)RYa();else{F=C;G=C}}else{F=0;G=r}r=x?f[h>>2]|0:h;pVa(G,s,t,f[e+4>>2]|0,r,r+(y<<2)|0,w,B,k,f[l>>2]|0,f[m>>2]|0,n,o,p,d);f[v>>2]=f[c>>2];c=f[s>>2]|0;s=f[t>>2]|0;f[i>>2]=f[v>>2];v=iSa(i,G,c,s,e,g)|0;if(F|0)eKa(F);qZa(p);qZa(o);_Ya(n);CQa(j);u=a;return v|0}function oVa(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;m=u;u=u+16|0;n=m+12|0;o=m;if(a){a=BQa(d,1976912)|0;if(c){Gh[f[(f[a>>2]|0)+44>>2]&511](n,a);p=f[n>>2]|0;b[e>>0]=p;b[e+1>>0]=p>>8;b[e+2>>0]=p>>16;b[e+3>>0]=p>>24;Gh[f[(f[a>>2]|0)+32>>2]&511](o,a);p=k+8+3|0;if((b[p>>0]|0)<0){q=f[k>>2]|0;f[n>>2]=0;nQa(q,n);f[k+4>>2]=0}else{f[n>>2]=0;nQa(k,n);b[p>>0]=0}uZa(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];p=0;while(1){if((p|0)==3)break;f[o+(p<<2)>>2]=0;p=p+1|0}qZa(o)}else{Gh[f[(f[a>>2]|0)+40>>2]&511](n,a);p=f[n>>2]|0;b[e>>0]=p;b[e+1>>0]=p>>8;b[e+2>>0]=p>>16;b[e+3>>0]=p>>24;Gh[f[(f[a>>2]|0)+28>>2]&511](o,a);p=k+8+3|0;if((b[p>>0]|0)<0){q=f[k>>2]|0;f[n>>2]=0;nQa(q,n);f[k+4>>2]=0}else{f[n>>2]=0;nQa(k,n);b[p>>0]=0}uZa(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];p=0;while(1){if((p|0)==3)break;f[o+(p<<2)>>2]=0;p=p+1|0}qZa(o)}p=mi[f[(f[a>>2]|0)+12>>2]&255](a)|0;f[g>>2]=p;p=mi[f[(f[a>>2]|0)+16>>2]&255](a)|0;f[h>>2]=p;Gh[f[(f[a>>2]|0)+20>>2]&511](o,a);p=i+11|0;if((b[p>>0]|0)<0){q=f[i>>2]|0;b[n>>0]=0;ZOa(q,n);f[i+4>>2]=0;r=i}else{b[n>>0]=0;ZOa(i,n);b[p>>0]=0;r=i}dZa(i,0);f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}_Ya(o);Gh[f[(f[a>>2]|0)+24>>2]&511](o,a);r=j+8+3|0;if((b[r>>0]|0)<0){p=f[j>>2]|0;f[n>>2]=0;nQa(p,n);f[j+4>>2]=0}else{f[n>>2]=0;nQa(j,n);b[r>>0]=0}uZa(j,0);f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[j+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}qZa(o);s=mi[f[(f[a>>2]|0)+36>>2]&255](a)|0}else{a=BQa(d,1976904)|0;if(c){Gh[f[(f[a>>2]|0)+44>>2]&511](n,a);c=f[n>>2]|0;b[e>>0]=c;b[e+1>>0]=c>>8;b[e+2>>0]=c>>16;b[e+3>>0]=c>>24;Gh[f[(f[a>>2]|0)+32>>2]&511](o,a);c=k+8+3|0;if((b[c>>0]|0)<0){d=f[k>>2]|0;f[n>>2]=0;nQa(d,n);f[k+4>>2]=0}else{f[n>>2]=0;nQa(k,n);b[c>>0]=0}uZa(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];c=0;while(1){if((c|0)==3)break;f[o+(c<<2)>>2]=0;c=c+1|0}qZa(o)}else{Gh[f[(f[a>>2]|0)+40>>2]&511](n,a);c=f[n>>2]|0;b[e>>0]=c;b[e+1>>0]=c>>8;b[e+2>>0]=c>>16;b[e+3>>0]=c>>24;Gh[f[(f[a>>2]|0)+28>>2]&511](o,a);c=k+8+3|0;if((b[c>>0]|0)<0){e=f[k>>2]|0;f[n>>2]=0;nQa(e,n);f[k+4>>2]=0}else{f[n>>2]=0;nQa(k,n);b[c>>0]=0}uZa(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];k=0;while(1){if((k|0)==3)break;f[o+(k<<2)>>2]=0;k=k+1|0}qZa(o)}k=mi[f[(f[a>>2]|0)+12>>2]&255](a)|0;f[g>>2]=k;k=mi[f[(f[a>>2]|0)+16>>2]&255](a)|0;f[h>>2]=k;Gh[f[(f[a>>2]|0)+20>>2]&511](o,a);k=i+11|0;if((b[k>>0]|0)<0){h=f[i>>2]|0;b[n>>0]=0;ZOa(h,n);f[i+4>>2]=0;t=i}else{b[n>>0]=0;ZOa(i,n);b[k>>0]=0;t=i}dZa(i,0);f[t>>2]=f[o>>2];f[t+4>>2]=f[o+4>>2];f[t+8>>2]=f[o+8>>2];t=0;while(1){if((t|0)==3)break;f[o+(t<<2)>>2]=0;t=t+1|0}_Ya(o);Gh[f[(f[a>>2]|0)+24>>2]&511](o,a);t=j+8+3|0;if((b[t>>0]|0)<0){i=f[j>>2]|0;f[n>>2]=0;nQa(i,n);f[j+4>>2]=0}else{f[n>>2]=0;nQa(j,n);b[t>>0]=0}uZa(j,0);f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[j+8>>2]=f[o+8>>2];j=0;while(1){if((j|0)==3)break;f[o+(j<<2)>>2]=0;j=j+1|0}qZa(o);s=mi[f[(f[a>>2]|0)+36>>2]&255](a)|0}f[l>>2]=s;u=m;return}function pVa(a,c,d,e,g,h,i,j,k,l,m,n,o,p,q){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;f[d>>2]=a;r=p+8+3|0;s=p+4|0;t=o+8+3|0;u=o+4|0;v=(e&512|0)==0;w=(q|0)>0;x=n+11|0;y=n+4|0;z=g;g=0;while(1){if((g|0)==4)break;a:do switch(b[k+g>>0]|0){case 0:{f[c>>2]=f[d>>2];A=z;break}case 1:{f[c>>2]=f[d>>2];B=$h[f[(f[i>>2]|0)+44>>2]&255](i,32)|0;C=f[d>>2]|0;f[d>>2]=C+4;f[C>>2]=B;A=z;break}case 3:{B=b[r>>0]|0;C=B<<24>>24<0;if(!((C?f[s>>2]|0:B&255)|0))A=z;else{B=f[(C?f[p>>2]|0:p)>>2]|0;C=f[d>>2]|0;f[d>>2]=C+4;f[C>>2]=B;A=z}break}case 2:{B=b[t>>0]|0;C=B<<24>>24<0;D=C?f[u>>2]|0:B&255;if(v|(D|0)==0)A=z;else{B=C?f[o>>2]|0:o;C=B+(D<<2)|0;E=f[d>>2]|0;F=B;B=E;while(1){if((F|0)==(C|0))break;f[B>>2]=f[F>>2];F=F+4|0;B=B+4|0}f[d>>2]=E+(D<<2);A=z}break}case 4:{B=f[d>>2]|0;F=j?z+4|0:z;C=F;while(1){if(C>>>0>=h>>>0)break;if(!(ui[f[(f[i>>2]|0)+12>>2]&127](i,2048,f[C>>2]|0)|0))break;C=C+4|0}if(w){D=C;E=q;while(1){G=(E|0)>0;if(!(D>>>0>F>>>0&G))break;H=D+-4|0;I=f[H>>2]|0;J=f[d>>2]|0;f[d>>2]=J+4;f[J>>2]=I;D=H;E=E+-1|0}if(G)K=$h[f[(f[i>>2]|0)+44>>2]&255](i,48)|0;else K=0;H=E;I=f[d>>2]|0;while(1){L=I+4|0;if((H|0)<=0)break;f[I>>2]=K;H=H+-1|0;I=L}f[d>>2]=L;f[I>>2]=l;M=D}else M=C;if((M|0)==(F|0)){H=$h[f[(f[i>>2]|0)+44>>2]&255](i,48)|0;E=f[d>>2]|0;J=E+4|0;f[d>>2]=J;f[E>>2]=H;N=J}else{J=b[x>>0]|0;H=J<<24>>24<0;E=J&255;if(!((H?f[y>>2]|0:E)|0)){O=M;P=-1;Q=0;R=0}else{O=M;P=b[(H?f[n>>2]|0:n)>>0]|0;Q=0;R=0}while(1){if((O|0)==(F|0))break;J=f[d>>2]|0;if((R|0)==(P|0)){S=J+4|0;f[d>>2]=S;f[J>>2]=m;T=Q+1|0;if(T>>>0<(H?f[y>>2]|0:E)>>>0){U=b[(H?f[n>>2]|0:n)+T>>0]|0;V=S;W=U<<24>>24==127?-1:U<<24>>24;X=T;Y=0}else{V=S;W=R;X=T;Y=0}}else{V=J;W=P;X=Q;Y=R}J=O+-4|0;T=f[J>>2]|0;f[d>>2]=V+4;f[V>>2]=T;O=J;P=W;Q=X;R=Y+1|0}N=f[d>>2]|0}if((B|0)==(N|0))A=F;else{H=B;E=N;while(1){C=E+-4|0;if(H>>>0>=C>>>0){A=F;break a}D=f[H>>2]|0;f[H>>2]=f[C>>2];f[C>>2]=D;H=H+4|0;E=C}}break}default:A=z}while(0);z=A;g=g+1|0}g=b[r>>0]|0;r=g<<24>>24<0;A=r?f[s>>2]|0:g&255;if(A>>>0>1){g=r?f[p>>2]|0:p;p=g+4|0;r=g+(A<<2)|0;A=f[d>>2]|0;g=r-p|0;s=p;p=A;while(1){if((s|0)==(r|0))break;f[p>>2]=f[s>>2];s=s+4|0;p=p+4|0}f[d>>2]=A+(g>>>2<<2)}switch((e&176)<<24>>24){case 32:{f[c>>2]=f[d>>2];break}case 16:break;default:f[c>>2]=a}return}function qVa(a){a=a|0;hQa(a);return}function rVa(a){a=a|0;hQa(a);PYa(a);return}function sVa(a,c,d){a=a|0;c=c|0;d=d|0;d=GNa((b[c+11>>0]|0)<0?f[c>>2]|0:c,1)|0;return d>>>((d|0)!=(-1|0)&1)|0}function tVa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;i=c;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;j=0;while(1){if((j|0)==3)break;f[i+(j<<2)>>2]=0;j=j+1|0}j=b[h+11>>0]|0;k=j<<24>>24<0;l=k?f[h>>2]|0:h;m=l+(k?f[h+4>>2]|0:j&255)|0;j=l;while(1){if(j>>>0>=m>>>0)break;kZa(i,b[j>>0]|0);j=j+1|0}j=(b[i+11>>0]|0)<0?f[i>>2]|0:i;m=DNa((d|0)==-1?-1:d<<1,e,g,j)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=0;while(1){if((g|0)==3)break;f[a+(g<<2)>>2]=0;g=g+1|0}g=j+(xKa(m)|0)|0;m=j;while(1){if(m>>>0>=g>>>0)break;kZa(a,b[m>>0]|0);m=m+1|0}_Ya(i);u=c;return}function uVa(a,b){a=a|0;b=b|0;return}function vVa(a){a=a|0;hQa(a);return}function wVa(a){a=a|0;hQa(a);PYa(a);return}function xVa(a,c,d){a=a|0;c=c|0;d=d|0;d=GNa((b[c+11>>0]|0)<0?f[c>>2]|0:c,1)|0;return d>>>((d|0)!=(-1|0)&1)|0}function yVa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;c=u;u=u+176|0;i=c+168|0;j=c+40|0;k=c+36|0;l=c+32|0;m=c;n=c+24|0;o=c+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;p=0;while(1){if((p|0)==3)break;f[m+(p<<2)>>2]=0;p=p+1|0}f[n+4>>2]=0;f[n>>2]=129808;p=b[h+8+3>>0]|0;q=p<<24>>24<0;r=q?f[h>>2]|0:h;s=r+((q?f[h+4>>2]|0:p&255)<<2)|0;p=j+32|0;h=0;q=r;while(1){if(!((h|0)!=2&q>>>0<s>>>0))break;f[l>>2]=q;r=Oi[f[(f[n>>2]|0)+12>>2]&15](n,i,q,s,l,j,p,k)|0;if((r|0)==2?1:(f[l>>2]|0)==(q|0)){t=7;break}else v=j;while(1){if(v>>>0>=(f[k>>2]|0)>>>0)break;kZa(m,b[v>>0]|0);v=v+1|0}h=r;q=f[l>>2]|0}if((t|0)==7)WTa(0);hQa(n);n=(b[m+11>>0]|0)<0?f[m>>2]|0:m;q=DNa((d|0)==-1?-1:d<<1,e,g,n)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=0;while(1){if((g|0)==3)break;f[a+(g<<2)>>2]=0;g=g+1|0}f[o+4>>2]=0;f[o>>2]=129856;g=n+(xKa(q)|0)|0;q=g;e=j+128|0;d=n;n=0;while(1){if(!((n|0)!=2&d>>>0<g>>>0)){t=21;break}f[l>>2]=d;h=Oi[f[(f[o>>2]|0)+16>>2]&15](o,i,d,(q-d|0)>32?d+32|0:g,l,j,e,k)|0;if((h|0)==2?1:(f[l>>2]|0)==(d|0)){t=17;break}else w=j;while(1){if(w>>>0>=(f[k>>2]|0)>>>0)break;yZa(a,f[w>>2]|0);w=w+4|0}d=f[l>>2]|0;n=h}if((t|0)==17)WTa(0);else if((t|0)==21){hQa(o);_Ya(m);u=c;return}}function zVa(a,b){a=a|0;b=b|0;return}function AVa(a){a=a|0;hQa(a);PYa(a);return}function BVa(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;b=u;u=u+16|0;a=b+4|0;j=b;f[a>>2]=c;f[j>>2]=g;k=KVa(c,d,a,g,h,j,1114111,0)|0;f[e>>2]=f[a>>2];f[i>>2]=f[j>>2];u=b;return k|0}function CVa(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;b=u;u=u+16|0;a=b+4|0;j=b;f[a>>2]=c;f[j>>2]=g;k=JVa(c,d,a,g,h,j,1114111,0)|0;f[e>>2]=f[a>>2];f[i>>2]=f[j>>2];u=b;return k|0}function DVa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f[e>>2]=c;return 3}function EVa(a){a=a|0;return 0}function FVa(a){a=a|0;return 0}function GVa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return IVa(c,d,e,1114111,0)|0}function HVa(a){a=a|0;return 4}function IVa(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=c;i=a;if(((g-i|0)>2&(f&4|0)!=0?(b[a>>0]|0)==-17:0)?(b[a+1>>0]|0)==-69:0){j=(b[a+2>>0]|0)==-65?a+3|0:a;k=0}else{j=a;k=0}a:while(1){if(!(k>>>0<d>>>0&j>>>0<c>>>0)){l=30;break}a=b[j>>0]|0;f=a&255;m=j+1|0;do if(a<<24>>24>-1)if(f>>>0>e>>>0){l=30;break a}else n=m;else{if((a&255)<194){l=30;break a}o=j+2|0;p=j;q=g-p|0;if((a&255)<224){if((q|0)<2){l=30;break a}r=h[m>>0]|0;if((r&192|0)!=128){l=30;break a}if((r&63|f<<6&1984)>>>0>e>>>0){l=30;break a}else{n=o;break}}r=j+3|0;if((a&255)<240){if((q|0)<3){l=30;break a}s=b[o>>0]|0;t=h[m>>0]|0;u=t&224;switch(a<<24>>24){case -32:{if((u|0)!=160){v=p;break a}break}case -19:{if((u|0)!=128){v=p;break a}break}default:if((t&192|0)!=128){v=p;break a}}u=s&255;if((u&192|0)!=128){l=30;break a}if((t<<6&4032|f<<12&61440|u&63)>>>0>e>>>0){l=30;break a}else{n=r;break}}if((q|0)<4|(a&255)>244){l=30;break a}q=b[m>>0]|0;u=b[o>>0]|0;o=b[r>>0]|0;r=q&255;switch(a<<24>>24){case -16:{if((q+112&255)>=48){v=p;break a}break}case -12:{if((r&240|0)!=128){v=p;break a}break}default:if((r&192|0)!=128){v=p;break a}}p=u&255;if((p&192|0)!=128){l=30;break a}u=o&255;if((u&192|0)!=128){l=30;break a}if((r<<12&258048|f<<18&1835008|p<<6&4032|u&63)>>>0>e>>>0){l=30;break a}else n=j+4|0}while(0);j=n;k=k+1|0}if((l|0)==30)v=j;return v-i|0}function JVa(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f[d>>2]=a;f[i>>2]=e;e=c;if((((k&4|0?(k=f[d>>2]|0,(e-k|0)>2):0)?(b[k>>0]|0)==-17:0)?(b[k+1>>0]|0)==-69:0)?(b[k+2>>0]|0)==-65:0)f[d>>2]=k+3;a:while(1){k=f[d>>2]|0;if(k>>>0>=c>>>0){l=0;break}a=f[i>>2]|0;if(a>>>0>=g>>>0){l=1;break}m=b[k>>0]|0;n=m&255;o=k+1|0;do if(m<<24>>24>-1){if(n>>>0>j>>>0){l=2;break a}f[a>>2]=n;p=o}else{if((m&255)<194){l=2;break a}q=k+2|0;r=e-k|0;if((m&255)<224){if((r|0)<2){l=1;break a}s=h[o>>0]|0;if((s&192|0)!=128){l=2;break a}t=s&63|n<<6&1984;if(t>>>0>j>>>0){l=2;break a}f[a>>2]=t;p=q;break}t=k+3|0;if((m&255)<240){if((r|0)<3){l=1;break a}s=b[q>>0]|0;u=h[o>>0]|0;v=u&224;switch(m<<24>>24){case -32:{if((v|0)!=160){l=2;break a}break}case -19:{if((v|0)!=128){l=2;break a}break}default:if((u&192|0)!=128){l=2;break a}}v=s&255;if((v&192|0)!=128){l=2;break a}s=u<<6&4032|n<<12&61440|v&63;if(s>>>0>j>>>0){l=2;break a}f[a>>2]=s;p=t;break}if((m&255)>=245){l=2;break a}if((r|0)<4){l=1;break a}r=b[o>>0]|0;s=b[q>>0]|0;q=b[t>>0]|0;t=r&255;switch(m<<24>>24){case -16:{if((r+112&255)>=48){l=2;break a}break}case -12:{if((t&240|0)!=128){l=2;break a}break}default:if((t&192|0)!=128){l=2;break a}}r=s&255;if((r&192|0)!=128){l=2;break a}s=q&255;if((s&192|0)!=128){l=2;break a}q=t<<12&258048|n<<18&1835008|r<<6&4032|s&63;if(q>>>0>j>>>0){l=2;break a}f[a>>2]=q;p=k+4|0}while(0);f[d>>2]=p;f[i>>2]=(f[i>>2]|0)+4}return l|0}function KVa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;f[d>>2]=a;f[h>>2]=e;a=g;if(j&2)if((a-e|0)<3)k=1;else{f[h>>2]=e+1;b[e>>0]=-17;e=f[h>>2]|0;f[h>>2]=e+1;b[e>>0]=-69;e=f[h>>2]|0;f[h>>2]=e+1;b[e>>0]=-65;l=4}else l=4;a:do if((l|0)==4){e=f[d>>2]|0;while(1){if(e>>>0>=c>>>0){k=0;break a}j=f[e>>2]|0;if(j>>>0>i>>>0|(j&-2048|0)==55296){k=2;break a}do if(j>>>0>=128){g=(j&63|128)&255;if(j>>>0<2048){m=f[h>>2]|0;if((a-m|0)<2){k=1;break a}f[h>>2]=m+1;b[m>>0]=j>>>6|192;m=f[h>>2]|0;f[h>>2]=m+1;b[m>>0]=g;break}m=f[h>>2]|0;n=a-m|0;o=m+1|0;p=(j>>>6&63|128)&255;if(j>>>0<65536){if((n|0)<3){k=1;break a}f[h>>2]=o;b[m>>0]=j>>>12|224;q=f[h>>2]|0;f[h>>2]=q+1;b[q>>0]=p;q=f[h>>2]|0;f[h>>2]=q+1;b[q>>0]=g;break}else{if((n|0)<4){k=1;break a}f[h>>2]=o;b[m>>0]=j>>>18|240;m=f[h>>2]|0;f[h>>2]=m+1;b[m>>0]=j>>>12&63|128;m=f[h>>2]|0;f[h>>2]=m+1;b[m>>0]=p;p=f[h>>2]|0;f[h>>2]=p+1;b[p>>0]=g;break}}else{g=f[h>>2]|0;if((a-g|0)<1){k=1;break a}f[h>>2]=g+1;b[g>>0]=j}while(0);j=(f[d>>2]|0)+4|0;f[d>>2]=j;e=j}}while(0);return k|0}function LVa(a){a=a|0;hQa(a);PYa(a);return}function MVa(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;f[e>>2]=c;f[i>>2]=g;return 3}function NVa(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;f[e>>2]=c;f[i>>2]=g;return 3}function OVa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f[e>>2]=c;return 3}function PVa(a){a=a|0;return 1}function QVa(a){a=a|0;return 1}function RVa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;return (b>>>0<e>>>0?b:e)|0}function SVa(a){a=a|0;return 1}function TVa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;k=u;u=u+16|0;l=k;m=k+8|0;n=d;while(1){if((n|0)==(e|0)){o=e;break}if(!(f[n>>2]|0)){o=n;break}n=n+4|0}f[j>>2]=h;f[g>>2]=d;n=i;p=a+8|0;a=o;o=d;d=h;a:while(1){if((d|0)==(i|0)|(o|0)==(e|0)){q=o;r=35;break}h=c;s=f[h+4>>2]|0;t=l;f[t>>2]=f[h>>2];f[t+4>>2]=s;s=ANa(f[p>>2]|0)|0;t=YMa(d,g,a-o>>2,n-d|0,c)|0;if(s|0)ANa(s)|0;switch(t|0){case -1:{r=10;break a;break}case 0:{v=1;r=32;break a;break}default:{}}s=(f[j>>2]|0)+t|0;f[j>>2]=s;if((s|0)==(i|0)){r=33;break}if((a|0)==(e|0)){w=s;x=f[g>>2]|0;y=e}else{s=ANa(f[p>>2]|0)|0;t=HLa(m,0,c)|0;if(s|0)ANa(s)|0;if((t|0)==-1){z=2;r=31;break}if(t>>>0>(n-(f[j>>2]|0)|0)>>>0){z=1;r=31;break}else{A=t;B=m}while(1){if(!A)break;t=b[B>>0]|0;s=f[j>>2]|0;f[j>>2]=s+1;b[s>>0]=t;A=A+-1|0;B=B+1|0}t=(f[g>>2]|0)+4|0;f[g>>2]=t;s=t;while(1){if((s|0)==(e|0)){C=e;break}if(!(f[s>>2]|0)){C=s;break}s=s+4|0}w=f[j>>2]|0;x=t;y=C}a=y;o=x;d=w}if((r|0)==10){f[j>>2]=d;w=d;d=o;while(1){if((d|0)==(f[g>>2]|0))break;o=f[d>>2]|0;x=ANa(f[p>>2]|0)|0;y=HLa(w,o,l)|0;if(x|0)ANa(x)|0;if((y|0)==-1)break;x=(f[j>>2]|0)+y|0;f[j>>2]=x;w=x;d=d+4|0}f[g>>2]=d;v=2;r=32}else if((r|0)==31){v=z;r=32}else if((r|0)==33){q=f[g>>2]|0;r=35}if((r|0)==32)D=v;else if((r|0)==35)D=(q|0)!=(e|0)&1;u=k;return D|0}function UVa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;k=u;u=u+16|0;l=k;m=d;while(1){if((m|0)==(e|0)){n=e;break}if(!(b[m>>0]|0)){n=m;break}m=m+1|0}f[j>>2]=h;f[g>>2]=d;m=i;o=a+8|0;a=n;n=d;d=h;while(1){if((d|0)==(i|0)|(n|0)==(e|0)){p=n;q=32;break}h=c;r=f[h+4>>2]|0;s=l;f[s>>2]=f[h>>2];f[s+4>>2]=r;t=a;r=ANa(f[o>>2]|0)|0;s=XMa(d,g,t-n|0,m-d>>2,c)|0;if(r|0)ANa(r)|0;if((s|0)==-1){v=n;w=d;q=10;break}r=(f[j>>2]|0)+(s<<2)|0;f[j>>2]=r;if((r|0)==(i|0)){q=29;break}s=f[g>>2]|0;if((a|0)==(e|0)){x=r;y=s;z=e}else{h=ANa(f[o>>2]|0)|0;A=mMa(r,s,1,c)|0;if(h|0)ANa(h)|0;if(A|0){B=2;q=28;break}f[j>>2]=(f[j>>2]|0)+4;A=(f[g>>2]|0)+1|0;f[g>>2]=A;h=A;while(1){if((h|0)==(e|0)){C=e;break}if(!(b[h>>0]|0)){C=h;break}h=h+1|0}x=f[j>>2]|0;y=A;z=C}a=z;n=y;d=x}do if((q|0)==10){a:while(1){q=0;f[j>>2]=w;if((v|0)==(f[g>>2]|0)){q=18;break}x=ANa(f[o>>2]|0)|0;d=mMa(w,v,t-v|0,l)|0;if(x|0)ANa(x)|0;switch(d|0){case -1:{q=15;break a;break}case -2:{q=16;break a;break}case 0:{D=1;break}default:D=d}v=v+D|0;w=(f[j>>2]|0)+4|0;q=10}if((q|0)==15){f[g>>2]=v;B=2;q=28;break}else if((q|0)==16){f[g>>2]=v;B=1;q=28;break}else if((q|0)==18){f[g>>2]=v;B=(v|0)!=(e|0)&1;q=28;break}}else if((q|0)==29){p=f[g>>2]|0;q=32}while(0);if((q|0)==28)E=B;else if((q|0)==32)E=(p|0)!=(e|0)&1;u=k;return E|0}function VVa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h;f[g>>2]=d;d=ANa(f[a+8>>2]|0)|0;a=HLa(i,0,c)|0;if(d|0)ANa(d)|0;a:do switch(a|0){case 0:case -1:{j=2;break}default:{d=a+-1|0;if(d>>>0>(e-(f[g>>2]|0)|0)>>>0)j=1;else{c=d;d=i;while(1){if(!c){j=0;break a}k=b[d>>0]|0;l=f[g>>2]|0;f[g>>2]=l+1;b[l>>0]=k;c=c+-1|0;d=d+1|0}}}}while(0);u=h;return j|0}function WVa(a){a=a|0;var b=0,c=0,d=0;b=a+8|0;a=ANa(f[b>>2]|0)|0;c=pMa(0,0,4)|0;if(a|0)ANa(a)|0;if(!c){c=f[b>>2]|0;if(!c)d=1;else{b=ANa(c)|0;c=aNa()|0;if(b|0)ANa(b)|0;return (c|0)==1|0}}else d=-1;return d|0}function XVa(a){a=a|0;return 0}function YVa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=d;h=a+8|0;a=c;c=0;i=0;a:while(1){if((a|0)==(d|0)|i>>>0>=e>>>0)break;j=ANa(f[h>>2]|0)|0;k=ZMa(a,g-a|0,b)|0;if(j|0)ANa(j)|0;switch(k|0){case -2:case -1:{break a;break}case 0:{l=1;break}default:l=k}a=a+l|0;c=l+c|0;i=i+1|0}return c|0}function ZVa(a){a=a|0;var b=0,c=0;b=f[a+8>>2]|0;if(b){a=ANa(b)|0;b=aNa()|0;if(!a)c=b;else{ANa(a)|0;c=b}}else c=1;return c|0}function _Va(a){a=a|0;var b=0,c=0;f[a>>2]=129904;b=a+8|0;c=f[b>>2]|0;if((c|0)!=(EQa()|0))ENa(f[b>>2]|0);hQa(a);return}function $Va(a){a=a|0;_Va(a);PYa(a);return}function aWa(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;b=u;u=u+16|0;a=b+4|0;j=b;f[a>>2]=c;f[j>>2]=g;k=jWa(c,d,a,g,h,j,1114111,0)|0;f[e>>2]=f[a>>2];f[i>>2]=f[j>>2];u=b;return k|0}function bWa(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;b=u;u=u+16|0;a=b+4|0;j=b;f[a>>2]=c;f[j>>2]=g;k=iWa(c,d,a,g,h,j,1114111,0)|0;f[e>>2]=f[a>>2];f[i>>2]=f[j>>2];u=b;return k|0}function cWa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f[e>>2]=c;return 3}function dWa(a){a=a|0;return 0}function eWa(a){a=a|0;return 0}function fWa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return hWa(c,d,e,1114111,0)|0}function gWa(a){a=a|0;return 4}function hWa(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=c;i=a;if(((g-i|0)>2&(f&4|0)!=0?(b[a>>0]|0)==-17:0)?(b[a+1>>0]|0)==-69:0){j=(b[a+2>>0]|0)==-65?a+3|0:a;k=0}else{j=a;k=0}a:while(1){if(!(k>>>0<d>>>0&j>>>0<c>>>0)){l=31;break}a=b[j>>0]|0;f=a&255;if(f>>>0>e>>>0){l=31;break}m=j+1|0;do if(a<<24>>24<=-1){if((a&255)<194){l=31;break a}n=j+2|0;o=j;p=g-o|0;if((a&255)<224){if((p|0)<2){l=31;break a}q=h[m>>0]|0;if((q&192|0)!=128){l=31;break a}if((q&63|f<<6&1984)>>>0>e>>>0){l=31;break a}else{r=n;s=k;break}}q=j+3|0;if((a&255)<240){if((p|0)<3){l=31;break a}t=b[n>>0]|0;u=h[m>>0]|0;v=u&224;switch(a<<24>>24){case -32:{if((v|0)!=160){w=o;break a}break}case -19:{if((v|0)!=128){w=o;break a}break}default:if((u&192|0)!=128){w=o;break a}}v=t&255;if((v&192|0)!=128){l=31;break a}if((u<<6&4032|f<<12&61440|v&63)>>>0>e>>>0){l=31;break a}else{r=q;s=k;break}}if((a&255)>=245){l=31;break a}if((d-k|0)>>>0<2|(p|0)<4){l=31;break a}p=b[m>>0]|0;v=b[n>>0]|0;n=b[q>>0]|0;q=p&255;switch(a<<24>>24){case -16:{if((p+112&255)>=48){w=o;break a}break}case -12:{if((q&240|0)!=128){w=o;break a}break}default:if((q&192|0)!=128){w=o;break a}}o=v&255;if((o&192|0)!=128){l=31;break a}v=n&255;if((v&192|0)!=128){l=31;break a}if((q<<12&258048|f<<18&1835008|o<<6&4032|v&63)>>>0>e>>>0){l=31;break a}else{r=j+4|0;s=k+1|0}}else{r=m;s=k}while(0);j=r;k=s+1|0}if((l|0)==31)w=j;return w-i|0}function iWa(a,c,e,g,i,j,k,l){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f[e>>2]=a;f[j>>2]=g;g=c;if((((l&4|0?(l=f[e>>2]|0,(g-l|0)>2):0)?(b[l>>0]|0)==-17:0)?(b[l+1>>0]|0)==-69:0)?(b[l+2>>0]|0)==-65:0)f[e>>2]=l+3;l=i;a:while(1){a=f[e>>2]|0;m=a>>>0<c>>>0;if(!m){n=40;break}o=f[j>>2]|0;if(o>>>0>=i>>>0){n=40;break}p=b[a>>0]|0;q=p&255;if(q>>>0>k>>>0){r=2;break}s=a+1|0;do if(p<<24>>24>-1){d[o>>1]=p&255;t=s}else{if((p&255)<194){r=2;break a}u=g-a|0;v=a+2|0;if((p&255)<224){if((u|0)<2){r=1;break a}w=h[s>>0]|0;if((w&192|0)!=128){r=2;break a}x=w&63|q<<6&1984;if(x>>>0>k>>>0){r=2;break a}d[o>>1]=x;t=v;break}x=a+3|0;if((p&255)<240){if((u|0)<3){r=1;break a}w=b[v>>0]|0;y=h[s>>0]|0;z=y&224;switch(p<<24>>24){case -32:{if((z|0)!=160){r=2;break a}break}case -19:{if((z|0)!=128){r=2;break a}break}default:if((y&192|0)!=128){r=2;break a}}z=w&255;if((z&192|0)!=128){r=2;break a}w=y<<6&4032|q<<12|z&63;if((w&65535)>>>0>k>>>0){r=2;break a}d[o>>1]=w;t=x;break}if((p&255)>=245){r=2;break a}if((u|0)<4){r=1;break a}u=b[s>>0]|0;w=b[v>>0]|0;v=b[x>>0]|0;x=u&255;switch(p<<24>>24){case -16:{if((u+112&255)>=48){r=2;break a}break}case -12:{if((x&240|0)!=128){r=2;break a}break}default:if((x&192|0)!=128){r=2;break a}}u=w&255;if((u&192|0)!=128){r=2;break a}w=v&255;if((w&192|0)!=128){r=2;break a}if((l-o|0)<4){r=1;break a}v=q&7;z=u<<6;y=w&63;if((x<<12&258048|v<<18|z&4032|y)>>>0>k>>>0){r=2;break a}d[o>>1]=x<<2&60|u>>>4&3|((x>>>4&3|v<<2)<<6)+16320|55296;v=o+2|0;f[j>>2]=v;d[v>>1]=y|z&960|56320;t=(f[e>>2]|0)+4|0}while(0);f[e>>2]=t;f[j>>2]=(f[j>>2]|0)+2}if((n|0)==40)r=m&1;return r|0}function jWa(a,c,e,g,h,i,k,l){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f[e>>2]=a;f[i>>2]=g;a=h;if(l&2)if((a-g|0)<3)m=1;else{f[i>>2]=g+1;b[g>>0]=-17;g=f[i>>2]|0;f[i>>2]=g+1;b[g>>0]=-69;g=f[i>>2]|0;f[i>>2]=g+1;b[g>>0]=-65;n=4}else n=4;a:do if((n|0)==4){g=c;l=f[e>>2]|0;while(1){if(l>>>0>=c>>>0){m=0;break a}h=d[l>>1]|0;o=h&65535;if(o>>>0>k>>>0){m=2;break a}do if((h&65535)<128){p=f[i>>2]|0;if((a-p|0)<1){m=1;break a}f[i>>2]=p+1;b[p>>0]=h}else{p=o&63;q=(p|128)&255;if((h&65535)<2048){r=f[i>>2]|0;if((a-r|0)<2){m=1;break a}f[i>>2]=r+1;b[r>>0]=o>>>6|192;r=f[i>>2]|0;f[i>>2]=r+1;b[r>>0]=q;break}r=(o>>>12|224)&255;s=(o>>>6&63|128)&255;if((h&65535)<55296){t=f[i>>2]|0;if((a-t|0)<3){m=1;break a}f[i>>2]=t+1;b[t>>0]=r;t=f[i>>2]|0;f[i>>2]=t+1;b[t>>0]=s;t=f[i>>2]|0;f[i>>2]=t+1;b[t>>0]=q;break}if((h&65535)>=56320){if((h&65535)<57344){m=2;break a}t=f[i>>2]|0;if((a-t|0)<3){m=1;break a}f[i>>2]=t+1;b[t>>0]=r;r=f[i>>2]|0;f[i>>2]=r+1;b[r>>0]=s;s=f[i>>2]|0;f[i>>2]=s+1;b[s>>0]=q;break}if((g-l|0)<4){m=1;break a}q=l+2|0;s=j[q>>1]|0;if((s&64512|0)!=56320){m=2;break a}if((a-(f[i>>2]|0)|0)<4){m=1;break a}r=o&960;if(((r<<10)+65536|p<<10|s&1023)>>>0>k>>>0){m=2;break a}f[e>>2]=q;q=(r>>>6)+1|0;r=f[i>>2]|0;f[i>>2]=r+1;b[r>>0]=q>>>2|240;r=f[i>>2]|0;f[i>>2]=r+1;b[r>>0]=o>>>2&15|q<<4&48|128;q=f[i>>2]|0;f[i>>2]=q+1;b[q>>0]=o<<4&48|s>>>6&15|128;q=f[i>>2]|0;f[i>>2]=q+1;b[q>>0]=s&63|128}while(0);o=(f[e>>2]|0)+2|0;f[e>>2]=o;l=o}}while(0);return m|0}function kWa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=129952;b=a+8|0;c=a+12|0;d=0;while(1){e=f[b>>2]|0;if(d>>>0>=(f[c>>2]|0)-e>>2>>>0)break;g=f[e+(d<<2)>>2]|0;if(g|0)KYa(g)|0;d=d+1|0}_Ya(a+144|0);mWa(b);hQa(a);return}function lWa(a){a=a|0;kWa(a);PYa(a);return}function mWa(a){a=a|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;do if(c|0){d=a+4|0;e=f[d>>2]|0;while(1){if((e|0)==(c|0))break;g=e+-4|0;f[d>>2]=g;e=g}if((a+16|0)==(c|0)){b[a+128>>0]=0;break}else{PYa(c);break}}while(0);return}function nWa(a){a=a|0;var c=0;f[a>>2]=129972;c=f[a+8>>2]|0;if(c|0?b[a+12>>0]|0:0)QYa(c);hQa(a);return}function oWa(a){a=a|0;nWa(a);PYa(a);return}function pWa(a,b){a=a|0;b=b|0;var c=0;if(b<<24>>24>-1){a=(yWa()|0)+((b&255)<<2)|0;c=f[a>>2]&255}else c=b;return c|0}function qWa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;a=c;while(1){if((a|0)==(d|0))break;c=b[a>>0]|0;if(c<<24>>24>-1){e=yWa()|0;g=f[e+(b[a>>0]<<2)>>2]&255}else g=c;b[a>>0]=g;a=a+1|0}return d|0}function rWa(a,b){a=a|0;b=b|0;var c=0;if(b<<24>>24>-1){a=(xWa()|0)+(b<<24>>24<<2)|0;c=f[a>>2]&255}else c=b;return c|0}function sWa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;a=c;while(1){if((a|0)==(d|0))break;c=b[a>>0]|0;if(c<<24>>24>-1){e=xWa()|0;g=f[e+(b[a>>0]<<2)>>2]&255}else g=c;b[a>>0]=g;a=a+1|0}return d|0}function tWa(a,b){a=a|0;b=b|0;return b|0}function uWa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;a=e;e=c;while(1){if((e|0)==(d|0))break;b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}return d|0}function vWa(a,b,c){a=a|0;b=b|0;c=c|0;return (b<<24>>24>-1?b:c)|0}function wWa(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;a=f;f=c;while(1){if((f|0)==(d|0))break;c=b[f>>0]|0;b[a>>0]=c<<24>>24>-1?c:e;a=a+1|0;f=f+1|0}return d|0}function xWa(){var a=0;a=eNa()|0;return f[a>>2]|0}function yWa(){var a=0;a=_Ma()|0;return f[a>>2]|0}function zWa(){var a=0;a=cNa()|0;return f[a>>2]|0}function AWa(a){a=a|0;f[a>>2]=130024;_Ya(a+12|0);hQa(a);return}function BWa(a){a=a|0;AWa(a);PYa(a);return}function CWa(a){a=a|0;return b[a+8>>0]|0}function DWa(a){a=a|0;return b[a+9>>0]|0}function EWa(a,b){a=a|0;b=b|0;YYa(a,b+12|0);return}
function aW(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0.0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0;h=u;u=u+6352|0;i=h+1200|0;j=h+1184|0;k=h+1168|0;l=h+1152|0;m=h+1136|0;n=h+1120|0;o=h+1104|0;q=h+1088|0;r=h+1072|0;t=h+1056|0;v=h+1040|0;w=h+1024|0;x=h;y=h+1224|0;z=h+1216|0;A=h+1212|0;F1a(y|0,0,5120)|0;f[z>>2]=0;B=b[c>>0]|0;C=c+1|0;D=b[C>>0]|0;E=(e&8|0)!=0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;a:do if(B<<24>>24==33){switch(D<<24>>24){case 94:case 33:{F=C;G=16;break}default:{F=c;G=0}}b:do if(D<<24>>24==60){e=F+1|0;H=e;c:while(1){I=H+1|0;J=b[I>>0]|0;if((J&255)<32){K=e;L=G;break b}switch(J<<24>>24){case 32:{K=e;L=G;break b;break}case 62:{break c;break}default:H=I}}if((I-e|0)>>>0>19?(yKa(e,180791,19)|0)==0:0){b[I>>0]=32;K=F+19|0;L=16}else{K=e;L=G}}else{K=F;L=G}while(0);f[z>>2]=K;H=K;do{H=H+1|0;f[z>>2]=H;M=b[H>>0]|0}while((M&255)>=33);J=K+1|0;N=H-J|0;do if(!N){O=f[a+88>>2]|0;f[w>>2]=f[a+60>>2];f[w+4>>2]=O;f[w+8>>2]=180811;SLa(x,178874,w)|0;T$(-212,180827,x,177754,1503);O=f[z>>2]|0;P=b[O>>0]|0;b[O>>0]=0;if(!(L&16)){Q=P;R=0;S=L}else{T=P;U=28}}else{b[H>>0]=0;P=(L&16|0)!=0;if(!(P|(N|0)!=3)){if(!(yKa(J,180844,3)|0)){Q=M;R=0;S=3;break}if(!(yKa(J,374460,3)|0)){Q=M;R=0;S=1;break}if(!(yKa(J,180848,3)|0)){Q=M;R=0;S=5;break}O=(yKa(J,180852,3)|0)==0;Q=M;R=0;S=O?6:L;break}if(!(P|(N|0)!=5)){O=(yKa(J,374506,5)|0)==0;Q=M;R=0;S=O?2:L;break}if((N|0)!=6|P^1)if(P){T=M;U=28;break}else{Q=M;R=0;S=L;break}if(!(yKa(J,178191,6)|0)){b[f[z>>2]>>0]=M;P=f[z>>2]|0;while(1){O=P+1|0;f[z>>2]=O;if((b[O>>0]|0)==32)P=O;else break}e=P+2|0;f[z>>2]=e;O=b[e>>0]|0;b[e>>0]=0;Q=O;R=1;S=5}else{Q=M;R=0;S=L}}while(0);d:do if((U|0)==28){N=f[225394]|0;e:do if(N|0){H=N;while(1){if(!(KKa(f[H+16>>2]|0,J)|0))break;O=f[H+12>>2]|0;if(!O)break e;else H=O}f[d+4>>2]=H;Q=T;R=0;S=L;break d}while(0);f[d+4>>2]=0;f[d>>2]=f[d>>2]&-17;Q=T;R=0;S=L}while(0);b[f[z>>2]>>0]=Q;J=$V(a,f[z>>2]|0,g)|0;N=b[J>>0]|0;f:do if(!(S&16)){switch(S|0){case 1:{V=J;U=47;break a;break}case 2:{W=J;U=46;break a;break}case 3:break;default:{U=37;break f}}switch(N<<24>>24){case 34:case 39:break;default:{X=J;Y=3;U=104;break a}}if(!R){Z=N;_=Q;$=J;aa=3;U=39;break a}}else U=37;while(0);if((U|0)==37?!R:0){Z=N;_=Q;$=J;aa=S;U=39;break}ba=GW(a,J,J-(f[a+76>>2]|0)|0,d)|0;u=h;return ba|0}else{Z=B;_=D;$=c;aa=0;U=39}while(0);g:do if((U|0)==39){h:do if((Z+-48&255)<10)ca=Z;else{switch(Z<<24>>24){case 43:case 45:{if(_<<24>>24==46|(_+-48&255)<10){ca=Z;break h}else U=77;break}case 46:{if((_+-48&255)<10|((_&-33)+-65&255)<26){ca=46;break h}else da=46;break}case 34:case 39:{f[d>>2]=3;c=a+60|0;D=a+88|0;i:do if(Z<<24>>24==39){B=0;S=$;while(1){Q=S+1|0;R=b[Q>>0]|0;j:do if(!((R+-48&255)<10|((R&-33)+-65&255)<26)){L=R;T=Q;M=S;while(1){if(L<<24>>24!=39&(L&255)>31){ea=L;fa=T;break j}if(L<<24>>24==39)break;w=f[D>>2]|0;f[t>>2]=f[c>>2];f[t+4>>2]=w;f[t+8>>2]=180856;SLa(x,178874,t)|0;T$(-212,180827,x,177754,1622);w=T+1|0;K=b[w>>0]|0;if((K+-48&255)<10|((K&-33)+-65&255)<26){ea=K;fa=w;break j}else{G=T;L=K;T=w;M=G}}T=M+2|0;if((b[T>>0]|0)==39){ea=39;fa=T}else{ga=B;ha=T;break i}}else{ea=R;fa=Q}while(0);Q=B+1|0;b[y+B>>0]=ea;if((Q|0)<4096){B=Q;S=fa}else{ia=Q;ja=fa;U=75;break}}}else{S=0;B=$;k:while(1){H=B+1|0;Q=b[H>>0]|0;l:do if((Q+-48&255)<10|((Q&-33)+-65&255)<26)U=60;else{switch(Q<<24>>24){case 34:{break k;break}case 92:break;default:{if((Q&255)>31){U=60;break l}R=f[D>>2]|0;f[r>>2]=f[c>>2];f[r+4>>2]=R;f[r+8>>2]=180856;SLa(x,178874,r)|0;T$(-212,180827,x,177754,1665);ka=S;la=H;break l}}R=B+2|0;T=b[R>>0]|0;switch(T<<24>>24){case 39:{b[y+S>>0]=39;ka=S+1|0;la=R;break l;break}case 92:case 34:{b[y+S>>0]=T;ka=S+1|0;la=R;break l;break}case 110:{b[y+S>>0]=10;ka=S+1|0;la=R;break l;break}case 114:{b[y+S>>0]=13;ka=S+1|0;la=R;break l;break}case 116:{b[y+S>>0]=9;ka=S+1|0;la=R;break l;break}default:{L=T<<24>>24==120;if(!L?!(T<<24>>24<56&(T+-48&255)<10):0){ka=S;la=R;break l}T=B+5|0;G=b[T>>0]|0;b[T>>0]=0;w=R+(L&1)|0;K=lNa(w,z,L?8:16)|0;b[T>>0]=G;G=f[z>>2]|0;T=S+1|0;if((G|0)==(w|0)){b[y+S>>0]=120;ka=T;la=R;break l}else{b[y+S>>0]=K;ka=T;la=G;break l}}}}while(0);if((U|0)==60){U=0;b[y+S>>0]=Q;ka=S+1|0;la=H}if((ka|0)<4096){S=ka;B=la}else{ia=ka;ja=la;U=75;break i}}ga=S;ha=B+2|0}while(0);if((U|0)==75){G=f[D>>2]|0;f[q>>2]=f[c>>2];f[q+4>>2]=G;f[q+8>>2]=180874;SLa(x,178874,q)|0;T$(-212,180827,x,177754,1669);ga=ia;ha=ja}xL(x,f[a+16>>2]|0,y,ga);G=d+8|0;p[s>>3]=+p[x>>3];f[G>>2]=f[s>>2];f[G+4>>2]=f[s+4>>2];ba=ha;u=h;return ba|0}default:U=77}m:do if((U|0)==77){G=Z<<24>>24==91;switch(Z<<24>>24){case 91:case 123:break;default:if(Z<<24>>24==45&(E^1)){ma=$;na=5;break g}else{da=Z;break m}}T=((E^1)&1)+g|0;K=Z<<24>>24==123?14:13;R=K&7;DW(a,(f[d+4>>2]|0?16:0)|R,d);w=d+8|0;L=(R|0)==6;R=x+4|0;F=a+60|0;I=a+88|0;C=1;P=$+1|0;n:while(1){f[A>>2]=0;oa=$V(a,P,T)|0;pa=b[oa>>0]|0;switch(pa<<24>>24){case 93:case 125:{U=80;break n;break}default:{}}if(!(f[(f[w>>2]|0)+24>>2]|0))qa=oa;else{if(pa<<24>>24!=44){O=f[I>>2]|0;f[n>>2]=f[F>>2];f[n+4>>2]=O;f[n+8>>2]=180924;SLa(x,178874,n)|0;T$(-212,180827,x,177754,1700)}qa=$V(a,oa+1|0,T)|0}if(L){O=$V(a,HW(a,qa,d,A)|0,T)|0;e=f[A>>2]|0;ra=e;sa=e;ta=O}else{if((b[qa>>0]|0)==93){ua=qa;break}O=NL(f[w>>2]|0,0)|0;f[A>>2]=O;ra=O;sa=O;ta=qa}if(!ra){f[x>>2]=0;f[R>>2]=0;O=c$(x,4)|0;b[O>>0]=101;b[O+1>>0]=108;b[O+2>>0]=101;b[O+3>>0]=109;j$(-215,x,180827,177754,1715);d$(x)}O=aW(a,ta,sa,K,T)|0;if(L)f[sa>>2]=f[sa>>2]|64;if(C)va=(f[sa>>2]&7)>>>0<5;else va=0;C=va;P=O}if((U|0)==80){if((pa<<24>>24|0)!=((G?93:125)|0)){P=f[I>>2]|0;f[o>>2]=f[F>>2];f[o+4>>2]=P;f[o+8>>2]=180898;SLa(x,178874,o)|0;T$(-212,180827,x,177754,1692)}ua=oa+1|0}P=f[w>>2]|0;f[P>>2]=f[P>>2]|(C?256:0);ba=ua;u=h;return ba|0}while(0);if(E){X=$;Y=aa;U=104;break g}switch(da<<24>>24){case 63:{c=f[a+88>>2]|0;f[m>>2]=f[a+60>>2];f[m+4>>2]=c;f[m+8>>2]=180955;SLa(x,178874,m)|0;T$(-212,180827,x,177754,1734);X=$;Y=aa;U=104;break g;break}case 62:case 124:{c=f[a+88>>2]|0;f[l>>2]=f[a+60>>2];f[l+4>>2]=c;f[l+8>>2]=180986;SLa(x,178874,l)|0;T$(-212,180827,x,177754,1736);X=$;Y=aa;U=104;break g;break}default:{X=$;Y=aa;U=104;break g}}}while(0);J=$+((ca<<24>>24==45|ca<<24>>24==43)&1)|0;while(1){f[z>>2]=J;wa=b[J>>0]|0;if((wa+-48&255)<10)J=J+1|0;else break}switch(wa<<24>>24){case 101:case 46:{W=$;U=46;break}default:{V=$;U=47}}}while(0);if((U|0)==46){xa=+mW(a,W,z);f[d>>2]=2;p[d+8>>3]=xa;ya=W;U=48}else if((U|0)==47){W=lNa(V,z,0)|0;f[d>>2]=1;f[d+8>>2]=W;ya=V;U=48}else if((U|0)==104){f[z>>2]=X;V=b[X>>0]|0;if((V&255)>31){o:do if(E){W=V;$=X;while(1){switch(W<<24>>24){case 93:case 125:case 44:{za=W;Aa=$;break o;break}default:{}}wa=$+1|0;f[z>>2]=wa;ca=b[wa>>0]|0;if((ca&255)>31){W=ca;$=wa}else{za=ca;Aa=wa;break o}}}else{if((Y|0)==3){$=X;while(1){W=$+1|0;f[z>>2]=W;wa=b[W>>0]|0;if((wa&255)>31)$=W;else{za=wa;Aa=W;break o}}}else{Ba=V;Ca=X}while(1){if(Ba<<24>>24==58){za=58;Aa=Ca;break o}$=Ca+1|0;f[z>>2]=$;W=b[$>>0]|0;if((W&255)>31){Ba=W;Ca=$}else{za=W;Aa=$;break}}}while(0);if((Aa|0)==(X|0)){Da=za;U=113}else Ea=za}else{Da=V;U=113}if((U|0)==113){V=f[a+88>>2]|0;f[k>>2]=f[a+60>>2];f[k+4>>2]=V;f[k+8>>2]=180856;SLa(x,178874,k)|0;T$(-212,180827,x,177754,1748);Ea=Da}if(Ea<<24>>24==58&(E^1)){ma=X;na=6}else{E=f[z>>2]|0;f[d>>2]=3;Ea=E;while(1){E=Ea+-1|0;if(E>>>0<=X>>>0)break;if((b[E>>0]|0)==32)Ea=E;else break}xL(x,f[a+16>>2]|0,X,Ea-X|0);X=d+8|0;p[s>>3]=+p[x>>3];f[X>>2]=f[s>>2];f[X+4>>2]=f[s+4>>2];ba=f[z>>2]|0;u=h;return ba|0}}if((U|0)==48){X=f[z>>2]|0;if(!((X|0)==0|(X|0)==(ya|0))){ba=X;u=h;return ba|0}X=f[a+88>>2]|0;f[v>>2]=f[a+60>>2];f[v+4>>2]=X;f[v+8>>2]=179801;SLa(x,178874,v)|0;T$(-212,180827,x,177754,1601);ba=f[z>>2]|0;u=h;return ba|0}DW(a,(f[d+4>>2]|0?16:0)|na,d);z=a+76|0;v=ma-(f[z>>2]|0)|0;X=(na|0)==6;ya=x+4|0;Ea=v+1|0;E=a+60|0;Da=a+88|0;k=d+8|0;V=1;za=ma;while(1){f[A>>2]=0;if(X){ma=HW(a,za,d,A)|0;Aa=f[A>>2]|0;Fa=Aa;Ga=Aa;Ha=ma}else{if((b[za>>0]|0)!=45){ma=f[Da>>2]|0;f[j>>2]=f[E>>2];f[j+4>>2]=ma;f[j+8>>2]=181029;SLa(x,178874,j)|0;T$(-212,180827,x,177754,1785)}ma=NL(f[k>>2]|0,0)|0;f[A>>2]=ma;Fa=ma;Ga=ma;Ha=za+1|0}if(!Fa){f[x>>2]=0;f[ya>>2]=0;ma=c$(x,4)|0;b[ma>>0]=101;b[ma+1>>0]=108;b[ma+2>>0]=101;b[ma+3>>0]=109;j$(-215,x,180827,177754,1789);d$(x)}ma=aW(a,$V(a,Ha,Ea)|0,Ga,na,Ea)|0;if(X)f[Ga>>2]=f[Ga>>2]|64;if(V)Ia=(f[Ga>>2]&7)>>>0<5;else Ia=0;za=$V(a,ma,0)|0;ma=za-(f[z>>2]|0)|0;if((ma|0)!=(v|0)){if((ma|0)<(v|0)){U=135;break}ma=f[Da>>2]|0;f[i>>2]=f[E>>2];f[i+4>>2]=ma;f[i+8>>2]=181079;SLa(x,178874,i)|0;T$(-212,180827,x,177754,1802)}if(!(yKa(za,374535,3)|0))break;else V=Ia}V=f[k>>2]|0;f[V>>2]=f[V>>2]|(Ia?256:0);ba=za;u=h;return ba|0}function bW(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+1056|0;e=d+16|0;g=d;h=d+32|0;i=a+60|0;j=a+88|0;k=a+76|0;l=a+80|0;m=c;a:while(1){n=b[m>>0]|0;b:do switch(n<<24>>24|0){case 47:{c=m+1|0;o=b[c>>0]|0;if(!(o<<24>>24)){p=f[k>>2]|0;q=CV(a,p,(f[l>>2]|0)-p|0)|0;if(!q){r=26;break a}s=b[q>>0]|0;t=q}else{s=o;t=c}switch(s<<24>>24){case 47:{c=47;o=t;while(1){switch(c<<24>>24){case 13:case 10:{v=0;w=o;break b;break}case 0:{q=f[k>>2]|0;p=CV(a,q,(f[l>>2]|0)-q|0)|0;if(!p){r=26;break a}else x=p;break}default:x=o+1|0}c=b[x>>0]|0;o=x}break}case 42:{o=t+1|0;while(1){c=b[o>>0]|0;if(!(c<<24>>24)){p=f[k>>2]|0;q=CV(a,p,(f[l>>2]|0)-p|0)|0;if(!q){r=26;break a}else{o=q;continue}}q=o+1|0;if(c<<24>>24!=42){o=q;continue}c=b[q>>0]|0;if(!(c<<24>>24)){p=f[k>>2]|0;y=CV(a,p,(f[l>>2]|0)-p|0)|0;if(!y){r=26;break a}z=b[y>>0]|0;A=y}else{z=c;A=q}if(z<<24>>24==47)break;else o=A}v=0;w=A+1|0;break b;break}default:{o=f[j>>2]|0;f[g>>2]=f[i>>2];f[g+4>>2]=o;f[g+8>>2]=180710;SLa(h,178874,g)|0;T$(-212,180741,h,177754,3335);v=0;w=t;break b}}break}case 32:case 9:{v=0;w=m+1|0;break}case 13:case 10:case 0:{o=f[k>>2]|0;q=CV(a,o,(f[l>>2]|0)-o|0)|0;v=(q|0)==0;w=q;break}default:break a}while(0);if(v){r=26;break}else m=w}if((r|0)==26){r=f[k>>2]|0;b[r>>0]=0;f[a+92>>2]=1;B=r;u=d;return B|0}if((n&255)>31){B=m;u=d;return B|0}n=f[j>>2]|0;f[e>>2]=f[i>>2];f[e+4>>2]=n;f[e+8>>2]=180759;SLa(h,178874,e)|0;T$(-212,180741,h,177754,3353);B=m;u=d;return B|0}function cW(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;e=u;u=u+1184|0;g=e+144|0;h=e+128|0;i=e+112|0;j=e+96|0;k=e+80|0;l=e+64|0;m=e+48|0;n=e+32|0;o=e+16|0;p=e+160|0;q=e;if(!c){r=f[a+88>>2]|0;f[o>>2]=f[a+60>>2];f[o+4>>2]=r;f[o+8>>2]=179319;SLa(p,178874,o)|0;T$(-212,180310,p,177754,3733)}if((b[c>>0]|0)==123)s=c+1|0;else{o=f[a+88>>2]|0;f[n>>2]=f[a+60>>2];f[n+4>>2]=o;f[n+8>>2]=180326;SLa(p,178874,n)|0;T$(-212,180310,p,177754,3736);s=c};f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;DW(a,6,d);c=bW(a,s)|0;a:do if(!c){t=p;v=a+60|0;w=a+88|0;x=47}else{s=a+92|0;n=a+60|0;o=a+88|0;r=q+8+4|0;y=d+4|0;z=c;while(1){if(f[s>>2]|0){A=z;break a}do if((b[z>>0]|0)==34){B=z;while(1){C=B+1|0;D=b[C>>0]|0;E=D<<24>>24!=34;if((D&255)<32|E^1)break;else B=C}D=z+1|0;if(E){F=f[o>>2]|0;f[m>>2]=f[n>>2];f[m+4>>2]=F;f[m+8>>2]=180361;SLa(p,178874,m)|0;T$(-212,180383,p,177754,3388)}F=bW(a,B+2|0)|0;if(!F){t=p;v=n;w=o;x=47;break a}if(f[s>>2]|0){t=p;v=n;w=o;x=47;break a}if((b[F>>0]|0)!=58){G=f[o>>2]|0;f[l>>2]=f[n>>2];f[l+4>>2]=G;f[l+8>>2]=180399;SLa(p,178874,l)|0;T$(-212,180383,p,177754,3397)}if(B>>>0<=z>>>0){G=f[o>>2]|0;f[k>>2]=f[n>>2];f[k+4>>2]=G;f[k+8>>2]=180433;SLa(p,178874,k)|0;T$(-212,180383,p,177754,3401)}G=C-D|0;if((G|0)==7?(yKa(D,180446,7)|0)==0:0)H=0;else H=FW(a,d,EW(a,D,G,1)|0,1)|0;G=F+1|0;if(f[s>>2]|0){A=G;break a}F=bW(a,G)|0;if(!F){t=p;v=n;w=o;x=47;break a}if(f[s>>2]|0){A=F;break a}if(H|0){switch(b[F>>0]|0){case 91:{I=dW(a,F,H)|0;break}case 123:{I=cW(a,F,H)|0;break}default:I=eW(a,F,H)|0}f[H>>2]=f[H>>2]|64;J=I;break}G=eW(a,F,q)|0;b:do if((f[q>>2]&7|0)==3){F=f[r>>2]|0;c:do if(F|0){D=f[225394]|0;if(!D)break;else K=D;while(1){if(!(KKa(f[K+16>>2]|0,F)|0))break;D=f[K+12>>2]|0;if(!D)break c;else K=D}f[y>>2]=K;f[d>>2]=f[d>>2]|16;break b}while(0);f[y>>2]=0}else{F=f[o>>2]|0;f[j>>2]=f[n>>2];f[j+4>>2]=F;f[j+8>>2]=180454;SLa(p,178874,j)|0;T$(-212,180310,p,177754,3772)}while(0);J=G}else J=z;while(0);B=bW(a,J)|0;if(!B){t=p;v=n;w=o;x=47;break a}if(f[s>>2]|0){A=B;break a}switch(b[B>>0]|0){case 125:{A=B;break a;break}case 44:{L=B+1|0;break}default:{F=f[o>>2]|0;f[i>>2]=f[n>>2];f[i+4>>2]=F;f[i+8>>2]=179382;SLa(p,178874,i)|0;T$(-212,180310,p,177754,3796);L=B}}z=bW(a,L)|0;if(!z){t=p;v=n;w=o;x=47;break a}}}while(0);if((x|0)==47){x=f[w>>2]|0;f[h>>2]=f[v>>2];f[h+4>>2]=x;f[h+8>>2]=179319;SLa(t,178874,h)|0;T$(-212,180310,t,177754,3800);A=0}if((b[A>>0]|0)==125){M=A+1|0;u=e;return M|0}else{t=f[a+88>>2]|0;f[g>>2]=f[a+60>>2];f[g+4>>2]=t;f[g+8>>2]=180489;SLa(p,178874,g)|0;T$(-212,180310,p,177754,3803);M=A;u=e;return M|0}return 0}function dW(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+1104|0;g=e+64|0;h=e+48|0;i=e+32|0;j=e+16|0;k=e;l=e+80|0;if(!c){m=f[a+88>>2]|0;f[k>>2]=f[a+60>>2];f[k+4>>2]=m;f[k+8>>2]=179319;SLa(l,178874,k)|0;T$(-212,179331,l,177754,3679)}if((b[c>>0]|0)==91)n=c+1|0;else{k=f[a+88>>2]|0;f[j>>2]=f[a+60>>2];f[j+4>>2]=k;f[j+8>>2]=179347;SLa(l,178874,j)|0;T$(-212,179331,l,177754,3682);n=c};f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;c=yL(0,56,16,f[a+16>>2]|0)|0;if(f[d>>2]&7|0)NL(c,d)|0;j=d+8|0;f[j>>2]=c;f[d>>2]=5;zL(c,8);c=bW(a,n)|0;a:do if(!c){o=l;p=a+60|0;q=a+88|0;r=23}else{n=a+92|0;d=a+60|0;k=a+88|0;m=c;while(1){if(f[n>>2]|0){s=m;break a}b:do if((b[m>>0]|0)==93)t=m;else{v=NL(f[j>>2]|0,0)|0;switch(b[m>>0]|0){case 91:{t=dW(a,m,v)|0;break b;break}case 123:{t=cW(a,m,v)|0;break b;break}default:{t=eW(a,m,v)|0;break b}}}while(0);v=bW(a,t)|0;if(!v){o=l;p=d;q=k;r=23;break a}if(f[n>>2]|0){s=v;break a}switch(b[v>>0]|0){case 93:{s=v;break a;break}case 44:{w=v+1|0;break}default:{x=f[k>>2]|0;f[i>>2]=f[d>>2];f[i+4>>2]=x;f[i+8>>2]=179382;SLa(l,178874,i)|0;T$(-212,179331,l,177754,3716);w=v}}m=bW(a,w)|0;if(!m){o=l;p=d;q=k;r=23;break a}}}while(0);if((r|0)==23){r=f[q>>2]|0;f[h>>2]=f[p>>2];f[h+4>>2]=r;f[h+8>>2]=179319;SLa(o,178874,h)|0;T$(-212,179331,o,177754,3720);s=0}if((b[s>>0]|0)==93){y=s+1|0;u=e;return y|0}else{o=f[a+88>>2]|0;f[g>>2]=f[a+60>>2];f[g+4>>2]=o;f[g+8>>2]=179403;SLa(l,178874,g)|0;T$(-212,179331,l,177754,3723);y=s;u=e;return y|0}return 0}function eW(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;e=u;u=u+1328|0;g=e+1264|0;i=e+1248|0;j=e+1232|0;k=e+1216|0;l=e+1200|0;m=e+1184|0;n=e+1168|0;o=e+1152|0;q=e+1136|0;r=e+1120|0;t=e+1104|0;v=e+1088|0;w=e+1072|0;x=e+1056|0;y=e+1040|0;z=e+1024|0;A=e;B=e+1300|0;C=e+1304|0;D=e+1288|0;E=e+1276|0;F=bW(a,c)|0;f[B>>2]=F;if((F|0)!=0?(f[a+92>>2]|0)==0:0)G=F;else H=3;if((H|0)==3){F=f[a+88>>2]|0;f[z>>2]=f[a+60>>2];f[z+4>>2]=F;f[z+8>>2]=179296;SLa(A,178874,z)|0;T$(-212,179439,A,177754,3421);G=f[B>>2]|0};f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;z=b[G>>0]|0;if(z<<24>>24!=34){a:do if((z+-48&255)<10)switch(z<<24>>24){case 45:case 43:{H=108;break}default:{I=G;J=z}}else{switch(z<<24>>24){case 45:case 43:{H=108;break a;break}case 46:{I=G;J=z;break a;break}default:{}}if(((z&-33)+-65&255)<26){F=G;c=0;do{c=c+1|0;F=F+1|0;f[B>>2]=F}while(c>>>0<7?((b[F>>0]&-33)+-65&255)<26:0);if(c>>>0>3){if(!(yKa(G,179867,4)|0)){F=f[a+88>>2]|0;f[i>>2]=f[a+60>>2];f[i+4>>2]=F;f[i+8>>2]=179872;SLa(A,178874,i)|0;T$(-212,179439,A,177754,3652);K=f[B>>2]|0;u=e;return K|0}if(!(yKa(G,374219,4)|0)){f[d+8>>2]=1;f[d>>2]=1;K=f[B>>2]|0;u=e;return K|0}if(c>>>0>4?(yKa(G,374213,5)|0)==0:0){f[d+8>>2]=0;f[d>>2]=1;K=f[B>>2]|0;u=e;return K|0}}}F=f[a+88>>2]|0;f[g>>2]=f[a+60>>2];f[g+4>>2]=F;f[g+8>>2]=179917;SLa(A,178874,g)|0;T$(-212,179439,A,177754,3666);K=f[B>>2]|0;u=e;return K|0}while(0);if((H|0)==108){g=G+1|0;f[B>>2]=g;I=g;J=b[g>>0]|0}if((J+-48&255)<10){g=I;do{g=g+1|0;f[B>>2]=g;I=b[g>>0]|0}while((I+-48&255)<10);L=I}else L=J;switch(L<<24>>24){case 101:case 46:{M=+mW(a,G,B);p[d+8>>3]=M;N=2;break}default:{L=lNa(G,B,0)|0;f[d+8>>2]=L;N=1}}f[d>>2]=N;if(G>>>0<(f[B>>2]|0)>>>0){K=f[B>>2]|0;u=e;return K|0}N=f[a+88>>2]|0;f[j>>2]=f[a+60>>2];f[j+4>>2]=N;f[j+8>>2]=179801;SLa(A,178874,j)|0;T$(-212,179439,A,177754,3641);K=f[B>>2]|0;u=e;return K|0}j=G+1|0;N=j;L=0;while(1){f[B>>2]=N;J=b[N>>0]|0;if((J+-48&255)<10|((J&-33)+-65&255)<26){if(L>>>0>=10){H=11;break}}else if(!(L>>>0<10&J<<24>>24==36)){H=10;break}N=N+1|0;L=L+1|0}if((H|0)==10?L>>>0>7:0)H=11;if((H|0)==11?(yKa(j,179457,8)|0)==0:0){L=G+9|0;f[B>>2]=L;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;dZa(C,131072);G=a+60|0;N=a+88|0;J=a+76|0;g=a+80|0;I=f[B>>2]|0;i=L;b:while(1){O=I;c:while(1)switch(b[O>>0]|0){case 34:{break b;break}case 0:{break c;break}case 13:case 10:{L=f[N>>2]|0;f[x>>2]=f[G>>2];f[x+4>>2]=L;f[x+8>>2]=179466;SLa(A,178874,x)|0;T$(-212,179439,A,177754,3466);O=f[B>>2]|0;continue c;break}default:{L=O+1|0;f[B>>2]=L;O=L;continue c}}fW(C,i,O)|0;c=f[J>>2]|0;L=CV(a,c,(f[g>>2]|0)-c|0)|0;f[B>>2]=L;if(!L){L=f[N>>2]|0;f[y>>2]=f[G>>2];f[y+4>>2]=L;f[y+8>>2]=179466;SLa(A,178874,y)|0;T$(-212,179439,A,177754,3451)}L=f[B>>2]|0;I=L;i=L}fW(C,i,O)|0;O=f[B>>2]|0;if((b[O>>0]|0)==34)f[B>>2]=O+1;else{O=f[N>>2]|0;f[w>>2]=f[G>>2];f[w+4>>2]=O;f[w+8>>2]=179466;SLa(A,178874,w)|0;T$(-212,179439,A,177754,3478)}w=C+11|0;O=b[w>>0]|0;i=O<<24>>24<0;I=C+4|0;y=f[I>>2]|0;g=O&255;O=i?y:g;do if(O>>>0>31){J=i?f[C>>2]|0:C;x=J+(i?y:g)|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[E>>2]=0;L=E+4|0;f[L>>2]=0;f[E+8>>2]=0;c=NYa(25)|0;f[E>>2]=c;z=c+25|0;f[E+8>>2]=z;F=c;P=F+25|0;do{b[F>>0]=32;F=F+1|0}while((F|0)<(P|0));f[L>>2]=z;if(J|0){F=J+32|0;P=J+4|0;Q=(((F>>>0>P>>>0?F:P)+~J|0)>>>2)*3|0;P=c;F=0;while(1){R=J+F|0;F=F+4|0;S=b[179505+(h[R+3>>0]|0)>>0]|0;T=h[179505+(h[R+2>>0]|0)>>0]|0;U=h[179505+(h[R+1>>0]|0)>>0]|0;b[P>>0]=U>>>4&3|h[179505+(h[R>>0]|0)>>0]<<2;b[P+1>>0]=T>>>2&15|U<<4;b[P+2>>0]=S&255|T<<6;if((F|0)>=32)break;else P=P+3|0}b[c+(Q+3)>>0]=0}if(!(gW(E,D)|0?(P=b[D+11>>0]|0,((P<<24>>24<0?f[D+4>>2]|0:P&255)|0)!=0):0)){P=f[N>>2]|0;f[v>>2]=f[G>>2];f[v+4>>2]=P;f[v+8>>2]=179632;SLa(A,178874,v)|0;T$(-212,179439,A,177754,3493)}P=f[E>>2]|0;if(P|0){if((f[L>>2]|0)!=(P|0))f[L>>2]=P;PYa(P)}P=iZa(C,32)|0;F=b[w>>0]|0;if((F<<24>>24<0?f[I>>2]|0:F&255)>>>0>32){F=x-P|0;if(!F){J=xKa(P)|0;if(!J)H=45;else{V=J;H=38}}else{V=F;H=38}d:do if((H|0)==38)if((V|0)!=0&(V&3|0)==0){J=P+V|0;z=J+-1|0;if((b[z>>0]|0)==61){T=z+-1|0;W=(b[T>>0]|0)==61?T:z}else W=J;if(P>>>0<W>>>0){J=P;do{z=b[J>>0]|0;if((z&255)>126){H=45;break d}J=J+1|0;if(!(z<<24>>24==65|(b[179505+(z&255)>>0]|0)!=0)){H=45;break d}}while(J>>>0<W>>>0)}}else H=45;while(0);if((H|0)==45){L=f[N>>2]|0;f[t>>2]=f[G>>2];f[t+4>>2]=L;f[t+8>>2]=179662;SLa(A,178874,t)|0;T$(-212,179439,A,177754,3502)}L=(F>>>2)*3|0;Q=L+1|0;f[E>>2]=0;c=E+4|0;f[c>>2]=0;f[E+8>>2]=0;if(!Q)X=0;else{if((Q|0)<0)gXa(E);J=NYa(Q)|0;f[c>>2]=J;f[E>>2]=J;f[E+8>>2]=J+Q;z=J;J=Q;do{b[z>>0]=0;z=(f[c>>2]|0)+1|0;f[c>>2]=z;J=J+-1|0}while((J|0)!=0);X=z}J=x;F=0;while(1){J=J+-1|0;if((b[J>>0]|0)!=61)break;else F=F+1|0}J=L-F|0;z=f[E>>2]|0;f[A>>2]=z;f[A+4>>2]=z+(X-z);z=A+8|0;f[z>>2]=0;Q=A+12|0;f[Q>>2]=0;f[A+16>>2]=0;T=NYa(120)|0;f[Q>>2]=T;f[z>>2]=T;f[A+16>>2]=T+120;z=T;T=120;do{b[z>>0]=0;z=(f[Q>>2]|0)+1|0;f[Q>>2]=z;T=T+-1|0}while((T|0)!=0);T=A+20|0;z=A+24|0;Q=A+28|0;F=A+32|0;L=A+36|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;f[T+16>>2]=0;f[T+20>>2]=0;S=NYa(161)|0;f[L>>2]=S;f[F>>2]=S;f[A+40>>2]=S+161;U=S;S=161;do{b[U>>0]=0;U=(f[L>>2]|0)+1|0;f[L>>2]=U;S=S+-1|0}while((S|0)!=0);S=f[F>>2]|0;f[T>>2]=S;f[z>>2]=S;f[Q>>2]=S+120;hW(A,P,x)|0;iW(A)|0;jW(A);S=D+11|0;U=kW((b[S>>0]|0)<0?f[D>>2]|0:D)|0;if((J|0)%(U|0)|0|0){L=f[N>>2]|0;f[r>>2]=f[G>>2];f[r+4>>2]=L;f[r+8>>2]=179683;SLa(A,178874,r)|0;T$(-212,179439,A,177754,3520)}L=yL(0,56,16,f[a+16>>2]|0)|0;if(f[d>>2]&7|0)NL(L,d)|0;R=d+8|0;f[R>>2]=L;f[d>>2]=13;zL(L,8);lW(f[E>>2]|0,(J|0)/(U|0)|0,(b[S>>0]|0)<0?f[D>>2]|0:D,f[R>>2]|0);R=f[E>>2]|0;if(R|0){if((f[c>>2]|0)!=(R|0))f[c>>2]=R;PYa(R)}Y=S}else{S=yL(0,56,16,f[a+16>>2]|0)|0;if(f[d>>2]&7|0)NL(S,d)|0;f[d+8>>2]=S;f[d>>2]=13;zL(S,8);Y=D+11|0}if((b[Y>>0]|0)<0)PYa(f[D>>2]|0)}else{if(O|0){S=f[N>>2]|0;f[q>>2]=f[G>>2];f[q+4>>2]=S;f[q+8>>2]=179716;SLa(A,178874,q)|0;T$(-212,179439,A,177754,3540);break}S=yL(0,56,16,f[a+16>>2]|0)|0;if(f[d>>2]&7|0)NL(S,d)|0;f[d+8>>2]=S;f[d>>2]=13;zL(S,8)}while(0);if((b[w>>0]|0)<0)PYa(f[C>>2]|0);K=f[B>>2]|0;u=e;return K|0};f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;dZa(C,131072);f[B>>2]=j;w=a+60|0;q=a+88|0;G=a+76|0;N=a+80|0;O=j;e:while(1){Z=O;f:while(1)switch(b[Z>>0]|0){case 34:{break e;break}case 92:{break f;break}case 0:{H=94;break f;break}case 13:case 10:{j=f[q>>2]|0;f[l>>2]=f[w>>2];f[l+4>>2]=j;f[l+8>>2]=179466;SLa(A,178874,l)|0;T$(-212,179439,A,177754,3597);Z=f[B>>2]|0;continue f;break}default:{j=Z+1|0;f[B>>2]=j;Z=j;continue f}}if((H|0)==94){H=0;fW(C,O,Z)|0;c=f[G>>2]|0;J=CV(a,c,(f[N>>2]|0)-c|0)|0;f[B>>2]=J;if(J|0){O=J;continue}J=f[q>>2]|0;f[m>>2]=f[w>>2];f[m+4>>2]=J;f[m+8>>2]=179466;SLa(A,178874,m)|0;T$(-212,179439,A,177754,3582);O=f[B>>2]|0;continue}fW(C,O,Z)|0;J=(f[B>>2]|0)+1|0;f[B>>2]=J;c=b[J>>0]|0;switch(c<<24>>24|0){case 39:case 34:case 92:{gZa(C,1,c)|0;break}case 110:{gZa(C,1,10)|0;break}case 114:{gZa(C,1,13)|0;break}case 116:{gZa(C,1,9)|0;break}case 98:{gZa(C,1,8)|0;break}case 102:{gZa(C,1,12)|0;break}case 117:{c=f[q>>2]|0;f[o>>2]=f[w>>2];f[o+4>>2]=c;f[o+8>>2]=179743;SLa(A,178874,o)|0;T$(-212,179439,A,177754,3568);H=92;break}default:H=92}if((H|0)==92){H=0;c=f[q>>2]|0;f[n>>2]=f[w>>2];f[n+4>>2]=c;f[n+8>>2]=179776;SLa(A,178874,n)|0;T$(-212,179439,A,177754,3569)}c=(f[B>>2]|0)+1|0;f[B>>2]=c;O=c}fW(C,O,Z)|0;Z=f[B>>2]|0;if((b[Z>>0]|0)==34)f[B>>2]=Z+1;else{Z=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=Z;f[k+8>>2]=179466;SLa(A,178874,k)|0;T$(-212,179439,A,177754,3609)}k=C+11|0;Z=b[k>>0]|0;w=Z<<24>>24<0;xL(A,f[a+16>>2]|0,w?f[C>>2]|0:C,w?f[C+4>>2]|0:Z&255);Z=d+8|0;p[s>>3]=+p[A>>3];f[Z>>2]=f[s>>2];f[Z+4>>2]=f[s+4>>2];f[d>>2]=3;if((b[k>>0]|0)<0)PYa(f[C>>2]|0);K=f[B>>2]|0;u=e;return K|0}function fW(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+16|0;g=c;h=e;i=a+11|0;j=b[i>>0]|0;k=j<<24>>24<0;if(k){l=f[a+4>>2]|0;m=(f[a+8>>2]&2147483647)+-1|0}else{l=j&255;m=10}n=d-g|0;if(!n){u=e;return a|0}if(k){k=f[a>>2]|0;o=k;p=k;q=f[a+4>>2]|0}else{o=a;p=a;q=j&255}if(o>>>0<=c>>>0&(p+q|0)>>>0>c>>>0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(n>>>0>4294967279)WYa(h);if(n>>>0<11){b[h+11>>0]=n;r=h}else{q=n+16&-16;p=NYa(q)|0;f[h>>2]=p;f[h+8>>2]=q|-2147483648;f[h+4>>2]=n;r=p}if((c|0)==(d|0))s=r;else{p=c;q=r;while(1){b[q>>0]=b[p>>0]|0;p=p+1|0;if((p|0)==(d|0))break;else q=q+1|0}s=r+n|0}b[s>>0]=0;s=h+11|0;r=b[s>>0]|0;q=r<<24>>24<0;jZa(a,q?f[h>>2]|0:h,q?f[h+4>>2]|0:r&255)|0;if((b[s>>0]|0)<0)PYa(f[h>>2]|0);u=e;return a|0}if((m-l|0)>>>0<n>>>0){hZa(a,m,l+n-m|0,l,l,0,0);t=b[i>>0]|0}else t=j;if(t<<24>>24<0)v=f[a>>2]|0;else v=a;t=v+l|0;if((c|0)==(d|0))w=t;else{j=d+(l-g)|0;g=c;c=t;while(1){b[c>>0]=b[g>>0]|0;g=g+1|0;if((g|0)==(d|0))break;else c=c+1|0}w=v+j|0}b[w>>0]=0;w=l+n|0;if((b[i>>0]|0)<0){f[a+4>>2]=w;u=e;return a|0}else{b[i>>0]=w;u=e;return a|0}return 0}function gW(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+160|0;e=d+12|0;g=d;h=f[a>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=xKa(h)|0;if(a>>>0>4294967279)WYa(g);if(a>>>0<11){b[g+11>>0]=a;if(!a)i=g;else{j=g;k=6}}else{l=a+16&-16;m=NYa(l)|0;f[g>>2]=m;f[g+8>>2]=l|-2147483648;f[g+4>>2]=a;j=m;k=6}if((k|0)==6){K1a(j|0,h|0,a|0)|0;i=j}b[i+a>>0]=0;a=e+60|0;i=e+8|0;f[e>>2]=12412;f[a>>2]=12432;f[e+4>>2]=0;$Oa(e+60|0,i);f[e+132>>2]=0;f[e+136>>2]=-1;f[e>>2]=42680;f[a>>2]=42700;ePa(i);f[i>>2]=42524;a=e+40|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[e+56>>2]=8;GU(i,g);if((b[g+11>>0]|0)<0)PYa(f[g>>2]|0);g=CW(e,c)|0;c=(f[g+(f[(f[g>>2]|0)+-12>>2]|0)+16>>2]&5|0)==0;wW(e);u=d;return c|0}function hW(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+16|0;g=e;if(c>>>0>=d>>>0){u=e;return a|0}h=d;i=a+28|0;j=a+24|0;k=g+4|0;l=c;do{c=h-l|0;m=f[j>>2]|0;n=(f[i>>2]|0)-m|0;o=(n|0)<(c|0)?n:c;K1a(m|0,l|0,o|0)|0;l=l+o|0;m=(f[j>>2]|0)+o|0;f[j>>2]=m;if(m>>>0>=(f[i>>2]|0)>>>0?!(iW(a)|0):0){f[g>>2]=0;f[k>>2]=0;m=c$(g,7)|0;b[m>>0]=b[180302]|0;b[m+1>>0]=b[180303]|0;b[m+2>>0]=b[180304]|0;b[m+3>>0]=b[180305]|0;b[m+4>>0]=b[180306]|0;b[m+5>>0]=b[180307]|0;b[m+6>>0]=b[180308]|0;j$(-215,g,345363,177754,7822);d$(g)}}while(l>>>0<d>>>0);u=e;return a|0}function iW(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;d=c;e=a+20|0;g=f[e>>2]|0;h=a+24|0;i=f[h>>2]|0;j=i-g|0;k=i;if(!g){l=0;u=c;return l|0}if(!j)m=xKa(g)|0;else m=j;if(!((m|0)!=0&(m&3|0)==0)){l=0;u=c;return l|0}i=g+m|0;m=i+-1|0;if((b[m>>0]|0)==61){n=m+-1|0;o=(b[n>>0]|0)==61?n:m}else o=i;a:do if(g>>>0<o>>>0){i=g;while(1){m=b[i>>0]|0;if((m&255)>126){l=0;p=18;break}i=i+1|0;if(!(m<<24>>24==65|(b[179505+(m&255)>>0]|0)!=0)){l=0;p=18;break}if(i>>>0>=o>>>0)break a}if((p|0)==18){u=c;return l|0}}while(0);if((k|0)==(g|0)){l=1;u=c;return l|0}k=f[a+32>>2]|0;p=BW(g,k,0,j)|0;f[h>>2]=f[e>>2];if(!p){f[d>>2]=0;f[d+4>>2]=0;e=c$(d,8)|0;h=e;b[h>>0]=108;b[h+1>>0]=101;b[h+2>>0]=110;b[h+3>>0]=32;h=e+4|0;b[h>>0]=33;b[h+1>>0]=61;b[h+2>>0]=32;b[h+3>>0]=48;j$(-215,d,180272,177754,7842);d$(d)}h=f[a>>2]|0;e=a+4|0;j=f[e>>2]|0;if((h+p|0)>>>0<j>>>0){q=h;r=j}else{f[d>>2]=0;f[d+4>>2]=0;j=c$(d,23)|0;h=180278;g=j+23|0;do{b[j>>0]=b[h>>0]|0;j=j+1|0;h=h+1|0}while((j|0)<(g|0));j$(-215,d,180272,177754,7845);d$(d);q=f[a>>2]|0;r=f[e>>2]|0}if((q+p|0)>>>0>=r>>>0){l=1;u=c;return l|0}K1a(q|0,k|0,p|0)|0;f[a>>2]=(f[a>>2]|0)+p;l=1;u=c;return l|0}function jW(a){a=a|0;var b=0,c=0;if((f[a+24>>2]|0)!=(f[a+20>>2]|0))iW(a)|0;b=f[a+32>>2]|0;if(b|0){c=a+36|0;if((f[c>>2]|0)!=(b|0))f[c>>2]=b;PYa(b)}b=f[a+8>>2]|0;if(!b)return;c=a+12|0;if((f[c>>2]|0)!=(b|0))f[c>>2]=b;PYa(b);return}function kW(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=u;u=u+512|0;d=c;e=AW(a,d)|0;g=e<<1;if((e|0)>0){e=0;h=0;do{i=f[d+((e|1)<<2)>>2]|0;j=(i>>>3&511)+1<<(47696>>>(i<<1&14)&3);h=(h+-1+j&0-j)+(Y(j,f[d+(e<<2)>>2]|0)|0)|0;e=e+2|0}while((e|0)<(g|0));k=h+-1|0}else k=-1;h=f[d+4>>2]|0;d=(h>>>3&511)+1<<(47696>>>(h<<1&14)&3);h=k+d&0-d;d=b[a>>0]|0;if(!(d<<24>>24)){l=0;m=h+-1|0;n=m+l|0;o=0-l|0;p=n&o;u=c;return p|0}else{q=d;r=0;s=a}while(1){switch(q<<24>>24|0){case 117:{t=(r|0)==0?1:r;break}case 99:{t=(r|0)==0?1:r;break}case 119:{t=r>>>0>2?r:2;break}case 115:{t=r>>>0>2?r:2;break}case 105:{t=r>>>0>4?r:4;break}case 102:{t=r>>>0>4?r:4;break}case 100:{t=r>>>0>8?r:8;break}default:t=r}s=s+1|0;q=b[s>>0]|0;if(!(q<<24>>24)){l=t;break}else r=t}m=h+-1|0;n=m+l|0;o=0-l|0;p=n&o;u=c;return p|0}function lW(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;i=u;u=u+64|0;k=i+16|0;l=i;m=i+24|0;f[l+4>>2]=0;nW(m,a,c,e);e=m+8|0;c=m+28|0;a=m+20|0;o=m+16|0;q=m+12|0;r=l+8|0;s=l+8|0;while(1){t=f[m>>2]|0;if(t>>>0>=(f[e>>2]|0)>>>0)break;v=k;f[v>>2]=0;f[v+4>>2]=0;v=f[c>>2]|0;$h[f[v+8>>2]&255](t+(f[v+4>>2]|0)|0,k)|0;v=f[c>>2]|0;t=f[v>>2]|0;switch(t|0){case 0:{f[r>>2]=h[k>>0];w=11;break}case 1:{f[r>>2]=b[k>>0];w=11;break}case 2:{f[r>>2]=j[k>>1];w=11;break}case 3:{f[r>>2]=d[k>>1];w=11;break}case 4:{f[r>>2]=f[k>>2];w=11;break}case 5:{p[s>>3]=+n[k>>2];w=11;break}case 6:{p[s>>3]=+p[k>>3];w=11;break}default:x=t}if((w|0)==11){w=0;x=f[v>>2]|0}switch(x|0){case 4:case 3:case 2:case 1:case 0:{y=1;w=14;break}case 6:case 5:{y=2;w=14;break}default:{}}if((w|0)==14){w=0;f[l>>2]=y}t=v+12|0;f[c>>2]=t;if((t|0)==(f[a>>2]|0)){f[c>>2]=f[o>>2];f[m>>2]=(f[m>>2]|0)+(f[q>>2]|0)}NL(g,l)|0}l=f[o>>2]|0;if(!l){u=i;return}o=f[a>>2]|0;if((o|0)!=(l|0))f[a>>2]=o+(~(((o+-12-l|0)>>>0)/12|0)*12|0);PYa(l);u=i;return}function mW(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,v=0;e=u;u=u+1056|0;g=e+16|0;h=e;i=e+32|0;j=+iNa(c,d);k=f[d>>2]|0;if((b[k>>0]|0)==46){b[k>>0]=44;l=+iNa(c,d);b[k>>0]=46;m=f[d>>2]|0;if(m>>>0>k>>>0){n=m;o=l}else{f[d>>2]=k;n=k;o=j}}else{n=k;o=j}if((n|0)!=(c|0)?((b[n>>0]&-33)+-65&255)>=26:0){p=o;u=e;return +p}n=b[c>>0]|0;switch(n<<24>>24){case 43:case 45:{k=c+1|0;q=k;r=b[k>>0]|0;s=n<<24>>24==45?-D:D;break}default:{q=c;r=n;s=D}}if(r<<24>>24!=46){r=f[a+88>>2]|0;f[h>>2]=f[a+60>>2];f[h+4>>2]=r;f[h+8>>2]=179936;SLa(i,178874,h)|0;T$(-212,179974,i,177754,1059)}h=b[q+1>>0]|0;if(((dNa(h)|0)==73?(dNa(b[q+2>>0]|0)|0)==78:0)?(dNa(b[q+3>>0]|0)|0)==70:0)t=s;else v=13;do if((v|0)==13){if(((dNa(h)|0)==78?(dNa(b[q+2>>0]|0)|0)==65:0)?(dNa(b[q+3>>0]|0)|0)==78:0){t=C;break}r=f[a+88>>2]|0;f[g>>2]=f[a+60>>2];f[g+4>>2]=r;f[g+8>>2]=179936;SLa(i,178874,g)|0;T$(-212,179974,i,177754,1068);t=0.0}while(0);f[d>>2]=q+4;p=t;u=e;return +p}function nW(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+16|0;h=g;f[a>>2]=c;i=a+4|0;f[i>>2]=c;j=a+8|0;f[j>>2]=c;k=a+16|0;f[k>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if(!c){f[h>>2]=0;f[h+4>>2]=0;c=c$(h,3)|0;b[c>>0]=b[179998]|0;b[c+1>>0]=b[179999]|0;b[c+2>>0]=b[18e4]|0;j$(-215,h,180002,177754,8135);d$(h)}if(!e){f[h>>2]=0;f[h+4>>2]=0;c=c$(h,2)|0;b[c>>0]=100;b[c+1>>0]=116;j$(-215,h,180002,177754,8136);d$(h)}if((d|0)<=-1){f[h>>2]=0;f[h+4>>2]=0;c=c$(h,8)|0;l=c;b[l>>0]=108;b[l+1>>0]=101;b[l+2>>0]=110;b[l+3>>0]=32;l=c+4|0;b[l>>0]=62;b[l+1>>0]=61;b[l+2>>0]=32;b[l+3>>0]=48;j$(-215,h,180002,177754,8137);d$(h)}oW(a,e);f[a+28>>2]=f[k>>2];k=kW(e)|0;f[a+12>>2]=k;a=(f[i>>2]|0)+(Y(k,d)|0)|0;f[j>>2]=a;u=g;return}function oW(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+176|0;e=d+160|0;g=d+164|0;h=d+20|0;i=d+8|0;j=d;f[e>>2]=0;b[g>>0]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;k=xKa(c)|0;if(k>>>0>4294967279)WYa(i);if(k>>>0<11){b[i+11>>0]=k;if(!k)l=i;else{m=i;n=6}}else{o=k+16&-16;p=NYa(o)|0;f[i>>2]=p;f[i+8>>2]=o|-2147483648;f[i+4>>2]=k;m=p;n=6}if((n|0)==6){K1a(m|0,c|0,k|0)|0;l=m}b[l+k>>0]=0;k=h+60|0;l=h+8|0;f[h>>2]=12412;f[k>>2]=12432;f[h+4>>2]=0;$Oa(h+60|0,l);f[h+132>>2]=0;f[h+136>>2]=-1;f[h>>2]=42680;f[k>>2]=42700;ePa(l);f[l>>2]=42524;k=h+40|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[h+56>>2]=8;GU(l,i);if((b[i+11>>0]|0)<0)PYa(f[i>>2]|0);l=f[h+(f[(f[h>>2]|0)+-12>>2]|0)+16>>2]|0;a:do if(!(l&2)){k=i+4|0;m=j+4|0;c=i+4|0;n=j+4|0;p=a+20|0;o=a+24|0;q=a+16|0;r=i+8|0;s=0;while(1){t=kPa(h,e)|0;if(!(f[t+(f[(f[t>>2]|0)+-12>>2]|0)+16>>2]&5)){if(!(f[e>>2]|0)){f[i>>2]=0;f[k>>2]=0;t=c$(i,8)|0;v=t;b[v>>0]=99;b[v+1>>0]=110;b[v+2>>0]=116;b[v+3>>0]=32;v=t+4|0;b[v>>0]=62;b[v+1>>0]=32;b[v+2>>0]=48;b[v+3>>0]=85;j$(-215,i,180025,177754,8228);d$(i)}}else{_Oa(h+(f[(f[h>>2]|0)+-12>>2]|0)|0,0);f[e>>2]=1}v=pW(h,g)|0;if(f[v+(f[(f[v>>2]|0)+-12>>2]|0)+16>>2]&5|0)break;v=f[e>>2]|0;f[e>>2]=v+-1;b:do if(!v)w=s;else{t=s;while(1){x=b[g>>0]|0;switch(x<<24>>24|0){case 99:case 117:{f[r>>2]=143;y=x;z=1;break}case 115:case 119:{f[r>>2]=144;y=x;z=2;break}case 105:{f[r>>2]=145;y=x;z=4;break}case 102:{f[r>>2]=146;y=x;z=4;break}case 100:{f[r>>2]=147;y=x;z=8;break}default:{f[j>>2]=0;f[m>>2]=0;A=c$(j,19)|0;B=180036;C=A+19|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));j$(-215,j,180025,177754,8263);d$(j);y=b[g>>0]|0;z=0}}x=t+-1+z&0-z;f[c>>2]=x;D=x+z|0;switch(y<<24>>24|0){case 117:{f[i>>2]=0;break}case 99:{f[i>>2]=1;break}case 119:{f[i>>2]=2;break}case 115:{f[i>>2]=3;break}case 105:{f[i>>2]=4;break}case 102:{f[i>>2]=5;break}case 100:{f[i>>2]=6;break}default:{f[j>>2]=0;f[n>>2]=0;A=c$(j,22)|0;B=180056;C=A+22|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));j$(-215,j,180025,177754,8281);d$(j)}}x=f[p>>2]|0;if((x|0)==(f[o>>2]|0))vW(q,i);else{f[x>>2]=f[i>>2];f[x+4>>2]=f[i+4>>2];f[x+8>>2]=f[i+8>>2];f[p>>2]=(f[p>>2]|0)+12}x=f[e>>2]|0;f[e>>2]=x+-1;if(!x){w=D;break b}else t=D}}while(0);v=f[h+(f[(f[h>>2]|0)+-12>>2]|0)+16>>2]|0;if(!(v&2))s=w;else{E=v;break a}}E=f[h+(f[(f[h>>2]|0)+-12>>2]|0)+16>>2]|0}else E=l;while(0);if(!(E&2)){f[i>>2]=0;f[i+4>>2]=0;A=c$(i,9)|0;B=180079;C=A+9|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));j$(-215,i,180025,177754,8288);d$(i)}if((f[a+20>>2]|0)!=(f[a+16>>2]|0)){wW(h);u=d;return}f[i>>2]=0;f[i+4>>2]=0;A=c$(i,22)|0;B=180089;C=A+22|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));j$(-215,i,180025,177754,8289);d$(i);wW(h);u=d;return}function pW(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;gPa(e,a,0);if(!(b[e>>0]|0)){u=d;return a|0}e=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0;g=e+12|0;i=f[g>>2]|0;if((i|0)==(f[e+16>>2]|0)){j=mi[f[(f[e>>2]|0)+40>>2]&255](e)|0;if((j|0)==-1){e=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;_Oa(e,f[e+16>>2]|6);u=d;return a|0}else k=j}else{f[g>>2]=i+1;k=h[i>>0]|0}b[c>>0]=k;u=d;return a|0}function qW(a,c){a=a|0;c=c|0;b[c>>0]=0;b[c>>0]=b[a>>0]|0;return 1}function rW(a,c){a=a|0;c=c|0;var e=0;d[c>>1]=0;e=b[a>>0]|0;d[c>>1]=e&255;d[c>>1]=(h[a+1>>0]|0)<<8|e&255;return 2}function sW(a,b){a=a|0;b=b|0;var c=0,d=0;f[b>>2]=0;c=h[a>>0]|0;f[b>>2]=c;d=(h[a+1>>0]|0)<<8|c;f[b>>2]=d;c=(h[a+2>>0]|0)<<16|d;f[b>>2]=c;f[b>>2]=(h[a+3>>0]|0)<<24|c;return 4}function tW(a,b){a=a|0;b=b|0;f[b>>2]=(h[a+1>>0]|0)<<8|(h[a>>0]|0)|(h[a+2>>0]|0)<<16|(h[a+3>>0]|0)<<24;return 4}function uW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0;c=h[a>>0]|0;d=R1a(h[a+1>>0]|0|0,0,8)|0;e=J;g=R1a(h[a+2>>0]|0|0,0,16)|0;i=e|J;e=R1a(h[a+3>>0]|0|0,0,24)|0;j=i|J|(h[a+4>>0]|0);i=R1a(h[a+5>>0]|0|0,0,40)|0;k=j|J;j=R1a(h[a+6>>0]|0|0,0,48)|0;l=k|J;k=R1a(h[a+7>>0]|0|0,0,56)|0;a=b;f[a>>2]=d|c|g|e|i|j|k;f[a+4>>2]=l|J;return 8}function vW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=(e|0)/12|0;h=g+1|0;if(h>>>0>357913941)gXa(a);i=a+8|0;j=((f[i>>2]|0)-d|0)/12|0;k=j<<1;l=j>>>0<178956970?(k>>>0<h>>>0?h:k):357913941;do if(l)if(l>>>0>357913941){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l*12|0)|0;break}else m=0;while(0);k=m+(g*12|0)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];b=k+(((e|0)/-12|0)*12|0)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+12;f[i>>2]=m+(l*12|0);if(!d)return;PYa(d);return}function wW(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=42680;c=a+60|0;f[c>>2]=42700;d=a+8|0;f[d>>2]=42524;e=a+40|0;if((b[e+11>>0]|0)<0)PYa(f[e>>2]|0);WNa(d);IOa(a,42712);RNa(c);return}function xW(a){a=a|0;wW(a);PYa(a);return}function yW(a){a=a|0;wW(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function zW(a){a=a|0;var b=0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;wW(b);PYa(b);return}function AW(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+16|0;e=d;if(!a){g=0;u=d;return g|0}h=xKa(a)|0;if(!h){g=0;u=d;return g|0}f[c>>2]=0;if((h|0)>0){i=~a;j=e+4|0;k=e+4|0;l=e+4|0;m=0;n=0;o=0;while(1){p=a+o|0;q=b[p>>0]|0;r=q<<24>>24;do if((q+-48&255)<10){if(((b[a+(o+1)>>0]|0)+-48&255)<10){f[e>>2]=0;s=lNa(p,e,10)|0;t=s;v=(f[e>>2]|0)+i|0}else{t=r+-48|0;v=o}if((t|0)<1){f[e>>2]=0;f[j>>2]=0;w=c$(e,31)|0;x=180182;y=w+31|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));j$(-5,e,180214,177754,4701);d$(e);z=t;A=n;B=v}else{z=t;A=n;B=v}}else{s=BKa(180230,r,9)|0;if(!s){f[e>>2]=0;f[k>>2]=0;w=c$(e,31)|0;x=180182;y=w+31|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));j$(-5,e,180214,177754,4709);d$(e);C=c+(n<<2)|0;D=f[C>>2]|0;E=C}else{D=m;E=c+(n<<2)|0}if(!D)f[E>>2]=1;C=s-180230|0;f[c+(n+1<<2)>>2]=C;if((n|0)>0?(C|0)==(f[c+(n+-1<<2)>>2]|0):0){C=c+(n+-2<<2)|0;f[C>>2]=(f[C>>2]|0)+(f[E>>2]|0);z=0;A=n;B=o;break}C=n+2|0;if((C|0)>255){f[e>>2]=0;f[l>>2]=0;w=c$(e,32)|0;x=180239;y=w+32|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));j$(-5,e,180214,177754,4719);d$(e);z=0;A=C;B=o}else{z=0;A=C;B=o}}while(0);f[c+(A<<2)>>2]=z;o=B+1|0;if((o|0)>=(h|0)){F=A;break}else{m=z;n=A}}}else F=0;g=(F|0)/2|0;u=d;return g|0}function BW(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,j=0,k=0,l=0;if(!((a|0)!=0&(c|0)!=0&(e|0)!=0&(e&3|0)==0)){f=0;return f|0}g=a+d|0;i=g+e|0;if((e|0)>0){e=a+(d+4)|0;j=((((i>>>0>e>>>0?i:e)+(~a-d)|0)>>>2)*3|0)+3|0;d=c;a=g;while(1){g=b[179505+(h[a+3>>0]|0)>>0]|0;e=h[179505+(h[a+2>>0]|0)>>0]|0;k=h[179505+(h[a+1>>0]|0)>>0]|0;b[d>>0]=k>>>4&3|(h[179505+(h[a>>0]|0)>>0]|0)<<2;a=a+4|0;b[d+1>>0]=e>>>2&15|k<<4;b[d+2>>0]=g&255|e<<6;if(a>>>0>=i>>>0)break;else d=d+3|0}l=c+j|0}else l=c;b[l>>0]=0;f=l-c|0;return f|0}function CW(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+16|0;g=e+4|0;i=e;gPa(g,a,0);if(!(b[g>>0]|0)){g=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;_Oa(g,f[g+16>>2]|4);u=e;return a|0}g=c+11|0;if((b[g>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0}else{b[c>>0]=0;b[g>>0]=0}g=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;j=f[g+12>>2]|0;k=(j|0)<1?2147483647:j;bPa(i,g);g=BQa(i,1975176)|0;CQa(i);a:do if((k|0)>0){i=g+8|0;j=0;while(1){l=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0;m=f[l+12>>2]|0;if((m|0)==(f[l+16>>2]|0)){n=mi[f[(f[l>>2]|0)+36>>2]&255](l)|0;if((n|0)==-1){o=j;p=2;break a}else q=n}else q=h[m>>0]|0;m=q&255;if(m<<24>>24>-1?d[(f[i>>2]|0)+(q<<24>>24<<1)>>1]&8192:0){o=j;p=0;break a}kZa(c,m);m=j+1|0;n=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0;l=n+12|0;r=f[l>>2]|0;if((r|0)==(f[n+16>>2]|0))mi[f[(f[n>>2]|0)+40>>2]&255](n)|0;else f[l>>2]=r+1;if((m|0)<(k|0))j=m;else{o=m;p=0;break}}}else{o=0;p=0}while(0);f[a+(f[(f[a>>2]|0)+-12>>2]|0)+12>>2]=0;k=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;_Oa(k,f[k+16>>2]|((o|0)==0?p|4:p));u=e;return a|0}function DW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+1040|0;e=d;g=d+16|0;if((b&7|0)==6){if(f[c>>2]|0){h=f[a+88>>2]|0;f[e>>2]=f[a+60>>2];f[e+4>>2]=h;f[e+8>>2]=180636;SLa(g,178874,e)|0;T$(-212,180688,g,177754,558)}g=f[a+16>>2]|0;e=UL(0,72,24,g)|0;f[e+64>>2]=16;h=vL(g,64)|0;f[e+68>>2]=h;g=h;h=g+64|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[c+8>>2]=e;i=e;j=c;f[j>>2]=b;zL(i,8);u=d;return}else{e=yL(0,56,16,f[a+16>>2]|0)|0;if(f[c>>2]&7|0)NL(e,c)|0;f[c+8>>2]=e;i=e;j=c;f[j>>2]=b;zL(i,8);u=d;return}}function EW(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+16|0;i=g;if(!a){j=0;u=g;return j|0}k=f[a+28>>2]|0;if((d|0)<0){a=b[c>>0]|0;if(!(a<<24>>24)){l=0;m=0}else{n=a;a=0;o=0;while(1){p=(n&255)+(a*33|0)|0;q=o+1|0;n=b[c+q>>0]|0;if(!(n<<24>>24)){l=p;m=q;break}else{a=p;o=q}}}}else if(!d){l=0;m=0}else{o=0;a=0;while(1){n=(h[c+a>>0]|0)+(o*33|0)|0;a=a+1|0;if((a|0)>=(d|0)){l=n;m=d;break}else o=n}}o=l&2147483647;l=f[k+64>>2]|0;d=l+-1|0;if(!(d&l))r=d&o;else r=(o>>>0)%(l>>>0)|0;l=k+68|0;d=f[(f[l>>2]|0)+(r<<2)>>2]|0;a:do if(d|0){a=d;while(1){if(((f[a>>2]|0)==(o|0)?(f[a+4>>2]|0)==(m|0):0)?(yKa(f[a+8>>2]|0,c,m)|0)==0:0){j=a;break}a=f[a+12>>2]|0;if(!a)break a}u=g;return j|0}while(0);if(!e){j=0;u=g;return j|0}e=k+56|0;d=f[e>>2]|0;f[i>>2]=d;if(!d){VL(k,0,i)|0;s=f[i>>2]|0}else{f[e>>2]=f[d+4>>2];f[d>>2]=f[d>>2]&67108863;e=k+60|0;f[e>>2]=(f[e>>2]|0)+1;s=d}f[s>>2]=o;xL(i,f[k+44>>2]|0,c,m);m=i;i=f[m+4>>2]|0;c=s+4|0;f[c>>2]=f[m>>2];f[c+4>>2]=i;i=(f[l>>2]|0)+(r<<2)|0;f[s+12>>2]=f[i>>2];f[i>>2]=s;j=s;u=g;return j|0}function FW(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=u;u=u+1040|0;h=g;i=g+16|0;if(!a){j=0;u=g;return j|0}if((f[a>>2]|0)!=1280131417){f[i>>2]=0;f[i+4>>2]=0;k=c$(i,31)|0;l=177863;m=k+31|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-5,i,180525,177754,786);d$(i)}if(!d){f[i>>2]=0;f[i+4>>2]=0;k=c$(i,16)|0;l=180539;m=k+16|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-27,i,180525,177754,789);d$(i)}n=(c|0)!=0;if(n){o=f[a+32>>2]|0;if(!o){j=0;u=g;return j|0}p=f[o+24>>2]|0;if((p|0)>0)q=p;else{j=0;u=g;return j|0}}else q=1;p=q+-1|0;o=(e|0)!=0;r=(e|0)==0;e=a+60|0;s=a+88|0;t=a+32|0;a=i+4|0;v=0;w=0;a:while(1){if(!n){x=AL(f[t>>2]|0,v)|0;if(!x){f[i>>2]=0;f[a>>2]=0;k=c$(i,14)|0;l=180556;m=k+14|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,i,180525,177754,807);d$(i);y=x}else y=x}else y=c;switch(f[y>>2]&7){case 5:{z=14;break a;break}case 0:{j=0;z=33;break a;break}case 6:break;default:break a}A=f[y+8>>2]|0;B=f[A+64>>2]|0;C=B+-1|0;D=f[d>>2]|0;if(!(C&B))E=D&C;else E=(D>>>0)%(B>>>0)|0;B=A+68|0;D=f[(f[B>>2]|0)+(E<<2)>>2]|0;b:do if(D|0){if(r){F=D;while(1){if((f[F+16>>2]|0)==(d|0)){z=24;break a}C=f[F+20>>2]|0;if(!C)break b;else F=C}}else G=D;do{if((f[G+16>>2]|0)==(d|0)){C=f[s>>2]|0;f[h>>2]=f[e>>2];f[h+4>>2]=C;f[h+8>>2]=180621;SLa(i,178874,h)|0;T$(-212,180525,i,177754,832)}G=f[G+20>>2]|0}while((G|0)!=0)}while(0);if(o&(v|0)==(p|0)){D=A+56|0;x=f[D>>2]|0;f[i>>2]=x;if(!x){VL(A,0,i)|0;H=f[i>>2]|0}else{f[D>>2]=f[x+4>>2];f[x>>2]=f[x>>2]&67108863;D=A+60|0;f[D>>2]=(f[D>>2]|0)+1;H=x}f[H+16>>2]=d;x=(f[B>>2]|0)+(E<<2)|0;f[H+20>>2]=f[x>>2];f[x>>2]=H;I=H}else I=w;v=v+1|0;if((v|0)>=(q|0)){j=I;z=33;break}else w=I}if((z|0)==14){if(!(f[(f[y+8>>2]|0)+24>>2]|0)){j=0;u=g;return j|0}}else if((z|0)==24){j=F;u=g;return j|0}else if((z|0)==33){u=g;return j|0}f[i>>2]=0;f[i+4>>2]=0;k=c$(i,49)|0;l=180571;m=k+49|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-2,i,180525,177754,812);d$(i);j=0;u=g;return j|0}function GW(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;g=u;u=u+1168|0;i=g+80|0;j=g+64|0;k=g+48|0;l=g+32|0;m=g+16|0;n=g;o=g+136|0;p=g+128|0;q=g+116|0;r=g+104|0;s=g+92|0;t=$V(a,c,0)|0;c=t;f[p>>2]=c;v=a+92|0;if((f[v>>2]|0)==0?(c-(f[a+76>>2]|0)|0)==(d|0):0){w=t;while(1){x=b[w>>0]|0;if((x&255)>31)w=w+1|0;else break}if(!(x<<24>>24)){x=f[a+88>>2]|0;f[n>>2]=f[a+60>>2];f[n+4>>2]=x;f[n+8>>2]=181168;SLa(o,178874,n)|0;T$(-212,181191,o,177754,1345)}n=w;f[p>>2]=n;y=n;z=w}else{y=c;z=t}if(t>>>0>=z>>>0){A=z;u=g;return A|0};f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;if((y-c|0)<32){y=f[a+88>>2]|0;f[m>>2]=f[a+60>>2];f[m+4>>2]=y;f[m+8>>2]=179716;SLa(o,178874,m)|0;T$(-212,181223,o,177754,1365)}f[r>>2]=0;m=r+4|0;f[m>>2]=0;f[r+8>>2]=0;y=NYa(25)|0;f[r>>2]=y;z=y+25|0;f[r+8>>2]=z;w=y;n=w+25|0;do{b[w>>0]=32;w=w+1|0}while((w|0)<(n|0));f[m>>2]=z;if(t|0){z=t+32|0;w=t+4|0;n=(((z>>>0>w>>>0?z:w)+~c|0)>>>2)*3|0;c=y;w=0;while(1){z=t+w|0;w=w+4|0;x=b[179505+(h[z+3>>0]|0)>>0]|0;B=h[179505+(h[z+2>>0]|0)>>0]|0;C=h[179505+(h[z+1>>0]|0)>>0]|0;b[c>>0]=C>>>4&3|h[179505+(h[z>>0]|0)>>0]<<2;b[c+1>>0]=B>>>2&15|C<<4;b[c+2>>0]=x&255|B<<6;if((w|0)>=32)break;else c=c+3|0}b[y+(n+3)>>0]=0}if(!(gW(r,q)|0?(n=b[q+11>>0]|0,((n<<24>>24<0?f[q+4>>2]|0:n&255)|0)!=0):0)){n=f[a+88>>2]|0;f[l>>2]=f[a+60>>2];f[l+4>>2]=n;f[l+8>>2]=179632;SLa(o,178874,l)|0;T$(-212,181223,o,177754,1370)}l=t+32|0;t=f[r>>2]|0;if(t|0){if((f[m>>2]|0)!=(t|0))f[m>>2]=t;PYa(t)};f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;dZa(r,131072);t=f[p>>2]|0;if(l>>>0<t>>>0){m=a+76|0;n=a+60|0;y=a+88|0;c=l;l=t;while(1){fW(r,c,l)|0;c=$V(a,l,0)|0;t=c;f[p>>2]=t;if((f[v>>2]|0)==0?(t-(f[m>>2]|0)|0)==(d|0):0){t=c;while(1){D=b[t>>0]|0;if((D&255)>31)t=t+1|0;else break}if(!(D<<24>>24)){w=f[y>>2]|0;f[k>>2]=f[n>>2];f[k+4>>2]=w;f[k+8>>2]=181168;SLa(o,178874,k)|0;T$(-212,181191,o,177754,1345)}f[p>>2]=t;E=t}else E=c;if(c>>>0>=E>>>0)break;else l=E}}E=r+11|0;l=b[E>>0]|0;c=l<<24>>24<0;k=r+4|0;n=f[k>>2]|0;y=l&255;a:do if((c?n:y)|0){D=c?f[r>>2]|0:r;d=c?n:y;if(!d)F=xKa(D)|0;else F=d;if(D){if(!F)G=xKa(D)|0;else G=F;if((G|0)!=0&(G&3|0)==0){d=D+G|0;m=d+-1|0;if((b[m>>0]|0)==61){w=m+-1|0;H=(b[w>>0]|0)==61?w:m}else H=d;if(D>>>0<H>>>0){d=D;while(1){D=b[d>>0]|0;if((D&255)>126){I=43;break a}d=d+1|0;if(!(D<<24>>24==65|(b[179505+(D&255)>>0]|0)!=0)){I=43;break a}if(d>>>0>=H>>>0){J=l;K=n;break}}}else{J=l;K=n}}else I=43}else I=43}else I=43;while(0);if((I|0)==43){I=f[a+88>>2]|0;f[j>>2]=f[a+60>>2];f[j+4>>2]=I;f[j+8>>2]=179662;SLa(o,178874,j)|0;T$(-212,181223,o,177754,1386);J=b[E>>0]|0;K=f[k>>2]|0}j=(((J<<24>>24<0?K:J&255)>>>2)*3|0)+1|0;f[s>>2]=0;I=s+4|0;f[I>>2]=0;f[s+8>>2]=0;if(!j){L=J;M=K;N=0}else{if((j|0)<0)gXa(s);K=NYa(j)|0;f[I>>2]=K;f[s>>2]=K;f[s+8>>2]=K+j;J=K;K=j;do{b[J>>0]=0;J=(f[I>>2]|0)+1|0;f[I>>2]=J;K=K+-1|0}while((K|0)!=0);L=b[E>>0]|0;M=f[k>>2]|0;N=J}J=L<<24>>24<0;K=J?M:L&255;L=(J?f[r>>2]|0:r)+K|0;J=0;while(1){L=L+-1|0;if((b[L>>0]|0)!=61)break;else J=J+1|0}L=((K>>>2)*3|0)-J|0;J=f[s>>2]|0;f[o>>2]=J;f[o+4>>2]=J+(N-J);J=o+8|0;f[J>>2]=0;N=o+12|0;f[N>>2]=0;f[o+16>>2]=0;K=NYa(120)|0;f[N>>2]=K;f[J>>2]=K;f[o+16>>2]=K+120;J=K;K=120;do{b[J>>0]=0;J=(f[N>>2]|0)+1|0;f[N>>2]=J;K=K+-1|0}while((K|0)!=0);K=o+20|0;J=o+24|0;N=o+28|0;M=o+32|0;j=o+36|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;f[K+16>>2]=0;f[K+20>>2]=0;n=NYa(161)|0;f[j>>2]=n;f[M>>2]=n;f[o+40>>2]=n+161;l=n;n=161;do{b[l>>0]=0;l=(f[j>>2]|0)+1|0;f[j>>2]=l;n=n+-1|0}while((n|0)!=0);n=f[M>>2]|0;f[K>>2]=n;f[J>>2]=n;f[N>>2]=n+120;n=b[E>>0]|0;N=n<<24>>24<0;J=N?f[r>>2]|0:r;hW(o,J,J+(N?f[k>>2]|0:n&255)|0)|0;iW(o)|0;jW(o);n=q+11|0;k=kW((b[n>>0]|0)<0?f[q>>2]|0:q)|0;if((L|0)%(k|0)|0|0){N=f[a+88>>2]|0;f[i>>2]=f[a+60>>2];f[i+4>>2]=N;f[i+8>>2]=179683;SLa(o,178874,i)|0;T$(-212,181223,o,177754,1404)}f[e>>2]=0;o=yL(0,56,16,f[a+16>>2]|0)|0;if(f[e>>2]&7|0)NL(o,e)|0;i=e+8|0;f[i>>2]=o;f[e>>2]=13;zL(o,8);lW(f[s>>2]|0,(L|0)/(k|0)|0,(b[n>>0]|0)<0?f[q>>2]|0:q,f[i>>2]|0);i=f[((f[v>>2]|0)==0?p:a+76|0)>>2]|0;a=f[s>>2]|0;if(a|0){if((f[I>>2]|0)!=(a|0))f[I>>2]=a;PYa(a)}if((b[E>>0]|0)<0)PYa(f[r>>2]|0);if((b[n>>0]|0)<0)PYa(f[q>>2]|0);A=i;u=g;return A|0}function HW(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+1072|0;h=g+32|0;i=g+16|0;j=g;k=g+48|0;l=c+-1|0;if((b[c>>0]|0)==45){m=f[a+88>>2]|0;f[j>>2]=f[a+60>>2];f[j+4>>2]=m;f[j+8>>2]=181101;SLa(k,178874,j)|0;T$(-212,181128,k,177754,1432);n=l}else n=l;while(1){o=n+1|0;l=b[o>>0]|0;p=l<<24>>24!=58;if((l&255)<32|p^1)break;else n=o}if(p){p=f[a+88>>2]|0;f[i>>2]=f[a+60>>2];f[i+4>>2]=p;f[i+8>>2]=181143;SLa(k,178874,i)|0;T$(-212,181128,k,177754,1438);q=o}else q=o;while(1){o=q+-1|0;if((b[o>>0]|0)==32)q=o;else break}o=n+2|0;if((q|0)!=(c|0)){r=q;s=c;t=r-s|0;v=EW(a,c,t,1)|0;w=FW(a,d,v,1)|0;f[e>>2]=w;u=g;return o|0}n=f[a+88>>2]|0;f[h>>2]=f[a+60>>2];f[h+4>>2]=n;f[h+8>>2]=181155;SLa(k,178874,h)|0;T$(-212,181128,k,177754,1446);r=q;s=c;t=r-s|0;v=EW(a,c,t,1)|0;w=FW(a,d,v,1)|0;f[e>>2]=w;u=g;return o|0}function IW(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;e=u;u=u+1168|0;g=e+80|0;i=e+64|0;j=e+48|0;k=e+32|0;l=e+16|0;m=e;n=e+136|0;o=e+128|0;p=e+116|0;q=e+104|0;r=e+92|0;s=YV(a,c,2)|0;c=s;f[o>>2]=c;t=a+92|0;if((f[t>>2]|0)==0?(v=b[s>>0]|0,v<<24>>24!=60):0){if((v&255)>31){w=s;while(1){x=w+1|0;y=b[x>>0]|0;if((y&255)>31)w=x;else{z=y;A=x;break}}}else{z=v;A=s}if(!(z<<24>>24)){z=f[a+88>>2]|0;f[m>>2]=f[a+60>>2];f[m+4>>2]=z;f[m+8>>2]=181168;SLa(n,178874,m)|0;T$(-212,181786,n,177754,2328)}m=A;f[o>>2]=m;B=m;C=A}else{B=c;C=s}if(s>>>0>=C>>>0){D=C;u=e;return D|0};f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;if((B-c|0)<32){B=f[a+88>>2]|0;f[l>>2]=f[a+60>>2];f[l+4>>2]=B;f[l+8>>2]=179716;SLa(n,178874,l)|0;T$(-212,181818,n,177754,2347)}f[q>>2]=0;l=q+4|0;f[l>>2]=0;f[q+8>>2]=0;B=NYa(25)|0;f[q>>2]=B;C=B+25|0;f[q+8>>2]=C;A=B;m=A+25|0;do{b[A>>0]=32;A=A+1|0}while((A|0)<(m|0));f[l>>2]=C;if(s|0){C=s+32|0;A=s+4|0;m=(((C>>>0>A>>>0?C:A)+~c|0)>>>2)*3|0;c=B;A=0;while(1){C=s+A|0;A=A+4|0;z=b[179505+(h[C+3>>0]|0)>>0]|0;v=h[179505+(h[C+2>>0]|0)>>0]|0;w=h[179505+(h[C+1>>0]|0)>>0]|0;b[c>>0]=w>>>4&3|h[179505+(h[C>>0]|0)>>0]<<2;b[c+1>>0]=v>>>2&15|w<<4;b[c+2>>0]=z&255|v<<6;if((A|0)>=32)break;else c=c+3|0}b[B+(m+3)>>0]=0}if(!(gW(q,p)|0?(m=b[p+11>>0]|0,((m<<24>>24<0?f[p+4>>2]|0:m&255)|0)!=0):0)){m=f[a+88>>2]|0;f[k>>2]=f[a+60>>2];f[k+4>>2]=m;f[k+8>>2]=179632;SLa(n,178874,k)|0;T$(-212,181818,n,177754,2352)}k=s+32|0;s=f[q>>2]|0;if(s|0){if((f[l>>2]|0)!=(s|0))f[l>>2]=s;PYa(s)};f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;dZa(q,131072);s=f[o>>2]|0;if(k>>>0<s>>>0){l=a+60|0;m=a+88|0;B=k;k=s;while(1){fW(q,B,k)|0;B=YV(a,k,2)|0;f[o>>2]=B;if((f[t>>2]|0)==0?(s=b[B>>0]|0,s<<24>>24!=60):0){if((s&255)>31){c=B;while(1){A=c+1|0;v=b[A>>0]|0;if((v&255)>31)c=A;else{E=v;F=A;break}}}else{E=s;F=B}if(!(E<<24>>24)){c=f[m>>2]|0;f[j>>2]=f[l>>2];f[j+4>>2]=c;f[j+8>>2]=181168;SLa(n,178874,j)|0;T$(-212,181786,n,177754,2328)}f[o>>2]=F;G=F}else G=B;if(B>>>0>=G>>>0)break;else k=G}}G=q+11|0;k=b[G>>0]|0;B=k<<24>>24<0;F=q+4|0;j=f[F>>2]|0;l=k&255;a:do if((B?j:l)|0){m=B?f[q>>2]|0:q;E=B?j:l;if(!E)H=xKa(m)|0;else H=E;if(m){if(!H)I=xKa(m)|0;else I=H;if((I|0)!=0&(I&3|0)==0){E=m+I|0;c=E+-1|0;if((b[c>>0]|0)==61){A=c+-1|0;J=(b[A>>0]|0)==61?A:c}else J=E;if(m>>>0<J>>>0){E=m;while(1){m=b[E>>0]|0;if((m&255)>126){K=45;break a}E=E+1|0;if(!(m<<24>>24==65|(b[179505+(m&255)>>0]|0)!=0)){K=45;break a}if(E>>>0>=J>>>0){L=k;M=j;break}}}else{L=k;M=j}}else K=45}else K=45}else K=45;while(0);if((K|0)==45){K=f[a+88>>2]|0;f[i>>2]=f[a+60>>2];f[i+4>>2]=K;f[i+8>>2]=179662;SLa(n,178874,i)|0;T$(-212,181818,n,177754,2368);L=b[G>>0]|0;M=f[F>>2]|0}i=(((L<<24>>24<0?M:L&255)>>>2)*3|0)+1|0;f[r>>2]=0;K=r+4|0;f[K>>2]=0;f[r+8>>2]=0;if(!i){N=L;O=M;P=0}else{if((i|0)<0)gXa(r);M=NYa(i)|0;f[K>>2]=M;f[r>>2]=M;f[r+8>>2]=M+i;L=M;M=i;do{b[L>>0]=0;L=(f[K>>2]|0)+1|0;f[K>>2]=L;M=M+-1|0}while((M|0)!=0);N=b[G>>0]|0;O=f[F>>2]|0;P=L}L=N<<24>>24<0;M=L?O:N&255;N=(L?f[q>>2]|0:q)+M|0;L=0;while(1){N=N+-1|0;if((b[N>>0]|0)!=61)break;else L=L+1|0}N=((M>>>2)*3|0)-L|0;L=f[r>>2]|0;f[n>>2]=L;f[n+4>>2]=L+(P-L);L=n+8|0;f[L>>2]=0;P=n+12|0;f[P>>2]=0;f[n+16>>2]=0;M=NYa(120)|0;f[P>>2]=M;f[L>>2]=M;f[n+16>>2]=M+120;L=M;M=120;do{b[L>>0]=0;L=(f[P>>2]|0)+1|0;f[P>>2]=L;M=M+-1|0}while((M|0)!=0);M=n+20|0;L=n+24|0;P=n+28|0;O=n+32|0;i=n+36|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;f[M+16>>2]=0;f[M+20>>2]=0;j=NYa(161)|0;f[i>>2]=j;f[O>>2]=j;f[n+40>>2]=j+161;k=j;j=161;do{b[k>>0]=0;k=(f[i>>2]|0)+1|0;f[i>>2]=k;j=j+-1|0}while((j|0)!=0);j=f[O>>2]|0;f[M>>2]=j;f[L>>2]=j;f[P>>2]=j+120;j=b[G>>0]|0;P=j<<24>>24<0;L=P?f[q>>2]|0:q;hW(n,L,L+(P?f[F>>2]|0:j&255)|0)|0;iW(n)|0;jW(n);j=p+11|0;F=kW((b[j>>0]|0)<0?f[p>>2]|0:p)|0;if((N|0)%(F|0)|0|0){P=f[a+88>>2]|0;f[g>>2]=f[a+60>>2];f[g+4>>2]=P;f[g+8>>2]=181836;SLa(n,178874,g)|0;T$(-212,181818,n,177754,2386)}f[d>>2]=0;n=yL(0,56,16,f[a+16>>2]|0)|0;if(f[d>>2]&7|0)NL(n,d)|0;g=d+8|0;f[g>>2]=n;f[d>>2]=5;zL(n,8);lW(f[r>>2]|0,(N|0)/(F|0)|0,(b[j>>0]|0)<0?f[p>>2]|0:p,f[g>>2]|0);g=f[((f[t>>2]|0)==0?o:a+76|0)>>2]|0;a=f[r>>2]|0;if(a|0){if((f[K>>2]|0)!=(a|0))f[K>>2]=a;PYa(a)}if((b[G>>0]|0)<0)PYa(f[q>>2]|0);if((b[j>>0]|0)<0)PYa(f[p>>2]|0);D=g;u=e;return D|0}function JW(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=u;u=u+16|0;g=e;pV(a,0);switch(f[a+280>>2]|0){case 0:{qV(a,1);break}case 2:{f[g>>2]=0;f[g+4>>2]=0;h=c$(g,36)|0;i=182519;j=h+36|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-2,g,182556,177754,1899);d$(g);break}default:{}}k=a+44|0;l=f[k>>2]|0;if(!c)m=0;else m=(b[c>>0]|0)==0?0:c;c=l&7;if(c>>>0>4)if((c|0)==6^(m|0)!=0){f[g>>2]=0;f[g+4>>2]=0;h=c$(g,85)|0;i=182568;j=h+85|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-5,g,182556,177754,1916);d$(g);n=l}else n=l;else{f[a+12>>2]=0;n=m|0?38:37}l=(m|0)!=0;do if(l){c=xKa(m)|0;if(!c){f[g>>2]=0;f[g+4>>2]=0;h=c$(g,19)|0;i=182654;j=h+19|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-5,g,182556,177754,1928);d$(g);o=0;break}if((c|0)>4096){f[g>>2]=0;f[g+4>>2]=0;h=c$(g,19)|0;i=182674;j=h+19|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-5,g,182556,177754,1931);d$(g);o=c}else o=c}else o=0;while(0);p=(d|0)!=0;if(p)q=xKa(d)|0;else q=0;r=(n&8|0)==0;s=a+72|0;t=f[s>>2]|0;do if(r){v=a+76|0;w=f[v>>2]|0;x=a+56|0;y=f[x>>2]|0;if(t>>>0>(w+y|0)>>>0){b[t>>0]=10;b[t+1>>0]=0;lV(a,f[v>>2]|0);z=f[v>>2]|0;f[s>>2]=z;A=f[x>>2]|0;B=z}else{A=y;B=w}w=f[a+40>>2]|0;if((A|0)==(w|0)){C=B;D=A}else{F1a(B|0,32,w|0)|0;f[x>>2]=w;C=f[v>>2]|0;D=w}w=C+D|0;f[s>>2]=w;if((n&7|0)!=6){v=w+1|0;b[w>>0]=45;if(p){b[v>>0]=32;E=w+2|0}else E=v}else E=w}else{if(!(n&32)){b[t>>0]=44;F=t+1|0}else F=t;w=a+76|0;v=f[w>>2]|0;x=q+o-v+F|0;y=v;if((x|0)>(f[a+84>>2]|0)?(v=a+40|0,z=f[v>>2]|0,(x-z|0)>10):0){f[s>>2]=F;x=a+56|0;G=f[x>>2]|0;if(F>>>0>(y+G|0)>>>0){b[F>>0]=10;b[F+1>>0]=0;lV(a,f[w>>2]|0);H=f[w>>2]|0;f[s>>2]=H;I=f[x>>2]|0;J=f[v>>2]|0;K=H}else{I=G;J=z;K=y}if((I|0)==(J|0))L=K;else{F1a(K|0,32,J|0)|0;f[x>>2]=J;L=f[w>>2]|0}w=L+J|0;f[s>>2]=w;E=w;break}b[F>>0]=32;E=F+1|0}while(0);if(l){l=b[m>>0]|0;if(!(((l&-33)+-65&255)<26|l<<24>>24==95)){f[g>>2]=0;f[g+4>>2]=0;h=c$(g,33)|0;i=182694;j=h+33|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-5,g,182556,177754,1966);d$(g)}l=a+80|0;F=f[l>>2]|0;if((E+o|0)>>>0<F>>>0)M=E;else{J=a+76|0;L=f[J>>2]|0;K=E-L|0;I=((F-L|0)*3|0)/2|0;L=K+o|0;F=(L|0)<(I|0)?I:L;L=_F(F+256|0)|0;I=f[J>>2]|0;f[s>>2]=L+((f[s>>2]|0)-I);if((K|0)>0)K1a(L|0,I|0,K|0)|0;f[J>>2]=L;f[l>>2]=L+F;M=L+K|0}if((o|0)>0){K=g+4|0;L=0;do{F=b[m+L>>0]|0;b[M+L>>0]=F;a:do if(!((F+-48&255)<10|((F&-33)+-65&255)<26)){switch(F<<24>>24){case 32:case 45:case 95:{break a;break}default:{}}f[g>>2]=0;f[K>>2]=0;h=c$(g,80)|0;i=182728;j=h+80|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-5,g,182556,177754,1976);d$(g)}while(0);L=L+1|0}while((L|0)<(o|0))}L=M+o|0;o=L+1|0;b[L>>0]=58;if(p&r){b[o>>0]=32;N=o+1|0}else N=o}else N=E;if(!p){O=N;f[s>>2]=O;P=n&-33;f[k>>2]=P;u=e;return}p=a+80|0;E=f[p>>2]|0;if((N+q|0)>>>0<E>>>0)Q=N;else{o=a+76|0;a=f[o>>2]|0;r=N-a|0;N=((E-a|0)*3|0)/2|0;a=r+q|0;E=(a|0)<(N|0)?N:a;a=_F(E+256|0)|0;N=f[o>>2]|0;f[s>>2]=a+((f[s>>2]|0)-N);if((r|0)>0)K1a(a|0,N|0,r|0)|0;f[o>>2]=a;f[p>>2]=a+E;Q=a+r|0}K1a(Q|0,d|0,q|0)|0;O=Q+q|0;f[s>>2]=O;P=n&-33;f[k>>2]=P;u=e;return}function KW(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=u;u=u+16|0;g=e;pV(a,0);switch(f[a+280>>2]|0){case 0:{qV(a,1);break}case 2:{f[g>>2]=0;f[g+4>>2]=0;h=c$(g,36)|0;i=182519;j=h+36|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-2,g,182828,177754,3855);d$(g);break}default:{}}do if((c|0)!=0?(b[c>>0]|0)!=0:0){k=xKa(c)|0;if(!k){f[g>>2]=0;f[g+4>>2]=0;h=c$(g,19)|0;i=182654;j=h+19|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-5,g,182828,177754,3867);d$(g);l=c;m=0;n=1;break}if((k|0)>4096){f[g>>2]=0;f[g+4>>2]=0;h=c$(g,19)|0;i=182674;j=h+19|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-5,g,182828,177754,3869);d$(g);l=c;m=k;n=1}else{l=c;m=k;n=1}}else{l=0;m=0;n=0}while(0);c=(d|0)!=0;if(c)o=xKa(d)|0;else o=0;p=a+44|0;q=f[p>>2]|0;r=q&7;if(r>>>0>4)if(n^(r|0)==6){f[g>>2]=0;f[g+4>>2]=0;h=c$(g,85)|0;i=182568;j=h+85|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-5,g,182828,177754,3881);d$(g);s=q}else s=q;else{f[a+12>>2]=0;s=n?38:37}q=(s&32|0)!=0;r=a+72|0;t=f[r>>2]|0;do if(!(s&8)){if(q){v=a+76|0;w=f[v>>2]|0;x=t;y=v}else{b[t>>0]=44;b[t+1>>0]=10;b[t+2>>0]=0;v=a+76|0;lV(a,f[v>>2]|0);z=f[v>>2]|0;f[r>>2]=z;A=z;w=A;x=A;y=v}v=a+56|0;A=f[v>>2]|0;if(x>>>0>(w+A|0)>>>0){b[x>>0]=10;b[x+1>>0]=0;lV(a,f[y>>2]|0);z=f[y>>2]|0;f[r>>2]=z;B=f[v>>2]|0;C=z}else{B=A;C=w}A=f[a+40>>2]|0;if((B|0)==(A|0)){D=C;E=B}else{F1a(C|0,32,A|0)|0;f[v>>2]=A;D=f[y>>2]|0;E=A}A=D+E|0;f[r>>2]=A;F=A}else{if(q)G=t;else{b[t>>0]=44;G=t+1|0}A=a+76|0;v=f[A>>2]|0;z=o+m-v+G|0;H=v;if((z|0)>(f[a+84>>2]|0)?(v=a+40|0,I=f[v>>2]|0,(z-I|0)>10):0){f[r>>2]=G;z=a+56|0;J=f[z>>2]|0;if(G>>>0>(H+J|0)>>>0){b[G>>0]=10;b[G+1>>0]=0;lV(a,f[A>>2]|0);K=f[A>>2]|0;f[r>>2]=K;L=f[z>>2]|0;M=f[v>>2]|0;N=K}else{L=J;M=I;N=H}if((L|0)==(M|0))O=N;else{F1a(N|0,32,M|0)|0;f[z>>2]=M;O=f[A>>2]|0}A=O+M|0;f[r>>2]=A;F=A;break}b[G>>0]=32;F=G+1|0}while(0);if(n){n=b[l>>0]|0;if(!(((n&-33)+-65&255)<26|n<<24>>24==95)){f[g>>2]=0;f[g+4>>2]=0;h=c$(g,33)|0;i=182694;j=h+33|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-5,g,182828,177754,3923);d$(g)}n=a+80|0;G=f[n>>2]|0;if((F+m|0)>>>0<G>>>0)P=F;else{r=a+76|0;M=f[r>>2]|0;O=F-M|0;N=((G-M|0)*3|0)/2|0;M=O+m|0;G=(M|0)<(N|0)?N:M;M=_F(G+256|0)|0;N=a+72|0;L=f[r>>2]|0;f[N>>2]=M+((f[N>>2]|0)-L);if((O|0)>0)K1a(M|0,L|0,O|0)|0;f[r>>2]=M;f[n>>2]=M+G;P=M+O|0}O=P+1|0;b[P>>0]=34;if(m|0){P=g+4|0;M=0;do{G=b[l+M>>0]|0;b[O+M>>0]=G;a:do if(!((G+-48&255)<10|((G&-33)+-65&255)<26)){switch(G<<24>>24){case 32:case 45:case 95:{break a;break}default:{}}f[g>>2]=0;f[P>>2]=0;h=c$(g,80)|0;i=182728;j=h+80|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-5,g,182828,177754,3934);d$(g)}while(0);M=M+1|0}while(M>>>0<m>>>0)}M=O+m|0;m=M+1|0;b[M>>0]=34;M=m+1|0;b[m>>0]=58;b[M>>0]=32;Q=M+1|0}else Q=F;if(!c){R=Q;S=a+72|0;f[S>>2]=R;T=s&-33;f[p>>2]=T;u=e;return}c=a+80|0;F=f[c>>2]|0;if((Q+o|0)>>>0<F>>>0)U=Q;else{M=a+76|0;m=f[M>>2]|0;O=Q-m|0;Q=((F-m|0)*3|0)/2|0;m=O+o|0;F=(m|0)<(Q|0)?Q:m;m=_F(F+256|0)|0;Q=a+72|0;g=f[M>>2]|0;f[Q>>2]=m+((f[Q>>2]|0)-g);if((O|0)>0)K1a(m|0,g|0,O|0)|0;f[M>>2]=m;f[c>>2]=m+F;U=m+O|0}K1a(U|0,d|0,o|0)|0;R=U+o|0;S=a+72|0;f[S>>2]=R;T=s&-33;f[p>>2]=T;u=e;return}function LW(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;g=u;u=u+16|0;h=g;pV(a,0);switch(f[a+280>>2]|0){case 0:{qV(a,1);break}case 2:{f[h>>2]=0;f[h+4>>2]=0;i=c$(h,38)|0;j=182866;k=i+38|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-2,h,182905,177754,3060);d$(h);break}default:{}}l=a+44|0;m=f[l>>2]&7;if((m|0)!=6?(n=(c|0)!=0,!(n&m>>>0<5)):0){m=a+72|0;o=f[m>>2]|0;p=a+76|0;q=o-(f[p>>2]|0)+e|0;if(n){f[h>>2]=0;f[h+4>>2]=0;i=c$(h,49)|0;j=182923;k=i+49|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-5,h,182905,177754,3078);d$(h)}f[l>>2]=5;if((q|0)>(f[a+84>>2]|0)?(q-(f[a+40>>2]|0)|0)>10:0){r=f[p>>2]|0;s=18}else s=16;do if((s|0)==16){q=f[p>>2]|0;if(o>>>0>q>>>0?(b[o+-1>>0]|0)==62:0){r=q;s=18;break}if(o>>>0>(q+(f[a+40>>2]|0)|0)>>>0?(b[o+-1>>0]|0)!=62:0){b[o>>0]=32;t=o+1|0}else t=o}while(0);if((s|0)==18){s=f[m>>2]|0;o=a+56|0;q=f[o>>2]|0;if(s>>>0>(r+q|0)>>>0){b[s>>0]=10;b[s+1>>0]=0;lV(a,f[p>>2]|0);s=f[p>>2]|0;f[m>>2]=s;v=f[o>>2]|0;w=s}else{v=q;w=r}r=f[a+40>>2]|0;if((v|0)==(r|0)){x=w;y=v}else{F1a(w|0,32,r|0)|0;f[o>>2]=r;x=f[p>>2]|0;y=r}r=x+y|0;f[m>>2]=r;t=r}K1a(t|0,d|0,e|0)|0;f[m>>2]=t+e;u=g;return}MW(a,c,1,0,0);t=a+72|0;m=f[t>>2]|0;r=a+80|0;y=f[r>>2]|0;if((m+e|0)>>>0<y>>>0)z=m;else{x=a+76|0;p=f[x>>2]|0;o=m-p|0;m=((y-p|0)*3|0)/2|0;p=o+e|0;y=(p|0)<(m|0)?m:p;p=_F(y+256|0)|0;m=f[x>>2]|0;f[t>>2]=p+((f[t>>2]|0)-m);if((o|0)>0)K1a(p|0,m|0,o|0)|0;f[x>>2]=p;f[r>>2]=p+y;z=p+o|0}K1a(z|0,d|0,e|0)|0;f[t>>2]=z+e;MW(a,c,2,0,0);u=g;return}function MW(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;h=u;u=u+16|0;i=e;j=g;g=h;k=a+72|0;l=f[k>>2]|0;m=a+44|0;n=f[m>>2]|0;if(!c)o=0;else o=(b[c>>0]|0)==0?0:c;c=(d|0)==3;if((d|2|0)==3){p=n&7;if(p>>>0>4)if((p|0)==6^(o|0)!=0){f[g>>2]=0;f[g+4>>2]=0;q=c$(g,85)|0;r=182568;s=q+85|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));j$(-5,g,182973,177754,2892);d$(g);t=n}else t=n;else{f[a+12>>2]=0;t=o|0?38:37}if(!(t&32)){p=f[k>>2]|0;v=a+76|0;w=f[v>>2]|0;x=a+56|0;y=f[x>>2]|0;if(p>>>0>(w+y|0)>>>0){b[p>>0]=10;b[p+1>>0]=0;lV(a,f[v>>2]|0);p=f[v>>2]|0;f[k>>2]=p;z=f[x>>2]|0;A=p}else{z=y;A=w}w=f[a+40>>2]|0;if((z|0)==(w|0)){B=A;C=z}else{F1a(A|0,32,w|0)|0;f[x>>2]=w;B=f[v>>2]|0;C=w}w=B+C|0;f[k>>2]=w;D=w;E=t}else{D=l;E=t}}else{D=l;E=n}if(o)if((b[o>>0]|0)==95?(b[o+1>>0]|0)==0:0){f[g>>2]=0;f[g+4>>2]=0;q=c$(g,33)|0;r=182988;s=q+33|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));j$(-5,g,182973,177754,2907);d$(g);F=o}else F=o;else F=183022;o=xKa(F)|0;n=D+1|0;b[D>>0]=60;if((d|0)==2){if(e|0){f[g>>2]=0;f[g+4>>2]=0;q=c$(g,45)|0;r=183024;s=q+45|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));j$(-5,g,182973,177754,2914);d$(g)}b[n>>0]=47;G=D+2|0}else G=n;n=b[F>>0]|0;if(!(((n&-33)+-65&255)<26|n<<24>>24==95)){f[g>>2]=0;f[g+4>>2]=0;q=c$(g,35)|0;r=183070;s=q+35|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));j$(-5,g,182973,177754,2919);d$(g)}n=a+80|0;D=f[n>>2]|0;if((G+o|0)>>>0<D>>>0)H=G;else{e=a+76|0;d=f[e>>2]|0;l=G-d|0;G=((D-d|0)*3|0)/2|0;d=l+o|0;D=(d|0)<(G|0)?G:d;d=_F(D+256|0)|0;G=f[e>>2]|0;f[k>>2]=d+((f[k>>2]|0)-G);if((l|0)>0)K1a(d|0,G|0,l|0)|0;f[e>>2]=d;f[n>>2]=d+D;H=d+l|0}if((o|0)>0){l=g+4|0;d=0;do{D=b[F+d>>0]|0;a:do if(!((D+-48&255)<10|((D&-33)+-65&255)<26)){switch(D<<24>>24){case 45:case 95:{break a;break}default:{}}f[g>>2]=0;f[l>>2]=0;q=c$(g,74)|0;r=183106;s=q+74|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));j$(-5,g,182973,177754,2926);d$(g)}while(0);b[H+d>>0]=D;d=d+1|0}while((d|0)<(o|0))}d=a+76|0;a=i;i=j;j=H+o|0;while(1){if((a|0)!=0?(o=a,H=f[o>>2]|0,(H|0)!=0):0){g=H;H=o;o=j;while(1){r=xKa(g)|0;q=H+4|0;s=xKa(f[q>>2]|0)|0;l=r+4+s|0;F=f[n>>2]|0;if((o+l|0)>>>0<F>>>0)I=o;else{e=f[d>>2]|0;G=o-e|0;t=((F-e|0)*3|0)/2|0;e=G+l|0;l=(e|0)<(t|0)?t:e;e=_F(l+256|0)|0;t=f[d>>2]|0;f[k>>2]=e+((f[k>>2]|0)-t);if((G|0)>0)K1a(e|0,t|0,G|0)|0;f[d>>2]=e;f[n>>2]=e+l;I=e+G|0}G=I+1|0;b[I>>0]=32;K1a(G|0,f[H>>2]|0,r|0)|0;e=G+r|0;r=e+1|0;b[e>>0]=61;e=r+1|0;b[r>>0]=34;K1a(e|0,f[q>>2]|0,s|0)|0;q=e+s|0;s=q+1|0;b[q>>0]=34;H=H+8|0;g=f[H>>2]|0;if(!g){J=s;break}else o=s}}else J=j;if(!i)break;a=f[i>>2]|0;i=f[i+4>>2]|0;j=J}if(!c){K=J;L=K+1|0;b[K>>0]=62;f[k>>2]=L;M=E&-33;f[m>>2]=M;u=h;return}b[J>>0]=47;K=J+1|0;L=K+1|0;b[K>>0]=62;f[k>>2]=L;M=E&-33;f[m>>2]=M;u=h;return}function NW(a,c){a=a|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d+8|0;g=d;p[s>>3]=c;h=f[s+4>>2]|0;if((h&2146435072|0)==2146435072)if(((h&2147483647)+((f[s>>2]|0)!=0&1)|0)>>>0>2146435072){b[a>>0]=b[183191]|0;b[a+1>>0]=b[183192]|0;b[a+2>>0]=b[183193]|0;b[a+3>>0]=b[183194]|0;b[a+4>>0]=b[183195]|0;u=d;return a|0}else{ZKa(a,(h|0)<0?183196:183202)|0;u=d;return a|0}h=rNa(c)|0;if(+(h|0)==c){f[g>>2]=h;SLa(a,183181,g)|0;u=d;return a|0}p[e>>3]=c;SLa(a,183185,e)|0;switch(b[a>>0]|0){case 45:case 43:{i=a+1|0;break}default:i=a}while(1){j=b[i>>0]|0;if((j+-48&255)<10)i=i+1|0;else break}if(j<<24>>24!=44){u=d;return a|0}b[i>>0]=46;u=d;return a|0}function OW(){var a=0,b=0;a=u;u=u+48|0;b=a;f[b>>2]=0;f[b+4>>2]=40;f[b+16>>2]=183695;f[b+12>>2]=0;f[b+8>>2]=0;f[b+20>>2]=216;f[b+24>>2]=945;f[b+36>>2]=217;f[b+28>>2]=148;f[b+32>>2]=149;UW(b);f[225396]=f[225394];Fd(946,901584,x|0)|0;f[b>>2]=0;f[b+4>>2]=40;f[b+16>>2]=183711;f[b+12>>2]=0;f[b+8>>2]=0;f[b+20>>2]=216;f[b+24>>2]=945;f[b+36>>2]=217;f[b+28>>2]=149;f[b+32>>2]=149;UW(b);f[225397]=f[225394];Fd(946,901588,x|0)|0;f[b>>2]=0;f[b+4>>2]=40;f[b+16>>2]=183732;f[b+12>>2]=0;f[b+8>>2]=0;f[b+20>>2]=218;f[b+24>>2]=947;f[b+36>>2]=219;f[b+28>>2]=150;f[b+32>>2]=150;UW(b);f[225398]=f[225394];Fd(946,901592,x|0)|0;f[b>>2]=0;f[b+4>>2]=40;f[b+16>>2]=183745;f[b+12>>2]=0;f[b+8>>2]=0;f[b+20>>2]=220;f[b+24>>2]=948;f[b+36>>2]=221;f[b+28>>2]=151;f[b+32>>2]=151;UW(b);f[225399]=f[225394];Fd(946,901596,x|0)|0;f[b>>2]=0;f[b+4>>2]=40;f[b+16>>2]=183766;f[b+12>>2]=0;f[b+8>>2]=0;f[b+20>>2]=222;f[b+24>>2]=949;f[b+36>>2]=223;f[b+28>>2]=152;f[b+32>>2]=152;UW(b);f[225400]=f[225394];Fd(946,901600,x|0)|0;f[b>>2]=0;f[b+4>>2]=40;f[b+16>>2]=183779;f[b+12>>2]=0;f[b+8>>2]=0;f[b+20>>2]=224;f[b+24>>2]=950;f[b+36>>2]=225;f[b+28>>2]=153;f[b+32>>2]=153;UW(b);f[225401]=f[225394];Fd(946,901604,x|0)|0;f[b>>2]=0;f[b+4>>2]=40;f[b+16>>2]=183793;f[b+12>>2]=0;f[b+8>>2]=0;f[b+20>>2]=226;f[b+24>>2]=951;f[b+36>>2]=227;f[b+28>>2]=154;f[b+32>>2]=154;UW(b);f[225402]=f[225394];Fd(946,901608,x|0)|0;u=a;return}function PW(a){a=a|0;var b=0;if(!a)b=0;else b=(f[a>>2]&-65536|0)==1117323264;return b&1|0}function QW(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;if(a|0){f[a>>2]=0;u=c;return}f[d>>2]=0;f[d+4>>2]=0;e=c$(d,19)|0;g=186213;h=e+19|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));j$(-27,d,186952,177754,5729);d$(d);f[a>>2]=0;u=c;return}function RW(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+16|0;c=b+8|0;d=b;e=d;f[e>>2]=0;f[e+4>>2]=0;f[d+4>>2]=1073741823;f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];d=SL(a,c,0,1)|0;u=b;return d|0}function SW(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=u;u=u+1072|0;e=d+552|0;g=d+520|0;h=d+8|0;i=d;f[i>>2]=0;j=CX(a,c,185525)|0;if((j|0)!=0?(f[j>>2]&7|0)==3:0)k=f[j+8+4>>2]|0;else k=0;j=CX(a,c,186737)|0;a:do if(!j)l=-1;else switch(f[j>>2]&7){case 1:{l=f[j+8>>2]|0;break a;break}case 2:{l=rNa(+p[j+8>>3])|0;break a;break}default:{l=2147483647;break a}}while(0);j=CX(a,c,183823)|0;if((j|0)!=0?(f[j>>2]&7|0)==3:0){m=f[j+8+4>>2]|0;if((k|0)!=0&(l|0)!=-1&(m|0)!=0)n=m;else{o=m;q=11}}else{o=0;q=11}if((q|0)==11){f[e>>2]=0;f[e+4>>2]=0;r=c$(e,48)|0;s=186743;t=r+48|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-2,e,186792,177754,5953);d$(e);n=o}if(((b[k>>0]|0)+-48&255)>=10){o=(SKa(k,186803)|0)==0;m=o?1117323264:1117327360;o=(SKa(k,186809)|0)==0;j=o?m:m|16384;m=(SKa(k,186816)|0)==0;o=m?j:j|32768;if(!(SKa(k,186821)|0))v=EX(n)|0|o;else v=o}else{o=lNa(k,i,16)|0;if(!((o&-65536|0)==1117323264?(f[i>>2]|0)!=(k|0):0)){f[e>>2]=0;f[e+4>>2]=0;r=c$(e,30)|0;s=185942;t=r+30|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-2,e,186792,177754,5970);d$(e)}v=o&33279|o<<2&16384|((o&3584|0)==512?1117327360:1117323264)}o=CX(a,c,185594)|0;if((o|0)!=0?(f[o>>2]&7|0)==3:0)w=f[o+8+4>>2]|0;else w=0;o=CX(a,c,185712)|0;k=(w|0)!=0;i=(o|0)!=0;j=i&1;if(k^i){f[e>>2]=0;f[e+4>>2]=0;r=c$(e,74)|0;s=185973;t=r+74|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-2,e,186792,177754,6004);d$(e)}m=CX(a,c,335733)|0;x=CX(a,c,185234)|0;y=(m|0)!=0;z=(x|0)!=0;if(((y&1)+j+(z&1)|0)>>>0>1){f[e>>2]=0;f[e+4>>2]=0;r=c$(e,66)|0;s=186829;t=r+66|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-2,e,186792,177754,6010);d$(e)}if(k){j=AW(w,e)|0;A=j<<1;if((j|0)>0){j=0;B=56;while(1){C=f[e+((j|1)<<2)>>2]|0;D=(C>>>3&511)+1<<(47696>>>(C<<1&14)&3);C=(B+-1+D&0-D)+(Y(D,f[e+(j<<2)>>2]|0)|0)|0;j=j+2|0;if((j|0)>=(A|0)){E=C;break}else B=C}}else E=56;F=e;G=e;H=E}else{F=e;G=e;H=y?88:z?64:56}F=AW(n,G)|0;G=F<<1;if((F|0)>0){F=0;E=0;while(1){B=f[e+((F|1)<<2)>>2]|0;A=(B>>>3&511)+1<<(47696>>>(B<<1&14)&3);B=(E+-1+A&0-A)+(Y(A,f[e+(F<<2)>>2]|0)|0)|0;F=F+2|0;if((F|0)>=(G|0)){I=B;break}else E=B}}else I=0;E=f[e+4>>2]|0;G=(E>>>3&511)+1<<(47696>>>(E<<1&14)&3);E=yL(v,H,I+-1+G&0-G,f[a+20>>2]|0)|0;do if(i){if(!k){f[e>>2]=0;f[e+4>>2]=0;r=c$(e,9)|0;s=185594;t=r+9|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-215,e,186792,177754,6026);d$(e)}DX(a,o,E+56|0,w)}else{if(!y){if(!z)break;G=CX(a,x,185271)|0;b:do if(!G)J=0;else switch(f[G>>2]&7){case 1:{J=f[G+8>>2]|0;break b;break}case 2:{J=rNa(+p[G+8>>3])|0;break b;break}default:{J=2147483647;break b}}while(0);f[E+56>>2]=J;G=CX(a,x,185273)|0;c:do if(!G)K=0;else switch(f[G>>2]&7){case 1:{K=f[G+8>>2]|0;break c;break}case 2:{K=rNa(+p[G+8>>3])|0;break c;break}default:{K=2147483647;break c}}while(0);f[E+60>>2]=K;break}G=CX(a,m,185271)|0;d:do if(!G)L=0;else switch(f[G>>2]&7){case 1:{L=f[G+8>>2]|0;break d;break}case 2:{L=rNa(+p[G+8>>3])|0;break d;break}default:{L=2147483647;break d}}while(0);f[E+56>>2]=L;G=CX(a,m,185273)|0;e:do if(!G)M=0;else switch(f[G>>2]&7){case 1:{M=f[G+8>>2]|0;break e;break}case 2:{M=rNa(+p[G+8>>3])|0;break e;break}default:{M=2147483647;break e}}while(0);f[E+60>>2]=M;G=CX(a,m,337923)|0;f:do if(!G)N=0;else switch(f[G>>2]&7){case 1:{N=f[G+8>>2]|0;break f;break}case 2:{N=rNa(+p[G+8>>3])|0;break f;break}default:{N=2147483647;break f}}while(0);f[E+64>>2]=N;G=CX(a,m,337929)|0;g:do if(!G)O=0;else switch(f[G>>2]&7){case 1:{O=f[G+8>>2]|0;break g;break}case 2:{O=rNa(+p[G+8>>3])|0;break g;break}default:{O=2147483647;break g}}while(0);f[E+68>>2]=O;G=CX(a,c,185698)|0;h:do if(!G)P=0;else switch(f[G>>2]&7){case 1:{P=f[G+8>>2]|0;break h;break}case 2:{P=rNa(+p[G+8>>3])|0;break h;break}default:{P=2147483647;break h}}while(0);f[E+72>>2]=P}while(0);PL(E,0,l,0);P=AW(n,h)|0;O=P<<1;if((P|0)>0){P=0;m=0;while(1){N=(f[h+(P<<2)>>2]|0)+m|0;P=P+2|0;if((P|0)>=(O|0)){Q=N;break}else m=N}}else Q=0;m=CX(a,c,183826)|0;if(!m){f[e>>2]=0;f[e+4>>2]=0;r=c$(e,43)|0;s=185374;t=r+43|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-2,e,186792,177754,6053);d$(e)}c=f[m>>2]&7;if(c>>>0>4)R=f[(f[m+8>>2]|0)+24>>2]|0;else R=(c|0)!=0&1;if((R|0)!=(Y(Q,l)|0)){f[e>>2]=0;f[e+4>>2]=0;r=c$(e,55)|0;s=186896;t=r+55|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-2,e,186792,177754,6056);d$(e)}FX(a,m,g);m=E+52|0;e=f[m>>2]|0;if(!e){u=d;return E|0}else S=e;while(1){e=Y(f[S+12>>2]|0,Q)|0;GX(a,g,e,f[S+16>>2]|0,n);if((S|0)==(f[f[m>>2]>>2]|0)){q=80;break}S=f[S+4>>2]|0;if(!S){q=80;break}}if((q|0)==80){u=d;return E|0}return 0}function TW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+48|0;g=e+32|0;h=e+8|0;i=e+24|0;j=e;k=d;a:do{l=f[k>>2]|0;if(!l)break;m=f[l>>2]|0;if(m|0){n=m;m=0;o=0;while(1){m=m+1|0;if(!(KKa(186705,n)|0)){p=7;break a}q=m<<1;n=f[l+(q<<2)>>2]|0;if(!n)break;else o=q}}k=f[k+4>>2]|0}while((k|0)!=0);if((((((p|0)==7?(p=f[l+((o|1)<<2)>>2]|0,p|0):0)?KKa(p,199416)|0:0)?KKa(p,374213)|0:0)?KKa(p,199418)|0:0)?KKa(p,199424)|0:0){f[i>>2]=0;f[i+4>>2]=0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];nX(a,b,6,183711,g);f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2];nX(a,186249,5,0,g);bM(h,c,2147483647);g=f[h>>2]|0;if(g|0){j=f[d>>2]|0;i=d+4|0;p=h+4|0;o=g;do{MX(a,0,o,j,f[i>>2]|0,f[p>>2]|0);cM(h)|0;o=f[h>>2]|0}while((o|0)!=0)}kV(a);kV(a);u=e;return}MX(a,b,c,f[d>>2]|0,f[d+4>>2]|0,-1);u=e;return}function UW(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+16|0;d=c;if(!((a|0)!=0?(f[a+4>>2]|0)==40:0)){f[d>>2]=0;f[d+4>>2]=0;e=c$(d,17)|0;g=186493;h=e+17|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));j$(-201,d,186511,177754,6559);d$(d)}if(!((((f[a+20>>2]|0)!=0?(f[a+24>>2]|0)!=0:0)?(f[a+28>>2]|0)!=0:0)?(f[a+32>>2]|0)!=0:0)){f[d>>2]=0;f[d+4>>2]=0;e=c$(d,81)|0;g=186526;h=e+81|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));j$(-27,d,186511,177754,6565);d$(d)}i=a+16|0;j=f[i>>2]|0;k=b[j>>0]|0;if(k<<24>>24==95|((k&-33)+-65&255)<26)l=j;else{f[d>>2]=0;f[d+4>>2]=0;e=c$(d,41)|0;g=186608;h=e+41|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));j$(-5,d,186511,177754,6569);d$(d);l=f[i>>2]|0}j=xKa(l)|0;a:do if((j|0)>0){k=d+4|0;m=l;n=0;while(1){o=b[m+n>>0]|0;b:do if(!((o+-48&255)<10|((o&-33)+-65&255)<26)){switch(o<<24>>24){case 45:case 95:{break b;break}default:{}}f[d>>2]=0;f[k>>2]=0;e=c$(d,54)|0;g=186650;h=e+54|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));j$(-5,d,186511,177754,6578);d$(d)}while(0);o=n+1|0;if((o|0)>=(j|0))break a;m=f[i>>2]|0;n=o}}while(0);d=_F(j+41|0)|0;e=d;g=a;h=e+40|0;do{f[e>>2]=f[g>>2];e=e+4|0;g=g+4|0}while((e|0)<(h|0));g=d+40|0;f[d+16>>2]=g;K1a(g|0,f[i>>2]|0,j+1|0)|0;f[d>>2]=0;j=f[225394]|0;f[d+12>>2]=j;f[d+8>>2]=0;f[(j|0?j+8|0:901580)>>2]=d;f[225394]=d;u=c;return}function VW(a){a=a|0;var b=0,c=0,d=0;b=f[(f[a>>2]|0)+16>>2]|0;if(!b)return;a=f[225394]|0;if(!a)return;else c=a;while(1){if(!(KKa(f[c+16>>2]|0,b)|0))break;a=f[c+12>>2]|0;if(!a){d=8;break}else c=a}if((d|0)==8)return;d=c+8|0;b=f[d>>2]|0;a=c+12|0;f[((b|0)==0?901576:b+12|0)>>2]=f[a>>2];b=f[a>>2]|0;f[((b|0)==0?901580:b+8|0)>>2]=f[d>>2];if(!((f[225394]|0)!=0&(f[225395]|0)!=0)){f[225395]=0;f[225394]=0}$F(c);return}function WW(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+8|0;g=d;h=CX(a,c,186249)|0;if(!((h|0)!=0?(f[h>>2]&7|0)==5:0)){f[g>>2]=0;f[g+4>>2]=0;i=c$(g,90)|0;j=186259;k=i+90|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-212,g,186350,177754,6087);d$(g)}c=f[h+8>>2]|0;h=f[c+24>>2]|0;CL(c,e,0);if((h|0)<=0){l=0;u=d;return l|0}m=e+12|0;n=g+4|0;o=g+4|0;q=c+28|0;c=e+20|0;r=0;s=0;t=0;v=0;w=0;x=0;while(1){y=f[m>>2]|0;z=w;w=LX(a,y,0)|0;if(!w){f[g>>2]=0;f[n>>2]=0;A=c$(g,3)|0;b[A>>0]=b[180848]|0;b[A+1>>0]=b[180849]|0;b[A+2>>0]=b[180850]|0;j$(-215,g,186350,177754,6099);d$(g)}A=CX(a,y,186365)|0;a:do if(A){switch(f[A>>2]&7){case 1:{B=f[A+8>>2]|0;break}case 2:{B=rNa(+p[A+8>>3])|0;break}default:{C=2147483647;break a}}if((B|0)<0){D=B;E=13}else C=B}else{D=-1;E=13}while(0);if((E|0)==13){E=0;f[g>>2]=0;f[o>>2]=0;i=c$(g,56)|0;j=186371;k=i+56|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-212,g,186350,177754,6102);d$(g);C=D}A=(x|0)==0;y=A?w:r;x=A?w:x;if((C|0)<=(v|0)){if((C|0)<(v|0)){A=v;F=z;while(1){G=f[F+16>>2]|0;if((A|0)>(C|0)){A=A+-1|0;F=G}else{H=G;I=F;break}}}else{H=t;I=z}f[w+8>>2]=I;if(!I)J=H;else{f[I+12>>2]=w;J=H}}else{if(z|0)f[z+20>>2]=w;f[w+8>>2]=0;J=z}f[w+16>>2]=J;F=(f[m>>2]|0)+(f[q>>2]|0)|0;f[m>>2]=F;if(F>>>0>=(f[c>>2]|0)>>>0)LL(e,1);s=s+1|0;if((s|0)>=(h|0)){l=y;break}else{r=y;t=J;v=C}}u=d;return l|0}function XW(a){a=a|0;var b=0;if(!a)b=0;else b=(f[a>>2]&-53248|0)==1117261824;return b&1|0}function YW(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;if(a|0){f[a>>2]=0;u=c;return}f[d>>2]=0;f[d+4>>2]=0;e=c$(d,19)|0;g=186213;h=e+19|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));j$(-27,d,186233,177754,6145);d$(d);f[a>>2]=0;u=c;return}function ZW(a){a=a|0;return $L(a,0)|0}function _W(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;d=u;u=u+1184|0;e=d;g=d+664|0;h=d+152|0;i=d+144|0;j=d+16|0;k=d+8|0;f[i>>2]=0;l=CX(a,c,185525)|0;if((l|0)!=0?(f[l>>2]&7|0)==3:0)m=f[l+8+4>>2]|0;else m=0;l=CX(a,c,185544)|0;if((l|0)!=0?(f[l>>2]&7|0)==3:0)n=f[l+8+4>>2]|0;else n=0;l=CX(a,c,185565)|0;if((l|0)!=0?(f[l>>2]&7|0)==3:0)o=f[l+8+4>>2]|0;else o=0;l=CX(a,c,185531)|0;a:do if(!l)q=-1;else switch(f[l>>2]&7){case 1:{q=f[l+8>>2]|0;break a;break}case 2:{q=rNa(+p[l+8>>3])|0;break a;break}default:{q=2147483647;break a}}while(0);l=CX(a,c,185554)|0;b:do if(!l)r=-1;else switch(f[l>>2]&7){case 1:{r=f[l+8>>2]|0;break b;break}case 2:{r=rNa(+p[l+8>>3])|0;break b;break}default:{r=2147483647;break b}}while(0);if(!((o|0)!=0&(((m|0)==0|(q|0)==-1|(r|0)==-1)^1))){f[g>>2]=0;f[g+4>>2]=0;s=c$(g,45)|0;t=185883;v=s+45|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-2,g,185929,177754,6324);d$(g)}if(!(fNa(b[m>>0]|0)|0))w=(SKa(m,185516)|0)==0;else{l=lNa(m,i,16)|0;if(!((l&-65536|0)==1117257728?(f[i>>2]|0)!=(m|0):0)){f[g>>2]=0;f[g+4>>2]=0;s=c$(g,30)|0;t=185942;v=s+30|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-2,g,185929,177754,6337);d$(g)}w=(l&4096|0)==0}l=w?1117261824:1117278208;w=CX(a,c,185594)|0;if((w|0)!=0?(f[w>>2]&7|0)==3:0)x=f[w+8+4>>2]|0;else x=0;w=CX(a,c,185712)|0;m=(x|0)!=0;y=(w|0)!=0;if(m^y){f[g>>2]=0;f[g+4>>2]=0;s=c$(g,74)|0;t=185973;v=s+74|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-2,g,185929,177754,6352);d$(g)}if(m){z=AW(x,g)|0;A=z<<1;if((z|0)>0){z=0;B=68;while(1){C=f[g+((z|1)<<2)>>2]|0;D=(C>>>3&511)+1<<(47696>>>(C<<1&14)&3);C=(B+-1+D&0-D)+(Y(D,f[g+(z<<2)>>2]|0)|0)|0;z=z+2|0;if((z|0)>=(A|0)){E=C;break}else B=C}}else E=68;F=E}else F=68;E=(n|0)==0;if(!E){B=AW(n,g)|0;A=B<<1;if((B|0)>0){B=0;z=0;while(1){C=f[g+((B|1)<<2)>>2]|0;D=(C>>>3&511)+1<<(47696>>>(C<<1&14)&3);C=(z+-1+D&0-D)+(Y(D,f[g+(B<<2)>>2]|0)|0)|0;B=B+2|0;if((B|0)>=(A|0)){G=C;break}else z=C}}else G=0;z=f[g+4>>2]|0;A=(z>>>3&511)+1<<(47696>>>(z<<1&14)&3);z=G+-1+A&0-A;A=AW(n,g)|0;G=A<<1;if((A|0)>0){A=0;B=8;while(1){C=f[g+((A|1)<<2)>>2]|0;D=(C>>>3&511)+1<<(47696>>>(C<<1&14)&3);C=(B+-1+D&0-D)+(Y(D,f[g+(A<<2)>>2]|0)|0)|0;A=A+2|0;if((A|0)>=(G|0)){H=C;break}else B=C}}else H=8;B=AW(o,h)|0;G=B<<1;if((B|0)>0){B=0;A=0;while(1){C=(f[h+(B<<2)>>2]|0)+A|0;B=B+2|0;if((B|0)>=(G|0)){I=h;J=z;K=C;L=H;break}else A=C}}else{I=h;J=z;K=0;L=H}}else{I=h;J=0;K=0;L=8}H=AW(o,I)|0;z=f[I>>2]|0;if(!((((H|0)>1&(z|0)==2?(f[h+4>>2]|0)==4:0)?(f[h+8>>2]|0)>=1:0)?(f[h+12>>2]|0)==5:0)){f[g>>2]=0;f[g+4>>2]=0;s=c$(g,52)|0;t=186048;v=s+52|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-5,g,185929,177754,6378);d$(g)}if((H|0)<=2)if((H|0)>0){M=4;N=50}else{O=0;P=4}else{I=f[h+20>>2]|0;M=((I>>>3&511)+1<<(47696>>>(I<<1&14)&3)|0)>7?8:4;N=50}if((N|0)==50){I=H<<1;if((I|0)>2){H=z;A=2;while(1){G=(f[h+(A<<2)>>2]|0)+H|0;A=A+2|0;if((A|0)>=(I|0)){O=G;P=M;break}else H=G}}else{O=z;P=M}}M=o+2|0;z=b[M>>0]|0;switch(z<<24>>24){case 102:{N=54;break}case 49:{if((b[o+3>>0]|0)==102)N=54;else N=55;break}default:N=55}if((N|0)==54)Q=o+3+((z+-48&255)<10&1)|0;else if((N|0)==55){N=(lNa(M,i,10)|0)+-1|0;M=f[i>>2]|0;f[e>>2]=N;f[e+4>>2]=M;SLa(j,186101,e)|0;Q=j}e=AW(Q,g)|0;Q=e<<1;if((e|0)>0){e=0;M=24;while(1){N=f[g+((e|1)<<2)>>2]|0;i=(N>>>3&511)+1<<(47696>>>(N<<1&14)&3);N=(M+-1+i&0-i)+(Y(i,f[g+(e<<2)>>2]|0)|0)|0;e=e+2|0;if((e|0)>=(Q|0)){R=N;break}else M=N}}else R=24;M=AW(o,g)|0;Q=M<<1;if((M|0)>0){M=0;e=0;do{N=f[g+((M|1)<<2)>>2]|0;i=(N>>>3&511)+1<<(47696>>>(N<<1&14)&3);e=(e+-1+i&0-i)+(Y(i,f[g+(M<<2)>>2]|0)|0)|0;M=M+2|0}while((M|0)<(Q|0));S=e+-1|0}else S=-1;e=f[g+4>>2]|0;Q=(e>>>3&511)+1<<(47696>>>(e<<1&14)&3);e=S+Q&0-Q;Q=XL(l,F,L,R,f[a+20>>2]|0)|0;if(y){if(!m){f[g>>2]=0;f[g+4>>2]=0;s=c$(g,9)|0;t=185594;v=s+9|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,g,185929,177754,6405);d$(g)}DX(a,w,Q+68|0,x)}x=J*3|0;w=(x|0)>65536?x:65536;x=e*3|0;m=(x|0)<(w|0)?w:x;x=_F(m)|0;w=_F(q<<2)|0;y=CX(a,c,185579)|0;F=CX(a,c,185588)|0;if(!F){f[g>>2]=0;f[g+4>>2]=0;s=c$(g,13)|0;t=186107;v=s+13|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-5,g,185929,177754,6417);d$(g)}if(!(E|(y|0)!=0)){f[g>>2]=0;f[g+4>>2]=0;s=c$(g,16)|0;t=186121;v=s+16|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-5,g,185929,177754,6419);d$(g)}E=k+4|0;c=P+-1|0;l=0-P|0;P=k+4|0;S=0;do{M=(S|0)==0;i=M?n:o;N=M?L:R;z=M?J:e;H=M?K:O;I=M?q:r;A=(m>>>0)/(((z|0)>1?z:1)>>>0)|0;h=(i|0)!=0;if(h)FX(a,M?y:F,g);c:do if((I|0)>0){G=(N|0)>24;B=N+-24|0;if(h){T=x;U=0;V=0}else{C=x;D=0;while(1){if(!M){f[j>>2]=0;W=f[C>>2]|0;X=f[C+4>>2]|0;if(!(W>>>0<q>>>0&X>>>0<q>>>0)){f[k>>2]=0;f[P>>2]=0;s=c$(k,46)|0;t=186138;v=s+46|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-211,k,185929,177754,6464);d$(k)}if(!(_L(Q,f[w+(W<<2)>>2]|0,f[w+(X<<2)>>2]|0,0,j)|0)){f[k>>2]=0;f[E>>2]=0;s=c$(k,27)|0;t=186185;v=s+27|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-5,k,185929,177754,6470);d$(k)}X=f[j>>2]|0;f[X+4>>2]=f[C+8>>2];if(G)K1a(X+24|0,c+(C+12)&l|0,B|0)|0}else{YL(Q,0,j)|0;f[w+(D<<2)>>2]=f[j>>2]}D=D+1|0;if((I|0)<=(D|0))break c;else C=C+z|0}}while(1){C=I-U|0;D=Y((C|0)>(A|0)?A:C,H)|0;if(!V){GX(a,g,D,x,i);Z=x;_=D}else{Z=T;_=V}if(!M){f[j>>2]=0;D=f[Z>>2]|0;C=f[Z+4>>2]|0;if(!(D>>>0<q>>>0&C>>>0<q>>>0)){f[k>>2]=0;f[P>>2]=0;s=c$(k,46)|0;t=186138;v=s+46|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-211,k,185929,177754,6464);d$(k)}if(!(_L(Q,f[w+(D<<2)>>2]|0,f[w+(C<<2)>>2]|0,0,j)|0)){f[k>>2]=0;f[E>>2]=0;s=c$(k,27)|0;t=186185;v=s+27|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-5,k,185929,177754,6470);d$(k)}C=f[j>>2]|0;f[C+4>>2]=f[Z+8>>2];if(G)K1a(C+24|0,c+(Z+12)&l|0,B|0)|0}else{YL(Q,0,j)|0;f[w+(U<<2)>>2]=f[j>>2];K1a((f[j>>2]|0)+8|0,Z|0,z|0)|0}U=U+1|0;if((I|0)<=(U|0))break;else{T=Z+z|0;V=_+-1|0}}}while(0);S=S+1|0}while((S|0)<2);$F(x);$F(w);u=d;return Q|0}function $W(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0;e=u;u=u+960|0;g=e+56|0;h=e;i=e+24|0;j=e+824|0;k=e+696|0;l=e+568|0;m=e+16|0;n=e+8|0;o=f[c+60>>2]|0;p=c+64|0;q=f[(f[p>>2]|0)+60>>2]|0;r=_F(o<<2)|0;CL(c,i,0);s=c+24|0;if((f[s>>2]|0)>0){t=i+12|0;v=c+28|0;w=i+20|0;x=0;y=0;while(1){z=f[t>>2]|0;A=f[z>>2]|0;if((A|0)>-1){f[r+(y<<2)>>2]=A;f[z>>2]=y;B=y+1|0}else B=y;A=z+(f[v>>2]|0)|0;f[t>>2]=A;if(A>>>0>=(f[w>>2]|0)>>>0)LL(i,1);x=x+1|0;if((x|0)>=(f[s>>2]|0))break;else y=B}}f[m>>2]=0;f[m+4>>2]=0;f[g>>2]=f[m>>2];f[g+4>>2]=f[m+4>>2];nX(a,b,6,183732,g);pX(a,185525,f[c>>2]&16384|0?185516:5694105,1);HX(a,185531,o);o=JX(c,185544,d,8,k)|0;if(o|0)pX(a,185544,o,0);HX(a,185554,q);q=JX(f[p>>2]|0,185565,d,24,j)|0;f[h>>2]=q|0?q:5694105;SLa(l,185573,h)|0;pX(a,185565,l,0);KX(a,c,d,68);d=c+28|0;h=(f[d>>2]|0)*3|0;q=(h|0)>65536?h:65536;h=(f[(f[p>>2]|0)+28>>2]|0)*3|0;j=(h|0)<(q|0)?q:h;h=_F(j)|0;q=g+4|0;k=g+20|0;b=n+4|0;m=i+12|0;B=i+20|0;y=0;do{x=(y|0)==0;w=x?o:l;if(w|0){if(x)C=c;else C=f[p>>2]|0;t=C+28|0;v=f[t>>2]|0;A=AW(w,g)|0;z=A<<1;if((A|0)>0){A=0;D=0;while(1){E=f[g+((A|1)<<2)>>2]|0;F=(E>>>3&511)+1<<(47696>>>(E<<1&14)&3);E=(D+-1+F&0-F)+(Y(F,f[g+(A<<2)>>2]|0)|0)|0;A=A+2|0;if((A|0)>=(z|0)){G=E;break}else D=E}}else G=0;D=f[q>>2]|0;z=(D>>>3&511)+1<<(47696>>>(D<<1&14)&3);D=G+-1+z&0-z;z=(j|0)/(D|0)|0;if((y|0)==1){if((AW(w,g)|0)>2){A=f[k>>2]|0;H=((A>>>3&511)+1<<(47696>>>(A<<1&14)&3)|0)>7?8:4}else H=4;I=H}else I=4;f[n>>2]=0;f[b>>2]=0;f[g>>2]=f[n>>2];f[g+4>>2]=f[n+4>>2];nX(a,x?185579:185588,13,0,g);CL(C,i,0);A=C+24|0;if((f[A>>2]|0)>0){E=v+-24|0;F=I+-1|0;J=0-I|0;if(!x)if((v|0)>24){K=0;L=h;M=0;while(1){N=f[m>>2]|0;if((f[N>>2]|0)>-1){O=L+3&-4;P=O;f[O>>2]=f[f[N+16>>2]>>2];f[P+4>>2]=f[f[N+20>>2]>>2];f[P+8>>2]=f[N+4>>2];K1a(F+(P+12)&J|0,N+24|0,E|0)|0;N=M+1|0;if((N|0)<(z|0)){Q=P+D|0;R=N}else{oX(a,h,N,w);Q=h;R=0}}else{Q=L;R=M}N=(f[m>>2]|0)+(f[t>>2]|0)|0;f[m>>2]=N;if(N>>>0>=(f[B>>2]|0)>>>0)LL(i,1);K=K+1|0;if((K|0)>=(f[A>>2]|0)){S=R;break}else{L=Q;M=R}}}else{M=0;L=h;K=0;while(1){E=f[m>>2]|0;if((f[E>>2]|0)>-1){J=L+3&-4;F=J;f[J>>2]=f[f[E+16>>2]>>2];f[F+4>>2]=f[f[E+20>>2]>>2];f[F+8>>2]=f[E+4>>2];J=K+1|0;if((J|0)<(z|0)){T=E;U=F+D|0;V=J}else{oX(a,h,J,w);T=f[m>>2]|0;U=h;V=0}}else{T=E;U=L;V=K}E=T+(f[t>>2]|0)|0;f[m>>2]=E;if(E>>>0>=(f[B>>2]|0)>>>0)LL(i,1);M=M+1|0;if((M|0)>=(f[A>>2]|0)){S=V;break}else{L=U;K=V}}}else{K=0;L=h;M=0;while(1){E=f[m>>2]|0;if((f[E>>2]|0)>-1){K1a(L|0,E+8|0,D|0)|0;E=M+1|0;if((E|0)<(z|0)){W=L+D|0;X=E}else{oX(a,h,E,w);W=h;X=0}}else{W=L;X=M}E=(f[m>>2]|0)+(f[t>>2]|0)|0;f[m>>2]=E;if(E>>>0>=(f[B>>2]|0)>>>0)LL(i,1);K=K+1|0;if((K|0)>=(f[A>>2]|0)){S=X;break}else{L=W;M=X}}}if((S|0)>0)oX(a,h,S,w)}kV(a)}y=y+1|0}while((y|0)!=2);kV(a);CL(c,i,0);c=f[s>>2]|0;if((c|0)>0){Z=c;_=0;$=0}else{$F(h);$F(r);u=e;return}while(1){c=f[m>>2]|0;if((f[c>>2]|0)>-1){f[c>>2]=f[r+($<<2)>>2];aa=$+1|0}else aa=$;a=c+(f[d>>2]|0)|0;f[m>>2]=a;if(a>>>0<(f[B>>2]|0)>>>0)ba=Z;else{LL(i,1);ba=f[s>>2]|0}_=_+1|0;if((_|0)>=(ba|0))break;else{Z=ba;$=aa}}$F(h);$F(r);u=e;return}function aX(a){a=a|0;var b=0;if(!a)b=0;else b=(f[a>>2]&-65536|0)==1111752704;return b&1|0}function bX(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+8240|0;e=d+8200|0;g=d+4104|0;h=d+8|0;i=d;j=CX(a,c,183810)|0;k=CX(a,c,183823)|0;if((k|0)!=0?(f[k>>2]&7|0)==3:0){l=f[k+8+4>>2]|0;if((j|0)!=0&(l|0)!=0)m=l;else{n=l;o=4}}else{n=0;o=4}if((o|0)==4){f[h>>2]=0;f[h+4>>2]=0;p=c$(h,46)|0;q=184398;r=p+46|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-2,h,185418,177754,5525);d$(h);m=n}n=f[j>>2]&7;if((n|0)==5)s=f[(f[j+8>>2]|0)+24>>2]|0;else s=(n|0)==1?1:-1;n=s+-1|0;if(n>>>0>31){f[h>>2]=0;f[h+4>>2]=0;p=c$(h,48)|0;q=185435;r=p+48|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-212,h,185418,177754,5531);d$(h)}DX(a,j,g,183816);j=EX(m)|0;o=CX(a,c,183826)|0;if(!((o|0)!=0?(f[o>>2]&7|0)==5:0)){f[h>>2]=0;f[h+4>>2]=0;p=c$(h,44)|0;q=184504;r=p+44|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-2,h,185418,177754,5538);d$(h)}c=H0(s,g,j)|0;g=j>>>3&511;j=g+1|0;l=f[o+8>>2]|0;FX(a,o,e);o=l+24|0;if((f[o>>2]|0)<=0){t=c;u=d;return t|0}k=e+12|0;v=h+(n<<2)|0;w=l+28|0;l=e+20|0;x=g+2|0;g=i+4|0;y=i+4|0;z=0;do{A=f[k>>2]|0;if((f[A>>2]&7|0)!=1){f[i>>2]=0;f[y>>2]=0;p=c$(i,31)|0;q=185484;r=p+31|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-212,i,185418,177754,5553);d$(i)}B=f[A+8>>2]|0;C=(z|0)>0;if(!(C&(B|0)>-1)){if(C)D=n+B|0;else{f[h>>2]=B;D=1}if((D|0)<(s|0)){C=z;E=D;while(1){F=(f[k>>2]|0)+(f[w>>2]|0)|0;f[k>>2]=F;if(F>>>0<(f[l>>2]|0)>>>0)G=F;else{LL(e,1);G=f[k>>2]|0}F=C+1|0;if((f[G>>2]&7|0)==1?(H=f[G+8>>2]|0,(H|0)>=0):0)I=H;else{f[i>>2]=0;f[g>>2]=0;p=c$(i,31)|0;q=185484;r=p+31|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-212,i,185418,177754,5569);d$(i);I=f[G+8>>2]|0}f[h+(E<<2)>>2]=I;E=E+1|0;if((E|0)>=(s|0)){J=F;break}else C=F}}else J=z}else{f[v>>2]=B;J=z}C=(f[k>>2]|0)+(f[w>>2]|0)|0;f[k>>2]=C;if(C>>>0>=(f[l>>2]|0)>>>0)LL(e,1);GX(a,e,j,R0(c,h,0,1,0)|0,m);z=x+J|0}while((z|0)<(f[o>>2]|0));t=c;u=d;return t|0}function cX(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+112|0;g=e+88|0;i=e;j=e+84|0;k=e+72|0;l=e+40|0;m=e+24|0;n=e+96|0;o=e+32|0;p=e+16|0;q=e+8|0;r=pL(0)|0;f[j>>2]=r;f[o>>2]=0;f[o+4>>2]=0;f[g>>2]=f[o>>2];f[g+4>>2]=f[o+4>>2];nX(a,c,6,183745,g);c=P0(d,0)|0;f[m>>2]=c;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=f[p>>2];f[g+4>>2]=f[p+4>>2];nX(a,183810,13,0,g);oX(a,d+36|0,c,183816);kV(a);c=f[d>>2]|0;p=b[180230+(c&7)>>0]|0;f[i>>2]=(c>>>3&511)+1;f[i+4>>2]=p;SLa(n,183818,i)|0;pX(a,183823,n+((b[n+2>>0]|0)==0&(b[n>>0]|0)==49&1)|0,0);f[q>>2]=0;f[q+4>>2]=0;f[g>>2]=f[q>>2];f[g+4>>2]=f[q+4>>2];nX(a,183826,13,0,g);q=yL(7,56,4,r)|0;r=K0(d,k)|0;if(r|0){i=d+32|0;p=k+4|0;c=k+8|0;o=r;a:while(1){f[g>>2]=o+(f[i>>2]|0);NL(q,g)|0;r=f[(f[p>>2]|0)+4>>2]|0;if(!r){s=(f[c>>2]|0)+1|0;f[c>>2]=s;t=f[k>>2]|0;v=f[t+24>>2]|0;if((s|0)>=(v|0))break;w=f[t+20>>2]|0;t=s;while(1){x=f[w+(t<<2)>>2]|0;if(x|0)break;s=t+1|0;if((s|0)<(v|0))t=s;else break a}f[c>>2]=t;y=x}else y=r;f[p>>2]=y;o=y}}TL(q,100,m);CL(q,l,0);y=q+24|0;if((f[y>>2]|0)<=0){kV(a);kV(a);rL(j);u=e;return}q=l+12|0;o=l+20|0;p=d+32|0;x=d+28|0;d=a+236|0;c=0;k=0;do{g=f[q>>2]|0;i=k;k=h[g>>0]|h[g+1>>0]<<8|h[g+2>>0]<<16|h[g+3>>0]<<24;v=g+4|0;f[q>>2]=v;if(v>>>0>=(f[o>>2]|0)>>>0)LL(l,1);if((c|0)>0){v=0;while(1){z=v+1|0;if((f[k+(v<<2)>>2]|0)==(f[i+(v<<2)>>2]|0))v=z;else break}i=f[m>>2]|0;if((v|0)<(i+-1|0)){fi[f[d>>2]&255](a,0,z-i|0);A=v}else A=v}else A=0;if((A|0)<(f[m>>2]|0)){i=A;do{fi[f[d>>2]&255](a,0,f[k+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(f[m>>2]|0))}oX(a,k+(0-(f[p>>2]|0))+(f[x>>2]|0)|0,1,n);c=c+1|0}while((c|0)<(f[y>>2]|0));kV(a);kV(a);rL(j);u=e;return}function dX(a){a=a|0;var b=0;if(!a)b=0;else b=(f[a>>2]|0)==112;return b&1|0}function eX(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+80|0;e=d+56|0;g=d+16|0;h=d+48|0;i=d;j=CX(a,c,337923)|0;a:do if(!j)k=0;else switch(f[j>>2]&7){case 1:{k=f[j+8>>2]|0;break a;break}case 2:{k=rNa(+p[j+8>>3])|0;break a;break}default:{k=2147483647;break a}}while(0);j=CX(a,c,337929)|0;b:do if(!j)l=0;else switch(f[j>>2]&7){case 1:{l=f[j+8>>2]|0;break b;break}case 2:{l=rNa(+p[j+8>>3])|0;break b;break}default:{l=2147483647;break b}}while(0);j=CX(a,c,183823)|0;if((j|0)!=0?(f[j>>2]&7|0)==3:0)m=f[j+8+4>>2]|0;else m=0;j=CX(a,c,185234)|0;if((j|0)!=0?(f[j>>2]&7|0)==3:0)n=f[j+8+4>>2]|0;else n=0;if((k|0)==0|(l|0)==0|(m|0)==0|(n|0)==0){f[e>>2]=0;f[e+4>>2]=0;o=c$(e,45)|0;q=185279;r=o+45|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));j$(-2,e,185325,177754,5666);d$(e)}n=EX(m)|0;j=CX(a,c,185260)|0;if(j)if((f[j>>2]&7|0)==3?(s=f[j+8+4>>2]|0,(s|0)!=0):0){t=s;v=20}else v=21;else{t=185248;v=20}if((v|0)==20?KKa(t,185248)|0:0)v=21;if((v|0)==21){f[e>>2]=0;f[e+4>>2]=0;o=c$(e,35)|0;q=185338;r=o+35|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));j$(-2,e,185325,177754,5671);d$(e)}v=CX(a,c,183826)|0;if(!v){f[e>>2]=0;f[e+4>>2]=0;o=c$(e,43)|0;q=185374;r=o+43|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));j$(-2,e,185325,177754,5675);d$(e)}t=f[v>>2]&7;if(t>>>0>4)w=f[(f[v+8>>2]|0)+24>>2]|0;else w=(t|0)!=0&1;t=Y(l,k)|0;s=(n>>>3&511)+1|0;if((w|0)!=(Y(s,t)|0)){f[e>>2]=0;f[e+4>>2]=0;o=c$(e,63)|0;q=184549;r=o+63|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));j$(-209,e,185325,177754,5679);d$(e)}q=n&7;f[h>>2]=k;f[h+4>>2]=l;f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];h=U0(e,1212424721>>>(q<<2)<<3&120|((q|0)==4|(q|2|0)==3?-2147483648:0),s)|0;q=CX(a,c,185267)|0;if(q|0){c=CX(a,q,185271)|0;c:do if(!c)x=0;else switch(f[c>>2]&7){case 1:{x=f[c+8>>2]|0;break c;break}case 2:{x=rNa(+p[c+8>>3])|0;break c;break}default:{x=2147483647;break c}}while(0);c=CX(a,q,185273)|0;d:do if(!c)y=0;else switch(f[c>>2]&7){case 1:{y=f[c+8>>2]|0;break d;break}case 2:{y=rNa(+p[c+8>>3])|0;break d;break}default:{y=2147483647;break d}}while(0);c=CX(a,q,337923)|0;e:do if(!c)z=0;else switch(f[c>>2]&7){case 1:{z=f[c+8>>2]|0;break e;break}case 2:{z=rNa(+p[c+8>>3])|0;break e;break}default:{z=2147483647;break e}}while(0);c=CX(a,q,337929)|0;f:do if(!c)A=0;else switch(f[c>>2]&7){case 1:{A=f[c+8>>2]|0;break f;break}case 2:{A=rNa(+p[c+8>>3])|0;break f;break}default:{A=2147483647;break f}}while(0);c=CX(a,q,185275)|0;g:do if(!c)B=0;else switch(f[c>>2]&7){case 1:{B=f[c+8>>2]|0;break g;break}case 2:{B=rNa(+p[c+8>>3])|0;break g;break}default:{B=2147483647;break g}}while(0);f[i>>2]=x;f[i+4>>2]=y;f[i+8>>2]=z;f[i+12>>2]=A;f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];W0(h,e);X0(h,B)}B=Y(s<<(47696>>>(n<<1&14)&3),k)|0;n=h+72|0;e=(B|0)==(f[n>>2]|0);B=e?1:l;l=Y(e?t:k,s)|0;FX(a,v,g);if((B|0)<=0){u=d;return h|0}v=h+68|0;s=0;do{GX(a,g,l,(f[v>>2]|0)+(Y(f[n>>2]|0,s)|0)|0,m);s=s+1|0}while((s|0)!=(B|0));u=d;return h|0}function fX(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+64|0;g=e+32|0;h=e;i=e+40|0;j=e+24|0;k=e+16|0;l=e+8|0;m=d+28|0;if((f[m>>2]|0)==1){f[g>>2]=0;f[g+4>>2]=0;n=c$(g,48)|0;o=185150;p=n+48|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-210,g,185199,177754,5606);d$(g)}f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2];nX(a,c,6,183766,g);c=d+40|0;HX(a,337923,f[c>>2]|0);j=d+44|0;HX(a,337929,f[j>>2]|0);pX(a,185234,(f[d+32>>2]|0)==0?185213:185222,0);pX(a,185260,(f[m>>2]|0)==1?185241:185248,0);m=d+48|0;if(f[m>>2]|0){f[k>>2]=0;f[k+4>>2]=0;f[g>>2]=f[k>>2];f[g+4>>2]=f[k+4>>2];nX(a,185267,14,0,g);HX(a,185271,f[(f[m>>2]|0)+4>>2]|0);HX(a,185273,f[(f[m>>2]|0)+8>>2]|0);HX(a,337923,f[(f[m>>2]|0)+12>>2]|0);HX(a,337929,f[(f[m>>2]|0)+16>>2]|0);HX(a,185275,f[f[m>>2]>>2]|0);kV(a)}m=f[d+16>>2]|0;k=1125516576>>>((m>>>2&60)+(m>>31&20)|0);m=d+8|0;o=b[180230+(k&7)>>0]|0;f[h>>2]=f[m>>2];f[h+4>>2]=o;SLa(i,183818,h)|0;h=i+((b[i+2>>0]|0)==0&(b[i>>0]|0)==49&1)|0;pX(a,183823,h,0);i=f[c>>2]|0;c=f[j>>2]|0;j=(Y(f[m>>2]|0,i)|0)<<(47696>>>(k<<1&14)&3);k=d+72|0;m=(j|0)==(f[k>>2]|0);j=Y(m?c:1,i)|0;i=m?1:c;f[l>>2]=0;f[l+4>>2]=0;f[g>>2]=f[l>>2];f[g+4>>2]=f[l+4>>2];nX(a,183826,13,0,g);if((i|0)<=0){kV(a);kV(a);u=e;return}g=d+68|0;d=0;do{oX(a,(f[g>>2]|0)+(Y(f[k>>2]|0,d)|0)|0,j,h);d=d+1|0}while((d|0)!=(i|0));kV(a);kV(a);u=e;return}function gX(a){a=a|0;var b=0;if(((a|0)!=0?(f[a>>2]&-65536|0)==1111621632:0)?(f[a+24>>2]|0)>-1:0)b=(f[a+20>>2]|0)>-1;else b=0;return b&1|0}function hX(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d;g=CX(a,c,185118)|0;a:do if(!g)h=-1;else switch(f[g>>2]&7){case 1:{h=f[g+8>>2]|0;break a;break}case 2:{h=rNa(+p[g+8>>3])|0;break a;break}default:{h=2147483647;break a}}while(0);g=CX(a,c,185123)|0;b:do if(!g)i=-1;else switch(f[g>>2]&7){case 1:{i=f[g+8>>2]|0;break b;break}case 2:{i=rNa(+p[g+8>>3])|0;break b;break}default:{i=2147483647;break b}}while(0);g=CX(a,c,183823)|0;if((g|0)!=0?(f[g>>2]&7|0)==3:0){j=f[g+8+4>>2]|0;if((i|h|0)>-1&(j|0)!=0)k=j;else{l=j;m=12}}else{l=0;m=12}if((m|0)==12){f[e>>2]=0;f[e+4>>2]=0;n=c$(e,46)|0;o=184398;q=n+46|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));j$(-2,e,185139,177754,5286);d$(e);k=l}l=EX(k)|0;m=CX(a,c,183826)|0;if(!m){f[e>>2]=0;f[e+4>>2]=0;n=c$(e,44)|0;o=184504;q=n+44|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));j$(-2,e,185139,177754,5292);d$(e)}c=f[m>>2]&7;if(c>>>0>4)r=f[(f[m+8>>2]|0)+24>>2]|0;else r=(c|0)!=0&1;if((r|0)<=0){s=u0(h,i,l)|0;u=d;return s|0}if((r|0)!=(Y(Y(i,h)|0,(l>>>3&511)+1|0)|0)){f[e>>2]=0;f[e+4>>2]=0;n=c$(e,63)|0;o=184549;q=n+63|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));j$(-209,e,185139,177754,5297);d$(e)}e=t0(h,i,l)|0;DX(a,m,f[e+16>>2]|0,k);s=e;u=d;return s|0}function iX(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+8|0;h=e;i=e+32|0;j=e+24|0;k=e+16|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2];nX(a,c,6,183779,g);HX(a,185118,f[d+20>>2]|0);HX(a,185123,f[d+24>>2]|0);c=f[d>>2]|0;j=b[180230+(c&7)>>0]|0;f[h>>2]=(c>>>3&511)+1;f[h+4>>2]=j;SLa(i,183818,h)|0;pX(a,183823,i+((b[i+2>>0]|0)==0&(b[i>>0]|0)==49&1)|0,0);f[k>>2]=0;f[k+4>>2]=0;f[g>>2]=f[k>>2];f[g+4>>2]=f[k+4>>2];nX(a,183826,13,0,g);Q0(g,d);k=g;g=f[k>>2]|0;h=f[k+4>>2]|0;if(!((g|0)>0&(h|0)>0)){kV(a);kV(a);u=e;return}k=d+16|0;j=f[k>>2]|0;if(!j){kV(a);kV(a);u=e;return}c=(f[d>>2]&16384|0)==0;l=c?h:1;m=Y(c?1:h,g)|0;if((l|0)<=0){kV(a);kV(a);u=e;return}g=d+4|0;oX(a,j,m,i);if((l|0)==1){kV(a);kV(a);u=e;return}else n=1;do{oX(a,(f[k>>2]|0)+(Y(f[g>>2]|0,n)|0)|0,m,i);n=n+1|0}while((n|0)!=(l|0));kV(a);kV(a);u=e;return}function jX(a){a=a|0;var b=0;if(!a)b=0;else b=(f[a>>2]&-65536|0)==1111687168;return b&1|0}function kX(a){a=a|0;x0(a);return}function lX(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+144|0;e=d+8|0;g=d;h=e;i=h+128|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));j=CX(a,c,183810)|0;k=CX(a,c,183823)|0;if((k|0)!=0?(f[k>>2]&7|0)==3:0){l=f[k+8+4>>2]|0;if((j|0)!=0&(l|0)!=0)m=l;else{n=l;o=4}}else{n=0;o=4}if((o|0)==4){f[g>>2]=0;f[g+4>>2]=0;h=c$(g,46)|0;p=184398;i=h+46|0;do{b[h>>0]=b[p>>0]|0;h=h+1|0;p=p+1|0}while((h|0)<(i|0));j$(-2,g,184445,177754,5369);d$(g);m=n}n=f[j>>2]&7;if((n|0)==5)q=f[(f[j+8>>2]|0)+24>>2]|0;else q=(n|0)==1?1:-1;if((q+-1|0)>>>0>31){f[g>>2]=0;f[g+4>>2]=0;h=c$(g,45)|0;p=184458;i=h+45|0;do{b[h>>0]=b[p>>0]|0;h=h+1|0;p=p+1|0}while((h|0)<(i|0));j$(-212,g,184445,177754,5375);d$(g)}DX(a,j,e,183816);j=EX(m)|0;n=CX(a,c,183826)|0;if(!n){f[g>>2]=0;f[g+4>>2]=0;h=c$(g,44)|0;p=184504;i=h+44|0;do{b[h>>0]=b[p>>0]|0;h=h+1|0;p=p+1|0}while((h|0)<(i|0));j$(-2,g,184445,177754,5382);d$(g)}c=(j>>>3&511)+1|0;if((q|0)>0){o=g+4|0;l=0;k=c;while(1){r=e+(l<<2)|0;s=f[r>>2]|0;if(!s){f[g>>2]=0;f[o>>2]=0;t=c$(g,8)|0;v=t;b[v>>0]=115;b[v+1>>0]=105;b[v+2>>0]=122;b[v+3>>0]=101;v=t+4|0;b[v>>0]=115;b[v+1>>0]=91;b[v+2>>0]=105;b[v+3>>0]=93;j$(-215,g,184445,177754,5388);d$(g);w=f[r>>2]|0}else w=s;s=Y(w,k)|0;l=l+1|0;if((l|0)>=(q|0)){x=s;break}else k=s}}else x=c;c=f[n>>2]&7;if(c>>>0>4)y=f[(f[n+8>>2]|0)+24>>2]|0;else y=(c|0)!=0&1;c=(y|0)>0;if(!((y|0)==(x|0)|c^1)){f[g>>2]=0;f[g+4>>2]=0;h=c$(g,63)|0;p=184549;i=h+63|0;do{b[h>>0]=b[p>>0]|0;h=h+1|0;p=p+1|0}while((h|0)<(i|0));j$(-209,g,184445,177754,5396);d$(g)}if(c){c=A0(q,e,j)|0;DX(a,n,f[c+16>>2]|0,m);z=c;u=d;return z|0}else{z=B0(q,e,j)|0;u=d;return z|0}return 0}function mX(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+688|0;g=e+664|0;h=e;i=e+660|0;j=e+160|0;k=e+24|0;l=e+672|0;m=e+152|0;n=e+16|0;o=e+8|0;f[i>>2]=d;p=j+8|0;f[p>>2]=0;f[j+12>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[g>>2]=f[m>>2];f[g+4>>2]=f[m+4>>2];nX(a,c,6,183793,g);c=P0(d,k)|0;f[n>>2]=0;f[n+4>>2]=0;f[g>>2]=f[n>>2];f[g+4>>2]=f[n+4>>2];nX(a,183810,13,0,g);oX(a,k,c,183816);kV(a);c=O0(d)|0;k=b[180230+(c&7)>>0]|0;f[h>>2]=(c>>>3&511)+1;f[h+4>>2]=k;SLa(l,183818,h)|0;pX(a,183823,l+((b[l+2>>0]|0)==0&(b[l>>0]|0)==49&1)|0,0);f[o>>2]=0;f[o+4>>2]=0;f[g>>2]=f[o>>2];f[g+4>>2]=f[o+4>>2];nX(a,183826,13,0,g);if((f[d+20>>2]|0)<=0){kV(a);kV(a);u=e;return}if(!(f[d+16>>2]|0)){kV(a);kV(a);u=e;return}D0(1,i,0,e+384|0,j,0)|0;i=j+16|0;do oX(a,f[i>>2]|0,f[p>>2]|0,l);while((G0(j)|0)!=0);kV(a);kV(a);u=e;return}function nX(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+16|0;h=g;i=(a|0)!=0;if(!(i?(f[a>>2]|0)==1280131417:0)){j=i?-5:-27;f[h>>2]=0;f[h+4>>2]=0;k=c$(h,31)|0;l=177863;m=k+31|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(j,h,184127,177754,4564);d$(h)}if(!(f[a+8>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;k=c$(h,38)|0;l=177912;m=k+38|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-2,h,184127,177754,4564);d$(h)}pV(a,0);j=a+280|0;i=f[j>>2]|0;if((i|0)==1){qV(a,0);n=f[j>>2]|0}else n=i;i=(n|0)==0;o=(d&7|0)==5;if(o&i?(e|0)==0&(b[a+276>>0]|0)!=0:0){p=a+284|0;if(b[p>>0]|0){f[h>>2]=0;f[h+4>>2]=0;k=c$(h,36)|0;l=184146;m=k+36|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,h,184183,177754,1252);d$(h)}f[a+292>>2]=d;if(c|0){q=OYa((xKa(c)|0)+1|0)|0;f[a+288>>2]=q;ZKa(q,c)|0}b[p>>0]=1;u=g;return}if(e|0?(yKa(e,178191,6)|0)==0:0){if(o){if(!i){f[h>>2]=0;f[h+4>>2]=0;k=c$(h,69)|0;l=184265;m=k+69|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-2,h,184127,177754,4587);d$(h)}}else{f[h>>2]=0;f[h+4>>2]=0;k=c$(h,55)|0;l=184209;m=k+55|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-5,h,184127,177754,4585);d$(h)}Ah[f[a+228>>2]&255](a,c,d,e);if(f[j>>2]|0)qV(a,0);qV(a,2);u=g;return}if((n|0)==2){f[h>>2]=0;f[h+4>>2]=0;k=c$(h,62)|0;l=184335;m=k+62|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-2,h,184127,177754,4599);d$(h)}Ah[f[a+228>>2]&255](a,c,d,e);if(f[j>>2]|0)qV(a,0);qV(a,1);u=g;return}function oX(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0;i=u;u=u+1312|0;k=i+8|0;l=i;m=i+24|0;o=i+1048|0;q=i+16|0;a:do if(!(b[a+276>>0]|0)){switch(f[a+280>>2]|0){case 2:{break a;break}case 0:{qV(a,1);break}default:{}}F1a(o|0,0,256)|0;if((f[a>>2]|0)!=1280131417){f[q>>2]=0;f[q+4>>2]=0;r=c$(q,31)|0;t=177863;v=r+31|0;do{b[r>>0]=b[t>>0]|0;r=r+1|0;t=t+1|0}while((r|0)<(v|0));j$(-5,q,183845,177754,4812);d$(q)}if(!(f[a+8>>2]|0)){f[q>>2]=0;f[q+4>>2]=0;r=c$(q,38)|0;t=177912;v=r+38|0;do{b[r>>0]=b[t>>0]|0;r=r+1|0;t=t+1|0}while((r|0)<(v|0));j$(-2,q,183845,177754,4812);d$(q)}if((e|0)>=0){w=AW(g,m)|0;if(e|0){x=m;y=w;z=12}}else{f[q>>2]=0;f[q+4>>2]=0;r=c$(q,27)|0;t=183860;v=r+27|0;do{b[r>>0]=b[t>>0]|0;r=r+1|0;t=t+1|0}while((r|0)<(v|0));j$(-211,q,183845,177754,4815);d$(q);x=m;y=AW(g,m)|0;z=12}b:do if((z|0)==12){if(!c){f[q>>2]=0;f[q+4>>2]=0;r=c$(q,17)|0;t=183888;v=r+17|0;do{b[r>>0]=b[t>>0]|0;r=r+1|0;t=t+1|0}while((r|0)<(v|0));j$(-27,q,183845,177754,4823);d$(q)}if((y|0)!=1)if(!e)break;else A=e;else{w=Y(f[x>>2]|0,e)|0;f[x>>2]=w;A=1}w=(y|0)>0;B=c;C=o+23|0;D=a+4|0;E=o+1|0;F=A;G=0;c:while(1){F=F+-1|0;if(w){H=0;I=G;while(1){J=H<<1;K=f[m+(J<<2)>>2]|0;L=f[m+((J|1)<<2)>>2]|0;J=(L>>>3&511)+1<<(47696>>>(L<<1&14)&3);M=c+(I+-1+J&0-J)|0;d:do if((K|0)>0){J=(L+-5|0)>>>0<2;N=M;O=0;while(1){e:do switch(L|0){case 0:{P=h[N>>0]|0;b[C>>0]=0;Q=C;R=P;while(1){P=R;R=(R>>>0)/10|0;S=P+48+(Y(R,-10)|0)&255;T=Q+-1|0;b[T>>0]=S;if(P>>>0<=9){U=1;V=T;break}else Q=T}break}case 1:{Q=b[N>>0]|0;R=Q<<24>>24;b[C>>0]=0;T=C;P=Q<<24>>24>-1?R:0-R|0;while(1){R=P;P=(P>>>0)/10|0;S=R+48+(Y(P,-10)|0)&255;W=T+-1|0;b[W>>0]=S;if(R>>>0<=9)break;else T=W}if(Q<<24>>24<0){P=T+-2|0;b[P>>0]=45;U=1;V=P}else{U=1;V=W}break}case 2:{P=j[N>>1]|0;b[C>>0]=0;R=C;S=P;while(1){P=S;S=(S>>>0)/10|0;X=P+48+(Y(S,-10)|0)&255;Z=R+-1|0;b[Z>>0]=X;if(P>>>0<=9){U=2;V=Z;break}else R=Z}break}case 3:{R=d[N>>1]|0;S=R<<16>>16;b[C>>0]=0;T=C;Q=R<<16>>16>-1?S:0-S|0;while(1){S=Q;Q=(Q>>>0)/10|0;Z=S+48+(Y(Q,-10)|0)&255;_=T+-1|0;b[_>>0]=Z;if(S>>>0<=9)break;else T=_}if(R<<16>>16<0){Q=T+-2|0;b[Q>>0]=45;U=2;V=Q}else{U=2;V=_}break}case 4:{Q=f[N>>2]|0;b[C>>0]=0;S=C;Z=(Q|0)>-1?Q:0-Q|0;while(1){P=Z;Z=(Z>>>0)/10|0;X=P+48+(Y(Z,-10)|0)&255;$=S+-1|0;b[$>>0]=X;if(P>>>0<=9)break;else S=$}if((Q|0)<0){Z=S+-2|0;b[Z>>0]=45;U=4;V=Z}else{U=4;V=$}break}case 5:{aa=+n[N>>2];Z=(n[s>>2]=aa,f[s>>2]|0);if((Z&2139095040|0)==2139095040)if((Z&2147483647|0)==2139095040){ZKa(o,(Z|0)<0?183196:183202)|0;U=4;V=o;break e}else{b[o>>0]=b[183191]|0;b[o+1>>0]=b[183192]|0;b[o+2>>0]=b[183193]|0;b[o+3>>0]=b[183194]|0;b[o+4>>0]=b[183195]|0;U=4;V=o;break e}Z=wNa(aa)|0;if(+(Z|0)==aa){f[l>>2]=Z;SLa(o,183181,l)|0;U=4;V=o;break e}p[k>>3]=aa;SLa(o,183906,k)|0;switch(b[o>>0]|0){case 45:case 43:{ba=E;break}default:ba=o}while(1){ca=b[ba>>0]|0;if((ca+-48&255)<10)ba=ba+1|0;else break}if(ca<<24>>24==44){b[ba>>0]=46;U=4;V=o}else{U=4;V=o}break}case 6:{NW(o,+p[N>>3])|0;U=8;V=o;break}case 7:{S=f[N>>2]|0;b[C>>0]=0;Q=C;Z=(S|0)>-1?S:0-S|0;while(1){T=Z;Z=(Z>>>0)/10|0;R=T+48+(Y(Z,-10)|0)&255;da=Q+-1|0;b[da>>0]=R;if(T>>>0<=9)break;else Q=da}if((S|0)<0){Z=Q+-2|0;b[Z>>0]=45;U=4;V=Z}else{U=4;V=da}break}default:break c}while(0);Z=N+U|0;switch(f[D>>2]|0){case 8:{LW(a,0,V,xKa(V)|0);break}case 16:{JW(a,0,V);break}default:{if((J?(T=xKa(V)|0,T|0):0)?(b[V+(T+-1)>>0]|0)==46:0){b[o+T>>0]=48;b[o+(T+1)>>0]=0}KW(a,0,V)}}O=O+1|0;if((O|0)>=(K|0)){ea=Z;break d}else N=Z}}else ea=M;while(0);M=ea-B|0;H=H+1|0;if((H|0)>=(y|0)){fa=M;break}else I=M}}else fa=G;if(!F)break b;else G=fa}f[q>>2]=0;f[q+4>>2]=0;r=c$(q,16)|0;t=205373;v=r+16|0;do{b[r>>0]=b[t>>0]|0;r=r+1|0;t=t+1|0}while((r|0)<(v|0));j$(-210,q,183845,177754,4880);d$(q)}while(0);u=i;return}while(0);qX(a,c,e,g);u=i;return}function pX(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;i=(a|0)!=0;if(!(i?(f[a>>2]|0)==1280131417:0)){j=i?-5:-27;f[h>>2]=0;f[h+4>>2]=0;k=c$(h,31)|0;l=177863;m=k+31|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(j,h,183831,177754,4642);d$(h)}if(f[a+8>>2]|0){n=a+244|0;o=f[n>>2]|0;Ah[o&255](a,c,d,e);u=g;return}f[h>>2]=0;f[h+4>>2]=0;k=c$(h,38)|0;l=177912;m=k+38|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-2,h,183831,177754,4642);d$(h);n=a+244|0;o=f[n>>2]|0;Ah[o&255](a,c,d,e);u=g;return}function qX(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16|0;h=g;i=(a|0)!=0;if(i){if((f[a>>2]|0)!=1280131417)j=4}else{f[h>>2]=0;f[h+4>>2]=0;k=c$(h,2)|0;b[k>>0]=102;b[k+1>>0]=115;j$(-215,h,183911,177754,8367);d$(h);j=4}if((j|0)==4){j=i?-5:-27;f[h>>2]=0;f[h+4>>2]=0;l=c$(h,31)|0;m=177863;n=l+31|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(j,h,183911,177754,8368);d$(h)}if(!(f[a+8>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;l=c$(h,38)|0;m=177912;n=l+38|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-2,h,183911,177754,8368);d$(h)}pV(a,1);switch(f[a+280>>2]|0){case 0:{qV(a,2);o=a+272|0;p=f[o>>2]|0;rX(p,c,d,e);u=g;return}case 2:{o=a+272|0;p=f[o>>2]|0;rX(p,c,d,e);u=g;return}default:{f[h>>2]=0;f[h+4>>2]=0;l=c$(h,37)|0;m=183932;n=l+37|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-2,h,183911,177754,8378);d$(h);o=a+272|0;p=f[o>>2]|0;rX(p,c,d,e);u=g;return}}}function rX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+32|0;g=e;sX(a,d);tX(g,b,c,a+4|0);c=f[a>>2]|0;a=NYa(1024)|0;F1a(a|0,0,1024)|0;b=g+4|0;d=f[b>>2]|0;h=g+8|0;if(d>>>0<(f[h>>2]|0)>>>0){i=g+16|0;j=g+20|0;k=g+12|0;l=c+36|0;m=c+32|0;n=d;while(1){d=f[i>>2]|0;o=(f[j>>2]|0)-d>>3;if(!o)p=n;else{q=d;d=n;r=0;while(1){s=f[q+(r<<3)>>2]|0;$h[f[q+(r<<3)+4>>2]&255](d+s|0,a+s|0)|0;s=r+1|0;if((s|0)==(o|0))break;q=f[i>>2]|0;d=f[b>>2]|0;r=s}p=f[b>>2]|0}r=f[k>>2]|0;d=p+r|0;f[b>>2]=d;q=a+r|0;if((r|0)>0){r=q;o=a;do{s=r-o|0;t=f[m>>2]|0;v=(f[l>>2]|0)-t|0;w=(v|0)<(s|0)?v:s;K1a(t|0,o|0,w|0)|0;o=o+w|0;t=(f[m>>2]|0)+w|0;f[m>>2]=t;if(t>>>0>=(f[l>>2]|0)>>>0)tV(c)|0}while(o>>>0<q>>>0);x=f[b>>2]|0}else x=d;if(x>>>0<(f[h>>2]|0)>>>0)n=x;else break}}PYa(a);a=f[g+16>>2]|0;if(!a){u=e;return}x=g+20|0;g=f[x>>2]|0;if((g|0)!=(a|0))f[x>>2]=g+(~((g+-8-a|0)>>>3)<<3);PYa(a);u=e;return}function sX(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;if(!c){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,13)|0;h=184036;i=g+13|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j$(-5,e,184050,177754,8339);d$(e);u=d;return}j=a+4|0;k=b[j+11>>0]|0;l=k<<24>>24<0;if(l)m=f[a+8>>2]|0;else m=k&255;if(m|0){m=xKa(c)|0;if((m|0)==((l?f[a+8>>2]|0:k&255)|0)?(pZa(j,0,-1,c,m)|0)==0:0){u=d;return}f[e>>2]=0;f[e+4>>2]=0;g=c$(e,20)|0;h=184059;i=g+20|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j$(-5,e,184050,177754,8350);d$(e);u=d;return}eZa(j,c)|0;BX(e,c);c=e+11|0;j=b[c>>0]|0;h=j<<24>>24<0;g=h?f[e>>2]|0:e;i=h?f[e+4>>2]|0:j&255;h=g+i|0;m=f[a>>2]|0;if((i|0)>0){i=h;a=m+36|0;k=m+32|0;l=g;do{g=i-l|0;n=f[k>>2]|0;o=(f[a>>2]|0)-n|0;p=(o|0)<(g|0)?o:g;K1a(n|0,l|0,p|0)|0;l=l+p|0;n=(f[k>>2]|0)+p|0;f[k>>2]=n;if(n>>>0>=(f[a>>2]|0)>>>0)tV(m)|0}while(l>>>0<h>>>0);q=b[c>>0]|0}else q=j;if(q<<24>>24<0)PYa(f[e>>2]|0);u=d;return}function tX(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+16|0;h=g;f[a>>2]=c;i=a+4|0;f[i>>2]=0;j=a+8|0;f[j>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if(!c){f[h>>2]=0;f[h+4>>2]=0;c=c$(h,3)|0;b[c>>0]=b[179998]|0;b[c+1>>0]=b[179999]|0;b[c+2>>0]=b[18e4]|0;j$(-215,h,183970,177754,8016);d$(h)}c=e+11|0;k=b[c>>0]|0;if(!((k<<24>>24<0?f[e+4>>2]|0:k&255)|0)){f[h>>2]=0;f[h+4>>2]=0;k=c$(h,11)|0;l=183995;m=k+11|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,h,183970,177754,8017);d$(h)}if((d|0)<=0){f[h>>2]=0;f[h+4>>2]=0;l=c$(h,7)|0;b[l>>0]=b[184007]|0;b[l+1>>0]=b[184008]|0;b[l+2>>0]=b[184009]|0;b[l+3>>0]=b[184010]|0;b[l+4>>0]=b[184011]|0;b[l+5>>0]=b[184012]|0;b[l+6>>0]=b[184013]|0;j$(-215,h,183970,177754,8018);d$(h)}uX(a,e);h=f[a>>2]|0;f[j>>2]=h;f[i>>2]=h;h=kW((b[c>>0]|0)<0?f[e>>2]|0:e)|0;f[a+12>>2]=h;e=(f[a>>2]|0)+(Y(h,d)|0)|0;f[j>>2]=e;u=g;return}function uX(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+176|0;e=d+156|0;g=d+160|0;h=d+16|0;i=d;j=d+8|0;f[e>>2]=0;b[g>>0]=0;k=h+60|0;l=h+8|0;f[h>>2]=12412;f[k>>2]=12432;f[h+4>>2]=0;$Oa(h+60|0,l);f[h+132>>2]=0;f[h+136>>2]=-1;f[h>>2]=42680;f[k>>2]=42700;ePa(l);f[l>>2]=42524;k=h+40|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[h+56>>2]=8;GU(l,c);c=f[h+(f[(f[h>>2]|0)+-12>>2]|0)+16>>2]|0;a:do if(!(c&2)){l=i+4|0;k=j+4|0;m=a+20|0;n=a+24|0;o=a+16|0;p=i+4|0;q=0;while(1){r=kPa(h,e)|0;if(!(f[r+(f[(f[r>>2]|0)+-12>>2]|0)+16>>2]&5)){if(!(f[e>>2]|0)){f[i>>2]=0;f[l>>2]=0;r=c$(i,8)|0;s=r;b[s>>0]=99;b[s+1>>0]=110;b[s+2>>0]=116;b[s+3>>0]=32;s=r+4|0;b[s>>0]=62;b[s+1>>0]=32;b[s+2>>0]=48;b[s+3>>0]=85;j$(-215,i,184015,177754,8070);d$(i)}}else{_Oa(h+(f[(f[h>>2]|0)+-12>>2]|0)|0,0);f[e>>2]=1}s=pW(h,g)|0;if(f[s+(f[(f[s>>2]|0)+-12>>2]|0)+16>>2]&5|0)break;s=f[e>>2]|0;f[e>>2]=s+-1;b:do if(!s)t=q;else{r=q;while(1){switch(b[g>>0]|0){case 99:case 117:{f[p>>2]=155;v=1;break}case 115:case 119:{f[p>>2]=156;v=2;break}case 105:{f[p>>2]=157;v=4;break}case 102:{f[p>>2]=158;v=4;break}case 100:{f[p>>2]=159;v=8;break}default:{f[j>>2]=0;f[k>>2]=0;w=c$(j,19)|0;x=180036;y=w+19|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));j$(-215,j,184015,177754,8104);d$(j);v=0}}z=r+-1+v&0-v;f[i>>2]=z;A=f[m>>2]|0;if((A|0)==(f[n>>2]|0))AX(o,i);else{B=i;C=f[B+4>>2]|0;D=A;f[D>>2]=f[B>>2];f[D+4>>2]=C;f[m>>2]=(f[m>>2]|0)+8}C=z+v|0;z=f[e>>2]|0;f[e>>2]=z+-1;if(!z){t=C;break b}else r=C}}while(0);s=f[h+(f[(f[h>>2]|0)+-12>>2]|0)+16>>2]|0;if(!(s&2))q=t;else{E=s;break a}}E=f[h+(f[(f[h>>2]|0)+-12>>2]|0)+16>>2]|0}else E=c;while(0);if(E&2|0){wW(h);u=d;return}f[i>>2]=0;f[i+4>>2]=0;w=c$(i,9)|0;x=180079;y=w+9|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));j$(-215,i,184015,177754,8115);d$(i);wW(h);u=d;return}function vX(a,c){a=a|0;c=c|0;b[c>>0]=b[a>>0]|0;return 1}function wX(a,c){a=a|0;c=c|0;var e=0;e=d[a>>1]|0;b[c>>0]=e;b[c+1>>0]=(e&65535)>>>8;return 2}function xX(a,c){a=a|0;c=c|0;var d=0;d=f[a>>2]|0;b[c>>0]=d;b[c+1>>0]=d>>>8;b[c+2>>0]=d>>>16;b[c+3>>0]=d>>>24;return 4}function yX(a,c){a=a|0;c=c|0;var d=0;d=f[a>>2]|0;b[c>>0]=d;b[c+1>>0]=d>>>8;b[c+2>>0]=d>>>16;b[c+3>>0]=d>>>24;return 4}function zX(a,c){a=a|0;c=c|0;var d=0,e=0;d=a;a=f[d>>2]|0;e=f[d+4>>2]|0;b[c>>0]=a;d=I1a(a|0,e|0,8)|0;b[c+1>>0]=d;d=I1a(a|0,e|0,16)|0;b[c+2>>0]=d;d=I1a(a|0,e|0,24)|0;b[c+3>>0]=d;b[c+4>>0]=e;d=I1a(a|0,e|0,40)|0;b[c+5>>0]=d;d=I1a(a|0,e|0,48)|0;b[c+6>>0]=d;d=I1a(a|0,e|0,56)|0;b[c+7>>0]=d;return 8}function AX(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)gXa(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;PYa(d);return}function BX(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+160|0;e=d+136|0;g=d;h=g+56|0;i=g+4|0;f[g>>2]=12308;f[h>>2]=12328;$Oa(g+56|0,i);f[g+128>>2]=0;f[g+132>>2]=-1;f[g>>2]=42488;f[h>>2]=42508;ePa(i);f[i>>2]=42524;h=g+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[g+52>>2]=16;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;GU(i,e);if((b[e+11>>0]|0)<0)PYa(f[e>>2]|0);h=HU(g,c,xKa(c)|0)|0;b[e>>0]=32;HU(h,e,1)|0;IU(a,i);i=a+11|0;h=b[i>>0]|0;if(h<<24>>24<0)j=f[a+4>>2]|0;else j=h&255;if(j>>>0>=24){f[e>>2]=0;f[e+4>>2]=0;j=c$(e,27)|0;h=184080;c=j+27|0;do{b[j>>0]=b[h>>0]|0;j=j+1|0;h=h+1|0}while((j|0)<(c|0));j$(-215,e,184108,177754,7765);d$(e)}dZa(a,24);e=a+4|0;while(1){h=b[i>>0]|0;if(h<<24>>24<0)k=f[e>>2]|0;else k=h&255;if(k>>>0>=24)break;kZa(a,32)}JU(g);u=d;return}function CX(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+16|0;g=e;if(!a){h=0;u=e;return h|0}if((f[a>>2]|0)!=1280131417){f[g>>2]=0;f[g+4>>2]=0;i=c$(g,31)|0;j=177863;k=i+31|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-5,g,185080,177754,861);d$(g)}if(!d){f[g>>2]=0;f[g+4>>2]=0;i=c$(g,17)|0;j=185100;k=i+17|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-27,g,185080,177754,864);d$(g)}l=b[d>>0]|0;if(!(l<<24>>24)){m=0;n=0}else{o=l;l=0;p=0;while(1){q=(o&255)+(l*33|0)|0;r=p+1|0;o=b[d+r>>0]|0;if(!(o<<24>>24)){m=q;n=r;break}else{l=q;p=r}}}p=m&2147483647;a:do if(!c){m=f[a+32>>2]|0;if(!m){h=0;u=e;return h|0}l=f[m+24>>2]|0;if((l|0)<=0){h=0;u=e;return h|0}m=a+32|0;o=0;b:while(1){s=AL(f[m>>2]|0,o)|0;switch(f[s>>2]&7){case 5:{t=22;break b;break}case 0:{h=0;t=35;break b;break}case 6:break;default:break a}r=f[s+8>>2]|0;q=f[r+64>>2]|0;v=q+-1|0;if(!(v&q))w=v&p;else w=(p>>>0)%(q>>>0)|0;q=f[(f[r+68>>2]|0)+(w<<2)>>2]|0;if(q|0){r=q;do{q=f[r+16>>2]|0;if(((f[q>>2]|0)==(p|0)?(f[q+4>>2]|0)==(n|0):0)?(yKa(f[q+8>>2]|0,d,n)|0)==0:0){x=r;t=34;break a}r=f[r+20>>2]|0}while((r|0)!=0)}o=o+1|0;if((o|0)>=(l|0)){h=0;t=35;break}}if((t|0)==22){y=s;t=23;break}else if((t|0)==35){u=e;return h|0}}else{l=c+8|0;switch(f[c>>2]&7){case 5:{y=c;t=23;break a;break}case 6:break;case 0:{h=0;u=e;return h|0}default:break a}o=f[l>>2]|0;l=f[o+64>>2]|0;m=l+-1|0;if(!(m&l))z=m&p;else z=(p>>>0)%(l>>>0)|0;l=f[(f[o+68>>2]|0)+(z<<2)>>2]|0;if(!l){h=0;u=e;return h|0}else A=l;while(1){l=f[A+16>>2]|0;if(((f[l>>2]|0)==(p|0)?(f[l+4>>2]|0)==(n|0):0)?(yKa(f[l+8>>2]|0,d,n)|0)==0:0){x=A;t=34;break a}A=f[A+20>>2]|0;if(!A){h=0;break}}u=e;return h|0}while(0);if((t|0)==23){if(!(f[(f[y+8>>2]|0)+24>>2]|0)){h=0;u=e;return h|0}}else if((t|0)==34){h=x;u=e;return h|0}f[g>>2]=0;f[g+4>>2]=0;i=c$(g,49)|0;j=180571;k=i+49|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-2,g,185080,177754,891);d$(g);h=0;u=e;return h|0}function DX(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+48|0;h=g+8|0;i=g;if(!((c|0)!=0&(d|0)!=0)){f[i>>2]=0;f[i+4>>2]=0;j=c$(i,54)|0;k=184669;l=j+54|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-27,i,184724,177754,5106);d$(i)}FX(a,c,h);if((f[c>>2]&7|0)!=5){m=1;GX(a,h,m,d,e);u=g;return}m=f[(f[c+8>>2]|0)+24>>2]|0;GX(a,h,m,d,e);u=g;return}function EX(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+528|0;d=c+8|0;e=c;g=(AW(a,d)|0)!=1;a=f[d>>2]|0;if(g|(a|0)>4){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,33)|0;h=184613;i=g+33|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j$(-2,e,184647,177754,4785);d$(e)}u=c;return (a<<3)+-8|f[d+4>>2]&7|0}function FX(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;h=(a|0)!=0;if(!(h?(f[a>>2]|0)==1280131417:0)){a=h?-5:-27;f[g>>2]=0;f[g+4>>2]=0;i=c$(g,31)|0;j=177863;k=i+31|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(a,g,184961,177754,4920);d$(g)}if(!((c|0)!=0&(d|0)!=0)){f[g>>2]=0;f[g+4>>2]=0;i=c$(g,42)|0;j=184980;k=i+42|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-27,g,184961,177754,4923);d$(g)}a=f[c>>2]|0;if(((a&7)+-1|0)>>>0<2){f[d+12>>2]=c;f[d+20>>2]=c+32;f[d+16>>2]=c;f[d+4>>2]=0;u=e;return}switch(a&7){case 5:{CL(f[c+8>>2]|0,d,0);u=e;return}case 0:{f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;u=e;return}default:{f[g>>2]=0;f[g+4>>2]=0;i=c$(g,56)|0;j=185023;k=i+56|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-5,g,184961,177754,4943);d$(g);u=e;return}}}function GX(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0;i=u;u=u+1040|0;j=i+8|0;k=i;l=(a|0)!=0;if(!(l?(f[a>>2]|0)==1280131417:0)){a=l?-5:-27;f[k>>2]=0;f[k+4>>2]=0;m=c$(k,31)|0;o=177863;q=m+31|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(q|0));j$(a,k,184738,177754,4955);d$(k)}if(!((c|0)!=0&(g|0)!=0)){f[k>>2]=0;f[k+4>>2]=0;m=c$(k,43)|0;o=184757;q=m+43|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(q|0));j$(-27,k,184738,177754,4958);d$(k)}a=c+4|0;if((e|0)!=1&(f[a>>2]|0)==0){f[k>>2]=0;f[k+4>>2]=0;m=c$(k,51)|0;o=184801;q=m+51|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(q|0));j$(-201,k,184738,177754,4961);d$(k)}l=AW(h,j)|0;r=kW(h)|0;h=(l|0)>0;s=c+12|0;t=k+4|0;v=c+20|0;w=g;g=e;a:while(1){if(h){e=w;x=0;y=g;z=0;while(1){A=x<<1;B=f[j+((A|1)<<2)>>2]|0;C=(B>>>3&511)+1<<(47696>>>(B<<1&14)&3);D=f[j+(A<<2)>>2]|0;A=w+(z+-1+C&0-C)|0;b:do if((D|0)>0){C=A;E=0;F=y;while(1){G=f[s>>2]|0;switch(f[G>>2]&7){case 1:{H=f[G+8>>2]|0;switch(B|0){case 0:{b[C>>0]=H>>>0<256?H:(H|0)>0?255:0;I=1;break}case 1:{b[C>>0]=(H+128|0)>>>0<256?H:(H|0)>0?127:128;I=1;break}case 2:{d[C>>1]=H>>>0<65536?H:(H|0)>0?65535:0;I=2;break}case 3:{d[C>>1]=(H+32768|0)>>>0<65536?H:(H|0)>0?32767:32768;I=2;break}case 4:{f[C>>2]=H;I=4;break}case 5:{n[C>>2]=+(H|0);I=4;break}case 6:{p[C>>3]=+(H|0);I=8;break}case 7:{f[C>>2]=H;I=4;break}default:{J=22;break a}}K=C+I|0;break}case 2:{L=+p[G+8>>3];switch(B|0){case 0:{G=rNa(L)|0;b[C>>0]=G>>>0<256?G:(G|0)>0?255:0;M=1;break}case 1:{G=rNa(L)|0;b[C>>0]=(G+128|0)>>>0<256?G:(G|0)>0?127:128;M=1;break}case 2:{G=rNa(L)|0;d[C>>1]=G>>>0<65536?G:(G|0)>0?65535:0;M=2;break}case 3:{G=rNa(L)|0;d[C>>1]=(G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768;M=2;break}case 4:{G=rNa(L)|0;f[C>>2]=G;M=4;break}case 5:{n[C>>2]=L;M=4;break}case 6:{p[C>>3]=L;M=8;break}case 7:{G=rNa(L)|0;f[C>>2]=G;M=4;break}default:{J=33;break a}}K=C+M|0;break}default:{f[k>>2]=0;f[t>>2]=0;m=c$(k,46)|0;o=184853;q=m+46|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(q|0));j$(-2,k,184738,177754,5077);d$(k);K=C}}G=(f[s>>2]|0)+16|0;f[s>>2]=G;if(G>>>0>=(f[v>>2]|0)>>>0)LL(c,1);G=F+-1|0;if(!G){J=42;break a}H=E+1|0;if((H|0)<(D|0)){C=K;E=H;F=G}else{N=K;O=G;break b}}}else{N=A;O=y}while(0);A=x+1|0;if((A|0)<(l|0)){x=A;y=O;z=N-e|0}else{P=O;break}}}else P=g;w=w+r|0;g=P}if((J|0)==22){f[k>>2]=0;f[k+4>>2]=0;m=c$(k,16)|0;o=205373;q=m+16|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(q|0));j$(-210,k,184738,177754,5021);d$(k);u=i;return}else if((J|0)==33){f[k>>2]=0;f[k+4>>2]=0;m=c$(k,16)|0;o=205373;q=m+16|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(q|0));j$(-210,k,184738,177754,5071);d$(k);u=i;return}else if((J|0)==42){if(!((x|0)==(l+-1|0)&(E|0)==(D+-1|0))){f[k>>2]=0;f[k+4>>2]=0;m=c$(k,60)|0;o=184900;q=m+60|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(q|0));j$(-201,k,184738,177754,5092);d$(k)}if(f[a>>2]|0){u=i;return}f[s>>2]=(f[s>>2]|0)+-16;u=i;return}}function HX(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=(a|0)!=0;if(!(h?(f[a>>2]|0)==1280131417:0)){i=h?-5:-27;f[g>>2]=0;f[g+4>>2]=0;j=c$(g,31)|0;k=177863;l=j+31|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(i,g,185128,177754,4626);d$(g)}if(f[a+8>>2]|0){m=a+236|0;n=f[m>>2]|0;fi[n&255](a,c,d);u=e;return}f[g>>2]=0;f[g+4>>2]=0;j=c$(g,38)|0;k=177912;l=j+38|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-2,g,185128,177754,4626);d$(g);m=a+236|0;n=f[m>>2]|0;fi[n&255](a,c,d);u=e;return}function IX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=f[c>>2]|0;c=f[a>>2]|0;a=f[b>>2]|0;if((d|0)>0)e=0;else{g=0;return g|0}while(1){b=(f[c+(e<<2)>>2]|0)-(f[a+(e<<2)>>2]|0)|0;e=e+1|0;if(b|0){g=b;h=4;break}if((e|0)>=(d|0)){g=0;h=4;break}}if((h|0)==4)return g|0;return 0}function JX(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=u;u=u+544|0;i=h+16|0;j=h+8|0;k=h;l=h+24|0;a:do if(d|0){m=d;b:while(1){n=f[m>>2]|0;if(!n)break a;o=f[n>>2]|0;if(o|0){p=o;o=0;q=0;while(1){o=o+1|0;if(!(KKa(c,p)|0))break b;r=o<<1;p=f[n+(r<<2)>>2]|0;if(!p)break;else q=r}}m=f[m+4>>2]|0;if(!m)break a}m=f[n+((q|1)<<2)>>2]|0;if(m|0){p=AW(m,l)|0;o=p<<1;if((p|0)>0){p=0;r=e;while(1){s=f[l+((p|1)<<2)>>2]|0;t=(s>>>3&511)+1<<(47696>>>(s<<1&14)&3);s=(r+-1+t&0-t)+(Y(t,f[l+(p<<2)>>2]|0)|0)|0;p=p+2|0;if((p|0)>=(o|0)){v=s;break}else r=s}}else v=e;if(!e){r=f[l+4>>2]|0;o=(r>>>3&511)+1<<(47696>>>(r<<1&14)&3);w=v+-1+o&0-o}else w=v;if((w|0)==(f[a+28>>2]|0)){x=m;u=h;return x|0}f[l>>2]=0;f[l+4>>2]=0;y=c$(l,71)|0;z=185729;A=y+71|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));j$(-209,l,185801,177754,5819);d$(l);x=m;u=h;return x|0}}while(0);w=f[a>>2]|0;v=f[a+28>>2]|0;if((w&4095|0)!=0|(v|0)==1){if(((w>>>3&511)+1<<(47696>>>(w<<1&14)&3)|0)==(v|0))B=w;else{f[l>>2]=0;f[l+4>>2]=0;y=c$(l,68)|0;z=185814;A=y+68|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));j$(-209,l,185801,177754,5825);d$(l);B=f[a>>2]|0}a=b[180230+(B&7)>>0]|0;f[k>>2]=(B>>>3&511)+1;f[k+4>>2]=a;SLa(g,183818,k)|0;if(!(b[g+2>>0]|0))C=(b[g>>0]|0)==49;else C=0;x=g+(C&1)|0;u=h;return x|0}if((v|0)<=(e|0)){x=0;u=h;return x|0}C=v-e|0;if(!(C&3)){f[j>>2]=C>>>2;SLa(g,185704,j)|0;x=g;u=h;return x|0}else{f[i>>2]=C;SLa(g,185708,i)|0;x=g;u=h;return x|0}return 0}function KX(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;g=u;u=u+688|0;h=g+40|0;i=g+8|0;j=g;k=g+552|0;l=g+32|0;m=g+24|0;n=g+16|0;a:do if(d){o=d;b:while(1){p=f[o>>2]|0;if(!p){q=14;break a}r=f[p>>2]|0;if(r|0){s=r;r=0;t=0;while(1){r=r+1|0;if(!(KKa(185594,s)|0))break b;v=r<<1;s=f[p+(v<<2)>>2]|0;if(!s)break;else t=v}}o=f[o+4>>2]|0;if(!o){q=14;break a}}o=f[p+((t|1)<<2)>>2]|0;if(o){s=AW(o,h)|0;r=s<<1;if((s|0)>0){s=0;v=e;while(1){w=f[h+((s|1)<<2)>>2]|0;x=(w>>>3&511)+1<<(47696>>>(w<<1&14)&3);w=(v+-1+x&0-x)+(Y(x,f[h+(s<<2)>>2]|0)|0)|0;s=s+2|0;if((s|0)>=(r|0)){y=w;break}else v=w}}else y=e;if(!e){v=f[h+4>>2]|0;r=(v>>>3&511)+1<<(47696>>>(v<<1&14)&3);z=y+-1+r&0-r}else z=y;if((z|0)>(f[c+4>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;r=c$(h,74)|0;v=185604;s=r+74|0;do{b[r>>0]=b[v>>0]|0;r=r+1|0;v=v+1|0}while((r|0)<(s|0));j$(-209,h,185679,177754,5755);d$(h);A=o}else A=o}else q=14}else q=14;while(0);do if((q|0)==14){z=f[c+4>>2]|0;if((z|0)<=(e|0)){u=g;return}y=f[c>>2]|0;if(((y&-65536|0)==1117323264?(z|0)==88&(y&4094|0)==12:0)?(f[c+28>>2]|0)==8:0){f[l>>2]=0;f[l+4>>2]=0;f[h>>2]=f[l>>2];f[h+4>>2]=f[l+4>>2];nX(a,335733,14,0,h);HX(a,185271,f[c+56>>2]|0);HX(a,185273,f[c+60>>2]|0);HX(a,337923,f[c+64>>2]|0);HX(a,337929,f[c+68>>2]|0);kV(a);HX(a,185698,f[c+72>>2]|0);u=g;return}if((y&-53248|0)==1117327360?((y&4095|0)==0?(f[c+28>>2]|0)==1:0):0){f[m>>2]=0;f[m+4>>2]=0;f[h>>2]=f[m>>2];f[h+4>>2]=f[m+4>>2];nX(a,185234,14,0,h);HX(a,185271,f[c+56>>2]|0);HX(a,185273,f[c+60>>2]|0);kV(a);u=g;return}y=z-e|0;if(!(y&3)){f[j>>2]=y>>>2;SLa(k,185704,j)|0;A=k;break}else{f[i>>2]=y;SLa(k,185708,i)|0;A=k;break}}while(0);pX(a,185594,A,0);f[n>>2]=0;f[n+4>>2]=0;f[h>>2]=f[n>>2];f[h+4>>2]=f[n+4>>2];nX(a,185712,13,0,h);oX(a,c+56|0,1,A);kV(a);u=g;return}function LX(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=(a|0)!=0;if(!(h?(f[a>>2]|0)==1280131417:0)){i=h?-5:-27;f[g>>2]=0;f[g+4>>2]=0;j=c$(g,31)|0;k=177863;l=j+31|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(i,g,186428,177754,6708);d$(g)}if(!c){m=0;u=e;return m|0}if((f[c>>2]&16|0)!=0?(i=f[c+4>>2]|0,(i|0)!=0):0)n=i;else{f[g>>2]=0;f[g+4>>2]=0;j=c$(g,57)|0;k=186435;l=j+57|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-2,g,186428,177754,6714);d$(g);n=f[c+4>>2]|0}g=$h[f[n+28>>2]&255](a,c)|0;if(!d){m=g;u=e;return m|0}f[d>>2]=0;f[d+4>>2]=0;m=g;u=e;return m|0}function MX(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+288|0;j=i+24|0;k=i;f[k>>2]=e;f[k+4>>2]=g;g=i+160|0;e=i+16|0;l=i+8|0;f[e>>2]=0;f[e+4>>2]=0;f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];nX(a,c,6,183695,j);if((h|0)>-1)HX(a,186365,h);h=JX(d,183823,k,0,i+32|0)|0;b[g>>0]=0;c=f[d>>2]|0;if(c&16384|0){e=g+(xKa(g)|0)|0;m=e;b[m>>0]=32;b[m+1>>0]=99;b[m+2>>0]=108;b[m+3>>0]=111;m=e+4|0;b[m>>0]=115;b[m+1>>0]=101;b[m+2>>0]=100;b[m+3>>0]=0}if(c&32768|0){m=g+(xKa(g)|0)|0;b[m>>0]=b[186715]|0;b[m+1>>0]=b[186716]|0;b[m+2>>0]=b[186717]|0;b[m+3>>0]=b[186718]|0;b[m+4>>0]=b[186719]|0;b[m+5>>0]=b[186720]|0}if((c&12288|0)==4096){m=g+(xKa(g)|0)|0;b[m>>0]=b[186721]|0;b[m+1>>0]=b[186722]|0;b[m+2>>0]=b[186723]|0;b[m+3>>0]=b[186724]|0;b[m+4>>0]=b[186725]|0;b[m+5>>0]=b[186726]|0;b[m+6>>0]=b[186727]|0}if((c&4095|0)==0?(f[d+28>>2]|0)!=1:0){c=g+(xKa(g)|0)|0;m=186728;e=c+9|0;do{b[c>>0]=b[m>>0]|0;c=c+1|0;m=m+1|0}while((c|0)<(e|0))}pX(a,185525,g+((b[g>>0]|0)!=0&1)|0,1);HX(a,186737,f[d+24>>2]|0);pX(a,183823,h,0);KX(a,d,k,56);f[l>>2]=0;f[l+4>>2]=0;f[j>>2]=f[l>>2];f[j+4>>2]=f[l+4>>2];nX(a,183826,13,0,j);j=d+52|0;d=f[j>>2]|0;if(!d){kV(a);kV(a);u=i;return}else n=d;while(1){oX(a,f[n+16>>2]|0,f[n+12>>2]|0,h);if((n|0)==(f[f[j>>2]>>2]|0)){o=15;break}n=f[n+4>>2]|0;if(!n){o=15;break}}if((o|0)==15){kV(a);kV(a);u=i;return}}function NX(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+1056|0;e=d+8|0;g=d;h=f[c>>2]|0;i=(h|0)==0?5694105:h;h=f[c+4>>2]|0;c=i+h|0;j=h+1|0;h=e+8|0;f[e>>2]=h;k=e+4|0;f[k>>2]=j;if(j>>>0>1032){l=OYa(j)|0;f[e>>2]=l;m=l}else m=h;l=c+-1|0;a:do if(l>>>0>=i>>>0){j=c;n=l;b:while(1){o=j;p=n;c:while(1){switch(b[p>>0]|0){case 58:case 47:case 92:{q=o;break b;break}case 46:{if(!(b[j>>0]|0))break c;if(!(aLa(j,186966,3)|0))break c;break}default:{}}r=p+-1|0;if(r>>>0<i>>>0){q=p;break b}else{s=p;p=r;o=s}}n=p+-1|0;if(n>>>0<i>>>0){t=p;v=p;w=11;break a}else j=p}if((q|0)==(j|0)){t=q;v=j;w=11}else{x=m;y=q;z=j}}else{t=c;v=c;w=11}while(0);if((w|0)==11){f[g>>2]=0;f[g+4>>2]=0;c=c$(g,16)|0;q=186970;m=c+16|0;do{b[c>>0]=b[q>>0]|0;c=c+1|0;q=q+1|0}while((c|0)<(m|0));j$(-5,g,186987,177754,157);d$(g);x=f[e>>2]|0;y=t;z=v}v=b[y>>0]|0;if(((v&-33)+-65&255)<26|v<<24>>24==95)A=x;else{b[x>>0]=95;A=x+1|0}if(y>>>0<z>>>0){x=A;v=y;while(1){y=b[v>>0]|0;v=v+1|0;t=x+1|0;b[x>>0]=y<<24>>24==95|(y<<24>>24==45|((y+-48&255)<10|((y&-33)+-65&255)<26))?y:95;if((v|0)==(z|0)){B=t;break}else x=t}}else B=A;b[B>>0]=0;B=f[e>>2]|0;if(KKa(B,183022)|0){f[a>>2]=0;f[a+4>>2]=0;if(B|0)w=19}else{A=B;x=A;b[x>>0]=117;b[x+1>>0]=110;b[x+2>>0]=110;b[x+3>>0]=97;x=A+4|0;b[x>>0]=109;b[x+1>>0]=101;b[x+2>>0]=100;b[x+3>>0]=0;f[a>>2]=0;f[a+4>>2]=0;w=19}if((w|0)==19?(w=xKa(B)|0,w|0):0)K1a(c$(a,w)|0,B|0,w|0)|0;w=f[e>>2]|0;if((w|0)==(h|0)){u=d;return}if(w|0)QYa(w);f[e>>2]=h;f[k>>2]=1032;u=d;return}function OX(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;g=(a|0)!=0;if(!(g?(f[a>>2]|0)==1280131417:0)){h=g?-5:-27;f[e>>2]=0;f[e+4>>2]=0;g=c$(e,31)|0;i=177863;j=g+31|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));j$(h,e,187008,177754,924);d$(e)}e=f[a+32>>2]|0;if(!e){k=0;u=d;return k|0}if((f[e+24>>2]|0)>>>0<=c>>>0){k=0;u=d;return k|0}k=AL(e,c)|0;u=d;return k|0}function PX(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=(a|0)!=0;if(!(h?(f[a>>2]|0)==1280131417:0)){i=h?-5:-27;f[g>>2]=0;f[g+4>>2]=0;j=c$(g,31)|0;k=177863;l=j+31|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(i,g,187026,177754,4634);d$(g)}if(f[a+8>>2]|0){m=a+240|0;n=f[m>>2]|0;hi[n&31](a,c,d);u=e;return}f[g>>2]=0;f[g+4>>2]=0;j=c$(g,38)|0;k=177912;l=j+38|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-2,g,187026,177754,4634);d$(g);m=a+240|0;n=f[m>>2]|0;hi[n&31](a,c,d);u=e;return}function QX(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=(a|0)!=0;if(!(h?(f[a>>2]|0)==1280131417:0)){i=h?-5:-27;f[g>>2]=0;f[g+4>>2]=0;j=c$(g,31)|0;k=177863;l=j+31|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(i,g,187038,177754,4650);d$(g)}if(f[a+8>>2]|0){m=a+248|0;n=f[m>>2]|0;fi[n&255](a,c,d);u=e;return}f[g>>2]=0;f[g+4>>2]=0;j=c$(g,38)|0;k=177912;l=j+38|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-2,g,187038,177754,4650);d$(g);m=a+248|0;n=f[m>>2]|0;fi[n&255](a,c,d);u=e;return}function RX(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+48|0;j=i;f[j>>2]=0;f[j+4>>2]=40;f[j+16>>2]=b;f[j+12>>2]=0;f[j+8>>2]=0;f[j+20>>2]=c;f[j+24>>2]=d;f[j+36>>2]=h;f[j+28>>2]=e;f[j+32>>2]=g;UW(j);f[a>>2]=f[225394];u=i;return}function SX(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;e=c$(d,19)|0;g=186213;h=e+19|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));j$(-27,d,187053,177754,6668);d$(d)}i=f[a>>2]|0;if(!i){u=c;return}j=f[225394]|0;a:do if(!j)k=7;else{l=j;while(1){if(mi[f[l+20>>2]&255](i)|0){m=l;break a}l=f[l+12>>2]|0;if(!l){k=7;break}}}while(0);if((k|0)==7){f[d>>2]=0;f[d+4>>2]=0;e=c$(d,19)|0;g=187063;h=e+19|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));j$(-2,d,187053,177754,6674);d$(d);m=0}k=m+24|0;m=f[k>>2]|0;if(!m){f[d>>2]=0;f[d+4>>2]=0;e=c$(d,32)|0;g=187083;h=e+32|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));j$(-2,d,187053,177754,6676);d$(d);n=f[k>>2]|0}else n=m;ki[n&2047](a);f[a>>2]=0;u=c;return}function TX(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=u;u=u+16|0;h=g+8|0;i=g;j=(a|0)!=0;if(!(j?(f[a>>2]|0)==1280131417:0)){k=j?-5:-27;f[h>>2]=0;f[h+4>>2]=0;l=c$(h,31)|0;m=177863;n=l+31|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(k,h,187116,177754,6731);d$(h)}if(!(f[a+8>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;l=c$(h,38)|0;m=177912;n=l+38|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-2,h,187116,177754,6731);d$(h)}a:do if(d){k=f[225394]|0;if(!k)o=11;else{j=k;while(1){if(mi[f[j+20>>2]&255](d)|0){p=j;break a}j=f[j+12>>2]|0;if(!j){o=11;break}}}}else{f[h>>2]=0;f[h+4>>2]=0;l=c$(h,34)|0;m=187124;n=l+34|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-27,h,187116,177754,6734);d$(h);o=11}while(0);if((o|0)==11){f[h>>2]=0;f[h+4>>2]=0;l=c$(h,14)|0;m=187159;n=l+14|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-5,h,187116,177754,6738);d$(h);p=0}o=p+32|0;p=f[o>>2]|0;if(p|0){q=p;r=e;s=r;t=f[s>>2]|0;v=r+4|0;w=v;x=f[w>>2]|0;y=i;z=y;f[z>>2]=t;A=y+4|0;B=A;f[B>>2]=x;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];Ah[q&255](a,c,d,h);u=g;return}f[h>>2]=0;f[h+4>>2]=0;l=c$(h,39)|0;m=187174;n=l+39|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-5,h,187116,177754,6741);d$(h);q=f[o>>2]|0;r=e;s=r;t=f[s>>2]|0;v=r+4|0;w=v;x=f[w>>2]|0;y=i;z=y;f[z>>2]=t;A=y+4|0;B=A;f[B>>2]=x;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];Ah[q&255](a,c,d,h);u=g;return}function UX(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=u;u=u+80|0;h=g+76|0;i=g+40|0;j=g+8|0;k=g;f[h>>2]=0;l=wV(a,c,0,0)|0;f[i>>2]=42604;a=i+4|0;m=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if(!l){f[a>>2]=0;f[m>>2]=l;f[i+32>>2]=0;n=0;dV(i);u=g;return n|0}o=NYa(16)|0;f[o+4>>2]=1;f[o>>2]=42656;f[o+8>>2]=l;f[a>>2]=o;f[m>>2]=l;f[i+32>>2]=l|0?6:0;if(!(b[l+300>>0]|0)){n=0;dV(i);u=g;return n|0}a:do if(!d){o=f[l+32>>2]|0;if((f[o+24>>2]|0)>0){a=k+4|0;p=j+12|0;q=j+20|0;r=o;o=0;b:while(1){s=AL(r,o)|0;if(!s){f[k>>2]=0;f[a>>2]=0;t=c$(k,10)|0;v=187214;w=t+10|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));j$(-215,k,187225,177754,6795);d$(k)}c:do if((f[s>>2]&7|0)==6){x=f[s+8>>2]|0;CL(x,j,0);y=x+24|0;z=f[y>>2]|0;if((z|0)>0){A=x+28|0;x=z;z=0;while(1){B=f[p>>2]|0;if((f[B>>2]|0)>-1)break;C=B+(f[A>>2]|0)|0;f[p>>2]=C;if(C>>>0<(f[q>>2]|0)>>>0)D=x;else{LL(j,1);D=f[y>>2]|0}z=z+1|0;if((z|0)>=(D|0)){E=0;F=0;break c}else x=D}E=8;F=B}else{E=0;F=0}}else{E=1;F=s}while(0);switch(E&15){case 8:{G=F;H=20;break a;break}case 0:break;default:break b}o=o+1|0;r=f[(f[m>>2]|0)+32>>2]|0;if((o|0)>=(f[r+24>>2]|0)){G=F;H=20;break a}}if(!E){G=F;H=20}else{n=0;dV(i);u=g;return n|0}}else H=21}else{G=CX(l,0,d)|0;H=20}while(0);if((H|0)==20)if(G)if(!(f[G>>2]&64)){I=0;J=G}else{I=f[(f[G+16>>2]|0)+8>>2]|0;J=G}else H=21;if((H|0)==21){f[j>>2]=0;f[j+4>>2]=0;t=c$(j,44)|0;v=187232;w=t+44|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));j$(-204,j,187225,177754,6820);d$(j);I=0;J=0}H=LX(f[m>>2]|0,J,0)|0;f[h>>2]=H;do if(!((c|0)!=0|(H|0)==0)){if((f[H>>2]&-65536|0)!=1117323264?(f[H>>2]&-65536|0)!=1117257728:0)break;f[j>>2]=0;f[j+4>>2]=0;t=c$(j,78)|0;v=187277;w=t+78|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));j$(-27,j,187225,177754,6828);d$(j)}while(0);if((S$()|0)<0){SX(h);K=0}else K=I;do if(e|0)if(!K){f[e>>2]=0;break}else{I=_F(xKa(K)|0)|0;f[e>>2]=I;K1a(I|0,K|0,xKa(K)|0)|0;break}while(0);n=f[h>>2]|0;dV(i);u=g;return n|0}function VX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;f[a>>2]=42604;e=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;fV(a,b,c,d)|0;return}function WX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;f[a>>2]=42604;d=a+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;if((b|0)==0|c^1)e=0;else{c=NYa(16)|0;f[c+4>>2]=1;f[c>>2]=42656;f[c+8>>2]=b;e=c}f[d>>2]=e;f[a+8>>2]=b;f[a+32>>2]=b|0?6:0;return}function XX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;if(mi[f[(f[b>>2]|0)+12>>2]&255](b)|0){d=f[b+8>>2]|0;e=OX(d,c)|0;g=d}else{e=0;g=0}f[a>>2]=g;f[a+4>>2]=e;return}function YX(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d+8|0;i=d;j=d+24|0;k=f[c>>2]|0;l=(k|0)==0?5694105:k;if(!((mi[f[(f[a>>2]|0)+12>>2]&255](a)|0)&(l|0)!=0)){u=d;return a|0}k=b[l>>0]|0;switch(k<<24>>24){case 93:case 125:{m=a+20|0;n=a+24|0;o=f[n>>2]|0;if((f[m>>2]|0)==(o|0)){f[i>>2]=k<<24>>24;p$(e,187356,i);j$(-2,e,373532,177754,6957);d$(e);p=b[l>>0]|0;q=f[n>>2]|0}else{p=k;q=o}o=b[q+-1>>0]|0;if(((p<<24>>24==93?91:123)|0)==(o|0))r=q;else{f[h>>2]=p<<24>>24;f[h+4>>2]=o;p$(e,187375,h);j$(-2,e,373532,177754,6960);d$(e);r=f[n>>2]|0}h=r+-1|0;f[n>>2]=h;if((f[m>>2]|0)==(h|0))s=6;else s=(b[r+-2>>0]|0)==123?6:1;f[a+32>>2]=s;kV(f[a+8>>2]|0);f[e>>2]=0;s=e+4|0;f[s>>2]=0;r=a+12|0;if((e|0)!=(r|0)){d$(r);h=f[e>>2]|0;if(!h)t=0;else{m=h+-4|0;f[m>>2]=(f[m>>2]|0)+1;t=f[e>>2]|0}f[r>>2]=t;f[a+16>>2]=f[s>>2]}d$(e);u=d;return a|0}default:{}}s=a+32|0;t=f[s>>2]|0;if((t|0)==6){if(!(((k&-33)+-65&255)<26|k<<24>>24==95)){f[g>>2]=l;p$(e,187424,g);j$(-2,e,373532,177754,6970);d$(e)}g=a+12|0;if((g|0)!=(c|0)){d$(g);r=f[c>>2]|0;if(!r)v=0;else{m=r+-4|0;f[m>>2]=(f[m>>2]|0)+1;v=f[c>>2]|0}f[g>>2]=v;f[a+16>>2]=f[c+4>>2]}f[s>>2]=5;u=d;return a|0}if((t&3|0)!=1){f[e>>2]=0;f[e+4>>2]=0;t=c$(e,16)|0;v=187450;g=t+16|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(g|0));j$(-2,e,373532,177754,7e3);d$(e);u=d;return a|0}switch(k<<24>>24){case 91:case 123:break;default:{a:do if(k<<24>>24==92){v=l+1|0;switch(b[v>>0]|0){case 93:case 91:case 125:case 123:break;default:{w=45;break a}}f[e>>2]=0;f[e+4>>2]=0;t=xKa(v)|0;if(t|0)K1a(c$(e,t)|0,v|0,t|0)|0}else w=45;while(0);if((w|0)==45?(w=f[c>>2]|0,f[e>>2]=w,f[e+4>>2]=f[c+4>>2],w|0):0){c=w+-4|0;f[c>>2]=(f[c>>2]|0)+1}if(!(f[a+16>>2]|0))x=0;else{c=f[a+12>>2]|0;x=(c|0)==0?5694105:c}c=f[e>>2]|0;pX(f[a+8>>2]|0,x,(c|0)==0?5694105:c,0);d$(e);if((f[s>>2]|0)!=5){u=d;return a|0}f[s>>2]=6;u=d;return a|0}}c=a+20|0;x=a+24|0;w=f[x>>2]|0;t=a+28|0;v=f[t>>2]|0;g=v;if((w|0)==(v|0)){v=f[c>>2]|0;m=w-v|0;r=m+1|0;h=v;if((r|0)<0)gXa(c);n=g-v|0;g=n<<1;o=n>>>0<1073741823?(g>>>0<r>>>0?r:g):2147483647;if(!o){y=k;z=0}else{g=NYa(o)|0;y=b[l>>0]|0;z=g}g=z+m|0;b[g>>0]=y;y=g+(0-m)|0;if((m|0)>0)K1a(y|0,h|0,m|0)|0;f[c>>2]=y;f[x>>2]=g+1;f[t>>2]=z+o;if(v|0)PYa(h)}else{b[w>>0]=k;f[x>>2]=(f[x>>2]|0)+1}x=l+1|0;k=(b[l>>0]|0)==123;w=k?6:5;f[s>>2]=k?6:1;k=(b[x>>0]|0)==58;s=k?l+2|0:x;x=f[a+8>>2]|0;l=a+12|0;h=a+16|0;if(!(f[h>>2]|0))A=0;else{v=f[l>>2]|0;A=(v|0)==0?5694105:v}v=b[s>>0]|0?s:0;f[j>>2]=0;f[j+4>>2]=0;f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];nX(x,A,k?w|8:w,v,e);f[e>>2]=0;v=e+4|0;f[v>>2]=0;if((e|0)!=(l|0)){d$(l);w=f[e>>2]|0;if(!w)B=0;else{k=w+-4|0;f[k>>2]=(f[k>>2]|0)+1;B=f[e>>2]|0}f[l>>2]=B;f[h>>2]=f[v>>2]}d$(e);u=d;return a|0}function ZX(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;if(!(mi[f[(f[a>>2]|0)+12>>2]&255](a)|0)){u=g;return}i=f[c>>2]|0;j=(i|0)==0?5694105:i;k=b[j>>0]|0;if((k+-48&255)<10){l=b[j+1>>0]|0;m=(k<<24>>24)+-48|0}else{l=k;m=1}switch(l<<24>>24){case 99:case 117:{n=1;break}case 119:{n=2;break}case 115:{n=2;break}case 105:{n=4;break}case 102:{n=4;break}case 100:{n=8;break}default:n=l<<24>>24==114?4:0}l=Y(n,m)|0;if(!((e>>>0)%(l>>>0)|0))o=i;else{f[h>>2]=0;f[h+4>>2]=0;i=c$(h,19)|0;m=187467;n=i+19|0;do{b[i>>0]=b[m>>0]|0;i=i+1|0;m=m+1|0}while((i|0)<(n|0));j$(-215,h,187487,177754,7011);d$(h);o=f[c>>2]|0}oX(f[a+8>>2]|0,d,(e>>>0)/(l>>>0)|0,(o|0)==0?5694105:o);u=g;return}function _X(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[b+8>>2]|0;b=f[c>>2]|0;c=CX(d,0,(b|0)==0?5694105:b)|0;f[a>>2]=d;f[a+4>>2]=c;return}function $X(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=f[b>>2]|0;e=CX(d,f[b+4>>2]|0,c)|0;f[a>>2]=d;f[a+4>>2]=e;return}function aY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=a+8|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;if((b|0)!=0&(c|0)!=0?(g=f[c>>2]|0,h=g&7,h|0):0){f[a>>2]=b;b=a+4|0;f[b>>2]=c;a:do if((g&16|0)==0&(h+-5|0)>>>0<2){i=c+8|0;CL(f[i>>2]|0,e,0);j=f[c>>2]|0;switch(j&7){case 6:{k=f[(f[i>>2]|0)+60>>2]|0;break a;break}case 5:{k=f[(f[i>>2]|0)+24>>2]|0;break a;break}default:{k=(j&7|0)!=0&1;break a}}}else{f[a+20>>2]=c;f[a+12>>2]=0;k=1}while(0);c=a+40|0;f[c>>2]=k;if(!d)return;if((d|0)>0)l=(k|0)<(d|0)?k:d;else{h=f[b>>2]|0;b:do if(!h){m=0;n=17}else{b=f[h>>2]|0;switch(b&7){case 6:{o=f[(f[h+8>>2]|0)+60>>2]|0;break b;break}case 5:{o=f[(f[h+8>>2]|0)+24>>2]|0;break b;break}default:{m=(b&7|0)!=0;n=17;break b}}}while(0);if((n|0)==17)o=m&1;m=k-d|0;l=k-(o>>>0<m>>>0?o:m)|0}f[c>>2]=k-l;if(!(f[a+12>>2]|0))return;DL(e,l,1);return}f[a>>2]=0;f[a+4>>2]=0;f[a+40>>2]=0;return}function bY(a){a=a|0;var b=0,c=0,d=0;b=f[a+4>>2]|0;a:do if(!b)c=0;else{a=f[b>>2]|0;switch(a&7){case 6:{d=f[(f[b+8>>2]|0)+60>>2]|0;return d|0}case 5:{d=f[(f[b+8>>2]|0)+24>>2]|0;return d|0}default:{c=(a&7|0)!=0;break a}}}while(0);d=c&1;return d|0}function cY(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=a+40|0;c=f[b>>2]|0;if(!c)return a|0;d=a+8|0;e=f[a+12>>2]|0;if((e|0)!=0?(g=a+20|0,h=(f[g>>2]|0)+(f[e+28>>2]|0)|0,f[g>>2]=h,h>>>0>=(f[a+28>>2]|0)>>>0):0){LL(d,1);i=f[b>>2]|0}else i=c;f[b>>2]=i+-1;return a|0}function dY(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+16|0;h=g;i=f[a>>2]|0;if(!i){u=g;return a|0}j=a+4|0;if(!(f[j>>2]|0)){u=g;return a|0}k=a+40|0;l=f[k>>2]|0;if(!l){u=g;return a|0}m=f[c>>2]|0;n=(m|0)==0?5694105:m;o=b[n>>0]|0;if((o+-48&255)<10){p=b[n+1>>0]|0;q=(o<<24>>24)+-48|0}else{p=o;q=1}switch(p<<24>>24){case 99:case 117:{r=1;break}case 119:{r=2;break}case 115:{r=2;break}case 105:{r=4;break}case 102:{r=4;break}case 100:{r=8;break}default:r=p<<24>>24==114?4:0}if(!(Y(r,q)|0)){f[h>>2]=0;f[h+4>>2]=0;r=c$(h,13)|0;p=187496;o=r+13|0;do{b[r>>0]=b[p>>0]|0;r=r+1|0;p=p+1|0}while((r|0)<(o|0));j$(-215,h,187510,177754,7205);d$(h);s=f[k>>2]|0;t=f[c>>2]|0;v=f[a>>2]|0}else{s=l;t=m;v=i}i=s>>>0>e>>>0?e:s;if(!(f[a+12>>2]|0)){DX(v,f[j>>2]|0,d,(t|0)==0?5694105:t);w=0}else{GX(v,a+8|0,i,d,(t|0)==0?5694105:t);t=Y(i,q)|0;w=(f[k>>2]|0)-t|0}f[k>>2]=w;u=g;return a|0}function eY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=f[a+8>>2]|0;if(!(f[b+4>>2]|0)){e=0;HX(d,e,c);return}a=f[b>>2]|0;e=(a|0)==0?5694105:a;HX(d,e,c);return}function fY(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0.0;d=f[a+8>>2]|0;if(!(f[b+4>>2]|0)){e=0;g=c;PX(d,e,g);return}a=f[b>>2]|0;e=(a|0)==0?5694105:a;g=c;PX(d,e,g);return}function gY(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;d=f[a+8>>2]|0;if(!(f[b+4>>2]|0)){e=0;PX(d,e,c);return}a=f[b>>2]|0;e=(a|0)==0?5694105:a;PX(d,e,c);return}function hY(a,b){a=a|0;b=b|0;HX(f[a+8>>2]|0,0,b);return}function iY(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+16|0;i=h+8|0;j=h;f[a>>2]=c;k=f[c+8>>2]|0;if(!(f[d+4>>2]|0))l=0;else{c=f[d>>2]|0;l=(c|0)==0?5694105:c}if(!(f[g+4>>2]|0))m=0;else{c=f[g>>2]|0;m=(c|0)==0?5694105:c}f[j>>2]=0;f[j+4>>2]=0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];nX(k,l,e,m,i);f[i>>2]=0;m=i+4|0;f[m>>2]=0;l=f[a>>2]|0;k=l+12|0;if((i|0)!=(k|0)){d$(k);j=f[i>>2]|0;if(!j)n=0;else{c=j+-4|0;f[c>>2]=(f[c>>2]|0)+1;n=f[i>>2]|0}f[k>>2]=n;f[l+16>>2]=f[m>>2]}d$(i);i=f[a>>2]|0;a=i+32|0;if((e&7|0)==5){f[a>>2]=1;e=i+20|0;m=i+24|0;l=f[m>>2]|0;n=i+28|0;k=f[n>>2]|0;if((l|0)!=(k|0)){b[l>>0]=91;f[m>>2]=(f[m>>2]|0)+1;u=h;return}c=f[e>>2]|0;j=l-c|0;l=j+1|0;g=c;if((l|0)<0)gXa(e);d=k-c|0;k=d<<1;o=d>>>0<1073741823?(k>>>0<l>>>0?l:k):2147483647;if(!o)p=0;else p=NYa(o)|0;k=p+j|0;b[k>>0]=91;l=k+(0-j)|0;if((j|0)>0)K1a(l|0,g|0,j|0)|0;f[e>>2]=l;f[m>>2]=k+1;f[n>>2]=p+o;if(!c){u=h;return}PYa(g);u=h;return}else{f[a>>2]=6;a=i+20|0;g=i+24|0;c=f[g>>2]|0;o=i+28|0;i=f[o>>2]|0;if((c|0)!=(i|0)){b[c>>0]=123;f[g>>2]=(f[g>>2]|0)+1;u=h;return}p=f[a>>2]|0;n=c-p|0;c=n+1|0;k=p;if((c|0)<0)gXa(a);m=i-p|0;i=m<<1;l=m>>>0<1073741823?(i>>>0<c>>>0?c:i):2147483647;if(!l)q=0;else q=NYa(l)|0;i=q+n|0;b[i>>0]=123;c=i+(0-n)|0;if((n|0)>0)K1a(c|0,k|0,n|0)|0;f[a>>2]=c;f[g>>2]=i+1;f[o>>2]=q+l;if(!p){u=h;return}PYa(k);u=h;return}}function jY(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;kV(f[(f[a>>2]|0)+8>>2]|0);e=f[a>>2]|0;a=e+24|0;g=f[a>>2]|0;h=g+-1|0;f[a>>2]=h;if((f[e+20>>2]|0)==(h|0))i=6;else i=(b[g+-2>>0]|0)==123?6:1;f[e+32>>2]=i;f[d>>2]=0;i=d+4|0;f[i>>2]=0;g=e+12|0;if((d|0)==(g|0)){d$(d);u=c;return}d$(g);h=f[d>>2]|0;if(!h)j=0;else{a=h+-4|0;f[a>>2]=(f[a>>2]|0)+1;j=f[d>>2]|0}f[g>>2]=j;f[e+16>>2]=f[i>>2];d$(d);u=c;return}function kY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/28|0;h=g+1|0;i=e;j=d;if(h>>>0>153391689)gXa(a);k=a+8|0;l=((f[k>>2]|0)-e|0)/28|0;e=l<<1;m=l>>>0<76695844?(e>>>0<h>>>0?h:e):153391689;do if(m)if(m>>>0>153391689){e=De(8)|0;UYa(e,358155);f[e>>2]=130560;Of(e|0,21520,875)}else{n=NYa(m*28|0)|0;break}else n=0;while(0);e=n+(g*28|0)|0;h=e;l=n+(m*28|0)|0;f[e>>2]=f[b>>2];f[n+(g*28|0)+4>>2]=f[b+4>>2];m=n+(g*28|0)+8|0;g=b+8|0;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[m+8>>2]=f[g+8>>2];f[m+12>>2]=f[g+12>>2];f[m+16>>2]=f[g+16>>2];g=e+28|0;if((j|0)==(i|0)){o=h;p=d}else{d=e;e=j;j=h;do{h=e;e=e+-28|0;f[d+-28>>2]=f[e>>2];f[d+-24>>2]=f[h+-24>>2];m=d+-20|0;b=h+-20|0;f[m>>2]=f[b>>2];f[m+4>>2]=f[b+4>>2];f[m+8>>2]=f[b+8>>2];f[m+12>>2]=f[b+12>>2];f[m+16>>2]=f[b+16>>2];d=j+-28|0;j=d}while((e|0)!=(i|0));o=j;p=f[a>>2]|0}f[a>>2]=o;f[c>>2]=g;f[k>>2]=l;if(!p)return;PYa(p);return}function lY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/28|0)>>>0>=b>>>0){i=h;j=b;while(1){n[i>>2]=0.0;n[i+4>>2]=0.0;n[i+8>>2]=0.0;n[i+12>>2]=-1.0;n[i+16>>2]=0.0;f[i+20>>2]=0;f[i+24>>2]=-1;j=j+-1|0;if(!j)break;else i=i+28|0}f[e>>2]=h+(b*28|0);return}i=f[a>>2]|0;j=(g-i|0)/28|0;k=j+b|0;l=i;if(k>>>0>153391689)gXa(a);m=(d-i|0)/28|0;i=m<<1;d=m>>>0<76695844?(i>>>0<k>>>0?k:i):153391689;do if(d)if(d>>>0>153391689){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{o=NYa(d*28|0)|0;break}else o=0;while(0);i=o+(j*28|0)|0;j=o+(d*28|0)|0;d=i;o=b;while(1){n[d>>2]=0.0;n[d+4>>2]=0.0;n[d+8>>2]=0.0;n[d+12>>2]=-1.0;n[d+16>>2]=0.0;f[d+20>>2]=0;f[d+24>>2]=-1;o=o+-1|0;if(!o)break;else d=d+28|0}d=i;o=j;j=i+(b*28|0)|0;if((h|0)==(l|0)){p=d;q=g}else{g=i;i=h;h=d;do{d=i;i=i+-28|0;f[g+-28>>2]=f[i>>2];f[g+-24>>2]=f[d+-24>>2];b=g+-20|0;k=d+-20|0;f[b>>2]=f[k>>2];f[b+4>>2]=f[k+4>>2];f[b+8>>2]=f[k+8>>2];f[b+12>>2]=f[k+12>>2];f[b+16>>2]=f[k+16>>2];g=h+-28|0;h=g}while((i|0)!=(l|0));p=h;q=f[a>>2]|0}f[a>>2]=p;f[e>>2]=j;f[c>>2]=o;if(!q)return;PYa(q);return}function mY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)gXa(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;PYa(d);return}function nY(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;if(!b){c=0;return c|0}c=f[b>>2]&7;return c|0}function oY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=f[a+4>>2]|0;if(d)if((f[d>>2]&7|0)==1)e=f[d+8>>2]|0;else e=2147483647;else e=c;f[b>>2]=e;return}function pY(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0.0;d=f[a+4>>2]|0;a:do if(!d)e=c;else switch(f[d>>2]&7){case 1:{e=+(f[d+8>>2]|0);break a;break}case 2:{e=+p[d+8>>3];break a;break}default:{e=3402823466385288598117041.0e14;break a}}while(0);n[b>>2]=e;return}function qY(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0.0;d=f[a+4>>2]|0;a:do if(!d)e=c;else switch(f[d>>2]&7){case 1:{e=+(f[d+8>>2]|0);break a;break}case 2:{e=+p[d+8>>3];break a;break}default:{e=1797693134862315708145274.0e284;break a}}while(0);p[b>>3]=e;return}function rY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[a+4>>2]|0;do if(!g){a=f[c>>2]|0;f[e>>2]=a;f[e+4>>2]=f[c+4>>2];if(a|0){h=a+-4|0;f[h>>2]=(f[h>>2]|0)+1}}else{if((f[g>>2]&7|0)!=3){f[e>>2]=0;f[e+4>>2]=0;break}h=f[g+8+4>>2]|0;f[e>>2]=0;f[e+4>>2]=0;if(h|0?(a=xKa(h)|0,a|0):0)K1a(c$(e,a)|0,h|0,a|0)|0}while(0);if((e|0)==(b|0)){d$(e);u=d;return}d$(b);g=f[e>>2]|0;if(!g)i=0;else{c=g+-4|0;f[c>>2]=(f[c>>2]|0)+1;i=f[e>>2]|0}f[b>>2]=i;f[b+4>>2]=f[e+4>>2];d$(e);u=d;return}function sY(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0.0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0;e=d;g=f[e>>2]|0;h=f[e+4>>2]|0;if(!(b[5689202]|0)){f[225404]=1991057938;f[225405]=0;n[225532]=1.7290404663583558e-09;n[225659]=1.6030947680434338e-09;n[225660]=1.0;n[225787]=2.6696291752159595e-03;e=126;i=3.442619855899;while(1){j=i;i=+M(+(+W(+(.00991256303526217/i+ +V(+(i*(i*-.5)))))*-2.0));f[901616+(e+1<<2)>>2]=~~(i/j*2147483648.0)>>>0;j=+V(+(i*(i*-.5)));n[902640+(e<<2)>>2]=j;n[902128+(e<<2)>>2]=i*4.656612873077393e-10;if((e|0)<=1)break;else e=e+-1|0}b[5689202]=1}if((c|0)>0){k=g;l=h;m=0}else{o=g;p=h;q=d;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}while(1){h=l;g=k;while(1){e=W1a(g|0,0,-130063606,0)|0;u=C1a(e|0,J|0,h|0,0)|0;e=J;v=g&127;i=+n[902128+(v<<2)>>2]*+(g|0);if(((g|0)>-1?g:0-g|0)>>>0<(f[901616+(v<<2)>>2]|0)>>>0){w=u;x=e;y=i;break}if(!v){z=u;A=e;B=9;break}C=W1a(u|0,0,-130063606,0)|0;D=C1a(C|0,J|0,e|0,0)|0;e=J;j=+n[902640+(v<<2)>>2];E=i;if(!(j+ +(u>>>0)*2.3283064365386963e-10*(+n[902640+(v+-1<<2)>>2]-j)<+V(+(E*(E*-.5))))){h=e;g=D}else{w=D;x=e;y=i;break}}if((B|0)==9){while(1){B=0;h=W1a(z|0,0,-130063606,0)|0;e=C1a(h|0,J|0,A|0,0)|0;h=J;D=W1a(e|0,0,-130063606,0)|0;v=z;z=C1a(D|0,J|0,h|0,0)|0;A=J;F=-+W(+(+(v>>>0)*2.3283064365386963e-10+1.1754943508222875e-38))*.2904764;i=+W(+(+(e>>>0)*2.3283064365386963e-10+1.1754943508222875e-38));if(!(-i-i<F*F))break;else B=9}w=z;x=A;y=(g|0)>0?F+3.442620038986206:-3.442620038986206-F}n[a+(m<<2)>>2]=y;m=m+1|0;if((m|0)==(c|0)){o=w;p=x;break}else{k=w;l=x}}q=d;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}function tY(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0;i=u;u=u+2528|0;j=i+2464|0;k=i+2408|0;l=i+2352|0;m=i+2296|0;o=i+1096|0;q=i+2224|0;r=i+2288|0;t=i+2280|0;v=i+2192|0;w=i;do if((NS(c)|0)==65536){x=f[c+4>>2]|0;f[k>>2]=f[x>>2];y=k+4|0;z=x+4|0;f[y>>2]=f[z>>2];A=k+8|0;f[A>>2]=f[x+8>>2];f[k+12>>2]=f[x+12>>2];f[k+16>>2]=f[x+16>>2];f[k+20>>2]=f[x+20>>2];f[k+24>>2]=f[x+24>>2];f[k+28>>2]=f[x+28>>2];f[k+32>>2]=f[x+32>>2];B=f[x+36>>2]|0;f[k+36>>2]=B;f[k+40>>2]=A;A=k+48|0;C=k+44|0;f[C>>2]=A;f[A>>2]=0;f[k+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[x+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;BR(k,x);break}}else OR(k,c,-1);while(0);do if((NS(e)|0)==65536){c=f[e+4>>2]|0;f[l>>2]=f[c>>2];x=l+4|0;y=c+4|0;f[x>>2]=f[y>>2];z=l+8|0;f[z>>2]=f[c+8>>2];f[l+12>>2]=f[c+12>>2];f[l+16>>2]=f[c+16>>2];f[l+20>>2]=f[c+20>>2];f[l+24>>2]=f[c+24>>2];f[l+28>>2]=f[c+28>>2];f[l+32>>2]=f[c+32>>2];A=f[c+36>>2]|0;f[l+36>>2]=A;f[l+40>>2]=z;z=l+48|0;C=l+44|0;f[C>>2]=z;f[z>>2]=0;f[l+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[c+44>>2]|0;z=f[C>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;BR(l,c);break}}else OR(l,e,-1);while(0);do if((NS(g)|0)==65536){e=f[g+4>>2]|0;f[m>>2]=f[e>>2];c=m+4|0;x=e+4|0;f[c>>2]=f[x>>2];y=m+8|0;f[y>>2]=f[e+8>>2];f[m+12>>2]=f[e+12>>2];f[m+16>>2]=f[e+16>>2];f[m+20>>2]=f[e+20>>2];f[m+24>>2]=f[e+24>>2];f[m+28>>2]=f[e+28>>2];f[m+32>>2]=f[e+32>>2];z=f[e+36>>2]|0;f[m+36>>2]=z;f[m+40>>2]=y;y=m+48|0;C=m+44|0;f[C>>2]=y;f[y>>2]=0;f[m+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[e+44>>2]|0;y=f[C>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[c>>2]=0;BR(m,e);break}}else OR(m,g,-1);while(0);g=f[k>>2]|0;e=g&7;c=g>>>3&511;x=c+1|0;y=o+8|0;f[o>>2]=y;C=o+4|0;f[C>>2]=136;z=f[l>>2]|0;if((z&4088|0)==0?(A=f[l+8>>2]|0,B=f[l+12>>2]|0,(A|0)==1|(B|0)==1):0){D=A+-1+B|0;if(!((D|0)==(x|0)|(D|0)==1)?(D=f[l+40>>2]|0,x>>>0>4|(z&4095|0)!=6|((f[D>>2]|0)!=4?1:(f[D+4>>2]|0)!=1)):0)E=26}else E=26;if((E|0)==26){f[j>>2]=0;f[j+4>>2]=0;K1a(c$(j,218)|0,187518,218)|0;j$(-215,j,187737,187742,509);d$(j)}do if(!(f[m>>2]&4088)){D=f[m+8>>2]|0;z=f[m+12>>2]|0;if((D|0)!=1)if((z|0)==1){F=1;E=30}else G=z;else{F=z;E=30}if((E|0)==30){z=D+-1+F|0;if((z|0)==(x|0)|(z|0)==1)break;z=f[l+40>>2]|0;if(((f[z>>2]|0)==4?(f[z+4>>2]|0)==1:0)?(x>>>0<5?(f[l>>2]&4095|0)==6:0):0)break;else G=F}if(!((D|0)==(x|0)?(d|0)==1&(G|0)==(x|0):0))E=35}else E=35;while(0);if((E|0)==35){f[j>>2]=0;f[j+4>>2]=0;K1a(c$(j,290)|0,187788,290)|0;j$(-215,j,187737,187742,514);d$(j)}G=l+4|0;F=f[G>>2]|0;if((F|0)<3)H=Y(f[l+12>>2]|0,f[l+8>>2]|0)|0;else{D=f[l+40>>2]|0;z=0;B=1;while(1){A=Y(f[D+(z<<2)>>2]|0,B)|0;z=z+1|0;if((z|0)==(F|0)){H=A;break}else B=A}}B=m+4|0;F=f[B>>2]|0;if((F|0)<3)I=Y(f[m+12>>2]|0,f[m+8>>2]|0)|0;else{z=f[m+40>>2]|0;D=0;A=1;while(1){K=Y(f[z+(D<<2)>>2]|0,A)|0;D=D+1|0;if((D|0)==(F|0)){I=K;break}else A=K}}A=(d|0)==0;do if(!A){if((d|0)!=1){f[j>>2]=0;f[j+4>>2]=0;L=c$(j,25)|0;M=188094;N=L+25|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));j$(-5,j,187737,187742,674);d$(j);O=0;P=0;Q=0;R=0;S=0;T=0;U=0;V=0;W=1;X=0;Z=0;break}F=(H|0)<=(c|0);D=F?x:H;z=(I|0)<=(c|0);K=(z?x:I)+D|0;if((f[C>>2]|0)>>>0<K>>>0){_=f[o>>2]|0;if((_|0)!=(y|0)){if(_|0)QYa(_);f[o>>2]=y;f[C>>2]=136}f[C>>2]=K;if(K>>>0>136){_=OYa(K>>>0>536870911?-1:K<<3)|0;f[o>>2]=_;$=_}else $=y}else{f[C>>2]=K;$=f[o>>2]|0}K=(e|0)==6?6:5;_=47696>>>(K<<1)&3;aa=f[l>>2]|0;if((aa&16384|0)!=0?!(F|(aa&4095|0)!=(K|0)):0)ba=f[l+16>>2]|0;else{aa=f[l+40>>2]|0;ca=f[aa>>2]|0;f[r>>2]=f[aa+4>>2];f[r+4>>2]=ca;CN(j,r,K,$,0);ca=q+8|0;f[ca>>2]=0;f[ca+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=j;WJ(l,q,K,1.0,0.0);ca=j+36|0;aa=f[ca>>2]|0;if(aa|0?(da=aa+12|0,aa=f[da>>2]|0,f[da>>2]=aa+-1,(aa|0)==1):0)CR(j);f[ca>>2]=0;ca=j+16|0;aa=j+4|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[aa>>2]|0)>0){ca=f[j+40>>2]|0;da=0;do{f[ca+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[aa>>2]|0))}aa=f[j+44>>2]|0;if((aa|0)!=(j+48|0))ZF(aa);ba=$}if(F?(aa=H<<_,da=x<<_,(aa|0)<(da|0)):0){ca=aa;do{b[ba+ca>>0]=b[ba+(ca-aa)>>0]|0;ca=ca+1|0}while((ca|0)!=(da|0))}da=f[m>>2]|0;if((da&16384|0)!=0?!(z|(da&4095|0)!=(K|0)):0)ea=f[m+16>>2]|0;else{da=f[m+40>>2]|0;ca=f[da>>2]|0;f[t>>2]=f[da+4>>2];f[t+4>>2]=ca;ca=$+(D<<3)|0;CN(j,t,K,ca,0);da=q+8|0;f[da>>2]=0;f[da+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=j;WJ(m,q,K,1.0,0.0);da=j+36|0;aa=f[da>>2]|0;if(aa|0?(F=aa+12|0,aa=f[F>>2]|0,f[F>>2]=aa+-1,(aa|0)==1):0)CR(j);f[da>>2]=0;da=j+16|0;aa=j+4|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[aa>>2]|0)>0){da=f[j+40>>2]|0;F=0;do{f[da+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[aa>>2]|0))}aa=f[j+44>>2]|0;if((aa|0)!=(j+48|0))ZF(aa);ea=ca}if(z?(aa=I<<_,F=x<<_,(aa|0)<(F|0)):0){da=aa;do{b[ea+da>>0]=b[ea+(da-aa)>>0]|0;da=da+1|0}while((da|0)!=(F|0))}F=(f[m+8>>2]|0)==(x|0)?(f[m+12>>2]|0)==(x|0):0;da=f[42788+(e<<2)>>2]|0;if((e|0)==7){f[j>>2]=0;f[j+4>>2]=0;L=c$(j,14)|0;M=188079;N=L+14|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));j$(-215,j,187737,187742,671);d$(j);O=0;P=0;Q=0;R=0;S=0;T=0;U=ba;V=da;W=1;X=ea;Z=F}else{O=0;P=0;Q=0;R=0;S=0;T=0;U=ba;V=da;W=1;X=ea;Z=F}}else{aa=H+(x<<3)+I|0;if((f[C>>2]|0)>>>0<aa>>>0){_=f[o>>2]|0;if((_|0)!=(y|0)){if(_|0)QYa(_);f[o>>2]=y;f[C>>2]=136}f[C>>2]=aa;if(aa>>>0>136){_=OYa(aa>>>0>536870911?-1:aa<<3)|0;f[o>>2]=_;fa=_}else fa=y}else{f[C>>2]=aa;fa=f[o>>2]|0}aa=f[m+16>>2]|0;_=f[l>>2]|0;if((_&16384|0)!=0?(H|0)==(x|0)&(_&4095|0)==6:0)ga=f[l+16>>2]|0;else{_=f[l+40>>2]|0;z=f[_+4>>2]|0;ca=f[_>>2]|0;f[q>>2]=1124007942;_=q+4|0;f[_>>2]=2;K=q+8|0;f[K>>2]=ca;D=q+12|0;f[D>>2]=z;ha=q+16|0;f[ha>>2]=fa;ia=q+20|0;f[ia>>2]=fa;ja=q+24|0;ka=q+28|0;la=q+40|0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;f[la>>2]=K;ma=q+48|0;na=q+44|0;f[na>>2]=ma;f[q+52>>2]=0;f[ma>>2]=0;if((fa|0)==0&(Y(ca,z)|0)!=0){f[j>>2]=0;f[j+4>>2]=0;L=c$(j,26)|0;M=358223;N=L+26|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));j$(-215,j,358250,358254,533);d$(j);oa=f[D>>2]|0;pa=f[q>>2]|0;qa=f[na>>2]|0;ra=f[ia>>2]|0}else{oa=z;pa=1124007942;qa=ma;ra=fa}F=oa<<3;f[q>>2]=pa|16384;f[qa>>2]=F;f[qa+4>>2]=8;da=ra+(Y(f[K>>2]|0,F)|0)|0;f[ka>>2]=da;f[ja>>2]=da+(0-F)+F;F=j+8|0;f[F>>2]=0;f[F+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=q;WJ(l,j,6,1.0,0.0);if((H|0)<=(c|0)){F=H;while(1){p[fa+(F<<3)>>3]=+p[fa+(F-H<<3)>>3];if((F|0)<(c|0))F=F+1|0;else break}}F=q+36|0;ja=f[F>>2]|0;if(ja|0?(ka=ja+12|0,ja=f[ka>>2]|0,f[ka>>2]=ja+-1,(ja|0)==1):0)CR(q);f[F>>2]=0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[_>>2]|0)>0){F=f[la>>2]|0;ja=0;do{f[F+(ja<<2)>>2]=0;ja=ja+1|0}while((ja|0)<(f[_>>2]|0))}_=f[na>>2]|0;if((_|0)!=(ma|0))ZF(_);ga=fa}_=f[m>>2]|0;if((_&16384|0)!=0?(I|0)==(x|0)&(_&4095|0)==6:0)sa=aa;else{_=f[m+40>>2]|0;ja=f[_+4>>2]|0;F=f[_>>2]|0;_=fa+(x<<3)|0;la=j+4|0;f[la>>2]=2;ha=j+8|0;f[ha>>2]=F;f[j+12>>2]=ja;ka=j+16|0;f[ka>>2]=_;f[j+20>>2]=_;K=j+24|0;z=j+40|0;ia=K+8|0;f[ia>>2]=0;f[ia+4>>2]=0;f[z>>2]=ha;ha=j+48|0;ia=j+44|0;f[ia>>2]=ha;D=ja<<3;f[j>>2]=1124024326;f[ha>>2]=D;f[j+52>>2]=8;ja=_+(Y(F,D)|0)|0;f[j+28>>2]=ja;f[K>>2]=ja+(0-D)+D;D=q+8|0;f[D>>2]=0;f[D+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=j;WJ(m,q,6,1.0,0.0);if((I|0)<=(c|0)){D=I;while(1){p[_+(D<<3)>>3]=+p[_+(D-I<<3)>>3];if((D|0)<(c|0))D=D+1|0;else break}}D=j+36|0;aa=f[D>>2]|0;if(aa|0?(ma=aa+12|0,aa=f[ma>>2]|0,f[ma>>2]=aa+-1,(aa|0)==1):0)CR(j);f[D>>2]=0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;if((f[la>>2]|0)>0){D=f[z>>2]|0;aa=0;do{f[D+(aa<<2)>>2]=0;aa=aa+1|0}while((aa|0)<(f[la>>2]|0))}la=f[ia>>2]|0;if((la|0)!=(ha|0))ZF(la);sa=_}do if(e>>>0>=5){ta=(e|0)==6?5.421010862427522e-20:2.3283064365386963e-10;ua=h?3402823466385288598117041.0e14:1797693134862315708145274.0e284;la=fa+(x<<1<<3)|0;if((e|0)==5){aa=0;do{va=+p[sa+(aa<<3)>>3];wa=+p[ga+(aa<<3)>>3];xa=va-wa;D=la+(aa<<3)|0;n[D>>2]=ta*(xa<ua?xa:ua);n[D+4>>2]=(va+wa)*.5;aa=aa+1|0}while((aa|0)!=(x|0));ya=0;za=0;Aa=0;Ba=0;Ca=la;Da=0;Ea=1;break}else{aa=0;do{D=sa+(aa<<3)|0;z=ga+(aa<<3)|0;ua=+p[D>>3]-+p[z>>3];p[la+(aa<<4)>>3]=ta*(ua<1797693134862315708145274.0e284?ua:1797693134862315708145274.0e284);p[la+(aa<<4)+8>>3]=(+p[D>>3]+ +p[z>>3])*.5;aa=aa+1|0}while((aa|0)!=(x|0));ya=0;za=la;Aa=0;Ba=0;Ca=0;Da=0;Ea=1}}else{la=fa+(x<<1<<3)|0;aa=(e|2|0)==2;z=g&255;D=(e|0)==3;ta=D?32768.0:2147483647.0;if(h){ka=aa|(e|0)!=1;ua=aa?0.0:D?-32768.0:-2147483648.0;D=1;aa=0;ma=1;while(1){wa=+p[sa+(aa<<3)>>3];va=+p[ga+(aa<<3)>>3];xa=wa<va?wa:va;Fa=va<wa?wa:va;a:do if(ka){va=xa<ua?ua:xa;switch(z&7){case 0:{Ga=va;Ha=256.0;break a;break}case 1:{Ia=va;E=87;break a;break}case 2:{Ga=va;Ha=65536.0;break a;break}default:{Ga=va;Ha=ta;break a}}}else{Ia=xa<-128.0?-128.0:xa;E=87}while(0);if((E|0)==87){E=0;Ga=Ia;Ha=128.0}xa=Ha<Fa?Ha:Fa;na=~~Ga;ja=(+(na|0)<Ga&1)+na|0;na=la+(aa<<3)|0;K=na+4|0;f[K>>2]=ja;F=~~xa;da=F-(+(F|0)>xa&1)-ja|0;ja=da+-1|0;f[na>>2]=ja;va=xa-Ga;F=(ja&da|0)==0;do if(D<<24>>24!=0&va<=4294967296.0){ja=F&1;if(!F){Ja=ja;E=92;break}Ka=ja;La=(ma&1)!=0&(da|0)<257&1}else{Ja=0;E=92}while(0);do if((E|0)==92){E=0;if(va>2147483647.0)f[na>>2]=2147483647;if(!(Ga<-1073741824.0)){Ka=Ja;La=ma;break}f[K>>2]=-1073741824;Ka=Ja;La=ma}while(0);aa=aa+1|0;if((aa|0)==(x|0)){Ma=Ka;Na=La;break}else{D=Ka;ma=La}}}else{ma=1;D=0;aa=1;while(1){ta=+p[sa+(D<<3)>>3];ua=+p[ga+(D<<3)>>3];va=ta<ua?ta:ua;Fa=ua<ta?ta:ua;z=~~va;ka=(+(z|0)<va&1)+z|0;z=la+(D<<3)|0;K=z+4|0;f[K>>2]=ka;na=~~Fa;da=na-(+(na|0)>Fa&1)-ka|0;ka=da+-1|0;f[z>>2]=ka;ua=Fa-va;na=(ka&da|0)==0;if(ma<<24>>24!=0&ua<=4294967296.0){ka=na&1;if(na){Oa=ka;Pa=(aa&1)!=0&(da|0)<257&1}else{Qa=ka;E=101}}else{Qa=0;E=101}do if((E|0)==101){E=0;if(ua>2147483647.0)f[z>>2]=2147483647;if(!(va<-1073741824.0)){Oa=Qa;Pa=aa;break}f[K>>2]=-1073741824;Oa=Qa;Pa=aa}while(0);D=D+1|0;if((D|0)==(x|0)){Ma=Oa;Na=Pa;break}else{ma=Oa;aa=Pa}}}if(!(Ma<<24>>24)){aa=la+(x<<3)|0;ma=0;do{D=la+(ma<<3)|0;f[aa+(ma*20|0)+16>>2]=f[D+4>>2];K=(f[D>>2]|0)+1|0;f[aa+(ma*20|0)>>2]=K;D=0;while(1){Ra=R1a(1,0,D|0)|0;Sa=J;if(Sa>>>0<0|(Sa|0)==0&Ra>>>0<K>>>0)D=D+1|0;else break}z=B1a(Ra|0,Sa|0,K|0,0)|0;ka=U1a(0,z|0,K|0,0)|0;f[aa+(ma*20|0)+4>>2]=ka+1;f[aa+(ma*20|0)+8>>2]=(D|0)<1?D:1;ka=D+-1|0;f[aa+(ma*20|0)+12>>2]=(ka|0)>0?ka:0;ma=ma+1|0}while((ma|0)!=(x|0));Ta=aa}else Ta=0;ya=Ma&255;za=0;Aa=Ta;Ba=Ma;Ca=0;Da=la;Ea=Na}while(0);_=f[42724+(ya<<5)+(e<<2)>>2]|0;if(!_){f[j>>2]=0;f[j+4>>2]=0;L=c$(j,9)|0;M=323538;N=L+9|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));j$(-215,j,187737,187742,633);d$(j)}O=za;P=Aa;Q=(Ba&1)!=0;R=Ca;S=_;T=Da;U=0;V=0;W=(Ea&1)!=0;X=0;Z=0}while(0);f[j>>2]=k;f[j+4>>2]=0;bU(v,j,q,1);j=f[v+20>>2]|0;Ea=((c|1024)>>>0)/(x>>>0)|0;c=(j|0)<(Ea|0)?j:Ea;Ea=k+4|0;Da=f[Ea>>2]|0;if((Da|0)>0)Ua=f[(f[k+44>>2]|0)+(Da+-1<<2)>>2]|0;else Ua=0;Da=w+8|0;f[w>>2]=Da;Ca=w+4|0;f[Ca>>2]=136;Ba=Y(c,x)|0;do if(A){Aa=Ba<<2;f[Ca>>2]=Aa;if(Aa>>>0>136){za=OYa(Aa>>>0>536870911?-1:Aa<<3)|0;f[w>>2]=za;Va=za}else Va=Da;if(e>>>0<5)if(Q){if((Ba|0)>0)Wa=0;else{Xa=0;Ya=Va;break}do{za=0;do{Aa=T+(za<<3)|0;M=Va+(za+Wa<<3)|0;f[s>>2]=f[Aa>>2];f[s+4>>2]=f[Aa+4>>2];p[s>>3]=+p[s>>3];f[M>>2]=f[s>>2];f[M+4>>2]=f[s+4>>2];za=za+1|0}while((za|0)!=(x|0));Wa=Wa+x|0}while((Wa|0)<(Ba|0));Xa=0;Ya=Va}else{if((Ba|0)>0)Za=0;else{Xa=0;Ya=Va;break}do{_=0;do{za=P+(_*20|0)|0;la=Va+((_+Za|0)*20|0)|0;f[la>>2]=f[za>>2];f[la+4>>2]=f[za+4>>2];f[la+8>>2]=f[za+8>>2];f[la+12>>2]=f[za+12>>2];f[la+16>>2]=f[za+16>>2];_=_+1|0}while((_|0)!=(x|0));Za=Za+x|0}while((Za|0)<(Ba|0));Xa=0;Ya=Va}else if((e|0)==5){if((Ba|0)>0)_a=0;else{Xa=0;Ya=Va;break}do{_=0;do{za=R+(_<<3)|0;la=Va+(_+_a<<3)|0;f[s>>2]=f[za>>2];f[s+4>>2]=f[za+4>>2];p[s>>3]=+p[s>>3];f[la>>2]=f[s>>2];f[la+4>>2]=f[s+4>>2];_=_+1|0}while((_|0)!=(x|0));_a=_a+x|0}while((_a|0)<(Ba|0));Xa=0;Ya=Va}else{if((Ba|0)>0)$a=0;else{Xa=0;Ya=Va;break}do{_=0;do{la=O+(_<<4)|0;za=Va+(_+$a<<4)|0;f[za>>2]=f[la>>2];f[za+4>>2]=f[la+4>>2];f[za+8>>2]=f[la+8>>2];f[za+12>>2]=f[la+12>>2];_=_+1|0}while((_|0)!=(x|0));$a=$a+x|0}while(($a|0)<(Ba|0));Xa=0;Ya=Va}}else{_=(Ba+1|0)/2|0;f[Ca>>2]=_;if(_>>>0>136){la=OYa(_>>>0>536870911?-1:_<<3)|0;f[w>>2]=la;Xa=la;Ya=0}else{Xa=Da;Ya=0}}while(0);Ba=v+16|0;b:do if((j|0)>0){Va=0;while(1){if(Va>>>0>=(f[Ba>>2]|0)>>>0)break b;if(A){$a=f[q>>2]|0;O=0;do{_a=j-O|0;R=(c|0)<(_a|0)?c:_a;_a=Y(R,x)|0;Bh[S&255]($a,_a,a,Ya,W);_a=Y(R,Ua)|0;$a=(f[q>>2]|0)+_a|0;f[q>>2]=$a;O=O+c|0}while((j|0)>(O|0))}else{O=0;do{$a=j-O|0;_a=(c|0)<($a|0)?c:$a;sY(Xa,Y(_a,x)|0,a);Xh[V&127](Xa,f[q>>2]|0,_a,x,U,X,Z);$a=Y(_a,Ua)|0;f[q>>2]=(f[q>>2]|0)+$a;O=O+c|0}while((j|0)>(O|0))}tR(v)|0;Va=Va+1|0}}else{Va=0;while(1){if(Va>>>0>=(f[Ba>>2]|0)>>>0)break b;tR(v)|0;Va=Va+1|0}}while(0);v=f[w>>2]|0;if((v|0)!=(Da|0)){if(v|0)QYa(v);f[w>>2]=Da;f[Ca>>2]=136}Ca=f[o>>2]|0;if((Ca|0)!=(y|0)){if(Ca|0)QYa(Ca);f[o>>2]=y;f[C>>2]=136}C=m+36|0;y=f[C>>2]|0;if(y|0?(o=y+12|0,y=f[o>>2]|0,f[o>>2]=y+-1,(y|0)==1):0)CR(m);f[C>>2]=0;C=m+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[B>>2]|0)>0){C=f[m+40>>2]|0;y=0;do{f[C+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[B>>2]|0))}B=f[m+44>>2]|0;if((B|0)!=(m+48|0))ZF(B);B=l+36|0;m=f[B>>2]|0;if(m|0?(y=m+12|0,m=f[y>>2]|0,f[y>>2]=m+-1,(m|0)==1):0)CR(l);f[B>>2]=0;B=l+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[G>>2]|0)>0){B=f[l+40>>2]|0;m=0;do{f[B+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[G>>2]|0))}G=f[l+44>>2]|0;if((G|0)!=(l+48|0))ZF(G);G=k+36|0;l=f[G>>2]|0;do if(l|0){m=l+12|0;B=f[m>>2]|0;f[m>>2]=B+-1;if((B|0)!=1)break;CR(k)}while(0);f[G>>2]=0;G=k+16|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[Ea>>2]|0)>0){G=f[k+40>>2]|0;l=0;do{f[G+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[Ea>>2]|0))}Ea=f[k+44>>2]|0;if((Ea|0)==(k+48|0)){u=i;return}ZF(Ea);u=i;return}function uY(a,c,d,e,f,g,h){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0;if(h){if((d|0)>0&(e|0)>0){i=c;j=0;k=a}else return;while(1){h=0;do{l=Y(h,e)|0;m=0;o=+n[f+(h<<2)>>2];do{o=o+ +n[k+(m<<2)>>2]*+n[g+(m+l<<2)>>2];m=m+1|0}while((m|0)!=(e|0));m=wNa(o)|0;b[i+h>>0]=m>>>0<256?m:(m|0)>0?255:0;h=h+1|0}while((h|0)!=(e|0));j=j+1|0;if((j|0)==(d|0))break;else{i=i+e|0;k=k+(e<<2)|0}}return}if((e|0)==1){p=+n[f>>2];q=+n[g>>2];if((d|0)>0)r=0;else return;do{k=wNa(p+q*+n[a+(r<<2)>>2])|0;b[c+r>>0]=k>>>0<256?k:(k|0)>0?255:0;r=r+1|0}while((r|0)!=(d|0));return}if((d|0)>0&(e|0)>0){s=c;t=0;u=a}else return;while(1){a=0;do{c=wNa(+n[u+(a<<2)>>2]*+n[g+(a<<2)>>2]+ +n[f+(a<<2)>>2])|0;b[s+a>>0]=c>>>0<256?c:(c|0)>0?255:0;a=a+1|0}while((a|0)!=(e|0));t=t+1|0;if((t|0)==(d|0))break;else{s=s+e|0;u=u+(e<<2)|0}}return}function vY(a,c,d,e,f,g,h){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0;if(h){if((d|0)>0&(e|0)>0){i=c;j=0;k=a}else return;while(1){h=0;do{l=Y(h,e)|0;m=0;o=+n[f+(h<<2)>>2];do{o=o+ +n[k+(m<<2)>>2]*+n[g+(m+l<<2)>>2];m=m+1|0}while((m|0)!=(e|0));m=wNa(o)|0;b[i+h>>0]=(m+128|0)>>>0<256?m:(m|0)>0?127:128;h=h+1|0}while((h|0)!=(e|0));j=j+1|0;if((j|0)==(d|0))break;else{i=i+e|0;k=k+(e<<2)|0}}return}if((e|0)==1){p=+n[f>>2];q=+n[g>>2];if((d|0)>0)r=0;else return;do{k=wNa(p+q*+n[a+(r<<2)>>2])|0;b[c+r>>0]=(k+128|0)>>>0<256?k:(k|0)>0?127:128;r=r+1|0}while((r|0)!=(d|0));return}if((d|0)>0&(e|0)>0){s=c;t=0;u=a}else return;while(1){a=0;do{c=wNa(+n[u+(a<<2)>>2]*+n[g+(a<<2)>>2]+ +n[f+(a<<2)>>2])|0;b[s+a>>0]=(c+128|0)>>>0<256?c:(c|0)>0?127:128;a=a+1|0}while((a|0)!=(e|0));t=t+1|0;if((t|0)==(d|0))break;else{s=s+e|0;u=u+(e<<2)|0}}return}function wY(a,b,c,e,f,g,h){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0;if(h){if((c|0)>0&(e|0)>0){i=b;j=0;k=a}else return;while(1){h=0;do{l=Y(h,e)|0;m=0;o=+n[f+(h<<2)>>2];do{o=o+ +n[k+(m<<2)>>2]*+n[g+(m+l<<2)>>2];m=m+1|0}while((m|0)!=(e|0));m=wNa(o)|0;d[i+(h<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;h=h+1|0}while((h|0)!=(e|0));j=j+1|0;if((j|0)==(c|0))break;else{i=i+(e<<1)|0;k=k+(e<<2)|0}}return}if((e|0)==1){p=+n[f>>2];q=+n[g>>2];if((c|0)>0)r=0;else return;do{k=wNa(p+q*+n[a+(r<<2)>>2])|0;d[b+(r<<1)>>1]=k>>>0<65536?k:(k|0)>0?65535:0;r=r+1|0}while((r|0)!=(c|0));return}if((c|0)>0&(e|0)>0){s=b;t=0;u=a}else return;while(1){a=0;do{b=wNa(+n[u+(a<<2)>>2]*+n[g+(a<<2)>>2]+ +n[f+(a<<2)>>2])|0;d[s+(a<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;a=a+1|0}while((a|0)!=(e|0));t=t+1|0;if((t|0)==(c|0))break;else{s=s+(e<<1)|0;u=u+(e<<2)|0}}return}function xY(a,b,c,e,f,g,h){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0;if(h){if((c|0)>0&(e|0)>0){i=b;j=0;k=a}else return;while(1){h=0;do{l=Y(h,e)|0;m=0;o=+n[f+(h<<2)>>2];do{o=o+ +n[k+(m<<2)>>2]*+n[g+(m+l<<2)>>2];m=m+1|0}while((m|0)!=(e|0));m=wNa(o)|0;d[i+(h<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;h=h+1|0}while((h|0)!=(e|0));j=j+1|0;if((j|0)==(c|0))break;else{i=i+(e<<1)|0;k=k+(e<<2)|0}}return}if((e|0)==1){p=+n[f>>2];q=+n[g>>2];if((c|0)>0)r=0;else return;do{k=wNa(p+q*+n[a+(r<<2)>>2])|0;d[b+(r<<1)>>1]=(k+32768|0)>>>0<65536?k:(k|0)>0?32767:32768;r=r+1|0}while((r|0)!=(c|0));return}if((c|0)>0&(e|0)>0){s=b;t=0;u=a}else return;while(1){a=0;do{b=wNa(+n[u+(a<<2)>>2]*+n[g+(a<<2)>>2]+ +n[f+(a<<2)>>2])|0;d[s+(a<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;a=a+1|0}while((a|0)!=(e|0));t=t+1|0;if((t|0)==(c|0))break;else{s=s+(e<<1)|0;u=u+(e<<2)|0}}return}function yY(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0;if(h){if((c|0)>0&(d|0)>0){i=b;j=0;k=a}else return;while(1){h=0;do{l=Y(h,d)|0;m=0;o=+n[e+(h<<2)>>2];do{o=o+ +n[k+(m<<2)>>2]*+n[g+(m+l<<2)>>2];m=m+1|0}while((m|0)!=(d|0));m=wNa(o)|0;f[i+(h<<2)>>2]=m;h=h+1|0}while((h|0)!=(d|0));j=j+1|0;if((j|0)==(c|0))break;else{i=i+(d<<2)|0;k=k+(d<<2)|0}}return}if((d|0)==1){p=+n[e>>2];q=+n[g>>2];if((c|0)>0)r=0;else return;do{k=wNa(p+q*+n[a+(r<<2)>>2])|0;f[b+(r<<2)>>2]=k;r=r+1|0}while((r|0)!=(c|0));return}if((c|0)>0&(d|0)>0){s=b;t=0;u=a}else return;while(1){a=0;do{b=wNa(+n[u+(a<<2)>>2]*+n[g+(a<<2)>>2]+ +n[e+(a<<2)>>2])|0;f[s+(a<<2)>>2]=b;a=a+1|0}while((a|0)!=(d|0));t=t+1|0;if((t|0)==(c|0))break;else{s=s+(d<<2)|0;u=u+(d<<2)|0}}return}function zY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,p=0.0,q=0,r=0,s=0,t=0;if(g){if((c|0)>0&(d|0)>0){h=b;i=0;j=a}else return;while(1){g=0;do{k=Y(g,d)|0;l=0;m=+n[e+(g<<2)>>2];do{m=m+ +n[j+(l<<2)>>2]*+n[f+(l+k<<2)>>2];l=l+1|0}while((l|0)!=(d|0));n[h+(g<<2)>>2]=m;g=g+1|0}while((g|0)!=(d|0));i=i+1|0;if((i|0)==(c|0))break;else{h=h+(d<<2)|0;j=j+(d<<2)|0}}return}if((d|0)==1){o=+n[e>>2];p=+n[f>>2];if((c|0)>0)q=0;else return;do{n[b+(q<<2)>>2]=o+p*+n[a+(q<<2)>>2];q=q+1|0}while((q|0)!=(c|0));return}if((c|0)>0&(d|0)>0){r=b;s=0;t=a}else return;while(1){a=0;do{n[r+(a<<2)>>2]=+n[t+(a<<2)>>2]*+n[f+(a<<2)>>2]+ +n[e+(a<<2)>>2];a=a+1|0}while((a|0)!=(d|0));s=s+1|0;if((s|0)==(c|0))break;else{r=r+(d<<2)|0;t=t+(d<<2)|0}}return}function AY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,q=0.0,r=0,s=0,t=0,u=0;if(g){if((c|0)>0&(d|0)>0){h=b;i=0;j=a}else return;while(1){g=0;do{k=Y(g,d)|0;l=0;m=+p[e+(g<<3)>>3];do{m=m+ +n[j+(l<<2)>>2]*+p[f+(l+k<<3)>>3];l=l+1|0}while((l|0)!=(d|0));p[h+(g<<3)>>3]=m;g=g+1|0}while((g|0)!=(d|0));i=i+1|0;if((i|0)==(c|0))break;else{h=h+(d<<3)|0;j=j+(d<<2)|0}}return}if((d|0)==1){o=+p[e>>3];q=+p[f>>3];if((c|0)>0)r=0;else return;do{p[b+(r<<3)>>3]=o+q*+n[a+(r<<2)>>2];r=r+1|0}while((r|0)!=(c|0));return}if((c|0)>0&(d|0)>0){s=b;t=0;u=a}else return;while(1){a=0;do{p[s+(a<<3)>>3]=+n[u+(a<<2)>>2]*+p[f+(a<<3)>>3]+ +p[e+(a<<3)>>3];a=a+1|0}while((a|0)!=(d|0));t=t+1|0;if((t|0)==(c|0))break;else{s=s+(d<<3)|0;u=u+(d<<2)|0}}return}function BY(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=d;h=f[g>>2]|0;i=f[g+4>>2]|0;g=c+-4|0;if((c|0)<4){j=h;k=i;l=0}else{m=i;i=h;h=0;do{n=W1a(i|0,0,-130063606,0)|0;o=C1a(n|0,J|0,m|0,0)|0;n=J;p=W1a(o|0,0,-130063606,0)|0;q=C1a(p|0,J|0,n|0,0)|0;n=J;W1a(o|0,0,f[e+(h*20|0)+4>>2]|0,0)|0;p=J;r=h|1;W1a(q|0,0,f[e+(r*20|0)+4>>2]|0,0)|0;s=J;t=o-(Y((((o-p|0)>>>(f[e+(h*20|0)+8>>2]|0))+p|0)>>>(f[e+(h*20|0)+12>>2]|0),f[e+(h*20|0)>>2]|0)|0)|0;p=t+(f[e+(h*20|0)+16>>2]|0)|0;t=q-(Y((((q-s|0)>>>(f[e+(r*20|0)+8>>2]|0))+s|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;s=t+(f[e+(r*20|0)+16>>2]|0)|0;b[a+h>>0]=p>>>0<256?p:(p|0)>0?255:0;b[a+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=W1a(q|0,0,-130063606,0)|0;q=C1a(s|0,J|0,n|0,0)|0;n=J;s=W1a(q|0,0,-130063606,0)|0;i=C1a(s|0,J|0,n|0,0)|0;m=J;n=h|2;W1a(f[e+(n*20|0)+4>>2]|0,0,q|0,0)|0;s=J;r=h|3;W1a(f[e+(r*20|0)+4>>2]|0,0,i|0,0)|0;p=J;t=q-(Y((((q-s|0)>>>(f[e+(n*20|0)+8>>2]|0))+s|0)>>>(f[e+(n*20|0)+12>>2]|0),f[e+(n*20|0)>>2]|0)|0)|0;s=t+(f[e+(n*20|0)+16>>2]|0)|0;t=i-(Y((((i-p|0)>>>(f[e+(r*20|0)+8>>2]|0))+p|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;p=t+(f[e+(r*20|0)+16>>2]|0)|0;b[a+n>>0]=s>>>0<256?s:(s|0)>0?255:0;b[a+r>>0]=p>>>0<256?p:(p|0)>0?255:0;h=h+4|0}while((h|0)<=(g|0));j=i;k=m;l=c&-4}if((l|0)<(c|0)){u=j;v=k;w=l}else{x=j;y=k;z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){k=W1a(u|0,0,-130063606,0)|0;j=C1a(k|0,J|0,v|0,0)|0;k=J;W1a(j|0,0,f[e+(w*20|0)+4>>2]|0,0)|0;l=J;m=j-(Y((((j-l|0)>>>(f[e+(w*20|0)+8>>2]|0))+l|0)>>>(f[e+(w*20|0)+12>>2]|0),f[e+(w*20|0)>>2]|0)|0)|0;l=m+(f[e+(w*20|0)+16>>2]|0)|0;b[a+w>>0]=l>>>0<256?l:(l|0)>0?255:0;w=w+1|0;if((w|0)==(c|0)){x=j;y=k;break}else{u=j;v=k}}z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function CY(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=d;h=f[g>>2]|0;i=f[g+4>>2]|0;g=c+-4|0;if((c|0)<4){j=h;k=i;l=0}else{m=i;i=h;h=0;do{n=W1a(i|0,0,-130063606,0)|0;o=C1a(n|0,J|0,m|0,0)|0;n=J;p=W1a(o|0,0,-130063606,0)|0;q=C1a(p|0,J|0,n|0,0)|0;n=J;W1a(o|0,0,f[e+(h*20|0)+4>>2]|0,0)|0;p=J;r=h|1;W1a(q|0,0,f[e+(r*20|0)+4>>2]|0,0)|0;s=J;t=o-(Y((((o-p|0)>>>(f[e+(h*20|0)+8>>2]|0))+p|0)>>>(f[e+(h*20|0)+12>>2]|0),f[e+(h*20|0)>>2]|0)|0)|0;p=t+(f[e+(h*20|0)+16>>2]|0)|0;t=q-(Y((((q-s|0)>>>(f[e+(r*20|0)+8>>2]|0))+s|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;s=t+(f[e+(r*20|0)+16>>2]|0)|0;b[a+h>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;b[a+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;s=W1a(q|0,0,-130063606,0)|0;q=C1a(s|0,J|0,n|0,0)|0;n=J;s=W1a(q|0,0,-130063606,0)|0;i=C1a(s|0,J|0,n|0,0)|0;m=J;n=h|2;W1a(f[e+(n*20|0)+4>>2]|0,0,q|0,0)|0;s=J;r=h|3;W1a(f[e+(r*20|0)+4>>2]|0,0,i|0,0)|0;p=J;t=q-(Y((((q-s|0)>>>(f[e+(n*20|0)+8>>2]|0))+s|0)>>>(f[e+(n*20|0)+12>>2]|0),f[e+(n*20|0)>>2]|0)|0)|0;s=t+(f[e+(n*20|0)+16>>2]|0)|0;t=i-(Y((((i-p|0)>>>(f[e+(r*20|0)+8>>2]|0))+p|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;p=t+(f[e+(r*20|0)+16>>2]|0)|0;b[a+n>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;b[a+r>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;h=h+4|0}while((h|0)<=(g|0));j=i;k=m;l=c&-4}if((l|0)<(c|0)){u=j;v=k;w=l}else{x=j;y=k;z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){k=W1a(u|0,0,-130063606,0)|0;j=C1a(k|0,J|0,v|0,0)|0;k=J;W1a(j|0,0,f[e+(w*20|0)+4>>2]|0,0)|0;l=J;m=j-(Y((((j-l|0)>>>(f[e+(w*20|0)+8>>2]|0))+l|0)>>>(f[e+(w*20|0)+12>>2]|0),f[e+(w*20|0)>>2]|0)|0)|0;l=m+(f[e+(w*20|0)+16>>2]|0)|0;b[a+w>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;w=w+1|0;if((w|0)==(c|0)){x=j;y=k;break}else{u=j;v=k}}z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function DY(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=c;h=f[g>>2]|0;i=f[g+4>>2]|0;g=b+-4|0;if((b|0)<4){j=h;k=i;l=0}else{m=i;i=h;h=0;do{n=W1a(i|0,0,-130063606,0)|0;o=C1a(n|0,J|0,m|0,0)|0;n=J;p=W1a(o|0,0,-130063606,0)|0;q=C1a(p|0,J|0,n|0,0)|0;n=J;W1a(o|0,0,f[e+(h*20|0)+4>>2]|0,0)|0;p=J;r=h|1;W1a(q|0,0,f[e+(r*20|0)+4>>2]|0,0)|0;s=J;t=o-(Y((((o-p|0)>>>(f[e+(h*20|0)+8>>2]|0))+p|0)>>>(f[e+(h*20|0)+12>>2]|0),f[e+(h*20|0)>>2]|0)|0)|0;p=t+(f[e+(h*20|0)+16>>2]|0)|0;t=q-(Y((((q-s|0)>>>(f[e+(r*20|0)+8>>2]|0))+s|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;s=t+(f[e+(r*20|0)+16>>2]|0)|0;d[a+(h<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;d[a+(r<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;s=W1a(q|0,0,-130063606,0)|0;q=C1a(s|0,J|0,n|0,0)|0;n=J;s=W1a(q|0,0,-130063606,0)|0;i=C1a(s|0,J|0,n|0,0)|0;m=J;n=h|2;W1a(f[e+(n*20|0)+4>>2]|0,0,q|0,0)|0;s=J;r=h|3;W1a(f[e+(r*20|0)+4>>2]|0,0,i|0,0)|0;p=J;t=q-(Y((((q-s|0)>>>(f[e+(n*20|0)+8>>2]|0))+s|0)>>>(f[e+(n*20|0)+12>>2]|0),f[e+(n*20|0)>>2]|0)|0)|0;s=t+(f[e+(n*20|0)+16>>2]|0)|0;t=i-(Y((((i-p|0)>>>(f[e+(r*20|0)+8>>2]|0))+p|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;p=t+(f[e+(r*20|0)+16>>2]|0)|0;d[a+(n<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;d[a+(r<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;h=h+4|0}while((h|0)<=(g|0));j=i;k=m;l=b&-4}if((l|0)<(b|0)){u=j;v=k;w=l}else{x=j;y=k;z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){k=W1a(u|0,0,-130063606,0)|0;j=C1a(k|0,J|0,v|0,0)|0;k=J;W1a(j|0,0,f[e+(w*20|0)+4>>2]|0,0)|0;l=J;m=j-(Y((((j-l|0)>>>(f[e+(w*20|0)+8>>2]|0))+l|0)>>>(f[e+(w*20|0)+12>>2]|0),f[e+(w*20|0)>>2]|0)|0)|0;l=m+(f[e+(w*20|0)+16>>2]|0)|0;d[a+(w<<1)>>1]=l>>>0<65536?l:(l|0)>0?65535:0;w=w+1|0;if((w|0)==(b|0)){x=j;y=k;break}else{u=j;v=k}}z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function EY(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=c;h=f[g>>2]|0;i=f[g+4>>2]|0;g=b+-4|0;if((b|0)<4){j=h;k=i;l=0}else{m=i;i=h;h=0;do{n=W1a(i|0,0,-130063606,0)|0;o=C1a(n|0,J|0,m|0,0)|0;n=J;p=W1a(o|0,0,-130063606,0)|0;q=C1a(p|0,J|0,n|0,0)|0;n=J;W1a(o|0,0,f[e+(h*20|0)+4>>2]|0,0)|0;p=J;r=h|1;W1a(q|0,0,f[e+(r*20|0)+4>>2]|0,0)|0;s=J;t=o-(Y((((o-p|0)>>>(f[e+(h*20|0)+8>>2]|0))+p|0)>>>(f[e+(h*20|0)+12>>2]|0),f[e+(h*20|0)>>2]|0)|0)|0;p=t+(f[e+(h*20|0)+16>>2]|0)|0;t=q-(Y((((q-s|0)>>>(f[e+(r*20|0)+8>>2]|0))+s|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;s=t+(f[e+(r*20|0)+16>>2]|0)|0;d[a+(h<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[a+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;s=W1a(q|0,0,-130063606,0)|0;q=C1a(s|0,J|0,n|0,0)|0;n=J;s=W1a(q|0,0,-130063606,0)|0;i=C1a(s|0,J|0,n|0,0)|0;m=J;n=h|2;W1a(f[e+(n*20|0)+4>>2]|0,0,q|0,0)|0;s=J;r=h|3;W1a(f[e+(r*20|0)+4>>2]|0,0,i|0,0)|0;p=J;t=q-(Y((((q-s|0)>>>(f[e+(n*20|0)+8>>2]|0))+s|0)>>>(f[e+(n*20|0)+12>>2]|0),f[e+(n*20|0)>>2]|0)|0)|0;s=t+(f[e+(n*20|0)+16>>2]|0)|0;t=i-(Y((((i-p|0)>>>(f[e+(r*20|0)+8>>2]|0))+p|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;p=t+(f[e+(r*20|0)+16>>2]|0)|0;d[a+(n<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;d[a+(r<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;h=h+4|0}while((h|0)<=(g|0));j=i;k=m;l=b&-4}if((l|0)<(b|0)){u=j;v=k;w=l}else{x=j;y=k;z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){k=W1a(u|0,0,-130063606,0)|0;j=C1a(k|0,J|0,v|0,0)|0;k=J;W1a(j|0,0,f[e+(w*20|0)+4>>2]|0,0)|0;l=J;m=j-(Y((((j-l|0)>>>(f[e+(w*20|0)+8>>2]|0))+l|0)>>>(f[e+(w*20|0)+12>>2]|0),f[e+(w*20|0)>>2]|0)|0)|0;l=m+(f[e+(w*20|0)+16>>2]|0)|0;d[a+(w<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;w=w+1|0;if((w|0)==(b|0)){x=j;y=k;break}else{u=j;v=k}}z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function FY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=c;g=f[e>>2]|0;h=f[e+4>>2]|0;e=b+-4|0;if((b|0)<4){i=g;j=h;k=0}else{l=h;h=g;g=0;do{m=W1a(h|0,0,-130063606,0)|0;n=C1a(m|0,J|0,l|0,0)|0;m=J;o=W1a(n|0,0,-130063606,0)|0;p=C1a(o|0,J|0,m|0,0)|0;m=J;W1a(n|0,0,f[d+(g*20|0)+4>>2]|0,0)|0;o=J;q=g|1;W1a(p|0,0,f[d+(q*20|0)+4>>2]|0,0)|0;r=J;s=Y((((n-o|0)>>>(f[d+(g*20|0)+8>>2]|0))+o|0)>>>(f[d+(g*20|0)+12>>2]|0),f[d+(g*20|0)>>2]|0)|0;o=Y((((p-r|0)>>>(f[d+(q*20|0)+8>>2]|0))+r|0)>>>(f[d+(q*20|0)+12>>2]|0),f[d+(q*20|0)>>2]|0)|0;r=(f[d+(q*20|0)+16>>2]|0)+p-o|0;f[a+(g<<2)>>2]=(f[d+(g*20|0)+16>>2]|0)+n-s;f[a+(q<<2)>>2]=r;r=W1a(p|0,0,-130063606,0)|0;p=C1a(r|0,J|0,m|0,0)|0;m=J;r=W1a(p|0,0,-130063606,0)|0;h=C1a(r|0,J|0,m|0,0)|0;l=J;m=g|2;W1a(f[d+(m*20|0)+4>>2]|0,0,p|0,0)|0;r=J;q=g|3;W1a(f[d+(q*20|0)+4>>2]|0,0,h|0,0)|0;s=J;n=Y((((p-r|0)>>>(f[d+(m*20|0)+8>>2]|0))+r|0)>>>(f[d+(m*20|0)+12>>2]|0),f[d+(m*20|0)>>2]|0)|0;r=Y((((h-s|0)>>>(f[d+(q*20|0)+8>>2]|0))+s|0)>>>(f[d+(q*20|0)+12>>2]|0),f[d+(q*20|0)>>2]|0)|0;s=(f[d+(q*20|0)+16>>2]|0)+h-r|0;f[a+(m<<2)>>2]=(f[d+(m*20|0)+16>>2]|0)+p-n;f[a+(q<<2)>>2]=s;g=g+4|0}while((g|0)<=(e|0));i=h;j=l;k=b&-4}if((k|0)<(b|0)){t=i;u=j;v=k}else{w=i;x=j;y=c;z=y;f[z>>2]=w;A=y+4|0;B=A;f[B>>2]=x;return}while(1){j=W1a(t|0,0,-130063606,0)|0;i=C1a(j|0,J|0,u|0,0)|0;j=J;W1a(i|0,0,f[d+(v*20|0)+4>>2]|0,0)|0;k=J;l=Y((((i-k|0)>>>(f[d+(v*20|0)+8>>2]|0))+k|0)>>>(f[d+(v*20|0)+12>>2]|0),f[d+(v*20|0)>>2]|0)|0;f[a+(v<<2)>>2]=(f[d+(v*20|0)+16>>2]|0)+i-l;v=v+1|0;if((v|0)==(b|0)){w=i;x=j;break}else{t=i;u=j}}y=c;z=y;f[z>>2]=w;A=y+4|0;B=A;f[B>>2]=x;return}function GY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=c;g=f[e>>2]|0;h=f[e+4>>2]|0;e=b+-4|0;if((b|0)<4){i=g;j=h;k=0}else{l=h;h=g;g=0;do{m=W1a(h|0,0,-130063606,0)|0;o=C1a(m|0,J|0,l|0,0)|0;m=J;p=W1a(o|0,0,-130063606,0)|0;q=C1a(p|0,J|0,m|0,0)|0;m=J;p=W1a(q|0,0,-130063606,0)|0;r=C1a(p|0,J|0,m|0,0)|0;m=J;p=W1a(r|0,0,-130063606,0)|0;h=C1a(p|0,J|0,m|0,0)|0;l=J;n[a+(g<<2)>>2]=+(o|0)*+n[d+(g<<3)>>2]+ +n[d+(g<<3)+4>>2];o=g|1;n[a+(o<<2)>>2]=+(q|0)*+n[d+(o<<3)>>2]+ +n[d+(o<<3)+4>>2];o=g|2;n[a+(o<<2)>>2]=+(r|0)*+n[d+(o<<3)>>2]+ +n[d+(o<<3)+4>>2];o=g|3;n[a+(o<<2)>>2]=+(h|0)*+n[d+(o<<3)>>2]+ +n[d+(o<<3)+4>>2];g=g+4|0}while((g|0)<=(e|0));i=h;j=l;k=b&-4}if((k|0)<(b|0)){s=i;t=j;u=k}else{v=i;w=j;x=c;y=x;f[y>>2]=v;z=x+4|0;A=z;f[A>>2]=w;return}while(1){j=W1a(s|0,0,-130063606,0)|0;i=C1a(j|0,J|0,t|0,0)|0;j=J;n[a+(u<<2)>>2]=+(i|0)*+n[d+(u<<3)>>2]+ +n[d+(u<<3)+4>>2];u=u+1|0;if((u|0)==(b|0)){v=i;w=j;break}else{s=i;t=j}}x=c;y=x;f[y>>2]=v;z=x+4|0;A=z;f[A>>2]=w;return}function HY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=c;g=f[e>>2]|0;h=f[e+4>>2]|0;e=b+-4|0;if((b|0)<4){i=g;j=h;k=0}else{l=h;h=g;g=0;do{m=W1a(h|0,0,-130063606,0)|0;n=C1a(m|0,J|0,l|0,0)|0;m=J;o=(+(m>>>0)+4294967296.0*+(n|0))*+p[d+(g<<4)>>3]+ +p[d+(g<<4)+8>>3];q=W1a(n|0,0,-130063606,0)|0;n=C1a(q|0,J|0,m|0,0)|0;m=J;q=g|1;r=(+(m>>>0)+4294967296.0*+(n|0))*+p[d+(q<<4)>>3]+ +p[d+(q<<4)+8>>3];p[a+(g<<3)>>3]=o;p[a+(q<<3)>>3]=r;q=W1a(n|0,0,-130063606,0)|0;n=C1a(q|0,J|0,m|0,0)|0;m=J;q=g|2;r=(+(m>>>0)+4294967296.0*+(n|0))*+p[d+(q<<4)>>3]+ +p[d+(q<<4)+8>>3];s=W1a(n|0,0,-130063606,0)|0;h=C1a(s|0,J|0,m|0,0)|0;l=J;m=g|3;o=(+(l>>>0)+4294967296.0*+(h|0))*+p[d+(m<<4)>>3]+ +p[d+(m<<4)+8>>3];p[a+(q<<3)>>3]=r;p[a+(m<<3)>>3]=o;g=g+4|0}while((g|0)<=(e|0));i=h;j=l;k=b&-4}if((k|0)<(b|0)){t=i;u=j;v=k}else{w=i;x=j;y=c;z=y;f[z>>2]=w;A=y+4|0;B=A;f[B>>2]=x;return}while(1){j=W1a(t|0,0,-130063606,0)|0;i=C1a(j|0,J|0,u|0,0)|0;j=J;p[a+(v<<3)>>3]=(+(j>>>0)+4294967296.0*+(i|0))*+p[d+(v<<4)>>3]+ +p[d+(v<<4)+8>>3];v=v+1|0;if((v|0)==(b|0)){w=i;x=j;break}else{t=i;u=j}}y=c;z=y;f[z>>2]=w;A=y+4|0;B=A;f[B>>2]=x;return}function IY(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=d;i=f[h>>2]|0;j=f[h+4>>2]|0;h=c+-4|0;k=(c|0)<4;if(g)if(k){l=i;m=j;n=0}else{g=i;o=j;p=0;do{q=W1a(g|0,0,-130063606,0)|0;g=C1a(q|0,J|0,o|0,0)|0;o=J;q=(g&f[e+(p<<3)>>2])+(f[e+(p<<3)+4>>2]|0)|0;r=p|1;s=(g>>8&f[e+(r<<3)>>2])+(f[e+(r<<3)+4>>2]|0)|0;b[a+p>>0]=q>>>0<256?q:(q|0)>0?255:0;b[a+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=p|2;r=(f[e+(s<<3)>>2]&g>>16)+(f[e+(s<<3)+4>>2]|0)|0;q=p|3;t=(f[e+(q<<3)>>2]&g>>24)+(f[e+(q<<3)+4>>2]|0)|0;b[a+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[a+q>>0]=t>>>0<256?t:(t|0)>0?255:0;p=p+4|0}while((p|0)<=(h|0));l=g;m=o;n=c&-4}else if(k){l=i;m=j;n=0}else{k=i;i=j;j=0;do{o=W1a(k|0,0,-130063606,0)|0;g=C1a(o|0,J|0,i|0,0)|0;o=J;p=(g&f[e+(j<<3)>>2])+(f[e+(j<<3)+4>>2]|0)|0;t=W1a(g|0,0,-130063606,0)|0;g=C1a(t|0,J|0,o|0,0)|0;o=J;t=j|1;q=(g&f[e+(t<<3)>>2])+(f[e+(t<<3)+4>>2]|0)|0;b[a+j>>0]=p>>>0<256?p:(p|0)>0?255:0;b[a+t>>0]=q>>>0<256?q:(q|0)>0?255:0;q=W1a(g|0,0,-130063606,0)|0;g=C1a(q|0,J|0,o|0,0)|0;o=J;q=j|2;t=(g&f[e+(q<<3)>>2])+(f[e+(q<<3)+4>>2]|0)|0;p=W1a(g|0,0,-130063606,0)|0;k=C1a(p|0,J|0,o|0,0)|0;i=J;o=j|3;p=(k&f[e+(o<<3)>>2])+(f[e+(o<<3)+4>>2]|0)|0;b[a+q>>0]=t>>>0<256?t:(t|0)>0?255:0;b[a+o>>0]=p>>>0<256?p:(p|0)>0?255:0;j=j+4|0}while((j|0)<=(h|0));l=k;m=i;n=c&-4}if((n|0)<(c|0)){u=l;v=m;w=n}else{x=l;y=m;z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){m=W1a(u|0,0,-130063606,0)|0;l=C1a(m|0,J|0,v|0,0)|0;m=J;n=(l&f[e+(w<<3)>>2])+(f[e+(w<<3)+4>>2]|0)|0;b[a+w>>0]=n>>>0<256?n:(n|0)>0?255:0;w=w+1|0;if((w|0)==(c|0)){x=l;y=m;break}else{u=l;v=m}}z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function JY(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=d;i=f[h>>2]|0;j=f[h+4>>2]|0;h=c+-4|0;k=(c|0)<4;if(g)if(k){l=i;m=j;n=0}else{g=i;o=j;p=0;do{q=W1a(g|0,0,-130063606,0)|0;g=C1a(q|0,J|0,o|0,0)|0;o=J;q=(g&f[e+(p<<3)>>2])+(f[e+(p<<3)+4>>2]|0)|0;r=p|1;s=(g>>8&f[e+(r<<3)>>2])+(f[e+(r<<3)+4>>2]|0)|0;b[a+p>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;b[a+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;s=p|2;r=(f[e+(s<<3)>>2]&g>>16)+(f[e+(s<<3)+4>>2]|0)|0;q=p|3;t=(f[e+(q<<3)>>2]&g>>24)+(f[e+(q<<3)+4>>2]|0)|0;b[a+s>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;b[a+q>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;p=p+4|0}while((p|0)<=(h|0));l=g;m=o;n=c&-4}else if(k){l=i;m=j;n=0}else{k=i;i=j;j=0;do{o=W1a(k|0,0,-130063606,0)|0;g=C1a(o|0,J|0,i|0,0)|0;o=J;p=(g&f[e+(j<<3)>>2])+(f[e+(j<<3)+4>>2]|0)|0;t=W1a(g|0,0,-130063606,0)|0;g=C1a(t|0,J|0,o|0,0)|0;o=J;t=j|1;q=(g&f[e+(t<<3)>>2])+(f[e+(t<<3)+4>>2]|0)|0;b[a+j>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;b[a+t>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;q=W1a(g|0,0,-130063606,0)|0;g=C1a(q|0,J|0,o|0,0)|0;o=J;q=j|2;t=(g&f[e+(q<<3)>>2])+(f[e+(q<<3)+4>>2]|0)|0;p=W1a(g|0,0,-130063606,0)|0;k=C1a(p|0,J|0,o|0,0)|0;i=J;o=j|3;p=(k&f[e+(o<<3)>>2])+(f[e+(o<<3)+4>>2]|0)|0;b[a+q>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;b[a+o>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;j=j+4|0}while((j|0)<=(h|0));l=k;m=i;n=c&-4}if((n|0)<(c|0)){u=l;v=m;w=n}else{x=l;y=m;z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){m=W1a(u|0,0,-130063606,0)|0;l=C1a(m|0,J|0,v|0,0)|0;m=J;n=(l&f[e+(w<<3)>>2])+(f[e+(w<<3)+4>>2]|0)|0;b[a+w>>0]=(n+128|0)>>>0<256?n:(n|0)>0?127:128;w=w+1|0;if((w|0)==(c|0)){x=l;y=m;break}else{u=l;v=m}}z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function KY(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=c;i=f[h>>2]|0;j=f[h+4>>2]|0;h=b+-4|0;k=(b|0)<4;if(g)if(k){l=i;m=j;n=0}else{g=i;o=j;p=0;do{q=W1a(g|0,0,-130063606,0)|0;g=C1a(q|0,J|0,o|0,0)|0;o=J;q=(g&f[e+(p<<3)>>2])+(f[e+(p<<3)+4>>2]|0)|0;r=p|1;s=(g>>8&f[e+(r<<3)>>2])+(f[e+(r<<3)+4>>2]|0)|0;d[a+(p<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;d[a+(r<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;s=p|2;r=(f[e+(s<<3)>>2]&g>>16)+(f[e+(s<<3)+4>>2]|0)|0;q=p|3;t=(f[e+(q<<3)>>2]&g>>24)+(f[e+(q<<3)+4>>2]|0)|0;d[a+(s<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;d[a+(q<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;p=p+4|0}while((p|0)<=(h|0));l=g;m=o;n=b&-4}else if(k){l=i;m=j;n=0}else{k=i;i=j;j=0;do{o=W1a(k|0,0,-130063606,0)|0;g=C1a(o|0,J|0,i|0,0)|0;o=J;p=(g&f[e+(j<<3)>>2])+(f[e+(j<<3)+4>>2]|0)|0;t=W1a(g|0,0,-130063606,0)|0;g=C1a(t|0,J|0,o|0,0)|0;o=J;t=j|1;q=(g&f[e+(t<<3)>>2])+(f[e+(t<<3)+4>>2]|0)|0;d[a+(j<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;d[a+(t<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;q=W1a(g|0,0,-130063606,0)|0;g=C1a(q|0,J|0,o|0,0)|0;o=J;q=j|2;t=(g&f[e+(q<<3)>>2])+(f[e+(q<<3)+4>>2]|0)|0;p=W1a(g|0,0,-130063606,0)|0;k=C1a(p|0,J|0,o|0,0)|0;i=J;o=j|3;p=(k&f[e+(o<<3)>>2])+(f[e+(o<<3)+4>>2]|0)|0;d[a+(q<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;d[a+(o<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;j=j+4|0}while((j|0)<=(h|0));l=k;m=i;n=b&-4}if((n|0)<(b|0)){u=l;v=m;w=n}else{x=l;y=m;z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){m=W1a(u|0,0,-130063606,0)|0;l=C1a(m|0,J|0,v|0,0)|0;m=J;n=(l&f[e+(w<<3)>>2])+(f[e+(w<<3)+4>>2]|0)|0;d[a+(w<<1)>>1]=n>>>0<65536?n:(n|0)>0?65535:0;w=w+1|0;if((w|0)==(b|0)){x=l;y=m;break}else{u=l;v=m}}z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function LY(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=c;i=f[h>>2]|0;j=f[h+4>>2]|0;h=b+-4|0;k=(b|0)<4;if(g)if(k){l=i;m=j;n=0}else{g=i;o=j;p=0;do{q=W1a(g|0,0,-130063606,0)|0;g=C1a(q|0,J|0,o|0,0)|0;o=J;q=(g&f[e+(p<<3)>>2])+(f[e+(p<<3)+4>>2]|0)|0;r=p|1;s=(g>>8&f[e+(r<<3)>>2])+(f[e+(r<<3)+4>>2]|0)|0;d[a+(p<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;d[a+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;s=p|2;r=(f[e+(s<<3)>>2]&g>>16)+(f[e+(s<<3)+4>>2]|0)|0;q=p|3;t=(f[e+(q<<3)>>2]&g>>24)+(f[e+(q<<3)+4>>2]|0)|0;d[a+(s<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;d[a+(q<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;p=p+4|0}while((p|0)<=(h|0));l=g;m=o;n=b&-4}else if(k){l=i;m=j;n=0}else{k=i;i=j;j=0;do{o=W1a(k|0,0,-130063606,0)|0;g=C1a(o|0,J|0,i|0,0)|0;o=J;p=(g&f[e+(j<<3)>>2])+(f[e+(j<<3)+4>>2]|0)|0;t=W1a(g|0,0,-130063606,0)|0;g=C1a(t|0,J|0,o|0,0)|0;o=J;t=j|1;q=(g&f[e+(t<<3)>>2])+(f[e+(t<<3)+4>>2]|0)|0;d[a+(j<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[a+(t<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;q=W1a(g|0,0,-130063606,0)|0;g=C1a(q|0,J|0,o|0,0)|0;o=J;q=j|2;t=(g&f[e+(q<<3)>>2])+(f[e+(q<<3)+4>>2]|0)|0;p=W1a(g|0,0,-130063606,0)|0;k=C1a(p|0,J|0,o|0,0)|0;i=J;o=j|3;p=(k&f[e+(o<<3)>>2])+(f[e+(o<<3)+4>>2]|0)|0;d[a+(q<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;d[a+(o<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;j=j+4|0}while((j|0)<=(h|0));l=k;m=i;n=b&-4}if((n|0)<(b|0)){u=l;v=m;w=n}else{x=l;y=m;z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){m=W1a(u|0,0,-130063606,0)|0;l=C1a(m|0,J|0,v|0,0)|0;m=J;n=(l&f[e+(w<<3)>>2])+(f[e+(w<<3)+4>>2]|0)|0;d[a+(w<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;w=w+1|0;if((w|0)==(b|0)){x=l;y=m;break}else{u=l;v=m}}z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function MY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=c;h=f[g>>2]|0;i=f[g+4>>2]|0;g=b+-4|0;j=(b|0)<4;if(e)if(j){k=h;l=i;m=0}else{e=h;n=i;o=0;do{p=W1a(e|0,0,-130063606,0)|0;e=C1a(p|0,J|0,n|0,0)|0;n=J;p=o|1;q=(e>>8&f[d+(p<<3)>>2])+(f[d+(p<<3)+4>>2]|0)|0;f[a+(o<<2)>>2]=(e&f[d+(o<<3)>>2])+(f[d+(o<<3)+4>>2]|0);f[a+(p<<2)>>2]=q;q=o|2;p=o|3;r=(f[d+(p<<3)>>2]&e>>24)+(f[d+(p<<3)+4>>2]|0)|0;f[a+(q<<2)>>2]=(f[d+(q<<3)>>2]&e>>16)+(f[d+(q<<3)+4>>2]|0);f[a+(p<<2)>>2]=r;o=o+4|0}while((o|0)<=(g|0));k=e;l=n;m=b&-4}else if(j){k=h;l=i;m=0}else{j=h;h=i;i=0;do{n=W1a(j|0,0,-130063606,0)|0;e=C1a(n|0,J|0,h|0,0)|0;n=J;o=(e&f[d+(i<<3)>>2])+(f[d+(i<<3)+4>>2]|0)|0;r=W1a(e|0,0,-130063606,0)|0;e=C1a(r|0,J|0,n|0,0)|0;n=J;r=i|1;p=(e&f[d+(r<<3)>>2])+(f[d+(r<<3)+4>>2]|0)|0;f[a+(i<<2)>>2]=o;f[a+(r<<2)>>2]=p;p=W1a(e|0,0,-130063606,0)|0;e=C1a(p|0,J|0,n|0,0)|0;n=J;p=i|2;r=(e&f[d+(p<<3)>>2])+(f[d+(p<<3)+4>>2]|0)|0;o=W1a(e|0,0,-130063606,0)|0;j=C1a(o|0,J|0,n|0,0)|0;h=J;n=i|3;o=(j&f[d+(n<<3)>>2])+(f[d+(n<<3)+4>>2]|0)|0;f[a+(p<<2)>>2]=r;f[a+(n<<2)>>2]=o;i=i+4|0}while((i|0)<=(g|0));k=j;l=h;m=b&-4}if((m|0)<(b|0)){s=k;t=l;u=m}else{v=k;w=l;x=c;y=x;f[y>>2]=v;z=x+4|0;A=z;f[A>>2]=w;return}while(1){l=W1a(s|0,0,-130063606,0)|0;k=C1a(l|0,J|0,t|0,0)|0;l=J;f[a+(u<<2)>>2]=(k&f[d+(u<<3)>>2])+(f[d+(u<<3)+4>>2]|0);u=u+1|0;if((u|0)==(b|0)){v=k;w=l;break}else{s=k;t=l}}x=c;y=x;f[y>>2]=v;z=x+4|0;A=z;f[A>>2]=w;return}function NY(){return y$(x$()|0)|0}function OY(a){a=a|0;var b=0,c=0;b=(a|0)!=0;c=y$(x$()|0)|0;f[c>>2]=b?a:-1;f[c+4>>2]=b?((a|0)<0)<<31>>31:0;return}function PY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_$(e,42820);tY(y$(x$()|0)|0,a,0,b,c,0);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function QY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_$(e,42840);tY(y$(x$()|0)|0,a,1,b,c,0);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function RY(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=(e|0)%4|0;h=(g|0)==0?4:g;g=f[c>>2]|0;a:do if((h|0)==1){if((e|0)==1){K1a(g|0,a|0,d|0)|0;i=1;break}if((d|0)>0){j=0;k=0;while(1){b[g+j>>0]=b[a+k>>0]|0;j=j+1|0;if((j|0)==(d|0)){i=1;break}else k=k+e|0}}else return}else{k=f[c+4>>2]|0;if((h|0)==2)if((d|0)>0){j=0;l=0;while(1){b[g+j>>0]=b[a+l>>0]|0;b[k+j>>0]=b[a+(l+1)>>0]|0;j=j+1|0;if((j|0)==(d|0)){i=2;break a}else l=l+e|0}}else return;l=f[c+8>>2]|0;if((h|0)==3)if((d|0)>0){j=0;m=0;while(1){b[g+j>>0]=b[a+m>>0]|0;b[k+j>>0]=b[a+(m+1)>>0]|0;b[l+j>>0]=b[a+(m+2)>>0]|0;j=j+1|0;if((j|0)==(d|0)){i=3;break}else m=m+e|0}}else return;else{m=f[c+12>>2]|0;if((d|0)>0){j=0;n=0;while(1){b[g+j>>0]=b[a+n>>0]|0;b[k+j>>0]=b[a+(n+1)>>0]|0;b[l+j>>0]=b[a+(n+2)>>0]|0;b[m+j>>0]=b[a+(n+3)>>0]|0;j=j+1|0;if((j|0)==(d|0)){i=h;break}else n=n+e|0}}else return}}while(0);if((d|0)>0&(i|0)<(e|0))o=i;else return;do{i=f[c+(o<<2)>>2]|0;h=f[c+(o+1<<2)>>2]|0;g=f[c+(o+2<<2)>>2]|0;n=f[c+(o+3<<2)>>2]|0;j=0;m=o;while(1){b[i+j>>0]=b[a+m>>0]|0;b[h+j>>0]=b[a+(m+1)>>0]|0;b[g+j>>0]=b[a+(m+2)>>0]|0;b[n+j>>0]=b[a+(m+3)>>0]|0;j=j+1|0;if((j|0)==(d|0))break;else m=m+e|0}o=o+4|0}while((o|0)<(e|0));return}function SY(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=(e|0)%4|0;h=(g|0)==0?4:g;g=f[b>>2]|0;a:do if((h|0)==1){if((e|0)==1){K1a(g|0,a|0,c<<1|0)|0;i=1;break}if((c|0)>0){j=0;k=0;while(1){d[g+(j<<1)>>1]=d[a+(k<<1)>>1]|0;j=j+1|0;if((j|0)==(c|0)){i=1;break}else k=k+e|0}}else return}else{k=f[b+4>>2]|0;if((h|0)==2)if((c|0)>0){j=0;l=0;while(1){d[g+(j<<1)>>1]=d[a+(l<<1)>>1]|0;d[k+(j<<1)>>1]=d[a+(l+1<<1)>>1]|0;j=j+1|0;if((j|0)==(c|0)){i=2;break a}else l=l+e|0}}else return;l=f[b+8>>2]|0;if((h|0)==3)if((c|0)>0){j=0;m=0;while(1){d[g+(j<<1)>>1]=d[a+(m<<1)>>1]|0;d[k+(j<<1)>>1]=d[a+(m+1<<1)>>1]|0;d[l+(j<<1)>>1]=d[a+(m+2<<1)>>1]|0;j=j+1|0;if((j|0)==(c|0)){i=3;break}else m=m+e|0}}else return;else{m=f[b+12>>2]|0;if((c|0)>0){j=0;n=0;while(1){d[g+(j<<1)>>1]=d[a+(n<<1)>>1]|0;d[k+(j<<1)>>1]=d[a+(n+1<<1)>>1]|0;d[l+(j<<1)>>1]=d[a+(n+2<<1)>>1]|0;d[m+(j<<1)>>1]=d[a+(n+3<<1)>>1]|0;j=j+1|0;if((j|0)==(c|0)){i=h;break}else n=n+e|0}}else return}}while(0);if((c|0)>0&(i|0)<(e|0))o=i;else return;do{i=f[b+(o<<2)>>2]|0;h=f[b+(o+1<<2)>>2]|0;g=f[b+(o+2<<2)>>2]|0;n=f[b+(o+3<<2)>>2]|0;j=0;m=o;while(1){d[i+(j<<1)>>1]=d[a+(m<<1)>>1]|0;d[h+(j<<1)>>1]=d[a+(m+1<<1)>>1]|0;d[g+(j<<1)>>1]=d[a+(m+2<<1)>>1]|0;d[n+(j<<1)>>1]=d[a+(m+3<<1)>>1]|0;j=j+1|0;if((j|0)==(c|0))break;else m=m+e|0}o=o+4|0}while((o|0)<(e|0));return}function TY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=(d|0)%4|0;g=(e|0)==0?4:e;e=f[b>>2]|0;a:do if((g|0)==1){if((d|0)==1){K1a(e|0,a|0,c<<2|0)|0;h=1;break}if((c|0)>0){i=0;j=0;while(1){f[e+(i<<2)>>2]=f[a+(j<<2)>>2];i=i+1|0;if((i|0)==(c|0)){h=1;break}else j=j+d|0}}else return}else{j=f[b+4>>2]|0;if((g|0)==2)if((c|0)>0){i=0;k=0;while(1){f[e+(i<<2)>>2]=f[a+(k<<2)>>2];f[j+(i<<2)>>2]=f[a+(k+1<<2)>>2];i=i+1|0;if((i|0)==(c|0)){h=2;break a}else k=k+d|0}}else return;k=f[b+8>>2]|0;if((g|0)==3)if((c|0)>0){i=0;l=0;while(1){f[e+(i<<2)>>2]=f[a+(l<<2)>>2];f[j+(i<<2)>>2]=f[a+(l+1<<2)>>2];f[k+(i<<2)>>2]=f[a+(l+2<<2)>>2];i=i+1|0;if((i|0)==(c|0)){h=3;break}else l=l+d|0}}else return;else{l=f[b+12>>2]|0;if((c|0)>0){i=0;m=0;while(1){f[e+(i<<2)>>2]=f[a+(m<<2)>>2];f[j+(i<<2)>>2]=f[a+(m+1<<2)>>2];f[k+(i<<2)>>2]=f[a+(m+2<<2)>>2];f[l+(i<<2)>>2]=f[a+(m+3<<2)>>2];i=i+1|0;if((i|0)==(c|0)){h=g;break}else m=m+d|0}}else return}}while(0);if((c|0)>0&(h|0)<(d|0))n=h;else return;do{h=f[b+(n<<2)>>2]|0;g=f[b+(n+1<<2)>>2]|0;e=f[b+(n+2<<2)>>2]|0;m=f[b+(n+3<<2)>>2]|0;i=0;l=n;while(1){f[h+(i<<2)>>2]=f[a+(l<<2)>>2];f[g+(i<<2)>>2]=f[a+(l+1<<2)>>2];f[e+(i<<2)>>2]=f[a+(l+2<<2)>>2];f[m+(i<<2)>>2]=f[a+(l+3<<2)>>2];i=i+1|0;if((i|0)==(c|0))break;else l=l+d|0}n=n+4|0}while((n|0)<(d|0));return}function UY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=(d|0)%4|0;g=(e|0)==0?4:e;e=f[b>>2]|0;a:do if((g|0)==1){if((d|0)==1){K1a(e|0,a|0,c<<3|0)|0;h=1;break}if((c|0)>0){i=0;j=0;while(1){k=a+(j<<3)|0;l=f[k+4>>2]|0;m=e+(i<<3)|0;f[m>>2]=f[k>>2];f[m+4>>2]=l;i=i+1|0;if((i|0)==(c|0)){h=1;break}else j=j+d|0}}else return}else{j=f[b+4>>2]|0;if((g|0)==2)if((c|0)>0){i=0;l=0;while(1){m=a+(l<<3)|0;k=f[m+4>>2]|0;n=e+(i<<3)|0;f[n>>2]=f[m>>2];f[n+4>>2]=k;k=a+(l+1<<3)|0;n=f[k+4>>2]|0;m=j+(i<<3)|0;f[m>>2]=f[k>>2];f[m+4>>2]=n;i=i+1|0;if((i|0)==(c|0)){h=2;break a}else l=l+d|0}}else return;l=f[b+8>>2]|0;if((g|0)==3)if((c|0)>0){i=0;n=0;while(1){m=a+(n<<3)|0;k=f[m+4>>2]|0;o=e+(i<<3)|0;f[o>>2]=f[m>>2];f[o+4>>2]=k;k=a+(n+1<<3)|0;o=f[k+4>>2]|0;m=j+(i<<3)|0;f[m>>2]=f[k>>2];f[m+4>>2]=o;o=a+(n+2<<3)|0;m=f[o+4>>2]|0;k=l+(i<<3)|0;f[k>>2]=f[o>>2];f[k+4>>2]=m;i=i+1|0;if((i|0)==(c|0)){h=3;break}else n=n+d|0}}else return;else{n=f[b+12>>2]|0;if((c|0)>0){i=0;m=0;while(1){k=a+(m<<3)|0;o=f[k+4>>2]|0;p=e+(i<<3)|0;f[p>>2]=f[k>>2];f[p+4>>2]=o;o=a+(m+1<<3)|0;p=f[o+4>>2]|0;k=j+(i<<3)|0;f[k>>2]=f[o>>2];f[k+4>>2]=p;p=a+(m+2<<3)|0;k=f[p+4>>2]|0;o=l+(i<<3)|0;f[o>>2]=f[p>>2];f[o+4>>2]=k;k=a+(m+3<<3)|0;o=f[k+4>>2]|0;p=n+(i<<3)|0;f[p>>2]=f[k>>2];f[p+4>>2]=o;i=i+1|0;if((i|0)==(c|0)){h=g;break}else m=m+d|0}}else return}}while(0);if((c|0)>0&(h|0)<(d|0))q=h;else return;do{h=f[b+(q<<2)>>2]|0;g=f[b+(q+1<<2)>>2]|0;e=f[b+(q+2<<2)>>2]|0;m=f[b+(q+3<<2)>>2]|0;i=0;n=q;while(1){l=a+(n<<3)|0;j=f[l+4>>2]|0;o=h+(i<<3)|0;f[o>>2]=f[l>>2];f[o+4>>2]=j;j=a+(n+1<<3)|0;o=f[j+4>>2]|0;l=g+(i<<3)|0;f[l>>2]=f[j>>2];f[l+4>>2]=o;o=a+(n+2<<3)|0;l=f[o+4>>2]|0;j=e+(i<<3)|0;f[j>>2]=f[o>>2];f[j+4>>2]=l;l=a+(n+3<<3)|0;j=f[l+4>>2]|0;o=m+(i<<3)|0;f[o>>2]=f[l>>2];f[o+4>>2]=j;i=i+1|0;if((i|0)==(c|0))break;else n=n+d|0}q=q+4|0}while((q|0)<(d|0));return}function VY(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=u;u=u+1184|0;e=d+1168|0;g=d+1112|0;h=d+1104|0;i=d+1096|0;j=d+1064|0;k=d;_$(e,42860);do if((NS(c)|0)==65536){l=f[c+4>>2]|0;f[g>>2]=f[l>>2];m=g+4|0;n=l+4|0;f[m>>2]=f[n>>2];o=g+8|0;f[o>>2]=f[l+8>>2];f[g+12>>2]=f[l+12>>2];f[g+16>>2]=f[l+16>>2];f[g+20>>2]=f[l+20>>2];f[g+24>>2]=f[l+24>>2];f[g+28>>2]=f[l+28>>2];f[g+32>>2]=f[l+32>>2];q=f[l+36>>2]|0;f[g+36>>2]=q;f[g+40>>2]=o;o=g+48|0;r=g+44|0;f[r>>2]=o;f[o>>2]=0;f[g+52>>2]=0;if(q|0){o=q+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[l+44>>2]|0;o=f[r>>2]|0;f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2];s=g;break}else{f[m>>2]=0;BR(g,l);s=g;break}}else{OR(g,c,-1);s=g}while(0);c=f[s>>2]|0;s=c>>>3&511;l=s+1|0;m=c&7;c=f[42880+(m<<2)>>2]|0;if(!((m|0)!=7&l>>>0<5)){f[h>>2]=0;f[h+4>>2]=0;n=c$(h,20)|0;o=188490;r=n+20|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(r|0));j$(-215,h,188511,188515,1199);d$(h)}f[h>>2]=g;f[h+4>>2]=0;bU(j,h,i,-1);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;h=f[j+20>>2]|0;o=k+8|0;f[k>>2]=o;n=k+4|0;f[n>>2]=264;r=m>>>0<4;if(r){q=m>>>0<2?8388608:32768;m=(q|0)<(h|0)?q:h;f[n>>2]=l;if(l>>>0>264){t=OYa(l<<2)|0;f[k>>2]=t;v=t}else v=o;F1a(v|0,0,(s<<2)+4|0)|0;s=f[g+4>>2]|0;if((s|0)>0){w=m;x=v;y=f[(f[g+44>>2]|0)+(s+-1<<2)>>2]|0;z=q}else{w=m;x=v;y=0;z=q}}else{w=h;x=a;y=0;z=0}q=j+16|0;a:do if((h|0)>0){v=0;m=0;while(1){if(m>>>0>=(f[q>>2]|0)>>>0)break a;s=m+1|0;t=f[i>>2]|0;if(r){A=t;B=v;C=0;while(1){D=h-C|0;E=(w|0)<(D|0)?w:D;uh[c&63](A,0,x,E,l)|0;D=E+B|0;if((D+w|0)<(z|0)?((E+C|0)<(h|0)?1:s>>>0<(f[q>>2]|0)>>>0):0)F=D;else{G=0;H=23}if((H|0)==23)while(1){H=0;D=x+(G<<2)|0;I=a+(G<<3)|0;p[I>>3]=+p[I>>3]+ +(f[D>>2]|0);f[D>>2]=0;G=G+1|0;if((G|0)==(l|0)){F=0;break}else H=23}D=Y(E,y)|0;A=(f[i>>2]|0)+D|0;f[i>>2]=A;C=C+w|0;if((h|0)<=(C|0)){J=F;break}else B=F}}else{B=t;C=v;A=0;while(1){D=h-A|0;I=(w|0)<(D|0)?w:D;uh[c&63](B,0,x,I,l)|0;D=I+C|0;K=Y(I,y)|0;B=(f[i>>2]|0)+K|0;f[i>>2]=B;A=A+w|0;if((h|0)<=(A|0)){J=D;break}else C=D}}tR(j)|0;v=J;m=s}}else{m=0;while(1){if(m>>>0>=(f[q>>2]|0)>>>0)break a;tR(j)|0;m=m+1|0}}while(0);j=f[k>>2]|0;if((j|0)!=(o|0)){if(j|0)QYa(j);f[k>>2]=o;f[n>>2]=264}n=g+36|0;o=f[n>>2]|0;if(o|0?(k=o+12|0,o=f[k>>2]|0,f[k>>2]=o+-1,(o|0)==1):0)CR(g);f[n>>2]=0;n=g+16|0;o=g+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[o>>2]|0)>0){n=f[g+40>>2]|0;k=0;do{f[n+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[o>>2]|0))}o=f[g+44>>2]|0;if((o|0)!=(g+48|0))ZF(o);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function WY(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;if(!c){i=(g|0)%4|0;switch(i|0){case 1:{j=f[d>>2]|0;k=e+-4|0;if((e|0)<4){l=0;m=j;n=a}else{o=g<<1;p=g*3|0;q=g<<2;r=e&-4;s=0;t=j;j=a;while(1){t=(h[j>>0]|0)+t+(h[j+g>>0]|0)+(h[j+o>>0]|0)+(h[j+p>>0]|0)|0;s=s+4|0;if((s|0)>(k|0))break;else j=j+q|0}l=r;m=t;n=a+(Y(r,g)|0)|0}if((l|0)<(e|0)){r=l;t=m;q=n;while(1){n=(h[q>>0]|0)+t|0;r=r+1|0;if((r|0)==(e|0)){u=e;v=n;break}else{t=n;q=q+g|0}}}else{u=l;v=m}f[d>>2]=v;w=u;break}case 2:{u=f[d>>2]|0;v=d+4|0;m=f[v>>2]|0;if((e|0)>0){l=0;q=u;t=m;r=a;while(1){n=(h[r>>0]|0)+q|0;j=(h[r+1>>0]|0)+t|0;l=l+1|0;if((l|0)==(e|0)){x=e;y=n;z=j;break}else{q=n;t=j;r=r+g|0}}}else{x=0;y=u;z=m}f[d>>2]=y;f[v>>2]=z;w=x;break}case 3:{x=f[d>>2]|0;z=d+4|0;v=f[z>>2]|0;y=d+8|0;m=f[y>>2]|0;if((e|0)>0){u=0;r=x;t=v;q=m;l=a;while(1){j=(h[l>>0]|0)+r|0;n=(h[l+1>>0]|0)+t|0;k=(h[l+2>>0]|0)+q|0;u=u+1|0;if((u|0)==(e|0)){A=e;B=j;C=n;D=k;break}else{r=j;t=n;q=k;l=l+g|0}}}else{A=0;B=x;C=v;D=m}f[d>>2]=B;f[z>>2]=C;f[y>>2]=D;w=A;break}default:w=0}if((i|0)<(g|0)){E=w;F=i}else{G=e;return G|0}while(1){i=d+(F<<2)|0;w=f[i>>2]|0;A=d+(F+1<<2)|0;D=f[A>>2]|0;y=d+(F+2<<2)|0;C=f[y>>2]|0;z=d+(F+3<<2)|0;B=f[z>>2]|0;if((E|0)<(e|0)){m=E;v=w;x=D;l=C;q=B;t=a+(Y(E,g)|0)+F|0;while(1){r=(h[t>>0]|0)+v|0;u=(h[t+1>>0]|0)+x|0;k=(h[t+2>>0]|0)+l|0;n=(h[t+3>>0]|0)+q|0;m=m+1|0;if((m|0)==(e|0)){H=e;I=r;J=u;K=k;L=n;break}else{v=r;x=u;l=k;q=n;t=t+g|0}}}else{H=E;I=w;J=D;K=C;L=B}f[i>>2]=I;f[A>>2]=J;f[y>>2]=K;f[z>>2]=L;F=F+4|0;if((F|0)>=(g|0)){G=e;break}else E=H}return G|0}switch(g|0){case 1:{H=f[d>>2]|0;if((e|0)>0){E=0;F=0;L=H;while(1){if(!(b[c+E>>0]|0)){M=F;N=L}else{M=F+1|0;N=(h[a+E>>0]|0)+L|0}E=E+1|0;if((E|0)==(e|0)){O=M;P=N;break}else{F=M;L=N}}}else{O=0;P=H}f[d>>2]=P;G=O;return G|0}case 3:{O=f[d>>2]|0;P=d+4|0;H=f[P>>2]|0;N=d+8|0;L=f[N>>2]|0;if((e|0)>0){M=0;F=0;E=O;K=H;J=L;I=a;while(1){if(!(b[c+M>>0]|0)){Q=F;R=E;S=K;T=J}else{Q=F+1|0;R=(h[I>>0]|0)+E|0;S=(h[I+1>>0]|0)+K|0;T=(h[I+2>>0]|0)+J|0}M=M+1|0;if((M|0)==(e|0)){U=Q;V=R;W=S;X=T;break}else{F=Q;E=R;K=S;J=T;I=I+3|0}}}else{U=0;V=O;W=H;X=L}f[d>>2]=V;f[P>>2]=W;f[N>>2]=X;G=U;return G|0}default:{if((e|0)<=0){G=0;return G|0}U=g+-4|0;if((g|0)<4){if((g|0)>0){Z=0;_=0;$=a}else{X=0;N=0;while(1){W=N+((b[c+X>>0]|0)!=0&1)|0;X=X+1|0;if((X|0)==(e|0)){G=W;break}else N=W}return G|0}while(1){if(!(b[c+Z>>0]|0))aa=_;else{N=0;do{X=d+(N<<2)|0;f[X>>2]=(f[X>>2]|0)+(h[$+N>>0]|0);N=N+1|0}while((N|0)!=(g|0));aa=_+1|0}Z=Z+1|0;if((Z|0)==(e|0)){G=aa;break}else{_=aa;$=$+g|0}}return G|0}$=g&-4;if(($|0)<(g|0)){ba=0;ca=0;da=a}else{aa=0;_=0;Z=a;while(1){if(!(b[c+aa>>0]|0))ea=_;else{a=0;do{N=d+(a<<2)|0;z=a|1;y=d+(z<<2)|0;A=(h[Z+z>>0]|0)+(f[y>>2]|0)|0;f[N>>2]=(h[Z+a>>0]|0)+(f[N>>2]|0);f[y>>2]=A;A=a|2;y=d+(A<<2)|0;N=a|3;z=d+(N<<2)|0;i=(h[Z+N>>0]|0)+(f[z>>2]|0)|0;f[y>>2]=(h[Z+A>>0]|0)+(f[y>>2]|0);f[z>>2]=i;a=a+4|0}while((a|0)<=(U|0));ea=_+1|0}aa=aa+1|0;if((aa|0)==(e|0)){G=ea;break}else{_=ea;Z=Z+g|0}}return G|0}while(1){if(!(b[c+ba>>0]|0))fa=ca;else{Z=0;do{ea=d+(Z<<2)|0;_=Z|1;aa=d+(_<<2)|0;a=(h[da+_>>0]|0)+(f[aa>>2]|0)|0;f[ea>>2]=(h[da+Z>>0]|0)+(f[ea>>2]|0);f[aa>>2]=a;a=Z|2;aa=d+(a<<2)|0;ea=Z|3;_=d+(ea<<2)|0;i=(h[da+ea>>0]|0)+(f[_>>2]|0)|0;f[aa>>2]=(h[da+a>>0]|0)+(f[aa>>2]|0);f[_>>2]=i;Z=Z+4|0}while((Z|0)<=(U|0));ga=$;do{Z=d+(ga<<2)|0;f[Z>>2]=(f[Z>>2]|0)+(h[da+ga>>0]|0);ga=ga+1|0}while((ga|0)!=(g|0));fa=ca+1|0}ba=ba+1|0;if((ba|0)==(e|0)){G=fa;break}else{ca=fa;da=da+g|0}}return G|0}}return 0}function XY(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;if(!c){h=(g|0)%4|0;switch(h|0){case 1:{i=f[d>>2]|0;j=e+-4|0;if((e|0)<4){k=0;l=i;m=a}else{n=g<<1;o=g*3|0;p=g<<2;q=e&-4;r=0;s=i;i=a;while(1){s=(b[i>>0]|0)+s+(b[i+g>>0]|0)+(b[i+n>>0]|0)+(b[i+o>>0]|0)|0;r=r+4|0;if((r|0)>(j|0))break;else i=i+p|0}k=q;l=s;m=a+(Y(q,g)|0)|0}if((k|0)<(e|0)){q=k;s=l;p=m;while(1){m=(b[p>>0]|0)+s|0;q=q+1|0;if((q|0)==(e|0)){t=e;u=m;break}else{s=m;p=p+g|0}}}else{t=k;u=l}f[d>>2]=u;v=t;break}case 2:{t=f[d>>2]|0;u=d+4|0;l=f[u>>2]|0;if((e|0)>0){k=0;p=t;s=l;q=a;while(1){m=(b[q>>0]|0)+p|0;i=(b[q+1>>0]|0)+s|0;k=k+1|0;if((k|0)==(e|0)){w=e;x=m;y=i;break}else{p=m;s=i;q=q+g|0}}}else{w=0;x=t;y=l}f[d>>2]=x;f[u>>2]=y;v=w;break}case 3:{w=f[d>>2]|0;y=d+4|0;u=f[y>>2]|0;x=d+8|0;l=f[x>>2]|0;if((e|0)>0){t=0;q=w;s=u;p=l;k=a;while(1){i=(b[k>>0]|0)+q|0;m=(b[k+1>>0]|0)+s|0;j=(b[k+2>>0]|0)+p|0;t=t+1|0;if((t|0)==(e|0)){z=e;A=i;B=m;C=j;break}else{q=i;s=m;p=j;k=k+g|0}}}else{z=0;A=w;B=u;C=l}f[d>>2]=A;f[y>>2]=B;f[x>>2]=C;v=z;break}default:v=0}if((h|0)<(g|0)){D=v;E=h}else{F=e;return F|0}while(1){h=d+(E<<2)|0;v=f[h>>2]|0;z=d+(E+1<<2)|0;C=f[z>>2]|0;x=d+(E+2<<2)|0;B=f[x>>2]|0;y=d+(E+3<<2)|0;A=f[y>>2]|0;if((D|0)<(e|0)){l=D;u=v;w=C;k=B;p=A;s=a+(Y(D,g)|0)+E|0;while(1){q=(b[s>>0]|0)+u|0;t=(b[s+1>>0]|0)+w|0;j=(b[s+2>>0]|0)+k|0;m=(b[s+3>>0]|0)+p|0;l=l+1|0;if((l|0)==(e|0)){G=e;H=q;I=t;J=j;K=m;break}else{u=q;w=t;k=j;p=m;s=s+g|0}}}else{G=D;H=v;I=C;J=B;K=A}f[h>>2]=H;f[z>>2]=I;f[x>>2]=J;f[y>>2]=K;E=E+4|0;if((E|0)>=(g|0)){F=e;break}else D=G}return F|0}switch(g|0){case 1:{G=f[d>>2]|0;if((e|0)>0){D=0;E=0;K=G;while(1){if(!(b[c+D>>0]|0)){L=E;M=K}else{L=E+1|0;M=(b[a+D>>0]|0)+K|0}D=D+1|0;if((D|0)==(e|0)){N=L;O=M;break}else{E=L;K=M}}}else{N=0;O=G}f[d>>2]=O;F=N;return F|0}case 3:{N=f[d>>2]|0;O=d+4|0;G=f[O>>2]|0;M=d+8|0;K=f[M>>2]|0;if((e|0)>0){L=0;E=0;D=N;J=G;I=K;H=a;while(1){if(!(b[c+L>>0]|0)){P=E;Q=D;R=J;S=I}else{P=E+1|0;Q=(b[H>>0]|0)+D|0;R=(b[H+1>>0]|0)+J|0;S=(b[H+2>>0]|0)+I|0}L=L+1|0;if((L|0)==(e|0)){T=P;U=Q;V=R;W=S;break}else{E=P;D=Q;J=R;I=S;H=H+3|0}}}else{T=0;U=N;V=G;W=K}f[d>>2]=U;f[O>>2]=V;f[M>>2]=W;F=T;return F|0}default:{if((e|0)<=0){F=0;return F|0}T=g+-4|0;if((g|0)<4){if((g|0)>0){X=0;Z=0;_=a}else{W=0;M=0;while(1){V=M+((b[c+W>>0]|0)!=0&1)|0;W=W+1|0;if((W|0)==(e|0)){F=V;break}else M=V}return F|0}while(1){if(!(b[c+X>>0]|0))$=Z;else{M=0;do{W=d+(M<<2)|0;f[W>>2]=(f[W>>2]|0)+(b[_+M>>0]|0);M=M+1|0}while((M|0)!=(g|0));$=Z+1|0}X=X+1|0;if((X|0)==(e|0)){F=$;break}else{Z=$;_=_+g|0}}return F|0}_=g&-4;if((_|0)<(g|0)){aa=0;ba=0;ca=a}else{$=0;Z=0;X=a;while(1){if(!(b[c+$>>0]|0))da=Z;else{a=0;do{M=d+(a<<2)|0;y=a|1;x=d+(y<<2)|0;z=(b[X+y>>0]|0)+(f[x>>2]|0)|0;f[M>>2]=(b[X+a>>0]|0)+(f[M>>2]|0);f[x>>2]=z;z=a|2;x=d+(z<<2)|0;M=a|3;y=d+(M<<2)|0;h=(b[X+M>>0]|0)+(f[y>>2]|0)|0;f[x>>2]=(b[X+z>>0]|0)+(f[x>>2]|0);f[y>>2]=h;a=a+4|0}while((a|0)<=(T|0));da=Z+1|0}$=$+1|0;if(($|0)==(e|0)){F=da;break}else{Z=da;X=X+g|0}}return F|0}while(1){if(!(b[c+aa>>0]|0))ea=ba;else{X=0;do{da=d+(X<<2)|0;Z=X|1;$=d+(Z<<2)|0;a=(b[ca+Z>>0]|0)+(f[$>>2]|0)|0;f[da>>2]=(b[ca+X>>0]|0)+(f[da>>2]|0);f[$>>2]=a;a=X|2;$=d+(a<<2)|0;da=X|3;Z=d+(da<<2)|0;h=(b[ca+da>>0]|0)+(f[Z>>2]|0)|0;f[$>>2]=(b[ca+a>>0]|0)+(f[$>>2]|0);f[Z>>2]=h;X=X+4|0}while((X|0)<=(T|0));fa=_;do{X=d+(fa<<2)|0;f[X>>2]=(f[X>>2]|0)+(b[ca+fa>>0]|0);fa=fa+1|0}while((fa|0)!=(g|0));ea=ba+1|0}aa=aa+1|0;if((aa|0)==(e|0)){F=ea;break}else{ba=ea;ca=ca+g|0}}return F|0}}return 0}function YY(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;if(!c){h=(g|0)%4|0;switch(h|0){case 1:{i=f[d>>2]|0;k=e+-4|0;if((e|0)<4){l=0;m=i;n=a}else{o=g<<1;p=g*3|0;q=g<<2;r=k>>>2;s=Y((r<<3)+8|0,g)|0;t=0;u=i;i=a;while(1){u=(j[i>>1]|0)+u+(j[i+(g<<1)>>1]|0)+(j[i+(o<<1)>>1]|0)+(j[i+(p<<1)>>1]|0)|0;t=t+4|0;if((t|0)>(k|0))break;else i=i+(q<<1)|0}l=(r<<2)+4|0;m=u;n=a+s|0}if((l|0)<(e|0)){s=l;u=m;r=n;while(1){n=(j[r>>1]|0)+u|0;s=s+1|0;if((s|0)==(e|0)){v=e;w=n;break}else{u=n;r=r+(g<<1)|0}}}else{v=l;w=m}f[d>>2]=w;x=v;break}case 2:{v=f[d>>2]|0;w=d+4|0;m=f[w>>2]|0;if((e|0)>0){l=0;r=v;u=m;s=a;while(1){n=(j[s>>1]|0)+r|0;q=(j[s+2>>1]|0)+u|0;l=l+1|0;if((l|0)==(e|0)){y=e;z=n;A=q;break}else{r=n;u=q;s=s+(g<<1)|0}}}else{y=0;z=v;A=m}f[d>>2]=z;f[w>>2]=A;x=y;break}case 3:{y=f[d>>2]|0;A=d+4|0;w=f[A>>2]|0;z=d+8|0;m=f[z>>2]|0;if((e|0)>0){v=0;s=y;u=w;r=m;l=a;while(1){q=(j[l>>1]|0)+s|0;n=(j[l+2>>1]|0)+u|0;i=(j[l+4>>1]|0)+r|0;v=v+1|0;if((v|0)==(e|0)){B=e;C=q;D=n;E=i;break}else{s=q;u=n;r=i;l=l+(g<<1)|0}}}else{B=0;C=y;D=w;E=m}f[d>>2]=C;f[A>>2]=D;f[z>>2]=E;x=B;break}default:x=0}if((h|0)<(g|0)){F=x;G=h}else{H=e;return H|0}while(1){h=d+(G<<2)|0;x=f[h>>2]|0;B=d+(G+1<<2)|0;E=f[B>>2]|0;z=d+(G+2<<2)|0;D=f[z>>2]|0;A=d+(G+3<<2)|0;C=f[A>>2]|0;if((F|0)<(e|0)){m=F;w=x;y=E;l=D;r=C;u=a+((Y(F,g)|0)<<1)+(G<<1)|0;while(1){s=(j[u>>1]|0)+w|0;v=(j[u+2>>1]|0)+y|0;i=(j[u+4>>1]|0)+l|0;n=(j[u+6>>1]|0)+r|0;m=m+1|0;if((m|0)==(e|0)){I=e;J=s;K=v;L=i;M=n;break}else{w=s;y=v;l=i;r=n;u=u+(g<<1)|0}}}else{I=F;J=x;K=E;L=D;M=C}f[h>>2]=J;f[B>>2]=K;f[z>>2]=L;f[A>>2]=M;G=G+4|0;if((G|0)>=(g|0)){H=e;break}else F=I}return H|0}switch(g|0){case 1:{I=f[d>>2]|0;if((e|0)>0){F=0;G=0;M=I;while(1){if(!(b[c+F>>0]|0)){N=G;O=M}else{N=G+1|0;O=(j[a+(F<<1)>>1]|0)+M|0}F=F+1|0;if((F|0)==(e|0)){P=N;Q=O;break}else{G=N;M=O}}}else{P=0;Q=I}f[d>>2]=Q;H=P;return H|0}case 3:{P=f[d>>2]|0;Q=d+4|0;I=f[Q>>2]|0;O=d+8|0;M=f[O>>2]|0;if((e|0)>0){N=0;G=0;F=P;L=I;K=M;J=a;while(1){if(!(b[c+N>>0]|0)){R=G;S=F;T=L;U=K}else{R=G+1|0;S=(j[J>>1]|0)+F|0;T=(j[J+2>>1]|0)+L|0;U=(j[J+4>>1]|0)+K|0}N=N+1|0;if((N|0)==(e|0)){V=R;W=S;X=T;Z=U;break}else{G=R;F=S;L=T;K=U;J=J+6|0}}}else{V=0;W=P;X=I;Z=M}f[d>>2]=W;f[Q>>2]=X;f[O>>2]=Z;H=V;return H|0}default:{if((e|0)<=0){H=0;return H|0}V=g+-4|0;if((g|0)<4){if((g|0)>0){_=0;$=0;aa=a}else{Z=0;O=0;while(1){X=O+((b[c+Z>>0]|0)!=0&1)|0;Z=Z+1|0;if((Z|0)==(e|0)){H=X;break}else O=X}return H|0}while(1){if(!(b[c+_>>0]|0))ba=$;else{O=0;do{Z=d+(O<<2)|0;f[Z>>2]=(f[Z>>2]|0)+(j[aa+(O<<1)>>1]|0);O=O+1|0}while((O|0)!=(g|0));ba=$+1|0}_=_+1|0;if((_|0)==(e|0)){H=ba;break}else{$=ba;aa=aa+(g<<1)|0}}return H|0}aa=g&-4;if((aa|0)<(g|0)){ca=0;da=0;ea=a}else{ba=0;$=0;_=a;while(1){if(!(b[c+ba>>0]|0))fa=$;else{a=0;do{O=d+(a<<2)|0;A=a|1;z=d+(A<<2)|0;B=(j[_+(A<<1)>>1]|0)+(f[z>>2]|0)|0;f[O>>2]=(j[_+(a<<1)>>1]|0)+(f[O>>2]|0);f[z>>2]=B;B=a|2;z=d+(B<<2)|0;O=a|3;A=d+(O<<2)|0;h=(j[_+(O<<1)>>1]|0)+(f[A>>2]|0)|0;f[z>>2]=(j[_+(B<<1)>>1]|0)+(f[z>>2]|0);f[A>>2]=h;a=a+4|0}while((a|0)<=(V|0));fa=$+1|0}ba=ba+1|0;if((ba|0)==(e|0)){H=fa;break}else{$=fa;_=_+(g<<1)|0}}return H|0}while(1){if(!(b[c+ca>>0]|0))ga=da;else{_=0;do{fa=d+(_<<2)|0;$=_|1;ba=d+($<<2)|0;a=(j[ea+($<<1)>>1]|0)+(f[ba>>2]|0)|0;f[fa>>2]=(j[ea+(_<<1)>>1]|0)+(f[fa>>2]|0);f[ba>>2]=a;a=_|2;ba=d+(a<<2)|0;fa=_|3;$=d+(fa<<2)|0;h=(j[ea+(fa<<1)>>1]|0)+(f[$>>2]|0)|0;f[ba>>2]=(j[ea+(a<<1)>>1]|0)+(f[ba>>2]|0);f[$>>2]=h;_=_+4|0}while((_|0)<=(V|0));ha=aa;do{_=d+(ha<<2)|0;f[_>>2]=(f[_>>2]|0)+(j[ea+(ha<<1)>>1]|0);ha=ha+1|0}while((ha|0)!=(g|0));ga=da+1|0}ca=ca+1|0;if((ca|0)==(e|0)){H=ga;break}else{da=ga;ea=ea+(g<<1)|0}}return H|0}}return 0}function ZY(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;if(!c){i=(h|0)%4|0;switch(i|0){case 1:{j=f[e>>2]|0;k=g+-4|0;if((g|0)<4){l=0;m=j;n=a}else{o=h<<1;p=h*3|0;q=h<<2;r=k>>>2;s=Y((r<<3)+8|0,h)|0;t=0;u=j;j=a;while(1){u=(d[j>>1]|0)+u+(d[j+(h<<1)>>1]|0)+(d[j+(o<<1)>>1]|0)+(d[j+(p<<1)>>1]|0)|0;t=t+4|0;if((t|0)>(k|0))break;else j=j+(q<<1)|0}l=(r<<2)+4|0;m=u;n=a+s|0}if((l|0)<(g|0)){s=l;u=m;r=n;while(1){n=(d[r>>1]|0)+u|0;s=s+1|0;if((s|0)==(g|0)){v=g;w=n;break}else{u=n;r=r+(h<<1)|0}}}else{v=l;w=m}f[e>>2]=w;x=v;break}case 2:{v=f[e>>2]|0;w=e+4|0;m=f[w>>2]|0;if((g|0)>0){l=0;r=v;u=m;s=a;while(1){n=(d[s>>1]|0)+r|0;q=(d[s+2>>1]|0)+u|0;l=l+1|0;if((l|0)==(g|0)){y=g;z=n;A=q;break}else{r=n;u=q;s=s+(h<<1)|0}}}else{y=0;z=v;A=m}f[e>>2]=z;f[w>>2]=A;x=y;break}case 3:{y=f[e>>2]|0;A=e+4|0;w=f[A>>2]|0;z=e+8|0;m=f[z>>2]|0;if((g|0)>0){v=0;s=y;u=w;r=m;l=a;while(1){q=(d[l>>1]|0)+s|0;n=(d[l+2>>1]|0)+u|0;j=(d[l+4>>1]|0)+r|0;v=v+1|0;if((v|0)==(g|0)){B=g;C=q;D=n;E=j;break}else{s=q;u=n;r=j;l=l+(h<<1)|0}}}else{B=0;C=y;D=w;E=m}f[e>>2]=C;f[A>>2]=D;f[z>>2]=E;x=B;break}default:x=0}if((i|0)<(h|0)){F=x;G=i}else{H=g;return H|0}while(1){i=e+(G<<2)|0;x=f[i>>2]|0;B=e+(G+1<<2)|0;E=f[B>>2]|0;z=e+(G+2<<2)|0;D=f[z>>2]|0;A=e+(G+3<<2)|0;C=f[A>>2]|0;if((F|0)<(g|0)){m=F;w=x;y=E;l=D;r=C;u=a+((Y(F,h)|0)<<1)+(G<<1)|0;while(1){s=(d[u>>1]|0)+w|0;v=(d[u+2>>1]|0)+y|0;j=(d[u+4>>1]|0)+l|0;n=(d[u+6>>1]|0)+r|0;m=m+1|0;if((m|0)==(g|0)){I=g;J=s;K=v;L=j;M=n;break}else{w=s;y=v;l=j;r=n;u=u+(h<<1)|0}}}else{I=F;J=x;K=E;L=D;M=C}f[i>>2]=J;f[B>>2]=K;f[z>>2]=L;f[A>>2]=M;G=G+4|0;if((G|0)>=(h|0)){H=g;break}else F=I}return H|0}switch(h|0){case 1:{I=f[e>>2]|0;if((g|0)>0){F=0;G=0;M=I;while(1){if(!(b[c+F>>0]|0)){N=G;O=M}else{N=G+1|0;O=(d[a+(F<<1)>>1]|0)+M|0}F=F+1|0;if((F|0)==(g|0)){P=N;Q=O;break}else{G=N;M=O}}}else{P=0;Q=I}f[e>>2]=Q;H=P;return H|0}case 3:{P=f[e>>2]|0;Q=e+4|0;I=f[Q>>2]|0;O=e+8|0;M=f[O>>2]|0;if((g|0)>0){N=0;G=0;F=P;L=I;K=M;J=a;while(1){if(!(b[c+N>>0]|0)){R=G;S=F;T=L;U=K}else{R=G+1|0;S=(d[J>>1]|0)+F|0;T=(d[J+2>>1]|0)+L|0;U=(d[J+4>>1]|0)+K|0}N=N+1|0;if((N|0)==(g|0)){V=R;W=S;X=T;Z=U;break}else{G=R;F=S;L=T;K=U;J=J+6|0}}}else{V=0;W=P;X=I;Z=M}f[e>>2]=W;f[Q>>2]=X;f[O>>2]=Z;H=V;return H|0}default:{if((g|0)<=0){H=0;return H|0}V=h+-4|0;if((h|0)<4){if((h|0)>0){_=0;$=0;aa=a}else{Z=0;O=0;while(1){X=O+((b[c+Z>>0]|0)!=0&1)|0;Z=Z+1|0;if((Z|0)==(g|0)){H=X;break}else O=X}return H|0}while(1){if(!(b[c+_>>0]|0))ba=$;else{O=0;do{Z=e+(O<<2)|0;f[Z>>2]=(f[Z>>2]|0)+(d[aa+(O<<1)>>1]|0);O=O+1|0}while((O|0)!=(h|0));ba=$+1|0}_=_+1|0;if((_|0)==(g|0)){H=ba;break}else{$=ba;aa=aa+(h<<1)|0}}return H|0}aa=h&-4;if((aa|0)<(h|0)){ca=0;da=0;ea=a}else{ba=0;$=0;_=a;while(1){if(!(b[c+ba>>0]|0))fa=$;else{a=0;do{O=e+(a<<2)|0;A=a|1;z=e+(A<<2)|0;B=(d[_+(A<<1)>>1]|0)+(f[z>>2]|0)|0;f[O>>2]=(d[_+(a<<1)>>1]|0)+(f[O>>2]|0);f[z>>2]=B;B=a|2;z=e+(B<<2)|0;O=a|3;A=e+(O<<2)|0;i=(d[_+(O<<1)>>1]|0)+(f[A>>2]|0)|0;f[z>>2]=(d[_+(B<<1)>>1]|0)+(f[z>>2]|0);f[A>>2]=i;a=a+4|0}while((a|0)<=(V|0));fa=$+1|0}ba=ba+1|0;if((ba|0)==(g|0)){H=fa;break}else{$=fa;_=_+(h<<1)|0}}return H|0}while(1){if(!(b[c+ca>>0]|0))ga=da;else{_=0;do{fa=e+(_<<2)|0;$=_|1;ba=e+($<<2)|0;a=(d[ea+($<<1)>>1]|0)+(f[ba>>2]|0)|0;f[fa>>2]=(d[ea+(_<<1)>>1]|0)+(f[fa>>2]|0);f[ba>>2]=a;a=_|2;ba=e+(a<<2)|0;fa=_|3;$=e+(fa<<2)|0;i=(d[ea+(fa<<1)>>1]|0)+(f[$>>2]|0)|0;f[ba>>2]=(d[ea+(a<<1)>>1]|0)+(f[ba>>2]|0);f[$>>2]=i;_=_+4|0}while((_|0)<=(V|0));ha=aa;do{_=e+(ha<<2)|0;f[_>>2]=(f[_>>2]|0)+(d[ea+(ha<<1)>>1]|0);ha=ha+1|0}while((ha|0)!=(h|0));ga=da+1|0}ca=ca+1|0;if((ca|0)==(g|0)){H=ga;break}else{da=ga;ea=ea+(h<<1)|0}}return H|0}}return 0}function _Y(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0.0,T=0,U=0.0,V=0,W=0.0,X=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;if(!c){h=(g|0)%4|0;switch(h|0){case 1:{i=+p[d>>3];j=e+-4|0;if((e|0)<4){k=0;l=i;m=a}else{n=g<<1;o=g*3|0;q=g<<2;r=j>>>2;s=Y((r<<4)+16|0,g)|0;t=0;u=i;v=a;while(1){u=u+ +((f[v+(g<<2)>>2]|0)+(f[v>>2]|0)+(f[v+(n<<2)>>2]|0)+(f[v+(o<<2)>>2]|0)|0);t=t+4|0;if((t|0)>(j|0))break;else v=v+(q<<2)|0}k=(r<<2)+4|0;l=u;m=a+s|0}if((k|0)<(e|0)){s=k;u=l;r=m;while(1){i=u+ +(f[r>>2]|0);s=s+1|0;if((s|0)==(e|0)){w=e;x=i;break}else{u=i;r=r+(g<<2)|0}}}else{w=k;x=l}p[d>>3]=x;y=w;break}case 2:{x=+p[d>>3];w=d+8|0;l=+p[w>>3];if((e|0)>0){k=0;u=x;i=l;r=a;while(1){z=u+ +(f[r>>2]|0);A=i+ +(f[r+4>>2]|0);k=k+1|0;if((k|0)==(e|0)){B=e;C=z;D=A;break}else{u=z;i=A;r=r+(g<<2)|0}}}else{B=0;C=x;D=l}p[d>>3]=C;p[w>>3]=D;y=B;break}case 3:{D=+p[d>>3];B=d+8|0;C=+p[B>>3];w=d+16|0;l=+p[w>>3];if((e|0)>0){r=0;x=D;i=C;u=l;k=a;while(1){A=x+ +(f[k>>2]|0);z=i+ +(f[k+4>>2]|0);E=u+ +(f[k+8>>2]|0);r=r+1|0;if((r|0)==(e|0)){F=e;G=A;H=z;I=E;break}else{x=A;i=z;u=E;k=k+(g<<2)|0}}}else{F=0;G=D;H=C;I=l}p[d>>3]=G;p[B>>3]=H;p[w>>3]=I;y=F;break}default:y=0}if((h|0)<(g|0)){J=y;K=h}else{L=e;return L|0}while(1){h=d+(K<<3)|0;I=+p[h>>3];y=d+(K+1<<3)|0;H=+p[y>>3];F=d+(K+2<<3)|0;G=+p[F>>3];w=d+(K+3<<3)|0;l=+p[w>>3];if((J|0)<(e|0)){B=J;C=I;D=H;u=G;i=l;k=a+((Y(J,g)|0)<<2)+(K<<2)|0;while(1){x=C+ +(f[k>>2]|0);E=D+ +(f[k+4>>2]|0);z=u+ +(f[k+8>>2]|0);A=i+ +(f[k+12>>2]|0);B=B+1|0;if((B|0)==(e|0)){M=e;N=x;O=E;P=z;Q=A;break}else{C=x;D=E;u=z;i=A;k=k+(g<<2)|0}}}else{M=J;N=I;O=H;P=G;Q=l}p[h>>3]=N;p[y>>3]=O;p[F>>3]=P;p[w>>3]=Q;K=K+4|0;if((K|0)>=(g|0)){L=e;break}else J=M}return L|0}switch(g|0){case 1:{Q=+p[d>>3];if((e|0)>0){M=0;J=0;P=Q;while(1){if(!(b[c+M>>0]|0)){R=J;S=P}else{R=J+1|0;S=P+ +(f[a+(M<<2)>>2]|0)}M=M+1|0;if((M|0)==(e|0)){T=R;U=S;break}else{J=R;P=S}}}else{T=0;U=Q}p[d>>3]=U;L=T;return L|0}case 3:{U=+p[d>>3];T=d+8|0;Q=+p[T>>3];R=d+16|0;S=+p[R>>3];if((e|0)>0){J=0;M=0;P=U;O=Q;N=S;K=a;while(1){if(!(b[c+J>>0]|0)){V=M;W=P;X=O;Z=N}else{V=M+1|0;W=P+ +(f[K>>2]|0);X=O+ +(f[K+4>>2]|0);Z=N+ +(f[K+8>>2]|0)}J=J+1|0;if((J|0)==(e|0)){_=V;$=W;aa=X;ba=Z;break}else{M=V;P=W;O=X;N=Z;K=K+12|0}}}else{_=0;$=U;aa=Q;ba=S}p[d>>3]=$;p[T>>3]=aa;p[R>>3]=ba;L=_;return L|0}default:{if((e|0)<=0){L=0;return L|0}_=g+-4|0;if((g|0)<4){if((g|0)>0){ca=0;da=0;ea=a}else{R=0;T=0;while(1){K=T+((b[c+R>>0]|0)!=0&1)|0;R=R+1|0;if((R|0)==(e|0)){L=K;break}else T=K}return L|0}while(1){if(!(b[c+ca>>0]|0))fa=da;else{T=0;do{R=d+(T<<3)|0;p[R>>3]=+p[R>>3]+ +(f[ea+(T<<2)>>2]|0);T=T+1|0}while((T|0)!=(g|0));fa=da+1|0}ca=ca+1|0;if((ca|0)==(e|0)){L=fa;break}else{da=fa;ea=ea+(g<<2)|0}}return L|0}ea=g&-4;if((ea|0)<(g|0)){ga=0;ha=0;ia=a}else{fa=0;da=0;ca=a;while(1){if(!(b[c+fa>>0]|0))ja=da;else{a=0;do{T=d+(a<<3)|0;w=a|1;F=d+(w<<3)|0;l=+p[F>>3]+ +(f[ca+(w<<2)>>2]|0);p[T>>3]=+p[T>>3]+ +(f[ca+(a<<2)>>2]|0);p[F>>3]=l;F=a|2;T=d+(F<<3)|0;w=a|3;y=d+(w<<3)|0;l=+p[y>>3]+ +(f[ca+(w<<2)>>2]|0);p[T>>3]=+p[T>>3]+ +(f[ca+(F<<2)>>2]|0);p[y>>3]=l;a=a+4|0}while((a|0)<=(_|0));ja=da+1|0}fa=fa+1|0;if((fa|0)==(e|0)){L=ja;break}else{da=ja;ca=ca+(g<<2)|0}}return L|0}while(1){if(!(b[c+ga>>0]|0))ka=ha;else{ca=0;do{ja=d+(ca<<3)|0;da=ca|1;fa=d+(da<<3)|0;l=+p[fa>>3]+ +(f[ia+(da<<2)>>2]|0);p[ja>>3]=+p[ja>>3]+ +(f[ia+(ca<<2)>>2]|0);p[fa>>3]=l;fa=ca|2;ja=d+(fa<<3)|0;da=ca|3;a=d+(da<<3)|0;l=+p[a>>3]+ +(f[ia+(da<<2)>>2]|0);p[ja>>3]=+p[ja>>3]+ +(f[ia+(fa<<2)>>2]|0);p[a>>3]=l;ca=ca+4|0}while((ca|0)<=(_|0));la=ea;do{ca=d+(la<<3)|0;p[ca>>3]=+p[ca>>3]+ +(f[ia+(la<<2)>>2]|0);la=la+1|0}while((la|0)!=(g|0));ka=ha+1|0}ga=ga+1|0;if((ga|0)==(e|0)){L=ka;break}else{ha=ka;ia=ia+(g<<2)|0}}return L|0}}return 0}function $Y(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0,j=0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0.0,T=0,U=0.0,V=0,W=0.0,X=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;if(!c){g=(f|0)%4|0;switch(g|0){case 1:{h=+p[d>>3];i=e+-4|0;if((e|0)<4){j=0;k=h;l=a}else{m=f<<1;o=f*3|0;q=f<<2;r=i>>>2;s=Y((r<<4)+16|0,f)|0;t=0;u=h;v=a;while(1){u=u+(+n[v>>2]+ +n[v+(f<<2)>>2]+ +n[v+(m<<2)>>2]+ +n[v+(o<<2)>>2]);t=t+4|0;if((t|0)>(i|0))break;else v=v+(q<<2)|0}j=(r<<2)+4|0;k=u;l=a+s|0}if((j|0)<(e|0)){s=j;u=k;r=l;while(1){h=u+ +n[r>>2];s=s+1|0;if((s|0)==(e|0)){w=e;x=h;break}else{u=h;r=r+(f<<2)|0}}}else{w=j;x=k}p[d>>3]=x;y=w;break}case 2:{x=+p[d>>3];w=d+8|0;k=+p[w>>3];if((e|0)>0){j=0;u=x;h=k;r=a;while(1){z=u+ +n[r>>2];A=h+ +n[r+4>>2];j=j+1|0;if((j|0)==(e|0)){B=e;C=z;D=A;break}else{u=z;h=A;r=r+(f<<2)|0}}}else{B=0;C=x;D=k}p[d>>3]=C;p[w>>3]=D;y=B;break}case 3:{D=+p[d>>3];B=d+8|0;C=+p[B>>3];w=d+16|0;k=+p[w>>3];if((e|0)>0){r=0;x=D;h=C;u=k;j=a;while(1){A=x+ +n[j>>2];z=h+ +n[j+4>>2];E=u+ +n[j+8>>2];r=r+1|0;if((r|0)==(e|0)){F=e;G=A;H=z;I=E;break}else{x=A;h=z;u=E;j=j+(f<<2)|0}}}else{F=0;G=D;H=C;I=k}p[d>>3]=G;p[B>>3]=H;p[w>>3]=I;y=F;break}default:y=0}if((g|0)<(f|0)){J=y;K=g}else{L=e;return L|0}while(1){g=d+(K<<3)|0;I=+p[g>>3];y=d+(K+1<<3)|0;H=+p[y>>3];F=d+(K+2<<3)|0;G=+p[F>>3];w=d+(K+3<<3)|0;k=+p[w>>3];if((J|0)<(e|0)){B=J;C=I;D=H;u=G;h=k;j=a+((Y(J,f)|0)<<2)+(K<<2)|0;while(1){x=C+ +n[j>>2];E=D+ +n[j+4>>2];z=u+ +n[j+8>>2];A=h+ +n[j+12>>2];B=B+1|0;if((B|0)==(e|0)){M=e;N=x;O=E;P=z;Q=A;break}else{C=x;D=E;u=z;h=A;j=j+(f<<2)|0}}}else{M=J;N=I;O=H;P=G;Q=k}p[g>>3]=N;p[y>>3]=O;p[F>>3]=P;p[w>>3]=Q;K=K+4|0;if((K|0)>=(f|0)){L=e;break}else J=M}return L|0}switch(f|0){case 1:{Q=+p[d>>3];if((e|0)>0){M=0;J=0;P=Q;while(1){if(!(b[c+M>>0]|0)){R=J;S=P}else{R=J+1|0;S=P+ +n[a+(M<<2)>>2]}M=M+1|0;if((M|0)==(e|0)){T=R;U=S;break}else{J=R;P=S}}}else{T=0;U=Q}p[d>>3]=U;L=T;return L|0}case 3:{U=+p[d>>3];T=d+8|0;Q=+p[T>>3];R=d+16|0;S=+p[R>>3];if((e|0)>0){J=0;M=0;P=U;O=Q;N=S;K=a;while(1){if(!(b[c+J>>0]|0)){V=M;W=P;X=O;Z=N}else{V=M+1|0;W=P+ +n[K>>2];X=O+ +n[K+4>>2];Z=N+ +n[K+8>>2]}J=J+1|0;if((J|0)==(e|0)){_=V;$=W;aa=X;ba=Z;break}else{M=V;P=W;O=X;N=Z;K=K+12|0}}}else{_=0;$=U;aa=Q;ba=S}p[d>>3]=$;p[T>>3]=aa;p[R>>3]=ba;L=_;return L|0}default:{if((e|0)<=0){L=0;return L|0}_=f+-4|0;if((f|0)<4){if((f|0)>0){ca=0;da=0;ea=a}else{R=0;T=0;while(1){K=T+((b[c+R>>0]|0)!=0&1)|0;R=R+1|0;if((R|0)==(e|0)){L=K;break}else T=K}return L|0}while(1){if(!(b[c+ca>>0]|0))fa=da;else{T=0;do{R=d+(T<<3)|0;p[R>>3]=+p[R>>3]+ +n[ea+(T<<2)>>2];T=T+1|0}while((T|0)!=(f|0));fa=da+1|0}ca=ca+1|0;if((ca|0)==(e|0)){L=fa;break}else{da=fa;ea=ea+(f<<2)|0}}return L|0}ea=f&-4;if((ea|0)<(f|0)){ga=0;ha=0;ia=a}else{fa=0;da=0;ca=a;while(1){if(!(b[c+fa>>0]|0))ja=da;else{a=0;do{T=d+(a<<3)|0;w=a|1;F=d+(w<<3)|0;k=+p[F>>3]+ +n[ca+(w<<2)>>2];p[T>>3]=+p[T>>3]+ +n[ca+(a<<2)>>2];p[F>>3]=k;F=a|2;T=d+(F<<3)|0;w=a|3;y=d+(w<<3)|0;k=+p[y>>3]+ +n[ca+(w<<2)>>2];p[T>>3]=+p[T>>3]+ +n[ca+(F<<2)>>2];p[y>>3]=k;a=a+4|0}while((a|0)<=(_|0));ja=da+1|0}fa=fa+1|0;if((fa|0)==(e|0)){L=ja;break}else{da=ja;ca=ca+(f<<2)|0}}return L|0}while(1){if(!(b[c+ga>>0]|0))ka=ha;else{ca=0;do{ja=d+(ca<<3)|0;da=ca|1;fa=d+(da<<3)|0;k=+p[fa>>3]+ +n[ia+(da<<2)>>2];p[ja>>3]=+p[ja>>3]+ +n[ia+(ca<<2)>>2];p[fa>>3]=k;fa=ca|2;ja=d+(fa<<3)|0;da=ca|3;a=d+(da<<3)|0;k=+p[a>>3]+ +n[ia+(da<<2)>>2];p[ja>>3]=+p[ja>>3]+ +n[ia+(fa<<2)>>2];p[a>>3]=k;ca=ca+4|0}while((ca|0)<=(_|0));la=ea;do{ca=d+(la<<3)|0;p[ca>>3]=+p[ca>>3]+ +n[ia+(la<<2)>>2];la=la+1|0}while((la|0)!=(f|0));ka=ha+1|0}ga=ga+1|0;if((ga|0)==(e|0)){L=ka;break}else{ha=ka;ia=ia+(f<<2)|0}}return L|0}}return 0}function aZ(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0.0,S=0,T=0.0,U=0,V=0.0,W=0.0,X=0.0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;if(!c){g=(f|0)%4|0;switch(g|0){case 1:{h=+p[d>>3];i=e+-4|0;if((e|0)<4){j=0;k=h;l=a}else{m=f<<1;n=f*3|0;o=f<<2;q=i>>>2;r=Y((q<<5)+32|0,f)|0;s=0;t=h;u=a;while(1){t=t+(+p[u>>3]+ +p[u+(f<<3)>>3]+ +p[u+(m<<3)>>3]+ +p[u+(n<<3)>>3]);s=s+4|0;if((s|0)>(i|0))break;else u=u+(o<<3)|0}j=(q<<2)+4|0;k=t;l=a+r|0}if((j|0)<(e|0)){r=j;t=k;q=l;while(1){h=t+ +p[q>>3];r=r+1|0;if((r|0)==(e|0)){v=e;w=h;break}else{t=h;q=q+(f<<3)|0}}}else{v=j;w=k}p[d>>3]=w;x=v;break}case 2:{w=+p[d>>3];v=d+8|0;k=+p[v>>3];if((e|0)>0){j=0;t=w;h=k;q=a;while(1){y=t+ +p[q>>3];z=h+ +p[q+8>>3];j=j+1|0;if((j|0)==(e|0)){A=e;B=y;C=z;break}else{t=y;h=z;q=q+(f<<3)|0}}}else{A=0;B=w;C=k}p[d>>3]=B;p[v>>3]=C;x=A;break}case 3:{C=+p[d>>3];A=d+8|0;B=+p[A>>3];v=d+16|0;k=+p[v>>3];if((e|0)>0){q=0;w=C;h=B;t=k;j=a;while(1){z=w+ +p[j>>3];y=h+ +p[j+8>>3];D=t+ +p[j+16>>3];q=q+1|0;if((q|0)==(e|0)){E=e;F=z;G=y;H=D;break}else{w=z;h=y;t=D;j=j+(f<<3)|0}}}else{E=0;F=C;G=B;H=k}p[d>>3]=F;p[A>>3]=G;p[v>>3]=H;x=E;break}default:x=0}if((g|0)<(f|0)){I=x;J=g}else{K=e;return K|0}while(1){g=d+(J<<3)|0;H=+p[g>>3];x=d+(J+1<<3)|0;G=+p[x>>3];E=d+(J+2<<3)|0;F=+p[E>>3];v=d+(J+3<<3)|0;k=+p[v>>3];if((I|0)<(e|0)){A=I;B=H;C=G;t=F;h=k;j=a+((Y(I,f)|0)<<3)+(J<<3)|0;while(1){w=B+ +p[j>>3];D=C+ +p[j+8>>3];y=t+ +p[j+16>>3];z=h+ +p[j+24>>3];A=A+1|0;if((A|0)==(e|0)){L=e;M=w;N=D;O=y;P=z;break}else{B=w;C=D;t=y;h=z;j=j+(f<<3)|0}}}else{L=I;M=H;N=G;O=F;P=k}p[g>>3]=M;p[x>>3]=N;p[E>>3]=O;p[v>>3]=P;J=J+4|0;if((J|0)>=(f|0)){K=e;break}else I=L}return K|0}switch(f|0){case 1:{P=+p[d>>3];if((e|0)>0){L=0;I=0;O=P;while(1){if(!(b[c+L>>0]|0)){Q=I;R=O}else{Q=I+1|0;R=O+ +p[a+(L<<3)>>3]}L=L+1|0;if((L|0)==(e|0)){S=Q;T=R;break}else{I=Q;O=R}}}else{S=0;T=P}p[d>>3]=T;K=S;return K|0}case 3:{T=+p[d>>3];S=d+8|0;P=+p[S>>3];Q=d+16|0;R=+p[Q>>3];if((e|0)>0){I=0;L=0;O=T;N=P;M=R;J=a;while(1){if(!(b[c+I>>0]|0)){U=L;V=O;W=N;X=M}else{U=L+1|0;V=O+ +p[J>>3];W=N+ +p[J+8>>3];X=M+ +p[J+16>>3]}I=I+1|0;if((I|0)==(e|0)){Z=U;_=V;$=W;aa=X;break}else{L=U;O=V;N=W;M=X;J=J+24|0}}}else{Z=0;_=T;$=P;aa=R}p[d>>3]=_;p[S>>3]=$;p[Q>>3]=aa;K=Z;return K|0}default:{if((e|0)<=0){K=0;return K|0}Z=f+-4|0;if((f|0)<4){if((f|0)>0){ba=0;ca=0;da=a}else{Q=0;S=0;while(1){J=S+((b[c+Q>>0]|0)!=0&1)|0;Q=Q+1|0;if((Q|0)==(e|0)){K=J;break}else S=J}return K|0}while(1){if(!(b[c+ba>>0]|0))ea=ca;else{S=0;do{Q=d+(S<<3)|0;p[Q>>3]=+p[da+(S<<3)>>3]+ +p[Q>>3];S=S+1|0}while((S|0)!=(f|0));ea=ca+1|0}ba=ba+1|0;if((ba|0)==(e|0)){K=ea;break}else{ca=ea;da=da+(f<<3)|0}}return K|0}da=f&-4;if((da|0)<(f|0)){fa=0;ga=0;ha=a}else{ea=0;ca=0;ba=a;while(1){if(!(b[c+ea>>0]|0))ia=ca;else{a=0;do{S=d+(a<<3)|0;v=a|1;E=d+(v<<3)|0;k=+p[E>>3]+ +p[ba+(v<<3)>>3];p[S>>3]=+p[S>>3]+ +p[ba+(a<<3)>>3];p[E>>3]=k;E=a|2;S=d+(E<<3)|0;v=a|3;x=d+(v<<3)|0;k=+p[x>>3]+ +p[ba+(v<<3)>>3];p[S>>3]=+p[S>>3]+ +p[ba+(E<<3)>>3];p[x>>3]=k;a=a+4|0}while((a|0)<=(Z|0));ia=ca+1|0}ea=ea+1|0;if((ea|0)==(e|0)){K=ia;break}else{ca=ia;ba=ba+(f<<3)|0}}return K|0}while(1){if(!(b[c+fa>>0]|0))ja=ga;else{ba=0;do{ia=d+(ba<<3)|0;ca=ba|1;ea=d+(ca<<3)|0;k=+p[ea>>3]+ +p[ha+(ca<<3)>>3];p[ia>>3]=+p[ia>>3]+ +p[ha+(ba<<3)>>3];p[ea>>3]=k;ea=ba|2;ia=d+(ea<<3)|0;ca=ba|3;a=d+(ca<<3)|0;k=+p[a>>3]+ +p[ha+(ca<<3)>>3];p[ia>>3]=+p[ia>>3]+ +p[ha+(ea<<3)>>3];p[a>>3]=k;ba=ba+4|0}while((ba|0)<=(Z|0));ka=da;do{ba=d+(ka<<3)|0;p[ba>>3]=+p[ha+(ka<<3)>>3]+ +p[ba>>3];ka=ka+1|0}while((ka|0)!=(f|0));ja=ga+1|0}fa=fa+1|0;if((fa|0)==(e|0)){K=ja;break}else{ga=ja;ha=ha+(f<<3)|0}}return K|0}}return 0}function bZ(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+112|0;d=c+104|0;e=c+48|0;g=c+40|0;h=c+32|0;i=c;_$(d,42912);if((RR(a,-1)|0)&4088|0){f[e>>2]=0;f[e+4>>2]=0;j=c$(e,7)|0;b[j>>0]=b[345674]|0;b[j+1>>0]=b[345675]|0;b[j+2>>0]=b[345676]|0;b[j+3>>0]=b[345677]|0;b[j+4>>0]=b[345678]|0;b[j+5>>0]=b[345679]|0;b[j+6>>0]=b[345680]|0;j$(-215,e,188592,188515,1358);d$(e)}do if((NS(a)|0)==65536){j=f[a+4>>2]|0;f[e>>2]=f[j>>2];k=e+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=e+8|0;f[m>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[e+16>>2]=f[j+16>>2];f[e+20>>2]=f[j+20>>2];f[e+24>>2]=f[j+24>>2];f[e+28>>2]=f[j+28>>2];f[e+32>>2]=f[j+32>>2];n=f[j+36>>2]|0;f[e+36>>2]=n;f[e+40>>2]=m;m=e+48|0;o=e+44|0;f[o>>2]=m;f[m>>2]=0;f[e+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];p=e;break}else{f[k>>2]=0;BR(e,j);p=e;break}}else{OR(e,a,-1);p=e}while(0);a=f[p>>2]&7;p=f[42932+(a<<2)>>2]|0;if((a|0)==7){f[g>>2]=0;f[g+4>>2]=0;a=c$(g,9)|0;j=323538;k=a+9|0;do{b[a>>0]=b[j>>0]|0;a=a+1|0;j=j+1|0}while((a|0)<(k|0));j$(-215,g,188592,188515,1374);d$(g)}f[g>>2]=e;f[g+4>>2]=0;bU(i,g,h,-1);g=f[i+20>>2]|0;j=i+16|0;a=0;k=0;while(1){if(a>>>0>=(f[j>>2]|0)>>>0)break;l=($h[p&255](f[h>>2]|0,g)|0)+k|0;tR(i)|0;a=a+1|0;k=l}a=e+36|0;i=f[a>>2]|0;if(i|0?(g=i+12|0,i=f[g>>2]|0,f[g>>2]=i+-1,(i|0)==1):0)CR(e);f[a>>2]=0;a=e+16|0;i=e+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[i>>2]|0)>0){a=f[e+40>>2]|0;g=0;do{f[a+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[i>>2]|0))}i=f[e+44>>2]|0;if((i|0)!=(e+48|0))ZF(i);if(!(f[d+4>>2]|0)){u=c;return k|0}u=c;return k|0}function cZ(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0;if((c|0)>0){d=0;e=0}else{f=0;return f|0}while(1){g=((b[a+d>>0]|0)!=0&1)+e|0;d=d+1|0;if((d|0)==(c|0)){f=g;break}else e=g}return f|0}function dZ(a,b){a=a|0;b=b|0;var c=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=b+-4|0;if((b|0)<4){e=0;f=0}else{g=0;h=0;do{h=((d[a+(g<<1)>>1]|0)!=0&1)+h+((d[a+((g|1)<<1)>>1]|0)!=0&1)+((d[a+((g|2)<<1)>>1]|0)!=0&1)+((d[a+((g|3)<<1)>>1]|0)!=0&1)|0;g=g+4|0}while((g|0)<=(c|0));e=b&-4;f=h}if((e|0)<(b|0)){i=e;j=f}else{k=f;return k|0}while(1){f=((d[a+(i<<1)>>1]|0)!=0&1)+j|0;i=i+1|0;if((i|0)==(b|0)){k=f;break}else j=f}return k|0}function eZ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=b+-4|0;if((b|0)<4){d=0;e=0}else{g=0;h=0;do{h=((f[a+(g<<2)>>2]|0)!=0&1)+h+((f[a+((g|1)<<2)>>2]|0)!=0&1)+((f[a+((g|2)<<2)>>2]|0)!=0&1)+((f[a+((g|3)<<2)>>2]|0)!=0&1)|0;g=g+4|0}while((g|0)<=(c|0));d=b&-4;e=h}if((d|0)<(b|0)){i=d;j=e}else{k=e;return k|0}while(1){e=((f[a+(i<<2)>>2]|0)!=0&1)+j|0;i=i+1|0;if((i|0)==(b|0)){k=e;break}else j=e}return k|0}function fZ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=b+-4|0;if((b|0)<4){d=0;e=0}else{f=0;g=0;do{g=(+n[a+(f<<2)>>2]!=0.0&1)+g+(+n[a+((f|1)<<2)>>2]!=0.0&1)+(+n[a+((f|2)<<2)>>2]!=0.0&1)+(+n[a+((f|3)<<2)>>2]!=0.0&1)|0;f=f+4|0}while((f|0)<=(c|0));d=b&-4;e=g}if((d|0)<(b|0)){h=d;i=e}else{j=e;return j|0}while(1){e=(+n[a+(h<<2)>>2]!=0.0&1)+i|0;h=h+1|0;if((h|0)==(b|0)){j=e;break}else i=e}return j|0}function gZ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=b+-4|0;if((b|0)<4){d=0;e=0}else{f=0;g=0;do{g=(+p[a+(f<<3)>>3]!=0.0&1)+g+(+p[a+((f|1)<<3)>>3]!=0.0&1)+(+p[a+((f|2)<<3)>>3]!=0.0&1)+(+p[a+((f|3)<<3)>>3]!=0.0&1)|0;f=f+4|0}while((f|0)<=(c|0));d=b&-4;e=g}if((d|0)<(b|0)){h=d;i=e}else{j=e;return j|0}while(1){e=(+p[a+(h<<3)>>3]!=0.0&1)+i|0;h=h+1|0;if((h|0)==(b|0)){j=e;break}else i=e}return j|0}function hZ(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0;e=u;u=u+1280|0;g=e+1264|0;h=e+1208|0;i=e+1152|0;j=e;k=e+1136|0;l=e+1128|0;m=e+1096|0;n=e+32|0;_$(g,42964);do if((NS(c)|0)==65536){o=f[c+4>>2]|0;f[h>>2]=f[o>>2];q=h+4|0;r=o+4|0;f[q>>2]=f[r>>2];s=h+8|0;f[s>>2]=f[o+8>>2];f[h+12>>2]=f[o+12>>2];f[h+16>>2]=f[o+16>>2];f[h+20>>2]=f[o+20>>2];f[h+24>>2]=f[o+24>>2];f[h+28>>2]=f[o+28>>2];f[h+32>>2]=f[o+32>>2];t=f[o+36>>2]|0;f[h+36>>2]=t;f[h+40>>2]=s;s=h+48|0;v=h+44|0;f[v>>2]=s;f[s>>2]=0;f[h+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[o+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;BR(h,o);break}}else OR(h,c,-1);while(0);do if((NS(d)|0)==65536){c=f[d+4>>2]|0;f[i>>2]=f[c>>2];o=i+4|0;q=c+4|0;f[o>>2]=f[q>>2];r=i+8|0;f[r>>2]=f[c+8>>2];f[i+12>>2]=f[c+12>>2];s=i+16|0;f[s>>2]=f[c+16>>2];f[i+20>>2]=f[c+20>>2];f[i+24>>2]=f[c+24>>2];f[i+28>>2]=f[c+28>>2];f[i+32>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[i+36>>2]=v;f[i+40>>2]=r;r=i+48|0;t=i+44|0;f[t>>2]=r;f[r>>2]=0;f[i+52>>2]=0;if(v|0){r=v+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[c+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];w=s;break}else{f[o>>2]=0;BR(i,c);w=s;break}}else{OR(i,d,-1);w=i+16|0}while(0);if(f[w>>2]|0){d=f[i+4>>2]|0;if((d|0)<3)x=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{s=f[i+40>>2]|0;c=0;o=1;while(1){q=Y(f[s+(c<<2)>>2]|0,o)|0;c=c+1|0;if((c|0)==(d|0)){x=q;break}else o=q}}if(!((d|0)==0|(x|0)==0)?f[i>>2]&4095|0:0){f[j>>2]=0;f[j+4>>2]=0;y=c$(j,32)|0;z=188638;A=y+32|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));j$(-215,j,188671,188515,1488);d$(j)}}x=f[h>>2]|0;d=x>>>3&511;o=d+1|0;c=x&7;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;x=f[42880+(c<<2)>>2]|0;if(!((c|0)!=7&o>>>0<5)){f[k>>2]=0;f[k+4>>2]=0;y=c$(k,20)|0;z=188490;A=y+20|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));j$(-215,k,188671,188515,1497);d$(k)}f[k>>2]=h;f[k+4>>2]=i;f[k+8>>2]=0;bU(m,k,l,-1);k=f[m+20>>2]|0;z=n+8|0;f[n>>2]=z;y=n+4|0;f[y>>2]=264;A=c>>>0<4;if(A){s=c>>>0<2?8388608:32768;c=(s|0)<(k|0)?s:k;f[y>>2]=o;if(o>>>0>264){q=OYa(o<<2)|0;f[n>>2]=q;B=q}else B=z;F1a(B|0,0,(d<<2)+4|0)|0;d=f[h+4>>2]|0;if((d|0)>0){C=c;D=B;E=f[(f[h+44>>2]|0)+(d+-1<<2)>>2]|0;F=s}else{C=c;D=B;E=0;F=s}}else{C=k;D=j;E=0;F=0}s=m+16|0;B=(k|0)>0;c=l+4|0;d=0;q=0;r=0;while(1){if(q>>>0>=(f[s>>2]|0)>>>0)break;t=q+1|0;a:do if(B){v=f[l>>2]|0;G=f[c>>2]|0;if(A){H=v;I=G;J=d;K=0;L=r}else{M=v;v=G;G=d;N=0;O=r;while(1){P=k-N|0;Q=(C|0)<(P|0)?C:P;P=uh[x&63](M,v,D,Q,o)|0;R=P+G|0;S=P+O|0;P=Y(Q,E)|0;M=(f[l>>2]|0)+P|0;f[l>>2]=M;P=f[c>>2]|0;if(!P)T=0;else{U=P+Q|0;f[c>>2]=U;T=U}N=N+C|0;if((k|0)<=(N|0)){V=R;W=S;break a}else{v=T;G=R;O=S}}}while(1){O=k-K|0;G=(C|0)<(O|0)?C:O;O=uh[x&63](H,I,D,G,o)|0;v=O+J|0;N=O+L|0;if((v+C|0)<(F|0)?((G+K|0)<(k|0)?1:t>>>0<(f[s>>2]|0)>>>0):0)X=v;else{Z=0;_=36}if((_|0)==36)while(1){_=0;v=D+(Z<<2)|0;O=j+(Z<<3)|0;p[O>>3]=+p[O>>3]+ +(f[v>>2]|0);f[v>>2]=0;Z=Z+1|0;if((Z|0)==(o|0)){X=0;break}else _=36}v=Y(G,E)|0;H=(f[l>>2]|0)+v|0;f[l>>2]=H;v=f[c>>2]|0;if(!v)$=0;else{O=v+G|0;f[c>>2]=O;$=O}K=K+C|0;if((k|0)<=(K|0)){V=X;W=N;break}else{I=$;J=X;L=N}}}else{V=d;W=r}while(0);tR(m)|0;d=V;q=t;r=W}aa=(r|0)==0?0.0:1.0/+(r>>>0);ba=aa*+p[j+8>>3];ca=aa*+p[j+16>>3];da=aa*+p[j+24>>3];p[a>>3]=aa*+p[j>>3];p[a+8>>3]=ba;p[a+16>>3]=ca;p[a+24>>3]=da;a=f[n>>2]|0;if((a|0)!=(z|0)){if(a|0)QYa(a);f[n>>2]=z;f[y>>2]=264}y=i+36|0;z=f[y>>2]|0;if(z|0?(n=z+12|0,z=f[n>>2]|0,f[n>>2]=z+-1,(z|0)==1):0)CR(i);f[y>>2]=0;y=i+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[y>>2]|0)>0){w=f[i+40>>2]|0;z=0;do{f[w+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[y>>2]|0))}y=f[i+44>>2]|0;if((y|0)!=(i+48|0))ZF(y);y=h+36|0;i=f[y>>2]|0;if(i|0?(z=i+12|0,i=f[z>>2]|0,f[z>>2]=i+-1,(i|0)==1):0)CR(h);f[y>>2]=0;y=h+16|0;i=h+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[i>>2]|0)>0){y=f[h+40>>2]|0;z=0;do{f[y+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)!=(h+48|0))ZF(i);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function iZ(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0;g=u;u=u+1360|0;h=g+1344|0;i=g+1288|0;j=g+1232|0;k=g+1216|0;l=g+1208|0;m=g+1176|0;n=g+16|0;o=g;q=g+1120|0;r=g+1112|0;_$(h,42984);do if((NS(a)|0)==65536){s=f[a+4>>2]|0;f[i>>2]=f[s>>2];t=i+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=i+8|0;f[w>>2]=f[s+8>>2];f[i+12>>2]=f[s+12>>2];f[i+16>>2]=f[s+16>>2];f[i+20>>2]=f[s+20>>2];f[i+24>>2]=f[s+24>>2];f[i+28>>2]=f[s+28>>2];f[i+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[i+36>>2]=x;f[i+40>>2]=w;w=i+48|0;y=i+44|0;f[y>>2]=w;f[w>>2]=0;f[i+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[t>>2]=0;BR(i,s);break}}else OR(i,a,-1);while(0);do if((NS(e)|0)==65536){a=f[e+4>>2]|0;f[j>>2]=f[a>>2];s=j+4|0;t=a+4|0;f[s>>2]=f[t>>2];v=j+8|0;f[v>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];w=j+16|0;f[w>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];y=f[a+36>>2]|0;f[j+36>>2]=y;f[j+40>>2]=v;v=j+48|0;x=j+44|0;f[x>>2]=v;f[v>>2]=0;f[j+52>>2]=0;if(y|0){v=y+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[a+44>>2]|0;v=f[x>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];z=w;break}else{f[s>>2]=0;BR(j,a);z=w;break}}else{OR(j,e,-1);z=j+16|0}while(0);if(f[z>>2]|0){e=f[j+4>>2]|0;if((e|0)<3)A=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{w=f[j+40>>2]|0;a=0;s=1;while(1){t=Y(f[w+(a<<2)>>2]|0,s)|0;a=a+1|0;if((a|0)==(e|0)){A=t;break}else s=t}}if(!((e|0)==0|(A|0)==0)?f[j>>2]&4095|0:0){f[k>>2]=0;f[k+4>>2]=0;B=c$(k,72)|0;C=312258;D=B+72|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));j$(-215,k,188720,188515,1869);d$(k)}}A=f[i>>2]|0;e=A>>>3;s=e&511;a=s+1|0;w=A&7;A=f[43004+(w<<2)>>2]|0;if((w|0)==7){f[k>>2]=0;f[k+4>>2]=0;B=c$(k,9)|0;C=323538;D=B+9|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));j$(-215,k,188720,188515,1880);d$(k)}f[k>>2]=i;f[k+4>>2]=j;f[k+8>>2]=0;bU(m,k,l,-1);k=f[m+20>>2]|0;t=n+8|0;f[n>>2]=t;v=n+4|0;f[v>>2]=a<<2;if(a>>>0>34){x=OYa(a<<5)|0;f[n>>2]=x;E=x}else E=t;x=E+(a<<3)|0;y=w>>>0<4;F=0;do{p[x+(F<<3)>>3]=0.0;p[E+(F<<3)>>3]=0.0;F=F+1|0}while((F|0)!=(a|0));F=w>>>0<2;if(y){w=(k|0)<32768;G=x+(a<<3)|0;H=F?G+(a<<2)|0:x;I=0;do{f[H+(I<<2)>>2]=0;f[G+(I<<2)>>2]=0;I=I+1|0}while((I|0)!=(a|0));I=w?k:32768;w=f[i+4>>2]|0;if((w|0)>0){J=I;K=f[(f[i+44>>2]|0)+(w+-1<<2)>>2]|0;L=32768;N=G;O=H}else{J=I;K=0;L=32768;N=G;O=H}}else{J=k;K=0;L=0;N=E;O=x}H=m+16|0;G=(k|0)>0;I=l+4|0;w=0;P=0;Q=0;while(1){if(P>>>0>=(f[H>>2]|0)>>>0)break;R=P+1|0;a:do if(G){S=f[l>>2]|0;T=f[I>>2]|0;if(y){U=S;V=T;W=w;X=0;Z=Q}else{_=S;S=T;T=w;$=0;aa=Q;while(1){ba=k-$|0;ca=(J|0)<(ba|0)?J:ba;ba=bg[A&127](_,S,N,O,ca,a)|0;da=ba+T|0;ea=ba+aa|0;ba=Y(ca,K)|0;_=(f[l>>2]|0)+ba|0;f[l>>2]=_;ba=f[I>>2]|0;if(!ba)fa=0;else{ga=ba+ca|0;f[I>>2]=ga;fa=ga}$=$+J|0;if((k|0)<=($|0)){ha=da;ia=ea;break a}else{S=fa;T=da;aa=ea}}}while(1){aa=k-X|0;T=(J|0)<(aa|0)?J:aa;aa=bg[A&127](U,V,N,O,T,a)|0;S=aa+W|0;$=aa+Z|0;if((S+J|0)<(L|0)?((T+X|0)<(k|0)?1:R>>>0<(f[H>>2]|0)>>>0):0)ja=S;else{ka=0;la=40}if((la|0)==40){while(1){la=0;S=N+(ka<<2)|0;aa=E+(ka<<3)|0;p[aa>>3]=+p[aa>>3]+ +(f[S>>2]|0);f[S>>2]=0;ka=ka+1|0;if((ka|0)==(a|0))break;else la=40}if(F){S=0;do{aa=O+(S<<2)|0;_=x+(S<<3)|0;p[_>>3]=+p[_>>3]+ +(f[aa>>2]|0);f[aa>>2]=0;S=S+1|0}while((S|0)!=(a|0));ja=0}else ja=0}S=Y(T,K)|0;U=(f[l>>2]|0)+S|0;f[l>>2]=U;S=f[I>>2]|0;if(!S)ma=0;else{aa=S+T|0;f[I>>2]=aa;ma=aa}X=X+J|0;if((k|0)<=(X|0)){ha=ja;ia=$;break}else{V=ma;W=ja;Z=$}}}else{ha=w;ia=Q}while(0);tR(m)|0;w=ha;P=R;Q=ia}na=(Q|0)==0?0.0:1.0/+(Q|0);Q=0;do{ia=E+(Q<<3)|0;oa=na*+p[ia>>3];p[ia>>3]=oa;ia=x+(Q<<3)|0;pa=na*+p[ia>>3]-oa*oa;oa=+M(+(pa<0.0?0.0:pa));p[ia>>3]=oa;Q=Q+1|0}while((Q|0)!=(a|0));Q=o+8|0;ia=o+12|0;P=o+4|0;ha=q+4|0;w=q+8|0;m=q+12|0;Z=q+16|0;ja=q+20|0;W=q+24|0;ma=q+28|0;V=q+32|0;X=q+36|0;k=q+40|0;J=q+48|0;I=q+44|0;U=q+52|0;l=r+4|0;K=(e|536870400)^511;e=0;do{O=(e|0)==0;F=O?E:x;ka=O?c:d;O=ka;N=f[O+4>>2]|0;H=o;f[H>>2]=f[O>>2];f[H+4>>2]=N;f[Q>>2]=f[ka+8>>2];f[ia>>2]=f[ka+12>>2];if(dT(o)|0){if(!($S(o)|0))pS(o,a,1,6,-1,1,0);do if((NS(o)|0)==65536){ka=f[P>>2]|0;f[q>>2]=f[ka>>2];N=ka+4|0;f[ha>>2]=f[N>>2];f[w>>2]=f[ka+8>>2];f[m>>2]=f[ka+12>>2];f[Z>>2]=f[ka+16>>2];f[ja>>2]=f[ka+20>>2];f[W>>2]=f[ka+24>>2];f[ma>>2]=f[ka+28>>2];f[V>>2]=f[ka+32>>2];H=f[ka+36>>2]|0;f[X>>2]=H;f[k>>2]=w;f[I>>2]=J;f[J>>2]=0;f[U>>2]=0;if(H|0){O=H+12|0;f[O>>2]=(f[O>>2]|0)+1}if((f[N>>2]|0)<3){N=f[ka+44>>2]|0;O=f[I>>2]|0;f[O>>2]=f[N>>2];f[O+4>>2]=f[N+4>>2];break}else{f[ha>>2]=0;BR(q,ka);break}}else OR(q,o,-1);while(0);R=f[ha>>2]|0;if((R|0)<3)qa=Y(f[m>>2]|0,f[w>>2]|0)|0;else{ka=f[k>>2]|0;N=0;O=1;while(1){H=Y(f[ka+(N<<2)>>2]|0,O)|0;N=N+1|0;if((N|0)==(R|0)){qa=H;break}else O=H}}do if((f[q>>2]&20479|0)==16390)if((f[m>>2]|0)==1)if((qa|0)>(s|0))break;else{la=71;break}else if((qa|0)<=(s|0)|(f[w>>2]|0)!=1){la=71;break}else break;else la=71;while(0);if((la|0)==71){la=0;f[r>>2]=0;f[l>>2]=0;B=c$(r,86)|0;C=188731;D=B+86|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));j$(-215,r,188720,188515,1958);d$(r)}O=f[Z>>2]|0;R=0;do{p[O+(R<<3)>>3]=+p[F+(R<<3)>>3];R=R+1|0}while((R|0)!=(a|0));if((a|0)<(qa|0))F1a(O+(a<<3)|0,0,K+qa<<3|0)|0;R=f[X>>2]|0;if(R|0?(F=R+12|0,R=f[F>>2]|0,f[F>>2]=R+-1,(R|0)==1):0)CR(q);f[X>>2]=0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[ha>>2]|0)>0){R=f[k>>2]|0;F=0;do{f[R+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[ha>>2]|0))}F=f[I>>2]|0;if((F|0)!=(J|0))ZF(F)}e=e+1|0}while((e|0)<2);e=f[n>>2]|0;if((e|0)!=(t|0)){if(e|0)QYa(e);f[n>>2]=t;f[v>>2]=136}v=j+36|0;t=f[v>>2]|0;if(t|0?(n=t+12|0,t=f[n>>2]|0,f[n>>2]=t+-1,(t|0)==1):0)CR(j);f[v>>2]=0;v=j+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[v>>2]|0)>0){z=f[j+40>>2]|0;t=0;do{f[z+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[v>>2]|0))}v=f[j+44>>2]|0;if((v|0)!=(j+48|0))ZF(v);v=i+36|0;j=f[v>>2]|0;if(j|0?(t=j+12|0,j=f[t>>2]|0,f[t>>2]=j+-1,(j|0)==1):0)CR(i);f[v>>2]=0;v=i+16|0;j=i+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[j>>2]|0)>0){v=f[i+40>>2]|0;t=0;do{f[v+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))ZF(j);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function jZ(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0;if(!c){j=(i|0)%4|0;switch(j|0){case 1:{k=f[d>>2]|0;l=f[e>>2]|0;if((g|0)>0){m=0;n=k;o=l;p=a;while(1){q=h[p>>0]|0;r=q+n|0;s=(Y(q,q)|0)+o|0;m=m+1|0;if((m|0)==(g|0)){t=g;u=r;v=s;break}else{n=r;o=s;p=p+i|0}}}else{t=0;u=k;v=l}f[d>>2]=u;f[e>>2]=v;w=t;break}case 2:{t=f[d>>2]|0;v=d+4|0;u=f[v>>2]|0;l=f[e>>2]|0;k=e+4|0;p=f[k>>2]|0;if((g|0)>0){o=0;n=t;m=u;s=l;r=p;q=a;while(1){x=h[q>>0]|0;y=x+n|0;z=(Y(x,x)|0)+s|0;x=h[q+1>>0]|0;A=x+m|0;B=(Y(x,x)|0)+r|0;o=o+1|0;if((o|0)==(g|0)){C=g;D=y;E=A;F=z;G=B;break}else{n=y;m=A;s=z;r=B;q=q+i|0}}}else{C=0;D=t;E=u;F=l;G=p}f[d>>2]=D;f[v>>2]=E;f[e>>2]=F;f[k>>2]=G;w=C;break}case 3:{C=f[d>>2]|0;G=d+4|0;k=f[G>>2]|0;F=d+8|0;E=f[F>>2]|0;v=f[e>>2]|0;D=e+4|0;p=f[D>>2]|0;l=e+8|0;u=f[l>>2]|0;if((g|0)>0){t=0;q=C;r=k;s=E;m=v;n=p;o=u;B=a;while(1){z=h[B>>0]|0;A=z+q|0;y=(Y(z,z)|0)+m|0;z=h[B+1>>0]|0;x=z+r|0;H=(Y(z,z)|0)+n|0;z=h[B+2>>0]|0;I=z+s|0;J=(Y(z,z)|0)+o|0;t=t+1|0;if((t|0)==(g|0)){K=g;L=A;M=x;N=I;O=y;P=H;Q=J;break}else{q=A;r=x;s=I;m=y;n=H;o=J;B=B+i|0}}}else{K=0;L=C;M=k;N=E;O=v;P=p;Q=u}f[d>>2]=L;f[G>>2]=M;f[F>>2]=N;f[e>>2]=O;f[D>>2]=P;f[l>>2]=Q;w=K;break}default:w=0}if((j|0)<(i|0)){R=w;S=j}else{T=g;return T|0}while(1){j=d+(S<<2)|0;w=f[j>>2]|0;K=S+1|0;Q=d+(K<<2)|0;l=f[Q>>2]|0;P=S+2|0;D=d+(P<<2)|0;O=f[D>>2]|0;N=S+3|0;F=d+(N<<2)|0;M=f[F>>2]|0;G=e+(S<<2)|0;L=f[G>>2]|0;u=e+(K<<2)|0;K=f[u>>2]|0;p=e+(P<<2)|0;P=f[p>>2]|0;v=e+(N<<2)|0;N=f[v>>2]|0;if((R|0)<(g|0)){E=R;k=w;C=l;B=O;o=M;n=L;m=K;s=P;r=N;q=a+S|0;while(1){t=h[q>>0]|0;J=t+k|0;H=(Y(t,t)|0)+n|0;t=h[q+1>>0]|0;y=t+C|0;I=(Y(t,t)|0)+m|0;t=h[q+2>>0]|0;x=t+B|0;A=(Y(t,t)|0)+s|0;t=h[q+3>>0]|0;z=t+o|0;U=(Y(t,t)|0)+r|0;E=E+1|0;if((E|0)==(g|0)){V=g;W=J;X=y;Z=x;_=z;$=H;aa=I;ba=A;ca=U;break}else{k=J;C=y;B=x;o=z;n=H;m=I;s=A;r=U;q=q+i|0}}}else{V=R;W=w;X=l;Z=O;_=M;$=L;aa=K;ba=P;ca=N}f[j>>2]=W;f[Q>>2]=X;f[D>>2]=Z;f[F>>2]=_;f[G>>2]=$;f[u>>2]=aa;f[p>>2]=ba;f[v>>2]=ca;S=S+4|0;if((S|0)>=(i|0)){T=g;break}else R=V}return T|0}switch(i|0){case 1:{V=f[d>>2]|0;R=f[e>>2]|0;if((g|0)>0){S=0;ca=0;ba=V;aa=R;while(1){if(!(b[c+S>>0]|0)){da=ca;ea=ba;fa=aa}else{$=h[a+S>>0]|0;da=ca+1|0;ea=$+ba|0;fa=(Y($,$)|0)+aa|0}S=S+1|0;if((S|0)==(g|0)){ga=da;ha=ea;ia=fa;break}else{ca=da;ba=ea;aa=fa}}}else{ga=0;ha=V;ia=R}f[d>>2]=ha;f[e>>2]=ia;T=ga;return T|0}case 3:{ga=f[d>>2]|0;ia=d+4|0;ha=f[ia>>2]|0;R=d+8|0;V=f[R>>2]|0;fa=f[e>>2]|0;aa=e+4|0;ea=f[aa>>2]|0;ba=e+8|0;da=f[ba>>2]|0;if((g|0)>0){ca=0;S=0;$=ga;_=ha;Z=V;X=fa;W=ea;q=da;r=a;while(1){if(!(b[c+ca>>0]|0)){ja=S;ka=$;la=_;ma=Z;na=X;oa=W;pa=q}else{s=h[r>>0]|0;m=h[r+1>>0]|0;n=h[r+2>>0]|0;ja=S+1|0;ka=s+$|0;la=m+_|0;ma=n+Z|0;na=(Y(s,s)|0)+X|0;oa=(Y(m,m)|0)+W|0;pa=(Y(n,n)|0)+q|0}ca=ca+1|0;if((ca|0)==(g|0)){qa=ja;ra=ka;sa=la;ta=ma;ua=na;va=oa;wa=pa;break}else{S=ja;$=ka;_=la;Z=ma;X=na;W=oa;q=pa;r=r+3|0}}}else{qa=0;ra=ga;sa=ha;ta=V;ua=fa;va=ea;wa=da}f[d>>2]=ra;f[ia>>2]=sa;f[R>>2]=ta;f[e>>2]=ua;f[aa>>2]=va;f[ba>>2]=wa;T=qa;return T|0}default:{if((g|0)<=0){T=0;return T|0}if((i|0)>0){xa=0;ya=0;za=a}else{a=0;qa=0;while(1){wa=((b[c+a>>0]|0)!=0&1)+qa|0;a=a+1|0;if((a|0)==(g|0)){T=wa;break}else qa=wa}return T|0}while(1){if(!(b[c+xa>>0]|0))Aa=ya;else{qa=0;do{a=d+(qa<<2)|0;wa=h[za+qa>>0]|0;ba=e+(qa<<2)|0;va=(f[ba>>2]|0)+(Y(wa,wa)|0)|0;f[a>>2]=(f[a>>2]|0)+wa;f[ba>>2]=va;qa=qa+1|0}while((qa|0)!=(i|0));Aa=ya+1|0}xa=xa+1|0;if((xa|0)==(g|0)){T=Aa;break}else{ya=Aa;za=za+i|0}}return T|0}}return 0}function kZ(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;if(!c){i=(h|0)%4|0;switch(i|0){case 1:{j=f[d>>2]|0;k=f[e>>2]|0;if((g|0)>0){l=0;m=j;n=k;o=a;while(1){p=b[o>>0]|0;q=p+m|0;r=(Y(p,p)|0)+n|0;l=l+1|0;if((l|0)==(g|0)){s=g;t=q;u=r;break}else{m=q;n=r;o=o+h|0}}}else{s=0;t=j;u=k}f[d>>2]=t;f[e>>2]=u;v=s;break}case 2:{s=f[d>>2]|0;u=d+4|0;t=f[u>>2]|0;k=f[e>>2]|0;j=e+4|0;o=f[j>>2]|0;if((g|0)>0){n=0;m=s;l=t;r=k;q=o;p=a;while(1){w=b[p>>0]|0;x=w+m|0;y=(Y(w,w)|0)+r|0;w=b[p+1>>0]|0;z=w+l|0;A=(Y(w,w)|0)+q|0;n=n+1|0;if((n|0)==(g|0)){B=g;C=x;D=z;E=y;F=A;break}else{m=x;l=z;r=y;q=A;p=p+h|0}}}else{B=0;C=s;D=t;E=k;F=o}f[d>>2]=C;f[u>>2]=D;f[e>>2]=E;f[j>>2]=F;v=B;break}case 3:{B=f[d>>2]|0;F=d+4|0;j=f[F>>2]|0;E=d+8|0;D=f[E>>2]|0;u=f[e>>2]|0;C=e+4|0;o=f[C>>2]|0;k=e+8|0;t=f[k>>2]|0;if((g|0)>0){s=0;p=B;q=j;r=D;l=u;m=o;n=t;A=a;while(1){y=b[A>>0]|0;z=y+p|0;x=(Y(y,y)|0)+l|0;y=b[A+1>>0]|0;w=y+q|0;G=(Y(y,y)|0)+m|0;y=b[A+2>>0]|0;H=y+r|0;I=(Y(y,y)|0)+n|0;s=s+1|0;if((s|0)==(g|0)){J=g;K=z;L=w;M=H;N=x;O=G;P=I;break}else{p=z;q=w;r=H;l=x;m=G;n=I;A=A+h|0}}}else{J=0;K=B;L=j;M=D;N=u;O=o;P=t}f[d>>2]=K;f[F>>2]=L;f[E>>2]=M;f[e>>2]=N;f[C>>2]=O;f[k>>2]=P;v=J;break}default:v=0}if((i|0)<(h|0)){Q=v;R=i}else{S=g;return S|0}while(1){i=d+(R<<2)|0;v=f[i>>2]|0;J=R+1|0;P=d+(J<<2)|0;k=f[P>>2]|0;O=R+2|0;C=d+(O<<2)|0;N=f[C>>2]|0;M=R+3|0;E=d+(M<<2)|0;L=f[E>>2]|0;F=e+(R<<2)|0;K=f[F>>2]|0;t=e+(J<<2)|0;J=f[t>>2]|0;o=e+(O<<2)|0;O=f[o>>2]|0;u=e+(M<<2)|0;M=f[u>>2]|0;if((Q|0)<(g|0)){D=Q;j=v;B=k;A=N;n=L;m=K;l=J;r=O;q=M;p=a+R|0;while(1){s=b[p>>0]|0;I=s+j|0;G=(Y(s,s)|0)+m|0;s=b[p+1>>0]|0;x=s+B|0;H=(Y(s,s)|0)+l|0;s=b[p+2>>0]|0;w=s+A|0;z=(Y(s,s)|0)+r|0;s=b[p+3>>0]|0;y=s+n|0;T=(Y(s,s)|0)+q|0;D=D+1|0;if((D|0)==(g|0)){U=g;V=I;W=x;X=w;Z=y;_=G;$=H;aa=z;ba=T;break}else{j=I;B=x;A=w;n=y;m=G;l=H;r=z;q=T;p=p+h|0}}}else{U=Q;V=v;W=k;X=N;Z=L;_=K;$=J;aa=O;ba=M}f[i>>2]=V;f[P>>2]=W;f[C>>2]=X;f[E>>2]=Z;f[F>>2]=_;f[t>>2]=$;f[o>>2]=aa;f[u>>2]=ba;R=R+4|0;if((R|0)>=(h|0)){S=g;break}else Q=U}return S|0}switch(h|0){case 1:{U=f[d>>2]|0;Q=f[e>>2]|0;if((g|0)>0){R=0;ba=0;aa=U;$=Q;while(1){if(!(b[c+R>>0]|0)){ca=ba;da=aa;ea=$}else{_=b[a+R>>0]|0;ca=ba+1|0;da=_+aa|0;ea=(Y(_,_)|0)+$|0}R=R+1|0;if((R|0)==(g|0)){fa=ca;ga=da;ha=ea;break}else{ba=ca;aa=da;$=ea}}}else{fa=0;ga=U;ha=Q}f[d>>2]=ga;f[e>>2]=ha;S=fa;return S|0}case 3:{fa=f[d>>2]|0;ha=d+4|0;ga=f[ha>>2]|0;Q=d+8|0;U=f[Q>>2]|0;ea=f[e>>2]|0;$=e+4|0;da=f[$>>2]|0;aa=e+8|0;ca=f[aa>>2]|0;if((g|0)>0){ba=0;R=0;_=fa;Z=ga;X=U;W=ea;V=da;p=ca;q=a;while(1){if(!(b[c+ba>>0]|0)){ia=R;ja=_;ka=Z;la=X;ma=W;na=V;oa=p}else{r=b[q>>0]|0;l=b[q+1>>0]|0;m=b[q+2>>0]|0;ia=R+1|0;ja=r+_|0;ka=l+Z|0;la=m+X|0;ma=(Y(r,r)|0)+W|0;na=(Y(l,l)|0)+V|0;oa=(Y(m,m)|0)+p|0}ba=ba+1|0;if((ba|0)==(g|0)){pa=ia;qa=ja;ra=ka;sa=la;ta=ma;ua=na;va=oa;break}else{R=ia;_=ja;Z=ka;X=la;W=ma;V=na;p=oa;q=q+3|0}}}else{pa=0;qa=fa;ra=ga;sa=U;ta=ea;ua=da;va=ca}f[d>>2]=qa;f[ha>>2]=ra;f[Q>>2]=sa;f[e>>2]=ta;f[$>>2]=ua;f[aa>>2]=va;S=pa;return S|0}default:{if((g|0)<=0){S=0;return S|0}if((h|0)>0){wa=0;xa=0;ya=a}else{a=0;pa=0;while(1){va=((b[c+a>>0]|0)!=0&1)+pa|0;a=a+1|0;if((a|0)==(g|0)){S=va;break}else pa=va}return S|0}while(1){if(!(b[c+wa>>0]|0))za=xa;else{pa=0;do{a=d+(pa<<2)|0;va=b[ya+pa>>0]|0;aa=e+(pa<<2)|0;ua=(f[aa>>2]|0)+(Y(va,va)|0)|0;f[a>>2]=(f[a>>2]|0)+va;f[aa>>2]=ua;pa=pa+1|0}while((pa|0)!=(h|0));za=xa+1|0}wa=wa+1|0;if((wa|0)==(g|0)){S=za;break}else{xa=za;ya=ya+h|0}}return S|0}}return 0}function lZ(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0.0,ha=0,ia=0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0,za=0,Aa=0,Ba=0;if(!c){j=(i|0)%4|0;switch(j|0){case 1:{k=f[e>>2]|0;l=+p[g>>3];if((h|0)>0){m=0;n=k;o=l;q=a;while(1){r=d[q>>1]|0;s=(r&65535)+n|0;t=+(r&65535);u=o+t*t;m=m+1|0;if((m|0)==(h|0)){v=h;w=s;x=u;break}else{n=s;o=u;q=q+(i<<1)|0}}}else{v=0;w=k;x=l}f[e>>2]=w;p[g>>3]=x;y=v;break}case 2:{v=f[e>>2]|0;w=e+4|0;k=f[w>>2]|0;x=+p[g>>3];q=g+8|0;l=+p[q>>3];if((h|0)>0){n=0;m=v;s=k;o=x;u=l;r=a;while(1){z=d[r>>1]|0;A=d[r+2>>1]|0;B=(z&65535)+m|0;t=+(z&65535);C=o+t*t;z=(A&65535)+s|0;t=+(A&65535);D=u+t*t;n=n+1|0;if((n|0)==(h|0)){E=h;F=B;G=z;H=C;I=D;break}else{m=B;s=z;o=C;u=D;r=r+(i<<1)|0}}}else{E=0;F=v;G=k;H=x;I=l}f[e>>2]=F;f[w>>2]=G;p[g>>3]=H;p[q>>3]=I;y=E;break}case 3:{E=f[e>>2]|0;q=e+4|0;G=f[q>>2]|0;w=e+8|0;F=f[w>>2]|0;I=+p[g>>3];k=g+8|0;H=+p[k>>3];v=g+16|0;l=+p[v>>3];if((h|0)>0){r=0;s=E;m=G;n=F;x=I;u=H;o=l;z=a;while(1){B=d[z>>1]|0;A=d[z+2>>1]|0;J=d[z+4>>1]|0;K=(B&65535)+s|0;D=+(B&65535);C=x+D*D;B=(A&65535)+m|0;D=+(A&65535);t=u+D*D;A=(J&65535)+n|0;D=+(J&65535);L=o+D*D;r=r+1|0;if((r|0)==(h|0)){M=h;N=K;O=B;P=A;Q=C;R=t;S=L;break}else{s=K;m=B;n=A;x=C;u=t;o=L;z=z+(i<<1)|0}}}else{M=0;N=E;O=G;P=F;Q=I;R=H;S=l}f[e>>2]=N;f[q>>2]=O;f[w>>2]=P;p[g>>3]=Q;p[k>>3]=R;p[v>>3]=S;y=M;break}default:y=0}if((j|0)<(i|0)){T=y;U=j}else{V=h;return V|0}while(1){j=e+(U<<2)|0;y=f[j>>2]|0;M=U+1|0;v=e+(M<<2)|0;k=f[v>>2]|0;P=U+2|0;w=e+(P<<2)|0;O=f[w>>2]|0;q=U+3|0;N=e+(q<<2)|0;F=f[N>>2]|0;G=g+(U<<3)|0;S=+p[G>>3];E=g+(M<<3)|0;R=+p[E>>3];M=g+(P<<3)|0;Q=+p[M>>3];P=g+(q<<3)|0;l=+p[P>>3];if((T|0)<(h|0)){q=T;z=y;n=k;m=O;s=F;H=S;I=R;o=Q;u=l;r=a+(U<<1)|0;while(1){A=d[r>>1]|0;B=d[r+2>>1]|0;K=(A&65535)+z|0;x=+(A&65535);L=H+x*x;A=(B&65535)+n|0;x=+(B&65535);t=I+x*x;B=d[r+4>>1]|0;J=d[r+6>>1]|0;W=(B&65535)+m|0;x=+(B&65535);C=o+x*x;B=(J&65535)+s|0;x=+(J&65535);D=u+x*x;q=q+1|0;if((q|0)==(h|0)){X=h;Y=K;Z=A;_=W;$=B;aa=L;ba=t;ca=C;da=D;break}else{z=K;n=A;m=W;s=B;H=L;I=t;o=C;u=D;r=r+(i<<1)|0}}}else{X=T;Y=y;Z=k;_=O;$=F;aa=S;ba=R;ca=Q;da=l}f[j>>2]=Y;f[v>>2]=Z;f[w>>2]=_;f[N>>2]=$;p[G>>3]=aa;p[E>>3]=ba;p[M>>3]=ca;p[P>>3]=da;U=U+4|0;if((U|0)>=(i|0)){V=h;break}else T=X}return V|0}switch(i|0){case 1:{X=f[e>>2]|0;da=+p[g>>3];if((h|0)>0){T=0;U=0;$=X;ca=da;while(1){if(!(b[c+T>>0]|0)){ea=U;fa=$;ga=ca}else{_=d[a+(T<<1)>>1]|0;ba=+(_&65535);ea=U+1|0;fa=(_&65535)+$|0;ga=ca+ba*ba}T=T+1|0;if((T|0)==(h|0)){ha=ea;ia=fa;ja=ga;break}else{U=ea;$=fa;ca=ga}}}else{ha=0;ia=X;ja=da}f[e>>2]=ia;p[g>>3]=ja;V=ha;return V|0}case 3:{ha=f[e>>2]|0;ia=e+4|0;X=f[ia>>2]|0;fa=e+8|0;$=f[fa>>2]|0;ja=+p[g>>3];ea=g+8|0;da=+p[ea>>3];U=g+16|0;ga=+p[U>>3];if((h|0)>0){T=0;_=0;Z=ha;Y=X;r=$;ca=ja;ba=da;aa=ga;s=a;while(1){if(!(b[c+T>>0]|0)){ka=_;la=Z;ma=Y;na=r;oa=ca;pa=ba;qa=aa}else{m=d[s>>1]|0;n=d[s+2>>1]|0;z=d[s+4>>1]|0;u=+(m&65535);o=+(n&65535);I=+(z&65535);ka=_+1|0;la=(m&65535)+Z|0;ma=(n&65535)+Y|0;na=(z&65535)+r|0;oa=ca+u*u;pa=ba+o*o;qa=aa+I*I}T=T+1|0;if((T|0)==(h|0)){ra=ka;sa=la;ta=ma;ua=na;va=oa;wa=pa;xa=qa;break}else{_=ka;Z=la;Y=ma;r=na;ca=oa;ba=pa;aa=qa;s=s+6|0}}}else{ra=0;sa=ha;ta=X;ua=$;va=ja;wa=da;xa=ga}f[e>>2]=sa;f[ia>>2]=ta;f[fa>>2]=ua;p[g>>3]=va;p[ea>>3]=wa;p[U>>3]=xa;V=ra;return V|0}default:{if((h|0)<=0){V=0;return V|0}if((i|0)>0){ya=0;za=0;Aa=a}else{a=0;ra=0;while(1){U=((b[c+a>>0]|0)!=0&1)+ra|0;a=a+1|0;if((a|0)==(h|0)){V=U;break}else ra=U}return V|0}while(1){if(!(b[c+ya>>0]|0))Ba=za;else{ra=0;do{a=d[Aa+(ra<<1)>>1]|0;U=e+(ra<<2)|0;ea=g+(ra<<3)|0;xa=+(a&65535);wa=+p[ea>>3]+xa*xa;f[U>>2]=(f[U>>2]|0)+(a&65535);p[ea>>3]=wa;ra=ra+1|0}while((ra|0)!=(i|0));Ba=za+1|0}ya=ya+1|0;if((ya|0)==(h|0)){V=Ba;break}else{za=Ba;Aa=Aa+(i<<1)|0}}return V|0}}return 0}function mZ(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0.0,ha=0,ia=0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0,za=0,Aa=0,Ba=0;if(!c){j=(i|0)%4|0;switch(j|0){case 1:{k=f[e>>2]|0;l=+p[g>>3];if((h|0)>0){m=0;n=k;o=l;q=a;while(1){r=d[q>>1]|0;s=(r<<16>>16)+n|0;t=+(r<<16>>16);u=o+t*t;m=m+1|0;if((m|0)==(h|0)){v=h;w=s;x=u;break}else{n=s;o=u;q=q+(i<<1)|0}}}else{v=0;w=k;x=l}f[e>>2]=w;p[g>>3]=x;y=v;break}case 2:{v=f[e>>2]|0;w=e+4|0;k=f[w>>2]|0;x=+p[g>>3];q=g+8|0;l=+p[q>>3];if((h|0)>0){n=0;m=v;s=k;o=x;u=l;r=a;while(1){z=d[r>>1]|0;A=d[r+2>>1]|0;B=(z<<16>>16)+m|0;t=+(z<<16>>16);C=o+t*t;z=(A<<16>>16)+s|0;t=+(A<<16>>16);D=u+t*t;n=n+1|0;if((n|0)==(h|0)){E=h;F=B;G=z;H=C;I=D;break}else{m=B;s=z;o=C;u=D;r=r+(i<<1)|0}}}else{E=0;F=v;G=k;H=x;I=l}f[e>>2]=F;f[w>>2]=G;p[g>>3]=H;p[q>>3]=I;y=E;break}case 3:{E=f[e>>2]|0;q=e+4|0;G=f[q>>2]|0;w=e+8|0;F=f[w>>2]|0;I=+p[g>>3];k=g+8|0;H=+p[k>>3];v=g+16|0;l=+p[v>>3];if((h|0)>0){r=0;s=E;m=G;n=F;x=I;u=H;o=l;z=a;while(1){B=d[z>>1]|0;A=d[z+2>>1]|0;J=d[z+4>>1]|0;K=(B<<16>>16)+s|0;D=+(B<<16>>16);C=x+D*D;B=(A<<16>>16)+m|0;D=+(A<<16>>16);t=u+D*D;A=(J<<16>>16)+n|0;D=+(J<<16>>16);L=o+D*D;r=r+1|0;if((r|0)==(h|0)){M=h;N=K;O=B;P=A;Q=C;R=t;S=L;break}else{s=K;m=B;n=A;x=C;u=t;o=L;z=z+(i<<1)|0}}}else{M=0;N=E;O=G;P=F;Q=I;R=H;S=l}f[e>>2]=N;f[q>>2]=O;f[w>>2]=P;p[g>>3]=Q;p[k>>3]=R;p[v>>3]=S;y=M;break}default:y=0}if((j|0)<(i|0)){T=y;U=j}else{V=h;return V|0}while(1){j=e+(U<<2)|0;y=f[j>>2]|0;M=U+1|0;v=e+(M<<2)|0;k=f[v>>2]|0;P=U+2|0;w=e+(P<<2)|0;O=f[w>>2]|0;q=U+3|0;N=e+(q<<2)|0;F=f[N>>2]|0;G=g+(U<<3)|0;S=+p[G>>3];E=g+(M<<3)|0;R=+p[E>>3];M=g+(P<<3)|0;Q=+p[M>>3];P=g+(q<<3)|0;l=+p[P>>3];if((T|0)<(h|0)){q=T;z=y;n=k;m=O;s=F;H=S;I=R;o=Q;u=l;r=a+(U<<1)|0;while(1){A=d[r>>1]|0;B=d[r+2>>1]|0;K=(A<<16>>16)+z|0;x=+(A<<16>>16);L=H+x*x;A=(B<<16>>16)+n|0;x=+(B<<16>>16);t=I+x*x;B=d[r+4>>1]|0;J=d[r+6>>1]|0;W=(B<<16>>16)+m|0;x=+(B<<16>>16);C=o+x*x;B=(J<<16>>16)+s|0;x=+(J<<16>>16);D=u+x*x;q=q+1|0;if((q|0)==(h|0)){X=h;Y=K;Z=A;_=W;$=B;aa=L;ba=t;ca=C;da=D;break}else{z=K;n=A;m=W;s=B;H=L;I=t;o=C;u=D;r=r+(i<<1)|0}}}else{X=T;Y=y;Z=k;_=O;$=F;aa=S;ba=R;ca=Q;da=l}f[j>>2]=Y;f[v>>2]=Z;f[w>>2]=_;f[N>>2]=$;p[G>>3]=aa;p[E>>3]=ba;p[M>>3]=ca;p[P>>3]=da;U=U+4|0;if((U|0)>=(i|0)){V=h;break}else T=X}return V|0}switch(i|0){case 1:{X=f[e>>2]|0;da=+p[g>>3];if((h|0)>0){T=0;U=0;$=X;ca=da;while(1){if(!(b[c+T>>0]|0)){ea=U;fa=$;ga=ca}else{_=d[a+(T<<1)>>1]|0;ba=+(_<<16>>16);ea=U+1|0;fa=(_<<16>>16)+$|0;ga=ca+ba*ba}T=T+1|0;if((T|0)==(h|0)){ha=ea;ia=fa;ja=ga;break}else{U=ea;$=fa;ca=ga}}}else{ha=0;ia=X;ja=da}f[e>>2]=ia;p[g>>3]=ja;V=ha;return V|0}case 3:{ha=f[e>>2]|0;ia=e+4|0;X=f[ia>>2]|0;fa=e+8|0;$=f[fa>>2]|0;ja=+p[g>>3];ea=g+8|0;da=+p[ea>>3];U=g+16|0;ga=+p[U>>3];if((h|0)>0){T=0;_=0;Z=ha;Y=X;r=$;ca=ja;ba=da;aa=ga;s=a;while(1){if(!(b[c+T>>0]|0)){ka=_;la=Z;ma=Y;na=r;oa=ca;pa=ba;qa=aa}else{m=d[s>>1]|0;n=d[s+2>>1]|0;z=d[s+4>>1]|0;u=+(m<<16>>16);o=+(n<<16>>16);I=+(z<<16>>16);ka=_+1|0;la=(m<<16>>16)+Z|0;ma=(n<<16>>16)+Y|0;na=(z<<16>>16)+r|0;oa=ca+u*u;pa=ba+o*o;qa=aa+I*I}T=T+1|0;if((T|0)==(h|0)){ra=ka;sa=la;ta=ma;ua=na;va=oa;wa=pa;xa=qa;break}else{_=ka;Z=la;Y=ma;r=na;ca=oa;ba=pa;aa=qa;s=s+6|0}}}else{ra=0;sa=ha;ta=X;ua=$;va=ja;wa=da;xa=ga}f[e>>2]=sa;f[ia>>2]=ta;f[fa>>2]=ua;p[g>>3]=va;p[ea>>3]=wa;p[U>>3]=xa;V=ra;return V|0}default:{if((h|0)<=0){V=0;return V|0}if((i|0)>0){ya=0;za=0;Aa=a}else{a=0;ra=0;while(1){U=((b[c+a>>0]|0)!=0&1)+ra|0;a=a+1|0;if((a|0)==(h|0)){V=U;break}else ra=U}return V|0}while(1){if(!(b[c+ya>>0]|0))Ba=za;else{ra=0;do{a=d[Aa+(ra<<1)>>1]|0;U=e+(ra<<2)|0;ea=g+(ra<<3)|0;xa=+(a<<16>>16);wa=+p[ea>>3]+xa*xa;f[U>>2]=(f[U>>2]|0)+(a<<16>>16);p[ea>>3]=wa;ra=ra+1|0}while((ra|0)!=(i|0));Ba=za+1|0}ya=ya+1|0;if((ya|0)==(h|0)){V=Ba;break}else{za=Ba;Aa=Aa+(i<<1)|0}}return V|0}}return 0}function nZ(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0.0,ea=0.0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0,xa=0,ya=0,za=0;if(!c){i=(h|0)%4|0;switch(i|0){case 1:{j=+p[d>>3];k=+p[e>>3];if((g|0)>0){l=0;m=j;n=k;o=a;while(1){q=+(f[o>>2]|0);r=m+q;s=n+q*q;l=l+1|0;if((l|0)==(g|0)){t=g;u=r;v=s;break}else{m=r;n=s;o=o+(h<<2)|0}}}else{t=0;u=j;v=k}p[d>>3]=u;p[e>>3]=v;w=t;break}case 2:{v=+p[d>>3];t=d+8|0;u=+p[t>>3];k=+p[e>>3];o=e+8|0;j=+p[o>>3];if((g|0)>0){l=0;n=v;m=u;s=k;r=j;x=a;while(1){q=+(f[x>>2]|0);y=n+q;z=s+q*q;q=+(f[x+4>>2]|0);A=m+q;B=r+q*q;l=l+1|0;if((l|0)==(g|0)){C=g;D=y;E=A;F=z;G=B;break}else{n=y;m=A;s=z;r=B;x=x+(h<<2)|0}}}else{C=0;D=v;E=u;F=k;G=j}p[d>>3]=D;p[t>>3]=E;p[e>>3]=F;p[o>>3]=G;w=C;break}case 3:{G=+p[d>>3];C=d+8|0;F=+p[C>>3];o=d+16|0;E=+p[o>>3];D=+p[e>>3];t=e+8|0;j=+p[t>>3];x=e+16|0;k=+p[x>>3];if((g|0)>0){l=0;u=G;v=F;r=E;s=D;m=j;n=k;H=a;while(1){B=+(f[H>>2]|0);z=u+B;A=s+B*B;B=+(f[H+4>>2]|0);y=v+B;q=m+B*B;B=+(f[H+8>>2]|0);I=r+B;J=n+B*B;l=l+1|0;if((l|0)==(g|0)){K=g;L=z;M=y;N=I;O=A;P=q;Q=J;break}else{u=z;v=y;r=I;s=A;m=q;n=J;H=H+(h<<2)|0}}}else{K=0;L=G;M=F;N=E;O=D;P=j;Q=k}p[d>>3]=L;p[C>>3]=M;p[o>>3]=N;p[e>>3]=O;p[t>>3]=P;p[x>>3]=Q;w=K;break}default:w=0}if((i|0)<(h|0)){R=w;S=i}else{T=g;return T|0}while(1){i=d+(S<<3)|0;Q=+p[i>>3];w=S+1|0;K=d+(w<<3)|0;P=+p[K>>3];x=S+2|0;t=d+(x<<3)|0;O=+p[t>>3];o=S+3|0;C=d+(o<<3)|0;N=+p[C>>3];H=e+(S<<3)|0;M=+p[H>>3];l=e+(w<<3)|0;L=+p[l>>3];w=e+(x<<3)|0;k=+p[w>>3];x=e+(o<<3)|0;j=+p[x>>3];if((R|0)<(g|0)){o=R;D=Q;E=P;F=O;G=N;n=M;m=L;s=k;r=j;U=a+(S<<2)|0;while(1){v=+(f[U>>2]|0);u=D+v;J=n+v*v;v=+(f[U+4>>2]|0);q=E+v;A=m+v*v;v=+(f[U+8>>2]|0);I=F+v;y=s+v*v;v=+(f[U+12>>2]|0);z=G+v;B=r+v*v;o=o+1|0;if((o|0)==(g|0)){V=g;W=u;X=q;Y=I;Z=z;_=J;$=A;aa=y;ba=B;break}else{D=u;E=q;F=I;G=z;n=J;m=A;s=y;r=B;U=U+(h<<2)|0}}}else{V=R;W=Q;X=P;Y=O;Z=N;_=M;$=L;aa=k;ba=j}p[i>>3]=W;p[K>>3]=X;p[t>>3]=Y;p[C>>3]=Z;p[H>>3]=_;p[l>>3]=$;p[w>>3]=aa;p[x>>3]=ba;S=S+4|0;if((S|0)>=(h|0)){T=g;break}else R=V}return T|0}switch(h|0){case 1:{ba=+p[d>>3];aa=+p[e>>3];if((g|0)>0){V=0;R=0;$=ba;_=aa;while(1){if(!(b[c+V>>0]|0)){ca=R;da=$;ea=_}else{Z=+(f[a+(V<<2)>>2]|0);ca=R+1|0;da=$+Z;ea=_+Z*Z}V=V+1|0;if((V|0)==(g|0)){fa=ca;ga=da;ha=ea;break}else{R=ca;$=da;_=ea}}}else{fa=0;ga=ba;ha=aa}p[d>>3]=ga;p[e>>3]=ha;T=fa;return T|0}case 3:{ha=+p[d>>3];fa=d+8|0;ga=+p[fa>>3];ca=d+16|0;aa=+p[ca>>3];ba=+p[e>>3];R=e+8|0;ea=+p[R>>3];V=e+16|0;_=+p[V>>3];if((g|0)>0){S=0;U=0;da=ha;$=ga;Z=aa;Y=ba;X=ea;W=_;o=a;while(1){if(!(b[c+S>>0]|0)){ia=U;ja=da;ka=$;la=Z;ma=Y;na=X;oa=W}else{r=+(f[o>>2]|0);s=+(f[o+4>>2]|0);m=+(f[o+8>>2]|0);ia=U+1|0;ja=da+r;ka=$+s;la=Z+m;ma=Y+r*r;na=X+s*s;oa=W+m*m}S=S+1|0;if((S|0)==(g|0)){pa=ia;qa=ja;ra=ka;sa=la;ta=ma;ua=na;va=oa;break}else{U=ia;da=ja;$=ka;Z=la;Y=ma;X=na;W=oa;o=o+12|0}}}else{pa=0;qa=ha;ra=ga;sa=aa;ta=ba;ua=ea;va=_}p[d>>3]=qa;p[fa>>3]=ra;p[ca>>3]=sa;p[e>>3]=ta;p[R>>3]=ua;p[V>>3]=va;T=pa;return T|0}default:{if((g|0)<=0){T=0;return T|0}if((h|0)>0){wa=0;xa=0;ya=a}else{a=0;pa=0;while(1){V=((b[c+a>>0]|0)!=0&1)+pa|0;a=a+1|0;if((a|0)==(g|0)){T=V;break}else pa=V}return T|0}while(1){if(!(b[c+wa>>0]|0))za=xa;else{pa=0;do{a=d+(pa<<3)|0;va=+(f[ya+(pa<<2)>>2]|0);V=e+(pa<<3)|0;ua=+p[V>>3]+va*va;p[a>>3]=+p[a>>3]+va;p[V>>3]=ua;pa=pa+1|0}while((pa|0)!=(h|0));za=xa+1|0}wa=wa+1|0;if((wa|0)==(g|0)){T=za;break}else{xa=za;ya=ya+(h<<2)|0}}return T|0}}return 0}function oZ(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0.0,j=0.0,k=0,l=0.0,m=0.0,o=0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0.0,ea=0.0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0,xa=0,ya=0,za=0;if(!c){h=(g|0)%4|0;switch(h|0){case 1:{i=+p[d>>3];j=+p[e>>3];if((f|0)>0){k=0;l=i;m=j;o=a;while(1){q=+n[o>>2];r=l+q;s=m+q*q;k=k+1|0;if((k|0)==(f|0)){t=f;u=r;v=s;break}else{l=r;m=s;o=o+(g<<2)|0}}}else{t=0;u=i;v=j}p[d>>3]=u;p[e>>3]=v;w=t;break}case 2:{v=+p[d>>3];t=d+8|0;u=+p[t>>3];j=+p[e>>3];o=e+8|0;i=+p[o>>3];if((f|0)>0){k=0;m=v;l=u;s=j;r=i;x=a;while(1){q=+n[x>>2];y=m+q;z=s+q*q;q=+n[x+4>>2];A=l+q;B=r+q*q;k=k+1|0;if((k|0)==(f|0)){C=f;D=y;E=A;F=z;G=B;break}else{m=y;l=A;s=z;r=B;x=x+(g<<2)|0}}}else{C=0;D=v;E=u;F=j;G=i}p[d>>3]=D;p[t>>3]=E;p[e>>3]=F;p[o>>3]=G;w=C;break}case 3:{G=+p[d>>3];C=d+8|0;F=+p[C>>3];o=d+16|0;E=+p[o>>3];D=+p[e>>3];t=e+8|0;i=+p[t>>3];x=e+16|0;j=+p[x>>3];if((f|0)>0){k=0;u=G;v=F;r=E;s=D;l=i;m=j;H=a;while(1){B=+n[H>>2];z=u+B;A=s+B*B;B=+n[H+4>>2];y=v+B;q=l+B*B;B=+n[H+8>>2];I=r+B;J=m+B*B;k=k+1|0;if((k|0)==(f|0)){K=f;L=z;M=y;N=I;O=A;P=q;Q=J;break}else{u=z;v=y;r=I;s=A;l=q;m=J;H=H+(g<<2)|0}}}else{K=0;L=G;M=F;N=E;O=D;P=i;Q=j}p[d>>3]=L;p[C>>3]=M;p[o>>3]=N;p[e>>3]=O;p[t>>3]=P;p[x>>3]=Q;w=K;break}default:w=0}if((h|0)<(g|0)){R=w;S=h}else{T=f;return T|0}while(1){h=d+(S<<3)|0;Q=+p[h>>3];w=S+1|0;K=d+(w<<3)|0;P=+p[K>>3];x=S+2|0;t=d+(x<<3)|0;O=+p[t>>3];o=S+3|0;C=d+(o<<3)|0;N=+p[C>>3];H=e+(S<<3)|0;M=+p[H>>3];k=e+(w<<3)|0;L=+p[k>>3];w=e+(x<<3)|0;j=+p[w>>3];x=e+(o<<3)|0;i=+p[x>>3];if((R|0)<(f|0)){o=R;D=Q;E=P;F=O;G=N;m=M;l=L;s=j;r=i;U=a+(S<<2)|0;while(1){v=+n[U>>2];u=D+v;J=m+v*v;v=+n[U+4>>2];q=E+v;A=l+v*v;v=+n[U+8>>2];I=F+v;y=s+v*v;v=+n[U+12>>2];z=G+v;B=r+v*v;o=o+1|0;if((o|0)==(f|0)){V=f;W=u;X=q;Y=I;Z=z;_=J;$=A;aa=y;ba=B;break}else{D=u;E=q;F=I;G=z;m=J;l=A;s=y;r=B;U=U+(g<<2)|0}}}else{V=R;W=Q;X=P;Y=O;Z=N;_=M;$=L;aa=j;ba=i}p[h>>3]=W;p[K>>3]=X;p[t>>3]=Y;p[C>>3]=Z;p[H>>3]=_;p[k>>3]=$;p[w>>3]=aa;p[x>>3]=ba;S=S+4|0;if((S|0)>=(g|0)){T=f;break}else R=V}return T|0}switch(g|0){case 1:{ba=+p[d>>3];aa=+p[e>>3];if((f|0)>0){V=0;R=0;$=ba;_=aa;while(1){if(!(b[c+V>>0]|0)){ca=R;da=$;ea=_}else{Z=+n[a+(V<<2)>>2];ca=R+1|0;da=$+Z;ea=_+Z*Z}V=V+1|0;if((V|0)==(f|0)){fa=ca;ga=da;ha=ea;break}else{R=ca;$=da;_=ea}}}else{fa=0;ga=ba;ha=aa}p[d>>3]=ga;p[e>>3]=ha;T=fa;return T|0}case 3:{ha=+p[d>>3];fa=d+8|0;ga=+p[fa>>3];ca=d+16|0;aa=+p[ca>>3];ba=+p[e>>3];R=e+8|0;ea=+p[R>>3];V=e+16|0;_=+p[V>>3];if((f|0)>0){S=0;U=0;da=ha;$=ga;Z=aa;Y=ba;X=ea;W=_;o=a;while(1){if(!(b[c+S>>0]|0)){ia=U;ja=da;ka=$;la=Z;ma=Y;na=X;oa=W}else{r=+n[o>>2];s=+n[o+4>>2];l=+n[o+8>>2];ia=U+1|0;ja=da+r;ka=$+s;la=Z+l;ma=Y+r*r;na=X+s*s;oa=W+l*l}S=S+1|0;if((S|0)==(f|0)){pa=ia;qa=ja;ra=ka;sa=la;ta=ma;ua=na;va=oa;break}else{U=ia;da=ja;$=ka;Z=la;Y=ma;X=na;W=oa;o=o+12|0}}}else{pa=0;qa=ha;ra=ga;sa=aa;ta=ba;ua=ea;va=_}p[d>>3]=qa;p[fa>>3]=ra;p[ca>>3]=sa;p[e>>3]=ta;p[R>>3]=ua;p[V>>3]=va;T=pa;return T|0}default:{if((f|0)<=0){T=0;return T|0}if((g|0)>0){wa=0;xa=0;ya=a}else{a=0;pa=0;while(1){V=((b[c+a>>0]|0)!=0&1)+pa|0;a=a+1|0;if((a|0)==(f|0)){T=V;break}else pa=V}return T|0}while(1){if(!(b[c+wa>>0]|0))za=xa;else{pa=0;do{a=d+(pa<<3)|0;va=+n[ya+(pa<<2)>>2];V=e+(pa<<3)|0;ua=+p[V>>3]+va*va;p[a>>3]=+p[a>>3]+va;p[V>>3]=ua;pa=pa+1|0}while((pa|0)!=(g|0));za=xa+1|0}wa=wa+1|0;if((wa|0)==(f|0)){T=za;break}else{xa=za;ya=ya+(g<<2)|0}}return T|0}}return 0}function pZ(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0,o=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0.0,I=0.0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0,xa=0,ya=0;if(!c){h=(g|0)%4|0;switch(h|0){case 1:{i=+p[d>>3];j=+p[e>>3];if((f|0)>0){k=0;l=i;m=j;n=a;while(1){o=+p[n>>3];q=l+o;r=m+o*o;k=k+1|0;if((k|0)==(f|0)){s=f;t=q;u=r;break}else{l=q;m=r;n=n+(g<<3)|0}}}else{s=0;t=i;u=j}p[d>>3]=t;p[e>>3]=u;v=s;break}case 2:{u=+p[d>>3];s=d+8|0;t=+p[s>>3];j=+p[e>>3];n=e+8|0;i=+p[n>>3];if((f|0)>0){k=0;m=u;l=t;r=j;q=i;w=a;while(1){o=+p[w>>3];x=+p[w+8>>3];y=m+o;z=r+o*o;o=l+x;A=q+x*x;k=k+1|0;if((k|0)==(f|0)){B=f;C=y;D=o;E=z;F=A;break}else{m=y;l=o;r=z;q=A;w=w+(g<<3)|0}}}else{B=0;C=u;D=t;E=j;F=i}p[d>>3]=C;p[s>>3]=D;p[e>>3]=E;p[n>>3]=F;v=B;break}case 3:{F=+p[d>>3];B=d+8|0;E=+p[B>>3];n=d+16|0;D=+p[n>>3];C=+p[e>>3];s=e+8|0;i=+p[s>>3];w=e+16|0;j=+p[w>>3];if((f|0)>0){k=0;t=F;u=E;q=D;r=C;l=i;m=j;G=a;while(1){A=+p[G>>3];z=+p[G+8>>3];o=+p[G+16>>3];y=t+A;x=r+A*A;A=u+z;H=l+z*z;z=q+o;I=m+o*o;k=k+1|0;if((k|0)==(f|0)){J=f;K=y;L=A;M=z;N=x;O=H;P=I;break}else{t=y;u=A;q=z;r=x;l=H;m=I;G=G+(g<<3)|0}}}else{J=0;K=F;L=E;M=D;N=C;O=i;P=j}p[d>>3]=K;p[B>>3]=L;p[n>>3]=M;p[e>>3]=N;p[s>>3]=O;p[w>>3]=P;v=J;break}default:v=0}if((h|0)<(g|0)){Q=v;R=h}else{S=f;return S|0}while(1){h=d+(R<<3)|0;P=+p[h>>3];v=R+1|0;J=d+(v<<3)|0;O=+p[J>>3];w=R+2|0;s=d+(w<<3)|0;N=+p[s>>3];n=R+3|0;B=d+(n<<3)|0;M=+p[B>>3];G=e+(R<<3)|0;L=+p[G>>3];k=e+(v<<3)|0;K=+p[k>>3];v=e+(w<<3)|0;j=+p[v>>3];w=e+(n<<3)|0;i=+p[w>>3];if((Q|0)<(f|0)){n=Q;C=P;D=O;E=N;F=M;m=L;l=K;r=j;q=i;T=a+(R<<3)|0;while(1){u=+p[T>>3];t=+p[T+8>>3];I=C+u;H=m+u*u;u=D+t;x=l+t*t;t=+p[T+16>>3];z=+p[T+24>>3];A=E+t;y=r+t*t;t=F+z;o=q+z*z;n=n+1|0;if((n|0)==(f|0)){U=f;V=I;W=u;X=A;Y=t;Z=H;_=x;$=y;aa=o;break}else{C=I;D=u;E=A;F=t;m=H;l=x;r=y;q=o;T=T+(g<<3)|0}}}else{U=Q;V=P;W=O;X=N;Y=M;Z=L;_=K;$=j;aa=i}p[h>>3]=V;p[J>>3]=W;p[s>>3]=X;p[B>>3]=Y;p[G>>3]=Z;p[k>>3]=_;p[v>>3]=$;p[w>>3]=aa;R=R+4|0;if((R|0)>=(g|0)){S=f;break}else Q=U}return S|0}switch(g|0){case 1:{aa=+p[d>>3];$=+p[e>>3];if((f|0)>0){U=0;Q=0;_=aa;Z=$;while(1){if(!(b[c+U>>0]|0)){ba=Q;ca=_;da=Z}else{Y=+p[a+(U<<3)>>3];ba=Q+1|0;ca=_+Y;da=Z+Y*Y}U=U+1|0;if((U|0)==(f|0)){ea=ba;fa=ca;ga=da;break}else{Q=ba;_=ca;Z=da}}}else{ea=0;fa=aa;ga=$}p[d>>3]=fa;p[e>>3]=ga;S=ea;return S|0}case 3:{ga=+p[d>>3];ea=d+8|0;fa=+p[ea>>3];ba=d+16|0;$=+p[ba>>3];aa=+p[e>>3];Q=e+8|0;da=+p[Q>>3];U=e+16|0;Z=+p[U>>3];if((f|0)>0){R=0;T=0;ca=ga;_=fa;Y=$;X=aa;W=da;V=Z;n=a;while(1){if(!(b[c+R>>0]|0)){ha=T;ia=ca;ja=_;ka=Y;la=X;ma=W;na=V}else{q=+p[n>>3];r=+p[n+8>>3];l=+p[n+16>>3];ha=T+1|0;ia=ca+q;ja=_+r;ka=Y+l;la=X+q*q;ma=W+r*r;na=V+l*l}R=R+1|0;if((R|0)==(f|0)){oa=ha;pa=ia;qa=ja;ra=ka;sa=la;ta=ma;ua=na;break}else{T=ha;ca=ia;_=ja;Y=ka;X=la;W=ma;V=na;n=n+24|0}}}else{oa=0;pa=ga;qa=fa;ra=$;sa=aa;ta=da;ua=Z}p[d>>3]=pa;p[ea>>3]=qa;p[ba>>3]=ra;p[e>>3]=sa;p[Q>>3]=ta;p[U>>3]=ua;S=oa;return S|0}default:{if((f|0)<=0){S=0;return S|0}if((g|0)>0){va=0;wa=0;xa=a}else{a=0;oa=0;while(1){U=((b[c+a>>0]|0)!=0&1)+oa|0;a=a+1|0;if((a|0)==(f|0)){S=U;break}else oa=U}return S|0}while(1){if(!(b[c+va>>0]|0))ya=wa;else{oa=0;do{ua=+p[xa+(oa<<3)>>3];a=d+(oa<<3)|0;U=e+(oa<<3)|0;ta=ua*ua+ +p[U>>3];p[a>>3]=ua+ +p[a>>3];p[U>>3]=ta;oa=oa+1|0}while((oa|0)!=(g|0));ya=wa+1|0}va=va+1|0;if((va|0)==(f|0)){S=ya;break}else{wa=ya;xa=xa+(g<<3)|0}}return S|0}}return 0}function qZ(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;i=u;u=u+224|0;j=i+208|0;k=i+152|0;l=i+96|0;m=i+80|0;o=i+72|0;q=i+40|0;r=i+36|0;s=i+32|0;t=i+28|0;v=i+24|0;w=i+20|0;x=i+16|0;y=i+8|0;z=i;_$(j,43036);A=RR(a,-1)|0;B=A&7;C=A>>>3&511;A=C+1|0;E=XS(h)|0;if(!C){if(!E?RR(h,-1)|0:0)F=5}else if((g|0)!=0|((e|0)!=0|E^1))F=5;if((F|0)==5){f[k>>2]=0;f[k+4>>2]=0;G=c$(k,100)|0;H=188888;I=G+100|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));j$(-215,k,188989,188515,2709);d$(k)}do if((NS(a)|0)==65536){F=f[a+4>>2]|0;f[k>>2]=f[F>>2];E=k+4|0;C=F+4|0;f[E>>2]=f[C>>2];J=k+8|0;f[J>>2]=f[F+8>>2];f[k+12>>2]=f[F+12>>2];f[k+16>>2]=f[F+16>>2];f[k+20>>2]=f[F+20>>2];f[k+24>>2]=f[F+24>>2];f[k+28>>2]=f[F+28>>2];f[k+32>>2]=f[F+32>>2];K=f[F+36>>2]|0;f[k+36>>2]=K;f[k+40>>2]=J;J=k+48|0;L=k+44|0;f[L>>2]=J;f[J>>2]=0;f[k+52>>2]=0;if(K|0){J=K+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[C>>2]|0)<3){C=f[F+44>>2]|0;J=f[L>>2]|0;f[J>>2]=f[C>>2];f[J+4>>2]=f[C+4>>2];break}else{f[E>>2]=0;BR(k,F);break}}else OR(k,a,-1);while(0);do if((NS(h)|0)==65536){a=f[h+4>>2]|0;f[l>>2]=f[a>>2];F=l+4|0;E=a+4|0;f[F>>2]=f[E>>2];C=l+8|0;f[C>>2]=f[a+8>>2];f[l+12>>2]=f[a+12>>2];f[l+16>>2]=f[a+16>>2];f[l+20>>2]=f[a+20>>2];f[l+24>>2]=f[a+24>>2];f[l+28>>2]=f[a+28>>2];f[l+32>>2]=f[a+32>>2];J=f[a+36>>2]|0;f[l+36>>2]=J;f[l+40>>2]=C;C=l+48|0;L=l+44|0;f[L>>2]=C;f[C>>2]=0;f[l+52>>2]=0;if(J|0){C=J+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[E>>2]|0)<3){E=f[a+44>>2]|0;C=f[L>>2]|0;f[C>>2]=f[E>>2];f[C+4>>2]=f[E+4>>2];break}else{f[F>>2]=0;BR(l,a);break}}else OR(l,h,-1);while(0);h=f[43056+(B<<2)>>2]|0;if((B|0)==7){f[m>>2]=0;f[m+4>>2]=0;G=c$(m,9)|0;H=323538;I=G+9|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));j$(-215,m,188989,188515,2722);d$(m)}f[m>>2]=k;f[m+4>>2]=l;f[m+8>>2]=0;bU(q,m,o,-1);f[r>>2]=0;f[s>>2]=0;f[t>>2]=2147483647;f[v>>2]=-2147483648;n[w>>2]=D;n[x>>2]=-D;p[y>>3]=D;p[z>>3]=-D;m=Y(f[q+20>>2]|0,A)|0;A=(B|0)==5;if(!A)if((B|0)==6){M=z;N=y}else{M=v;N=t}else{M=x;N=w}H=q+16|0;if(f[H>>2]|0){G=o+4|0;I=0;a=1;while(1){Oh[h&255](f[o>>2]|0,f[G>>2]|0,N,M,r,s,m,a);tR(q)|0;I=I+1|0;if(I>>>0>=(f[H>>2]|0)>>>0)break;else a=a+m|0}}m=k+16|0;do if(f[m>>2]|0){a=f[k+4>>2]|0;if((a|0)<3)O=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{H=f[k+40>>2]|0;I=0;q=1;while(1){M=Y(f[H+(I<<2)>>2]|0,q)|0;I=I+1|0;if((I|0)==(a|0)){O=M;break}else q=M}}if(!((a|0)==0|(O|0)==0)){if(f[l+16>>2]|0){q=f[l+4>>2]|0;if((q|0)<3)P=Y(f[l+12>>2]|0,f[l+8>>2]|0)|0;else{I=f[l+40>>2]|0;H=0;M=1;while(1){N=Y(f[I+(H<<2)>>2]|0,M)|0;H=H+1|0;if((H|0)==(q|0)){P=N;break}else M=N}}if(!((q|0)==0|(P|0)==0))break}if(!(f[r>>2]|0))f[r>>2]=1;if(!(f[s>>2]|0))f[s>>2]=1}}while(0);P=f[r>>2]|0;r=(P|0)==0;do if(!r){if(A){p[y>>3]=+n[w>>2];p[z>>3]=+n[x>>2];break}if(B>>>0<5){p[y>>3]=+(f[t>>2]|0);p[z>>3]=+(f[v>>2]|0)}}else{p[z>>3]=0.0;p[y>>3]=0.0}while(0);if(c|0)p[c>>3]=+p[y>>3];if(d|0)p[d>>3]=+p[z>>3];do if(e|0){z=f[k+4>>2]|0;d=(z|0)>0;if(r){if(!d)break;F1a(e|0,-1,z<<2|0)|0;break}if(d){d=f[k+40>>2]|0;y=z;z=P+-1|0;while(1){c=y;y=y+-1|0;v=f[d+(y<<2)>>2]|0;f[e+(y<<2)>>2]=(z>>>0)%(v>>>0)|0;if((c|0)<=1)break;else z=(z>>>0)/(v>>>0)|0}}}while(0);do if(g|0){e=f[s>>2]|0;P=f[k+4>>2]|0;r=(P|0)>0;if(!e){if(!r)break;F1a(g|0,-1,P<<2|0)|0;break}if(r){r=f[k+40>>2]|0;z=P;P=e+-1|0;while(1){e=z;z=z+-1|0;y=f[r+(z<<2)>>2]|0;f[g+(z<<2)>>2]=(P>>>0)%(y>>>0)|0;if((e|0)<=1)break;else P=(P>>>0)/(y>>>0)|0}}}while(0);g=l+36|0;s=f[g>>2]|0;if(s|0?(P=s+12|0,s=f[P>>2]|0,f[P>>2]=s+-1,(s|0)==1):0)CR(l);f[g>>2]=0;g=l+16|0;s=l+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[s>>2]|0)>0){g=f[l+40>>2]|0;P=0;do{f[g+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[s>>2]|0))}s=f[l+44>>2]|0;if((s|0)!=(l+48|0))ZF(s);s=k+36|0;l=f[s>>2]|0;if(l|0?(P=l+12|0,l=f[P>>2]|0,f[P>>2]=l+-1,(l|0)==1):0)CR(k);f[s>>2]=0;s=k+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[s>>2]|0)>0){m=f[k+40>>2]|0;l=0;do{f[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[s>>2]|0))}s=f[k+44>>2]|0;if((s|0)!=(k+48|0))ZF(s);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function rZ(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;l=f[d>>2]|0;m=f[e>>2]|0;n=f[g>>2]|0;o=f[i>>2]|0;p=(j|0)>0;if(!c)if(p){q=0;r=o;s=m;t=n;u=l;while(1){v=h[a+q>>0]|0;w=(v|0)<(u|0);x=q+k|0;y=w?x:t;z=w?v:u;w=(v|0)>(s|0);A=w?x:r;x=w?v:s;q=q+1|0;if((q|0)==(j|0)){B=A;C=x;D=y;E=z;break}else{r=A;s=x;t=y;u=z}}}else{B=o;C=m;D=n;E=l}else if(p){p=0;u=o;t=m;s=n;r=l;while(1){q=(b[c+p>>0]|0)!=0;z=h[a+p>>0]|0;y=p+k|0;x=q&(z|0)<(r|0);A=x?z:r;v=x?y:s;x=q&(z|0)>(t|0);q=x?y:u;y=x?z:t;p=p+1|0;if((p|0)==(j|0)){B=q;C=y;D=v;E=A;break}else{u=q;t=y;s=v;r=A}}}else{B=o;C=m;D=n;E=l}f[g>>2]=D;f[i>>2]=B;f[d>>2]=E;f[e>>2]=C;return}function sZ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;k=f[d>>2]|0;l=f[e>>2]|0;m=f[g>>2]|0;n=f[h>>2]|0;o=(i|0)>0;if(!c)if(o){p=0;q=n;r=l;s=m;t=k;while(1){u=b[a+p>>0]|0;v=(u|0)<(t|0);w=p+j|0;x=v?w:s;y=v?u:t;v=(u|0)>(r|0);z=v?w:q;w=v?u:r;p=p+1|0;if((p|0)==(i|0)){A=z;B=w;C=x;D=y;break}else{q=z;r=w;s=x;t=y}}}else{A=n;B=l;C=m;D=k}else if(o){o=0;t=n;s=l;r=m;q=k;while(1){p=(b[c+o>>0]|0)!=0;y=b[a+o>>0]|0;x=o+j|0;w=p&(y|0)<(q|0);z=w?y:q;u=w?x:r;w=p&(y|0)>(s|0);p=w?x:t;x=w?y:s;o=o+1|0;if((o|0)==(i|0)){A=p;B=x;C=u;D=z;break}else{t=p;s=x;r=u;q=z}}}else{A=n;B=l;C=m;D=k}f[g>>2]=C;f[h>>2]=A;f[d>>2]=D;f[e>>2]=B;return}function tZ(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;l=f[d>>2]|0;m=f[e>>2]|0;n=f[g>>2]|0;o=f[h>>2]|0;p=(i|0)>0;if(!c)if(p){q=0;r=o;s=m;t=n;u=l;while(1){v=j[a+(q<<1)>>1]|0;w=(v|0)<(u|0);x=q+k|0;y=w?x:t;z=w?v:u;w=(v|0)>(s|0);A=w?x:r;x=w?v:s;q=q+1|0;if((q|0)==(i|0)){B=A;C=x;D=y;E=z;break}else{r=A;s=x;t=y;u=z}}}else{B=o;C=m;D=n;E=l}else if(p){p=0;u=o;t=m;s=n;r=l;while(1){q=(b[c+p>>0]|0)!=0;z=j[a+(p<<1)>>1]|0;y=p+k|0;x=q&(z|0)<(r|0);A=x?z:r;v=x?y:s;x=q&(z|0)>(t|0);q=x?y:u;y=x?z:t;p=p+1|0;if((p|0)==(i|0)){B=q;C=y;D=v;E=A;break}else{u=q;t=y;s=v;r=A}}}else{B=o;C=m;D=n;E=l}f[g>>2]=D;f[h>>2]=B;f[d>>2]=E;f[e>>2]=C;return}function uZ(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;l=f[e>>2]|0;m=f[g>>2]|0;n=f[h>>2]|0;o=f[i>>2]|0;p=(j|0)>0;if(!c)if(p){q=0;r=o;s=m;t=n;u=l;while(1){v=d[a+(q<<1)>>1]|0;w=(v|0)<(u|0);x=q+k|0;y=w?x:t;z=w?v:u;w=(v|0)>(s|0);A=w?x:r;x=w?v:s;q=q+1|0;if((q|0)==(j|0)){B=A;C=x;D=y;E=z;break}else{r=A;s=x;t=y;u=z}}}else{B=o;C=m;D=n;E=l}else if(p){p=0;u=o;t=m;s=n;r=l;while(1){q=(b[c+p>>0]|0)!=0;z=d[a+(p<<1)>>1]|0;y=p+k|0;x=q&(z|0)<(r|0);A=x?z:r;v=x?y:s;x=q&(z|0)>(t|0);q=x?y:u;y=x?z:t;p=p+1|0;if((p|0)==(j|0)){B=q;C=y;D=v;E=A;break}else{u=q;t=y;s=v;r=A}}}else{B=o;C=m;D=n;E=l}f[h>>2]=D;f[i>>2]=B;f[e>>2]=E;f[g>>2]=C;return}function vZ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;k=f[d>>2]|0;l=f[e>>2]|0;m=f[g>>2]|0;n=f[h>>2]|0;o=(i|0)>0;if(!c)if(o){p=0;q=n;r=l;s=m;t=k;while(1){u=f[a+(p<<2)>>2]|0;v=(u|0)<(t|0);w=p+j|0;x=v?w:s;y=v?u:t;v=(u|0)>(r|0);z=v?w:q;w=v?u:r;p=p+1|0;if((p|0)==(i|0)){A=z;B=w;C=x;D=y;break}else{q=z;r=w;s=x;t=y}}}else{A=n;B=l;C=m;D=k}else if(o){o=0;t=n;s=l;r=m;q=k;while(1){p=f[a+(o<<2)>>2]|0;y=(b[c+o>>0]|0)!=0;x=(p|0)<(q|0)&y;w=o+j|0;z=x?w:r;u=x?p:q;x=(p|0)>(s|0)&y;y=x?w:t;w=x?p:s;o=o+1|0;if((o|0)==(i|0)){A=y;B=w;C=z;D=u;break}else{t=y;s=w;r=z;q=u}}}else{A=n;B=l;C=m;D=k}f[g>>2]=C;f[h>>2]=A;f[d>>2]=D;f[e>>2]=B;return}function wZ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0,B=0.0,C=0,D=0.0,E=0,F=0.0;k=+n[d>>2];l=+n[e>>2];m=f[g>>2]|0;o=f[h>>2]|0;p=(i|0)>0;if(!c)if(p){q=0;r=o;s=l;t=m;u=k;while(1){v=+n[a+(q<<2)>>2];w=v<u;x=q+j|0;y=w?x:t;z=w?v:u;w=v>s;A=w?x:r;B=w?v:s;q=q+1|0;if((q|0)==(i|0)){C=A;D=B;E=y;F=z;break}else{r=A;s=B;t=y;u=z}}}else{C=o;D=l;E=m;F=k}else if(p){p=0;t=o;u=l;r=m;s=k;while(1){z=+n[a+(p<<2)>>2];q=(b[c+p>>0]|0)!=0;y=z<s&q;A=p+j|0;w=y?A:r;B=y?z:s;y=z>u&q;q=y?A:t;v=y?z:u;p=p+1|0;if((p|0)==(i|0)){C=q;D=v;E=w;F=B;break}else{t=q;u=v;r=w;s=B}}}else{C=o;D=l;E=m;F=k}f[g>>2]=E;f[h>>2]=C;n[d>>2]=F;n[e>>2]=D;return}function xZ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0,B=0.0,C=0,D=0.0,E=0,F=0.0;k=+p[d>>3];l=+p[e>>3];m=f[g>>2]|0;n=f[h>>2]|0;o=(i|0)>0;if(!c)if(o){q=0;r=n;s=l;t=m;u=k;while(1){v=+p[a+(q<<3)>>3];w=v<u;x=q+j|0;y=w?x:t;z=w?v:u;w=v>s;A=w?x:r;B=w?v:s;q=q+1|0;if((q|0)==(i|0)){C=A;D=B;E=y;F=z;break}else{r=A;s=B;t=y;u=z}}}else{C=n;D=l;E=m;F=k}else if(o){o=0;t=n;u=l;r=m;s=k;while(1){z=+p[a+(o<<3)>>3];q=(b[c+o>>0]|0)!=0;y=z<s&q;A=o+j|0;w=y?A:r;B=y?z:s;y=z>u&q;q=y?A:t;v=y?z:u;o=o+1|0;if((o|0)==(i|0)){C=q;D=v;E=w;F=B;break}else{t=q;u=v;r=w;s=B}}}else{C=n;D=l;E=m;F=k}f[g>>2]=E;f[h>>2]=C;p[d>>3]=F;p[e>>3]=D;return}function yZ(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+16|0;j=i+8|0;k=i;_$(j,43088);if((nS(a,-1)|0)>=3){f[k>>2]=0;f[k+4>>2]=0;l=c$(k,16)|0;m=189076;n=l+16|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-215,k,189093,188515,2775);d$(k)}qZ(a,c,d,e,g,h);if(e|0){h=e+4|0;d=f[e>>2]|0;f[e>>2]=f[h>>2];f[h>>2]=d}if(g|0){d=g+4|0;h=f[g>>2]|0;f[g>>2]=f[d>>2];f[d>>2]=h}if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function zZ(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;e=u;u=u+272|0;g=e+256|0;i=e+200|0;j=e+144|0;k=e+88|0;l=e+72|0;m=e;o=e+40|0;q=e+32|0;_$(g,43108);r=c&7;t=(r|0)==1;v=(r|0)==2;w=(r|0)==4;x=(r|0)==5;y=c&255;a:do switch(y&7){case 1:case 2:case 4:case 5:break;default:{if((r|1|0)==7?(RR(a,-1)|0)==0:0)break a;f[i>>2]=0;f[i+4>>2]=0;K1a(c$(i,173)|0,189184,173)|0;j$(-215,i,189358,188515,3186);d$(i)}}while(0);do if((NS(a)|0)==65536){c=f[a+4>>2]|0;f[i>>2]=f[c>>2];z=i+4|0;A=c+4|0;f[z>>2]=f[A>>2];B=i+8|0;f[B>>2]=f[c+8>>2];f[i+12>>2]=f[c+12>>2];f[i+16>>2]=f[c+16>>2];f[i+20>>2]=f[c+20>>2];f[i+24>>2]=f[c+24>>2];f[i+28>>2]=f[c+28>>2];f[i+32>>2]=f[c+32>>2];C=f[c+36>>2]|0;f[i+36>>2]=C;f[i+40>>2]=B;B=i+48|0;D=i+44|0;f[D>>2]=B;f[B>>2]=0;f[i+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[c+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];break}else{f[z>>2]=0;BR(i,c);break}}else OR(i,a,-1);while(0);do if((NS(d)|0)==65536){a=f[d+4>>2]|0;f[j>>2]=f[a>>2];c=j+4|0;z=a+4|0;f[c>>2]=f[z>>2];A=j+8|0;f[A>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];B=f[a+36>>2]|0;f[j+36>>2]=B;f[j+40>>2]=A;A=j+48|0;D=j+44|0;f[D>>2]=A;f[A>>2]=0;f[j+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[a+44>>2]|0;A=f[D>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[c>>2]=0;BR(j,a);break}}else OR(j,d,-1);while(0);d=f[i>>2]|0;a=d&7;c=(d>>>3&511)+1|0;z=j+16|0;A=f[z>>2]|0;b:do if(!(d&16384))E=64;else{if(A|0){D=f[j+4>>2]|0;if((D|0)<3)F=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{B=f[j+40>>2]|0;C=0;G=1;while(1){H=Y(f[B+(C<<2)>>2]|0,G)|0;C=C+1|0;if((C|0)==(D|0)){F=H;break}else G=H}}if(!((D|0)==0|(F|0)==0)){E=64;break}}G=f[i+4>>2]|0;if((G|0)<3)I=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{C=f[i+40>>2]|0;B=0;H=1;while(1){J=Y(f[C+(B<<2)>>2]|0,H)|0;B=B+1|0;if((B|0)==(G|0)){I=J;break}else H=J}}H=Y(I,c)|0;switch(d&7){case 5:break;case 0:{G=f[i+16>>2]|0;switch(y&7){case 6:{K=+(a$(G,H)|0);break b;break}case 7:break;default:{E=64;break b}}B=H+-4|0;if((H|0)<4){N=0;O=0}else{C=0;D=0;do{D=(h[189363+(h[G+C>>0]|0)>>0]|0)+D+(h[189363+(h[G+(C|1)>>0]|0)>>0]|0)+(h[189363+(h[G+(C|2)>>0]|0)>>0]|0)+(h[189363+(h[G+(C|3)>>0]|0)>>0]|0)|0;C=C+4|0}while((C|0)<=(B|0));N=H&-4;O=D}if((N|0)<(H|0)){B=N;C=O;while(1){J=(h[189363+(h[G+B>>0]|0)>>0]|0)+C|0;B=B+1|0;if((B|0)==(H|0)){P=J;break}else C=J}}else P=O;K=+(P|0);break b;break}default:{E=64;break b}}C=f[i+16>>2]|0;if(w){B=H+-4|0;if((H|0)<4){Q=0;R=0.0}else{G=0;S=0.0;do{T=+n[C+(G<<2)>>2];U=+n[C+((G|1)<<2)>>2];V=+n[C+((G|2)<<2)>>2];W=+n[C+((G|3)<<2)>>2];S=S+(T*T+U*U+V*V+W*W);G=G+4|0}while((G|0)<=(B|0));Q=H&-4;R=S}if((Q|0)<(H|0)){B=Q;W=R;while(1){V=+n[C+(B<<2)>>2];U=W+V*V;B=B+1|0;if((B|0)==(H|0)){X=U;break}else W=U}}else X=R;K=+M(+(X+0.0));break}if(x){B=H+-4|0;if((H|0)<4){Z=0;_=0.0}else{G=0;W=0.0;do{S=+n[C+(G<<2)>>2];U=+n[C+((G|1)<<2)>>2];V=+n[C+((G|2)<<2)>>2];T=+n[C+((G|3)<<2)>>2];W=W+(S*S+U*U+V*V+T*T);G=G+4|0}while((G|0)<=(B|0));Z=H&-4;_=W}if((Z|0)<(H|0)){B=Z;T=_;while(1){V=+n[C+(B<<2)>>2];U=T+V*V;B=B+1|0;if((B|0)==(H|0)){$=U;break}else T=U}}else $=_;K=$+0.0;break}if(!v){if(!t){E=64;break}if((H|0)>0){B=0;T=0.0;while(1){W=+L(+(+n[C+(B<<2)>>2]));U=T<W?W:T;B=B+1|0;if((B|0)==(H|0)){aa=U;break}else T=U}}else aa=0.0;K=aa>0.0?aa:0.0;break}B=H+-4|0;if((H|0)<4){ba=0;ca=0.0}else{G=0;T=0.0;do{U=+L(+(+n[C+(G<<2)>>2]));W=U+ +L(+(+n[C+((G|1)<<2)>>2]));U=W+ +L(+(+n[C+((G|2)<<2)>>2]));T=T+(U+ +L(+(+n[C+((G|3)<<2)>>2])));G=G+4|0}while((G|0)<=(B|0));ba=H&-4;ca=T}if((ba|0)<(H|0)){B=ba;U=ca;while(1){W=U+ +L(+(+n[C+(B<<2)>>2]));B=B+1|0;if((B|0)==(H|0)){da=W;break}else U=W}}else da=ca;K=da+0.0}while(0);do if((E|0)==64){if(A|0){ba=f[j+4>>2]|0;if((ba|0)<3)ea=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{Z=f[j+40>>2]|0;x=0;Q=1;while(1){P=Y(f[Z+(x<<2)>>2]|0,Q)|0;x=x+1|0;if((x|0)==(ba|0)){ea=P;break}else Q=P}}if(!((ba|0)==0|(ea|0)==0)?f[j>>2]&4095|0:0){f[k>>2]=0;f[k+4>>2]=0;fa=c$(k,32)|0;ga=188638;ha=fa+32|0;do{b[fa>>0]=b[ga>>0]|0;fa=fa+1|0;ga=ga+1|0}while((fa|0)<(ha|0));j$(-215,k,189358,188515,3253);d$(k)}}ba=(r|0)==6;Q=r|1;if((Q|0)==7){if(f[z>>2]|0){x=f[j+4>>2]|0;if((x|0)<3)ia=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{Z=f[j+40>>2]|0;P=0;O=1;while(1){N=Y(f[Z+(P<<2)>>2]|0,O)|0;P=P+1|0;if((P|0)==(x|0)){ia=N;break}else O=N}}if(!((x|0)==0|(ia|0)==0)){f[k>>2]=1124007936;O=k+4|0;P=k+8|0;Z=k+40|0;fa=O;ha=fa+36|0;do{f[fa>>2]=0;fa=fa+4|0}while((fa|0)<(ha|0));f[Z>>2]=P;x=k+48|0;N=k+44|0;f[N>>2]=x;f[x>>2]=0;f[k+52>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=i;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=j;y=o+8|0;f[y>>2]=0;f[y+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=k;bG(l,m,o,fT()|0);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=k;da=+zZ(l,r,fT()|0);y=k+36|0;d=f[y>>2]|0;if(d|0?(I=d+12|0,d=f[I>>2]|0,f[I>>2]=d+-1,(d|0)==1):0)CR(k);f[y>>2]=0;y=k+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[O>>2]|0)>0){y=f[Z>>2]|0;d=0;do{f[y+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[O>>2]|0))}O=f[N>>2]|0;if((O|0)!=(x|0))ZF(O);K=da;break}}O=ba?1:2;f[k>>2]=i;f[k+4>>2]=0;bU(m,k,l,-1);d=f[m+20>>2]|0;y=m+16|0;Z=0;P=0;while(1){if(Z>>>0>=(f[y>>2]|0)>>>0)break;I=(AZ(f[l>>2]|0,d,O)|0)+P|0;tR(m)|0;Z=Z+1|0;P=I}K=+(P|0);break}Z=f[43128+(r>>>1<<5)+(a<<2)>>2]|0;if(!Z){f[k>>2]=0;f[k+4>>2]=0;fa=c$(k,9)|0;ga=323538;ha=fa+9|0;do{b[fa>>0]=b[ga>>0]|0;fa=fa+1|0;ga=ga+1|0}while((fa|0)<(ha|0));j$(-215,k,189358,188515,3280);d$(k)}f[k>>2]=i;f[k+4>>2]=j;f[k+8>>2]=0;p[m>>3]=0.0;bU(o,k,l,-1);P=f[o+20>>2]|0;O=a>>>0<2;f[q>>2]=0;if(v&a>>>0<4|(Q|0)==5&O){d=((v&O?8388608:32768)>>>0)/(c>>>0)|0;O=(d|0)<(P|0)?d:P;y=f[i+4>>2]|0;if((y|0)>0){ja=1;ka=O;la=f[(f[i+44>>2]|0)+(y+-1<<2)>>2]|0;ma=q;na=d}else{ja=1;ka=O;la=0;ma=q;na=d}}else{ja=0;ka=P;la=0;ma=m;na=0}d=o+16|0;O=l+4|0;c:do if((P|0)>0){y=0;ba=0;while(1){if(ba>>>0>=(f[d>>2]|0)>>>0)break c;x=ba+1|0;N=f[l>>2]|0;I=f[O>>2]|0;if(ja){F=N;H=I;B=y;C=0;while(1){G=P-C|0;D=(ka|0)<(G|0)?ka:G;uh[Z&63](F,H,ma,D,c)|0;G=D+B|0;if((G+ka|0)<(na|0)?((D+C|0)<(P|0)?1:x>>>0<(f[d>>2]|0)>>>0):0)oa=G;else{p[m>>3]=+p[m>>3]+ +(f[q>>2]|0);f[q>>2]=0;oa=0}G=Y(D,la)|0;F=(f[l>>2]|0)+G|0;f[l>>2]=F;G=f[O>>2]|0;if(!G)pa=0;else{J=G+D|0;f[O>>2]=J;pa=J}C=C+ka|0;if((P|0)<=(C|0)){qa=oa;break}else{H=pa;B=oa}}}else{B=N;H=I;C=y;F=0;while(1){J=P-F|0;D=(ka|0)<(J|0)?ka:J;uh[Z&63](B,H,ma,D,c)|0;J=D+C|0;G=Y(D,la)|0;B=(f[l>>2]|0)+G|0;f[l>>2]=B;G=f[O>>2]|0;if(!G)ra=0;else{sa=G+D|0;f[O>>2]=sa;ra=sa}F=F+ka|0;if((P|0)<=(F|0)){qa=J;break}else{H=ra;C=J}}}tR(o)|0;y=qa;ba=x}}else{ba=0;while(1){if(ba>>>0>=(f[d>>2]|0)>>>0)break c;tR(o)|0;ba=ba+1|0}}while(0);if(t){if((a|0)!=6){d=f[m>>2]|0;p[m>>3]=(a|0)==5?(f[s>>2]=d,+n[s>>2]):+(d|0)}}else if(w){da=+M(+(+p[m>>3]));p[m>>3]=da}K=+p[m>>3]}while(0);m=j+36|0;w=f[m>>2]|0;if(w|0?(a=w+12|0,w=f[a>>2]|0,f[a>>2]=w+-1,(w|0)==1):0)CR(j);f[m>>2]=0;m=j+16|0;w=j+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[w>>2]|0)>0){m=f[j+40>>2]|0;a=0;do{f[m+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[w>>2]|0))}w=f[j+44>>2]|0;if((w|0)!=(j+48|0))ZF(w);w=i+36|0;j=f[w>>2]|0;if(j|0?(a=j+12|0,j=f[a>>2]|0,f[a>>2]=j+-1,(j|0)==1):0)CR(i);f[w>>2]=0;w=i+16|0;j=i+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[j>>2]|0)>0){w=f[i+40>>2]|0;a=0;do{f[w+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))ZF(j);if(!(f[g+4>>2]|0)){u=e;return +K}u=e;return +K}function AZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,j=0,k=0,l=0;switch(c|0){case 1:{d=a$(a,b)|0;return d|0}case 2:{e=189363;break}case 4:{e=189619;break}default:{d=-1;return d|0}}c=b+-4|0;if((b|0)<4){f=0;g=0}else{i=0;j=0;do{j=(h[e+(h[a+i>>0]|0)>>0]|0)+j+(h[e+(h[a+(i|1)>>0]|0)>>0]|0)+(h[e+(h[a+(i|2)>>0]|0)>>0]|0)+(h[e+(h[a+(i|3)>>0]|0)>>0]|0)|0;i=i+4|0}while((i|0)<=(c|0));f=b&-4;g=j}if((f|0)<(b|0)){k=f;l=g}else{d=g;return d|0}while(1){g=(h[e+(h[a+k>>0]|0)>>0]|0)+l|0;k=k+1|0;if((k|0)==(b|0)){d=g;break}else l=g}return d|0}function BZ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;i=f[d>>2]|0;if(!c){j=Y(g,e)|0;if((j|0)>0){k=0;l=0;while(1){m=h[a+k>>0]|0;n=(l|0)<(m|0)?m:l;k=k+1|0;if((k|0)==(j|0)){o=n;break}else l=n}}else o=0;p=(i|0)<(o|0)?o:i;f[d>>2]=p;return 0}if((e|0)>0&(g|0)>0){q=0;r=i;s=a}else{p=i;f[d>>2]=p;return 0}while(1){if(!(b[c+q>>0]|0))t=r;else{i=0;a=r;while(1){o=h[s+i>>0]|0;l=(a|0)<(o|0)?o:a;i=i+1|0;if((i|0)==(g|0)){t=l;break}else a=l}}q=q+1|0;if((q|0)==(e|0)){p=t;break}else{r=t;s=s+g|0}}f[d>>2]=p;return 0}function CZ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=f[d>>2]|0;if(!c){i=Y(g,e)|0;if((i|0)>0){j=0;k=0;while(1){l=b[a+j>>0]|0;m=l<<24>>24;n=l<<24>>24>-1?m:0-m|0;m=(k|0)<(n|0)?n:k;j=j+1|0;if((j|0)==(i|0)){o=m;break}else k=m}}else o=0;p=(h|0)<(o|0)?o:h;f[d>>2]=p;return 0}if((e|0)>0&(g|0)>0){q=0;r=h;s=a}else{p=h;f[d>>2]=p;return 0}while(1){if(!(b[c+q>>0]|0))t=r;else{h=0;a=r;while(1){o=b[s+h>>0]|0;k=o<<24>>24;i=o<<24>>24>-1?k:0-k|0;k=(a|0)<(i|0)?i:a;h=h+1|0;if((h|0)==(g|0)){t=k;break}else a=k}}q=q+1|0;if((q|0)==(e|0)){p=t;break}else{r=t;s=s+g|0}}f[d>>2]=p;return 0}function DZ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=f[d>>2]|0;if(!c){i=Y(g,e)|0;if((i|0)>0){k=0;l=0;while(1){m=j[a+(k<<1)>>1]|0;n=(l|0)<(m|0)?m:l;k=k+1|0;if((k|0)==(i|0)){o=n;break}else l=n}}else o=0;p=(h|0)<(o|0)?o:h;f[d>>2]=p;return 0}if((e|0)>0&(g|0)>0){q=0;r=h;s=a}else{p=h;f[d>>2]=p;return 0}while(1){if(!(b[c+q>>0]|0))t=r;else{h=0;a=r;while(1){o=j[s+(h<<1)>>1]|0;l=(a|0)<(o|0)?o:a;h=h+1|0;if((h|0)==(g|0)){t=l;break}else a=l}}q=q+1|0;if((q|0)==(e|0)){p=t;break}else{r=t;s=s+(g<<1)|0}}f[d>>2]=p;return 0}function EZ(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;i=f[e>>2]|0;if(!c){j=Y(h,g)|0;if((j|0)>0){k=0;l=0;while(1){m=d[a+(k<<1)>>1]|0;n=m<<16>>16;o=m<<16>>16>-1?n:0-n|0;n=(l|0)<(o|0)?o:l;k=k+1|0;if((k|0)==(j|0)){p=n;break}else l=n}}else p=0;q=(i|0)<(p|0)?p:i;f[e>>2]=q;return 0}if((g|0)>0&(h|0)>0){r=0;s=i;t=a}else{q=i;f[e>>2]=q;return 0}while(1){if(!(b[c+r>>0]|0))u=s;else{i=0;a=s;while(1){p=d[t+(i<<1)>>1]|0;l=p<<16>>16;j=p<<16>>16>-1?l:0-l|0;l=(a|0)<(j|0)?j:a;i=i+1|0;if((i|0)==(h|0)){u=l;break}else a=l}}r=r+1|0;if((r|0)==(g|0)){q=u;break}else{s=u;t=t+(h<<1)|0}}f[e>>2]=q;return 0}function FZ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=f[d>>2]|0;if(!c){i=Y(g,e)|0;if((i|0)>0){j=0;k=0;while(1){l=f[a+(j<<2)>>2]|0;m=(l|0)>-1?l:0-l|0;l=(k|0)<(m|0)?m:k;j=j+1|0;if((j|0)==(i|0)){n=l;break}else k=l}}else n=0;o=(h|0)<(n|0)?n:h;f[d>>2]=o;return 0}if((e|0)>0&(g|0)>0){p=0;q=h;r=a}else{o=h;f[d>>2]=o;return 0}while(1){if(!(b[c+p>>0]|0))s=q;else{h=0;a=q;while(1){n=f[r+(h<<2)>>2]|0;k=(n|0)>-1?n:0-n|0;n=(a|0)<(k|0)?k:a;h=h+1|0;if((h|0)==(g|0)){s=n;break}else a=n}}p=p+1|0;if((p|0)==(e|0)){o=s;break}else{q=s;r=r+(g<<2)|0}}f[d>>2]=o;return 0}function GZ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0,l=0.0,m=0.0,o=0.0,p=0.0,q=0,r=0,t=0.0,u=0,v=0,w=0.0,x=0;h=f[d>>2]|0;i=(f[s>>2]=h,+n[s>>2]);if(!c){j=Y(g,e)|0;if((j|0)>0){k=0;l=0.0;while(1){m=+L(+(+n[a+(k<<2)>>2]));o=l<m?m:l;k=k+1|0;if((k|0)==(j|0)){p=o;break}else l=o}}else p=0.0;q=(n[s>>2]=i<p?p:i,f[s>>2]|0);f[d>>2]=q;return 0}if((e|0)>0&(g|0)>0){r=0;t=i;u=h;v=a}else{q=h;f[d>>2]=q;return 0}while(1){if(!(b[c+r>>0]|0)){w=t;x=u}else{h=0;i=t;do{p=+L(+(+n[v+(h<<2)>>2]));i=i<p?p:i;h=h+1|0}while((h|0)!=(g|0));w=i;x=(n[s>>2]=i,f[s>>2]|0)}r=r+1|0;if((r|0)==(e|0)){q=x;break}else{t=w;u=x;v=v+(g<<2)|0}}f[d>>2]=q;return 0}function HZ(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,q=0.0,r=0,s=0.0;g=+p[d>>3];if(!c){h=Y(f,e)|0;if((h|0)>0){i=0;j=0.0;while(1){k=+L(+(+p[a+(i<<3)>>3]));l=j<k?k:j;i=i+1|0;if((i|0)==(h|0)){m=l;break}else j=l}}else m=0.0;n=g<m?m:g;p[d>>3]=n;return 0}if((e|0)>0&(f|0)>0){o=0;q=g;r=a}else{n=g;p[d>>3]=n;return 0}while(1){if(!(b[c+o>>0]|0))s=q;else{a=0;g=q;while(1){m=+L(+(+p[r+(a<<3)>>3]));j=g<m?m:g;a=a+1|0;if((a|0)==(f|0)){s=j;break}else g=j}}o=o+1|0;if((o|0)==(e|0)){n=s;break}else{q=s;r=r+(f<<3)|0}}p[d>>3]=n;return 0}function IZ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;i=f[d>>2]|0;if(c|0){if((e|0)>0&(g|0)>0){j=0;k=i;l=a}else{m=i;f[d>>2]=m;return 0}while(1){if(!(b[c+j>>0]|0))n=k;else{o=0;p=k;while(1){q=(h[l+o>>0]|0)+p|0;o=o+1|0;if((o|0)==(g|0)){n=q;break}else p=q}}j=j+1|0;if((j|0)==(e|0)){m=n;break}else{k=n;l=l+g|0}}f[d>>2]=m;return 0}l=Y(g,e)|0;e=l+-4|0;if((l|0)<4){r=0;s=0}else{g=0;n=0;do{n=(h[a+g>>0]|0)+n+(h[a+(g|1)>>0]|0)+(h[a+(g|2)>>0]|0)+(h[a+(g|3)>>0]|0)|0;g=g+4|0}while((g|0)<=(e|0));r=l&-4;s=n}if((r|0)<(l|0)){n=r;r=s;while(1){e=(h[a+n>>0]|0)+r|0;n=n+1|0;if((n|0)==(l|0)){t=e;break}else r=e}}else t=s;m=t+i|0;f[d>>2]=m;return 0}function JZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return d_(a,b,c,d,e)|0}function KZ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=f[d>>2]|0;if(c|0){if((e|0)>0&(g|0)>0){i=0;k=h;l=a}else{m=h;f[d>>2]=m;return 0}while(1){if(!(b[c+i>>0]|0))n=k;else{o=0;p=k;while(1){q=(j[l+(o<<1)>>1]|0)+p|0;o=o+1|0;if((o|0)==(g|0)){n=q;break}else p=q}}i=i+1|0;if((i|0)==(e|0)){m=n;break}else{k=n;l=l+(g<<1)|0}}f[d>>2]=m;return 0}l=Y(g,e)|0;e=l+-4|0;if((l|0)<4){r=0;s=0}else{g=0;n=0;do{n=(j[a+(g<<1)>>1]|0)+n+(j[a+((g|1)<<1)>>1]|0)+(j[a+((g|2)<<1)>>1]|0)+(j[a+((g|3)<<1)>>1]|0)|0;g=g+4|0}while((g|0)<=(e|0));r=l&-4;s=n}if((r|0)<(l|0)){n=r;r=s;while(1){e=(j[a+(n<<1)>>1]|0)+r|0;n=n+1|0;if((n|0)==(l|0)){t=e;break}else r=e}}else t=s;m=t+h|0;f[d>>2]=m;return 0}function LZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return c_(a,b,c,d,e)|0}function MZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return b_(a,b,c,d,e)|0}function NZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return a_(a,b,c,d,e)|0}function OZ(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){h=0;i=g;j=a}else{k=g;p[d>>3]=k;return 0}while(1){if(!(b[c+h>>0]|0))l=i;else{m=0;n=i;while(1){o=n+ +L(+(+p[j+(m<<3)>>3]));m=m+1|0;if((m|0)==(f|0)){l=o;break}else n=o}}h=h+1|0;if((h|0)==(e|0)){k=l;break}else{i=l;j=j+(f<<3)|0}}p[d>>3]=k;return 0}j=Y(f,e)|0;e=j+-4|0;if((j|0)<4){q=0;r=0.0}else{f=0;l=0.0;do{i=+L(+(+p[a+(f<<3)>>3]));n=i+ +L(+(+p[a+((f|1)<<3)>>3]));i=n+ +L(+(+p[a+((f|2)<<3)>>3]));l=l+(i+ +L(+(+p[a+((f|3)<<3)>>3])));f=f+4|0}while((f|0)<=(e|0));q=j&-4;r=l}if((q|0)<(j|0)){e=q;l=r;while(1){i=l+ +L(+(+p[a+(e<<3)>>3]));e=e+1|0;if((e|0)==(j|0)){s=i;break}else l=i}}else s=r;k=g+s;p[d>>3]=k;return 0}function PZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return $Z(a,b,c,d,e)|0}function QZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return _Z(a,b,c,d,e)|0}function RZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ZZ(a,b,c,d,e)|0}function SZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return YZ(a,b,c,d,e)|0}function TZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return XZ(a,b,c,d,e)|0}function UZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return WZ(a,b,c,d,e)|0}function VZ(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,q=0.0,r=0,s=0.0,t=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){h=0;i=g;j=a}else{k=g;p[d>>3]=k;return 0}while(1){if(!(b[c+h>>0]|0))l=i;else{m=0;n=i;while(1){o=+p[j+(m<<3)>>3];q=n+o*o;m=m+1|0;if((m|0)==(f|0)){l=q;break}else n=q}}h=h+1|0;if((h|0)==(e|0)){k=l;break}else{i=l;j=j+(f<<3)|0}}p[d>>3]=k;return 0}j=Y(f,e)|0;e=j+-4|0;if((j|0)<4){r=0;s=0.0}else{f=0;l=0.0;do{i=+p[a+(f<<3)>>3];n=+p[a+((f|1)<<3)>>3];q=+p[a+((f|2)<<3)>>3];o=+p[a+((f|3)<<3)>>3];l=l+(i*i+n*n+q*q+o*o);f=f+4|0}while((f|0)<=(e|0));r=j&-4;s=l}if((r|0)<(j|0)){e=r;l=s;while(1){o=+p[a+(e<<3)>>3];q=l+o*o;e=e+1|0;if((e|0)==(j|0)){t=q;break}else l=q}}else t=s;k=g+t;p[d>>3]=k;return 0}function WZ(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0,o=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){h=0;i=g;j=a}else{k=g;p[d>>3]=k;return 0}while(1){if(!(b[c+h>>0]|0))l=i;else{m=0;o=i;while(1){q=+n[j+(m<<2)>>2];r=o+q*q;m=m+1|0;if((m|0)==(f|0)){l=r;break}else o=r}}h=h+1|0;if((h|0)==(e|0)){k=l;break}else{i=l;j=j+(f<<2)|0}}p[d>>3]=k;return 0}j=Y(f,e)|0;e=j+-4|0;if((j|0)<4){s=0;t=0.0}else{f=0;l=0.0;do{i=+n[a+(f<<2)>>2];o=+n[a+((f|1)<<2)>>2];r=+n[a+((f|2)<<2)>>2];q=+n[a+((f|3)<<2)>>2];l=l+(i*i+o*o+r*r+q*q);f=f+4|0}while((f|0)<=(e|0));s=j&-4;t=l}if((s|0)<(j|0)){e=s;l=t;while(1){q=+n[a+(e<<2)>>2];r=l+q*q;e=e+1|0;if((e|0)==(j|0)){u=r;break}else l=r}}else u=t;k=g+u;p[d>>3]=k;return 0}function XZ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0.0,m=0.0,n=0,o=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0;h=+p[d>>3];if(c|0){if((e|0)>0&(g|0)>0){i=0;j=h;k=a}else{l=h;p[d>>3]=l;return 0}while(1){if(!(b[c+i>>0]|0))m=j;else{n=0;o=j;while(1){q=+(f[k+(n<<2)>>2]|0);r=o+q*q;n=n+1|0;if((n|0)==(g|0)){m=r;break}else o=r}}i=i+1|0;if((i|0)==(e|0)){l=m;break}else{j=m;k=k+(g<<2)|0}}p[d>>3]=l;return 0}k=Y(g,e)|0;e=k+-4|0;if((k|0)<4){s=0;t=0.0}else{g=0;m=0.0;do{j=+(f[a+(g<<2)>>2]|0);o=+(f[a+((g|1)<<2)>>2]|0);r=+(f[a+((g|2)<<2)>>2]|0);q=+(f[a+((g|3)<<2)>>2]|0);m=m+(j*j+o*o+r*r+q*q);g=g+4|0}while((g|0)<=(e|0));s=k&-4;t=m}if((s|0)<(k|0)){e=s;m=t;while(1){q=+(f[a+(e<<2)>>2]|0);r=m+q*q;e=e+1|0;if((e|0)==(k|0)){u=r;break}else m=r}}else u=t;l=h+u;p[d>>3]=l;return 0}function YZ(a,c,e,f,g){a=a|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0.0,m=0.0,n=0,o=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0;h=+p[e>>3];if(c|0){if((f|0)>0&(g|0)>0){i=0;j=h;k=a}else{l=h;p[e>>3]=l;return 0}while(1){if(!(b[c+i>>0]|0))m=j;else{n=0;o=j;while(1){q=+(d[k+(n<<1)>>1]|0);r=o+q*q;n=n+1|0;if((n|0)==(g|0)){m=r;break}else o=r}}i=i+1|0;if((i|0)==(f|0)){l=m;break}else{j=m;k=k+(g<<1)|0}}p[e>>3]=l;return 0}k=Y(g,f)|0;f=k+-4|0;if((k|0)<4){s=0;t=0.0}else{g=0;m=0.0;do{j=+(d[a+(g<<1)>>1]|0);o=+(d[a+((g|1)<<1)>>1]|0);r=+(d[a+((g|2)<<1)>>1]|0);q=+(d[a+((g|3)<<1)>>1]|0);m=m+(j*j+o*o+r*r+q*q);g=g+4|0}while((g|0)<=(f|0));s=k&-4;t=m}if((s|0)<(k|0)){f=s;m=t;while(1){q=+(d[a+(f<<1)>>1]|0);r=m+q*q;f=f+1|0;if((f|0)==(k|0)){u=r;break}else m=r}}else u=t;l=h+u;p[e>>3]=l;return 0}function ZZ(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,k=0,l=0.0,m=0.0,n=0,o=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){h=0;i=g;k=a}else{l=g;p[d>>3]=l;return 0}while(1){if(!(b[c+h>>0]|0))m=i;else{n=0;o=i;while(1){q=+(j[k+(n<<1)>>1]|0);r=o+q*q;n=n+1|0;if((n|0)==(f|0)){m=r;break}else o=r}}h=h+1|0;if((h|0)==(e|0)){l=m;break}else{i=m;k=k+(f<<1)|0}}p[d>>3]=l;return 0}k=Y(f,e)|0;e=k+-4|0;if((k|0)<4){s=0;t=0.0}else{f=0;m=0.0;do{i=+(j[a+(f<<1)>>1]|0);o=+(j[a+((f|1)<<1)>>1]|0);r=+(j[a+((f|2)<<1)>>1]|0);q=+(j[a+((f|3)<<1)>>1]|0);m=m+(i*i+o*o+r*r+q*q);f=f+4|0}while((f|0)<=(e|0));s=k&-4;t=m}if((s|0)<(k|0)){e=s;m=t;while(1){q=+(j[a+(e<<1)>>1]|0);r=m+q*q;e=e+1|0;if((e|0)==(k|0)){u=r;break}else m=r}}else u=t;l=g+u;p[d>>3]=l;return 0}function _Z(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=f[d>>2]|0;if(c|0){if((e|0)>0&(g|0)>0){i=0;j=h;k=a}else{l=h;f[d>>2]=l;return 0}while(1){if(!(b[c+i>>0]|0))m=j;else{n=0;o=j;while(1){p=b[k+n>>0]|0;q=(Y(p,p)|0)+o|0;n=n+1|0;if((n|0)==(g|0)){m=q;break}else o=q}}i=i+1|0;if((i|0)==(e|0)){l=m;break}else{j=m;k=k+g|0}}f[d>>2]=l;return 0}k=Y(g,e)|0;e=k+-4|0;if((k|0)<4){r=0;s=0}else{g=0;m=0;do{j=b[a+g>>0]|0;i=b[a+(g|1)>>0]|0;c=b[a+(g|2)>>0]|0;o=b[a+(g|3)>>0]|0;m=(Y(j,j)|0)+m+(Y(i,i)|0)+(Y(c,c)|0)+(Y(o,o)|0)|0;g=g+4|0}while((g|0)<=(e|0));r=k&-4;s=m}if((r|0)<(k|0)){m=r;r=s;while(1){e=b[a+m>>0]|0;g=(Y(e,e)|0)+r|0;m=m+1|0;if((m|0)==(k|0)){t=g;break}else r=g}}else t=s;l=t+h|0;f[d>>2]=l;return 0}function $Z(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;i=f[d>>2]|0;if(c|0){if((e|0)>0&(g|0)>0){j=0;k=i;l=a}else{m=i;f[d>>2]=m;return 0}while(1){if(!(b[c+j>>0]|0))n=k;else{o=0;p=k;while(1){q=h[l+o>>0]|0;r=(Y(q,q)|0)+p|0;o=o+1|0;if((o|0)==(g|0)){n=r;break}else p=r}}j=j+1|0;if((j|0)==(e|0)){m=n;break}else{k=n;l=l+g|0}}f[d>>2]=m;return 0}l=Y(g,e)|0;e=l+-4|0;if((l|0)<4){s=0;t=0}else{g=0;n=0;do{k=h[a+g>>0]|0;j=h[a+(g|1)>>0]|0;c=h[a+(g|2)>>0]|0;p=h[a+(g|3)>>0]|0;n=(Y(k,k)|0)+n+(Y(j,j)|0)+(Y(c,c)|0)+(Y(p,p)|0)|0;g=g+4|0}while((g|0)<=(e|0));s=l&-4;t=n}if((s|0)<(l|0)){n=s;s=t;while(1){e=h[a+n>>0]|0;g=(Y(e,e)|0)+s|0;n=n+1|0;if((n|0)==(l|0)){u=g;break}else s=g}}else u=t;m=u+i|0;f[d>>2]=m;return 0}function a_(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0,o=0.0,q=0.0,r=0,s=0.0,t=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){h=0;i=g;j=a}else{k=g;p[d>>3]=k;return 0}while(1){if(!(b[c+h>>0]|0))l=i;else{m=0;o=i;while(1){q=o+ +L(+(+n[j+(m<<2)>>2]));m=m+1|0;if((m|0)==(f|0)){l=q;break}else o=q}}h=h+1|0;if((h|0)==(e|0)){k=l;break}else{i=l;j=j+(f<<2)|0}}p[d>>3]=k;return 0}j=Y(f,e)|0;e=j+-4|0;if((j|0)<4){r=0;s=0.0}else{f=0;l=0.0;do{i=+L(+(+n[a+(f<<2)>>2]));o=i+ +L(+(+n[a+((f|1)<<2)>>2]));i=o+ +L(+(+n[a+((f|2)<<2)>>2]));l=l+(i+ +L(+(+n[a+((f|3)<<2)>>2])));f=f+4|0}while((f|0)<=(e|0));r=j&-4;s=l}if((r|0)<(j|0)){e=r;l=s;while(1){i=l+ +L(+(+n[a+(e<<2)>>2]));e=e+1|0;if((e|0)==(j|0)){t=i;break}else l=i}}else t=s;k=g+t;p[d>>3]=k;return 0}function b_(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0.0,m=0.0,n=0,o=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0;h=+p[d>>3];if(c|0){if((e|0)>0&(g|0)>0){i=0;j=h;k=a}else{l=h;p[d>>3]=l;return 0}while(1){if(!(b[c+i>>0]|0))m=j;else{n=0;o=j;while(1){q=f[k+(n<<2)>>2]|0;r=o+ +(((q|0)>-1?q:0-q|0)|0);n=n+1|0;if((n|0)==(g|0)){m=r;break}else o=r}}i=i+1|0;if((i|0)==(e|0)){l=m;break}else{j=m;k=k+(g<<2)|0}}p[d>>3]=l;return 0}k=Y(g,e)|0;e=k+-4|0;if((k|0)<4){s=0;t=0.0}else{g=0;m=0.0;do{i=f[a+(g<<2)>>2]|0;c=f[a+((g|1)<<2)>>2]|0;n=f[a+((g|2)<<2)>>2]|0;q=f[a+((g|3)<<2)>>2]|0;m=m+(+(((i|0)>-1?i:0-i|0)|0)+ +(((c|0)>-1?c:0-c|0)|0)+ +(((n|0)>-1?n:0-n|0)|0)+ +(((q|0)>-1?q:0-q|0)|0));g=g+4|0}while((g|0)<=(e|0));s=k&-4;t=m}if((s|0)<(k|0)){e=s;m=t;while(1){s=f[a+(e<<2)>>2]|0;j=m+ +(((s|0)>-1?s:0-s|0)|0);e=e+1|0;if((e|0)==(k|0)){u=j;break}else m=j}}else u=t;l=h+u;p[d>>3]=l;return 0}function c_(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;i=f[e>>2]|0;if(c|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=a}else{m=i;f[e>>2]=m;return 0}while(1){if(!(b[c+j>>0]|0))n=k;else{o=0;p=k;while(1){q=d[l+(o<<1)>>1]|0;r=q<<16>>16;s=(q<<16>>16>-1?r:0-r|0)+p|0;o=o+1|0;if((o|0)==(h|0)){n=s;break}else p=s}}j=j+1|0;if((j|0)==(g|0)){m=n;break}else{k=n;l=l+(h<<1)|0}}f[e>>2]=m;return 0}l=Y(h,g)|0;g=l+-4|0;if((l|0)<4){t=0;u=0}else{h=0;n=0;do{k=d[a+(h<<1)>>1]|0;j=k<<16>>16;c=d[a+((h|1)<<1)>>1]|0;p=c<<16>>16;o=d[a+((h|2)<<1)>>1]|0;s=o<<16>>16;r=d[a+((h|3)<<1)>>1]|0;q=r<<16>>16;n=(k<<16>>16>-1?j:0-j|0)+n+(c<<16>>16>-1?p:0-p|0)+(o<<16>>16>-1?s:0-s|0)+(r<<16>>16>-1?q:0-q|0)|0;h=h+4|0}while((h|0)<=(g|0));t=l&-4;u=n}if((t|0)<(l|0)){n=t;t=u;while(1){g=d[a+(n<<1)>>1]|0;h=g<<16>>16;q=(g<<16>>16>-1?h:0-h|0)+t|0;n=n+1|0;if((n|0)==(l|0)){v=q;break}else t=q}}else v=u;m=v+i|0;f[e>>2]=m;return 0}function d_(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=f[d>>2]|0;if(c|0){if((e|0)>0&(g|0)>0){i=0;j=h;k=a}else{l=h;f[d>>2]=l;return 0}while(1){if(!(b[c+i>>0]|0))m=j;else{n=0;o=j;while(1){p=b[k+n>>0]|0;q=p<<24>>24;r=(p<<24>>24>-1?q:0-q|0)+o|0;n=n+1|0;if((n|0)==(g|0)){m=r;break}else o=r}}i=i+1|0;if((i|0)==(e|0)){l=m;break}else{j=m;k=k+g|0}}f[d>>2]=l;return 0}k=Y(g,e)|0;e=k+-4|0;if((k|0)<4){s=0;t=0}else{g=0;m=0;do{j=b[a+g>>0]|0;i=j<<24>>24;c=b[a+(g|1)>>0]|0;o=c<<24>>24;n=b[a+(g|2)>>0]|0;r=n<<24>>24;q=b[a+(g|3)>>0]|0;p=q<<24>>24;m=(j<<24>>24>-1?i:0-i|0)+m+(c<<24>>24>-1?o:0-o|0)+(n<<24>>24>-1?r:0-r|0)+(q<<24>>24>-1?p:0-p|0)|0;g=g+4|0}while((g|0)<=(e|0));s=k&-4;t=m}if((s|0)<(k|0)){m=s;s=t;while(1){e=b[a+m>>0]|0;g=e<<24>>24;p=(e<<24>>24>-1?g:0-g|0)+s|0;m=m+1|0;if((m|0)==(k|0)){u=p;break}else s=p}}else u=t;l=u+h|0;f[d>>2]=l;return 0}
function zO(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=u;u=u+1392|0;g=e+1368|0;h=e+1360|0;i=e+1304|0;j=e+1248|0;k=e+1240|0;l=e+1184|0;m=e;n=e+1128|0;o=e+1096|0;_$(h,39864);do if((NS(a)|0)==65536){p=f[a+4>>2]|0;f[i>>2]=f[p>>2];q=i+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=i+8|0;f[s>>2]=f[p+8>>2];f[i+12>>2]=f[p+12>>2];f[i+16>>2]=f[p+16>>2];f[i+20>>2]=f[p+20>>2];f[i+24>>2]=f[p+24>>2];f[i+28>>2]=f[p+28>>2];f[i+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[i+36>>2]=t;f[i+40>>2]=s;s=i+48|0;v=i+44|0;f[v>>2]=s;f[s>>2]=0;f[i+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;BR(i,p);break}}else OR(i,a,-1);while(0);do if((NS(d)|0)==65536){a=f[d+4>>2]|0;f[j>>2]=f[a>>2];p=j+4|0;q=a+4|0;f[p>>2]=f[q>>2];r=j+8|0;f[r>>2]=f[a+8>>2];s=j+12|0;f[s>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];v=f[a+36>>2]|0;f[j+36>>2]=v;f[j+40>>2]=r;t=j+48|0;w=j+44|0;f[w>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[q>>2]|0)<3){q=f[a+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[q>>2];f[t+4>>2]=f[q+4>>2];x=s;y=r;break}else{f[p>>2]=0;BR(j,a);x=s;y=r;break}}else{OR(j,d,-1);x=j+12|0;y=j+8|0}while(0);d=f[i>>2]|0;r=d&7;s=d>>>3&511;d=s+1|0;a=f[y>>2]|0;p=a+-1|0;q=s+2|0;if((q|0)!=(f[x>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;z=c$(g,17)|0;A=168779;B=z+17|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-215,g,168797,168105,2299);d$(g)}s=(r|0)==5;if((r+-5|0)>>>0>=2){f[g>>2]=0;f[g+4>>2]=0;z=c$(g,24)|0;A=168818;B=z+24|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-215,g,168797,168105,2300);d$(g)}t=i+40|0;w=f[t>>2]|0;v=f[w>>2]|0;f[k>>2]=f[w+4>>2];f[k+4>>2]=v;KS(c,k,(a<<3)+-16|r,-1,0,0);do if((NS(c)|0)==65536){r=f[c+4>>2]|0;f[l>>2]=f[r>>2];k=l+4|0;v=r+4|0;f[k>>2]=f[v>>2];w=l+8|0;f[w>>2]=f[r+8>>2];f[l+12>>2]=f[r+12>>2];f[l+16>>2]=f[r+16>>2];f[l+20>>2]=f[r+20>>2];f[l+24>>2]=f[r+24>>2];f[l+28>>2]=f[r+28>>2];f[l+32>>2]=f[r+32>>2];C=f[r+36>>2]|0;f[l+36>>2]=C;f[l+40>>2]=w;w=l+48|0;D=l+44|0;f[D>>2]=w;f[w>>2]=0;f[l+52>>2]=0;if(C|0){w=C+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[r+44>>2]|0;w=f[D>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[k>>2]=0;BR(l,r);break}}else OR(l,c,-1);while(0);c=m+8|0;f[m>>2]=c;r=m+4|0;f[r>>2]=136;if((f[j>>2]&20479|0)==16390)E=f[j+16>>2]|0;else{k=Y(q,a)|0;f[r>>2]=k;if(k>>>0>136){v=OYa(k>>>0>536870911?-1:k<<3)|0;f[m>>2]=v;F=v}else F=c;f[n>>2]=1124007942;v=n+4|0;f[v>>2]=2;w=n+8|0;f[w>>2]=a;a=n+12|0;f[a>>2]=q;D=n+16|0;f[D>>2]=F;C=n+20|0;f[C>>2]=F;G=n+24|0;H=n+28|0;I=n+40|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;f[I>>2]=w;J=n+48|0;K=n+44|0;f[K>>2]=J;f[n+52>>2]=0;f[J>>2]=0;if((k|0)!=0&(F|0)==0){f[g>>2]=0;f[g+4>>2]=0;z=c$(g,26)|0;A=358223;B=z+26|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-215,g,358250,358254,500);d$(g);L=f[a>>2]|0;M=f[n>>2]|0;N=f[K>>2]|0;O=f[C>>2]|0}else{L=q;M=1124007942;N=J;O=F}F=L<<3;f[n>>2]=M|16384;f[N>>2]=F;f[N+4>>2]=8;N=O+(Y(f[w>>2]|0,F)|0)|0;f[H>>2]=N;f[G>>2]=N+(0-F)+F;F=g+8|0;f[F>>2]=0;f[F+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=n;WJ(j,g,6,1.0,0.0);F=n+36|0;N=f[F>>2]|0;if(N|0){O=N+12|0;f[O>>2]=(f[O>>2]|0)+1}O=j+36|0;N=f[O>>2]|0;if(N|0?(M=N+12|0,N=f[M>>2]|0,f[M>>2]=N+-1,(N|0)==1):0)CR(j);f[O>>2]=0;N=j+16|0;M=j+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[M>>2]|0)>0){L=f[j+40>>2]|0;q=0;do{f[L+(q<<2)>>2]=0;q=q+1|0;P=f[M>>2]|0}while((q|0)<(P|0));f[j>>2]=f[n>>2];if((P|0)<3)Q=41;else Q=43}else{f[j>>2]=f[n>>2];Q=41}if((Q|0)==41){P=f[v>>2]|0;if((P|0)<3){f[M>>2]=P;f[y>>2]=f[w>>2];f[x>>2]=f[a>>2];a=f[K>>2]|0;x=f[j+44>>2]|0;f[x>>2]=f[a>>2];f[x+4>>2]=f[a+4>>2]}else Q=43}if((Q|0)==43)BR(j,n);f[N>>2]=f[D>>2];f[j+20>>2]=f[C>>2];f[j+24>>2]=f[G>>2];f[j+28>>2]=f[H>>2];f[j+32>>2]=f[n+32>>2];H=f[F>>2]|0;f[O>>2]=H;if(H|0?(O=H+12|0,H=f[O>>2]|0,f[O>>2]=H+-1,(H|0)==1):0)CR(n);f[F>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[v>>2]|0)>0){D=f[I>>2]|0;I=0;do{f[D+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[v>>2]|0))}v=f[K>>2]|0;if((v|0)!=(J|0))ZF(v);E=c}v=s?130:129;f[g>>2]=i;f[g+4>>2]=l;f[g+8>>2]=0;bU(o,g,n,-1);g=f[o+20>>2]|0;s=o+16|0;J=n+4|0;K=0;while(1){if(K>>>0>=(f[s>>2]|0)>>>0)break;bh[v&255](f[n>>2]|0,f[J>>2]|0,E,g,d,p);tR(o)|0;K=K+1|0}K=f[m>>2]|0;if((K|0)!=(c|0)){if(K|0)QYa(K);f[m>>2]=c;f[r>>2]=136}r=l+36|0;c=f[r>>2]|0;if(c|0?(m=c+12|0,c=f[m>>2]|0,f[m>>2]=c+-1,(c|0)==1):0)CR(l);f[r>>2]=0;r=l+16|0;c=l+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[c>>2]|0)>0){r=f[l+40>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[c>>2]|0))}c=f[l+44>>2]|0;if((c|0)!=(l+48|0))ZF(c);c=j+36|0;l=f[c>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)CR(j);f[c>>2]=0;c=j+16|0;l=j+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[l>>2]|0)>0){c=f[j+40>>2]|0;m=0;do{f[c+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[l>>2]|0))}l=f[j+44>>2]|0;if((l|0)!=(j+48|0))ZF(l);l=i+36|0;j=f[l>>2]|0;if(j|0?(m=j+12|0,j=f[m>>2]|0,f[m>>2]=j+-1,(j|0)==1):0)CR(i);f[l>>2]=0;l=i+16|0;j=i+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[j>>2]|0)>0){l=f[t>>2]|0;t=0;do{f[l+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))ZF(j);if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function AO(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0.0,j=0.0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;g=(f|0)==2;if((e|0)==2&g){h=d<<1;if((d|0)<=0)return;i=+p[c+48>>3];j=+p[c+56>>3];k=+p[c+64>>3];l=c+8|0;m=c+16|0;o=c+24|0;q=c+32|0;r=c+40|0;s=0;do{t=s|1;u=+n[a+(s<<2)>>2];v=+n[a+(t<<2)>>2];w=k+(i*u+j*v);if(+L(+w)>1.1920928955078125e-07){x=1.0/w;n[b+(s<<2)>>2]=x*(+p[m>>3]+(u*+p[c>>3]+v*+p[l>>3]));y=x*(+p[r>>3]+(u*+p[o>>3]+v*+p[q>>3]));z=t}else{n[b+(t<<2)>>2]=0.0;y=0.0;z=s}n[b+(z<<2)>>2]=y;s=s+2|0}while((s|0)<(h|0));return}h=(e|0)==3;if(h&(f|0)==3){s=d*3|0;if((d|0)<=0)return;y=+p[c+96>>3];j=+p[c+104>>3];i=+p[c+112>>3];k=+p[c+120>>3];z=c+8|0;q=c+16|0;o=c+24|0;r=c+32|0;l=c+40|0;m=c+48|0;t=c+56|0;A=c+64|0;B=c+72|0;C=c+80|0;D=c+88|0;E=0;do{F=E+1|0;G=E+2|0;v=+n[a+(E<<2)>>2];u=+n[a+(F<<2)>>2];x=+n[a+(G<<2)>>2];w=k+(y*v+j*u+i*x);if(+L(+w)>1.1920928955078125e-07){H=1.0/w;n[b+(E<<2)>>2]=H*(+p[o>>3]+(v*+p[c>>3]+u*+p[z>>3]+x*+p[q>>3]));I=H*(+p[D>>3]+(v*+p[A>>3]+u*+p[B>>3]+x*+p[C>>3]));J=H*(+p[t>>3]+(v*+p[r>>3]+u*+p[l>>3]+x*+p[m>>3]));K=G}else{n[b+(G<<2)>>2]=0.0;I=0.0;J=0.0;K=E}n[b+(F<<2)>>2]=J;n[b+(K<<2)>>2]=I;E=E+3|0}while((E|0)<(s|0));return}s=(d|0)>0;if(h&g){if(!s)return;I=+p[c+64>>3];J=+p[c+72>>3];i=+p[c+80>>3];j=+p[c+88>>3];g=c+8|0;h=c+16|0;E=c+24|0;K=c+32|0;m=c+40|0;l=c+48|0;r=c+56|0;t=b;C=0;B=a;while(1){y=+n[B>>2];k=+n[B+4>>2];x=+n[B+8>>2];u=j+(I*y+J*k+i*x);if(+L(+u)>1.1920928955078125e-07){v=1.0/u;n[t>>2]=v*(+p[E>>3]+(y*+p[c>>3]+k*+p[g>>3]+x*+p[h>>3]));M=v*(+p[r>>3]+(y*+p[K>>3]+k*+p[m>>3]+x*+p[l>>3]));N=t+4|0}else{n[t+4>>2]=0.0;M=0.0;N=t}n[N>>2]=M;C=C+1|0;if((C|0)==(d|0))break;else{t=t+8|0;B=B+12|0}}return}if(!s)return;s=e+1|0;B=c+((Y(s,f)|0)<<3)|0;M=+p[B+(e<<3)>>3];t=(f|0)>0;C=f<<2;if((e|0)>0){if(t){O=b;P=0;Q=a}else return;while(1){a=b+((Y(P,f)|0)<<2)|0;N=0;i=M;do{i=i+ +p[B+(N<<3)>>3]*+n[Q+(N<<2)>>2];N=N+1|0}while((N|0)!=(e|0));if(+L(+i)>1.1920928955078125e-07){N=c;l=0;while(1){m=0;J=+p[N+(e<<3)>>3];do{J=J+ +p[N+(m<<3)>>3]*+n[Q+(m<<2)>>2];m=m+1|0}while((m|0)!=(e|0));n[O+(l<<2)>>2]=i*J;l=l+1|0;if((l|0)==(f|0))break;else N=N+(s<<3)|0}}else F1a(a|0,0,C|0)|0;P=P+1|0;if((P|0)==(d|0))break;else{O=O+(f<<2)|0;Q=Q+(e<<2)|0}}return}else{if(!(+L(+M)>1.1920928955078125e-07)){if(t)R=0;else return;do{F1a(b+((Y(R,f)|0)<<2)|0,0,C|0)|0;R=R+1|0}while((R|0)!=(d|0));return}if(t){S=b;T=0}else return;while(1){b=c;t=0;while(1){n[S+(t<<2)>>2]=M*+p[b+(e<<3)>>3];t=t+1|0;if((t|0)==(f|0))break;else b=b+(s<<3)|0}T=T+1|0;if((T|0)==(d|0))break;else S=S+(f<<2)|0}return}}function BO(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,M=0,N=0,O=0,P=0,Q=0;g=(f|0)==2;if((e|0)==2&g){h=d<<1;if((d|0)<=0)return;i=c+48|0;j=c+56|0;k=c+64|0;l=c+8|0;m=c+16|0;n=c+24|0;o=c+32|0;q=c+40|0;r=0;do{s=+p[a+(r<<3)>>3];t=r|1;u=+p[a+(t<<3)>>3];v=+p[k>>3]+(s*+p[i>>3]+u*+p[j>>3]);if(+L(+v)>1.1920928955078125e-07){w=1.0/v;p[b+(r<<3)>>3]=w*(+p[m>>3]+(s*+p[c>>3]+u*+p[l>>3]));x=w*(+p[q>>3]+(s*+p[n>>3]+u*+p[o>>3]));y=t}else{p[b+(t<<3)>>3]=0.0;x=0.0;y=r}p[b+(y<<3)>>3]=x;r=r+2|0}while((r|0)<(h|0));return}h=(e|0)==3;if(h&(f|0)==3){r=d*3|0;if((d|0)<=0)return;y=c+96|0;o=c+104|0;n=c+112|0;q=c+120|0;l=c+8|0;m=c+16|0;j=c+24|0;i=c+32|0;k=c+40|0;t=c+48|0;z=c+56|0;A=c+64|0;B=c+72|0;C=c+80|0;D=c+88|0;E=0;do{x=+p[a+(E<<3)>>3];F=E+1|0;u=+p[a+(F<<3)>>3];G=E+2|0;s=+p[a+(G<<3)>>3];w=+p[q>>3]+(x*+p[y>>3]+u*+p[o>>3]+s*+p[n>>3]);if(+L(+w)>1.1920928955078125e-07){v=1.0/w;p[b+(E<<3)>>3]=v*(+p[j>>3]+(x*+p[c>>3]+u*+p[l>>3]+s*+p[m>>3]));p[b+(F<<3)>>3]=v*(+p[z>>3]+(x*+p[i>>3]+u*+p[k>>3]+s*+p[t>>3]));H=v*(+p[D>>3]+(x*+p[A>>3]+u*+p[B>>3]+s*+p[C>>3]));I=G}else{p[b+(G<<3)>>3]=0.0;p[b+(F<<3)>>3]=0.0;H=0.0;I=E}p[b+(I<<3)>>3]=H;E=E+3|0}while((E|0)<(r|0));return}r=(d|0)>0;if(h&g){if(!r)return;g=c+64|0;h=c+72|0;E=c+80|0;I=c+88|0;C=c+8|0;B=c+16|0;A=c+24|0;D=c+32|0;t=c+40|0;k=c+48|0;i=c+56|0;z=b;m=0;l=a;while(1){H=+p[l>>3];s=+p[l+8>>3];u=+p[l+16>>3];x=+p[I>>3]+(H*+p[g>>3]+s*+p[h>>3]+u*+p[E>>3]);if(+L(+x)>1.1920928955078125e-07){v=1.0/x;p[z>>3]=v*(+p[A>>3]+(H*+p[c>>3]+s*+p[C>>3]+u*+p[B>>3]));J=v*(+p[i>>3]+(H*+p[D>>3]+s*+p[t>>3]+u*+p[k>>3]));K=z+8|0}else{p[z+8>>3]=0.0;J=0.0;K=z}p[K>>3]=J;m=m+1|0;if((m|0)==(d|0))break;else{z=z+16|0;l=l+24|0}}return}if(!r)return;r=e+1|0;l=c+((Y(r,f)|0)<<3)|0;z=l+(e<<3)|0;m=(f|0)>0;K=f<<3;if((e|0)<=0){if(m){M=b;N=0}else return;while(1){J=+p[z>>3];if(+L(+J)>1.1920928955078125e-07){k=c;t=0;while(1){p[M+(t<<3)>>3]=J*+p[k+(e<<3)>>3];t=t+1|0;if((t|0)==(f|0))break;else k=k+(r<<3)|0}}else F1a(b+((Y(N,f)|0)<<3)|0,0,K|0)|0;N=N+1|0;if((N|0)==(d|0))break;else M=M+(f<<3)|0}return}if(m){O=b;P=0;Q=a}else return;while(1){a=b+((Y(P,f)|0)<<3)|0;m=0;J=+p[z>>3];do{J=J+ +p[l+(m<<3)>>3]*+p[Q+(m<<3)>>3];m=m+1|0}while((m|0)!=(e|0));if(+L(+J)>1.1920928955078125e-07){m=c;M=0;while(1){N=0;u=+p[m+(e<<3)>>3];do{u=u+ +p[m+(N<<3)>>3]*+p[Q+(N<<3)>>3];N=N+1|0}while((N|0)!=(e|0));p[O+(M<<3)>>3]=J*u;M=M+1|0;if((M|0)==(f|0))break;else m=m+(r<<3)|0}}else F1a(a|0,0,K|0)|0;P=P+1|0;if((P|0)==(d|0))break;else{O=O+(f<<3)|0;Q=Q+(e<<3)|0}}return}function CO(a,c,d,e){a=a|0;c=+c;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=u;u=u+256|0;h=g;i=g+248|0;j=g+192|0;k=g+136|0;l=g+80|0;m=g+72|0;o=g+56|0;q=g+40|0;r=g+8|0;p[h>>3]=c;_$(i,39884);s=RR(a,-1)|0;t=s&7;v=(s>>>3&511)+1|0;if((s|0)!=(RR(d,-1)|0)){f[j>>2]=0;f[j+4>>2]=0;w=c$(j,20)|0;x=168910;y=w+20|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));j$(-215,j,168931,168105,2494);d$(j)}if(t>>>0>=5){do if((NS(a)|0)==65536){z=f[a+4>>2]|0;f[j>>2]=f[z>>2];A=j+4|0;B=z+4|0;f[A>>2]=f[B>>2];C=j+8|0;f[C>>2]=f[z+8>>2];f[j+12>>2]=f[z+12>>2];f[j+16>>2]=f[z+16>>2];f[j+20>>2]=f[z+20>>2];f[j+24>>2]=f[z+24>>2];f[j+28>>2]=f[z+28>>2];f[j+32>>2]=f[z+32>>2];D=f[z+36>>2]|0;f[j+36>>2]=D;f[j+40>>2]=C;C=j+48|0;E=j+44|0;f[E>>2]=C;f[C>>2]=0;f[j+52>>2]=0;if(D|0){C=D+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[B>>2]|0)<3){B=f[z+44>>2]|0;C=f[E>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2];break}else{f[A>>2]=0;BR(j,z);break}}else OR(j,a,-1);while(0);do if((NS(d)|0)==65536){z=f[d+4>>2]|0;f[k>>2]=f[z>>2];A=k+4|0;B=z+4|0;f[A>>2]=f[B>>2];C=k+8|0;f[C>>2]=f[z+8>>2];f[k+12>>2]=f[z+12>>2];f[k+16>>2]=f[z+16>>2];f[k+20>>2]=f[z+20>>2];f[k+24>>2]=f[z+24>>2];f[k+28>>2]=f[z+28>>2];f[k+32>>2]=f[z+32>>2];E=f[z+36>>2]|0;f[k+36>>2]=E;D=k+40|0;f[D>>2]=C;C=k+48|0;F=k+44|0;f[F>>2]=C;f[C>>2]=0;f[k+52>>2]=0;if(E|0){C=E+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[B>>2]|0)<3){B=f[z+44>>2]|0;C=f[F>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2];G=D;break}else{f[A>>2]=0;BR(k,z);G=D;break}}else{OR(k,d,-1);G=k+40|0}while(0);D=j+40|0;z=f[D>>2]|0;A=f[z+-4>>2]|0;B=f[G>>2]|0;a:do if((A|0)==(f[B+-4>>2]|0)){if((A|0)==2){if((f[z>>2]|0)!=(f[B>>2]|0)){H=26;break}if((f[z+4>>2]|0)==(f[B+4>>2]|0)){I=z;break}else{H=26;break}}if((A|0)>0){C=0;while(1){if((f[z+(C<<2)>>2]|0)!=(f[B+(C<<2)>>2]|0)){H=26;break a}C=C+1|0;if((C|0)>=(A|0)){I=z;break}}}else I=z}else H=26;while(0);if((H|0)==26){f[l>>2]=0;f[l+4>>2]=0;w=c$(l,22)|0;x=168940;y=w+22|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));j$(-215,l,168931,168105,2506);d$(l);I=f[D>>2]|0}x=j+4|0;MR(e,f[x>>2]|0,I,s,-1,0,0);do if((NS(e)|0)==65536){s=f[e+4>>2]|0;f[l>>2]=f[s>>2];I=l+4|0;w=s+4|0;f[I>>2]=f[w>>2];y=l+8|0;f[y>>2]=f[s+8>>2];f[l+12>>2]=f[s+12>>2];f[l+16>>2]=f[s+16>>2];f[l+20>>2]=f[s+20>>2];f[l+24>>2]=f[s+24>>2];f[l+28>>2]=f[s+28>>2];f[l+32>>2]=f[s+32>>2];H=f[s+36>>2]|0;f[l+36>>2]=H;f[l+40>>2]=y;y=l+48|0;z=l+44|0;f[z>>2]=y;f[y>>2]=0;f[l+52>>2]=0;if(H|0){y=H+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[w>>2]|0)<3){w=f[s+44>>2]|0;y=f[z>>2]|0;f[y>>2]=f[w>>2];f[y+4>>2]=f[w+4>>2];break}else{f[I>>2]=0;BR(l,s);break}}else OR(l,e,-1);while(0);n[m>>2]=+p[h>>3];s=(t|0)==5;I=s?m:h;m=s?132:131;if(((f[j>>2]&16384|0)!=0?(f[k>>2]&16384|0)!=0:0)?(f[l>>2]&16384|0)!=0:0){s=f[x>>2]|0;if((s|0)<3)J=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{w=f[D>>2]|0;y=0;z=1;while(1){H=Y(f[w+(y<<2)>>2]|0,z)|0;y=y+1|0;if((y|0)==(s|0)){J=H;break}else z=H}}z=Y(J,v)|0;Bh[m&255](f[j+16>>2]|0,f[k+16>>2]|0,f[l+16>>2]|0,z,I)}else{f[o>>2]=j;f[o+4>>2]=k;f[o+8>>2]=l;f[o+12>>2]=0;bU(r,o,q,-1);o=Y(f[r+20>>2]|0,v)|0;v=r+16|0;z=q+4|0;J=q+8|0;s=0;while(1){if(s>>>0>=(f[v>>2]|0)>>>0)break;Bh[m&255](f[q>>2]|0,f[z>>2]|0,f[J>>2]|0,o,I);tR(r)|0;s=s+1|0}}s=l+36|0;r=f[s>>2]|0;if(r|0?(I=r+12|0,r=f[I>>2]|0,f[I>>2]=r+-1,(r|0)==1):0)CR(l);f[s>>2]=0;s=l+16|0;r=l+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[r>>2]|0)>0){s=f[l+40>>2]|0;I=0;do{f[s+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[r>>2]|0))}r=f[l+44>>2]|0;if((r|0)!=(l+48|0))ZF(r);r=k+36|0;l=f[r>>2]|0;if(l|0?(I=l+12|0,l=f[I>>2]|0,f[I>>2]=l+-1,(l|0)==1):0)CR(k);f[r>>2]=0;r=k+16|0;l=k+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[l>>2]|0)>0){r=f[G>>2]|0;G=0;do{f[r+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))ZF(l);l=j+36|0;k=f[l>>2]|0;if(k|0?(G=k+12|0,k=f[G>>2]|0,f[G>>2]=k+-1,(k|0)==1):0)CR(j);f[l>>2]=0;l=j+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[x>>2]|0)>0){l=f[D>>2]|0;D=0;do{f[l+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[x>>2]|0))}x=f[j+44>>2]|0;if((x|0)!=(j+48|0))ZF(x)}else hI(a,+p[h>>3],d,1.0,0.0,e,t);if(!(f[i+4>>2]|0)){u=g;return}u=g;return}function DO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0,i=0,j=0.0,k=0,l=0;f=+n[e>>2];e=d+-4|0;if((d|0)<4)g=0;else{h=0;do{i=h|1;j=f*+n[a+(i<<2)>>2]+ +n[b+(i<<2)>>2];n[c+(h<<2)>>2]=f*+n[a+(h<<2)>>2]+ +n[b+(h<<2)>>2];n[c+(i<<2)>>2]=j;i=h|2;k=h|3;j=f*+n[a+(k<<2)>>2]+ +n[b+(k<<2)>>2];n[c+(i<<2)>>2]=f*+n[a+(i<<2)>>2]+ +n[b+(i<<2)>>2];n[c+(k<<2)>>2]=j;h=h+4|0}while((h|0)<=(e|0));g=d&-4}if((g|0)<(d|0))l=g;else return;do{n[c+(l<<2)>>2]=f*+n[a+(l<<2)>>2]+ +n[b+(l<<2)>>2];l=l+1|0}while((l|0)!=(d|0));return}function EO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0,i=0,j=0.0,k=0,l=0;f=+p[e>>3];e=d+-4|0;if((d|0)<4)g=0;else{h=0;do{i=h|1;j=f*+p[a+(i<<3)>>3]+ +p[b+(i<<3)>>3];p[c+(h<<3)>>3]=f*+p[a+(h<<3)>>3]+ +p[b+(h<<3)>>3];p[c+(i<<3)>>3]=j;i=h|2;k=h|3;j=f*+p[a+(k<<3)>>3]+ +p[b+(k<<3)>>3];p[c+(i<<3)>>3]=f*+p[a+(i<<3)>>3]+ +p[b+(i<<3)>>3];p[c+(k<<3)>>3]=j;h=h+4|0}while((h|0)<=(e|0));g=d&-4}if((g|0)<(d|0))l=g;else return;do{p[c+(l<<3)>>3]=f*+p[a+(l<<3)>>3]+ +p[b+(l<<3)>>3];l=l+1|0}while((l|0)!=(d|0));return}function FO(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;i=u;u=u+352|0;j=i+344|0;k=i+288|0;l=i+232|0;m=i+176|0;n=i+120|0;o=i+104|0;p=i+88|0;q=i+72|0;r=i+16|0;s=i;_$(j,39904);do if((NS(a)|0)==65536){t=f[a+4>>2]|0;f[k>>2]=f[t>>2];v=k+4|0;w=t+4|0;f[v>>2]=f[w>>2];x=k+8|0;f[x>>2]=f[t+8>>2];f[k+12>>2]=f[t+12>>2];f[k+16>>2]=f[t+16>>2];f[k+20>>2]=f[t+20>>2];f[k+24>>2]=f[t+24>>2];f[k+28>>2]=f[t+28>>2];f[k+32>>2]=f[t+32>>2];y=f[t+36>>2]|0;f[k+36>>2]=y;f[k+40>>2]=x;x=k+48|0;z=k+44|0;f[z>>2]=x;f[x>>2]=0;f[k+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;x=f[z>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[v>>2]=0;BR(k,t);break}}else OR(k,a,-1);while(0);do if((NS(e)|0)==65536){a=f[e+4>>2]|0;f[l>>2]=f[a>>2];t=l+4|0;v=a+4|0;f[t>>2]=f[v>>2];w=l+8|0;f[w>>2]=f[a+8>>2];f[l+12>>2]=f[a+12>>2];f[l+16>>2]=f[a+16>>2];f[l+20>>2]=f[a+20>>2];f[l+24>>2]=f[a+24>>2];f[l+28>>2]=f[a+28>>2];f[l+32>>2]=f[a+32>>2];x=f[a+36>>2]|0;f[l+36>>2]=x;f[l+40>>2]=w;w=l+48|0;z=l+44|0;f[z>>2]=w;f[w>>2]=0;f[l+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[a+44>>2]|0;w=f[z>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];A=l;break}else{f[t>>2]=0;BR(l,a);A=l;break}}else{OR(l,e,-1);A=l}while(0);e=f[k>>2]|0;a=e&4095;t=((h|0)>-1?h:e)&7;h=f[A>>2]&7;v=t>>>0<h>>>0?h:t;t=(v|0)>5?v:5;if(e&4088|0){f[m>>2]=0;f[m+4>>2]=0;B=c$(m,19)|0;C=169026;D=B+19|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));j$(-215,m,169046,168105,2967);d$(m)}e=l+16|0;if(f[e>>2]|0){h=f[l+4>>2]|0;if((h|0)<3)E=Y(f[l+12>>2]|0,f[l+8>>2]|0)|0;else{w=f[l+40>>2]|0;z=0;x=1;while(1){y=Y(f[w+(z<<2)>>2]|0,x)|0;z=z+1|0;if((z|0)==(h|0)){E=y;break}else x=y}}if(!((h|0)==0|(E|0)==0)){if(f[A>>2]&4088|0){f[m>>2]=0;f[m+4>>2]=0;B=c$(m,21)|0;C=169060;D=B+21|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));j$(-215,m,169046,168105,2973);d$(m)}E=f[l+8>>2]|0;if(!((E|0)==1?1:(E|0)==(f[k+8>>2]|0))){f[m>>2]=0;f[m+4>>2]=0;B=c$(m,43)|0;C=169082;D=B+43|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));j$(-215,m,169046,168105,2973);d$(m)}E=f[l+12>>2]|0;if(!((E|0)==1?1:(E|0)==(f[k+12>>2]|0))){f[m>>2]=0;f[m+4>>2]=0;B=c$(m,43)|0;C=169126;D=B+43|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));j$(-215,m,169046,168105,2973);d$(m)}if((f[A>>2]&4095|0)!=(t|0)){A=m+8|0;f[A>>2]=0;f[A+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=l;WJ(l,m,t,1.0,0.0)}}}A=k+8|0;C=k+12|0;E=d?f[C>>2]|0:f[A>>2]|0;pS(c,E,E,t,-1,0,0);do if((NS(c)|0)==65536){E=f[c+4>>2]|0;f[m>>2]=f[E>>2];h=m+4|0;x=E+4|0;f[h>>2]=f[x>>2];z=m+8|0;f[z>>2]=f[E+8>>2];f[m+12>>2]=f[E+12>>2];w=m+16|0;f[w>>2]=f[E+16>>2];f[m+20>>2]=f[E+20>>2];f[m+24>>2]=f[E+24>>2];f[m+28>>2]=f[E+28>>2];f[m+32>>2]=f[E+32>>2];y=f[E+36>>2]|0;f[m+36>>2]=y;f[m+40>>2]=z;z=m+48|0;F=m+44|0;f[F>>2]=z;f[z>>2]=0;f[m+52>>2]=0;if(y|0){z=y+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[x>>2]|0)<3){x=f[E+44>>2]|0;z=f[F>>2]|0;f[z>>2]=f[x>>2];f[z+4>>2]=f[x+4>>2];G=w;break}else{f[h>>2]=0;BR(m,E);G=w;break}}else{OR(m,c,-1);G=m+16|0}while(0);c=k+16|0;do if((f[c>>2]|0)==(f[G>>2]|0))H=42;else{if(((a|0)==(t|0)?(f[m+12>>2]|0)>99:0)?((f[C>>2]|0)>99?(f[m+8>>2]|0)>99:0)&(f[A>>2]|0)>99:0){H=42;break}w=(a|0)==0;E=(v|0)<6;do if(!(w&E)){h=(t|0)==6;if(w&h){I=d?18:17;break}x=(a|0)==2;if(x&E){I=d?20:19;break}if(x&h){I=d?22:21;break}x=(a|0)==3;if(x&E){I=d?24:23;break}if(x&h){I=d?26:25;break}x=(a|0)==5;if(x&E){I=d?28:27;break}if(x&h){I=d?30:29;break}if((a|0)==6&h)I=d?32:31;else{f[n>>2]=0;f[n+4>>2]=0;j$(-210,n,169046,168105,3068);d$(n)}}else I=d?16:15;while(0);vh[I&63](k,m,l,g);E=n+8|0;f[E>>2]=0;f[E+4>>2]=0;f[n>>2]=50397184;f[n+4>>2]=m;mT(n,0)}while(0);if((H|0)==42){f[n>>2]=1124007936;H=n+4|0;I=n+8|0;a=n+40|0;B=H;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[a>>2]=I;I=n+48|0;t=n+44|0;f[t>>2]=I;f[I>>2]=0;f[n+52>>2]=0;do if(f[e>>2]|0){v=f[l+4>>2]|0;if((v|0)<3)J=Y(f[l+12>>2]|0,f[l+8>>2]|0)|0;else{E=f[l+40>>2]|0;w=0;h=1;while(1){x=Y(f[E+(w<<2)>>2]|0,h)|0;w=w+1|0;if((w|0)==(v|0)){J=x;break}else h=x}}if(!((v|0)==0|(J|0)==0)){h=f[l+40>>2]|0;w=f[k+40>>2]|0;if((f[h>>2]|0)==(f[w>>2]|0)?(f[h+4>>2]|0)==(f[w+4>>2]|0):0){f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=l;w=q+8|0;f[w>>2]=0;f[w+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=n;hH(o,p,q,fT()|0,-1);K=n;break}else{f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=l;w=f[A>>2]|0;h=f[l+8>>2]|0;E=f[C>>2]|0;x=f[l+12>>2]|0;z=p+8|0;f[z>>2]=0;f[z+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=n;kL(o,(w|0)/(h|0)|0,(E|0)/(x|0)|0,p);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=n;x=q+8|0;f[x>>2]=0;f[x+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=n;hH(o,p,q,fT()|0,-1);K=n;break}}else K=k}else K=k;while(0);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=K;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=K;f[r>>2]=1124007936;K=r+4|0;C=r+8|0;A=r+40|0;B=K;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[A>>2]=C;C=r+48|0;B=r+44|0;f[B>>2]=C;f[C>>2]=0;f[r+52>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=r;D=s+8|0;f[D>>2]=0;f[D+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=m;jO(o,p,g,q,0.0,s,d?1:2);d=r+36|0;s=f[d>>2]|0;if(s|0?(q=s+12|0,s=f[q>>2]|0,f[q>>2]=s+-1,(s|0)==1):0)CR(r);f[d>>2]=0;d=r+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[K>>2]|0)>0){d=f[A>>2]|0;A=0;do{f[d+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[K>>2]|0))}K=f[B>>2]|0;if((K|0)!=(C|0))ZF(K);K=n+36|0;C=f[K>>2]|0;if(C|0?(B=C+12|0,C=f[B>>2]|0,f[B>>2]=C+-1,(C|0)==1):0)CR(n);f[K>>2]=0;K=n+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[H>>2]|0)>0){K=f[a>>2]|0;a=0;do{f[K+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[H>>2]|0))}H=f[t>>2]|0;if((H|0)!=(I|0))ZF(H)}H=m+36|0;I=f[H>>2]|0;if(I|0?(t=I+12|0,I=f[t>>2]|0,f[t>>2]=I+-1,(I|0)==1):0)CR(m);f[H>>2]=0;H=m+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[H>>2]|0)>0){G=f[m+40>>2]|0;I=0;do{f[G+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[H>>2]|0))}H=f[m+44>>2]|0;if((H|0)!=(m+48|0))ZF(H);H=l+36|0;m=f[H>>2]|0;if(m|0?(I=m+12|0,m=f[I>>2]|0,f[I>>2]=m+-1,(m|0)==1):0)CR(l);f[H>>2]=0;H=l+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[H>>2]|0)>0){e=f[l+40>>2]|0;m=0;do{f[e+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[H>>2]|0))}H=f[l+44>>2]|0;if((H|0)!=(l+48|0))ZF(H);H=k+36|0;l=f[H>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)CR(k);f[H>>2]=0;H=k+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[H>>2]|0)>0){c=f[k+40>>2]|0;l=0;do{f[c+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[H>>2]|0))}H=f[k+44>>2]|0;if((H|0)!=(k+48|0))ZF(H);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function GO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;e=u;u=u+1040|0;g=e;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=f[a+48>>2]|0;m=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;p=f[c>>2]|0;c=g+8|0;f[g>>2]=c;q=g+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(o|0)<(a|0);o=r&s?p*20|0:p<<2;f[q>>2]=o;if(o>>>0>1032){t=OYa(o)|0;f[g>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(p<<2)|0;if((p|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{o=k+((Y(A,b)|0)<<2)|0;B=f[o>>2]|0;o=A<<2;f[t+((o|3)<<2)>>2]=B;f[t+((o|2)<<2)>>2]=B;f[t+((o|1)<<2)>>2]=B;f[t+(o<<2)>>2]=B;A=A+1|0}while((A|0)!=(p|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){B=(y|0)!=0;o=(p|0)>0;C=a+-4|0;D=d*0.0;E=d*0.0;F=d*0.0;G=0;H=j;while(1){if(B){if(o){I=0;do{J=i+((Y(I,l)|0)+G)|0;K=y+((Y(I,z)|0)<<2)|0;n[v+(I<<2)>>2]=+(h[J>>0]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}}else if(o){I=0;do{t=i+((Y(I,l)|0)+G)|0;K=x+((Y(I,z)|0)+G<<2)|0;n[v+(I<<2)>>2]=+(h[t>>0]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}b:do if((G|0)>(C|0))L=G;else{if(o)M=G;else{I=G;while(1){n[H+(I<<2)>>2]=F;n[H+(I+1<<2)>>2]=F;n[H+(I+2<<2)>>2]=F;n[H+(I+3<<2)>>2]=F;K=I+4|0;if((K|0)>(C|0)){L=K;break b}else I=K}}while(1){I=B?y:x+(M<<2)|0;K=0;N=0.0;O=0.0;P=0.0;Q=0.0;t=i+M|0;while(1){R=+n[v+(K<<2)>>2];N=N+R*(+(h[t>>0]|0)-+n[I>>2]);O=O+R*(+(h[t+1>>0]|0)-+n[I+4>>2]);P=P+R*(+(h[t+2>>0]|0)-+n[I+8>>2]);Q=Q+R*(+(h[t+3>>0]|0)-+n[I+12>>2]);K=K+1|0;if((K|0)==(p|0))break;else{I=I+(z<<2)|0;t=t+l|0}}n[H+(M<<2)>>2]=N*d;n[H+(M+1<<2)>>2]=O*d;n[H+(M+2<<2)>>2]=P*d;n[H+(M+3<<2)>>2]=Q*d;t=M+4|0;if((t|0)>(C|0)){L=t;break}else M=t}}while(0);c:do if((L|0)<(a|0)){if(!o)if(B){t=L;while(1){n[H+(t<<2)>>2]=D;t=t+1|0;if((t|0)==(a|0))break c}}else{t=L;while(1){n[H+(t<<2)>>2]=E;t=t+1|0;if((t|0)==(a|0))break c}}if(B){t=L;do{I=y;K=0;R=0.0;J=i+t|0;while(1){R=R+ +n[v+(K<<2)>>2]*(+(h[J>>0]|0)-+n[I>>2]);K=K+1|0;if((K|0)==(p|0))break;else{I=I+(z<<2)|0;J=J+l|0}}n[H+(t<<2)>>2]=R*d;t=t+1|0}while((t|0)!=(a|0))}else{t=L;do{J=x+(t<<2)|0;I=0;Q=0.0;K=i+t|0;while(1){Q=Q+ +n[v+(I<<2)>>2]*(+(h[K>>0]|0)-+n[J>>2]);I=I+1|0;if((I|0)==(p|0))break;else{J=J+(z<<2)|0;K=K+l|0}}n[H+(t<<2)>>2]=Q*d;t=t+1|0}while((t|0)!=(a|0))}}while(0);G=G+1|0;if((G|0)==(a|0))break;else H=H+(m<<2)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(p|0)>0;z=a+-4|0;E=d*0.0;D=d*0.0;x=0;L=j;while(1){if(w){j=0;do{y=i+((Y(j,l)|0)+x)|0;n[v+(j<<2)>>2]=+(h[y>>0]|0);j=j+1|0}while((j|0)!=(p|0))}d:do if((x|0)>(z|0))S=x;else{if(w)T=x;else{j=x;while(1){n[L+(j<<2)>>2]=D;n[L+(j+1<<2)>>2]=D;n[L+(j+2<<2)>>2]=D;n[L+(j+3<<2)>>2]=D;y=j+4|0;if((y|0)>(z|0)){S=y;break d}else j=y}}while(1){j=0;F=0.0;R=0.0;P=0.0;O=0.0;y=i+T|0;while(1){N=+n[v+(j<<2)>>2];F=F+N*+(h[y>>0]|0);R=R+N*+(h[y+1>>0]|0);P=P+N*+(h[y+2>>0]|0);O=O+N*+(h[y+3>>0]|0);j=j+1|0;if((j|0)==(p|0))break;else y=y+l|0}n[L+(T<<2)>>2]=F*d;n[L+(T+1<<2)>>2]=R*d;n[L+(T+2<<2)>>2]=P*d;n[L+(T+3<<2)>>2]=O*d;y=T+4|0;if((y|0)>(z|0)){S=y;break}else T=y}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{y=S;while(1){n[L+(y<<2)>>2]=E;y=y+1|0;if((y|0)==(a|0))break e}}do{y=0;N=0.0;j=i+U|0;while(1){N=N+ +n[v+(y<<2)>>2]*+(h[j>>0]|0);y=y+1|0;if((y|0)==(p|0))break;else j=j+l|0}n[L+(U<<2)>>2]=N*d;U=U+1|0}while((U|0)!=(a|0))}while(0);x=x+1|0;if((x|0)==(a|0))break;else L=L+(m<<2)|0}}if((v|0)==(c|0)){u=e;return}QYa(v);f[g>>2]=c;f[q>>2]=1032;u=e;return}function HO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0,V=0,W=0,X=0,Z=0,_=0.0,$=0,aa=0.0,ba=0,ca=0.0;e=u;u=u+1056|0;g=e+1040|0;i=e;j=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=f[a+48>>2]|0;o=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;p=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=e;return}c=a+-4|0;r=(a|0)<4;t=a&-4;v=(a|0)>0;w=(t|0)<(a|0);x=0;y=k;while(1){z=j+(Y(x,m)|0)|0;if(r){A=x;do{B=j+(Y(A,m)|0)|0;if(v){C=0;D=0.0;while(1){E=D+ +(h[z+C>>0]|0)*+(h[B+C>>0]|0);C=C+1|0;if((C|0)==(a|0)){F=E;break}else D=E}}else F=0.0;n[y+(A<<2)>>2]=F*d;A=A+1|0}while((A|0)!=(q|0))}else{A=x;do{C=j+(Y(A,m)|0)|0;B=0;D=0.0;do{G=B|1;H=B|2;I=B|3;D=D+(+(h[z+B>>0]|0)*+(h[C+B>>0]|0)+ +(h[z+G>>0]|0)*+(h[C+G>>0]|0)+ +(h[z+H>>0]|0)*+(h[C+H>>0]|0)+ +(h[z+I>>0]|0)*+(h[C+I>>0]|0));B=B+4|0}while((B|0)<=(c|0));if(w){B=t;E=D;while(1){J=E+ +(h[z+B>>0]|0)*+(h[C+B>>0]|0);B=B+1|0;if((B|0)==(a|0)){K=J;break}else E=J}}else K=D;n[y+(A<<2)>>2]=K*d;A=A+1|0}while((A|0)!=(q|0))}x=x+1|0;if((x|0)==(q|0))break;else y=y+(o<<2)|0}u=e;return}y=(p|0)==(a|0)?4:0;x=a<<2;t=i+8|0;f[i>>2]=t;w=i+4|0;f[w>>2]=x;if(x>>>0>1032){c=OYa(x)|0;f[i>>2]=c;L=c}else L=t;if((q|0)>0){c=(p|0)<(a|0);p=(a|0)>0;x=g+12|0;v=g+8|0;r=g+4|0;A=a+-4|0;z=(a|0)<4;B=a&-4;C=Y(y,B)|0;I=g+C|0;H=0;G=l+C|0;C=k;while(1){k=j+(Y(H,m)|0)|0;M=l+((Y(H,b)|0)<<2)|0;if(c)if(p){N=0;do{n[L+(N<<2)>>2]=+(h[k+N>>0]|0)-+n[M>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{P=H;O=22}else if(p){N=0;do{n[L+(N<<2)>>2]=+(h[k+N>>0]|0)-+n[M+(N<<2)>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{Q=G;R=H;O=31}if((O|0)==21){O=0;if(c){P=H;O=22}else{Q=G;R=H;O=31}}if((O|0)==22)while(1){O=0;N=j+(Y(P,m)|0)|0;M=l+((Y(P,b)|0)<<2)|0;k=f[M>>2]|0;f[x>>2]=k;f[v>>2]=k;f[r>>2]=k;f[g>>2]=k;a:do if(z){S=0;T=0.0;U=g}else{K=(f[s>>2]=k,+n[s>>2]);M=0;F=0.0;V=g;while(1){W=M|1;X=M|2;Z=M|3;E=F+(+n[L+(M<<2)>>2]*(+(h[N+M>>0]|0)-K)+ +n[L+(W<<2)>>2]*(+(h[N+W>>0]|0)-+n[V+4>>2])+ +n[L+(X<<2)>>2]*(+(h[N+X>>0]|0)-+n[V+8>>2])+ +n[L+(Z<<2)>>2]*(+(h[N+Z>>0]|0)-+n[V+12>>2]));Z=M+4|0;X=V+(y<<2)|0;if((Z|0)>(A|0)){S=B;T=E;U=I;break a}K=+n[X>>2];M=Z;F=E;V=X}}while(0);if((S|0)<(a|0)){k=S;D=T;V=U;while(1){F=D+ +n[L+(k<<2)>>2]*(+(h[N+k>>0]|0)-+n[V>>2]);k=k+1|0;if((k|0)==(a|0)){_=F;break}else{D=F;V=V+4|0}}}else _=T;n[C+(P<<2)>>2]=_*d;P=P+1|0;if((P|0)==(q|0))break;else O=22}else if((O|0)==31)while(1){O=0;V=j+(Y(R,m)|0)|0;k=l+((Y(R,b)|0)<<2)|0;if(z){$=0;aa=0.0;ba=k}else{N=0;D=0.0;M=k;while(1){k=N|1;X=N|2;Z=N|3;F=D+(+n[L+(N<<2)>>2]*(+(h[V+N>>0]|0)-+n[M>>2])+ +n[L+(k<<2)>>2]*(+(h[V+k>>0]|0)-+n[M+4>>2])+ +n[L+(X<<2)>>2]*(+(h[V+X>>0]|0)-+n[M+8>>2])+ +n[L+(Z<<2)>>2]*(+(h[V+Z>>0]|0)-+n[M+12>>2]));N=N+4|0;if((N|0)>(A|0)){$=B;aa=F;ba=Q;break}else{D=F;M=M+(y<<2)|0}}}if(($|0)<(a|0)){M=$;D=aa;N=ba;while(1){F=D+ +n[L+(M<<2)>>2]*(+(h[V+M>>0]|0)-+n[N>>2]);M=M+1|0;if((M|0)==(a|0)){ca=F;break}else{D=F;N=N+4|0}}}else ca=aa;n[C+(R<<2)>>2]=ca*d;R=R+1|0;if((R|0)==(q|0))break;else{Q=Q+(b<<2)|0;O=31}}H=H+1|0;if((H|0)==(q|0))break;else{G=G+(b<<2)|0;C=C+(o<<2)|0}}}if((L|0)!=(t|0)){QYa(L);f[i>>2]=t;f[w>>2]=1032}u=e;return}function IO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;e=u;u=u+1040|0;g=e;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=f[a+48>>2]|0;m=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;n=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;c=g+8|0;f[g>>2]=c;q=g+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(n|0)<(a|0);n=r&s?o*40|0:o<<3;f[q>>2]=n;if(n>>>0>1032){t=OYa(n)|0;f[g>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(o<<3)|0;if((o|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{n=k+((Y(A,b)|0)<<3)|0;B=+p[n>>3];n=A<<2;p[t+((n|3)<<3)>>3]=B;p[t+((n|2)<<3)>>3]=B;p[t+((n|1)<<3)>>3]=B;p[t+(n<<3)>>3]=B;A=A+1|0}while((A|0)!=(o|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){n=(y|0)!=0;C=(o|0)>0;D=a+-4|0;B=d*0.0;E=d*0.0;F=d*0.0;G=0;H=j;while(1){if(n){if(C){I=0;do{J=i+((Y(I,l)|0)+G)|0;K=y+((Y(I,z)|0)<<3)|0;p[v+(I<<3)>>3]=+(h[J>>0]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}}else if(C){I=0;do{t=i+((Y(I,l)|0)+G)|0;K=x+((Y(I,z)|0)+G<<3)|0;p[v+(I<<3)>>3]=+(h[t>>0]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}b:do if((G|0)>(D|0))L=G;else{if(C)M=G;else{I=G;while(1){p[H+(I<<3)>>3]=F;p[H+(I+1<<3)>>3]=F;p[H+(I+2<<3)>>3]=F;p[H+(I+3<<3)>>3]=F;K=I+4|0;if((K|0)>(D|0)){L=K;break b}else I=K}}while(1){I=n?y:x+(M<<3)|0;K=0;N=0.0;O=0.0;P=0.0;Q=0.0;t=i+M|0;while(1){R=+p[v+(K<<3)>>3];N=N+R*(+(h[t>>0]|0)-+p[I>>3]);O=O+R*(+(h[t+1>>0]|0)-+p[I+8>>3]);P=P+R*(+(h[t+2>>0]|0)-+p[I+16>>3]);Q=Q+R*(+(h[t+3>>0]|0)-+p[I+24>>3]);K=K+1|0;if((K|0)==(o|0))break;else{I=I+(z<<3)|0;t=t+l|0}}p[H+(M<<3)>>3]=N*d;p[H+(M+1<<3)>>3]=O*d;p[H+(M+2<<3)>>3]=P*d;p[H+(M+3<<3)>>3]=Q*d;t=M+4|0;if((t|0)>(D|0)){L=t;break}else M=t}}while(0);c:do if((L|0)<(a|0)){if(!C)if(n){t=L;while(1){p[H+(t<<3)>>3]=B;t=t+1|0;if((t|0)==(a|0))break c}}else{t=L;while(1){p[H+(t<<3)>>3]=E;t=t+1|0;if((t|0)==(a|0))break c}}if(n){t=L;do{I=y;K=0;R=0.0;J=i+t|0;while(1){R=R+ +p[v+(K<<3)>>3]*(+(h[J>>0]|0)-+p[I>>3]);K=K+1|0;if((K|0)==(o|0))break;else{I=I+(z<<3)|0;J=J+l|0}}p[H+(t<<3)>>3]=R*d;t=t+1|0}while((t|0)!=(a|0))}else{t=L;do{J=x+(t<<3)|0;I=0;Q=0.0;K=i+t|0;while(1){Q=Q+ +p[v+(I<<3)>>3]*(+(h[K>>0]|0)-+p[J>>3]);I=I+1|0;if((I|0)==(o|0))break;else{J=J+(z<<3)|0;K=K+l|0}}p[H+(t<<3)>>3]=Q*d;t=t+1|0}while((t|0)!=(a|0))}}while(0);G=G+1|0;if((G|0)==(a|0))break;else H=H+(m<<3)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(o|0)>0;z=a+-4|0;E=d*0.0;B=d*0.0;x=0;L=j;while(1){if(w){j=0;do{y=i+((Y(j,l)|0)+x)|0;p[v+(j<<3)>>3]=+(h[y>>0]|0);j=j+1|0}while((j|0)!=(o|0))}d:do if((x|0)>(z|0))S=x;else{if(w)T=x;else{j=x;while(1){p[L+(j<<3)>>3]=B;p[L+(j+1<<3)>>3]=B;p[L+(j+2<<3)>>3]=B;p[L+(j+3<<3)>>3]=B;y=j+4|0;if((y|0)>(z|0)){S=y;break d}else j=y}}while(1){j=0;F=0.0;R=0.0;P=0.0;O=0.0;y=i+T|0;while(1){N=+p[v+(j<<3)>>3];F=F+N*+(h[y>>0]|0);R=R+N*+(h[y+1>>0]|0);P=P+N*+(h[y+2>>0]|0);O=O+N*+(h[y+3>>0]|0);j=j+1|0;if((j|0)==(o|0))break;else y=y+l|0}p[L+(T<<3)>>3]=F*d;p[L+(T+1<<3)>>3]=R*d;p[L+(T+2<<3)>>3]=P*d;p[L+(T+3<<3)>>3]=O*d;y=T+4|0;if((y|0)>(z|0)){S=y;break}else T=y}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{y=S;while(1){p[L+(y<<3)>>3]=E;y=y+1|0;if((y|0)==(a|0))break e}}do{y=0;N=0.0;j=i+U|0;while(1){N=N+ +p[v+(y<<3)>>3]*+(h[j>>0]|0);y=y+1|0;if((y|0)==(o|0))break;else j=j+l|0}p[L+(U<<3)>>3]=N*d;U=U+1|0}while((U|0)!=(a|0))}while(0);x=x+1|0;if((x|0)==(a|0))break;else L=L+(m<<3)|0}}if((v|0)==(c|0)){u=e;return}QYa(v);f[g>>2]=c;f[q>>2]=1032;u=e;return}function JO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0.0,Z=0,_=0.0,$=0,aa=0.0;e=u;u=u+1072|0;g=e;i=e+32|0;j=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=f[a+48>>2]|0;n=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=e;return}c=a+-4|0;r=(a|0)<4;s=a&-4;t=(a|0)>0;v=(s|0)<(a|0);w=0;x=k;while(1){y=j+(Y(w,m)|0)|0;if(r){z=w;do{A=j+(Y(z,m)|0)|0;if(t){B=0;C=0.0;while(1){D=C+ +(h[y+B>>0]|0)*+(h[A+B>>0]|0);B=B+1|0;if((B|0)==(a|0)){E=D;break}else C=D}}else E=0.0;p[x+(z<<3)>>3]=E*d;z=z+1|0}while((z|0)!=(q|0))}else{z=w;do{B=j+(Y(z,m)|0)|0;A=0;C=0.0;do{F=A|1;G=A|2;H=A|3;C=C+(+(h[y+A>>0]|0)*+(h[B+A>>0]|0)+ +(h[y+F>>0]|0)*+(h[B+F>>0]|0)+ +(h[y+G>>0]|0)*+(h[B+G>>0]|0)+ +(h[y+H>>0]|0)*+(h[B+H>>0]|0));A=A+4|0}while((A|0)<=(c|0));if(v){A=s;D=C;while(1){I=D+ +(h[y+A>>0]|0)*+(h[B+A>>0]|0);A=A+1|0;if((A|0)==(a|0)){J=I;break}else D=I}}else J=C;p[x+(z<<3)>>3]=J*d;z=z+1|0}while((z|0)!=(q|0))}w=w+1|0;if((w|0)==(q|0))break;else x=x+(n<<3)|0}u=e;return}x=(o|0)==(a|0)?4:0;w=a<<3;s=i+8|0;f[i>>2]=s;v=i+4|0;f[v>>2]=w;if(w>>>0>1032){c=OYa(w)|0;f[i>>2]=c;K=c}else K=s;if((q|0)>0){c=(o|0)<(a|0);o=(a|0)>0;w=g+24|0;t=g+16|0;r=g+8|0;z=a+-4|0;y=(a|0)<4;A=z>>>2;B=(A<<2)+4|0;H=Y(x,(A<<3)+8|0)|0;A=g+H|0;G=0;F=l+H|0;H=k;while(1){k=j+(Y(G,m)|0)|0;L=l+((Y(G,b)|0)<<3)|0;if(c)if(o){M=0;do{p[K+(M<<3)>>3]=+(h[k+M>>0]|0)-+p[L>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{O=G;N=22}else if(o){M=0;do{p[K+(M<<3)>>3]=+(h[k+M>>0]|0)-+p[L+(M<<3)>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{P=F;Q=G;N=30}if((N|0)==21){N=0;if(c){O=G;N=22}else{P=F;Q=G;N=30}}if((N|0)==22)while(1){N=0;M=j+(Y(O,m)|0)|0;L=l+((Y(O,b)|0)<<3)|0;J=+p[L>>3];p[w>>3]=J;p[t>>3]=J;p[r>>3]=J;p[g>>3]=J;a:do if(y){R=0;S=0.0;T=g}else{E=J;L=0;D=0.0;k=g;while(1){U=L|1;V=L|2;W=L|3;I=D+(+p[K+(L<<3)>>3]*(+(h[M+L>>0]|0)-E)+ +p[K+(U<<3)>>3]*(+(h[M+U>>0]|0)-+p[k+8>>3])+ +p[K+(V<<3)>>3]*(+(h[M+V>>0]|0)-+p[k+16>>3])+ +p[K+(W<<3)>>3]*(+(h[M+W>>0]|0)-+p[k+24>>3]));W=L+4|0;V=k+(x<<3)|0;if((W|0)>(z|0)){R=B;S=I;T=A;break a}E=+p[V>>3];L=W;D=I;k=V}}while(0);if((R|0)<(a|0)){k=R;J=S;L=T;while(1){C=J+ +p[K+(k<<3)>>3]*(+(h[M+k>>0]|0)-+p[L>>3]);k=k+1|0;if((k|0)==(a|0)){X=C;break}else{J=C;L=L+8|0}}}else X=S;p[H+(O<<3)>>3]=X*d;O=O+1|0;if((O|0)==(q|0))break;else N=22}else if((N|0)==30)while(1){N=0;L=j+(Y(Q,m)|0)|0;k=l+((Y(Q,b)|0)<<3)|0;if(y){Z=0;_=0.0;$=k}else{M=0;J=0.0;V=k;while(1){k=M|1;W=M|2;U=M|3;C=J+(+p[K+(M<<3)>>3]*(+(h[L+M>>0]|0)-+p[V>>3])+ +p[K+(k<<3)>>3]*(+(h[L+k>>0]|0)-+p[V+8>>3])+ +p[K+(W<<3)>>3]*(+(h[L+W>>0]|0)-+p[V+16>>3])+ +p[K+(U<<3)>>3]*(+(h[L+U>>0]|0)-+p[V+24>>3]));M=M+4|0;if((M|0)>(z|0)){Z=B;_=C;$=P;break}else{J=C;V=V+(x<<3)|0}}}if((Z|0)<(a|0)){V=Z;J=_;M=$;while(1){C=J+ +p[K+(V<<3)>>3]*(+(h[L+V>>0]|0)-+p[M>>3]);V=V+1|0;if((V|0)==(a|0)){aa=C;break}else{J=C;M=M+8|0}}}else aa=_;p[H+(Q<<3)>>3]=aa*d;Q=Q+1|0;if((Q|0)==(q|0))break;else{P=P+(b<<3)|0;N=30}}G=G+1|0;if((G|0)==(q|0))break;else{F=F+(b<<3)|0;H=H+(n<<3)|0}}}if((K|0)!=(s|0)){QYa(K);f[i>>2]=s;f[v>>2]=1032}u=e;return}function KO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;e=u;u=u+1040|0;g=e;h=f[a+16>>2]|0;i=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>1;m=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;p=f[c>>2]|0;c=g+8|0;f[g>>2]=c;q=g+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(o|0)<(a|0);o=r&s?p*20|0:p<<2;f[q>>2]=o;if(o>>>0>1032){t=OYa(o)|0;f[g>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(p<<2)|0;if((p|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{o=k+((Y(A,b)|0)<<2)|0;B=f[o>>2]|0;o=A<<2;f[t+((o|3)<<2)>>2]=B;f[t+((o|2)<<2)>>2]=B;f[t+((o|1)<<2)>>2]=B;f[t+(o<<2)>>2]=B;A=A+1|0}while((A|0)!=(p|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){B=(y|0)!=0;o=(p|0)>0;C=a+-4|0;D=d*0.0;E=d*0.0;F=d*0.0;G=0;H=i;while(1){if(B){if(o){I=0;do{J=h+((Y(I,l)|0)+G<<1)|0;K=y+((Y(I,z)|0)<<2)|0;n[v+(I<<2)>>2]=+(j[J>>1]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}}else if(o){I=0;do{t=h+((Y(I,l)|0)+G<<1)|0;K=x+((Y(I,z)|0)+G<<2)|0;n[v+(I<<2)>>2]=+(j[t>>1]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}b:do if((G|0)>(C|0))L=G;else{if(o)M=G;else{I=G;while(1){n[H+(I<<2)>>2]=F;n[H+(I+1<<2)>>2]=F;n[H+(I+2<<2)>>2]=F;n[H+(I+3<<2)>>2]=F;K=I+4|0;if((K|0)>(C|0)){L=K;break b}else I=K}}while(1){I=B?y:x+(M<<2)|0;K=0;N=0.0;O=0.0;P=0.0;Q=0.0;t=h+(M<<1)|0;while(1){R=+n[v+(K<<2)>>2];N=N+R*(+(j[t>>1]|0)-+n[I>>2]);O=O+R*(+(j[t+2>>1]|0)-+n[I+4>>2]);P=P+R*(+(j[t+4>>1]|0)-+n[I+8>>2]);Q=Q+R*(+(j[t+6>>1]|0)-+n[I+12>>2]);K=K+1|0;if((K|0)==(p|0))break;else{I=I+(z<<2)|0;t=t+(l<<1)|0}}n[H+(M<<2)>>2]=N*d;n[H+(M+1<<2)>>2]=O*d;n[H+(M+2<<2)>>2]=P*d;n[H+(M+3<<2)>>2]=Q*d;t=M+4|0;if((t|0)>(C|0)){L=t;break}else M=t}}while(0);c:do if((L|0)<(a|0)){if(!o)if(B){t=L;while(1){n[H+(t<<2)>>2]=D;t=t+1|0;if((t|0)==(a|0))break c}}else{t=L;while(1){n[H+(t<<2)>>2]=E;t=t+1|0;if((t|0)==(a|0))break c}}if(B){t=L;do{I=y;K=0;R=0.0;J=h+(t<<1)|0;while(1){R=R+ +n[v+(K<<2)>>2]*(+(j[J>>1]|0)-+n[I>>2]);K=K+1|0;if((K|0)==(p|0))break;else{I=I+(z<<2)|0;J=J+(l<<1)|0}}n[H+(t<<2)>>2]=R*d;t=t+1|0}while((t|0)!=(a|0))}else{t=L;do{J=x+(t<<2)|0;I=0;Q=0.0;K=h+(t<<1)|0;while(1){Q=Q+ +n[v+(I<<2)>>2]*(+(j[K>>1]|0)-+n[J>>2]);I=I+1|0;if((I|0)==(p|0))break;else{J=J+(z<<2)|0;K=K+(l<<1)|0}}n[H+(t<<2)>>2]=Q*d;t=t+1|0}while((t|0)!=(a|0))}}while(0);G=G+1|0;if((G|0)==(a|0))break;else H=H+(m<<2)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(p|0)>0;z=a+-4|0;E=d*0.0;D=d*0.0;x=0;L=i;while(1){if(w){i=0;do{y=h+((Y(i,l)|0)+x<<1)|0;n[v+(i<<2)>>2]=+(j[y>>1]|0);i=i+1|0}while((i|0)!=(p|0))}d:do if((x|0)>(z|0))S=x;else{if(w)T=x;else{i=x;while(1){n[L+(i<<2)>>2]=D;n[L+(i+1<<2)>>2]=D;n[L+(i+2<<2)>>2]=D;n[L+(i+3<<2)>>2]=D;y=i+4|0;if((y|0)>(z|0)){S=y;break d}else i=y}}while(1){i=0;F=0.0;R=0.0;P=0.0;O=0.0;y=h+(T<<1)|0;while(1){N=+n[v+(i<<2)>>2];F=F+N*+(j[y>>1]|0);R=R+N*+(j[y+2>>1]|0);P=P+N*+(j[y+4>>1]|0);O=O+N*+(j[y+6>>1]|0);i=i+1|0;if((i|0)==(p|0))break;else y=y+(l<<1)|0}n[L+(T<<2)>>2]=F*d;n[L+(T+1<<2)>>2]=R*d;n[L+(T+2<<2)>>2]=P*d;n[L+(T+3<<2)>>2]=O*d;y=T+4|0;if((y|0)>(z|0)){S=y;break}else T=y}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{y=S;while(1){n[L+(y<<2)>>2]=E;y=y+1|0;if((y|0)==(a|0))break e}}do{y=0;N=0.0;i=h+(U<<1)|0;while(1){N=N+ +n[v+(y<<2)>>2]*+(j[i>>1]|0);y=y+1|0;if((y|0)==(p|0))break;else i=i+(l<<1)|0}n[L+(U<<2)>>2]=N*d;U=U+1|0}while((U|0)!=(a|0))}while(0);x=x+1|0;if((x|0)==(a|0))break;else L=L+(m<<2)|0}}if((v|0)==(c|0)){u=e;return}QYa(v);f[g>>2]=c;f[q>>2]=1032;u=e;return}function LO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0,V=0,W=0,X=0,Z=0,_=0.0,$=0,aa=0.0,ba=0,ca=0.0;e=u;u=u+1056|0;g=e+1040|0;h=e;i=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=(f[a+48>>2]|0)>>>1;o=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;p=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=e;return}c=a+-4|0;r=(a|0)<4;t=a&-4;v=(a|0)>0;w=(t|0)<(a|0);x=0;y=k;while(1){z=i+((Y(x,m)|0)<<1)|0;if(r){A=x;do{B=i+((Y(A,m)|0)<<1)|0;if(v){C=0;D=0.0;while(1){E=D+ +(j[z+(C<<1)>>1]|0)*+(j[B+(C<<1)>>1]|0);C=C+1|0;if((C|0)==(a|0)){F=E;break}else D=E}}else F=0.0;n[y+(A<<2)>>2]=F*d;A=A+1|0}while((A|0)!=(q|0))}else{A=x;do{C=i+((Y(A,m)|0)<<1)|0;B=0;D=0.0;do{G=B|1;H=B|2;I=B|3;D=D+(+(j[z+(B<<1)>>1]|0)*+(j[C+(B<<1)>>1]|0)+ +(j[z+(G<<1)>>1]|0)*+(j[C+(G<<1)>>1]|0)+ +(j[z+(H<<1)>>1]|0)*+(j[C+(H<<1)>>1]|0)+ +(j[z+(I<<1)>>1]|0)*+(j[C+(I<<1)>>1]|0));B=B+4|0}while((B|0)<=(c|0));if(w){B=t;E=D;while(1){J=E+ +(j[z+(B<<1)>>1]|0)*+(j[C+(B<<1)>>1]|0);B=B+1|0;if((B|0)==(a|0)){K=J;break}else E=J}}else K=D;n[y+(A<<2)>>2]=K*d;A=A+1|0}while((A|0)!=(q|0))}x=x+1|0;if((x|0)==(q|0))break;else y=y+(o<<2)|0}u=e;return}y=(p|0)==(a|0)?4:0;x=a<<2;t=h+8|0;f[h>>2]=t;w=h+4|0;f[w>>2]=x;if(x>>>0>1032){c=OYa(x)|0;f[h>>2]=c;L=c}else L=t;if((q|0)>0){c=(p|0)<(a|0);p=(a|0)>0;x=g+12|0;v=g+8|0;r=g+4|0;A=a+-4|0;z=(a|0)<4;B=a&-4;C=Y(y,B)|0;I=g+C|0;H=0;G=l+C|0;C=k;while(1){k=i+((Y(H,m)|0)<<1)|0;M=l+((Y(H,b)|0)<<2)|0;if(c)if(p){N=0;do{n[L+(N<<2)>>2]=+(j[k+(N<<1)>>1]|0)-+n[M>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{P=H;O=22}else if(p){N=0;do{n[L+(N<<2)>>2]=+(j[k+(N<<1)>>1]|0)-+n[M+(N<<2)>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{Q=G;R=H;O=31}if((O|0)==21){O=0;if(c){P=H;O=22}else{Q=G;R=H;O=31}}if((O|0)==22)while(1){O=0;N=i+((Y(P,m)|0)<<1)|0;M=l+((Y(P,b)|0)<<2)|0;k=f[M>>2]|0;f[x>>2]=k;f[v>>2]=k;f[r>>2]=k;f[g>>2]=k;a:do if(z){S=0;T=0.0;U=g}else{K=(f[s>>2]=k,+n[s>>2]);M=0;F=0.0;V=g;while(1){W=M|1;X=M|2;Z=M|3;E=F+(+n[L+(M<<2)>>2]*(+(j[N+(M<<1)>>1]|0)-K)+ +n[L+(W<<2)>>2]*(+(j[N+(W<<1)>>1]|0)-+n[V+4>>2])+ +n[L+(X<<2)>>2]*(+(j[N+(X<<1)>>1]|0)-+n[V+8>>2])+ +n[L+(Z<<2)>>2]*(+(j[N+(Z<<1)>>1]|0)-+n[V+12>>2]));Z=M+4|0;X=V+(y<<2)|0;if((Z|0)>(A|0)){S=B;T=E;U=I;break a}K=+n[X>>2];M=Z;F=E;V=X}}while(0);if((S|0)<(a|0)){k=S;D=T;V=U;while(1){F=D+ +n[L+(k<<2)>>2]*(+(j[N+(k<<1)>>1]|0)-+n[V>>2]);k=k+1|0;if((k|0)==(a|0)){_=F;break}else{D=F;V=V+4|0}}}else _=T;n[C+(P<<2)>>2]=_*d;P=P+1|0;if((P|0)==(q|0))break;else O=22}else if((O|0)==31)while(1){O=0;V=i+((Y(R,m)|0)<<1)|0;k=l+((Y(R,b)|0)<<2)|0;if(z){$=0;aa=0.0;ba=k}else{N=0;D=0.0;M=k;while(1){k=N|1;X=N|2;Z=N|3;F=D+(+n[L+(N<<2)>>2]*(+(j[V+(N<<1)>>1]|0)-+n[M>>2])+ +n[L+(k<<2)>>2]*(+(j[V+(k<<1)>>1]|0)-+n[M+4>>2])+ +n[L+(X<<2)>>2]*(+(j[V+(X<<1)>>1]|0)-+n[M+8>>2])+ +n[L+(Z<<2)>>2]*(+(j[V+(Z<<1)>>1]|0)-+n[M+12>>2]));N=N+4|0;if((N|0)>(A|0)){$=B;aa=F;ba=Q;break}else{D=F;M=M+(y<<2)|0}}}if(($|0)<(a|0)){M=$;D=aa;N=ba;while(1){F=D+ +n[L+(M<<2)>>2]*(+(j[V+(M<<1)>>1]|0)-+n[N>>2]);M=M+1|0;if((M|0)==(a|0)){ca=F;break}else{D=F;N=N+4|0}}}else ca=aa;n[C+(R<<2)>>2]=ca*d;R=R+1|0;if((R|0)==(q|0))break;else{Q=Q+(b<<2)|0;O=31}}H=H+1|0;if((H|0)==(q|0))break;else{G=G+(b<<2)|0;C=C+(o<<2)|0}}}if((L|0)!=(t|0)){QYa(L);f[h>>2]=t;f[w>>2]=1032}u=e;return}function MO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;e=u;u=u+1040|0;g=e;h=f[a+16>>2]|0;i=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>1;m=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;n=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;c=g+8|0;f[g>>2]=c;q=g+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(n|0)<(a|0);n=r&s?o*40|0:o<<3;f[q>>2]=n;if(n>>>0>1032){t=OYa(n)|0;f[g>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(o<<3)|0;if((o|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{n=k+((Y(A,b)|0)<<3)|0;B=+p[n>>3];n=A<<2;p[t+((n|3)<<3)>>3]=B;p[t+((n|2)<<3)>>3]=B;p[t+((n|1)<<3)>>3]=B;p[t+(n<<3)>>3]=B;A=A+1|0}while((A|0)!=(o|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){n=(y|0)!=0;C=(o|0)>0;D=a+-4|0;B=d*0.0;E=d*0.0;F=d*0.0;G=0;H=i;while(1){if(n){if(C){I=0;do{J=h+((Y(I,l)|0)+G<<1)|0;K=y+((Y(I,z)|0)<<3)|0;p[v+(I<<3)>>3]=+(j[J>>1]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}}else if(C){I=0;do{t=h+((Y(I,l)|0)+G<<1)|0;K=x+((Y(I,z)|0)+G<<3)|0;p[v+(I<<3)>>3]=+(j[t>>1]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}b:do if((G|0)>(D|0))L=G;else{if(C)M=G;else{I=G;while(1){p[H+(I<<3)>>3]=F;p[H+(I+1<<3)>>3]=F;p[H+(I+2<<3)>>3]=F;p[H+(I+3<<3)>>3]=F;K=I+4|0;if((K|0)>(D|0)){L=K;break b}else I=K}}while(1){I=n?y:x+(M<<3)|0;K=0;N=0.0;O=0.0;P=0.0;Q=0.0;t=h+(M<<1)|0;while(1){R=+p[v+(K<<3)>>3];N=N+R*(+(j[t>>1]|0)-+p[I>>3]);O=O+R*(+(j[t+2>>1]|0)-+p[I+8>>3]);P=P+R*(+(j[t+4>>1]|0)-+p[I+16>>3]);Q=Q+R*(+(j[t+6>>1]|0)-+p[I+24>>3]);K=K+1|0;if((K|0)==(o|0))break;else{I=I+(z<<3)|0;t=t+(l<<1)|0}}p[H+(M<<3)>>3]=N*d;p[H+(M+1<<3)>>3]=O*d;p[H+(M+2<<3)>>3]=P*d;p[H+(M+3<<3)>>3]=Q*d;t=M+4|0;if((t|0)>(D|0)){L=t;break}else M=t}}while(0);c:do if((L|0)<(a|0)){if(!C)if(n){t=L;while(1){p[H+(t<<3)>>3]=B;t=t+1|0;if((t|0)==(a|0))break c}}else{t=L;while(1){p[H+(t<<3)>>3]=E;t=t+1|0;if((t|0)==(a|0))break c}}if(n){t=L;do{I=y;K=0;R=0.0;J=h+(t<<1)|0;while(1){R=R+ +p[v+(K<<3)>>3]*(+(j[J>>1]|0)-+p[I>>3]);K=K+1|0;if((K|0)==(o|0))break;else{I=I+(z<<3)|0;J=J+(l<<1)|0}}p[H+(t<<3)>>3]=R*d;t=t+1|0}while((t|0)!=(a|0))}else{t=L;do{J=x+(t<<3)|0;I=0;Q=0.0;K=h+(t<<1)|0;while(1){Q=Q+ +p[v+(I<<3)>>3]*(+(j[K>>1]|0)-+p[J>>3]);I=I+1|0;if((I|0)==(o|0))break;else{J=J+(z<<3)|0;K=K+(l<<1)|0}}p[H+(t<<3)>>3]=Q*d;t=t+1|0}while((t|0)!=(a|0))}}while(0);G=G+1|0;if((G|0)==(a|0))break;else H=H+(m<<3)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(o|0)>0;z=a+-4|0;E=d*0.0;B=d*0.0;x=0;L=i;while(1){if(w){i=0;do{y=h+((Y(i,l)|0)+x<<1)|0;p[v+(i<<3)>>3]=+(j[y>>1]|0);i=i+1|0}while((i|0)!=(o|0))}d:do if((x|0)>(z|0))S=x;else{if(w)T=x;else{i=x;while(1){p[L+(i<<3)>>3]=B;p[L+(i+1<<3)>>3]=B;p[L+(i+2<<3)>>3]=B;p[L+(i+3<<3)>>3]=B;y=i+4|0;if((y|0)>(z|0)){S=y;break d}else i=y}}while(1){i=0;F=0.0;R=0.0;P=0.0;O=0.0;y=h+(T<<1)|0;while(1){N=+p[v+(i<<3)>>3];F=F+N*+(j[y>>1]|0);R=R+N*+(j[y+2>>1]|0);P=P+N*+(j[y+4>>1]|0);O=O+N*+(j[y+6>>1]|0);i=i+1|0;if((i|0)==(o|0))break;else y=y+(l<<1)|0}p[L+(T<<3)>>3]=F*d;p[L+(T+1<<3)>>3]=R*d;p[L+(T+2<<3)>>3]=P*d;p[L+(T+3<<3)>>3]=O*d;y=T+4|0;if((y|0)>(z|0)){S=y;break}else T=y}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{y=S;while(1){p[L+(y<<3)>>3]=E;y=y+1|0;if((y|0)==(a|0))break e}}do{y=0;N=0.0;i=h+(U<<1)|0;while(1){N=N+ +p[v+(y<<3)>>3]*+(j[i>>1]|0);y=y+1|0;if((y|0)==(o|0))break;else i=i+(l<<1)|0}p[L+(U<<3)>>3]=N*d;U=U+1|0}while((U|0)!=(a|0))}while(0);x=x+1|0;if((x|0)==(a|0))break;else L=L+(m<<3)|0}}if((v|0)==(c|0)){u=e;return}QYa(v);f[g>>2]=c;f[q>>2]=1032;u=e;return}function NO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0.0,Z=0,_=0.0,$=0,aa=0.0;e=u;u=u+1072|0;g=e;h=e+32|0;i=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=(f[a+48>>2]|0)>>>1;n=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=e;return}c=a+-4|0;r=(a|0)<4;s=a&-4;t=(a|0)>0;v=(s|0)<(a|0);w=0;x=k;while(1){y=i+((Y(w,m)|0)<<1)|0;if(r){z=w;do{A=i+((Y(z,m)|0)<<1)|0;if(t){B=0;C=0.0;while(1){D=C+ +(j[y+(B<<1)>>1]|0)*+(j[A+(B<<1)>>1]|0);B=B+1|0;if((B|0)==(a|0)){E=D;break}else C=D}}else E=0.0;p[x+(z<<3)>>3]=E*d;z=z+1|0}while((z|0)!=(q|0))}else{z=w;do{B=i+((Y(z,m)|0)<<1)|0;A=0;C=0.0;do{F=A|1;G=A|2;H=A|3;C=C+(+(j[y+(A<<1)>>1]|0)*+(j[B+(A<<1)>>1]|0)+ +(j[y+(F<<1)>>1]|0)*+(j[B+(F<<1)>>1]|0)+ +(j[y+(G<<1)>>1]|0)*+(j[B+(G<<1)>>1]|0)+ +(j[y+(H<<1)>>1]|0)*+(j[B+(H<<1)>>1]|0));A=A+4|0}while((A|0)<=(c|0));if(v){A=s;D=C;while(1){I=D+ +(j[y+(A<<1)>>1]|0)*+(j[B+(A<<1)>>1]|0);A=A+1|0;if((A|0)==(a|0)){J=I;break}else D=I}}else J=C;p[x+(z<<3)>>3]=J*d;z=z+1|0}while((z|0)!=(q|0))}w=w+1|0;if((w|0)==(q|0))break;else x=x+(n<<3)|0}u=e;return}x=(o|0)==(a|0)?4:0;w=a<<3;s=h+8|0;f[h>>2]=s;v=h+4|0;f[v>>2]=w;if(w>>>0>1032){c=OYa(w)|0;f[h>>2]=c;K=c}else K=s;if((q|0)>0){c=(o|0)<(a|0);o=(a|0)>0;w=g+24|0;t=g+16|0;r=g+8|0;z=a+-4|0;y=(a|0)<4;A=z>>>2;B=(A<<2)+4|0;H=Y(x,(A<<3)+8|0)|0;A=g+H|0;G=0;F=l+H|0;H=k;while(1){k=i+((Y(G,m)|0)<<1)|0;L=l+((Y(G,b)|0)<<3)|0;if(c)if(o){M=0;do{p[K+(M<<3)>>3]=+(j[k+(M<<1)>>1]|0)-+p[L>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{O=G;N=22}else if(o){M=0;do{p[K+(M<<3)>>3]=+(j[k+(M<<1)>>1]|0)-+p[L+(M<<3)>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{P=F;Q=G;N=30}if((N|0)==21){N=0;if(c){O=G;N=22}else{P=F;Q=G;N=30}}if((N|0)==22)while(1){N=0;M=i+((Y(O,m)|0)<<1)|0;L=l+((Y(O,b)|0)<<3)|0;J=+p[L>>3];p[w>>3]=J;p[t>>3]=J;p[r>>3]=J;p[g>>3]=J;a:do if(y){R=0;S=0.0;T=g}else{E=J;L=0;D=0.0;k=g;while(1){U=L|1;V=L|2;W=L|3;I=D+(+p[K+(L<<3)>>3]*(+(j[M+(L<<1)>>1]|0)-E)+ +p[K+(U<<3)>>3]*(+(j[M+(U<<1)>>1]|0)-+p[k+8>>3])+ +p[K+(V<<3)>>3]*(+(j[M+(V<<1)>>1]|0)-+p[k+16>>3])+ +p[K+(W<<3)>>3]*(+(j[M+(W<<1)>>1]|0)-+p[k+24>>3]));W=L+4|0;V=k+(x<<3)|0;if((W|0)>(z|0)){R=B;S=I;T=A;break a}E=+p[V>>3];L=W;D=I;k=V}}while(0);if((R|0)<(a|0)){k=R;J=S;L=T;while(1){C=J+ +p[K+(k<<3)>>3]*(+(j[M+(k<<1)>>1]|0)-+p[L>>3]);k=k+1|0;if((k|0)==(a|0)){X=C;break}else{J=C;L=L+8|0}}}else X=S;p[H+(O<<3)>>3]=X*d;O=O+1|0;if((O|0)==(q|0))break;else N=22}else if((N|0)==30)while(1){N=0;L=i+((Y(Q,m)|0)<<1)|0;k=l+((Y(Q,b)|0)<<3)|0;if(y){Z=0;_=0.0;$=k}else{M=0;J=0.0;V=k;while(1){k=M|1;W=M|2;U=M|3;C=J+(+p[K+(M<<3)>>3]*(+(j[L+(M<<1)>>1]|0)-+p[V>>3])+ +p[K+(k<<3)>>3]*(+(j[L+(k<<1)>>1]|0)-+p[V+8>>3])+ +p[K+(W<<3)>>3]*(+(j[L+(W<<1)>>1]|0)-+p[V+16>>3])+ +p[K+(U<<3)>>3]*(+(j[L+(U<<1)>>1]|0)-+p[V+24>>3]));M=M+4|0;if((M|0)>(z|0)){Z=B;_=C;$=P;break}else{J=C;V=V+(x<<3)|0}}}if((Z|0)<(a|0)){V=Z;J=_;M=$;while(1){C=J+ +p[K+(V<<3)>>3]*(+(j[L+(V<<1)>>1]|0)-+p[M>>3]);V=V+1|0;if((V|0)==(a|0)){aa=C;break}else{J=C;M=M+8|0}}}else aa=_;p[H+(Q<<3)>>3]=aa*d;Q=Q+1|0;if((Q|0)==(q|0))break;else{P=P+(b<<3)|0;N=30}}G=G+1|0;if((G|0)==(q|0))break;else{F=F+(b<<3)|0;H=H+(n<<3)|0}}}if((K|0)!=(s|0)){QYa(K);f[h>>2]=s;f[v>>2]=1032}u=e;return}function OO(a,b,c,e){a=a|0;b=b|0;c=c|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;g=u;u=u+1040|0;h=g;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>1;m=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;p=f[c>>2]|0;c=h+8|0;f[h>>2]=c;q=h+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(o|0)<(a|0);o=r&s?p*20|0:p<<2;f[q>>2]=o;if(o>>>0>1032){t=OYa(o)|0;f[h>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(p<<2)|0;if((p|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{o=k+((Y(A,b)|0)<<2)|0;B=f[o>>2]|0;o=A<<2;f[t+((o|3)<<2)>>2]=B;f[t+((o|2)<<2)>>2]=B;f[t+((o|1)<<2)>>2]=B;f[t+(o<<2)>>2]=B;A=A+1|0}while((A|0)!=(p|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){B=(y|0)!=0;o=(p|0)>0;C=a+-4|0;D=e*0.0;E=e*0.0;F=e*0.0;G=0;H=j;while(1){if(B){if(o){I=0;do{J=i+((Y(I,l)|0)+G<<1)|0;K=y+((Y(I,z)|0)<<2)|0;n[v+(I<<2)>>2]=+(d[J>>1]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}}else if(o){I=0;do{t=i+((Y(I,l)|0)+G<<1)|0;K=x+((Y(I,z)|0)+G<<2)|0;n[v+(I<<2)>>2]=+(d[t>>1]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}b:do if((G|0)>(C|0))L=G;else{if(o)M=G;else{I=G;while(1){n[H+(I<<2)>>2]=F;n[H+(I+1<<2)>>2]=F;n[H+(I+2<<2)>>2]=F;n[H+(I+3<<2)>>2]=F;K=I+4|0;if((K|0)>(C|0)){L=K;break b}else I=K}}while(1){I=B?y:x+(M<<2)|0;K=0;N=0.0;O=0.0;P=0.0;Q=0.0;t=i+(M<<1)|0;while(1){R=+n[v+(K<<2)>>2];N=N+R*(+(d[t>>1]|0)-+n[I>>2]);O=O+R*(+(d[t+2>>1]|0)-+n[I+4>>2]);P=P+R*(+(d[t+4>>1]|0)-+n[I+8>>2]);Q=Q+R*(+(d[t+6>>1]|0)-+n[I+12>>2]);K=K+1|0;if((K|0)==(p|0))break;else{I=I+(z<<2)|0;t=t+(l<<1)|0}}n[H+(M<<2)>>2]=N*e;n[H+(M+1<<2)>>2]=O*e;n[H+(M+2<<2)>>2]=P*e;n[H+(M+3<<2)>>2]=Q*e;t=M+4|0;if((t|0)>(C|0)){L=t;break}else M=t}}while(0);c:do if((L|0)<(a|0)){if(!o)if(B){t=L;while(1){n[H+(t<<2)>>2]=D;t=t+1|0;if((t|0)==(a|0))break c}}else{t=L;while(1){n[H+(t<<2)>>2]=E;t=t+1|0;if((t|0)==(a|0))break c}}if(B){t=L;do{I=y;K=0;R=0.0;J=i+(t<<1)|0;while(1){R=R+ +n[v+(K<<2)>>2]*(+(d[J>>1]|0)-+n[I>>2]);K=K+1|0;if((K|0)==(p|0))break;else{I=I+(z<<2)|0;J=J+(l<<1)|0}}n[H+(t<<2)>>2]=R*e;t=t+1|0}while((t|0)!=(a|0))}else{t=L;do{J=x+(t<<2)|0;I=0;Q=0.0;K=i+(t<<1)|0;while(1){Q=Q+ +n[v+(I<<2)>>2]*(+(d[K>>1]|0)-+n[J>>2]);I=I+1|0;if((I|0)==(p|0))break;else{J=J+(z<<2)|0;K=K+(l<<1)|0}}n[H+(t<<2)>>2]=Q*e;t=t+1|0}while((t|0)!=(a|0))}}while(0);G=G+1|0;if((G|0)==(a|0))break;else H=H+(m<<2)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(p|0)>0;z=a+-4|0;E=e*0.0;D=e*0.0;x=0;L=j;while(1){if(w){j=0;do{y=i+((Y(j,l)|0)+x<<1)|0;n[v+(j<<2)>>2]=+(d[y>>1]|0);j=j+1|0}while((j|0)!=(p|0))}d:do if((x|0)>(z|0))S=x;else{if(w)T=x;else{j=x;while(1){n[L+(j<<2)>>2]=D;n[L+(j+1<<2)>>2]=D;n[L+(j+2<<2)>>2]=D;n[L+(j+3<<2)>>2]=D;y=j+4|0;if((y|0)>(z|0)){S=y;break d}else j=y}}while(1){j=0;F=0.0;R=0.0;P=0.0;O=0.0;y=i+(T<<1)|0;while(1){N=+n[v+(j<<2)>>2];F=F+N*+(d[y>>1]|0);R=R+N*+(d[y+2>>1]|0);P=P+N*+(d[y+4>>1]|0);O=O+N*+(d[y+6>>1]|0);j=j+1|0;if((j|0)==(p|0))break;else y=y+(l<<1)|0}n[L+(T<<2)>>2]=F*e;n[L+(T+1<<2)>>2]=R*e;n[L+(T+2<<2)>>2]=P*e;n[L+(T+3<<2)>>2]=O*e;y=T+4|0;if((y|0)>(z|0)){S=y;break}else T=y}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{y=S;while(1){n[L+(y<<2)>>2]=E;y=y+1|0;if((y|0)==(a|0))break e}}do{y=0;N=0.0;j=i+(U<<1)|0;while(1){N=N+ +n[v+(y<<2)>>2]*+(d[j>>1]|0);y=y+1|0;if((y|0)==(p|0))break;else j=j+(l<<1)|0}n[L+(U<<2)>>2]=N*e;U=U+1|0}while((U|0)!=(a|0))}while(0);x=x+1|0;if((x|0)==(a|0))break;else L=L+(m<<2)|0}}if((v|0)==(c|0)){u=g;return}QYa(v);f[h>>2]=c;f[q>>2]=1032;u=g;return}function PO(a,b,c,e){a=a|0;b=b|0;c=c|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0,V=0,W=0,X=0,Z=0,_=0.0,$=0,aa=0.0,ba=0,ca=0.0;g=u;u=u+1056|0;h=g+1040|0;i=g;j=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=(f[a+48>>2]|0)>>>1;o=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;p=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=g;return}c=a+-4|0;r=(a|0)<4;t=a&-4;v=(a|0)>0;w=(t|0)<(a|0);x=0;y=k;while(1){z=j+((Y(x,m)|0)<<1)|0;if(r){A=x;do{B=j+((Y(A,m)|0)<<1)|0;if(v){C=0;D=0.0;while(1){E=D+ +(d[z+(C<<1)>>1]|0)*+(d[B+(C<<1)>>1]|0);C=C+1|0;if((C|0)==(a|0)){F=E;break}else D=E}}else F=0.0;n[y+(A<<2)>>2]=F*e;A=A+1|0}while((A|0)!=(q|0))}else{A=x;do{C=j+((Y(A,m)|0)<<1)|0;B=0;D=0.0;do{G=B|1;H=B|2;I=B|3;D=D+(+(d[z+(B<<1)>>1]|0)*+(d[C+(B<<1)>>1]|0)+ +(d[z+(G<<1)>>1]|0)*+(d[C+(G<<1)>>1]|0)+ +(d[z+(H<<1)>>1]|0)*+(d[C+(H<<1)>>1]|0)+ +(d[z+(I<<1)>>1]|0)*+(d[C+(I<<1)>>1]|0));B=B+4|0}while((B|0)<=(c|0));if(w){B=t;E=D;while(1){J=E+ +(d[z+(B<<1)>>1]|0)*+(d[C+(B<<1)>>1]|0);B=B+1|0;if((B|0)==(a|0)){K=J;break}else E=J}}else K=D;n[y+(A<<2)>>2]=K*e;A=A+1|0}while((A|0)!=(q|0))}x=x+1|0;if((x|0)==(q|0))break;else y=y+(o<<2)|0}u=g;return}y=(p|0)==(a|0)?4:0;x=a<<2;t=i+8|0;f[i>>2]=t;w=i+4|0;f[w>>2]=x;if(x>>>0>1032){c=OYa(x)|0;f[i>>2]=c;L=c}else L=t;if((q|0)>0){c=(p|0)<(a|0);p=(a|0)>0;x=h+12|0;v=h+8|0;r=h+4|0;A=a+-4|0;z=(a|0)<4;B=a&-4;C=Y(y,B)|0;I=h+C|0;H=0;G=l+C|0;C=k;while(1){k=j+((Y(H,m)|0)<<1)|0;M=l+((Y(H,b)|0)<<2)|0;if(c)if(p){N=0;do{n[L+(N<<2)>>2]=+(d[k+(N<<1)>>1]|0)-+n[M>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{P=H;O=22}else if(p){N=0;do{n[L+(N<<2)>>2]=+(d[k+(N<<1)>>1]|0)-+n[M+(N<<2)>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{Q=G;R=H;O=31}if((O|0)==21){O=0;if(c){P=H;O=22}else{Q=G;R=H;O=31}}if((O|0)==22)while(1){O=0;N=j+((Y(P,m)|0)<<1)|0;M=l+((Y(P,b)|0)<<2)|0;k=f[M>>2]|0;f[x>>2]=k;f[v>>2]=k;f[r>>2]=k;f[h>>2]=k;a:do if(z){S=0;T=0.0;U=h}else{K=(f[s>>2]=k,+n[s>>2]);M=0;F=0.0;V=h;while(1){W=M|1;X=M|2;Z=M|3;E=F+(+n[L+(M<<2)>>2]*(+(d[N+(M<<1)>>1]|0)-K)+ +n[L+(W<<2)>>2]*(+(d[N+(W<<1)>>1]|0)-+n[V+4>>2])+ +n[L+(X<<2)>>2]*(+(d[N+(X<<1)>>1]|0)-+n[V+8>>2])+ +n[L+(Z<<2)>>2]*(+(d[N+(Z<<1)>>1]|0)-+n[V+12>>2]));Z=M+4|0;X=V+(y<<2)|0;if((Z|0)>(A|0)){S=B;T=E;U=I;break a}K=+n[X>>2];M=Z;F=E;V=X}}while(0);if((S|0)<(a|0)){k=S;D=T;V=U;while(1){F=D+ +n[L+(k<<2)>>2]*(+(d[N+(k<<1)>>1]|0)-+n[V>>2]);k=k+1|0;if((k|0)==(a|0)){_=F;break}else{D=F;V=V+4|0}}}else _=T;n[C+(P<<2)>>2]=_*e;P=P+1|0;if((P|0)==(q|0))break;else O=22}else if((O|0)==31)while(1){O=0;V=j+((Y(R,m)|0)<<1)|0;k=l+((Y(R,b)|0)<<2)|0;if(z){$=0;aa=0.0;ba=k}else{N=0;D=0.0;M=k;while(1){k=N|1;X=N|2;Z=N|3;F=D+(+n[L+(N<<2)>>2]*(+(d[V+(N<<1)>>1]|0)-+n[M>>2])+ +n[L+(k<<2)>>2]*(+(d[V+(k<<1)>>1]|0)-+n[M+4>>2])+ +n[L+(X<<2)>>2]*(+(d[V+(X<<1)>>1]|0)-+n[M+8>>2])+ +n[L+(Z<<2)>>2]*(+(d[V+(Z<<1)>>1]|0)-+n[M+12>>2]));N=N+4|0;if((N|0)>(A|0)){$=B;aa=F;ba=Q;break}else{D=F;M=M+(y<<2)|0}}}if(($|0)<(a|0)){M=$;D=aa;N=ba;while(1){F=D+ +n[L+(M<<2)>>2]*(+(d[V+(M<<1)>>1]|0)-+n[N>>2]);M=M+1|0;if((M|0)==(a|0)){ca=F;break}else{D=F;N=N+4|0}}}else ca=aa;n[C+(R<<2)>>2]=ca*e;R=R+1|0;if((R|0)==(q|0))break;else{Q=Q+(b<<2)|0;O=31}}H=H+1|0;if((H|0)==(q|0))break;else{G=G+(b<<2)|0;C=C+(o<<2)|0}}}if((L|0)!=(t|0)){QYa(L);f[i>>2]=t;f[w>>2]=1032}u=g;return}function QO(a,b,c,e){a=a|0;b=b|0;c=c|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;g=u;u=u+1040|0;h=g;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>1;m=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;n=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;c=h+8|0;f[h>>2]=c;q=h+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(n|0)<(a|0);n=r&s?o*40|0:o<<3;f[q>>2]=n;if(n>>>0>1032){t=OYa(n)|0;f[h>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(o<<3)|0;if((o|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{n=k+((Y(A,b)|0)<<3)|0;B=+p[n>>3];n=A<<2;p[t+((n|3)<<3)>>3]=B;p[t+((n|2)<<3)>>3]=B;p[t+((n|1)<<3)>>3]=B;p[t+(n<<3)>>3]=B;A=A+1|0}while((A|0)!=(o|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){n=(y|0)!=0;C=(o|0)>0;D=a+-4|0;B=e*0.0;E=e*0.0;F=e*0.0;G=0;H=j;while(1){if(n){if(C){I=0;do{J=i+((Y(I,l)|0)+G<<1)|0;K=y+((Y(I,z)|0)<<3)|0;p[v+(I<<3)>>3]=+(d[J>>1]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}}else if(C){I=0;do{t=i+((Y(I,l)|0)+G<<1)|0;K=x+((Y(I,z)|0)+G<<3)|0;p[v+(I<<3)>>3]=+(d[t>>1]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}b:do if((G|0)>(D|0))L=G;else{if(C)M=G;else{I=G;while(1){p[H+(I<<3)>>3]=F;p[H+(I+1<<3)>>3]=F;p[H+(I+2<<3)>>3]=F;p[H+(I+3<<3)>>3]=F;K=I+4|0;if((K|0)>(D|0)){L=K;break b}else I=K}}while(1){I=n?y:x+(M<<3)|0;K=0;N=0.0;O=0.0;P=0.0;Q=0.0;t=i+(M<<1)|0;while(1){R=+p[v+(K<<3)>>3];N=N+R*(+(d[t>>1]|0)-+p[I>>3]);O=O+R*(+(d[t+2>>1]|0)-+p[I+8>>3]);P=P+R*(+(d[t+4>>1]|0)-+p[I+16>>3]);Q=Q+R*(+(d[t+6>>1]|0)-+p[I+24>>3]);K=K+1|0;if((K|0)==(o|0))break;else{I=I+(z<<3)|0;t=t+(l<<1)|0}}p[H+(M<<3)>>3]=N*e;p[H+(M+1<<3)>>3]=O*e;p[H+(M+2<<3)>>3]=P*e;p[H+(M+3<<3)>>3]=Q*e;t=M+4|0;if((t|0)>(D|0)){L=t;break}else M=t}}while(0);c:do if((L|0)<(a|0)){if(!C)if(n){t=L;while(1){p[H+(t<<3)>>3]=B;t=t+1|0;if((t|0)==(a|0))break c}}else{t=L;while(1){p[H+(t<<3)>>3]=E;t=t+1|0;if((t|0)==(a|0))break c}}if(n){t=L;do{I=y;K=0;R=0.0;J=i+(t<<1)|0;while(1){R=R+ +p[v+(K<<3)>>3]*(+(d[J>>1]|0)-+p[I>>3]);K=K+1|0;if((K|0)==(o|0))break;else{I=I+(z<<3)|0;J=J+(l<<1)|0}}p[H+(t<<3)>>3]=R*e;t=t+1|0}while((t|0)!=(a|0))}else{t=L;do{J=x+(t<<3)|0;I=0;Q=0.0;K=i+(t<<1)|0;while(1){Q=Q+ +p[v+(I<<3)>>3]*(+(d[K>>1]|0)-+p[J>>3]);I=I+1|0;if((I|0)==(o|0))break;else{J=J+(z<<3)|0;K=K+(l<<1)|0}}p[H+(t<<3)>>3]=Q*e;t=t+1|0}while((t|0)!=(a|0))}}while(0);G=G+1|0;if((G|0)==(a|0))break;else H=H+(m<<3)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(o|0)>0;z=a+-4|0;E=e*0.0;B=e*0.0;x=0;L=j;while(1){if(w){j=0;do{y=i+((Y(j,l)|0)+x<<1)|0;p[v+(j<<3)>>3]=+(d[y>>1]|0);j=j+1|0}while((j|0)!=(o|0))}d:do if((x|0)>(z|0))S=x;else{if(w)T=x;else{j=x;while(1){p[L+(j<<3)>>3]=B;p[L+(j+1<<3)>>3]=B;p[L+(j+2<<3)>>3]=B;p[L+(j+3<<3)>>3]=B;y=j+4|0;if((y|0)>(z|0)){S=y;break d}else j=y}}while(1){j=0;F=0.0;R=0.0;P=0.0;O=0.0;y=i+(T<<1)|0;while(1){N=+p[v+(j<<3)>>3];F=F+N*+(d[y>>1]|0);R=R+N*+(d[y+2>>1]|0);P=P+N*+(d[y+4>>1]|0);O=O+N*+(d[y+6>>1]|0);j=j+1|0;if((j|0)==(o|0))break;else y=y+(l<<1)|0}p[L+(T<<3)>>3]=F*e;p[L+(T+1<<3)>>3]=R*e;p[L+(T+2<<3)>>3]=P*e;p[L+(T+3<<3)>>3]=O*e;y=T+4|0;if((y|0)>(z|0)){S=y;break}else T=y}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{y=S;while(1){p[L+(y<<3)>>3]=E;y=y+1|0;if((y|0)==(a|0))break e}}do{y=0;N=0.0;j=i+(U<<1)|0;while(1){N=N+ +p[v+(y<<3)>>3]*+(d[j>>1]|0);y=y+1|0;if((y|0)==(o|0))break;else j=j+(l<<1)|0}p[L+(U<<3)>>3]=N*e;U=U+1|0}while((U|0)!=(a|0))}while(0);x=x+1|0;if((x|0)==(a|0))break;else L=L+(m<<3)|0}}if((v|0)==(c|0)){u=g;return}QYa(v);f[h>>2]=c;f[q>>2]=1032;u=g;return}function RO(a,b,c,e){a=a|0;b=b|0;c=c|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0.0,Z=0,_=0.0,$=0,aa=0.0;g=u;u=u+1072|0;h=g;i=g+32|0;j=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=(f[a+48>>2]|0)>>>1;n=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=g;return}c=a+-4|0;r=(a|0)<4;s=a&-4;t=(a|0)>0;v=(s|0)<(a|0);w=0;x=k;while(1){y=j+((Y(w,m)|0)<<1)|0;if(r){z=w;do{A=j+((Y(z,m)|0)<<1)|0;if(t){B=0;C=0.0;while(1){D=C+ +(d[y+(B<<1)>>1]|0)*+(d[A+(B<<1)>>1]|0);B=B+1|0;if((B|0)==(a|0)){E=D;break}else C=D}}else E=0.0;p[x+(z<<3)>>3]=E*e;z=z+1|0}while((z|0)!=(q|0))}else{z=w;do{B=j+((Y(z,m)|0)<<1)|0;A=0;C=0.0;do{F=A|1;G=A|2;H=A|3;C=C+(+(d[y+(A<<1)>>1]|0)*+(d[B+(A<<1)>>1]|0)+ +(d[y+(F<<1)>>1]|0)*+(d[B+(F<<1)>>1]|0)+ +(d[y+(G<<1)>>1]|0)*+(d[B+(G<<1)>>1]|0)+ +(d[y+(H<<1)>>1]|0)*+(d[B+(H<<1)>>1]|0));A=A+4|0}while((A|0)<=(c|0));if(v){A=s;D=C;while(1){I=D+ +(d[y+(A<<1)>>1]|0)*+(d[B+(A<<1)>>1]|0);A=A+1|0;if((A|0)==(a|0)){J=I;break}else D=I}}else J=C;p[x+(z<<3)>>3]=J*e;z=z+1|0}while((z|0)!=(q|0))}w=w+1|0;if((w|0)==(q|0))break;else x=x+(n<<3)|0}u=g;return}x=(o|0)==(a|0)?4:0;w=a<<3;s=i+8|0;f[i>>2]=s;v=i+4|0;f[v>>2]=w;if(w>>>0>1032){c=OYa(w)|0;f[i>>2]=c;K=c}else K=s;if((q|0)>0){c=(o|0)<(a|0);o=(a|0)>0;w=h+24|0;t=h+16|0;r=h+8|0;z=a+-4|0;y=(a|0)<4;A=z>>>2;B=(A<<2)+4|0;H=Y(x,(A<<3)+8|0)|0;A=h+H|0;G=0;F=l+H|0;H=k;while(1){k=j+((Y(G,m)|0)<<1)|0;L=l+((Y(G,b)|0)<<3)|0;if(c)if(o){M=0;do{p[K+(M<<3)>>3]=+(d[k+(M<<1)>>1]|0)-+p[L>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{O=G;N=22}else if(o){M=0;do{p[K+(M<<3)>>3]=+(d[k+(M<<1)>>1]|0)-+p[L+(M<<3)>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{P=F;Q=G;N=30}if((N|0)==21){N=0;if(c){O=G;N=22}else{P=F;Q=G;N=30}}if((N|0)==22)while(1){N=0;M=j+((Y(O,m)|0)<<1)|0;L=l+((Y(O,b)|0)<<3)|0;J=+p[L>>3];p[w>>3]=J;p[t>>3]=J;p[r>>3]=J;p[h>>3]=J;a:do if(y){R=0;S=0.0;T=h}else{E=J;L=0;D=0.0;k=h;while(1){U=L|1;V=L|2;W=L|3;I=D+(+p[K+(L<<3)>>3]*(+(d[M+(L<<1)>>1]|0)-E)+ +p[K+(U<<3)>>3]*(+(d[M+(U<<1)>>1]|0)-+p[k+8>>3])+ +p[K+(V<<3)>>3]*(+(d[M+(V<<1)>>1]|0)-+p[k+16>>3])+ +p[K+(W<<3)>>3]*(+(d[M+(W<<1)>>1]|0)-+p[k+24>>3]));W=L+4|0;V=k+(x<<3)|0;if((W|0)>(z|0)){R=B;S=I;T=A;break a}E=+p[V>>3];L=W;D=I;k=V}}while(0);if((R|0)<(a|0)){k=R;J=S;L=T;while(1){C=J+ +p[K+(k<<3)>>3]*(+(d[M+(k<<1)>>1]|0)-+p[L>>3]);k=k+1|0;if((k|0)==(a|0)){X=C;break}else{J=C;L=L+8|0}}}else X=S;p[H+(O<<3)>>3]=X*e;O=O+1|0;if((O|0)==(q|0))break;else N=22}else if((N|0)==30)while(1){N=0;L=j+((Y(Q,m)|0)<<1)|0;k=l+((Y(Q,b)|0)<<3)|0;if(y){Z=0;_=0.0;$=k}else{M=0;J=0.0;V=k;while(1){k=M|1;W=M|2;U=M|3;C=J+(+p[K+(M<<3)>>3]*(+(d[L+(M<<1)>>1]|0)-+p[V>>3])+ +p[K+(k<<3)>>3]*(+(d[L+(k<<1)>>1]|0)-+p[V+8>>3])+ +p[K+(W<<3)>>3]*(+(d[L+(W<<1)>>1]|0)-+p[V+16>>3])+ +p[K+(U<<3)>>3]*(+(d[L+(U<<1)>>1]|0)-+p[V+24>>3]));M=M+4|0;if((M|0)>(z|0)){Z=B;_=C;$=P;break}else{J=C;V=V+(x<<3)|0}}}if((Z|0)<(a|0)){V=Z;J=_;M=$;while(1){C=J+ +p[K+(V<<3)>>3]*(+(d[L+(V<<1)>>1]|0)-+p[M>>3]);V=V+1|0;if((V|0)==(a|0)){aa=C;break}else{J=C;M=M+8|0}}}else aa=_;p[H+(Q<<3)>>3]=aa*e;Q=Q+1|0;if((Q|0)==(q|0))break;else{P=P+(b<<3)|0;N=30}}G=G+1|0;if((G|0)==(q|0))break;else{F=F+(b<<3)|0;H=H+(n<<3)|0}}}if((K|0)!=(s|0)){QYa(K);f[i>>2]=s;f[v>>2]=1032}u=g;return}function SO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0;e=u;u=u+1040|0;g=e;h=f[a+16>>2]|0;i=f[b+16>>2]|0;j=f[c+16>>2]|0;k=(f[a+48>>2]|0)>>>2;l=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;m=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;c=g+8|0;f[g>>2]=c;p=g+4|0;f[p>>2]=1032;q=(j|0)!=0;r=(m|0)<(a|0);m=q&r?o*20|0:o<<2;f[p>>2]=m;if(m>>>0>1032){s=OYa(m)|0;f[g>>2]=s;t=s}else t=c;a:do if(q){do if(r){s=t+(o<<2)|0;if((o|0)<=0)if(!s){v=11;break a}else{w=s;x=s;y=b|0?4:0;break}else z=0;do{m=j+((Y(z,b)|0)<<2)|0;A=f[m>>2]|0;m=z<<2;f[s+((m|3)<<2)>>2]=A;f[s+((m|2)<<2)>>2]=A;f[s+((m|1)<<2)>>2]=A;f[s+(m<<2)>>2]=A;z=z+1|0}while((z|0)!=(o|0));w=s;x=s;y=b|0?4:0}else{w=j;x=0;y=b}while(0);if((a|0)>0){A=(x|0)!=0;m=(o|0)>0;B=a+-4|0;C=d*0.0;D=d*0.0;E=d*0.0;F=0;G=i;while(1){if(A){if(m){H=0;do{I=h+((Y(H,k)|0)+F<<2)|0;J=x+((Y(H,y)|0)<<2)|0;n[t+(H<<2)>>2]=+n[I>>2]-+n[J>>2];H=H+1|0}while((H|0)!=(o|0))}}else if(m){H=0;do{s=h+((Y(H,k)|0)+F<<2)|0;J=w+((Y(H,y)|0)+F<<2)|0;n[t+(H<<2)>>2]=+n[s>>2]-+n[J>>2];H=H+1|0}while((H|0)!=(o|0))}b:do if((F|0)>(B|0))K=F;else{if(m)L=F;else{H=F;while(1){n[G+(H<<2)>>2]=E;n[G+(H+1<<2)>>2]=E;n[G+(H+2<<2)>>2]=E;n[G+(H+3<<2)>>2]=E;J=H+4|0;if((J|0)>(B|0)){K=J;break b}else H=J}}while(1){H=A?x:w+(L<<2)|0;J=0;M=0.0;N=0.0;O=0.0;P=0.0;s=h+(L<<2)|0;while(1){Q=+n[t+(J<<2)>>2];M=M+Q*(+n[s>>2]-+n[H>>2]);N=N+Q*(+n[s+4>>2]-+n[H+4>>2]);O=O+Q*(+n[s+8>>2]-+n[H+8>>2]);P=P+Q*(+n[s+12>>2]-+n[H+12>>2]);J=J+1|0;if((J|0)==(o|0))break;else{H=H+(y<<2)|0;s=s+(k<<2)|0}}n[G+(L<<2)>>2]=M*d;n[G+(L+1<<2)>>2]=N*d;n[G+(L+2<<2)>>2]=O*d;n[G+(L+3<<2)>>2]=P*d;s=L+4|0;if((s|0)>(B|0)){K=s;break}else L=s}}while(0);c:do if((K|0)<(a|0)){if(!m)if(A){s=K;while(1){n[G+(s<<2)>>2]=C;s=s+1|0;if((s|0)==(a|0))break c}}else{s=K;while(1){n[G+(s<<2)>>2]=D;s=s+1|0;if((s|0)==(a|0))break c}}if(A){s=K;do{H=x;J=0;Q=0.0;I=h+(s<<2)|0;while(1){Q=Q+ +n[t+(J<<2)>>2]*(+n[I>>2]-+n[H>>2]);J=J+1|0;if((J|0)==(o|0))break;else{H=H+(y<<2)|0;I=I+(k<<2)|0}}n[G+(s<<2)>>2]=Q*d;s=s+1|0}while((s|0)!=(a|0))}else{s=K;do{I=w+(s<<2)|0;H=0;P=0.0;J=h+(s<<2)|0;while(1){P=P+ +n[t+(H<<2)>>2]*(+n[J>>2]-+n[I>>2]);H=H+1|0;if((H|0)==(o|0))break;else{I=I+(y<<2)|0;J=J+(k<<2)|0}}n[G+(s<<2)>>2]=P*d;s=s+1|0}while((s|0)!=(a|0))}}while(0);F=F+1|0;if((F|0)==(a|0))break;else G=G+(l<<2)|0}}}else v=11;while(0);if((v|0)==11?(a|0)>0:0){v=(o|0)>0;y=a+-4|0;D=d*0.0;C=d*0.0;w=0;K=i;while(1){if(v){i=0;do{x=h+((Y(i,k)|0)+w<<2)|0;f[t+(i<<2)>>2]=f[x>>2];i=i+1|0}while((i|0)!=(o|0))}d:do if((w|0)>(y|0))R=w;else{if(v)S=w;else{i=w;while(1){n[K+(i<<2)>>2]=C;n[K+(i+1<<2)>>2]=C;n[K+(i+2<<2)>>2]=C;n[K+(i+3<<2)>>2]=C;x=i+4|0;if((x|0)>(y|0)){R=x;break d}else i=x}}while(1){i=0;E=0.0;Q=0.0;O=0.0;N=0.0;x=h+(S<<2)|0;while(1){M=+n[t+(i<<2)>>2];E=E+M*+n[x>>2];Q=Q+M*+n[x+4>>2];O=O+M*+n[x+8>>2];N=N+M*+n[x+12>>2];i=i+1|0;if((i|0)==(o|0))break;else x=x+(k<<2)|0}n[K+(S<<2)>>2]=E*d;n[K+(S+1<<2)>>2]=Q*d;n[K+(S+2<<2)>>2]=O*d;n[K+(S+3<<2)>>2]=N*d;x=S+4|0;if((x|0)>(y|0)){R=x;break}else S=x}}while(0);e:do if((R|0)<(a|0)){if(v)T=R;else{x=R;while(1){n[K+(x<<2)>>2]=D;x=x+1|0;if((x|0)==(a|0))break e}}do{x=0;M=0.0;i=h+(T<<2)|0;while(1){M=M+ +n[t+(x<<2)>>2]*+n[i>>2];x=x+1|0;if((x|0)==(o|0))break;else i=i+(k<<2)|0}n[K+(T<<2)>>2]=M*d;T=T+1|0}while((T|0)!=(a|0))}while(0);w=w+1|0;if((w|0)==(a|0))break;else K=K+(l<<2)|0}}if((t|0)==(c|0)){u=e;return}QYa(t);f[g>>2]=c;f[p>>2]=1032;u=e;return}function TO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0,Z=0.0,_=0,$=0.0,aa=0,ba=0.0;e=u;u=u+1056|0;g=e+1040|0;h=e;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>2;m=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;p=f[c>>2]|0;if(!k){if((p|0)<=0){u=e;return}c=a+-4|0;q=(a|0)<4;r=a&-4;t=(a|0)>0;v=(r|0)<(a|0);w=0;x=j;while(1){y=i+((Y(w,l)|0)<<2)|0;if(q){z=w;do{A=i+((Y(z,l)|0)<<2)|0;if(t){B=0;C=0.0;while(1){D=C+ +n[y+(B<<2)>>2]*+n[A+(B<<2)>>2];B=B+1|0;if((B|0)==(a|0)){E=D;break}else C=D}}else E=0.0;n[x+(z<<2)>>2]=E*d;z=z+1|0}while((z|0)!=(p|0))}else{z=w;do{B=i+((Y(z,l)|0)<<2)|0;A=0;C=0.0;do{F=A|1;G=A|2;H=A|3;C=C+(+n[y+(A<<2)>>2]*+n[B+(A<<2)>>2]+ +n[y+(F<<2)>>2]*+n[B+(F<<2)>>2]+ +n[y+(G<<2)>>2]*+n[B+(G<<2)>>2]+ +n[y+(H<<2)>>2]*+n[B+(H<<2)>>2]);A=A+4|0}while((A|0)<=(c|0));if(v){A=r;D=C;while(1){I=D+ +n[y+(A<<2)>>2]*+n[B+(A<<2)>>2];A=A+1|0;if((A|0)==(a|0)){J=I;break}else D=I}}else J=C;n[x+(z<<2)>>2]=J*d;z=z+1|0}while((z|0)!=(p|0))}w=w+1|0;if((w|0)==(p|0))break;else x=x+(m<<2)|0}u=e;return}x=(o|0)==(a|0)?4:0;w=a<<2;r=h+8|0;f[h>>2]=r;v=h+4|0;f[v>>2]=w;if(w>>>0>1032){c=OYa(w)|0;f[h>>2]=c;K=c}else K=r;if((p|0)>0){c=(o|0)<(a|0);o=(a|0)>0;w=g+12|0;t=g+8|0;q=g+4|0;z=a+-4|0;y=(a|0)<4;A=a&-4;B=Y(x,A)|0;H=g+B|0;G=0;F=k+B|0;B=j;while(1){j=i+((Y(G,l)|0)<<2)|0;L=k+((Y(G,b)|0)<<2)|0;if(c)if(o){M=0;do{n[K+(M<<2)>>2]=+n[j+(M<<2)>>2]-+n[L>>2];M=M+1|0}while((M|0)!=(a|0));N=21}else{O=G;N=22}else if(o){M=0;do{n[K+(M<<2)>>2]=+n[j+(M<<2)>>2]-+n[L+(M<<2)>>2];M=M+1|0}while((M|0)!=(a|0));N=21}else{P=F;Q=G;N=31}if((N|0)==21){N=0;if(c){O=G;N=22}else{P=F;Q=G;N=31}}if((N|0)==22)while(1){N=0;M=i+((Y(O,l)|0)<<2)|0;L=k+((Y(O,b)|0)<<2)|0;j=f[L>>2]|0;f[w>>2]=j;f[t>>2]=j;f[q>>2]=j;f[g>>2]=j;a:do if(y){R=0;S=0.0;T=g}else{J=(f[s>>2]=j,+n[s>>2]);L=0;E=0.0;U=g;while(1){V=L|1;W=L|2;X=L|3;D=E+(+n[K+(L<<2)>>2]*(+n[M+(L<<2)>>2]-J)+ +n[K+(V<<2)>>2]*(+n[M+(V<<2)>>2]-+n[U+4>>2])+ +n[K+(W<<2)>>2]*(+n[M+(W<<2)>>2]-+n[U+8>>2])+ +n[K+(X<<2)>>2]*(+n[M+(X<<2)>>2]-+n[U+12>>2]));X=L+4|0;W=U+(x<<2)|0;if((X|0)>(z|0)){R=A;S=D;T=H;break a}J=+n[W>>2];L=X;E=D;U=W}}while(0);if((R|0)<(a|0)){j=R;C=S;U=T;while(1){E=C+ +n[K+(j<<2)>>2]*(+n[M+(j<<2)>>2]-+n[U>>2]);j=j+1|0;if((j|0)==(a|0)){Z=E;break}else{C=E;U=U+4|0}}}else Z=S;n[B+(O<<2)>>2]=Z*d;O=O+1|0;if((O|0)==(p|0))break;else N=22}else if((N|0)==31)while(1){N=0;U=i+((Y(Q,l)|0)<<2)|0;j=k+((Y(Q,b)|0)<<2)|0;if(y){_=0;$=0.0;aa=j}else{M=0;C=0.0;L=j;while(1){j=M|1;W=M|2;X=M|3;E=C+(+n[K+(M<<2)>>2]*(+n[U+(M<<2)>>2]-+n[L>>2])+ +n[K+(j<<2)>>2]*(+n[U+(j<<2)>>2]-+n[L+4>>2])+ +n[K+(W<<2)>>2]*(+n[U+(W<<2)>>2]-+n[L+8>>2])+ +n[K+(X<<2)>>2]*(+n[U+(X<<2)>>2]-+n[L+12>>2]));M=M+4|0;if((M|0)>(z|0)){_=A;$=E;aa=P;break}else{C=E;L=L+(x<<2)|0}}}if((_|0)<(a|0)){L=_;C=$;M=aa;while(1){E=C+ +n[K+(L<<2)>>2]*(+n[U+(L<<2)>>2]-+n[M>>2]);L=L+1|0;if((L|0)==(a|0)){ba=E;break}else{C=E;M=M+4|0}}}else ba=$;n[B+(Q<<2)>>2]=ba*d;Q=Q+1|0;if((Q|0)==(p|0))break;else{P=P+(b<<2)|0;N=31}}G=G+1|0;if((G|0)==(p|0))break;else{F=F+(b<<2)|0;B=B+(m<<2)|0}}}if((K|0)!=(r|0)){QYa(K);f[h>>2]=r;f[v>>2]=1032}u=e;return}function UO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;e=u;u=u+1040|0;g=e;h=f[a+16>>2]|0;i=f[b+16>>2]|0;j=f[c+16>>2]|0;k=(f[a+48>>2]|0)>>>2;l=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;m=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;c=g+8|0;f[g>>2]=c;q=g+4|0;f[q>>2]=1032;r=(j|0)!=0;s=(m|0)<(a|0);m=r&s?o*40|0:o<<3;f[q>>2]=m;if(m>>>0>1032){t=OYa(m)|0;f[g>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(o<<3)|0;if((o|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{m=j+((Y(A,b)|0)<<3)|0;B=+p[m>>3];m=A<<2;p[t+((m|3)<<3)>>3]=B;p[t+((m|2)<<3)>>3]=B;p[t+((m|1)<<3)>>3]=B;p[t+(m<<3)>>3]=B;A=A+1|0}while((A|0)!=(o|0));x=t;y=t;z=b|0?4:0}else{x=j;y=0;z=b}while(0);if((a|0)>0){m=(y|0)!=0;C=(o|0)>0;D=a+-4|0;B=d*0.0;E=d*0.0;F=d*0.0;G=0;H=i;while(1){if(m){if(C){I=0;do{J=h+((Y(I,k)|0)+G<<2)|0;K=y+((Y(I,z)|0)<<3)|0;p[v+(I<<3)>>3]=+n[J>>2]-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}}else if(C){I=0;do{t=h+((Y(I,k)|0)+G<<2)|0;K=x+((Y(I,z)|0)+G<<3)|0;p[v+(I<<3)>>3]=+n[t>>2]-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}b:do if((G|0)>(D|0))L=G;else{if(C)M=G;else{I=G;while(1){p[H+(I<<3)>>3]=F;p[H+(I+1<<3)>>3]=F;p[H+(I+2<<3)>>3]=F;p[H+(I+3<<3)>>3]=F;K=I+4|0;if((K|0)>(D|0)){L=K;break b}else I=K}}while(1){I=m?y:x+(M<<3)|0;K=0;N=0.0;O=0.0;P=0.0;Q=0.0;t=h+(M<<2)|0;while(1){R=+p[v+(K<<3)>>3];N=N+R*(+n[t>>2]-+p[I>>3]);O=O+R*(+n[t+4>>2]-+p[I+8>>3]);P=P+R*(+n[t+8>>2]-+p[I+16>>3]);Q=Q+R*(+n[t+12>>2]-+p[I+24>>3]);K=K+1|0;if((K|0)==(o|0))break;else{I=I+(z<<3)|0;t=t+(k<<2)|0}}p[H+(M<<3)>>3]=N*d;p[H+(M+1<<3)>>3]=O*d;p[H+(M+2<<3)>>3]=P*d;p[H+(M+3<<3)>>3]=Q*d;t=M+4|0;if((t|0)>(D|0)){L=t;break}else M=t}}while(0);c:do if((L|0)<(a|0)){if(!C)if(m){t=L;while(1){p[H+(t<<3)>>3]=B;t=t+1|0;if((t|0)==(a|0))break c}}else{t=L;while(1){p[H+(t<<3)>>3]=E;t=t+1|0;if((t|0)==(a|0))break c}}if(m){t=L;do{I=y;K=0;R=0.0;J=h+(t<<2)|0;while(1){R=R+ +p[v+(K<<3)>>3]*(+n[J>>2]-+p[I>>3]);K=K+1|0;if((K|0)==(o|0))break;else{I=I+(z<<3)|0;J=J+(k<<2)|0}}p[H+(t<<3)>>3]=R*d;t=t+1|0}while((t|0)!=(a|0))}else{t=L;do{J=x+(t<<3)|0;I=0;Q=0.0;K=h+(t<<2)|0;while(1){Q=Q+ +p[v+(I<<3)>>3]*(+n[K>>2]-+p[J>>3]);I=I+1|0;if((I|0)==(o|0))break;else{J=J+(z<<3)|0;K=K+(k<<2)|0}}p[H+(t<<3)>>3]=Q*d;t=t+1|0}while((t|0)!=(a|0))}}while(0);G=G+1|0;if((G|0)==(a|0))break;else H=H+(l<<3)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(o|0)>0;z=a+-4|0;E=d*0.0;B=d*0.0;x=0;L=i;while(1){if(w){i=0;do{y=h+((Y(i,k)|0)+x<<2)|0;p[v+(i<<3)>>3]=+n[y>>2];i=i+1|0}while((i|0)!=(o|0))}d:do if((x|0)>(z|0))S=x;else{if(w)T=x;else{i=x;while(1){p[L+(i<<3)>>3]=B;p[L+(i+1<<3)>>3]=B;p[L+(i+2<<3)>>3]=B;p[L+(i+3<<3)>>3]=B;y=i+4|0;if((y|0)>(z|0)){S=y;break d}else i=y}}while(1){i=0;F=0.0;R=0.0;P=0.0;O=0.0;y=h+(T<<2)|0;while(1){N=+p[v+(i<<3)>>3];F=F+N*+n[y>>2];R=R+N*+n[y+4>>2];P=P+N*+n[y+8>>2];O=O+N*+n[y+12>>2];i=i+1|0;if((i|0)==(o|0))break;else y=y+(k<<2)|0}p[L+(T<<3)>>3]=F*d;p[L+(T+1<<3)>>3]=R*d;p[L+(T+2<<3)>>3]=P*d;p[L+(T+3<<3)>>3]=O*d;y=T+4|0;if((y|0)>(z|0)){S=y;break}else T=y}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{y=S;while(1){p[L+(y<<3)>>3]=E;y=y+1|0;if((y|0)==(a|0))break e}}do{y=0;N=0.0;i=h+(U<<2)|0;while(1){N=N+ +p[v+(y<<3)>>3]*+n[i>>2];y=y+1|0;if((y|0)==(o|0))break;else i=i+(k<<2)|0}p[L+(U<<3)>>3]=N*d;U=U+1|0}while((U|0)!=(a|0))}while(0);x=x+1|0;if((x|0)==(a|0))break;else L=L+(l<<3)|0}}if((v|0)==(c|0)){u=e;return}QYa(v);f[g>>2]=c;f[q>>2]=1032;u=e;return}function VO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0.0,Z=0,_=0.0,$=0,aa=0.0;e=u;u=u+1072|0;g=e;h=e+32|0;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>2;m=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!k){if((q|0)<=0){u=e;return}c=a+-4|0;r=(a|0)<4;s=a&-4;t=(a|0)>0;v=(s|0)<(a|0);w=0;x=j;while(1){y=i+((Y(w,l)|0)<<2)|0;if(r){z=w;do{A=i+((Y(z,l)|0)<<2)|0;if(t){B=0;C=0.0;while(1){D=C+ +n[y+(B<<2)>>2]*+n[A+(B<<2)>>2];B=B+1|0;if((B|0)==(a|0)){E=D;break}else C=D}}else E=0.0;p[x+(z<<3)>>3]=E*d;z=z+1|0}while((z|0)!=(q|0))}else{z=w;do{B=i+((Y(z,l)|0)<<2)|0;A=0;C=0.0;do{F=A|1;G=A|2;H=A|3;C=C+(+n[y+(A<<2)>>2]*+n[B+(A<<2)>>2]+ +n[y+(F<<2)>>2]*+n[B+(F<<2)>>2]+ +n[y+(G<<2)>>2]*+n[B+(G<<2)>>2]+ +n[y+(H<<2)>>2]*+n[B+(H<<2)>>2]);A=A+4|0}while((A|0)<=(c|0));if(v){A=s;D=C;while(1){I=D+ +n[y+(A<<2)>>2]*+n[B+(A<<2)>>2];A=A+1|0;if((A|0)==(a|0)){J=I;break}else D=I}}else J=C;p[x+(z<<3)>>3]=J*d;z=z+1|0}while((z|0)!=(q|0))}w=w+1|0;if((w|0)==(q|0))break;else x=x+(m<<3)|0}u=e;return}x=(o|0)==(a|0)?4:0;w=a<<3;s=h+8|0;f[h>>2]=s;v=h+4|0;f[v>>2]=w;if(w>>>0>1032){c=OYa(w)|0;f[h>>2]=c;K=c}else K=s;if((q|0)>0){c=(o|0)<(a|0);o=(a|0)>0;w=g+24|0;t=g+16|0;r=g+8|0;z=a+-4|0;y=(a|0)<4;A=z>>>2;B=(A<<2)+4|0;H=Y(x,(A<<3)+8|0)|0;A=g+H|0;G=0;F=k+H|0;H=j;while(1){j=i+((Y(G,l)|0)<<2)|0;L=k+((Y(G,b)|0)<<3)|0;if(c)if(o){M=0;do{p[K+(M<<3)>>3]=+n[j+(M<<2)>>2]-+p[L>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{O=G;N=22}else if(o){M=0;do{p[K+(M<<3)>>3]=+n[j+(M<<2)>>2]-+p[L+(M<<3)>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{P=F;Q=G;N=30}if((N|0)==21){N=0;if(c){O=G;N=22}else{P=F;Q=G;N=30}}if((N|0)==22)while(1){N=0;M=i+((Y(O,l)|0)<<2)|0;L=k+((Y(O,b)|0)<<3)|0;J=+p[L>>3];p[w>>3]=J;p[t>>3]=J;p[r>>3]=J;p[g>>3]=J;a:do if(y){R=0;S=0.0;T=g}else{E=J;L=0;D=0.0;j=g;while(1){U=L|1;V=L|2;W=L|3;I=D+(+p[K+(L<<3)>>3]*(+n[M+(L<<2)>>2]-E)+ +p[K+(U<<3)>>3]*(+n[M+(U<<2)>>2]-+p[j+8>>3])+ +p[K+(V<<3)>>3]*(+n[M+(V<<2)>>2]-+p[j+16>>3])+ +p[K+(W<<3)>>3]*(+n[M+(W<<2)>>2]-+p[j+24>>3]));W=L+4|0;V=j+(x<<3)|0;if((W|0)>(z|0)){R=B;S=I;T=A;break a}E=+p[V>>3];L=W;D=I;j=V}}while(0);if((R|0)<(a|0)){j=R;J=S;L=T;while(1){C=J+ +p[K+(j<<3)>>3]*(+n[M+(j<<2)>>2]-+p[L>>3]);j=j+1|0;if((j|0)==(a|0)){X=C;break}else{J=C;L=L+8|0}}}else X=S;p[H+(O<<3)>>3]=X*d;O=O+1|0;if((O|0)==(q|0))break;else N=22}else if((N|0)==30)while(1){N=0;L=i+((Y(Q,l)|0)<<2)|0;j=k+((Y(Q,b)|0)<<3)|0;if(y){Z=0;_=0.0;$=j}else{M=0;J=0.0;V=j;while(1){j=M|1;W=M|2;U=M|3;C=J+(+p[K+(M<<3)>>3]*(+n[L+(M<<2)>>2]-+p[V>>3])+ +p[K+(j<<3)>>3]*(+n[L+(j<<2)>>2]-+p[V+8>>3])+ +p[K+(W<<3)>>3]*(+n[L+(W<<2)>>2]-+p[V+16>>3])+ +p[K+(U<<3)>>3]*(+n[L+(U<<2)>>2]-+p[V+24>>3]));M=M+4|0;if((M|0)>(z|0)){Z=B;_=C;$=P;break}else{J=C;V=V+(x<<3)|0}}}if((Z|0)<(a|0)){V=Z;J=_;M=$;while(1){C=J+ +p[K+(V<<3)>>3]*(+n[L+(V<<2)>>2]-+p[M>>3]);V=V+1|0;if((V|0)==(a|0)){aa=C;break}else{J=C;M=M+8|0}}}else aa=_;p[H+(Q<<3)>>3]=aa*d;Q=Q+1|0;if((Q|0)==(q|0))break;else{P=P+(b<<3)|0;N=30}}G=G+1|0;if((G|0)==(q|0))break;else{F=F+(b<<3)|0;H=H+(m<<3)|0}}}if((K|0)!=(s|0)){QYa(K);f[h>>2]=s;f[v>>2]=1032}u=e;return}function WO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0;e=u;u=u+1040|0;g=e;h=f[a+16>>2]|0;i=f[b+16>>2]|0;j=f[c+16>>2]|0;k=(f[a+48>>2]|0)>>>3;l=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;m=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;n=f[c>>2]|0;c=g+8|0;f[g>>2]=c;o=g+4|0;f[o>>2]=1032;q=(j|0)!=0;r=(m|0)<(a|0);m=q&r?n*40|0:n<<3;f[o>>2]=m;if(m>>>0>1032){s=OYa(m)|0;f[g>>2]=s;t=s}else t=c;a:do if(q){do if(r){s=t+(n<<3)|0;if((n|0)<=0)if(!s){v=11;break a}else{w=s;x=s;y=b|0?4:0;break}else z=0;do{m=j+((Y(z,b)|0)<<3)|0;A=+p[m>>3];m=z<<2;p[s+((m|3)<<3)>>3]=A;p[s+((m|2)<<3)>>3]=A;p[s+((m|1)<<3)>>3]=A;p[s+(m<<3)>>3]=A;z=z+1|0}while((z|0)!=(n|0));w=s;x=s;y=b|0?4:0}else{w=j;x=0;y=b}while(0);if((a|0)>0){m=(x|0)!=0;B=(n|0)>0;C=a+-4|0;A=d*0.0;D=d*0.0;E=d*0.0;F=0;G=i;while(1){if(m){if(B){H=0;do{I=h+((Y(H,k)|0)+F<<3)|0;J=x+((Y(H,y)|0)<<3)|0;p[t+(H<<3)>>3]=+p[I>>3]-+p[J>>3];H=H+1|0}while((H|0)!=(n|0))}}else if(B){H=0;do{s=h+((Y(H,k)|0)+F<<3)|0;J=w+((Y(H,y)|0)+F<<3)|0;p[t+(H<<3)>>3]=+p[s>>3]-+p[J>>3];H=H+1|0}while((H|0)!=(n|0))}b:do if((F|0)>(C|0))K=F;else{if(B)L=F;else{H=F;while(1){p[G+(H<<3)>>3]=E;p[G+(H+1<<3)>>3]=E;p[G+(H+2<<3)>>3]=E;p[G+(H+3<<3)>>3]=E;J=H+4|0;if((J|0)>(C|0)){K=J;break b}else H=J}}while(1){H=m?x:w+(L<<3)|0;J=0;M=0.0;N=0.0;O=0.0;P=0.0;s=h+(L<<3)|0;while(1){Q=+p[t+(J<<3)>>3];M=M+Q*(+p[s>>3]-+p[H>>3]);N=N+Q*(+p[s+8>>3]-+p[H+8>>3]);O=O+Q*(+p[s+16>>3]-+p[H+16>>3]);P=P+Q*(+p[s+24>>3]-+p[H+24>>3]);J=J+1|0;if((J|0)==(n|0))break;else{H=H+(y<<3)|0;s=s+(k<<3)|0}}p[G+(L<<3)>>3]=M*d;p[G+(L+1<<3)>>3]=N*d;p[G+(L+2<<3)>>3]=O*d;p[G+(L+3<<3)>>3]=P*d;s=L+4|0;if((s|0)>(C|0)){K=s;break}else L=s}}while(0);c:do if((K|0)<(a|0)){if(!B)if(m){s=K;while(1){p[G+(s<<3)>>3]=A;s=s+1|0;if((s|0)==(a|0))break c}}else{s=K;while(1){p[G+(s<<3)>>3]=D;s=s+1|0;if((s|0)==(a|0))break c}}if(m){s=K;do{H=x;J=0;Q=0.0;I=h+(s<<3)|0;while(1){Q=Q+ +p[t+(J<<3)>>3]*(+p[I>>3]-+p[H>>3]);J=J+1|0;if((J|0)==(n|0))break;else{H=H+(y<<3)|0;I=I+(k<<3)|0}}p[G+(s<<3)>>3]=Q*d;s=s+1|0}while((s|0)!=(a|0))}else{s=K;do{I=w+(s<<3)|0;H=0;P=0.0;J=h+(s<<3)|0;while(1){P=P+ +p[t+(H<<3)>>3]*(+p[J>>3]-+p[I>>3]);H=H+1|0;if((H|0)==(n|0))break;else{I=I+(y<<3)|0;J=J+(k<<3)|0}}p[G+(s<<3)>>3]=P*d;s=s+1|0}while((s|0)!=(a|0))}}while(0);F=F+1|0;if((F|0)==(a|0))break;else G=G+(l<<3)|0}}}else v=11;while(0);if((v|0)==11?(a|0)>0:0){v=(n|0)>0;y=a+-4|0;D=d*0.0;A=d*0.0;w=0;K=i;while(1){if(v){i=0;do{x=h+((Y(i,k)|0)+w<<3)|0;p[t+(i<<3)>>3]=+p[x>>3];i=i+1|0}while((i|0)!=(n|0))}d:do if((w|0)>(y|0))R=w;else{if(v)S=w;else{i=w;while(1){p[K+(i<<3)>>3]=A;p[K+(i+1<<3)>>3]=A;p[K+(i+2<<3)>>3]=A;p[K+(i+3<<3)>>3]=A;x=i+4|0;if((x|0)>(y|0)){R=x;break d}else i=x}}while(1){i=0;E=0.0;Q=0.0;O=0.0;N=0.0;x=h+(S<<3)|0;while(1){M=+p[t+(i<<3)>>3];E=E+M*+p[x>>3];Q=Q+M*+p[x+8>>3];O=O+M*+p[x+16>>3];N=N+M*+p[x+24>>3];i=i+1|0;if((i|0)==(n|0))break;else x=x+(k<<3)|0}p[K+(S<<3)>>3]=E*d;p[K+(S+1<<3)>>3]=Q*d;p[K+(S+2<<3)>>3]=O*d;p[K+(S+3<<3)>>3]=N*d;x=S+4|0;if((x|0)>(y|0)){R=x;break}else S=x}}while(0);e:do if((R|0)<(a|0)){if(v)T=R;else{x=R;while(1){p[K+(x<<3)>>3]=D;x=x+1|0;if((x|0)==(a|0))break e}}do{x=0;M=0.0;i=h+(T<<3)|0;while(1){M=M+ +p[t+(x<<3)>>3]*+p[i>>3];x=x+1|0;if((x|0)==(n|0))break;else i=i+(k<<3)|0}p[K+(T<<3)>>3]=M*d;T=T+1|0}while((T|0)!=(a|0))}while(0);w=w+1|0;if((w|0)==(a|0))break;else K=K+(l<<3)|0}}if((t|0)==(c|0)){u=e;return}QYa(t);f[g>>2]=c;f[o>>2]=1032;u=e;return}function XO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0.0,X=0,Z=0.0,_=0,$=0.0;e=u;u=u+1072|0;g=e;h=e+32|0;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>3;m=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;n=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;if(!k){if((o|0)<=0){u=e;return}c=a+-4|0;q=(a|0)<4;r=a&-4;s=(a|0)>0;t=(r|0)<(a|0);v=0;w=j;while(1){x=i+((Y(v,l)|0)<<3)|0;if(q){y=v;do{z=i+((Y(y,l)|0)<<3)|0;if(s){A=0;B=0.0;while(1){C=B+ +p[x+(A<<3)>>3]*+p[z+(A<<3)>>3];A=A+1|0;if((A|0)==(a|0)){D=C;break}else B=C}}else D=0.0;p[w+(y<<3)>>3]=D*d;y=y+1|0}while((y|0)!=(o|0))}else{y=v;do{A=i+((Y(y,l)|0)<<3)|0;z=0;B=0.0;do{E=z|1;F=z|2;G=z|3;B=B+(+p[x+(z<<3)>>3]*+p[A+(z<<3)>>3]+ +p[x+(E<<3)>>3]*+p[A+(E<<3)>>3]+ +p[x+(F<<3)>>3]*+p[A+(F<<3)>>3]+ +p[x+(G<<3)>>3]*+p[A+(G<<3)>>3]);z=z+4|0}while((z|0)<=(c|0));if(t){z=r;C=B;while(1){H=C+ +p[x+(z<<3)>>3]*+p[A+(z<<3)>>3];z=z+1|0;if((z|0)==(a|0)){I=H;break}else C=H}}else I=B;p[w+(y<<3)>>3]=I*d;y=y+1|0}while((y|0)!=(o|0))}v=v+1|0;if((v|0)==(o|0))break;else w=w+(m<<3)|0}u=e;return}w=(n|0)==(a|0)?4:0;v=a<<3;r=h+8|0;f[h>>2]=r;t=h+4|0;f[t>>2]=v;if(v>>>0>1032){c=OYa(v)|0;f[h>>2]=c;J=c}else J=r;if((o|0)>0){c=(n|0)<(a|0);n=(a|0)>0;v=g+24|0;s=g+16|0;q=g+8|0;y=a+-4|0;x=(a|0)<4;z=y>>>2;A=(z<<2)+4|0;G=Y(w,(z<<3)+8|0)|0;z=g+G|0;F=0;E=k+G|0;G=j;while(1){j=i+((Y(F,l)|0)<<3)|0;K=k+((Y(F,b)|0)<<3)|0;if(c)if(n){L=0;do{p[J+(L<<3)>>3]=+p[j+(L<<3)>>3]-+p[K>>3];L=L+1|0}while((L|0)!=(a|0));M=21}else{N=F;M=22}else if(n){L=0;do{p[J+(L<<3)>>3]=+p[j+(L<<3)>>3]-+p[K+(L<<3)>>3];L=L+1|0}while((L|0)!=(a|0));M=21}else{O=E;P=F;M=30}if((M|0)==21){M=0;if(c){N=F;M=22}else{O=E;P=F;M=30}}if((M|0)==22)while(1){M=0;L=i+((Y(N,l)|0)<<3)|0;K=k+((Y(N,b)|0)<<3)|0;I=+p[K>>3];p[v>>3]=I;p[s>>3]=I;p[q>>3]=I;p[g>>3]=I;a:do if(x){Q=0;R=0.0;S=g}else{D=I;K=0;C=0.0;j=g;while(1){T=K|1;U=K|2;V=K|3;H=C+(+p[J+(K<<3)>>3]*(+p[L+(K<<3)>>3]-D)+ +p[J+(T<<3)>>3]*(+p[L+(T<<3)>>3]-+p[j+8>>3])+ +p[J+(U<<3)>>3]*(+p[L+(U<<3)>>3]-+p[j+16>>3])+ +p[J+(V<<3)>>3]*(+p[L+(V<<3)>>3]-+p[j+24>>3]));V=K+4|0;U=j+(w<<3)|0;if((V|0)>(y|0)){Q=A;R=H;S=z;break a}D=+p[U>>3];K=V;C=H;j=U}}while(0);if((Q|0)<(a|0)){j=Q;I=R;K=S;while(1){B=I+ +p[J+(j<<3)>>3]*(+p[L+(j<<3)>>3]-+p[K>>3]);j=j+1|0;if((j|0)==(a|0)){W=B;break}else{I=B;K=K+8|0}}}else W=R;p[G+(N<<3)>>3]=W*d;N=N+1|0;if((N|0)==(o|0))break;else M=22}else if((M|0)==30)while(1){M=0;K=i+((Y(P,l)|0)<<3)|0;j=k+((Y(P,b)|0)<<3)|0;if(x){X=0;Z=0.0;_=j}else{L=0;I=0.0;U=j;while(1){j=L|1;V=L|2;T=L|3;B=I+(+p[J+(L<<3)>>3]*(+p[K+(L<<3)>>3]-+p[U>>3])+ +p[J+(j<<3)>>3]*(+p[K+(j<<3)>>3]-+p[U+8>>3])+ +p[J+(V<<3)>>3]*(+p[K+(V<<3)>>3]-+p[U+16>>3])+ +p[J+(T<<3)>>3]*(+p[K+(T<<3)>>3]-+p[U+24>>3]));L=L+4|0;if((L|0)>(y|0)){X=A;Z=B;_=O;break}else{I=B;U=U+(w<<3)|0}}}if((X|0)<(a|0)){U=X;I=Z;L=_;while(1){B=I+ +p[J+(U<<3)>>3]*(+p[K+(U<<3)>>3]-+p[L>>3]);U=U+1|0;if((U|0)==(a|0)){$=B;break}else{I=B;L=L+8|0}}}else $=Z;p[G+(P<<3)>>3]=$*d;P=P+1|0;if((P|0)==(o|0))break;else{O=O+(b<<3)|0;M=30}}F=F+1|0;if((F|0)==(o|0))break;else{E=E+(b<<3)|0;G=G+(m<<3)|0}}}if((J|0)!=(r|0)){QYa(J);f[h>>2]=r;f[t>>2]=1032}u=e;return}function YO(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0;d=u;u=u+128|0;e=d+112|0;g=d+56|0;h=d+40|0;i=d+32|0;j=d;_$(e,39924);do if((NS(c)|0)==65536){k=f[c+4>>2]|0;f[g>>2]=f[k>>2];l=g+4|0;m=k+4|0;f[l>>2]=f[m>>2];n=g+8|0;f[n>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];f[g+16>>2]=f[k+16>>2];f[g+20>>2]=f[k+20>>2];f[g+24>>2]=f[k+24>>2];f[g+28>>2]=f[k+28>>2];f[g+32>>2]=f[k+32>>2];o=f[k+36>>2]|0;f[g+36>>2]=o;f[g+40>>2]=n;n=g+48|0;p=g+44|0;f[p>>2]=n;f[n>>2]=0;f[g+52>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[k+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2];q=g;break}else{f[l>>2]=0;BR(g,k);q=g;break}}else{OR(g,c,-1);q=g}while(0);c=f[a>>2]|0;k=(c>>>3&511)+1|0;l=c&7;m=f[39944+(l<<2)>>2]|0;if((f[q>>2]^c)&4095|0){f[h>>2]=0;f[h+4>>2]=0;r=c$(h,20)|0;s=169249;t=r+20|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-215,h,169270,168105,3383);d$(h)}c=g+40|0;n=f[c>>2]|0;p=f[n+-4>>2]|0;o=a+40|0;v=f[o>>2]|0;a:do if((p|0)==(f[v+-4>>2]|0)){if((p|0)==2){if((f[n>>2]|0)!=(f[v>>2]|0)){w=17;break}if((f[n+4>>2]|0)==(f[v+4>>2]|0))break;else{w=17;break}}if((p|0)>0){x=0;do{if((f[n+(x<<2)>>2]|0)!=(f[v+(x<<2)>>2]|0)){w=17;break a}x=x+1|0}while((x|0)<(p|0))}}else w=17;while(0);if((w|0)==17){f[h>>2]=0;f[h+4>>2]=0;r=c$(h,16)|0;s=169274;t=r+16|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-215,h,169270,168105,3383);d$(h)}if((l|0)==7){f[h>>2]=0;f[h+4>>2]=0;r=c$(h,9)|0;s=323538;t=r+9|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-215,h,169270,168105,3383);d$(h)}if((f[a>>2]&16384|0)!=0?(f[q>>2]&16384|0)!=0:0){q=f[a+4>>2]|0;if((q|0)<3)y=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{s=f[o>>2]|0;o=0;r=1;while(1){t=Y(f[s+(o<<2)>>2]|0,r)|0;o=o+1|0;if((o|0)==(q|0)){y=t;break}else r=t}}r=Y(y,k)|0;z=+mh[m&31](f[a+16>>2]|0,f[g+16>>2]|0,r)}else{f[h>>2]=a;f[h+4>>2]=g;f[h+8>>2]=0;bU(j,h,i,-1);h=Y(f[j+20>>2]|0,k)|0;k=j+16|0;a=i+4|0;r=0;A=0.0;while(1){if(r>>>0>=(f[k>>2]|0)>>>0)break;B=A+ +mh[m&31](f[i>>2]|0,f[a>>2]|0,h);tR(j)|0;r=r+1|0;A=B}z=A}r=g+36|0;j=f[r>>2]|0;if(j|0?(h=j+12|0,j=f[h>>2]|0,f[h>>2]=j+-1,(j|0)==1):0)CR(g);f[r>>2]=0;r=g+16|0;j=g+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[j>>2]|0)>0){r=f[c>>2]|0;c=0;do{f[r+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[j>>2]|0))}j=f[g+44>>2]|0;if((j|0)!=(g+48|0))ZF(j);if(!(f[e+4>>2]|0)){u=d;return +z}u=d;return +z}function ZO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0,i=0.0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0;d=c+-4|0;if((c|0)<4){e=0;f=0.0}else{g=0;i=0.0;do{j=g|1;k=g|2;l=g|3;i=i+(+(h[a+g>>0]|0)*+(h[b+g>>0]|0)+ +(h[a+j>>0]|0)*+(h[b+j>>0]|0)+ +(h[a+k>>0]|0)*+(h[b+k>>0]|0)+ +(h[a+l>>0]|0)*+(h[b+l>>0]|0));g=g+4|0}while((g|0)<=(d|0));e=c&-4;f=i}if((e|0)<(c|0)){m=e;n=f}else{o=f;p=o+0.0;return +p}while(1){f=n+ +(h[a+m>>0]|0)*+(h[b+m>>0]|0);m=m+1|0;if((m|0)==(c|0)){o=f;break}else n=f}p=o+0.0;return +p}function _O(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0.0,h=0,i=0.0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0;e=d+-4|0;if((d|0)<4){f=0;g=0.0}else{h=0;i=0.0;do{j=h|1;k=h|2;l=h|3;i=i+(+(b[a+h>>0]|0)*+(b[c+h>>0]|0)+ +(b[a+j>>0]|0)*+(b[c+j>>0]|0)+ +(b[a+k>>0]|0)*+(b[c+k>>0]|0)+ +(b[a+l>>0]|0)*+(b[c+l>>0]|0));h=h+4|0}while((h|0)<=(e|0));f=d&-4;g=i}if((f|0)<(d|0)){m=f;n=g}else{o=g;p=o+0.0;return +p}while(1){g=n+ +(b[a+m>>0]|0)*+(b[c+m>>0]|0);m=m+1|0;if((m|0)==(d|0)){o=g;break}else n=g}p=o+0.0;return +p}function $O(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0,h=0.0,i=0,k=0,l=0,m=0,n=0.0,o=0.0;d=c+-4|0;if((c|0)<4){e=0;f=0.0}else{g=0;h=0.0;do{i=g|1;k=g|2;l=g|3;h=h+(+(j[a+(g<<1)>>1]|0)*+(j[b+(g<<1)>>1]|0)+ +(j[a+(i<<1)>>1]|0)*+(j[b+(i<<1)>>1]|0)+ +(j[a+(k<<1)>>1]|0)*+(j[b+(k<<1)>>1]|0)+ +(j[a+(l<<1)>>1]|0)*+(j[b+(l<<1)>>1]|0));g=g+4|0}while((g|0)<=(d|0));e=c&-4;f=h}if((e|0)<(c|0)){m=e;n=f}else{o=f;return +o}while(1){f=n+ +(j[a+(m<<1)>>1]|0)*+(j[b+(m<<1)>>1]|0);m=m+1|0;if((m|0)==(c|0)){o=f;break}else n=f}return +o}function aP(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0.0,h=0,i=0.0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;e=c+-4|0;if((c|0)<4){f=0;g=0.0}else{h=0;i=0.0;do{j=h|1;k=h|2;l=h|3;i=i+(+(d[a+(h<<1)>>1]|0)*+(d[b+(h<<1)>>1]|0)+ +(d[a+(j<<1)>>1]|0)*+(d[b+(j<<1)>>1]|0)+ +(d[a+(k<<1)>>1]|0)*+(d[b+(k<<1)>>1]|0)+ +(d[a+(l<<1)>>1]|0)*+(d[b+(l<<1)>>1]|0));h=h+4|0}while((h|0)<=(e|0));f=c&-4;g=i}if((f|0)<(c|0)){m=f;n=g}else{o=g;return +o}while(1){g=n+ +(d[a+(m<<1)>>1]|0)*+(d[b+(m<<1)>>1]|0);m=m+1|0;if((m|0)==(c|0)){o=g;break}else n=g}return +o}function bP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0.0,h=0,i=0.0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;d=c+-4|0;if((c|0)<4){e=0;g=0.0}else{h=0;i=0.0;do{j=h|1;k=h|2;l=h|3;i=i+(+(f[a+(h<<2)>>2]|0)*+(f[b+(h<<2)>>2]|0)+ +(f[a+(j<<2)>>2]|0)*+(f[b+(j<<2)>>2]|0)+ +(f[a+(k<<2)>>2]|0)*+(f[b+(k<<2)>>2]|0)+ +(f[a+(l<<2)>>2]|0)*+(f[b+(l<<2)>>2]|0));h=h+4|0}while((h|0)<=(d|0));e=c&-4;g=i}if((e|0)<(c|0)){m=e;n=g}else{o=g;return +o}while(1){g=n+ +(f[a+(m<<2)>>2]|0)*+(f[b+(m<<2)>>2]|0);m=m+1|0;if((m|0)==(c|0)){o=g;break}else n=g}return +o}function cP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0,h=0.0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,p=0.0;d=c+-4|0;if((c|0)<4){e=0;f=0.0}else{g=0;h=0.0;do{i=g|1;j=g|2;k=g|3;h=h+(+n[a+(g<<2)>>2]*+n[b+(g<<2)>>2]+ +n[a+(i<<2)>>2]*+n[b+(i<<2)>>2]+ +n[a+(j<<2)>>2]*+n[b+(j<<2)>>2]+ +n[a+(k<<2)>>2]*+n[b+(k<<2)>>2]);g=g+4|0}while((g|0)<=(d|0));e=c&-4;f=h}if((e|0)<(c|0)){l=e;m=f}else{o=f;p=o+0.0;return +p}while(1){f=m+ +n[a+(l<<2)>>2]*+n[b+(l<<2)>>2];l=l+1|0;if((l|0)==(c|0)){o=f;break}else m=f}p=o+0.0;return +p}function dP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0,h=0.0,i=0,j=0,k=0,l=0,m=0.0,n=0.0;d=c+-4|0;if((c|0)<4){e=0;f=0.0}else{g=0;h=0.0;do{i=g|1;j=g|2;k=g|3;h=h+(+p[a+(g<<3)>>3]*+p[b+(g<<3)>>3]+ +p[a+(i<<3)>>3]*+p[b+(i<<3)>>3]+ +p[a+(j<<3)>>3]*+p[b+(j<<3)>>3]+ +p[a+(k<<3)>>3]*+p[b+(k<<3)>>3]);g=g+4|0}while((g|0)<=(d|0));e=c&-4;f=h}if((e|0)<(c|0)){l=e;m=f}else{n=f;return +n}while(1){f=m+ +p[a+(l<<3)>>3]*+p[b+(l<<3)>>3];l=l+1|0;if((l|0)==(c|0)){n=f;break}else m=f}return +n}function eP(a){a=a|0;return}function fP(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=u;u=u+656|0;h=g+312|0;i=g+256|0;j=g+592|0;k=g+32|0;l=g+536|0;m=g;if(!($h[f[(f[a>>2]|0)+8>>2]&255](a,b)|0)){f[j>>2]=1124007936;a=j+4|0;n=j+8|0;o=j+40|0;q=a;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[o>>2]=n;n=j+48|0;s=j+44|0;f[s>>2]=n;f[n>>2]=0;f[j+52>>2]=0;t=f[b>>2]|0;Ah[f[(f[t>>2]|0)+12>>2]&255](t,b,j,-1);t=c;v=f[t>>2]|0;w=f[t+4>>2]|0;t=d;x=f[t+4>>2]|0;y=h;f[y>>2]=f[t>>2];f[y+4>>2]=x;x=i;f[x>>2]=v;f[x+4>>2]=w;DR(l,j,i,h);f[h>>2]=1124007936;w=h+4|0;x=h+8|0;v=h+40|0;q=w;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[v>>2]=x;x=h+48|0;y=h+44|0;f[y>>2]=x;f[x>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;t=i+4|0;z=i+8|0;A=i+40|0;q=t;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[A>>2]=z;z=i+48|0;B=i+44|0;f[B>>2]=z;f[z>>2]=0;f[i+52>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;DP(k,40116,0,l,h,i,1.0,1.0,m);EP(e,k)|0;fj(k);m=i+36|0;C=f[m>>2]|0;if(C|0?(D=C+12|0,C=f[D>>2]|0,f[D>>2]=C+-1,(C|0)==1):0)CR(i);f[m>>2]=0;m=i+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[t>>2]|0)>0){m=f[A>>2]|0;A=0;do{f[m+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[t>>2]|0))}t=f[B>>2]|0;if((t|0)!=(z|0))ZF(t);t=h+36|0;z=f[t>>2]|0;if(z|0?(B=z+12|0,z=f[B>>2]|0,f[B>>2]=z+-1,(z|0)==1):0)CR(h);f[t>>2]=0;t=h+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[w>>2]|0)>0){t=f[v>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[w>>2]|0))}w=f[y>>2]|0;if((w|0)!=(x|0))ZF(w);w=l+36|0;x=f[w>>2]|0;if(x|0?(y=x+12|0,x=f[y>>2]|0,f[y>>2]=x+-1,(x|0)==1):0)CR(l);f[w>>2]=0;w=l+16|0;x=l+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[x>>2]|0)>0){w=f[l+40>>2]|0;y=0;do{f[w+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[x>>2]|0))}x=f[l+44>>2]|0;if((x|0)!=(l+48|0))ZF(x);x=j+36|0;l=f[x>>2]|0;if(l|0?(y=l+12|0,l=f[y>>2]|0,f[y>>2]=l+-1,(l|0)==1):0)CR(j);f[x>>2]=0;x=j+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[a>>2]|0)>0){x=f[o>>2]|0;o=0;do{f[x+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[a>>2]|0))}a=f[s>>2]|0;if((a|0)!=(n|0))ZF(a);u=g;return}a=f[b>>2]|0;n=f[b+4>>2]|0;f[i>>2]=1124007936;s=i+4|0;o=i+8|0;x=i+40|0;q=s;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[x>>2]=o;o=i+48|0;l=i+44|0;f[l>>2]=o;f[o>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;y=j+4|0;w=j+8|0;v=j+40|0;q=y;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[v>>2]=w;w=j+48|0;t=j+44|0;f[t>>2]=w;f[w>>2]=0;f[j+52>>2]=0;f[k>>2]=1124007936;z=k+4|0;B=k+8|0;A=k+40|0;q=z;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[A>>2]=B;B=k+48|0;q=k+44|0;f[q>>2]=B;f[B>>2]=0;f[k+52>>2]=0;DP(h,a,n,i,j,k,+p[b+176>>3],+p[b+184>>3],b+192|0);EP(e,h)|0;fj(h);n=k+36|0;a=f[n>>2]|0;if(a|0?(r=a+12|0,a=f[r>>2]|0,f[r>>2]=a+-1,(a|0)==1):0)CR(k);f[n>>2]=0;n=k+16|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[z>>2]|0)>0){n=f[A>>2]|0;A=0;do{f[n+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[z>>2]|0))}z=f[q>>2]|0;if((z|0)!=(B|0))ZF(z);z=j+36|0;B=f[z>>2]|0;if(B|0?(q=B+12|0,B=f[q>>2]|0,f[q>>2]=B+-1,(B|0)==1):0)CR(j);f[z>>2]=0;z=j+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[y>>2]|0)>0){z=f[v>>2]|0;v=0;do{f[z+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[y>>2]|0))}y=f[t>>2]|0;if((y|0)!=(w|0))ZF(y);y=i+36|0;w=f[y>>2]|0;if(w|0?(t=w+12|0,w=f[t>>2]|0,f[t>>2]=w+-1,(w|0)==1):0)CR(i);f[y>>2]=0;y=i+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[s>>2]|0)>0){y=f[x>>2]|0;x=0;do{f[y+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[s>>2]|0))}s=f[l>>2]|0;if((s|0)!=(o|0))ZF(s);if(f[b+24>>2]|0){s=c;o=f[s>>2]|0;l=f[s+4>>2]|0;s=d;x=f[s+4>>2]|0;y=h;f[y>>2]=f[s>>2];f[y+4>>2]=x;x=i;f[x>>2]=o;f[x+4>>2]=l;DR(j,b+8|0,i,h);l=e+8|0;x=j+36|0;o=f[x>>2]|0;if((l|0)==(j|0))E=o;else{if(o|0){y=o+12|0;f[y>>2]=(f[y>>2]|0)+1}y=e+44|0;o=f[y>>2]|0;if(o|0?(s=o+12|0,o=f[s>>2]|0,f[s>>2]=o+-1,(o|0)==1):0)CR(l);f[y>>2]=0;o=e+24|0;s=e+12|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[s>>2]|0)>0){w=f[e+48>>2]|0;t=0;do{f[w+(t<<2)>>2]=0;t=t+1|0;F=f[s>>2]|0}while((t|0)<(F|0));f[l>>2]=f[j>>2];if((F|0)<3)G=38;else G=40}else{f[l>>2]=f[j>>2];G=38}if((G|0)==38){F=f[j+4>>2]|0;if((F|0)<3){f[s>>2]=F;f[e+16>>2]=f[j+8>>2];f[e+20>>2]=f[j+12>>2];F=f[j+44>>2]|0;s=f[e+52>>2]|0;f[s>>2]=f[F>>2];f[s+4>>2]=f[F+4>>2]}else G=40}if((G|0)==40)BR(l,j);f[o>>2]=f[j+16>>2];f[e+28>>2]=f[j+20>>2];f[e+32>>2]=f[j+24>>2];f[e+36>>2]=f[j+28>>2];f[e+40>>2]=f[j+32>>2];o=f[x>>2]|0;f[y>>2]=o;E=o}if(E|0?(o=E+12|0,E=f[o>>2]|0,f[o>>2]=E+-1,(E|0)==1):0)CR(j);f[x>>2]=0;x=j+16|0;E=j+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[E>>2]|0)>0){x=f[j+40>>2]|0;o=0;do{f[x+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[E>>2]|0))}E=f[j+44>>2]|0;if((E|0)!=(j+48|0))ZF(E)}if(f[b+80>>2]|0){E=c;o=f[E>>2]|0;x=f[E+4>>2]|0;E=d;y=f[E+4>>2]|0;l=h;f[l>>2]=f[E>>2];f[l+4>>2]=y;y=i;f[y>>2]=o;f[y+4>>2]=x;DR(j,b+64|0,i,h);x=e+64|0;y=j+36|0;o=f[y>>2]|0;if((x|0)==(j|0))H=o;else{if(o|0){l=o+12|0;f[l>>2]=(f[l>>2]|0)+1}l=e+100|0;o=f[l>>2]|0;if(o|0?(E=o+12|0,o=f[E>>2]|0,f[E>>2]=o+-1,(o|0)==1):0)CR(x);f[l>>2]=0;o=e+80|0;E=e+68|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[E>>2]|0)>0){F=f[e+104>>2]|0;s=0;do{f[F+(s<<2)>>2]=0;s=s+1|0;I=f[E>>2]|0}while((s|0)<(I|0));f[x>>2]=f[j>>2];if((I|0)<3)G=63;else G=65}else{f[x>>2]=f[j>>2];G=63}if((G|0)==63){I=f[j+4>>2]|0;if((I|0)<3){f[E>>2]=I;f[e+72>>2]=f[j+8>>2];f[e+76>>2]=f[j+12>>2];I=f[j+44>>2]|0;E=f[e+108>>2]|0;f[E>>2]=f[I>>2];f[E+4>>2]=f[I+4>>2]}else G=65}if((G|0)==65)BR(x,j);f[o>>2]=f[j+16>>2];f[e+84>>2]=f[j+20>>2];f[e+88>>2]=f[j+24>>2];f[e+92>>2]=f[j+28>>2];f[e+96>>2]=f[j+32>>2];o=f[y>>2]|0;f[l>>2]=o;H=o}if(H|0?(o=H+12|0,H=f[o>>2]|0,f[o>>2]=H+-1,(H|0)==1):0)CR(j);f[y>>2]=0;y=j+16|0;H=j+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[H>>2]|0)>0){y=f[j+40>>2]|0;o=0;do{f[y+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[H>>2]|0))}H=f[j+44>>2]|0;if((H|0)!=(j+48|0))ZF(H)}if(!(f[b+136>>2]|0)){u=g;return}H=c;c=f[H>>2]|0;o=f[H+4>>2]|0;H=d;d=f[H+4>>2]|0;y=h;f[y>>2]=f[H>>2];f[y+4>>2]=d;d=i;f[d>>2]=c;f[d+4>>2]=o;DR(j,b+120|0,i,h);h=e+120|0;i=j+36|0;b=f[i>>2]|0;if((h|0)==(j|0))J=b;else{if(b|0){o=b+12|0;f[o>>2]=(f[o>>2]|0)+1}o=e+156|0;b=f[o>>2]|0;if(b|0?(d=b+12|0,b=f[d>>2]|0,f[d>>2]=b+-1,(b|0)==1):0)CR(h);f[o>>2]=0;b=e+136|0;d=e+124|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){c=f[e+160>>2]|0;y=0;do{f[c+(y<<2)>>2]=0;y=y+1|0;K=f[d>>2]|0}while((y|0)<(K|0));f[h>>2]=f[j>>2];if((K|0)<3)G=88;else G=90}else{f[h>>2]=f[j>>2];G=88}if((G|0)==88){K=f[j+4>>2]|0;if((K|0)<3){f[d>>2]=K;f[e+128>>2]=f[j+8>>2];f[e+132>>2]=f[j+12>>2];K=f[j+44>>2]|0;d=f[e+164>>2]|0;f[d>>2]=f[K>>2];f[d+4>>2]=f[K+4>>2]}else G=90}if((G|0)==90)BR(h,j);f[b>>2]=f[j+16>>2];f[e+140>>2]=f[j+20>>2];f[e+144>>2]=f[j+24>>2];f[e+148>>2]=f[j+28>>2];f[e+152>>2]=f[j+32>>2];e=f[i>>2]|0;f[o>>2]=e;J=e}if(J|0?(e=J+12|0,J=f[e>>2]|0,f[e>>2]=J+-1,(J|0)==1):0)CR(j);f[i>>2]=0;i=j+16|0;J=j+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[J>>2]|0)>0){i=f[j+40>>2]|0;e=0;do{f[i+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[J>>2]|0))}J=f[j+44>>2]|0;if((J|0)!=(j+48|0))ZF(J);u=g;return}function gP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=u;u=u+656|0;g=e+256|0;h=e+32|0;i=e+592|0;j=e+536|0;k=e+480|0;l=e;if(!($h[f[(f[a>>2]|0)+8>>2]&255](a,b)|0)){f[g>>2]=1124007936;a=g+4|0;m=g+8|0;n=g+40|0;o=a;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=m;m=g+48|0;r=g+44|0;f[r>>2]=m;f[m>>2]=0;f[g+52>>2]=0;s=f[b>>2]|0;Ah[f[(f[s>>2]|0)+12>>2]&255](s,b,g,-1);HR(i,g,c);f[j>>2]=1124007936;s=j+4|0;t=j+8|0;v=j+40|0;o=s;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[v>>2]=t;t=j+48|0;w=j+44|0;f[w>>2]=t;f[t>>2]=0;f[j+52>>2]=0;f[k>>2]=1124007936;x=k+4|0;y=k+8|0;z=k+40|0;o=x;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[z>>2]=y;y=k+48|0;A=k+44|0;f[A>>2]=y;f[y>>2]=0;f[k+52>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;DP(h,40116,0,i,j,k,1.0,1.0,l);EP(d,h)|0;fj(h);l=k+36|0;B=f[l>>2]|0;if(B|0?(C=B+12|0,B=f[C>>2]|0,f[C>>2]=B+-1,(B|0)==1):0)CR(k);f[l>>2]=0;l=k+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[x>>2]|0)>0){l=f[z>>2]|0;z=0;do{f[l+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[x>>2]|0))}x=f[A>>2]|0;if((x|0)!=(y|0))ZF(x);x=j+36|0;y=f[x>>2]|0;if(y|0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0)CR(j);f[x>>2]=0;x=j+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[s>>2]|0)>0){x=f[v>>2]|0;v=0;do{f[x+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[s>>2]|0))}s=f[w>>2]|0;if((s|0)!=(t|0))ZF(s);s=i+36|0;t=f[s>>2]|0;if(t|0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0)CR(i);f[s>>2]=0;s=i+16|0;t=i+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[t>>2]|0)>0){s=f[i+40>>2]|0;w=0;do{f[s+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[t>>2]|0))}t=f[i+44>>2]|0;if((t|0)!=(i+48|0))ZF(t);t=g+36|0;w=f[t>>2]|0;if(w|0?(s=w+12|0,w=f[s>>2]|0,f[s>>2]=w+-1,(w|0)==1):0)CR(g);f[t>>2]=0;t=g+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[a>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[a>>2]|0))}a=f[r>>2]|0;if((a|0)!=(m|0))ZF(a);u=e;return}a=f[b>>2]|0;m=f[b+4>>2]|0;f[h>>2]=1124007936;r=h+4|0;n=h+8|0;t=h+40|0;o=r;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[t>>2]=n;n=h+48|0;w=h+44|0;f[w>>2]=n;f[n>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;s=i+4|0;v=i+8|0;x=i+40|0;o=s;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[x>>2]=v;v=i+48|0;y=i+44|0;f[y>>2]=v;f[v>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;A=j+4|0;z=j+8|0;l=j+40|0;o=A;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[l>>2]=z;z=j+48|0;o=j+44|0;f[o>>2]=z;f[z>>2]=0;f[j+52>>2]=0;DP(g,a,m,h,i,j,+p[b+176>>3],+p[b+184>>3],b+192|0);EP(d,g)|0;fj(g);m=j+36|0;a=f[m>>2]|0;if(a|0?(q=a+12|0,a=f[q>>2]|0,f[q>>2]=a+-1,(a|0)==1):0)CR(j);f[m>>2]=0;m=j+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[A>>2]|0)>0){m=f[l>>2]|0;l=0;do{f[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[A>>2]|0))}A=f[o>>2]|0;if((A|0)!=(z|0))ZF(A);A=i+36|0;z=f[A>>2]|0;if(z|0?(o=z+12|0,z=f[o>>2]|0,f[o>>2]=z+-1,(z|0)==1):0)CR(i);f[A>>2]=0;A=i+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[s>>2]|0)>0){A=f[x>>2]|0;x=0;do{f[A+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[s>>2]|0))}s=f[y>>2]|0;if((s|0)!=(v|0))ZF(s);s=h+36|0;v=f[s>>2]|0;if(v|0?(y=v+12|0,v=f[y>>2]|0,f[y>>2]=v+-1,(v|0)==1):0)CR(h);f[s>>2]=0;s=h+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[r>>2]|0)>0){s=f[t>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[w>>2]|0;if((r|0)!=(n|0))ZF(r);if(f[b+24>>2]|0){HR(g,b+8|0,c);r=d+8|0;n=g+36|0;w=f[n>>2]|0;if((r|0)==(g|0))D=w;else{if(w|0){t=w+12|0;f[t>>2]=(f[t>>2]|0)+1}t=d+44|0;w=f[t>>2]|0;if(w|0?(s=w+12|0,w=f[s>>2]|0,f[s>>2]=w+-1,(w|0)==1):0)CR(r);f[t>>2]=0;w=d+24|0;s=d+12|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[s>>2]|0)>0){h=f[d+48>>2]|0;v=0;do{f[h+(v<<2)>>2]=0;v=v+1|0;E=f[s>>2]|0}while((v|0)<(E|0));f[r>>2]=f[g>>2];if((E|0)<3)F=38;else F=40}else{f[r>>2]=f[g>>2];F=38}if((F|0)==38){E=f[g+4>>2]|0;if((E|0)<3){f[s>>2]=E;f[d+16>>2]=f[g+8>>2];f[d+20>>2]=f[g+12>>2];E=f[g+44>>2]|0;s=f[d+52>>2]|0;f[s>>2]=f[E>>2];f[s+4>>2]=f[E+4>>2]}else F=40}if((F|0)==40)BR(r,g);f[w>>2]=f[g+16>>2];f[d+28>>2]=f[g+20>>2];f[d+32>>2]=f[g+24>>2];f[d+36>>2]=f[g+28>>2];f[d+40>>2]=f[g+32>>2];w=f[n>>2]|0;f[t>>2]=w;D=w}if(D|0?(w=D+12|0,D=f[w>>2]|0,f[w>>2]=D+-1,(D|0)==1):0)CR(g);f[n>>2]=0;n=g+16|0;D=g+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[D>>2]|0)>0){n=f[g+40>>2]|0;w=0;do{f[n+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[D>>2]|0))}D=f[g+44>>2]|0;if((D|0)!=(g+48|0))ZF(D)}if(f[b+80>>2]|0){HR(g,b+64|0,c);D=d+64|0;w=g+36|0;n=f[w>>2]|0;if((D|0)==(g|0))G=n;else{if(n|0){t=n+12|0;f[t>>2]=(f[t>>2]|0)+1}t=d+100|0;n=f[t>>2]|0;if(n|0?(r=n+12|0,n=f[r>>2]|0,f[r>>2]=n+-1,(n|0)==1):0)CR(D);f[t>>2]=0;n=d+80|0;r=d+68|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[r>>2]|0)>0){E=f[d+104>>2]|0;s=0;do{f[E+(s<<2)>>2]=0;s=s+1|0;H=f[r>>2]|0}while((s|0)<(H|0));f[D>>2]=f[g>>2];if((H|0)<3)F=63;else F=65}else{f[D>>2]=f[g>>2];F=63}if((F|0)==63){H=f[g+4>>2]|0;if((H|0)<3){f[r>>2]=H;f[d+72>>2]=f[g+8>>2];f[d+76>>2]=f[g+12>>2];H=f[g+44>>2]|0;r=f[d+108>>2]|0;f[r>>2]=f[H>>2];f[r+4>>2]=f[H+4>>2]}else F=65}if((F|0)==65)BR(D,g);f[n>>2]=f[g+16>>2];f[d+84>>2]=f[g+20>>2];f[d+88>>2]=f[g+24>>2];f[d+92>>2]=f[g+28>>2];f[d+96>>2]=f[g+32>>2];n=f[w>>2]|0;f[t>>2]=n;G=n}if(G|0?(n=G+12|0,G=f[n>>2]|0,f[n>>2]=G+-1,(G|0)==1):0)CR(g);f[w>>2]=0;w=g+16|0;G=g+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[G>>2]|0)>0){w=f[g+40>>2]|0;n=0;do{f[w+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[G>>2]|0))}G=f[g+44>>2]|0;if((G|0)!=(g+48|0))ZF(G)}if(!(f[b+136>>2]|0)){u=e;return}HR(g,b+120|0,c);c=d+120|0;b=g+36|0;G=f[b>>2]|0;if((c|0)==(g|0))I=G;else{if(G|0){n=G+12|0;f[n>>2]=(f[n>>2]|0)+1}n=d+156|0;G=f[n>>2]|0;if(G|0?(w=G+12|0,G=f[w>>2]|0,f[w>>2]=G+-1,(G|0)==1):0)CR(c);f[n>>2]=0;G=d+136|0;w=d+124|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[w>>2]|0)>0){t=f[d+160>>2]|0;D=0;do{f[t+(D<<2)>>2]=0;D=D+1|0;J=f[w>>2]|0}while((D|0)<(J|0));f[c>>2]=f[g>>2];if((J|0)<3)F=88;else F=90}else{f[c>>2]=f[g>>2];F=88}if((F|0)==88){J=f[g+4>>2]|0;if((J|0)<3){f[w>>2]=J;f[d+128>>2]=f[g+8>>2];f[d+132>>2]=f[g+12>>2];J=f[g+44>>2]|0;w=f[d+164>>2]|0;f[w>>2]=f[J>>2];f[w+4>>2]=f[J+4>>2]}else F=90}if((F|0)==90)BR(c,g);f[G>>2]=f[g+16>>2];f[d+140>>2]=f[g+20>>2];f[d+144>>2]=f[g+24>>2];f[d+148>>2]=f[g+28>>2];f[d+152>>2]=f[g+32>>2];d=f[b>>2]|0;f[n>>2]=d;I=d}if(I|0?(d=I+12|0,I=f[d>>2]|0,f[d>>2]=I+-1,(I|0)==1):0)CR(g);f[b>>2]=0;b=g+16|0;I=g+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[I>>2]|0)>0){b=f[g+40>>2]|0;d=0;do{f[b+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[I>>2]|0))}I=f[g+44>>2]|0;if((I|0)!=(g+48|0))ZF(I);u=e;return}function hP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;Ah[f[(f[m>>2]|0)+12>>2]&255](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;TG(d,e,g,fT()|0,-1);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)CR(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}ZF(i);u=a;return}function iP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;Ah[f[(f[m>>2]|0)+12>>2]&255](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;hH(d,e,g,fT()|0,-1);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)CR(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}ZF(i);u=a;return}function jP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=u;u=u+176|0;d=a+160|0;e=a+144|0;g=a+128|0;h=a+72|0;i=a+56|0;j=a;f[j>>2]=1124007936;k=j+4|0;l=j+8|0;m=j+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=j+48|0;p=j+44|0;f[p>>2]=l;f[l>>2]=0;f[j+52>>2]=0;q=f[b>>2]|0;Ah[f[(f[q>>2]|0)+12>>2]&255](q,b,j,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=j;f[h>>2]=1124007936;b=h+4|0;q=h+8|0;r=h+40|0;n=b;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[r>>2]=q;q=h+48|0;n=h+44|0;f[n>>2]=q;f[q>>2]=0;f[h+52>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=h;o=i+8|0;f[o>>2]=0;f[o+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;jO(d,e,1.0,g,0.0,i,0);i=h+36|0;g=f[i>>2]|0;if(g|0?(e=g+12|0,g=f[e>>2]|0,f[e>>2]=g+-1,(g|0)==1):0)CR(h);f[i>>2]=0;i=h+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[b>>2]|0)>0){i=f[r>>2]|0;r=0;do{f[i+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[b>>2]|0))}b=f[n>>2]|0;if((b|0)!=(q|0))ZF(b);b=j+36|0;q=f[b>>2]|0;if(q|0?(n=q+12|0,q=f[n>>2]|0,f[n>>2]=q+-1,(q|0)==1):0)CR(j);f[b>>2]=0;b=j+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[k>>2]|0)>0){b=f[m>>2]|0;m=0;do{f[b+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[p>>2]|0;if((k|0)==(l|0)){u=a;return}ZF(k);u=a;return}function kP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;Ah[f[(f[m>>2]|0)+12>>2]&255](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;TH(d,e,g,1.0,-1);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)CR(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}ZF(i);u=a;return}function lP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;Ah[f[(f[m>>2]|0)+12>>2]&255](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;bG(d,e,g,fT()|0);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)CR(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}ZF(i);u=a;return}function mP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;Ah[f[(f[m>>2]|0)+12>>2]&255](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;fG(d,e,g,fT()|0);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)CR(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}ZF(i);u=a;return}function nP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;Ah[f[(f[m>>2]|0)+12>>2]&255](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;iG(d,e,g,fT()|0);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)CR(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}ZF(i);u=a;return}function oP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0.0;e=u;u=u+160|0;g=e+144|0;h=e;i=e+88|0;j=e+32|0;_$(g,41296);k=f[c>>2]|0;if((k|0)==(a|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[i>>2]=1124007936;a=i+4|0;l=i+8|0;m=i+40|0;n=a;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;q=i+48|0;r=i+44|0;f[r>>2]=q;f[q>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;s=j+4|0;t=j+8|0;v=j+40|0;n=s;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[v>>2]=t;n=j+48|0;o=j+44|0;f[o>>2]=n;f[n>>2]=0;f[j+52>>2]=0;w=f[b>>2]|0;do if((w|0)==40360){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){x=21;break}y=b+8|0;if((i|0)!=(y|0)){z=b+44|0;A=f[z>>2]|0;if(A){B=A+12|0;f[B>>2]=(f[B>>2]|0)+1;B=i+36|0;A=f[B>>2]|0;if((A|0)!=0?(C=A+12|0,A=f[C>>2]|0,f[C>>2]=A+-1,(A|0)==1):0){CR(i);D=B}else D=B}else D=i+36|0;f[D>>2]=0;B=i+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[a>>2]|0)>0){A=f[m>>2]|0;C=0;do{f[A+(C<<2)>>2]=0;C=C+1|0;E=f[a>>2]|0}while((C|0)<(E|0));f[i>>2]=f[y>>2];if((E|0)<3)x=16;else x=18}else{f[i>>2]=f[y>>2];x=16}if((x|0)==16){C=f[b+12>>2]|0;if((C|0)<3){f[a>>2]=C;f[l>>2]=f[b+16>>2];f[i+12>>2]=f[b+20>>2];C=f[b+52>>2]|0;A=f[r>>2]|0;f[A>>2]=f[C>>2];f[A+4>>2]=f[C+4>>2]}else x=18}if((x|0)==18)BR(i,y);f[B>>2]=f[b+24>>2];f[i+20>>2]=f[b+28>>2];f[i+24>>2]=f[b+32>>2];f[i+28>>2]=f[b+36>>2];f[i+32>>2]=f[b+40>>2];f[D>>2]=f[z>>2]}F=+p[b+176>>3];C=b+192|0;f[h>>2]=f[C>>2];f[h+4>>2]=f[C+4>>2];f[h+8>>2]=f[C+8>>2];f[h+12>>2]=f[C+12>>2];f[h+16>>2]=f[C+16>>2];f[h+20>>2]=f[C+20>>2];f[h+24>>2]=f[C+24>>2];f[h+28>>2]=f[C+28>>2];G=F}else x=21;while(0);if((x|0)==21){Ah[f[(f[w>>2]|0)+12>>2]&255](w,b,i,-1);G=1.0}w=f[c>>2]|0;do if((w|0)==40360){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){x=41;break}D=c+8|0;if((j|0)!=(D|0)){l=c+44|0;E=f[l>>2]|0;if(E|0){C=E+12|0;f[C>>2]=(f[C>>2]|0)+1}C=j+36|0;E=f[C>>2]|0;if(E|0?(A=E+12|0,E=f[A>>2]|0,f[A>>2]=E+-1,(E|0)==1):0)CR(j);f[C>>2]=0;E=j+16|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[s>>2]|0)>0){A=f[v>>2]|0;H=0;do{f[A+(H<<2)>>2]=0;H=H+1|0;I=f[s>>2]|0}while((H|0)<(I|0));f[j>>2]=f[D>>2];if((I|0)<3)x=36;else x=38}else{f[j>>2]=f[D>>2];x=36}if((x|0)==36){H=f[c+12>>2]|0;if((H|0)<3){f[s>>2]=H;f[t>>2]=f[c+16>>2];f[j+12>>2]=f[c+20>>2];H=f[c+52>>2]|0;A=f[o>>2]|0;f[A>>2]=f[H>>2];f[A+4>>2]=f[H+4>>2]}else x=38}if((x|0)==38)BR(j,D);f[E>>2]=f[c+24>>2];f[j+20>>2]=f[c+28>>2];f[j+24>>2]=f[c+32>>2];f[j+28>>2]=f[c+36>>2];f[j+32>>2]=f[c+40>>2];f[C>>2]=f[l>>2]}F=+p[c+176>>3];p[h>>3]=+p[c+192>>3]+ +p[h>>3];H=h+8|0;p[H>>3]=+p[c+200>>3]+ +p[H>>3];H=h+16|0;p[H>>3]=+p[c+208>>3]+ +p[H>>3];H=h+24|0;p[H>>3]=+p[c+216>>3]+ +p[H>>3];J=F}else x=41;while(0);if((x|0)==41){Ah[f[(f[w>>2]|0)+12>>2]&255](w,c,j,-1);J=1.0}mQ(d,i,j,G,J,h);h=j+36|0;w=f[h>>2]|0;if(w|0?(x=w+12|0,w=f[x>>2]|0,f[x>>2]=w+-1,(w|0)==1):0)CR(j);f[h>>2]=0;h=j+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[s>>2]|0)>0){h=f[v>>2]|0;v=0;do{f[h+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[s>>2]|0))}s=f[o>>2]|0;if((s|0)!=(n|0))ZF(s);s=i+36|0;n=f[s>>2]|0;if(n|0?(o=n+12|0,n=f[o>>2]|0,f[o>>2]=n+-1,(n|0)==1):0)CR(i);f[s>>2]=0;s=i+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[a>>2]|0)>0){s=f[m>>2]|0;m=0;do{f[s+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[a>>2]|0))}a=f[r>>2]|0;if((a|0)!=(q|0))ZF(a)}else Ah[f[(f[k>>2]|0)+52>>2]&255](k,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function pP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+128|0;e=a+112|0;g=a+56|0;h=a;_$(e,41276);f[g>>2]=1124007936;i=g+4|0;j=g+8|0;k=g+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=g+48|0;n=g+44|0;f[n>>2]=j;f[j>>2]=0;f[g+52>>2]=0;o=f[b>>2]|0;Ah[f[(f[o>>2]|0)+12>>2]&255](o,b,g,-1);f[h>>2]=1124007936;b=h+4|0;o=h+8|0;p=h+40|0;l=b;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[p>>2]=o;o=h+48|0;l=h+44|0;f[l>>2]=o;f[o>>2]=0;f[h+52>>2]=0;mQ(d,g,h,1.0,0.0,c);c=h+36|0;d=f[c>>2]|0;if(d|0?(m=d+12|0,d=f[m>>2]|0,f[m>>2]=d+-1,(d|0)==1):0)CR(h);f[c>>2]=0;c=h+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[p>>2]|0;p=0;do{f[c+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[b>>2]|0))}b=f[l>>2]|0;if((b|0)!=(o|0))ZF(b);b=g+36|0;o=f[b>>2]|0;if(o|0?(l=o+12|0,o=f[l>>2]|0,f[l>>2]=o+-1,(o|0)==1):0)CR(g);f[b>>2]=0;b=g+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[i>>2]|0)>0){b=f[k>>2]|0;k=0;do{f[b+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[n>>2]|0;if((i|0)!=(j|0))ZF(i);if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function qP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0.0;e=u;u=u+160|0;g=e+144|0;h=e;i=e+88|0;j=e+32|0;_$(g,41256);k=f[c>>2]|0;if((k|0)==(a|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[i>>2]=1124007936;a=i+4|0;l=i+8|0;m=i+40|0;n=a;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;q=i+48|0;r=i+44|0;f[r>>2]=q;f[q>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;s=j+4|0;t=j+8|0;v=j+40|0;n=s;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[v>>2]=t;n=j+48|0;o=j+44|0;f[o>>2]=n;f[n>>2]=0;f[j+52>>2]=0;w=f[b>>2]|0;do if((w|0)==40360){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){x=21;break}y=b+8|0;if((i|0)!=(y|0)){z=b+44|0;A=f[z>>2]|0;if(A){B=A+12|0;f[B>>2]=(f[B>>2]|0)+1;B=i+36|0;A=f[B>>2]|0;if((A|0)!=0?(C=A+12|0,A=f[C>>2]|0,f[C>>2]=A+-1,(A|0)==1):0){CR(i);D=B}else D=B}else D=i+36|0;f[D>>2]=0;B=i+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[a>>2]|0)>0){A=f[m>>2]|0;C=0;do{f[A+(C<<2)>>2]=0;C=C+1|0;E=f[a>>2]|0}while((C|0)<(E|0));f[i>>2]=f[y>>2];if((E|0)<3)x=16;else x=18}else{f[i>>2]=f[y>>2];x=16}if((x|0)==16){C=f[b+12>>2]|0;if((C|0)<3){f[a>>2]=C;f[l>>2]=f[b+16>>2];f[i+12>>2]=f[b+20>>2];C=f[b+52>>2]|0;A=f[r>>2]|0;f[A>>2]=f[C>>2];f[A+4>>2]=f[C+4>>2]}else x=18}if((x|0)==18)BR(i,y);f[B>>2]=f[b+24>>2];f[i+20>>2]=f[b+28>>2];f[i+24>>2]=f[b+32>>2];f[i+28>>2]=f[b+36>>2];f[i+32>>2]=f[b+40>>2];f[D>>2]=f[z>>2]}F=+p[b+176>>3];C=b+192|0;f[h>>2]=f[C>>2];f[h+4>>2]=f[C+4>>2];f[h+8>>2]=f[C+8>>2];f[h+12>>2]=f[C+12>>2];f[h+16>>2]=f[C+16>>2];f[h+20>>2]=f[C+20>>2];f[h+24>>2]=f[C+24>>2];f[h+28>>2]=f[C+28>>2];G=F}else x=21;while(0);if((x|0)==21){Ah[f[(f[w>>2]|0)+12>>2]&255](w,b,i,-1);G=1.0}w=f[c>>2]|0;do if((w|0)==40360){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){x=41;break}D=c+8|0;if((j|0)!=(D|0)){l=c+44|0;E=f[l>>2]|0;if(E|0){C=E+12|0;f[C>>2]=(f[C>>2]|0)+1}C=j+36|0;E=f[C>>2]|0;if(E|0?(A=E+12|0,E=f[A>>2]|0,f[A>>2]=E+-1,(E|0)==1):0)CR(j);f[C>>2]=0;E=j+16|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[s>>2]|0)>0){A=f[v>>2]|0;H=0;do{f[A+(H<<2)>>2]=0;H=H+1|0;I=f[s>>2]|0}while((H|0)<(I|0));f[j>>2]=f[D>>2];if((I|0)<3)x=36;else x=38}else{f[j>>2]=f[D>>2];x=36}if((x|0)==36){H=f[c+12>>2]|0;if((H|0)<3){f[s>>2]=H;f[t>>2]=f[c+16>>2];f[j+12>>2]=f[c+20>>2];H=f[c+52>>2]|0;A=f[o>>2]|0;f[A>>2]=f[H>>2];f[A+4>>2]=f[H+4>>2]}else x=38}if((x|0)==38)BR(j,D);f[E>>2]=f[c+24>>2];f[j+20>>2]=f[c+28>>2];f[j+24>>2]=f[c+32>>2];f[j+28>>2]=f[c+36>>2];f[j+32>>2]=f[c+40>>2];f[C>>2]=f[l>>2]}F=-+p[c+176>>3];p[h>>3]=+p[h>>3]-+p[c+192>>3];H=h+8|0;p[H>>3]=+p[H>>3]-+p[c+200>>3];H=h+16|0;p[H>>3]=+p[H>>3]-+p[c+208>>3];H=h+24|0;p[H>>3]=+p[H>>3]-+p[c+216>>3];J=F}else x=41;while(0);if((x|0)==41){Ah[f[(f[w>>2]|0)+12>>2]&255](w,c,j,-1);J=-1.0}mQ(d,i,j,G,J,h);h=j+36|0;w=f[h>>2]|0;if(w|0?(x=w+12|0,w=f[x>>2]|0,f[x>>2]=w+-1,(w|0)==1):0)CR(j);f[h>>2]=0;h=j+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[s>>2]|0)>0){h=f[v>>2]|0;v=0;do{f[h+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[s>>2]|0))}s=f[o>>2]|0;if((s|0)!=(n|0))ZF(s);s=i+36|0;n=f[s>>2]|0;if(n|0?(o=n+12|0,n=f[o>>2]|0,f[o>>2]=n+-1,(n|0)==1):0)CR(i);f[s>>2]=0;s=i+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[a>>2]|0)>0){s=f[m>>2]|0;m=0;do{f[s+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[a>>2]|0))}a=f[r>>2]|0;if((a|0)!=(q|0))ZF(a)}else Ah[f[(f[k>>2]|0)+60>>2]&255](k,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function rP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+128|0;e=a+112|0;g=a+56|0;h=a;_$(e,41236);f[g>>2]=1124007936;i=g+4|0;j=g+8|0;k=g+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=g+48|0;n=g+44|0;f[n>>2]=j;f[j>>2]=0;f[g+52>>2]=0;o=f[c>>2]|0;Ah[f[(f[o>>2]|0)+12>>2]&255](o,c,g,-1);f[h>>2]=1124007936;c=h+4|0;o=h+8|0;p=h+40|0;l=c;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[p>>2]=o;o=h+48|0;l=h+44|0;f[l>>2]=o;f[o>>2]=0;f[h+52>>2]=0;mQ(d,g,h,-1.0,0.0,b);b=h+36|0;d=f[b>>2]|0;if(d|0?(m=d+12|0,d=f[m>>2]|0,f[m>>2]=d+-1,(d|0)==1):0)CR(h);f[b>>2]=0;b=h+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[c>>2]|0)>0){b=f[p>>2]|0;p=0;do{f[b+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[c>>2]|0))}c=f[l>>2]|0;if((c|0)!=(o|0))ZF(c);c=g+36|0;o=f[c>>2]|0;if(o|0?(l=o+12|0,o=f[l>>2]|0,f[l>>2]=o+-1,(o|0)==1):0)CR(g);f[c>>2]=0;c=g+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[i>>2]|0)>0){c=f[k>>2]|0;k=0;do{f[c+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[n>>2]|0;if((i|0)!=(j|0))ZF(i);if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function sP(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0;g=u;u=u+128|0;h=g+112|0;i=g+56|0;j=g;_$(h,41216);k=f[c>>2]|0;if((k|0)==(a|0)){f[i>>2]=1124007936;l=i+4|0;m=i+8|0;n=i+40|0;o=l;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=m;r=i+48|0;s=i+44|0;f[s>>2]=r;f[r>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;t=j+4|0;v=j+8|0;w=j+40|0;o=t;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[w>>2]=v;o=j+48|0;q=j+44|0;f[q>>2]=o;f[o>>2]=0;f[j+52>>2]=0;x=f[b>>2]|0;do if(!((x|0)==40720?(f[b+4>>2]|0)==47:0))if((x|0)==40360){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){y=52;break}if(((+p[b+192>>3]==0.0?+p[b+200>>3]==0.0:0)?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){z=b+8|0;if((i|0)!=(z|0)){A=b+44|0;B=f[A>>2]|0;if(B){C=B+12|0;f[C>>2]=(f[C>>2]|0)+1;C=i+36|0;B=f[C>>2]|0;if((B|0)!=0?(D=B+12|0,B=f[D>>2]|0,f[D>>2]=B+-1,(B|0)==1):0){CR(i);E=C}else E=C}else E=i+36|0;f[E>>2]=0;C=i+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[l>>2]|0)>0){B=f[n>>2]|0;D=0;do{f[B+(D<<2)>>2]=0;D=D+1|0;F=f[l>>2]|0}while((D|0)<(F|0));f[i>>2]=f[z>>2];if((F|0)<3)y=47;else y=49}else{f[i>>2]=f[z>>2];y=47}if((y|0)==47){D=f[b+12>>2]|0;if((D|0)<3){f[l>>2]=D;f[m>>2]=f[b+16>>2];f[i+12>>2]=f[b+20>>2];D=f[b+52>>2]|0;B=f[s>>2]|0;f[B>>2]=f[D>>2];f[B+4>>2]=f[D+4>>2]}else y=49}if((y|0)==49)BR(i,z);f[C>>2]=f[b+24>>2];f[i+20>>2]=f[b+28>>2];f[i+24>>2]=f[b+32>>2];f[i+28>>2]=f[b+36>>2];f[i+32>>2]=f[b+40>>2];f[E>>2]=f[A>>2]}G=+p[b+176>>3]*e;y=53}else y=52}else y=52;else{if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){y=52;break}do if((a|0)==40360){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){y=27;break}if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){H=+p[c+176>>3]*e;D=c+8|0;if((j|0)==(D|0))I=H;else{B=c+44|0;J=f[B>>2]|0;if(J){K=J+12|0;f[K>>2]=(f[K>>2]|0)+1;K=j+36|0;J=f[K>>2]|0;if((J|0)!=0?(L=J+12|0,J=f[L>>2]|0,f[L>>2]=J+-1,(J|0)==1):0){CR(j);M=K}else M=K}else M=j+36|0;f[M>>2]=0;K=j+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[t>>2]|0)>0){J=f[w>>2]|0;L=0;do{f[J+(L<<2)>>2]=0;L=L+1|0;N=f[t>>2]|0}while((L|0)<(N|0));f[j>>2]=f[D>>2];if((N|0)<3)y=23;else y=25}else{f[j>>2]=f[D>>2];y=23}if((y|0)==23){L=f[c+12>>2]|0;if((L|0)<3){f[t>>2]=L;f[v>>2]=f[c+16>>2];f[j+12>>2]=f[c+20>>2];L=f[c+52>>2]|0;J=f[q>>2]|0;f[J>>2]=f[L>>2];f[J+4>>2]=f[L+4>>2]}else y=25}if((y|0)==25)BR(j,D);f[K>>2]=f[c+24>>2];f[j+20>>2]=f[c+28>>2];f[j+24>>2]=f[c+32>>2];f[j+28>>2]=f[c+36>>2];f[j+32>>2]=f[c+40>>2];f[M>>2]=f[B>>2];I=H}}else y=27}else y=27;while(0);if((y|0)==27){Ah[f[(f[a>>2]|0)+12>>2]&255](a,c,j,-1);I=e}gQ(d,47,j,b+8|0,I/+p[b+176>>3])}while(0);if((y|0)==52){Ah[f[(f[x>>2]|0)+12>>2]&255](x,b,i,-1);G=e;y=53}if((y|0)==53){x=f[c>>2]|0;do if((x|0)==40360){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){y=95;break}if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){a=c+8|0;if((j|0)!=(a|0)){M=c+44|0;N=f[M>>2]|0;if(N|0){E=N+12|0;f[E>>2]=(f[E>>2]|0)+1}E=j+36|0;N=f[E>>2]|0;if(N|0?(m=N+12|0,N=f[m>>2]|0,f[m>>2]=N+-1,(N|0)==1):0)CR(j);f[E>>2]=0;N=j+16|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[t>>2]|0)>0){m=f[w>>2]|0;F=0;do{f[m+(F<<2)>>2]=0;F=F+1|0;O=f[t>>2]|0}while((F|0)<(O|0));f[j>>2]=f[a>>2];if((O|0)<3)y=71;else y=73}else{f[j>>2]=f[a>>2];y=71}if((y|0)==71){F=f[c+12>>2]|0;if((F|0)<3){f[t>>2]=F;f[v>>2]=f[c+16>>2];f[j+12>>2]=f[c+20>>2];F=f[c+52>>2]|0;m=f[q>>2]|0;f[m>>2]=f[F>>2];f[m+4>>2]=f[F+4>>2]}else y=73}if((y|0)==73)BR(j,a);f[N>>2]=f[c+24>>2];f[j+20>>2]=f[c+28>>2];f[j+24>>2]=f[c+32>>2];f[j+28>>2]=f[c+36>>2];f[j+32>>2]=f[c+40>>2];f[E>>2]=f[M>>2]}P=42;Q=G*+p[c+176>>3]}else y=95}else if((x|0)==40720?(f[c+4>>2]|0)==47:0){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){y=95;break}F=c+8|0;if((j|0)!=(F|0)){m=c+44|0;A=f[m>>2]|0;if(A|0){C=A+12|0;f[C>>2]=(f[C>>2]|0)+1}C=j+36|0;A=f[C>>2]|0;if(A|0?(z=A+12|0,A=f[z>>2]|0,f[z>>2]=A+-1,(A|0)==1):0)CR(j);f[C>>2]=0;A=j+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[t>>2]|0)>0){z=f[w>>2]|0;L=0;do{f[z+(L<<2)>>2]=0;L=L+1|0;R=f[t>>2]|0}while((L|0)<(R|0));f[j>>2]=f[F>>2];if((R|0)<3)y=90;else y=92}else{f[j>>2]=f[F>>2];y=90}if((y|0)==90){L=f[c+12>>2]|0;if((L|0)<3){f[t>>2]=L;f[v>>2]=f[c+16>>2];f[j+12>>2]=f[c+20>>2];L=f[c+52>>2]|0;z=f[q>>2]|0;f[z>>2]=f[L>>2];f[z+4>>2]=f[L+4>>2]}else y=92}if((y|0)==92)BR(j,F);f[A>>2]=f[c+24>>2];f[j+20>>2]=f[c+28>>2];f[j+24>>2]=f[c+32>>2];f[j+28>>2]=f[c+36>>2];f[j+32>>2]=f[c+40>>2];f[C>>2]=f[m>>2]}P=47;Q=G/+p[c+176>>3]}else y=95;while(0);if((y|0)==95){Ah[f[(f[x>>2]|0)+12>>2]&255](x,c,j,-1);P=42;Q=G}gQ(d,P,i,j,Q)}P=j+36|0;x=f[P>>2]|0;if(x|0?(y=x+12|0,x=f[y>>2]|0,f[y>>2]=x+-1,(x|0)==1):0)CR(j);f[P>>2]=0;P=j+16|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[t>>2]|0)>0){P=f[w>>2]|0;w=0;do{f[P+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[t>>2]|0))}t=f[q>>2]|0;if((t|0)!=(o|0))ZF(t);t=i+36|0;o=f[t>>2]|0;if(o|0?(q=o+12|0,o=f[q>>2]|0,f[q>>2]=o+-1,(o|0)==1):0)CR(i);f[t>>2]=0;t=i+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[l>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[l>>2]|0))}l=f[s>>2]|0;if((l|0)!=(r|0))ZF(l)}else Hh[f[(f[k>>2]|0)+68>>2]&15](k,b,c,d,e);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function tP(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=u;u=u+160|0;e=a+144|0;g=a+88|0;h=a+32|0;i=a;_$(e,41196);f[g>>2]=1124007936;j=g+4|0;k=g+8|0;l=g+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=g+48|0;o=g+44|0;f[o>>2]=k;f[k>>2]=0;f[g+52>>2]=0;p=f[b>>2]|0;Ah[f[(f[p>>2]|0)+12>>2]&255](p,b,g,-1);f[h>>2]=1124007936;b=h+4|0;p=h+8|0;q=h+40|0;m=b;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[q>>2]=p;p=h+48|0;m=h+44|0;f[m>>2]=p;f[p>>2]=0;f[h+52>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;mQ(d,g,h,c,0.0,i);i=h+36|0;d=f[i>>2]|0;if(d|0?(n=d+12|0,d=f[n>>2]|0,f[n>>2]=d+-1,(d|0)==1):0)CR(h);f[i>>2]=0;i=h+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[b>>2]|0)>0){i=f[q>>2]|0;q=0;do{f[i+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[b>>2]|0))}b=f[m>>2]|0;if((b|0)!=(p|0))ZF(b);b=g+36|0;p=f[b>>2]|0;if(p|0?(m=p+12|0,p=f[m>>2]|0,f[m>>2]=p+-1,(p|0)==1):0)CR(g);f[b>>2]=0;b=g+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[j>>2]|0)>0){b=f[l>>2]|0;l=0;do{f[b+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[o>>2]|0;if((j|0)!=(k|0))ZF(j);if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function uP(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0,P=0;g=u;u=u+128|0;h=g+112|0;i=g+56|0;j=g;_$(h,41176);k=f[c>>2]|0;a:do if((k|0)==(a|0)){l=f[b>>2]|0;do if((l|0)==40720?(f[b+4>>2]|0)==47:0){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0)break;if((a|0)==40720?(f[c+4>>2]|0)==47:0){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0)break;gQ(d,47,c+8|0,b+8|0,+p[b+176>>3]/+p[c+176>>3]);break a}}while(0);f[i>>2]=1124007936;m=i+4|0;n=i+8|0;o=i+40|0;q=m;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[o>>2]=n;s=i+48|0;t=i+44|0;f[t>>2]=s;f[s>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;v=j+4|0;w=j+8|0;x=j+40|0;q=v;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[x>>2]=w;q=j+48|0;r=j+44|0;f[r>>2]=q;f[q>>2]=0;f[j+52>>2]=0;do if((l|0)==40360){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){y=32;break}if(((+p[b+192>>3]==0.0?+p[b+200>>3]==0.0:0)?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){z=b+8|0;if((i|0)!=(z|0)){A=b+44|0;B=f[A>>2]|0;if(B){C=B+12|0;f[C>>2]=(f[C>>2]|0)+1;C=i+36|0;B=f[C>>2]|0;if((B|0)!=0?(D=B+12|0,B=f[D>>2]|0,f[D>>2]=B+-1,(B|0)==1):0){CR(i);E=C}else E=C}else E=i+36|0;f[E>>2]=0;C=i+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[m>>2]|0)>0){B=f[o>>2]|0;D=0;do{f[B+(D<<2)>>2]=0;D=D+1|0;F=f[m>>2]|0}while((D|0)<(F|0));f[i>>2]=f[z>>2];if((F|0)<3)y=27;else y=29}else{f[i>>2]=f[z>>2];y=27}if((y|0)==27){D=f[b+12>>2]|0;if((D|0)<3){f[m>>2]=D;f[n>>2]=f[b+16>>2];f[i+12>>2]=f[b+20>>2];D=f[b+52>>2]|0;B=f[t>>2]|0;f[B>>2]=f[D>>2];f[B+4>>2]=f[D+4>>2]}else y=29}if((y|0)==29)BR(i,z);f[C>>2]=f[b+24>>2];f[i+20>>2]=f[b+28>>2];f[i+24>>2]=f[b+32>>2];f[i+28>>2]=f[b+36>>2];f[i+32>>2]=f[b+40>>2];f[E>>2]=f[A>>2]}G=+p[b+176>>3]*e}else y=32}else y=32;while(0);if((y|0)==32){Ah[f[(f[l>>2]|0)+12>>2]&255](l,b,i,-1);G=e}n=f[c>>2]|0;do if((n|0)==40360){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){y=75;break}if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){D=c+8|0;if((j|0)!=(D|0)){B=c+44|0;H=f[B>>2]|0;if(H|0){I=H+12|0;f[I>>2]=(f[I>>2]|0)+1}I=j+36|0;H=f[I>>2]|0;if(H|0?(J=H+12|0,H=f[J>>2]|0,f[J>>2]=H+-1,(H|0)==1):0)CR(j);f[I>>2]=0;H=j+16|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[v>>2]|0)>0){J=f[x>>2]|0;K=0;do{f[J+(K<<2)>>2]=0;K=K+1|0;L=f[v>>2]|0}while((K|0)<(L|0));f[j>>2]=f[D>>2];if((L|0)<3)y=51;else y=53}else{f[j>>2]=f[D>>2];y=51}if((y|0)==51){K=f[c+12>>2]|0;if((K|0)<3){f[v>>2]=K;f[w>>2]=f[c+16>>2];f[j+12>>2]=f[c+20>>2];K=f[c+52>>2]|0;J=f[r>>2]|0;f[J>>2]=f[K>>2];f[J+4>>2]=f[K+4>>2]}else y=53}if((y|0)==53)BR(j,D);f[H>>2]=f[c+24>>2];f[j+20>>2]=f[c+28>>2];f[j+24>>2]=f[c+32>>2];f[j+28>>2]=f[c+36>>2];f[j+32>>2]=f[c+40>>2];f[I>>2]=f[B>>2]}M=47;N=G/+p[c+176>>3]}else y=75}else if((n|0)==40720?(f[c+4>>2]|0)==47:0){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){y=75;break}K=c+8|0;if((j|0)!=(K|0)){J=c+44|0;A=f[J>>2]|0;if(A|0){C=A+12|0;f[C>>2]=(f[C>>2]|0)+1}C=j+36|0;A=f[C>>2]|0;if(A|0?(z=A+12|0,A=f[z>>2]|0,f[z>>2]=A+-1,(A|0)==1):0)CR(j);f[C>>2]=0;A=j+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[v>>2]|0)>0){z=f[x>>2]|0;O=0;do{f[z+(O<<2)>>2]=0;O=O+1|0;P=f[v>>2]|0}while((O|0)<(P|0));f[j>>2]=f[K>>2];if((P|0)<3)y=70;else y=72}else{f[j>>2]=f[K>>2];y=70}if((y|0)==70){O=f[c+12>>2]|0;if((O|0)<3){f[v>>2]=O;f[w>>2]=f[c+16>>2];f[j+12>>2]=f[c+20>>2];O=f[c+52>>2]|0;z=f[r>>2]|0;f[z>>2]=f[O>>2];f[z+4>>2]=f[O+4>>2]}else y=72}if((y|0)==72)BR(j,K);f[A>>2]=f[c+24>>2];f[j+20>>2]=f[c+28>>2];f[j+24>>2]=f[c+32>>2];f[j+28>>2]=f[c+36>>2];f[j+32>>2]=f[c+40>>2];f[C>>2]=f[J>>2]}M=42;N=G/+p[c+176>>3]}else y=75;while(0);if((y|0)==75){Ah[f[(f[n>>2]|0)+12>>2]&255](n,c,j,-1);M=47;N=G}gQ(d,M,i,j,N);w=j+36|0;l=f[w>>2]|0;if(l|0?(O=l+12|0,l=f[O>>2]|0,f[O>>2]=l+-1,(l|0)==1):0)CR(j);f[w>>2]=0;w=j+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[v>>2]|0)>0){w=f[x>>2]|0;l=0;do{f[w+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[v>>2]|0))}v=f[r>>2]|0;if((v|0)!=(q|0))ZF(v);v=i+36|0;l=f[v>>2]|0;if(l|0?(w=l+12|0,l=f[w>>2]|0,f[w>>2]=l+-1,(l|0)==1):0)CR(i);f[v>>2]=0;v=i+16|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[m>>2]|0)>0){v=f[o>>2]|0;l=0;do{f[v+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[m>>2]|0))}m=f[t>>2]|0;if((m|0)!=(s|0))ZF(m)}else Hh[f[(f[k>>2]|0)+76>>2]&15](k,b,c,d,e);while(0);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function vP(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=u;u=u+128|0;e=a+112|0;g=a+56|0;h=a;_$(e,41156);f[g>>2]=1124007936;i=g+4|0;j=g+8|0;k=g+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=g+48|0;n=g+44|0;f[n>>2]=j;f[j>>2]=0;f[g+52>>2]=0;o=f[c>>2]|0;Ah[f[(f[o>>2]|0)+12>>2]&255](o,c,g,-1);f[h>>2]=1124007936;c=h+4|0;o=h+8|0;p=h+40|0;l=c;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[p>>2]=o;o=h+48|0;l=h+44|0;f[l>>2]=o;f[o>>2]=0;f[h+52>>2]=0;gQ(d,47,g,h,b);d=h+36|0;m=f[d>>2]|0;if(m|0?(q=m+12|0,m=f[q>>2]|0,f[q>>2]=m+-1,(m|0)==1):0)CR(h);f[d>>2]=0;d=h+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){d=f[p>>2]|0;p=0;do{f[d+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[c>>2]|0))}c=f[l>>2]|0;if((c|0)!=(o|0))ZF(c);c=g+36|0;o=f[c>>2]|0;if(o|0?(l=o+12|0,o=f[l>>2]|0,f[l>>2]=o+-1,(o|0)==1):0)CR(g);f[c>>2]=0;c=g+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[i>>2]|0)>0){c=f[k>>2]|0;k=0;do{f[c+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[n>>2]|0;if((i|0)!=(j|0))ZF(i);if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function wP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+128|0;d=a+112|0;e=a+56|0;g=a;_$(d,41136);f[e>>2]=1124007936;h=e+4|0;i=e+8|0;j=e+40|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=e+48|0;m=e+44|0;f[m>>2]=i;f[i>>2]=0;f[e+52>>2]=0;n=f[b>>2]|0;Ah[f[(f[n>>2]|0)+12>>2]&255](n,b,e,-1);f[g>>2]=1124007936;b=g+4|0;n=g+8|0;o=g+40|0;k=b;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[o>>2]=n;n=g+48|0;k=g+44|0;f[k>>2]=n;f[n>>2]=0;f[g+52>>2]=0;gQ(c,97,e,g,1.0);c=g+36|0;l=f[c>>2]|0;if(l|0?(p=l+12|0,l=f[p>>2]|0,f[p>>2]=l+-1,(l|0)==1):0)CR(g);f[c>>2]=0;c=g+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[o>>2]|0;o=0;do{f[c+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[b>>2]|0))}b=f[k>>2]|0;if((b|0)!=(n|0))ZF(b);b=e+36|0;n=f[b>>2]|0;if(n|0?(k=n+12|0,n=f[k>>2]|0,f[k>>2]=n+-1,(n|0)==1):0)CR(e);f[b>>2]=0;b=e+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[h>>2]|0)>0){b=f[j>>2]|0;j=0;do{f[b+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[h>>2]|0))}h=f[m>>2]|0;if((h|0)!=(i|0))ZF(h);if(!(f[d+4>>2]|0)){u=a;return}u=a;return}function xP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;a=u;u=u+64|0;d=a+56|0;e=a;_$(d,41116);f[e>>2]=1124007936;g=e+4|0;h=e+8|0;i=e+40|0;j=g;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=e+48|0;j=e+44|0;f[j>>2]=h;f[h>>2]=0;f[e+52>>2]=0;k=f[b>>2]|0;Ah[f[(f[k>>2]|0)+12>>2]&255](k,b,e,-1);eQ(c,e,1.0);c=e+36|0;b=f[c>>2]|0;if(b|0?(k=b+12|0,b=f[k>>2]|0,f[k>>2]=b+-1,(b|0)==1):0)CR(e);f[c>>2]=0;c=e+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[g>>2]|0)>0){c=f[i>>2]|0;i=0;do{f[c+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[g>>2]|0))}g=f[j>>2]|0;if((g|0)!=(h|0))ZF(g);if(!(f[d+4>>2]|0)){u=a;return}u=a;return}function yP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0;e=u;u=u+432|0;g=e+32|0;h=e;i=e+368|0;j=e+312|0;k=e+256|0;l=f[c>>2]|0;if((l|0)!=(a|0)){Ah[f[(f[l>>2]|0)+92>>2]&255](l,b,c,d);u=e;return}f[i>>2]=1124007936;l=i+4|0;a=i+8|0;m=i+40|0;n=l;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=a;q=i+48|0;r=i+44|0;f[r>>2]=q;f[q>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;s=j+4|0;t=j+8|0;v=j+40|0;n=s;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[v>>2]=t;w=j+48|0;x=j+44|0;f[x>>2]=w;f[w>>2]=0;f[j+52>>2]=0;y=f[b>>2]|0;a:do if((y|0)==40356){z=+p[b+176>>3];A=b+8|0;if((i|0)==(A|0)){B=1;C=z}else{D=b+44|0;E=f[D>>2]|0;if(E){F=E+12|0;f[F>>2]=(f[F>>2]|0)+1;F=i+36|0;E=f[F>>2]|0;if((E|0)!=0?(G=E+12|0,E=f[G>>2]|0,f[G>>2]=E+-1,(E|0)==1):0){CR(i);H=F}else H=F}else H=i+36|0;f[H>>2]=0;F=i+16|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[l>>2]|0)>0){E=f[m>>2]|0;G=0;do{f[E+(G<<2)>>2]=0;G=G+1|0;I=f[l>>2]|0}while((G|0)<(I|0));f[i>>2]=f[A>>2];if((I|0)<3)J=14;else J=16}else{f[i>>2]=f[A>>2];J=14}if((J|0)==14){G=f[b+12>>2]|0;if((G|0)<3){f[l>>2]=G;f[a>>2]=f[b+16>>2];f[i+12>>2]=f[b+20>>2];G=f[b+52>>2]|0;E=f[r>>2]|0;f[E>>2]=f[G>>2];f[E+4>>2]=f[G+4>>2]}else J=16}if((J|0)==16)BR(i,A);f[F>>2]=f[b+24>>2];f[i+20>>2]=f[b+28>>2];f[i+24>>2]=f[b+32>>2];f[i+28>>2]=f[b+36>>2];f[i+32>>2]=f[b+40>>2];f[H>>2]=f[D>>2];B=1;C=z}}else{do if((y|0)==40360){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0)break;if(((+p[b+192>>3]==0.0?+p[b+200>>3]==0.0:0)?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){K=+p[b+176>>3];G=b+8|0;if((i|0)==(G|0)){B=0;C=K;break a}E=b+44|0;L=f[E>>2]|0;if(L){M=L+12|0;f[M>>2]=(f[M>>2]|0)+1;M=i+36|0;L=f[M>>2]|0;if((L|0)!=0?(N=L+12|0,L=f[N>>2]|0,f[N>>2]=L+-1,(L|0)==1):0){CR(i);O=M}else O=M}else O=i+36|0;f[O>>2]=0;M=i+16|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[l>>2]|0)>0){L=f[m>>2]|0;N=0;do{f[L+(N<<2)>>2]=0;N=N+1|0;P=f[l>>2]|0}while((N|0)<(P|0));f[i>>2]=f[G>>2];if((P|0)<3)J=36;else J=38}else{f[i>>2]=f[G>>2];J=36}if((J|0)==36){N=f[b+12>>2]|0;if((N|0)<3){f[l>>2]=N;f[a>>2]=f[b+16>>2];f[i+12>>2]=f[b+20>>2];N=f[b+52>>2]|0;L=f[r>>2]|0;f[L>>2]=f[N>>2];f[L+4>>2]=f[N+4>>2]}else J=38}if((J|0)==38)BR(i,G);f[M>>2]=f[b+24>>2];f[i+20>>2]=f[b+28>>2];f[i+24>>2]=f[b+32>>2];f[i+28>>2]=f[b+36>>2];f[i+32>>2]=f[b+40>>2];f[O>>2]=f[E>>2];B=0;C=K;break a}}while(0);Ah[f[(f[y>>2]|0)+12>>2]&255](y,b,i,-1);B=0;C=1.0}while(0);b=f[c>>2]|0;b:do if((b|0)==40356){y=B|2;z=C*+p[c+176>>3];O=c+8|0;if((j|0)==(O|0)){Q=y;R=z}else{a=c+44|0;P=f[a>>2]|0;if(P|0){H=P+12|0;f[H>>2]=(f[H>>2]|0)+1}H=j+36|0;P=f[H>>2]|0;if(P|0?(I=P+12|0,P=f[I>>2]|0,f[I>>2]=P+-1,(P|0)==1):0)CR(j);f[H>>2]=0;P=j+16|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[s>>2]|0)>0){I=f[v>>2]|0;D=0;do{f[I+(D<<2)>>2]=0;D=D+1|0;S=f[s>>2]|0}while((D|0)<(S|0));f[j>>2]=f[O>>2];if((S|0)<3)J=53;else J=55}else{f[j>>2]=f[O>>2];J=53}if((J|0)==53){D=f[c+12>>2]|0;if((D|0)<3){f[s>>2]=D;f[t>>2]=f[c+16>>2];f[j+12>>2]=f[c+20>>2];D=f[c+52>>2]|0;I=f[x>>2]|0;f[I>>2]=f[D>>2];f[I+4>>2]=f[D+4>>2]}else J=55}if((J|0)==55)BR(j,O);f[P>>2]=f[c+24>>2];f[j+20>>2]=f[c+28>>2];f[j+24>>2]=f[c+32>>2];f[j+28>>2]=f[c+36>>2];f[j+32>>2]=f[c+40>>2];f[H>>2]=f[a>>2];Q=y;R=z}}else{do if((b|0)==40360){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0)break;if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){T=C*+p[c+176>>3];D=c+8|0;if((j|0)==(D|0)){Q=B;R=T;break b}I=c+44|0;F=f[I>>2]|0;if(F|0){A=F+12|0;f[A>>2]=(f[A>>2]|0)+1}A=j+36|0;F=f[A>>2]|0;if(F|0?(N=F+12|0,F=f[N>>2]|0,f[N>>2]=F+-1,(F|0)==1):0)CR(j);f[A>>2]=0;F=j+16|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[s>>2]|0)>0){N=f[v>>2]|0;L=0;do{f[N+(L<<2)>>2]=0;L=L+1|0;U=f[s>>2]|0}while((L|0)<(U|0));f[j>>2]=f[D>>2];if((U|0)<3)J=75;else J=77}else{f[j>>2]=f[D>>2];J=75}if((J|0)==75){L=f[c+12>>2]|0;if((L|0)<3){f[s>>2]=L;f[t>>2]=f[c+16>>2];f[j+12>>2]=f[c+20>>2];L=f[c+52>>2]|0;N=f[x>>2]|0;f[N>>2]=f[L>>2];f[N+4>>2]=f[L+4>>2]}else J=77}if((J|0)==77)BR(j,D);f[F>>2]=f[c+24>>2];f[j+20>>2]=f[c+28>>2];f[j+24>>2]=f[c+32>>2];f[j+28>>2]=f[c+36>>2];f[j+32>>2]=f[c+40>>2];f[A>>2]=f[I>>2];Q=B;R=T;break b}}while(0);Ah[f[(f[b>>2]|0)+12>>2]&255](b,c,j,-1);Q=B;R=C}while(0);f[k>>2]=1124007936;B=k+4|0;c=k+8|0;b=k+40|0;n=B;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[b>>2]=c;c=k+48|0;n=k+44|0;f[n>>2]=c;f[c>>2]=0;f[k+52>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;DP(g,40364,Q,i,j,k,R,1.0,h);EP(d,g)|0;fj(g);g=k+36|0;d=f[g>>2]|0;if(d|0?(h=d+12|0,d=f[h>>2]|0,f[h>>2]=d+-1,(d|0)==1):0)CR(k);f[g>>2]=0;g=k+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[B>>2]|0)>0){g=f[b>>2]|0;b=0;do{f[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[B>>2]|0))}B=f[n>>2]|0;if((B|0)!=(c|0))ZF(B);B=j+36|0;c=f[B>>2]|0;if(c|0?(n=c+12|0,c=f[n>>2]|0,f[n>>2]=c+-1,(c|0)==1):0)CR(j);f[B>>2]=0;B=j+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[s>>2]|0)>0){B=f[v>>2]|0;v=0;do{f[B+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[s>>2]|0))}s=f[x>>2]|0;if((s|0)!=(w|0))ZF(s);s=i+36|0;w=f[s>>2]|0;if(w|0?(x=w+12|0,w=f[x>>2]|0,f[x>>2]=w+-1,(w|0)==1):0)CR(i);f[s>>2]=0;s=i+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[l>>2]|0)>0){s=f[m>>2]|0;m=0;do{f[s+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[l>>2]|0))}l=f[r>>2]|0;if((l|0)!=(q|0))ZF(l);u=e;return}function zP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;a=u;u=u+64|0;e=a;f[e>>2]=1124007936;g=e+4|0;h=e+8|0;i=e+40|0;j=g;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=e+48|0;j=e+44|0;f[j>>2]=h;f[h>>2]=0;f[e+52>>2]=0;k=f[b>>2]|0;Ah[f[(f[k>>2]|0)+12>>2]&255](k,b,e,-1);CP(d,c,e);c=e+36|0;d=f[c>>2]|0;if(d|0?(b=d+12|0,d=f[b>>2]|0,f[b>>2]=d+-1,(d|0)==1):0)CR(e);f[c>>2]=0;c=e+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[g>>2]|0)>0){c=f[i>>2]|0;i=0;do{f[c+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[g>>2]|0))}g=f[j>>2]|0;if((g|0)==(h|0)){u=a;return}ZF(g);u=a;return}function AP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;if(f[c+24>>2]|0){b=f[c+12>>2]|0;if((b|0)<3)d=Y(f[c+20>>2]|0,f[c+16>>2]|0)|0;else{e=f[c+48>>2]|0;g=0;h=1;while(1){i=Y(f[e+(g<<2)>>2]|0,h)|0;g=g+1|0;if((g|0)==(b|0)){d=i;break}else h=i}}if(!((b|0)==0|(d|0)==0))j=c+48|0;else k=8}else k=8;do if((k|0)==8){if(f[c+80>>2]|0){d=f[c+68>>2]|0;if((d|0)<3)l=Y(f[c+76>>2]|0,f[c+72>>2]|0)|0;else{b=f[c+104>>2]|0;h=0;g=1;while(1){e=Y(f[b+(h<<2)>>2]|0,g)|0;h=h+1|0;if((h|0)==(d|0)){l=e;break}else g=e}}if(!((d|0)==0|(l|0)==0)){j=c+160|0;break}}j=c+104|0}while(0);c=f[j>>2]|0;j=f[c>>2]|0;f[a>>2]=f[c+4>>2];f[a+4>>2]=j;return}function BP(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+16|0;c=a;_$(c,39976);d=b+8|0;if(f[b+24>>2]|0){e=f[b+12>>2]|0;if((e|0)<3)g=Y(f[b+20>>2]|0,f[b+16>>2]|0)|0;else{h=f[b+48>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if(!((e|0)==0|(g|0)==0))l=d;else m=7}else m=7;do if((m|0)==7){d=b+64|0;if(f[b+80>>2]|0){g=f[b+68>>2]|0;if((g|0)<3)n=Y(f[b+76>>2]|0,f[b+72>>2]|0)|0;else{e=f[b+104>>2]|0;j=0;i=1;while(1){h=Y(f[e+(j<<2)>>2]|0,i)|0;j=j+1|0;if((j|0)==(g|0)){n=h;break}else i=h}}if(!((g|0)==0|(n|0)==0)){l=b+120|0;break}}l=d}while(0);b=f[l>>2]&4095;if(!(f[c+4>>2]|0)){u=a;return b|0}u=a;return b|0}function CP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+368|0;e=d+32|0;g=d+312|0;h=d+256|0;i=d;f[g>>2]=1124007936;j=g+4|0;k=g+8|0;l=g+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=g+48|0;o=g+44|0;f[o>>2]=k;f[k>>2]=0;f[g+52>>2]=0;f[h>>2]=1124007936;p=h+4|0;q=h+8|0;r=h+40|0;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[r>>2]=q;q=h+48|0;m=h+44|0;f[m>>2]=q;f[q>>2]=0;f[h+52>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;DP(e,39996,b,c,g,h,1.0,0.0,i);EP(a,e)|0;fj(e);e=h+36|0;a=f[e>>2]|0;if(a|0?(i=a+12|0,a=f[i>>2]|0,f[i>>2]=a+-1,(a|0)==1):0)CR(h);f[e>>2]=0;e=h+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[p>>2]|0)>0){e=f[r>>2]|0;r=0;do{f[e+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[m>>2]|0;if((p|0)!=(q|0))ZF(p);p=g+36|0;q=f[p>>2]|0;if(q|0?(m=q+12|0,q=f[m>>2]|0,f[m>>2]=q+-1,(q|0)==1):0)CR(g);f[p>>2]=0;p=g+16|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[j>>2]|0)>0){p=f[l>>2]|0;l=0;do{f[p+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[o>>2]|0;if((j|0)==(k|0)){u=d;return}ZF(j);u=d;return}function DP(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0.0,B=0;f[a>>2]=b;f[a+4>>2]=c;c=a+8|0;f[c>>2]=f[d>>2];b=a+12|0;k=d+4|0;f[b>>2]=f[k>>2];l=a+16|0;f[l>>2]=f[d+8>>2];f[a+20>>2]=f[d+12>>2];f[a+24>>2]=f[d+16>>2];f[a+28>>2]=f[d+20>>2];f[a+32>>2]=f[d+24>>2];f[a+36>>2]=f[d+28>>2];f[a+40>>2]=f[d+32>>2];m=f[d+36>>2]|0;f[a+44>>2]=m;f[a+48>>2]=l;l=a+56|0;n=a+52|0;f[n>>2]=l;f[l>>2]=0;f[a+60>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[d+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[b>>2]=0;BR(c,d)}d=a+64|0;f[d>>2]=f[e>>2];c=a+68|0;b=e+4|0;f[c>>2]=f[b>>2];k=a+72|0;f[k>>2]=f[e+8>>2];f[a+76>>2]=f[e+12>>2];f[a+80>>2]=f[e+16>>2];f[a+84>>2]=f[e+20>>2];f[a+88>>2]=f[e+24>>2];f[a+92>>2]=f[e+28>>2];f[a+96>>2]=f[e+32>>2];l=f[e+36>>2]|0;f[a+100>>2]=l;f[a+104>>2]=k;k=a+112|0;n=a+108|0;f[n>>2]=k;f[k>>2]=0;f[a+116>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[b>>2]|0)<3){b=f[e+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2]}else{f[c>>2]=0;BR(d,e)}e=a+120|0;f[e>>2]=f[g>>2];d=a+124|0;c=g+4|0;f[d>>2]=f[c>>2];b=a+128|0;f[b>>2]=f[g+8>>2];f[a+132>>2]=f[g+12>>2];f[a+136>>2]=f[g+16>>2];f[a+140>>2]=f[g+20>>2];f[a+144>>2]=f[g+24>>2];f[a+148>>2]=f[g+28>>2];f[a+152>>2]=f[g+32>>2];k=f[g+36>>2]|0;f[a+156>>2]=k;f[a+160>>2]=b;b=a+168|0;n=a+164|0;f[n>>2]=b;f[b>>2]=0;f[a+172>>2]=0;if(k|0){b=k+12|0;f[b>>2]=(f[b>>2]|0)+1}if((f[c>>2]|0)<3){c=f[g+44>>2]|0;b=f[n>>2]|0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];o=a+176|0;p[o>>3]=h;q=a+184|0;p[q>>3]=i;r=+p[j>>3];s=a+192|0;p[s>>3]=r;t=j+8|0;u=+p[t>>3];v=a+200|0;p[v>>3]=u;w=j+16|0;x=+p[w>>3];y=a+208|0;p[y>>3]=x;z=j+24|0;A=+p[z>>3];B=a+216|0;p[B>>3]=A;return}else{f[d>>2]=0;BR(e,g);o=a+176|0;p[o>>3]=h;q=a+184|0;p[q>>3]=i;r=+p[j>>3];s=a+192|0;p[s>>3]=r;t=j+8|0;u=+p[t>>3];v=a+200|0;p[v>>3]=u;w=j+16|0;x=+p[w>>3];y=a+208|0;p[y>>3]=x;z=j+24|0;A=+p[z>>3];B=a+216|0;p[B>>3]=A;return}}function EP(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=b;d=f[c+4>>2]|0;e=a;f[e>>2]=f[c>>2];f[e+4>>2]=d;d=a+8|0;e=b+8|0;c=(a|0)==(b|0);if(c){g=a+176|0;h=b+176|0;i=g;j=h;k=i+48|0;do{f[i>>2]=f[j>>2];i=i+4|0;j=j+4|0}while((i|0)<(k|0));return a|0}l=b+44|0;m=f[l>>2]|0;if(m|0){n=m+12|0;f[n>>2]=(f[n>>2]|0)+1}n=a+44|0;m=f[n>>2]|0;if(m|0?(o=m+12|0,m=f[o>>2]|0,f[o>>2]=m+-1,(m|0)==1):0)CR(d);f[n>>2]=0;m=a+24|0;o=a+12|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[o>>2]|0)>0){p=f[a+48>>2]|0;q=0;do{f[p+(q<<2)>>2]=0;q=q+1|0;r=f[o>>2]|0}while((q|0)<(r|0));f[d>>2]=f[e>>2];if((r|0)<3)s=12;else s=14}else{f[d>>2]=f[e>>2];s=12}if((s|0)==12){r=f[b+12>>2]|0;if((r|0)<3){f[o>>2]=r;f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];r=f[b+52>>2]|0;o=f[a+52>>2]|0;f[o>>2]=f[r>>2];f[o+4>>2]=f[r+4>>2]}else s=14}if((s|0)==14)BR(d,e);f[m>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];f[a+36>>2]=f[b+36>>2];f[a+40>>2]=f[b+40>>2];f[n>>2]=f[l>>2];l=a+64|0;n=b+64|0;if(c){g=a+176|0;h=b+176|0;i=g;j=h;k=i+48|0;do{f[i>>2]=f[j>>2];i=i+4|0;j=j+4|0}while((i|0)<(k|0));return a|0}m=b+100|0;e=f[m>>2]|0;if(e|0){d=e+12|0;f[d>>2]=(f[d>>2]|0)+1}d=a+100|0;e=f[d>>2]|0;if(e|0?(r=e+12|0,e=f[r>>2]|0,f[r>>2]=e+-1,(e|0)==1):0)CR(l);f[d>>2]=0;e=a+80|0;r=a+68|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[r>>2]|0)>0){o=f[a+104>>2]|0;q=0;do{f[o+(q<<2)>>2]=0;q=q+1|0;t=f[r>>2]|0}while((q|0)<(t|0));f[l>>2]=f[n>>2];if((t|0)<3)s=26;else s=28}else{f[l>>2]=f[n>>2];s=26}if((s|0)==26){t=f[b+68>>2]|0;if((t|0)<3){f[r>>2]=t;f[a+72>>2]=f[b+72>>2];f[a+76>>2]=f[b+76>>2];t=f[b+108>>2]|0;r=f[a+108>>2]|0;f[r>>2]=f[t>>2];f[r+4>>2]=f[t+4>>2]}else s=28}if((s|0)==28)BR(l,n);f[e>>2]=f[b+80>>2];f[a+84>>2]=f[b+84>>2];f[a+88>>2]=f[b+88>>2];f[a+92>>2]=f[b+92>>2];f[a+96>>2]=f[b+96>>2];f[d>>2]=f[m>>2];m=a+120|0;d=b+120|0;if(c){g=a+176|0;h=b+176|0;i=g;j=h;k=i+48|0;do{f[i>>2]=f[j>>2];i=i+4|0;j=j+4|0}while((i|0)<(k|0));return a|0}c=b+156|0;e=f[c>>2]|0;if(e|0){n=e+12|0;f[n>>2]=(f[n>>2]|0)+1}n=a+156|0;e=f[n>>2]|0;if(e|0?(l=e+12|0,e=f[l>>2]|0,f[l>>2]=e+-1,(e|0)==1):0)CR(m);f[n>>2]=0;e=a+136|0;l=a+124|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[l>>2]|0)>0){t=f[a+160>>2]|0;r=0;do{f[t+(r<<2)>>2]=0;r=r+1|0;u=f[l>>2]|0}while((r|0)<(u|0));f[m>>2]=f[d>>2];if((u|0)<3)s=40;else s=42}else{f[m>>2]=f[d>>2];s=40}if((s|0)==40){u=f[b+124>>2]|0;if((u|0)<3){f[l>>2]=u;f[a+128>>2]=f[b+128>>2];f[a+132>>2]=f[b+132>>2];u=f[b+164>>2]|0;l=f[a+164>>2]|0;f[l>>2]=f[u>>2];f[l+4>>2]=f[u+4>>2]}else s=42}if((s|0)==42)BR(m,d);f[e>>2]=f[b+136>>2];f[a+140>>2]=f[b+140>>2];f[a+144>>2]=f[b+144>>2];f[a+148>>2]=f[b+148>>2];f[a+152>>2]=f[b+152>>2];f[n>>2]=f[c>>2];g=a+176|0;h=b+176|0;i=g;j=h;k=i+48|0;do{f[i>>2]=f[j>>2];i=i+4|0;j=j+4|0}while((i|0)<(k|0));return a|0}function FP(a){a=a|0;PYa(a);return}function GP(a,b){a=a|0;b=b|0;return 0}function HP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+96|0;e=a+32|0;g=a+16|0;h=a;f[e>>2]=1124007936;i=e+4|0;j=e+8|0;k=e+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=e+48|0;l=e+44|0;f[l>>2]=j;f[j>>2]=0;f[e+52>>2]=0;if((d|0)!=-1?(f[b+8>>2]&4095|0)!=(d|0):0)n=e;else n=c;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;m=h+8|0;f[m>>2]=0;f[m+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=n;+_M(g,h,f[b+4>>2]|0);if((f[n+16>>2]|0)!=(f[c+16>>2]|0)){b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;WJ(n,g,d,1.0,0.0)}d=e+36|0;g=f[d>>2]|0;if(g|0?(n=g+12|0,g=f[n>>2]|0,f[n>>2]=g+-1,(g|0)==1):0)CR(e);f[d>>2]=0;d=e+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[i>>2]|0)>0){d=f[k>>2]|0;k=0;do{f[d+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}ZF(i);u=a;return}function IP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=f[c>>2]|0;if((f[b>>2]|0)==39996&(e|0)==40116){JP(d,f[b+4>>2]|0,b+8|0,c+8|0);return}if((a|0)==(e|0)){yP(e,b,c,d);return}else{Ah[f[(f[e>>2]|0)+92>>2]&255](e,b,c,d);return}}function JP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+320|0;g=e+32|0;h=e+256|0;i=e;f[h>>2]=1124007936;j=h+4|0;k=h+8|0;l=h+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=h+48|0;m=h+44|0;f[m>>2]=k;f[k>>2]=0;f[h+52>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;DP(g,40120,b,c,d,h,1.0,1.0,i);EP(a,g)|0;fj(g);g=h+36|0;a=f[g>>2]|0;if(a|0?(i=a+12|0,a=f[i>>2]|0,f[i>>2]=a+-1,(a|0)==1):0)CR(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[j>>2]|0)>0){g=f[l>>2]|0;l=0;do{f[g+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[m>>2]|0;if((j|0)==(k|0)){u=e;return}ZF(j);u=e;return}function KP(a){a=a|0;PYa(a);return}function LP(a,b){a=a|0;b=b|0;return 0}function MP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+112|0;e=a+48|0;g=a+32|0;h=a+16|0;i=a;f[e>>2]=1124007936;j=e+4|0;k=e+8|0;l=e+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if((d|0)!=-1?(f[b+8>>2]&4095|0)!=(d|0):0)o=e;else o=c;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+64;n=i+8|0;f[n>>2]=0;f[n+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;hN(g,h,i,f[b+4>>2]|0)|0;if((f[o+16>>2]|0)!=(f[c+16>>2]|0)){b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;WJ(o,g,d,1.0,0.0)}d=e+36|0;g=f[d>>2]|0;if(g|0?(o=g+12|0,g=f[o>>2]|0,f[o>>2]=g+-1,(g|0)==1):0)CR(e);f[d>>2]=0;d=e+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[j>>2]|0)>0){d=f[l>>2]|0;l=0;do{f[d+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[m>>2]|0;if((j|0)==(k|0)){u=a;return}ZF(j);u=a;return}function NP(a){a=a|0;PYa(a);return}function OP(a,b){a=a|0;b=b|0;return 1}function PP(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+16|0;g=a;h=c+8|0;if((e|0)!=-1?(i=f[h>>2]|0,(i&4095|0)!=(e|0)):0){if((i^e)&4088|0){f[g>>2]=0;f[g+4>>2]=0;i=c$(g,59)|0;j=169450;k=i+59|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-215,g,169510,169384,1238);d$(g)}j=g+8|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=d;WJ(h,g,e,1.0,0.0);u=a;return}if((h|0)==(d|0)){u=a;return}e=c+44|0;g=f[e>>2]|0;if(g|0){j=g+12|0;f[j>>2]=(f[j>>2]|0)+1}j=d+36|0;g=f[j>>2]|0;if(g|0?(i=g+12|0,g=f[i>>2]|0,f[i>>2]=g+-1,(g|0)==1):0)CR(d);f[j>>2]=0;g=d+16|0;i=d+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){k=f[d+40>>2]|0;l=0;do{f[k+(l<<2)>>2]=0;l=l+1|0;m=f[i>>2]|0}while((l|0)<(m|0));f[d>>2]=f[c+8>>2];if((m|0)<3)n=14;else n=16}else{f[d>>2]=f[c+8>>2];n=14}if((n|0)==14){m=f[c+12>>2]|0;if((m|0)<3){f[i>>2]=m;f[d+8>>2]=f[c+16>>2];f[d+12>>2]=f[c+20>>2];m=f[c+52>>2]|0;i=f[d+44>>2]|0;f[i>>2]=f[m>>2];f[i+4>>2]=f[m+4>>2]}else n=16}if((n|0)==16)BR(d,h);f[g>>2]=f[c+24>>2];f[d+20>>2]=f[c+28>>2];f[d+24>>2]=f[c+32>>2];f[d+28>>2]=f[c+36>>2];f[d+32>>2]=f[c+40>>2];f[j>>2]=f[e>>2];u=a;return}function QP(a){a=a|0;PYa(a);return}function RP(a,b){a=a|0;b=b|0;return 0}function SP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0.0;a=u;u=u+128|0;e=a+64|0;g=a+48|0;h=a+32|0;i=a+16|0;j=a;f[e>>2]=1124007936;k=e+4|0;l=e+8|0;m=e+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=e+48|0;n=e+44|0;f[n>>2]=l;f[l>>2]=0;f[e+52>>2]=0;if((d|0)!=-1?(f[b+8>>2]&4095|0)!=(d|0):0)q=e;else q=c;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+64;r=+p[b+176>>3];f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b+120;s=+p[b+184>>3];o=j+8|0;f[o>>2]=0;f[o+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=q;jO(g,h,r,i,s,j,f[b+4>>2]|0);if((f[q+16>>2]|0)!=(f[c+16>>2]|0)){b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;WJ(q,g,d,1.0,0.0)}d=e+36|0;g=f[d>>2]|0;if(g|0?(q=g+12|0,g=f[q>>2]|0,f[q>>2]=g+-1,(g|0)==1):0)CR(e);f[d>>2]=0;d=e+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[k>>2]|0)>0){d=f[m>>2]|0;m=0;do{f[d+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[n>>2]|0;if((k|0)==(l|0)){u=a;return}ZF(k);u=a;return}function TP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0,s=0;e=u;u=u+272|0;g=e+32|0;h=e;i=e+256|0;_$(i,40544);j=f[b>>2]|0;k=(j|0)==40116;l=f[c>>2]|0;m=(l|0)==40116;n=k?1.0:+p[b+176>>3];o=m?1.0:+p[c+176>>3];q=+p[b+184>>3];a:do if((j|0)!=40364|(f[b+136>>2]|0)!=0&q!=0.0)r=12;else{do if(!m){if((l|0)!=40360)if((l|0)==40356)break;else{r=12;break a}if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){r=12;break a}if(!(+p[c+192>>3]==0.0)){r=12;break a}if(!(+p[c+200>>3]==0.0)){r=12;break a}if(!(+p[c+208>>3]==0.0)){r=12;break a}if(!(+p[c+216>>3]==0.0)){r=12;break a}}while(0);s=((l|0)==40356?4:0)|f[b+4>>2]&-5;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;DP(g,40364,s,b+8|0,b+64|0,c+8|0,n,o,h);EP(d,g)|0;fj(g)}while(0);b:do if((r|0)==12){c:do if(!((l|0)!=40364|(f[c+136>>2]|0?+p[c+184>>3]!=0.0:0))){do if(!k){if((j|0)!=40360)if((j|0)==40356)break;else break c;if(!((f[b+80>>2]|0)==0|q==0.0))break c;if(!(+p[b+192>>3]==0.0))break c;if(!(+p[b+200>>3]==0.0))break c;if(!(+p[b+208>>3]==0.0))break c;if(!(+p[b+216>>3]==0.0))break c}while(0);m=((j|0)==40356?4:0)|f[c+4>>2]&-5;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;DP(g,40364,m,c+8|0,c+64|0,b+8|0,o,n,h);EP(d,g)|0;fj(g);break b}while(0);if((a|0)==(l|0)){oP(l,b,c,d);break}else{Ah[f[(f[l>>2]|0)+52>>2]&255](l,b,c,d);break}}while(0);if(!(f[i+4>>2]|0)){u=e;return}u=e;return}function UP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0,s=0;e=u;u=u+272|0;g=e+32|0;h=e;i=e+256|0;_$(i,40524);j=f[b>>2]|0;k=(j|0)==40116;l=f[c>>2]|0;m=(l|0)==40116;n=k?1.0:+p[b+176>>3];o=m?1.0:+p[c+176>>3];q=+p[b+184>>3];a:do if((j|0)!=40364|(f[b+136>>2]|0)!=0&q!=0.0)r=12;else{do if(!m){if((l|0)!=40360)if((l|0)==40356)break;else{r=12;break a}if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){r=12;break a}if(!(+p[c+192>>3]==0.0)){r=12;break a}if(!(+p[c+200>>3]==0.0)){r=12;break a}if(!(+p[c+208>>3]==0.0)){r=12;break a}if(!(+p[c+216>>3]==0.0)){r=12;break a}}while(0);s=((l|0)==40356?4:0)|f[b+4>>2]&-5;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;DP(g,40364,s,b+8|0,b+64|0,c+8|0,n,-o,h);EP(d,g)|0;fj(g)}while(0);b:do if((r|0)==12){c:do if(!((l|0)!=40364|(f[c+136>>2]|0?+p[c+184>>3]!=0.0:0))){do if(!k){if((j|0)!=40360)if((j|0)==40356)break;else break c;if(!((f[b+80>>2]|0)==0|q==0.0))break c;if(!(+p[b+192>>3]==0.0))break c;if(!(+p[b+200>>3]==0.0))break c;if(!(+p[b+208>>3]==0.0))break c;if(!(+p[b+216>>3]==0.0))break c}while(0);m=((j|0)==40356?4:0)|f[c+4>>2]&-5;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;DP(g,40364,m,c+8|0,c+64|0,b+8|0,-o,n,h);EP(d,g)|0;fj(g);break b}while(0);if((a|0)==(l|0)){qP(l,b,c,d);break}else{Ah[f[(f[l>>2]|0)+60>>2]&255](l,b,c,d);break}}while(0);if(!(f[i+4>>2]|0)){u=e;return}u=e;return}function VP(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0;a=u;u=u+16|0;e=a;_$(e,40504);EP(d,b)|0;b=d+176|0;p[b>>3]=+p[b>>3]*c;b=d+184|0;p[b>>3]=+p[b>>3]*c;if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function WP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=u;u=u+16|0;d=a;_$(d,40484);EP(c,b)|0;e=f[b+4>>2]|0;f[c+4>>2]=(e<<1&2|e&4|e>>>1&1)^7;zR(c+8|0,c+64|0);if(!(f[d+4>>2]|0)){u=a;return}u=a;return}function XP(a){a=a|0;PYa(a);return}function YP(a,b){a=a|0;b=b|0;return 1}function ZP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,v=0,w=0.0,x=0.0;a=u;u=u+112|0;e=a+48|0;g=a+32|0;h=a+16|0;i=a;f[e>>2]=1124007936;j=e+4|0;k=e+8|0;l=e+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if((d|0)!=-1?(f[b+8>>2]&4095|0)!=(d|0):0)o=e;else o=c;n=b+64|0;q=b+192|0;a:do if(!(f[b+80>>2]|0)){do if((+p[b+200>>3]==0.0?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){r=+p[b+176>>3];if((f[o+16>>2]|0)==(f[c+16>>2]|0)?!(+L(+r)!=1.0):0)break;s=g+8|0;f[s>>2]=0;f[s+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;WJ(b+8|0,g,d,r,+p[q>>3]);break a}while(0);r=+p[b+176>>3];if(r==1.0){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h>>2]=-1056833530;f[h+4>>2]=q;f[h+8>>2]=1;f[h+12>>2]=4;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;TG(g,h,i,fT()|0,-1);t=38;break}if(r==-1.0){f[g>>2]=-1056833530;f[g+4>>2]=q;f[g+8>>2]=1;f[g+12>>2]=4;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+8;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;hH(g,h,i,fT()|0,-1);t=38;break}else{s=b+8|0;v=g+8|0;f[v>>2]=0;f[v+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=o;WJ(s,g,f[s>>2]&4095,r,0.0);f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=o;f[h>>2]=-1056833530;f[h+4>>2]=q;f[h+8>>2]=1;f[h+12>>2]=4;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;TG(g,h,i,fT()|0,-1);t=38;break}}else{r=+p[q>>3];w=+p[b+200>>3];if(r==0.0&w==0.0?+p[b+208>>3]==0.0:0){if(w==0.0?+p[b+216>>3]!=0.0:0)t=9}else t=8;if((t|0)==8?w==0.0:0)t=9;if(((t|0)==9?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;w=+p[b+176>>3];f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=n;x=+p[b+184>>3];s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;hI(g,w,h,x,r,i,-1);t=38;break}r=+p[b+176>>3];x=+p[b+184>>3];s=x==1.0;do if(r==1.0){if(s){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=n;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;TG(g,h,i,fT()|0,-1);break}if(x==-1.0){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=n;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;hH(g,h,i,fT()|0,-1);break}else{f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=n;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+8;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;CO(g,x,h,i);break}}else{if(!s){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=n;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;hI(g,r,h,x,0.0,i,-1);break}if(r==-1.0){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=n;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+8;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;hH(g,h,i,fT()|0,-1);break}else{f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=n;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;CO(g,r,h,i);break}}while(0);if((+p[b+200>>3]==0.0?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){t=38;break}f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=o;f[h>>2]=-1056833530;f[h+4>>2]=q;f[h+8>>2]=1;f[h+12>>2]=4;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;TG(g,h,i,fT()|0,-1);t=38}while(0);if((t|0)==38?(f[o+16>>2]|0)!=(f[c+16>>2]|0):0){t=g+8|0;f[t>>2]=0;f[t+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;WJ(o,g,f[c>>2]&4095,1.0,0.0)}c=e+36|0;g=f[c>>2]|0;if(g|0?(o=g+12|0,g=f[o>>2]|0,f[o>>2]=g+-1,(g|0)==1):0)CR(e);f[c>>2]=0;c=e+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[j>>2]|0)>0){c=f[l>>2]|0;l=0;do{f[c+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[m>>2]|0;if((j|0)==(k|0)){u=a;return}ZF(j);u=a;return}function _P(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;a=u;u=u+16|0;e=a;_$(e,40940);EP(d,b)|0;b=d+192|0;p[b>>3]=+p[c>>3]+ +p[b>>3];b=d+200|0;p[b>>3]=+p[c+8>>3]+ +p[b>>3];b=d+208|0;p[b>>3]=+p[c+16>>3]+ +p[b>>3];b=d+216|0;p[b>>3]=+p[c+24>>3]+ +p[b>>3];if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function $P(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0.0,i=0,j=0.0,k=0,l=0.0;a=u;u=u+16|0;e=a;_$(e,40920);EP(d,c)|0;c=d+176|0;p[c>>3]=-+p[c>>3];c=d+184|0;p[c>>3]=-+p[c>>3];c=d+192|0;g=d+200|0;h=+p[b+8>>3]-+p[g>>3];i=d+208|0;j=+p[b+16>>3]-+p[i>>3];k=d+216|0;l=+p[b+24>>3]-+p[k>>3];p[c>>3]=+p[b>>3]-+p[c>>3];p[g>>3]=h;p[i>>3]=j;p[k>>3]=l;if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function aQ(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0;a=u;u=u+16|0;e=a;_$(e,40900);EP(d,b)|0;b=d+176|0;p[b>>3]=+p[b>>3]*c;b=d+184|0;p[b>>3]=+p[b>>3]*c;b=d+192|0;p[b>>3]=+p[b>>3]*c;b=d+200|0;p[b>>3]=+p[b>>3]*c;b=d+208|0;p[b>>3]=+p[b>>3]*c;b=d+216|0;p[b>>3]=+p[b>>3]*c;if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function bQ(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;a=u;u=u+64|0;e=a+56|0;g=a;_$(e,40880);do if((f[c>>2]|0)==40360){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){h=17;break}if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){f[g>>2]=1124007936;i=g+4|0;j=g+8|0;k=g+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;l=g+48|0;m=g+44|0;f[m>>2]=l;f[l>>2]=0;f[g+52>>2]=0;gQ(d,47,c+8|0,g,b/+p[c+176>>3]);n=g+36|0;o=f[n>>2]|0;if(o|0?(q=o+12|0,o=f[q>>2]|0,f[q>>2]=o+-1,(o|0)==1):0)CR(g);f[n>>2]=0;n=g+16|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[i>>2]|0)>0){n=f[k>>2]|0;o=0;do{f[n+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[i>>2]|0))}i=f[m>>2]|0;if((i|0)!=(l|0))ZF(i)}else h=17}else h=17;while(0);if((h|0)==17)vP(0,b,c,d);if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function cQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0.0,m=0.0;a=u;u=u+48|0;d=a+32|0;e=a;_$(d,40700);g=b+64|0;h=(f[b+80>>2]|0)==0;if(!h?!(+p[b+184>>3]==0.0):0)i=6;else i=3;do if((i|0)==3){j=+p[b+176>>3];if(!(+L(+j)==1.0))if(h){i=8;break}else{i=6;break}else{k=-(+p[b+200>>3]*j);l=-(+p[b+208>>3]*j);m=-(+p[b+216>>3]*j);p[e>>3]=-(+p[b+192>>3]*j);p[e+8>>3]=k;p[e+16>>3]=l;p[e+24>>3]=m;fQ(c,97,b+8|0,e);break}}while(0);if((i|0)==6){m=+p[b+176>>3];l=+p[b+184>>3];if(m+l==0.0&m*l==-1.0)gQ(c,97,b+8|0,g,1.0);else i=8}if((i|0)==8)wP(0,b,c);if(!(f[d+4>>2]|0)){u=a;return}u=a;return}function dQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=u;u=u+16|0;d=a;_$(d,40680);do if((f[b>>2]|0)==40360){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){e=9;break}if(((+p[b+192>>3]==0.0?+p[b+200>>3]==0.0:0)?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0)eQ(c,b+8|0,+p[b+176>>3]);else e=9}else e=9;while(0);if((e|0)==9)xP(0,b,c);if(!(f[d+4>>2]|0)){u=a;return}u=a;return}function eQ(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+368|0;e=d+32|0;g=d+312|0;h=d+256|0;i=d;f[g>>2]=1124007936;j=g+4|0;k=g+8|0;l=g+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=g+48|0;o=g+44|0;f[o>>2]=k;f[k>>2]=0;f[g+52>>2]=0;f[h>>2]=1124007936;p=h+4|0;q=h+8|0;r=h+40|0;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[r>>2]=q;q=h+48|0;m=h+44|0;f[m>>2]=q;f[q>>2]=0;f[h+52>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;DP(e,40356,0,b,g,h,c,0.0,i);EP(a,e)|0;fj(e);e=h+36|0;a=f[e>>2]|0;if(a|0?(i=a+12|0,a=f[i>>2]|0,f[i>>2]=a+-1,(a|0)==1):0)CR(h);f[e>>2]=0;e=h+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[p>>2]|0)>0){e=f[r>>2]|0;r=0;do{f[e+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[m>>2]|0;if((p|0)!=(q|0))ZF(p);p=g+36|0;q=f[p>>2]|0;if(q|0?(m=q+12|0,q=f[m>>2]|0,f[m>>2]=q+-1,(q|0)==1):0)CR(g);f[p>>2]=0;p=g+16|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[j>>2]|0)>0){p=f[l>>2]|0;l=0;do{f[p+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[o>>2]|0;if((j|0)==(k|0)){u=d;return}ZF(j);u=d;return}function fQ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+336|0;g=e;h=e+280|0;i=e+224|0;f[h>>2]=1124007936;j=h+4|0;k=h+8|0;l=h+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=h+48|0;o=h+44|0;f[o>>2]=k;f[k>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;p=i+4|0;q=i+8|0;r=i+40|0;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[r>>2]=q;q=i+48|0;m=i+44|0;f[m>>2]=q;f[q>>2]=0;f[i+52>>2]=0;DP(g,40720,b<<24>>24,c,h,i,1.0,0.0,d);EP(a,g)|0;fj(g);g=i+36|0;a=f[g>>2]|0;if(a|0?(d=a+12|0,a=f[d>>2]|0,f[d>>2]=a+-1,(a|0)==1):0)CR(i);f[g>>2]=0;g=i+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[p>>2]|0)>0){g=f[r>>2]|0;r=0;do{f[g+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[m>>2]|0;if((p|0)!=(q|0))ZF(p);p=h+36|0;q=f[p>>2]|0;if(q|0?(m=q+12|0,q=f[m>>2]|0,f[m>>2]=q+-1,(q|0)==1):0)CR(h);f[p>>2]=0;p=h+16|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[j>>2]|0)>0){p=f[l>>2]|0;l=0;do{f[p+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[o>>2]|0;if((j|0)==(k|0)){u=e;return}ZF(j);u=e;return}function gQ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+320|0;h=g+32|0;i=g+256|0;j=g;f[i>>2]=1124007936;k=i+4|0;l=i+8|0;m=i+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=i+48|0;n=i+44|0;f[n>>2]=l;f[l>>2]=0;f[i+52>>2]=0;o=f[d+16>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;DP(h,40720,b<<24>>24,c,d,i,e,+((o|0)!=0&1),j);EP(a,h)|0;fj(h);h=i+36|0;a=f[h>>2]|0;if(a|0?(j=a+12|0,a=f[j>>2]|0,f[j>>2]=a+-1,(a|0)==1):0)CR(i);f[h>>2]=0;h=i+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[k>>2]|0)>0){h=f[m>>2]|0;m=0;do{f[h+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[n>>2]|0;if((k|0)==(l|0)){u=g;return}ZF(k);u=g;return}function hQ(a){a=a|0;PYa(a);return}function iQ(a,b){a=a|0;b=b|0;return 1}function jQ(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,v=0;a=u;u=u+112|0;g=a+48|0;h=a+32|0;i=a+16|0;j=a;f[g>>2]=1124007936;k=g+4|0;l=g+8|0;m=g+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=g+48|0;q=g+44|0;f[q>>2]=l;f[l>>2]=0;f[g+52>>2]=0;if((e|0)!=-1?(f[c+8>>2]&4095|0)!=(e|0):0)r=g;else r=d;a:do switch(f[c+4>>2]|0){case 42:{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;LH(h,i,j,+p[c+176>>3],-1);break}case 47:{if(!(f[c+80>>2]|0)){t=+p[c+176>>3];f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=r;$H(t,h,i,-1);break a}else{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;TH(h,i,j,+p[c+176>>3],-1);break a}break}case 38:{if(!(f[c+80>>2]|0)){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=4;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;bG(h,i,j,fT()|0);break a}else{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;bG(h,i,j,fT()|0);break a}break}case 124:{if(!(f[c+80>>2]|0)){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=4;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;fG(h,i,j,fT()|0);break a}else{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;fG(h,i,j,fT()|0);break a}break}case 94:{if(!(f[c+80>>2]|0)){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=4;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;iG(h,i,j,fT()|0);break a}else{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;iG(h,i,j,fT()|0);break a}break}case 126:{if(!(f[c+80>>2]|0)){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=r;lG(h,i,fT()|0)}else v=28;break}case 109:{SG(c+8|0,c+64|0,r);break}case 110:{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=1;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;CG(h,i,j);break}case 77:{RG(c+8|0,c+64|0,r);break}case 78:{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=1;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;nG(h,i,j);break}case 97:{if(f[c+80>>2]|0){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;wH(h,i,j);break a}if(!(f[c+80>>2]|0)){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=4;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;wH(h,i,j)}else v=28;break}default:v=28}while(0);if((v|0)==28){f[h>>2]=0;f[h+4>>2]=0;n=c$(h,17)|0;v=170197;o=n+17|0;do{b[n>>0]=b[v>>0]|0;n=n+1|0;v=v+1|0}while((n|0)<(o|0));j$(-2,h,169510,169384,1408);d$(h)}if((f[r+16>>2]|0)!=(f[d+16>>2]|0)){v=h+8|0;f[v>>2]=0;f[v+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=d;WJ(r,h,e,1.0,0.0)}e=g+36|0;h=f[e>>2]|0;if(h|0?(r=h+12|0,h=f[r>>2]|0,f[r>>2]=h+-1,(h|0)==1):0)CR(g);f[e>>2]=0;e=g+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[k>>2]|0)>0){e=f[m>>2]|0;m=0;do{f[e+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[q>>2]|0;if((k|0)==(l|0)){u=a;return}ZF(k);u=a;return}function kQ(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0;a=u;u=u+16|0;e=a;_$(e,40860);switch(f[b+4>>2]|0){case 47:case 42:{EP(d,b)|0;g=d+176|0;p[g>>3]=+p[g>>3]*c;break}default:tP(0,b,c,d)}if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function lQ(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0.0,r=0,s=0,t=0;a=u;u=u+96|0;e=a+88|0;g=a+32|0;h=a;_$(e,40840);do if((f[c+4>>2]|0)==47){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){i=13;break}j=c+8|0;f[g>>2]=1124007936;k=g+4|0;l=g+8|0;m=g+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;n=g+48|0;o=g+44|0;f[o>>2]=n;f[n>>2]=0;f[g+52>>2]=0;q=+p[c+176>>3];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;mQ(d,j,g,b/q,0.0,h);r=g+36|0;s=f[r>>2]|0;if(s|0?(t=s+12|0,s=f[t>>2]|0,f[t>>2]=s+-1,(s|0)==1):0)CR(g);f[r>>2]=0;r=g+16|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;s=0;do{f[r+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[k>>2]|0))}k=f[o>>2]|0;if((k|0)!=(n|0))ZF(k)}else i=13;while(0);if((i|0)==13)vP(0,b,c,d);if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function mQ(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=u;u=u+288|0;i=h;j=h+224|0;f[j>>2]=1124007936;k=j+4|0;l=j+8|0;m=j+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=j+48|0;n=j+44|0;f[n>>2]=l;f[l>>2]=0;f[j+52>>2]=0;DP(i,40360,0,b,c,j,d,e,g);EP(a,i)|0;fj(i);i=j+36|0;a=f[i>>2]|0;if(a|0?(g=a+12|0,a=f[g>>2]|0,f[g>>2]=a+-1,(a|0)==1):0)CR(j);f[i>>2]=0;i=j+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[k>>2]|0)>0){i=f[m>>2]|0;m=0;do{f[i+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[n>>2]|0;if((k|0)==(l|0)){u=h;return}ZF(k);u=h;return}function nQ(a){a=a|0;PYa(a);return}function oQ(a,b){a=a|0;b=b|0;return 0}function pQ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0;a=u;u=u+96|0;e=a+32|0;g=a+16|0;h=a;f[e>>2]=1124007936;i=e+4|0;j=e+8|0;k=e+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=e+48|0;l=e+44|0;f[l>>2]=j;f[j>>2]=0;f[e+52>>2]=0;if((d|0)!=-1?(f[b+8>>2]&4095|0)!=(d|0):0)n=e;else n=c;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;m=h+8|0;f[m>>2]=0;f[m+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=n;mS(g,h);o=+p[b+176>>3];if(o!=1.0?1:(f[n+16>>2]|0)!=(f[c+16>>2]|0)){b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;WJ(n,g,d,o,0.0)}d=e+36|0;g=f[d>>2]|0;if(g|0?(n=g+12|0,g=f[n>>2]|0,f[n>>2]=g+-1,(g|0)==1):0)CR(e);f[d>>2]=0;d=e+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[i>>2]|0)>0){d=f[k>>2]|0;k=0;do{f[d+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}ZF(i);u=a;return}function qQ(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0;a=u;u=u+16|0;e=a;_$(e,41096);EP(d,b)|0;b=d+176|0;p[b>>3]=+p[b>>3]*c;if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function rQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+96|0;d=a+88|0;e=a+32|0;g=a;_$(d,41076);h=+p[b+176>>3];i=b+8|0;if(!(h==1.0)){f[e>>2]=1124007936;b=e+4|0;j=e+8|0;k=e+40|0;l=b;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=e+48|0;l=e+44|0;f[l>>2]=j;f[j>>2]=0;f[e+52>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;mQ(c,i,e,h,0.0,g);g=e+36|0;m=f[g>>2]|0;if(m|0?(n=m+12|0,m=f[n>>2]|0,f[n>>2]=m+-1,(m|0)==1):0)CR(e);f[g>>2]=0;g=e+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[b>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[b>>2]|0))}b=f[l>>2]|0;if((b|0)!=(j|0))ZF(b)}else sQ(c,i);if(!(f[d+4>>2]|0)){u=a;return}u=a;return}function sQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+368|0;d=c+32|0;e=c+312|0;g=c+256|0;h=c;f[e>>2]=1124007936;i=e+4|0;j=e+8|0;k=e+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=e+48|0;n=e+44|0;f[n>>2]=j;f[j>>2]=0;f[e+52>>2]=0;f[g>>2]=1124007936;o=g+4|0;p=g+8|0;q=g+40|0;l=o;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[q>>2]=p;p=g+48|0;l=g+44|0;f[l>>2]=p;f[p>>2]=0;f[g+52>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;DP(d,40116,0,b,e,g,1.0,0.0,h);EP(a,d)|0;fj(d);d=g+36|0;a=f[d>>2]|0;if(a|0?(h=a+12|0,a=f[h>>2]|0,f[h>>2]=a+-1,(a|0)==1):0)CR(g);f[d>>2]=0;d=g+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[o>>2]|0)>0){d=f[q>>2]|0;q=0;do{f[d+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[o>>2]|0))}o=f[l>>2]|0;if((o|0)!=(p|0))ZF(o);o=e+36|0;p=f[o>>2]|0;if(p|0?(l=p+12|0,p=f[l>>2]|0,f[l>>2]=p+-1,(p|0)==1):0)CR(e);f[o>>2]=0;o=e+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[i>>2]|0)>0){o=f[k>>2]|0;k=0;do{f[o+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[n>>2]|0;if((i|0)==(j|0)){u=c;return}ZF(i);u=c;return}function tQ(a){a=a|0;PYa(a);return}function uQ(a,b){a=a|0;b=b|0;return 1}function vQ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+112|0;e=a+48|0;g=a+32|0;h=a+16|0;i=a;f[e>>2]=1124007936;j=e+4|0;k=e+8|0;l=e+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;n=(d|0)==-1|(d|0)==0?c:e;if(!(f[b+80>>2]|0)){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h>>2]=-1056833530;f[h+4>>2]=b+176;f[h+8>>2]=1;f[h+12>>2]=1;o=i+8|0;f[o>>2]=0;f[o+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=n;pI(g,h,i,f[b+4>>2]|0)}else{f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+64;o=i+8|0;f[o>>2]=0;f[o+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=n;pI(g,h,i,f[b+4>>2]|0)}if((f[n+16>>2]|0)!=(f[c+16>>2]|0)){b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;WJ(n,g,d,1.0,0.0)}d=e+36|0;g=f[d>>2]|0;if(g|0?(n=g+12|0,g=f[n>>2]|0,f[n>>2]=g+-1,(g|0)==1):0)CR(e);f[d>>2]=0;d=e+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[j>>2]|0)>0){d=f[l>>2]|0;l=0;do{f[d+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[m>>2]|0;if((j|0)==(k|0)){u=a;return}ZF(j);u=a;return}function wQ(a){a=a|0;PYa(a);return}function xQ(a,b){a=a|0;b=b|0;return 0}function yQ(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+64|0;g=a+32|0;h=a;i=(e|0)==-1?f[c+8>>2]&4095:e;e=c+12|0;j=f[e>>2]|0;k=f[c+48>>2]|0;do if((j|0)<3){l=f[k+4>>2]|0;m=f[k>>2]|0;n=i&4095;if(((((f[d+4>>2]|0)<3?(f[d+8>>2]|0)==(m|0):0)?(f[d+12>>2]|0)==(l|0):0)?(f[d>>2]&4095|0)==(n|0):0)?f[d+16>>2]|0:0)break;f[g>>2]=m;f[g+4>>2]=l;AR(d,2,g,n)}else AR(d,j,k,i);while(0);i=f[c+4>>2]|0;if((i|0)==73&(f[e>>2]|0)<3){e=g+8|0;f[e>>2]=0;f[e+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=d;p[h>>3]=+p[c+176>>3];e=h+8|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;kT(g,h);u=a;return}switch(i|0){case 48:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;gL(d,g)|0;u=a;return}case 49:{p[g>>3]=+p[c+176>>3];c=g+8|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;gL(d,g)|0;u=a;return}default:{f[g>>2]=0;f[g+4>>2]=0;d=c$(g,31)|0;c=171871;i=d+31|0;do{b[d>>0]=b[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(i|0));j$(-2,g,169510,169384,1643);d$(g);u=a;return}}}function zQ(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0;a=u;u=u+16|0;e=a;_$(e,41548);EP(d,b)|0;b=d+176|0;p[b>>3]=+p[b>>3]*c;if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function AQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=40116;f[a+4>>2]=0;c=a+8|0;f[c>>2]=f[b>>2];d=a+12|0;e=b+4|0;f[d>>2]=f[e>>2];g=a+16|0;f[g>>2]=f[b+8>>2];f[a+20>>2]=f[b+12>>2];f[a+24>>2]=f[b+16>>2];f[a+28>>2]=f[b+20>>2];f[a+32>>2]=f[b+24>>2];f[a+36>>2]=f[b+28>>2];f[a+40>>2]=f[b+32>>2];h=f[b+36>>2]|0;f[a+44>>2]=h;f[a+48>>2]=g;g=a+56|0;i=a+52|0;f[i>>2]=g;f[g>>2]=0;f[a+60>>2]=0;if(h|0){g=h+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[e>>2]|0)<3){e=f[b+44>>2]|0;g=f[i>>2]|0;f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2]}else{f[d>>2]=0;BR(c,b)}f[a+64>>2]=1124007936;b=a+72|0;c=a+104|0;d=a+68|0;e=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));f[c>>2]=b;b=a+112|0;f[a+108>>2]=b;f[b>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;b=a+128|0;c=a+160|0;d=a+124|0;e=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));f[c>>2]=b;b=a+168|0;f[a+164>>2]=b;f[b>>2]=0;f[a+172>>2]=0;p[a+176>>3]=1.0;d=a+184|0;e=d+40|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));return}function BQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=f[b>>2]|0;Ah[f[(f[g>>2]|0)+96>>2]&255](g,b,c,a);return}function CQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=f[b>>2]|0;Ah[f[(f[g>>2]|0)+56>>2]&255](g,b,c,a);return}function DQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=f[b>>2]|0;Ah[f[(f[g>>2]|0)+52>>2]&255](g,b,c,a);return}function EQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+32|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;mQ(a,b,c,1.0,-1.0,e);u=d;return}function FQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+224|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));i=f[b>>2]|0;j=f[(f[i>>2]|0)+60>>2]|0;AQ(e,c);Ah[j&255](i,b,e,a);fj(e);u=d;return}function GQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0.0,l=0.0,m=0.0;d=u;u=u+32|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));i=f[b>>2]|0;j=f[(f[i>>2]|0)+56>>2]|0;k=-+p[c+8>>3];l=-+p[c+16>>3];m=-+p[c+24>>3];p[e>>3]=-+p[c>>3];p[e+8>>3]=k;p[e+16>>3]=l;p[e+24>>3]=m;Ah[j&255](i,b,e,a);u=d;return}function HQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=f[b>>2]|0;Ah[f[(f[g>>2]|0)+60>>2]&255](g,b,c,a);return}function IQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+96|0;d=c+32|0;e=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[d>>2]=1124007936;g=d+4|0;h=d+8|0;k=d+40|0;i=g;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[k>>2]=h;h=d+48|0;i=d+44|0;f[i>>2]=h;f[h>>2]=0;f[d+52>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;mQ(a,b,d,-1.0,0.0,e);e=d+36|0;b=f[e>>2]|0;if(b|0?(a=b+12|0,b=f[a>>2]|0,f[a>>2]=b+-1,(b|0)==1):0)CR(d);f[e>>2]=0;e=d+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[g>>2]|0)>0){e=f[k>>2]|0;k=0;do{f[e+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[g>>2]|0))}g=f[i>>2]|0;if((g|0)==(h|0)){u=c;return}ZF(g);u=c;return}function JQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+32|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;e=a+16|0;g=a+48|0;h=a+12|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+56|0;f[a+52>>2]=e;f[e>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;e=a+72|0;g=a+104|0;h=a+68|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+112|0;f[a+108>>2]=e;f[e>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;e=a+128|0;g=a+160|0;h=a+124|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+168|0;f[a+164>>2]=e;h=e;i=h+56|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));h=f[b>>2]|0;i=f[(f[h>>2]|0)+64>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;Ah[i&255](h,d,b,a);u=c;return}function KQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+320|0;e=d+32|0;g=d;h=d+256|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;i=a+16|0;j=a+48|0;k=a+12|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+56|0;f[a+52>>2]=i;f[i>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;i=a+72|0;j=a+104|0;k=a+68|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+112|0;f[a+108>>2]=i;f[i>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;i=a+128|0;j=a+160|0;k=a+124|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+168|0;f[a+164>>2]=i;k=i;l=k+56|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[h>>2]=1124007936;i=h+4|0;j=h+8|0;m=h+40|0;k=i;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[m>>2]=j;j=h+48|0;k=h+44|0;f[k>>2]=j;f[j>>2]=0;f[h+52>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;DP(e,40364,0,b,c,h,1.0,1.0,g);EP(a,e)|0;fj(e);e=h+36|0;a=f[e>>2]|0;if(a|0?(g=a+12|0,a=f[g>>2]|0,f[g>>2]=a+-1,(a|0)==1):0)CR(h);f[e>>2]=0;e=h+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[i>>2]|0)>0){e=f[m>>2]|0;m=0;do{f[e+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[i>>2]|0))}i=f[k>>2]|0;if((i|0)==(j|0)){u=d;return}ZF(i);u=d;return}function LQ(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+96|0;e=d+32|0;g=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;h=a+16|0;i=a+48|0;j=a+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+56|0;f[a+52>>2]=h;f[h>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;h=a+72|0;i=a+104|0;j=a+68|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+112|0;f[a+108>>2]=h;f[h>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;h=a+128|0;i=a+160|0;j=a+124|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+168|0;f[a+164>>2]=h;j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[e>>2]=1124007936;h=e+4|0;i=e+8|0;l=e+40|0;j=h;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[l>>2]=i;i=e+48|0;j=e+44|0;f[j>>2]=i;f[i>>2]=0;f[e+52>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;mQ(a,b,e,c,0.0,g);g=e+36|0;b=f[g>>2]|0;if(b|0?(a=b+12|0,b=f[a>>2]|0,f[a>>2]=b+-1,(b|0)==1):0)CR(e);f[g>>2]=0;g=e+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[h>>2]|0)>0){g=f[l>>2]|0;l=0;do{f[g+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[h>>2]|0))}h=f[j>>2]|0;if((h|0)==(i|0)){u=d;return}ZF(h);u=d;return}function MQ(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+96|0;e=d+32|0;g=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;h=a+16|0;i=a+48|0;j=a+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+56|0;f[a+52>>2]=h;f[h>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;h=a+72|0;i=a+104|0;j=a+68|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+112|0;f[a+108>>2]=h;f[h>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;h=a+128|0;i=a+160|0;j=a+124|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+168|0;f[a+164>>2]=h;j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[e>>2]=1124007936;h=e+4|0;i=e+8|0;l=e+40|0;j=h;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[l>>2]=i;i=e+48|0;j=e+44|0;f[j>>2]=i;f[i>>2]=0;f[e+52>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;mQ(a,c,e,b,0.0,g);g=e+36|0;c=f[g>>2]|0;if(c|0?(a=c+12|0,c=f[a>>2]|0,f[a>>2]=c+-1,(c|0)==1):0)CR(e);f[g>>2]=0;g=e+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[h>>2]|0)>0){g=f[l>>2]|0;l=0;do{f[g+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[h>>2]|0))}h=f[j>>2]|0;if((h|0)==(i|0)){u=d;return}ZF(h);u=d;return}function NQ(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=f[b>>2]|0;Kh[f[(f[g>>2]|0)+72>>2]&15](g,b,c,a);return}function OQ(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+64|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[e>>2]=1124007936;g=e+4|0;h=e+8|0;k=e+40|0;i=g;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[k>>2]=h;h=e+48|0;i=e+44|0;f[i>>2]=h;f[h>>2]=0;f[e+52>>2]=0;gQ(a,47,c,e,b);c=e+36|0;a=f[c>>2]|0;if(a|0?(j=a+12|0,a=f[j>>2]|0,f[j>>2]=a+-1,(a|0)==1):0)CR(e);f[c>>2]=0;c=e+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[g>>2]|0)>0){c=f[k>>2]|0;k=0;do{f[c+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[g>>2]|0))}g=f[i>>2]|0;if((g|0)==(h|0)){u=d;return}ZF(g);u=d;return}function PQ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+368|0;g=e+32|0;h=e+312|0;i=e+256|0;j=e;f[h>>2]=1124007936;k=h+4|0;l=h+8|0;m=h+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=h+48|0;p=h+44|0;f[p>>2]=l;f[l>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;q=i+4|0;r=i+8|0;s=i+40|0;n=q;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[s>>2]=r;r=i+48|0;n=i+44|0;f[n>>2]=r;f[r>>2]=0;f[i+52>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;DP(g,41568,b,c,h,i,d,1.0,j);EP(a,g)|0;fj(g);g=i+36|0;a=f[g>>2]|0;if(a|0?(j=a+12|0,a=f[j>>2]|0,f[j>>2]=a+-1,(a|0)==1):0)CR(i);f[g>>2]=0;g=i+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[q>>2]|0)>0){g=f[s>>2]|0;s=0;do{f[g+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[q>>2]|0))}q=f[n>>2]|0;if((q|0)!=(r|0))ZF(q);q=h+36|0;r=f[q>>2]|0;if(r|0?(n=r+12|0,r=f[n>>2]|0,f[n>>2]=r+-1,(r|0)==1):0)CR(h);f[q>>2]=0;q=h+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[k>>2]|0)>0){q=f[m>>2]|0;m=0;do{f[q+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[p>>2]|0;if((k|0)==(l|0)){u=e;return}ZF(k);u=e;return}function QQ(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));PQ(a,0,b,c);return}function RQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));gQ(a,38,b,c,1.0);return}function SQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[b>>2]|0;if((c|0)==40356|(c|0)==39996){d=f[b+20>>2]|0;f[a>>2]=f[b+16>>2];f[a+4>>2]=d;return}if((c|0)==40364){d=f[b+16>>2]|0;f[a>>2]=f[b+76>>2];f[a+4>>2]=d;return}if((c|0)==40120){d=f[b+20>>2]|0;f[a>>2]=f[b+76>>2];f[a+4>>2]=d;return}if(!(f[225361]|0)){d=r$()|0;W$(d);if(!(f[225361]|0)){e=NYa(4)|0;f[e>>2]=41440;f[225361]=e}X$(d)}if((f[225361]|0)==(c|0)){c=f[b+48>>2]|0;d=f[c>>2]|0;f[a>>2]=f[c+4>>2];f[a+4>>2]=d;return}d=f[b>>2]|0;if(!d){f[a>>2]=0;f[a+4>>2]=0;return}else{fi[f[(f[d>>2]|0)+100>>2]&255](a,d,b);return}}function TQ(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+16|0;c=b;_$(c,41572);d=f[a>>2]|0;if(!(f[225361]|0)){e=r$()|0;W$(e);if(!(f[225361]|0)){g=NYa(4)|0;f[g>>2]=41440;f[225361]=g}X$(e)}if((f[225361]|0)!=(d|0)){d=f[a>>2]|0;if((d|0)!=41568)if(!d)h=-1;else h=$h[f[(f[d>>2]|0)+104>>2]&255](d,a)|0;else h=0}else h=f[a+8>>2]&4095;if(!(f[c+4>>2]|0)){u=b;return h|0}u=b;return h|0}function UQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;_$(d,41592);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;e=a+16|0;g=a+48|0;h=a+12|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+56|0;f[a+52>>2]=e;f[e>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;e=a+72|0;g=a+104|0;h=a+68|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+112|0;f[a+108>>2]=e;f[e>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;e=a+128|0;g=a+160|0;h=a+124|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+168|0;f[a+164>>2]=e;h=e;i=h+56|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));eQ(a,b,1.0);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function VQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;_$(e,41612);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));CP(a,c,b);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function WQ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+240|0;g=e+224|0;h=e;_$(g,41632);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;i=a+16|0;j=a+48|0;k=a+12|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+56|0;f[a+52>>2]=i;f[i>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;i=a+72|0;j=a+104|0;k=a+68|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+112|0;f[a+108>>2]=i;f[i>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;i=a+128|0;j=a+160|0;k=a+124|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+168|0;f[a+164>>2]=i;k=i;l=k+56|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));if((NS(c)|0)!=393216){do if((NS(c)|0)==65536){k=f[c+4>>2]|0;f[h>>2]=f[k>>2];l=h+4|0;i=k+4|0;f[l>>2]=f[i>>2];j=h+8|0;f[j>>2]=f[k+8>>2];f[h+12>>2]=f[k+12>>2];f[h+16>>2]=f[k+16>>2];f[h+20>>2]=f[k+20>>2];f[h+24>>2]=f[k+24>>2];f[h+28>>2]=f[k+28>>2];f[h+32>>2]=f[k+32>>2];m=f[k+36>>2]|0;f[h+36>>2]=m;f[h+40>>2]=j;j=h+48|0;n=h+44|0;f[n>>2]=j;f[j>>2]=0;f[h+52>>2]=0;if(m|0){j=m+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[k+44>>2]|0;j=f[n>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];break}else{f[l>>2]=0;BR(h,k);break}}else OR(h,c,-1);while(0);gQ(a,42,b,h,d);k=h+36|0;l=f[k>>2]|0;if(l|0?(i=l+12|0,l=f[i>>2]|0,f[i>>2]=l+-1,(l|0)==1):0)CR(h);f[k>>2]=0;k=h+16|0;l=h+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[l>>2]|0)>0){k=f[h+40>>2]|0;i=0;do{f[k+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[l>>2]|0))}l=f[h+44>>2]|0;if((l|0)!=(h+48|0))ZF(l)}else{l=f[c+4>>2]|0;c=f[l>>2]|0;i=f[(f[c>>2]|0)+68>>2]|0;AQ(h,b);Hh[i&15](c,h,l,a,d);fj(h)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function XQ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e+8|0;h=e;_$(g,41652);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;i=a+16|0;j=a+48|0;k=a+12|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+56|0;f[a+52>>2]=i;f[i>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;i=a+72|0;j=a+104|0;k=a+68|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+112|0;f[a+108>>2]=i;f[i>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;i=a+128|0;j=a+160|0;k=a+124|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+168|0;f[a+164>>2]=i;k=i;l=k+56|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[h>>2]=c;f[h+4>>2]=b;YQ(a,48,h,d,1.0);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function YQ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+432|0;h=g+32|0;i=g+376|0;j=g+312|0;k=g+320|0;l=g+256|0;m=g;if(!(f[225361]|0)){n=r$()|0;W$(n);if(!(f[225361]|0)){o=NYa(4)|0;f[o>>2]=41440;f[225361]=o}X$(n)}n=f[225361]|0;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];CN(i,j,d,-286331154,0);f[k>>2]=1124007936;d=k+4|0;j=k+8|0;c=k+40|0;o=d;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[c>>2]=j;j=k+48|0;q=k+44|0;f[q>>2]=j;f[j>>2]=0;f[k+52>>2]=0;f[l>>2]=1124007936;r=l+4|0;s=l+8|0;t=l+40|0;o=r;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[t>>2]=s;s=l+48|0;o=l+44|0;f[o>>2]=s;f[s>>2]=0;f[l+52>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;DP(h,n,b,i,k,l,e,0.0,m);EP(a,h)|0;fj(h);h=l+36|0;a=f[h>>2]|0;if(a|0?(m=a+12|0,a=f[m>>2]|0,f[m>>2]=a+-1,(a|0)==1):0)CR(l);f[h>>2]=0;h=l+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[r>>2]|0)>0){h=f[t>>2]|0;t=0;do{f[h+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[o>>2]|0;if((r|0)!=(s|0))ZF(r);r=k+36|0;s=f[r>>2]|0;if(s|0?(o=s+12|0,s=f[o>>2]|0,f[o>>2]=s+-1,(s|0)==1):0)CR(k);f[r>>2]=0;r=k+16|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[d>>2]|0)>0){r=f[c>>2]|0;c=0;do{f[r+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[q>>2]|0;if((d|0)!=(j|0))ZF(d);d=i+36|0;j=f[d>>2]|0;if(j|0?(q=j+12|0,j=f[q>>2]|0,f[q>>2]=j+-1,(j|0)==1):0)CR(i);f[d>>2]=0;d=i+16|0;j=i+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[j>>2]|0)>0){d=f[i+40>>2]|0;q=0;do{f[d+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)==(i+48|0)){u=g;return}ZF(j);u=g;return}function ZQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d+8|0;g=d;_$(e,41672);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;h=a+16|0;i=a+48|0;j=a+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+56|0;f[a+52>>2]=h;f[h>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;h=a+72|0;i=a+104|0;j=a+68|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+112|0;f[a+108>>2]=h;f[h>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;h=a+128|0;i=a+160|0;j=a+124|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+168|0;f[a+164>>2]=h;j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];YQ(a,48,g,c,1.0);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function _Q(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e+8|0;h=e;_$(g,41692);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;i=a+16|0;j=a+48|0;k=a+12|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+56|0;f[a+52>>2]=i;f[i>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;i=a+72|0;j=a+104|0;k=a+68|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+112|0;f[a+108>>2]=i;f[i>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;i=a+128|0;j=a+160|0;k=a+124|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+168|0;f[a+164>>2]=i;k=i;l=k+56|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[h>>2]=c;f[h+4>>2]=b;YQ(a,49,h,d,1.0);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function $Q(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d+8|0;g=d;_$(e,41712);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;h=a+16|0;i=a+48|0;j=a+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+56|0;f[a+52>>2]=h;f[h>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;h=a+72|0;i=a+104|0;j=a+68|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+112|0;f[a+108>>2]=h;f[h>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;h=a+128|0;i=a+160|0;j=a+124|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+168|0;f[a+164>>2]=h;j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];YQ(a,49,g,c,1.0);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function aR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e+8|0;h=e;_$(g,41732);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;i=a+16|0;j=a+48|0;k=a+12|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+56|0;f[a+52>>2]=i;f[i>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;i=a+72|0;j=a+104|0;k=a+68|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+112|0;f[a+108>>2]=i;f[i>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;i=a+128|0;j=a+160|0;k=a+124|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+168|0;f[a+164>>2]=i;k=i;l=k+56|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[h>>2]=c;f[h+4>>2]=b;YQ(a,73,h,d,1.0);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function bR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d+8|0;g=d;_$(e,41752);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;h=a+16|0;i=a+48|0;j=a+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+56|0;f[a+52>>2]=h;f[h>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;h=a+72|0;i=a+104|0;j=a+68|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+112|0;f[a+108>>2]=h;f[h>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;h=a+128|0;i=a+160|0;j=a+124|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+168|0;f[a+164>>2]=h;j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];YQ(a,73,g,c,1.0);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function cR(a){a=a|0;return}function dR(a,b,c){a=a|0;b=b|0;c=c|0;return}function eR(a,b){a=a|0;b=b|0;if(f[b+8>>2]|0)return;if(f[b+12>>2]|0)return;Gh[f[(f[a>>2]|0)+16>>2]&511](a,b);return}function fR(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;a=u;u=u+288|0;k=a+160|0;l=a+104|0;m=a+48|0;n=a+40|0;o=a+32|0;p=a;if(!c){u=a;return}q=f[c+16>>2]|0;a:do if((e|0)>0){c=e+-2|0;r=l+4|0;if(!h){s=0;while(1){t=g+(s<<2)|0;v=f[t>>2]|0;if((v|0)>-1)w=v;else{f[l>>2]=0;f[r>>2]=0;x=c$(l,27)|0;y=172413;z=x+27|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));j$(-215,l,172909,172446,77);d$(l);w=f[t>>2]|0}if(!w)break a;f[k+(s<<2)>>2]=w;s=s+1|0;if((s|0)>=(e|0)){A=q;B=14;break a}}}else{C=0;D=q}while(1){s=g+(C<<2)|0;v=f[s>>2]|0;if((v|0)>-1)E=v;else{f[l>>2]=0;f[r>>2]=0;x=c$(l,27)|0;y=172413;z=x+27|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));j$(-215,l,172909,172446,77);d$(l);E=f[s>>2]|0}if(!E)break a;if((C|0)>(c|0))F=1;else F=f[i+(C<<2)>>2]|0;t=D+(Y(F,f[h+(C<<2)>>2]|0)|0)|0;f[k+(C<<2)>>2]=E;C=C+1|0;if((C|0)>=(e|0)){A=t;B=14;break}else D=t}}else{A=q;B=14}while(0);if((B|0)==14){B=l+4|0;q=l+8|0;D=l+16|0;C=l+20|0;E=l+40|0;x=B;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[E>>2]=q;q=l+48|0;h=l+44|0;f[h>>2]=q;f[l+52>>2]=0;f[q>>2]=0;f[l>>2]=1124007936;f[D>>2]=A;f[C>>2]=A;pR(l,e,k,i,1);qR(l);i=m+4|0;A=m+8|0;C=m+16|0;F=m+20|0;y=m+40|0;x=i;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[y>>2]=A;A=m+48|0;x=m+44|0;f[x>>2]=A;f[m+52>>2]=0;f[A>>2]=0;f[m>>2]=1124007936;f[C>>2]=d;f[F>>2]=d;pR(m,e,k,j,1);qR(m);f[n>>2]=l;f[n+4>>2]=m;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;f[p+28>>2]=0;rR(p,n,0,o,2);n=f[p+20>>2]|0;j=p+16|0;if(f[j>>2]|0){k=o+4|0;e=0;do{K1a(f[k>>2]|0,f[o>>2]|0,n|0)|0;e=e+1|0;tR(p)|0}while(e>>>0<(f[j>>2]|0)>>>0)}j=m+36|0;e=f[j>>2]|0;if((e|0?(p=e+12|0,e=f[p>>2]|0,f[p>>2]=e+-1,(e|0)==1):0)?(e=f[j>>2]|0,e|0):0){f[j>>2]=0;p=f[e+4>>2]|0;if(!p){n=f[m+32>>2]|0;if(!n)G=sR()|0;else G=n}else G=p;Gh[f[(f[G>>2]|0)+24>>2]&511](G,e)}f[j>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[i>>2]|0)>0){C=f[y>>2]|0;y=0;do{f[C+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[i>>2]|0))}i=f[x>>2]|0;if((i|0)!=(A|0))ZF(i);i=l+36|0;A=f[i>>2]|0;if((A|0?(x=A+12|0,A=f[x>>2]|0,f[x>>2]=A+-1,(A|0)==1):0)?(A=f[i>>2]|0,A|0):0){f[i>>2]=0;x=f[A+4>>2]|0;if(!x){y=f[l+32>>2]|0;if(!y)H=sR()|0;else H=y}else H=x;Gh[f[(f[H>>2]|0)+24>>2]&511](H,A)}f[i>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[B>>2]|0)>0){D=f[E>>2]|0;E=0;do{f[D+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[B>>2]|0))}B=f[h>>2]|0;if((B|0)!=(q|0))ZF(B)}u=a;return}function gR(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;a=u;u=u+288|0;k=a+160|0;l=a+104|0;m=a+48|0;n=a+40|0;o=a+32|0;p=a;if(!c){u=a;return}q=f[c+16>>2]|0;a:do if((e|0)>0){c=e+-2|0;r=l+4|0;if(!h){s=0;while(1){t=g+(s<<2)|0;v=f[t>>2]|0;if((v|0)>-1)w=v;else{f[l>>2]=0;f[r>>2]=0;x=c$(l,27)|0;y=172413;z=x+27|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));j$(-215,l,172902,172446,108);d$(l);w=f[t>>2]|0}if(!w)break a;f[k+(s<<2)>>2]=w;s=s+1|0;if((s|0)>=(e|0)){A=q;B=14;break a}}}else{C=q;D=0}while(1){s=g+(D<<2)|0;v=f[s>>2]|0;if((v|0)>-1)E=v;else{f[l>>2]=0;f[r>>2]=0;x=c$(l,27)|0;y=172413;z=x+27|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));j$(-215,l,172902,172446,108);d$(l);E=f[s>>2]|0}if(!E)break a;if((D|0)>(c|0))F=1;else F=f[i+(D<<2)>>2]|0;t=C+(Y(F,f[h+(D<<2)>>2]|0)|0)|0;f[k+(D<<2)>>2]=E;D=D+1|0;if((D|0)>=(e|0)){A=t;B=14;break}else C=t}}else{A=q;B=14}while(0);if((B|0)==14){B=l+4|0;q=l+8|0;C=l+16|0;D=l+20|0;E=l+40|0;x=B;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[E>>2]=q;q=l+48|0;h=l+44|0;f[h>>2]=q;f[l+52>>2]=0;f[q>>2]=0;f[l>>2]=1124007936;f[C>>2]=d;f[D>>2]=d;pR(l,e,k,j,1);qR(l);j=m+4|0;d=m+8|0;D=m+16|0;F=m+20|0;y=m+40|0;x=j;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[y>>2]=d;d=m+48|0;x=m+44|0;f[x>>2]=d;f[m+52>>2]=0;f[d>>2]=0;f[m>>2]=1124007936;f[D>>2]=A;f[F>>2]=A;pR(m,e,k,i,1);qR(m);f[n>>2]=l;f[n+4>>2]=m;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;f[p+28>>2]=0;rR(p,n,0,o,2);n=f[p+20>>2]|0;i=p+16|0;if(f[i>>2]|0){k=o+4|0;e=0;do{K1a(f[k>>2]|0,f[o>>2]|0,n|0)|0;e=e+1|0;tR(p)|0}while(e>>>0<(f[i>>2]|0)>>>0)}i=m+36|0;e=f[i>>2]|0;if((e|0?(p=e+12|0,e=f[p>>2]|0,f[p>>2]=e+-1,(e|0)==1):0)?(e=f[i>>2]|0,e|0):0){f[i>>2]=0;p=f[e+4>>2]|0;if(!p){n=f[m+32>>2]|0;if(!n)G=sR()|0;else G=n}else G=p;Gh[f[(f[G>>2]|0)+24>>2]&511](G,e)}f[i>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[j>>2]|0)>0){D=f[y>>2]|0;y=0;do{f[D+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[j>>2]|0))}j=f[x>>2]|0;if((j|0)!=(d|0))ZF(j);j=l+36|0;d=f[j>>2]|0;if((d|0?(x=d+12|0,d=f[x>>2]|0,f[x>>2]=d+-1,(d|0)==1):0)?(d=f[j>>2]|0,d|0):0){f[j>>2]=0;x=f[d+4>>2]|0;if(!x){y=f[l+32>>2]|0;if(!y)H=sR()|0;else H=y}else H=x;Gh[f[(f[H>>2]|0)+24>>2]&511](H,d)}f[j>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[B>>2]|0)>0){C=f[E>>2]|0;E=0;do{f[C+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[B>>2]|0))}B=f[h>>2]|0;if((B|0)!=(q|0))ZF(B)}u=a;return}function hR(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;l=u;u=u+304|0;a=l+288|0;m=l+160|0;n=l+104|0;o=l+48|0;p=l+40|0;q=l+32|0;r=l;_$(a,41804);if((c|0)!=0&(d|0)!=0){s=f[c+16>>2]|0;c=f[d+16>>2]|0;a:do if((e|0)>0){d=(j|0)==0;t=e+-2|0;v=n+4|0;if(!h){w=c;x=0;while(1){y=g+(x<<2)|0;z=f[y>>2]|0;if((z|0)>-1)A=z;else{f[n>>2]=0;f[v>>2]=0;B=c$(n,27)|0;C=172413;D=B+27|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));j$(-215,n,172441,172446,141);d$(n);A=f[y>>2]|0}if(!A)break a;if(d)E=w;else{if((x|0)>(t|0))F=1;else F=f[k+(x<<2)>>2]|0;E=w+(Y(F,f[j+(x<<2)>>2]|0)|0)|0}f[m+(x<<2)>>2]=A;x=x+1|0;if((x|0)>=(e|0)){G=E;H=s;I=22;break a}else w=E}}else{J=c;K=0;L=s}while(1){w=g+(K<<2)|0;x=f[w>>2]|0;if((x|0)>-1)M=x;else{f[n>>2]=0;f[v>>2]=0;B=c$(n,27)|0;C=172413;D=B+27|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));j$(-215,n,172441,172446,141);d$(n);M=f[w>>2]|0}if(!M)break a;y=(K|0)>(t|0);if(y)N=1;else N=f[i+(K<<2)>>2]|0;x=L+(Y(N,f[h+(K<<2)>>2]|0)|0)|0;if(d)O=J;else{if(y)P=1;else P=f[k+(K<<2)>>2]|0;O=J+(Y(P,f[j+(K<<2)>>2]|0)|0)|0}f[m+(K<<2)>>2]=M;K=K+1|0;if((K|0)>=(e|0)){G=O;H=x;I=22;break}else{J=O;L=x}}}else{G=c;H=s;I=22}while(0);if((I|0)==22){I=n+4|0;s=n+8|0;c=n+16|0;L=n+20|0;O=n+40|0;B=I;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[O>>2]=s;s=n+48|0;J=n+44|0;f[J>>2]=s;f[n+52>>2]=0;f[s>>2]=0;f[n>>2]=1124007936;f[c>>2]=H;f[L>>2]=H;pR(n,e,m,i,1);qR(n);i=o+4|0;H=o+8|0;L=o+16|0;K=o+20|0;M=o+40|0;B=i;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[M>>2]=H;H=o+48|0;B=o+44|0;f[B>>2]=H;f[o+52>>2]=0;f[H>>2]=0;f[o>>2]=1124007936;f[L>>2]=G;f[K>>2]=G;pR(o,e,m,k,1);qR(o);f[p>>2]=n;f[p+4>>2]=o;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;f[r+24>>2]=0;f[r+28>>2]=0;rR(r,p,0,q,2);p=f[r+20>>2]|0;k=r+16|0;if(f[k>>2]|0){m=q+4|0;e=0;do{K1a(f[m>>2]|0,f[q>>2]|0,p|0)|0;e=e+1|0;tR(r)|0}while(e>>>0<(f[k>>2]|0)>>>0)}k=o+36|0;e=f[k>>2]|0;if((e|0?(r=e+12|0,e=f[r>>2]|0,f[r>>2]=e+-1,(e|0)==1):0)?(e=f[k>>2]|0,e|0):0){f[k>>2]=0;r=f[e+4>>2]|0;if(!r){p=f[o+32>>2]|0;if(!p)Q=sR()|0;else Q=p}else Q=r;Gh[f[(f[Q>>2]|0)+24>>2]&511](Q,e)}f[k>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[i>>2]|0)>0){L=f[M>>2]|0;M=0;do{f[L+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[i>>2]|0))}i=f[B>>2]|0;if((i|0)!=(H|0))ZF(i);i=n+36|0;H=f[i>>2]|0;if((H|0?(B=H+12|0,H=f[B>>2]|0,f[B>>2]=H+-1,(H|0)==1):0)?(H=f[i>>2]|0,H|0):0){f[i>>2]=0;B=f[H+4>>2]|0;if(!B){M=f[n+32>>2]|0;if(!M)R=sR()|0;else R=M}else R=B;Gh[f[(f[R>>2]|0)+24>>2]&511](R,H)}f[i>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[I>>2]|0)>0){c=f[O>>2]|0;O=0;do{f[c+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[I>>2]|0))}I=f[J>>2]|0;if((I|0)!=(s|0))ZF(I)}}if(!(f[a+4>>2]|0)){u=l;return}u=l;return}function iR(a,c){a=a|0;c=c|0;if((b[374976]|0)==0?u1a(374976)|0:0)f[225372]=41780;return 901488}function jR(a){a=a|0;return -1}function kR(a){a=a|0;return -1}function lR(a,b){a=a|0;b=b|0;return}function mR(a){a=a|0;return}function nR(a){a=a|0;return}function oR(a){a=a|0;PYa(a);return}function pR(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=u;u=u+16|0;i=h;if(c>>>0>=33){f[i>>2]=0;f[i+4>>2]=0;j=c$(i,25)|0;k=200337;l=j+25|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,i,200363,172446,284);d$(i)}m=a+4|0;if((f[m>>2]|0)!=(c|0)){n=a+44|0;o=f[n>>2]|0;p=a+48|0;if((o|0)!=(p|0)){ZF(o);f[n>>2]=p;f[a+40>>2]=a+8}if((c|0)>2){p=YF(c<<3|4)|0;f[n>>2]=p;n=p+(c<<2)+4|0;f[a+40>>2]=n;f[n+-4>>2]=c;f[a+12>>2]=-1;f[a+8>>2]=-1}}f[m>>2]=c;if(!d){u=h;return}n=f[a>>2]|0;p=n&7;o=(n>>>3&511)+1<<(47696>>>(p<<1)&3);n=1212424721>>>(p<<2)&15;p=c+-1|0;if((c|0)<=0){u=h;return}q=a+40|0;r=a+44|0;s=i+4|0;t=i+4|0;v=i+4|0;if(!e){w=p;x=o;while(1){y=f[d+(w<<2)>>2]|0;if((y|0)<=-1){f[i>>2]=0;f[v>>2]=0;z=c$(i,6)|0;b[z>>0]=b[200371]|0;b[z+1>>0]=b[200372]|0;b[z+2>>0]=b[200373]|0;b[z+3>>0]=b[200374]|0;b[z+4>>0]=b[200375]|0;b[z+5>>0]=b[200376]|0;j$(-215,i,200363,172446,310);d$(i)}f[(f[q>>2]|0)+(w<<2)>>2]=y;if(g){f[(f[r>>2]|0)+(w<<2)>>2]=x;z=W1a(y|0,((y|0)<0)<<31>>31|0,x|0,0)|0;if((z|0)==(z|0)&(J|0)==0)A=z;else{f[i>>2]=0;f[s>>2]=0;j=c$(i,51)|0;k=200378;l=j+51|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-211,i,200363,172446,327);d$(i);A=z}}else A=x;if((w|0)>0){w=w+-1|0;x=A}else break}}else{A=p;while(1){x=f[d+(A<<2)>>2]|0;if((x|0)<=-1){f[i>>2]=0;f[v>>2]=0;w=c$(i,6)|0;b[w>>0]=b[200371]|0;b[w+1>>0]=b[200372]|0;b[w+2>>0]=b[200373]|0;b[w+3>>0]=b[200374]|0;b[w+4>>0]=b[200375]|0;b[w+5>>0]=b[200376]|0;j$(-215,i,200363,172446,310);d$(i)}f[(f[q>>2]|0)+(A<<2)>>2]=x;x=e+(A<<2)|0;if(((f[x>>2]|0)>>>0)%(n>>>0)|0|0){f[i>>2]=0;f[t>>2]=0;j=c$(i,31)|0;k=172705;l=j+31|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-13,i,200363,172446,317);d$(i)}if((A|0)<(p|0))B=f[x>>2]|0;else B=o;f[(f[r>>2]|0)+(A<<2)>>2]=B;if((A|0)>0)A=A+-1|0;else break}}if((c|0)!=1){u=h;return}f[m>>2]=2;f[a+12>>2]=1;f[(f[a+44>>2]|0)+4>>2]=o;u=h;return}function qR(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=f[a+4>>2]|0;c=f[a+40>>2]|0;a:do if((b|0)>0){d=0;while(1){if((f[c+(d<<2)>>2]|0)>1){e=d;break a}g=d+1|0;if((g|0)<(b|0))d=g;else{e=g;break}}}else e=0;while(0);d=f[a+44>>2]|0;g=b;do{h=g;g=g+-1|0;if((g|0)<=(e|0))break;i=Y(f[c+(g<<2)>>2]|0,f[d+(g<<2)>>2]|0)|0}while(i>>>0>=(f[d+(h+-2<<2)>>2]|0)>>>0);h=f[c>>2]|0;i=W1a(h|0,((h|0)<0)<<31>>31|0,f[d>>2]|0,0)|0;h=f[a>>2]|0;f[a>>2]=(g|0)<=(e|0)&((i|0)==(i|0)&(J|0)==0)?h|16384:h&-16385;if((b|0)>2){f[a+12>>2]=-1;f[a+8>>2]=-1}h=f[a+36>>2]|0;if(!h)j=a+16|0;else{i=f[h+16>>2]|0;h=a+16|0;f[h>>2]=i;f[a+20>>2]=i;j=h}h=f[j>>2]|0;if(!h){f[a+28>>2]=0;f[a+24>>2]=0;return}j=f[c>>2]|0;i=f[d>>2]|0;e=(f[a+20>>2]|0)+(Y(i,j)|0)|0;f[a+28>>2]=e;if((j|0)<=0){f[a+24>>2]=e;return}e=b+-1|0;g=h+(Y(f[d+(e<<2)>>2]|0,f[c+(e<<2)>>2]|0)|0)|0;h=a+24|0;f[h>>2]=g;if((b|0)<=1)return;b=g+(Y(i,j+-1|0)|0)|0;if((e|0)==1)k=b;else{j=b;b=1;while(1){i=j+(Y(f[d+(b<<2)>>2]|0,(f[c+(b<<2)>>2]|0)+-1|0)|0)|0;b=b+1|0;if((b|0)==(e|0)){k=i;break}else j=i}}f[h>>2]=k;return}function rR(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;h=u;u=u+64|0;i=h;if(!((c|0)!=0?(d|0)!=0|(e|0)!=0:0)){f[i>>2]=0;f[i+4>>2]=0;j=c$(i,29)|0;k=172589;l=j+29|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,i,225905,172446,4727);d$(i)}f[a>>2]=c;m=a+8|0;f[m>>2]=e;e=a+4|0;f[e>>2]=d;d=a+12|0;f[d>>2]=g;n=a+16|0;f[n>>2]=0;o=a+20|0;f[o>>2]=0;if((g|0)<0){p=0;while(1)if(!(f[c+(p<<2)>>2]|0))break;else p=p+1|0;f[d>>2]=p;if((p|0)<1001)q=p;else{f[i>>2]=0;f[i+4>>2]=0;j=c$(i,15)|0;k=172619;l=j+15|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,i,225905,172446,4742);d$(i);q=f[d>>2]|0}}else q=g;g=a+24|0;f[g>>2]=0;if((q|0)>0){p=i+4|0;c=i+4|0;r=i+4|0;s=-1;t=0;v=0;w=-1;while(1){x=f[(f[a>>2]|0)+(v<<2)>>2]|0;if(!x){f[i>>2]=0;f[p>>2]=0;j=c$(i,14)|0;k=172635;l=j+14|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,i,225905,172446,4749);d$(i);y=f[(f[a>>2]|0)+(v<<2)>>2]|0}else y=x;z=f[m>>2]|0;if(!z)A=y+16|0;else{B=y+16|0;f[z+(v<<2)>>2]=f[B>>2];A=B}if(f[A>>2]|0){a:do if((w|0)<0){B=f[y+4>>2]|0;if((B|0)>0){z=f[y+40>>2]|0;C=0;while(1){if((f[z+(C<<2)>>2]|0)>1){D=B;E=C;F=v;break a}G=C+1|0;if((G|0)<(B|0))C=G;else{D=B;E=G;F=v;break}}}else{D=B;E=0;F=v}}else{C=f[y+40>>2]|0;z=f[C+-4>>2]|0;G=f[(f[(f[a>>2]|0)+(w<<2)>>2]|0)+40>>2]|0;b:do if((z|0)==(f[G+-4>>2]|0)){if((z|0)==2){if((f[C>>2]|0)!=(f[G>>2]|0))break;if((f[C+4>>2]|0)==(f[G+4>>2]|0)){D=s;E=t;F=w;break a}else break}if((z|0)>0)H=0;else{D=s;E=t;F=w;break a}while(1){if((f[C+(H<<2)>>2]|0)!=(f[G+(H<<2)>>2]|0))break b;H=H+1|0;if((H|0)>=(z|0)){D=s;E=t;F=w;break a}}}while(0);f[i>>2]=0;f[r>>2]=0;j=c$(i,26)|0;k=172650;l=j+26|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,i,225905,172446,4769);d$(i);D=s;E=t;F=w}while(0);if(!(f[y>>2]&16384)){x=D+-1|0;z=y+44|0;G=f[z>>2]|0;C=f[y+4>>2]|0;if((C|0)>0)I=f[G+(C+-1<<2)>>2]|0;else I=0;if((f[G+(x<<2)>>2]|0)!=(I|0)){f[i>>2]=0;f[c>>2]=0;j=c$(i,27)|0;k=172677;l=j+27|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,i,225905,172446,4773);d$(i)}G=y+40|0;C=x;while(1){if((C|0)<=(E|0))break;B=f[z>>2]|0;K=Y(f[(f[G>>2]|0)+(C<<2)>>2]|0,f[B+(C<<2)>>2]|0)|0;L=C+-1|0;if(K>>>0<(f[B+(L<<2)>>2]|0)>>>0)break;else C=L}G=f[g>>2]|0;f[g>>2]=(G|0)<(C|0)?C:G;M=D;N=E;O=F}else{M=D;N=E;O=F}}else{M=s;N=t;O=w}v=v+1|0;P=f[d>>2]|0;if((v|0)>=(P|0))break;else{s=M;t=N;w=O}}if((O|0)>-1){w=M+-1|0;M=f[(f[(f[a>>2]|0)+(O<<2)>>2]|0)+40>>2]|0;O=f[g>>2]|0;t=f[M+(w<<2)>>2]|0;s=w;while(1){f[o>>2]=t;if((s|0)<=(O|0))break;w=s+-1|0;v=f[M+(w<<2)>>2]|0;t=W1a(v|0,((v|0)<0)<<31>>31|0,t|0,0)|0;if(!((t|0)==(t|0)&(J|0)==(((t|0)<0)<<31>>31|0)))break;else s=w}t=(s|0)==(N|0)?0:s;f[g>>2]=t;f[n>>2]=1;if((t|0)>0){s=1;N=t;do{t=N;N=N+-1|0;s=Y(s,f[M+(N<<2)>>2]|0)|0;f[n>>2]=s}while((t|0)>1);Q=P}else Q=P}else{R=P;S=45}}else{R=q;S=45}if((S|0)==45){f[g>>2]=0;Q=R}f[a+28>>2]=0;if(!((f[e>>2]|0)!=0&(Q|0)>0)){u=h;return}Q=i+4|0;R=i+4|0;g=i+8|0;S=i+40|0;q=i+48|0;P=i+44|0;s=i+52|0;n=i+36|0;N=i+16|0;M=i+32|0;t=i+36|0;O=i+16|0;w=i+4|0;v=i+40|0;F=i+44|0;E=i+48|0;D=i+32|0;y=0;do{c=f[(f[a>>2]|0)+(y<<2)>>2]|0;if(!c){f[i>>2]=0;f[Q>>2]=0;j=c$(i,14)|0;k=172635;l=j+14|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,i,225905,172446,4810);d$(i);T=f[(f[a>>2]|0)+(y<<2)>>2]|0}else T=c;C=f[T+16>>2]|0;if(!C){f[i>>2]=1124007936;j=R;l=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(l|0));f[S>>2]=g;f[P>>2]=q;f[q>>2]=0;f[s>>2]=0;yR((f[e>>2]|0)+(y*56|0)|0,i)|0;c=f[n>>2]|0;if((c|0?(I=c+12|0,c=f[I>>2]|0,f[I>>2]=c+-1,(c|0)==1):0)?(c=f[n>>2]|0,c|0):0){f[n>>2]=0;I=f[c+4>>2]|0;if(!I){r=f[M>>2]|0;if(!r)U=sR()|0;else U=r}else U=I;Gh[f[(f[U>>2]|0)+24>>2]&511](U,c)}f[n>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[R>>2]|0)>0){c=f[S>>2]|0;I=0;do{f[c+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[R>>2]|0))}I=f[P>>2]|0;if((I|0)!=(q|0))ZF(I)}else{$i(i,1,f[o>>2]|0,f[T>>2]&4095,C,0);yR((f[e>>2]|0)+(y*56|0)|0,i)|0;I=f[t>>2]|0;if((I|0?(c=I+12|0,I=f[c>>2]|0,f[c>>2]=I+-1,(I|0)==1):0)?(I=f[t>>2]|0,I|0):0){f[t>>2]=0;c=f[I+4>>2]|0;if(!c){r=f[D>>2]|0;if(!r)V=sR()|0;else V=r}else V=c;Gh[f[(f[V>>2]|0)+24>>2]&511](V,I)}f[t>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[w>>2]|0)>0){I=f[v>>2]|0;c=0;do{f[I+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[w>>2]|0))}c=f[F>>2]|0;if((c|0)!=(E|0))ZF(c)}y=y+1|0}while((y|0)<(f[d>>2]|0));u=h;return}function sR(){var a=0,b=0,c=0,d=0;if(f[225373]|0){a=f[225373]|0;return a|0}b=r$()|0;W$(b);if(!(f[225373]|0)){if(!(f[225374]|0)){c=r$()|0;W$(c);if(!(f[225374]|0)){d=NYa(4)|0;f[d>>2]=41832;f[225374]=d}X$(c)}f[225373]=f[225374]}X$(b);a=f[225373]|0;return a|0}function tR(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=a+28|0;c=f[b>>2]|0;if(c>>>0>=((f[a+16>>2]|0)+-1|0)>>>0)return a|0;d=c+1|0;f[b>>2]=d;b=f[a+24>>2]|0;if((b|0)!=1){c=f[a+12>>2]|0;if((c|0)<=0)return a|0;e=a+8|0;g=a+4|0;h=(d|0)>0&(b|0)>0;i=0;do{j=f[(f[a>>2]|0)+(i<<2)>>2]|0;k=f[j+16>>2]|0;if(k|0){if(h){l=f[j+40>>2]|0;m=f[j+44>>2]|0;j=d;n=k;o=b;while(1){p=o;o=o+-1|0;q=f[l+(o<<2)>>2]|0;r=j;j=(j|0)/(q|0)|0;s=r-(Y(j,q)|0)|0;q=n+(Y(s,f[m+(o<<2)>>2]|0)|0)|0;if(!((j|0)>0&(p|0)>1)){t=q;break}else n=q}}else t=k;n=f[e>>2]|0;if(n|0)f[n+(i<<2)>>2]=t;n=f[g>>2]|0;if(n|0)f[n+(i*56|0)+16>>2]=t}i=i+1|0}while((i|0)<(c|0));return a|0}c=a+8|0;i=f[c>>2]|0;a:do if(i|0?(t=f[a+12>>2]|0,(t|0)>0):0){g=i;e=0;while(1){b=g+(e<<2)|0;if(f[b>>2]|0){h=f[(f[a>>2]|0)+(e<<2)>>2]|0;n=(f[h+16>>2]|0)+(Y(d,f[f[h+44>>2]>>2]|0)|0)|0;f[b>>2]=n}n=e+1|0;if((n|0)>=(t|0))break a;g=f[c>>2]|0;e=n}}while(0);c=f[a+4>>2]|0;if(!c)return a|0;i=f[a+12>>2]|0;if((i|0)<=0)return a|0;e=0;do{g=c+(e*56|0)+16|0;if(f[g>>2]|0){t=f[(f[a>>2]|0)+(e<<2)>>2]|0;k=(f[t+16>>2]|0)+(Y(d,f[f[t+44>>2]>>2]|0)|0)|0;f[g>>2]=k}e=e+1|0}while((e|0)<(i|0));return a|0}function uR(a){a=a|0;PYa(a);return}function vR(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;j=u;u=u+16|0;i=j;k=(e>>>3&511)+1<<(47696>>>(e<<1&14)&3);e=c+-1|0;a:do if((c|0)>0){l=i+4|0;if(!h){m=e;n=k;while(1){o=Y(f[d+(m<<2)>>2]|0,n)|0;if((m|0)>0){m=m+-1|0;n=o}else{p=o;break a}}}if(!g){n=e;m=k;while(1){f[h+(n<<2)>>2]=m;o=Y(f[d+(n<<2)>>2]|0,m)|0;if((n|0)>0){n=n+-1|0;m=o}else{p=o;break a}}}else{q=e;r=k}while(1){m=h+(q<<2)|0;n=f[m>>2]|0;if((n|0)!=2147483647)if(r>>>0>n>>>0){f[i>>2]=0;f[l>>2]=0;o=c$(i,16)|0;s=172540;t=o+16|0;do{b[o>>0]=b[s>>0]|0;o=o+1|0;s=s+1|0}while((o|0)<(t|0));j$(-215,i,172557,172446,183);d$(i);v=f[m>>2]|0}else v=n;else{f[m>>2]=r;v=r}s=Y(f[d+(q<<2)>>2]|0,v)|0;if((q|0)>0){q=q+-1|0;r=s}else{p=s;break}}}else p=k;while(0);k=(g|0)!=0;if(k)w=g;else w=YF(p)|0;g=NYa(52)|0;c0(g,a);f[g+20>>2]=w;f[g+16>>2]=w;f[g+24>>2]=p;if(!k){u=j;return g|0}k=g+28|0;f[k>>2]=f[k>>2]|32;u=j;return g|0}function wR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return (b|0)!=0|0}function xR(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;a=u;u=u+16|0;d=a;if(!c){u=a;return}if(f[c+8>>2]|0){f[d>>2]=0;f[d+4>>2]=0;e=c$(d,17)|0;g=172494;h=e+17|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));j$(-215,d,172512,172446,212);d$(d)}if(f[c+12>>2]|0){f[d>>2]=0;f[d+4>>2]=0;e=c$(d,16)|0;g=172523;h=e+16|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));j$(-215,d,172512,172446,213);d$(d)}if(!(f[c+28>>2]&32)){d=c+20|0;ZF(f[d>>2]|0);f[d>>2]=0}d0(c);PYa(c);u=a;return}function yR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;if((a|0)==(b|0))return a|0;c=b+36|0;d=f[c>>2]|0;if(d|0){e=d+12|0;f[e>>2]=(f[e>>2]|0)+1}e=a+36|0;d=f[e>>2]|0;if((d|0?(g=d+12|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)?(d=f[e>>2]|0,d|0):0){f[e>>2]=0;g=f[d+4>>2]|0;if(!g){h=f[a+32>>2]|0;if(!h)i=sR()|0;else i=h}else i=g;Gh[f[(f[i>>2]|0)+24>>2]&511](i,d)}f[e>>2]=0;d=a+16|0;i=a+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[i>>2]|0)>0){g=f[a+40>>2]|0;h=0;do{f[g+(h<<2)>>2]=0;h=h+1|0;j=f[i>>2]|0}while((h|0)<(j|0));f[a>>2]=f[b>>2];if((j|0)<3)k=17;else{l=f[b+4>>2]|0;k=19}}else{f[a>>2]=f[b>>2];k=17}if((k|0)==17){j=f[b+4>>2]|0;if((j|0)<3){f[i>>2]=j;f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];h=f[b+44>>2]|0;g=f[a+44>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{l=j;k=19}}if((k|0)==19?(pR(a,l,0,0,0),(f[i>>2]|0)>0):0){l=f[b+40>>2]|0;k=f[a+40>>2]|0;j=f[b+44>>2]|0;h=f[a+44>>2]|0;g=0;do{f[k+(g<<2)>>2]=f[l+(g<<2)>>2];f[h+(g<<2)>>2]=f[j+(g<<2)>>2];g=g+1|0}while((g|0)<(f[i>>2]|0))}f[d>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];f[e>>2]=f[c>>2];return a|0}function zR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=c;c=a+4|0;d=b+4|0;e=f[c>>2]|0;f[c>>2]=f[d>>2];f[d>>2]=e;e=a+8|0;d=b+8|0;c=f[e>>2]|0;f[e>>2]=f[d>>2];f[d>>2]=c;c=a+12|0;g=b+12|0;h=f[c>>2]|0;f[c>>2]=f[g>>2];f[g>>2]=h;h=a+16|0;g=b+16|0;c=f[h>>2]|0;f[h>>2]=f[g>>2];f[g>>2]=c;c=a+20|0;g=b+20|0;h=f[c>>2]|0;f[c>>2]=f[g>>2];f[g>>2]=h;h=a+24|0;g=b+24|0;c=f[h>>2]|0;f[h>>2]=f[g>>2];f[g>>2]=c;c=a+28|0;g=b+28|0;h=f[c>>2]|0;f[c>>2]=f[g>>2];f[g>>2]=h;h=a+32|0;g=b+32|0;c=f[h>>2]|0;f[h>>2]=f[g>>2];f[g>>2]=c;c=a+36|0;g=b+36|0;h=f[c>>2]|0;f[c>>2]=f[g>>2];f[g>>2]=h;h=a+40|0;g=b+40|0;c=f[h>>2]|0;f[h>>2]=f[g>>2];f[g>>2]=c;c=a+44|0;i=b+44|0;j=f[c>>2]|0;f[c>>2]=f[i>>2];f[i>>2]=j;k=a+48|0;l=b+48|0;m=f[k>>2]|0;f[k>>2]=f[l>>2];f[l>>2]=m;m=a+52|0;a=b+52|0;b=f[m>>2]|0;f[m>>2]=f[a>>2];f[a>>2]=b;if((f[c>>2]|0)==(l|0)){f[c>>2]=k;f[h>>2]=e;n=f[i>>2]|0}else n=j;if((n|0)!=(k|0))return;f[i>>2]=l;f[g>>2]=d;return}function AR(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+144|0;h=g+8|0;i=g;if(!(c>>>0<33&(d|0)!=0)){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,27)|0;k=200608;l=j+27|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,h,357830,172446,390);d$(h)}k=e&4095;e=a+16|0;do if(f[e>>2]|0){j=f[a+4>>2]|0;if((j|0)!=(c|0)?!((c|0)==1&(j|0)<3):0)break;if((k|0)==(f[a>>2]&4095|0)){if((c|0)==2)if((f[a+8>>2]|0)==(f[d>>2]|0)?(f[a+12>>2]|0)==(f[d+4>>2]|0):0){u=g;return}else m=11;else if((c|0)>0)m=11;else n=0;a:do if((m|0)==11){j=f[a+40>>2]|0;l=0;while(1){if((f[j+(l<<2)>>2]|0)!=(f[d+(l<<2)>>2]|0)){n=l;break a}o=l+1|0;if((o|0)<(c|0))l=o;else{n=o;break}}}while(0);if((n|0)==(c|0)){if((c|0)>1){u=g;return}if((f[(f[a+40>>2]|0)+4>>2]|0)==1){u=g;return}}}}while(0);n=a+40|0;if((f[n>>2]|0)==(d|0)){if((c|0)>0)K1a(h|0,d|0,c<<2|0)|0;p=h}else p=d;d=a+36|0;h=f[d>>2]|0;if((h|0?(m=h+12|0,h=f[m>>2]|0,f[m>>2]=h+-1,(h|0)==1):0)?(h=f[d>>2]|0,h|0):0){f[d>>2]=0;m=f[h+4>>2]|0;if(!m){l=f[a+32>>2]|0;if(!l)q=sR()|0;else q=l}else q=m;Gh[f[(f[q>>2]|0)+24>>2]&511](q,h)}f[d>>2]=0;h=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[h>>2]|0)>0){e=f[n>>2]|0;q=0;do{f[e+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[h>>2]|0))}if(c|0){f[a>>2]=k|1124007936;pR(a,c,p,0,1);p=f[h>>2]|0;if((p|0)<3)r=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{c=f[n>>2]|0;q=0;e=1;while(1){m=Y(f[c+(q<<2)>>2]|0,e)|0;q=q+1|0;if((q|0)==(p|0)){r=m;break}else e=m}}if(r|0){r=f[a+32>>2]|0;e=sR()|0;p=(r|0)==0?e:r;r=a+44|0;e=Oi[f[(f[p>>2]|0)+8>>2]&15](p,f[h>>2]|0,f[n>>2]|0,k,0,f[r>>2]|0,0,0)|0;f[d>>2]=e;if(!e){f[i>>2]=0;f[i+4>>2]=0;e=c$(i,6)|0;b[e>>0]=b[200636]|0;b[e+1>>0]=b[200637]|0;b[e+2>>0]=b[200638]|0;b[e+3>>0]=b[200639]|0;b[e+4>>0]=b[200640]|0;b[e+5>>0]=b[200641]|0;j$(-215,i,357830,172446,430);d$(i)}e=f[a>>2]|0;if((f[(f[r>>2]|0)+((f[h>>2]|0)+-1<<2)>>2]|0)!=((e>>>3&511)+1<<(47696>>>(e<<1&14)&3)|0)){f[i>>2]=0;f[i+4>>2]=0;K1a(c$(i,146)|0,200643,146)|0;j$(-215,i,357830,172446,438);d$(i)}}i=f[d>>2]|0;if(i|0){d=i+12|0;f[d>>2]=(f[d>>2]|0)+1}qR(a)}u=g;return}function BR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;pR(a,f[b+4>>2]|0,0,0,0);c=a+4|0;if((f[c>>2]|0)<=0)return;d=f[b+40>>2]|0;e=f[a+40>>2]|0;g=f[b+44>>2]|0;b=f[a+44>>2]|0;a=0;do{f[e+(a<<2)>>2]=f[d+(a<<2)>>2];f[b+(a<<2)>>2]=f[g+(a<<2)>>2];a=a+1|0}while((a|0)<(f[c>>2]|0));return}function CR(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+36|0;c=f[b>>2]|0;if(!c)return;f[b>>2]=0;b=f[c+4>>2]|0;if(!b){d=f[a+32>>2]|0;if(!d)e=sR()|0;else e=d}else e=b;Gh[f[(f[e>>2]|0)+24>>2]&511](e,c);return}function DR(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=u;u=u+1152|0;h=g+56|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+12|0;m=a+16|0;n=a+32|0;o=a+36|0;p=a+40|0;q=j;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[p>>2]=k;s=a+48|0;t=a+44|0;f[t>>2]=s;f[a+52>>2]=0;f[s>>2]=0;v=c+4|0;w=f[v>>2]|0;if((w|0)>1)x=w;else{f[h>>2]=0;f[h+4>>2]=0;q=c$(h,11)|0;y=200790;r=q+11|0;do{b[q>>0]=b[y>>0]|0;q=q+1|0;y=y+1|0}while((q|0)<(r|0));j$(-215,h,358250,172446,474);d$(h);x=f[v>>2]|0}if((x|0)>2){w=h+8|0;F1a(w|0,0,1088)|0;f[h>>2]=w;z=h+4|0;f[z>>2]=x;if(x>>>0>136){A=OYa(x>>>0>536870911?-1:x<<3)|0;F1a(A|0,0,x<<3|0)|0;f[h>>2]=A;B=A}else B=w;A=d;x=f[A+4>>2]|0;C=B;f[C>>2]=f[A>>2];f[C+4>>2]=x;x=f[h>>2]|0;C=e;A=f[C+4>>2]|0;B=x+8|0;f[B>>2]=f[C>>2];f[B+4>>2]=A;if((f[v>>2]|0)>2){A=x;B=2;while(1){C=A+(B<<3)|0;f[C>>2]=-2147483648;f[C+4>>2]=2147483647;B=B+1|0;C=f[h>>2]|0;if((B|0)>=(f[v>>2]|0)){D=C;break}else A=C}}else D=x;ER(i,c,D);yR(a,i)|0;D=i+36|0;x=f[D>>2]|0;if((x|0?(A=x+12|0,x=f[A>>2]|0,f[A>>2]=x+-1,(x|0)==1):0)?(x=f[D>>2]|0,x|0):0){f[D>>2]=0;A=f[x+4>>2]|0;if(!A){v=f[i+32>>2]|0;if(!v)E=sR()|0;else E=v}else E=A;Gh[f[(f[E>>2]|0)+24>>2]&511](E,x)}f[D>>2]=0;D=i+16|0;x=i+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[x>>2]|0)>0){D=f[i+40>>2]|0;E=0;do{f[D+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[x>>2]|0))}x=f[i+44>>2]|0;if((x|0)!=(i+48|0))ZF(x);x=f[h>>2]|0;if((x|0)!=(w|0)){if(x|0)QYa(x);f[h>>2]=w;f[z>>2]=136}u=g;return}yR(a,c)|0;z=f[d>>2]|0;w=d+4|0;x=f[w>>2]|0;if((z|0)!=-2147483648|(x|0)!=2147483647?(z|0?1:(x|0)!=(f[k>>2]|0)):0){if(!((z|0)<0|(z|0)>(x|0))?(x|0)<=(f[c+8>>2]|0):0){F=z;G=x}else{f[h>>2]=0;f[h+4>>2]=0;q=c$(h,83)|0;y=200802;r=q+83|0;do{b[q>>0]=b[y>>0]|0;q=q+1|0;y=y+1|0}while((q|0)<(r|0));j$(-215,h,358250,172446,492);d$(h);F=f[d>>2]|0;G=f[w>>2]|0}f[k>>2]=G-F;G=Y(F,f[s>>2]|0)|0;f[m>>2]=(f[m>>2]|0)+G;f[a>>2]=f[a>>2]|32768}G=f[e>>2]|0;s=e+4|0;F=f[s>>2]|0;if((G|0)!=-2147483648|(F|0)!=2147483647?(G|0?1:(F|0)!=(f[l>>2]|0)):0){if(!((G|0)<0|(G|0)>(F|0))?(F|0)<=(f[c+12>>2]|0):0){H=G;I=F}else{f[h>>2]=0;f[h+4>>2]=0;q=c$(h,83)|0;y=200886;r=q+83|0;do{b[q>>0]=b[y>>0]|0;q=q+1|0;y=y+1|0}while((q|0)<(r|0));j$(-215,h,358250,172446,501);d$(h);H=f[e>>2]|0;I=f[s>>2]|0}s=I-H|0;f[l>>2]=s;I=f[j>>2]|0;if((I|0)>0)J=f[(f[t>>2]|0)+(I+-1<<2)>>2]|0;else J=0;I=Y(J,H)|0;f[m>>2]=(f[m>>2]|0)+I;f[a>>2]=((s|0)<(f[c+12>>2]|0)?-49153:-32769)&f[a>>2]|32768}c=f[k>>2]|0;if((c|0)!=1){if((c|0)>=1)K=42}else{f[a>>2]=f[a>>2]|16384;K=42}if((K|0)==42?(f[l>>2]|0)>=1:0){u=g;return}K=f[o>>2]|0;if((K|0?(a=K+12|0,K=f[a>>2]|0,f[a>>2]=K+-1,(K|0)==1):0)?(K=f[o>>2]|0,K|0):0){f[o>>2]=0;a=f[K+4>>2]|0;if(!a){c=f[n>>2]|0;if(!c)L=sR()|0;else L=c}else L=a;Gh[f[(f[L>>2]|0)+24>>2]&511](L,K)}f[o>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[j>>2]|0)>0){m=f[p>>2]|0;p=0;do{f[m+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[j>>2]|0))}f[l>>2]=0;f[k>>2]=0;u=g;return}function ER(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;f[a>>2]=1124007936;h=a+4|0;i=a+8|0;j=a+16|0;k=a+40|0;l=h;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=i;i=a+48|0;n=a+44|0;f[n>>2]=i;f[a+52>>2]=0;f[i>>2]=0;i=f[c+4>>2]|0;if(!d){f[g>>2]=0;f[g+4>>2]=0;o=c$(g,6)|0;b[o>>0]=b[200970]|0;b[o+1>>0]=b[200971]|0;b[o+2>>0]=b[200972]|0;b[o+3>>0]=b[200973]|0;b[o+4>>0]=b[200974]|0;b[o+5>>0]=b[200975]|0;j$(-215,g,358250,172446,582);d$(g)}o=(i|0)>0;if(o){p=c+40|0;q=g+4|0;r=0;do{s=d+(r<<3)|0;t=f[s>>2]|0;v=f[s+4>>2]|0;do if(!((t|0)==-2147483648&(v|0)==2147483647)){if((t|0)>-1&(t|0)<(v|0)?(v|0)<=(f[(f[p>>2]|0)+(r<<2)>>2]|0):0)break;f[g>>2]=0;f[q>>2]=0;l=c$(g,76)|0;s=200977;m=l+76|0;do{b[l>>0]=b[s>>0]|0;l=l+1|0;s=s+1|0}while((l|0)<(m|0));j$(-215,g,358250,172446,586);d$(g)}while(0);r=r+1|0}while((r|0)<(i|0));yR(a,c)|0;if(o){o=0;do{r=d+(o<<3)|0;g=f[r>>2]|0;l=f[r+4>>2]|0;if((g|0)!=-2147483648|(l|0)!=2147483647?(r=(f[k>>2]|0)+(o<<2)|0,g|0?1:(l|0)!=(f[r>>2]|0)):0){f[r>>2]=l-g;l=Y(f[(f[n>>2]|0)+(o<<2)>>2]|0,g)|0;f[j>>2]=(f[j>>2]|0)+l;f[a>>2]=f[a>>2]|32768}o=o+1|0}while((o|0)!=(i|0))}}else yR(a,c)|0;c=f[h>>2]|0;h=f[k>>2]|0;a:do if((c|0)>0){k=0;while(1){if((f[h+(k<<2)>>2]|0)>1){w=k;break a}i=k+1|0;if((i|0)<(c|0))k=i;else{w=i;break}}}else w=0;while(0);k=f[n>>2]|0;n=c;while(1){c=n;n=n+-1|0;if((n|0)<=(w|0)){x=18;break}i=Y(f[h+(n<<2)>>2]|0,f[k+(n<<2)>>2]|0)|0;if(i>>>0<(f[k+(c+-2<<2)>>2]|0)>>>0){x=18;break}}if((x|0)==18){x=f[h>>2]|0;h=W1a(x|0,((x|0)<0)<<31>>31|0,f[k>>2]|0,0)|0;k=f[a>>2]|0;f[a>>2]=(n|0)<=(w|0)&((h|0)==(h|0)&(J|0)==0)?k|16384:k&-16385;u=e;return}}function FR(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=u;u=u+16|0;g=e;h=f[c>>2]|0;f[a>>2]=h;i=a+4|0;f[i>>2]=2;j=a+8|0;k=d+12|0;f[j>>2]=f[k>>2];l=a+12|0;m=d+8|0;f[l>>2]=f[m>>2];n=a+16|0;o=d+4|0;p=c+44|0;q=(f[c+16>>2]|0)+(Y(f[f[p>>2]>>2]|0,f[o>>2]|0)|0)|0;f[n>>2]=q;f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];r=a+32|0;f[r>>2]=f[c+32>>2];s=a+36|0;f[s>>2]=f[c+36>>2];t=a+40|0;f[t>>2]=j;v=a+48|0;w=a+44|0;f[w>>2]=v;f[a+52>>2]=0;f[v>>2]=0;if((f[c+4>>2]|0)<3){x=h;y=q}else{f[g>>2]=0;f[g+4>>2]=0;z=c$(g,11)|0;A=200466;B=z+11|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-215,g,358250,172446,531);d$(g);x=f[a>>2]|0;y=f[n>>2]|0}q=f[m>>2]|0;h=c+12|0;v=f[h>>2]|0;C=f[k>>2]|0;f[a>>2]=((C|0)==1?16384:0)|((q|0)<(v|0)?-16385:-1)&x;D=(x>>>3&511)+1<<(47696>>>(x<<1&14)&3);x=f[d>>2]|0;d=y+(Y(D,x)|0)|0;f[n>>2]=d;if(!((!((x|q|0)<0|(x+q|0)>(v|0))?(v=f[o>>2]|0,(v|C|0)>-1):0)?(v+C|0)<=(f[c+8>>2]|0):0)){f[g>>2]=0;f[g+4>>2]=0;z=c$(g,124)|0;A=200483;B=z+124|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-215,g,358250,172446,538);d$(g)}g=f[s>>2]|0;if(g|0){A=g+12|0;f[A>>2]=(f[A>>2]|0)+1}if(!((f[m>>2]|0)>=(f[h>>2]|0)?(f[k>>2]|0)>=(f[c+8>>2]|0):0))f[a>>2]=f[a>>2]|32768;a=f[w>>2]|0;f[a>>2]=f[f[p>>2]>>2];f[a+4>>2]=D;if((f[j>>2]|0)>=1?(f[l>>2]|0)>=1:0){u=e;return}D=f[s>>2]|0;if((D|0?(a=D+12|0,D=f[a>>2]|0,f[a>>2]=D+-1,(D|0)==1):0)?(D=f[s>>2]|0,D|0):0){f[s>>2]=0;a=f[D+4>>2]|0;if(!a){p=f[r>>2]|0;if(!p)E=sR()|0;else E=p}else E=a;Gh[f[(f[E>>2]|0)+24>>2]&511](E,D)}f[s>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[i>>2]|0)>0){n=f[t>>2]|0;t=0;do{f[n+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[i>>2]|0))}f[l>>2]=0;f[j>>2]=0;u=e;return}function GR(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=a+8|0;i=a+16|0;j=a+20|0;k=a+40|0;l=a+4|0;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=h;h=a+48|0;f[a+44>>2]=h;f[a+52>>2]=0;f[h>>2]=0;f[a>>2]=d&4095|1124007936;f[i>>2]=e;f[j>>2]=e;pR(a,b,c,g,1);qR(a);return}function HR(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=c+4|0;i=f[h>>2]|0;if((i|0)<3)j=i;else{f[g>>2]=0;f[g+4>>2]=0;i=c$(g,9)|0;k=172938;l=i+9|0;do{b[i>>0]=b[k>>0]|0;i=i+1|0;k=k+1|0}while((i|0)<(l|0));j$(-215,g,172948,172446,750);d$(g);j=f[h>>2]|0}f[a>>2]=f[c>>2];g=a+4|0;f[g>>2]=j;k=a+8|0;i=c+8|0;f[k>>2]=f[i>>2];l=a+12|0;m=c+12|0;f[l>>2]=f[m>>2];n=a+16|0;f[n>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];o=f[c+36>>2]|0;f[a+36>>2]=o;p=a+40|0;f[p>>2]=k;q=a+48|0;r=a+44|0;f[r>>2]=q;f[q>>2]=0;f[a+52>>2]=0;if(!o)s=j;else{j=o+12|0;f[j>>2]=(f[j>>2]|0)+1;s=f[h>>2]|0}if((s|0)>=3){f[g>>2]=0;pR(a,s,0,0,0);if((f[g>>2]|0)>0){s=f[c+40>>2]|0;j=f[p>>2]|0;o=f[c+44>>2]|0;q=f[r>>2]|0;t=0;do{f[j+(t<<2)>>2]=f[s+(t<<2)>>2];f[q+(t<<2)>>2]=f[o+(t<<2)>>2];t=t+1|0}while((t|0)<(f[g>>2]|0))}}else{g=f[c+44>>2]|0;t=f[r>>2]|0;f[t>>2]=f[g>>2];f[t+4>>2]=f[g+4>>2]}g=f[h>>2]|0;if((g|0)>0)v=f[(f[c+44>>2]|0)+(g+-1<<2)>>2]|0;else v=0;if((d|0)>-1){g=(f[m>>2]|0)-d|0;h=f[i>>2]|0;t=Y(v,d)|0;w=(f[n>>2]|0)+t|0;x=(h|0)<(g|0)?h:g}else{g=(f[i>>2]|0)+d|0;i=f[m>>2]|0;w=(f[n>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,0-d|0)|0)|0;x=(i|0)<(g|0)?i:g}f[n>>2]=w;f[k>>2]=x;w=f[p>>2]|0;f[w>>2]=x;f[l>>2]=1;f[w+4>>2]=1;w=f[r>>2]|0;f[w>>2]=(f[w>>2]|0)+((x|0)>1?v:0);v=f[a>>2]|0;x=(f[k>>2]|0)>1?v&-16385:v|16384;f[a>>2]=x;v=f[c+40>>2]|0;if(!((f[v>>2]|0)!=1?1:(f[v+4>>2]|0)!=1)){u=e;return}f[a>>2]=x|32768;u=e;return}function IR(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+144|0;e=d+120|0;g=d+112|0;h=d+56|0;i=d;if((c|0)<=-1){f[e>>2]=0;f[e+4>>2]=0;j=c$(e,16)|0;k=172953;l=j+16|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,e,172970,172446,821);d$(e)}if((f[a>>2]&32768|0)==0?(k=(f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,c)|0)|0,k>>>0<=(f[a+28>>2]|0)>>>0):0){u=d;return}k=a+40|0;m=f[k>>2]|0;n=f[m>>2]|0;if(n>>>0>=c>>>0){u=d;return}f[m>>2]=(c|0)>1?c:1;m=a+4|0;o=f[m>>2]|0;if((o|0)<3)p=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{q=f[k>>2]|0;r=0;s=1;while(1){t=Y(f[q+(r<<2)>>2]|0,s)|0;r=r+1|0;if((r|0)==(o|0)){p=t;break}else s=t}}if((o|0)>0)v=f[(f[a+44>>2]|0)+(o+-1<<2)>>2]|0;else v=0;s=Y(v,p)|0;if(s>>>0<64){p=((Y(s+63|0,c)|0)>>>0)/(s>>>0)|0;f[f[k>>2]>>2]=p;w=f[m>>2]|0}else w=o;o=f[k>>2]|0;m=f[a>>2]&4095;f[h>>2]=1124007936;p=h+4|0;s=h+8|0;c=h+40|0;j=p;l=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(l|0));f[c>>2]=s;s=h+48|0;j=h+44|0;f[j>>2]=s;f[s>>2]=0;f[h+52>>2]=0;AR(h,w,o,m);f[f[k>>2]>>2]=n;if((n|0)>0){f[e>>2]=0;f[e+4>>2]=n;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;DR(i,h,e,g);g=e+8|0;f[g>>2]=0;f[g+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=i;eL(a,e);e=i+36|0;g=f[e>>2]|0;if((g|0?(m=g+12|0,g=f[m>>2]|0,f[m>>2]=g+-1,(g|0)==1):0)?(g=f[e>>2]|0,g|0):0){f[e>>2]=0;m=f[g+4>>2]|0;if(!m){o=f[i+32>>2]|0;if(!o)x=sR()|0;else x=o}else x=m;Gh[f[(f[x>>2]|0)+24>>2]&511](x,g)}f[e>>2]=0;e=i+16|0;g=i+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[g>>2]|0)>0){e=f[i+40>>2]|0;x=0;do{f[e+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[g>>2]|0))}g=f[i+44>>2]|0;if((g|0)!=(i+48|0))ZF(g)}yR(a,h)|0;f[f[k>>2]>>2]=n;k=(f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,n)|0)|0;f[a+24>>2]=k;k=h+36|0;a=f[k>>2]|0;if((a|0?(n=a+12|0,a=f[n>>2]|0,f[n>>2]=a+-1,(a|0)==1):0)?(a=f[k>>2]|0,a|0):0){f[k>>2]=0;n=f[a+4>>2]|0;if(!n){g=f[h+32>>2]|0;if(!g)y=sR()|0;else y=g}else y=n;Gh[f[(f[y>>2]|0)+24>>2]&511](y,a)}f[k>>2]=0;k=h+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[p>>2]|0)>0){k=f[c>>2]|0;c=0;do{f[k+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[p>>2]|0))}p=f[j>>2]|0;if((p|0)!=(s|0))ZF(p);u=d;return}function JR(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;e=u;u=u+352|0;i=e+216|0;j=e+88|0;k=e+32|0;l=e+16|0;m=e+8|0;n=e;if(!c){f[a>>2]=1124007936;o=a+8|0;p=a+40|0;q=a+4|0;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[p>>2]=o;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;u=e;return}o=f[c>>2]|0;p=o&-65536;if((p|0)==1111621632){s=f[c+24>>2]|0;if((s|0)>-1?(t=f[c+20>>2]|0,(t|0)>-1):0){f[a>>2]=1124007936;v=a+4|0;w=a+8|0;x=a+40|0;q=v;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[x>>2]=w;x=a+48|0;f[a+44>>2]=x;f[x>>2]=0;y=a+52|0;f[y>>2]=0;z=f[c+4>>2]|0;if(d){f[a+16>>2]=0;f[a+24>>2]=0;f[a+20>>2]=0;$i(i,t,s,o,f[c+16>>2]|0,z);A=j+8|0;f[A>>2]=0;f[A+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=a;eL(i,j);A=i+36|0;B=f[A>>2]|0;if((B|0?(C=B+12|0,B=f[C>>2]|0,f[C>>2]=B+-1,(B|0)==1):0)?(B=f[A>>2]|0,B|0):0){f[A>>2]=0;C=f[B+4>>2]|0;if(!C){D=f[i+32>>2]|0;if(!D)E=sR()|0;else E=D}else E=C;Gh[f[(f[E>>2]|0)+24>>2]&511](E,B)}f[A>>2]=0;A=i+16|0;B=i+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[B>>2]|0)>0){A=f[i+40>>2]|0;E=0;do{f[A+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[B>>2]|0))}B=f[i+44>>2]|0;if((B|0)!=(i+48|0))ZF(B)}else{f[a>>2]=o&20479|1124007936;f[v>>2]=2;f[w>>2]=t;f[a+12>>2]=s;w=f[c+16>>2]|0;f[a+16>>2]=w;f[a+20>>2]=w;v=(o>>>3&511)+1<<(47696>>>(o<<1&14)&3);B=Y(s,v)|0;s=(z|0)==0?B:z;z=w+(Y(s,t)|0)|0;f[a+28>>2]=z;f[a+24>>2]=z+(0-s)+B;f[x>>2]=s;f[y>>2]=v}u=e;return}}else if((p|0)==1111687168?(v=f[c+16>>2]|0,y=v,v|0):0){v=a+4|0;s=a+8|0;x=a+40|0;q=v;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[x>>2]=s;B=a+48|0;z=a+44|0;f[z>>2]=B;f[B>>2]=0;f[a+52>>2]=0;B=a+16|0;f[B>>2]=y;t=a+20|0;f[t>>2]=y;f[a>>2]=o&4095|1124007936;y=f[c+4>>2]|0;if((y|0)>0){w=0;do{f[i+(w<<2)>>2]=f[c+20+(w<<3)>>2];f[j+(w<<2)>>2]=f[c+20+(w<<3)+4>>2];w=w+1|0}while((w|0)!=(y|0))}pR(a,y,i,j,0);qR(a);if(d){f[k>>2]=f[a>>2];y=k+4|0;w=f[v>>2]|0;f[y>>2]=w;E=k+8|0;f[E>>2]=f[s>>2];f[k+12>>2]=f[a+12>>2];s=k+16|0;f[s>>2]=f[B>>2];f[k+20>>2]=f[t>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];t=k+32|0;A=a+32|0;f[t>>2]=f[A>>2];C=k+36|0;D=a+36|0;F=f[D>>2]|0;f[C>>2]=F;G=k+40|0;f[G>>2]=E;E=k+48|0;H=k+44|0;f[H>>2]=E;f[E>>2]=0;f[k+52>>2]=0;if(!F)I=w;else{w=F+12|0;f[w>>2]=(f[w>>2]|0)+1;I=f[v>>2]|0}if((I|0)>=3){f[y>>2]=0;pR(k,I,0,0,0);if((f[y>>2]|0)>0){I=f[x>>2]|0;w=f[G>>2]|0;F=f[z>>2]|0;J=f[H>>2]|0;K=0;do{f[w+(K<<2)>>2]=f[I+(K<<2)>>2];f[J+(K<<2)>>2]=f[F+(K<<2)>>2];K=K+1|0}while((K|0)<(f[y>>2]|0))}}else{K=f[z>>2]|0;z=f[H>>2]|0;f[z>>2]=f[K>>2];f[z+4>>2]=f[K+4>>2]}K=f[D>>2]|0;if((K|0?(z=K+12|0,K=f[z>>2]|0,f[z>>2]=K+-1,(K|0)==1):0)?(K=f[D>>2]|0,K|0):0){f[D>>2]=0;z=f[K+4>>2]|0;if(!z){F=f[A>>2]|0;if(!F)L=sR()|0;else L=F}else L=z;Gh[f[(f[L>>2]|0)+24>>2]&511](L,K)}f[D>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[v>>2]|0)>0){B=f[x>>2]|0;x=0;do{f[B+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[v>>2]|0))}v=l+8|0;f[v>>2]=0;f[v+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=a;eL(k,l);l=f[C>>2]|0;if((l|0?(v=l+12|0,l=f[v>>2]|0,f[v>>2]=l+-1,(l|0)==1):0)?(l=f[C>>2]|0,l|0):0){f[C>>2]=0;v=f[l+4>>2]|0;if(!v){x=f[t>>2]|0;if(!x)M=sR()|0;else M=x}else M=v;Gh[f[(f[M>>2]|0)+24>>2]&511](M,l)}f[C>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[y>>2]|0)>0){s=f[G>>2]|0;G=0;do{f[s+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[y>>2]|0))}y=f[H>>2]|0;if((y|0)!=(E|0))ZF(y)}u=e;return}if((o|0)==112?(y=c+68|0,f[y>>2]|0):0){if(((g|0)==0?(g=f[c+48>>2]|0,g|0):0)?(f[g>>2]|0)>0:0){f[i>>2]=0;f[i+4>>2]=0;q=c$(i,36)|0;N=172978;r=q+36|0;do{b[q>>0]=b[N>>0]|0;q=q+1|0;N=N+1|0}while((q|0)<(r|0));j$(-24,i,173015,172446,961);d$(i)}f[a>>2]=1124007936;g=a+4|0;E=a+8|0;H=a+40|0;G=g+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;f[G+16>>2]=0;f[G+20>>2]=0;f[G+24>>2]=0;f[G+28>>2]=0;f[H>>2]=E;G=a+48|0;s=a+44|0;f[s>>2]=G;f[a+52>>2]=0;f[g>>2]=2;C=f[c+16>>2]|0;l=1125516576>>>((C>>>2&60)+(C>>31&20)|0);f[G>>2]=f[c+72>>2];C=c+48|0;M=f[C>>2]|0;v=c+28|0;x=(f[v>>2]|0)==0;if(!M){if(x)O=G;else{f[i>>2]=0;f[i+4>>2]=0;q=c$(i,19)|0;N=173026;r=q+19|0;do{b[q>>0]=b[N>>0]|0;q=q+1|0;N=N+1|0}while((q|0)<(r|0));j$(-215,i,173046,172446,706);d$(i);O=f[s>>2]|0}t=((f[c+8>>2]<<3)+-8|l&7)+1124007936|0;f[a>>2]=t;B=f[c+44>>2]|0;f[E>>2]=B;D=f[c+40>>2]|0;K=a+12|0;f[K>>2]=D;L=f[y>>2]|0;f[a+16>>2]=L;f[a+20>>2]=L;P=B;Q=f[O>>2]|0;R=L;S=D;T=t;U=O;V=L;W=K;X=(t>>>3&511)+1<<(47696>>>(t<<1&14)&3)}else{if(!x?(f[M>>2]|0)==0:0){f[i>>2]=0;f[i+4>>2]=0;q=c$(i,41)|0;N=173060;r=q+41|0;do{b[q>>0]=b[N>>0]|0;q=q+1|0;N=N+1|0}while((q|0)<(r|0));j$(-215,i,173046,172446,715);d$(i);Z=f[C>>2]|0}else Z=M;M=f[Z>>2]|0;if(M){x=l&7;if((f[v>>2]|0)==1){_=1;$=x;aa=1}else{ba=x;ca=73}}else{ba=l&7;ca=73}if((ca|0)==73){_=0;$=ba;aa=f[c+8>>2]|0}ba=((aa<<3)+-8|$)+1124007936|0;f[a>>2]=ba;$=f[Z+16>>2]|0;f[E>>2]=$;aa=f[Z+12>>2]|0;ca=a+12|0;f[ca>>2]=aa;l=(ba>>>3&511)+1<<(47696>>>(ba<<1&14)&3);if(_){_=Y(f[G>>2]|0,M+-1|0)|0;da=Y(_,f[c+44>>2]|0)|0}else da=0;_=f[s>>2]|0;M=f[_>>2]|0;G=(f[y>>2]|0)+da+(Y(M,f[Z+8>>2]|0)|0)|0;da=G+(Y(f[Z+4>>2]|0,l)|0)|0;f[a+16>>2]=da;f[a+20>>2]=da;P=$;Q=M;R=da;S=aa;T=ba;U=_;V=da;W=ca;X=l}l=R+(Y(Q,P)|0)|0;f[a+28>>2]=l;ca=Y(X,S)|0;S=R+(Y(P+-1|0,Q)|0)+ca|0;f[a+24>>2]=S;f[a>>2]=((P|0)==1|(ca|0)==(Q|0)?16384:0)|T;f[U+4>>2]=X;if(!d){u=e;return}f[j>>2]=f[a>>2];X=j+4|0;U=f[g>>2]|0;f[X>>2]=U;T=j+8|0;f[T>>2]=f[E>>2];E=j+12|0;f[E>>2]=f[W>>2];W=j+16|0;Q=a+16|0;f[W>>2]=V;f[j+20>>2]=V;f[j+24>>2]=S;f[j+28>>2]=l;l=j+32|0;S=a+32|0;f[l>>2]=f[S>>2];V=j+36|0;ca=a+36|0;P=f[ca>>2]|0;f[V>>2]=P;R=j+40|0;f[R>>2]=T;da=j+48|0;_=j+44|0;f[_>>2]=da;f[da>>2]=0;f[j+52>>2]=0;if(!P)ea=U;else{U=P+12|0;f[U>>2]=(f[U>>2]|0)+1;ea=f[g>>2]|0}if((ea|0)>=3){f[X>>2]=0;pR(j,ea,0,0,0);if((f[X>>2]|0)>0){ea=f[H>>2]|0;U=f[R>>2]|0;P=f[s>>2]|0;ba=f[_>>2]|0;aa=0;do{f[U+(aa<<2)>>2]=f[ea+(aa<<2)>>2];f[ba+(aa<<2)>>2]=f[P+(aa<<2)>>2];aa=aa+1|0}while((aa|0)<(f[X>>2]|0))}}else{aa=f[s>>2]|0;s=f[_>>2]|0;f[s>>2]=f[aa>>2];f[s+4>>2]=f[aa+4>>2]}aa=f[ca>>2]|0;if((aa|0?(s=aa+12|0,aa=f[s>>2]|0,f[s>>2]=aa+-1,(aa|0)==1):0)?(aa=f[ca>>2]|0,aa|0):0){f[ca>>2]=0;s=f[aa+4>>2]|0;if(!s){P=f[S>>2]|0;if(!P)fa=sR()|0;else fa=P}else fa=s;Gh[f[(f[fa>>2]|0)+24>>2]&511](fa,aa)}f[ca>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[g>>2]|0)>0){Q=f[H>>2]|0;H=0;do{f[Q+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[g>>2]|0))}g=f[C>>2]|0;if(((g|0)!=0?(C=f[g>>2]|0,(C|0)!=0):0)?(f[v>>2]|0)!=1:0){f[k>>2]=C+-1;f[k+4>>2]=0;C=f[E>>2]|0;E=f[j>>2]&4095;f[i>>2]=f[T>>2];f[i+4>>2]=C;AR(a,2,i,E);II(j,1,a,1,k,1)}else{k=i+8|0;f[k>>2]=0;f[k+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=a;eL(j,i)}k=f[V>>2]|0;if((k|0?(E=k+12|0,k=f[E>>2]|0,f[E>>2]=k+-1,(k|0)==1):0)?(k=f[V>>2]|0,k|0):0){f[V>>2]=0;E=f[k+4>>2]|0;if(!E){C=f[l>>2]|0;if(!C)ga=sR()|0;else ga=C}else ga=E;Gh[f[(f[ga>>2]|0)+24>>2]&511](ga,k)}f[V>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[X>>2]|0)>0){W=f[R>>2]|0;R=0;do{f[W+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[X>>2]|0))}X=f[_>>2]|0;if((X|0)!=(da|0))ZF(X);u=e;return}if((p|0)!=1117323264){f[i>>2]=0;f[i+4>>2]=0;q=c$(i,18)|0;N=173255;r=q+18|0;do{b[q>>0]=b[N>>0]|0;q=q+1|0;N=N+1|0}while((q|0)<(r|0));j$(-5,i,173015,172446,985);d$(i);f[a>>2]=1124007936;N=a+8|0;p=a+40|0;q=a+4|0;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[p>>2]=N;N=a+48|0;f[a+44>>2]=N;f[N>>2]=0;f[a+52>>2]=0;u=e;return}N=f[c+24>>2]|0;p=o&4095;X=f[c+28>>2]|0;if(!N){f[a>>2]=1124007936;da=a+8|0;_=a+40|0;q=a+4|0;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[_>>2]=da;da=a+48|0;f[a+44>>2]=da;f[da>>2]=0;f[a+52>>2]=0;u=e;return}if(!((N|0)>0?((o>>>3&511)+1<<(47696>>>(o<<1&14)&3)|0)==(X|0):0)){f[i>>2]=0;f[i+4>>2]=0;K1a(c$(i,152)|0,173102,152)|0;j$(-215,i,173015,172446,970);d$(i)}if(!d?(d=f[c+52>>2]|0,(f[d+4>>2]|0)==(d|0)):0){$i(a,N,1,p,f[d+16>>2]|0,0);u=e;return}if(h|0){d=(Y(X,N)|0)+7|0;X=d>>>3;o=h+4|0;do if((f[o>>2]|0)>>>0<X>>>0){da=f[h>>2]|0;_=h+8|0;if((da|0)==(_|0))ha=da;else{if(da|0)QYa(da);f[h>>2]=_;f[o>>2]=136;ha=_}f[o>>2]=X;if(d>>>0>1095){_=OYa(X<<3)|0;f[h>>2]=_;ia=_;break}else{ia=ha;break}}else{f[o>>2]=X;ia=f[h>>2]|0}while(0);h=m;f[h>>2]=0;f[h+4>>2]=0;f[m+4>>2]=1073741823;f[i>>2]=f[m>>2];f[i+4>>2]=f[m+4>>2];BL(c,ia,i)|0;$i(a,N,1,p,ia,0);u=e;return}f[j>>2]=1124007936;ia=j+4|0;m=j+8|0;h=j+40|0;q=ia;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[h>>2]=m;q=j+48|0;r=j+44|0;f[r>>2]=q;f[q>>2]=0;f[j+52>>2]=0;f[i>>2]=N;f[i+4>>2]=1;AR(j,2,i,p);p=j+16|0;N=f[p>>2]|0;X=n;f[X>>2]=0;f[X+4>>2]=0;f[n+4>>2]=1073741823;f[i>>2]=f[n>>2];f[i+4>>2]=f[n+4>>2];BL(c,N,i)|0;f[a>>2]=f[j>>2];i=a+4|0;N=f[ia>>2]|0;f[i>>2]=N;c=a+8|0;f[c>>2]=f[m>>2];f[a+12>>2]=f[j+12>>2];f[a+16>>2]=f[p>>2];f[a+20>>2]=f[j+20>>2];f[a+24>>2]=f[j+24>>2];f[a+28>>2]=f[j+28>>2];m=j+32|0;f[a+32>>2]=f[m>>2];n=j+36|0;j=f[n>>2]|0;f[a+36>>2]=j;X=a+40|0;f[X>>2]=c;c=a+48|0;o=a+44|0;f[o>>2]=c;f[c>>2]=0;f[a+52>>2]=0;if(!j)ja=N;else{N=j+12|0;f[N>>2]=(f[N>>2]|0)+1;ja=f[ia>>2]|0}if((ja|0)>=3){f[i>>2]=0;pR(a,ja,0,0,0);if((f[i>>2]|0)>0){ja=f[h>>2]|0;a=f[X>>2]|0;X=f[r>>2]|0;N=f[o>>2]|0;j=0;do{f[a+(j<<2)>>2]=f[ja+(j<<2)>>2];f[N+(j<<2)>>2]=f[X+(j<<2)>>2];j=j+1|0}while((j|0)<(f[i>>2]|0))}}else{i=f[r>>2]|0;j=f[o>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2]}i=f[n>>2]|0;if((i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)?(i=f[n>>2]|0,i|0):0){f[n>>2]=0;j=f[i+4>>2]|0;if(!j){o=f[m>>2]|0;if(!o)ka=sR()|0;else ka=o}else ka=j;Gh[f[(f[ka>>2]|0)+24>>2]&511](ka,i)}f[n>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[ia>>2]|0)>0){p=f[h>>2]|0;h=0;do{f[p+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[ia>>2]|0))}ia=f[r>>2]|0;if((ia|0)!=(q|0))ZF(ia);u=e;return}function KR(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+16|0;g=e;h=a+4|0;i=f[h>>2]|0;if((i|0)<3?(f[f[a+44>>2]>>2]|0)!=0:0)j=i;else{f[g>>2]=0;f[g+4>>2]=0;i=c$(g,24)|0;k=173274;l=i+24|0;do{b[i>>0]=b[k>>0]|0;i=i+1|0;k=k+1|0}while((i|0)<(l|0));j$(-215,g,173299,172446,991);d$(g);j=f[h>>2]|0}if((j|0)>0)m=f[(f[a+44>>2]|0)+(j+-1<<2)>>2]|0;else m=0;j=f[a+20>>2]|0;h=(f[a+16>>2]|0)-j|0;g=(f[a+24>>2]|0)-j|0;if(!h){f[d+4>>2]=0;n=f[a+44>>2]|0;o=0;p=0}else{j=f[a+44>>2]|0;k=(h>>>0)/((f[j>>2]|0)>>>0)|0;f[d+4>>2]=k;n=j;o=k;p=((h-(Y(f[j>>2]|0,k)|0)|0)>>>0)/(m>>>0)|0}f[d>>2]=p;d=(f[a+12>>2]|0)+p|0;p=g-(Y(d,m)|0)|0;k=((p>>>0)/((f[n>>2]|0)>>>0)|0)+1|0;n=(f[a+8>>2]|0)+o|0;o=(k|0)<(n|0)?n:k;f[c+4>>2]=o;k=((g-(Y(o+-1|0,f[a+48>>2]|0)|0)|0)>>>0)/(m>>>0)|0;f[c>>2]=(k|0)<(d|0)?d:k;u=e;return}function LR(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=u;u=u+16|0;i=h+8|0;j=h;k=a+4|0;l=f[k>>2]|0;if((l|0)<3?(f[f[a+44>>2]>>2]|0)!=0:0)m=l;else{f[i>>2]=0;f[i+4>>2]=0;l=c$(i,24)|0;n=173274;o=l+24|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(o|0));j$(-215,i,173309,172446,1012);d$(i);m=f[k>>2]|0}f[i>>2]=0;k=i+4|0;f[k>>2]=0;f[j>>2]=0;n=j+4|0;f[n>>2]=0;l=a+44|0;if((m|0)>0)p=f[(f[l>>2]|0)+(m+-1<<2)>>2]|0;else p=0;KR(a,i,j);m=f[n>>2]|0;n=m-c|0;c=f[k>>2]|0;k=(n|0)>0?n:0;n=(c|0)<(k|0)?c:k;k=a+8|0;o=m+d+(f[k>>2]|0)|0;d=(c|0)<(o|0)?c:o;o=(d|0)>0?d:0;d=f[j>>2]|0;j=d-e|0;e=f[i>>2]|0;i=(j|0)>0?j:0;j=(e|0)<(i|0)?e:i;i=a+12|0;c=d+g+(f[i>>2]|0)|0;g=(e|0)<(c|0)?e:c;c=(g|0)>0?g:0;g=(n|0)>(o|0);e=g?o:n;q=(j|0)>(c|0);r=q?c:j;s=(Y(r-d|0,p)|0)+(Y(e-m|0,f[a+48>>2]|0)|0)|0;m=a+16|0;f[m>>2]=(f[m>>2]|0)+s;s=(g?n:o)-e|0;f[k>>2]=s;f[i>>2]=(q?j:c)-r;r=f[a+40>>2]|0;f[r>>2]=s;f[r+4>>2]=f[i>>2];r=Y(f[i>>2]|0,p)|0;p=f[a>>2]|0;if((r|0)!=(f[f[l>>2]>>2]|0)?(f[k>>2]|0)!=1:0){t=p&-16385;f[a>>2]=t;u=h;return a|0}t=p|16384;f[a>>2]=t;u=h;return a|0}function MR(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;j=u;u=u+16|0;k=j;l=j+8|0;m=f[a>>2]|0;n=m&2031616;o=e&4095;p=n&2097151;a:do if((p|0)<655360){if((p|0)>=131072){switch(p|0){case 131072:break;default:break a}if((g|0)<0)q=m;else{f[l>>2]=0;f[l+4>>2]=0;r=c$(l,5)|0;b[r>>0]=b[173319]|0;b[r+1>>0]=b[173320]|0;b[r+2>>0]=b[173321]|0;b[r+3>>0]=b[173322]|0;b[r+4>>0]=b[173323]|0;j$(-215,l,357830,172446,2540);d$(l);q=f[a>>2]|0}r=q&4095;do if((o|0)!=(r|0)){if((e&4088|0)==0?1<<r&i|0:0)break;f[l>>2]=0;f[l+4>>2]=0;s=c$(l,106)|0;t=173753;v=s+106|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2542);d$(l)}while(0);if((c|0)==2){r=f[d>>2]|0;w=a+8|0;x=f[a+12>>2]|0;if((r|0)==(x|0)?(f[d+4>>2]|0)==(f[w>>2]|0):0){u=j;return}if((h?(r|0)==(f[w>>2]|0):0)?(f[d+4>>2]|0)==(x|0):0){u=j;return}}f[l>>2]=0;f[l+4>>2]=0;K1a(c$(l,129)|0,173860,129)|0;j$(-215,l,357830,172446,2544);d$(l);u=j;return}switch(p|0){case 65536:break;default:break a}if((g|0)>=0){f[l>>2]=0;f[l+4>>2]=0;x=c$(l,5)|0;b[x>>0]=b[173319]|0;b[x+1>>0]=b[173320]|0;b[x+2>>0]=b[173321]|0;b[x+3>>0]=b[173322]|0;b[x+4>>0]=b[173323]|0;j$(-215,l,357830,172446,2472);d$(l)}x=f[a+4>>2]|0;if(h){if(!(f[x>>2]&16384)){if((f[a>>2]|0)>>>0>1073741823){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,28)|0;t=173647;v=s+28|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2478);d$(l)}w=x+36|0;r=f[w>>2]|0;if((r|0?(y=r+12|0,r=f[y>>2]|0,f[y>>2]=r+-1,(r|0)==1):0)?(r=f[w>>2]|0,r|0):0){f[w>>2]=0;y=f[r+4>>2]|0;if(!y){z=f[x+32>>2]|0;if(!z)A=sR()|0;else A=z}else A=y;Gh[f[(f[A>>2]|0)+24>>2]&511](A,r)}f[w>>2]=0;w=x+16|0;r=x+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[r>>2]|0)>0){w=f[x+40>>2]|0;y=0;do{f[w+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[r>>2]|0))}}if((((((c|0)==2?(f[x+4>>2]|0)==2:0)?f[x+16>>2]|0:0)?(f[x>>2]&4095|0)==(o|0):0)?(f[x+8>>2]|0)==(f[d+4>>2]|0):0)?(f[x+12>>2]|0)==(f[d>>2]|0):0){u=j;return}}r=f[a>>2]|0;do if((r|0)<0){y=f[x>>2]|0;if(((y^e)&4088|0)==0?1<<(r&4095)&i|0:0){B=r;C=y&4095;break}if((o|0)!=(y&4095|0)){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,42)|0;t=173676;v=s+42|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2492);d$(l);B=f[a>>2]|0;C=o}else{B=r;C=o}}else{B=r;C=o}while(0);if(B&1073741824|0){if((f[x+4>>2]|0)!=(c|0)){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,11)|0;t=173719;v=s+11|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2496);d$(l)}if((c|0)>0){r=x+40|0;y=l+4|0;w=0;do{if((f[(f[r>>2]|0)+(w<<2)>>2]|0)!=(f[d+(w<<2)>>2]|0)){f[l>>2]=0;f[y>>2]=0;s=c$(l,21)|0;t=173731;v=s+21|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2498);d$(l)}w=w+1|0}while((w|0)<(c|0))}}AR(x,c,d,C);u=j;return}else{if((p|0)>=917504){switch(p|0){case 917504:break;default:break a}w=m&4095;do if((o|0)!=(w|0)){if((e&4088|0)==0?1<<w&i|0:0)break;f[l>>2]=0;f[l+4>>2]=0;s=c$(l,106)|0;t=173753;v=s+106|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2551);d$(l)}while(0);if((c|0)==2?(w=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0,(w|0)==(Y(f[d+4>>2]|0,f[d>>2]|0)|0)):0){u=j;return}f[l>>2]=0;f[l+4>>2]=0;s=c$(l,40)|0;t=173990;v=s+40|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2552);d$(l);u=j;return}switch(p|0){case 655360:break;default:break a}if((g|0)>=0){f[l>>2]=0;f[l+4>>2]=0;w=c$(l,5)|0;b[w>>0]=b[173319]|0;b[w+1>>0]=b[173320]|0;b[w+2>>0]=b[173321]|0;b[w+3>>0]=b[173322]|0;b[w+4>>0]=b[173323]|0;j$(-215,l,357830,172446,2506);d$(l)}w=f[a+4>>2]|0;if(h){if(!(f[w>>2]&16384)){if((f[a>>2]|0)>>>0>1073741823){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,28)|0;t=173647;v=s+28|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2512);d$(l)}x=w+24|0;y=f[x>>2]|0;if(y|0?(r=y+8|0,y=f[r>>2]|0,f[r>>2]=y+-1,(y|0)==1):0)k0(w);y=w+4|0;if((f[y>>2]|0)>0){r=f[w+32>>2]|0;z=0;do{f[r+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[y>>2]|0))}f[x>>2]=0}if(((((((c|0)==2?(f[w+4>>2]|0)==2:0)?f[w+24>>2]|0:0)?(y=f[w+8>>2]|0,z=f[w+12>>2]|0,Y(z,y)|0):0)?(f[w>>2]&4095|0)==(o|0):0)?(y|0)==(f[d+4>>2]|0):0)?(z|0)==(f[d>>2]|0):0){u=j;return}}z=f[a>>2]|0;do if((z|0)<0){y=f[w>>2]|0;if(((y^e)&4088|0)==0?1<<(z&4095)&i|0:0){D=z;E=y&4095;break}if((o|0)!=(y&4095|0)){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,42)|0;t=173676;v=s+42|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2526);d$(l);D=f[a>>2]|0;E=o}else{D=z;E=o}}else{D=z;E=o}while(0);if(D&1073741824|0){if((f[w+4>>2]|0)!=(c|0)){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,11)|0;t=173719;v=s+11|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2530);d$(l)}if((c|0)>0){z=w+32|0;x=l+4|0;y=0;do{if((f[(f[z>>2]|0)+(y<<2)>>2]|0)!=(f[d+(y<<2)>>2]|0)){f[l>>2]=0;f[x>>2]=0;s=c$(l,21)|0;t=173731;v=s+21|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2532);d$(l)}y=y+1|0}while((y|0)<(c|0))}}h0(w,c,d,E,0);u=j;return}while(0);E=(n|0)==262144;D=n&2097151;b:do if((D|0)<327680){if((D|0)<196608){switch(D|0){case 0:break;default:break b}f[l>>2]=0;f[l+4>>2]=0;s=c$(l,44)|0;t=174428;v=s+44|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-27,l,357830,172446,2640);d$(l);u=j;return}if((D|0)<262144)switch(D|0){case 196608:break;default:break b}else switch(D|0){case 262144:break;default:break b}if((c|0)==2){w=f[d>>2]|0;if((w|0)!=1){n=f[d+4>>2]|0;if((n|0)==1|(Y(n,w)|0)==0)F=w;else G=98}else F=1}else G=98;if((G|0)==98){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,68)|0;t=174031;v=s+68|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2558);d$(l);F=f[d>>2]|0}w=f[d+4>>2]|0;n=(Y(w,F)|0)>0;p=n?F+-1+w|0:0;w=f[a+4>>2]|0;n=(g|0)<0;do if(!E)if(n)H=w;else{f[l>>2]=0;f[l+4>>2]=0;C=c$(l,5)|0;b[C>>0]=b[173319]|0;b[C+1>>0]=b[173320]|0;b[C+2>>0]=b[173321]|0;b[C+3>>0]=b[173322]|0;b[C+4>>0]=b[173323]|0;j$(-215,l,357830,172446,2575);d$(l);H=w}else{if(!n){C=f[w>>2]|0;if((((f[w+4>>2]|0)-C|0)/12|0|0)>(g|0))I=C;else{f[l>>2]=0;f[l+4>>2]=0;s=c$(l,18)|0;t=173614;v=s+18|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2571);d$(l);I=f[w>>2]|0}H=I+(g*12|0)|0;break}C=w+4|0;if((f[a>>2]&1073741824|0)!=0?(p|0)!=(((f[C>>2]|0)-(f[w>>2]|0)|0)/12|0|0):0){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,32)|0;t=174100;v=s+32|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2567);d$(l);J=w}else J=w;B=f[C>>2]|0;A=f[J>>2]|0;q=(B-A|0)/12|0;y=B;if(p>>>0>q>>>0){SR(w,p-q|0);u=j;return}if(p>>>0>=q>>>0){u=j;return}q=A+(p*12|0)|0;if((y|0)==(q|0)){u=j;return}else K=y;while(1){y=K+-12|0;f[C>>2]=y;A=f[y>>2]|0;if(!A)L=y;else{y=K+-8|0;if((f[y>>2]|0)!=(A|0))f[y>>2]=A;PYa(A);L=f[C>>2]|0}if((L|0)==(q|0))break;else K=L}u=j;return}while(0);w=f[a>>2]|0;n=w&4095;do if((o|0)==(n|0))M=w;else{if(((w^e)&4088|0)==0?1<<n&i|0:0){M=w;break}f[l>>2]=0;f[l+4>>2]=0;K1a(c$(l,146)|0,174133,146)|0;j$(-215,l,357830,172446,2578);d$(l);M=f[a>>2]|0}while(0);n=(w>>>3&511)+1<<(47696>>>(w<<1&14)&3);if(M&1073741824|0?(p|0)!=((((f[H+4>>2]|0)-(f[H>>2]|0)|0)>>>0)/(n>>>0)|0|0):0){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,61)|0;t=174280;v=s+61|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2581);d$(l)}do switch(n&8191){case 1:{w=H+4|0;q=f[w>>2]|0;C=f[H>>2]|0;A=q-C|0;if(p>>>0>A>>>0){TR(H,p-A|0);u=j;return}if(p>>>0>=A>>>0){u=j;return}A=C+p|0;if((q|0)==(A|0)){u=j;return}f[w>>2]=A;u=j;return}case 2:{A=H+4|0;w=f[A>>2]|0;q=f[H>>2]|0;C=w-q>>1;y=w;if(p>>>0>C>>>0){UR(H,p-C|0);u=j;return}if(p>>>0>=C>>>0){u=j;return}C=q+(p<<1)|0;if((y|0)==(C|0)){u=j;return}f[A>>2]=y+(~((0-C+(y+-2)|0)>>>1)<<1);u=j;return}case 3:{y=H+4|0;C=f[y>>2]|0;A=f[H>>2]|0;q=(C-A|0)/3|0;w=C;if(p>>>0>q>>>0){VR(H,p-q|0);u=j;return}if(p>>>0>=q>>>0){u=j;return}q=A+(p*3|0)|0;if((w|0)==(q|0)){u=j;return}f[y>>2]=w+(~(((0-q+(w+-3)|0)>>>0)/3|0)*3|0);u=j;return}case 4:{w=H+4|0;q=f[w>>2]|0;y=f[H>>2]|0;A=q-y>>2;C=q;if(p>>>0>A>>>0){GM(H,p-A|0);u=j;return}if(p>>>0>=A>>>0){u=j;return}A=y+(p<<2)|0;if((C|0)==(A|0)){u=j;return}f[w>>2]=C+(~((C+-4-A|0)>>>2)<<2);u=j;return}case 6:{A=H+4|0;C=f[A>>2]|0;w=f[H>>2]|0;y=(C-w|0)/6|0;q=C;if(p>>>0>y>>>0){WR(H,p-y|0);u=j;return}if(p>>>0>=y>>>0){u=j;return}y=w+(p*6|0)|0;if((q|0)==(y|0)){u=j;return}f[A>>2]=q+(~(((q+-6-y|0)>>>0)/6|0)*6|0);u=j;return}case 8:{y=H+4|0;q=f[y>>2]|0;A=f[H>>2]|0;w=q-A>>3;C=q;if(p>>>0>w>>>0){XR(H,p-w|0);u=j;return}if(p>>>0>=w>>>0){u=j;return}w=A+(p<<3)|0;if((C|0)==(w|0)){u=j;return}f[y>>2]=C+(~((C+-8-w|0)>>>3)<<3);u=j;return}case 12:{w=H+4|0;C=f[w>>2]|0;y=f[H>>2]|0;A=(C-y|0)/12|0;q=C;if(p>>>0>A>>>0){YR(H,p-A|0);u=j;return}if(p>>>0>=A>>>0){u=j;return}A=y+(p*12|0)|0;if((q|0)==(A|0)){u=j;return}f[w>>2]=q+(~(((q+-12-A|0)>>>0)/12|0)*12|0);u=j;return}case 16:{A=H+4|0;q=f[A>>2]|0;w=f[H>>2]|0;y=q-w>>4;C=q;if(p>>>0>y>>>0){ZR(H,p-y|0);u=j;return}if(p>>>0>=y>>>0){u=j;return}y=w+(p<<4)|0;if((C|0)==(y|0)){u=j;return}f[A>>2]=C+(~((C+-16-y|0)>>>4)<<4);u=j;return}case 24:{y=H+4|0;C=f[y>>2]|0;A=f[H>>2]|0;w=(C-A|0)/24|0;q=C;if(p>>>0>w>>>0){_R(H,p-w|0);u=j;return}if(p>>>0>=w>>>0){u=j;return}w=A+(p*24|0)|0;if((q|0)==(w|0)){u=j;return}f[y>>2]=q+(~(((q+-24-w|0)>>>0)/24|0)*24|0);u=j;return}case 32:{w=H+4|0;q=f[w>>2]|0;y=f[H>>2]|0;A=q-y>>5;C=q;if(p>>>0>A>>>0){$R(H,p-A|0);u=j;return}if(p>>>0>=A>>>0){u=j;return}A=y+(p<<5)|0;if((C|0)==(A|0)){u=j;return}f[w>>2]=C+(~((C+-32-A|0)>>>5)<<5);u=j;return}case 36:{A=H+4|0;C=f[A>>2]|0;w=f[H>>2]|0;y=(C-w|0)/36|0;q=C;if(p>>>0>y>>>0){aS(H,p-y|0);u=j;return}if(p>>>0>=y>>>0){u=j;return}y=w+(p*36|0)|0;if((q|0)==(y|0)){u=j;return}f[A>>2]=q+(~(((q+-36-y|0)>>>0)/36|0)*36|0);u=j;return}case 48:{y=H+4|0;q=f[y>>2]|0;A=f[H>>2]|0;w=(q-A|0)/48|0;C=q;if(p>>>0>w>>>0){bS(H,p-w|0);u=j;return}if(p>>>0>=w>>>0){u=j;return}w=A+(p*48|0)|0;if((C|0)==(w|0)){u=j;return}f[y>>2]=C+(~(((C+-48-w|0)>>>0)/48|0)*48|0);u=j;return}case 64:{w=H+4|0;C=f[w>>2]|0;y=f[H>>2]|0;A=C-y>>6;q=C;if(p>>>0>A>>>0){cS(H,p-A|0);u=j;return}if(p>>>0>=A>>>0){u=j;return}A=y+(p<<6)|0;if((q|0)==(A|0)){u=j;return}f[w>>2]=q+(~((q+-64-A|0)>>>6)<<6);u=j;return}case 128:{A=H+4|0;q=f[A>>2]|0;w=f[H>>2]|0;y=q-w>>7;C=q;if(p>>>0>y>>>0){dS(H,p-y|0);u=j;return}if(p>>>0>=y>>>0){u=j;return}y=w+(p<<7)|0;if((C|0)==(y|0)){u=j;return}f[A>>2]=C+(~((C+-128-y|0)>>>7)<<7);u=j;return}case 256:{y=H+4|0;C=f[y>>2]|0;A=f[H>>2]|0;w=C-A>>8;q=C;if(p>>>0>w>>>0){eS(H,p-w|0);u=j;return}if(p>>>0>=w>>>0){u=j;return}w=A+(p<<8)|0;if((q|0)==(w|0)){u=j;return}f[y>>2]=q+(~((q+-256-w|0)>>>8)<<8);u=j;return}case 512:{w=H+4|0;q=f[w>>2]|0;y=f[H>>2]|0;A=q-y>>9;C=q;if(p>>>0>A>>>0){fS(H,p-A|0);u=j;return}if(p>>>0>=A>>>0){u=j;return}A=y+(p<<9)|0;if((C|0)==(A|0)){u=j;return}f[w>>2]=C+(~((C+-512-A|0)>>>9)<<9);u=j;return}default:{f[k>>2]=n;p$(l,174342,k);j$(-5,l,357830,172446,2633);d$(l);u=j;return}}while(0)}else{if((D|0)<720896){switch(D|0){case 327680:break;default:break b}n=f[a+4>>2]|0;if((g|0)<0){if((c|0)==2){p=f[d>>2]|0;if((p|0)!=1){A=f[d+4>>2]|0;if((A|0)==1|(Y(A,p)|0)==0){N=p;O=m}else G=214}else{N=1;O=m}}else G=214;if((G|0)==214){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,68)|0;t=174031;v=s+68|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2650);d$(l);N=f[d>>2]|0;O=f[a>>2]|0}p=f[d+4>>2]|0;A=(Y(p,N)|0)>0;C=A?N+-1+p|0:0;p=((f[n+4>>2]|0)-(f[n>>2]|0)|0)/56|0;if(!((O&1073741824|0)==0|(C|0)==(p|0))){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,27)|0;t=174473;v=s+27|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2653);d$(l)}gS(n,C);A=f[a>>2]|0;if((A|0)>=0){u=j;return}w=A&4095;if(p>>>0>=C>>>0){u=j;return}A=l+4|0;y=f[n>>2]|0;q=p;while(1){B=f[y+(q*56|0)>>2]|0;if((B&4095|0)==(w|0))P=y;else{if(f[y+(q*56|0)+16>>2]|0){x=f[y+(q*56|0)+4>>2]|0;if((x|0)<3)Q=Y(f[y+(q*56|0)+12>>2]|0,f[y+(q*56|0)+8>>2]|0)|0;else{z=f[y+(q*56|0)+40>>2]|0;r=0;R=1;while(1){S=Y(f[z+(r<<2)>>2]|0,R)|0;r=r+1|0;if((r|0)==(x|0)){Q=S;break}else R=S}}if(!((x|0)==0|(Q|0)==0)){f[l>>2]=0;f[A>>2]=0;s=c$(l,12)|0;t=174501;v=s+12|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2662);d$(l);x=f[n>>2]|0;T=x;U=f[x+(q*56|0)>>2]|0}else{T=y;U=B}}else{T=y;U=B}f[T+(q*56|0)>>2]=U&-4096|w;P=T}q=q+1|0;if(q>>>0>=C>>>0)break;else y=P}u=j;return}y=f[n>>2]|0;if((((f[n+4>>2]|0)-y|0)/56|0|0)>(g|0))V=y;else{f[l>>2]=0;f[l+4>>2]=0;s=c$(l,17)|0;t=174514;v=s+17|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2669);d$(l);V=f[n>>2]|0}y=V+(g*56|0)|0;if(h){if(!(f[y>>2]&16384)){if((f[a>>2]|0)>>>0>1073741823){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,28)|0;t=173647;v=s+28|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2676);d$(l)}n=V+(g*56|0)+36|0;C=f[n>>2]|0;if((C|0?(q=C+12|0,C=f[q>>2]|0,f[q>>2]=C+-1,(C|0)==1):0)?(C=f[n>>2]|0,C|0):0){f[n>>2]=0;q=f[C+4>>2]|0;if(!q){w=f[V+(g*56|0)+32>>2]|0;if(!w)W=sR()|0;else W=w}else W=q;Gh[f[(f[W>>2]|0)+24>>2]&511](W,C)}f[n>>2]=0;n=V+(g*56|0)+16|0;C=V+(g*56|0)+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[C>>2]|0)>0){n=f[V+(g*56|0)+40>>2]|0;q=0;do{f[n+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[C>>2]|0))}}if((((((c|0)==2?(f[V+(g*56|0)+4>>2]|0)==2:0)?f[V+(g*56|0)+16>>2]|0:0)?(f[y>>2]&4095|0)==(o|0):0)?(f[V+(g*56|0)+8>>2]|0)==(f[d+4>>2]|0):0)?(f[V+(g*56|0)+12>>2]|0)==(f[d>>2]|0):0){u=j;return}}C=f[a>>2]|0;do if((C|0)<0){q=f[y>>2]|0;if(((q^e)&4088|0)==0?1<<(C&4095)&i|0:0){X=C;Z=q&4095;break}if((o|0)!=(q&4095|0)){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,42)|0;t=173676;v=s+42|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2690);d$(l);X=f[a>>2]|0;Z=o}else{X=C;Z=o}}else{X=C;Z=o}while(0);if(X&1073741824|0){if((f[V+(g*56|0)+4>>2]|0)!=(c|0)){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,11)|0;t=173719;v=s+11|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2694);d$(l)}if((c|0)>0){C=V+(g*56|0)+40|0;B=l+4|0;q=0;do{if((f[(f[C>>2]|0)+(q<<2)>>2]|0)!=(f[d+(q<<2)>>2]|0)){f[l>>2]=0;f[B>>2]=0;s=c$(l,21)|0;t=173731;v=s+21|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2696);d$(l)}q=q+1|0}while((q|0)<(c|0))}}AR(y,c,d,Z);u=j;return}if((D|0)>=983040){switch(D|0){case 983040:break;default:break b}q=f[a+4>>2]|0;if((g|0)<0){if((c|0)==2){B=f[d>>2]|0;if((B|0)!=1){C=f[d+4>>2]|0;if((C|0)==1|(Y(C,B)|0)==0)_=B;else G=272}else _=1}else G=272;if((G|0)==272){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,68)|0;t=174031;v=s+68|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2709);d$(l);_=f[d>>2]|0}y=f[d+4>>2]|0;B=(Y(y,_)|0)>0;C=B?_+-1+y|0:0;y=f[a+12>>2]|0;if((C|0)!=(y|0)){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,11)|0;t=174532;v=s+11|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2712);d$(l)}B=f[a>>2]|0;if((B|0)>=0){u=j;return}n=B&4095;if(y>>>0>=C>>>0){u=j;return}B=l+4|0;w=y;do{A=q+(w*56|0)|0;p=f[A>>2]|0;if((p&4095|0)!=(n|0)){if(f[q+(w*56|0)+16>>2]|0){x=f[q+(w*56|0)+4>>2]|0;if((x|0)<3)$=Y(f[q+(w*56|0)+12>>2]|0,f[q+(w*56|0)+8>>2]|0)|0;else{R=f[q+(w*56|0)+40>>2]|0;r=0;z=1;while(1){S=Y(f[R+(r<<2)>>2]|0,z)|0;r=r+1|0;if((r|0)==(x|0)){$=S;break}else z=S}}if(!((x|0)==0|($|0)==0)){f[l>>2]=0;f[B>>2]=0;s=c$(l,12)|0;t=174501;v=s+12|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2720);d$(l);aa=f[A>>2]|0}else aa=p}else aa=p;f[A>>2]=aa&-4096|n}w=w+1|0}while(w>>>0<C>>>0);u=j;return}if((f[a+12>>2]|0)<=(g|0)){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,13)|0;t=173633;v=s+13|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2727);d$(l)}C=q+(g*56|0)|0;if(h){if(!(f[C>>2]&16384)){if((f[a>>2]|0)>>>0>1073741823){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,28)|0;t=173647;v=s+28|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2734);d$(l)}w=q+(g*56|0)+36|0;n=f[w>>2]|0;if((n|0?(B=n+12|0,n=f[B>>2]|0,f[B>>2]=n+-1,(n|0)==1):0)?(n=f[w>>2]|0,n|0):0){f[w>>2]=0;B=f[n+4>>2]|0;if(!B){y=f[q+(g*56|0)+32>>2]|0;if(!y)ba=sR()|0;else ba=y}else ba=B;Gh[f[(f[ba>>2]|0)+24>>2]&511](ba,n)}f[w>>2]=0;w=q+(g*56|0)+16|0;n=q+(g*56|0)+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[n>>2]|0)>0){w=f[q+(g*56|0)+40>>2]|0;B=0;do{f[w+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[n>>2]|0))}}if((((((c|0)==2?(f[q+(g*56|0)+4>>2]|0)==2:0)?f[q+(g*56|0)+16>>2]|0:0)?(f[C>>2]&4095|0)==(o|0):0)?(f[q+(g*56|0)+8>>2]|0)==(f[d+4>>2]|0):0)?(f[q+(g*56|0)+12>>2]|0)==(f[d>>2]|0):0){u=j;return}}n=f[a>>2]|0;do if((n|0)<0){B=f[C>>2]|0;if(((B^e)&4088|0)==0?1<<(n&4095)&i|0:0){ca=n;da=B&4095;break}if((o|0)!=(B&4095|0)){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,42)|0;t=173676;v=s+42|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2748);d$(l);ca=f[a>>2]|0;da=o}else{ca=n;da=o}}else{ca=n;da=o}while(0);if(ca&1073741824|0){if((f[q+(g*56|0)+4>>2]|0)!=(c|0)){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,11)|0;t=173719;v=s+11|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2753);d$(l)}if((c|0)>0){n=q+(g*56|0)+40|0;A=l+4|0;p=0;do{if((f[(f[n>>2]|0)+(p<<2)>>2]|0)!=(f[d+(p<<2)>>2]|0)){f[l>>2]=0;f[A>>2]=0;s=c$(l,21)|0;t=173731;v=s+21|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2755);d$(l)}p=p+1|0}while((p|0)<(c|0))}}AR(C,c,d,da);u=j;return}switch(D|0){case 720896:break;default:break b}p=f[a+4>>2]|0;if((g|0)<0){if((c|0)==2){A=f[d>>2]|0;if((A|0)!=1){n=f[d+4>>2]|0;if((n|0)==1|(Y(n,A)|0)==0){ea=A;fa=m}else G=329}else{ea=1;fa=m}}else G=329;if((G|0)==329){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,68)|0;t=174031;v=s+68|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2768);d$(l);ea=f[d>>2]|0;fa=f[a>>2]|0}C=f[d+4>>2]|0;A=(Y(C,ea)|0)>0;n=A?ea+-1+C|0:0;C=p+4|0;A=f[C>>2]|0;q=f[p>>2]|0;B=(A-q|0)/48|0;if((fa&1073741824|0)==0|(n|0)==(B|0)){ga=q;ha=A}else{f[l>>2]=0;f[l+4>>2]=0;s=c$(l,27)|0;t=174473;v=s+27|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2771);d$(l);ga=f[p>>2]|0;ha=f[C>>2]|0}A=(ha-ga|0)/48|0;q=ga;w=ha;if(n>>>0<=A>>>0){if(n>>>0<A>>>0?(y=q+(n*48|0)|0,(w|0)!=(y|0)):0){q=w;do{w=q+-48|0;f[C>>2]=w;j0(w);q=f[C>>2]|0}while((q|0)!=(y|0))}}else hS(p,n-A|0);y=f[a>>2]|0;if((y|0)>=0){u=j;return}q=y&4095;if(B>>>0>=n>>>0){u=j;return}y=l+4|0;C=f[p>>2]|0;w=B;while(1){x=f[C+(w*48|0)>>2]|0;if((x&4095|0)==(q|0))ia=C;else{if(f[C+(w*48|0)+24>>2]|0){z=f[C+(w*48|0)+4>>2]|0;if((z|0)<3)ja=Y(f[C+(w*48|0)+12>>2]|0,f[C+(w*48|0)+8>>2]|0)|0;else{r=f[C+(w*48|0)+32>>2]|0;R=0;S=1;while(1){ka=Y(f[r+(R<<2)>>2]|0,S)|0;R=R+1|0;if((R|0)==(z|0)){ja=ka;break}else S=ka}}if(!((z|0)==0|(ja|0)==0)){f[l>>2]=0;f[y>>2]=0;s=c$(l,12)|0;t=174501;v=s+12|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2780);d$(l);z=f[p>>2]|0;la=z;ma=f[z+(w*48|0)>>2]|0}else{la=C;ma=x}}else{la=C;ma=x}f[la+(w*48|0)>>2]=ma&-4096|q;ia=la}w=w+1|0;if(w>>>0>=n>>>0)break;else C=ia}u=j;return}C=f[p>>2]|0;if((((f[p+4>>2]|0)-C|0)/48|0|0)>(g|0))na=C;else{f[l>>2]=0;f[l+4>>2]=0;s=c$(l,17)|0;t=174514;v=s+17|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2787);d$(l);na=f[p>>2]|0}C=na+(g*48|0)|0;if(h){if(!(f[C>>2]&16384)){if((f[a>>2]|0)>>>0>1073741823){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,28)|0;t=173647;v=s+28|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2794);d$(l)}p=na+(g*48|0)+24|0;n=f[p>>2]|0;if(n|0?(w=n+8|0,n=f[w>>2]|0,f[w>>2]=n+-1,(n|0)==1):0)k0(C);n=na+(g*48|0)+4|0;if((f[n>>2]|0)>0){w=f[na+(g*48|0)+32>>2]|0;q=0;do{f[w+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[n>>2]|0))}f[p>>2]=0}if((((((c|0)==2?(f[na+(g*48|0)+4>>2]|0)==2:0)?f[na+(g*48|0)+24>>2]|0:0)?(f[C>>2]&4095|0)==(o|0):0)?(f[na+(g*48|0)+8>>2]|0)==(f[d+4>>2]|0):0)?(f[na+(g*48|0)+12>>2]|0)==(f[d>>2]|0):0){u=j;return}}n=f[a>>2]|0;do if((n|0)<0){q=f[C>>2]|0;if(((q^e)&4088|0)==0?1<<(n&4095)&i|0:0){oa=n;pa=q&4095;break}if((o|0)!=(q&4095|0)){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,42)|0;t=173676;v=s+42|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2808);d$(l);oa=f[a>>2]|0;pa=o}else{oa=n;pa=o}}else{oa=n;pa=o}while(0);if(oa&1073741824|0){if((f[na+(g*48|0)+4>>2]|0)!=(c|0)){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,11)|0;t=173719;v=s+11|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2812);d$(l)}if((c|0)>0){n=na+(g*48|0)+32|0;p=l+4|0;x=0;do{if((f[(f[n>>2]|0)+(x<<2)>>2]|0)!=(f[d+(x<<2)>>2]|0)){f[l>>2]=0;f[p>>2]=0;s=c$(l,21)|0;t=173731;v=s+21|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,357830,172446,2814);d$(l)}x=x+1|0}while((x|0)<(c|0))}}h0(C,c,d,pa,0);u=j;return}while(0);f[l>>2]=0;f[l+4>>2]=0;s=c$(l,30)|0;t=173557;v=s+30|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-213,l,357830,172446,2821);d$(l);u=j;return}function NR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;if(!((c|0)<0?(f[b>>2]&2031616|0)==65536:0)){OR(a,b,c);return}c=f[b+4>>2]|0;f[a>>2]=f[c>>2];b=a+4|0;d=c+4|0;f[b>>2]=f[d>>2];e=a+8|0;f[e>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];g=f[c+36>>2]|0;f[a+36>>2]=g;h=a+40|0;f[h>>2]=e;e=a+48|0;i=a+44|0;f[i>>2]=e;f[e>>2]=0;f[a+52>>2]=0;if(g|0){e=g+12|0;f[e>>2]=(f[e>>2]|0)+1}if((f[d>>2]|0)<3){e=f[c+44>>2]|0;g=f[i>>2]|0;f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];return}f[b>>2]=0;pR(a,f[d>>2]|0,0,0,0);if((f[b>>2]|0)<=0)return;d=f[c+40>>2]|0;a=f[h>>2]|0;h=f[c+44>>2]|0;c=f[i>>2]|0;i=0;do{f[a+(i<<2)>>2]=f[d+(i<<2)>>2];f[c+(i<<2)>>2]=f[h+(i<<2)>>2];i=i+1|0}while((i|0)<(f[b>>2]|0));return}function OR(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;e=u;u=u+144|0;g=e+136|0;h=e;i=e+80|0;j=e+72|0;k=e+64|0;l=e+56|0;m=f[c>>2]|0;n=m&50331648;do switch(m>>>16&31){case 1:{o=f[c+4>>2]|0;if((d|0)>=0){f[g>>2]=d;f[g+4>>2]=d+1;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;DR(a,o,g,h);u=e;return}f[a>>2]=f[o>>2];p=a+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=a+8|0;f[r>>2]=f[o+8>>2];f[a+12>>2]=f[o+12>>2];f[a+16>>2]=f[o+16>>2];f[a+20>>2]=f[o+20>>2];f[a+24>>2]=f[o+24>>2];f[a+28>>2]=f[o+28>>2];f[a+32>>2]=f[o+32>>2];s=f[o+36>>2]|0;f[a+36>>2]=s;t=a+40|0;f[t>>2]=r;r=a+48|0;v=a+44|0;f[v>>2]=r;f[r>>2]=0;f[a+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){r=f[o+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];u=e;return}f[p>>2]=0;pR(a,f[q>>2]|0,0,0,0);if((f[p>>2]|0)<=0){u=e;return}q=f[o+40>>2]|0;r=f[t>>2]|0;t=f[o+44>>2]|0;o=f[v>>2]|0;v=0;do{f[r+(v<<2)>>2]=f[q+(v<<2)>>2];f[o+(v<<2)>>2]=f[t+(v<<2)>>2];v=v+1|0}while((v|0)<(f[p>>2]|0));u=e;return}case 10:{p=f[c+4>>2]|0;if((d|0)<0){r0(a,p,n);u=e;return}r0(i,p,n);f[g>>2]=d;f[g+4>>2]=d+1;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;DR(a,i,g,h);p=i+36|0;v=f[p>>2]|0;if((v|0?(t=v+12|0,v=f[t>>2]|0,f[t>>2]=v+-1,(v|0)==1):0)?(v=f[p>>2]|0,v|0):0){f[p>>2]=0;t=f[v+4>>2]|0;if(!t){o=f[i+32>>2]|0;if(!o)w=sR()|0;else w=o}else w=t;Gh[f[(f[w>>2]|0)+24>>2]&511](w,v)}f[p>>2]=0;p=i+16|0;v=i+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[v>>2]|0)>0){p=f[i+40>>2]|0;t=0;do{f[p+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[v>>2]|0))}v=f[i+44>>2]|0;if((v|0)==(i+48|0)){u=e;return}ZF(v);u=e;return}case 6:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;v=c$(g,5)|0;b[v>>0]=b[173319]|0;b[v+1>>0]=b[173320]|0;b[v+2>>0]=b[173321]|0;b[v+3>>0]=b[173322]|0;b[v+4>>0]=b[173323]|0;j$(-215,g,173325,172446,1225);d$(g)}PR(a,f[c+4>>2]|0);u=e;return}case 2:case 14:{if((d|0)<0)x=m;else{f[g>>2]=0;f[g+4>>2]=0;v=c$(g,5)|0;b[v>>0]=b[173319]|0;b[v+1>>0]=b[173320]|0;b[v+2>>0]=b[173321]|0;b[v+3>>0]=b[173322]|0;b[v+4>>0]=b[173323]|0;j$(-215,g,173325,172446,1231);d$(g);x=f[c>>2]|0}f[j>>2]=f[c+8>>2];f[j+4>>2]=f[c+12>>2];CN(a,j,x,f[c+4>>2]|0,0);u=e;return}case 3:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;v=c$(g,5)|0;b[v>>0]=b[173319]|0;b[v+1>>0]=b[173320]|0;b[v+2>>0]=b[173321]|0;b[v+3>>0]=b[173322]|0;b[v+4>>0]=b[173323]|0;j$(-215,g,173325,172446,1237);d$(g)}v=f[c+4>>2]|0;if((f[v>>2]|0)==(f[v+4>>2]|0)){f[a>>2]=1124007936;t=a+8|0;p=a+40|0;y=a+4|0;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[p>>2]=t;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;u=e;return}o=f[c>>2]|0;QR(k,c,-1);q=f[v>>2]|0;r=o&4095|1124007936;f[a>>2]=r;f[a+4>>2]=2;s=a+8|0;A=f[k+4>>2]|0;f[s>>2]=A;B=a+12|0;C=f[k>>2]|0;f[B>>2]=C;f[a+16>>2]=q;D=a+20|0;f[D>>2]=q;E=a+24|0;F=a+28|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;f[a+40>>2]=s;G=a+48|0;H=a+44|0;f[H>>2]=G;f[a+52>>2]=0;f[G>>2]=0;if((q|0)==0&(Y(C,A)|0)!=0){f[g>>2]=0;f[g+4>>2]=0;y=c$(g,26)|0;I=358223;z=y+26|0;do{b[y>>0]=b[I>>0]|0;y=y+1|0;I=I+1|0}while((y|0)<(z|0));j$(-215,g,358250,358254,533);d$(g);J=f[B>>2]|0;K=f[a>>2]|0;L=f[H>>2]|0;M=f[D>>2]|0}else{J=C;K=r;L=G;M=q}v=(o>>>3&511)+1<<(47696>>>(o<<1&14)&3);t=Y(J,v)|0;f[a>>2]=K|16384;f[L>>2]=t;f[L+4>>2]=v;v=M+(Y(f[s>>2]|0,t)|0)|0;f[F>>2]=v;f[E>>2]=v+(0-t)+t;u=e;return}case 12:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;t=c$(g,5)|0;b[t>>0]=b[173319]|0;b[t+1>>0]=b[173320]|0;b[t+2>>0]=b[173321]|0;b[t+3>>0]=b[173322]|0;b[t+4>>0]=b[173323]|0;j$(-215,g,173325,172446,1246);d$(g)}t=f[c+4>>2]|0;v=f[t+4>>2]|0;if(!v){f[a>>2]=1124007936;p=a+8|0;A=a+40|0;y=a+4|0;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[A>>2]=p;E=a+48|0;f[a+44>>2]=E;f[E>>2]=0;f[a+52>>2]=0;u=e;return}f[h>>2]=1124007936;E=h+4|0;F=h+8|0;s=h+40|0;y=E;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[s>>2]=F;p=h+48|0;A=h+44|0;f[A>>2]=p;f[p>>2]=0;f[h+52>>2]=0;f[g>>2]=1;f[g+4>>2]=v;AR(h,2,g,0);o=h+16|0;q=f[o>>2]|0;if((v|0)>0){G=0;do{b[q+G>>0]=(f[(f[t>>2]|0)+(G>>>5<<2)>>2]&1<<(G&31)|0)!=0&1;G=G+1|0}while((G|0)!=(v|0));N=f[o>>2]|0}else N=q;f[a>>2]=f[h>>2];v=a+4|0;G=f[E>>2]|0;f[v>>2]=G;t=a+8|0;f[t>>2]=f[F>>2];f[a+12>>2]=f[h+12>>2];f[a+16>>2]=N;f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];r=h+32|0;f[a+32>>2]=f[r>>2];C=h+36|0;D=f[C>>2]|0;f[a+36>>2]=D;H=a+40|0;f[H>>2]=t;t=a+48|0;B=a+44|0;f[B>>2]=t;f[t>>2]=0;f[a+52>>2]=0;if(!D)O=G;else{G=D+12|0;f[G>>2]=(f[G>>2]|0)+1;O=f[E>>2]|0}if((O|0)>=3){f[v>>2]=0;pR(a,O,0,0,0);if((f[v>>2]|0)>0){G=f[s>>2]|0;D=f[H>>2]|0;H=f[A>>2]|0;t=f[B>>2]|0;P=0;do{f[D+(P<<2)>>2]=f[G+(P<<2)>>2];f[t+(P<<2)>>2]=f[H+(P<<2)>>2];P=P+1|0}while((P|0)<(f[v>>2]|0))}}else{v=f[A>>2]|0;P=f[B>>2]|0;f[P>>2]=f[v>>2];f[P+4>>2]=f[v+4>>2]}v=f[C>>2]|0;if((v|0?(P=v+12|0,v=f[P>>2]|0,f[P>>2]=v+-1,(v|0)==1):0)?(v=f[C>>2]|0,v|0):0){f[C>>2]=0;P=f[v+4>>2]|0;if(!P){H=f[r>>2]|0;if(!H)Q=sR()|0;else Q=H}else Q=P;Gh[f[(f[Q>>2]|0)+24>>2]&511](Q,v)}f[C>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[E>>2]|0)>0){v=f[s>>2]|0;P=0;do{f[v+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[E>>2]|0))}E=f[A>>2]|0;if((E|0)!=(p|0))ZF(E);u=e;return}case 0:{f[a>>2]=1124007936;E=a+8|0;P=a+40|0;y=a+4|0;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[P>>2]=E;p=a+48|0;f[a+44>>2]=p;f[p>>2]=0;f[a+52>>2]=0;u=e;return}case 4:{p=RR(c,d)|0;A=f[c+4>>2]|0;if((d|0)>-1?(v=f[A>>2]|0,(((f[A+4>>2]|0)-v|0)/12|0|0)>(d|0)):0)R=v;else{f[g>>2]=0;f[g+4>>2]=0;y=c$(g,28)|0;I=173333;z=y+28|0;do{b[y>>0]=b[I>>0]|0;y=y+1|0;I=I+1|0}while((y|0)<(z|0));j$(-215,g,173325,172446,1266);d$(g);R=f[A>>2]|0}E=R+(d*12|0)|0;if((f[E>>2]|0)==(f[R+(d*12|0)+4>>2]|0)){f[a>>2]=1124007936;P=a+8|0;v=a+40|0;y=a+4|0;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[v>>2]=P;A=a+48|0;f[a+44>>2]=A;f[A>>2]=0;f[a+52>>2]=0;u=e;return}QR(l,c,d);A=f[E>>2]|0;s=p&4095|1124007936;f[a>>2]=s;f[a+4>>2]=2;o=a+8|0;C=f[l+4>>2]|0;f[o>>2]=C;r=a+12|0;B=f[l>>2]|0;f[r>>2]=B;f[a+16>>2]=A;H=a+20|0;f[H>>2]=A;t=a+24|0;G=a+28|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[a+40>>2]=o;D=a+48|0;F=a+44|0;f[F>>2]=D;f[a+52>>2]=0;f[D>>2]=0;if((A|0)==0&(Y(B,C)|0)!=0){f[g>>2]=0;f[g+4>>2]=0;y=c$(g,26)|0;I=358223;z=y+26|0;do{b[y>>0]=b[I>>0]|0;y=y+1|0;I=I+1|0}while((y|0)<(z|0));j$(-215,g,358250,358254,533);d$(g);S=f[r>>2]|0;T=f[a>>2]|0;U=f[F>>2]|0;V=f[H>>2]|0}else{S=B;T=s;U=D;V=A}E=(p>>>3&511)+1<<(47696>>>(p<<1&14)&3);P=Y(S,E)|0;f[a>>2]=T|16384;f[U>>2]=P;f[U+4>>2]=E;E=V+(Y(f[o>>2]|0,P)|0)|0;f[G>>2]=E;f[t>>2]=E+(0-P)+P;u=e;return}case 5:{P=f[c+4>>2]|0;if((d|0)>-1?(E=f[P>>2]|0,(((f[P+4>>2]|0)-E|0)/56|0|0)>(d|0)):0)W=E;else{f[g>>2]=0;f[g+4>>2]=0;y=c$(g,27)|0;I=173362;z=y+27|0;do{b[y>>0]=b[I>>0]|0;y=y+1|0;I=I+1|0}while((y|0)<(z|0));j$(-215,g,173325,172446,1275);d$(g);W=f[P>>2]|0}f[a>>2]=f[W+(d*56|0)>>2];t=a+4|0;G=W+(d*56|0)+4|0;f[t>>2]=f[G>>2];o=a+8|0;f[o>>2]=f[W+(d*56|0)+8>>2];f[a+12>>2]=f[W+(d*56|0)+12>>2];f[a+16>>2]=f[W+(d*56|0)+16>>2];f[a+20>>2]=f[W+(d*56|0)+20>>2];f[a+24>>2]=f[W+(d*56|0)+24>>2];f[a+28>>2]=f[W+(d*56|0)+28>>2];f[a+32>>2]=f[W+(d*56|0)+32>>2];p=f[W+(d*56|0)+36>>2]|0;f[a+36>>2]=p;A=a+40|0;f[A>>2]=o;o=a+48|0;D=a+44|0;f[D>>2]=o;f[o>>2]=0;f[a+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[G>>2]|0)<3){o=f[W+(d*56|0)+44>>2]|0;p=f[D>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];u=e;return}f[t>>2]=0;pR(a,f[G>>2]|0,0,0,0);if((f[t>>2]|0)<=0){u=e;return}G=f[W+(d*56|0)+40>>2]|0;o=f[A>>2]|0;A=f[W+(d*56|0)+44>>2]|0;p=f[D>>2]|0;D=0;do{f[o+(D<<2)>>2]=f[G+(D<<2)>>2];f[p+(D<<2)>>2]=f[A+(D<<2)>>2];D=D+1|0}while((D|0)<(f[t>>2]|0));u=e;return}case 15:{t=f[c+4>>2]|0;if(!((d|0)>-1?(f[c+12>>2]|0)>(d|0):0)){f[g>>2]=0;f[g+4>>2]=0;y=c$(g,23)|0;I=173390;z=y+23|0;do{b[y>>0]=b[I>>0]|0;y=y+1|0;I=I+1|0}while((y|0)<(z|0));j$(-215,g,173325,172446,1283);d$(g)}f[a>>2]=f[t+(d*56|0)>>2];D=a+4|0;A=t+(d*56|0)+4|0;f[D>>2]=f[A>>2];p=a+8|0;f[p>>2]=f[t+(d*56|0)+8>>2];f[a+12>>2]=f[t+(d*56|0)+12>>2];f[a+16>>2]=f[t+(d*56|0)+16>>2];f[a+20>>2]=f[t+(d*56|0)+20>>2];f[a+24>>2]=f[t+(d*56|0)+24>>2];f[a+28>>2]=f[t+(d*56|0)+28>>2];f[a+32>>2]=f[t+(d*56|0)+32>>2];G=f[t+(d*56|0)+36>>2]|0;f[a+36>>2]=G;o=a+40|0;f[o>>2]=p;p=a+48|0;P=a+44|0;f[P>>2]=p;f[p>>2]=0;f[a+52>>2]=0;if(G|0){p=G+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[A>>2]|0)<3){p=f[t+(d*56|0)+44>>2]|0;G=f[P>>2]|0;f[G>>2]=f[p>>2];f[G+4>>2]=f[p+4>>2];u=e;return}f[D>>2]=0;pR(a,f[A>>2]|0,0,0,0);if((f[D>>2]|0)<=0){u=e;return}A=f[t+(d*56|0)+40>>2]|0;p=f[o>>2]|0;o=f[t+(d*56|0)+44>>2]|0;G=f[P>>2]|0;P=0;do{f[p+(P<<2)>>2]=f[A+(P<<2)>>2];f[G+(P<<2)>>2]=f[o+(P<<2)>>2];P=P+1|0}while((P|0)<(f[D>>2]|0));u=e;return}case 11:{D=f[c+4>>2]|0;if((d|0)>-1?(P=f[D>>2]|0,(((f[D+4>>2]|0)-P|0)/48|0|0)>(d|0)):0)X=P;else{f[g>>2]=0;f[g+4>>2]=0;y=c$(g,27)|0;I=173362;z=y+27|0;do{b[y>>0]=b[I>>0]|0;y=y+1|0;I=I+1|0}while((y|0)<(z|0));j$(-215,g,173325,172446,1291);d$(g);X=f[D>>2]|0}r0(a,X+(d*48|0)|0,n);u=e;return}case 7:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;P=c$(g,5)|0;b[P>>0]=b[173319]|0;b[P+1>>0]=b[173320]|0;b[P+2>>0]=b[173321]|0;b[P+3>>0]=b[173322]|0;b[P+4>>0]=b[173323]|0;j$(-215,g,173325,172446,1298);d$(g)}f[g>>2]=0;f[g+4>>2]=0;y=c$(g,75)|0;I=173414;z=y+75|0;do{b[y>>0]=b[I>>0]|0;y=y+1|0;I=I+1|0}while((y|0)<(z|0));j$(-213,g,173325,172446,1299);d$(g);f[a>>2]=1124007936;D=a+8|0;P=a+40|0;y=a+4|0;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[P>>2]=D;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;u=e;return}case 9:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;o=c$(g,5)|0;b[o>>0]=b[173319]|0;b[o+1>>0]=b[173320]|0;b[o+2>>0]=b[173321]|0;b[o+3>>0]=b[173322]|0;b[o+4>>0]=b[173323]|0;j$(-215,g,173325,172446,1305);d$(g)}f[g>>2]=0;f[g+4>>2]=0;y=c$(g,66)|0;I=173490;z=y+66|0;do{b[y>>0]=b[I>>0]|0;y=y+1|0;I=I+1|0}while((y|0)<(z|0));j$(-213,g,173325,172446,1306);d$(g);f[a>>2]=1124007936;D=a+8|0;P=a+40|0;y=a+4|0;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[P>>2]=D;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;u=e;return}case 8:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;o=c$(g,5)|0;b[o>>0]=b[173319]|0;b[o+1>>0]=b[173320]|0;b[o+2>>0]=b[173321]|0;b[o+3>>0]=b[173322]|0;b[o+4>>0]=b[173323]|0;j$(-215,g,173325,172446,1312);d$(g)}o=f[c+4>>2]|0;G=f[o+4>>2]|0;f[g>>2]=f[o+8>>2];f[g+4>>2]=G;CN(a,g,f[o>>2]&4095,f[o+16>>2]|0,f[o+12>>2]|0);u=e;return}default:{f[g>>2]=0;f[g+4>>2]=0;y=c$(g,30)|0;I=173557;z=y+30|0;do{b[y>>0]=b[I>>0]|0;y=y+1|0;I=I+1|0}while((y|0)<(z|0));j$(-213,g,173325,172446,1319);d$(g);f[a>>2]=1124007936;D=a+8|0;P=a+40|0;y=a+4|0;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[P>>2]=D;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;u=e;return}}while(0)}function PR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;f[a>>2]=1124007936;c=a+8|0;d=a+40|0;e=a+4|0;g=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[d>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;c=f[b>>2]|0;Ah[f[(f[c>>2]|0)+12>>2]&255](c,b,a,-1);return}function QR(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+16|0;g=e;do switch((f[c>>2]|0)>>>16&31){case 1:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;h=c$(g,5)|0;b[h>>0]=b[173319]|0;b[h+1>>0]=b[173320]|0;b[h+2>>0]=b[173321]|0;b[h+3>>0]=b[173322]|0;b[h+4>>0]=b[173323]|0;j$(-215,g,338897,172446,1592);d$(g)}h=f[(f[c+4>>2]|0)+40>>2]|0;i=f[h>>2]|0;f[a>>2]=f[h+4>>2];f[a+4>>2]=i;u=e;return}case 6:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;i=c$(g,5)|0;b[i>>0]=b[173319]|0;b[i+1>>0]=b[173320]|0;b[i+2>>0]=b[173321]|0;b[i+3>>0]=b[173322]|0;b[i+4>>0]=b[173323]|0;j$(-215,g,338897,172446,1598);d$(g)}SQ(a,f[c+4>>2]|0);u=e;return}case 10:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;i=c$(g,5)|0;b[i>>0]=b[173319]|0;b[i+1>>0]=b[173320]|0;b[i+2>>0]=b[173321]|0;b[i+3>>0]=b[173322]|0;b[i+4>>0]=b[173323]|0;j$(-215,g,338897,172446,1604);d$(g)}i=f[(f[c+4>>2]|0)+32>>2]|0;h=f[i>>2]|0;f[a>>2]=f[i+4>>2];f[a+4>>2]=h;u=e;return}case 2:case 14:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;h=c$(g,5)|0;b[h>>0]=b[173319]|0;b[h+1>>0]=b[173320]|0;b[h+2>>0]=b[173321]|0;b[h+3>>0]=b[173322]|0;b[h+4>>0]=b[173323]|0;j$(-215,g,338897,172446,1610);d$(g)}f[a>>2]=f[c+8>>2];f[a+4>>2]=f[c+12>>2];u=e;return}case 3:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;h=c$(g,5)|0;b[h>>0]=b[173319]|0;b[h+1>>0]=b[173320]|0;b[h+2>>0]=b[173321]|0;b[h+3>>0]=b[173322]|0;b[h+4>>0]=b[173323]|0;j$(-215,g,338897,172446,1616);d$(g)}h=f[c+4>>2]|0;i=(f[h+4>>2]|0)-(f[h>>2]|0)|0;if((i|0)==(i>>2|0)){f[a>>2]=i;f[a+4>>2]=1;u=e;return}else{h=f[c>>2]|0;f[a>>2]=(i>>>0)/((h>>>3&511)+1<<(47696>>>(h<<1&14)&3)>>>0)|0;f[a+4>>2]=1;u=e;return}break}case 12:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;h=c$(g,5)|0;b[h>>0]=b[173319]|0;b[h+1>>0]=b[173320]|0;b[h+2>>0]=b[173321]|0;b[h+3>>0]=b[173322]|0;b[h+4>>0]=b[173323]|0;j$(-215,g,338897,172446,1625);d$(g)}f[a>>2]=f[(f[c+4>>2]|0)+4>>2];f[a+4>>2]=1;u=e;return}case 0:{f[a>>2]=0;f[a+4>>2]=0;u=e;return}case 4:{h=c+4|0;i=f[h>>2]|0;if((d|0)<0){j=f[i>>2]|0;k=f[i+4>>2]|0;if((j|0)==(k|0)){f[a>>2]=0;f[a+4>>2]=0;u=e;return}else{f[a>>2]=(k-j|0)/12|0;f[a+4>>2]=1;u=e;return}}j=f[i>>2]|0;if((((f[i+4>>2]|0)-j|0)/12|0|0)>(d|0)){l=j;m=i}else{f[g>>2]=0;f[g+4>>2]=0;n=c$(g,18)|0;o=173614;p=n+18|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-215,g,338897,172446,1638);d$(g);l=f[i>>2]|0;m=f[h>>2]|0}j=(f[l+(d*12|0)+4>>2]|0)-(f[l+(d*12|0)>>2]|0)|0;k=f[m>>2]|0;if((j|0)==((f[k+(d*12|0)+4>>2]|0)-(f[k+(d*12|0)>>2]|0)>>2|0)){f[a>>2]=j;f[a+4>>2]=1;u=e;return}else{k=f[c>>2]|0;f[a>>2]=(j>>>0)/((k>>>3&511)+1<<(47696>>>(k<<1&14)&3)>>>0)|0;f[a+4>>2]=1;u=e;return}break}case 5:{k=f[c+4>>2]|0;if((d|0)<0){j=f[k>>2]|0;q=f[k+4>>2]|0;if((j|0)==(q|0)){f[a>>2]=0;f[a+4>>2]=0;u=e;return}else{f[a>>2]=(q-j|0)/56|0;f[a+4>>2]=1;u=e;return}}else{j=f[k>>2]|0;if((((f[k+4>>2]|0)-j|0)/56|0|0)>(d|0))r=j;else{f[g>>2]=0;f[g+4>>2]=0;n=c$(g,18)|0;o=173614;p=n+18|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-215,g,338897,172446,1650);d$(g);r=f[k>>2]|0}h=f[r+(d*56|0)+40>>2]|0;i=f[h>>2]|0;f[a>>2]=f[h+4>>2];f[a+4>>2]=i;u=e;return}break}case 15:{i=f[c+4>>2]|0;h=f[c+12>>2]|0;if((d|0)>=0){if((h|0)<=(d|0)){f[g>>2]=0;f[g+4>>2]=0;n=c$(g,13)|0;o=173633;p=n+13|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-215,g,338897,172446,1660);d$(g)}k=f[i+(d*56|0)+40>>2]|0;j=f[k>>2]|0;f[a>>2]=f[k+4>>2];f[a+4>>2]=j;u=e;return}if(!h){f[a>>2]=0;f[a+4>>2]=0;u=e;return}else{f[a>>2]=h;f[a+4>>2]=1;u=e;return}break}case 13:{j=f[c+4>>2]|0;if((d|0)<0){k=f[j>>2]|0;q=f[j+4>>2]|0;if((k|0)==(q|0)){f[a>>2]=0;f[a+4>>2]=0;u=e;return}else{f[a>>2]=(q-k|0)/36|0;f[a+4>>2]=1;u=e;return}}else{k=f[j>>2]|0;if((((f[j+4>>2]|0)-k|0)/36|0|0)>(d|0))s=k;else{f[g>>2]=0;f[g+4>>2]=0;n=c$(g,18)|0;o=173614;p=n+18|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-215,g,338897,172446,1670);d$(g);s=f[j>>2]|0}h=f[s+(d*36|0)+4>>2]|0;f[a>>2]=f[s+(d*36|0)+8>>2];f[a+4>>2]=h;u=e;return}break}case 11:{h=f[c+4>>2]|0;if((d|0)<0){i=f[h>>2]|0;k=f[h+4>>2]|0;if((i|0)==(k|0)){f[a>>2]=0;f[a+4>>2]=0;u=e;return}else{f[a>>2]=(k-i|0)/48|0;f[a+4>>2]=1;u=e;return}}else{i=f[h>>2]|0;if((((f[h+4>>2]|0)-i|0)/48|0|0)>(d|0))t=i;else{f[g>>2]=0;f[g+4>>2]=0;n=c$(g,18)|0;o=173614;p=n+18|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-215,g,338897,172446,1679);d$(g);t=f[h>>2]|0}j=f[t+(d*48|0)+32>>2]|0;i=f[j>>2]|0;f[a>>2]=f[j+4>>2];f[a+4>>2]=i;u=e;return}break}case 7:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;i=c$(g,5)|0;b[i>>0]=b[173319]|0;b[i+1>>0]=b[173320]|0;b[i+2>>0]=b[173321]|0;b[i+3>>0]=b[173322]|0;b[i+4>>0]=b[173323]|0;j$(-215,g,338897,172446,1686);d$(g)}i=f[c+4>>2]|0;j=f[i+8>>2]|0;f[a>>2]=f[i+12>>2];f[a+4>>2]=j;u=e;return}case 9:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;j=c$(g,5)|0;b[j>>0]=b[173319]|0;b[j+1>>0]=b[173320]|0;b[j+2>>0]=b[173321]|0;b[j+3>>0]=b[173322]|0;b[j+4>>0]=b[173323]|0;j$(-215,g,338897,172446,1693);d$(g)}j=f[c+4>>2]|0;i=f[j+4>>2]|0;f[a>>2]=f[j+8>>2];f[a+4>>2]=i;u=e;return}case 8:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;i=c$(g,5)|0;b[i>>0]=b[173319]|0;b[i+1>>0]=b[173320]|0;b[i+2>>0]=b[173321]|0;b[i+3>>0]=b[173322]|0;b[i+4>>0]=b[173323]|0;j$(-215,g,338897,172446,1700);d$(g)}i=f[c+4>>2]|0;j=f[i+4>>2]|0;f[a>>2]=f[i+8>>2];f[a+4>>2]=j;u=e;return}default:{f[g>>2]=0;f[g+4>>2]=0;n=c$(g,30)|0;o=173557;p=n+30|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-213,g,338897,172446,1705);d$(g);f[a>>2]=0;f[a+4>>2]=0;u=e;return}}while(0)}function RR(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;do switch(g>>>16&31){case 1:{h=f[f[a+4>>2]>>2]&4095;u=d;return h|0}case 10:{h=f[f[a+4>>2]>>2]&4095;u=d;return h|0}case 6:{h=TQ(f[a+4>>2]|0)|0;u=d;return h|0}case 2:case 3:case 4:case 12:case 14:{h=g&4095;u=d;return h|0}case 11:{i=f[a+4>>2]|0;j=f[i>>2]|0;k=f[i+4>>2]|0;if((j|0)==(k|0)){if((g|0)<0)l=g;else{f[e>>2]=0;f[e+4>>2]=0;m=c$(e,25)|0;n=173588;o=m+25|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,e,312091,172446,1982);d$(e);l=f[a>>2]|0}h=l&4095;u=d;return h|0}else{if(((k-j|0)/48|0|0)>(c|0))p=j;else{f[e>>2]=0;f[e+4>>2]=0;m=c$(e,18)|0;n=173614;o=m+18|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,e,312091,172446,1985);d$(e);p=f[i>>2]|0}h=f[p+(((c|0)>0?c:0)*48|0)>>2]&4095;u=d;return h|0}break}case 5:{j=f[a+4>>2]|0;k=f[j>>2]|0;q=f[j+4>>2]|0;if((k|0)==(q|0)){if((g|0)<0)r=g;else{f[e>>2]=0;f[e+4>>2]=0;m=c$(e,25)|0;n=173588;o=m+25|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,e,312091,172446,1994);d$(e);r=f[a>>2]|0}h=r&4095;u=d;return h|0}else{if(((q-k|0)/56|0|0)>(c|0))s=k;else{f[e>>2]=0;f[e+4>>2]=0;m=c$(e,18)|0;n=173614;o=m+18|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,e,312091,172446,1997);d$(e);s=f[j>>2]|0}h=f[s+(((c|0)>0?c:0)*56|0)>>2]&4095;u=d;return h|0}break}case 15:{k=f[a+4>>2]|0;q=f[a+12>>2]|0;if(!q){if((g|0)<0)t=g;else{f[e>>2]=0;f[e+4>>2]=0;m=c$(e,25)|0;n=173588;o=m+25|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,e,312091,172446,2006);d$(e);t=f[a>>2]|0}h=t&4095;u=d;return h|0}else{if((q|0)<=(c|0)){f[e>>2]=0;f[e+4>>2]=0;m=c$(e,13)|0;n=173633;o=m+13|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,e,312091,172446,2009);d$(e)}h=f[k+(((c|0)>0?c:0)*56|0)>>2]&4095;u=d;return h|0}break}case 13:{q=f[a+4>>2]|0;j=f[q>>2]|0;i=f[q+4>>2]|0;if((j|0)==(i|0)){if((g|0)<0)v=g;else{f[e>>2]=0;f[e+4>>2]=0;m=c$(e,25)|0;n=173588;o=m+25|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,e,312091,172446,2018);d$(e);v=f[a>>2]|0}h=v&4095;u=d;return h|0}else{if(((i-j|0)/36|0|0)>(c|0))w=j;else{f[e>>2]=0;f[e+4>>2]=0;m=c$(e,18)|0;n=173614;o=m+18|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,e,312091,172446,2021);d$(e);w=f[q>>2]|0}h=f[w+(((c|0)>0?c:0)*36|0)>>2]&4095;u=d;return h|0}break}case 7:{h=f[(f[a+4>>2]|0)+16>>2]|0;u=d;return h|0}case 9:{h=f[f[a+4>>2]>>2]&4095;u=d;return h|0}case 8:{h=f[f[a+4>>2]>>2]&4095;u=d;return h|0}case 0:{h=-1;u=d;return h|0}default:{f[e>>2]=0;f[e+4>>2]=0;m=c$(e,30)|0;n=173557;o=m+30|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-213,e,312091,172446,2034);d$(e);h=0;u=d;return h|0}}while(0);return 0}function SR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+32|0;d=c;e=f[a+8>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/12|0)>>>0>=b>>>0){F1a(h|0,0,b*12|0)|0;f[g>>2]=h+(b*12|0);u=c;return}g=f[a>>2]|0;i=(h-g|0)/12|0;h=i+b|0;if(h>>>0>357913941)gXa(a);j=(e-g|0)/12|0;g=j<<1;e=j>>>0<178956970?(g>>>0<h>>>0?h:g):357913941;f[d+12>>2]=0;f[d+16>>2]=a+8;do if(e)if(e>>>0>357913941){g=De(8)|0;UYa(g,358155);f[g>>2]=130560;Of(g|0,21520,875)}else{k=NYa(e*12|0)|0;break}else k=0;while(0);f[d>>2]=k;g=k+(i*12|0)|0;i=d+8|0;h=d+4|0;f[h>>2]=g;f[d+12>>2]=k+(e*12|0);F1a(g|0,0,b*12|0)|0;f[i>>2]=g+(b*12|0);jS(a,d);a=f[h>>2]|0;h=f[i>>2]|0;if((h|0)!=(a|0)){b=h;while(1){h=b+-12|0;f[i>>2]=h;g=f[h>>2]|0;if(!g)l=h;else{h=b+-8|0;if((f[h>>2]|0)!=(g|0))f[h>>2]=g;PYa(g);l=f[i>>2]|0}if((l|0)==(a|0))break;else b=l}}l=f[d>>2]|0;if(l|0)PYa(l);u=c;return}function TR(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if((e-h|0)>>>0>=c>>>0){i=h;j=c;do{b[i>>0]=0;i=(f[g>>2]|0)+1|0;f[g>>2]=i;j=j+-1|0}while((j|0)!=0);return}j=f[a>>2]|0;i=h-j|0;h=i+c|0;if((h|0)<0)gXa(a);k=e-j|0;j=k<<1;e=k>>>0<1073741823?(j>>>0<h>>>0?h:j):2147483647;if(!e)l=0;else l=NYa(e)|0;j=l+i|0;i=l+e|0;e=j;l=c;c=j;do{b[e>>0]=0;e=c+1|0;c=e;l=l+-1|0}while((l|0)!=0);l=f[a>>2]|0;e=(f[g>>2]|0)-l|0;h=j+(0-e)|0;if((e|0)>0)K1a(h|0,l|0,e|0)|0;f[a>>2]=h;f[g>>2]=c;f[d>>2]=i;if(!l)return;PYa(l);return}
function UR(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>1>>>0>=c>>>0){i=h;j=c;do{b[i>>0]=0;b[i+1>>0]=0;i=(f[g>>2]|0)+2|0;f[g>>2]=i;j=j+-1|0}while((j|0)!=0);return}j=f[a>>2]|0;i=h-j>>1;h=i+c|0;if((h|0)<0)gXa(a);k=e-j|0;j=k>>1>>>0<1073741823?(k>>>0<h>>>0?h:k):2147483647;do if(j)if((j|0)<0){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{l=NYa(j<<1)|0;break}else l=0;while(0);k=l+(i<<1)|0;i=k;h=l+(j<<1)|0;j=k;l=c;c=i;do{b[j>>0]=0;b[j+1>>0]=0;j=c+2|0;c=j;l=l+-1|0}while((l|0)!=0);l=h;h=f[a>>2]|0;j=f[g>>2]|0;if((j|0)==(h|0)){m=i;n=h}else{e=k;k=j;j=i;do{i=k;k=k+-2|0;b[e+-2>>0]=b[k>>0]|0;b[e+-1>>0]=b[i+-1>>0]|0;e=j+-2|0;j=e}while((k|0)!=(h|0));m=j;n=f[a>>2]|0}f[a>>2]=m;f[g>>2]=c;f[d>>2]=l;if(!n)return;PYa(n);return}function VR(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/3|0)>>>0>=c>>>0){i=h;j=c;do{b[i>>0]=0;b[i+1>>0]=0;b[i+2>>0]=0;i=(f[g>>2]|0)+3|0;f[g>>2]=i;j=j+-1|0}while((j|0)!=0);return}j=f[a>>2]|0;i=(h-j|0)/3|0;h=i+c|0;if(h>>>0>1431655765)gXa(a);k=(e-j|0)/3|0;j=k<<1;e=k>>>0<715827882?(j>>>0<h>>>0?h:j):1431655765;do if(e)if(e>>>0>1431655765){j=De(8)|0;UYa(j,358155);f[j>>2]=130560;Of(j|0,21520,875)}else{l=NYa(e*3|0)|0;break}else l=0;while(0);j=l+(i*3|0)|0;i=j;h=l+(e*3|0)|0;e=j;l=c;c=i;do{b[e>>0]=0;b[e+1>>0]=0;b[e+2>>0]=0;e=c+3|0;c=e;l=l+-1|0}while((l|0)!=0);l=h;h=f[a>>2]|0;e=f[g>>2]|0;if((e|0)==(h|0)){m=i;n=h}else{k=j;j=e;e=i;do{i=j;j=j+-3|0;b[k+-3>>0]=b[j>>0]|0;b[k+-2>>0]=b[i+-2>>0]|0;b[k+-1>>0]=b[i+-1>>0]|0;k=e+-3|0;e=k}while((j|0)!=(h|0));m=e;n=f[a>>2]|0}f[a>>2]=m;f[g>>2]=c;f[d>>2]=l;if(!n)return;PYa(n);return}function WR(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;e=f[c>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/6|0)>>>0>=b>>>0){i=h;j=b;do{d[i>>1]=0;d[i+2>>1]=0;d[i+4>>1]=0;i=(f[g>>2]|0)+6|0;f[g>>2]=i;j=j+-1|0}while((j|0)!=0);return}j=f[a>>2]|0;i=(h-j|0)/6|0;h=i+b|0;if(h>>>0>715827882)gXa(a);k=(e-j|0)/6|0;j=k<<1;e=k>>>0<357913941?(j>>>0<h>>>0?h:j):715827882;do if(e)if(e>>>0>715827882){j=De(8)|0;UYa(j,358155);f[j>>2]=130560;Of(j|0,21520,875)}else{l=NYa(e*6|0)|0;break}else l=0;while(0);j=l+(i*6|0)|0;i=j;h=l+(e*6|0)|0;e=j;l=b;b=i;do{d[e>>1]=0;d[e+2>>1]=0;d[e+4>>1]=0;e=b+6|0;b=e;l=l+-1|0}while((l|0)!=0);l=h;h=f[a>>2]|0;e=f[g>>2]|0;if((e|0)==(h|0)){m=i;n=h}else{i=j;j=e;do{e=j;j=j+-6|0;d[i+-6>>1]=d[j>>1]|0;d[i+-4>>1]=d[e+-4>>1]|0;d[i+-2>>1]=d[e+-2>>1]|0;i=i+-6|0}while((j|0)!=(h|0));m=i;n=f[a>>2]|0}f[a>>2]=m;f[g>>2]=b;f[c>>2]=l;if(!n)return;PYa(n);return}function XR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){h=g;i=b;do{j=h;f[j>>2]=0;f[j+4>>2]=0;h=(f[e>>2]|0)+8|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=g-i>>3;g=h+b|0;if(g>>>0>536870911)gXa(a);j=d-i|0;i=j>>2;d=j>>3>>>0<268435455?(i>>>0<g>>>0?g:i):536870911;do if(d)if(d>>>0>536870911){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{k=NYa(d<<3)|0;break}else k=0;while(0);i=k+(h<<3)|0;h=i;g=k+(d<<3)|0;d=i;k=b;b=h;do{j=d;f[j>>2]=0;f[j+4>>2]=0;d=b+8|0;b=d;k=k+-1|0}while((k|0)!=0);k=g;g=f[a>>2]|0;d=f[e>>2]|0;j=g;if((d|0)==(g|0)){l=h;m=j}else{h=d+-8-j|0;j=i;n=d;while(1){d=n;n=n+-8|0;f[j+-8>>2]=f[n>>2];f[j+-4>>2]=f[d+-4>>2];if((n|0)==(g|0))break;else j=j+-8|0}l=i+(~(h>>>3)<<3)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=b;f[c>>2]=k;if(!m)return;PYa(m);return}function YR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/12|0)>>>0>=b>>>0){h=g;i=b;do{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;h=(f[e>>2]|0)+12|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=(g-i|0)/12|0;g=h+b|0;if(g>>>0>357913941)gXa(a);j=(d-i|0)/12|0;i=j<<1;d=j>>>0<178956970?(i>>>0<g>>>0?g:i):357913941;do if(d)if(d>>>0>357913941){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{k=NYa(d*12|0)|0;break}else k=0;while(0);i=k+(h*12|0)|0;h=i;g=k+(d*12|0)|0;d=i;k=b;b=h;do{f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;d=b+12|0;b=d;k=k+-1|0}while((k|0)!=0);k=g;g=f[a>>2]|0;d=f[e>>2]|0;if((d|0)==(g|0)){l=h;m=g}else{h=i;i=d;do{d=i;i=i+-12|0;f[h+-12>>2]=f[i>>2];f[h+-8>>2]=f[d+-8>>2];f[h+-4>>2]=f[d+-4>>2];h=h+-12|0}while((i|0)!=(g|0));l=h;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=b;f[c>>2]=k;if(!m)return;PYa(m);return}function ZR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>4>>>0>=b>>>0){h=g;i=b;do{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;h=(f[e>>2]|0)+16|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=g-i>>4;g=h+b|0;if(g>>>0>268435455)gXa(a);j=d-i|0;i=j>>3;d=j>>4>>>0<134217727?(i>>>0<g>>>0?g:i):268435455;do if(d)if(d>>>0>268435455){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{k=NYa(d<<4)|0;break}else k=0;while(0);i=k+(h<<4)|0;h=i;g=k+(d<<4)|0;d=i;k=b;b=h;do{f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;d=b+16|0;b=d;k=k+-1|0}while((k|0)!=0);k=g;g=f[a>>2]|0;d=f[e>>2]|0;j=g;if((d|0)==(g|0)){l=h;m=j}else{h=d+-16-j|0;j=i;n=d;while(1){d=n;n=n+-16|0;f[j+-16>>2]=f[n>>2];f[j+-12>>2]=f[d+-12>>2];f[j+-8>>2]=f[d+-8>>2];f[j+-4>>2]=f[d+-4>>2];if((n|0)==(g|0))break;else j=j+-16|0}l=i+(~(h>>>4)<<4)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=b;f[c>>2]=k;if(!m)return;PYa(m);return}function _R(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/24|0)>>>0>=b>>>0){h=g;i=b;do{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;h=(f[e>>2]|0)+24|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=(g-i|0)/24|0;g=h+b|0;if(g>>>0>178956970)gXa(a);j=(d-i|0)/24|0;i=j<<1;d=j>>>0<89478485?(i>>>0<g>>>0?g:i):178956970;do if(d)if(d>>>0>178956970){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{k=NYa(d*24|0)|0;break}else k=0;while(0);i=k+(h*24|0)|0;h=i;g=k+(d*24|0)|0;d=i;k=b;b=h;do{f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;d=b+24|0;b=d;k=k+-1|0}while((k|0)!=0);k=g;g=f[a>>2]|0;d=f[e>>2]|0;if((d|0)==(g|0)){l=h;m=g}else{h=i;i=d;do{d=i;i=i+-24|0;f[h+-24>>2]=f[i>>2];f[h+-20>>2]=f[d+-20>>2];f[h+-16>>2]=f[d+-16>>2];f[h+-12>>2]=f[d+-12>>2];f[h+-8>>2]=f[d+-8>>2];f[h+-4>>2]=f[d+-4>>2];h=h+-24|0}while((i|0)!=(g|0));l=h;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=b;f[c>>2]=k;if(!m)return;PYa(m);return}function $R(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>5>>>0>=b>>>0){h=g;i=b;do{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;h=(f[e>>2]|0)+32|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=g-i>>5;g=h+b|0;if(g>>>0>134217727)gXa(a);j=d-i|0;i=j>>4;d=j>>5>>>0<67108863?(i>>>0<g>>>0?g:i):134217727;do if(d)if(d>>>0>134217727){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{k=NYa(d<<5)|0;break}else k=0;while(0);i=k+(h<<5)|0;h=i;g=k+(d<<5)|0;d=i;k=b;b=h;do{f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;d=b+32|0;b=d;k=k+-1|0}while((k|0)!=0);k=g;g=f[a>>2]|0;d=f[e>>2]|0;j=g;if((d|0)==(g|0)){l=h;m=j}else{h=d+-32-j|0;j=i;n=d;while(1){d=n;n=n+-32|0;f[j+-32>>2]=f[n>>2];f[j+-28>>2]=f[d+-28>>2];f[j+-24>>2]=f[d+-24>>2];f[j+-20>>2]=f[d+-20>>2];f[j+-16>>2]=f[d+-16>>2];f[j+-12>>2]=f[d+-12>>2];f[j+-8>>2]=f[d+-8>>2];f[j+-4>>2]=f[d+-4>>2];if((n|0)==(g|0))break;else j=j+-32|0}l=i+(~(h>>>5)<<5)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=b;f[c>>2]=k;if(!m)return;PYa(m);return}function aS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/36|0)>>>0>=b>>>0){h=g;i=b;do{j=h;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));h=(f[e>>2]|0)+36|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=(g-i|0)/36|0;g=h+b|0;if(g>>>0>119304647)gXa(a);l=(d-i|0)/36|0;i=l<<1;d=l>>>0<59652323?(i>>>0<g>>>0?g:i):119304647;do if(d)if(d>>>0>119304647){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{m=NYa(d*36|0)|0;break}else m=0;while(0);i=m+(h*36|0)|0;h=i;g=m+(d*36|0)|0;d=i;m=b;b=h;do{j=d;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));d=b+36|0;b=d;m=m+-1|0}while((m|0)!=0);m=g;g=f[a>>2]|0;d=f[e>>2]|0;if((d|0)==(g|0)){n=h;o=g}else{h=i;i=d;do{d=i;i=i+-36|0;f[h+-36>>2]=f[i>>2];f[h+-32>>2]=f[d+-32>>2];f[h+-28>>2]=f[d+-28>>2];f[h+-24>>2]=f[d+-24>>2];f[h+-20>>2]=f[d+-20>>2];f[h+-16>>2]=f[d+-16>>2];f[h+-12>>2]=f[d+-12>>2];f[h+-8>>2]=f[d+-8>>2];f[h+-4>>2]=f[d+-4>>2];h=h+-36|0}while((i|0)!=(g|0));n=h;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=b;f[c>>2]=m;if(!o)return;PYa(o);return}function bS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/48|0)>>>0>=b>>>0){h=g;i=b;do{j=h;k=j+48|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));h=(f[e>>2]|0)+48|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=(g-i|0)/48|0;g=h+b|0;if(g>>>0>89478485)gXa(a);l=(d-i|0)/48|0;i=l<<1;d=l>>>0<44739242?(i>>>0<g>>>0?g:i):89478485;do if(d)if(d>>>0>89478485){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{m=NYa(d*48|0)|0;break}else m=0;while(0);i=m+(h*48|0)|0;h=i;g=m+(d*48|0)|0;d=i;m=b;b=h;do{j=d;k=j+48|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));d=b+48|0;b=d;m=m+-1|0}while((m|0)!=0);m=g;g=f[a>>2]|0;d=f[e>>2]|0;if((d|0)==(g|0)){n=h;o=g}else{h=i;i=d;do{d=i;i=i+-48|0;f[h+-48>>2]=f[i>>2];f[h+-44>>2]=f[d+-44>>2];f[h+-40>>2]=f[d+-40>>2];f[h+-36>>2]=f[d+-36>>2];f[h+-32>>2]=f[d+-32>>2];f[h+-28>>2]=f[d+-28>>2];f[h+-24>>2]=f[d+-24>>2];f[h+-20>>2]=f[d+-20>>2];f[h+-16>>2]=f[d+-16>>2];f[h+-12>>2]=f[d+-12>>2];f[h+-8>>2]=f[d+-8>>2];f[h+-4>>2]=f[d+-4>>2];h=h+-48|0}while((i|0)!=(g|0));n=h;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=b;f[c>>2]=m;if(!o)return;PYa(o);return}function cS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>6>>>0>=b>>>0){h=g;i=b;do{j=h;k=j+64|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));h=(f[e>>2]|0)+64|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=g-i>>6;g=h+b|0;if(g>>>0>67108863)gXa(a);l=d-i|0;i=l>>5;d=l>>6>>>0<33554431?(i>>>0<g>>>0?g:i):67108863;do if(d)if(d>>>0>67108863){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{m=NYa(d<<6)|0;break}else m=0;while(0);i=m+(h<<6)|0;h=i;g=m+(d<<6)|0;d=i;m=b;b=h;do{j=d;k=j+64|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));d=b+64|0;b=d;m=m+-1|0}while((m|0)!=0);m=g;g=f[a>>2]|0;d=f[e>>2]|0;j=g;if((d|0)==(g|0)){n=h;o=j}else{h=d+-64-j|0;j=i;k=d;while(1){d=k;k=k+-64|0;f[j+-64>>2]=f[k>>2];f[j+-60>>2]=f[d+-60>>2];f[j+-56>>2]=f[d+-56>>2];f[j+-52>>2]=f[d+-52>>2];f[j+-48>>2]=f[d+-48>>2];f[j+-44>>2]=f[d+-44>>2];f[j+-40>>2]=f[d+-40>>2];f[j+-36>>2]=f[d+-36>>2];f[j+-32>>2]=f[d+-32>>2];f[j+-28>>2]=f[d+-28>>2];f[j+-24>>2]=f[d+-24>>2];f[j+-20>>2]=f[d+-20>>2];f[j+-16>>2]=f[d+-16>>2];f[j+-12>>2]=f[d+-12>>2];f[j+-8>>2]=f[d+-8>>2];f[j+-4>>2]=f[d+-4>>2];if((k|0)==(g|0))break;else j=j+-64|0}n=i+(~(h>>>6)<<6)|0;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=b;f[c>>2]=m;if(!o)return;PYa(o);return}function dS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>7>>>0>=b>>>0){h=g;i=b;do{j=h;k=j+128|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));h=(f[e>>2]|0)+128|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=g-i>>7;g=h+b|0;if(g>>>0>33554431)gXa(a);l=d-i|0;i=l>>6;d=l>>7>>>0<16777215?(i>>>0<g>>>0?g:i):33554431;do if(d)if(d>>>0>33554431){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{m=NYa(d<<7)|0;break}else m=0;while(0);i=m+(h<<7)|0;h=i;g=m+(d<<7)|0;d=i;m=b;b=h;do{j=d;k=j+128|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));d=b+128|0;b=d;m=m+-1|0}while((m|0)!=0);m=g;g=f[a>>2]|0;d=f[e>>2]|0;j=g;if((d|0)==(g|0)){n=h;o=j}else{h=d+-128-j|0;j=i;k=d;while(1){d=0;do{f[j+-128+(d<<2)>>2]=f[k+-128+(d<<2)>>2];d=d+1|0}while((d|0)!=32);k=k+-128|0;if((k|0)==(g|0))break;else j=j+-128|0}n=i+(~(h>>>7)<<7)|0;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=b;f[c>>2]=m;if(!o)return;PYa(o);return}function eS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>8>>>0>=b>>>0){h=g;i=b;do{F1a(h|0,0,256)|0;h=(f[e>>2]|0)+256|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=g-i>>8;g=h+b|0;if(g>>>0>16777215)gXa(a);j=d-i|0;i=j>>7;d=j>>8>>>0<8388607?(i>>>0<g>>>0?g:i):16777215;do if(d)if(d>>>0>16777215){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{k=NYa(d<<8)|0;break}else k=0;while(0);i=k+(h<<8)|0;h=i;g=k+(d<<8)|0;d=i;k=b;b=h;do{F1a(d|0,0,256)|0;d=b+256|0;b=d;k=k+-1|0}while((k|0)!=0);k=g;g=f[a>>2]|0;d=f[e>>2]|0;j=g;if((d|0)==(g|0)){l=h;m=j}else{h=d+-256-j|0;j=i;n=d;while(1){d=0;do{f[j+-256+(d<<2)>>2]=f[n+-256+(d<<2)>>2];d=d+1|0}while((d|0)!=64);n=n+-256|0;if((n|0)==(g|0))break;else j=j+-256|0}l=i+(~(h>>>8)<<8)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=b;f[c>>2]=k;if(!m)return;PYa(m);return}function fS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>9>>>0>=b>>>0){h=g;i=b;do{F1a(h|0,0,512)|0;h=(f[e>>2]|0)+512|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=g-i>>9;g=h+b|0;if(g>>>0>8388607)gXa(a);j=d-i|0;i=j>>8;d=j>>9>>>0<4194303?(i>>>0<g>>>0?g:i):8388607;do if(d)if(d>>>0>8388607){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{k=NYa(d<<9)|0;break}else k=0;while(0);i=k+(h<<9)|0;h=i;g=k+(d<<9)|0;d=i;k=b;b=h;do{F1a(d|0,0,512)|0;d=b+512|0;b=d;k=k+-1|0}while((k|0)!=0);k=g;g=f[a>>2]|0;d=f[e>>2]|0;j=g;if((d|0)==(g|0)){l=h;m=j}else{h=d+-512-j|0;j=i;n=d;while(1){d=0;do{f[j+-512+(d<<2)>>2]=f[n+-512+(d<<2)>>2];d=d+1|0}while((d|0)!=128);n=n+-512|0;if((n|0)==(g|0))break;else j=j+-512|0}l=i+(~(h>>>9)<<9)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=b;f[c>>2]=k;if(!m)return;PYa(m);return}function gS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/56|0;h=d;if(g>>>0<b>>>0){iS(a,b-g|0);return}if(g>>>0<=b>>>0)return;g=e+(b*56|0)|0;if((h|0)==(g|0))return;else i=h;do{f[c>>2]=i+-56;h=i+-20|0;b=f[h>>2]|0;if((b|0?(e=b+12|0,b=f[e>>2]|0,f[e>>2]=b+-1,(b|0)==1):0)?(b=f[h>>2]|0,b|0):0){f[h>>2]=0;e=f[b+4>>2]|0;if(!e){a=f[i+-24>>2]|0;if(!a)j=sR()|0;else j=a}else j=e;Gh[f[(f[j>>2]|0)+24>>2]&511](j,b)}f[h>>2]=0;h=i+-40|0;b=i+-52|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[b>>2]|0)>0){h=f[i+-16>>2]|0;e=0;do{f[h+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[b>>2]|0))}b=f[i+-12>>2]|0;if((b|0)!=(i+-8|0))ZF(b);i=f[c>>2]|0}while((i|0)!=(g|0));return}function hS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/48|0)>>>0>=b>>>0){h=g;i=b;do{f[h>>2]=1124007936;j=h+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[h+32>>2]=h+8;j=h+40|0;f[h+36>>2]=j;f[h+44>>2]=0;f[j>>2]=0;h=(f[e>>2]|0)+48|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=(g-i|0)/48|0;g=h+b|0;if(g>>>0>89478485)gXa(a);j=(d-i|0)/48|0;i=j<<1;d=j>>>0<44739242?(i>>>0<g>>>0?g:i):89478485;do if(d)if(d>>>0>89478485){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{k=NYa(d*48|0)|0;break}else k=0;while(0);i=k+(h*48|0)|0;h=i;g=k+(d*48|0)|0;d=i;k=b;b=h;do{f[d>>2]=1124007936;j=d+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[d+32>>2]=d+8;j=d+40|0;f[d+36>>2]=j;f[d+44>>2]=0;f[j>>2]=0;d=b+48|0;b=d;k=k+-1|0}while((k|0)!=0);k=g;g=f[a>>2]|0;d=f[e>>2]|0;if((d|0)==(g|0)){l=h;m=g;n=d}else{j=i;i=d;d=h;do{h=j+-48|0;o=i;i=i+-48|0;f[h>>2]=f[i>>2];p=j+-44|0;q=o+-44|0;f[p>>2]=f[q>>2];r=j+-40|0;f[r>>2]=f[o+-40>>2];f[j+-36>>2]=f[o+-36>>2];f[j+-32>>2]=f[o+-32>>2];f[j+-28>>2]=f[o+-28>>2];s=f[o+-24>>2]|0;f[j+-24>>2]=s;f[j+-20>>2]=f[o+-20>>2];f[j+-16>>2]=r;r=j+-8|0;t=j+-12|0;f[t>>2]=r;f[j+-4>>2]=0;f[r>>2]=0;if(s|0){r=s+8|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+-12>>2]|0;o=f[t>>2]|0;f[o>>2]=f[q>>2];f[o+4>>2]=f[q+4>>2]}else{f[p>>2]=0;i0(h,i)}j=d+-48|0;d=j}while((i|0)!=(g|0));l=d;m=f[a>>2]|0;n=f[e>>2]|0}f[a>>2]=l;f[e>>2]=b;f[c>>2]=k;k=m;c=n;while(1){n=c;if((n|0)==(k|0))break;b=n+-48|0;j0(b);c=b}if(!m)return;PYa(m);return}function iS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+32|0;d=c;e=f[a+8>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/56|0)>>>0>=b>>>0){i=h;j=b;do{f[i>>2]=1124007936;k=i+8|0;l=i+40|0;m=i+4|0;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=i+48|0;f[i+44>>2]=o;f[o>>2]=0;f[i+52>>2]=0;i=(f[g>>2]|0)+56|0;f[g>>2]=i;j=j+-1|0}while((j|0)!=0);u=c;return}j=f[a>>2]|0;i=(h-j|0)/56|0;h=i+b|0;if(h>>>0>76695844)gXa(a);g=(e-j|0)/56|0;j=g<<1;e=g>>>0<38347922?(j>>>0<h>>>0?h:j):76695844;f[d+12>>2]=0;f[d+16>>2]=a+8;do if(e)if(e>>>0>76695844){j=De(8)|0;UYa(j,358155);f[j>>2]=130560;Of(j|0,21520,875)}else{p=NYa(e*56|0)|0;break}else p=0;while(0);f[d>>2]=p;j=p+(i*56|0)|0;i=d+8|0;f[i>>2]=j;f[d+4>>2]=j;f[d+12>>2]=p+(e*56|0);e=j;j=b;while(1){f[e>>2]=1124007936;b=e+8|0;g=e+40|0;m=e+4|0;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[g>>2]=b;k=e+48|0;f[e+44>>2]=k;f[k>>2]=0;f[e+52>>2]=0;j=j+-1|0;if(!j)break;else e=e+56|0}f[i>>2]=p+(h*56|0);Qt(a,d);Rt(d);u=c;return}function jS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a>>2]|0;d=a+4|0;e=f[d>>2]|0;g=b+4|0;do if((e|0)!=(c|0)){h=f[g>>2]|0;i=e;while(1){j=h+-12|0;f[j>>2]=0;k=h+-8|0;f[k>>2]=0;f[h+-4>>2]=0;l=i+-8|0;i=i+-12|0;m=(f[l>>2]|0)-(f[i>>2]|0)|0;if(m|0){if((m|0)<0){n=6;break}o=NYa(m)|0;f[k>>2]=o;f[j>>2]=o;f[h+-4>>2]=o+m;m=f[i>>2]|0;p=(f[l>>2]|0)-m|0;if((p|0)>0){K1a(o|0,m|0,p|0)|0;f[k>>2]=o+p}}h=(f[g>>2]|0)+-12|0;f[g>>2]=h;if((i|0)==(c|0)){n=10;break}}if((n|0)==6)gXa(j);else if((n|0)==10){q=g;r=a;s=h;t=f[a>>2]|0;break}}else{q=g;r=a;s=f[g>>2]|0;t=c}while(0);f[r>>2]=s;f[q>>2]=t;t=b+8|0;s=f[d>>2]|0;f[d>>2]=f[t>>2];f[t>>2]=s;s=a+8|0;a=b+12|0;t=f[s>>2]|0;f[s>>2]=f[a>>2];f[a>>2]=t;f[b>>2]=f[q>>2];return}function kS(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;g=u;u=u+64|0;h=g+8|0;i=g;j=f[c>>2]|0;k=(j>>>3&511)+1|0;f[h>>2]=j;j=h+4|0;l=c+4|0;m=f[l>>2]|0;f[j>>2]=m;n=h+8|0;o=c+8|0;f[n>>2]=f[o>>2];p=h+12|0;q=c+12|0;f[p>>2]=f[q>>2];r=h+16|0;f[r>>2]=f[c+16>>2];s=h+20|0;f[s>>2]=f[c+20>>2];t=h+24|0;f[t>>2]=f[c+24>>2];v=h+28|0;f[v>>2]=f[c+28>>2];w=h+32|0;f[w>>2]=f[c+32>>2];x=h+36|0;y=f[c+36>>2]|0;f[x>>2]=y;z=h+40|0;f[z>>2]=n;A=h+48|0;B=h+44|0;f[B>>2]=A;f[A>>2]=0;f[h+52>>2]=0;if(!y)C=m;else{m=y+12|0;f[m>>2]=(f[m>>2]|0)+1;C=f[l>>2]|0}if((C|0)>=3){f[j>>2]=0;pR(h,C,0,0,0);if((f[j>>2]|0)>0){C=f[c+40>>2]|0;m=f[z>>2]|0;y=f[c+44>>2]|0;D=f[B>>2]|0;E=0;do{f[m+(E<<2)>>2]=f[C+(E<<2)>>2];f[D+(E<<2)>>2]=f[y+(E<<2)>>2];E=E+1|0}while((E|0)<(f[j>>2]|0))}}else{E=f[c+44>>2]|0;y=f[B>>2]|0;f[y>>2]=f[E>>2];f[y+4>>2]=f[E+4>>2]}E=f[l>>2]|0;a:do if((E|0)>2){if((d|0)!=0&(e|0)==0){y=E+-1|0;if(!((Y(f[(f[c+40>>2]|0)+(y<<2)>>2]|0,k)|0)%(d|0)|0)){D=f[h>>2]|0;C=(d<<3)+-8|0;f[h>>2]=D&-4089|C;f[(f[B>>2]|0)+(y<<2)>>2]=(C>>>3&511)+1<<(47696>>>(D<<1&14)&3);D=(f[z>>2]|0)+((f[l>>2]|0)+-1<<2)|0;C=(Y(f[D>>2]|0,k)|0)/(d|0)|0;f[D>>2]=C;f[a>>2]=f[h>>2];C=a+4|0;D=f[j>>2]|0;f[C>>2]=D;y=a+8|0;f[y>>2]=f[n>>2];f[a+12>>2]=f[p>>2];f[a+16>>2]=f[r>>2];f[a+20>>2]=f[s>>2];f[a+24>>2]=f[t>>2];f[a+28>>2]=f[v>>2];f[a+32>>2]=f[w>>2];m=f[x>>2]|0;f[a+36>>2]=m;F=a+40|0;f[F>>2]=y;y=a+48|0;G=a+44|0;f[G>>2]=y;f[y>>2]=0;f[a+52>>2]=0;if(!m)H=D;else{D=m+12|0;f[D>>2]=(f[D>>2]|0)+1;H=f[j>>2]|0}if((H|0)<3){D=f[B>>2]|0;m=f[G>>2]|0;f[m>>2]=f[D>>2];f[m+4>>2]=f[D+4>>2];break}f[C>>2]=0;pR(a,H,0,0,0);if((f[C>>2]|0)<=0)break;D=f[z>>2]|0;m=f[F>>2]|0;F=f[B>>2]|0;y=f[G>>2]|0;G=0;while(1){f[m+(G<<2)>>2]=f[D+(G<<2)>>2];f[y+(G<<2)>>2]=f[F+(G<<2)>>2];G=G+1|0;if((G|0)>=(f[C>>2]|0))break a}}}else if((e|0)>0){f[i>>2]=e;C=f[c+40>>2]|0;G=0;F=1;do{F=Y(f[C+(G<<2)>>2]|0,F)|0;G=G+1|0}while((G|0)!=(E|0));f[i+4>>2]=(F>>>0)/(e>>>0)|0;lS(a,c,d,2,i);break}f[i>>2]=0;f[i+4>>2]=0;I=c$(i,9)|0;J=172938;K=I+9|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));j$(-215,i,174544,172446,1087);d$(i);L=23}else L=23;while(0);do if((L|0)==23){E=(d|0)==0?k:d;H=Y(f[q>>2]|0,k)|0;l=(e|0)==0;if((E|0)>(H|0))if(l)L=26;else{M=e;L=28}else if(l&((H|0)%(E|0)|0|0)!=0)L=26;else{N=e;L=27}if((L|0)==26){N=(Y(f[o>>2]|0,H)|0)/(E|0)|0;L=27}if((L|0)==27)if(!N)O=H;else{M=N;L=28}if((L|0)==28){l=f[o>>2]|0;if((M|0)==(l|0))O=H;else{F=Y(l,H)|0;if(!(f[c>>2]&16384)){f[i>>2]=0;f[i+4>>2]=0;I=c$(i,72)|0;J=203279;K=I+72|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));j$(-13,i,174544,172446,1102);d$(i)}if(M>>>0>F>>>0){f[i>>2]=0;f[i+4>>2]=0;I=c$(i,22)|0;J=203352;K=I+22|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));j$(-211,i,174544,172446,1105);d$(i)}H=(F|0)/(M|0)|0;if((Y(H,M)|0)!=(F|0)){f[i>>2]=0;f[i+4>>2]=0;I=c$(i,78)|0;J=203190;K=I+78|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));j$(-5,i,174544,172446,1111);d$(i)}f[n>>2]=M;F=Y(1212424721>>>(f[c>>2]<<2&28)&15,H)|0;f[f[B>>2]>>2]=F;O=H}}F=(O|0)/(E|0)|0;if((Y(F,E)|0)!=(O|0)){f[i>>2]=0;f[i+4>>2]=0;I=c$(i,62)|0;J=203375;K=I+62|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));j$(-15,i,174544,172446,1121);d$(i)}f[p>>2]=F;H=f[h>>2]|0;l=(E<<3)+-8|0;G=H&-4089|l;f[h>>2]=G;f[(f[B>>2]|0)+4>>2]=(l>>>3&511)+1<<(47696>>>(H<<1&14)&3);f[a>>2]=G;G=a+4|0;H=f[j>>2]|0;f[G>>2]=H;l=a+8|0;f[l>>2]=f[n>>2];f[a+12>>2]=f[p>>2];f[a+16>>2]=f[r>>2];f[a+20>>2]=f[s>>2];f[a+24>>2]=f[t>>2];f[a+28>>2]=f[v>>2];f[a+32>>2]=f[w>>2];C=f[x>>2]|0;f[a+36>>2]=C;y=a+40|0;f[y>>2]=l;l=a+48|0;D=a+44|0;f[D>>2]=l;f[l>>2]=0;f[a+52>>2]=0;if(!C)P=H;else{H=C+12|0;f[H>>2]=(f[H>>2]|0)+1;P=f[j>>2]|0}if((P|0)<3){H=f[B>>2]|0;C=f[D>>2]|0;f[C>>2]=f[H>>2];f[C+4>>2]=f[H+4>>2];break}f[G>>2]=0;pR(a,P,0,0,0);if((f[G>>2]|0)>0){H=f[z>>2]|0;C=f[y>>2]|0;y=f[B>>2]|0;l=f[D>>2]|0;D=0;do{f[C+(D<<2)>>2]=f[H+(D<<2)>>2];f[l+(D<<2)>>2]=f[y+(D<<2)>>2];D=D+1|0}while((D|0)<(f[G>>2]|0))}}while(0);P=f[x>>2]|0;if((P|0?(a=P+12|0,P=f[a>>2]|0,f[a>>2]=P+-1,(P|0)==1):0)?(P=f[x>>2]|0,P|0):0){f[x>>2]=0;a=f[P+4>>2]|0;if(!a){v=f[w>>2]|0;if(!v)Q=sR()|0;else Q=v}else Q=a;Gh[f[(f[Q>>2]|0)+24>>2]&511](Q,P)}f[x>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[j>>2]|0)>0){r=f[z>>2]|0;z=0;do{f[r+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[j>>2]|0))}j=f[B>>2]|0;if((j|0)==(A|0)){u=g;return}ZF(j);u=g;return}function lS(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=u;u=u+32|0;i=h+8|0;j=h;k=c+4|0;if((f[k>>2]|0)==(e|0)){if(!g){kS(a,c,d,0);u=h;return}if((e|0)==2){kS(a,c,d,f[g>>2]|0);u=h;return}}if(!(f[c>>2]&16384)){f[i>>2]=0;f[i+4>>2]=0;l=c$(i,71)|0;m=174765;n=l+71|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-213,i,174544,172446,4691);d$(i);f[a>>2]=1124007936;o=a+8|0;p=a+40|0;l=a+4|0;n=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(n|0));f[p>>2]=o;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;u=h;return}if(!((g|0)!=0&((d|0)>-1&(e+-1|0)>>>0<32))){f[i>>2]=0;f[i+4>>2]=0;l=c$(i,54)|0;m=174552;n=l+54|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-215,i,174544,172446,4655);d$(i)}if(d)if((d|0)<513)q=d;else{f[i>>2]=0;f[i+4>>2]=0;l=c$(i,10)|0;m=174607;n=l+10|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-215,i,174544,172446,4660);d$(i);q=d}else q=((f[c>>2]|0)>>>3&511)+1|0;d=f[k>>2]|0;if((d|0)<3)r=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{o=f[c+40>>2]|0;p=0;s=1;while(1){t=Y(f[o+(p<<2)>>2]|0,s)|0;p=p+1|0;if((p|0)==(d|0)){r=t;break}else s=t}}s=Y(((f[c>>2]|0)>>>3&511)+1|0,r)|0;r=i+8|0;f[i>>2]=r;d=i+4|0;f[d>>2]=e;if(e>>>0>4){p=OYa(e>>>0>1073741823?-1:e<<2)|0;f[i>>2]=p}if((e|0)>0){p=c+40|0;o=j+4|0;t=j+4|0;v=0;w=q;while(1){x=g+(v<<2)|0;y=f[x>>2]|0;if((y|0)>-1)z=y;else{f[j>>2]=0;f[t>>2]=0;l=c$(j,14)|0;m=174618;n=l+14|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-215,j,174544,172446,4669);d$(j);z=f[x>>2]|0}do if((z|0)<=0)if((v|0)<(f[k>>2]|0)){y=f[(f[p>>2]|0)+(v<<2)>>2]|0;f[(f[i>>2]|0)+(v<<2)>>2]=y;A=y;break}else{f[j>>2]=0;f[o>>2]=0;l=c$(j,68)|0;m=174633;n=l+68|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-211,j,174544,172446,4676);d$(j);A=f[(f[i>>2]|0)+(v<<2)>>2]|0;break}else{f[(f[i>>2]|0)+(v<<2)>>2]=z;A=z}while(0);x=Y(A,w)|0;v=v+1|0;if((v|0)>=(e|0)){B=x;break}else w=x}}else B=q;if((B|0)!=(s|0)){f[j>>2]=0;f[j+4>>2]=0;l=c$(j,62)|0;m=174702;n=l+62|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-209,j,174544,172446,4682);d$(j)}f[a>>2]=f[c>>2];j=a+4|0;m=f[k>>2]|0;f[j>>2]=m;l=a+8|0;f[l>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];n=f[c+36>>2]|0;f[a+36>>2]=n;s=a+40|0;f[s>>2]=l;l=a+48|0;B=a+44|0;f[B>>2]=l;f[l>>2]=0;f[a+52>>2]=0;if(!n)C=m;else{m=n+12|0;f[m>>2]=(f[m>>2]|0)+1;C=f[k>>2]|0}if((C|0)>=3){f[j>>2]=0;pR(a,C,0,0,0);if((f[j>>2]|0)>0){C=f[c+40>>2]|0;k=f[s>>2]|0;s=f[c+44>>2]|0;m=f[B>>2]|0;n=0;do{f[k+(n<<2)>>2]=f[C+(n<<2)>>2];f[m+(n<<2)>>2]=f[s+(n<<2)>>2];n=n+1|0}while((n|0)<(f[j>>2]|0))}}else{j=f[c+44>>2]|0;c=f[B>>2]|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2]}f[a>>2]=f[a>>2]&-4089|(q<<3)+-8;pR(a,e,f[i>>2]|0,0,1);e=f[i>>2]|0;if((e|0)!=(r|0)){if(e|0)QYa(e);f[i>>2]=r;f[d>>2]=4}u=h;return}function mS(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+144|0;e=d+136|0;g=d+80|0;h=d+24|0;i=d;j=d+16|0;_$(e,41876);k=RR(a,-1)|0;l=(k>>>3&511)+1<<(47696>>>(k<<1&14)&3);if(!((l|0)<33&(nS(a,-1)|0)<3)){f[g>>2]=0;f[g+4>>2]=0;m=c$(g,29)|0;n=174837;o=m+29|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,g,174867,172446,3515);d$(g)}NR(g,a,-1);a=g+16|0;if(f[a>>2]|0){k=f[g+4>>2]|0;if((k|0)<3)p=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{q=f[g+40>>2]|0;r=0;s=1;while(1){t=Y(f[q+(r<<2)>>2]|0,s)|0;r=r+1|0;if((r|0)==(k|0)){p=t;break}else s=t}}if(!((k|0)==0|(p|0)==0)){p=g+12|0;k=g+8|0;pS(c,f[p>>2]|0,f[k>>2]|0,f[g>>2]&4095,-1,0,0);NR(h,c,-1);s=f[k>>2]|0;k=h+12|0;do if((s|0)==(f[k>>2]|0)?(r=f[p>>2]|0,q=h+8|0,(r|0)==(f[q>>2]|0)):0){t=h+16|0;v=f[t>>2]|0;w=f[a>>2]|0;if((v|0)!=(w|0)){x=f[42028+(l<<2)>>2]|0;if(!x){f[i>>2]=0;f[i+4>>2]=0;m=c$(i,9)|0;n=323538;o=m+9|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,i,174867,172446,3550);d$(i);y=f[a>>2]|0;z=f[t>>2]|0}else{y=w;z=v}A=f[g+48>>2]|0;B=f[h+48>>2]|0;C=f[g+40>>2]|0;D=f[C>>2]|0;f[j>>2]=f[C+4>>2];f[j+4>>2]=D;Bh[x&255](y,A,z,B,j);break}B=f[41896+(l<<2)>>2]|0;if(!B){f[i>>2]=0;f[i+4>>2]=0;m=c$(i,9)|0;n=323538;o=m+9|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,i,174867,172446,3543);d$(i);E=f[k>>2]|0;F=f[q>>2]|0}else{E=s;F=r}if((E|0)==(F|0))G=F;else{f[i>>2]=0;f[i+4>>2]=0;m=c$(i,20)|0;n=347552;o=m+20|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,i,174867,172446,3544);d$(i);G=f[q>>2]|0}fi[B&255](f[t>>2]|0,f[h+48>>2]|0,G)}else H=12;while(0);if((H|0)==12){G=f[g+40>>2]|0;F=f[h+40>>2]|0;if(!(((f[F>>2]|0)==(f[G>>2]|0)?(f[F+4>>2]|0)==(f[G+4>>2]|0):0)?(f[p>>2]|0)==1|(s|0)==1:0)){f[i>>2]=0;f[i+4>>2]=0;m=c$(i,60)|0;n=174877;o=m+60|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,i,174867,172446,3533);d$(i)}n=i+8|0;f[n>>2]=0;f[n+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=h;eL(g,i)}i=h+36|0;n=f[i>>2]|0;if((n|0?(m=n+12|0,n=f[m>>2]|0,f[m>>2]=n+-1,(n|0)==1):0)?(n=f[i>>2]|0,n|0):0){f[i>>2]=0;m=f[n+4>>2]|0;if(!m){o=f[h+32>>2]|0;if(!o)I=sR()|0;else I=o}else I=m;Gh[f[(f[I>>2]|0)+24>>2]&511](I,n)}f[i>>2]=0;i=h+16|0;n=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[n>>2]|0)>0){i=f[h+40>>2]|0;I=0;do{f[i+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[n>>2]|0))}n=f[h+44>>2]|0;if((n|0)!=(h+48|0))ZF(n)}else H=9}else H=9;if((H|0)==9)oS(c);c=g+36|0;H=f[c>>2]|0;if((H|0?(n=H+12|0,H=f[n>>2]|0,f[n>>2]=H+-1,(H|0)==1):0)?(H=f[c>>2]|0,H|0):0){f[c>>2]=0;n=f[H+4>>2]|0;if(!n){h=f[g+32>>2]|0;if(!h)J=sR()|0;else J=h}else J=n;Gh[f[(f[J>>2]|0)+24>>2]&511](J,H)}f[c>>2]=0;c=g+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[c>>2]|0)>0){a=f[g+40>>2]|0;H=0;do{f[a+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[c>>2]|0))}c=f[g+44>>2]|0;if((c|0)!=(g+48|0))ZF(c);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function nS(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;do switch((f[a>>2]|0)>>>16&31){case 1:{if((c|0)>=0){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,5)|0;b[g>>0]=b[173319]|0;b[g+1>>0]=b[173320]|0;b[g+2>>0]=b[173321]|0;b[g+3>>0]=b[173322]|0;b[g+4>>0]=b[173323]|0;j$(-215,e,175817,172446,1817);d$(e)}h=f[(f[a+4>>2]|0)+4>>2]|0;u=d;return h|0}case 6:{if((c|0)>=0){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,5)|0;b[g>>0]=b[173319]|0;b[g+1>>0]=b[173320]|0;b[g+2>>0]=b[173321]|0;b[g+3>>0]=b[173322]|0;b[g+4>>0]=b[173323]|0;j$(-215,e,175817,172446,1823);d$(e)}h=f[(f[a+4>>2]|0)+12>>2]|0;u=d;return h|0}case 10:{if((c|0)>=0){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,5)|0;b[g>>0]=b[173319]|0;b[g+1>>0]=b[173320]|0;b[g+2>>0]=b[173321]|0;b[g+3>>0]=b[173322]|0;b[g+4>>0]=b[173323]|0;j$(-215,e,175817,172446,1829);d$(e)}h=f[(f[a+4>>2]|0)+4>>2]|0;u=d;return h|0}case 2:case 14:{if((c|0)<0){h=2;u=d;return h|0}f[e>>2]=0;f[e+4>>2]=0;g=c$(e,5)|0;b[g>>0]=b[173319]|0;b[g+1>>0]=b[173320]|0;b[g+2>>0]=b[173321]|0;b[g+3>>0]=b[173322]|0;b[g+4>>0]=b[173323]|0;j$(-215,e,175817,172446,1835);d$(e);h=2;u=d;return h|0}case 3:case 12:{if((c|0)<0){h=2;u=d;return h|0}f[e>>2]=0;f[e+4>>2]=0;g=c$(e,5)|0;b[g>>0]=b[173319]|0;b[g+1>>0]=b[173320]|0;b[g+2>>0]=b[173321]|0;b[g+3>>0]=b[173322]|0;b[g+4>>0]=b[173323]|0;j$(-215,e,175817,172446,1841);d$(e);h=2;u=d;return h|0}case 4:{if((c|0)<0){h=1;u=d;return h|0}g=f[a+4>>2]|0;if((((f[g+4>>2]|0)-(f[g>>2]|0)|0)/12|0|0)>(c|0)){h=2;u=d;return h|0}f[e>>2]=0;f[e+4>>2]=0;i=c$(e,18)|0;j=173614;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-215,e,175817,172446,1853);d$(e);h=2;u=d;return h|0}case 5:{g=f[a+4>>2]|0;if((c|0)<0){h=1;u=d;return h|0}l=f[g>>2]|0;if((((f[g+4>>2]|0)-l|0)/56|0|0)>(c|0))m=l;else{f[e>>2]=0;f[e+4>>2]=0;i=c$(e,18)|0;j=173614;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-215,e,175817,172446,1862);d$(e);m=f[g>>2]|0}h=f[m+(c*56|0)+4>>2]|0;u=d;return h|0}case 15:{l=f[a+4>>2]|0;if((c|0)<0){h=1;u=d;return h|0}if((f[a+12>>2]|0)<=(c|0)){f[e>>2]=0;f[e+4>>2]=0;i=c$(e,13)|0;j=173633;k=i+13|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-215,e,175817,172446,1872);d$(e)}h=f[l+(c*56|0)+4>>2]|0;u=d;return h|0}case 11:{g=f[a+4>>2]|0;if((c|0)<0){h=1;u=d;return h|0}n=f[g>>2]|0;if((((f[g+4>>2]|0)-n|0)/48|0|0)>(c|0))o=n;else{f[e>>2]=0;f[e+4>>2]=0;i=c$(e,18)|0;j=173614;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-215,e,175817,172446,1882);d$(e);o=f[g>>2]|0}h=f[o+(c*48|0)+4>>2]|0;u=d;return h|0}case 7:{if((c|0)<0){h=2;u=d;return h|0}f[e>>2]=0;f[e+4>>2]=0;l=c$(e,5)|0;b[l>>0]=b[173319]|0;b[l+1>>0]=b[173320]|0;b[l+2>>0]=b[173321]|0;b[l+3>>0]=b[173322]|0;b[l+4>>0]=b[173323]|0;j$(-215,e,175817,172446,1889);d$(e);h=2;u=d;return h|0}case 9:{if((c|0)<0){h=2;u=d;return h|0}f[e>>2]=0;f[e+4>>2]=0;l=c$(e,5)|0;b[l>>0]=b[173319]|0;b[l+1>>0]=b[173320]|0;b[l+2>>0]=b[173321]|0;b[l+3>>0]=b[173322]|0;b[l+4>>0]=b[173323]|0;j$(-215,e,175817,172446,1895);d$(e);h=2;u=d;return h|0}case 8:{if((c|0)<0){h=2;u=d;return h|0}f[e>>2]=0;f[e+4>>2]=0;l=c$(e,5)|0;b[l>>0]=b[173319]|0;b[l+1>>0]=b[173320]|0;b[l+2>>0]=b[173321]|0;b[l+3>>0]=b[173322]|0;b[l+4>>0]=b[173323]|0;j$(-215,e,175817,172446,1901);d$(e);h=2;u=d;return h|0}case 0:{h=0;u=d;return h|0}default:{f[e>>2]=0;f[e+4>>2]=0;i=c$(e,30)|0;j=173557;k=i+30|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-213,e,175817,172446,1905);d$(e);h=0;u=d;return h|0}}while(0);return 0}function oS(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+16|0;d=c+8|0;e=c;g=f[a>>2]|0;if(!(g&1073741824))h=g;else{f[d>>2]=0;f[d+4>>2]=0;i=c$(d,12)|0;j=175531;k=i+12|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-215,d,175544,172446,2832);d$(d);h=f[a>>2]|0}do switch(h>>>16&31){case 1:{g=f[a+4>>2]|0;l=g+36|0;m=f[l>>2]|0;if((m|0?(n=m+12|0,m=f[n>>2]|0,f[n>>2]=m+-1,(m|0)==1):0)?(m=f[l>>2]|0,m|0):0){f[l>>2]=0;n=f[m+4>>2]|0;if(!n){o=f[g+32>>2]|0;if(!o)p=sR()|0;else p=o}else p=n;Gh[f[(f[p>>2]|0)+24>>2]&511](p,m)}f[l>>2]=0;l=g+16|0;m=g+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[m>>2]|0)<=0){u=c;return}l=f[g+40>>2]|0;g=0;do{f[l+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[m>>2]|0));u=c;return}case 10:{m=f[a+4>>2]|0;g=m+24|0;l=f[g>>2]|0;if(l|0?(n=l+8|0,l=f[n>>2]|0,f[n>>2]=l+-1,(l|0)==1):0)k0(m);l=m+4|0;if((f[l>>2]|0)>0){n=f[m+32>>2]|0;m=0;do{f[n+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[l>>2]|0))}f[g>>2]=0;u=c;return}case 9:{u=c;return}case 8:{u=c;return}case 7:{YU(f[a+4>>2]|0);u=c;return}case 3:{f[e>>2]=0;f[e+4>>2]=0;KS(a,e,h&4095,-1,0,0);u=c;return}case 4:{l=f[a+4>>2]|0;m=f[l>>2]|0;n=l+4|0;l=f[n>>2]|0;if((l|0)==(m|0)){u=c;return}else q=l;while(1){l=q+-12|0;f[n>>2]=l;o=f[l>>2]|0;if(!o)r=l;else{l=q+-8|0;if((f[l>>2]|0)!=(o|0))f[l>>2]=o;PYa(o);r=f[n>>2]|0}if((r|0)==(m|0))break;else q=r}u=c;return}case 5:{m=f[a+4>>2]|0;n=f[m>>2]|0;g=m+4|0;m=f[g>>2]|0;if((m|0)==(n|0)){u=c;return}else s=m;do{f[g>>2]=s+-56;m=s+-20|0;o=f[m>>2]|0;if((o|0?(l=o+12|0,o=f[l>>2]|0,f[l>>2]=o+-1,(o|0)==1):0)?(o=f[m>>2]|0,o|0):0){f[m>>2]=0;l=f[o+4>>2]|0;if(!l){t=f[s+-24>>2]|0;if(!t)v=sR()|0;else v=t}else v=l;Gh[f[(f[v>>2]|0)+24>>2]&511](v,o)}f[m>>2]=0;m=s+-40|0;o=s+-52|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[o>>2]|0)>0){m=f[s+-16>>2]|0;l=0;do{f[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[o>>2]|0))}o=f[s+-12>>2]|0;if((o|0)!=(s+-8|0))ZF(o);s=f[g>>2]|0}while((s|0)!=(n|0));u=c;return}case 11:{n=f[a+4>>2]|0;g=f[n>>2]|0;o=n+4|0;while(1){n=f[o>>2]|0;if((n|0)==(g|0))break;l=n+-48|0;f[o>>2]=l;j0(l)}u=c;return}case 13:{o=f[a+4>>2]|0;g=f[o>>2]|0;l=o+4|0;while(1){o=f[l>>2]|0;if((o|0)==(g|0))break;f[l>>2]=o+-36}u=c;return}case 0:{u=c;return}default:{f[d>>2]=0;f[d+4>>2]=0;i=c$(d,30)|0;j=173557;k=i+30|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-213,d,175544,172446,2897);d$(d);u=c;return}}while(0)}function pS(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;j=u;u=u+16|0;k=j;l=f[a>>2]|0;m=l&2031616;n=(g|0)<0;do if(n&(m|0)==65536){if((i|0)==0&(h^1)){if((l&1073741824|0)!=0?(o=f[(f[a+4>>2]|0)+40>>2]|0,!((f[o>>2]|0)==(c|0)?(f[o+4>>2]|0)==(d|0):0)):0){f[k>>2]=0;f[k+4>>2]=0;p=c$(k,68)|0;q=174938;r=p+68|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,k,357830,172446,2427);d$(k);s=f[a>>2]|0}else s=l;o=a+4|0;if((s|0)<0?(f[f[o>>2]>>2]&4095|0)!=(e|0):0){f[k>>2]=0;f[k+4>>2]=0;p=c$(k,44)|0;q=175007;r=p+44|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,k,357830,172446,2428);d$(k)}t=f[o>>2]|0;v=e&4095;if(((((f[t+4>>2]|0)<3?(f[t+8>>2]|0)==(c|0):0)?(f[t+12>>2]|0)==(d|0):0)?(f[t>>2]&4095|0)==(v|0):0)?f[t+16>>2]|0:0){u=j;return}f[k>>2]=c;f[k+4>>2]=d;AR(t,2,k,v);u=j;return}}else{if(n&(m|0)==655360){if(!((i|0)==0&(h^1)))break;if((l&1073741824|0)!=0?(v=f[(f[a+4>>2]|0)+32>>2]|0,!((f[v>>2]|0)==(c|0)?(f[v+4>>2]|0)==(d|0):0)):0){f[k>>2]=0;f[k+4>>2]=0;p=c$(k,69)|0;q=175052;r=p+69|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,k,357830,172446,2434);d$(k);w=f[a>>2]|0}else w=l;o=a+4|0;if((w|0)<0?(f[f[o>>2]>>2]&4095|0)!=(e|0):0){f[k>>2]=0;f[k+4>>2]=0;p=c$(k,45)|0;q=175122;r=p+45|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,k,357830,172446,2435);d$(k)}v=f[o>>2]|0;t=e&4095;if(((((f[v+4>>2]|0)<3?(f[v+8>>2]|0)==(c|0):0)?(f[v+12>>2]|0)==(d|0):0)?(f[v>>2]&4095|0)==(t|0):0)?f[v+24>>2]|0:0){u=j;return}f[k>>2]=c;f[k+4>>2]=d;h0(v,2,k,t,0);u=j;return}if(n&(m|0)==589824){if(!((i|0)==0&(h^1)))break;if((l&1073741824|0)!=0?(t=f[a+4>>2]|0,!((f[t+8>>2]|0)==(d|0)?(f[t+4>>2]|0)==(c|0):0)):0){f[k>>2]=0;f[k+4>>2]=0;p=c$(k,66)|0;q=175168;r=p+66|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,k,357830,172446,2441);d$(k);x=f[a>>2]|0}else x=l;o=a+4|0;if((x|0)<0?(f[f[o>>2]>>2]&4095|0)!=(e|0):0){f[k>>2]=0;f[k+4>>2]=0;p=c$(k,53)|0;q=175235;r=p+53|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,k,357830,172446,2442);d$(k)}b1(f[o>>2]|0,c,d,e);u=j;return}if(n&(m|0)==458752){if(!((i|0)==0&(h^1)))break;if((l&1073741824|0)!=0?(t=f[a+4>>2]|0,!((f[t+12>>2]|0)==(d|0)?(f[t+8>>2]|0)==(c|0):0)):0){f[k>>2]=0;f[k+4>>2]=0;p=c$(k,65)|0;q=175289;r=p+65|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,k,357830,172446,2448);d$(k);y=f[a>>2]|0}else y=l;o=a+4|0;if((y|0)<0?(f[(f[o>>2]|0)+16>>2]|0)!=(e|0):0){f[k>>2]=0;f[k+4>>2]=0;p=c$(k,52)|0;q=175355;r=p+52|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,k,357830,172446,2449);d$(k)}XU(f[o>>2]|0,c,d,e,34962,0);u=j;return}if(n&(m|0)==524288?(i|0)==0&(h^1):0){if((l&1073741824|0)!=0?(t=f[a+4>>2]|0,!((f[t+8>>2]|0)==(d|0)?(f[t+4>>2]|0)==(c|0):0)):0){f[k>>2]=0;f[k+4>>2]=0;p=c$(k,67)|0;q=175408;r=p+67|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,k,357830,172446,2455);d$(k);z=f[a>>2]|0}else z=l;o=a+4|0;if((z|0)<0?(f[f[o>>2]>>2]&4095|0)!=(e|0):0){f[k>>2]=0;f[k+4>>2]=0;p=c$(k,54)|0;q=175476;r=p+54|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,k,357830,172446,2456);d$(k)}e1(f[o>>2]|0,c,d,e);u=j;return}}while(0);f[k>>2]=c;f[k+4>>2]=d;MR(a,2,k,e,g,h,i);u=j;return}function qS(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=f[g>>2]|0;i=f[g+4>>2]|0;g=h+-4|0;do if((h|0)<4)j=0;else{k=i+-4|0;if((i|0)<4){if((i|0)>0){l=0;do{m=d+(Y(l,e)|0)|0;n=d+(Y(l|1,e)|0)|0;o=d+(Y(l|2,e)|0)|0;p=d+(Y(l|3,e)|0)|0;q=a+l|0;r=0;do{s=q+(Y(r,c)|0)|0;b[m+r>>0]=b[s>>0]|0;b[n+r>>0]=b[s+1>>0]|0;b[o+r>>0]=b[s+2>>0]|0;b[p+r>>0]=b[s+3>>0]|0;r=r+1|0}while((r|0)!=(i|0));l=l+4|0}while((l|0)<=(g|0))}j=h&-4;break}l=i&-4;r=(l|0)<(i|0);p=0;do{o=d+(Y(p,e)|0)|0;n=d+(Y(p|1,e)|0)|0;m=d+(Y(p|2,e)|0)|0;q=d+(Y(p|3,e)|0)|0;s=a+p|0;t=0;do{u=s+(Y(t,c)|0)|0;v=t|1;w=s+(Y(v,c)|0)|0;x=t|2;y=s+(Y(x,c)|0)|0;z=t|3;A=s+(Y(z,c)|0)|0;b[o+t>>0]=b[u>>0]|0;b[o+v>>0]=b[w>>0]|0;b[o+x>>0]=b[y>>0]|0;b[o+z>>0]=b[A>>0]|0;b[n+t>>0]=b[u+1>>0]|0;b[n+v>>0]=b[w+1>>0]|0;b[n+x>>0]=b[y+1>>0]|0;b[n+z>>0]=b[A+1>>0]|0;b[m+t>>0]=b[u+2>>0]|0;b[m+v>>0]=b[w+2>>0]|0;b[m+x>>0]=b[y+2>>0]|0;b[m+z>>0]=b[A+2>>0]|0;b[q+t>>0]=b[u+3>>0]|0;b[q+v>>0]=b[w+3>>0]|0;b[q+x>>0]=b[y+3>>0]|0;b[q+z>>0]=b[A+3>>0]|0;t=t+4|0}while((t|0)<=(k|0));if(r){t=l;do{A=s+(Y(t,c)|0)|0;b[o+t>>0]=b[A>>0]|0;b[n+t>>0]=b[A+1>>0]|0;b[m+t>>0]=b[A+2>>0]|0;b[q+t>>0]=b[A+3>>0]|0;t=t+1|0}while((t|0)!=(i|0))}p=p+4|0}while((p|0)<=(g|0));j=h&-4}while(0);if((j|0)>=(h|0))return;g=i+-4|0;if((i|0)<4){if((i|0)>0)B=j;else return;do{p=d+(Y(B,e)|0)|0;l=a+B|0;r=0;do{k=l+(Y(r,c)|0)|0;b[p+r>>0]=b[k>>0]|0;r=r+1|0}while((r|0)!=(i|0));B=B+1|0}while((B|0)!=(h|0));return}B=i&-4;if((B|0)<(i|0))C=j;else{r=j;do{j=d+(Y(r,e)|0)|0;p=a+r|0;l=0;do{k=p+(Y(l,c)|0)|0;t=l|1;q=p+(Y(t,c)|0)|0;m=l|2;n=p+(Y(m,c)|0)|0;o=l|3;s=p+(Y(o,c)|0)|0;b[j+l>>0]=b[k>>0]|0;b[j+t>>0]=b[q>>0]|0;b[j+m>>0]=b[n>>0]|0;b[j+o>>0]=b[s>>0]|0;l=l+4|0}while((l|0)<=(g|0));r=r+1|0}while((r|0)!=(h|0));return}do{r=d+(Y(C,e)|0)|0;l=a+C|0;j=0;do{p=l+(Y(j,c)|0)|0;s=j|1;o=l+(Y(s,c)|0)|0;n=j|2;m=l+(Y(n,c)|0)|0;q=j|3;t=l+(Y(q,c)|0)|0;b[r+j>>0]=b[p>>0]|0;b[r+s>>0]=b[o>>0]|0;b[r+n>>0]=b[m>>0]|0;b[r+q>>0]=b[t>>0]|0;j=j+4|0}while((j|0)<=(g|0));D=B;do{j=l+(Y(D,c)|0)|0;b[r+D>>0]=b[j>>0]|0;D=D+1|0}while((D|0)!=(i|0));C=C+1|0}while((C|0)!=(h|0));return}function rS(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=f[g>>2]|0;i=f[g+4>>2]|0;g=h+-4|0;do if((h|0)<4)j=0;else{k=i+-4|0;if((i|0)<4){if((i|0)>0){l=0;do{m=c+(Y(l,e)|0)|0;n=c+(Y(l|1,e)|0)|0;o=c+(Y(l|2,e)|0)|0;p=c+(Y(l|3,e)|0)|0;q=a+(l<<1)|0;r=0;do{s=q+(Y(r,b)|0)|0;d[m+(r<<1)>>1]=d[s>>1]|0;d[n+(r<<1)>>1]=d[s+2>>1]|0;d[o+(r<<1)>>1]=d[s+4>>1]|0;d[p+(r<<1)>>1]=d[s+6>>1]|0;r=r+1|0}while((r|0)!=(i|0));l=l+4|0}while((l|0)<=(g|0))}j=h&-4;break}l=i&-4;r=(l|0)<(i|0);p=0;do{o=c+(Y(p,e)|0)|0;n=c+(Y(p|1,e)|0)|0;m=c+(Y(p|2,e)|0)|0;q=c+(Y(p|3,e)|0)|0;s=a+(p<<1)|0;t=0;do{u=s+(Y(t,b)|0)|0;v=t|1;w=s+(Y(v,b)|0)|0;x=t|2;y=s+(Y(x,b)|0)|0;z=t|3;A=s+(Y(z,b)|0)|0;d[o+(t<<1)>>1]=d[u>>1]|0;d[o+(v<<1)>>1]=d[w>>1]|0;d[o+(x<<1)>>1]=d[y>>1]|0;d[o+(z<<1)>>1]=d[A>>1]|0;d[n+(t<<1)>>1]=d[u+2>>1]|0;d[n+(v<<1)>>1]=d[w+2>>1]|0;d[n+(x<<1)>>1]=d[y+2>>1]|0;d[n+(z<<1)>>1]=d[A+2>>1]|0;d[m+(t<<1)>>1]=d[u+4>>1]|0;d[m+(v<<1)>>1]=d[w+4>>1]|0;d[m+(x<<1)>>1]=d[y+4>>1]|0;d[m+(z<<1)>>1]=d[A+4>>1]|0;d[q+(t<<1)>>1]=d[u+6>>1]|0;d[q+(v<<1)>>1]=d[w+6>>1]|0;d[q+(x<<1)>>1]=d[y+6>>1]|0;d[q+(z<<1)>>1]=d[A+6>>1]|0;t=t+4|0}while((t|0)<=(k|0));if(r){t=l;do{A=s+(Y(t,b)|0)|0;d[o+(t<<1)>>1]=d[A>>1]|0;d[n+(t<<1)>>1]=d[A+2>>1]|0;d[m+(t<<1)>>1]=d[A+4>>1]|0;d[q+(t<<1)>>1]=d[A+6>>1]|0;t=t+1|0}while((t|0)!=(i|0))}p=p+4|0}while((p|0)<=(g|0));j=h&-4}while(0);if((j|0)>=(h|0))return;g=i+-4|0;if((i|0)<4){if((i|0)>0)B=j;else return;do{p=c+(Y(B,e)|0)|0;l=a+(B<<1)|0;r=0;do{k=l+(Y(r,b)|0)|0;d[p+(r<<1)>>1]=d[k>>1]|0;r=r+1|0}while((r|0)!=(i|0));B=B+1|0}while((B|0)!=(h|0));return}B=i&-4;if((B|0)<(i|0))C=j;else{r=j;do{j=c+(Y(r,e)|0)|0;p=a+(r<<1)|0;l=0;do{k=p+(Y(l,b)|0)|0;t=l|1;q=p+(Y(t,b)|0)|0;m=l|2;n=p+(Y(m,b)|0)|0;o=l|3;s=p+(Y(o,b)|0)|0;d[j+(l<<1)>>1]=d[k>>1]|0;d[j+(t<<1)>>1]=d[q>>1]|0;d[j+(m<<1)>>1]=d[n>>1]|0;d[j+(o<<1)>>1]=d[s>>1]|0;l=l+4|0}while((l|0)<=(g|0));r=r+1|0}while((r|0)!=(h|0));return}do{r=c+(Y(C,e)|0)|0;l=a+(C<<1)|0;j=0;do{p=l+(Y(j,b)|0)|0;s=j|1;o=l+(Y(s,b)|0)|0;n=j|2;m=l+(Y(n,b)|0)|0;q=j|3;t=l+(Y(q,b)|0)|0;d[r+(j<<1)>>1]=d[p>>1]|0;d[r+(s<<1)>>1]=d[o>>1]|0;d[r+(n<<1)>>1]=d[m>>1]|0;d[r+(q<<1)>>1]=d[t>>1]|0;j=j+4|0}while((j|0)<=(g|0));D=B;do{j=l+(Y(D,b)|0)|0;d[r+(D<<1)>>1]=d[j>>1]|0;D=D+1|0}while((D|0)!=(i|0));C=C+1|0}while((C|0)!=(h|0));return}function sS(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=f[g>>2]|0;i=f[g+4>>2]|0;g=h+-4|0;do if((h|0)<4)j=0;else{k=i+-4|0;if((i|0)<4){if((i|0)>0){l=0;do{m=d+(Y(l,e)|0)|0;n=d+(Y(l|1,e)|0)|0;o=d+(Y(l|2,e)|0)|0;p=d+(Y(l|3,e)|0)|0;q=a+(l*3|0)|0;r=0;do{s=q+(Y(r,c)|0)|0;t=m+(r*3|0)|0;b[t>>0]=b[s>>0]|0;b[t+1>>0]=b[s+1>>0]|0;b[t+2>>0]=b[s+2>>0]|0;t=s+3|0;u=n+(r*3|0)|0;b[u>>0]=b[t>>0]|0;b[u+1>>0]=b[t+1>>0]|0;b[u+2>>0]=b[t+2>>0]|0;t=s+6|0;u=o+(r*3|0)|0;b[u>>0]=b[t>>0]|0;b[u+1>>0]=b[t+1>>0]|0;b[u+2>>0]=b[t+2>>0]|0;t=s+9|0;s=p+(r*3|0)|0;b[s>>0]=b[t>>0]|0;b[s+1>>0]=b[t+1>>0]|0;b[s+2>>0]=b[t+2>>0]|0;r=r+1|0}while((r|0)!=(i|0));l=l+4|0}while((l|0)<=(g|0))}j=h&-4;break}l=i&-4;r=(l|0)<(i|0);p=0;do{o=d+(Y(p,e)|0)|0;n=d+(Y(p|1,e)|0)|0;m=d+(Y(p|2,e)|0)|0;q=d+(Y(p|3,e)|0)|0;t=a+(p*3|0)|0;s=0;do{u=t+(Y(s,c)|0)|0;v=s|1;w=t+(Y(v,c)|0)|0;x=s|2;y=t+(Y(x,c)|0)|0;z=s|3;A=t+(Y(z,c)|0)|0;B=o+(s*3|0)|0;b[B>>0]=b[u>>0]|0;b[B+1>>0]=b[u+1>>0]|0;b[B+2>>0]=b[u+2>>0]|0;B=o+(v*3|0)|0;b[B>>0]=b[w>>0]|0;b[B+1>>0]=b[w+1>>0]|0;b[B+2>>0]=b[w+2>>0]|0;B=o+(x*3|0)|0;b[B>>0]=b[y>>0]|0;b[B+1>>0]=b[y+1>>0]|0;b[B+2>>0]=b[y+2>>0]|0;B=o+(z*3|0)|0;b[B>>0]=b[A>>0]|0;b[B+1>>0]=b[A+1>>0]|0;b[B+2>>0]=b[A+2>>0]|0;B=u+3|0;C=n+(s*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=w+3|0;C=n+(v*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=y+3|0;C=n+(x*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=A+3|0;C=n+(z*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=u+6|0;C=m+(s*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=w+6|0;C=m+(v*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=y+6|0;C=m+(x*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=A+6|0;C=m+(z*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=u+9|0;u=q+(s*3|0)|0;b[u>>0]=b[B>>0]|0;b[u+1>>0]=b[B+1>>0]|0;b[u+2>>0]=b[B+2>>0]|0;B=w+9|0;w=q+(v*3|0)|0;b[w>>0]=b[B>>0]|0;b[w+1>>0]=b[B+1>>0]|0;b[w+2>>0]=b[B+2>>0]|0;B=y+9|0;y=q+(x*3|0)|0;b[y>>0]=b[B>>0]|0;b[y+1>>0]=b[B+1>>0]|0;b[y+2>>0]=b[B+2>>0]|0;B=A+9|0;A=q+(z*3|0)|0;b[A>>0]=b[B>>0]|0;b[A+1>>0]=b[B+1>>0]|0;b[A+2>>0]=b[B+2>>0]|0;s=s+4|0}while((s|0)<=(k|0));if(r){s=l;do{B=t+(Y(s,c)|0)|0;A=o+(s*3|0)|0;b[A>>0]=b[B>>0]|0;b[A+1>>0]=b[B+1>>0]|0;b[A+2>>0]=b[B+2>>0]|0;A=B+3|0;z=n+(s*3|0)|0;b[z>>0]=b[A>>0]|0;b[z+1>>0]=b[A+1>>0]|0;b[z+2>>0]=b[A+2>>0]|0;A=B+6|0;z=m+(s*3|0)|0;b[z>>0]=b[A>>0]|0;b[z+1>>0]=b[A+1>>0]|0;b[z+2>>0]=b[A+2>>0]|0;A=B+9|0;B=q+(s*3|0)|0;b[B>>0]=b[A>>0]|0;b[B+1>>0]=b[A+1>>0]|0;b[B+2>>0]=b[A+2>>0]|0;s=s+1|0}while((s|0)!=(i|0))}p=p+4|0}while((p|0)<=(g|0));j=h&-4}while(0);if((j|0)>=(h|0))return;g=i+-4|0;if((i|0)<4){if((i|0)>0)D=j;else return;do{p=d+(Y(D,e)|0)|0;l=a+(D*3|0)|0;r=0;do{k=l+(Y(r,c)|0)|0;s=p+(r*3|0)|0;b[s>>0]=b[k>>0]|0;b[s+1>>0]=b[k+1>>0]|0;b[s+2>>0]=b[k+2>>0]|0;r=r+1|0}while((r|0)!=(i|0));D=D+1|0}while((D|0)!=(h|0));return}D=i&-4;if((D|0)<(i|0))E=j;else{r=j;do{j=d+(Y(r,e)|0)|0;p=a+(r*3|0)|0;l=0;do{k=p+(Y(l,c)|0)|0;s=l|1;q=p+(Y(s,c)|0)|0;m=l|2;n=p+(Y(m,c)|0)|0;o=l|3;t=p+(Y(o,c)|0)|0;A=j+(l*3|0)|0;b[A>>0]=b[k>>0]|0;b[A+1>>0]=b[k+1>>0]|0;b[A+2>>0]=b[k+2>>0]|0;k=j+(s*3|0)|0;b[k>>0]=b[q>>0]|0;b[k+1>>0]=b[q+1>>0]|0;b[k+2>>0]=b[q+2>>0]|0;q=j+(m*3|0)|0;b[q>>0]=b[n>>0]|0;b[q+1>>0]=b[n+1>>0]|0;b[q+2>>0]=b[n+2>>0]|0;n=j+(o*3|0)|0;b[n>>0]=b[t>>0]|0;b[n+1>>0]=b[t+1>>0]|0;b[n+2>>0]=b[t+2>>0]|0;l=l+4|0}while((l|0)<=(g|0));r=r+1|0}while((r|0)!=(h|0));return}do{r=d+(Y(E,e)|0)|0;l=a+(E*3|0)|0;j=0;do{p=l+(Y(j,c)|0)|0;t=j|1;n=l+(Y(t,c)|0)|0;o=j|2;q=l+(Y(o,c)|0)|0;m=j|3;k=l+(Y(m,c)|0)|0;s=r+(j*3|0)|0;b[s>>0]=b[p>>0]|0;b[s+1>>0]=b[p+1>>0]|0;b[s+2>>0]=b[p+2>>0]|0;p=r+(t*3|0)|0;b[p>>0]=b[n>>0]|0;b[p+1>>0]=b[n+1>>0]|0;b[p+2>>0]=b[n+2>>0]|0;n=r+(o*3|0)|0;b[n>>0]=b[q>>0]|0;b[n+1>>0]=b[q+1>>0]|0;b[n+2>>0]=b[q+2>>0]|0;q=r+(m*3|0)|0;b[q>>0]=b[k>>0]|0;b[q+1>>0]=b[k+1>>0]|0;b[q+2>>0]=b[k+2>>0]|0;j=j+4|0}while((j|0)<=(g|0));F=D;do{j=l+(Y(F,c)|0)|0;k=r+(F*3|0)|0;b[k>>0]=b[j>>0]|0;b[k+1>>0]=b[j+1>>0]|0;b[k+2>>0]=b[j+2>>0]|0;F=F+1|0}while((F|0)!=(i|0));E=E+1|0}while((E|0)!=(h|0));return}function tS(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k<<2)|0;q=0;do{r=p+(Y(q,b)|0)|0;f[l+(q<<2)>>2]=f[r>>2];f[m+(q<<2)>>2]=f[r+4>>2];f[n+(q<<2)>>2]=f[r+8>>2];f[o+(q<<2)>>2]=f[r+12>>2];q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;r=a+(o<<2)|0;s=0;do{t=r+(Y(s,b)|0)|0;u=s|1;v=r+(Y(u,b)|0)|0;w=s|2;x=r+(Y(w,b)|0)|0;y=s|3;z=r+(Y(y,b)|0)|0;f[n+(s<<2)>>2]=f[t>>2];f[n+(u<<2)>>2]=f[v>>2];f[n+(w<<2)>>2]=f[x>>2];f[n+(y<<2)>>2]=f[z>>2];f[m+(s<<2)>>2]=f[t+4>>2];f[m+(u<<2)>>2]=f[v+4>>2];f[m+(w<<2)>>2]=f[x+4>>2];f[m+(y<<2)>>2]=f[z+4>>2];f[l+(s<<2)>>2]=f[t+8>>2];f[l+(u<<2)>>2]=f[v+8>>2];f[l+(w<<2)>>2]=f[x+8>>2];f[l+(y<<2)>>2]=f[z+8>>2];f[p+(s<<2)>>2]=f[t+12>>2];f[p+(u<<2)>>2]=f[v+12>>2];f[p+(w<<2)>>2]=f[x+12>>2];f[p+(y<<2)>>2]=f[z+12>>2];s=s+4|0}while((s|0)<=(j|0));if(q){s=k;do{z=r+(Y(s,b)|0)|0;f[n+(s<<2)>>2]=f[z>>2];f[m+(s<<2)>>2]=f[z+4>>2];f[l+(s<<2)>>2]=f[z+8>>2];f[p+(s<<2)>>2]=f[z+12>>2];s=s+1|0}while((s|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)A=i;else return;do{o=c+(Y(A,d)|0)|0;k=a+(A<<2)|0;q=0;do{j=k+(Y(q,b)|0)|0;f[o+(q<<2)>>2]=f[j>>2];q=q+1|0}while((q|0)!=(h|0));A=A+1|0}while((A|0)!=(g|0));return}A=h&-4;if((A|0)<(h|0))B=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q<<2)|0;k=0;do{j=o+(Y(k,b)|0)|0;s=k|1;p=o+(Y(s,b)|0)|0;l=k|2;m=o+(Y(l,b)|0)|0;n=k|3;r=o+(Y(n,b)|0)|0;f[i+(k<<2)>>2]=f[j>>2];f[i+(s<<2)>>2]=f[p>>2];f[i+(l<<2)>>2]=f[m>>2];f[i+(n<<2)>>2]=f[r>>2];k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(B,d)|0)|0;k=a+(B<<2)|0;i=0;do{o=k+(Y(i,b)|0)|0;r=i|1;n=k+(Y(r,b)|0)|0;m=i|2;l=k+(Y(m,b)|0)|0;p=i|3;s=k+(Y(p,b)|0)|0;f[q+(i<<2)>>2]=f[o>>2];f[q+(r<<2)>>2]=f[n>>2];f[q+(m<<2)>>2]=f[l>>2];f[q+(p<<2)>>2]=f[s>>2];i=i+4|0}while((i|0)<=(e|0));C=A;do{i=k+(Y(C,b)|0)|0;f[q+(C<<2)>>2]=f[i>>2];C=C+1|0}while((C|0)!=(h|0));B=B+1|0}while((B|0)!=(g|0));return}function uS(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=f[g>>2]|0;i=f[g+4>>2]|0;g=h+-4|0;do if((h|0)<4)j=0;else{k=i+-4|0;if((i|0)<4){if((i|0)>0){l=0;do{m=c+(Y(l,e)|0)|0;n=c+(Y(l|1,e)|0)|0;o=c+(Y(l|2,e)|0)|0;p=c+(Y(l|3,e)|0)|0;q=a+(l*6|0)|0;r=0;do{s=q+(Y(r,b)|0)|0;t=m+(r*6|0)|0;d[t>>1]=d[s>>1]|0;d[t+2>>1]=d[s+2>>1]|0;d[t+4>>1]=d[s+4>>1]|0;t=s+6|0;u=n+(r*6|0)|0;d[u>>1]=d[t>>1]|0;d[u+2>>1]=d[t+2>>1]|0;d[u+4>>1]=d[t+4>>1]|0;t=s+12|0;u=o+(r*6|0)|0;d[u>>1]=d[t>>1]|0;d[u+2>>1]=d[t+2>>1]|0;d[u+4>>1]=d[t+4>>1]|0;t=s+18|0;s=p+(r*6|0)|0;d[s>>1]=d[t>>1]|0;d[s+2>>1]=d[t+2>>1]|0;d[s+4>>1]=d[t+4>>1]|0;r=r+1|0}while((r|0)!=(i|0));l=l+4|0}while((l|0)<=(g|0))}j=h&-4;break}l=i&-4;r=(l|0)<(i|0);p=0;do{o=c+(Y(p,e)|0)|0;n=c+(Y(p|1,e)|0)|0;m=c+(Y(p|2,e)|0)|0;q=c+(Y(p|3,e)|0)|0;t=a+(p*6|0)|0;s=0;do{u=t+(Y(s,b)|0)|0;v=s|1;w=t+(Y(v,b)|0)|0;x=s|2;y=t+(Y(x,b)|0)|0;z=s|3;A=t+(Y(z,b)|0)|0;B=o+(s*6|0)|0;d[B>>1]=d[u>>1]|0;d[B+2>>1]=d[u+2>>1]|0;d[B+4>>1]=d[u+4>>1]|0;B=o+(v*6|0)|0;d[B>>1]=d[w>>1]|0;d[B+2>>1]=d[w+2>>1]|0;d[B+4>>1]=d[w+4>>1]|0;B=o+(x*6|0)|0;d[B>>1]=d[y>>1]|0;d[B+2>>1]=d[y+2>>1]|0;d[B+4>>1]=d[y+4>>1]|0;B=o+(z*6|0)|0;d[B>>1]=d[A>>1]|0;d[B+2>>1]=d[A+2>>1]|0;d[B+4>>1]=d[A+4>>1]|0;B=u+6|0;C=n+(s*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=w+6|0;C=n+(v*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=y+6|0;C=n+(x*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=A+6|0;C=n+(z*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=u+12|0;C=m+(s*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=w+12|0;C=m+(v*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=y+12|0;C=m+(x*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=A+12|0;C=m+(z*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=u+18|0;u=q+(s*6|0)|0;d[u>>1]=d[B>>1]|0;d[u+2>>1]=d[B+2>>1]|0;d[u+4>>1]=d[B+4>>1]|0;B=w+18|0;w=q+(v*6|0)|0;d[w>>1]=d[B>>1]|0;d[w+2>>1]=d[B+2>>1]|0;d[w+4>>1]=d[B+4>>1]|0;B=y+18|0;y=q+(x*6|0)|0;d[y>>1]=d[B>>1]|0;d[y+2>>1]=d[B+2>>1]|0;d[y+4>>1]=d[B+4>>1]|0;B=A+18|0;A=q+(z*6|0)|0;d[A>>1]=d[B>>1]|0;d[A+2>>1]=d[B+2>>1]|0;d[A+4>>1]=d[B+4>>1]|0;s=s+4|0}while((s|0)<=(k|0));if(r){s=l;do{B=t+(Y(s,b)|0)|0;A=o+(s*6|0)|0;d[A>>1]=d[B>>1]|0;d[A+2>>1]=d[B+2>>1]|0;d[A+4>>1]=d[B+4>>1]|0;A=B+6|0;z=n+(s*6|0)|0;d[z>>1]=d[A>>1]|0;d[z+2>>1]=d[A+2>>1]|0;d[z+4>>1]=d[A+4>>1]|0;A=B+12|0;z=m+(s*6|0)|0;d[z>>1]=d[A>>1]|0;d[z+2>>1]=d[A+2>>1]|0;d[z+4>>1]=d[A+4>>1]|0;A=B+18|0;B=q+(s*6|0)|0;d[B>>1]=d[A>>1]|0;d[B+2>>1]=d[A+2>>1]|0;d[B+4>>1]=d[A+4>>1]|0;s=s+1|0}while((s|0)!=(i|0))}p=p+4|0}while((p|0)<=(g|0));j=h&-4}while(0);if((j|0)>=(h|0))return;g=i+-4|0;if((i|0)<4){if((i|0)>0)D=j;else return;do{p=c+(Y(D,e)|0)|0;l=a+(D*6|0)|0;r=0;do{k=l+(Y(r,b)|0)|0;s=p+(r*6|0)|0;d[s>>1]=d[k>>1]|0;d[s+2>>1]=d[k+2>>1]|0;d[s+4>>1]=d[k+4>>1]|0;r=r+1|0}while((r|0)!=(i|0));D=D+1|0}while((D|0)!=(h|0));return}D=i&-4;if((D|0)<(i|0))E=j;else{r=j;do{j=c+(Y(r,e)|0)|0;p=a+(r*6|0)|0;l=0;do{k=p+(Y(l,b)|0)|0;s=l|1;q=p+(Y(s,b)|0)|0;m=l|2;n=p+(Y(m,b)|0)|0;o=l|3;t=p+(Y(o,b)|0)|0;A=j+(l*6|0)|0;d[A>>1]=d[k>>1]|0;d[A+2>>1]=d[k+2>>1]|0;d[A+4>>1]=d[k+4>>1]|0;k=j+(s*6|0)|0;d[k>>1]=d[q>>1]|0;d[k+2>>1]=d[q+2>>1]|0;d[k+4>>1]=d[q+4>>1]|0;q=j+(m*6|0)|0;d[q>>1]=d[n>>1]|0;d[q+2>>1]=d[n+2>>1]|0;d[q+4>>1]=d[n+4>>1]|0;n=j+(o*6|0)|0;d[n>>1]=d[t>>1]|0;d[n+2>>1]=d[t+2>>1]|0;d[n+4>>1]=d[t+4>>1]|0;l=l+4|0}while((l|0)<=(g|0));r=r+1|0}while((r|0)!=(h|0));return}do{r=c+(Y(E,e)|0)|0;l=a+(E*6|0)|0;j=0;do{p=l+(Y(j,b)|0)|0;t=j|1;n=l+(Y(t,b)|0)|0;o=j|2;q=l+(Y(o,b)|0)|0;m=j|3;k=l+(Y(m,b)|0)|0;s=r+(j*6|0)|0;d[s>>1]=d[p>>1]|0;d[s+2>>1]=d[p+2>>1]|0;d[s+4>>1]=d[p+4>>1]|0;p=r+(t*6|0)|0;d[p>>1]=d[n>>1]|0;d[p+2>>1]=d[n+2>>1]|0;d[p+4>>1]=d[n+4>>1]|0;n=r+(o*6|0)|0;d[n>>1]=d[q>>1]|0;d[n+2>>1]=d[q+2>>1]|0;d[n+4>>1]=d[q+4>>1]|0;q=r+(m*6|0)|0;d[q>>1]=d[k>>1]|0;d[q+2>>1]=d[k+2>>1]|0;d[q+4>>1]=d[k+4>>1]|0;j=j+4|0}while((j|0)<=(g|0));F=D;do{j=l+(Y(F,b)|0)|0;k=r+(F*6|0)|0;d[k>>1]=d[j>>1]|0;d[k+2>>1]=d[j+2>>1]|0;d[k+4>>1]=d[j+4>>1]|0;F=F+1|0}while((F|0)!=(i|0));E=E+1|0}while((E|0)!=(h|0));return}function vS(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k<<3)|0;q=0;do{r=p+(Y(q,b)|0)|0;s=r;t=f[s+4>>2]|0;u=l+(q<<3)|0;f[u>>2]=f[s>>2];f[u+4>>2]=t;t=r+8|0;u=f[t+4>>2]|0;s=m+(q<<3)|0;f[s>>2]=f[t>>2];f[s+4>>2]=u;u=r+16|0;s=f[u+4>>2]|0;t=n+(q<<3)|0;f[t>>2]=f[u>>2];f[t+4>>2]=s;s=r+24|0;r=f[s+4>>2]|0;t=o+(q<<3)|0;f[t>>2]=f[s>>2];f[t+4>>2]=r;q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;r=a+(o<<3)|0;t=0;do{s=r+(Y(t,b)|0)|0;u=t|1;v=r+(Y(u,b)|0)|0;w=t|2;x=r+(Y(w,b)|0)|0;y=t|3;z=r+(Y(y,b)|0)|0;A=s;B=f[A+4>>2]|0;C=n+(t<<3)|0;f[C>>2]=f[A>>2];f[C+4>>2]=B;B=v;C=f[B+4>>2]|0;A=n+(u<<3)|0;f[A>>2]=f[B>>2];f[A+4>>2]=C;C=x;A=f[C+4>>2]|0;B=n+(w<<3)|0;f[B>>2]=f[C>>2];f[B+4>>2]=A;A=z;B=f[A+4>>2]|0;C=n+(y<<3)|0;f[C>>2]=f[A>>2];f[C+4>>2]=B;B=s+8|0;C=f[B+4>>2]|0;A=m+(t<<3)|0;f[A>>2]=f[B>>2];f[A+4>>2]=C;C=v+8|0;A=f[C+4>>2]|0;B=m+(u<<3)|0;f[B>>2]=f[C>>2];f[B+4>>2]=A;A=x+8|0;B=f[A+4>>2]|0;C=m+(w<<3)|0;f[C>>2]=f[A>>2];f[C+4>>2]=B;B=z+8|0;C=f[B+4>>2]|0;A=m+(y<<3)|0;f[A>>2]=f[B>>2];f[A+4>>2]=C;C=s+16|0;A=f[C+4>>2]|0;B=l+(t<<3)|0;f[B>>2]=f[C>>2];f[B+4>>2]=A;A=v+16|0;B=f[A+4>>2]|0;C=l+(u<<3)|0;f[C>>2]=f[A>>2];f[C+4>>2]=B;B=x+16|0;C=f[B+4>>2]|0;A=l+(w<<3)|0;f[A>>2]=f[B>>2];f[A+4>>2]=C;C=z+16|0;A=f[C+4>>2]|0;B=l+(y<<3)|0;f[B>>2]=f[C>>2];f[B+4>>2]=A;A=s+24|0;s=f[A+4>>2]|0;B=p+(t<<3)|0;f[B>>2]=f[A>>2];f[B+4>>2]=s;s=v+24|0;v=f[s+4>>2]|0;B=p+(u<<3)|0;f[B>>2]=f[s>>2];f[B+4>>2]=v;v=x+24|0;x=f[v+4>>2]|0;B=p+(w<<3)|0;f[B>>2]=f[v>>2];f[B+4>>2]=x;x=z+24|0;z=f[x+4>>2]|0;B=p+(y<<3)|0;f[B>>2]=f[x>>2];f[B+4>>2]=z;t=t+4|0}while((t|0)<=(j|0));if(q){t=k;do{z=r+(Y(t,b)|0)|0;B=z;x=f[B+4>>2]|0;y=n+(t<<3)|0;f[y>>2]=f[B>>2];f[y+4>>2]=x;x=z+8|0;y=f[x+4>>2]|0;B=m+(t<<3)|0;f[B>>2]=f[x>>2];f[B+4>>2]=y;y=z+16|0;B=f[y+4>>2]|0;x=l+(t<<3)|0;f[x>>2]=f[y>>2];f[x+4>>2]=B;B=z+24|0;z=f[B+4>>2]|0;x=p+(t<<3)|0;f[x>>2]=f[B>>2];f[x+4>>2]=z;t=t+1|0}while((t|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)D=i;else return;do{o=c+(Y(D,d)|0)|0;k=a+(D<<3)|0;q=0;do{j=k+(Y(q,b)|0)|0;t=f[j+4>>2]|0;p=o+(q<<3)|0;f[p>>2]=f[j>>2];f[p+4>>2]=t;q=q+1|0}while((q|0)!=(h|0));D=D+1|0}while((D|0)!=(g|0));return}D=h&-4;if((D|0)<(h|0))E=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q<<3)|0;k=0;do{t=k|1;p=o+(Y(t,b)|0)|0;j=k|2;l=o+(Y(j,b)|0)|0;m=k|3;n=o+(Y(m,b)|0)|0;r=o+(Y(k,b)|0)|0;z=f[r+4>>2]|0;x=i+(k<<3)|0;f[x>>2]=f[r>>2];f[x+4>>2]=z;z=p;p=f[z+4>>2]|0;x=i+(t<<3)|0;f[x>>2]=f[z>>2];f[x+4>>2]=p;p=l;l=f[p+4>>2]|0;x=i+(j<<3)|0;f[x>>2]=f[p>>2];f[x+4>>2]=l;l=n;n=f[l+4>>2]|0;x=i+(m<<3)|0;f[x>>2]=f[l>>2];f[x+4>>2]=n;k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(E,d)|0)|0;k=a+(E<<3)|0;i=0;do{o=i|1;n=k+(Y(o,b)|0)|0;x=i|2;l=k+(Y(x,b)|0)|0;m=i|3;p=k+(Y(m,b)|0)|0;j=k+(Y(i,b)|0)|0;z=f[j+4>>2]|0;t=q+(i<<3)|0;f[t>>2]=f[j>>2];f[t+4>>2]=z;z=n;n=f[z+4>>2]|0;t=q+(o<<3)|0;f[t>>2]=f[z>>2];f[t+4>>2]=n;n=l;l=f[n+4>>2]|0;t=q+(x<<3)|0;f[t>>2]=f[n>>2];f[t+4>>2]=l;l=p;p=f[l+4>>2]|0;t=q+(m<<3)|0;f[t>>2]=f[l>>2];f[t+4>>2]=p;i=i+4|0}while((i|0)<=(e|0));F=D;do{i=k+(Y(F,b)|0)|0;p=f[i+4>>2]|0;t=q+(F<<3)|0;f[t>>2]=f[i>>2];f[t+4>>2]=p;F=F+1|0}while((F|0)!=(h|0));E=E+1|0}while((E|0)!=(g|0));return}function wS(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k*12|0)|0;q=0;do{r=p+(Y(q,b)|0)|0;s=l+(q*12|0)|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];f[s+8>>2]=f[r+8>>2];s=r+12|0;t=m+(q*12|0)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];s=r+24|0;t=n+(q*12|0)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];s=r+36|0;r=o+(q*12|0)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;s=a+(o*12|0)|0;r=0;do{t=s+(Y(r,b)|0)|0;u=r|1;v=s+(Y(u,b)|0)|0;w=r|2;x=s+(Y(w,b)|0)|0;y=r|3;z=s+(Y(y,b)|0)|0;A=n+(r*12|0)|0;f[A>>2]=f[t>>2];f[A+4>>2]=f[t+4>>2];f[A+8>>2]=f[t+8>>2];A=n+(u*12|0)|0;f[A>>2]=f[v>>2];f[A+4>>2]=f[v+4>>2];f[A+8>>2]=f[v+8>>2];A=n+(w*12|0)|0;f[A>>2]=f[x>>2];f[A+4>>2]=f[x+4>>2];f[A+8>>2]=f[x+8>>2];A=n+(y*12|0)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];A=t+12|0;B=m+(r*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=v+12|0;B=m+(u*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=x+12|0;B=m+(w*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=z+12|0;B=m+(y*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=t+24|0;B=l+(r*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=v+24|0;B=l+(u*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=x+24|0;B=l+(w*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=z+24|0;B=l+(y*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=t+36|0;t=p+(r*12|0)|0;f[t>>2]=f[A>>2];f[t+4>>2]=f[A+4>>2];f[t+8>>2]=f[A+8>>2];A=v+36|0;v=p+(u*12|0)|0;f[v>>2]=f[A>>2];f[v+4>>2]=f[A+4>>2];f[v+8>>2]=f[A+8>>2];A=x+36|0;x=p+(w*12|0)|0;f[x>>2]=f[A>>2];f[x+4>>2]=f[A+4>>2];f[x+8>>2]=f[A+8>>2];A=z+36|0;z=p+(y*12|0)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];r=r+4|0}while((r|0)<=(j|0));if(q){r=k;do{A=s+(Y(r,b)|0)|0;z=n+(r*12|0)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];z=A+12|0;y=m+(r*12|0)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];z=A+24|0;y=l+(r*12|0)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];z=A+36|0;A=p+(r*12|0)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];r=r+1|0}while((r|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)C=i;else return;do{o=c+(Y(C,d)|0)|0;k=a+(C*12|0)|0;q=0;do{j=k+(Y(q,b)|0)|0;r=o+(q*12|0)|0;f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[r+8>>2]=f[j+8>>2];q=q+1|0}while((q|0)!=(h|0));C=C+1|0}while((C|0)!=(g|0));return}C=h&-4;if((C|0)<(h|0))D=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q*12|0)|0;k=0;do{j=o+(Y(k,b)|0)|0;r=k|1;p=o+(Y(r,b)|0)|0;l=k|2;m=o+(Y(l,b)|0)|0;n=k|3;s=o+(Y(n,b)|0)|0;z=i+(k*12|0)|0;f[z>>2]=f[j>>2];f[z+4>>2]=f[j+4>>2];f[z+8>>2]=f[j+8>>2];j=i+(r*12|0)|0;f[j>>2]=f[p>>2];f[j+4>>2]=f[p+4>>2];f[j+8>>2]=f[p+8>>2];p=i+(l*12|0)|0;f[p>>2]=f[m>>2];f[p+4>>2]=f[m+4>>2];f[p+8>>2]=f[m+8>>2];m=i+(n*12|0)|0;f[m>>2]=f[s>>2];f[m+4>>2]=f[s+4>>2];f[m+8>>2]=f[s+8>>2];k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(D,d)|0)|0;k=a+(D*12|0)|0;i=0;do{o=k+(Y(i,b)|0)|0;s=i|1;m=k+(Y(s,b)|0)|0;n=i|2;p=k+(Y(n,b)|0)|0;l=i|3;j=k+(Y(l,b)|0)|0;r=q+(i*12|0)|0;f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];o=q+(s*12|0)|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];f[o+8>>2]=f[m+8>>2];m=q+(n*12|0)|0;f[m>>2]=f[p>>2];f[m+4>>2]=f[p+4>>2];f[m+8>>2]=f[p+8>>2];p=q+(l*12|0)|0;f[p>>2]=f[j>>2];f[p+4>>2]=f[j+4>>2];f[p+8>>2]=f[j+8>>2];i=i+4|0}while((i|0)<=(e|0));E=C;do{i=k+(Y(E,b)|0)|0;j=q+(E*12|0)|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];E=E+1|0}while((E|0)!=(h|0));D=D+1|0}while((D|0)!=(g|0));return}function xS(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k<<4)|0;q=0;do{r=p+(Y(q,b)|0)|0;s=l+(q<<4)|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];f[s+8>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];s=r+16|0;t=m+(q<<4)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];s=r+32|0;t=n+(q<<4)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];s=r+48|0;r=o+(q<<4)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2];q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;s=a+(o<<4)|0;r=0;do{t=s+(Y(r,b)|0)|0;u=r|1;v=s+(Y(u,b)|0)|0;w=r|2;x=s+(Y(w,b)|0)|0;y=r|3;z=s+(Y(y,b)|0)|0;A=n+(r<<4)|0;f[A>>2]=f[t>>2];f[A+4>>2]=f[t+4>>2];f[A+8>>2]=f[t+8>>2];f[A+12>>2]=f[t+12>>2];A=n+(u<<4)|0;f[A>>2]=f[v>>2];f[A+4>>2]=f[v+4>>2];f[A+8>>2]=f[v+8>>2];f[A+12>>2]=f[v+12>>2];A=n+(w<<4)|0;f[A>>2]=f[x>>2];f[A+4>>2]=f[x+4>>2];f[A+8>>2]=f[x+8>>2];f[A+12>>2]=f[x+12>>2];A=n+(y<<4)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];A=t+16|0;B=m+(r<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=v+16|0;B=m+(u<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=x+16|0;B=m+(w<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=z+16|0;B=m+(y<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=t+32|0;B=l+(r<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=v+32|0;B=l+(u<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=x+32|0;B=l+(w<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=z+32|0;B=l+(y<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=t+48|0;t=p+(r<<4)|0;f[t>>2]=f[A>>2];f[t+4>>2]=f[A+4>>2];f[t+8>>2]=f[A+8>>2];f[t+12>>2]=f[A+12>>2];A=v+48|0;v=p+(u<<4)|0;f[v>>2]=f[A>>2];f[v+4>>2]=f[A+4>>2];f[v+8>>2]=f[A+8>>2];f[v+12>>2]=f[A+12>>2];A=x+48|0;x=p+(w<<4)|0;f[x>>2]=f[A>>2];f[x+4>>2]=f[A+4>>2];f[x+8>>2]=f[A+8>>2];f[x+12>>2]=f[A+12>>2];A=z+48|0;z=p+(y<<4)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];r=r+4|0}while((r|0)<=(j|0));if(q){r=k;do{A=s+(Y(r,b)|0)|0;z=n+(r<<4)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];z=A+16|0;y=m+(r<<4)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];z=A+32|0;y=l+(r<<4)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];z=A+48|0;A=p+(r<<4)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];r=r+1|0}while((r|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)C=i;else return;do{o=c+(Y(C,d)|0)|0;k=a+(C<<4)|0;q=0;do{j=k+(Y(q,b)|0)|0;r=o+(q<<4)|0;f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[r+8>>2]=f[j+8>>2];f[r+12>>2]=f[j+12>>2];q=q+1|0}while((q|0)!=(h|0));C=C+1|0}while((C|0)!=(g|0));return}C=h&-4;if((C|0)<(h|0))D=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q<<4)|0;k=0;do{j=o+(Y(k,b)|0)|0;r=k|1;p=o+(Y(r,b)|0)|0;l=k|2;m=o+(Y(l,b)|0)|0;n=k|3;s=o+(Y(n,b)|0)|0;z=i+(k<<4)|0;f[z>>2]=f[j>>2];f[z+4>>2]=f[j+4>>2];f[z+8>>2]=f[j+8>>2];f[z+12>>2]=f[j+12>>2];j=i+(r<<4)|0;f[j>>2]=f[p>>2];f[j+4>>2]=f[p+4>>2];f[j+8>>2]=f[p+8>>2];f[j+12>>2]=f[p+12>>2];p=i+(l<<4)|0;f[p>>2]=f[m>>2];f[p+4>>2]=f[m+4>>2];f[p+8>>2]=f[m+8>>2];f[p+12>>2]=f[m+12>>2];m=i+(n<<4)|0;f[m>>2]=f[s>>2];f[m+4>>2]=f[s+4>>2];f[m+8>>2]=f[s+8>>2];f[m+12>>2]=f[s+12>>2];k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(D,d)|0)|0;k=a+(D<<4)|0;i=0;do{o=k+(Y(i,b)|0)|0;s=i|1;m=k+(Y(s,b)|0)|0;n=i|2;p=k+(Y(n,b)|0)|0;l=i|3;j=k+(Y(l,b)|0)|0;r=q+(i<<4)|0;f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];f[r+12>>2]=f[o+12>>2];o=q+(s<<4)|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];f[o+8>>2]=f[m+8>>2];f[o+12>>2]=f[m+12>>2];m=q+(n<<4)|0;f[m>>2]=f[p>>2];f[m+4>>2]=f[p+4>>2];f[m+8>>2]=f[p+8>>2];f[m+12>>2]=f[p+12>>2];p=q+(l<<4)|0;f[p>>2]=f[j>>2];f[p+4>>2]=f[j+4>>2];f[p+8>>2]=f[j+8>>2];f[p+12>>2]=f[j+12>>2];i=i+4|0}while((i|0)<=(e|0));E=C;do{i=k+(Y(E,b)|0)|0;j=q+(E<<4)|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];E=E+1|0}while((E|0)!=(h|0));D=D+1|0}while((D|0)!=(g|0));return}function yS(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k*24|0)|0;q=0;do{r=p+(Y(q,b)|0)|0;s=l+(q*24|0)|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];f[s+8>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];f[s+16>>2]=f[r+16>>2];f[s+20>>2]=f[r+20>>2];s=r+24|0;t=m+(q*24|0)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];s=r+48|0;t=n+(q*24|0)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];s=r+72|0;r=o+(q*24|0)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2];f[r+16>>2]=f[s+16>>2];f[r+20>>2]=f[s+20>>2];q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;s=a+(o*24|0)|0;r=0;do{t=s+(Y(r,b)|0)|0;u=r|1;v=s+(Y(u,b)|0)|0;w=r|2;x=s+(Y(w,b)|0)|0;y=r|3;z=s+(Y(y,b)|0)|0;A=n+(r*24|0)|0;f[A>>2]=f[t>>2];f[A+4>>2]=f[t+4>>2];f[A+8>>2]=f[t+8>>2];f[A+12>>2]=f[t+12>>2];f[A+16>>2]=f[t+16>>2];f[A+20>>2]=f[t+20>>2];A=n+(u*24|0)|0;f[A>>2]=f[v>>2];f[A+4>>2]=f[v+4>>2];f[A+8>>2]=f[v+8>>2];f[A+12>>2]=f[v+12>>2];f[A+16>>2]=f[v+16>>2];f[A+20>>2]=f[v+20>>2];A=n+(w*24|0)|0;f[A>>2]=f[x>>2];f[A+4>>2]=f[x+4>>2];f[A+8>>2]=f[x+8>>2];f[A+12>>2]=f[x+12>>2];f[A+16>>2]=f[x+16>>2];f[A+20>>2]=f[x+20>>2];A=n+(y*24|0)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];f[A+16>>2]=f[z+16>>2];f[A+20>>2]=f[z+20>>2];A=t+24|0;B=m+(r*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=v+24|0;B=m+(u*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=x+24|0;B=m+(w*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=z+24|0;B=m+(y*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=t+48|0;B=l+(r*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=v+48|0;B=l+(u*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=x+48|0;B=l+(w*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=z+48|0;B=l+(y*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=t+72|0;t=p+(r*24|0)|0;f[t>>2]=f[A>>2];f[t+4>>2]=f[A+4>>2];f[t+8>>2]=f[A+8>>2];f[t+12>>2]=f[A+12>>2];f[t+16>>2]=f[A+16>>2];f[t+20>>2]=f[A+20>>2];A=v+72|0;v=p+(u*24|0)|0;f[v>>2]=f[A>>2];f[v+4>>2]=f[A+4>>2];f[v+8>>2]=f[A+8>>2];f[v+12>>2]=f[A+12>>2];f[v+16>>2]=f[A+16>>2];f[v+20>>2]=f[A+20>>2];A=x+72|0;x=p+(w*24|0)|0;f[x>>2]=f[A>>2];f[x+4>>2]=f[A+4>>2];f[x+8>>2]=f[A+8>>2];f[x+12>>2]=f[A+12>>2];f[x+16>>2]=f[A+16>>2];f[x+20>>2]=f[A+20>>2];A=z+72|0;z=p+(y*24|0)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];f[z+16>>2]=f[A+16>>2];f[z+20>>2]=f[A+20>>2];r=r+4|0}while((r|0)<=(j|0));if(q){r=k;do{A=s+(Y(r,b)|0)|0;z=n+(r*24|0)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];f[z+16>>2]=f[A+16>>2];f[z+20>>2]=f[A+20>>2];z=A+24|0;y=m+(r*24|0)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];f[y+16>>2]=f[z+16>>2];f[y+20>>2]=f[z+20>>2];z=A+48|0;y=l+(r*24|0)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];f[y+16>>2]=f[z+16>>2];f[y+20>>2]=f[z+20>>2];z=A+72|0;A=p+(r*24|0)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];f[A+16>>2]=f[z+16>>2];f[A+20>>2]=f[z+20>>2];r=r+1|0}while((r|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)C=i;else return;do{o=c+(Y(C,d)|0)|0;k=a+(C*24|0)|0;q=0;do{j=k+(Y(q,b)|0)|0;r=o+(q*24|0)|0;f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[r+8>>2]=f[j+8>>2];f[r+12>>2]=f[j+12>>2];f[r+16>>2]=f[j+16>>2];f[r+20>>2]=f[j+20>>2];q=q+1|0}while((q|0)!=(h|0));C=C+1|0}while((C|0)!=(g|0));return}C=h&-4;if((C|0)<(h|0))D=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q*24|0)|0;k=0;do{j=o+(Y(k,b)|0)|0;r=k|1;p=o+(Y(r,b)|0)|0;l=k|2;m=o+(Y(l,b)|0)|0;n=k|3;s=o+(Y(n,b)|0)|0;z=i+(k*24|0)|0;f[z>>2]=f[j>>2];f[z+4>>2]=f[j+4>>2];f[z+8>>2]=f[j+8>>2];f[z+12>>2]=f[j+12>>2];f[z+16>>2]=f[j+16>>2];f[z+20>>2]=f[j+20>>2];j=i+(r*24|0)|0;f[j>>2]=f[p>>2];f[j+4>>2]=f[p+4>>2];f[j+8>>2]=f[p+8>>2];f[j+12>>2]=f[p+12>>2];f[j+16>>2]=f[p+16>>2];f[j+20>>2]=f[p+20>>2];p=i+(l*24|0)|0;f[p>>2]=f[m>>2];f[p+4>>2]=f[m+4>>2];f[p+8>>2]=f[m+8>>2];f[p+12>>2]=f[m+12>>2];f[p+16>>2]=f[m+16>>2];f[p+20>>2]=f[m+20>>2];m=i+(n*24|0)|0;f[m>>2]=f[s>>2];f[m+4>>2]=f[s+4>>2];f[m+8>>2]=f[s+8>>2];f[m+12>>2]=f[s+12>>2];f[m+16>>2]=f[s+16>>2];f[m+20>>2]=f[s+20>>2];k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(D,d)|0)|0;k=a+(D*24|0)|0;i=0;do{o=k+(Y(i,b)|0)|0;s=i|1;m=k+(Y(s,b)|0)|0;n=i|2;p=k+(Y(n,b)|0)|0;l=i|3;j=k+(Y(l,b)|0)|0;r=q+(i*24|0)|0;f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];f[r+12>>2]=f[o+12>>2];f[r+16>>2]=f[o+16>>2];f[r+20>>2]=f[o+20>>2];o=q+(s*24|0)|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];f[o+8>>2]=f[m+8>>2];f[o+12>>2]=f[m+12>>2];f[o+16>>2]=f[m+16>>2];f[o+20>>2]=f[m+20>>2];m=q+(n*24|0)|0;f[m>>2]=f[p>>2];f[m+4>>2]=f[p+4>>2];f[m+8>>2]=f[p+8>>2];f[m+12>>2]=f[p+12>>2];f[m+16>>2]=f[p+16>>2];f[m+20>>2]=f[p+20>>2];p=q+(l*24|0)|0;f[p>>2]=f[j>>2];f[p+4>>2]=f[j+4>>2];f[p+8>>2]=f[j+8>>2];f[p+12>>2]=f[j+12>>2];f[p+16>>2]=f[j+16>>2];f[p+20>>2]=f[j+20>>2];i=i+4|0}while((i|0)<=(e|0));E=C;do{i=k+(Y(E,b)|0)|0;j=q+(E*24|0)|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];f[j+16>>2]=f[i+16>>2];f[j+20>>2]=f[i+20>>2];E=E+1|0}while((E|0)!=(h|0));D=D+1|0}while((D|0)!=(g|0));return}function zS(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k<<5)|0;q=0;do{r=p+(Y(q,b)|0)|0;s=l+(q<<5)|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];f[s+8>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];f[s+16>>2]=f[r+16>>2];f[s+20>>2]=f[r+20>>2];f[s+24>>2]=f[r+24>>2];f[s+28>>2]=f[r+28>>2];s=r+32|0;t=m+(q<<5)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];f[t+24>>2]=f[s+24>>2];f[t+28>>2]=f[s+28>>2];s=r+64|0;t=n+(q<<5)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];f[t+24>>2]=f[s+24>>2];f[t+28>>2]=f[s+28>>2];s=r+96|0;r=o+(q<<5)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2];f[r+16>>2]=f[s+16>>2];f[r+20>>2]=f[s+20>>2];f[r+24>>2]=f[s+24>>2];f[r+28>>2]=f[s+28>>2];q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;s=a+(o<<5)|0;r=0;do{t=s+(Y(r,b)|0)|0;u=r|1;v=s+(Y(u,b)|0)|0;w=r|2;x=s+(Y(w,b)|0)|0;y=r|3;z=s+(Y(y,b)|0)|0;A=n+(r<<5)|0;f[A>>2]=f[t>>2];f[A+4>>2]=f[t+4>>2];f[A+8>>2]=f[t+8>>2];f[A+12>>2]=f[t+12>>2];f[A+16>>2]=f[t+16>>2];f[A+20>>2]=f[t+20>>2];f[A+24>>2]=f[t+24>>2];f[A+28>>2]=f[t+28>>2];A=n+(u<<5)|0;f[A>>2]=f[v>>2];f[A+4>>2]=f[v+4>>2];f[A+8>>2]=f[v+8>>2];f[A+12>>2]=f[v+12>>2];f[A+16>>2]=f[v+16>>2];f[A+20>>2]=f[v+20>>2];f[A+24>>2]=f[v+24>>2];f[A+28>>2]=f[v+28>>2];A=n+(w<<5)|0;f[A>>2]=f[x>>2];f[A+4>>2]=f[x+4>>2];f[A+8>>2]=f[x+8>>2];f[A+12>>2]=f[x+12>>2];f[A+16>>2]=f[x+16>>2];f[A+20>>2]=f[x+20>>2];f[A+24>>2]=f[x+24>>2];f[A+28>>2]=f[x+28>>2];A=n+(y<<5)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];f[A+16>>2]=f[z+16>>2];f[A+20>>2]=f[z+20>>2];f[A+24>>2]=f[z+24>>2];f[A+28>>2]=f[z+28>>2];A=t+32|0;B=m+(r<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=v+32|0;B=m+(u<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=x+32|0;B=m+(w<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=z+32|0;B=m+(y<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=t+64|0;B=l+(r<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=v+64|0;B=l+(u<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=x+64|0;B=l+(w<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=z+64|0;B=l+(y<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=t+96|0;t=p+(r<<5)|0;f[t>>2]=f[A>>2];f[t+4>>2]=f[A+4>>2];f[t+8>>2]=f[A+8>>2];f[t+12>>2]=f[A+12>>2];f[t+16>>2]=f[A+16>>2];f[t+20>>2]=f[A+20>>2];f[t+24>>2]=f[A+24>>2];f[t+28>>2]=f[A+28>>2];A=v+96|0;v=p+(u<<5)|0;f[v>>2]=f[A>>2];f[v+4>>2]=f[A+4>>2];f[v+8>>2]=f[A+8>>2];f[v+12>>2]=f[A+12>>2];f[v+16>>2]=f[A+16>>2];f[v+20>>2]=f[A+20>>2];f[v+24>>2]=f[A+24>>2];f[v+28>>2]=f[A+28>>2];A=x+96|0;x=p+(w<<5)|0;f[x>>2]=f[A>>2];f[x+4>>2]=f[A+4>>2];f[x+8>>2]=f[A+8>>2];f[x+12>>2]=f[A+12>>2];f[x+16>>2]=f[A+16>>2];f[x+20>>2]=f[A+20>>2];f[x+24>>2]=f[A+24>>2];f[x+28>>2]=f[A+28>>2];A=z+96|0;z=p+(y<<5)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];f[z+16>>2]=f[A+16>>2];f[z+20>>2]=f[A+20>>2];f[z+24>>2]=f[A+24>>2];f[z+28>>2]=f[A+28>>2];r=r+4|0}while((r|0)<=(j|0));if(q){r=k;do{A=s+(Y(r,b)|0)|0;z=n+(r<<5)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];f[z+16>>2]=f[A+16>>2];f[z+20>>2]=f[A+20>>2];f[z+24>>2]=f[A+24>>2];f[z+28>>2]=f[A+28>>2];z=A+32|0;y=m+(r<<5)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];f[y+16>>2]=f[z+16>>2];f[y+20>>2]=f[z+20>>2];f[y+24>>2]=f[z+24>>2];f[y+28>>2]=f[z+28>>2];z=A+64|0;y=l+(r<<5)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];f[y+16>>2]=f[z+16>>2];f[y+20>>2]=f[z+20>>2];f[y+24>>2]=f[z+24>>2];f[y+28>>2]=f[z+28>>2];z=A+96|0;A=p+(r<<5)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];f[A+16>>2]=f[z+16>>2];f[A+20>>2]=f[z+20>>2];f[A+24>>2]=f[z+24>>2];f[A+28>>2]=f[z+28>>2];r=r+1|0}while((r|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)C=i;else return;do{o=c+(Y(C,d)|0)|0;k=a+(C<<5)|0;q=0;do{j=k+(Y(q,b)|0)|0;r=o+(q<<5)|0;f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[r+8>>2]=f[j+8>>2];f[r+12>>2]=f[j+12>>2];f[r+16>>2]=f[j+16>>2];f[r+20>>2]=f[j+20>>2];f[r+24>>2]=f[j+24>>2];f[r+28>>2]=f[j+28>>2];q=q+1|0}while((q|0)!=(h|0));C=C+1|0}while((C|0)!=(g|0));return}C=h&-4;if((C|0)<(h|0))D=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q<<5)|0;k=0;do{j=o+(Y(k,b)|0)|0;r=k|1;p=o+(Y(r,b)|0)|0;l=k|2;m=o+(Y(l,b)|0)|0;n=k|3;s=o+(Y(n,b)|0)|0;z=i+(k<<5)|0;f[z>>2]=f[j>>2];f[z+4>>2]=f[j+4>>2];f[z+8>>2]=f[j+8>>2];f[z+12>>2]=f[j+12>>2];f[z+16>>2]=f[j+16>>2];f[z+20>>2]=f[j+20>>2];f[z+24>>2]=f[j+24>>2];f[z+28>>2]=f[j+28>>2];j=i+(r<<5)|0;f[j>>2]=f[p>>2];f[j+4>>2]=f[p+4>>2];f[j+8>>2]=f[p+8>>2];f[j+12>>2]=f[p+12>>2];f[j+16>>2]=f[p+16>>2];f[j+20>>2]=f[p+20>>2];f[j+24>>2]=f[p+24>>2];f[j+28>>2]=f[p+28>>2];p=i+(l<<5)|0;f[p>>2]=f[m>>2];f[p+4>>2]=f[m+4>>2];f[p+8>>2]=f[m+8>>2];f[p+12>>2]=f[m+12>>2];f[p+16>>2]=f[m+16>>2];f[p+20>>2]=f[m+20>>2];f[p+24>>2]=f[m+24>>2];f[p+28>>2]=f[m+28>>2];m=i+(n<<5)|0;f[m>>2]=f[s>>2];f[m+4>>2]=f[s+4>>2];f[m+8>>2]=f[s+8>>2];f[m+12>>2]=f[s+12>>2];f[m+16>>2]=f[s+16>>2];f[m+20>>2]=f[s+20>>2];f[m+24>>2]=f[s+24>>2];f[m+28>>2]=f[s+28>>2];k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(D,d)|0)|0;k=a+(D<<5)|0;i=0;do{o=k+(Y(i,b)|0)|0;s=i|1;m=k+(Y(s,b)|0)|0;n=i|2;p=k+(Y(n,b)|0)|0;l=i|3;j=k+(Y(l,b)|0)|0;r=q+(i<<5)|0;f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];f[r+12>>2]=f[o+12>>2];f[r+16>>2]=f[o+16>>2];f[r+20>>2]=f[o+20>>2];f[r+24>>2]=f[o+24>>2];f[r+28>>2]=f[o+28>>2];o=q+(s<<5)|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];f[o+8>>2]=f[m+8>>2];f[o+12>>2]=f[m+12>>2];f[o+16>>2]=f[m+16>>2];f[o+20>>2]=f[m+20>>2];f[o+24>>2]=f[m+24>>2];f[o+28>>2]=f[m+28>>2];m=q+(n<<5)|0;f[m>>2]=f[p>>2];f[m+4>>2]=f[p+4>>2];f[m+8>>2]=f[p+8>>2];f[m+12>>2]=f[p+12>>2];f[m+16>>2]=f[p+16>>2];f[m+20>>2]=f[p+20>>2];f[m+24>>2]=f[p+24>>2];f[m+28>>2]=f[p+28>>2];p=q+(l<<5)|0;f[p>>2]=f[j>>2];f[p+4>>2]=f[j+4>>2];f[p+8>>2]=f[j+8>>2];f[p+12>>2]=f[j+12>>2];f[p+16>>2]=f[j+16>>2];f[p+20>>2]=f[j+20>>2];f[p+24>>2]=f[j+24>>2];f[p+28>>2]=f[j+28>>2];i=i+4|0}while((i|0)<=(e|0));E=C;do{i=k+(Y(E,b)|0)|0;j=q+(E<<5)|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];f[j+16>>2]=f[i+16>>2];f[j+20>>2]=f[i+20>>2];f[j+24>>2]=f[i+24>>2];f[j+28>>2]=f[i+28>>2];E=E+1|0}while((E|0)!=(h|0));D=D+1|0}while((D|0)!=(g|0));return}function AS(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;if((d|0)>0)e=0;else return;do{f=a+(Y(e,c)|0)|0;g=a+e|0;e=e+1|0;if((e|0)<(d|0)){h=e;do{i=f+h|0;j=g+(Y(h,c)|0)|0;k=b[i>>0]|0;b[i>>0]=b[j>>0]|0;b[j>>0]=k;h=h+1|0}while((h|0)!=(d|0))}}while((e|0)!=(d|0));return}function BS(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;if((c|0)>0)e=0;else return;do{f=a+(Y(e,b)|0)|0;g=a+(e<<1)|0;e=e+1|0;if((e|0)<(c|0)){h=e;do{i=f+(h<<1)|0;j=g+(Y(h,b)|0)|0;k=d[i>>1]|0;d[i>>1]=d[j>>1]|0;d[j>>1]=k;h=h+1|0}while((h|0)!=(c|0))}}while((e|0)!=(c|0));return}function CS(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if((d|0)>0)e=0;else return;do{f=a+(Y(e,c)|0)|0;g=a+(e*3|0)|0;e=e+1|0;if((e|0)<(d|0)){h=e;do{i=g+(Y(h,c)|0)|0;j=f+(h*3|0)|0;k=b[j>>0]|0;l=b[f+(h*3|0)+1>>0]|0;m=b[f+(h*3|0)+2>>0]|0;b[j>>0]=b[i>>0]|0;b[j+1>>0]=b[i+1>>0]|0;b[j+2>>0]=b[i+2>>0]|0;b[i>>0]=k;b[i+1>>0]=l;b[i+2>>0]=m;h=h+1|0}while((h|0)!=(d|0))}}while((e|0)!=(d|0));return}function DS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d<<2)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h<<2)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;f[i>>2]=f[j>>2];f[j>>2]=k;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function ES(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if((c|0)>0)e=0;else return;do{f=a+(Y(e,b)|0)|0;g=a+(e*6|0)|0;e=e+1|0;if((e|0)<(c|0)){h=e;do{i=f+(h*6|0)|0;j=g+(Y(h,b)|0)|0;k=d[i>>1]|0;l=d[f+(h*6|0)+2>>1]|0;m=d[f+(h*6|0)+4>>1]|0;d[i>>1]=d[j>>1]|0;d[i+2>>1]=d[j+2>>1]|0;d[i+4>>1]=d[j+4>>1]|0;d[j>>1]=k;d[j+2>>1]=l;d[j+4>>1]=m;h=h+1|0}while((h|0)!=(c|0))}}while((e|0)!=(c|0));return}function FS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d<<3)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h<<3)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;l=f[e+(h<<3)+4>>2]|0;m=j;n=f[m+4>>2]|0;o=i;f[o>>2]=f[m>>2];f[o+4>>2]=n;n=j;f[n>>2]=k;f[n+4>>2]=l;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function GS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d*12|0)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h*12|0)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;l=f[e+(h*12|0)+4>>2]|0;m=f[e+(h*12|0)+8>>2]|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];f[j>>2]=k;f[j+4>>2]=l;f[j+8>>2]=m;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function HS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d<<4)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h<<4)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;l=f[e+(h<<4)+4>>2]|0;m=f[e+(h<<4)+8>>2]|0;n=f[e+(h<<4)+12>>2]|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];f[i+12>>2]=f[j+12>>2];f[j>>2]=k;f[j+4>>2]=l;f[j+8>>2]=m;f[j+12>>2]=n;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function IS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d*24|0)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h*24|0)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;l=f[e+(h*24|0)+4>>2]|0;m=f[e+(h*24|0)+8>>2]|0;n=f[e+(h*24|0)+12>>2]|0;o=f[e+(h*24|0)+16>>2]|0;p=f[e+(h*24|0)+20>>2]|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];f[i+12>>2]=f[j+12>>2];f[i+16>>2]=f[j+16>>2];f[i+20>>2]=f[j+20>>2];f[j>>2]=k;f[j+4>>2]=l;f[j+8>>2]=m;f[j+12>>2]=n;f[j+16>>2]=o;f[j+20>>2]=p;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function JS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d<<5)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h<<5)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;l=f[e+(h<<5)+4>>2]|0;m=f[e+(h<<5)+8>>2]|0;n=f[e+(h<<5)+12>>2]|0;o=f[e+(h<<5)+16>>2]|0;p=f[e+(h<<5)+20>>2]|0;q=f[e+(h<<5)+24>>2]|0;r=f[e+(h<<5)+28>>2]|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];f[i+12>>2]=f[j+12>>2];f[i+16>>2]=f[j+16>>2];f[i+20>>2]=f[j+20>>2];f[i+24>>2]=f[j+24>>2];f[i+28>>2]=f[j+28>>2];f[j>>2]=k;f[j+4>>2]=l;f[j+8>>2]=m;f[j+12>>2]=n;f[j+16>>2]=o;f[j+20>>2]=p;f[j+24>>2]=q;f[j+28>>2]=r;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function KS(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;i=u;u=u+16|0;j=i;k=f[a>>2]|0;l=k&2031616;m=(e|0)<0;do if(m&(l|0)==65536){if((h|0)==0&(g^1)){if((k&1073741824|0)!=0?(n=f[(f[a+4>>2]|0)+40>>2]|0,!((f[c>>2]|0)==(f[n+4>>2]|0)?(f[c+4>>2]|0)==(f[n>>2]|0):0)):0){f[j>>2]=0;f[j+4>>2]=0;o=c$(j,53)|0;p=175552;q=o+53|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-215,j,357830,172446,2385);d$(j);r=f[a>>2]|0}else r=k;n=a+4|0;if((r|0)<0?(f[f[n>>2]>>2]&4095|0)!=(d|0):0){f[j>>2]=0;f[j+4>>2]=0;o=c$(j,44)|0;p=175007;q=o+44|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-215,j,357830,172446,2386);d$(j)}s=f[n>>2]|0;t=f[c>>2]|0;v=f[c+4>>2]|0;w=d&4095;if(((((f[s+4>>2]|0)<3?(f[s+8>>2]|0)==(v|0):0)?(f[s+12>>2]|0)==(t|0):0)?(f[s>>2]&4095|0)==(w|0):0)?f[s+16>>2]|0:0){u=i;return}f[j>>2]=v;f[j+4>>2]=t;AR(s,2,j,w);u=i;return}}else{if(m&(l|0)==655360){if(!((h|0)==0&(g^1)))break;if((k&1073741824|0)!=0?(w=f[(f[a+4>>2]|0)+32>>2]|0,!((f[c>>2]|0)==(f[w+4>>2]|0)?(f[c+4>>2]|0)==(f[w>>2]|0):0)):0){f[j>>2]=0;f[j+4>>2]=0;o=c$(j,54)|0;p=175606;q=o+54|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-215,j,357830,172446,2392);d$(j);x=f[a>>2]|0}else x=k;n=a+4|0;if((x|0)<0?(f[f[n>>2]>>2]&4095|0)!=(d|0):0){f[j>>2]=0;f[j+4>>2]=0;o=c$(j,45)|0;p=175122;q=o+45|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-215,j,357830,172446,2393);d$(j)}w=f[n>>2]|0;s=f[c>>2]|0;t=f[c+4>>2]|0;v=d&4095;if(((((f[w+4>>2]|0)<3?(f[w+8>>2]|0)==(t|0):0)?(f[w+12>>2]|0)==(s|0):0)?(f[w>>2]&4095|0)==(v|0):0)?f[w+24>>2]|0:0){u=i;return}f[j>>2]=t;f[j+4>>2]=s;h0(w,2,j,v,0);u=i;return}if(m&(l|0)==589824){if(!((h|0)==0&(g^1)))break;if((k&1073741824|0)!=0?(v=f[a+4>>2]|0,!((f[c>>2]|0)==(f[v+8>>2]|0)?(f[c+4>>2]|0)==(f[v+4>>2]|0):0)):0){f[j>>2]=0;f[j+4>>2]=0;o=c$(j,51)|0;p=175661;q=o+51|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-215,j,357830,172446,2399);d$(j);y=f[a>>2]|0}else y=k;n=a+4|0;if((y|0)<0?(f[f[n>>2]>>2]&4095|0)!=(d|0):0){f[j>>2]=0;f[j+4>>2]=0;o=c$(j,53)|0;p=175235;q=o+53|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-215,j,357830,172446,2400);d$(j)}b1(f[n>>2]|0,f[c+4>>2]|0,f[c>>2]|0,d);u=i;return}if(m&(l|0)==458752){if(!((h|0)==0&(g^1)))break;if((k&1073741824|0)!=0?(v=f[a+4>>2]|0,!((f[c>>2]|0)==(f[v+12>>2]|0)?(f[c+4>>2]|0)==(f[v+8>>2]|0):0)):0){f[j>>2]=0;f[j+4>>2]=0;o=c$(j,50)|0;p=175713;q=o+50|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-215,j,357830,172446,2406);d$(j);z=f[a>>2]|0}else z=k;n=a+4|0;if((z|0)<0?(f[(f[n>>2]|0)+16>>2]|0)!=(d|0):0){f[j>>2]=0;f[j+4>>2]=0;o=c$(j,52)|0;p=175355;q=o+52|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-215,j,357830,172446,2407);d$(j)}XU(f[n>>2]|0,f[c+4>>2]|0,f[c>>2]|0,d,34962,0);u=i;return}if(m&(l|0)==524288?(h|0)==0&(g^1):0){if((k&1073741824|0)!=0?(v=f[a+4>>2]|0,!((f[c>>2]|0)==(f[v+8>>2]|0)?(f[c+4>>2]|0)==(f[v+4>>2]|0):0)):0){f[j>>2]=0;f[j+4>>2]=0;o=c$(j,52)|0;p=175764;q=o+52|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-215,j,357830,172446,2413);d$(j);A=f[a>>2]|0}else A=k;n=a+4|0;if((A|0)<0?(f[f[n>>2]>>2]&4095|0)!=(d|0):0){f[j>>2]=0;f[j+4>>2]=0;o=c$(j,54)|0;p=175476;q=o+54|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-215,j,357830,172446,2414);d$(j)}e1(f[n>>2]|0,f[c+4>>2]|0,f[c>>2]|0,d);u=i;return}}while(0);f[j>>2]=f[c+4>>2];f[j+4>>2]=f[c>>2];MR(a,2,j,d,e,g,h);u=i;return}function LS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;if(!(f[a+16>>2]|0)){e=-1;return e|0}g=f[a>>2]|0;if(!((c|0)<1|(g&7|0)==(c|0))){e=-1;return e|0}c=g&16384;if(!((c|0)!=0|d^1)){e=-1;return e|0}d=f[a+4>>2]|0;switch(d|0){case 2:{if((f[a+8>>2]|0)!=1?(h=f[a+12>>2]|0,(h|0)!=1):0){i=h;j=9}else j=7;if((j|0)==7?((g>>>3&511)+1|0)!=(b|0):0){i=f[a+12>>2]|0;j=9}if((j|0)==9?!((i|0)==(b|0)&(g&4088|0)==0):0){e=-1;return e|0}k=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;break}case 3:{if(g&4088|0){e=-1;return e|0}i=f[a+40>>2]|0;if((f[i+8>>2]|0)!=(b|0)){e=-1;return e|0}if((f[i>>2]|0)!=1?(f[i+4>>2]|0)!=1:0){e=-1;return e|0}if((c|0)==0?(c=f[a+44>>2]|0,(f[c+4>>2]|0)!=(Y(f[c+8>>2]|0,b)|0)):0){e=-1;return e|0}c=f[a+40>>2]|0;a=0;i=1;while(1){j=Y(f[c+(a<<2)>>2]|0,i)|0;a=a+1|0;if((a|0)==(d|0)){k=j;break}else i=j}break}default:{e=-1;return e|0}}e=((Y((g>>>3&511)+1|0,k)|0)>>>0)/(b>>>0)|0;return e|0}function MS(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+8|0;j=h;_$(i,42160);k=(e>>>3&511)+1|0;if(k>>>0>=5){f[j>>2]=0;f[j+4>>2]=0;l=c$(j,7)|0;b[l>>0]=b[175866]|0;b[l+1>>0]=b[175867]|0;b[l+2>>0]=b[175868]|0;b[l+3>>0]=b[175869]|0;b[l+4>>0]=b[175870]|0;b[l+5>>0]=b[175871]|0;b[l+6>>0]=b[175872]|0;j$(-215,j,175874,172446,1168);d$(j)}switch(e&7){case 0:{e=0;do{l=rNa(+p[a+(e<<3)>>3])|0;b[c+e>>0]=l>>>0<256?l:(l|0)>0?255:0;e=e+1|0}while((e|0)!=(k|0));if((k|0)<(g|0)){e=k;do{b[c+e>>0]=b[c+(e-k)>>0]|0;e=e+1|0}while((e|0)!=(g|0))}break}case 1:{e=0;do{l=rNa(+p[a+(e<<3)>>3])|0;b[c+e>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;e=e+1|0}while((e|0)!=(k|0));if((k|0)<(g|0)){e=k;do{b[c+e>>0]=b[c+(e-k)>>0]|0;e=e+1|0}while((e|0)!=(g|0))}break}case 2:{e=0;do{l=rNa(+p[a+(e<<3)>>3])|0;d[c+(e<<1)>>1]=l>>>0<65536?l:(l|0)>0?65535:0;e=e+1|0}while((e|0)!=(k|0));if((k|0)<(g|0)){e=k;do{d[c+(e<<1)>>1]=d[c+(e-k<<1)>>1]|0;e=e+1|0}while((e|0)!=(g|0))}break}case 3:{e=0;do{l=rNa(+p[a+(e<<3)>>3])|0;d[c+(e<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;e=e+1|0}while((e|0)!=(k|0));if((k|0)<(g|0)){e=k;do{d[c+(e<<1)>>1]=d[c+(e-k<<1)>>1]|0;e=e+1|0}while((e|0)!=(g|0))}break}case 4:{e=0;do{l=rNa(+p[a+(e<<3)>>3])|0;f[c+(e<<2)>>2]=l;e=e+1|0}while((e|0)!=(k|0));if((k|0)<(g|0)){e=k;do{f[c+(e<<2)>>2]=f[c+(e-k<<2)>>2];e=e+1|0}while((e|0)!=(g|0))}break}case 5:{e=0;do{n[c+(e<<2)>>2]=+p[a+(e<<3)>>3];e=e+1|0}while((e|0)!=(k|0));if((k|0)<(g|0)){e=k;do{f[c+(e<<2)>>2]=f[c+(e-k<<2)>>2];e=e+1|0}while((e|0)!=(g|0))}break}case 6:{e=0;do{p[c+(e<<3)>>3]=+p[a+(e<<3)>>3];e=e+1|0}while((e|0)!=(k|0));if((k|0)<(g|0)){e=k;do{p[c+(e<<3)>>3]=+p[c+(e-k<<3)>>3];e=e+1|0}while((e|0)!=(g|0))}break}default:{f[j>>2]=0;f[j+4>>2]=0;j$(-210,j,175874,172446,1193);d$(j)}}if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function NS(a){a=a|0;return f[a>>2]&2031616|0}function OS(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+128|0;g=e+120|0;h=e+112|0;i=e+56|0;j=e;k=f[c>>2]|0;l=k&50331648;m=k&2031616;a:do if((m|0)>=655360){if((m|0)<720896){switch(m|0){case 655360:break;default:break a}k=f[c+4>>2]|0;if((d|0)>=0){f[g>>2]=d;f[g+4>>2]=d+1;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;l0(a,k,g,h);u=e;return}f[a>>2]=f[k>>2];n=a+4|0;o=k+4|0;f[n>>2]=f[o>>2];p=a+8|0;f[p>>2]=f[k+8>>2];f[a+12>>2]=f[k+12>>2];f[a+16>>2]=f[k+16>>2];f[a+20>>2]=f[k+20>>2];q=f[k+24>>2]|0;f[a+24>>2]=q;f[a+28>>2]=f[k+28>>2];f[a+32>>2]=p;p=a+40|0;r=a+36|0;f[r>>2]=p;f[a+44>>2]=0;f[p>>2]=0;if(q|0){p=q+8|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[k+36>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];u=e;return}else{f[n>>2]=0;i0(a,k);u=e;return}}switch(m|0){case 720896:break;default:break a}k=f[c+4>>2]|0;if((d|0)>-1?(n=f[k>>2]|0,(((f[k+4>>2]|0)-n|0)/48|0|0)>(d|0)):0)s=n;else{f[g>>2]=0;f[g+4>>2]=0;n=c$(g,27)|0;o=173362;p=n+27|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-215,g,200448,172446,1339);d$(g);s=f[k>>2]|0}o=s+(d*48|0)|0;f[a>>2]=f[o>>2];n=a+4|0;p=s+(d*48|0)+4|0;f[n>>2]=f[p>>2];r=a+8|0;f[r>>2]=f[s+(d*48|0)+8>>2];f[a+12>>2]=f[s+(d*48|0)+12>>2];f[a+16>>2]=f[s+(d*48|0)+16>>2];f[a+20>>2]=f[s+(d*48|0)+20>>2];q=f[s+(d*48|0)+24>>2]|0;f[a+24>>2]=q;f[a+28>>2]=f[s+(d*48|0)+28>>2];f[a+32>>2]=r;r=a+40|0;t=a+36|0;f[t>>2]=r;f[a+44>>2]=0;f[r>>2]=0;if(q|0){r=q+8|0;f[r>>2]=(f[r>>2]|0)+1}if((f[p>>2]|0)<3){p=f[s+(d*48|0)+36>>2]|0;r=f[t>>2]|0;f[r>>2]=f[p>>2];f[r+4>>2]=f[p+4>>2];u=e;return}else{f[n>>2]=0;i0(a,o);u=e;return}}else{switch(m|0){case 65536:break;default:break a}o=f[c+4>>2]|0;if((d|0)<0){f0(a,o,l,0);u=e;return}f[g>>2]=d;f[g+4>>2]=d+1;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;DR(i,o,g,h);f0(a,i,l,0);o=i+36|0;n=f[o>>2]|0;if((n|0?(p=n+12|0,n=f[p>>2]|0,f[p>>2]=n+-1,(n|0)==1):0)?(n=f[o>>2]|0,n|0):0){f[o>>2]=0;p=f[n+4>>2]|0;if(!p){r=f[i+32>>2]|0;if(!r)v=sR()|0;else v=r}else v=p;Gh[f[(f[v>>2]|0)+24>>2]&511](v,n)}f[o>>2]=0;o=i+16|0;n=i+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[n>>2]|0)>0){o=f[i+40>>2]|0;p=0;do{f[o+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[n>>2]|0))}n=f[i+44>>2]|0;if((n|0)==(i+48|0)){u=e;return}ZF(n);u=e;return}while(0);NR(j,c,d);f0(a,j,l,0);l=j+36|0;a=f[l>>2]|0;if((a|0?(d=a+12|0,a=f[d>>2]|0,f[d>>2]=a+-1,(a|0)==1):0)?(a=f[l>>2]|0,a|0):0){f[l>>2]=0;d=f[a+4>>2]|0;if(!d){c=f[j+32>>2]|0;if(!c)w=sR()|0;else w=c}else w=d;Gh[f[(f[w>>2]|0)+24>>2]&511](w,a)}f[l>>2]=0;l=j+16|0;a=j+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[a>>2]|0)>0){l=f[j+40>>2]|0;w=0;do{f[l+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[a>>2]|0))}a=f[j+44>>2]|0;if((a|0)==(j+48|0)){u=e;return}ZF(a);u=e;return}function PS(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;d=u;u=u+240|0;e=d+184|0;g=d+128|0;h=d+64|0;i=d;j=d+120|0;k=d+56|0;l=f[a>>2]|0;m=l&50331648;do switch(l>>>16&31){case 1:{n=f[a+4>>2]|0;o=n+40|0;p=f[f[o>>2]>>2]|0;gS(c,p);if((p|0)<=0){u=d;return}q=n+4|0;r=n+12|0;s=n+16|0;t=n+44|0;v=e+36|0;w=e+16|0;x=e+4|0;y=e+40|0;z=e+44|0;A=e+48|0;B=e+32|0;C=e+8|0;D=e+20|0;E=e+52|0;F=0;do{G=f[q>>2]|0;if((G|0)==2)$i(e,1,f[r>>2]|0,f[n>>2]&4095,(f[s>>2]|0)+(Y(f[f[t>>2]>>2]|0,F)|0)|0,0);else{H=G+-1|0;G=(f[o>>2]|0)+4|0;I=f[n>>2]&4095;J=f[t>>2]|0;K=(f[s>>2]|0)+(Y(f[J>>2]|0,F)|0)|0;L=J+4|0;M=x;N=M+36|0;do{f[M>>2]=0;M=M+4|0}while((M|0)<(N|0));f[y>>2]=C;f[z>>2]=A;f[E>>2]=0;f[A>>2]=0;f[e>>2]=I|1124007936;f[w>>2]=K;f[D>>2]=K;pR(e,H,G,L,1);qR(e)}yR((f[c>>2]|0)+(F*56|0)|0,e)|0;J=f[v>>2]|0;if((J|0?(O=J+12|0,J=f[O>>2]|0,f[O>>2]=J+-1,(J|0)==1):0)?(J=f[v>>2]|0,J|0):0){f[v>>2]=0;O=f[J+4>>2]|0;if(!O){P=f[B>>2]|0;if(!P)Q=sR()|0;else Q=P}else Q=O;Gh[f[(f[Q>>2]|0)+24>>2]&511](Q,J)}f[v>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[x>>2]|0)>0){J=f[y>>2]|0;O=0;do{f[J+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[x>>2]|0))}O=f[z>>2]|0;if((O|0)!=(A|0))ZF(O);F=F+1|0}while((F|0)<(p|0));u=d;return}case 6:{PR(h,f[a+4>>2]|0);p=h+40|0;F=f[f[p>>2]>>2]|0;gS(c,F);if((F|0)>0){A=e+4|0;z=g+4|0;x=i+36|0;y=i+16|0;w=i+4|0;v=i+40|0;B=i+44|0;D=i+48|0;E=i+32|0;C=0;do{s=C;C=C+1|0;f[e>>2]=s;f[A>>2]=C;f[g>>2]=-2147483648;f[z>>2]=2147483647;DR(i,h,e,g);yR((f[c>>2]|0)+(s*56|0)|0,i)|0;s=f[x>>2]|0;if((s|0?(t=s+12|0,s=f[t>>2]|0,f[t>>2]=s+-1,(s|0)==1):0)?(s=f[x>>2]|0,s|0):0){f[x>>2]=0;t=f[s+4>>2]|0;if(!t){n=f[E>>2]|0;if(!n)R=sR()|0;else R=n}else R=t;Gh[f[(f[R>>2]|0)+24>>2]&511](R,s)}f[x>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[w>>2]|0)>0){s=f[v>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[w>>2]|0))}t=f[B>>2]|0;if((t|0)!=(D|0))ZF(t)}while((C|0)<(F|0))}F=h+36|0;C=f[F>>2]|0;if((C|0?(D=C+12|0,C=f[D>>2]|0,f[D>>2]=C+-1,(C|0)==1):0)?(C=f[F>>2]|0,C|0):0){f[F>>2]=0;D=f[C+4>>2]|0;if(!D){B=f[h+32>>2]|0;if(!B)S=sR()|0;else S=B}else S=D;Gh[f[(f[S>>2]|0)+24>>2]&511](S,C)}f[F>>2]=0;F=h+16|0;C=h+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[C>>2]|0)>0){F=f[p>>2]|0;D=0;do{f[F+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[C>>2]|0))}C=f[h+44>>2]|0;if((C|0)!=(h+48|0))ZF(C);u=d;return}case 2:case 14:{C=f[a+12>>2]|0;D=(l>>>3&511)+1<<(47696>>>(l<<1&14)&3);gS(c,C);if(!C){u=d;return}F=a+8|0;p=a+4|0;B=e+36|0;w=e+16|0;v=e+4|0;y=e+40|0;x=e+44|0;E=e+48|0;z=e+32|0;A=0;do{t=f[F>>2]|0;$i(e,1,t,f[a>>2]&4095,(f[p>>2]|0)+(Y(Y(A,D)|0,t)|0)|0,0);yR((f[c>>2]|0)+(A*56|0)|0,e)|0;t=f[B>>2]|0;if((t|0?(s=t+12|0,t=f[s>>2]|0,f[s>>2]=t+-1,(t|0)==1):0)?(t=f[B>>2]|0,t|0):0){f[B>>2]=0;s=f[t+4>>2]|0;if(!s){n=f[z>>2]|0;if(!n)T=sR()|0;else T=n}else T=s;Gh[f[(f[T>>2]|0)+24>>2]&511](T,t)}f[B>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[v>>2]|0)>0){t=f[y>>2]|0;s=0;do{f[t+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[v>>2]|0))}s=f[x>>2]|0;if((s|0)!=(E|0))ZF(s);A=A+1|0}while(A>>>0<C>>>0);u=d;return}case 3:{C=f[a+4>>2]|0;QR(j,a,-1);A=f[j>>2]|0;E=f[a>>2]|0;x=(E>>>3&511)+1|0;v=E&7;E=x<<(47696>>>(v<<1)&3);gS(c,A);if(!A){u=d;return}y=e+36|0;w=e+16|0;B=e+4|0;z=e+40|0;D=e+44|0;p=e+48|0;F=e+32|0;s=0;do{$i(e,1,x,v,(f[C>>2]|0)+(Y(s,E)|0)|0,0);yR((f[c>>2]|0)+(s*56|0)|0,e)|0;t=f[y>>2]|0;if((t|0?(n=t+12|0,t=f[n>>2]|0,f[n>>2]=t+-1,(t|0)==1):0)?(t=f[y>>2]|0,t|0):0){f[y>>2]=0;n=f[t+4>>2]|0;if(!n){o=f[F>>2]|0;if(!o)U=sR()|0;else U=o}else U=n;Gh[f[(f[U>>2]|0)+24>>2]&511](U,t)}f[y>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[B>>2]|0)>0){t=f[z>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[B>>2]|0))}n=f[D>>2]|0;if((n|0)!=(p|0))ZF(n);s=s+1|0}while(s>>>0<A>>>0);u=d;return}case 0:{A=f[c>>2]|0;s=c+4|0;p=f[s>>2]|0;if((p|0)==(A|0)){u=d;return}else V=p;do{f[s>>2]=V+-56;p=V+-20|0;D=f[p>>2]|0;if((D|0?(B=D+12|0,D=f[B>>2]|0,f[B>>2]=D+-1,(D|0)==1):0)?(D=f[p>>2]|0,D|0):0){f[p>>2]=0;B=f[D+4>>2]|0;if(!B){z=f[V+-24>>2]|0;if(!z)W=sR()|0;else W=z}else W=B;Gh[f[(f[W>>2]|0)+24>>2]&511](W,D)}f[p>>2]=0;p=V+-40|0;D=V+-52|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[D>>2]|0)>0){p=f[V+-16>>2]|0;B=0;do{f[p+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[D>>2]|0))}D=f[V+-12>>2]|0;if((D|0)!=(V+-8|0))ZF(D);V=f[s>>2]|0}while((V|0)!=(A|0));u=d;return}case 4:{A=f[a+4>>2]|0;s=(f[A+4>>2]|0)-(f[A>>2]|0)|0;D=(s|0)/12|0;gS(c,D);if((s|0)<=0){u=d;return}s=l&4095|1124007936;B=g+4|0;p=g+8|0;z=k+4|0;w=g+12|0;y=g+16|0;F=g+20|0;E=g+24|0;C=g+28|0;v=g+40|0;x=g+48|0;n=g+44|0;t=g+52|0;o=e+4|0;r=(l>>>3&511)+1<<(47696>>>(l<<1&14)&3);q=g+36|0;O=g+32|0;J=0;do{L=f[A>>2]|0;QR(k,a,J);G=f[L+(J*12|0)>>2]|0;f[g>>2]=s;f[B>>2]=2;L=f[z>>2]|0;f[p>>2]=L;H=f[k>>2]|0;f[w>>2]=H;f[y>>2]=G;f[F>>2]=G;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;f[v>>2]=p;f[n>>2]=x;f[t>>2]=0;f[x>>2]=0;if((G|0)==0&(Y(H,L)|0)!=0){f[e>>2]=0;f[o>>2]=0;M=c$(e,26)|0;X=358223;N=M+26|0;do{b[M>>0]=b[X>>0]|0;M=M+1|0;X=X+1|0}while((M|0)<(N|0));j$(-215,e,358250,358254,533);d$(e);Z=f[w>>2]|0;_=f[g>>2]|0;$=f[n>>2]|0;aa=f[F>>2]|0}else{Z=H;_=s;$=x;aa=G}L=Y(Z,r)|0;f[g>>2]=_|16384;f[$>>2]=L;f[$+4>>2]=r;K=aa+(Y(f[p>>2]|0,L)|0)|0;f[C>>2]=K;f[E>>2]=K+(0-L)+L;yR((f[c>>2]|0)+(J*56|0)|0,g)|0;L=f[q>>2]|0;if((L|0?(K=L+12|0,L=f[K>>2]|0,f[K>>2]=L+-1,(L|0)==1):0)?(L=f[q>>2]|0,L|0):0){f[q>>2]=0;K=f[L+4>>2]|0;if(!K){I=f[O>>2]|0;if(!I)ba=sR()|0;else ba=I}else ba=K;Gh[f[(f[ba>>2]|0)+24>>2]&511](ba,L)}f[q>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[B>>2]|0)>0){L=f[v>>2]|0;K=0;do{f[L+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[B>>2]|0))}K=f[n>>2]|0;if((K|0)!=(x|0))ZF(K);J=J+1|0}while((J|0)<(D|0));u=d;return}case 5:{D=f[a+4>>2]|0;J=(f[D+4>>2]|0)-(f[D>>2]|0)|0;x=(J|0)/56|0;gS(c,x);if(!J){u=d;return}J=0;do{yR((f[c>>2]|0)+(J*56|0)|0,(f[D>>2]|0)+(J*56|0)|0)|0;J=J+1|0}while(J>>>0<x>>>0);u=d;return}case 15:{x=f[a+4>>2]|0;J=f[a+12>>2]|0;gS(c,J);if(!J){u=d;return}D=0;do{yR((f[c>>2]|0)+(D*56|0)|0,x+(D*56|0)|0)|0;D=D+1|0}while((D|0)!=(J|0));u=d;return}case 11:{J=f[a+4>>2]|0;D=(f[J+4>>2]|0)-(f[J>>2]|0)|0;x=(D|0)/48|0;gS(c,x);if(!D){u=d;return}D=e+36|0;n=e+16|0;B=e+4|0;v=e+40|0;y=e+44|0;q=e+48|0;O=e+32|0;E=0;do{r0(e,(f[J>>2]|0)+(E*48|0)|0,m);yR((f[c>>2]|0)+(E*56|0)|0,e)|0;C=f[D>>2]|0;if((C|0?(p=C+12|0,C=f[p>>2]|0,f[p>>2]=C+-1,(C|0)==1):0)?(C=f[D>>2]|0,C|0):0){f[D>>2]=0;p=f[C+4>>2]|0;if(!p){r=f[O>>2]|0;if(!r)ca=sR()|0;else ca=r}else ca=p;Gh[f[(f[ca>>2]|0)+24>>2]&511](ca,C)}f[D>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[B>>2]|0)>0){C=f[v>>2]|0;p=0;do{f[C+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[B>>2]|0))}p=f[y>>2]|0;if((p|0)!=(q|0))ZF(p);E=E+1|0}while(E>>>0<x>>>0);u=d;return}default:{f[e>>2]=0;f[e+4>>2]=0;M=c$(e,30)|0;X=173557;N=M+30|0;do{b[M>>0]=b[X>>0]|0;M=M+1|0;X=X+1|0}while((M|0)<(N|0));j$(-213,e,175949,172446,1460);d$(e);u=d;return}}while(0)}function QS(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=u;u=u+48|0;e=d;g=f[a>>2]|0;h=g&50331648;i=g&2031616;a:do if((i|0)>=655360){if((i|0)<720896){switch(i|0){case 655360:break;default:break a}g=f[a+4>>2]|0;j=c+4|0;k=f[j>>2]|0;l=f[c>>2]|0;m=k-l|0;n=(m|0)/48|0;o=l;l=k;if(m){if(n>>>0>1?(m=o+48|0,(l|0)!=(m|0)):0){o=l;do{l=o+-48|0;f[j>>2]=l;j0(l);o=f[j>>2]|0}while((o|0)!=(m|0))}}else hS(c,1-n|0);m=f[c>>2]|0;if((m|0)==(g|0)){u=d;return}o=g+24|0;j=f[o>>2]|0;if(j|0){l=j+8|0;f[l>>2]=(f[l>>2]|0)+1}l=m+24|0;j=f[l>>2]|0;if(j|0?(k=j+8|0,j=f[k>>2]|0,f[k>>2]=j+-1,(j|0)==1):0)k0(m);j=m+4|0;if((f[j>>2]|0)>0){k=f[m+32>>2]|0;p=0;do{f[k+(p<<2)>>2]=0;p=p+1|0;q=f[j>>2]|0}while((p|0)<(q|0));f[l>>2]=0;f[m>>2]=f[g>>2];if((q|0)<3)r=96;else r=98}else{f[l>>2]=0;f[m>>2]=f[g>>2];r=96}if((r|0)==96){p=f[g+4>>2]|0;if((p|0)<3){f[j>>2]=p;f[m+8>>2]=f[g+8>>2];f[m+12>>2]=f[g+12>>2];p=f[g+36>>2]|0;k=f[m+36>>2]|0;f[k>>2]=f[p>>2];f[k+4>>2]=f[p+4>>2]}else r=98}if((r|0)==98)i0(m,g);f[m+16>>2]=f[g+16>>2];p=m+20|0;if(!(f[p>>2]|0))f[p>>2]=f[g+20>>2];f[l>>2]=f[o>>2];f[m+28>>2]=f[g+28>>2];u=d;return}if((i|0)<983040){switch(i|0){case 720896:break;default:break a}p=f[a+4>>2]|0;k=(f[p+4>>2]|0)-(f[p>>2]|0)|0;n=(k|0)/48|0;s=c+4|0;t=f[s>>2]|0;v=f[c>>2]|0;w=(t-v|0)/48|0;x=v;v=t;if(n>>>0<=w>>>0){if(n>>>0<w>>>0?(t=x+(n*48|0)|0,(v|0)!=(t|0)):0){x=v;do{v=x+-48|0;f[s>>2]=v;j0(v);x=f[s>>2]|0}while((x|0)!=(t|0))}}else hS(c,n-w|0);if(!k){u=d;return}t=0;do{x=f[p>>2]|0;s=x+(t*48|0)|0;g=f[c>>2]|0;m=g+(t*48|0)|0;if((g|0)!=(x|0)){o=x+(t*48|0)+24|0;l=f[o>>2]|0;if(l|0){j=l+8|0;f[j>>2]=(f[j>>2]|0)+1}j=g+(t*48|0)+24|0;l=f[j>>2]|0;if(l|0?(v=l+8|0,l=f[v>>2]|0,f[v>>2]=l+-1,(l|0)==1):0)k0(m);l=g+(t*48|0)+4|0;if((f[l>>2]|0)>0){v=f[g+(t*48|0)+32>>2]|0;y=0;do{f[v+(y<<2)>>2]=0;y=y+1|0;z=f[l>>2]|0}while((y|0)<(z|0));f[j>>2]=0;f[m>>2]=f[s>>2];if((z|0)<3)r=73;else r=75}else{f[j>>2]=0;f[m>>2]=f[s>>2];r=73}if((r|0)==73){r=0;y=f[x+(t*48|0)+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[g+(t*48|0)+8>>2]=f[x+(t*48|0)+8>>2];f[g+(t*48|0)+12>>2]=f[x+(t*48|0)+12>>2];y=f[x+(t*48|0)+36>>2]|0;v=f[g+(t*48|0)+36>>2]|0;f[v>>2]=f[y>>2];f[v+4>>2]=f[y+4>>2]}else r=75}if((r|0)==75){r=0;i0(m,s)}f[g+(t*48|0)+16>>2]=f[x+(t*48|0)+16>>2];y=g+(t*48|0)+20|0;if(!(f[y>>2]|0))f[y>>2]=f[x+(t*48|0)+20>>2];f[j>>2]=f[o>>2];f[g+(t*48|0)+28>>2]=f[x+(t*48|0)+28>>2]}t=t+1|0}while(t>>>0<n>>>0);u=d;return}else{switch(i|0){case 983040:break;default:break a}n=f[a+4>>2]|0;t=f[a+12>>2]|0;p=c+4|0;k=f[p>>2]|0;w=f[c>>2]|0;y=(k-w|0)/48|0;v=w;w=k;if(t>>>0<=y>>>0){if(t>>>0<y>>>0?(k=v+(t*48|0)|0,(w|0)!=(k|0)):0){v=w;do{w=v+-48|0;f[p>>2]=w;j0(w);v=f[p>>2]|0}while((v|0)!=(k|0))}if(!t){u=d;return}}else hS(c,t-y|0);k=e+24|0;v=e+4|0;p=e+8|0;w=e+12|0;A=e+36|0;B=e+16|0;C=e+20|0;D=e+28|0;E=0;do{f0(e,n+(E*56|0)|0,h,0);F=f[c>>2]|0;G=F+(E*48|0)|0;if((G|0)!=(e|0)){H=f[k>>2]|0;if(H|0){I=H+8|0;f[I>>2]=(f[I>>2]|0)+1}I=F+(E*48|0)+24|0;H=f[I>>2]|0;if(H|0?(J=H+8|0,H=f[J>>2]|0,f[J>>2]=H+-1,(H|0)==1):0)k0(G);H=F+(E*48|0)+4|0;if((f[H>>2]|0)>0){J=f[F+(E*48|0)+32>>2]|0;K=0;do{f[J+(K<<2)>>2]=0;K=K+1|0;L=f[H>>2]|0}while((K|0)<(L|0));f[I>>2]=0;f[G>>2]=f[e>>2];if((L|0)<3)r=48;else r=50}else{f[I>>2]=0;f[G>>2]=f[e>>2];r=48}if((r|0)==48){r=0;K=f[v>>2]|0;if((K|0)<3){f[H>>2]=K;f[F+(E*48|0)+8>>2]=f[p>>2];f[F+(E*48|0)+12>>2]=f[w>>2];K=f[A>>2]|0;J=f[F+(E*48|0)+36>>2]|0;f[J>>2]=f[K>>2];f[J+4>>2]=f[K+4>>2]}else r=50}if((r|0)==50){r=0;i0(G,e)}f[F+(E*48|0)+16>>2]=f[B>>2];K=F+(E*48|0)+20|0;if(!(f[K>>2]|0))f[K>>2]=f[C>>2];f[I>>2]=f[k>>2];f[F+(E*48|0)+28>>2]=f[D>>2]}j0(e);E=E+1|0}while(E>>>0<t>>>0);u=d;return}}else{if((i|0)<65536){switch(i|0){case 0:break;default:break a}t=f[c>>2]|0;E=c+4|0;while(1){D=f[E>>2]|0;if((D|0)==(t|0))break;k=D+-48|0;f[E>>2]=k;j0(k)}u=d;return}if((i|0)<327680){switch(i|0){case 65536:break;default:break a}E=f[a+4>>2]|0;t=c+4|0;k=f[t>>2]|0;D=f[c>>2]|0;C=k-D|0;B=(C|0)/48|0;A=D;D=k;if(C){if(B>>>0>1?(C=A+48|0,(D|0)!=(C|0)):0){A=D;do{D=A+-48|0;f[t>>2]=D;j0(D);A=f[t>>2]|0}while((A|0)!=(C|0))}}else hS(c,1-B|0);f0(e,E,h,0);C=f[c>>2]|0;if((C|0)!=(e|0)){A=e+24|0;t=f[A>>2]|0;if(t|0){D=t+8|0;f[D>>2]=(f[D>>2]|0)+1}D=C+24|0;t=f[D>>2]|0;if(t|0?(k=t+8|0,t=f[k>>2]|0,f[k>>2]=t+-1,(t|0)==1):0)k0(C);t=C+4|0;if((f[t>>2]|0)>0){k=f[C+32>>2]|0;w=0;do{f[k+(w<<2)>>2]=0;w=w+1|0;M=f[t>>2]|0}while((w|0)<(M|0));f[D>>2]=0;f[C>>2]=f[e>>2];if((M|0)<3)r=118;else r=120}else{f[D>>2]=0;f[C>>2]=f[e>>2];r=118}if((r|0)==118){w=f[e+4>>2]|0;if((w|0)<3){f[t>>2]=w;f[C+8>>2]=f[e+8>>2];f[C+12>>2]=f[e+12>>2];w=f[e+36>>2]|0;k=f[C+36>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else r=120}if((r|0)==120)i0(C,e);f[C+16>>2]=f[e+16>>2];w=C+20|0;if(!(f[w>>2]|0))f[w>>2]=f[e+20>>2];f[D>>2]=f[A>>2];f[C+28>>2]=f[e+28>>2]}j0(e);u=d;return}switch(i|0){case 327680:break;default:break a}w=f[a+4>>2]|0;k=(f[w+4>>2]|0)-(f[w>>2]|0)|0;E=(k|0)/56|0;B=c+4|0;p=f[B>>2]|0;v=f[c>>2]|0;n=(p-v|0)/48|0;y=v;v=p;if(E>>>0<=n>>>0){if(E>>>0<n>>>0?(p=y+(E*48|0)|0,(v|0)!=(p|0)):0){y=v;do{v=y+-48|0;f[B>>2]=v;j0(v);y=f[B>>2]|0}while((y|0)!=(p|0))}}else hS(c,E-n|0);if(!k){u=d;return}p=e+24|0;y=e+4|0;B=e+8|0;C=e+12|0;A=e+36|0;D=e+16|0;t=e+20|0;v=e+28|0;K=0;do{f0(e,(f[w>>2]|0)+(K*56|0)|0,h,0);J=f[c>>2]|0;x=J+(K*48|0)|0;if((x|0)!=(e|0)){g=f[p>>2]|0;if(g|0){o=g+8|0;f[o>>2]=(f[o>>2]|0)+1}o=J+(K*48|0)+24|0;g=f[o>>2]|0;if(g|0?(j=g+8|0,g=f[j>>2]|0,f[j>>2]=g+-1,(g|0)==1):0)k0(x);g=J+(K*48|0)+4|0;if((f[g>>2]|0)>0){j=f[J+(K*48|0)+32>>2]|0;s=0;do{f[j+(s<<2)>>2]=0;s=s+1|0;N=f[g>>2]|0}while((s|0)<(N|0));f[o>>2]=0;f[x>>2]=f[e>>2];if((N|0)<3)r=23;else r=25}else{f[o>>2]=0;f[x>>2]=f[e>>2];r=23}if((r|0)==23){r=0;s=f[y>>2]|0;if((s|0)<3){f[g>>2]=s;f[J+(K*48|0)+8>>2]=f[B>>2];f[J+(K*48|0)+12>>2]=f[C>>2];s=f[A>>2]|0;j=f[J+(K*48|0)+36>>2]|0;f[j>>2]=f[s>>2];f[j+4>>2]=f[s+4>>2]}else r=25}if((r|0)==25){r=0;i0(x,e)}f[J+(K*48|0)+16>>2]=f[D>>2];s=J+(K*48|0)+20|0;if(!(f[s>>2]|0))f[s>>2]=f[t>>2];f[o>>2]=f[p>>2];f[J+(K*48|0)+28>>2]=f[v>>2]}j0(e);K=K+1|0}while(K>>>0<E>>>0);u=d;return}while(0);f[e>>2]=0;f[e+4>>2]=0;r=c$(e,30)|0;N=173557;c=r+30|0;do{b[r>>0]=b[N>>0]|0;r=r+1|0;N=N+1|0}while((r|0)<(c|0));j$(-213,e,175962,172446,1522);d$(e);u=d;return}function RS(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;QR(d,a,b);u=c;return f[d+4>>2]|0}function SS(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;QR(d,a,b);u=c;return f[d>>2]|0}function TS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+16|0;d=c;e=f[b>>2]&2031616;g=f[a>>2]&2031616;a:do if((g|0)<655360){switch(g|0){case 65536:break;default:{h=36;break a}}i=f[a+4>>2]|0;j=e&2097151;b:do if((j|0)<655360){switch(j|0){case 65536:break;default:break b}k=f[i+40>>2]|0;l=f[k+-4>>2]|0;m=f[(f[b+4>>2]|0)+40>>2]|0;if((l|0)!=(f[m+-4>>2]|0)){n=0;u=c;return n|0}if((l|0)==2){if((f[k>>2]|0)!=(f[m>>2]|0)){n=0;u=c;return n|0}n=(f[k+4>>2]|0)==(f[m+4>>2]|0);u=c;return n|0}if((l|0)>0)o=0;else{n=1;u=c;return n|0}while(1){if((f[k+(o<<2)>>2]|0)!=(f[m+(o<<2)>>2]|0)){n=0;h=39;break}o=o+1|0;if((o|0)>=(l|0)){n=1;h=39;break}}if((h|0)==39){u=c;return n|0}}else{switch(j|0){case 655360:break;default:break b}l=f[i+40>>2]|0;m=f[l+-4>>2]|0;k=f[(f[b+4>>2]|0)+32>>2]|0;if((m|0)!=(f[k+-4>>2]|0)){n=0;u=c;return n|0}if((m|0)==2){if((f[l>>2]|0)!=(f[k>>2]|0)){n=0;u=c;return n|0}n=(f[l+4>>2]|0)==(f[k+4>>2]|0);u=c;return n|0}if((m|0)>0)p=0;else{n=1;u=c;return n|0}while(1){if((f[l+(p<<2)>>2]|0)!=(f[k+(p<<2)>>2]|0)){n=0;h=39;break}p=p+1|0;if((p|0)>=(m|0)){n=1;h=39;break}}if((h|0)==39){u=c;return n|0}}while(0);if((f[i+4>>2]|0)>2){n=0;u=c;return n|0}else{j=f[i+40>>2]|0;q=f[j+4>>2]|0;r=f[j>>2]|0;break}}else{switch(g|0){case 655360:break;default:{h=36;break a}}j=f[a+4>>2]|0;m=e&2097151;c:do if((m|0)<655360){switch(m|0){case 65536:break;default:break c}k=f[j+32>>2]|0;l=f[k+-4>>2]|0;s=f[(f[b+4>>2]|0)+40>>2]|0;if((l|0)!=(f[s+-4>>2]|0)){n=0;u=c;return n|0}if((l|0)==2){if((f[k>>2]|0)!=(f[s>>2]|0)){n=0;u=c;return n|0}n=(f[k+4>>2]|0)==(f[s+4>>2]|0);u=c;return n|0}if((l|0)>0)t=0;else{n=1;u=c;return n|0}while(1){if((f[k+(t<<2)>>2]|0)!=(f[s+(t<<2)>>2]|0)){n=0;h=39;break}t=t+1|0;if((t|0)>=(l|0)){n=1;h=39;break}}if((h|0)==39){u=c;return n|0}}else{switch(m|0){case 655360:break;default:break c}l=f[j+32>>2]|0;s=f[l+-4>>2]|0;k=f[(f[b+4>>2]|0)+32>>2]|0;if((s|0)!=(f[k+-4>>2]|0)){n=0;u=c;return n|0}if((s|0)==2){if((f[l>>2]|0)!=(f[k>>2]|0)){n=0;u=c;return n|0}n=(f[l+4>>2]|0)==(f[k+4>>2]|0);u=c;return n|0}if((s|0)>0)v=0;else{n=1;u=c;return n|0}while(1){if((f[l+(v<<2)>>2]|0)!=(f[k+(v<<2)>>2]|0)){n=0;h=39;break}v=v+1|0;if((v|0)>=(s|0)){n=1;h=39;break}}if((h|0)==39){u=c;return n|0}}while(0);if((f[j+4>>2]|0)>2){n=0;u=c;return n|0}else{m=f[j+32>>2]|0;q=f[m+4>>2]|0;r=f[m>>2]|0;break}}while(0);if((h|0)==36){QR(d,a,-1);q=f[d>>2]|0;r=f[d+4>>2]|0}if((nS(b,-1)|0)>2){n=0;u=c;return n|0}QR(d,b,-1);n=(f[d>>2]|0)==(q|0)?(f[d+4>>2]|0)==(r|0):0;u=c;return n|0}function US(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+16|0;e=d+8|0;g=d;h=f[a>>2]&2031616;a:do if((h|0)>=655360){if((h|0)<720896){switch(h|0){case 655360:break;default:break a}if((c|0)>=0){f[e>>2]=0;f[e+4>>2]=0;i=c$(e,5)|0;b[i>>0]=b[173319]|0;b[i+1>>0]=b[173320]|0;b[i+2>>0]=b[173321]|0;b[i+3>>0]=b[173322]|0;b[i+4>>0]=b[173323]|0;j$(-215,e,175976,172446,1921);d$(e)}i=f[a+4>>2]|0;j=f[i+4>>2]|0;if((j|0)<3){k=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;u=d;return k|0}l=f[i+32>>2]|0;i=0;m=1;while(1){n=Y(f[l+(i<<2)>>2]|0,m)|0;i=i+1|0;if((i|0)==(j|0)){k=n;break}else m=n}u=d;return k|0}if((h|0)<983040){switch(h|0){case 720896:break;default:break a}m=f[a+4>>2]|0;j=f[m>>2]|0;i=((f[m+4>>2]|0)-j|0)/48|0;if((c|0)<0){k=i;u=d;return k|0}if((i|0)>(c|0))o=j;else{f[e>>2]=0;f[e+4>>2]=0;p=c$(e,18)|0;q=173614;r=p+18|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,e,175976,172446,1951);d$(e);o=f[m>>2]|0}j=f[o+(c*48|0)+4>>2]|0;if((j|0)<3){k=Y(f[o+(c*48|0)+12>>2]|0,f[o+(c*48|0)+8>>2]|0)|0;u=d;return k|0}i=f[o+(c*48|0)+32>>2]|0;l=0;n=1;while(1){s=Y(f[i+(l<<2)>>2]|0,n)|0;l=l+1|0;if((l|0)==(j|0)){k=s;break}else n=s}u=d;return k|0}else{switch(h|0){case 983040:break;default:break a}n=f[a+4>>2]|0;j=f[a+12>>2]|0;if((c|0)<0){k=j;u=d;return k|0}if((j|0)<=(c|0)){f[e>>2]=0;f[e+4>>2]=0;p=c$(e,13)|0;q=173633;r=p+13|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,e,175976,172446,1941);d$(e)}j=f[n+(c*56|0)+4>>2]|0;if((j|0)<3){k=Y(f[n+(c*56|0)+12>>2]|0,f[n+(c*56|0)+8>>2]|0)|0;u=d;return k|0}l=f[n+(c*56|0)+40>>2]|0;i=0;m=1;while(1){s=Y(f[l+(i<<2)>>2]|0,m)|0;i=i+1|0;if((i|0)==(j|0)){k=s;break}else m=s}u=d;return k|0}}else{if((h|0)<327680){switch(h|0){case 65536:break;default:break a}if((c|0)>=0){f[e>>2]=0;f[e+4>>2]=0;m=c$(e,5)|0;b[m>>0]=b[173319]|0;b[m+1>>0]=b[173320]|0;b[m+2>>0]=b[173321]|0;b[m+3>>0]=b[173322]|0;b[m+4>>0]=b[173323]|0;j$(-215,e,175976,172446,1915);d$(e)}m=f[a+4>>2]|0;j=f[m+4>>2]|0;if((j|0)<3){k=Y(f[m+12>>2]|0,f[m+8>>2]|0)|0;u=d;return k|0}i=f[m+40>>2]|0;m=0;l=1;while(1){n=Y(f[i+(m<<2)>>2]|0,l)|0;m=m+1|0;if((m|0)==(j|0)){k=n;break}else l=n}u=d;return k|0}switch(h|0){case 327680:break;default:break a}l=f[a+4>>2]|0;j=f[l>>2]|0;m=((f[l+4>>2]|0)-j|0)/56|0;if((c|0)<0){k=m;u=d;return k|0}if((m|0)>(c|0))t=j;else{f[e>>2]=0;f[e+4>>2]=0;p=c$(e,18)|0;q=173614;r=p+18|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,e,175976,172446,1931);d$(e);t=f[l>>2]|0}j=f[t+(c*56|0)+4>>2]|0;if((j|0)<3){k=Y(f[t+(c*56|0)+12>>2]|0,f[t+(c*56|0)+8>>2]|0)|0;u=d;return k|0}m=f[t+(c*56|0)+40>>2]|0;i=0;n=1;while(1){s=Y(f[m+(i<<2)>>2]|0,n)|0;i=i+1|0;if((i|0)==(j|0)){k=s;break}else n=s}u=d;return k|0}while(0);QR(g,a,c);k=Y(f[g+4>>2]|0,f[g>>2]|0)|0;u=d;return k|0}function VS(a,b){a=a|0;b=b|0;return (RR(a,b)|0)&7|0}function WS(a,b){a=a|0;b=b|0;return ((RR(a,b)|0)>>>3&511)+1|0}function XS(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;do switch((f[a>>2]|0)>>>16&31){case 1:{e=f[a+4>>2]|0;if(!(f[e+16>>2]|0)){g=1;u=c;return g|0}h=f[e+4>>2]|0;if((h|0)<3)i=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{j=f[e+40>>2]|0;e=0;k=1;while(1){l=Y(f[j+(e<<2)>>2]|0,k)|0;e=e+1|0;if((e|0)==(h|0)){i=l;break}else k=l}}g=(h|0)==0|(i|0)==0;u=c;return g|0}case 10:{k=f[a+4>>2]|0;if(!(f[k+24>>2]|0)){g=1;u=c;return g|0}e=f[k+4>>2]|0;if((e|0)<3)m=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{j=f[k+32>>2]|0;k=0;l=1;while(1){n=Y(f[j+(k<<2)>>2]|0,l)|0;k=k+1|0;if((k|0)==(e|0)){m=n;break}else l=n}}g=(e|0)==0|(m|0)==0;u=c;return g|0}case 3:{l=f[a+4>>2]|0;g=(f[l>>2]|0)==(f[l+4>>2]|0);u=c;return g|0}case 12:{g=(f[(f[a+4>>2]|0)+4>>2]|0)==0;u=c;return g|0}case 0:{g=1;u=c;return g|0}case 4:{l=f[a+4>>2]|0;g=(f[l>>2]|0)==(f[l+4>>2]|0);u=c;return g|0}case 5:{l=f[a+4>>2]|0;g=(f[l>>2]|0)==(f[l+4>>2]|0);u=c;return g|0}case 15:{g=(f[a+12>>2]|0)==0;u=c;return g|0}case 11:{l=f[a+4>>2]|0;g=(f[l>>2]|0)==(f[l+4>>2]|0);u=c;return g|0}case 7:{l=f[a+4>>2]|0;if(!(f[l+8>>2]|0)){g=1;u=c;return g|0}g=(f[l+12>>2]|0)==0;u=c;return g|0}case 9:{g=(f[(f[a+4>>2]|0)+16>>2]|0)==0;u=c;return g|0}case 13:{l=f[a+4>>2]|0;g=(f[l>>2]|0)==(f[l+4>>2]|0);u=c;return g|0}case 8:{g=(f[(f[a+4>>2]|0)+16>>2]|0)==0;u=c;return g|0}case 2:case 14:case 6:{g=0;u=c;return g|0}default:{f[d>>2]=0;f[d+4>>2]=0;l=c$(d,30)|0;k=173557;j=l+30|0;do{b[l>>0]=b[k>>0]|0;l=l+1|0;k=k+1|0}while((l|0)<(j|0));j$(-213,d,175982,172446,2117);d$(d);g=1;u=c;return g|0}}while(0);return 0}function YS(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d;switch((f[a>>2]|0)>>>16&31){case 1:{if((c|0)>=0){g=1;u=d;return g|0}g=(f[f[a+4>>2]>>2]&16384|0)!=0;u=d;return g|0}case 10:{if((c|0)>=0){g=1;u=d;return g|0}g=(f[f[a+4>>2]>>2]&16384|0)!=0;u=d;return g|0}case 5:{h=f[a+4>>2]|0;i=f[h>>2]|0;if((((f[h+4>>2]|0)-i|0)/56|0)>>>0>c>>>0)j=i;else{f[e>>2]=0;f[e+4>>2]=0;k=c$(e,21)|0;l=175988;m=k+21|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,e,176010,172446,2138);d$(e);j=f[h>>2]|0}g=(f[j+(c*56|0)>>2]&16384|0)!=0;u=d;return g|0}case 15:{j=f[a+4>>2]|0;if(!((c|0)>0?(f[a+12>>2]|0)>(c|0):0)){f[e>>2]=0;f[e+4>>2]=0;k=c$(e,22)|0;l=176023;m=k+22|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,e,176010,172446,2145);d$(e)}g=(f[j+(c*56|0)>>2]&16384|0)!=0;u=d;return g|0}case 11:{j=f[a+4>>2]|0;h=f[j>>2]|0;if((((f[j+4>>2]|0)-h|0)/48|0)>>>0>c>>>0)n=h;else{f[e>>2]=0;f[e+4>>2]=0;k=c$(e,21)|0;l=175988;m=k+21|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,e,176010,172446,2152);d$(e);n=f[j>>2]|0}g=(f[n+(c*48|0)>>2]&16384|0)!=0;u=d;return g|0}case 9:{if((c|0)>=0){g=1;u=d;return g|0}g=(f[f[a+4>>2]>>2]&16384|0)!=0;u=d;return g|0}case 0:case 2:case 3:case 4:case 6:case 12:case 14:{g=1;u=d;return g|0}default:{f[e>>2]=0;f[e+4>>2]=0;k=c$(e,30)|0;l=173557;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-213,e,176010,172446,2159);d$(e);g=0;u=d;return g|0}}return 0}function ZS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+112|0;d=c+56|0;e=c;switch((f[a>>2]|0)>>>16&31){case 0:{oS(b);u=c;return}case 1:case 2:case 3:case 12:case 14:{NR(d,a,-1);eL(d,b);g=d+36|0;h=f[g>>2]|0;if((h|0?(i=h+12|0,h=f[i>>2]|0,f[i>>2]=h+-1,(h|0)==1):0)?(h=f[g>>2]|0,h|0):0){f[g>>2]=0;i=f[h+4>>2]|0;if(!i){j=f[d+32>>2]|0;if(!j)k=sR()|0;else k=j}else k=i;Gh[f[(f[k>>2]|0)+24>>2]&511](k,h)}f[g>>2]=0;g=d+16|0;h=d+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[h>>2]|0)>0){g=f[d+40>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[h>>2]|0))}h=f[d+44>>2]|0;if((h|0)!=(d+48|0))ZF(h);u=c;return}case 6:{h=f[a+4>>2]|0;if((f[b>>2]&2031616|0)==65536){k=_S(b,-1)|0;g=f[h>>2]|0;Ah[f[(f[g>>2]|0)+12>>2]&255](g,h,k,-1);u=c;return}PR(e,h);eL(e,b);h=e+36|0;k=f[h>>2]|0;if((k|0?(g=k+12|0,k=f[g>>2]|0,f[g>>2]=k+-1,(k|0)==1):0)?(k=f[h>>2]|0,k|0):0){f[h>>2]=0;g=f[k+4>>2]|0;if(!g){i=f[e+32>>2]|0;if(!i)l=sR()|0;else l=i}else l=g;Gh[f[(f[l>>2]|0)+24>>2]&511](l,k)}f[h>>2]=0;h=e+16|0;k=e+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[k>>2]|0)>0){h=f[e+40>>2]|0;l=0;do{f[h+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[k>>2]|0))}k=f[e+44>>2]|0;if((k|0)==(e+48|0)){u=c;return}ZF(k);u=c;return}case 10:{p0(f[a+4>>2]|0,b);u=c;return}default:{f[d>>2]=0;f[d+4>>2]=0;j$(-213,d,201110,172446,2350);d$(d);u=c;return}}}function _S(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;g=f[a>>2]&2031616;if((c|0)<0){if((g|0)!=65536){f[e>>2]=0;f[e+4>>2]=0;h=c$(e,8)|0;i=h;b[i>>0]=107;b[i+1>>0]=32;b[i+2>>0]=61;b[i+3>>0]=61;i=h+4|0;b[i>>0]=32;b[i+1>>0]=77;b[i+2>>0]=65;b[i+3>>0]=84;j$(-215,e,176046,172446,2924);d$(e)}j=f[a+4>>2]|0;u=d;return j|0}i=(g|0)==327680;h=g&2097151;if((h|0)<983040)switch(h|0){case 327680:break;default:k=6}else switch(h|0){case 983040:break;default:k=6}if((k|0)==6){f[e>>2]=0;f[e+4>>2]=0;l=c$(e,41)|0;m=176056;n=l+41|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-215,e,176046,172446,2928);d$(e)}k=f[a+4>>2]|0;if(i){i=f[k>>2]|0;if((((f[k+4>>2]|0)-i|0)/56|0|0)>(c|0))o=i;else{f[e>>2]=0;f[e+4>>2]=0;l=c$(e,17)|0;m=174514;n=l+17|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-215,e,176046,172446,2933);d$(e);o=f[k>>2]|0}j=o+(c*56|0)|0;u=d;return j|0}else{if(!((c|0)>-1?(f[a+12>>2]|0)>(c|0):0)){f[e>>2]=0;f[e+4>>2]=0;l=c$(e,23)|0;m=173390;n=l+23|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-215,e,176046,172446,2939);d$(e)}j=k+(c*56|0)|0;u=d;return j|0}return 0}function $S(a){a=a|0;return (f[a>>2]&1073741824|0)!=0|0}function aT(a){a=a|0;return (f[a>>2]|0)<0|0}function bT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+144|0;e=d+128|0;g=d;h=f[b>>2]&2031616;a:do if((h|0)>=65536)if((h|0)<655360){switch(h|0){case 65536:break;default:{i=8;break a}}j=f[b+4>>2]|0;k=f[j+4>>2]|0;if((k|0)<=0){l=k;break}m=f[j+40>>2]|0;j=0;do{f[g+(j<<2)>>2]=f[m+(j<<2)>>2];j=j+1|0}while((j|0)!=(k|0));l=k}else{switch(h|0){case 655360:break;default:{i=8;break a}}k=f[b+4>>2]|0;j=f[k+4>>2]|0;if((j|0)<=0){l=j;break}m=f[k+32>>2]|0;k=0;do{f[g+(k<<2)>>2]=f[m+(k<<2)>>2];k=k+1|0}while((k|0)!=(j|0));l=j}else switch(h|0){case 0:{l=0;break}default:i=8}while(0);if((i|0)==8){QR(e,b,-1);f[g>>2]=f[e+4>>2];f[g+4>>2]=f[e>>2];l=2}MR(a,l,g,c,-1,0,0);u=d;return}function cT(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[a>>2]|0;if((e&2031616|0)!=65536){oS(a);u=c;return}if(e&1073741824|0){f[d>>2]=0;f[d+4>>2]=0;e=c$(d,12)|0;g=175531;h=e+12|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));j$(-215,d,176098,172446,2906);d$(d)}d=f[a+4>>2]|0;a=d+40|0;g=f[a>>2]|0;e=f[g>>2]|0;if(!e){u=c;return}if(!(f[d>>2]&32768)){h=d+44|0;if((f[d+16>>2]|0)>>>0>(f[d+28>>2]|0)>>>0){i=h;j=8}else{k=h;l=g}}else{i=d+44|0;j=8}if((j|0)==8){IR(d,0);k=i;l=f[a>>2]|0}a=f[k>>2]|0;f[l>>2]=0;l=Y(f[a>>2]|0,0-e|0)|0;e=d+24|0;f[e>>2]=(f[e>>2]|0)+l;u=c;return}function dT(a){a=a|0;return (f[a>>2]&2031616|0)!=0|0}function eT(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0.0,t=0.0,v=0;e=u;u=u+112|0;g=e;h=e+56|0;switch((f[a>>2]|0)>>>16&31){case 1:case 2:case 3:case 14:{NR(g,a,-1);hL(g,c,d)|0;i=g+36|0;j=f[i>>2]|0;if((j|0?(k=j+12|0,j=f[k>>2]|0,f[k>>2]=j+-1,(j|0)==1):0)?(j=f[i>>2]|0,j|0):0){f[i>>2]=0;k=f[j+4>>2]|0;if(!k){l=f[g+32>>2]|0;if(!l)m=sR()|0;else m=l}else m=k;Gh[f[(f[m>>2]|0)+24>>2]&511](m,j)}f[i>>2]=0;i=g+16|0;j=g+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[j>>2]|0)>0){i=f[g+40>>2]|0;m=0;do{f[i+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[j>>2]|0))}j=f[g+44>>2]|0;if((j|0)!=(g+48|0))ZF(j);u=e;return}case 10:{o0(f[a+4>>2]|0,c,d)|0;u=e;return}case 9:{NR(h,c,-1);c=RR(a,-1)|0;j=h+4|0;if(((f[j>>2]|0)<=2?(m=f[h>>2]|0,(m&16384|0)!=0):0)?(i=f[h+40>>2]|0,k=f[i+4>>2]|0,l=f[i>>2]|0,i=(k|0)==1,n=(l|0)==1,i|n):0){o=(c>>>3&511)+1|0;if(!((o|0)==(k|0)&n|i&(n|(o|0)==(l|0)))?o>>>0>4|(m&4095|0)!=6|i&(l|0)==4^1:0)q=21}else q=21;if((q|0)==21){f[g>>2]=0;f[g+4>>2]=0;q=c$(g,65)|0;l=176104;i=q+65|0;do{b[q>>0]=b[l>>0]|0;q=q+1|0;l=l+1|0}while((q|0)<(i|0));j$(-215,g,176170,172446,3004);d$(g)}l=f[a+4>>2]|0;a=h+16|0;q=f[a>>2]|0;i=h+44|0;r=+p[q+8>>3];s=+p[q+16>>3];t=+p[q+24>>3];p[g>>3]=+p[q>>3];p[g+8>>3]=r;p[g+16>>3]=s;p[g+24>>3]=t;d1(l,g,d,h1()|0)|0;d=h+36|0;l=f[d>>2]|0;if((l|0?(q=l+12|0,l=f[q>>2]|0,f[q>>2]=l+-1,(l|0)==1):0)?(l=f[d>>2]|0,l|0):0){f[d>>2]=0;q=f[l+4>>2]|0;if(!q){m=f[h+32>>2]|0;if(!m)v=sR()|0;else v=m}else v=q;Gh[f[(f[v>>2]|0)+24>>2]&511](v,l)}f[d>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[j>>2]|0)>0){a=f[h+40>>2]|0;d=0;do{f[a+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[j>>2]|0))}j=f[i>>2]|0;if((j|0)!=(h+48|0))ZF(j);u=e;return}case 0:{u=e;return}default:{f[g>>2]=0;f[g+4>>2]=0;j$(-213,g,176170,172446,3008);d$(g);u=e;return}}}function fT(){return 42180}function gT(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=u;u=u+144|0;g=e+128|0;h=e+72|0;i=e+16|0;j=e;_$(g,42196);if((a|0)!=0&(c|0)!=0){k=a+8|0;l=h+4|0;m=0;n=0;do{if(!(((f[a+(m*56|0)+4>>2]|0)<3?(f[a+(m*56|0)+8>>2]|0)==(f[k>>2]|0):0)?!((f[a>>2]^f[a+(m*56|0)>>2])&4095|0):0)){f[h>>2]=0;f[l>>2]=0;o=c$(h,80)|0;p=176176;q=o+80|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-215,h,176257,172446,3080);d$(h)}n=(f[a+(m*56|0)+12>>2]|0)+n|0;m=m+1|0}while(m>>>0<c>>>0);pS(d,f[k>>2]|0,n,f[a>>2]&4095,-1,0,0);NR(h,d,-1);n=j+4|0;k=j+8|0;m=j+12|0;l=j+8|0;p=j+4|0;o=i+36|0;q=i+16|0;r=i+4|0;s=i+40|0;t=i+44|0;v=i+48|0;w=i+32|0;x=0;y=0;while(1){z=a+(y*56|0)+12|0;A=f[z>>2]|0;B=f[a+(y*56|0)+8>>2]|0;f[j>>2]=x;f[n>>2]=0;f[k>>2]=A;f[m>>2]=B;FR(i,h,j);B=l;f[B>>2]=0;f[B+4>>2]=0;f[j>>2]=33619968;f[p>>2]=i;eL(a+(y*56|0)|0,j);B=f[z>>2]|0;z=f[o>>2]|0;if((z|0?(A=z+12|0,z=f[A>>2]|0,f[A>>2]=z+-1,(z|0)==1):0)?(z=f[o>>2]|0,z|0):0){f[o>>2]=0;A=f[z+4>>2]|0;if(!A){C=f[w>>2]|0;if(!C)D=sR()|0;else D=C}else D=A;Gh[f[(f[D>>2]|0)+24>>2]&511](D,z)}f[o>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[r>>2]|0)>0){z=f[s>>2]|0;A=0;do{f[z+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[r>>2]|0))}A=f[t>>2]|0;if((A|0)!=(v|0))ZF(A);y=y+1|0;if(y>>>0>=c>>>0)break;else x=B+x|0}x=h+36|0;c=f[x>>2]|0;if((c|0?(y=c+12|0,c=f[y>>2]|0,f[y>>2]=c+-1,(c|0)==1):0)?(c=f[x>>2]|0,c|0):0){f[x>>2]=0;y=f[c+4>>2]|0;if(!y){v=f[h+32>>2]|0;if(!v)E=sR()|0;else E=v}else E=y;Gh[f[(f[E>>2]|0)+24>>2]&511](E,c)}f[x>>2]=0;x=h+16|0;c=h+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[c>>2]|0)>0){x=f[h+40>>2]|0;E=0;do{f[x+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[c>>2]|0))}c=f[h+44>>2]|0;if((c|0)!=(h+48|0))ZF(c)}else oS(d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function hT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+32|0;d=c+16|0;e=c;_$(d,42216);f[e>>2]=0;g=e+4|0;f[g>>2]=0;f[e+8>>2]=0;PS(a,e);a=f[e>>2]|0;h=f[g>>2]|0;gT((a|0)==(h|0)?0:a,(h-a|0)/56|0,b);Vt(e);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function iT(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=u;u=u+144|0;g=e+128|0;h=e+72|0;i=e+16|0;j=e;_$(g,42236);if((a|0)!=0&(c|0)!=0){k=a+12|0;l=h+4|0;m=0;n=0;do{if(!(((f[a+(m*56|0)+4>>2]|0)<3?(f[a+(m*56|0)+12>>2]|0)==(f[k>>2]|0):0)?!((f[a>>2]^f[a+(m*56|0)>>2])&4095|0):0)){f[h>>2]=0;f[l>>2]=0;o=c$(h,80)|0;p=176362;q=o+80|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-215,h,176443,172446,3125);d$(h)}n=(f[a+(m*56|0)+8>>2]|0)+n|0;m=m+1|0}while(m>>>0<c>>>0);pS(d,n,f[k>>2]|0,f[a>>2]&4095,-1,0,0);NR(h,d,-1);k=j+4|0;n=j+8|0;m=j+12|0;l=j+8|0;p=j+4|0;o=i+36|0;q=i+16|0;r=i+4|0;s=i+40|0;t=i+44|0;v=i+48|0;w=i+32|0;x=0;y=0;while(1){z=f[a+(x*56|0)+12>>2]|0;A=a+(x*56|0)+8|0;B=f[A>>2]|0;f[j>>2]=0;f[k>>2]=y;f[n>>2]=z;f[m>>2]=B;FR(i,h,j);B=l;f[B>>2]=0;f[B+4>>2]=0;f[j>>2]=33619968;f[p>>2]=i;eL(a+(x*56|0)|0,j);B=f[A>>2]|0;A=f[o>>2]|0;if((A|0?(z=A+12|0,A=f[z>>2]|0,f[z>>2]=A+-1,(A|0)==1):0)?(A=f[o>>2]|0,A|0):0){f[o>>2]=0;z=f[A+4>>2]|0;if(!z){C=f[w>>2]|0;if(!C)D=sR()|0;else D=C}else D=z;Gh[f[(f[D>>2]|0)+24>>2]&511](D,A)}f[o>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[r>>2]|0)>0){A=f[s>>2]|0;z=0;do{f[A+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[r>>2]|0))}z=f[t>>2]|0;if((z|0)!=(v|0))ZF(z);x=x+1|0;if(x>>>0>=c>>>0)break;else y=B+y|0}y=h+36|0;c=f[y>>2]|0;if((c|0?(x=c+12|0,c=f[x>>2]|0,f[x>>2]=c+-1,(c|0)==1):0)?(c=f[y>>2]|0,c|0):0){f[y>>2]=0;x=f[c+4>>2]|0;if(!x){v=f[h+32>>2]|0;if(!v)E=sR()|0;else E=v}else E=x;Gh[f[(f[E>>2]|0)+24>>2]&511](E,c)}f[y>>2]=0;y=h+16|0;c=h+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[c>>2]|0)>0){y=f[h+40>>2]|0;E=0;do{f[y+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[c>>2]|0))}c=f[h+44>>2]|0;if((c|0)!=(h+48|0))ZF(c)}else oS(d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function jT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+32|0;d=c+16|0;e=c;_$(d,42256);f[e>>2]=0;g=e+4|0;f[g>>2]=0;f[e+8>>2]=0;PS(a,e);a=f[e>>2]|0;h=f[g>>2]|0;iT((a|0)==(h|0)?0:a,(h-a|0)/56|0,b);Vt(e);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function kT(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0,q=0,r=0,s=0,t=0;d=u;u=u+160|0;e=d+144|0;g=d+88|0;h=d;i=d+32|0;_$(e,42276);if((nS(a,-1)|0)>=3){f[g>>2]=0;f[g+4>>2]=0;j=c$(g,14)|0;k=176548;l=j+14|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,g,176563,172446,3201);d$(g)}NR(g,a,-1);a=f[g+8>>2]|0;k=f[g+12>>2]|0;a:do switch(f[g>>2]&4095){case 5:{j=f[g+16>>2]|0;m=+p[c>>3];l=(f[g+48>>2]|0)>>>2;if((a|0)>0){if((k|0)<=0){o=j;q=0;while(1){if((q|0)<(k|0))n[o+(q<<2)>>2]=m;q=q+1|0;if((q|0)==(a|0))break a;else o=o+(l<<2)|0}}o=k<<2;q=j;r=0;while(1){F1a(j+((Y(l,r)|0)<<2)|0,0,o|0)|0;if((r|0)<(k|0))n[q+(r<<2)>>2]=m;r=r+1|0;if((r|0)==(a|0))break;else q=q+(l<<2)|0}}break}case 6:{m=+p[c>>3];l=(f[g+48>>2]|0)>>>3;if((a|0)>0&(k|0)>0){q=f[g+16>>2]|0;r=0;while(1){o=0;do{p[q+(o<<3)>>3]=(o|0)==(r|0)?m:0.0;o=o+1|0}while((o|0)!=(k|0));r=r+1|0;if((r|0)==(a|0))break;else q=q+(l<<3)|0}}break}default:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;gL(g,h)|0;HR(i,g,0);gL(i,c)|0;l=i+36|0;q=f[l>>2]|0;if((q|0?(r=q+12|0,q=f[r>>2]|0,f[r>>2]=q+-1,(q|0)==1):0)?(q=f[l>>2]|0,q|0):0){f[l>>2]=0;r=f[q+4>>2]|0;if(!r){o=f[i+32>>2]|0;if(!o)s=sR()|0;else s=o}else s=r;Gh[f[(f[s>>2]|0)+24>>2]&511](s,q)}f[l>>2]=0;l=i+16|0;q=i+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[q>>2]|0)>0){l=f[i+40>>2]|0;r=0;do{f[l+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[q>>2]|0))}q=f[i+44>>2]|0;if((q|0)!=(i+48|0))ZF(q)}}while(0);i=g+36|0;s=f[i>>2]|0;if((s|0?(c=s+12|0,s=f[c>>2]|0,f[c>>2]=s+-1,(s|0)==1):0)?(s=f[i>>2]|0,s|0):0){f[i>>2]=0;c=f[s+4>>2]|0;if(!c){h=f[g+32>>2]|0;if(!h)t=sR()|0;else t=h}else t=c;Gh[f[(f[t>>2]|0)+24>>2]&511](t,s)}f[i>>2]=0;i=g+16|0;s=g+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[s>>2]|0)>0){i=f[g+40>>2]|0;t=0;do{f[i+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[s>>2]|0))}s=f[g+44>>2]|0;if((s|0)!=(g+48|0))ZF(s);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function lT(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0,q=0,r=0.0,s=0.0,t=0.0,v=0,w=0;d=u;u=u+144|0;e=d+128|0;g=d+72|0;h=d+56|0;i=d;_$(e,42296);NR(g,c,-1);c=g+4|0;if((f[c>>2]|0)>=3){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,11)|0;k=200466;l=j+11|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,h,176630,172446,3249);d$(h)}k=f[g+12>>2]|0;j=f[g+8>>2]|0;l=(k|0)<(j|0)?k:j;switch(f[g>>2]&4095){case 5:{j=f[g+16>>2]|0;k=((f[g+48>>2]|0)>>>2)+1|0;if((l|0)>0){m=0.0;o=0;while(1){q=j+((Y(o,k)|0)<<2)|0;r=m+ +n[q>>2];o=o+1|0;if((o|0)>=(l|0)){s=r;break}else m=r}}else s=0.0;p[a>>3]=s;o=a+8|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;break}case 6:{o=f[g+16>>2]|0;k=((f[g+48>>2]|0)>>>3)+1|0;if((l|0)>0){s=0.0;j=0;while(1){q=o+((Y(j,k)|0)<<3)|0;m=s+ +p[q>>3];j=j+1|0;if((j|0)>=(l|0)){t=m;break}else s=m}}else t=0.0;p[a>>3]=t;l=a+8|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;break}default:{HR(i,g,0);f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=i;VY(a,h);h=i+36|0;a=f[h>>2]|0;if((a|0?(l=a+12|0,a=f[l>>2]|0,f[l>>2]=a+-1,(a|0)==1):0)?(a=f[h>>2]|0,a|0):0){f[h>>2]=0;l=f[a+4>>2]|0;if(!l){j=f[i+32>>2]|0;if(!j)v=sR()|0;else v=j}else v=l;Gh[f[(f[v>>2]|0)+24>>2]&511](v,a)}f[h>>2]=0;h=i+16|0;a=i+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[a>>2]|0)>0){h=f[i+40>>2]|0;v=0;do{f[h+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[a>>2]|0))}a=f[i+44>>2]|0;if((a|0)!=(i+48|0))ZF(a)}}a=g+36|0;i=f[a>>2]|0;if((i|0?(v=i+12|0,i=f[v>>2]|0,f[v>>2]=i+-1,(i|0)==1):0)?(i=f[a>>2]|0,i|0):0){f[a>>2]=0;v=f[i+4>>2]|0;if(!v){h=f[g+32>>2]|0;if(!h)w=sR()|0;else w=h}else w=v;Gh[f[(f[w>>2]|0)+24>>2]&511](w,i)}f[a>>2]=0;a=g+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[c>>2]|0)>0){a=f[g+40>>2]|0;i=0;do{f[a+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[c>>2]|0))}c=f[g+44>>2]|0;if((c|0)!=(g+48|0))ZF(c);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function mT(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+80|0;e=d+64|0;g=d+8|0;h=d;_$(e,42316);NR(g,a,-1);a=g+48|0;i=f[a>>2]|0;j=g+4|0;k=f[j>>2]|0;if((k|0)>0){l=f[(f[g+44>>2]|0)+(k+-1<<2)>>2]|0;if((k|0)<3){m=l;n=3}else{o=l;n=4}}else{m=0;n=3}if((n|0)==3){l=f[g+8>>2]|0;if((l|0)==(f[g+12>>2]|0)){p=l;q=m}else{o=m;n=4}}if((n|0)==4){f[h>>2]=0;f[h+4>>2]=0;n=c$(h,31)|0;m=176669;l=n+31|0;do{b[n>>0]=b[m>>0]|0;n=n+1|0;m=m+1|0}while((n|0)<(l|0));j$(-215,h,176701,172446,3564);d$(h);p=f[g+8>>2]|0;q=o}o=g+16|0;h=f[o>>2]|0;m=g+44|0;if((p|0)>0)if(c){c=0;do{n=c;c=c+1|0;if((c|0)<(p|0)){l=Y(n,i)|0;k=Y(n,q)|0;n=c;do{K1a(h+((Y(n,q)|0)+l)|0,h+((Y(n,i)|0)+k)|0,q|0)|0;n=n+1|0}while((n|0)!=(p|0))}}while((c|0)!=(p|0))}else{c=0;do{if((c|0)>0){n=Y(c,i)|0;k=Y(c,q)|0;l=0;do{K1a(h+((Y(l,q)|0)+n)|0,h+((Y(l,i)|0)+k)|0,q|0)|0;l=l+1|0}while((l|0)!=(c|0))}c=c+1|0}while((c|0)!=(p|0))}p=g+36|0;c=f[p>>2]|0;if((c|0?(q=c+12|0,c=f[q>>2]|0,f[q>>2]=c+-1,(c|0)==1):0)?(c=f[p>>2]|0,c|0):0){f[p>>2]=0;q=f[c+4>>2]|0;if(!q){i=f[g+32>>2]|0;if(!i)r=sR()|0;else r=i}else r=q;Gh[f[(f[r>>2]|0)+24>>2]&511](r,c)}f[p>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[j>>2]|0)>0){o=f[g+40>>2]|0;g=0;do{f[o+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[j>>2]|0))}j=f[m>>2]|0;if((j|0)!=(a|0))ZF(j);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function nT(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;h=u;u=u+272|0;i=h+224|0;j=h+216|0;k=h+168|0;l=h+112|0;m=h+56|0;n=h;_$(j,42336);if((nS(a,-1)|0)>=3){f[i>>2]=0;f[i+4>>2]=0;o=c$(i,16)|0;p=176760;q=o+16|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-215,i,176777,172446,3986);d$(i)}r=RR(a,-1)|0;s=r&7;t=r&4088;if((g|0)<0)if((f[c>>2]|0)<0)v=RR(c,-1)|0;else v=r;else v=g;g=(v|0)>-1?v:r;v=g&7;w=v|t;x=(e|0)==1;if(e>>>0>=4){f[i>>2]=0;f[i+4>>2]=0;o=c$(i,40)|0;p=176784;q=o+40|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-215,i,176777,172446,3996);d$(i)}f[k>>2]=1124007936;y=k+4|0;z=k+8|0;A=k+20|0;B=k+24|0;C=k+28|0;D=k+32|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[y+16>>2]=0;f[y+20>>2]=0;f[y+24>>2]=0;f[D>>2]=z;E=k+40|0;F=k+36|0;f[F>>2]=E;f[k+44>>2]=0;f[E>>2]=0;if((f[a>>2]&2031616|0)==655360){OS(i,a,-1);E=i+24|0;G=f[E>>2]|0;if(G|0){H=G+8|0;f[H>>2]=(f[H>>2]|0)+1}H=f[B>>2]|0;if(H|0?(G=H+8|0,H=f[G>>2]|0,f[G>>2]=H+-1,(H|0)==1):0)k0(k);if((f[y>>2]|0)>0){H=f[D>>2]|0;D=0;do{f[H+(D<<2)>>2]=0;D=D+1|0;I=f[y>>2]|0}while((D|0)<(I|0));f[B>>2]=0;f[k>>2]=f[i>>2];if((I|0)<3)J=19;else J=21}else{f[B>>2]=0;f[k>>2]=f[i>>2];J=19}if((J|0)==19){I=f[i+4>>2]|0;if((I|0)<3){f[y>>2]=I;f[z>>2]=f[i+8>>2];f[k+12>>2]=f[i+12>>2];z=f[i+36>>2]|0;I=f[F>>2]|0;f[I>>2]=f[z>>2];f[I+4>>2]=f[z+4>>2]}else J=21}if((J|0)==21)i0(k,i);f[k+16>>2]=f[i+16>>2];if(!(f[A>>2]|0))f[A>>2]=f[i+20>>2];f[B>>2]=f[E>>2];f[C>>2]=f[i+28>>2];j0(i)}NR(l,a,-1);a=(d|0)==0;d=l+8|0;C=l+12|0;pS(c,a?1:f[d>>2]|0,a?f[C>>2]|0:1,w,-1,0,0);NR(m,c,-1);f[n>>2]=f[m>>2];c=n+4|0;w=m+4|0;E=f[w>>2]|0;f[c>>2]=E;B=n+8|0;A=m+8|0;f[B>>2]=f[A>>2];z=n+12|0;I=m+12|0;f[z>>2]=f[I>>2];F=n+16|0;y=m+16|0;f[F>>2]=f[y>>2];f[n+20>>2]=f[m+20>>2];f[n+24>>2]=f[m+24>>2];f[n+28>>2]=f[m+28>>2];D=n+32|0;H=m+32|0;f[D>>2]=f[H>>2];G=n+36|0;K=m+36|0;L=f[K>>2]|0;f[G>>2]=L;M=n+40|0;f[M>>2]=B;N=n+48|0;O=n+44|0;f[O>>2]=N;f[N>>2]=0;f[n+52>>2]=0;if(!L)P=E;else{E=L+12|0;f[E>>2]=(f[E>>2]|0)+1;P=f[w>>2]|0}if((P|0)>=3){f[c>>2]=0;pR(n,P,0,0,0);if((f[c>>2]|0)>0){P=f[m+40>>2]|0;E=f[M>>2]|0;L=f[m+44>>2]|0;Q=f[O>>2]|0;R=0;do{f[E+(R<<2)>>2]=f[P+(R<<2)>>2];f[Q+(R<<2)>>2]=f[L+(R<<2)>>2];R=R+1|0}while((R|0)<(f[c>>2]|0))}}else{R=f[m+44>>2]|0;L=f[O>>2]|0;f[L>>2]=f[R>>2];f[L+4>>2]=f[R+4>>2]}do if(x)if(!((g|r)&4)){R=f[A>>2]|0;L=f[I>>2]|0;Q=t|4;if(((f[c>>2]|0)<3?(f[B>>2]|0)==(R|0):0)&(f[z>>2]|0)==(L|0)?!((f[F>>2]|0)==0?1:(f[n>>2]&4095|0)!=(Q|0)):0){S=4;T=0;break}f[i>>2]=R;f[i+4>>2]=L;AR(n,2,i,Q);S=4;T=0}else{S=v;T=0}else{S=v;T=e}while(0);e=(T|0)==0;a:do if(a){if(e){v=(s|0)==0;if(v&(S|0)==4){U=343;break}z=(S|0)==5;if(v&z){U=344;break}B=(S|0)==6;if(v&B){U=345;break}v=(s|0)==2;if(v&z){U=346;break}if(v&B){U=347;break}v=(s|0)==3;if(v&z){U=348;break}if(v&B){U=349;break}v=(s|0)==5;if(v&z){U=350;break}if(v&B){U=351;break}else{V=(s|0)==6&B?337:0;J=76;break}}switch(T|0){case 2:{if(!(S|s)){U=352;break a}if((s|0)==2&(S|0)==2){U=353;break a}if((s|0)==3&(S|0)==3){U=354;break a}if((s|0)==5&(S|0)==5){U=355;break a}else{V=(s|0)==6&(S|0)==6?338:0;J=76;break a}break}case 3:{if(!(S|s)){U=356;break a}if((s|0)==2&(S|0)==2){U=357;break a}if((s|0)==3&(S|0)==3){U=358;break a}if((s|0)==5&(S|0)==5){U=359;break a}else{V=(s|0)==6&(S|0)==6?339:0;J=76;break a}break}default:{f[i>>2]=0;W=i+4|0;f[W>>2]=0;X=c$(i,57)|0;o=X;p=176825;q=o+57|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-210,i,176777,172446,4128);d$(i)}}}else{if(e){B=(s|0)==0;if(B&(S|0)==4){U=360;break}v=(S|0)==5;if(B&v){U=361;break}z=(S|0)==6;if(B&z){U=362;break}B=(s|0)==2;if(B&v){U=363;break}if(B&z){U=364;break}B=(s|0)==3;if(B&v){U=365;break}if(B&z){U=366;break}B=(s|0)==5;if(B&v){U=367;break}if(B&z){U=368;break}else{V=(s|0)==6&z?340:0;J=76;break}}switch(T|0){case 2:{if(!(S|s)){U=369;break a}if((s|0)==2&(S|0)==2){U=370;break a}if((s|0)==3&(S|0)==3){U=371;break a}if((s|0)==5&(S|0)==5){U=372;break a}else{V=(s|0)==6&(S|0)==6?341:0;J=76;break a}break}case 3:{if(!(S|s)){U=373;break a}if((s|0)==2&(S|0)==2){U=374;break a}if((s|0)==3&(S|0)==3){U=375;break a}if((s|0)==5&(S|0)==5){U=376;break a}else{V=(s|0)==6&(S|0)==6?342:0;J=76;break a}break}default:{f[i>>2]=0;W=i+4|0;f[W>>2]=0;X=c$(i,57)|0;o=X;p=176825;q=o+57|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-210,i,176777,172446,4128);d$(i)}}}while(0);if((J|0)==76)if(!V){f[i>>2]=0;W=i+4|0;f[W>>2]=0;X=c$(i,57)|0;o=X;p=176825;q=o+57|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-210,i,176777,172446,4128);d$(i)}else U=V;Gh[U&511](l,n);if(x){x=i+8|0;f[x>>2]=0;f[x+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=m;WJ(n,i,f[m>>2]&4095,1.0/+((a?f[d>>2]|0:f[C>>2]|0)|0),0.0)}C=f[G>>2]|0;if((C|0?(d=C+12|0,C=f[d>>2]|0,f[d>>2]=C+-1,(C|0)==1):0)?(C=f[G>>2]|0,C|0):0){f[G>>2]=0;d=f[C+4>>2]|0;if(!d){a=f[D>>2]|0;if(!a)Y=sR()|0;else Y=a}else Y=d;Gh[f[(f[Y>>2]|0)+24>>2]&511](Y,C)}f[G>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[c>>2]|0)>0){F=f[M>>2]|0;M=0;do{f[F+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[c>>2]|0))}c=f[O>>2]|0;if((c|0)!=(N|0))ZF(c);c=f[K>>2]|0;if((c|0?(N=c+12|0,c=f[N>>2]|0,f[N>>2]=c+-1,(c|0)==1):0)?(c=f[K>>2]|0,c|0):0){f[K>>2]=0;N=f[c+4>>2]|0;if(!N){O=f[H>>2]|0;if(!O)Z=sR()|0;else Z=O}else Z=N;Gh[f[(f[Z>>2]|0)+24>>2]&511](Z,c)}f[K>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[w>>2]|0)>0){y=f[m+40>>2]|0;K=0;do{f[y+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[w>>2]|0))}w=f[m+44>>2]|0;if((w|0)!=(m+48|0))ZF(w);w=l+36|0;m=f[w>>2]|0;if((m|0?(K=m+12|0,m=f[K>>2]|0,f[K>>2]=m+-1,(m|0)==1):0)?(m=f[w>>2]|0,m|0):0){f[w>>2]=0;K=f[m+4>>2]|0;do if(!K){y=f[l+32>>2]|0;if(y|0){_=y;break}_=sR()|0}else _=K;while(0);Gh[f[(f[_>>2]|0)+24>>2]&511](_,m)}f[w>>2]=0;w=l+16|0;m=l+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[m>>2]|0)>0){w=f[l+40>>2]|0;_=0;do{f[w+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))ZF(m);j0(k);if(!(f[j+4>>2]|0)){u=h;return}u=h;return}function oT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0;c=u;u=u+1104|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>136){j=OYa(h>>>0>536870911?-1:h<<3)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>3;a=(h|0)>0;if(a){m=0;do{p[k+(m<<3)>>3]=+p[b+(m<<3)>>3];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){n=m;o=b;while(1){o=o+(l<<3)|0;if(a){q=0;do{r=k+(q<<3)|0;p[r>>3]=+p[r>>3]+ +p[o+(q<<3)>>3];q=q+1|0}while((q|0)!=(h|0))}n=n+-1|0;if(!n)break a}}n=h&-4;o=(n|0)<(h|0);q=m;r=b;do{r=r+(l<<3)|0;s=0;do{t=k+(s<<3)|0;v=s|1;w=k+(v<<3)|0;x=+p[w>>3]+ +p[r+(v<<3)>>3];p[t>>3]=+p[t>>3]+ +p[r+(s<<3)>>3];p[w>>3]=x;w=s|2;t=k+(w<<3)|0;v=s|3;y=k+(v<<3)|0;x=+p[y>>3]+ +p[r+(v<<3)>>3];p[t>>3]=+p[t>>3]+ +p[r+(w<<3)>>3];p[y>>3]=x;s=s+4|0}while((s|0)<=(g|0));if(o){s=n;do{y=k+(s<<3)|0;p[y>>3]=+p[y>>3]+ +p[r+(s<<3)>>3];s=s+1|0}while((s|0)!=(h|0))}q=q+-1|0}while((q|0)!=0)}while(0);if(a){a=0;do{p[j+(a<<3)>>3]=+p[k+(a<<3)>>3];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}QYa(k);f[d>>2]=e;f[i>>2]=136;u=c;return}function pT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0.0;c=u;u=u+1104|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>136){j=OYa(h>>>0>536870911?-1:h<<3)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>3;a=(h|0)>0;if(a){m=0;do{p[k+(m<<3)>>3]=+p[b+(m<<3)>>3];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){n=m;o=b;while(1){o=o+(l<<3)|0;if(a){q=0;do{r=k+(q<<3)|0;s=+p[r>>3];t=+p[o+(q<<3)>>3];p[r>>3]=s<t?t:s;q=q+1|0}while((q|0)!=(h|0))}n=n+-1|0;if(!n)break a}}n=h&-4;o=(n|0)<(h|0);q=m;r=b;do{r=r+(l<<3)|0;v=0;do{w=k+(v<<3)|0;s=+p[w>>3];t=+p[r+(v<<3)>>3];x=v|1;y=k+(x<<3)|0;z=+p[y>>3];A=+p[r+(x<<3)>>3];p[w>>3]=s<t?t:s;p[y>>3]=z<A?A:z;y=v|2;w=k+(y<<3)|0;z=+p[w>>3];A=+p[r+(y<<3)>>3];y=v|3;x=k+(y<<3)|0;s=+p[x>>3];t=+p[r+(y<<3)>>3];p[w>>3]=z<A?A:z;p[x>>3]=s<t?t:s;v=v+4|0}while((v|0)<=(g|0));if(o){v=n;do{x=k+(v<<3)|0;s=+p[x>>3];t=+p[r+(v<<3)>>3];p[x>>3]=s<t?t:s;v=v+1|0}while((v|0)!=(h|0))}q=q+-1|0}while((q|0)!=0)}while(0);if(a){a=0;do{p[j+(a<<3)>>3]=+p[k+(a<<3)>>3];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}QYa(k);f[d>>2]=e;f[i>>2]=136;u=c;return}function qT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0.0;c=u;u=u+1104|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>136){j=OYa(h>>>0>536870911?-1:h<<3)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>3;a=(h|0)>0;if(a){m=0;do{p[k+(m<<3)>>3]=+p[b+(m<<3)>>3];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){n=m;o=b;while(1){o=o+(l<<3)|0;if(a){q=0;do{r=k+(q<<3)|0;s=+p[r>>3];t=+p[o+(q<<3)>>3];p[r>>3]=t<s?t:s;q=q+1|0}while((q|0)!=(h|0))}n=n+-1|0;if(!n)break a}}n=h&-4;o=(n|0)<(h|0);q=m;r=b;do{r=r+(l<<3)|0;v=0;do{w=k+(v<<3)|0;s=+p[w>>3];t=+p[r+(v<<3)>>3];x=v|1;y=k+(x<<3)|0;z=+p[y>>3];A=+p[r+(x<<3)>>3];p[w>>3]=t<s?t:s;p[y>>3]=A<z?A:z;y=v|2;w=k+(y<<3)|0;z=+p[w>>3];A=+p[r+(y<<3)>>3];y=v|3;x=k+(y<<3)|0;s=+p[x>>3];t=+p[r+(y<<3)>>3];p[w>>3]=A<z?A:z;p[x>>3]=t<s?t:s;v=v+4|0}while((v|0)<=(g|0));if(o){v=n;do{x=k+(v<<3)|0;s=+p[x>>3];t=+p[r+(v<<3)>>3];p[x>>3]=t<s?t:s;v=v+1|0}while((v|0)!=(h|0))}q=q+-1|0}while((q|0)!=0)}while(0);if(a){a=0;do{p[j+(a<<3)>>3]=+p[k+(a<<3)>>3];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}QYa(k);f[d>>2]=e;f[i>>2]=136;u=c;return}function rT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);n=e*3|0;o=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{p[s+(t<<3)>>3]=+p[r+(t<<3)>>3];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+p[r+(t<<3)>>3];v=+p[r+(t+e<<3)>>3];if(o){w=u;x=j;while(1){y=w+ +p[r+(x+t<<3)>>3];x=x+e|0;if((x|0)>=(g|0)){z=y;break}else w=y}}else z=u;p[s+(t<<3)>>3]=v+z;t=t+1|0;if((t|0)==(e|0))break a}}else A=0;do{w=+p[r+(A<<3)>>3];y=+p[r+(A+e<<3)>>3];t=j;do{x=t+A|0;w=w+ +p[r+(x<<3)>>3]+ +p[r+(x+j<<3)>>3];y=y+ +p[r+(x+e<<3)>>3]+ +p[r+(x+n<<3)>>3];t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){v=w;x=t;while(1){u=v+ +p[r+(x+A<<3)>>3];x=x+e|0;if((x|0)>=(g|0)){B=u;break}else v=u}}else B=w;p[s+(A<<3)>>3]=y+B;A=A+1|0}while((A|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function sT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);n=e*3|0;o=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{p[s+(t<<3)>>3]=+p[r+(t<<3)>>3];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+p[r+(t<<3)>>3];v=+p[r+(t+e<<3)>>3];if(o){w=u;x=j;while(1){y=+p[r+(x+t<<3)>>3];z=w<y?y:w;x=x+e|0;if((x|0)>=(g|0)){A=z;break}else w=z}}else A=u;p[s+(t<<3)>>3]=A<v?v:A;t=t+1|0;if((t|0)==(e|0))break a}}else B=0;do{w=+p[r+(B<<3)>>3];z=+p[r+(B+e<<3)>>3];t=j;do{x=t+B|0;y=+p[r+(x<<3)>>3];C=w<y?y:w;y=+p[r+(x+e<<3)>>3];D=z<y?y:z;y=+p[r+(x+j<<3)>>3];w=C<y?y:C;C=+p[r+(x+n<<3)>>3];z=D<C?C:D;t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){v=w;x=t;while(1){u=+p[r+(x+B<<3)>>3];D=v<u?u:v;x=x+e|0;if((x|0)>=(g|0)){E=D;break}else v=D}}else E=w;p[s+(B<<3)>>3]=E<z?z:E;B=B+1|0}while((B|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function tT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);n=e*3|0;o=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{p[s+(t<<3)>>3]=+p[r+(t<<3)>>3];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+p[r+(t<<3)>>3];v=+p[r+(t+e<<3)>>3];if(o){w=u;x=j;while(1){y=+p[r+(x+t<<3)>>3];z=y<w?y:w;x=x+e|0;if((x|0)>=(g|0)){A=z;break}else w=z}}else A=u;p[s+(t<<3)>>3]=v<A?v:A;t=t+1|0;if((t|0)==(e|0))break a}}else B=0;do{w=+p[r+(B<<3)>>3];z=+p[r+(B+e<<3)>>3];t=j;do{x=t+B|0;y=+p[r+(x<<3)>>3];C=y<w?y:w;y=+p[r+(x+e<<3)>>3];D=y<z?y:z;y=+p[r+(x+j<<3)>>3];w=y<C?y:C;C=+p[r+(x+n<<3)>>3];z=C<D?C:D;t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){v=w;x=t;while(1){u=+p[r+(x+B<<3)>>3];D=u<v?u:v;x=x+e|0;if((x|0)>=(g|0)){E=D;break}else v=D}}else E=w;p[s+(B<<3)>>3]=z<E?z:E;B=B+1|0}while((B|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function uT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);o=e*3|0;p=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{f[s+(t<<2)>>2]=f[r+(t<<2)>>2];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+n[r+(t<<2)>>2];v=+n[r+(t+e<<2)>>2];if(p){w=u;x=j;while(1){y=+n[r+(x+t<<2)>>2];z=y<w?y:w;x=x+e|0;if((x|0)>=(g|0)){A=z;break}else w=z}}else A=u;n[s+(t<<2)>>2]=v<A?v:A;t=t+1|0;if((t|0)==(e|0))break a}}else B=0;do{w=+n[r+(B<<2)>>2];z=+n[r+(B+e<<2)>>2];t=j;do{x=t+B|0;y=+n[r+(x<<2)>>2];C=y<w?y:w;y=+n[r+(x+e<<2)>>2];D=y<z?y:z;y=+n[r+(x+j<<2)>>2];w=y<C?y:C;C=+n[r+(x+o<<2)>>2];z=C<D?C:D;t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){v=w;x=t;while(1){u=+n[r+(x+B<<2)>>2];D=u<v?u:v;x=x+e|0;if((x|0)>=(g|0)){E=D;break}else v=D}}else E=w;n[s+(B<<2)>>2]=z<E?z:E;B=B+1|0}while((B|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function vT(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;n=(k|0)>(m|0);o=g*3|0;p=(k|0)<(h|0);q=0;do{r=c+(Y(i,q)|0)|0;s=a+(Y(j,q)|0)|0;a:do if(b){t=0;do{d[s+(t<<1)>>1]=d[r+(t<<1)>>1]|0;t=t+1|0}while((t|0)!=(g|0))}else{if(n){t=0;while(1){u=d[r+(t<<1)>>1]|0;v=d[r+(t+g<<1)>>1]|0;if(p){w=u;x=k;while(1){y=d[r+(x+t<<1)>>1]|0;z=y<<16>>16<w<<16>>16?y:w;x=x+g|0;if((x|0)>=(h|0)){A=z;break}else w=z}}else A=u;d[s+(t<<1)>>1]=v<<16>>16<A<<16>>16?v:A;t=t+1|0;if((t|0)==(g|0))break a}}else B=0;do{t=d[r+(B<<1)>>1]|0;w=d[r+(B+g<<1)>>1]|0;x=k;do{z=x+B|0;y=d[r+(z<<1)>>1]|0;C=y<<16>>16<t<<16>>16?y:t;y=d[r+(z+g<<1)>>1]|0;D=y<<16>>16<w<<16>>16?y:w;y=d[r+(z+k<<1)>>1]|0;t=y<<16>>16<C<<16>>16?y:C;C=d[r+(z+o<<1)>>1]|0;w=C<<16>>16<D<<16>>16?C:D;x=x+l|0}while((x|0)<=(m|0));if((x|0)<(h|0)){v=t;u=x;while(1){D=d[r+(u+B<<1)>>1]|0;C=D<<16>>16<v<<16>>16?D:v;u=u+g|0;if((u|0)>=(h|0)){E=C;break}else v=C}}else E=t;d[s+(B<<1)>>1]=w<<16>>16<E<<16>>16?w:E;B=B+1|0}while((B|0)!=(g|0))}while(0);q=q+1|0}while((q|0)!=(e|0));return}function wT(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;n=(k|0)>(m|0);o=g*3|0;p=(k|0)<(h|0);q=0;do{r=c+(Y(i,q)|0)|0;s=a+(Y(j,q)|0)|0;a:do if(b){t=0;do{d[s+(t<<1)>>1]=d[r+(t<<1)>>1]|0;t=t+1|0}while((t|0)!=(g|0))}else{if(n){t=0;while(1){u=d[r+(t<<1)>>1]|0;v=d[r+(t+g<<1)>>1]|0;if(p){w=u;x=k;while(1){y=d[r+(x+t<<1)>>1]|0;z=(y&65535)<(w&65535)?y:w;x=x+g|0;if((x|0)>=(h|0)){A=z;break}else w=z}}else A=u;d[s+(t<<1)>>1]=(v&65535)<(A&65535)?v:A;t=t+1|0;if((t|0)==(g|0))break a}}else B=0;do{t=d[r+(B<<1)>>1]|0;w=d[r+(B+g<<1)>>1]|0;x=k;do{z=x+B|0;y=d[r+(z<<1)>>1]|0;C=(y&65535)<(t&65535)?y:t;y=d[r+(z+g<<1)>>1]|0;D=(y&65535)<(w&65535)?y:w;y=d[r+(z+k<<1)>>1]|0;t=(y&65535)<(C&65535)?y:C;C=d[r+(z+o<<1)>>1]|0;w=(C&65535)<(D&65535)?C:D;x=x+l|0}while((x|0)<=(m|0));if((x|0)<(h|0)){v=t;u=x;while(1){D=d[r+(u+B<<1)>>1]|0;C=(D&65535)<(v&65535)?D:v;u=u+g|0;if((u|0)>=(h|0)){E=C;break}else v=C}}else E=t;d[s+(B<<1)>>1]=(w&65535)<(E&65535)?w:E;B=B+1|0}while((B|0)!=(g|0))}while(0);q=q+1|0}while((q|0)!=(e|0));return}function xT(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=f[a+40>>2]|0;e=f[d>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;i=Y(g,f[d+4>>2]|0)|0;if((e|0)<=0)return;d=a+16|0;j=a+44|0;a=c+16|0;k=c+44|0;c=(i|0)==(g|0);l=g<<1;m=g<<2;n=i-m|0;o=(l|0)>(n|0);p=g*3|0;q=(l|0)<(i|0);r=0;do{s=(f[d>>2]|0)+(Y(f[f[j>>2]>>2]|0,r)|0)|0;t=(f[a>>2]|0)+(Y(f[f[k>>2]>>2]|0,r)|0)|0;a:do if(c){u=0;do{b[t+u>>0]=b[s+u>>0]|0;u=u+1|0}while((u|0)!=(g|0))}else{if(o){u=0;while(1){v=b[s+u>>0]|0;w=b[s+(u+g)>>0]|0;if(q){x=v;y=l;while(1){z=x&255;A=z-(h[199495+((z|256)-(h[s+(y+u)>>0]|0))>>0]|0)&255;y=y+g|0;if((y|0)>=(i|0)){B=A;break}else x=A}}else B=v;x=B&255;b[t+u>>0]=x-(h[199495+((x|256)-(w&255))>>0]|0);u=u+1|0;if((u|0)==(g|0))break a}}else C=0;do{u=b[s+C>>0]|0;x=b[s+(C+g)>>0]|0;y=l;while(1){A=y+C|0;z=u&255;D=z-(h[199495+((z|256)-(h[s+A>>0]|0))>>0]|0)|0;z=x&255;E=z-(h[199495+((z|256)-(h[s+(A+g)>>0]|0))>>0]|0)|0;F=D-(h[199495+((D&255|256)-(h[s+(A+l)>>0]|0))>>0]|0)|0;G=E-(h[199495+((E&255|256)-(h[s+(A+p)>>0]|0))>>0]|0)|0;y=y+m|0;if((y|0)>(n|0))break;else{u=F&255;x=G&255}}if((y|0)<(i|0)){x=F;u=y;while(1){w=x&255;v=w-(h[199495+((w|256)-(h[s+(u+C)>>0]|0))>>0]|0)|0;u=u+g|0;if((u|0)>=(i|0)){H=v;break}else x=v}}else H=F;b[t+C>>0]=H-(h[199495+((H&255|256)-(G&255))>>0]|0);C=C+1|0}while((C|0)!=(g|0))}while(0);r=r+1|0}while((r|0)!=(e|0));return}function yT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);o=e*3|0;p=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{f[s+(t<<2)>>2]=f[r+(t<<2)>>2];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+n[r+(t<<2)>>2];v=+n[r+(t+e<<2)>>2];if(p){w=u;x=j;while(1){y=+n[r+(x+t<<2)>>2];z=w<y?y:w;x=x+e|0;if((x|0)>=(g|0)){A=z;break}else w=z}}else A=u;n[s+(t<<2)>>2]=A<v?v:A;t=t+1|0;if((t|0)==(e|0))break a}}else B=0;do{w=+n[r+(B<<2)>>2];z=+n[r+(B+e<<2)>>2];t=j;do{x=t+B|0;y=+n[r+(x<<2)>>2];C=w<y?y:w;y=+n[r+(x+e<<2)>>2];D=z<y?y:z;y=+n[r+(x+j<<2)>>2];w=C<y?y:C;C=+n[r+(x+o<<2)>>2];z=D<C?C:D;t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){v=w;x=t;while(1){u=+n[r+(x+B<<2)>>2];D=v<u?u:v;x=x+e|0;if((x|0)>=(g|0)){E=D;break}else v=D}}else E=w;n[s+(B<<2)>>2]=E<z?z:E;B=B+1|0}while((B|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function zT(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;n=(k|0)>(m|0);o=g*3|0;p=(k|0)<(h|0);q=0;do{r=c+(Y(i,q)|0)|0;s=a+(Y(j,q)|0)|0;a:do if(b){t=0;do{d[s+(t<<1)>>1]=d[r+(t<<1)>>1]|0;t=t+1|0}while((t|0)!=(g|0))}else{if(n){t=0;while(1){u=d[r+(t<<1)>>1]|0;v=d[r+(t+g<<1)>>1]|0;if(p){w=u;x=k;while(1){y=d[r+(x+t<<1)>>1]|0;z=w<<16>>16<y<<16>>16?y:w;x=x+g|0;if((x|0)>=(h|0)){A=z;break}else w=z}}else A=u;d[s+(t<<1)>>1]=A<<16>>16<v<<16>>16?v:A;t=t+1|0;if((t|0)==(g|0))break a}}else B=0;do{t=d[r+(B<<1)>>1]|0;w=d[r+(B+g<<1)>>1]|0;x=k;do{z=x+B|0;y=d[r+(z<<1)>>1]|0;C=t<<16>>16<y<<16>>16?y:t;y=d[r+(z+g<<1)>>1]|0;D=w<<16>>16<y<<16>>16?y:w;y=d[r+(z+k<<1)>>1]|0;t=C<<16>>16<y<<16>>16?y:C;C=d[r+(z+o<<1)>>1]|0;w=D<<16>>16<C<<16>>16?C:D;x=x+l|0}while((x|0)<=(m|0));if((x|0)<(h|0)){v=t;u=x;while(1){D=d[r+(u+B<<1)>>1]|0;C=v<<16>>16<D<<16>>16?D:v;u=u+g|0;if((u|0)>=(h|0)){E=C;break}else v=C}}else E=t;d[s+(B<<1)>>1]=E<<16>>16<w<<16>>16?w:E;B=B+1|0}while((B|0)!=(g|0))}while(0);q=q+1|0}while((q|0)!=(e|0));return}function AT(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;n=(k|0)>(m|0);o=g*3|0;p=(k|0)<(h|0);q=0;do{r=c+(Y(i,q)|0)|0;s=a+(Y(j,q)|0)|0;a:do if(b){t=0;do{d[s+(t<<1)>>1]=d[r+(t<<1)>>1]|0;t=t+1|0}while((t|0)!=(g|0))}else{if(n){t=0;while(1){u=d[r+(t<<1)>>1]|0;v=d[r+(t+g<<1)>>1]|0;if(p){w=u;x=k;while(1){y=d[r+(x+t<<1)>>1]|0;z=(w&65535)<(y&65535)?y:w;x=x+g|0;if((x|0)>=(h|0)){A=z;break}else w=z}}else A=u;d[s+(t<<1)>>1]=(A&65535)<(v&65535)?v:A;t=t+1|0;if((t|0)==(g|0))break a}}else B=0;do{t=d[r+(B<<1)>>1]|0;w=d[r+(B+g<<1)>>1]|0;x=k;do{z=x+B|0;y=d[r+(z<<1)>>1]|0;C=(t&65535)<(y&65535)?y:t;y=d[r+(z+g<<1)>>1]|0;D=(w&65535)<(y&65535)?y:w;y=d[r+(z+k<<1)>>1]|0;t=(C&65535)<(y&65535)?y:C;C=d[r+(z+o<<1)>>1]|0;w=(D&65535)<(C&65535)?C:D;x=x+l|0}while((x|0)<=(m|0));if((x|0)<(h|0)){v=t;u=x;while(1){D=d[r+(u+B<<1)>>1]|0;C=(v&65535)<(D&65535)?D:v;u=u+g|0;if((u|0)>=(h|0)){E=C;break}else v=C}}else E=t;d[s+(B<<1)>>1]=(E&65535)<(w&65535)?w:E;B=B+1|0}while((B|0)!=(g|0))}while(0);q=q+1|0}while((q|0)!=(e|0));return}function BT(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=f[a+40>>2]|0;e=f[d>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;i=Y(g,f[d+4>>2]|0)|0;if((e|0)<=0)return;d=a+16|0;j=a+44|0;a=c+16|0;k=c+44|0;c=(i|0)==(g|0);l=g<<1;m=g<<2;n=i-m|0;o=(l|0)>(n|0);p=g*3|0;q=(l|0)<(i|0);r=0;do{s=(f[d>>2]|0)+(Y(f[f[j>>2]>>2]|0,r)|0)|0;t=(f[a>>2]|0)+(Y(f[f[k>>2]>>2]|0,r)|0)|0;a:do if(c){u=0;do{b[t+u>>0]=b[s+u>>0]|0;u=u+1|0}while((u|0)!=(g|0))}else{if(o){u=0;while(1){v=b[s+u>>0]|0;w=b[s+(u+g)>>0]|0;if(q){x=v;y=l;while(1){z=x&255;A=(h[199495+(256-z+(h[s+(y+u)>>0]|0))>>0]|0)+z&255;y=y+g|0;if((y|0)>=(i|0)){B=A;break}else x=A}}else B=v;x=B&255;b[t+u>>0]=(h[199495+((w&255|256)-x)>>0]|0)+x;u=u+1|0;if((u|0)==(g|0))break a}}else C=0;do{u=b[s+C>>0]|0;x=b[s+(C+g)>>0]|0;y=l;while(1){A=y+C|0;z=u&255;D=(h[199495+(256-z+(h[s+A>>0]|0))>>0]|0)+z|0;z=x&255;E=(h[199495+(256-z+(h[s+(A+g)>>0]|0))>>0]|0)+z|0;F=(h[199495+(256-(D&255)+(h[s+(A+l)>>0]|0))>>0]|0)+D|0;G=(h[199495+(256-(E&255)+(h[s+(A+p)>>0]|0))>>0]|0)+E|0;y=y+m|0;if((y|0)>(n|0))break;else{u=F&255;x=G&255}}if((y|0)<(i|0)){x=F;u=y;while(1){w=x&255;v=(h[199495+(256-w+(h[s+(u+C)>>0]|0))>>0]|0)+w|0;u=u+g|0;if((u|0)>=(i|0)){H=v;break}else x=v}}else H=F;b[t+C>>0]=(h[199495+((G&255|256)-(H&255))>>0]|0)+H;C=C+1|0}while((C|0)!=(g|0))}while(0);r=r+1|0}while((r|0)!=(e|0));return}function CT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);o=e*3|0;q=(j|0)<(g|0);r=0;do{s=c+(Y(h,r)|0)|0;t=a+(Y(i,r)|0)|0;a:do if(b){u=0;do{p[t+(u<<3)>>3]=+n[s+(u<<2)>>2];u=u+1|0}while((u|0)!=(e|0))}else{if(m){u=0;while(1){v=+n[s+(u<<2)>>2];w=+n[s+(u+e<<2)>>2];if(q){x=v;y=j;while(1){z=x+ +n[s+(y+u<<2)>>2];y=y+e|0;if((y|0)>=(g|0)){A=z;break}else x=z}}else A=v;p[t+(u<<3)>>3]=w+A;u=u+1|0;if((u|0)==(e|0))break a}}else B=0;do{x=+n[s+(B<<2)>>2];z=+n[s+(B+e<<2)>>2];u=j;do{y=u+B|0;x=x+ +n[s+(y<<2)>>2]+ +n[s+(y+j<<2)>>2];z=z+ +n[s+(y+e<<2)>>2]+ +n[s+(y+o<<2)>>2];u=u+k|0}while((u|0)<=(l|0));if((u|0)<(g|0)){w=x;y=u;while(1){v=w+ +n[s+(y+B<<2)>>2];y=y+e|0;if((y|0)>=(g|0)){C=v;break}else w=v}}else C=x;p[t+(B<<3)>>3]=z+C;B=B+1|0}while((B|0)!=(e|0))}while(0);r=r+1|0}while((r|0)!=(d|0));return}function DT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);o=e*3|0;p=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{f[s+(t<<2)>>2]=f[r+(t<<2)>>2];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+n[r+(t<<2)>>2];v=+n[r+(t+e<<2)>>2];if(p){w=u;x=j;while(1){y=w+ +n[r+(x+t<<2)>>2];x=x+e|0;if((x|0)>=(g|0)){z=y;break}else w=y}}else z=u;n[s+(t<<2)>>2]=v+z;t=t+1|0;if((t|0)==(e|0))break a}}else A=0;do{w=+n[r+(A<<2)>>2];y=+n[r+(A+e<<2)>>2];t=j;do{x=t+A|0;w=w+ +n[r+(x<<2)>>2]+ +n[r+(x+j<<2)>>2];y=y+ +n[r+(x+e<<2)>>2]+ +n[r+(x+o<<2)>>2];t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){v=w;x=t;while(1){u=v+ +n[r+(x+A<<2)>>2];x=x+e|0;if((x|0)>=(g|0)){B=u;break}else v=u}}else B=w;n[s+(A<<2)>>2]=y+B;A=A+1|0}while((A|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function ET(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;n=(k|0)>(m|0);o=g*3|0;q=(k|0)<(h|0);r=0;do{s=c+(Y(i,r)|0)|0;t=a+(Y(j,r)|0)|0;a:do if(b){u=0;do{p[t+(u<<3)>>3]=+(d[s+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(g|0))}else{if(n){u=0;while(1){v=+(d[s+(u<<1)>>1]|0);w=+(d[s+(u+g<<1)>>1]|0);if(q){x=v;y=k;while(1){z=x+ +(d[s+(y+u<<1)>>1]|0);y=y+g|0;if((y|0)>=(h|0)){A=z;break}else x=z}}else A=v;p[t+(u<<3)>>3]=w+A;u=u+1|0;if((u|0)==(g|0))break a}}else B=0;do{x=+(d[s+(B<<1)>>1]|0);z=+(d[s+(B+g<<1)>>1]|0);u=k;do{y=u+B|0;x=x+ +(d[s+(y<<1)>>1]|0)+ +(d[s+(y+k<<1)>>1]|0);z=z+ +(d[s+(y+g<<1)>>1]|0)+ +(d[s+(y+o<<1)>>1]|0);u=u+l|0}while((u|0)<=(m|0));if((u|0)<(h|0)){w=x;y=u;while(1){v=w+ +(d[s+(y+B<<1)>>1]|0);y=y+g|0;if((y|0)>=(h|0)){C=v;break}else w=v}}else C=x;p[t+(B<<3)>>3]=z+C;B=B+1|0}while((B|0)!=(g|0))}while(0);r=r+1|0}while((r|0)!=(e|0));return}function FT(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;o=(k|0)>(m|0);p=g*3|0;q=(k|0)<(h|0);r=0;do{s=c+(Y(i,r)|0)|0;t=a+(Y(j,r)|0)|0;a:do if(b){u=0;do{n[t+(u<<2)>>2]=+(d[s+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(g|0))}else{if(o){u=0;while(1){v=+(d[s+(u<<1)>>1]|0);w=+(d[s+(u+g<<1)>>1]|0);if(q){x=v;y=k;while(1){z=x+ +(d[s+(y+u<<1)>>1]|0);y=y+g|0;if((y|0)>=(h|0)){A=z;break}else x=z}}else A=v;n[t+(u<<2)>>2]=w+A;u=u+1|0;if((u|0)==(g|0))break a}}else B=0;do{x=+(d[s+(B<<1)>>1]|0);z=+(d[s+(B+g<<1)>>1]|0);u=k;do{y=u+B|0;x=x+ +(d[s+(y<<1)>>1]|0)+ +(d[s+(y+k<<1)>>1]|0);z=z+ +(d[s+(y+g<<1)>>1]|0)+ +(d[s+(y+p<<1)>>1]|0);u=u+l|0}while((u|0)<=(m|0));if((u|0)<(h|0)){w=x;y=u;while(1){v=w+ +(d[s+(y+B<<1)>>1]|0);y=y+g|0;if((y|0)>=(h|0)){C=v;break}else w=v}}else C=x;n[t+(B<<2)>>2]=z+C;B=B+1|0}while((B|0)!=(g|0))}while(0);r=r+1|0}while((r|0)!=(e|0));return}function GT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);k=e<<1;l=e<<2;m=g-l|0;n=(k|0)>(m|0);o=e*3|0;q=(k|0)<(g|0);r=0;do{s=c+(Y(h,r)|0)|0;t=a+(Y(i,r)|0)|0;a:do if(b){u=0;do{p[t+(u<<3)>>3]=+(j[s+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(e|0))}else{if(n){u=0;while(1){v=+(j[s+(u<<1)>>1]|0);w=+(j[s+(u+e<<1)>>1]|0);if(q){x=v;y=k;while(1){z=x+ +(j[s+(y+u<<1)>>1]|0);y=y+e|0;if((y|0)>=(g|0)){A=z;break}else x=z}}else A=v;p[t+(u<<3)>>3]=w+A;u=u+1|0;if((u|0)==(e|0))break a}}else B=0;do{x=+(j[s+(B<<1)>>1]|0);z=+(j[s+(B+e<<1)>>1]|0);u=k;do{y=u+B|0;x=x+ +(j[s+(y<<1)>>1]|0)+ +(j[s+(y+k<<1)>>1]|0);z=z+ +(j[s+(y+e<<1)>>1]|0)+ +(j[s+(y+o<<1)>>1]|0);u=u+l|0}while((u|0)<=(m|0));if((u|0)<(g|0)){w=x;y=u;while(1){v=w+ +(j[s+(y+B<<1)>>1]|0);y=y+e|0;if((y|0)>=(g|0)){C=v;break}else w=v}}else C=x;p[t+(B<<3)>>3]=z+C;B=B+1|0}while((B|0)!=(e|0))}while(0);r=r+1|0}while((r|0)!=(d|0));return}function HT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);k=e<<1;l=e<<2;m=g-l|0;o=(k|0)>(m|0);p=e*3|0;q=(k|0)<(g|0);r=0;do{s=c+(Y(h,r)|0)|0;t=a+(Y(i,r)|0)|0;a:do if(b){u=0;do{n[t+(u<<2)>>2]=+(j[s+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(e|0))}else{if(o){u=0;while(1){v=+(j[s+(u<<1)>>1]|0);w=+(j[s+(u+e<<1)>>1]|0);if(q){x=v;y=k;while(1){z=x+ +(j[s+(y+u<<1)>>1]|0);y=y+e|0;if((y|0)>=(g|0)){A=z;break}else x=z}}else A=v;n[t+(u<<2)>>2]=w+A;u=u+1|0;if((u|0)==(e|0))break a}}else B=0;do{x=+(j[s+(B<<1)>>1]|0);z=+(j[s+(B+e<<1)>>1]|0);u=k;do{y=u+B|0;x=x+ +(j[s+(y<<1)>>1]|0)+ +(j[s+(y+k<<1)>>1]|0);z=z+ +(j[s+(y+e<<1)>>1]|0)+ +(j[s+(y+p<<1)>>1]|0);u=u+l|0}while((u|0)<=(m|0));if((u|0)<(g|0)){w=x;y=u;while(1){v=w+ +(j[s+(y+B<<1)>>1]|0);y=y+e|0;if((y|0)>=(g|0)){C=v;break}else w=v}}else C=x;n[t+(B<<2)>>2]=z+C;B=B+1|0}while((B|0)!=(e|0))}while(0);r=r+1|0}while((r|0)!=(d|0));return}function IT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=(g|0)==(e|0);i=e<<1;j=e<<2;k=g-j|0;l=(i|0)>(k|0);m=e*3|0;n=f[a+16>>2]|0;o=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;q=f[f[b+44>>2]>>2]|0;b=(i|0)<(g|0);r=0;do{s=n+(Y(o,r)|0)|0;t=a+(Y(q,r)|0)|0;a:do if(c){u=0;do{p[t+(u<<3)>>3]=+(h[s+u>>0]|0);u=u+1|0}while((u|0)!=(e|0))}else{if(l){u=0;while(1){v=h[s+u>>0]|0;w=h[s+(u+e)>>0]|0;if(b){x=v;y=i;while(1){z=(h[s+(y+u)>>0]|0)+x|0;y=y+e|0;if((y|0)>=(g|0)){A=z;break}else x=z}}else A=v;p[t+(u<<3)>>3]=+(A+w|0);u=u+1|0;if((u|0)==(e|0))break a}}else B=0;do{u=h[s+B>>0]|0;x=h[s+(B+e)>>0]|0;y=i;do{z=y+B|0;u=(h[s+z>>0]|0)+u+(h[s+(z+i)>>0]|0)|0;x=(h[s+(z+e)>>0]|0)+x+(h[s+(z+m)>>0]|0)|0;y=y+j|0}while((y|0)<=(k|0));if((y|0)<(g|0)){w=u;v=y;while(1){z=(h[s+(v+B)>>0]|0)+w|0;v=v+e|0;if((v|0)>=(g|0)){C=z;break}else w=z}}else C=u;p[t+(B<<3)>>3]=+(C+x|0);B=B+1|0}while((B|0)!=(e|0))}while(0);r=r+1|0}while((r|0)!=(d|0));return}function JT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=(g|0)==(e|0);i=e<<1;j=e<<2;k=g-j|0;l=(i|0)>(k|0);m=e*3|0;o=f[a+16>>2]|0;p=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;q=f[f[b+44>>2]>>2]|0;b=(i|0)<(g|0);r=0;do{s=o+(Y(p,r)|0)|0;t=a+(Y(q,r)|0)|0;a:do if(c){u=0;do{n[t+(u<<2)>>2]=+(h[s+u>>0]|0);u=u+1|0}while((u|0)!=(e|0))}else{if(l){u=0;while(1){v=h[s+u>>0]|0;w=h[s+(u+e)>>0]|0;if(b){x=v;y=i;while(1){z=(h[s+(y+u)>>0]|0)+x|0;y=y+e|0;if((y|0)>=(g|0)){A=z;break}else x=z}}else A=v;n[t+(u<<2)>>2]=+(A+w|0);u=u+1|0;if((u|0)==(e|0))break a}}else B=0;do{u=h[s+B>>0]|0;x=h[s+(B+e)>>0]|0;y=i;do{z=y+B|0;u=(h[s+z>>0]|0)+u+(h[s+(z+i)>>0]|0)|0;x=(h[s+(z+e)>>0]|0)+x+(h[s+(z+m)>>0]|0)|0;y=y+j|0}while((y|0)<=(k|0));if((y|0)<(g|0)){w=u;v=y;while(1){z=(h[s+(v+B)>>0]|0)+w|0;v=v+e|0;if((v|0)>=(g|0)){C=z;break}else w=z}}else C=u;n[t+(B<<2)>>2]=+(C+x|0);B=B+1|0}while((B|0)!=(e|0))}while(0);r=r+1|0}while((r|0)!=(d|0));return}function KT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=(g|0)==(e|0);i=e<<1;j=e<<2;k=g-j|0;l=(i|0)>(k|0);m=e*3|0;n=f[a+16>>2]|0;o=f[a+44>>2]|0;a=f[b+16>>2]|0;p=f[b+44>>2]|0;b=(i|0)<(g|0);q=0;do{r=n+(Y(f[o>>2]|0,q)|0)|0;s=a+(Y(f[p>>2]|0,q)|0)|0;a:do if(c){t=0;do{f[s+(t<<2)>>2]=h[r+t>>0];t=t+1|0}while((t|0)!=(e|0))}else{if(l){t=0;while(1){u=h[r+t>>0]|0;v=h[r+(t+e)>>0]|0;if(b){w=u;x=i;while(1){y=(h[r+(x+t)>>0]|0)+w|0;x=x+e|0;if((x|0)>=(g|0)){z=y;break}else w=y}}else z=u;f[s+(t<<2)>>2]=z+v;t=t+1|0;if((t|0)==(e|0))break a}}else A=0;do{t=h[r+A>>0]|0;w=h[r+(A+e)>>0]|0;x=i;do{y=x+A|0;t=(h[r+y>>0]|0)+t+(h[r+(y+i)>>0]|0)|0;w=(h[r+(y+e)>>0]|0)+w+(h[r+(y+m)>>0]|0)|0;x=x+j|0}while((x|0)<=(k|0));if((x|0)<(g|0)){v=t;u=x;while(1){y=(h[r+(u+A)>>0]|0)+v|0;u=u+e|0;if((u|0)>=(g|0)){B=y;break}else v=y}}else B=t;f[s+(A<<2)>>2]=B+w;A=A+1|0}while((A|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function LT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0.0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>264){j=OYa(h>>>0>1073741823?-1:h<<2)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>2;a=(h|0)>0;if(a){m=0;do{f[k+(m<<2)>>2]=f[b+(m<<2)>>2];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){o=m;p=b;while(1){p=p+(l<<2)|0;if(a){q=0;do{r=k+(q<<2)|0;s=+n[r>>2];t=+n[p+(q<<2)>>2];n[r>>2]=t<s?t:s;q=q+1|0}while((q|0)!=(h|0))}o=o+-1|0;if(!o)break a}}o=h&-4;p=(o|0)<(h|0);q=m;r=b;do{r=r+(l<<2)|0;v=0;do{w=k+(v<<2)|0;s=+n[w>>2];t=+n[r+(v<<2)>>2];x=v|1;y=k+(x<<2)|0;z=+n[y>>2];A=+n[r+(x<<2)>>2];n[w>>2]=t<s?t:s;n[y>>2]=A<z?A:z;y=v|2;w=k+(y<<2)|0;z=+n[w>>2];A=+n[r+(y<<2)>>2];y=v|3;x=k+(y<<2)|0;s=+n[x>>2];t=+n[r+(y<<2)>>2];n[w>>2]=A<z?A:z;n[x>>2]=t<s?t:s;v=v+4|0}while((v|0)<=(g|0));if(p){v=o;do{x=k+(v<<2)|0;s=+n[x>>2];t=+n[r+(v<<2)>>2];n[x>>2]=t<s?t:s;v=v+1|0}while((v|0)!=(h|0))}q=q+-1|0}while((q|0)!=0)}while(0);if(a){a=0;do{f[j+(a<<2)>>2]=f[k+(a<<2)>>2];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}QYa(k);f[d>>2]=e;f[i>>2]=264;u=c;return}function MT(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+1056|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>520){k=OYa(i>>>0>2147483647?-1:i<<1)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){n=0;do{d[l+(n<<1)>>1]=d[b+(n<<1)>>1]|0;n=n+1|0}while((n|0)!=(i|0))}n=h+-1|0;a:do if(n|0){h=i+-4|0;if((i|0)<4){o=n;p=b;while(1){p=p+(m<<1)|0;if(a){q=0;do{r=l+(q<<1)|0;s=d[r>>1]|0;t=d[p+(q<<1)>>1]|0;d[r>>1]=t<<16>>16<s<<16>>16?t:s;q=q+1|0}while((q|0)!=(i|0))}o=o+-1|0;if(!o)break a}}o=i&-4;p=(o|0)<(i|0);q=n;s=b;do{s=s+(m<<1)|0;t=0;do{r=l+(t<<1)|0;v=d[r>>1]|0;w=d[s+(t<<1)>>1]|0;x=t|1;y=l+(x<<1)|0;z=d[y>>1]|0;A=d[s+(x<<1)>>1]|0;d[r>>1]=w<<16>>16<v<<16>>16?w:v;d[y>>1]=A<<16>>16<z<<16>>16?A:z;z=t|2;A=l+(z<<1)|0;y=d[A>>1]|0;v=d[s+(z<<1)>>1]|0;z=t|3;w=l+(z<<1)|0;r=d[w>>1]|0;x=d[s+(z<<1)>>1]|0;d[A>>1]=v<<16>>16<y<<16>>16?v:y;d[w>>1]=x<<16>>16<r<<16>>16?x:r;t=t+4|0}while((t|0)<=(h|0));if(p){t=o;do{r=l+(t<<1)|0;x=d[r>>1]|0;w=d[s+(t<<1)>>1]|0;d[r>>1]=w<<16>>16<x<<16>>16?w:x;t=t+1|0}while((t|0)!=(i|0))}q=q+-1|0}while((q|0)!=0)}while(0);if(a){a=0;do{d[k+(a<<1)>>1]=d[l+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}QYa(l);f[e>>2]=g;f[j>>2]=520;u=c;return}function NT(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+1056|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>520){k=OYa(i>>>0>2147483647?-1:i<<1)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){n=0;do{d[l+(n<<1)>>1]=d[b+(n<<1)>>1]|0;n=n+1|0}while((n|0)!=(i|0))}n=h+-1|0;a:do if(n|0){h=i+-4|0;if((i|0)<4){o=n;p=b;while(1){p=p+(m<<1)|0;if(a){q=0;do{r=l+(q<<1)|0;s=d[r>>1]|0;t=d[p+(q<<1)>>1]|0;d[r>>1]=(t&65535)<(s&65535)?t:s;q=q+1|0}while((q|0)!=(i|0))}o=o+-1|0;if(!o)break a}}o=i&-4;p=(o|0)<(i|0);q=n;s=b;do{s=s+(m<<1)|0;t=0;do{r=l+(t<<1)|0;v=d[r>>1]|0;w=d[s+(t<<1)>>1]|0;x=t|1;y=l+(x<<1)|0;z=d[y>>1]|0;A=d[s+(x<<1)>>1]|0;d[r>>1]=(w&65535)<(v&65535)?w:v;d[y>>1]=(A&65535)<(z&65535)?A:z;z=t|2;A=l+(z<<1)|0;y=d[A>>1]|0;v=d[s+(z<<1)>>1]|0;z=t|3;w=l+(z<<1)|0;r=d[w>>1]|0;x=d[s+(z<<1)>>1]|0;d[A>>1]=(v&65535)<(y&65535)?v:y;d[w>>1]=(x&65535)<(r&65535)?x:r;t=t+4|0}while((t|0)<=(h|0));if(p){t=o;do{r=l+(t<<1)|0;x=d[r>>1]|0;w=d[s+(t<<1)>>1]|0;d[r>>1]=(w&65535)<(x&65535)?w:x;t=t+1|0}while((t|0)!=(i|0))}q=q+-1|0}while((q|0)!=0)}while(0);if(a){a=0;do{d[k+(a<<1)>>1]=d[l+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}QYa(l);f[e>>2]=g;f[j>>2]=520;u=c;return}function OT(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+1040|0;e=d;g=f[a+40>>2]|0;i=f[g>>2]|0;j=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;k=e+4|0;f[k>>2]=j;if(j>>>0>1032){l=OYa(j)|0;f[e>>2]=l;m=l}else m=g;l=f[c+16>>2]|0;c=f[a+16>>2]|0;n=f[a+48>>2]|0;a=(j|0)>0;if(a){o=0;do{b[m+o>>0]=b[c+o>>0]|0;o=o+1|0}while((o|0)!=(j|0))}o=i+-1|0;a:do if(o|0){i=j+-4|0;if((j|0)<4){p=o;q=c;while(1){q=q+n|0;if(a){r=0;do{s=m+r|0;t=h[s>>0]|0;b[s>>0]=t-(h[199495+((t|256)-(h[q+r>>0]|0))>>0]|0);r=r+1|0}while((r|0)!=(j|0))}p=p+-1|0;if(!p)break a}}p=j&-4;q=(p|0)<(j|0);r=o;t=c;do{t=t+n|0;s=0;do{v=m+s|0;w=h[v>>0]|0;x=s|1;y=m+x|0;z=h[y>>0]|0;A=z-(h[199495+((z|256)-(h[t+x>>0]|0))>>0]|0)&255;b[v>>0]=w-(h[199495+((w|256)-(h[t+s>>0]|0))>>0]|0);b[y>>0]=A;A=s|2;y=m+A|0;w=h[y>>0]|0;v=s|3;x=m+v|0;z=h[x>>0]|0;B=z-(h[199495+((z|256)-(h[t+v>>0]|0))>>0]|0)&255;b[y>>0]=w-(h[199495+((w|256)-(h[t+A>>0]|0))>>0]|0);b[x>>0]=B;s=s+4|0}while((s|0)<=(i|0));if(q){s=p;do{B=m+s|0;x=h[B>>0]|0;b[B>>0]=x-(h[199495+((x|256)-(h[t+s>>0]|0))>>0]|0);s=s+1|0}while((s|0)!=(j|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{b[l+a>>0]=b[m+a>>0]|0;a=a+1|0}while((a|0)!=(j|0));C=f[e>>2]|0}else C=m;if((C|0)==(g|0)){u=d;return}if(C|0)QYa(C);f[e>>2]=g;f[k>>2]=1032;u=d;return}function PT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0.0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>264){j=OYa(h>>>0>1073741823?-1:h<<2)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>2;a=(h|0)>0;if(a){m=0;do{f[k+(m<<2)>>2]=f[b+(m<<2)>>2];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){o=m;p=b;while(1){p=p+(l<<2)|0;if(a){q=0;do{r=k+(q<<2)|0;s=+n[r>>2];t=+n[p+(q<<2)>>2];n[r>>2]=s<t?t:s;q=q+1|0}while((q|0)!=(h|0))}o=o+-1|0;if(!o)break a}}o=h&-4;p=(o|0)<(h|0);q=m;r=b;do{r=r+(l<<2)|0;v=0;do{w=k+(v<<2)|0;s=+n[w>>2];t=+n[r+(v<<2)>>2];x=v|1;y=k+(x<<2)|0;z=+n[y>>2];A=+n[r+(x<<2)>>2];n[w>>2]=s<t?t:s;n[y>>2]=z<A?A:z;y=v|2;w=k+(y<<2)|0;z=+n[w>>2];A=+n[r+(y<<2)>>2];y=v|3;x=k+(y<<2)|0;s=+n[x>>2];t=+n[r+(y<<2)>>2];n[w>>2]=z<A?A:z;n[x>>2]=s<t?t:s;v=v+4|0}while((v|0)<=(g|0));if(p){v=o;do{x=k+(v<<2)|0;s=+n[x>>2];t=+n[r+(v<<2)>>2];n[x>>2]=s<t?t:s;v=v+1|0}while((v|0)!=(h|0))}q=q+-1|0}while((q|0)!=0)}while(0);if(a){a=0;do{f[j+(a<<2)>>2]=f[k+(a<<2)>>2];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}QYa(k);f[d>>2]=e;f[i>>2]=264;u=c;return}function QT(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+1056|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>520){k=OYa(i>>>0>2147483647?-1:i<<1)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){n=0;do{d[l+(n<<1)>>1]=d[b+(n<<1)>>1]|0;n=n+1|0}while((n|0)!=(i|0))}n=h+-1|0;a:do if(n|0){h=i+-4|0;if((i|0)<4){o=n;p=b;while(1){p=p+(m<<1)|0;if(a){q=0;do{r=l+(q<<1)|0;s=d[r>>1]|0;t=d[p+(q<<1)>>1]|0;d[r>>1]=s<<16>>16<t<<16>>16?t:s;q=q+1|0}while((q|0)!=(i|0))}o=o+-1|0;if(!o)break a}}o=i&-4;p=(o|0)<(i|0);q=n;s=b;do{s=s+(m<<1)|0;t=0;do{r=l+(t<<1)|0;v=d[r>>1]|0;w=d[s+(t<<1)>>1]|0;x=t|1;y=l+(x<<1)|0;z=d[y>>1]|0;A=d[s+(x<<1)>>1]|0;d[r>>1]=v<<16>>16<w<<16>>16?w:v;d[y>>1]=z<<16>>16<A<<16>>16?A:z;z=t|2;A=l+(z<<1)|0;y=d[A>>1]|0;v=d[s+(z<<1)>>1]|0;z=t|3;w=l+(z<<1)|0;r=d[w>>1]|0;x=d[s+(z<<1)>>1]|0;d[A>>1]=y<<16>>16<v<<16>>16?v:y;d[w>>1]=r<<16>>16<x<<16>>16?x:r;t=t+4|0}while((t|0)<=(h|0));if(p){t=o;do{r=l+(t<<1)|0;x=d[r>>1]|0;w=d[s+(t<<1)>>1]|0;d[r>>1]=x<<16>>16<w<<16>>16?w:x;t=t+1|0}while((t|0)!=(i|0))}q=q+-1|0}while((q|0)!=0)}while(0);if(a){a=0;do{d[k+(a<<1)>>1]=d[l+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}QYa(l);f[e>>2]=g;f[j>>2]=520;u=c;return}function RT(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+1056|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>520){k=OYa(i>>>0>2147483647?-1:i<<1)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){n=0;do{d[l+(n<<1)>>1]=d[b+(n<<1)>>1]|0;n=n+1|0}while((n|0)!=(i|0))}n=h+-1|0;a:do if(n|0){h=i+-4|0;if((i|0)<4){o=n;p=b;while(1){p=p+(m<<1)|0;if(a){q=0;do{r=l+(q<<1)|0;s=d[r>>1]|0;t=d[p+(q<<1)>>1]|0;d[r>>1]=(s&65535)<(t&65535)?t:s;q=q+1|0}while((q|0)!=(i|0))}o=o+-1|0;if(!o)break a}}o=i&-4;p=(o|0)<(i|0);q=n;s=b;do{s=s+(m<<1)|0;t=0;do{r=l+(t<<1)|0;v=d[r>>1]|0;w=d[s+(t<<1)>>1]|0;x=t|1;y=l+(x<<1)|0;z=d[y>>1]|0;A=d[s+(x<<1)>>1]|0;d[r>>1]=(v&65535)<(w&65535)?w:v;d[y>>1]=(z&65535)<(A&65535)?A:z;z=t|2;A=l+(z<<1)|0;y=d[A>>1]|0;v=d[s+(z<<1)>>1]|0;z=t|3;w=l+(z<<1)|0;r=d[w>>1]|0;x=d[s+(z<<1)>>1]|0;d[A>>1]=(y&65535)<(v&65535)?v:y;d[w>>1]=(r&65535)<(x&65535)?x:r;t=t+4|0}while((t|0)<=(h|0));if(p){t=o;do{r=l+(t<<1)|0;x=d[r>>1]|0;w=d[s+(t<<1)>>1]|0;d[r>>1]=(x&65535)<(w&65535)?w:x;t=t+1|0}while((t|0)!=(i|0))}q=q+-1|0}while((q|0)!=0)}while(0);if(a){a=0;do{d[k+(a<<1)>>1]=d[l+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}QYa(l);f[e>>2]=g;f[j>>2]=520;u=c;return}function ST(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+1040|0;e=d;g=f[a+40>>2]|0;i=f[g>>2]|0;j=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;k=e+4|0;f[k>>2]=j;if(j>>>0>1032){l=OYa(j)|0;f[e>>2]=l;m=l}else m=g;l=f[c+16>>2]|0;c=f[a+16>>2]|0;n=f[a+48>>2]|0;a=(j|0)>0;if(a){o=0;do{b[m+o>>0]=b[c+o>>0]|0;o=o+1|0}while((o|0)!=(j|0))}o=i+-1|0;a:do if(o|0){i=j+-4|0;if((j|0)<4){p=o;q=c;while(1){q=q+n|0;if(a){r=0;do{s=m+r|0;t=h[s>>0]|0;b[s>>0]=(h[199495+(256-t+(h[q+r>>0]|0))>>0]|0)+t;r=r+1|0}while((r|0)!=(j|0))}p=p+-1|0;if(!p)break a}}p=j&-4;q=(p|0)<(j|0);r=o;t=c;do{t=t+n|0;s=0;do{v=m+s|0;w=h[v>>0]|0;x=s|1;y=m+x|0;z=h[y>>0]|0;A=(h[199495+(256-z+(h[t+x>>0]|0))>>0]|0)+z&255;b[v>>0]=(h[199495+(256-w+(h[t+s>>0]|0))>>0]|0)+w;b[y>>0]=A;A=s|2;y=m+A|0;w=h[y>>0]|0;v=s|3;z=m+v|0;x=h[z>>0]|0;B=(h[199495+(256-x+(h[t+v>>0]|0))>>0]|0)+x&255;b[y>>0]=(h[199495+(256-w+(h[t+A>>0]|0))>>0]|0)+w;b[z>>0]=B;s=s+4|0}while((s|0)<=(i|0));if(q){s=p;do{B=m+s|0;z=h[B>>0]|0;b[B>>0]=(h[199495+(256-z+(h[t+s>>0]|0))>>0]|0)+z;s=s+1|0}while((s|0)!=(j|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{b[l+a>>0]=b[m+a>>0]|0;a=a+1|0}while((a|0)!=(j|0));C=f[e>>2]|0}else C=m;if((C|0)==(g|0)){u=d;return}if(C|0)QYa(C);f[e>>2]=g;f[k>>2]=1032;u=d;return}function TT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+1104|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>136){j=OYa(h>>>0>536870911?-1:h<<3)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>2;a=(h|0)>0;if(a){m=0;do{p[k+(m<<3)>>3]=+n[b+(m<<2)>>2];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){o=m;q=b;while(1){q=q+(l<<2)|0;if(a){r=0;do{s=k+(r<<3)|0;p[s>>3]=+p[s>>3]+ +n[q+(r<<2)>>2];r=r+1|0}while((r|0)!=(h|0))}o=o+-1|0;if(!o)break a}}o=h&-4;q=(o|0)<(h|0);r=m;s=b;do{s=s+(l<<2)|0;t=0;do{v=k+(t<<3)|0;w=t|1;x=k+(w<<3)|0;y=+p[x>>3]+ +n[s+(w<<2)>>2];p[v>>3]=+p[v>>3]+ +n[s+(t<<2)>>2];p[x>>3]=y;x=t|2;v=k+(x<<3)|0;w=t|3;z=k+(w<<3)|0;y=+p[z>>3]+ +n[s+(w<<2)>>2];p[v>>3]=+p[v>>3]+ +n[s+(x<<2)>>2];p[z>>3]=y;t=t+4|0}while((t|0)<=(g|0));if(q){t=o;do{z=k+(t<<3)|0;p[z>>3]=+p[z>>3]+ +n[s+(t<<2)>>2];t=t+1|0}while((t|0)!=(h|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{p[j+(a<<3)>>3]=+p[k+(a<<3)>>3];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}QYa(k);f[d>>2]=e;f[i>>2]=136;u=c;return}function UT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>264){j=OYa(h>>>0>1073741823?-1:h<<2)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>2;a=(h|0)>0;if(a){m=0;do{f[k+(m<<2)>>2]=f[b+(m<<2)>>2];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){o=m;p=b;while(1){p=p+(l<<2)|0;if(a){q=0;do{r=k+(q<<2)|0;n[r>>2]=+n[r>>2]+ +n[p+(q<<2)>>2];q=q+1|0}while((q|0)!=(h|0))}o=o+-1|0;if(!o)break a}}o=h&-4;p=(o|0)<(h|0);q=m;r=b;do{r=r+(l<<2)|0;s=0;do{t=k+(s<<2)|0;v=s|1;w=k+(v<<2)|0;x=+n[w>>2]+ +n[r+(v<<2)>>2];n[t>>2]=+n[t>>2]+ +n[r+(s<<2)>>2];n[w>>2]=x;w=s|2;t=k+(w<<2)|0;v=s|3;y=k+(v<<2)|0;x=+n[y>>2]+ +n[r+(v<<2)>>2];n[t>>2]=+n[t>>2]+ +n[r+(w<<2)>>2];n[y>>2]=x;s=s+4|0}while((s|0)<=(g|0));if(p){s=o;do{y=k+(s<<2)|0;n[y>>2]=+n[y>>2]+ +n[r+(s<<2)>>2];s=s+1|0}while((s|0)!=(h|0))}q=q+-1|0}while((q|0)!=0)}while(0);if(a){a=0;do{f[j+(a<<2)>>2]=f[k+(a<<2)>>2];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}QYa(k);f[d>>2]=e;f[i>>2]=264;u=c;return}function VT(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+1104|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>136){k=OYa(i>>>0>536870911?-1:i<<3)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){n=0;do{p[l+(n<<3)>>3]=+(d[b+(n<<1)>>1]|0);n=n+1|0}while((n|0)!=(i|0))}n=h+-1|0;a:do if(n|0){h=i+-4|0;if((i|0)<4){o=n;q=b;while(1){q=q+(m<<1)|0;if(a){r=0;do{s=l+(r<<3)|0;p[s>>3]=+p[s>>3]+ +(d[q+(r<<1)>>1]|0);r=r+1|0}while((r|0)!=(i|0))}o=o+-1|0;if(!o)break a}}o=i&-4;q=(o|0)<(i|0);r=n;s=b;do{s=s+(m<<1)|0;t=0;do{v=l+(t<<3)|0;w=t|1;x=l+(w<<3)|0;y=+p[x>>3]+ +(d[s+(w<<1)>>1]|0);p[v>>3]=+p[v>>3]+ +(d[s+(t<<1)>>1]|0);p[x>>3]=y;x=t|2;v=l+(x<<3)|0;w=t|3;z=l+(w<<3)|0;y=+p[z>>3]+ +(d[s+(w<<1)>>1]|0);p[v>>3]=+p[v>>3]+ +(d[s+(x<<1)>>1]|0);p[z>>3]=y;t=t+4|0}while((t|0)<=(h|0));if(q){t=o;do{z=l+(t<<3)|0;p[z>>3]=+p[z>>3]+ +(d[s+(t<<1)>>1]|0);t=t+1|0}while((t|0)!=(i|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{p[k+(a<<3)>>3]=+p[l+(a<<3)>>3];a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}QYa(l);f[e>>2]=g;f[j>>2]=136;u=c;return}function WT(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+1072|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>264){k=OYa(i>>>0>1073741823?-1:i<<2)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){o=0;do{n[l+(o<<2)>>2]=+(d[b+(o<<1)>>1]|0);o=o+1|0}while((o|0)!=(i|0))}o=h+-1|0;a:do if(o|0){h=i+-4|0;if((i|0)<4){p=o;q=b;while(1){q=q+(m<<1)|0;if(a){r=0;do{s=l+(r<<2)|0;n[s>>2]=+n[s>>2]+ +(d[q+(r<<1)>>1]|0);r=r+1|0}while((r|0)!=(i|0))}p=p+-1|0;if(!p)break a}}p=i&-4;q=(p|0)<(i|0);r=o;s=b;do{s=s+(m<<1)|0;t=0;do{v=l+(t<<2)|0;w=t|1;x=l+(w<<2)|0;y=+n[x>>2]+ +(d[s+(w<<1)>>1]|0);n[v>>2]=+n[v>>2]+ +(d[s+(t<<1)>>1]|0);n[x>>2]=y;x=t|2;v=l+(x<<2)|0;w=t|3;z=l+(w<<2)|0;y=+n[z>>2]+ +(d[s+(w<<1)>>1]|0);n[v>>2]=+n[v>>2]+ +(d[s+(x<<1)>>1]|0);n[z>>2]=y;t=t+4|0}while((t|0)<=(h|0));if(q){t=p;do{z=l+(t<<2)|0;n[z>>2]=+n[z>>2]+ +(d[s+(t<<1)>>1]|0);t=t+1|0}while((t|0)!=(i|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{f[k+(a<<2)>>2]=f[l+(a<<2)>>2];a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}QYa(l);f[e>>2]=g;f[j>>2]=264;u=c;return}function XT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+1104|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>136){k=OYa(h>>>0>536870911?-1:h<<3)|0;f[d>>2]=k;l=k}else l=e;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(h|0)>0;if(a){n=0;do{p[l+(n<<3)>>3]=+(j[b+(n<<1)>>1]|0);n=n+1|0}while((n|0)!=(h|0))}n=g+-1|0;a:do if(n|0){g=h+-4|0;if((h|0)<4){o=n;q=b;while(1){q=q+(m<<1)|0;if(a){r=0;do{s=l+(r<<3)|0;p[s>>3]=+p[s>>3]+ +(j[q+(r<<1)>>1]|0);r=r+1|0}while((r|0)!=(h|0))}o=o+-1|0;if(!o)break a}}o=h&-4;q=(o|0)<(h|0);r=n;s=b;do{s=s+(m<<1)|0;t=0;do{v=l+(t<<3)|0;w=t|1;x=l+(w<<3)|0;y=+p[x>>3]+ +(j[s+(w<<1)>>1]|0);p[v>>3]=+p[v>>3]+ +(j[s+(t<<1)>>1]|0);p[x>>3]=y;x=t|2;v=l+(x<<3)|0;w=t|3;z=l+(w<<3)|0;y=+p[z>>3]+ +(j[s+(w<<1)>>1]|0);p[v>>3]=+p[v>>3]+ +(j[s+(x<<1)>>1]|0);p[z>>3]=y;t=t+4|0}while((t|0)<=(g|0));if(q){t=o;do{z=l+(t<<3)|0;p[z>>3]=+p[z>>3]+ +(j[s+(t<<1)>>1]|0);t=t+1|0}while((t|0)!=(h|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{p[k+(a<<3)>>3]=+p[l+(a<<3)>>3];a=a+1|0}while((a|0)!=(h|0))}if((l|0)==(e|0)){u=c;return}QYa(l);f[d>>2]=e;f[i>>2]=136;u=c;return}function YT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>264){k=OYa(h>>>0>1073741823?-1:h<<2)|0;f[d>>2]=k;l=k}else l=e;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(h|0)>0;if(a){o=0;do{n[l+(o<<2)>>2]=+(j[b+(o<<1)>>1]|0);o=o+1|0}while((o|0)!=(h|0))}o=g+-1|0;a:do if(o|0){g=h+-4|0;if((h|0)<4){p=o;q=b;while(1){q=q+(m<<1)|0;if(a){r=0;do{s=l+(r<<2)|0;n[s>>2]=+n[s>>2]+ +(j[q+(r<<1)>>1]|0);r=r+1|0}while((r|0)!=(h|0))}p=p+-1|0;if(!p)break a}}p=h&-4;q=(p|0)<(h|0);r=o;s=b;do{s=s+(m<<1)|0;t=0;do{v=l+(t<<2)|0;w=t|1;x=l+(w<<2)|0;y=+n[x>>2]+ +(j[s+(w<<1)>>1]|0);n[v>>2]=+n[v>>2]+ +(j[s+(t<<1)>>1]|0);n[x>>2]=y;x=t|2;v=l+(x<<2)|0;w=t|3;z=l+(w<<2)|0;y=+n[z>>2]+ +(j[s+(w<<1)>>1]|0);n[v>>2]=+n[v>>2]+ +(j[s+(x<<1)>>1]|0);n[z>>2]=y;t=t+4|0}while((t|0)<=(g|0));if(q){t=p;do{z=l+(t<<2)|0;n[z>>2]=+n[z>>2]+ +(j[s+(t<<1)>>1]|0);t=t+1|0}while((t|0)!=(h|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{f[k+(a<<2)>>2]=f[l+(a<<2)>>2];a=a+1|0}while((a|0)!=(h|0))}if((l|0)==(e|0)){u=c;return}QYa(l);f[d>>2]=e;f[i>>2]=264;u=c;return}function ZT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;j=d+4|0;f[j>>2]=i;if(i>>>0>264){k=OYa(i>>>0>1073741823?-1:i<<2)|0;f[d>>2]=k;l=k}else l=e;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=f[a+48>>2]|0;a=(i|0)>0;if(a){n=0;do{f[l+(n<<2)>>2]=h[b+n>>0];n=n+1|0}while((n|0)!=(i|0))}n=g+-1|0;a:do if(n|0){g=i+-4|0;if((i|0)<4){o=n;q=b;while(1){q=q+m|0;if(a){r=0;do{s=l+(r<<2)|0;f[s>>2]=(h[q+r>>0]|0)+(f[s>>2]|0);r=r+1|0}while((r|0)!=(i|0))}o=o+-1|0;if(!o)break a}}o=i&-4;q=(o|0)<(i|0);r=n;s=b;do{s=s+m|0;t=0;do{v=l+(t<<2)|0;w=t|1;x=l+(w<<2)|0;y=(h[s+w>>0]|0)+(f[x>>2]|0)|0;f[v>>2]=(h[s+t>>0]|0)+(f[v>>2]|0);f[x>>2]=y;y=t|2;x=l+(y<<2)|0;v=t|3;w=l+(v<<2)|0;z=(h[s+v>>0]|0)+(f[w>>2]|0)|0;f[x>>2]=(h[s+y>>0]|0)+(f[x>>2]|0);f[w>>2]=z;t=t+4|0}while((t|0)<=(g|0));if(q){t=o;do{z=l+(t<<2)|0;f[z>>2]=(h[s+t>>0]|0)+(f[z>>2]|0);t=t+1|0}while((t|0)!=(i|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{p[k+(a<<3)>>3]=+(f[l+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(e|0)){u=c;return}QYa(l);f[d>>2]=e;f[j>>2]=264;u=c;return}function _T(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;j=d+4|0;f[j>>2]=i;if(i>>>0>264){k=OYa(i>>>0>1073741823?-1:i<<2)|0;f[d>>2]=k;l=k}else l=e;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=f[a+48>>2]|0;a=(i|0)>0;if(a){o=0;do{f[l+(o<<2)>>2]=h[b+o>>0];o=o+1|0}while((o|0)!=(i|0))}o=g+-1|0;a:do if(o|0){g=i+-4|0;if((i|0)<4){p=o;q=b;while(1){q=q+m|0;if(a){r=0;do{s=l+(r<<2)|0;f[s>>2]=(h[q+r>>0]|0)+(f[s>>2]|0);r=r+1|0}while((r|0)!=(i|0))}p=p+-1|0;if(!p)break a}}p=i&-4;q=(p|0)<(i|0);r=o;s=b;do{s=s+m|0;t=0;do{v=l+(t<<2)|0;w=t|1;x=l+(w<<2)|0;y=(h[s+w>>0]|0)+(f[x>>2]|0)|0;f[v>>2]=(h[s+t>>0]|0)+(f[v>>2]|0);f[x>>2]=y;y=t|2;x=l+(y<<2)|0;v=t|3;w=l+(v<<2)|0;z=(h[s+v>>0]|0)+(f[w>>2]|0)|0;f[x>>2]=(h[s+y>>0]|0)+(f[x>>2]|0);f[w>>2]=z;t=t+4|0}while((t|0)<=(g|0));if(q){t=p;do{z=l+(t<<2)|0;f[z>>2]=(h[s+t>>0]|0)+(f[z>>2]|0);t=t+1|0}while((t|0)!=(i|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{n[k+(a<<2)>>2]=+(f[l+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(e|0)){u=c;return}QYa(l);f[d>>2]=e;f[j>>2]=264;u=c;return}function $T(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;j=d+4|0;f[j>>2]=i;if(i>>>0>264){k=OYa(i>>>0>1073741823?-1:i<<2)|0;f[d>>2]=k;l=k}else l=e;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=f[a+48>>2]|0;a=(i|0)>0;if(a){n=0;do{f[l+(n<<2)>>2]=h[b+n>>0];n=n+1|0}while((n|0)!=(i|0))}n=g+-1|0;a:do if(n|0){g=i+-4|0;if((i|0)<4){o=n;p=b;while(1){p=p+m|0;if(a){q=0;do{r=l+(q<<2)|0;f[r>>2]=(h[p+q>>0]|0)+(f[r>>2]|0);q=q+1|0}while((q|0)!=(i|0))}o=o+-1|0;if(!o)break a}}o=i&-4;p=(o|0)<(i|0);q=n;r=b;do{r=r+m|0;s=0;do{t=l+(s<<2)|0;v=s|1;w=l+(v<<2)|0;x=(h[r+v>>0]|0)+(f[w>>2]|0)|0;f[t>>2]=(h[r+s>>0]|0)+(f[t>>2]|0);f[w>>2]=x;x=s|2;w=l+(x<<2)|0;t=s|3;v=l+(t<<2)|0;y=(h[r+t>>0]|0)+(f[v>>2]|0)|0;f[w>>2]=(h[r+x>>0]|0)+(f[w>>2]|0);f[v>>2]=y;s=s+4|0}while((s|0)<=(g|0));if(p){s=o;do{y=l+(s<<2)|0;f[y>>2]=(h[r+s>>0]|0)+(f[y>>2]|0);s=s+1|0}while((s|0)!=(i|0))}q=q+-1|0}while((q|0)!=0)}while(0);if(a){a=0;do{f[k+(a<<2)>>2]=f[l+(a<<2)>>2];a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(e|0)){u=c;return}QYa(l);f[d>>2]=e;f[j>>2]=264;u=c;return}function aU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;rR(a,b,c,0,d);return}function bU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;rR(a,b,0,c,d);return}function cU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){F1a(g|0,0,b<<2|0)|0;f[e>>2]=g+(b<<2);return}h=f[a>>2]|0;i=g-h|0;g=i>>2;j=g+b|0;if(j>>>0>1073741823)gXa(a);k=d-h|0;d=k>>1;l=k>>2>>>0<536870911?(d>>>0<j>>>0?j:d):1073741823;do if(l)if(l>>>0>1073741823){d=De(8)|0;UYa(d,358155);f[d>>2]=130560;Of(d|0,21520,875)}else{m=NYa(l<<2)|0;break}else m=0;while(0);d=m+(g<<2)|0;F1a(d|0,0,b<<2|0)|0;j=d+(0-g<<2)|0;if((i|0)>0)K1a(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<2);f[c>>2]=m+(l<<2);if(!h)return;PYa(h);return}function dU(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0.0,f=0.0,g=0.0,h=0.0,i=0.0,j=0,k=0.0;c=+n[a+16>>2]*3.141592653589793/180.0;d=+O(+c)*.5;e=+P(+c)*.5;c=+n[a+12>>2];f=e*c;g=+n[a+8>>2];h=d*g;i=+n[a>>2]-f-h;n[b>>2]=i;j=a+4|0;k=d*c;c=e*g;g=k+ +n[j>>2]-c;n[b+4>>2]=g;e=f+ +n[a>>2]-h;n[b+8>>2]=e;h=+n[j>>2]-k-c;n[b+12>>2]=h;n[b+16>>2]=+n[a>>2]*2.0-i;n[b+20>>2]=+n[j>>2]*2.0-g;n[b+24>>2]=+n[a>>2]*2.0-e;n[b+28>>2]=+n[j>>2]*2.0-h;return}function eU(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0.0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0,p=0,q=0;c=+n[b+16>>2]*3.141592653589793/180.0;d=+O(+c)*.5;e=+P(+c)*.5;c=+n[b>>2];g=+n[b+12>>2];h=e*g;i=+n[b+8>>2];j=d*i;k=c-h-j;l=+n[b+4>>2];m=d*g;g=e*i;i=m+l-g;e=h+c-j;j=l-m-g;g=c*2.0;c=g-k;m=l*2.0;l=m-i;h=g-e;g=m-j;m=e<k?e:k;d=c<m?c:m;m=h<d?h:d;b=~~m;o=b-(+(b|0)>m&1)|0;m=j<i?j:i;d=l<m?l:m;m=g<d?g:d;b=~~m;p=b-(+(b|0)>m&1)|0;m=k<e?e:k;k=m<c?c:m;m=k<h?h:k;b=~~m;k=i<j?j:i;i=k<l?l:k;k=i<g?g:i;q=~~k;f[a>>2]=o;f[a+4>>2]=p;f[a+8>>2]=(+(b|0)<m&1)+b+1-o;f[a+12>>2]=1-p+((+(q|0)<k&1)+q);return}function fU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,t=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=u;u=u+48|0;d=c+16|0;e=c+12|0;g=c+8|0;h=c+4|0;i=c;j=+n[b+16>>2]*3.141592653589793/180.0;k=+O(+j)*.5;l=+P(+j)*.5;j=+n[b>>2];m=+n[b+12>>2];o=l*m;p=+n[b+8>>2];q=k*p;r=j-o-q;n[d>>2]=r;t=+n[b+4>>2];v=k*m;m=l*p;p=v+t-m;b=d+4|0;n[b>>2]=p;l=o+j-q;w=d+8|0;n[w>>2]=l;q=t-v-m;x=d+12|0;n[x>>2]=q;m=j*2.0;j=m-r;y=d+16|0;n[y>>2]=j;v=t*2.0;t=v-p;z=d+20|0;n[z>>2]=t;o=m-l;A=d+24|0;n[A>>2]=o;m=v-q;B=d+28|0;n[B>>2]=m;C=l<r?w:d;D=j<+n[C>>2]?y:C;C=f[(o<+n[D>>2]?A:D)>>2]|0;D=q<p?x:b;E=t<+n[D>>2]?z:D;D=f[(m<+n[E>>2]?B:E)>>2]|0;f[e>>2]=C;f[g>>2]=D;E=r<l?w:d;d=+n[E>>2]<j?y:E;E=f[(+n[d>>2]<o?A:d)>>2]|0;d=p<q?x:b;b=+n[d>>2]<t?z:d;d=f[(+n[b>>2]<m?B:b)>>2]|0;f[h>>2]=E;f[i>>2]=d;m=(f[s>>2]=E,+n[s>>2]);t=(f[s>>2]=C,+n[s>>2]);C=f[(m<t?h:e)>>2]|0;f[a>>2]=C;q=(f[s>>2]=d,+n[s>>2]);p=(f[s>>2]=D,+n[s>>2]);D=f[(q<p?i:g)>>2]|0;f[a+4>>2]=D;n[a+8>>2]=(t<m?m:t)-(f[s>>2]=C,+n[s>>2]);n[a+12>>2]=(p<q?q:p)-(f[s>>2]=D,+n[s>>2]);u=c;return}function gU(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h;_$(i,42356);j=hU(a,b,c,d,e,g)|0;if(!(f[i+4>>2]|0)){u=h;return j|0}u=h;return j|0}function hU(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0;h=b>>>2;b=e>>>2;e=(c|0)>0;a:do if(e){i=(d|0)==0;j=i|(g|0)<1;k=i|(g|0)<1;i=0;l=1;while(1){m=i;i=i+1|0;o=(i|0)<(c|0);if(o){p=i;q=m;while(1){r=a+((Y(p,h)|0)+m<<2)|0;s=+L(+(+n[r>>2]));r=a+((Y(q,h)|0)+m<<2)|0;t=s>+L(+(+n[r>>2]));r=t?p:q;p=p+1|0;if((p|0)==(c|0)){u=r;break}else q=r}}else u=m;q=Y(u,h)|0;if(+L(+(+n[a+(q+m<<2)>>2]))<1.1920928955078125e-06){v=0;break}if((u|0)==(m|0))w=l;else{p=Y(m,h)|0;r=m;do{t=a+(r+p<<2)|0;x=a+(r+q<<2)|0;y=f[t>>2]|0;f[t>>2]=f[x>>2];f[x>>2]=y;r=r+1|0}while((r|0)!=(c|0));if(!k){r=Y(m,b)|0;q=Y(u,b)|0;p=0;do{y=d+(p+r<<2)|0;x=d+(p+q<<2)|0;t=f[y>>2]|0;f[y>>2]=f[x>>2];f[x>>2]=t;p=p+1|0}while((p|0)!=(g|0))}w=0-l|0}p=Y(m,h)|0;s=-1.0/+n[a+(p+m<<2)>>2];if(!o){z=w;break a}q=Y(m,b)|0;r=i;do{t=Y(r,h)|0;A=s*+n[a+(t+m<<2)>>2];x=i;do{y=a+(x+t<<2)|0;n[y>>2]=+n[y>>2]+A*+n[a+(x+p<<2)>>2];x=x+1|0}while((x|0)!=(c|0));if(!j){x=Y(r,b)|0;t=0;do{y=d+(t+x<<2)|0;n[y>>2]=+n[y>>2]+A*+n[d+(t+q<<2)>>2];t=t+1|0}while((t|0)!=(g|0))}r=r+1|0}while((r|0)!=(c|0));if(!o){z=w;break a}else l=w}return v|0}else z=1;while(0);if(e&(d|0)!=0&(g|0)>0)B=c;else{v=z;return v|0}do{e=B;B=B+-1|0;w=Y(B,b)|0;u=Y(B,h)|0;l=a+(u+B<<2)|0;if((e|0)<(c|0)){j=0;do{i=d+(j+w<<2)|0;k=e;s=+n[i>>2];do{r=d+((Y(k,b)|0)+j<<2)|0;s=s-+n[a+(k+u<<2)>>2]*+n[r>>2];k=k+1|0}while((k|0)!=(c|0));n[i>>2]=s/+n[l>>2];j=j+1|0}while((j|0)!=(g|0))}else{j=0;do{u=d+(j+w<<2)|0;n[u>>2]=+n[u>>2]/+n[l>>2];j=j+1|0}while((j|0)!=(g|0))}}while((e|0)>1);v=z;return v|0}function iU(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h;_$(i,42376);j=jU(a,b,c,d,e,g)|0;if(!(f[i+4>>2]|0)){u=h;return j|0}u=h;return j|0}function jU(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0;g=b>>>3;b=e>>>3;e=(c|0)>0;a:do if(e){h=(d|0)==0;i=h|(f|0)<1;j=h|(f|0)<1;h=0;k=1;while(1){l=h;h=h+1|0;m=(h|0)<(c|0);if(m){n=h;o=l;while(1){q=a+((Y(n,g)|0)+l<<3)|0;r=+L(+(+p[q>>3]));q=a+((Y(o,g)|0)+l<<3)|0;s=r>+L(+(+p[q>>3]));q=s?n:o;n=n+1|0;if((n|0)==(c|0)){t=q;break}else o=q}}else t=l;o=Y(t,g)|0;if(+L(+(+p[a+(o+l<<3)>>3]))<2.220446049250313e-14){u=0;break}if((t|0)==(l|0))v=k;else{n=Y(l,g)|0;q=l;do{s=a+(q+n<<3)|0;w=a+(q+o<<3)|0;r=+p[s>>3];p[s>>3]=+p[w>>3];p[w>>3]=r;q=q+1|0}while((q|0)!=(c|0));if(!j){q=Y(l,b)|0;o=Y(t,b)|0;n=0;do{w=d+(n+q<<3)|0;s=d+(n+o<<3)|0;r=+p[w>>3];p[w>>3]=+p[s>>3];p[s>>3]=r;n=n+1|0}while((n|0)!=(f|0))}v=0-k|0}n=Y(l,g)|0;r=-1.0/+p[a+(n+l<<3)>>3];if(!m){x=v;break a}o=Y(l,b)|0;q=h;do{s=Y(q,g)|0;y=r*+p[a+(s+l<<3)>>3];w=h;do{z=a+(w+s<<3)|0;p[z>>3]=+p[z>>3]+y*+p[a+(w+n<<3)>>3];w=w+1|0}while((w|0)!=(c|0));if(!i){w=Y(q,b)|0;s=0;do{z=d+(s+w<<3)|0;p[z>>3]=+p[z>>3]+y*+p[d+(s+o<<3)>>3];s=s+1|0}while((s|0)!=(f|0))}q=q+1|0}while((q|0)!=(c|0));if(!m){x=v;break a}else k=v}return u|0}else x=1;while(0);if(e&(d|0)!=0&(f|0)>0)A=c;else{u=x;return u|0}do{e=A;A=A+-1|0;v=Y(A,b)|0;t=Y(A,g)|0;k=a+(t+A<<3)|0;if((e|0)<(c|0)){i=0;do{h=d+(i+v<<3)|0;j=e;r=+p[h>>3];do{q=d+((Y(j,b)|0)+i<<3)|0;r=r-+p[a+(j+t<<3)>>3]*+p[q>>3];j=j+1|0}while((j|0)!=(c|0));p[h>>3]=r/+p[k>>3];i=i+1|0}while((i|0)!=(f|0))}else{i=0;do{t=d+(i+v<<3)|0;p[t>>3]=+p[t>>3]/+p[k>>3];i=i+1|0}while((i|0)!=(f|0))}}while((e|0)>1);u=x;return u|0}function kU(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h;_$(i,42396);j=lU(a,b,c,d,e,g)|0;if(!(f[i+4>>2]|0)){u=h;return j|0}u=h;return j|0}function lU(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0;g=b>>>2;b=e>>>2;e=(c|0)>0;a:do if(e){h=0;while(1){i=(h|0)>0;j=Y(h,g)|0;if(i){k=0;do{l=a+(k+j<<2)|0;m=+n[l>>2];o=Y(k,g)|0;if((k|0)>0){p=0;q=m;while(1){r=q-+n[a+(p+j<<2)>>2]*+n[a+(p+o<<2)>>2];p=p+1|0;if((p|0)==(k|0)){s=r;break}else q=r}}else s=m;n[l>>2]=s*+n[a+(o+k<<2)>>2];k=k+1|0}while((k|0)!=(h|0));k=a+(j+h<<2)|0;q=+n[k>>2];if(i){p=0;r=q;while(1){t=+n[a+(p+j<<2)>>2];u=r-t*t;p=p+1|0;if((p|0)==(h|0)){v=k;w=u;break}else r=u}}else{v=k;w=q}}else{p=a+(j+h<<2)|0;v=p;w=+n[p>>2]}if(w<1.1920928955078125e-07){x=0;break}r=1.0/+M(+w);n[v>>2]=r;h=h+1|0;if((h|0)>=(c|0))break a}return x|0}while(0);if(!d){if(e)y=0;else{x=1;return x|0}do{v=a+((Y(y,g)|0)+y<<2)|0;n[v>>2]=1.0/+n[v>>2];y=y+1|0}while((y|0)!=(c|0));x=1;return x|0}if(!e){x=1;return x|0}if((f|0)>0){y=0;do{v=Y(y,b)|0;h=Y(y,g)|0;p=a+(h+y<<2)|0;if((y|0)>0){i=0;do{z=d+(i+v<<2)|0;A=0;w=+n[z>>2];do{B=d+((Y(A,b)|0)+i<<2)|0;w=w-+n[a+(A+h<<2)>>2]*+n[B>>2];A=A+1|0}while((A|0)!=(y|0));n[z>>2]=w*+n[p>>2];i=i+1|0}while((i|0)!=(f|0))}else{i=0;do{h=d+(i+v<<2)|0;n[h>>2]=+n[h>>2]*+n[p>>2];i=i+1|0}while((i|0)!=(f|0))}y=y+1|0}while((y|0)!=(c|0));y=c+-1|0;if(!e){x=1;return x|0}if((f|0)>0){i=y;while(1){p=Y(i,b)|0;v=a+((Y(i,g)|0)+i<<2)|0;if((y|0)>(i|0)){h=0;do{A=d+(h+p<<2)|0;j=y;q=+n[A>>2];do{k=a+((Y(j,g)|0)+i<<2)|0;B=d+((Y(j,b)|0)+h<<2)|0;q=q-+n[k>>2]*+n[B>>2];j=j+-1|0}while((j|0)>(i|0));n[A>>2]=q*+n[v>>2];h=h+1|0}while((h|0)!=(f|0))}else{h=0;do{j=d+(h+p<<2)|0;n[j>>2]=+n[j>>2]*+n[v>>2];h=h+1|0}while((h|0)!=(f|0))}if((i|0)>0)i=i+-1|0;else break}if(!e){x=1;return x|0}else C=0}else C=0}else C=0;do{e=a+((Y(C,g)|0)+C<<2)|0;n[e>>2]=1.0/+n[e>>2];C=C+1|0}while((C|0)!=(c|0));x=1;return x|0}function mU(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h;_$(i,42416);j=nU(a,b,c,d,e,g)|0;if(!(f[i+4>>2]|0)){u=h;return j|0}u=h;return j|0}function nU(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0,o=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0;g=b>>>3;b=e>>>3;e=(c|0)>0;a:do if(e){h=0;while(1){i=(h|0)>0;j=Y(h,g)|0;if(i){k=0;do{l=a+(k+j<<3)|0;m=+p[l>>3];n=Y(k,g)|0;if((k|0)>0){o=0;q=m;while(1){r=q-+p[a+(o+j<<3)>>3]*+p[a+(o+n<<3)>>3];o=o+1|0;if((o|0)==(k|0)){s=r;break}else q=r}}else s=m;p[l>>3]=s*+p[a+(n+k<<3)>>3];k=k+1|0}while((k|0)!=(h|0));k=a+(j+h<<3)|0;q=+p[k>>3];if(i){o=0;r=q;while(1){t=+p[a+(o+j<<3)>>3];u=r-t*t;o=o+1|0;if((o|0)==(h|0)){v=k;w=u;break}else r=u}}else{v=k;w=q}}else{o=a+(j+h<<3)|0;v=o;w=+p[o>>3]}if(w<2.220446049250313e-16){x=0;break}r=1.0/+M(+w);p[v>>3]=r;h=h+1|0;if((h|0)>=(c|0))break a}return x|0}while(0);if(!d){if(e)y=0;else{x=1;return x|0}do{v=a+((Y(y,g)|0)+y<<3)|0;p[v>>3]=1.0/+p[v>>3];y=y+1|0}while((y|0)!=(c|0));x=1;return x|0}if(!e){x=1;return x|0}if((f|0)>0){y=0;do{v=Y(y,b)|0;h=Y(y,g)|0;o=a+(h+y<<3)|0;if((y|0)>0){i=0;do{z=d+(i+v<<3)|0;A=0;w=+p[z>>3];do{B=d+((Y(A,b)|0)+i<<3)|0;w=w-+p[a+(A+h<<3)>>3]*+p[B>>3];A=A+1|0}while((A|0)!=(y|0));p[z>>3]=w*+p[o>>3];i=i+1|0}while((i|0)!=(f|0))}else{i=0;do{h=d+(i+v<<3)|0;p[h>>3]=+p[h>>3]*+p[o>>3];i=i+1|0}while((i|0)!=(f|0))}y=y+1|0}while((y|0)!=(c|0));y=c+-1|0;if(!e){x=1;return x|0}if((f|0)>0){i=y;while(1){o=Y(i,b)|0;v=a+((Y(i,g)|0)+i<<3)|0;if((y|0)>(i|0)){h=0;do{A=d+(h+o<<3)|0;j=y;q=+p[A>>3];do{k=a+((Y(j,g)|0)+i<<3)|0;B=d+((Y(j,b)|0)+h<<3)|0;q=q-+p[k>>3]*+p[B>>3];j=j+-1|0}while((j|0)>(i|0));p[A>>3]=q*+p[v>>3];h=h+1|0}while((h|0)!=(f|0))}else{h=0;do{j=d+(h+o<<3)|0;p[j>>3]=+p[j>>3]*+p[v>>3];h=h+1|0}while((h|0)!=(f|0))}if((i|0)>0)i=i+-1|0;else break}if(!e){x=1;return x|0}else C=0}else C=0}else C=0;do{e=a+((Y(C,g)|0)+C<<3)|0;p[e>>3]=1.0/+p[e>>3];C=C+1|0}while((C|0)!=(c|0));x=1;return x|0}function oU(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;j=u;u=u+1072|0;k=j+8|0;l=j;_$(l,42436);m=b>>>2;b=h>>>2;h=k+8|0;f[k>>2]=h;o=k+4|0;p=(c|0)==0?(i|0)!=0&1:d+c|0;f[o>>2]=p;if(p>>>0>264){q=OYa(p>>>0>1073741823?-1:p<<2)|0;f[k>>2]=q;r=q}else r=h;q=(i|0)==0?r+(c<<2)|0:i;a:do if((d|0)>0){i=c;p=0;while(1){s=c-p|0;t=(s|0)>0;if(t){v=0;w=0.0;while(1){x=a+((Y(v+p|0,m)|0)+p<<2)|0;y=+n[x>>2];n[r+(v<<2)>>2]=y;z=w+y*y;v=v+1|0;if((v|0)==(i|0)){A=z;break}else w=z}}else A=0.0;w=+n[r>>2];z=w+ +M(+A)*(!(w>=0.0)?-1.0:1.0);n[r>>2]=z;y=+M(+(A+z*z-w*w));if(t?(n[r>>2]=z/y,(i|0)!=1):0){v=1;do{x=r+(v<<2)|0;n[x>>2]=+n[x>>2]/y;v=v+1|0}while((v|0)!=(i|0))}if((p|0)<(c|0)){v=p;do{t=p;y=0.0;do{x=a+((Y(t,m)|0)+v<<2)|0;y=y+ +n[r+(t-p<<2)>>2]*+n[x>>2];t=t+1|0}while((t|0)!=(c|0));B=p;do{t=a+((Y(B,m)|0)+v<<2)|0;n[t>>2]=+n[t>>2]-y*(+n[r+(B-p<<2)>>2]*2.0);B=B+1|0}while((B|0)!=(c|0));v=v+1|0}while((v|0)!=(d|0))}y=+n[r>>2];n[q+(p<<2)>>2]=y*y;if((s|0)>1){y=+n[r>>2];v=1;do{t=a+((Y(v+p|0,m)|0)+p<<2)|0;n[t>>2]=+n[r+(v<<2)>>2]/y;v=v+1|0}while((v|0)!=(i|0))}p=p+1|0;if((p|0)==(d|0))break;else i=i+-1|0}if(g){i=(e|0)>0;if(i){p=c;v=0;while(1){n[r>>2]=1.0;if((c-v|0)>1){s=1;do{t=a+((Y(s+v|0,m)|0)+v<<2)|0;f[r+(s<<2)>>2]=f[t>>2];s=s+1|0}while((s|0)!=(p|0))}s=q+(v<<2)|0;if((v|0)<(c|0)){t=0;do{x=v;y=0.0;do{C=g+((Y(x,b)|0)+t<<2)|0;y=y+ +n[r+(x-v<<2)>>2]*+n[C>>2];x=x+1|0}while((x|0)!=(c|0));D=v;do{x=g+((Y(D,b)|0)+t<<2)|0;n[x>>2]=+n[x>>2]-+n[s>>2]*(y*(+n[r+(D-v<<2)>>2]*2.0));D=D+1|0}while((D|0)!=(c|0));t=t+1|0}while((t|0)!=(e|0))}v=v+1|0;if((v|0)==(d|0))break;else p=p+-1|0}}else{p=c;v=0;while(1){n[r>>2]=1.0;if((c-v|0)>1){t=1;do{s=a+((Y(t+v|0,m)|0)+v<<2)|0;f[r+(t<<2)>>2]=f[s>>2];t=t+1|0}while((t|0)!=(p|0))}v=v+1|0;if((v|0)==(d|0))break;else p=p+-1|0}}p=d+-1|0;if(!i){v=p;while(1){t=a+((Y(v,m)|0)+v<<2)|0;if(+L(+(+n[t>>2]))<1.1920928955078125e-06){E=0;break a}if((v|0)>0)v=v+-1|0;else{E=1;break a}}}if((e|0)==1){v=p;while(1){i=Y(v,m)|0;if((p|0)>(v|0)){t=g+((Y(v,b)|0)<<2)|0;s=p;do{x=g+((Y(s,b)|0)<<2)|0;n[t>>2]=+n[t>>2]-+n[x>>2]*+n[a+(s+i<<2)>>2];s=s+-1|0}while((s|0)>(v|0))}y=+n[a+(i+v<<2)>>2];if(+L(+y)<1.1920928955078125e-06){E=0;break a}s=g+((Y(v,b)|0)<<2)|0;n[s>>2]=+n[s>>2]/y;if((v|0)>0)v=v+-1|0;else{E=1;break a}}}else F=p;while(1){v=Y(F,m)|0;if((p|0)>(F|0)){s=Y(F,b)|0;t=p;do{x=Y(t,b)|0;C=a+(t+v<<2)|0;G=0;do{H=g+(G+s<<2)|0;n[H>>2]=+n[H>>2]-+n[g+(G+x<<2)>>2]*+n[C>>2];G=G+1|0}while((G|0)!=(e|0));t=t+-1|0}while((t|0)>(F|0))}t=a+(v+F<<2)|0;y=+n[t>>2];if(+L(+y)<1.1920928955078125e-06){E=0;break a}s=Y(F,b)|0;i=g+(s<<2)|0;n[i>>2]=+n[i>>2]/y;i=1;do{G=g+(i+s<<2)|0;n[G>>2]=+n[G>>2]/+n[t>>2];i=i+1|0}while((i|0)!=(e|0));if((F|0)>0)F=F+-1|0;else{E=1;break}}}else E=1}else E=1;while(0);if((r|0)!=(h|0)){QYa(r);f[k>>2]=h;f[o>>2]=264}if(!(f[l+4>>2]|0)){u=j;return E|0}u=j;return E|0}function pU(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;j=u;u=u+1104|0;k=j;l=j+1096|0;_$(l,42456);m=b>>>3;b=h>>>3;h=k+8|0;f[k>>2]=h;n=k+4|0;o=(c|0)==0?(i|0)!=0&1:d+c|0;f[n>>2]=o;if(o>>>0>136){q=OYa(o>>>0>536870911?-1:o<<3)|0;f[k>>2]=q;r=q}else r=h;q=(i|0)==0?r+(c<<3)|0:i;a:do if((d|0)>0){i=c;o=0;while(1){s=c-o|0;t=(s|0)>0;if(t){v=0;w=0.0;while(1){x=a+((Y(v+o|0,m)|0)+o<<3)|0;y=+p[x>>3];p[r+(v<<3)>>3]=y;z=w+y*y;v=v+1|0;if((v|0)==(i|0)){A=z;break}else w=z}}else A=0.0;w=+p[r>>3];z=w+ +M(+A)*(!(w>=0.0)?-1.0:1.0);p[r>>3]=z;y=+M(+(A+z*z-w*w));if(t?(p[r>>3]=z/y,(i|0)!=1):0){v=1;do{x=r+(v<<3)|0;p[x>>3]=+p[x>>3]/y;v=v+1|0}while((v|0)!=(i|0))}if((o|0)<(c|0)){v=o;do{t=o;y=0.0;do{x=a+((Y(t,m)|0)+v<<3)|0;y=y+ +p[r+(t-o<<3)>>3]*+p[x>>3];t=t+1|0}while((t|0)!=(c|0));B=o;do{t=a+((Y(B,m)|0)+v<<3)|0;p[t>>3]=+p[t>>3]-y*(+p[r+(B-o<<3)>>3]*2.0);B=B+1|0}while((B|0)!=(c|0));v=v+1|0}while((v|0)!=(d|0))}y=+p[r>>3];p[q+(o<<3)>>3]=y*y;if((s|0)>1){y=+p[r>>3];v=1;do{t=a+((Y(v+o|0,m)|0)+o<<3)|0;p[t>>3]=+p[r+(v<<3)>>3]/y;v=v+1|0}while((v|0)!=(i|0))}o=o+1|0;if((o|0)==(d|0))break;else i=i+-1|0}if(g){i=(e|0)>0;if(i){o=c;v=0;while(1){p[r>>3]=1.0;if((c-v|0)>1){s=1;do{t=a+((Y(s+v|0,m)|0)+v<<3)|0;p[r+(s<<3)>>3]=+p[t>>3];s=s+1|0}while((s|0)!=(o|0))}s=q+(v<<3)|0;if((v|0)<(c|0)){t=0;do{x=v;y=0.0;do{C=g+((Y(x,b)|0)+t<<3)|0;y=y+ +p[r+(x-v<<3)>>3]*+p[C>>3];x=x+1|0}while((x|0)!=(c|0));D=v;do{x=g+((Y(D,b)|0)+t<<3)|0;p[x>>3]=+p[x>>3]-+p[s>>3]*(y*(+p[r+(D-v<<3)>>3]*2.0));D=D+1|0}while((D|0)!=(c|0));t=t+1|0}while((t|0)!=(e|0))}v=v+1|0;if((v|0)==(d|0))break;else o=o+-1|0}}else{o=c;v=0;while(1){p[r>>3]=1.0;if((c-v|0)>1){t=1;do{s=a+((Y(t+v|0,m)|0)+v<<3)|0;p[r+(t<<3)>>3]=+p[s>>3];t=t+1|0}while((t|0)!=(o|0))}v=v+1|0;if((v|0)==(d|0))break;else o=o+-1|0}}o=d+-1|0;if(!i){v=o;while(1){t=a+((Y(v,m)|0)+v<<3)|0;if(+L(+(+p[t>>3]))<2.220446049250313e-14){E=0;break a}if((v|0)>0)v=v+-1|0;else{E=1;break a}}}if((e|0)==1){v=o;while(1){i=Y(v,m)|0;if((o|0)>(v|0)){t=g+((Y(v,b)|0)<<3)|0;s=o;do{x=g+((Y(s,b)|0)<<3)|0;p[t>>3]=+p[t>>3]-+p[x>>3]*+p[a+(s+i<<3)>>3];s=s+-1|0}while((s|0)>(v|0))}y=+p[a+(i+v<<3)>>3];if(+L(+y)<2.220446049250313e-14){E=0;break a}s=g+((Y(v,b)|0)<<3)|0;p[s>>3]=+p[s>>3]/y;if((v|0)>0)v=v+-1|0;else{E=1;break a}}}else F=o;while(1){v=Y(F,m)|0;if((o|0)>(F|0)){s=Y(F,b)|0;t=o;do{x=Y(t,b)|0;C=a+(t+v<<3)|0;G=0;do{H=g+(G+s<<3)|0;p[H>>3]=+p[H>>3]-+p[g+(G+x<<3)>>3]*+p[C>>3];G=G+1|0}while((G|0)!=(e|0));t=t+-1|0}while((t|0)>(F|0))}t=a+(v+F<<3)|0;y=+p[t>>3];if(+L(+y)<2.220446049250313e-14){E=0;break a}s=Y(F,b)|0;i=g+(s<<3)|0;p[i>>3]=+p[i>>3]/y;i=1;do{G=g+(i+s<<3)|0;p[G>>3]=+p[G>>3]/+p[t>>3];i=i+1|0}while((i|0)!=(e|0));if((F|0)>0)F=F+-1|0;else{E=1;break}}}else E=1}else E=1;while(0);if((r|0)!=(h|0)){QYa(r);f[k>>2]=h;f[n>>2]=136}if(!(f[l+4>>2]|0)){u=j;return E|0}u=j;return E|0}function qU(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=(e|0)%4|0;h=(g|0)==0?4:g;g=f[a>>2]|0;a:do if((h|0)==1)if((d|0)>0){i=0;j=0;while(1){b[c+j>>0]=b[g+i>>0]|0;i=i+1|0;if((i|0)==(d|0))break;else j=j+e|0}}else return;else{j=f[a+4>>2]|0;if((h|0)==2)if((d|0)>0){i=0;k=0;while(1){b[c+k>>0]=b[g+i>>0]|0;b[c+(k+1)>>0]=b[j+i>>0]|0;i=i+1|0;if((i|0)==(d|0))break a;else k=k+e|0}}else return;k=f[a+8>>2]|0;if((h|0)==3)if((d|0)>0){i=0;l=0;while(1){b[c+l>>0]=b[g+i>>0]|0;b[c+(l+1)>>0]=b[j+i>>0]|0;b[c+(l+2)>>0]=b[k+i>>0]|0;i=i+1|0;if((i|0)==(d|0))break;else l=l+e|0}}else return;else{l=f[a+12>>2]|0;if((d|0)>0){i=0;m=0;while(1){b[c+m>>0]=b[g+i>>0]|0;b[c+(m+1)>>0]=b[j+i>>0]|0;b[c+(m+2)>>0]=b[k+i>>0]|0;b[c+(m+3)>>0]=b[l+i>>0]|0;i=i+1|0;if((i|0)==(d|0))break;else m=m+e|0}}else return}}while(0);if((d|0)>0&(h|0)<(e|0))n=h;else return;do{h=f[a+(n<<2)>>2]|0;g=f[a+(n+1<<2)>>2]|0;m=f[a+(n+2<<2)>>2]|0;i=f[a+(n+3<<2)>>2]|0;l=0;k=n;while(1){b[c+k>>0]=b[h+l>>0]|0;b[c+(k+1)>>0]=b[g+l>>0]|0;b[c+(k+2)>>0]=b[m+l>>0]|0;b[c+(k+3)>>0]=b[i+l>>0]|0;l=l+1|0;if((l|0)==(d|0))break;else k=k+e|0}n=n+4|0}while((n|0)<(e|0));return}function rU(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=(e|0)%4|0;h=(g|0)==0?4:g;g=f[a>>2]|0;a:do if((h|0)==1)if((c|0)>0){i=0;j=0;while(1){d[b+(j<<1)>>1]=d[g+(i<<1)>>1]|0;i=i+1|0;if((i|0)==(c|0))break;else j=j+e|0}}else return;else{j=f[a+4>>2]|0;if((h|0)==2)if((c|0)>0){i=0;k=0;while(1){d[b+(k<<1)>>1]=d[g+(i<<1)>>1]|0;d[b+(k+1<<1)>>1]=d[j+(i<<1)>>1]|0;i=i+1|0;if((i|0)==(c|0))break a;else k=k+e|0}}else return;k=f[a+8>>2]|0;if((h|0)==3)if((c|0)>0){i=0;l=0;while(1){d[b+(l<<1)>>1]=d[g+(i<<1)>>1]|0;d[b+(l+1<<1)>>1]=d[j+(i<<1)>>1]|0;d[b+(l+2<<1)>>1]=d[k+(i<<1)>>1]|0;i=i+1|0;if((i|0)==(c|0))break;else l=l+e|0}}else return;else{l=f[a+12>>2]|0;if((c|0)>0){i=0;m=0;while(1){d[b+(m<<1)>>1]=d[g+(i<<1)>>1]|0;d[b+(m+1<<1)>>1]=d[j+(i<<1)>>1]|0;d[b+(m+2<<1)>>1]=d[k+(i<<1)>>1]|0;d[b+(m+3<<1)>>1]=d[l+(i<<1)>>1]|0;i=i+1|0;if((i|0)==(c|0))break;else m=m+e|0}}else return}}while(0);if((c|0)>0&(h|0)<(e|0))n=h;else return;do{h=f[a+(n<<2)>>2]|0;g=f[a+(n+1<<2)>>2]|0;m=f[a+(n+2<<2)>>2]|0;i=f[a+(n+3<<2)>>2]|0;l=0;k=n;while(1){d[b+(k<<1)>>1]=d[h+(l<<1)>>1]|0;d[b+(k+1<<1)>>1]=d[g+(l<<1)>>1]|0;d[b+(k+2<<1)>>1]=d[m+(l<<1)>>1]|0;d[b+(k+3<<1)>>1]=d[i+(l<<1)>>1]|0;l=l+1|0;if((l|0)==(c|0))break;else k=k+e|0}n=n+4|0}while((n|0)<(e|0));return}function sU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=(d|0)%4|0;g=(e|0)==0?4:e;e=f[a>>2]|0;a:do if((g|0)==1)if((c|0)>0){h=0;i=0;while(1){f[b+(i<<2)>>2]=f[e+(h<<2)>>2];h=h+1|0;if((h|0)==(c|0))break;else i=i+d|0}}else return;else{i=f[a+4>>2]|0;if((g|0)==2)if((c|0)>0){h=0;j=0;while(1){f[b+(j<<2)>>2]=f[e+(h<<2)>>2];f[b+(j+1<<2)>>2]=f[i+(h<<2)>>2];h=h+1|0;if((h|0)==(c|0))break a;else j=j+d|0}}else return;j=f[a+8>>2]|0;if((g|0)==3)if((c|0)>0){h=0;k=0;while(1){f[b+(k<<2)>>2]=f[e+(h<<2)>>2];f[b+(k+1<<2)>>2]=f[i+(h<<2)>>2];f[b+(k+2<<2)>>2]=f[j+(h<<2)>>2];h=h+1|0;if((h|0)==(c|0))break;else k=k+d|0}}else return;else{k=f[a+12>>2]|0;if((c|0)>0){h=0;l=0;while(1){f[b+(l<<2)>>2]=f[e+(h<<2)>>2];f[b+(l+1<<2)>>2]=f[i+(h<<2)>>2];f[b+(l+2<<2)>>2]=f[j+(h<<2)>>2];f[b+(l+3<<2)>>2]=f[k+(h<<2)>>2];h=h+1|0;if((h|0)==(c|0))break;else l=l+d|0}}else return}}while(0);if((c|0)>0&(g|0)<(d|0))m=g;else return;do{g=f[a+(m<<2)>>2]|0;e=f[a+(m+1<<2)>>2]|0;l=f[a+(m+2<<2)>>2]|0;h=f[a+(m+3<<2)>>2]|0;k=0;j=m;while(1){f[b+(j<<2)>>2]=f[g+(k<<2)>>2];f[b+(j+1<<2)>>2]=f[e+(k<<2)>>2];f[b+(j+2<<2)>>2]=f[l+(k<<2)>>2];f[b+(j+3<<2)>>2]=f[h+(k<<2)>>2];k=k+1|0;if((k|0)==(c|0))break;else j=j+d|0}m=m+4|0}while((m|0)<(d|0));return}function tU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=(d|0)%4|0;g=(e|0)==0?4:e;e=f[a>>2]|0;a:do if((g|0)==1)if((c|0)>0){h=0;i=0;while(1){j=e+(h<<3)|0;k=f[j+4>>2]|0;l=b+(i<<3)|0;f[l>>2]=f[j>>2];f[l+4>>2]=k;h=h+1|0;if((h|0)==(c|0))break;else i=i+d|0}}else return;else{i=f[a+4>>2]|0;if((g|0)==2)if((c|0)>0){h=0;k=0;while(1){l=e+(h<<3)|0;j=f[l+4>>2]|0;m=b+(k<<3)|0;f[m>>2]=f[l>>2];f[m+4>>2]=j;j=i+(h<<3)|0;m=f[j+4>>2]|0;l=b+(k+1<<3)|0;f[l>>2]=f[j>>2];f[l+4>>2]=m;h=h+1|0;if((h|0)==(c|0))break a;else k=k+d|0}}else return;k=f[a+8>>2]|0;if((g|0)==3)if((c|0)>0){h=0;m=0;while(1){l=e+(h<<3)|0;j=f[l+4>>2]|0;n=b+(m<<3)|0;f[n>>2]=f[l>>2];f[n+4>>2]=j;j=i+(h<<3)|0;n=f[j+4>>2]|0;l=b+(m+1<<3)|0;f[l>>2]=f[j>>2];f[l+4>>2]=n;n=k+(h<<3)|0;l=f[n+4>>2]|0;j=b+(m+2<<3)|0;f[j>>2]=f[n>>2];f[j+4>>2]=l;h=h+1|0;if((h|0)==(c|0))break;else m=m+d|0}}else return;else{m=f[a+12>>2]|0;if((c|0)>0){h=0;l=0;while(1){j=e+(h<<3)|0;n=f[j+4>>2]|0;o=b+(l<<3)|0;f[o>>2]=f[j>>2];f[o+4>>2]=n;n=i+(h<<3)|0;o=f[n+4>>2]|0;j=b+(l+1<<3)|0;f[j>>2]=f[n>>2];f[j+4>>2]=o;o=k+(h<<3)|0;j=f[o+4>>2]|0;n=b+(l+2<<3)|0;f[n>>2]=f[o>>2];f[n+4>>2]=j;j=m+(h<<3)|0;n=f[j+4>>2]|0;o=b+(l+3<<3)|0;f[o>>2]=f[j>>2];f[o+4>>2]=n;h=h+1|0;if((h|0)==(c|0))break;else l=l+d|0}}else return}}while(0);if((c|0)>0&(g|0)<(d|0))p=g;else return;do{g=f[a+(p<<2)>>2]|0;e=f[a+(p+1<<2)>>2]|0;l=f[a+(p+2<<2)>>2]|0;h=f[a+(p+3<<2)>>2]|0;m=0;k=p;while(1){i=g+(m<<3)|0;n=f[i+4>>2]|0;o=b+(k<<3)|0;f[o>>2]=f[i>>2];f[o+4>>2]=n;n=e+(m<<3)|0;o=f[n+4>>2]|0;i=b+(k+1<<3)|0;f[i>>2]=f[n>>2];f[i+4>>2]=o;o=l+(m<<3)|0;i=f[o+4>>2]|0;n=b+(k+2<<3)|0;f[n>>2]=f[o>>2];f[n+4>>2]=i;i=h+(m<<3)|0;n=f[i+4>>2]|0;o=b+(k+3<<3)|0;f[o>>2]=f[i>>2];f[o+4>>2]=n;m=m+1|0;if((m|0)==(c|0))break;else k=k+d|0}p=p+4|0}while((p|0)<(d|0));return}function uU(){return 0}function vU(){var a=0,b=0,c=0,d=0;a=(y$(x$()|0)|0)+16|0;b=f[a>>2]|0;if((b|0)>=0){c=b;d=(c|0)>0;return d|0}f[a>>2]=0;c=0;d=(c|0)>0;return d|0}function wU(){var a=0,c=0,d=0;if((b[374984]|0)==0?u1a(374984)|0:0){a=NYa(4)|0;f[a>>2]=0;f[225392]=a}a=f[225392]|0;c=(y$(x$()|0)|0)+8|0;d=f[c>>2]|0;if((b[374992]|0)==0?u1a(374992)|0:0){f[225393]=0;Fd(938,901572,x|0)|0}c=f[a>>2]|0;if(!c)return 901572;else{a=f[c+8>>2]|0;return ((f[c+12>>2]|0)-a>>2>>>0>d>>>0?a+(d<<2)|0:901572)|0}return 0}function xU(a){a=a|0;var c=0;c=f[a>>2]|0;if(!c)return;a=f[c>>2]|0;f[c>>2]=a+-1;if((a|0)!=1|(b[5689203]|0)!=0)return;yU(c);PYa(c);return}function yU(a){a=a|0;var c=0,d=0,e=0;zU(a+88|0,f[a+92>>2]|0);d$(a+72|0);d$(a+64|0);c=a+24|0;if((b[c+11>>0]|0)>=0){d=a+16|0;d$(d);e=a+8|0;d$(e);return}PYa(f[c>>2]|0);d=a+16|0;d$(d);e=a+8|0;d$(e);return}function zU(a,c){a=a|0;c=c|0;if(!c)return;zU(a,f[c>>2]|0);zU(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)PYa(f[a>>2]|0);PYa(c);return}function AU(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=(c|0)==(a|0);b[c+12>>0]=d&1;if(d)return;else e=c;while(1){g=f[e+8>>2]|0;c=g+12|0;if(b[c>>0]|0){h=23;break}i=g+8|0;j=f[i>>2]|0;d=f[j>>2]|0;if((d|0)==(g|0)){k=f[j+4>>2]|0;if(!k){h=7;break}l=k+12|0;if(!(b[l>>0]|0))m=l;else{h=7;break}}else{if(!d){h=16;break}l=d+12|0;if(!(b[l>>0]|0))m=l;else{h=16;break}}b[c>>0]=1;c=(j|0)==(a|0);b[j+12>>0]=c&1;b[m>>0]=1;if(c){h=23;break}else e=j}if((h|0)==7){if((f[g>>2]|0)==(e|0)){n=g;o=j}else{m=g+4|0;a=f[m>>2]|0;c=f[a>>2]|0;f[m>>2]=c;if(!c)p=j;else{f[c+8>>2]=g;p=f[i>>2]|0}f[a+8>>2]=p;p=f[i>>2]|0;f[((f[p>>2]|0)==(g|0)?p:p+4|0)>>2]=a;f[a>>2]=g;f[i>>2]=a;n=a;o=f[a+8>>2]|0}b[n+12>>0]=1;b[o+12>>0]=0;n=f[o>>2]|0;a=n+4|0;p=f[a>>2]|0;f[o>>2]=p;if(p|0)f[p+8>>2]=o;p=o+8|0;f[n+8>>2]=f[p>>2];c=f[p>>2]|0;f[((f[c>>2]|0)==(o|0)?c:c+4|0)>>2]=n;f[a>>2]=o;f[p>>2]=n;return}else if((h|0)==16){if((f[g>>2]|0)==(e|0)){e=f[g>>2]|0;n=e+4|0;p=f[n>>2]|0;f[g>>2]=p;if(!p)q=j;else{f[p+8>>2]=g;q=f[i>>2]|0}f[e+8>>2]=q;q=f[i>>2]|0;f[((f[q>>2]|0)==(g|0)?q:q+4|0)>>2]=e;f[n>>2]=g;f[i>>2]=e;r=e;s=f[e+8>>2]|0}else{r=g;s=j}b[r+12>>0]=1;b[s+12>>0]=0;r=s+4|0;j=f[r>>2]|0;g=f[j>>2]|0;f[r>>2]=g;if(g|0)f[g+8>>2]=s;g=s+8|0;f[j+8>>2]=f[g>>2];r=f[g>>2]|0;f[((f[r>>2]|0)==(s|0)?r:r+4|0)>>2]=j;f[j>>2]=s;f[g>>2]=j;return}else if((h|0)==23)return}function BU(a){a=a|0;var b=0,c=0;b=f[a>>2]|0;if(!b){c=0;return c|0}c=f[b+80>>2]|0;return c|0}function CU(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=f[c>>2]|0;if(d){e=f[c+4>>2]|0;if(!e){g=d;h=c}else{d=e;while(1){e=f[d>>2]|0;if(!e){g=0;h=d;break}else d=e}}}else{g=0;h=c}d=h+4|0;e=f[(g|0?h:d)>>2]|0;g=(e|0)==0;i=h+8|0;if(!g)f[e+8>>2]=f[i>>2];j=f[i>>2]|0;if((f[j>>2]|0)==(h|0)){f[j>>2]=e;if((h|0)==(a|0)){k=e;l=0}else{m=j+4|0;n=10}}else{f[j+4>>2]=e;m=j;n=10}if((n|0)==10){k=a;l=f[m>>2]|0}m=h+12|0;a=(b[m>>0]|0)==0;if((h|0)==(c|0))o=k;else{j=c+8|0;p=f[j>>2]|0;f[i>>2]=p;f[((f[f[j>>2]>>2]|0)==(c|0)?p:p+4|0)>>2]=h;p=f[c>>2]|0;f[h>>2]=p;f[p+8>>2]=h;p=f[c+4>>2]|0;f[d>>2]=p;if(p|0)f[p+8>>2]=h;b[m>>0]=b[c+12>>0]|0;o=(k|0)==(c|0)?h:k}if(a|(o|0)==0)return;if(g){q=o;r=l}else{b[e+12>>0]=1;return}while(1){e=f[r+8>>2]|0;l=r+12|0;o=(b[l>>0]|0)!=0;if((f[e>>2]|0)==(r|0)){if(o){s=q;t=r}else{b[l>>0]=1;b[e+12>>0]=0;g=f[e>>2]|0;a=g+4|0;k=f[a>>2]|0;f[e>>2]=k;if(k|0)f[k+8>>2]=e;k=e+8|0;f[g+8>>2]=f[k>>2];h=f[k>>2]|0;f[((f[h>>2]|0)==(e|0)?h:h+4|0)>>2]=g;f[a>>2]=e;f[k>>2]=g;g=f[r+4>>2]|0;s=(q|0)==(g|0)?r:q;t=f[g>>2]|0}u=f[t>>2]|0;v=(u|0)==0;if(!v?(b[u+12>>0]|0)==0:0){n=50;break}g=f[t+4>>2]|0;if(g|0?(b[g+12>>0]|0)==0:0){n=49;break}b[t+12>>0]=0;g=f[t+8>>2]|0;w=g+12|0;if((g|0)==(s|0)|(b[w>>0]|0)==0){n=48;break}else{x=g;y=s}}else{if(o){z=q;A=r}else{b[l>>0]=1;b[e+12>>0]=0;l=e+4|0;o=f[l>>2]|0;g=f[o>>2]|0;f[l>>2]=g;if(g|0)f[g+8>>2]=e;g=e+8|0;f[o+8>>2]=f[g>>2];l=f[g>>2]|0;f[((f[l>>2]|0)==(e|0)?l:l+4|0)>>2]=o;f[o>>2]=e;f[g>>2]=o;o=f[r>>2]|0;z=(q|0)==(o|0)?r:q;A=f[o+4>>2]|0}B=f[A>>2]|0;if(B|0?(b[B+12>>0]|0)==0:0){n=31;break}o=f[A+4>>2]|0;if(o|0?(b[o+12>>0]|0)==0:0){C=o;n=32;break}b[A+12>>0]=0;o=f[A+8>>2]|0;if((o|0)==(z|0)){D=z;n=30;break}if(!(b[o+12>>0]|0)){D=o;n=30;break}else{x=o;y=z}}o=f[x+8>>2]|0;q=y;r=f[((f[o>>2]|0)==(x|0)?o+4|0:o)>>2]|0}if((n|0)==30){b[D+12>>0]=1;return}else if((n|0)==31){D=f[A+4>>2]|0;if(!D)n=33;else{C=D;n=32}}else if((n|0)==48){b[w>>0]=1;return}else if((n|0)==49)if(v)n=51;else n=50;if((n|0)==32)if(!(b[C+12>>0]|0)){E=C;F=A;n=36}else n=33;else if((n|0)==50)if(!(b[u+12>>0]|0)){G=u;H=t;n=54}else n=51;if((n|0)==33){b[B+12>>0]=1;b[A+12>>0]=0;u=B+4|0;C=f[u>>2]|0;f[A>>2]=C;if(C|0)f[C+8>>2]=A;C=A+8|0;f[B+8>>2]=f[C>>2];v=f[C>>2]|0;f[((f[v>>2]|0)==(A|0)?v:v+4|0)>>2]=B;f[u>>2]=A;f[C>>2]=B;E=A;F=B;n=36}else if((n|0)==51){B=t+4|0;A=f[B>>2]|0;b[A+12>>0]=1;b[t+12>>0]=0;C=f[A>>2]|0;f[B>>2]=C;if(C|0)f[C+8>>2]=t;C=t+8|0;f[A+8>>2]=f[C>>2];B=f[C>>2]|0;f[((f[B>>2]|0)==(t|0)?B:B+4|0)>>2]=A;f[A>>2]=t;f[C>>2]=A;G=t;H=A;n=54}if((n|0)==36){A=f[F+8>>2]|0;t=A+12|0;b[F+12>>0]=b[t>>0]|0;b[t>>0]=1;b[E+12>>0]=1;E=A+4|0;t=f[E>>2]|0;F=f[t>>2]|0;f[E>>2]=F;if(F|0)f[F+8>>2]=A;F=A+8|0;f[t+8>>2]=f[F>>2];E=f[F>>2]|0;f[((f[E>>2]|0)==(A|0)?E:E+4|0)>>2]=t;f[t>>2]=A;f[F>>2]=t;return}else if((n|0)==54){n=f[H+8>>2]|0;t=n+12|0;b[H+12>>0]=b[t>>0]|0;b[t>>0]=1;b[G+12>>0]=1;G=f[n>>2]|0;t=G+4|0;H=f[t>>2]|0;f[n>>2]=H;if(H|0)f[H+8>>2]=n;H=n+8|0;f[G+8>>2]=f[H>>2];F=f[H>>2]|0;f[((f[F>>2]|0)==(n|0)?F:F+4|0)>>2]=G;f[t>>2]=n;f[H>>2]=G;return}}function DU(a){a=a|0;var c=0;c=f[a>>2]|0;f[a>>2]=c+-1;if((c|0)!=1)return;if((a|0)==0|(b[5689203]|0)!=0)return;c=a+4|0;if(f[c>>2]|0)f[c>>2]=0;c=f[a+12>>2]|0;if(c|0)DU(c);PYa(a);return}function EU(a){a=a|0;f[a>>2]=0;return}function FU(a){a=a|0;var b=0;b=f[a>>2]|0;if(!b)return;DU(b);return}function GU(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+32|0;$Ya(d,c)|0;c=a+44|0;f[c>>2]=0;e=a+48|0;g=f[e>>2]|0;if(g&8|0){h=b[d+11>>0]|0;if(h<<24>>24<0){i=f[d>>2]|0;j=i;k=i;l=i+(f[a+36>>2]|0)|0}else{j=d;k=d;l=d+(h&255)|0}f[c>>2]=l;f[a+8>>2]=k;f[a+12>>2]=j;f[a+16>>2]=l}if(!(g&16))return;g=d+11|0;l=b[g>>0]|0;if(l<<24>>24<0){j=f[a+36>>2]|0;f[c>>2]=(f[d>>2]|0)+j;m=(f[a+40>>2]&2147483647)+-1|0;n=j}else{j=l&255;f[c>>2]=d+j;m=10;n=j}fZa(d,m,0);m=b[g>>0]|0;if(m<<24>>24<0){g=f[d>>2]|0;o=g;p=f[a+36>>2]|0;q=g}else{o=d;p=m&255;q=d}d=a+24|0;f[d>>2]=o;f[a+20>>2]=o;f[a+28>>2]=q+p;if(!(f[e>>2]&3))return;f[d>>2]=o+n;return}function HU(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+16|0;g=e+12|0;h=e;i=e+8|0;iPa(h,a);if(!(b[h>>0]|0)){jPa(h);u=e;return a|0}j=(f[a>>2]|0)+-12|0;f[i>>2]=f[a+(f[j>>2]|0)+24>>2];k=a+(f[j>>2]|0)|0;j=f[k+4>>2]|0;l=c+d|0;d=k+76|0;m=f[d>>2]|0;if((m|0)==-1){bPa(g,k);n=BQa(g,1975176)|0;o=$h[f[(f[n>>2]|0)+28>>2]&255](n,32)|0;CQa(g);n=o<<24>>24;f[d>>2]=n;p=n}else p=m;f[g>>2]=f[i>>2];if(KU(g,c,(j&176|0)==32?l:c,l,k,p&255)|0){jPa(h);u=e;return a|0}p=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;_Oa(p,f[p+16>>2]|5);jPa(h);u=e;return a|0}function IU(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=f[c+48>>2]|0;if(d&16|0){e=c+44|0;g=f[e>>2]|0;h=f[c+24>>2]|0;if(g>>>0<h>>>0){f[e>>2]=h;i=h}else i=g;g=f[c+20>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=i-g|0;if(h>>>0>4294967279)WYa(a);if(h>>>0<11){b[a+11>>0]=h;j=a}else{e=h+16&-16;k=NYa(e)|0;f[a>>2]=k;f[a+8>>2]=e|-2147483648;f[a+4>>2]=h;j=k}if((g|0)==(i|0))l=j;else{k=g;g=j;while(1){b[g>>0]=b[k>>0]|0;k=k+1|0;if((k|0)==(i|0))break;else g=g+1|0}l=j+h|0}b[l>>0]=0;return}if(!(d&8)){f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return}d=f[c+8>>2]|0;l=f[c+16>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=l-d|0;if(c>>>0>4294967279)WYa(a);if(c>>>0<11){b[a+11>>0]=c;m=a}else{h=c+16&-16;j=NYa(h)|0;f[a>>2]=j;f[a+8>>2]=h|-2147483648;f[a+4>>2]=c;m=j}if((d|0)==(l|0))n=m;else{j=d;d=m;while(1){b[d>>0]=b[j>>0]|0;j=j+1|0;if((j|0)==(l|0))break;else d=d+1|0}n=m+c|0}b[n>>0]=0;return}function JU(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=42488;c=a+56|0;f[c>>2]=42508;d=a+4|0;f[d>>2]=42524;e=a+36|0;if((b[e+11>>0]|0)<0)PYa(f[e>>2]|0);WNa(d);SOa(a,42584);RNa(c);return}function KU(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;i=u;u=u+16|0;j=i;k=f[a>>2]|0;if(!k){l=0;u=i;return l|0}m=e;e=c;n=m-e|0;o=g+12|0;g=f[o>>2]|0;p=(g|0)>(n|0)?g-n|0:0;n=d;g=n-e|0;if((g|0)>0?(ui[f[(f[k>>2]|0)+48>>2]&127](k,c,g)|0)!=(g|0):0){f[a>>2]=0;l=0;u=i;return l|0}if((p|0)>0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(p>>>0<11){g=j+11|0;b[g>>0]=p;q=j;r=j;s=g}else{g=p+16&-16;c=NYa(g)|0;f[j>>2]=c;f[j+8>>2]=g|-2147483648;f[j+4>>2]=p;q=j;r=c;s=j+11|0}F1a(r|0,h|0,p|0)|0;b[r+p>>0]=0;if((ui[f[(f[k>>2]|0)+48>>2]&127](k,(b[s>>0]|0)<0?f[q>>2]|0:j,p)|0)==(p|0)){t=k;v=1}else{f[a>>2]=0;t=0;v=0}if((b[s>>0]|0)<0)PYa(f[q>>2]|0);if(v)w=t;else{l=0;u=i;return l|0}}else w=k;k=m-n|0;if((k|0)>0?(ui[f[(f[w>>2]|0)+48>>2]&127](w,d,k)|0)!=(k|0):0){f[a>>2]=0;l=0;u=i;return l|0}f[o>>2]=0;l=w;u=i;return l|0}function LU(a){a=a|0;var c=0;f[a>>2]=42524;c=a+32|0;if((b[c+11>>0]|0)<0)PYa(f[c>>2]|0);WNa(a);return}function MU(a){a=a|0;var c=0;f[a>>2]=42524;c=a+32|0;if((b[c+11>>0]|0)<0)PYa(f[c>>2]|0);WNa(a);PYa(a);return}function NU(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;i=c+44|0;j=f[i>>2]|0;k=c+24|0;l=f[k>>2]|0;m=l;if(j>>>0<l>>>0){f[i>>2]=l;n=m}else n=j;j=h&24;a:do if((j|0)!=0?!((g|0)==1&(j|0)==24):0){b:do switch(g|0){case 0:{o=0;p=0;break}case 1:{if(!(h&8)){i=m-(f[c+20>>2]|0)|0;o=i;p=((i|0)<0)<<31>>31;break b}else{i=(f[c+12>>2]|0)-(f[c+8>>2]|0)|0;o=i;p=((i|0)<0)<<31>>31;break b}break}case 2:{i=c+32|0;if((b[i+11>>0]|0)<0)q=f[i>>2]|0;else q=i;i=n-q|0;o=i;p=((i|0)<0)<<31>>31;break}default:{r=-1;s=-1;break a}}while(0);i=C1a(o|0,p|0,d|0,e|0)|0;t=J;if((t|0)>=0){u=c+32|0;if((b[u+11>>0]|0)<0)v=f[u>>2]|0;else v=u;u=n-v|0;w=((u|0)<0)<<31>>31;if(!((w|0)<(t|0)|(w|0)==(t|0)&u>>>0<i>>>0)){u=h&8;if(!((i|0)==0&(t|0)==0)){if(u|0?(f[c+12>>2]|0)==0:0){r=-1;s=-1;break}if((h&16|0)!=0&(l|0)==0){r=-1;s=-1;break}}if(u|0){f[c+12>>2]=(f[c+8>>2]|0)+i;f[c+16>>2]=n}if(!(h&16)){r=i;s=t}else{f[k>>2]=(f[c+20>>2]|0)+i;r=i;s=t}}else{r=-1;s=-1}}else{r=-1;s=-1}}else{r=-1;s=-1}while(0);c=a;f[c>>2]=0;f[c+4>>2]=0;c=a+8|0;f[c>>2]=r;f[c+4>>2]=s;return}function OU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=c+8|0;bh[f[(f[b>>2]|0)+16>>2]&255](a,b,f[e>>2]|0,f[e+4>>2]|0,0,d);return}function PU(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,i=0;b=a+44|0;c=f[b>>2]|0;d=f[a+24>>2]|0;if(c>>>0<d>>>0){f[b>>2]=d;e=d}else e=c;if(!(f[a+48>>2]&8)){g=-1;return g|0}c=a+16|0;d=f[c>>2]|0;if(d>>>0<e>>>0){f[c>>2]=e;i=e}else i=d;d=f[a+12>>2]|0;if(d>>>0>=i>>>0){g=-1;return g|0}g=h[d>>0]|0;return g|0}function QU(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+44|0;e=f[d>>2]|0;g=f[a+24>>2]|0;if(e>>>0<g>>>0){f[d>>2]=g;h=g}else h=e;e=h;h=a+12|0;g=f[h>>2]|0;if((f[a+8>>2]|0)>>>0>=g>>>0){i=-1;return i|0}if((c|0)==-1){f[h>>2]=g+-1;f[a+16>>2]=e;i=0;return i|0}if(!(f[a+48>>2]&16)){d=c&255;j=g+-1|0;if(d<<24>>24==(b[j>>0]|0)){k=j;l=d}else{i=-1;return i|0}}else{k=g+-1|0;l=c&255}f[h>>2]=k;f[a+16>>2]=e;b[k>>0]=l;i=c;return i|0}function RU(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+16|0;e=d;if((c|0)==-1){g=0;u=d;return g|0}h=a+12|0;i=a+8|0;j=(f[h>>2]|0)-(f[i>>2]|0)|0;k=a+24|0;l=f[k>>2]|0;m=a+28|0;n=f[m>>2]|0;if((l|0)==(n|0)){o=a+48|0;if(!(f[o>>2]&16)){g=-1;u=d;return g|0}p=a+20|0;q=f[p>>2]|0;r=a+44|0;s=(f[r>>2]|0)-q|0;t=a+32|0;kZa(t,0);v=t+11|0;if((b[v>>0]|0)<0)w=(f[a+40>>2]&2147483647)+-1|0;else w=10;fZa(t,w,0);w=b[v>>0]|0;if(w<<24>>24<0){x=f[a+36>>2]|0;y=f[t>>2]|0}else{x=w&255;y=t}t=y+x|0;f[p>>2]=y;f[m>>2]=t;m=y+(l-q)|0;f[k>>2]=m;q=y+s|0;f[r>>2]=q;z=r;A=m;B=q;C=t;D=r;E=o}else{o=a+44|0;z=o;A=l;B=f[o>>2]|0;C=n;D=o;E=a+48|0}o=A+1|0;f[e>>2]=o;n=f[(o>>>0<B>>>0?D:e)>>2]|0;f[z>>2]=n;if(f[E>>2]&8|0){E=a+32|0;if((b[E+11>>0]|0)<0)F=f[E>>2]|0;else F=E;f[i>>2]=F;f[h>>2]=F+j;f[a+16>>2]=n}if((A|0)==(C|0)){g=$h[f[(f[a>>2]|0)+52>>2]&255](a,c&255)|0;u=d;return g|0}else{f[k>>2]=o;b[A>>0]=c;g=c&255;u=d;return g|0}return 0}function SU(a){a=a|0;JU(a);PYa(a);return}function TU(a){a=a|0;JU(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function UU(a){a=a|0;var b=0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;JU(b);PYa(b);return}function VU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)gXa(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;PYa(d);return}function WU(){var a=0,c=0,d=0;if(!(b[5689200]|0)){a=(Y$(177557,0)|0)&1;b[5689201]=a;b[5689200]=1;c=a;d=c<<24>>24!=0;return d|0}else{c=b[5689201]|0;d=c<<24>>24!=0;return d|0}return 0}function XU(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;h=u;u=u+16|0;g=h;f[g>>2]=0;f[g+4>>2]=0;e=c$(g,46)|0;d=177577;c=e+46|0;do{b[e>>0]=b[d>>0]|0;e=e+1|0;d=d+1|0}while((e|0)<(c|0));j$(-218,g,177624,177637,60);d$(g);u=h;return}function YU(a){a=a|0;return}function ZU(a){a=a|0;return}function _U(a,b,c){a=a|0;b=b|0;c=+c;if((f[a>>2]|0)==(f[a+4>>2]|0))return;Gh[f[(f[b>>2]|0)+8>>2]&511](b,a);return}function $U(){return 1}function aV(a){a=a|0;return}function bV(){return 1}function cV(){return 0}function dV(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;f[a>>2]=42604;b=a+20|0;c=a+24|0;d=f[c>>2]|0;e=f[b>>2]|0;if((d|0)==(e|0)){g=e;h=d}else{d=a+8|0;do{kV(f[d>>2]|0);e=(f[c>>2]|0)+-1|0;f[c>>2]=e;i=f[b>>2]|0}while((e|0)!=(i|0));g=i;h=e}b=g;if(g|0){if((h|0)!=(b|0))f[c>>2]=b;PYa(b)}d$(a+12|0);b=a+4|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;j=a+8|0;f[j>>2]=0;return}h=c+4|0;g=f[h>>2]|0;f[h>>2]=g+-1;if((g|0)!=1){f[b>>2]=0;j=a+8|0;f[j>>2]=0;return}ki[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;j=a+8|0;f[j>>2]=0;return}function eV(a){a=a|0;dV(a);PYa(a);return}function fV(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;_$(g,42628);ki[f[(f[a>>2]|0)+16>>2]&2047](a);h=a+4|0;i=f[b>>2]|0;if(!(f[d+4>>2]|0))j=0;else{b=f[d>>2]|0;j=(b|0)==0?5694105:b}b=wV((i|0)==0?5694105:i,0,c,j)|0;if(!b)k=0;else{j=NYa(16)|0;f[j+4>>2]=1;f[j>>2]=42656;f[j+8>>2]=b;k=j}j=f[h>>2]|0;f[h>>2]=k;f[a+8>>2]=b;if(j|0?(b=j+4|0,k=f[b>>2]|0,f[b>>2]=k+-1,(k|0)==1):0)ki[f[(f[j>>2]|0)+8>>2]&2047](j);j=mi[f[(f[a>>2]|0)+12>>2]&255](a)|0;f[a+32>>2]=j?6:0;if(!(f[g+4>>2]|0)){u=e;return j|0}u=e;return j|0}function gV(a){a=a|0;var c=0,d=0;c=f[a+8>>2]|0;if(!c){d=0;return d|0}d=(b[c+300>>0]|0)!=0;return d|0}function hV(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+4|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)ki[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+8>>2]=0;b=f[a+20>>2]|0;c=a+24|0;if((f[c>>2]|0)==(b|0)){g=a+32|0;f[g>>2]=0;return}f[c>>2]=b;g=a+32|0;f[g>>2]=0;return}function iV(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=0;f[a+4>>2]=0;c=f[b+8>>2]|0;if(c|0?f[c+268>>2]|0:0)jV(c,a);ki[f[(f[b>>2]|0)+16>>2]&2047](b);return}function jV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=(c|0)!=0;if(g)d$(c);if(!a){f[e>>2]=0;f[e+4>>2]=0;h=c$(e,35)|0;i=177709;j=h+35|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-27,e,177745,177754,667);d$(e)}i=a+300|0;if(b[i>>0]|0){h=a+64|0;a:do if(f[a+8>>2]|0){if(((f[h>>2]|0)==0?(f[a+68>>2]|0)==0:0)?(f[a+268>>2]|0)==0:0)break;j=a+36|0;k=f[j>>2]|0;if(k|0?(f[k+24>>2]|0)>0:0)do kV(a);while((f[(f[j>>2]|0)+24>>2]|0)>0);j=a+72|0;k=f[j>>2]|0;l=a+76|0;m=f[l>>2]|0;n=a+56|0;o=f[n>>2]|0;if(k>>>0>(m+o|0)>>>0){b[k>>0]=10;b[k+1>>0]=0;lV(a,f[l>>2]|0);k=f[l>>2]|0;f[j>>2]=k;p=f[n>>2]|0;q=k}else{p=o;q=m}m=f[a+40>>2]|0;if((p|0)==(m|0)){r=q;s=p}else{F1a(q|0,32,m|0)|0;f[n>>2]=m;r=f[l>>2]|0;s=m}f[j>>2]=r+s;switch(f[a+4>>2]|0){case 8:{lV(a,177807);break a;break}case 24:{lV(a,177826);break a;break}default:break a}}while(0);s=f[h>>2]|0;if(!s){r=a+68|0;q=f[r>>2]|0;if(!q)t=r;else{kDa(q)|0;t=r}}else{GMa(s)|0;t=a+68|0}f[h>>2]=0;f[t>>2]=0;f[a+256>>2]=0;f[a+264>>2]=0;b[i>>0]=0}i=f[a+268>>2]|0;if(!(g&(i|0)!=0)){u=d;return}g=f[i+4>>2]|0;a=f[i+16>>2]|0;t=g+(a>>>12<<2)|0;if((f[i+8>>2]|0)!=(g|0)){h=(f[t>>2]|0)+(a&4095)|0;s=a+(f[i+20>>2]|0)|0;i=g+(s>>>12<<2)|0;g=(f[i>>2]|0)+(s&4095)|0;s=h;f[e>>2]=0;a=e+4|0;f[a>>2]=0;if((g|0)!=(h|0)?(r=(i-t<<10)-s+g-(f[i>>2]|0)+(f[t>>2]|0)|0,(r|0)!=0):0){i=h;h=t;t=s;s=c$(e,r)|0;while(1){b[s>>0]=b[i>>0]|0;r=t+1|0;q=r;if((q-(f[h>>2]|0)|0)==4096){p=h+4|0;j=f[p>>2]|0;v=j;w=p;x=j}else{v=r;w=h;x=q}if((v|0)==(g|0)){y=e;z=a;break}else{i=v;h=w;t=x;s=s+1|0}}}else{y=e;z=a}}else{f[e>>2]=0;a=e+4|0;f[a>>2]=0;y=e;z=a}if((e|0)!=(c|0)){d$(c);a=f[y>>2]|0;if(!a)A=0;else{y=a+-4|0;f[y>>2]=(f[y>>2]|0)+1;A=f[e>>2]|0}f[c>>2]=A;f[c+4>>2]=f[z>>2]}d$(e);u=d;return}function kV(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=(a|0)!=0;if(!(e?(f[a>>2]|0)==1280131417:0)){g=e?-5:-27;f[d>>2]=0;f[d+4>>2]=0;h=c$(d,31)|0;i=177863;j=h+31|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(g,d,177895,177754,4613);d$(d)}if(!(f[a+8>>2]|0)){f[d>>2]=0;f[d+4>>2]=0;h=c$(d,38)|0;i=177912;j=h+38|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-2,d,177895,177754,4613);d$(d)}pV(a,0);if(!(f[a+280>>2]|0)){k=a+232|0;l=f[k>>2]|0;ki[l&2047](a);u=c;return}qV(a,0);k=a+232|0;l=f[k>>2]|0;ki[l&2047](a);u=c;return}function lV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+16|0;e=d;g=f[a+268>>2]|0;if(g|0){h=xKa(c)|0;i=c+h|0;if(!h){u=d;return}h=g+20|0;j=g+8|0;k=g+4|0;l=g+16|0;m=f[h>>2]|0;n=c;do{o=f[k>>2]|0;p=(f[j>>2]|0)-o|0;q=f[l>>2]|0;if((((p|0)==0?0:(p<<10)+-1|0)|0)==(q+m|0)){mV(g);r=f[l>>2]|0;s=f[h>>2]|0;t=f[k>>2]|0}else{r=q;s=m;t=o}o=s+r|0;b[(f[t+(o>>>12<<2)>>2]|0)+(o&4095)>>0]=b[n>>0]|0;m=(f[h>>2]|0)+1|0;f[h>>2]=m;n=n+1|0}while((n|0)!=(i|0));u=d;return}i=f[a+64>>2]|0;if(i|0){VMa(c,i)|0;u=d;return}i=f[a+68>>2]|0;if(!i){f[e>>2]=0;f[e+4>>2]=0;a=c$(e,25)|0;n=177829;m=a+25|0;do{b[a>>0]=b[n>>0]|0;a=a+1|0;n=n+1|0}while((a|0)<(m|0));j$(-2,e,177855,177754,405);d$(e);u=d;return}else{yDa(i,c)|0;u=d;return}}function mV(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;b=u;u=u+32|0;c=b;d=a+16|0;e=f[d>>2]|0;if(e>>>0>4095){f[d>>2]=e+-4096;e=a+4|0;d=f[e>>2]|0;g=f[d>>2]|0;h=d+4|0;f[e>>2]=h;d=a+8|0;i=f[d>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;m=i;do if((i|0)==(k|0)){n=f[a>>2]|0;o=n;if(h>>>0>n>>>0){p=h;q=((p-o>>2)+1|0)/-2|0;r=h+(q<<2)|0;s=m-p|0;p=s>>2;if(!p)t=h;else{M1a(r|0,h|0,s|0)|0;t=f[e>>2]|0}s=r+(p<<2)|0;f[d>>2]=s;f[e>>2]=t+(q<<2);v=s;break}s=l-o>>1;o=(s|0)==0?1:s;if(o>>>0>1073741823){s=De(8)|0;UYa(s,358155);f[s>>2]=130560;Of(s|0,21520,875)}s=NYa(o<<2)|0;q=s;p=s+(o>>>2<<2)|0;r=p;w=s+(o<<2)|0;if((h|0)==(i|0)){x=n;y=r}else{n=p;p=h;o=r;do{f[n>>2]=f[p>>2];n=o+4|0;o=n;p=p+4|0}while((p|0)!=(i|0));x=f[a>>2]|0;y=o}f[a>>2]=q;f[e>>2]=r;f[d>>2]=y;f[j>>2]=w;if(!x)v=y;else{PYa(x);v=f[d>>2]|0}}else v=i;while(0);f[v>>2]=g;f[d>>2]=(f[d>>2]|0)+4;u=b;return}d=a+8|0;g=f[d>>2]|0;v=a+4|0;i=f[v>>2]|0;x=g-i|0;y=a+12|0;j=f[y>>2]|0;e=f[a>>2]|0;h=j-e|0;l=g;t=j;m=i;k=e;if(x>>>0>=h>>>0){p=h>>1;n=(p|0)==0?1:p;f[c+12>>2]=0;f[c+16>>2]=a+12;if(n>>>0>1073741823){p=De(8)|0;UYa(p,358155);f[p>>2]=130560;Of(p|0,21520,875)}p=x>>2;s=NYa(n<<2)|0;f[c>>2]=s;z=s+(p<<2)|0;A=c+8|0;f[A>>2]=z;B=c+4|0;f[B>>2]=z;C=s+(n<<2)|0;D=c+12|0;f[D>>2]=C;E=s;F=NYa(4096)|0;G=C;C=z;do if((p|0)==(n|0)){if(z>>>0>s>>>0){H=z+((((C-E>>2)+1|0)/-2|0)<<2)|0;f[A>>2]=H;f[B>>2]=H;I=H;break}H=G-E>>1;J=(H|0)==0?1:H;if(J>>>0>1073741823){H=De(8)|0;UYa(H,358155);f[H>>2]=130560;Of(H|0,21520,875)}else{H=NYa(J<<2)|0;K=H+(J>>>2<<2)|0;L=K;f[c>>2]=H;f[B>>2]=L;f[A>>2]=L;f[D>>2]=H+(J<<2);PYa(s);I=K;break}}else I=z;while(0);f[I>>2]=F;f[A>>2]=(f[A>>2]|0)+4;F=f[d>>2]|0;while(1){M=f[v>>2]|0;if((F|0)==(M|0))break;I=F+-4|0;oV(c,I);F=I}I=M;M=f[a>>2]|0;f[a>>2]=f[c>>2];f[c>>2]=M;f[v>>2]=f[B>>2];f[B>>2]=I;B=f[d>>2]|0;f[d>>2]=f[A>>2];f[A>>2]=B;z=f[y>>2]|0;f[y>>2]=f[D>>2];f[D>>2]=z;z=B;if((z|0)!=(F|0))f[A>>2]=z+(~((z+-4-I|0)>>>2)<<2);if(M|0)PYa(M);u=b;return}if((j|0)==(g|0)){j=NYa(4096)|0;f[c>>2]=j;nV(a,c);c=f[v>>2]|0;j=f[c>>2]|0;M=c+4|0;f[v>>2]=M;c=f[d>>2]|0;I=f[y>>2]|0;z=I;A=c;do if((c|0)==(I|0)){F=f[a>>2]|0;B=F;if(M>>>0>F>>>0){D=M;s=((D-B>>2)+1|0)/-2|0;E=M+(s<<2)|0;G=A-D|0;D=G>>2;if(!D)N=M;else{M1a(E|0,M|0,G|0)|0;N=f[v>>2]|0}G=E+(D<<2)|0;f[d>>2]=G;f[v>>2]=N+(s<<2);O=G;break}G=z-B>>1;B=(G|0)==0?1:G;if(B>>>0>1073741823){G=De(8)|0;UYa(G,358155);f[G>>2]=130560;Of(G|0,21520,875)}G=NYa(B<<2)|0;s=G;D=G+(B>>>2<<2)|0;E=D;C=G+(B<<2)|0;if((M|0)==(c|0)){P=F;Q=E}else{F=D;D=M;B=E;do{f[F>>2]=f[D>>2];F=B+4|0;B=F;D=D+4|0}while((D|0)!=(c|0));P=f[a>>2]|0;Q=B}f[a>>2]=s;f[v>>2]=E;f[d>>2]=Q;f[y>>2]=C;if(!P)O=Q;else{PYa(P);O=f[d>>2]|0}}else O=c;while(0);f[O>>2]=j;f[d>>2]=(f[d>>2]|0)+4;u=b;return}else{j=NYa(4096)|0;O=g;do if((l|0)==(t|0)){if(m>>>0>k>>>0){g=((i-e>>2)+1|0)/-2|0;c=m+(g<<2)|0;P=x>>2;if(!P)R=m;else{M1a(c|0,i|0,x|0)|0;R=f[v>>2]|0}Q=c+(P<<2)|0;f[d>>2]=Q;f[v>>2]=R+(g<<2);S=Q;break}Q=h>>1;g=(Q|0)==0?1:Q;if(g>>>0>1073741823){Q=De(8)|0;UYa(Q,358155);f[Q>>2]=130560;Of(Q|0,21520,875)}Q=NYa(g<<2)|0;P=Q;c=Q+(g>>>2<<2)|0;M=c;z=Q+(g<<2)|0;if((m|0)==(l|0)){T=k;U=M}else{g=c;c=m;Q=M;do{f[g>>2]=f[c>>2];g=Q+4|0;Q=g;c=c+4|0}while((c|0)!=(l|0));T=f[a>>2]|0;U=Q}f[a>>2]=P;f[v>>2]=M;f[d>>2]=U;f[y>>2]=z;if(!T)S=U;else{PYa(T);S=f[d>>2]|0}}else S=O;while(0);f[S>>2]=j;f[d>>2]=(f[d>>2]|0)+4;u=b;return}}function nV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=e;do if((d|0)==(e|0)){h=a+8|0;i=f[h>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;if(i>>>0<k>>>0){k=i;m=((l-k>>2)+1|0)/2|0;n=i+(m<<2)|0;o=k-d|0;k=o>>2;p=n+(0-k<<2)|0;if(!k){q=i;r=n}else{M1a(p|0,d|0,o|0)|0;q=f[h>>2]|0;r=p}f[c>>2]=r;f[h>>2]=q+(m<<2);s=r;break}m=l-g>>1;l=(m|0)==0?1:m;if(l>>>0>1073741823){m=De(8)|0;UYa(m,358155);f[m>>2]=130560;Of(m|0,21520,875)}m=NYa(l<<2)|0;p=m;o=m+((l+3|0)>>>2<<2)|0;n=o;k=m+(l<<2)|0;if((d|0)==(i|0)){t=d;u=n}else{l=o;m=d;v=n;do{f[l>>2]=f[m>>2];l=v+4|0;v=l;m=m+4|0}while((m|0)!=(i|0));t=f[a>>2]|0;u=v}f[a>>2]=p;f[c>>2]=n;f[h>>2]=u;f[j>>2]=k;if(!t)s=o;else{PYa(t);s=f[c>>2]|0}}else s=d;while(0);f[s+-4>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+-4;return}function oV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=e;do if((d|0)==(e|0)){h=a+8|0;i=f[h>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;if(i>>>0<k>>>0){k=i;m=((l-k>>2)+1|0)/2|0;n=i+(m<<2)|0;o=k-d|0;k=o>>2;p=n+(0-k<<2)|0;if(!k){q=i;r=n}else{M1a(p|0,d|0,o|0)|0;q=f[h>>2]|0;r=p}f[c>>2]=r;f[h>>2]=q+(m<<2);s=r;break}m=l-g>>1;l=(m|0)==0?1:m;if(l>>>0>1073741823){m=De(8)|0;UYa(m,358155);f[m>>2]=130560;Of(m|0,21520,875)}m=NYa(l<<2)|0;p=m;o=m+((l+3|0)>>>2<<2)|0;n=o;k=m+(l<<2)|0;if((d|0)==(i|0)){t=d;u=n}else{l=o;m=d;v=n;do{f[l>>2]=f[m>>2];l=v+4|0;v=l;m=m+4|0}while((m|0)!=(i|0));t=f[a>>2]|0;u=v}f[a>>2]=p;f[c>>2]=n;f[h>>2]=u;f[j>>2]=k;if(!t)s=o;else{PYa(t);s=f[c>>2]|0}}else s=d;while(0);f[s+-4>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+-4;return}function pV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d+12|0;g=d;h=a+284|0;if(!(b[h>>0]|0)){u=d;return};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;i=a+292|0;j=f[i>>2]|0;k=a+288|0;l=f[k>>2]|0;if(l|0?b[l>>0]|0:0)eZa(e,l)|0;l=a+296|0;m=f[l>>2]|0;if(m|0?b[m>>0]|0:0)eZa(g,m)|0;m=f[k>>2]|0;if(m|0)QYa(m);m=f[l>>2]|0;if(m|0)QYa(m);f[k>>2]=0;f[i>>2]=0;f[l>>2]=0;b[h>>0]=0;h=f[a+228>>2]|0;l=e+11|0;i=(b[l>>0]|0)<0?f[e>>2]|0:e;if(c){Ah[h&255](a,i,j,178191);if(f[a+280>>2]|0)qV(a,0);qV(a,2);n=g+11|0}else{c=g+11|0;Ah[h&255](a,i,j,(b[c>>0]|0)<0?f[g>>2]|0:g);if(f[a+280>>2]|0)qV(a,0);qV(a,1);n=c}if((b[n>>0]|0)<0)PYa(f[g>>2]|0);if((b[l>>0]|0)<0)PYa(f[e>>2]|0);u=d;return}function qV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=a+280|0;switch(f[g>>2]|0){case 0:{switch(c|0){case 2:{h=NYa(16)|0;rV(h,a);f[a+272>>2]=h;f[g>>2]=c;u=d;return}case 1:case 0:{f[g>>2]=c;u=d;return}default:{f[e>>2]=0;f[e+4>>2]=0;i=c$(e,55)|0;j=177951;k=i+55|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-2,e,178007,177754,1157);d$(e);f[g>>2]=c;u=d;return}}break}case 2:{switch(c|0){case 1:case 2:{f[e>>2]=0;f[e+4>>2]=0;i=c$(e,49)|0;j=178030;k=i+49|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-2,e,178007,177754,1166);d$(e);f[g>>2]=c;u=d;return}case 0:{h=a+272|0;a=f[h>>2]|0;if(a|0){l=f[a>>2]|0;if(l|0){sV(l);PYa(l)}l=a+4|0;if((b[l+11>>0]|0)<0)PYa(f[l>>2]|0);PYa(a)}f[h>>2]=0;f[g>>2]=c;u=d;return}default:{f[e>>2]=0;f[e+4>>2]=0;i=c$(e,55)|0;j=177951;k=i+55|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-2,e,178007,177754,1173);d$(e);f[g>>2]=c;u=d;return}}break}case 1:{switch(c|0){case 1:case 2:{f[e>>2]=0;f[e+4>>2]=0;i=c$(e,49)|0;j=178030;k=i+49|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-2,e,178007,177754,1182);d$(e);f[g>>2]=c;u=d;return}case 0:{f[g>>2]=c;u=d;return}default:{f[e>>2]=0;f[e+4>>2]=0;i=c$(e,55)|0;j=177951;k=i+55|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-2,e,178007,177754,1187);d$(e);f[g>>2]=c;u=d;return}}break}default:{f[e>>2]=0;f[e+4>>2]=0;i=c$(e,55)|0;j=177951;k=i+55|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-2,e,178007,177754,1192);d$(e);f[g>>2]=c;u=d;return}}}function rV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;g=NYa(40)|0;vV(g,c);f[a>>2]=g;g=a+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;g=(c|0)!=0;if(!(g?(f[c>>2]|0)==1280131417:0)){f[e>>2]=0;f[e+4>>2]=0;h=c$(e,31)|0;i=177863;j=h+31|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(g?-5:-27,e,178147,177754,8314);d$(e)}if(f[c+8>>2]|0){u=d;return}f[e>>2]=0;f[e+4>>2]=0;h=c$(e,38)|0;i=177912;j=h+38|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-2,e,178147,177754,8314);d$(e);u=d;return}function sV(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if((f[a+32>>2]|0)!=(f[a+28>>2]|0))tV(a)|0;c=f[a>>2]|0;if((f[c+4>>2]|0)==24){lV(c,178080);c=f[a>>2]|0;d=c+76|0;e=f[d>>2]|0;g=c+72|0;f[g>>2]=e;h=e;e=c+56|0;i=f[e>>2]|0;if((i|0)<0){b[h>>0]=10;b[h+1>>0]=0;lV(c,f[d>>2]|0);j=f[d>>2]|0;f[g>>2]=j;k=f[e>>2]|0;l=j}else{k=i;l=h}h=f[c+40>>2]|0;if((k|0)==(h|0)){m=l;n=k}else{F1a(l|0,32,h|0)|0;f[e>>2]=h;m=f[d>>2]|0;n=h}f[g>>2]=m+n;n=f[a>>2]|0;F1a(f[n+76>>2]|0,0,f[n+56>>2]|0)|0;n=f[a>>2]|0;f[n+72>>2]=f[n+76>>2]}n=f[a+16>>2]|0;if(n|0){m=a+20|0;if((f[m>>2]|0)!=(n|0))f[m>>2]=n;PYa(n)}n=f[a+4>>2]|0;if(!n)return;m=a+8|0;if((f[m>>2]|0)!=(n|0))f[m>>2]=n;PYa(n);return}function tV(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+80|0;d=c;e=a+28|0;g=f[e>>2]|0;h=a+16|0;i=a+32|0;if(!(uV(g,f[h>>2]|0,0,(f[i>>2]|0)-g|0)|0)){j=0;u=c;return j|0}f[i>>2]=f[e>>2];e=f[a>>2]|0;if((f[e+4>>2]|0)==24){lV(e,f[h>>2]|0);j=1;u=c;return j|0}i=f[e+40>>2]|0;F1a(d|0,32,i|0)|0;b[d+i>>0]=0;lV(e,d);lV(f[a>>2]|0,f[h>>2]|0);lV(f[a>>2]|0,353714);h=f[a>>2]|0;a=h+72|0;d=f[a>>2]|0;e=h+76|0;i=f[e>>2]|0;g=h+56|0;k=f[g>>2]|0;if(d>>>0>(i+k|0)>>>0){b[d>>0]=10;b[d+1>>0]=0;lV(h,f[e>>2]|0);d=f[e>>2]|0;f[a>>2]=d;l=f[g>>2]|0;m=d}else{l=k;m=i}i=f[h+40>>2]|0;if((l|0)==(i|0)){n=m;o=l}else{F1a(m|0,32,i|0)|0;f[g>>2]=i;n=f[e>>2]|0;o=i}f[a>>2]=n+o;j=1;u=c;return j|0}function uV(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;if(!((a|0)!=0&(c|0)!=0&(e|0)!=0)){f=0;return f|0}g=a+d|0;d=e-((e>>>0)%3|0)|0;a=g+d|0;if((d|0)>0){d=c;i=g;while(1){j=b[i+1>>0]|0;k=i+3|0;l=b[i+2>>0]|0;m=h[i>>0]|0;b[d>>0]=b[178082+(m>>>2)>>0]|0;n=j&255;b[d+1>>0]=b[178082+(n>>>4|m<<4&48)>>0]|0;m=l&255;b[d+2>>0]=b[178082+(m>>>6|n<<2&60)>>0]|0;n=d+4|0;b[d+3>>0]=b[178082+(m&63)>>0]|0;if(k>>>0<a>>>0){d=n;i=k}else{o=n;p=k;break}}}else{o=c;p=g}i=g+e-p|0;switch(i|0){case 1:{e=h[p>>0]|0;b[o>>0]=b[178082+(e>>>2)>>0]|0;q=48;r=2;s=e<<4;t=o+1|0;u=7;break}case 2:{e=b[p+1>>0]|0;g=h[p>>0]|0;b[o>>0]=b[178082+(g>>>2)>>0]|0;p=e&255;b[o+1>>0]=b[178082+(g<<4&48|p>>>4)>>0]|0;q=60;r=3;s=p<<2;t=o+2|0;u=7;break}default:v=o}if((u|0)==7){b[t>>0]=b[178082+(s&q)>>0]|0;v=o+r|0}switch(i|0){case 1:{b[v>>0]=61;w=v+1|0;u=10;break}case 2:{w=v;u=10;break}default:x=v}if((u|0)==10){b[w>>0]=61;x=w+1|0}b[x>>0]=0;f=x-c|0;return f|0}function vV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;f[a>>2]=c;g=a+4|0;f[g>>2]=0;h=a+8|0;f[h>>2]=0;f[a+12>>2]=0;i=NYa(48)|0;f[h>>2]=i;f[g>>2]=i;f[a+12>>2]=i+48;j=i;i=48;do{b[j>>0]=0;j=(f[h>>2]|0)+1|0;f[h>>2]=j;i=i+-1|0}while((i|0)!=0);i=a+16|0;f[i>>2]=0;j=a+20|0;f[j>>2]=0;f[a+24>>2]=0;h=NYa(65)|0;f[j>>2]=h;f[i>>2]=h;f[a+24>>2]=h+65;i=h;h=65;do{b[i>>0]=0;i=(f[j>>2]|0)+1|0;f[j>>2]=i;h=h+-1|0}while((h|0)!=0);h=f[g>>2]|0;f[a+28>>2]=h;f[a+36>>2]=h+48;f[a+32>>2]=h;h=(c|0)!=0;if(!(h?(f[c>>2]|0)==1280131417:0)){f[e>>2]=0;f[e+4>>2]=0;k=c$(e,31)|0;l=177863;m=k+31|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(h?-5:-27,e,178160,177754,7880);d$(e)}if(!(f[c+8>>2]|0)){f[e>>2]=0;f[e+4>>2]=0;k=c$(e,38)|0;l=177912;m=k+38|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-2,e,178160,177754,7880);d$(e)}if((f[c+4>>2]|0)==24){e=c+72|0;l=f[e>>2]|0;f[e>>2]=l+1;b[l>>0]=0;l=c+76|0;lV(c,f[l>>2]|0);f[e>>2]=f[l>>2];l=f[a>>2]|0;F1a(f[l+76>>2]|0,0,f[l+56>>2]|0)|0;lV(c,178181);u=d;return}c=f[a>>2]|0;a=c+72|0;l=f[a>>2]|0;e=c+76|0;k=f[e>>2]|0;m=c+56|0;h=f[m>>2]|0;if(l>>>0>(k+h|0)>>>0){b[l>>0]=10;b[l+1>>0]=0;lV(c,f[e>>2]|0);l=f[e>>2]|0;f[a>>2]=l;n=f[m>>2]|0;o=l}else{n=h;o=k}k=f[c+40>>2]|0;if((n|0)==(k|0)){p=o;q=n}else{F1a(o|0,32,k|0)|0;f[m>>2]=k;p=f[e>>2]|0;q=k}f[a>>2]=p+q;u=d;return}function wV(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0;g=u;u=u+1344|0;h=g+168|0;i=g+152|0;j=g+136|0;k=g+120|0;l=g+104|0;m=g+88|0;n=g+72|0;o=g+56|0;p=g+40|0;q=g+24|0;r=g+8|0;s=g;t=g+228|0;v=g+216|0;w=g+204|0;x=g+200|0;y=g+196|0;z=g+192|0;A=g+180|0;B=g+1328|0;f[z>>2]=0;C=d&3;D=(C|0)==2;E=d&4;F=(E|0)!=0;G=(C|0)!=0;C=G&(d&64|0)!=0;f[A>>2]=0;H=A+4|0;f[H>>2]=0;f[A+8>>2]=0;if(!F){f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;I=xKa(a)|0;if(I>>>0>4294967279)WYa(w);if(I>>>0<11){b[w+11>>0]=I;if(!I)J=w;else{K=w;L=7}}else{M=I+16&-16;N=NYa(M)|0;f[w>>2]=N;f[w+8>>2]=M|-2147483648;f[w+4>>2]=I;K=N;L=7}if((L|0)==7){K1a(K|0,a|0,I|0)|0;J=K}b[J+I>>0]=0;f[v>>2]=0;I=v+4|0;f[I>>2]=0;f[v+8>>2]=0;if((nZa(w,10,0)|0)==-1){J=oZa(w,63,-1)|0;K=b[w+11>>0]|0;N=K<<24>>24<0?f[w+4>>2]|0:K&255;ZYa(t,w,0,J,w);K=f[I>>2]|0;M=v+8|0;if((K|0)==(f[M>>2]|0))zV(v,t);else{YYa(K,t);f[I>>2]=(f[I>>2]|0)+12}if((b[t+11>>0]|0)<0)PYa(f[t>>2]|0);if((J|0)!=-1?(K=J+1|0,K>>>0<N>>>0):0){J=t+11|0;O=K;while(1){K=nZa(w,38,O)|0;if((O+1|0)>>>0<N>>>0&((K|0)!=(O|0)|(K|0)==-1)){ZYa(t,w,O,K-O|0,w);P=f[I>>2]|0;if((P|0)==(f[M>>2]|0))zV(v,t);else{YYa(P,t);f[I>>2]=(f[I>>2]|0)+12}if((b[J>>0]|0)<0)PYa(f[t>>2]|0)}if(K>>>0<N>>>0)O=K+1|0;else break}}}AV(A,f[v>>2]|0,f[I>>2]|0);O=f[v>>2]|0;if(O|0){N=f[I>>2]|0;if((N|0)==(O|0))Q=O;else{J=N;while(1){N=J+-12|0;f[I>>2]=N;if((b[N+11>>0]|0)<0){PYa(f[N>>2]|0);R=f[I>>2]|0}else R=N;if((R|0)==(O|0))break;else J=R}Q=f[v>>2]|0}PYa(Q)}if((b[w+11>>0]|0)<0)PYa(f[w>>2]|0);Q=f[A>>2]|0;R=f[H>>2]|0;J=(Q|0)==(R|0);O=R;I=Q;do if(!J)if((b[Q+11>>0]|0)<0){S=f[Q>>2]|0;break}else{S=Q;break}else S=a;while(0);if(C){T=S;U=1}else{f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;b[t+11>>0]=6;b[t>>0]=b[178267]|0;b[t+1>>0]=b[178268]|0;b[t+2>>0]=b[178269]|0;b[t+3>>0]=b[178270]|0;b[t+4>>0]=b[178271]|0;b[t+5>>0]=b[178272]|0;b[t+6>>0]=0;if(((O-I|0)/12|0)>>>0<2)V=0;else{a:do if(J)W=Q;else{I=f[t>>2]&255;O=Q;while(1){N=b[O+11>>0]|0;M=N<<24>>24<0;K=N&255;do if(((M?f[O+4>>2]|0:K)|0)==6){N=f[O>>2]|0;if(M)if(!(yKa(N,t,6)|0)){W=O;break a}else break;if((N&255)<<24>>24==I<<24>>24){N=K;P=O;X=t;do{N=N+-1|0;P=P+1|0;if(!N){W=O;break a}X=X+1|0}while((b[P>>0]|0)==(b[X>>0]|0))}}while(0);O=O+12|0;if((O|0)==(R|0)){W=R;break}}}while(0);V=(W|0)!=(R|0)}T=S;U=V&G}}else{T=a;U=C}C=(T|0)!=0;if(C?(b[T>>0]|0)!=0:0){Y=xKa(T)|0;Z=F}else if(G){Y=0;Z=1}else{f[t>>2]=0;f[t+4>>2]=0;a=E>>>1|20;E=c$(t,a)|0;K1a(E|0,(F?178274:178297)|0,a|0)|0;j$(-27,t,178318,177754,4198);d$(t);Y=0;Z=1}a=D^1;if(!(a|Z^1)){f[t>>2]=0;f[t+4>>2]=0;_=c$(t,68)|0;$=178336;aa=_+68|0;do{b[_>>0]=b[$>>0]|0;_=_+1|0;$=$+1|0}while((_|0)<(aa|0));j$(-206,t,178318,177754,4205);d$(t)}F=_F(304)|0;f[z>>2]=F;if(!F){f[t>>2]=0;f[t+4>>2]=0;E=c$(t,2)|0;b[E>>0]=102;b[E+1>>0]=115;j$(-215,t,178318,177754,4208);d$(t);ba=f[z>>2]|0}else ba=F;F1a(ba|0,0,304)|0;ba=pL(262144)|0;F=f[z>>2]|0;f[F+16>>2]=ba;f[F+20>>2]=(c|0)==0?ba:c;f[F>>2]=1280131417;f[F+8>>2]=G&1;b:do if(!Z){G=vL(ba,Y+1|0)|0;f[(f[z>>2]|0)+60>>2]=G;ZKa(G,T)|0;G=f[z>>2]|0;c=f[G+60>>2]|0;E=QKa(c,46)|0;do if((E|0?(b[E+1>>0]|0)==103:0)?(b[E+2>>0]|0)==122:0){V=E+3|0;S=b[V>>0]|0;if(S<<24>>24){if((S+-48&255)>=10)break;if(b[E+4>>0]|0)break}if(D){BV(z);f[t>>2]=0;f[t+4>>2]=0;_=c$(t,52)|0;$=178405;aa=_+52|0;do{b[_>>0]=b[$>>0]|0;_=_+1|0;$=$+1|0}while((_|0)<(aa|0));j$(-213,t,178318,177754,4231);d$(t);ca=b[V>>0]|0}else ca=S;if(!(ca<<24>>24)){da=0;ea=Y}else{b[V>>0]=0;da=ca;ea=Y+-1|0}R=f[z>>2]|0;b[t>>0]=f[R+8>>2]|0?119:114;b[t+1>>0]=98;b[t+2>>0]=da<<24>>24?da:51;b[t+3>>0]=0;W=lDa(f[R+60>>2]|0,t)|0;R=f[z>>2]|0;f[R+68>>2]=W;if(!W){fa=R;break b}else{ga=R;ha=ea;ia=1;L=74;break b}}while(0);E=NMa(c,(f[G+8>>2]|0)==0?178465:D?178458:178462)|0;R=f[z>>2]|0;f[R+64>>2]=E;if(!E)fa=R;else{ga=R;ha=Y;ia=0;L=74}}else{ga=F;ha=Y;ia=0;L=74}while(0);if((L|0)==74){f[ga+32>>2]=0;f[ga+40>>2]=0;f[ga+44>>2]=0;f[ga+84>>2]=71;if(!(f[ga+8>>2]|0)){if(Z){f[ga+256>>2]=T;f[ga+260>>2]=ha}CV(ga,B,14)|0;if((b[B>>0]|0)==-17?(b[B+1>>0]|0)==-69:0)ja=(b[B+2>>0]|0)==-65?B+3|0:B;else ja=B;ha=ja-B|0;do if(aLa(ja,178810,5)|0){if((b[ja>>0]|0)==123){f[(f[z>>2]|0)+4>>2]=24;break}B=(aLa(ja,178816,5)|0)==0;Y=f[z>>2]|0;if(B){f[Y+4>>2]=8;break}if((f[Y+260>>2]|0)==(ha|0)){f[t>>2]=0;f[t+4>>2]=0;_=c$(t,19)|0;$=178822;aa=_+19|0;do{b[_>>0]=b[$>>0]|0;_=_+1|0;$=$+1|0}while((_|0)<(aa|0));j$(-49,t,178318,177754,4484);d$(t);break}else{f[t>>2]=0;f[t+4>>2]=0;_=c$(t,31)|0;$=178842;aa=_+31|0;do{b[_>>0]=b[$>>0]|0;_=_+1|0;$=$+1|0}while((_|0)<(aa|0));j$(-49,t,178318,177754,4486);d$(t);break}}else f[(f[z>>2]|0)+4>>2]=16;while(0);if(ia)ka=1048576;else{ia=f[z>>2]|0;if(Z)la=f[ia+260>>2]|0;else{RMa(f[ia+64>>2]|0,0,2)|0;la=iMa(f[(f[z>>2]|0)+64>>2]|0)|0}ia=la>>>0<1048576?la:1048576;ka=ia>>>0>9216?ia:9216}ia=f[z>>2]|0;la=f[ia+64>>2]|0;if(!la){ja=f[ia+68>>2]|0;if(ja|0)nDa(ja)|0}else uMa(la);f[ia+264>>2]=0;ia=f[z>>2]|0;f[ia+264>>2]=ha;ha=f[ia+16>>2]|0;ia=UL(0,72,16,ha)|0;f[ia+64>>2]=256;la=vL(ha,1024)|0;f[ia+68>>2]=la;F1a(la|0,0,1024)|0;la=f[z>>2]|0;f[la+28>>2]=ia;ia=yL(0,56,16,f[la+16>>2]|0)|0;f[(f[z>>2]|0)+32>>2]=ia;ia=_F(ka+256|0)|0;la=f[z>>2]|0;f[la+76>>2]=ia;f[la+72>>2]=ia;f[la+80>>2]=ia+ka;b[ia>>0]=10;b[(f[(f[z>>2]|0)+72>>2]|0)+1>>0]=0;ia=f[z>>2]|0;c:do switch(f[ia+4>>2]|0){case 8:{ka=f[ia+76>>2]|0;f[v>>2]=0;f[w>>2]=0;f[x>>2]=0;f[y>>2]=0;la=YV(ia,ka,2)|0;if(yKa(la,178816,5)|0){ka=f[ia+88>>2]|0;f[r>>2]=f[ia+60>>2];f[r+4>>2]=ka;f[r+8>>2]=178885;SLa(t,178874,r)|0;T$(-212,178927,t,177754,2825)}ka=ZV(ia,la,v,x,y)|0;d:do if(b[ka>>0]|0){la=ia+32|0;ha=ia+60|0;ja=ia+88|0;G=ka;do{c=YV(ia,G,0)|0;if(!(b[c>>0]|0))break d;Y=ZV(ia,c,v,x,y)|0;c=f[v>>2]|0;if(!((f[y>>2]|0)==1&(c|0)!=0?!(KKa(f[c+8>>2]|0,178939)|0):0)){B=f[ja>>2]|0;f[q>>2]=f[ha>>2];f[q+4>>2]=B;f[q+8>>2]=178954;SLa(t,178874,q)|0;T$(-212,178927,t,177754,2855)}B=ZV(ia,_V(ia,Y,NL(f[la>>2]|0,0)|0,0)|0,w,x,y)|0;if(!((f[y>>2]|0)==2?(c|0)==(f[w>>2]|0):0)){c=f[ja>>2]|0;f[p>>2]=f[ha>>2];f[p+4>>2]=c;f[p+8>>2]=178986;SLa(t,178874,p)|0;T$(-212,178927,t,177754,2861)}G=YV(ia,B,0)|0}while((b[G>>0]|0)!=0)}while(0);break}case 16:{ka=$V(ia,f[ia+76>>2]|0,0)|0;if(ka|0){G=ia+92|0;ha=ia+60|0;ja=ia+88|0;la=ia+32|0;V=ka;ka=0;while(1){e:do if(!ka){S=V;f:while(1){B=b[S>>0]|0;switch(B<<24>>24){case 45:{break f;break}case 37:{do if(!(yKa(S,178810,5)|0)){if(!(yKa(S,179023,8)|0))break;if(!(yKa(S,179032,8)|0))break;c=f[ja>>2]|0;f[m>>2]=f[ha>>2];f[m+4>>2]=c;f[m+8>>2]=179041;SLa(t,178874,m)|0;T$(-212,179083,t,177754,1836)}while(0);b[S>>0]=0;break}default:{if(B<<24>>24==95|((B+-48&255)<10|((B&-33)+-65&255)<26)){ma=S;L=210;break e}if(f[G>>2]|0){na=S;break e}c=f[ja>>2]|0;f[k>>2]=f[ha>>2];f[k+4>>2]=c;f[k+8>>2]=179095;SLa(t,178874,k)|0;T$(-212,179083,t,177754,1858)}}c=$V(ia,S,0)|0;if(!c)break c;else S=c}if(!(yKa(S,179019,3)|0)){oa=S;L=208}else na=S}else{c=V;while(1){Y=b[c>>0]|0;switch(Y<<24>>24){case 37:{do if(!(yKa(c,178810,5)|0)){if(!(yKa(c,179023,8)|0))break;if(!(yKa(c,179032,8)|0))break;F=f[ja>>2]|0;f[o>>2]=f[ha>>2];f[o+4>>2]=F;f[o+8>>2]=179041;SLa(t,178874,o)|0;T$(-212,179083,t,177754,1836)}while(0);b[c>>0]=0;break}case 45:{if(!(yKa(c,179019,3)|0)){oa=c;L=208;break e}break}default:{if(Y<<24>>24==95|((Y+-48&255)<10|((Y&-33)+-65&255)<26)){ma=c;L=210;break e}if(f[G>>2]|0){na=c;break e}B=f[ja>>2]|0;f[n>>2]=f[ha>>2];f[n+4>>2]=B;f[n+8>>2]=179095;SLa(t,178874,n)|0;T$(-212,179083,t,177754,1858)}}c=$V(ia,c,0)|0;if(!c)break c}}while(0);if((L|0)==208){L=0;na=oa+3|0}else if((L|0)==210){L=0;if(ka){c=f[ja>>2]|0;f[l>>2]=f[ha>>2];f[l+4>>2]=c;f[l+8>>2]=179125;SLa(t,178874,l)|0;T$(-212,179083,t,177754,1852);na=ma}else na=ma}c=$V(ia,na,0)|0;if(yKa(c,374535,3)|0){S=NL(f[la>>2]|0,0)|0;B=aW(ia,c,S,0,0)|0;if((f[S>>2]&7)>>>0<=4){S=f[ja>>2]|0;f[j>>2]=f[ha>>2];f[j+4>>2]=S;f[j+8>>2]=179186;SLa(t,178874,j)|0;T$(-212,179083,t,177754,1869)}S=$V(ia,B,0)|0;if(!S)break c;else pa=S}else pa=c;if(f[G>>2]|0)break c;V=$V(ia,pa+3|0,0)|0;if(!V)break;else ka=1}}break}case 24:{ka=bW(ia,f[ia+76>>2]|0)|0;if(ka|0?(V=ia+92|0,(f[V>>2]|0)==0):0){switch(b[ka>>0]|0){case 123:{cW(ia,ka,NL(f[ia+32>>2]|0,0)|0)|0;break}case 91:{dW(ia,ka,NL(f[ia+32>>2]|0,0)|0)|0;break}default:{ka=f[ia+88>>2]|0;f[i>>2]=f[ia+60>>2];f[i+4>>2]=ka;f[i+8>>2]=179248;SLa(t,178874,i)|0;T$(-212,179283,t,177754,3831)}}if(f[V>>2]|0){V=f[ia+88>>2]|0;f[h>>2]=f[ia+60>>2];f[h+4>>2]=V;f[h+8>>2]=179296;SLa(t,178874,h)|0;T$(-212,179283,t,177754,3835)}}break}default:{}}while(0);$F(f[(f[z>>2]|0)+76>>2]|0);h=f[z>>2]|0;f[h+76>>2]=0;f[h+80>>2]=0;f[h+72>>2]=0;qa=h}else{h=d&56;if(Z){Z=NYa(24)|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;f[Z+16>>2]=0;f[Z+20>>2]=0;f[ga+268>>2]=Z}g:do if((h|0)==0&C){Z=0;ga=0;d=T;h:while(1){switch(b[d>>0]|0){case 0:{break h;break}case 46:{ra=ga;sa=d;break}default:{ra=Z;sa=ga}}Z=ra;ga=sa;d=d+1|0}if((((ga|0)!=0?(xKa(ga)|0)==3:0)?(d=OKa(b[ga>>0]|0)|0,(d|0)==(OKa(46)|0)):0)?(d=OKa(b[ga+1>>0]|0)|0,(d|0)==(OKa(103)|0)):0){d=OKa(b[ga+2>>0]|0)|0;ia=(d|0)==(OKa(122)|0);ta=ia?1:0}else ta=0;ia=(Z|0)!=0&ta?Z:ga;if(ia){if(((((xKa(ia)|0)==4?(d=OKa(b[ia>>0]|0)|0,(d|0)==(OKa(46)|0)):0)?(d=OKa(b[ia+1>>0]|0)|0,(d|0)==(OKa(120)|0)):0)?(d=OKa(b[ia+2>>0]|0)|0,(d|0)==(OKa(109)|0)):0)?(d=OKa(b[ia+3>>0]|0)|0,(d|0)==(OKa(108)|0)):0){ua=8;break}do if(((((xKa(ia)|0)==7?(d=OKa(b[ia>>0]|0)|0,(d|0)==(OKa(46)|0)):0)?(d=OKa(b[ia+1>>0]|0)|0,(d|0)==(OKa(120)|0)):0)?(d=OKa(b[ia+2>>0]|0)|0,(d|0)==(OKa(109)|0)):0)?(d=OKa(b[ia+3>>0]|0)|0,(d|0)==(OKa(108)|0)):0){d=OKa(b[ia+4>>0]|0)|0;if((d|0)!=(OKa(46)|0))break;d=OKa(b[ia+5>>0]|0)|0;if((d|0)!=(OKa(103)|0))break;d=OKa(b[ia+6>>0]|0)|0;if((d|0)==(OKa(122)|0)){ua=8;break g}}while(0);do if((((xKa(ia)|0)==5?(ga=OKa(b[ia>>0]|0)|0,(ga|0)==(OKa(46)|0)):0)?(ga=OKa(b[ia+1>>0]|0)|0,(ga|0)==(OKa(106)|0)):0)?(ga=OKa(b[ia+2>>0]|0)|0,(ga|0)==(OKa(115)|0)):0){ga=OKa(b[ia+3>>0]|0)|0;if((ga|0)!=(OKa(111)|0))break;ga=OKa(b[ia+4>>0]|0)|0;if((ga|0)==(OKa(110)|0)){ua=24;break g}}while(0);if((((xKa(ia)|0)==8?(ga=OKa(b[ia>>0]|0)|0,(ga|0)==(OKa(46)|0)):0)?(ga=OKa(b[ia+1>>0]|0)|0,(ga|0)==(OKa(106)|0)):0)?(ga=OKa(b[ia+2>>0]|0)|0,(ga|0)==(OKa(115)|0)):0){ga=OKa(b[ia+3>>0]|0)|0;if((ga|0)!=(OKa(111)|0)){ua=16;break}ga=OKa(b[ia+4>>0]|0)|0;if((ga|0)!=(OKa(110)|0)){ua=16;break}ga=OKa(b[ia+5>>0]|0)|0;if((ga|0)!=(OKa(46)|0)){ua=16;break}ga=OKa(b[ia+6>>0]|0)|0;if((ga|0)!=(OKa(103)|0)){ua=16;break}ga=OKa(b[ia+7>>0]|0)|0;Z=(ga|0)==(OKa(122)|0);ua=Z?24:16}else ua=16}else ua=16}else ua=h|0?h:8;while(0);h=f[z>>2]|0;f[h+4>>2]=ua;ta=(ua|0)==8?25600:17408;if(D){RMa(f[h+64>>2]|0,0,2)|0;sa=f[z>>2]|0;va=f[sa+4>>2]|0;wa=sa}else{va=ua;wa=h}h=yL(0,56,(va|0)==8?24:4,f[wa+16>>2]|0)|0;wa=f[z>>2]|0;f[wa+36>>2]=h;f[wa+12>>2]=1;f[wa+40>>2]=0;f[wa+44>>2]=32;wa=_F(ta+1024|0)|0;h=f[z>>2]|0;f[h+72>>2]=wa;f[h+76>>2]=wa;f[h+80>>2]=wa+ta;f[h+272>>2]=0;b[h+276>>0]=U&1;f[h+280>>2]=0;b[h+284>>0]=0;f[h+288>>2]=0;f[h+292>>2]=0;f[h+296>>2]=0;switch(f[h+4>>2]|0){case 8:{U=f[h+64>>2]|0;if(!U){xa=h;ya=0}else{ta=iMa(U)|0;xa=f[z>>2]|0;ya=ta}ta=qL(f[xa+16>>2]|0)|0;xa=f[z>>2]|0;f[xa+24>>2]=ta;if((ya|0)==0|a){if(!e)lV(xa,178608);else{if(!(((KKa(e,178468)|0)!=0?(KKa(e,178475)|0)!=0:0)?(KKa(e,178482)|0)!=0:0)){BV(z);f[t>>2]=0;f[t+4>>2]=0;_=c$(t,57)|0;$=178489;aa=_+57|0;do{b[_>>0]=b[$>>0]|0;_=_+1|0;$=$+1|0}while((_|0)<(aa|0));j$(-5,t,178318,177754,4342);d$(t)}if((xKa(e)|0)>>>0>=1e3){f[t>>2]=0;f[t+4>>2]=0;_=c$(t,23)|0;$=178547;aa=_+23|0;do{b[_>>0]=b[$>>0]|0;_=_+1|0;$=$+1|0}while((_|0)<(aa|0));j$(-215,t,178318,177754,4345);d$(t)}f[s>>2]=e;SLa(t,178571,s)|0;lV(f[z>>2]|0,t)}lV(f[z>>2]|0,178631)}else{s=(ya|0)<1024?ya:1024;RMa(f[xa+64>>2]|0,0-s|0,2)|0;xa=_F(s+2|0)|0;ya=-1;i:while(1){while(1){za=iMa(f[(f[z>>2]|0)+64>>2]|0)|0;Aa=CV(f[z>>2]|0,xa,s)|0;if(!Aa)break i;e=SKa(Aa,178649)|0;if(e|0){Ba=e;break}}while(1){ia=SKa(Ba+17|0,178649)|0;if(!ia)break;else Ba=ia}ya=za-Aa+Ba|0}$F(xa);if((ya|0)<0){BV(z);f[t>>2]=0;f[t+4>>2]=0;_=c$(t,53)|0;$=178667;aa=_+53|0;do{b[_>>0]=b[$>>0]|0;_=_+1|0;$=$+1|0}while((_|0)<(aa|0));j$(-2,t,178318,177754,4383);d$(t)}xa=f[z>>2]|0;Ba=xa+64|0;Aa=f[Ba>>2]|0;if(!Aa){za=xa+68|0;s=f[za>>2]|0;if(!s)Ca=za;else{kDa(s)|0;Ca=za}}else{GMa(Aa)|0;Ca=xa+68|0}f[Ba>>2]=0;f[Ca>>2]=0;f[xa+256>>2]=0;f[xa+264>>2]=0;b[xa+300>>0]=0;xa=NMa(f[(f[z>>2]|0)+60>>2]|0,178721)|0;f[(f[z>>2]|0)+64>>2]=xa;if(!xa){f[t>>2]=0;f[t+4>>2]=0;Ca=c$(t,8)|0;Ba=Ca;b[Ba>>0]=102;b[Ba+1>>0]=115;b[Ba+2>>0]=45;b[Ba+3>>0]=62;Ba=Ca+4|0;b[Ba>>0]=102;b[Ba+1>>0]=105;b[Ba+2>>0]=108;b[Ba+3>>0]=101;j$(-215,t,178318,177754,4387);d$(t);Da=f[(f[z>>2]|0)+64>>2]|0}else Da=xa;RMa(Da,ya,0)|0;lV(f[z>>2]|0,178725);RMa(f[(f[z>>2]|0)+64>>2]|0,0,2)|0;lV(f[z>>2]|0,353714)}Ea=f[z>>2]|0;Fa=179;Ga=22;Ha=144;Ia=180;Ja=939;Ka=940;La=143;break}case 16:{if(D)lV(h,178758);else lV(h,178743);Ea=f[z>>2]|0;Fa=181;Ga=23;Ha=146;Ia=182;Ja=941;Ka=942;La=145;break}default:{j:do if(D){k:do if(!(RMa(f[h+64>>2]|0,0,2)|0)){ya=0;while(1){if((LMa(f[(f[z>>2]|0)+64>>2]|0)|0)==125)break;Da=ya+-1|0;if(!(RMa(f[(f[z>>2]|0)+64>>2]|0,Da,2)|0))ya=Da;else break k}RMa(f[(f[z>>2]|0)+64>>2]|0,ya,2)|0;Da=f[z>>2]|0;xa=Da+64|0;Ba=f[xa>>2]|0;if(!Ba){Ca=Da+68|0;Aa=f[Ca>>2]|0;if(!Aa)Ma=Ca;else{kDa(Aa)|0;Ma=Ca}}else{GMa(Ba)|0;Ma=Da+68|0}f[xa>>2]=0;f[Ma>>2]=0;f[Da+256>>2]=0;f[Da+264>>2]=0;b[Da+300>>0]=0;Da=NMa(f[(f[z>>2]|0)+60>>2]|0,178721)|0;f[(f[z>>2]|0)+64>>2]=Da;if(!Da){f[t>>2]=0;f[t+4>>2]=0;xa=c$(t,8)|0;Ba=xa;b[Ba>>0]=102;b[Ba+1>>0]=115;b[Ba+2>>0]=45;b[Ba+3>>0]=62;Ba=xa+4|0;b[Ba>>0]=102;b[Ba+1>>0]=105;b[Ba+2>>0]=108;b[Ba+3>>0]=101;j$(-215,t,178318,177754,4441);d$(t);Na=f[(f[z>>2]|0)+64>>2]|0}else Na=Da;RMa(Na,ya,2)|0;EMa(44,f[(f[z>>2]|0)+64>>2]|0)|0;break j}while(0);f[t>>2]=0;f[t+4>>2]=0;_=c$(t,39)|0;$=178770;aa=_+39|0;do{b[_>>0]=b[$>>0]|0;_=_+1|0;$=$+1|0}while((_|0)<(aa|0));j$(-2,t,178318,177754,4447);d$(t)}else lV(h,178767);while(0);h=f[z>>2]|0;f[h+40>>2]=4;Ea=h;Fa=183;Ga=24;Ha=148;Ia=184;Ja=943;Ka=944;La=147}}f[Ea+228>>2]=La;f[Ea+232>>2]=Ja;f[Ea+236>>2]=Fa;f[Ea+240>>2]=Ga;f[Ea+244>>2]=Ha;f[Ea+248>>2]=Ia;f[Ea+252>>2]=Ka;qa=Ea}b[qa+300>>0]=1;fa=qa}l:do if(!fa)Oa=0;else{do if((S$()|0)>=0){qa=f[z>>2]|0;Ea=qa+64|0;Ka=f[Ea>>2]|0;Ia=(Ka|0)==0;if(((Ia?(f[qa+68>>2]|0)==0:0)?(f[qa+268>>2]|0)==0:0)?(f[qa+256>>2]|0)==0:0)break;if(f[qa+8>>2]|0){Oa=qa;break l}if(Ia){Ia=qa+68|0;Ha=f[Ia>>2]|0;if(!Ha)Pa=Ia;else{kDa(Ha)|0;Pa=Ia}}else{GMa(Ka)|0;Pa=qa+68|0}f[Ea>>2]=0;f[Pa>>2]=0;f[qa+256>>2]=0;f[qa+264>>2]=0;b[qa+300>>0]=0;qa=f[z>>2]|0;b[qa+300>>0]=1;Oa=qa;break l}while(0);BV(z);Oa=f[z>>2]|0}while(0);z=f[A>>2]|0;if(!z){u=g;return Oa|0}Pa=f[H>>2]|0;if((Pa|0)==(z|0))Qa=z;else{fa=Pa;while(1){Pa=fa+-12|0;f[H>>2]=Pa;if((b[Pa+11>>0]|0)<0){PYa(f[Pa>>2]|0);Ra=f[H>>2]|0}else Ra=Pa;if((Ra|0)==(z|0))break;else fa=Ra}Qa=f[A>>2]|0}PYa(Qa);u=g;return Oa|0}function xV(a){a=a|0;PYa(a);return}function yV(a){a=a|0;a1(a+12|0,f[a+8>>2]|0);if(!a)return;ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function zV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=f[a>>2]|0;g=((f[d>>2]|0)-e|0)/12|0;h=g+1|0;if(h>>>0>357913941)gXa(a);i=a+8|0;j=((f[i>>2]|0)-e|0)/12|0;e=j<<1;k=j>>>0<178956970?(e>>>0<h>>>0?h:e):357913941;do if(k)if(k>>>0>357913941){e=De(8)|0;UYa(e,358155);f[e>>2]=130560;Of(e|0,21520,875)}else{l=NYa(k*12|0)|0;break}else l=0;while(0);e=l+(g*12|0)|0;g=e;h=l+(k*12|0)|0;YYa(e,c);c=e+12|0;k=f[a>>2]|0;l=f[d>>2]|0;if((l|0)==(k|0)){m=g;n=k;o=k}else{j=e;e=l;l=g;do{e=e+-12|0;YYa(j+-12|0,e);j=l+-12|0;l=j}while((e|0)!=(k|0));m=l;n=f[a>>2]|0;o=f[d>>2]|0}f[a>>2]=m;f[d>>2]=c;f[i>>2]=h;h=n;if((o|0)!=(h|0)){i=o;do{i=i+-12|0;if((b[i+11>>0]|0)<0)PYa(f[i>>2]|0)}while((i|0)!=(h|0))}if(!n)return;PYa(n);return}function AV(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=(d-c|0)/12|0;g=a+8|0;h=f[g>>2]|0;i=f[a>>2]|0;j=i;if(e>>>0<=((h-i|0)/12|0)>>>0){k=a+4|0;l=((f[k>>2]|0)-i|0)/12|0;m=e>>>0>l>>>0;n=c+(l*12|0)|0;l=m?n:d;if((l|0)==(c|0))o=j;else{p=c;q=j;while(1){$Ya(q,p)|0;p=p+12|0;r=q+12|0;if((p|0)==(l|0)){o=r;break}else q=r}}if(m){if((l|0)==(d|0))return;l=f[k>>2]|0;m=n;do{YYa(l,m);m=m+12|0;l=(f[k>>2]|0)+12|0;f[k>>2]=l}while((m|0)!=(d|0));return}m=f[k>>2]|0;if((m|0)==(o|0))return;else s=m;while(1){m=s+-12|0;f[k>>2]=m;if((b[m+11>>0]|0)<0){PYa(f[m>>2]|0);t=f[k>>2]|0}else t=m;if((t|0)==(o|0))break;else s=t}return}if(!i)u=h;else{h=a+4|0;t=f[h>>2]|0;if((t|0)==(j|0))v=i;else{i=t;while(1){t=i+-12|0;f[h>>2]=t;if((b[t+11>>0]|0)<0){PYa(f[t>>2]|0);w=f[h>>2]|0}else w=t;if((w|0)==(j|0))break;else i=w}v=f[a>>2]|0}PYa(v);f[g>>2]=0;f[h>>2]=0;f[a>>2]=0;u=0}if(e>>>0>357913941)gXa(a);h=(u|0)/12|0;u=h<<1;v=h>>>0<178956970?(u>>>0<e>>>0?e:u):357913941;if(v>>>0>357913941)gXa(a);u=NYa(v*12|0)|0;e=a+4|0;f[e>>2]=u;f[a>>2]=u;f[g>>2]=u+(v*12|0);if((c|0)==(d|0))return;v=u;u=c;do{YYa(v,u);u=u+12|0;v=(f[e>>2]|0)+12|0;f[e>>2]=v}while((u|0)!=(d|0));return}function BV(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;e=c$(d,35)|0;g=177709;h=e+35|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));j$(-27,d,183575,177754,700);d$(d)}d=f[a>>2]|0;if(!d){u=c;return}f[a>>2]=0;jV(d,0);rL(d+24|0);a=d+76|0;$F(f[a>>2]|0);f[a>>2]=0;rL(d+16|0);a=f[d+268>>2]|0;if(a|0){g=a+4|0;e=f[g>>2]|0;h=a+16|0;i=f[h>>2]|0;j=e+(i>>>12<<2)|0;k=a+8|0;l=f[k>>2]|0;m=l;n=e;if((l|0)==(e|0)){o=a+20|0;p=0;q=0}else{l=a+20|0;r=(f[l>>2]|0)+i|0;o=l;p=(f[e+(r>>>12<<2)>>2]|0)+(r&4095)|0;q=(f[j>>2]|0)+(i&4095)|0}i=j;j=q;a:while(1){q=j;do{r=q;if((r|0)==(p|0))break a;q=r+1|0}while((q-(f[i>>2]|0)|0)!=4096);q=i+4|0;i=q;j=f[q>>2]|0}f[o>>2]=0;o=m-n>>2;if(o>>>0>2){n=e;do{PYa(f[n>>2]|0);n=(f[g>>2]|0)+4|0;f[g>>2]=n;e=(f[k>>2]|0)-n>>2}while(e>>>0>2);s=e}else s=o;switch(s|0){case 1:{t=2048;v=17;break}case 2:{t=4096;v=17;break}default:{}}if((v|0)==17)f[h>>2]=t;t=f[g>>2]|0;h=f[k>>2]|0;if((t|0)!=(h|0)){v=t;do{PYa(f[v>>2]|0);v=v+4|0}while((v|0)!=(h|0));h=f[g>>2]|0;g=f[k>>2]|0;if((g|0)!=(h|0))f[k>>2]=g+(~((g+-4-h|0)>>>2)<<2)}h=f[a>>2]|0;if(h|0)PYa(h);PYa(a)}a=f[d+272>>2]|0;if(a|0){h=f[a>>2]|0;if(h|0){sV(h);PYa(h)}h=a+4|0;if((b[h+11>>0]|0)<0)PYa(f[h>>2]|0);PYa(a)}a=f[d+288>>2]|0;if(a|0)QYa(a);a=f[d+296>>2]|0;if(a|0)QYa(a);F1a(d|0,0,304)|0;$F(d);u=c;return}function CV(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+16|0;g=e;h=f[a+256>>2]|0;if(h|0){i=a+264|0;j=f[a+260>>2]|0;k=d+-1|0;l=f[i>>2]|0;m=0;while(1){if(!((m|0)<(k|0)&l>>>0<j>>>0)){n=l;o=m;break}p=l+1|0;q=b[h+l>>0]|0;r=m+1|0;if(!(q<<24>>24)){n=p;o=m;break}b[c+m>>0]=q;if(q<<24>>24==10){n=p;o=r;break}else{l=p;m=r}}b[c+o>>0]=0;f[i>>2]=n;s=(o|0)>0?c:0;u=e;return s|0}o=f[a+64>>2]|0;if(o|0){s=MLa(c,d,o)|0;u=e;return s|0}o=f[a+68>>2]|0;if(!o){f[g>>2]=0;f[g+4>>2]=0;a=c$(g,25)|0;n=177829;i=a+25|0;do{b[a>>0]=b[n>>0]|0;a=a+1|0;n=n+1|0}while((a|0)<(i|0));j$(-2,g,183567,177754,434);d$(g);s=0;u=e;return s|0}else{s=tDa(o,c,d)|0;u=e;return s|0}return 0}function DV(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+80|0;h=g+48|0;i=g+8|0;j=g;k=d&15|32;if((d&7)>>>0<=4){f[j>>2]=0;f[j+4>>2]=0;l=c$(j,66)|0;m=183477;n=l+66|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-5,j,183544,177754,2974);d$(j)}if((e|0)!=0?(b[e>>0]|0)!=0:0){f[i>>2]=180446;f[i+4>>2]=e;o=2}else o=0;f[i+(o<<2)>>2]=0;MW(a,c,1,i,0);i=a+44|0;f[h+20>>2]=f[i>>2]&-33;o=a+40|0;f[h+16>>2]=f[o>>2];e=a+48|0;m=e;l=f[m+4>>2]|0;n=h+8|0;f[n>>2]=f[m>>2];f[n+4>>2]=l;l=a+24|0;tL(f[l>>2]|0,h);NL(f[a+36>>2]|0,h)|0;h=(f[o>>2]|0)+2|0;f[o>>2]=h;if(!(d&8)){d=a+72|0;n=f[d>>2]|0;m=a+76|0;p=f[m>>2]|0;q=a+56|0;r=f[q>>2]|0;if(n>>>0>(p+r|0)>>>0){b[n>>0]=10;b[n+1>>0]=0;lV(a,f[m>>2]|0);n=f[m>>2]|0;f[d>>2]=n;s=f[q>>2]|0;t=f[o>>2]|0;v=n}else{s=r;t=h;v=p}if((s|0)==(t|0))w=v;else{F1a(v|0,32,t|0)|0;f[q>>2]=t;w=f[m>>2]|0}f[d>>2]=w+t}f[i>>2]=k;if(!c){f[a+52>>2]=0;f[e>>2]=0;u=g;return}else{xL(j,f[l>>2]|0,c,-1);c=j;j=f[c+4>>2]|0;l=e;f[l>>2]=f[c>>2];f[l+4>>2]=j;u=g;return}}function EV(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+5136|0;h=g+8|0;i=g+16|0;j=g;k=d&15|32;l=d&7;if(l>>>0<=4){f[j>>2]=0;f[j+4>>2]=0;d=c$(j,68)|0;m=183337;n=d+68|0;do{b[d>>0]=b[m>>0]|0;d=d+1|0;m=m+1|0}while((d|0)<(n|0));j$(-5,j,183453,177754,3965);d$(j)}if((e|0)!=0?(b[e>>0]|0)!=0:0)if(!(yKa(e,178191,6)|0)){o=i;p=0;q=3;r=e}else{s=1;t=e;v=6}else{s=0;t=0;v=6}if((v|0)==6){b[i>>0]=(l|0)==6?123:91;o=i+1|0;p=s;q=k;r=t}b[o>>0]=0;KW(a,c,i);i=a+44|0;f[h>>2]=f[i>>2];NL(f[a+36>>2]|0,h)|0;f[i>>2]=q;q=a+40|0;f[q>>2]=(f[q>>2]|0)+4;if(!p){u=g;return}Ah[f[a+244>>2]&255](a,180446,r,1);u=g;return}function FV(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+5152|0;h=g+8|0;i=g;j=g+24|0;k=g+32|0;l=g+16|0;if(!e)m=0;else m=(b[e>>0]|0)==0?0:e;e=d&15;n=e|32;o=d&7;if(o>>>0<=4){f[l>>2]=0;f[l+4>>2]=0;p=c$(l,68)|0;q=183337;r=p+68|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-5,l,183406,177754,2011);d$(l)}l=(m|0)!=0;if(l?(yKa(m,178191,6)|0)==0:0){p=k;q=183429;r=p+11|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));s=k;t=5}else v=8;do if((v|0)==8){if(!(d&8)){if(!l){s=0;t=n;break}f[h>>2]=m;SLa(k,183448,h)|0;s=k;t=n;break}q=(o|0)==6?123:91;p=e|40;if(l){f[i>>2]=m;f[i+4>>2]=q&255;SLa(k,183440,i)|0;s=k;t=p;break}else{b[k>>0]=q;b[k+1>>0]=0;s=k;t=p;break}}while(0);JW(a,c,s);s=a+44|0;f[j>>2]=f[s>>2];NL(f[a+36>>2]|0,j)|0;f[s>>2]=t;s=a+40|0;if(f[j>>2]&8|0){u=g;return}f[s>>2]=(t>>>3&1)+3+(f[s>>2]|0);u=g;return}function GV(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+32|0;d=c+8|0;e=c;g=a+36|0;if(!(f[(f[g>>2]|0)+24>>2]|0)){f[e>>2]=0;f[e+4>>2]=0;h=c$(e,20)|0;i=183295;j=h+20|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-2,e,183316,177754,3017);d$(e)}MW(a,f[a+52>>2]|0,2,0,0);OL(f[g>>2]|0,d);f[a+40>>2]=f[d+16>>2];f[a+44>>2]=f[d+20>>2];g=d+8|0;e=f[g+4>>2]|0;i=a+48|0;f[i>>2]=f[g>>2];f[i+4>>2]=e;uL(f[a+24>>2]|0,d);u=c;return}function HV(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=u;u=u+16|0;d=c;e=a+36|0;g=f[e>>2]|0;if(!(f[g+24>>2]|0)){f[d>>2]=0;f[d+4>>2]=0;h=c$(d,44)|0;i=183207;j=h+44|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-2,d,183273,177754,4006);d$(d);k=f[e>>2]|0}else k=g;f[d>>2]=0;g=a+44|0;e=f[g>>2]|0;OL(k,d);k=a+40|0;i=(f[k>>2]|0)+-4|0;f[k>>2]=i;f[g>>2]=f[d>>2]&-33;d=e&7;if(d>>>0<=4){u=c;return}g=a+72|0;h=f[g>>2]|0;j=a+76|0;l=f[j>>2]|0;if(!(e&8)){m=a+56|0;n=f[m>>2]|0;if(h>>>0>(l+n|0)>>>0){o=l;p=n;q=h}else{f[g>>2]=h+1;b[h>>0]=10;n=f[g>>2]|0;f[g>>2]=n+1;b[n>>0]=0;lV(a,f[j>>2]|0);n=f[j>>2]|0;f[g>>2]=n;r=n;o=r;p=f[m>>2]|0;q=r}if(q>>>0>(o+p|0)>>>0){b[q>>0]=10;b[q+1>>0]=0;lV(a,f[j>>2]|0);a=f[j>>2]|0;f[g>>2]=a;s=f[m>>2]|0;t=a}else{s=p;t=o}o=f[k>>2]|0;if((s|0)==(o|0)){v=s;w=t;x=s}else{F1a(t|0,32,o|0)|0;f[m>>2]=o;v=f[k>>2]|0;w=f[j>>2]|0;x=o}o=w+x|0;f[g>>2]=o;y=w;z=v;A=o}else{y=l;z=i;A=h}if((e&32|0)==0&A>>>0>(y+z|0)>>>0){b[A>>0]=32;B=A+1|0}else B=A;b[B>>0]=(d|0)==6?125:93;f[g>>2]=B+1;u=c;return}function IV(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;c=u;u=u+16|0;d=c+8|0;e=c;f[d>>2]=0;g=a+44|0;h=f[g>>2]|0;i=a+36|0;j=f[i>>2]|0;if(!(f[j+24>>2]|0)){f[e>>2]=0;f[e+4>>2]=0;k=c$(e,44)|0;l=183207;m=k+44|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-2,e,183252,177754,2059);d$(e);n=f[i>>2]|0}else n=j;OL(n,d);n=h&8;if(!n){if(h&32|0){j=a+72|0;i=f[j>>2]|0;e=a+76|0;l=f[e>>2]|0;k=a+56|0;m=f[k>>2]|0;if(i>>>0>(l+m|0)>>>0){b[i>>0]=10;b[i+1>>0]=0;lV(a,f[e>>2]|0);i=f[e>>2]|0;f[j>>2]=i;o=f[k>>2]|0;p=i}else{o=m;p=l}l=f[a+40>>2]|0;if((o|0)==(l|0)){q=p;r=o}else{F1a(p|0,32,l|0)|0;f[k>>2]=l;q=f[e>>2]|0;r=l}l=q+r|0;f[j>>2]=l;r=(h&7|0)==6?32123:23899;b[l>>0]=r;b[l+1>>0]=r>>8;s=l+2|0;t=j;v=13}}else{j=a+72|0;l=f[j>>2]|0;if((h&32|0)==0?l>>>0>((f[a+76>>2]|0)+(f[a+40>>2]|0)|0)>>>0:0){b[l>>0]=32;w=l+1|0}else w=l;b[w>>0]=(h&7|0)==6?125:93;s=w+1|0;t=j;v=13}if((v|0)==13)f[t>>2]=s;s=f[d>>2]|0;d=a+40|0;if(s&8|0){f[g>>2]=s;u=c;return}f[d>>2]=-3-(n>>>3)+(f[d>>2]|0);f[g>>2]=s;u=c;return}function JV(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+128|0;f=e+23|0;b[f>>0]=0;g=f;f=(d|0)>-1?d:0-d|0;while(1){h=f;f=(f>>>0)/10|0;i=h+48+(Y(f,-10)|0)&255;j=g+-1|0;b[j>>0]=i;if(h>>>0<=9)break;else g=j}if((d|0)<0){d=g+-2|0;b[d>>0]=45;k=d}else k=j;LW(a,c,k,xKa(k)|0);u=e;return}function KV(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+128|0;f=e+23|0;b[f>>0]=0;g=f;f=(d|0)>-1?d:0-d|0;while(1){h=f;f=(f>>>0)/10|0;i=h+48+(Y(f,-10)|0)&255;j=g+-1|0;b[j>>0]=i;if(h>>>0<=9)break;else g=j}if((d|0)>=0){k=j;KW(a,c,k);u=e;return}j=g+-2|0;b[j>>0]=45;k=j;KW(a,c,k);u=e;return}function LV(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+128|0;f=e+23|0;b[f>>0]=0;g=f;f=(d|0)>-1?d:0-d|0;while(1){h=f;f=(f>>>0)/10|0;i=h+48+(Y(f,-10)|0)&255;j=g+-1|0;b[j>>0]=i;if(h>>>0<=9)break;else g=j}if((d|0)>=0){k=j;JW(a,c,k);u=e;return}j=g+-2|0;b[j>>0]=45;k=j;JW(a,c,k);u=e;return}function MV(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;d=u;u=u+128|0;e=d;LW(a,b,e,xKa(NW(e,c)|0)|0);u=d;return}function NV(a,c,d){a=a|0;c=c|0;d=+d;var e=0,f=0,g=0;e=u;u=u+128|0;f=e;g=xKa(NW(f,d)|0)|0;if(g|0?(b[f+(g+-1)>>0]|0)==46:0){b[f+g>>0]=48;b[f+(g+1)>>0]=0}KW(a,c,f);u=e;return}function OV(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=u;u=u+128|0;JW(a,b,NW(d,c)|0);u=d;return}function PV(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=u;u=u+24608|0;h=g;i=g+16|0;j=g+8|0;if(!d){f[j>>2]=0;f[j+4>>2]=0;k=c$(j,19)|0;l=182444;m=k+19|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-27,j,182841,177754,3122);d$(j)}n=xKa(d)|0;if((n|0)>4096){f[j>>2]=0;f[j+4>>2]=0;k=c$(j,30)|0;l=182482;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-5,j,182841,177754,3126);d$(j)}j=(e|0)!=0|(n|0)==0;if((!j?(b[d>>0]|0)==34:0)?(b[d+(n+-1)>>0]|0)==34:0){o=d;p=n;LW(a,c,o,p);u=g;return}e=j&1;j=i+1|0;b[i>>0]=34;if((n|0)>0){l=j;k=0;m=e;while(1){q=b[d+k>>0]|0;r=q&255;a:do if(q<<24>>24<0|q<<24>>24==32){b[l>>0]=q;s=l;t=1}else{b:do if((q&255)>=32){switch(q<<24>>24){case 34:case 38:case 39:case 60:case 62:{break b;break}default:{}}b[l>>0]=q;s=l;t=m;break a}while(0);v=l+1|0;b[l>>0]=38;switch(q<<24>>24){case 60:{b[v>>0]=108;b[v+1>>0]=116;w=3;break}case 62:{b[v>>0]=103;b[v+1>>0]=116;w=3;break}case 38:{b[v>>0]=b[181719]|0;b[v+1>>0]=b[181720]|0;b[v+2>>0]=b[181721]|0;w=4;break}case 39:{b[v>>0]=97;b[v+1>>0]=112;b[v+2>>0]=111;b[v+3>>0]=115;w=5;break}case 34:{b[v>>0]=113;b[v+1>>0]=117;b[v+2>>0]=111;b[v+3>>0]=116;w=5;break}default:{f[h>>2]=r;SLa(v,182859,h)|0;w=5}}v=l+w|0;b[v>>0]=59;s=v;t=1}while(0);r=s+1|0;k=k+1|0;if((k|0)==(n|0)){x=r;y=t;break}else{l=r;m=t}}}else{x=j;y=e}if(!y){e=b[d>>0]|0;if((e+-48&255)<10){z=1;A=26}else switch(e<<24>>24){case 46:case 45:case 43:{z=1;A=26;break}default:{B=x;C=1}}}else{z=y;A=26}if((A|0)==26){b[x>>0]=34;B=x+1|0;C=(z|0)==0}b[B>>0]=0;o=i+(C&1)|0;p=(C<<31>>31)-i+B|0;LW(a,c,o,p);u=g;return}function QV(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16416|0;h=g+8|0;i=g;if(!d){f[i>>2]=0;f[i+4>>2]=0;j=c$(i,19)|0;k=182444;l=j+19|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-27,i,182809,177754,4086);d$(i)}m=xKa(d)|0;if((m|0)>4096){f[i>>2]=0;f[i+4>>2]=0;j=c$(i,30)|0;k=182482;l=j+30|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-5,i,182809,177754,4090);d$(i)}a:do if(!((e|0)!=0|(m|0)==0)?(i=b[d>>0]|0,i<<24>>24==(b[d+(m+-1)>>0]|0)):0){switch(i<<24>>24){case 39:case 34:{n=d;break}default:break a}KW(a,c,n);u=g;return}while(0);e=h+1|0;b[h>>0]=34;b:do if((m|0)>0){i=e;k=0;while(1){j=b[d+k>>0]|0;switch(j<<24>>24|0){case 39:case 34:case 92:{b[i>>0]=92;b[i+1>>0]=j;o=i+2|0;break}case 10:{b[i>>0]=92;b[i+1>>0]=110;o=i+2|0;break}case 13:{b[i>>0]=92;b[i+1>>0]=114;o=i+2|0;break}case 9:{b[i>>0]=92;b[i+1>>0]=116;o=i+2|0;break}case 8:{b[i>>0]=92;b[i+1>>0]=98;o=i+2|0;break}case 12:{b[i>>0]=92;b[i+1>>0]=102;o=i+2|0;break}default:{b[i>>0]=j;o=i+1|0}}k=k+1|0;if((k|0)==(m|0)){p=o;break b}else i=o}}else p=e;while(0);b[p>>0]=34;b[p+1>>0]=0;n=h;KW(a,c,n);u=g;return}function RV(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=u;u=u+16416|0;h=g;i=g+16|0;j=g+8|0;if(!d){f[j>>2]=0;f[j+4>>2]=0;k=c$(j,19)|0;l=182444;m=k+19|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-27,j,182464,177754,2128);d$(j)}n=xKa(d)|0;if((n|0)>4096){f[j>>2]=0;f[j+4>>2]=0;k=c$(j,30)|0;l=182482;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-5,j,182464,177754,2132);d$(j)}if((e|0)!=0|(n|0)==0)o=1;else{e=b[d>>0]|0;a:do if(e<<24>>24==(b[d+(n+-1)>>0]|0)){switch(e<<24>>24){case 39:case 34:{p=d;break}default:break a}JW(a,c,p);u=g;return}while(0);o=e<<24>>24==32}e=o&1;j=i+1|0;b[i>>0]=34;if((n|0)>0){l=j;k=0;m=e;q=o;while(1){r=b[d+k>>0]|0;s=r+-48<<24>>24;b:do if(!q){t=(r&-33)+-65<<24>>24;if((s&255)<10|(t&255)<26){v=t;w=0}else{switch(r<<24>>24){case 32:case 40:case 41:case 43:case 45:case 47:case 59:case 95:{v=t;w=0;break b;break}default:{}}v=t;w=1}}else{v=(r&-33)+-65<<24>>24;w=m}while(0);c:do if((s&255)<10|(v&255)<26)x=24;else{if((r&255)>31){switch(r<<24>>24){case 34:case 39:case 92:break;default:{x=24;break c}}b[l>>0]=92;b[l+1>>0]=r;y=l+2|0;break}t=l+1|0;b[l>>0]=92;switch(r<<24>>24){case 10:{b[t>>0]=110;y=l+2|0;break c;break}case 13:{b[t>>0]=114;y=l+2|0;break c;break}case 9:{b[t>>0]=116;y=l+2|0;break c;break}default:{f[h>>2]=r<<24>>24;SLa(t,182513,h)|0;y=l+4|0;break c}}}while(0);if((x|0)==24){x=0;b[l>>0]=r;y=l+1|0}k=k+1|0;s=(w|0)!=0;if((k|0)==(n|0)){z=y;A=w;B=s;break}else{l=y;m=w;q=s}}}else{z=j;A=e;B=o}if(!B){B=b[d>>0]|0;if((B+-48&255)<10){C=1;x=29}else switch(B<<24>>24){case 46:case 45:case 43:{C=1;x=29;break}default:{D=z;E=1}}}else{C=A;x=29}if((x|0)==29){b[z>>0]=34;D=z+1|0;E=(C|0)==0}b[D>>0]=0;p=i+(E&1)|0;JW(a,c,p);u=g;return}function SV(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=u;u=u+16|0;g=e;h=e+8|0;i=(c|0)==0;if(i){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,12)|0;k=182306;l=j+12|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-27,h,182358,177754,3205);d$(h)}if(SKa(c,373143)|0){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,49)|0;k=182377;l=j+49|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-5,h,182358,177754,3208);d$(h)}h=xKa(c)|0;k=TKa(c,10)|0;j=(k|0)!=0;l=a+72|0;m=f[l>>2]|0;if((d|0)!=0&(j^1)?((f[a+80>>2]|0)-m|0)>=(h+5|0):0)if(m>>>0>((f[a+76>>2]|0)+(f[a+40>>2]|0)|0)>>>0){b[m>>0]=32;n=m+1|0}else n=m;else{d=a+76|0;o=f[d>>2]|0;p=a+56|0;q=f[p>>2]|0;if(m>>>0>(o+q|0)>>>0){b[m>>0]=10;b[m+1>>0]=0;lV(a,f[d>>2]|0);m=f[d>>2]|0;f[l>>2]=m;r=f[p>>2]|0;s=m}else{r=q;s=o}o=f[a+40>>2]|0;if((r|0)==(o|0)){t=s;v=r}else{F1a(s|0,32,o|0)|0;f[p>>2]=o;t=f[d>>2]|0;v=o}o=t+v|0;f[l>>2]=o;n=o}if(j){b[n>>0]=b[182439]|0;b[n+1>>0]=b[182440]|0;b[n+2>>0]=b[182441]|0;b[n+3>>0]=b[182442]|0;b[n+4>>0]=b[182443]|0;w=4;x=n}else{o=h+9|0;h=a+80|0;v=f[h>>2]|0;if((n+o|0)>>>0<v>>>0)y=n;else{t=a+76|0;d=f[t>>2]|0;p=n-d|0;n=((v-d|0)*3|0)/2|0;d=p+o|0;o=(d|0)<(n|0)?n:d;d=_F(o+256|0)|0;n=f[t>>2]|0;f[l>>2]=d+((f[l>>2]|0)-n);if((p|0)>0)K1a(d|0,n|0,p|0)|0;f[t>>2]=d;f[h>>2]=d+o;y=d+p|0}f[g>>2]=c;SLa(y,182427,g)|0;w=xKa(y)|0;x=y}y=x+w|0;f[l>>2]=y;w=a+76|0;x=f[w>>2]|0;g=a+56|0;p=f[g>>2]|0;if(y>>>0>(x+p|0)>>>0){b[y>>0]=10;b[y+1>>0]=0;lV(a,f[w>>2]|0);y=f[w>>2]|0;f[l>>2]=y;z=f[g>>2]|0;A=y;B=y}else{z=p;A=x;B=x}x=a+40|0;p=f[x>>2]|0;if((z|0)==(p|0)){C=A;D=z;E=B}else{F1a(A|0,32,p|0)|0;f[g>>2]=p;A=f[w>>2]|0;C=A;D=p;E=A}A=C+D|0;f[l>>2]=A;if(!j){u=e;return}if(i)F=A;else{i=a+80|0;j=E;E=c;c=k;k=A;while(1){if(!c){A=xKa(E)|0;D=f[i>>2]|0;if((k+A|0)>>>0<D>>>0)G=k;else{C=k-j|0;p=((D-j|0)*3|0)/2|0;D=C+A|0;B=(D|0)<(p|0)?p:D;D=_F(B+256|0)|0;p=f[w>>2]|0;f[l>>2]=D+((f[l>>2]|0)-p);if((C|0)>0)K1a(D|0,p|0,C|0)|0;f[w>>2]=D;f[i>>2]=D+B;G=D+C|0}K1a(G|0,E|0,A|0)|0;H=0;I=0;J=G+A|0}else{A=c-E|0;C=A+1|0;D=f[i>>2]|0;if((k+C|0)>>>0<D>>>0)K=k;else{B=k-j|0;p=((D-j|0)*3|0)/2|0;D=B+C|0;z=(D|0)<(p|0)?p:D;D=_F(z+256|0)|0;p=f[w>>2]|0;f[l>>2]=D+((f[l>>2]|0)-p);if((B|0)>0)K1a(D|0,p|0,B|0)|0;f[w>>2]=D;f[i>>2]=D+z;K=D+B|0}K1a(K|0,E|0,C|0)|0;C=c+1|0;H=C;I=TKa(C,10)|0;J=K+A|0}f[l>>2]=J;A=f[w>>2]|0;C=f[g>>2]|0;if(J>>>0>(A+C|0)>>>0){b[J>>0]=10;b[J+1>>0]=0;lV(a,f[w>>2]|0);B=f[w>>2]|0;f[l>>2]=B;L=f[g>>2]|0;M=B;N=B}else{L=C;M=A;N=A}A=f[x>>2]|0;if((L|0)==(A|0)){O=M;P=L;Q=N}else{F1a(M|0,32,A|0)|0;f[g>>2]=A;C=f[w>>2]|0;O=C;P=A;Q=C}C=O+P|0;f[l>>2]=C;if(!H){F=C;break}else{j=Q;E=H;c=I;k=C}}}b[F>>0]=45;b[F+1>>0]=45;b[F+2>>0]=62;b[F+3>>0]=0;k=F+3|0;f[l>>2]=k;I=f[w>>2]|0;c=f[g>>2]|0;if(k>>>0>(I+c|0)>>>0){b[k>>0]=10;b[F+4>>0]=0;lV(a,f[w>>2]|0);a=f[w>>2]|0;f[l>>2]=a;R=f[g>>2]|0;S=a}else{R=c;S=I}I=f[x>>2]|0;if((R|0)==(I|0)){T=S;U=R}else{F1a(S|0,32,I|0)|0;f[g>>2]=I;T=f[w>>2]|0;U=I}f[l>>2]=T+U;u=e;return}function TV(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+16|0;g=e;h=(c|0)==0;if(h){f[g>>2]=0;f[g+4>>2]=0;i=c$(g,12)|0;j=182306;k=i+12|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-27,g,182338,177754,4129);d$(g)}g=a+72|0;j=f[g>>2]|0;i=TKa(c,10)|0;if(((d|0)!=0&(i|0)==0?(d=xKa(c)|0,((f[a+80>>2]|0)-j|0)>=(d|0)):0)?(j|0)!=(f[a+76>>2]|0):0){b[j>>0]=32;l=0;m=j+1|0}else{d=a+76|0;k=f[d>>2]|0;n=a+56|0;o=f[n>>2]|0;if(j>>>0>(k+o|0)>>>0){b[j>>0]=10;b[j+1>>0]=0;lV(a,f[d>>2]|0);j=f[d>>2]|0;f[g>>2]=j;p=j;q=f[n>>2]|0}else{p=k;q=o}o=f[a+40>>2]|0;if((q|0)==(o|0)){r=p;s=q}else{F1a(p|0,32,o|0)|0;f[n>>2]=o;r=f[d>>2]|0;s=o}o=r+s|0;f[g>>2]=o;l=i;m=o}if(h){u=e;return}h=a+80|0;o=a+76|0;i=a+56|0;s=a+40|0;r=c;c=l;l=m;while(1){b[l>>0]=47;b[l+1>>0]=47;m=l+3|0;b[l+2>>0]=32;if(!c){d=xKa(r)|0;n=f[h>>2]|0;if((m+d|0)>>>0<n>>>0)t=m;else{p=f[o>>2]|0;q=m-p|0;k=((n-p|0)*3|0)/2|0;p=q+d|0;n=(p|0)<(k|0)?k:p;p=_F(n+256|0)|0;k=f[o>>2]|0;f[g>>2]=p+((f[g>>2]|0)-k);if((q|0)>0)K1a(p|0,k|0,q|0)|0;f[o>>2]=p;f[h>>2]=p+n;t=p+q|0}K1a(t|0,r|0,d|0)|0;q=t+d|0;f[g>>2]=q;v=q;w=0;x=0}else{q=c-r|0;d=q+1|0;p=f[h>>2]|0;if((m+d|0)>>>0<p>>>0)y=m;else{n=f[o>>2]|0;k=m-n|0;m=((p-n|0)*3|0)/2|0;n=k+d|0;p=(n|0)<(m|0)?m:n;n=_F(p+256|0)|0;m=f[o>>2]|0;f[g>>2]=n+((f[g>>2]|0)-m);if((k|0)>0)K1a(n|0,m|0,k|0)|0;f[o>>2]=n;f[h>>2]=n+p;y=n+k|0}K1a(y|0,r|0,d|0)|0;d=y+q|0;f[g>>2]=d;q=c+1|0;v=d;w=q;x=TKa(q,10)|0}q=f[o>>2]|0;d=f[i>>2]|0;if(v>>>0>(q+d|0)>>>0){b[v>>0]=10;b[v+1>>0]=0;lV(a,f[o>>2]|0);k=f[o>>2]|0;f[g>>2]=k;z=f[i>>2]|0;A=k}else{z=d;A=q}q=f[s>>2]|0;if((z|0)==(q|0)){B=A;C=z}else{F1a(A|0,32,q|0)|0;f[i>>2]=q;B=f[o>>2]|0;C=q}l=B+C|0;f[g>>2]=l;if(!w)break;else{r=w;c=x}}u=e;return}function UV(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+16|0;g=e;h=(c|0)==0;if(h){f[g>>2]=0;f[g+4>>2]=0;i=c$(g,12)|0;j=182306;k=i+12|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-27,g,182319,177754,2190);d$(g)}g=TKa(c,10)|0;j=a+72|0;i=f[j>>2]|0;if((!((d|0)==0|(g|0)!=0)?(d=xKa(c)|0,((f[a+80>>2]|0)-i|0)>=(d|0)):0)?(i|0)!=(f[a+76>>2]|0):0){b[i>>0]=32;l=i+1|0}else{d=a+76|0;k=f[d>>2]|0;m=a+56|0;n=f[m>>2]|0;if(i>>>0>(k+n|0)>>>0){b[i>>0]=10;b[i+1>>0]=0;lV(a,f[d>>2]|0);i=f[d>>2]|0;f[j>>2]=i;o=i;p=f[m>>2]|0}else{o=k;p=n}n=f[a+40>>2]|0;if((p|0)==(n|0)){q=o;r=p}else{F1a(o|0,32,n|0)|0;f[m>>2]=n;q=f[d>>2]|0;r=n}n=q+r|0;f[j>>2]=n;l=n}if(h){u=e;return}h=a+80|0;n=a+76|0;r=a+56|0;q=a+40|0;d=c;c=g;g=l;while(1){b[g>>0]=35;l=g+2|0;b[g+1>>0]=32;if(!c){m=xKa(d)|0;o=f[h>>2]|0;if((l+m|0)>>>0<o>>>0)s=l;else{p=f[n>>2]|0;k=l-p|0;i=((o-p|0)*3|0)/2|0;p=k+m|0;o=(p|0)<(i|0)?i:p;p=_F(o+256|0)|0;i=f[n>>2]|0;f[j>>2]=p+((f[j>>2]|0)-i);if((k|0)>0)K1a(p|0,i|0,k|0)|0;f[n>>2]=p;f[h>>2]=p+o;s=p+k|0}K1a(s|0,d|0,m|0)|0;k=s+m|0;f[j>>2]=k;t=k;v=0;w=0}else{k=c-d|0;m=k+1|0;p=f[h>>2]|0;if((l+m|0)>>>0<p>>>0)x=l;else{o=f[n>>2]|0;i=l-o|0;l=((p-o|0)*3|0)/2|0;o=i+m|0;p=(o|0)<(l|0)?l:o;o=_F(p+256|0)|0;l=f[n>>2]|0;f[j>>2]=o+((f[j>>2]|0)-l);if((i|0)>0)K1a(o|0,l|0,i|0)|0;f[n>>2]=o;f[h>>2]=o+p;x=o+i|0}K1a(x|0,d|0,m|0)|0;m=x+k|0;f[j>>2]=m;k=c+1|0;t=m;v=k;w=TKa(k,10)|0}k=f[n>>2]|0;m=f[r>>2]|0;if(t>>>0>(k+m|0)>>>0){b[t>>0]=10;b[t+1>>0]=0;lV(a,f[n>>2]|0);i=f[n>>2]|0;f[j>>2]=i;y=f[r>>2]|0;z=i}else{y=m;z=k}k=f[q>>2]|0;if((y|0)==(k|0)){A=z;B=y}else{F1a(z|0,32,k|0)|0;f[r>>2]=k;A=f[n>>2]|0;B=k}g=A+B|0;f[j>>2]=g;if(!v)break;else{d=v;c=w}}u=e;return}function VV(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if(f[a+12>>2]|0)return;c=a+36|0;if((f[(f[c>>2]|0)+24>>2]|0)>0)do GV(a);while((f[(f[c>>2]|0)+24>>2]|0)>0);c=a+40|0;f[c>>2]=0;d=a+72|0;e=f[d>>2]|0;g=a+76|0;h=f[g>>2]|0;i=a+56|0;j=f[i>>2]|0;if(e>>>0>(h+j|0)>>>0){b[e>>0]=10;b[e+1>>0]=0;lV(a,f[g>>2]|0);e=f[g>>2]|0;f[d>>2]=e;k=f[i>>2]|0;l=f[c>>2]|0;m=e}else{k=j;l=0;m=h}if((k|0)==(l|0))n=m;else{F1a(m|0,32,l|0)|0;f[i>>2]=l;n=f[g>>2]|0}f[d>>2]=n+l;lV(a,182283);f[d>>2]=f[g>>2];return}function WV(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;if(f[a+12>>2]|0)return;c=a+36|0;if((f[(f[c>>2]|0)+24>>2]|0)>0)do HV(a);while((f[(f[c>>2]|0)+24>>2]|0)>0);c=a+40|0;f[c>>2]=4;d=a+72|0;e=f[d>>2]|0;g=a+76|0;h=f[g>>2]|0;i=a+56|0;j=f[i>>2]|0;if(e>>>0>(h+j|0)>>>0){b[e>>0]=10;b[e+1>>0]=0;lV(a,f[g>>2]|0);a=f[g>>2]|0;f[d>>2]=a;k=f[i>>2]|0;l=f[c>>2]|0;m=a;n=a}else{k=j;l=4;m=h;n=h}if((k|0)==(l|0))o=n;else{F1a(m|0,32,l|0)|0;f[i>>2]=l;o=f[g>>2]|0}f[d>>2]=o;return}function XV(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if(f[a+12>>2]|0)return;c=a+36|0;if((f[(f[c>>2]|0)+24>>2]|0)>0)do IV(a);while((f[(f[c>>2]|0)+24>>2]|0)>0);c=a+40|0;f[c>>2]=0;d=a+72|0;e=f[d>>2]|0;g=a+76|0;h=f[g>>2]|0;i=a+56|0;j=f[i>>2]|0;if(e>>>0>(h+j|0)>>>0){b[e>>0]=10;b[e+1>>0]=0;lV(a,f[g>>2]|0);e=f[g>>2]|0;f[d>>2]=e;k=f[i>>2]|0;l=f[c>>2]|0;m=e}else{k=j;l=0;m=h}if((k|0)==(l|0))n=m;else{F1a(m|0,32,l|0)|0;f[i>>2]=l;n=f[g>>2]|0}f[d>>2]=n+l;lV(a,182273);lV(a,182278);f[d>>2]=f[g>>2];return}function YV(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=u;u=u+1072|0;g=e+32|0;h=e+16|0;i=e;j=e+48|0;k=a+80|0;l=a+76|0;m=a+60|0;n=a+88|0;o=a+256|0;p=a+64|0;q=a+68|0;r=a+264|0;s=a+260|0;t=0;v=d;d=c;a:while(1){c=d+-1|0;b:do switch(v|0){case 1:{w=b[d>>0]|0;c:do if((w&255)>31|w<<24>>24==9){x=w;y=d;z=c;while(1){if((x<<24>>24==45?(b[z+2>>0]|0)==45:0)?(b[z+3>>0]|0)==62:0){A=45;B=y;C=z;break c}D=y+1|0;E=b[D>>0]|0;if((E&255)>31|E<<24>>24==9){F=y;x=E;y=D;z=F}else{A=E;B=D;C=y;break}}}else{A=w;B=d;C=c}while(0);w=A<<24>>24==45;G=t;H=(w^1)&1;I=w?C+4|0:B;break}case 3:{w=t;y=c;while(1){z=y+1|0;x=b[z>>0]|0;D=(x<<24>>24==60&1)+w+((x<<24>>24==62)<<31>>31)|0;if((D|0)<0){J=z;K=34;break a}if((x&255)>31|x<<24>>24==9){w=D;y=z}else{G=D;H=3;I=z;break}}break}default:{y=c;d:while(1){L=y+1|0;M=b[L>>0]|0;switch(M<<24>>24){case 9:case 32:{y=L;break}case 60:{break d;break}default:{K=18;break d}}}if((K|0)==18){K=0;if((M&255)>31){J=L;K=34;break a}else{G=t;H=v;I=L;break b}}if((b[y+2>>0]|0)!=33){J=L;K=34;break a}if((b[y+3>>0]|0)!=45){J=L;K=34;break a}if((b[y+4>>0]|0)!=45){J=L;K=34;break a}if(v|0){w=f[n>>2]|0;f[i>>2]=f[m>>2];f[i+4>>2]=w;f[i+8>>2]=182226;SLa(j,178874,i)|0;T$(-212,182256,j,177754,2278)}G=t;H=1;I=y+5|0}}while(0);c=b[I>>0]|0;if((c&255)>31){t=G;v=H;d=I;continue}w=f[l>>2]|0;z=(f[k>>2]|0)-w|0;switch(c<<24>>24){case 13:case 10:case 0:{N=w;break}default:{w=f[n>>2]|0;f[h>>2]=f[m>>2];f[h+4>>2]=w;f[h+8>>2]=180759;SLa(j,178874,h)|0;T$(-212,182256,j,177754,2290);N=f[l>>2]|0}}w=CV(a,N,z)|0;if(!w){K=33;break}z=w+((xKa(w)|0)+-1)|0;e:do switch(b[z>>0]|0){case 13:case 10:break;default:{do if(!(f[o>>2]|0)){c=f[p>>2]|0;if(c|0){O=yMa(c)|0;K=30;break}c=f[q>>2]|0;if(c|0){O=pDa(c)|0;K=30}}else{O=(f[r>>2]|0)>>>0>=(f[s>>2]|0)>>>0&1;K=30}while(0);if((K|0)==30?(K=0,O|0):0)break e;y=f[n>>2]|0;f[g>>2]=f[m>>2];f[g+4>>2]=y;f[g+8>>2]=181258;SLa(j,178874,g)|0;T$(-212,182256,j,177754,2303)}}while(0);f[n>>2]=(f[n>>2]|0)+1;t=G;v=H;d=w}if((K|0)==33){d=f[l>>2]|0;b[d>>0]=0;f[a+92>>2]=1;J=d;u=e;return J|0}else if((K|0)==34){u=e;return J|0}return 0}function ZV(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;h=u;u=u+1200|0;i=h+160|0;j=h+144|0;k=h+128|0;l=h+112|0;m=h+96|0;n=h+80|0;o=h+64|0;p=h+48|0;q=h+32|0;r=h+16|0;s=h+176|0;t=h;v=b[c>>0]|0;if(!(v<<24>>24)){w=f[a+88>>2]|0;f[r>>2]=f[a+60>>2];f[r+4>>2]=w;f[r+8>>2]=181871;SLa(s,178874,r)|0;T$(-212,181901,s,177754,2681);x=b[c>>0]|0}else x=v;if(x<<24>>24!=60){x=f[a+88>>2]|0;f[q>>2]=f[a+60>>2];f[q+4>>2]=x;f[q+8>>2]=181916;SLa(s,178874,q)|0;T$(-212,181901,s,177754,2684)}q=c+1|0;x=b[q>>0]|0;a:do if(((x&-33)+-65&255)<26|(x+-48&255)<10){y=q;z=1}else switch(x<<24>>24){case 95:{y=q;z=1;break a;break}case 47:{y=c+2|0;z=2;break a;break}case 63:{y=c+2|0;z=4;break a;break}case 33:{y=c+2|0;z=5;break a;break}default:{v=f[a+88>>2]|0;f[p>>2]=f[a+60>>2];f[p+4>>2]=v;f[p+8>>2]=181942;SLa(s,178874,p)|0;T$(-212,181901,s,177754,2706);y=q;z=0;break a}}while(0);q=s+4|0;p=(z|0)==4;c=(z|0)==1;x=a+60|0;v=a+88|0;r=t+8+4|0;w=(z|0)==2;A=a+16|0;B=0;C=0;D=0;E=y;y=0;b:while(1){F=b[E>>0]|0;if(!(((F&-33)+-65&255)<26|F<<24>>24==95)){F=f[v>>2]|0;f[o>>2]=f[x>>2];f[o+4>>2]=F;f[o+8>>2]=181959;SLa(s,178874,o)|0;T$(-212,181901,s,177754,2713)}F=E+-1|0;c:while(1){G=F+1|0;H=b[G>>0]|0;if((H+-48&255)<10|((H&-33)+-65&255)<26){F=G;continue}switch(H<<24>>24){case 45:case 95:{F=G;break}default:break c}}F=EW(a,E,G-E|0,1)|0;if(!F){f[s>>2]=0;f[q>>2]=0;H=c$(s,8)|0;I=H;b[I>>0]=97;b[I+1>>0]=116;b[I+2>>0]=116;b[I+3>>0]=114;I=H+4|0;b[I>>0]=110;b[I+1>>0]=97;b[I+2>>0]=109;b[I+3>>0]=101;j$(-215,s,181901,177754,2720);d$(s)}if(!y){J=B;K=C;L=D;M=F}else{if(w){I=f[v>>2]|0;f[n>>2]=f[x>>2];f[n+4>>2]=I;f[n+8>>2]=182005;SLa(s,178874,n)|0;T$(-212,181901,s,177754,2728)}I=(D|0)!=0;if((B|0)>3|I^1){H=vL(f[A>>2]|0,44)|0;N=H+4|0;O=N+40|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(O|0));f[H>>2]=H+8;if(I){f[D+4>>2]=H;P=0;Q=C;R=H}else{P=0;Q=H;R=H}}else{P=B;Q=C;R=D}f[(f[R>>2]|0)+(P<<1<<2)>>2]=f[F+8>>2];J=P;K=Q;L=R;M=y}if(!L){S=J;T=G}else{if((b[G>>0]|0)!=61){N=YV(a,G,2)|0;if((b[N>>0]|0)==61)U=N;else{O=f[v>>2]|0;f[m>>2]=f[x>>2];f[m+4>>2]=O;f[m+8>>2]=182051;SLa(s,178874,m)|0;T$(-212,181901,s,177754,2754);U=N}}else U=G;N=U+1|0;d:do switch(b[N>>0]|0){case 39:case 34:{V=N;break}default:{O=YV(a,N,2)|0;switch(b[O>>0]|0){case 39:case 34:{V=O;break d;break}default:{}}W=f[v>>2]|0;f[l>>2]=f[x>>2];f[l+4>>2]=W;f[l+8>>2]=182092;SLa(s,178874,l)|0;T$(-212,181901,s,177754,2762);V=O}}while(0);N=_V(a,V,t,3)|0;f[(f[L>>2]|0)+((J<<1|1)<<2)>>2]=f[r>>2];S=J+1|0;T=N}N=b[T>>0]|0;if(N<<24>>24==62){X=35;break}Y=YV(a,T,2)|0;F=b[Y>>0]|0;if(F<<24>>24==62){X=37;break}if(p&F<<24>>24==63){X=41;break}if(F<<24>>24==47?c&(b[Y+1>>0]|0)==62:0){X=46;break}switch(N<<24>>24){case 0:case 9:case 10:case 11:case 12:case 13:case 32:{B=S;C=K;D=L;E=Y;y=M;continue b;break}default:{}}N=f[v>>2]|0;f[i>>2]=f[x>>2];f[i+4>>2]=N;f[i+8>>2]=182185;SLa(s,178874,i)|0;T$(-212,181901,s,177754,2802);B=S;C=K;D=L;E=Y;y=M}if((X|0)==35)if(p){Z=T;X=38}else _=T;else if((X|0)==37)if(p){Z=Y;X=38}else _=Y;else if((X|0)==41){if((b[Y+1>>0]|0)!=62){p=f[v>>2]|0;f[j>>2]=f[x>>2];f[j+4>>2]=p;f[j+8>>2]=182151;SLa(s,178874,j)|0;T$(-212,181901,s,177754,2790)}$=Y+2|0;aa=4;f[d>>2]=M;f[g>>2]=aa;f[e>>2]=K;u=h;return $|0}else if((X|0)==46){$=Y+2|0;aa=3;f[d>>2]=M;f[g>>2]=aa;f[e>>2]=K;u=h;return $|0}if((X|0)==38){X=f[v>>2]|0;f[k>>2]=f[x>>2];f[k+4>>2]=X;f[k+8>>2]=182151;SLa(s,178874,k)|0;T$(-212,181901,s,177754,2783);_=Z}$=_+1|0;aa=z;f[d>>2]=M;f[g>>2]=aa;f[e>>2]=K;u=h;return $|0}function _V(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0;g=u;u=u+5360|0;h=g+1216|0;i=g+1200|0;j=g+1184|0;k=g+1168|0;l=g+1152|0;m=g+1136|0;n=g+1120|0;o=g+1104|0;q=g+1088|0;r=g+1072|0;t=g+1056|0;v=g+1040|0;w=g+1024|0;x=g;y=g+5352|0;z=g+1240|0;A=g+1236|0;B=g+1232|0;C=g+1228|0;D=e&16;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;E=e&7;e=(E|0)==3;F=a+60|0;G=a+88|0;H=a+16|0;I=(E+-1|0)>>>0<4;J=d+8|0;K=x+4|0;L=1;M=1;N=c;a:while(1){c=b[N>>0]|0;switch(c<<24>>24){case 0:case 9:case 10:case 11:case 12:case 13:case 32:{O=5;break}case 60:{P=b[N+1>>0]|0;if(P<<24>>24==33)if((b[N+2>>0]|0)==45)O=5;else{Q=33;R=60;S=L;T=N;O=7}else{Q=P;R=60;S=L;T=N;O=7}break}default:{U=c;V=L;W=N;O=6}}if((O|0)==5){O=0;c=YV(a,N,0)|0;U=b[c>>0]|0;V=1;W=c;O=6}b:do if((O|0)==6){O=0;c=b[W+1>>0]|0;switch(U<<24>>24){case 0:case 60:{Q=c;R=U;S=V;T=W;O=7;break b;break}default:{}}if(!V){P=f[G>>2]|0;f[q>>2]=f[F>>2];f[q+4>>2]=P;f[q+8>>2]=181468;SLa(x,178874,q)|0;T$(-212,181368,x,177754,2515)}P=f[d>>2]|0;if(!P)X=d;else{if((P&7)>>>0<=4){P=yL(0,56,16,f[H>>2]|0)|0;if(f[d>>2]&7|0)NL(P,d)|0;f[J>>2]=P;f[d>>2]=5;zL(P,8)}P=NL(f[J>>2]|0,0)|0;f[P+4>>2]=0;X=P}c:do if(!e){d:do if((U+-48&255)<10)Y=U;else switch(U<<24>>24){case 43:case 45:{if(c<<24>>24==46|(c+-48&255)<10){Y=U;break d}else{O=67;break c}break}case 46:{if((c+-48&255)<10|((c&-33)+-65&255)<26){Y=46;break d}else{O=67;break c}break}default:{O=67;break c}}while(0);P=W+((U<<24>>24==43|Y<<24>>24==45)&1)|0;while(1){f[y>>2]=P;Z=b[P>>0]|0;if((Z+-48&255)<10)P=P+1|0;else break}switch(Z<<24>>24){case 101:case 46:{_=+mW(a,W,y);f[X>>2]=2;p[X+8>>3]=_;break}default:{P=lNa(W,y,0)|0;f[X>>2]=1;f[X+8>>2]=P}}P=f[y>>2]|0;if((P|0)==(W|0)){$=f[G>>2]|0;f[o>>2]=f[F>>2];f[o+4>>2]=$;f[o+8>>2]=179801;SLa(x,178874,o)|0;T$(-212,181368,x,177754,2552);aa=P}else aa=P}else O=67;while(0);if((O|0)==67){O=0;F1a(z|0,0,4112)|0;f[X>>2]=3;c=U<<24>>24==34;P=0;$=c?W:W+-1|0;e:while(1){ba=$+1|0;ca=b[ba>>0]|0;f:do if((ca+-48&255)<10|((ca&-33)+-65&255)<26){da=ca;ea=P;fa=ba}else{if(ca<<24>>24==34){O=70;break e}if((ca&255)<32|ca<<24>>24==60){O=76;break e}if(c)switch(ca<<24>>24){case 62:case 39:{O=79;break}case 38:break;default:{da=ca;ea=P;fa=ba;break f}}else switch(ca<<24>>24){case 9:case 10:case 11:case 12:case 13:case 32:{ga=ba;break e;break}case 62:case 39:{O=79;break}case 38:break;default:{da=ca;ea=P;fa=ba;break f}}if((O|0)==79){O=0;ha=f[G>>2]|0;f[l>>2]=f[F>>2];f[l+4>>2]=ha;f[l+8>>2]=181582;SLa(x,178874,l)|0;T$(-212,181368,x,177754,2587);da=ca;ea=P;fa=ba;break}ha=$+2|0;if((b[ha>>0]|0)==35){ia=$+3|0;ja=(b[ia>>0]|0)==120;ka=lNa(ja?$+4|0:ia,y,ja?16:10)|0;ja=f[y>>2]|0;if(!(ka>>>0<256&(ja|0)!=0?(b[ja>>0]|0)==59:0)){ia=f[G>>2]|0;f[k>>2]=f[F>>2];f[k+4>>2]=ia;f[k+8>>2]=181633;SLa(x,178874,k)|0;T$(-212,181368,x,177754,2603)}da=ka&255;ea=P;fa=ja;break}f[y>>2]=ha;ja=ha;do{ja=ja+1|0;la=b[ja>>0]|0}while((la+-48&255)<10|((la&-33)+-65&255)<26);f[y>>2]=ja;if(la<<24>>24!=59){ka=f[G>>2]|0;f[j>>2]=f[F>>2];f[j+4>>2]=ka;f[j+8>>2]=181669;SLa(x,178874,j)|0;T$(-212,181368,x,177754,2612)}ka=ja-ha|0;switch(ka|0){case 2:{if(!(yKa(ha,181713,2)|0)){da=60;ea=P;fa=ja;break f}if(!(yKa(ha,181716,2)|0)){da=62;ea=P;fa=ja;break f}break}case 3:{if(!(yKa(ha,181719,3)|0)){da=38;ea=P;fa=ja;break f}break}case 4:{if(!(yKa(ha,181723,4)|0)){da=39;ea=P;fa=ja;break f}if(!(yKa(ha,181728,4)|0)){da=34;ea=P;fa=ja;break f}break}default:{}}ia=ka+2|0;K1a(z+P|0,ba|0,ia|0)|0;da=la;ea=ia+P|0;fa=ja}while(0);ca=ea+1|0;b[z+ea>>0]=da;if((ea|0)<=4094){P=ca;$=fa;continue}ia=f[G>>2]|0;f[i>>2]=f[F>>2];f[i+4>>2]=ia;f[i+8>>2]=180874;SLa(x,178874,i)|0;T$(-212,181368,x,177754,2635);P=ca;$=fa}if((O|0)==70){O=0;if(!c){ca=f[G>>2]|0;f[n>>2]=f[F>>2];f[n+4>>2]=ca;f[n+8>>2]=181507;SLa(x,178874,n)|0;T$(-212,181368,x,177754,2575)}ga=$+2|0}else if((O|0)==76){O=0;if(c){ca=f[G>>2]|0;f[m>>2]=f[F>>2];f[m+4>>2]=ca;f[m+8>>2]=181560;SLa(x,178874,m)|0;T$(-212,181368,x,177754,2582);ga=ba}else ga=ba}xL(x,f[H>>2]|0,z,P);ca=X+8|0;p[s>>3]=+p[x>>3];f[ca>>2]=f[s>>2];f[ca+4>>2]=f[s+4>>2];aa=ga}if(I){ma=M;na=aa;break a}else{oa=0;pa=M;qa=aa}}while(0);if((O|0)==7){O=0;f[z>>2]=0;f[A>>2]=0;f[B>>2]=0;f[C>>2]=0;if(!(Q<<24>>24==47|R<<24>>24==0)){ca=ZV(a,T,z,B,C)|0;switch(f[C>>2]|0){case 5:{ia=f[G>>2]|0;f[w>>2]=f[F>>2];f[w+4>>2]=ia;f[w+8>>2]=181332;SLa(x,178874,w)|0;T$(-212,181368,x,177754,2450);break}case 3:{ia=f[G>>2]|0;f[v>>2]=f[F>>2];f[v+4>>2]=ia;f[v+8>>2]=181385;SLa(x,178874,v)|0;T$(-212,181368,x,177754,2452);break}default:{}}ia=f[B>>2]|0;g:do if(ia){ka=ia;h:while(1){ra=f[ka>>2]|0;if(!ra){sa=0;ta=0;ua=0;break g}va=f[ra>>2]|0;if(va|0){wa=va;va=0;xa=0;while(1){va=va+1|0;if(!(KKa(180446,wa)|0))break h;ya=va<<1;wa=f[ra+(ya<<2)>>2]|0;if(!wa)break;else xa=ya}}ka=f[ka+4>>2]|0;if(!ka){sa=0;ta=0;ua=0;break g}}ka=f[ra+((xa|1)<<2)>>2]|0;if(ka)if(KKa(ka,180844)|0)if(KKa(ka,180852)|0)if(KKa(ka,180848)|0)if(!(KKa(ka,178191)|0)){sa=0;ta=0;ua=1}else{P=f[225394]|0;i:do if(!P)za=0;else{c=P;while(1){if(!(KKa(f[c+16>>2]|0,ka)|0)){za=c;break i}c=f[c+12>>2]|0;if(!c){za=0;break}}}while(0);sa=(za|0)==0?0:16;ta=za;ua=0}else{sa=5;ta=0;ua=0}else{sa=6;ta=0;ua=0}else{sa=3;ta=0;ua=0}else{sa=0;ta=0;ua=0}}else{sa=0;ta=0;ua=0}while(0);ia=f[z>>2]|0;if((f[ia+4>>2]|0)==1)Aa=(b[f[ia+8>>2]>>0]|0)==95;else Aa=0;ka=f[d>>2]&7;if(ka>>>0>4){if(Aa^(ka|0)==5){ka=f[G>>2]|0;f[t>>2]=f[F>>2];f[t+4>>2]=ka;f[t+8>>2]=Aa?181414:180636;SLa(x,178874,t)|0;T$(-212,181368,x,177754,2488)}}else DW(a,Aa?5:6,d);if(Aa)Ba=NL(f[J>>2]|0,0)|0;else Ba=FW(a,d,ia,1)|0;if(!Ba){f[x>>2]=0;f[K>>2]=0;ka=c$(x,4)|0;b[ka>>0]=101;b[ka+1>>0]=108;b[ka+2>>0]=101;b[ka+3>>0]=109;j$(-215,x,181368,177754,2494);d$(x)}if(ua)Ca=YV(a,IW(a,ca,Ba)|0,0)|0;else Ca=_V(a,ca,Ba,sa)|0;if(!Aa)f[Ba>>2]=f[Ba>>2]|64;if(M)Da=(f[Ba>>2]&7)>>>0<5;else Da=0;f[Ba+4>>2]=ta;ka=ZV(a,Ca,A,B,C)|0;if((f[C>>2]|0)==2?(f[A>>2]|0)==(ia|0):0){Ea=1;Fa=1;Ga=Da;Ha=ka}else{ia=f[G>>2]|0;f[r>>2]=f[F>>2];f[r+4>>2]=ia;f[r+8>>2]=181445;SLa(x,178874,r)|0;T$(-212,181368,x,177754,2509);Ea=1;Fa=1;Ga=Da;Ha=ka}}else{Ea=0;Fa=S;Ga=M;Ha=T}if(Ea){oa=Fa;pa=Ga;qa=Ha}else{ma=Ga;na=Ha;break}}L=oa;M=pa;N=qa}qa=f[d>>2]|0;N=qa&7;if(!N)if(E>>>0>4)O=104;else O=105;else if(E>>>0>4&(N>>>0<5&(N|0)!=(E|0)))O=104;else O=105;if((O|0)==104){DW(a,(E|0)==6?6:5,d);Ia=f[d>>2]|0;O=106}else if((O|0)==105)if(!E)Ja=qa;else{Ia=qa;O=106}if((O|0)==106)if((E|0)==(Ia&7|0))Ja=Ia;else{Ia=f[G>>2]|0;f[h>>2]=f[F>>2];f[h+4>>2]=Ia;f[h+8>>2]=181733;SLa(x,178874,h)|0;T$(-212,181368,x,177754,2657);Ja=f[d>>2]|0}if((Ja&7)>>>0<5|ma^1){Ka=Ja|D;f[d>>2]=Ka;u=g;return na|0}ma=f[J>>2]|0;f[ma>>2]=f[ma>>2]|256;Ka=Ja|D;f[d>>2]=Ka;u=g;return na|0}function $V(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+1072|0;g=e+32|0;h=e+16|0;i=e;j=e+48|0;k=a+60|0;l=a+88|0;m=a+80|0;n=a+76|0;o=a+256|0;p=a+64|0;q=a+68|0;r=a+264|0;s=a+260|0;t=c;a:while(1){v=t;b:while(1){w=b[v>>0]|0;switch(w<<24>>24){case 35:{x=5;break b;break}case 32:break;default:break b}v=v+1|0}if((x|0)==5){x=0;b[v>>0]=0;t=v;continue}if((w&255)>31)break;switch(w<<24>>24){case 13:case 10:case 0:break;default:{c=f[l>>2]|0;f[g>>2]=f[k>>2];f[g+4>>2]=c;f[g+8>>2]=w<<24>>24==9?181303:180856;SLa(j,178874,g)|0;T$(-212,181241,j,177754,1322);t=v;continue a}}c=f[n>>2]|0;y=CV(a,c,(f[m>>2]|0)-c|0)|0;if(!y){x=21;break}c=y+((xKa(y)|0)+-1)|0;c:do switch(b[c>>0]|0){case 13:case 10:break;default:{do if(!(f[o>>2]|0)){z=f[p>>2]|0;if(z|0){A=yMa(z)|0;x=18;break}z=f[q>>2]|0;if(z|0){A=pDa(z)|0;x=18}}else{A=(f[r>>2]|0)>>>0>=(f[s>>2]|0)>>>0&1;x=18}while(0);if((x|0)==18?(x=0,A|0):0)break c;z=f[l>>2]|0;f[h>>2]=f[k>>2];f[h+4>>2]=z;f[h+8>>2]=181258;SLa(j,178874,h)|0;T$(-212,181241,j,177754,1316)}}while(0);f[l>>2]=(f[l>>2]|0)+1;t=y}if((x|0)==21){x=f[n>>2]|0;b[x+2>>0]=46;b[x+1>>0]=46;b[x>>0]=46;b[x+3>>0]=0;f[a+92>>2]=1;B=x;u=e;return B|0}if((v-(f[n>>2]|0)|0)>=(d|0)){B=v;u=e;return B|0}d=f[l>>2]|0;f[i>>2]=f[k>>2];f[i+4>>2]=d;f[i+8>>2]=181079;SLa(j,178874,i)|0;T$(-212,181241,j,177754,1296);B=v;u=e;return B|0}
function e_(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0.0,ea=0,fa=0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0;g=u;u=u+320|0;h=g+312|0;i=g+256|0;j=g+200|0;k=g+144|0;l=g+88|0;m=g+72|0;o=g;q=g+40|0;r=g+32|0;_$(h,43224);if(!(TS(a,c)|0?(t=RR(a,-1)|0,(t|0)==(RR(c,-1)|0)):0)){f[i>>2]=0;f[i+4>>2]=0;v=c$(i,53)|0;w=189920;x=v+53|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-215,i,189358,188515,3628);d$(i)}if(!(d&8)){do if((NS(a)|0)==65536){t=f[a+4>>2]|0;f[i>>2]=f[t>>2];y=i+4|0;z=t+4|0;f[y>>2]=f[z>>2];A=i+8|0;f[A>>2]=f[t+8>>2];f[i+12>>2]=f[t+12>>2];f[i+16>>2]=f[t+16>>2];f[i+20>>2]=f[t+20>>2];f[i+24>>2]=f[t+24>>2];f[i+28>>2]=f[t+28>>2];f[i+32>>2]=f[t+32>>2];B=f[t+36>>2]|0;f[i+36>>2]=B;f[i+40>>2]=A;A=i+48|0;C=i+44|0;f[C>>2]=A;f[A>>2]=0;f[i+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[t+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;BR(i,t);break}}else OR(i,a,-1);while(0);do if((NS(c)|0)==65536){t=f[c+4>>2]|0;f[j>>2]=f[t>>2];y=j+4|0;z=t+4|0;f[y>>2]=f[z>>2];A=j+8|0;f[A>>2]=f[t+8>>2];f[j+12>>2]=f[t+12>>2];f[j+16>>2]=f[t+16>>2];f[j+20>>2]=f[t+20>>2];f[j+24>>2]=f[t+24>>2];f[j+28>>2]=f[t+28>>2];f[j+32>>2]=f[t+32>>2];C=f[t+36>>2]|0;f[j+36>>2]=C;f[j+40>>2]=A;A=j+48|0;B=j+44|0;f[B>>2]=A;f[A>>2]=0;f[j+52>>2]=0;if(C|0){A=C+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[t+44>>2]|0;A=f[B>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;BR(j,t);break}}else OR(j,c,-1);while(0);do if((NS(e)|0)==65536){t=f[e+4>>2]|0;f[k>>2]=f[t>>2];y=k+4|0;z=t+4|0;f[y>>2]=f[z>>2];A=k+8|0;f[A>>2]=f[t+8>>2];f[k+12>>2]=f[t+12>>2];f[k+16>>2]=f[t+16>>2];f[k+20>>2]=f[t+20>>2];f[k+24>>2]=f[t+24>>2];f[k+28>>2]=f[t+28>>2];f[k+32>>2]=f[t+32>>2];B=f[t+36>>2]|0;f[k+36>>2]=B;f[k+40>>2]=A;A=k+48|0;C=k+44|0;f[C>>2]=A;f[A>>2]=0;f[k+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[t+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;BR(k,t);break}}else OR(k,e,-1);while(0);t=f[i>>2]|0;y=t&7;z=(t>>>3&511)+1|0;A=d&7;C=(A|0)==1;B=(A|0)==2;D=(A|0)==4;E=(A|0)==5;switch(d&7){case 1:case 2:case 4:case 5:{F=t;break}default:if((A|1|0)==7&(t&4095|0)==0)F=t;else{f[l>>2]=0;f[l+4>>2]=0;K1a(c$(l,173)|0,189974,173)|0;j$(-215,l,189358,188515,3653);d$(l);F=f[i>>2]|0}}do if((F&16384|0)!=0?(f[j>>2]&16384|0)!=0:0){if(f[k+16>>2]|0){t=f[k+4>>2]|0;if((t|0)<3)G=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{H=f[k+40>>2]|0;I=0;J=1;while(1){K=Y(f[H+(I<<2)>>2]|0,J)|0;I=I+1|0;if((I|0)==(t|0)){G=K;break}else J=K}}if(!((t|0)==0|(G|0)==0)){N=68;break}}J=f[i+4>>2]|0;if((J|0)<3)O=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{I=f[i+40>>2]|0;H=0;K=1;while(1){P=Y(f[I+(H<<2)>>2]|0,K)|0;H=H+1|0;if((H|0)==(J|0)){O=P;break}else K=P}}K=Y((F>>>3&511)+1|0,O)|0;if((F&7|0)==5){J=f[i+16>>2]|0;H=f[j+16>>2]|0;if(D){I=K+-4|0;if((K|0)<4){Q=0;R=0.0}else{t=0;S=0.0;do{T=+n[J+(t<<2)>>2]-+n[H+(t<<2)>>2];P=t|1;U=+n[J+(P<<2)>>2]-+n[H+(P<<2)>>2];P=t|2;V=+n[J+(P<<2)>>2]-+n[H+(P<<2)>>2];P=t|3;W=+n[J+(P<<2)>>2]-+n[H+(P<<2)>>2];S=S+(T*T+U*U+V*V+W*W);t=t+4|0}while((t|0)<=(I|0));Q=K&-4;R=S}if((Q|0)<(K|0)){I=Q;W=R;while(1){V=+n[J+(I<<2)>>2]-+n[H+(I<<2)>>2];U=W+V*V;I=I+1|0;if((I|0)==(K|0)){X=U;break}else W=U}}else X=R;Z=+M(+(X+0.0));break}if(E){I=K+-4|0;if((K|0)<4){_=0;$=0.0}else{t=0;W=0.0;do{S=+n[J+(t<<2)>>2]-+n[H+(t<<2)>>2];P=t|1;U=+n[J+(P<<2)>>2]-+n[H+(P<<2)>>2];P=t|2;V=+n[J+(P<<2)>>2]-+n[H+(P<<2)>>2];P=t|3;T=+n[J+(P<<2)>>2]-+n[H+(P<<2)>>2];W=W+(S*S+U*U+V*V+T*T);t=t+4|0}while((t|0)<=(I|0));_=K&-4;$=W}if((_|0)<(K|0)){I=_;T=$;while(1){V=+n[J+(I<<2)>>2]-+n[H+(I<<2)>>2];U=T+V*V;I=I+1|0;if((I|0)==(K|0)){aa=U;break}else T=U}}else aa=$;Z=aa+0.0;break}if(!B){if(!C){N=68;break}if((K|0)>0){I=0;T=0.0;while(1){W=+L(+(+n[J+(I<<2)>>2]-+n[H+(I<<2)>>2]));U=T<W?W:T;I=I+1|0;if((I|0)==(K|0)){ba=U;break}else T=U}}else ba=0.0;Z=ba>0.0?ba:0.0;break}I=K+-4|0;if((K|0)<4){ca=0;da=0.0}else{t=0;T=0.0;do{P=t|1;ea=t|2;fa=t|3;T=T+(+L(+(+n[J+(t<<2)>>2]-+n[H+(t<<2)>>2]))+ +L(+(+n[J+(P<<2)>>2]-+n[H+(P<<2)>>2]))+ +L(+(+n[J+(ea<<2)>>2]-+n[H+(ea<<2)>>2]))+ +L(+(+n[J+(fa<<2)>>2]-+n[H+(fa<<2)>>2])));t=t+4|0}while((t|0)<=(I|0));ca=K&-4;da=T}if((ca|0)<(K|0)){I=ca;U=da;while(1){W=U+ +L(+(+n[J+(I<<2)>>2]-+n[H+(I<<2)>>2]));I=I+1|0;if((I|0)==(K|0)){ga=W;break}else U=W}}else ga=da;Z=ga+0.0}else N=68}else N=68;while(0);do if((N|0)==68){ca=k+16|0;if(f[ca>>2]|0){_=f[k+4>>2]|0;if((_|0)<3)ha=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{E=f[k+40>>2]|0;Q=0;F=1;while(1){O=Y(f[E+(Q<<2)>>2]|0,F)|0;Q=Q+1|0;if((Q|0)==(_|0)){ha=O;break}else F=O}}if(!((_|0)==0|(ha|0)==0)?f[k>>2]&4095|0:0){f[l>>2]=0;f[l+4>>2]=0;v=c$(l,32)|0;w=188638;x=v+32|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-215,l,189358,188515,3693);d$(l)}}_=(A|0)==6;F=A|1;if((F|0)==7){if(f[ca>>2]|0){Q=f[k+4>>2]|0;if((Q|0)<3)ia=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{E=f[k+40>>2]|0;O=0;G=1;while(1){K=Y(f[E+(O<<2)>>2]|0,G)|0;O=O+1|0;if((O|0)==(Q|0)){ia=K;break}else G=K}}if(!((Q|0)==0|(ia|0)==0)){f[l>>2]=1124007936;G=l+4|0;O=l+8|0;E=l+40|0;v=G;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[E>>2]=O;Q=l+48|0;ca=l+44|0;f[ca>>2]=Q;f[Q>>2]=0;f[l+52>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=i;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=j;K=q+8|0;f[K>>2]=0;f[K+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=l;iG(m,o,q,fT()|0);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=l;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;K=q+8|0;f[K>>2]=0;f[K+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=l;bG(m,o,q,fT()|0);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=l;ga=+zZ(m,A,fT()|0);K=l+36|0;I=f[K>>2]|0;if(I|0?(H=I+12|0,I=f[H>>2]|0,f[H>>2]=I+-1,(I|0)==1):0)CR(l);f[K>>2]=0;K=l+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[G>>2]|0)>0){K=f[E>>2]|0;I=0;do{f[K+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[G>>2]|0))}G=f[ca>>2]|0;if((G|0)!=(Q|0))ZF(G);Z=ga;break}}G=_?1:2;f[l>>2]=i;f[l+4>>2]=j;f[l+8>>2]=0;bU(o,l,m,-1);I=f[o+20>>2]|0;K=o+16|0;E=m+4|0;O=0;H=0;while(1){if(O>>>0>=(f[K>>2]|0)>>>0)break;J=(f_(f[m>>2]|0,f[E>>2]|0,I,G)|0)+H|0;tR(o)|0;O=O+1|0;H=J}Z=+(H|0);break}O=f[43244+(A>>>1<<5)+(y<<2)>>2]|0;if(!O){f[l>>2]=0;f[l+4>>2]=0;v=c$(l,9)|0;w=323538;x=v+9|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-215,l,189358,188515,3721);d$(l)}f[l>>2]=i;f[l+4>>2]=j;f[l+8>>2]=k;f[l+12>>2]=0;p[o>>3]=0.0;bU(q,l,m,-1);H=f[q+20>>2]|0;G=y>>>0<2;f[r>>2]=0;if(B&y>>>0<4|(F|0)==5&G){I=B&G?8388608:32768;G=(I|0)<(H|0)?I:H;E=f[i+4>>2]|0;if((E|0)>0){ja=1;ka=G;la=f[(f[i+44>>2]|0)+(E+-1<<2)>>2]|0;ma=r;na=I}else{ja=1;ka=G;la=0;ma=r;na=I}}else{ja=0;ka=H;la=0;ma=o;na=0}I=q+16|0;G=(H|0)>0;E=m+4|0;K=m+8|0;_=0;Q=0;while(1){if(Q>>>0>=(f[I>>2]|0)>>>0)break;ca=Q+1|0;a:do if(G){J=f[m>>2]|0;t=f[E>>2]|0;fa=f[K>>2]|0;if(ja){oa=J;pa=t;qa=fa;ra=_;sa=0}else{ea=J;J=t;t=fa;fa=_;P=0;while(1){ta=H-P|0;ua=(ka|0)<(ta|0)?ka:ta;bg[O&127](ea,J,t,ma,ua,z)|0;ta=ua+fa|0;va=Y(ua,la)|0;ea=(f[m>>2]|0)+va|0;f[m>>2]=ea;J=(f[E>>2]|0)+va|0;f[E>>2]=J;va=f[K>>2]|0;if(!va)wa=0;else{xa=va+ua|0;f[K>>2]=xa;wa=xa}P=P+ka|0;if((H|0)<=(P|0)){ya=ta;break a}else{t=wa;fa=ta}}}while(1){fa=H-sa|0;t=(ka|0)<(fa|0)?ka:fa;bg[O&127](oa,pa,qa,ma,t,z)|0;fa=t+ra|0;if((fa+ka|0)<(na|0)?((t+sa|0)<(H|0)?1:ca>>>0<(f[I>>2]|0)>>>0):0)za=fa;else{p[o>>3]=+p[o>>3]+ +((f[r>>2]|0)>>>0);f[r>>2]=0;za=0}fa=Y(t,la)|0;oa=(f[m>>2]|0)+fa|0;f[m>>2]=oa;pa=(f[E>>2]|0)+fa|0;f[E>>2]=pa;fa=f[K>>2]|0;if(!fa)Aa=0;else{P=fa+t|0;f[K>>2]=P;Aa=P}sa=sa+ka|0;if((H|0)<=(sa|0)){ya=za;break}else{qa=Aa;ra=za}}}else ya=_;while(0);tR(q)|0;_=ya;Q=ca}if(C){if((y|0)!=6){Q=f[o>>2]|0;p[o>>3]=(y|0)==5?(f[s>>2]=Q,+n[s>>2]):+(Q>>>0)}}else if(D){ga=+M(+(+p[o>>3]));p[o>>3]=ga}Z=+p[o>>3]}while(0);o=k+36|0;D=f[o>>2]|0;if(D|0?(y=D+12|0,D=f[y>>2]|0,f[y>>2]=D+-1,(D|0)==1):0)CR(k);f[o>>2]=0;o=k+16|0;D=k+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[D>>2]|0)>0){o=f[k+40>>2]|0;y=0;do{f[o+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[D>>2]|0))}D=f[k+44>>2]|0;if((D|0)!=(k+48|0))ZF(D);D=j+36|0;k=f[D>>2]|0;if(k|0?(y=k+12|0,k=f[y>>2]|0,f[y>>2]=k+-1,(k|0)==1):0)CR(j);f[D>>2]=0;D=j+16|0;k=j+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[k>>2]|0)>0){D=f[j+40>>2]|0;y=0;do{f[D+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))ZF(k);k=i+36|0;j=f[k>>2]|0;if(j|0?(y=j+12|0,j=f[y>>2]|0,f[y>>2]=j+-1,(j|0)==1):0)CR(i);f[k>>2]=0;k=i+16|0;j=i+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[i+40>>2]|0;y=0;do{f[k+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))ZF(j);Ba=Z}else{Z=+e_(a,c,d&-9,e);Ba=Z/(+zZ(c,d,e)+2.220446049250313e-16)}if(!(f[h+4>>2]|0)){u=g;return +Ba}u=g;return +Ba}function f_(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;switch(e|0){case 1:{f=b$(a,c,d)|0;return f|0}case 2:{g=189363;break}case 4:{g=189619;break}default:{f=-1;return f|0}}e=d+-4|0;if((d|0)<4){i=0;j=0}else{k=0;l=0;do{m=k|1;n=k|2;o=k|3;l=(h[g+((b[c+k>>0]^b[a+k>>0])&255)>>0]|0)+l+(h[g+((b[c+m>>0]^b[a+m>>0])&255)>>0]|0)+(h[g+((b[c+n>>0]^b[a+n>>0])&255)>>0]|0)+(h[g+((b[c+o>>0]^b[a+o>>0])&255)>>0]|0)|0;k=k+4|0}while((k|0)<=(e|0));i=d&-4;j=l}if((i|0)<(d|0)){p=i;q=j}else{f=j;return f|0}while(1){j=(h[g+((b[c+p>>0]^b[a+p>>0])&255)>>0]|0)+q|0;p=p+1|0;if((p|0)==(d|0)){f=j;break}else q=j}return f|0}function g_(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=f[e>>2]|0;if(!d){k=Y(i,g)|0;if((k|0)>0){l=0;m=0;while(1){n=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;o=(n|0)>-1?n:0-n|0;n=(m|0)<(o|0)?o:m;l=l+1|0;if((l|0)==(k|0)){p=n;break}else m=n}}else p=0;q=(j|0)<(p|0)?p:j;f[e>>2]=q;return 0}if((g|0)>0&(i|0)>0){r=0;s=j;t=a;u=c}else{q=j;f[e>>2]=q;return 0}while(1){if(!(b[d+r>>0]|0))v=s;else{j=0;c=s;while(1){a=(h[t+j>>0]|0)-(h[u+j>>0]|0)|0;p=(a|0)>-1?a:0-a|0;a=(c|0)<(p|0)?p:c;j=j+1|0;if((j|0)==(i|0)){v=a;break}else c=a}}r=r+1|0;if((r|0)==(g|0)){q=v;break}else{s=v;t=t+i|0;u=u+i|0}}f[e>>2]=q;return 0}function h_(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;i=f[e>>2]|0;if(!d){j=Y(h,g)|0;if((j|0)>0){k=0;l=0;while(1){m=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;n=(m|0)>-1?m:0-m|0;m=(l|0)<(n|0)?n:l;k=k+1|0;if((k|0)==(j|0)){o=m;break}else l=m}}else o=0;p=(i|0)<(o|0)?o:i;f[e>>2]=p;return 0}if((g|0)>0&(h|0)>0){q=0;r=i;s=a;t=c}else{p=i;f[e>>2]=p;return 0}while(1){if(!(b[d+q>>0]|0))u=r;else{i=0;c=r;while(1){a=(b[s+i>>0]|0)-(b[t+i>>0]|0)|0;o=(a|0)>-1?a:0-a|0;a=(c|0)<(o|0)?o:c;i=i+1|0;if((i|0)==(h|0)){u=a;break}else c=a}}q=q+1|0;if((q|0)==(g|0)){p=u;break}else{r=u;s=s+h|0;t=t+h|0}}f[e>>2]=p;return 0}function i_(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;i=f[e>>2]|0;if(!d){k=Y(h,g)|0;if((k|0)>0){l=0;m=0;while(1){n=(j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0;o=(n|0)>-1?n:0-n|0;n=(m|0)<(o|0)?o:m;l=l+1|0;if((l|0)==(k|0)){p=n;break}else m=n}}else p=0;q=(i|0)<(p|0)?p:i;f[e>>2]=q;return 0}if((g|0)>0&(h|0)>0){r=0;s=i;t=a;u=c}else{q=i;f[e>>2]=q;return 0}while(1){if(!(b[d+r>>0]|0))v=s;else{i=0;c=s;while(1){a=(j[t+(i<<1)>>1]|0)-(j[u+(i<<1)>>1]|0)|0;p=(a|0)>-1?a:0-a|0;a=(c|0)<(p|0)?p:c;i=i+1|0;if((i|0)==(h|0)){v=a;break}else c=a}}r=r+1|0;if((r|0)==(g|0)){q=v;break}else{s=v;t=t+(h<<1)|0;u=u+(h<<1)|0}}f[e>>2]=q;return 0}function j_(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=f[g>>2]|0;if(!e){k=Y(i,h)|0;if((k|0)>0){l=0;m=0;while(1){n=(d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0;o=(n|0)>-1?n:0-n|0;n=(m|0)<(o|0)?o:m;l=l+1|0;if((l|0)==(k|0)){p=n;break}else m=n}}else p=0;q=(j|0)<(p|0)?p:j;f[g>>2]=q;return 0}if((h|0)>0&(i|0)>0){r=0;s=j;t=a;u=c}else{q=j;f[g>>2]=q;return 0}while(1){if(!(b[e+r>>0]|0))v=s;else{j=0;c=s;while(1){a=(d[t+(j<<1)>>1]|0)-(d[u+(j<<1)>>1]|0)|0;p=(a|0)>-1?a:0-a|0;a=(c|0)<(p|0)?p:c;j=j+1|0;if((j|0)==(i|0)){v=a;break}else c=a}}r=r+1|0;if((r|0)==(h|0)){q=v;break}else{s=v;t=t+(i<<1)|0;u=u+(i<<1)|0}}f[g>>2]=q;return 0}function k_(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;i=f[e>>2]|0;if(!d){j=Y(h,g)|0;if((j|0)>0){k=0;l=0;while(1){m=(f[a+(k<<2)>>2]|0)-(f[c+(k<<2)>>2]|0)|0;n=(m|0)>-1?m:0-m|0;m=(l|0)<(n|0)?n:l;k=k+1|0;if((k|0)==(j|0)){o=m;break}else l=m}}else o=0;p=(i|0)<(o|0)?o:i;f[e>>2]=p;return 0}if((g|0)>0&(h|0)>0){q=0;r=i;s=a;t=c}else{p=i;f[e>>2]=p;return 0}while(1){if(!(b[d+q>>0]|0))u=r;else{i=0;c=r;while(1){a=(f[s+(i<<2)>>2]|0)-(f[t+(i<<2)>>2]|0)|0;o=(a|0)>-1?a:0-a|0;a=(c|0)<(o|0)?o:c;i=i+1|0;if((i|0)==(h|0)){u=a;break}else c=a}}q=q+1|0;if((q|0)==(g|0)){p=u;break}else{r=u;s=s+(h<<2)|0;t=t+(h<<2)|0}}f[e>>2]=p;return 0}function l_(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0.0,o=0.0,p=0.0,q=0.0,r=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0;i=f[e>>2]|0;j=(f[s>>2]=i,+n[s>>2]);if(!d){k=Y(h,g)|0;if((k|0)>0){l=0;m=0.0;while(1){o=+L(+(+n[a+(l<<2)>>2]-+n[c+(l<<2)>>2]));p=m<o?o:m;l=l+1|0;if((l|0)==(k|0)){q=p;break}else m=p}}else q=0.0;r=(n[s>>2]=j<q?q:j,f[s>>2]|0);f[e>>2]=r;return 0}if((g|0)>0&(h|0)>0){t=0;u=j;v=i;w=a;x=c}else{r=i;f[e>>2]=r;return 0}while(1){if(!(b[d+t>>0]|0)){y=u;z=v}else{i=0;j=u;do{q=+L(+(+n[w+(i<<2)>>2]-+n[x+(i<<2)>>2]));j=j<q?q:j;i=i+1|0}while((i|0)!=(h|0));y=j;z=(n[s>>2]=j,f[s>>2]|0)}t=t+1|0;if((t|0)==(g|0)){r=z;break}else{u=y;v=z;w=w+(h<<2)|0;x=x+(h<<2)|0}}f[e>>2]=r;return 0}function m_(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,q=0,r=0.0,s=0,t=0,u=0.0;h=+p[e>>3];if(!d){i=Y(g,f)|0;if((i|0)>0){j=0;k=0.0;while(1){l=+L(+(+p[a+(j<<3)>>3]-+p[c+(j<<3)>>3]));m=k<l?l:k;j=j+1|0;if((j|0)==(i|0)){n=m;break}else k=m}}else n=0.0;o=h<n?n:h;p[e>>3]=o;return 0}if((f|0)>0&(g|0)>0){q=0;r=h;s=a;t=c}else{o=h;p[e>>3]=o;return 0}while(1){if(!(b[d+q>>0]|0))u=r;else{c=0;h=r;while(1){n=+L(+(+p[s+(c<<3)>>3]-+p[t+(c<<3)>>3]));k=h<n?n:h;c=c+1|0;if((c|0)==(g|0)){u=k;break}else h=k}}q=q+1|0;if((q|0)==(f|0)){o=u;break}else{r=u;s=s+(g<<3)|0;t=t+(g<<3)|0}}p[e>>3]=o;return 0}function n_(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=f[e>>2]|0;if(d|0){if((g|0)>0&(i|0)>0){k=0;l=j;m=a;n=c}else{o=j;f[e>>2]=o;return 0}while(1){if(!(b[d+k>>0]|0))p=l;else{q=0;r=l;while(1){s=(h[m+q>>0]|0)-(h[n+q>>0]|0)|0;t=((s|0)>-1?s:0-s|0)+r|0;q=q+1|0;if((q|0)==(i|0)){p=t;break}else r=t}}k=k+1|0;if((k|0)==(g|0)){o=p;break}else{l=p;m=m+i|0;n=n+i|0}}f[e>>2]=o;return 0}n=Y(i,g)|0;g=n+-4|0;if((n|0)<4){u=0;v=0}else{i=0;m=0;do{p=(h[a+i>>0]|0)-(h[c+i>>0]|0)|0;l=i|1;k=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;l=i|2;d=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;l=i|3;r=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;m=((p|0)>-1?p:0-p|0)+m+((k|0)>-1?k:0-k|0)+((d|0)>-1?d:0-d|0)+((r|0)>-1?r:0-r|0)|0;i=i+4|0}while((i|0)<=(g|0));u=n&-4;v=m}if((u|0)<(n|0)){m=u;u=v;while(1){g=(h[a+m>>0]|0)-(h[c+m>>0]|0)|0;i=((g|0)>-1?g:0-g|0)+u|0;m=m+1|0;if((m|0)==(n|0)){w=i;break}else u=i}}else w=v;o=w+j|0;f[e>>2]=o;return 0}function o_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return M_(a,b,c,d,e,f)|0}function p_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return L_(a,b,c,d,e,f)|0}function q_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return K_(a,b,c,d,e,f)|0}function r_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return J_(a,b,c,d,e,f)|0}function s_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return I_(a,b,c,d,e,f)|0}function t_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return H_(a,b,c,d,e,f)|0}function u_(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=f[e>>2]|0;if(d|0){if((g|0)>0&(i|0)>0){k=0;l=j;m=a;n=c}else{o=j;f[e>>2]=o;return 0}while(1){if(!(b[d+k>>0]|0))p=l;else{q=0;r=l;while(1){s=(h[m+q>>0]|0)-(h[n+q>>0]|0)|0;t=(Y(s,s)|0)+r|0;q=q+1|0;if((q|0)==(i|0)){p=t;break}else r=t}}k=k+1|0;if((k|0)==(g|0)){o=p;break}else{l=p;m=m+i|0;n=n+i|0}}f[e>>2]=o;return 0}n=Y(i,g)|0;g=n+-4|0;if((n|0)<4){u=0;v=0}else{i=0;m=0;do{p=(h[a+i>>0]|0)-(h[c+i>>0]|0)|0;l=i|1;k=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;l=i|2;d=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;l=i|3;r=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;m=(Y(p,p)|0)+m+(Y(k,k)|0)+(Y(d,d)|0)+(Y(r,r)|0)|0;i=i+4|0}while((i|0)<=(g|0));u=n&-4;v=m}if((u|0)<(n|0)){m=u;u=v;while(1){g=(h[a+m>>0]|0)-(h[c+m>>0]|0)|0;i=(Y(g,g)|0)+u|0;m=m+1|0;if((m|0)==(n|0)){w=i;break}else u=i}}else w=v;o=w+j|0;f[e>>2]=o;return 0}function v_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return G_(a,b,c,d,e,f)|0}function w_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return F_(a,b,c,d,e,f)|0}function x_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return E_(a,b,c,d,e,f)|0}function y_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return D_(a,b,c,d,e,f)|0}function z_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return C_(a,b,c,d,e,f)|0}function A_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return B_(a,b,c,d,e,f)|0}function B_(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;h=+p[e>>3];if(d|0){if((f|0)>0&(g|0)>0){i=0;j=h;k=a;l=c}else{m=h;p[e>>3]=m;return 0}while(1){if(!(b[d+i>>0]|0))n=j;else{o=0;q=j;while(1){r=+p[k+(o<<3)>>3]-+p[l+(o<<3)>>3];s=q+r*r;o=o+1|0;if((o|0)==(g|0)){n=s;break}else q=s}}i=i+1|0;if((i|0)==(f|0)){m=n;break}else{j=n;k=k+(g<<3)|0;l=l+(g<<3)|0}}p[e>>3]=m;return 0}l=Y(g,f)|0;f=l+-4|0;if((l|0)<4){t=0;u=0.0}else{g=0;n=0.0;do{j=+p[a+(g<<3)>>3]-+p[c+(g<<3)>>3];k=g|1;q=+p[a+(k<<3)>>3]-+p[c+(k<<3)>>3];k=g|2;s=+p[a+(k<<3)>>3]-+p[c+(k<<3)>>3];k=g|3;r=+p[a+(k<<3)>>3]-+p[c+(k<<3)>>3];n=n+(j*j+q*q+s*s+r*r);g=g+4|0}while((g|0)<=(f|0));t=l&-4;u=n}if((t|0)<(l|0)){f=t;n=u;while(1){r=+p[a+(f<<3)>>3]-+p[c+(f<<3)>>3];s=n+r*r;f=f+1|0;if((f|0)==(l|0)){v=s;break}else n=s}}else v=u;m=h+v;p[e>>3]=m;return 0}function C_(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0,m=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0;h=+p[e>>3];if(d|0){if((f|0)>0&(g|0)>0){i=0;j=h;k=a;l=c}else{m=h;p[e>>3]=m;return 0}while(1){if(!(b[d+i>>0]|0))o=j;else{q=0;r=j;while(1){s=+n[k+(q<<2)>>2]-+n[l+(q<<2)>>2];t=r+s*s;q=q+1|0;if((q|0)==(g|0)){o=t;break}else r=t}}i=i+1|0;if((i|0)==(f|0)){m=o;break}else{j=o;k=k+(g<<2)|0;l=l+(g<<2)|0}}p[e>>3]=m;return 0}l=Y(g,f)|0;f=l+-4|0;if((l|0)<4){u=0;v=0.0}else{g=0;o=0.0;do{j=+n[a+(g<<2)>>2]-+n[c+(g<<2)>>2];k=g|1;r=+n[a+(k<<2)>>2]-+n[c+(k<<2)>>2];k=g|2;t=+n[a+(k<<2)>>2]-+n[c+(k<<2)>>2];k=g|3;s=+n[a+(k<<2)>>2]-+n[c+(k<<2)>>2];o=o+(j*j+r*r+t*t+s*s);g=g+4|0}while((g|0)<=(f|0));u=l&-4;v=o}if((u|0)<(l|0)){f=u;o=v;while(1){s=+n[a+(f<<2)>>2]-+n[c+(f<<2)>>2];t=o+s*s;f=f+1|0;if((f|0)==(l|0)){w=t;break}else o=t}}else w=v;m=h+w;p[e>>3]=m;return 0}function D_(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0;i=+p[e>>3];if(d|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=a;m=c}else{n=i;p[e>>3]=n;return 0}while(1){if(!(b[d+j>>0]|0))o=k;else{q=0;r=k;while(1){s=+((f[l+(q<<2)>>2]|0)-(f[m+(q<<2)>>2]|0)|0);t=r+s*s;q=q+1|0;if((q|0)==(h|0)){o=t;break}else r=t}}j=j+1|0;if((j|0)==(g|0)){n=o;break}else{k=o;l=l+(h<<2)|0;m=m+(h<<2)|0}}p[e>>3]=n;return 0}m=Y(h,g)|0;g=m+-4|0;if((m|0)<4){u=0;v=0.0}else{h=0;o=0.0;do{k=+((f[a+(h<<2)>>2]|0)-(f[c+(h<<2)>>2]|0)|0);l=h|1;r=+((f[a+(l<<2)>>2]|0)-(f[c+(l<<2)>>2]|0)|0);l=h|2;t=+((f[a+(l<<2)>>2]|0)-(f[c+(l<<2)>>2]|0)|0);l=h|3;s=+((f[a+(l<<2)>>2]|0)-(f[c+(l<<2)>>2]|0)|0);o=o+(k*k+r*r+t*t+s*s);h=h+4|0}while((h|0)<=(g|0));u=m&-4;v=o}if((u|0)<(m|0)){g=u;o=v;while(1){s=+((f[a+(g<<2)>>2]|0)-(f[c+(g<<2)>>2]|0)|0);t=o+s*s;g=g+1|0;if((g|0)==(m|0)){w=t;break}else o=t}}else w=v;n=i+w;p[e>>3]=n;return 0}function E_(a,c,e,f,g,h){a=a|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0;i=+p[f>>3];if(e|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=a;m=c}else{n=i;p[f>>3]=n;return 0}while(1){if(!(b[e+j>>0]|0))o=k;else{q=0;r=k;while(1){s=+((d[l+(q<<1)>>1]|0)-(d[m+(q<<1)>>1]|0)|0);t=r+s*s;q=q+1|0;if((q|0)==(h|0)){o=t;break}else r=t}}j=j+1|0;if((j|0)==(g|0)){n=o;break}else{k=o;l=l+(h<<1)|0;m=m+(h<<1)|0}}p[f>>3]=n;return 0}m=Y(h,g)|0;g=m+-4|0;if((m|0)<4){u=0;v=0.0}else{h=0;o=0.0;do{k=+((d[a+(h<<1)>>1]|0)-(d[c+(h<<1)>>1]|0)|0);l=h|1;r=+((d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0);l=h|2;t=+((d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0);l=h|3;s=+((d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0);o=o+(k*k+r*r+t*t+s*s);h=h+4|0}while((h|0)<=(g|0));u=m&-4;v=o}if((u|0)<(m|0)){g=u;o=v;while(1){s=+((d[a+(g<<1)>>1]|0)-(d[c+(g<<1)>>1]|0)|0);t=o+s*s;g=g+1|0;if((g|0)==(m|0)){w=t;break}else o=t}}else w=v;n=i+w;p[f>>3]=n;return 0}function F_(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,k=0.0,l=0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0;h=+p[e>>3];if(d|0){if((f|0)>0&(g|0)>0){i=0;k=h;l=a;m=c}else{n=h;p[e>>3]=n;return 0}while(1){if(!(b[d+i>>0]|0))o=k;else{q=0;r=k;while(1){s=+((j[l+(q<<1)>>1]|0)-(j[m+(q<<1)>>1]|0)|0);t=r+s*s;q=q+1|0;if((q|0)==(g|0)){o=t;break}else r=t}}i=i+1|0;if((i|0)==(f|0)){n=o;break}else{k=o;l=l+(g<<1)|0;m=m+(g<<1)|0}}p[e>>3]=n;return 0}m=Y(g,f)|0;f=m+-4|0;if((m|0)<4){u=0;v=0.0}else{g=0;o=0.0;do{k=+((j[a+(g<<1)>>1]|0)-(j[c+(g<<1)>>1]|0)|0);l=g|1;r=+((j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0);l=g|2;t=+((j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0);l=g|3;s=+((j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0);o=o+(k*k+r*r+t*t+s*s);g=g+4|0}while((g|0)<=(f|0));u=m&-4;v=o}if((u|0)<(m|0)){f=u;o=v;while(1){s=+((j[a+(f<<1)>>1]|0)-(j[c+(f<<1)>>1]|0)|0);t=o+s*s;f=f+1|0;if((f|0)==(m|0)){w=t;break}else o=t}}else w=v;n=h+w;p[e>>3]=n;return 0}function G_(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;i=f[e>>2]|0;if(d|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=a;m=c}else{n=i;f[e>>2]=n;return 0}while(1){if(!(b[d+j>>0]|0))o=k;else{p=0;q=k;while(1){r=(b[l+p>>0]|0)-(b[m+p>>0]|0)|0;s=(Y(r,r)|0)+q|0;p=p+1|0;if((p|0)==(h|0)){o=s;break}else q=s}}j=j+1|0;if((j|0)==(g|0)){n=o;break}else{k=o;l=l+h|0;m=m+h|0}}f[e>>2]=n;return 0}m=Y(h,g)|0;g=m+-4|0;if((m|0)<4){t=0;u=0}else{h=0;l=0;do{o=(b[a+h>>0]|0)-(b[c+h>>0]|0)|0;k=h|1;j=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;k=h|2;d=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;k=h|3;q=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;l=(Y(o,o)|0)+l+(Y(j,j)|0)+(Y(d,d)|0)+(Y(q,q)|0)|0;h=h+4|0}while((h|0)<=(g|0));t=m&-4;u=l}if((t|0)<(m|0)){l=t;t=u;while(1){g=(b[a+l>>0]|0)-(b[c+l>>0]|0)|0;h=(Y(g,g)|0)+t|0;l=l+1|0;if((l|0)==(m|0)){v=h;break}else t=h}}else v=u;n=v+i|0;f[e>>2]=n;return 0}function H_(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0,q=0.0,r=0.0,s=0,t=0.0,u=0.0;h=+p[e>>3];if(d|0){if((f|0)>0&(g|0)>0){i=0;j=h;k=a;l=c}else{m=h;p[e>>3]=m;return 0}while(1){if(!(b[d+i>>0]|0))n=j;else{o=0;q=j;while(1){r=q+ +L(+(+p[k+(o<<3)>>3]-+p[l+(o<<3)>>3]));o=o+1|0;if((o|0)==(g|0)){n=r;break}else q=r}}i=i+1|0;if((i|0)==(f|0)){m=n;break}else{j=n;k=k+(g<<3)|0;l=l+(g<<3)|0}}p[e>>3]=m;return 0}l=Y(g,f)|0;f=l+-4|0;if((l|0)<4){s=0;t=0.0}else{g=0;n=0.0;do{k=g|1;i=g|2;d=g|3;n=n+(+L(+(+p[a+(g<<3)>>3]-+p[c+(g<<3)>>3]))+ +L(+(+p[a+(k<<3)>>3]-+p[c+(k<<3)>>3]))+ +L(+(+p[a+(i<<3)>>3]-+p[c+(i<<3)>>3]))+ +L(+(+p[a+(d<<3)>>3]-+p[c+(d<<3)>>3])));g=g+4|0}while((g|0)<=(f|0));s=l&-4;t=n}if((s|0)<(l|0)){f=s;n=t;while(1){j=n+ +L(+(+p[a+(f<<3)>>3]-+p[c+(f<<3)>>3]));f=f+1|0;if((f|0)==(l|0)){u=j;break}else n=j}}else u=t;m=h+u;p[e>>3]=m;return 0}function I_(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0,m=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;h=+p[e>>3];if(d|0){if((f|0)>0&(g|0)>0){i=0;j=h;k=a;l=c}else{m=h;p[e>>3]=m;return 0}while(1){if(!(b[d+i>>0]|0))o=j;else{q=0;r=j;while(1){s=r+ +L(+(+n[k+(q<<2)>>2]-+n[l+(q<<2)>>2]));q=q+1|0;if((q|0)==(g|0)){o=s;break}else r=s}}i=i+1|0;if((i|0)==(f|0)){m=o;break}else{j=o;k=k+(g<<2)|0;l=l+(g<<2)|0}}p[e>>3]=m;return 0}l=Y(g,f)|0;f=l+-4|0;if((l|0)<4){t=0;u=0.0}else{g=0;o=0.0;do{k=g|1;i=g|2;d=g|3;o=o+(+L(+(+n[a+(g<<2)>>2]-+n[c+(g<<2)>>2]))+ +L(+(+n[a+(k<<2)>>2]-+n[c+(k<<2)>>2]))+ +L(+(+n[a+(i<<2)>>2]-+n[c+(i<<2)>>2]))+ +L(+(+n[a+(d<<2)>>2]-+n[c+(d<<2)>>2])));g=g+4|0}while((g|0)<=(f|0));t=l&-4;u=o}if((t|0)<(l|0)){f=t;o=u;while(1){j=o+ +L(+(+n[a+(f<<2)>>2]-+n[c+(f<<2)>>2]));f=f+1|0;if((f|0)==(l|0)){v=j;break}else o=j}}else v=u;m=h+v;p[e>>3]=m;return 0}function J_(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0,t=0.0,u=0,v=0.0,w=0.0;i=+p[e>>3];if(d|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=a;m=c}else{n=i;p[e>>3]=n;return 0}while(1){if(!(b[d+j>>0]|0))o=k;else{q=0;r=k;while(1){s=(f[l+(q<<2)>>2]|0)-(f[m+(q<<2)>>2]|0)|0;t=r+ +(((s|0)>-1?s:0-s|0)|0);q=q+1|0;if((q|0)==(h|0)){o=t;break}else r=t}}j=j+1|0;if((j|0)==(g|0)){n=o;break}else{k=o;l=l+(h<<2)|0;m=m+(h<<2)|0}}p[e>>3]=n;return 0}m=Y(h,g)|0;g=m+-4|0;if((m|0)<4){u=0;v=0.0}else{h=0;o=0.0;do{l=h|1;j=h|2;d=h|3;o=o+(+L(+(+((f[a+(h<<2)>>2]|0)-(f[c+(h<<2)>>2]|0)|0)))+ +L(+(+((f[a+(l<<2)>>2]|0)-(f[c+(l<<2)>>2]|0)|0)))+ +L(+(+((f[a+(j<<2)>>2]|0)-(f[c+(j<<2)>>2]|0)|0)))+ +L(+(+((f[a+(d<<2)>>2]|0)-(f[c+(d<<2)>>2]|0)|0))));h=h+4|0}while((h|0)<=(g|0));u=m&-4;v=o}if((u|0)<(m|0)){g=u;o=v;while(1){k=o+ +L(+(+((f[a+(g<<2)>>2]|0)-(f[c+(g<<2)>>2]|0)|0)));g=g+1|0;if((g|0)==(m|0)){w=k;break}else o=k}}else w=v;n=i+w;p[e>>3]=n;return 0}function K_(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=f[g>>2]|0;if(e|0){if((h|0)>0&(i|0)>0){k=0;l=j;m=a;n=c}else{o=j;f[g>>2]=o;return 0}while(1){if(!(b[e+k>>0]|0))p=l;else{q=0;r=l;while(1){s=(d[m+(q<<1)>>1]|0)-(d[n+(q<<1)>>1]|0)|0;t=((s|0)>-1?s:0-s|0)+r|0;q=q+1|0;if((q|0)==(i|0)){p=t;break}else r=t}}k=k+1|0;if((k|0)==(h|0)){o=p;break}else{l=p;m=m+(i<<1)|0;n=n+(i<<1)|0}}f[g>>2]=o;return 0}n=Y(i,h)|0;h=n+-4|0;if((n|0)<4){u=0;v=0}else{i=0;m=0;do{p=(d[a+(i<<1)>>1]|0)-(d[c+(i<<1)>>1]|0)|0;l=i|1;k=(d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0;l=i|2;e=(d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0;l=i|3;r=(d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0;m=((p|0)>-1?p:0-p|0)+m+((k|0)>-1?k:0-k|0)+((e|0)>-1?e:0-e|0)+((r|0)>-1?r:0-r|0)|0;i=i+4|0}while((i|0)<=(h|0));u=n&-4;v=m}if((u|0)<(n|0)){m=u;u=v;while(1){h=(d[a+(m<<1)>>1]|0)-(d[c+(m<<1)>>1]|0)|0;i=((h|0)>-1?h:0-h|0)+u|0;m=m+1|0;if((m|0)==(n|0)){w=i;break}else u=i}}else w=v;o=w+j|0;f[g>>2]=o;return 0}function L_(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;i=f[e>>2]|0;if(d|0){if((g|0)>0&(h|0)>0){k=0;l=i;m=a;n=c}else{o=i;f[e>>2]=o;return 0}while(1){if(!(b[d+k>>0]|0))p=l;else{q=0;r=l;while(1){s=(j[m+(q<<1)>>1]|0)-(j[n+(q<<1)>>1]|0)|0;t=((s|0)>-1?s:0-s|0)+r|0;q=q+1|0;if((q|0)==(h|0)){p=t;break}else r=t}}k=k+1|0;if((k|0)==(g|0)){o=p;break}else{l=p;m=m+(h<<1)|0;n=n+(h<<1)|0}}f[e>>2]=o;return 0}n=Y(h,g)|0;g=n+-4|0;if((n|0)<4){u=0;v=0}else{h=0;m=0;do{p=(j[a+(h<<1)>>1]|0)-(j[c+(h<<1)>>1]|0)|0;l=h|1;k=(j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0;l=h|2;d=(j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0;l=h|3;r=(j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0;m=((p|0)>-1?p:0-p|0)+m+((k|0)>-1?k:0-k|0)+((d|0)>-1?d:0-d|0)+((r|0)>-1?r:0-r|0)|0;h=h+4|0}while((h|0)<=(g|0));u=n&-4;v=m}if((u|0)<(n|0)){m=u;u=v;while(1){g=(j[a+(m<<1)>>1]|0)-(j[c+(m<<1)>>1]|0)|0;h=((g|0)>-1?g:0-g|0)+u|0;m=m+1|0;if((m|0)==(n|0)){w=h;break}else u=h}}else w=v;o=w+i|0;f[e>>2]=o;return 0}function M_(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;i=f[e>>2]|0;if(d|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=a;m=c}else{n=i;f[e>>2]=n;return 0}while(1){if(!(b[d+j>>0]|0))o=k;else{p=0;q=k;while(1){r=(b[l+p>>0]|0)-(b[m+p>>0]|0)|0;s=((r|0)>-1?r:0-r|0)+q|0;p=p+1|0;if((p|0)==(h|0)){o=s;break}else q=s}}j=j+1|0;if((j|0)==(g|0)){n=o;break}else{k=o;l=l+h|0;m=m+h|0}}f[e>>2]=n;return 0}m=Y(h,g)|0;g=m+-4|0;if((m|0)<4){t=0;u=0}else{h=0;l=0;do{o=(b[a+h>>0]|0)-(b[c+h>>0]|0)|0;k=h|1;j=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;k=h|2;d=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;k=h|3;q=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;l=((o|0)>-1?o:0-o|0)+l+((j|0)>-1?j:0-j|0)+((d|0)>-1?d:0-d|0)+((q|0)>-1?q:0-q|0)|0;h=h+4|0}while((h|0)<=(g|0));t=m&-4;u=l}if((t|0)<(m|0)){l=t;t=u;while(1){g=(b[a+l>>0]|0)-(b[c+l>>0]|0)|0;h=((g|0)>-1?g:0-g|0)+t|0;l=l+1|0;if((l|0)==(m|0)){v=h;break}else t=h}}else v=u;n=v+i|0;f[e>>2]=n;return 0}function N_(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0.0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0;m=u;u=u+512|0;o=m+56|0;q=m+496|0;r=m+440|0;s=m+384|0;t=m+328|0;v=m+272|0;w=m+208|0;x=m+264|0;y=m;z=m+152|0;A=m+136|0;B=m+120|0;C=m+104|0;D=m+88|0;E=m+72|0;_$(q,43340);do if((NS(a)|0)==65536){F=f[a+4>>2]|0;f[r>>2]=f[F>>2];G=r+4|0;H=F+4|0;f[G>>2]=f[H>>2];I=r+8|0;f[I>>2]=f[F+8>>2];f[r+12>>2]=f[F+12>>2];f[r+16>>2]=f[F+16>>2];f[r+20>>2]=f[F+20>>2];f[r+24>>2]=f[F+24>>2];f[r+28>>2]=f[F+28>>2];f[r+32>>2]=f[F+32>>2];J=f[F+36>>2]|0;f[r+36>>2]=J;f[r+40>>2]=I;I=r+48|0;K=r+44|0;f[K>>2]=I;f[I>>2]=0;f[r+52>>2]=0;if(J|0){I=J+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[H>>2]|0)<3){H=f[F+44>>2]|0;I=f[K>>2]|0;f[I>>2]=f[H>>2];f[I+4>>2]=f[H+4>>2];break}else{f[G>>2]=0;BR(r,F);break}}else OR(r,a,-1);while(0);do if((NS(c)|0)==65536){a=f[c+4>>2]|0;f[s>>2]=f[a>>2];F=s+4|0;G=a+4|0;f[F>>2]=f[G>>2];H=s+8|0;f[H>>2]=f[a+8>>2];f[s+12>>2]=f[a+12>>2];f[s+16>>2]=f[a+16>>2];f[s+20>>2]=f[a+20>>2];f[s+24>>2]=f[a+24>>2];f[s+28>>2]=f[a+28>>2];f[s+32>>2]=f[a+32>>2];I=f[a+36>>2]|0;f[s+36>>2]=I;f[s+40>>2]=H;H=s+48|0;K=s+44|0;f[K>>2]=H;f[H>>2]=0;f[s+52>>2]=0;if(I|0){H=I+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[G>>2]|0)<3){G=f[a+44>>2]|0;H=f[K>>2]|0;f[H>>2]=f[G>>2];f[H+4>>2]=f[G+4>>2];break}else{f[F>>2]=0;BR(s,a);break}}else OR(s,c,-1);while(0);do if((NS(j)|0)==65536){c=f[j+4>>2]|0;f[t>>2]=f[c>>2];a=t+4|0;F=c+4|0;f[a>>2]=f[F>>2];G=t+8|0;f[G>>2]=f[c+8>>2];f[t+12>>2]=f[c+12>>2];f[t+16>>2]=f[c+16>>2];f[t+20>>2]=f[c+20>>2];f[t+24>>2]=f[c+24>>2];f[t+28>>2]=f[c+28>>2];f[t+32>>2]=f[c+32>>2];H=f[c+36>>2]|0;f[t+36>>2]=H;f[t+40>>2]=G;G=t+48|0;K=t+44|0;f[K>>2]=G;f[G>>2]=0;f[t+52>>2]=0;if(H|0){G=H+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[F>>2]|0)<3){F=f[c+44>>2]|0;G=f[K>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=f[F+4>>2];break}else{f[a>>2]=0;BR(t,c);break}}else OR(t,j,-1);while(0);j=f[r>>2]|0;c=j&4095;if((c|0)==(f[s>>2]&4095|0)?(f[r+12>>2]|0)==(f[s+12>>2]|0):0)switch(j&4095){case 0:case 5:break;default:L=25}else L=25;if((L|0)==25){f[v>>2]=0;f[v+4>>2]=0;M=c$(v,73)|0;N=190205;O=M+73|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));j$(-215,v,190279,188515,4017);d$(v)}if((i|0)>0^(dT(g)|0)){f[v>>2]=0;f[v+4>>2]=0;M=c$(v,25)|0;N=190293;O=M+25|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));j$(-215,v,190279,188515,4018);d$(v)}j=(e|0)==-1?((h|1|0)==7?4:5):e;e=(c|0)==0;a=(j|0)==4;F=(j|0)==5;if(!(F|a&e)){f[v>>2]=0;f[v+4>>2]=0;M=c$(v,39)|0;N=190319;O=M+39|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));j$(-215,v,190279,188515,4024);d$(v)}G=f[s+8>>2]|0;K=(G|0)<(i|0)?G:i;i=r+8|0;H=(K|0)>0;pS(d,f[i>>2]|0,H?K:G,j,-1,0,0);do if((NS(d)|0)==65536){G=f[d+4>>2]|0;f[v>>2]=f[G>>2];I=v+4|0;J=G+4|0;f[I>>2]=f[J>>2];P=v+8|0;f[P>>2]=f[G+8>>2];f[v+12>>2]=f[G+12>>2];f[v+16>>2]=f[G+16>>2];f[v+20>>2]=f[G+20>>2];f[v+24>>2]=f[G+24>>2];f[v+28>>2]=f[G+28>>2];f[v+32>>2]=f[G+32>>2];Q=f[G+36>>2]|0;f[v+36>>2]=Q;f[v+40>>2]=P;P=v+48|0;R=v+44|0;f[R>>2]=P;f[P>>2]=0;f[v+52>>2]=0;if(Q|0){P=Q+12|0;f[P>>2]=(f[P>>2]|0)+1}if((f[J>>2]|0)<3){J=f[G+44>>2]|0;P=f[R>>2]|0;f[P>>2]=f[J>>2];f[P+4>>2]=f[J+4>>2];break}else{f[I>>2]=0;BR(v,G);break}}else OR(v,d,-1);while(0);f[w>>2]=1124007936;d=w+4|0;G=w+8|0;I=w+40|0;M=d;O=M+36|0;do{f[M>>2]=0;M=M+4|0}while((M|0)<(O|0));f[I>>2]=G;J=w+48|0;P=w+44|0;f[P>>2]=J;f[J>>2]=0;f[w+52>>2]=0;if(dT(g)|0){R=f[v+40>>2]|0;Q=f[R>>2]|0;f[x>>2]=f[R+4>>2];f[x+4>>2]=Q;KS(g,x,4,-1,0,0);do if((NS(g)|0)==65536){x=f[g+4>>2]|0;f[y>>2]=f[x>>2];Q=y+4|0;R=x+4|0;f[Q>>2]=f[R>>2];S=y+8|0;f[S>>2]=f[x+8>>2];f[y+12>>2]=f[x+12>>2];f[y+16>>2]=f[x+16>>2];f[y+20>>2]=f[x+20>>2];f[y+24>>2]=f[x+24>>2];f[y+28>>2]=f[x+28>>2];f[y+32>>2]=f[x+32>>2];T=y+36|0;U=f[x+36>>2]|0;f[T>>2]=U;f[y+40>>2]=S;S=y+48|0;V=y+44|0;f[V>>2]=S;f[S>>2]=0;f[y+52>>2]=0;if(U|0){S=U+12|0;f[S>>2]=(f[S>>2]|0)+1}if((f[R>>2]|0)<3){R=f[x+44>>2]|0;S=f[V>>2]|0;f[S>>2]=f[R>>2];f[S+4>>2]=f[R+4>>2];W=T;break}else{f[Q>>2]=0;BR(y,x);W=T;break}}else{OR(y,g,-1);W=y+36|0}while(0);g=f[W>>2]|0;if(g|0){T=g+12|0;f[T>>2]=(f[T>>2]|0)+1}T=w+36|0;g=f[T>>2]|0;if(g|0?(x=g+12|0,g=f[x>>2]|0,f[x>>2]=g+-1,(g|0)==1):0)CR(w);f[T>>2]=0;g=w+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[d>>2]|0)>0){x=f[I>>2]|0;Q=0;do{f[x+(Q<<2)>>2]=0;Q=Q+1|0;X=f[d>>2]|0}while((Q|0)<(X|0));f[w>>2]=f[y>>2];if((X|0)<3)L=55;else L=57}else{f[w>>2]=f[y>>2];L=55}if((L|0)==55){X=f[y+4>>2]|0;if((X|0)<3){f[d>>2]=X;f[G>>2]=f[y+8>>2];f[w+12>>2]=f[y+12>>2];G=f[y+44>>2]|0;X=f[P>>2]|0;f[X>>2]=f[G>>2];f[X+4>>2]=f[G+4>>2]}else L=57}if((L|0)==57)BR(w,y);G=y+16|0;f[g>>2]=f[G>>2];f[w+20>>2]=f[y+20>>2];f[w+24>>2]=f[y+24>>2];f[w+28>>2]=f[y+28>>2];f[w+32>>2]=f[y+32>>2];g=f[W>>2]|0;f[T>>2]=g;if(g|0?(T=g+12|0,g=f[T>>2]|0,f[T>>2]=g+-1,(g|0)==1):0)CR(y);f[W>>2]=0;W=y+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[W>>2]|0)>0){G=f[y+40>>2]|0;g=0;do{f[G+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[W>>2]|0))}W=f[y+44>>2]|0;if((W|0)!=(y+48|0))ZF(W)}W=(k|0)==0;if(W&H){Z=a?2147483647.0:3402823466385288598117041.0e14;p[y>>3]=Z;p[y+8>>3]=Z;p[y+16>>3]=Z;p[y+24>>3]=Z;gL(v,y)|0;p[y>>3]=-1.0;p[y+8>>3]=-1.0;p[y+16>>3]=-1.0;p[y+24>>3]=-1.0;gL(w,y)|0}if(l){if(W&(K|0)==1){if(f[t+16>>2]|0){W=f[t+4>>2]|0;if((W|0)<3)_=Y(f[t+12>>2]|0,f[t+8>>2]|0)|0;else{l=f[t+40>>2]|0;H=0;g=1;while(1){G=Y(f[l+(H<<2)>>2]|0,g)|0;H=H+1|0;if((H|0)==(W|0)){_=G;break}else g=G}}if(!((W|0)==0|(_|0)==0))L=77}}else L=77;if((L|0)==77){f[y>>2]=0;f[y+4>>2]=0;M=c$(y,37)|0;N=190359;O=M+37|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));j$(-215,y,190279,188515,4044);d$(y)}f[y>>2]=1124007936;N=y+4|0;_=y+8|0;W=y+40|0;M=N;O=M+36|0;do{f[M>>2]=0;M=M+4|0}while((M|0)<(O|0));f[W>>2]=_;g=y+48|0;H=y+44|0;f[H>>2]=g;f[g>>2]=0;f[y+52>>2]=0;f[z>>2]=1124007936;l=z+4|0;G=z+8|0;T=z+40|0;M=l;O=M+36|0;do{f[M>>2]=0;M=M+4|0}while((M|0)<(O|0));f[T>>2]=G;G=z+48|0;M=z+44|0;f[M>>2]=G;f[G>>2]=0;f[z+52>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;f[A>>2]=16842752;f[A+4>>2]=s;f[B+8>>2]=0;f[B+12>>2]=0;f[B>>2]=16842752;f[B+4>>2]=r;O=C+8|0;f[O>>2]=0;f[O+4>>2]=0;f[C>>2]=33619968;f[C+4>>2]=y;O=D+8|0;f[O>>2]=0;f[O+4>>2]=0;f[D>>2]=33619968;f[D+4>>2]=z;f[E+8>>2]=0;f[E+12>>2]=0;f[E>>2]=16842752;f[E+4>>2]=t;N_(A,B,C,j,D,h,K,E,0,0);E=f[_>>2]|0;D=(E|0)>0;if(a){if(D){C=f[z+16>>2]|0;B=f[T>>2]|0;A=B+4|0;O=f[M>>2]|0;X=z+12|0;Q=f[y+16>>2]|0;x=f[W>>2]|0;R=x+4|0;S=f[H>>2]|0;V=y+12|0;U=f[v+16>>2]|0;$=f[v+40>>2]|0;aa=$+4|0;ba=f[v+44>>2]|0;ca=v+12|0;da=f[w+16>>2]|0;ea=f[I>>2]|0;fa=ea+4|0;ga=f[P>>2]|0;ha=w+12|0;ia=E;ja=0;while(1){do if((f[z>>2]&16384|0)==0?(f[B>>2]|0)!=1:0){ka=f[O>>2]|0;if((f[A>>2]|0)==1){la=C+(Y(ka,ja)|0)|0;break}else{ma=f[X>>2]|0;na=(ja|0)/(ma|0)|0;la=C+(Y(na,ka)|0)+(ja-(Y(na,ma)|0)<<2)|0;break}}else L=85;while(0);if((L|0)==85){L=0;la=C+(ja<<2)|0}ma=f[la>>2]|0;do if((f[y>>2]&16384|0)==0?(f[x>>2]|0)!=1:0){na=f[S>>2]|0;if((f[R>>2]|0)==1){oa=Q+(Y(na,ja)|0)|0;break}else{ka=f[V>>2]|0;pa=(ja|0)/(ka|0)|0;oa=Q+(Y(pa,na)|0)+(ja-(Y(pa,ka)|0)<<2)|0;break}}else L=91;while(0);if((L|0)==91){L=0;oa=Q+(ja<<2)|0}ka=f[oa>>2]|0;pa=(f[v>>2]&16384|0)==0;do if(pa){if((f[$>>2]|0)==1){L=97;break}na=f[ba>>2]|0;if((f[aa>>2]|0)==1){qa=U+(Y(na,ma)|0)|0;break}else{ra=f[ca>>2]|0;sa=(ma|0)/(ra|0)|0;qa=U+(Y(sa,na)|0)+(ma-(Y(sa,ra)|0)<<2)|0;break}}else L=97;while(0);if((L|0)==97){L=0;qa=U+(ma<<2)|0}if((ka|0)<(f[qa>>2]|0)){do if(pa){if((f[$>>2]|0)==1){L=104;break}ra=f[ba>>2]|0;if((f[aa>>2]|0)==1){ta=U+(Y(ra,ma)|0)|0;break}else{sa=f[ca>>2]|0;na=(ma|0)/(sa|0)|0;ta=U+(Y(na,ra)|0)+(ma-(Y(na,sa)|0)<<2)|0;break}}else L=104;while(0);if((L|0)==104){L=0;ta=U+(ma<<2)|0}f[ta>>2]=ka;pa=ja+k|0;do if(!(f[w>>2]&16384)){if((f[ea>>2]|0)==1){L=110;break}sa=f[ga>>2]|0;if((f[fa>>2]|0)==1){ua=da+(Y(sa,ma)|0)|0;break}else{na=f[ha>>2]|0;ra=(ma|0)/(na|0)|0;ua=da+(Y(ra,sa)|0)+(ma-(Y(ra,na)|0)<<2)|0;break}}else L=110;while(0);if((L|0)==110){L=0;ua=da+(ma<<2)|0}f[ua>>2]=pa;va=f[_>>2]|0}else va=ia;ja=ja+1|0;if((ja|0)>=(va|0))break;else ia=va}}}else if(D){D=f[z+16>>2]|0;va=f[T>>2]|0;ia=va+4|0;ja=f[M>>2]|0;ua=z+12|0;da=f[y+16>>2]|0;ha=f[W>>2]|0;fa=ha+4|0;ga=f[H>>2]|0;ea=y+12|0;ta=f[v+16>>2]|0;U=f[v+40>>2]|0;ca=U+4|0;aa=f[v+44>>2]|0;ba=v+12|0;$=f[w+16>>2]|0;qa=f[I>>2]|0;oa=qa+4|0;Q=f[P>>2]|0;V=w+12|0;R=E;E=0;while(1){do if((f[z>>2]&16384|0)==0?(f[va>>2]|0)!=1:0){S=f[ja>>2]|0;if((f[ia>>2]|0)==1){wa=D+(Y(S,E)|0)|0;break}else{x=f[ua>>2]|0;la=(E|0)/(x|0)|0;wa=D+(Y(la,S)|0)+(E-(Y(la,x)|0)<<2)|0;break}}else L=118;while(0);if((L|0)==118){L=0;wa=D+(E<<2)|0}pa=f[wa>>2]|0;do if((f[y>>2]&16384|0)==0?(f[ha>>2]|0)!=1:0){ma=f[ga>>2]|0;if((f[fa>>2]|0)==1){xa=da+(Y(ma,E)|0)|0;break}else{x=f[ea>>2]|0;la=(E|0)/(x|0)|0;xa=da+(Y(la,ma)|0)+(E-(Y(la,x)|0)<<2)|0;break}}else L=124;while(0);if((L|0)==124){L=0;xa=da+(E<<2)|0}Z=+n[xa>>2];x=(f[v>>2]&16384|0)==0;do if(x){if((f[U>>2]|0)==1){L=130;break}la=f[aa>>2]|0;if((f[ca>>2]|0)==1){ya=ta+(Y(la,pa)|0)|0;break}else{ma=f[ba>>2]|0;S=(pa|0)/(ma|0)|0;ya=ta+(Y(S,la)|0)+(pa-(Y(S,ma)|0)<<2)|0;break}}else L=130;while(0);if((L|0)==130){L=0;ya=ta+(pa<<2)|0}if(Z<+n[ya>>2]){do if(x){if((f[U>>2]|0)==1){L=137;break}ma=f[aa>>2]|0;if((f[ca>>2]|0)==1){za=ta+(Y(ma,pa)|0)|0;break}else{S=f[ba>>2]|0;la=(pa|0)/(S|0)|0;za=ta+(Y(la,ma)|0)+(pa-(Y(la,S)|0)<<2)|0;break}}else L=137;while(0);if((L|0)==137){L=0;za=ta+(pa<<2)|0}n[za>>2]=Z;x=E+k|0;do if(!(f[w>>2]&16384)){if((f[qa>>2]|0)==1){L=143;break}S=f[Q>>2]|0;if((f[oa>>2]|0)==1){Aa=$+(Y(S,pa)|0)|0;break}else{la=f[V>>2]|0;ma=(pa|0)/(la|0)|0;Aa=$+(Y(ma,S)|0)+(pa-(Y(ma,la)|0)<<2)|0;break}}else L=143;while(0);if((L|0)==143){L=0;Aa=$+(pa<<2)|0}f[Aa>>2]=x;Ba=f[_>>2]|0}else Ba=R;E=E+1|0;if((E|0)>=(Ba|0))break;else R=Ba}}Ba=z+36|0;R=f[Ba>>2]|0;if(R|0?(E=R+12|0,R=f[E>>2]|0,f[E>>2]=R+-1,(R|0)==1):0)CR(z);f[Ba>>2]=0;Ba=z+16|0;f[Ba>>2]=0;f[Ba+4>>2]=0;f[Ba+8>>2]=0;f[Ba+12>>2]=0;if((f[l>>2]|0)>0){Ba=f[T>>2]|0;T=0;do{f[Ba+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[l>>2]|0))}l=f[M>>2]|0;if((l|0)!=(G|0))ZF(l);l=y+36|0;G=f[l>>2]|0;if(G|0?(M=G+12|0,G=f[M>>2]|0,f[M>>2]=G+-1,(G|0)==1):0)CR(y);f[l>>2]=0;l=y+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[N>>2]|0)>0){l=f[W>>2]|0;W=0;do{f[l+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[N>>2]|0))}N=f[H>>2]|0;if((N|0)!=(g|0))ZF(N)}else{a:do if(e){N=(h|0)==2;if(!(N&a))if(!(N&F)){N=(h|0)==5;if(!(N&a))if(!(N&F))if(!((h|0)==4&F))if(!((h|0)==6&a))if((h|0)==7&a)Ca=96;else L=178;else Ca=92;else Ca=91;else Ca=90;else Ca=89}else Ca=88;else Ca=87}else if(F&(c|0)==5)switch(h|0){case 2:{Ca=93;break a;break}case 5:{Ca=94;break a;break}case 4:{Ca=95;break a;break}default:{L=178;break a}}else L=178;while(0);if((L|0)==178){f[o>>2]=c;f[o+4>>2]=j;f[o+8>>2]=h;p$(y,190397,o);j$(-210,y,190279,188515,4114);d$(y);Ca=0}o=f[i>>2]|0;f[y>>2]=0;f[y+4>>2]=o;f[z>>2]=43368;f[z+4>>2]=r;f[z+8>>2]=s;f[z+12>>2]=v;f[z+16>>2]=w;f[z+24>>2]=K;f[z+20>>2]=t;f[z+28>>2]=k;f[z+32>>2]=Ca;_U(y,z,-1.0)}z=w+36|0;y=f[z>>2]|0;if(y|0?(Ca=y+12|0,y=f[Ca>>2]|0,f[Ca>>2]=y+-1,(y|0)==1):0)CR(w);f[z>>2]=0;z=w+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[d>>2]|0)>0){z=f[I>>2]|0;I=0;do{f[z+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[d>>2]|0))}d=f[P>>2]|0;if((d|0)!=(J|0))ZF(d);d=v+36|0;J=f[d>>2]|0;if(J|0?(P=J+12|0,J=f[P>>2]|0,f[P>>2]=J+-1,(J|0)==1):0)CR(v);f[d>>2]=0;d=v+16|0;J=v+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[J>>2]|0)>0){d=f[v+40>>2]|0;P=0;do{f[d+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[J>>2]|0))}J=f[v+44>>2]|0;if((J|0)!=(v+48|0))ZF(J);J=t+36|0;v=f[J>>2]|0;if(v|0?(P=v+12|0,v=f[P>>2]|0,f[P>>2]=v+-1,(v|0)==1):0)CR(t);f[J>>2]=0;J=t+16|0;v=t+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[v>>2]|0)>0){J=f[t+40>>2]|0;P=0;do{f[J+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[v>>2]|0))}v=f[t+44>>2]|0;if((v|0)!=(t+48|0))ZF(v);v=s+36|0;t=f[v>>2]|0;do if(t|0){P=t+12|0;J=f[P>>2]|0;f[P>>2]=J+-1;if((J|0)!=1)break;CR(s)}while(0);f[v>>2]=0;v=s+16|0;t=s+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[t>>2]|0)>0){v=f[s+40>>2]|0;J=0;do{f[v+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[t>>2]|0))}t=f[s+44>>2]|0;if((t|0)!=(s+48|0))ZF(t);t=r+36|0;s=f[t>>2]|0;do if(s|0){J=s+12|0;v=f[J>>2]|0;f[J>>2]=v+-1;if((v|0)!=1)break;CR(r)}while(0);f[t>>2]=0;t=r+16|0;s=r+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[s>>2]|0)>0){t=f[r+40>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[s>>2]|0))}s=f[r+44>>2]|0;if((s|0)!=(r+48|0))ZF(s);if(!(f[q+4>>2]|0)){u=m;return}u=m;return}function O_(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;j=(e|0)>0;if(!i){if(j)k=0;else return;do{l=f_(a,c+(Y(k,d)|0)|0,g,2)|0;f[h+(k<<2)>>2]=l;k=k+1|0}while((k|0)!=(e|0));return}if(j)m=0;else return;do{if(!(b[i+m>>0]|0))n=2147483647;else n=f_(a,c+(Y(m,d)|0)|0,g,2)|0;f[h+(m<<2)>>2]=n;m=m+1|0}while((m|0)!=(e|0));return}function P_(a,c,d,e,f,g,h){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;i=d>>>2;d=(e|0)>0;if(!h){if(!d)return;j=f+-4|0;k=f&-4;if((f|0)<4){l=(f|0)>0;m=0;do{o=c+((Y(m,i)|0)<<2)|0;if(l){p=0;q=0.0;while(1){r=q+ +L(+(+n[a+(p<<2)>>2]-+n[o+(p<<2)>>2]));p=p+1|0;if((p|0)==(f|0)){s=r;break}else q=r}}else s=0.0;n[g+(m<<2)>>2]=s;m=m+1|0}while((m|0)!=(e|0));return}m=(k|0)<(f|0);l=0;do{p=c+((Y(l,i)|0)<<2)|0;o=0;s=0.0;do{t=o|1;u=o|2;v=o|3;s=s+(+L(+(+n[a+(o<<2)>>2]-+n[p+(o<<2)>>2]))+ +L(+(+n[a+(t<<2)>>2]-+n[p+(t<<2)>>2]))+ +L(+(+n[a+(u<<2)>>2]-+n[p+(u<<2)>>2]))+ +L(+(+n[a+(v<<2)>>2]-+n[p+(v<<2)>>2])));o=o+4|0}while((o|0)<=(j|0));if(m){o=k;q=s;while(1){r=q+ +L(+(+n[a+(o<<2)>>2]-+n[p+(o<<2)>>2]));o=o+1|0;if((o|0)==(f|0)){w=r;break}else q=r}}else w=s;n[g+(l<<2)>>2]=w;l=l+1|0}while((l|0)!=(e|0));return}if(!d)return;d=f+-4|0;l=f&-4;if((f|0)<4){k=(f|0)>0;m=0;do{if(b[h+m>>0]|0){j=c+((Y(m,i)|0)<<2)|0;if(k){o=0;w=0.0;while(1){q=w+ +L(+(+n[a+(o<<2)>>2]-+n[j+(o<<2)>>2]));o=o+1|0;if((o|0)==(f|0)){x=q;break}else w=q}}else x=0.0}else x=3402823466385288598117041.0e14;n[g+(m<<2)>>2]=x;m=m+1|0}while((m|0)!=(e|0));return}m=(l|0)<(f|0);k=0;do{if(b[h+k>>0]|0){o=c+((Y(k,i)|0)<<2)|0;j=0;x=0.0;do{p=j|1;v=j|2;u=j|3;x=x+(+L(+(+n[a+(j<<2)>>2]-+n[o+(j<<2)>>2]))+ +L(+(+n[a+(p<<2)>>2]-+n[o+(p<<2)>>2]))+ +L(+(+n[a+(v<<2)>>2]-+n[o+(v<<2)>>2]))+ +L(+(+n[a+(u<<2)>>2]-+n[o+(u<<2)>>2])));j=j+4|0}while((j|0)<=(d|0));if(m){j=l;w=x;while(1){s=w+ +L(+(+n[a+(j<<2)>>2]-+n[o+(j<<2)>>2]));j=j+1|0;if((j|0)==(f|0)){y=s;break}else w=s}}else y=x}else y=3402823466385288598117041.0e14;n[g+(k<<2)>>2]=y;k=k+1|0}while((k|0)!=(e|0));return}function Q_(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;j=(e|0)>0;if(!i){if(j)k=0;else return;do{l=b$(a,c+(Y(k,d)|0)|0,g)|0;f[h+(k<<2)>>2]=l;k=k+1|0}while((k|0)!=(e|0));return}if(j)m=0;else return;do{if(!(b[i+m>>0]|0))n=2147483647;else n=b$(a,c+(Y(m,d)|0)|0,g)|0;f[h+(m<<2)>>2]=n;m=m+1|0}while((m|0)!=(e|0));return}function R_(a,c,d,e,f,g,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0;j=(e|0)>0;if(!i){if(!j)return;k=f+-4|0;l=f&-4;if((f|0)<4){m=(f|0)>0;o=0;do{p=c+(Y(o,d)|0)|0;if(m){q=0;r=0.0;while(1){s=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);t=r+s*s;q=q+1|0;if((q|0)==(f|0)){u=t;break}else r=t}}else u=0.0;r=+M(+u);n[g+(o<<2)>>2]=r;o=o+1|0}while((o|0)!=(e|0));return}o=(l|0)<(f|0);m=0;do{q=c+(Y(m,d)|0)|0;p=0;u=0.0;do{r=+((h[a+p>>0]|0)-(h[q+p>>0]|0)|0);v=p|1;t=+((h[a+v>>0]|0)-(h[q+v>>0]|0)|0);v=p|2;s=+((h[a+v>>0]|0)-(h[q+v>>0]|0)|0);v=p|3;w=+((h[a+v>>0]|0)-(h[q+v>>0]|0)|0);u=u+(r*r+t*t+s*s+w*w);p=p+4|0}while((p|0)<=(k|0));if(o){p=l;w=u;while(1){s=+((h[a+p>>0]|0)-(h[q+p>>0]|0)|0);t=w+s*s;p=p+1|0;if((p|0)==(f|0)){x=t;break}else w=t}}else x=u;w=+M(+x);n[g+(m<<2)>>2]=w;m=m+1|0}while((m|0)!=(e|0));return}if(!j)return;j=f+-4|0;m=f&-4;if((f|0)<4){l=(f|0)>0;o=0;do{if(!(b[i+o>>0]|0))y=3402823466385288598117041.0e14;else{k=c+(Y(o,d)|0)|0;if(l){p=0;x=0.0;while(1){w=+((h[a+p>>0]|0)-(h[k+p>>0]|0)|0);t=x+w*w;p=p+1|0;if((p|0)==(f|0)){z=t;break}else x=t}}else z=0.0;y=+M(+z)}n[g+(o<<2)>>2]=y;o=o+1|0}while((o|0)!=(e|0));return}o=(m|0)<(f|0);l=0;do{if(!(b[i+l>>0]|0))A=3402823466385288598117041.0e14;else{p=c+(Y(l,d)|0)|0;k=0;y=0.0;do{z=+((h[a+k>>0]|0)-(h[p+k>>0]|0)|0);q=k|1;x=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);q=k|2;u=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);q=k|3;t=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);y=y+(z*z+x*x+u*u+t*t);k=k+4|0}while((k|0)<=(j|0));if(o){k=m;t=y;while(1){u=+((h[a+k>>0]|0)-(h[p+k>>0]|0)|0);x=t+u*u;k=k+1|0;if((k|0)==(f|0)){B=x;break}else t=x}}else B=y;A=+M(+B)}n[g+(l<<2)>>2]=A;l=l+1|0}while((l|0)!=(e|0));return}function S_(a,c,d,e,f,g,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0;j=(e|0)>0;if(!i){if(!j)return;k=f+-4|0;l=f&-4;if((f|0)<4){m=(f|0)>0;o=0;do{p=c+(Y(o,d)|0)|0;if(m){q=0;r=0.0;while(1){s=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);t=r+s*s;q=q+1|0;if((q|0)==(f|0)){u=t;break}else r=t}}else u=0.0;n[g+(o<<2)>>2]=u;o=o+1|0}while((o|0)!=(e|0));return}o=(l|0)<(f|0);m=0;do{q=c+(Y(m,d)|0)|0;p=0;u=0.0;do{r=+((h[a+p>>0]|0)-(h[q+p>>0]|0)|0);v=p|1;t=+((h[a+v>>0]|0)-(h[q+v>>0]|0)|0);v=p|2;s=+((h[a+v>>0]|0)-(h[q+v>>0]|0)|0);v=p|3;w=+((h[a+v>>0]|0)-(h[q+v>>0]|0)|0);u=u+(r*r+t*t+s*s+w*w);p=p+4|0}while((p|0)<=(k|0));if(o){p=l;w=u;while(1){s=+((h[a+p>>0]|0)-(h[q+p>>0]|0)|0);t=w+s*s;p=p+1|0;if((p|0)==(f|0)){x=t;break}else w=t}}else x=u;n[g+(m<<2)>>2]=x;m=m+1|0}while((m|0)!=(e|0));return}if(!j)return;j=f+-4|0;m=f&-4;if((f|0)<4){l=(f|0)>0;o=0;do{if(b[i+o>>0]|0){k=c+(Y(o,d)|0)|0;if(l){p=0;x=0.0;while(1){w=+((h[a+p>>0]|0)-(h[k+p>>0]|0)|0);t=x+w*w;p=p+1|0;if((p|0)==(f|0)){y=t;break}else x=t}}else y=0.0}else y=3402823466385288598117041.0e14;n[g+(o<<2)>>2]=y;o=o+1|0}while((o|0)!=(e|0));return}o=(m|0)<(f|0);l=0;do{if(b[i+l>>0]|0){p=c+(Y(l,d)|0)|0;k=0;y=0.0;do{x=+((h[a+k>>0]|0)-(h[p+k>>0]|0)|0);q=k|1;u=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);q=k|2;t=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);q=k|3;w=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);y=y+(x*x+u*u+t*t+w*w);k=k+4|0}while((k|0)<=(j|0));if(o){k=m;w=y;while(1){t=+((h[a+k>>0]|0)-(h[p+k>>0]|0)|0);u=w+t*t;k=k+1|0;if((k|0)==(f|0)){z=u;break}else w=u}}else z=y}else z=3402823466385288598117041.0e14;n[g+(l<<2)>>2]=z;l=l+1|0}while((l|0)!=(e|0));return}function T_(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;k=(e|0)>0;if(!j){if(!k)return;l=g+-4|0;m=g&-4;if((g|0)<4){n=(g|0)>0;o=0;do{p=c+(Y(o,d)|0)|0;if(n){q=0;r=0;while(1){s=(h[a+q>>0]|0)-(h[p+q>>0]|0)|0;t=(Y(s,s)|0)+r|0;q=q+1|0;if((q|0)==(g|0)){u=t;break}else r=t}}else u=0;f[i+(o<<2)>>2]=u;o=o+1|0}while((o|0)!=(e|0));return}o=(m|0)<(g|0);u=0;do{n=c+(Y(u,d)|0)|0;r=0;q=0;do{p=(h[a+r>>0]|0)-(h[n+r>>0]|0)|0;t=r|1;s=(h[a+t>>0]|0)-(h[n+t>>0]|0)|0;t=r|2;v=(h[a+t>>0]|0)-(h[n+t>>0]|0)|0;t=r|3;w=(h[a+t>>0]|0)-(h[n+t>>0]|0)|0;q=(Y(p,p)|0)+q+(Y(s,s)|0)+(Y(v,v)|0)+(Y(w,w)|0)|0;r=r+4|0}while((r|0)<=(l|0));if(o){r=m;w=q;while(1){v=(h[a+r>>0]|0)-(h[n+r>>0]|0)|0;s=(Y(v,v)|0)+w|0;r=r+1|0;if((r|0)==(g|0)){x=s;break}else w=s}}else x=q;f[i+(u<<2)>>2]=x;u=u+1|0}while((u|0)!=(e|0));return}if(!k)return;k=g+-4|0;u=g&-4;if((g|0)<4){x=(g|0)>0;m=0;do{if(b[j+m>>0]|0){o=c+(Y(m,d)|0)|0;if(x){l=0;w=0;while(1){r=(h[a+l>>0]|0)-(h[o+l>>0]|0)|0;n=(Y(r,r)|0)+w|0;l=l+1|0;if((l|0)==(g|0)){y=n;break}else w=n}}else y=0}else y=2147483647;f[i+(m<<2)>>2]=y;m=m+1|0}while((m|0)!=(e|0));return}m=(u|0)<(g|0);y=0;do{if(b[j+y>>0]|0){x=c+(Y(y,d)|0)|0;w=0;l=0;do{o=(h[a+w>>0]|0)-(h[x+w>>0]|0)|0;q=w|1;n=(h[a+q>>0]|0)-(h[x+q>>0]|0)|0;q=w|2;r=(h[a+q>>0]|0)-(h[x+q>>0]|0)|0;q=w|3;s=(h[a+q>>0]|0)-(h[x+q>>0]|0)|0;l=(Y(o,o)|0)+l+(Y(n,n)|0)+(Y(r,r)|0)+(Y(s,s)|0)|0;w=w+4|0}while((w|0)<=(k|0));if(m){w=u;s=l;while(1){r=(h[a+w>>0]|0)-(h[x+w>>0]|0)|0;n=(Y(r,r)|0)+s|0;w=w+1|0;if((w|0)==(g|0)){z=n;break}else s=n}}else z=l}else z=2147483647;f[i+(y<<2)>>2]=z;y=y+1|0}while((y|0)!=(e|0));return}function U_(a,c,d,e,f,g,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0;j=(e|0)>0;if(!i){if(!j)return;k=f+-4|0;l=f&-4;if((f|0)<4){m=(f|0)>0;o=0;do{p=c+(Y(o,d)|0)|0;if(m){q=0;r=0.0;while(1){s=r+ +L(+(+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0)));q=q+1|0;if((q|0)==(f|0)){t=s;break}else r=s}}else t=0.0;n[g+(o<<2)>>2]=t;o=o+1|0}while((o|0)!=(e|0));return}o=(l|0)<(f|0);m=0;do{q=c+(Y(m,d)|0)|0;p=0;t=0.0;do{u=p|1;v=p|2;w=p|3;t=t+(+L(+(+((h[a+p>>0]|0)-(h[q+p>>0]|0)|0)))+ +L(+(+((h[a+u>>0]|0)-(h[q+u>>0]|0)|0)))+ +L(+(+((h[a+v>>0]|0)-(h[q+v>>0]|0)|0)))+ +L(+(+((h[a+w>>0]|0)-(h[q+w>>0]|0)|0))));p=p+4|0}while((p|0)<=(k|0));if(o){p=l;r=t;while(1){s=r+ +L(+(+((h[a+p>>0]|0)-(h[q+p>>0]|0)|0)));p=p+1|0;if((p|0)==(f|0)){x=s;break}else r=s}}else x=t;n[g+(m<<2)>>2]=x;m=m+1|0}while((m|0)!=(e|0));return}if(!j)return;j=f+-4|0;m=f&-4;if((f|0)<4){l=(f|0)>0;o=0;do{if(b[i+o>>0]|0){k=c+(Y(o,d)|0)|0;if(l){p=0;x=0.0;while(1){r=x+ +L(+(+((h[a+p>>0]|0)-(h[k+p>>0]|0)|0)));p=p+1|0;if((p|0)==(f|0)){y=r;break}else x=r}}else y=0.0}else y=3402823466385288598117041.0e14;n[g+(o<<2)>>2]=y;o=o+1|0}while((o|0)!=(e|0));return}o=(m|0)<(f|0);l=0;do{if(b[i+l>>0]|0){p=c+(Y(l,d)|0)|0;k=0;y=0.0;do{q=k|1;w=k|2;v=k|3;y=y+(+L(+(+((h[a+k>>0]|0)-(h[p+k>>0]|0)|0)))+ +L(+(+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0)))+ +L(+(+((h[a+w>>0]|0)-(h[p+w>>0]|0)|0)))+ +L(+(+((h[a+v>>0]|0)-(h[p+v>>0]|0)|0))));k=k+4|0}while((k|0)<=(j|0));if(o){k=m;x=y;while(1){t=x+ +L(+(+((h[a+k>>0]|0)-(h[p+k>>0]|0)|0)));k=k+1|0;if((k|0)==(f|0)){z=t;break}else x=t}}else z=y}else z=3402823466385288598117041.0e14;n[g+(l<<2)>>2]=z;l=l+1|0}while((l|0)!=(e|0));return}function V_(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;k=(e|0)>0;if(!j){if(!k)return;l=g+-4|0;m=g&-4;if((g|0)<4){n=(g|0)>0;o=0;do{p=c+(Y(o,d)|0)|0;if(n){q=0;r=0;while(1){s=(h[a+q>>0]|0)-(h[p+q>>0]|0)|0;t=((s|0)>-1?s:0-s|0)+r|0;q=q+1|0;if((q|0)==(g|0)){u=t;break}else r=t}}else u=0;f[i+(o<<2)>>2]=u;o=o+1|0}while((o|0)!=(e|0));return}o=(m|0)<(g|0);u=0;do{n=c+(Y(u,d)|0)|0;r=0;q=0;do{p=(h[a+r>>0]|0)-(h[n+r>>0]|0)|0;t=r|1;s=(h[a+t>>0]|0)-(h[n+t>>0]|0)|0;t=r|2;v=(h[a+t>>0]|0)-(h[n+t>>0]|0)|0;t=r|3;w=(h[a+t>>0]|0)-(h[n+t>>0]|0)|0;q=((p|0)>-1?p:0-p|0)+q+((s|0)>-1?s:0-s|0)+((v|0)>-1?v:0-v|0)+((w|0)>-1?w:0-w|0)|0;r=r+4|0}while((r|0)<=(l|0));if(o){r=m;w=q;while(1){v=(h[a+r>>0]|0)-(h[n+r>>0]|0)|0;s=((v|0)>-1?v:0-v|0)+w|0;r=r+1|0;if((r|0)==(g|0)){x=s;break}else w=s}}else x=q;f[i+(u<<2)>>2]=x;u=u+1|0}while((u|0)!=(e|0));return}if(!k)return;k=g+-4|0;u=g&-4;if((g|0)<4){x=(g|0)>0;m=0;do{if(b[j+m>>0]|0){o=c+(Y(m,d)|0)|0;if(x){l=0;w=0;while(1){r=(h[a+l>>0]|0)-(h[o+l>>0]|0)|0;n=((r|0)>-1?r:0-r|0)+w|0;l=l+1|0;if((l|0)==(g|0)){y=n;break}else w=n}}else y=0}else y=2147483647;f[i+(m<<2)>>2]=y;m=m+1|0}while((m|0)!=(e|0));return}m=(u|0)<(g|0);y=0;do{if(b[j+y>>0]|0){x=c+(Y(y,d)|0)|0;w=0;l=0;do{o=(h[a+w>>0]|0)-(h[x+w>>0]|0)|0;q=w|1;n=(h[a+q>>0]|0)-(h[x+q>>0]|0)|0;q=w|2;r=(h[a+q>>0]|0)-(h[x+q>>0]|0)|0;q=w|3;s=(h[a+q>>0]|0)-(h[x+q>>0]|0)|0;l=((o|0)>-1?o:0-o|0)+l+((n|0)>-1?n:0-n|0)+((r|0)>-1?r:0-r|0)+((s|0)>-1?s:0-s|0)|0;w=w+4|0}while((w|0)<=(k|0));if(m){w=u;s=l;while(1){r=(h[a+w>>0]|0)-(h[x+w>>0]|0)|0;n=((r|0)>-1?r:0-r|0)+s|0;w=w+1|0;if((w|0)==(g|0)){z=n;break}else s=n}}else z=l}else z=2147483647;f[i+(y<<2)>>2]=z;y=y+1|0}while((y|0)!=(e|0));return}function W_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;__(a,b,c,d,e,f,g);return}function X_(a,c,d,e,f,g,h){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0;i=d>>>2;d=(e|0)>0;if(!h){if(!d)return;j=f+-4|0;k=f&-4;if((f|0)<4){l=(f|0)>0;m=0;do{o=c+((Y(m,i)|0)<<2)|0;if(l){p=0;q=0.0;while(1){r=+n[a+(p<<2)>>2]-+n[o+(p<<2)>>2];s=q+r*r;p=p+1|0;if((p|0)==(f|0)){t=s;break}else q=s}}else t=0.0;n[g+(m<<2)>>2]=t;m=m+1|0}while((m|0)!=(e|0));return}m=(k|0)<(f|0);l=0;do{p=c+((Y(l,i)|0)<<2)|0;o=0;t=0.0;do{q=+n[a+(o<<2)>>2]-+n[p+(o<<2)>>2];u=o|1;s=+n[a+(u<<2)>>2]-+n[p+(u<<2)>>2];u=o|2;r=+n[a+(u<<2)>>2]-+n[p+(u<<2)>>2];u=o|3;v=+n[a+(u<<2)>>2]-+n[p+(u<<2)>>2];t=t+(q*q+s*s+r*r+v*v);o=o+4|0}while((o|0)<=(j|0));if(m){o=k;v=t;while(1){r=+n[a+(o<<2)>>2]-+n[p+(o<<2)>>2];s=v+r*r;o=o+1|0;if((o|0)==(f|0)){w=s;break}else v=s}}else w=t;n[g+(l<<2)>>2]=w;l=l+1|0}while((l|0)!=(e|0));return}if(!d)return;d=f+-4|0;l=f&-4;if((f|0)<4){k=(f|0)>0;m=0;do{if(b[h+m>>0]|0){j=c+((Y(m,i)|0)<<2)|0;if(k){o=0;w=0.0;while(1){v=+n[a+(o<<2)>>2]-+n[j+(o<<2)>>2];s=w+v*v;o=o+1|0;if((o|0)==(f|0)){x=s;break}else w=s}}else x=0.0}else x=3402823466385288598117041.0e14;n[g+(m<<2)>>2]=x;m=m+1|0}while((m|0)!=(e|0));return}m=(l|0)<(f|0);k=0;do{if(b[h+k>>0]|0){o=c+((Y(k,i)|0)<<2)|0;j=0;x=0.0;do{w=+n[a+(j<<2)>>2]-+n[o+(j<<2)>>2];p=j|1;t=+n[a+(p<<2)>>2]-+n[o+(p<<2)>>2];p=j|2;s=+n[a+(p<<2)>>2]-+n[o+(p<<2)>>2];p=j|3;v=+n[a+(p<<2)>>2]-+n[o+(p<<2)>>2];x=x+(w*w+t*t+s*s+v*v);j=j+4|0}while((j|0)<=(d|0));if(m){j=l;v=x;while(1){s=+n[a+(j<<2)>>2]-+n[o+(j<<2)>>2];t=v+s*s;j=j+1|0;if((j|0)==(f|0)){y=t;break}else v=t}}else y=x}else y=3402823466385288598117041.0e14;n[g+(k<<2)>>2]=y;k=k+1|0}while((k|0)!=(e|0));return}function Y_(a){a=a|0;PYa(a);return}function Z_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;c=u;u=u+1072|0;d=c;e=a+8|0;g=f[e>>2]|0;h=f[g+8>>2]|0;i=d+8|0;f[d>>2]=i;j=d+4|0;f[j>>2]=h;if(h>>>0>264){k=OYa(h>>>0>1073741823?-1:h<<2)|0;f[d>>2]=k;l=k}else l=i;k=f[b>>2]|0;h=b+4|0;if((k|0)<(f[h>>2]|0)){b=a+32|0;m=a+4|0;n=a+24|0;o=a+20|0;p=a+16|0;q=a+12|0;r=a+28|0;a=g;g=k;while(1){k=f[m>>2]|0;s=(f[k+16>>2]|0)+(Y(f[f[k+44>>2]>>2]|0,g)|0)|0;if((f[n>>2]|0)>0)t=l;else{k=f[q>>2]|0;t=(f[k+16>>2]|0)+(Y(f[f[k+44>>2]>>2]|0,g)|0)|0}k=f[o>>2]|0;v=f[k+16>>2]|0;if(!v)w=0;else w=v+(Y(f[f[k+44>>2]>>2]|0,g)|0)|0;Xh[f[b>>2]&127](s,f[a+16>>2]|0,f[a+48>>2]|0,f[a+8>>2]|0,f[a+12>>2]|0,t,w);s=f[n>>2]|0;a:do if((s|0)>0?(k=f[p>>2]|0,v=(f[k+16>>2]|0)+(Y(f[f[k+44>>2]>>2]|0,g)|0)|0,k=f[q>>2]|0,x=(f[k+16>>2]|0)+(Y(f[f[k+44>>2]>>2]|0,g)|0)|0,k=(f[e>>2]|0)+8|0,y=f[k>>2]|0,(y|0)>0):0){z=s;A=y;y=0;while(1){B=f[l+(y<<2)>>2]|0;C=z+-1|0;if((B|0)<(f[x+(C<<2)>>2]|0)){D=z+-2|0;b:do if((D|0)>-1){E=C;F=D;while(1){G=x+(F<<2)|0;if((f[G>>2]|0)<=(B|0)){H=E;break b}f[v+(E<<2)>>2]=f[v+(F<<2)>>2];f[x+(E<<2)>>2]=f[G>>2];if((F|0)>0){G=F;F=F+-1|0;E=G}else{H=F;break}}}else H=C;while(0);f[v+(H<<2)>>2]=(f[r>>2]|0)+y;f[x+(H<<2)>>2]=B;I=f[k>>2]|0}else I=A;C=y+1|0;if((C|0)>=(I|0))break a;z=f[n>>2]|0;A=I;y=C}}while(0);s=g+1|0;if((s|0)>=(f[h>>2]|0))break;a=f[e>>2]|0;g=s}J=f[d>>2]|0}else J=l;if((J|0)==(i|0)){u=c;return}if(J|0)QYa(J);f[d>>2]=i;f[j>>2]=264;u=c;return}function __(a,c,d,e,f,g,h){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0;i=d>>>2;d=(e|0)>0;if(!h){if(!d)return;j=f+-4|0;k=f&-4;if((f|0)<4){l=(f|0)>0;m=0;do{o=c+((Y(m,i)|0)<<2)|0;if(l){p=0;q=0.0;while(1){r=+n[a+(p<<2)>>2]-+n[o+(p<<2)>>2];s=q+r*r;p=p+1|0;if((p|0)==(f|0)){t=s;break}else q=s}}else t=0.0;q=+M(+t);n[g+(m<<2)>>2]=q;m=m+1|0}while((m|0)!=(e|0));return}m=(k|0)<(f|0);l=0;do{p=c+((Y(l,i)|0)<<2)|0;o=0;t=0.0;do{q=+n[a+(o<<2)>>2]-+n[p+(o<<2)>>2];u=o|1;s=+n[a+(u<<2)>>2]-+n[p+(u<<2)>>2];u=o|2;r=+n[a+(u<<2)>>2]-+n[p+(u<<2)>>2];u=o|3;v=+n[a+(u<<2)>>2]-+n[p+(u<<2)>>2];t=t+(q*q+s*s+r*r+v*v);o=o+4|0}while((o|0)<=(j|0));if(m){o=k;v=t;while(1){r=+n[a+(o<<2)>>2]-+n[p+(o<<2)>>2];s=v+r*r;o=o+1|0;if((o|0)==(f|0)){w=s;break}else v=s}}else w=t;v=+M(+w);n[g+(l<<2)>>2]=v;l=l+1|0}while((l|0)!=(e|0));return}if(!d)return;d=f+-4|0;l=f&-4;if((f|0)<4){k=(f|0)>0;m=0;do{if(!(b[h+m>>0]|0))x=3402823466385288598117041.0e14;else{j=c+((Y(m,i)|0)<<2)|0;if(k){o=0;w=0.0;while(1){v=+n[a+(o<<2)>>2]-+n[j+(o<<2)>>2];s=w+v*v;o=o+1|0;if((o|0)==(f|0)){y=s;break}else w=s}}else y=0.0;x=+M(+y)}n[g+(m<<2)>>2]=x;m=m+1|0}while((m|0)!=(e|0));return}m=(l|0)<(f|0);k=0;do{if(!(b[h+k>>0]|0))z=3402823466385288598117041.0e14;else{o=c+((Y(k,i)|0)<<2)|0;j=0;x=0.0;do{y=+n[a+(j<<2)>>2]-+n[o+(j<<2)>>2];p=j|1;w=+n[a+(p<<2)>>2]-+n[o+(p<<2)>>2];p=j|2;t=+n[a+(p<<2)>>2]-+n[o+(p<<2)>>2];p=j|3;s=+n[a+(p<<2)>>2]-+n[o+(p<<2)>>2];x=x+(y*y+w*w+t*t+s*s);j=j+4|0}while((j|0)<=(d|0));if(m){j=l;s=x;while(1){t=+n[a+(j<<2)>>2]-+n[o+(j<<2)>>2];w=s+t*t;j=j+1|0;if((j|0)==(f|0)){A=w;break}else s=w}}else A=x;z=+M(+A)}n[g+(k<<2)>>2]=z;k=k+1|0}while((k|0)!=(e|0));return}function $_(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=d+-4|0;if((d|0)<4){f=0;g=0}else{i=0;j=0;do{k=i|1;l=i|2;m=i|3;j=(h[188234+((b[c+i>>0]^b[a+i>>0])&255)>>0]|0)+j+(h[188234+((b[c+k>>0]^b[a+k>>0])&255)>>0]|0)+(h[188234+((b[c+l>>0]^b[a+l>>0])&255)>>0]|0)+(h[188234+((b[c+m>>0]^b[a+m>>0])&255)>>0]|0)|0;i=i+4|0}while((i|0)<=(e|0));f=d&-4;g=j}if((f|0)<(d|0)){n=f;o=g}else{p=g;return p|0}while(1){g=(h[188234+((b[c+n>>0]^b[a+n>>0])&255)>>0]|0)+o|0;n=n+1|0;if((n|0)==(d|0)){p=g;break}else o=g}return p|0}function a$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;_$(d,43380);e=b+-4|0;if((b|0)<4){g=0;i=0}else{j=0;k=0;do{k=(h[188234+(h[a+j>>0]|0)>>0]|0)+k+(h[188234+(h[a+(j|1)>>0]|0)>>0]|0)+(h[188234+(h[a+(j|2)>>0]|0)>>0]|0)+(h[188234+(h[a+(j|3)>>0]|0)>>0]|0)|0;j=j+4|0}while((j|0)<=(e|0));g=b&-4;i=k}if((g|0)<(b|0)){k=g;g=i;while(1){e=(h[188234+(h[a+k>>0]|0)>>0]|0)+g|0;k=k+1|0;if((k|0)==(b|0)){l=e;break}else g=e}}else l=i;if(!(f[d+4>>2]|0)){u=c;return l|0}u=c;return l|0}function b$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;_$(e,43400);g=$_(a,b,c)|0;if(!(f[e+4>>2]|0)){u=d;return g|0}u=d;return g|0}function c$(a,c){a=a|0;c=c|0;var d=0,e=0;d=YF(c+8&-4)|0;f[d>>2]=1;e=d+4|0;f[a>>2]=e;f[a+4>>2]=c;b[e+c>>0]=0;return f[a>>2]|0}function d$(a){a=a|0;var b=0;b=f[a>>2]|0;f[a+4>>2]=0;f[a>>2]=0;if(!b)return;a=b+-4|0;b=f[a>>2]|0;f[a>>2]=b+-1;if((b|0)!=1)return;ZF(a);return}function e$(a){a=a|0;f[a>>2]=43428;d$(a+32|0);d$(a+24|0);d$(a+16|0);d$(a+4|0);return}function f$(a){a=a|0;e$(a);PYa(a);return}function g$(a){a=a|0;var b=0;b=f[a+4>>2]|0;return ((b|0)==0?5694105:b)|0}function h$(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[a>>2]=43448;if((f[a+4>>2]|0)==-1){u=c;return}f[d>>2]=0;f[d+4>>2]=0;a=c$(d,10)|0;e=190778;g=a+10|0;do{b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}while((a|0)<(g|0));j$(-215,d,190789,190807,1503);d$(d);u=c;return}function i$(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=43448;if((f[a+4>>2]|0)==-1){PYa(a);u=c;return}f[d>>2]=0;f[d+4>>2]=0;e=c$(d,10)|0;g=190778;h=e+10|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));j$(-215,d,190789,190807,1503);d$(d);PYa(a);u=c;return}function j$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+64|0;h=g+16|0;i=g+8|0;j=g;f[i>>2]=0;f[i+4>>2]=0;if(c|0?(g=xKa(c)|0,g|0):0)K1a(c$(i,g)|0,c|0,g|0)|0;f[j>>2]=0;f[j+4>>2]=0;if(d|0?(g=xKa(d)|0,g|0):0)K1a(c$(j,g)|0,d|0,g|0)|0;k$(h,a,b,i,j,e);l$(h)}function k$(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0;f[a>>2]=43428;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=b;b=f[c>>2]|0;f[a+16>>2]=b;f[a+20>>2]=f[c+4>>2];if(b|0){c=b+-4|0;f[c>>2]=(f[c>>2]|0)+1}c=f[d>>2]|0;f[a+24>>2]=c;f[a+28>>2]=f[d+4>>2];if(c|0){d=c+-4|0;f[d>>2]=(f[d>>2]|0)+1}d=f[e>>2]|0;f[a+32>>2]=d;f[a+36>>2]=f[e+4>>2];if(!d){h=a+40|0;f[h>>2]=g;o$(a);return}e=d+-4|0;f[e>>2]=(f[e>>2]|0)+1;h=a+40|0;f[h>>2]=g;o$(a);return}function l$(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+4144|0;d=c+32|0;e=c+8|0;g=c;h=c+40|0;c=f[225802]|0;i=f[a+12>>2]|0;if(!c){do switch(i|0){case 0:{j=191683;break}case -1:{j=191673;break}case -2:{j=191655;break}case -3:{j=191640;break}case -4:{j=191620;break}case -5:{j=191607;break}case -7:{j=191580;break}case -8:{j=191565;break}case -201:{j=191535;break}case -27:{j=191522;break}case -202:{j=191496;break}case -13:{j=191476;break}case -203:{j=191441;break}case -204:{j=191410;break}case -17:{j=191363;break}case -205:{j=191323;break}case -209:{j=191285;break}case -211:{j=191244;break}case -210:{j=191199;break}case -24:{j=191172;break}case -15:{j=191149;break}case -206:{j=191109;break}case -207:{j=191079;break}case -208:{j=191053;break}case -212:{j=191039;break}case -213:{j=190999;break}case -214:{j=190967;break}case -215:{j=190950;break}case -216:{j=190934;break}case -217:{j=190921;break}case -218:{j=190903;break}case -219:{j=190887;break}default:{f[g>>2]=(i|0)>-1?190855:190862;f[g+4>>2]=i;SLa(5689204,190868,g)|0;j=5689204}}while(0);g=f[a+16>>2]|0;if(!(f[a+28>>2]|0))k=191692;else{l=f[a+24>>2]|0;k=(l|0)==0?5694105:l}l=f[a+32>>2]|0;m=f[a+40>>2]|0;f[e>>2]=j;f[e+4>>2]=(g|0)==0?5694105:g;f[e+8>>2]=k;f[e+12>>2]=(l|0)==0?5694105:l;f[e+16>>2]=m;m$(h,4096,191709,e)|0;e=f[30809]|0;f[d>>2]=h;ULa(e,365442,d)|0;IMa(e)|0}else{e=f[a+24>>2]|0;d=f[a+16>>2]|0;h=f[a+32>>2]|0;bg[c&127](i,(e|0)==0?5694105:e,(d|0)==0?5694105:d,(h|0)==0?5694105:h,f[a+40>>2]|0,f[225803]|0)|0}if(!(b[5689460]|0)){n=De(44)|0;n$(n,a);Of(n|0,12472,59)}f[0]=0;aa();n=De(44)|0;n$(n,a);Of(n|0,12472,59)}function m$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=d;d=qLa(a,b,c,g)|0;u=e;return d|0}function n$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=43428;c=f[b+4>>2]|0;f[a+4>>2]=c;f[a+8>>2]=f[b+8>>2];if(c|0){d=c+-4|0;f[d>>2]=(f[d>>2]|0)+1}f[a+12>>2]=f[b+12>>2];d=f[b+16>>2]|0;f[a+16>>2]=d;f[a+20>>2]=f[b+20>>2];if(d|0){c=d+-4|0;f[c>>2]=(f[c>>2]|0)+1}c=f[b+24>>2]|0;f[a+24>>2]=c;f[a+28>>2]=f[b+28>>2];if(c|0){d=c+-4|0;f[d>>2]=(f[d>>2]|0)+1}d=f[b+32>>2]|0;f[a+32>>2]=d;f[a+36>>2]=f[b+36>>2];if(!d){e=a+40|0;g=b+40|0;h=f[g>>2]|0;f[e>>2]=h;return}c=d+-4|0;f[c>>2]=(f[c>>2]|0)+1;e=a+40|0;g=b+40|0;h=f[g>>2]|0;f[e>>2]=h;return}function o$(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=u;u=u+48|0;c=b+24|0;d=b;e=b+40|0;if(!(f[a+28>>2]|0)){g=f[a+32>>2]|0;h=f[a+40>>2]|0;i=f[a+12>>2]|0;j=f[a+16>>2]|0;f[c>>2]=(g|0)==0?5694105:g;f[c+4>>2]=h;f[c+8>>2]=i;f[c+12>>2]=(j|0)==0?5694105:j;p$(e,191793,c);c=a+4|0;if((e|0)!=(c|0)){d$(c);j=f[e>>2]|0;if(!j)k=0;else{i=j+-4|0;f[i>>2]=(f[i>>2]|0)+1;k=f[e>>2]|0}f[c>>2]=k;f[a+8>>2]=f[e+4>>2]}d$(e);u=b;return}else{k=f[a+32>>2]|0;c=f[a+40>>2]|0;i=f[a+12>>2]|0;j=f[a+16>>2]|0;h=f[a+24>>2]|0;f[d>>2]=(k|0)==0?5694105:k;f[d+4>>2]=c;f[d+8>>2]=i;f[d+12>>2]=(j|0)==0?5694105:j;f[d+16>>2]=(h|0)==0?5694105:h;p$(e,191755,d);d=a+4|0;if((e|0)!=(d|0)){d$(d);h=f[e>>2]|0;if(!h)l=0;else{j=h+-4|0;f[j>>2]=(f[j>>2]|0)+1;l=f[e>>2]|0}f[d>>2]=l;f[a+8>>2]=f[e+4>>2]}d$(e);u=b;return}}function p$(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+1056|0;g=e+24|0;h=e+8|0;i=e;j=g+8|0;f[g>>2]=j;k=g+4|0;f[k>>2]=1024;l=i+4|0;while(1){f[h>>2]=d;m=f[k>>2]|0;n=qLa(f[g>>2]|0,m,c,h)|0;if((n|0)<=-1){f[i>>2]=0;f[l>>2]=0;o=c$(i,44)|0;p=191816;q=o+44|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-215,i,191861,190807,809);d$(i)}if((n|0)<(m|0))break;p=n+1|0;o=f[k>>2]|0;if(o>>>0<p>>>0){q=f[g>>2]|0;if(p>>>0>1024)r=OYa(p)|0;else r=j;f[g>>2]=r;f[k>>2]=p;if((o|0)!=0&(r|0)!=(q|0)){b[r>>0]=b[q>>0]|0;if((o|0)!=1){b[r+1>>0]=b[q+1>>0]|0;if((o|0)==2)s=o;else{t=2;do{b[(f[g>>2]|0)+t>>0]=b[q+t>>0]|0;t=t+1|0}while((t|0)!=(o|0));s=o}}else s=1}else s=o;do{b[(f[g>>2]|0)+s>>0]=0;s=s+1|0}while((s|0)!=(p|0));if(!((q|0)==(j|0)|(q|0)==0))QYa(q)}else f[k>>2]=p}b[(f[g>>2]|0)+(m+-1)>>0]=0;m=f[g>>2]|0;f[a>>2]=0;f[a+4>>2]=0;if((n|0)!=0&(m|0)!=0){K1a(c$(a,n)|0,m|0,n|0)|0;v=f[g>>2]|0}else v=m;if((v|0)==(j|0)){u=e;return}if(v|0)QYa(v);f[g>>2]=j;f[k>>2]=1024;u=e;return}function q$(){var a=0;a=r$()|0;f[225801]=a;F1a(5689461,0,255)|0;s$(5689461);F1a(5689717,0,255)|0;return}function r$(){var a=0,b=0,c=0,d=0,e=0;a=u;u=u+16|0;b=a;c=f[226061]|0;if(c|0){d=c;u=a;return d|0}c=NYa(4)|0;e=NYa(32)|0;Kf(b|0)|0;Bd(b|0,1)|0;Tf(e|0,b|0)|0;tf(b|0)|0;f[e+28>>2]=1;f[c>>2]=e;f[226061]=c;d=c;u=a;return d|0}function s$(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;e=c+4|0;if(Me(191892)|0){g=f[30809]|0;if((b[375e3]|0)==0?u1a(375e3)|0:0){f[225804]=0;f[225805]=0;K1a(c$(903216,6515)|0,191911,6515)|0;Fd(952,903216,x|0)|0}h=f[225804]|0;f[d>>2]=(h|0)==0?5694105:h;ULa(g,198427,d)|0}F1a(903224,0,1020)|0;f[225807]=198463;f[225808]=198467;f[225809]=198471;f[225810]=198476;f[225811]=198481;f[225812]=198487;f[225813]=198494;f[225814]=198501;f[225815]=198508;f[225816]=198513;f[225817]=198517;f[225818]=198522;f[225819]=198527;f[225820]=198535;f[225821]=198544;f[225822]=198553;f[225823]=198562;f[225824]=198571;f[225825]=198582;f[225826]=198591;f[225827]=198602;f[225906]=198611;f[226006]=198616;b[a+200>>0]=0;f[e>>2]=0;u$(a,e,1);u=c;return}function t$(a){a=a|0;d$(a);return}function u$(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+48|0;g=e+16|0;h=e+8|0;i=e;j=e+32|0;k=e+24|0;l=Me(198620)|0;if(!l){u=e;return}m=b[l>>0]|0;if(!(m<<24>>24)){u=e;return}n=j+4|0;o=k+4|0;p=f[30809]|0;q=(d|0)>0;r=m;m=l;a:while(1){l=r;s=m;while(1){t=l+-44<<24>>24;if((t&255)>15|((-32765&65535)>>>(t&255)&1)==0){v=l;w=s;break}t=s+1|0;x=b[t>>0]|0;if(!(x<<24>>24)){y=29;break a}else{l=x;s=t}}while(1){t=v+-44<<24>>24;if(!((t&255)>15|((-32765&65535)>>>(t&255)&1)==0)){z=w;break}t=w+1|0;v=b[t>>0]|0;if(!(v<<24>>24)){z=t;break}else w=t}if((z|0)==(s|0)){A=l;B=s}else{f[j>>2]=0;f[n>>2]=0;t=z-s|0;if((t|0)!=0?(K1a(c$(j,t)|0,s|0,t|0)|0,t=f[n>>2]|0,(t|0)!=0):0)C=t;else{f[k>>2]=0;f[o>>2]=0;t=c$(k,18)|0;x=198639;D=t+18|0;do{b[t>>0]=b[x>>0]|0;t=t+1|0;x=x+1|0}while((t|0)<(D|0));j$(-215,k,198658,190807,606);d$(k);C=f[n>>2]|0}x=f[j>>2]|0;t=(x|0)==0?5694105:x;D=0;while(1){E=903224+(D<<2)|0;F=f[E>>2]|0;if(F|0?(xKa(F)|0)==(C|0):0){if((x|0)==(F|0)){y=19;break}if(!(KKa(t,F)|0)){y=19;break}}s=D+1|0;if((s|0)<255)D=s;else{y=27;break}}if((y|0)==19){y=0;b:do if(q){x=0;while(1){if((f[c+(x<<2)>>2]|0)==(D|0))break;x=x+1|0;if((x|0)>=(d|0))break b}f[i>>2]=F;ULa(p,198671,i)|0}while(0);x=a+D|0;if(!(b[x>>0]|0)){s=f[E>>2]|0;f[h>>2]=s|0?s:198848;ULa(p,198864,h)|0}b[x>>0]=0}else if((y|0)==27){y=0;f[g>>2]=t;ULa(p,198946,g)|0}d$(j);A=b[z>>0]|0;B=z}if(!(A<<24>>24)){y=29;break}else{r=A;m=B}}if((y|0)==29){u=e;return}}function v$(a){a=a|0;var b=0;f[a>>2]=43428;b=a+4|0;a=b+40|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(a|0));return}function w$(a){a=a|0;return (b[(f[10866]|0)+a>>0]|0)!=0|0}function x$(){var a=0,b=0,c=0,d=0;if(f[226063]|0){a=f[226063]|0;return a|0}b=r$()|0;E1a(f[b>>2]|0)|0;if(!(f[226063]|0)){c=NYa(8)|0;f[c>>2]=43448;d=I$(z$()|0)|0;f[c+4>>2]=d;f[c>>2]=43476;f[226063]=c}D1a(f[b>>2]|0)|0;a=f[226063]|0;return a|0}function y$(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;e=a+4|0;if((f[e>>2]|0)==-1){f[d>>2]=0;f[d+4>>2]=0;g=c$(d,63)|0;h=199e3;i=g+63|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j$(-215,d,199064,190807,1532);d$(d)}d=z$()|0;h=A$(d,f[e>>2]|0)|0;if(h|0){j=h;u=c;return j|0}h=mi[f[(f[a>>2]|0)+8>>2]&255](a)|0;a=z$()|0;B$(a,f[e>>2]|0,h);j=h;u=c;return j|0}function z$(){var a=0,b=0,c=0;if(f[226062]|0){a=f[226062]|0;return a|0}b=r$()|0;E1a(f[b>>2]|0)|0;if(!(f[226062]|0)){c=NYa(36)|0;F$(c);f[226062]=c}D1a(f[b>>2]|0)|0;a=f[226062]|0;return a|0}function A$(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;if((f[a+8>>2]|0)>>>0<=c>>>0){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,22)|0;h=199072;i=g+22|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j$(-215,e,199064,190807,1425);d$(e)}e=cf(f[a>>2]|0)|0;if(!e){j=0;u=d;return j|0}a=f[e>>2]|0;if((f[e+4>>2]|0)-a>>2>>>0<=c>>>0){j=0;u=d;return j|0}j=f[a+(c<<2)>>2]|0;u=d;return j|0}function B$(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+16|0;g=e+8|0;h=e;if((f[a+8>>2]|0)>>>0<=c>>>0){f[g>>2]=0;f[g+4>>2]=0;i=c$(g,22)|0;j=199072;k=i+22|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-215,g,199095,190807,1457);d$(g)}j=cf(f[a>>2]|0)|0;f[g>>2]=j;if(!j){i=NYa(16)|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;k=NYa(128)|0;l=k;f[i>>2]=l;f[i+4>>2]=l;f[i+8>>2]=k+128;f[g>>2]=i;C$(a,i);k=a+4|0;E1a(f[k>>2]|0)|0;l=a+24|0;m=a+28|0;n=f[m>>2]|0;f[i+12>>2]=n-(f[l>>2]|0)>>2;if((n|0)==(f[a+32>>2]|0))D$(l,g);else{f[n>>2]=i;f[m>>2]=(f[m>>2]|0)+4}D1a(f[k>>2]|0)|0;o=f[g>>2]|0}else o=j;if((f[o+4>>2]|0)-(f[o>>2]|0)>>2>>>0>c>>>0){p=o;q=f[p>>2]|0;r=q+(c<<2)|0;f[r>>2]=d;u=e;return}o=a+4|0;E1a(f[o>>2]|0)|0;a=f[g>>2]|0;j=c+1|0;f[h>>2]=0;k=a+4|0;m=f[k>>2]|0;i=f[a>>2]|0;n=m-i>>2;l=i;i=m;if(j>>>0<=n>>>0){if(j>>>0<n>>>0?(m=l+(j<<2)|0,(i|0)!=(m|0)):0)f[k>>2]=i+(~((i+-4-m|0)>>>2)<<2)}else E$(a,j-n|0,h);D1a(f[o>>2]|0)|0;p=f[g>>2]|0;q=f[p>>2]|0;r=q+(c<<2)|0;f[r>>2]=d;u=e;return}function C$(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;if(!(Lf(f[a>>2]|0,c|0)|0)){u=d;return}f[e>>2]=0;f[e+4>>2]=0;c=c$(e,39)|0;a=199103;g=c+39|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(g|0));j$(-215,e,199143,190807,1313);d$(e);u=d;return}function D$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)gXa(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;PYa(d);return}function E$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>2>>>0>=b>>>0){i=h;j=b;do{f[i>>2]=f[c>>2];i=(f[g>>2]|0)+4|0;f[g>>2]=i;j=j+-1|0}while((j|0)!=0);return}j=f[a>>2]|0;i=h-j>>2;h=i+b|0;if(h>>>0>1073741823)gXa(a);k=e-j|0;j=k>>1;e=k>>2>>>0<536870911?(j>>>0<h>>>0?h:j):1073741823;do if(e)if(e>>>0>1073741823){j=De(8)|0;UYa(j,358155);f[j>>2]=130560;Of(j|0,21520,875)}else{l=NYa(e<<2)|0;break}else l=0;while(0);j=l+(i<<2)|0;i=l+(e<<2)|0;e=j;l=b;b=j;do{f[e>>2]=f[c>>2];e=b+4|0;b=e;l=l+-1|0}while((l|0)!=0);l=f[a>>2]|0;e=(f[g>>2]|0)-l|0;c=j+(0-(e>>2)<<2)|0;if((e|0)>0)K1a(c|0,l|0,e|0)|0;f[a>>2]=c;f[g>>2]=b;f[d>>2]=i;if(!l)return;PYa(l);return}function F$(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;G$(a);d=NYa(32)|0;Kf(c|0)|0;Bd(c|0,1)|0;Tf(d|0,c|0)|0;tf(c|0)|0;f[d+28>>2]=1;f[a+4>>2]=d;d=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;d=NYa(128)|0;c=d;f[a+12>>2]=c;f[a+16>>2]=c;f[a+20>>2]=d+128;d=NYa(128)|0;c=d;f[a+24>>2]=c;f[a+28>>2]=c;f[a+32>>2]=d+128;u=b;return}function G$(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;if(!(Qe(a|0,0)|0)){u=c;return}f[d>>2]=0;f[d+4>>2]=0;a=c$(d,36)|0;e=199199;g=a+36|0;do{b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}while((a|0)<(g|0));j$(-215,d,199236,190807,1301);d$(d);u=c;return}function H$(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;if(!(rd(f[a>>2]|0)|0)){u=c;return}f[d>>2]=0;f[d+4>>2]=0;a=c$(d,31)|0;e=199151;g=a+31|0;do{b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}while((a|0)<(g|0));j$(-215,d,199183,190807,1305);d$(d);u=c;return}function I$(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+16|0;d=c;e=a+4|0;E1a(f[e>>2]|0)|0;g=a+8|0;h=f[g>>2]|0;i=a+12|0;j=a+16|0;if((h|0)==((f[j>>2]|0)-(f[i>>2]|0)>>2|0))k=h;else{f[d>>2]=0;f[d+4>>2]=0;h=c$(d,31)|0;l=199251;m=h+31|0;do{b[h>>0]=b[l>>0]|0;h=h+1|0;l=l+1|0}while((h|0)<(m|0));j$(-215,d,199328,190807,1380);d$(d);k=f[g>>2]|0}a:do if(k|0){l=f[i>>2]|0;h=0;while(1){n=l+(h<<2)|0;if(!(f[n>>2]|0))break;m=h+1|0;if(m>>>0<k>>>0)h=m;else break a}f[n>>2]=1;o=h;p=f[e>>2]|0;D1a(p|0)|0;u=c;return o|0}while(0);f[d>>2]=1;n=f[j>>2]|0;if((n|0)==(f[a+20>>2]|0))VU(i,d);else{f[n>>2]=1;f[j>>2]=n+4}n=f[g>>2]|0;f[g>>2]=n+1;o=n;p=f[e>>2]|0;D1a(p|0)|0;u=c;return o|0}function J$(a){a=a|0;f[a>>2]=43476;N$(a);h$(a);return}function K$(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=43476;N$(a);f[a>>2]=43448;if((f[a+4>>2]|0)==-1){PYa(a);u=c;return}f[d>>2]=0;f[d+4>>2]=0;e=c$(d,10)|0;g=190778;h=e+10|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));j$(-215,d,190789,190807,1503);d$(d);PYa(a);u=c;return}function L$(a){a=a|0;var b=0;a=NYa(32)|0;b=a;f[b>>2]=-1;f[b+4>>2]=0;f[a+8>>2]=0;EU(a+12|0);f[a+16>>2]=-1;f[a+20>>2]=-1;f[a+24>>2]=-1;return a|0}function M$(a,b){a=a|0;b=b|0;if(!b)return;FU(b+12|0);PYa(b);return}function N$(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=u;u=u+16|0;c=b;f[c>>2]=0;d=c+4|0;f[d>>2]=0;f[c+8>>2]=0;e=NYa(128)|0;g=e;f[c>>2]=g;f[d>>2]=g;f[c+8>>2]=e+128;e=z$()|0;g=a+4|0;O$(e,f[g>>2]|0,c,0);f[g>>2]=-1;g=f[d>>2]|0;e=f[c>>2]|0;h=e;if((g|0)==(e|0)){i=g;j=h}else{g=h;h=0;while(1){Gh[f[(f[a>>2]|0)+12>>2]&511](a,f[g+(h<<2)>>2]|0);h=h+1|0;e=f[d>>2]|0;k=f[c>>2]|0;l=k;if(h>>>0>=e-k>>2>>>0){i=e;j=l;break}else g=l}}g=i;if(!j){u=b;return}if((g|0)!=(j|0))f[d>>2]=g+(~((g+-4-j|0)>>>2)<<2);PYa(j);u=b;return}function O$(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+16|0;h=g;i=a+4|0;E1a(f[i>>2]|0)|0;j=a+8|0;k=f[j>>2]|0;l=a+12|0;if((k|0)==((f[a+16>>2]|0)-(f[l>>2]|0)>>2|0))m=k;else{f[h>>2]=0;f[h+4>>2]=0;n=c$(h,31)|0;o=199251;p=n+31|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-215,h,199283,190807,1401);d$(h);m=f[j>>2]|0}if(m>>>0<=c>>>0){f[h>>2]=0;f[h+4>>2]=0;n=c$(h,22)|0;o=199072;p=n+22|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-215,h,199283,190807,1402);d$(h)}h=a+24|0;o=a+28|0;a=f[o>>2]|0;n=f[h>>2]|0;if((a|0)!=(n|0)){p=d+4|0;m=d+8|0;j=a;a=n;n=0;while(1){k=f[a+(n<<2)>>2]|0;if(((k|0)!=0?(q=f[k>>2]|0,(f[k+4>>2]|0)-q>>2>>>0>c>>>0):0)?(r=q+(c<<2)|0,q=f[r>>2]|0,s=q,(q|0)!=0):0){q=f[p>>2]|0;if((q|0)==(f[m>>2]|0))P$(d,r);else{f[q>>2]=s;f[p>>2]=(f[p>>2]|0)+4}f[(f[k>>2]|0)+(c<<2)>>2]=0;t=f[h>>2]|0;v=f[o>>2]|0}else{t=a;v=j}n=n+1|0;if(n>>>0>=v-t>>2>>>0)break;else{j=v;a=t}}}if(e){w=f[i>>2]|0;D1a(w|0)|0;u=g;return}f[(f[l>>2]|0)+(c<<2)>>2]=0;w=f[i>>2]|0;D1a(w|0)|0;u=g;return}function P$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)gXa(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;PYa(d);return}function Q$(){if(b[375e3]|0)return 903216;if(!(u1a(375e3)|0))return 903216;f[225804]=0;f[225805]=0;K1a(c$(903216,6515)|0,191911,6515)|0;Fd(952,903216,x|0)|0;return 903216}function R$(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=0;h=e+4|0;f[h>>2]=0;i=Me(199340)|0;if((i|0)!=0?(b[i>>0]|0)!=0:0){d$(e);j=xKa(i)|0;if(j|0)K1a(c$(e,j)|0,i|0,j|0)|0;j=f[h>>2]|0;switch(b[(f[e>>2]|0)+(j+-1)>>0]|0){case 92:case 47:{k=j;break}default:{f[g>>2]=0;i=g+4|0;f[i>>2]=0;c$(g,j+1|0)|0;j=f[h>>2]|0;if(!j)l=0;else{K1a(f[g>>2]|0,f[e>>2]|0,j|0)|0;l=f[h>>2]|0}b[(f[g>>2]|0)+l>>0]=47;d$(e);l=f[g>>2]|0;if(!l)m=0;else{j=l+-4|0;f[j>>2]=(f[j>>2]|0)+1;m=f[g>>2]|0}f[e>>2]=m;f[h>>2]=f[i>>2];d$(g);k=f[h>>2]|0}}f[g>>2]=0;i=g+4|0;f[i>>2]=0;c$(g,k+20|0)|0;k=f[h>>2]|0;if(!k)n=0;else{K1a(f[g>>2]|0,f[e>>2]|0,k|0)|0;n=f[h>>2]|0}o=(f[g>>2]|0)+n|0;p=199383;q=o+20|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));d$(e);n=f[g>>2]|0;if(!n)r=0;else{k=n+-4|0;f[k>>2]=(f[k>>2]|0)+1;r=f[g>>2]|0}f[e>>2]=r;f[h>>2]=f[i>>2];d$(g)}else{d$(e);o=c$(e,25)|0;p=199357;q=o+25|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0))}p=f[e>>2]|0;o=vKa((p|0)==0?5694105:p)|0;if((o|0)==-1){f[a>>2]=0;f[a+4>>2]=0;d$(e);u=d;return}gLa(o)|0;o=f[e>>2]|0;DMa((o|0)==0?5694105:o)|0;if(!c){o=f[e>>2]|0;f[a>>2]=o;f[a+4>>2]=f[h>>2];if(!o){d$(e);u=d;return}p=o+-4|0;f[p>>2]=(f[p>>2]|0)+1;d$(e);u=d;return}if((b[c>>0]|0)==46){f[a>>2]=0;f[a+4>>2]=0;p=xKa(c)|0;c$(a,(f[h>>2]|0)+p|0)|0;o=f[h>>2]|0;if(o|0)K1a(f[a>>2]|0,f[e>>2]|0,o|0)|0;if(!p){d$(e);u=d;return}K1a((f[a>>2]|0)+(f[h>>2]|0)|0,c|0,p|0)|0;d$(e);u=d;return}f[g>>2]=0;p=g+4|0;f[p>>2]=0;c$(g,(f[h>>2]|0)+1|0)|0;o=f[h>>2]|0;if(!o)s=0;else{K1a(f[g>>2]|0,f[e>>2]|0,o|0)|0;s=f[h>>2]|0}b[(f[g>>2]|0)+s>>0]=46;f[a>>2]=0;f[a+4>>2]=0;s=xKa(c)|0;c$(a,(f[p>>2]|0)+s|0)|0;h=f[p>>2]|0;if(h|0)K1a(f[a>>2]|0,f[g>>2]|0,h|0)|0;if(s|0)K1a((f[a>>2]|0)+(f[p>>2]|0)|0,c|0,s|0)|0;d$(g);d$(e);u=d;return}function S$(){return 0}function T$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+80|0;h=g+24|0;i=g+16|0;j=g+8|0;k=g;f[i>>2]=0;f[i+4>>2]=0;if(c|0?(g=xKa(c)|0,g|0):0)K1a(c$(i,g)|0,c|0,g|0)|0;f[j>>2]=0;f[j+4>>2]=0;if(b|0?(g=xKa(b)|0,g|0):0)K1a(c$(j,g)|0,b|0,g|0)|0;f[k>>2]=0;f[k+4>>2]=0;if(d|0?(g=xKa(d)|0,g|0):0)K1a(c$(k,g)|0,d|0,g|0)|0;k$(h,a,i,j,k,e);l$(h)}function U$(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;d=NYa(32)|0;Kf(c|0)|0;Bd(c|0,1)|0;Tf(d|0,c|0)|0;tf(c|0)|0;f[d+28>>2]=1;f[a>>2]=d;u=b;return}function V$(a){a=a|0;var b=0,c=0;b=(f[a>>2]|0)+28|0;c=f[b>>2]|0;f[b>>2]=c+-1;if((c|0)==1?(c=f[a>>2]|0,c|0):0){Df(c|0)|0;PYa(c)}f[a>>2]=0;return}function W$(a){a=a|0;E1a(f[a>>2]|0)|0;return}function X$(a){a=a|0;D1a(f[a>>2]|0)|0;return}function Y$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+32|0;d=c;e=c+16|0;g=c+8|0;h=Me(a|0)|0;if(!h){i=b;u=c;return i|0}f[e>>2]=0;f[e+4>>2]=0;b=xKa(h)|0;if(b){K1a(c$(e,b)|0,h|0,b|0)|0;b=f[e>>2]|0;if((b|0)==199404)j=1;else{k=b;l=4}}else{k=0;l=4}if((l|0)==4){l=(k|0)==0?5694105:k;if(((!((KKa(l,199404)|0)==0|(k|0)==199406)?!((KKa(l,199406)|0)==0|(k|0)==374219):0)?!((KKa(l,374219)|0)==0|(k|0)==199411):0)?(KKa(l,199411)|0)!=0:0)if(((((k|0)!=199416?!((KKa(l,199416)|0)==0|(k|0)==199418):0)?!((KKa(l,199418)|0)==0|(k|0)==374213):0)?!((KKa(l,374213)|0)==0|(k|0)==199424):0)?(KKa(l,199424)|0)!=0:0){f[d>>2]=a;f[d+4>>2]=l;p$(g,199430,d);Z$(-5,g,199465,1619)}else j=0;else j=1}d$(e);i=j;u=c;return i|0}function Z$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;j$(a,b,c,190807,d);return}function _$(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;return}function $$(a){a=a|0;return}function a0(){U$(904256);U$(904260);U$(904264);U$(904268);U$(904272);U$(904276);U$(904280);U$(904284);U$(904288);U$(904292);U$(904296);U$(904300);U$(904304);U$(904308);U$(904312);U$(904316);U$(904320);U$(904324);U$(904328);U$(904332);U$(904336);U$(904340);U$(904344);U$(904348);U$(904352);U$(904356);U$(904360);U$(904364);U$(904368);U$(904372);U$(904376);Fd(953,0,x|0)|0;return}function b0(a){a=a|0;V$(904376);V$(904372);V$(904368);V$(904364);V$(904360);V$(904356);V$(904352);V$(904348);V$(904344);V$(904340);V$(904336);V$(904332);V$(904328);V$(904324);V$(904320);V$(904316);V$(904312);V$(904308);V$(904304);V$(904300);V$(904296);V$(904292);V$(904288);V$(904284);V$(904280);V$(904276);V$(904272);V$(904268);V$(904264);V$(904260);V$(904256);return}function c0(a,b){a=a|0;b=b|0;f[a+4>>2]=b;f[a>>2]=b;b=a+8|0;a=b+44|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(a|0));return}function d0(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if(f[a+44>>2]|0){f[d>>2]=0;f[d+4>>2]=0;e=c$(d,13)|0;g=200264;h=e+13|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));j$(-215,d,200278,200288,77);d$(d)}d=a+16|0;g=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;d=f[g>>2]|0;if(!d){u=c;return}a=d+8|0;f[a>>2]=(f[a>>2]|0)+-1;e=d+12|0;f[e>>2]=(f[e>>2]|0)+-1;do if(!(f[e>>2]|0)){if(f[d+44>>2]|0){h=f[d+4>>2]|0;if(!h)i=sR()|0;else i=h;Gh[f[(f[i>>2]|0)+24>>2]&511](i,d);if(f[e>>2]|0)break}if(!(f[a>>2]|0)){h=f[d+4>>2]|0;Gh[f[(f[h>>2]|0)+16>>2]&511](h,d)}}while(0);f[g>>2]=0;u=c;return}function e0(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+16|0;i=h;if(c>>>0>=33){f[i>>2]=0;f[i+4>>2]=0;j=c$(i,25)|0;k=200337;l=j+25|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,i,200363,200288,182);d$(i)}m=a+4|0;if((f[m>>2]|0)!=(c|0)){n=a+36|0;o=f[n>>2]|0;p=a+40|0;if((o|0)!=(p|0)){ZF(o);f[n>>2]=p;f[a+32>>2]=a+8}if((c|0)>2){p=YF(c<<3|4)|0;f[n>>2]=p;n=p+(c<<2)+4|0;f[a+32>>2]=n;f[n+-4>>2]=c;f[a+12>>2]=-1;f[a+8>>2]=-1}}f[m>>2]=c;if(!d){u=h;return}n=f[a>>2]|0;p=(n>>>3&511)+1<<(47696>>>(n<<1&14)&3);n=c+-1|0;if((c|0)<=0){u=h;return}o=a+32|0;q=a+36|0;r=i+4|0;s=i+4|0;if(!e){t=n;v=p;while(1){w=f[d+(t<<2)>>2]|0;if((w|0)<=-1){f[i>>2]=0;f[s>>2]=0;x=c$(i,6)|0;b[x>>0]=b[200371]|0;b[x+1>>0]=b[200372]|0;b[x+2>>0]=b[200373]|0;b[x+3>>0]=b[200374]|0;b[x+4>>0]=b[200375]|0;b[x+5>>0]=b[200376]|0;j$(-215,i,200363,200288,209);d$(i)}f[(f[o>>2]|0)+(t<<2)>>2]=w;if(g){f[(f[q>>2]|0)+(t<<2)>>2]=v;x=W1a(w|0,((w|0)<0)<<31>>31|0,v|0,0)|0;if((x|0)==(x|0)&(J|0)==0)y=x;else{f[i>>2]=0;f[r>>2]=0;j=c$(i,51)|0;k=200378;l=j+51|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-211,i,200363,200288,219);d$(i);y=x}}else y=v;if((t|0)>0){t=t+-1|0;v=y}else break}}else{y=n;while(1){v=f[d+(y<<2)>>2]|0;if((v|0)<=-1){f[i>>2]=0;f[s>>2]=0;t=c$(i,6)|0;b[t>>0]=b[200371]|0;b[t+1>>0]=b[200372]|0;b[t+2>>0]=b[200373]|0;b[t+3>>0]=b[200374]|0;b[t+4>>0]=b[200375]|0;b[t+5>>0]=b[200376]|0;j$(-215,i,200363,200288,209);d$(i)}f[(f[o>>2]|0)+(y<<2)>>2]=v;if((y|0)<(n|0))z=f[e+(y<<2)>>2]|0;else z=p;f[(f[q>>2]|0)+(y<<2)>>2]=z;if((y|0)>0)y=y+-1|0;else break}}if((c|0)!=1){u=h;return}f[m>>2]=2;f[a+12>>2]=1;f[(f[a+36>>2]|0)+4>>2]=p;u=h;return}function f0(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0;g=u;u=u+192|0;h=g+136|0;i=g+128|0;j=g+120|0;k=g+64|0;l=g;m=g+48|0;f[h>>2]=1124007936;n=h+4|0;o=h+8|0;p=h+20|0;q=h+24|0;r=h+28|0;s=h+32|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[n+16>>2]=0;f[n+20>>2]=0;f[n+24>>2]=0;f[s>>2]=o;t=h+40|0;v=h+36|0;f[v>>2]=t;f[h+44>>2]=0;f[t>>2]=0;w=c+16|0;x=f[w>>2]|0;a:do if(x){y=c+20|0;do if((x|0)!=(f[y>>2]|0)){f[i>>2]=0;z=i+4|0;f[z>>2]=0;f[j>>2]=0;A=j+4|0;f[A>>2]=0;KR(c,i,j);B=f[c+12>>2]|0;C=f[c+8>>2]|0;if(!(f[A>>2]|f[j>>2])){if((f[w>>2]|0)==(f[y>>2]|0))break;f[i>>2]=0;f[i+4>>2]=0;D=c$(i,17)|0;E=200430;F=D+17|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));j$(-215,i,200448,200288,287);d$(i);break}f[k>>2]=f[c>>2];G=k+4|0;H=c+4|0;I=f[H>>2]|0;f[G>>2]=I;K=k+8|0;f[K>>2]=C;L=k+12|0;f[L>>2]=B;M=k+16|0;f[M>>2]=f[w>>2];f[k+20>>2]=f[y>>2];f[k+24>>2]=f[c+24>>2];f[k+28>>2]=f[c+28>>2];f[k+32>>2]=f[c+32>>2];N=k+36|0;O=f[c+36>>2]|0;f[N>>2]=O;P=k+40|0;f[P>>2]=K;Q=k+48|0;R=k+44|0;f[R>>2]=Q;f[Q>>2]=0;f[k+52>>2]=0;if(!O)S=I;else{I=O+12|0;f[I>>2]=(f[I>>2]|0)+1;S=f[H>>2]|0}if((S|0)<3){H=f[c+44>>2]|0;I=f[R>>2]|0;f[I>>2]=f[H>>2];f[I+4>>2]=f[H+4>>2]}else{f[G>>2]=0;BR(k,c)}H=f[A>>2]|0;I=f[j>>2]|0;LR(k,H,(f[z>>2]|0)-H-(f[K>>2]|0)|0,I,(f[i>>2]|0)-I-(f[L>>2]|0)|0)|0;f0(l,k,d,e);L=f[A>>2]|0;f[m>>2]=f[j>>2];f[m+4>>2]=L;f[m+8>>2]=B;f[m+12>>2]=C;g0(a,l,m);L=l+24|0;I=f[L>>2]|0;if(I|0?(K=I+8|0,I=f[K>>2]|0,f[K>>2]=I+-1,(I|0)==1):0){I=f[L>>2]|0;f[L>>2]=0;K=f[I+4>>2]|0;Gh[f[(f[K>>2]|0)+16>>2]&511](K,I)}I=l+4|0;if((f[I>>2]|0)>0){K=f[l+32>>2]|0;H=0;do{f[K+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[I>>2]|0))}f[L>>2]=0;I=f[l+36>>2]|0;if((I|0)!=(l+40|0))ZF(I);I=f[N>>2]|0;if(I|0?(H=I+12|0,I=f[H>>2]|0,f[H>>2]=I+-1,(I|0)==1):0)CR(k);f[N>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[G>>2]|0)>0){I=f[P>>2]|0;H=0;do{f[I+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[G>>2]|0))}G=f[R>>2]|0;if((G|0)!=(Q|0))ZF(G);break a}while(0);y=d|50331648;G=f[c+32>>2]|0;H=sR()|0;I=(G|0)==0?H:G;G=c+4|0;H=c+40|0;P=c+44|0;M=Oi[f[(f[I>>2]|0)+8>>2]&15](I,f[G>>2]|0,f[H>>2]|0,f[c>>2]&4095,f[w>>2]|0,f[P>>2]|0,y,e)|0;I=sR()|0;if(!(Jg[f[(f[I>>2]|0)+12>>2]&63](I,M,y,e)|0)?(I=sR()|0,!(Jg[f[(f[I>>2]|0)+12>>2]&63](I,M,y,e)|0)):0){f[i>>2]=0;f[i+4>>2]=0;D=c$(i,9)|0;E=200456;F=D+9|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));j$(-215,i,200448,200288,309);d$(i)}y=c+36|0;I=f[y>>2]|0;if(I|0){f[M+48>>2]=I;N=I+12|0;f[N>>2]=(f[N>>2]|0)+1;N=(f[y>>2]|0)+8|0;f[N>>2]=(f[N>>2]|0)+1}f[h>>2]=f[c>>2];e0(h,f[G>>2]|0,f[H>>2]|0,f[P>>2]|0,0);N=f[n>>2]|0;y=f[s>>2]|0;b:do if((N|0)>0){I=0;while(1){if((f[y+(I<<2)>>2]|0)>1){T=I;break b}L=I+1|0;if((L|0)<(N|0))I=L;else{T=L;break}}}else T=0;while(0);P=f[v>>2]|0;H=N;do{G=H;H=H+-1|0;if((H|0)<=(T|0))break;I=Y(f[y+(H<<2)>>2]|0,f[P+(H<<2)>>2]|0)|0}while(I>>>0>=(f[P+(G+-2<<2)>>2]|0)>>>0);G=f[y>>2]|0;I=W1a(G|0,((G|0)<0)<<31>>31|0,f[P>>2]|0,0)|0;G=f[h>>2]|0;Q=(H|0)<=(T|0)&((I|0)==(I|0)&(J|0)==0)?G|16384:G&-16385;f[h>>2]=Q;if((N|0)>2){f[h+12>>2]=-1;f[o>>2]=-1}f[q>>2]=M;f[r>>2]=0;if(!M){U=Q;V=N;W=M;X=0}else{Q=M+8|0;f[Q>>2]=(f[Q>>2]|0)+1;U=f[h>>2]|0;V=f[n>>2]|0;W=f[q>>2]|0;X=f[r>>2]|0}f[a>>2]=U;Q=a+4|0;f[Q>>2]=V;G=a+8|0;f[G>>2]=f[o>>2];f[a+12>>2]=f[h+12>>2];f[a+16>>2]=f[h+16>>2];f[a+20>>2]=f[p>>2];f[a+24>>2]=W;f[a+28>>2]=X;I=a+32|0;f[I>>2]=G;G=a+40|0;R=a+36|0;f[R>>2]=G;f[a+44>>2]=0;f[G>>2]=0;if(!W)Z=V;else{G=W+8|0;f[G>>2]=(f[G>>2]|0)+1;Z=f[n>>2]|0}if((Z|0)<3){G=f[v>>2]|0;L=f[R>>2]|0;f[L>>2]=f[G>>2];f[L+4>>2]=f[G+4>>2];break}f[Q>>2]=0;e0(a,Z,0,0,0);if((f[Q>>2]|0)>0){G=f[s>>2]|0;L=f[I>>2]|0;I=f[v>>2]|0;K=f[R>>2]|0;R=0;do{f[L+(R<<2)>>2]=f[G+(R<<2)>>2];f[K+(R<<2)>>2]=f[I+(R<<2)>>2];R=R+1|0}while((R|0)<(f[Q>>2]|0))}}else{f[a>>2]=1124007936;Q=a+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;f[Q+16>>2]=0;f[Q+20>>2]=0;f[Q+24>>2]=0;f[a+32>>2]=a+8;Q=a+40|0;f[a+36>>2]=Q;f[Q>>2]=0;f[a+44>>2]=0}while(0);a=f[q>>2]|0;if(a|0?(Z=a+8|0,a=f[Z>>2]|0,f[Z>>2]=a+-1,(a|0)==1):0){a=f[q>>2]|0;f[q>>2]=0;Z=f[a+4>>2]|0;Gh[f[(f[Z>>2]|0)+16>>2]&511](Z,a)}if((f[n>>2]|0)>0){a=f[s>>2]|0;s=0;do{f[a+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[n>>2]|0))}f[q>>2]=0;q=f[v>>2]|0;if((q|0)==(t|0)){u=g;return}ZF(q);u=g;return}function g0(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+16|0;g=e;h=f[c>>2]|0;f[a>>2]=h;i=a+4|0;f[i>>2]=2;j=a+8|0;k=d+12|0;f[j>>2]=f[k>>2];l=a+12|0;m=d+8|0;f[l>>2]=f[m>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];n=a+24|0;f[n>>2]=f[c+24>>2];o=a+28|0;p=d+4|0;q=c+36|0;r=(Y(f[f[q>>2]>>2]|0,f[p>>2]|0)|0)+(f[c+28>>2]|0)|0;f[o>>2]=r;s=a+32|0;f[s>>2]=j;t=a+40|0;v=a+36|0;f[v>>2]=t;f[a+44>>2]=0;f[t>>2]=0;if((f[c+4>>2]|0)<3){w=h;x=r}else{f[g>>2]=0;f[g+4>>2]=0;y=c$(g,11)|0;z=200466;A=y+11|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));j$(-215,g,200478,200288,471);d$(g);w=f[a>>2]|0;x=f[o>>2]|0}r=f[m>>2]|0;h=c+12|0;t=f[h>>2]|0;B=f[k>>2]|0;f[a>>2]=((B|0)==1?16384:0)|((r|0)<(t|0)?-16385:-1)&w;C=(w>>>3&511)+1<<(47696>>>(w<<1&14)&3);w=f[d>>2]|0;d=(Y(C,w)|0)+x|0;f[o>>2]=d;if(!((!((w|r|0)<0|(w+r|0)>(t|0))?(t=f[p>>2]|0,(t|B|0)>-1):0)?(t+B|0)<=(f[c+8>>2]|0):0)){f[g>>2]=0;f[g+4>>2]=0;y=c$(g,124)|0;z=200483;A=y+124|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));j$(-215,g,200478,200288,478);d$(g)}g=f[n>>2]|0;if(g|0){z=g+8|0;f[z>>2]=(f[z>>2]|0)+1}if(!((f[m>>2]|0)>=(f[h>>2]|0)?(f[k>>2]|0)>=(f[c+8>>2]|0):0))f[a>>2]=f[a>>2]|32768;a=f[v>>2]|0;f[a>>2]=f[f[q>>2]>>2];f[a+4>>2]=C;if((f[j>>2]|0)>=1?(f[l>>2]|0)>=1:0){u=e;return}C=f[n>>2]|0;if(C|0?(a=C+8|0,C=f[a>>2]|0,f[a>>2]=C+-1,(C|0)==1):0){C=f[n>>2]|0;f[n>>2]=0;a=f[C+4>>2]|0;Gh[f[(f[a>>2]|0)+16>>2]&511](a,C)}if((f[i>>2]|0)>0){C=f[s>>2]|0;s=0;do{f[C+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[i>>2]|0))}f[n>>2]=0;f[l>>2]=0;f[j>>2]=0;u=e;return}function h0(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+144|0;i=h+8|0;j=h;k=a+20|0;f[k>>2]=g;if(!(c>>>0<33&(d|0)!=0)){f[i>>2]=0;f[i+4>>2]=0;g=c$(i,27)|0;l=200608;m=g+27|0;do{b[g>>0]=b[l>>0]|0;g=g+1|0;l=l+1|0}while((g|0)<(m|0));j$(-215,i,357830,200288,337);d$(i)}l=e&4095;e=a+24|0;g=f[e>>2]|0;m=(g|0)==0;do if(!m){n=f[a+4>>2]|0;if((n|0)!=(c|0)?!((c|0)==1&(n|0)<3):0)break;if((l|0)==(f[a>>2]&4095|0)){if((c|0)==2)if((f[a+8>>2]|0)==(f[d>>2]|0)?(f[a+12>>2]|0)==(f[d+4>>2]|0):0){u=h;return}else o=11;else if((c|0)>0)o=11;else p=0;a:do if((o|0)==11){n=f[a+32>>2]|0;q=0;while(1){if((f[n+(q<<2)>>2]|0)!=(f[d+(q<<2)>>2]|0)){p=q;break a}r=q+1|0;if((r|0)<(c|0))q=r;else{p=r;break}}}while(0);if((p|0)==(c|0)){if((c|0)>1){u=h;return}if((f[(f[a+32>>2]|0)+4>>2]|0)==1){u=h;return}}}}while(0);p=a+32|0;if((f[p>>2]|0)==(d|0)){if((c|0)>0)K1a(i|0,d|0,c<<2|0)|0;s=i}else s=d;if(!m?(m=g+8|0,g=f[m>>2]|0,f[m>>2]=g+-1,(g|0)==1):0){g=f[e>>2]|0;f[e>>2]=0;m=f[g+4>>2]|0;Gh[f[(f[m>>2]|0)+16>>2]&511](m,g)}g=a+4|0;if((f[g>>2]|0)>0){m=f[p>>2]|0;d=0;do{f[m+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[g>>2]|0))}f[e>>2]=0;if(c|0){f[a>>2]=l|1124007936;e0(a,c,s,0,1);f[a+28>>2]=0;s=f[g>>2]|0;if((s|0)<3)t=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{c=f[p>>2]|0;d=0;m=1;while(1){i=Y(f[c+(d<<2)>>2]|0,m)|0;d=d+1|0;if((d|0)==(s|0)){t=i;break}else m=i}}if(t){t=f[a+16>>2]|0;m=sR()|0;if(!t){sR()|0;v=m}else v=t;t=a+36|0;m=Oi[f[(f[v>>2]|0)+8>>2]&15](v,f[g>>2]|0,f[p>>2]|0,l,0,f[t>>2]|0,0,f[k>>2]|0)|0;f[e>>2]=m;if(!m){f[j>>2]=0;f[j+4>>2]=0;m=c$(j,6)|0;b[m>>0]=b[200636]|0;b[m+1>>0]=b[200637]|0;b[m+2>>0]=b[200638]|0;b[m+3>>0]=b[200639]|0;b[m+4>>0]=b[200640]|0;b[m+5>>0]=b[200641]|0;j$(-215,j,357830,200288,377);d$(j)}m=f[g>>2]|0;k=f[a>>2]|0;if((f[(f[t>>2]|0)+(m+-1<<2)>>2]|0)==((k>>>3&511)+1<<(47696>>>(k<<1&14)&3)|0))w=m;else{f[j>>2]=0;f[j+4>>2]=0;K1a(c$(j,146)|0,200643,146)|0;j$(-215,j,357830,200288,385);d$(j);w=f[g>>2]|0}}else w=s;s=f[p>>2]|0;b:do if((w|0)>0){p=0;while(1){if((f[s+(p<<2)>>2]|0)>1){x=p;break b}g=p+1|0;if((g|0)<(w|0))p=g;else{x=g;break}}}else x=0;while(0);p=f[a+36>>2]|0;g=w;do{j=g;g=g+-1|0;if((g|0)<=(x|0))break;m=Y(f[s+(g<<2)>>2]|0,f[p+(g<<2)>>2]|0)|0}while(m>>>0>=(f[p+(j+-2<<2)>>2]|0)>>>0);j=f[s>>2]|0;s=W1a(j|0,((j|0)<0)<<31>>31|0,f[p>>2]|0,0)|0;p=f[a>>2]|0;f[a>>2]=(g|0)<=(x|0)&((s|0)==(s|0)&(J|0)==0)?p|16384:p&-16385;if((w|0)>2){f[a+12>>2]=-1;f[a+8>>2]=-1}a=f[e>>2]|0;if(a|0){e=a+8|0;f[e>>2]=(f[e>>2]|0)+1}}u=h;return}function i0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;e0(a,f[b+4>>2]|0,0,0,0);c=a+4|0;if((f[c>>2]|0)<=0)return;d=f[b+32>>2]|0;e=f[a+32>>2]|0;g=f[b+36>>2]|0;b=f[a+36>>2]|0;a=0;do{f[e+(a<<2)>>2]=f[d+(a<<2)>>2];f[b+(a<<2)>>2]=f[g+(a<<2)>>2];a=a+1|0}while((a|0)<(f[c>>2]|0));return}function j0(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+24|0;c=f[b>>2]|0;if(c|0?(d=c+8|0,c=f[d>>2]|0,f[d>>2]=c+-1,(c|0)==1):0){c=f[b>>2]|0;f[b>>2]=0;d=f[c+4>>2]|0;Gh[f[(f[d>>2]|0)+16>>2]&511](d,c)}c=a+4|0;if((f[c>>2]|0)>0){d=f[a+32>>2]|0;e=0;do{f[d+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[c>>2]|0))}f[b>>2]=0;b=f[a+36>>2]|0;if((b|0)==(a+40|0))return;ZF(b);return}function k0(a){a=a|0;var b=0;b=a+24|0;a=f[b>>2]|0;f[b>>2]=0;b=f[a+4>>2]|0;Gh[f[(f[b>>2]|0)+16>>2]&511](b,a);return}function l0(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=u;u=u+1152|0;h=g+48|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+12|0;m=a+24|0;n=a+28|0;o=a+32|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[o>>2]=k;p=a+40|0;q=a+36|0;f[q>>2]=p;f[a+44>>2]=0;f[p>>2]=0;r=c+4|0;s=f[r>>2]|0;if((s|0)>1)t=s;else{f[h>>2]=0;f[h+4>>2]=0;v=c$(h,11)|0;w=200790;x=v+11|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-215,h,200478,200288,426);d$(h);t=f[r>>2]|0}if((t|0)>2){s=h+8|0;F1a(s|0,0,1088)|0;f[h>>2]=s;y=h+4|0;f[y>>2]=t;if(t>>>0>136){z=OYa(t>>>0>536870911?-1:t<<3)|0;F1a(z|0,0,t<<3|0)|0;f[h>>2]=z;A=z}else A=s;z=d;t=f[z+4>>2]|0;B=A;f[B>>2]=f[z>>2];f[B+4>>2]=t;t=f[h>>2]|0;B=e;z=f[B+4>>2]|0;A=t+8|0;f[A>>2]=f[B>>2];f[A+4>>2]=z;if((f[r>>2]|0)>2){z=t;A=2;while(1){B=z+(A<<3)|0;f[B>>2]=-2147483648;f[B+4>>2]=2147483647;A=A+1|0;B=f[h>>2]|0;if((A|0)>=(f[r>>2]|0)){C=B;break}else z=B}}else C=t;m0(i,c,C);n0(a,i)|0;C=i+24|0;t=f[C>>2]|0;if(t|0?(z=t+8|0,t=f[z>>2]|0,f[z>>2]=t+-1,(t|0)==1):0){t=f[C>>2]|0;f[C>>2]=0;z=f[t+4>>2]|0;Gh[f[(f[z>>2]|0)+16>>2]&511](z,t)}t=i+4|0;if((f[t>>2]|0)>0){z=f[i+32>>2]|0;r=0;do{f[z+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[t>>2]|0))}f[C>>2]=0;C=f[i+36>>2]|0;if((C|0)!=(i+40|0))ZF(C);C=f[h>>2]|0;if((C|0)!=(s|0)){if(C|0)QYa(C);f[h>>2]=s;f[y>>2]=136}u=g;return}n0(a,c)|0;y=f[d>>2]|0;s=d+4|0;C=f[s>>2]|0;if((y|0)!=-2147483648|(C|0)!=2147483647?(y|0?1:(C|0)!=(f[k>>2]|0)):0){if(!((y|0)<0|(y|0)>(C|0))?(C|0)<=(f[c+8>>2]|0):0){D=y;E=C}else{f[h>>2]=0;f[h+4>>2]=0;v=c$(h,83)|0;w=200802;x=v+83|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-215,h,200478,200288,441);d$(h);D=f[d>>2]|0;E=f[s>>2]|0}f[k>>2]=E-D;E=Y(D,f[p>>2]|0)|0;f[n>>2]=(f[n>>2]|0)+E;f[a>>2]=f[a>>2]|32768}E=f[e>>2]|0;p=e+4|0;D=f[p>>2]|0;if((E|0)!=-2147483648|(D|0)!=2147483647?(E|0?1:(D|0)!=(f[l>>2]|0)):0){if(!((E|0)<0|(E|0)>(D|0))?(D|0)<=(f[c+12>>2]|0):0){F=E;G=D}else{f[h>>2]=0;f[h+4>>2]=0;v=c$(h,83)|0;w=200886;x=v+83|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-215,h,200478,200288,449);d$(h);F=f[e>>2]|0;G=f[p>>2]|0}p=G-F|0;f[l>>2]=p;G=f[j>>2]|0;if((G|0)>0)H=f[(f[q>>2]|0)+(G+-1<<2)>>2]|0;else H=0;G=Y(H,F)|0;f[n>>2]=(f[n>>2]|0)+G;f[a>>2]=((p|0)<(f[c+12>>2]|0)?-49153:-32769)&f[a>>2]|32768}c=f[k>>2]|0;if((c|0)!=1){if((c|0)>=1)I=38}else{f[a>>2]=f[a>>2]|16384;I=38}if((I|0)==38?(f[l>>2]|0)>=1:0){u=g;return}I=f[m>>2]|0;if(I|0?(a=I+8|0,I=f[a>>2]|0,f[a>>2]=I+-1,(I|0)==1):0){I=f[m>>2]|0;f[m>>2]=0;a=f[I+4>>2]|0;Gh[f[(f[a>>2]|0)+16>>2]&511](a,I)}if((f[j>>2]|0)>0){I=f[o>>2]|0;o=0;do{f[I+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[j>>2]|0))}f[m>>2]=0;f[l>>2]=0;f[k>>2]=0;u=g;return}function m0(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;f[a>>2]=1124007936;h=a+4|0;i=a+28|0;j=a+32|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[j>>2]=a+8;k=a+40|0;l=a+36|0;f[l>>2]=k;f[a+44>>2]=0;f[k>>2]=0;k=f[c+4>>2]|0;if(!d){f[g>>2]=0;f[g+4>>2]=0;m=c$(g,6)|0;b[m>>0]=b[200970]|0;b[m+1>>0]=b[200971]|0;b[m+2>>0]=b[200972]|0;b[m+3>>0]=b[200973]|0;b[m+4>>0]=b[200974]|0;b[m+5>>0]=b[200975]|0;j$(-215,g,200478,200288,499);d$(g)}m=(k|0)>0;if(m){n=c+32|0;o=g+4|0;p=0;do{q=d+(p<<3)|0;r=f[q>>2]|0;s=f[q+4>>2]|0;do if(!((r|0)==-2147483648&(s|0)==2147483647)){if((r|0)>-1&(r|0)<(s|0)?(s|0)<=(f[(f[n>>2]|0)+(p<<2)>>2]|0):0)break;f[g>>2]=0;f[o>>2]=0;q=c$(g,76)|0;t=200977;v=q+76|0;do{b[q>>0]=b[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(v|0));j$(-215,g,200478,200288,503);d$(g)}while(0);p=p+1|0}while((p|0)<(k|0));n0(a,c)|0;if(m){m=0;do{p=d+(m<<3)|0;g=f[p>>2]|0;o=f[p+4>>2]|0;if((g|0)!=-2147483648|(o|0)!=2147483647?(p=(f[j>>2]|0)+(m<<2)|0,g|0?1:(o|0)!=(f[p>>2]|0)):0){f[p>>2]=o-g;o=Y(f[(f[l>>2]|0)+(m<<2)>>2]|0,g)|0;f[i>>2]=(f[i>>2]|0)+o;f[a>>2]=f[a>>2]|32768}m=m+1|0}while((m|0)!=(k|0))}}else n0(a,c)|0;c=f[h>>2]|0;h=f[j>>2]|0;a:do if((c|0)>0){j=0;while(1){if((f[h+(j<<2)>>2]|0)>1){w=j;break a}k=j+1|0;if((k|0)<(c|0))j=k;else{w=k;break}}}else w=0;while(0);j=f[l>>2]|0;l=c;while(1){c=l;l=l+-1|0;if((l|0)<=(w|0)){x=22;break}k=Y(f[h+(l<<2)>>2]|0,f[j+(l<<2)>>2]|0)|0;if(k>>>0<(f[j+(c+-2<<2)>>2]|0)>>>0){x=22;break}}if((x|0)==22){x=f[h>>2]|0;h=W1a(x|0,((x|0)<0)<<31>>31|0,f[j>>2]|0,0)|0;j=f[a>>2]|0;f[a>>2]=(l|0)<=(w|0)&((h|0)==(h|0)&(J|0)==0)?j|16384:j&-16385;u=e;return}}function n0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;if((a|0)==(b|0))return a|0;c=b+24|0;d=f[c>>2]|0;if(d|0){e=d+8|0;f[e>>2]=(f[e>>2]|0)+1}e=a+24|0;d=f[e>>2]|0;if(d|0?(g=d+8|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0){d=f[e>>2]|0;f[e>>2]=0;g=f[d+4>>2]|0;Gh[f[(f[g>>2]|0)+16>>2]&511](g,d)}d=a+4|0;if((f[d>>2]|0)>0){g=f[a+32>>2]|0;h=0;do{f[g+(h<<2)>>2]=0;h=h+1|0;i=f[d>>2]|0}while((h|0)<(i|0));f[e>>2]=0;f[a>>2]=f[b>>2];if((i|0)<3)j=13;else{k=f[b+4>>2]|0;j=15}}else{f[e>>2]=0;f[a>>2]=f[b>>2];j=13}if((j|0)==13){i=f[b+4>>2]|0;if((i|0)<3){f[d>>2]=i;f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];h=f[b+36>>2]|0;g=f[a+36>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{k=i;j=15}}if((j|0)==15?(e0(a,k,0,0,0),(f[d>>2]|0)>0):0){k=f[b+32>>2]|0;j=f[a+32>>2]|0;i=f[b+36>>2]|0;h=f[a+36>>2]|0;g=0;do{f[j+(g<<2)>>2]=f[k+(g<<2)>>2];f[h+(g<<2)>>2]=f[i+(g<<2)>>2];g=g+1|0}while((g|0)<(f[d>>2]|0))}f[a+16>>2]=f[b+16>>2];d=a+20|0;if(!(f[d>>2]|0))f[d>>2]=f[b+20>>2];f[e>>2]=f[c>>2];f[a+28>>2]=f[b+28>>2];return a|0}function o0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+64|0;e=d+56|0;g=d;_$(e,45068);h=XS(c)|0;r0(g,a,h?33554432:50331648);hL(g,b,c)|0;c=g+36|0;b=f[c>>2]|0;if(b|0?(h=b+12|0,b=f[h>>2]|0,f[h>>2]=b+-1,(b|0)==1):0)CR(g);f[c>>2]=0;c=g+16|0;b=g+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[g+40>>2]|0;h=0;do{f[c+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[b>>2]|0))}b=f[g+44>>2]|0;if((b|0)!=(g+48|0))ZF(b);if(!(f[e+4>>2]|0)){u=d;return a|0}u=d;return a|0}function p0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=u;u=u+464|0;e=d+448|0;g=d+320|0;h=d+192|0;i=d+64|0;j=d+8|0;k=d;_$(e,45028);l=RR(c,-1)|0;if(aT(c)|0?(m=f[a>>2]|0,(l|0)!=(m&4095|0)):0){if((m^l)&4088|0){f[g>>2]=0;f[g+4>>2]=0;n=c$(g,55)|0;m=201054;o=n+55|0;do{b[n>>0]=b[m>>0]|0;n=n+1|0;m=m+1|0}while((n|0)<(o|0));j$(-215,g,201110,200288,820);d$(g)}q0(a,c,l,1.0,0.0)}else p=6;do if((p|0)==6){l=a+24|0;if(f[l>>2]|0){m=a+4|0;q=f[m>>2]|0;if((q|0)<3)r=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{s=f[a+32>>2]|0;t=0;v=1;while(1){w=Y(f[s+(t<<2)>>2]|0,v)|0;t=t+1|0;if((t|0)==(q|0)){r=w;break}else v=w}}if(!((q|0)==0|(r|0)==0)){n=g;o=n+128|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));v=(q|0)>0;if(v)x=f[(f[a+36>>2]|0)+(q+-1<<2)>>2]|0;else x=0;t=f[a+32>>2]|0;s=0;do{f[g+(s<<2)>>2]=f[t+(s<<2)>>2];s=s+1|0}while(s>>>0<q>>>0);s=q+-1|0;t=g+(s<<2)|0;w=Y(f[t>>2]|0,x)|0;f[t>>2]=w;if(v){w=f[a+36>>2]|0;t=0;y=f[a+28>>2]|0;do{z=f[w+(t<<2)>>2]|0;A=(y>>>0)/(z>>>0)|0;f[h+(t<<2)>>2]=A;y=y-(Y(A,z)|0)|0;t=t+1|0}while((t|0)<(q|0))}t=h+(s<<2)|0;y=Y(f[t>>2]|0,x)|0;f[t>>2]=y;MR(c,q,f[a+32>>2]|0,f[a>>2]&4095,-1,0,0);if((NS(c)|0)==655360){OS(j,c,-1);y=j+24|0;t=f[y>>2]|0;if(!t){f[k>>2]=0;f[k+4>>2]=0;w=c$(k,5)|0;b[w>>0]=b[201117]|0;b[w+1>>0]=b[201118]|0;b[w+2>>0]=b[201119]|0;b[w+3>>0]=b[201120]|0;b[w+4>>0]=b[201121]|0;j$(-215,k,201110,200288,842);d$(k);B=f[y>>2]|0}else B=t;t=f[l>>2]|0;if((t|0)==(B|0)?(f[j+28>>2]|0)==(f[a+28>>2]|0):0){C=B;p=31}else{w=f[t+4>>2]|0;if((w|0)==(f[B+4>>2]|0)){v=f[j+4>>2]|0;if((v|0)>0){z=f[j+36>>2]|0;A=0;D=f[j+28>>2]|0;do{E=f[z+(A<<2)>>2]|0;F=(D>>>0)/(E>>>0)|0;f[i+(A<<2)>>2]=F;D=D-(Y(F,E)|0)|0;A=A+1|0}while((A|0)<(v|0));G=z}else G=f[j+36>>2]|0;z=f[m>>2]|0;v=i+(z+-1<<2)|0;A=Y(f[v>>2]|0,x)|0;f[v>>2]=A;kh[f[(f[w>>2]|0)+36>>2]&7](w,t,B,z,g,h,f[a+36>>2]|0,i,G,0);C=f[y>>2]|0;p=31}else{H=B;I=0;p=32}}if((p|0)==31)if(!C)J=1;else{H=C;I=1;p=32}if((p|0)==32){z=H+8|0;A=f[z>>2]|0;f[z>>2]=A+-1;if((A|0)==1){A=f[y>>2]|0;f[y>>2]=0;z=f[A+4>>2]|0;Gh[f[(f[z>>2]|0)+16>>2]&511](z,A);J=I}else J=I}A=j+4|0;if((f[A>>2]|0)>0){z=f[j+32>>2]|0;v=0;do{f[z+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[A>>2]|0))}f[y>>2]=0;A=f[j+36>>2]|0;if((A|0)!=(j+40|0))ZF(A);if(!J)p=40}else p=40;if((p|0)==40){do if((NS(c)|0)==65536){A=f[c+4>>2]|0;f[j>>2]=f[A>>2];v=j+4|0;z=A+4|0;f[v>>2]=f[z>>2];t=j+8|0;f[t>>2]=f[A+8>>2];f[j+12>>2]=f[A+12>>2];w=j+16|0;f[w>>2]=f[A+16>>2];f[j+20>>2]=f[A+20>>2];f[j+24>>2]=f[A+24>>2];f[j+28>>2]=f[A+28>>2];f[j+32>>2]=f[A+32>>2];D=f[A+36>>2]|0;f[j+36>>2]=D;f[j+40>>2]=t;t=j+48|0;q=j+44|0;f[q>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(D|0){t=D+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[z>>2]|0)<3){z=f[A+44>>2]|0;t=f[q>>2]|0;f[t>>2]=f[z>>2];f[t+4>>2]=f[z+4>>2];K=w;L=q;break}else{f[v>>2]=0;BR(j,A);K=w;L=q;break}}else{OR(j,c,-1);K=j+16|0;L=j+44|0}while(0);y=f[l>>2]|0;q=f[y+4>>2]|0;Oh[f[(f[q>>2]|0)+28>>2]&255](q,y,f[K>>2]|0,f[m>>2]|0,g,h,f[a+36>>2]|0,f[L>>2]|0);y=j+36|0;q=f[y>>2]|0;if(q|0?(w=q+12|0,q=f[w>>2]|0,f[w>>2]=q+-1,(q|0)==1):0)CR(j);f[y>>2]=0;y=j+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[y>>2]|0)>0){q=f[j+40>>2]|0;w=0;do{f[q+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[y>>2]|0))}y=f[L>>2]|0;if((y|0)!=(j+48|0))ZF(y)}break}}oS(c)}while(0);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function q0(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+112|0;h=g+104|0;i=g+56|0;j=g;_$(h,45048);if(+L(+(d+-1.0))<2.220446049250313e-16)k=+L(+e)<2.220446049250313e-16;else k=0;l=f[a>>2]|0;m=l&4095;if((c|0)<0)if(aT(b)|0)n=RR(b,-1)|0;else n=m;else n=l&4088|c&7;if(((n^l)&7|0)!=0|k^1){f[i>>2]=f[a>>2];k=i+4|0;l=a+4|0;c=f[l>>2]|0;f[k>>2]=c;m=i+8|0;f[m>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];o=i+24|0;p=f[a+24>>2]|0;f[o>>2]=p;f[i+28>>2]=f[a+28>>2];q=i+32|0;f[q>>2]=m;m=i+40|0;r=i+36|0;f[r>>2]=m;f[i+44>>2]=0;f[m>>2]=0;if(!p)s=c;else{c=p+8|0;f[c>>2]=(f[c>>2]|0)+1;s=f[l>>2]|0}if((s|0)>=3){f[k>>2]=0;e0(i,s,0,0,0);if((f[k>>2]|0)>0){s=f[a+32>>2]|0;i=f[q>>2]|0;l=f[a+36>>2]|0;c=f[r>>2]|0;p=0;do{f[i+(p<<2)>>2]=f[s+(p<<2)>>2];f[c+(p<<2)>>2]=f[l+(p<<2)>>2];p=p+1|0}while((p|0)<(f[k>>2]|0))}}else{p=f[a+36>>2]|0;l=f[r>>2]|0;f[l>>2]=f[p>>2];f[l+4>>2]=f[p+4>>2]}r0(j,a,16777216);WJ(j,b,n,d,e);n=j+36|0;p=f[n>>2]|0;if(p|0?(l=p+12|0,p=f[l>>2]|0,f[l>>2]=p+-1,(p|0)==1):0)CR(j);f[n>>2]=0;n=j+16|0;p=j+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[p>>2]|0)>0){n=f[j+40>>2]|0;l=0;do{f[n+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[p>>2]|0))}p=f[j+44>>2]|0;if((p|0)!=(j+48|0))ZF(p);p=f[o>>2]|0;if(p|0?(j=p+8|0,p=f[j>>2]|0,f[j>>2]=p+-1,(p|0)==1):0){p=f[o>>2]|0;f[o>>2]=0;j=f[p+4>>2]|0;Gh[f[(f[j>>2]|0)+16>>2]&511](j,p)}if((f[k>>2]|0)>0){p=f[q>>2]|0;q=0;do{f[p+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[k>>2]|0))}f[o>>2]=0;o=f[r>>2]|0;if((o|0)!=(m|0))ZF(o)}else p0(a,b);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function r0(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=c+24|0;i=f[h>>2]|0;if(!i){f[a>>2]=1124007936;j=a+8|0;k=a+40|0;l=a+4|0;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=a+48|0;f[a+44>>2]=j;f[j>>2]=0;f[a+52>>2]=0;u=e;return}j=904256+(((i>>>0)%31|0)<<2)|0;W$(j);i=(f[h>>2]|0)+12|0;k=f[i>>2]|0;f[i>>2]=k+1;if(!k){k=f[h>>2]|0;i=f[k+4>>2]|0;fi[f[(f[i>>2]|0)+20>>2]&255](i,k,d|50331648)}d=f[h>>2]|0;k=f[d+16>>2]|0;if(!k){i=d+12|0;f[i>>2]=(f[i>>2]|0)+-1;if(!(f[(f[h>>2]|0)+16>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;l=c$(g,55)|0;i=201123;m=l+55|0;do{b[l>>0]=b[i>>0]|0;l=l+1|0;i=i+1|0}while((l|0)<(m|0));j$(-215,g,201179,200288,778);d$(g)}f[a>>2]=1124007936;g=a+8|0;i=a+40|0;l=a+4|0;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[i>>2]=g;g=a+48|0;f[a+44>>2]=g;f[g>>2]=0;f[a+52>>2]=0}else{g=c+28|0;GR(a,f[c+4>>2]|0,f[c+32>>2]|0,f[c>>2]&4095,k+(f[g>>2]|0)|0,f[c+36>>2]|0);f[a>>2]=f[c>>2];c=f[h>>2]|0;f[a+36>>2]=c;h=f[c+16>>2]|0;f[a+20>>2]=h;f[a+16>>2]=h+(f[g>>2]|0);g=h+(f[c+24>>2]|0)|0;f[a+24>>2]=g;f[a+28>>2]=g}X$(j);u=e;return}function s0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+4|0;if((f[c>>2]|0)<=0)return;d=f[a+36>>2]|0;e=0;g=f[a+28>>2]|0;do{a=f[d+(e<<2)>>2]|0;h=(g>>>0)/(a>>>0)|0;f[b+(e<<2)>>2]=h;g=g-(Y(h,a)|0)|0;e=e+1|0}while((e|0)<(f[c>>2]|0));return}function t0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=u0(a,b,c)|0;v0(d);return d|0}function u0(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;h=d&4095;if((c|a|0)<0){f[g>>2]=0;f[g+4>>2]=0;i=c$(g,28)|0;j=201518;k=i+28|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-201,g,201547,201342,119);d$(g)}l=(d>>>3&511)+1<<(47696>>>(d<<1&14)&3);if((l|0)<1){f[g>>2]=0;f[g+4>>2]=0;i=c$(g,19)|0;j=201565;k=i+19|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-210,g,201547,201342,123);d$(g)}g=Y(l,c)|0;l=_F(28)|0;f[l+4>>2]=g;f[l>>2]=h|1111638016;f[l+20>>2]=a;f[l+24>>2]=c;f[l+16>>2]=0;f[l+8>>2]=0;f[l+12>>2]=1;c=W1a(a|0,((a|0)<0)<<31>>31|0,g|0,((g|0)<0)<<31>>31|0)|0;g=J;if(!((g|0)>0|(g|0)==0&c>>>0>2147483647)){u=e;return l|0}f[l>>2]=h|1111621632;u=e;return l|0}function v0(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;c=u;u=u+16|0;d=c;do if(a|0){e=f[a>>2]|0;g=e&-65536;if(((g|0)==1111621632?(h=a+24|0,i=f[h>>2]|0,(i|0)>-1):0)?(j=a+20|0,k=f[j>>2]|0,(k|0)>-1):0){l=f[a+4>>2]|0;if((i|0)==0|(k|0)==0){u=c;return}k=a+16|0;if(f[k>>2]|0){f[d>>2]=0;f[d+4>>2]=0;m=c$(d,25)|0;n=201389;o=m+25|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-2,d,201415,201342,806);d$(d)}if(!l){i=f[a>>2]|0;p=Y((i>>>3&511)+1<<(47696>>>(i<<1&14)&3),f[h>>2]|0)|0}else p=l;i=f[j>>2]|0;q=W1a(i|0,((i|0)<0)<<31>>31|0,p|0,0)|0;i=C1a(q|0,J|0,68,0)|0;if(!((i|0)==(i|0)&(J|0)==0)){f[d>>2]=0;f[d+4>>2]=0;m=c$(d,27)|0;n=201428;o=m+27|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-4,d,201415,201342,814);d$(d)}j=_F(i)|0;f[a+8>>2]=j;f[k>>2]=j+4+63&-64;f[j>>2]=1;u=c;return}if((e|0)==112){j=a+68|0;if(f[j>>2]|0){f[d>>2]=0;f[d+4>>2]=0;m=c$(d,25)|0;n=201389;o=m+25|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-2,d,201415,201342,824);d$(d)}k=f[226099]|0;if(!k){i=f[a+72>>2]|0;l=f[a+44>>2]|0;h=W1a(l|0,((l|0)<0)<<31>>31|0,i|0,((i|0)<0)<<31>>31|0)|0;i=a+64|0;l=f[i>>2]|0;if((l|0)==(h|0)&(((l|0)<0)<<31>>31|0)==(J|0))r=l;else{f[d>>2]=0;f[d+4>>2]=0;m=c$(d,22)|0;n=201456;o=m+22|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-4,d,201415,201342,830);d$(d);r=f[i>>2]|0}l=_F(r)|0;f[a+108>>2]=l;f[j>>2]=l;u=c;return}else{l=a+16|0;h=f[l>>2]|0;q=a+40|0;s=f[q>>2]|0;switch(h|0){case 32:case 64:{t=Y((h|0)==32?4:8,s)|0;f[q>>2]=t;f[l>>2]=8;break}default:{}}fi[k&255](a,0,0);f[q>>2]=s;f[l>>2]=h;u=c;return}}else{if((g|0)!=1111687168)break;h=(e>>>3&511)+1<<(47696>>>(e<<1&14)&3);l=a+20|0;if(!(f[l>>2]|0)){u=c;return}s=a+16|0;if(!(f[s>>2]|0))v=e;else{f[d>>2]=0;f[d+4>>2]=0;m=c$(d,25)|0;n=201389;o=m+25|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-2,d,201415,201342,860);d$(d);v=f[a>>2]|0}if(!(v&16384)){e=f[a+4>>2]|0;if((e|0)>0){g=e;e=h;while(1){k=g;g=g+-1|0;j=Y(f[l+(g<<3)>>2]|0,f[l+(g<<3)+4>>2]|0)|0;i=e>>>0<j>>>0?j:e;if((k|0)<=1){w=i;break}else e=i}}else w=h}else{e=f[a+24>>2]|0;w=Y((e|0)==0?h:e,f[l>>2]|0)|0}e=_F(w+68|0)|0;f[a+8>>2]=e;f[s>>2]=e+4+63&-64;f[e>>2]=1;u=c;return}}while(0);f[d>>2]=0;f[d+4>>2]=0;m=c$(d,38)|0;n=201479;o=m+38|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-5,d,201415,201342,885);d$(d);u=c;return}function w0(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+16|0;j=i;if(!a){f[j>>2]=0;f[j+4>>2]=0;j$(-27,j,201585,201342,147);d$(j)}if((d|c|0)<0){f[j>>2]=0;f[j+4>>2]=0;k=c$(j,25)|0;l=201601;m=k+25|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-201,j,201585,201342,153);d$(j)}l=e&4095|1111621632;f[a>>2]=l;k=a+20|0;f[k>>2]=c;f[a+24>>2]=d;f[a+16>>2]=g;f[a+8>>2]=0;f[a+12>>2]=0;g=Y((e>>>3&511)+1<<(47696>>>(e<<1&14)&3),d)|0;if((h|0)<2147483647)switch(h|0){case 0:{n=g;o=c;break}default:p=6}else switch(h|0){case 2147483647:{n=g;o=c;break}default:p=6}if((p|0)==6)if((g|0)>(h|0)){f[j>>2]=0;f[j+4>>2]=0;j$(-13,j,201585,201342,169);d$(j);n=h;o=f[k>>2]|0}else{n=h;o=c}f[a+4>>2]=n;c=W1a(o|0,((o|0)<0)<<31>>31|0,n|0,((n|0)<0)<<31>>31|0)|0;h=J;f[a>>2]=l|((h|0)>0|(h|0)==0&c>>>0>2147483647?0:(n|0)==(g|0)|(o|0)==1?16384:0);u=i;return a|0}function x0(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;j$(-9,c,201627,201342,190);d$(c)}d=f[a>>2]|0;if(!d){u=b;return}e=f[d>>2]&-65536;a:do if((e|0)<1111687168){switch(e|0){case 1111621632:break;default:{g=7;break a}}if(!((f[d+24>>2]|0)>-1?(f[d+20>>2]|0)>-1:0))g=7}else switch(e|0){case 1111687168:break;default:g=7}while(0);if((g|0)==7){f[c>>2]=0;f[c+4>>2]=0;j$(-206,c,201627,201342,197);d$(c)}f[a>>2]=0;a=f[d>>2]&-65536;b:do if((a|0)<1111687168){switch(a|0){case 1111621632:break;default:break b}if(((f[d+24>>2]|0)>0?(f[d+20>>2]|0)>0:0)?(c=d+16|0,f[c>>2]|0):0){f[c>>2]=0;c=d+8|0;g=f[c>>2]|0;if(g|0?(e=(f[g>>2]|0)+-1|0,f[g>>2]=e,(e|0)==0):0){$F(g);f[c>>2]=0}f[c>>2]=0}}else{switch(a|0){case 1111687168:break;default:break b}c=d+16|0;if(f[c>>2]|0){f[c>>2]=0;c=d+8|0;g=f[c>>2]|0;if(g|0?(e=(f[g>>2]|0)+-1|0,f[g>>2]=e,(e|0)==0):0){$F(g);f[c>>2]=0}f[c>>2]=0}}while(0);$F(d);u=b;return}function y0(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c;if((((a|0)!=0?(e=f[a>>2]|0,(e&-65536|0)==1111621632):0)?(g=f[a+24>>2]|0,(g|0)>0):0)?(h=f[a+20>>2]|0,(h|0)>0):0){i=h;j=g;k=e}else{f[d>>2]=0;f[d+4>>2]=0;e=c$(d,16)|0;g=201640;h=e+16|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));j$(-5,d,201657,201342,212);d$(d);i=f[a+20>>2]|0;j=f[a+24>>2]|0;k=f[a>>2]|0}d=u0(i,j,k)|0;if(!(f[a+16>>2]|0)){u=c;return d|0}v0(d);nL(a,d,0);u=c;return d|0}function z0(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0;h=u;u=u+16|0;i=h;j=e&4095;k=(e>>>3&511)+1<<(47696>>>(e<<1&14)&3);if(!a){f[i>>2]=0;f[i+4>>2]=0;l=c$(i,26)|0;m=201668;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-27,i,201695,201342,238);d$(i)}if(!k){f[i>>2]=0;f[i+4>>2]=0;l=c$(i,23)|0;m=201713;n=l+23|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-210,i,201695,201342,241);d$(i)}if(!d){f[i>>2]=0;f[i+4>>2]=0;l=c$(i,20)|0;m=201737;n=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-27,i,201695,201342,244);d$(i)}if((c+-1|0)>>>0>31){f[i>>2]=0;f[i+4>>2]=0;l=c$(i,46)|0;m=201758;n=l+46|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-211,i,201695,201342,248);d$(i);if((c|0)<=0){o=0;p=k;q=(o|0)<0;r=p>>>0<2147483648;s=(o|0)==0;t=s&r;v=q|t;w=v?1111703552:1111687168;x=w|j;f[a>>2]=x;y=a+4|0;f[y>>2]=c;z=a+16|0;f[z>>2]=g;A=a+8|0;f[A>>2]=0;B=a+12|0;f[B>>2]=0;u=h;return a|0}}e=i+4|0;C=i+4|0;D=0;E=k;k=c;while(1){F=k;k=k+-1|0;G=d+(k<<2)|0;H=f[G>>2]|0;if((H|0)<0){f[i>>2]=0;f[e>>2]=0;l=c$(i,37)|0;m=201805;n=l+37|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-201,i,201695,201342,253);d$(i);I=f[G>>2]|0}else I=H;f[a+20+(k<<3)>>2]=I;if((D|0)>0|(D|0)==0&E>>>0>2147483647){f[i>>2]=0;f[C>>2]=0;l=c$(i,20)|0;m=201843;n=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-211,i,201695,201342,256);d$(i)}f[a+20+(k<<3)+4>>2]=E;H=f[G>>2]|0;K=W1a(H|0,((H|0)<0)<<31>>31|0,E|0,D|0)|0;H=J;if((F|0)<=1){o=H;p=K;break}else{D=H;E=K}}q=(o|0)<0;r=p>>>0<2147483648;s=(o|0)==0;t=s&r;v=q|t;w=v?1111703552:1111687168;x=w|j;f[a>>2]=x;y=a+4|0;f[y>>2]=c;z=a+16|0;f[z>>2]=g;A=a+8|0;f[A>>2]=0;B=a+12|0;f[B>>2]=0;u=h;return a|0}function A0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=B0(a,b,c)|0;v0(d);return d|0}function B0(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;if((a+-1|0)>>>0>31){f[g>>2]=0;f[g+4>>2]=0;h=c$(g,46)|0;i=201758;j=h+46|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-211,g,201864,201342,287);d$(g)}g=_F(276)|0;z0(g,a,c,d,0)|0;f[g+12>>2]=1;u=e;return g|0}function C0(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+256|0;d=c+128|0;e=c+72|0;g=c+16|0;h=c;if(!((a|0)!=0?(f[a>>2]&-65536|0)==1111687168:0)){f[d>>2]=0;f[d+4>>2]=0;i=c$(d,18)|0;j=201884;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-5,d,201903,201342,302);d$(d)}l=a+4|0;m=f[l>>2]|0;if((m|0)<33)n=m;else{f[d>>2]=0;f[d+4>>2]=0;i=c$(d,15)|0;j=201916;k=i+15|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-215,d,201903,201342,304);d$(d);n=f[l>>2]|0}if((n|0)>0){l=0;do{f[d+(l<<2)>>2]=f[a+20+(l<<3)>>2];l=l+1|0}while((l|0)<(n|0))}l=B0(n,d,f[a>>2]|0)|0;if(!(f[a+16>>2]|0)){u=c;return l|0}v0(l);JR(e,a,0,1,0,0);JR(g,l,0,1,0,0);a=f[l+16>>2]|0;d=h+8|0;f[d>>2]=0;f[d+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=g;eL(e,h);d=g+16|0;if((f[d>>2]|0)!=(a|0)){f[h>>2]=0;f[h+4>>2]=0;i=c$(h,18)|0;j=201932;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-215,h,201903,201342,319);d$(h)}h=g+36|0;j=f[h>>2]|0;if(j|0?(i=j+12|0,j=f[i>>2]|0,f[i>>2]=j+-1,(j|0)==1):0)CR(g);f[h>>2]=0;h=g+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[h>>2]|0)>0){d=f[g+40>>2]|0;j=0;do{f[d+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)!=(g+48|0))ZF(h);h=e+36|0;g=f[h>>2]|0;if(g|0?(j=g+12|0,g=f[j>>2]|0,f[j>>2]=g+-1,(g|0)==1):0)CR(e);f[h>>2]=0;h=e+16|0;g=e+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[g>>2]|0)>0){h=f[e+40>>2]|0;j=0;do{f[h+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[g>>2]|0))}g=f[e+44>>2]|0;if((g|0)!=(e+48|0))ZF(g);u=c;return l|0}function D0(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;i=u;u=u+16|0;j=i+8|0;k=i;if((a+-1|0)>>>0>9){f[j>>2]=0;f[j+4>>2]=0;l=c$(j,26)|0;m=201951;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-211,j,201978,201342,394);d$(j)}if(!((c|0)!=0&(e|0)!=0)){f[j>>2]=0;f[j+4>>2]=0;l=c$(j,39)|0;m=201999;n=l+39|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-27,j,201978,201342,397);d$(j)}if(!g){f[j>>2]=0;f[j+4>>2]=0;l=c$(j,24)|0;m=202039;n=l+24|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-27,j,201978,201342,400);d$(j)}if(d|0){f[j>>2]=0;f[j+4>>2]=0;l=c$(j,35)|0;m=202064;n=l+35|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-5,j,201978,201342,403);d$(j)}d=j+4|0;o=k+4|0;p=h&255;q=(h&4|0)==0;h=j+4|0;r=j+4|0;s=j+4|0;t=j+4|0;v=j+4|0;w=-1;x=0;y=0;while(1){z=f[c+(y<<2)>>2]|0;if(z)if((f[z>>2]&-65536|0)==1111687168?(f[z+16>>2]|0)!=0:0)A=z;else B=14;else{f[j>>2]=0;f[d>>2]=0;l=c$(j,39)|0;m=201999;n=l+39|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-27,j,201978,201342,411);d$(j);B=14}if((B|0)==14){B=0;f[j>>2]=0;C=E0(z,e+(y*276|0)|0,j)|0;if(f[j>>2]|0){f[k>>2]=0;f[o>>2]=0;l=c$(k,27)|0;m=202100;n=l+27|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-24,k,201978,201342,420);d$(k)}A=C}z=g+184+(y<<2)|0;f[z>>2]=A;D=A+4|0;if((y|0)>0){if((f[D>>2]|0)!=(f[x+4>>2]|0)){f[j>>2]=0;f[v>>2]=0;l=c$(j,47)|0;m=202128;n=l+47|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-209,j,201978,201342,429);d$(j)}switch(p&3){case 0:{if((f[x>>2]^f[A>>2])&4095|0){f[j>>2]=0;f[r>>2]=0;l=c$(j,40)|0;m=202176;n=l+40|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-205,j,201978,201342,436);d$(j)}break}case 1:{if((f[x>>2]^f[A>>2])&4088|0){f[j>>2]=0;f[s>>2]=0;l=c$(j,49)|0;m=202217;n=l+49|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-205,j,201978,201342,441);d$(j)}break}case 2:{if((f[x>>2]^f[A>>2])&4088|0){f[j>>2]=0;f[t>>2]=0;l=c$(j,36)|0;m=202267;n=l+36|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-205,j,201978,201342,446);d$(j)}break}default:{}}if(q?(C=f[D>>2]|0,(C|0)>0):0){E=C;C=0;while(1){if((f[A+20+(C<<3)>>2]|0)==(f[x+20+(C<<3)>>2]|0))F=E;else{f[j>>2]=0;f[h>>2]=0;l=c$(j,43)|0;m=202304;n=l+43|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-209,j,201978,201342,455);d$(j);F=f[D>>2]|0}C=C+1|0;if((C|0)>=(F|0)){G=x;break}else E=F}}else G=x}else G=A;E=f[A>>2]|0;C=(E>>>3&511)+1<<(47696>>>(E<<1&14)&3);E=f[D>>2]|0;H=E+-1|0;a:do if((H|0)>(w|0)){I=C;K=0;L=E;M=H;while(1){N=f[A+20+(M<<3)+4>>2]|0;if(!((I|0)==(N|0)&(K|0)==(((N|0)<0)<<31>>31|0))){O=K;P=I;Q=L;R=M;break a}N=f[A+20+(M<<3)>>2]|0;S=W1a(N|0,((N|0)<0)<<31>>31|0,I|0,K|0)|0;N=J;T=M+-1|0;if((T|0)>(w|0)){U=M;I=S;K=N;M=T;L=U}else{O=N;P=S;Q=M;R=T;break}}}else{O=0;P=C;Q=E;R=H}while(0);H=(R|0)==(w|0)&((O|0)>0|(O|0)==0&P>>>0>2147483647)?Q:R;w=(H|0)>(w|0)?H:w;f[z>>2]=A;f[g+16+(y<<2)>>2]=f[A+16>>2];y=y+1|0;if((y|0)>=(a|0))break;else x=G}x=(f[G+4>>2]|0)+-1|0;if((x|0)>(w|0)){y=x;x=1;do{x=Y(f[G+20+(y<<3)>>2]|0,x)|0;y=y+-1|0}while((y|0)>(w|0));V=x;W=1}else{V=1;W=1}x=w+1|0;f[g+4>>2]=x;f[g>>2]=a;a=g+8|0;f[a>>2]=V;f[a+4>>2]=W;if((w|0)<0){u=i;return x|0}else X=0;do{f[g+56+(X<<2)>>2]=f[G+20+(X<<3)>>2];X=X+1|0}while((X|0)!=(x|0));u=i;return x|0}function E0(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+48|0;g=e+8|0;h=e;if(d|0)f[d>>2]=0;i=(a|0)!=0;if(!(i&(c|0)!=0)){f[g>>2]=0;f[g+4>>2]=0;j=c$(g,28)|0;k=202348;l=j+28|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-27,g,202377,201342,336);d$(g)}if(i){i=f[a>>2]|0;if((i&-65536|0)==1111687168){if(f[a+16>>2]|0){m=a;u=e;return m|0}f[g>>2]=0;f[g+4>>2]=0;j=c$(g,32)|0;k=202388;l=j+32|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-27,g,202377,201342,341);d$(g);m=a;u=e;return m|0}if((i|0)==112)n=F0(a,g,d,0)|0;else n=a;if(n)if(((f[n>>2]&-65536|0)==1111621632?(f[n+24>>2]|0)>0:0)?(f[n+20>>2]|0)>0:0){o=g;p=n}else{q=g;r=n;s=16}else{q=g;r=0;s=16}}else{q=g;r=0;s=16}if((s|0)==16){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,38)|0;k=202421;l=j+38|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-5,h,202377,201342,353);d$(h);o=q;p=r}r=p+16|0;q=f[r>>2]|0;if(!q){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,33)|0;k=202460;l=j+33|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-27,h,202377,201342,356);d$(h);t=f[r>>2]|0}else t=q;f[c+16>>2]=t;f[c+8>>2]=0;f[c+12>>2]=0;t=f[p>>2]|0;f[c>>2]=t;f[c+4>>2]=2;f[c+20>>2]=f[p+20>>2];f[c+24>>2]=f[p+4>>2];f[c+28>>2]=f[p+24>>2];f[c+32>>2]=(t>>>3&511)+1<<(47696>>>(t<<1&14)&3);m=c;u=e;return m|0}function F0(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=u;u=u+16|0;h=g;i=(a|0)!=0;if(!(i&(c|0)!=0)){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,28)|0;k=202348;l=j+28|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-27,h,202494,201342,2391);d$(h)}do if(i){m=f[a>>2]|0;n=m&-65536;if(((n|0)==1111621632?(f[a+24>>2]|0)>0:0)?(f[a+20>>2]|0)>0:0){if(f[a+16>>2]|0){o=0;p=a;break}f[h>>2]=0;f[h+4>>2]=0;j=c$(h,32)|0;k=202388;l=j+32|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-27,h,202494,201342,2396);d$(h);o=0;p=a;break}if((m|0)!=112){if(!((e|0)!=0&(n|0)==1111687168)){q=34;break}r=a+20|0;s=f[r>>2]|0;t=a+16|0;if(!(f[t>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,33)|0;k=202460;l=j+33|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-27,h,202494,201342,2466);d$(h);v=f[a>>2]|0}else v=m;if(!(v&16384)){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,44)|0;k=202697;l=j+44|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-5,h,202494,201342,2469);d$(h)}m=f[a+4>>2]|0;if((m|0)<=2)if((m|0)==1)w=1;else w=f[a+28>>2]|0;else{n=1;x=1;while(1){y=Y(f[r+(n<<3)>>2]|0,x)|0;n=n+1|0;if((n|0)==(m|0)){w=y;break}else x=y}}f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=f[t>>2];f[c+20>>2]=s;f[c+24>>2]=w;x=f[a>>2]|0;m=x&4095;f[c>>2]=m|1111638016;n=Y((x>>>3&511)+1<<(47696>>>(x<<1&14)&3),w)|0;x=(s|0)>1?n:0;f[c+4>>2]=x;n=W1a(x|0,((x|0)<0)<<31>>31|0,s|0,((s|0)<0)<<31>>31|0)|0;x=J;if(!((x|0)>0|(x|0)==0&n>>>0>2147483647)){o=0;p=c;break}f[c>>2]=m|1111621632;o=0;p=c;break}m=a+68|0;if(!(f[m>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,31)|0;k=202503;l=j+31|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-27,h,202494,201342,2406);d$(h)}s=f[a+16>>2]|0;t=1125516576>>>((s>>>2&60)+(s>>31&20)|0);s=t&7;n=f[a+8>>2]|0;x=(n|0)>1?f[a+28>>2]|0:0;r=a+48|0;y=f[r>>2]|0;if(!y){z=s|(n<<3)+-8;if(x|0){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,40)|0;k=202656;l=j+40|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-206,h,202494,201342,2452);d$(h)}w0(c,f[a+44>>2]|0,f[a+40>>2]|0,z,f[m>>2]|0,f[a+72>>2]|0)|0;o=0;p=c;break}A=f[y>>2]|0;if((x|0)==1){if(!A){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,63)|0;k=202535;l=j+63|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-206,h,202494,201342,2422);d$(h);x=f[r>>2]|0;B=x;C=f[x>>2]|0}else{B=y;C=A}x=(f[m>>2]|0)+(Y(C+-1|0,f[a+64>>2]|0)|0)|0;z=f[a+72>>2]|0;D=x+(Y(z,f[B+8>>2]|0)|0)|0;w0(c,f[B+16>>2]|0,f[B+12>>2]|0,s,D+(f[B+4>>2]<<(47696>>>(t<<1&14)&3))|0,z)|0;o=0;p=c;break}else{z=(n<<3)+-8|0;D=s|z;if((n|0)>512){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,56)|0;k=202599;l=j+56|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-15,h,202494,201342,2438);d$(h);E=f[r>>2]|0}else E=y;n=f[a+72>>2]|0;s=(f[m>>2]|0)+(Y(n,f[E+8>>2]|0)|0)|0;w0(c,f[E+16>>2]|0,f[E+12>>2]|0,D,s+(Y(f[E+4>>2]|0,(z>>>3&511)+1<<(47696>>>(t<<1&14)&3))|0)|0,n)|0;o=A;p=c;break}}else q=34;while(0);if((q|0)==34){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,38)|0;k=202421;l=j+38|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-206,h,202494,201342,2493);d$(h);o=0;p=0}if(!d){u=g;return p|0}f[d>>2]=o;u=g;return p|0}function G0(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=f[a+4>>2]|0;if((b|0)<=0){c=0;return c|0}d=a+184|0;e=a+16|0;g=b;while(1){b=g;g=g+-1|0;if((f[a>>2]|0)>0){h=0;do{i=a+16+(h<<2)|0;f[i>>2]=(f[i>>2]|0)+(f[(f[a+184+(h<<2)>>2]|0)+20+(g<<3)+4>>2]|0);h=h+1|0}while((h|0)<(f[a>>2]|0))}h=a+56+(g<<2)|0;i=f[h>>2]|0;f[h>>2]=i+-1;if((i|0)>1){c=1;j=10;break}i=f[d>>2]|0;k=f[i+20+(g<<3)>>2]|0;l=f[a>>2]|0;if((l|0)>0?(m=0-k|0,n=(f[e>>2]|0)+(Y(f[i+20+(g<<3)+4>>2]|0,m)|0)|0,f[e>>2]=n,(l|0)!=1):0){n=1;do{i=a+16+(n<<2)|0;o=(f[i>>2]|0)+(Y(f[(f[a+184+(n<<2)>>2]|0)+20+(g<<3)+4>>2]|0,m)|0)|0;f[i>>2]=o;n=n+1|0}while((n|0)<(l|0))}f[h>>2]=k;if((b|0)<=1){c=0;j=10;break}}if((j|0)==10)return c|0;return 0}function H0(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=d&4095;i=1212424721>>>(d<<2&28)&15;j=Y(i,(d>>>3&511)+1|0)|0;if(!j){f[g>>2]=0;f[g+4>>2]=0;k=c$(g,23)|0;l=201713;m=k+23|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-210,g,202742,201342,537);d$(g)}if((a+-1|0)>>>0>31){f[g>>2]=0;f[g+4>>2]=0;k=c$(g,24)|0;l=202760;m=k+24|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-211,g,202742,201342,540);d$(g)}if(!c){f[g>>2]=0;f[g+4>>2]=0;k=c$(g,20)|0;l=201737;m=k+20|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-27,g,202742,201342,543);d$(g)}if((a|0)>0){d=g+4|0;n=0;do{if((f[c+(n<<2)>>2]|0)<1){f[g>>2]=0;f[d>>2]=0;k=c$(g,37)|0;l=201805;m=k+37|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-201,g,202742,201342,548);d$(g)}n=n+1|0}while((n|0)<(a|0))}n=a+-32|0;g=_F((((n|0)>0?n:0)<<2)+164|0)|0;f[g>>2]=h|1111752704;f[g+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=1;h=a<<2;K1a(g+36|0,c|0,h|0)|0;c=i+7&0-i;f[g+28>>2]=c;i=j+3+c&65532;f[g+32>>2]=i;c=UL(0,64,h+7+i&-8,pL(4096)|0)|0;f[g+16>>2]=c;f[g+24>>2]=1024;c=_F(4096)|0;f[g+20>>2]=c;F1a(c|0,0,4096)|0;u=e;return g|0}function I0(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;j$(-9,c,202785,201342,581);d$(c)}d=f[a>>2]|0;if(!d){u=b;return}if((f[d>>2]&-65536|0)!=1111752704){f[c>>2]=0;f[c+4>>2]=0;j$(-206,c,202785,201342,588);d$(c)}f[a>>2]=0;f[c>>2]=f[(f[d+16>>2]|0)+44>>2];rL(c);c=d+20|0;$F(f[c>>2]|0);f[c>>2]=0;$F(d);u=b;return}function J0(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;if((a|0)!=0?(e=f[a>>2]|0,(e&-65536|0)==1111752704):0)g=e;else{f[d>>2]=0;f[d+4>>2]=0;e=c$(d,27)|0;h=202804;i=e+27|0;do{b[e>>0]=b[h>>0]|0;e=e+1|0;h=h+1|0}while((e|0)<(i|0));j$(-5,d,202832,201342,605);d$(d);g=f[a>>2]|0}d=H0(f[a+4>>2]|0,a+36|0,g)|0;nL(a,d,0);u=c;return d|0}function K0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d;if(!((a|0)!=0?(f[a>>2]&-65536|0)==1111752704:0)){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,28)|0;h=202849;i=g+28|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j$(-5,e,202878,201342,620);d$(e)}if(!c){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,21)|0;h=202902;i=g+21|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j$(-27,e,202878,201342,623);d$(e)}f[c>>2]=a;e=c+4|0;f[e>>2]=0;h=f[a+24>>2]|0;if((h|0)<=0){j=0;k=0;l=c+8|0;f[l>>2]=j;u=d;return k|0}g=f[a+20>>2]|0;a=0;while(1){m=f[g+(a<<2)>>2]|0;if(m|0)break;i=a+1|0;if((i|0)<(h|0))a=i;else{j=i;k=0;n=11;break}}if((n|0)==11){l=c+8|0;f[l>>2]=j;u=d;return k|0}f[e>>2]=m;j=a;k=m;l=c+8|0;f[l>>2]=j;u=d;return k|0}function L0(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;if(a|0){e=f[a>>2]|0;g=e&-65536;a:do if((g|0)<1111687168){switch(g|0){case 1111621632:break;default:break a}if((f[a+24>>2]|0)>0?(f[a+20>>2]|0)>0:0){if((f[a+24>>2]|0)<=0){u=c;return}if((f[a+20>>2]|0)<=0){u=c;return}h=a+16|0;if(!(f[h>>2]|0)){u=c;return}f[h>>2]=0;h=a+8|0;i=f[h>>2]|0;if(i|0?(j=(f[i>>2]|0)+-1|0,f[i>>2]=j,(j|0)==0):0){$F(i);f[h>>2]=0}f[h>>2]=0;u=c;return}}else{switch(g|0){case 1111687168:break;default:break a}h=a+16|0;if(!(f[h>>2]|0)){u=c;return}f[h>>2]=0;h=a+8|0;i=f[h>>2]|0;if(i|0?(j=(f[i>>2]|0)+-1|0,f[i>>2]=j,(j|0)==0):0){$F(i);f[h>>2]=0}f[h>>2]=0;u=c;return}while(0);if((e|0)==112){e=f[226100]|0;if(!e){g=a+108|0;h=f[g>>2]|0;f[g>>2]=0;f[a+68>>2]=0;$F(h);u=c;return}else{Gh[e&511](a,2);u=c;return}}}f[d>>2]=0;f[d+4>>2]=0;a=c$(d,38)|0;e=201479;h=a+38|0;do{b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}while((a|0)<(h|0));j$(-5,d,202924,201342,1001);d$(d);u=c;return}function M0(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=u;u=u+16|0;h=g;do if(a|0){i=f[a>>2]|0;j=i&-65536;if((((j|0)==1111621632?(k=f[a+24>>2]|0,(k|0)>0):0)?(l=f[a+20>>2]|0,(l|0)>0):0)?(m=a+16|0,f[m>>2]|0):0){if(k>>>0>d>>>0&l>>>0>c>>>0)n=i;else{f[h>>2]=0;f[h+4>>2]=0;o=c$(h,21)|0;p=202938;q=o+21|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-211,h,202960,201342,1762);d$(h);n=f[a>>2]|0}if(e|0)f[e>>2]=n&4095;r=(f[m>>2]|0)+(Y(f[a+4>>2]|0,c)|0)+(Y((n>>>3&511)+1<<(47696>>>(n<<1&14)&3),d)|0)|0;u=g;return r|0}if((i|0)==112?(l=f[a+68>>2]|0,l|0):0){k=a+16|0;s=(f[k>>2]|0)>>>3&31;t=(f[a+28>>2]|0)==0;if(t)v=Y(f[a+8>>2]|0,s)|0;else v=s;s=f[a+48>>2]|0;if(s){w=f[s+12>>2]|0;x=f[s+16>>2]|0;y=Y(f[a+72>>2]|0,f[s+8>>2]|0)|0;z=l+((Y(f[s+4>>2]|0,v)|0)+y)|0;if(t){A=x;B=z;C=w}else{t=f[s>>2]|0;if(!t){f[h>>2]=0;f[h+4>>2]=0;o=c$(h,45)|0;p=202968;q=o+45|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-24,h,202960,201342,1793);d$(h)}A=x;B=z+(Y(f[a+64>>2]|0,t+-1|0)|0)|0;C=w}}else{A=f[a+44>>2]|0;B=l;C=f[a+40>>2]|0}if(!(C>>>0>d>>>0&A>>>0>c>>>0)){f[h>>2]=0;f[h+4>>2]=0;o=c$(h,21)|0;p=202938;q=o+21|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-211,h,202960,201342,1805);d$(h)}l=B+((Y(f[a+72>>2]|0,c)|0)+(Y(v,d)|0))|0;if(!e){r=l;u=g;return r|0}w=f[k>>2]|0;t=a+8|0;z=f[t>>2]|0;if((z+-1|0)>>>0>3){f[h>>2]=0;f[h+4>>2]=0;j$(-210,h,202960,201342,1813);d$(h);D=f[t>>2]|0}else D=z;f[e>>2]=(D<<3)+-8|1125516576>>>((w>>>2&60)+(w>>31&20)|0)&7;r=l;u=g;return r|0}if((j|0)!=1111687168){if((j|0)!=1111752704)break;if((f[a+4>>2]|0)!=2){f[h>>2]=0;f[h+4>>2]=0;o=c$(h,30)|0;p=203014;q=o+30|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-215,h,202960,201342,1833);d$(h)}f[h>>2]=c;f[h+4>>2]=d;r=N0(a,h,e,1,0)|0;u=g;return r|0}j=a+16|0;k=f[j>>2]|0;if(k|0){if(((f[a+4>>2]|0)==2?(f[a+20>>2]|0)>>>0>c>>>0:0)?(f[a+28>>2]|0)>>>0>d>>>0:0)E=k;else{f[h>>2]=0;f[h+4>>2]=0;o=c$(h,21)|0;p=202938;q=o+21|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-211,h,202960,201342,1825);d$(h);E=f[j>>2]|0}k=E+(Y(f[a+24>>2]|0,c)|0)|0;l=k+(Y(f[a+32>>2]|0,d)|0)|0;if(!e){r=l;u=g;return r|0}f[e>>2]=f[a>>2]&4095;r=l;u=g;return r|0}}while(0);f[h>>2]=0;f[h+4>>2]=0;o=c$(h,38)|0;p=201479;q=o+38|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-5,h,202960,201342,1839);d$(h);r=0;u=g;return r|0}function N0(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=u;u=u+16|0;i=h;if(!g){j=a+4|0;k=f[j>>2]|0;if((k|0)>0){l=i+4|0;m=k;k=0;n=0;while(1){o=f[c+(n<<2)>>2]|0;if(o>>>0<(f[a+36+(n<<2)>>2]|0)>>>0)p=m;else{f[i>>2]=0;f[l>>2]=0;q=c$(i,30)|0;r=203045;s=q+30|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));j$(-211,i,203076,201342,657);d$(i);p=f[j>>2]|0}r=o+(Y(k,1540483477)|0)|0;n=n+1|0;if((n|0)>=(p|0)){t=r;break}else{m=p;k=r}}}else t=0}else t=f[g>>2]|0;g=a+24|0;k=f[g>>2]|0;p=k+-1&t;m=t&2147483647;a:do if((e|0)>-2?(t=f[(f[a+20>>2]|0)+(p<<2)>>2]|0,(t|0)!=0):0){n=a+32|0;j=a+4|0;l=t;while(1){if((f[l>>2]|0)==(m|0)){t=l+(f[n>>2]|0)|0;r=f[j>>2]|0;b:do if((r|0)>0){q=0;while(1){if((f[c+(q<<2)>>2]|0)!=(f[t+(q<<2)>>2]|0)){v=q;break b}s=q+1|0;if((s|0)<(r|0))q=s;else{v=s;break}}}else v=0;while(0);if((v|0)==(r|0))break}t=f[l+4>>2]|0;if(!t){w=0;break a}else l=t}w=l+(f[a+28>>2]|0)|0}else w=0;while(0);if((e|0)!=0&(w|0)==0){v=a+16|0;j=f[v>>2]|0;if((f[j+60>>2]|0)<(k*3|0)){x=j;y=p}else{p=k<<1;k=(p|0)>1024?p:1024;p=k<<2;j=_F(p)|0;F1a(j|0,0,p|0)|0;p=K0(a,i)|0;if(p|0){n=i+4|0;o=i+8|0;t=k+-1|0;q=p;while(1){p=f[(f[n>>2]|0)+4>>2]|0;c:do if(!p){s=(f[o>>2]|0)+1|0;f[o>>2]=s;z=f[i>>2]|0;A=f[z+24>>2]|0;if((s|0)<(A|0)){B=f[z+20>>2]|0;z=s;while(1){C=f[B+(z<<2)>>2]|0;if(C|0)break;s=z+1|0;if((s|0)<(A|0))z=s;else{D=0;break c}}f[o>>2]=z;E=C;F=28}else D=0}else{E=p;F=28}while(0);if((F|0)==28){F=0;f[n>>2]=E;D=E}p=j+((f[q>>2]&t)<<2)|0;f[q+4>>2]=f[p>>2];f[p>>2]=q;if(!D)break;else q=D}}D=a+20|0;$F(f[D>>2]|0);f[D>>2]=j;f[g>>2]=k;x=f[v>>2]|0;y=k+2147483647&m}k=x+56|0;v=f[k>>2]|0;f[i>>2]=v;if(!v){VL(x,0,i)|0;G=f[i>>2]|0}else{f[k>>2]=f[v+4>>2];f[v>>2]=f[v>>2]&67108863;k=x+60|0;f[k>>2]=(f[k>>2]|0)+1;G=v}f[G>>2]=m;m=(f[a+20>>2]|0)+(y<<2)|0;f[G+4>>2]=f[m>>2];f[m>>2]=G;K1a(G+(f[a+32>>2]|0)|0,c|0,f[a+4>>2]<<2|0)|0;c=G+(f[a+28>>2]|0)|0;if((e|0)>0){e=f[a>>2]|0;F1a(c|0,0,(e>>>3&511)+1<<(47696>>>(e<<1&14)&3)|0)|0;H=c}else H=c}else H=w;if(!d){u=h;return H|0}f[d>>2]=f[a>>2]&4095;u=h;return H|0}function O0(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;if(a|0){e=f[a>>2]|0;g=e&-65536;a:do if((g|0)<1111687168){switch(g|0){case 1111621632:break;default:break a}if((f[a+24>>2]|0)>0?(f[a+20>>2]|0)>0:0)h=5}else if((g|0)<1111752704)switch(g|0){case 1111687168:{h=5;break a;break}default:break a}else switch(g|0){case 1111752704:{h=5;break a;break}default:break a}while(0);if((h|0)==5){i=e&4095;u=c;return i|0}if((e|0)==112?f[a+68>>2]|0:0){e=f[a+16>>2]|0;i=1125516576>>>((e>>>2&60)+(e>>31&20)|0)&7|(f[a+8>>2]<<3)+-8;u=c;return i|0}}f[d>>2]=0;f[d+4>>2]=0;a=c$(d,38)|0;e=201479;h=a+38|0;do{b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}while((a|0)<(h|0));j$(-5,d,203090,201342,1094);d$(d);i=-1;u=c;return i|0}function P0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;a:do if(a|0){g=f[a>>2]|0;h=g&-65536;if(((h|0)==1111621632?(i=a+24|0,(f[i>>2]|0)>0):0)?(j=f[a+20>>2]|0,(j|0)>0):0){if(!c){k=2;u=d;return k|0}f[c>>2]=j;f[c+4>>2]=f[i>>2];k=2;u=d;return k|0}if((g|0)==112?f[a+68>>2]|0:0){if(!c){k=2;u=d;return k|0}f[c>>2]=f[a+44>>2];f[c+4>>2]=f[a+40>>2];k=2;u=d;return k|0}if((h|0)>=1111752704){switch(h|0){case 1111752704:break;default:break a}g=f[a+4>>2]|0;if(!c){k=g;u=d;return k|0}K1a(c|0,a+36|0,g<<2|0)|0;k=g;u=d;return k|0}switch(h|0){case 1111687168:break;default:break a}h=f[a+4>>2]|0;if(!((c|0)!=0&(h|0)>0)){k=h;u=d;return k|0}g=a+20|0;i=0;do{f[c+(i<<2)>>2]=f[g+(i<<3)>>2];i=i+1|0}while((i|0)!=(h|0));k=h;u=d;return k|0}while(0);f[e>>2]=0;f[e+4>>2]=0;c=c$(e,38)|0;a=201479;h=c+38|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(h|0));j$(-5,e,203104,201342,1148);d$(e);k=-1;u=d;return k|0}function Q0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;f[a>>2]=0;g=a+4|0;f[g>>2]=0;if(c|0){h=f[c>>2]|0;if(((h&-65536|0)==1111621632?(i=f[c+24>>2]|0,(i|0)>-1):0)?(j=f[c+20>>2]|0,(j|0)>-1):0){f[a>>2]=i;f[g>>2]=j;u=d;return}if((h|0)==112){h=f[c+48>>2]|0;if(!h){f[a>>2]=f[c+40>>2];k=c+44|0}else{f[a>>2]=f[h+12>>2];k=h+16|0}f[g>>2]=f[k>>2];u=d;return}}f[e>>2]=0;f[e+4>>2]=0;k=c$(e,33)|0;g=203114;h=k+33|0;do{b[k>>0]=b[g>>0]|0;k=k+1|0;g=g+1|0}while((k|0)<(h|0));j$(-5,e,203148,201342,1246);d$(e);u=d;return}function R0(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=u;u=u+16|0;i=h;if(!c){f[i>>2]=0;f[i+4>>2]=0;j=c$(i,23)|0;k=203158;l=j+23|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-27,i,203182,201342,1888);d$(i)}a:do if(a|0){m=f[a>>2]|0;n=m&-65536;b:do if((n|0)<1111687168){switch(n|0){case 1111621632:break;default:{o=16;break b}}if((f[a+24>>2]|0)>0){if(!((f[a+20>>2]|0)>0|(m|0)==112))break a}else o=16}else{if((n|0)>=1111752704){switch(n|0){case 1111752704:break;default:{o=16;break b}}p=N0(a,c,d,e,g)|0;u=h;return p|0}switch(n|0){case 1111687168:break;default:{o=16;break b}}q=f[a+16>>2]|0;if(!q)o=16;else{r=a+4|0;s=f[r>>2]|0;if((s|0)>0){t=a+20|0;v=i+4|0;w=s;s=0;x=q;while(1){y=c+(s<<2)|0;z=f[y>>2]|0;if(z>>>0<(f[t+(s<<3)>>2]|0)>>>0){A=z;B=w}else{f[i>>2]=0;f[v>>2]=0;j=c$(i,21)|0;k=202938;l=j+21|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-211,i,203182,201342,1902);d$(i);A=f[y>>2]|0;B=f[r>>2]|0}z=x+(Y(f[t+(s<<3)+4>>2]|0,A)|0)|0;s=s+1|0;if((s|0)>=(B|0)){C=z;break}else{w=B;x=z}}}else C=q;if(!d){p=C;u=h;return p|0}f[d>>2]=f[a>>2]&4095;p=C;u=h;return p|0}}while(0);if((o|0)==16?(m|0)!=112:0)break;p=M0(a,f[c>>2]|0,f[c+4>>2]|0,d)|0;u=h;return p|0}while(0);f[i>>2]=0;f[i+4>>2]=0;j=c$(i,38)|0;k=201479;l=j+38|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-5,i,203182,201342,1912);d$(i);p=0;u=h;return p|0}function S0(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+16|0;h=g+8|0;i=g;if(!c){f[h>>2]=0;f[h+4>>2]=0;j$(-27,h,203269,201342,2719);d$(h)}if(((((a|0)!=0?(f[a>>2]&-65536|0)==1111621632:0)?(f[a+24>>2]|0)>0:0)?(f[a+20>>2]|0)>0:0)?(f[a+16>>2]|0)!=0:0)j=a;else{f[h>>2]=0;k=F0(a,c,h,1)|0;if(f[h>>2]|0){f[i>>2]=0;f[i+4>>2]=0;l=c$(i,20)|0;m=340913;n=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-24,i,203269,201342,2726);d$(i)}j=k}if(d)if((d+-1|0)>>>0>3){f[h>>2]=0;f[h+4>>2]=0;j$(-15,h,203269,201342,2732);d$(h);o=d}else o=d;else o=((f[j>>2]|0)>>>3&511)+1|0;if((j|0)!=(c|0)){d=c+12|0;k=f[d>>2]|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];f[c+16>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[c+24>>2]=f[j+24>>2];f[c+8>>2]=0;f[d>>2]=k}k=f[j>>2]|0;d=Y((k>>>3&511)+1|0,f[j+24>>2]|0)|0;i=(e|0)==0;if((o|0)>(d|0))if(i)p=20;else{q=e;p=23}else if(i&((d|0)%(o|0)|0|0)!=0)p=20;else{r=e;p=21}if((p|0)==20){r=(Y(f[j+20>>2]|0,d)|0)/(o|0)|0;p=21}if((p|0)==21)if(!r){s=f[j+20>>2]|0;p=24}else{q=r;p=23}if((p|0)==23){r=f[j+20>>2]|0;if((q|0)==(r|0)){s=q;p=24}else{e=Y(r,d)|0;if(!(k&16384)){f[h>>2]=0;f[h+4>>2]=0;l=c$(h,72)|0;m=203279;n=l+72|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-13,h,203269,201342,2757);d$(h)}if(q>>>0>e>>>0){f[h>>2]=0;f[h+4>>2]=0;l=c$(h,22)|0;m=203352;n=l+22|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-211,h,203269,201342,2760);d$(h)}k=(e|0)/(q|0)|0;if((Y(k,q)|0)!=(e|0)){f[h>>2]=0;f[h+4>>2]=0;l=c$(h,78)|0;m=203190;n=l+78|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-5,h,203269,201342,2766);d$(h)}f[c+20>>2]=q;t=Y(1212424721>>>(f[j>>2]<<2&28)&15,k)|0;v=k}}if((p|0)==24){f[c+20>>2]=s;t=f[j+4>>2]|0;v=d}f[c+4>>2]=t;t=(v|0)/(o|0)|0;if((Y(t,o)|0)==(v|0)){w=c+24|0;f[w>>2]=t;x=f[j>>2]|0;y=x&-4096;z=x&7;A=o<<3;B=A+-8|0;C=z|B;D=C|y;f[c>>2]=D;u=g;return c|0}f[h>>2]=0;f[h+4>>2]=0;l=c$(h,62)|0;m=203375;n=l+62|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-15,h,203269,201342,2776);d$(h);w=c+24|0;f[w>>2]=t;x=f[j>>2]|0;y=x&-4096;z=x&7;A=o<<3;B=A+-8|0;C=z|B;D=C|y;f[c>>2]=D;u=g;return c|0}function T0(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+16|0;j=i;if(!a){f[j>>2]=0;f[j+4>>2]=0;k=c$(j,22)|0;l=203438;m=k+22|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-9,j,203461,201342,2918);d$(j)}k=a+4|0;m=k+108|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(m|0));f[a>>2]=112;n=e+-1|0;if(n>>>0<4){o=f[45088+(n<<3)+4>>2]|0;p=f[45088+(n<<3)>>2]|0}else{o=5694105;p=5694105}bLa(a+20|0,p,4)|0;bLa(a+24|0,o,4)|0;o=f[c>>2]|0;if(!((o|0)>=0?(f[c+4>>2]|0)>=0:0)){f[j>>2]=0;f[j+4>>2]=0;k=c$(j,13)|0;l=203479;m=k+13|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-25,j,203461,201342,2928);d$(j)}if((e|0)<0|(d|0)!=64&((d|0)!=32&((d|0)!=-2147483616&((d|0)!=-2147483632&((d|0)!=16&((d|0)!=-2147483640&((d|0)!=1&(d|0)!=8))))))){f[j>>2]=0;f[j+4>>2]=0;k=c$(j,18)|0;l=203493;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-17,j,203461,201342,2935);d$(j)}if(g>>>0>1){f[j>>2]=0;f[j+4>>2]=0;k=c$(j,16)|0;l=203512;m=k+16|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-20,j,203461,201342,2937);d$(j)}switch(h|0){case 4:case 8:break;default:{f[j>>2]=0;f[j+4>>2]=0;k=c$(j,15)|0;l=203529;m=k+15|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-21,j,203461,201342,2940);d$(j)}}f[a+40>>2]=o;p=f[c+4>>2]|0;f[a+44>>2]=p;c=f[a+48>>2]|0;if(c|0){f[c>>2]=0;f[c+8>>2]=0;f[c+4>>2]=0;f[c+12>>2]=o;f[c+16>>2]=p}c=(e|0)>1?e:1;f[a+8>>2]=c;f[a+16>>2]=d;f[a+36>>2]=h;e=h+-1+(((Y(Y(c,d&2147483647)|0,o)|0)+7|0)>>>3)&0-h;f[a+72>>2]=e;f[a+32>>2]=g;g=W1a(e|0,((e|0)<0)<<31>>31|0,p|0,((p|0)<0)<<31>>31|0)|0;f[a+64>>2]=g;if((g|0)==(g|0)&(((g|0)<0)<<31>>31|0)==(J|0)){u=i;return a|0}f[j>>2]=0;f[j+4>>2]=0;k=c$(j,22)|0;l=201456;m=k+22|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-4,j,203461,201342,2962);d$(j);u=i;return a|0}function U0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d+8|0;g=d;h=a;a=f[h>>2]|0;i=f[h+4>>2]|0;h=f[226098]|0;if(!h){j=_F(112)|0;k=g;f[k>>2]=a;f[k+4>>2]=i;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];T0(j,e,b,c,0,4)|0;l=j;v0(l);u=d;return l|0}j=c+-1|0;if(j>>>0<4){m=f[45088+(j<<3)+4>>2]|0;n=f[45088+(j<<3)>>2]|0}else{m=5694105;n=5694105}l=Ci[h&0](c,0,b,n,m,0,0,4,a,i,0,0,0,0)|0;v0(l);u=d;return l|0}function V0(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;j$(-27,c,203563,201342,2996);d$(c)}c=f[a>>2]|0;if(!c){u=b;return}f[a>>2]=0;L0(c);a=f[226100]|0;if(!a){d=c+48|0;$F(f[d>>2]|0);f[d>>2]=0;$F(c);u=b;return}else{Gh[a&511](c,5);u=b;return}}function W0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;j$(-9,d,203578,201342,3013);d$(d)}e=b+8|0;g=f[e>>2]|0;if((((((g|0)>-1?(h=b+12|0,i=f[h>>2]|0,(i|0)>-1):0)?(j=f[b>>2]|0,k=f[a+40>>2]|0,(j|0)<(k|0)):0)?(l=b+4|0,m=f[l>>2]|0,n=f[a+44>>2]|0,(m|0)<(n|0)):0)?(j+g|0)>=((g|0)>0|0):0)?(m+i|0)>=((i|0)>0|0):0){o=k;p=n;q=j;r=m;s=i;t=h;v=b;w=l}else{f[d>>2]=0;f[d+4>>2]=0;K1a(c$(d,184)|0,203592,184)|0;j$(-215,d,203578,201342,3019);d$(d);d=b+4|0;l=b+12|0;o=f[a+40>>2]|0;p=f[a+44>>2]|0;q=f[b>>2]|0;r=f[d>>2]|0;s=f[l>>2]|0;t=l;v=b;w=d}d=g+q|0;g=s+r|0;s=(q|0)>0?q:0;f[v>>2]=s;v=(r|0)>0?r:0;f[w>>2]=v;w=((o|0)<(d|0)?o:d)-s|0;f[e>>2]=w;e=((p|0)<(g|0)?p:g)-v|0;f[t>>2]=e;t=a+48|0;a=f[t>>2]|0;if(a|0){f[a+4>>2]=s;f[a+8>>2]=v;f[a+12>>2]=w;f[a+16>>2]=e;u=c;return}a=f[226101]|0;if(!a){g=_F(20)|0;f[g>>2]=0;f[g+4>>2]=s;f[g+8>>2]=v;f[g+12>>2]=w;f[g+16>>2]=e;x=g}else x=uh[a&63](0,s,v,w,e)|0;f[t>>2]=x;u=c;return}function X0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;j$(-9,d,203777,201342,3086);d$(d)}do if((f[a+8>>2]|0)>>>0<b>>>0){f[d>>2]=0;f[d+4>>2]=0;j$(-24,d,203777,201342,3089);d$(d);e=a+48|0;g=f[e>>2]|0;if(!g)h=e;else{i=g;j=7}}else{g=a+48|0;e=f[g>>2]|0;k=(e|0)!=0;if((b|0)!=0|k)if(k){i=e;j=7;break}else{h=g;break}else{u=c;return}}while(0);if((j|0)==7){f[i>>2]=b;u=c;return}i=f[a+40>>2]|0;j=f[a+44>>2]|0;a=f[226101]|0;if(!a){d=_F(20)|0;f[d>>2]=b;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=i;f[d+16>>2]=j;l=d}else l=uh[a&63](b,0,0,i,j)|0;f[h>>2]=l;u=c;return}function Y0(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;j$(-9,c,203791,201342,3109);d$(c)}c=f[a+48>>2]|0;if(!c){d=0;u=b;return d|0}d=f[c>>2]|0;u=b;return d|0}function Z0(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+16|0;d=c;if(!((a|0)!=0?(f[a>>2]|0)==112:0)){f[d>>2]=0;f[d+4>>2]=0;e=c$(d,16)|0;g=203805;h=e+16|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));j$(-5,d,203822,201342,3121);d$(d)}d=f[226102]|0;if(d|0){i=mi[d&255](a)|0;u=c;return i|0}d=_F(112)|0;e=d;g=a;h=e+108|0;do{f[e>>2]=f[g>>2];e=e+4|0;g=g+4|0}while((e|0)<(h|0));f[d+108>>2]=0;g=d+68|0;f[g>>2]=0;e=d+48|0;f[e>>2]=0;h=f[a+48>>2]|0;if(h|0){j=f[h>>2]|0;k=f[h+4>>2]|0;l=f[h+8>>2]|0;m=f[h+12>>2]|0;n=f[h+16>>2]|0;h=f[226101]|0;if(!h){o=_F(20)|0;f[o>>2]=j;f[o+4>>2]=k;f[o+8>>2]=l;f[o+12>>2]=m;f[o+16>>2]=n;p=o}else p=uh[h&63](j,k,l,m,n)|0;f[e>>2]=p}p=a+68|0;if(!(f[p>>2]|0)){i=d;u=c;return i|0}e=f[a+64>>2]|0;v0(d);K1a(f[g>>2]|0,f[p>>2]|0,e|0)|0;i=d;u=c;return i|0}function _0(a,b){a=a|0;b=b|0;var c=0;a=u;u=u+16|0;c=a;f[c>>2]=b;x0(c);u=a;return}function $0(a,b){a=a|0;b=b|0;var c=0;a=u;u=u+16|0;c=a;f[c>>2]=b;rL(c);u=a;return}function a1(a,b){a=a|0;b=b|0;var c=0;a=u;u=u+16|0;c=a;f[c>>2]=b;BV(c);u=a;return}function b1(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0;e=u;u=u+16|0;d=e;f[d>>2]=0;f[d+4>>2]=0;c=c$(d,44)|0;a=203835;g=c+44|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(g|0));j$(-216,d,203880,203894,107);d$(d);u=e;return}function c1(a){a=a|0;return}function d1(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;e=u;u=u+16|0;d=e;f[d>>2]=0;f[d+4>>2]=0;c=c$(d,44)|0;g=203835;h=c+44|0;do{b[c>>0]=b[g>>0]|0;c=c+1|0;g=g+1|0}while((c|0)<(h|0));j$(-216,d,203880,203894,107);d$(d);u=e;return a|0}function e1(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0;e=u;u=u+16|0;d=e;f[d>>2]=0;f[d+4>>2]=0;c=c$(d,44)|0;a=203835;g=c+44|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(g|0));j$(-216,d,203880,203894,107);d$(d);u=e;return}function f1(a){a=a|0;return}function g1(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[d>>2]=0;f[d+4>>2]=0;a=c$(d,44)|0;e=203835;g=a+44|0;do{b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}while((a|0)<(g|0));j$(-216,d,203880,203894,107);d$(d);u=c;return}function h1(){var a=0,c=0,d=0,e=0,g=0;a=u;u=u+16|0;c=a;f[c>>2]=0;f[c+4>>2]=0;d=c$(c,44)|0;e=203835;g=d+44|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));j$(-216,c,203880,203894,107);d$(c);if(b[375008]|0){u=a;return 904412}if(!(u1a(375008)|0)){u=a;return 904412}g1(904412);Fd(954,904412,x|0)|0;u=a;return 904412}function i1(a){a=a|0;var b=0,c=0,d=0;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)ki[f[(f[b>>2]|0)+8>>2]&2047](b);f[a>>2]=0;f[a+4>>2]=0;return}function j1(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;g=u;u=u+1312|0;i=g+112|0;j=g+92|0;k=g+32|0;l=g+8|0;m=g;o=a+24|0;p=(f[o>>2]|0)+8|0;q=i+8|0;f[q>>2]=0;f[i+12>>2]=0;f[i+28>>2]=0;f[i+32>>2]=0;f[i+48>>2]=0;f[i+52>>2]=0;f[i+68>>2]=0;f[i+72>>2]=0;f[i+88>>2]=0;f[i+92>>2]=0;f[i+108>>2]=0;f[i+112>>2]=0;f[i+128>>2]=0;f[i+132>>2]=0;f[i+148>>2]=0;f[i+152>>2]=0;f[i+168>>2]=0;f[i+172>>2]=0;f[i+188>>2]=0;f[i+192>>2]=0;f[i+208>>2]=0;f[i+212>>2]=0;f[i+228>>2]=0;f[i+232>>2]=0;f[i+248>>2]=0;f[i+252>>2]=0;f[i+268>>2]=0;f[i+272>>2]=0;f[i+288>>2]=0;f[i+292>>2]=0;f[i+308>>2]=0;f[i+312>>2]=0;f[i+328>>2]=0;f[i+332>>2]=0;f[i+348>>2]=0;f[i+352>>2]=0;f[i+368>>2]=0;f[i+372>>2]=0;f[i+388>>2]=0;f[i+392>>2]=0;f[i+408>>2]=0;f[i+412>>2]=0;f[i+428>>2]=0;f[i+432>>2]=0;f[i+448>>2]=0;f[i+452>>2]=0;f[i+468>>2]=0;f[i+472>>2]=0;f[i+488>>2]=0;f[i+492>>2]=0;f[i+508>>2]=0;f[i+512>>2]=0;f[i+528>>2]=0;f[i+532>>2]=0;f[i+548>>2]=0;f[i+552>>2]=0;f[i+568>>2]=0;f[i+572>>2]=0;f[i+588>>2]=0;f[i+592>>2]=0;f[i+608>>2]=0;f[i+612>>2]=0;f[i+628>>2]=0;f[i+632>>2]=0;f[i+648>>2]=0;f[i+652>>2]=0;f[i+668>>2]=0;f[i+672>>2]=0;f[i+688>>2]=0;f[i+692>>2]=0;f[i+708>>2]=0;f[i+712>>2]=0;f[i+728>>2]=0;f[i+732>>2]=0;f[i+748>>2]=0;f[i+752>>2]=0;f[i+768>>2]=0;f[i+772>>2]=0;f[i+788>>2]=0;f[i+792>>2]=0;f[i+808>>2]=0;f[i+812>>2]=0;f[i+828>>2]=0;f[i+832>>2]=0;f[i+848>>2]=0;f[i+852>>2]=0;f[i+868>>2]=0;f[i+872>>2]=0;f[i+888>>2]=0;f[i+892>>2]=0;f[i+908>>2]=0;f[i+912>>2]=0;f[i+928>>2]=0;f[i+932>>2]=0;f[i+948>>2]=0;f[i+952>>2]=0;f[i+968>>2]=0;f[i+972>>2]=0;f[i+988>>2]=0;f[i+992>>2]=0;f[i+1008>>2]=0;f[i+1012>>2]=0;f[i+1028>>2]=0;f[i+1032>>2]=0;f[i+1048>>2]=0;f[i+1052>>2]=0;f[i+1068>>2]=0;f[i+1072>>2]=0;f[i+1088>>2]=0;f[i+1092>>2]=0;f[i+1108>>2]=0;f[i+1112>>2]=0;f[i+1128>>2]=0;f[i+1132>>2]=0;f[i+1148>>2]=0;f[i+1152>>2]=0;f[i+1168>>2]=0;f[i+1172>>2]=0;f[i>>2]=q;r=i+4|0;f[r>>2]=p;if(p>>>0>59){t=OYa(p>>>0>214748364?-1:p*20|0)|0;v=t+(p*20|0)|0;p=t;do{f[p>>2]=0;f[p+4>>2]=0;p=p+20|0}while((p|0)!=(v|0));f[i>>2]=t;w=t}else w=q;f[j>>2]=0;f[j+4>>2]=0;t=f[o>>2]|0;f[k+36>>2]=0;v=k+40|0;f[v>>2]=0;p=a+56|0;x=f[p>>2]|0;y=f[p+4>>2]|0;p=f[a>>2]|0;if(!((p&12288|0)==4096?!((p&16384|0)==0?1:(f[a+28>>2]|0)!=1):0)){f[m>>2]=0;f[m+4>>2]=0;K1a(c$(m,129)|0,203965,129)|0;j$(-215,m,204095,204119,74);d$(m)}if((c|0)<=87){f[m>>2]=0;f[m+4>>2]=0;p=c$(m,37)|0;z=204170;A=p+37|0;do{b[p>>0]=b[z>>0]|0;p=p+1|0;z=z+1|0}while((p|0)<(A|0));j$(-215,m,204095,204119,75);d$(m)}GL(f[a>>2]&-4096|12,c,8,d,l);if(f[o>>2]|0){o=k+32|0;b[o>>0]=0;$6(a,k);a=j+16|0;f[a>>2]=0;a:do if((t|0)>0){d=k+28|0;c=k+12|0;m=k+36|0;z=(e|0)==1;p=l+12|0;A=l+20|0;B=k+20|0;if((e|0)<3)C=0;else{D=j;E=0;while(1){F=b[f[d>>2]>>0]|0;G=f[c>>2]|0;f[d>>2]=G;H=m;I=f[H>>2]|0;J=f[H+4>>2]|0;H=G;if(!G)K=b[o>>0]|0;else{G=b[H>>0]|0;b[o>>0]=G;L=H+1|0;f[c>>2]=L;if(L>>>0<(f[B>>2]|0)>>>0){N=G;O=I}else{LL(k,1);N=b[o>>0]|0;O=f[m>>2]|0}G=N<<24>>24;f[m>>2]=O+(b[k+44+(G<<1)>>0]|0);f[v>>2]=(f[v>>2]|0)+(b[k+44+(G<<1)+1>>0]|0);K=N}G=(K<<24>>24)-F|0;F=f[45120+(G+7<<2)>>2]|0;L=w+(E*20|0)|0;if(!G)P=D;else{f[D+16>>2]=L;P=L}f[w+(E*20|0)+12>>2]=F;F=w+(E*20|0)|0;f[F>>2]=I;f[F+4>>2]=J;J=E+1|0;if((J|0)<(t|0)){D=P;E=J}else{Q=P;R=J;break a}}}while(1){E=b[f[d>>2]>>0]|0;D=f[c>>2]|0;f[d>>2]=D;J=m;F=f[J>>2]|0;I=f[J+4>>2]|0;J=D;if(!D)S=b[o>>0]|0;else{D=b[J>>0]|0;b[o>>0]=D;L=J+1|0;f[c>>2]=L;if(L>>>0<(f[B>>2]|0)>>>0){T=D;U=F}else{LL(k,1);T=b[o>>0]|0;U=f[m>>2]|0}D=T<<24>>24;f[m>>2]=U+(b[k+44+(D<<1)>>0]|0);f[v>>2]=(f[v>>2]|0)+(b[k+44+(D<<1)+1>>0]|0);S=T}if(z|S<<24>>24!=E<<24>>24){E=f[p>>2]|0;if(E>>>0<(f[A>>2]|0)>>>0)V=E;else{JL(l);V=f[p>>2]|0}E=V;D=E;b[D>>0]=F;b[D+1>>0]=F>>8;b[D+2>>0]=F>>16;b[D+3>>0]=F>>24;F=E+4|0;b[F>>0]=I;b[F+1>>0]=I>>8;b[F+2>>0]=I>>16;b[F+3>>0]=I>>24;f[p>>2]=(f[p>>2]|0)+8}I=C+1|0;if((I|0)<(t|0))C=I;else{Q=j;R=I;break}}}else{Q=j;R=0}while(0);if((e|0)>=3){f[Q+16>>2]=0;Q=f[a>>2]|0;C=w;t=(e|0)==4;e=Q;do{V=(e-C|0)/20|0;S=e;T=f[S>>2]|0;k=f[S+4>>2]|0;S=0;v=1;U=0;while(1){o=V-v|0;P=((o|0)<0?R:0)+o|0;o=v+V|0;K=o-((o|0)>=(R|0)?R:0)|0;o=f[w+(P*20|0)>>2]|0;N=(f[w+(K*20|0)>>2]|0)-o|0;O=f[w+(P*20|0)+4>>2]|0;P=(f[w+(K*20|0)+4>>2]|0)-O|0;K=(Y(P,P)|0)+(Y(N,N)|0)|0;p=(Y(P,T-o|0)|0)-(Y(k-O|0,N)|0)|0;N=(n[s>>2]=+(S|0)*+(K|0)-+(U|0)*+(p|0),f[s>>2]|0);if((v|0)>1){if((U|0)>=(K|0))break;if((S|0)>0&(N|0)<1)break;if((S|0)<0&(N|0)>-1)break}S=p;v=v+1|0;U=K}U=v+-1|0;f[e+8>>2]=U;if(t){S=U;K=0;while(1){p=V-S|0;N=((p|0)<0?R:0)+p|0;p=S+V|0;O=p-((p|0)>=(R|0)?R:0)|0;p=(f[w+(N*20|0)>>2]|0)-T|0;o=(f[w+(N*20|0)+4>>2]|0)-k|0;N=(f[w+(O*20|0)>>2]|0)-T|0;P=(f[w+(O*20|0)+4>>2]|0)-k|0;if((o|p|0)==0|(P|N|0)==0){W=K;break}X=+(p|0);Z=+(o|0);_=+(N|0);$=+(P|0);aa=+((Y(P,o)|0)+(Y(N,p)|0)|0)/+M(+((X*X+Z*Z)*(_*_+$*$)))+1.1;p=(n[s>>2]=aa,f[s>>2]|0);if(!((S|0)>=(U|0)|(p|0)>(K|0))){W=K;break}if((S|0)>1){S=S+-1|0;K=p}else{W=p;break}}f[e+12>>2]=W}e=f[e+16>>2]|0}while((e|0)!=0);ba=Q;ca=j;while(1){Q=f[ba+8>>2]>>1;e=ba+12|0;W=f[e>>2]|0;K=(ba-C|0)/20|0;b:do if((Q|0)<1)da=ba;else{S=1;while(1){U=K-S|0;if((f[w+((((U|0)<0?R:0)+U|0)*20|0)+12>>2]|0)>(W|0))break;U=S+K|0;if((f[w+((U-((U|0)>=(R|0)?R:0)|0)*20|0)+12>>2]|0)>(W|0))break;if((S|0)<(Q|0))S=S+1|0;else{da=ba;break b}}f[ca+16>>2]=f[ba+16>>2];f[e>>2]=0;da=ca}while(0);ba=f[ba+16>>2]|0;if(!ba)break;else ca=da}da=f[a>>2]|0;ca=j;while(1){do if((f[da+8>>2]|0)==1){ba=da+12|0;e=f[ba>>2]|0;Q=da-C|0;W=(Q|0)/20|0;K=W+1|0;if((e|0)>(f[w+((W+-1+((Q|0)<20?R:0)|0)*20|0)+12>>2]|0)?(e|0)>(f[w+((K-((K|0)>=(R|0)?R:0)|0)*20|0)+12>>2]|0):0){ea=da;break}f[ca+16>>2]=f[da+16>>2];f[ba>>2]=0;ea=ca}else ea=da;while(0);da=f[da+16>>2]|0;if(!da)break;else ca=ea}do if(!t){if(f[w+12>>2]|0?(ea=R+-1|0,f[w+(ea*20|0)+12>>2]|0):0){c:do if((R|0)>1){ca=1;while(1){if(!(f[w+(ca*20|0)+12>>2]|0)){fa=ca;break c}f[w+((ca+-1|0)*20|0)+12>>2]=0;da=ca+1|0;if((da|0)<(R|0))ca=da;else{fa=da;break}}}else fa=1;while(0);if((fa|0)==(R|0))break;ca=fa+-1|0;d:do if((R|0)>2){da=ea;ba=R+-2|0;while(1){if(!(f[w+(ba*20|0)+12>>2]|0)){ga=da;break d}f[w+(ba*20|0)+16>>2]=0;f[w+(da*20|0)+12>>2]=0;if((ba|0)>1){K=ba;ba=ba+-1|0;da=K}else{ga=ba;break}}}else ga=ea;while(0);if((ca|0)==0&(ga|0)==(ea|0)){ba=((f[w+16>>2]|0)-C|0)/20|0;da=w+(R*20|0)|0;f[da>>2]=f[w>>2];f[da+4>>2]=f[w+4>>2];f[da+8>>2]=f[w+8>>2];f[da+12>>2]=f[w+12>>2];f[da+16>>2]=f[w+16>>2];f[w+(R*20|0)+16>>2]=0;f[w+(ea*20|0)+16>>2]=da;ha=ba}else ha=ca;f[a>>2]=w+(ha*20|0)}ba=f[a>>2]|0;da=j;while(1){K=ba+16|0;e=f[K>>2]|0;e:do if(!e){ia=e;ja=1;ka=ba;la=K;ma=da}else{Q=e;W=1;S=ba;U=K;k=da;while(1){if((Q-S|0)!=20){ia=Q;ja=W;ka=S;la=U;ma=k;break e}T=W+1|0;V=Q+16|0;v=f[V>>2]|0;if(!v){ia=v;ja=T;ka=Q;la=V;ma=S;break}else{p=Q;Q=v;W=T;U=V;k=S;S=p}}}while(0);if((ja|0)>1){do if((ja|0)==2){K=f[ma+12>>2]|0;e=f[ka+12>>2]|0;if((K|0)<=(e|0)){if((K|0)!=(e|0)){na=ka;oa=da;break}if((f[ma+8>>2]|0)>(f[ka+8>>2]|0)){na=ka;oa=da;break}}na=ia;oa=ma}else{na=ka;oa=f[da+16>>2]|0}while(0);f[oa+16>>2]=na;pa=f[la>>2]|0}else pa=ia;if(!pa)break;else{ba=pa;da=ka}}}while(0);ka=l+12|0;pa=l+20|0;ia=f[ka>>2]|0;la=f[a>>2]|0;do{if(ia>>>0<(f[pa>>2]|0)>>>0)qa=ia;else{JL(l);qa=f[ka>>2]|0}a=la;na=a;oa=h[na>>0]|h[na+1>>0]<<8|h[na+2>>0]<<16|h[na+3>>0]<<24;na=a+4|0;a=h[na>>0]|h[na+1>>0]<<8|h[na+2>>0]<<16|h[na+3>>0]<<24;na=qa;ma=na;b[ma>>0]=oa;b[ma+1>>0]=oa>>8;b[ma+2>>0]=oa>>16;b[ma+3>>0]=oa>>24;oa=na+4|0;b[oa>>0]=a;b[oa+1>>0]=a>>8;b[oa+2>>0]=a>>16;b[oa+3>>0]=a>>24;ia=(f[ka>>2]|0)+8|0;f[ka>>2]=ia;la=f[la+16>>2]|0}while((la|0)!=0)}}else{la=l+12|0;ia=f[la>>2]|0;if(ia>>>0<(f[l+20>>2]|0)>>>0)ra=ia;else{JL(l);ra=f[la>>2]|0}ia=ra;ra=ia;b[ra>>0]=x;b[ra+1>>0]=x>>8;b[ra+2>>0]=x>>16;b[ra+3>>0]=x>>24;x=ia+4|0;b[x>>0]=y;b[x+1>>0]=y>>8;b[x+2>>0]=y>>16;b[x+3>>0]=y>>24;f[la>>2]=(f[la>>2]|0)+8}la=IL(l)|0;l=f[i>>2]|0;if((l|0)==(q|0)){u=g;return la|0}if(l|0)QYa(l);f[i>>2]=q;f[r>>2]=59;u=g;return la|0}function k1(a,c,d,e){a=a|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+2320|0;h=g+2312|0;i=g+2256|0;j=g+1160|0;k=g+64|0;l=g;m=g+8|0;_$(h,45180);do if((NS(a)|0)==65536){n=f[a+4>>2]|0;f[i>>2]=f[n>>2];o=i+4|0;p=n+4|0;f[o>>2]=f[p>>2];q=i+8|0;f[q>>2]=f[n+8>>2];f[i+12>>2]=f[n+12>>2];f[i+16>>2]=f[n+16>>2];f[i+20>>2]=f[n+20>>2];f[i+24>>2]=f[n+24>>2];f[i+28>>2]=f[n+28>>2];f[i+32>>2]=f[n+32>>2];r=f[n+36>>2]|0;f[i+36>>2]=r;f[i+40>>2]=q;q=i+48|0;s=i+44|0;f[s>>2]=q;f[q>>2]=0;f[i+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[n+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[o>>2]=0;BR(i,n);break}}else OR(i,a,-1);while(0);a=LS(i,2,-1,1)|0;n=f[i>>2]|0;o=n&7;if(!((a|0)>-1&(o|1|0)==5)){f[j>>2]=0;f[j+4>>2]=0;p=c$(j,42)|0;q=204208;s=p+42|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(s|0));j$(-215,j,204251,204119,682);d$(j)}if(a){q=j+8|0;F1a(q|0,0,1088)|0;f[j>>2]=q;p=j+4|0;s=a>>>0>136;f[p>>2]=a;if(s){r=OYa(a>>>0>536870911?-1:a<<3)|0;F1a(r|0,0,a<<3|0)|0;f[j>>2]=r;t=r}else t=q;r=k+8|0;F1a(r|0,0,1088)|0;f[k>>2]=r;v=k+4|0;f[v>>2]=a;if(s){s=OYa(a>>>0>536870911?-1:a<<3)|0;F1a(s|0,0,a<<3|0)|0;f[k>>2]=s}switch(n&7){case 4:{w=l1(f[i+16>>2]|0,a,t,e,d,k)|0;break}case 5:{w=m1(f[i+16>>2]|0,a,t,e,d,k)|0;break}default:{f[l>>2]=0;f[l+4>>2]=0;j$(-210,l,204251,204119,700);d$(l);w=0}}$i(m,w,1,o|8,t,0);eL(m,c);t=m+36|0;o=f[t>>2]|0;if(o|0?(w=o+12|0,o=f[w>>2]|0,f[w>>2]=o+-1,(o|0)==1):0)CR(m);f[t>>2]=0;t=m+16|0;o=m+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[o>>2]|0)>0){t=f[m+40>>2]|0;w=0;do{f[t+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[o>>2]|0))}o=f[m+44>>2]|0;if((o|0)!=(m+48|0))ZF(o);o=f[k>>2]|0;if((o|0)!=(r|0)){if(o|0)QYa(o);f[k>>2]=r;f[v>>2]=136}v=f[j>>2]|0;if((v|0)!=(q|0)){if(v|0)QYa(v);f[j>>2]=q;f[p>>2]=136}}else oS(c);c=i+36|0;p=f[c>>2]|0;if(p|0?(q=p+12|0,p=f[q>>2]|0,f[q>>2]=p+-1,(p|0)==1):0)CR(i);f[c>>2]=0;c=i+16|0;p=i+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){c=f[i+40>>2]|0;q=0;do{f[c+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[p>>2]|0))}p=f[i+44>>2]|0;if((p|0)!=(i+48|0))ZF(p);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function l1(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;h=g+4|0;i=f[h>>2]|0;j=f[g>>2]|0;if(!b){k=0;return k|0}l=e*e;if(!d){m=b+-1|0;if((f[a+(m<<3)>>2]|0)==(f[a>>2]|0)?(f[a+(m<<3)+4>>2]|0)==(f[a+4>>2]|0):0){n=1;o=7}else{if(!i){f[h>>2]=0;p=0}else p=i;q=j;f[q>>2]=0;f[q+4>>2]=m;r=b;s=j;t=p;u=0;v=1;o=41}}else{n=3;o=7}do if((o|0)==7){if((b|0)>1){p=0;m=0;q=0;while(1){w=(m+q|0)%(b|0)|0;x=f[a+(w<<3)>>2]|0;y=f[a+(w<<3)+4>>2]|0;z=w+1|0;w=1;e=0.0;A=(z|0)>=(b|0)?0:z;z=q;do{B=A+1|0;C=A;A=(B|0)>=(b|0)?0:B;D=+((f[a+(C<<3)>>2]|0)-x|0);E=+((f[a+(C<<3)+4>>2]|0)-y|0);F=D*D+E*E;C=F>e;z=C?w:z;e=C?F:e;w=w+1|0}while((w|0)!=(b|0));p=p+1|0;if((p|0)>=(n|0)){G=e;H=A;I=z;J=x;K=y;break}else{m=A;q=z}}}else{q=0;m=0;do{M=(m|0)%(b|0)|0;p=M+1|0;m=(p|0)>=(b|0)?0:p;q=q+1|0}while((q|0)<(n|0));G=0.0;H=m;I=0;J=f[a+(M<<3)>>2]|0;K=f[a+(M<<3)+4>>2]|0}if(G<=l){f[c>>2]=J;f[c+4>>2]=K;N=1;break}q=(H|0)%(b|0)|0;p=(q+I|0)%(b|0)|0;if(!i){w=(i*3|0)>>>1;C=f[h>>2]|0;if(C>>>0<w>>>0){B=f[g>>2]|0;O=g+8|0;f[g>>2]=O;f[h>>2]=w;if((C|0)!=0&(O|0)!=(B|0)){P=B;Q=f[P+4>>2]|0;R=O;f[R>>2]=f[P>>2];f[R+4>>2]=Q;if((C|0)!=1){Q=B+8|0;R=f[Q+4>>2]|0;P=g+16|0;f[P>>2]=f[Q>>2];f[P+4>>2]=R;if((C|0)==2)S=C;else{R=2;do{P=B+(R<<3)|0;Q=f[P+4>>2]|0;O=(f[g>>2]|0)+(R<<3)|0;f[O>>2]=f[P>>2];f[O+4>>2]=Q;R=R+1|0}while((R|0)!=(C|0));S=C}}else S=1}else S=C;do{R=(f[g>>2]|0)+(S<<3)|0;f[R>>2]=0;f[R+4>>2]=0;S=S+1|0}while((S|0)!=(w|0));if(!((B|0)==(g+8|0)|(B|0)==0))QYa(B)}else f[h>>2]=w;T=f[g>>2]|0;U=f[h>>2]|0}else{T=j;U=i}C=T;f[C>>2]=p;f[C+4>>2]=q;if(U>>>0>1){V=T;W=U}else{C=U*3|0;R=C>>>1;m=f[h>>2]|0;if(m>>>0<R>>>0){Q=f[g>>2]|0;if(C>>>0>273){C=OYa(R>>>0>536870911?-1:R<<3)|0;F1a(C|0,0,R<<3|0)|0;X=C}else X=g+8|0;f[g>>2]=X;f[h>>2]=R;if((m|0)!=0&(X|0)!=(Q|0)){C=Q;O=f[C+4>>2]|0;P=X;f[P>>2]=f[C>>2];f[P+4>>2]=O;if((m|0)!=1){O=Q+8|0;P=f[O+4>>2]|0;C=X+8|0;f[C>>2]=f[O>>2];f[C+4>>2]=P;if((m|0)==2)Z=m;else{P=2;do{C=Q+(P<<3)|0;O=f[C+4>>2]|0;_=(f[g>>2]|0)+(P<<3)|0;f[_>>2]=f[C>>2];f[_+4>>2]=O;P=P+1|0}while((P|0)!=(m|0));Z=m}}else Z=1}else Z=m;do{P=(f[g>>2]|0)+(Z<<3)|0;f[P>>2]=0;f[P+4>>2]=0;Z=Z+1|0}while((Z|0)!=(R|0));if(!((Q|0)==(g+8|0)|(Q|0)==0))QYa(Q)}else f[h>>2]=R;V=f[g>>2]|0;W=f[h>>2]|0}m=V+8|0;f[m>>2]=q;f[m+4>>2]=p;r=p;s=V;t=W;u=1;v=2;o=41}while(0);if((o|0)==41){o=b+-1|0;W=g+8|0;V=0;Z=r;r=s;s=t;t=v;a:while(1){v=V;X=Z;U=t;while(1){$=U+-1|0;T=r+($<<3)|0;aa=f[T>>2]|0;ba=f[T+4>>2]|0;T=f[a+(aa<<3)>>2]|0;i=f[a+(aa<<3)+4>>2]|0;j=aa+1|0;S=(j|0)>=(b|0)?0:j;if((S|0)!=(ba|0)){G=+((f[a+(ba<<3)>>2]|0)-T|0);F=+((f[a+(ba<<3)+4>>2]|0)-i|0);E=0.0;j=S;ca=X;b:while(1){S=j;do{if((S|0)==(ba|0))break b;I=S+1|0;H=S;S=(I|0)>=(b|0)?0:I;da=+L(+(G*+((f[a+(H<<3)+4>>2]|0)-i|0)-F*+((f[a+(H<<3)>>2]|0)-T|0)))}while(!(da>E));E=da;j=S;ca=(o+S|0)%(b|0)|0}if(!(E*E<=l*(F*F+G*G)))break;else ea=ca}else ea=X;j=v+1|0;f[c+(v<<3)>>2]=T;f[c+(v<<3)+4>>2]=i;if(!$){fa=j;break a}else{v=j;X=ea;U=$}}if($>>>0<s>>>0){ga=r;ha=s}else{X=s*3|0;p=X>>>1;q=f[h>>2]|0;if(q>>>0<p>>>0){R=f[g>>2]|0;if(X>>>0>273){X=OYa(p>>>0>536870911?-1:p<<3)|0;F1a(X|0,0,p<<3|0)|0;ia=X}else ia=W;f[g>>2]=ia;f[h>>2]=p;if((q|0)!=0&(ia|0)!=(R|0)){X=R;Q=f[X+4>>2]|0;j=ia;f[j>>2]=f[X>>2];f[j+4>>2]=Q;if((q|0)!=1){Q=R+8|0;j=f[Q+4>>2]|0;X=ia+8|0;f[X>>2]=f[Q>>2];f[X+4>>2]=j;if((q|0)==2)ja=q;else{j=2;do{X=R+(j<<3)|0;Q=f[X+4>>2]|0;z=(f[g>>2]|0)+(j<<3)|0;f[z>>2]=f[X>>2];f[z+4>>2]=Q;j=j+1|0}while((j|0)!=(q|0));ja=q}}else ja=1}else ja=q;do{j=(f[g>>2]|0)+(ja<<3)|0;f[j>>2]=0;f[j+4>>2]=0;ja=ja+1|0}while((ja|0)!=(p|0));if(!((R|0)==(W|0)|(R|0)==0))QYa(R)}else f[h>>2]=p;ga=f[g>>2]|0;ha=f[h>>2]|0}q=ga+($<<3)|0;f[q>>2]=ca;f[q+4>>2]=ba;if(U>>>0<ha>>>0){ka=ga;la=ha}else{q=ha*3|0;j=q>>>1;Q=f[h>>2]|0;if(Q>>>0<j>>>0){z=f[g>>2]|0;if(q>>>0>273){q=OYa(j>>>0>536870911?-1:j<<3)|0;F1a(q|0,0,j<<3|0)|0;ma=q}else ma=W;f[g>>2]=ma;f[h>>2]=j;if((Q|0)!=0&(ma|0)!=(z|0)){q=z;X=f[q+4>>2]|0;A=ma;f[A>>2]=f[q>>2];f[A+4>>2]=X;if((Q|0)!=1){X=z+8|0;A=f[X+4>>2]|0;q=ma+8|0;f[q>>2]=f[X>>2];f[q+4>>2]=A;if((Q|0)==2)na=Q;else{A=2;do{q=z+(A<<3)|0;X=f[q+4>>2]|0;y=(f[g>>2]|0)+(A<<3)|0;f[y>>2]=f[q>>2];f[y+4>>2]=X;A=A+1|0}while((A|0)!=(Q|0));na=Q}}else na=1}else na=Q;do{A=(f[g>>2]|0)+(na<<3)|0;f[A>>2]=0;f[A+4>>2]=0;na=na+1|0}while((na|0)!=(j|0));if(!((z|0)==(W|0)|(z|0)==0))QYa(z)}else f[h>>2]=j;ka=f[g>>2]|0;la=f[h>>2]|0}t=U+1|0;Q=ka+(U<<3)|0;f[Q>>2]=aa;f[Q+4>>2]=ca;if(!t){fa=v;break}else{V=v;Z=ca;r=ka;s=la}}if(u)N=fa;else{f[c+(fa<<3)>>2]=f[a+(o<<3)>>2];f[c+(fa<<3)+4>>2]=f[a+(o<<3)+4>>2];N=fa+1|0}}fa=d?N+-1|0:0;o=fa+1|0;a=(o|0)>=(N|0)?0:o;o=f[c+(a<<3)>>2]|0;u=f[c+(a<<3)+4>>2]|0;la=a+1|0;s=(d^1)&1;ka=N-s|0;if((N|0)>2&(s|0)<(ka|0)){da=l*.5;r=s;s=N;ca=(la|0)>=(N|0)?0:la;la=o;Z=u;V=f[c+(fa<<3)>>2]|0;t=f[c+(fa<<3)+4>>2]|0;fa=a;while(1){aa=f[c+(ca<<3)>>2]|0;h=f[c+(ca<<3)+4>>2]|0;g=ca+1|0;W=(g|0)>=(N|0)?0:g;g=aa-V|0;l=+(g|0);na=h-t|0;e=+(na|0);ma=la-V|0;ha=Z-t|0;D=+L(+(+(ma|0)*e-+(ha|0)*l));if(((Y(h-Z|0,ha)|0)+(Y(aa-la|0,ma)|0)|0)>-1&((na|0)!=0&(g|0?D*D<=da*(l*l+e*e):0))){f[c+(fa<<3)>>2]=aa;f[c+(fa<<3)+4>>2]=h;g=fa+1|0;na=W+1|0;oa=r+1|0;pa=s+-1|0;qa=(na|0)>=(N|0)?0:na;ra=f[c+(W<<3)>>2]|0;sa=f[c+(W<<3)+4>>2]|0;ta=aa;ua=h;va=(g|0)>=(N|0)?0:g}else{f[c+(fa<<3)>>2]=la;f[c+(fa<<3)+4>>2]=Z;g=fa+1|0;oa=r;pa=s;qa=W;ra=aa;sa=h;ta=la;ua=Z;va=(g|0)>=(N|0)?0:g}r=oa+1|0;if(!((pa|0)>2&(r|0)<(ka|0))){wa=pa;xa=ra;ya=sa;za=va;break}else{s=pa;ca=qa;la=ra;Z=sa;V=ta;t=ua;fa=va}}}else{wa=N;xa=o;ya=u;za=a}if(d){k=wa;return k|0}f[c+(za<<3)>>2]=xa;f[c+(za<<3)+4>>2]=ya;k=wa;return k|0}function m1(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0,r=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0;h=g+4|0;i=f[h>>2]|0;j=f[g>>2]|0;if(!b){k=0;return k|0}l=e*e;do if(d){m=3;o=8}else{p=b+-1|0;if(!(+n[a+(p<<3)>>2]!=+n[a>>2])?!(+n[a+(p<<3)+4>>2]!=+n[a+4>>2]):0){m=1;o=8;break}if(!i){f[h>>2]=0;q=0}else q=i;r=j;f[r>>2]=0;f[r+4>>2]=p;t=b;u=j;v=q;w=0;x=1;o=42}while(0);do if((o|0)==8){if((b|0)>1){q=0;p=0;r=0;while(1){y=(p+r|0)%(b|0)|0;z=f[a+(y<<3)>>2]|0;A=f[a+(y<<3)+4>>2]|0;B=y+1|0;e=(f[s>>2]=z,+n[s>>2]);C=(f[s>>2]=A,+n[s>>2]);y=1;D=0.0;E=(B|0)>=(b|0)?0:B;B=r;do{F=E+1|0;G=E;E=(F|0)>=(b|0)?0:F;H=+n[a+(G<<3)>>2]-e;I=+n[a+(G<<3)+4>>2]-C;J=H*H+I*I;G=J>D;B=G?y:B;D=G?J:D;y=y+1|0}while((y|0)!=(b|0));q=q+1|0;if((q|0)>=(m|0)){K=D;M=E;N=B;O=z;P=A;break}else{p=E;r=B}}}else{r=0;p=0;do{Q=(p|0)%(b|0)|0;q=Q+1|0;p=(q|0)>=(b|0)?0:q;r=r+1|0}while((r|0)<(m|0));K=0.0;M=p;N=0;O=f[a+(Q<<3)>>2]|0;P=f[a+(Q<<3)+4>>2]|0}if(K<=l){f[c>>2]=O;f[c+4>>2]=P;R=1;break}r=(M|0)%(b|0)|0;q=(r+N|0)%(b|0)|0;if(!i){y=(i*3|0)>>>1;G=f[h>>2]|0;if(G>>>0<y>>>0){F=f[g>>2]|0;S=g+8|0;f[g>>2]=S;f[h>>2]=y;if((G|0)!=0&(S|0)!=(F|0)){T=F;U=f[T+4>>2]|0;V=S;f[V>>2]=f[T>>2];f[V+4>>2]=U;if((G|0)!=1){U=F+8|0;V=f[U+4>>2]|0;T=g+16|0;f[T>>2]=f[U>>2];f[T+4>>2]=V;if((G|0)==2)W=G;else{V=2;do{T=F+(V<<3)|0;U=f[T+4>>2]|0;S=(f[g>>2]|0)+(V<<3)|0;f[S>>2]=f[T>>2];f[S+4>>2]=U;V=V+1|0}while((V|0)!=(G|0));W=G}}else W=1}else W=G;do{V=(f[g>>2]|0)+(W<<3)|0;f[V>>2]=0;f[V+4>>2]=0;W=W+1|0}while((W|0)!=(y|0));if(!((F|0)==(g+8|0)|(F|0)==0))QYa(F)}else f[h>>2]=y;X=f[g>>2]|0;Y=f[h>>2]|0}else{X=j;Y=i}G=X;f[G>>2]=q;f[G+4>>2]=r;if(Y>>>0>1){Z=X;_=Y}else{G=Y*3|0;V=G>>>1;p=f[h>>2]|0;if(p>>>0<V>>>0){U=f[g>>2]|0;if(G>>>0>273){G=OYa(V>>>0>536870911?-1:V<<3)|0;F1a(G|0,0,V<<3|0)|0;$=G}else $=g+8|0;f[g>>2]=$;f[h>>2]=V;if((p|0)!=0&($|0)!=(U|0)){G=U;S=f[G+4>>2]|0;T=$;f[T>>2]=f[G>>2];f[T+4>>2]=S;if((p|0)!=1){S=U+8|0;T=f[S+4>>2]|0;G=$+8|0;f[G>>2]=f[S>>2];f[G+4>>2]=T;if((p|0)==2)aa=p;else{T=2;do{G=U+(T<<3)|0;S=f[G+4>>2]|0;ba=(f[g>>2]|0)+(T<<3)|0;f[ba>>2]=f[G>>2];f[ba+4>>2]=S;T=T+1|0}while((T|0)!=(p|0));aa=p}}else aa=1}else aa=p;do{T=(f[g>>2]|0)+(aa<<3)|0;f[T>>2]=0;f[T+4>>2]=0;aa=aa+1|0}while((aa|0)!=(V|0));if(!((U|0)==(g+8|0)|(U|0)==0))QYa(U)}else f[h>>2]=V;Z=f[g>>2]|0;_=f[h>>2]|0}p=Z+8|0;f[p>>2]=r;f[p+4>>2]=q;t=q;u=Z;v=_;w=1;x=2;o=42}while(0);if((o|0)==42){o=b+-1|0;_=g+8|0;Z=0;aa=t;t=u;u=v;v=x;a:while(1){x=Z;$=aa;Y=v;while(1){ca=Y+-1|0;X=t+(ca<<3)|0;da=f[X>>2]|0;ea=f[X+4>>2]|0;X=f[a+(da<<3)>>2]|0;i=f[a+(da<<3)+4>>2]|0;j=da+1|0;W=(j|0)>=(b|0)?0:j;if((W|0)!=(ea|0)){K=(f[s>>2]=X,+n[s>>2]);C=+n[a+(ea<<3)>>2]-K;e=(f[s>>2]=i,+n[s>>2]);J=+n[a+(ea<<3)+4>>2]-e;I=0.0;j=W;fa=$;b:while(1){W=j;do{if((W|0)==(ea|0))break b;N=W+1|0;M=W;W=(N|0)>=(b|0)?0:N;ga=+L(+(C*(+n[a+(M<<3)+4>>2]-e)-J*(+n[a+(M<<3)>>2]-K)))}while(!(ga>I));I=ga;j=W;fa=(o+W|0)%(b|0)|0}if(!(I*I<=l*(J*J+C*C)))break;else ha=fa}else ha=$;j=x+1|0;f[c+(x<<3)>>2]=X;f[c+(x<<3)+4>>2]=i;if(!ca){ia=j;break a}else{x=j;$=ha;Y=ca}}if(ca>>>0<u>>>0){ja=t;ka=u}else{$=u*3|0;q=$>>>1;r=f[h>>2]|0;if(r>>>0<q>>>0){V=f[g>>2]|0;if($>>>0>273){$=OYa(q>>>0>536870911?-1:q<<3)|0;F1a($|0,0,q<<3|0)|0;la=$}else la=_;f[g>>2]=la;f[h>>2]=q;if((r|0)!=0&(la|0)!=(V|0)){$=V;U=f[$+4>>2]|0;j=la;f[j>>2]=f[$>>2];f[j+4>>2]=U;if((r|0)!=1){U=V+8|0;j=f[U+4>>2]|0;$=la+8|0;f[$>>2]=f[U>>2];f[$+4>>2]=j;if((r|0)==2)ma=r;else{j=2;do{$=V+(j<<3)|0;U=f[$+4>>2]|0;B=(f[g>>2]|0)+(j<<3)|0;f[B>>2]=f[$>>2];f[B+4>>2]=U;j=j+1|0}while((j|0)!=(r|0));ma=r}}else ma=1}else ma=r;do{j=(f[g>>2]|0)+(ma<<3)|0;f[j>>2]=0;f[j+4>>2]=0;ma=ma+1|0}while((ma|0)!=(q|0));if(!((V|0)==(_|0)|(V|0)==0))QYa(V)}else f[h>>2]=q;ja=f[g>>2]|0;ka=f[h>>2]|0}r=ja+(ca<<3)|0;f[r>>2]=fa;f[r+4>>2]=ea;if(Y>>>0<ka>>>0){na=ja;oa=ka}else{r=ka*3|0;j=r>>>1;U=f[h>>2]|0;if(U>>>0<j>>>0){B=f[g>>2]|0;if(r>>>0>273){r=OYa(j>>>0>536870911?-1:j<<3)|0;F1a(r|0,0,j<<3|0)|0;pa=r}else pa=_;f[g>>2]=pa;f[h>>2]=j;if((U|0)!=0&(pa|0)!=(B|0)){r=B;$=f[r+4>>2]|0;E=pa;f[E>>2]=f[r>>2];f[E+4>>2]=$;if((U|0)!=1){$=B+8|0;E=f[$+4>>2]|0;r=pa+8|0;f[r>>2]=f[$>>2];f[r+4>>2]=E;if((U|0)==2)qa=U;else{E=2;do{r=B+(E<<3)|0;$=f[r+4>>2]|0;A=(f[g>>2]|0)+(E<<3)|0;f[A>>2]=f[r>>2];f[A+4>>2]=$;E=E+1|0}while((E|0)!=(U|0));qa=U}}else qa=1}else qa=U;do{E=(f[g>>2]|0)+(qa<<3)|0;f[E>>2]=0;f[E+4>>2]=0;qa=qa+1|0}while((qa|0)!=(j|0));if(!((B|0)==(_|0)|(B|0)==0))QYa(B)}else f[h>>2]=j;na=f[g>>2]|0;oa=f[h>>2]|0}v=Y+1|0;U=na+(Y<<3)|0;f[U>>2]=da;f[U+4>>2]=fa;if(!v){ia=x;break}else{Z=x;aa=fa;t=na;u=oa}}if(w)R=ia;else{f[c+(ia<<3)>>2]=f[a+(o<<3)>>2];f[c+(ia<<3)+4>>2]=f[a+(o<<3)+4>>2];R=ia+1|0}}ia=d?R+-1|0:0;o=ia+1|0;a=(o|0)>=(R|0)?0:o;o=f[c+(a<<3)>>2]|0;w=f[c+(a<<3)+4>>2]|0;oa=a+1|0;u=(d^1)&1;na=R-u|0;if((R|0)>2&(u|0)<(na|0)){ga=l*.5;t=u;u=R;fa=(oa|0)>=(R|0)?0:oa;oa=o;aa=w;Z=f[c+(ia<<3)>>2]|0;v=f[c+(ia<<3)+4>>2]|0;ia=a;while(1){da=f[c+(fa<<3)>>2]|0;h=f[c+(fa<<3)+4>>2]|0;g=fa+1|0;_=(g|0)>=(R|0)?0:g;l=(f[s>>2]=da,+n[s>>2]);K=(f[s>>2]=Z,+n[s>>2]);e=l-K;D=e;H=(f[s>>2]=h,+n[s>>2]);ra=(f[s>>2]=v,+n[s>>2]);sa=H-ra;ta=sa;ua=(f[s>>2]=oa,+n[s>>2]);va=ua-K;K=(f[s>>2]=aa,+n[s>>2]);wa=K-ra;ra=+L(+(va*ta-wa*D));if(va*(l-ua)+wa*(H-K)>=0.0&(sa!=0.0&(e!=0.0?ra*ra<=ga*(D*D+ta*ta):0))){f[c+(ia<<3)>>2]=da;f[c+(ia<<3)+4>>2]=h;g=ia+1|0;qa=_+1|0;xa=t+1|0;ya=u+-1|0;za=(qa|0)>=(R|0)?0:qa;Aa=f[c+(_<<3)>>2]|0;Ba=f[c+(_<<3)+4>>2]|0;Ca=da;Da=h;Ea=(g|0)>=(R|0)?0:g}else{f[c+(ia<<3)>>2]=oa;f[c+(ia<<3)+4>>2]=aa;g=ia+1|0;xa=t;ya=u;za=_;Aa=da;Ba=h;Ca=oa;Da=aa;Ea=(g|0)>=(R|0)?0:g}t=xa+1|0;if(!((ya|0)>2&(t|0)<(na|0))){Fa=ya;Ga=Aa;Ha=Ba;Ia=Ea;break}else{u=ya;fa=za;oa=Aa;aa=Ba;Z=Ca;v=Da;ia=Ea}}}else{Fa=R;Ga=o;Ha=w;Ia=a}if(d){k=Fa;return k|0}f[c+(Ia<<3)>>2]=Ga;f[c+(Ia<<3)+4>>2]=Ha;k=Fa;return k|0}function n1(a,c,d,e,g,h){a=a|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;i=u;u=u+304|0;j=i+288|0;k=i+280|0;l=i+216|0;m=i+272|0;n=i+160|0;o=i+104|0;p=i+80|0;q=i+72|0;r=i+24|0;s=i+16|0;t=i;_$(j,45200);if(VS(a,-1)|0){f[k>>2]=0;f[k+4>>2]=0;v=c$(k,17)|0;w=204325;x=v+17|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-215,k,204343,204349,971);d$(k)}QR(k,a,-1);y=c+4|0;z=a+4|0;if((f[y>>2]|0)==(f[z>>2]|0)?RR(a,-1)|0:0){f[l>>2]=0;f[l+4>>2]=0;K1a(c$(l,134)|0,204399,134)|0;j$(-215,l,204343,204349,976);d$(l)}f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2];KS(c,m,0,-1,0,0);m=(g|0)<0&(h^1);k=m|h;h=m?g&2147483647:g;if(!(h&1))A=8;else switch(h|0){case 3:case 4:case 5:case 6:case 7:case -1:break;default:A=8}if((A|0)==8){f[l>>2]=0;f[l+4>>2]=0;v=c$(l,43)|0;w=204534;x=v+43|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-206,l,204343,204349,988);d$(l)}w=d>e;B=w?d:e;C=w?e:d;do if((NS(a)|0)==65536){w=f[z>>2]|0;f[l>>2]=f[w>>2];A=l+4|0;g=w+4|0;f[A>>2]=f[g>>2];m=l+8|0;f[m>>2]=f[w+8>>2];f[l+12>>2]=f[w+12>>2];f[l+16>>2]=f[w+16>>2];f[l+20>>2]=f[w+20>>2];f[l+24>>2]=f[w+24>>2];f[l+28>>2]=f[w+28>>2];f[l+32>>2]=f[w+32>>2];D=f[w+36>>2]|0;f[l+36>>2]=D;f[l+40>>2]=m;m=l+48|0;E=l+44|0;f[E>>2]=m;f[m>>2]=0;f[l+52>>2]=0;if(D|0){m=D+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[g>>2]|0)<3){g=f[w+44>>2]|0;m=f[E>>2]|0;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];break}else{f[A>>2]=0;BR(l,w);break}}else OR(l,a,-1);while(0);do if((NS(c)|0)==65536){a=f[y>>2]|0;f[n>>2]=f[a>>2];z=n+4|0;w=a+4|0;f[z>>2]=f[w>>2];A=n+8|0;f[A>>2]=f[a+8>>2];f[n+12>>2]=f[a+12>>2];f[n+16>>2]=f[a+16>>2];f[n+20>>2]=f[a+20>>2];f[n+24>>2]=f[a+24>>2];f[n+28>>2]=f[a+28>>2];f[n+32>>2]=f[a+32>>2];g=f[a+36>>2]|0;f[n+36>>2]=g;f[n+40>>2]=A;A=n+48|0;m=n+44|0;f[m>>2]=A;f[A>>2]=0;f[n+52>>2]=0;if(g|0){A=g+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[w>>2]|0)<3){w=f[a+44>>2]|0;A=f[m>>2]|0;f[A>>2]=f[w>>2];f[A+4>>2]=f[w+4>>2];break}else{f[z>>2]=0;BR(n,a);break}}else OR(n,c,-1);while(0);if(k){d=C<32767.0?C:32767.0;e=B<32767.0?B:32767.0;F=d>0.0?d*d:d;if(e>0.0){G=e*e;H=F}else{G=e;H=F}}else{G=B;H=C}c=~~H;y=c-(+(c|0)>H&1)|0;c=~~G;a=c-(+(c|0)>G&1)|0;c=$U()|0;z=bV()|0;w=(z|0)<(c|0)?z:c;c=(w|0)>1?w:1;w=l+8|0;z=f[w>>2]|0;A=(h|0)<0?4:(((h|0)/2|0)<<1)+2|0;if(((z|0)/(c|0)|0|0)<(A|0)){m=(z|0)/(A|0)|0;I=(m|0)>1?m:1}else I=c;f[o>>2]=1124007936;c=o+4|0;m=o+8|0;A=o+40|0;v=c;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[A>>2]=m;m=o+48|0;v=o+44|0;f[v>>2]=m;f[m>>2]=0;f[o+52>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[q>>2]=0;f[q+4>>2]=z;o1(r,l,o,p,y,a,h,k);_U(q,r,+(I|0));f[r>>2]=45228;V$(r+44|0);_$(q,45240);q=f[o+12>>2]|0;I=p+20|0;k=f[I>>2]|0;if(k|0){h=p+16|0;a=p+4|0;y=p+8|0;z=0-q|0;x=~q;g=1-q|0;E=q+-1|0;D=q+1|0;J=k;while(1){k=f[h>>2]|0;K=J+-1|0;L=k+K|0;M=f[a>>2]|0;N=f[(f[M+(L>>>10<<2)>>2]|0)+((L&1023)<<2)>>2]|0;f[I>>2]=K;K=f[y>>2]|0;L=K-M|0;if((1-J-k+((L|0)==0?0:(L<<8)+-1|0)|0)>>>0>2047){PYa(f[K+-4>>2]|0);f[y>>2]=(f[y>>2]|0)+-4}K=N+z|0;if(!(b[N+x>>0]|0)){L=K+-1|0;b[L>>0]=2;k=f[a>>2]|0;M=(f[y>>2]|0)-k|0;O=f[h>>2]|0;P=f[I>>2]|0;if((((M|0)==0?0:(M<<8)+-1|0)|0)==(P+O|0)){p1(p);Q=f[h>>2]|0;R=f[I>>2]|0;S=f[a>>2]|0}else{Q=O;R=P;S=k}k=R+Q|0;f[(f[S+(k>>>10<<2)>>2]|0)+((k&1023)<<2)>>2]=L;f[I>>2]=R+1}if(!(b[K>>0]|0)){b[K>>0]=2;L=f[a>>2]|0;k=(f[y>>2]|0)-L|0;P=f[h>>2]|0;O=f[I>>2]|0;if((((k|0)==0?0:(k<<8)+-1|0)|0)==(O+P|0)){p1(p);T=f[h>>2]|0;U=f[I>>2]|0;V=f[a>>2]|0}else{T=P;U=O;V=L}L=U+T|0;f[(f[V+(L>>>10<<2)>>2]|0)+((L&1023)<<2)>>2]=K;f[I>>2]=U+1}if(!(b[N+g>>0]|0)){K=N+z+1|0;b[K>>0]=2;L=f[a>>2]|0;O=(f[y>>2]|0)-L|0;P=f[h>>2]|0;k=f[I>>2]|0;if((((O|0)==0?0:(O<<8)+-1|0)|0)==(k+P|0)){p1(p);W=f[h>>2]|0;X=f[I>>2]|0;Z=f[a>>2]|0}else{W=P;X=k;Z=L}L=X+W|0;f[(f[Z+(L>>>10<<2)>>2]|0)+((L&1023)<<2)>>2]=K;f[I>>2]=X+1}K=N+-1|0;if(!(b[K>>0]|0)){b[K>>0]=2;L=f[a>>2]|0;k=(f[y>>2]|0)-L|0;P=f[h>>2]|0;O=f[I>>2]|0;if((((k|0)==0?0:(k<<8)+-1|0)|0)==(O+P|0)){p1(p);_=f[h>>2]|0;$=f[I>>2]|0;aa=f[a>>2]|0}else{_=P;$=O;aa=L}L=$+_|0;f[(f[aa+(L>>>10<<2)>>2]|0)+((L&1023)<<2)>>2]=K;f[I>>2]=$+1}K=N+1|0;if(!(b[K>>0]|0)){b[K>>0]=2;L=f[a>>2]|0;O=(f[y>>2]|0)-L|0;P=f[h>>2]|0;k=f[I>>2]|0;if((((O|0)==0?0:(O<<8)+-1|0)|0)==(k+P|0)){p1(p);ba=f[h>>2]|0;ca=f[I>>2]|0;da=f[a>>2]|0}else{ba=P;ca=k;da=L}L=ca+ba|0;f[(f[da+(L>>>10<<2)>>2]|0)+((L&1023)<<2)>>2]=K;f[I>>2]=ca+1}K=N+q|0;if(!(b[N+E>>0]|0)){L=K+-1|0;b[L>>0]=2;k=f[a>>2]|0;P=(f[y>>2]|0)-k|0;O=f[h>>2]|0;M=f[I>>2]|0;if((((P|0)==0?0:(P<<8)+-1|0)|0)==(M+O|0)){p1(p);ea=f[h>>2]|0;fa=f[I>>2]|0;ga=f[a>>2]|0}else{ea=O;fa=M;ga=k}k=fa+ea|0;f[(f[ga+(k>>>10<<2)>>2]|0)+((k&1023)<<2)>>2]=L;f[I>>2]=fa+1}if(!(b[K>>0]|0)){b[K>>0]=2;L=f[a>>2]|0;k=(f[y>>2]|0)-L|0;M=f[h>>2]|0;O=f[I>>2]|0;if((((k|0)==0?0:(k<<8)+-1|0)|0)==(O+M|0)){p1(p);ha=f[h>>2]|0;ia=f[I>>2]|0;ja=f[a>>2]|0}else{ha=M;ia=O;ja=L}L=ia+ha|0;f[(f[ja+(L>>>10<<2)>>2]|0)+((L&1023)<<2)>>2]=K;f[I>>2]=ia+1}if(!(b[N+D>>0]|0)){K=N+q+1|0;b[K>>0]=2;N=f[a>>2]|0;L=(f[y>>2]|0)-N|0;O=f[h>>2]|0;M=f[I>>2]|0;if((((L|0)==0?0:(L<<8)+-1|0)|0)==(M+O|0)){p1(p);ka=f[h>>2]|0;la=f[I>>2]|0;ma=f[a>>2]|0}else{ka=O;la=M;ma=N}N=la+ka|0;f[(f[ma+(N>>>10<<2)>>2]|0)+((N&1023)<<2)>>2]=K;K=la+1|0;f[I>>2]=K;na=K}else na=f[I>>2]|0;if(!na)break;else J=na}}_$(r,45260);r=f[w>>2]|0;f[s>>2]=0;f[s+4>>2]=r;f[t>>2]=45288;f[t+4>>2]=o;f[t+8>>2]=n;w=l+4|0;na=f[w>>2]|0;if((na|0)<3)oa=Y(f[l+12>>2]|0,r)|0;else{r=f[l+40>>2]|0;J=0;I=1;while(1){la=Y(f[r+(J<<2)>>2]|0,I)|0;J=J+1|0;if((J|0)==(na|0)){oa=la;break}else I=la}}_U(s,t,+(oa>>>0)*.0000152587890625);q1(p);p=o+36|0;oa=f[p>>2]|0;if(oa|0?(t=oa+12|0,oa=f[t>>2]|0,f[t>>2]=oa+-1,(oa|0)==1):0)CR(o);f[p>>2]=0;p=o+16|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[c>>2]|0)>0){p=f[A>>2]|0;A=0;do{f[p+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[c>>2]|0))}c=f[v>>2]|0;if((c|0)!=(m|0))ZF(c);c=n+36|0;m=f[c>>2]|0;if(m|0?(v=m+12|0,m=f[v>>2]|0,f[v>>2]=m+-1,(m|0)==1):0)CR(n);f[c>>2]=0;c=n+16|0;m=n+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[m>>2]|0)>0){c=f[n+40>>2]|0;v=0;do{f[c+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[m>>2]|0))}m=f[n+44>>2]|0;if((m|0)!=(n+48|0))ZF(m);m=l+36|0;n=f[m>>2]|0;if(n|0?(v=n+12|0,n=f[v>>2]|0,f[v>>2]=n+-1,(n|0)==1):0)CR(l);f[m>>2]=0;m=l+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[w>>2]|0)>0){m=f[l+40>>2]|0;n=0;do{f[m+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[w>>2]|0))}w=f[l+44>>2]|0;if((w|0)!=(l+48|0))ZF(w);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function o1(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=u;u=u+144|0;l=k+120|0;m=k;n=k+64|0;o=k+8|0;f[a>>2]=45228;q=a+4|0;f[q>>2]=c;f[a+8>>2]=c;c=a+12|0;f[c>>2]=d;f[a+16>>2]=e;f[a+20>>2]=g;f[a+24>>2]=h;f[a+28>>2]=i;b[a+32>>0]=j&1;U$(a+44|0);j=f[q>>2]|0;i=(f[j+8>>2]|0)+2|0;h=(f[j+12>>2]|0)+2|0;j=d+4|0;if(!(((((f[j>>2]|0)<3?(f[d+8>>2]|0)==(i|0):0)?(f[d+12>>2]|0)==(h|0):0)?(f[d>>2]&4095|0)==0:0)?(f[d+16>>2]|0)!=0:0)){f[l>>2]=i;f[l+4>>2]=h;AR(d,2,l,0)}h=f[c>>2]|0;if((h|0)==(d|0))r=d;else{i=d+36|0;g=f[i>>2]|0;if(g|0){e=g+12|0;f[e>>2]=(f[e>>2]|0)+1}e=h+36|0;g=f[e>>2]|0;if(g|0?(s=g+12|0,g=f[s>>2]|0,f[s>>2]=g+-1,(g|0)==1):0)CR(h);f[e>>2]=0;g=h+16|0;s=h+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[s>>2]|0)>0){t=f[h+40>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0;w=f[s>>2]|0}while((v|0)<(w|0));f[h>>2]=f[d>>2];if((w|0)<3)x=18;else x=20}else{f[h>>2]=f[d>>2];x=18}if((x|0)==18){w=f[j>>2]|0;if((w|0)<3){f[s>>2]=w;f[h+8>>2]=f[d+8>>2];f[h+12>>2]=f[d+12>>2];w=f[d+44>>2]|0;s=f[h+44>>2]|0;f[s>>2]=f[w>>2];f[s+4>>2]=f[w+4>>2]}else x=20}if((x|0)==20)BR(h,d);f[g>>2]=f[d+16>>2];f[h+20>>2]=f[d+20>>2];f[h+24>>2]=f[d+24>>2];f[h+28>>2]=f[d+28>>2];f[h+32>>2]=f[d+32>>2];f[e>>2]=f[i>>2];r=f[c>>2]|0}f[l>>2]=0;f[l+4>>2]=1;f[m>>2]=-2147483648;f[m+4>>2]=2147483647;DR(n,r,l,m);p[m>>3]=1.0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;hL(n,l,fT()|0)|0;r=n+36|0;i=f[r>>2]|0;if(i|0?(e=i+12|0,i=f[e>>2]|0,f[e>>2]=i+-1,(i|0)==1):0)CR(n);f[r>>2]=0;r=n+16|0;i=n+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[i>>2]|0)>0){r=f[n+40>>2]|0;e=0;do{f[r+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[i>>2]|0))}i=f[n+44>>2]|0;if((i|0)!=(n+48|0))ZF(i);i=f[c>>2]|0;n=f[(f[q>>2]|0)+8>>2]|0;f[l>>2]=n+1;f[l+4>>2]=n+2;f[m>>2]=-2147483648;f[m+4>>2]=2147483647;DR(o,i,l,m);p[m>>3]=1.0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;hL(o,l,fT()|0)|0;l=o+36|0;m=f[l>>2]|0;if(m|0?(i=m+12|0,m=f[i>>2]|0,f[i>>2]=m+-1,(m|0)==1):0)CR(o);f[l>>2]=0;l=o+16|0;m=o+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[m>>2]|0)>0){l=f[o+40>>2]|0;i=0;do{f[l+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[m>>2]|0))}m=f[o+44>>2]|0;if((m|0)==(o+48|0)){y=f[c>>2]|0;z=y+12|0;A=f[z>>2]|0;B=a+36|0;f[B>>2]=A;C=a+33|0;b[C>>0]=1;D=f[q>>2]|0;E=f[D>>2]|0;F=E>>>3;G=F&511;H=G+1|0;I=a+40|0;f[I>>2]=H;u=k;return}ZF(m);y=f[c>>2]|0;z=y+12|0;A=f[z>>2]|0;B=a+36|0;f[B>>2]=A;C=a+33|0;b[C>>0]=1;D=f[q>>2]|0;E=f[D>>2]|0;F=E>>>3;G=F&511;H=G+1|0;I=a+40|0;f[I>>2]=H;u=k;return}function p1(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;b=u;u=u+32|0;c=b;d=a+16|0;e=f[d>>2]|0;if(e>>>0>1023){f[d>>2]=e+-1024;e=a+4|0;d=f[e>>2]|0;g=f[d>>2]|0;h=d+4|0;f[e>>2]=h;d=a+8|0;i=f[d>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;m=i;do if((i|0)==(k|0)){n=f[a>>2]|0;o=n;if(h>>>0>n>>>0){p=h;q=((p-o>>2)+1|0)/-2|0;r=h+(q<<2)|0;s=m-p|0;p=s>>2;if(!p)t=h;else{M1a(r|0,h|0,s|0)|0;t=f[e>>2]|0}s=r+(p<<2)|0;f[d>>2]=s;f[e>>2]=t+(q<<2);v=s;break}s=l-o>>1;o=(s|0)==0?1:s;if(o>>>0>1073741823){s=De(8)|0;UYa(s,358155);f[s>>2]=130560;Of(s|0,21520,875)}s=NYa(o<<2)|0;q=s;p=s+(o>>>2<<2)|0;r=p;w=s+(o<<2)|0;if((h|0)==(i|0)){x=n;y=r}else{n=p;p=h;o=r;do{f[n>>2]=f[p>>2];n=o+4|0;o=n;p=p+4|0}while((p|0)!=(i|0));x=f[a>>2]|0;y=o}f[a>>2]=q;f[e>>2]=r;f[d>>2]=y;f[j>>2]=w;if(!x)v=y;else{PYa(x);v=f[d>>2]|0}}else v=i;while(0);f[v>>2]=g;f[d>>2]=(f[d>>2]|0)+4;u=b;return}d=a+8|0;g=f[d>>2]|0;v=a+4|0;i=f[v>>2]|0;x=g-i|0;y=a+12|0;j=f[y>>2]|0;e=f[a>>2]|0;h=j-e|0;l=g;t=j;m=i;k=e;if(x>>>0>=h>>>0){p=h>>1;n=(p|0)==0?1:p;f[c+12>>2]=0;f[c+16>>2]=a+12;if(n>>>0>1073741823){p=De(8)|0;UYa(p,358155);f[p>>2]=130560;Of(p|0,21520,875)}p=x>>2;s=NYa(n<<2)|0;f[c>>2]=s;z=s+(p<<2)|0;A=c+8|0;f[A>>2]=z;B=c+4|0;f[B>>2]=z;C=s+(n<<2)|0;D=c+12|0;f[D>>2]=C;E=s;F=NYa(4096)|0;G=C;C=z;do if((p|0)==(n|0)){if(z>>>0>s>>>0){H=z+((((C-E>>2)+1|0)/-2|0)<<2)|0;f[A>>2]=H;f[B>>2]=H;I=H;break}H=G-E>>1;J=(H|0)==0?1:H;if(J>>>0>1073741823){H=De(8)|0;UYa(H,358155);f[H>>2]=130560;Of(H|0,21520,875)}else{H=NYa(J<<2)|0;K=H+(J>>>2<<2)|0;L=K;f[c>>2]=H;f[B>>2]=L;f[A>>2]=L;f[D>>2]=H+(J<<2);PYa(s);I=K;break}}else I=z;while(0);f[I>>2]=F;f[A>>2]=(f[A>>2]|0)+4;F=f[d>>2]|0;while(1){M=f[v>>2]|0;if((F|0)==(M|0))break;I=F+-4|0;u1(c,I);F=I}I=M;M=f[a>>2]|0;f[a>>2]=f[c>>2];f[c>>2]=M;f[v>>2]=f[B>>2];f[B>>2]=I;B=f[d>>2]|0;f[d>>2]=f[A>>2];f[A>>2]=B;z=f[y>>2]|0;f[y>>2]=f[D>>2];f[D>>2]=z;z=B;if((z|0)!=(F|0))f[A>>2]=z+(~((z+-4-I|0)>>>2)<<2);if(M|0)PYa(M);u=b;return}if((j|0)==(g|0)){j=NYa(4096)|0;f[c>>2]=j;t1(a,c);c=f[v>>2]|0;j=f[c>>2]|0;M=c+4|0;f[v>>2]=M;c=f[d>>2]|0;I=f[y>>2]|0;z=I;A=c;do if((c|0)==(I|0)){F=f[a>>2]|0;B=F;if(M>>>0>F>>>0){D=M;s=((D-B>>2)+1|0)/-2|0;E=M+(s<<2)|0;G=A-D|0;D=G>>2;if(!D)N=M;else{M1a(E|0,M|0,G|0)|0;N=f[v>>2]|0}G=E+(D<<2)|0;f[d>>2]=G;f[v>>2]=N+(s<<2);O=G;break}G=z-B>>1;B=(G|0)==0?1:G;if(B>>>0>1073741823){G=De(8)|0;UYa(G,358155);f[G>>2]=130560;Of(G|0,21520,875)}G=NYa(B<<2)|0;s=G;D=G+(B>>>2<<2)|0;E=D;C=G+(B<<2)|0;if((M|0)==(c|0)){P=F;Q=E}else{F=D;D=M;B=E;do{f[F>>2]=f[D>>2];F=B+4|0;B=F;D=D+4|0}while((D|0)!=(c|0));P=f[a>>2]|0;Q=B}f[a>>2]=s;f[v>>2]=E;f[d>>2]=Q;f[y>>2]=C;if(!P)O=Q;else{PYa(P);O=f[d>>2]|0}}else O=c;while(0);f[O>>2]=j;f[d>>2]=(f[d>>2]|0)+4;u=b;return}else{j=NYa(4096)|0;O=g;do if((l|0)==(t|0)){if(m>>>0>k>>>0){g=((i-e>>2)+1|0)/-2|0;c=m+(g<<2)|0;P=x>>2;if(!P)R=m;else{M1a(c|0,i|0,x|0)|0;R=f[v>>2]|0}Q=c+(P<<2)|0;f[d>>2]=Q;f[v>>2]=R+(g<<2);S=Q;break}Q=h>>1;g=(Q|0)==0?1:Q;if(g>>>0>1073741823){Q=De(8)|0;UYa(Q,358155);f[Q>>2]=130560;Of(Q|0,21520,875)}Q=NYa(g<<2)|0;P=Q;c=Q+(g>>>2<<2)|0;M=c;z=Q+(g<<2)|0;if((m|0)==(l|0)){T=k;U=M}else{g=c;c=m;Q=M;do{f[g>>2]=f[c>>2];g=Q+4|0;Q=g;c=c+4|0}while((c|0)!=(l|0));T=f[a>>2]|0;U=Q}f[a>>2]=P;f[v>>2]=M;f[d>>2]=U;f[y>>2]=z;if(!T)S=U;else{PYa(T);S=f[d>>2]|0}}else S=O;while(0);f[S>>2]=j;f[d>>2]=(f[d>>2]|0)+4;u=b;return}}function q1(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=a+4|0;c=f[b>>2]|0;d=a+16|0;e=f[d>>2]|0;g=c+(e>>>10<<2)|0;h=a+8|0;i=f[h>>2]|0;j=i;k=c;if((i|0)==(c|0)){l=a+20|0;m=0;n=0}else{i=a+20|0;o=(f[i>>2]|0)+e|0;l=i;m=(f[c+(o>>>10<<2)>>2]|0)+((o&1023)<<2)|0;n=(f[g>>2]|0)+((e&1023)<<2)|0}e=g;g=n;a:while(1){n=g;do{o=n;if((o|0)==(m|0))break a;n=o+4|0}while((n-(f[e>>2]|0)|0)!=4096);n=e+4|0;e=n;g=f[n>>2]|0}f[l>>2]=0;l=j-k>>2;if(l>>>0>2){k=c;do{PYa(f[k>>2]|0);k=(f[b>>2]|0)+4|0;f[b>>2]=k;c=(f[h>>2]|0)-k>>2}while(c>>>0>2);p=c}else p=l;switch(p|0){case 1:{q=512;r=13;break}case 2:{q=1024;r=13;break}default:{}}if((r|0)==13)f[d>>2]=q;q=f[b>>2]|0;d=f[h>>2]|0;if((q|0)!=(d|0)){r=q;do{PYa(f[r>>2]|0);r=r+4|0}while((r|0)!=(d|0));d=f[b>>2]|0;b=f[h>>2]|0;if((b|0)!=(d|0))f[h>>2]=b+(~((b+-4-d|0)>>>2)<<2)}d=f[a>>2]|0;if(!d)return;PYa(d);return}function r1(a){a=a|0;PYa(a);return}function s1(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=f[c>>2]|0;e=c+4|0;c=f[e>>2]|0;if((d|0)>=(c|0))return;g=a+8|0;i=a+4|0;a=c;c=d;d=f[g>>2]|0;while(1){j=(f[d+16>>2]|0)+(Y(f[f[d+44>>2]>>2]|0,c)|0)|0;k=f[i>>2]|0;c=c+1|0;l=(f[k+16>>2]|0)+(Y(f[f[k+44>>2]>>2]|0,c)|0)+1|0;if((f[d+12>>2]|0)>0){k=0;do{b[j+k>>0]=0-((h[l+k>>0]|0)>>>1);k=k+1|0;m=f[g>>2]|0}while((k|0)<(f[m+12>>2]|0));n=f[e>>2]|0;o=m}else{n=a;o=d}if((c|0)>=(n|0))break;else{a=n;d=o}}return}function t1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=e;do if((d|0)==(e|0)){h=a+8|0;i=f[h>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;if(i>>>0<k>>>0){k=i;m=((l-k>>2)+1|0)/2|0;n=i+(m<<2)|0;o=k-d|0;k=o>>2;p=n+(0-k<<2)|0;if(!k){q=i;r=n}else{M1a(p|0,d|0,o|0)|0;q=f[h>>2]|0;r=p}f[c>>2]=r;f[h>>2]=q+(m<<2);s=r;break}m=l-g>>1;l=(m|0)==0?1:m;if(l>>>0>1073741823){m=De(8)|0;UYa(m,358155);f[m>>2]=130560;Of(m|0,21520,875)}m=NYa(l<<2)|0;p=m;o=m+((l+3|0)>>>2<<2)|0;n=o;k=m+(l<<2)|0;if((d|0)==(i|0)){t=d;u=n}else{l=o;m=d;v=n;do{f[l>>2]=f[m>>2];l=v+4|0;v=l;m=m+4|0}while((m|0)!=(i|0));t=f[a>>2]|0;u=v}f[a>>2]=p;f[c>>2]=n;f[h>>2]=u;f[j>>2]=k;if(!t)s=o;else{PYa(t);s=f[c>>2]|0}}else s=d;while(0);f[s+-4>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+-4;return}function u1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=e;do if((d|0)==(e|0)){h=a+8|0;i=f[h>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;if(i>>>0<k>>>0){k=i;m=((l-k>>2)+1|0)/2|0;n=i+(m<<2)|0;o=k-d|0;k=o>>2;p=n+(0-k<<2)|0;if(!k){q=i;r=n}else{M1a(p|0,d|0,o|0)|0;q=f[h>>2]|0;r=p}f[c>>2]=r;f[h>>2]=q+(m<<2);s=r;break}m=l-g>>1;l=(m|0)==0?1:m;if(l>>>0>1073741823){m=De(8)|0;UYa(m,358155);f[m>>2]=130560;Of(m|0,21520,875)}m=NYa(l<<2)|0;p=m;o=m+((l+3|0)>>>2<<2)|0;n=o;k=m+(l<<2)|0;if((d|0)==(i|0)){t=d;u=n}else{l=o;m=d;v=n;do{f[l>>2]=f[m>>2];l=v+4|0;v=l;m=m+4|0}while((m|0)!=(i|0));t=f[a>>2]|0;u=v}f[a>>2]=p;f[c>>2]=n;f[h>>2]=u;f[j>>2]=k;if(!t)s=o;else{PYa(t);s=f[c>>2]|0}}else s=d;while(0);f[s+-4>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+-4;return}function v1(a){a=a|0;f[a>>2]=45228;V$(a+44|0);return}function w1(a){a=a|0;f[a>>2]=45228;V$(a+44|0);PYa(a);return}function x1(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0;e=u;u=u+3520|0;g=e+3496|0;h=e+3488|0;i=e+3432|0;j=e+3424|0;k=e+3368|0;l=e+3312|0;m=e+2256|0;n=e+1200|0;o=e+1168|0;p=e+1144|0;q=e+1136|0;r=e+1080|0;s=e+16|0;t=e+8|0;v=e+3304|0;w=e+2248|0;x=e+1192|0;y=e;_$(j,45300);f[k>>2]=1124007936;z=k+4|0;A=k+8|0;B=k+40|0;C=z;D=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(D|0));f[B>>2]=A;E=k+48|0;F=k+44|0;f[F>>2]=E;f[E>>2]=0;f[k+52>>2]=0;f[l>>2]=1124007936;G=l+4|0;H=l+8|0;I=l+40|0;C=G;D=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(D|0));f[I>>2]=H;C=l+48|0;D=l+44|0;f[D>>2]=C;f[C>>2]=0;f[l+52>>2]=0;J=m+8|0;f[m>>2]=J;K=m+4|0;f[K>>2]=0;L=n+8|0;f[n>>2]=L;M=n+4|0;f[M>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;N=f[c>>2]|0;O=N+-1|0;P=(O|0)>0?O:0;O=a+4|0;Q=c+4|0;R=(f[Q>>2]|0)+1|0;S=f[(f[O>>2]|0)+8>>2]|0;T=(R|0)<(S|0)?R:S;_$(q,45320);if(!(b[a+33>>0]|0)){q=f[O>>2]|0;f[g>>2]=P;f[g+4>>2]=T;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;DR(i,q,g,h);q=i+36|0;S=f[q>>2]|0;if(S|0){R=S+12|0;f[R>>2]=(f[R>>2]|0)+1}R=k+36|0;S=f[R>>2]|0;if(S|0?(U=S+12|0,S=f[U>>2]|0,f[U>>2]=S+-1,(S|0)==1):0)CR(k);f[R>>2]=0;S=k+16|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[z>>2]|0)>0){U=f[B>>2]|0;V=0;do{f[U+(V<<2)>>2]=0;V=V+1|0;W=f[z>>2]|0}while((V|0)<(W|0));f[k>>2]=f[i>>2];if((W|0)<3)X=29;else X=31}else{f[k>>2]=f[i>>2];X=29}if((X|0)==29){W=f[i+4>>2]|0;if((W|0)<3){f[z>>2]=W;f[A>>2]=f[i+8>>2];f[k+12>>2]=f[i+12>>2];A=f[i+44>>2]|0;W=f[F>>2]|0;f[W>>2]=f[A>>2];f[W+4>>2]=f[A+4>>2]}else X=31}if((X|0)==31)BR(k,i);A=i+16|0;f[S>>2]=f[A>>2];f[k+20>>2]=f[i+20>>2];f[k+24>>2]=f[i+24>>2];f[k+28>>2]=f[i+28>>2];f[k+32>>2]=f[i+32>>2];S=f[q>>2]|0;f[R>>2]=S;if(S|0?(R=S+12|0,S=f[R>>2]|0,f[R>>2]=S+-1,(S|0)==1):0)CR(i);f[q>>2]=0;q=i+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[q>>2]|0)>0){A=f[i+40>>2]|0;S=0;do{f[A+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[q>>2]|0))}q=f[i+44>>2]|0;if((q|0)!=(i+48|0))ZF(q);q=f[a+8>>2]|0;f[g>>2]=P;f[g+4>>2]=T;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;DR(i,q,g,h);q=i+36|0;S=f[q>>2]|0;if(S|0){A=S+12|0;f[A>>2]=(f[A>>2]|0)+1}A=l+36|0;S=f[A>>2]|0;if(S|0?(R=S+12|0,S=f[R>>2]|0,f[R>>2]=S+-1,(S|0)==1):0)CR(l);f[A>>2]=0;S=l+16|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[G>>2]|0)>0){R=f[I>>2]|0;W=0;do{f[R+(W<<2)>>2]=0;W=W+1|0;Z=f[G>>2]|0}while((W|0)<(Z|0));f[l>>2]=f[i>>2];if((Z|0)<3)X=50;else X=52}else{f[l>>2]=f[i>>2];X=50}if((X|0)==50){Z=f[i+4>>2]|0;if((Z|0)<3){f[G>>2]=Z;f[H>>2]=f[i+8>>2];f[l+12>>2]=f[i+12>>2];H=f[i+44>>2]|0;Z=f[D>>2]|0;f[Z>>2]=f[H>>2];f[Z+4>>2]=f[H+4>>2]}else X=52}if((X|0)==52)BR(l,i);H=i+16|0;f[S>>2]=f[H>>2];f[l+20>>2]=f[i+20>>2];f[l+24>>2]=f[i+24>>2];f[l+28>>2]=f[i+28>>2];f[l+32>>2]=f[i+32>>2];S=f[q>>2]|0;f[A>>2]=S;if(S|0?(A=S+12|0,S=f[A>>2]|0,f[A>>2]=S+-1,(S|0)==1):0)CR(i);f[q>>2]=0;q=i+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[q>>2]|0)>0){H=f[i+40>>2]|0;S=0;do{f[H+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[q>>2]|0))}q=f[i+44>>2]|0;if((q|0)!=(i+48|0))ZF(q)}else{q=f[O>>2]|0;f[g>>2]=P;f[g+4>>2]=T;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;DR(r,q,g,h);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=r;q=g+8|0;f[q>>2]=0;f[q+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;q=a+28|0;b8(i,g,3,1,0,f[q>>2]|0,1.0,0.0,1);S=r+36|0;H=f[S>>2]|0;if(H|0?(A=H+12|0,H=f[A>>2]|0,f[A>>2]=H+-1,(H|0)==1):0)CR(r);f[S>>2]=0;S=r+16|0;H=r+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[H>>2]|0)>0){S=f[r+40>>2]|0;A=0;do{f[S+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[H>>2]|0))}H=f[r+44>>2]|0;if((H|0)!=(r+48|0))ZF(H);H=f[O>>2]|0;f[g>>2]=P;f[g+4>>2]=T;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;DR(r,H,g,h);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=r;H=g+8|0;f[H>>2]=0;f[H+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=l;b8(i,g,3,0,1,f[q>>2]|0,1.0,0.0,1);q=r+36|0;H=f[q>>2]|0;if(H|0?(A=H+12|0,H=f[A>>2]|0,f[A>>2]=H+-1,(H|0)==1):0)CR(r);f[q>>2]=0;q=r+16|0;H=r+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[H>>2]|0)>0){q=f[r+40>>2]|0;A=0;do{f[q+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[H>>2]|0))}H=f[r+44>>2]|0;if((H|0)!=(r+48|0))ZF(H)}_$(r,45340);r=a+40|0;H=f[r>>2]|0;if((H|0)>1){A=k+12|0;q=f[A>>2]<<1;if((f[K>>2]|0)>>>0<q>>>0){S=f[m>>2]|0;if((S|0)!=(J|0)){if(S|0)QYa(S);f[m>>2]=J;f[K>>2]=520}f[K>>2]=q;if(q>>>0>520){S=OYa(q>>>0>2147483647?-1:q<<1)|0;f[m>>2]=S}}else f[K>>2]=q;q=l+12|0;S=f[q>>2]<<1;if((f[M>>2]|0)>>>0<S>>>0){Z=f[n>>2]|0;if((Z|0)!=(L|0)){if(Z|0)QYa(Z);f[n>>2]=L;f[M>>2]=520}f[M>>2]=S;if(S>>>0>520){Z=OYa(S>>>0>2147483647?-1:S<<1)|0;f[n>>2]=Z;_=Z}else _=L}else{f[M>>2]=S;_=f[n>>2]|0}S=f[m>>2]|0;$=f[r>>2]|0;aa=S;ba=S+(f[A>>2]<<1)|0;ca=_;da=_+(f[q>>2]<<1)|0}else{$=H;aa=0;ba=0;ca=0;da=0}H=a+36|0;q=f[H>>2]|0;_=Y(q*3|0,$)|0;A=s+8|0;f[s>>2]=A;S=s+4|0;f[S>>2]=_;if(_>>>0>264){Z=OYa(_>>>0>1073741823?-1:_<<2)|0;f[s>>2]=Z;ea=Z}else ea=A;Z=ea+4|0;_=Y($,q)|0;$=Z+(_<<2)|0;W=$+(_<<2)|0;_=W+-4|0;if((P|0)==(f[c>>2]|0))F1a(_|0,0,q<<2|0)|0;else{f[_>>2]=0;f[W+(f[(f[O>>2]|0)+12>>2]<<2)>>2]=0}f[ea>>2]=0;f[Z+(f[(f[O>>2]|0)+12>>2]<<2)>>2]=0;f[$+-4>>2]=0;f[$+(f[(f[O>>2]|0)+12>>2]<<2)>>2]=0;ea=f[Q>>2]|0;if((P|0)>(ea|0)){fa=ea;ga=a+12|0}else{ea=k+16|0;_=l+16|0;q=a+32|0;R=a+12|0;V=a+20|0;U=a+24|0;ha=o+8|0;ia=o+4|0;ja=o+16|0;ka=o+20|0;la=aa;aa=ba;ba=ca;ca=da;da=$;$=W;W=Z;Z=P;while(1){if((Z|0)<(T|0)){ma=Z-P|0;na=(f[ea>>2]|0)+(Y(f[f[F>>2]>>2]|0,ma)|0)|0;oa=(f[_>>2]|0)+(Y(f[f[D>>2]>>2]|0,ma)|0)|0;ma=Y(f[r>>2]|0,f[(f[O>>2]|0)+12>>2]|0)|0;pa=(ma|0)>0;if(!(b[q>>0]|0)){if(pa){qa=W;ra=0;do{sa=d[na+(ra<<1)>>1]|0;ta=sa<<16>>16;ua=d[oa+(ra<<1)>>1]|0;va=ua<<16>>16;f[qa+(ra<<2)>>2]=(ua<<16>>16>-1?va:0-va|0)+(sa<<16>>16>-1?ta:0-ta|0);ra=ra+1|0}while((ra|0)!=(ma|0))}}else if(pa){ra=W;qa=0;do{ta=d[na+(qa<<1)>>1]|0;sa=Y(ta,ta)|0;ta=d[oa+(qa<<1)>>1]|0;va=(Y(ta,ta)|0)+sa|0;f[ra+(qa<<2)>>2]=va;qa=qa+1|0}while((qa|0)!=(ma|0))}ma=f[r>>2]|0;if((ma|0)>1){qa=f[(f[O>>2]|0)+12>>2]|0;ra=W;if((qa|0)>0){pa=la;va=ba;sa=ma;ma=0;ta=0;while(1){ua=f[ra+(ta<<2)>>2]|0;if((sa|0)>1){wa=ua;xa=1;ya=ta;while(1){za=xa+ta|0;Aa=(f[ra+(za<<2)>>2]|0)>(wa|0)?za:ya;xa=xa+1|0;za=f[ra+(Aa<<2)>>2]|0;if((xa|0)>=(sa|0)){Ba=za;Ca=Aa;break}else{wa=za;ya=Aa}}}else{Ba=ua;Ca=ta}f[ra+(ma<<2)>>2]=Ba;d[pa+(ma<<1)>>1]=d[na+(Ca<<1)>>1]|0;d[va+(ma<<1)>>1]=d[oa+(Ca<<1)>>1]|0;ma=ma+1|0;ya=f[r>>2]|0;wa=f[(f[O>>2]|0)+12>>2]|0;if((ma|0)>=(wa|0)){Da=wa;break}else{sa=ya;ta=ya+ta|0}}}else Da=qa;f[ra+(Da<<2)>>2]=0;Ea=aa;Fa=la;Ga=ca;Ha=ba}else{Ea=la;Fa=aa;Ga=ba;Ha=ca}if((Z|0)>(f[c>>2]|0)){Ia=Ea;Ja=Fa;Ka=Ga;La=Ha;X=106}else{Ma=Ea;Na=Fa;Oa=Ga;Pa=Ha}}else{F1a(W+-4|0,0,f[H>>2]<<2|0)|0;ta=(f[r>>2]|0)>1;Ia=ta?aa:la;Ja=ta?la:aa;Ka=ta?ca:ba;La=ta?ba:ca;X=106}if((X|0)==106){X=0;ta=f[R>>2]|0;sa=(f[ta+16>>2]|0)+(Y(f[f[ta+44>>2]>>2]|0,Z)|0)|0;ta=sa+1|0;b[sa>>0]=1;b[ta+(f[(f[O>>2]|0)+12>>2]|0)>>0]=1;if((f[r>>2]|0)==1){sa=Z-P+-1|0;ma=(f[ea>>2]|0)+(Y(f[f[F>>2]>>2]|0,sa)|0)|0;Qa=ma;Ra=(f[_>>2]|0)+(Y(f[f[D>>2]>>2]|0,sa)|0)|0}else{Qa=Ia;Ra=Ka}if((f[(f[O>>2]|0)+12>>2]|0)>0){sa=$;ma=da;oa=W;va=0;do{na=f[sa+(va<<2)>>2]|0;do if((na|0)>(f[V>>2]|0)){pa=d[Qa+(va<<1)>>1]|0;ya=d[Ra+(va<<1)>>1]|0;wa=pa<<16>>16;xa=pa<<16>>16>-1?wa:0-wa|0;wa=ya<<16>>16;Aa=(ya<<16>>16>-1?wa:0-wa|0)<<15;if((Aa|0)<(xa*13573|0)){if((na|0)<=(f[sa+(va+-1<<2)>>2]|0)){X=135;break}if((na|0)<(f[sa+(va+1<<2)>>2]|0)){X=135;break}wa=ta+va|0;if((na|0)<=(f[U>>2]|0)){b[wa>>0]=0;break}b[wa>>0]=2;za=f[ia>>2]|0;Sa=(f[ha>>2]|0)-za|0;Ta=f[ja>>2]|0;Ua=f[ka>>2]|0;if((((Sa|0)==0?0:(Sa<<8)+-1|0)|0)==(Ua+Ta|0)){p1(o);Va=f[ja>>2]|0;Wa=f[ka>>2]|0;Xa=f[ia>>2]|0}else{Va=Ta;Wa=Ua;Xa=za}za=Wa+Va|0;f[(f[Xa+(za>>>10<<2)>>2]|0)+((za&1023)<<2)>>2]=wa;f[ka>>2]=Wa+1;break}if((Aa|0)>(xa*79109|0)){if((na|0)<=(f[ma+(va<<2)>>2]|0)){X=135;break}if((na|0)<(f[oa+(va<<2)>>2]|0)){X=135;break}xa=ta+va|0;if((na|0)<=(f[U>>2]|0)){b[xa>>0]=0;break}b[xa>>0]=2;Aa=f[ia>>2]|0;wa=(f[ha>>2]|0)-Aa|0;za=f[ja>>2]|0;Ua=f[ka>>2]|0;if((((wa|0)==0?0:(wa<<8)+-1|0)|0)==(Ua+za|0)){p1(o);Ya=f[ja>>2]|0;Za=f[ka>>2]|0;_a=f[ia>>2]|0}else{Ya=za;Za=Ua;_a=Aa}Aa=Za+Ya|0;f[(f[_a+(Aa>>>10<<2)>>2]|0)+((Aa&1023)<<2)>>2]=xa;f[ka>>2]=Za+1;break}else{xa=(ya^pa)<<16>>16<0?-1:1;if((na|0)<=(f[ma+(va-xa<<2)>>2]|0)){X=135;break}if((na|0)<=(f[oa+(xa+va<<2)>>2]|0)){X=135;break}xa=ta+va|0;if((na|0)<=(f[U>>2]|0)){b[xa>>0]=0;break}b[xa>>0]=2;pa=f[ia>>2]|0;ya=(f[ha>>2]|0)-pa|0;Aa=f[ja>>2]|0;Ua=f[ka>>2]|0;if((((ya|0)==0?0:(ya<<8)+-1|0)|0)==(Ua+Aa|0)){p1(o);$a=f[ja>>2]|0;ab=f[ka>>2]|0;bb=f[ia>>2]|0}else{$a=Aa;ab=Ua;bb=pa}pa=ab+$a|0;f[(f[bb+(pa>>>10<<2)>>2]|0)+((pa&1023)<<2)>>2]=xa;f[ka>>2]=ab+1;break}}else X=135;while(0);if((X|0)==135){X=0;b[ta+va>>0]=1}va=va+1|0}while((va|0)<(f[(f[O>>2]|0)+12>>2]|0));Ma=Ia;Na=Ja;Oa=Ka;Pa=La}else{Ma=Ia;Na=Ja;Oa=Ka;Pa=La}}va=f[Q>>2]|0;if((Z|0)<(va|0)){ta=W;oa=$;la=Ma;aa=Na;ba=Oa;ca=Pa;Z=Z+1|0;W=da;$=ta;da=oa}else{fa=va;ga=R;break}}}R=f[ga>>2]|0;ga=f[R+16>>2]|0;if((N|0)<2)cb=ga;else cb=ga+(Y((f[c>>2]|0)+2|0,f[H>>2]|0)|0)|0;if((T|0)==(f[(f[O>>2]|0)+8>>2]|0))db=f[R+28>>2]|0;else db=ga+(Y(f[H>>2]|0,fa)|0)|0;fa=cb;ga=db-fa|0;_$(t,45360);t=o+20|0;db=f[t>>2]|0;if(!db)eb=p+20|0;else{R=o+16|0;O=o+4|0;T=o+8|0;c=p+8|0;N=p+4|0;da=p+16|0;$=p+20|0;W=db;while(1){db=f[R>>2]|0;Z=W+-1|0;Pa=db+Z|0;ca=f[O>>2]|0;Oa=f[(f[ca+(Pa>>>10<<2)>>2]|0)+((Pa&1023)<<2)>>2]|0;f[t>>2]=Z;Z=f[T>>2]|0;Pa=Z-ca|0;if((1-W-db+((Pa|0)==0?0:(Pa<<8)+-1|0)|0)>>>0>2047){PYa(f[Z+-4>>2]|0);f[T>>2]=(f[T>>2]|0)+-4}Z=Oa;do if((Oa-fa|0)>>>0>=ga>>>0){Pa=f[N>>2]|0;db=(f[c>>2]|0)-Pa|0;ca=f[da>>2]|0;ba=f[$>>2]|0;if((((db|0)==0?0:(db<<8)+-1|0)|0)==(ba+ca|0)){p1(p);fb=f[da>>2]|0;gb=f[$>>2]|0;hb=f[N>>2]|0}else{fb=ca;gb=ba;hb=Pa}Pa=gb+fb|0;f[(f[hb+(Pa>>>10<<2)>>2]|0)+((Pa&1023)<<2)>>2]=Oa;f[$>>2]=gb+1;Pa=f[H>>2]|0;ba=Z>>>0<cb>>>0?Pa:0-Pa|0;Pa=Z+-1|0;if(!(b[Pa>>0]|0)){b[Pa>>0]=2;ca=f[O>>2]|0;db=(f[T>>2]|0)-ca|0;Na=f[R>>2]|0;aa=f[t>>2]|0;if((((db|0)==0?0:(db<<8)+-1|0)|0)==(aa+Na|0)){p1(o);ib=f[R>>2]|0;jb=f[t>>2]|0;kb=f[O>>2]|0}else{ib=Na;jb=aa;kb=ca}ca=jb+ib|0;f[(f[kb+(ca>>>10<<2)>>2]|0)+((ca&1023)<<2)>>2]=Pa;f[t>>2]=jb+1}Pa=Z+1|0;if(!(b[Pa>>0]|0)){b[Pa>>0]=2;ca=f[O>>2]|0;aa=(f[T>>2]|0)-ca|0;Na=f[R>>2]|0;db=f[t>>2]|0;if((((aa|0)==0?0:(aa<<8)+-1|0)|0)==(db+Na|0)){p1(o);lb=f[R>>2]|0;mb=f[t>>2]|0;nb=f[O>>2]|0}else{lb=Na;mb=db;nb=ca}ca=mb+lb|0;f[(f[nb+(ca>>>10<<2)>>2]|0)+((ca&1023)<<2)>>2]=Pa;f[t>>2]=mb+1}Pa=Z+ba|0;if(!(b[Z+(ba+-1)>>0]|0)){ca=Pa+-1|0;b[ca>>0]=2;db=f[O>>2]|0;Na=(f[T>>2]|0)-db|0;aa=f[R>>2]|0;Ma=f[t>>2]|0;if((((Na|0)==0?0:(Na<<8)+-1|0)|0)==(Ma+aa|0)){p1(o);ob=f[R>>2]|0;pb=f[t>>2]|0;qb=f[O>>2]|0}else{ob=aa;pb=Ma;qb=db}db=pb+ob|0;f[(f[qb+(db>>>10<<2)>>2]|0)+((db&1023)<<2)>>2]=ca;f[t>>2]=pb+1}if(!(b[Pa>>0]|0)){b[Pa>>0]=2;ca=f[O>>2]|0;db=(f[T>>2]|0)-ca|0;Ma=f[R>>2]|0;aa=f[t>>2]|0;if((((db|0)==0?0:(db<<8)+-1|0)|0)==(aa+Ma|0)){p1(o);rb=f[R>>2]|0;sb=f[t>>2]|0;tb=f[O>>2]|0}else{rb=Ma;sb=aa;tb=ca}ca=sb+rb|0;f[(f[tb+(ca>>>10<<2)>>2]|0)+((ca&1023)<<2)>>2]=Pa;f[t>>2]=sb+1}if(!(b[Z+(ba+1)>>0]|0)){Pa=Z+ba+1|0;b[Pa>>0]=2;ba=f[O>>2]|0;ca=(f[T>>2]|0)-ba|0;aa=f[R>>2]|0;Ma=f[t>>2]|0;if((((ca|0)==0?0:(ca<<8)+-1|0)|0)==(Ma+aa|0)){p1(o);ub=f[R>>2]|0;vb=f[t>>2]|0;wb=f[O>>2]|0}else{ub=aa;vb=Ma;wb=ba}ba=vb+ub|0;f[(f[wb+(ba>>>10<<2)>>2]|0)+((ba&1023)<<2)>>2]=Pa;Pa=vb+1|0;f[t>>2]=Pa;xb=Pa}else X=202}else{Pa=f[H>>2]|0;if(!(b[Z+~Pa>>0]|0)){b[Z+(0-Pa)+-1>>0]=2;ba=f[H>>2]|0;Ma=f[O>>2]|0;aa=(f[T>>2]|0)-Ma|0;ca=f[R>>2]|0;db=f[t>>2]|0;if((((aa|0)==0?0:(aa<<8)+-1|0)|0)==(db+ca|0)){p1(o);yb=f[H>>2]|0;zb=f[R>>2]|0;Ab=f[t>>2]|0;Bb=f[O>>2]|0}else{yb=ba;zb=ca;Ab=db;Bb=Ma}Ma=Ab+zb|0;f[(f[Bb+(Ma>>>10<<2)>>2]|0)+((Ma&1023)<<2)>>2]=Z+(0-ba)+-1;f[t>>2]=Ab+1;Cb=yb}else Cb=Pa;Pa=Z+(0-Cb)|0;if(!(b[Pa>>0]|0)){b[Pa>>0]=2;Pa=f[H>>2]|0;ba=f[O>>2]|0;Ma=(f[T>>2]|0)-ba|0;db=f[R>>2]|0;ca=f[t>>2]|0;if((((Ma|0)==0?0:(Ma<<8)+-1|0)|0)==(ca+db|0)){p1(o);Db=f[H>>2]|0;Eb=f[R>>2]|0;Fb=f[t>>2]|0;Gb=f[O>>2]|0}else{Db=Pa;Eb=db;Fb=ca;Gb=ba}ba=Fb+Eb|0;f[(f[Gb+(ba>>>10<<2)>>2]|0)+((ba&1023)<<2)>>2]=Z+(0-Pa);f[t>>2]=Fb+1;Hb=Db}else Hb=Cb;if(!(b[Z+(1-Hb)>>0]|0)){b[Z+(0-Hb)+1>>0]=2;Pa=Z+(0-(f[H>>2]|0))+1|0;ba=f[O>>2]|0;ca=(f[T>>2]|0)-ba|0;db=f[R>>2]|0;Ma=f[t>>2]|0;if((((ca|0)==0?0:(ca<<8)+-1|0)|0)==(Ma+db|0)){p1(o);Ib=f[R>>2]|0;Jb=f[t>>2]|0;Kb=f[O>>2]|0}else{Ib=db;Jb=Ma;Kb=ba}ba=Jb+Ib|0;f[(f[Kb+(ba>>>10<<2)>>2]|0)+((ba&1023)<<2)>>2]=Pa;f[t>>2]=Jb+1}Pa=Z+-1|0;if(!(b[Pa>>0]|0)){b[Pa>>0]=2;ba=f[O>>2]|0;Ma=(f[T>>2]|0)-ba|0;db=f[R>>2]|0;ca=f[t>>2]|0;if((((Ma|0)==0?0:(Ma<<8)+-1|0)|0)==(ca+db|0)){p1(o);Lb=f[R>>2]|0;Mb=f[t>>2]|0;Nb=f[O>>2]|0}else{Lb=db;Mb=ca;Nb=ba}ba=Mb+Lb|0;f[(f[Nb+(ba>>>10<<2)>>2]|0)+((ba&1023)<<2)>>2]=Pa;f[t>>2]=Mb+1}Pa=Z+1|0;if(!(b[Pa>>0]|0)){b[Pa>>0]=2;ba=f[O>>2]|0;ca=(f[T>>2]|0)-ba|0;db=f[R>>2]|0;Ma=f[t>>2]|0;if((((ca|0)==0?0:(ca<<8)+-1|0)|0)==(Ma+db|0)){p1(o);Ob=f[R>>2]|0;Pb=f[t>>2]|0;Qb=f[O>>2]|0}else{Ob=db;Pb=Ma;Qb=ba}ba=Pb+Ob|0;f[(f[Qb+(ba>>>10<<2)>>2]|0)+((ba&1023)<<2)>>2]=Pa;f[t>>2]=Pb+1}Pa=f[H>>2]|0;if(!(b[Z+(Pa+-1)>>0]|0)){b[Z+Pa+-1>>0]=2;ba=f[H>>2]|0;Ma=f[O>>2]|0;db=(f[T>>2]|0)-Ma|0;ca=f[R>>2]|0;aa=f[t>>2]|0;if((((db|0)==0?0:(db<<8)+-1|0)|0)==(aa+ca|0)){p1(o);Rb=f[H>>2]|0;Sb=f[R>>2]|0;Tb=f[t>>2]|0;Ub=f[O>>2]|0}else{Rb=ba;Sb=ca;Tb=aa;Ub=Ma}Ma=Tb+Sb|0;f[(f[Ub+(Ma>>>10<<2)>>2]|0)+((Ma&1023)<<2)>>2]=Z+ba+-1;f[t>>2]=Tb+1;Vb=Rb}else Vb=Pa;Pa=Z+Vb|0;if(!(b[Pa>>0]|0)){b[Pa>>0]=2;Pa=f[H>>2]|0;ba=f[O>>2]|0;Ma=(f[T>>2]|0)-ba|0;aa=f[R>>2]|0;ca=f[t>>2]|0;if((((Ma|0)==0?0:(Ma<<8)+-1|0)|0)==(ca+aa|0)){p1(o);Wb=f[H>>2]|0;Xb=f[R>>2]|0;Yb=f[t>>2]|0;Zb=f[O>>2]|0}else{Wb=Pa;Xb=aa;Yb=ca;Zb=ba}ba=Yb+Xb|0;f[(f[Zb+(ba>>>10<<2)>>2]|0)+((ba&1023)<<2)>>2]=Z+Pa;f[t>>2]=Yb+1;_b=Wb}else _b=Vb;if(b[Z+(_b+1)>>0]|0){X=202;break}b[Z+_b+1>>0]=2;Pa=Z+(f[H>>2]|0)+1|0;ba=f[O>>2]|0;ca=(f[T>>2]|0)-ba|0;aa=f[R>>2]|0;Ma=f[t>>2]|0;if((((ca|0)==0?0:(ca<<8)+-1|0)|0)==(Ma+aa|0)){p1(o);$b=f[R>>2]|0;ac=f[t>>2]|0;bc=f[O>>2]|0}else{$b=aa;ac=Ma;bc=ba}ba=ac+$b|0;f[(f[bc+(ba>>>10<<2)>>2]|0)+((ba&1023)<<2)>>2]=Pa;Pa=ac+1|0;f[t>>2]=Pa;xb=Pa}while(0);if((X|0)==202){X=0;xb=f[t>>2]|0}if(!xb){eb=$;break}else W=xb}}if(f[eb>>2]|0){xb=a+44|0;W$(xb);W=f[a+16>>2]|0;a=(f[W+16>>2]|0)+(f[W+20>>2]|0)|0;$=f[W+4>>2]|0;t=$+(a>>>10<<2)|0;if((f[W+8>>2]|0)==($|0))cc=0;else cc=(f[t>>2]|0)+((a&1023)<<2)|0;f[v>>2]=t;f[v+4>>2]=cc;cc=f[p+4>>2]|0;t=f[p+16>>2]|0;a=cc+(t>>>10<<2)|0;$=(f[p+8>>2]|0)==(cc|0);if($)dc=0;else dc=(f[a>>2]|0)+((t&1023)<<2)|0;f[w>>2]=a;f[w+4>>2]=dc;dc=t+(f[eb>>2]|0)|0;eb=cc+(dc>>>10<<2)|0;if($)ec=0;else ec=(f[eb>>2]|0)+((dc&1023)<<2)|0;f[x>>2]=eb;f[x+4>>2]=ec;f[i>>2]=f[v>>2];f[i+4>>2]=f[v+4>>2];f[h>>2]=f[w>>2];f[h+4>>2]=f[w+4>>2];f[g>>2]=f[x>>2];f[g+4>>2]=f[x+4>>2];y1(y,W,i,h,g,0);X$(xb)}xb=f[s>>2]|0;if((xb|0)!=(A|0)){if(xb|0)QYa(xb);f[s>>2]=A;f[S>>2]=264}q1(p);q1(o);o=f[n>>2]|0;if((o|0)!=(L|0)){if(o|0)QYa(o);f[n>>2]=L;f[M>>2]=520}M=f[m>>2]|0;if((M|0)!=(J|0)){if(M|0)QYa(M);f[m>>2]=J;f[K>>2]=520}K=l+36|0;J=f[K>>2]|0;if(J|0?(m=J+12|0,J=f[m>>2]|0,f[m>>2]=J+-1,(J|0)==1):0)CR(l);f[K>>2]=0;K=l+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[G>>2]|0)>0){K=f[I>>2]|0;I=0;do{f[K+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[G>>2]|0))}G=f[D>>2]|0;if((G|0)!=(C|0))ZF(G);G=k+36|0;C=f[G>>2]|0;do if(C|0){D=C+12|0;I=f[D>>2]|0;f[D>>2]=I+-1;if((I|0)!=1)break;CR(k)}while(0);f[G>>2]=0;G=k+16|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[z>>2]|0)>0){G=f[B>>2]|0;B=0;do{f[G+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[z>>2]|0))}z=f[F>>2]|0;if((z|0)!=(E|0))ZF(z);if(!(f[j+4>>2]|0)){u=e;return}u=e;return}function y1(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0;g=u;u=u+128|0;h=g+120|0;i=g+112|0;j=g+104|0;k=g+24|0;l=g+96|0;m=g+88|0;n=g+80|0;o=g+72|0;p=g+64|0;q=g+56|0;r=g+48|0;s=g+40|0;t=g+32|0;v=g+16|0;w=g+8|0;x=g;y=d;z=f[y>>2]|0;A=f[y+4>>2]|0;y=e;B=f[y>>2]|0;C=f[y+4>>2]|0;if((C|0)==(A|0))D=0;else D=(C-(f[B>>2]|0)>>2)+(B-z<<8)-(A-(f[z>>2]|0)>>2)|0;y=b+4|0;E=f[y>>2]|0;F=b+16|0;G=f[F>>2]|0;H=E+(G>>>10<<2)|0;I=b+8|0;J=f[I>>2]|0;K=J;L=E;if((J|0)==(E|0))M=0;else M=(f[H>>2]|0)+((G&1023)<<2)|0;N=f[c+4>>2]|0;if((N|0)==(M|0))O=0;else{P=f[c>>2]|0;O=(N-(f[P>>2]|0)>>2)+(P-H<<8)-(M-(f[H>>2]|0)>>2)|0}H=b+20|0;M=f[H>>2]|0;if(O>>>0<(M-O|0)>>>0){if(D>>>0>G>>>0){z1(b,D-G|0);Q=f[y>>2]|0;R=f[I>>2]|0;S=f[F>>2]|0}else{Q=E;R=J;S=G}P=Q+(S>>>10<<2)|0;if((R|0)==(Q|0))T=0;else T=(f[P>>2]|0)+((S&1023)<<2)|0;Q=P;R=T;if(D>>>0>O>>>0){if(O>>>0<D>>>1>>>0)if(!O){U=B;V=C}else{N=B;c=(C-(f[B>>2]|0)>>2)-O|0;if((c|0)>0){W=N+(c>>>10<<2)|0;X=(f[W>>2]|0)+((c&1023)<<2)|0;Y=W}else{W=1023-c|0;c=N+(((W|0)/-1024|0)<<2)|0;X=(f[c>>2]|0)+(1023-((W|0)%1024|0)<<2)|0;Y=c}U=Y;V=X}else{X=D-O|0;if(!X){U=z;V=A}else{Y=z;c=(A-(f[z>>2]|0)>>2)+X|0;if((c|0)>0){X=Y+(c>>>10<<2)|0;Z=(f[X>>2]|0)+((c&1023)<<2)|0;_=X}else{X=1023-c|0;c=Y+(((X|0)/-1024|0)<<2)|0;Z=(f[c>>2]|0)+(1023-((X|0)%1024|0)<<2)|0;_=c}U=_;V=Z}}Z=V;_=d+4|0;if((Z|0)==(f[_>>2]|0)){$=V;aa=U;ba=Q;ca=R;da=O;ea=S}else{c=Z;Z=f[H>>2]|0;X=Q;Y=R;W=U;N=S;while(1){fa=Y;ga=X;if((fa|0)==(f[ga>>2]|0)){ha=ga+-4|0;ia=(f[ha>>2]|0)+4096|0;ja=ha}else{ia=fa;ja=X}fa=ia+-4|0;Y=fa;ha=W;if((c|0)==(f[ha>>2]|0)){ga=ha+-4|0;ka=(f[ga>>2]|0)+4096|0;la=ga}else{ka=c;la=W}c=ka+-4|0;f[fa>>2]=f[c>>2];N=N+-1|0;Z=Z+1|0;if((c|0)==(f[_>>2]|0))break;else{X=ja;W=la}}f[F>>2]=N;f[H>>2]=Z;$=V;aa=U;ba=ja;ca=Y;da=O;ea=N}}else{$=A;aa=z;ba=Q;ca=R;da=D;ea=S}if(da|0){S=(R-(f[P>>2]|0)>>2)+da|0;if((S|0)>0){N=P+(S>>>10<<2)|0;ma=N;na=(f[N>>2]|0)+((S&1023)<<2)|0}else{N=1023-S|0;S=P+(((N|0)/-1024|0)<<2)|0;ma=S;na=(f[S>>2]|0)+(1023-((N|0)%1024|0)<<2)|0}N=ma;ma=na;if((na|0)!=(T|0)){S=na;na=f[H>>2]|0;Y=ba;ba=ca;ca=N;ja=ea;while(1){ea=ba;U=Y;if((ea|0)==(f[U>>2]|0)){V=U+-4|0;oa=(f[V>>2]|0)+4096|0;pa=V}else{oa=ea;pa=Y}ba=oa+-4|0;ea=ca;if((S|0)==(f[ea>>2]|0)){V=ea+-4|0;qa=(f[V>>2]|0)+4096|0;ra=V}else{qa=S;ra=ca}S=qa+-4|0;f[ba>>2]=f[S>>2];ja=ja+-1|0;na=na+1|0;if((S|0)==(T|0))break;else{Y=pa;ca=ra}}f[F>>2]=ja;f[H>>2]=na}if(da>>>0<O>>>0){f[l>>2]=N;f[l+4>>2]=ma;ma=m;f[ma>>2]=Q;f[ma+4>>2]=R;ma=(R-(f[P>>2]|0)>>2)+O|0;if((ma|0)>0){N=P+(ma>>>10<<2)|0;f[m>>2]=N;sa=(f[N>>2]|0)+((ma&1023)<<2)|0}else{N=1023-ma|0;ma=P+(((N|0)/-1024|0)<<2)|0;f[m>>2]=ma;sa=(f[ma>>2]|0)+(1023-((N|0)%1024|0)<<2)|0}f[m+4>>2]=sa;f[n>>2]=Q;f[n+4>>2]=R;f[j>>2]=f[l>>2];f[j+4>>2]=f[l+4>>2];f[i>>2]=f[m>>2];f[i+4>>2]=f[m+4>>2];f[h>>2]=f[n>>2];f[h+4>>2]=f[n+4>>2];A1(k,j,i,h);ta=f[k>>2]|0;ua=f[k+4>>2]|0}else{ta=Q;ua=R}R=o;f[R>>2]=aa;f[R+4>>2]=$;$=e;R=f[$+4>>2]|0;aa=p;f[aa>>2]=f[$>>2];f[aa+4>>2]=R;f[q>>2]=ta;f[q+4>>2]=ua;f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[i>>2]=f[p>>2];f[i+4>>2]=f[p+4>>2];f[h>>2]=f[q>>2];f[h+4>>2]=f[q+4>>2];B1(k,j,i,h)}}else{q=K-L|0;L=((q|0)==0?0:(q<<8)+-1|0)-(M+G)|0;if(D>>>0>L>>>0){C1(b,D-L|0);va=f[F>>2]|0;wa=f[y>>2]|0;xa=f[I>>2]|0;ya=f[H>>2]|0}else{va=G;wa=E;xa=J;ya=M}M=va+ya|0;va=wa+(M>>>10<<2)|0;if((xa|0)==(wa|0))za=0;else za=(f[va>>2]|0)+((M&1023)<<2)|0;M=va;wa=za;xa=ya-O|0;if(D>>>0>xa>>>0){if(xa>>>0<D>>>1>>>0)if(!xa){Aa=z;Ba=A}else{J=z;E=(A-(f[z>>2]|0)>>2)+xa|0;if((E|0)>0){z=J+(E>>>10<<2)|0;Ca=(f[z>>2]|0)+((E&1023)<<2)|0;Da=z}else{z=1023-E|0;E=J+(((z|0)/-1024|0)<<2)|0;Ca=(f[E>>2]|0)+(1023-((z|0)%1024|0)<<2)|0;Da=E}Aa=Da;Ba=Ca}else{Ca=D-xa|0;if(!Ca){Aa=B;Ba=C}else{Da=B;E=(C-(f[B>>2]|0)>>2)-Ca|0;if((E|0)>0){Ca=Da+(E>>>10<<2)|0;Ea=(f[Ca>>2]|0)+((E&1023)<<2)|0;Fa=Ca}else{Ca=1023-E|0;E=Da+(((Ca|0)/-1024|0)<<2)|0;Ea=(f[E>>2]|0)+(1023-((Ca|0)%1024|0)<<2)|0;Fa=E}Aa=Fa;Ba=Ea}}Ea=Ba;Fa=e+4|0;if((Ea|0)==(f[Fa>>2]|0)){Ga=Aa;Ha=Ba;Ia=ya;Ja=M;Ka=wa;La=xa}else{e=Ea;Ea=ya;E=M;Ca=wa;Da=Aa;z=Ba;while(1){f[Ca>>2]=f[z>>2];J=Ca+4|0;if((J-(f[E>>2]|0)|0)==4096){A=E+4|0;Ma=A;Na=f[A>>2]|0}else{Ma=E;Na=J}J=e+4|0;if((J-(f[Da>>2]|0)|0)==4096){A=Da+4|0;Oa=A;Pa=f[A>>2]|0}else{Oa=Da;Pa=J}Ea=Ea+1|0;e=Pa;if((e|0)==(f[Fa>>2]|0))break;else{E=Ma;Ca=Na;Da=Oa;z=Pa}}f[H>>2]=Ea;Ga=Aa;Ha=Ba;Ia=Ea;Ja=Ma;Ka=Na;La=xa}}else{Ga=B;Ha=C;Ia=ya;Ja=M;Ka=wa;La=D}if(La|0){D=(wa-(f[va>>2]|0)>>2)-La|0;if((D|0)>0){ya=va+(D>>>10<<2)|0;Qa=ya;Ra=(f[ya>>2]|0)+((D&1023)<<2)|0}else{ya=1023-D|0;D=va+(((ya|0)/-1024|0)<<2)|0;Qa=D;Ra=(f[D>>2]|0)+(1023-((ya|0)%1024|0)<<2)|0}ya=Qa;Qa=Ra;if((Ra|0)!=(za|0)){D=Ra;Ra=Ia;Ia=Ja;Ja=Ka;Ka=ya;C=Qa;while(1){f[Ja>>2]=f[C>>2];B=Ja+4|0;if((B-(f[Ia>>2]|0)|0)==4096){Na=Ia+4|0;Sa=Na;Ta=f[Na>>2]|0}else{Sa=Ia;Ta=B}B=D+4|0;if((B-(f[Ka>>2]|0)|0)==4096){Na=Ka+4|0;Ua=Na;Va=f[Na>>2]|0}else{Ua=Ka;Va=B}Ra=Ra+1|0;D=Va;if((D|0)==(za|0))break;else{Ia=Sa;Ja=Ta;Ka=Ua;C=Va}}f[H>>2]=Ra}if(La>>>0<xa>>>0){La=r;f[La>>2]=M;f[La+4>>2]=wa;La=(wa-(f[va>>2]|0)>>2)-xa|0;if((La|0)>0){xa=va+(La>>>10<<2)|0;f[r>>2]=xa;Wa=(f[xa>>2]|0)+((La&1023)<<2)|0}else{xa=1023-La|0;La=va+(((xa|0)/-1024|0)<<2)|0;f[r>>2]=La;Wa=(f[La>>2]|0)+(1023-((xa|0)%1024|0)<<2)|0}f[r+4>>2]=Wa;f[s>>2]=ya;f[s+4>>2]=Qa;f[t>>2]=M;f[t+4>>2]=wa;f[j>>2]=f[r>>2];f[j+4>>2]=f[r+4>>2];f[i>>2]=f[s>>2];f[i+4>>2]=f[s+4>>2];f[h>>2]=f[t>>2];f[h+4>>2]=f[t+4>>2];D1(k,j,i,h);Xa=f[k>>2]|0;Ya=f[k+4>>2]|0}else{Xa=M;Ya=wa}wa=d;d=f[wa+4>>2]|0;M=v;f[M>>2]=f[wa>>2];f[M+4>>2]=d;d=w;f[d>>2]=Ga;f[d+4>>2]=Ha;f[x>>2]=Xa;f[x+4>>2]=Ya;f[j>>2]=f[v>>2];f[j+4>>2]=f[v+4>>2];f[i>>2]=f[w>>2];f[i+4>>2]=f[w+4>>2];f[h>>2]=f[x>>2];f[h+4>>2]=f[x+4>>2];E1(k,j,i,h)}}h=f[y>>2]|0;y=f[F>>2]|0;F=h+(y>>>10<<2)|0;if((f[I>>2]|0)==(h|0)){Za=0;_a=0}else{Za=0;_a=(f[F>>2]|0)+((y&1023)<<2)|0}y=a;f[y>>2]=Za|F;f[y+4>>2]=_a;if(!O){u=g;return}y=(_a-(f[F>>2]|0)>>2)+O|0;if((y|0)>0){O=F+(y>>>10<<2)|0;f[a>>2]=O;$a=(f[O>>2]|0)+((y&1023)<<2)|0}else{O=1023-y|0;y=F+(((O|0)/-1024|0)<<2)|0;f[a>>2]=y;$a=(f[y>>2]|0)+(1023-((O|0)%1024|0)<<2)|0}f[a+4>>2]=$a;u=g;return}function z1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;c=u;u=u+16|0;d=c;e=a+8|0;g=f[e>>2]|0;h=a+4|0;i=f[h>>2]|0;j=(g|0)==(i|0);k=(j&1)+b|0;b=((k&1023|0)!=0&1)+(k>>>10)|0;k=i;i=g-k|0;l=a+16|0;m=f[l>>2]|0;n=(((i|0)==0?0:(i<<8)+-1|0)-((f[a+20>>2]|0)+m)|0)>>>10;o=b>>>0<n>>>0?b:n;n=b-o|0;if(!n){f[l>>2]=(o<<10)+m;if(!o){u=c;return}m=g+-4|0;f[d>>2]=f[m>>2];f[e>>2]=m;t1(a,d);m=o+-1|0;if(!m){u=c;return}else p=m;do{m=(f[e>>2]|0)+-4|0;f[d>>2]=f[m>>2];f[e>>2]=m;t1(a,d);p=p+-1|0}while((p|0)!=0);u=c;return}p=a+12|0;m=f[a>>2]|0;q=(f[p>>2]|0)-m|0;r=i>>2;if(n>>>0<=((q>>2)-r|0)>>>0){do if((k|0)!=(m|0)){i=n;while(1){s=NYa(4096)|0;f[d>>2]=s;t1(a,d);i=i+-1|0;t=f[e>>2]|0;s=f[h>>2]|0;v=(f[l>>2]|0)+1024+(((t-s|0)==4)<<31>>31)|0;f[l>>2]=v;if(!i){w=25;break}if((s|0)==(f[a>>2]|0)){w=7;break}}if((w|0)==7){x=t;y=i;w=8;break}else if((w|0)==25){z=v;A=t;B=o;break}}else{x=g;y=n;w=8}while(0);do if((w|0)==8){g=x;t=o;v=y;a:while(1){m=NYa(4096)|0;k=f[p>>2]|0;s=k;C=g;do if((g|0)==(k|0)){D=f[h>>2]|0;E=f[a>>2]|0;F=E;if(D>>>0>E>>>0){G=D;H=((G-F>>2)+1|0)/-2|0;I=D+(H<<2)|0;J=C-G|0;G=J>>2;if(!G)K=D;else{M1a(I|0,D|0,J|0)|0;K=f[h>>2]|0}J=I+(G<<2)|0;f[e>>2]=J;f[h>>2]=K+(H<<2);L=J;break}J=s-F>>1;F=(J|0)==0?1:J;if(F>>>0>1073741823){w=17;break a}J=NYa(F<<2)|0;H=J;G=J+(F>>>2<<2)|0;I=G;M=J+(F<<2)|0;if((D|0)==(g|0)){N=E;O=I}else{E=G;G=D;D=I;do{f[E>>2]=f[G>>2];E=D+4|0;D=E;G=G+4|0}while((G|0)!=(g|0));N=f[a>>2]|0;O=D}f[a>>2]=H;f[h>>2]=I;f[e>>2]=O;f[p>>2]=M;if(!N)L=O;else{PYa(N);L=f[e>>2]|0}}else L=g;while(0);f[L>>2]=m;g=(f[e>>2]|0)+4|0;f[e>>2]=g;v=v+-1|0;t=t+1|0;if(!v){w=24;break}}if((w|0)==17){v=De(8)|0;UYa(v,358155);f[v>>2]=130560;Of(v|0,21520,875)}else if((w|0)==24){z=f[l>>2]|0;A=g;B=t;break}}while(0);f[l>>2]=z+(B<<10);if(!B){u=c;return}z=A+-4|0;f[d>>2]=f[z>>2];f[e>>2]=z;t1(a,d);z=B+-1|0;if(!z){u=c;return}else P=z;do{z=(f[e>>2]|0)+-4|0;f[d>>2]=f[z>>2];f[e>>2]=z;t1(a,d);P=P+-1|0}while((P|0)!=0);u=c;return}P=(b<<10)+(j<<31>>31)|0;j=q>>1;q=r+n|0;r=j>>>0<q>>>0?q:j;do if(r)if(r>>>0>1073741823){j=De(8)|0;UYa(j,358155);f[j>>2]=130560;Of(j|0,21520,875)}else{Q=NYa(r<<2)|0;break}else Q=0;while(0);j=Q;q=j;b=j;d=j;j=Q+(r<<2)|0;r=n;b:while(1){n=NYa(4096)|0;Q=d;z=d;do if((Q|0)==(j|0)){B=b;if(B>>>0>q>>>0){A=B+((((b-q>>2)+1|0)/-2|0)<<2)|0;L=d-b|0;N=L>>2;if(N|0)M1a(A|0,b|0,L|0)|0;L=A+(N<<2)|0;R=L;S=q;T=A;U=L;V=j;break}L=j-q>>1;A=(L|0)==0?1:L;if(A>>>0>1073741823){w=41;break b}L=NYa(A<<2)|0;N=L;O=L+(A>>>2<<2)|0;K=O;y=L+(A<<2)|0;if((B|0)==(Q|0))W=K;else{A=O;O=B;B=K;while(1){f[A>>2]=f[O>>2];A=B+4|0;L=A;O=O+4|0;if((O|0)==(Q|0)){W=L;break}else B=L}}B=W;if(!q){R=B;S=N;T=K;U=W;V=y}else{PYa(q);R=B;S=N;T=K;U=W;V=y}}else{R=z;S=q;T=b;U=d;V=j}while(0);f[R>>2]=n;d=U+4|0;r=r+-1|0;if(!r)break;else{q=S;b=T;j=V}}if((w|0)==41){w=De(8)|0;UYa(w,358155);f[w>>2]=130560;Of(w|0,21520,875)}w=f[e>>2]|0;c:do if(!o){X=w;Y=S;Z=T;_=d;$=V}else{j=w;b=o;q=S;r=T;U=d;R=V;d:while(1){W=j+-4|0;z=U;Q=U;do if((z|0)==(R|0)){t=r;if(t>>>0>q>>>0){g=t+((((r-q>>2)+1|0)/-2|0)<<2)|0;B=U-r|0;O=B>>2;if(O|0)M1a(g|0,r|0,B|0)|0;B=g+(O<<2)|0;aa=B;ba=q;ca=g;da=B;ea=R;break}B=R-q>>1;g=(B|0)==0?1:B;if(g>>>0>1073741823)break d;B=NYa(g<<2)|0;O=B;A=B+(g>>>2<<2)|0;m=A;L=B+(g<<2)|0;if((t|0)==(z|0))fa=m;else{g=A;A=t;t=m;while(1){f[g>>2]=f[A>>2];g=t+4|0;B=g;A=A+4|0;if((A|0)==(z|0)){fa=B;break}else t=B}}t=fa;if(!q){aa=t;ba=O;ca=m;da=fa;ea=L}else{PYa(q);aa=t;ba=O;ca=m;da=fa;ea=L}}else{aa=Q;ba=q;ca=r;da=U;ea=R}while(0);f[aa>>2]=f[W>>2];Q=da+4|0;z=(f[e>>2]|0)+-4|0;f[e>>2]=z;b=b+-1|0;if(!b){X=z;Y=ba;Z=ca;_=Q;$=ea;break c}else{j=z;q=ba;r=ca;U=Q;R=ea}}R=De(8)|0;UYa(R,358155);f[R>>2]=130560;Of(R|0,21520,875)}while(0);ea=f[h>>2]|0;e:do if((ea|0)==(X|0)){ga=Y;ha=Z;ia=_;ja=$}else{ca=Y;ba=Z;da=_;aa=$;fa=ea;f:while(1){V=da;d=da;do if((V|0)==(aa|0)){T=ba;if(T>>>0>ca>>>0){S=T+((((ba-ca>>2)+1|0)/-2|0)<<2)|0;o=da-ba|0;w=o>>2;if(w|0)M1a(S|0,ba|0,o|0)|0;o=S+(w<<2)|0;ka=o;la=ca;ma=S;na=o;oa=aa;break}o=aa-ca>>1;S=(o|0)==0?1:o;if(S>>>0>1073741823)break f;o=NYa(S<<2)|0;w=o;R=o+(S>>>2<<2)|0;U=R;r=o+(S<<2)|0;if((T|0)==(V|0))pa=U;else{S=R;R=T;T=U;while(1){f[S>>2]=f[R>>2];S=T+4|0;o=S;R=R+4|0;if((R|0)==(V|0)){pa=o;break}else T=o}}T=pa;if(!ca){ka=T;la=w;ma=U;na=pa;oa=r}else{PYa(ca);ka=T;la=w;ma=U;na=pa;oa=r}}else{ka=d;la=ca;ma=ba;na=da;oa=aa}while(0);f[ka>>2]=f[fa>>2];d=na+4|0;fa=fa+4|0;if((fa|0)==(f[e>>2]|0)){ga=la;ha=ma;ia=d;ja=oa;break e}else{ca=la;ba=ma;da=d;aa=oa}}aa=De(8)|0;UYa(aa,358155);f[aa>>2]=130560;Of(aa|0,21520,875)}while(0);oa=f[a>>2]|0;f[a>>2]=ga;f[h>>2]=ha;f[e>>2]=ia;f[p>>2]=ja;f[l>>2]=P+(f[l>>2]|0);if(!oa){u=c;return}PYa(oa);u=c;return}function A1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=f[c+4>>2]|0;g=b+4|0;h=f[g>>2]|0;if((e|0)!=(h|0)?(i=f[c>>2]|0,c=f[b>>2]|0,j=(e-(f[i>>2]|0)>>2)+(i-c<<8)-(h-(f[c>>2]|0)>>2)|0,(j|0)>0):0){c=d;i=f[c>>2]|0;e=f[c+4>>2]|0;c=h;h=j;while(1){j=(f[f[b>>2]>>2]|0)+4096|0;k=j-c>>2;l=(k|0)>(h|0);m=l?c+(h<<2)|0:j;j=l?h:k;if((c|0)==(m|0)){n=i;o=e}else{k=m;l=e;p=c;q=i;r=e;while(1){s=q;t=(f[s>>2]|0)+4096-l>>2;u=p;v=k-u>>2;w=(v|0)>(t|0);x=w?t:v;v=p;p=w?p+(t<<2)|0:m;t=p-u|0;if(t|0)M1a(l|0,v|0,t|0)|0;if(!x){y=l;z=q;A=r}else{t=(r-(f[q>>2]|0)>>2)+x|0;if((t|0)>0){x=s+(t>>>10<<2)|0;B=(f[x>>2]|0)+((t&1023)<<2)|0;C=x}else{x=1023-t|0;t=s+(((x|0)/-1024|0)<<2)|0;B=(f[t>>2]|0)+(1023-((x|0)%1024|0)<<2)|0;C=t}y=B;z=C;A=B}if((p|0)==(m|0)){n=z;o=A;break}else{l=y;q=z;r=A}}}r=d;f[r>>2]=n;f[r+4>>2]=o;r=h-j|0;if(j|0){q=f[b>>2]|0;l=((f[g>>2]|0)-(f[q>>2]|0)>>2)+j|0;if((l|0)>0){m=q+(l>>>10<<2)|0;f[b>>2]=m;D=(f[m>>2]|0)+((l&1023)<<2)|0}else{m=1023-l|0;l=q+(((m|0)/-1024|0)<<2)|0;f[b>>2]=l;D=(f[l>>2]|0)+(1023-((m|0)%1024|0)<<2)|0}f[g>>2]=D}if((r|0)<=0){E=n;F=o;break}i=n;e=o;c=f[g>>2]|0;h=r}G=a;H=G;f[H>>2]=E;I=G+4|0;J=I;f[J>>2]=F;return}h=d;E=f[h>>2]|0;F=f[h+4>>2]|0;G=a;H=G;f[H>>2]=E;I=G+4|0;J=I;f[J>>2]=F;return}function B1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=f[c+4>>2]|0;g=b+4|0;h=f[g>>2]|0;if((e|0)!=(h|0)?(i=f[c>>2]|0,c=f[b>>2]|0,j=(e-(f[i>>2]|0)>>2)+(i-c<<8)-(h-(f[c>>2]|0)>>2)|0,(j|0)>0):0){c=d;i=f[c>>2]|0;e=f[c+4>>2]|0;c=h;h=j;while(1){j=(f[f[b>>2]>>2]|0)+4096|0;k=j-c>>2;l=(k|0)>(h|0);m=l?c+(h<<2)|0:j;j=l?h:k;if((c|0)==(m|0)){n=i;o=e}else{k=m;l=e;p=c;q=i;r=e;while(1){s=q;t=(f[s>>2]|0)+4096-l>>2;u=p;v=k-u>>2;w=(v|0)>(t|0);x=w?t:v;v=p;p=w?p+(t<<2)|0:m;t=p-u|0;if(t|0)M1a(l|0,v|0,t|0)|0;if(!x){y=l;z=q;A=r}else{t=(r-(f[q>>2]|0)>>2)+x|0;if((t|0)>0){x=s+(t>>>10<<2)|0;B=(f[x>>2]|0)+((t&1023)<<2)|0;C=x}else{x=1023-t|0;t=s+(((x|0)/-1024|0)<<2)|0;B=(f[t>>2]|0)+(1023-((x|0)%1024|0)<<2)|0;C=t}y=B;z=C;A=B}if((p|0)==(m|0)){n=z;o=A;break}else{l=y;q=z;r=A}}}r=d;f[r>>2]=n;f[r+4>>2]=o;r=h-j|0;if(j|0){q=f[b>>2]|0;l=((f[g>>2]|0)-(f[q>>2]|0)>>2)+j|0;if((l|0)>0){m=q+(l>>>10<<2)|0;f[b>>2]=m;D=(f[m>>2]|0)+((l&1023)<<2)|0}else{m=1023-l|0;l=q+(((m|0)/-1024|0)<<2)|0;f[b>>2]=l;D=(f[l>>2]|0)+(1023-((m|0)%1024|0)<<2)|0}f[g>>2]=D}if((r|0)<=0){E=n;F=o;break}i=n;e=o;c=f[g>>2]|0;h=r}G=a;H=G;f[H>>2]=E;I=G+4|0;J=I;f[J>>2]=F;return}h=d;E=f[h>>2]|0;F=f[h+4>>2]|0;G=a;H=G;f[H>>2]=E;I=G+4|0;J=I;f[J>>2]=F;return}function C1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;c=u;u=u+32|0;d=c;e=a+8|0;g=f[e>>2]|0;h=a+4|0;i=f[h>>2]|0;j=((g|0)==(i|0)&1)+b|0;b=((j&1023|0)!=0&1)+(j>>>10)|0;j=a+16|0;k=f[j>>2]|0;l=k>>>10;m=b>>>0<l>>>0?b:l;n=b-m|0;o=g;if(!n){f[j>>2]=k-(m<<10);if(!m){u=c;return}k=a+12|0;p=i;q=g;r=m;a:while(1){s=f[p>>2]|0;t=p+4|0;f[h>>2]=t;v=f[k>>2]|0;w=v;x=q;do if((q|0)==(v|0)){y=f[a>>2]|0;z=y;if(t>>>0>y>>>0){A=t;B=((A-z>>2)+1|0)/-2|0;C=t+(B<<2)|0;D=x-A|0;A=D>>2;if(!A)E=t;else{M1a(C|0,t|0,D|0)|0;E=f[h>>2]|0}D=C+(A<<2)|0;f[e>>2]=D;f[h>>2]=E+(B<<2);F=D;break}D=w-z>>1;z=(D|0)==0?1:D;if(z>>>0>1073741823){G=10;break a}D=NYa(z<<2)|0;B=D;A=D+(z>>>2<<2)|0;C=A;H=D+(z<<2)|0;if((t|0)==(q|0)){I=y;J=C}else{y=A;A=t;z=C;do{f[y>>2]=f[A>>2];y=z+4|0;z=y;A=A+4|0}while((A|0)!=(q|0));I=f[a>>2]|0;J=z}f[a>>2]=B;f[h>>2]=C;f[e>>2]=J;f[k>>2]=H;if(!I)F=J;else{PYa(I);F=f[e>>2]|0}}else F=q;while(0);f[F>>2]=s;t=(f[e>>2]|0)+4|0;f[e>>2]=t;w=r+-1|0;if(!w){G=92;break}p=f[h>>2]|0;q=t;r=w}if((G|0)==10){r=De(8)|0;UYa(r,358155);f[r>>2]=130560;Of(r|0,21520,875)}else if((G|0)==92){u=c;return}}r=a+12|0;q=f[r>>2]|0;p=q-(f[a>>2]|0)|0;F=o-i>>2;if(n>>>0<=((p>>2)-F|0)>>>0){b:do if((q|0)!=(o|0)){i=q;I=g;J=n;c:while(1){k=i;E=NYa(4096)|0;w=I;do if((I|0)==(k|0)){t=f[h>>2]|0;x=f[a>>2]|0;v=x;if(t>>>0>x>>>0){A=t;y=((A-v>>2)+1|0)/-2|0;D=t+(y<<2)|0;K=w-A|0;A=K>>2;if(!A)L=t;else{M1a(D|0,t|0,K|0)|0;L=f[h>>2]|0}K=D+(A<<2)|0;f[e>>2]=K;f[h>>2]=L+(y<<2);M=K;break}K=i-v>>1;v=(K|0)==0?1:K;if(v>>>0>1073741823){G=28;break c}K=NYa(v<<2)|0;y=K;A=K+(v>>>2<<2)|0;D=A;N=K+(v<<2)|0;if((t|0)==(k|0)){O=x;P=D}else{x=A;A=t;t=D;do{f[x>>2]=f[A>>2];x=t+4|0;t=x;A=A+4|0}while((A|0)!=(k|0));O=f[a>>2]|0;P=t}f[a>>2]=y;f[h>>2]=D;f[e>>2]=P;f[r>>2]=N;if(!O)M=P;else{PYa(O);M=f[e>>2]|0}}else M=I;while(0);f[M>>2]=E;I=(f[e>>2]|0)+4|0;f[e>>2]=I;k=J+-1|0;if(!k){G=20;break}i=f[r>>2]|0;if((i|0)==(I|0)){Q=k;G=21;break b}else J=k}if((G|0)==20){R=I;S=f[j>>2]|0;T=m;break}else if((G|0)==28){J=De(8)|0;UYa(J,358155);f[J>>2]=130560;Of(J|0,21520,875)}}else{Q=n;G=21}while(0);if((G|0)==21){M=~(b>>>0>l>>>0?l:b);b=Q;do{l=NYa(4096)|0;f[d>>2]=l;t1(a,d);b=b+-1|0;U=f[e>>2]|0;V=(f[j>>2]|0)+1024+(((U-(f[h>>2]|0)|0)==4)<<31>>31)|0;f[j>>2]=V}while((b|0)!=0);R=U;S=V;T=Q+-1-M|0}f[j>>2]=S-(T<<10);if(!T){u=c;return}S=R;R=T;d:while(1){T=f[h>>2]|0;M=f[T>>2]|0;Q=T+4|0;f[h>>2]=Q;T=f[r>>2]|0;V=T;U=S;do if((S|0)==(T|0)){b=f[a>>2]|0;l=b;if(Q>>>0>b>>>0){O=Q;P=((O-l>>2)+1|0)/-2|0;L=Q+(P<<2)|0;g=U-O|0;O=g>>2;if(!O)W=Q;else{M1a(L|0,Q|0,g|0)|0;W=f[h>>2]|0}g=L+(O<<2)|0;f[e>>2]=g;f[h>>2]=W+(P<<2);X=g;break}g=V-l>>1;l=(g|0)==0?1:g;if(l>>>0>1073741823){G=46;break d}g=NYa(l<<2)|0;P=g;O=g+(l>>>2<<2)|0;L=O;q=g+(l<<2)|0;if((Q|0)==(S|0)){Y=b;Z=L}else{b=O;O=Q;l=L;do{f[b>>2]=f[O>>2];b=l+4|0;l=b;O=O+4|0}while((O|0)!=(S|0));Y=f[a>>2]|0;Z=l}f[a>>2]=P;f[h>>2]=L;f[e>>2]=Z;f[r>>2]=q;if(!Y)X=Z;else{PYa(Y);X=f[e>>2]|0}}else X=S;while(0);f[X>>2]=M;S=(f[e>>2]|0)+4|0;f[e>>2]=S;R=R+-1|0;if(!R){G=92;break}}if((G|0)==46){R=De(8)|0;UYa(R,358155);f[R>>2]=130560;Of(R|0,21520,875)}else if((G|0)==92){u=c;return}}R=m<<10;S=p>>1;p=F+n|0;X=S>>>0<p>>>0?p:S;S=F-m|0;f[d+12>>2]=0;f[d+16>>2]=a+12;do if(X)if(X>>>0>1073741823){F=De(8)|0;UYa(F,358155);f[F>>2]=130560;Of(F|0,21520,875)}else{_=NYa(X<<2)|0;break}else _=0;while(0);f[d>>2]=_;F=_+(S<<2)|0;S=d+8|0;f[S>>2]=F;p=d+4|0;f[p>>2]=F;Y=d+12|0;f[Y>>2]=_+(X<<2);X=F;F=n;e:do{n=NYa(4096)|0;_=f[Y>>2]|0;Z=_;W=X;do if((X|0)==(_|0)){Q=f[p>>2]|0;V=f[d>>2]|0;U=V;if(Q>>>0>V>>>0){T=Q;I=Q+((((T-U>>2)+1|0)/-2|0)<<2)|0;O=W-T|0;T=O>>2;if(T|0)M1a(I|0,Q|0,O|0)|0;O=I+(T<<2)|0;f[S>>2]=O;f[p>>2]=I;$=O;break}O=Z-U>>1;U=(O|0)==0?1:O;if(U>>>0>1073741823){G=66;break e}O=NYa(U<<2)|0;I=O;T=O+(U>>>2<<2)|0;b=T;E=O+(U<<2)|0;if((Q|0)==(X|0))aa=b;else{U=T;T=Q;Q=b;while(1){f[U>>2]=f[T>>2];U=Q+4|0;O=U;T=T+4|0;if((T|0)==(X|0)){aa=O;break}else Q=O}}f[d>>2]=I;f[p>>2]=b;f[S>>2]=aa;f[Y>>2]=E;Q=aa;if(!V)$=Q;else{PYa(V);$=Q}}else $=X;while(0);f[$>>2]=n;X=(f[S>>2]|0)+4|0;f[S>>2]=X;F=F+-1|0}while((F|0)!=0);if((G|0)==66){G=De(8)|0;UYa(G,358155);f[G>>2]=130560;Of(G|0,21520,875)}f:do if(m|0){G=f[h>>2]|0;F=X;$=m;g:while(1){aa=f[Y>>2]|0;Z=aa;W=F;do if((F|0)==(aa|0)){_=f[p>>2]|0;M=f[d>>2]|0;Q=M;if(_>>>0>M>>>0){T=_;U=_+((((T-Q>>2)+1|0)/-2|0)<<2)|0;q=W-T|0;T=q>>2;if(T|0)M1a(U|0,_|0,q|0)|0;q=U+(T<<2)|0;f[S>>2]=q;f[p>>2]=U;ba=q;break}q=Z-Q>>1;Q=(q|0)==0?1:q;if(Q>>>0>1073741823)break g;q=NYa(Q<<2)|0;U=q;T=q+(Q>>>2<<2)|0;L=T;P=q+(Q<<2)|0;if((_|0)==(F|0))ca=L;else{Q=T;T=_;_=L;while(1){f[Q>>2]=f[T>>2];Q=_+4|0;q=Q;T=T+4|0;if((T|0)==(F|0)){ca=q;break}else _=q}}f[d>>2]=U;f[p>>2]=L;f[S>>2]=ca;f[Y>>2]=P;_=ca;if(!M)ba=_;else{PYa(M);ba=_}}else ba=F;while(0);f[ba>>2]=f[G>>2];F=(f[S>>2]|0)+4|0;f[S>>2]=F;G=(f[h>>2]|0)+4|0;f[h>>2]=G;$=$+-1|0;if(!$)break f}$=De(8)|0;UYa($,358155);f[$>>2]=130560;Of($|0,21520,875)}while(0);ba=f[e>>2]|0;while(1){da=f[h>>2]|0;if((ba|0)==(da|0))break;ca=ba+-4|0;u1(d,ca);ba=ca}ca=da;da=f[a>>2]|0;f[a>>2]=f[d>>2];f[d>>2]=da;f[h>>2]=f[p>>2];f[p>>2]=ca;p=f[e>>2]|0;f[e>>2]=f[S>>2];f[S>>2]=p;e=f[r>>2]|0;f[r>>2]=f[Y>>2];f[Y>>2]=e;f[j>>2]=(f[j>>2]|0)-R;R=p;if((R|0)!=(ba|0))f[S>>2]=R+(~((R+-4-ca|0)>>>2)<<2);if(da|0)PYa(da);u=c;return}function D1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=c+4|0;g=f[e>>2]|0;h=f[b+4>>2]|0;if((g|0)!=(h|0)?(i=f[c>>2]|0,j=f[b>>2]|0,b=(g-(f[i>>2]|0)>>2)+(i-j<<8)-(h-(f[j>>2]|0)>>2)|0,(b|0)>0):0){j=f[c>>2]|0;h=g;g=b;while(1){if((h|0)==(f[j>>2]|0)){b=j+-4|0;f[c>>2]=b;i=(f[b>>2]|0)+4096|0;f[e>>2]=i;k=i;l=b}else{k=h;l=j}b=k+-4|0;f[e>>2]=b;i=f[l>>2]|0;m=k-i>>2;n=(m|0)>(g|0);o=n?k+(0-g<<2)|0:i;i=n?g:m;m=d;n=f[m>>2]|0;p=f[m+4>>2]|0;m=b;if((k|0)==(o|0)){q=n;r=p}else{s=o;t=k;u=n;n=p;while(1){p=u;v=u;w=n-(f[v>>2]|0)|0;x=w>>2;y=x+-1|0;if((w|0)>4){w=p+(y>>>10<<2)|0;z=(f[w>>2]|0)+((y&1023)<<2)|0;A=w}else{w=1024-x|0;x=p+(((w|0)/-1024|0)<<2)|0;z=(f[x>>2]|0)+(1023-((w|0)%1024|0)<<2)|0;A=x}x=z+4|0;w=x-(f[A>>2]|0)>>2;y=t;B=y-s>>2;C=(B|0)>(w|0);D=C?w:B;t=C?t+(0-w<<2)|0:o;w=y-t|0;y=w>>2;if(y|0)M1a(x+(0-y<<2)|0,t|0,w|0)|0;if(!D){E=u;F=n}else{w=(n-(f[v>>2]|0)>>2)-D|0;if((w|0)>0){D=p+(w>>>10<<2)|0;G=(f[D>>2]|0)+((w&1023)<<2)|0;H=D}else{D=1023-w|0;w=p+(((D|0)/-1024|0)<<2)|0;G=(f[w>>2]|0)+(1023-((D|0)%1024|0)<<2)|0;H=w}E=H;F=G}if((t|0)==(o|0)){q=E;r=F;break}else{u=E;n=F}}}n=d;f[n>>2]=q;f[n+4>>2]=r;g=g-i|0;n=i+-1|0;if(!n){I=l;J=b}else{u=(m-(f[l>>2]|0)>>2)-n|0;if((u|0)>0){n=l+(u>>>10<<2)|0;f[c>>2]=n;K=n;L=(f[n>>2]|0)+((u&1023)<<2)|0}else{n=1023-u|0;u=l+(((n|0)/-1024|0)<<2)|0;f[c>>2]=u;K=u;L=(f[u>>2]|0)+(1023-((n|0)%1024|0)<<2)|0}f[e>>2]=L;I=K;J=L}if((g|0)<=0){M=q;N=r;break}else{j=I;h=J}}O=a;P=O;f[P>>2]=M;Q=O+4|0;R=Q;f[R>>2]=N;return}J=d;M=f[J>>2]|0;N=f[J+4>>2]|0;O=a;P=O;f[P>>2]=M;Q=O+4|0;R=Q;f[R>>2]=N;return}function E1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=c+4|0;g=f[e>>2]|0;h=f[b+4>>2]|0;if((g|0)!=(h|0)?(i=f[c>>2]|0,j=f[b>>2]|0,b=(g-(f[i>>2]|0)>>2)+(i-j<<8)-(h-(f[j>>2]|0)>>2)|0,(b|0)>0):0){j=f[c>>2]|0;h=g;g=b;while(1){if((h|0)==(f[j>>2]|0)){b=j+-4|0;f[c>>2]=b;i=(f[b>>2]|0)+4096|0;f[e>>2]=i;k=i;l=b}else{k=h;l=j}b=k+-4|0;f[e>>2]=b;i=f[l>>2]|0;m=k-i>>2;n=(m|0)>(g|0);o=n?k+(0-g<<2)|0:i;i=n?g:m;m=d;n=f[m>>2]|0;p=f[m+4>>2]|0;m=b;if((k|0)==(o|0)){q=n;r=p}else{s=o;t=k;u=n;n=p;while(1){p=u;v=u;w=n-(f[v>>2]|0)|0;x=w>>2;y=x+-1|0;if((w|0)>4){w=p+(y>>>10<<2)|0;z=(f[w>>2]|0)+((y&1023)<<2)|0;A=w}else{w=1024-x|0;x=p+(((w|0)/-1024|0)<<2)|0;z=(f[x>>2]|0)+(1023-((w|0)%1024|0)<<2)|0;A=x}x=z+4|0;w=x-(f[A>>2]|0)>>2;y=t;B=y-s>>2;C=(B|0)>(w|0);D=C?w:B;t=C?t+(0-w<<2)|0:o;w=y-t|0;y=w>>2;if(y|0)M1a(x+(0-y<<2)|0,t|0,w|0)|0;if(!D){E=u;F=n}else{w=(n-(f[v>>2]|0)>>2)-D|0;if((w|0)>0){D=p+(w>>>10<<2)|0;G=(f[D>>2]|0)+((w&1023)<<2)|0;H=D}else{D=1023-w|0;w=p+(((D|0)/-1024|0)<<2)|0;G=(f[w>>2]|0)+(1023-((D|0)%1024|0)<<2)|0;H=w}E=H;F=G}if((t|0)==(o|0)){q=E;r=F;break}else{u=E;n=F}}}n=d;f[n>>2]=q;f[n+4>>2]=r;g=g-i|0;n=i+-1|0;if(!n){I=l;J=b}else{u=(m-(f[l>>2]|0)>>2)-n|0;if((u|0)>0){n=l+(u>>>10<<2)|0;f[c>>2]=n;K=n;L=(f[n>>2]|0)+((u&1023)<<2)|0}else{n=1023-u|0;u=l+(((n|0)/-1024|0)<<2)|0;f[c>>2]=u;K=u;L=(f[u>>2]|0)+(1023-((n|0)%1024|0)<<2)|0}f[e>>2]=L;I=K;J=L}if((g|0)<=0){M=q;N=r;break}else{j=I;h=J}}O=a;P=O;f[P>>2]=M;Q=O+4|0;R=Q;f[R>>2]=N;return}J=d;M=f[J>>2]|0;N=f[J+4>>2]|0;O=a;P=O;f[P>>2]=M;Q=O+4|0;R=Q;f[R>>2]=N;return}function F1(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;i=u;u=u+352|0;j=i+344|0;k=i+336|0;l=i+328|0;m=i+272|0;n=i+216|0;o=i+160|0;p=i+136|0;q=i+80|0;r=i+72|0;s=i+24|0;t=i+16|0;v=i;_$(j,45380);if((nS(a,-1)|0)!=2){f[k>>2]=0;f[k+4>>2]=0;w=c$(k,15)|0;x=204808;y=w+15|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));j$(-215,k,204343,204349,1075);d$(k)}if((RR(a,-1)|0)!=3?(RR(a,-1)|0)!=19:0){f[k>>2]=0;f[k+4>>2]=0;w=c$(k,114)|0;x=204824;y=w+114|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));j$(-215,k,204343,204349,1076);d$(k)}z=RR(c,-1)|0;if((z|0)!=(RR(a,-1)|0)){f[k>>2]=0;f[k+4>>2]=0;w=c$(k,24)|0;x=204939;y=w+24|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));j$(-215,k,204343,204349,1077);d$(k)}if(!(TS(a,c)|0)){f[k>>2]=0;f[k+4>>2]=0;w=c$(k,17)|0;x=204964;y=w+17|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));j$(-215,k,204343,204349,1078);d$(k)}x=e>g;A=x?e:g;B=x?g:e;QR(k,a,-1);f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];KS(d,l,0,-1,0,0);do if((NS(d)|0)==65536){l=f[d+4>>2]|0;f[m>>2]=f[l>>2];k=m+4|0;x=l+4|0;f[k>>2]=f[x>>2];z=m+8|0;f[z>>2]=f[l+8>>2];f[m+12>>2]=f[l+12>>2];f[m+16>>2]=f[l+16>>2];f[m+20>>2]=f[l+20>>2];f[m+24>>2]=f[l+24>>2];f[m+28>>2]=f[l+28>>2];f[m+32>>2]=f[l+32>>2];C=f[l+36>>2]|0;f[m+36>>2]=C;f[m+40>>2]=z;z=m+48|0;D=m+44|0;f[D>>2]=z;f[z>>2]=0;f[m+52>>2]=0;if(C|0){z=C+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[x>>2]|0)<3){x=f[l+44>>2]|0;z=f[D>>2]|0;f[z>>2]=f[x>>2];f[z+4>>2]=f[x+4>>2];break}else{f[k>>2]=0;BR(m,l);break}}else OR(m,d,-1);while(0);do if((NS(a)|0)==65536){d=f[a+4>>2]|0;f[n>>2]=f[d>>2];l=n+4|0;k=d+4|0;f[l>>2]=f[k>>2];x=n+8|0;f[x>>2]=f[d+8>>2];f[n+12>>2]=f[d+12>>2];f[n+16>>2]=f[d+16>>2];f[n+20>>2]=f[d+20>>2];f[n+24>>2]=f[d+24>>2];f[n+28>>2]=f[d+28>>2];f[n+32>>2]=f[d+32>>2];z=f[d+36>>2]|0;f[n+36>>2]=z;f[n+40>>2]=x;x=n+48|0;D=n+44|0;f[D>>2]=x;f[x>>2]=0;f[n+52>>2]=0;if(z|0){x=z+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[k>>2]|0)<3){k=f[d+44>>2]|0;x=f[D>>2]|0;f[x>>2]=f[k>>2];f[x+4>>2]=f[k+4>>2];break}else{f[l>>2]=0;BR(n,d);break}}else OR(n,a,-1);while(0);do if((NS(c)|0)==65536){a=f[c+4>>2]|0;f[o>>2]=f[a>>2];d=o+4|0;l=a+4|0;f[d>>2]=f[l>>2];k=o+8|0;f[k>>2]=f[a+8>>2];f[o+12>>2]=f[a+12>>2];f[o+16>>2]=f[a+16>>2];f[o+20>>2]=f[a+20>>2];f[o+24>>2]=f[a+24>>2];f[o+28>>2]=f[a+28>>2];f[o+32>>2]=f[a+32>>2];x=f[a+36>>2]|0;f[o+36>>2]=x;f[o+40>>2]=k;k=o+48|0;D=o+44|0;f[D>>2]=k;f[k>>2]=0;f[o+52>>2]=0;if(x|0){k=x+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[l>>2]|0)<3){l=f[a+44>>2]|0;k=f[D>>2]|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];break}else{f[d>>2]=0;BR(o,a);break}}else OR(o,c,-1);while(0);if(h){e=B<32767.0?B:32767.0;g=A<32767.0?A:32767.0;E=e>0.0?e*e:e;if(g>0.0){F=g*g;G=E}else{F=g;G=E}}else{F=A;G=B}c=~~G;a=c-(+(c|0)>G&1)|0;c=~~F;d=c-(+(c|0)>F&1)|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[q>>2]=1124007936;c=q+4|0;l=q+8|0;k=q+40|0;w=c;y=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(y|0));f[k>>2]=l;l=q+48|0;w=q+44|0;f[w>>2]=l;f[l>>2]=0;f[q+52>>2]=0;y=$U()|0;D=bV()|0;x=(D|0)<(y|0)?D:y;y=(x|0)>1?x:1;x=n+8|0;D=f[x>>2]|0;if(((D|0)/(y|0)|0|0)<3){z=(D|0)/3|0;H=(z|0)>1?z:1}else H=y;f[r>>2]=0;f[r+4>>2]=D;G1(s,n,o,q,p,a,d,h);_U(r,s,+(H|0));f[s>>2]=45228;V$(s+44|0);_$(r,45400);r=f[q+12>>2]|0;H=p+20|0;h=f[H>>2]|0;if(h|0){d=p+16|0;a=p+4|0;D=p+8|0;y=0-r|0;z=~r;C=1-r|0;I=r+-1|0;J=r+1|0;K=h;while(1){h=f[d>>2]|0;L=K+-1|0;M=h+L|0;N=f[a>>2]|0;O=f[(f[N+(M>>>10<<2)>>2]|0)+((M&1023)<<2)>>2]|0;f[H>>2]=L;L=f[D>>2]|0;M=L-N|0;if((1-K-h+((M|0)==0?0:(M<<8)+-1|0)|0)>>>0>2047){PYa(f[L+-4>>2]|0);f[D>>2]=(f[D>>2]|0)+-4}L=O+y|0;if(!(b[O+z>>0]|0)){M=L+-1|0;b[M>>0]=2;h=f[a>>2]|0;N=(f[D>>2]|0)-h|0;P=f[d>>2]|0;Q=f[H>>2]|0;if((((N|0)==0?0:(N<<8)+-1|0)|0)==(Q+P|0)){p1(p);R=f[d>>2]|0;S=f[H>>2]|0;T=f[a>>2]|0}else{R=P;S=Q;T=h}h=S+R|0;f[(f[T+(h>>>10<<2)>>2]|0)+((h&1023)<<2)>>2]=M;f[H>>2]=S+1}if(!(b[L>>0]|0)){b[L>>0]=2;M=f[a>>2]|0;h=(f[D>>2]|0)-M|0;Q=f[d>>2]|0;P=f[H>>2]|0;if((((h|0)==0?0:(h<<8)+-1|0)|0)==(P+Q|0)){p1(p);U=f[d>>2]|0;V=f[H>>2]|0;W=f[a>>2]|0}else{U=Q;V=P;W=M}M=V+U|0;f[(f[W+(M>>>10<<2)>>2]|0)+((M&1023)<<2)>>2]=L;f[H>>2]=V+1}if(!(b[O+C>>0]|0)){L=O+y+1|0;b[L>>0]=2;M=f[a>>2]|0;P=(f[D>>2]|0)-M|0;Q=f[d>>2]|0;h=f[H>>2]|0;if((((P|0)==0?0:(P<<8)+-1|0)|0)==(h+Q|0)){p1(p);X=f[d>>2]|0;Z=f[H>>2]|0;_=f[a>>2]|0}else{X=Q;Z=h;_=M}M=Z+X|0;f[(f[_+(M>>>10<<2)>>2]|0)+((M&1023)<<2)>>2]=L;f[H>>2]=Z+1}L=O+-1|0;if(!(b[L>>0]|0)){b[L>>0]=2;M=f[a>>2]|0;h=(f[D>>2]|0)-M|0;Q=f[d>>2]|0;P=f[H>>2]|0;if((((h|0)==0?0:(h<<8)+-1|0)|0)==(P+Q|0)){p1(p);$=f[d>>2]|0;aa=f[H>>2]|0;ba=f[a>>2]|0}else{$=Q;aa=P;ba=M}M=aa+$|0;f[(f[ba+(M>>>10<<2)>>2]|0)+((M&1023)<<2)>>2]=L;f[H>>2]=aa+1}L=O+1|0;if(!(b[L>>0]|0)){b[L>>0]=2;M=f[a>>2]|0;P=(f[D>>2]|0)-M|0;Q=f[d>>2]|0;h=f[H>>2]|0;if((((P|0)==0?0:(P<<8)+-1|0)|0)==(h+Q|0)){p1(p);ca=f[d>>2]|0;da=f[H>>2]|0;ea=f[a>>2]|0}else{ca=Q;da=h;ea=M}M=da+ca|0;f[(f[ea+(M>>>10<<2)>>2]|0)+((M&1023)<<2)>>2]=L;f[H>>2]=da+1}L=O+r|0;if(!(b[O+I>>0]|0)){M=L+-1|0;b[M>>0]=2;h=f[a>>2]|0;Q=(f[D>>2]|0)-h|0;P=f[d>>2]|0;N=f[H>>2]|0;if((((Q|0)==0?0:(Q<<8)+-1|0)|0)==(N+P|0)){p1(p);fa=f[d>>2]|0;ga=f[H>>2]|0;ha=f[a>>2]|0}else{fa=P;ga=N;ha=h}h=ga+fa|0;f[(f[ha+(h>>>10<<2)>>2]|0)+((h&1023)<<2)>>2]=M;f[H>>2]=ga+1}if(!(b[L>>0]|0)){b[L>>0]=2;M=f[a>>2]|0;h=(f[D>>2]|0)-M|0;N=f[d>>2]|0;P=f[H>>2]|0;if((((h|0)==0?0:(h<<8)+-1|0)|0)==(P+N|0)){p1(p);ia=f[d>>2]|0;ja=f[H>>2]|0;ka=f[a>>2]|0}else{ia=N;ja=P;ka=M}M=ja+ia|0;f[(f[ka+(M>>>10<<2)>>2]|0)+((M&1023)<<2)>>2]=L;f[H>>2]=ja+1}if(!(b[O+J>>0]|0)){L=O+r+1|0;b[L>>0]=2;O=f[a>>2]|0;M=(f[D>>2]|0)-O|0;P=f[d>>2]|0;N=f[H>>2]|0;if((((M|0)==0?0:(M<<8)+-1|0)|0)==(N+P|0)){p1(p);la=f[d>>2]|0;ma=f[H>>2]|0;na=f[a>>2]|0}else{la=P;ma=N;na=O}O=ma+la|0;f[(f[na+(O>>>10<<2)>>2]|0)+((O&1023)<<2)>>2]=L;L=ma+1|0;f[H>>2]=L;oa=L}else oa=f[H>>2]|0;if(!oa)break;else K=oa}}_$(s,45420);s=f[x>>2]|0;f[t>>2]=0;f[t+4>>2]=s;f[v>>2]=45288;f[v+4>>2]=q;f[v+8>>2]=m;x=n+4|0;oa=f[x>>2]|0;if((oa|0)<3)pa=Y(f[n+12>>2]|0,s)|0;else{s=f[n+40>>2]|0;K=0;H=1;while(1){ma=Y(f[s+(K<<2)>>2]|0,H)|0;K=K+1|0;if((K|0)==(oa|0)){pa=ma;break}else H=ma}}_U(t,v,+(pa>>>0)*.0000152587890625);pa=q+36|0;v=f[pa>>2]|0;if(v|0?(t=v+12|0,v=f[t>>2]|0,f[t>>2]=v+-1,(v|0)==1):0)CR(q);f[pa>>2]=0;pa=q+16|0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[c>>2]|0)>0){pa=f[k>>2]|0;k=0;do{f[pa+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[c>>2]|0))}c=f[w>>2]|0;if((c|0)!=(l|0))ZF(c);q1(p);p=o+36|0;c=f[p>>2]|0;if(c|0?(l=c+12|0,c=f[l>>2]|0,f[l>>2]=c+-1,(c|0)==1):0)CR(o);f[p>>2]=0;p=o+16|0;c=o+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[c>>2]|0)>0){p=f[o+40>>2]|0;l=0;do{f[p+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[c>>2]|0))}c=f[o+44>>2]|0;if((c|0)!=(o+48|0))ZF(c);c=n+36|0;o=f[c>>2]|0;do if(o|0){l=o+12|0;p=f[l>>2]|0;f[l>>2]=p+-1;if((p|0)!=1)break;CR(n)}while(0);f[c>>2]=0;c=n+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[x>>2]|0)>0){c=f[n+40>>2]|0;o=0;do{f[c+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[x>>2]|0))}x=f[n+44>>2]|0;if((x|0)!=(n+48|0))ZF(x);x=m+36|0;n=f[x>>2]|0;do if(n|0){o=n+12|0;c=f[o>>2]|0;f[o>>2]=c+-1;if((c|0)!=1)break;CR(m)}while(0);f[x>>2]=0;x=m+16|0;n=m+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[n>>2]|0)>0){x=f[m+40>>2]|0;c=0;do{f[x+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[n>>2]|0))}n=f[m+44>>2]|0;if((n|0)!=(m+48|0))ZF(n);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function G1(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=u;u=u+144|0;l=k+120|0;m=k;n=k+64|0;o=k+8|0;f[a>>2]=45228;q=a+4|0;f[q>>2]=c;f[a+8>>2]=d;d=a+12|0;f[d>>2]=e;f[a+16>>2]=g;f[a+20>>2]=h;f[a+24>>2]=i;f[a+28>>2]=0;b[a+32>>0]=j&1;U$(a+44|0);j=f[q>>2]|0;i=(f[j+8>>2]|0)+2|0;h=(f[j+12>>2]|0)+2|0;j=e+4|0;if(!(((((f[j>>2]|0)<3?(f[e+8>>2]|0)==(i|0):0)?(f[e+12>>2]|0)==(h|0):0)?(f[e>>2]&4095|0)==0:0)?(f[e+16>>2]|0)!=0:0)){f[l>>2]=i;f[l+4>>2]=h;AR(e,2,l,0)}h=f[d>>2]|0;if((h|0)==(e|0))r=e;else{i=e+36|0;g=f[i>>2]|0;if(g|0){c=g+12|0;f[c>>2]=(f[c>>2]|0)+1}c=h+36|0;g=f[c>>2]|0;if(g|0?(s=g+12|0,g=f[s>>2]|0,f[s>>2]=g+-1,(g|0)==1):0)CR(h);f[c>>2]=0;g=h+16|0;s=h+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[s>>2]|0)>0){t=f[h+40>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0;w=f[s>>2]|0}while((v|0)<(w|0));f[h>>2]=f[e>>2];if((w|0)<3)x=18;else x=20}else{f[h>>2]=f[e>>2];x=18}if((x|0)==18){w=f[j>>2]|0;if((w|0)<3){f[s>>2]=w;f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];w=f[e+44>>2]|0;s=f[h+44>>2]|0;f[s>>2]=f[w>>2];f[s+4>>2]=f[w+4>>2]}else x=20}if((x|0)==20)BR(h,e);f[g>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];f[c>>2]=f[i>>2];r=f[d>>2]|0}f[l>>2]=0;f[l+4>>2]=1;f[m>>2]=-2147483648;f[m+4>>2]=2147483647;DR(n,r,l,m);p[m>>3]=1.0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;hL(n,l,fT()|0)|0;r=n+36|0;i=f[r>>2]|0;if(i|0?(c=i+12|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)CR(n);f[r>>2]=0;r=n+16|0;i=n+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[i>>2]|0)>0){r=f[n+40>>2]|0;c=0;do{f[r+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[n+44>>2]|0;if((i|0)!=(n+48|0))ZF(i);i=f[d>>2]|0;n=f[(f[q>>2]|0)+8>>2]|0;f[l>>2]=n+1;f[l+4>>2]=n+2;f[m>>2]=-2147483648;f[m+4>>2]=2147483647;DR(o,i,l,m);p[m>>3]=1.0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;hL(o,l,fT()|0)|0;l=o+36|0;m=f[l>>2]|0;if(m|0?(i=m+12|0,m=f[i>>2]|0,f[i>>2]=m+-1,(m|0)==1):0)CR(o);f[l>>2]=0;l=o+16|0;m=o+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[m>>2]|0)>0){l=f[o+40>>2]|0;i=0;do{f[l+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[m>>2]|0))}m=f[o+44>>2]|0;if((m|0)==(o+48|0)){y=f[d>>2]|0;z=y+12|0;A=f[z>>2]|0;B=a+36|0;f[B>>2]=A;C=a+33|0;b[C>>0]=0;D=f[q>>2]|0;E=f[D>>2]|0;F=E>>>3;G=F&511;H=G+1|0;I=a+40|0;f[I>>2]=H;u=k;return}ZF(m);y=f[d>>2]|0;z=y+12|0;A=f[z>>2]|0;B=a+36|0;f[B>>2]=A;C=a+33|0;b[C>>0]=0;D=f[q>>2]|0;E=f[D>>2]|0;F=E>>>3;G=F&511;H=G+1|0;I=a+40|0;f[I>>2]=H;u=k;return}function H1(a,c,d,e,g){a=a|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+144|0;i=h+88|0;j=h+32|0;k=h+16|0;l=h;JR(i,a,0,1,0,0);JR(j,c,0,1,0,0);c=i+40|0;a=f[c>>2]|0;m=f[a+-4>>2]|0;n=j+40|0;o=f[n>>2]|0;a:do if((m|0)==(f[o+-4>>2]|0)){if((m|0)==2){if((f[a>>2]|0)!=(f[o>>2]|0)){p=10;break}if((f[a+4>>2]|0)!=(f[o+4>>2]|0)){p=10;break}}else if((m|0)>0){q=0;do{if((f[a+(q<<2)>>2]|0)!=(f[o+(q<<2)>>2]|0)){p=10;break a}q=q+1|0}while((q|0)<(m|0))}if(!((f[i>>2]&7|0)==0?!(f[j>>2]&4095|0):0))p=10}else p=10;while(0);if((p|0)==10){f[k>>2]=0;f[k+4>>2]=0;p=c$(k,59)|0;m=205056;o=p+59|0;do{b[p>>0]=b[m>>0]|0;p=p+1|0;m=m+1|0}while((p|0)<(o|0));j$(-215,k,205116,204349,1147);d$(k)}f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=i;m=l+8|0;f[m>>2]=0;f[m+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=j;n1(k,l,d,e,g&255,(g|0)<0);g=j+36|0;l=f[g>>2]|0;if(l|0?(k=l+12|0,l=f[k>>2]|0,f[k>>2]=l+-1,(l|0)==1):0)CR(j);f[g>>2]=0;g=j+16|0;l=j+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[l>>2]|0)>0){g=f[n>>2]|0;n=0;do{f[g+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[l>>2]|0))}l=f[j+44>>2]|0;if((l|0)!=(j+48|0))ZF(l);l=i+36|0;j=f[l>>2]|0;if(j|0?(n=j+12|0,j=f[n>>2]|0,f[n>>2]=j+-1,(j|0)==1):0)CR(i);f[l>>2]=0;l=i+16|0;j=i+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[j>>2]|0)>0){l=f[c>>2]|0;c=0;do{f[l+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)==(i+48|0)){u=h;return}ZF(j);u=h;return}function I1(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0,h=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=NYa(136)|0;WF(c);f[c>>2]=45448;p[c+8>>3]=b;f[c+16>>2]=d;f[c+20>>2]=e;f[c+24>>2]=1124007936;e=c+32|0;d=c+64|0;g=c+28|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[d>>2]=e;e=c+72|0;f[c+68>>2]=e;f[e>>2]=0;f[c+76>>2]=0;f[c+80>>2]=1124007936;e=c+88|0;d=c+120|0;g=c+84|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[d>>2]=e;e=c+128|0;f[c+124>>2]=e;f[e>>2]=0;f[c+132>>2]=0;e=NYa(16)|0;d=e+4|0;f[d>>2]=1;f[e>>2]=45512;f[e+8>>2]=c;f[a>>2]=e;f[a+4>>2]=c;f[d>>2]=(f[d>>2]|0)+1;c=f[d>>2]|0;f[d>>2]=c+-1;if((c|0)!=1)return;ki[f[(f[e>>2]|0)+8>>2]&2047](e);return}function J1(a){a=a|0;PYa(a);return}function K1(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function L1(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=45448;b=a+80|0;c=a+116|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+96|0;b=a+84|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+120>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+124>>2]|0;if((b|0)!=(a+128|0))ZF(b);b=a+24|0;d=a+60|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+40|0;b=a+28|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+64>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){OF(a);return}ZF(b);OF(a);return}function M1(a){a=a|0;L1(a);PYa(a);return}function N1(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;e=u;u=u+272|0;g=e+248|0;h=e+240|0;i=e+56|0;j=e+232|0;k=e+224|0;l=e+216|0;m=e+208|0;o=e+144|0;q=e+80|0;r=e;s=e+72|0;t=e+152|0;v=e+88|0;_$(h,45524);if(RR(c,-1)|0?(RR(c,-1)|0)!=2:0){f[g>>2]=0;f[g+4>>2]=0;w=c$(g,116)|0;x=205206;y=w+116|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));j$(-215,g,345174,205323,360);d$(g)}z=(RR(c,-1)|0)==0;A=z?256:65536;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;QR(j,c,-1);z=a+16|0;if(!((f[j>>2]|0)%(f[z>>2]|0)|0)){QR(k,c,-1);j=a+20|0;B=f[j>>2]|0;if(!((f[k+4>>2]|0)%(B|0)|0)){QR(l,c,-1);k=f[l>>2]|0;l=f[z>>2]|0;QR(m,c,-1);C=(f[m+4>>2]|0)/(f[j>>2]|0)|0;m=c;D=f[m+4>>2]|0;E=i;f[E>>2]=f[m>>2];f[E+4>>2]=D;f[i+8>>2]=f[c+8>>2];F=f[c+12>>2]|0;G=(k|0)/(l|0)|0;H=C}else{I=B;J=j;K=8}}else{j=a+20|0;I=f[j>>2]|0;J=j;K=8}if((K|0)==8){K=a+24|0;j=g+8|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=K;QR(o,c,-1);j=f[o+4>>2]|0;o=f[J>>2]|0;B=f[z>>2]|0;QR(q,c,-1);C=f[q>>2]|0;q=f[z>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;f[r+24>>2]=0;f[r+28>>2]=0;mL(c,g,0,I-((j|0)%(o|0)|0)|0,0,B-((C|0)%(q|0)|0)|0,4,r);q=f[a+64>>2]|0;C=(f[q+4>>2]|0)/(f[z>>2]|0)|0;B=(f[q>>2]|0)/(f[J>>2]|0)|0;f[i>>2]=16842752;f[i+4>>2]=K;f[i+8>>2]=0;F=0;G=C;H=B}f[i+12>>2]=F;F=Y(H,G)|0;L=+(A+-1|0)/+(F|0);M=+p[a+8>>3];if(M>0.0){B=~~(M*+(F|0)/+(A|0));N=(B|0)>1?B:1}else N=0;do if((NS(c)|0)==65536){B=f[c+4>>2]|0;f[r>>2]=f[B>>2];F=r+4|0;C=B+4|0;f[F>>2]=f[C>>2];K=r+8|0;f[K>>2]=f[B+8>>2];f[r+12>>2]=f[B+12>>2];f[r+16>>2]=f[B+16>>2];f[r+20>>2]=f[B+20>>2];f[r+24>>2]=f[B+24>>2];f[r+28>>2]=f[B+28>>2];f[r+32>>2]=f[B+32>>2];J=f[B+36>>2]|0;f[r+36>>2]=J;q=r+40|0;f[q>>2]=K;K=r+48|0;o=r+44|0;f[o>>2]=K;f[K>>2]=0;f[r+52>>2]=0;if(J|0){K=J+12|0;f[K>>2]=(f[K>>2]|0)+1}if((f[C>>2]|0)<3){C=f[B+44>>2]|0;K=f[o>>2]|0;f[K>>2]=f[C>>2];f[K+4>>2]=f[C+4>>2];O=r;P=q;break}else{f[F>>2]=0;BR(r,B);O=r;P=q;break}}else{OR(r,c,-1);O=r;P=r+40|0}while(0);q=f[P>>2]|0;B=f[q>>2]|0;f[s>>2]=f[q+4>>2];f[s+4>>2]=B;KS(d,s,f[O>>2]&4095,-1,0,0);do if((NS(d)|0)==65536){s=f[d+4>>2]|0;f[t>>2]=f[s>>2];B=t+4|0;q=s+4|0;f[B>>2]=f[q>>2];F=t+8|0;f[F>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];f[t+24>>2]=f[s+24>>2];f[t+28>>2]=f[s+28>>2];f[t+32>>2]=f[s+32>>2];C=f[s+36>>2]|0;f[t+36>>2]=C;f[t+40>>2]=F;F=t+48|0;K=t+44|0;f[K>>2]=F;f[F>>2]=0;f[t+52>>2]=0;if(C|0){F=C+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[q>>2]|0)<3){q=f[s+44>>2]|0;F=f[K>>2]|0;f[F>>2]=f[q>>2];f[F+4>>2]=f[q+4>>2];break}else{f[B>>2]=0;BR(t,s);break}}else OR(t,d,-1);while(0);do if((NS(i)|0)==65536){d=f[i+4>>2]|0;f[v>>2]=f[d>>2];s=v+4|0;B=d+4|0;f[s>>2]=f[B>>2];q=v+8|0;f[q>>2]=f[d+8>>2];f[v+12>>2]=f[d+12>>2];f[v+16>>2]=f[d+16>>2];f[v+20>>2]=f[d+20>>2];f[v+24>>2]=f[d+24>>2];f[v+28>>2]=f[d+28>>2];f[v+32>>2]=f[d+32>>2];F=f[d+36>>2]|0;f[v+36>>2]=F;f[v+40>>2]=q;q=v+48|0;K=v+44|0;f[K>>2]=q;f[q>>2]=0;f[v+52>>2]=0;if(F|0){q=F+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[B>>2]|0)<3){B=f[d+44>>2]|0;q=f[K>>2]|0;f[q>>2]=f[B>>2];f[q+4>>2]=f[B+4>>2];break}else{f[s>>2]=0;BR(v,d);break}}else OR(v,i,-1);while(0);i=a+80|0;d=f[z>>2]|0;s=a+20|0;B=f[s>>2]|0;q=Y(B,d)|0;d=(RR(c,-1)|0)&4095;B=a+84|0;if(!(((((f[B>>2]|0)<3?(f[a+88>>2]|0)==(q|0):0)?(f[a+92>>2]|0)==(A|0):0)?(f[i>>2]&4095|0)==(d|0):0)?(f[a+96>>2]|0)!=0:0)){f[g>>2]=q;f[g+4>>2]=A;AR(i,2,g,d)}do if(!(RR(c,-1)|0)){d=NYa(136)|0;f[d>>2]=45552;A=d+4|0;f[A>>2]=f[v>>2];q=d+8|0;K=v+4|0;F=f[K>>2]|0;f[q>>2]=F;C=d+12|0;f[C>>2]=f[v+8>>2];f[d+16>>2]=f[v+12>>2];f[d+20>>2]=f[v+16>>2];f[d+24>>2]=f[v+20>>2];f[d+28>>2]=f[v+24>>2];f[d+32>>2]=f[v+28>>2];f[d+36>>2]=f[v+32>>2];o=f[v+36>>2]|0;f[d+40>>2]=o;f[d+44>>2]=C;C=d+52|0;J=d+48|0;f[J>>2]=C;f[C>>2]=0;f[d+56>>2]=0;if(!o)Q=F;else{F=o+12|0;f[F>>2]=(f[F>>2]|0)+1;Q=f[K>>2]|0}if((Q|0)<3){K=f[v+44>>2]|0;F=f[J>>2]|0;f[F>>2]=f[K>>2];f[F+4>>2]=f[K+4>>2]}else{f[q>>2]=0;BR(A,v)}A=d+60|0;f[A>>2]=f[i>>2];q=d+64|0;K=f[B>>2]|0;f[q>>2]=K;F=d+68|0;f[F>>2]=f[a+88>>2];f[d+72>>2]=f[a+92>>2];f[d+76>>2]=f[a+96>>2];f[d+80>>2]=f[a+100>>2];f[d+84>>2]=f[a+104>>2];f[d+88>>2]=f[a+108>>2];f[d+92>>2]=f[a+112>>2];J=f[a+116>>2]|0;f[d+96>>2]=J;f[d+100>>2]=F;F=d+108|0;o=d+104|0;f[o>>2]=F;f[F>>2]=0;f[d+112>>2]=0;if(!J)R=K;else{K=J+12|0;f[K>>2]=(f[K>>2]|0)+1;R=f[B>>2]|0}if((R|0)<3){K=f[a+124>>2]|0;J=f[o>>2]|0;f[J>>2]=f[K>>2];f[J+4>>2]=f[K+4>>2]}else{f[q>>2]=0;BR(A,i)}f[d+116>>2]=G;f[d+120>>2]=H;f[d+124>>2]=f[z>>2];f[d+128>>2]=N;n[d+132>>2]=L;A=NYa(16)|0;q=A+4|0;f[q>>2]=1;f[A>>2]=45572;f[A+8>>2]=d;K=A;J=d;f[q>>2]=(f[q>>2]|0)+1;d=f[q>>2]|0;f[q>>2]=d+-1;if((d|0)==1){ki[f[(f[A>>2]|0)+8>>2]&2047](A);S=K;T=J}else{S=K;T=J}}else{if((RR(c,-1)|0)!=2){f[g>>2]=0;f[g+4>>2]=0;w=c$(g,16)|0;x=205373;y=w+16|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));j$(-5,g,345174,205323,425);d$(g);S=0;T=0;break}J=NYa(136)|0;f[J>>2]=45592;K=J+4|0;f[K>>2]=f[v>>2];A=J+8|0;d=v+4|0;q=f[d>>2]|0;f[A>>2]=q;o=J+12|0;f[o>>2]=f[v+8>>2];f[J+16>>2]=f[v+12>>2];f[J+20>>2]=f[v+16>>2];f[J+24>>2]=f[v+20>>2];f[J+28>>2]=f[v+24>>2];f[J+32>>2]=f[v+28>>2];f[J+36>>2]=f[v+32>>2];F=f[v+36>>2]|0;f[J+40>>2]=F;f[J+44>>2]=o;o=J+52|0;C=J+48|0;f[C>>2]=o;f[o>>2]=0;f[J+56>>2]=0;if(!F)U=q;else{q=F+12|0;f[q>>2]=(f[q>>2]|0)+1;U=f[d>>2]|0}if((U|0)<3){d=f[v+44>>2]|0;q=f[C>>2]|0;f[q>>2]=f[d>>2];f[q+4>>2]=f[d+4>>2]}else{f[A>>2]=0;BR(K,v)}K=J+60|0;f[K>>2]=f[i>>2];A=J+64|0;d=f[B>>2]|0;f[A>>2]=d;q=J+68|0;f[q>>2]=f[a+88>>2];f[J+72>>2]=f[a+92>>2];f[J+76>>2]=f[a+96>>2];f[J+80>>2]=f[a+100>>2];f[J+84>>2]=f[a+104>>2];f[J+88>>2]=f[a+108>>2];f[J+92>>2]=f[a+112>>2];C=f[a+116>>2]|0;f[J+96>>2]=C;f[J+100>>2]=q;q=J+108|0;F=J+104|0;f[F>>2]=q;f[q>>2]=0;f[J+112>>2]=0;if(!C)V=d;else{d=C+12|0;f[d>>2]=(f[d>>2]|0)+1;V=f[B>>2]|0}if((V|0)<3){d=f[a+124>>2]|0;C=f[F>>2]|0;f[C>>2]=f[d>>2];f[C+4>>2]=f[d+4>>2]}else{f[A>>2]=0;BR(K,i)}f[J+116>>2]=G;f[J+120>>2]=H;f[J+124>>2]=f[z>>2];f[J+128>>2]=N;n[J+132>>2]=L;K=NYa(16)|0;A=K+4|0;f[A>>2]=1;f[K>>2]=45612;f[K+8>>2]=J;d=K;C=J;f[A>>2]=(f[A>>2]|0)+1;J=f[A>>2]|0;f[A>>2]=J+-1;if((J|0)==1){ki[f[(f[K>>2]|0)+8>>2]&2047](K);S=d;T=C}else{S=d;T=C}}while(0);N=Y(f[s>>2]|0,f[z>>2]|0)|0;f[g>>2]=0;f[g+4>>2]=N;_U(g,T,-1.0);do if(!(RR(c,-1)|0)){T=NYa(1268)|0;f[T>>2]=45632;N=T+4|0;f[N>>2]=f[O>>2];V=T+8|0;U=r+4|0;x=f[U>>2]|0;f[V>>2]=x;w=T+12|0;y=r+8|0;f[w>>2]=f[y>>2];R=r+12|0;f[T+16>>2]=f[R>>2];f[T+20>>2]=f[r+16>>2];f[T+24>>2]=f[r+20>>2];f[T+28>>2]=f[r+24>>2];f[T+32>>2]=f[r+28>>2];f[T+36>>2]=f[r+32>>2];Q=f[r+36>>2]|0;f[T+40>>2]=Q;f[T+44>>2]=w;w=T+52|0;C=T+48|0;f[C>>2]=w;f[w>>2]=0;f[T+56>>2]=0;if(!Q)W=x;else{x=Q+12|0;f[x>>2]=(f[x>>2]|0)+1;W=f[U>>2]|0}if((W|0)<3){U=f[r+44>>2]|0;x=f[C>>2]|0;f[x>>2]=f[U>>2];f[x+4>>2]=f[U+4>>2]}else{f[V>>2]=0;BR(N,r)}N=T+60|0;f[N>>2]=f[t>>2];V=T+64|0;U=t+4|0;x=f[U>>2]|0;f[V>>2]=x;C=T+68|0;f[C>>2]=f[t+8>>2];f[T+72>>2]=f[t+12>>2];f[T+76>>2]=f[t+16>>2];f[T+80>>2]=f[t+20>>2];f[T+84>>2]=f[t+24>>2];f[T+88>>2]=f[t+28>>2];f[T+92>>2]=f[t+32>>2];Q=f[t+36>>2]|0;f[T+96>>2]=Q;f[T+100>>2]=C;C=T+108|0;w=T+104|0;f[w>>2]=C;f[C>>2]=0;f[T+112>>2]=0;if(!Q)X=x;else{x=Q+12|0;f[x>>2]=(f[x>>2]|0)+1;X=f[U>>2]|0}if((X|0)<3){U=f[t+44>>2]|0;x=f[w>>2]|0;f[x>>2]=f[U>>2];f[x+4>>2]=f[U+4>>2]}else{f[V>>2]=0;BR(N,t)}N=T+116|0;f[N>>2]=f[i>>2];V=T+120|0;U=f[B>>2]|0;f[V>>2]=U;x=T+124|0;f[x>>2]=f[a+88>>2];f[T+128>>2]=f[a+92>>2];f[T+132>>2]=f[a+96>>2];f[T+136>>2]=f[a+100>>2];f[T+140>>2]=f[a+104>>2];f[T+144>>2]=f[a+108>>2];f[T+148>>2]=f[a+112>>2];w=f[a+116>>2]|0;f[T+152>>2]=w;f[T+156>>2]=x;x=T+164|0;Q=T+160|0;f[Q>>2]=x;f[x>>2]=0;f[T+168>>2]=0;if(!w)Z=U;else{U=w+12|0;f[U>>2]=(f[U>>2]|0)+1;Z=f[B>>2]|0}if((Z|0)<3){U=f[a+124>>2]|0;w=f[Q>>2]|0;f[w>>2]=f[U>>2];f[w+4>>2]=f[U+4>>2]}else{f[V>>2]=0;BR(N,i)}f[T+172>>2]=G;f[T+176>>2]=H;N=T+180|0;V=f[z>>2]|0;f[N>>2]=V;f[T+184>>2]=f[s>>2];U=T+188|0;w=T+196|0;f[U>>2]=w;Q=f[R>>2]|0;R=Q<<2;f[T+192>>2]=R;if(R>>>0>264){C=OYa(R>>>0>1073741823?-1:R<<2)|0;f[U>>2]=C;_=C}else _=w;f[T+1252>>2]=_;w=_+(Q<<2)|0;f[T+1256>>2]=w;C=w+(Q<<2)|0;f[T+1260>>2]=C;U=C+(Q<<2)|0;f[T+1264>>2]=U;R=f[x>>2]|0;L=1.0/+(G|0);a:do if((Q|0)>0){x=Q+-1|0;d=V;K=0;while(1){M=L*+(K|0)+-.5;J=~~M;A=J-(+(J|0)>M&1)|0;J=A+1|0;$=M-+(A|0);n[C+(K<<2)>>2]=$;n[U+(K<<2)>>2]=1.0-$;F=d+-1|0;q=Y((A|0)>0?A:0,R)|0;f[_+(K<<2)>>2]=q;q=Y((F|0)<(J|0)?F:J,R)|0;f[w+(K<<2)>>2]=q;if((K|0)==(x|0))break a;d=f[N>>2]|0;K=K+1|0}}while(0);N=NYa(16)|0;w=N+4|0;f[w>>2]=1;f[N>>2]=45652;f[N+8>>2]=T;R=N;U=T;f[w>>2]=(f[w>>2]|0)+1;C=f[w>>2]|0;f[w>>2]=C+-1;if((C|0)==1){ki[f[(f[N>>2]|0)+8>>2]&2047](N);aa=R;ba=U;ca=y}else{aa=R;ba=U;ca=y}}else{if((RR(c,-1)|0)!=2){aa=0;ba=0;ca=r+8|0;break}U=NYa(1268)|0;f[U>>2]=45672;R=U+4|0;f[R>>2]=f[O>>2];N=U+8|0;C=r+4|0;w=f[C>>2]|0;f[N>>2]=w;V=U+12|0;Q=r+8|0;f[V>>2]=f[Q>>2];K=r+12|0;f[U+16>>2]=f[K>>2];f[U+20>>2]=f[r+16>>2];f[U+24>>2]=f[r+20>>2];f[U+28>>2]=f[r+24>>2];f[U+32>>2]=f[r+28>>2];f[U+36>>2]=f[r+32>>2];d=f[r+36>>2]|0;f[U+40>>2]=d;f[U+44>>2]=V;V=U+52|0;x=U+48|0;f[x>>2]=V;f[V>>2]=0;f[U+56>>2]=0;if(!d)da=w;else{w=d+12|0;f[w>>2]=(f[w>>2]|0)+1;da=f[C>>2]|0}if((da|0)<3){C=f[r+44>>2]|0;w=f[x>>2]|0;f[w>>2]=f[C>>2];f[w+4>>2]=f[C+4>>2]}else{f[N>>2]=0;BR(R,r)}R=U+60|0;f[R>>2]=f[t>>2];N=U+64|0;C=t+4|0;w=f[C>>2]|0;f[N>>2]=w;x=U+68|0;f[x>>2]=f[t+8>>2];f[U+72>>2]=f[t+12>>2];f[U+76>>2]=f[t+16>>2];f[U+80>>2]=f[t+20>>2];f[U+84>>2]=f[t+24>>2];f[U+88>>2]=f[t+28>>2];f[U+92>>2]=f[t+32>>2];d=f[t+36>>2]|0;f[U+96>>2]=d;f[U+100>>2]=x;x=U+108|0;V=U+104|0;f[V>>2]=x;f[x>>2]=0;f[U+112>>2]=0;if(!d)ea=w;else{w=d+12|0;f[w>>2]=(f[w>>2]|0)+1;ea=f[C>>2]|0}if((ea|0)<3){C=f[t+44>>2]|0;w=f[V>>2]|0;f[w>>2]=f[C>>2];f[w+4>>2]=f[C+4>>2]}else{f[N>>2]=0;BR(R,t)}R=U+116|0;f[R>>2]=f[i>>2];N=U+120|0;C=f[B>>2]|0;f[N>>2]=C;w=U+124|0;f[w>>2]=f[a+88>>2];f[U+128>>2]=f[a+92>>2];f[U+132>>2]=f[a+96>>2];f[U+136>>2]=f[a+100>>2];f[U+140>>2]=f[a+104>>2];f[U+144>>2]=f[a+108>>2];f[U+148>>2]=f[a+112>>2];V=f[a+116>>2]|0;f[U+152>>2]=V;f[U+156>>2]=w;w=U+164|0;d=U+160|0;f[d>>2]=w;f[w>>2]=0;f[U+168>>2]=0;if(!V)fa=C;else{C=V+12|0;f[C>>2]=(f[C>>2]|0)+1;fa=f[B>>2]|0}if((fa|0)<3){C=f[a+124>>2]|0;V=f[d>>2]|0;f[V>>2]=f[C>>2];f[V+4>>2]=f[C+4>>2]}else{f[N>>2]=0;BR(R,i)}f[U+172>>2]=G;f[U+176>>2]=H;R=U+180|0;N=f[z>>2]|0;f[R>>2]=N;f[U+184>>2]=f[s>>2];C=U+188|0;V=U+196|0;f[C>>2]=V;d=f[K>>2]|0;K=d<<2;f[U+192>>2]=K;if(K>>>0>264){x=OYa(K>>>0>1073741823?-1:K<<2)|0;f[C>>2]=x;ga=x}else ga=V;f[U+1252>>2]=ga;V=ga+(d<<2)|0;f[U+1256>>2]=V;x=V+(d<<2)|0;f[U+1260>>2]=x;C=x+(d<<2)|0;f[U+1264>>2]=C;K=(f[w>>2]|0)>>>1;L=1.0/+(G|0);b:do if((d|0)>0){w=d+-1|0;q=N;J=0;while(1){$=L*+(J|0)+-.5;F=~~$;A=F-(+(F|0)>$&1)|0;F=A+1|0;M=$-+(A|0);n[x+(J<<2)>>2]=M;n[C+(J<<2)>>2]=1.0-M;o=q+-1|0;j=Y((A|0)>0?A:0,K)|0;f[ga+(J<<2)>>2]=j;j=Y((o|0)<(F|0)?o:F,K)|0;f[V+(J<<2)>>2]=j;if((J|0)==(w|0))break b;q=f[R>>2]|0;J=J+1|0}}while(0);R=NYa(16)|0;V=R+4|0;f[V>>2]=1;f[R>>2]=45692;f[R+8>>2]=U;K=R;C=U;f[V>>2]=(f[V>>2]|0)+1;x=f[V>>2]|0;f[V>>2]=x+-1;if((x|0)==1){ki[f[(f[R>>2]|0)+8>>2]&2047](R);aa=K;ba=C;ca=Q}else{aa=K;ba=C;ca=Q}}while(0);ga=f[ca>>2]|0;f[g>>2]=0;f[g+4>>2]=ga;_U(g,ba,-1.0);ba=aa;if(aa|0?(g=ba+4|0,ga=f[g>>2]|0,f[g>>2]=ga+-1,(ga|0)==1):0)ki[f[(f[aa>>2]|0)+8>>2]&2047](ba);ba=S;if(S|0?(aa=ba+4|0,ga=f[aa>>2]|0,f[aa>>2]=ga+-1,(ga|0)==1):0)ki[f[(f[S>>2]|0)+8>>2]&2047](ba);ba=v+36|0;S=f[ba>>2]|0;if(S|0?(ga=S+12|0,S=f[ga>>2]|0,f[ga>>2]=S+-1,(S|0)==1):0)CR(v);f[ba>>2]=0;ba=v+16|0;S=v+4|0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[S>>2]|0)>0){ba=f[v+40>>2]|0;ga=0;do{f[ba+(ga<<2)>>2]=0;ga=ga+1|0}while((ga|0)<(f[S>>2]|0))}S=f[v+44>>2]|0;if((S|0)!=(v+48|0))ZF(S);S=t+36|0;v=f[S>>2]|0;if(v|0?(ga=v+12|0,v=f[ga>>2]|0,f[ga>>2]=v+-1,(v|0)==1):0)CR(t);f[S>>2]=0;S=t+16|0;v=t+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[v>>2]|0)>0){S=f[t+40>>2]|0;ga=0;do{f[S+(ga<<2)>>2]=0;ga=ga+1|0}while((ga|0)<(f[v>>2]|0))}v=f[t+44>>2]|0;if((v|0)!=(t+48|0))ZF(v);v=r+36|0;t=f[v>>2]|0;if(t|0?(ga=t+12|0,t=f[ga>>2]|0,f[ga>>2]=t+-1,(t|0)==1):0)CR(r);f[v>>2]=0;v=r+16|0;t=r+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[t>>2]|0)>0){v=f[P>>2]|0;P=0;do{f[v+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[t>>2]|0))}t=f[r+44>>2]|0;if((t|0)!=(r+48|0))ZF(t);if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function O1(a,b){a=a|0;b=+b;p[a+8>>3]=b;return}function P1(a){a=a|0;return +(+p[a+8>>3])}function Q1(a,b){a=a|0;b=b|0;f[a+16>>2]=f[b>>2];f[a+20>>2]=f[b+4>>2];return}function R1(a,b){a=a|0;b=b|0;var c=0;c=f[b+20>>2]|0;f[a>>2]=f[b+16>>2];f[a+4>>2]=c;return}function S1(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=a+80|0;d=a+116|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+96|0;b=a+84|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)<=0)return;d=f[a+120>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[b>>2]|0));return}function T1(a){a=a|0;PYa(a);return}function U1(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function V1(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=45672;b=a+188|0;c=f[b>>2]|0;d=a+196|0;if((c|0)!=(d|0)){if(c|0)QYa(c);f[b>>2]=d;f[a+192>>2]=264}d=a+116|0;b=a+152|0;c=f[b>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(d);f[b>>2]=0;b=a+132|0;d=a+120|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+156>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+160>>2]|0;if((d|0)!=(a+164|0))ZF(d);d=a+60|0;c=a+96|0;b=f[c>>2]|0;if(b|0?(e=b+12|0,b=f[e>>2]|0,f[e>>2]=b+-1,(b|0)==1):0)CR(d);f[c>>2]=0;c=a+76|0;d=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[d>>2]|0)>0){c=f[a+100>>2]|0;b=0;do{f[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[d>>2]|0))}d=f[a+104>>2]|0;if((d|0)!=(a+108|0))ZF(d);d=a+4|0;b=a+40|0;c=f[b>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(d);f[b>>2]=0;b=a+20|0;d=a+8|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+44>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+48>>2]|0;if((d|0)==(a+52|0))return;ZF(d);return}function W1(a){a=a|0;V1(a);PYa(a);return}function X1(a,b){a=a|0;b=b|0;var c=0.0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0.0,F=0.0;c=1.0/+(f[a+176>>2]|0);e=f[b>>2]|0;g=f[b+4>>2]|0;if((e|0)>=(g|0))return;b=f[a+20>>2]|0;h=f[f[a+48>>2]>>2]|0;i=f[a+76>>2]|0;k=f[f[a+104>>2]>>2]|0;l=(f[a+184>>2]|0)+-1|0;m=f[a+180>>2]|0;o=f[a+132>>2]|0;p=f[f[a+160>>2]>>2]|0;q=f[a+16>>2]|0;if((q|0)<=0)return;r=f[a+1252>>2]|0;s=f[a+1256>>2]|0;t=f[a+1264>>2]|0;u=f[a+1260>>2]|0;a=e;do{e=b+(Y(h,a)|0)|0;v=i+(Y(k,a)|0)|0;w=c*+(a|0)+-.5;x=~~w;y=x-(+(x|0)>w&1)|0;x=y+1|0;z=w-+(y|0);w=1.0-z;A=o+(Y(Y(m,(y|0)>0?y:0)|0,p)|0)|0;y=o+(Y(Y((l|0)<(x|0)?l:x,m)|0,p)|0)|0;x=0;do{B=j[e+(x<<1)>>1]|0;C=(f[r+(x<<2)>>2]|0)+B|0;D=(f[s+(x<<2)>>2]|0)+B|0;E=+n[t+(x<<2)>>2];F=+n[u+(x<<2)>>2];B=wNa(w*(+(j[A+(C<<1)>>1]|0)*E+ +(j[A+(D<<1)>>1]|0)*F)+z*(E*+(j[y+(C<<1)>>1]|0)+F*+(j[y+(D<<1)>>1]|0)))|0;d[v+(x<<1)>>1]=B>>>0<65536?B:(B|0)>0?65535:0;x=x+1|0}while((x|0)<(q|0));a=a+1|0}while((a|0)<(g|0));return}function Y1(a){a=a|0;PYa(a);return}function Z1(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function _1(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=45632;b=a+188|0;c=f[b>>2]|0;d=a+196|0;if((c|0)!=(d|0)){if(c|0)QYa(c);f[b>>2]=d;f[a+192>>2]=264}d=a+116|0;b=a+152|0;c=f[b>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(d);f[b>>2]=0;b=a+132|0;d=a+120|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+156>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+160>>2]|0;if((d|0)!=(a+164|0))ZF(d);d=a+60|0;c=a+96|0;b=f[c>>2]|0;if(b|0?(e=b+12|0,b=f[e>>2]|0,f[e>>2]=b+-1,(b|0)==1):0)CR(d);f[c>>2]=0;c=a+76|0;d=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[d>>2]|0)>0){c=f[a+100>>2]|0;b=0;do{f[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[d>>2]|0))}d=f[a+104>>2]|0;if((d|0)!=(a+108|0))ZF(d);d=a+4|0;b=a+40|0;c=f[b>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(d);f[b>>2]=0;b=a+20|0;d=a+8|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+44>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+48>>2]|0;if((d|0)==(a+52|0))return;ZF(d);return}function $1(a){a=a|0;_1(a);PYa(a);return}function a2(a,c){a=a|0;c=c|0;var d=0.0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0,K=0,L=0;d=1.0/+(f[a+176>>2]|0);e=f[c>>2]|0;g=c+4|0;c=f[g>>2]|0;if((e|0)>=(c|0))return;i=a+20|0;j=a+48|0;k=a+76|0;l=a+104|0;m=a+184|0;o=a+180|0;p=a+132|0;q=a+160|0;r=a+16|0;s=a+1252|0;t=a+1256|0;u=a+1264|0;v=a+1260|0;a=f[r>>2]|0;w=c;c=e;while(1){e=(f[i>>2]|0)+(Y(f[f[j>>2]>>2]|0,c)|0)|0;x=(f[k>>2]|0)+(Y(f[f[l>>2]>>2]|0,c)|0)|0;y=d*+(c|0)+-.5;z=~~y;A=z-(+(z|0)>y&1)|0;z=A+1|0;B=y-+(A|0);y=1.0-B;C=(f[m>>2]|0)+-1|0;D=f[o>>2]|0;E=Y(D,(A|0)>0?A:0)|0;A=f[p>>2]|0;F=f[f[q>>2]>>2]|0;G=A+(Y(E,F)|0)|0;E=A+(Y(Y((C|0)<(z|0)?C:z,D)|0,F)|0)|0;if((a|0)>0){F=0;do{D=h[e+F>>0]|0;z=(f[(f[s>>2]|0)+(F<<2)>>2]|0)+D|0;C=(f[(f[t>>2]|0)+(F<<2)>>2]|0)+D|0;H=+n[(f[u>>2]|0)+(F<<2)>>2];I=+n[(f[v>>2]|0)+(F<<2)>>2];D=wNa(y*(+(h[G+z>>0]|0)*H+ +(h[G+C>>0]|0)*I)+B*(H*+(h[E+z>>0]|0)+I*+(h[E+C>>0]|0)))|0;b[x+F>>0]=D>>>0<256?D:(D|0)>0?255:0;F=F+1|0;J=f[r>>2]|0}while((F|0)<(J|0));K=f[g>>2]|0;L=J}else{K=w;L=a}c=c+1|0;if((c|0)>=(K|0))break;else{a=L;w=K}}return}function b2(a){a=a|0;PYa(a);return}function c2(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function d2(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=45592;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function e2(a){a=a|0;d2(a);PYa(a);return}function f2(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0;c=u;u=u+262224|0;e=c+262200|0;g=c+262144|0;h=c;i=f[b>>2]|0;k=(f[a+108>>2]|0)>>>1;l=b+4|0;if((i|0)>=(f[l>>2]|0)){u=c;return}b=a+124|0;m=a+116|0;o=a+120|0;p=e+4|0;q=e+8|0;r=e+12|0;s=a+4|0;t=a+52|0;v=g+16|0;w=g+44|0;x=a+128|0;y=a+132|0;z=g+36|0;A=g+4|0;B=g+40|0;C=g+48|0;D=i;E=(f[a+76>>2]|0)+(Y(f[f[a+104>>2]>>2]|0,i)|0)|0;while(1){i=f[b>>2]|0;a=f[m>>2]|0;F=Y(a,(D|0)%(i|0)|0)|0;f[e>>2]=F;F=f[o>>2]|0;G=Y(F,(D|0)/(i|0)|0)|0;f[p>>2]=G;f[q>>2]=a;f[r>>2]=F;FR(g,s,e);F1a(h|0,0,262144)|0;F=f[r>>2]|0;a=(f[t>>2]|0)>>>1;G=f[v>>2]|0;i=F+-1|0;a:do if(F|0){H=f[q>>2]|0;I=H+-4|0;if((H|0)<4){J=(H|0)>0;K=i;L=G;while(1){if(J){M=0;do{N=h+((j[L+(M<<1)>>1]|0)<<2)|0;f[N>>2]=(f[N>>2]|0)+1;M=M+1|0}while((M|0)!=(H|0))}if(!K)break a;else{K=K+-1|0;L=L+(a<<1)|0}}}L=H&-4;K=(L|0)<(H|0);J=i;M=G;while(1){N=0;do{O=j[M+((N|1)<<1)>>1]|0;P=h+((j[M+(N<<1)>>1]|0)<<2)|0;f[P>>2]=(f[P>>2]|0)+1;P=h+(O<<2)|0;f[P>>2]=(f[P>>2]|0)+1;P=j[M+((N|3)<<1)>>1]|0;O=h+((j[M+((N|2)<<1)>>1]|0)<<2)|0;f[O>>2]=(f[O>>2]|0)+1;O=h+(P<<2)|0;f[O>>2]=(f[O>>2]|0)+1;N=N+4|0}while((N|0)<=(I|0));if(K){N=L;do{O=h+((j[M+(N<<1)>>1]|0)<<2)|0;f[O>>2]=(f[O>>2]|0)+1;N=N+1|0}while((N|0)!=(H|0))}if(!J)break;else{J=J+-1|0;M=M+(a<<1)|0}}}while(0);a=f[x>>2]|0;if((a|0)>0){G=0;i=0;while(1){F=h+(i<<2)|0;M=f[F>>2]|0;if((M|0)>(a|0)){f[F>>2]=a;Q=M+G-a|0}else Q=G;i=i+1|0;if((i|0)==65536)break;else G=Q}G=(Q|0)/65536|0;i=G<<16;a=0;do{M=h+(a<<2)|0;f[M>>2]=(f[M>>2]|0)+G;a=a+1|0}while((a|0)!=65536);a=Q-i|0;if(a|0?(G=65536/(a|0)|0,M=(G|0)>1?G:1,(a|0)>0):0){G=0;F=a;while(1){a=h+(G<<2)|0;f[a>>2]=(f[a>>2]|0)+1;G=G+M|0;if(!((F|0)>1&(G|0)<65536))break;else F=F+-1|0}}}R=+n[y>>2];F=0;G=0;do{G=(f[h+(F<<2)>>2]|0)+G|0;M=wNa(R*+(G|0))|0;d[E+(F<<1)>>1]=M>>>0<65536?M:(M|0)>0?65535:0;F=F+1|0}while((F|0)!=65536);F=f[z>>2]|0;if(F|0?(G=F+12|0,F=f[G>>2]|0,f[G>>2]=F+-1,(F|0)==1):0)CR(g);f[z>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[A>>2]|0)>0){F=f[B>>2]|0;G=0;do{f[F+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[A>>2]|0))}G=f[w>>2]|0;if((G|0)!=(C|0))ZF(G);D=D+1|0;if((D|0)>=(f[l>>2]|0))break;else E=E+(k<<1)|0}u=c;return}function g2(a){a=a|0;PYa(a);return}function h2(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function i2(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=45552;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function j2(a){a=a|0;i2(a);PYa(a);return}function k2(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=u;u=u+1104|0;e=d+1080|0;g=d+1024|0;i=d;j=f[c>>2]|0;k=f[a+108>>2]|0;l=c+4|0;if((j|0)>=(f[l>>2]|0)){u=d;return}c=a+124|0;m=a+116|0;o=a+120|0;p=e+4|0;q=e+8|0;r=e+12|0;s=a+4|0;t=a+52|0;v=g+16|0;w=g+44|0;x=a+128|0;y=a+132|0;z=g+36|0;A=g+4|0;B=g+40|0;C=g+48|0;D=j;E=(f[a+76>>2]|0)+(Y(f[f[a+104>>2]>>2]|0,j)|0)|0;while(1){j=f[c>>2]|0;a=f[m>>2]|0;F=Y(a,(D|0)%(j|0)|0)|0;f[e>>2]=F;F=f[o>>2]|0;G=Y(F,(D|0)/(j|0)|0)|0;f[p>>2]=G;f[q>>2]=a;f[r>>2]=F;FR(g,s,e);F1a(i|0,0,1024)|0;F=f[r>>2]|0;a=f[t>>2]|0;if(F|0){G=f[q>>2]|0;j=(G|0)<4;H=G+-4|0;I=F;F=f[v>>2]|0;while(1){I=I+-1|0;if(j)J=0;else{K=0;while(1){L=h[F+(K|1)>>0]|0;M=i+((h[F+K>>0]|0)<<2)|0;f[M>>2]=(f[M>>2]|0)+1;M=i+(L<<2)|0;f[M>>2]=(f[M>>2]|0)+1;M=h[F+(K|3)>>0]|0;L=i+((h[F+(K|2)>>0]|0)<<2)|0;f[L>>2]=(f[L>>2]|0)+1;L=i+(M<<2)|0;f[L>>2]=(f[L>>2]|0)+1;L=K+4|0;if((L|0)>(H|0)){J=L;break}else K=L}}if((J|0)<(G|0)){K=J;do{L=i+((h[F+K>>0]|0)<<2)|0;f[L>>2]=(f[L>>2]|0)+1;K=K+1|0}while((K|0)!=(G|0))}if(!I)break;else F=F+a|0}}a=f[x>>2]|0;if((a|0)>0){F=0;I=0;while(1){G=i+(I<<2)|0;H=f[G>>2]|0;if((H|0)>(a|0)){f[G>>2]=a;N=H+F-a|0}else N=F;I=I+1|0;if((I|0)==256)break;else F=N}F=(N|0)/256|0;I=F<<8;a=0;do{H=i+(a<<2)|0;f[H>>2]=(f[H>>2]|0)+F;a=a+1|0}while((a|0)!=256);a=N-I|0;if((a|0)!=0?(F=256/(a|0)|0,H=(F|0)>1?F:1,(a|0)>0):0){F=0;G=a;while(1){a=i+(F<<2)|0;f[a>>2]=(f[a>>2]|0)+1;F=F+H|0;if(!((G|0)>1&(F|0)<256)){O=0;P=0;break}else G=G+-1|0}}else{O=0;P=0}}else{O=0;P=0}do{P=(f[i+(O<<2)>>2]|0)+P|0;G=wNa(+n[y>>2]*+(P|0))|0;b[E+O>>0]=G>>>0<256?G:(G|0)>0?255:0;O=O+1|0}while((O|0)!=256);G=f[z>>2]|0;if(G|0?(F=G+12|0,G=f[F>>2]|0,f[F>>2]=G+-1,(G|0)==1):0)CR(g);f[z>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[A>>2]|0)>0){G=f[B>>2]|0;F=0;do{f[G+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[A>>2]|0))}F=f[w>>2]|0;if((F|0)!=(C|0))ZF(F);D=D+1|0;if((D|0)>=(f[l>>2]|0))break;else E=E+k|0}u=d;return}function l2(){var a=0,b=0,c=0,d=0,e=0;a=u;u=u+32|0;b=a+8|0;c=a;d=a+16|0;e=375016;f[e>>2]=1149814285;f[e+4>>2]=1071277473;e=375024;f[e>>2]=963447064;f[e+4>>2]=1071047319;e=375032;f[e>>2]=-768008872;f[e+4>>2]=1070012441;e=375040;f[e>>2]=-1494786058;f[e+4>>2]=1070282957;e=375048;f[e>>2]=963447064;f[e+4>>2]=1072095895;e=375056;f[e>>2]=-423037099;f[e+4>>2]=1068661162;e=375064;f[e>>2]=-959598773;f[e+4>>2]=1066650698;e=375072;f[e>>2]=-1259765448;f[e+4>>2]=1069450094;e=375080;f[e>>2]=1947784849;f[e+4>>2]=1072588866;e=375088;f[e>>2]=1090715535;f[e+4>>2]=1074392192;e=375096;f[e>>2]=-1724858866;f[e+4>>2]=-1074227158;e=375104;f[e>>2]=1480217529;f[e+4>>2]=-1075845121;e=375112;f[e>>2]=682521843;f[e+4>>2]=-1074854875;e=375120;f[e>>2]=596210180;f[e+4>>2]=1073611791;e=375128;f[e>>2]=-102254581;f[e+4>>2]=1067796179;e=375136;f[e>>2]=137164076;f[e+4>>2]=1068269029;e=375144;f[e>>2]=-1107483087;f[e+4>>2]=-1077273068;e=375152;f[e>>2]=-261408890;f[e+4>>2]=1072753342;e=375160;f[e>>2]=-1282855192;f[e+4>>2]=1072589346;e=375168;f[e>>2]=0;f[e+4>>2]=1072693248;e=375176;f[e>>2]=1349925401;f[e+4>>2]=1072786313;JCa(b,2048);JCa(c,3);QCa(d,b,c);f[226117]=f[d>>2];JCa(904472,-134);JCa(904476,220);OCa(904480,904476,904472);JCa(904484,-140);JCa(904488,122);OCa(904492,904488,904484);UCa(b,809);UCa(c,2e4);cDa(375184,b,c);UCa(b,7827);UCa(c,25e5);cDa(375192,b,c);UCa(b,323);UCa(c,25);cDa(375200,b,c);UCa(b,12);UCa(c,5);cDa(375208,b,c);UCa(b,11);UCa(c,200);cDa(375216,b,c);u=a;return}function m2(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=u;u=u+64|0;m=l+56|0;n=l+24|0;o=l+16|0;p=l;_$(o,45704);q=k?2:0;switch(h|0){case 0:{f[p>>2]=i;f[p+4>>2]=j;f[p+8>>2]=q;f[m>>2]=0;f[m+4>>2]=g;f[n>>2]=45732;f[n+4>>2]=a;f[n+8>>2]=b;f[n+12>>2]=c;f[n+16>>2]=d;f[n+20>>2]=e;f[n+24>>2]=p;_U(m,n,+(Y(g,e)|0)*.0000152587890625);break}case 2:{f[p>>2]=i;f[p+4>>2]=j;f[p+8>>2]=q;f[m>>2]=0;f[m+4>>2]=g;f[n>>2]=45752;f[n+4>>2]=a;f[n+8>>2]=b;f[n+12>>2]=c;f[n+16>>2]=d;f[n+20>>2]=e;f[n+24>>2]=p;_U(m,n,+(Y(g,e)|0)*.0000152587890625);break}default:{f[p>>2]=i;f[p+4>>2]=j;f[p+8>>2]=q;f[m>>2]=0;f[m+4>>2]=g;f[n>>2]=45772;f[n+4>>2]=a;f[n+8>>2]=b;f[n+12>>2]=c;f[n+16>>2]=d;f[n+20>>2]=e;f[n+24>>2]=p;_U(m,n,+(Y(g,e)|0)*.0000152587890625)}}if(!(f[o+4>>2]|0)){u=l;return}u=l;return}function n2(a){a=a|0;PYa(a);return}function o2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,45784);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){p2(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function p2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=f[a>>2]|0;g=f[a+8>>2]|0;if((f[a+4>>2]|0)==3){a=d*3|0;if((d|0)<=0)return;h=g^2;i=0;j=b;while(1){k=f[j+4>>2]|0;l=f[j+(h<<2)>>2]|0;f[c+(i<<2)>>2]=f[j+(g<<2)>>2];f[c+(i+1<<2)>>2]=k;f[c+(i+2<<2)>>2]=l;i=i+3|0;if((i|0)>=(a|0))break;else j=j+(e<<2)|0}return}if((e|0)==3){e=d*3|0;if((d|0)<=0)return;j=g^2;a=c;i=0;while(1){h=f[b+(i+1<<2)>>2]|0;l=f[b+(i+2<<2)>>2]|0;f[a+(g<<2)>>2]=f[b+(i<<2)>>2];f[a+4>>2]=h;f[a+(j<<2)>>2]=l;n[a+12>>2]=1.0;i=i+3|0;if((i|0)>=(e|0))break;else a=a+16|0}return}else{a=d<<2;if((d|0)<=0)return;d=g^2;e=0;do{i=e|1;j=f[b+(i<<2)>>2]|0;l=f[b+((e|2)<<2)>>2]|0;h=e|3;k=f[b+(h<<2)>>2]|0;f[c+(e+g<<2)>>2]=f[b+(e<<2)>>2];f[c+(i<<2)>>2]=j;f[c+(e+d<<2)>>2]=l;f[c+(h<<2)>>2]=k;e=e+4|0}while((e|0)<(a|0));return}}function q2(a){a=a|0;PYa(a);return}function r2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,45804);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){s2(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function s2(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=f[a>>2]|0;h=f[a+8>>2]|0;if((f[a+4>>2]|0)==3){a=e*3|0;if((e|0)<=0)return;i=h^2;j=0;k=b;while(1){l=d[k+2>>1]|0;m=d[k+(i<<1)>>1]|0;d[c+(j<<1)>>1]=d[k+(h<<1)>>1]|0;d[c+(j+1<<1)>>1]=l;d[c+(j+2<<1)>>1]=m;j=j+3|0;if((j|0)>=(a|0))break;else k=k+(g<<1)|0}return}if((g|0)==3){g=e*3|0;if((e|0)<=0)return;k=h^2;a=c;j=0;while(1){i=d[b+(j+1<<1)>>1]|0;m=d[b+(j+2<<1)>>1]|0;d[a+(h<<1)>>1]=d[b+(j<<1)>>1]|0;d[a+2>>1]=i;d[a+(k<<1)>>1]=m;d[a+6>>1]=-1;j=j+3|0;if((j|0)>=(g|0))break;else a=a+8|0}return}else{a=e<<2;if((e|0)<=0)return;e=h^2;g=0;do{j=g|1;k=d[b+(j<<1)>>1]|0;m=d[b+((g|2)<<1)>>1]|0;i=g|3;l=d[b+(i<<1)>>1]|0;d[c+(g+h<<1)>>1]=d[b+(g<<1)>>1]|0;d[c+(j<<1)>>1]=k;d[c+(g+e<<1)>>1]=m;d[c+(i<<1)>>1]=l;g=g+4|0}while((g|0)<(a|0));return}}function t2(a){a=a|0;PYa(a);return}function u2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,45824);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){v2(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function v2(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=f[a>>2]|0;h=f[a+8>>2]|0;if((f[a+4>>2]|0)==3){a=e*3|0;if((e|0)<=0)return;i=h^2;j=0;k=c;while(1){l=b[k+1>>0]|0;m=b[k+i>>0]|0;b[d+j>>0]=b[k+h>>0]|0;b[d+(j+1)>>0]=l;b[d+(j+2)>>0]=m;j=j+3|0;if((j|0)>=(a|0))break;else k=k+g|0}return}if((g|0)==3){g=e*3|0;if((e|0)<=0)return;k=h^2;a=d;j=0;while(1){i=b[c+(j+1)>>0]|0;m=b[c+(j+2)>>0]|0;b[a+h>>0]=b[c+j>>0]|0;b[a+1>>0]=i;b[a+k>>0]=m;b[a+3>>0]=-1;j=j+3|0;if((j|0)>=(g|0))break;else a=a+4|0}return}else{a=e<<2;if((e|0)<=0)return;e=h^2;g=0;do{j=g|1;k=b[c+j>>0]|0;m=b[c+(g|2)>>0]|0;i=g|3;l=b[c+i>>0]|0;b[d+(g+h)>>0]=b[c+g>>0]|0;b[d+j>>0]=k;b[d+(g+e)>>0]=m;b[d+i>>0]=l;g=g+4|0}while((g|0)<(a|0));return}}function w2(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=u;u=u+64|0;l=k+56|0;m=k+24|0;n=k+16|0;o=k;_$(n,45844);f[o>>2]=h;f[o+4>>2]=i?2:0;f[o+8>>2]=j;f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=45872;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=o;_U(l,m,+(Y(g,e)|0)*.0000152587890625);if(!(f[n+4>>2]|0)){u=k;return}u=k;return}function x2(a){a=a|0;PYa(a);return}function y2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,45884);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){z2(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function z2(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0;i=f[a+4>>2]|0;j=(f[a>>2]|0)==3;k=(g|0)>0;if((f[a+8>>2]|0)==6)if(j){if(!k)return;a=i^2;l=0;m=c;while(1){d[e+(l<<1)>>1]=(b[m+1>>0]&-4&255)<<3|(h[m+i>>0]|0)>>>3|(b[m+a>>0]&-8&255)<<8;l=l+1|0;if((l|0)==(g|0))break;else m=m+3|0}return}else{if(!k)return;m=i^2;l=0;a=c;while(1){d[e+(l<<1)>>1]=(b[a+1>>0]&-4&255)<<3|(h[a+i>>0]|0)>>>3|(b[a+m>>0]&-8&255)<<8;l=l+1|0;if((l|0)==(g|0))break;else a=a+4|0}return}else if(j){if(!k)return;j=i^2;a=0;l=c;while(1){d[e+(a<<1)>>1]=(b[l+1>>0]&-8&255)<<2|(h[l+i>>0]|0)>>>3|(b[l+j>>0]&-8&255)<<7;a=a+1|0;if((a|0)==(g|0))break;else l=l+3|0}return}else{if(!k)return;k=i^2;l=0;a=c;while(1){d[e+(l<<1)>>1]=(b[a+1>>0]&-8&255)<<2|(h[a+i>>0]|0)>>>3|(b[a+k>>0]&-8&255)<<7|(b[a+3>>0]|0?32768:0);l=l+1|0;if((l|0)==(g|0))break;else a=a+4|0}return}}function A2(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=u;u=u+64|0;l=k+56|0;m=k+24|0;n=k+16|0;o=k;_$(n,45904);f[o>>2]=h;f[o+4>>2]=i?2:0;f[o+8>>2]=j;f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=45932;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=o;_U(l,m,+(Y(g,e)|0)*.0000152587890625);if(!(f[n+4>>2]|0)){u=k;return}u=k;return}function B2(a){a=a|0;PYa(a);return}function C2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,45944);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){D2(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function D2(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0;g=f[a>>2]|0;h=f[a+4>>2]|0;i=(e|0)>0;if((f[a+8>>2]|0)==6){if(!i)return;a=h^2;if((g|0)==4){k=d;l=0;while(1){m=j[c+(l<<1)>>1]|0;b[k+h>>0]=m<<3;b[k+1>>0]=m>>>3&252;b[k+a>>0]=m>>>8&248;b[k+3>>0]=-1;l=l+1|0;if((l|0)==(e|0))break;else k=k+4|0}return}else{k=d;l=0;while(1){m=j[c+(l<<1)>>1]|0;b[k+h>>0]=m<<3;b[k+1>>0]=m>>>3&252;b[k+a>>0]=m>>>8&248;l=l+1|0;if((l|0)==(e|0))break;else k=k+g|0}return}}else{if(!i)return;i=h^2;if((g|0)==4){k=d;l=0;while(1){a=j[c+(l<<1)>>1]|0;b[k+h>>0]=a<<3;b[k+1>>0]=a>>>2&248;b[k+i>>0]=a>>>7&248;b[k+3>>0]=a<<16>>31;l=l+1|0;if((l|0)==(e|0))break;else k=k+4|0}return}else{k=d;d=0;while(1){l=j[c+(d<<1)>>1]|0;b[k+h>>0]=l<<3;b[k+1>>0]=l>>>2&248;b[k+i>>0]=l>>>7&248;d=d+1|0;if((d|0)==(e|0))break;else k=k+g|0}return}}}function E2(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=u;u=u+3136|0;l=k+3120|0;m=k+3088|0;n=k+3080|0;o=k;_$(n,45964);p=j?2:0;switch(h|0){case 0:{f[o>>2]=i;h=f[45984+((p^2)<<2)>>2]|0;q=f[45984+(p<<2)>>2]|0;p=0;r=0;s=0;t=8192;while(1){f[o+4+(s<<2)>>2]=p;f[o+4+(s+256<<2)>>2]=r;f[o+4+(s+512<<2)>>2]=t;s=s+1|0;if((s|0)==256)break;else{p=p+h|0;r=r+9617|0;t=t+q|0}}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=46004;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=o;_U(l,m,+(Y(g,e)|0)*.0000152587890625);break}case 2:{f[o>>2]=i;q=o+4|0;f[q>>2]=f[11496];f[q+4>>2]=f[11497];f[q+8>>2]=f[11498];if(!j){f[q>>2]=1868;f[o+12>>2]=4899}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=46024;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=o;_U(l,m,+(Y(g,e)|0)*.0000152587890625);break}default:{f[o>>2]=i;i=o+4|0;f[i>>2]=f[11509];f[i+4>>2]=f[11510];f[i+8>>2]=f[11511];if(!j){f[i>>2]=1038710997;f[o+12>>2]=1050220167}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=46056;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=o;_U(l,m,+(Y(g,e)|0)*.0000152587890625)}}if(!(f[n+4>>2]|0)){u=k;return}u=k;return}function F2(a){a=a|0;PYa(a);return}function G2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;c=u;u=u+16|0;d=c;_$(d,46068);e=f[b>>2]|0;g=f[b+4>>2]|0;a:do if((e|0)<(g|0)){b=f[a+16>>2]|0;h=f[a+8>>2]|0;i=a+24|0;j=f[a+20>>2]|0;if((j|0)<=0){k=e;while(1){k=k+1|0;if((k|0)>=(g|0))break a}}k=(f[a+4>>2]|0)+(Y(h,e)|0)|0;l=e;m=(f[a+12>>2]|0)+(Y(b,e)|0)|0;o=k;while(1){k=f[i>>2]|0;p=f[k>>2]|0;q=+n[k+4>>2];r=+n[k+8>>2];s=+n[k+12>>2];k=0;t=o;while(1){n[m+(k<<2)>>2]=q*+n[t>>2]+r*+n[t+4>>2]+s*+n[t+8>>2];k=k+1|0;if((k|0)==(j|0))break;else t=t+(p<<2)|0}l=l+1|0;if((l|0)>=(g|0))break;else{m=m+b|0;o=o+h|0}}}while(0);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function H2(a){a=a|0;PYa(a);return}function I2(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;c=u;u=u+16|0;e=c;_$(e,46088);g=f[b>>2]|0;h=f[b+4>>2]|0;if((g|0)<(h|0)){b=f[a+16>>2]|0;i=(f[a+12>>2]|0)+(Y(b,g)|0)|0;k=f[a+8>>2]|0;l=(f[a+4>>2]|0)+(Y(k,g)|0)|0;m=a+24|0;n=f[a+20>>2]|0;a=(n|0)>0;o=g;g=i;i=l;while(1){l=f[m>>2]|0;p=f[l>>2]|0;q=f[l+4>>2]|0;r=f[l+8>>2]|0;s=f[l+12>>2]|0;if(a){l=0;t=i;while(1){v=Y(j[t>>1]|0,q)|0;w=Y(j[t+2>>1]|0,r)|0;x=(v+8192+w+(Y(j[t+4>>1]|0,s)|0)|0)>>>14&65535;d[g+(l<<1)>>1]=x;l=l+1|0;if((l|0)==(n|0))break;else t=t+(p<<1)|0}}o=o+1|0;if((o|0)>=(h|0))break;else{g=g+b|0;i=i+k|0}}}if(!(f[e+4>>2]|0)){u=c;return}u=c;return}function J2(a){a=a|0;PYa(a);return}function K2(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;_$(e,46108);g=f[c>>2]|0;i=a+8|0;j=a+16|0;k=c+4|0;c=f[k>>2]|0;if((g|0)<(c|0)){l=f[j>>2]|0;m=(f[a+12>>2]|0)+(Y(l,g)|0)|0;n=f[i>>2]|0;o=a+24|0;p=a+20|0;q=c;c=l;l=n;r=g;s=m;m=(f[a+4>>2]|0)+(Y(n,g)|0)|0;while(1){g=f[o>>2]|0;n=f[p>>2]|0;a=f[g>>2]|0;if((n|0)>0){t=0;v=m;while(1){b[s+t>>0]=((f[g+4+((h[v+1>>0]|0|256)<<2)>>2]|0)+(f[g+4+((h[v>>0]|0)<<2)>>2]|0)+(f[g+4+((h[v+2>>0]|0|512)<<2)>>2]|0)|0)>>>14;t=t+1|0;if((t|0)==(n|0))break;else v=v+a|0}w=f[i>>2]|0;x=f[j>>2]|0;y=f[k>>2]|0}else{w=l;x=c;y=q}r=r+1|0;if((r|0)>=(y|0))break;else{q=y;c=x;l=w;s=s+x|0;m=m+w|0}}}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function L2(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;j=u;u=u+64|0;k=j+48|0;l=j+16|0;m=j+8|0;n=j;_$(m,46128);switch(h|0){case 0:{f[n>>2]=i;f[k>>2]=0;f[k+4>>2]=g;f[l>>2]=46156;f[l+4>>2]=a;f[l+8>>2]=b;f[l+12>>2]=c;f[l+16>>2]=d;f[l+20>>2]=e;f[l+24>>2]=n;_U(k,l,+(Y(g,e)|0)*.0000152587890625);break}case 2:{f[n>>2]=i;f[k>>2]=0;f[k+4>>2]=g;f[l>>2]=46176;f[l+4>>2]=a;f[l+8>>2]=b;f[l+12>>2]=c;f[l+16>>2]=d;f[l+20>>2]=e;f[l+24>>2]=n;_U(k,l,+(Y(g,e)|0)*.0000152587890625);break}default:{f[n>>2]=i;f[k>>2]=0;f[k+4>>2]=g;f[l>>2]=46196;f[l+4>>2]=a;f[l+8>>2]=b;f[l+12>>2]=c;f[l+16>>2]=d;f[l+20>>2]=e;f[l+24>>2]=n;_U(k,l,+(Y(g,e)|0)*.0000152587890625)}}if(!(f[m+4>>2]|0)){u=j;return}u=j;return}function M2(a){a=a|0;PYa(a);return}function N2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0;c=u;u=u+16|0;d=c;_$(d,46208);e=f[b>>2]|0;g=f[b+4>>2]|0;a:do if((e|0)<(g|0)){b=f[a+8>>2]|0;h=f[a+16>>2]|0;i=a+24|0;j=f[a+20>>2]|0;if((j|0)<=0){k=e;while(1){k=k+1|0;if((k|0)>=(g|0))break a}}k=(f[a+12>>2]|0)+(Y(h,e)|0)|0;l=e;m=k;k=(f[a+4>>2]|0)+(Y(b,e)|0)|0;while(1){if((f[f[i>>2]>>2]|0)==3){o=m;p=0;while(1){q=f[k+(p<<2)>>2]|0;f[o+8>>2]=q;f[o+4>>2]=q;f[o>>2]=q;p=p+1|0;if((p|0)==(j|0))break;else o=o+12|0}}else{o=m;p=0;while(1){q=f[k+(p<<2)>>2]|0;f[o+8>>2]=q;f[o+4>>2]=q;f[o>>2]=q;n[o+12>>2]=1.0;p=p+1|0;if((p|0)==(j|0))break;else o=o+16|0}}l=l+1|0;if((l|0)>=(g|0))break;else{m=m+h|0;k=k+b|0}}}while(0);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function O2(a){a=a|0;PYa(a);return}function P2(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+16|0;e=c;_$(e,46228);g=f[b>>2]|0;h=f[b+4>>2]|0;a:do if((g|0)<(h|0)){b=f[a+8>>2]|0;i=f[a+16>>2]|0;j=a+24|0;k=f[a+20>>2]|0;if((k|0)<=0){l=g;while(1){l=l+1|0;if((l|0)>=(h|0))break a}}l=(f[a+12>>2]|0)+(Y(i,g)|0)|0;m=g;n=l;l=(f[a+4>>2]|0)+(Y(b,g)|0)|0;while(1){if((f[f[j>>2]>>2]|0)==3){o=n;p=0;while(1){q=d[l+(p<<1)>>1]|0;d[o+4>>1]=q;d[o+2>>1]=q;d[o>>1]=q;p=p+1|0;if((p|0)==(k|0))break;else o=o+6|0}}else{o=n;p=0;while(1){q=d[l+(p<<1)>>1]|0;d[o+4>>1]=q;d[o+2>>1]=q;d[o>>1]=q;d[o+6>>1]=-1;p=p+1|0;if((p|0)==(k|0))break;else o=o+8|0}}m=m+1|0;if((m|0)>=(h|0))break;else{n=n+i|0;l=l+b|0}}}while(0);if(!(f[e+4>>2]|0)){u=c;return}u=c;return}function Q2(a){a=a|0;PYa(a);return}function R2(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;_$(e,46248);g=f[c>>2]|0;h=a+8|0;i=a+16|0;j=c+4|0;if((g|0)<(f[j>>2]|0)){c=(f[a+12>>2]|0)+(Y(f[i>>2]|0,g)|0)|0;k=a+24|0;l=a+20|0;m=g;n=c;c=(f[a+4>>2]|0)+(Y(f[h>>2]|0,g)|0)|0;while(1){g=f[l>>2]|0;a=(g|0)>0;if((f[f[k>>2]>>2]|0)==3){if(a){o=n;p=0;while(1){q=b[c+p>>0]|0;b[o+2>>0]=q;b[o+1>>0]=q;b[o>>0]=q;p=p+1|0;if((p|0)==(g|0))break;else o=o+3|0}}}else if(a){o=n;p=0;while(1){q=b[c+p>>0]|0;b[o+2>>0]=q;b[o+1>>0]=q;b[o>>0]=q;b[o+3>>0]=-1;p=p+1|0;if((p|0)==(g|0))break;else o=o+4|0}}m=m+1|0;if((m|0)>=(f[j>>2]|0))break;else{n=n+(f[i>>2]|0)|0;c=c+(f[h>>2]|0)|0}}}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function S2(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+48|0;k=i+16|0;l=i+8|0;m=i;_$(l,46268);f[m>>2]=h;f[j>>2]=0;f[j+4>>2]=g;f[k>>2]=46296;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+16>>2]=d;f[k+20>>2]=e;f[k+24>>2]=m;_U(j,k,+(Y(g,e)|0)*.0000152587890625);if(!(f[l+4>>2]|0)){u=i;return}u=i;return}function T2(a){a=a|0;PYa(a);return}function U2(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;_$(e,46308);g=f[c>>2]|0;h=a+8|0;i=a+16|0;k=c+4|0;if((g|0)<(f[k>>2]|0)){c=(f[a+12>>2]|0)+(Y(f[i>>2]|0,g)|0)|0;l=a+24|0;m=a+20|0;n=g;o=c;c=(f[a+4>>2]|0)+(Y(f[h>>2]|0,g)|0)|0;while(1){g=f[m>>2]|0;a=(g|0)>0;if((f[f[l>>2]>>2]|0)==6){if(a){p=0;do{q=j[c+(p<<1)>>1]|0;b[o+p>>0]=(((q>>>3&252)*9617|0)+8192+((q<<3&248)*1868|0)+((q>>>8&248)*4899|0)|0)>>>14;p=p+1|0}while((p|0)!=(g|0))}}else if(a){p=0;do{q=j[c+(p<<1)>>1]|0;b[o+p>>0]=(((q>>>2&248)*9617|0)+8192+((q<<3&248)*1868|0)+((q>>>7&248)*4899|0)|0)>>>14;p=p+1|0}while((p|0)!=(g|0))}n=n+1|0;if((n|0)>=(f[k>>2]|0))break;else{o=o+(f[i>>2]|0)|0;c=c+(f[h>>2]|0)|0}}}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function V2(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+48|0;k=i+16|0;l=i+8|0;m=i;_$(l,46328);f[m>>2]=h;f[j>>2]=0;f[j+4>>2]=g;f[k>>2]=46356;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+16>>2]=d;f[k+20>>2]=e;f[k+24>>2]=m;_U(j,k,+(Y(g,e)|0)*.0000152587890625);if(!(f[l+4>>2]|0)){u=i;return}u=i;return}function W2(a){a=a|0;PYa(a);return}function X2(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+16|0;e=c;_$(e,46368);g=f[b>>2]|0;i=f[b+4>>2]|0;if((g|0)<(i|0)){b=f[a+16>>2]|0;j=(f[a+12>>2]|0)+(Y(b,g)|0)|0;k=f[a+8>>2]|0;l=(f[a+4>>2]|0)+(Y(k,g)|0)|0;m=a+24|0;n=f[a+20>>2]|0;a=(n|0)>0;o=g;g=j;j=l;while(1){if((f[f[m>>2]>>2]|0)==6){if(a){l=0;do{p=h[j+l>>0]|0;d[g+(l<<1)>>1]=p<<3&2016|p>>>3|p<<8&63488;l=l+1|0}while((l|0)!=(n|0))}}else if(a){l=0;do{p=(h[j+l>>0]|0)>>>3;d[g+(l<<1)>>1]=p<<5|p|p<<10;l=l+1|0}while((l|0)!=(n|0))}o=o+1|0;if((o|0)>=(i|0))break;else{g=g+b|0;j=j+k|0}}}if(!(f[e+4>>2]|0)){u=c;return}u=c;return}function Y2(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;m=u;u=u+80|0;n=m+72|0;o=m+40|0;p=m+32|0;q=m;_$(p,46388);r=k?2:0;switch(i|0){case 0:{f[q>>2]=j;f[q+4>>2]=r;b[q+8>>0]=l&1;i=q+12|0;s=l?46408:46428;f[i>>2]=f[s>>2];f[i+4>>2]=f[s+4>>2];f[i+8>>2]=f[s+8>>2];f[i+12>>2]=f[s+12>>2];f[i+16>>2]=f[s+16>>2];if(!k){s=q+20|0;t=f[i>>2]|0;f[i>>2]=f[s>>2];f[s>>2]=t}f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=46456;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=q;_U(n,o,+(Y(h,g)|0)*.0000152587890625);break}case 2:{f[q>>2]=j;f[q+4>>2]=r;b[q+8>>0]=l&1;t=q+12|0;s=l?46468:46488;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];if(!k){s=q+20|0;i=f[t>>2]|0;f[t>>2]=f[s>>2];f[s>>2]=i}f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=46516;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=q;_U(n,o,+(Y(h,g)|0)*.0000152587890625);break}default:{f[q>>2]=j;f[q+4>>2]=r;b[q+8>>0]=l&1;r=q+12|0;j=l?46528:46548;f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[r+8>>2]=f[j+8>>2];f[r+12>>2]=f[j+12>>2];f[r+16>>2]=f[j+16>>2];if(!k){k=q+20|0;j=f[r>>2]|0;f[r>>2]=f[k>>2];f[k>>2]=j}f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=46576;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=q;_U(n,o,+(Y(h,g)|0)*.0000152587890625)}}if(!(f[p+4>>2]|0)){u=m;return}u=m;return}function Z2(a){a=a|0;PYa(a);return}function _2(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0;d=u;u=u+16|0;e=d;_$(e,46588);g=f[c>>2]|0;h=f[c+4>>2]|0;a:do if((g|0)<(h|0)){c=f[a+16>>2]|0;i=f[a+8>>2]|0;j=a+24|0;k=f[a+20>>2]|0;l=k*3|0;if((k|0)<=0){k=g;while(1){k=k+1|0;if((k|0)>=(h|0))break a}}k=(f[a+4>>2]|0)+(Y(i,g)|0)|0;m=g;o=(f[a+12>>2]|0)+(Y(c,g)|0)|0;p=k;while(1){k=f[j>>2]|0;q=f[k>>2]|0;r=f[k+4>>2]|0;s=(b[k+8>>0]^1)&255;t=+n[k+12>>2];v=+n[k+16>>2];w=+n[k+20>>2];x=+n[k+24>>2];y=+n[k+28>>2];k=r^2;z=s+1|0;A=2-s|0;s=0;B=p;while(1){C=t*+n[B>>2]+v*+n[B+4>>2]+w*+n[B+8>>2];D=x*(+n[B+(k<<2)>>2]-C)+.5;E=y*(+n[B+(r<<2)>>2]-C)+.5;n[o+(s<<2)>>2]=C;n[o+(z+s<<2)>>2]=D;n[o+(A+s<<2)>>2]=E;s=s+3|0;if((s|0)>=(l|0))break;else B=B+(q<<2)|0}m=m+1|0;if((m|0)>=(h|0))break;else{o=o+c|0;p=p+i|0}}}while(0);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function $2(a){a=a|0;PYa(a);return}function a3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,46608);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){b3(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function b3(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=f[a>>2]|0;i=f[a+4>>2]|0;k=(b[a+8>>0]^1)&255;l=f[a+12>>2]|0;m=f[a+16>>2]|0;n=f[a+20>>2]|0;o=f[a+24>>2]|0;p=f[a+28>>2]|0;a=g*3|0;if((g|0)<=0)return;g=i^2;q=k+1|0;r=2-k|0;k=0;s=c;while(1){c=Y(j[s>>1]|0,l)|0;t=Y(j[s+2>>1]|0,m)|0;u=c+8192+t+(Y(j[s+4>>1]|0,n)|0)>>14;t=(Y((j[s+(g<<1)>>1]|0)-u|0,o)|0)+536879104>>14;c=(Y((j[s+(i<<1)>>1]|0)-u|0,p)|0)+536879104>>14;d[e+(k<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[e+(q+k<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;d[e+(r+k<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;k=k+3|0;if((k|0)>=(a|0))break;else s=s+(h<<1)|0}return}function c3(a){a=a|0;PYa(a);return}function d3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,46628);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){e3(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function e3(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=f[a>>2]|0;i=f[a+4>>2]|0;j=(b[a+8>>0]^1)&255;k=f[a+12>>2]|0;l=f[a+16>>2]|0;m=f[a+20>>2]|0;n=f[a+24>>2]|0;o=f[a+28>>2]|0;a=e*3|0;if((e|0)<=0)return;e=i^2;p=j+1|0;q=2-j|0;j=0;r=c;while(1){c=Y(h[r>>0]|0,k)|0;s=Y(h[r+1>>0]|0,l)|0;t=c+8192+s+(Y(h[r+2>>0]|0,m)|0)>>14;s=(Y((h[r+e>>0]|0)-t|0,n)|0)+2105344>>14;c=(Y((h[r+i>>0]|0)-t|0,o)|0)+2105344>>14;b[d+j>>0]=t>>>0<256?t:(t|0)>0?255:0;b[d+(p+j)>>0]=s>>>0<256?s:(s|0)>0?255:0;b[d+(q+j)>>0]=c>>>0<256?c:(c|0)>0?255:0;j=j+3|0;if((j|0)>=(a|0))break;else r=r+g|0}return}function f3(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0;m=u;u=u+80|0;n=m+72|0;o=m+40|0;p=m+32|0;q=m;_$(p,46648);r=k?2:0;switch(i|0){case 0:{f[q>>2]=j;f[q+4>>2]=r;b[q+8>>0]=l&1;i=q+12|0;k=l?46668:46684;f[i>>2]=f[k>>2];f[i+4>>2]=f[k+4>>2];f[i+8>>2]=f[k+8>>2];f[i+12>>2]=f[k+12>>2];f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=46708;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=q;_U(n,o,+(Y(h,g)|0)*.0000152587890625);break}case 2:{f[q>>2]=j;f[q+4>>2]=r;b[q+8>>0]=l&1;k=q+12|0;i=l?46720:46736;f[k>>2]=f[i>>2];f[k+4>>2]=f[i+4>>2];f[k+8>>2]=f[i+8>>2];f[k+12>>2]=f[i+12>>2];f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=46760;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=q;_U(n,o,+(Y(h,g)|0)*.0000152587890625);break}default:{f[q>>2]=j;f[q+4>>2]=r;b[q+8>>0]=l&1;r=q+12|0;j=l?46772:46788;f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[r+8>>2]=f[j+8>>2];f[r+12>>2]=f[j+12>>2];f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=46812;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=q;_U(n,o,+(Y(h,g)|0)*.0000152587890625)}}if(!(f[p+4>>2]|0)){u=m;return}u=m;return}function g3(a){a=a|0;PYa(a);return}function h3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,46824);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){i3(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function i3(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0.0,k=0.0,l=0.0,m=0.0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0;g=f[a>>2]|0;h=f[a+4>>2]|0;i=(b[a+8>>0]^1)&255;j=+n[a+12>>2];k=+n[a+16>>2];l=+n[a+20>>2];m=+n[a+24>>2];a=e*3|0;if((e|0)<=0)return;e=i+1|0;o=2-i|0;i=h^2;if((g|0)==4){p=d;q=0;while(1){r=+n[c+(q<<2)>>2];s=+n[c+(o+q<<2)>>2]+-.5;t=+n[c+(e+q<<2)>>2]+-.5;n[p+(h<<2)>>2]=r+m*s;n[p+4>>2]=k*t+(r+l*s);n[p+(i<<2)>>2]=r+j*t;n[p+12>>2]=1.0;q=q+3|0;if((q|0)>=(a|0))break;else p=p+16|0}return}else{p=d;d=0;while(1){t=+n[c+(d<<2)>>2];r=+n[c+(o+d<<2)>>2]+-.5;s=+n[c+(e+d<<2)>>2]+-.5;n[p+(h<<2)>>2]=t+m*r;n[p+4>>2]=k*s+(t+l*r);n[p+(i<<2)>>2]=t+j*s;d=d+3|0;if((d|0)>=(a|0))break;else p=p+(g<<2)|0}return}}function j3(a){a=a|0;PYa(a);return}function k3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,46844);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){l3(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function l3(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=f[a>>2]|0;i=f[a+4>>2]|0;k=(b[a+8>>0]^1)&255;l=f[a+12>>2]|0;m=f[a+16>>2]|0;n=f[a+20>>2]|0;o=f[a+24>>2]|0;a=g*3|0;if((g|0)<=0)return;g=k+1|0;p=2-k|0;k=i^2;if((h|0)==4){q=e;r=0;while(1){s=j[c+(r<<1)>>1]|0;t=(j[c+(p+r<<1)>>1]|0)+-32768|0;u=((Y(t,o)|0)+8192>>14)+s|0;v=(j[c+(g+r<<1)>>1]|0)+-32768|0;w=((Y(v,m)|0)+8192+(Y(t,n)|0)>>14)+s|0;t=((Y(v,l)|0)+8192>>14)+s|0;d[q+(i<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[q+2>>1]=w>>>0<65536?w:(w|0)>0?65535:0;d[q+(k<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;d[q+6>>1]=-1;r=r+3|0;if((r|0)>=(a|0))break;else q=q+8|0}return}else{q=e;e=0;while(1){r=j[c+(e<<1)>>1]|0;t=(j[c+(p+e<<1)>>1]|0)+-32768|0;w=((Y(t,o)|0)+8192>>14)+r|0;u=(j[c+(g+e<<1)>>1]|0)+-32768|0;s=((Y(u,m)|0)+8192+(Y(t,n)|0)>>14)+r|0;t=((Y(u,l)|0)+8192>>14)+r|0;d[q+(i<<1)>>1]=w>>>0<65536?w:(w|0)>0?65535:0;d[q+2>>1]=s>>>0<65536?s:(s|0)>0?65535:0;d[q+(k<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;e=e+3|0;if((e|0)>=(a|0))break;else q=q+(h<<1)|0}return}}function m3(a){a=a|0;PYa(a);return}function n3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,46864);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){o3(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function o3(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=f[a>>2]|0;i=f[a+4>>2]|0;j=(b[a+8>>0]^1)&255;k=f[a+12>>2]|0;l=f[a+16>>2]|0;m=f[a+20>>2]|0;n=f[a+24>>2]|0;a=e*3|0;if((e|0)<=0)return;e=j+1|0;o=2-j|0;j=i^2;if((g|0)==4){p=d;q=0;while(1){r=h[c+q>>0]|0;s=(h[c+(o+q)>>0]|0)+-128|0;t=((Y(s,n)|0)+8192>>14)+r|0;u=(h[c+(e+q)>>0]|0)+-128|0;v=((Y(u,l)|0)+8192+(Y(s,m)|0)>>14)+r|0;s=((Y(u,k)|0)+8192>>14)+r|0;b[p+i>>0]=t>>>0<256?t:(t|0)>0?255:0;b[p+1>>0]=v>>>0<256?v:(v|0)>0?255:0;b[p+j>>0]=s>>>0<256?s:(s|0)>0?255:0;b[p+3>>0]=-1;q=q+3|0;if((q|0)>=(a|0))break;else p=p+4|0}return}else{p=d;d=0;while(1){q=h[c+d>>0]|0;s=(h[c+(o+d)>>0]|0)+-128|0;v=((Y(s,n)|0)+8192>>14)+q|0;t=(h[c+(e+d)>>0]|0)+-128|0;r=((Y(t,l)|0)+8192+(Y(s,m)|0)>>14)+q|0;s=((Y(t,k)|0)+8192>>14)+q|0;b[p+i>>0]=v>>>0<256?v:(v|0)>0?255:0;b[p+1>>0]=r>>>0<256?r:(r|0)>0?255:0;b[p+j>>0]=s>>>0<256?s:(s|0)>0?255:0;d=d+3|0;if((d|0)>=(a|0))break;else p=p+g|0}return}}function p3(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0;k=u;u=u+96|0;l=k+80|0;m=k+48|0;o=k+40|0;q=k;_$(o,46884);switch(h|0){case 0:{f[q>>2]=i;h=q+4|0;f[h>>2]=1689;f[q+8>>2]=1465;r=q+12|0;f[r>>2]=739;s=q+16|0;f[s>>2]=871;f[q+20>>2]=2929;t=q+24|0;f[t>>2]=296;v=q+28|0;f[v>>2]=79;f[q+32>>2]=488;w=q+36|0;f[w>>2]=3892;if(!j){f[h>>2]=739;f[r>>2]=1689;f[s>>2]=296;f[t>>2]=871;f[v>>2]=3892;f[w>>2]=79}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=46912;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=q;_U(l,m,+(Y(g,e)|0)*.0000152587890625);break}case 2:{f[q>>2]=i;w=q+4|0;f[w>>2]=1689;f[q+8>>2]=1465;v=q+12|0;f[v>>2]=739;t=q+16|0;f[t>>2]=871;f[q+20>>2]=2929;s=q+24|0;f[s>>2]=296;r=q+28|0;f[r>>2]=79;f[q+32>>2]=488;h=q+36|0;f[h>>2]=3892;if(!j){f[w>>2]=739;f[v>>2]=1689;f[t>>2]=296;f[s>>2]=871;f[r>>2]=3892;f[h>>2]=79}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=46932;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=q;_U(l,m,+(Y(g,e)|0)*.0000152587890625);break}default:{f[q>>2]=i;x=+p[46877];i=q+4|0;n[i>>2]=x;n[q+8>>2]=+p[46878];y=+p[46879];h=q+12|0;n[h>>2]=y;z=+p[46880];r=q+16|0;n[r>>2]=z;n[q+20>>2]=+p[46881];A=+p[46882];s=q+24|0;n[s>>2]=A;B=+p[46883];t=q+28|0;n[t>>2]=B;n[q+32>>2]=+p[46884];C=+p[46885];v=q+36|0;n[v>>2]=C;if(!j){n[i>>2]=y;n[h>>2]=x;n[r>>2]=A;n[s>>2]=z;n[t>>2]=C;n[v>>2]=B}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=46952;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=q;_U(l,m,+(Y(g,e)|0)*.0000152587890625)}}if(!(f[o+4>>2]|0)){u=k;return}u=k;return}function q3(a){a=a|0;PYa(a);return}function r3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0;c=u;u=u+16|0;d=c;_$(d,46964);e=f[b>>2]|0;g=f[b+4>>2]|0;a:do if((e|0)<(g|0)){b=f[a+8>>2]|0;h=f[a+16>>2]|0;i=a+24|0;j=f[a+20>>2]|0;k=j*3|0;if((j|0)<=0){j=e;while(1){j=j+1|0;if((j|0)>=(g|0))break a}}j=(f[a+12>>2]|0)+(Y(h,e)|0)|0;l=e;m=j;j=(f[a+4>>2]|0)+(Y(b,e)|0)|0;while(1){o=f[i>>2]|0;p=f[o>>2]|0;q=+n[o+4>>2];r=+n[o+8>>2];s=+n[o+12>>2];t=+n[o+16>>2];v=+n[o+20>>2];w=+n[o+24>>2];x=+n[o+28>>2];y=+n[o+32>>2];z=+n[o+36>>2];o=0;A=j;while(1){B=+n[A>>2];C=+n[A+4>>2];D=+n[A+8>>2];n[m+(o<<2)>>2]=q*B+r*C+s*D;n[m+(o+1<<2)>>2]=t*B+v*C+w*D;n[m+(o+2<<2)>>2]=x*B+y*C+z*D;o=o+3|0;if((o|0)>=(k|0))break;else A=A+(p<<2)|0}l=l+1|0;if((l|0)>=(g|0))break;else{m=m+h|0;j=j+b|0}}}while(0);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function s3(a){a=a|0;PYa(a);return}function t3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,46984);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){u3(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}
function DDa(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0;e=u;u=u+16|0;g=e;if(!a){i=-2;u=e;return i|0}k=f[a+28>>2]|0;if(!k){i=-2;u=e;return i|0}l=a+12|0;m=f[l>>2]|0;if(!m){i=-2;u=e;return i|0}n=f[a>>2]|0;if((n|0)==0?f[a+4>>2]|0:0){i=-2;u=e;return i|0}o=f[k>>2]|0;if((o|0)==11){f[k>>2]=12;p=12}else p=o;o=a+16|0;q=f[o>>2]|0;r=a+4|0;s=f[r>>2]|0;t=k+56|0;v=k+60|0;w=k+8|0;x=k+24|0;y=g+1|0;z=k+16|0;A=k+32|0;B=a+24|0;C=k+36|0;D=k+20|0;E=a+48|0;F=k+64|0;G=k+12|0;H=(c+-5|0)>>>0<2;I=k+4|0;J=k+76|0;K=k+84|0;L=k+80|0;M=k+88|0;N=(c|0)==6;O=k+7108|0;P=k+72|0;Q=k+7112|0;R=k+68|0;S=k+44|0;T=k+7104|0;U=k+48|0;V=k+52|0;W=k+40|0;X=a+20|0;Y=k+28|0;Z=g+2|0;_=g+3|0;$=k+104|0;aa=k+96|0;ba=k+100|0;ca=k+624|0;da=k+1328|0;ea=k+108|0;fa=k+112|0;ga=k+752|0;ha=k+92|0;ia=p;p=m;m=f[v>>2]|0;ja=s;ka=f[t>>2]|0;la=q;ma=n;n=q;q=0;a:while(1){b:do switch(ia|0){case 28:{na=la;oa=m;pa=ja;qa=ka;ra=ma;sa=1;ta=281;break a;break}case 29:{ua=la;va=m;wa=ja;xa=ka;ya=ma;za=n;Aa=-3;break a;break}case 30:{ta=295;break a;break}case 0:{Ba=f[w>>2]|0;if(!Ba){f[k>>2]=12;Ca=m;Da=ja;Ea=ka;Fa=la;Ga=ma;Ha=n;Ia=p;Ja=q;break b}if(m>>>0<16){Ka=m;La=ja;Ma=ka;Na=ma;while(1){if(!La){ua=la;va=Ka;wa=0;xa=Ma;ya=Na;za=n;Aa=q;break a}Oa=La+-1|0;Pa=Na+1|0;Qa=(h[Na>>0]<<Ka)+Ma|0;Ra=Ka+8|0;if(Ra>>>0<16){Ka=Ra;La=Oa;Ma=Qa;Na=Pa}else{Sa=Ra;Ta=Oa;Ua=Qa;Va=Pa;break}}}else{Sa=m;Ta=ja;Ua=ka;Va=ma}if((Ua|0)==35615&(Ba&2|0)!=0){Na=LDa(0,0,0)|0;f[x>>2]=Na;b[g>>0]=31;b[y>>0]=-117;Ma=LDa(Na,g,2)|0;f[x>>2]=Ma;f[k>>2]=1;Ca=0;Da=Ta;Ea=0;Fa=la;Ga=Va;Ha=n;Ia=p;Ja=q;break b}f[z>>2]=0;Ma=f[A>>2]|0;if(Ma|0)f[Ma+48>>2]=-1;if(Ba&1|0?((((Ua<<8&65280)+(Ua>>>8)|0)>>>0)%31|0|0)==0:0){if((Ua&15|0)!=8){f[B>>2]=358986;f[k>>2]=29;Ca=Sa;Da=Ta;Ea=Ua;Fa=la;Ga=Va;Ha=n;Ia=p;Ja=q;break b}Ma=Ua>>>4;Na=Sa+-4|0;La=Ma&15;Ka=La+8|0;Pa=f[C>>2]|0;if(Pa){if(Ka>>>0>Pa>>>0){f[B>>2]=359013;f[k>>2]=29;Ca=Na;Da=Ta;Ea=Ma;Fa=la;Ga=Va;Ha=n;Ia=p;Ja=q;break b}}else f[C>>2]=Ka;f[D>>2]=256<<La;La=KDa(0,0,0)|0;f[x>>2]=La;f[E>>2]=La;f[k>>2]=Ua>>>12&2^11;Ca=0;Da=Ta;Ea=0;Fa=la;Ga=Va;Ha=n;Ia=p;Ja=q;break b}f[B>>2]=358963;f[k>>2]=29;Ca=Sa;Da=Ta;Ea=Ua;Fa=la;Ga=Va;Ha=n;Ia=p;Ja=q;break}case 1:{if(m>>>0<16){La=m;Ka=ja;Ma=ka;Na=ma;while(1){if(!Ka){ua=la;va=La;wa=0;xa=Ma;ya=Na;za=n;Aa=q;break a}Pa=Ka+-1|0;Qa=Na+1|0;Oa=(h[Na>>0]<<La)+Ma|0;Ra=La+8|0;if(Ra>>>0<16){La=Ra;Ka=Pa;Ma=Oa;Na=Qa}else{Wa=Oa;Xa=Ra;Ya=Pa;Za=Qa;break}}}else{Wa=ka;Xa=m;Ya=ja;Za=ma}f[z>>2]=Wa;if((Wa&255|0)!=8){f[B>>2]=358986;f[k>>2]=29;Ca=Xa;Da=Ya;Ea=Wa;Fa=la;Ga=Za;Ha=n;Ia=p;Ja=q;break b}if(Wa&57344|0){f[B>>2]=359033;f[k>>2]=29;Ca=Xa;Da=Ya;Ea=Wa;Fa=la;Ga=Za;Ha=n;Ia=p;Ja=q;break b}Na=f[A>>2]|0;if(Na|0)f[Na>>2]=Wa>>>8&1;if(Wa&512|0){b[g>>0]=Wa;b[y>>0]=Wa>>>8;Na=LDa(f[x>>2]|0,g,2)|0;f[x>>2]=Na}f[k>>2]=2;_a=0;$a=Ya;ab=0;bb=Za;ta=47;break}case 2:{if(m>>>0<32){_a=m;$a=ja;ab=ka;bb=ma;ta=47}else{cb=ja;db=ka;eb=ma;ta=49}break}case 3:{if(m>>>0<16){fb=m;gb=ja;hb=ka;ib=ma;ta=55}else{jb=ja;kb=ka;lb=ma;ta=57}break}case 4:{mb=m;nb=ja;ob=ka;pb=ma;ta=62;break}case 5:{qb=m;rb=ja;sb=ka;tb=ma;ta=73;break}case 6:{ub=m;vb=ja;wb=ka;xb=ma;ta=83;break}case 7:{yb=m;zb=ja;Ab=ka;Bb=ma;ta=96;break}case 8:{Cb=m;Db=ja;Eb=ka;Fb=ma;ta=109;break}case 9:{if(m>>>0<32){Na=m;Ma=ja;Ka=ka;La=ma;while(1){if(!Ma){ua=la;va=Na;wa=0;xa=Ka;ya=La;za=n;Aa=q;break a}Ba=Ma+-1|0;Qa=La+1|0;Pa=(h[La>>0]<<Na)+Ka|0;Na=Na+8|0;if(Na>>>0>=32){Gb=Ba;Hb=Pa;Ib=Qa;break}else{Ma=Ba;Ka=Pa;La=Qa}}}else{Gb=ja;Hb=ka;Ib=ma}La=Q1a(Hb|0)|0;f[x>>2]=La;f[E>>2]=La;f[k>>2]=10;Jb=0;Kb=Gb;Lb=0;Mb=Ib;ta=121;break}case 10:{Jb=m;Kb=ja;Lb=ka;Mb=ma;ta=121;break}case 11:{Nb=m;Ob=ja;Pb=ka;Qb=ma;ta=124;break}case 12:{Rb=m;Sb=ja;Tb=ka;Ub=ma;ta=125;break}case 13:{La=m&7;Ka=ka>>>La;Ma=m-La|0;if(Ma>>>0<32){La=Ma;Na=ja;Qa=Ka;Pa=ma;while(1){if(!Na){ua=la;va=La;wa=0;xa=Qa;ya=Pa;za=n;Aa=q;break a}Ba=Na+-1|0;Ra=Pa+1|0;Oa=(h[Pa>>0]<<La)+Qa|0;Vb=La+8|0;if(Vb>>>0<32){La=Vb;Na=Ba;Qa=Oa;Pa=Ra}else{Wb=Vb;Xb=Ba;Yb=Oa;Zb=Ra;break}}}else{Wb=Ma;Xb=ja;Yb=Ka;Zb=ma}Pa=Yb&65535;if((Pa|0)==(Yb>>>16^65535|0)){f[F>>2]=Pa;f[k>>2]=14;if(N){na=la;oa=0;pa=Xb;qa=0;ra=Zb;sa=q;ta=281;break a}else{_b=0;$b=Xb;ac=0;bc=Zb;ta=144;break b}}else{f[B>>2]=359097;f[k>>2]=29;Ca=Wb;Da=Xb;Ea=Yb;Fa=la;Ga=Zb;Ha=n;Ia=p;Ja=q;break b}break}case 14:{_b=m;$b=ja;ac=ka;bc=ma;ta=144;break}case 15:{cc=m;dc=ja;ec=ka;fc=ma;ta=145;break}case 16:{if(m>>>0<14){Pa=m;Qa=ja;Na=ka;La=ma;while(1){if(!Qa){ua=la;va=Pa;wa=0;xa=Na;ya=La;za=n;Aa=q;break a}Ra=Qa+-1|0;Oa=La+1|0;Ba=(h[La>>0]<<Pa)+Na|0;Vb=Pa+8|0;if(Vb>>>0<14){Pa=Vb;Qa=Ra;Na=Ba;La=Oa}else{gc=Vb;hc=Ra;ic=Ba;jc=Oa;break}}}else{gc=m;hc=ja;ic=ka;jc=ma}La=(ic&31)+257|0;f[aa>>2]=La;Na=(ic>>>5&31)+1|0;f[ba>>2]=Na;Qa=(ic>>>10&15)+4|0;f[ha>>2]=Qa;Pa=ic>>>14;Ka=gc+-14|0;if(La>>>0>286|Na>>>0>30){f[B>>2]=359126;f[k>>2]=29;Ca=Ka;Da=hc;Ea=Pa;Fa=la;Ga=jc;Ha=n;Ia=p;Ja=q;break b}else{f[$>>2]=0;f[k>>2]=17;kc=0;lc=Qa;mc=Ka;nc=hc;oc=Pa;pc=jc;ta=155;break b}break}case 17:{Pa=f[$>>2]|0;Ka=f[ha>>2]|0;if(Pa>>>0<Ka>>>0){kc=Pa;lc=Ka;mc=m;nc=ja;oc=ka;pc=ma;ta=155}else{qc=Pa;rc=m;sc=ja;tc=ka;uc=ma;ta=156}break}case 18:{vc=f[$>>2]|0;wc=m;xc=ja;yc=ka;zc=ma;Ac=q;ta=166;break}case 19:{Bc=m;Cc=ja;Dc=ka;Ec=ma;Fc=q;ta=199;break}case 20:{Gc=m;Hc=ja;Ic=ka;Jc=ma;Kc=q;ta=200;break}case 21:{Lc=f[P>>2]|0;Mc=m;Nc=ja;Oc=ka;Pc=ma;Qc=q;ta=218;break}case 22:{Rc=m;Sc=ja;Tc=ka;Uc=ma;Vc=q;ta=225;break}case 23:{Wc=f[P>>2]|0;Xc=m;Yc=ja;Zc=ka;_c=ma;$c=q;ta=237;break}case 24:{ad=m;bd=ja;cd=ka;dd=ma;ed=q;ta=243;break}case 25:{if(!la){na=0;oa=m;pa=ja;qa=ka;ra=ma;sa=q;ta=281;break a}b[p>>0]=f[F>>2];f[k>>2]=20;Ca=m;Da=ja;Ea=ka;Fa=la+-1|0;Ga=ma;Ha=n;Ia=p+1|0;Ja=q;break}case 26:{if(f[w>>2]|0){if(m>>>0<32){Pa=m;Ka=ja;Qa=ka;Na=ma;while(1){if(!Ka){ua=la;va=Pa;wa=0;xa=Qa;ya=Na;za=n;Aa=q;break a}La=Ka+-1|0;Ma=Na+1|0;Oa=(h[Na>>0]<<Pa)+Qa|0;Ba=Pa+8|0;if(Ba>>>0<32){Pa=Ba;Ka=La;Qa=Oa;Na=Ma}else{fd=Ba;gd=La;hd=Oa;id=Ma;break}}}else{fd=m;gd=ja;hd=ka;id=ma}Na=n-la|0;f[X>>2]=(f[X>>2]|0)+Na;f[Y>>2]=(f[Y>>2]|0)+Na;if(!Na)jd=f[x>>2]|0;else{Qa=f[x>>2]|0;Ka=p+(0-Na)|0;if(!(f[z>>2]|0))kd=KDa(Qa,Ka,Na)|0;else kd=LDa(Qa,Ka,Na)|0;f[x>>2]=kd;f[E>>2]=kd;jd=kd}Na=(f[z>>2]|0)==0;Ka=Q1a(hd|0)|0;if(((Na?Ka:hd)|0)==(jd|0)){ld=0;md=gd;nd=0;od=id;pd=la}else{f[B>>2]=359300;f[k>>2]=29;Ca=fd;Da=gd;Ea=hd;Fa=la;Ga=id;Ha=la;Ia=p;Ja=q;break b}}else{ld=m;md=ja;nd=ka;od=ma;pd=n}f[k>>2]=27;qd=ld;rd=md;sd=nd;td=od;ud=pd;ta=273;break}case 27:{qd=m;rd=ja;sd=ka;td=ma;ud=n;ta=273;break}default:{i=-2;ta=296;break a}}while(0);if((ta|0)==47)while(1){ta=0;if(!$a){ua=la;va=_a;wa=0;xa=ab;ya=bb;za=n;Aa=q;break a}Ka=$a+-1|0;Na=bb+1|0;Qa=(h[bb>>0]<<_a)+ab|0;_a=_a+8|0;if(_a>>>0>=32){cb=Ka;db=Qa;eb=Na;ta=49;break}else{$a=Ka;ab=Qa;bb=Na;ta=47}}else if((ta|0)==121){ta=0;if(!(f[G>>2]|0)){ta=122;break}Na=KDa(0,0,0)|0;f[x>>2]=Na;f[E>>2]=Na;f[k>>2]=11;Nb=Jb;Ob=Kb;Pb=Lb;Qb=Mb;ta=124}else if((ta|0)==144){ta=0;f[k>>2]=15;cc=_b;dc=$b;ec=ac;fc=bc;ta=145}else if((ta|0)==155){ta=0;Na=kc;Qa=mc;Ka=nc;Pa=oc;Ma=pc;while(1){if(Qa>>>0<3){if(!Ka){ua=la;va=Qa;wa=0;xa=Pa;ya=Ma;za=n;Aa=q;break a}vd=Qa+8|0;wd=Ka+-1|0;xd=(h[Ma>>0]<<Qa)+Pa|0;yd=Ma+1|0}else{vd=Qa;wd=Ka;xd=Pa;yd=Ma}Oa=Na+1|0;f[$>>2]=Oa;d[k+112+(j[132872+(Na<<1)>>1]<<1)>>1]=xd&7;La=xd>>>3;Ba=vd+-3|0;if(Oa>>>0<lc>>>0){Na=Oa;Qa=Ba;Ka=wd;Pa=La;Ma=yd}else{qc=Oa;rc=Ba;sc=wd;tc=La;uc=yd;ta=156;break}}}else if((ta|0)==273){ta=0;if(!(f[w>>2]|0)){zd=qd;Ad=rd;Bd=sd;Cd=td;ta=280;break}if(!(f[z>>2]|0)){zd=qd;Ad=rd;Bd=sd;Cd=td;ta=280;break}if(qd>>>0<32){Ma=qd;Pa=rd;Ka=sd;Qa=td;while(1){if(!Pa){ua=la;va=Ma;wa=0;xa=Ka;ya=Qa;za=ud;Aa=q;break a}Na=Pa+-1|0;La=Qa+1|0;Ba=(h[Qa>>0]<<Ma)+Ka|0;Oa=Ma+8|0;if(Oa>>>0<32){Ma=Oa;Pa=Na;Ka=Ba;Qa=La}else{Dd=Oa;Ed=Na;Fd=Ba;Gd=La;break}}}else{Dd=qd;Ed=rd;Fd=sd;Gd=td}if((Fd|0)==(f[Y>>2]|0)){zd=0;Ad=Ed;Bd=0;Cd=Gd;ta=280;break}f[B>>2]=359321;f[k>>2]=29;Ca=Dd;Da=Ed;Ea=Fd;Fa=la;Ga=Gd;Ha=ud;Ia=p;Ja=q}do if((ta|0)==49){ta=0;Qa=f[A>>2]|0;if(Qa|0)f[Qa+4>>2]=db;if(f[z>>2]&512|0){b[g>>0]=db;b[y>>0]=db>>>8;b[Z>>0]=db>>>16;b[_>>0]=db>>>24;Qa=LDa(f[x>>2]|0,g,4)|0;f[x>>2]=Qa}f[k>>2]=3;fb=0;gb=cb;hb=0;ib=eb;ta=55}else if((ta|0)==124){ta=0;if(H){na=la;oa=Nb;pa=Ob;qa=Pb;ra=Qb;sa=q;ta=281;break a}else{Rb=Nb;Sb=Ob;Tb=Pb;Ub=Qb;ta=125}}else if((ta|0)==145){ta=0;Qa=f[F>>2]|0;if(!Qa){f[k>>2]=11;Ca=cc;Da=dc;Ea=ec;Fa=la;Ga=fc;Ha=n;Ia=p;Ja=q;break}Ka=Qa>>>0>dc>>>0?dc:Qa;Qa=Ka>>>0>la>>>0?la:Ka;if(!Qa){na=la;oa=cc;pa=dc;qa=ec;ra=fc;sa=q;ta=281;break a}K1a(p|0,fc|0,Qa|0)|0;f[F>>2]=(f[F>>2]|0)-Qa;Ca=cc;Da=dc-Qa|0;Ea=ec;Fa=la-Qa|0;Ga=fc+Qa|0;Ha=n;Ia=p+Qa|0;Ja=q}else if((ta|0)==156){ta=0;if(qc>>>0<19){Qa=qc;do{d[k+112+(j[132872+(Qa<<1)>>1]<<1)>>1]=0;Qa=Qa+1|0}while((Qa|0)!=19);f[$>>2]=19}f[ea>>2]=da;f[J>>2]=da;f[K>>2]=7;Qa=GDa(0,fa,19,ea,K,ga)|0;if(!Qa){f[$>>2]=0;f[k>>2]=18;vc=0;wc=rc;xc=sc;yc=tc;zc=uc;Ac=0;ta=166;break}else{f[B>>2]=359162;f[k>>2]=29;Ca=rc;Da=sc;Ea=tc;Fa=la;Ga=uc;Ha=n;Ia=p;Ja=Qa;break}}while(0);c:do if((ta|0)==55)while(1){ta=0;if(!gb){ua=la;va=fb;wa=0;xa=hb;ya=ib;za=n;Aa=q;break a}Qa=gb+-1|0;Ka=ib+1|0;Pa=(h[ib>>0]<<fb)+hb|0;fb=fb+8|0;if(fb>>>0>=16){jb=Qa;kb=Pa;lb=Ka;ta=57;break}else{gb=Qa;hb=Pa;ib=Ka;ta=55}}else if((ta|0)==125){ta=0;if(f[I>>2]|0){Ka=Rb&7;f[k>>2]=26;Ca=Rb-Ka|0;Da=Sb;Ea=Tb>>>Ka;Fa=la;Ga=Ub;Ha=n;Ia=p;Ja=q;break}if(Rb>>>0<3){if(!Sb){na=la;oa=Rb;pa=0;qa=Tb;ra=Ub;sa=q;ta=281;break a}Hd=Rb+8|0;Id=Sb+-1|0;Jd=(h[Ub>>0]<<Rb)+Tb|0;Kd=Ub+1|0}else{Hd=Rb;Id=Sb;Jd=Tb;Kd=Ub}f[I>>2]=Jd&1;switch(Jd>>>1&3){case 0:{Ld=13;ta=136;break}case 1:{f[J>>2]=130696;f[K>>2]=9;f[L>>2]=132744;f[M>>2]=5;f[k>>2]=19;if(N){ta=132;break a}break}case 2:{Ld=16;ta=136;break}case 3:{f[B>>2]=359078;Ld=29;ta=136;break}default:{ta=135;break a}}if((ta|0)==136){ta=0;f[k>>2]=Ld}Ca=Hd+-3|0;Da=Id;Ea=Jd>>>3;Fa=la;Ga=Kd;Ha=n;Ia=p;Ja=q}else if((ta|0)==166){ta=0;Ka=f[aa>>2]|0;Pa=f[ba>>2]|0;do if(vc>>>0<(Pa+Ka|0)>>>0){Qa=vc;Ma=Ka;La=Pa;Ba=wc;Na=xc;Oa=yc;Ra=zc;d:while(1){Vb=f[J>>2]|0;Md=(1<<f[K>>2])+-1|0;Nd=Md&Oa;Od=h[Vb+(Nd<<2)+1>>0]|0;if(Ba>>>0<Od>>>0){Pd=Ba;Qd=Na;Rd=Oa;Sd=Ra;while(1){if(!Qd){ua=la;va=Pd;wa=0;xa=Rd;ya=Sd;za=n;Aa=Ac;break a}Td=Qd+-1|0;Ud=Sd+1|0;Vd=(h[Sd>>0]<<Pd)+Rd|0;Wd=Pd+8|0;Xd=Md&Vd;Yd=h[Vb+(Xd<<2)+1>>0]|0;if(Wd>>>0<Yd>>>0){Pd=Wd;Qd=Td;Rd=Vd;Sd=Ud}else{Zd=Xd;_d=Wd;$d=Yd;ae=Td;be=Vd;ce=Ud;break}}}else{Zd=Nd;_d=Ba;$d=Od;ae=Na;be=Oa;ce=Ra}Sd=d[Vb+(Zd<<2)+2>>1]|0;if((Sd&65535)>=16){switch(Sd<<16>>16){case 16:{Rd=$d+2|0;if(_d>>>0<Rd>>>0){Qd=_d;Pd=ae;Md=be;Ud=ce;while(1){if(!Pd){ua=la;va=Qd;wa=0;xa=Md;ya=Ud;za=n;Aa=Ac;break a}Vd=Pd+-1|0;Td=Ud+1|0;Yd=(h[Ud>>0]<<Qd)+Md|0;Wd=Qd+8|0;if(Wd>>>0<Rd>>>0){Qd=Wd;Pd=Vd;Md=Yd;Ud=Td}else{de=Wd;ee=Vd;fe=Yd;ge=Td;break}}}else{de=_d;ee=ae;fe=be;ge=ce}Ud=fe>>>$d;Md=de-$d|0;if(!Qa){he=Md;ie=ee;je=Ud;ke=ge;ta=190;break d}le=Md+-2|0;me=(Ud&3)+3|0;ne=ee;oe=Ud>>>2;pe=j[k+112+(Qa+-1<<1)>>1]|0;qe=ge;break}case 17:{Ud=$d+3|0;if(_d>>>0<Ud>>>0){Md=_d;Pd=ae;Qd=be;Rd=ce;while(1){if(!Pd){ua=la;va=Md;wa=0;xa=Qd;ya=Rd;za=n;Aa=Ac;break a}Vb=Pd+-1|0;Od=Rd+1|0;Nd=(h[Rd>>0]<<Md)+Qd|0;Td=Md+8|0;if(Td>>>0<Ud>>>0){Md=Td;Pd=Vb;Qd=Nd;Rd=Od}else{re=Td;se=Vb;te=Nd;ue=Od;break}}}else{re=_d;se=ae;te=be;ue=ce}Rd=te>>>$d;le=-3-$d+re|0;me=(Rd&7)+3|0;ne=se;oe=Rd>>>3;pe=0;qe=ue;break}default:{Rd=$d+7|0;if(_d>>>0<Rd>>>0){Qd=_d;Pd=ae;Md=be;Ud=ce;while(1){if(!Pd){ua=la;va=Qd;wa=0;xa=Md;ya=Ud;za=n;Aa=Ac;break a}Od=Pd+-1|0;Nd=Ud+1|0;Vb=(h[Ud>>0]<<Qd)+Md|0;Td=Qd+8|0;if(Td>>>0<Rd>>>0){Qd=Td;Pd=Od;Md=Vb;Ud=Nd}else{ve=Td;we=Od;xe=Vb;ye=Nd;break}}}else{ve=_d;we=ae;xe=be;ye=ce}Ud=xe>>>$d;le=-7-$d+ve|0;me=(Ud&127)+11|0;ne=we;oe=Ud>>>7;pe=0;qe=ye}}if((Qa+me|0)>>>0>(La+Ma|0)>>>0){he=le;ie=ne;je=oe;ke=qe;ta=190;break}Ud=pe&65535;Md=me+-1|0;f[$>>2]=Qa+1;d[k+112+(Qa<<1)>>1]=Ud;if(!Md){ze=le;Ae=ne;Be=oe;Ce=qe}else{Pd=Md;do{Md=f[$>>2]|0;Pd=Pd+-1|0;f[$>>2]=Md+1;d[k+112+(Md<<1)>>1]=Ud}while((Pd|0)!=0);ze=le;Ae=ne;Be=oe;Ce=qe}}else{f[$>>2]=Qa+1;d[k+112+(Qa<<1)>>1]=Sd;ze=_d-$d|0;Ae=ae;Be=be>>>$d;Ce=ce}Qa=f[$>>2]|0;Ma=f[aa>>2]|0;La=f[ba>>2]|0;if(Qa>>>0>=(La+Ma|0)>>>0){ta=191;break}else{Ba=ze;Na=Ae;Oa=Be;Ra=Ce}}if((ta|0)==190){ta=0;f[B>>2]=359187;f[k>>2]=29;Ca=he;Da=ie;Ea=je;Fa=la;Ga=ke;Ha=n;Ia=p;Ja=Ac;break c}else if((ta|0)==191){ta=0;if((f[k>>2]|0)==29){Ca=ze;Da=Ae;Ea=Be;Fa=la;Ga=Ce;Ha=n;Ia=p;Ja=Ac;break c}else{De=Ma;Ee=ze;Fe=Ae;Ge=Be;He=Ce;break}}}else{De=Ka;Ee=wc;Fe=xc;Ge=yc;He=zc}while(0);if(!(d[ca>>1]|0)){f[B>>2]=359213;f[k>>2]=29;Ca=Ee;Da=Fe;Ea=Ge;Fa=la;Ga=He;Ha=n;Ia=p;Ja=Ac;break}f[ea>>2]=da;f[J>>2]=da;f[K>>2]=9;Ka=GDa(1,fa,De,ea,K,ga)|0;if(Ka|0){f[B>>2]=359250;f[k>>2]=29;Ca=Ee;Da=Fe;Ea=Ge;Fa=la;Ga=He;Ha=n;Ia=p;Ja=Ka;break}f[L>>2]=f[ea>>2];f[M>>2]=6;Ka=GDa(2,k+112+(f[aa>>2]<<1)|0,f[ba>>2]|0,ea,M,ga)|0;if(!Ka){f[k>>2]=19;if(N){na=la;oa=Ee;pa=Fe;qa=Ge;ra=He;sa=0;ta=281;break a}else{Bc=Ee;Cc=Fe;Dc=Ge;Ec=He;Fc=0;ta=199;break}}else{f[B>>2]=359278;f[k>>2]=29;Ca=Ee;Da=Fe;Ea=Ge;Fa=la;Ga=He;Ha=n;Ia=p;Ja=Ka;break}}while(0);if((ta|0)==57){ta=0;Ka=f[A>>2]|0;if(Ka|0){f[Ka+8>>2]=kb&255;f[Ka+12>>2]=kb>>>8}if(f[z>>2]&512|0){b[g>>0]=kb;b[y>>0]=kb>>>8;Ka=LDa(f[x>>2]|0,g,2)|0;f[x>>2]=Ka}f[k>>2]=4;mb=0;nb=jb;ob=0;pb=lb;ta=62}else if((ta|0)==199){ta=0;f[k>>2]=20;Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ec;Kc=Fc;ta=200}do if((ta|0)==62){ta=0;Ka=f[z>>2]|0;if(!(Ka&1024)){Pa=f[A>>2]|0;if(!Pa){Ie=mb;Je=nb;Ke=ob;Le=pb}else{f[Pa+16>>2]=0;Ie=mb;Je=nb;Ke=ob;Le=pb}}else{if(mb>>>0<16){Pa=mb;Ra=nb;Oa=ob;Na=pb;while(1){if(!Ra){ua=la;va=Pa;wa=0;xa=Oa;ya=Na;za=n;Aa=q;break a}Ba=Ra+-1|0;La=Na+1|0;Qa=(h[Na>>0]<<Pa)+Oa|0;Pa=Pa+8|0;if(Pa>>>0>=16){Me=Ba;Ne=Qa;Oe=La;break}else{Ra=Ba;Oa=Qa;Na=La}}}else{Me=nb;Ne=ob;Oe=pb}f[F>>2]=Ne;Na=f[A>>2]|0;if(Na|0)f[Na+20>>2]=Ne;if(!(Ka&512)){Ie=0;Je=Me;Ke=0;Le=Oe}else{b[g>>0]=Ne;b[y>>0]=Ne>>>8;Na=LDa(f[x>>2]|0,g,2)|0;f[x>>2]=Na;Ie=0;Je=Me;Ke=0;Le=Oe}}f[k>>2]=5;qb=Ie;rb=Je;sb=Ke;tb=Le;ta=73}else if((ta|0)==200){ta=0;if(la>>>0>257&Hc>>>0>5){f[l>>2]=p;f[o>>2]=la;f[a>>2]=Jc;f[r>>2]=Hc;f[t>>2]=Ic;f[v>>2]=Gc;HDa(a,n);Na=f[l>>2]|0;Oa=f[o>>2]|0;Ra=f[a>>2]|0;Pa=f[r>>2]|0;La=f[t>>2]|0;Qa=f[v>>2]|0;if((f[k>>2]|0)!=11){Ca=Qa;Da=Pa;Ea=La;Fa=Oa;Ga=Ra;Ha=n;Ia=Na;Ja=Kc;break}f[O>>2]=-1;Ca=Qa;Da=Pa;Ea=La;Fa=Oa;Ga=Ra;Ha=n;Ia=Na;Ja=Kc;break}f[O>>2]=0;Na=f[J>>2]|0;Ra=(1<<f[K>>2])+-1|0;Oa=Ra&Ic;La=b[Na+(Oa<<2)+1>>0]|0;Pa=La&255;if(Pa>>>0>Gc>>>0){Qa=Gc;Ba=Hc;Pd=Ic;Ud=Jc;while(1){if(!Ba){ua=la;va=Qa;wa=0;xa=Pd;ya=Ud;za=n;Aa=Kc;break a}Md=Ba+-1|0;Qd=Ud+1|0;Rd=(h[Ud>>0]<<Qa)+Pd|0;Nd=Qa+8|0;Vb=Ra&Rd;Od=b[Na+(Vb<<2)+1>>0]|0;Td=Od&255;if(Td>>>0>Nd>>>0){Qa=Nd;Ba=Md;Pd=Rd;Ud=Qd}else{Pe=Vb;Qe=Nd;Re=Td;Se=Md;Te=Od;Ue=Rd;Ve=Qd;break}}}else{Pe=Oa;Qe=Gc;Re=Pa;Se=Hc;Te=La;Ue=Ic;Ve=Jc}Ud=d[Na+(Pe<<2)+2>>1]|0;Pd=b[Na+(Pe<<2)>>0]|0;Ba=Pd&255;if(Pd<<24>>24!=0&(Ba&240|0)==0){Qa=Ud&65535;Ra=(1<<Re+Ba)+-1|0;Ba=((Ue&Ra)>>>Re)+Qa|0;Ka=b[Na+(Ba<<2)+1>>0]|0;if(((Ka&255)+Re|0)>>>0>Qe>>>0){Qd=Qe;Rd=Se;Od=Ue;Md=Ve;while(1){if(!Rd){ua=la;va=Qd;wa=0;xa=Od;ya=Md;za=n;Aa=Kc;break a}Td=Rd+-1|0;Nd=Md+1|0;Vb=(h[Md>>0]<<Qd)+Od|0;Yd=Qd+8|0;Vd=((Vb&Ra)>>>Re)+Qa|0;Wd=b[Na+(Vd<<2)+1>>0]|0;if(((Wd&255)+Re|0)>>>0>Yd>>>0){Qd=Yd;Rd=Td;Od=Vb;Md=Nd}else{We=Vd;Xe=Yd;Ye=Td;Ze=Wd;_e=Vb;$e=Nd;break}}}else{We=Ba;Xe=Qe;Ye=Se;Ze=Ka;_e=Ue;$e=Ve}Md=d[Na+(We<<2)+2>>1]|0;Od=b[Na+(We<<2)>>0]|0;f[O>>2]=Re;af=Re;bf=Xe-Re|0;cf=Ye;df=Od;ef=Ze;ff=Md;gf=_e>>>Re;hf=$e}else{af=0;bf=Qe;cf=Se;df=Pd;ef=Te;ff=Ud;gf=Ue;hf=Ve}Md=ef&255;Od=gf>>>Md;Rd=bf-Md|0;f[O>>2]=af+Md;f[F>>2]=ff&65535;Md=df&255;if(!(df<<24>>24)){f[k>>2]=25;Ca=Rd;Da=cf;Ea=Od;Fa=la;Ga=hf;Ha=n;Ia=p;Ja=Kc;break}if(Md&32|0){f[O>>2]=-1;f[k>>2]=11;Ca=Rd;Da=cf;Ea=Od;Fa=la;Ga=hf;Ha=n;Ia=p;Ja=Kc;break}if(!(Md&64)){Qd=Md&15;f[P>>2]=Qd;f[k>>2]=21;Lc=Qd;Mc=Rd;Nc=cf;Oc=Od;Pc=hf;Qc=Kc;ta=218;break}else{f[B>>2]=359344;f[k>>2]=29;Ca=Rd;Da=cf;Ea=Od;Fa=la;Ga=hf;Ha=n;Ia=p;Ja=Kc;break}}while(0);if((ta|0)==73){ta=0;Od=f[z>>2]|0;if(Od&1024){Rd=f[F>>2]|0;Qd=Rd>>>0>rb>>>0?rb:Rd;if(!Qd){jf=Rd;kf=rb;lf=tb}else{Md=f[A>>2]|0;if((Md|0)!=0?(Qa=f[Md+16>>2]|0,(Qa|0)!=0):0){Ra=(f[Md+20>>2]|0)-Rd|0;Rd=f[Md+24>>2]|0;K1a(Qa+Ra|0,tb|0,((Ra+Qd|0)>>>0>Rd>>>0?Rd-Ra|0:Qd)|0)|0;mf=f[z>>2]|0}else mf=Od;if(mf&512|0){Od=LDa(f[x>>2]|0,tb,Qd)|0;f[x>>2]=Od}Od=(f[F>>2]|0)-Qd|0;f[F>>2]=Od;jf=Od;kf=rb-Qd|0;lf=tb+Qd|0}if(!jf){nf=kf;of=lf}else{na=la;oa=qb;pa=kf;qa=sb;ra=lf;sa=q;ta=281;break}}else{nf=rb;of=tb}f[F>>2]=0;f[k>>2]=6;ub=qb;vb=nf;wb=sb;xb=of;ta=83}else if((ta|0)==218){ta=0;if(!Lc){pf=f[F>>2]|0;qf=Mc;rf=Nc;sf=Oc;tf=Pc}else{if(Mc>>>0<Lc>>>0){Qd=Mc;Od=Nc;Ra=Oc;Rd=Pc;while(1){if(!Od){ua=la;va=Qd;wa=0;xa=Ra;ya=Rd;za=n;Aa=Qc;break a}Qa=Od+-1|0;Md=Rd+1|0;La=(h[Rd>>0]<<Qd)+Ra|0;Pa=Qd+8|0;if(Pa>>>0<Lc>>>0){Qd=Pa;Od=Qa;Ra=La;Rd=Md}else{uf=Pa;vf=Qa;wf=La;xf=Md;break}}}else{uf=Mc;vf=Nc;wf=Oc;xf=Pc}Rd=(f[F>>2]|0)+(wf&(1<<Lc)+-1)|0;f[F>>2]=Rd;f[O>>2]=(f[O>>2]|0)+Lc;pf=Rd;qf=uf-Lc|0;rf=vf;sf=wf>>>Lc;tf=xf}f[Q>>2]=pf;f[k>>2]=22;Rc=qf;Sc=rf;Tc=sf;Uc=tf;Vc=Qc;ta=225}do if((ta|0)==83){ta=0;if(!(f[z>>2]&2048)){Rd=f[A>>2]|0;if(!Rd){yf=vb;zf=xb}else{f[Rd+28>>2]=0;yf=vb;zf=xb}}else{if(!vb){na=la;oa=ub;pa=0;qa=wb;ra=xb;sa=q;ta=281;break a}else Af=0;do{Rd=Af;Af=Af+1|0;Ra=b[xb+Rd>>0]|0;Rd=f[A>>2]|0;if((Rd|0?(Od=f[Rd+28>>2]|0,Od|0):0)?(Qd=f[F>>2]|0,Qd>>>0<(f[Rd+32>>2]|0)>>>0):0){f[F>>2]=Qd+1;b[Od+Qd>>0]=Ra}Bf=Ra<<24>>24!=0}while(Bf&vb>>>0>Af>>>0);if(f[z>>2]&512|0){Ud=LDa(f[x>>2]|0,xb,Af)|0;f[x>>2]=Ud}Ud=vb-Af|0;Pd=xb+Af|0;if(Bf){na=la;oa=ub;pa=Ud;qa=wb;ra=Pd;sa=q;ta=281;break a}else{yf=Ud;zf=Pd}}f[F>>2]=0;f[k>>2]=7;yb=ub;zb=yf;Ab=wb;Bb=zf;ta=96}else if((ta|0)==225){ta=0;Pd=f[L>>2]|0;Ud=(1<<f[M>>2])+-1|0;Na=Ud&Tc;Ka=b[Pd+(Na<<2)+1>>0]|0;Ba=Ka&255;if(Ba>>>0>Rc>>>0){Ra=Rc;Qd=Sc;Od=Tc;Rd=Uc;while(1){if(!Qd){ua=la;va=Ra;wa=0;xa=Od;ya=Rd;za=n;Aa=Vc;break a}Md=Qd+-1|0;La=Rd+1|0;Qa=(h[Rd>>0]<<Ra)+Od|0;Pa=Ra+8|0;Oa=Ud&Qa;Nd=b[Pd+(Oa<<2)+1>>0]|0;Vb=Nd&255;if(Vb>>>0>Pa>>>0){Ra=Pa;Qd=Md;Od=Qa;Rd=La}else{Cf=Oa;Df=Pa;Ef=Vb;Ff=Md;Gf=Nd;Hf=Qa;If=La;break}}}else{Cf=Na;Df=Rc;Ef=Ba;Ff=Sc;Gf=Ka;Hf=Tc;If=Uc}Rd=d[Pd+(Cf<<2)+2>>1]|0;Od=b[Pd+(Cf<<2)>>0]|0;Qd=Od&255;if(!(Qd&240)){Ra=Rd&65535;Ud=(1<<Ef+Qd)+-1|0;Qd=((Hf&Ud)>>>Ef)+Ra|0;La=b[Pd+(Qd<<2)+1>>0]|0;if(((La&255)+Ef|0)>>>0>Df>>>0){Qa=Df;Nd=Ff;Md=Hf;Vb=If;while(1){if(!Nd){ua=la;va=Qa;wa=0;xa=Md;ya=Vb;za=n;Aa=Vc;break a}Pa=Nd+-1|0;Oa=Vb+1|0;Wd=(h[Vb>>0]<<Qa)+Md|0;Td=Qa+8|0;Yd=((Wd&Ud)>>>Ef)+Ra|0;Vd=b[Pd+(Yd<<2)+1>>0]|0;if(((Vd&255)+Ef|0)>>>0>Td>>>0){Qa=Td;Nd=Pa;Md=Wd;Vb=Oa}else{Jf=Yd;Kf=Td;Lf=Pa;Mf=Vd;Nf=Wd;Of=Oa;break}}}else{Jf=Qd;Kf=Df;Lf=Ff;Mf=La;Nf=Hf;Of=If}Vb=d[Pd+(Jf<<2)+2>>1]|0;Md=b[Pd+(Jf<<2)>>0]|0;Nd=(f[O>>2]|0)+Ef|0;f[O>>2]=Nd;Pf=Nd;Qf=Kf-Ef|0;Rf=Lf;Sf=Md;Tf=Mf;Uf=Vb;Vf=Nf>>>Ef;Wf=Of}else{Pf=f[O>>2]|0;Qf=Df;Rf=Ff;Sf=Od;Tf=Gf;Uf=Rd;Vf=Hf;Wf=If}Vb=Tf&255;Md=Vf>>>Vb;Nd=Qf-Vb|0;f[O>>2]=Pf+Vb;Vb=Sf&255;if(!(Vb&64)){f[R>>2]=Uf&65535;Qa=Vb&15;f[P>>2]=Qa;f[k>>2]=23;Wc=Qa;Xc=Nd;Yc=Rf;Zc=Md;_c=Wf;$c=Vc;ta=237;break}else{f[B>>2]=359372;f[k>>2]=29;Ca=Nd;Da=Rf;Ea=Md;Fa=la;Ga=Wf;Ha=n;Ia=p;Ja=Vc;break}}while(0);if((ta|0)==96){ta=0;if(!(f[z>>2]&4096)){Md=f[A>>2]|0;if(!Md){Xf=zb;Yf=Bb}else{f[Md+36>>2]=0;Xf=zb;Yf=Bb}}else{if(!zb){na=la;oa=yb;pa=0;qa=Ab;ra=Bb;sa=q;ta=281;break}else Zf=0;do{Md=Zf;Zf=Zf+1|0;Nd=b[Bb+Md>>0]|0;Md=f[A>>2]|0;if((Md|0?(Qa=f[Md+36>>2]|0,Qa|0):0)?(Vb=f[F>>2]|0,Vb>>>0<(f[Md+40>>2]|0)>>>0):0){f[F>>2]=Vb+1;b[Qa+Vb>>0]=Nd}_f=Nd<<24>>24!=0}while(_f&zb>>>0>Zf>>>0);if(f[z>>2]&512|0){Nd=LDa(f[x>>2]|0,Bb,Zf)|0;f[x>>2]=Nd}Nd=zb-Zf|0;Vb=Bb+Zf|0;if(_f){na=la;oa=yb;pa=Nd;qa=Ab;ra=Vb;sa=q;ta=281;break}else{Xf=Nd;Yf=Vb}}f[k>>2]=8;Cb=yb;Db=Xf;Eb=Ab;Fb=Yf;ta=109}else if((ta|0)==237){ta=0;if(!Wc){$f=Xc;ag=Yc;bg=Zc;cg=_c}else{if(Xc>>>0<Wc>>>0){Vb=Xc;Nd=Yc;Qa=Zc;Md=_c;while(1){if(!Nd){ua=la;va=Vb;wa=0;xa=Qa;ya=Md;za=n;Aa=$c;break a}Ra=Nd+-1|0;Ud=Md+1|0;Ka=(h[Md>>0]<<Vb)+Qa|0;Ba=Vb+8|0;if(Ba>>>0<Wc>>>0){Vb=Ba;Nd=Ra;Qa=Ka;Md=Ud}else{dg=Ba;eg=Ra;fg=Ka;gg=Ud;break}}}else{dg=Xc;eg=Yc;fg=Zc;gg=_c}f[R>>2]=(f[R>>2]|0)+(fg&(1<<Wc)+-1);f[O>>2]=(f[O>>2]|0)+Wc;$f=dg-Wc|0;ag=eg;bg=fg>>>Wc;cg=gg}f[k>>2]=24;ad=$f;bd=ag;cd=bg;dd=cg;ed=$c;ta=243}do if((ta|0)==109){ta=0;Md=f[z>>2]|0;if(Md&512){if(Cb>>>0<16){Qa=Cb;Nd=Db;Vb=Eb;Ud=Fb;while(1){if(!Nd){ua=la;va=Qa;wa=0;xa=Vb;ya=Ud;za=n;Aa=q;break a}Ka=Nd+-1|0;Ra=Ud+1|0;Ba=(h[Ud>>0]<<Qa)+Vb|0;Na=Qa+8|0;if(Na>>>0<16){Qa=Na;Nd=Ka;Vb=Ba;Ud=Ra}else{hg=Na;ig=Ka;jg=Ba;kg=Ra;break}}}else{hg=Cb;ig=Db;jg=Eb;kg=Fb}if((jg|0)==(f[x>>2]&65535|0)){lg=0;mg=ig;ng=0;og=kg}else{f[B>>2]=359058;f[k>>2]=29;Ca=hg;Da=ig;Ea=jg;Fa=la;Ga=kg;Ha=n;Ia=p;Ja=q;break}}else{lg=Cb;mg=Db;ng=Eb;og=Fb}Ud=f[A>>2]|0;if(Ud|0){f[Ud+44>>2]=Md>>>9&1;f[Ud+48>>2]=1}Ud=LDa(0,0,0)|0;f[x>>2]=Ud;f[E>>2]=Ud;f[k>>2]=11;Ca=lg;Da=mg;Ea=ng;Fa=la;Ga=og;Ha=n;Ia=p;Ja=q}else if((ta|0)==243){ta=0;if(!la){na=0;oa=ad;pa=bd;qa=cd;ra=dd;sa=ed;ta=281;break a}Ud=n-la|0;Vb=f[R>>2]|0;if(Vb>>>0>Ud>>>0){Nd=Vb-Ud|0;if(Nd>>>0>(f[S>>2]|0)>>>0?f[T>>2]|0:0){f[B>>2]=359394;f[k>>2]=29;Ca=ad;Da=bd;Ea=cd;Fa=la;Ga=dd;Ha=n;Ia=p;Ja=ed;break}Ud=f[U>>2]|0;if(Nd>>>0>Ud>>>0){Qa=Nd-Ud|0;pg=Qa;qg=(f[W>>2]|0)-Qa|0}else{pg=Nd;qg=Ud-Nd|0}Nd=f[F>>2]|0;rg=Nd;sg=pg>>>0>Nd>>>0?Nd:pg;tg=(f[V>>2]|0)+qg|0}else{Nd=f[F>>2]|0;rg=Nd;sg=Nd;tg=p+(0-Vb)|0}Vb=sg>>>0>la>>>0?la:sg;f[F>>2]=rg-Vb;Nd=Vb+1|0;Ud=Vb;Qa=tg;Rd=p;while(1){b[Rd>>0]=b[Qa>>0]|0;Ud=Ud+-1|0;if(!Ud)break;else{Qa=Qa+1|0;Rd=Rd+1|0}}Rd=la-Vb|0;Qa=p+-1+Nd|0;if(!(f[F>>2]|0)){f[k>>2]=20;Ca=ad;Da=bd;Ea=cd;Fa=Rd;Ga=dd;Ha=n;Ia=Qa;Ja=ed}else{Ca=ad;Da=bd;Ea=cd;Fa=Rd;Ga=dd;Ha=n;Ia=Qa;Ja=ed}}while(0);ia=f[k>>2]|0;p=Ia;m=Ca;ja=Da;ka=Ea;la=Fa;ma=Ga;n=Ha;q=Ja}if((ta|0)==122){f[l>>2]=p;f[o>>2]=la;f[a>>2]=Mb;f[r>>2]=Kb;f[t>>2]=Lb;f[v>>2]=Jb;i=2;u=e;return i|0}else if((ta|0)==132){ua=la;va=Hd+-3|0;wa=Id;xa=Jd>>>3;ya=Kd;za=n;Aa=q}else if((ta|0)!=135)if((ta|0)==280){f[k>>2]=28;ua=la;va=zd;wa=Ad;xa=Bd;ya=Cd;za=ud;Aa=1}else if((ta|0)==281){ua=na;va=oa;wa=pa;xa=qa;ya=ra;za=n;Aa=sa}else if((ta|0)==295){i=-4;u=e;return i|0}else if((ta|0)==296){u=e;return i|0}f[l>>2]=p;f[o>>2]=ua;f[a>>2]=ya;f[r>>2]=wa;f[t>>2]=xa;f[v>>2]=va;if(!(f[W>>2]|0))if(((za|0)!=(ua|0)?(W=f[k>>2]|0,W>>>0<29):0)?(c|0)!=4|W>>>0<26:0)ta=286;else{ug=wa;vg=ua}else ta=286;do if((ta|0)==286){if(!(EDa(a,p,za-ua|0)|0)){ug=f[r>>2]|0;vg=f[o>>2]|0;break}f[k>>2]=30;i=-4;u=e;return i|0}while(0);o=s-ug|0;ug=za-vg|0;vg=a+8|0;f[vg>>2]=(f[vg>>2]|0)+o;f[X>>2]=(f[X>>2]|0)+ug;f[Y>>2]=(f[Y>>2]|0)+ug;if((ug|0)!=0&(f[w>>2]|0)!=0){w=f[x>>2]|0;Y=(f[l>>2]|0)+(0-ug)|0;if(!(f[z>>2]|0))wg=KDa(w,Y,ug)|0;else wg=LDa(w,Y,ug)|0;f[x>>2]=wg;f[E>>2]=wg}wg=f[k>>2]|0;f[a+44>>2]=(f[I>>2]|0?64:0)+(f[v>>2]|0)+((wg|0)==11?128:0)+((wg|0)==19|(wg|0)==14?256:0);i=(Aa|0)==0&((c|0)==4|(ug|o|0)==0)?-5:Aa;u=e;return i|0}function EDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=f[a+28>>2]|0;e=d+52|0;g=f[e>>2]|0;if(!g){h=ui[f[a+32>>2]&127](f[a+40>>2]|0,1<<f[d+36>>2],1)|0;f[e>>2]=h;if(!h){i=1;return i|0}else j=h}else j=g;g=d+40|0;h=f[g>>2]|0;if(!h){a=1<<f[d+36>>2];f[g>>2]=a;f[d+48>>2]=0;f[d+44>>2]=0;k=a}else k=h;if(k>>>0<=c>>>0){K1a(j|0,b+(0-k)|0,k|0)|0;f[d+48>>2]=0;f[d+44>>2]=f[g>>2];i=0;return i|0}h=d+48|0;a=f[h>>2]|0;l=k-a|0;k=l>>>0>c>>>0?c:l;K1a(j+a|0,b+(0-c)|0,k|0)|0;a=c-k|0;if(a|0){K1a(f[e>>2]|0,b+(0-a)|0,a|0)|0;f[h>>2]=a;f[d+44>>2]=f[g>>2];i=0;return i|0}a=(f[h>>2]|0)+k|0;b=f[g>>2]|0;f[h>>2]=(a|0)==(b|0)?0:a;a=d+44|0;d=f[a>>2]|0;if(d>>>0>=b>>>0){i=0;return i|0}f[a>>2]=d+k;i=0;return i|0}function FDa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;if(!a){b=-2;return b|0}c=a+28|0;d=f[c>>2]|0;if(!d){b=-2;return b|0}e=a+36|0;g=f[e>>2]|0;if(!g){b=-2;return b|0}h=f[d+52>>2]|0;i=a+40|0;if(!h){j=g;k=d}else{Gh[g&511](f[i>>2]|0,h);j=f[e>>2]|0;k=f[c>>2]|0}Gh[j&511](f[i>>2]|0,k);f[c>>2]=0;b=0;return b|0}function GDa(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;k=u;u=u+64|0;l=k+32|0;m=k;n=l;o=n+32|0;do{d[n>>1]=0;n=n+2|0}while((n|0)<(o|0));n=(e|0)==0;if(!n){o=0;do{p=l+(j[c+(o<<1)>>1]<<1)|0;d[p>>1]=(d[p>>1]|0)+1<<16>>16;o=o+1|0}while((o|0)!=(e|0));o=d[l+30>>1]|0;p=f[h>>2]|0;if(!(o<<16>>16)){q=p;r=5}else{s=p;t=o;v=15;r=7}}else{q=f[h>>2]|0;r=5}do if((r|0)==5)if(!(d[l+28>>1]|0))if(!(d[l+26>>1]|0))if(!(d[l+24>>1]|0))if(!(d[l+22>>1]|0))if(!(d[l+20>>1]|0))if(!(d[l+18>>1]|0))if(!(d[l+16>>1]|0))if(!(d[l+14>>1]|0))if(!(d[l+12>>1]|0))if(!(d[l+10>>1]|0))if(!(d[l+8>>1]|0))if(!(d[l+6>>1]|0))if(!(d[l+4>>1]|0)){if(d[l+2>>1]|0){w=0;x=(q|0)!=0&1;y=1;z=1;break}o=f[g>>2]|0;f[g>>2]=o+4;b[o>>0]=64;b[o+1>>0]=1;d[o+2>>1]=0;o=f[g>>2]|0;f[g>>2]=o+4;b[o>>0]=64;b[o+1>>0]=1;d[o+2>>1]=0;f[h>>2]=1;A=0;u=k;return A|0}else{s=q;t=0;v=2;r=7}else{s=q;t=0;v=3;r=7}else{s=q;t=0;v=4;r=7}else{s=q;t=0;v=5;r=7}else{s=q;t=0;v=6;r=7}else{s=q;t=0;v=7;r=7}else{s=q;t=0;v=8;r=7}else{s=q;t=0;v=9;r=7}else{s=q;t=0;v=10;r=7}else{s=q;t=0;v=11;r=7}else{s=q;t=0;v=12;r=7}else{s=q;t=0;v=13;r=7}else{s=q;t=0;v=14;r=7}while(0);a:do if((r|0)==7){q=s>>>0>v>>>0?v:s;o=1;while(1){if(d[l+(o<<1)>>1]|0){w=t;x=q;y=v;z=o;break a}p=o+1|0;if(p>>>0<v>>>0)o=p;else{w=t;x=q;y=v;z=p;break}}}while(0);v=x>>>0<z>>>0?z:x;x=d[l+2>>1]|0;t=x&65535;s=2-t|0;if((s|0)<0){A=-1;u=k;return A|0}q=j[l+4>>1]|0;o=(s<<1)-q|0;if((o|0)<0){A=-1;u=k;return A|0}s=j[l+6>>1]|0;p=(o<<1)-s|0;if((p|0)<0){A=-1;u=k;return A|0}o=j[l+8>>1]|0;B=(p<<1)-o|0;if((B|0)<0){A=-1;u=k;return A|0}p=j[l+10>>1]|0;C=(B<<1)-p|0;if((C|0)<0){A=-1;u=k;return A|0}B=j[l+12>>1]|0;D=(C<<1)-B|0;if((D|0)<0){A=-1;u=k;return A|0}C=j[l+14>>1]|0;E=(D<<1)-C|0;if((E|0)<0){A=-1;u=k;return A|0}D=j[l+16>>1]|0;F=(E<<1)-D|0;if((F|0)<0){A=-1;u=k;return A|0}E=j[l+18>>1]|0;G=(F<<1)-E|0;if((G|0)<0){A=-1;u=k;return A|0}F=j[l+20>>1]|0;H=(G<<1)-F|0;if((H|0)<0){A=-1;u=k;return A|0}G=j[l+22>>1]|0;I=(H<<1)-G|0;if((I|0)<0){A=-1;u=k;return A|0}H=j[l+24>>1]|0;J=(I<<1)-H|0;if((J|0)<0){A=-1;u=k;return A|0}I=j[l+26>>1]|0;K=(J<<1)-I|0;if((K|0)<0){A=-1;u=k;return A|0}J=j[l+28>>1]|0;L=(K<<1)-J|0;if((L|0)<0){A=-1;u=k;return A|0}K=(L<<1)-(w&65535)|0;if((K|0)<0){A=-1;u=k;return A|0}if(K|0?(a|0)==0|(y|0)!=1:0){A=-1;u=k;return A|0}d[m+2>>1]=0;d[m+4>>1]=x;x=q+t|0;d[m+6>>1]=x;d[m+8>>1]=s+x;t=x+s|0;d[m+10>>1]=o+t;s=t+o|0;d[m+12>>1]=p+s;o=s+p|0;d[m+14>>1]=B+o;p=o+B|0;d[m+16>>1]=C+p;B=p+C|0;d[m+18>>1]=D+B;C=B+D|0;d[m+20>>1]=E+C;D=C+E|0;d[m+22>>1]=F+D;E=D+F|0;d[m+24>>1]=G+E;F=E+G|0;d[m+26>>1]=H+F;G=F+H|0;d[m+28>>1]=I+G;d[m+30>>1]=J+(G+I);if(!n){n=0;do{I=d[c+(n<<1)>>1]|0;if(I<<16>>16){G=m+((I&65535)<<1)|0;I=d[G>>1]|0;d[G>>1]=I+1<<16>>16;d[i+((I&65535)<<1)>>1]=n}n=n+1|0}while((n|0)!=(e|0))}switch(a|0){case 0:{M=i;N=0;O=0;P=19;Q=i;break}case 1:{if(v>>>0>9){A=1;u=k;return A|0}else{M=132460;N=1;O=0;P=256;Q=132586}break}default:{e=(a|0)==2;if(e&v>>>0>9){A=1;u=k;return A|0}else{M=132910;N=0;O=e;P=-1;Q=133036}}}e=1<<v;a=e+-1|0;n=v&255;m=v;I=0;G=0;J=z;z=-1;H=f[g>>2]|0;F=0;E=e;b:while(1){e=1<<m;R=G;D=J;C=F;while(1){B=D-I|0;S=B&255;p=d[i+(C<<1)>>1]|0;o=p&65535;do if((o|0)<(P|0)){T=p;U=0}else{if((o|0)<=(P|0)){T=0;U=96;break}T=d[M+(o<<1)>>1]|0;U=d[Q+(o<<1)>>1]&255}while(0);o=1<<B;p=R>>>I;s=e;do{s=s-o|0;t=s+p|0;b[H+(t<<2)>>0]=U;b[H+(t<<2)+1>>0]=S;d[H+(t<<2)+2>>1]=T}while((s|0)!=0);s=1<<D+-1;while(1)if(!(s&R))break;else s=s>>>1;p=R;R=(s|0)==0?0:(s+-1&R)+s|0;p=C;C=C+1|0;p=l+(D<<1)|0;o=(d[p>>1]|0)+-1<<16>>16;d[p>>1]=o;if(!(o<<16>>16)){if((D|0)==(y|0))break b;V=j[c+(j[i+(C<<1)>>1]<<1)>>1]|0}else V=D;if(V>>>0<=v>>>0){R=R;D=V;C=C;continue}W=R&a;if((W|0)!=(z|0))break;else D=V}D=(I|0)==0?v:I;o=H+(e<<2)|0;p=V-D|0;c:do if(V>>>0<y>>>0){B=V;t=p;x=1<<p;while(1){q=x-(j[l+(B<<1)>>1]|0)|0;if((q|0)<1){X=t;break c}K=t+1|0;B=K+D|0;if(B>>>0>=y>>>0){X=K;break}else{t=K;x=q<<1}}}else X=p;while(0);p=(1<<X)+E|0;if(N&p>>>0>852|O&p>>>0>592){A=1;r=43;break}e=f[g>>2]|0;b[e+(W<<2)>>0]=X;b[e+(W<<2)+1>>0]=n;d[e+(W<<2)+2>>1]=(o-e|0)>>>2;m=X;I=D;G=R;J=V;z=W;H=o;F=C;E=p}if((r|0)==43){u=k;return A|0}if(R|0){b[H+(R<<2)>>0]=64;b[H+(R<<2)+1>>0]=S;d[H+(R<<2)+2>>1]=0}f[g>>2]=(f[g>>2]|0)+(E<<2);f[h>>2]=v;A=0;u=k;return A|0}function HDa(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0;e=f[a+28>>2]|0;g=(f[a>>2]|0)+-1|0;i=a+4|0;j=g+((f[i>>2]|0)+-5)|0;k=a+12|0;l=(f[k>>2]|0)+-1|0;m=a+16|0;n=f[m>>2]|0;o=l+(n+-257)|0;p=f[e+40>>2]|0;q=f[e+44>>2]|0;r=f[e+48>>2]|0;s=e+56|0;t=e+60|0;u=f[e+76>>2]|0;v=f[e+80>>2]|0;w=(1<<f[e+84>>2])+-1|0;x=(1<<f[e+88>>2])+-1|0;y=l+(n-c)|0;c=e+7104|0;n=(f[e+52>>2]|0)+-1|0;z=(r|0)==0;A=r+p|0;B=y-r|0;C=f[t>>2]|0;D=f[s>>2]|0;E=g;g=l;a:while(1){if(C>>>0<15){l=E+2|0;F=C+16|0;G=((h[E+1>>0]|0)<<C)+D+((h[l>>0]|0)<<C+8)|0;H=l}else{F=C;G=D;H=E}l=G&w;I=b[u+(l<<2)>>0]|0;J=d[u+(l<<2)+2>>1]|0;K=h[u+(l<<2)+1>>0]|0;l=G>>>K;L=F-K|0;do if(I<<24>>24){M=I&255;K=J;N=l;O=L;while(1){if(M&16|0)break;if(M&64|0){P=53;break a}Q=(N&(1<<M)+-1)+(K&65535)|0;R=b[u+(Q<<2)>>0]|0;S=d[u+(Q<<2)+2>>1]|0;T=h[u+(Q<<2)+1>>0]|0;U=N>>>T;V=O-T|0;if(!(R<<24>>24)){P=6;break}else{M=R&255;K=S;N=U;O=V}}if((P|0)==6){P=0;W=S&255;X=U;Y=V;P=7;break}R=K&65535;T=M&15;if(!T){Z=O;_=N;$=H;aa=R}else{Q=H+1|0;if(O>>>0<T>>>0){ba=O+8|0;ca=((h[Q>>0]|0)<<O)+N|0;da=Q}else{ba=O;ca=N;da=H}Z=ba-T|0;_=ca>>>T;$=da;aa=(ca&(1<<T)+-1)+R|0}if(Z>>>0<15){R=$+2|0;ea=Z+16|0;fa=((h[$+1>>0]|0)<<Z)+_+((h[R>>0]|0)<<Z+8)|0;ga=R}else{ea=Z;fa=_;ga=$}R=fa&x;T=d[v+(R<<2)+2>>1]|0;Q=h[v+(R<<2)+1>>0]|0;ha=fa>>>Q;ia=ea-Q|0;Q=h[v+(R<<2)>>0]|0;if(!(Q&16)){R=Q;ja=T;ka=ha;la=ia;while(1){if(R&64|0){ma=359372;na=la;oa=ka;pa=ga;P=55;break a}qa=(ka&(1<<R)+-1)+(ja&65535)|0;ra=d[v+(qa<<2)+2>>1]|0;sa=h[v+(qa<<2)+1>>0]|0;ta=ka>>>sa;ua=la-sa|0;sa=h[v+(qa<<2)>>0]|0;if(!(sa&16)){R=sa;ja=ra;ka=ta;la=ua}else{va=sa;wa=ra;xa=ta;ya=ua;break}}}else{va=Q;wa=T;xa=ha;ya=ia}la=wa&65535;ka=va&15;if(ya>>>0<ka>>>0){ja=ga+1|0;R=((h[ja>>0]|0)<<ya)+xa|0;K=ya+8|0;ua=ga+2|0;if(K>>>0<ka>>>0){za=ya+16|0;Aa=((h[ua>>0]|0)<<K)+R|0;Ba=ua}else{za=K;Aa=R;Ba=ja}}else{za=ya;Aa=xa;Ba=ga}ja=(Aa&(1<<ka)+-1)+la|0;la=Aa>>>ka;R=za-ka|0;ka=g;K=ka-y|0;if(ja>>>0<=K>>>0){ua=g+(0-ja)|0;ta=aa;ra=g;while(1){b[ra+1>>0]=b[ua+1>>0]|0;b[ra+2>>0]=b[ua+2>>0]|0;sa=ua+3|0;Ca=ra+3|0;b[Ca>>0]=b[sa>>0]|0;ta=ta+-3|0;if(ta>>>0<=2)break;else{ua=sa;ra=Ca}}if(!ta){Da=R;Ea=la;Fa=Ba;Ga=Ca;break}ia=ra+4|0;b[ia>>0]=b[ua+4>>0]|0;if((ta|0)==1){Da=R;Ea=la;Fa=Ba;Ga=ia;break}ia=ra+5|0;b[ia>>0]=b[ua+5>>0]|0;Da=R;Ea=la;Fa=Ba;Ga=ia;break}ia=ja-K|0;if(ia>>>0>q>>>0?f[c>>2]|0:0){ma=359394;na=R;oa=la;pa=Ba;P=55;break a}do if(z){ha=n+(p-ia)|0;if(aa>>>0>ia>>>0){T=aa-ia|0;Q=ja-ka|0;sa=ha;qa=ia;Ha=g;do{sa=sa+1|0;Ha=Ha+1|0;b[Ha>>0]=b[sa>>0]|0;qa=qa+-1|0}while((qa|0)!=0);qa=g+y+Q|0;Ia=qa+(0-ja)|0;Ja=T;Ka=qa}else{Ia=ha;Ja=aa;Ka=g}}else{if(r>>>0>=ia>>>0){qa=n+(r-ia)|0;if(aa>>>0<=ia>>>0){Ia=qa;Ja=aa;Ka=g;break}sa=aa-ia|0;Ha=ja-ka|0;La=qa;qa=ia;Ma=g;do{La=La+1|0;Ma=Ma+1|0;b[Ma>>0]=b[La>>0]|0;qa=qa+-1|0}while((qa|0)!=0);qa=g+y+Ha|0;Ia=qa+(0-ja)|0;Ja=sa;Ka=qa;break}qa=n+(A-ia)|0;La=ia-r|0;if(aa>>>0>La>>>0){Ma=aa-La|0;ha=ja-ka|0;T=qa;Q=La;La=g;do{T=T+1|0;La=La+1|0;b[La>>0]=b[T>>0]|0;Q=Q+-1|0}while((Q|0)!=0);Q=g+B+ha|0;if(Ma>>>0>r>>>0){T=g+y|0;La=n;sa=r;Ha=Q;do{La=La+1|0;Ha=Ha+1|0;b[Ha>>0]=b[La>>0]|0;sa=sa+-1|0}while((sa|0)!=0);sa=T+ha|0;Ia=sa+(0-ja)|0;Ja=Ma-r|0;Ka=sa}else{Ia=n;Ja=Ma;Ka=Q}}else{Ia=qa;Ja=aa;Ka=g}}while(0);if(Ja>>>0>2){ja=Ia;ka=Ja;ia=Ka;while(1){b[ia+1>>0]=b[ja+1>>0]|0;b[ia+2>>0]=b[ja+2>>0]|0;K=ja+3|0;ua=ia+3|0;b[ua>>0]=b[K>>0]|0;ra=ka+-3|0;if(ra>>>0>2){ja=K;ka=ra;ia=ua}else{Na=K;Oa=ra;Pa=ua;break}}}else{Na=Ia;Oa=Ja;Pa=Ka}if(Oa){ia=Pa+1|0;b[ia>>0]=b[Na+1>>0]|0;if((Oa|0)==1){Da=R;Ea=la;Fa=Ba;Ga=ia}else{ia=Pa+2|0;b[ia>>0]=b[Na+2>>0]|0;Da=R;Ea=la;Fa=Ba;Ga=ia}}else{Da=R;Ea=la;Fa=Ba;Ga=Pa}}else{W=J&255;X=l;Y=L;P=7}while(0);if((P|0)==7){P=0;L=g+1|0;b[L>>0]=W;Da=Y;Ea=X;Fa=H;Ga=L}if(Ga>>>0<o>>>0&Fa>>>0<j>>>0){C=Da;D=Ea;E=Fa;g=Ga}else{Qa=Da;Ra=Ea;Sa=Fa;Ta=Ga;P=57;break}}if((P|0)==53)if(!(M&32)){ma=359344;na=O;oa=N;pa=H;P=55}else{Ua=11;Va=O;Wa=N;Xa=H}else if((P|0)==57){Ya=Qa>>>3;Za=0-Ya|0;_a=Sa+Za|0;$a=Ya<<3;ab=Qa-$a|0;bb=1<<ab;cb=bb+-1|0;db=cb&Ra;eb=_a+1|0;f[a>>2]=eb;fb=Ta+1|0;f[k>>2]=fb;gb=_a;hb=j;ib=hb+5|0;jb=ib-gb|0;f[i>>2]=jb;kb=Ta;lb=o;mb=lb+257|0;nb=mb-kb|0;f[m>>2]=nb;f[s>>2]=db;f[t>>2]=ab;return}if((P|0)==55){f[a+24>>2]=ma;Ua=29;Va=na;Wa=oa;Xa=pa}f[e>>2]=Ua;Qa=Va;Ra=Wa;Sa=Xa;Ta=g;Ya=Qa>>>3;Za=0-Ya|0;_a=Sa+Za|0;$a=Ya<<3;ab=Qa-$a|0;bb=1<<ab;cb=bb+-1|0;db=cb&Ra;eb=_a+1|0;f[a>>2]=eb;fb=Ta+1|0;f[k>>2]=fb;gb=_a;hb=j;ib=hb+5|0;jb=ib-gb|0;f[i>>2]=jb;kb=Ta;lb=o;mb=lb+257|0;nb=mb-kb|0;f[m>>2]=nb;f[s>>2]=db;f[t>>2]=ab;return}function IDa(a,b,c){a=a|0;b=b|0;c=c|0;return dKa(Y(c,b)|0)|0}function JDa(a,b){a=a|0;b=b|0;eKa(b);return}function KDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=a>>>16;e=a&65535;if((c|0)==1){a=(h[b>>0]|0)+e|0;f=a>>>0>65520?a+-65521|0:a;a=f+d|0;g=(a>>>0>65520?a+15|0:a)<<16|f;return g|0}if(!b){g=1;return g|0}if(c>>>0<16){if(!c){i=e;j=d}else{f=e;a=b;k=c;l=d;while(1){k=k+-1|0;m=(h[a>>0]|0)+f|0;n=m+l|0;if(!k){i=m;j=n;break}else{f=m;a=a+1|0;l=n}}}g=((j>>>0)%65521|0)<<16|(i>>>0>65520?i+-65521|0:i);return g|0}if(c>>>0>5551){i=e;j=b;l=c;a=d;do{l=l+-5552|0;f=i;k=j;n=347;m=a;while(1){o=(h[k>>0]|0)+f|0;p=o+(h[k+1>>0]|0)|0;q=p+(h[k+2>>0]|0)|0;r=q+(h[k+3>>0]|0)|0;s=r+(h[k+4>>0]|0)|0;t=s+(h[k+5>>0]|0)|0;u=t+(h[k+6>>0]|0)|0;v=u+(h[k+7>>0]|0)|0;w=v+(h[k+8>>0]|0)|0;x=w+(h[k+9>>0]|0)|0;y=x+(h[k+10>>0]|0)|0;z=y+(h[k+11>>0]|0)|0;A=z+(h[k+12>>0]|0)|0;B=A+(h[k+13>>0]|0)|0;C=B+(h[k+14>>0]|0)|0;f=C+(h[k+15>>0]|0)|0;m=o+m+p+q+r+s+t+u+v+w+x+y+z+A+B+C+f|0;n=n+-1|0;if(!n)break;else k=k+16|0}j=j+5552|0;i=(f>>>0)%65521|0;a=(m>>>0)%65521|0}while(l>>>0>5551);if(l)if(l>>>0>15){D=i;E=j;F=l;G=a;H=14}else{I=i;J=j;K=l;L=a;H=17}else{M=i;N=a}}else{D=e;E=b;F=c;G=d;H=14}if((H|0)==14){d=F+-16|0;c=d&-16;b=c+16|0;e=D;D=E;a=F;F=G;while(1){a=a+-16|0;G=(h[D>>0]|0)+e|0;i=G+(h[D+1>>0]|0)|0;l=i+(h[D+2>>0]|0)|0;j=l+(h[D+3>>0]|0)|0;k=j+(h[D+4>>0]|0)|0;n=k+(h[D+5>>0]|0)|0;C=n+(h[D+6>>0]|0)|0;B=C+(h[D+7>>0]|0)|0;A=B+(h[D+8>>0]|0)|0;z=A+(h[D+9>>0]|0)|0;y=z+(h[D+10>>0]|0)|0;x=y+(h[D+11>>0]|0)|0;w=x+(h[D+12>>0]|0)|0;v=w+(h[D+13>>0]|0)|0;u=v+(h[D+14>>0]|0)|0;e=u+(h[D+15>>0]|0)|0;F=G+F+i+l+j+k+n+C+B+A+z+y+x+w+v+u+e|0;if(a>>>0<=15)break;else D=D+16|0}D=d-c|0;if(!D){O=e;P=F;H=18}else{I=e;J=E+b|0;K=D;L=F;H=17}}if((H|0)==17)while(1){H=0;K=K+-1|0;F=(h[J>>0]|0)+I|0;D=F+L|0;if(!K){O=F;P=D;H=18;break}else{I=F;J=J+1|0;L=D;H=17}}if((H|0)==18){M=(O>>>0)%65521|0;N=(P>>>0)%65521|0}g=N<<16|M;return g|0}function LDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;if(!b){d=0;return d|0}e=~a;a:do if(c){a=b;g=e;i=c;while(1){if(!(a&3))break;j=f[110296+(((h[a>>0]|0)^g&255)<<2)>>2]^g>>>8;k=i+-1|0;if(!k){l=j;break a}else{a=a+1|0;g=j;i=k}}if(i>>>0>31){k=i+-32|0;j=k&-32;m=a+(j+32)|0;n=a;o=g;p=i;while(1){q=f[n>>2]^o;r=f[112344+((q>>>8&255)<<2)>>2]^f[113368+((q&255)<<2)>>2]^f[111320+((q>>>16&255)<<2)>>2]^f[110296+(q>>>24<<2)>>2]^f[n+4>>2];q=f[112344+((r>>>8&255)<<2)>>2]^f[113368+((r&255)<<2)>>2]^f[111320+((r>>>16&255)<<2)>>2]^f[110296+(r>>>24<<2)>>2]^f[n+8>>2];r=f[112344+((q>>>8&255)<<2)>>2]^f[113368+((q&255)<<2)>>2]^f[111320+((q>>>16&255)<<2)>>2]^f[110296+(q>>>24<<2)>>2]^f[n+12>>2];q=f[112344+((r>>>8&255)<<2)>>2]^f[113368+((r&255)<<2)>>2]^f[111320+((r>>>16&255)<<2)>>2]^f[110296+(r>>>24<<2)>>2]^f[n+16>>2];r=f[112344+((q>>>8&255)<<2)>>2]^f[113368+((q&255)<<2)>>2]^f[111320+((q>>>16&255)<<2)>>2]^f[110296+(q>>>24<<2)>>2]^f[n+20>>2];q=f[112344+((r>>>8&255)<<2)>>2]^f[113368+((r&255)<<2)>>2]^f[111320+((r>>>16&255)<<2)>>2]^f[110296+(r>>>24<<2)>>2]^f[n+24>>2];r=f[112344+((q>>>8&255)<<2)>>2]^f[113368+((q&255)<<2)>>2]^f[111320+((q>>>16&255)<<2)>>2]^f[110296+(q>>>24<<2)>>2]^f[n+28>>2];o=f[112344+((r>>>8&255)<<2)>>2]^f[113368+((r&255)<<2)>>2]^f[111320+((r>>>16&255)<<2)>>2]^f[110296+(r>>>24<<2)>>2];p=p+-32|0;if(p>>>0<=31)break;else n=n+32|0}s=m;t=o;u=k-j|0}else{s=a;t=g;u=i}if(u>>>0>3){n=u+-4|0;p=n>>>2;r=p+1|0;q=s;v=t;w=u;while(1){x=f[q>>2]^v;v=f[112344+((x>>>8&255)<<2)>>2]^f[113368+((x&255)<<2)>>2]^f[111320+((x>>>16&255)<<2)>>2]^f[110296+(x>>>24<<2)>>2];w=w+-4|0;if(w>>>0<=3)break;else q=q+4|0}y=s+(r<<2)|0;z=v;A=n-(p<<2)|0}else{y=s;z=t;A=u}if(!A)l=z;else{q=y;w=z;i=A;while(1){g=f[110296+(((h[q>>0]|0)^w&255)<<2)>>2]^w>>>8;i=i+-1|0;if(!i){l=g;break}else{q=q+1|0;w=g}}}}else l=e;while(0);d=~l;return d|0}function MDa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;if(!i){k=-6;return k|0}if((j|0)!=56|(b[i>>0]|0)!=49){k=-6;return k|0}if(!a){k=-2;return k|0}i=a+24|0;f[i>>2]=0;j=a+32|0;l=f[j>>2]|0;if(!l){f[j>>2]=103;f[a+40>>2]=0;m=103}else m=l;l=a+36|0;if(!(f[l>>2]|0))f[l>>2]=387;n=(c|0)==-1?6:c;if((e|0)<0){o=0-e|0;p=0}else{c=(e|0)>15;o=c?e+-16|0:e;p=c?2:1}if(h>>>0>4|(n>>>0>9|((d|0)!=8|(g+-1|0)>>>0>8|(o&-8|0)!=8))){k=-2;return k|0}d=(o|0)==8?9:o;o=a+40|0;c=ui[m&127](f[o>>2]|0,1,5828)|0;if(!c){k=-4;return k|0}m=a+28|0;f[m>>2]=c;f[c>>2]=a;f[c+24>>2]=p;f[c+28>>2]=0;f[c+48>>2]=d;p=1<<d;d=c+44|0;f[d>>2]=p;f[c+52>>2]=p+-1;e=g+7|0;f[c+80>>2]=e;q=1<<e;e=c+76|0;f[e>>2]=q;f[c+84>>2]=q+-1;f[c+88>>2]=((g+9|0)>>>0)/3|0;q=ui[f[j>>2]&127](f[o>>2]|0,p,2)|0;p=c+56|0;f[p>>2]=q;q=ui[f[j>>2]&127](f[o>>2]|0,f[d>>2]|0,2)|0;d=c+64|0;f[d>>2]=q;q=ui[f[j>>2]&127](f[o>>2]|0,f[e>>2]|0,2)|0;e=c+68|0;f[e>>2]=q;f[c+5824>>2]=0;q=1<<g+6;g=c+5788|0;f[g>>2]=q;r=ui[f[j>>2]&127](f[o>>2]|0,q,4)|0;f[c+8>>2]=r;q=f[g>>2]|0;f[c+12>>2]=q<<2;if((f[p>>2]|0?f[d>>2]|0:0)?!((f[e>>2]|0)==0|(r|0)==0):0){f[c+5796>>2]=r+(q>>>1<<1);f[c+5784>>2]=r+(q*3|0);f[c+132>>2]=n;f[c+136>>2]=h;b[c+36>>0]=8;k=NDa(a)|0;return k|0}f[c+4>>2]=666;f[i>>2]=f[27570];i=f[m>>2]|0;if(!i){k=-4;return k|0}switch(f[i+4>>2]|0){case 42:case 69:case 73:case 91:case 103:case 113:case 666:break;default:{k=-4;return k|0}}c=f[i+8>>2]|0;if(!c)s=i;else{Gh[f[l>>2]&511](f[o>>2]|0,c);s=f[m>>2]|0}c=f[s+68>>2]|0;if(!c)t=s;else{Gh[f[l>>2]&511](f[o>>2]|0,c);t=f[m>>2]|0}c=f[t+64>>2]|0;if(!c)u=t;else{Gh[f[l>>2]&511](f[o>>2]|0,c);u=f[m>>2]|0}c=f[u+56>>2]|0;if(!c)v=u;else{Gh[f[l>>2]&511](f[o>>2]|0,c);v=f[m>>2]|0}Gh[f[l>>2]&511](f[o>>2]|0,v);f[m>>2]=0;k=-4;return k|0}function NDa(a){a=a|0;var b=0,c=0,e=0,g=0,h=0,i=0,k=0,l=0;if(!a){b=-2;return b|0}c=a+28|0;e=f[c>>2]|0;if(!e){b=-2;return b|0}if(!(f[a+32>>2]|0)){b=-2;return b|0}if(!(f[a+36>>2]|0)){b=-2;return b|0}f[a+20>>2]=0;f[a+8>>2]=0;f[a+24>>2]=0;f[a+44>>2]=2;f[e+20>>2]=0;f[e+16>>2]=f[e+8>>2];g=e+24|0;h=f[g>>2]|0;i=0-h|0;if((h|0)<0){f[g>>2]=i;k=i}else k=h;f[e+4>>2]=k|0?42:113;if((k|0)==2)l=LDa(0,0,0)|0;else l=KDa(0,0,0)|0;f[a+48>>2]=l;f[e+40>>2]=0;VDa(e);e=f[c>>2]|0;f[e+60>>2]=f[e+44>>2]<<1;c=f[e+68>>2]|0;l=(f[e+76>>2]|0)+-1|0;d[c+(l<<1)>>1]=0;F1a(c|0,0,l<<1|0)|0;l=f[e+132>>2]|0;f[e+128>>2]=j[118488+(l*12|0)+2>>1];f[e+140>>2]=j[118488+(l*12|0)>>1];f[e+144>>2]=j[118488+(l*12|0)+4>>1];f[e+124>>2]=j[118488+(l*12|0)+6>>1];f[e+108>>2]=0;f[e+92>>2]=0;f[e+116>>2]=0;f[e+5812>>2]=0;f[e+120>>2]=2;f[e+96>>2]=2;f[e+104>>2]=0;f[e+72>>2]=0;b=0;return b|0}function ODa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;c=(f[a+12>>2]|0)+-5|0;d=c>>>0<65535?c:65535;c=a+116|0;e=a+108|0;g=a+92|0;h=a+44|0;i=a+56|0;while(1){j=f[c>>2]|0;if(j>>>0<2){RDa(a);k=f[c>>2]|0;if(!(k|b)){l=0;m=35;break}if(!k){m=20;break}else n=k}else n=j;j=(f[e>>2]|0)+n|0;f[e>>2]=j;f[c>>2]=0;k=f[g>>2]|0;o=k+d|0;if((j|0)!=0&j>>>0<o>>>0){p=k;q=j}else{f[c>>2]=j-o;f[e>>2]=o;if((k|0)>-1)r=(f[i>>2]|0)+k|0;else r=0;_Da(a,r,d,0);f[g>>2]=f[e>>2];k=f[a>>2]|0;o=f[k+28>>2]|0;YDa(o);j=o+20|0;s=f[j>>2]|0;t=k+16|0;u=f[t>>2]|0;v=s>>>0>u>>>0?u:s;if(v|0?(s=k+12|0,u=o+16|0,K1a(f[s>>2]|0,f[u>>2]|0,v|0)|0,f[s>>2]=(f[s>>2]|0)+v,f[u>>2]=(f[u>>2]|0)+v,s=k+20|0,f[s>>2]=(f[s>>2]|0)+v,f[t>>2]=(f[t>>2]|0)-v,t=(f[j>>2]|0)-v|0,f[j>>2]=t,(t|0)==0):0)f[u>>2]=f[o+8>>2];if(!(f[(f[a>>2]|0)+16>>2]|0)){l=0;m=35;break}p=f[g>>2]|0;q=f[e>>2]|0}o=q-p|0;if(o>>>0<((f[h>>2]|0)+-262|0)>>>0)continue;if((p|0)>-1)w=(f[i>>2]|0)+p|0;else w=0;_Da(a,w,o,0);f[g>>2]=f[e>>2];o=f[a>>2]|0;u=f[o+28>>2]|0;YDa(u);t=u+20|0;j=f[t>>2]|0;v=o+16|0;s=f[v>>2]|0;k=j>>>0>s>>>0?s:j;if(k|0?(j=o+12|0,s=u+16|0,K1a(f[j>>2]|0,f[s>>2]|0,k|0)|0,f[j>>2]=(f[j>>2]|0)+k,f[s>>2]=(f[s>>2]|0)+k,j=o+20|0,f[j>>2]=(f[j>>2]|0)+k,f[v>>2]=(f[v>>2]|0)-k,v=(f[t>>2]|0)-k|0,f[t>>2]=v,(v|0)==0):0)f[s>>2]=f[u+8>>2];if(!(f[(f[a>>2]|0)+16>>2]|0)){l=0;m=35;break}}if((m|0)==20){f[a+5812>>2]=0;w=f[e>>2]|0;p=f[g>>2]|0;if((b|0)==4){if((p|0)>-1)x=(f[i>>2]|0)+p|0;else x=0;_Da(a,x,w-p|0,1);f[g>>2]=f[e>>2];x=f[a>>2]|0;b=f[x+28>>2]|0;YDa(b);h=b+20|0;q=f[h>>2]|0;d=x+16|0;r=f[d>>2]|0;c=q>>>0>r>>>0?r:q;if(c|0?(q=x+12|0,r=b+16|0,K1a(f[q>>2]|0,f[r>>2]|0,c|0)|0,f[q>>2]=(f[q>>2]|0)+c,f[r>>2]=(f[r>>2]|0)+c,q=x+20|0,f[q>>2]=(f[q>>2]|0)+c,f[d>>2]=(f[d>>2]|0)-c,d=(f[h>>2]|0)-c|0,f[h>>2]=d,(d|0)==0):0)f[r>>2]=f[b+8>>2];l=(f[(f[a>>2]|0)+16>>2]|0)==0?2:3;return l|0}if((w|0)>(p|0)){if((p|0)>-1)y=(f[i>>2]|0)+p|0;else y=0;_Da(a,y,w-p|0,0);f[g>>2]=f[e>>2];e=f[a>>2]|0;g=f[e+28>>2]|0;YDa(g);p=g+20|0;w=f[p>>2]|0;y=e+16|0;i=f[y>>2]|0;b=w>>>0>i>>>0?i:w;if(b|0?(w=e+12|0,i=g+16|0,K1a(f[w>>2]|0,f[i>>2]|0,b|0)|0,f[w>>2]=(f[w>>2]|0)+b,f[i>>2]=(f[i>>2]|0)+b,w=e+20|0,f[w>>2]=(f[w>>2]|0)+b,f[y>>2]=(f[y>>2]|0)-b,y=(f[p>>2]|0)-b|0,f[p>>2]=y,(y|0)==0):0)f[i>>2]=f[g+8>>2];if(!(f[(f[a>>2]|0)+16>>2]|0)){l=0;return l|0}}l=1;return l|0}else if((m|0)==35)return l|0;return 0}function PDa(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=a+116|0;g=(c|0)==0;i=a+72|0;j=a+88|0;k=a+56|0;l=a+108|0;m=a+84|0;n=a+68|0;o=a+64|0;p=a+52|0;q=a+44|0;r=a+96|0;s=a+5784|0;t=a+5796|0;u=a+112|0;v=a+5792|0;w=a+5788|0;x=a+128|0;y=a+92|0;while(1){if((f[e>>2]|0)>>>0<262){RDa(a);z=f[e>>2]|0;if(g&z>>>0<262){A=0;B=39;break}if(!z){B=24;break}if(z>>>0<=2)B=9;else B=6}else B=6;if((B|0)==6){B=0;z=f[l>>2]|0;C=((h[(f[k>>2]|0)+(z+2)>>0]|0)^f[i>>2]<<f[j>>2])&f[m>>2];f[i>>2]=C;D=(f[n>>2]|0)+(C<<1)|0;C=d[D>>1]|0;d[(f[o>>2]|0)+((f[p>>2]&z)<<1)>>1]=C;E=C&65535;d[D>>1]=z;if(C<<16>>16!=0?(z-E|0)>>>0<=((f[q>>2]|0)+-262|0)>>>0:0){z=SDa(a,E)|0;f[r>>2]=z;F=z}else B=9}if((B|0)==9){B=0;F=f[r>>2]|0}z=f[s>>2]|0;E=f[t>>2]|0;do if(F>>>0>2){C=F+253|0;D=(f[l>>2]|0)-(f[u>>2]|0)|0;G=f[v>>2]|0;d[E+(G<<1)>>1]=D;f[v>>2]=G+1;b[z+G>>0]=C;G=a+148+((h[360052+(C&255)>>0]|0|256)+1<<2)|0;d[G>>1]=(d[G>>1]|0)+1<<16>>16;G=D+65535&65535;D=a+2440+((h[359540+(G>>>0<256?G:(G>>>7)+256|0)>>0]|0)<<2)|0;d[D>>1]=(d[D>>1]|0)+1<<16>>16;D=(f[v>>2]|0)==((f[w>>2]|0)+-1|0)&1;G=f[r>>2]|0;C=(f[e>>2]|0)-G|0;f[e>>2]=C;if(!(C>>>0>2?G>>>0<=(f[x>>2]|0)>>>0:0)){C=(f[l>>2]|0)+G|0;f[l>>2]=C;f[r>>2]=0;H=f[k>>2]|0;I=h[H+C>>0]|0;f[i>>2]=I;f[i>>2]=((h[H+(C+1)>>0]|0)^I<<f[j>>2])&f[m>>2];J=C;K=D;break}C=G+-1|0;f[r>>2]=C;G=f[j>>2]|0;I=f[k>>2]|0;H=f[m>>2]|0;L=f[n>>2]|0;M=f[o>>2]|0;N=f[p>>2]|0;O=f[l>>2]|0;P=f[i>>2]|0;Q=C;while(1){C=O+1|0;f[l>>2]=C;P=((h[I+(O+3)>>0]|0)^P<<G)&H;f[i>>2]=P;R=L+(P<<1)|0;d[M+((N&C)<<1)>>1]=d[R>>1]|0;d[R>>1]=C;Q=Q+-1|0;f[r>>2]=Q;if(!Q)break;else O=C}Q=O+2|0;f[l>>2]=Q;J=Q;K=D}else{Q=b[(f[k>>2]|0)+(f[l>>2]|0)>>0]|0;N=f[v>>2]|0;d[E+(N<<1)>>1]=0;f[v>>2]=N+1;b[z+N>>0]=Q;N=a+148+((Q&255)<<2)|0;d[N>>1]=(d[N>>1]|0)+1<<16>>16;N=(f[v>>2]|0)==((f[w>>2]|0)+-1|0)&1;f[e>>2]=(f[e>>2]|0)+-1;Q=(f[l>>2]|0)+1|0;f[l>>2]=Q;J=Q;K=N}while(0);if(!K)continue;z=f[y>>2]|0;if((z|0)>-1)S=(f[k>>2]|0)+z|0;else S=0;_Da(a,S,J-z|0,0);f[y>>2]=f[l>>2];z=f[a>>2]|0;E=f[z+28>>2]|0;YDa(E);N=E+20|0;Q=f[N>>2]|0;M=z+16|0;P=f[M>>2]|0;L=Q>>>0>P>>>0?P:Q;if(L|0?(Q=z+12|0,P=E+16|0,K1a(f[Q>>2]|0,f[P>>2]|0,L|0)|0,f[Q>>2]=(f[Q>>2]|0)+L,f[P>>2]=(f[P>>2]|0)+L,Q=z+20|0,f[Q>>2]=(f[Q>>2]|0)+L,f[M>>2]=(f[M>>2]|0)-L,M=(f[N>>2]|0)-L|0,f[N>>2]=M,(M|0)==0):0)f[P>>2]=f[E+8>>2];if(!(f[(f[a>>2]|0)+16>>2]|0)){A=0;B=39;break}}if((B|0)==24){J=f[l>>2]|0;f[a+5812>>2]=J>>>0<2?J:2;if((c|0)==4){c=f[y>>2]|0;if((c|0)>-1)T=(f[k>>2]|0)+c|0;else T=0;_Da(a,T,J-c|0,1);f[y>>2]=f[l>>2];c=f[a>>2]|0;T=f[c+28>>2]|0;YDa(T);S=T+20|0;K=f[S>>2]|0;e=c+16|0;w=f[e>>2]|0;r=K>>>0>w>>>0?w:K;if(r|0?(K=c+12|0,w=T+16|0,K1a(f[K>>2]|0,f[w>>2]|0,r|0)|0,f[K>>2]=(f[K>>2]|0)+r,f[w>>2]=(f[w>>2]|0)+r,K=c+20|0,f[K>>2]=(f[K>>2]|0)+r,f[e>>2]=(f[e>>2]|0)-r,e=(f[S>>2]|0)-r|0,f[S>>2]=e,(e|0)==0):0)f[w>>2]=f[T+8>>2];A=(f[(f[a>>2]|0)+16>>2]|0)==0?2:3;return A|0}if(f[v>>2]|0){v=f[y>>2]|0;if((v|0)>-1)U=(f[k>>2]|0)+v|0;else U=0;_Da(a,U,J-v|0,0);f[y>>2]=f[l>>2];l=f[a>>2]|0;y=f[l+28>>2]|0;YDa(y);v=y+20|0;J=f[v>>2]|0;U=l+16|0;k=f[U>>2]|0;T=J>>>0>k>>>0?k:J;if(T|0?(J=l+12|0,k=y+16|0,K1a(f[J>>2]|0,f[k>>2]|0,T|0)|0,f[J>>2]=(f[J>>2]|0)+T,f[k>>2]=(f[k>>2]|0)+T,J=l+20|0,f[J>>2]=(f[J>>2]|0)+T,f[U>>2]=(f[U>>2]|0)-T,U=(f[v>>2]|0)-T|0,f[v>>2]=U,(U|0)==0):0)f[k>>2]=f[y+8>>2];if(!(f[(f[a>>2]|0)+16>>2]|0)){A=0;return A|0}}A=1;return A|0}else if((B|0)==39)return A|0;return 0}function QDa(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=a+116|0;g=(c|0)==0;i=a+72|0;j=a+88|0;k=a+56|0;l=a+108|0;m=a+84|0;n=a+68|0;o=a+64|0;p=a+52|0;q=a+96|0;r=a+120|0;s=a+112|0;t=a+100|0;u=a+5796|0;v=a+5792|0;w=a+5784|0;x=a+5788|0;y=a+104|0;z=a+92|0;A=a+128|0;B=a+44|0;C=a+136|0;a:while(1){D=f[e>>2]|0;while(1){if(D>>>0<262){RDa(a);E=f[e>>2]|0;if(g&E>>>0<262){F=0;G=55;break a}if(!E){G=38;break a}if(E>>>0<=2){f[r>>2]=f[q>>2];f[t>>2]=f[s>>2];f[q>>2]=2;H=2;G=16}else G=8}else G=8;do if((G|0)==8){G=0;E=f[l>>2]|0;I=((h[(f[k>>2]|0)+(E+2)>>0]|0)^f[i>>2]<<f[j>>2])&f[m>>2];f[i>>2]=I;J=(f[n>>2]|0)+(I<<1)|0;I=d[J>>1]|0;d[(f[o>>2]|0)+((f[p>>2]&E)<<1)>>1]=I;K=I&65535;d[J>>1]=E;E=f[q>>2]|0;f[r>>2]=E;f[t>>2]=f[s>>2];f[q>>2]=2;if(I<<16>>16)if(E>>>0<(f[A>>2]|0)>>>0)if(((f[l>>2]|0)-K|0)>>>0<=((f[B>>2]|0)+-262|0)>>>0){I=SDa(a,K)|0;f[q>>2]=I;if(I>>>0<6){if((f[C>>2]|0)!=1){if((I|0)!=3){H=I;G=16;break}if(((f[l>>2]|0)-(f[s>>2]|0)|0)>>>0<=4096){H=3;G=16;break}}f[q>>2]=2;H=2;G=16}else{H=I;G=16}}else{H=2;G=16}else{L=E;M=2}else{H=2;G=16}}while(0);if((G|0)==16){G=0;L=f[r>>2]|0;M=H}if(!(L>>>0<3|M>>>0>L>>>0))break;if(!(f[y>>2]|0)){f[y>>2]=1;f[l>>2]=(f[l>>2]|0)+1;E=(f[e>>2]|0)+-1|0;f[e>>2]=E;D=E;continue}E=b[(f[k>>2]|0)+((f[l>>2]|0)+-1)>>0]|0;I=f[v>>2]|0;d[(f[u>>2]|0)+(I<<1)>>1]=0;K=f[w>>2]|0;f[v>>2]=I+1;b[K+I>>0]=E;I=a+148+((E&255)<<2)|0;d[I>>1]=(d[I>>1]|0)+1<<16>>16;if((f[v>>2]|0)==((f[x>>2]|0)+-1|0)){I=f[z>>2]|0;if((I|0)>-1)N=(f[k>>2]|0)+I|0;else N=0;_Da(a,N,(f[l>>2]|0)-I|0,0);f[z>>2]=f[l>>2];I=f[a>>2]|0;E=f[I+28>>2]|0;YDa(E);K=E+20|0;J=f[K>>2]|0;O=I+16|0;P=f[O>>2]|0;Q=J>>>0>P>>>0?P:J;if(Q|0?(J=I+12|0,P=E+16|0,K1a(f[J>>2]|0,f[P>>2]|0,Q|0)|0,f[J>>2]=(f[J>>2]|0)+Q,f[P>>2]=(f[P>>2]|0)+Q,J=I+20|0,f[J>>2]=(f[J>>2]|0)+Q,f[O>>2]=(f[O>>2]|0)-Q,O=(f[K>>2]|0)-Q|0,f[K>>2]=O,(O|0)==0):0)f[P>>2]=f[E+8>>2]}f[l>>2]=(f[l>>2]|0)+1;D=(f[e>>2]|0)+-1|0;f[e>>2]=D;if(!(f[(f[a>>2]|0)+16>>2]|0)){F=0;G=55;break a}}D=f[l>>2]|0;E=D+-3+(f[e>>2]|0)|0;P=L+253|0;O=D+65535-(f[t>>2]|0)|0;D=f[v>>2]|0;d[(f[u>>2]|0)+(D<<1)>>1]=O;K=f[w>>2]|0;f[v>>2]=D+1;b[K+D>>0]=P;D=a+148+((h[360052+(P&255)>>0]|0|256)+1<<2)|0;d[D>>1]=(d[D>>1]|0)+1<<16>>16;D=O+65535&65535;O=a+2440+((h[359540+(D>>>0<256?D:(D>>>7)+256|0)>>0]|0)<<2)|0;d[O>>1]=(d[O>>1]|0)+1<<16>>16;O=f[v>>2]|0;D=(f[x>>2]|0)+-1|0;P=f[r>>2]|0;f[e>>2]=1-P+(f[e>>2]|0);K=P+-2|0;f[r>>2]=K;P=f[l>>2]|0;Q=K;while(1){K=P+1|0;f[l>>2]=K;if(K>>>0<=E>>>0){J=((h[(f[k>>2]|0)+(P+3)>>0]|0)^f[i>>2]<<f[j>>2])&f[m>>2];f[i>>2]=J;I=(f[n>>2]|0)+(J<<1)|0;d[(f[o>>2]|0)+((f[p>>2]&K)<<1)>>1]=d[I>>1]|0;d[I>>1]=K}Q=Q+-1|0;f[r>>2]=Q;if(!Q)break;else P=K}f[y>>2]=0;f[q>>2]=2;Q=P+2|0;f[l>>2]=Q;if((O|0)!=(D|0))continue;E=f[z>>2]|0;if((E|0)>-1)R=(f[k>>2]|0)+E|0;else R=0;_Da(a,R,Q-E|0,0);f[z>>2]=f[l>>2];E=f[a>>2]|0;Q=f[E+28>>2]|0;YDa(Q);K=Q+20|0;I=f[K>>2]|0;J=E+16|0;S=f[J>>2]|0;T=I>>>0>S>>>0?S:I;if(T|0?(I=E+12|0,S=Q+16|0,K1a(f[I>>2]|0,f[S>>2]|0,T|0)|0,f[I>>2]=(f[I>>2]|0)+T,f[S>>2]=(f[S>>2]|0)+T,I=E+20|0,f[I>>2]=(f[I>>2]|0)+T,f[J>>2]=(f[J>>2]|0)-T,J=(f[K>>2]|0)-T|0,f[K>>2]=J,(J|0)==0):0)f[S>>2]=f[Q+8>>2];if(!(f[(f[a>>2]|0)+16>>2]|0)){F=0;G=55;break}}if((G|0)==38){if(f[y>>2]|0){R=b[(f[k>>2]|0)+((f[l>>2]|0)+-1)>>0]|0;q=f[v>>2]|0;d[(f[u>>2]|0)+(q<<1)>>1]=0;u=f[w>>2]|0;f[v>>2]=q+1;b[u+q>>0]=R;q=a+148+((R&255)<<2)|0;d[q>>1]=(d[q>>1]|0)+1<<16>>16;f[y>>2]=0}y=f[l>>2]|0;f[a+5812>>2]=y>>>0<2?y:2;if((c|0)==4){c=f[z>>2]|0;if((c|0)>-1)U=(f[k>>2]|0)+c|0;else U=0;_Da(a,U,y-c|0,1);f[z>>2]=f[l>>2];c=f[a>>2]|0;U=f[c+28>>2]|0;YDa(U);q=U+20|0;R=f[q>>2]|0;u=c+16|0;w=f[u>>2]|0;r=R>>>0>w>>>0?w:R;if(r|0?(R=c+12|0,w=U+16|0,K1a(f[R>>2]|0,f[w>>2]|0,r|0)|0,f[R>>2]=(f[R>>2]|0)+r,f[w>>2]=(f[w>>2]|0)+r,R=c+20|0,f[R>>2]=(f[R>>2]|0)+r,f[u>>2]=(f[u>>2]|0)-r,u=(f[q>>2]|0)-r|0,f[q>>2]=u,(u|0)==0):0)f[w>>2]=f[U+8>>2];F=(f[(f[a>>2]|0)+16>>2]|0)==0?2:3;return F|0}if(f[v>>2]|0){v=f[z>>2]|0;if((v|0)>-1)V=(f[k>>2]|0)+v|0;else V=0;_Da(a,V,y-v|0,0);f[z>>2]=f[l>>2];l=f[a>>2]|0;z=f[l+28>>2]|0;YDa(z);v=z+20|0;y=f[v>>2]|0;V=l+16|0;k=f[V>>2]|0;U=y>>>0>k>>>0?k:y;if(U|0?(y=l+12|0,k=z+16|0,K1a(f[y>>2]|0,f[k>>2]|0,U|0)|0,f[y>>2]=(f[y>>2]|0)+U,f[k>>2]=(f[k>>2]|0)+U,y=l+20|0,f[y>>2]=(f[y>>2]|0)+U,f[V>>2]=(f[V>>2]|0)-U,V=(f[v>>2]|0)-U|0,f[v>>2]=V,(V|0)==0):0)f[k>>2]=f[z+8>>2];if(!(f[(f[a>>2]|0)+16>>2]|0)){F=0;return F|0}}F=1;return F|0}else if((G|0)==55)return F|0;return 0}function RDa(a){a=a|0;var b=0,c=0,e=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=a+44|0;c=f[b>>2]|0;e=a+60|0;g=a+116|0;i=a+108|0;k=c+-262|0;l=a+56|0;m=a+5812|0;n=a+72|0;o=a+88|0;p=a+84|0;q=a+68|0;r=a+64|0;s=a+52|0;t=a+112|0;u=a+92|0;v=a+76|0;w=f[g>>2]|0;x=c;while(1){y=f[i>>2]|0;z=(f[e>>2]|0)-w-y|0;if(y>>>0<(k+x|0)>>>0){A=y;B=z}else{y=f[l>>2]|0;K1a(y|0,y+c|0,c|0)|0;f[t>>2]=(f[t>>2]|0)-c;y=(f[i>>2]|0)-c|0;f[i>>2]=y;f[u>>2]=(f[u>>2]|0)-c;C=f[v>>2]|0;D=C;E=(f[q>>2]|0)+(C<<1)|0;do{E=E+-2|0;C=j[E>>1]|0;d[E>>1]=C>>>0<c>>>0?0:C-c&65535;D=D+-1|0}while((D|0)!=0);D=c;E=(f[r>>2]|0)+(c<<1)|0;do{E=E+-2|0;C=j[E>>1]|0;d[E>>1]=C>>>0<c>>>0?0:C-c&65535;D=D+-1|0}while((D|0)!=0);A=y;B=z+c|0}D=f[a>>2]|0;E=D+4|0;C=f[E>>2]|0;if(!C)break;F=f[g>>2]|0;G=(f[l>>2]|0)+A+F|0;H=C>>>0>B>>>0?B:C;if(!H){I=F;J=0}else{f[E>>2]=C-H;K1a(G|0,f[D>>2]|0,H|0)|0;switch(f[(f[D+28>>2]|0)+24>>2]|0){case 1:{C=D+48|0;K=C;L=KDa(f[C>>2]|0,G,H)|0;M=13;break}case 2:{C=D+48|0;K=C;L=LDa(f[C>>2]|0,G,H)|0;M=13;break}default:{}}if((M|0)==13){M=0;f[K>>2]=L}f[D>>2]=(f[D>>2]|0)+H;G=D+8|0;f[G>>2]=(f[G>>2]|0)+H;I=f[g>>2]|0;J=H}H=I+J|0;f[g>>2]=H;G=f[m>>2]|0;a:do if((G+H|0)>>>0>2){D=(f[i>>2]|0)-G|0;C=f[l>>2]|0;E=h[C+D>>0]|0;f[n>>2]=E;F=f[o>>2]|0;N=f[p>>2]|0;O=((h[C+(D+1)>>0]|0)^E<<F)&N;f[n>>2]=O;E=G;P=O;O=D;while(1){if(!E)break a;P=((h[C+(O+2)>>0]|0)^P<<F)&N;f[n>>2]=P;D=(f[q>>2]|0)+(P<<1)|0;d[(f[r>>2]|0)+((f[s>>2]&O)<<1)>>1]=d[D>>1]|0;d[D>>1]=O;E=E+-1|0;f[m>>2]=E;if((H+E|0)>>>0<3)break;else O=O+1|0}}while(0);if(H>>>0>=262)break;if(!(f[(f[a>>2]|0)+4>>2]|0))break;w=H;x=f[b>>2]|0}b=a+5824|0;a=f[b>>2]|0;x=f[e>>2]|0;if(x>>>0<=a>>>0)return;e=(f[g>>2]|0)+(f[i>>2]|0)|0;do if(a>>>0>=e>>>0){i=e+258|0;if(i>>>0>a>>>0){g=i-a|0;i=x-a|0;w=g>>>0>i>>>0?i:g;F1a((f[l>>2]|0)+a|0,0,w|0)|0;Q=(f[b>>2]|0)+w|0;break}else return}else{w=x-e|0;g=w>>>0<258?w:258;F1a((f[l>>2]|0)+e|0,0,g|0)|0;Q=g+e|0}while(0);f[b>>2]=Q;return}function SDa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=f[a+124>>2]|0;e=f[a+56>>2]|0;g=f[a+108>>2]|0;h=e+g|0;i=f[a+120>>2]|0;k=f[a+144>>2]|0;l=(f[a+44>>2]|0)+-262|0;m=g>>>0>l>>>0?g-l|0:0;l=f[a+64>>2]|0;g=f[a+52>>2]|0;n=f[a+116>>2]|0;o=k>>>0>n>>>0?n:k;k=a+112|0;p=h+1|0;q=h+258|0;r=i;s=i>>>0<(f[a+140>>2]|0)>>>0?d:d>>>2;d=c;c=b[h+i>>0]|0;a=b[h+(i+-1)>>0]|0;while(1){i=e+d|0;if((((b[i+r>>0]|0)==c<<24>>24?(b[i+(r+-1)>>0]|0)==a<<24>>24:0)?(b[i>>0]|0)==(b[h>>0]|0):0)?(t=i+1|0,(b[t>>0]|0)==(b[p>>0]|0)):0){i=t;t=2;while(1){u=h+t|0;v=u+1|0;if((b[v>>0]|0)!=(b[i+2>>0]|0)){w=v;break}v=u+2|0;if((b[v>>0]|0)!=(b[i+3>>0]|0)){w=v;break}v=u+3|0;if((b[v>>0]|0)!=(b[i+4>>0]|0)){w=v;break}v=u+4|0;if((b[v>>0]|0)!=(b[i+5>>0]|0)){w=v;break}v=u+5|0;if((b[v>>0]|0)!=(b[i+6>>0]|0)){w=v;break}v=u+6|0;if((b[v>>0]|0)!=(b[i+7>>0]|0)){w=v;break}v=u+7|0;u=i;i=i+8|0;if((b[v>>0]|0)!=(b[i>>0]|0)){w=v;break}t=t+8|0;v=h+t|0;if(!((t|0)<258?(b[v>>0]|0)==(b[u+9>>0]|0):0)){w=v;break}}t=w-q|0;i=t+258|0;if((i|0)>(r|0)){f[k>>2]=d;if((i|0)>=(o|0)){x=i;y=19;break}z=i;A=b[h+i>>0]|0;B=b[h+(t+257)>>0]|0}else{z=r;A=c;B=a}}else{z=r;A=c;B=a}d=j[l+((d&g)<<1)>>1]|0;if(d>>>0<=m>>>0){x=z;y=19;break}s=s+-1|0;if(!s){x=z;y=19;break}else{r=z;c=A;a=B}}if((y|0)==19)return (x>>>0>n>>>0?n:x)|0;return 0}function TDa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if(!a){b=-2;return b|0}c=a+28|0;d=f[c>>2]|0;if(!d){b=-2;return b|0}e=f[d+4>>2]|0;switch(e|0){case 42:case 69:case 73:case 91:case 103:case 113:case 666:break;default:{b=-2;return b|0}}g=f[d+8>>2]|0;if(!g)h=d;else{Gh[f[a+36>>2]&511](f[a+40>>2]|0,g);h=f[c>>2]|0}g=f[h+68>>2]|0;if(!g)i=h;else{Gh[f[a+36>>2]&511](f[a+40>>2]|0,g);i=f[c>>2]|0}g=f[i+64>>2]|0;if(!g)j=i;else{Gh[f[a+36>>2]&511](f[a+40>>2]|0,g);j=f[c>>2]|0}g=f[j+56>>2]|0;if(!g){k=j;l=a+40|0;m=a+36|0}else{j=a+36|0;i=a+40|0;Gh[f[j>>2]&511](f[i>>2]|0,g);k=f[c>>2]|0;l=i;m=j}Gh[f[m>>2]&511](f[l>>2]|0,k);f[c>>2]=0;b=(e|0)==113?-3:0;return b|0}function UDa(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0;if(!a){e=-2;return e|0}g=a+28|0;i=f[g>>2]|0;if(c>>>0>5|(i|0)==0){e=-2;return e|0}j=a+12|0;do if(f[j>>2]|0){if((f[a>>2]|0)==0?f[a+4>>2]|0:0)break;k=i+4|0;l=f[k>>2]|0;m=(c|0)!=4;if(!(m&(l|0)==666)){n=a+16|0;if(!(f[n>>2]|0)){f[a+24>>2]=f[27571];e=-5;return e|0}f[i>>2]=a;o=i+40|0;p=f[o>>2]|0;f[o>>2]=c;do if((l|0)==42){if((f[i+24>>2]|0)!=2){q=(f[i+48>>2]<<12)+-30720|0;if((f[i+136>>2]|0)<=1?(r=f[i+132>>2]|0,(r|0)>=2):0)s=(r|0)<6?64:(r|0)==6?128:192;else s=0;r=s|q;q=i+108|0;t=(f[q>>2]|0)==0?r:r|32;r=(((t>>>0)%31|0)^31)+t|0;f[k>>2]=113;t=i+8|0;u=f[t>>2]|0;v=i+20|0;w=f[v>>2]|0;f[v>>2]=w+1;b[u+w>>0]=r>>>8;w=f[t>>2]|0;u=f[v>>2]|0;f[v>>2]=u+1;b[w+u>>0]=r;r=a+48|0;if(f[q>>2]|0){q=f[r>>2]|0;u=f[t>>2]|0;w=f[v>>2]|0;f[v>>2]=w+1;b[u+w>>0]=q>>>24;w=f[t>>2]|0;u=f[v>>2]|0;f[v>>2]=u+1;b[w+u>>0]=q>>>16;q=f[r>>2]|0;u=f[t>>2]|0;w=f[v>>2]|0;f[v>>2]=w+1;b[u+w>>0]=q>>>8;w=f[t>>2]|0;t=f[v>>2]|0;f[v>>2]=t+1;b[w+t>>0]=q}q=KDa(0,0,0)|0;f[r>>2]=q;x=f[k>>2]|0;break}q=LDa(0,0,0)|0;r=a+48|0;f[r>>2]=q;q=i+8|0;t=f[q>>2]|0;w=i+20|0;v=f[w>>2]|0;f[w>>2]=v+1;b[t+v>>0]=31;v=f[q>>2]|0;t=f[w>>2]|0;f[w>>2]=t+1;b[v+t>>0]=-117;t=f[q>>2]|0;v=f[w>>2]|0;f[w>>2]=v+1;b[t+v>>0]=8;v=i+28|0;t=f[v>>2]|0;if(!t){u=f[q>>2]|0;y=f[w>>2]|0;f[w>>2]=y+1;b[u+y>>0]=0;y=f[q>>2]|0;u=f[w>>2]|0;f[w>>2]=u+1;b[y+u>>0]=0;u=f[q>>2]|0;y=f[w>>2]|0;f[w>>2]=y+1;b[u+y>>0]=0;y=f[q>>2]|0;u=f[w>>2]|0;f[w>>2]=u+1;b[y+u>>0]=0;u=f[q>>2]|0;y=f[w>>2]|0;f[w>>2]=y+1;b[u+y>>0]=0;y=f[i+132>>2]|0;if((y|0)==9)z=2;else z=((y|0)<2?1:(f[i+136>>2]|0)>1)?4:0;y=f[q>>2]|0;u=f[w>>2]|0;f[w>>2]=u+1;b[y+u>>0]=z;u=f[q>>2]|0;y=f[w>>2]|0;f[w>>2]=y+1;b[u+y>>0]=3;A=113}else{y=((f[t+44>>2]|0?2:0)|(f[t>>2]|0)!=0|((f[t+16>>2]|0)==0?0:4)|((f[t+28>>2]|0)==0?0:8)|((f[t+36>>2]|0)==0?0:16))&255;t=f[q>>2]|0;u=f[w>>2]|0;f[w>>2]=u+1;b[t+u>>0]=y;y=f[(f[v>>2]|0)+4>>2]&255;u=f[q>>2]|0;t=f[w>>2]|0;f[w>>2]=t+1;b[u+t>>0]=y;y=(f[(f[v>>2]|0)+4>>2]|0)>>>8&255;t=f[q>>2]|0;u=f[w>>2]|0;f[w>>2]=u+1;b[t+u>>0]=y;y=(f[(f[v>>2]|0)+4>>2]|0)>>>16&255;u=f[q>>2]|0;t=f[w>>2]|0;f[w>>2]=t+1;b[u+t>>0]=y;y=(f[(f[v>>2]|0)+4>>2]|0)>>>24&255;t=f[q>>2]|0;u=f[w>>2]|0;f[w>>2]=u+1;b[t+u>>0]=y;y=f[i+132>>2]|0;if((y|0)==9)B=2;else B=((y|0)<2?1:(f[i+136>>2]|0)>1)?4:0;y=f[q>>2]|0;u=f[w>>2]|0;f[w>>2]=u+1;b[y+u>>0]=B;u=f[(f[v>>2]|0)+12>>2]&255;y=f[q>>2]|0;t=f[w>>2]|0;f[w>>2]=t+1;b[y+t>>0]=u;u=f[v>>2]|0;if(!(f[u+16>>2]|0))C=u;else{t=f[u+20>>2]&255;u=f[q>>2]|0;y=f[w>>2]|0;f[w>>2]=y+1;b[u+y>>0]=t;t=(f[(f[v>>2]|0)+20>>2]|0)>>>8&255;y=f[q>>2]|0;u=f[w>>2]|0;f[w>>2]=u+1;b[y+u>>0]=t;C=f[v>>2]|0}if(f[C+44>>2]|0){v=LDa(f[r>>2]|0,f[q>>2]|0,f[w>>2]|0)|0;f[r>>2]=v}f[i+32>>2]=0;A=69}f[k>>2]=A;x=A}else x=l;while(0);a:do if((x|0)==69){l=i+28|0;v=f[l>>2]|0;do if(f[v+16>>2]|0){r=i+20|0;w=f[r>>2]|0;q=i+32|0;t=f[q>>2]|0;b:do if(t>>>0<(f[v+20>>2]&65535)>>>0){u=i+12|0;y=a+48|0;D=i+8|0;E=a+20|0;F=w;G=v;H=t;I=w;while(1){if((F|0)==(f[u>>2]|0)){if(F>>>0>I>>>0&(f[G+44>>2]|0)!=0){J=LDa(f[y>>2]|0,(f[D>>2]|0)+I|0,F-I|0)|0;f[y>>2]=J}J=f[g>>2]|0;YDa(J);K=J+20|0;L=f[K>>2]|0;M=f[n>>2]|0;N=L>>>0>M>>>0?M:L;do if(N|0){L=J+16|0;K1a(f[j>>2]|0,f[L>>2]|0,N|0)|0;f[j>>2]=(f[j>>2]|0)+N;f[L>>2]=(f[L>>2]|0)+N;f[E>>2]=(f[E>>2]|0)+N;f[n>>2]=(f[n>>2]|0)-N;M=(f[K>>2]|0)-N|0;f[K>>2]=M;if(M|0)break;f[L>>2]=f[J+8>>2]}while(0);J=f[r>>2]|0;K=f[l>>2]|0;if((J|0)==(f[u>>2]|0)){O=K;P=J;break b}Q=K;R=f[q>>2]|0;S=J;T=J}else{Q=G;R=H;S=F;T=I}J=b[(f[Q+16>>2]|0)+R>>0]|0;K=f[D>>2]|0;f[r>>2]=S+1;b[K+S>>0]=J;J=(f[q>>2]|0)+1|0;f[q>>2]=J;K=f[l>>2]|0;if(J>>>0>=(f[K+20>>2]&65535)>>>0){O=K;P=T;break b}F=f[r>>2]|0;G=K;H=J;I=T}}else{O=v;P=w}while(0);if((f[O+44>>2]|0)!=0?(w=f[r>>2]|0,w>>>0>P>>>0):0){t=a+48|0;I=LDa(f[t>>2]|0,(f[i+8>>2]|0)+P|0,w-P|0)|0;f[t>>2]=I;U=f[l>>2]|0}else U=O;if((f[q>>2]|0)==(f[U+20>>2]|0)){f[q>>2]=0;V=U;break}else{W=f[k>>2]|0;X=50;break a}}else V=v;while(0);f[k>>2]=73;Y=V;Z=l;X=53}else{W=x;X=50}while(0);if((X|0)==50)if((W|0)==73){v=i+28|0;Y=f[v>>2]|0;Z=v;X=53}else{_=W;X=70}c:do if((X|0)==53){do if(f[Y+28>>2]|0){v=i+20|0;I=f[v>>2]|0;t=i+12|0;w=a+48|0;H=i+8|0;G=a+20|0;F=i+32|0;D=I;u=I;while(1){if((D|0)==(f[t>>2]|0)){if(D>>>0>u>>>0?(f[(f[Z>>2]|0)+44>>2]|0)!=0:0){I=LDa(f[w>>2]|0,(f[H>>2]|0)+u|0,D-u|0)|0;f[w>>2]=I}I=f[g>>2]|0;YDa(I);E=I+20|0;y=f[E>>2]|0;J=f[n>>2]|0;K=y>>>0>J>>>0?J:y;if(K|0?(y=I+16|0,K1a(f[j>>2]|0,f[y>>2]|0,K|0)|0,f[j>>2]=(f[j>>2]|0)+K,f[y>>2]=(f[y>>2]|0)+K,f[G>>2]=(f[G>>2]|0)+K,f[n>>2]=(f[n>>2]|0)-K,J=(f[E>>2]|0)-K|0,f[E>>2]=J,(J|0)==0):0)f[y>>2]=f[I+8>>2];I=f[v>>2]|0;if((I|0)==(f[t>>2]|0)){$=I;aa=1;break}else{ba=I;ca=I}}else{ba=D;ca=u}I=f[(f[Z>>2]|0)+28>>2]|0;y=f[F>>2]|0;f[F>>2]=y+1;J=b[I+y>>0]|0;y=f[H>>2]|0;f[v>>2]=ba+1;b[y+ba>>0]=J;if(!(J<<24>>24)){$=ca;aa=J&255;break}D=f[v>>2]|0;u=ca}if(f[(f[Z>>2]|0)+44>>2]|0?(u=f[v>>2]|0,u>>>0>$>>>0):0){D=LDa(f[w>>2]|0,(f[H>>2]|0)+$|0,u-$|0)|0;f[w>>2]=D}if(!aa){f[F>>2]=0;break}else{_=f[k>>2]|0;X=70;break c}}while(0);f[k>>2]=91;da=Z;X=73}while(0);if((X|0)==70)if((_|0)==91){da=i+28|0;X=73}else{ea=_;X=89}do if((X|0)==73){if(f[(f[da>>2]|0)+36>>2]|0){l=i+20|0;D=f[l>>2]|0;u=i+12|0;t=a+48|0;G=i+8|0;q=a+20|0;r=i+32|0;J=D;y=D;while(1){if((J|0)==(f[u>>2]|0)){if(J>>>0>y>>>0?(f[(f[da>>2]|0)+44>>2]|0)!=0:0){D=LDa(f[t>>2]|0,(f[G>>2]|0)+y|0,J-y|0)|0;f[t>>2]=D}D=f[g>>2]|0;YDa(D);I=D+20|0;E=f[I>>2]|0;K=f[n>>2]|0;N=E>>>0>K>>>0?K:E;if(N|0?(E=D+16|0,K1a(f[j>>2]|0,f[E>>2]|0,N|0)|0,f[j>>2]=(f[j>>2]|0)+N,f[E>>2]=(f[E>>2]|0)+N,f[q>>2]=(f[q>>2]|0)+N,f[n>>2]=(f[n>>2]|0)-N,K=(f[I>>2]|0)-N|0,f[I>>2]=K,(K|0)==0):0)f[E>>2]=f[D+8>>2];D=f[l>>2]|0;if((D|0)==(f[u>>2]|0)){fa=D;ga=1;break}else{ha=D;ia=D}}else{ha=J;ia=y}D=f[(f[da>>2]|0)+36>>2]|0;E=f[r>>2]|0;f[r>>2]=E+1;K=b[D+E>>0]|0;E=f[G>>2]|0;f[l>>2]=ha+1;b[E+ha>>0]=K;if(!(K<<24>>24)){fa=ia;ga=K&255;break}J=f[l>>2]|0;y=ia}if(f[(f[da>>2]|0)+44>>2]|0?(y=f[l>>2]|0,y>>>0>fa>>>0):0){J=LDa(f[t>>2]|0,(f[G>>2]|0)+fa|0,y-fa|0)|0;f[t>>2]=J}if(ga|0){ea=f[k>>2]|0;X=89;break}}f[k>>2]=103;ja=da;X=92}while(0);if((X|0)==89?(ea|0)==103:0){ja=i+28|0;X=92}do if((X|0)==92){if(f[(f[ja>>2]|0)+44>>2]|0){J=i+20|0;y=i+12|0;if((((f[J>>2]|0)+2|0)>>>0>(f[y>>2]|0)>>>0?(r=f[g>>2]|0,YDa(r),u=r+20|0,q=f[u>>2]|0,K=f[n>>2]|0,E=q>>>0>K>>>0?K:q,E|0):0)?(q=r+16|0,K1a(f[j>>2]|0,f[q>>2]|0,E|0)|0,f[j>>2]=(f[j>>2]|0)+E,f[q>>2]=(f[q>>2]|0)+E,K=a+20|0,f[K>>2]=(f[K>>2]|0)+E,f[n>>2]=(f[n>>2]|0)-E,K=(f[u>>2]|0)-E|0,f[u>>2]=K,(K|0)==0):0)f[q>>2]=f[r+8>>2];r=f[J>>2]|0;if((r+2|0)>>>0>(f[y>>2]|0)>>>0)break;y=a+48|0;q=f[y>>2]&255;K=i+8|0;u=f[K>>2]|0;f[J>>2]=r+1;b[u+r>>0]=q;q=(f[y>>2]|0)>>>8&255;r=f[K>>2]|0;K=f[J>>2]|0;f[J>>2]=K+1;b[r+K>>0]=q;q=LDa(0,0,0)|0;f[y>>2]=q}f[k>>2]=113}while(0);q=i+20|0;do if(!(f[q>>2]|0)){y=f[a+4>>2]|0;if(!y){if(!(m&((c<<1)-((c|0)>4?9:0)|0)<=((p<<1)-((p|0)>4?9:0)|0))){ka=(f[k>>2]|0)==666;X=114;break}f[a+24>>2]=f[27571];e=-5;return e|0}else{la=y;X=111}}else{y=f[g>>2]|0;YDa(y);K=y+20|0;r=f[K>>2]|0;J=f[n>>2]|0;u=r>>>0>J>>>0?J:r;if(u){r=y+16|0;K1a(f[j>>2]|0,f[r>>2]|0,u|0)|0;f[j>>2]=(f[j>>2]|0)+u;f[r>>2]=(f[r>>2]|0)+u;E=a+20|0;f[E>>2]=(f[E>>2]|0)+u;E=(f[n>>2]|0)-u|0;f[n>>2]=E;D=(f[K>>2]|0)-u|0;f[K>>2]=D;if(!D){f[r>>2]=f[y+8>>2];ma=E}else ma=E}else ma=J;if(ma|0){la=f[a+4>>2]|0;X=111;break}f[o>>2]=-1;e=0;return e|0}while(0);do if((X|0)==111){p=(f[k>>2]|0)==666;J=(la|0)!=0;if(!(p&J))if(J){X=115;break}else{ka=p;X=114;break}f[a+24>>2]=f[27571];e=-5;return e|0}while(0);if((X|0)==114?!(((c|0)==0|ka)&(f[i+116>>2]|0)==0):0)X=115;do if((X|0)==115){d:do switch(f[i+136>>2]|0){case 2:{p=i+116|0;J=i+96|0;E=i+56|0;y=i+108|0;r=i+5796|0;D=i+5792|0;K=i+5784|0;u=i+5788|0;I=i+92|0;while(1){if((f[p>>2]|0)==0?(RDa(i),(f[p>>2]|0)==0):0)break;f[J>>2]=0;N=b[(f[E>>2]|0)+(f[y>>2]|0)>>0]|0;L=f[D>>2]|0;d[(f[r>>2]|0)+(L<<1)>>1]=0;M=f[K>>2]|0;f[D>>2]=L+1;b[M+L>>0]=N;L=i+148+((N&255)<<2)|0;d[L>>1]=(d[L>>1]|0)+1<<16>>16;L=(f[D>>2]|0)==((f[u>>2]|0)+-1|0);f[p>>2]=(f[p>>2]|0)+-1;N=(f[y>>2]|0)+1|0;f[y>>2]=N;if(!L)continue;L=f[I>>2]|0;if((L|0)>-1)na=(f[E>>2]|0)+L|0;else na=0;_Da(i,na,N-L|0,0);f[I>>2]=f[y>>2];L=f[i>>2]|0;N=f[L+28>>2]|0;YDa(N);M=N+20|0;oa=f[M>>2]|0;pa=L+16|0;qa=f[pa>>2]|0;ra=oa>>>0>qa>>>0?qa:oa;if(ra|0?(oa=L+12|0,qa=N+16|0,K1a(f[oa>>2]|0,f[qa>>2]|0,ra|0)|0,f[oa>>2]=(f[oa>>2]|0)+ra,f[qa>>2]=(f[qa>>2]|0)+ra,oa=L+20|0,f[oa>>2]=(f[oa>>2]|0)+ra,f[pa>>2]=(f[pa>>2]|0)-ra,pa=(f[M>>2]|0)-ra|0,f[M>>2]=pa,(pa|0)==0):0)f[qa>>2]=f[N+8>>2];if(!(f[(f[i>>2]|0)+16>>2]|0)){X=190;break d}}if(c){f[i+5812>>2]=0;if((c|0)==4){p=f[I>>2]|0;if((p|0)>-1)sa=(f[E>>2]|0)+p|0;else sa=0;_Da(i,sa,(f[y>>2]|0)-p|0,1);f[I>>2]=f[y>>2];p=f[i>>2]|0;u=f[p+28>>2]|0;YDa(u);K=u+20|0;r=f[K>>2]|0;J=p+16|0;F=f[J>>2]|0;w=r>>>0>F>>>0?F:r;if(w|0?(r=p+12|0,F=u+16|0,K1a(f[r>>2]|0,f[F>>2]|0,w|0)|0,f[r>>2]=(f[r>>2]|0)+w,f[F>>2]=(f[F>>2]|0)+w,r=p+20|0,f[r>>2]=(f[r>>2]|0)+w,f[J>>2]=(f[J>>2]|0)-w,J=(f[K>>2]|0)-w|0,f[K>>2]=J,(J|0)==0):0)f[F>>2]=f[u+8>>2];ta=(f[(f[i>>2]|0)+16>>2]|0)==0?2:3;X=187;break d}if(f[D>>2]|0){u=f[I>>2]|0;if((u|0)>-1)ua=(f[E>>2]|0)+u|0;else ua=0;_Da(i,ua,(f[y>>2]|0)-u|0,0);f[I>>2]=f[y>>2];u=f[i>>2]|0;F=f[u+28>>2]|0;YDa(F);J=F+20|0;K=f[J>>2]|0;w=u+16|0;r=f[w>>2]|0;p=K>>>0>r>>>0?r:K;if(p|0?(K=u+12|0,r=F+16|0,K1a(f[K>>2]|0,f[r>>2]|0,p|0)|0,f[K>>2]=(f[K>>2]|0)+p,f[r>>2]=(f[r>>2]|0)+p,K=u+20|0,f[K>>2]=(f[K>>2]|0)+p,f[w>>2]=(f[w>>2]|0)-p,w=(f[J>>2]|0)-p|0,f[J>>2]=w,(w|0)==0):0)f[r>>2]=f[F+8>>2];if(!(f[(f[i>>2]|0)+16>>2]|0))X=190}}else X=190;break}case 3:{F=i+116|0;r=(c|0)==0;w=i+96|0;J=i+108|0;p=i+5784|0;K=i+5796|0;u=i+5792|0;H=i+5788|0;v=i+56|0;N=i+92|0;while(1){qa=f[F>>2]|0;if(qa>>>0<259){RDa(i);pa=f[F>>2]|0;if(r&pa>>>0<259){X=190;break d}if(!pa)break;f[w>>2]=0;if(pa>>>0>2){va=pa;X=148}else{wa=f[J>>2]|0;xa=f[K>>2]|0;ya=f[p>>2]|0;X=164}}else{f[w>>2]=0;va=qa;X=148}do if((X|0)==148){X=0;qa=f[J>>2]|0;if(((qa|0?(pa=(f[v>>2]|0)+qa|0,M=b[pa+-1>>0]|0,M<<24>>24==(b[pa>>0]|0)):0)?(ra=pa+1|0,M<<24>>24==(b[ra>>0]|0)):0)?M<<24>>24==(b[ra+1>>0]|0):0){ra=pa+258|0;oa=1;while(1){L=pa+oa|0;za=L+2|0;if(M<<24>>24!=(b[za>>0]|0)){Aa=za;break}za=L+3|0;if(M<<24>>24!=(b[za>>0]|0)){Aa=za;break}za=L+4|0;if(M<<24>>24!=(b[za>>0]|0)){Aa=za;break}za=L+5|0;if(M<<24>>24!=(b[za>>0]|0)){Aa=za;break}za=L+6|0;if(M<<24>>24!=(b[za>>0]|0)){Aa=za;break}za=L+7|0;if(M<<24>>24!=(b[za>>0]|0)){Aa=za;break}za=oa;oa=oa+8|0;L=pa+oa|0;if(M<<24>>24!=(b[L>>0]|0)){Aa=L;break}L=za+9|0;za=pa+L|0;if(!((L|0)<258?M<<24>>24==(b[za>>0]|0):0)){Aa=za;break}}M=Aa-ra+258|0;pa=M>>>0>va>>>0?va:M;f[w>>2]=pa;M=f[p>>2]|0;oa=f[K>>2]|0;if(pa>>>0<=2){wa=qa;xa=oa;ya=M;X=164;break}za=pa+253|0;pa=f[u>>2]|0;d[oa+(pa<<1)>>1]=1;f[u>>2]=pa+1;b[M+pa>>0]=za;pa=i+148+((h[360052+(za&255)>>0]|256)+1<<2)|0;d[pa>>1]=(d[pa>>1]|0)+1<<16>>16;pa=i+2440+(h[359540]<<2)|0;d[pa>>1]=(d[pa>>1]|0)+1<<16>>16;pa=(f[u>>2]|0)==((f[H>>2]|0)+-1|0)&1;za=f[w>>2]|0;f[F>>2]=(f[F>>2]|0)-za;M=(f[J>>2]|0)+za|0;f[J>>2]=M;f[w>>2]=0;Ba=M;Ca=pa;break}wa=qa;xa=f[K>>2]|0;ya=f[p>>2]|0;X=164}while(0);if((X|0)==164){X=0;pa=b[(f[v>>2]|0)+wa>>0]|0;M=f[u>>2]|0;d[xa+(M<<1)>>1]=0;f[u>>2]=M+1;b[ya+M>>0]=pa;M=i+148+((pa&255)<<2)|0;d[M>>1]=(d[M>>1]|0)+1<<16>>16;M=(f[u>>2]|0)==((f[H>>2]|0)+-1|0)&1;f[F>>2]=(f[F>>2]|0)+-1;pa=(f[J>>2]|0)+1|0;f[J>>2]=pa;Ba=pa;Ca=M}if(!Ca)continue;M=f[N>>2]|0;if((M|0)>-1)Da=(f[v>>2]|0)+M|0;else Da=0;_Da(i,Da,Ba-M|0,0);f[N>>2]=f[J>>2];M=f[i>>2]|0;pa=f[M+28>>2]|0;YDa(pa);za=pa+20|0;oa=f[za>>2]|0;L=M+16|0;Ea=f[L>>2]|0;Fa=oa>>>0>Ea>>>0?Ea:oa;if(Fa|0?(oa=M+12|0,Ea=pa+16|0,K1a(f[oa>>2]|0,f[Ea>>2]|0,Fa|0)|0,f[oa>>2]=(f[oa>>2]|0)+Fa,f[Ea>>2]=(f[Ea>>2]|0)+Fa,oa=M+20|0,f[oa>>2]=(f[oa>>2]|0)+Fa,f[L>>2]=(f[L>>2]|0)-Fa,L=(f[za>>2]|0)-Fa|0,f[za>>2]=L,(L|0)==0):0)f[Ea>>2]=f[pa+8>>2];if(!(f[(f[i>>2]|0)+16>>2]|0)){X=190;break d}}f[i+5812>>2]=0;if((c|0)==4){F=f[N>>2]|0;if((F|0)>-1)Ga=(f[v>>2]|0)+F|0;else Ga=0;_Da(i,Ga,(f[J>>2]|0)-F|0,1);f[N>>2]=f[J>>2];F=f[i>>2]|0;H=f[F+28>>2]|0;YDa(H);p=H+20|0;K=f[p>>2]|0;w=F+16|0;r=f[w>>2]|0;y=K>>>0>r>>>0?r:K;if(y|0?(K=F+12|0,r=H+16|0,K1a(f[K>>2]|0,f[r>>2]|0,y|0)|0,f[K>>2]=(f[K>>2]|0)+y,f[r>>2]=(f[r>>2]|0)+y,K=F+20|0,f[K>>2]=(f[K>>2]|0)+y,f[w>>2]=(f[w>>2]|0)-y,w=(f[p>>2]|0)-y|0,f[p>>2]=w,(w|0)==0):0)f[r>>2]=f[H+8>>2];ta=(f[(f[i>>2]|0)+16>>2]|0)==0?2:3;X=187;break d}if(f[u>>2]|0){H=f[N>>2]|0;if((H|0)>-1)Ha=(f[v>>2]|0)+H|0;else Ha=0;_Da(i,Ha,(f[J>>2]|0)-H|0,0);f[N>>2]=f[J>>2];H=f[i>>2]|0;r=f[H+28>>2]|0;YDa(r);w=r+20|0;p=f[w>>2]|0;y=H+16|0;K=f[y>>2]|0;F=p>>>0>K>>>0?K:p;if(F|0?(p=H+12|0,K=r+16|0,K1a(f[p>>2]|0,f[K>>2]|0,F|0)|0,f[p>>2]=(f[p>>2]|0)+F,f[K>>2]=(f[K>>2]|0)+F,p=H+20|0,f[p>>2]=(f[p>>2]|0)+F,f[y>>2]=(f[y>>2]|0)-F,y=(f[w>>2]|0)-F|0,f[w>>2]=y,(y|0)==0):0)f[K>>2]=f[r+8>>2];if(!(f[(f[i>>2]|0)+16>>2]|0))X=190}break}default:{ta=$h[f[118488+((f[i+132>>2]|0)*12|0)+8>>2]&255](i,c)|0;X=187}}while(0);if((X|0)==187){if((ta|1|0)==3)f[k>>2]=666;if((ta|2|0)!=2){if((ta|0)!=1)break}else X=190}if((X|0)==190){if(f[n>>2]|0){e=0;return e|0}f[o>>2]=-1;e=0;return e|0}switch(c|0){case 1:{ZDa(i);break}case 5:break;default:{XDa(i,0,0,0);if((c|0)==3?(t=f[i+68>>2]|0,G=(f[i+76>>2]|0)+-1|0,d[t+(G<<1)>>1]=0,F1a(t|0,0,G<<1|0)|0,(f[i+116>>2]|0)==0):0){f[i+108>>2]=0;f[i+92>>2]=0;f[i+5812>>2]=0}}}G=f[g>>2]|0;YDa(G);t=G+20|0;l=f[t>>2]|0;r=f[n>>2]|0;K=l>>>0>r>>>0?r:l;if(K){l=G+16|0;K1a(f[j>>2]|0,f[l>>2]|0,K|0)|0;f[j>>2]=(f[j>>2]|0)+K;f[l>>2]=(f[l>>2]|0)+K;y=a+20|0;f[y>>2]=(f[y>>2]|0)+K;y=(f[n>>2]|0)-K|0;f[n>>2]=y;w=(f[t>>2]|0)-K|0;f[t>>2]=w;if(!w){f[l>>2]=f[G+8>>2];Ia=y}else Ia=y}else Ia=r;if(!Ia){f[o>>2]=-1;e=0;return e|0}}while(0);if(m){e=0;return e|0}o=i+24|0;k=f[o>>2]|0;if((k|0)<1){e=1;return e|0}r=a+48|0;y=f[r>>2]|0;if((k|0)==2){k=i+8|0;G=f[k>>2]|0;l=f[q>>2]|0;f[q>>2]=l+1;b[G+l>>0]=y;l=(f[r>>2]|0)>>>8&255;G=f[k>>2]|0;w=f[q>>2]|0;f[q>>2]=w+1;b[G+w>>0]=l;l=(f[r>>2]|0)>>>16&255;w=f[k>>2]|0;G=f[q>>2]|0;f[q>>2]=G+1;b[w+G>>0]=l;l=(f[r>>2]|0)>>>24&255;G=f[k>>2]|0;w=f[q>>2]|0;f[q>>2]=w+1;b[G+w>>0]=l;l=a+8|0;w=f[l>>2]&255;G=f[k>>2]|0;t=f[q>>2]|0;f[q>>2]=t+1;b[G+t>>0]=w;w=(f[l>>2]|0)>>>8&255;t=f[k>>2]|0;G=f[q>>2]|0;f[q>>2]=G+1;b[t+G>>0]=w;w=(f[l>>2]|0)>>>16&255;G=f[k>>2]|0;t=f[q>>2]|0;f[q>>2]=t+1;b[G+t>>0]=w;w=(f[l>>2]|0)>>>24;l=f[k>>2]|0;k=f[q>>2]|0;f[q>>2]=k+1;Ja=l+k|0;Ka=w}else{w=i+8|0;k=f[w>>2]|0;l=f[q>>2]|0;f[q>>2]=l+1;b[k+l>>0]=y>>>24;l=f[w>>2]|0;k=f[q>>2]|0;f[q>>2]=k+1;b[l+k>>0]=y>>>16;y=f[r>>2]|0;r=f[w>>2]|0;k=f[q>>2]|0;f[q>>2]=k+1;b[r+k>>0]=y>>>8;k=f[w>>2]|0;w=f[q>>2]|0;f[q>>2]=w+1;Ja=k+w|0;Ka=y}b[Ja>>0]=Ka;y=f[g>>2]|0;YDa(y);w=y+20|0;k=f[w>>2]|0;r=f[n>>2]|0;l=k>>>0>r>>>0?r:k;if(l|0?(k=y+16|0,K1a(f[j>>2]|0,f[k>>2]|0,l|0)|0,f[j>>2]=(f[j>>2]|0)+l,f[k>>2]=(f[k>>2]|0)+l,r=a+20|0,f[r>>2]=(f[r>>2]|0)+l,f[n>>2]=(f[n>>2]|0)-l,r=(f[w>>2]|0)-l|0,f[w>>2]=r,(r|0)==0):0)f[k>>2]=f[y+8>>2];y=f[o>>2]|0;if((y|0)>0)f[o>>2]=0-y;e=(f[q>>2]|0)==0&1;return e|0}}while(0);f[a+24>>2]=f[27568];e=-2;return e|0}function VDa(a){a=a|0;f[a+2840>>2]=a+148;f[a+2848>>2]=118608;f[a+2852>>2]=a+2440;f[a+2860>>2]=118628;f[a+2864>>2]=a+2684;f[a+2872>>2]=118648;d[a+5816>>1]=0;f[a+5820>>2]=0;WDa(a);return}function WDa(a){a=a|0;var b=0;b=0;do{d[a+148+(b<<2)>>1]=0;b=b+1|0}while((b|0)!=286);d[a+2440>>1]=0;d[a+2444>>1]=0;d[a+2448>>1]=0;d[a+2452>>1]=0;d[a+2456>>1]=0;d[a+2460>>1]=0;d[a+2464>>1]=0;d[a+2468>>1]=0;d[a+2472>>1]=0;d[a+2476>>1]=0;d[a+2480>>1]=0;d[a+2484>>1]=0;d[a+2488>>1]=0;d[a+2492>>1]=0;d[a+2496>>1]=0;d[a+2500>>1]=0;d[a+2504>>1]=0;d[a+2508>>1]=0;d[a+2512>>1]=0;d[a+2516>>1]=0;d[a+2520>>1]=0;d[a+2524>>1]=0;d[a+2528>>1]=0;d[a+2532>>1]=0;d[a+2536>>1]=0;d[a+2540>>1]=0;d[a+2544>>1]=0;d[a+2548>>1]=0;d[a+2552>>1]=0;d[a+2556>>1]=0;d[a+2684>>1]=0;d[a+2688>>1]=0;d[a+2692>>1]=0;d[a+2696>>1]=0;d[a+2700>>1]=0;d[a+2704>>1]=0;d[a+2708>>1]=0;d[a+2712>>1]=0;d[a+2716>>1]=0;d[a+2720>>1]=0;d[a+2724>>1]=0;d[a+2728>>1]=0;d[a+2732>>1]=0;d[a+2736>>1]=0;d[a+2740>>1]=0;d[a+2744>>1]=0;d[a+2748>>1]=0;d[a+2752>>1]=0;d[a+2756>>1]=0;d[a+1172>>1]=1;f[a+5804>>2]=0;f[a+5800>>2]=0;f[a+5808>>2]=0;f[a+5792>>2]=0;return}function XDa(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=a+5820|0;i=f[h>>2]|0;k=g&65535;g=a+5816|0;l=j[g>>1]|0|k<<i;d[g>>1]=l;if((i|0)>13){m=a+8|0;n=f[m>>2]|0;o=a+20|0;p=f[o>>2]|0;f[o>>2]=p+1;b[n+p>>0]=l;p=(j[g>>1]|0)>>>8&255;n=f[m>>2]|0;m=f[o>>2]|0;f[o>>2]=m+1;b[n+m>>0]=p;p=f[h>>2]|0;m=k>>>(16-p|0);d[g>>1]=m;q=m;r=p+-13|0}else{q=l;r=i+3|0}i=q&255;f[h>>2]=r;if((r|0)<=8){if((r|0)>0){r=f[a+8>>2]|0;q=a+20|0;l=f[q>>2]|0;f[q>>2]=l+1;s=r+l|0;t=i;u=8}}else{l=a+8|0;r=f[l>>2]|0;q=a+20|0;p=f[q>>2]|0;f[q>>2]=p+1;b[r+p>>0]=i;i=(j[g>>1]|0)>>>8&255;p=f[l>>2]|0;l=f[q>>2]|0;f[q>>2]=l+1;s=p+l|0;t=i;u=8}if((u|0)==8)b[s>>0]=t;d[g>>1]=0;f[h>>2]=0;h=a+8|0;g=f[h>>2]|0;t=a+20|0;a=f[t>>2]|0;f[t>>2]=a+1;b[g+a>>0]=e;a=f[h>>2]|0;g=f[t>>2]|0;f[t>>2]=g+1;b[a+g>>0]=e>>>8;g=e&65535^65535;a=f[h>>2]|0;s=f[t>>2]|0;f[t>>2]=s+1;b[a+s>>0]=g;s=f[h>>2]|0;a=f[t>>2]|0;f[t>>2]=a+1;b[s+a>>0]=g>>>8;if(!e)return;else{v=c;w=e}while(1){w=w+-1|0;e=b[v>>0]|0;c=f[h>>2]|0;g=f[t>>2]|0;f[t>>2]=g+1;b[c+g>>0]=e;if(!w)break;else v=v+1|0}return}function YDa(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0;c=a+5820|0;e=f[c>>2]|0;do if((e|0)!=16)if((e|0)>7){g=a+5816|0;h=d[g>>1]&255;i=f[a+8>>2]|0;k=a+20|0;l=f[k>>2]|0;f[k>>2]=l+1;b[i+l>>0]=h;d[g>>1]=(j[g>>1]|0)>>>8;m=(f[c>>2]|0)+-8|0;break}else return;else{g=a+5816|0;h=d[g>>1]&255;l=a+8|0;i=f[l>>2]|0;k=a+20|0;n=f[k>>2]|0;f[k>>2]=n+1;b[i+n>>0]=h;h=(j[g>>1]|0)>>>8&255;n=f[l>>2]|0;l=f[k>>2]|0;f[k>>2]=l+1;b[n+l>>0]=h;d[g>>1]=0;m=0}while(0);f[c>>2]=m;return}function ZDa(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+5820|0;e=f[c>>2]|0;g=a+5816|0;h=j[g>>1]|0|2<<e;d[g>>1]=h;if((e|0)>13){i=a+8|0;k=f[i>>2]|0;l=a+20|0;m=f[l>>2]|0;f[l>>2]=m+1;b[k+m>>0]=h;m=(j[g>>1]|0)>>>8&255;k=f[i>>2]|0;i=f[l>>2]|0;f[l>>2]=i+1;b[k+i>>0]=m;m=f[c>>2]|0;i=2>>>(16-m|0);d[g>>1]=i;n=i;o=m+-13|0}else{n=h;o=e+3|0}e=n&255;f[c>>2]=o;if((o|0)>9){n=a+8|0;h=f[n>>2]|0;m=a+20|0;i=f[m>>2]|0;f[m>>2]=i+1;b[h+i>>0]=e;i=(j[g>>1]|0)>>>8&255;h=f[n>>2]|0;n=f[m>>2]|0;f[m>>2]=n+1;b[h+n>>0]=i;i=f[c>>2]|0;d[g>>1]=0;p=0;q=i+-9|0}else{p=e;q=o+7|0}f[c>>2]=q;do if((q|0)!=16)if((q|0)>7){o=f[a+8>>2]|0;e=a+20|0;i=f[e>>2]|0;f[e>>2]=i+1;b[o+i>>0]=p;d[g>>1]=(j[g>>1]|0)>>>8;r=(f[c>>2]|0)+-8|0;break}else return;else{i=a+8|0;o=f[i>>2]|0;e=a+20|0;n=f[e>>2]|0;f[e>>2]=n+1;b[o+n>>0]=p;n=(j[g>>1]|0)>>>8&255;o=f[i>>2]|0;i=f[e>>2]|0;f[e>>2]=i+1;b[o+i>>0]=n;d[g>>1]=0;r=0}while(0);f[c>>2]=r;return}function _Da(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;if((f[a+132>>2]|0)>0){i=(f[a>>2]|0)+44|0;if((f[i>>2]|0)==2){k=-201342849;l=0;while(1){if(k&1|0?d[a+148+(l<<2)>>1]|0:0){m=0;break}l=l+1|0;if((l|0)>=32){n=6;break}else k=k>>>1}a:do if((n|0)==6)if(((d[a+184>>1]|0)==0?(d[a+188>>1]|0)==0:0)?(d[a+200>>1]|0)==0:0){k=32;while(1){if(d[a+148+(k<<2)>>1]|0){m=1;break a}k=k+1|0;if((k|0)>=256){m=0;break}}}else m=1;while(0);f[i>>2]=m}$Da(a,a+2840|0);$Da(a,a+2852|0);m=f[a+2844>>2]|0;i=d[a+150>>1]|0;k=i<<16>>16==0;d[a+148+(m+1<<2)+2>>1]=-1;l=a+2756|0;o=a+2752|0;p=a+2748|0;q=k?138:7;r=k?3:4;k=0;s=i&65535;i=-1;b:while(1){t=0;u=k;do{if((u|0)>(m|0))break b;u=u+1|0;v=d[a+148+(u<<2)+2>>1]|0;w=v&65535;t=t+1|0;x=(s|0)==(w|0)}while((t|0)<(q|0)&x);if((t|0)<(r|0)){y=a+2684+(s<<2)|0;d[y>>1]=(j[y>>1]|0)+t}else{if(s){y=a+2684+(s<<2)|0;if((s|0)==(i|0))z=p;else{d[y>>1]=(d[y>>1]|0)+1<<16>>16;z=p}}else z=(t|0)<11?o:l;d[z>>1]=(d[z>>1]|0)+1<<16>>16}y=v<<16>>16==0;A=s;q=y?138:x?6:7;r=y|x?3:4;k=u;s=w;i=A}i=f[a+2856>>2]|0;w=d[a+2442>>1]|0;s=w<<16>>16==0;d[a+2440+(i+1<<2)+2>>1]=-1;k=s?138:7;x=s?3:4;s=0;r=w&65535;w=-1;c:while(1){q=0;v=s;do{if((v|0)>(i|0))break c;v=v+1|0;B=d[a+2440+(v<<2)+2>>1]|0;C=B&65535;q=q+1|0;D=(r|0)==(C|0)}while((q|0)<(k|0)&D);if((q|0)<(x|0)){u=a+2684+(r<<2)|0;d[u>>1]=(j[u>>1]|0)+q}else{if(r){u=a+2684+(r<<2)|0;if((r|0)==(w|0))E=p;else{d[u>>1]=(d[u>>1]|0)+1<<16>>16;E=p}}else E=(q|0)<11?o:l;d[E>>1]=(d[E>>1]|0)+1<<16>>16}u=B<<16>>16==0;t=r;k=u?138:D?6:7;x=u|D?3:4;s=v;r=C;w=t}$Da(a,a+2864|0);if(!(d[a+2746>>1]|0))if(!(d[a+2690>>1]|0))if(!(d[a+2742>>1]|0))if(!(d[a+2694>>1]|0))if(!(d[a+2738>>1]|0))if(!(d[a+2698>>1]|0))if(!(d[a+2734>>1]|0))if(!(d[a+2702>>1]|0))if(!(d[a+2730>>1]|0))if(!(d[a+2706>>1]|0))if(!(d[a+2726>>1]|0))if(!(d[a+2710>>1]|0))if(!(d[a+2722>>1]|0))if(!(d[a+2714>>1]|0))if(!(d[a+2718>>1]|0))F=(d[a+2686>>1]|0)==0?2:3;else F=4;else F=5;else F=6;else F=7;else F=8;else F=9;else F=10;else F=11;else F=12;else F=13;else F=14;else F=15;else F=16;else F=17;else F=18;w=a+5800|0;C=(F*3|0)+17+(f[w>>2]|0)|0;f[w>>2]=C;w=(C+10|0)>>>3;C=((f[a+5804>>2]|0)+10|0)>>>3;G=F;H=C>>>0>w>>>0?w:C;I=C}else{C=e+5|0;G=0;H=C;I=C}do if((c|0)!=0&(e+4|0)>>>0<=H>>>0)XDa(a,c,e,g);else{C=a+5820|0;w=f[C>>2]|0;F=(w|0)>13;if((I|0)==(H|0)?1:(f[a+136>>2]|0)==4){r=g+2&65535;s=a+5816|0;D=j[s>>1]|r<<w;d[s>>1]=D;if(F){x=a+8|0;k=f[x>>2]|0;B=a+20|0;E=f[B>>2]|0;f[B>>2]=E+1;b[k+E>>0]=D;D=(j[s>>1]|0)>>>8&255;E=f[x>>2]|0;x=f[B>>2]|0;f[B>>2]=x+1;b[E+x>>0]=D;D=f[C>>2]|0;d[s>>1]=r>>>(16-D|0);J=D+-13|0}else J=w+3|0;f[C>>2]=J;aEa(a,133282,133162);break}D=g+4&65535;r=a+5816|0;s=j[r>>1]|D<<w;d[r>>1]=s;if(F){F=a+8|0;x=f[F>>2]|0;E=a+20|0;B=f[E>>2]|0;f[E>>2]=B+1;b[x+B>>0]=s;B=(j[r>>1]|0)>>>8&255;x=f[F>>2]|0;F=f[E>>2]|0;f[E>>2]=F+1;b[x+F>>0]=B;B=f[C>>2]|0;F=D>>>(16-B|0);d[r>>1]=F;K=F;L=B+-13|0}else{K=s;L=w+3|0}f[C>>2]=L;w=f[a+2844>>2]|0;s=f[a+2856>>2]|0;B=w+65280&65535;F=K&65535|B<<L;d[r>>1]=F;if((L|0)>11){D=a+8|0;x=f[D>>2]|0;E=a+20|0;k=f[E>>2]|0;f[E>>2]=k+1;b[x+k>>0]=F;k=(j[r>>1]|0)>>>8&255;x=f[D>>2]|0;D=f[E>>2]|0;f[E>>2]=D+1;b[x+D>>0]=k;k=f[C>>2]|0;D=B>>>(16-k|0);d[r>>1]=D;M=k+-11|0;N=D}else{M=L+5|0;N=F}f[C>>2]=M;F=s&65535;D=F<<M|N&65535;d[r>>1]=D;if((M|0)>11){k=a+8|0;B=f[k>>2]|0;x=a+20|0;E=f[x>>2]|0;f[x>>2]=E+1;b[B+E>>0]=D;E=(j[r>>1]|0)>>>8&255;B=f[k>>2]|0;k=f[x>>2]|0;f[x>>2]=k+1;b[B+k>>0]=E;E=f[C>>2]|0;k=F>>>(16-E|0);d[r>>1]=k;O=E+-11|0;P=k}else{O=M+5|0;P=D}f[C>>2]=O;D=G+65533&65535;k=D<<O|P&65535;d[r>>1]=k;if((O|0)>12){E=a+8|0;F=f[E>>2]|0;B=a+20|0;x=f[B>>2]|0;f[B>>2]=x+1;b[F+x>>0]=k;x=(j[r>>1]|0)>>>8&255;F=f[E>>2]|0;l=f[B>>2]|0;f[B>>2]=l+1;b[F+l>>0]=x;x=f[C>>2]|0;l=D>>>(16-x|0);d[r>>1]=l;Q=l;R=B;S=E;T=x+-12|0}else{Q=k;R=a+20|0;S=a+8|0;T=O+4|0}f[C>>2]=T;k=T;x=Q;E=0;while(1){B=j[a+2684+(h[360308+E>>0]<<2)+2>>1]|0;l=B<<k|x&65535;d[r>>1]=l;if((k|0)>13){D=f[S>>2]|0;F=f[R>>2]|0;f[R>>2]=F+1;b[D+F>>0]=l;F=(j[r>>1]|0)>>>8&255;D=f[S>>2]|0;o=f[R>>2]|0;f[R>>2]=o+1;b[D+o>>0]=F;F=f[C>>2]|0;o=B>>>(16-F|0);d[r>>1]=o;U=o;V=F+-13|0}else{U=l;V=k+3|0}f[C>>2]=V;if((E|0)==(G|0))break;else{k=V;x=U;E=E+1|0}}E=a+148|0;bEa(a,E,w);x=a+2440|0;bEa(a,x,s);aEa(a,E,x)}while(0);WDa(a);if(!g)return;g=a+5820|0;U=f[g>>2]|0;if((U|0)<=8){if((U|0)>0){U=d[a+5816>>1]&255;V=f[a+8>>2]|0;G=a+20|0;R=f[G>>2]|0;f[G>>2]=R+1;W=V+R|0;X=U;n=84}}else{U=a+5816|0;R=d[U>>1]&255;V=a+8|0;G=f[V>>2]|0;S=a+20|0;Q=f[S>>2]|0;f[S>>2]=Q+1;b[G+Q>>0]=R;R=(j[U>>1]|0)>>>8&255;U=f[V>>2]|0;V=f[S>>2]|0;f[S>>2]=V+1;W=U+V|0;X=R;n=84}if((n|0)==84)b[W>>0]=X;d[a+5816>>1]=0;f[g>>2]=0;return}function $Da(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=u;u=u+32|0;g=e;i=f[c>>2]|0;k=c+8|0;l=f[k>>2]|0;m=f[l>>2]|0;n=f[l+12>>2]|0;l=a+5200|0;f[l>>2]=0;o=a+5204|0;f[o>>2]=573;if((n|0)>0){p=-1;q=0;while(1){if(!(d[i+(q<<2)>>1]|0)){d[i+(q<<2)+2>>1]=0;r=p}else{s=(f[l>>2]|0)+1|0;f[l>>2]=s;f[a+2908+(s<<2)>>2]=q;b[a+5208+q>>0]=0;r=q}q=q+1|0;if((q|0)==(n|0))break;else p=r}p=f[l>>2]|0;if((p|0)<2){t=p;v=r;w=3}else{x=p;y=r}}else{t=0;v=-1;w=3}if((w|0)==3){w=a+5800|0;r=a+5804|0;if(!m){p=t;q=v;while(1){s=(q|0)<2;z=q+1|0;A=s?z:q;B=s?z:0;z=p+1|0;f[l>>2]=z;f[a+2908+(z<<2)>>2]=B;d[i+(B<<2)>>1]=1;b[a+5208+B>>0]=0;f[w>>2]=(f[w>>2]|0)+-1;B=f[l>>2]|0;if((B|0)<2){p=B;q=A}else{x=B;y=A;break}}}else{q=t;t=v;while(1){v=(t|0)<2;p=t+1|0;A=v?p:t;B=v?p:0;p=q+1|0;f[l>>2]=p;f[a+2908+(p<<2)>>2]=B;d[i+(B<<2)>>1]=1;b[a+5208+B>>0]=0;f[w>>2]=(f[w>>2]|0)+-1;f[r>>2]=(f[r>>2]|0)-(j[m+(B<<2)+2>>1]|0);B=f[l>>2]|0;if((B|0)<2){q=B;t=A}else{x=B;y=A;break}}}}t=c+4|0;f[t>>2]=y;q=x>>>1;if(!q)C=x;else{m=x;x=q;while(1){q=f[a+2908+(x<<2)>>2]|0;r=a+5208+q|0;w=x<<1;a:do if((w|0)>(m|0))D=x;else{A=i+(q<<2)|0;B=m;p=w;v=x;while(1){do if((p|0)<(B|0)){z=p|1;s=f[a+2908+(z<<2)>>2]|0;E=d[i+(s<<2)>>1]|0;F=f[a+2908+(p<<2)>>2]|0;G=d[i+(F<<2)>>1]|0;if((E&65535)>=(G&65535)){if(E<<16>>16!=G<<16>>16){H=p;break}if((h[a+5208+s>>0]|0)>(h[a+5208+F>>0]|0)){H=p;break}}H=z}else H=p;while(0);z=d[A>>1]|0;F=f[a+2908+(H<<2)>>2]|0;s=d[i+(F<<2)>>1]|0;if((z&65535)<(s&65535)){D=v;break a}if(z<<16>>16==s<<16>>16?(h[r>>0]|0)<=(h[a+5208+F>>0]|0):0){D=v;break a}f[a+2908+(v<<2)>>2]=F;p=H<<1;B=f[l>>2]|0;if((p|0)>(B|0)){D=H;break}else v=H}}while(0);f[a+2908+(D<<2)>>2]=q;if((x|0)<=1)break;m=f[l>>2]|0;x=x+-1|0}C=f[l>>2]|0}x=a+2912|0;m=C;C=n;do{n=f[x>>2]|0;D=m+-1|0;f[l>>2]=D;H=f[a+2908+(m<<2)>>2]|0;f[x>>2]=H;r=a+5208+H|0;b:do if((m|0)<3)I=1;else{w=i+(H<<2)|0;v=D;B=2;p=1;while(1){do if((B|0)<(v|0)){A=B|1;F=f[a+2908+(A<<2)>>2]|0;s=d[i+(F<<2)>>1]|0;z=f[a+2908+(B<<2)>>2]|0;G=d[i+(z<<2)>>1]|0;if((s&65535)>=(G&65535)){if(s<<16>>16!=G<<16>>16){J=B;break}if((h[a+5208+F>>0]|0)>(h[a+5208+z>>0]|0)){J=B;break}}J=A}else J=B;while(0);A=d[w>>1]|0;z=f[a+2908+(J<<2)>>2]|0;F=d[i+(z<<2)>>1]|0;if((A&65535)<(F&65535)){I=p;break b}if(A<<16>>16==F<<16>>16?(h[r>>0]|0)<=(h[a+5208+z>>0]|0):0){I=p;break b}f[a+2908+(p<<2)>>2]=z;B=J<<1;v=f[l>>2]|0;if((B|0)>(v|0)){I=J;break}else p=J}}while(0);f[a+2908+(I<<2)>>2]=H;r=f[x>>2]|0;D=(f[o>>2]|0)+-1|0;f[o>>2]=D;f[a+2908+(D<<2)>>2]=n;D=(f[o>>2]|0)+-1|0;f[o>>2]=D;f[a+2908+(D<<2)>>2]=r;D=i+(C<<2)|0;d[D>>1]=(j[i+(r<<2)>>1]|0)+(j[i+(n<<2)>>1]|0);q=a+5208+C|0;b[q>>0]=(h[((h[a+5208+n>>0]|0)>=(h[a+5208+r>>0]|0)?n:r)+(a+5208)>>0]|0)+1;p=C&65535;d[i+(r<<2)+2>>1]=p;d[i+(n<<2)+2>>1]=p;f[x>>2]=C;p=f[l>>2]|0;c:do if((p|0)<2)K=1;else{r=p;v=2;B=1;while(1){do if((v|0)<(r|0)){w=v|1;z=f[a+2908+(w<<2)>>2]|0;F=d[i+(z<<2)>>1]|0;A=f[a+2908+(v<<2)>>2]|0;G=d[i+(A<<2)>>1]|0;if((F&65535)>=(G&65535)){if(F<<16>>16!=G<<16>>16){L=v;break}if((h[a+5208+z>>0]|0)>(h[a+5208+A>>0]|0)){L=v;break}}L=w}else L=v;while(0);w=d[D>>1]|0;A=f[a+2908+(L<<2)>>2]|0;z=d[i+(A<<2)>>1]|0;if((w&65535)<(z&65535)){K=B;break c}if(w<<16>>16==z<<16>>16?(h[q>>0]|0)<=(h[a+5208+A>>0]|0):0){K=B;break c}f[a+2908+(B<<2)>>2]=A;v=L<<1;r=f[l>>2]|0;if((v|0)>(r|0)){K=L;break}else B=L}}while(0);f[a+2908+(K<<2)>>2]=C;C=C+1|0;m=f[l>>2]|0}while((m|0)>1);m=f[x>>2]|0;x=(f[o>>2]|0)+-1|0;f[o>>2]=x;f[a+2908+(x<<2)>>2]=m;m=f[c>>2]|0;c=f[t>>2]|0;t=f[k>>2]|0;k=f[t>>2]|0;x=f[t+4>>2]|0;l=f[t+8>>2]|0;C=f[t+16>>2]|0;t=a+2876|0;K=t+32|0;do{d[t>>1]=0;t=t+2|0}while((t|0)<(K|0));t=f[o>>2]|0;d[m+(f[a+2908+(t<<2)>>2]<<2)+2>>1]=0;o=t+1|0;d:do if((o|0)<573){t=a+5800|0;K=a+5804|0;if(!k){L=o;I=0;while(1){J=f[a+2908+(L<<2)>>2]|0;q=m+(J<<2)+2|0;D=j[m+(j[q>>1]<<2)+2>>1]|0;p=(D|0)<(C|0);n=p?D+1|0:C;D=((p^1)&1)+I|0;d[q>>1]=n;if((J|0)<=(c|0)){q=a+2876+(n<<1)|0;d[q>>1]=(d[q>>1]|0)+1<<16>>16;if((J|0)<(l|0))M=0;else M=f[x+(J-l<<2)>>2]|0;q=Y(j[m+(J<<2)>>1]|0,M+n|0)|0;f[t>>2]=q+(f[t>>2]|0)}L=L+1|0;if((L|0)==573){N=D;break}else I=D}}else{I=o;L=0;while(1){D=f[a+2908+(I<<2)>>2]|0;q=m+(D<<2)+2|0;n=j[m+(j[q>>1]<<2)+2>>1]|0;J=(n|0)<(C|0);p=J?n+1|0:C;n=((J^1)&1)+L|0;d[q>>1]=p;if((D|0)<=(c|0)){q=a+2876+(p<<1)|0;d[q>>1]=(d[q>>1]|0)+1<<16>>16;if((D|0)<(l|0))O=0;else O=f[x+(D-l<<2)>>2]|0;q=j[m+(D<<2)>>1]|0;J=Y(q,O+p|0)|0;f[t>>2]=J+(f[t>>2]|0);J=Y((j[k+(D<<2)+2>>1]|0)+O|0,q)|0;f[K>>2]=J+(f[K>>2]|0)}I=I+1|0;if((I|0)==573){N=n;break}else L=n}}if(N|0){L=a+2876+(C<<1)|0;I=N;while(1){K=C;while(1){n=K+-1|0;P=a+2876+(n<<1)|0;Q=d[P>>1]|0;if(!(Q<<16>>16))K=n;else break}d[P>>1]=Q+-1<<16>>16;n=a+2876+(K<<1)|0;d[n>>1]=(j[n>>1]|0)+2;R=(d[L>>1]|0)+-1<<16>>16;d[L>>1]=R;if((I|0)>2)I=I+-2|0;else break}if(C|0){I=R;L=C;n=573;while(1){J=L&65535;if(!(I<<16>>16))S=n;else{q=n;D=I&65535;while(1){p=q;do{p=p+-1|0;T=f[a+2908+(p<<2)>>2]|0}while((T|0)>(c|0));H=m+(T<<2)+2|0;B=j[H>>1]|0;if((L|0)!=(B|0)){r=Y(j[m+(T<<2)>>1]|0,L-B|0)|0;f[t>>2]=r+(f[t>>2]|0);d[H>>1]=J}D=D+-1|0;if(!D){S=p;break}else q=p}}q=L+-1|0;if(!q)break d;I=d[a+2876+(q<<1)>>1]|0;L=q;n=S}}}}while(0);S=1;T=0;do{T=(j[a+2876+(S+-1<<1)>>1]|0)+(T&65534)<<1;d[g+(S<<1)>>1]=T;S=S+1|0}while((S|0)!=16);if((y|0)<0){u=e;return}else U=0;while(1){S=d[i+(U<<2)+2>>1]|0;T=S&65535;if(S<<16>>16){S=g+(T<<1)|0;a=d[S>>1]|0;d[S>>1]=a+1<<16>>16;S=a&65535;a=T;T=0;while(1){V=T|S&1;if((a|0)>1){S=S>>>1;a=a+-1|0;T=V<<1}else break}d[i+(U<<2)>>1]=V}if((U|0)==(y|0))break;else U=U+1|0}u=e;return}function aEa(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;g=a+5792|0;if(!(f[g>>2]|0)){i=a+5820|0;k=a+5816|0;l=f[i>>2]|0;m=d[k>>1]|0;n=k;o=i}else{i=a+5796|0;k=a+5784|0;p=a+5820|0;q=a+5816|0;r=a+8|0;s=a+20|0;t=0;do{u=d[(f[i>>2]|0)+(t<<1)>>1]|0;v=u&65535;w=h[(f[k>>2]|0)+t>>0]|0;t=t+1|0;do if(!(u<<16>>16)){x=j[c+(w<<2)+2>>1]|0;y=f[p>>2]|0;z=j[c+(w<<2)>>1]|0;A=j[q>>1]|0|z<<y;B=A&65535;d[q>>1]=B;if((y|0)>(16-x|0)){C=f[r>>2]|0;D=f[s>>2]|0;f[s>>2]=D+1;b[C+D>>0]=A;A=(j[q>>1]|0)>>>8&255;D=f[r>>2]|0;C=f[s>>2]|0;f[s>>2]=C+1;b[D+C>>0]=A;A=f[p>>2]|0;C=z>>>(16-A|0)&65535;d[q>>1]=C;E=C;F=x+-16+A|0;G=23;break}else{E=B;F=y+x|0;G=23;break}}else{x=h[360052+w>>0]|0;y=(x|256)+1|0;B=j[c+(y<<2)+2>>1]|0;A=f[p>>2]|0;C=j[c+(y<<2)>>1]|0;y=j[q>>1]|0|C<<A;z=y&65535;d[q>>1]=z;if((A|0)>(16-B|0)){D=f[r>>2]|0;H=f[s>>2]|0;f[s>>2]=H+1;b[D+H>>0]=y;y=(j[q>>1]|0)>>>8&255;H=f[r>>2]|0;D=f[s>>2]|0;f[s>>2]=D+1;b[H+D>>0]=y;y=f[p>>2]|0;D=C>>>(16-y|0)&65535;d[q>>1]=D;I=B+-16+y|0;J=D}else{I=A+B|0;J=z}f[p>>2]=I;z=f[118864+(x<<2)>>2]|0;if((x+-8|0)>>>0<20){B=w-(f[118980+(x<<2)>>2]|0)&65535;x=B<<I|J&65535;A=x&65535;d[q>>1]=A;if((I|0)>(16-z|0)){D=f[r>>2]|0;y=f[s>>2]|0;f[s>>2]=y+1;b[D+y>>0]=x;x=(j[q>>1]|0)>>>8&255;y=f[r>>2]|0;D=f[s>>2]|0;f[s>>2]=D+1;b[y+D>>0]=x;x=f[p>>2]|0;D=B>>>(16-x|0)&65535;d[q>>1]=D;K=D;L=z+-16+x|0}else{K=A;L=I+z|0}f[p>>2]=L;M=L;N=K}else{M=I;N=J}z=v+-1|0;A=h[359540+(z>>>0<256?z:(z>>>7)+256|0)>>0]|0;x=j[e+(A<<2)+2>>1]|0;D=j[e+(A<<2)>>1]|0;B=N&65535|D<<M;y=B&65535;d[q>>1]=y;if((M|0)>(16-x|0)){C=f[r>>2]|0;H=f[s>>2]|0;f[s>>2]=H+1;b[C+H>>0]=B;B=(j[q>>1]|0)>>>8&255;H=f[r>>2]|0;C=f[s>>2]|0;f[s>>2]=C+1;b[H+C>>0]=B;B=f[p>>2]|0;C=D>>>(16-B|0)&65535;d[q>>1]=C;O=x+-16+B|0;P=C}else{O=M+x|0;P=y}f[p>>2]=O;y=f[118744+(A<<2)>>2]|0;if((A+-4|0)>>>0<26){x=z-(f[119096+(A<<2)>>2]|0)&65535;A=x<<O|P&65535;z=A&65535;d[q>>1]=z;if((O|0)>(16-y|0)){C=f[r>>2]|0;B=f[s>>2]|0;f[s>>2]=B+1;b[C+B>>0]=A;A=(j[q>>1]|0)>>>8&255;B=f[r>>2]|0;C=f[s>>2]|0;f[s>>2]=C+1;b[B+C>>0]=A;A=f[p>>2]|0;C=x>>>(16-A|0)&65535;d[q>>1]=C;E=C;F=y+-16+A|0;G=23;break}else{E=z;F=O+y|0;G=23;break}}else{Q=P;R=O}}while(0);if((G|0)==23){G=0;f[p>>2]=F;Q=E;R=F}}while(t>>>0<(f[g>>2]|0)>>>0);l=R;m=Q;n=q;o=p}p=j[c+1026>>1]|0;q=j[c+1024>>1]|0;c=m&65535|q<<l;d[n>>1]=c;if((l|0)>(16-p|0)){m=a+8|0;Q=f[m>>2]|0;R=a+20|0;a=f[R>>2]|0;f[R>>2]=a+1;b[Q+a>>0]=c;c=(j[n>>1]|0)>>>8&255;a=f[m>>2]|0;m=f[R>>2]|0;f[R>>2]=m+1;b[a+m>>0]=c;c=f[o>>2]|0;d[n>>1]=q>>>(16-c|0);S=p+-16+c|0;f[o>>2]=S;return}else{S=l+p|0;f[o>>2]=S;return}}function bEa(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;g=d[c+2>>1]|0;h=g<<16>>16==0;i=a+2754|0;k=a+5820|0;l=a+2752|0;m=a+5816|0;n=a+8|0;o=a+20|0;p=a+2758|0;q=a+2756|0;r=a+2750|0;s=a+2748|0;t=h?138:7;u=h?3:4;h=0;v=g&65535;g=-1;a:while(1){w=0;x=h;while(1){if((x|0)>(e|0))break a;x=x+1|0;y=d[c+(x<<2)+2>>1]|0;z=y&65535;A=w+1|0;B=(v|0)==(z|0);if(!((A|0)<(t|0)&B))break;else w=A}if((A|0)<(u|0)){C=a+2684+(v<<2)+2|0;D=a+2684+(v<<2)|0;E=f[k>>2]|0;F=d[m>>1]|0;G=A;while(1){H=j[C>>1]|0;I=j[D>>1]|0;J=F&65535|I<<E;K=J&65535;d[m>>1]=K;if((E|0)>(16-H|0)){L=f[n>>2]|0;M=f[o>>2]|0;f[o>>2]=M+1;b[L+M>>0]=J;J=(j[m>>1]|0)>>>8&255;M=f[n>>2]|0;L=f[o>>2]|0;f[o>>2]=L+1;b[M+L>>0]=J;J=f[k>>2]|0;L=I>>>(16-J|0)&65535;d[m>>1]=L;N=L;O=H+-16+J|0}else{N=K;O=E+H|0}f[k>>2]=O;G=G+-1|0;if(!G)break;else{E=O;F=N}}}else{do if(!v)if((A|0)<11){F=j[i>>1]|0;E=f[k>>2]|0;G=j[l>>1]|0;D=j[m>>1]|0|G<<E;d[m>>1]=D;if((E|0)>(16-F|0)){C=f[n>>2]|0;H=f[o>>2]|0;f[o>>2]=H+1;b[C+H>>0]=D;H=(j[m>>1]|0)>>>8&255;C=f[n>>2]|0;K=f[o>>2]|0;f[o>>2]=K+1;b[C+K>>0]=H;H=f[k>>2]|0;K=G>>>(16-H|0);d[m>>1]=K;P=F+-16+H|0;Q=K}else{P=E+F|0;Q=D}f[k>>2]=P;D=w+65534&65535;F=Q&65535|D<<P;d[m>>1]=F;if((P|0)>13){E=f[n>>2]|0;K=f[o>>2]|0;f[o>>2]=K+1;b[E+K>>0]=F;F=(j[m>>1]|0)>>>8&255;K=f[n>>2]|0;E=f[o>>2]|0;f[o>>2]=E+1;b[K+E>>0]=F;F=f[k>>2]|0;d[m>>1]=D>>>(16-F|0);R=F+-13|0;break}else{R=P+3|0;break}}else{F=j[p>>1]|0;D=f[k>>2]|0;E=j[q>>1]|0;K=j[m>>1]|0|E<<D;d[m>>1]=K;if((D|0)>(16-F|0)){H=f[n>>2]|0;G=f[o>>2]|0;f[o>>2]=G+1;b[H+G>>0]=K;G=(j[m>>1]|0)>>>8&255;H=f[n>>2]|0;C=f[o>>2]|0;f[o>>2]=C+1;b[H+C>>0]=G;G=f[k>>2]|0;C=E>>>(16-G|0);d[m>>1]=C;S=F+-16+G|0;T=C}else{S=D+F|0;T=K}f[k>>2]=S;K=w+65526&65535;F=T&65535|K<<S;d[m>>1]=F;if((S|0)>9){D=f[n>>2]|0;C=f[o>>2]|0;f[o>>2]=C+1;b[D+C>>0]=F;F=(j[m>>1]|0)>>>8&255;C=f[n>>2]|0;D=f[o>>2]|0;f[o>>2]=D+1;b[C+D>>0]=F;F=f[k>>2]|0;d[m>>1]=K>>>(16-F|0);R=F+-9|0;break}else{R=S+7|0;break}}else{if((v|0)==(g|0)){U=f[k>>2]|0;V=d[m>>1]|0;W=A}else{F=j[a+2684+(v<<2)+2>>1]|0;K=f[k>>2]|0;D=j[a+2684+(v<<2)>>1]|0;C=j[m>>1]|0|D<<K;G=C&65535;d[m>>1]=G;if((K|0)>(16-F|0)){E=f[n>>2]|0;H=f[o>>2]|0;f[o>>2]=H+1;b[E+H>>0]=C;C=(j[m>>1]|0)>>>8&255;H=f[n>>2]|0;E=f[o>>2]|0;f[o>>2]=E+1;b[H+E>>0]=C;C=f[k>>2]|0;E=D>>>(16-C|0)&65535;d[m>>1]=E;X=E;Y=F+-16+C|0}else{X=G;Y=K+F|0}f[k>>2]=Y;U=Y;V=X;W=w}F=j[r>>1]|0;K=j[s>>1]|0;G=V&65535|K<<U;d[m>>1]=G;if((U|0)>(16-F|0)){C=f[n>>2]|0;E=f[o>>2]|0;f[o>>2]=E+1;b[C+E>>0]=G;E=(j[m>>1]|0)>>>8&255;C=f[n>>2]|0;D=f[o>>2]|0;f[o>>2]=D+1;b[C+D>>0]=E;E=f[k>>2]|0;D=K>>>(16-E|0);d[m>>1]=D;Z=F+-16+E|0;_=D}else{Z=U+F|0;_=G}f[k>>2]=Z;G=W+65533&65535;F=_&65535|G<<Z;d[m>>1]=F;if((Z|0)>14){D=f[n>>2]|0;E=f[o>>2]|0;f[o>>2]=E+1;b[D+E>>0]=F;F=(j[m>>1]|0)>>>8&255;E=f[n>>2]|0;D=f[o>>2]|0;f[o>>2]=D+1;b[E+D>>0]=F;F=f[k>>2]|0;d[m>>1]=G>>>(16-F|0);R=F+-14|0;break}else{R=Z+2|0;break}}while(0);f[k>>2]=R}w=y<<16>>16==0;F=v;t=w?138:B?6:7;u=w|B?3:4;h=x;v=z;g=F}return}function cEa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;f[a+4>>2]=0;if((b|0)!=90){d=f[a>>2]|0;f[d+20>>2]=13;f[d+24>>2]=90;f[d+28>>2]=b;ki[f[d>>2]&2047](a)}if((c|0)==440)e=a;else{d=f[a>>2]|0;f[d+20>>2]=22;f[d+24>>2]=440;f[d+28>>2]=c;ki[f[d>>2]&2047](a);e=a}d=f[a>>2]|0;c=a+12|0;b=f[c>>2]|0;F1a(a+4|0,0,436)|0;f[a>>2]=d;f[c>>2]=b;f[a+16>>2]=0;jGa(e);f[a+8>>2]=0;f[a+24>>2]=0;f[a+84>>2]=0;f[a+88>>2]=0;f[a+104>>2]=100;f[a+92>>2]=0;f[a+108>>2]=100;f[a+96>>2]=0;f[a+112>>2]=100;f[a+100>>2]=0;f[a+116>>2]=100;e=a+120|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;f[a+380>>2]=8;f[a+384>>2]=120268;f[a+388>>2]=63;f[a+428>>2]=0;p[a+48>>3]=1.0;f[a+20>>2]=100;return}function dEa(a){a=a|0;FEa(a);return}function eEa(a,b){a=a|0;b=b|0;var c=0;c=f[a+88>>2]|0;if(c|0)f[c+128>>2]=b;c=f[a+92>>2]|0;if(c|0)f[c+128>>2]=b;c=f[a+96>>2]|0;if(c|0)f[c+128>>2]=b;c=f[a+100>>2]|0;if(c|0)f[c+128>>2]=b;c=f[a+120>>2]|0;if(c|0)f[c+276>>2]=b;c=f[a+136>>2]|0;if(c|0)f[c+276>>2]=b;c=f[a+124>>2]|0;if(c|0)f[c+276>>2]=b;c=f[a+140>>2]|0;if(c|0)f[c+276>>2]=b;c=f[a+128>>2]|0;if(c|0)f[c+276>>2]=b;c=f[a+144>>2]|0;if(c|0)f[c+276>>2]=b;c=f[a+132>>2]|0;if(c|0)f[c+276>>2]=b;c=f[a+148>>2]|0;if(!c)return;f[c+276>>2]=b;return}function fEa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=f[a+20>>2]|0;switch(b|0){case 102:case 101:{if((f[a+264>>2]|0)>>>0<(f[a+32>>2]|0)>>>0){c=f[a>>2]|0;f[c+20>>2]=69;ki[f[c>>2]&2047](a)}ki[f[(f[a+392>>2]|0)+8>>2]&2047](a);break}case 103:break;default:{c=f[a>>2]|0;f[c+20>>2]=21;f[c+24>>2]=b;ki[f[c>>2]&2047](a)}}c=a+392|0;b=f[c>>2]|0;if(f[b+16>>2]|0){d=a;e=a+408|0;g=f[e>>2]|0;h=g+12|0;i=f[h>>2]|0;ki[i&2047](a);j=a+24|0;k=f[j>>2]|0;l=k+16|0;m=f[l>>2]|0;ki[m&2047](a);EEa(d);return}n=a+288|0;o=a+8|0;p=a+404|0;q=b;do{ki[f[q>>2]&2047](a);b=f[n>>2]|0;if(b|0){r=b;b=0;do{s=f[o>>2]|0;if(s|0){f[s+4>>2]=b;f[s+8>>2]=r;ki[f[s>>2]&2047](a)}if(!($h[f[(f[p>>2]|0)+4>>2]&255](a,0)|0)){s=f[a>>2]|0;f[s+20>>2]=25;ki[f[s>>2]&2047](a)}b=b+1|0;r=f[n>>2]|0}while(b>>>0<r>>>0)}ki[f[(f[c>>2]|0)+8>>2]&2047](a);q=f[c>>2]|0}while(!(f[q+16>>2]|0));d=a;e=a+408|0;g=f[e>>2]|0;h=g+12|0;i=f[h>>2]|0;ki[i&2047](a);j=a+24|0;k=f[j>>2]|0;l=k+16|0;m=f[l>>2]|0;ki[m&2047](a);EEa(d);return}function gEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a+20|0;d=f[c>>2]|0;if((d|0)!=100){e=f[a>>2]|0;f[e+20>>2]=21;f[e+24>>2]=d;ki[f[e>>2]&2047](a)}if(b|0)eEa(a,0);ki[f[(f[a>>2]|0)+16>>2]&2047](a);ki[f[(f[a+24>>2]|0)+8>>2]&2047](a);iEa(a);ki[f[f[a+392>>2]>>2]&2047](a);f[a+264>>2]=0;f[c>>2]=f[a+208>>2]|0?102:101;return}function hEa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[a+20>>2]|0;if((g|0)!=101){h=f[a>>2]|0;f[h+20>>2]=21;f[h+24>>2]=g;ki[f[h>>2]&2047](a)}h=a+264|0;g=a+32|0;if((f[h>>2]|0)>>>0>=(f[g>>2]|0)>>>0){i=f[a>>2]|0;f[i+20>>2]=126;Gh[f[i+4>>2]&511](a,-1)}i=f[a+8>>2]|0;if(i|0){f[i+4>>2]=f[h>>2];f[i+8>>2]=f[g>>2];ki[f[i>>2]&2047](a)}i=f[a+392>>2]|0;if(f[i+12>>2]|0)ki[f[i+4>>2]&2047](a);i=(f[g>>2]|0)-(f[h>>2]|0)|0;f[e>>2]=0;Ah[f[(f[a+396>>2]|0)+4>>2]&255](a,b,e,i>>>0<c>>>0?i:c);c=f[e>>2]|0;f[h>>2]=(f[h>>2]|0)+c;u=d;return c|0}function iEa(a){a=a|0;var b=0;yEa(a,0);if(!(f[a+208>>2]|0)){hHa(a);UEa(a);QEa(a,0)}rHa(a);if(!(f[a+212>>2]|0))vHa(a);else UGa(a);if((f[a+200>>2]|0)>1)b=1;else b=(f[a+216>>2]|0)!=0;cHa(a,b&1);jEa(a,0);mEa(a);ki[f[(f[a+4>>2]|0)+24>>2]&2047](a);ki[f[f[a+408>>2]>>2]&2047](a);return}function jEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+4|0;d=ui[f[f[c>>2]>>2]&127](a,1,64)|0;f[a+396>>2]=d;f[d>>2]=388;if(f[a+208>>2]|0)return;if(b|0){b=f[a>>2]|0;f[b+20>>2]=3;ki[f[b>>2]&2047](a);return}b=a+76|0;if((f[b>>2]|0)<=0)return;e=d+24|0;d=0;g=f[a+84>>2]|0;while(1){h=Y(f[g+36>>2]|0,f[g+28>>2]|0)|0;i=Y(f[g+40>>2]|0,f[g+12>>2]|0)|0;j=Jg[f[(f[c>>2]|0)+8>>2]&63](a,1,h,i)|0;f[e+(d<<2)>>2]=j;d=d+1|0;if((d|0)>=(f[b>>2]|0))break;else g=g+88|0}return}function kEa(a,b){a=a|0;b=b|0;var c=0;c=f[a+396>>2]|0;if(f[a+208>>2]|0)return;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=b;if(!b){f[c+4>>2]=158;return}else{c=f[a>>2]|0;f[c+20>>2]=3;ki[f[c>>2]&2047](a);return}}function lEa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+396>>2]|0;g=e+8|0;h=a+288|0;if((f[g>>2]|0)>>>0>=(f[h>>2]|0)>>>0)return;i=e+12|0;j=a+284|0;k=a+400|0;l=e+24|0;m=a+404|0;n=e+16|0;e=f[i>>2]|0;while(1){o=f[j>>2]|0;if(e>>>0<o>>>0){Xh[f[(f[k>>2]|0)+4>>2]&127](a,b,c,d,l,i,o);p=f[i>>2]|0;q=f[j>>2]|0}else{p=e;q=o}if((p|0)!=(q|0)){r=12;break}o=($h[f[(f[m>>2]|0)+4>>2]&255](a,l)|0)==0;s=(f[n>>2]|0)!=0;if(o){r=7;break}if(s){f[c>>2]=(f[c>>2]|0)+1;f[n>>2]=0}f[i>>2]=0;o=(f[g>>2]|0)+1|0;f[g>>2]=o;if(o>>>0<(f[h>>2]|0)>>>0)e=0;else{r=12;break}}if((r|0)==7){if(s)return;f[c>>2]=(f[c>>2]|0)+-1;f[n>>2]=1;return}else if((r|0)==12)return}function mEa(a){a=a|0;var b=0;b=ui[f[f[a+4>>2]>>2]&127](a,1,32)|0;f[a+408>>2]=b;f[b>>2]=972;f[b+4>>2]=973;f[b+8>>2]=974;f[b+12>>2]=975;f[b+16>>2]=976;f[b+20>>2]=200;f[b+24>>2]=389;f[b+28>>2]=0;return}function nEa(a){a=a|0;var c=0,e=0,g=0,h=0,i=0;c=f[a+408>>2]|0;e=a+24|0;g=f[e>>2]|0;h=f[g>>2]|0;f[g>>2]=h+1;b[h>>0]=-1;h=g+4|0;i=(f[h>>2]|0)+-1|0;f[h>>2]=i;if((i|0)==0?(mi[f[g+12>>2]&255](a)|0)==0:0){g=f[a>>2]|0;f[g+20>>2]=25;ki[f[g>>2]&2047](a)}g=f[e>>2]|0;i=f[g>>2]|0;f[g>>2]=i+1;b[i>>0]=-40;i=g+4|0;h=(f[i>>2]|0)+-1|0;f[i>>2]=h;if((h|0)==0?(mi[f[g+12>>2]&255](a)|0)==0:0){g=f[a>>2]|0;f[g+20>>2]=25;ki[f[g>>2]&2047](a)}f[c+28>>2]=0;do if(f[a+244>>2]|0){c=f[e>>2]|0;g=f[c>>2]|0;f[c>>2]=g+1;b[g>>0]=-1;g=c+4|0;h=(f[g>>2]|0)+-1|0;f[g>>2]=h;if((h|0)==0?(mi[f[c+12>>2]&255](a)|0)==0:0){c=f[a>>2]|0;f[c+20>>2]=25;ki[f[c>>2]&2047](a)}c=f[e>>2]|0;h=f[c>>2]|0;f[c>>2]=h+1;b[h>>0]=-32;h=c+4|0;g=(f[h>>2]|0)+-1|0;f[h>>2]=g;if((g|0)==0?(mi[f[c+12>>2]&255](a)|0)==0:0){c=f[a>>2]|0;f[c+20>>2]=25;ki[f[c>>2]&2047](a)}c=f[e>>2]|0;g=f[c>>2]|0;f[c>>2]=g+1;b[g>>0]=0;g=c+4|0;h=(f[g>>2]|0)+-1|0;f[g>>2]=h;if((h|0)==0?(mi[f[c+12>>2]&255](a)|0)==0:0){c=f[a>>2]|0;f[c+20>>2]=25;ki[f[c>>2]&2047](a)}c=f[e>>2]|0;h=f[c>>2]|0;f[c>>2]=h+1;b[h>>0]=16;h=c+4|0;g=(f[h>>2]|0)+-1|0;f[h>>2]=g;if((g|0)==0?(mi[f[c+12>>2]&255](a)|0)==0:0){c=f[a>>2]|0;f[c+20>>2]=25;ki[f[c>>2]&2047](a)}c=f[e>>2]|0;g=f[c>>2]|0;f[c>>2]=g+1;b[g>>0]=74;g=c+4|0;h=(f[g>>2]|0)+-1|0;f[g>>2]=h;if((h|0)==0?(mi[f[c+12>>2]&255](a)|0)==0:0){c=f[a>>2]|0;f[c+20>>2]=25;ki[f[c>>2]&2047](a)}c=f[e>>2]|0;h=f[c>>2]|0;f[c>>2]=h+1;b[h>>0]=70;h=c+4|0;g=(f[h>>2]|0)+-1|0;f[h>>2]=g;if((g|0)==0?(mi[f[c+12>>2]&255](a)|0)==0:0){c=f[a>>2]|0;f[c+20>>2]=25;ki[f[c>>2]&2047](a)}c=f[e>>2]|0;g=f[c>>2]|0;f[c>>2]=g+1;b[g>>0]=73;g=c+4|0;h=(f[g>>2]|0)+-1|0;f[g>>2]=h;if((h|0)==0?(mi[f[c+12>>2]&255](a)|0)==0:0){c=f[a>>2]|0;f[c+20>>2]=25;ki[f[c>>2]&2047](a)}c=f[e>>2]|0;h=f[c>>2]|0;f[c>>2]=h+1;b[h>>0]=70;h=c+4|0;g=(f[h>>2]|0)+-1|0;f[h>>2]=g;if((g|0)==0?(mi[f[c+12>>2]&255](a)|0)==0:0){c=f[a>>2]|0;f[c+20>>2]=25;ki[f[c>>2]&2047](a)}c=f[e>>2]|0;g=f[c>>2]|0;f[c>>2]=g+1;b[g>>0]=0;g=c+4|0;h=(f[g>>2]|0)+-1|0;f[g>>2]=h;if((h|0)==0?(mi[f[c+12>>2]&255](a)|0)==0:0){c=f[a>>2]|0;f[c+20>>2]=25;ki[f[c>>2]&2047](a)}c=b[a+248>>0]|0;h=f[e>>2]|0;g=f[h>>2]|0;f[h>>2]=g+1;b[g>>0]=c;c=h+4|0;g=(f[c>>2]|0)+-1|0;f[c>>2]=g;if((g|0)==0?(mi[f[h+12>>2]&255](a)|0)==0:0){h=f[a>>2]|0;f[h+20>>2]=25;ki[f[h>>2]&2047](a)}h=b[a+249>>0]|0;g=f[e>>2]|0;c=f[g>>2]|0;f[g>>2]=c+1;b[c>>0]=h;h=g+4|0;c=(f[h>>2]|0)+-1|0;f[h>>2]=c;if((c|0)==0?(mi[f[g+12>>2]&255](a)|0)==0:0){g=f[a>>2]|0;f[g+20>>2]=25;ki[f[g>>2]&2047](a)}g=b[a+250>>0]|0;c=f[e>>2]|0;h=f[c>>2]|0;f[c>>2]=h+1;b[h>>0]=g;g=c+4|0;h=(f[g>>2]|0)+-1|0;f[g>>2]=h;if((h|0)==0?(mi[f[c+12>>2]&255](a)|0)==0:0){c=f[a>>2]|0;f[c+20>>2]=25;ki[f[c>>2]&2047](a)}c=d[a+252>>1]|0;h=f[e>>2]|0;g=f[h>>2]|0;f[h>>2]=g+1;b[g>>0]=(c&65535)>>>8;g=h+4|0;i=(f[g>>2]|0)+-1|0;f[g>>2]=i;if((i|0)==0?(mi[f[h+12>>2]&255](a)|0)==0:0){h=f[a>>2]|0;f[h+20>>2]=25;ki[f[h>>2]&2047](a)}h=f[e>>2]|0;i=f[h>>2]|0;f[h>>2]=i+1;b[i>>0]=c;c=h+4|0;i=(f[c>>2]|0)+-1|0;f[c>>2]=i;if((i|0)==0?(mi[f[h+12>>2]&255](a)|0)==0:0){h=f[a>>2]|0;f[h+20>>2]=25;ki[f[h>>2]&2047](a)}h=d[a+254>>1]|0;i=f[e>>2]|0;c=f[i>>2]|0;f[i>>2]=c+1;b[c>>0]=(h&65535)>>>8;c=i+4|0;g=(f[c>>2]|0)+-1|0;f[c>>2]=g;do if(!g){if(mi[f[i+12>>2]&255](a)|0)break;c=f[a>>2]|0;f[c+20>>2]=25;ki[f[c>>2]&2047](a)}while(0);i=f[e>>2]|0;g=f[i>>2]|0;f[i>>2]=g+1;b[g>>0]=h;g=i+4|0;c=(f[g>>2]|0)+-1|0;f[g>>2]=c;do if(!c){if(mi[f[i+12>>2]&255](a)|0)break;g=f[a>>2]|0;f[g+20>>2]=25;ki[f[g>>2]&2047](a)}while(0);i=f[e>>2]|0;c=f[i>>2]|0;f[i>>2]=c+1;b[c>>0]=0;c=i+4|0;h=(f[c>>2]|0)+-1|0;f[c>>2]=h;do if(!h){if(mi[f[i+12>>2]&255](a)|0)break;c=f[a>>2]|0;f[c+20>>2]=25;ki[f[c>>2]&2047](a)}while(0);i=f[e>>2]|0;h=f[i>>2]|0;f[i>>2]=h+1;b[h>>0]=0;h=i+4|0;c=(f[h>>2]|0)+-1|0;f[h>>2]=c;if(c|0)break;if(mi[f[i+12>>2]&255](a)|0)break;i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}while(0);if(!(f[a+256>>2]|0))return;i=f[e>>2]|0;c=f[i>>2]|0;f[i>>2]=c+1;b[c>>0]=-1;c=i+4|0;h=(f[c>>2]|0)+-1|0;f[c>>2]=h;if((h|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=f[e>>2]|0;h=f[i>>2]|0;f[i>>2]=h+1;b[h>>0]=-18;h=i+4|0;c=(f[h>>2]|0)+-1|0;f[h>>2]=c;if((c|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=f[e>>2]|0;c=f[i>>2]|0;f[i>>2]=c+1;b[c>>0]=0;c=i+4|0;h=(f[c>>2]|0)+-1|0;f[c>>2]=h;if((h|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=f[e>>2]|0;h=f[i>>2]|0;f[i>>2]=h+1;b[h>>0]=14;h=i+4|0;c=(f[h>>2]|0)+-1|0;f[h>>2]=c;if((c|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=f[e>>2]|0;c=f[i>>2]|0;f[i>>2]=c+1;b[c>>0]=65;c=i+4|0;h=(f[c>>2]|0)+-1|0;f[c>>2]=h;if((h|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=f[e>>2]|0;h=f[i>>2]|0;f[i>>2]=h+1;b[h>>0]=100;h=i+4|0;c=(f[h>>2]|0)+-1|0;f[h>>2]=c;if((c|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=f[e>>2]|0;c=f[i>>2]|0;f[i>>2]=c+1;b[c>>0]=111;c=i+4|0;h=(f[c>>2]|0)+-1|0;f[c>>2]=h;if((h|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=f[e>>2]|0;h=f[i>>2]|0;f[i>>2]=h+1;b[h>>0]=98;h=i+4|0;c=(f[h>>2]|0)+-1|0;f[h>>2]=c;if((c|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=f[e>>2]|0;c=f[i>>2]|0;f[i>>2]=c+1;b[c>>0]=101;c=i+4|0;h=(f[c>>2]|0)+-1|0;f[c>>2]=h;if((h|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=f[e>>2]|0;h=f[i>>2]|0;f[i>>2]=h+1;b[h>>0]=0;h=i+4|0;c=(f[h>>2]|0)+-1|0;f[h>>2]=c;if((c|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=f[e>>2]|0;c=f[i>>2]|0;f[i>>2]=c+1;b[c>>0]=100;c=i+4|0;h=(f[c>>2]|0)+-1|0;f[c>>2]=h;if((h|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=f[e>>2]|0;h=f[i>>2]|0;f[i>>2]=h+1;b[h>>0]=0;h=i+4|0;c=(f[h>>2]|0)+-1|0;f[h>>2]=c;if((c|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=f[e>>2]|0;c=f[i>>2]|0;f[i>>2]=c+1;b[c>>0]=0;c=i+4|0;h=(f[c>>2]|0)+-1|0;f[c>>2]=h;if((h|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=f[e>>2]|0;h=f[i>>2]|0;f[i>>2]=h+1;b[h>>0]=0;h=i+4|0;c=(f[h>>2]|0)+-1|0;f[h>>2]=c;if((c|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=f[e>>2]|0;c=f[i>>2]|0;f[i>>2]=c+1;b[c>>0]=0;c=i+4|0;h=(f[c>>2]|0)+-1|0;f[c>>2]=h;do if(!h){if(mi[f[i+12>>2]&255](a)|0)break;c=f[a>>2]|0;f[c+20>>2]=25;ki[f[c>>2]&2047](a)}while(0);switch(f[a+80>>2]|0){case 3:{i=f[e>>2]|0;h=f[i>>2]|0;f[i>>2]=h+1;b[h>>0]=1;h=i+4|0;c=(f[h>>2]|0)+-1|0;f[h>>2]=c;if(c|0)return;if(mi[f[i+12>>2]&255](a)|0)return;i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a);return}case 5:{i=f[e>>2]|0;c=f[i>>2]|0;f[i>>2]=c+1;b[c>>0]=2;c=i+4|0;h=(f[c>>2]|0)+-1|0;f[c>>2]=h;if(h|0)return;if(mi[f[i+12>>2]&255](a)|0)return;i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a);return}default:{i=f[e>>2]|0;e=f[i>>2]|0;f[i>>2]=e+1;b[e>>0]=0;e=i+4|0;h=(f[e>>2]|0)+-1|0;f[e>>2]=h;if(h|0)return;if(mi[f[i+12>>2]&255](a)|0)return;i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a);return}}}function oEa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+84|0;d=a+76|0;e=f[d>>2]|0;if((e|0)>0){g=0;h=f[c>>2]|0;i=0;while(1){j=(uEa(a,f[h+16>>2]|0)|0)+i|0;g=g+1|0;k=f[d>>2]|0;if((g|0)>=(k|0)){l=k;m=j;break}else{h=h+88|0;i=j}}}else{l=e;m=0}e=a+212|0;i=a+268|0;h=(f[i>>2]|0)==0;a:do if(f[e>>2]|0)if(h)n=19;else n=18;else{b:do if(h){do if((f[a+72>>2]|0)==8?(f[a+380>>2]|0)==8:0){if((l|0)>0){g=0;j=f[c>>2]|0;k=1;while(1){if((f[j+20>>2]|0)<=1?(f[j+24>>2]|0)<=1:0)o=k;else o=0;g=g+1|0;if((g|0)>=(l|0)){p=o;break}else{j=j+88|0;k=o}}}else p=1;if(!((m|0)!=0&(p|0)!=0)){if(!p)break;wEa(a,192);break a}k=f[a>>2]|0;f[k+20>>2]=77;Gh[f[k+4>>2]&511](a,0);k=(f[i>>2]|0)!=0;if(!(f[e>>2]|0))if(k)break b;else break;else if(k){n=18;break a}else{n=19;break a}}while(0);wEa(a,193);break a}while(0);wEa(a,194)}while(0);if((n|0)==18)wEa(a,202);else if((n|0)==19)wEa(a,201);switch(f[a+260>>2]|0){case 0:break;case 1:{if((f[d>>2]|0)<3)n=27;else n=28;break}default:n=27}if((n|0)==27){d=f[a>>2]|0;f[d+20>>2]=28;ki[f[d>>2]&2047](a);n=28}do if((n|0)==28){d=a+24|0;e=f[d>>2]|0;p=f[e>>2]|0;f[e>>2]=p+1;b[p>>0]=-1;p=e+4|0;m=(f[p>>2]|0)+-1|0;f[p>>2]=m;if((m|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}e=f[d>>2]|0;m=f[e>>2]|0;f[e>>2]=m+1;b[m>>0]=-8;m=e+4|0;p=(f[m>>2]|0)+-1|0;f[m>>2]=p;if((p|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}e=f[d>>2]|0;p=f[e>>2]|0;f[e>>2]=p+1;b[p>>0]=0;p=e+4|0;m=(f[p>>2]|0)+-1|0;f[p>>2]=m;if((m|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}e=f[d>>2]|0;m=f[e>>2]|0;f[e>>2]=m+1;b[m>>0]=24;m=e+4|0;p=(f[m>>2]|0)+-1|0;f[m>>2]=p;if((p|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}e=f[d>>2]|0;p=f[e>>2]|0;f[e>>2]=p+1;b[p>>0]=13;p=e+4|0;m=(f[p>>2]|0)+-1|0;f[p>>2]=m;if((m|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}e=f[d>>2]|0;m=f[e>>2]|0;f[e>>2]=m+1;b[m>>0]=0;m=e+4|0;p=(f[m>>2]|0)+-1|0;f[m>>2]=p;if((p|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}e=f[d>>2]|0;p=f[e>>2]|0;f[e>>2]=p+1;b[p>>0]=-1;p=e+4|0;m=(f[p>>2]|0)+-1|0;f[p>>2]=m;if((m|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}e=f[d>>2]|0;m=f[e>>2]|0;f[e>>2]=m+1;b[m>>0]=3;m=e+4|0;p=(f[m>>2]|0)+-1|0;f[m>>2]=p;if((p|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}e=f[d>>2]|0;p=f[(f[c>>2]|0)+88>>2]&255;m=f[e>>2]|0;f[e>>2]=m+1;b[m>>0]=p;p=e+4|0;m=(f[p>>2]|0)+-1|0;f[p>>2]=m;if((m|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}e=f[d>>2]|0;m=f[f[c>>2]>>2]&255;p=f[e>>2]|0;f[e>>2]=p+1;b[p>>0]=m;m=e+4|0;p=(f[m>>2]|0)+-1|0;f[m>>2]=p;if((p|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}e=f[d>>2]|0;p=f[(f[c>>2]|0)+176>>2]&255;m=f[e>>2]|0;f[e>>2]=m+1;b[m>>0]=p;p=e+4|0;m=(f[p>>2]|0)+-1|0;f[p>>2]=m;if((m|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}e=f[d>>2]|0;m=f[e>>2]|0;f[e>>2]=m+1;b[m>>0]=-128;m=e+4|0;p=(f[m>>2]|0)+-1|0;f[m>>2]=p;if((p|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}e=f[d>>2]|0;p=f[e>>2]|0;f[e>>2]=p+1;b[p>>0]=0;p=e+4|0;m=(f[p>>2]|0)+-1|0;f[p>>2]=m;if((m|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}e=f[d>>2]|0;m=f[e>>2]|0;f[e>>2]=m+1;b[m>>0]=0;m=e+4|0;p=(f[m>>2]|0)+-1|0;f[m>>2]=p;if((p|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}e=f[d>>2]|0;p=f[e>>2]|0;f[e>>2]=p+1;b[p>>0]=0;p=e+4|0;m=(f[p>>2]|0)+-1|0;f[p>>2]=m;if((m|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}e=f[d>>2]|0;m=f[e>>2]|0;f[e>>2]=m+1;b[m>>0]=0;m=e+4|0;p=(f[m>>2]|0)+-1|0;f[m>>2]=p;do if(!p){if(mi[f[e+12>>2]&255](a)|0)break;m=f[a>>2]|0;f[m+20>>2]=25;ki[f[m>>2]&2047](a)}while(0);e=f[d>>2]|0;p=f[e>>2]|0;f[e>>2]=p+1;b[p>>0]=0;p=e+4|0;m=(f[p>>2]|0)+-1|0;f[p>>2]=m;do if(!m){if(mi[f[e+12>>2]&255](a)|0)break;p=f[a>>2]|0;f[p+20>>2]=25;ki[f[p>>2]&2047](a)}while(0);e=f[d>>2]|0;m=f[e>>2]|0;f[e>>2]=m+1;b[m>>0]=0;m=e+4|0;p=(f[m>>2]|0)+-1|0;f[m>>2]=p;do if(!p){if(mi[f[e+12>>2]&255](a)|0)break;m=f[a>>2]|0;f[m+20>>2]=25;ki[f[m>>2]&2047](a)}while(0);e=f[d>>2]|0;p=f[e>>2]|0;f[e>>2]=p+1;b[p>>0]=1;p=e+4|0;m=(f[p>>2]|0)+-1|0;f[p>>2]=m;do if(!m){if(mi[f[e+12>>2]&255](a)|0)break;p=f[a>>2]|0;f[p+20>>2]=25;ki[f[p>>2]&2047](a)}while(0);e=f[d>>2]|0;m=f[e>>2]|0;f[e>>2]=m+1;b[m>>0]=0;m=e+4|0;p=(f[m>>2]|0)+-1|0;f[m>>2]=p;do if(!p){if(mi[f[e+12>>2]&255](a)|0)break;m=f[a>>2]|0;f[m+20>>2]=25;ki[f[m>>2]&2047](a)}while(0);e=f[d>>2]|0;p=f[e>>2]|0;f[e>>2]=p+1;b[p>>0]=0;p=e+4|0;m=(f[p>>2]|0)+-1|0;f[p>>2]=m;do if(!m){if(mi[f[e+12>>2]&255](a)|0)break;p=f[a>>2]|0;f[p+20>>2]=25;ki[f[p>>2]&2047](a)}while(0);e=f[d>>2]|0;m=f[e>>2]|0;f[e>>2]=m+1;b[m>>0]=0;m=e+4|0;p=(f[m>>2]|0)+-1|0;f[m>>2]=p;do if(!p){if(mi[f[e+12>>2]&255](a)|0)break;m=f[a>>2]|0;f[m+20>>2]=25;ki[f[m>>2]&2047](a)}while(0);e=f[d>>2]|0;p=f[e>>2]|0;f[e>>2]=p+1;b[p>>0]=0;p=e+4|0;m=(f[p>>2]|0)+-1|0;f[p>>2]=m;do if(!m){if(mi[f[e+12>>2]&255](a)|0)break;p=f[a>>2]|0;f[p+20>>2]=25;ki[f[p>>2]&2047](a)}while(0);e=f[d>>2]|0;m=f[e>>2]|0;f[e>>2]=m+1;b[m>>0]=1;m=e+4|0;p=(f[m>>2]|0)+-1|0;f[m>>2]=p;do if(!p){if(mi[f[e+12>>2]&255](a)|0)break;m=f[a>>2]|0;f[m+20>>2]=25;ki[f[m>>2]&2047](a)}while(0);e=f[d>>2]|0;p=f[e>>2]|0;f[e>>2]=p+1;b[p>>0]=0;p=e+4|0;m=(f[p>>2]|0)+-1|0;f[p>>2]=m;do if(!m){if(mi[f[e+12>>2]&255](a)|0)break;p=f[a>>2]|0;f[p+20>>2]=25;ki[f[p>>2]&2047](a)}while(0);e=f[d>>2]|0;m=f[e>>2]|0;f[e>>2]=m+1;b[m>>0]=0;m=e+4|0;p=(f[m>>2]|0)+-1|0;f[m>>2]=p;if(p|0)break;if(mi[f[e+12>>2]&255](a)|0)break;e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}while(0);if(!(f[i>>2]|0))return;i=a+380|0;if((f[i>>2]|0)==8)return;c=a+24|0;n=f[c>>2]|0;e=f[n>>2]|0;f[n>>2]=e+1;b[e>>0]=-1;e=n+4|0;p=(f[e>>2]|0)+-1|0;f[e>>2]=p;if((p|0)==0?(mi[f[n+12>>2]&255](a)|0)==0:0){n=f[a>>2]|0;f[n+20>>2]=25;ki[f[n>>2]&2047](a)}n=f[c>>2]|0;p=f[n>>2]|0;f[n>>2]=p+1;b[p>>0]=-38;p=n+4|0;e=(f[p>>2]|0)+-1|0;f[p>>2]=e;if((e|0)==0?(mi[f[n+12>>2]&255](a)|0)==0:0){n=f[a>>2]|0;f[n+20>>2]=25;ki[f[n>>2]&2047](a)}n=f[c>>2]|0;e=f[n>>2]|0;f[n>>2]=e+1;b[e>>0]=0;e=n+4|0;p=(f[e>>2]|0)+-1|0;f[e>>2]=p;if((p|0)==0?(mi[f[n+12>>2]&255](a)|0)==0:0){n=f[a>>2]|0;f[n+20>>2]=25;ki[f[n>>2]&2047](a)}n=f[c>>2]|0;p=f[n>>2]|0;f[n>>2]=p+1;b[p>>0]=6;p=n+4|0;e=(f[p>>2]|0)+-1|0;f[p>>2]=e;if((e|0)==0?(mi[f[n+12>>2]&255](a)|0)==0:0){n=f[a>>2]|0;f[n+20>>2]=25;ki[f[n>>2]&2047](a)}n=f[c>>2]|0;e=f[n>>2]|0;f[n>>2]=e+1;b[e>>0]=0;e=n+4|0;p=(f[e>>2]|0)+-1|0;f[e>>2]=p;if((p|0)==0?(mi[f[n+12>>2]&255](a)|0)==0:0){n=f[a>>2]|0;f[n+20>>2]=25;ki[f[n>>2]&2047](a)}n=f[c>>2]|0;p=f[n>>2]|0;f[n>>2]=p+1;b[p>>0]=0;p=n+4|0;e=(f[p>>2]|0)+-1|0;f[p>>2]=e;if((e|0)==0?(mi[f[n+12>>2]&255](a)|0)==0:0){n=f[a>>2]|0;f[n+20>>2]=25;ki[f[n>>2]&2047](a)}n=f[i>>2]|0;i=(Y(n,n)|0)+255|0;n=f[c>>2]|0;e=f[n>>2]|0;f[n>>2]=e+1;b[e>>0]=i;i=n+4|0;e=(f[i>>2]|0)+-1|0;f[i>>2]=e;if((e|0)==0?(mi[f[n+12>>2]&255](a)|0)==0:0){n=f[a>>2]|0;f[n+20>>2]=25;ki[f[n>>2]&2047](a)}n=f[c>>2]|0;c=f[n>>2]|0;f[n>>2]=c+1;b[c>>0]=0;c=n+4|0;e=(f[c>>2]|0)+-1|0;f[c>>2]=e;if(e|0)return;if(mi[f[n+12>>2]&255](a)|0)return;n=f[a>>2]|0;f[n+20>>2]=25;ki[f[n>>2]&2047](a);return}function pEa(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;c=u;u=u+32|0;d=c+16|0;e=c;g=f[a+408>>2]|0;if(!(f[a+212>>2]|0)){i=a+292|0;if((f[i>>2]|0)>0){j=a+364|0;k=a+372|0;l=a+368|0;m=0;do{n=f[a+296+(m<<2)>>2]|0;if((f[j>>2]|0)==0?(f[k>>2]|0)==0:0)vEa(a,f[n+20>>2]|0,0);if(f[l>>2]|0)vEa(a,f[n+24>>2]|0,1);m=m+1|0}while((m|0)<(f[i>>2]|0))}}else{i=e;m=i+16|0;do{b[i>>0]=0;i=i+1|0}while((i|0)<(m|0));i=d;m=i+16|0;do{b[i>>0]=0;i=i+1|0}while((i|0)<(m|0));i=f[a+292>>2]|0;a:do if((i|0)>0){m=(f[a+368>>2]|0)==0;if(f[a+364>>2]|0){if(m){o=0;p=0;q=0;r=0;s=0;t=0;v=0;w=0;x=0;y=0;z=0;A=0;B=0;C=0;D=0;E=0;break}else F=0;while(1){b[e+(f[(f[a+296+(F<<2)>>2]|0)+24>>2]|0)>>0]=1;F=F+1|0;if((F|0)==(i|0)){o=0;p=0;q=0;r=0;s=0;t=0;v=0;w=0;x=0;y=0;z=0;A=0;B=0;C=0;D=0;E=0;break a}}}if(!(f[a+372>>2]|0))G=0;else{if(m){o=0;p=0;q=0;r=0;s=0;t=0;v=0;w=0;x=0;y=0;z=0;A=0;B=0;C=0;D=0;E=0;break}else H=0;while(1){b[e+(f[(f[a+296+(H<<2)>>2]|0)+24>>2]|0)>>0]=1;H=H+1|0;if((H|0)==(i|0)){o=0;p=0;q=0;r=0;s=0;t=0;v=0;w=0;x=0;y=0;z=0;A=0;B=0;C=0;D=0;E=0;break a}}}do{l=f[a+296+(G<<2)>>2]|0;b[d+(f[l+20>>2]|0)>>0]=1;if(!m)b[e+(f[l+24>>2]|0)>>0]=1;G=G+1|0}while((G|0)!=(i|0));o=b[d>>0]|0;p=b[d+1>>0]|0;q=b[d+2>>0]|0;r=b[d+3>>0]|0;s=b[d+4>>0]|0;t=b[d+5>>0]|0;v=b[d+6>>0]|0;w=b[d+7>>0]|0;x=b[d+8>>0]|0;y=b[d+9>>0]|0;z=b[d+10>>0]|0;A=b[d+11>>0]|0;B=b[d+12>>0]|0;C=b[d+13>>0]|0;D=b[d+14>>0]|0;E=b[d+15>>0]|0}else{o=0;p=0;q=0;r=0;s=0;t=0;v=0;w=0;x=0;y=0;z=0;A=0;B=0;C=0;D=0;E=0}while(0);i=(A<<24>>24)+(B<<24>>24)+(z<<24>>24)+(y<<24>>24)+(x<<24>>24)+(w<<24>>24)+(v<<24>>24)+(t<<24>>24)+(s<<24>>24)+(r<<24>>24)+(q<<24>>24)+(p<<24>>24)+(o<<24>>24)+(b[e>>0]|0)+(b[e+1>>0]|0)+(b[e+2>>0]|0)+(b[e+3>>0]|0)+(b[e+4>>0]|0)+(b[e+5>>0]|0)+(b[e+6>>0]|0)+(b[e+7>>0]|0)+(b[e+8>>0]|0)+(b[e+9>>0]|0)+(b[e+10>>0]|0)+(b[e+11>>0]|0)+(b[e+12>>0]|0)+(C<<24>>24)+(b[e+13>>0]|0)+(D<<24>>24)+(b[e+14>>0]|0)+(E<<24>>24)+(b[e+15>>0]|0)|0;if(i|0){E=a+24|0;D=f[E>>2]|0;C=f[D>>2]|0;f[D>>2]=C+1;b[C>>0]=-1;C=D+4|0;o=(f[C>>2]|0)+-1|0;f[C>>2]=o;if((o|0)==0?(mi[f[D+12>>2]&255](a)|0)==0:0){D=f[a>>2]|0;f[D+20>>2]=25;ki[f[D>>2]&2047](a)}D=f[E>>2]|0;o=f[D>>2]|0;f[D>>2]=o+1;b[o>>0]=-52;o=D+4|0;C=(f[o>>2]|0)+-1|0;f[o>>2]=C;if((C|0)==0?(mi[f[D+12>>2]&255](a)|0)==0:0){D=f[a>>2]|0;f[D+20>>2]=25;ki[f[D>>2]&2047](a)}D=(i<<1)+2|0;i=f[E>>2]|0;C=f[i>>2]|0;f[i>>2]=C+1;b[C>>0]=D>>>8;C=i+4|0;o=(f[C>>2]|0)+-1|0;f[C>>2]=o;if((o|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=f[E>>2]|0;o=f[i>>2]|0;f[i>>2]=o+1;b[o>>0]=D;D=i+4|0;o=(f[D>>2]|0)+-1|0;f[D>>2]=o;if((o|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=0;do{if(b[d+i>>0]|0){o=f[E>>2]|0;D=f[o>>2]|0;f[o>>2]=D+1;b[D>>0]=i;D=o+4|0;C=(f[D>>2]|0)+-1|0;f[D>>2]=C;if((C|0)==0?(mi[f[o+12>>2]&255](a)|0)==0:0){o=f[a>>2]|0;f[o+20>>2]=25;ki[f[o>>2]&2047](a)}o=f[E>>2]|0;C=(h[a+168+i>>0]<<4)+(h[a+152+i>>0]|0)&255;D=f[o>>2]|0;f[o>>2]=D+1;b[D>>0]=C;C=o+4|0;D=(f[C>>2]|0)+-1|0;f[C>>2]=D;if((D|0)==0?(mi[f[o+12>>2]&255](a)|0)==0:0){o=f[a>>2]|0;f[o+20>>2]=25;ki[f[o>>2]&2047](a)}}if(b[e+i>>0]|0){o=f[E>>2]|0;D=f[o>>2]|0;f[o>>2]=D+1;b[D>>0]=i+16;D=o+4|0;C=(f[D>>2]|0)+-1|0;f[D>>2]=C;if((C|0)==0?(mi[f[o+12>>2]&255](a)|0)==0:0){o=f[a>>2]|0;f[o+20>>2]=25;ki[f[o>>2]&2047](a)}o=b[a+184+i>>0]|0;C=f[E>>2]|0;D=f[C>>2]|0;f[C>>2]=D+1;b[D>>0]=o;o=C+4|0;D=(f[o>>2]|0)+-1|0;f[o>>2]=D;if((D|0)==0?(mi[f[C+12>>2]&255](a)|0)==0:0){C=f[a>>2]|0;f[C+20>>2]=25;ki[f[C>>2]&2047](a)}}i=i+1|0}while((i|0)!=16)}}i=a+236|0;E=g+28|0;g=a+24|0;if((f[i>>2]|0)!=(f[E>>2]|0)){e=f[g>>2]|0;d=f[e>>2]|0;f[e>>2]=d+1;b[d>>0]=-1;d=e+4|0;C=(f[d>>2]|0)+-1|0;f[d>>2]=C;if((C|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}e=f[g>>2]|0;C=f[e>>2]|0;f[e>>2]=C+1;b[C>>0]=-35;C=e+4|0;d=(f[C>>2]|0)+-1|0;f[C>>2]=d;if((d|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}e=f[g>>2]|0;d=f[e>>2]|0;f[e>>2]=d+1;b[d>>0]=0;d=e+4|0;C=(f[d>>2]|0)+-1|0;f[d>>2]=C;if((C|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}e=f[g>>2]|0;C=f[e>>2]|0;f[e>>2]=C+1;b[C>>0]=4;C=e+4|0;d=(f[C>>2]|0)+-1|0;f[C>>2]=d;if((d|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}e=f[i>>2]|0;d=f[g>>2]|0;C=f[d>>2]|0;f[d>>2]=C+1;b[C>>0]=e>>>8;C=d+4|0;D=(f[C>>2]|0)+-1|0;f[C>>2]=D;if((D|0)==0?(mi[f[d+12>>2]&255](a)|0)==0:0){d=f[a>>2]|0;f[d+20>>2]=25;ki[f[d>>2]&2047](a)}d=f[g>>2]|0;D=f[d>>2]|0;f[d>>2]=D+1;b[D>>0]=e;e=d+4|0;D=(f[e>>2]|0)+-1|0;f[e>>2]=D;if((D|0)==0?(mi[f[d+12>>2]&255](a)|0)==0:0){d=f[a>>2]|0;f[d+20>>2]=25;ki[f[d>>2]&2047](a)}f[E>>2]=f[i>>2]}i=f[g>>2]|0;E=f[i>>2]|0;f[i>>2]=E+1;b[E>>0]=-1;E=i+4|0;d=(f[E>>2]|0)+-1|0;f[E>>2]=d;if((d|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=f[g>>2]|0;d=f[i>>2]|0;f[i>>2]=d+1;b[d>>0]=-38;d=i+4|0;E=(f[d>>2]|0)+-1|0;f[d>>2]=E;if((E|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=a+292|0;E=(f[i>>2]<<1)+6|0;d=f[g>>2]|0;D=f[d>>2]|0;f[d>>2]=D+1;b[D>>0]=E>>>8;D=d+4|0;e=(f[D>>2]|0)+-1|0;f[D>>2]=e;if((e|0)==0?(mi[f[d+12>>2]&255](a)|0)==0:0){d=f[a>>2]|0;f[d+20>>2]=25;ki[f[d>>2]&2047](a)}d=f[g>>2]|0;e=f[d>>2]|0;f[d>>2]=e+1;b[e>>0]=E;E=d+4|0;e=(f[E>>2]|0)+-1|0;f[E>>2]=e;if((e|0)==0?(mi[f[d+12>>2]&255](a)|0)==0:0){d=f[a>>2]|0;f[d+20>>2]=25;ki[f[d>>2]&2047](a)}d=f[g>>2]|0;e=f[i>>2]&255;E=f[d>>2]|0;f[d>>2]=E+1;b[E>>0]=e;e=d+4|0;E=(f[e>>2]|0)+-1|0;f[e>>2]=E;if((E|0)==0?(mi[f[d+12>>2]&255](a)|0)==0:0){d=f[a>>2]|0;f[d+20>>2]=25;ki[f[d>>2]&2047](a)}if((f[i>>2]|0)>0){d=a+364|0;E=a+372|0;e=a+368|0;D=0;do{C=f[a+296+(D<<2)>>2]|0;o=f[g>>2]|0;p=f[C>>2]&255;q=f[o>>2]|0;f[o>>2]=q+1;b[q>>0]=p;p=o+4|0;q=(f[p>>2]|0)+-1|0;f[p>>2]=q;if((q|0)==0?(mi[f[o+12>>2]&255](a)|0)==0:0){o=f[a>>2]|0;f[o+20>>2]=25;ki[f[o>>2]&2047](a)}if((f[d>>2]|0)==0?(f[E>>2]|0)==0:0)I=f[C+20>>2]|0;else I=0;if(!(f[e>>2]|0))J=0;else J=f[C+24>>2]|0;C=f[g>>2]|0;o=f[C>>2]|0;f[C>>2]=o+1;b[o>>0]=J+(I<<4);o=C+4|0;q=(f[o>>2]|0)+-1|0;f[o>>2]=q;if((q|0)==0?(mi[f[C+12>>2]&255](a)|0)==0:0){C=f[a>>2]|0;f[C+20>>2]=25;ki[f[C>>2]&2047](a)}D=D+1|0}while((D|0)<(f[i>>2]|0));K=d}else K=a+364|0;d=f[g>>2]|0;i=f[K>>2]&255;K=f[d>>2]|0;f[d>>2]=K+1;b[K>>0]=i;i=d+4|0;K=(f[i>>2]|0)+-1|0;f[i>>2]=K;if((K|0)==0?(mi[f[d+12>>2]&255](a)|0)==0:0){d=f[a>>2]|0;f[d+20>>2]=25;ki[f[d>>2]&2047](a)}d=f[g>>2]|0;K=f[a+368>>2]&255;i=f[d>>2]|0;f[d>>2]=i+1;b[i>>0]=K;K=d+4|0;i=(f[K>>2]|0)+-1|0;f[K>>2]=i;if((i|0)==0?(mi[f[d+12>>2]&255](a)|0)==0:0){d=f[a>>2]|0;f[d+20>>2]=25;ki[f[d>>2]&2047](a)}d=f[g>>2]|0;g=(f[a+372>>2]<<4)+(f[a+376>>2]|0)&255;i=f[d>>2]|0;f[d>>2]=i+1;b[i>>0]=g;g=d+4|0;i=(f[g>>2]|0)+-1|0;f[g>>2]=i;if(i|0){u=c;return}if(mi[f[d+12>>2]&255](a)|0){u=c;return}d=f[a>>2]|0;f[d+20>>2]=25;ki[f[d>>2]&2047](a);u=c;return}function qEa(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+24|0;d=f[c>>2]|0;e=f[d>>2]|0;f[d>>2]=e+1;b[e>>0]=-1;e=d+4|0;g=(f[e>>2]|0)+-1|0;f[e>>2]=g;if((g|0)==0?(mi[f[d+12>>2]&255](a)|0)==0:0){d=f[a>>2]|0;f[d+20>>2]=25;ki[f[d>>2]&2047](a)}d=f[c>>2]|0;c=f[d>>2]|0;f[d>>2]=c+1;b[c>>0]=-39;c=d+4|0;g=(f[c>>2]|0)+-1|0;f[c>>2]=g;if(g|0)return;if(mi[f[d+12>>2]&255](a)|0)return;d=f[a>>2]|0;f[d+20>>2]=25;ki[f[d>>2]&2047](a);return}function rEa(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+24|0;d=f[c>>2]|0;e=f[d>>2]|0;f[d>>2]=e+1;b[e>>0]=-1;e=d+4|0;g=(f[e>>2]|0)+-1|0;f[e>>2]=g;if((g|0)==0?(mi[f[d+12>>2]&255](a)|0)==0:0){d=f[a>>2]|0;f[d+20>>2]=25;ki[f[d>>2]&2047](a)}d=f[c>>2]|0;g=f[d>>2]|0;f[d>>2]=g+1;b[g>>0]=-40;g=d+4|0;e=(f[g>>2]|0)+-1|0;f[g>>2]=e;if((e|0)==0?(mi[f[d+12>>2]&255](a)|0)==0:0){d=f[a>>2]|0;f[d+20>>2]=25;ki[f[d>>2]&2047](a)}if(f[a+88>>2]|0)uEa(a,0)|0;if(f[a+92>>2]|0)uEa(a,1)|0;if(f[a+96>>2]|0)uEa(a,2)|0;if(f[a+100>>2]|0)uEa(a,3)|0;if(!(f[a+212>>2]|0)){if(f[a+120>>2]|0)vEa(a,0,0);if(f[a+136>>2]|0)vEa(a,0,1);if(f[a+124>>2]|0)vEa(a,1,0);if(f[a+140>>2]|0)vEa(a,1,1);if(f[a+128>>2]|0)vEa(a,2,0);if(f[a+144>>2]|0)vEa(a,2,1);if(f[a+132>>2]|0)vEa(a,3,0);if(f[a+148>>2]|0)vEa(a,3,1)}d=f[c>>2]|0;e=f[d>>2]|0;f[d>>2]=e+1;b[e>>0]=-1;e=d+4|0;g=(f[e>>2]|0)+-1|0;f[e>>2]=g;if((g|0)==0?(mi[f[d+12>>2]&255](a)|0)==0:0){d=f[a>>2]|0;f[d+20>>2]=25;ki[f[d>>2]&2047](a)}d=f[c>>2]|0;c=f[d>>2]|0;f[d>>2]=c+1;b[c>>0]=-39;c=d+4|0;g=(f[c>>2]|0)+-1|0;f[c>>2]=g;if(g|0)return;if(mi[f[d+12>>2]&255](a)|0)return;d=f[a>>2]|0;f[d+20>>2]=25;ki[f[d>>2]&2047](a);return}function sEa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;if(d>>>0>65533){e=f[a>>2]|0;f[e+20>>2]=12;ki[f[e>>2]&2047](a)}e=a+24|0;g=f[e>>2]|0;h=f[g>>2]|0;f[g>>2]=h+1;b[h>>0]=-1;h=g+4|0;i=(f[h>>2]|0)+-1|0;f[h>>2]=i;if((i|0)==0?(mi[f[g+12>>2]&255](a)|0)==0:0){g=f[a>>2]|0;f[g+20>>2]=25;ki[f[g>>2]&2047](a)}g=f[e>>2]|0;i=f[g>>2]|0;f[g>>2]=i+1;b[i>>0]=c;c=g+4|0;i=(f[c>>2]|0)+-1|0;f[c>>2]=i;if((i|0)==0?(mi[f[g+12>>2]&255](a)|0)==0:0){g=f[a>>2]|0;f[g+20>>2]=25;ki[f[g>>2]&2047](a)}g=d+2|0;d=f[e>>2]|0;i=f[d>>2]|0;f[d>>2]=i+1;b[i>>0]=g>>>8;i=d+4|0;c=(f[i>>2]|0)+-1|0;f[i>>2]=c;if((c|0)==0?(mi[f[d+12>>2]&255](a)|0)==0:0){d=f[a>>2]|0;f[d+20>>2]=25;ki[f[d>>2]&2047](a)}d=f[e>>2]|0;e=f[d>>2]|0;f[d>>2]=e+1;b[e>>0]=g;g=d+4|0;e=(f[g>>2]|0)+-1|0;f[g>>2]=e;if(e|0)return;if(mi[f[d+12>>2]&255](a)|0)return;d=f[a>>2]|0;f[d+20>>2]=25;ki[f[d>>2]&2047](a);return}function tEa(a,c){a=a|0;c=c|0;var d=0,e=0;d=f[a+24>>2]|0;e=f[d>>2]|0;f[d>>2]=e+1;b[e>>0]=c;c=d+4|0;e=(f[c>>2]|0)+-1|0;f[c>>2]=e;if(e|0)return;if(mi[f[d+12>>2]&255](a)|0)return;d=f[a>>2]|0;f[d+20>>2]=25;ki[f[d>>2]&2047](a);return}function uEa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=f[a+88+(c<<2)>>2]|0;if(!e){g=f[a>>2]|0;f[g+20>>2]=54;f[g+24>>2]=c;ki[f[g>>2]&2047](a)}g=a+388|0;h=f[g>>2]|0;if((h|0)<0)i=0;else{k=f[a+384>>2]|0;l=0;m=0;while(1){n=(j[e+(f[k+(l<<2)>>2]<<1)>>1]|0)>255?1:m;if((l|0)<(h|0)){l=l+1|0;m=n}else{i=n;break}}}m=e+128|0;if(f[m>>2]|0)return i|0;l=a+24|0;h=f[l>>2]|0;k=f[h>>2]|0;f[h>>2]=k+1;b[k>>0]=-1;k=h+4|0;n=(f[k>>2]|0)+-1|0;f[k>>2]=n;if((n|0)==0?(mi[f[h+12>>2]&255](a)|0)==0:0){h=f[a>>2]|0;f[h+20>>2]=25;ki[f[h>>2]&2047](a)}h=f[l>>2]|0;n=f[h>>2]|0;f[h>>2]=n+1;b[n>>0]=-37;n=h+4|0;k=(f[n>>2]|0)+-1|0;f[n>>2]=k;if((k|0)==0?(mi[f[h+12>>2]&255](a)|0)==0:0){h=f[a>>2]|0;f[h+20>>2]=25;ki[f[h>>2]&2047](a)}h=(i|0)!=0;k=f[g>>2]|0;n=(h?(k<<1)+2|0:k+1|0)+3|0;k=f[l>>2]|0;o=f[k>>2]|0;f[k>>2]=o+1;b[o>>0]=n>>>8;o=k+4|0;p=(f[o>>2]|0)+-1|0;f[o>>2]=p;if((p|0)==0?(mi[f[k+12>>2]&255](a)|0)==0:0){k=f[a>>2]|0;f[k+20>>2]=25;ki[f[k>>2]&2047](a)}k=f[l>>2]|0;p=f[k>>2]|0;f[k>>2]=p+1;b[p>>0]=n;n=k+4|0;p=(f[n>>2]|0)+-1|0;f[n>>2]=p;if((p|0)==0?(mi[f[k+12>>2]&255](a)|0)==0:0){k=f[a>>2]|0;f[k+20>>2]=25;ki[f[k>>2]&2047](a)}k=f[l>>2]|0;p=f[k>>2]|0;f[k>>2]=p+1;b[p>>0]=(i<<4)+c;c=k+4|0;p=(f[c>>2]|0)+-1|0;f[c>>2]=p;if((p|0)==0?(mi[f[k+12>>2]&255](a)|0)==0:0){k=f[a>>2]|0;f[k+20>>2]=25;ki[f[k>>2]&2047](a)}a:do if((f[g>>2]|0)>=0){k=a+384|0;if(h)q=0;else{p=0;while(1){c=f[l>>2]|0;n=d[e+(f[(f[k>>2]|0)+(p<<2)>>2]<<1)>>1]&255;o=f[c>>2]|0;f[c>>2]=o+1;b[o>>0]=n;n=c+4|0;o=(f[n>>2]|0)+-1|0;f[n>>2]=o;if((o|0)==0?(mi[f[c+12>>2]&255](a)|0)==0:0){c=f[a>>2]|0;f[c+20>>2]=25;ki[f[c>>2]&2047](a)}if((p|0)<(f[g>>2]|0))p=p+1|0;else break a}}while(1){p=d[e+(f[(f[k>>2]|0)+(q<<2)>>2]<<1)>>1]|0;c=f[l>>2]|0;o=f[c>>2]|0;f[c>>2]=o+1;b[o>>0]=(p&65535)>>>8;o=c+4|0;n=(f[o>>2]|0)+-1|0;f[o>>2]=n;if((n|0)==0?(mi[f[c+12>>2]&255](a)|0)==0:0){c=f[a>>2]|0;f[c+20>>2]=25;ki[f[c>>2]&2047](a)}c=f[l>>2]|0;n=f[c>>2]|0;f[c>>2]=n+1;b[n>>0]=p;p=c+4|0;n=(f[p>>2]|0)+-1|0;f[p>>2]=n;if((n|0)==0?(mi[f[c+12>>2]&255](a)|0)==0:0){c=f[a>>2]|0;f[c+20>>2]=25;ki[f[c>>2]&2047](a)}if((q|0)<(f[g>>2]|0))q=q+1|0;else break}}while(0);f[m>>2]=1;return i|0}function vEa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0;e=(d|0)==0;d=e?c:c+16|0;g=f[(e?a+120+(c<<2)|0:a+136+(c<<2)|0)>>2]|0;if(!g){c=f[a>>2]|0;f[c+20>>2]=52;f[c+24>>2]=d;ki[f[c>>2]&2047](a)}c=g+276|0;if(f[c>>2]|0)return;e=a+24|0;i=f[e>>2]|0;j=f[i>>2]|0;f[i>>2]=j+1;b[j>>0]=-1;j=i+4|0;k=(f[j>>2]|0)+-1|0;f[j>>2]=k;if((k|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=f[e>>2]|0;k=f[i>>2]|0;f[i>>2]=k+1;b[k>>0]=-60;k=i+4|0;j=(f[k>>2]|0)+-1|0;f[k>>2]=j;if((j|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=(h[g+16>>0]|0)+((h[g+15>>0]|0)+((h[g+14>>0]|0)+((h[g+13>>0]|0)+((h[g+12>>0]|0)+((h[g+11>>0]|0)+((h[g+10>>0]|0)+((h[g+9>>0]|0)+((h[g+8>>0]|0)+((h[g+7>>0]|0)+((h[g+6>>0]|0)+((h[g+5>>0]|0)+((h[g+4>>0]|0)+((h[g+3>>0]|0)+((h[g+2>>0]|0)+(h[g+1>>0]|0)))))))))))))))|0;j=i+19|0;k=f[e>>2]|0;l=f[k>>2]|0;f[k>>2]=l+1;b[l>>0]=j>>>8;l=k+4|0;m=(f[l>>2]|0)+-1|0;f[l>>2]=m;if((m|0)==0?(mi[f[k+12>>2]&255](a)|0)==0:0){k=f[a>>2]|0;f[k+20>>2]=25;ki[f[k>>2]&2047](a)}k=f[e>>2]|0;m=f[k>>2]|0;f[k>>2]=m+1;b[m>>0]=j;j=k+4|0;m=(f[j>>2]|0)+-1|0;f[j>>2]=m;if((m|0)==0?(mi[f[k+12>>2]&255](a)|0)==0:0){k=f[a>>2]|0;f[k+20>>2]=25;ki[f[k>>2]&2047](a)}k=f[e>>2]|0;m=f[k>>2]|0;f[k>>2]=m+1;b[m>>0]=d;d=k+4|0;m=(f[d>>2]|0)+-1|0;f[d>>2]=m;if((m|0)==0?(mi[f[k+12>>2]&255](a)|0)==0:0){k=f[a>>2]|0;f[k+20>>2]=25;ki[f[k>>2]&2047](a)}k=1;do{m=b[g+k>>0]|0;d=f[e>>2]|0;j=f[d>>2]|0;f[d>>2]=j+1;b[j>>0]=m;m=d+4|0;j=(f[m>>2]|0)+-1|0;f[m>>2]=j;if((j|0)==0?(mi[f[d+12>>2]&255](a)|0)==0:0){d=f[a>>2]|0;f[d+20>>2]=25;ki[f[d>>2]&2047](a)}k=k+1|0}while((k|0)!=17);if((i|0)>0){k=0;do{d=b[g+17+k>>0]|0;j=f[e>>2]|0;m=f[j>>2]|0;f[j>>2]=m+1;b[m>>0]=d;d=j+4|0;m=(f[d>>2]|0)+-1|0;f[d>>2]=m;if((m|0)==0?(mi[f[j+12>>2]&255](a)|0)==0:0){j=f[a>>2]|0;f[j+20>>2]=25;ki[f[j>>2]&2047](a)}k=k+1|0}while((k|0)!=(i|0))}f[c>>2]=1;return}function wEa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+24|0;e=f[d>>2]|0;g=f[e>>2]|0;f[e>>2]=g+1;b[g>>0]=-1;g=e+4|0;h=(f[g>>2]|0)+-1|0;f[g>>2]=h;if((h|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}e=f[d>>2]|0;h=f[e>>2]|0;f[e>>2]=h+1;b[h>>0]=c;c=e+4|0;h=(f[c>>2]|0)+-1|0;f[c>>2]=h;if((h|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}e=a+76|0;h=((f[e>>2]|0)*3|0)+8|0;c=f[d>>2]|0;g=f[c>>2]|0;f[c>>2]=g+1;b[g>>0]=h>>>8;g=c+4|0;i=(f[g>>2]|0)+-1|0;f[g>>2]=i;if((i|0)==0?(mi[f[c+12>>2]&255](a)|0)==0:0){c=f[a>>2]|0;f[c+20>>2]=25;ki[f[c>>2]&2047](a)}c=f[d>>2]|0;i=f[c>>2]|0;f[c>>2]=i+1;b[i>>0]=h;h=c+4|0;i=(f[h>>2]|0)+-1|0;f[h>>2]=i;if((i|0)==0?(mi[f[c+12>>2]&255](a)|0)==0:0){c=f[a>>2]|0;f[c+20>>2]=25;ki[f[c>>2]&2047](a)}c=a+68|0;if(!((f[c>>2]|0)<=65535?(f[a+64>>2]|0)<=65535:0)){i=f[a>>2]|0;f[i+20>>2]=42;f[i+24>>2]=65535;ki[f[i>>2]&2047](a)}i=f[d>>2]|0;h=f[a+72>>2]&255;g=f[i>>2]|0;f[i>>2]=g+1;b[g>>0]=h;h=i+4|0;g=(f[h>>2]|0)+-1|0;f[h>>2]=g;if((g|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=f[c>>2]|0;c=f[d>>2]|0;g=f[c>>2]|0;f[c>>2]=g+1;b[g>>0]=i>>>8;g=c+4|0;h=(f[g>>2]|0)+-1|0;f[g>>2]=h;if((h|0)==0?(mi[f[c+12>>2]&255](a)|0)==0:0){c=f[a>>2]|0;f[c+20>>2]=25;ki[f[c>>2]&2047](a)}c=f[d>>2]|0;h=f[c>>2]|0;f[c>>2]=h+1;b[h>>0]=i;i=c+4|0;h=(f[i>>2]|0)+-1|0;f[i>>2]=h;if((h|0)==0?(mi[f[c+12>>2]&255](a)|0)==0:0){c=f[a>>2]|0;f[c+20>>2]=25;ki[f[c>>2]&2047](a)}c=f[a+64>>2]|0;h=f[d>>2]|0;i=f[h>>2]|0;f[h>>2]=i+1;b[i>>0]=c>>>8;i=h+4|0;g=(f[i>>2]|0)+-1|0;f[i>>2]=g;if((g|0)==0?(mi[f[h+12>>2]&255](a)|0)==0:0){h=f[a>>2]|0;f[h+20>>2]=25;ki[f[h>>2]&2047](a)}h=f[d>>2]|0;g=f[h>>2]|0;f[h>>2]=g+1;b[g>>0]=c;c=h+4|0;g=(f[c>>2]|0)+-1|0;f[c>>2]=g;if((g|0)==0?(mi[f[h+12>>2]&255](a)|0)==0:0){h=f[a>>2]|0;f[h+20>>2]=25;ki[f[h>>2]&2047](a)}h=f[d>>2]|0;g=f[e>>2]&255;c=f[h>>2]|0;f[h>>2]=c+1;b[c>>0]=g;g=h+4|0;c=(f[g>>2]|0)+-1|0;f[g>>2]=c;if((c|0)==0?(mi[f[h+12>>2]&255](a)|0)==0:0){h=f[a>>2]|0;f[h+20>>2]=25;ki[f[h>>2]&2047](a)}if((f[e>>2]|0)<=0)return;h=0;c=f[a+84>>2]|0;while(1){g=f[d>>2]|0;i=f[c>>2]&255;j=f[g>>2]|0;f[g>>2]=j+1;b[j>>0]=i;i=g+4|0;j=(f[i>>2]|0)+-1|0;f[i>>2]=j;if((j|0)==0?(mi[f[g+12>>2]&255](a)|0)==0:0){g=f[a>>2]|0;f[g+20>>2]=25;ki[f[g>>2]&2047](a)}g=f[d>>2]|0;j=(f[c+8>>2]<<4)+(f[c+12>>2]|0)&255;i=f[g>>2]|0;f[g>>2]=i+1;b[i>>0]=j;j=g+4|0;i=(f[j>>2]|0)+-1|0;f[j>>2]=i;if((i|0)==0?(mi[f[g+12>>2]&255](a)|0)==0:0){g=f[a>>2]|0;f[g+20>>2]=25;ki[f[g>>2]&2047](a)}g=f[d>>2]|0;i=f[c+16>>2]&255;j=f[g>>2]|0;f[g>>2]=j+1;b[j>>0]=i;i=g+4|0;j=(f[i>>2]|0)+-1|0;f[i>>2]=j;if((j|0)==0?(mi[f[g+12>>2]&255](a)|0)==0:0){g=f[a>>2]|0;f[g+20>>2]=25;ki[f[g>>2]&2047](a)}h=h+1|0;if((h|0)>=(f[e>>2]|0))break;else c=c+88|0}return}function xEa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=a+28|0;if(!((f[b>>2]|0)>>>0<=16777215?(f[a+32>>2]|0)>>>0<=16777215:0)){c=f[a>>2]|0;f[c+20>>2]=42;f[c+24>>2]=65500;ki[f[c>>2]&2047](a)}c=f[a+56>>2]|0;d=a+380|0;e=f[d>>2]|0;g=Y(e,f[a+60>>2]|0)|0;do if(c>>>0<g>>>0){if(c<<1>>>0>=g>>>0){h=QGa(Y(f[b>>2]|0,e)|0,2)|0;f[a+64>>2]=h;i=2;j=QGa(Y(f[d>>2]|0,f[a+32>>2]|0)|0,2)|0;break}if((c*3|0)>>>0>=g>>>0){h=QGa(Y(f[b>>2]|0,e)|0,3)|0;f[a+64>>2]=h;i=3;j=QGa(Y(f[d>>2]|0,f[a+32>>2]|0)|0,3)|0;break}if(c<<2>>>0>=g>>>0){h=QGa(Y(f[b>>2]|0,e)|0,4)|0;f[a+64>>2]=h;i=4;j=QGa(Y(f[d>>2]|0,f[a+32>>2]|0)|0,4)|0;break}if((c*5|0)>>>0>=g>>>0){h=QGa(Y(f[b>>2]|0,e)|0,5)|0;f[a+64>>2]=h;i=5;j=QGa(Y(f[d>>2]|0,f[a+32>>2]|0)|0,5)|0;break}h=f[b>>2]|0;if((c*6|0)>>>0>=g>>>0){k=QGa(Y(h,e)|0,6)|0;f[a+64>>2]=k;i=6;j=QGa(Y(f[d>>2]|0,f[a+32>>2]|0)|0,6)|0;break}k=Y(h,e)|0;if((c*7|0)>>>0>=g>>>0){h=QGa(k,7)|0;f[a+64>>2]=h;i=7;j=QGa(Y(f[d>>2]|0,f[a+32>>2]|0)|0,7)|0;break}if(c<<3>>>0>=g>>>0){h=QGa(k,8)|0;f[a+64>>2]=h;i=8;j=QGa(Y(f[d>>2]|0,f[a+32>>2]|0)|0,8)|0;break}if((c*9|0)>>>0>=g>>>0){h=QGa(k,9)|0;f[a+64>>2]=h;i=9;j=QGa(Y(f[d>>2]|0,f[a+32>>2]|0)|0,9)|0;break}if((c*10|0)>>>0>=g>>>0){h=QGa(k,10)|0;f[a+64>>2]=h;i=10;j=QGa(Y(f[d>>2]|0,f[a+32>>2]|0)|0,10)|0;break}if((c*11|0)>>>0>=g>>>0){h=QGa(k,11)|0;f[a+64>>2]=h;i=11;j=QGa(Y(f[d>>2]|0,f[a+32>>2]|0)|0,11)|0;break}if((c*12|0)>>>0>=g>>>0){h=QGa(k,12)|0;f[a+64>>2]=h;i=12;j=QGa(Y(f[d>>2]|0,f[a+32>>2]|0)|0,12)|0;break}if((c*13|0)>>>0>=g>>>0){h=QGa(k,13)|0;f[a+64>>2]=h;i=13;j=QGa(Y(f[d>>2]|0,f[a+32>>2]|0)|0,13)|0;break}if((c*14|0)>>>0>=g>>>0){h=QGa(k,14)|0;f[a+64>>2]=h;i=14;j=QGa(Y(f[d>>2]|0,f[a+32>>2]|0)|0,14)|0;break}if((c*15|0)>>>0<g>>>0){h=QGa(k,16)|0;f[a+64>>2]=h;i=16;j=QGa(Y(f[d>>2]|0,f[a+32>>2]|0)|0,16)|0;break}else{h=QGa(k,15)|0;f[a+64>>2]=h;i=15;j=QGa(Y(f[d>>2]|0,f[a+32>>2]|0)|0,15)|0;break}}else{h=Y(f[b>>2]|0,e)|0;f[a+64>>2]=h;i=1;j=Y(f[a+32>>2]|0,e)|0}while(0);f[a+68>>2]=j;f[a+280>>2]=i;f[a+284>>2]=i;return}function yEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;c=u;u=u+2608|0;d=c+2560|0;e=c;g=ui[f[f[a+4>>2]>>2]&127](a,1,36)|0;f[a+392>>2]=g;f[g>>2]=977;f[g+4>>2]=978;f[g+8>>2]=979;f[g+16>>2]=0;h=(b|0)==0;if(h){xEa(a);b=a+380|0;i=f[b>>2]|0;j=b}else{b=a+280|0;k=f[b>>2]|0;l=a+284|0;if((k|0)==(f[l>>2]|0))m=k;else{n=f[a>>2]|0;f[n+20>>2]=7;f[n+24>>2]=k;f[n+28>>2]=f[l>>2];ki[f[n>>2]&2047](a);m=f[b>>2]|0}b=a+380|0;f[b>>2]=m;i=m;j=b}if((i+-1|0)>>>0>15){b=f[a>>2]|0;f[b+20>>2]=7;f[b+24>>2]=i;f[b+28>>2]=f[j>>2];ki[f[b>>2]&2047](a);o=f[j>>2]|0}else o=i;switch(o|0){case 2:{p=121448;break}case 3:{p=121348;break}case 4:{p=121220;break}case 5:{p=121056;break}case 6:{p=120848;break}case 7:{p=120588;break}default:p=120268}f[a+384>>2]=p;p=f[j>>2]|0;o=(Y(p,p)|0)+-1|0;i=a+388|0;f[i>>2]=(p|0)<8?o:63;o=a+68|0;p=f[o>>2]|0;if((((p|0)!=0?(f[a+64>>2]|0)!=0:0)?(f[a+76>>2]|0)>=1:0)?(f[a+36>>2]|0)>=1:0)q=p;else{p=f[a>>2]|0;f[p+20>>2]=33;ki[f[p>>2]&2047](a);q=f[o>>2]|0}if(!((q|0)<=65500?(f[a+64>>2]|0)<=65500:0)){q=f[a>>2]|0;f[q+20>>2]=42;f[q+24>>2]=65500;ki[f[q>>2]&2047](a)}q=f[a+72>>2]|0;if((q|0)!=8){p=f[a>>2]|0;f[p+20>>2]=16;f[p+24>>2]=q;ki[f[p>>2]&2047](a)}p=a+76|0;q=f[p>>2]|0;if((q|0)>10){b=f[a>>2]|0;f[b+20>>2]=27;f[b+24>>2]=q;f[b+28>>2]=10;ki[f[b>>2]&2047](a);r=f[p>>2]|0}else r=q;q=a+272|0;f[q>>2]=1;b=a+276|0;f[b>>2]=1;m=a+84|0;if((r|0)>0){n=r;r=1;l=1;k=0;s=f[m>>2]|0;while(1){t=s+8|0;v=f[t>>2]|0;w=s+12|0;if((v+-1|0)>>>0<=3?((f[w>>2]|0)+-1|0)>>>0<=3:0){x=l;y=v;z=r;A=n}else{v=f[a>>2]|0;f[v+20>>2]=19;ki[f[v>>2]&2047](a);x=f[q>>2]|0;y=f[t>>2]|0;z=f[b>>2]|0;A=f[p>>2]|0}l=(x|0)>(y|0)?x:y;f[q>>2]=l;t=f[w>>2]|0;r=(z|0)>(t|0)?z:t;f[b>>2]=r;k=k+1|0;if((k|0)>=(A|0))break;else{n=A;s=s+88|0}}if((A|0)>0){A=a+280|0;s=a+224|0;n=a+284|0;k=a+64|0;z=0;l=f[m>>2]|0;while(1){f[l+4>>2]=z;m=f[A>>2]|0;y=f[s>>2]|0?8:4;a:do if((m|0)>(y|0))B=m;else{x=f[q>>2]|0;t=f[l+8>>2]|0;w=m;v=1;while(1){v=v<<1;if((x|0)%(Y(v,t)|0)|0|0){B=w;break a}C=Y(v,m)|0;if((C|0)>(y|0)){B=C;break}else w=C}}while(0);m=l+36|0;f[m>>2]=B;w=f[n>>2]|0;b:do if((w|0)>(y|0))D=w;else{v=f[b>>2]|0;t=f[l+12>>2]|0;x=w;C=1;while(1){C=C<<1;if((v|0)%(Y(C,t)|0)|0|0){D=x;break b}E=Y(C,w)|0;if((E|0)>(y|0)){D=E;break}else x=E}}while(0);y=l+40|0;f[y>>2]=D;w=D<<1;if((B|0)<=(w|0)){x=B<<1;if((D|0)>(x|0))f[y>>2]=x}else f[m>>2]=w;w=l+8|0;x=Y(f[w>>2]|0,f[k>>2]|0)|0;C=QGa(x,Y(f[j>>2]|0,f[q>>2]|0)|0)|0;f[l+28>>2]=C;C=l+12|0;x=Y(f[C>>2]|0,f[o>>2]|0)|0;t=QGa(x,Y(f[j>>2]|0,f[b>>2]|0)|0)|0;f[l+32>>2]=t;t=Y(Y(f[w>>2]|0,f[k>>2]|0)|0,f[m>>2]|0)|0;w=QGa(t,Y(f[j>>2]|0,f[q>>2]|0)|0)|0;f[l+44>>2]=w;w=Y(Y(f[C>>2]|0,f[o>>2]|0)|0,f[y>>2]|0)|0;y=QGa(w,Y(f[j>>2]|0,f[b>>2]|0)|0)|0;f[l+48>>2]=y;f[l+52>>2]=1;z=z+1|0;if((z|0)>=(f[p>>2]|0))break;else l=l+88|0}F=f[b>>2]|0}else F=r}else F=1;r=QGa(f[o>>2]|0,Y(f[j>>2]|0,F)|0)|0;f[a+288>>2]=r;r=a+204|0;F=f[r>>2]|0;if(F){j=a+200|0;if((f[j>>2]|0)<1){o=f[a>>2]|0;f[o+20>>2]=20;f[o+24>>2]=0;ki[f[o>>2]&2047](a);G=f[r>>2]|0}else G=F;if((f[G+20>>2]|0)==0?(f[G+24>>2]|0)==63:0){f[a+268>>2]=0;F=f[p>>2]|0;if((F|0)>0){F1a(d|0,0,F<<2|0)|0;H=F;I=0}else{H=F;I=0}}else{f[a+268>>2]=1;F=f[p>>2]|0;if((F|0)>0){F1a(e|0,-1,F<<8|0)|0;H=F;I=1}else{H=F;I=1}}if((f[j>>2]|0)<1){J=I;K=H}else{H=a+268|0;I=1;F=G;while(1){G=f[F>>2]|0;if((G+-1|0)>>>0>3?(o=f[a>>2]|0,f[o+20>>2]=27,f[o+24>>2]=G,f[o+28>>2]=4,ki[f[o>>2]&2047](a),(G|0)<=0):0)L=0;else{M=0;N=62}if((N|0)==62)while(1){N=0;o=f[F+4+(M<<2)>>2]|0;if(!((o|0)>=0?(o|0)<(f[p>>2]|0):0)){b=f[a>>2]|0;f[b+20>>2]=20;f[b+24>>2]=I;ki[f[b>>2]&2047](a)}do if((M|0)>0){if((o|0)>(f[F+4+(M+-1<<2)>>2]|0))break;b=f[a>>2]|0;f[b+20>>2]=20;f[b+24>>2]=I;ki[f[b>>2]&2047](a)}while(0);M=M+1|0;if((M|0)==(G|0)){L=1;break}else N=62}m=f[F+20>>2]|0;o=f[F+24>>2]|0;b=f[F+28>>2]|0;l=f[F+32>>2]|0;c:do if(!(f[H>>2]|0)){if((o|0)!=63|(b|m|l|0)!=0){z=f[a>>2]|0;f[z+20>>2]=18;f[z+24>>2]=I;ki[f[z>>2]&2047](a)}if(L){z=0;do{q=d+(f[F+4+(z<<2)>>2]<<2)|0;if(f[q>>2]|0){k=f[a>>2]|0;f[k+20>>2]=20;f[k+24>>2]=I;ki[f[k>>2]&2047](a)}f[q>>2]=1;z=z+1|0}while((z|0)!=(G|0))}}else{if(!(m>>>0<=63?!(l>>>0>10|(b>>>0>10|((o|0)<(m|0)|(o|0)>63))):0)){z=f[a>>2]|0;f[z+20>>2]=18;f[z+24>>2]=I;ki[f[z>>2]&2047](a)}z=(m|0)==0;do if(z){if(!o)break;q=f[a>>2]|0;f[q+20>>2]=18;f[q+24>>2]=I;ki[f[q>>2]&2047](a)}else{if((G|0)==1)break;q=f[a>>2]|0;f[q+20>>2]=18;f[q+24>>2]=I;ki[f[q>>2]&2047](a)}while(0);if(L){q=(b|0)==0;k=(l|0)==(b+-1|0);if(z){D=o+1|0;B=(o|0)<0;n=0;while(1){s=f[F+4+(n<<2)>>2]|0;d:do if(!B){if(!k){if(q)O=0;else{A=0;while(1){y=f[a>>2]|0;f[y+20>>2]=18;f[y+24>>2]=I;ki[f[y>>2]&2047](a);f[e+(s<<8)+(A<<2)>>2]=l;A=A+1|0;if((A|0)==(D|0))break d}}while(1){A=e+(s<<8)+(O<<2)|0;if((f[A>>2]|0)>=0){y=f[a>>2]|0;f[y+20>>2]=18;f[y+24>>2]=I;ki[f[y>>2]&2047](a)}f[A>>2]=l;O=O+1|0;if((O|0)==(D|0))break d}}if(q){A=0;while(1){y=e+(s<<8)+(A<<2)|0;if((f[y>>2]|0)>=1){w=f[a>>2]|0;f[w+20>>2]=18;f[w+24>>2]=I;ki[f[w>>2]&2047](a)}f[y>>2]=l;A=A+1|0;if((A|0)==(D|0))break d}}else P=0;do{A=e+(s<<8)+(P<<2)|0;y=f[A>>2]|0;do if((y|0)<0){w=f[a>>2]|0;f[w+20>>2]=18;f[w+24>>2]=I;ki[f[w>>2]&2047](a)}else{if((b|0)==(y|0))break;w=f[a>>2]|0;f[w+20>>2]=18;f[w+24>>2]=I;ki[f[w>>2]&2047](a)}while(0);f[A>>2]=l;P=P+1|0}while((P|0)!=(D|0))}while(0);n=n+1|0;if((n|0)==(G|0))break c}}n=(m|0)>(o|0);D=0;do{B=f[F+4+(D<<2)>>2]|0;if((f[e+(B<<8)>>2]|0)<0){z=f[a>>2]|0;f[z+20>>2]=18;f[z+24>>2]=I;ki[f[z>>2]&2047](a)}e:do if(!n){if(!k){if(q)Q=m;else{z=m;while(1){s=f[a>>2]|0;f[s+20>>2]=18;f[s+24>>2]=I;ki[f[s>>2]&2047](a);f[e+(B<<8)+(z<<2)>>2]=l;if((z|0)<(o|0))z=z+1|0;else break e}}while(1){z=e+(B<<8)+(Q<<2)|0;if((f[z>>2]|0)>=0){s=f[a>>2]|0;f[s+20>>2]=18;f[s+24>>2]=I;ki[f[s>>2]&2047](a)}f[z>>2]=l;if((Q|0)<(o|0))Q=Q+1|0;else break e}}if(q){z=m;while(1){s=e+(B<<8)+(z<<2)|0;if((f[s>>2]|0)>=1){y=f[a>>2]|0;f[y+20>>2]=18;f[y+24>>2]=I;ki[f[y>>2]&2047](a)}f[s>>2]=l;if((z|0)<(o|0))z=z+1|0;else break e}}else R=m;while(1){z=e+(B<<8)+(R<<2)|0;s=f[z>>2]|0;do if((s|0)<0){y=f[a>>2]|0;f[y+20>>2]=18;f[y+24>>2]=I;ki[f[y>>2]&2047](a)}else{if((b|0)==(s|0))break;y=f[a>>2]|0;f[y+20>>2]=18;f[y+24>>2]=I;ki[f[y>>2]&2047](a)}while(0);f[z>>2]=l;if((R|0)<(o|0))R=R+1|0;else break}}while(0);D=D+1|0}while((D|0)!=(G|0))}}while(0);if((I|0)<(f[j>>2]|0)){I=I+1|0;F=F+36|0}else break}J=f[H>>2]|0;K=f[p>>2]|0}H=(K|0)>0;if(!J){if(H){J=K;F=0;while(1){if(!(f[d+(F<<2)>>2]|0)){I=f[a>>2]|0;f[I+20>>2]=46;ki[f[I>>2]&2047](a);S=f[p>>2]|0}else S=J;F=F+1|0;if((F|0)>=(S|0))break;else J=S}}}else if(H){H=K;K=0;while(1){if((f[e+(K<<8)>>2]|0)<0){S=f[a>>2]|0;f[S+20>>2]=46;ki[f[S>>2]&2047](a);T=f[p>>2]|0}else T=H;K=K+1|0;if((K|0)>=(T|0))break;else H=T}}if((f[a+380>>2]|0)<8){T=f[r>>2]|0;if((f[j>>2]|0)>0){r=0;H=0;while(1){if((r|0)!=(H|0)){K=T+(H*36|0)|0;p=T+(r*36|0)|0;e=K+36|0;do{f[K>>2]=f[p>>2];K=K+4|0;p=p+4|0}while((K|0)<(e|0))}p=f[i>>2]|0;if((f[T+(H*36|0)+20>>2]|0)>(p|0))U=H;else{K=T+(H*36|0)+24|0;if((f[K>>2]|0)>(p|0))f[K>>2]=p;U=H+1|0}r=r+1|0;if((r|0)>=(f[j>>2]|0)){V=U;break}else H=U}}else V=0;f[j>>2]=V}}else{f[a+268>>2]=0;f[a+200>>2]=1}if((f[a+268>>2]|0)==0?(f[a+380>>2]|0)>=8:0){W=a+216|0;X=f[W>>2]|0;Z=(X|0)!=0;_=g+20|0;$=Z?1:2;aa=h?0:$;f[_>>2]=aa;ba=g+32|0;f[ba>>2]=0;ca=g+24|0;f[ca>>2]=0;da=a+200|0;ea=f[da>>2]|0;fa=Z&1;ga=ea<<fa;ha=g+28|0;f[ha>>2]=ga;u=c;return}if(f[a+212>>2]|0){W=a+216|0;X=f[W>>2]|0;Z=(X|0)!=0;_=g+20|0;$=Z?1:2;aa=h?0:$;f[_>>2]=aa;ba=g+32|0;f[ba>>2]=0;ca=g+24|0;f[ca>>2]=0;da=a+200|0;ea=f[da>>2]|0;fa=Z&1;ga=ea<<fa;ha=g+28|0;f[ha>>2]=ga;u=c;return}f[a+216>>2]=1;W=a+216|0;X=f[W>>2]|0;Z=(X|0)!=0;_=g+20|0;$=Z?1:2;aa=h?0:$;f[_>>2]=aa;ba=g+32|0;f[ba>>2]=0;ca=g+24|0;f[ca>>2]=0;da=a+200|0;ea=f[da>>2]|0;fa=Z&1;ga=ea<<fa;ha=g+28|0;f[ha>>2]=ga;u=c;return}function zEa(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+392>>2]|0;c=b+20|0;a:do switch(f[c>>2]|0){case 0:{CEa(a);DEa(a);if(!(f[a+208>>2]|0)){ki[f[f[a+412>>2]>>2]&2047](a);ki[f[f[a+416>>2]>>2]&2047](a);Gh[f[f[a+400>>2]>>2]&511](a,0)}ki[f[f[a+420>>2]>>2]&2047](a);d=a+216|0;Gh[f[f[a+424>>2]>>2]&511](a,f[d>>2]|0);Gh[f[f[a+404>>2]>>2]&511](a,(f[b+28>>2]|0)>1?3:0);Gh[f[f[a+396>>2]>>2]&511](a,0);f[b+12>>2]=(f[d>>2]|0)==0&1;break}case 1:{CEa(a);DEa(a);if((f[a+364>>2]|0)==0?f[a+372>>2]|0:0){f[c>>2]=2;d=b+24|0;f[d>>2]=(f[d>>2]|0)+1;e=9;break a}Gh[f[f[a+424>>2]>>2]&511](a,1);Gh[f[f[a+404>>2]>>2]&511](a,2);f[b+12>>2]=0;break}case 2:{e=9;break}default:{d=f[a>>2]|0;f[d+20>>2]=49;ki[f[d>>2]&2047](a)}}while(0);if((e|0)==9){if(!(f[a+216>>2]|0)){CEa(a);DEa(a)}Gh[f[f[a+424>>2]>>2]&511](a,0);Gh[f[f[a+404>>2]>>2]&511](a,2);e=a+408|0;if(!(f[b+32>>2]|0))ki[f[(f[e>>2]|0)+4>>2]&2047](a);ki[f[(f[e>>2]|0)+8>>2]&2047](a);f[b+12>>2]=0}e=f[b+24>>2]|0;c=f[b+28>>2]|0;f[b+16>>2]=(e|0)==(c+-1|0)&1;b=f[a+8>>2]|0;if(!b)return;f[b+12>>2]=e;f[b+16>>2]=c;return}function AEa(a){a=a|0;var b=0;f[(f[a+392>>2]|0)+12>>2]=0;b=a+408|0;ki[f[(f[b>>2]|0)+4>>2]&2047](a);ki[f[(f[b>>2]|0)+8>>2]&2047](a);return}function BEa(a){a=a|0;var b=0,c=0,d=0;b=f[a+392>>2]|0;ki[f[(f[a+424>>2]|0)+8>>2]&2047](a);c=b+20|0;switch(f[c>>2]|0){case 0:{f[c>>2]=2;if(!(f[a+216>>2]|0)){d=b+32|0;f[d>>2]=(f[d>>2]|0)+1}break}case 1:{f[c>>2]=2;break}case 2:{if(f[a+216>>2]|0)f[c>>2]=1;c=b+32|0;f[c>>2]=(f[c>>2]|0)+1;break}default:{}}c=b+24|0;f[c>>2]=(f[c>>2]|0)+1;return}function CEa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=f[a+204>>2]|0;if(!b){c=a+76|0;d=f[c>>2]|0;if((d|0)>4){e=f[a>>2]|0;f[e+20>>2]=27;f[e+24>>2]=d;f[e+28>>2]=4;ki[f[e>>2]&2047](a);g=f[c>>2]|0}else g=d;f[a+292>>2]=g;if((g|0)>0){g=a+84|0;d=0;do{f[a+296+(d<<2)>>2]=(f[g>>2]|0)+(d*88|0);d=d+1|0}while((d|0)<(f[c>>2]|0))}}else{c=f[(f[a+392>>2]|0)+32>>2]|0;d=f[b+(c*36|0)>>2]|0;f[a+292>>2]=d;if((d|0)>0){g=a+84|0;e=0;do{f[a+296+(e<<2)>>2]=(f[g>>2]|0)+((f[b+(c*36|0)+4+(e<<2)>>2]|0)*88|0);e=e+1|0}while((e|0)!=(d|0))}if(f[a+268>>2]|0){f[a+364>>2]=f[b+(c*36|0)+20>>2];f[a+368>>2]=f[b+(c*36|0)+24>>2];f[a+372>>2]=f[b+(c*36|0)+28>>2];h=f[b+(c*36|0)+32>>2]|0;i=a+376|0;f[i>>2]=h;return}}f[a+364>>2]=0;c=f[a+380>>2]|0;b=(Y(c,c)|0)+-1|0;f[a+368>>2]=b;f[a+372>>2]=0;h=0;i=a+376|0;f[i>>2]=h;return}function DEa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=a+292|0;c=f[b>>2]|0;a:do if((c|0)!=1){if((c+-1|0)>>>0>3){d=f[a>>2]|0;f[d+20>>2]=27;f[d+24>>2]=c;f[d+28>>2]=4;ki[f[d>>2]&2047](a)}d=a+380|0;e=QGa(f[a+64>>2]|0,Y(f[d>>2]|0,f[a+272>>2]|0)|0)|0;f[a+312>>2]=e;e=QGa(f[a+68>>2]|0,Y(f[d>>2]|0,f[a+276>>2]|0)|0)|0;f[a+316>>2]=e;e=a+320|0;f[e>>2]=0;if((f[b>>2]|0)>0){d=0;g=0;while(1){h=f[a+296+(g<<2)>>2]|0;i=f[h+8>>2]|0;f[h+56>>2]=i;j=f[h+12>>2]|0;f[h+60>>2]=j;k=Y(j,i)|0;f[h+64>>2]=k;l=Y(f[h+36>>2]|0,i)|0;f[h+68>>2]=l;l=((f[h+28>>2]|0)>>>0)%(i>>>0)|0;f[h+72>>2]=(l|0)==0?i:l;l=((f[h+32>>2]|0)>>>0)%(j>>>0)|0;f[h+76>>2]=(l|0)==0?j:l;if((d+k|0)>10){l=f[a>>2]|0;f[l+20>>2]=14;ki[f[l>>2]&2047](a)}if((k|0)>0){l=k;while(1){k=f[e>>2]|0;f[e>>2]=k+1;f[a+324+(k<<2)>>2]=g;if((l|0)>1)l=l+-1|0;else break}}l=g+1|0;if((l|0)>=(f[b>>2]|0))break a;d=f[e>>2]|0;g=l}}}else{g=f[a+296>>2]|0;f[a+312>>2]=f[g+28>>2];e=f[g+32>>2]|0;f[a+316>>2]=e;f[g+56>>2]=1;f[g+60>>2]=1;f[g+64>>2]=1;f[g+68>>2]=f[g+36>>2];f[g+72>>2]=1;d=f[g+12>>2]|0;l=(e>>>0)%(d>>>0)|0;f[g+76>>2]=(l|0)==0?d:l;f[a+320>>2]=1;f[a+324>>2]=0}while(0);b=f[a+240>>2]|0;if((b|0)<=0)return;c=Y(f[a+312>>2]|0,b)|0;f[a+236>>2]=(c|0)<65535?c:65535;return}function EEa(a){a=a|0;var b=0;b=f[a+4>>2]|0;if(!b)return;Gh[f[b+36>>2]&511](a,1);b=a+20|0;if(!(f[a+16>>2]|0)){f[b>>2]=100;return}else{f[b>>2]=200;f[a+312>>2]=0;return}}function FEa(a){a=a|0;var b=0,c=0;b=a+4|0;c=f[b>>2]|0;if(c|0)ki[f[c+40>>2]&2047](a);f[b>>2]=0;f[a+20>>2]=0;return}function GEa(a){a=a|0;var b=0;b=ui[f[f[a+4>>2]>>2]&127](a,0,132)|0;f[b+128>>2]=0;return b|0}function HEa(a){a=a|0;var b=0;b=ui[f[f[a+4>>2]>>2]&127](a,0,280)|0;f[b+276>>2]=0;return b|0}function IEa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+104>>2]|0;e=a+20|0;g=f[e>>2]|0;if((g|0)!=100){h=f[a>>2]|0;f[h+20>>2]=21;f[h+24>>2]=g;ki[f[h>>2]&2047](a)}h=a+88|0;g=f[h>>2]|0;if(!g){i=GEa(a)|0;f[h>>2]=i;j=i}else j=g;g=(b|0)==0;if(g){b=0;do{i=((Y(f[119216+(b<<2)>>2]|0,c)|0)+50|0)/100|0;h=(i|0)>1?i:1;d[j+(b<<1)>>1]=(h|0)<32767?h:32767;b=b+1|0}while((b|0)!=64)}else{b=0;do{h=((Y(f[119216+(b<<2)>>2]|0,c)|0)+50|0)/100|0;i=(h|0)>1?h:1;d[j+(b<<1)>>1]=(i|0)<255?i:255;b=b+1|0}while((b|0)!=64)}f[j+128>>2]=0;j=f[a+108>>2]|0;b=f[e>>2]|0;if((b|0)!=100){e=f[a>>2]|0;f[e+20>>2]=21;f[e+24>>2]=b;ki[f[e>>2]&2047](a)}e=a+92|0;b=f[e>>2]|0;if(!b){c=GEa(a)|0;f[e>>2]=c;k=c}else k=b;if(g){g=0;do{b=((Y(f[119472+(g<<2)>>2]|0,j)|0)+50|0)/100|0;c=(b|0)>1?b:1;d[k+(g<<1)>>1]=(c|0)<32767?c:32767;g=g+1|0}while((g|0)!=64);l=k+128|0;f[l>>2]=0;return}else{g=0;do{c=((Y(f[119472+(g<<2)>>2]|0,j)|0)+50|0)/100|0;b=(c|0)>1?c:1;d[k+(g<<1)>>1]=(b|0)<255?b:255;g=g+1|0}while((g|0)!=64);l=k+128|0;f[l>>2]=0;return}}function JEa(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a+20|0;g=f[e>>2]|0;if((g|0)!=100){h=f[a>>2]|0;f[h+20>>2]=21;f[h+24>>2]=g;ki[f[h>>2]&2047](a)}h=a+88|0;g=f[h>>2]|0;if(!g){i=GEa(a)|0;f[h>>2]=i;j=i}else j=g;g=(c|0)==0;if(g){c=0;do{i=((Y(f[119216+(c<<2)>>2]|0,b)|0)+50|0)/100|0;h=(i|0)>1?i:1;d[j+(c<<1)>>1]=(h|0)<32767?h:32767;c=c+1|0}while((c|0)!=64)}else{c=0;do{h=((Y(f[119216+(c<<2)>>2]|0,b)|0)+50|0)/100|0;i=(h|0)>1?h:1;d[j+(c<<1)>>1]=(i|0)<255?i:255;c=c+1|0}while((c|0)!=64)}f[j+128>>2]=0;j=f[e>>2]|0;if((j|0)!=100){e=f[a>>2]|0;f[e+20>>2]=21;f[e+24>>2]=j;ki[f[e>>2]&2047](a)}e=a+92|0;j=f[e>>2]|0;if(!j){c=GEa(a)|0;f[e>>2]=c;k=c}else k=j;if(g){g=0;do{j=((Y(f[119472+(g<<2)>>2]|0,b)|0)+50|0)/100|0;c=(j|0)>1?j:1;d[k+(g<<1)>>1]=(c|0)<32767?c:32767;g=g+1|0}while((g|0)!=64);l=k+128|0;f[l>>2]=0;return}else{g=0;do{c=((Y(f[119472+(g<<2)>>2]|0,b)|0)+50|0)/100|0;j=(c|0)>1?c:1;d[k+(g<<1)>>1]=(j|0)<255?j:255;g=g+1|0}while((g|0)!=64);l=k+128|0;f[l>>2]=0;return}}function KEa(a){a=a|0;var b=0,c=0;b=(a|0)>1?a:1;a=(b|0)<100?b:100;if((a|0)<50){c=5e3/(a>>>0)|0;return c|0}else{c=200-(a<<1)|0;return c|0}return 0}function LEa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=(b|0)>1?b:1;b=(d|0)<100?d:100;if((b|0)<50)e=5e3/(b>>>0)|0;else e=200-(b<<1)|0;JEa(a,e,c);return}function MEa(a){a=a|0;var c=0,e=0;c=f[a+20>>2]|0;if((c|0)!=100){e=f[a>>2]|0;f[e+20>>2]=21;f[e+24>>2]=c;ki[f[e>>2]&2047](a)}e=a+84|0;if(!(f[e>>2]|0)){c=ui[f[f[a+4>>2]>>2]&127](a,0,880)|0;f[e>>2]=c}f[a+56>>2]=1;f[a+60>>2]=1;c=a+72|0;f[c>>2]=8;JEa(a,50,1);NEa(a,a+120|0,360327,360344);NEa(a,a+136|0,360356,360373);NEa(a,a+124|0,360535,360552);NEa(a,a+140|0,360564,360581);b[a+152>>0]=0;b[a+168>>0]=1;b[a+184>>0]=5;b[a+153>>0]=0;b[a+169>>0]=1;b[a+185>>0]=5;b[a+154>>0]=0;b[a+170>>0]=1;b[a+186>>0]=5;b[a+155>>0]=0;b[a+171>>0]=1;b[a+187>>0]=5;b[a+156>>0]=0;b[a+172>>0]=1;b[a+188>>0]=5;b[a+157>>0]=0;b[a+173>>0]=1;b[a+189>>0]=5;b[a+158>>0]=0;b[a+174>>0]=1;b[a+190>>0]=5;b[a+159>>0]=0;b[a+175>>0]=1;b[a+191>>0]=5;b[a+160>>0]=0;b[a+176>>0]=1;b[a+192>>0]=5;b[a+161>>0]=0;b[a+177>>0]=1;b[a+193>>0]=5;b[a+162>>0]=0;b[a+178>>0]=1;b[a+194>>0]=5;b[a+163>>0]=0;b[a+179>>0]=1;b[a+195>>0]=5;b[a+164>>0]=0;b[a+180>>0]=1;b[a+196>>0]=5;b[a+165>>0]=0;b[a+181>>0]=1;b[a+197>>0]=5;b[a+166>>0]=0;b[a+182>>0]=1;b[a+198>>0]=5;b[a+167>>0]=0;b[a+183>>0]=1;b[a+199>>0]=5;e=a+200|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[a+216>>2]=(f[c>>2]|0)>8&1;f[a+220>>2]=0;f[a+224>>2]=1;c=a+228|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;b[a+248>>0]=1;b[a+249>>0]=1;b[a+250>>0]=0;d[a+252>>1]=1;d[a+254>>1]=1;f[a+260>>2]=0;OEa(a);return}function NEa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0;g=f[c>>2]|0;if(!g){i=HEa(a)|0;f[c>>2]=i;j=i}else j=g;g=j;j=d;i=g+17|0;do{b[g>>0]=b[j>>0]|0;g=g+1|0;j=j+1|0}while((g|0)<(i|0));j=(h[d+16>>0]|0)+((h[d+15>>0]|0)+((h[d+14>>0]|0)+((h[d+13>>0]|0)+((h[d+12>>0]|0)+((h[d+11>>0]|0)+((h[d+10>>0]|0)+((h[d+9>>0]|0)+((h[d+8>>0]|0)+((h[d+7>>0]|0)+((h[d+6>>0]|0)+((h[d+5>>0]|0)+((h[d+4>>0]|0)+((h[d+3>>0]|0)+((h[d+2>>0]|0)+(h[d+1>>0]|0)))))))))))))))|0;if((j+-1|0)>>>0<=255){k=f[c>>2]|0;l=k+17|0;K1a(l|0,e|0,j|0)|0;m=f[c>>2]|0;n=m+276|0;f[n>>2]=0;return}d=f[a>>2]|0;f[d+20>>2]=9;ki[f[d>>2]&2047](a);k=f[c>>2]|0;l=k+17|0;K1a(l|0,e|0,j|0)|0;m=f[c>>2]|0;n=m+276|0;f[n>>2]=0;return}function OEa(a){a=a|0;var b=0,c=0,d=0,e=0;switch(f[a+40>>2]|0){case 1:{b=f[a+20>>2]|0;if((b|0)!=100){c=f[a>>2]|0;f[c+20>>2]=21;f[c+24>>2]=b;ki[f[c>>2]&2047](a)}f[a+80>>2]=1;f[a+256>>2]=0;f[a+244>>2]=1;f[a+76>>2]=1;c=f[a+84>>2]|0;f[c>>2]=1;f[c+8>>2]=1;f[c+12>>2]=1;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;return}case 2:{c=f[a+20>>2]|0;if((c|0)!=100){b=f[a>>2]|0;f[b+20>>2]=21;f[b+24>>2]=c;ki[f[b>>2]&2047](a)}f[a+80>>2]=3;f[a+256>>2]=0;f[a+244>>2]=1;f[a+76>>2]=3;b=f[a+84>>2]|0;f[b>>2]=1;f[b+8>>2]=2;f[b+12>>2]=2;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+88>>2]=2;f[b+96>>2]=1;f[b+100>>2]=1;f[b+104>>2]=1;f[b+108>>2]=1;f[b+112>>2]=1;f[b+176>>2]=3;f[b+184>>2]=1;f[b+188>>2]=1;f[b+192>>2]=1;f[b+196>>2]=1;f[b+200>>2]=1;return}case 3:{b=f[a+20>>2]|0;if((b|0)!=100){c=f[a>>2]|0;f[c+20>>2]=21;f[c+24>>2]=b;ki[f[c>>2]&2047](a)}f[a+80>>2]=3;f[a+256>>2]=0;f[a+244>>2]=1;f[a+76>>2]=3;c=f[a+84>>2]|0;f[c>>2]=1;f[c+8>>2]=2;f[c+12>>2]=2;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[c+88>>2]=2;f[c+96>>2]=1;f[c+100>>2]=1;f[c+104>>2]=1;f[c+108>>2]=1;f[c+112>>2]=1;f[c+176>>2]=3;f[c+184>>2]=1;f[c+188>>2]=1;f[c+192>>2]=1;f[c+196>>2]=1;f[c+200>>2]=1;return}case 4:{c=f[a+20>>2]|0;if((c|0)!=100){b=f[a>>2]|0;f[b+20>>2]=21;f[b+24>>2]=c;ki[f[b>>2]&2047](a)}f[a+80>>2]=4;f[a+244>>2]=0;f[a+256>>2]=1;f[a+76>>2]=4;b=f[a+84>>2]|0;f[b>>2]=67;f[b+8>>2]=1;f[b+12>>2]=1;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+88>>2]=77;f[b+96>>2]=1;f[b+100>>2]=1;f[b+104>>2]=0;f[b+108>>2]=0;f[b+112>>2]=0;f[b+176>>2]=89;f[b+184>>2]=1;f[b+188>>2]=1;f[b+192>>2]=0;f[b+196>>2]=0;f[b+200>>2]=0;f[b+264>>2]=75;f[b+272>>2]=1;f[b+276>>2]=1;f[b+280>>2]=0;f[b+284>>2]=0;f[b+288>>2]=0;return}case 5:{b=f[a+20>>2]|0;if((b|0)!=100){c=f[a>>2]|0;f[c+20>>2]=21;f[c+24>>2]=b;ki[f[c>>2]&2047](a)}f[a+80>>2]=5;f[a+244>>2]=0;f[a+256>>2]=1;f[a+76>>2]=4;c=f[a+84>>2]|0;f[c>>2]=1;f[c+8>>2]=2;f[c+12>>2]=2;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[c+88>>2]=2;f[c+96>>2]=1;f[c+100>>2]=1;f[c+104>>2]=1;f[c+108>>2]=1;f[c+112>>2]=1;f[c+176>>2]=3;f[c+184>>2]=1;f[c+188>>2]=1;f[c+192>>2]=1;f[c+196>>2]=1;f[c+200>>2]=1;f[c+264>>2]=4;f[c+272>>2]=2;f[c+276>>2]=2;f[c+280>>2]=0;f[c+284>>2]=0;f[c+288>>2]=0;return}case 0:{c=f[a+20>>2]|0;if((c|0)!=100){b=f[a>>2]|0;f[b+20>>2]=21;f[b+24>>2]=c;ki[f[b>>2]&2047](a)}f[a+80>>2]=0;f[a+244>>2]=0;f[a+256>>2]=0;b=f[a+36>>2]|0;c=a+76|0;f[c>>2]=b;if((b+-1|0)>>>0>9){d=f[a>>2]|0;f[d+20>>2]=27;f[d+24>>2]=b;f[d+28>>2]=10;ki[f[d>>2]&2047](a);d=f[c>>2]|0;if((d|0)>0)e=d;else return}else e=b;b=f[a+84>>2]|0;d=0;do{f[b+(d*88|0)>>2]=d;f[b+(d*88|0)+8>>2]=1;f[b+(d*88|0)+12>>2]=1;f[b+(d*88|0)+16>>2]=0;f[b+(d*88|0)+20>>2]=0;f[b+(d*88|0)+24>>2]=0;d=d+1|0}while((d|0)<(e|0));return}default:{e=f[a>>2]|0;f[e+20>>2]=10;ki[f[e>>2]&2047](a);return}}}function PEa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=f[a+76>>2]|0;c=f[a+20>>2]|0;if((c|0)!=100){d=f[a>>2]|0;f[d+20>>2]=21;f[d+24>>2]=c;ki[f[d>>2]&2047](a)}d=(b|0)==3;if(d)if((f[a+80>>2]|0)==3)e=10;else g=7;else if((b|0)>4)e=b*6|0;else g=7;if((g|0)==7)e=b<<2|2;c=a+428|0;h=f[c>>2]|0;i=a+432|0;if((h|0)!=0?(f[i>>2]|0)>=(e|0):0)j=h;else{h=(e|0)>10?e:10;f[i>>2]=h;i=ui[f[f[a+4>>2]>>2]&127](a,0,h*36|0)|0;f[c>>2]=i;j=i}f[a+204>>2]=j;f[a+200>>2]=e;do if(d){e=(f[a+80>>2]|0)==3;f[j>>2]=3;if(e){f[j+4>>2]=0;f[j+8>>2]=1;f[j+12>>2]=2;f[j+24>>2]=0;f[j+20>>2]=0;f[j+28>>2]=0;f[j+32>>2]=1;f[j+36>>2]=1;f[j+40>>2]=0;f[j+56>>2]=1;f[j+60>>2]=5;f[j+64>>2]=0;f[j+68>>2]=2;f[j+72>>2]=1;f[j+76>>2]=2;f[j+92>>2]=1;f[j+96>>2]=63;f[j+100>>2]=0;f[j+104>>2]=1;f[j+108>>2]=1;f[j+112>>2]=1;f[j+128>>2]=1;f[j+132>>2]=63;f[j+136>>2]=0;f[j+140>>2]=1;f[j+144>>2]=1;f[j+148>>2]=0;f[j+164>>2]=6;f[j+168>>2]=63;f[j+172>>2]=0;f[j+176>>2]=2;f[j+180>>2]=1;f[j+184>>2]=0;f[j+200>>2]=1;f[j+204>>2]=63;f[j+208>>2]=2;f[j+212>>2]=1;f[j+216>>2]=3;f[j+220>>2]=0;f[j+224>>2]=1;f[j+228>>2]=2;f[j+240>>2]=0;f[j+236>>2]=0;f[j+244>>2]=1;f[j+248>>2]=0;f[j+252>>2]=1;f[j+256>>2]=2;f[j+272>>2]=1;f[j+276>>2]=63;f[j+280>>2]=1;f[j+284>>2]=0;f[j+288>>2]=1;f[j+292>>2]=1;f[j+308>>2]=1;f[j+312>>2]=63;f[j+316>>2]=1;f[j+320>>2]=0;f[j+324>>2]=1;f[j+328>>2]=0;f[j+344>>2]=1;f[j+348>>2]=63;f[j+352>>2]=1;f[j+356>>2]=0;return}else{k=0;g=16}}else if((b|0)<5){f[j>>2]=b;if((b|0)>0){k=0;g=16;break}else{g=17;break}}else{e=0;i=j;while(1){f[i>>2]=1;f[i+4>>2]=e;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;f[i+32>>2]=1;e=e+1|0;if((e|0)==(b|0)){l=0;m=b;break}else i=i+36|0}}while(0);if((g|0)==16)while(1){g=0;f[j+4+(k<<2)>>2]=k;k=k+1|0;if((k|0)==(b|0)){g=17;break}else g=16}if((g|0)==17){f[j+24>>2]=0;f[j+20>>2]=0;f[j+28>>2]=0;f[j+32>>2]=1;l=1;m=1}g=j+(m*36|0)|0;m=(b|0)>0;if(m){j=0;k=g;while(1){f[k>>2]=1;f[k+4>>2]=j;f[k+20>>2]=1;f[k+24>>2]=5;f[k+28>>2]=0;f[k+32>>2]=2;j=j+1|0;if((j|0)==(b|0))break;else k=k+36|0}k=g+(b*36|0)|0;j=0;a=k;while(1){f[a>>2]=1;f[a+4>>2]=j;f[a+20>>2]=6;f[a+24>>2]=63;f[a+28>>2]=0;f[a+32>>2]=2;j=j+1|0;if((j|0)==(b|0))break;else a=a+36|0}a=k+(b*36|0)|0;k=0;j=a;while(1){f[j>>2]=1;f[j+4>>2]=k;f[j+20>>2]=1;f[j+24>>2]=63;f[j+28>>2]=2;f[j+32>>2]=1;k=k+1|0;if((k|0)==(b|0))break;else j=j+36|0}n=a+(b*36|0)|0}else n=g;if(l){f[n>>2]=b;if(m){l=0;do{f[n+4+(l<<2)>>2]=l;l=l+1|0}while((l|0)!=(b|0))}f[n+24>>2]=0;f[n+20>>2]=0;f[n+28>>2]=1;f[n+32>>2]=0;o=1}else{l=0;g=n;while(1){f[g>>2]=1;f[g+4>>2]=l;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=1;f[g+32>>2]=0;l=l+1|0;if((l|0)==(b|0)){o=b;break}else g=g+36|0}}if(!m)return;m=0;g=n+(o*36|0)|0;while(1){f[g>>2]=1;f[g+4>>2]=m;f[g+20>>2]=1;f[g+24>>2]=63;f[g+28>>2]=1;f[g+32>>2]=0;m=m+1|0;if((m|0)==(b|0))break;else g=g+36|0}return}function QEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if(b|0){b=f[a>>2]|0;f[b+20>>2]=3;ki[f[b>>2]&2047](a)}b=a+4|0;c=ui[f[f[b>>2]>>2]&127](a,1,64)|0;f[a+400>>2]=c;f[c>>2]=390;d=c+4|0;if(!(f[(f[a+416>>2]|0)+8>>2]|0)){f[d>>2]=98;e=a+76|0;if((f[e>>2]|0)<=0)return;g=a+280|0;h=a+272|0;i=a+276|0;j=c+8|0;k=0;l=f[a+84>>2]|0;while(1){m=Y(f[g>>2]|0,f[l+28>>2]|0)|0;n=Y(m,f[h>>2]|0)|0;m=Jg[f[(f[b>>2]|0)+8>>2]&63](a,1,(n|0)/(f[l+8>>2]|0)|0,f[i>>2]|0)|0;f[j+(k<<2)>>2]=m;k=k+1|0;if((k|0)>=(f[e>>2]|0))break;else l=l+88|0}return}f[d>>2]=97;d=f[a+276>>2]|0;l=a+76|0;e=Y(d*20|0,f[l>>2]|0)|0;k=ui[f[f[b>>2]>>2]&127](a,1,e)|0;e=f[a+84>>2]|0;if((f[l>>2]|0)<=0)return;j=a+280|0;i=a+272|0;h=d*3|0;g=d*12|0;m=d*5|0;n=d<<1;o=d<<2;if((d|0)>0){p=0;q=e;r=k}else{s=0;t=e;e=k;while(1){k=Y(f[j>>2]|0,f[t+28>>2]|0)|0;u=Y(k,f[i>>2]|0)|0;k=e+(d<<2)|0;K1a(k|0,Jg[f[(f[b>>2]|0)+8>>2]&63](a,1,(u|0)/(f[t+8>>2]|0)|0,h)|0,g|0)|0;f[c+8+(s<<2)>>2]=k;s=s+1|0;if((s|0)>=(f[l>>2]|0))break;else{t=t+88|0;e=e+(m<<2)|0}}return}while(1){e=Y(f[j>>2]|0,f[q+28>>2]|0)|0;t=Y(e,f[i>>2]|0)|0;e=Jg[f[(f[b>>2]|0)+8>>2]&63](a,1,(t|0)/(f[q+8>>2]|0)|0,h)|0;t=r+(d<<2)|0;K1a(t|0,e|0,g|0)|0;s=0;do{f[r+(s<<2)>>2]=f[e+(s+n<<2)>>2];f[r+(s+o<<2)>>2]=f[e+(s<<2)>>2];s=s+1|0}while((s|0)!=(d|0));f[c+8+(p<<2)>>2]=t;p=p+1|0;if((p|0)>=(f[l>>2]|0))break;else{q=q+88|0;r=r+(m<<2)|0}}return}function REa(a,b){a=a|0;b=b|0;var c=0;c=f[a+400>>2]|0;if(b|0){b=f[a>>2]|0;f[b+20>>2]=3;ki[f[b>>2]&2047](a)}f[c+48>>2]=f[a+32>>2];f[c+52>>2]=0;f[c+56>>2]=0;f[c+60>>2]=f[a+276>>2]<<1;return}function SEa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;i=f[a+400>>2]|0;j=a+276|0;k=(f[j>>2]|0)*3|0;l=i+48|0;if((f[g>>2]|0)>>>0>=h>>>0)return;m=i+60|0;n=i+52|0;o=a+412|0;p=i+8|0;q=a+32|0;r=a+76|0;s=a+28|0;t=a+416|0;u=i+56|0;while(1){v=f[c>>2]|0;if(v>>>0>=d>>>0){if(f[l>>2]|0){w=28;break}x=f[n>>2]|0;y=f[m>>2]|0;if((x|0)<(y|0)){z=f[r>>2]|0;a:do if((z|0)>0){A=x;B=y;C=z;D=0;while(1){E=f[i+8+(D<<2)>>2]|0;F=f[s>>2]|0;if((A|0)<(B|0)){G=A+-1|0;H=A;do{SGa(E,G,E,H,1,F);H=H+1|0}while((H|0)!=(B|0));I=f[r>>2]|0;J=f[m>>2]|0}else{I=C;J=B}H=D+1|0;if((H|0)>=(I|0)){K=J;break a}A=f[n>>2]|0;B=J;C=I;D=H}}else K=y;while(0);f[n>>2]=K;w=24}else{L=x;M=y;w=23}}else{z=d-v|0;D=f[n>>2]|0;C=(f[m>>2]|0)-D|0;B=C>>>0<z>>>0?C:z;Bh[f[(f[o>>2]|0)+4>>2]&255](a,b+(v<<2)|0,p,D,B);if((f[l>>2]|0)==(f[q>>2]|0)?(D=f[r>>2]|0,(D|0)>0):0){z=f[j>>2]|0;C=D;D=0;while(1){if((z|0)<1){N=C;O=z}else{A=i+8+(D<<2)|0;H=1;while(1){F=f[A>>2]|0;SGa(F,0,F,0-H|0,1,f[s>>2]|0);P=f[j>>2]|0;if((H|0)<(P|0))H=H+1|0;else break}N=f[r>>2]|0;O=P}D=D+1|0;if((D|0)>=(N|0))break;else{z=O;C=N}}}f[c>>2]=(f[c>>2]|0)+B;C=(f[n>>2]|0)+B|0;f[n>>2]=C;f[l>>2]=(f[l>>2]|0)-B;L=C;M=f[m>>2]|0;w=23}if((w|0)==23?(w=0,(L|0)==(M|0)):0)w=24;if((w|0)==24){w=0;Bh[f[(f[t>>2]|0)+4>>2]&255](a,p,f[u>>2]|0,e,f[g>>2]|0);f[g>>2]=(f[g>>2]|0)+1;C=f[j>>2]|0;z=(f[u>>2]|0)+C|0;f[u>>2]=(z|0)<(k|0)?z:0;z=f[n>>2]|0;if((z|0)<(k|0))Q=z;else{f[n>>2]=0;Q=0}f[m>>2]=C+Q}if((f[g>>2]|0)>>>0>=h>>>0){w=28;break}}if((w|0)==28)return}function TEa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+400>>2]|0;j=f[c>>2]|0;if(j>>>0>=d>>>0)return;k=a+276|0;l=i+52|0;m=a+412|0;n=i+8|0;o=i+48|0;p=a+76|0;q=a+28|0;r=a+416|0;s=j;while(1){if((f[g>>2]|0)>>>0>=h>>>0){t=27;break}j=d-s|0;u=f[l>>2]|0;v=(f[k>>2]|0)-u|0;w=v>>>0<j>>>0?v:j;Bh[f[(f[m>>2]|0)+4>>2]&255](a,b+(s<<2)|0,n,u,w);f[c>>2]=(f[c>>2]|0)+w;u=(f[l>>2]|0)+w|0;f[l>>2]=u;j=(f[o>>2]|0)-w|0;f[o>>2]=j;w=f[k>>2]|0;if(!((j|0)==0&(u|0)<(w|0))){if((u|0)==(w|0))t=14}else{j=f[p>>2]|0;a:do if((j|0)>0){v=u;x=w;y=j;z=0;while(1){A=f[i+8+(z<<2)>>2]|0;B=f[q>>2]|0;if((v|0)<(x|0)){C=v+-1|0;D=v;do{SGa(A,C,A,D,1,B);D=D+1|0}while((D|0)!=(x|0));E=f[p>>2]|0;F=f[k>>2]|0}else{E=y;F=x}D=z+1|0;if((D|0)>=(E|0)){G=F;break a}v=f[l>>2]|0;x=F;y=E;z=D}}else G=w;while(0);f[l>>2]=G;t=14}if((t|0)==14){t=0;Bh[f[(f[r>>2]|0)+4>>2]&255](a,n,0,e,f[g>>2]|0);f[l>>2]=0;f[g>>2]=(f[g>>2]|0)+1}if((f[o>>2]|0)==0?(H=f[g>>2]|0,H>>>0<h>>>0):0){t=18;break}s=f[c>>2]|0;if(s>>>0>=d>>>0){t=27;break}}if((t|0)==18){d=f[p>>2]|0;b:do if((d|0)>0){s=a+284|0;c=H;o=d;l=0;n=f[a+84>>2]|0;while(1){r=Y(f[n+40>>2]|0,f[n+12>>2]|0)|0;G=(r|0)/(f[s>>2]|0)|0;r=f[e+(l<<2)>>2]|0;E=Y(f[n+36>>2]|0,f[n+28>>2]|0)|0;F=Y(c,G)|0;k=Y(G,h)|0;if((F|0)<(k|0)){G=F+-1|0;q=F;do{SGa(r,G,r,q,1,E);q=q+1|0}while((q|0)!=(k|0));I=f[p>>2]|0}else I=o;k=l+1|0;if((k|0)>=(I|0))break b;c=f[g>>2]|0;o=I;l=k;n=n+88|0}}while(0);f[g>>2]=h;return}else if((t|0)==27)return}function UEa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=ui[f[f[a+4>>2]>>2]&127](a,1,112)|0;f[a+416>>2]=c;f[c>>2]=980;f[c+4>>2]=136;d=c+8|0;f[d>>2]=0;if(f[a+220>>2]|0){e=f[a>>2]|0;f[e+20>>2]=26;ki[f[e>>2]&2047](a)}e=a+76|0;if((f[e>>2]|0)<=0)return;g=a+280|0;h=a+284|0;i=a+272|0;j=a+276|0;k=c+52|0;l=a+228|0;m=c+12|0;n=c+92|0;o=c+102|0;c=0;p=f[a+84>>2]|0;q=1;while(1){r=Y(f[p+36>>2]|0,f[p+8>>2]|0)|0;s=(r|0)/(f[g>>2]|0)|0;r=Y(f[p+40>>2]|0,f[p+12>>2]|0)|0;t=(r|0)/(f[h>>2]|0)|0;r=f[i>>2]|0;u=f[j>>2]|0;f[k+(c<<2)>>2]=t;v=(u|0)==(t|0);do if((r|0)==(s|0)&v){w=m+(c<<2)|0;if(!(f[l>>2]|0)){f[w>>2]=160;x=q;break}else{f[w>>2]=159;f[d>>2]=1;x=q;break}}else{w=(r|0)==(s<<1|0);if(w&v){f[m+(c<<2)>>2]=161;x=0;break}if(w&(u|0)==(t<<1|0)){w=m+(c<<2)|0;if(!(f[l>>2]|0)){f[w>>2]=163;x=q;break}else{f[w>>2]=162;f[d>>2]=1;x=q;break}}if(((r|0)%(s|0)|0|0)==0?((u|0)%(t|0)|0|0)==0:0){f[m+(c<<2)>>2]=164;b[n+c>>0]=(r|0)/(s|0)|0;b[o+c>>0]=(u|0)/(t|0)|0;x=0;break}w=f[a>>2]|0;f[w+20>>2]=39;ki[f[w>>2]&2047](a);x=q}while(0);c=c+1|0;if((c|0)>=(f[e>>2]|0))break;else{p=p+88|0;q=x}}if((x|0)!=0|(f[l>>2]|0)==0)return;l=f[a>>2]|0;f[l+20>>2]=101;Gh[f[l+4>>2]&511](a,0);return}function VEa(a){a=a|0;return}function WEa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=f[a+416>>2]|0;h=a+76|0;if((f[h>>2]|0)<=0)return;i=0;j=f[a+84>>2]|0;while(1){k=(f[d+(i<<2)>>2]|0)+((Y(f[g+52+(i<<2)>>2]|0,e)|0)<<2)|0;Ah[f[g+12+(i<<2)>>2]&255](a,j,(f[b+(i<<2)>>2]|0)+(c<<2)|0,k);i=i+1|0;if((i|0)>=(f[h>>2]|0))break;else j=j+88|0}return}function XEa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=Y(f[c+36>>2]|0,f[c+28>>2]|0)|0;c=d+-4|0;i=a+276|0;j=f[i>>2]|0;k=f[a+28>>2]|0;if((j|0)>-2&(g-k|0)>0){l=k+~g|0;m=g+2-k+((l|0)>-2?l:-2)|0;l=j+1|0;n=0;while(1){o=(f[c+(n<<2)>>2]|0)+k|0;F1a(o|0,b[o+-1>>0]|0,m|0)|0;if((n|0)==(l|0))break;else n=n+1|0}p=f[i>>2]|0}else p=j;j=f[a+228>>2]|0;a=65536-(j<<9)|0;n=j<<6;if((p|0)<=0)return;p=g+-2|0;if(!p){j=0;do{l=f[e+(j<<2)>>2]|0;m=f[d+(j<<2)>>2]|0;k=f[d+(j+-1<<2)>>2]|0;j=j+1|0;c=f[d+(j<<2)>>2]|0;o=(h[c>>0]|0)+(h[k>>0]|0)|0;q=h[m>>0]|0;r=o+q|0;s=m+1|0;m=(h[c+1>>0]|0)+(h[k+1>>0]|0)+(h[s>>0]|0)|0;k=((Y(q,a)|0)+32768+(Y(r+o+m|0,n)|0)|0)>>>16&255;b[l>>0]=k;k=h[s>>0]|0;s=((Y(k,a)|0)+32768+(Y(m-k+r+m|0,n)|0)|0)>>>16&255;b[l+1>>0]=s}while((j|0)<(f[i>>2]|0));return}j=g+-1|0;g=0;do{s=f[e+(g<<2)>>2]|0;l=f[d+(g<<2)>>2]|0;m=f[d+(g+-1<<2)>>2]|0;g=g+1|0;r=f[d+(g<<2)>>2]|0;k=m+1|0;o=r+1|0;q=(h[r>>0]|0)+(h[m>>0]|0)|0;m=h[l>>0]|0;r=q+m|0;c=l+1|0;l=(h[o>>0]|0)+(h[k>>0]|0)+(h[c>>0]|0)|0;t=((Y(m,a)|0)+32768+(Y(r+q+l|0,n)|0)|0)>>>16&255;b[s>>0]=t;t=h[c>>0]|0;q=s;m=k;k=l-t+r|0;r=o;o=p;u=l;l=c;c=Y(t,a)|0;do{q=q+1|0;l=l+1|0;m=m+1|0;r=r+1|0;t=u;u=(h[r>>0]|0)+(h[m>>0]|0)+(h[l>>0]|0)|0;v=(c+32768+(Y(u+k|0,n)|0)|0)>>>16&255;b[q>>0]=v;o=o+-1|0;v=h[l>>0]|0;c=Y(v,a)|0;k=u-v+t|0}while((o|0)!=0);o=(c+32768+(Y(k+u|0,n)|0)|0)>>>16&255;b[s+j>>0]=o}while((g|0)<(f[i>>2]|0));return}function YEa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=a+276|0;h=a+28|0;SGa(d,0,e,0,f[g>>2]|0,f[h>>2]|0);d=f[g>>2]|0;g=f[h>>2]|0;h=Y(f[c+36>>2]|0,f[c+28>>2]|0)|0;if(!((d|0)>0&(h-g|0)>0))return;c=g+-1-h|0;a=2-g+h+((c|0)>-2?c:-2)|0;c=0;do{h=(f[e+(c<<2)>>2]|0)+g|0;F1a(h|0,b[h+-1>>0]|0,a|0)|0;c=c+1|0}while((c|0)!=(d|0));return}function ZEa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0;g=Y(f[c+36>>2]|0,f[c+28>>2]|0)|0;c=a+276|0;i=f[c>>2]|0;j=f[a+28>>2]|0;a=g<<1;if((i|0)>0&(a-j|0)>0){k=j+-1-a|0;l=a+2-j+((k|0)>-2?k:-2)|0;k=0;do{a=(f[d+(k<<2)>>2]|0)+j|0;F1a(a|0,b[a+-1>>0]|0,l|0)|0;k=k+1|0}while((k|0)!=(i|0));m=f[c>>2]|0}else m=i;if((m|0)<=0)return;if(!g){i=0;do i=i+1|0;while((i|0)<(m|0));return}else n=0;do{m=0;i=f[d+(n<<2)>>2]|0;k=0;l=f[e+(n<<2)>>2]|0;while(1){b[l>>0]=((h[i>>0]|0)+m+(h[i+1>>0]|0)|0)>>>1;k=k+1|0;if((k|0)==(g|0))break;else{m=m^1;i=i+2|0;l=l+1|0}}n=n+1|0}while((n|0)<(f[c>>2]|0));return}function _Ea(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=Y(f[c+36>>2]|0,f[c+28>>2]|0)|0;c=d+-4|0;i=a+276|0;j=f[i>>2]|0;k=f[a+28>>2]|0;l=g<<1;if((j|0)>-2&(l-k|0)>0){m=k+-1-l|0;n=l+2-k+((m|0)>-2?m:-2)|0;m=j+1|0;l=0;while(1){o=(f[c+(l<<2)>>2]|0)+k|0;F1a(o|0,b[o+-1>>0]|0,n|0)|0;if((l|0)==(m|0))break;else l=l+1|0}p=f[i>>2]|0}else p=j;j=f[a+228>>2]|0;a=(Y(j,-80)|0)+16384|0;l=j<<4;if((p|0)<=0)return;p=g+-2|0;j=g+-1|0;g=0;m=0;while(1){n=f[e+(m<<2)>>2]|0;k=f[d+(g<<2)>>2]|0;c=f[d+((g|1)<<2)>>2]|0;o=f[d+(g+-1<<2)>>2]|0;g=g+2|0;q=f[d+(g<<2)>>2]|0;r=h[k>>0]|0;s=h[c>>0]|0;t=h[o>>0]|0;u=h[q>>0]|0;v=k+2|0;w=c+2|0;x=o+2|0;y=q+2|0;z=((Y((h[k+1>>0]|0)+r+s+(h[c+1>>0]|0)|0,a)|0)+32768+(Y(u+t+(h[x>>0]|0)+(h[y>>0]|0)+(s+r+t+(h[o+1>>0]|0)+u+(h[q+1>>0]|0)+(h[v>>0]|0)+(h[w>>0]|0)<<1)|0,l)|0)|0)>>>16&255;b[n>>0]=z;z=n;q=x;x=y;y=p;u=v;v=w;while(1){w=z+1|0;A=h[u+1>>0]|0;B=h[v+1>>0]|0;C=h[q+1>>0]|0;D=h[x+1>>0]|0;E=C+(h[q>>0]|0)+(h[x>>0]|0)+D+(h[u+-1>>0]|0)|0;F=Y(A+(h[u>>0]|0)+(h[v>>0]|0)+B|0,a)|0;G=h[x+-1>>0]|0;H=h[v+-1>>0]|0;I=h[q+-1>>0]|0;if(!y)break;o=u+2|0;t=v+2|0;r=q+2|0;s=x+2|0;c=(F+32768+(Y(I+G+(h[r>>0]|0)+(h[s>>0]|0)+(H+E+(h[o>>0]|0)+(h[t>>0]|0)<<1)|0,l)|0)|0)>>>16&255;b[w>>0]=c;z=w;q=r;x=s;y=y+-1|0;u=o;v=t}v=(F+32768+(Y(D+C+G+I+(B+A+E+H<<1)|0,l)|0)|0)>>>16&255;b[n+j>>0]=v;if((g|0)>=(f[i>>2]|0))break;else m=m+1|0}return}function $Ea(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=Y(f[c+36>>2]|0,f[c+28>>2]|0)|0;c=a+276|0;i=f[c>>2]|0;j=f[a+28>>2]|0;a=g<<1;if((i|0)>0&(a-j|0)>0){k=j+-1-a|0;l=a+2-j+((k|0)>-2?k:-2)|0;k=0;do{a=(f[d+(k<<2)>>2]|0)+j|0;F1a(a|0,b[a+-1>>0]|0,l|0)|0;k=k+1|0}while((k|0)!=(i|0));m=f[c>>2]|0}else m=i;if((m|0)<=0)return;if(!g){i=0;do i=i+2|0;while((i|0)<(m|0));return}else{n=0;o=0}while(1){m=1;i=f[d+(n<<2)>>2]|0;k=f[d+((n|1)<<2)>>2]|0;l=0;j=f[e+(o<<2)>>2]|0;while(1){b[j>>0]=((h[i>>0]|0)+m+(h[i+1>>0]|0)+(h[k>>0]|0)+(h[k+1>>0]|0)|0)>>>2;l=l+1|0;if((l|0)==(g|0))break;else{m=m^3;i=i+2|0;k=k+2|0;j=j+1|0}}n=n+2|0;if((n|0)>=(f[c>>2]|0))break;else o=o+1|0}return}function aFa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=f[a+416>>2]|0;i=Y(f[c+36>>2]|0,f[c+28>>2]|0)|0;j=f[c+4>>2]|0;c=b[g+92+j>>0]|0;k=c&255;l=b[g+102+j>>0]|0;j=l&255;g=Y(j,k)|0;m=g>>>1;n=a+276|0;o=f[n>>2]|0;p=f[a+28>>2]|0;a=Y(k,i)|0;if((o|0)>0&(a-p|0)>0){q=p+~a|0;r=a+2-p+((q|0)>-2?q:-2)|0;q=0;do{a=(f[d+(q<<2)>>2]|0)+p|0;F1a(a|0,b[a+-1>>0]|0,r|0)|0;q=q+1|0}while((q|0)!=(o|0));s=f[n>>2]|0}else s=o;if((s|0)<=0)return;s=(i|0)==0;o=l<<24>>24==0;l=c<<24>>24==0;c=0;q=0;while(1){r=f[e+(q<<2)>>2]|0;a:do if(!s){if(o){p=((m>>>0)/(g>>>0)|0)&255;a=0;t=r;while(1){b[t>>0]=p;a=a+1|0;if((a|0)==(i|0))break a;else t=t+1|0}}else{u=0;v=0;w=r}while(1){if(l)x=0;else{t=0;a=0;while(1){p=0;y=(f[d+(a+c<<2)>>2]|0)+v|0;z=t;while(1){z=(h[y>>0]|0)+z|0;p=p+1|0;if((p|0)==(k|0))break;else y=y+1|0}a=a+1|0;if((a|0)==(j|0)){x=z;break}else t=z}}b[w>>0]=(x+m|0)/(g|0)|0;u=u+1|0;if((u|0)==(i|0))break;else{v=v+k|0;w=w+1|0}}}while(0);c=c+j|0;if((c|0)>=(f[n>>2]|0))break;else q=q+1|0}return}function bFa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;f[a+4>>2]=0;if((b|0)!=90){d=f[a>>2]|0;f[d+20>>2]=13;f[d+24>>2]=90;f[d+28>>2]=b;ki[f[d>>2]&2047](a)}if((c|0)==488)e=a;else{d=f[a>>2]|0;f[d+20>>2]=22;f[d+24>>2]=488;f[d+28>>2]=c;ki[f[d>>2]&2047](a);e=a}d=f[a>>2]|0;c=a+12|0;b=f[c>>2]|0;F1a(a+4|0,0,484)|0;f[a>>2]=d;f[c>>2]=b;f[a+16>>2]=1;jGa(e);f[a+8>>2]=0;f[a+24>>2]=0;f[a+312>>2]=0;e=a+164|0;b=e+48|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(b|0));zFa(a);sFa(a);f[a+20>>2]=200;return}function cFa(a){a=a|0;FEa(a);return}function dFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if((c&-2|0)!=200){d=f[a>>2]|0;f[d+20>>2]=21;f[d+24>>2]=c;ki[f[d>>2]&2047](a)}d=eFa(a)|0;switch(d|0){case 1:{e=1;return e|0}case 2:{if(b|0){b=f[a>>2]|0;f[b+20>>2]=53;ki[f[b>>2]&2047](a)}EEa(a);e=2;return e|0}default:{e=d;return e|0}}return 0}function eFa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+20|0;d=f[c>>2]|0;switch(d|0){case 200:{e=a+460|0;ki[f[(f[e>>2]|0)+4>>2]&2047](a);ki[f[(f[a+24>>2]|0)+8>>2]&2047](a);f[c>>2]=201;g=e;break}case 201:{g=a+460|0;break}case 210:case 208:case 207:case 206:case 205:case 204:case 203:{h=mi[f[f[a+460>>2]>>2]&255](a)|0;return h|0}case 202:{h=1;return h|0}default:{e=f[a>>2]|0;f[e+20>>2]=21;f[e+24>>2]=d;ki[f[e>>2]&2047](a);h=0;return h|0}}e=mi[f[f[g>>2]>>2]&255](a)|0;if((e|0)!=1){h=e;return h|0}a:do switch(f[a+36>>2]|0){case 1:{i=1;j=1;break}case 3:{if(!(f[a+284>>2]|0))if(!(f[a+296>>2]|0)){e=f[a+216>>2]|0;g=f[e>>2]|0;d=f[e+88>>2]|0;k=f[e+176>>2]|0;if((g|0)==1&(d|0)==2&(k|0)==3){i=2;j=3;break a}if((g|0)==82&(d|0)==71&(k|0)==66){i=2;j=2;break a}e=f[a>>2]|0;f[e+24>>2]=g;f[e+28>>2]=d;f[e+32>>2]=k;f[e+20>>2]=113;Gh[f[e+4>>2]&511](a,1);i=2;j=3;break a}else{e=b[a+300>>0]|0;switch(e<<24>>24){case 0:{i=2;j=2;break a;break}case 1:{i=2;j=3;break a;break}default:{k=f[a>>2]|0;f[k+20>>2]=116;f[k+24>>2]=e&255;Gh[f[k+4>>2]&511](a,-1);i=2;j=3;break a}}}else{i=2;j=3}break}case 4:{if(!(f[a+296>>2]|0)){i=4;j=4}else{k=b[a+300>>0]|0;switch(k<<24>>24){case 0:{i=4;j=4;break a;break}case 2:{i=4;j=5;break a;break}default:{e=f[a>>2]|0;f[e+20>>2]=116;f[e+24>>2]=k&255;Gh[f[e+4>>2]&511](a,-1);i=4;j=5;break a}}}break}default:{i=0;j=0}}while(0);f[a+40>>2]=j;f[a+44>>2]=i;i=f[a+428>>2]|0;f[a+48>>2]=i;f[a+52>>2]=i;p[a+56>>3]=1.0;f[a+64>>2]=0;f[a+68>>2]=0;f[a+72>>2]=0;f[a+76>>2]=1;f[a+80>>2]=1;f[a+84>>2]=0;f[a+88>>2]=2;f[a+92>>2]=1;f[a+96>>2]=256;f[a+136>>2]=0;f[a+100>>2]=0;f[a+104>>2]=0;f[a+108>>2]=0;f[c>>2]=202;h=1;return h|0}function fFa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+20|0;c=f[b>>2]|0;switch(c|0){case 206:case 205:{if(!(f[a+64>>2]|0)){if((f[a+140>>2]|0)>>>0<(f[a+116>>2]|0)>>>0){d=f[a>>2]|0;f[d+20>>2]=69;ki[f[d>>2]&2047](a)}ki[f[(f[a+444>>2]|0)+4>>2]&2047](a);f[b>>2]=210}else e=7;break}case 207:{f[b>>2]=210;break}case 210:break;default:e=7}if((e|0)==7){b=f[a>>2]|0;f[b+20>>2]=21;f[b+24>>2]=c;ki[f[b>>2]&2047](a)}b=a+460|0;while(1){c=f[b>>2]|0;if(f[c+20>>2]|0)break;if(!(mi[f[c>>2]&255](a)|0)){g=0;e=12;break}}if((e|0)==12)return g|0;ki[f[(f[a+24>>2]|0)+24>>2]&2047](a);EEa(a);g=1;return g|0}function gFa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+20|0;c=f[b>>2]|0;a:do switch(c|0){case 202:{JFa(a);if(!(f[a+64>>2]|0)){f[b>>2]=203;d=6;break a}f[b>>2]=207;e=1;return e|0}case 203:{d=6;break}case 204:{g=a+444|0;break}default:{h=f[a>>2]|0;f[h+20>>2]=21;f[h+24>>2]=c;ki[f[h>>2]&2047](a);d=16}}while(0);if((d|0)==6){c=a+460|0;b:do if(f[(f[c>>2]|0)+16>>2]|0){h=a+8|0;i=a+332|0;j=f[h>>2]|0;c:while(1){if(j|0)ki[f[j>>2]&2047](a);k=mi[f[f[c>>2]>>2]&255](a)|0;switch(k|0){case 2:{break b;break}case 0:{e=0;break c;break}default:{}}l=f[h>>2]|0;if(!((k|2|0)==3&(l|0)!=0)){j=l;continue}k=l+4|0;m=(f[k>>2]|0)+1|0;f[k>>2]=m;k=l+8|0;n=f[k>>2]|0;if((m|0)<(n|0)){j=l;continue}f[k>>2]=(f[i>>2]|0)+n;j=l}return e|0}while(0);f[a+152>>2]=f[a+144>>2];d=16}if((d|0)==16){d=a+444|0;if((f[b>>2]|0)==204)g=d;else{ki[f[f[d>>2]>>2]&2047](a);f[a+140>>2]=0;f[b>>2]=204;g=d}}d:do if(f[(f[g>>2]|0)+8>>2]|0){d=a+140|0;c=a+116|0;j=a+8|0;i=a+448|0;h=f[d>>2]|0;e:while(1){l=h;while(1){n=f[c>>2]|0;if(l>>>0>=n>>>0)break;k=f[j>>2]|0;if(!k)o=l;else{f[k+4>>2]=l;f[k+8>>2]=n;ki[f[k>>2]&2047](a);o=f[d>>2]|0}Ah[f[(f[i>>2]|0)+4>>2]&255](a,0,d,0);l=f[d>>2]|0;if((l|0)==(o|0)){e=0;break e}}ki[f[(f[g>>2]|0)+4>>2]&2047](a);ki[f[f[g>>2]>>2]&2047](a);f[d>>2]=0;if(!(f[(f[g>>2]|0)+8>>2]|0))break d;else h=0}return e|0}while(0);f[b>>2]=f[a+68>>2]|0?206:205;e=1;return e|0}function hFa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;g=f[a+20>>2]|0;if((g|0)!=205){h=f[a>>2]|0;f[h+20>>2]=21;f[h+24>>2]=g;ki[f[h>>2]&2047](a)}h=a+140|0;g=f[h>>2]|0;i=f[a+116>>2]|0;if(g>>>0>=i>>>0){j=f[a>>2]|0;f[j+20>>2]=126;Gh[f[j+4>>2]&511](a,-1);k=0;u=d;return k|0}j=f[a+8>>2]|0;if(j|0){f[j+4>>2]=g;f[j+8>>2]=i;ki[f[j>>2]&2047](a)}f[e>>2]=0;Ah[f[(f[a+448>>2]|0)+4>>2]&255](a,b,e,c);c=f[e>>2]|0;f[h>>2]=(f[h>>2]|0)+c;k=c;u=d;return k|0}function iFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+24|0;d=f[c>>2]|0;if(!d){e=ui[f[f[a+4>>2]>>2]&127](a,0,28)|0;f[c>>2]=e;g=e}else g=d;f[g+8>>2]=981;f[g+12>>2]=245;f[g+16>>2]=982;f[g+20>>2]=b;return}function jFa(a){a=a|0;var b=0,c=0;b=f[a+24>>2]|0;c=ui[f[f[a+4>>2]>>2]&127](a,1,4096)|0;f[b+24>>2]=c;f[b>>2]=c;f[b+4>>2]=4096;return}function kFa(a){a=a|0;var b=0,c=0,d=0;b=f[a+24>>2]|0;c=b+24|0;if((xMa(f[c>>2]|0,1,4096,f[b+20>>2]|0)|0)!=4096){d=f[a>>2]|0;f[d+20>>2]=38;ki[f[d>>2]&2047](a)}f[b>>2]=f[c>>2];f[b+4>>2]=4096;return 1}function lFa(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+24>>2]|0;c=4096-(f[b+4>>2]|0)|0;if(c){d=b+20|0;if((xMa(f[b+24>>2]|0,1,c,f[d>>2]|0)|0)==(c|0))e=d;else{c=f[a>>2]|0;f[c+20>>2]=38;ki[f[c>>2]&2047](a);e=d}}else e=b+20|0;IMa(f[e>>2]|0)|0;if(!(QMa(f[e>>2]|0)|0))return;e=f[a>>2]|0;f[e+20>>2]=38;ki[f[e>>2]&2047](a);return}function mFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+24|0;d=f[c>>2]|0;if(!d){e=a+4|0;g=ui[f[f[e>>2]>>2]&127](a,0,40)|0;f[c>>2]=g;h=ui[f[f[e>>2]>>2]&127](a,0,4096)|0;f[g+32>>2]=h;i=f[c>>2]|0}else i=d;f[i+8>>2]=983;f[i+12>>2]=246;f[i+16>>2]=391;f[i+20>>2]=163;f[i+24>>2]=984;f[i+28>>2]=b;f[i+4>>2]=0;f[i>>2]=0;return}function nFa(a){a=a|0;f[(f[a+24>>2]|0)+36>>2]=1;return}function oFa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[a+24>>2]|0;d=c+32|0;e=MMa(f[d>>2]|0,1,4096,f[c+28>>2]|0)|0;g=c+36|0;if(e|0){h=e;i=f[d>>2]|0;f[c>>2]=i;j=c+4|0;f[j>>2]=h;f[g>>2]=0;return 1}if(f[g>>2]|0){e=f[a>>2]|0;f[e+20>>2]=43;ki[f[e>>2]&2047](a)}e=f[a>>2]|0;f[e+20>>2]=123;Gh[f[e+4>>2]&511](a,-1);b[f[d>>2]>>0]=-1;b[(f[d>>2]|0)+1>>0]=-39;h=2;i=f[d>>2]|0;f[c>>2]=i;j=c+4|0;f[j>>2]=h;f[g>>2]=0;return 1}function pFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[a+24>>2]|0;if((b|0)<=0)return;d=c+4|0;e=f[d>>2]|0;if((e|0)<(b|0)){g=c+12|0;h=e;i=b;while(1){j=i-h|0;mi[f[g>>2]&255](a)|0;k=f[d>>2]|0;if((j|0)>(k|0)){h=k;i=j}else{l=k;m=j;break}}}else{l=e;m=b}f[c>>2]=(f[c>>2]|0)+m;f[d>>2]=l-m;return}function qFa(a){a=a|0;return}function rFa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=a+428|0;c=f[b>>2]|0;d=Y(c,f[a+48>>2]|0)|0;e=f[a+52>>2]|0;do if(d>>>0>e>>>0){if(d>>>0<=e<<1>>>0){g=QGa(f[a+28>>2]<<1,c)|0;f[a+112>>2]=g;h=2;i=f[a+32>>2]<<1;break}if(d>>>0<=(e*3|0)>>>0){g=QGa((f[a+28>>2]|0)*3|0,c)|0;f[a+112>>2]=g;h=3;i=(f[a+32>>2]|0)*3|0;break}if(d>>>0<=e<<2>>>0){g=QGa(f[a+28>>2]<<2,c)|0;f[a+112>>2]=g;h=4;i=f[a+32>>2]<<2;break}if(d>>>0<=(e*5|0)>>>0){g=QGa((f[a+28>>2]|0)*5|0,c)|0;f[a+112>>2]=g;h=5;i=(f[a+32>>2]|0)*5|0;break}g=f[a+28>>2]|0;if(d>>>0<=(e*6|0)>>>0){j=QGa(g*6|0,c)|0;f[a+112>>2]=j;h=6;i=(f[a+32>>2]|0)*6|0;break}if(d>>>0<=(e*7|0)>>>0){j=QGa(g*7|0,c)|0;f[a+112>>2]=j;h=7;i=(f[a+32>>2]|0)*7|0;break}if(d>>>0<=e<<3>>>0){j=QGa(g<<3,c)|0;f[a+112>>2]=j;h=8;i=f[a+32>>2]<<3;break}if(d>>>0<=(e*9|0)>>>0){j=QGa(g*9|0,c)|0;f[a+112>>2]=j;h=9;i=(f[a+32>>2]|0)*9|0;break}if(d>>>0<=(e*10|0)>>>0){j=QGa(g*10|0,c)|0;f[a+112>>2]=j;h=10;i=(f[a+32>>2]|0)*10|0;break}if(d>>>0<=(e*11|0)>>>0){j=QGa(g*11|0,c)|0;f[a+112>>2]=j;h=11;i=(f[a+32>>2]|0)*11|0;break}if(d>>>0<=(e*12|0)>>>0){j=QGa(g*12|0,c)|0;f[a+112>>2]=j;h=12;i=(f[a+32>>2]|0)*12|0;break}if(d>>>0<=(e*13|0)>>>0){j=QGa(g*13|0,c)|0;f[a+112>>2]=j;h=13;i=(f[a+32>>2]|0)*13|0;break}if(d>>>0<=(e*14|0)>>>0){j=QGa(g*14|0,c)|0;f[a+112>>2]=j;h=14;i=(f[a+32>>2]|0)*14|0;break}if(d>>>0>(e*15|0)>>>0){j=QGa(g<<4,c)|0;f[a+112>>2]=j;h=16;i=f[a+32>>2]<<4;break}else{j=QGa(g*15|0,c)|0;f[a+112>>2]=j;h=15;i=(f[a+32>>2]|0)*15|0;break}}else{j=QGa(f[a+28>>2]|0,c)|0;f[a+112>>2]=j;h=1;i=f[a+32>>2]|0}while(0);c=QGa(i,f[b>>2]|0)|0;f[a+116>>2]=c;f[a+324>>2]=h;f[a+328>>2]=h;c=f[a+36>>2]|0;if((c|0)<=0)return;b=0;i=f[a+216>>2]|0;while(1){f[i+36>>2]=h;f[i+40>>2]=h;b=b+1|0;if((b|0)>=(c|0))break;else i=i+88|0}return}function sFa(a){a=a|0;var b=0;b=ui[f[f[a+4>>2]>>2]&127](a,0,28)|0;f[a+460>>2]=b;f[b>>2]=247;f[b+4>>2]=985;f[b+8>>2]=986;f[b+12>>2]=987;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=1;return}function tFa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;b=a+460|0;c=f[b>>2]|0;d=c+20|0;if(f[d>>2]|0){e=2;return e|0}g=a+464|0;h=c+24|0;i=a+340|0;j=c+16|0;c=a+32|0;k=a+212|0;l=a+36|0;m=a+316|0;n=a+320|0;o=a+216|0;p=a+220|0;q=a+224|0;r=a+416|0;s=a+412|0;t=a+420|0;u=a+424|0;v=a+428|0;w=a+432|0;x=a+436|0;y=a+324|0;z=a+328|0;A=a+28|0;B=a+332|0;a:while(1){C=mi[f[(f[g>>2]|0)+4>>2]&255](a)|0;switch(C|0){case 2:{D=54;break a;break}case 1:break;default:{e=C;D=59;break a}}switch(f[h>>2]|0){case 0:{if(!(f[j>>2]|0)){C=f[a>>2]|0;f[C+20>>2]=36;ki[f[C>>2]&2047](a)}if(!(f[i>>2]|0))continue a;else{D=53;break a}break}case 1:{if(!((f[c>>2]|0)<=65500?(f[A>>2]|0)<=65500:0)){C=f[a>>2]|0;f[C+20>>2]=42;f[C+24>>2]=65500;ki[f[C>>2]&2047](a)}C=f[k>>2]|0;if((C|0)!=8){E=f[a>>2]|0;f[E+20>>2]=16;f[E+24>>2]=C;ki[f[E>>2]&2047](a)}E=f[l>>2]|0;if((E|0)>10){C=f[a>>2]|0;f[C+20>>2]=27;f[C+24>>2]=E;f[C+28>>2]=10;ki[f[C>>2]&2047](a);F=f[l>>2]|0}else F=E;f[m>>2]=1;f[n>>2]=1;if((F|0)>0){E=F;C=1;G=1;H=0;I=f[o>>2]|0;while(1){J=I+8|0;K=f[J>>2]|0;L=I+12|0;if((K+-1|0)>>>0<=3?(M=f[L>>2]|0,(M+-1|0)>>>0<=3):0){N=G;O=K;P=C;Q=M;R=E}else{M=f[a>>2]|0;f[M+20>>2]=19;ki[f[M>>2]&2047](a);N=f[m>>2]|0;O=f[J>>2]|0;P=f[n>>2]|0;Q=f[L>>2]|0;R=f[l>>2]|0}G=(N|0)>(O|0)?N:O;f[m>>2]=G;C=(P|0)>(Q|0)?P:Q;f[n>>2]=C;H=H+1|0;if((H|0)>=(R|0)){S=R;break}else{E=R;I=I+88|0}}}else S=F;b:do if(!(f[p>>2]|0)){if(f[q>>2]|0?f[i>>2]|0:0){D=22;break}do switch(f[r>>2]|0){case 0:{f[v>>2]=1;f[w>>2]=120268;f[x>>2]=0;T=1;U=S;break b;break}case 3:{f[v>>2]=2;f[w>>2]=121448;f[x>>2]=3;T=2;U=S;break b;break}case 8:{f[v>>2]=3;f[w>>2]=121348;f[x>>2]=8;T=3;U=S;break b;break}case 15:{f[v>>2]=4;f[w>>2]=121220;f[x>>2]=15;T=4;U=S;break b;break}case 24:{f[v>>2]=5;f[w>>2]=121056;f[x>>2]=24;T=5;U=S;break b;break}case 35:{f[v>>2]=6;f[w>>2]=120848;f[x>>2]=35;T=6;U=S;break b;break}case 48:{f[v>>2]=7;f[w>>2]=120588;f[x>>2]=48;T=7;U=S;break b;break}case 63:{f[v>>2]=8;f[w>>2]=120268;f[x>>2]=63;T=8;U=S;break b;break}case 80:{f[v>>2]=9;f[w>>2]=120268;f[x>>2]=63;T=9;U=S;break b;break}case 99:{f[v>>2]=10;f[w>>2]=120268;f[x>>2]=63;T=10;U=S;break b;break}case 120:{f[v>>2]=11;f[w>>2]=120268;f[x>>2]=63;T=11;U=S;break b;break}case 143:{f[v>>2]=12;f[w>>2]=120268;f[x>>2]=63;T=12;U=S;break b;break}case 168:{f[v>>2]=13;f[w>>2]=120268;f[x>>2]=63;T=13;U=S;break b;break}case 195:{f[v>>2]=14;f[w>>2]=120268;f[x>>2]=63;T=14;U=S;break b;break}case 224:{f[v>>2]=15;f[w>>2]=120268;f[x>>2]=63;T=15;U=S;break b;break}case 255:{f[v>>2]=16;f[w>>2]=120268;f[x>>2]=63;T=16;U=S;break b;break}default:{I=f[a>>2]|0;f[I+20>>2]=17;f[I+24>>2]=f[s>>2];f[I+28>>2]=f[r>>2];f[I+32>>2]=f[t>>2];f[I+36>>2]=f[u>>2];ki[f[I>>2]&2047](a);T=f[v>>2]|0;U=f[l>>2]|0;break b}}while(0)}else D=22;while(0);if((D|0)==22){D=0;f[v>>2]=8;f[w>>2]=120268;f[x>>2]=63;T=8;U=S}f[y>>2]=T;f[z>>2]=T;if((U|0)>0){I=T;E=0;H=f[o>>2]|0;while(1){f[H+36>>2]=I;f[H+40>>2]=I;C=H+8|0;G=Y(f[C>>2]|0,f[A>>2]|0)|0;L=QGa(G,Y(f[m>>2]|0,I)|0)|0;f[H+28>>2]=L;L=H+12|0;G=Y(f[L>>2]|0,f[c>>2]|0)|0;J=QGa(G,Y(f[v>>2]|0,f[n>>2]|0)|0)|0;f[H+32>>2]=J;J=Y(f[C>>2]|0,f[A>>2]|0)|0;C=QGa(J,f[m>>2]|0)|0;f[H+44>>2]=C;C=Y(f[L>>2]|0,f[c>>2]|0)|0;L=QGa(C,f[n>>2]|0)|0;f[H+48>>2]=L;f[H+52>>2]=1;f[H+80>>2]=0;E=E+1|0;L=f[v>>2]|0;if((E|0)>=(f[l>>2]|0)){V=L;break}else{I=L;H=H+88|0}}}else V=T;H=QGa(f[c>>2]|0,Y(f[n>>2]|0,V)|0)|0;f[B>>2]=H;H=f[i>>2]|0;if((H|0)<(f[l>>2]|0))W=1;else W=(f[q>>2]|0)!=0&1;f[(f[b>>2]|0)+16>>2]=W;X=H;break}default:X=f[i>>2]|0}if(X|0){D=49;break}f[h>>2]=2}if((D|0)==49){f[h>>2]=0;e=1;return e|0}else if((D|0)==53){vFa(a);e=1;return e|0}else if((D|0)==54){f[d>>2]=1;if(!(f[h>>2]|0)){h=a+152|0;d=f[a+144>>2]|0;if((f[h>>2]|0)<=(d|0)){e=2;return e|0}f[h>>2]=d;e=2;return e|0}else{if(!(f[(f[g>>2]|0)+16>>2]|0)){e=2;return e|0}g=f[a>>2]|0;f[g+20>>2]=62;ki[f[g>>2]&2047](a);e=2;return e|0}}else if((D|0)==59)return e|0;return 0}function uFa(a){a=a|0;var b=0;b=f[a+460>>2]|0;f[b>>2]=247;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=1;ki[f[(f[a>>2]|0)+16>>2]&2047](a);ki[f[f[a+464>>2]>>2]&2047](a);f[a+160>>2]=0;return}function vFa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;b=a+340|0;c=f[b>>2]|0;if((c|0)!=1){if((c+-1|0)>>>0>3){d=f[a>>2]|0;f[d+20>>2]=27;f[d+24>>2]=c;f[d+28>>2]=4;ki[f[d>>2]&2047](a)}d=a+428|0;c=QGa(f[a+28>>2]|0,Y(f[d>>2]|0,f[a+316>>2]|0)|0)|0;f[a+360>>2]=c;c=QGa(f[a+32>>2]|0,Y(f[d>>2]|0,f[a+320>>2]|0)|0)|0;f[a+364>>2]=c;c=a+368|0;f[c>>2]=0;if((f[b>>2]|0)<=0){e=a+468|0;g=f[e>>2]|0;h=f[g>>2]|0;ki[h&2047](a);i=a+452|0;j=f[i>>2]|0;k=f[j>>2]|0;ki[k&2047](a);l=f[i>>2]|0;m=l+4|0;n=f[m>>2]|0;o=a+460|0;p=f[o>>2]|0;f[p>>2]=n;return}d=0;q=0;while(1){r=f[a+344+(q<<2)>>2]|0;s=f[r+8>>2]|0;f[r+56>>2]=s;t=f[r+12>>2]|0;f[r+60>>2]=t;u=Y(t,s)|0;f[r+64>>2]=u;v=Y(f[r+36>>2]|0,s)|0;f[r+68>>2]=v;v=((f[r+28>>2]|0)>>>0)%(s>>>0)|0;f[r+72>>2]=(v|0)==0?s:v;v=((f[r+32>>2]|0)>>>0)%(t>>>0)|0;f[r+76>>2]=(v|0)==0?t:v;if((u+d|0)>10){v=f[a>>2]|0;f[v+20>>2]=14;ki[f[v>>2]&2047](a)}if((u|0)>0){v=u;while(1){u=f[c>>2]|0;f[c>>2]=u+1;f[a+372+(u<<2)>>2]=q;if((v|0)>1)v=v+-1|0;else break}}v=q+1|0;w=f[b>>2]|0;if((v|0)>=(w|0))break;d=f[c>>2]|0;q=v}if((w|0)>0)x=w;else{e=a+468|0;g=f[e>>2]|0;h=f[g>>2]|0;ki[h&2047](a);i=a+452|0;j=f[i>>2]|0;k=f[j>>2]|0;ki[k&2047](a);l=f[i>>2]|0;m=l+4|0;n=f[m>>2]|0;o=a+460|0;p=f[o>>2]|0;f[p>>2]=n;return}}else{w=f[a+344>>2]|0;f[a+360>>2]=f[w+28>>2];q=f[w+32>>2]|0;f[a+364>>2]=q;f[w+56>>2]=1;f[w+60>>2]=1;f[w+64>>2]=1;f[w+68>>2]=f[w+36>>2];f[w+72>>2]=1;c=f[w+12>>2]|0;d=(q>>>0)%(c>>>0)|0;f[w+76>>2]=(d|0)==0?c:d;f[a+368>>2]=1;f[a+372>>2]=0;x=1}d=a+4|0;c=x;x=0;while(1){w=f[a+344+(x<<2)>>2]|0;q=w+80|0;if(!(f[q>>2]|0)){v=f[w+16>>2]|0;w=a+164+(v<<2)|0;if(!(v>>>0<=3?(f[w>>2]|0)!=0:0)){u=f[a>>2]|0;f[u+20>>2]=54;f[u+24>>2]=v;ki[f[u>>2]&2047](a)}u=ui[f[f[d>>2]>>2]&127](a,1,132)|0;K1a(u|0,f[w>>2]|0,132)|0;f[q>>2]=u;y=f[b>>2]|0}else y=c;x=x+1|0;if((x|0)>=(y|0))break;else c=y}e=a+468|0;g=f[e>>2]|0;h=f[g>>2]|0;ki[h&2047](a);i=a+452|0;j=f[i>>2]|0;k=f[j>>2]|0;ki[k&2047](a);l=f[i>>2]|0;m=l+4|0;n=f[m>>2]|0;o=a+460|0;p=f[o>>2]|0;f[p>>2]=n;return}function wFa(a){a=a|0;f[f[a+460>>2]>>2]=247;return}function xFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+440|0;d=f[c>>2]|0;e=f[a>>2]|0;f[e+20>>2]=124;f[e+24>>2]=d;f[e+28>>2]=b;Gh[f[e+4>>2]&511](a,-1);e=b+1&7|208;g=b+2&7|208;h=b+7&7|208;i=b+6&7|208;b=d;a:while(1){d=(b|0)==(e|0);j=(b|0)==(g|0);k=(b|0)==(h|0)|(b|0)==(i|0)?2:1;b:do if((b|0)<192){l=f[a>>2]|0;f[l+20>>2]=99;f[l+24>>2]=b;f[l+28>>2]=2;Gh[f[l+4>>2]&511](a,4)}else{if((b&-8|0)!=208){m=5;break a}if(d){m=8;break a}l=j?3:k;n=l&255;while(1){o=f[a>>2]|0;f[o+20>>2]=99;f[o+24>>2]=b;f[o+28>>2]=l;Gh[f[o+4>>2]&511](a,4);switch(n&3){case 1:{m=10;break a;break}case 3:{p=1;m=13;break a;break}case 2:{break b;break}default:{}}}}while(0);if(!(yFa(a)|0)){p=0;m=13;break}b=f[c>>2]|0}if((m|0)==5){i=f[a>>2]|0;f[i+20>>2]=99;f[i+24>>2]=b;f[i+28>>2]=3;Gh[f[i+4>>2]&511](a,4);p=1;return p|0}else if((m|0)==8){i=f[a>>2]|0;f[i+20>>2]=99;f[i+24>>2]=e;f[i+28>>2]=3;Gh[f[i+4>>2]&511](a,4);p=1;return p|0}else if((m|0)==10){f[c>>2]=0;p=1;return p|0}else if((m|0)==13)return p|0;return 0}function yFa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;c=f[a+24>>2]|0;d=c+4|0;e=c+12|0;g=a+464|0;h=f[d>>2]|0;i=f[c>>2]|0;a:while(1){if(!h){if(!(mi[f[e>>2]&255](a)|0)){j=0;k=19;break}l=f[d>>2]|0;m=f[c>>2]|0}else{l=h;m=i}n=l+-1|0;o=m+1|0;if((b[m>>0]|0)==-1){p=n;q=o}else{r=n;n=o;while(1){o=(f[g>>2]|0)+24|0;f[o>>2]=(f[o>>2]|0)+1;f[c>>2]=n;f[d>>2]=r;if(!r){if(!(mi[f[e>>2]&255](a)|0)){j=0;k=19;break a}s=f[d>>2]|0;t=f[c>>2]|0}else{s=r;t=n}o=s+-1|0;u=t+1|0;if((b[t>>0]|0)==-1){p=o;q=u;break}else{r=o;n=u}}}do{if(!p){if(!(mi[f[e>>2]&255](a)|0)){j=0;k=19;break a}v=f[d>>2]|0;w=f[c>>2]|0}else{v=p;w=q}p=v+-1|0;q=w+1|0;x=b[w>>0]|0}while(x<<24>>24==-1);n=(f[g>>2]|0)+24|0;y=f[n>>2]|0;if(x<<24>>24){k=16;break}f[n>>2]=y+2;f[c>>2]=q;f[d>>2]=p;h=p;i=q}if((k|0)==16){i=x&255;if(y|0){x=f[a>>2]|0;f[x+20>>2]=119;f[x+24>>2]=y;f[x+28>>2]=i;Gh[f[x+4>>2]&511](a,-1);f[(f[g>>2]|0)+24>>2]=0}f[a+440>>2]=i;f[c>>2]=q;f[d>>2]=p;j=1;return j|0}else if((k|0)==19)return j|0;return 0}function zFa(a){a=a|0;var b=0,c=0;b=ui[f[f[a+4>>2]>>2]&127](a,0,172)|0;c=a+464|0;f[c>>2]=b;f[b>>2]=988;f[b+4>>2]=248;f[b+8>>2]=249;f[b+28>>2]=250;f[b+96>>2]=0;f[b+100>>2]=0;f[b+36>>2]=250;f[b+104>>2]=0;f[b+40>>2]=250;f[b+108>>2]=0;f[b+44>>2]=250;f[b+112>>2]=0;f[b+48>>2]=250;f[b+116>>2]=0;f[b+52>>2]=250;f[b+120>>2]=0;f[b+56>>2]=250;f[b+124>>2]=0;f[b+60>>2]=250;f[b+128>>2]=0;f[b+64>>2]=250;f[b+132>>2]=0;f[b+68>>2]=250;f[b+136>>2]=0;f[b+72>>2]=250;f[b+140>>2]=0;f[b+76>>2]=250;f[b+144>>2]=0;f[b+80>>2]=250;f[b+148>>2]=0;f[b+84>>2]=250;f[b+152>>2]=0;f[b+156>>2]=0;f[b+92>>2]=250;f[b+160>>2]=0;f[b+32>>2]=251;f[b+88>>2]=251;b=f[c>>2]|0;f[a+216>>2]=0;f[a+144>>2]=0;f[a+440>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+24>>2]=0;f[b+164>>2]=0;return}function AFa(a){a=a|0;var b=0;b=f[a+464>>2]|0;f[a+216>>2]=0;f[a+144>>2]=0;f[a+440>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+24>>2]=0;f[b+164>>2]=0;return}function BFa(a){a=a|0;var c=0,e=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0;c=u;u=u+288|0;e=c+256|0;g=c;i=a+440|0;k=a+464|0;l=a+24|0;m=a+232|0;n=a+248|0;o=a+264|0;p=a+233|0;q=a+249|0;r=a+265|0;s=a+234|0;t=a+250|0;v=a+266|0;w=a+235|0;x=a+251|0;y=a+267|0;z=a+236|0;A=a+252|0;B=a+268|0;C=a+237|0;D=a+253|0;E=a+269|0;F=a+238|0;G=a+254|0;H=a+270|0;I=a+239|0;J=a+255|0;K=a+271|0;L=a+240|0;M=a+256|0;N=a+272|0;O=a+241|0;P=a+257|0;Q=a+273|0;R=a+242|0;S=a+258|0;T=a+274|0;U=a+243|0;V=a+259|0;W=a+275|0;X=a+244|0;Y=a+260|0;Z=a+276|0;_=a+245|0;$=a+261|0;aa=a+277|0;ba=a+246|0;ca=a+262|0;da=a+278|0;ea=a+247|0;fa=a+263|0;ga=a+279|0;ha=a+280|0;ia=a+40|0;ja=a+304|0;ka=a+308|0;la=a+284|0;ma=a+288|0;na=a+289|0;oa=a+290|0;pa=a+292|0;qa=a+294|0;ra=a+296|0;sa=a+300|0;ta=e+1|0;ua=e+2|0;va=e+3|0;wa=e+4|0;xa=e+5|0;ya=e+6|0;za=e+7|0;Aa=e+8|0;Ba=e+9|0;Ca=e+10|0;Da=e+11|0;Ea=e+12|0;Fa=e+13|0;Ga=e+14|0;Ha=e+15|0;Ia=e+16|0;Ja=a+36|0;Ka=a+216|0;La=f[i>>2]|0;a:while(1){do if(!La){if(f[(f[k>>2]|0)+12>>2]|0){if(!(yFa(a)|0)){Ma=0;Na=301;break a}Oa=f[i>>2]|0;break}Pa=f[l>>2]|0;Qa=Pa+4|0;Ra=f[Qa>>2]|0;if(!Ra){if(!(mi[f[Pa+12>>2]&255](a)|0)){Ma=0;Na=301;break a}Sa=f[Qa>>2]|0}else Sa=Ra;Ra=f[Pa>>2]|0;Ta=Sa+-1|0;Ua=Ra+1|0;Va=b[Ra>>0]|0;Ra=Va&255;if(!Ta){if(!(mi[f[Pa+12>>2]&255](a)|0)){Ma=0;Na=301;break a}Wa=f[Qa>>2]|0;Xa=f[Pa>>2]|0}else{Wa=Ta;Xa=Ua}Ua=b[Xa>>0]|0;Ta=Ua&255;if(Va<<24>>24!=-1|Ua<<24>>24!=-40){Ua=f[a>>2]|0;f[Ua+20>>2]=55;f[Ua+24>>2]=Ra;f[Ua+28>>2]=Ta;ki[f[Ua>>2]&2047](a)}f[i>>2]=Ta;f[Pa>>2]=Xa+1;f[Qa>>2]=Wa+-1;Oa=Ta}else Oa=La;while(0);do switch(Oa|0){case 218:{Na=25;break a;break}case 217:{Na=72;break a;break}case 216:{Ta=f[a>>2]|0;f[Ta+20>>2]=104;Gh[f[Ta+4>>2]&511](a,1);Ta=f[k>>2]|0;if(!(f[Ta+12>>2]|0))Ya=Ta;else{Ta=f[a>>2]|0;f[Ta+20>>2]=64;ki[f[Ta>>2]&2047](a);Ya=f[k>>2]|0}b[m>>0]=0;b[n>>0]=1;b[o>>0]=5;b[p>>0]=0;b[q>>0]=1;b[r>>0]=5;b[s>>0]=0;b[t>>0]=1;b[v>>0]=5;b[w>>0]=0;b[x>>0]=1;b[y>>0]=5;b[z>>0]=0;b[A>>0]=1;b[B>>0]=5;b[C>>0]=0;b[D>>0]=1;b[E>>0]=5;b[F>>0]=0;b[G>>0]=1;b[H>>0]=5;b[I>>0]=0;b[J>>0]=1;b[K>>0]=5;b[L>>0]=0;b[M>>0]=1;b[N>>0]=5;b[O>>0]=0;b[P>>0]=1;b[Q>>0]=5;b[R>>0]=0;b[S>>0]=1;b[T>>0]=5;b[U>>0]=0;b[V>>0]=1;b[W>>0]=5;b[X>>0]=0;b[Y>>0]=1;b[Z>>0]=5;b[_>>0]=0;b[$>>0]=1;b[aa>>0]=5;b[ba>>0]=0;b[ca>>0]=1;b[da>>0]=5;b[ea>>0]=0;b[fa>>0]=1;b[ga>>0]=5;f[ha>>2]=0;f[ia>>2]=0;f[ja>>2]=0;f[ka>>2]=0;f[la>>2]=0;b[ma>>0]=1;b[na>>0]=1;b[oa>>0]=0;d[pa>>1]=1;d[qa>>1]=1;f[ra>>2]=0;b[sa>>0]=0;f[Ya+12>>2]=1;break}case 192:{if(!(GFa(a,1,0,0)|0)){Ma=0;Na=301;break a}break}case 193:{if(!(GFa(a,0,0,0)|0)){Ma=0;Na=301;break a}break}case 194:{if(!(GFa(a,0,1,0)|0)){Ma=0;Na=301;break a}break}case 201:{if(!(GFa(a,0,0,1)|0)){Ma=0;Na=301;break a}break}case 202:{if(!(GFa(a,0,1,1)|0)){Ma=0;Na=301;break a}break}case 207:case 206:case 205:case 203:case 200:case 199:case 198:case 197:case 195:{Ta=f[a>>2]|0;f[Ta+20>>2]=63;f[Ta+24>>2]=Oa;ki[f[Ta>>2]&2047](a);break}case 204:{Ta=f[l>>2]|0;Qa=Ta+4|0;Pa=f[Qa>>2]|0;if(!Pa){if(!(mi[f[Ta+12>>2]&255](a)|0)){Ma=0;Na=301;break a}Za=f[Qa>>2]|0}else Za=Pa;Pa=f[Ta>>2]|0;Ua=Za+-1|0;Ra=Pa+1|0;Va=h[Pa>>0]<<8;if(!Ua){if(!(mi[f[Ta+12>>2]&255](a)|0)){Ma=0;Na=301;break a}_a=f[Qa>>2]|0;$a=f[Ta>>2]|0}else{_a=Ua;$a=Ra}Ra=_a+-1|0;Ua=$a+1|0;Pa=h[$a>>0]|Va;Va=Pa+-2|0;if(Pa>>>0>2){Pa=Ta+12|0;ab=Ra;bb=Va;cb=Ua;while(1){if(!ab){if(!(mi[f[Pa>>2]&255](a)|0)){Ma=0;Na=301;break a}db=f[Qa>>2]|0;eb=f[Ta>>2]|0}else{db=ab;eb=cb}fb=db+-1|0;gb=eb+1|0;hb=b[eb>>0]|0;ib=hb&255;if(!fb){if(!(mi[f[Pa>>2]&255](a)|0)){Ma=0;Na=301;break a}jb=f[Qa>>2]|0;kb=f[Ta>>2]|0}else{jb=fb;kb=gb}gb=jb+-1|0;fb=kb+1|0;lb=b[kb>>0]|0;mb=lb&255;nb=bb+-2|0;ob=f[a>>2]|0;f[ob+20>>2]=81;f[ob+24>>2]=ib;f[ob+28>>2]=mb;Gh[f[ob+4>>2]&511](a,1);if((hb&255)<=31)if((hb&255)<=15){hb=mb&15;b[a+232+ib>>0]=hb;ob=(lb&255)>>>4;b[a+248+ib>>0]=ob;if(hb>>>0>(ob&255)>>>0){ob=f[a>>2]|0;f[ob+20>>2]=30;f[ob+24>>2]=mb;ki[f[ob>>2]&2047](a)}}else Na=90;else{ob=f[a>>2]|0;f[ob+20>>2]=29;f[ob+24>>2]=ib;ki[f[ob>>2]&2047](a);Na=90}if((Na|0)==90){Na=0;b[ib+-16+(a+264)>>0]=lb}if((bb|0)>2){ab=gb;bb=nb;cb=fb}else{pb=gb;qb=nb;rb=fb;break}}}else{pb=Ra;qb=Va;rb=Ua}if(qb|0){cb=f[a>>2]|0;f[cb+20>>2]=12;ki[f[cb>>2]&2047](a)}f[Ta>>2]=rb;f[Qa>>2]=pb;break}case 196:{cb=f[l>>2]|0;bb=cb+4|0;ab=f[bb>>2]|0;if(!ab){if(!(mi[f[cb+12>>2]&255](a)|0)){Na=127;break a}sb=f[bb>>2]|0}else sb=ab;ab=f[cb>>2]|0;Pa=sb+-1|0;fb=ab+1|0;nb=h[ab>>0]<<8;if(!Pa){if(!(mi[f[cb+12>>2]&255](a)|0)){Na=127;break a}tb=f[bb>>2]|0;ub=f[cb>>2]|0}else{tb=Pa;ub=fb}fb=tb+-1|0;Pa=ub+1|0;ab=(h[ub>>0]|nb)+-2|0;if((ab|0)>16){nb=cb+12|0;gb=fb;lb=ab;ib=Pa;while(1){if(!gb){if(!(mi[f[nb>>2]&255](a)|0)){Na=127;break a}vb=f[bb>>2]|0;wb=f[cb>>2]|0}else{vb=gb;wb=ib}ob=h[wb>>0]|0;mb=f[a>>2]|0;f[mb+20>>2]=82;f[mb+24>>2]=ob;Gh[f[mb+4>>2]&511](a,1);b[e>>0]=0;mb=vb+-1|0;hb=0;xb=1;yb=wb+1|0;do{if(!mb){if(!(mi[f[nb>>2]&255](a)|0)){Na=127;break a}zb=f[bb>>2]|0;Ab=f[cb>>2]|0}else{zb=mb;Ab=yb}Bb=b[Ab>>0]|0;b[e+xb>>0]=Bb;hb=(Bb&255)+hb|0;xb=xb+1|0;mb=zb+-1|0;yb=Ab+1|0}while((xb|0)<17);xb=lb+-17|0;Bb=f[a>>2]|0;f[Bb+24>>2]=h[ta>>0];f[Bb+28>>2]=h[ua>>0];f[Bb+32>>2]=h[va>>0];f[Bb+36>>2]=h[wa>>0];f[Bb+40>>2]=h[xa>>0];f[Bb+44>>2]=h[ya>>0];f[Bb+48>>2]=h[za>>0];f[Bb+52>>2]=h[Aa>>0];f[Bb+20>>2]=88;Gh[f[Bb+4>>2]&511](a,2);Bb=f[a>>2]|0;f[Bb+24>>2]=h[Ba>>0];f[Bb+28>>2]=h[Ca>>0];f[Bb+32>>2]=h[Da>>0];f[Bb+36>>2]=h[Ea>>0];f[Bb+40>>2]=h[Fa>>0];f[Bb+44>>2]=h[Ga>>0];f[Bb+48>>2]=h[Ha>>0];f[Bb+52>>2]=h[Ia>>0];f[Bb+20>>2]=88;Gh[f[Bb+4>>2]&511](a,2);if((hb|0)>256|(xb|0)<(hb|0)){Bb=f[a>>2]|0;f[Bb+20>>2]=9;ki[f[Bb>>2]&2047](a)}if((hb|0)>0){Bb=mb;Cb=0;Db=yb;while(1){if(!Bb){if(!(mi[f[nb>>2]&255](a)|0)){Na=127;break a}Eb=f[bb>>2]|0;Fb=f[cb>>2]|0}else{Eb=Bb;Fb=Db}Gb=Eb+-1|0;Hb=Fb+1|0;b[g+Cb>>0]=b[Fb>>0]|0;Cb=Cb+1|0;if((Cb|0)>=(hb|0)){Ib=Gb;Jb=Hb;break}else{Bb=Gb;Db=Hb}}}else{Ib=mb;Jb=yb}Db=xb-hb|0;Bb=(ob&16|0)==0;Cb=ob+-16|0;Hb=Bb?ob:Cb;Gb=Bb?a+180+(ob<<2)|0:a+196+(Cb<<2)|0;if(Hb>>>0>3){Cb=f[a>>2]|0;f[Cb+20>>2]=31;f[Cb+24>>2]=Hb;ki[f[Cb>>2]&2047](a)}Cb=f[Gb>>2]|0;if(!Cb){Hb=HEa(a)|0;f[Gb>>2]=Hb;Kb=Hb}else Kb=Cb;Cb=Kb;Hb=e;Bb=Cb+17|0;do{b[Cb>>0]=b[Hb>>0]|0;Cb=Cb+1|0;Hb=Hb+1|0}while((Cb|0)<(Bb|0));K1a((f[Gb>>2]|0)+17|0,g|0,256)|0;if((Db|0)>16){gb=Ib;lb=Db;ib=Jb}else{Lb=Ib;Mb=Db;Nb=Jb;break}}}else{Lb=fb;Mb=ab;Nb=Pa}if(Mb|0){ib=f[a>>2]|0;f[ib+20>>2]=12;ki[f[ib>>2]&2047](a)}f[cb>>2]=Nb;f[bb>>2]=Lb;break}case 219:{ib=f[l>>2]|0;lb=ib+4|0;gb=f[lb>>2]|0;if(!gb){if(!(mi[f[ib+12>>2]&255](a)|0)){Ma=0;Na=301;break a}Ob=f[lb>>2]|0}else Ob=gb;gb=f[ib>>2]|0;nb=Ob+-1|0;Qa=gb+1|0;Ta=h[gb>>0]<<8;if(!nb){if(!(mi[f[ib+12>>2]&255](a)|0)){Ma=0;Na=301;break a}Pb=f[lb>>2]|0;Qb=f[ib>>2]|0}else{Pb=nb;Qb=Qa}Qa=Pb+-1|0;nb=Qb+1|0;gb=h[Qb>>0]|Ta;Ta=gb+-2|0;if(gb>>>0>2){gb=ib+12|0;Ua=Qa;Va=Ta;Ra=nb;while(1){Hb=Va+-1|0;if(!Ua){if(!(mi[f[gb>>2]&255](a)|0)){Ma=0;Na=301;break a}Rb=f[lb>>2]|0;Sb=f[ib>>2]|0}else{Rb=Ua;Sb=Ra}Cb=h[Sb>>0]|0;Bb=Cb>>>4;ob=Cb&15;Cb=f[a>>2]|0;f[Cb+20>>2]=83;f[Cb+24>>2]=ob;f[Cb+28>>2]=Bb;Gh[f[Cb+4>>2]&511](a,1);if(ob>>>0>3){Cb=f[a>>2]|0;f[Cb+20>>2]=32;f[Cb+24>>2]=ob;ki[f[Cb>>2]&2047](a)}Cb=a+164+(ob<<2)|0;ob=f[Cb>>2]|0;if(!ob){hb=GEa(a)|0;f[Cb>>2]=hb;Tb=hb}else Tb=ob;ob=(Bb|0)!=0;if(ob)if((Va|0)<129){Bb=0;do{d[Tb+(Bb<<1)>>1]=1;Bb=Bb+1|0}while((Bb|0)!=64);Ub=Hb>>1;Na=150}else Na=157;else if((Va|0)<65){Bb=0;do{d[Tb+(Bb<<1)>>1]=1;Bb=Bb+1|0}while((Bb|0)!=64);Ub=Hb;Na=150}else Na=157;b:do if((Na|0)==150){Na=0;switch(Ub|0){case 4:{Vb=4;Wb=121448;break}case 9:{Vb=Ub;Wb=121348;break}case 16:{Vb=Ub;Wb=121220;break}case 25:{Vb=Ub;Wb=121056;break}case 36:{Vb=Ub;Wb=120848;break}case 49:{Vb=Ub;Wb=120588;break}default:{Bb=Rb+-1|0;Db=Sb+1|0;if((Ub|0)>0){Xb=Bb;Yb=Ub;Zb=120268;_b=Db;Na=159;break b}else{$b=Bb;ac=Ub;bc=Db;break b}}}Xb=Rb+-1|0;Yb=Vb;Zb=Wb;_b=Sb+1|0;Na=159}else if((Na|0)==157){Na=0;Xb=Rb+-1|0;Yb=64;Zb=120268;_b=Sb+1|0;Na=159}while(0);c:do if((Na|0)==159){Na=0;if(ob){cc=Xb;dc=0;ec=_b}else{Db=Xb;Bb=0;Gb=_b;while(1){if(!Db){if(!(mi[f[gb>>2]&255](a)|0)){Ma=0;Na=301;break a}fc=f[lb>>2]|0;gc=f[ib>>2]|0}else{fc=Db;gc=Gb}d[Tb+(f[Zb+(Bb<<2)>>2]<<1)>>1]=h[gc>>0]|0;Bb=Bb+1|0;hb=fc+-1|0;Cb=gc+1|0;if((Bb|0)>=(Yb|0)){$b=hb;ac=Yb;bc=Cb;break c}else{Db=hb;Gb=Cb}}}while(1){if(!cc){if(!(mi[f[gb>>2]&255](a)|0)){Ma=0;Na=301;break a}hc=f[lb>>2]|0;ic=f[ib>>2]|0}else{hc=cc;ic=ec}Gb=hc+-1|0;Db=ic+1|0;Bb=h[ic>>0]<<8;if(!Gb){if(!(mi[f[gb>>2]&255](a)|0)){Ma=0;Na=301;break a}jc=f[lb>>2]|0;kc=f[ib>>2]|0}else{jc=Gb;kc=Db}d[Tb+(f[Zb+(dc<<2)>>2]<<1)>>1]=h[kc>>0]|Bb;dc=dc+1|0;Bb=jc+-1|0;Db=kc+1|0;if((dc|0)>=(Yb|0)){$b=Bb;ac=Yb;bc=Db;break}else{cc=Bb;ec=Db}}}while(0);Db=f[a>>2]|0;d:do if((f[Db+104>>2]|0)>1){Bb=Db;Gb=0;while(1){f[Bb+24>>2]=j[Tb+(Gb<<1)>>1];f[Bb+28>>2]=j[Tb+((Gb|1)<<1)>>1];f[Bb+32>>2]=j[Tb+((Gb|2)<<1)>>1];f[Bb+36>>2]=j[Tb+((Gb|3)<<1)>>1];f[Bb+40>>2]=j[Tb+((Gb|4)<<1)>>1];f[Bb+44>>2]=j[Tb+((Gb|5)<<1)>>1];f[Bb+48>>2]=j[Tb+((Gb|6)<<1)>>1];f[Bb+52>>2]=j[Tb+((Gb|7)<<1)>>1];f[Bb+20>>2]=95;Gh[f[Bb+4>>2]&511](a,2);Cb=Gb+8|0;if((Cb|0)>=64)break d;Bb=f[a>>2]|0;Gb=Cb}}while(0);Db=Hb-ac+(ob?0-ac|0:0)|0;if((Db|0)>0){Ua=$b;Va=Db;Ra=bc}else{lc=$b;mc=Db;nc=bc;break}}}else{lc=Qa;mc=Ta;nc=nb}if(mc|0){Ra=f[a>>2]|0;f[Ra+20>>2]=12;ki[f[Ra>>2]&2047](a)}f[ib>>2]=nc;f[lb>>2]=lc;break}case 221:{Ra=f[l>>2]|0;Va=Ra+4|0;Ua=f[Va>>2]|0;if(!Ua){if(!(mi[f[Ra+12>>2]&255](a)|0)){Ma=0;Na=301;break a}oc=f[Va>>2]|0}else oc=Ua;Ua=f[Ra>>2]|0;gb=oc+-1|0;bb=Ua+1|0;cb=h[Ua>>0]<<8;if(!gb){if(!(mi[f[Ra+12>>2]&255](a)|0)){Ma=0;Na=301;break a}pc=f[Va>>2]|0;qc=f[Ra>>2]|0}else{pc=gb;qc=bb}bb=pc+-1|0;gb=qc+1|0;if((h[qc>>0]|cb|0)!=4){cb=f[a>>2]|0;f[cb+20>>2]=12;ki[f[cb>>2]&2047](a)}if(!bb){if(!(mi[f[Ra+12>>2]&255](a)|0)){Ma=0;Na=301;break a}rc=f[Va>>2]|0;sc=f[Ra>>2]|0}else{rc=bb;sc=gb}gb=rc+-1|0;bb=sc+1|0;cb=h[sc>>0]<<8;if(!gb){if(!(mi[f[Ra+12>>2]&255](a)|0)){Ma=0;Na=301;break a}tc=f[Va>>2]|0;uc=f[Ra>>2]|0}else{tc=gb;uc=bb}bb=h[uc>>0]|cb;cb=f[a>>2]|0;f[cb+20>>2]=84;f[cb+24>>2]=bb;Gh[f[cb+4>>2]&511](a,1);f[ha>>2]=bb;f[Ra>>2]=uc+1;f[Va>>2]=tc+-1;break}case 248:{Va=f[l>>2]|0;Ra=f[Va>>2]|0;bb=Va+4|0;cb=f[bb>>2]|0;if(!(f[(f[k>>2]|0)+16>>2]|0)){gb=f[a>>2]|0;f[gb+20>>2]=60;bLa(gb+24|0,360747,80)|0;ki[f[f[a>>2]>>2]&2047](a)}do if((f[Ja>>2]|0)>=3){if(!cb){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}vc=f[bb>>2]|0;wc=f[Va>>2]|0}else{vc=cb;wc=Ra}gb=vc+-1|0;Ua=wc+1|0;Pa=h[wc>>0]<<8;if(!gb){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}xc=f[bb>>2]|0;yc=f[Va>>2]|0}else{xc=gb;yc=Ua}Ua=xc+-1|0;gb=yc+1|0;if((h[yc>>0]|Pa|0)!=24){Pa=f[a>>2]|0;f[Pa+20>>2]=12;ki[f[Pa>>2]&2047](a)}if(!Ua){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}zc=f[bb>>2]|0;Ac=f[Va>>2]|0}else{zc=Ua;Ac=gb}gb=zc+-1|0;Ua=Ac+1|0;if((b[Ac>>0]|0)!=13){Pa=f[a>>2]|0;f[Pa+20>>2]=70;f[Pa+24>>2]=f[i>>2];ki[f[Pa>>2]&2047](a)}if(!gb){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}Bc=f[bb>>2]|0;Cc=f[Va>>2]|0}else{Bc=gb;Cc=Ua}Ua=Bc+-1|0;gb=Cc+1|0;Pa=h[Cc>>0]<<8;if(!Ua){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}Dc=f[bb>>2]|0;Ec=f[Va>>2]|0}else{Dc=Ua;Ec=gb}gb=Dc+-1|0;Ua=Ec+1|0;if((h[Ec>>0]|Pa|0)==255){if(!gb){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}Fc=f[bb>>2]|0;Gc=f[Va>>2]|0}else{Fc=gb;Gc=Ua}Pa=Fc+-1|0;ab=Gc+1|0;if((b[Gc>>0]|0)==3){if(!Pa){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}Hc=f[bb>>2]|0;Ic=f[Va>>2]|0}else{Hc=Pa;Ic=ab}fb=Hc+-1|0;Db=Ic+1|0;Gb=f[Ka>>2]|0;if((h[Ic>>0]|0)==(f[Gb+88>>2]|0)){if(!fb){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}Jc=f[Ka>>2]|0;Kc=f[bb>>2]|0;Lc=f[Va>>2]|0}else{Jc=Gb;Kc=fb;Lc=Db}Gb=Kc+-1|0;Bb=Lc+1|0;if((h[Lc>>0]|0)==(f[Jc>>2]|0)){if(!Gb){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}Mc=f[Ka>>2]|0;Nc=f[bb>>2]|0;Oc=f[Va>>2]|0}else{Mc=Jc;Nc=Gb;Oc=Bb}Cb=Nc+-1|0;hb=Oc+1|0;if((h[Oc>>0]|0)!=(f[Mc+176>>2]|0)){Pc=Cb;Qc=hb;Na=286;break}if(!Cb){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}Rc=f[bb>>2]|0;Sc=f[Va>>2]|0}else{Rc=Cb;Sc=hb}hb=Rc+-1|0;Cb=Sc+1|0;if((b[Sc>>0]|0)!=-128){Pc=hb;Qc=Cb;Na=286;break}if(!hb){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}Tc=f[bb>>2]|0;Uc=f[Va>>2]|0}else{Tc=hb;Uc=Cb}Cb=Tc+-1|0;hb=Uc+1|0;xb=h[Uc>>0]<<8;if(!Cb){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}Vc=f[bb>>2]|0;Wc=f[Va>>2]|0}else{Vc=Cb;Wc=hb}hb=Vc+-1|0;Cb=Wc+1|0;if(h[Wc>>0]|xb|0){Pc=hb;Qc=Cb;Na=286;break}if(!hb){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}Xc=f[bb>>2]|0;Yc=f[Va>>2]|0}else{Xc=hb;Yc=Cb}Cb=Xc+-1|0;hb=Yc+1|0;xb=h[Yc>>0]<<8;if(!Cb){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}Zc=f[bb>>2]|0;_c=f[Va>>2]|0}else{Zc=Cb;_c=hb}hb=Zc+-1|0;Cb=_c+1|0;if(h[_c>>0]|xb|0){Pc=hb;Qc=Cb;Na=286;break}if(!hb){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}$c=f[bb>>2]|0;ad=f[Va>>2]|0}else{$c=hb;ad=Cb}Cb=$c+-1|0;hb=ad+1|0;if(b[ad>>0]|0){Pc=Cb;Qc=hb;Na=286;break}if(!Cb){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}bd=f[bb>>2]|0;cd=f[Va>>2]|0}else{bd=Cb;cd=hb}hb=bd+-1|0;Cb=cd+1|0;xb=h[cd>>0]<<8;if(!hb){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}dd=f[bb>>2]|0;ed=f[Va>>2]|0}else{dd=hb;ed=Cb}Cb=dd+-1|0;hb=ed+1|0;if((h[ed>>0]|xb|0)!=1){Pc=Cb;Qc=hb;Na=286;break}if(!Cb){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}fd=f[bb>>2]|0;gd=f[Va>>2]|0}else{fd=Cb;gd=hb}hb=fd+-1|0;Cb=gd+1|0;xb=h[gd>>0]<<8;if(!hb){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}hd=f[bb>>2]|0;id=f[Va>>2]|0}else{hd=hb;id=Cb}Cb=hd+-1|0;hb=id+1|0;if(h[id>>0]|xb|0){Pc=Cb;Qc=hb;Na=286;break}if(!Cb){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}jd=f[bb>>2]|0;kd=f[Va>>2]|0}else{jd=Cb;kd=hb}hb=jd+-1|0;Cb=kd+1|0;if(b[kd>>0]|0){Pc=hb;Qc=Cb;Na=286;break}if(!hb){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}ld=f[bb>>2]|0;md=f[Va>>2]|0}else{ld=hb;md=Cb}Cb=ld+-1|0;hb=md+1|0;xb=h[md>>0]<<8;if(!Cb){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}nd=f[bb>>2]|0;od=f[Va>>2]|0}else{nd=Cb;od=hb}hb=nd+-1|0;Cb=od+1|0;if((h[od>>0]|xb|0)!=1){Pc=hb;Qc=Cb;Na=286;break}if(!hb){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}pd=f[bb>>2]|0;qd=f[Va>>2]|0}else{pd=hb;qd=Cb}Cb=pd+-1|0;hb=qd+1|0;xb=h[qd>>0]<<8;if(!Cb){if(!(mi[f[Va+12>>2]&255](a)|0)){Ma=0;Na=301;break a}rd=f[bb>>2]|0;sd=f[Va>>2]|0}else{rd=Cb;sd=hb}hb=rd+-1|0;Cb=sd+1|0;if(!(h[sd>>0]|xb)){td=hb;ud=Cb}else{Pc=hb;Qc=Cb;Na=286}}else{Pc=Gb;Qc=Bb;Na=286}}else{Pc=fb;Qc=Db;Na=286}}else{Pc=Pa;Qc=ab;Na=286}}else{Pc=gb;Qc=Ua;Na=286}}else{Pc=cb;Qc=Ra;Na=286}while(0);if((Na|0)==286){Na=0;Ra=f[a>>2]|0;f[Ra+20>>2]=28;ki[f[Ra>>2]&2047](a);td=Pc;ud=Qc}f[ja>>2]=1;f[Va>>2]=ud;f[bb>>2]=td;break}case 239:case 238:case 237:case 236:case 235:case 234:case 233:case 232:case 231:case 230:case 229:case 228:case 227:case 226:case 225:case 224:{if(!(mi[f[(f[k>>2]|0)+32+(Oa+-224<<2)>>2]&255](a)|0)){Ma=0;Na=301;break a}break}case 254:{if(!(mi[f[(f[k>>2]|0)+28>>2]&255](a)|0)){Ma=0;Na=301;break a}break}case 1:case 215:case 214:case 213:case 212:case 211:case 210:case 209:case 208:{Ra=f[a>>2]|0;f[Ra+20>>2]=94;f[Ra+24>>2]=Oa;Gh[f[Ra+4>>2]&511](a,1);break}case 220:{Ra=f[l>>2]|0;cb=Ra+4|0;lb=f[cb>>2]|0;if(!lb){if(!(mi[f[Ra+12>>2]&255](a)|0)){Ma=0;Na=301;break a}vd=f[cb>>2]|0}else vd=lb;lb=f[Ra>>2]|0;ib=vd+-1|0;nb=lb+1|0;Ta=h[lb>>0]<<8;if(!ib){if(!(mi[f[Ra+12>>2]&255](a)|0)){Ma=0;Na=301;break a}wd=f[cb>>2]|0;xd=f[Ra>>2]|0}else{wd=ib;xd=nb}nb=h[xd>>0]|Ta;Ta=nb+-2|0;ib=f[a>>2]|0;f[ib+20>>2]=93;f[ib+24>>2]=f[i>>2];f[ib+28>>2]=Ta;Gh[f[ib+4>>2]&511](a,1);f[Ra>>2]=xd+1;f[cb>>2]=wd+-1;if(nb>>>0>2)Gh[f[(f[l>>2]|0)+16>>2]&511](a,Ta);break}default:{Ta=f[a>>2]|0;f[Ta+20>>2]=70;f[Ta+24>>2]=Oa;ki[f[Ta>>2]&2047](a)}}while(0);f[i>>2]=0;La=0}if((Na|0)==25){La=f[l>>2]|0;l=f[La>>2]|0;Oa=La+4|0;wd=f[Oa>>2]|0;if(!(f[(f[k>>2]|0)+16>>2]|0)){xd=f[a>>2]|0;f[xd+20>>2]=60;bLa(xd+24|0,360743,80)|0;ki[f[f[a>>2]>>2]&2047](a)}do if(!wd)if(!(mi[f[La+12>>2]&255](a)|0)){Ma=0;u=c;return Ma|0}else{yd=f[Oa>>2]|0;zd=f[La>>2]|0;break}else{yd=wd;zd=l}while(0);l=yd+-1|0;yd=zd+1|0;wd=h[zd>>0]<<8;do if(!l)if(!(mi[f[La+12>>2]&255](a)|0)){Ma=0;u=c;return Ma|0}else{Ad=f[Oa>>2]|0;Bd=f[La>>2]|0;break}else{Ad=l;Bd=yd}while(0);yd=Ad+-1|0;Ad=Bd+1|0;l=h[Bd>>0]|wd;do if(!yd)if(!(mi[f[La+12>>2]&255](a)|0)){Ma=0;u=c;return Ma|0}else{Cd=f[Oa>>2]|0;Dd=f[La>>2]|0;break}else{Cd=yd;Dd=Ad}while(0);Ad=b[Dd>>0]|0;yd=Ad&255;wd=f[a>>2]|0;f[wd+20>>2]=105;f[wd+24>>2]=yd;Gh[f[wd+4>>2]&511](a,1);do if(!((Ad&255)>4|(l|0)!=((yd<<1)+6|0))){if(Ad<<24>>24){f[a+340>>2]=yd;wd=Cd+-1|0;Ed=wd;Fd=(wd|0)==0;Gd=Dd+1|0;Na=42;break}if(f[a+224>>2]|0){f[a+340>>2]=yd;wd=Cd+-1|0;if(!wd){Hd=1;Na=61}else{Id=wd;Jd=1;Kd=Dd+1|0}}else Na=41}else Na=41;while(0);if((Na|0)==41){l=f[a>>2]|0;f[l+20>>2]=12;ki[f[l>>2]&2047](a);f[a+340>>2]=yd;l=Cd+-1|0;Cd=Dd+1|0;Dd=(l|0)==0;if(!(Ad<<24>>24)){Ld=l;Md=1;Nd=Dd;Od=Cd;Na=60}else{Ed=l;Fd=Dd;Gd=Cd;Na=42}}e:do if((Na|0)==42){Cd=La+12|0;Dd=a+344|0;l=Ed;Ad=Fd;wd=0;Bd=Gd;while(1){if(Ad){if(!(mi[f[Cd>>2]&255](a)|0)){Ma=0;Na=301;break}Pd=f[Oa>>2]|0;Qd=f[La>>2]|0}else{Pd=l;Qd=Bd}zd=Pd+-1|0;xd=Qd+1|0;vd=h[Qd>>0]|0;f:do if((wd|0)>0){td=0;while(1){if((vd|0)==(f[f[a+344+(td<<2)>>2]>>2]|0))break;td=td+1|0;if((td|0)>=(wd|0)){Rd=vd;break f}}td=f[f[Dd>>2]>>2]|0;if((wd|0)>1){ob=td;Hb=1;while(1){ud=f[f[a+344+(Hb<<2)>>2]>>2]|0;ja=(ud|0)>(ob|0)?ud:ob;Hb=Hb+1|0;if((Hb|0)==(wd|0)){Sd=ja;break}else ob=ja}}else Sd=td;Rd=Sd+1|0}else Rd=vd;while(0);vd=f[Ka>>2]|0;bb=f[Ja>>2]|0;g:do if((bb|0)>0){Va=0;ob=vd;while(1){if((Rd|0)==(f[ob>>2]|0)){Td=ob;break g}Va=Va+1|0;Hb=ob+88|0;if((Va|0)>=(bb|0)){Ud=Hb;Na=55;break}else ob=Hb}}else{Ud=vd;Na=55}while(0);if((Na|0)==55){Na=0;vd=f[a>>2]|0;f[vd+20>>2]=4;f[vd+24>>2]=Rd;ki[f[vd>>2]&2047](a);Td=Ud}f[a+344+(wd<<2)>>2]=Td;if(!zd){if(!(mi[f[Cd>>2]&255](a)|0)){Ma=0;Na=301;break}Vd=f[Oa>>2]|0;Wd=f[La>>2]|0}else{Vd=zd;Wd=xd}vd=h[Wd>>0]|0;bb=Td+20|0;f[bb>>2]=vd>>>4;ob=Td+24|0;f[ob>>2]=vd&15;vd=f[a>>2]|0;f[vd+24>>2]=f[Td>>2];f[vd+28>>2]=f[bb>>2];f[vd+32>>2]=f[ob>>2];f[vd+20>>2]=106;Gh[f[vd+4>>2]&511](a,1);wd=wd+1|0;vd=Vd+-1|0;ob=Wd+1|0;bb=(vd|0)==0;if((wd|0)>=(yd|0)){Ld=vd;Md=0;Nd=bb;Od=ob;Na=60;break e}else{l=vd;Ad=bb;Bd=ob}}if((Na|0)==301){u=c;return Ma|0}}while(0);if((Na|0)==60)if(Nd){Hd=Md;Na=61}else{Id=Ld;Jd=Md;Kd=Od}do if((Na|0)==61)if(!(mi[f[La+12>>2]&255](a)|0)){Ma=0;u=c;return Ma|0}else{Id=f[Oa>>2]|0;Jd=Hd;Kd=f[La>>2]|0;break}while(0);Hd=Id+-1|0;Id=Kd+1|0;Od=a+412|0;f[Od>>2]=h[Kd>>0];do if(!Hd)if(!(mi[f[La+12>>2]&255](a)|0)){Ma=0;u=c;return Ma|0}else{Xd=f[Oa>>2]|0;Yd=f[La>>2]|0;break}else{Xd=Hd;Yd=Id}while(0);Id=Xd+-1|0;Xd=Yd+1|0;Hd=a+416|0;f[Hd>>2]=h[Yd>>0];do if(!Id)if(!(mi[f[La+12>>2]&255](a)|0)){Ma=0;u=c;return Ma|0}else{Zd=f[Oa>>2]|0;_d=f[La>>2]|0;break}else{Zd=Id;_d=Xd}while(0);Xd=h[_d>>0]|0;Id=a+420|0;f[Id>>2]=Xd>>>4;Yd=a+424|0;f[Yd>>2]=Xd&15;Xd=f[a>>2]|0;f[Xd+24>>2]=f[Od>>2];f[Xd+28>>2]=f[Hd>>2];f[Xd+32>>2]=f[Id>>2];f[Xd+36>>2]=f[Yd>>2];f[Xd+20>>2]=107;Gh[f[Xd+4>>2]&511](a,1);f[(f[k>>2]|0)+20>>2]=0;if(!Jd){Jd=a+144|0;f[Jd>>2]=(f[Jd>>2]|0)+1}f[La>>2]=_d+1;f[Oa>>2]=Zd+-1;f[i>>2]=0;Ma=1;u=c;return Ma|0}else if((Na|0)==72){Zd=f[a>>2]|0;f[Zd+20>>2]=87;Gh[f[Zd+4>>2]&511](a,1);f[i>>2]=0;Ma=2;u=c;return Ma|0}else if((Na|0)==127){Ma=0;u=c;return Ma|0}else if((Na|0)==301){u=c;return Ma|0}return 0}function CFa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+440|0;c=f[b>>2]|0;do if(!c)if(!(yFa(a)|0)){d=0;return d|0}else{e=f[b>>2]|0;break}else e=c;while(0);c=a+464|0;g=f[(f[c>>2]|0)+20>>2]|0;if((e|0)!=(g+208|0)){if(!($h[f[(f[a+24>>2]|0)+20>>2]&255](a,g)|0)){d=0;return d|0}}else{e=f[a>>2]|0;f[e+20>>2]=100;f[e+24>>2]=g;Gh[f[e+4>>2]&511](a,3);f[b>>2]=0}b=(f[c>>2]|0)+20|0;f[b>>2]=(f[b>>2]|0)+1&7;d=1;return d|0}function DFa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0;b=a+24|0;c=f[b>>2]|0;d=c+4|0;e=f[d>>2]|0;do if(!e)if(!(mi[f[c+12>>2]&255](a)|0)){g=0;return g|0}else{i=f[d>>2]|0;break}else i=e;while(0);e=f[c>>2]|0;j=i+-1|0;i=e+1|0;k=(h[e>>0]|0)<<8;do if(!j)if(!(mi[f[c+12>>2]&255](a)|0)){g=0;return g|0}else{l=f[d>>2]|0;m=f[c>>2]|0;break}else{l=j;m=i}while(0);i=h[m>>0]|0|k;k=i+-2|0;j=f[a>>2]|0;f[j+20>>2]=93;f[j+24>>2]=f[a+440>>2];f[j+28>>2]=k;Gh[f[j+4>>2]&511](a,1);f[c>>2]=m+1;f[d>>2]=l+-1;if(i>>>0<=2){g=1;return g|0}Gh[f[(f[b>>2]|0)+16>>2]&511](a,k);g=1;return g|0}function EFa(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+16|0;d=c;e=a+24|0;g=f[e>>2]|0;i=g+4|0;j=f[i>>2]|0;do if(!j)if(!(mi[f[g+12>>2]&255](a)|0)){k=0;u=c;return k|0}else{l=f[i>>2]|0;break}else l=j;while(0);j=f[g>>2]|0;m=l+-1|0;l=j+1|0;n=h[j>>0]<<8;do if(!m)if(!(mi[f[g+12>>2]&255](a)|0)){k=0;u=c;return k|0}else{o=f[i>>2]|0;p=f[g>>2]|0;break}else{o=m;p=l}while(0);l=h[p>>0]|n;n=l+-2|0;m=(n|0)>13?14:l>>>0>2?n:0;l=o+-1|0;o=p+1|0;a:do if(!m){q=l;r=o}else{p=g+12|0;j=l;s=0;t=o;while(1){if(!j){if(!(mi[f[p>>2]&255](a)|0)){k=0;break}v=f[i>>2]|0;w=f[g>>2]|0}else{v=j;w=t}b[d+s>>0]=b[w>>0]|0;s=s+1|0;x=v+-1|0;y=w+1|0;if(s>>>0>=m>>>0){q=x;r=y;break a}else{j=x;t=y}}u=c;return k|0}while(0);w=n-m|0;v=f[a+440>>2]|0;b:do switch(v|0){case 224:{FFa(a,d,m,w);break}case 238:{if((((m>>>0>11&(b[d>>0]|0)==65?(b[d+1>>0]|0)==100:0)?(b[d+2>>0]|0)==111:0)?(b[d+3>>0]|0)==98:0)?(b[d+4>>0]|0)==101:0){o=h[d+7>>0]<<8|h[d+8>>0];l=h[d+9>>0]<<8|h[d+10>>0];t=b[d+11>>0]|0;j=f[a>>2]|0;f[j+24>>2]=h[d+5>>0]<<8|h[d+6>>0];f[j+28>>2]=o;f[j+32>>2]=l;f[j+36>>2]=t&255;f[j+20>>2]=78;Gh[f[j+4>>2]&511](a,1);f[a+296>>2]=1;b[a+300>>0]=t;break b}t=f[a>>2]|0;f[t+20>>2]=80;f[t+24>>2]=n;Gh[f[t+4>>2]&511](a,1);break}default:{t=f[a>>2]|0;f[t+20>>2]=70;f[t+24>>2]=v;ki[f[t>>2]&2047](a)}}while(0);f[g>>2]=r;f[i>>2]=q;if((w|0)<=0){k=1;u=c;return k|0}Gh[f[(f[e>>2]|0)+16>>2]&511](a,w);k=1;u=c;return k|0}function FFa(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;i=g+e|0;if(e>>>0>13){if((b[c>>0]|0)==74)if((((b[c+1>>0]|0)==70?(b[c+2>>0]|0)==73:0)?(b[c+3>>0]|0)==70:0)?(b[c+4>>0]|0)==0:0){f[a+284>>2]=1;g=b[c+5>>0]|0;j=a+288|0;b[j>>0]=g;k=b[c+6>>0]|0;l=a+289|0;b[l>>0]=k;m=b[c+7>>0]|0;n=a+290|0;b[n>>0]=m;o=(h[c+8>>0]<<8|h[c+9>>0])&65535;p=a+292|0;d[p>>1]=o;q=(h[c+10>>0]<<8|h[c+11>>0])&65535;r=a+294|0;d[r>>1]=q;if(g<<24>>24==1){s=1;t=k;u=o;v=q;w=m;x=a}else{m=f[a>>2]|0;f[m+20>>2]=122;f[m+24>>2]=g&255;f[m+28>>2]=k&255;Gh[f[m+4>>2]&511](a,-1);s=b[j>>0]|0;t=b[l>>0]|0;u=d[p>>1]|0;v=d[r>>1]|0;w=b[n>>0]|0;x=a}n=f[x>>2]|0;f[n+24>>2]=s&255;f[n+28>>2]=t&255;f[n+32>>2]=u&65535;f[n+36>>2]=v&65535;f[n+40>>2]=w&255;f[n+20>>2]=89;Gh[f[n+4>>2]&511](a,1);n=c+12|0;w=b[n>>0]|0;v=c+13|0;u=b[v>>0]|0;if(!((u|w)<<24>>24)){y=w;z=u}else{u=f[x>>2]|0;f[u+20>>2]=92;f[u+24>>2]=h[n>>0];f[u+28>>2]=h[v>>0];Gh[f[u+4>>2]&511](a,1);y=b[n>>0]|0;z=b[v>>0]|0}v=i+-14|0;if((v|0)==(Y((y&255)*3|0,z&255)|0))return;z=f[x>>2]|0;f[z+20>>2]=90;f[z+24>>2]=v;Gh[f[z+4>>2]&511](a,1);return}else A=16}else if(e>>>0>5?(b[c>>0]|0)==74:0)A=16;if(((((A|0)==16?(b[c+1>>0]|0)==70:0)?(b[c+2>>0]|0)==88:0)?(b[c+3>>0]|0)==88:0)?(b[c+4>>0]|0)==0:0){A=c+5|0;switch(b[A>>0]|0){case 16:{c=f[a>>2]|0;f[c+20>>2]=110;f[c+24>>2]=i;Gh[f[c+4>>2]&511](a,1);return}case 17:{c=f[a>>2]|0;f[c+20>>2]=111;f[c+24>>2]=i;Gh[f[c+4>>2]&511](a,1);return}case 19:{c=f[a>>2]|0;f[c+20>>2]=112;f[c+24>>2]=i;Gh[f[c+4>>2]&511](a,1);return}default:{c=f[a>>2]|0;f[c+20>>2]=91;f[c+24>>2]=h[A>>0];f[c+28>>2]=i;Gh[f[c+4>>2]&511](a,1);return}}}c=f[a>>2]|0;f[c+20>>2]=79;f[c+24>>2]=i;Gh[f[c+4>>2]&511](a,1);return}function GFa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=f[a+24>>2]|0;g=f[e>>2]|0;i=e+4|0;j=f[i>>2]|0;f[a+220>>2]=b;f[a+224>>2]=c;f[a+228>>2]=d;do if(!j)if(!(mi[f[e+12>>2]&255](a)|0)){k=0;return k|0}else{l=f[i>>2]|0;m=f[e>>2]|0;break}else{l=j;m=g}while(0);g=l+-1|0;l=m+1|0;j=(h[m>>0]|0)<<8;do if(!g)if(!(mi[f[e+12>>2]&255](a)|0)){k=0;return k|0}else{n=f[i>>2]|0;o=f[e>>2]|0;break}else{n=g;o=l}while(0);l=n+-1|0;n=o+1|0;g=h[o>>0]|0|j;do if(!l)if(!(mi[f[e+12>>2]&255](a)|0)){k=0;return k|0}else{p=f[i>>2]|0;q=f[e>>2]|0;break}else{p=l;q=n}while(0);n=p+-1|0;p=q+1|0;f[a+212>>2]=h[q>>0];do if(!n)if(!(mi[f[e+12>>2]&255](a)|0)){k=0;return k|0}else{r=f[i>>2]|0;s=f[e>>2]|0;break}else{r=n;s=p}while(0);p=r+-1|0;r=s+1|0;n=(h[s>>0]|0)<<8;s=a+32|0;f[s>>2]=n;do if(!p)if(!(mi[f[e+12>>2]&255](a)|0)){k=0;return k|0}else{t=f[s>>2]|0;u=f[i>>2]|0;v=f[e>>2]|0;break}else{t=n;u=p;v=r}while(0);r=u+-1|0;u=v+1|0;f[s>>2]=t+(h[v>>0]|0);do if(!r)if(!(mi[f[e+12>>2]&255](a)|0)){k=0;return k|0}else{w=f[i>>2]|0;x=f[e>>2]|0;break}else{w=r;x=u}while(0);u=w+-1|0;w=x+1|0;r=(h[x>>0]|0)<<8;x=a+28|0;f[x>>2]=r;do if(!u)if(!(mi[f[e+12>>2]&255](a)|0)){k=0;return k|0}else{y=f[x>>2]|0;z=f[i>>2]|0;A=f[e>>2]|0;break}else{y=r;z=u;A=w}while(0);w=z+-1|0;z=A+1|0;f[x>>2]=y+(h[A>>0]|0);do if(!w)if(!(mi[f[e+12>>2]&255](a)|0)){k=0;return k|0}else{B=f[i>>2]|0;C=f[e>>2]|0;break}else{B=w;C=z}while(0);z=a+36|0;f[z>>2]=h[C>>0];w=g+-8|0;g=f[a>>2]|0;f[g+24>>2]=f[a+440>>2];f[g+28>>2]=f[x>>2];f[g+32>>2]=f[s>>2];f[g+36>>2]=f[z>>2];f[g+20>>2]=102;Gh[f[g+4>>2]&511](a,1);g=a+464|0;if(f[(f[g>>2]|0)+16>>2]|0){A=f[a>>2]|0;f[A+20>>2]=61;ki[f[A>>2]&2047](a)}if(((f[s>>2]|0)!=0?(f[x>>2]|0)!=0:0)?(x=f[z>>2]|0,(x|0)>=1):0)D=x;else{x=f[a>>2]|0;f[x+20>>2]=33;ki[f[x>>2]&2047](a);D=f[z>>2]|0}if((w|0)!=(D*3|0)){D=f[a>>2]|0;f[D+20>>2]=12;ki[f[D>>2]&2047](a)}D=a+216|0;if(!(f[D>>2]|0)){w=ui[f[f[a+4>>2]>>2]&127](a,1,(f[z>>2]|0)*88|0)|0;f[D>>2]=w}w=B+-1|0;B=C+1|0;a:do if((f[z>>2]|0)>0){C=e+12|0;x=w;s=0;A=B;while(1){if(!x){if(!(mi[f[C>>2]&255](a)|0)){k=0;E=55;break}F=f[i>>2]|0;G=f[e>>2]|0}else{F=x;G=A}y=F+-1|0;u=G+1|0;r=h[G>>0]|0;v=f[D>>2]|0;b:do if((s|0)>0){t=v;p=0;while(1){if((r|0)==(f[t>>2]|0))break;p=p+1|0;n=t+88|0;if((p|0)>=(s|0)){H=r;I=n;break b}else t=n}t=f[v>>2]|0;p=v+88|0;if((s|0)>1){n=t;q=p;l=1;while(1){j=f[q>>2]|0;n=(j|0)>(n|0)?j:n;l=l+1|0;if((l|0)==(s|0))break;else q=q+88|0}J=n;K=v+(s*88|0)|0}else{J=t;K=p}H=J+1|0;I=K}else{H=r;I=v}while(0);f[I>>2]=H;f[I+4>>2]=s;if(!y){if(!(mi[f[C>>2]&255](a)|0)){k=0;E=55;break}L=f[i>>2]|0;M=f[e>>2]|0}else{L=y;M=u}v=L+-1|0;r=M+1|0;q=h[M>>0]|0;l=I+8|0;f[l>>2]=q>>>4;j=I+12|0;f[j>>2]=q&15;if(!v){if(!(mi[f[C>>2]&255](a)|0)){k=0;E=55;break}N=f[i>>2]|0;O=f[e>>2]|0}else{N=v;O=r}r=I+16|0;f[r>>2]=h[O>>0];v=f[a>>2]|0;f[v+24>>2]=f[I>>2];f[v+28>>2]=f[l>>2];f[v+32>>2]=f[j>>2];f[v+36>>2]=f[r>>2];f[v+20>>2]=103;Gh[f[v+4>>2]&511](a,1);s=s+1|0;v=N+-1|0;r=O+1|0;if((s|0)>=(f[z>>2]|0)){P=v;Q=r;break a}else{x=v;A=r}}if((E|0)==55)return k|0}else{P=w;Q=B}while(0);f[(f[g>>2]|0)+16>>2]=1;f[e>>2]=Q;f[i>>2]=P;k=1;return k|0}function HFa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;b=f[a+20>>2]|0;if((b|0)!=202){c=f[a>>2]|0;f[c+20>>2]=21;f[c+24>>2]=b;ki[f[c>>2]&2047](a)}rFa(a);c=f[a+216>>2]|0;b=a+36|0;d=f[b>>2]|0;e=(d|0)>0;if(e){g=f[a+324>>2]|0;h=f[a+76>>2]|0?8:4;i=a+320|0;j=f[a+328>>2]|0;if((g|0)>(h|0)){k=(j|0)>(h|0);l=g<<1;m=0;n=c;while(1){o=n+36|0;f[o>>2]=g;a:do if(k)p=j;else{q=f[i>>2]|0;r=f[n+12>>2]|0;s=j;t=1;while(1){t=t<<1;if((q|0)%(Y(t,r)|0)|0|0){p=s;break a}u=Y(j,t)|0;if((u|0)>(h|0)){p=u;break}else s=u}}while(0);s=n+40|0;f[s>>2]=p;t=p<<1;if((g|0)<=(t|0)){if((p|0)>(l|0))f[s>>2]=l}else f[o>>2]=t;m=m+1|0;if((m|0)>=(d|0))break;else n=n+88|0}}else{n=f[a+316>>2]|0;m=(j|0)>(h|0);l=0;p=c;while(1){k=f[p+8>>2]|0;t=g;s=1;while(1){s=s<<1;if((n|0)%(Y(s,k)|0)|0|0){v=t;break}r=Y(g,s)|0;if((r|0)>(h|0)){v=r;break}else t=r}t=p+36|0;f[t>>2]=v;b:do if(m)w=j;else{s=f[i>>2]|0;k=f[p+12>>2]|0;o=j;r=1;while(1){r=r<<1;if((s|0)%(Y(r,k)|0)|0|0){w=o;break b}q=Y(j,r)|0;if((q|0)>(h|0)){w=q;break}else o=q}}while(0);o=p+40|0;f[o>>2]=w;r=w<<1;if((v|0)<=(r|0)){k=v<<1;if((w|0)>(k|0))f[o>>2]=k}else f[t>>2]=r;l=l+1|0;if((l|0)>=(d|0))break;else p=p+88|0}}if(e){e=a+28|0;p=a+316|0;l=a+428|0;w=a+32|0;v=a+320|0;h=0;j=c;while(1){c=Y(Y(f[j+8>>2]|0,f[e>>2]|0)|0,f[j+36>>2]|0)|0;i=QGa(c,Y(f[l>>2]|0,f[p>>2]|0)|0)|0;f[j+44>>2]=i;i=Y(Y(f[j+12>>2]|0,f[w>>2]|0)|0,f[j+40>>2]|0)|0;c=QGa(i,Y(f[l>>2]|0,f[v>>2]|0)|0)|0;f[j+48>>2]=c;h=h+1|0;c=f[b>>2]|0;if((h|0)>=(c|0)){x=c;break}else j=j+88|0}}else x=d}else x=d;d=f[a+44>>2]|0;switch(d|0){case 3:case 1:{y=d;break}case 2:{y=3;break}case 5:case 4:{y=4;break}default:y=x}f[a+120>>2]=y;f[a+124>>2]=(f[a+84>>2]|0)==0?y:1;if(!(IFa(a)|0)){z=1;A=a+128|0;f[A>>2]=z;return}z=f[a+320>>2]|0;A=a+128|0;f[A>>2]=z;return}function IFa(a){a=a|0;var b=0,c=0;if(f[a+76>>2]|0)return 0;if(f[a+308>>2]|0)return 0;if((f[a+40>>2]|0)!=3)return 0;if((f[a+36>>2]|0)!=3)return 0;if((f[a+44>>2]|0)!=2)return 0;if((f[a+120>>2]|0)!=3)return 0;b=f[a+216>>2]|0;if((f[b+8>>2]|0)!=2)return 0;if((f[b+96>>2]|0)!=1)return 0;if((f[b+184>>2]|0)!=1)return 0;if((f[b+12>>2]|0)>2)return 0;if((f[b+100>>2]|0)!=1)return 0;if((f[b+188>>2]|0)!=1)return 0;c=f[b+36>>2]|0;if((c|0)!=(f[a+324>>2]|0))return 0;if((f[b+124>>2]|0)!=(c|0))return 0;if((f[b+212>>2]|0)!=(c|0))return 0;c=f[b+40>>2]|0;if((c|0)!=(f[a+328>>2]|0))return 0;if((f[b+128>>2]|0)==(c|0))return (f[b+216>>2]|0)==(c|0)|0;else return 0;return 0}function JFa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+4|0;d=ui[f[f[c>>2]>>2]&127](a,1,28)|0;f[a+444>>2]=d;f[d>>2]=989;f[d+4>>2]=990;f[d+8>>2]=0;HFa(a);e=ui[f[f[c>>2]>>2]&127](a,1,1408)|0;g=e+256|0;h=a+336|0;f[h>>2]=g;F1a(e|0,0,256)|0;i=0;do{b[g+i>>0]=i;i=i+1|0}while((i|0)!=256);F1a(e+512|0,-1,384)|0;F1a(e+896|0,0,384)|0;i=e+1280|0;e=f[h>>2]|0;h=i+128|0;do{b[i>>0]=b[e>>0]|0;i=i+1|0;e=e+1|0}while((i|0)<(h|0));e=a+120|0;i=d+12|0;f[i>>2]=0;h=IFa(a)|0;g=d+16|0;f[g>>2]=h;h=d+20|0;f[h>>2]=0;j=d+24|0;f[j>>2]=0;do if(!(f[a+84>>2]|0)){f[a+100>>2]=0;f[a+104>>2]=0;f[a+108>>2]=0;k=a+68|0}else{if(!(f[a+64>>2]|0)){f[a+100>>2]=0;f[a+104>>2]=0;f[a+108>>2]=0}d=a+68|0;if(f[d>>2]|0){l=f[a>>2]|0;f[l+20>>2]=48;ki[f[l>>2]&2047](a)}do if((f[e>>2]|0)==3)if(!(f[a+136>>2]|0)){l=a+100|0;f[(f[a+92>>2]|0?a+108|0:l)>>2]=1;m=l;break}else{f[a+104>>2]=1;m=a+100|0;break}else{l=a+100|0;f[l>>2]=1;f[a+104>>2]=0;f[a+108>>2]=0;f[a+136>>2]=0;m=l}while(0);if(f[m>>2]|0){vGa(a);f[h>>2]=f[a+484>>2]}if((f[a+108>>2]|0)==0?(f[a+104>>2]|0)==0:0){k=d;break}FGa(a);f[j>>2]=f[a+484>>2];k=d}while(0);if(!(f[k>>2]|0)){if(!(f[g>>2]|0)){aIa(a);XFa(a)}else MFa(a);SFa(a,f[a+108>>2]|0)}lIa(a);if(!(f[a+228>>2]|0))nIa(a);else MHa(a);g=a+460|0;if(!(f[(f[g>>2]|0)+16>>2]|0))n=(f[a+64>>2]|0)!=0;else n=1;UHa(a,n&1);if(!(f[k>>2]|0))yIa(a,0);ki[f[(f[c>>2]|0)+24>>2]&2047](a);ki[f[(f[g>>2]|0)+8>>2]&2047](a);c=f[a+8>>2]|0;if(!c)return;if(f[a+64>>2]|0)return;if(!(f[(f[g>>2]|0)+16>>2]|0))return;g=f[a+36>>2]|0;k=(f[a+224>>2]|0)==0?g:(g*3|0)+2|0;f[c+4>>2]=0;g=Y(k,f[a+332>>2]|0)|0;f[c+8>>2]=g;f[c+12>>2]=0;f[c+16>>2]=f[a+108>>2]|0?3:2;f[i>>2]=(f[i>>2]|0)+1;return}function KFa(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+444>>2]|0;c=b+8|0;if(!(f[c>>2]|0)){d=a+84|0;do if(f[d>>2]|0?(f[a+136>>2]|0)==0:0){if(f[a+92>>2]|0?f[a+108>>2]|0:0){f[a+484>>2]=f[b+24>>2];f[c>>2]=1;break}if(!(f[a+100>>2]|0)){e=f[a>>2]|0;f[e+20>>2]=47;ki[f[e>>2]&2047](a);break}else{f[a+484>>2]=f[b+20>>2];break}}while(0);ki[f[f[a+472>>2]>>2]&2047](a);ki[f[(f[a+452>>2]|0)+8>>2]&2047](a);if(!(f[a+68>>2]|0)){if(!(f[b+16>>2]|0))ki[f[f[a+480>>2]>>2]&2047](a);ki[f[f[a+476>>2]>>2]&2047](a);if(f[d>>2]|0)Gh[f[f[a+484>>2]>>2]&511](a,f[c>>2]|0);Gh[f[f[a+456>>2]>>2]&511](a,f[c>>2]|0?3:0);Gh[f[f[a+448>>2]>>2]&511](a,0)}}else{f[c>>2]=0;Gh[f[f[a+484>>2]>>2]&511](a,0);Gh[f[f[a+456>>2]>>2]&511](a,2);Gh[f[f[a+448>>2]>>2]&511](a,2)}d=f[a+8>>2]|0;if(!d)return;e=f[b+12>>2]|0;f[d+12>>2]=e;b=(f[c>>2]|0?2:1)+e|0;e=d+16|0;f[e>>2]=b;if(!(f[a+64>>2]|0))return;if(f[(f[a+460>>2]|0)+20>>2]|0)return;f[e>>2]=(f[a+108>>2]|0?2:1)+b;return}function LFa(a){a=a|0;var b=0;b=f[a+444>>2]|0;if(f[a+84>>2]|0)ki[f[(f[a+484>>2]|0)+8>>2]&2047](a);a=b+12|0;f[a>>2]=(f[a>>2]|0)+1;return}function MFa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=a+4|0;c=ui[f[f[b>>2]>>2]&127](a,1,48)|0;d=a+476|0;f[d>>2]=c;f[c>>2]=991;f[c+8>>2]=0;e=Y(f[a+120>>2]|0,f[a+112>>2]|0)|0;f[c+40>>2]=e;g=c+4|0;if((f[a+320>>2]|0)==2){f[g>>2]=99;f[c+12>>2]=165;h=ui[f[(f[b>>2]|0)+4>>2]&127](a,1,e)|0;i=h;j=f[d>>2]|0}else{f[g>>2]=100;f[c+12>>2]=166;i=0;j=c}f[c+32>>2]=i;i=ui[f[f[b>>2]>>2]&127](a,1,1024)|0;c=j+16|0;f[c>>2]=i;i=ui[f[f[b>>2]>>2]&127](a,1,1024)|0;g=j+20|0;f[g>>2]=i;i=ui[f[f[b>>2]>>2]&127](a,1,1024)|0;d=j+24|0;f[d>>2]=i;i=ui[f[f[b>>2]>>2]&127](a,1,1024)|0;f[j+28>>2]=i;j=f[c>>2]|0;c=f[g>>2]|0;g=f[d>>2]|0;d=0;a=-128;while(1){f[j+(d<<2)>>2]=(a*91881|0)+32768>>16;f[c+(d<<2)>>2]=(a*116130|0)+32768>>16;b=Y(a,-46802)|0;f[g+(d<<2)>>2]=b;b=(Y(a,-22554)|0)+32768|0;f[i+(d<<2)>>2]=b;d=d+1|0;if((d|0)==256)break;else a=a+1|0}return}function NFa(a){a=a|0;var b=0;b=f[a+476>>2]|0;f[b+36>>2]=0;f[b+44>>2]=f[a+116>>2];return}function OFa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;i=d;j=f[a+476>>2]|0;k=j+36|0;if(!(f[k>>2]|0)){l=j+44|0;m=f[l>>2]|0;n=m>>>0<2?m:2;m=f[g>>2]|0;o=h-m|0;h=n>>>0>o>>>0?o:n;f[i>>2]=f[e+(m<<2)>>2];if(h>>>0>1)f[i+4>>2]=f[e+(m+1<<2)>>2];else{f[i+4>>2]=f[j+32>>2];f[k>>2]=1}Ah[f[j+12>>2]&255](a,b,f[c>>2]|0,i);i=(f[k>>2]|0)==0;f[g>>2]=(f[g>>2]|0)+h;f[l>>2]=(f[l>>2]|0)-h;if(!i){u=d;return}}else{SGa(j+32|0,0,e+(f[g>>2]<<2)|0,0,1,f[j+40>>2]|0);f[k>>2]=0;k=j+44|0;f[g>>2]=(f[g>>2]|0)+1;f[k>>2]=(f[k>>2]|0)+-1}f[c>>2]=(f[c>>2]|0)+1;u=d;return}function PFa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=f[a+476>>2]|0;i=f[a+336>>2]|0;j=f[g+16>>2]|0;k=f[g+20>>2]|0;l=f[g+24>>2]|0;m=f[g+28>>2]|0;g=f[c>>2]|0;n=d<<1;o=f[g+(n<<2)>>2]|0;p=f[g+((n|1)<<2)>>2]|0;n=f[(f[c+4>>2]|0)+(d<<2)>>2]|0;g=f[(f[c+8>>2]|0)+(d<<2)>>2]|0;d=f[e>>2]|0;c=f[e+4>>2]|0;e=a+112|0;a=f[e>>2]|0;q=a>>>1;if(!q){r=a;s=o;t=p;u=n;v=g;w=d;x=c}else{a=n+q|0;y=q<<1;z=q*6|0;A=p+y|0;B=q;C=o;D=p;p=n;n=g;E=d;F=c;while(1){G=h[p>>0]|0;H=h[n>>0]|0;I=f[j+(H<<2)>>2]|0;J=(f[l+(H<<2)>>2]|0)+(f[m+(G<<2)>>2]|0)>>16;H=f[k+(G<<2)>>2]|0;G=h[C>>0]|0;b[E>>0]=b[i+(G+I)>>0]|0;b[E+1>>0]=b[i+(G+J)>>0]|0;b[E+2>>0]=b[i+(G+H)>>0]|0;G=h[C+1>>0]|0;b[E+3>>0]=b[i+(G+I)>>0]|0;b[E+4>>0]=b[i+(G+J)>>0]|0;b[E+5>>0]=b[i+(G+H)>>0]|0;G=h[D>>0]|0;b[F>>0]=b[i+(G+I)>>0]|0;b[F+1>>0]=b[i+(G+J)>>0]|0;b[F+2>>0]=b[i+(G+H)>>0]|0;G=h[D+1>>0]|0;b[F+3>>0]=b[i+(G+I)>>0]|0;b[F+4>>0]=b[i+(G+J)>>0]|0;b[F+5>>0]=b[i+(G+H)>>0]|0;B=B+-1|0;if(!B)break;else{C=C+2|0;D=D+2|0;p=p+1|0;n=n+1|0;E=E+6|0;F=F+6|0}}r=f[e>>2]|0;s=o+y|0;t=A;u=a;v=g+q|0;w=d+z|0;x=c+z|0}if(!(r&1))return;r=h[u>>0]|0;u=h[v>>0]|0;v=f[j+(u<<2)>>2]|0;j=(f[l+(u<<2)>>2]|0)+(f[m+(r<<2)>>2]|0)>>16;m=f[k+(r<<2)>>2]|0;r=h[s>>0]|0;b[w>>0]=b[i+(r+v)>>0]|0;b[w+1>>0]=b[i+(r+j)>>0]|0;b[w+2>>0]=b[i+(r+m)>>0]|0;r=h[t>>0]|0;b[x>>0]=b[i+(r+v)>>0]|0;b[x+1>>0]=b[i+(r+j)>>0]|0;b[x+2>>0]=b[i+(r+m)>>0]|0;return}function QFa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;Ah[f[(f[a+476>>2]|0)+12>>2]&255](a,b,f[c>>2]|0,e+(f[g>>2]<<2)|0);f[g>>2]=(f[g>>2]|0)+1;f[c>>2]=(f[c>>2]|0)+1;return}function RFa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=f[a+476>>2]|0;i=f[a+336>>2]|0;j=f[g+16>>2]|0;k=f[g+20>>2]|0;l=f[g+24>>2]|0;m=f[g+28>>2]|0;g=f[(f[c>>2]|0)+(d<<2)>>2]|0;n=f[(f[c+4>>2]|0)+(d<<2)>>2]|0;o=f[(f[c+8>>2]|0)+(d<<2)>>2]|0;d=f[e>>2]|0;e=a+112|0;a=f[e>>2]|0;c=a>>>1;if(!c){p=a;q=g;r=n;s=o;t=d}else{a=n+c|0;u=c<<1;v=c*6|0;w=c;x=g;y=n;n=o;z=d;while(1){A=h[y>>0]|0;B=h[n>>0]|0;C=f[j+(B<<2)>>2]|0;D=(f[l+(B<<2)>>2]|0)+(f[m+(A<<2)>>2]|0)>>16;B=f[k+(A<<2)>>2]|0;A=h[x>>0]|0;b[z>>0]=b[i+(A+C)>>0]|0;b[z+1>>0]=b[i+(A+D)>>0]|0;b[z+2>>0]=b[i+(A+B)>>0]|0;A=h[x+1>>0]|0;b[z+3>>0]=b[i+(A+C)>>0]|0;b[z+4>>0]=b[i+(A+D)>>0]|0;b[z+5>>0]=b[i+(A+B)>>0]|0;w=w+-1|0;if(!w)break;else{x=x+2|0;y=y+1|0;n=n+1|0;z=z+6|0}}p=f[e>>2]|0;q=g+u|0;r=a;s=o+c|0;t=d+v|0}if(!(p&1))return;p=h[r>>0]|0;r=h[s>>0]|0;s=(f[l+(r<<2)>>2]|0)+(f[m+(p<<2)>>2]|0)>>16;m=f[k+(p<<2)>>2]|0;p=h[q>>0]|0;b[t>>0]=b[i+(p+(f[j+(r<<2)>>2]|0))>>0]|0;b[t+1>>0]=b[i+(p+s)>>0]|0;b[t+2>>0]=b[i+(p+m)>>0]|0;return}function SFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+4|0;d=ui[f[f[c>>2]>>2]&127](a,1,28)|0;f[a+456>>2]=d;f[d>>2]=392;e=d+8|0;f[e>>2]=0;g=d+12|0;f[g>>2]=0;if(!(f[a+84>>2]|0))return;h=f[a+320>>2]|0;i=d+16|0;f[i>>2]=h;d=f[c>>2]|0;c=Y(f[a+120>>2]|0,f[a+112>>2]|0)|0;if(!b){b=Jg[f[d+8>>2]&63](a,1,c,h)|0;f[g>>2]=b;return}else{b=f[d+16>>2]|0;d=RGa(f[a+116>>2]|0,h)|0;h=bg[b&127](a,1,0,c,d,f[i>>2]|0)|0;f[e>>2]=h;return}}function TFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+456>>2]|0;a:do switch(b|0){case 0:{if(!(f[a+84>>2]|0)){f[c+4>>2]=f[(f[a+476>>2]|0)+4>>2];break a}f[c+4>>2]=101;d=c+12|0;if(!(f[d>>2]|0)){e=uh[f[(f[a+4>>2]|0)+28>>2]&63](a,f[c+8>>2]|0,0,f[c+16>>2]|0,1)|0;f[d>>2]=e}break}case 3:{if(!(f[c+8>>2]|0)){e=f[a>>2]|0;f[e+20>>2]=3;ki[f[e>>2]&2047](a)}f[c+4>>2]=102;break}case 2:{if(!(f[c+8>>2]|0)){e=f[a>>2]|0;f[e+20>>2]=3;ki[f[e>>2]&2047](a)}f[c+4>>2]=103;break}default:{e=f[a>>2]|0;f[e+20>>2]=3;ki[f[e>>2]&2047](a)}}while(0);f[c+24>>2]=0;f[c+20>>2]=0;return}function UFa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+16|0;j=i;k=f[a+456>>2]|0;l=h-(f[g>>2]|0)|0;h=f[k+16>>2]|0;f[j>>2]=0;m=k+12|0;Xh[f[(f[a+476>>2]|0)+4>>2]&127](a,b,c,d,f[m>>2]|0,j,l>>>0>h>>>0?h:l);Ah[f[(f[a+484>>2]|0)+4>>2]&255](a,f[m>>2]|0,e+(f[g>>2]<<2)|0,f[j>>2]|0);f[g>>2]=(f[g>>2]|0)+(f[j>>2]|0);u=i;return}function VFa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=f[a+456>>2]|0;e=h+24|0;i=f[e>>2]|0;if(!i){j=h+16|0;k=uh[f[(f[a+4>>2]|0)+28>>2]&63](a,f[h+8>>2]|0,f[h+20>>2]|0,f[j>>2]|0,1)|0;l=h+12|0;f[l>>2]=k;m=k;n=f[e>>2]|0;o=l;p=j}else{j=h+12|0;m=f[j>>2]|0;n=i;o=j;p=h+16|0}Xh[f[(f[a+476>>2]|0)+4>>2]&127](a,b,c,d,m,e,f[p>>2]|0);m=f[e>>2]|0;if(m>>>0>n>>>0){d=m-n|0;Ah[f[(f[a+484>>2]|0)+4>>2]&255](a,(f[o>>2]|0)+(n<<2)|0,0,d);f[g>>2]=(f[g>>2]|0)+d;q=f[e>>2]|0}else q=m;m=f[p>>2]|0;if(q>>>0<m>>>0)return;q=h+20|0;f[q>>2]=(f[q>>2]|0)+m;f[e>>2]=0;return}function WFa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=f[a+456>>2]|0;c=d+24|0;b=f[c>>2]|0;if(!b){i=d+20|0;j=d+16|0;k=uh[f[(f[a+4>>2]|0)+28>>2]&63](a,f[d+8>>2]|0,f[i>>2]|0,f[j>>2]|0,0)|0;f[d+12>>2]=k;l=k;m=f[c>>2]|0;n=i;o=j}else{l=f[d+12>>2]|0;m=b;n=d+20|0;o=d+16|0}d=(f[o>>2]|0)-m|0;b=f[g>>2]|0;j=h-b|0;h=d>>>0>j>>>0?j:d;d=(f[a+116>>2]|0)-(f[n>>2]|0)|0;j=h>>>0>d>>>0?d:h;Ah[f[(f[a+484>>2]|0)+4>>2]&255](a,l+(m<<2)|0,e+(b<<2)|0,j);f[g>>2]=(f[g>>2]|0)+j;g=(f[c>>2]|0)+j|0;f[c>>2]=g;j=f[o>>2]|0;if(g>>>0<j>>>0)return;f[n>>2]=(f[n>>2]|0)+j;f[c>>2]=0;return}function XFa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=a+4|0;d=ui[f[f[c>>2]>>2]&127](a,1,160)|0;f[a+476>>2]=d;f[d>>2]=992;f[d+4>>2]=104;f[d+8>>2]=0;if(f[a+308>>2]|0){e=f[a>>2]|0;f[e+20>>2]=26;ki[f[e>>2]&2047](a)}e=a+36|0;if((f[e>>2]|0)<=0)return;g=a+324|0;h=a+328|0;i=a+316|0;j=a+320|0;k=d+100|0;l=d+52|0;m=a+112|0;n=d+12|0;o=d+140|0;p=d+150|0;d=0;q=f[a+216>>2]|0;while(1){r=Y(f[q+36>>2]|0,f[q+8>>2]|0)|0;s=(r|0)/(f[g>>2]|0)|0;r=Y(f[q+40>>2]|0,f[q+12>>2]|0)|0;t=(r|0)/(f[h>>2]|0)|0;r=f[i>>2]|0;u=f[j>>2]|0;f[k+(d<<2)>>2]=t;do if(!(f[q+52>>2]|0))f[l+(d<<2)>>2]=167;else{v=(t|0)==(u|0);if((s|0)==(r|0)&v){f[l+(d<<2)>>2]=168;break}w=(s<<1|0)==(r|0);do if(w&v)f[l+(d<<2)>>2]=169;else{if(w&(t<<1|0)==(u|0)){f[l+(d<<2)>>2]=170;break}if(((r|0)%(s|0)|0|0)==0?((u|0)%(t|0)|0|0)==0:0){f[l+(d<<2)>>2]=171;b[o+d>>0]=(r|0)/(s|0)|0;b[p+d>>0]=(u|0)/(t|0)|0;break}x=f[a>>2]|0;f[x+20>>2]=39;ki[f[x>>2]&2047](a)}while(0);w=f[(f[c>>2]|0)+8>>2]|0;v=RGa(f[m>>2]|0,f[i>>2]|0)|0;x=Jg[w&63](a,1,v,f[j>>2]|0)|0;f[n+(d<<2)>>2]=x}while(0);d=d+1|0;if((d|0)>=(f[e>>2]|0))break;else q=q+88|0}return}function YFa(a){a=a|0;var b=0;b=f[a+476>>2]|0;f[b+92>>2]=f[a+320>>2];f[b+96>>2]=f[a+116>>2];return}function ZFa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=f[a+476>>2]|0;i=d+92|0;j=f[i>>2]|0;k=a+320|0;l=f[k>>2]|0;if((j|0)<(l|0)){m=j;n=l}else{j=a+36|0;if((f[j>>2]|0)>0){o=0;p=f[a+216>>2]|0;while(1){q=(f[b+(o<<2)>>2]|0)+((Y(f[d+100+(o<<2)>>2]|0,f[c>>2]|0)|0)<<2)|0;Ah[f[d+52+(o<<2)>>2]&255](a,p,q,d+12+(o<<2)|0);o=o+1|0;if((o|0)>=(f[j>>2]|0))break;else p=p+88|0}r=f[k>>2]|0}else r=l;f[i>>2]=0;m=0;n=r}r=n-m|0;n=d+96|0;l=f[n>>2]|0;p=r>>>0>l>>>0?l:r;r=f[g>>2]|0;l=h-r|0;h=p>>>0>l>>>0?l:p;Bh[f[(f[a+480>>2]|0)+4>>2]&255](a,d+12|0,m,e+(r<<2)|0,h);f[g>>2]=(f[g>>2]|0)+h;f[n>>2]=(f[n>>2]|0)-h;n=(f[i>>2]|0)+h|0;f[i>>2]=n;if((n|0)<(f[k>>2]|0))return;f[c>>2]=(f[c>>2]|0)+1;return}function _Fa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[d>>2]=0;return}function $Fa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[d>>2]=c;return}function aGa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[e>>2]|0;e=a+320|0;g=f[e>>2]|0;if((g|0)<=0)return;h=a+112|0;a=g;g=0;while(1){i=f[c+(g<<2)>>2]|0;j=f[h>>2]|0;k=i+j|0;if((j|0)>0){j=f[d+(g<<2)>>2]|0;l=i;while(1){i=b[j>>0]|0;b[l>>0]=i;b[l+1>>0]=i;l=l+2|0;if(l>>>0>=k>>>0)break;else j=j+1|0}m=f[e>>2]|0}else m=a;g=g+1|0;if((g|0)>=(m|0))break;else a=m}return}function bGa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=f[e>>2]|0;e=a+320|0;if((f[e>>2]|0)<=0)return;g=a+112|0;a=0;h=0;while(1){i=f[c+(h<<2)>>2]|0;j=f[g>>2]|0;k=i+j|0;if((j|0)>0){l=f[d+(a<<2)>>2]|0;m=i;while(1){i=b[l>>0]|0;b[m>>0]=i;b[m+1>>0]=i;m=m+2|0;if(m>>>0>=k>>>0)break;else l=l+1|0}n=f[g>>2]|0}else n=j;SGa(c,h,c,h|1,1,n);h=h+2|0;if((h|0)>=(f[e>>2]|0))break;else a=a+1|0}return}function cGa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=f[a+476>>2]|0;h=f[e>>2]|0;e=f[c+4>>2]|0;c=b[g+140+e>>0]|0;i=c&255;j=b[g+150+e>>0]|0;e=j&255;g=a+320|0;k=f[g>>2]|0;if((k|0)<=0)return;l=a+112|0;a=c<<24>>24!=0;m=e+-1|0;if((j&255)>1){j=(c<<24>>24==0?~i:-2)+i+2|0;c=0;n=0;while(1){o=f[h+(n<<2)>>2]|0;p=f[l>>2]|0;q=o+p|0;if((p|0)>0){if(!a){r=7;break}s=f[d+(c<<2)>>2]|0;t=o;while(1){F1a(t|0,b[s>>0]|0,j|0)|0;o=i;u=t;while(1){u=u+1|0;if((o|0)<=1)break;else o=o+-1|0}if(u>>>0<q>>>0){s=s+1|0;t=u}else break}v=f[l>>2]|0}else v=p;SGa(h,n,h,n+1|0,m,v);n=n+e|0;if((n|0)>=(f[g>>2]|0)){r=24;break}else c=c+1|0}if((r|0)==7)while(1){r=0;r=7}else if((r|0)==24)return}if(!a){a=(f[l>>2]|0)>0;c=0;while(1){if(a){r=22;break}c=c+e|0;if((c|0)>=(k|0)){r=24;break}}if((r|0)==22)while(1){r=0;r=22}else if((r|0)==24)return}else{w=0;x=0}while(1){r=f[h+(x<<2)>>2]|0;k=f[l>>2]|0;c=r+k|0;if((k|0)>0){k=f[d+(w<<2)>>2]|0;a=r;while(1){F1a(a|0,b[k>>0]|0,i|0)|0;r=i;n=a;while(1){n=n+1|0;if((r|0)<=1)break;else r=r+-1|0}if(n>>>0<c>>>0){k=k+1|0;a=n}else break}}x=x+e|0;if((x|0)>=(f[g>>2]|0))break;else w=w+1|0}return}function dGa(a){a=a|0;f[a>>2]=993;f[a+4>>2]=393;f[a+8>>2]=994;f[a+12>>2]=394;f[a+16>>2]=995;f[a+104>>2]=0;f[a+108>>2]=0;f[a+20>>2]=0;f[a+112>>2]=119728;f[a+116>>2]=126;f[a+120>>2]=0;f[a+124>>2]=0;f[a+128>>2]=0;return a|0}function eGa(a){a=a|0;ki[f[(f[a>>2]|0)+8>>2]&2047](a);FEa(a);ue(1)}function fGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;if((b|0)>=0){if((f[c+104>>2]|0)<(b|0))return;ki[f[c+8>>2]&2047](a);return}b=c+108|0;d=f[b>>2]|0;if((d|0)!=0?(f[c+104>>2]|0)<=2:0)e=d;else{ki[f[c+8>>2]&2047](a);e=f[b>>2]|0}f[b>>2]=e+1;return}function gGa(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+208|0;c=b;d=b+8|0;Gh[f[(f[a>>2]|0)+12>>2]&511](a,d);a=f[30809]|0;f[c>>2]=d;ULa(a,365442,c)|0;u=b;return}function hGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+48|0;e=d+8|0;g=d;h=f[a>>2]|0;a=f[h+20>>2]|0;if((a|0)>0?(a|0)<=(f[h+116>>2]|0):0){i=(f[h+112>>2]|0)+(a<<2)|0;j=7}else{k=f[h+120>>2]|0;if(((k|0)!=0?(l=f[h+124>>2]|0,(a|0)>=(l|0)):0)?(a|0)<=(f[h+128>>2]|0):0){i=k+(a-l<<2)|0;j=7}else j=8}if((j|0)==7){l=f[i>>2]|0;if(!l)j=8;else m=l}if((j|0)==8){f[h+24>>2]=a;m=f[f[h+112>>2]>>2]|0}a=m;a:while(1){n=a+1|0;switch(b[a>>0]|0){case 0:{break a;break}case 37:{j=11;break a;break}default:a=n}}if((j|0)==11?(b[n>>0]|0)==115:0){f[g>>2]=h+24;SLa(c,m,g)|0;u=d;return}g=f[h+28>>2]|0;n=f[h+32>>2]|0;j=f[h+36>>2]|0;a=f[h+40>>2]|0;l=f[h+44>>2]|0;i=f[h+48>>2]|0;k=f[h+52>>2]|0;f[e>>2]=f[h+24>>2];f[e+4>>2]=g;f[e+8>>2]=n;f[e+12>>2]=j;f[e+16>>2]=a;f[e+20>>2]=l;f[e+24>>2]=i;f[e+28>>2]=k;SLa(c,m,e)|0;u=d;return}function iGa(a){a=a|0;var b=0;b=f[a>>2]|0;f[b+108>>2]=0;f[b+20>>2]=0;return}function jGa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=c+8|0;g=c+12|0;h=a+4|0;f[h>>2]=0;i=_Ja(a)|0;f[e>>2]=i;j=RJa(a,84)|0;if(!j){$Ja(a);k=f[a>>2]|0;f[k+20>>2]=56;f[k+24>>2]=0;ki[f[k>>2]&2047](a)}f[j>>2]=104;f[j+4>>2]=105;f[j+8>>2]=48;f[j+12>>2]=49;f[j+16>>2]=71;f[j+20>>2]=72;f[j+24>>2]=996;f[j+28>>2]=62;f[j+32>>2]=63;f[j+36>>2]=395;f[j+40>>2]=997;f[j+48>>2]=1e9;a=j+44|0;f[a>>2]=i;f[j+56>>2]=0;f[j+64>>2]=0;f[j+52>>2]=0;f[j+60>>2]=0;f[j+68>>2]=0;f[j+72>>2]=0;f[j+76>>2]=84;f[h>>2]=j;j=Me(365446)|0;if(!j){u=c;return}b[g>>0]=120;f[d>>2]=e;f[d+4>>2]=g;if((SMa(j,365454,d)|0)>0){switch(b[g>>0]|0){case 77:case 109:{g=(f[e>>2]|0)*1e3|0;f[e>>2]=g;l=g;break}default:l=f[e>>2]|0}f[a>>2]=l*1e3}u=c;return}function kGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=f[a+4>>2]|0;if(c>>>0>999999984){e=f[a>>2]|0;f[e+20>>2]=56;f[e+24>>2]=1;ki[f[e>>2]&2047](a)}e=c&7;g=((e|0)==0?0:8-e|0)+c|0;if(b>>>0>1){c=f[a>>2]|0;f[c+20>>2]=15;f[c+24>>2]=b;ki[f[c>>2]&2047](a)}c=d+52+(b<<2)|0;e=f[c>>2]|0;a:do if(!e){h=0;i=8}else{j=e;while(1){if((f[j+8>>2]|0)>>>0>=g>>>0){k=j;break a}l=f[j>>2]|0;if(!l){h=j;i=8;break}else j=l}}while(0);do if((i|0)==8){e=g+16|0;j=(h|0)==0;l=f[(j?120240:120248)+(b<<2)>>2]|0;m=999999984-g|0;n=l>>>0>m>>>0?m:l;l=e+n|0;m=RJa(a,l)|0;if(!m){o=n;while(1){p=o>>>1;if(o>>>0<100){q=f[a>>2]|0;f[q+20>>2]=56;f[q+24>>2]=2;ki[f[q>>2]&2047](a)}q=e+p|0;r=RJa(a,q)|0;if(!r)o=p;else{s=q;t=r;u=p;break}}}else{s=l;t=m;u=n}o=d+76|0;f[o>>2]=(f[o>>2]|0)+s;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=u+g;if(j){f[c>>2]=t;k=t;break}else{f[h>>2]=t;k=t;break}}while(0);t=k+4|0;h=f[t>>2]|0;f[t>>2]=h+g;t=k+8|0;f[t>>2]=(f[t>>2]|0)-g;return k+16+h|0}function lGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=f[a+4>>2]|0;if(c>>>0>999999984){e=f[a>>2]|0;f[e+20>>2]=56;f[e+24>>2]=3;ki[f[e>>2]&2047](a)}e=c&7;g=((e|0)==0?0:8-e|0)+c|0;if(b>>>0>1){c=f[a>>2]|0;f[c+20>>2]=15;f[c+24>>2]=b;ki[f[c>>2]&2047](a)}c=g+16|0;e=TJa(a,c)|0;if(!e){h=f[a>>2]|0;f[h+20>>2]=56;f[h+24>>2]=4;ki[f[h>>2]&2047](a)}a=d+76|0;f[a>>2]=(f[a>>2]|0)+c;c=d+60+(b<<2)|0;f[e>>2]=f[c>>2];f[e+4>>2]=g;f[e+8>>2]=0;f[c>>2]=e;return e+16|0}function mGa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=f[a+4>>2]|0;g=999999984/(c>>>0)|0;if(c>>>0>999999984){h=f[a>>2]|0;f[h+20>>2]=72;ki[f[h>>2]&2047](a)}h=(g|0)<(d|0)?g:d;f[e+80>>2]=h;e=kGa(a,b,d<<2)|0;if(!d)return e|0;else{i=0;j=h}while(1){h=d-i|0;j=j>>>0<h>>>0?j:h;h=lGa(a,b,Y(j,c)|0)|0;if(!j)k=i;else{g=i;l=j;m=h;while(1){h=g+1|0;f[e+(g<<2)>>2]=m;l=l+-1|0;if(!l){k=h;break}else{g=h;m=m+c|0}}}if(k>>>0>=d>>>0)break;else i=k}return e|0}function nGa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=f[a+4>>2]|0;g=c<<7;h=999999984/(g>>>0)|0;if(g>>>0>999999984){i=f[a>>2]|0;f[i+20>>2]=72;ki[f[i>>2]&2047](a)}i=(h|0)<(d|0)?h:d;f[e+80>>2]=i;e=kGa(a,b,d<<2)|0;if(!d)return e|0;else{j=0;k=i}while(1){i=d-j|0;k=k>>>0<i>>>0?k:i;i=lGa(a,b,Y(g,k)|0)|0;if(!k)l=j;else{h=j;m=k;n=i;while(1){i=h+1|0;f[e+(h<<2)>>2]=n;m=m+-1|0;if(!m){l=i;break}else{h=i;n=n+(c<<7)|0}}}if(l>>>0>=d>>>0)break;else j=l}return e|0}function oGa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=f[a+4>>2]|0;if((b|0)!=1){i=f[a>>2]|0;f[i+20>>2]=15;f[i+24>>2]=b;ki[f[i>>2]&2047](a)}i=kGa(a,b,128)|0;f[i>>2]=0;f[i+4>>2]=e;f[i+8>>2]=d;f[i+12>>2]=g;f[i+32>>2]=c;f[i+40>>2]=0;c=h+68|0;f[i+44>>2]=f[c>>2];f[c>>2]=i;return i|0}function pGa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=f[a+4>>2]|0;if((b|0)!=1){i=f[a>>2]|0;f[i+20>>2]=15;f[i+24>>2]=b;ki[f[i>>2]&2047](a)}i=kGa(a,b,128)|0;f[i>>2]=0;f[i+4>>2]=e;f[i+8>>2]=d;f[i+12>>2]=g;f[i+32>>2]=c;f[i+40>>2]=0;c=h+72|0;f[i+44>>2]=f[c>>2];f[c>>2]=i;return i|0}function qGa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;b=a+4|0;c=f[b>>2]|0;d=c+68|0;e=f[d>>2]|0;if(!e){g=0;h=0}else{i=0;j=0;k=e;while(1){if(!(f[k>>2]|0)){e=f[k+8>>2]|0;l=(Y(e,f[k+12>>2]|0)|0)+j|0;m=(Y(f[k+4>>2]|0,e)|0)+i|0;n=l}else{m=i;n=j}k=f[k+44>>2]|0;if(!k){g=m;h=n;break}else{i=m;j=n}}}n=c+72|0;j=f[n>>2]|0;if(!j){o=g;p=h}else{m=j;j=g;g=h;while(1){if(!(f[m>>2]|0)){h=f[m+8>>2]|0;i=(Y(f[m+12>>2]<<7,h)|0)+g|0;q=(Y(h<<7,f[m+4>>2]|0)|0)+j|0;r=i}else{q=j;r=g}m=f[m+44>>2]|0;if(!m){o=q;p=r;break}else{j=q;g=r}}}if((p|0)<1)return;r=VJa(a,p,o,f[c+76>>2]|0)|0;if((r|0)<(o|0)){o=(r|0)/(p|0)|0;s=(o|0)>1?o:1}else s=1e9;o=f[d>>2]|0;if(o|0){d=c+80|0;p=o;do{if(!(f[p>>2]|0)){o=f[p+4>>2]|0;r=f[p+12>>2]|0;if(((((o+-1|0)>>>0)/(r>>>0)|0)+1|0)>(s|0)){g=Y(r,s)|0;r=p+16|0;f[r>>2]=g;g=p+8|0;WJa(a,p+48|0,Y(f[g>>2]|0,o)|0);f[p+40>>2]=1;t=f[r>>2]|0;u=g}else{f[p+16>>2]=o;t=o;u=p+8|0}o=f[u>>2]|0;g=f[b>>2]|0;r=999999984/(o>>>0)|0;if(o>>>0>999999984){q=f[a>>2]|0;f[q+20>>2]=72;ki[f[q>>2]&2047](a)}q=(r|0)<(t|0)?r:t;f[g+80>>2]=q;g=kGa(a,1,t<<2)|0;if(t|0){r=0;j=q;while(1){q=t-r|0;j=j>>>0<q>>>0?j:q;q=Y(j,o)|0;m=f[b>>2]|0;if(q>>>0>999999984){i=f[a>>2]|0;f[i+20>>2]=56;f[i+24>>2]=3;ki[f[i>>2]&2047](a)}i=q&7;h=((i|0)==0?0:8-i|0)+q|0;q=h+16|0;i=TJa(a,q)|0;if(!i){k=f[a>>2]|0;f[k+20>>2]=56;f[k+24>>2]=4;ki[f[k>>2]&2047](a)}k=m+76|0;f[k>>2]=(f[k>>2]|0)+q;q=m+64|0;f[i>>2]=f[q>>2];f[i+4>>2]=h;f[i+8>>2]=0;f[q>>2]=i;if(!j)v=r;else{q=r;h=j;m=i+16|0;while(1){i=q+1|0;f[g+(q<<2)>>2]=m;h=h+-1|0;if(!h){v=i;break}else{q=i;m=m+o|0}}}if(v>>>0>=t>>>0)break;else r=v}}f[p>>2]=g;f[p+20>>2]=f[d>>2];f[p+24>>2]=0;f[p+28>>2]=0;f[p+36>>2]=0}p=f[p+44>>2]|0}while((p|0)!=0)}p=f[n>>2]|0;if(!p)return;n=c+80|0;c=p;do{if(!(f[c>>2]|0)){p=f[c+4>>2]|0;d=f[c+12>>2]|0;if(((((p+-1|0)>>>0)/(d>>>0)|0)+1|0)>(s|0)){v=Y(d,s)|0;d=c+16|0;f[d>>2]=v;v=c+8|0;WJa(a,c+48|0,Y(p<<7,f[v>>2]|0)|0);f[c+40>>2]=1;w=f[d>>2]|0;x=v}else{f[c+16>>2]=p;w=p;x=c+8|0}p=f[x>>2]|0;v=f[b>>2]|0;d=p<<7;t=999999984/(d>>>0)|0;if(d>>>0>999999984){u=f[a>>2]|0;f[u+20>>2]=72;ki[f[u>>2]&2047](a)}u=(t|0)<(w|0)?t:w;f[v+80>>2]=u;v=kGa(a,1,w<<2)|0;if(w|0){t=0;r=u;while(1){u=w-t|0;r=r>>>0<u>>>0?r:u;u=Y(r,d)|0;o=f[b>>2]|0;if(u>>>0>999999984){j=f[a>>2]|0;f[j+20>>2]=56;f[j+24>>2]=3;ki[f[j>>2]&2047](a)}j=u|16;m=TJa(a,j)|0;if(!m){q=f[a>>2]|0;f[q+20>>2]=56;f[q+24>>2]=4;ki[f[q>>2]&2047](a)}q=o+76|0;f[q>>2]=(f[q>>2]|0)+j;j=o+64|0;f[m>>2]=f[j>>2];f[m+4>>2]=u;f[m+8>>2]=0;f[j>>2]=m;if(!r)y=t;else{j=t;u=r;o=m+16|0;while(1){m=j+1|0;f[v+(j<<2)>>2]=o;u=u+-1|0;if(!u){y=m;break}else{j=m;o=o+(p<<7)|0}}}if(y>>>0>=w>>>0)break;else t=y}}f[c>>2]=v;f[c+20>>2]=f[n>>2];f[c+24>>2]=0;f[c+28>>2]=0;f[c+36>>2]=0}c=f[c+44>>2]|0}while((c|0)!=0);return}function rGa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=d+c|0;h=b+4|0;if(!((g>>>0<=(f[h>>2]|0)>>>0?(f[b+12>>2]|0)>>>0>=d>>>0:0)?(f[b>>2]|0)!=0:0)){d=f[a>>2]|0;f[d+20>>2]=23;ki[f[d>>2]&2047](a)}d=b+24|0;i=f[d>>2]|0;if(!(i>>>0<=c>>>0?g>>>0<=((f[b+16>>2]|0)+i|0)>>>0:0))j=7;a:do if((j|0)==7){if(!(f[b+40>>2]|0)){i=f[a>>2]|0;f[i+20>>2]=71;ki[f[i>>2]&2047](a)}i=b+36|0;if(f[i>>2]|0){k=f[b+8>>2]|0;l=f[d>>2]|0;m=b+20|0;n=b+16|0;o=f[n>>2]|0;b:do if((o|0)>0?(p=b+28|0,q=b+48|0,r=b+52|0,s=f[m>>2]|0,t=(s|0)<(o|0)?s:o,s=(f[p>>2]|0)-l|0,u=(t|0)<(s|0)?t:s,s=(f[h>>2]|0)-l|0,t=(u|0)<(s|0)?u:s,(t|0)>=1):0){s=t;t=Y(l,k)|0;u=0;while(1){v=Y(s,k)|0;Bh[f[r>>2]&255](a,q,f[(f[b>>2]|0)+(u<<2)>>2]|0,t,v);w=f[m>>2]|0;u=w+u|0;x=f[n>>2]|0;if((x|0)<=(u|0))break b;y=x-u|0;x=(w|0)<(y|0)?w:y;y=u+(f[d>>2]|0)|0;w=(f[p>>2]|0)-y|0;z=(x|0)<(w|0)?x:w;w=(f[h>>2]|0)-y|0;s=(z|0)<(w|0)?z:w;if((s|0)<1)break;else t=v+t|0}}while(0);f[i>>2]=0}n=b+16|0;m=f[n>>2]|0;if((f[d>>2]|0)>>>0<c>>>0)A=c;else{k=g-m|0;A=(k|0)>0?k:0}f[d>>2]=A;k=f[b+8>>2]|0;l=b+20|0;if((m|0)>0?(o=b+28|0,t=b+48|0,s=f[l>>2]|0,p=(s|0)<(m|0)?s:m,m=(f[o>>2]|0)-A|0,s=(p|0)<(m|0)?p:m,m=(f[h>>2]|0)-A|0,p=(s|0)<(m|0)?s:m,(p|0)>=1):0){m=p;p=Y(k,A)|0;s=0;while(1){u=Y(m,k)|0;Bh[f[t>>2]&255](a,t,f[(f[b>>2]|0)+(s<<2)>>2]|0,p,u);q=f[l>>2]|0;s=q+s|0;r=f[n>>2]|0;if((r|0)<=(s|0))break a;v=r-s|0;r=(q|0)<(v|0)?q:v;v=s+(f[d>>2]|0)|0;q=(f[o>>2]|0)-v|0;w=(r|0)<(q|0)?r:q;q=(f[h>>2]|0)-v|0;m=(w|0)<(q|0)?w:q;if((m|0)<1)break;else p=u+p|0}}}while(0);h=b+28|0;A=f[h>>2]|0;do if(A>>>0<g>>>0){p=(e|0)==0;if(A>>>0<c>>>0)if(p){B=0;C=c}else{m=f[a>>2]|0;f[m+20>>2]=23;ki[f[m>>2]&2047](a);D=c;j=28}else if(p){B=0;C=A}else{D=A;j=28}if((j|0)==28){f[h>>2]=g;B=1;C=D}if(!(f[b+32>>2]|0)){if(B)break;p=f[a>>2]|0;f[p+20>>2]=23;ki[f[p>>2]&2047](a);break}p=f[b+8>>2]|0;m=f[d>>2]|0;o=C-m|0;s=g-m|0;if(o>>>0<s>>>0){m=o;do{F1a(f[(f[b>>2]|0)+(m<<2)>>2]|0,0,p|0)|0;m=m+1|0}while((m|0)!=(s|0))}}while(0);if(!e){E=f[b>>2]|0;F=f[d>>2]|0;G=c-F|0;H=E+(G<<2)|0;return H|0}f[b+36>>2]=1;E=f[b>>2]|0;F=f[d>>2]|0;G=c-F|0;H=E+(G<<2)|0;return H|0}function sGa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=d+c|0;h=b+4|0;if(!((g>>>0<=(f[h>>2]|0)>>>0?(f[b+12>>2]|0)>>>0>=d>>>0:0)?(f[b>>2]|0)!=0:0)){d=f[a>>2]|0;f[d+20>>2]=23;ki[f[d>>2]&2047](a)}d=b+24|0;i=f[d>>2]|0;if(!(i>>>0<=c>>>0?g>>>0<=((f[b+16>>2]|0)+i|0)>>>0:0))j=7;a:do if((j|0)==7){if(!(f[b+40>>2]|0)){i=f[a>>2]|0;f[i+20>>2]=71;ki[f[i>>2]&2047](a)}i=b+36|0;if(f[i>>2]|0){k=f[b+8>>2]<<7;l=f[d>>2]|0;m=b+20|0;n=b+16|0;o=f[n>>2]|0;b:do if((o|0)>0?(p=b+28|0,q=b+48|0,r=b+52|0,s=f[m>>2]|0,t=(s|0)<(o|0)?s:o,s=(f[p>>2]|0)-l|0,u=(t|0)<(s|0)?t:s,s=(f[h>>2]|0)-l|0,t=(u|0)<(s|0)?u:s,(t|0)>=1):0){s=t;t=Y(l,k)|0;u=0;while(1){v=Y(s,k)|0;Bh[f[r>>2]&255](a,q,f[(f[b>>2]|0)+(u<<2)>>2]|0,t,v);w=f[m>>2]|0;u=w+u|0;x=f[n>>2]|0;if((x|0)<=(u|0))break b;y=x-u|0;x=(w|0)<(y|0)?w:y;y=u+(f[d>>2]|0)|0;w=(f[p>>2]|0)-y|0;z=(x|0)<(w|0)?x:w;w=(f[h>>2]|0)-y|0;s=(z|0)<(w|0)?z:w;if((s|0)<1)break;else t=v+t|0}}while(0);f[i>>2]=0}n=b+16|0;m=f[n>>2]|0;if((f[d>>2]|0)>>>0<c>>>0)A=c;else{k=g-m|0;A=(k|0)>0?k:0}f[d>>2]=A;k=f[b+8>>2]<<7;l=b+20|0;if((m|0)>0?(o=b+28|0,t=b+48|0,s=f[l>>2]|0,p=(s|0)<(m|0)?s:m,m=(f[o>>2]|0)-A|0,s=(p|0)<(m|0)?p:m,m=(f[h>>2]|0)-A|0,p=(s|0)<(m|0)?s:m,(p|0)>=1):0){m=p;p=Y(k,A)|0;s=0;while(1){u=Y(m,k)|0;Bh[f[t>>2]&255](a,t,f[(f[b>>2]|0)+(s<<2)>>2]|0,p,u);q=f[l>>2]|0;s=q+s|0;r=f[n>>2]|0;if((r|0)<=(s|0))break a;v=r-s|0;r=(q|0)<(v|0)?q:v;v=s+(f[d>>2]|0)|0;q=(f[o>>2]|0)-v|0;w=(r|0)<(q|0)?r:q;q=(f[h>>2]|0)-v|0;m=(w|0)<(q|0)?w:q;if((m|0)<1)break;else p=u+p|0}}}while(0);h=b+28|0;A=f[h>>2]|0;do if(A>>>0<g>>>0){p=(e|0)==0;if(A>>>0<c>>>0)if(p){B=0;C=c}else{m=f[a>>2]|0;f[m+20>>2]=23;ki[f[m>>2]&2047](a);D=c;j=28}else if(p){B=0;C=A}else{D=A;j=28}if((j|0)==28){f[h>>2]=g;B=1;C=D}if(!(f[b+32>>2]|0)){if(B)break;p=f[a>>2]|0;f[p+20>>2]=23;ki[f[p>>2]&2047](a);break}p=f[b+8>>2]<<7;m=f[d>>2]|0;o=C-m|0;s=g-m|0;if(o>>>0<s>>>0){m=o;do{F1a(f[(f[b>>2]|0)+(m<<2)>>2]|0,0,p|0)|0;m=m+1|0}while((m|0)!=(s|0))}}while(0);if(!e){E=f[b>>2]|0;F=f[d>>2]|0;G=c-F|0;H=E+(G<<2)|0;return H|0}f[b+36>>2]=1;E=f[b>>2]|0;F=f[d>>2]|0;G=c-F|0;H=E+(G<<2)|0;return H|0}function tGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[a+4>>2]|0;if(b>>>0<=1){if((b|0)==1){d=c+68|0;e=f[d>>2]|0;if(e|0){g=e;do{e=g+40|0;if(f[e>>2]|0){f[e>>2]=0;Gh[f[g+56>>2]&511](a,g+48|0)}g=f[g+44>>2]|0}while((g|0)!=0)}f[d>>2]=0;d=c+72|0;g=f[d>>2]|0;if(g|0){e=g;do{g=e+40|0;if(f[g>>2]|0){f[g>>2]=0;Gh[f[e+56>>2]&511](a,e+48|0)}e=f[e+44>>2]|0}while((e|0)!=0)}f[d>>2]=0}}else{d=f[a>>2]|0;f[d+20>>2]=15;f[d+24>>2]=b;ki[f[d>>2]&2047](a)}d=c+60+(b<<2)|0;e=f[d>>2]|0;f[d>>2]=0;if(e|0){d=c+76|0;g=e;do{e=g;g=f[g>>2]|0;h=(f[e+4>>2]|0)+16+(f[e+8>>2]|0)|0;UJa(a,e,h);f[d>>2]=(f[d>>2]|0)-h}while((g|0)!=0)}g=c+52+(b<<2)|0;b=f[g>>2]|0;f[g>>2]=0;if(!b)return;g=c+76|0;c=b;do{b=c;c=f[c>>2]|0;d=(f[b+4>>2]|0)+16+(f[b+8>>2]|0)|0;SJa(a,b,d);f[g>>2]=(f[g>>2]|0)-d}while((c|0)!=0);return}function uGa(a){a=a|0;var b=0;tGa(a,1);tGa(a,0);b=a+4|0;SJa(a,f[b>>2]|0,84);f[b>>2]=0;$Ja(a);return}function vGa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;c=a+4|0;d=ui[f[f[c>>2]>>2]&127](a,1,88)|0;e=a+484|0;f[e>>2]=d;f[d>>2]=396;f[d+8>>2]=998;f[d+12>>2]=999;f[d+68>>2]=0;f[d+52>>2]=0;d=a+120|0;if((f[d>>2]|0)>4){g=f[a>>2]|0;f[g+20>>2]=57;f[g+24>>2]=4;ki[f[g>>2]&2047](a)}g=a+96|0;h=f[g>>2]|0;if((h|0)>256){i=f[a>>2]|0;f[i+20>>2]=59;f[i+24>>2]=256;ki[f[i>>2]&2047](a);j=f[g>>2]|0}else j=h;h=f[e>>2]|0;g=h+32|0;i=f[d>>2]|0;if((i|0)>1){k=1;while(1){l=k+1|0;m=1;n=l;do{n=Y(n,l)|0;m=m+1|0}while((m|0)!=(i|0));if((n|0)>(j|0)){o=k;p=n;break}else k=l}}else{k=(j|0)>1?j:1;o=k;p=k+1|0}if((o|0)<2){k=f[a>>2]|0;f[k+20>>2]=58;f[k+24>>2]=p;ki[f[k>>2]&2047](a)}if((i|0)>0){k=0;p=1;do{f[h+32+(k<<2)>>2]=o;p=Y(p,o)|0;k=k+1|0}while((k|0)!=(i|0));if((f[a+44>>2]|0)==2){k=p;a:while(1){o=0;m=0;q=k;while(1){r=h+32+(f[120256+(m<<2)>>2]<<2)|0;s=f[r>>2]|0;t=s+1|0;u=Y((q|0)/(s|0)|0,t)|0;if((u|0)>(j|0))break;f[r>>2]=t;t=m+1|0;if((t|0)<(i|0)){o=1;m=t;q=u}else{k=u;continue a}}if(!o){v=q;break}else k=q}}else{k=p;b:while(1){p=0;m=0;l=k;while(1){n=h+32+(m<<2)|0;u=f[n>>2]|0;t=u+1|0;r=Y((l|0)/(u|0)|0,t)|0;if((r|0)>(j|0))break;f[n>>2]=t;t=m+1|0;if((t|0)<(i|0)){p=1;m=t;l=r}else{k=r;continue b}}if(!p){v=l;break}else k=l}}}else v=1;k=f[a>>2]|0;i=f[k+4>>2]|0;if((f[d>>2]|0)==3){f[k+24>>2]=v;f[k+28>>2]=f[g>>2];f[k+32>>2]=f[h+36>>2];f[k+36>>2]=f[h+40>>2];f[k+20>>2]=96;Gh[i&511](a,1)}else{f[k+20>>2]=97;f[k+24>>2]=v;Gh[i&511](a,1)}i=Jg[f[(f[c>>2]|0)+8>>2]&63](a,1,v,f[d>>2]|0)|0;k=f[d>>2]|0;if((k|0)>0){g=k;k=v;j=0;while(1){m=f[h+32+(j<<2)>>2]|0;q=k;k=(k|0)/(m|0)|0;if((m|0)>0?(o=m+-1|0,r=(o|0)/2|0,t=i+(j<<2)|0,(k|0)>0):0){n=0;do{u=Y(n,k)|0;if((u|0)<(v|0)){s=(((n*255|0)+r|0)/(o|0)|0)&255;w=u;do{u=0;do{b[(f[t>>2]|0)+(u+w)>>0]=s;u=u+1|0}while((u|0)!=(k|0));w=w+q|0}while((w|0)<(v|0))}n=n+1|0}while((n|0)!=(m|0));x=f[d>>2]|0}else x=g;j=j+1|0;if((j|0)>=(x|0))break;else g=x}}f[h+16>>2]=i;f[h+20>>2]=v;zGa(a);if((f[a+88>>2]|0)!=2)return;v=f[e>>2]|0;e=(f[a+112>>2]<<1)+4|0;if((f[d>>2]|0)>0)y=0;else return;do{h=ui[f[(f[c>>2]|0)+4>>2]&127](a,1,e)|0;f[v+68+(y<<2)>>2]=h;y=y+1|0}while((y|0)<(f[d>>2]|0));return}function wGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;b=a+484|0;c=f[b>>2]|0;f[a+136>>2]=f[c+16>>2];f[a+132>>2]=f[c+20>>2];switch(f[a+88>>2]|0){case 0:{f[c+4>>2]=(f[a+120>>2]|0)==3?173:172;return}case 1:{d=a+120|0;f[c+4>>2]=(f[d>>2]|0)==3?175:174;f[c+48>>2]=0;if(!(f[c+28>>2]|0))zGa(a);if(f[c+52>>2]|0)return;e=f[b>>2]|0;b=f[d>>2]|0;if((b|0)<=0)return;g=a+4|0;i=b;b=0;while(1){j=f[e+32+(b<<2)>>2]|0;a:do if((b|0)>0){k=0;while(1){if((j|0)==(f[e+32+(k<<2)>>2]|0))break;l=k+1|0;if((l|0)<(b|0))k=l;else{m=12;break a}}l=f[e+52+(k<<2)>>2]|0;if(l){n=i;o=l}else m=12}else m=12;while(0);if((m|0)==12){m=0;l=ui[f[f[g>>2]>>2]&127](a,1,1024)|0;p=(j<<9)+-512|0;q=0;do{r=0;do{s=255-((h[365460+(q<<4)+r>>0]|0)<<1)|0;t=s*255|0;if((s|0)<0)u=0-((0-t|0)/(p|0)|0)|0;else u=(t|0)/(p|0)|0;f[l+(q<<6)+(r<<2)>>2]=u;r=r+1|0}while((r|0)!=16);q=q+1|0}while((q|0)!=16);n=f[d>>2]|0;o=l}f[e+52+(b<<2)>>2]=o;b=b+1|0;if((b|0)>=(n|0))break;else i=n}return}case 2:{f[c+4>>2]=176;f[c+84>>2]=0;if(!(f[c+68>>2]|0)){n=a+112|0;i=(f[n>>2]<<1)+4|0;b=a+120|0;if((f[b>>2]|0)<=0)return;o=a+4|0;e=0;do{d=ui[f[(f[o>>2]|0)+4>>2]&127](a,1,i)|0;f[c+68+(e<<2)>>2]=d;e=e+1|0;d=f[b>>2]|0}while((e|0)<(d|0));v=d;w=b;x=n}else{n=a+120|0;v=f[n>>2]|0;w=n;x=a+112|0}n=(f[x>>2]<<1)+4|0;if((v|0)>0)y=0;else return;do{F1a(f[c+68+(y<<2)>>2]|0,0,n|0)|0;y=y+1|0}while((y|0)<(f[w>>2]|0));return}default:{w=f[a>>2]|0;f[w+20>>2]=49;ki[f[w>>2]&2047](a);return}}}function xGa(a){a=a|0;return}function yGa(a){a=a|0;var b=0;b=f[a>>2]|0;f[b+20>>2]=47;ki[f[b>>2]&2047](a);return}function zGa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;c=f[a+484>>2]|0;d=(f[a+88>>2]|0)==1;f[c+28>>2]=d&1;e=a+120|0;g=Jg[f[(f[a+4>>2]|0)+8>>2]&63](a,1,d?766:256,f[e>>2]|0)|0;a=c+24|0;f[a>>2]=g;h=f[c+20>>2]|0;if((f[e>>2]|0)<=0)return;if(d){i=g;j=h;k=0}else{d=g;g=h;h=0;while(1){l=f[c+32+(h<<2)>>2]|0;m=(g|0)/(l|0)|0;n=f[d+(h<<2)>>2]|0;o=l+-1|0;p=o<<1;q=0;r=(l+254|0)/(p|0)|0;l=0;while(1){if((q|0)>(r|0)){s=l;while(1){t=s+1|0;u=(((t<<1|1)*255|0)+o|0)/(p|0)|0;if((q|0)>(u|0))s=t;else{v=u;w=t;break}}}else{v=r;w=l}s=(Y(w,m)|0)&255;b[n+q>>0]=s;q=q+1|0;if((q|0)==256)break;else{r=v;l=w}}l=h+1|0;if((l|0)>=(f[e>>2]|0))break;d=f[a>>2]|0;g=m;h=l}return}while(1){h=f[c+32+(k<<2)>>2]|0;g=(j|0)/(h|0)|0;d=i+(k<<2)|0;f[d>>2]=(f[d>>2]|0)+255;d=f[(f[a>>2]|0)+(k<<2)>>2]|0;w=h+-1|0;v=w<<1;l=0;r=(h+254|0)/(v|0)|0;h=0;while(1){if((l|0)>(r|0)){q=h;while(1){n=q+1|0;p=(((n<<1|1)*255|0)+w|0)/(v|0)|0;if((l|0)>(p|0))q=n;else{x=p;y=n;break}}}else{x=r;y=h}q=(Y(y,g)|0)&255;b[d+l>>0]=q;l=l+1|0;if((l|0)==256)break;else{r=x;h=y}}h=d+255|0;r=1;do{b[d+(0-r)>>0]=b[d>>0]|0;b[d+(r+255)>>0]=b[h>>0]|0;r=r+1|0}while((r|0)!=256);r=k+1|0;if((r|0)>=(f[e>>2]|0))break;i=f[a>>2]|0;j=g;k=r}return}function AGa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0;g=f[(f[a+484>>2]|0)+24>>2]|0;i=f[g>>2]|0;j=f[g+4>>2]|0;k=f[g+8>>2]|0;g=f[a+112>>2]|0;if((e|0)<1|(g|0)==0)return;else l=0;do{a=g;m=f[c+(l<<2)>>2]|0;n=f[d+(l<<2)>>2]|0;while(1){b[n>>0]=(h[j+(h[m+1>>0]|0)>>0]|0)+(h[i+(h[m>>0]|0)>>0]|0)+(h[k+(h[m+2>>0]|0)>>0]|0);a=a+-1|0;if(!a)break;else{m=m+3|0;n=n+1|0}}l=l+1|0}while((l|0)!=(e|0));return}function BGa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=f[(f[a+484>>2]|0)+24>>2]|0;i=f[a+112>>2]|0;j=f[a+120>>2]|0;if((e|0)<=0)return;a=(j|0)>0;if(!i)return;else k=0;do{l=f[d+(k<<2)>>2]|0;if(a){m=i;n=f[c+(k<<2)>>2]|0;o=l;while(1){p=0;q=0;r=n;while(1){q=(h[(f[g+(p<<2)>>2]|0)+(h[r>>0]|0)>>0]|0)+q|0;p=p+1|0;if((p|0)==(j|0))break;else r=r+1|0}b[o>>0]=q;m=m+-1|0;if(!m)break;else{n=n+j|0;o=o+1|0}}}else F1a(l|0,0,i|0)|0;k=k+1|0}while((k|0)!=(e|0));return}function CGa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=f[a+484>>2]|0;i=f[g+24>>2]|0;j=f[i>>2]|0;k=f[i+4>>2]|0;l=f[i+8>>2]|0;i=f[a+112>>2]|0;if((e|0)<=0)return;a=g+48|0;m=g+52|0;n=g+56|0;o=g+60|0;g=f[a>>2]|0;if(!i){p=g;q=0;do{p=p+1&15;q=q+1|0}while((q|0)!=(e|0));f[a>>2]=p;return}else{r=g;s=0}do{g=f[m>>2]|0;p=f[n>>2]|0;q=f[o>>2]|0;t=i;u=0;v=f[c+(s<<2)>>2]|0;w=f[d+(s<<2)>>2]|0;while(1){b[w>>0]=(h[k+((h[v+1>>0]|0)+(f[p+(r<<6)+(u<<2)>>2]|0))>>0]|0)+(h[j+((h[v>>0]|0)+(f[g+(r<<6)+(u<<2)>>2]|0))>>0]|0)+(h[l+((h[v+2>>0]|0)+(f[q+(r<<6)+(u<<2)>>2]|0))>>0]|0);t=t+-1|0;if(!t)break;else{u=u+1&15;v=v+3|0;w=w+1|0}}r=r+1&15;f[a>>2]=r;s=s+1|0}while((s|0)!=(e|0));return}function DGa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=f[a+484>>2]|0;i=f[a+120>>2]|0;j=f[a+112>>2]|0;if((e|0)<=0)return;a=g+48|0;k=g+24|0;l=(j|0)==0;if((i|0)>0)m=0;else{n=0;do{F1a(f[d+(n<<2)>>2]|0,0,j|0)|0;f[a>>2]=(f[a>>2]|0)+1&15;n=n+1|0}while((n|0)!=(e|0));return}do{n=d+(m<<2)|0;F1a(f[n>>2]|0,0,j|0)|0;o=f[a>>2]|0;p=c+(m<<2)|0;if(!l){q=0;do{r=f[(f[k>>2]|0)+(q<<2)>>2]|0;s=f[g+52+(q<<2)>>2]|0;t=j;u=0;v=(f[p>>2]|0)+q|0;w=f[n>>2]|0;while(1){b[w>>0]=(h[w>>0]|0)+(h[r+((h[v>>0]|0)+(f[s+(o<<6)+(u<<2)>>2]|0))>>0]|0);t=t+-1|0;if(!t)break;else{u=u+1&15;v=v+i|0;w=w+1|0}}q=q+1|0}while((q|0)!=(i|0))}f[a>>2]=o+1&15;m=m+1|0}while((m|0)!=(e|0));return}function EGa(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;i=f[a+484>>2]|0;j=f[a+120>>2]|0;k=f[a+112>>2]|0;l=f[a+336>>2]|0;if((g|0)<=0)return;a=(j|0)>0;m=i+84|0;n=k+-1|0;o=Y(n,j)|0;p=0-j|0;q=k+1|0;r=i+24|0;s=i+16|0;t=(k|0)==0;u=0;do{v=e+(u<<2)|0;F1a(f[v>>2]|0,0,k|0)|0;w=(f[m>>2]|0)!=0;a:do if(a){x=c+(u<<2)|0;if(t){y=0;while(1){z=f[i+68+(y<<2)>>2]|0;d[(w?z+(q<<1)|0:z)>>1]=0;y=y+1|0;if((y|0)==(j|0)){A=w;break a}}}else{B=0;C=w}while(1){y=(f[x>>2]|0)+B|0;z=f[v>>2]|0;D=f[i+68+(B<<2)>>2]|0;E=C?D+(q<<1)|0:D;D=C?-1:1;F=C?p:j;G=f[(f[r>>2]|0)+(B<<2)>>2]|0;H=f[(f[s>>2]|0)+(B<<2)>>2]|0;I=Y(k,D)|0;J=0;K=0;L=k;M=0;N=E;O=C?y+o|0:y;y=C?z+n|0:z;while(1){z=N;N=N+(D<<1)|0;P=h[l+((M+8+(d[N>>1]|0)>>4)+(h[O>>0]|0))>>0]|0;Q=h[G+P>>0]|0;b[y>>0]=(h[y>>0]|0)+Q;R=P-(h[H+Q>>0]|0)|0;d[z>>1]=(R*3|0)+K;K=(R*5|0)+J|0;L=L+-1|0;if(!L)break;else{J=R;M=R*7|0;O=O+F|0;y=y+D|0}}d[E+(I<<1)>>1]=K;B=B+1|0;D=(f[m>>2]|0)!=0;if((B|0)==(j|0)){A=D;break}else C=D}}else A=w;while(0);f[m>>2]=(A^1)&1;u=u+1|0}while((u|0)!=(g|0));return}function FGa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=a+4|0;c=ui[f[f[b>>2]>>2]&127](a,1,44)|0;f[a+484>>2]=c;f[c>>2]=397;f[c+12>>2]=1e3;d=c+32|0;f[d>>2]=0;f[c+40>>2]=0;if((f[a+120>>2]|0)!=3){e=f[a>>2]|0;f[e+20>>2]=48;ki[f[e>>2]&2047](a)}e=ui[f[f[b>>2]>>2]&127](a,1,128)|0;g=c+24|0;f[g>>2]=e;e=0;do{h=ui[f[(f[b>>2]|0)+4>>2]&127](a,1,4096)|0;f[(f[g>>2]|0)+(e<<2)>>2]=h;e=e+1|0}while((e|0)!=32);f[c+28>>2]=1;if(!(f[a+108>>2]|0))f[c+16>>2]=0;else{e=f[a+96>>2]|0;if((e|0)>=8){if((e|0)>256){g=f[a>>2]|0;f[g+20>>2]=59;f[g+24>>2]=256;ki[f[g>>2]&2047](a)}}else{g=f[a>>2]|0;f[g+20>>2]=58;f[g+24>>2]=8;ki[f[g>>2]&2047](a)}g=Jg[f[(f[b>>2]|0)+8>>2]&63](a,1,e,3)|0;f[c+16>>2]=g;f[c+20>>2]=e}e=a+88|0;if(!(f[e>>2]|0))return;f[e>>2]=2;e=ui[f[(f[b>>2]|0)+4>>2]&127](a,1,((f[a+112>>2]|0)*6|0)+12|0)|0;f[d>>2]=e;IGa(a);return}function GGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=f[a+484>>2]|0;d=f[c+24>>2]|0;e=a+88|0;if(!(f[e>>2]|0))g=0;else{f[e>>2]=2;g=2}if(!b){f[c+4>>2]=(g|0)==2?179:178;f[c+8>>2]=1002;g=f[a+132>>2]|0;if((g|0)>=1){if((g|0)>256){g=f[a>>2]|0;f[g+20>>2]=59;f[g+24>>2]=256;ki[f[g>>2]&2047](a)}}else{g=f[a>>2]|0;f[g+20>>2]=58;f[g+24>>2]=1;ki[f[g>>2]&2047](a)}if((f[e>>2]|0)==2){e=((f[a+112>>2]|0)*6|0)+12|0;g=c+32|0;b=f[g>>2]|0;if(!b){h=ui[f[(f[a+4>>2]|0)+4>>2]&127](a,1,e)|0;f[g>>2]=h;i=h}else i=b;F1a(i|0,0,e|0)|0;if(!(f[c+40>>2]|0))IGa(a);f[c+36>>2]=0}}else{f[c+4>>2]=177;f[c+8>>2]=1001;f[c+28>>2]=1}a=c+28|0;if(!(f[a>>2]|0))return;F1a(f[d>>2]|0,0,4096)|0;F1a(f[d+4>>2]|0,0,4096)|0;F1a(f[d+8>>2]|0,0,4096)|0;F1a(f[d+12>>2]|0,0,4096)|0;F1a(f[d+16>>2]|0,0,4096)|0;F1a(f[d+20>>2]|0,0,4096)|0;F1a(f[d+24>>2]|0,0,4096)|0;F1a(f[d+28>>2]|0,0,4096)|0;F1a(f[d+32>>2]|0,0,4096)|0;F1a(f[d+36>>2]|0,0,4096)|0;F1a(f[d+40>>2]|0,0,4096)|0;F1a(f[d+44>>2]|0,0,4096)|0;F1a(f[d+48>>2]|0,0,4096)|0;F1a(f[d+52>>2]|0,0,4096)|0;F1a(f[d+56>>2]|0,0,4096)|0;F1a(f[d+60>>2]|0,0,4096)|0;F1a(f[d+64>>2]|0,0,4096)|0;F1a(f[d+68>>2]|0,0,4096)|0;F1a(f[d+72>>2]|0,0,4096)|0;F1a(f[d+76>>2]|0,0,4096)|0;F1a(f[d+80>>2]|0,0,4096)|0;F1a(f[d+84>>2]|0,0,4096)|0;F1a(f[d+88>>2]|0,0,4096)|0;F1a(f[d+92>>2]|0,0,4096)|0;F1a(f[d+96>>2]|0,0,4096)|0;F1a(f[d+100>>2]|0,0,4096)|0;F1a(f[d+104>>2]|0,0,4096)|0;F1a(f[d+108>>2]|0,0,4096)|0;F1a(f[d+112>>2]|0,0,4096)|0;F1a(f[d+116>>2]|0,0,4096)|0;F1a(f[d+120>>2]|0,0,4096)|0;F1a(f[d+124>>2]|0,0,4096)|0;f[a>>2]=0;return}function HGa(a){a=a|0;f[(f[a+484>>2]|0)+28>>2]=1;return}function IGa(a){a=a|0;var b=0,c=0,d=0;b=f[a+484>>2]|0;c=ui[f[f[a+4>>2]>>2]&127](a,1,2044)|0;a=c+1020|0;f[b+40>>2]=a;f[a>>2]=0;f[c+1024>>2]=1;f[c+1016>>2]=-1;f[c+1028>>2]=2;f[c+1012>>2]=-2;f[c+1032>>2]=3;f[c+1008>>2]=-3;f[c+1036>>2]=4;f[c+1004>>2]=-4;f[c+1040>>2]=5;f[c+1e3>>2]=-5;f[c+1044>>2]=6;f[c+996>>2]=-6;f[c+1048>>2]=7;f[c+992>>2]=-7;f[c+1052>>2]=8;f[c+988>>2]=-8;f[c+1056>>2]=9;f[c+984>>2]=-9;f[c+1060>>2]=10;f[c+980>>2]=-10;f[c+1064>>2]=11;f[c+976>>2]=-11;f[c+1068>>2]=12;f[c+972>>2]=-12;f[c+1072>>2]=13;f[c+968>>2]=-13;f[c+1076>>2]=14;f[c+964>>2]=-14;f[c+1080>>2]=15;f[c+960>>2]=-15;c=16;b=16;do{f[a+(c<<2)>>2]=b;f[a+(0-c<<2)>>2]=0-b;c=c+1|0;b=(c&1^1)+b|0}while((c|0)!=48);c=0-b|0;d=48;do{f[a+(d<<2)>>2]=b;f[a+(0-d<<2)>>2]=c;d=d+1|0}while((d|0)!=256);return}function JGa(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0;c=f[(f[a+484>>2]|0)+24>>2]|0;g=f[a+112>>2]|0;if((e|0)<1|(g|0)==0)return;else i=0;do{a=g;j=f[b+(i<<2)>>2]|0;while(1){k=(f[c+((h[j>>0]|0)>>>3<<2)>>2]|0)+((h[j+1>>0]|0)>>>2<<6)+((h[j+2>>0]|0)>>>3<<1)|0;l=d[k>>1]|0;m=l+1<<16>>16;d[k>>1]=m<<16>>16==0?l:m;a=a+-1|0;if(!a)break;else j=j+3|0}i=i+1|0}while((i|0)!=(e|0));return}function KGa(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0;c=a+484|0;e=f[c>>2]|0;g=a+136|0;f[g>>2]=f[e+16>>2];h=f[e+20>>2]|0;i=ui[f[f[a+4>>2]>>2]&127](a,1,h<<5)|0;f[i>>2]=0;f[i+4>>2]=31;f[i+8>>2]=0;f[i+12>>2]=63;f[i+16>>2]=0;f[i+20>>2]=31;PGa(a,i);if((h|0)>1){j=1;while(1){if((j<<1|0)>(h|0)){k=i;l=0;m=0;n=0;while(1){o=f[k+24>>2]|0;p=(o|0)>(m|0);q=p?k:n;l=l+1|0;if((l|0)==(j|0)){r=q;break}else{k=k+32|0;m=p?o:m;n=q}}}else{n=i;m=0;k=0;l=0;while(1){q=f[n+28>>2]|0;if((q|0)>(k|0)){o=(f[n+24>>2]|0)>0;s=o?q:k;t=o?n:l}else{s=k;t=l}m=m+1|0;if((m|0)==(j|0)){r=t;break}else{n=n+32|0;k=s;l=t}}}if(!r){u=j;break}l=i+(j<<5)|0;k=r+4|0;f[i+(j<<5)+4>>2]=f[k>>2];n=r+12|0;f[i+(j<<5)+12>>2]=f[n>>2];m=r+20|0;f[i+(j<<5)+20>>2]=f[m>>2];f[l>>2]=f[r>>2];o=r+8|0;q=i+(j<<5)+8|0;f[q>>2]=f[o>>2];p=r+16|0;v=i+(j<<5)+16|0;f[v>>2]=f[p>>2];w=f[k>>2]|0;x=f[r>>2]|0;y=w-x<<4;z=f[n>>2]|0;A=f[o>>2]|0;o=(z-A|0)*12|0;B=f[m>>2]|0;C=f[p>>2]|0;p=(y|0)>(o|0);switch(((B-C<<3|0)>((p?y:o)|0)?2:(p^1)&1)&3){case 0:{p=(x+w|0)/2|0;f[k>>2]=p;D=l;E=p;F=12;break}case 1:{p=(A+z|0)/2|0;f[n>>2]=p;D=q;E=p;F=12;break}case 2:{p=(C+B|0)/2|0;f[m>>2]=p;D=v;E=p;F=12;break}default:{}}if((F|0)==12){F=0;f[D>>2]=E+1}PGa(a,r);PGa(a,l);l=j+1|0;if((l|0)<(h|0))j=l;else{u=l;break}}if((u|0)>0)G=u;else{H=u;I=a+132|0;f[I>>2]=H;J=f[a>>2]|0;K=J+20|0;f[K>>2]=98;L=J+24|0;f[L>>2]=H;M=J+4|0;N=f[M>>2]|0;Gh[N&511](a,1);O=e+28|0;f[O>>2]=1;return}}else G=1;u=0;do{j=f[(f[c>>2]|0)+24>>2]|0;h=f[i+(u<<5)>>2]|0;r=f[i+(u<<5)+4>>2]|0;E=f[i+(u<<5)+8>>2]|0;D=f[i+(u<<5)+12>>2]|0;F=f[i+(u<<5)+16>>2]|0;t=f[i+(u<<5)+20>>2]|0;if((h|0)>(r|0)|(E|0)>(D|0)|(F|0)>(t|0)){P=0;Q=0;R=0;S=0}else{s=h;h=0;l=0;p=0;v=0;while(1){m=f[j+(s<<2)>>2]|0;B=s<<3|4;C=h;q=E;n=l;z=p;A=v;while(1){k=q<<2|2;w=C;x=n;o=F;y=z;T=m+(q<<6)+(F<<1)|0;U=A;while(1){V=d[T>>1]|0;W=V&65535;if(!(V<<16>>16)){X=w;Z=x;_=y;$=U}else{X=(Y(W,B)|0)+w|0;Z=(Y(W,k)|0)+x|0;_=(Y(W,o<<3|4)|0)+y|0;$=W+U|0}if((o|0)<(t|0)){w=X;x=Z;o=o+1|0;y=_;T=T+2|0;U=$}else break}if((q|0)<(D|0)){C=X;q=q+1|0;n=Z;z=_;A=$}else break}if((s|0)<(r|0)){s=s+1|0;h=X;l=Z;p=_;v=$}else{P=X;Q=Z;R=_;S=$;break}}}v=S>>1;b[(f[f[g>>2]>>2]|0)+u>>0]=(P+v|0)/(S|0)|0;b[(f[(f[g>>2]|0)+4>>2]|0)+u>>0]=(Q+v|0)/(S|0)|0;b[(f[(f[g>>2]|0)+8>>2]|0)+u>>0]=(R+v|0)/(S|0)|0;u=u+1|0}while((u|0)!=(G|0));H=G;I=a+132|0;f[I>>2]=H;J=f[a>>2]|0;K=J+20|0;f[K>>2]=98;L=J+24|0;f[L>>2]=H;M=J+4|0;N=f[M>>2]|0;Gh[N&511](a,1);O=e+28|0;f[O>>2]=1;return}function LGa(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0;i=f[a+484>>2]|0;j=f[i+24>>2]|0;k=f[a+112>>2]|0;l=f[a+336>>2]|0;m=f[i+40>>2]|0;n=f[a+136>>2]|0;o=f[n>>2]|0;p=f[n+4>>2]|0;q=f[n+8>>2]|0;if((g|0)<=0)return;n=i+36|0;r=i+32|0;i=k+-1|0;s=i*3|0;t=(k*3|0)+3|0;u=(k|0)==0;v=0;do{w=f[c+(v<<2)>>2]|0;x=f[e+(v<<2)>>2]|0;y=(f[n>>2]|0)==0;z=f[r>>2]|0;A=y?z:z+(t<<1)|0;z=y?1:-1;B=y?3:-3;f[n>>2]=y&1;if(u){C=0;D=0;E=0;F=A}else{G=B+1|0;H=B+2|0;I=Y(k,B)|0;J=0;K=0;L=0;M=0;N=0;O=0;P=k;Q=0;R=0;S=0;T=A;U=y?w:w+s|0;w=y?x:x+i|0;while(1){x=T;T=T+(B<<1)|0;y=h[l+((h[U>>0]|0)+(f[m+(Q+8+(d[T>>1]|0)>>4<<2)>>2]|0))>>0]|0;V=h[l+((h[U+1>>0]|0)+(f[m+(R+8+(d[x+(G<<1)>>1]|0)>>4<<2)>>2]|0))>>0]|0;W=h[l+((h[U+2>>0]|0)+(f[m+(S+8+(d[x+(H<<1)>>1]|0)>>4<<2)>>2]|0))>>0]|0;X=y>>>3;Z=V>>>2;_=W>>>3;$=(f[j+(X<<2)>>2]|0)+(Z<<6)+(_<<1)|0;aa=d[$>>1]|0;if(!(aa<<16>>16)){OGa(a,X,Z,_);ba=d[$>>1]|0}else ba=aa;aa=(ba&65535)+-1|0;b[w>>0]=aa;$=y-(h[o+aa>>0]|0)|0;y=V-(h[p+aa>>0]|0)|0;V=W-(h[q+aa>>0]|0)|0;d[x>>1]=($*3|0)+M;M=($*5|0)+J|0;d[x+2>>1]=(y*3|0)+N;N=(y*5|0)+K|0;d[x+4>>1]=(V*3|0)+O;O=(V*5|0)+L|0;P=P+-1|0;if(!P)break;else{J=$;K=y;L=V;Q=$*7|0;R=y*7|0;S=V*7|0;U=U+B|0;w=w+z|0}}C=M;D=N;E=O;F=A+(I<<1)|0}d[F>>1]=C;d[F+2>>1]=D;d[F+4>>1]=E;v=v+1|0}while((v|0)!=(g|0));return}function MGa(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;i=f[(f[a+484>>2]|0)+24>>2]|0;j=f[a+112>>2]|0;if((g|0)<1|(j|0)==0)return;else k=0;do{l=j;m=f[c+(k<<2)>>2]|0;n=f[e+(k<<2)>>2]|0;while(1){o=(h[m>>0]|0)>>>3;p=(h[m+1>>0]|0)>>>2;q=(h[m+2>>0]|0)>>>3;r=(f[i+(o<<2)>>2]|0)+(p<<6)+(q<<1)|0;s=d[r>>1]|0;if(!(s<<16>>16)){OGa(a,o,p,q);t=d[r>>1]|0}else t=s;b[n>>0]=(t&65535)+255;l=l+-1|0;if(!l)break;else{m=m+3|0;n=n+1|0}}k=k+1|0}while((k|0)!=(g|0));return}function NGa(a){a=a|0;return}function OGa(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;i=u;u=u+1408|0;j=i;k=i+1152|0;l=i+1024|0;m=f[(f[a+484>>2]|0)+24>>2]|0;n=c>>2;c=e>>3;e=g>>2;g=n<<5;o=g|4;p=c<<5;q=p|2;r=e<<5;s=r|4;t=f[a+132>>2]|0;v=g|28;g=v+o>>1;w=p|30;p=w+q>>1;x=r|28;r=x+s>>1;if((t|0)>0){y=f[a+136>>2]|0;z=f[y>>2]|0;A=f[y+4>>2]|0;B=f[y+8>>2]|0;y=0;C=2147483647;do{D=h[z+y>>0]|0;do if((D|0)>=(o|0)){if((D|0)>(v|0)){E=D-v<<1;F=D-o<<1;G=Y(F,F)|0;H=Y(E,E)|0;break}if((D|0)>(g|0)){E=D-o<<1;G=Y(E,E)|0;H=0;break}else{E=D-v<<1;G=Y(E,E)|0;H=0;break}}else{E=D-o<<1;F=D-v<<1;G=Y(F,F)|0;H=Y(E,E)|0}while(0);D=h[A+y>>0]|0;do if((D|0)>=(q|0)){if((D|0)>(w|0)){E=(D-w|0)*3|0;F=(D-q|0)*3|0;I=(Y(E,E)|0)+H|0;J=Y(F,F)|0;break}if((D|0)>(p|0)){F=(D-q|0)*3|0;I=H;J=Y(F,F)|0;break}else{F=(D-w|0)*3|0;I=H;J=Y(F,F)|0;break}}else{F=(D-q|0)*3|0;E=(D-w|0)*3|0;I=(Y(F,F)|0)+H|0;J=Y(E,E)|0}while(0);D=J+G|0;E=h[B+y>>0]|0;do if((E|0)>=(s|0)){if((E|0)>(x|0)){F=E-x|0;K=E-s|0;L=(Y(F,F)|0)+I|0;M=Y(K,K)|0;break}if((E|0)>(r|0)){K=E-s|0;L=I;M=Y(K,K)|0;break}else{K=E-x|0;L=I;M=Y(K,K)|0;break}}else{K=E-s|0;F=E-x|0;L=(Y(K,K)|0)+I|0;M=Y(F,F)|0}while(0);E=D+M|0;f[j+(y<<2)>>2]=L;C=(E|0)<(C|0)?E:C;y=y+1|0}while((y|0)!=(t|0));N=0;O=0;while(1){if((f[j+(N<<2)>>2]|0)>(C|0))P=O;else{b[k+O>>0]=N;P=O+1|0}N=N+1|0;if((N|0)==(t|0)){Q=P;break}else O=P}}else Q=0;P=j;O=127;while(1){f[P>>2]=2147483647;if((O|0)>0){P=P+4|0;O=O+-1|0}else break}if((Q|0)>0){O=a+136|0;a=j+128|0;P=l+32|0;t=j+256|0;N=l+64|0;C=j+384|0;y=l+96|0;L=0;do{M=b[k+L>>0]|0;I=M&255;x=f[O>>2]|0;r=o-(h[(f[x>>2]|0)+I>>0]|0)|0;B=r<<1;G=Y(B,B)|0;B=q-(h[(f[x+4>>2]|0)+I>>0]|0)|0;J=B*3|0;H=(Y(J,J)|0)+G|0;G=s-(h[(f[x+8>>2]|0)+I>>0]|0)|0;I=H+(Y(G,G)|0)|0;H=r<<6;r=H+256|0;x=(B*72|0)+144|0;B=G<<4;G=B+64|0;J=B+192|0;w=B+320|0;B=j;p=l;A=I;v=7;g=x;while(1){if((A|0)<(f[B>>2]|0)){f[B>>2]=A;b[p>>0]=M}z=G+A|0;E=B+4|0;if((z|0)<(f[E>>2]|0)){f[E>>2]=z;b[p+1>>0]=M}E=J+z|0;z=B+8|0;if((E|0)<(f[z>>2]|0)){f[z>>2]=E;b[p+2>>0]=M}z=w+E|0;E=B+12|0;if((z|0)<(f[E>>2]|0)){f[E>>2]=z;b[p+3>>0]=M}if((v|0)>0){B=B+16|0;p=p+4|0;A=A+g|0;v=v+-1|0;g=g+288|0}else break}g=I+r|0;v=H+768|0;A=a;p=P;B=g;D=7;z=x;while(1){if((B|0)<(f[A>>2]|0)){f[A>>2]=B;b[p>>0]=M}E=G+B|0;F=A+4|0;if((E|0)<(f[F>>2]|0)){f[F>>2]=E;b[p+1>>0]=M}F=J+E|0;E=A+8|0;if((F|0)<(f[E>>2]|0)){f[E>>2]=F;b[p+2>>0]=M}E=w+F|0;F=A+12|0;if((E|0)<(f[F>>2]|0)){f[F>>2]=E;b[p+3>>0]=M}if((D|0)>0){A=A+16|0;p=p+4|0;B=B+z|0;D=D+-1|0;z=z+288|0}else break}z=g+v|0;D=H+1280|0;B=t;p=N;A=z;r=7;I=x;while(1){if((A|0)<(f[B>>2]|0)){f[B>>2]=A;b[p>>0]=M}E=G+A|0;F=B+4|0;if((E|0)<(f[F>>2]|0)){f[F>>2]=E;b[p+1>>0]=M}F=J+E|0;E=B+8|0;if((F|0)<(f[E>>2]|0)){f[E>>2]=F;b[p+2>>0]=M}E=w+F|0;F=B+12|0;if((E|0)<(f[F>>2]|0)){f[F>>2]=E;b[p+3>>0]=M}if((r|0)>0){B=B+16|0;p=p+4|0;A=A+I|0;r=r+-1|0;I=I+288|0}else break}I=C;r=y;A=z+D|0;p=7;B=x;while(1){if((A|0)<(f[I>>2]|0)){f[I>>2]=A;b[r>>0]=M}H=G+A|0;v=I+4|0;if((H|0)<(f[v>>2]|0)){f[v>>2]=H;b[r+1>>0]=M}v=J+H|0;H=I+8|0;if((v|0)<(f[H>>2]|0)){f[H>>2]=v;b[r+2>>0]=M}H=w+v|0;v=I+12|0;if((H|0)<(f[v>>2]|0)){f[v>>2]=H;b[r+3>>0]=M}if((p|0)>0){I=I+16|0;r=r+4|0;A=A+B|0;p=p+-1|0;B=B+288|0}else break}L=L+1|0}while((L|0)!=(Q|0))}Q=n<<2;n=c<<3;c=e<<2;e=f[m+(Q<<2)>>2]|0;L=l;y=0;while(1){C=e+(y+n<<6)+(c<<1)|0;d[C>>1]=(h[L>>0]|0)+1;d[C+2>>1]=(h[L+1>>0]|0)+1;d[C+4>>1]=(h[L+2>>0]|0)+1;d[C+6>>1]=(h[L+3>>0]|0)+1;y=y+1|0;if((y|0)==8)break;else L=L+4|0}L=f[m+((Q|1)<<2)>>2]|0;y=l+32|0;e=0;while(1){C=L+(e+n<<6)+(c<<1)|0;d[C>>1]=(h[y>>0]|0)+1;d[C+2>>1]=(h[y+1>>0]|0)+1;d[C+4>>1]=(h[y+2>>0]|0)+1;d[C+6>>1]=(h[y+3>>0]|0)+1;e=e+1|0;if((e|0)==8)break;else y=y+4|0}y=f[m+((Q|2)<<2)>>2]|0;e=l+64|0;L=0;while(1){C=y+(L+n<<6)+(c<<1)|0;d[C>>1]=(h[e>>0]|0)+1;d[C+2>>1]=(h[e+1>>0]|0)+1;d[C+4>>1]=(h[e+2>>0]|0)+1;d[C+6>>1]=(h[e+3>>0]|0)+1;L=L+1|0;if((L|0)==8)break;else e=e+4|0}e=f[m+((Q|3)<<2)>>2]|0;Q=l+96|0;l=0;while(1){m=e+(l+n<<6)+(c<<1)|0;d[m>>1]=(h[Q>>0]|0)+1;d[m+2>>1]=(h[Q+1>>0]|0)+1;d[m+4>>1]=(h[Q+2>>0]|0)+1;d[m+6>>1]=(h[Q+3>>0]|0)+1;l=l+1|0;if((l|0)==8)break;else Q=Q+4|0}u=i;return}function PGa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=f[(f[a+484>>2]|0)+24>>2]|0;a=f[b>>2]|0;e=b+4|0;g=f[e>>2]|0;h=b+8|0;i=f[h>>2]|0;j=b+12|0;k=f[j>>2]|0;l=b+16|0;m=f[l>>2]|0;n=b+20|0;o=f[n>>2]|0;a:do if((g|0)<=(a|0)|(i|0)>(k|0)|(m|0)>(o|0))p=a;else{q=a;b:while(1){r=f[c+(q<<2)>>2]|0;s=i;while(1){t=m;u=r+(s<<6)+(m<<1)|0;while(1){if(d[u>>1]|0)break b;if((t|0)<(o|0)){t=t+1|0;u=u+2|0}else break}if((s|0)<(k|0))s=s+1|0;else break}if((q|0)<(g|0))q=q+1|0;else{p=a;break a}}f[b>>2]=q;p=q}while(0);c:do if((g|0)<=(p|0)|(i|0)>(k|0)|(m|0)>(o|0))v=g;else{a=g;d:while(1){s=f[c+(a<<2)>>2]|0;r=i;while(1){u=m;t=s+(r<<6)+(m<<1)|0;while(1){if(d[t>>1]|0)break d;if((u|0)<(o|0)){u=u+1|0;t=t+2|0}else break}if((r|0)<(k|0))r=r+1|0;else break}if((a|0)>(p|0))a=a+-1|0;else{v=g;break c}}f[e>>2]=a;v=a}while(0);e:do if((k|0)<=(i|0)|(v|0)<(p|0)|(m|0)>(o|0))w=i;else{e=i;f:while(1){g=p;while(1){q=m;r=(f[c+(g<<2)>>2]|0)+(e<<6)+(m<<1)|0;while(1){if(d[r>>1]|0)break f;if((q|0)<(o|0)){q=q+1|0;r=r+2|0}else break}if((g|0)<(v|0))g=g+1|0;else break}if((e|0)<(k|0))e=e+1|0;else{w=i;break e}}f[h>>2]=e;w=e}while(0);g:do if((k|0)<=(w|0)|(v|0)<(p|0)|(m|0)>(o|0))x=k;else{h=k;h:while(1){i=p;while(1){a=m;g=(f[c+(i<<2)>>2]|0)+(h<<6)+(m<<1)|0;while(1){if(d[g>>1]|0)break h;if((a|0)<(o|0)){a=a+1|0;g=g+2|0}else break}if((i|0)<(v|0))i=i+1|0;else break}if((h|0)>(w|0))h=h+-1|0;else{x=k;break g}}f[j>>2]=h;x=h}while(0);i:do if((o|0)<=(m|0)|(v|0)<(p|0)|(x|0)<(w|0))y=m;else{j=m;j:while(1){k=p;while(1){e=w;i=(f[c+(k<<2)>>2]|0)+(w<<6)+(j<<1)|0;while(1){if(d[i>>1]|0)break j;if((e|0)<(x|0)){e=e+1|0;i=i+64|0}else break}if((k|0)<(v|0))k=k+1|0;else break}if((j|0)<(o|0))j=j+1|0;else{y=m;break i}}f[l>>2]=j;y=j}while(0);k:do if((o|0)<=(y|0)|(v|0)<(p|0)|(x|0)<(w|0))z=o;else{l=o;l:while(1){m=p;while(1){h=w;k=(f[c+(m<<2)>>2]|0)+(w<<6)+(l<<1)|0;while(1){if(d[k>>1]|0)break l;if((h|0)<(x|0)){h=h+1|0;k=k+64|0}else break}if((m|0)<(v|0))m=m+1|0;else break}if((l|0)>(y|0))l=l+-1|0;else{z=o;break k}}f[n>>2]=l;z=l}while(0);n=v-p<<4;o=(x-w|0)*12|0;j=z-y<<3;m=(Y(o,o)|0)+(Y(n,n)|0)+(Y(j,j)|0)|0;f[b+24>>2]=m;if((v|0)<(p|0)|(x|0)<(w|0)|(z|0)<(y|0)){A=0;B=b+28|0;f[B>>2]=A;return}else{C=p;D=0}while(1){p=f[c+(C<<2)>>2]|0;m=w;j=D;while(1){n=y;E=j;o=p+(m<<6)+(y<<1)|0;while(1){E=((d[o>>1]|0)!=0&1)+E|0;if((n|0)>=(z|0))break;else{n=n+1|0;o=o+2|0}}if((m|0)<(x|0)){m=m+1|0;j=E}else break}if((C|0)<(v|0)){C=C+1|0;D=E}else{A=E;break}}B=b+28|0;f[B>>2]=A;return}function QGa(a,b){a=a|0;b=b|0;return (a+-1+b|0)/(b|0)|0|0}function RGa(a,b){a=a|0;b=b|0;var c=0;c=a+-1+b|0;return c-((c|0)%(b|0)|0)|0}function SGa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0;if((e|0)<=0)return;h=a+(b<<2)|0;b=c+(d<<2)|0;d=e;while(1){K1a(f[b>>2]|0,f[h>>2]|0,g|0)|0;if((d|0)>1){h=h+4|0;b=b+4|0;d=d+-1|0}else break}return}function TGa(a,b,c){a=a|0;b=b|0;c=c|0;K1a(b|0,a|0,c<<7|0)|0;return}function UGa(a){a=a|0;var c=0;c=ui[f[f[a+4>>2]>>2]&127](a,1,208)|0;f[a+424>>2]=c;f[c>>2]=398;f[c+8>>2]=1003;f[c+76>>2]=0;f[c+140>>2]=0;f[c+80>>2]=0;f[c+144>>2]=0;f[c+84>>2]=0;f[c+148>>2]=0;f[c+88>>2]=0;f[c+152>>2]=0;f[c+92>>2]=0;f[c+156>>2]=0;f[c+96>>2]=0;f[c+160>>2]=0;f[c+100>>2]=0;f[c+164>>2]=0;f[c+104>>2]=0;f[c+168>>2]=0;f[c+108>>2]=0;f[c+172>>2]=0;f[c+112>>2]=0;f[c+176>>2]=0;f[c+116>>2]=0;f[c+180>>2]=0;f[c+120>>2]=0;f[c+184>>2]=0;f[c+124>>2]=0;f[c+188>>2]=0;f[c+128>>2]=0;f[c+192>>2]=0;f[c+132>>2]=0;f[c+196>>2]=0;f[c+136>>2]=0;f[c+200>>2]=0;b[c+204>>0]=113;return}function VGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[a+424>>2]|0;if(c|0){c=f[a>>2]|0;f[c+20>>2]=49;ki[f[c>>2]&2047](a)}do if(f[a+268>>2]|0){c=(f[a+364>>2]|0)==0;e=d+4|0;if(!(f[a+372>>2]|0)){f[e>>2]=c?168:167;break}else{f[e>>2]=c?170:169;break}}else f[d+4>>2]=171;while(0);c=a+292|0;if((f[c>>2]|0)<=0){g=d+12|0;f[g>>2]=0;h=d+16|0;f[h>>2]=65536;i=d+20|0;f[i>>2]=0;j=d+24|0;f[j>>2]=0;k=d+28|0;f[k>>2]=11;l=d+32|0;f[l>>2]=-1;m=a+236|0;n=f[m>>2]|0;o=d+68|0;f[o>>2]=n;p=d+72|0;f[p>>2]=0;return}e=a+364|0;q=a+372|0;r=a+4|0;s=a+368|0;t=0;do{u=f[a+296+(t<<2)>>2]|0;if((f[e>>2]|0)==0?(f[q>>2]|0)==0:0){v=f[u+20>>2]|0;if(v>>>0>15){w=f[a>>2]|0;f[w+20>>2]=50;f[w+24>>2]=v;ki[f[w>>2]&2047](a)}w=d+76+(v<<2)|0;v=f[w>>2]|0;if(!v){x=ui[f[f[r>>2]>>2]&127](a,1,64)|0;f[w>>2]=x;y=x}else y=v;v=y;x=v+64|0;do{b[v>>0]=0;v=v+1|0}while((v|0)<(x|0));f[d+36+(t<<2)>>2]=0;f[d+52+(t<<2)>>2]=0}if(f[s>>2]|0){v=f[u+24>>2]|0;if(v>>>0>15){x=f[a>>2]|0;f[x+20>>2]=50;f[x+24>>2]=v;ki[f[x>>2]&2047](a)}x=d+140+(v<<2)|0;v=f[x>>2]|0;if(!v){w=ui[f[f[r>>2]>>2]&127](a,1,256)|0;f[x>>2]=w;z=w}else z=v;F1a(z|0,0,256)|0}t=t+1|0}while((t|0)<(f[c>>2]|0));g=d+12|0;f[g>>2]=0;h=d+16|0;f[h>>2]=65536;i=d+20|0;f[i>>2]=0;j=d+24|0;f[j>>2]=0;k=d+28|0;f[k>>2]=11;l=d+32|0;f[l>>2]=-1;m=a+236|0;n=f[m>>2]|0;o=d+68|0;f[o>>2]=n;p=d+72|0;f[p>>2]=0;return}function WGa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[a+424>>2]|0;d=c+12|0;e=f[d>>2]|0;g=(f[c+16>>2]|0)+-1+e&-65536;h=((g|0)<(e|0)?g|32768:g)<<f[c+28>>2];f[d>>2]=h;g=c+32|0;e=f[g>>2]|0;if(h>>>0<=134217727){if(e){if((e|0)>-1){h=c+24|0;i=a+24|0;if(!(f[h>>2]|0))j=e;else{do{k=f[i>>2]|0;l=f[k>>2]|0;f[k>>2]=l+1;b[l>>0]=0;l=k+4|0;m=(f[l>>2]|0)+-1|0;f[l>>2]=m;if((m|0)==0?(mi[f[k+12>>2]&255](a)|0)==0:0){k=f[a>>2]|0;f[k+20>>2]=25;ki[f[k>>2]&2047](a)}k=(f[h>>2]|0)+-1|0;f[h>>2]=k}while((k|0)!=0);j=f[g>>2]|0}h=f[i>>2]|0;i=f[h>>2]|0;f[h>>2]=i+1;b[i>>0]=j;j=h+4|0;i=(f[j>>2]|0)+-1|0;f[j>>2]=i;if((i|0)==0?(mi[f[h+12>>2]&255](a)|0)==0:0){h=f[a>>2]|0;f[h+20>>2]=25;ki[f[h>>2]&2047](a)}}}else{h=c+24|0;f[h>>2]=(f[h>>2]|0)+1}h=c+20|0;if(f[h>>2]|0){i=c+24|0;j=a+24|0;if(f[i>>2]|0)do{k=f[j>>2]|0;m=f[k>>2]|0;f[k>>2]=m+1;b[m>>0]=0;m=k+4|0;l=(f[m>>2]|0)+-1|0;f[m>>2]=l;if((l|0)==0?(mi[f[k+12>>2]&255](a)|0)==0:0){k=f[a>>2]|0;f[k+20>>2]=25;ki[f[k>>2]&2047](a)}k=(f[i>>2]|0)+-1|0;f[i>>2]=k}while((k|0)!=0);do{i=f[j>>2]|0;k=f[i>>2]|0;f[i>>2]=k+1;b[k>>0]=-1;k=i+4|0;l=(f[k>>2]|0)+-1|0;f[k>>2]=l;if((l|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=f[j>>2]|0;l=f[i>>2]|0;f[i>>2]=l+1;b[l>>0]=0;l=i+4|0;k=(f[l>>2]|0)+-1|0;f[l>>2]=k;if((k|0)==0?(mi[f[i+12>>2]&255](a)|0)==0:0){i=f[a>>2]|0;f[i+20>>2]=25;ki[f[i>>2]&2047](a)}i=(f[h>>2]|0)+-1|0;f[h>>2]=i}while((i|0)!=0)}}else{h=c+24|0;if((e|0)>-1){j=a+24|0;if(!(f[h>>2]|0))n=e;else{do{e=f[j>>2]|0;i=f[e>>2]|0;f[e>>2]=i+1;b[i>>0]=0;i=e+4|0;k=(f[i>>2]|0)+-1|0;f[i>>2]=k;if((k|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}e=(f[h>>2]|0)+-1|0;f[h>>2]=e}while((e|0)!=0);n=f[g>>2]|0}e=f[j>>2]|0;k=f[e>>2]|0;f[e>>2]=k+1;b[k>>0]=n+1;n=e+4|0;k=(f[n>>2]|0)+-1|0;f[n>>2]=k;if((k|0)==0?(mi[f[e+12>>2]&255](a)|0)==0:0){e=f[a>>2]|0;f[e+20>>2]=25;ki[f[e>>2]&2047](a)}if(((f[g>>2]|0)==254?(g=f[j>>2]|0,j=f[g>>2]|0,f[g>>2]=j+1,b[j>>0]=0,j=g+4|0,e=(f[j>>2]|0)+-1|0,f[j>>2]=e,(e|0)==0):0)?(mi[f[g+12>>2]&255](a)|0)==0:0){g=f[a>>2]|0;f[g+20>>2]=25;ki[f[g>>2]&2047](a)}}g=c+20|0;f[h>>2]=(f[h>>2]|0)+(f[g>>2]|0);f[g>>2]=0}g=f[d>>2]|0;if(!(g&134215680))return;h=c+24|0;c=a+24|0;if(!(f[h>>2]|0))o=g;else{do{g=f[c>>2]|0;e=f[g>>2]|0;f[g>>2]=e+1;b[e>>0]=0;e=g+4|0;j=(f[e>>2]|0)+-1|0;f[e>>2]=j;if((j|0)==0?(mi[f[g+12>>2]&255](a)|0)==0:0){g=f[a>>2]|0;f[g+20>>2]=25;ki[f[g>>2]&2047](a)}g=(f[h>>2]|0)+-1|0;f[h>>2]=g}while((g|0)!=0);o=f[d>>2]|0}h=f[c>>2]|0;g=f[h>>2]|0;f[h>>2]=g+1;b[g>>0]=o>>>19;o=h+4|0;g=(f[o>>2]|0)+-1|0;f[o>>2]=g;if((g|0)==0?(mi[f[h+12>>2]&255](a)|0)==0:0){h=f[a>>2]|0;f[h+20>>2]=25;ki[f[h>>2]&2047](a)}if(((f[d>>2]&133693440|0)==133693440?(h=f[c>>2]|0,g=f[h>>2]|0,f[h>>2]=g+1,b[g>>0]=0,g=h+4|0,o=(f[g>>2]|0)+-1|0,f[g>>2]=o,(o|0)==0):0)?(mi[f[h+12>>2]&255](a)|0)==0:0){h=f[a>>2]|0;f[h+20>>2]=25;ki[f[h>>2]&2047](a)}h=f[d>>2]|0;if(!(h&522240))return;o=f[c>>2]|0;g=f[o>>2]|0;f[o>>2]=g+1;b[g>>0]=h>>>11;h=o+4|0;g=(f[h>>2]|0)+-1|0;f[h>>2]=g;if((g|0)==0?(mi[f[o+12>>2]&255](a)|0)==0:0){o=f[a>>2]|0;f[o+20>>2]=25;ki[f[o>>2]&2047](a)}if((f[d>>2]&522240|0)!=522240)return;d=f[c>>2]|0;c=f[d>>2]|0;f[d>>2]=c+1;b[c>>0]=0;c=d+4|0;o=(f[c>>2]|0)+-1|0;f[c>>2]=o;if(o|0)return;if(mi[f[d+12>>2]&255](a)|0)return;d=f[a>>2]|0;f[d+20>>2]=25;ki[f[d>>2]&2047](a);return}function XGa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=f[a+424>>2]|0;e=a+236|0;if(f[e>>2]|0){g=c+68|0;i=f[g>>2]|0;if(!i){j=c+72|0;aHa(a,f[j>>2]|0);k=f[e>>2]|0;f[g>>2]=k;f[j>>2]=(f[j>>2]|0)+1&7;l=k}else l=i;f[g>>2]=l+-1}l=a+320|0;if((f[l>>2]|0)<=0)return 1;g=a+376|0;i=0;do{k=f[a+324+(i<<2)>>2]|0;j=f[(f[a+296+(k<<2)>>2]|0)+20>>2]|0;e=d[f[b+(i<<2)>>2]>>1]>>f[g>>2];m=c+76+(j<<2)|0;n=c+52+(k<<2)|0;o=(f[m>>2]|0)+(f[n>>2]|0)|0;p=c+36+(k<<2)|0;k=e-(f[p>>2]|0)|0;if(k){f[p>>2]=e;bHa(a,o,1);if((k|0)>0){bHa(a,o+1|0,0);q=4;r=2;s=k}else{bHa(a,o+1|0,1);q=8;r=3;s=0-k|0}k=o+r|0;f[n>>2]=q;e=s+-1|0;if(e){bHa(a,k,1);p=(f[m>>2]|0)+20|0;m=e>>1;if(!m){t=1;u=p}else{v=1;w=m;m=p;while(1){bHa(a,m,1);p=v<<1;x=m+1|0;w=w>>1;if(!w){t=p;u=x;break}else{v=p;m=x}}}}else{t=0;u=k}bHa(a,u,0);if((t|0)>=(1<<h[a+152+j>>0]>>1|0)){if((t|0)>(1<<h[a+168+j>>0]>>1|0)){y=(f[n>>2]|0)+8|0;z=18}}else{y=0;z=18}if((z|0)==18){z=0;f[n>>2]=y}m=u+14|0;v=t>>1;if(v|0){w=v;do{bHa(a,m,(w&e|0)!=0&1);w=w>>1}while((w|0)!=0)}}else{bHa(a,o,0);f[n>>2]=0}i=i+1|0}while((i|0)<(f[l>>2]|0));return 1}function YGa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;c=f[a+424>>2]|0;e=a+236|0;if(f[e>>2]|0){g=c+68|0;i=f[g>>2]|0;if(!i){j=c+72|0;aHa(a,f[j>>2]|0);k=f[e>>2]|0;f[g>>2]=k;f[j>>2]=(f[j>>2]|0)+1&7;l=k}else l=i;f[g>>2]=l+-1}l=f[a+384>>2]|0;g=f[b>>2]|0;b=f[(f[a+296>>2]|0)+24>>2]|0;i=a+368|0;k=f[i>>2]|0;j=a+376|0;e=k;while(1){m=d[g+(f[l+(e<<2)>>2]<<1)>>1]|0;n=m<<16>>16;if(m<<16>>16>-1){if(n>>f[j>>2]|0){o=e;break}}else if(0-n>>f[j>>2]|0){o=e;break}e=e+-1|0;if(!e){o=0;break}}e=f[a+364>>2]|0;n=e+-1|0;if((e|0)>(o|0)){p=k;q=n}else{k=c+140+(b<<2)|0;e=c+204|0;m=a+184+b|0;r=n;while(1){n=(f[k>>2]|0)+(r*3|0)|0;bHa(a,n,0);s=r;t=n;while(1){u=s+1|0;n=d[g+(f[l+(u<<2)>>2]<<1)>>1]|0;v=n<<16>>16;w=f[j>>2]|0;if(n<<16>>16>-1){x=v>>w;if(x|0){y=16;break}}else{z=0-v>>w;if(z|0){y=18;break}}bHa(a,t+1|0,0);s=u;t=t+3|0}if((y|0)==16){y=0;bHa(a,t+1|0,1);bHa(a,e,0);A=x}else if((y|0)==18){y=0;bHa(a,t+1|0,1);bHa(a,e,1);A=z}w=t+2|0;v=A+-1|0;if(v){bHa(a,w,1);if((v|0)!=1){bHa(a,w,1);n=(f[k>>2]|0)+((s|0)<(h[m>>0]|0|0)?189:217)|0;B=v>>2;if(!B){C=2;D=n}else{E=2;F=B;B=n;while(1){bHa(a,B,1);n=E<<1;G=B+1|0;F=F>>1;if(!F){C=n;D=G;break}else{E=n;B=G}}}}else{C=1;D=w}}else{C=0;D=w}bHa(a,D,0);B=D+14|0;E=C>>1;if(E|0){F=E;do{bHa(a,B,(F&v|0)!=0&1);F=F>>1}while((F|0)!=0)}if((u|0)<(o|0))r=u;else break}p=f[i>>2]|0;q=u}if((q|0)>=(p|0))return 1;bHa(a,(f[c+140+(b<<2)>>2]|0)+(q*3|0)|0,1);return 1}function ZGa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+424>>2]|0;e=a+236|0;if(f[e>>2]|0){g=c+68|0;h=f[g>>2]|0;if(!h){i=c+72|0;aHa(a,f[i>>2]|0);j=f[e>>2]|0;f[g>>2]=j;f[i>>2]=(f[i>>2]|0)+1&7;k=j}else k=h;f[g>>2]=k+-1}k=c+204|0;c=f[a+376>>2]|0;g=a+320|0;if((f[g>>2]|0)>0)l=0;else return 1;do{bHa(a,k,(d[f[b+(l<<2)>>2]>>1]|0)>>>c&1);l=l+1|0}while((l|0)<(f[g>>2]|0));return 1}function _Ga(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;c=f[a+424>>2]|0;e=a+236|0;if(f[e>>2]|0){g=c+68|0;h=f[g>>2]|0;if(!h){i=c+72|0;aHa(a,f[i>>2]|0);j=f[e>>2]|0;f[g>>2]=j;f[i>>2]=(f[i>>2]|0)+1&7;k=j}else k=h;f[g>>2]=k+-1}k=f[a+384>>2]|0;g=f[b>>2]|0;b=f[(f[a+296>>2]|0)+24>>2]|0;h=a+368|0;j=f[h>>2]|0;i=a+376|0;e=j;while(1){l=d[g+(f[k+(e<<2)>>2]<<1)>>1]|0;m=l<<16>>16;if(l<<16>>16>-1){if(m>>f[i>>2]|0){n=10;break}}else if(0-m>>f[i>>2]|0){n=10;break}m=e+-1|0;if(!m){o=0;p=0;break}else e=m}a:do if((n|0)==10)if((e|0)>0){m=f[a+372>>2]|0;l=e;while(1){q=d[g+(f[k+(l<<2)>>2]<<1)>>1]|0;r=q<<16>>16;if(q<<16>>16>-1){if(r>>m|0){o=e;p=l;break a}}else if(0-r>>m|0){o=e;p=l;break a}r=l+-1|0;if((l|0)>1)l=r;else{o=e;p=r;break}}}else{o=e;p=e}while(0);e=f[a+364>>2]|0;l=e+-1|0;if((e|0)>(o|0)){s=j;t=l}else{j=c+140+(b<<2)|0;e=c+204|0;m=l;while(1){l=(f[j>>2]|0)+(m*3|0)|0;if((m|0)<(p|0)){u=m;v=l}else{bHa(a,l,0);u=m;v=l}b:while(1){w=u+1|0;l=d[g+(f[k+(w<<2)>>2]<<1)>>1]|0;r=l<<16>>16;q=f[i>>2]|0;if(l<<16>>16>-1){x=r>>q;switch(x|0){case 1:{n=23;break b;break}case 0:break;default:{n=22;break b}}}else{y=0-r>>q;switch(y|0){case 1:{n=27;break b;break}case 0:break;default:{n=25;break b}}}bHa(a,v+1|0,0);u=w;v=v+3|0}if((n|0)==22){n=0;bHa(a,v+2|0,x&1)}else if((n|0)==23){n=0;bHa(a,v+1|0,1);bHa(a,e,0)}else if((n|0)==25){n=0;bHa(a,v+2|0,y&1)}else if((n|0)==27){n=0;bHa(a,v+1|0,1);bHa(a,e,1)}if((w|0)<(o|0))m=w;else break}s=f[h>>2]|0;t=w}if((t|0)>=(s|0))return 1;bHa(a,(f[c+140+(b<<2)>>2]|0)+(t*3|0)|0,1);return 1}function $Ga(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;c=f[a+424>>2]|0;e=a+236|0;if(f[e>>2]|0){g=c+68|0;i=f[g>>2]|0;if(!i){j=c+72|0;aHa(a,f[j>>2]|0);k=f[e>>2]|0;f[g>>2]=k;f[j>>2]=(f[j>>2]|0)+1&7;l=k}else l=i;f[g>>2]=l+-1}l=f[a+384>>2]|0;g=a+320|0;if((f[g>>2]|0)<=0)return 1;i=a+388|0;k=c+204|0;j=0;do{e=f[b+(j<<2)>>2]|0;m=f[a+324+(j<<2)>>2]|0;n=f[a+296+(m<<2)>>2]|0;o=f[n+20>>2]|0;p=c+76+(o<<2)|0;q=c+52+(m<<2)|0;r=(f[p>>2]|0)+(f[q>>2]|0)|0;s=d[e>>1]|0;t=c+36+(m<<2)|0;m=s-(f[t>>2]|0)|0;if(m){f[t>>2]=s;bHa(a,r,1);if((m|0)>0){bHa(a,r+1|0,0);u=4;v=2;w=m}else{bHa(a,r+1|0,1);u=8;v=3;w=0-m|0}m=r+v|0;f[q>>2]=u;s=w+-1|0;if(s){bHa(a,m,1);t=(f[p>>2]|0)+20|0;p=s>>1;if(!p){x=1;y=t}else{z=1;A=p;p=t;while(1){bHa(a,p,1);t=z<<1;B=p+1|0;A=A>>1;if(!A){x=t;y=B;break}else{z=t;p=B}}}}else{x=0;y=m}bHa(a,y,0);if((x|0)>=(1<<h[a+152+o>>0]>>1|0)){if((x|0)>(1<<h[a+168+o>>0]>>1|0)){C=(f[q>>2]|0)+8|0;D=18}}else{C=0;D=18}if((D|0)==18){D=0;f[q>>2]=C}p=y+14|0;z=x>>1;if(z|0){A=z;do{bHa(a,p,(A&s|0)!=0&1);A=A>>1}while((A|0)!=0)}}else{bHa(a,r,0);f[q>>2]=0}A=f[i>>2]|0;if(A|0){s=f[n+24>>2]|0;p=A;while(1){if(d[e+(f[l+(p<<2)>>2]<<1)>>1]|0){D=25;break}o=p+-1|0;if(!o){E=A;F=0;break}else p=o}if((D|0)==25){D=0;if((p|0)>0){n=c+140+(s<<2)|0;q=a+184+s|0;r=0;while(1){o=(f[n>>2]|0)+(r*3|0)|0;bHa(a,o,0);m=r+1|0;z=d[e+(f[l+(m<<2)>>2]<<1)>>1]|0;B=z<<16>>16;t=o+1|0;if(!(z<<16>>16)){G=t;H=m;I=o;while(1){bHa(a,G,0);J=I;I=I+3|0;K=H+1|0;L=d[e+(f[l+(K<<2)>>2]<<1)>>1]|0;G=J+4|0;if(L<<16>>16)break;else H=K}M=L;N=G;O=L<<16>>16;P=K;Q=H;R=I}else{M=z;N=t;O=B;P=m;Q=r;R=o}bHa(a,N,1);if(M<<16>>16>0){bHa(a,k,0);S=O}else{bHa(a,k,1);S=0-O|0}J=R+2|0;T=S+-1|0;if(T){bHa(a,J,1);if((T|0)!=1){bHa(a,J,1);U=(f[n>>2]|0)+((Q|0)<(h[q>>0]|0)?189:217)|0;V=T>>2;if(!V){W=2;X=U}else{Y=2;Z=V;V=U;while(1){bHa(a,V,1);U=Y<<1;_=V+1|0;Z=Z>>1;if(!Z){W=U;X=_;break}else{Y=U;V=_}}}}else{W=1;X=J}}else{W=0;X=J}bHa(a,X,0);V=X+14|0;Y=W>>1;if(Y|0){Z=Y;do{bHa(a,V,(Z&T|0)!=0&1);Z=Z>>1}while((Z|0)!=0)}if((P|0)<(p|0))r=P;else break}E=f[i>>2]|0;F=P}else{E=A;F=0}}if((F|0)<(E|0))bHa(a,(f[c+140+(s<<2)>>2]|0)+(F*3|0)|0,1)}j=j+1|0}while((j|0)<(f[g>>2]|0));return 1}function aHa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=f[a+424>>2]|0;WGa(a);e=a+24|0;g=f[e>>2]|0;h=f[g>>2]|0;f[g>>2]=h+1;b[h>>0]=-1;h=g+4|0;i=(f[h>>2]|0)+-1|0;f[h>>2]=i;if((i|0)==0?(mi[f[g+12>>2]&255](a)|0)==0:0){g=f[a>>2]|0;f[g+20>>2]=25;ki[f[g>>2]&2047](a)}g=f[e>>2]|0;e=f[g>>2]|0;f[g>>2]=e+1;b[e>>0]=c+208;c=g+4|0;e=(f[c>>2]|0)+-1|0;f[c>>2]=e;if((e|0)==0?(mi[f[g+12>>2]&255](a)|0)==0:0){g=f[a>>2]|0;f[g+20>>2]=25;ki[f[g>>2]&2047](a)}g=a+292|0;if((f[g>>2]|0)<=0){j=d+12|0;f[j>>2]=0;k=d+16|0;f[k>>2]=65536;l=d+20|0;f[l>>2]=0;m=d+24|0;f[m>>2]=0;n=d+28|0;f[n>>2]=11;o=d+32|0;f[o>>2]=-1;return}e=a+364|0;c=a+372|0;i=a+368|0;h=0;do{p=f[a+296+(h<<2)>>2]|0;if((f[e>>2]|0)==0?(f[c>>2]|0)==0:0){q=f[d+76+(f[p+20>>2]<<2)>>2]|0;r=q+64|0;do{b[q>>0]=0;q=q+1|0}while((q|0)<(r|0));f[d+36+(h<<2)>>2]=0;f[d+52+(h<<2)>>2]=0}if(f[i>>2]|0)F1a(f[d+140+(f[p+24>>2]<<2)>>2]|0,0,256)|0;h=h+1|0}while((h|0)<(f[g>>2]|0));j=d+12|0;f[j>>2]=0;k=d+16|0;f[k>>2]=65536;l=d+20|0;f[l>>2]=0;m=d+24|0;f[m>>2]=0;n=d+28|0;f[n>>2]=11;o=d+32|0;f[o>>2]=-1;return}function bHa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=f[a+424>>2]|0;g=h[c>>0]|0;i=f[122404+((g&127)<<2)>>2]|0;j=i>>>8;k=i>>16;l=e+16|0;m=(f[l>>2]|0)-k|0;f[l>>2]=m;if((g>>>7|0)==(d|0)){if((m|0)>32767)return;if((m|0)<(k|0)){d=e+12|0;f[d>>2]=(f[d>>2]|0)+m;f[l>>2]=k;n=j}else n=j}else if((m|0)<(k|0))n=i;else{j=e+12|0;f[j>>2]=(f[j>>2]|0)+m;f[l>>2]=k;n=i}b[c>>0]=n^g&128;g=e+12|0;n=e+28|0;c=e+32|0;i=e+24|0;k=a+24|0;m=e+20|0;e=f[l>>2]|0;j=f[g>>2]|0;d=f[n>>2]|0;while(1){o=e<<1;f[l>>2]=o;p=j<<1;f[g>>2]=p;q=d+-1|0;f[n>>2]=q;if(!q){r=p>>19;do if((r|0)>255){s=f[c>>2]|0;if((s|0)>-1){if(!(f[i>>2]|0))t=s;else{do{s=f[k>>2]|0;u=f[s>>2]|0;f[s>>2]=u+1;b[u>>0]=0;u=s+4|0;v=(f[u>>2]|0)+-1|0;f[u>>2]=v;if((v|0)==0?(mi[f[s+12>>2]&255](a)|0)==0:0){s=f[a>>2]|0;f[s+20>>2]=25;ki[f[s>>2]&2047](a)}s=(f[i>>2]|0)+-1|0;f[i>>2]=s}while((s|0)!=0);t=f[c>>2]|0}s=f[k>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[v>>0]=t+1;v=s+4|0;u=(f[v>>2]|0)+-1|0;f[v>>2]=u;if((u|0)==0?(mi[f[s+12>>2]&255](a)|0)==0:0){s=f[a>>2]|0;f[s+20>>2]=25;ki[f[s>>2]&2047](a)}if(((f[c>>2]|0)==254?(s=f[k>>2]|0,u=f[s>>2]|0,f[s>>2]=u+1,b[u>>0]=0,u=s+4|0,v=(f[u>>2]|0)+-1|0,f[u>>2]=v,(v|0)==0):0)?(mi[f[s+12>>2]&255](a)|0)==0:0){s=f[a>>2]|0;f[s+20>>2]=25;ki[f[s>>2]&2047](a)}}f[i>>2]=(f[i>>2]|0)+(f[m>>2]|0);f[m>>2]=0;f[c>>2]=r&255}else{if((r|0)==255){f[m>>2]=(f[m>>2]|0)+1;break}s=f[c>>2]|0;if(s){if((s|0)>-1){if(!(f[i>>2]|0))w=s;else{do{s=f[k>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[v>>0]=0;v=s+4|0;u=(f[v>>2]|0)+-1|0;f[v>>2]=u;if((u|0)==0?(mi[f[s+12>>2]&255](a)|0)==0:0){s=f[a>>2]|0;f[s+20>>2]=25;ki[f[s>>2]&2047](a)}s=(f[i>>2]|0)+-1|0;f[i>>2]=s}while((s|0)!=0);w=f[c>>2]|0}s=f[k>>2]|0;u=f[s>>2]|0;f[s>>2]=u+1;b[u>>0]=w;u=s+4|0;v=(f[u>>2]|0)+-1|0;f[u>>2]=v;if((v|0)==0?(mi[f[s+12>>2]&255](a)|0)==0:0){s=f[a>>2]|0;f[s+20>>2]=25;ki[f[s>>2]&2047](a)}}}else f[i>>2]=(f[i>>2]|0)+1;if(f[m>>2]|0){if(f[i>>2]|0)do{s=f[k>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[v>>0]=0;v=s+4|0;u=(f[v>>2]|0)+-1|0;f[v>>2]=u;if((u|0)==0?(mi[f[s+12>>2]&255](a)|0)==0:0){s=f[a>>2]|0;f[s+20>>2]=25;ki[f[s>>2]&2047](a)}s=(f[i>>2]|0)+-1|0;f[i>>2]=s}while((s|0)!=0);do{s=f[k>>2]|0;u=f[s>>2]|0;f[s>>2]=u+1;b[u>>0]=-1;u=s+4|0;v=(f[u>>2]|0)+-1|0;f[u>>2]=v;if((v|0)==0?(mi[f[s+12>>2]&255](a)|0)==0:0){s=f[a>>2]|0;f[s+20>>2]=25;ki[f[s>>2]&2047](a)}s=f[k>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[v>>0]=0;v=s+4|0;u=(f[v>>2]|0)+-1|0;f[v>>2]=u;if((u|0)==0?(mi[f[s+12>>2]&255](a)|0)==0:0){s=f[a>>2]|0;f[s+20>>2]=25;ki[f[s>>2]&2047](a)}s=(f[m>>2]|0)+-1|0;f[m>>2]=s}while((s|0)!=0)}f[c>>2]=r&255}while(0);r=f[g>>2]&524287;f[g>>2]=r;s=(f[n>>2]|0)+8|0;f[n>>2]=s;x=f[l>>2]|0;y=s;z=r}else{x=o;y=q;z=p}if((x|0)<32768){e=x;j=z;d=y}else break}return}function cHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+4|0;d=ui[f[f[c>>2]>>2]&127](a,1,104)|0;f[a+404>>2]=d;f[d>>2]=399;if(!b){b=ui[f[(f[c>>2]|0)+4>>2]&127](a,1,1280)|0;f[d+24>>2]=b;f[d+28>>2]=b+128;f[d+32>>2]=b+256;f[d+36>>2]=b+384;f[d+40>>2]=b+512;f[d+44>>2]=b+640;f[d+48>>2]=b+768;f[d+52>>2]=b+896;f[d+56>>2]=b+1024;f[d+60>>2]=b+1152;f[d+64>>2]=0;return}b=a+76|0;if((f[b>>2]|0)<=0)return;e=d+64|0;d=0;g=f[a+84>>2]|0;while(1){h=f[(f[c>>2]|0)+20>>2]|0;i=RGa(f[g+28>>2]|0,f[g+8>>2]|0)|0;j=g+12|0;k=RGa(f[g+32>>2]|0,f[j>>2]|0)|0;l=bg[h&127](a,1,0,i,k,f[j>>2]|0)|0;f[e+(d<<2)>>2]=l;d=d+1|0;if((d|0)>=(f[b>>2]|0))break;else g=g+88|0}return}function dHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+404>>2]|0;f[c+8>>2]=0;if((f[a+292>>2]|0)>1)d=1;else{e=f[a+296>>2]|0;d=f[((f[a+288>>2]|0)!=1?e+12|0:e+76|0)>>2]|0}f[c+20>>2]=d;f[c+12>>2]=0;f[c+16>>2]=0;switch(b|0){case 0:{if(f[c+64>>2]|0){b=f[a>>2]|0;f[b+20>>2]=3;ki[f[b>>2]&2047](a)}f[c+4>>2]=172;return}case 3:{if(!(f[c+64>>2]|0)){b=f[a>>2]|0;f[b+20>>2]=3;ki[f[b>>2]&2047](a)}f[c+4>>2]=173;return}case 2:{if(!(f[c+64>>2]|0)){b=f[a>>2]|0;f[b+20>>2]=3;ki[f[b>>2]&2047](a)}f[c+4>>2]=174;return}default:{c=f[a>>2]|0;f[c+20>>2]=3;ki[f[c>>2]&2047](a);return}}}function eHa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;c=a+404|0;e=f[c>>2]|0;g=(f[a+312>>2]|0)+-1|0;h=a+288|0;i=(f[h>>2]|0)+-1|0;j=e+16|0;k=f[j>>2]|0;l=e+20|0;m=f[l>>2]|0;do if((k|0)<(m|0)){n=e+12|0;o=a+292|0;p=a+420|0;q=e+8|0;r=a+424|0;s=e+24|0;t=f[n>>2]|0;u=m;v=k;a:while(1){if(t>>>0>g>>>0)w=u;else{x=t;while(1){y=f[o>>2]|0;if((y|0)>0)if(x>>>0<g>>>0){z=y;A=0;B=0;while(1){C=f[a+296+(B<<2)>>2]|0;D=C+4|0;E=f[(f[p>>2]|0)+4+(f[D>>2]<<2)>>2]|0;F=C+56|0;G=f[F>>2]|0;H=Y(f[C+68>>2]|0,x)|0;I=C+40|0;J=C+60|0;if((f[J>>2]|0)>0){K=C+76|0;L=G;M=A;N=0;O=Y(f[I>>2]|0,v)|0;while(1){P=f[e+24+(M<<2)>>2]|0;if((f[q>>2]|0)>>>0>=i>>>0?(N+v|0)>=(f[K>>2]|0):0){F1a(P|0,0,L<<7|0)|0;Q=f[F>>2]|0;if((Q|0)>0){R=f[e+24+(M+-1<<2)>>2]|0;S=0;do{d[f[e+24+(S+M<<2)>>2]>>1]=d[R>>1]|0;S=S+1|0}while((S|0)<(Q|0))}}else T=14;if(((T|0)==14?(T=0,Xh[E&127](a,C,f[b+(f[D>>2]<<2)>>2]|0,P,O,H,G),Q=f[F>>2]|0,(Q|0)>(G|0)):0)?(F1a(f[e+24+(M+G<<2)>>2]|0,0,Q-G<<7|0)|0,Q=f[F>>2]|0,(G|0)<(Q|0)):0){S=G;do{R=S+M|0;d[f[e+24+(R<<2)>>2]>>1]=d[f[e+24+(R+-1<<2)>>2]>>1]|0;S=S+1|0}while((S|0)<(Q|0))}L=f[F>>2]|0;M=L+M|0;N=N+1|0;if((N|0)>=(f[J>>2]|0))break;else O=(f[I>>2]|0)+O|0}U=f[o>>2]|0;V=M}else{U=z;V=A}B=B+1|0;if((B|0)>=(U|0))break;else{z=U;A=V}}}else{A=y;z=0;B=0;while(1){O=f[a+296+(B<<2)>>2]|0;I=O+4|0;J=f[(f[p>>2]|0)+4+(f[I>>2]<<2)>>2]|0;N=O+56|0;L=f[O+72>>2]|0;F=Y(f[O+68>>2]|0,x)|0;G=O+40|0;H=O+60|0;if((f[H>>2]|0)>0){D=O+76|0;C=z;E=0;K=Y(f[G>>2]|0,v)|0;while(1){Q=f[e+24+(C<<2)>>2]|0;if((f[q>>2]|0)>>>0>=i>>>0?(E+v|0)>=(f[D>>2]|0):0){F1a(Q|0,0,f[N>>2]<<7|0)|0;S=f[N>>2]|0;if((S|0)>0){P=f[e+24+(C+-1<<2)>>2]|0;R=0;do{d[f[e+24+(R+C<<2)>>2]>>1]=d[P>>1]|0;R=R+1|0}while((R|0)<(S|0));W=S}else W=S}else{Xh[J&127](a,O,f[b+(f[I>>2]<<2)>>2]|0,Q,K,F,L);R=f[N>>2]|0;if((R|0)>(L|0)){F1a(f[e+24+(C+L<<2)>>2]|0,0,R-L<<7|0)|0;P=f[N>>2]|0;if((L|0)<(P|0)){X=L;do{Z=X+C|0;d[f[e+24+(Z<<2)>>2]>>1]=d[f[e+24+(Z+-1<<2)>>2]>>1]|0;X=X+1|0}while((X|0)<(P|0));W=P}else W=P}else W=R}C=W+C|0;E=E+1|0;if((E|0)>=(f[H>>2]|0))break;else K=(f[G>>2]|0)+K|0}_=f[o>>2]|0;$=C}else{_=A;$=z}B=B+1|0;if((B|0)>=(_|0))break;else{A=_;z=$}}}if(!($h[f[(f[r>>2]|0)+4>>2]&255](a,s)|0))break a;z=x+1|0;if(z>>>0>g>>>0)break;else x=z}w=f[l>>2]|0}f[n>>2]=0;z=v+1|0;if((z|0)<(w|0)){t=0;u=w;v=z}else{T=38;break}}if((T|0)==38){aa=f[c>>2]|0;ba=o;ca=q;break}f[j>>2]=v;f[n>>2]=x;da=0;return da|0}else{aa=e;ba=a+292|0;ca=e+8|0}while(0);f[ca>>2]=(f[ca>>2]|0)+1;if((f[ba>>2]|0)>1)ea=1;else{ba=f[a+296>>2]|0;ea=f[((f[aa+8>>2]|0)>>>0<((f[h>>2]|0)+-1|0)>>>0?ba+12|0:ba+76|0)>>2]|0}f[aa+20>>2]=ea;f[aa+12>>2]=0;f[aa+16>>2]=0;da=1;return da|0}
function Gza(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=g+4|0;i=f[h>>2]|0;k=i+-1|0;f[h>>2]=k;if(!i)return;i=f[g>>2]|0;l=k;k=d;d=a;while(1){if((i|0)>0){a=k;m=0;do{n=j[d+(m<<1)>>1]|0;b[a>>0]=n<<3;b[a+1>>0]=n>>>3&252;b[a+2>>0]=n>>>8&248;m=m+1|0;a=a+3|0;o=f[g>>2]|0}while((m|0)<(o|0));p=o;q=f[h>>2]|0;r=a}else{p=i;q=l;r=k}k=r+((Y(p,-3)|0)+e)|0;l=q+-1|0;f[h>>2]=l;if(!q)break;else{i=p;d=d+c|0}}return}function Hza(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;i=g+4|0;j=f[i>>2]|0;k=j+-1|0;f[i>>2]=k;if(!j)return;j=f[g>>2]|0;l=k;k=d;d=a;while(1){if((j|0)>0){a=k;m=d;n=0;do{o=h[m+3>>0]|0;p=o-((Y(o,~b[m+1>>0]&255)|0)>>>8)|0;q=o-((Y(o,~b[m+2>>0]&255)|0)>>>8)|0;r=o-((Y(o,~b[m>>0]&255)|0)>>>8)&255;b[a+2>>0]=r;b[a+1>>0]=p;b[a>>0]=q;n=n+1|0;a=a+3|0;m=m+4|0;s=f[g>>2]|0}while((n|0)<(s|0));t=s;u=f[i>>2]|0;v=a;w=m}else{t=j;u=l;v=k;w=d}k=v+((Y(t,-3)|0)+e)|0;l=u+-1|0;f[i>>2]=l;if(!u)break;else{j=t;d=w+(c-(t<<2))|0}}return}function Iza(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=g+4|0;j=f[i>>2]|0;k=j+-1|0;f[i>>2]=k;if(!j)return;j=f[g>>2]|0;l=k;k=a;a=d;while(1){if((j|0)>0){d=k;m=0;do{n=h[d+3>>0]|0;o=(((n-((Y(n,~b[d+1>>0]&255)|0)>>>8)|0)*9617|0)+8192+((n-((Y(n,~b[d+2>>0]&255)|0)>>>8)|0)*1868|0)+((n-((Y(n,~b[d>>0]&255)|0)>>>8)|0)*4899|0)|0)>>>14&255;b[a+m>>0]=o;m=m+1|0;d=d+4|0;p=f[g>>2]|0}while((m|0)<(p|0));q=p;r=f[i>>2]|0;s=d}else{q=j;r=l;s=k}l=r+-1|0;f[i>>2]=l;if(!r)break;else{j=q;k=s+(c-(q<<2))|0;a=a+e|0}}return}function Jza(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0;if((d|0)>0)e=0;else return;do{f=a+(e<<2)|0;b[c+e>>0]=(((h[f>>0]|0)*1868|0)+8192+((h[f+1>>0]|0)*9617|0)+((h[f+2>>0]|0)*4899|0)|0)>>>14;e=e+1|0}while((e|0)!=(d|0));return}function Kza(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=1<<c;f=d?255:0;if((c|0)==31)return;c=e+-1|0;d=0;do{g=(((d*255|0)/(c|0)|0)^f)&255;b[a+(d<<2)+2>>0]=g;b[a+(d<<2)+1>>0]=g;b[a+(d<<2)>>0]=g;b[a+(d<<2)+3>>0]=0;d=d+1|0}while((d|0)<(e|0));return}function Lza(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0;d=1<<c;if((c|0)==31){e=0;return e|0}else f=0;while(1){c=b[a+(f<<2)>>0]|0;if(c<<24>>24!=(b[a+(f<<2)+1>>0]|0)){e=1;g=5;break}if(c<<24>>24!=(b[a+(f<<2)+2>>0]|0)){e=1;g=5;break}f=f+1|0;if((f|0)>=(d|0)){e=0;g=5;break}}if((g|0)==5)return e|0;return 0}function Mza(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=0-e|0;e=j+1|0;l=j+2|0;m=f[c>>2]|0;n=i;i=a;while(1){a=i+n|0;o=a>>>0>m>>>0?m:a;n=i-o+n|0;if(i>>>0<o>>>0){a=i;do{b[a>>0]=b[j>>0]|0;b[a+1>>0]=b[e>>0]|0;b[a+2>>0]=b[l>>0]|0;a=a+3|0}while(a>>>0<o>>>0);p=f[c>>2]|0;q=a}else{p=m;q=i}if(q>>>0>=p>>>0){o=p+d|0;f[c>>2]=o;r=o+k|0;s=(f[g>>2]|0)+1|0;f[g>>2]=s;if((s|0)<(h|0)){t=o;u=r}else{v=r;w=8;break}}else{t=p;u=q}if((n|0)<=0){v=u;w=8;break}else{m=t;i=u}}if((w|0)==8)return v|0;return 0}function Nza(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=0-d|0;d=f[b>>2]|0;k=h;h=a;while(1){a=h;l=h+k|0;m=l>>>0>d>>>0?d:l;k=a-m+k|0;if(h>>>0<m>>>0){n=d;o=l;F1a(h|0,i|0,~a-~(o>>>0>n>>>0?n:o)|0)|0;o=h;do o=o+1|0;while(o>>>0<m>>>0);p=f[b>>2]|0;q=o}else{p=d;q=h}if(q>>>0>=p>>>0){m=p+c|0;f[b>>2]=m;n=m+j|0;a=(f[e>>2]|0)+1|0;f[e>>2]=a;if((a|0)<(g|0)){r=m;s=n}else{t=n;u=9;break}}else{r=p;s=q}if((k|0)<=0){t=s;u=9;break}else{d=r;h=s}}if((u|0)==9)return t|0;return 0}function Oza(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=d*3|0;d=a+f|0;g=a+3|0;i=h[c>>0]|0;if((f|0)>3){f=g;j=a;k=i;l=c;while(1){l=l+1|0;c=e+(k<<2)|0;m=h[c>>0]|h[c+1>>0]<<8|h[c+2>>0]<<16|h[c+3>>0]<<24;b[j>>0]=m;b[j+1>>0]=m>>8;b[j+2>>0]=m>>16;b[j+3>>0]=m>>24;m=f+3|0;c=h[l>>0]|0;if(m>>>0>=d>>>0){n=m;o=f;p=c;break}else{q=f;f=m;k=c;j=q}}}else{n=g;o=a;p=i}i=b[e+(p<<2)+1>>0]|0;a=b[e+(p<<2)+2>>0]|0;b[o>>0]=b[e+(p<<2)>>0]|0;b[o+1>>0]=i;b[o+2>>0]=a;return n|0}function Pza(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;if((d|0)>0)f=0;else{g=a+d|0;return g|0}do{b[a+f>>0]=b[e+(h[c+f>>0]|0)>>0]|0;f=f+1|0}while((f|0)!=(d|0));g=a+d|0;return g|0}function Qza(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=d*3|0;d=a+f|0;g=a+6|0;i=h[c>>0]|0;j=i>>>4;if((f|0)>6){f=g;k=i;l=a;m=c;c=j;while(1){m=m+1|0;n=e+(c<<2)|0;o=h[n>>0]|h[n+1>>0]<<8|h[n+2>>0]<<16|h[n+3>>0]<<24;b[l>>0]=o;b[l+1>>0]=o>>8;b[l+2>>0]=o>>16;b[l+3>>0]=o>>24;o=l+3|0;n=e+((k&15)<<2)|0;p=h[n>>0]|h[n+1>>0]<<8|h[n+2>>0]<<16|h[n+3>>0]<<24;b[o>>0]=p;b[o+1>>0]=p>>8;b[o+2>>0]=p>>16;b[o+3>>0]=p>>24;p=f+6|0;o=h[m>>0]|0;n=o>>>4;if(p>>>0>=d>>>0){q=p;r=o;s=f;t=n;break}else{u=f;f=p;k=o;c=n;l=u}}}else{q=g;r=i;s=a;t=j}j=b[e+(t<<2)+1>>0]|0;a=b[e+(t<<2)+2>>0]|0;b[s>>0]=b[e+(t<<2)>>0]|0;b[s+1>>0]=j;b[s+2>>0]=a;if((q|0)!=(d|0))return d|0;q=r&15;r=b[e+(q<<2)+1>>0]|0;a=b[e+(q<<2)+2>>0]|0;b[s+3>>0]=b[e+(q<<2)>>0]|0;b[s+4>>0]=r;b[s+5>>0]=a;return d|0}function Rza(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=a+d|0;g=a+2|0;i=h[c>>0]|0;b[a>>0]=b[e+(i>>>4)>>0]|0;if((d|0)>2){d=a+4|0;j=(f>>>0>d>>>0?f:d)+(-3-a)&-2;d=j+2|0;k=j+4|0;j=g;l=i;m=a;n=c;while(1){n=n+1|0;b[m+1>>0]=b[e+(l&15)>>0]|0;c=j+2|0;l=h[n>>0]|0;b[j>>0]=b[e+(l>>>4)>>0]|0;if(c>>>0>=f>>>0)break;else{o=j;j=c;m=o}}p=a+k|0;q=l;r=a+d|0}else{p=g;q=i;r=a}if((p|0)!=(f|0))return f|0;b[r+1>>0]=b[e+(q&15)>>0]|0;return f|0}function Sza(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+16|0;i=g+4|0;j=g;k=d*3|0;d=a+k|0;f[i>>2]=h[e>>0]|h[e+1>>0]<<8|h[e+2>>0]<<16|h[e+3>>0]<<24;l=e+4|0;f[j>>2]=h[l>>0]|h[l+1>>0]<<8|h[l+2>>0]<<16|h[l+3>>0]<<24;l=h[c>>0]|0;if((k|0)>24){k=a+24|0;e=l;m=a;n=c;while(1){n=n+1|0;c=f[(e&128|0?j:i)>>2]|0;b[m>>0]=c;b[m+1>>0]=c>>8;b[m+2>>0]=c>>16;b[m+3>>0]=c>>24;c=m+3|0;o=f[(e&64|0?j:i)>>2]|0;b[c>>0]=o;b[c+1>>0]=o>>8;b[c+2>>0]=o>>16;b[c+3>>0]=o>>24;o=m+6|0;c=f[(e&32|0?j:i)>>2]|0;b[o>>0]=c;b[o+1>>0]=c>>8;b[o+2>>0]=c>>16;b[o+3>>0]=c>>24;c=m+9|0;o=f[(e&16|0?j:i)>>2]|0;b[c>>0]=o;b[c+1>>0]=o>>8;b[c+2>>0]=o>>16;b[c+3>>0]=o>>24;o=m+12|0;c=f[(e&8|0?j:i)>>2]|0;b[o>>0]=c;b[o+1>>0]=c>>8;b[o+2>>0]=c>>16;b[o+3>>0]=c>>24;c=m+15|0;o=f[(e&4|0?j:i)>>2]|0;b[c>>0]=o;b[c+1>>0]=o>>8;b[c+2>>0]=o>>16;b[c+3>>0]=o>>24;o=m+18|0;c=f[(e&2|0?j:i)>>2]|0;b[o>>0]=c;b[o+1>>0]=c>>8;b[o+2>>0]=c>>16;b[o+3>>0]=c>>24;c=m+21|0;o=f[(e&1|0?j:i)>>2]|0;b[c>>0]=o;b[c+1>>0]=o>>8;b[c+2>>0]=o>>16;b[c+3>>0]=o>>24;o=k+24|0;c=h[n>>0]|0;if(o>>>0>=d>>>0){p=c;q=k;break}else{r=k;k=o;e=c;m=r}}}else{p=l;q=a}if(q>>>0<d>>>0){s=q;t=p}else{v=q;u=g;return v|0}while(1){q=t&128|0?j:i;p=b[q+1>>0]|0;a=b[q+2>>0]|0;b[s>>0]=b[q>>0]|0;b[s+1>>0]=p;b[s+2>>0]=a;a=s+3|0;if(a>>>0<d>>>0){s=a;t=t<<1}else{v=a;break}}u=g;return v|0}function Tza(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=a+d|0;g=b[e>>0]|0;i=b[e+1>>0]|0;e=h[c>>0]|0;if((d|0)>8){d=a+16|0;j=(f>>>0>d>>>0?f:d)+(-9-a)+8&-8;d=a+8|0;k=e;l=a;m=c;while(1){m=m+1|0;b[l>>0]=k&128|0?i:g;b[l+1>>0]=k&64|0?i:g;b[l+2>>0]=k&32|0?i:g;b[l+3>>0]=k&16|0?i:g;b[l+4>>0]=k&8|0?i:g;b[l+5>>0]=k&4|0?i:g;b[l+6>>0]=k&2|0?i:g;b[l+7>>0]=k&1|0?i:g;c=d+8|0;k=h[m>>0]|0;if(c>>>0>=f>>>0)break;else{n=d;d=c;l=n}}o=k;p=a+j|0}else{o=e;p=a}if(p>>>0<f>>>0){q=p;r=o}else{s=p;return s|0}while(1){b[q>>0]=r&128|0?i:g;q=q+1|0;if((q|0)==(f|0)){s=f;break}else r=r<<1}return s|0}function Uza(a){a=a|0;Owa(a);PYa(a);return}function Vza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+20|0;if((c|0)!=(b|0)){d$(c);d=f[b>>2]|0;if(!d)e=0;else{g=d+-4|0;f[g>>2]=(f[g>>2]|0)+1;e=f[b>>2]|0}f[c>>2]=e;f[a+24>>2]=f[b+4>>2]}b=a+36|0;e=a+72|0;c=f[e>>2]|0;if(c|0?(g=c+12|0,c=f[g>>2]|0,f[g>>2]=c+-1,(c|0)==1):0)CR(b);f[e>>2]=0;e=a+52|0;b=a+40|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[b>>2]|0)<=0)return 1;e=f[a+76>>2]|0;a=0;do{f[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[b>>2]|0));return 1}function Wza(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;if(!(b[a+92>>0]|0)){g=0;u=d;return g|0}f[e>>2]=0;h=e+4|0;f[h>>2]=0;i=a+20|0;if((e|0)!=(i|0)){d$(i);j=f[e>>2]|0;if(!j)k=0;else{l=j+-4|0;f[l>>2]=(f[l>>2]|0)+1;k=f[e>>2]|0}f[i>>2]=k;f[a+24>>2]=f[h>>2]}d$(e);e=a+36|0;if((e|0)==(c|0)){g=1;u=d;return g|0}h=c+36|0;k=f[h>>2]|0;if(k|0){i=k+12|0;f[i>>2]=(f[i>>2]|0)+1}i=a+72|0;k=f[i>>2]|0;if(k|0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)CR(e);f[i>>2]=0;k=a+52|0;l=a+40|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[l>>2]|0)>0){j=f[a+76>>2]|0;m=0;do{f[j+(m<<2)>>2]=0;m=m+1|0;n=f[l>>2]|0}while((m|0)<(n|0));f[e>>2]=f[c>>2];if((n|0)<3)o=17;else o=19}else{f[e>>2]=f[c>>2];o=17}if((o|0)==17){n=f[c+4>>2]|0;if((n|0)<3){f[l>>2]=n;f[a+44>>2]=f[c+8>>2];f[a+48>>2]=f[c+12>>2];n=f[c+44>>2]|0;l=f[a+80>>2]|0;f[l>>2]=f[n>>2];f[l+4>>2]=f[n+4>>2]}else o=19}if((o|0)==19)BR(e,c);f[k>>2]=f[c+16>>2];f[a+56>>2]=f[c+20>>2];f[a+60>>2]=f[c+24>>2];f[a+64>>2]=f[c+28>>2];f[a+68>>2]=f[c+32>>2];f[i>>2]=f[h>>2];g=1;u=d;return g|0}function Xza(a,b){a=a|0;b=b|0;var c=0;c=a+16|0;a=f[c>>2]|0;f[c>>2]=f[b>>2];return a|0}function Yza(a){a=a|0;return f[a+32>>2]|0}function Zza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=mi[f[(f[a>>2]|0)+36>>2]&255](a)|0;if((f[b+4>>2]|0)>>>0<c>>>0){d=0;return d|0}e=f[b>>2]|0;b=f[a+28>>2]|0;d=(yKa((e|0)==0?5694105:e,(b|0)==0?5694105:b,c)|0)==0;return d|0}function _za(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;return}function $za(a){a=a|0;f[a>>2]=104796;d$(a+28|0);d$(a+12|0);d$(a+4|0);return}function aAa(a){a=a|0;f[a>>2]=104796;d$(a+28|0);d$(a+12|0);d$(a+4|0);PYa(a);return}function bAa(a,b){a=a|0;b=b|0;return (b|0)==0|0}function cAa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+12|0;if((c|0)==(b|0)){d=a+20|0;f[d>>2]=0;return 1}d$(c);e=f[b>>2]|0;if(!e)g=0;else{h=e+-4|0;f[h>>2]=(f[h>>2]|0)+1;g=f[b>>2]|0}f[c>>2]=g;f[a+16>>2]=f[b+4>>2];d=a+20|0;f[d>>2]=0;return 1}function dAa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;if(!(b[a+24>>0]|0)){g=0;u=d;return g|0}f[a+20>>2]=c;h=f[c>>2]|0;i=c+4|0;if((f[i>>2]|0)!=(h|0))f[i>>2]=h;f[e>>2]=0;h=e+4|0;f[h>>2]=0;i=a+12|0;if((e|0)!=(i|0)){d$(i);c=f[e>>2]|0;if(!c)j=0;else{k=c+-4|0;f[k>>2]=(f[k>>2]|0)+1;j=f[e>>2]|0}f[i>>2]=j;f[a+16>>2]=f[h>>2]}d$(e);g=1;u=d;return g|0}function eAa(a,b){a=a|0;b=b|0;var c=0;c=f[b+4>>2]|0;f[a>>2]=c;f[a+4>>2]=f[b+8>>2];if(!c)return;b=c+-4|0;f[b>>2]=(f[b>>2]|0)+1;return}function fAa(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;return}function gAa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c+8|0;e=c;g=a+32|0;h=f[g>>2]|0;if(!h){u=c;return}f[d>>2]=0;f[d+4>>2]=0;c$(d,h+25|0)|0;h=f[d>>2]|0;i=h;j=353954;k=i+25|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j=f[g>>2]|0;if(j|0)K1a(h+25|0,f[a+28>>2]|0,j|0)|0;j=(h|0)==0?5694105:h;f[e>>2]=0;f[e+4>>2]=0;h=xKa(j)|0;if(h|0)K1a(c$(e,h)|0,j|0,h|0)|0;j$(-10,e,353980,353992,140);d$(e);d$(d);u=c;return}function hAa(a){a=a|0;var c=0,d=0,e=0,g=0;f[a>>2]=104740;c=a+20|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[a+36>>2]=1124007936;c=a+44|0;d=a+76|0;e=a+40|0;g=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[d>>2]=c;c=a+84|0;f[a+80>>2]=c;f[c>>2]=0;f[a+88>>2]=0;f[a+8>>2]=0;f[a+4>>2]=0;f[a+12>>2]=-1;b[a+92>>0]=0;f[a+16>>2]=1;return}function iAa(a){a=a|0;var c=0;f[a>>2]=104796;c=a+4|0;f[a+28>>2]=0;f[a+32>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;b[c+20>>0]=0;return}function jAa(a){a=a|0;OF(a);return}function kAa(a){a=a|0;OF(a);PYa(a);return}function lAa(a,b){a=a|0;b=b|0;XF(a+(f[(f[a>>2]|0)+-40>>2]|0)|0,b);uAa(a+4|0,b);return}function mAa(a,b){a=a|0;b=b|0;tAa(a+4|0,b);return}function nAa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;gBa(e,c);f[a>>2]=0;f[a+4>>2]=0;c=e+4|0;c$(a,(f[c>>2]|0)+19|0)|0;g=f[c>>2]|0;if(!g)h=0;else{K1a(f[a>>2]|0,f[e>>2]|0,g|0)|0;h=f[c>>2]|0}c=(f[a>>2]|0)+h|0;h=354380;a=c+19|0;do{b[c>>0]=b[h>>0]|0;c=c+1|0;h=h+1|0}while((c|0)<(a|0));d$(e);u=d;return}function oAa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0,Pa=0;e=u;u=u+224|0;g=e+216|0;h=e+160|0;i=e+104|0;j=e+48|0;k=e+32|0;l=e+16|0;m=e;_$(g,104960);o=f[d>>2]|0;q=d+4|0;r=f[q>>2]|0;if((r|0)!=(o|0))f[q>>2]=r+(~(((r+-28-o|0)>>>0)/28|0)*28|0);f[h>>2]=1124007936;o=h+4|0;r=h+8|0;s=h+40|0;t=o;v=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));f[s>>2]=r;w=h+48|0;x=h+44|0;f[x>>2]=w;f[w>>2]=0;f[h+52>>2]=0;if((WS(c,-1)|0)!=3){do if((NS(c)|0)==65536){y=f[c+4>>2]|0;f[i>>2]=f[y>>2];z=i+4|0;A=y+4|0;f[z>>2]=f[A>>2];B=i+8|0;f[B>>2]=f[y+8>>2];f[i+12>>2]=f[y+12>>2];f[i+16>>2]=f[y+16>>2];f[i+20>>2]=f[y+20>>2];f[i+24>>2]=f[y+24>>2];f[i+28>>2]=f[y+28>>2];f[i+32>>2]=f[y+32>>2];C=i+36|0;D=f[y+36>>2]|0;f[C>>2]=D;f[i+40>>2]=B;B=i+48|0;E=i+44|0;f[E>>2]=B;f[B>>2]=0;f[i+52>>2]=0;if(D|0){B=D+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[y+44>>2]|0;B=f[E>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];F=C;break}else{f[z>>2]=0;BR(i,y);F=C;break}}else{OR(i,c,-1);F=i+36|0}while(0);C=f[F>>2]|0;if(C|0){y=C+12|0;f[y>>2]=(f[y>>2]|0)+1}y=h+36|0;C=f[y>>2]|0;if(C|0?(z=C+12|0,C=f[z>>2]|0,f[z>>2]=C+-1,(C|0)==1):0)CR(h);f[y>>2]=0;C=h+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[o>>2]|0)>0){z=f[s>>2]|0;A=0;do{f[z+(A<<2)>>2]=0;A=A+1|0;G=f[o>>2]|0}while((A|0)<(G|0));f[h>>2]=f[i>>2];if((G|0)<3)H=22;else H=24}else{f[h>>2]=f[i>>2];H=22}if((H|0)==22){G=f[i+4>>2]|0;if((G|0)<3){f[o>>2]=G;f[r>>2]=f[i+8>>2];f[h+12>>2]=f[i+12>>2];r=f[i+44>>2]|0;G=f[x>>2]|0;f[G>>2]=f[r>>2];f[G+4>>2]=f[r+4>>2]}else H=24}if((H|0)==24)BR(h,i);r=i+16|0;f[C>>2]=f[r>>2];f[h+20>>2]=f[i+20>>2];f[h+24>>2]=f[i+24>>2];f[h+28>>2]=f[i+28>>2];f[h+32>>2]=f[i+32>>2];C=f[F>>2]|0;f[y>>2]=C;if(C|0?(y=C+12|0,C=f[y>>2]|0,f[y>>2]=C+-1,(C|0)==1):0)CR(i);f[F>>2]=0;F=i+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[F>>2]|0)>0){r=f[i+40>>2]|0;C=0;do{f[r+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[F>>2]|0))}F=f[i+44>>2]|0;if((F|0)!=(i+48|0))ZF(F)}else{F=i+8|0;f[F>>2]=0;f[F+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=h;f6(c,i,6,0)}if(f[h>>2]&4095|0){f[i>>2]=0;f[i+4>>2]=0;t=c$(i,41)|0;c=354237;v=t+41|0;do{b[t>>0]=b[c>>0]|0;t=t+1|0;c=c+1|0}while((t|0)<(v|0));j$(-210,i,356368,354177,320);d$(i)}f[i>>2]=0;c=i+4|0;f[c>>2]=0;f[i+8>>2]=0;I=+n[a+8>>2];F=a+12|0;if(I<+n[F>>2]){C=j+4|0;r=j+8|0;y=j+40|0;G=j+48|0;A=j+44|0;z=j+52|0;B=k+8|0;E=k+12|0;D=k+4|0;J=l+8|0;K=l+4|0;L=k+4|0;N=k+8|0;O=l+8|0;P=l+12|0;Q=l+4|0;R=m+8|0;S=m+12|0;T=m+4|0;U=l+4|0;V=l+8|0;W=j+36|0;X=j+16|0;Y=a+4|0;Z=i+8|0;_=m+4|0;$=m+8|0;aa=m+8|0;ba=l+8|0;ca=a+20|0;da=I;do{f[j>>2]=1124007936;t=C;v=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));f[y>>2]=r;f[A>>2]=G;f[G>>2]=0;f[z>>2]=0;f[B>>2]=0;f[E>>2]=0;f[k>>2]=16842752;f[D>>2]=h;ea=J;f[ea>>2]=0;f[ea+4>>2]=0;f[l>>2]=33619968;f[K>>2]=j;+gqa(k,l,da,255.0,0);f[k>>2]=0;f[L>>2]=0;f[N>>2]=0;ea=f[(f[a>>2]|0)+64>>2]|0;f[O>>2]=0;f[P>>2]=0;f[l>>2]=16842752;f[Q>>2]=h;f[R>>2]=0;f[S>>2]=0;f[m>>2]=16842752;f[T>>2]=j;Ah[ea&255](a,l,m,k);f[l>>2]=0;f[U>>2]=0;f[V>>2]=0;ea=f[k>>2]|0;if((f[L>>2]|0)!=(ea|0)){fa=ea;ea=0;while(1){ga=fa;ha=f[c>>2]|0;ia=f[i>>2]|0;ja=ia;a:do if((ha|0)==(ia|0))H=55;else{I=+p[ga+(ea<<5)>>3];ka=+p[ga+(ea<<5)+8>>3];la=+n[ca>>2];ma=ga+(ea<<5)+16|0;na=(ha-ia|0)/12|0;oa=0;while(1){pa=ja+(oa*12|0)|0;qa=ja+(oa*12|0)+4|0;ra=f[qa>>2]|0;sa=f[pa>>2]|0;ta=ra-sa>>5>>>1;ua=sa;va=+p[ua+(ta<<5)>>3]-I;wa=+p[ua+(ta<<5)+8>>3]-ka;xa=+M(+(va*va+wa*wa));if(!(xa>=la))break;if(!(xa>=+p[ua+(ta<<5)+16>>3]))break;if(!(xa>=+p[ma>>3]))break;ta=oa+1|0;if(ta>>>0<na>>>0)oa=ta;else{H=55;break a}}na=ra;ma=ga+(ea<<5)|0;if((na|0)==(f[ja+(oa*12|0)+8>>2]|0)){qAa(pa,ma);ta=f[i>>2]|0;ya=ta;za=f[ta+(oa*12|0)+4>>2]|0}else{p[na>>3]=+p[ma>>3];p[na+8>>3]=+p[ga+(ea<<5)+8>>3];ma=na+16|0;na=ga+(ea<<5)+16|0;f[ma>>2]=f[na>>2];f[ma+4>>2]=f[na+4>>2];f[ma+8>>2]=f[na+8>>2];f[ma+12>>2]=f[na+12>>2];na=(f[qa>>2]|0)+32|0;f[qa>>2]=na;ya=ja;za=na}na=za-(f[ya+(oa*12|0)>>2]|0)>>5;ma=na+-1|0;b:do if(!ma)Aa=0;else{ta=ya+(oa*12|0)|0;ua=na;sa=ma;while(1){Ba=f[ta>>2]|0;Ca=Ba+(sa<<5)+16|0;Da=ua+-2|0;Ea=Ba+(Da<<5)+16|0;if(!(+p[Ca>>3]<+p[Ea>>3])){Aa=sa;break b}p[Ba+(sa<<5)>>3]=+p[Ba+(Da<<5)>>3];p[Ba+(sa<<5)+8>>3]=+p[Ba+(Da<<5)+8>>3];f[Ca>>2]=f[Ea>>2];f[Ca+4>>2]=f[Ea+4>>2];f[Ca+8>>2]=f[Ea+8>>2];f[Ca+12>>2]=f[Ea+12>>2];Ea=sa+-1|0;if(!Ea){Aa=0;break}else{Ca=sa;sa=Ea;ua=Ca}}}while(0);ma=f[k>>2]|0;na=f[ya+(oa*12|0)>>2]|0;p[na+(Aa<<5)>>3]=+p[ma+(ea<<5)>>3];p[na+(Aa<<5)+8>>3]=+p[ma+(ea<<5)+8>>3];ua=na+(Aa<<5)+16|0;na=ma+(ea<<5)+16|0;f[ua>>2]=f[na>>2];f[ua+4>>2]=f[na+4>>2];f[ua+8>>2]=f[na+8>>2];f[ua+12>>2]=f[na+12>>2];Fa=ma}while(0);if((H|0)==55){H=0;f[m>>2]=0;f[_>>2]=0;f[$>>2]=0;ja=NYa(32)|0;f[m>>2]=ja;f[aa>>2]=ja+32;ia=ga+(ea<<5)+16|0;p[ja>>3]=+p[ga+(ea<<5)>>3];p[ja+8>>3]=+p[ga+(ea<<5)+8>>3];ha=ja+16|0;f[ha>>2]=f[ia>>2];f[ha+4>>2]=f[ia+4>>2];f[ha+8>>2]=f[ia+8>>2];f[ha+12>>2]=f[ia+12>>2];f[_>>2]=ja+32;ja=f[U>>2]|0;if((ja|0)==(f[ba>>2]|0))sAa(l,m);else{rAa(ja,m);f[U>>2]=(f[U>>2]|0)+12}ja=f[m>>2]|0;if(ja|0){ia=f[_>>2]|0;if((ia|0)!=(ja|0))f[_>>2]=ia+(~((ia+-32-ja|0)>>>5)<<5);PYa(ja)}Fa=f[k>>2]|0}ea=ea+1|0;if(ea>>>0>=(f[L>>2]|0)-Fa>>5>>>0)break;else fa=Fa}fa=f[l>>2]|0;ea=f[U>>2]|0;if((fa|0)==(ea|0))Ga=ea;else{ja=fa;do{fa=f[c>>2]|0;if((fa|0)==(f[Z>>2]|0))sAa(i,ja);else{rAa(fa,ja);f[c>>2]=(f[c>>2]|0)+12}ja=ja+12|0}while((ja|0)!=(ea|0));Ga=f[l>>2]|0}if(Ga|0){ea=f[U>>2]|0;if((ea|0)==(Ga|0))Ha=Ga;else{ja=ea;while(1){ea=ja+-12|0;f[U>>2]=ea;fa=f[ea>>2]|0;if(!fa)Ia=ea;else{ea=ja+-8|0;ia=f[ea>>2]|0;if((ia|0)!=(fa|0))f[ea>>2]=ia+(~((ia+-32-fa|0)>>>5)<<5);PYa(fa);Ia=f[U>>2]|0}if((Ia|0)==(Ga|0))break;else ja=Ia}Ha=f[l>>2]|0}PYa(Ha)}}ja=f[k>>2]|0;if(ja|0){fa=f[L>>2]|0;if((fa|0)!=(ja|0))f[L>>2]=fa+(~((fa+-32-ja|0)>>>5)<<5);PYa(ja)}ja=f[W>>2]|0;if(ja|0?(fa=ja+12|0,ja=f[fa>>2]|0,f[fa>>2]=ja+-1,(ja|0)==1):0)CR(j);f[W>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[C>>2]|0)>0){ja=f[y>>2]|0;fa=0;do{f[ja+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[C>>2]|0))}fa=f[A>>2]|0;if((fa|0)!=(G|0))ZF(fa);da=da+ +n[Y>>2]}while(da<+n[F>>2]);F=f[c>>2]|0;Y=f[i>>2]|0;G=Y;if((F|0)==(Y|0)){Ja=F;Ka=G}else{F=a+16|0;a=j+4|0;Y=j+8|0;A=j+12|0;C=j+16|0;y=j+20|0;X=j+24|0;W=d+8|0;L=G;G=0;while(1){if((f[L+(G*12|0)+4>>2]|0)-(f[L+(G*12|0)>>2]|0)>>5>>>0>=(f[F>>2]|0)>>>0){if((f[L+(G*12|0)+4>>2]|0)==(f[L+(G*12|0)>>2]|0)){La=0.0;Ma=0.0;Na=0.0}else{k=(f[L+(G*12|0)+4>>2]|0)-(f[L+(G*12|0)>>2]|0)>>5;Ha=f[L+(G*12|0)>>2]|0;l=0;da=0.0;la=0.0;ka=0.0;while(1){I=+p[Ha+(l<<5)+24>>3];xa=la+I*+p[Ha+(l<<5)>>3];wa=ka+I*+p[Ha+(l<<5)+8>>3];va=da+I;l=l+1|0;if(l>>>0>=k>>>0){La=va;Ma=xa;Na=wa;break}else{da=va;la=xa;ka=wa}}}ka=1.0/La;la=Ma*ka;da=Na*ka;k=f[L+(G*12|0)>>2]|0;ka=+p[k+((f[L+(G*12|0)+4>>2]|0)-k>>5>>>1<<5)+16>>3]*2.0;n[j>>2]=la;n[a>>2]=da;n[Y>>2]=ka;n[A>>2]=-1.0;n[C>>2]=0.0;f[y>>2]=0;f[X>>2]=-1;k=f[q>>2]|0;if((k|0)==(f[W>>2]|0))kY(d,j);else{n[k>>2]=la;n[k+4>>2]=da;l=k+8|0;f[l>>2]=f[Y>>2];f[l+4>>2]=f[Y+4>>2];f[l+8>>2]=f[Y+8>>2];f[l+12>>2]=f[Y+12>>2];f[l+16>>2]=f[Y+16>>2];f[q>>2]=(f[q>>2]|0)+28}}G=G+1|0;l=f[c>>2]|0;k=f[i>>2]|0;Ha=k;if(G>>>0>=((l-k|0)/12|0)>>>0){Ja=l;Ka=Ha;break}else L=Ha}}L=Ja;if(Ka|0){if((L|0)==(Ka|0))Oa=Ka;else{Ja=L;while(1){L=Ja+-12|0;f[c>>2]=L;G=f[L>>2]|0;if(!G)Pa=L;else{L=Ja+-8|0;q=f[L>>2]|0;if((q|0)!=(G|0))f[L>>2]=q+(~((q+-32-G|0)>>>5)<<5);PYa(G);Pa=f[c>>2]|0}if((Pa|0)==(Ka|0))break;else Ja=Pa}Oa=f[i>>2]|0}PYa(Oa)}}Oa=h+36|0;i=f[Oa>>2]|0;if(i|0?(Pa=i+12|0,i=f[Pa>>2]|0,f[Pa>>2]=i+-1,(i|0)==1):0)CR(h);f[Oa>>2]=0;Oa=h+16|0;f[Oa>>2]=0;f[Oa+4>>2]=0;f[Oa+8>>2]=0;f[Oa+12>>2]=0;if((f[o>>2]|0)>0){Oa=f[s>>2]|0;s=0;do{f[Oa+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[o>>2]|0))}o=f[x>>2]|0;if((o|0)!=(w|0))ZF(o);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function pAa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0.0,Gb=0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0;g=u;u=u+576|0;h=g+224|0;i=g+560|0;j=g+504|0;k=g+448|0;l=g+432|0;m=g+376|0;o=g+192|0;q=g+368|0;r=g;s=g+312|0;t=g+256|0;v=g+240|0;_$(i,104940);do if((NS(c)|0)==65536){w=f[c+4>>2]|0;f[j>>2]=f[w>>2];x=j+4|0;y=w+4|0;f[x>>2]=f[y>>2];z=j+8|0;f[z>>2]=f[w+8>>2];f[j+12>>2]=f[w+12>>2];f[j+16>>2]=f[w+16>>2];f[j+20>>2]=f[w+20>>2];f[j+24>>2]=f[w+24>>2];f[j+28>>2]=f[w+28>>2];f[j+32>>2]=f[w+32>>2];A=f[w+36>>2]|0;f[j+36>>2]=A;f[j+40>>2]=z;z=j+48|0;B=j+44|0;f[B>>2]=z;f[z>>2]=0;f[j+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[w+44>>2]|0;z=f[B>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;BR(j,w);break}}else OR(j,c,-1);while(0);do if((NS(d)|0)==65536){c=f[d+4>>2]|0;f[k>>2]=f[c>>2];w=k+4|0;x=c+4|0;f[w>>2]=f[x>>2];y=k+8|0;f[y>>2]=f[c+8>>2];f[k+12>>2]=f[c+12>>2];f[k+16>>2]=f[c+16>>2];f[k+20>>2]=f[c+20>>2];f[k+24>>2]=f[c+24>>2];f[k+28>>2]=f[c+28>>2];f[k+32>>2]=f[c+32>>2];z=f[c+36>>2]|0;f[k+36>>2]=z;f[k+40>>2]=y;y=k+48|0;B=k+44|0;f[B>>2]=y;f[y>>2]=0;f[k+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[c+44>>2]|0;y=f[B>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[w>>2]=0;BR(k,c);break}}else OR(k,d,-1);while(0);d=f[e>>2]|0;c=e+4|0;w=f[c>>2]|0;if((w|0)!=(d|0))f[c>>2]=w+(~((w+-32-d|0)>>>5)<<5);f[l>>2]=0;d=l+4|0;f[d>>2]=0;f[l+8>>2]=0;f[m>>2]=1124007936;w=m+4|0;x=m+8|0;y=m+40|0;B=w;z=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(z|0));f[y>>2]=x;x=m+48|0;B=m+44|0;f[B>>2]=x;f[x>>2]=0;f[m+52>>2]=0;z=h+8|0;f[z>>2]=0;f[z+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=m;eL(k,h);z=h+8|0;f[z>>2]=0;f[z+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=m;z=o+8|0;f[z>>2]=0;f[z+4>>2]=0;f[o>>2]=-2113667060;f[o+4>>2]=l;f[q>>2]=0;f[q+4>>2]=0;h7(h,o,1,1,q);if((f[d>>2]|0)!=(f[l>>2]|0)){q=o+24|0;z=s+4|0;A=s+8|0;C=s+12|0;D=s+16|0;E=s+40|0;F=s+48|0;G=s+44|0;H=s+52|0;I=h+8|0;J=h+12|0;K=h+4|0;L=s+36|0;N=a+26|0;O=a+36|0;P=a+48|0;Q=a+60|0;R=r+8|0;S=r+16|0;T=o+8|0;U=a+24|0;V=s+4|0;W=s+8|0;X=o+16|0;Z=e+8|0;_=s+8|0;$=k+16|0;aa=k+44|0;ba=a+25|0;ca=h+4|0;da=h+8|0;ea=t+4|0;fa=t+8|0;ga=t+12|0;ha=t+16|0;ia=t+40|0;ja=t+48|0;ka=t+44|0;la=t+52|0;ma=s+8|0;na=s+12|0;oa=s+4|0;pa=v+8|0;qa=v+4|0;ra=t+36|0;sa=t+4|0;ta=t+8|0;ua=t+12|0;va=t+16|0;wa=t+40|0;xa=t+48|0;ya=t+44|0;za=t+52|0;Aa=s+8|0;Ba=s+12|0;Ca=s+4|0;Da=t+36|0;Ea=t+4|0;Fa=t+8|0;Ga=t+12|0;Ha=t+16|0;Ia=t+40|0;Ja=t+48|0;Ka=t+44|0;La=t+52|0;Ma=s+8|0;Na=s+12|0;Oa=s+4|0;Pa=t+36|0;Qa=a+64|0;Ra=a+68|0;Sa=t+28|0;Ta=t+24|0;Ua=t+20|0;Va=t+28|0;Wa=t+24|0;Xa=t+20|0;Ya=t+28|0;Za=t+24|0;_a=t+20|0;$a=r+88|0;ab=r+80|0;bb=r+96|0;cb=a+52|0;db=a+56|0;eb=s+4|0;fb=s+8|0;gb=s+12|0;hb=s+16|0;ib=s+40|0;jb=s+48|0;kb=s+44|0;lb=s+52|0;mb=h+8|0;nb=h+12|0;ob=h+4|0;pb=s+36|0;qb=a+40|0;rb=a+44|0;sb=s+28|0;tb=s+24|0;ub=s+20|0;vb=a+28|0;wb=a+32|0;a=s+28|0;xb=s+24|0;yb=s+20|0;zb=f[l>>2]|0;Ab=0;do{f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;p[q>>3]=1.0;f[s>>2]=1124024332;f[z>>2]=2;Bb=f[zb+(Ab*12|0)+4>>2]|0;Cb=f[zb+(Ab*12|0)>>2]|0;Db=Bb-Cb|0;f[A>>2]=Db>>3;f[C>>2]=1;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;f[D+16>>2]=0;f[D+20>>2]=0;f[E>>2]=A;f[G>>2]=F;f[F>>2]=0;f[H>>2]=0;Eb=Cb;if((Eb|0)!=(Bb|0)){f[H>>2]=8;f[F>>2]=8;f[D>>2]=Eb;f[yb>>2]=Eb;Eb=Cb+Db|0;f[xb>>2]=Eb;f[a>>2]=Eb}f[I>>2]=0;f[J>>2]=0;f[h>>2]=16842752;f[K>>2]=s;kha(r,h,0);Eb=f[L>>2]|0;if(Eb|0?(Db=Eb+12|0,Eb=f[Db>>2]|0,f[Db>>2]=Eb+-1,(Eb|0)==1):0)CR(s);f[L>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[z>>2]|0)>0){Eb=f[E>>2]|0;Db=0;do{f[Eb+(Db<<2)>>2]=0;Db=Db+1|0}while((Db|0)<(f[z>>2]|0))}Db=f[G>>2]|0;if((Db|0)!=(F|0))ZF(Db);if(b[N>>0]|0){Fb=+p[r>>3];if(!(Fb<+n[vb>>2])?!(Fb>=+n[wb>>2]):0)Gb=40}else Gb=40;do if((Gb|0)==40){Gb=0;if(b[O>>0]|0){Fb=+p[r>>3];Db=f[l>>2]|0;f[s>>2]=1124024332;f[eb>>2]=2;Eb=f[Db+(Ab*12|0)+4>>2]|0;Cb=f[Db+(Ab*12|0)>>2]|0;Db=Eb-Cb|0;f[fb>>2]=Db>>3;f[gb>>2]=1;f[hb>>2]=0;f[hb+4>>2]=0;f[hb+8>>2]=0;f[hb+12>>2]=0;f[hb+16>>2]=0;f[hb+20>>2]=0;f[ib>>2]=fb;f[kb>>2]=jb;f[jb>>2]=0;f[lb>>2]=0;Bb=Cb;if((Bb|0)!=(Eb|0)){f[lb>>2]=8;f[jb>>2]=8;f[hb>>2]=Bb;f[ub>>2]=Bb;Bb=Cb+Db|0;f[tb>>2]=Bb;f[sb>>2]=Bb}f[mb>>2]=0;f[nb>>2]=0;f[h>>2]=16842752;f[ob>>2]=s;Hb=+ona(h,1);Bb=f[pb>>2]|0;if(Bb|0?(Db=Bb+12|0,Bb=f[Db>>2]|0,f[Db>>2]=Bb+-1,(Bb|0)==1):0)CR(s);f[pb>>2]=0;f[hb>>2]=0;f[hb+4>>2]=0;f[hb+8>>2]=0;f[hb+12>>2]=0;if((f[eb>>2]|0)>0){Bb=f[ib>>2]|0;Db=0;do{f[Bb+(Db<<2)>>2]=0;Db=Db+1|0}while((Db|0)<(f[eb>>2]|0))}Db=f[kb>>2]|0;if((Db|0)!=(jb|0))ZF(Db);Ib=Fb*12.566370614359172/(Hb*Hb);if(Ib<+n[qb>>2])break;if(Ib>=+n[rb>>2])break}if(b[P>>0]|0){Ib=+p[$a>>3];Jb=Ib*2.0;Kb=+p[ab>>3];Lb=+p[bb>>3];Mb=Kb-Lb;Nb=+M(+(Jb*Jb+Mb*Mb));if(Nb>.01){Ob=(Kb+Lb)*.5;Lb=Mb*.5*(Mb/Nb);Mb=Ib*(Jb/Nb);Pb=(Ob-Lb-Mb)/(Mb+(Ob+Lb))}else Pb=1.0;if(Pb<+n[cb>>2])break;if(Pb>=+n[db>>2])break;p[q>>3]=Pb*Pb}if(b[Q>>0]|0){f[h>>2]=0;f[ca>>2]=0;f[da>>2]=0;Db=f[l>>2]|0;f[t>>2]=1124024332;f[ea>>2]=2;Bb=f[Db+(Ab*12|0)+4>>2]|0;Cb=f[Db+(Ab*12|0)>>2]|0;Db=Bb-Cb|0;f[fa>>2]=Db>>3;f[ga>>2]=1;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;f[ha+16>>2]=0;f[ha+20>>2]=0;f[ia>>2]=fa;f[ka>>2]=ja;f[ja>>2]=0;f[la>>2]=0;Eb=Cb;if((Eb|0)!=(Bb|0)){f[la>>2]=8;f[ja>>2]=8;f[ha>>2]=Eb;f[_a>>2]=Eb;Eb=Cb+Db|0;f[Za>>2]=Eb;f[Ya>>2]=Eb}f[ma>>2]=0;f[na>>2]=0;f[s>>2]=16842752;f[oa>>2]=t;Eb=pa;f[Eb>>2]=0;f[Eb+4>>2]=0;f[v>>2]=-2113732596;f[qa>>2]=h;i7(s,v,0,1);Eb=f[ra>>2]|0;if(Eb|0?(Db=Eb+12|0,Eb=f[Db>>2]|0,f[Db>>2]=Eb+-1,(Eb|0)==1):0)CR(t);f[ra>>2]=0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[ea>>2]|0)>0){Eb=f[ia>>2]|0;Db=0;do{f[Eb+(Db<<2)>>2]=0;Db=Db+1|0}while((Db|0)<(f[ea>>2]|0))}Db=f[ka>>2]|0;if((Db|0)!=(ja|0))ZF(Db);Db=f[l>>2]|0;f[t>>2]=1124024332;f[sa>>2]=2;Eb=f[Db+(Ab*12|0)+4>>2]|0;Cb=f[Db+(Ab*12|0)>>2]|0;Db=Eb-Cb|0;f[ta>>2]=Db>>3;f[ua>>2]=1;f[va>>2]=0;f[va+4>>2]=0;f[va+8>>2]=0;f[va+12>>2]=0;f[va+16>>2]=0;f[va+20>>2]=0;f[wa>>2]=ta;f[ya>>2]=xa;f[xa>>2]=0;f[za>>2]=0;Bb=Cb;if((Bb|0)!=(Eb|0)){f[za>>2]=8;f[xa>>2]=8;f[va>>2]=Bb;f[Xa>>2]=Bb;Bb=Cb+Db|0;f[Wa>>2]=Bb;f[Va>>2]=Bb}f[Aa>>2]=0;f[Ba>>2]=0;f[s>>2]=16842752;f[Ca>>2]=t;Hb=+pna(s,0);Bb=f[Da>>2]|0;do if(Bb|0){Db=Bb+12|0;Cb=f[Db>>2]|0;f[Db>>2]=Cb+-1;if((Cb|0)!=1)break;CR(t)}while(0);f[Da>>2]=0;f[va>>2]=0;f[va+4>>2]=0;f[va+8>>2]=0;f[va+12>>2]=0;if((f[sa>>2]|0)>0){Bb=f[wa>>2]|0;Cb=0;do{f[Bb+(Cb<<2)>>2]=0;Cb=Cb+1|0}while((Cb|0)<(f[sa>>2]|0))}Cb=f[ya>>2]|0;if((Cb|0)!=(xa|0))ZF(Cb);f[t>>2]=1124024332;f[Ea>>2]=2;Cb=f[ca>>2]|0;Bb=f[h>>2]|0;Db=Cb-Bb|0;f[Fa>>2]=Db>>3;f[Ga>>2]=1;f[Ha>>2]=0;f[Ha+4>>2]=0;f[Ha+8>>2]=0;f[Ha+12>>2]=0;f[Ha+16>>2]=0;f[Ha+20>>2]=0;f[Ia>>2]=Fa;f[Ka>>2]=Ja;f[Ja>>2]=0;f[La>>2]=0;Eb=Bb;if((Eb|0)!=(Cb|0)){f[La>>2]=8;f[Ja>>2]=8;f[Ha>>2]=Eb;f[Ua>>2]=Eb;Eb=Bb+Db|0;f[Ta>>2]=Eb;f[Sa>>2]=Eb}f[Ma>>2]=0;f[Na>>2]=0;f[s>>2]=16842752;f[Oa>>2]=t;Fb=+pna(s,0);Eb=f[Pa>>2]|0;do if(Eb|0){Db=Eb+12|0;Bb=f[Db>>2]|0;f[Db>>2]=Bb+-1;if((Bb|0)!=1)break;CR(t)}while(0);f[Pa>>2]=0;f[Ha>>2]=0;f[Ha+4>>2]=0;f[Ha+8>>2]=0;f[Ha+12>>2]=0;if((f[Ea>>2]|0)>0){Eb=f[Ia>>2]|0;Bb=0;do{f[Eb+(Bb<<2)>>2]=0;Bb=Bb+1|0}while((Bb|0)<(f[Ea>>2]|0))}Bb=f[Ka>>2]|0;if((Bb|0)!=(Ja|0))ZF(Bb);Lb=Hb/Fb;do if(Lb<+n[Qa>>2])Qb=4;else{if(Lb>=+n[Ra>>2]){Qb=4;break}Qb=0}while(0);Bb=f[h>>2]|0;if(Bb|0){Eb=f[ca>>2]|0;if((Eb|0)!=(Bb|0))f[ca>>2]=Eb+(~((Eb+-8-Bb|0)>>>3)<<3);PYa(Bb)}if(Qb|0)break}Lb=+p[r>>3];if(!(Lb==0.0)){Fb=+p[R>>3]/Lb;Hb=+p[S>>3]/Lb;p[o>>3]=Fb;p[T>>3]=Hb;if(b[U>>0]|0?(Bb=rNa(Hb)|0,Eb=rNa(Fb)|0,Db=(f[$>>2]|0)+(Y(f[f[aa>>2]>>2]|0,Bb)|0)+Eb|0,(b[Db>>0]|0)!=(b[ba>>0]|0)):0)break;f[s>>2]=0;f[V>>2]=0;f[W>>2]=0;Db=f[l>>2]|0;if((f[Db+(Ab*12|0)+4>>2]|0)==(f[Db+(Ab*12|0)>>2]|0)){Rb=0;Sb=0}else{Eb=Db;Db=0;Bb=0;Lb=Fb;Fb=Hb;Cb=0;while(1){Tb=f[Eb+(Ab*12|0)>>2]|0;Hb=Lb-+(f[Tb+(Cb<<3)>>2]|0);Ob=Fb-+(f[Tb+(Cb<<3)+4>>2]|0);Mb=+M(+(Hb*Hb+Ob*Ob));p[h>>3]=Mb;if((Db|0)==(Bb|0)){Wra(s,h);Ub=f[l>>2]|0}else{p[Db>>3]=Mb;f[V>>2]=Db+8;Ub=Eb}Tb=Cb+1|0;if(Tb>>>0>=(f[Ub+(Ab*12|0)+4>>2]|0)-(f[Ub+(Ab*12|0)>>2]|0)>>3>>>0)break;Eb=Ub;Db=f[V>>2]|0;Bb=f[_>>2]|0;Lb=+p[o>>3];Fb=+p[T>>3];Cb=Tb}Rb=f[s>>2]|0;Sb=f[V>>2]|0}LNa(Rb,Sb,h);Cb=f[V>>2]|0;Bb=f[s>>2]|0;Db=Cb-Bb>>3;Eb=Bb;p[X>>3]=(+p[Eb+((Db+-1|0)>>>1<<3)>>3]+ +p[Eb+(Db>>>1<<3)>>3])*.5;Db=Bb;Tb=Cb;if(Bb|0){if((Tb|0)!=(Eb|0))f[V>>2]=Tb+(~((Tb+-8-Bb|0)>>>3)<<3);PYa(Db)}Db=f[c>>2]|0;if((Db|0)==(f[Z>>2]|0)){qAa(e,o);break}else{p[Db>>3]=+p[o>>3];p[Db+8>>3]=+p[T>>3];Bb=Db+16|0;f[Bb>>2]=f[X>>2];f[Bb+4>>2]=f[X+4>>2];f[Bb+8>>2]=f[X+8>>2];f[Bb+12>>2]=f[X+12>>2];f[c>>2]=(f[c>>2]|0)+32;break}}}while(0);Ab=Ab+1|0;zb=f[l>>2]|0}while(Ab>>>0<(((f[d>>2]|0)-zb|0)/12|0)>>>0)}zb=m+36|0;Ab=f[zb>>2]|0;if(Ab|0?(c=Ab+12|0,Ab=f[c>>2]|0,f[c>>2]=Ab+-1,(Ab|0)==1):0)CR(m);f[zb>>2]=0;zb=m+16|0;f[zb>>2]=0;f[zb+4>>2]=0;f[zb+8>>2]=0;f[zb+12>>2]=0;if((f[w>>2]|0)>0){zb=f[y>>2]|0;y=0;do{f[zb+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[w>>2]|0))}w=f[B>>2]|0;if((w|0)!=(x|0))ZF(w);w=f[l>>2]|0;if(w|0){x=f[d>>2]|0;if((x|0)==(w|0))Vb=w;else{B=x;while(1){x=B+-12|0;f[d>>2]=x;y=f[x>>2]|0;if(!y)Wb=x;else{x=B+-8|0;zb=f[x>>2]|0;if((zb|0)!=(y|0))f[x>>2]=zb+(~((zb+-8-y|0)>>>3)<<3);PYa(y);Wb=f[d>>2]|0}if((Wb|0)==(w|0))break;else B=Wb}Vb=f[l>>2]|0}PYa(Vb)}Vb=k+36|0;l=f[Vb>>2]|0;if(l|0?(Wb=l+12|0,l=f[Wb>>2]|0,f[Wb>>2]=l+-1,(l|0)==1):0)CR(k);f[Vb>>2]=0;Vb=k+16|0;l=k+4|0;f[Vb>>2]=0;f[Vb+4>>2]=0;f[Vb+8>>2]=0;f[Vb+12>>2]=0;if((f[l>>2]|0)>0){Vb=f[k+40>>2]|0;Wb=0;do{f[Vb+(Wb<<2)>>2]=0;Wb=Wb+1|0}while((Wb|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))ZF(l);l=j+36|0;k=f[l>>2]|0;if(k|0?(Wb=k+12|0,k=f[Wb>>2]|0,f[Wb>>2]=k+-1,(k|0)==1):0)CR(j);f[l>>2]=0;l=j+16|0;k=j+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[k>>2]|0)>0){l=f[j+40>>2]|0;Wb=0;do{f[l+(Wb<<2)>>2]=0;Wb=Wb+1|0}while((Wb|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))ZF(k);if(!(f[i+4>>2]|0)){u=g;return}u=g;return}function qAa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>5;h=g+1|0;i=e;j=d;if(h>>>0>134217727)gXa(a);k=a+8|0;l=(f[k>>2]|0)-e|0;e=l>>4;m=l>>5>>>0<67108863?(e>>>0<h>>>0?h:e):134217727;do if(m)if(m>>>0>134217727){e=De(8)|0;UYa(e,358155);f[e>>2]=130560;Of(e|0,21520,875)}else{n=NYa(m<<5)|0;break}else n=0;while(0);e=n+(g<<5)|0;h=e;l=n+(m<<5)|0;p[e>>3]=+p[b>>3];p[n+(g<<5)+8>>3]=+p[b+8>>3];m=n+(g<<5)+16|0;g=b+16|0;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[m+8>>2]=f[g+8>>2];f[m+12>>2]=f[g+12>>2];g=e+32|0;if((j|0)==(i|0)){o=h;q=d}else{d=e;e=j;j=h;do{h=e;e=e+-32|0;p[d+-32>>3]=+p[e>>3];p[d+-24>>3]=+p[h+-24>>3];m=d+-16|0;b=h+-16|0;f[m>>2]=f[b>>2];f[m+4>>2]=f[b+4>>2];f[m+8>>2]=f[b+8>>2];f[m+12>>2]=f[b+12>>2];d=j+-32|0;j=d}while((e|0)!=(i|0));o=j;q=f[a>>2]|0}f[a>>2]=o;f[c>>2]=g;f[k>>2]=l;if(!q)return;PYa(q);return}function rAa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>5;if(!g)return;if(g>>>0>134217727)gXa(a);h=NYa(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<5);g=f[b>>2]|0;b=f[d>>2]|0;if((g|0)==(b|0))return;d=h;h=g;do{p[d>>3]=+p[h>>3];p[d+8>>3]=+p[h+8>>3];g=d+16|0;a=h+16|0;f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];f[g+8>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];h=h+32|0;d=(f[c>>2]|0)+32|0;f[c>>2]=d}while((h|0)!=(b|0));return}function sAa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/12|0;g=e+1|0;if(g>>>0>357913941)gXa(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/12|0;d=i<<1;j=i>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(j)if(j>>>0>357913941){d=De(8)|0;UYa(d,358155);f[d>>2]=130560;Of(d|0,21520,875)}else{k=NYa(j*12|0)|0;break}else k=0;while(0);d=k+(e*12|0)|0;e=d;g=k+(j*12|0)|0;rAa(d,b);b=d+12|0;j=f[a>>2]|0;k=f[c>>2]|0;if((k|0)==(j|0)){l=e;m=j;n=j}else{i=d;d=k;k=e;do{d=d+-12|0;rAa(i+-12|0,d);i=k+-12|0;k=i}while((d|0)!=(j|0));l=k;m=f[a>>2]|0;n=f[c>>2]|0}f[a>>2]=l;f[c>>2]=b;f[h>>2]=g;g=m;if((n|0)!=(g|0)){h=n;do{n=h;h=h+-12|0;b=f[h>>2]|0;if(b|0){c=n+-8|0;n=f[c>>2]|0;if((n|0)!=(b|0))f[c>>2]=n+(~((n+-32-b|0)>>>5)<<5);PYa(b)}}while((h|0)!=(g|0))}if(!m)return;PYa(m);return}function tAa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+160|0;e=d+152|0;g=d+144|0;h=d+136|0;i=d+128|0;j=d+120|0;k=d+112|0;l=d+104|0;m=d+96|0;n=d+88|0;o=d+80|0;p=d+72|0;q=d+64|0;r=d+56|0;s=d+48|0;t=d+40|0;v=d+32|0;w=d+24|0;x=d+16|0;y=d+8|0;z=d;$X(g,c,354400);pY(g,e,0.0);f[a>>2]=f[e>>2];$X(h,c,354414);pY(h,e,0.0);f[a+4>>2]=f[e>>2];$X(i,c,354427);pY(i,e,0.0);f[a+8>>2]=f[e>>2];$X(j,c,354440);oY(j,e,0);f[a+12>>2]=f[e>>2];$X(k,c,354457);pY(k,e,0.0);f[a+16>>2]=f[e>>2];$X(l,c,354477);oY(l,e,0);b[a+20>>0]=(f[e>>2]|0)!=0&1;$X(m,c,354491);oY(m,e,0);b[a+21>>0]=f[e>>2];$X(n,c,354501);oY(n,e,0);b[a+22>>0]=(f[e>>2]|0)!=0&1;$X(o,c,354514);pY(o,e,0.0);f[a+24>>2]=f[e>>2];$X(p,c,354522);pY(p,e,0.0);f[a+28>>2]=f[e>>2];$X(q,c,354530);oY(q,e,0);b[a+32>>0]=(f[e>>2]|0)!=0&1;$X(r,c,354550);pY(r,e,0.0);f[a+36>>2]=f[e>>2];$X(s,c,354565);pY(s,e,0.0);f[a+40>>2]=f[e>>2];$X(t,c,354580);oY(t,e,0);b[a+44>>0]=(f[e>>2]|0)!=0&1;$X(v,c,354596);pY(v,e,0.0);f[a+48>>2]=f[e>>2];$X(w,c,354612);pY(w,e,0.0);f[a+52>>2]=f[e>>2];$X(x,c,354628);oY(x,e,0);b[a+56>>0]=(f[e>>2]|0)!=0&1;$X(y,c,354646);pY(y,e,0.0);f[a+60>>2]=f[e>>2];$X(z,c,354659);pY(z,e,0.0);f[a+64>>2]=f[e>>2];u=d;return}function uAa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;g=c$(e,13)|0;i=354400;j=g+13|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));k=YX(c,e)|0;d$(e);if(mi[f[(f[c>>2]|0)+12>>2]&255](k)|0){l=c+32|0;if((f[l>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,30)|0;i=354672;j=g+30|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));j$(-2,e,373532,354703,1186);d$(e)}fY(k,c+12|0,+n[a>>2]);if(f[l>>2]&4|0)f[l>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=c$(e,12)|0;i=354414;j=g+12|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));l=YX(c,e)|0;d$(e);k=a+4|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](l)|0){m=c+32|0;if((f[m>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,30)|0;i=354672;j=g+30|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));j$(-2,e,373532,354703,1186);d$(e)}fY(l,c+12|0,+n[k>>2]);if(f[m>>2]&4|0)f[m>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=c$(e,12)|0;i=354427;j=g+12|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));m=YX(c,e)|0;d$(e);k=a+8|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](m)|0){l=c+32|0;if((f[l>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,30)|0;i=354672;j=g+30|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));j$(-2,e,373532,354703,1186);d$(e)}fY(m,c+12|0,+n[k>>2]);if(f[l>>2]&4|0)f[l>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=c$(e,16)|0;i=354440;j=g+16|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));l=YX(c,e)|0;d$(e);k=f[a+12>>2]|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](l)|0){m=c+32|0;if((f[m>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,30)|0;i=354672;j=g+30|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));j$(-2,e,373532,354703,1186);d$(e)}eY(l,c+12|0,k);if(f[m>>2]&4|0)f[m>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=c$(e,19)|0;i=354457;j=g+19|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));m=YX(c,e)|0;d$(e);k=a+16|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](m)|0){l=c+32|0;if((f[l>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,30)|0;i=354672;j=g+30|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));j$(-2,e,373532,354703,1186);d$(e)}fY(m,c+12|0,+n[k>>2]);if(f[l>>2]&4|0)f[l>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=c$(e,13)|0;i=354477;j=g+13|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));l=YX(c,e)|0;d$(e);k=h[a+20>>0]|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](l)|0){m=c+32|0;if((f[m>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,30)|0;i=354672;j=g+30|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));j$(-2,e,373532,354703,1186);d$(e)}eY(l,c+12|0,k);if(f[m>>2]&4|0)f[m>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=c$(e,9)|0;i=354491;j=g+9|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));m=YX(c,e)|0;d$(e);k=h[a+21>>0]|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](m)|0){l=c+32|0;if((f[l>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,30)|0;i=354672;j=g+30|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));j$(-2,e,373532,354703,1186);d$(e)}eY(m,c+12|0,k);if(f[l>>2]&4|0)f[l>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=c$(e,12)|0;i=354501;j=g+12|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));l=YX(c,e)|0;d$(e);k=h[a+22>>0]|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](l)|0){m=c+32|0;if((f[m>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,30)|0;i=354672;j=g+30|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));j$(-2,e,373532,354703,1186);d$(e)}eY(l,c+12|0,k);if(f[m>>2]&4|0)f[m>>2]=6}f[e>>2]=0;f[e+4>>2]=0;m=c$(e,7)|0;b[m>>0]=b[354514]|0;b[m+1>>0]=b[354515]|0;b[m+2>>0]=b[354516]|0;b[m+3>>0]=b[354517]|0;b[m+4>>0]=b[354518]|0;b[m+5>>0]=b[354519]|0;b[m+6>>0]=b[354520]|0;m=YX(c,e)|0;d$(e);k=a+24|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](m)|0){l=c+32|0;if((f[l>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,30)|0;i=354672;j=g+30|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));j$(-2,e,373532,354703,1186);d$(e)}fY(m,c+12|0,+n[k>>2]);if(f[l>>2]&4|0)f[l>>2]=6}f[e>>2]=0;f[e+4>>2]=0;l=c$(e,7)|0;b[l>>0]=b[354522]|0;b[l+1>>0]=b[354523]|0;b[l+2>>0]=b[354524]|0;b[l+3>>0]=b[354525]|0;b[l+4>>0]=b[354526]|0;b[l+5>>0]=b[354527]|0;b[l+6>>0]=b[354528]|0;l=YX(c,e)|0;d$(e);k=a+28|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](l)|0){m=c+32|0;if((f[m>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,30)|0;i=354672;j=g+30|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));j$(-2,e,373532,354703,1186);d$(e)}fY(l,c+12|0,+n[k>>2]);if(f[m>>2]&4|0)f[m>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=c$(e,19)|0;i=354530;j=g+19|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));m=YX(c,e)|0;d$(e);k=h[a+32>>0]|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](m)|0){l=c+32|0;if((f[l>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,30)|0;i=354672;j=g+30|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));j$(-2,e,373532,354703,1186);d$(e)}eY(m,c+12|0,k);if(f[l>>2]&4|0)f[l>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=c$(e,14)|0;i=354550;j=g+14|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));l=YX(c,e)|0;d$(e);k=a+36|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](l)|0){m=c+32|0;if((f[m>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,30)|0;i=354672;j=g+30|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));j$(-2,e,373532,354703,1186);d$(e)}fY(l,c+12|0,+n[k>>2]);if(f[m>>2]&4|0)f[m>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=c$(e,14)|0;i=354565;j=g+14|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));m=YX(c,e)|0;d$(e);k=a+40|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](m)|0){l=c+32|0;if((f[l>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,30)|0;i=354672;j=g+30|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));j$(-2,e,373532,354703,1186);d$(e)}fY(m,c+12|0,+n[k>>2]);if(f[l>>2]&4|0)f[l>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=c$(e,15)|0;i=354580;j=g+15|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));l=YX(c,e)|0;d$(e);k=h[a+44>>0]|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](l)|0){m=c+32|0;if((f[m>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,30)|0;i=354672;j=g+30|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));j$(-2,e,373532,354703,1186);d$(e)}eY(l,c+12|0,k);if(f[m>>2]&4|0)f[m>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=c$(e,15)|0;i=354596;j=g+15|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));m=YX(c,e)|0;d$(e);k=a+48|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](m)|0){l=c+32|0;if((f[l>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,30)|0;i=354672;j=g+30|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));j$(-2,e,373532,354703,1186);d$(e)}fY(m,c+12|0,+n[k>>2]);if(f[l>>2]&4|0)f[l>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=c$(e,15)|0;i=354612;j=g+15|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));l=YX(c,e)|0;d$(e);k=a+52|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](l)|0){m=c+32|0;if((f[m>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,30)|0;i=354672;j=g+30|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));j$(-2,e,373532,354703,1186);d$(e)}fY(l,c+12|0,+n[k>>2]);if(f[m>>2]&4|0)f[m>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=c$(e,17)|0;i=354628;j=g+17|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));m=YX(c,e)|0;d$(e);k=h[a+56>>0]|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](m)|0){l=c+32|0;if((f[l>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,30)|0;i=354672;j=g+30|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));j$(-2,e,373532,354703,1186);d$(e)}eY(m,c+12|0,k);if(f[l>>2]&4|0)f[l>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=c$(e,12)|0;i=354646;j=g+12|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));l=YX(c,e)|0;d$(e);k=a+60|0;do if(mi[f[(f[c>>2]|0)+12>>2]&255](l)|0){m=c+32|0;if((f[m>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,30)|0;i=354672;j=g+30|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));j$(-2,e,373532,354703,1186);d$(e)}fY(l,c+12|0,+n[k>>2]);if(!(f[m>>2]&4))break;f[m>>2]=6}while(0);f[e>>2]=0;f[e+4>>2]=0;g=c$(e,12)|0;i=354659;j=g+12|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));k=YX(c,e)|0;d$(e);l=a+64|0;if(!(mi[f[(f[c>>2]|0)+12>>2]&255](k)|0)){u=d;return}a=c+32|0;if((f[a>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,30)|0;i=354672;j=g+30|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));j$(-2,e,373532,354703,1186);d$(e)}fY(k,c+12|0,+n[l>>2]);if(!(f[a>>2]&4)){u=d;return}f[a>>2]=6;u=d;return}function vAa(a){a=a|0;OF(a);return}function wAa(a){a=a|0;OF(a);PYa(a);return}function xAa(a){a=a|0;n[a>>2]=10.0;n[a+4>>2]=50.0;n[a+8>>2]=220.0;f[a+12>>2]=2;n[a+16>>2]=10.0;b[a+20>>0]=1;b[a+21>>0]=0;b[a+22>>0]=1;n[a+24>>2]=25.0;n[a+28>>2]=5.0e3;b[a+32>>0]=0;n[a+36>>2]=.800000011920929;n[a+40>>2]=3402823466385288598117041.0e14;b[a+44>>0]=1;n[a+48>>2]=.10000000149011612;n[a+52>>2]=3402823466385288598117041.0e14;b[a+56>>0]=1;n[a+60>>2]=.949999988079071;n[a+64>>2]=3402823466385288598117041.0e14;return}function yAa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=NYa(72)|0;WF(c);f[c>>2]=104872;d=c+4|0;e=b;b=d+68|0;do{f[d>>2]=f[e>>2];d=d+4|0;e=e+4|0}while((d|0)<(b|0));e=NYa(16)|0;d=e+4|0;f[d>>2]=1;f[e>>2]=105028;f[e+8>>2]=c;f[a>>2]=e;f[a+4>>2]=c;f[d>>2]=(f[d>>2]|0)+1;c=f[d>>2]|0;f[d>>2]=c+-1;if((c|0)!=1)return;ki[f[(f[e>>2]|0)+8>>2]&2047](e);return}function zAa(a){a=a|0;PYa(a);return}function AAa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function BAa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;h=u;u=u+48|0;i=h+32|0;j=h;_$(i,105040);do if(!(g&1)){if((RR(a,-1)|0)==16){ZS(a,d);break}if(!(RR(a,-1)|0)){f6(a,d,8,0);break}else{f[j>>2]=0;f[j+4>>2]=0;k=c$(j,31)|0;l=354911;m=k+31|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-5,j,354943,354957,108);d$(j);break}}while(0);a=NY()|0;if((+p[e>>3]==-1.0?+p[e+8>>3]==-1.0:0)?+p[e+16>>3]==-1.0:0)n=+p[e+24>>3]==-1.0;else n=0;if(XS(d)|0){f[j>>2]=0;f[j+4>>2]=0;k=c$(j,17)|0;l=355009;m=k+17|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,j,354943,354957,115);d$(j)}l=f[c>>2]|0;k=f[c+4>>2]|0;if((l|0)!=(k|0)){c=j+8|0;m=j+16|0;o=j+24|0;q=e+8|0;r=e+16|0;s=e+24|0;if(n){n=l;do{t=a;v=f[t+4>>2]|0;w=W1a(f[t>>2]|0,0,-130063606,0)|0;t=C1a(w|0,J|0,v|0,0)|0;v=J;w=W1a(t|0,0,-130063606,0)|0;x=C1a(w|0,J|0,v|0,0)|0;v=J;w=W1a(x|0,0,-130063606,0)|0;y=C1a(w|0,J|0,v|0,0)|0;v=a;f[v>>2]=y;f[v+4>>2]=J;p[j>>3]=+((t&255)>>>0);p[c>>3]=+((x&255)>>>0);p[m>>3]=+((y&255)>>>0);p[o>>3]=0.0;CAa(d,n,j,g);n=n+28|0}while((n|0)!=(k|0))}else{n=l;do{p[j>>3]=+p[e>>3];p[c>>3]=+p[q>>3];p[m>>3]=+p[r>>3];p[o>>3]=+p[s>>3];CAa(d,n,j,g);n=n+28|0}while((n|0)!=(k|0))}}if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function CAa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0;g=u;u=u+48|0;h=g+32|0;i=g+24|0;j=g+16|0;k=g+8|0;l=g;if(XS(a)|0){f[h>>2]=0;f[h+4>>2]=0;m=c$(h,12)|0;o=355027;p=m+12|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));j$(-215,h,355040,354957,55);d$(h)}h=wNa(+n[c>>2]*16.0)|0;o=wNa(+n[c+4>>2]*16.0)|0;if(!(e&4)){f[l>>2]=h;f[l+4>>2]=o;O8(a,l,48,d,1,16,4);u=g;return}l=wNa(+n[c+8>>2]*.5*16.0)|0;f[i>>2]=h;f[i+4>>2]=o;O8(a,i,l,d,1,16,4);q=+n[c+12>>2];if(!(q!=-1.0)){u=g;return}r=q*3.1415927410125732/180.0;q=+(l|0);l=wNa(q*+O(+r))|0;c=wNa(q*+P(+r))|0;f[j>>2]=h;f[j+4>>2]=o;f[k>>2]=l+h;f[k+4>>2]=c+o;t8(a,j,k,d,1,16,4);u=g;return}function DAa(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;m=u;u=u+144|0;n=m+88|0;o=m+32|0;p=m+16|0;q=m;r=f[k>>2]|0;s=k+4|0;t=f[s>>2]|0;if((r|0)!=(t|0)?(t-r|0)!=((f[g+4>>2]|0)-(f[g>>2]|0)>>4|0):0){f[n>>2]=0;f[n+4>>2]=0;v=c$(n,50)|0;w=355159;x=v+50|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-201,n,355210,354957,198);d$(n)}f[n>>2]=1124007936;r=n+4|0;t=n+8|0;y=n+40|0;v=r;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[y>>2]=t;t=n+48|0;z=n+44|0;f[z>>2]=t;f[t>>2]=0;f[n+52>>2]=0;f[o>>2]=1124007936;A=o+4|0;B=o+8|0;C=o+40|0;v=A;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[C>>2]=B;B=o+48|0;D=o+44|0;f[D>>2]=B;f[B>>2]=0;f[o+52>>2]=0;EAa(a,c,d,e,h,n,o,j,l);j=g+4|0;d=f[j>>2]|0;a=f[g>>2]|0;if((d|0)!=(a|0)){E=c+4|0;F=e+4|0;G=p+8|0;H=p+4|0;I=q+8|0;J=q+4|0;K=p+4|0;L=p+4|0;M=a;a=d;d=0;while(1){N=M;O=f[k>>2]|0;if((O|0)!=(f[s>>2]|0)?(b[O+d>>0]|0)==0:0){P=M;Q=a}else{O=f[N+(d<<4)>>2]|0;R=f[N+(d<<4)+4>>2]|0;if(!((O|0)>-1?(O|0)<(((f[E>>2]|0)-(f[c>>2]|0)|0)/28|0|0):0)){f[p>>2]=0;f[L>>2]=0;v=c$(p,51)|0;w=355222;x=v+51|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-215,p,355210,354957,211);d$(p)}if((R|0)>-1?(N=f[e>>2]|0,(R|0)<(((f[F>>2]|0)-N|0)/28|0|0)):0)S=N;else{f[p>>2]=0;f[K>>2]=0;v=c$(p,51)|0;w=355274;x=v+51|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-215,p,355210,354957,212);d$(p);S=f[e>>2]|0}N=(f[c>>2]|0)+(O*28|0)|0;T=G;f[T>>2]=0;f[T+4>>2]=0;f[p>>2]=50397184;f[H>>2]=n;T=I;f[T>>2]=0;f[T+4>>2]=0;f[q>>2]=50397184;f[J>>2]=o;FAa(h,p,q,N,S+(R*28|0)|0,i,l);P=f[g>>2]|0;Q=f[j>>2]|0}d=d+1|0;if(d>>>0>=Q-P>>4>>>0)break;else{M=P;a=Q}}}Q=o+36|0;a=f[Q>>2]|0;if(a|0?(P=a+12|0,a=f[P>>2]|0,f[P>>2]=a+-1,(a|0)==1):0)CR(o);f[Q>>2]=0;Q=o+16|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[A>>2]|0)>0){Q=f[C>>2]|0;C=0;do{f[Q+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[A>>2]|0))}A=f[D>>2]|0;if((A|0)!=(B|0))ZF(A);A=n+36|0;B=f[A>>2]|0;if(B|0?(D=B+12|0,B=f[D>>2]|0,f[D>>2]=B+-1,(B|0)==1):0)CR(n);f[A>>2]=0;A=n+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[r>>2]|0)>0){A=f[y>>2]|0;y=0;do{f[A+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[r>>2]|0))}r=f[z>>2]|0;if((r|0)==(t|0)){u=m;return}ZF(r);u=m;return}function EAa(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0;l=u;u=u+224|0;m=l+168|0;n=l+160|0;o=l+152|0;p=l;q=l+88|0;r=l+144|0;s=l+72|0;t=l+56|0;f[m>>2]=1124007936;v=m+4|0;w=m+8|0;x=m+40|0;y=v;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[x>>2]=w;A=m+48|0;B=m+44|0;f[B>>2]=A;f[A>>2]=0;f[m+52>>2]=0;QR(n,a,-1);QR(o,d,-1);C=(f[o>>2]|0)+(f[n>>2]|0)|0;D=n+4|0;E=o+4|0;F=f[((f[D>>2]|0)<(f[E>>2]|0)?o:n)+4>>2]|0;do if(!(k&1)){f[r>>2]=C;f[r+4>>2]=F;KS(g,r,(VS(a,-1)|0)&7|16,-1,0,0);do if((NS(g)|0)==65536){G=f[g+4>>2]|0;f[p>>2]=f[G>>2];H=p+4|0;I=G+4|0;f[H>>2]=f[I>>2];J=p+8|0;f[J>>2]=f[G+8>>2];f[p+12>>2]=f[G+12>>2];f[p+16>>2]=f[G+16>>2];f[p+20>>2]=f[G+20>>2];f[p+24>>2]=f[G+24>>2];f[p+28>>2]=f[G+28>>2];f[p+32>>2]=f[G+32>>2];K=p+36|0;L=f[G+36>>2]|0;f[K>>2]=L;f[p+40>>2]=J;J=p+48|0;M=p+44|0;f[M>>2]=J;f[J>>2]=0;f[p+52>>2]=0;if(L|0){J=L+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[I>>2]|0)<3){I=f[G+44>>2]|0;J=f[M>>2]|0;f[J>>2]=f[I>>2];f[J+4>>2]=f[I+4>>2];N=K;break}else{f[H>>2]=0;BR(p,G);N=K;break}}else{OR(p,g,-1);N=p+36|0}while(0);K=f[N>>2]|0;if(K|0){G=K+12|0;f[G>>2]=(f[G>>2]|0)+1}G=m+36|0;K=f[G>>2]|0;if(K|0?(H=K+12|0,K=f[H>>2]|0,f[H>>2]=K+-1,(K|0)==1):0)CR(m);f[G>>2]=0;K=m+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[v>>2]|0)>0){H=f[x>>2]|0;I=0;do{f[H+(I<<2)>>2]=0;I=I+1|0;O=f[v>>2]|0}while((I|0)<(O|0));f[m>>2]=f[p>>2];if((O|0)<3)P=98;else P=100}else{f[m>>2]=f[p>>2];P=98}if((P|0)==98){I=f[p+4>>2]|0;if((I|0)<3){f[v>>2]=I;f[w>>2]=f[p+8>>2];f[m+12>>2]=f[p+12>>2];I=f[p+44>>2]|0;H=f[B>>2]|0;f[H>>2]=f[I>>2];f[H+4>>2]=f[I+4>>2]}else P=100}if((P|0)==100)BR(m,p);I=p+16|0;f[K>>2]=f[I>>2];f[m+20>>2]=f[p+20>>2];f[m+24>>2]=f[p+24>>2];f[m+28>>2]=f[p+28>>2];f[m+32>>2]=f[p+32>>2];H=f[N>>2]|0;f[G>>2]=H;if(H|0?(J=H+12|0,H=f[J>>2]|0,f[J>>2]=H+-1,(H|0)==1):0)CR(p);f[N>>2]=0;H=p+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[H>>2]|0)>0){I=f[p+40>>2]|0;J=0;do{f[I+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[H>>2]|0))}H=f[p+44>>2]|0;if((H|0)!=(p+48|0))ZF(H);f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;f[p+28>>2]=0;gL(m,p)|0;H=f[n>>2]|0;J=f[D>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=H;f[q+12>>2]=J;FR(p,m,q);if((p|0)==(h|0)){Q=f[h+36>>2]|0;R=p+36|0}else{J=p+36|0;H=f[J>>2]|0;if(H|0){I=H+12|0;f[I>>2]=(f[I>>2]|0)+1}I=h+36|0;H=f[I>>2]|0;if(H|0?(G=H+12|0,H=f[G>>2]|0,f[G>>2]=H+-1,(H|0)==1):0)CR(h);f[I>>2]=0;H=h+16|0;G=h+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[G>>2]|0)>0){K=f[h+40>>2]|0;M=0;do{f[K+(M<<2)>>2]=0;M=M+1|0;S=f[G>>2]|0}while((M|0)<(S|0));f[h>>2]=f[p>>2];if((S|0)<3)P=121;else P=123}else{f[h>>2]=f[p>>2];P=121}if((P|0)==121){M=f[p+4>>2]|0;if((M|0)<3){f[G>>2]=M;f[h+8>>2]=f[p+8>>2];f[h+12>>2]=f[p+12>>2];M=f[p+44>>2]|0;K=f[h+44>>2]|0;f[K>>2]=f[M>>2];f[K+4>>2]=f[M+4>>2]}else P=123}if((P|0)==123)BR(h,p);f[H>>2]=f[p+16>>2];f[h+20>>2]=f[p+20>>2];f[h+24>>2]=f[p+24>>2];f[h+28>>2]=f[p+28>>2];f[h+32>>2]=f[p+32>>2];M=f[J>>2]|0;f[I>>2]=M;Q=M;R=J}if(Q|0?(M=Q+12|0,K=f[M>>2]|0,f[M>>2]=K+-1,(K|0)==1):0)CR(p);f[R>>2]=0;K=p+16|0;M=p+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[M>>2]|0)>0){K=f[p+40>>2]|0;L=0;do{f[K+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[M>>2]|0))}M=f[p+44>>2]|0;if((M|0)!=(p+48|0))ZF(M);M=f[o>>2]|0;L=f[E>>2]|0;f[q>>2]=f[n>>2];f[q+4>>2]=0;f[q+8>>2]=M;f[q+12>>2]=L;FR(p,m,q);if((p|0)==(i|0)){T=f[i+36>>2]|0;U=p+36|0}else{L=p+36|0;M=f[L>>2]|0;if(M|0){K=M+12|0;f[K>>2]=(f[K>>2]|0)+1}K=i+36|0;M=f[K>>2]|0;if(M|0?(J=M+12|0,M=f[J>>2]|0,f[J>>2]=M+-1,(M|0)==1):0)CR(i);f[K>>2]=0;M=i+16|0;J=i+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[J>>2]|0)>0){I=f[i+40>>2]|0;H=0;do{f[I+(H<<2)>>2]=0;H=H+1|0;V=f[J>>2]|0}while((H|0)<(V|0));f[i>>2]=f[p>>2];if((V|0)<3)P=145;else P=147}else{f[i>>2]=f[p>>2];P=145}if((P|0)==145){H=f[p+4>>2]|0;if((H|0)<3){f[J>>2]=H;f[i+8>>2]=f[p+8>>2];f[i+12>>2]=f[p+12>>2];H=f[p+44>>2]|0;I=f[i+44>>2]|0;f[I>>2]=f[H>>2];f[I+4>>2]=f[H+4>>2]}else P=147}if((P|0)==147)BR(i,p);f[M>>2]=f[p+16>>2];f[i+20>>2]=f[p+20>>2];f[i+24>>2]=f[p+24>>2];f[i+28>>2]=f[p+28>>2];f[i+32>>2]=f[p+32>>2];H=f[L>>2]|0;f[K>>2]=H;T=H;U=L}if(T|0?(H=T+12|0,I=f[H>>2]|0,f[H>>2]=I+-1,(I|0)==1):0)CR(p);f[U>>2]=0;I=p+16|0;H=p+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[H>>2]|0)>0){I=f[p+40>>2]|0;G=0;do{f[I+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[H>>2]|0))}H=f[p+44>>2]|0;if((H|0)!=(p+48|0))ZF(H);if(!(RR(a,-1)|0)){H=p+8|0;f[H>>2]=0;f[H+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=h;f6(a,p,8,0)}else{H=p+8|0;f[H>>2]=0;f[H+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=h;ZS(a,p)}if(!(RR(d,-1)|0)){H=p+8|0;f[H>>2]=0;f[H+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=i;f6(d,p,8,0);break}else{H=p+8|0;f[H>>2]=0;f[H+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=i;ZS(d,p);break}}else{do if((NS(g)|0)==65536){H=f[g+4>>2]|0;f[p>>2]=f[H>>2];G=p+4|0;I=H+4|0;f[G>>2]=f[I>>2];L=p+8|0;f[L>>2]=f[H+8>>2];f[p+12>>2]=f[H+12>>2];f[p+16>>2]=f[H+16>>2];f[p+20>>2]=f[H+20>>2];f[p+24>>2]=f[H+24>>2];f[p+28>>2]=f[H+28>>2];f[p+32>>2]=f[H+32>>2];K=p+36|0;M=f[H+36>>2]|0;f[K>>2]=M;f[p+40>>2]=L;L=p+48|0;J=p+44|0;f[J>>2]=L;f[L>>2]=0;f[p+52>>2]=0;if(M|0){L=M+12|0;f[L>>2]=(f[L>>2]|0)+1}if((f[I>>2]|0)<3){I=f[H+44>>2]|0;L=f[J>>2]|0;f[L>>2]=f[I>>2];f[L+4>>2]=f[I+4>>2];W=K;break}else{f[G>>2]=0;BR(p,H);W=K;break}}else{OR(p,g,-1);W=p+36|0}while(0);K=f[W>>2]|0;if(K|0){H=K+12|0;f[H>>2]=(f[H>>2]|0)+1}H=m+36|0;K=f[H>>2]|0;if(K|0?(G=K+12|0,K=f[G>>2]|0,f[G>>2]=K+-1,(K|0)==1):0)CR(m);f[H>>2]=0;K=m+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[v>>2]|0)>0){G=f[x>>2]|0;I=0;do{f[G+(I<<2)>>2]=0;I=I+1|0;X=f[v>>2]|0}while((I|0)<(X|0));f[m>>2]=f[p>>2];if((X|0)<3)P=19;else P=21}else{f[m>>2]=f[p>>2];P=19}if((P|0)==19){I=f[p+4>>2]|0;if((I|0)<3){f[v>>2]=I;f[w>>2]=f[p+8>>2];f[m+12>>2]=f[p+12>>2];I=f[p+44>>2]|0;G=f[B>>2]|0;f[G>>2]=f[I>>2];f[G+4>>2]=f[I+4>>2]}else P=21}if((P|0)==21)BR(m,p);I=p+16|0;f[K>>2]=f[I>>2];f[m+20>>2]=f[p+20>>2];f[m+24>>2]=f[p+24>>2];f[m+28>>2]=f[p+28>>2];f[m+32>>2]=f[p+32>>2];G=f[W>>2]|0;f[H>>2]=G;if(G|0?(L=G+12|0,G=f[L>>2]|0,f[L>>2]=G+-1,(G|0)==1):0)CR(p);f[W>>2]=0;G=p+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[G>>2]|0)>0){I=f[p+40>>2]|0;L=0;do{f[I+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[G>>2]|0))}G=f[p+44>>2]|0;if((G|0)!=(p+48|0))ZF(G);if((F|0)>(f[w>>2]|0)?1:(C|0)>(f[m+12>>2]|0)){f[p>>2]=0;f[p+4>>2]=0;y=c$(p,61)|0;G=355326;z=y+61|0;do{b[y>>0]=b[G>>0]|0;y=y+1|0;G=G+1|0}while((y|0)<(z|0));j$(-201,p,355388,354957,137);d$(p)}G=f[n>>2]|0;L=f[D>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=G;f[q+12>>2]=L;FR(p,m,q);if((p|0)==(h|0)){Y=f[h+36>>2]|0;Z=p+36|0}else{L=p+36|0;G=f[L>>2]|0;if(G|0){I=G+12|0;f[I>>2]=(f[I>>2]|0)+1}I=h+36|0;G=f[I>>2]|0;if(G|0?(H=G+12|0,G=f[H>>2]|0,f[H>>2]=G+-1,(G|0)==1):0)CR(h);f[I>>2]=0;G=h+16|0;H=h+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[H>>2]|0)>0){K=f[h+40>>2]|0;J=0;do{f[K+(J<<2)>>2]=0;J=J+1|0;_=f[H>>2]|0}while((J|0)<(_|0));f[h>>2]=f[p>>2];if((_|0)<3)P=44;else P=46}else{f[h>>2]=f[p>>2];P=44}if((P|0)==44){J=f[p+4>>2]|0;if((J|0)<3){f[H>>2]=J;f[h+8>>2]=f[p+8>>2];f[h+12>>2]=f[p+12>>2];J=f[p+44>>2]|0;K=f[h+44>>2]|0;f[K>>2]=f[J>>2];f[K+4>>2]=f[J+4>>2]}else P=46}if((P|0)==46)BR(h,p);f[G>>2]=f[p+16>>2];f[h+20>>2]=f[p+20>>2];f[h+24>>2]=f[p+24>>2];f[h+28>>2]=f[p+28>>2];f[h+32>>2]=f[p+32>>2];J=f[L>>2]|0;f[I>>2]=J;Y=J;Z=L}if(Y|0?(J=Y+12|0,K=f[J>>2]|0,f[J>>2]=K+-1,(K|0)==1):0)CR(p);f[Z>>2]=0;K=p+16|0;J=p+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[J>>2]|0)>0){K=f[p+40>>2]|0;M=0;do{f[K+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[J>>2]|0))}J=f[p+44>>2]|0;if((J|0)!=(p+48|0))ZF(J);J=f[o>>2]|0;M=f[E>>2]|0;f[q>>2]=f[n>>2];f[q+4>>2]=0;f[q+8>>2]=J;f[q+12>>2]=M;FR(p,m,q);if((p|0)==(i|0)){$=f[i+36>>2]|0;aa=p+36|0}else{M=p+36|0;J=f[M>>2]|0;if(J|0){K=J+12|0;f[K>>2]=(f[K>>2]|0)+1}K=i+36|0;J=f[K>>2]|0;if(J|0?(L=J+12|0,J=f[L>>2]|0,f[L>>2]=J+-1,(J|0)==1):0)CR(i);f[K>>2]=0;J=i+16|0;L=i+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[L>>2]|0)>0){I=f[i+40>>2]|0;G=0;do{f[I+(G<<2)>>2]=0;G=G+1|0;ba=f[L>>2]|0}while((G|0)<(ba|0));f[i>>2]=f[p>>2];if((ba|0)<3)P=68;else P=70}else{f[i>>2]=f[p>>2];P=68}do if((P|0)==68){G=f[p+4>>2]|0;if((G|0)>=3){P=70;break}f[L>>2]=G;f[i+8>>2]=f[p+8>>2];f[i+12>>2]=f[p+12>>2];G=f[p+44>>2]|0;I=f[i+44>>2]|0;f[I>>2]=f[G>>2];f[I+4>>2]=f[G+4>>2]}while(0);if((P|0)==70)BR(i,p);f[J>>2]=f[p+16>>2];f[i+20>>2]=f[p+20>>2];f[i+24>>2]=f[p+24>>2];f[i+28>>2]=f[p+28>>2];f[i+32>>2]=f[p+32>>2];L=f[M>>2]|0;f[K>>2]=L;$=L;aa=M}if($|0?(L=$+12|0,G=f[L>>2]|0,f[L>>2]=G+-1,(G|0)==1):0)CR(p);f[aa>>2]=0;G=p+16|0;L=p+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[L>>2]|0)>0){G=f[p+40>>2]|0;I=0;do{f[G+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[L>>2]|0))}L=f[p+44>>2]|0;if((L|0)!=(p+48|0))ZF(L)}while(0);if(!(k&2)){aa=f[n>>2]|0;$=f[D>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=aa;f[q+12>>2]=$;FR(p,m,q);f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=p;$=s+8|0;f[$>>2]=0;f[$+4>>2]=0;f[s>>2]=50397184;f[s+4>>2]=p;$=k|1;BAa(q,c,s,j,$);c=f[o>>2]|0;o=f[E>>2]|0;f[s>>2]=f[n>>2];f[s+4>>2]=0;f[s+8>>2]=c;f[s+12>>2]=o;FR(q,m,s);f[s+8>>2]=0;f[s+12>>2]=0;f[s>>2]=16842752;f[s+4>>2]=q;o=t+8|0;f[o>>2]=0;f[o+4>>2]=0;f[t>>2]=50397184;f[t+4>>2]=q;BAa(s,e,t,j,$);$=q+36|0;j=f[$>>2]|0;if(j|0?(t=j+12|0,j=f[t>>2]|0,f[t>>2]=j+-1,(j|0)==1):0)CR(q);f[$>>2]=0;$=q+16|0;j=q+4|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[j>>2]|0)>0){$=f[q+40>>2]|0;t=0;do{f[$+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[j>>2]|0))}j=f[q+44>>2]|0;if((j|0)!=(q+48|0))ZF(j);j=p+36|0;q=f[j>>2]|0;if(q|0?(t=q+12|0,q=f[t>>2]|0,f[t>>2]=q+-1,(q|0)==1):0)CR(p);f[j>>2]=0;j=p+16|0;q=p+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[q>>2]|0)>0){j=f[p+40>>2]|0;t=0;do{f[j+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[q>>2]|0))}q=f[p+44>>2]|0;if((q|0)!=(p+48|0))ZF(q)}q=m+36|0;p=f[q>>2]|0;if(p|0?(t=p+12|0,p=f[t>>2]|0,f[t>>2]=p+-1,(p|0)==1):0)CR(m);f[q>>2]=0;q=m+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[v>>2]|0)>0){q=f[x>>2]|0;x=0;do{f[q+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[v>>2]|0))}v=f[B>>2]|0;if((v|0)==(A|0)){u=l;return}ZF(v);u=l;return}function FAa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0.0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0,G=0;i=u;u=u+64|0;j=i;k=i+56|0;l=i+48|0;m=i+40|0;o=i+32|0;q=NY()|0;r=+p[g>>3];s=+p[g+8>>3];if(r==-1.0&s==-1.0)if(+p[g+16>>3]==-1.0){t=+p[g+24>>3];if(t==-1.0){v=q;w=f[v+4>>2]|0;x=W1a(f[v>>2]|0,0,-130063606,0)|0;v=C1a(x|0,J|0,w|0,0)|0;w=J;x=W1a(v|0,0,-130063606,0)|0;y=C1a(x|0,J|0,w|0,0)|0;w=J;x=W1a(y|0,0,-130063606,0)|0;z=C1a(x|0,J|0,w|0,0)|0;w=q;f[w>>2]=z;f[w+4>>2]=J;A=0.0;B=+((z&255)>>>0);C=+((y&255)>>>0);D=+((v&255)>>>0);E=j}else{A=t;B=-1.0;C=-1.0;D=r;E=j}}else{F=-1.0;G=3}else{F=s;G=3}if((G|0)==3){A=+p[g+24>>3];B=+p[g+16>>3];C=F;D=r;E=j}p[j>>3]=D;p[j+8>>3]=C;p[j+16>>3]=B;p[j+24>>3]=A;CAa(b,d,j,h);CAa(c,e,j,h);A=+n[d>>2];B=+n[d+4>>2];C=+n[e>>2];D=+n[e+4>>2];QR(k,b,-1);r=C+ +(f[k>>2]|0);QR(l,a,-1);C=+((f[l>>2]|0)+-1|0);l=wNa(A*16.0)|0;k=wNa(B*16.0)|0;f[m>>2]=l;f[m+4>>2]=k;k=wNa((C<r?C:r)*16.0)|0;l=wNa(D*16.0)|0;f[o>>2]=k;f[o+4>>2]=l;t8(a,m,o,j,1,16,4);u=i;return}function GAa(a){a=a|0;qBa(a,105064);OF(a);return}function HAa(a){a=a|0;qBa(a,105064);OF(a);PYa(a);return}function IAa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;gBa(e,c);f[a>>2]=0;f[a+4>>2]=0;c=e+4|0;c$(a,(f[c>>2]|0)+20|0)|0;g=f[c>>2]|0;if(!g)h=0;else{K1a(f[a>>2]|0,f[e>>2]|0,g|0)|0;h=f[c>>2]|0}c=(f[a>>2]|0)+h|0;h=355416;a=c+20|0;do{b[c>>0]=b[h>>0]|0;c=c+1|0;h=h+1|0}while((c|0)<(a|0));d$(e);u=d;return}function JAa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;_$(h,105076);switch(e|0){case 0:{KAa(a,b,c,d);break}case 1:{LAa(a,b,c,d);break}case 2:{MAa(a,b,c,d);break}default:{}}if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function KAa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0,Qa=0.0,Ra=0.0,Sa=0;g=u;u=u+1776|0;i=g+1196|0;j=g+1200|0;k=g+1096|0;l=g+1256|0;m=g+56|0;o=g+40|0;p=g+28|0;q=g;f[i>>2]=d;do if((NS(a)|0)==65536){d=f[a+4>>2]|0;f[j>>2]=f[d>>2];r=j+4|0;s=d+4|0;f[r>>2]=f[s>>2];t=j+8|0;f[t>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];f[j+16>>2]=f[d+16>>2];f[j+20>>2]=f[d+20>>2];f[j+24>>2]=f[d+24>>2];f[j+28>>2]=f[d+28>>2];f[j+32>>2]=f[d+32>>2];v=f[d+36>>2]|0;f[j+36>>2]=v;f[j+40>>2]=t;t=j+48|0;w=j+44|0;f[w>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(v|0){x=v+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[s>>2]|0)<3){s=f[d+44>>2]|0;x=f[w>>2]|0;f[x>>2]=f[s>>2];f[x+4>>2]=f[s+4>>2];y=t;break}else{f[r>>2]=0;BR(j,d);y=t;break}}else{OR(j,a,-1);y=j+48|0}while(0);ZAa(k,f[y>>2]|0,8);a=f[c>>2]|0;t=c+4|0;d=f[t>>2]|0;if((d|0)!=(a|0))f[t>>2]=d+(~(((d+-28-a|0)>>>0)/28|0)*28|0);a=f[i>>2]|0;d=(a|0)>0?a:0;a=(d|0)<255?d:255;f[i>>2]=a;i=0-a|0;d=-255;do{b[l+(d+255)>>0]=(d|0)<(i|0)?1:(d|0)>(a|0)?2:0;d=d+1|0}while((d|0)!=256);d=j+12|0;i=f[d>>2]|0;r=(i*15|0)+368|0;s=m+8|0;f[m>>2]=s;x=m+4|0;f[x>>2]=r;if(r>>>0>1032){w=OYa(r)|0;f[m>>2]=w;z=w}else z=s;f[o>>2]=z;w=z+i|0;f[o+4>>2]=w;r=w+i|0;f[o+8>>2]=r;w=(r+i+3&-4)+4|0;f[p>>2]=w;r=w+(i<<2)+4|0;f[p+4>>2]=r;f[p+8>>2]=r+(i<<2)+4;F1a(z|0,0,i*3|0)|0;r=j+8|0;if(((f[r>>2]|0)+-2|0)>3){w=j+16|0;v=j+44|0;A=k+32|0;B=k+8|0;C=k+40|0;D=k+16|0;E=k+48|0;F=k+24|0;G=k+56|0;H=k+4|0;I=k+36|0;J=k+12|0;K=k+44|0;L=k+20|0;M=k+52|0;N=k+28|0;O=k+60|0;P=q+4|0;Q=q+8|0;R=q+12|0;S=q+16|0;T=q+20|0;U=q+24|0;V=c+8|0;W=i;i=3;while(1){X=f[w>>2]|0;Z=f[f[v>>2]>>2]|0;_=(i+-3|0)%3|0;$=f[o+(_<<2)>>2]|0;aa=f[p+(_<<2)>>2]|0;F1a($|0,0,W|0)|0;if((i|0)<((f[r>>2]|0)+-3|0)?((f[d>>2]|0)+-3|0)>3:0){_=3;ba=0;ca=X+(Y(Z,i)|0)+3|0;while(1){Z=h[ca>>0]|0;X=l+(0-Z)+255|0;da=h[ca+(f[k>>2]|0)>>0]|0;ea=h[ca+(f[A>>2]|0)>>0]|0;fa=b[X+ea>>0]|b[X+da>>0];a:do if(fa<<24>>24!=0?(ga=h[ca+(f[B>>2]|0)>>0]|0,ha=h[ca+(f[C>>2]|0)>>0]|0,ia=h[ca+(f[D>>2]|0)>>0]|0,ja=h[ca+(f[E>>2]|0)>>0]|0,ka=h[ca+(f[F>>2]|0)>>0]|0,la=(b[X+ha>>0]|b[X+ga>>0])&fa&(b[X+ja>>0]|b[X+ia>>0])&(b[X+(h[ca+(f[G>>2]|0)>>0]|0)>>0]|b[X+ka>>0]),la<<24>>24!=0):0){ma=h[ca+(f[H>>2]|0)>>0]|0;na=h[ca+(f[I>>2]|0)>>0]|0;oa=h[ca+(f[J>>2]|0)>>0]|0;pa=h[ca+(f[K>>2]|0)>>0]|0;qa=h[ca+(f[L>>2]|0)>>0]|0;ra=h[ca+(f[N>>2]|0)>>0]|0;sa=(b[X+na>>0]|b[X+ma>>0])&la&(b[X+pa>>0]|b[X+oa>>0])&(b[X+(h[ca+(f[M>>2]|0)>>0]|0)>>0]|b[X+qa>>0])&(b[X+(h[ca+(f[O>>2]|0)>>0]|0)>>0]|b[X+ra>>0])&255;b:do if(sa&1){la=Z-a|0;ta=(oa|0)<(la|0)?((ga|0)<(la|0)?((ma|0)<(la|0)?((da|0)<(la|0)?4:3):2):1):0;if((ia|0)<(la|0)){if(ta>>>0<=3){ua=ta+1|0;va=67}}else{ua=0;va=67}do if((va|0)==67){va=0;if((qa|0)<(la|0))if((ua|0)>3)break;else wa=ua+1|0;else wa=0;if((ka|0)<(la|0))if((wa|0)>3)break;else xa=wa+1|0;else xa=0;if((ra|0)<(la|0))if((xa|0)>3)break;else ya=xa+1|0;else ya=0;if((ea|0)<(la|0))if((ya|0)>3)break;else za=ya+1|0;else za=0;if((na|0)<(la|0))if((za|0)>3)break;else Aa=za+1|0;else Aa=0;if((ha|0)<(la|0))if((Aa|0)>3)break;else Ba=Aa+1|0;else Ba=0;if((pa|0)<(la|0))if((Ba|0)>3)break;else Ca=Ba+1|0;else Ca=0;if(!((ja|0)<(la|0)&(Ca|0)>3)){Da=ba;break b}}while(0);la=ba+1|0;f[aa+(ba<<2)>>2]=_;if(e){ta=(aBa(ca,k,a)|0)&255;b[$+_>>0]=ta;Da=la}else Da=la}else Da=ba;while(0);if(sa&2){ja=a+Z|0;pa=(h[ca+(f[J>>2]|0)>>0]|0)>>>0>ja>>>0?((h[ca+(f[B>>2]|0)>>0]|0)>>>0>ja>>>0?((h[ca+(f[H>>2]|0)>>0]|0)>>>0>ja>>>0?((h[ca+(f[k>>2]|0)>>0]|0)>>>0>ja>>>0?4:3):2):1):0;if((h[ca+(f[D>>2]|0)>>0]|0)>>>0>ja>>>0){if(pa>>>0<=3){Ea=pa+1|0;va=83}}else{Ea=0;va=83}do if((va|0)==83){va=0;if((h[ca+(f[L>>2]|0)>>0]|0)>>>0>ja>>>0)if((Ea|0)>3)break;else Fa=Ea+1|0;else Fa=0;if((h[ca+(f[F>>2]|0)>>0]|0)>>>0>ja>>>0)if((Fa|0)>3)break;else Ga=Fa+1|0;else Ga=0;if((h[ca+(f[N>>2]|0)>>0]|0)>>>0>ja>>>0)if((Ga|0)>3)break;else Ha=Ga+1|0;else Ha=0;if((h[ca+(f[A>>2]|0)>>0]|0)>>>0>ja>>>0)if((Ha|0)>3)break;else Ia=Ha+1|0;else Ia=0;if((h[ca+(f[I>>2]|0)>>0]|0)>>>0>ja>>>0)if((Ia|0)>3)break;else Ja=Ia+1|0;else Ja=0;if((h[ca+(f[C>>2]|0)>>0]|0)>>>0>ja>>>0)if((Ja|0)>3)break;else Ka=Ja+1|0;else Ka=0;if((h[ca+(f[K>>2]|0)>>0]|0)>>>0>ja>>>0)if((Ka|0)>3)break;else La=Ka+1|0;else La=0;if(!((La|0)>3?(h[ca+(f[E>>2]|0)>>0]|0)>>>0>ja>>>0:0)){Ma=Da;break a}}while(0);ja=Da+1|0;f[aa+(Da<<2)>>2]=_;if(e){sa=(aBa(ca,k,a)|0)&255;b[$+_>>0]=sa;Ma=ja}else Ma=ja}else Ma=Da}else Ma=ba;while(0);_=_+1|0;if((_|0)>=((f[d>>2]|0)+-3|0)){Na=Ma;break}else{ba=Ma;ca=ca+1|0}}}else Na=0;f[aa+-4>>2]=Na;c:do if((i|0)!=3?(ca=i+-1|0,ba=(ca|0)%3|0,_=f[o+(ba<<2)>>2]|0,Z=f[o+(((i+-2|0)%3|0)<<2)>>2]|0,ea=f[p+(ba<<2)>>2]|0,ba=f[ea+-4>>2]|0,(ba|0)>0):0){Oa=+(ca|0);if(e)Pa=0;else{ca=0;while(1){da=f[ea+(ca<<2)>>2]|0;Qa=+(da|0);Ra=+(h[_+da>>0]|0);n[q>>2]=Qa;n[P>>2]=Oa;n[Q>>2]=7.0;n[R>>2]=-1.0;n[S>>2]=Ra;f[T>>2]=0;f[U>>2]=-1;da=f[t>>2]|0;if((da|0)==(f[V>>2]|0))kY(c,q);else{n[da>>2]=Qa;n[da+4>>2]=Oa;X=da+8|0;f[X>>2]=f[Q>>2];f[X+4>>2]=f[Q+4>>2];f[X+8>>2]=f[Q+8>>2];f[X+12>>2]=f[Q+12>>2];f[X+16>>2]=f[Q+16>>2];f[t>>2]=(f[t>>2]|0)+28}ca=ca+1|0;if((ca|0)>=(ba|0))break c}}do{ca=f[ea+(Pa<<2)>>2]|0;X=b[_+ca>>0]|0;da=ca+1|0;do if(((((((X&255)>(h[_+da>>0]|0)?(fa=ca+-1|0,(X&255)>(h[_+fa>>0]|0)):0)?(X&255)>(h[Z+fa>>0]|0):0)?(X&255)>(h[Z+ca>>0]|0):0)?(X&255)>(h[Z+da>>0]|0):0)?(X&255)>(h[$+fa>>0]|0):0)?(X&255)>(h[$+ca>>0]|0):0){if((X&255)<=(h[$+da>>0]|0))break;Qa=+(ca|0);n[q>>2]=Qa;n[P>>2]=Oa;n[Q>>2]=7.0;n[R>>2]=-1.0;n[S>>2]=+(X&255);f[T>>2]=0;f[U>>2]=-1;fa=f[t>>2]|0;if((fa|0)==(f[V>>2]|0))kY(c,q);else{n[fa>>2]=Qa;n[fa+4>>2]=Oa;ja=fa+8|0;f[ja>>2]=f[Q>>2];f[ja+4>>2]=f[Q+4>>2];f[ja+8>>2]=f[Q+8>>2];f[ja+12>>2]=f[Q+12>>2];f[ja+16>>2]=f[Q+16>>2];f[t>>2]=(f[t>>2]|0)+28}}while(0);Pa=Pa+1|0}while((Pa|0)<(ba|0))}while(0);$=i+1|0;if(($|0)>=((f[r>>2]|0)+-2|0))break;W=f[d>>2]|0;i=$}Sa=f[m>>2]|0}else Sa=z;if((Sa|0)!=(s|0)){if(Sa|0)QYa(Sa);f[m>>2]=s;f[x>>2]=1032}x=j+36|0;s=f[x>>2]|0;if(s|0?(m=s+12|0,s=f[m>>2]|0,f[m>>2]=s+-1,(s|0)==1):0)CR(j);f[x>>2]=0;x=j+16|0;s=j+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[s>>2]|0)>0){x=f[j+40>>2]|0;m=0;do{f[x+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[s>>2]|0))}s=f[j+44>>2]|0;if((s|0)==(y|0)){u=g;return}ZF(s);u=g;return}function LAa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0.0,ua=0;g=u;u=u+1776|0;i=g+1196|0;j=g+1200|0;k=g+1096|0;l=g+1256|0;m=g+56|0;o=g+40|0;p=g+28|0;q=g;f[i>>2]=d;do if((NS(a)|0)==65536){d=f[a+4>>2]|0;f[j>>2]=f[d>>2];r=j+4|0;s=d+4|0;f[r>>2]=f[s>>2];t=j+8|0;f[t>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];f[j+16>>2]=f[d+16>>2];f[j+20>>2]=f[d+20>>2];f[j+24>>2]=f[d+24>>2];f[j+28>>2]=f[d+28>>2];f[j+32>>2]=f[d+32>>2];v=f[d+36>>2]|0;f[j+36>>2]=v;f[j+40>>2]=t;t=j+48|0;w=j+44|0;f[w>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(v|0){x=v+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[s>>2]|0)<3){s=f[d+44>>2]|0;x=f[w>>2]|0;f[x>>2]=f[s>>2];f[x+4>>2]=f[s+4>>2];y=t;break}else{f[r>>2]=0;BR(j,d);y=t;break}}else{OR(j,a,-1);y=j+48|0}while(0);ZAa(k,f[y>>2]|0,12);a=f[c>>2]|0;t=c+4|0;d=f[t>>2]|0;if((d|0)!=(a|0))f[t>>2]=d+(~(((d+-28-a|0)>>>0)/28|0)*28|0);a=f[i>>2]|0;d=(a|0)>0?a:0;a=(d|0)<255?d:255;f[i>>2]=a;i=0-a|0;d=-255;do{b[l+(d+255)>>0]=(d|0)<(i|0)?1:(d|0)>(a|0)?2:0;d=d+1|0}while((d|0)!=256);d=j+12|0;i=f[d>>2]|0;r=(i*15|0)+368|0;s=m+8|0;f[m>>2]=s;x=m+4|0;f[x>>2]=r;if(r>>>0>1032){w=OYa(r)|0;f[m>>2]=w;z=w}else z=s;f[o>>2]=z;w=z+i|0;f[o+4>>2]=w;r=w+i|0;f[o+8>>2]=r;w=(r+i+3&-4)+4|0;f[p>>2]=w;r=w+(i<<2)+4|0;f[p+4>>2]=r;f[p+8>>2]=r+(i<<2)+4;F1a(z|0,0,i*3|0)|0;r=j+8|0;if(((f[r>>2]|0)+-2|0)>3){w=j+16|0;v=j+44|0;A=k+32|0;B=k+8|0;C=k+40|0;D=k+16|0;E=k+48|0;F=k+24|0;G=k+56|0;H=k+4|0;I=k+36|0;J=k+12|0;K=k+44|0;L=k+20|0;M=k+52|0;N=k+28|0;O=k+60|0;P=q+4|0;Q=q+8|0;R=q+12|0;S=q+16|0;T=q+20|0;U=q+24|0;V=c+8|0;W=i;i=3;while(1){X=f[w>>2]|0;Z=f[f[v>>2]>>2]|0;_=(i+-3|0)%3|0;$=f[o+(_<<2)>>2]|0;aa=f[p+(_<<2)>>2]|0;F1a($|0,0,W|0)|0;if((i|0)<((f[r>>2]|0)+-3|0)?((f[d>>2]|0)+-3|0)>3:0){_=3;ba=0;ca=X+(Y(Z,i)|0)+3|0;while(1){Z=h[ca>>0]|0;X=l+(0-Z)+255|0;da=b[ca+(f[k>>2]|0)>>0]|0;ea=b[X+(h[ca+(f[A>>2]|0)>>0]|0)>>0]|b[X+(da&255)>>0];a:do if(ea<<24>>24!=0?(fa=(b[X+(h[ca+(f[C>>2]|0)>>0]|0)>>0]|b[X+(h[ca+(f[B>>2]|0)>>0]|0)>>0])&ea&(b[X+(h[ca+(f[E>>2]|0)>>0]|0)>>0]|b[X+(h[ca+(f[D>>2]|0)>>0]|0)>>0])&(b[X+(h[ca+(f[G>>2]|0)>>0]|0)>>0]|b[X+(h[ca+(f[F>>2]|0)>>0]|0)>>0]),fa<<24>>24!=0):0){ga=(b[X+(h[ca+(f[I>>2]|0)>>0]|0)>>0]|b[X+(h[ca+(f[H>>2]|0)>>0]|0)>>0])&fa&(b[X+(h[ca+(f[K>>2]|0)>>0]|0)>>0]|b[X+(h[ca+(f[J>>2]|0)>>0]|0)>>0])&(b[X+(h[ca+(f[M>>2]|0)>>0]|0)>>0]|b[X+(h[ca+(f[L>>2]|0)>>0]|0)>>0])&(b[X+(h[ca+(f[O>>2]|0)>>0]|0)>>0]|b[X+(h[ca+(f[N>>2]|0)>>0]|0)>>0])&255;b:do if(ga&1){fa=Z-a|0;ha=da;ia=0;ja=0;while(1){if((ha&255|0)<(fa|0))if((ia|0)>5)break;else ka=ia+1|0;else ka=0;la=ja+1|0;if((la|0)>=19){ma=ba;break b}ha=b[ca+(f[k+(la<<2)>>2]|0)>>0]|0;ia=ka;ja=la}ja=ba+1|0;f[aa+(ba<<2)>>2]=_;if(e){ia=($Aa(ca,k,a)|0)&255;b[$+_>>0]=ia;ma=ja}else ma=ja}else ma=ba;while(0);if(ga&2){ja=a+Z|0;ia=0;ha=0;while(1){if((h[ca+(f[k+(ha<<2)>>2]|0)>>0]|0)>>>0>ja>>>0)if((ia|0)>5)break;else na=ia+1|0;else na=0;ha=ha+1|0;if((ha|0)>=19){oa=ma;break a}else ia=na}ia=ma+1|0;f[aa+(ma<<2)>>2]=_;if(e){ha=($Aa(ca,k,a)|0)&255;b[$+_>>0]=ha;oa=ia}else oa=ia}else oa=ma}else oa=ba;while(0);_=_+1|0;if((_|0)>=((f[d>>2]|0)+-3|0)){pa=oa;break}else{ba=oa;ca=ca+1|0}}}else pa=0;f[aa+-4>>2]=pa;c:do if((i|0)!=3?(ca=i+-1|0,ba=(ca|0)%3|0,_=f[o+(ba<<2)>>2]|0,Z=f[o+(((i+-2|0)%3|0)<<2)>>2]|0,da=f[p+(ba<<2)>>2]|0,ba=f[da+-4>>2]|0,(ba|0)>0):0){qa=+(ca|0);if(e)ra=0;else{ca=0;while(1){X=f[da+(ca<<2)>>2]|0;sa=+(X|0);ta=+(h[_+X>>0]|0);n[q>>2]=sa;n[P>>2]=qa;n[Q>>2]=7.0;n[R>>2]=-1.0;n[S>>2]=ta;f[T>>2]=0;f[U>>2]=-1;X=f[t>>2]|0;if((X|0)==(f[V>>2]|0))kY(c,q);else{n[X>>2]=sa;n[X+4>>2]=qa;ea=X+8|0;f[ea>>2]=f[Q>>2];f[ea+4>>2]=f[Q+4>>2];f[ea+8>>2]=f[Q+8>>2];f[ea+12>>2]=f[Q+12>>2];f[ea+16>>2]=f[Q+16>>2];f[t>>2]=(f[t>>2]|0)+28}ca=ca+1|0;if((ca|0)>=(ba|0))break c}}do{ca=f[da+(ra<<2)>>2]|0;ea=b[_+ca>>0]|0;X=ca+1|0;do if(((((((ea&255)>(h[_+X>>0]|0)?(ia=ca+-1|0,(ea&255)>(h[_+ia>>0]|0)):0)?(ea&255)>(h[Z+ia>>0]|0):0)?(ea&255)>(h[Z+ca>>0]|0):0)?(ea&255)>(h[Z+X>>0]|0):0)?(ea&255)>(h[$+ia>>0]|0):0)?(ea&255)>(h[$+ca>>0]|0):0){if((ea&255)<=(h[$+X>>0]|0))break;sa=+(ca|0);n[q>>2]=sa;n[P>>2]=qa;n[Q>>2]=7.0;n[R>>2]=-1.0;n[S>>2]=+(ea&255);f[T>>2]=0;f[U>>2]=-1;ia=f[t>>2]|0;if((ia|0)==(f[V>>2]|0))kY(c,q);else{n[ia>>2]=sa;n[ia+4>>2]=qa;ha=ia+8|0;f[ha>>2]=f[Q>>2];f[ha+4>>2]=f[Q+4>>2];f[ha+8>>2]=f[Q+8>>2];f[ha+12>>2]=f[Q+12>>2];f[ha+16>>2]=f[Q+16>>2];f[t>>2]=(f[t>>2]|0)+28}}while(0);ra=ra+1|0}while((ra|0)<(ba|0))}while(0);$=i+1|0;if(($|0)>=((f[r>>2]|0)+-2|0))break;W=f[d>>2]|0;i=$}ua=f[m>>2]|0}else ua=z;if((ua|0)!=(s|0)){if(ua|0)QYa(ua);f[m>>2]=s;f[x>>2]=1032}x=j+36|0;s=f[x>>2]|0;if(s|0?(m=s+12|0,s=f[m>>2]|0,f[m>>2]=s+-1,(s|0)==1):0)CR(j);f[x>>2]=0;x=j+16|0;s=j+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[s>>2]|0)>0){x=f[j+40>>2]|0;m=0;do{f[x+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[s>>2]|0))}s=f[j+44>>2]|0;if((s|0)==(y|0)){u=g;return}ZF(s);u=g;return}function MAa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0.0,ua=0;g=u;u=u+1776|0;i=g+1196|0;j=g+1200|0;k=g+1096|0;l=g+1256|0;m=g+56|0;o=g+40|0;p=g+28|0;q=g;f[i>>2]=d;do if((NS(a)|0)==65536){d=f[a+4>>2]|0;f[j>>2]=f[d>>2];r=j+4|0;s=d+4|0;f[r>>2]=f[s>>2];t=j+8|0;f[t>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];f[j+16>>2]=f[d+16>>2];f[j+20>>2]=f[d+20>>2];f[j+24>>2]=f[d+24>>2];f[j+28>>2]=f[d+28>>2];f[j+32>>2]=f[d+32>>2];v=f[d+36>>2]|0;f[j+36>>2]=v;f[j+40>>2]=t;t=j+48|0;w=j+44|0;f[w>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(v|0){x=v+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[s>>2]|0)<3){s=f[d+44>>2]|0;x=f[w>>2]|0;f[x>>2]=f[s>>2];f[x+4>>2]=f[s+4>>2];y=t;break}else{f[r>>2]=0;BR(j,d);y=t;break}}else{OR(j,a,-1);y=j+48|0}while(0);ZAa(k,f[y>>2]|0,16);a=f[c>>2]|0;t=c+4|0;d=f[t>>2]|0;if((d|0)!=(a|0))f[t>>2]=d+(~(((d+-28-a|0)>>>0)/28|0)*28|0);a=f[i>>2]|0;d=(a|0)>0?a:0;a=(d|0)<255?d:255;f[i>>2]=a;i=0-a|0;d=-255;do{b[l+(d+255)>>0]=(d|0)<(i|0)?1:(d|0)>(a|0)?2:0;d=d+1|0}while((d|0)!=256);d=j+12|0;i=f[d>>2]|0;r=(i*15|0)+368|0;s=m+8|0;f[m>>2]=s;x=m+4|0;f[x>>2]=r;if(r>>>0>1032){w=OYa(r)|0;f[m>>2]=w;z=w}else z=s;f[o>>2]=z;w=z+i|0;f[o+4>>2]=w;r=w+i|0;f[o+8>>2]=r;w=(r+i+3&-4)+4|0;f[p>>2]=w;r=w+(i<<2)+4|0;f[p+4>>2]=r;f[p+8>>2]=r+(i<<2)+4;F1a(z|0,0,i*3|0)|0;r=j+8|0;if(((f[r>>2]|0)+-2|0)>3){w=j+16|0;v=j+44|0;A=k+32|0;B=k+8|0;C=k+40|0;D=k+16|0;E=k+48|0;F=k+24|0;G=k+56|0;H=k+4|0;I=k+36|0;J=k+12|0;K=k+44|0;L=k+20|0;M=k+52|0;N=k+28|0;O=k+60|0;P=q+4|0;Q=q+8|0;R=q+12|0;S=q+16|0;T=q+20|0;U=q+24|0;V=c+8|0;W=i;i=3;while(1){X=f[w>>2]|0;Z=f[f[v>>2]>>2]|0;_=(i+-3|0)%3|0;$=f[o+(_<<2)>>2]|0;aa=f[p+(_<<2)>>2]|0;F1a($|0,0,W|0)|0;if((i|0)<((f[r>>2]|0)+-3|0)?((f[d>>2]|0)+-3|0)>3:0){_=3;ba=0;ca=X+(Y(Z,i)|0)+3|0;while(1){Z=h[ca>>0]|0;X=l+(0-Z)+255|0;da=b[ca+(f[k>>2]|0)>>0]|0;ea=b[X+(h[ca+(f[A>>2]|0)>>0]|0)>>0]|b[X+(da&255)>>0];a:do if(ea<<24>>24!=0?(fa=(b[X+(h[ca+(f[C>>2]|0)>>0]|0)>>0]|b[X+(h[ca+(f[B>>2]|0)>>0]|0)>>0])&ea&(b[X+(h[ca+(f[E>>2]|0)>>0]|0)>>0]|b[X+(h[ca+(f[D>>2]|0)>>0]|0)>>0])&(b[X+(h[ca+(f[G>>2]|0)>>0]|0)>>0]|b[X+(h[ca+(f[F>>2]|0)>>0]|0)>>0]),fa<<24>>24!=0):0){ga=(b[X+(h[ca+(f[I>>2]|0)>>0]|0)>>0]|b[X+(h[ca+(f[H>>2]|0)>>0]|0)>>0])&fa&(b[X+(h[ca+(f[K>>2]|0)>>0]|0)>>0]|b[X+(h[ca+(f[J>>2]|0)>>0]|0)>>0])&(b[X+(h[ca+(f[M>>2]|0)>>0]|0)>>0]|b[X+(h[ca+(f[L>>2]|0)>>0]|0)>>0])&(b[X+(h[ca+(f[O>>2]|0)>>0]|0)>>0]|b[X+(h[ca+(f[N>>2]|0)>>0]|0)>>0])&255;b:do if(ga&1){fa=Z-a|0;ha=da;ia=0;ja=0;while(1){if((ha&255|0)<(fa|0))if((ia|0)>7)break;else ka=ia+1|0;else ka=0;la=ja+1|0;if((la|0)>=25){ma=ba;break b}ha=b[ca+(f[k+(la<<2)>>2]|0)>>0]|0;ia=ka;ja=la}ja=ba+1|0;f[aa+(ba<<2)>>2]=_;if(e){ia=(_Aa(ca,k,a)|0)&255;b[$+_>>0]=ia;ma=ja}else ma=ja}else ma=ba;while(0);if(ga&2){ja=a+Z|0;ia=0;ha=0;while(1){if((h[ca+(f[k+(ha<<2)>>2]|0)>>0]|0)>>>0>ja>>>0)if((ia|0)>7)break;else na=ia+1|0;else na=0;ha=ha+1|0;if((ha|0)>=25){oa=ma;break a}else ia=na}ia=ma+1|0;f[aa+(ma<<2)>>2]=_;if(e){ha=(_Aa(ca,k,a)|0)&255;b[$+_>>0]=ha;oa=ia}else oa=ia}else oa=ma}else oa=ba;while(0);_=_+1|0;if((_|0)>=((f[d>>2]|0)+-3|0)){pa=oa;break}else{ba=oa;ca=ca+1|0}}}else pa=0;f[aa+-4>>2]=pa;c:do if((i|0)!=3?(ca=i+-1|0,ba=(ca|0)%3|0,_=f[o+(ba<<2)>>2]|0,Z=f[o+(((i+-2|0)%3|0)<<2)>>2]|0,da=f[p+(ba<<2)>>2]|0,ba=f[da+-4>>2]|0,(ba|0)>0):0){qa=+(ca|0);if(e)ra=0;else{ca=0;while(1){X=f[da+(ca<<2)>>2]|0;sa=+(X|0);ta=+(h[_+X>>0]|0);n[q>>2]=sa;n[P>>2]=qa;n[Q>>2]=7.0;n[R>>2]=-1.0;n[S>>2]=ta;f[T>>2]=0;f[U>>2]=-1;X=f[t>>2]|0;if((X|0)==(f[V>>2]|0))kY(c,q);else{n[X>>2]=sa;n[X+4>>2]=qa;ea=X+8|0;f[ea>>2]=f[Q>>2];f[ea+4>>2]=f[Q+4>>2];f[ea+8>>2]=f[Q+8>>2];f[ea+12>>2]=f[Q+12>>2];f[ea+16>>2]=f[Q+16>>2];f[t>>2]=(f[t>>2]|0)+28}ca=ca+1|0;if((ca|0)>=(ba|0))break c}}do{ca=f[da+(ra<<2)>>2]|0;ea=b[_+ca>>0]|0;X=ca+1|0;do if(((((((ea&255)>(h[_+X>>0]|0)?(ia=ca+-1|0,(ea&255)>(h[_+ia>>0]|0)):0)?(ea&255)>(h[Z+ia>>0]|0):0)?(ea&255)>(h[Z+ca>>0]|0):0)?(ea&255)>(h[Z+X>>0]|0):0)?(ea&255)>(h[$+ia>>0]|0):0)?(ea&255)>(h[$+ca>>0]|0):0){if((ea&255)<=(h[$+X>>0]|0))break;sa=+(ca|0);n[q>>2]=sa;n[P>>2]=qa;n[Q>>2]=7.0;n[R>>2]=-1.0;n[S>>2]=+(ea&255);f[T>>2]=0;f[U>>2]=-1;ia=f[t>>2]|0;if((ia|0)==(f[V>>2]|0))kY(c,q);else{n[ia>>2]=sa;n[ia+4>>2]=qa;ha=ia+8|0;f[ha>>2]=f[Q>>2];f[ha+4>>2]=f[Q+4>>2];f[ha+8>>2]=f[Q+8>>2];f[ha+12>>2]=f[Q+12>>2];f[ha+16>>2]=f[Q+16>>2];f[t>>2]=(f[t>>2]|0)+28}}while(0);ra=ra+1|0}while((ra|0)<(ba|0))}while(0);$=i+1|0;if(($|0)>=((f[r>>2]|0)+-2|0))break;W=f[d>>2]|0;i=$}ua=f[m>>2]|0}else ua=z;if((ua|0)!=(s|0)){if(ua|0)QYa(ua);f[m>>2]=s;f[x>>2]=1032}x=j+36|0;s=f[x>>2]|0;if(s|0?(m=s+12|0,s=f[m>>2]|0,f[m>>2]=s+-1,(s|0)==1):0)CR(j);f[x>>2]=0;x=j+16|0;s=j+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[s>>2]|0)>0){x=f[j+40>>2]|0;m=0;do{f[x+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[s>>2]|0))}s=f[j+44>>2]|0;if((s|0)==(y|0)){u=g;return}ZF(s);u=g;return}function NAa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0;g=NYa(16)|0;WF(g);f[g>>2]=105136;f[g+4>>2]=c;b[g+8>>0]=d&1;f[g+12>>2]=e<<16>>16;e=NYa(16)|0;d=e+4|0;f[d>>2]=1;f[e>>2]=105232;f[e+8>>2]=g;f[a>>2]=e;f[a+4>>2]=g;f[d>>2]=(f[d>>2]|0)+1;g=f[d>>2]|0;f[d>>2]=g+-1;if((g|0)!=1)return;ki[f[(f[e>>2]|0)+8>>2]&2047](e);return}function OAa(a){a=a|0;PYa(a);return}function PAa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function QAa(a){a=a|0;qBa(a,105272);OF(a);return}function RAa(a){a=a|0;qBa(a,105272);OF(a);PYa(a);return}function SAa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+208|0;h=g+192|0;i=g+136|0;j=g+80|0;k=g+32|0;l=g+16|0;m=g;_$(h,105244);do if((NS(e)|0)==65536){n=f[e+4>>2]|0;f[i>>2]=f[n>>2];o=i+4|0;p=n+4|0;f[o>>2]=f[p>>2];q=i+8|0;f[q>>2]=f[n+8>>2];f[i+12>>2]=f[n+12>>2];f[i+16>>2]=f[n+16>>2];f[i+20>>2]=f[n+20>>2];f[i+24>>2]=f[n+24>>2];f[i+28>>2]=f[n+28>>2];f[i+32>>2]=f[n+32>>2];r=f[n+36>>2]|0;f[i+36>>2]=r;f[i+40>>2]=q;q=i+48|0;s=i+44|0;f[s>>2]=q;f[q>>2]=0;f[i+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[n+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[o>>2]=0;BR(i,n);break}}else OR(i,e,-1);while(0);f[j>>2]=1124007936;e=j+4|0;n=j+8|0;o=j+40|0;p=e;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=n;n=j+48|0;p=j+44|0;f[p>>2]=n;f[n>>2]=0;f[j+52>>2]=0;f[k>>2]=1124007936;q=k+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q+16>>2]=0;f[q+20>>2]=0;f[q+24>>2]=0;f[k+32>>2]=k+8;q=k+40|0;f[k+36>>2]=q;f[k+44>>2]=0;f[q>>2]=0;q=c;s=f[q+4>>2]|0;r=l;f[r>>2]=f[q>>2];f[r+4>>2]=s;s=l+8|0;f[s>>2]=f[c+8>>2];r=l+12|0;f[r>>2]=f[c+12>>2];if(RR(c,-1)|0){q=(NS(c)|0)==655360;t=m+8|0;f[t>>2]=0;f[t+4>>2]=0;if(q){f[m>>2]=34209792;f[m+4>>2]=k}else{f[m>>2]=33619968;f[m+4>>2]=j}f6(c,m,6,0);c=m;q=f[c+4>>2]|0;t=l;f[t>>2]=f[c>>2];f[t+4>>2]=q;f[s>>2]=f[m+8>>2];f[r>>2]=f[m+12>>2]}JAa(l,d,f[a+4>>2]|0,(b[a+8>>0]|0)!=0,f[a+12>>2]|0);wBa(d,i);j0(k);k=j+36|0;d=f[k>>2]|0;if(d|0?(a=d+12|0,d=f[a>>2]|0,f[a>>2]=d+-1,(d|0)==1):0)CR(j);f[k>>2]=0;k=j+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[e>>2]|0)>0){k=f[o>>2]|0;o=0;do{f[k+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[e>>2]|0))}e=f[p>>2]|0;if((e|0)!=(n|0))ZF(e);e=i+36|0;n=f[e>>2]|0;if(n|0?(p=n+12|0,n=f[p>>2]|0,f[p>>2]=n+-1,(n|0)==1):0)CR(i);f[e>>2]=0;e=i+16|0;n=i+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[n>>2]|0)>0){e=f[i+40>>2]|0;p=0;do{f[e+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[n>>2]|0))}n=f[i+44>>2]|0;if((n|0)!=(i+48|0))ZF(n);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function TAa(a,b){a=a|0;b=b|0;f[a+4>>2]=b;return}function UAa(a){a=a|0;return f[a+4>>2]|0}function VAa(a,c){a=a|0;c=c|0;b[a+8>>0]=c&1;return}function WAa(a){a=a|0;return (b[a+8>>0]|0)!=0|0}function XAa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function YAa(a){a=a|0;return f[a+12>>2]|0}function ZAa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;switch(d|0){case 16:{h=105352;break}case 12:{h=105480;break}default:h=(d|0)==8?105288:0}if(!((a|0)!=0&(h|0)!=0)){f[g>>2]=0;f[g+4>>2]=0;i=c$(g,16)|0;j=355798;k=i+16|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-215,g,355815,355827,74);d$(g)}if((d|0)>0){g=0;do{j=(Y(f[h+(g<<3)+4>>2]|0,c)|0)+(f[h+(g<<3)>>2]|0)|0;f[a+(g<<2)>>2]=j;g=g+1|0}while((g|0)!=(d|0));if((d|0)<25)l=d;else{u=e;return}}else l=0;do{f[a+(l<<2)>>2]=f[a+(l-d<<2)>>2];l=l+1|0}while((l|0)!=25);u=e;return}function _Aa(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+64|0;g=e;i=h[a>>0]|0;j=0;do{d[g+(j<<1)>>1]=i-(h[a+(f[b+(j<<2)>>2]|0)>>0]|0);j=j+1|0}while((j|0)!=25);k=c;l=0;while(1){c=d[g+((l|1)<<1)>>1]|0;j=l;l=l+2|0;b=d[g+(l<<1)>>1]|0;a=(b|0)<(c|0)?b:c;c=d[g+(j+3<<1)>>1]|0;b=(c|0)<(a|0)?c:a;if((b|0)>(k|0)){a=d[g+(j+4<<1)>>1]|0;c=(a|0)<(b|0)?a:b;b=d[g+(j+5<<1)>>1]|0;a=(b|0)<(c|0)?b:c;c=d[g+(j+6<<1)>>1]|0;b=(c|0)<(a|0)?c:a;a=d[g+(j+7<<1)>>1]|0;c=(a|0)<(b|0)?a:b;b=d[g+(j+8<<1)>>1]|0;a=(b|0)<(c|0)?b:c;c=d[g+(j<<1)>>1]|0;b=(c|0)<(a|0)?c:a;c=(k|0)<(b|0)?b:k;b=d[g+(j+9<<1)>>1]|0;j=(b|0)<(a|0)?b:a;m=(c|0)<(j|0)?j:c}else m=k;if((l|0)>=16)break;else k=m}k=d[g+4>>1]|0;l=d[g+6>>1]|0;c=0-m|0;m=0;while(1){j=d[g+((m|1)<<1)>>1]|0;a=m;m=m+2|0;b=k<<16>>16;i=(j|0)<(b|0)?b:j;j=l<<16>>16;b=(i|0)<(j|0)?j:i;k=d[g+(a+4<<1)>>1]|0;i=k<<16>>16;j=(b|0)<(i|0)?i:b;l=d[g+(a+5<<1)>>1]|0;b=l<<16>>16;i=(j|0)<(b|0)?b:j;if((i|0)<(c|0)){j=d[g+(a+6<<1)>>1]|0;b=(i|0)<(j|0)?j:i;i=d[g+(a+7<<1)>>1]|0;j=(b|0)<(i|0)?i:b;b=d[g+(a+8<<1)>>1]|0;i=(j|0)<(b|0)?b:j;j=d[g+(a<<1)>>1]|0;b=(i|0)<(j|0)?j:i;j=(b|0)<(c|0)?b:c;b=d[g+(a+9<<1)>>1]|0;a=(i|0)<(b|0)?b:i;n=(a|0)<(j|0)?a:j}else n=c;if((m|0)>=16)break;else c=n}u=e;return ~n|0}function $Aa(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e;i=h[a>>0]|0;j=0;do{d[g+(j<<1)>>1]=i-(h[a+(f[b+(j<<2)>>2]|0)>>0]|0);j=j+1|0}while((j|0)!=19);k=c;l=0;while(1){c=d[g+((l|1)<<1)>>1]|0;j=l;l=l+2|0;b=d[g+(l<<1)>>1]|0;a=(b|0)<(c|0)?b:c;if((a|0)>(k|0)){c=d[g+(j+3<<1)>>1]|0;b=(c|0)<(a|0)?c:a;a=d[g+(j+4<<1)>>1]|0;c=(a|0)<(b|0)?a:b;b=d[g+(j+5<<1)>>1]|0;a=(b|0)<(c|0)?b:c;c=d[g+(j+6<<1)>>1]|0;b=(c|0)<(a|0)?c:a;a=d[g+(j<<1)>>1]|0;c=(a|0)<(b|0)?a:b;a=(k|0)<(c|0)?c:k;c=d[g+(j+7<<1)>>1]|0;j=(c|0)<(b|0)?c:b;m=(a|0)<(j|0)?j:a}else m=k;if((l|0)>=12)break;else k=m}k=d[g+4>>1]|0;l=0-m|0;m=0;while(1){a=d[g+((m|1)<<1)>>1]|0;j=m;m=m+2|0;b=k<<16>>16;c=(a|0)<(b|0)?b:a;a=d[g+(j+3<<1)>>1]|0;b=(c|0)<(a|0)?a:c;k=d[g+(j+4<<1)>>1]|0;c=k<<16>>16;a=(b|0)<(c|0)?c:b;if((a|0)<(l|0)){b=d[g+(j+5<<1)>>1]|0;c=(a|0)<(b|0)?b:a;a=d[g+(j+6<<1)>>1]|0;b=(c|0)<(a|0)?a:c;c=d[g+(j<<1)>>1]|0;a=(b|0)<(c|0)?c:b;c=(a|0)<(l|0)?a:l;a=d[g+(j+7<<1)>>1]|0;j=(b|0)<(a|0)?a:b;n=(j|0)<(c|0)?j:c}else n=l;if((m|0)>=12)break;else l=n}u=e;return ~n|0}function aBa(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+32|0;g=e;i=h[a>>0]|0;d[g>>1]=i-(h[a+(f[b>>2]|0)>>0]|0);d[g+2>>1]=i-(h[a+(f[b+4>>2]|0)>>0]|0);d[g+4>>1]=i-(h[a+(f[b+8>>2]|0)>>0]|0);d[g+6>>1]=i-(h[a+(f[b+12>>2]|0)>>0]|0);d[g+8>>1]=i-(h[a+(f[b+16>>2]|0)>>0]|0);d[g+10>>1]=i-(h[a+(f[b+20>>2]|0)>>0]|0);d[g+12>>1]=i-(h[a+(f[b+24>>2]|0)>>0]|0);d[g+14>>1]=i-(h[a+(f[b+28>>2]|0)>>0]|0);d[g+16>>1]=i-(h[a+(f[b+32>>2]|0)>>0]|0);d[g+18>>1]=i-(h[a+(f[b+36>>2]|0)>>0]|0);d[g+20>>1]=i-(h[a+(f[b+40>>2]|0)>>0]|0);d[g+22>>1]=i-(h[a+(f[b+44>>2]|0)>>0]|0);d[g+24>>1]=i-(h[a+(f[b+48>>2]|0)>>0]|0);b=d[g+2>>1]|0;a=d[g+4>>1]|0;i=(a|0)<(b|0)?a:b;if((i|0)>(c|0)){b=d[g+6>>1]|0;a=(b|0)<(i|0)?b:i;i=d[g+8>>1]|0;b=(i|0)<(a|0)?i:a;a=d[g>>1]|0;i=(a|0)<(b|0)?a:b;a=(i|0)>(c|0)?i:c;i=d[g+10>>1]|0;j=(i|0)<(b|0)?i:b;k=(a|0)<(j|0)?j:a}else k=c;c=d[g+6>>1]|0;a=d[g+8>>1]|0;j=(a|0)<(c|0)?a:c;if((j|0)>(k|0)){c=d[g+10>>1]|0;a=(c|0)<(j|0)?c:j;j=d[g+12>>1]|0;c=(j|0)<(a|0)?j:a;a=d[g+4>>1]|0;j=(a|0)<(c|0)?a:c;a=(k|0)<(j|0)?j:k;j=d[g+14>>1]|0;b=(j|0)<(c|0)?j:c;l=(a|0)<(b|0)?b:a}else l=k;k=d[g+10>>1]|0;a=d[g+12>>1]|0;b=(a|0)<(k|0)?a:k;if((b|0)>(l|0)){k=d[g+14>>1]|0;a=(k|0)<(b|0)?k:b;b=d[g+16>>1]|0;k=(b|0)<(a|0)?b:a;a=d[g+8>>1]|0;b=(a|0)<(k|0)?a:k;a=(l|0)<(b|0)?b:l;b=d[g+18>>1]|0;c=(b|0)<(k|0)?b:k;m=(a|0)<(c|0)?c:a}else m=l;l=d[g+14>>1]|0;a=d[g+16>>1]|0;c=(a|0)<(l|0)?a:l;if((c|0)>(m|0)){l=d[g+18>>1]|0;a=(l|0)<(c|0)?l:c;c=d[g+20>>1]|0;l=(c|0)<(a|0)?c:a;a=d[g+12>>1]|0;c=(a|0)<(l|0)?a:l;a=(m|0)<(c|0)?c:m;c=d[g+22>>1]|0;k=(c|0)<(l|0)?c:l;n=(a|0)<(k|0)?k:a}else n=m;m=0-n|0;n=d[g+2>>1]|0;a=d[g+4>>1]|0;k=(n|0)<(a|0)?a:n;n=d[g+6>>1]|0;a=(k|0)<(n|0)?n:k;if((a|0)<(m|0)){k=d[g+8>>1]|0;n=(a|0)<(k|0)?k:a;a=d[g>>1]|0;k=(n|0)<(a|0)?a:n;a=(k|0)<(m|0)?k:m;k=d[g+10>>1]|0;l=(n|0)<(k|0)?k:n;o=(l|0)<(a|0)?l:a}else o=m;m=d[g+6>>1]|0;a=d[g+8>>1]|0;l=(m|0)<(a|0)?a:m;m=d[g+10>>1]|0;a=(l|0)<(m|0)?m:l;if((a|0)<(o|0)){l=d[g+12>>1]|0;m=(a|0)<(l|0)?l:a;a=d[g+4>>1]|0;l=(m|0)<(a|0)?a:m;a=(l|0)<(o|0)?l:o;l=d[g+14>>1]|0;n=(m|0)<(l|0)?l:m;p=(n|0)<(a|0)?n:a}else p=o;o=d[g+10>>1]|0;a=d[g+12>>1]|0;n=(o|0)<(a|0)?a:o;o=d[g+14>>1]|0;a=(n|0)<(o|0)?o:n;if((a|0)<(p|0)){n=d[g+16>>1]|0;o=(a|0)<(n|0)?n:a;a=d[g+8>>1]|0;n=(o|0)<(a|0)?a:o;a=(n|0)<(p|0)?n:p;n=d[g+18>>1]|0;m=(o|0)<(n|0)?n:o;q=(m|0)<(a|0)?m:a}else q=p;p=d[g+14>>1]|0;a=d[g+16>>1]|0;m=(p|0)<(a|0)?a:p;p=d[g+18>>1]|0;a=(m|0)<(p|0)?p:m;if((a|0)>=(q|0)){r=q;s=~r;u=e;return s|0}m=d[g+20>>1]|0;p=(a|0)<(m|0)?m:a;a=d[g+12>>1]|0;m=(p|0)<(a|0)?a:p;a=(m|0)<(q|0)?m:q;q=d[g+22>>1]|0;g=(p|0)<(q|0)?q:p;r=(g|0)<(a|0)?g:a;s=~r;u=e;return s|0}function bBa(a){a=a|0;OF(a);return}function cBa(a){a=a|0;OF(a);PYa(a);return}function dBa(a,b){a=a|0;b=b|0;return}function eBa(a,b){a=a|0;b=b|0;return}function fBa(a){a=a|0;return 1}function gBa(a,c){a=a|0;c=c|0;var d=0;f[a>>2]=0;f[a+4>>2]=0;c=c$(a,9)|0;a=356573;d=c+9|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(d|0));return}function hBa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;_$(g,105656);if(XS(b)|0){h=f[c>>2]|0;i=c+4|0;j=f[i>>2]|0;if((j|0)!=(h|0))f[i>>2]=j+(~(((j+-28-h|0)>>>0)/28|0)*28|0)}else{h=f[(f[a>>2]|0)+48>>2]|0;j=fT()|0;bh[h&255](a,b,d,c,j,0)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function iBa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;g=u;u=u+128|0;h=g+112|0;i=g+100|0;j=g+88|0;k=g+72|0;l=g+56|0;m=g;_$(h,105636);f[i>>2]=0;n=i+4|0;f[n>>2]=0;f[i+8>>2]=0;f[j>>2]=0;o=j+4|0;f[o>>2]=0;f[j+8>>2]=0;PS(c,i);c=(f[n>>2]|0)-(f[i>>2]|0)|0;n=(c|0)/56|0;if(!(XS(e)|0)?(PS(e,j),(((f[o>>2]|0)-(f[j>>2]|0)|0)/56|0|0)!=(n|0)):0){f[k>>2]=0;f[k+4>>2]=0;p=c$(k,23)|0;e=356344;q=p+23|0;do{b[p>>0]=b[e>>0]|0;p=p+1|0;e=e+1|0}while((p|0)<(q|0));j$(-215,k,356368,355885,88);d$(k)}e=d+4|0;r=f[e>>2]|0;s=f[d>>2]|0;t=(r-s|0)/12|0;v=s;s=r;if(n>>>0<=t>>>0){if(n>>>0<t>>>0?(r=v+(n*12|0)|0,(s|0)!=(r|0)):0){v=s;while(1){s=v+-12|0;f[e>>2]=s;w=f[s>>2]|0;if(!w)x=s;else{s=v+-8|0;y=f[s>>2]|0;if((y|0)!=(w|0))f[s>>2]=y+(~(((y+-28-w|0)>>>0)/28|0)*28|0);PYa(w);x=f[e>>2]|0}if((x|0)==(r|0))break;else v=x}}}else pBa(d,n-t|0);if(c|0){c=k+8|0;t=k+12|0;x=k+4|0;v=m+4|0;r=m+8|0;e=m+40|0;w=m+48|0;y=m+44|0;s=m+52|0;z=l+8|0;A=l+12|0;B=l+4|0;C=m+36|0;D=m+16|0;E=m+12|0;F=m+20|0;G=m+24|0;H=m+28|0;I=m+32|0;J=0;do{K=f[(f[a>>2]|0)+32>>2]|0;L=(f[i>>2]|0)+(J*56|0)|0;f[c>>2]=0;f[t>>2]=0;f[k>>2]=16842752;f[x>>2]=L;L=(f[d>>2]|0)+(J*12|0)|0;M=f[j>>2]|0;do if((M|0)!=(f[o>>2]|0)){N=M+(J*56|0)|0;f[m>>2]=f[N>>2];O=M+(J*56|0)+4|0;f[v>>2]=f[O>>2];f[r>>2]=f[M+(J*56|0)+8>>2];f[E>>2]=f[M+(J*56|0)+12>>2];f[D>>2]=f[M+(J*56|0)+16>>2];f[F>>2]=f[M+(J*56|0)+20>>2];f[G>>2]=f[M+(J*56|0)+24>>2];f[H>>2]=f[M+(J*56|0)+28>>2];f[I>>2]=f[M+(J*56|0)+32>>2];P=f[M+(J*56|0)+36>>2]|0;f[C>>2]=P;f[e>>2]=r;f[y>>2]=w;f[w>>2]=0;f[s>>2]=0;if(P|0){Q=P+12|0;f[Q>>2]=(f[Q>>2]|0)+1}if((f[O>>2]|0)<3){O=f[M+(J*56|0)+44>>2]|0;Q=f[y>>2]|0;f[Q>>2]=f[O>>2];f[Q+4>>2]=f[O+4>>2];break}else{f[v>>2]=0;BR(m,N);break}}else{f[m>>2]=1124007936;p=v;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[e>>2]=r;f[y>>2]=w;f[w>>2]=0;f[s>>2]=0}while(0);f[z>>2]=0;f[A>>2]=0;f[l>>2]=16842752;f[B>>2]=m;Ah[K&255](a,k,L,l);M=f[C>>2]|0;if(M|0?(N=M+12|0,M=f[N>>2]|0,f[N>>2]=M+-1,(M|0)==1):0)CR(m);f[C>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[v>>2]|0)>0){M=f[e>>2]|0;N=0;do{f[M+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[v>>2]|0))}N=f[y>>2]|0;if((N|0)!=(w|0))ZF(N);J=J+1|0}while(J>>>0<n>>>0)}Vt(j);Vt(i);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function jBa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;_$(g,105616);if(XS(b)|0)oS(d);else{h=f[(f[a>>2]|0)+48>>2]|0;i=fT()|0;bh[h&255](a,b,i,c,d,1)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function kBa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;_$(h,105596);if(dT(e)|0){f[i>>2]=0;l=i+4|0;f[l>>2]=0;f[i+8>>2]=0;PS(c,i);c=(f[l>>2]|0)-(f[i>>2]|0)|0;l=(c|0)/56|0;if((((f[d+4>>2]|0)-(f[d>>2]|0)|0)/12|0|0)!=(l|0)){f[j>>2]=0;f[j+4>>2]=0;m=c$(j,27)|0;n=356055;o=m+27|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,j,356083,355885,133);d$(j)}if((NS(e)|0)!=327680){f[j>>2]=0;f[j+4>>2]=0;m=c$(j,50)|0;n=356091;o=m+50|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,j,356083,355885,134);d$(j)}n=f[e+4>>2]|0;gS(n,l);if(c|0){c=j+8|0;e=j+12|0;m=j+4|0;o=k+8|0;p=k+4|0;q=0;do{r=f[(f[a>>2]|0)+40>>2]|0;s=(f[i>>2]|0)+(q*56|0)|0;f[c>>2]=0;f[e>>2]=0;f[j>>2]=16842752;f[m>>2]=s;s=(f[d>>2]|0)+(q*12|0)|0;t=(f[n>>2]|0)+(q*56|0)|0;v=o;f[v>>2]=0;f[v+4>>2]=0;f[k>>2]=33619968;f[p>>2]=t;Ah[r&255](a,j,s,k);q=q+1|0}while(q>>>0<l>>>0)}Vt(i)}if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function lBa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;g=u;u=u+16|0;e=g+8|0;d=g;_$(e,105576);f[d>>2]=0;f[d+4>>2]=0;j$(-213,d,357862,355885,154);d$(d);if(!(f[e+4>>2]|0)){u=g;return}u=g;return}function mBa(a){a=a|0;return 0}function nBa(a){a=a|0;return 5}function oBa(a){a=a|0;var b=0;b=(mi[f[(f[a>>2]|0)+56>>2]&255](a)|0)==0;return (b?6:4)|0}function pBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/12|0)>>>0>=b>>>0){F1a(g|0,0,b*12|0)|0;f[e>>2]=h+(b*12|0);return}i=f[a>>2]|0;j=(g-i|0)/12|0;k=j+b|0;l=i;if(k>>>0>357913941)gXa(a);m=(d-i|0)/12|0;i=m<<1;d=m>>>0<178956970?(i>>>0<k>>>0?k:i):357913941;do if(d)if(d>>>0>357913941){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{n=NYa(d*12|0)|0;break}else n=0;while(0);i=n+(j*12|0)|0;j=i;k=n+(d*12|0)|0;F1a(i|0,0,b*12|0)|0;d=i+(b*12|0)|0;if((h|0)==(l|0)){o=j;p=g;q=h}else{g=i;i=h;h=j;do{i=i+-12|0;yu(g+-12|0,i);g=h+-12|0;h=g}while((i|0)!=(l|0));o=h;p=f[a>>2]|0;q=f[e>>2]|0}f[a>>2]=o;f[e>>2]=d;f[c>>2]=k;k=p;if((q|0)!=(k|0)){c=q;do{q=c;c=c+-12|0;d=f[c>>2]|0;if(d|0){e=q+-8|0;q=f[e>>2]|0;if((q|0)!=(d|0))f[e>>2]=q+(~(((q+-28-d|0)>>>0)/28|0)*28|0);PYa(d)}}while((c|0)!=(k|0))}if(!p)return;PYa(p);return}function qBa(a,b){a=a|0;b=b|0;return}function rBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,v=0;c=u;u=u+48|0;d=c+8|0;e=c+44|0;g=c+40|0;h=c+36|0;i=c+32|0;j=c+28|0;k=c;if((b|0)<=-1){u=c;return}l=a+4|0;m=f[l>>2]|0;o=f[a>>2]|0;p=o;q=m;if(((m-o|0)/28|0)>>>0<=b>>>0){u=c;return}if(!b){if((q|0)==(p|0)){u=c;return}f[l>>2]=q+(~(((q+-28-o|0)>>>0)/28|0)*28|0);u=c;return}f[h>>2]=o;f[i>>2]=p+(b*28|0);f[j>>2]=m;f[g>>2]=f[h>>2];f[e>>2]=f[i>>2];f[d>>2]=f[j>>2];sBa(g,e,d,k);k=f[a>>2]|0;r=+n[k+((b+-1|0)*28|0)+16>>2];e=k+(b*28|0)|0;b=f[l>>2]|0;a:do if((e|0)==(b|0))s=e;else{k=e;g=b;while(1){j=k;while(1){if(!(+n[j+16>>2]>=r)){t=g;break}i=j+28|0;if((i|0)==(g|0)){s=g;break a}else j=i}while(1){v=t+-28|0;if((j|0)==(v|0)){s=j;break a}if(!(+n[t+-12>>2]>=r))t=v;else break}i=f[j>>2]|0;h=j+4|0;m=f[h>>2]|0;p=j+8|0;f[d>>2]=f[p>>2];f[d+4>>2]=f[p+4>>2];f[d+8>>2]=f[p+8>>2];f[d+12>>2]=f[p+12>>2];f[d+16>>2]=f[p+16>>2];f[j>>2]=f[v>>2];o=t+-24|0;f[h>>2]=f[o>>2];h=t+-20|0;f[p>>2]=f[h>>2];f[p+4>>2]=f[h+4>>2];f[p+8>>2]=f[h+8>>2];f[p+12>>2]=f[h+12>>2];f[p+16>>2]=f[h+16>>2];f[v>>2]=i;f[o>>2]=m;f[h>>2]=f[d>>2];f[h+4>>2]=f[d+4>>2];f[h+8>>2]=f[d+8>>2];f[h+12>>2]=f[d+12>>2];f[h+16>>2]=f[d+16>>2];h=j+28|0;if((h|0)==(v|0)){s=h;break}else{k=h;g=v}}}while(0);v=f[a>>2]|0;d=(s-v|0)/28|0;s=f[l>>2]|0;t=(s-v|0)/28|0;b=s;if(d>>>0>t>>>0){lY(a,d-t|0);u=c;return}if(d>>>0>=t>>>0){u=c;return}t=v+(d*28|0)|0;if((b|0)==(t|0)){u=c;return}f[l>>2]=b+(~(((b+-28-t|0)>>>0)/28|0)*28|0);u=c;return}function sBa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;e=u;u=u+64|0;g=e+8|0;h=e;i=e+56|0;j=e+52|0;k=e+48|0;l=e+44|0;m=e+28|0;o=e+40|0;p=e+36|0;q=e+32|0;r=f[b>>2]|0;s=f[c>>2]|0;if((r|0)==(s|0)){u=e;return}t=f[b>>2]|0;b=s;s=r;a:while(1){r=b+-28|0;v=r;w=(s|0)==(b|0);x=b;y=b+-28|0;z=y;A=b+-12|0;B=b+-24|0;C=b+-20|0;D=f[a>>2]|0;b:while(1){E=D;F=x-D|0;G=(F|0)/28|0;switch(G|0){case 2:{H=5;break a;break}case 3:{H=7;break a;break}case 1:case 0:{H=67;break a;break}default:{}}if((F|0)<224){H=9;break a}F=G>>>1;G=E+(F*28|0)|0;f[m>>2]=G;f[o>>2]=D;f[p>>2]=G;f[q>>2]=v;f[i>>2]=f[o>>2];f[h>>2]=f[p>>2];f[g>>2]=f[q>>2];I=tBa(i,h,g,d)|0;f[h>>2]=v;J=+n[E+(F*28|0)+16>>2];if(+n[E+16>>2]>J){K=r;L=I;break}else M=r;while(1){N=M+-28|0;f[h>>2]=N;if((E|0)==(N|0))break;if(+n[M+-12>>2]>J){H=40;break b}else M=N}F=E+28|0;G=F;f[h>>2]=z;if(+n[E+16>>2]>+n[A>>2]){O=G;P=y}else{if((F|0)==(y|0)){H=65;break a}J=+n[E+16>>2];Q=F;F=G;while(1){if(J>+n[Q+16>>2])break;G=Q+28|0;if((G|0)==(y|0)){H=65;break a}else{Q=G;F=G}}G=F;R=f[G>>2]|0;S=Q+4|0;T=f[S>>2]|0;U=Q+8|0;f[g>>2]=f[U>>2];f[g+4>>2]=f[U+4>>2];f[g+8>>2]=f[U+8>>2];f[g+12>>2]=f[U+12>>2];f[g+16>>2]=f[U+16>>2];f[G>>2]=f[y>>2];f[S>>2]=f[B>>2];f[U>>2]=f[C>>2];f[U+4>>2]=f[C+4>>2];f[U+8>>2]=f[C+8>>2];f[U+12>>2]=f[C+12>>2];f[U+16>>2]=f[C+16>>2];f[y>>2]=R;f[B>>2]=T;f[C>>2]=f[g>>2];f[C+4>>2]=f[g+4>>2];f[C+8>>2]=f[g+8>>2];f[C+12>>2]=f[g+12>>2];f[C+16>>2]=f[g+16>>2];O=Q+28|0;P=f[h>>2]|0}if((O|0)==(P|0)){H=65;break a}T=(f[a>>2]|0)+16|0;R=O;while(1){U=R;J=+n[T>>2];if(J>+n[U+16>>2]){V=U;W=R}else{S=U;do{U=S;S=S+28|0}while(!(J>+n[U+44>>2]));V=S;W=S}U=f[h>>2]|0;while(1){X=U+-28|0;f[h>>2]=X;if(J>+n[U+-12>>2])U=X;else break}if(V>>>0>=X>>>0)break;S=W;G=f[S>>2]|0;Y=V+4|0;Z=f[Y>>2]|0;_=V+8|0;f[g>>2]=f[_>>2];f[g+4>>2]=f[_+4>>2];f[g+8>>2]=f[_+8>>2];f[g+12>>2]=f[_+12>>2];f[g+16>>2]=f[_+16>>2];f[S>>2]=f[X>>2];S=U+-24|0;f[Y>>2]=f[S>>2];Y=U+-20|0;f[_>>2]=f[Y>>2];f[_+4>>2]=f[Y+4>>2];f[_+8>>2]=f[Y+8>>2];f[_+12>>2]=f[Y+12>>2];f[_+16>>2]=f[Y+16>>2];f[X>>2]=G;f[S>>2]=Z;f[Y>>2]=f[g>>2];f[Y+4>>2]=f[g+4>>2];f[Y+8>>2]=f[g+8>>2];f[Y+12>>2]=f[g+12>>2];f[Y+16>>2]=f[g+16>>2];R=V+28|0}if(s>>>0<V>>>0){H=65;break a}f[a>>2]=W;if(w){H=67;break a}else D=W}if((H|0)==40){H=0;w=D;C=f[w>>2]|0;B=E+4|0;y=f[B>>2]|0;A=E+8|0;f[g>>2]=f[A>>2];f[g+4>>2]=f[A+4>>2];f[g+8>>2]=f[A+8>>2];f[g+12>>2]=f[A+12>>2];f[g+16>>2]=f[A+16>>2];f[w>>2]=f[N>>2];w=M+-24|0;f[B>>2]=f[w>>2];B=M+-20|0;f[A>>2]=f[B>>2];f[A+4>>2]=f[B+4>>2];f[A+8>>2]=f[B+8>>2];f[A+12>>2]=f[B+12>>2];f[A+16>>2]=f[B+16>>2];f[N>>2]=C;f[w>>2]=y;f[B>>2]=f[g>>2];f[B+4>>2]=f[g+4>>2];f[B+8>>2]=f[g+8>>2];f[B+12>>2]=f[g+12>>2];f[B+16>>2]=f[g+16>>2];K=f[h>>2]|0;L=I+1|0}B=E+28|0;y=B;w=f[m>>2]|0;c:do if(B>>>0<K>>>0){C=y;A=w;z=L;while(1){r=C;if(+n[r+16>>2]>+n[A+16>>2]){J=+n[A+16>>2];v=r;do{x=v;v=v+28|0}while(+n[x+44>>2]>J);$=v;aa=v}else{$=r;aa=C}J=+n[A+16>>2];U=f[h>>2]|0;while(1){ba=U+-28|0;f[h>>2]=ba;if(+n[U+-12>>2]>J)break;else U=ba}if($>>>0>=ba>>>0){ca=aa;da=A;ea=z;break c}r=aa;v=f[r>>2]|0;x=$+4|0;R=f[x>>2]|0;T=$+8|0;f[g>>2]=f[T>>2];f[g+4>>2]=f[T+4>>2];f[g+8>>2]=f[T+8>>2];f[g+12>>2]=f[T+12>>2];f[g+16>>2]=f[T+16>>2];f[r>>2]=f[ba>>2];r=U+-24|0;f[x>>2]=f[r>>2];x=U+-20|0;f[T>>2]=f[x>>2];f[T+4>>2]=f[x+4>>2];f[T+8>>2]=f[x+8>>2];f[T+12>>2]=f[x+12>>2];f[T+16>>2]=f[x+16>>2];f[ba>>2]=v;f[r>>2]=R;f[x>>2]=f[g>>2];f[x+4>>2]=f[g+4>>2];f[x+8>>2]=f[g+8>>2];f[x+12>>2]=f[g+12>>2];f[x+16>>2]=f[g+16>>2];x=f[m>>2]|0;if((x|0)==($|0)){R=f[h>>2]|0;f[m>>2]=R;fa=R}else fa=x;C=$+28|0;A=fa;z=z+1|0}}else{ca=y;da=w;ea=L}while(0);w=ca;if((w|0)!=(da|0)?+n[da+16>>2]>+n[w+16>>2]:0){y=ca;B=f[y>>2]|0;z=w+4|0;A=f[z>>2]|0;C=w+8|0;f[g>>2]=f[C>>2];f[g+4>>2]=f[C+4>>2];f[g+8>>2]=f[C+8>>2];f[g+12>>2]=f[C+12>>2];f[g+16>>2]=f[C+16>>2];f[y>>2]=f[da>>2];y=da+4|0;f[z>>2]=f[y>>2];z=da+8|0;f[C>>2]=f[z>>2];f[C+4>>2]=f[z+4>>2];f[C+8>>2]=f[z+8>>2];f[C+12>>2]=f[z+12>>2];f[C+16>>2]=f[z+16>>2];f[da>>2]=B;f[y>>2]=A;f[z>>2]=f[g>>2];f[z+4>>2]=f[g+4>>2];f[z+8>>2]=f[g+8>>2];f[z+12>>2]=f[g+12>>2];f[z+16>>2]=f[g+16>>2];ga=ea+1|0}else ga=ea;if((t|0)==(w|0)){H=65;break}if(!ga)if(t>>>0<w>>>0){f[m>>2]=D;z=D;A=h;while(1){f[A>>2]=z;y=f[h>>2]|0;B=y+28|0;C=B;f[h>>2]=C;if((B|0)==(w|0)){H=65;break a}if(+n[y+44>>2]>+n[(f[m>>2]|0)+16>>2])break;else{z=C;A=m}}}else{f[m>>2]=ca;A=ca;z=h;while(1){f[z>>2]=A;C=f[h>>2]|0;y=C+28|0;B=y;f[h>>2]=B;if((y|0)==(b|0)){H=65;break a}if(+n[C+44>>2]>+n[(f[m>>2]|0)+16>>2])break;else{A=B;z=m}}}z=t>>>0<w>>>0;f[(z?c:a)>>2]=z?ca:w+28|0;z=f[c>>2]|0;if((t|0)==(z|0)){H=67;break}else{b=z;s=t}}if((H|0)==5){t=b+-28|0;f[c>>2]=t;if(!(+n[b+-12>>2]>+n[E+16>>2])){u=e;return}s=D;ca=f[s>>2]|0;a=E+4|0;m=f[a>>2]|0;ga=E+8|0;f[g>>2]=f[ga>>2];f[g+4>>2]=f[ga+4>>2];f[g+8>>2]=f[ga+8>>2];f[g+12>>2]=f[ga+12>>2];f[g+16>>2]=f[ga+16>>2];f[s>>2]=f[t>>2];s=b+-24|0;f[a>>2]=f[s>>2];a=b+-20|0;f[ga>>2]=f[a>>2];f[ga+4>>2]=f[a+4>>2];f[ga+8>>2]=f[a+8>>2];f[ga+12>>2]=f[a+12>>2];f[ga+16>>2]=f[a+16>>2];f[t>>2]=ca;f[s>>2]=m;f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2];f[a+8>>2]=f[g+8>>2];f[a+12>>2]=f[g+12>>2];f[a+16>>2]=f[g+16>>2];u=e;return}else if((H|0)==7){f[j>>2]=D;f[k>>2]=D+28;a=b+-28|0;f[c>>2]=a;f[l>>2]=a;f[i>>2]=f[j>>2];f[h>>2]=f[k>>2];f[g>>2]=f[l>>2];tBa(i,h,g,d)|0;u=e;return}else if((H|0)==9){d=b+-28|0;i=D;if((i|0)==(d|0)){u=e;return}D=i;do{f[h>>2]=D;if((D|0)==(b|0))ha=b;else{i=g;l=h;d:while(1){f[i>>2]=f[l>>2];ia=f[h>>2]|0;k=ia+16|0;j=f[g>>2]|0;do{a=j;j=j+28|0;if((j|0)==(b|0))break d}while(!(+n[a+44>>2]>+n[k>>2]));f[g>>2]=j;i=h;l=g}ha=ia}if((ha|0)!=(D|0)){l=f[D>>2]|0;i=D+4|0;w=f[i>>2]|0;k=D+8|0;f[g>>2]=f[k>>2];f[g+4>>2]=f[k+4>>2];f[g+8>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];f[g+16>>2]=f[k+16>>2];f[D>>2]=f[ha>>2];a=ha+4|0;f[i>>2]=f[a>>2];i=ha+8|0;f[k>>2]=f[i>>2];f[k+4>>2]=f[i+4>>2];f[k+8>>2]=f[i+8>>2];f[k+12>>2]=f[i+12>>2];f[k+16>>2]=f[i+16>>2];f[ha>>2]=l;f[a>>2]=w;f[i>>2]=f[g>>2];f[i+4>>2]=f[g+4>>2];f[i+8>>2]=f[g+8>>2];f[i+12>>2]=f[g+12>>2];f[i+16>>2]=f[g+16>>2]}D=D+28|0}while((D|0)!=(d|0));u=e;return}else if((H|0)==65){u=e;return}else if((H|0)==67){u=e;return}}function tBa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0.0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+32|0;e=d;g=f[b>>2]|0;b=f[a>>2]|0;a=g+16|0;h=+n[a>>2];i=b+16|0;j=f[c>>2]|0;c=j+16|0;k=+n[c>>2]>h;if(!(h>+n[i>>2])){if(!k){l=0;u=d;return l|0}m=f[g>>2]|0;o=g+4|0;p=f[o>>2]|0;q=g+8|0;f[e>>2]=f[q>>2];f[e+4>>2]=f[q+4>>2];f[e+8>>2]=f[q+8>>2];f[e+12>>2]=f[q+12>>2];f[e+16>>2]=f[q+16>>2];f[g>>2]=f[j>>2];r=j+4|0;f[o>>2]=f[r>>2];s=j+8|0;f[q>>2]=f[s>>2];f[q+4>>2]=f[s+4>>2];f[q+8>>2]=f[s+8>>2];f[q+12>>2]=f[s+12>>2];f[q+16>>2]=f[s+16>>2];f[j>>2]=m;f[r>>2]=p;f[s>>2]=f[e>>2];f[s+4>>2]=f[e+4>>2];f[s+8>>2]=f[e+8>>2];f[s+12>>2]=f[e+12>>2];f[s+16>>2]=f[e+16>>2];if(!(+n[a>>2]>+n[i>>2])){l=1;u=d;return l|0}i=f[b>>2]|0;s=b+4|0;p=f[s>>2]|0;r=b+8|0;f[e>>2]=f[r>>2];f[e+4>>2]=f[r+4>>2];f[e+8>>2]=f[r+8>>2];f[e+12>>2]=f[r+12>>2];f[e+16>>2]=f[r+16>>2];f[b>>2]=f[g>>2];f[s>>2]=f[o>>2];f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];f[r+8>>2]=f[q+8>>2];f[r+12>>2]=f[q+12>>2];f[r+16>>2]=f[q+16>>2];f[g>>2]=i;f[o>>2]=p;f[q>>2]=f[e>>2];f[q+4>>2]=f[e+4>>2];f[q+8>>2]=f[e+8>>2];f[q+12>>2]=f[e+12>>2];f[q+16>>2]=f[e+16>>2];l=2;u=d;return l|0}if(k){k=f[b>>2]|0;q=b+4|0;p=f[q>>2]|0;o=b+8|0;f[e>>2]=f[o>>2];f[e+4>>2]=f[o+4>>2];f[e+8>>2]=f[o+8>>2];f[e+12>>2]=f[o+12>>2];f[e+16>>2]=f[o+16>>2];f[b>>2]=f[j>>2];i=j+4|0;f[q>>2]=f[i>>2];q=j+8|0;f[o>>2]=f[q>>2];f[o+4>>2]=f[q+4>>2];f[o+8>>2]=f[q+8>>2];f[o+12>>2]=f[q+12>>2];f[o+16>>2]=f[q+16>>2];f[j>>2]=k;f[i>>2]=p;f[q>>2]=f[e>>2];f[q+4>>2]=f[e+4>>2];f[q+8>>2]=f[e+8>>2];f[q+12>>2]=f[e+12>>2];f[q+16>>2]=f[e+16>>2];l=1;u=d;return l|0}q=f[b>>2]|0;p=b+4|0;i=f[p>>2]|0;k=b+8|0;f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[e+16>>2]=f[k+16>>2];f[b>>2]=f[g>>2];b=g+4|0;f[p>>2]=f[b>>2];p=g+8|0;f[k>>2]=f[p>>2];f[k+4>>2]=f[p+4>>2];f[k+8>>2]=f[p+8>>2];f[k+12>>2]=f[p+12>>2];f[k+16>>2]=f[p+16>>2];f[g>>2]=q;f[b>>2]=i;f[p>>2]=f[e>>2];f[p+4>>2]=f[e+4>>2];f[p+8>>2]=f[e+8>>2];f[p+12>>2]=f[e+12>>2];f[p+16>>2]=f[e+16>>2];if(!(+n[c>>2]>+n[a>>2])){l=1;u=d;return l|0};f[e>>2]=f[p>>2];f[e+4>>2]=f[p+4>>2];f[e+8>>2]=f[p+8>>2];f[e+12>>2]=f[p+12>>2];f[e+16>>2]=f[p+16>>2];f[g>>2]=f[j>>2];g=j+4|0;f[b>>2]=f[g>>2];b=j+8|0;f[p>>2]=f[b>>2];f[p+4>>2]=f[b+4>>2];f[p+8>>2]=f[b+8>>2];f[p+12>>2]=f[b+12>>2];f[p+16>>2]=f[b+16>>2];f[j>>2]=q;f[g>>2]=i;f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];f[b+8>>2]=f[e+8>>2];f[b+12>>2]=f[e+12>>2];f[b+16>>2]=f[e+16>>2];l=2;u=d;return l|0}function uBa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d+28|0;g=d+24|0;h=d+20|0;i=d+16|0;j=d;if((c|0)<=0){u=d;return}k=f[b+4>>2]|0;l=c<<1;if((k|0)>(l|0)?(m=f[b>>2]|0,(m|0)>(l|0)):0){f[h>>2]=f[a>>2];l=a+4|0;f[i>>2]=f[l>>2];b=m-c|0;m=k-c|0;k=(b|0)<(c|0)?b:c;n=(m|0)<(c|0)?m:c;f[j>>2]=k;f[j+4>>2]=n;f[j+8>>2]=((b|0)>(c|0)?b:c)-k;f[j+12>>2]=((m|0)>(c|0)?m:c)-n;f[g>>2]=f[h>>2];f[e>>2]=f[i>>2];i=vBa(g,e,j)|0;j=f[l>>2]|0;if((i|0)==(j|0)){u=d;return}f[l>>2]=j+(~(((j+-28-i|0)>>>0)/28|0)*28|0);u=d;return}i=f[a>>2]|0;j=a+4|0;a=f[j>>2]|0;if((a|0)==(i|0)){u=d;return}f[j>>2]=a+(~(((a+-28-i|0)>>>0)/28|0)*28|0);u=d;return}function vBa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0;d=f[a>>2]|0;e=f[b>>2]|0;a:do if((d|0)==(e|0))g=d;else{b=f[c>>2]|0;h=(f[c+8>>2]|0)+b|0;i=f[c+4>>2]|0;j=(f[c+12>>2]|0)+i|0;k=d;do{l=wNa(+n[k>>2])|0;m=wNa(+n[k+4>>2])|0;if(!((m|0)<(j|0)&(((l|0)>=(h|0)|(b|0)>(l|0)|(i|0)>(m|0))^1))){g=k;break a}k=k+28|0}while((k|0)!=(e|0));f[a>>2]=e;o=e;return o|0}while(0);f[a>>2]=g;if((g|0)==(e|0)){o=e;return o|0}d=g+28|0;if((d|0)==(e|0)){o=g;return o|0}k=c+8|0;i=c+4|0;b=c+12|0;h=d;d=g;j=g;while(1){p=+n[h>>2];g=wNa(p)|0;q=+n[d+32>>2];m=wNa(q)|0;l=f[c>>2]|0;if((((l|0)<=(g|0)?(g|0)<((f[k>>2]|0)+l|0):0)?(l=f[i>>2]|0,(l|0)<=(m|0)):0)?(m|0)<((f[b>>2]|0)+l|0):0){n[j>>2]=p;n[j+4>>2]=q;l=j+8|0;m=d+36|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];f[l+12>>2]=f[m+12>>2];f[l+16>>2]=f[m+16>>2];m=j+28|0;f[a>>2]=m;r=m}else r=j;m=h+28|0;if((m|0)==(e|0)){o=r;break}else{l=h;h=m;j=r;d=l}}return o|0}function wBa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0;d=u;u=u+64|0;e=d+56|0;g=d;_$(e,105676);h=f[c+16>>2]|0;i=h;if(h|0){h=c+4|0;j=f[h>>2]|0;if((j|0)<3)k=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{l=f[c+40>>2]|0;m=0;o=1;while(1){p=Y(f[l+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)==(j|0)){k=p;break}else o=p}}if(!((j|0)==0|(k|0)==0)){k=f[a>>2]|0;o=a+4|0;a=f[o>>2]|0;f[g>>2]=f[c>>2];m=g+4|0;f[m>>2]=j;l=g+8|0;f[l>>2]=f[c+8>>2];f[g+12>>2]=f[c+12>>2];p=g+16|0;f[p>>2]=i;f[g+20>>2]=f[c+20>>2];f[g+24>>2]=f[c+24>>2];f[g+28>>2]=f[c+28>>2];f[g+32>>2]=f[c+32>>2];i=g+36|0;q=f[c+36>>2]|0;f[i>>2]=q;r=g+40|0;f[r>>2]=l;l=g+48|0;s=g+44|0;f[s>>2]=l;f[l>>2]=0;f[g+52>>2]=0;if(!q)t=j;else{j=q+12|0;f[j>>2]=(f[j>>2]|0)+1;t=f[h>>2]|0}if((t|0)<3){t=f[c+44>>2]|0;h=f[s>>2]|0;f[h>>2]=f[t>>2];f[h+4>>2]=f[t+4>>2]}else{f[m>>2]=0;BR(g,c)}a:do if((k|0)==(a|0)){v=k;w=16}else{c=f[p>>2]|0;t=f[f[s>>2]>>2]|0;h=k;while(1){j=c+(Y(~~(+n[h+4>>2]+.5),t)|0)+~~(+n[h>>2]+.5)|0;if(!(b[j>>0]|0)){v=h;w=16;break a}h=h+28|0;if((h|0)==(a|0)){x=a;break}}}while(0);if((w|0)==16)if((v|0)!=(a|0)){w=v+28|0;if((w|0)==(a|0))x=v;else{k=w;w=v;h=v;while(1){y=+n[w+32>>2];z=+n[k>>2];v=(f[p>>2]|0)+(Y(f[f[s>>2]>>2]|0,~~(y+.5))|0)+~~(z+.5)|0;if(!(b[v>>0]|0))A=h;else{n[h>>2]=z;n[h+4>>2]=y;v=h+8|0;t=w+36|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];f[v+8>>2]=f[t+8>>2];f[v+12>>2]=f[t+12>>2];f[v+16>>2]=f[t+16>>2];A=h+28|0}t=k+28|0;if((t|0)==(a|0)){x=A;break}else{v=k;k=t;h=A;w=v}}}}else x=a;a=f[o>>2]|0;if((x|0)!=(a|0))f[o>>2]=a+(~(((a+-28-x|0)>>>0)/28|0)*28|0);x=f[i>>2]|0;if(x|0?(a=x+12|0,x=f[a>>2]|0,f[a>>2]=x+-1,(x|0)==1):0)CR(g);f[i>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[m>>2]|0)>0){p=f[r>>2]|0;r=0;do{f[p+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[m>>2]|0))}m=f[s>>2]|0;if((m|0)!=(l|0))ZF(m)}}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function xBa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=105704;b=a+16|0;c=f[b>>2]|0;if(c|0){d=a+20|0;while(1){e=f[d>>2]|0;if((e|0)==(c|0))break;g=e+-48|0;f[d>>2]=g;j0(g)}PYa(f[b>>2]|0)}Vt(a+4|0);OF(a);return}function yBa(a){a=a|0;xBa(a);PYa(a);return}function zBa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=f[a+16>>2]|0;c=a+20|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-48|0;f[c>>2]=e;j0(e)}c=f[a+4>>2]|0;b=a+8|0;a=f[b>>2]|0;if((a|0)==(c|0))return;else g=a;do{a=g+-56|0;f[b>>2]=a;e=g+-20|0;d=f[e>>2]|0;if(d|0?(h=d+12|0,d=f[h>>2]|0,f[h>>2]=d+-1,(d|0)==1):0)CR(a);f[e>>2]=0;e=g+-40|0;a=g+-52|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[a>>2]|0)>0){e=f[g+-16>>2]|0;d=0;do{f[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[a>>2]|0))}a=f[g+-12>>2]|0;if((a|0)!=(g+-8|0))ZF(a);g=f[b>>2]|0}while((g|0)!=(c|0));return}function ABa(a,b){a=a|0;b=b|0;return}function BBa(a,b){a=a|0;b=b|0;return}function CBa(a){a=a|0;var b=0;if((f[a+4>>2]|0)!=(f[a+8>>2]|0)){b=0;return b|0}b=(f[a+16>>2]|0)==(f[a+20>>2]|0);return b|0}function DBa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+128|0;e=d+72|0;g=d+64|0;h=d+60|0;i=d+12|0;j=d+56|0;k=d+52|0;l=d+48|0;m=d+44|0;n=d+40|0;o=d+36|0;p=d+32|0;q=d+28|0;r=d+24|0;s=d+8|0;t=d+4|0;v=d;if((NS(c)|0)==720896){f[i>>2]=0;w=i+4|0;f[w>>2]=0;f[i+8>>2]=0;QS(c,i);f[j>>2]=f[a+20>>2];f[k>>2]=f[i>>2];f[l>>2]=f[w>>2];f[h>>2]=f[j>>2];f[g>>2]=f[k>>2];f[e>>2]=f[l>>2];FBa(a+16|0,h,g,e)|0;l=f[i>>2]|0;if(l|0){while(1){k=f[w>>2]|0;if((k|0)==(l|0))break;j=k+-48|0;f[w>>2]=j;j0(j)}PYa(f[i>>2]|0)}u=d;return}if((NS(c)|0)==655360){OS(e,c,-1);UI(i,1,e);j0(e);f[m>>2]=f[a+20>>2];f[n>>2]=f[i>>2];w=i+4|0;f[o>>2]=f[w>>2];f[h>>2]=f[m>>2];f[g>>2]=f[n>>2];f[e>>2]=f[o>>2];FBa(a+16|0,h,g,e)|0;o=f[i>>2]|0;if(o|0){while(1){n=f[w>>2]|0;if((n|0)==(o|0))break;m=n+-48|0;f[w>>2]=m;j0(m)}PYa(f[i>>2]|0)}u=d;return}if((NS(c)|0)==327680){f[i>>2]=0;w=i+4|0;f[w>>2]=0;f[i+8>>2]=0;PS(c,i);f[p>>2]=f[a+8>>2];f[q>>2]=f[i>>2];f[r>>2]=f[w>>2];f[h>>2]=f[p>>2];f[g>>2]=f[q>>2];f[e>>2]=f[r>>2];GBa(a+4|0,h,g,e)|0;Vt(i);u=d;return}if((NS(c)|0)!=65536){if((NS(c)|0)==655360){u=d;return}if((NS(c)|0)==720896){u=d;return}if((NS(c)|0)==65536){u=d;return}if((NS(c)|0)==327680){u=d;return}f[e>>2]=0;f[e+4>>2]=0;r=c$(e,106)|0;q=356746;p=r+106|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(p|0));j$(-215,e,356853,356857,544);d$(e);u=d;return}do if((NS(c)|0)==65536){q=f[c+4>>2]|0;f[e>>2]=f[q>>2];r=e+4|0;p=q+4|0;f[r>>2]=f[p>>2];w=e+8|0;f[w>>2]=f[q+8>>2];f[e+12>>2]=f[q+12>>2];f[e+16>>2]=f[q+16>>2];f[e+20>>2]=f[q+20>>2];f[e+24>>2]=f[q+24>>2];f[e+28>>2]=f[q+28>>2];f[e+32>>2]=f[q+32>>2];o=f[q+36>>2]|0;f[e+36>>2]=o;f[e+40>>2]=w;w=e+48|0;m=e+44|0;f[m>>2]=w;f[w>>2]=0;f[e+52>>2]=0;if(o|0){w=o+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[p>>2]|0)<3){p=f[q+44>>2]|0;w=f[m>>2]|0;f[w>>2]=f[p>>2];f[w+4>>2]=f[p+4>>2];break}else{f[r>>2]=0;BR(e,q);break}}else OR(e,c,-1);while(0);gxa(i,1,e);c=e+36|0;q=f[c>>2]|0;if(q|0?(r=q+12|0,q=f[r>>2]|0,f[r>>2]=q+-1,(q|0)==1):0)CR(e);f[c>>2]=0;c=e+16|0;q=e+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[q>>2]|0)>0){c=f[e+40>>2]|0;r=0;do{f[c+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[q>>2]|0))}q=f[e+44>>2]|0;if((q|0)!=(e+48|0))ZF(q);f[s>>2]=f[a+8>>2];f[t>>2]=f[i>>2];f[v>>2]=f[i+4>>2];f[h>>2]=f[s>>2];f[g>>2]=f[t>>2];f[e>>2]=f[v>>2];GBa(a+4|0,h,g,e)|0;Vt(i);u=d;return}function EBa(a){a=a|0;return}function FBa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=u;u=u+32|0;g=e;h=f[a>>2]|0;i=h;j=(f[b>>2]|0)-i|0;b=h+(((j|0)/48|0)*48|0)|0;h=f[c>>2]|0;k=f[d>>2]|0;d=k-h|0;l=(d|0)/48|0;m=h;n=k;if((d|0)<=0){o=b;u=e;return o|0}d=f[a+8>>2]|0;p=a+4|0;q=f[p>>2]|0;r=q;if((l|0)>((d-r|0)/48|0|0)){s=((r-i|0)/48|0)+l|0;if(s>>>0>89478485)gXa(a);t=(d-i|0)/48|0;i=t<<1;d=t>>>0<44739242?(i>>>0<s>>>0?s:i):89478485;i=(j|0)/48|0;f[g+12>>2]=0;f[g+16>>2]=a+8;do if(d)if(d>>>0>89478485){j=De(8)|0;UYa(j,358155);f[j>>2]=130560;Of(j|0,21520,875)}else{v=NYa(d*48|0)|0;break}else v=0;while(0);f[g>>2]=v;j=v+(i*48|0)|0;i=g+8|0;f[i>>2]=j;s=g+4|0;f[s>>2]=j;f[g+12>>2]=v+(d*48|0);if((m|0)!=(n|0)){d=m;v=j;j=h;while(1){f[v>>2]=f[d>>2];h=v+4|0;t=d+4|0;f[h>>2]=f[t>>2];w=v+8|0;f[w>>2]=f[d+8>>2];f[v+12>>2]=f[d+12>>2];f[v+16>>2]=f[d+16>>2];f[v+20>>2]=f[d+20>>2];x=f[d+24>>2]|0;f[v+24>>2]=x;f[v+28>>2]=f[d+28>>2];f[v+32>>2]=w;w=v+40|0;y=v+36|0;f[y>>2]=w;f[v+44>>2]=0;f[w>>2]=0;if(x|0){w=x+8|0;f[w>>2]=(f[w>>2]|0)+1}if((f[t>>2]|0)<3){t=f[d+36>>2]|0;w=f[y>>2]|0;f[w>>2]=f[t>>2];f[w+4>>2]=f[t+4>>2]}else{f[h>>2]=0;i0(v,d)}h=(f[i>>2]|0)+48|0;f[i>>2]=h;t=j+48|0;if((t|0)==(n|0))break;else{d=t;v=h;j=t}}}j=KBa(a,g,b)|0;v=f[s>>2]|0;while(1){s=f[i>>2]|0;if((s|0)==(v|0))break;d=s+-48|0;f[i>>2]=d;j0(d)}i=f[g>>2]|0;if(i|0)PYa(i);o=j;u=e;return o|0}j=r-b|0;r=(j|0)/48|0;do if((l|0)>(r|0)){i=m+(r*48|0)|0;g=i;if((i|0)!=(n|0)){v=i;i=q;d=g;while(1){f[i>>2]=f[v>>2];s=i+4|0;t=v+4|0;f[s>>2]=f[t>>2];h=i+8|0;f[h>>2]=f[v+8>>2];f[i+12>>2]=f[v+12>>2];f[i+16>>2]=f[v+16>>2];f[i+20>>2]=f[v+20>>2];w=f[v+24>>2]|0;f[i+24>>2]=w;f[i+28>>2]=f[v+28>>2];f[i+32>>2]=h;h=i+40|0;y=i+36|0;f[y>>2]=h;f[i+44>>2]=0;f[h>>2]=0;if(w|0){h=w+8|0;f[h>>2]=(f[h>>2]|0)+1}if((f[t>>2]|0)<3){t=f[v+36>>2]|0;h=f[y>>2]|0;f[h>>2]=f[t>>2];f[h+4>>2]=f[t+4>>2]}else{f[s>>2]=0;i0(i,v)}s=d+48|0;t=(f[p>>2]|0)+48|0;f[p>>2]=t;if((s|0)==(n|0))break;else{v=s;i=t;d=s}}}if((j|0)>0){z=f[c>>2]|0;A=g;break}else{o=b;u=e;return o|0}}else{z=m;A=k}while(0);JBa(a,b,q,b+(l*48|0)|0);l=A;if((z|0)==(l|0)){o=b;u=e;return o|0}else{B=b;C=z}while(1){if((B|0)!=(C|0)){z=C+24|0;A=f[z>>2]|0;if(A|0){q=A+8|0;f[q>>2]=(f[q>>2]|0)+1}q=B+24|0;A=f[q>>2]|0;if(A|0?(a=A+8|0,A=f[a>>2]|0,f[a>>2]=A+-1,(A|0)==1):0)k0(B);A=B+4|0;if((f[A>>2]|0)>0){a=f[B+32>>2]|0;k=0;do{f[a+(k<<2)>>2]=0;k=k+1|0;D=f[A>>2]|0}while((k|0)<(D|0));f[q>>2]=0;f[B>>2]=f[C>>2];if((D|0)<3)E=25;else E=27}else{f[q>>2]=0;f[B>>2]=f[C>>2];E=25}if((E|0)==25){E=0;k=f[C+4>>2]|0;if((k|0)<3){f[A>>2]=k;f[B+8>>2]=f[C+8>>2];f[B+12>>2]=f[C+12>>2];k=f[C+36>>2]|0;a=f[B+36>>2]|0;f[a>>2]=f[k>>2];f[a+4>>2]=f[k+4>>2]}else E=27}if((E|0)==27){E=0;i0(B,C)}f[B+16>>2]=f[C+16>>2];k=B+20|0;if(!(f[k>>2]|0))f[k>>2]=f[C+20>>2];f[q>>2]=f[z>>2];f[B+28>>2]=f[C+28>>2]}C=C+48|0;if((C|0)==(l|0)){o=b;break}else B=B+48|0}u=e;return o|0}function GBa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=u;u=u+32|0;g=e;h=f[a>>2]|0;i=h;j=(f[b>>2]|0)-i|0;b=h+(((j|0)/56|0)*56|0)|0;h=f[c>>2]|0;k=f[d>>2]|0;d=k-h|0;l=(d|0)/56|0;m=h;n=k;if((d|0)<=0){o=b;u=e;return o|0}d=f[a+8>>2]|0;p=a+4|0;q=f[p>>2]|0;r=q;if((l|0)>((d-r|0)/56|0|0)){s=((r-i|0)/56|0)+l|0;if(s>>>0>76695844)gXa(a);t=(d-i|0)/56|0;i=t<<1;d=t>>>0<38347922?(i>>>0<s>>>0?s:i):76695844;i=(j|0)/56|0;f[g+12>>2]=0;f[g+16>>2]=a+8;do if(d)if(d>>>0>76695844){j=De(8)|0;UYa(j,358155);f[j>>2]=130560;Of(j|0,21520,875)}else{v=NYa(d*56|0)|0;break}else v=0;while(0);f[g>>2]=v;j=v+(i*56|0)|0;i=g+8|0;f[i>>2]=j;f[g+4>>2]=j;f[g+12>>2]=v+(d*56|0);if((m|0)!=(n|0)){d=m;v=j;j=h;while(1){f[v>>2]=f[d>>2];h=v+4|0;s=d+4|0;f[h>>2]=f[s>>2];t=v+8|0;f[t>>2]=f[d+8>>2];f[v+12>>2]=f[d+12>>2];f[v+16>>2]=f[d+16>>2];f[v+20>>2]=f[d+20>>2];f[v+24>>2]=f[d+24>>2];f[v+28>>2]=f[d+28>>2];f[v+32>>2]=f[d+32>>2];w=f[d+36>>2]|0;f[v+36>>2]=w;f[v+40>>2]=t;t=v+48|0;x=v+44|0;f[x>>2]=t;f[t>>2]=0;f[v+52>>2]=0;if(w|0){t=w+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[d+44>>2]|0;t=f[x>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[h>>2]=0;BR(v,d)}h=(f[i>>2]|0)+56|0;f[i>>2]=h;s=j+56|0;if((s|0)==(n|0))break;else{d=s;v=h;j=s}}}j=IBa(a,g,b)|0;Rt(g);o=j;u=e;return o|0}j=r-b|0;r=(j|0)/56|0;do if((l|0)>(r|0)){g=m+(r*56|0)|0;v=g;if((g|0)!=(n|0)){d=g;g=q;i=v;while(1){f[g>>2]=f[d>>2];s=g+4|0;h=d+4|0;f[s>>2]=f[h>>2];t=g+8|0;f[t>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];f[g+16>>2]=f[d+16>>2];f[g+20>>2]=f[d+20>>2];f[g+24>>2]=f[d+24>>2];f[g+28>>2]=f[d+28>>2];f[g+32>>2]=f[d+32>>2];x=f[d+36>>2]|0;f[g+36>>2]=x;f[g+40>>2]=t;t=g+48|0;w=g+44|0;f[w>>2]=t;f[t>>2]=0;f[g+52>>2]=0;if(x|0){t=x+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[h>>2]|0)<3){h=f[d+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[h>>2];f[t+4>>2]=f[h+4>>2]}else{f[s>>2]=0;BR(g,d)}s=i+56|0;h=(f[p>>2]|0)+56|0;f[p>>2]=h;if((s|0)==(n|0))break;else{d=s;g=h;i=s}}}if((j|0)>0){y=f[c>>2]|0;z=v;break}else{o=b;u=e;return o|0}}else{y=m;z=k}while(0);HBa(a,b,q,b+(l*56|0)|0);l=z;if((y|0)==(l|0)){o=b;u=e;return o|0}else{A=b;B=y}while(1){if((A|0)!=(B|0)){y=B+36|0;z=f[y>>2]|0;if(z|0){q=z+12|0;f[q>>2]=(f[q>>2]|0)+1}q=A+36|0;z=f[q>>2]|0;if(z|0?(a=z+12|0,z=f[a>>2]|0,f[a>>2]=z+-1,(z|0)==1):0)CR(A);f[q>>2]=0;z=A+16|0;a=A+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[a>>2]|0)>0){k=f[A+40>>2]|0;m=0;do{f[k+(m<<2)>>2]=0;m=m+1|0;C=f[a>>2]|0}while((m|0)<(C|0));f[A>>2]=f[B>>2];if((C|0)<3)D=25;else D=27}else{f[A>>2]=f[B>>2];D=25}if((D|0)==25){D=0;m=f[B+4>>2]|0;if((m|0)<3){f[a>>2]=m;f[A+8>>2]=f[B+8>>2];f[A+12>>2]=f[B+12>>2];m=f[B+44>>2]|0;k=f[A+44>>2]|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2]}else D=27}if((D|0)==27){D=0;BR(A,B)}f[z>>2]=f[B+16>>2];f[A+20>>2]=f[B+20>>2];f[A+24>>2]=f[B+24>>2];f[A+28>>2]=f[B+28>>2];f[A+32>>2]=f[B+32>>2];f[q>>2]=f[y>>2]}B=B+56|0;if((B|0)==(l|0)){o=b;break}else A=A+56|0}u=e;return o|0}function HBa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;a=f[e>>2]|0;g=a-d|0;d=b+(((g|0)/56|0)*56|0)|0;if(d>>>0<c>>>0){h=a;i=d;do{f[h>>2]=f[i>>2];j=h+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=h+8|0;f[l>>2]=f[i+8>>2];f[h+12>>2]=f[i+12>>2];f[h+16>>2]=f[i+16>>2];f[h+20>>2]=f[i+20>>2];f[h+24>>2]=f[i+24>>2];f[h+28>>2]=f[i+28>>2];f[h+32>>2]=f[i+32>>2];m=f[i+36>>2]|0;f[h+36>>2]=m;f[h+40>>2]=l;l=h+48|0;n=h+44|0;f[n>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;BR(h,i)}i=i+56|0;h=(f[e>>2]|0)+56|0;f[e>>2]=h}while(i>>>0<c>>>0)}if(!g)return;else{o=d;p=a}do{a=o;o=o+-56|0;d=p;p=p+-56|0;if((d|0)!=(a|0)){g=a+-20|0;c=f[g>>2]|0;if(c|0){i=c+12|0;f[i>>2]=(f[i>>2]|0)+1}i=d+-20|0;c=f[i>>2]|0;if(c|0?(h=c+12|0,c=f[h>>2]|0,f[h>>2]=c+-1,(c|0)==1):0)CR(p);f[i>>2]=0;c=d+-40|0;h=d+-52|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[h>>2]|0)>0){e=f[d+-16>>2]|0;j=0;do{f[e+(j<<2)>>2]=0;j=j+1|0;q=f[h>>2]|0}while((j|0)<(q|0));f[p>>2]=f[o>>2];if((q|0)<3)r=15;else r=17}else{f[p>>2]=f[o>>2];r=15}if((r|0)==15){r=0;j=f[a+-52>>2]|0;if((j|0)<3){f[h>>2]=j;f[d+-48>>2]=f[a+-48>>2];f[d+-44>>2]=f[a+-44>>2];j=f[a+-12>>2]|0;e=f[d+-12>>2]|0;f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2]}else r=17}if((r|0)==17){r=0;BR(p,o)}f[c>>2]=f[a+-40>>2];f[d+-36>>2]=f[a+-36>>2];f[d+-32>>2]=f[a+-32>>2];f[d+-28>>2]=f[a+-28>>2];f[d+-24>>2]=f[a+-24>>2];f[i>>2]=f[g>>2]}}while((o|0)!=(b|0));return}function IBa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=b+4|0;e=f[d>>2]|0;g=f[a>>2]|0;if((g|0)==(c|0))h=e;else{i=e;j=c;while(1){k=i+-56|0;l=j;j=j+-56|0;f[k>>2]=f[j>>2];m=i+-52|0;n=l+-52|0;f[m>>2]=f[n>>2];o=i+-48|0;f[o>>2]=f[l+-48>>2];f[i+-44>>2]=f[l+-44>>2];f[i+-40>>2]=f[l+-40>>2];f[i+-36>>2]=f[l+-36>>2];f[i+-32>>2]=f[l+-32>>2];f[i+-28>>2]=f[l+-28>>2];f[i+-24>>2]=f[l+-24>>2];p=f[l+-20>>2]|0;f[i+-20>>2]=p;f[i+-16>>2]=o;o=i+-8|0;q=i+-12|0;f[q>>2]=o;f[o>>2]=0;f[i+-4>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[l+-12>>2]|0;l=f[q>>2]|0;f[l>>2]=f[n>>2];f[l+4>>2]=f[n+4>>2]}else{f[m>>2]=0;BR(k,j)}k=(f[d>>2]|0)+-56|0;f[d>>2]=k;if((j|0)==(g|0)){h=k;break}else i=k}}i=a+4|0;g=f[i>>2]|0;j=b+8|0;if((g|0)==(c|0)){r=d;s=h;t=f[a>>2]|0;f[a>>2]=s;f[r>>2]=t;u=f[i>>2]|0;v=f[j>>2]|0;f[i>>2]=v;f[j>>2]=u;w=a+8|0;x=b+12|0;y=f[w>>2]|0;z=f[x>>2]|0;f[w>>2]=z;f[x>>2]=y;A=f[r>>2]|0;f[b>>2]=A;return e|0}h=f[j>>2]|0;k=c;do{f[h>>2]=f[k>>2];c=h+4|0;m=k+4|0;f[c>>2]=f[m>>2];n=h+8|0;f[n>>2]=f[k+8>>2];f[h+12>>2]=f[k+12>>2];f[h+16>>2]=f[k+16>>2];f[h+20>>2]=f[k+20>>2];f[h+24>>2]=f[k+24>>2];f[h+28>>2]=f[k+28>>2];f[h+32>>2]=f[k+32>>2];l=f[k+36>>2]|0;f[h+36>>2]=l;f[h+40>>2]=n;n=h+48|0;q=h+44|0;f[q>>2]=n;f[n>>2]=0;f[h+52>>2]=0;if(l|0){n=l+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[k+44>>2]|0;n=f[q>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2]}else{f[c>>2]=0;BR(h,k)}k=k+56|0;h=(f[j>>2]|0)+56|0;f[j>>2]=h}while((k|0)!=(g|0));r=d;s=f[d>>2]|0;t=f[a>>2]|0;f[a>>2]=s;f[r>>2]=t;u=f[i>>2]|0;v=f[j>>2]|0;f[i>>2]=v;f[j>>2]=u;w=a+8|0;x=b+12|0;y=f[w>>2]|0;z=f[x>>2]|0;f[w>>2]=z;f[x>>2]=y;A=f[r>>2]|0;f[b>>2]=A;return e|0}function JBa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;a=f[e>>2]|0;g=a-d|0;d=b+(((g|0)/48|0)*48|0)|0;if(d>>>0<c>>>0){h=a;i=d;do{f[h>>2]=f[i>>2];j=h+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=h+8|0;f[l>>2]=f[i+8>>2];f[h+12>>2]=f[i+12>>2];f[h+16>>2]=f[i+16>>2];f[h+20>>2]=f[i+20>>2];m=f[i+24>>2]|0;f[h+24>>2]=m;f[h+28>>2]=f[i+28>>2];f[h+32>>2]=l;l=h+40|0;n=h+36|0;f[n>>2]=l;f[h+44>>2]=0;f[l>>2]=0;if(m|0){l=m+8|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+36>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;i0(h,i)}i=i+48|0;h=(f[e>>2]|0)+48|0;f[e>>2]=h}while(i>>>0<c>>>0)}if(!g)return;else{o=d;p=a}do{a=o;o=o+-48|0;d=p;p=p+-48|0;if((d|0)!=(a|0)){g=a+-24|0;c=f[g>>2]|0;if(c|0){i=c+8|0;f[i>>2]=(f[i>>2]|0)+1}i=d+-24|0;c=f[i>>2]|0;if(c|0?(h=c+8|0,c=f[h>>2]|0,f[h>>2]=c+-1,(c|0)==1):0)k0(p);c=d+-44|0;if((f[c>>2]|0)>0){h=f[d+-16>>2]|0;e=0;do{f[h+(e<<2)>>2]=0;e=e+1|0;q=f[c>>2]|0}while((e|0)<(q|0));f[i>>2]=0;f[p>>2]=f[o>>2];if((q|0)<3)r=15;else r=17}else{f[i>>2]=0;f[p>>2]=f[o>>2];r=15}if((r|0)==15){r=0;e=f[a+-44>>2]|0;if((e|0)<3){f[c>>2]=e;f[d+-40>>2]=f[a+-40>>2];f[d+-36>>2]=f[a+-36>>2];e=f[a+-12>>2]|0;h=f[d+-12>>2]|0;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2]}else r=17}if((r|0)==17){r=0;i0(p,o)}f[d+-32>>2]=f[a+-32>>2];e=d+-28|0;if(!(f[e>>2]|0))f[e>>2]=f[a+-28>>2];f[i>>2]=f[g>>2];f[d+-20>>2]=f[a+-20>>2]}}while((o|0)!=(b|0));return}function KBa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=b+4|0;e=f[d>>2]|0;g=f[a>>2]|0;if((g|0)==(c|0))h=e;else{i=e;j=c;while(1){k=i+-48|0;l=j;j=j+-48|0;f[k>>2]=f[j>>2];m=i+-44|0;n=l+-44|0;f[m>>2]=f[n>>2];o=i+-40|0;f[o>>2]=f[l+-40>>2];f[i+-36>>2]=f[l+-36>>2];f[i+-32>>2]=f[l+-32>>2];f[i+-28>>2]=f[l+-28>>2];p=f[l+-24>>2]|0;f[i+-24>>2]=p;f[i+-20>>2]=f[l+-20>>2];f[i+-16>>2]=o;o=i+-8|0;q=i+-12|0;f[q>>2]=o;f[i+-4>>2]=0;f[o>>2]=0;if(p|0){o=p+8|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[l+-12>>2]|0;l=f[q>>2]|0;f[l>>2]=f[n>>2];f[l+4>>2]=f[n+4>>2]}else{f[m>>2]=0;i0(k,j)}k=(f[d>>2]|0)+-48|0;f[d>>2]=k;if((j|0)==(g|0)){h=k;break}else i=k}}i=a+4|0;g=f[i>>2]|0;j=b+8|0;if((g|0)==(c|0)){r=d;s=h;t=f[a>>2]|0;f[a>>2]=s;f[r>>2]=t;u=f[i>>2]|0;v=f[j>>2]|0;f[i>>2]=v;f[j>>2]=u;w=a+8|0;x=b+12|0;y=f[w>>2]|0;z=f[x>>2]|0;f[w>>2]=z;f[x>>2]=y;A=f[r>>2]|0;f[b>>2]=A;return e|0}h=f[j>>2]|0;k=c;do{f[h>>2]=f[k>>2];c=h+4|0;m=k+4|0;f[c>>2]=f[m>>2];n=h+8|0;f[n>>2]=f[k+8>>2];f[h+12>>2]=f[k+12>>2];f[h+16>>2]=f[k+16>>2];f[h+20>>2]=f[k+20>>2];l=f[k+24>>2]|0;f[h+24>>2]=l;f[h+28>>2]=f[k+28>>2];f[h+32>>2]=n;n=h+40|0;q=h+36|0;f[q>>2]=n;f[h+44>>2]=0;f[n>>2]=0;if(l|0){n=l+8|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[k+36>>2]|0;n=f[q>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2]}else{f[c>>2]=0;i0(h,k)}k=k+48|0;h=(f[j>>2]|0)+48|0;f[j>>2]=h}while((k|0)!=(g|0));r=d;s=f[d>>2]|0;t=f[a>>2]|0;f[a>>2]=s;f[r>>2]=t;u=f[i>>2]|0;v=f[j>>2]|0;f[i>>2]=v;f[j>>2]=u;w=a+8|0;x=b+12|0;y=f[w>>2]|0;z=f[x>>2]|0;f[w>>2]=z;f[x>>2]=y;A=f[r>>2]|0;f[b>>2]=A;return e|0}function LBa(a){a=a|0;xBa(a);PYa(a);return}function MBa(a){a=a|0;return 1}function NBa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;e=u;u=u+128|0;g=e+112|0;h=e+56|0;i=e;j=NYa(36)|0;k=f[c+28>>2]|0;l=b[c+32>>0]|0;WF(j);m=j+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[j>>2]=105768;f[j+28>>2]=k;b[j+32>>0]=l;l=NYa(16)|0;k=l+4|0;f[k>>2]=1;f[l>>2]=105832;f[l+8>>2]=j;n=l;o=j;if(!d?(d=c+4|0,j=c+8|0,gS(m,((f[j>>2]|0)-(f[d>>2]|0)|0)/56|0),c=f[d>>2]|0,d=f[j>>2]|0,(c|0)!=(d|0)):0){j=i+4|0;p=i+8|0;q=i+12|0;r=i+16|0;s=i+20|0;t=i+24|0;v=i+28|0;w=i+32|0;x=i+36|0;y=i+40|0;z=i+48|0;A=i+44|0;B=i+52|0;C=h+36|0;D=h+16|0;E=h+4|0;F=h+40|0;G=h+44|0;H=h+48|0;I=h+8|0;J=h+12|0;K=h+20|0;L=h+24|0;M=h+28|0;N=h+32|0;O=h+52|0;P=g+8|0;Q=g+4|0;R=f[m>>2]|0;m=c;while(1){f[i>>2]=f[m>>2];c=m+4|0;f[j>>2]=f[c>>2];f[p>>2]=f[m+8>>2];f[q>>2]=f[m+12>>2];f[r>>2]=f[m+16>>2];f[s>>2]=f[m+20>>2];f[t>>2]=f[m+24>>2];f[v>>2]=f[m+28>>2];f[w>>2]=f[m+32>>2];S=f[m+36>>2]|0;f[x>>2]=S;f[y>>2]=p;f[A>>2]=z;f[z>>2]=0;f[B>>2]=0;if(S|0){T=S+12|0;f[T>>2]=(f[T>>2]|0)+1}if((f[c>>2]|0)<3){c=f[m+44>>2]|0;T=f[A>>2]|0;f[T>>2]=f[c>>2];f[T+4>>2]=f[c+4>>2]}else{f[j>>2]=0;BR(i,m)}f[h>>2]=1124007936;c=E;T=c+36|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(T|0));f[F>>2]=I;f[G>>2]=H;f[H>>2]=0;f[O>>2]=0;c=P;f[c>>2]=0;f[c+4>>2]=0;f[g>>2]=33619968;f[Q>>2]=h;eL(i,g);if((R|0)!=(h|0)){c=f[C>>2]|0;if(c|0){T=c+12|0;f[T>>2]=(f[T>>2]|0)+1}T=R+36|0;c=f[T>>2]|0;if(c|0?(S=c+12|0,c=f[S>>2]|0,f[S>>2]=c+-1,(c|0)==1):0)CR(R);f[T>>2]=0;c=R+16|0;S=R+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[S>>2]|0)>0){U=f[R+40>>2]|0;V=0;do{f[U+(V<<2)>>2]=0;V=V+1|0;W=f[S>>2]|0}while((V|0)<(W|0));f[R>>2]=f[h>>2];if((W|0)<3)X=20;else X=22}else{f[R>>2]=f[h>>2];X=20}if((X|0)==20){X=0;V=f[E>>2]|0;if((V|0)<3){f[S>>2]=V;f[R+8>>2]=f[I>>2];f[R+12>>2]=f[J>>2];V=f[G>>2]|0;U=f[R+44>>2]|0;f[U>>2]=f[V>>2];f[U+4>>2]=f[V+4>>2]}else X=22}if((X|0)==22){X=0;BR(R,h)}f[c>>2]=f[D>>2];f[R+20>>2]=f[K>>2];f[R+24>>2]=f[L>>2];f[R+28>>2]=f[M>>2];f[R+32>>2]=f[N>>2];f[T>>2]=f[C>>2]}V=f[C>>2]|0;if(V|0?(U=V+12|0,V=f[U>>2]|0,f[U>>2]=V+-1,(V|0)==1):0)CR(h);f[C>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[E>>2]|0)>0){V=f[F>>2]|0;U=0;do{f[V+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[E>>2]|0))}U=f[G>>2]|0;if((U|0)!=(H|0))ZF(U);U=f[x>>2]|0;if(U|0?(V=U+12|0,U=f[V>>2]|0,f[V>>2]=U+-1,(U|0)==1):0)CR(i);f[x>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[j>>2]|0)>0){U=f[y>>2]|0;V=0;do{f[U+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[j>>2]|0))}V=f[A>>2]|0;if((V|0)!=(z|0))ZF(V);m=m+56|0;if((m|0)==(d|0))break;else R=R+56|0}}f[a>>2]=n;f[a+4>>2]=o;f[k>>2]=(f[k>>2]|0)+1;o=f[k>>2]|0;f[k>>2]=o+-1;if((o|0)!=1){u=e;return}ki[f[(f[l>>2]|0)+8>>2]&2047](l);u=e;return}function OBa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;i=u;u=u+368|0;j=i+344|0;k=i+288|0;l=i+232|0;m=i+176|0;n=i+120|0;o=i+104|0;p=i+88|0;q=i+72|0;r=i+56|0;s=i;t=a+4|0;v=f[t>>2]|0;w=a+8|0;if((v|0)==(f[w>>2]|0))x=f[a+16>>2]|0;else x=v;v=f[x>>2]&4095;if((RR(c,-1)|0)!=(v|0)){f[j>>2]=0;f[j+4>>2]=0;y=c$(j,41)|0;z=356938;A=y+41|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));j$(-215,j,356996,356857,744);d$(j)}do if(!(XS(c)|0)){if((f[t>>2]|0)==(f[w>>2]|0)?(f[a+16>>2]|0)==(f[a+20>>2]|0):0)break;f[j>>2]=0;v=j+4|0;f[v>>2]=0;f[j+8>>2]=0;PS(g,j);if((f[t>>2]|0)!=(f[w>>2]|0)?(x=a+16|0,B=f[x>>2]|0,C=a+20|0,D=f[C>>2]|0,(B|0)!=(D|0)):0){if((D-B|0)>0){E=k+4|0;F=k+8|0;G=k+40|0;H=k+48|0;I=k+44|0;K=k+52|0;L=l+8|0;M=l+4|0;N=a+12|0;O=k+36|0;P=k+16|0;Q=k+12|0;R=k+20|0;S=k+24|0;T=k+28|0;U=k+32|0;V=B;W=0;do{f[k>>2]=1124007936;y=E;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[G>>2]=F;f[I>>2]=H;f[H>>2]=0;f[K>>2]=0;X=L;f[X>>2]=0;f[X+4>>2]=0;f[l>>2]=33619968;f[M>>2]=k;p0(V+(W*48|0)|0,l);X=f[w>>2]|0;if((X|0)==(f[N>>2]|0))xwa(t,k);else{f[X>>2]=f[k>>2];Z=X+4|0;f[Z>>2]=f[E>>2];_=X+8|0;f[_>>2]=f[F>>2];f[X+12>>2]=f[Q>>2];f[X+16>>2]=f[P>>2];f[X+20>>2]=f[R>>2];f[X+24>>2]=f[S>>2];f[X+28>>2]=f[T>>2];f[X+32>>2]=f[U>>2];$=f[O>>2]|0;f[X+36>>2]=$;f[X+40>>2]=_;_=X+48|0;aa=X+44|0;f[aa>>2]=_;f[_>>2]=0;f[X+52>>2]=0;if($|0){_=$+12|0;f[_>>2]=(f[_>>2]|0)+1}if((f[E>>2]|0)<3){_=f[I>>2]|0;$=f[aa>>2]|0;f[$>>2]=f[_>>2];f[$+4>>2]=f[_+4>>2]}else{f[Z>>2]=0;BR(X,k)}f[w>>2]=(f[w>>2]|0)+56}X=f[O>>2]|0;if(X|0?(Z=X+12|0,X=f[Z>>2]|0,f[Z>>2]=X+-1,(X|0)==1):0)CR(k);f[O>>2]=0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[E>>2]|0)>0){X=f[G>>2]|0;Z=0;do{f[X+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[E>>2]|0))}Z=f[I>>2]|0;if((Z|0)!=(H|0))ZF(Z);W=W+1|0;ba=f[C>>2]|0;Z=f[x>>2]|0;V=Z}while((W|0)<((ba-Z|0)/48|0|0));ca=ba;da=V}else{ca=D;da=B}if((ca|0)!=(da|0)){W=ca;do{x=W+-48|0;f[C>>2]=x;j0(x);W=f[C>>2]|0}while((W|0)!=(da|0))}}do if((NS(c)|0)==65536){W=f[c+4>>2]|0;f[k>>2]=f[W>>2];C=k+4|0;B=W+4|0;f[C>>2]=f[B>>2];D=k+8|0;f[D>>2]=f[W+8>>2];f[k+12>>2]=f[W+12>>2];f[k+16>>2]=f[W+16>>2];f[k+20>>2]=f[W+20>>2];f[k+24>>2]=f[W+24>>2];f[k+28>>2]=f[W+28>>2];f[k+32>>2]=f[W+32>>2];V=f[W+36>>2]|0;f[k+36>>2]=V;f[k+40>>2]=D;D=k+48|0;x=k+44|0;f[x>>2]=D;f[D>>2]=0;f[k+52>>2]=0;if(V|0){D=V+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[B>>2]|0)<3){B=f[W+44>>2]|0;D=f[x>>2]|0;f[D>>2]=f[B>>2];f[D+4>>2]=f[B+4>>2];break}else{f[C>>2]=0;BR(k,W);break}}else OR(k,c,-1);while(0);if((f[t>>2]|0)==(f[w>>2]|0)?(W=a+16|0,C=f[W>>2]|0,B=a+20|0,D=f[B>>2]|0,(C|0)!=(D|0)):0){if((D-C|0)>0){x=l+4|0;V=l+8|0;H=l+40|0;I=l+48|0;E=l+44|0;G=l+52|0;P=m+8|0;O=m+4|0;U=a+12|0;T=l+36|0;S=l+16|0;R=l+12|0;Q=l+20|0;F=l+24|0;N=l+28|0;M=l+32|0;L=C;K=0;do{f[l>>2]=1124007936;y=x;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[H>>2]=V;f[E>>2]=I;f[I>>2]=0;f[G>>2]=0;Z=P;f[Z>>2]=0;f[Z+4>>2]=0;f[m>>2]=33619968;f[O>>2]=l;p0(L+(K*48|0)|0,m);Z=f[w>>2]|0;if((Z|0)==(f[U>>2]|0))xwa(t,l);else{f[Z>>2]=f[l>>2];X=Z+4|0;f[X>>2]=f[x>>2];_=Z+8|0;f[_>>2]=f[V>>2];f[Z+12>>2]=f[R>>2];f[Z+16>>2]=f[S>>2];f[Z+20>>2]=f[Q>>2];f[Z+24>>2]=f[F>>2];f[Z+28>>2]=f[N>>2];f[Z+32>>2]=f[M>>2];$=f[T>>2]|0;f[Z+36>>2]=$;f[Z+40>>2]=_;_=Z+48|0;aa=Z+44|0;f[aa>>2]=_;f[_>>2]=0;f[Z+52>>2]=0;if($|0){_=$+12|0;f[_>>2]=(f[_>>2]|0)+1}if((f[x>>2]|0)<3){_=f[E>>2]|0;$=f[aa>>2]|0;f[$>>2]=f[_>>2];f[$+4>>2]=f[_+4>>2]}else{f[X>>2]=0;BR(Z,l)}f[w>>2]=(f[w>>2]|0)+56}Z=f[T>>2]|0;if(Z|0?(X=Z+12|0,Z=f[X>>2]|0,f[X>>2]=Z+-1,(Z|0)==1):0)CR(l);f[T>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[x>>2]|0)>0){Z=f[H>>2]|0;X=0;do{f[Z+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[x>>2]|0))}X=f[E>>2]|0;if((X|0)!=(I|0))ZF(X);K=K+1|0;ea=f[B>>2]|0;X=f[W>>2]|0;L=X}while((K|0)<((ea-X|0)/48|0|0));fa=ea;ga=L}else{fa=D;ga=C}if((fa|0)!=(ga|0)){K=fa;do{W=K+-48|0;f[B>>2]=W;j0(W);K=f[B>>2]|0}while((K|0)!=(ga|0))}}K=k+8|0;UBa(d,f[K>>2]|0);f[l>>2]=1124007936;B=l+4|0;C=l+8|0;D=l+40|0;y=B;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[D>>2]=C;L=l+48|0;W=l+44|0;f[W>>2]=L;f[L>>2]=0;f[l+52>>2]=0;f[m>>2]=1124007936;I=m+4|0;E=m+8|0;x=m+40|0;y=I;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[x>>2]=E;H=m+48|0;S=m+44|0;f[S>>2]=H;f[H>>2]=0;f[m+52>>2]=0;T=(f[w>>2]|0)-(f[t>>2]|0)|0;M=(T|0)/56|0;N=a+28|0;switch(f[N>>2]|0){case 7:case 6:{ha=1;break}case 2:{ha=(f[k>>2]&4095|0)==0;break}default:ha=0}F=ha?4:5;Q=R1a(M|0,((M|0)<0)<<31>>31|0,18)|0;R=J;if(!((R|0)<0|(R|0)==0&Q>>>0<2147483647)){f[n>>2]=0;f[n+4>>2]=0;y=c$(n,39)|0;z=357009;A=y+39|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));j$(-215,n,356996,356857,839);d$(n)}if((T|0)>0){E=n+8|0;Q=n+12|0;R=n+4|0;V=o+8|0;U=o+12|0;O=o+4|0;P=p+8|0;G=p+4|0;X=q+8|0;Z=q+4|0;_=s+4|0;$=s+8|0;aa=s+40|0;ia=s+48|0;ja=s+44|0;ka=s+52|0;la=r+8|0;ma=r+12|0;na=r+4|0;oa=a+32|0;pa=s+36|0;qa=s+16|0;ra=s+12|0;sa=s+20|0;ta=s+24|0;ua=s+28|0;va=s+32|0;wa=n+4|0;xa=0;ya=0;while(1){za=f[t>>2]|0;if((f[za+(xa*56|0)+8>>2]|0)<262144)Aa=za;else{f[n>>2]=0;f[wa>>2]=0;y=c$(n,43)|0;z=357049;A=y+43|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));j$(-215,n,356996,356857,843);d$(n);Aa=f[t>>2]|0}f[E>>2]=0;f[Q>>2]=0;f[n>>2]=16842752;f[R>>2]=k;f[V>>2]=0;f[U>>2]=0;f[o>>2]=16842752;f[O>>2]=Aa+(xa*56|0);za=P;f[za>>2]=0;f[za+4>>2]=0;f[p>>2]=33619968;f[G>>2]=l;za=X;f[za>>2]=0;f[za+4>>2]=0;f[q>>2]=33619968;f[Z>>2]=m;za=f[N>>2]|0;Ba=f[j>>2]|0;do if((Ba|0)!=(f[v>>2]|0)){Ca=Ba+(xa*56|0)|0;f[s>>2]=f[Ca>>2];Da=Ba+(xa*56|0)+4|0;f[_>>2]=f[Da>>2];f[$>>2]=f[Ba+(xa*56|0)+8>>2];f[ra>>2]=f[Ba+(xa*56|0)+12>>2];f[qa>>2]=f[Ba+(xa*56|0)+16>>2];f[sa>>2]=f[Ba+(xa*56|0)+20>>2];f[ta>>2]=f[Ba+(xa*56|0)+24>>2];f[ua>>2]=f[Ba+(xa*56|0)+28>>2];f[va>>2]=f[Ba+(xa*56|0)+32>>2];Ea=f[Ba+(xa*56|0)+36>>2]|0;f[pa>>2]=Ea;f[aa>>2]=$;f[ja>>2]=ia;f[ia>>2]=0;f[ka>>2]=0;if(Ea|0){Fa=Ea+12|0;f[Fa>>2]=(f[Fa>>2]|0)+1}if((f[Da>>2]|0)<3){Da=f[Ba+(xa*56|0)+44>>2]|0;Fa=f[ja>>2]|0;f[Fa>>2]=f[Da>>2];f[Fa+4>>2]=f[Da+4>>2];break}else{f[_>>2]=0;BR(s,Ca);break}}else{f[s>>2]=1124007936;y=_;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[aa>>2]=$;f[ja>>2]=ia;f[ia>>2]=0;f[ka>>2]=0}while(0);f[la>>2]=0;f[ma>>2]=0;f[r>>2]=16842752;f[na>>2]=s;N_(n,o,p,F,q,za,e,r,ya,(b[oa>>0]|0)!=0);Ba=f[pa>>2]|0;if(Ba|0?(Ca=Ba+12|0,Ba=f[Ca>>2]|0,f[Ca>>2]=Ba+-1,(Ba|0)==1):0)CR(s);f[pa>>2]=0;f[qa>>2]=0;f[qa+4>>2]=0;f[qa+8>>2]=0;f[qa+12>>2]=0;if((f[_>>2]|0)>0){Ba=f[aa>>2]|0;Ca=0;do{f[Ba+(Ca<<2)>>2]=0;Ca=Ca+1|0}while((Ca|0)<(f[_>>2]|0))}Ca=f[ja>>2]|0;if((Ca|0)!=(ia|0))ZF(Ca);xa=xa+1|0;if((xa|0)>=(M|0))break;else ya=ya+262144|0}}if(ha){f[n>>2]=1124007936;ya=n+4|0;M=n+8|0;xa=n+40|0;y=ya;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[xa>>2]=M;ia=n+48|0;ja=n+44|0;f[ja>>2]=ia;f[ia>>2]=0;f[n+52>>2]=0;_=o+8|0;f[_>>2]=0;f[_+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=n;WJ(l,o,5,1.0,0.0);_=n+36|0;aa=f[_>>2]|0;if(aa|0){qa=aa+12|0;f[qa>>2]=(f[qa>>2]|0)+1}qa=l+36|0;aa=f[qa>>2]|0;if(aa|0?(pa=aa+12|0,aa=f[pa>>2]|0,f[pa>>2]=aa+-1,(aa|0)==1):0)CR(l);f[qa>>2]=0;aa=l+16|0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[B>>2]|0)>0){pa=f[D>>2]|0;oa=0;do{f[pa+(oa<<2)>>2]=0;oa=oa+1|0;Ga=f[B>>2]|0}while((oa|0)<(Ga|0));f[l>>2]=f[n>>2];if((Ga|0)<3)Ha=108;else Ha=110}else{f[l>>2]=f[n>>2];Ha=108}if((Ha|0)==108){oa=f[ya>>2]|0;if((oa|0)<3){f[B>>2]=oa;f[C>>2]=f[M>>2];f[l+12>>2]=f[n+12>>2];oa=f[ja>>2]|0;pa=f[W>>2]|0;f[pa>>2]=f[oa>>2];f[pa+4>>2]=f[oa+4>>2]}else Ha=110}if((Ha|0)==110)BR(l,n);oa=n+16|0;f[aa>>2]=f[oa>>2];f[l+20>>2]=f[n+20>>2];f[l+24>>2]=f[n+24>>2];f[l+28>>2]=f[n+28>>2];f[l+32>>2]=f[n+32>>2];pa=f[_>>2]|0;f[qa>>2]=pa;if(pa|0?(F=pa+12|0,pa=f[F>>2]|0,f[F>>2]=pa+-1,(pa|0)==1):0)CR(n);f[_>>2]=0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((f[ya>>2]|0)>0){oa=f[xa>>2]|0;pa=0;do{f[oa+(pa<<2)>>2]=0;pa=pa+1|0}while((pa|0)<(f[ya>>2]|0))}ya=f[ja>>2]|0;if((ya|0)!=(ia|0))ZF(ya)}a:do if((f[K>>2]|0)>0){ya=l+16|0;pa=m+16|0;oa=n+4|0;xa=n+8|0;_=d+4|0;qa=d+8|0;aa=m+12|0;M=h^1;C=n+4|0;F=n+8|0;na=n+12|0;ma=0;while(1){la=(f[ya>>2]|0)+(Y(f[f[W>>2]>>2]|0,ma)|0)|0;ka=(f[pa>>2]|0)+(Y(f[f[S>>2]>>2]|0,ma)|0)|0;f[n>>2]=0;f[oa>>2]=0;f[xa>>2]=0;Ia=f[_>>2]|0;if((Ia|0)==(f[qa>>2]|0)){VBa(d,n);Ja=f[n>>2]|0}else{f[Ia>>2]=0;$=Ia+4|0;f[$>>2]=0;f[Ia+8>>2]=0;va=f[n>>2]|0;ua=(f[oa>>2]|0)-va|0;ta=ua>>4;if(ta){if(ta>>>0>268435455)break;sa=NYa(ua)|0;f[$>>2]=sa;f[Ia>>2]=sa;f[Ia+8>>2]=sa+(ta<<4);ta=f[n>>2]|0;ua=(f[oa>>2]|0)-ta|0;if((ua|0)>0){K1a(sa|0,ta|0,ua|0)|0;f[$>>2]=sa+(ua>>>4<<4);Ka=ta}else Ka=ta}else Ka=va;f[_>>2]=(f[_>>2]|0)+12;Ja=Ka}if(Ja|0){va=f[oa>>2]|0;if((va|0)!=(Ja|0))f[oa>>2]=va+(~((va+-16-Ja|0)>>>4)<<4);PYa(Ja)}va=f[_>>2]|0;ta=va+-12|0;WBa(ta,e);ua=va+-8|0;b:do if((f[aa>>2]|0)>0){sa=va+-4|0;$=0;do{ra=f[ka+($<<2)>>2]|0;if((ra|0)<0)break b;v=f[la+($<<2)>>2]|0;f[n>>2]=ma;f[C>>2]=ra&262143;f[F>>2]=ra>>>18;f[na>>2]=v;v=f[ua>>2]|0;if((v|0)==(f[sa>>2]|0))mY(ta,n);else{f[v>>2]=f[n>>2];f[v+4>>2]=f[n+4>>2];f[v+8>>2]=f[n+8>>2];f[v+12>>2]=f[n+12>>2];f[ua>>2]=(f[ua>>2]|0)+16}$=$+1|0}while(($|0)<(f[aa>>2]|0))}while(0);if(!((f[ta>>2]|0)!=(f[ua>>2]|0)|M)){la=f[_>>2]|0;ka=la+-12|0;va=la;while(1){la=va+-12|0;f[_>>2]=la;$=f[la>>2]|0;if(!$)La=la;else{la=va+-8|0;sa=f[la>>2]|0;if((sa|0)!=($|0))f[la>>2]=sa+(~((sa+-16-$|0)>>>4)<<4);PYa($);La=f[_>>2]|0}if((La|0)==(ka|0))break;else va=La}}ma=ma+1|0;if((ma|0)>=(f[K>>2]|0))break a}gXa(Ia)}while(0);K=m+36|0;ia=f[K>>2]|0;if(ia|0?(ja=ia+12|0,ia=f[ja>>2]|0,f[ja>>2]=ia+-1,(ia|0)==1):0)CR(m);f[K>>2]=0;K=m+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[I>>2]|0)>0){K=f[x>>2]|0;ia=0;do{f[K+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[I>>2]|0))}I=f[S>>2]|0;if((I|0)!=(H|0))ZF(I);I=l+36|0;ia=f[I>>2]|0;if(ia|0?(K=ia+12|0,ia=f[K>>2]|0,f[K>>2]=ia+-1,(ia|0)==1):0)CR(l);f[I>>2]=0;I=l+16|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[B>>2]|0)>0){I=f[D>>2]|0;ia=0;do{f[I+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[B>>2]|0))}B=f[W>>2]|0;if((B|0)!=(L|0))ZF(B);B=k+36|0;ia=f[B>>2]|0;do if(ia|0){I=ia+12|0;D=f[I>>2]|0;f[I>>2]=D+-1;if((D|0)!=1)break;CR(k)}while(0);f[B>>2]=0;ia=k+16|0;L=k+4|0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[L>>2]|0)>0){ia=f[k+40>>2]|0;W=0;do{f[ia+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[L>>2]|0))}L=f[k+44>>2]|0;if((L|0)!=(k+48|0))ZF(L);Vt(j);u=i;return}while(0);j=f[d>>2]|0;k=d+4|0;d=f[k>>2]|0;if((d|0)==(j|0)){u=i;return}else Ma=d;while(1){d=Ma+-12|0;f[k>>2]=d;l=f[d>>2]|0;if(!l)Na=d;else{d=Ma+-8|0;m=f[d>>2]|0;if((m|0)!=(l|0))f[d>>2]=m+(~((m+-16-l|0)>>>4)<<4);PYa(l);Na=f[k>>2]|0}if((Na|0)==(j|0))break;else Ma=Na}u=i;return}function PBa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0.0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0;i=u;u=u+352|0;j=i;k=i+328|0;l=i+272|0;m=i+216|0;o=i+160|0;p=i+144|0;q=i+128|0;r=i+112|0;s=i+56|0;t=a+4|0;v=f[t>>2]|0;w=a+8|0;if((v|0)==(f[w>>2]|0))x=f[a+16>>2]|0;else x=v;v=f[x>>2]&4095;if((RR(c,-1)|0)!=(v|0)){f[j>>2]=0;f[j+4>>2]=0;y=c$(j,41)|0;v=356938;z=y+41|0;do{b[y>>0]=b[v>>0]|0;y=y+1|0;v=v+1|0}while((y|0)<(z|0));j$(-215,j,356980,356857,895);d$(j)}do if(!(XS(c)|0)){if((f[t>>2]|0)==(f[w>>2]|0)?(f[a+16>>2]|0)==(f[a+20>>2]|0):0)break;f[k>>2]=0;v=k+4|0;f[v>>2]=0;f[k+8>>2]=0;PS(g,k);if((f[t>>2]|0)!=(f[w>>2]|0)?(x=a+16|0,A=f[x>>2]|0,B=a+20|0,C=f[B>>2]|0,(A|0)!=(C|0)):0){if((C-A|0)>0){D=j+4|0;E=j+8|0;F=j+40|0;G=j+48|0;H=j+44|0;I=j+52|0;J=l+8|0;K=l+4|0;L=a+12|0;M=j+36|0;N=j+16|0;O=j+12|0;P=j+20|0;Q=j+24|0;R=j+28|0;S=j+32|0;T=A;U=0;do{f[j>>2]=1124007936;y=D;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[F>>2]=E;f[H>>2]=G;f[G>>2]=0;f[I>>2]=0;V=J;f[V>>2]=0;f[V+4>>2]=0;f[l>>2]=33619968;f[K>>2]=j;p0(T+(U*48|0)|0,l);V=f[w>>2]|0;if((V|0)==(f[L>>2]|0))xwa(t,j);else{f[V>>2]=f[j>>2];W=V+4|0;f[W>>2]=f[D>>2];X=V+8|0;f[X>>2]=f[E>>2];f[V+12>>2]=f[O>>2];f[V+16>>2]=f[N>>2];f[V+20>>2]=f[P>>2];f[V+24>>2]=f[Q>>2];f[V+28>>2]=f[R>>2];f[V+32>>2]=f[S>>2];Z=f[M>>2]|0;f[V+36>>2]=Z;f[V+40>>2]=X;X=V+48|0;_=V+44|0;f[_>>2]=X;f[X>>2]=0;f[V+52>>2]=0;if(Z|0){X=Z+12|0;f[X>>2]=(f[X>>2]|0)+1}if((f[D>>2]|0)<3){X=f[H>>2]|0;Z=f[_>>2]|0;f[Z>>2]=f[X>>2];f[Z+4>>2]=f[X+4>>2]}else{f[W>>2]=0;BR(V,j)}f[w>>2]=(f[w>>2]|0)+56}V=f[M>>2]|0;if(V|0?(W=V+12|0,V=f[W>>2]|0,f[W>>2]=V+-1,(V|0)==1):0)CR(j);f[M>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[D>>2]|0)>0){V=f[F>>2]|0;W=0;do{f[V+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[D>>2]|0))}W=f[H>>2]|0;if((W|0)!=(G|0))ZF(W);U=U+1|0;$=f[B>>2]|0;W=f[x>>2]|0;T=W}while((U|0)<(($-W|0)/48|0|0));aa=$;ba=T}else{aa=C;ba=A}if((aa|0)!=(ba|0)){U=aa;do{x=U+-48|0;f[B>>2]=x;j0(x);U=f[B>>2]|0}while((U|0)!=(ba|0))}}do if((NS(c)|0)==65536){U=f[c+4>>2]|0;f[l>>2]=f[U>>2];B=l+4|0;A=U+4|0;f[B>>2]=f[A>>2];C=l+8|0;f[C>>2]=f[U+8>>2];f[l+12>>2]=f[U+12>>2];f[l+16>>2]=f[U+16>>2];f[l+20>>2]=f[U+20>>2];f[l+24>>2]=f[U+24>>2];f[l+28>>2]=f[U+28>>2];f[l+32>>2]=f[U+32>>2];T=f[U+36>>2]|0;f[l+36>>2]=T;f[l+40>>2]=C;C=l+48|0;x=l+44|0;f[x>>2]=C;f[C>>2]=0;f[l+52>>2]=0;if(T|0){C=T+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[A>>2]|0)<3){A=f[U+44>>2]|0;C=f[x>>2]|0;f[C>>2]=f[A>>2];f[C+4>>2]=f[A+4>>2];break}else{f[B>>2]=0;BR(l,U);break}}else OR(l,c,-1);while(0);if((f[t>>2]|0)==(f[w>>2]|0)?(U=a+16|0,B=f[U>>2]|0,A=a+20|0,C=f[A>>2]|0,(B|0)!=(C|0)):0){if((C-B|0)>0){x=j+4|0;T=j+8|0;G=j+40|0;H=j+48|0;D=j+44|0;F=j+52|0;N=m+8|0;M=m+4|0;S=a+12|0;R=j+36|0;Q=j+16|0;P=j+12|0;O=j+20|0;E=j+24|0;L=j+28|0;K=j+32|0;J=B;I=0;do{f[j>>2]=1124007936;y=x;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[G>>2]=T;f[D>>2]=H;f[H>>2]=0;f[F>>2]=0;W=N;f[W>>2]=0;f[W+4>>2]=0;f[m>>2]=33619968;f[M>>2]=j;p0(J+(I*48|0)|0,m);W=f[w>>2]|0;if((W|0)==(f[S>>2]|0))xwa(t,j);else{f[W>>2]=f[j>>2];V=W+4|0;f[V>>2]=f[x>>2];X=W+8|0;f[X>>2]=f[T>>2];f[W+12>>2]=f[P>>2];f[W+16>>2]=f[Q>>2];f[W+20>>2]=f[O>>2];f[W+24>>2]=f[E>>2];f[W+28>>2]=f[L>>2];f[W+32>>2]=f[K>>2];Z=f[R>>2]|0;f[W+36>>2]=Z;f[W+40>>2]=X;X=W+48|0;_=W+44|0;f[_>>2]=X;f[X>>2]=0;f[W+52>>2]=0;if(Z|0){X=Z+12|0;f[X>>2]=(f[X>>2]|0)+1}if((f[x>>2]|0)<3){X=f[D>>2]|0;Z=f[_>>2]|0;f[Z>>2]=f[X>>2];f[Z+4>>2]=f[X+4>>2]}else{f[V>>2]=0;BR(W,j)}f[w>>2]=(f[w>>2]|0)+56}W=f[R>>2]|0;if(W|0?(V=W+12|0,W=f[V>>2]|0,f[V>>2]=W+-1,(W|0)==1):0)CR(j);f[R>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[x>>2]|0)>0){W=f[G>>2]|0;V=0;do{f[W+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[x>>2]|0))}V=f[D>>2]|0;if((V|0)!=(H|0))ZF(V);I=I+1|0;ca=f[A>>2]|0;V=f[U>>2]|0;J=V}while((I|0)<((ca-V|0)/48|0|0));da=ca;ea=J}else{da=C;ea=B}if((da|0)!=(ea|0)){I=da;do{U=I+-48|0;f[A>>2]=U;j0(U);I=f[A>>2]|0}while((I|0)!=(ea|0))}}I=l+8|0;A=f[I>>2]|0;B=d+4|0;C=f[B>>2]|0;J=f[d>>2]|0;U=(C-J|0)/12|0;H=J;J=C;if(A>>>0<=U>>>0){if(A>>>0<U>>>0?(C=H+(A*12|0)|0,(J|0)!=(C|0)):0){H=J;while(1){J=H+-12|0;f[B>>2]=J;D=f[J>>2]|0;if(!D)fa=J;else{J=H+-8|0;x=f[J>>2]|0;if((x|0)!=(D|0))f[J>>2]=x+(~((x+-16-D|0)>>>4)<<4);PYa(D);fa=f[B>>2]|0}if((fa|0)==(C|0))break;else H=fa}}}else QBa(d,A-U|0);f[m>>2]=1124007936;H=m+4|0;C=m+8|0;B=m+40|0;y=H;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[B>>2]=C;U=m+48|0;A=m+44|0;f[A>>2]=U;f[U>>2]=0;f[m+52>>2]=0;f[o>>2]=1124007936;D=o+4|0;x=o+8|0;J=o+40|0;y=D;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[J>>2]=x;G=o+48|0;Q=o+44|0;f[Q>>2]=G;f[G>>2]=0;f[o+52>>2]=0;R=f[t>>2]|0;K=(f[w>>2]|0)-R|0;L=(K|0)/56|0;E=a+28|0;O=R;switch(f[E>>2]|0){case 7:case 6:{ga=1;break}case 2:{ga=(f[l>>2]&4095|0)==0;break}default:ga=0}R=ga?4:5;a:do if((K|0)>0){P=j+8|0;T=j+12|0;S=j+4|0;M=p+8|0;N=p+12|0;F=p+4|0;V=q+8|0;W=q+4|0;X=s+4|0;Z=s+8|0;_=s+40|0;ha=s+48|0;ia=s+44|0;ja=s+52|0;ka=r+8|0;la=r+12|0;ma=r+4|0;na=s+36|0;oa=s+16|0;pa=j+8|0;qa=j+4|0;ra=o+16|0;sa=o+12|0;ta=j+4|0;ua=j+8|0;va=j+12|0;wa=m+36|0;xa=o+36|0;ya=m+12|0;za=m+16|0;Aa=m+20|0;Ba=o+20|0;Ca=m+24|0;Da=o+24|0;Ea=m+28|0;Fa=o+28|0;Ga=m+32|0;Ha=o+32|0;Ia=s+12|0;Ja=s+20|0;Ka=s+24|0;La=s+28|0;Ma=s+32|0;Na=O;Oa=0;while(1){f[P>>2]=0;f[T>>2]=0;f[j>>2]=16842752;f[S>>2]=l;f[M>>2]=0;f[N>>2]=0;f[p>>2]=16842752;f[F>>2]=Na+(Oa*56|0);Pa=V;f[Pa>>2]=0;f[Pa+4>>2]=0;f[q>>2]=33619968;f[W>>2]=m;Pa=fT()|0;Qa=f[E>>2]|0;Ra=f[k>>2]|0;do if((Ra|0)!=(f[v>>2]|0)){Sa=Ra+(Oa*56|0)|0;f[s>>2]=f[Sa>>2];Ta=Ra+(Oa*56|0)+4|0;f[X>>2]=f[Ta>>2];f[Z>>2]=f[Ra+(Oa*56|0)+8>>2];f[Ia>>2]=f[Ra+(Oa*56|0)+12>>2];f[oa>>2]=f[Ra+(Oa*56|0)+16>>2];f[Ja>>2]=f[Ra+(Oa*56|0)+20>>2];f[Ka>>2]=f[Ra+(Oa*56|0)+24>>2];f[La>>2]=f[Ra+(Oa*56|0)+28>>2];f[Ma>>2]=f[Ra+(Oa*56|0)+32>>2];Ua=f[Ra+(Oa*56|0)+36>>2]|0;f[na>>2]=Ua;f[_>>2]=Z;f[ia>>2]=ha;f[ha>>2]=0;f[ja>>2]=0;if(Ua|0){Va=Ua+12|0;f[Va>>2]=(f[Va>>2]|0)+1}if((f[Ta>>2]|0)<3){Ta=f[Ra+(Oa*56|0)+44>>2]|0;Va=f[ia>>2]|0;f[Va>>2]=f[Ta>>2];f[Va+4>>2]=f[Ta+4>>2];break}else{f[X>>2]=0;BR(s,Sa);break}}else{f[s>>2]=1124007936;y=X;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[_>>2]=Z;f[ia>>2]=ha;f[ha>>2]=0;f[ja>>2]=0}while(0);f[ka>>2]=0;f[la>>2]=0;f[r>>2]=16842752;f[ma>>2]=s;N_(j,p,q,R,Pa,Qa,0,r,0,0);Ra=f[na>>2]|0;if(Ra|0?(Sa=Ra+12|0,Ra=f[Sa>>2]|0,f[Sa>>2]=Ra+-1,(Ra|0)==1):0)CR(s);f[na>>2]=0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((f[X>>2]|0)>0){Ra=f[_>>2]|0;Sa=0;do{f[Ra+(Sa<<2)>>2]=0;Sa=Sa+1|0}while((Sa|0)<(f[X>>2]|0))}Sa=f[ia>>2]|0;if((Sa|0)!=(ha|0))ZF(Sa);if(ga){Sa=pa;f[Sa>>2]=0;f[Sa+4>>2]=0;f[j>>2]=33619968;f[qa>>2]=o;WJ(m,j,5,1.0,0.0)}else{Sa=f[wa>>2]|0;if(Sa|0){Ra=Sa+12|0;f[Ra>>2]=(f[Ra>>2]|0)+1}Ra=f[xa>>2]|0;do if(Ra|0){Sa=Ra+12|0;Qa=f[Sa>>2]|0;f[Sa>>2]=Qa+-1;if((Qa|0)!=1)break;CR(o)}while(0);f[xa>>2]=0;f[ra>>2]=0;f[ra+4>>2]=0;f[ra+8>>2]=0;f[ra+12>>2]=0;if((f[D>>2]|0)>0){Ra=f[J>>2]|0;Qa=0;do{f[Ra+(Qa<<2)>>2]=0;Qa=Qa+1|0;Wa=f[D>>2]|0}while((Qa|0)<(Wa|0));f[o>>2]=f[m>>2];if((Wa|0)<3)Xa=115;else Xa=117}else{f[o>>2]=f[m>>2];Xa=115}do if((Xa|0)==115){Xa=0;Qa=f[H>>2]|0;if((Qa|0)>=3){Xa=117;break}f[D>>2]=Qa;f[x>>2]=f[C>>2];f[sa>>2]=f[ya>>2];Qa=f[A>>2]|0;Ra=f[Q>>2]|0;f[Ra>>2]=f[Qa>>2];f[Ra+4>>2]=f[Qa+4>>2]}while(0);if((Xa|0)==117){Xa=0;BR(o,m)}f[ra>>2]=f[za>>2];f[Ba>>2]=f[Aa>>2];f[Da>>2]=f[Ca>>2];f[Fa>>2]=f[Ea>>2];f[Ha>>2]=f[Ga>>2];f[xa>>2]=f[wa>>2]}Qa=f[I>>2]|0;if((Qa|0)>0){Ra=f[sa>>2]|0;Sa=0;while(1){Pa=(f[ra>>2]|0)+(Y(f[f[Q>>2]>>2]|0,Sa)|0)|0;Ta=f[d>>2]|0;Va=Ta+(Sa*12|0)|0;if((Ra|0)>0){Ua=Ta+(Sa*12|0)+4|0;Ya=Ta+(Sa*12|0)+8|0;Ta=Ra;Za=0;while(1){_a=+n[Pa+(Za<<2)>>2];if(!(_a<=e))$a=Ta;else{f[j>>2]=Sa;f[ta>>2]=Za;f[ua>>2]=Oa;n[va>>2]=_a;ab=f[Ua>>2]|0;if((ab|0)==(f[Ya>>2]|0))mY(Va,j);else{f[ab>>2]=f[j>>2];f[ab+4>>2]=f[j+4>>2];f[ab+8>>2]=f[j+8>>2];f[ab+12>>2]=f[j+12>>2];f[Ua>>2]=(f[Ua>>2]|0)+16}$a=f[sa>>2]|0}Za=Za+1|0;if((Za|0)>=($a|0)){bb=$a;break}else Ta=$a}}else bb=Ra;Sa=Sa+1|0;Ta=f[I>>2]|0;if((Sa|0)>=(Ta|0)){cb=Ta;break}else Ra=bb}}else cb=Qa;Ra=Oa+1|0;if((Ra|0)>=(L|0)){db=cb;break a}Na=f[t>>2]|0;Oa=Ra}}else db=f[I>>2]|0;while(0);b:do if((db|0)>0){if(h){eb=db;fb=0;gb=0}else{L=0;while(1){C=f[d>>2]|0;RBa(f[C+(L*12|0)>>2]|0,f[C+(L*12|0)+4>>2]|0,j);L=L+1|0;if((L|0)>=(f[I>>2]|0))break b}}while(1){L=f[d>>2]|0;C=L+(gb*12|0)|0;x=f[C>>2]|0;R=L+(gb*12|0)+4|0;v=x;if((x|0)==(f[R>>2]|0)){hb=eb;ib=fb}else{if((fb|0)<(gb|0)){x=L+(fb*12|0)|0;f[C>>2]=f[x>>2];f[x>>2]=v;v=L+(fb*12|0)+4|0;x=f[R>>2]|0;f[R>>2]=f[v>>2];f[v>>2]=x;x=L+(gb*12|0)+8|0;v=L+(fb*12|0)+8|0;R=f[x>>2]|0;f[x>>2]=f[v>>2];f[v>>2]=R;jb=f[d>>2]|0}else jb=L;RBa(f[jb+(fb*12|0)>>2]|0,f[jb+(fb*12|0)+4>>2]|0,j);hb=f[I>>2]|0;ib=fb+1|0}gb=gb+1|0;if((gb|0)>=(hb|0))break;else{eb=hb;fb=ib}}}while(0);I=o+36|0;L=f[I>>2]|0;if(L|0?(R=L+12|0,L=f[R>>2]|0,f[R>>2]=L+-1,(L|0)==1):0)CR(o);f[I>>2]=0;I=o+16|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[D>>2]|0)>0){I=f[J>>2]|0;L=0;do{f[I+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[D>>2]|0))}D=f[Q>>2]|0;if((D|0)!=(G|0))ZF(D);D=m+36|0;L=f[D>>2]|0;if(L|0?(I=L+12|0,L=f[I>>2]|0,f[I>>2]=L+-1,(L|0)==1):0)CR(m);f[D>>2]=0;D=m+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[H>>2]|0)>0){D=f[B>>2]|0;L=0;do{f[D+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[H>>2]|0))}H=f[A>>2]|0;if((H|0)!=(U|0))ZF(H);H=l+36|0;L=f[H>>2]|0;if(L|0?(D=L+12|0,L=f[D>>2]|0,f[D>>2]=L+-1,(L|0)==1):0)CR(l);f[H>>2]=0;H=l+16|0;L=l+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[L>>2]|0)>0){H=f[l+40>>2]|0;D=0;do{f[H+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[L>>2]|0))}L=f[l+44>>2]|0;if((L|0)!=(l+48|0))ZF(L);Vt(k);u=i;return}while(0);k=f[d>>2]|0;l=d+4|0;d=f[l>>2]|0;if((d|0)==(k|0)){u=i;return}else kb=d;while(1){d=kb+-12|0;f[l>>2]=d;m=f[d>>2]|0;if(!m)lb=d;else{d=kb+-8|0;o=f[d>>2]|0;if((o|0)!=(m|0))f[d>>2]=o+(~((o+-16-m|0)>>>4)<<4);PYa(m);lb=f[l>>2]|0}if((lb|0)==(k|0))break;else kb=lb}u=i;return}function QBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/12|0)>>>0>=b>>>0){F1a(g|0,0,b*12|0)|0;f[e>>2]=h+(b*12|0);return}i=f[a>>2]|0;j=(g-i|0)/12|0;k=j+b|0;l=i;if(k>>>0>357913941)gXa(a);m=(d-i|0)/12|0;i=m<<1;d=m>>>0<178956970?(i>>>0<k>>>0?k:i):357913941;do if(d)if(d>>>0>357913941){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{n=NYa(d*12|0)|0;break}else n=0;while(0);i=n+(j*12|0)|0;j=i;k=n+(d*12|0)|0;F1a(i|0,0,b*12|0)|0;d=i+(b*12|0)|0;if((h|0)==(l|0)){o=j;p=g;q=h}else{g=i;i=h;h=j;do{i=i+-12|0;uv(g+-12|0,i);g=h+-12|0;h=g}while((i|0)!=(l|0));o=h;p=f[a>>2]|0;q=f[e>>2]|0}f[a>>2]=o;f[e>>2]=d;f[c>>2]=k;k=p;if((q|0)!=(k|0)){c=q;do{q=c;c=c+-12|0;d=f[c>>2]|0;if(d|0){e=q+-8|0;q=f[e>>2]|0;if((q|0)!=(d|0))f[e>>2]=q+(~((q+-16-d|0)>>>4)<<4);PYa(d)}}while((c|0)!=(k|0))}if(!p)return;PYa(p);return}function RBa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0;d=u;u=u+16|0;e=d;g=a;a=b;a:while(1){b=a;h=a+-16|0;i=a+-4|0;j=g;while(1){k=j;b:while(1){l=k;m=b-l|0;o=m>>4;switch(o|0){case 2:{p=5;break a;break}case 3:{p=7;break a;break}case 4:{p=15;break a;break}case 5:{p=16;break a;break}case 1:case 0:{p=84;break a;break}default:{}}if((m|0)<496){p=22;break a}q=(o|0)/2|0;r=k+(q<<4)|0;do if((m|0)>15984){s=(o|0)/4|0;t=k+(s<<4)|0;v=r+(s<<4)|0;w=SBa(k,t,r,v,c)|0;x=v+12|0;if(!(+n[i>>2]<+n[x>>2])){y=w;z=k+(q<<4)+12|0;break};f[e>>2]=f[v>>2];f[e+4>>2]=f[v+4>>2];f[e+8>>2]=f[v+8>>2];f[e+12>>2]=f[v+12>>2];f[v>>2]=f[h>>2];f[v+4>>2]=f[h+4>>2];f[v+8>>2]=f[h+8>>2];f[v+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];A=w+1|0;B=k+(q<<4)+12|0;if(+n[x>>2]<+n[B>>2]){f[e>>2]=f[r>>2];f[e+4>>2]=f[r+4>>2];f[e+8>>2]=f[r+8>>2];f[e+12>>2]=f[r+12>>2];f[r>>2]=f[v>>2];f[r+4>>2]=f[v+4>>2];f[r+8>>2]=f[v+8>>2];f[r+12>>2]=f[v+12>>2];f[v>>2]=f[e>>2];f[v+4>>2]=f[e+4>>2];f[v+8>>2]=f[e+8>>2];f[v+12>>2]=f[e+12>>2];v=w+2|0;x=k+(s<<4)+12|0;if(+n[B>>2]<+n[x>>2]){f[e>>2]=f[t>>2];f[e+4>>2]=f[t+4>>2];f[e+8>>2]=f[t+8>>2];f[e+12>>2]=f[t+12>>2];f[t>>2]=f[r>>2];f[t+4>>2]=f[r+4>>2];f[t+8>>2]=f[r+8>>2];f[t+12>>2]=f[r+12>>2];f[r>>2]=f[e>>2];f[r+4>>2]=f[e+4>>2];f[r+8>>2]=f[e+8>>2];f[r+12>>2]=f[e+12>>2];if(+n[x>>2]<+n[k+12>>2]){f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[t>>2];f[k+4>>2]=f[t+4>>2];f[k+8>>2]=f[t+8>>2];f[k+12>>2]=f[t+12>>2];f[t>>2]=f[e>>2];f[t+4>>2]=f[e+4>>2];f[t+8>>2]=f[e+8>>2];f[t+12>>2]=f[e+12>>2];y=w+4|0;z=B}else{y=w+3|0;z=B}}else{y=v;z=B}}else{y=A;z=B}}else{B=k+(q<<4)+12|0;C=+n[B>>2];A=k+12|0;v=+n[i>>2]<C;if(!(C<+n[A>>2])){if(!v){y=0;z=B;break};f[e>>2]=f[r>>2];f[e+4>>2]=f[r+4>>2];f[e+8>>2]=f[r+8>>2];f[e+12>>2]=f[r+12>>2];f[r>>2]=f[h>>2];f[r+4>>2]=f[h+4>>2];f[r+8>>2]=f[h+8>>2];f[r+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];if(!(+n[B>>2]<+n[A>>2])){y=1;z=B;break};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[r>>2];f[k+4>>2]=f[r+4>>2];f[k+8>>2]=f[r+8>>2];f[k+12>>2]=f[r+12>>2];f[r>>2]=f[e>>2];f[r+4>>2]=f[e+4>>2];f[r+8>>2]=f[e+8>>2];f[r+12>>2]=f[e+12>>2];y=2;z=B;break}if(v){f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];f[k+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];y=1;z=B;break};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[r>>2];f[k+4>>2]=f[r+4>>2];f[k+8>>2]=f[r+8>>2];f[k+12>>2]=f[r+12>>2];f[r>>2]=f[e>>2];f[r+4>>2]=f[e+4>>2];f[r+8>>2]=f[e+8>>2];f[r+12>>2]=f[e+12>>2];if(+n[i>>2]<+n[B>>2]){f[e>>2]=f[r>>2];f[e+4>>2]=f[r+4>>2];f[e+8>>2]=f[r+8>>2];f[e+12>>2]=f[r+12>>2];f[r>>2]=f[h>>2];f[r+4>>2]=f[h+4>>2];f[r+8>>2]=f[h+8>>2];f[r+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];y=2;z=B}else{y=1;z=B}}while(0);q=k+12|0;C=+n[q>>2];D=+n[z>>2];if(C<D){E=h;F=y;break}else G=h;while(1){o=G;G=G+-16|0;if((k|0)==(G|0))break;if(+n[o+-4>>2]<D){p=67;break b}}o=k+16|0;if(C<+n[i>>2])H=o;else{if((o|0)==(h|0)){p=84;break a}else I=o;while(1){if(C<+n[I+12>>2])break;o=I+16|0;if((o|0)==(h|0)){p=84;break a}else I=o}f[e>>2]=f[I>>2];f[e+4>>2]=f[I+4>>2];f[e+8>>2]=f[I+8>>2];f[e+12>>2]=f[I+12>>2];f[I>>2]=f[h>>2];f[I+4>>2]=f[h+4>>2];f[I+8>>2]=f[h+8>>2];f[I+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];H=I+16|0}if((H|0)==(h|0)){p=84;break a}else{J=H;K=h}while(1){C=+n[q>>2];o=J;while(1){L=o+16|0;if(C<+n[o+12>>2]){M=K;break}else o=L}do{m=M;M=M+-16|0}while(C<+n[m+-4>>2]);if(o>>>0>=M>>>0){k=o;continue b};f[e>>2]=f[o>>2];f[e+4>>2]=f[o+4>>2];f[e+8>>2]=f[o+8>>2];f[e+12>>2]=f[o+12>>2];f[o>>2]=f[M>>2];f[o+4>>2]=f[M+4>>2];f[o+8>>2]=f[M+8>>2];f[o+12>>2]=f[M+12>>2];f[M>>2]=f[e>>2];f[M+4>>2]=f[e+4>>2];f[M+8>>2]=f[e+8>>2];f[M+12>>2]=f[e+12>>2];J=L;K=M}}if((p|0)==67){p=0;f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[G>>2];f[k+4>>2]=f[G+4>>2];f[k+8>>2]=f[G+8>>2];f[k+12>>2]=f[G+12>>2];f[G>>2]=f[e>>2];f[G+4>>2]=f[e+4>>2];f[G+8>>2]=f[e+8>>2];f[G+12>>2]=f[e+12>>2];E=G;F=y+1|0}q=k+16|0;c:do if(q>>>0<E>>>0){m=q;B=E;v=r;A=F;while(1){C=+n[v+12>>2];w=m;while(1){N=w+16|0;if(+n[w+12>>2]<C)w=N;else{O=B;break}}do{o=O;O=O+-16|0}while(!(+n[o+-4>>2]<C));if(w>>>0>O>>>0){P=w;Q=v;R=A;break c};f[e>>2]=f[w>>2];f[e+4>>2]=f[w+4>>2];f[e+8>>2]=f[w+8>>2];f[e+12>>2]=f[w+12>>2];f[w>>2]=f[O>>2];f[w+4>>2]=f[O+4>>2];f[w+8>>2]=f[O+8>>2];f[w+12>>2]=f[O+12>>2];f[O>>2]=f[e>>2];f[O+4>>2]=f[e+4>>2];f[O+8>>2]=f[e+8>>2];f[O+12>>2]=f[e+12>>2];m=N;B=O;v=(v|0)==(w|0)?O:v;A=A+1|0}}else{P=q;Q=r;R=F}while(0);if((P|0)!=(Q|0)?+n[Q+12>>2]<+n[P+12>>2]:0){f[e>>2]=f[P>>2];f[e+4>>2]=f[P+4>>2];f[e+8>>2]=f[P+8>>2];f[e+12>>2]=f[P+12>>2];f[P>>2]=f[Q>>2];f[P+4>>2]=f[Q+4>>2];f[P+8>>2]=f[Q+8>>2];f[P+12>>2]=f[Q+12>>2];f[Q>>2]=f[e>>2];f[Q+4>>2]=f[e+4>>2];f[Q+8>>2]=f[e+8>>2];f[Q+12>>2]=f[e+12>>2];S=R+1|0}else S=R;if(!S){T=TBa(k,P,c)|0;q=P+16|0;if(TBa(q,a,c)|0){p=83;break}if(T){j=q;continue}}q=P;if((q-l|0)>=(b-q|0)){p=82;break}RBa(k,P,c);j=P+16|0}if((p|0)==82){p=0;RBa(P+16|0,a,c);g=k;a=P;continue}else if((p|0)==83){p=0;if(T){p=84;break}else{g=k;a=P;continue}}}if((p|0)==5){if(!(+n[i>>2]<+n[k+12>>2])){u=d;return};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];f[k+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];u=d;return}else if((p|0)==7){P=k+16|0;g=k+28|0;C=+n[g>>2];T=k+12|0;l=+n[i>>2]<C;if(!(C<+n[T>>2])){if(!l){u=d;return};f[e>>2]=f[P>>2];f[e+4>>2]=f[P+4>>2];f[e+8>>2]=f[P+8>>2];f[e+12>>2]=f[P+12>>2];f[P>>2]=f[h>>2];f[P+4>>2]=f[h+4>>2];f[P+8>>2]=f[h+8>>2];f[P+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];if(!(+n[g>>2]<+n[T>>2])){u=d;return};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[P>>2];f[k+4>>2]=f[P+4>>2];f[k+8>>2]=f[P+8>>2];f[k+12>>2]=f[P+12>>2];f[P>>2]=f[e>>2];f[P+4>>2]=f[e+4>>2];f[P+8>>2]=f[e+8>>2];f[P+12>>2]=f[e+12>>2];u=d;return}if(l){f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];f[k+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];u=d;return};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[P>>2];f[k+4>>2]=f[P+4>>2];f[k+8>>2]=f[P+8>>2];f[k+12>>2]=f[P+12>>2];f[P>>2]=f[e>>2];f[P+4>>2]=f[e+4>>2];f[P+8>>2]=f[e+8>>2];f[P+12>>2]=f[e+12>>2];if(!(+n[i>>2]<+n[g>>2])){u=d;return};f[e>>2]=f[P>>2];f[e+4>>2]=f[P+4>>2];f[e+8>>2]=f[P+8>>2];f[e+12>>2]=f[P+12>>2];f[P>>2]=f[h>>2];f[P+4>>2]=f[h+4>>2];f[P+8>>2]=f[h+8>>2];f[P+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];u=d;return}else if((p|0)==15){SBa(k,k+16|0,k+32|0,h,c)|0;u=d;return}else if((p|0)==16){P=k+16|0;g=k+32|0;l=k+48|0;SBa(k,P,g,l,c)|0;c=k+60|0;if(!(+n[i>>2]<+n[c>>2])){u=d;return};f[e>>2]=f[l>>2];f[e+4>>2]=f[l+4>>2];f[e+8>>2]=f[l+8>>2];f[e+12>>2]=f[l+12>>2];f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[l+8>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];h=k+44|0;if(!(+n[c>>2]<+n[h>>2])){u=d;return};f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];f[e+12>>2]=f[g+12>>2];f[g>>2]=f[l>>2];f[g+4>>2]=f[l+4>>2];f[g+8>>2]=f[l+8>>2];f[g+12>>2]=f[l+12>>2];f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];f[l+8>>2]=f[e+8>>2];f[l+12>>2]=f[e+12>>2];l=k+28|0;if(!(+n[h>>2]<+n[l>>2])){u=d;return};f[e>>2]=f[P>>2];f[e+4>>2]=f[P+4>>2];f[e+8>>2]=f[P+8>>2];f[e+12>>2]=f[P+12>>2];f[P>>2]=f[g>>2];f[P+4>>2]=f[g+4>>2];f[P+8>>2]=f[g+8>>2];f[P+12>>2]=f[g+12>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];if(!(+n[l>>2]<+n[k+12>>2])){u=d;return};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[P>>2];f[k+4>>2]=f[P+4>>2];f[k+8>>2]=f[P+8>>2];f[k+12>>2]=f[P+12>>2];f[P>>2]=f[e>>2];f[P+4>>2]=f[e+4>>2];f[P+8>>2]=f[e+8>>2];f[P+12>>2]=f[e+12>>2];u=d;return}else if((p|0)==22){P=k+32|0;l=k+16|0;g=k+28|0;C=+n[g>>2];D=+n[k+12>>2];U=+n[k+44>>2];h=U<C;do if(C<D){if(h){f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[P>>2];f[k+4>>2]=f[P+4>>2];f[k+8>>2]=f[P+8>>2];f[k+12>>2]=f[P+12>>2];f[P>>2]=f[e>>2];f[P+4>>2]=f[e+4>>2];f[P+8>>2]=f[e+8>>2];f[P+12>>2]=f[e+12>>2];break};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];f[k+12>>2]=f[l+12>>2];f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];f[l+8>>2]=f[e+8>>2];f[l+12>>2]=f[e+12>>2];if(U<+n[g>>2]){f[e>>2]=f[l>>2];f[e+4>>2]=f[l+4>>2];f[e+8>>2]=f[l+8>>2];f[e+12>>2]=f[l+12>>2];f[l>>2]=f[P>>2];f[l+4>>2]=f[P+4>>2];f[l+8>>2]=f[P+8>>2];f[l+12>>2]=f[P+12>>2];f[P>>2]=f[e>>2];f[P+4>>2]=f[e+4>>2];f[P+8>>2]=f[e+8>>2];f[P+12>>2]=f[e+12>>2]}}else if(h?(f[e>>2]=f[l>>2],f[e+4>>2]=f[l+4>>2],f[e+8>>2]=f[l+8>>2],f[e+12>>2]=f[l+12>>2],f[l>>2]=f[P>>2],f[l+4>>2]=f[P+4>>2],f[l+8>>2]=f[P+8>>2],f[l+12>>2]=f[P+12>>2],f[P>>2]=f[e>>2],f[P+4>>2]=f[e+4>>2],f[P+8>>2]=f[e+8>>2],f[P+12>>2]=f[e+12>>2],+n[g>>2]<D):0){f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];f[k+12>>2]=f[l+12>>2];f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];f[l+8>>2]=f[e+8>>2];f[l+12>>2]=f[e+12>>2]}while(0);l=k+48|0;if((l|0)==(a|0)){u=d;return}g=l;l=P;while(1){D=+n[g+12>>2];if(D<+n[l+12>>2]){f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];P=g;h=l;while(1){f[P>>2]=f[h>>2];f[P+4>>2]=f[h+4>>2];f[P+8>>2]=f[h+8>>2];f[P+12>>2]=f[h+12>>2];if((h|0)==(k|0)){V=k;break}if(D<+n[h+-4>>2]){c=h;h=h+-16|0;P=c}else{V=h;break}}f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];n[V+12>>2]=D}P=g+16|0;if((P|0)==(a|0))break;else{c=g;g=P;l=c}}u=d;return}else if((p|0)==84){u=d;return}}function SBa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0.0,j=0,k=0,l=0,m=0,o=0;e=u;u=u+16|0;g=e;h=b+12|0;i=+n[h>>2];j=a+12|0;k=c+12|0;l=+n[k>>2]<i;do if(i<+n[j>>2]){if(l){f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];f[g+8>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];m=1;break};f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];f[g+8>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];if(+n[k>>2]<+n[h>>2]){f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];f[g+8>>2]=f[b+8>>2];f[g+12>>2]=f[b+12>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];m=2}else m=1}else if(l){f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];f[g+8>>2]=f[b+8>>2];f[g+12>>2]=f[b+12>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];if(+n[h>>2]<+n[j>>2]){f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];f[g+8>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];m=2}else m=1}else m=0;while(0);if(!(+n[d+12>>2]<+n[k>>2])){o=m;u=e;return o|0};f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];f[g+8>>2]=f[c+8>>2];f[g+12>>2]=f[c+12>>2];f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];f[c+8>>2]=f[d+8>>2];f[c+12>>2]=f[d+12>>2];f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];f[d+8>>2]=f[g+8>>2];f[d+12>>2]=f[g+12>>2];if(!(+n[k>>2]<+n[h>>2])){o=m+1|0;u=e;return o|0};f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];f[g+8>>2]=f[b+8>>2];f[g+12>>2]=f[b+12>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];if(!(+n[h>>2]<+n[j>>2])){o=m+2|0;u=e;return o|0};f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];f[g+8>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];o=m+3|0;u=e;return o|0}function TBa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0.0,l=0,m=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+16|0;e=d;switch(b-a>>4|0){case 2:{if(!(+n[b+-4>>2]<+n[a+12>>2])){g=1;u=d;return g|0}h=b+-16|0;f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[h>>2];f[a+4>>2]=f[h+4>>2];f[a+8>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];g=1;u=d;return g|0}case 3:{h=a+16|0;i=b+-16|0;j=a+28|0;k=+n[j>>2];l=a+12|0;m=b+-4|0;o=+n[m>>2]<k;if(!(k<+n[l>>2])){if(!o){g=1;u=d;return g|0};f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];f[e+8>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];f[h+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];if(!(+n[j>>2]<+n[l>>2])){g=1;u=d;return g|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[h>>2];f[a+4>>2]=f[h+4>>2];f[a+8>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];g=1;u=d;return g|0}if(o){f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[i>>2];f[a+4>>2]=f[i+4>>2];f[a+8>>2]=f[i+8>>2];f[a+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];g=1;u=d;return g|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[h>>2];f[a+4>>2]=f[h+4>>2];f[a+8>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];if(!(+n[m>>2]<+n[j>>2])){g=1;u=d;return g|0};f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];f[e+8>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];f[h+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];g=1;u=d;return g|0}case 4:{SBa(a,a+16|0,a+32|0,b+-16|0,c)|0;g=1;u=d;return g|0}case 5:{i=a+16|0;h=a+32|0;j=a+48|0;SBa(a,i,h,j,c)|0;c=a+60|0;if(!(+n[b+-4>>2]<+n[c>>2])){g=1;u=d;return g|0}m=b+-16|0;f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[m>>2];f[j+4>>2]=f[m+4>>2];f[j+8>>2]=f[m+8>>2];f[j+12>>2]=f[m+12>>2];f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];f[m+8>>2]=f[e+8>>2];f[m+12>>2]=f[e+12>>2];m=a+44|0;if(!(+n[c>>2]<+n[m>>2])){g=1;u=d;return g|0};f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];f[e+8>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];f[h+8>>2]=f[j+8>>2];f[h+12>>2]=f[j+12>>2];f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[j+8>>2]=f[e+8>>2];f[j+12>>2]=f[e+12>>2];j=a+28|0;if(!(+n[m>>2]<+n[j>>2])){g=1;u=d;return g|0};f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];f[i>>2]=f[h>>2];f[i+4>>2]=f[h+4>>2];f[i+8>>2]=f[h+8>>2];f[i+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];if(!(+n[j>>2]<+n[a+12>>2])){g=1;u=d;return g|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[i>>2];f[a+4>>2]=f[i+4>>2];f[a+8>>2]=f[i+8>>2];f[a+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];g=1;u=d;return g|0}case 1:case 0:{g=1;u=d;return g|0}default:{i=a+32|0;j=a+16|0;h=a+28|0;k=+n[h>>2];p=+n[a+12>>2];q=+n[a+44>>2];m=q<k;do if(k<p){if(m){f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[i>>2];f[a+4>>2]=f[i+4>>2];f[a+8>>2]=f[i+8>>2];f[a+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];break};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[j>>2];f[a+4>>2]=f[j+4>>2];f[a+8>>2]=f[j+8>>2];f[a+12>>2]=f[j+12>>2];f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[j+8>>2]=f[e+8>>2];f[j+12>>2]=f[e+12>>2];if(q<+n[h>>2]){f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2]}}else if(m?(f[e>>2]=f[j>>2],f[e+4>>2]=f[j+4>>2],f[e+8>>2]=f[j+8>>2],f[e+12>>2]=f[j+12>>2],f[j>>2]=f[i>>2],f[j+4>>2]=f[i+4>>2],f[j+8>>2]=f[i+8>>2],f[j+12>>2]=f[i+12>>2],f[i>>2]=f[e>>2],f[i+4>>2]=f[e+4>>2],f[i+8>>2]=f[e+8>>2],f[i+12>>2]=f[e+12>>2],+n[h>>2]<p):0){f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[j>>2];f[a+4>>2]=f[j+4>>2];f[a+8>>2]=f[j+8>>2];f[a+12>>2]=f[j+12>>2];f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[j+8>>2]=f[e+8>>2];f[j+12>>2]=f[e+12>>2]}while(0);j=a+48|0;a:do if((j|0)==(b|0)){r=1;s=0}else{h=0;m=j;c=i;while(1){p=+n[m+12>>2];if(p<+n[c+12>>2]){f[e>>2]=f[m>>2];f[e+4>>2]=f[m+4>>2];f[e+8>>2]=f[m+8>>2];o=m;l=c;while(1){f[o>>2]=f[l>>2];f[o+4>>2]=f[l+4>>2];f[o+8>>2]=f[l+8>>2];f[o+12>>2]=f[l+12>>2];if((l|0)==(a|0)){t=a;break}if(p<+n[l+-4>>2]){v=l;l=l+-16|0;o=v}else{t=l;break}}f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];f[l+8>>2]=f[e+8>>2];n[t+12>>2]=p;o=h+1|0;if((o|0)==8){r=0;s=(m+16|0)==(b|0);break a}else w=o}else w=h;o=m+16|0;if((o|0)==(b|0)){r=1;s=0;break}else{v=m;h=w;m=o;c=v}}}while(0);g=s|r;u=d;return g|0}}return 0}function UBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[a>>2]|0;e=d;if((((f[c>>2]|0)-d|0)/12|0)>>>0>=b>>>0)return;g=a+4|0;if(b>>>0>357913941){h=De(8)|0;UYa(h,358155);f[h>>2]=130560;Of(h|0,21520,875)}h=f[g>>2]|0;i=NYa(b*12|0)|0;j=i+(((h-d|0)/12|0)*12|0)|0;d=j;k=i+(b*12|0)|0;b=h;if((b|0)==(e|0)){l=d;m=h;n=e}else{h=j;j=b;b=d;do{j=j+-12|0;uv(h+-12|0,j);h=b+-12|0;b=h}while((j|0)!=(e|0));l=b;m=f[a>>2]|0;n=f[g>>2]|0}f[a>>2]=l;f[g>>2]=d;f[c>>2]=k;k=m;if((n|0)!=(k|0)){c=n;do{n=c;c=c+-12|0;d=f[c>>2]|0;if(d|0){g=n+-8|0;n=f[g>>2]|0;if((n|0)!=(d|0))f[g>>2]=n+(~((n+-16-d|0)>>>4)<<4);PYa(d)}}while((c|0)!=(k|0))}if(!m)return;PYa(m);return}function VBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/12|0;g=e+1|0;if(g>>>0>357913941)gXa(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/12|0;d=i<<1;j=i>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(j)if(j>>>0>357913941){d=De(8)|0;UYa(d,358155);f[d>>2]=130560;Of(d|0,21520,875)}else{k=NYa(j*12|0)|0;break}else k=0;while(0);d=k+(e*12|0)|0;e=d;g=k+(j*12|0)|0;uv(d,b);b=d+12|0;j=f[a>>2]|0;k=f[c>>2]|0;if((k|0)==(j|0)){l=e;m=j;n=j}else{i=d;d=k;k=e;do{d=d+-12|0;uv(i+-12|0,d);i=k+-12|0;k=i}while((d|0)!=(j|0));l=k;m=f[a>>2]|0;n=f[c>>2]|0}f[a>>2]=l;f[c>>2]=b;f[h>>2]=g;g=m;if((n|0)!=(g|0)){h=n;do{n=h;h=h+-12|0;b=f[h>>2]|0;if(b|0){c=n+-8|0;n=f[c>>2]|0;if((n|0)!=(b|0))f[c>>2]=n+(~((n+-16-b|0)>>>4)<<4);PYa(b)}}while((h|0)!=(g|0))}if(!m)return;PYa(m);return}function WBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>4>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>268435455){g=De(8)|0;UYa(g,358155);f[g>>2]=130560;Of(g|0,21520,875)}g=(f[e>>2]|0)-d|0;h=g>>4;i=NYa(b<<4)|0;j=i+(h<<4)|0;k=j+(0-h<<4)|0;if((g|0)>0)K1a(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<4);if(!d)return;PYa(d);return}function XBa(a){a=a|0;PYa(a);return}function YBa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function ZBa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+112|0;h=g+96|0;i=g+88|0;j=g+72|0;k=g+56|0;l=g;_$(h,105844);fi[f[(f[a>>2]|0)+44>>2]&255](i,a,1);a=i+4|0;m=f[a>>2]|0;Gh[f[(f[m>>2]|0)+32>>2]&511](m,c);c=f[a>>2]|0;do if((NS(e)|0)==65536){a=f[e+4>>2]|0;f[l>>2]=f[a>>2];m=l+4|0;n=a+4|0;f[m>>2]=f[n>>2];o=l+8|0;f[o>>2]=f[a+8>>2];f[l+12>>2]=f[a+12>>2];f[l+16>>2]=f[a+16>>2];f[l+20>>2]=f[a+20>>2];f[l+24>>2]=f[a+24>>2];f[l+28>>2]=f[a+28>>2];f[l+32>>2]=f[a+32>>2];p=f[a+36>>2]|0;f[l+36>>2]=p;f[l+40>>2]=o;o=l+48|0;q=l+44|0;f[q>>2]=o;f[o>>2]=0;f[l+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[a+44>>2]|0;o=f[q>>2]|0;f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2];break}else{f[m>>2]=0;BR(l,a);break}}else OR(l,e,-1);while(0);gxa(k,1,l);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=17104896;f[j+4>>2]=k;_Ba(c,b,d,j);Vt(k);k=l+36|0;j=f[k>>2]|0;if(j|0?(d=j+12|0,j=f[d>>2]|0,f[d>>2]=j+-1,(j|0)==1):0)CR(l);f[k>>2]=0;k=l+16|0;j=l+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[l+40>>2]|0;d=0;do{f[k+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[j>>2]|0))}j=f[l+44>>2]|0;if((j|0)!=(l+48|0))ZF(j);j=f[i>>2]|0;if(j|0?(i=j+4|0,l=f[i>>2]|0,f[i>>2]=l+-1,(l|0)==1):0)ki[f[(f[j>>2]|0)+8>>2]&2047](j);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function _Ba(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=u;u=u+32|0;h=g+24|0;i=g+16|0;j=g;_$(i,105864);f[j>>2]=0;k=j+4|0;f[k>>2]=0;f[j+8>>2]=0;$Ba(a,c,j,1,e,1);e=f[d>>2]|0;c=d+4|0;a=f[c>>2]|0;if((a|0)!=(e|0))f[c>>2]=a+(~((a+-16-e|0)>>>4)<<4);WBa(d,((f[k>>2]|0)-(f[j>>2]|0)|0)/12|0);e=f[k>>2]|0;a=f[j>>2]|0;l=a;if((e|0)==(a|0)){m=e;n=l}else{e=d+8|0;o=h+4|0;p=a;a=l;l=0;while(1){q=p;r=f[q+(l*12|0)+4>>2]|0;if(r-(f[q+(l*12|0)>>2]|0)>>4>>>0<2){s=q;t=r;v=a;w=p}else{f[h>>2]=0;f[o>>2]=0;r=c$(h,25)|0;q=357177;x=r+25|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(x|0));j$(-215,h,357203,356857,509);d$(h);q=f[j>>2]|0;s=q;t=f[q+(l*12|0)+4>>2]|0;v=q;w=q}q=f[s+(l*12|0)>>2]|0;do if((q|0)!=(t|0)){r=f[c>>2]|0;if((r|0)==(f[e>>2]|0)){mY(d,q);x=f[j>>2]|0;y=x;z=x;break}else{f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];f[r+8>>2]=f[q+8>>2];f[r+12>>2]=f[q+12>>2];f[c>>2]=(f[c>>2]|0)+16;y=w;z=v;break}}else{y=w;z=v}while(0);l=l+1|0;q=f[k>>2]|0;if(l>>>0>=((q-y|0)/12|0)>>>0){m=q;n=z;break}else{p=y;a=z}}}z=m;if(n|0){if((z|0)==(n|0))A=n;else{m=z;while(1){z=m+-12|0;f[k>>2]=z;a=f[z>>2]|0;if(!a)B=z;else{z=m+-8|0;y=f[z>>2]|0;if((y|0)!=(a|0))f[z>>2]=y+(~((y+-16-a|0)>>>4)<<4);PYa(a);B=f[k>>2]|0}if((B|0)==(n|0))break;else m=B}A=f[j>>2]|0}PYa(A)}if(!(f[i+4>>2]|0)){u=g;return}u=g;return}function $Ba(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;_$(j,105884);if(!(mi[f[(f[a>>2]|0)+20>>2]&255](a)|0)?!(XS(c)|0):0){if((e|0)<=0){f[k>>2]=0;f[k+4>>2]=0;m=c$(k,7)|0;b[m>>0]=b[357218]|0;b[m+1>>0]=b[357219]|0;b[m+2>>0]=b[357220]|0;b[m+3>>0]=b[357221]|0;b[m+4>>0]=b[357222]|0;b[m+5>>0]=b[357223]|0;b[m+6>>0]=b[357224]|0;j$(-215,k,357226,356857,638);d$(k)}QR(l,c,-1);aCa(a,g,f[l+4>>2]|0);ki[f[(f[a>>2]|0)+40>>2]&2047](a);bh[f[(f[a>>2]|0)+48>>2]&255](a,c,d,e,g,h)}if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function aCa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=u;u=u+32|0;g=e+8|0;h=e;f[g>>2]=0;i=g+4|0;f[i>>2]=0;f[g+8>>2]=0;PS(c,g);if(!(mi[f[(f[a>>2]|0)+36>>2]&255](a)|0)){Vt(g);u=e;return}c=f[g>>2]|0;j=f[i>>2]|0;if((c|0)==(j|0)){Vt(g);u=e;return}i=a+4|0;k=((f[a+8>>2]|0)-(f[i>>2]|0)|0)/56|0;l=a+16|0;m=((f[a+20>>2]|0)-(f[l>>2]|0)|0)/48|0;a=k>>>0<m>>>0?m:k;if(((j-c|0)/56|0|0)!=(a|0)){f[h>>2]=0;f[h+4>>2]=0;n=c$(h,26)|0;o=357235;p=n+26|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-215,h,357262,356857,617);d$(h)}if(!a){Vt(g);u=e;return}c=h+4|0;j=0;do{k=f[g>>2]|0;do if(f[k+(j*56|0)+16>>2]|0){m=f[k+(j*56|0)+4>>2]|0;if((m|0)<3)q=Y(f[k+(j*56|0)+12>>2]|0,f[k+(j*56|0)+8>>2]|0)|0;else{r=f[k+(j*56|0)+40>>2]|0;s=0;t=1;while(1){v=Y(f[r+(s<<2)>>2]|0,t)|0;s=s+1|0;if((s|0)==(m|0)){q=v;break}else t=v}}if(!((m|0)==0|(q|0)==0)){t=f[i>>2]|0;s=(f[t+(j*56|0)+16>>2]|0)==0;if(!s){r=f[t+(j*56|0)+4>>2]|0;if((r|0)<3)w=Y(f[t+(j*56|0)+12>>2]|0,f[t+(j*56|0)+8>>2]|0)|0;else{v=f[t+(j*56|0)+40>>2]|0;x=0;y=1;while(1){z=Y(f[v+(x<<2)>>2]|0,y)|0;x=x+1|0;if((x|0)==(r|0)){w=z;break}else y=z}}if((r|0)==0|(w|0)==0)A=19}else A=19;if((A|0)==19){A=0;y=f[l>>2]|0;if(!(f[y+(j*48|0)+24>>2]|0))break;x=f[y+(j*48|0)+4>>2]|0;if((x|0)<3)B=Y(f[y+(j*48|0)+12>>2]|0,f[y+(j*48|0)+8>>2]|0)|0;else{v=f[y+(j*48|0)+32>>2]|0;y=0;m=1;while(1){z=Y(f[v+(y<<2)>>2]|0,m)|0;y=y+1|0;if((y|0)==(x|0)){B=z;break}else m=z}}if((x|0)==0|(B|0)==0)break}if(!s){m=f[t+(j*56|0)+4>>2]|0;if((m|0)<3)C=Y(f[t+(j*56|0)+12>>2]|0,f[t+(j*56|0)+8>>2]|0)|0;else{y=f[t+(j*56|0)+40>>2]|0;v=0;r=1;while(1){z=Y(f[y+(v<<2)>>2]|0,r)|0;v=v+1|0;if((v|0)==(m|0)){C=z;break}else r=z}}if(!((m|0)==0|(C|0)==0))D=t+(j*56|0)+8|0;else A=31}else A=31;if((A|0)==31){A=0;D=(f[l>>2]|0)+(j*48|0)+8|0}if(((f[k+(j*56|0)+8>>2]|0)==(d|0)?(f[k+(j*56|0)+12>>2]|0)==(f[D>>2]|0):0)?(f[k+(j*56|0)>>2]&4095|0)==0:0)break;f[h>>2]=0;f[c>>2]=0;n=c$(h,127)|0;o=357273;p=n+127|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-215,h,357262,356857,624);d$(h)}}while(0);j=j+1|0}while(j>>>0<a>>>0);Vt(g);u=e;return}function bCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;f[a>>2]=0;g=a+4|0;f[g>>2]=0;h=f[c>>2]|0;if((h|0)!=357706?(c=(h|0)==0?5694105:h,KKa(c,357706)|0):0){if((h|0)!=357717?KKa(c,357717)|0:0){if((h|0)!=357732?KKa(c,357732)|0:0){if(((h|0)!=357746?!((KKa(c,357746)|0)==0|(h|0)==357765):0)?KKa(c,357765)|0:0){if((h|0)!=357787?KKa(c,357787)|0:0){f[e>>2]=0;f[e+4>>2]=0;c=c$(e,20)|0;h=357809;i=c+20|0;do{b[c>>0]=b[h>>0]|0;c=c+1|0;h=h+1|0}while((c|0)<(i|0));j$(-5,e,357830,356857,1037);d$(e);u=d;return}e=NYa(36)|0;WF(e);h=e+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[e>>2]=105768;f[e+28>>2]=7;b[e+32>>0]=0;h=NYa(16)|0;c=h+4|0;f[c>>2]=1;f[h>>2]=105832;f[h+8>>2]=e;f[c>>2]=(f[c>>2]|0)+1;i=f[a>>2]|0;f[a>>2]=h;f[g>>2]=e;if(i|0?(e=i+4|0,j=f[e>>2]|0,f[e>>2]=j+-1,(j|0)==1):0)ki[f[(f[i>>2]|0)+8>>2]&2047](i);i=f[c>>2]|0;f[c>>2]=i+-1;if((i|0)!=1){u=d;return}ki[f[(f[h>>2]|0)+8>>2]&2047](h);u=d;return}h=NYa(36)|0;WF(h);i=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[h>>2]=105768;f[h+28>>2]=6;b[h+32>>0]=0;i=NYa(16)|0;c=i+4|0;f[c>>2]=1;f[i>>2]=105832;f[i+8>>2]=h;f[c>>2]=(f[c>>2]|0)+1;j=f[a>>2]|0;f[a>>2]=i;f[g>>2]=h;if(j|0?(h=j+4|0,e=f[h>>2]|0,f[h>>2]=e+-1,(e|0)==1):0)ki[f[(f[j>>2]|0)+8>>2]&2047](j);j=f[c>>2]|0;f[c>>2]=j+-1;if((j|0)!=1){u=d;return}ki[f[(f[i>>2]|0)+8>>2]&2047](i);u=d;return}i=NYa(36)|0;WF(i);j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[i>>2]=105768;f[i+28>>2]=2;b[i+32>>0]=0;j=NYa(16)|0;c=j+4|0;f[c>>2]=1;f[j>>2]=105832;f[j+8>>2]=i;f[c>>2]=(f[c>>2]|0)+1;e=f[a>>2]|0;f[a>>2]=j;f[g>>2]=i;if(e|0?(i=e+4|0,h=f[i>>2]|0,f[i>>2]=h+-1,(h|0)==1):0)ki[f[(f[e>>2]|0)+8>>2]&2047](e);e=f[c>>2]|0;f[c>>2]=e+-1;if((e|0)!=1){u=d;return}ki[f[(f[j>>2]|0)+8>>2]&2047](j);u=d;return}j=NYa(36)|0;WF(j);e=j+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[j>>2]=105768;f[j+28>>2]=5;b[j+32>>0]=0;e=NYa(16)|0;c=e+4|0;f[c>>2]=1;f[e>>2]=105832;f[e+8>>2]=j;f[c>>2]=(f[c>>2]|0)+1;h=f[a>>2]|0;f[a>>2]=e;f[g>>2]=j;if(h|0?(j=h+4|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)ki[f[(f[h>>2]|0)+8>>2]&2047](h);h=f[c>>2]|0;f[c>>2]=h+-1;if((h|0)!=1){u=d;return}ki[f[(f[e>>2]|0)+8>>2]&2047](e);u=d;return}e=NYa(36)|0;WF(e);h=e+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[e>>2]=105768;f[e+28>>2]=4;b[e+32>>0]=0;h=NYa(16)|0;c=h+4|0;f[c>>2]=1;f[h>>2]=105832;f[h+8>>2]=e;f[c>>2]=(f[c>>2]|0)+1;i=f[a>>2]|0;f[a>>2]=h;f[g>>2]=e;if(i|0?(e=i+4|0,g=f[e>>2]|0,f[e>>2]=g+-1,(g|0)==1):0)ki[f[(f[i>>2]|0)+8>>2]&2047](i);i=f[c>>2]|0;f[c>>2]=i+-1;if((i|0)!=1){u=d;return}ki[f[(f[h>>2]|0)+8>>2]&2047](h);u=d;return}function cCa(a){a=a|0;qBa(a,105908);OF(a);return}function dCa(a){a=a|0;qBa(a,105908);OF(a);PYa(a);return}function eCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;gBa(e,c);f[a>>2]=0;f[a+4>>2]=0;c=e+4|0;c$(a,(f[c>>2]|0)+4|0)|0;g=f[c>>2]|0;if(!g)h=0;else{K1a(f[a>>2]|0,f[e>>2]|0,g|0)|0;h=f[c>>2]|0}c=(f[a>>2]|0)+h|0;b[c>>0]=46;b[c+1>>0]=79;b[c+2>>0]=82;b[c+3>>0]=66;d$(e);u=d;return}function fCa(a){a=a|0;qBa(a,110220);OF(a);return}function gCa(a){a=a|0;qBa(a,110220);OF(a);PYa(a);return}function hCa(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0.0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0.0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0;j=u;u=u+6016|0;k=j+4952|0;l=j+4896|0;m=j+800|0;o=j+744|0;q=j+688|0;r=j+632|0;s=j+584|0;t=j;v=j+568|0;w=j+560|0;x=j+552|0;y=j+496|0;z=j+440|0;A=j+400|0;B=j+380|0;C=j+368|0;D=j+312|0;E=j+256|0;F=j+208|0;G=j+160|0;H=j+104|0;I=j+48|0;K=j+432|0;L=j+424|0;Q=j+416|0;R=j+392|0;_$(x,106096);S=a+36|0;if((f[S>>2]|0)<=1){f[k>>2]=0;f[k+4>>2]=0;T=c$(k,14)|0;U=357847;V=T+14|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));j$(-215,k,357862,357879,962);d$(k)}W=dT(g)|0;if(W|i^1?!(XS(c)|0):0){X=+((f[S>>2]|0)/2|0|0)*1.4142135623730951;Z=~~X;_=(+(Z|0)<X&1)+Z|0;Z=a+20|0;$=f[Z>>2]|0;aa=(_|0)>4?_:4;_=(($|0)<(aa|0)?aa:$)+1|0;if(vU()|0)if(!(WU()|0)?(NS(c)|0)!=655360:0)ba=(NS(g)|0)==655360;else ba=1;else ba=0;do if((NS(c)|0)==65536){$=f[c+4>>2]|0;f[y>>2]=f[$>>2];aa=y+4|0;ca=$+4|0;f[aa>>2]=f[ca>>2];da=y+8|0;f[da>>2]=f[$+8>>2];f[y+12>>2]=f[$+12>>2];f[y+16>>2]=f[$+16>>2];f[y+20>>2]=f[$+20>>2];f[y+24>>2]=f[$+24>>2];f[y+28>>2]=f[$+28>>2];f[y+32>>2]=f[$+32>>2];ea=f[$+36>>2]|0;f[y+36>>2]=ea;f[y+40>>2]=da;da=y+48|0;fa=y+44|0;f[fa>>2]=da;f[da>>2]=0;f[y+52>>2]=0;if(ea|0){da=ea+12|0;f[da>>2]=(f[da>>2]|0)+1}if((f[ca>>2]|0)<3){ca=f[$+44>>2]|0;da=f[fa>>2]|0;f[da>>2]=f[ca>>2];f[da+4>>2]=f[ca+4>>2];break}else{f[aa>>2]=0;BR(y,$);break}}else OR(y,c,-1);while(0);do if((NS(d)|0)==65536){$=f[d+4>>2]|0;f[z>>2]=f[$>>2];aa=z+4|0;ca=$+4|0;f[aa>>2]=f[ca>>2];da=z+8|0;f[da>>2]=f[$+8>>2];f[z+12>>2]=f[$+12>>2];f[z+16>>2]=f[$+16>>2];f[z+20>>2]=f[$+20>>2];f[z+24>>2]=f[$+24>>2];f[z+28>>2]=f[$+28>>2];f[z+32>>2]=f[$+32>>2];fa=f[$+36>>2]|0;f[z+36>>2]=fa;f[z+40>>2]=da;da=z+48|0;ea=z+44|0;f[ea>>2]=da;f[da>>2]=0;f[z+52>>2]=0;if(fa|0){da=fa+12|0;f[da>>2]=(f[da>>2]|0)+1}if((f[ca>>2]|0)<3){ca=f[$+44>>2]|0;da=f[ea>>2]|0;f[da>>2]=f[ca>>2];f[da+4>>2]=f[ca+4>>2];break}else{f[aa>>2]=0;BR(z,$);break}}else OR(z,d,-1);while(0);if(f[y>>2]&4095|0){d=k+8|0;f[d>>2]=0;f[d+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=y;f6(c,k,6,0)}c=f[a+16>>2]|0;d=e+4|0;$=f[e>>2]|0;aa=(f[d>>2]|0)-$|0;ca=(aa|0)/28|0;da=$;if(i){a:do if((aa|0)>0){$=k+4|0;ea=da;fa=0;ga=0;ha=1;while(1){ia=f[ea+(fa*28|0)+20>>2]|0;if((ia|0)<=-1){f[k>>2]=0;f[$>>2]=0;T=c$(k,10)|0;U=357930;V=T+10|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));j$(-215,k,357862,357879,1001);d$(k)}if((fa|0)>0)ja=ha&(ia|0)>=(f[(f[e>>2]|0)+((fa+-1|0)*28|0)+20>>2]|0);else ja=ha;ka=(ga|0)<(ia|0)?ia:ga;la=fa+1|0;if((la|0)>=(ca|0)){ma=ka;na=ja;break a}ea=f[e>>2]|0;fa=la;ga=ka;ha=ja}}else{ma=0;na=1}while(0);oa=ma+1|0;pa=na}else{oa=c;pa=1}f[A>>2]=0;c=A+4|0;f[c>>2]=0;f[A+8>>2]=0;na=(oa|0)==0;do if(!na)if(oa>>>0>268435455)gXa(A);else{ma=oa<<4;ja=NYa(ma)|0;f[A>>2]=ja;f[A+8>>2]=ja+(oa<<4);F1a(ja|0,0,ma|0)|0;f[c>>2]=ja+ma;qa=ja;break}else qa=0;while(0);f[B>>2]=0;ja=B+4|0;f[ja>>2]=0;f[B+8>>2]=0;if(na)ra=0;else{ma=oa<<2;ca=NYa(ma)|0;f[B>>2]=ca;da=ca+(oa<<2)|0;f[B+8>>2]=da;F1a(ca|0,0,ma|0)|0;f[ja>>2]=da;ra=ca}f[C>>2]=0;ca=C+4|0;f[ca>>2]=0;f[C+8>>2]=0;if(na)sa=0;else{na=oa<<2;da=NYa(na)|0;f[C>>2]=da;ma=da+(oa<<2)|0;f[C+8>>2]=ma;F1a(da|0,0,na|0)|0;f[ca>>2]=ma;sa=da}f[D>>2]=1124007936;da=D+4|0;ma=D+8|0;na=D+40|0;T=da;V=T+36|0;do{f[T>>2]=0;T=T+4|0}while((T|0)<(V|0));f[na>>2]=ma;ma=D+48|0;aa=D+44|0;f[aa>>2]=ma;f[ma>>2]=0;f[D+52>>2]=0;f[E>>2]=1124007936;ha=E+4|0;ga=E+8|0;fa=E+40|0;T=ha;V=T+36|0;do{f[T>>2]=0;T=T+4|0}while((T|0)<(V|0));f[fa>>2]=ga;ea=E+48|0;$=E+44|0;f[$>>2]=ea;f[ea>>2]=0;f[E+52>>2]=0;f[F>>2]=1124007936;ka=F+4|0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;f[ka+16>>2]=0;f[ka+20>>2]=0;f[ka+24>>2]=0;f[F+32>>2]=F+8;ka=F+40|0;f[F+36>>2]=ka;f[F+44>>2]=0;f[ka>>2]=0;f[G>>2]=1124007936;ka=G+4|0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;f[ka+16>>2]=0;f[ka+20>>2]=0;f[ka+24>>2]=0;f[G+32>>2]=G+8;ka=G+40|0;f[G+36>>2]=ka;f[G+44>>2]=0;f[ka>>2]=0;ka=y+8|0;la=f[ka>>2]|0;ta=_<<1;ua=la+ta|0;va=y+12|0;wa=f[va>>2]|0;xa=ta+15+wa&-16;ya=(oa|0)>0;if(ya){X=+p[a+8>>3];za=f[a+24>>2]|0;Aa=f[va>>2]|0;Ba=f[ka>>2]|0;Ca=wa;wa=la;la=ua;Da=0;Ea=0;Fa=0;while(1){Ga=+N(+X,+(+(Fa-za|0)));n[sa+(Fa<<2)>>2]=Ga;Ha=wNa(+(Ca|0)/Ga)|0;Ia=wNa(+(wa|0)/Ga)|0;Ja=Ha+ta|0;Ka=(Ja+Da|0)>(xa|0);La=Ka?0:Da;Ma=(Ka?la:0)+Ea|0;Na=Ka?Ia+ta|0:la;Ka=La+_|0;Oa=Ma+_|0;f[qa+(Fa<<4)>>2]=Ka;f[qa+(Fa<<4)+4>>2]=Oa;f[qa+(Fa<<4)+8>>2]=Ha;f[qa+(Fa<<4)+12>>2]=Ia;Ia=(Y(Oa,xa)|0)+Ka|0;f[ra+(Fa<<2)>>2]=Ia;Ia=Fa+1|0;if((Ia|0)==(oa|0)){Pa=Na;Qa=Ma;break}else{Ca=Aa;wa=Ba;la=Na;Da=La+Ja|0;Ea=Ma;Fa=Ia}}}else{Pa=ua;Qa=0}ua=Pa+Qa|0;f[k>>2]=ua;f[k+4>>2]=xa;AR(D,2,k,0);Qa=z+16|0;b:do if(f[Qa>>2]|0){Pa=f[z+4>>2]|0;if((Pa|0)<3)Ra=Y(f[z+12>>2]|0,f[z+8>>2]|0)|0;else{Fa=f[z+40>>2]|0;Ea=0;Da=1;while(1){la=Y(f[Fa+(Ea<<2)>>2]|0,Da)|0;Ea=Ea+1|0;if((Ea|0)==(Pa|0)){Ra=la;break}else Da=la}}if(!((Pa|0)==0|(Ra|0)==0)){do if(((f[ha>>2]|0)<3?(f[ga>>2]|0)==(ua|0):0)?(f[E+12>>2]|0)==(xa|0):0){if(f[E>>2]&4095|0)break;if(f[E+16>>2]|0)break b}while(0);f[k>>2]=ua;f[k+4>>2]=xa;AR(E,2,k,0)}}while(0);f[H>>2]=f[y>>2];xa=H+4|0;ua=y+4|0;Ra=f[ua>>2]|0;f[xa>>2]=Ra;Pa=H+8|0;f[Pa>>2]=f[ka>>2];ka=H+12|0;f[ka>>2]=f[va>>2];va=H+16|0;Da=y+16|0;f[va>>2]=f[Da>>2];Ea=H+20|0;f[Ea>>2]=f[y+20>>2];Fa=H+24|0;f[Fa>>2]=f[y+24>>2];la=H+28|0;f[la>>2]=f[y+28>>2];Ba=H+32|0;f[Ba>>2]=f[y+32>>2];wa=H+36|0;Aa=y+36|0;Ca=f[Aa>>2]|0;f[wa>>2]=Ca;ra=H+40|0;f[ra>>2]=Pa;qa=H+48|0;sa=H+44|0;f[sa>>2]=qa;f[qa>>2]=0;f[H+52>>2]=0;if(!Ca)Sa=Ra;else{Ra=Ca+12|0;f[Ra>>2]=(f[Ra>>2]|0)+1;Sa=f[ua>>2]|0}if((Sa|0)<3){Sa=f[y+44>>2]|0;Ra=f[sa>>2]|0;f[Ra>>2]=f[Sa>>2];f[Ra+4>>2]=f[Sa+4>>2]}else{f[xa>>2]=0;BR(H,y)}f[I>>2]=f[z>>2];Sa=I+4|0;Ra=z+4|0;Ca=f[Ra>>2]|0;f[Sa>>2]=Ca;za=I+8|0;Ia=z+8|0;f[za>>2]=f[Ia>>2];Ma=I+12|0;Ja=z+12|0;f[Ma>>2]=f[Ja>>2];La=I+16|0;f[La>>2]=f[Qa>>2];Na=I+20|0;f[Na>>2]=f[z+20>>2];Ka=I+24|0;f[Ka>>2]=f[z+24>>2];Oa=I+28|0;f[Oa>>2]=f[z+28>>2];Ha=I+32|0;f[Ha>>2]=f[z+32>>2];Ta=I+36|0;Ua=z+36|0;Va=f[Ua>>2]|0;f[Ta>>2]=Va;Wa=I+40|0;f[Wa>>2]=za;Xa=I+48|0;Ya=I+44|0;f[Ya>>2]=Xa;f[Xa>>2]=0;f[I+52>>2]=0;if(!Va)Za=Ca;else{Ca=Va+12|0;f[Ca>>2]=(f[Ca>>2]|0)+1;Za=f[Ra>>2]|0}if((Za|0)<3){Za=f[z+44>>2]|0;Ca=f[Ya>>2]|0;f[Ca>>2]=f[Za>>2];f[Ca+4>>2]=f[Za+4>>2]}else{f[Sa>>2]=0;BR(I,z)}if(ya){Za=k+4|0;Ca=k+8|0;Va=k+12|0;_a=m+4|0;$a=m+8|0;ab=m+40|0;bb=m+48|0;cb=m+44|0;db=m+52|0;eb=q+4|0;fb=q+8|0;gb=q+12|0;hb=q+4|0;ib=q+8|0;jb=q+40|0;kb=q+48|0;lb=q+44|0;mb=q+52|0;nb=a+24|0;ob=r+8|0;pb=r+12|0;qb=r+4|0;rb=s+8|0;sb=s+4|0;tb=r+8|0;ub=r+12|0;vb=r+4|0;wb=s+8|0;xb=s+4|0;yb=z+40|0;zb=o+36|0;Ab=o+4|0;Bb=o+8|0;Cb=o+12|0;Db=o+44|0;Eb=o+16|0;Fb=o+20|0;Gb=o+24|0;Hb=o+28|0;Ib=o+32|0;Jb=q+36|0;Kb=q+12|0;Lb=q+16|0;Mb=q+20|0;Nb=q+24|0;Ob=q+28|0;Pb=q+32|0;Qb=o+40|0;Rb=o+48|0;Sb=m+36|0;Tb=m+16|0;Ub=l+36|0;Vb=l+16|0;Wb=l+4|0;Xb=l+40|0;Yb=l+44|0;Zb=l+48|0;_b=r+8|0;$b=r+12|0;ac=r+4|0;bc=s+8|0;cc=s+4|0;dc=K+4|0;ec=r+8|0;fc=r+12|0;gc=r+4|0;hc=s+8|0;ic=s+4|0;jc=r+8|0;kc=r+12|0;lc=r+4|0;mc=s+8|0;nc=s+4|0;oc=r+8|0;pc=r+12|0;qc=r+4|0;rc=s+8|0;sc=s+4|0;tc=L+4|0;uc=r+8|0;vc=r+12|0;wc=r+4|0;xc=s+8|0;yc=s+4|0;zc=r+36|0;Ac=r+4|0;Bc=r+8|0;Cc=r+12|0;Dc=m+12|0;Ec=r+44|0;Fc=r+16|0;Gc=r+20|0;Hc=m+20|0;Ic=r+24|0;Jc=m+24|0;Kc=r+28|0;Lc=m+28|0;Mc=r+32|0;Nc=m+32|0;Oc=r+40|0;Pc=r+48|0;Qc=s+4|0;Rc=s+8|0;Sc=s+12|0;Tc=r+36|0;Uc=r+4|0;Vc=r+8|0;Wc=r+12|0;Xc=r+44|0;Yc=r+16|0;Zc=r+20|0;_c=r+24|0;$c=r+28|0;ad=r+32|0;bd=r+40|0;cd=r+48|0;dd=0;do{ed=f[A>>2]|0;fd=f[ed+(dd<<4)+8>>2]|0;gd=f[ed+(dd<<4)+12>>2]|0;hd=(f[ed+(dd<<4)+4>>2]|0)-_|0;f[k>>2]=(f[ed+(dd<<4)>>2]|0)-_;f[Za>>2]=hd;f[Ca>>2]=fd+ta;f[Va>>2]=gd+ta;FR(l,D,k);f[m>>2]=1124007936;T=_a;V=T+36|0;do{f[T>>2]=0;T=T+4|0}while((T|0)<(V|0));f[ab>>2]=$a;f[cb>>2]=bb;f[bb>>2]=0;f[db>>2]=0;f[q>>2]=_;f[eb>>2]=_;f[fb>>2]=fd;f[gb>>2]=gd;FR(o,l,q);f[q>>2]=1124007936;T=hb;V=T+36|0;do{f[T>>2]=0;T=T+4|0}while((T|0)<(V|0));f[jb>>2]=ib;f[lb>>2]=kb;f[kb>>2]=0;f[mb>>2]=0;do if(f[Qa>>2]|0){hd=f[Ra>>2]|0;if((hd|0)<3)id=Y(f[Ja>>2]|0,f[Ia>>2]|0)|0;else{ed=f[yb>>2]|0;jd=0;kd=1;while(1){ld=Y(f[ed+(jd<<2)>>2]|0,kd)|0;jd=jd+1|0;if((jd|0)==(hd|0)){id=ld;break}else kd=ld}}if((hd|0)==0|(id|0)==0)break;FR(r,E,k);kd=f[zc>>2]|0;if(kd|0){jd=kd+12|0;f[jd>>2]=(f[jd>>2]|0)+1}jd=f[Sb>>2]|0;do if(jd|0){kd=jd+12|0;ed=f[kd>>2]|0;f[kd>>2]=ed+-1;if((ed|0)!=1)break;CR(m)}while(0);f[Sb>>2]=0;f[Tb>>2]=0;f[Tb+4>>2]=0;f[Tb+8>>2]=0;f[Tb+12>>2]=0;if((f[_a>>2]|0)>0){jd=f[ab>>2]|0;hd=0;do{f[jd+(hd<<2)>>2]=0;hd=hd+1|0;md=f[_a>>2]|0}while((hd|0)<(md|0));f[m>>2]=f[r>>2];if((md|0)<3)nd=85;else nd=87}else{f[m>>2]=f[r>>2];nd=85}do if((nd|0)==85){nd=0;hd=f[Ac>>2]|0;if((hd|0)>=3){nd=87;break}f[_a>>2]=hd;f[$a>>2]=f[Bc>>2];f[Dc>>2]=f[Cc>>2];hd=f[Ec>>2]|0;jd=f[cb>>2]|0;f[jd>>2]=f[hd>>2];f[jd+4>>2]=f[hd+4>>2]}while(0);if((nd|0)==87){nd=0;BR(m,r)}f[Tb>>2]=f[Fc>>2];f[Hc>>2]=f[Gc>>2];f[Jc>>2]=f[Ic>>2];f[Lc>>2]=f[Kc>>2];f[Nc>>2]=f[Mc>>2];hd=f[zc>>2]|0;f[Sb>>2]=hd;do if(hd|0){jd=hd+12|0;ed=f[jd>>2]|0;f[jd>>2]=ed+-1;if((ed|0)!=1)break;CR(r)}while(0);f[zc>>2]=0;f[Fc>>2]=0;f[Fc+4>>2]=0;f[Fc+8>>2]=0;f[Fc+12>>2]=0;if((f[Ac>>2]|0)>0){hd=f[Oc>>2]|0;ed=0;do{f[hd+(ed<<2)>>2]=0;ed=ed+1|0}while((ed|0)<(f[Ac>>2]|0))}ed=f[Ec>>2]|0;if((ed|0)!=(Pc|0))ZF(ed);f[s>>2]=_;f[Qc>>2]=_;f[Rc>>2]=fd;f[Sc>>2]=gd;FR(r,m,s);ed=f[Tc>>2]|0;if(ed|0){hd=ed+12|0;f[hd>>2]=(f[hd>>2]|0)+1}hd=f[Jb>>2]|0;do if(hd|0){ed=hd+12|0;jd=f[ed>>2]|0;f[ed>>2]=jd+-1;if((jd|0)!=1)break;CR(q)}while(0);f[Jb>>2]=0;f[Lb>>2]=0;f[Lb+4>>2]=0;f[Lb+8>>2]=0;f[Lb+12>>2]=0;if((f[hb>>2]|0)>0){hd=f[jb>>2]|0;jd=0;do{f[hd+(jd<<2)>>2]=0;jd=jd+1|0;od=f[hb>>2]|0}while((jd|0)<(od|0));f[q>>2]=f[r>>2];if((od|0)<3)nd=106;else nd=108}else{f[q>>2]=f[r>>2];nd=106}do if((nd|0)==106){nd=0;jd=f[Uc>>2]|0;if((jd|0)>=3){nd=108;break}f[hb>>2]=jd;f[ib>>2]=f[Vc>>2];f[Kb>>2]=f[Wc>>2];jd=f[Xc>>2]|0;hd=f[lb>>2]|0;f[hd>>2]=f[jd>>2];f[hd+4>>2]=f[jd+4>>2]}while(0);if((nd|0)==108){nd=0;BR(q,r)}f[Lb>>2]=f[Yc>>2];f[Mb>>2]=f[Zc>>2];f[Nb>>2]=f[_c>>2];f[Ob>>2]=f[$c>>2];f[Pb>>2]=f[ad>>2];jd=f[Tc>>2]|0;f[Jb>>2]=jd;do if(jd|0){hd=jd+12|0;ed=f[hd>>2]|0;f[hd>>2]=ed+-1;if((ed|0)!=1)break;CR(r)}while(0);f[Tc>>2]=0;f[Yc>>2]=0;f[Yc+4>>2]=0;f[Yc+8>>2]=0;f[Yc+12>>2]=0;if((f[Uc>>2]|0)>0){jd=f[bd>>2]|0;ed=0;do{f[jd+(ed<<2)>>2]=0;ed=ed+1|0}while((ed|0)<(f[Uc>>2]|0))}ed=f[Xc>>2]|0;if((ed|0)!=(cd|0))ZF(ed)}while(0);do if((dd|0)==(f[nb>>2]|0)){f[ob>>2]=0;f[pb>>2]=0;f[r>>2]=16842752;f[qb>>2]=y;ed=rb;f[ed>>2]=0;f[ed+4>>2]=0;f[s>>2]=33619968;f[sb>>2]=l;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=0;f[t+20>>2]=0;f[t+24>>2]=0;f[t+28>>2]=0;mL(r,s,_,_,_,_,4,t);if(!(f[Qa>>2]|0))break;ed=f[Ra>>2]|0;if((ed|0)<3)pd=Y(f[Ja>>2]|0,f[Ia>>2]|0)|0;else{jd=f[yb>>2]|0;hd=0;kd=1;while(1){ia=Y(f[jd+(hd<<2)>>2]|0,kd)|0;hd=hd+1|0;if((hd|0)==(ed|0)){pd=ia;break}else kd=ia}}if((ed|0)==0|(pd|0)==0)break;f[tb>>2]=0;f[ub>>2]=0;f[r>>2]=16842752;f[vb>>2]=z;kd=wb;f[kd>>2]=0;f[kd+4>>2]=0;f[s>>2]=33619968;f[xb>>2]=m;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=0;f[t+20>>2]=0;f[t+24>>2]=0;f[t+28>>2]=0;mL(r,s,_,_,_,_,16,t)}else{f[_b>>2]=0;f[$b>>2]=0;f[r>>2]=16842752;f[ac>>2]=H;kd=bc;f[kd>>2]=0;f[kd+4>>2]=0;f[s>>2]=33619968;f[cc>>2]=o;f[K>>2]=fd;f[dc>>2]=gd;fna(r,s,K,0.0,0.0,1);do if(f[Qa>>2]|0){kd=f[Ra>>2]|0;if((kd|0)<3)qd=Y(f[Ja>>2]|0,f[Ia>>2]|0)|0;else{hd=f[yb>>2]|0;jd=0;ia=1;while(1){ld=Y(f[hd+(jd<<2)>>2]|0,ia)|0;jd=jd+1|0;if((jd|0)==(kd|0)){qd=ld;break}else ia=ld}}if((kd|0)==0|(qd|0)==0)break;f[oc>>2]=0;f[pc>>2]=0;f[r>>2]=16842752;f[qc>>2]=I;ia=rc;f[ia>>2]=0;f[ia+4>>2]=0;f[s>>2]=33619968;f[sc>>2]=q;f[L>>2]=fd;f[tc>>2]=gd;fna(r,s,L,0.0,0.0,1);if((dd|0)<=(f[nb>>2]|0))break;f[uc>>2]=0;f[vc>>2]=0;f[r>>2]=16842752;f[wc>>2]=q;ia=xc;f[ia>>2]=0;f[ia+4>>2]=0;f[s>>2]=33619968;f[yc>>2]=q;+gqa(r,s,254.0,0.0,3)}while(0);f[ec>>2]=0;f[fc>>2]=0;f[r>>2]=16842752;f[gc>>2]=o;ed=hc;f[ed>>2]=0;f[ed+4>>2]=0;f[s>>2]=33619968;f[ic>>2]=l;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=0;f[t+20>>2]=0;f[t+24>>2]=0;f[t+28>>2]=0;mL(r,s,_,_,_,_,20,t);if(!(f[Qa>>2]|0))break;ed=f[Ra>>2]|0;if((ed|0)<3)rd=Y(f[Ja>>2]|0,f[Ia>>2]|0)|0;else{ia=f[yb>>2]|0;jd=0;hd=1;while(1){ld=Y(f[ia+(jd<<2)>>2]|0,hd)|0;jd=jd+1|0;if((jd|0)==(ed|0)){rd=ld;break}else hd=ld}}if((ed|0)==0|(rd|0)==0)break;f[jc>>2]=0;f[kc>>2]=0;f[r>>2]=16842752;f[lc>>2]=q;hd=mc;f[hd>>2]=0;f[hd+4>>2]=0;f[s>>2]=33619968;f[nc>>2]=m;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=0;f[t+20>>2]=0;f[t+24>>2]=0;f[t+28>>2]=0;mL(r,s,_,_,_,_,16,t)}while(0);gd=f[zb>>2]|0;if(gd|0){fd=gd+12|0;f[fd>>2]=(f[fd>>2]|0)+1}fd=f[wa>>2]|0;do if(fd|0){gd=fd+12|0;hd=f[gd>>2]|0;f[gd>>2]=hd+-1;if((hd|0)!=1)break;CR(H)}while(0);f[wa>>2]=0;f[va>>2]=0;f[va+4>>2]=0;f[va+8>>2]=0;f[va+12>>2]=0;if((f[xa>>2]|0)>0){fd=f[ra>>2]|0;hd=0;do{f[fd+(hd<<2)>>2]=0;hd=hd+1|0;sd=f[xa>>2]|0}while((hd|0)<(sd|0));f[H>>2]=f[o>>2];if((sd|0)<3)nd=151;else nd=153}else{f[H>>2]=f[o>>2];nd=151}do if((nd|0)==151){nd=0;hd=f[Ab>>2]|0;if((hd|0)>=3){nd=153;break}f[xa>>2]=hd;f[Pa>>2]=f[Bb>>2];f[ka>>2]=f[Cb>>2];hd=f[Db>>2]|0;fd=f[sa>>2]|0;f[fd>>2]=f[hd>>2];f[fd+4>>2]=f[hd+4>>2]}while(0);if((nd|0)==153){nd=0;BR(H,o)}f[va>>2]=f[Eb>>2];f[Ea>>2]=f[Fb>>2];f[Fa>>2]=f[Gb>>2];f[la>>2]=f[Hb>>2];f[Ba>>2]=f[Ib>>2];f[wa>>2]=f[zb>>2];hd=f[Jb>>2]|0;if(hd|0){fd=hd+12|0;f[fd>>2]=(f[fd>>2]|0)+1}fd=f[Ta>>2]|0;do if(fd|0){hd=fd+12|0;gd=f[hd>>2]|0;f[hd>>2]=gd+-1;if((gd|0)!=1)break;CR(I)}while(0);f[Ta>>2]=0;f[La>>2]=0;f[La+4>>2]=0;f[La+8>>2]=0;f[La+12>>2]=0;if((f[Sa>>2]|0)>0){fd=f[Wa>>2]|0;gd=0;do{f[fd+(gd<<2)>>2]=0;gd=gd+1|0;td=f[Sa>>2]|0}while((gd|0)<(td|0));f[I>>2]=f[q>>2];if((td|0)<3)nd=164;else nd=166}else{f[I>>2]=f[q>>2];nd=164}do if((nd|0)==164){nd=0;gd=f[hb>>2]|0;if((gd|0)>=3){nd=166;break}f[Sa>>2]=gd;f[za>>2]=f[ib>>2];f[Ma>>2]=f[Kb>>2];gd=f[lb>>2]|0;fd=f[Ya>>2]|0;f[fd>>2]=f[gd>>2];f[fd+4>>2]=f[gd+4>>2]}while(0);if((nd|0)==166){nd=0;BR(I,q)}f[La>>2]=f[Lb>>2];f[Na>>2]=f[Mb>>2];f[Ka>>2]=f[Nb>>2];f[Oa>>2]=f[Ob>>2];f[Ha>>2]=f[Pb>>2];gd=f[Jb>>2]|0;f[Ta>>2]=gd;do if(gd|0){fd=gd+12|0;hd=f[fd>>2]|0;f[fd>>2]=hd+-1;if((hd|0)!=1)break;CR(q)}while(0);f[Jb>>2]=0;f[Lb>>2]=0;f[Lb+4>>2]=0;f[Lb+8>>2]=0;f[Lb+12>>2]=0;if((f[hb>>2]|0)>0){gd=f[jb>>2]|0;hd=0;do{f[gd+(hd<<2)>>2]=0;hd=hd+1|0}while((hd|0)<(f[hb>>2]|0))}hd=f[lb>>2]|0;if((hd|0)!=(kb|0))ZF(hd);hd=f[zb>>2]|0;do if(hd|0){gd=hd+12|0;fd=f[gd>>2]|0;f[gd>>2]=fd+-1;if((fd|0)!=1)break;CR(o)}while(0);f[zb>>2]=0;f[Eb>>2]=0;f[Eb+4>>2]=0;f[Eb+8>>2]=0;f[Eb+12>>2]=0;if((f[Ab>>2]|0)>0){hd=f[Qb>>2]|0;fd=0;do{f[hd+(fd<<2)>>2]=0;fd=fd+1|0}while((fd|0)<(f[Ab>>2]|0))}fd=f[Db>>2]|0;if((fd|0)!=(Rb|0))ZF(fd);fd=f[Sb>>2]|0;do if(fd|0){hd=fd+12|0;gd=f[hd>>2]|0;f[hd>>2]=gd+-1;if((gd|0)!=1)break;CR(m)}while(0);f[Sb>>2]=0;f[Tb>>2]=0;f[Tb+4>>2]=0;f[Tb+8>>2]=0;f[Tb+12>>2]=0;if((f[_a>>2]|0)>0){fd=f[ab>>2]|0;gd=0;do{f[fd+(gd<<2)>>2]=0;gd=gd+1|0}while((gd|0)<(f[_a>>2]|0))}gd=f[cb>>2]|0;if((gd|0)!=(bb|0))ZF(gd);gd=f[Ub>>2]|0;do if(gd|0){fd=gd+12|0;hd=f[fd>>2]|0;f[fd>>2]=hd+-1;if((hd|0)!=1)break;CR(l)}while(0);f[Ub>>2]=0;f[Vb>>2]=0;f[Vb+4>>2]=0;f[Vb+8>>2]=0;f[Vb+12>>2]=0;if((f[Wb>>2]|0)>0){gd=f[Xb>>2]|0;hd=0;do{f[gd+(hd<<2)>>2]=0;hd=hd+1|0}while((hd|0)<(f[Wb>>2]|0))}hd=f[Yb>>2]|0;if((hd|0)!=(Zb|0))ZF(hd);dd=dd+1|0}while((dd|0)<(oa|0))}if(ba){dd=k+8|0;f[dd>>2]=0;f[dd+4>>2]=0;f[k>>2]=34209792;f[k+4>>2]=G;DCa(B,k)}do if(i){dd=f[y+40>>2]|0;Zb=f[dd>>2]|0;f[Q>>2]=f[dd+4>>2];f[Q+4>>2]=Zb;uBa(e,Q,f[Z>>2]|0);if(pa)break;FCa(k,oa);Zb=f[d>>2]|0;dd=f[e>>2]|0;Yb=Zb-dd|0;Wb=(Yb|0)/28|0;Xb=dd;dd=Zb;if((Yb|0)>0){Yb=l+4|0;Zb=Xb;Vb=0;do{Ub=f[Zb+(Vb*28|0)+20>>2]|0;if((Ub|0)>-1)ud=Zb;else{f[l>>2]=0;f[Yb>>2]=0;T=c$(l,10)|0;U=358044;V=T+10|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));j$(-215,l,357862,357879,1113);d$(l);ud=f[e>>2]|0}ed=f[k>>2]|0;bb=ud+(Vb*28|0)|0;cb=ed+(Ub*12|0)+4|0;_a=f[cb>>2]|0;if((_a|0)==(f[ed+(Ub*12|0)+8>>2]|0))kY(ed+(Ub*12|0)|0,bb);else{f[_a>>2]=f[bb>>2];f[_a+4>>2]=f[ud+(Vb*28|0)+4>>2];bb=_a+8|0;_a=ud+(Vb*28|0)+8|0;f[bb>>2]=f[_a>>2];f[bb+4>>2]=f[_a+4>>2];f[bb+8>>2]=f[_a+8>>2];f[bb+12>>2]=f[_a+12>>2];f[bb+16>>2]=f[_a+16>>2];f[cb>>2]=(f[cb>>2]|0)+28}Vb=Vb+1|0;Zb=f[e>>2]|0}while((Vb|0)<(Wb|0));vd=Zb;wd=f[d>>2]|0}else{vd=Xb;wd=dd}if((wd|0)!=(vd|0))f[d>>2]=wd+(~(((wd+-28-vd|0)>>>0)/28|0)*28|0);Wb=f[k>>2]|0;if(ya){Vb=e+8|0;Yb=Wb;cb=0;while(1){_a=f[Yb+(cb*12|0)>>2]|0;bb=f[Yb+(cb*12|0)+4>>2]|0;if((_a|0)==(bb|0))xd=Yb;else{ed=_a;do{_a=f[d>>2]|0;if((_a|0)==(f[Vb>>2]|0))kY(e,ed);else{f[_a>>2]=f[ed>>2];f[_a+4>>2]=f[ed+4>>2];ab=_a+8|0;_a=ed+8|0;f[ab>>2]=f[_a>>2];f[ab+4>>2]=f[_a+4>>2];f[ab+8>>2]=f[_a+8>>2];f[ab+12>>2]=f[_a+12>>2];f[ab+16>>2]=f[_a+16>>2];f[d>>2]=(f[d>>2]|0)+28}ed=ed+28|0}while((ed|0)!=(bb|0));xd=f[k>>2]|0}cb=cb+1|0;if((cb|0)>=(oa|0)){yd=xd;break}else Yb=xd}}else yd=Wb;if(yd|0){Yb=k+4|0;cb=f[Yb>>2]|0;if((cb|0)==(yd|0))zd=yd;else{Vb=cb;while(1){cb=Vb+-12|0;f[Yb>>2]=cb;dd=f[cb>>2]|0;if(!dd)Ad=cb;else{cb=Vb+-8|0;Xb=f[cb>>2]|0;if((Xb|0)!=(dd|0))f[cb>>2]=Xb+(~(((Xb+-28-dd|0)>>>0)/28|0)*28|0);PYa(dd);Ad=f[Yb>>2]|0}if((Ad|0)==(yd|0))break;else Vb=Ad}zd=f[k>>2]|0}PYa(zd)}}else{if(ba){Vb=k+8|0;f[Vb>>2]=0;f[Vb+4>>2]=0;f[k>>2]=34209792;f[k+4>>2]=F;eL(D,k)}Vb=f[a+4>>2]|0;X=+p[a+8>>3];Yb=f[Z>>2]|0;Wb=f[S>>2]|0;dd=f[a+32>>2]|0;Xb=f[a+40>>2]|0;cb=(f[c>>2]|0)-(f[A>>2]|0)|0;Zb=cb>>4;f[l>>2]=0;bb=l+4|0;f[bb>>2]=0;f[l+8>>2]=0;ed=(Zb|0)==0;do if(!ed)if(Zb>>>0>1073741823)gXa(l);else{Ub=cb>>2;_a=NYa(Ub)|0;f[l>>2]=_a;ab=_a+(Zb<<2)|0;f[l+8>>2]=ab;F1a(_a|0,0,Ub|0)|0;f[bb>>2]=ab;Bd=_a;break}else Bd=0;while(0);Ga=1.0/X;_a=Zb+-1|0;if((cb|0)>16){ab=0;Cd=+(Vb|0)*(1.0-Ga)/(1.0-+N(+Ga,+(+(Zb|0))));Ub=0;while(1){Tb=wNa(Cd)|0;f[Bd+(ab<<2)>>2]=Tb;Sb=Tb+Ub|0;ab=ab+1|0;if((ab|0)>=(_a|0)){Dd=Sb;break}else{Cd=Ga*Cd;Ub=Sb}}}else Dd=0;Ub=Vb-Dd|0;f[Bd+(_a<<2)>>2]=(Ub|0)>0?Ub:0;Ub=(Wb|0)/2|0;ab=Ub+2|0;f[m>>2]=0;Sb=m+4|0;f[Sb>>2]=0;f[m+8>>2]=0;do if(ab)if(ab>>>0>1073741823)gXa(m);else{Tb=ab<<2;Rb=NYa(Tb)|0;f[m>>2]=Rb;Db=Rb+(ab<<2)|0;f[m+8>>2]=Db;F1a(Rb|0,0,Tb|0)|0;f[Sb>>2]=Db;Ed=Rb;break}else Ed=0;while(0);Cd=+(Ub|0)*1.4142135381698608*.5;Ga=Cd+1.0;ab=~~Ga;_a=+(ab|0)>Ga;Vb=~~Cd;Rb=(+(Vb|0)<Cd&1)+Vb|0;if((ab|0)>=(_a&1|0)){Cd=+(Ub|0);Ga=Cd*Cd;Vb=ab+1+(_a<<31>>31)|0;_a=0;do{ab=rNa(+M(+(Ga-+(Y(_a,_a)|0))))|0;f[Ed+(_a<<2)>>2]=ab;_a=_a+1|0}while((_a|0)!=(Vb|0))}if((Ub|0)>=(Rb|0)){Vb=Ub;_a=0;while(1){ab=f[Ed+(_a<<2)>>2]|0;Db=_a;while(1){Fd=Db+1|0;if((ab|0)==(f[Ed+(Fd<<2)>>2]|0))Db=Fd;else break}f[Ed+(Vb<<2)>>2]=Db;if((Vb|0)>(Rb|0)){Vb=Vb+-1|0;_a=Fd}else break}}_a=f[e>>2]|0;Vb=f[d>>2]|0;if((Vb|0)!=(_a|0))f[d>>2]=Vb+(~(((Vb+-28-_a|0)>>>0)/28|0)*28|0);f[o>>2]=0;_a=o+4|0;f[_a>>2]=0;f[o+8>>2]=0;f[q>>2]=0;Vb=q+4|0;f[Vb>>2]=0;f[q+8>>2]=0;do if(!ed)if(Zb>>>0>1073741823)gXa(q);else{Rb=cb>>2;ab=NYa(Rb)|0;f[q>>2]=ab;Tb=ab+(Zb<<2)|0;f[q+8>>2]=Tb;F1a(ab|0,0,Rb|0)|0;f[Vb>>2]=Tb;break}while(0);ECa(o,f[Bd>>2]<<1);ed=(cb|0)>0;if(ed){Tb=E+16|0;Rb=r+4|0;ab=r+8|0;Ab=r+40|0;Qb=r+48|0;Eb=r+44|0;zb=r+52|0;kb=s+4|0;lb=t+8|0;hb=t+12|0;jb=t+4|0;Lb=v+8|0;Jb=v+12|0;Pb=v+4|0;Ha=k+40|0;Ob=w+4|0;Oa=(dd|0)==0&1;Nb=r+36|0;Ka=r+16|0;Mb=k+36|0;Na=k+16|0;Kb=k+4|0;Ma=k+44|0;ib=k+48|0;za=e+8|0;Ga=+(Wb|0);td=E+12|0;Ib=0;do{Ba=f[(f[l>>2]|0)+(Ib<<2)>>2]|0;FR(k,D,(f[A>>2]|0)+(Ib<<4)|0);do if(!(f[Tb>>2]|0))nd=237;else{Hb=f[ha>>2]|0;if((Hb|0)<3)Gd=Y(f[td>>2]|0,f[ga>>2]|0)|0;else{la=f[fa>>2]|0;Gb=0;Fa=1;while(1){Fb=Y(f[la+(Gb<<2)>>2]|0,Fa)|0;Gb=Gb+1|0;if((Gb|0)==(Hb|0)){Gd=Fb;break}else Fa=Fb}}if((Hb|0)==0|(Gd|0)==0){nd=237;break}FR(r,E,(f[A>>2]|0)+(Ib<<4)|0)}while(0);if((nd|0)==237){nd=0;f[r>>2]=1124007936;T=Rb;V=T+36|0;do{f[T>>2]=0;T=T+4|0}while((T|0)<(V|0));f[Ab>>2]=ab;f[Eb>>2]=Qb;f[Qb>>2]=0;f[zb>>2]=0}NAa(s,Xb,1,2);Db=f[kb>>2]|0;Fa=f[(f[Db>>2]|0)+32>>2]|0;f[lb>>2]=0;f[hb>>2]=0;f[t>>2]=16842752;f[jb>>2]=k;f[Lb>>2]=0;f[Jb>>2]=0;f[v>>2]=16842752;f[Pb>>2]=r;Ah[Fa&255](Db,t,o,v);Db=f[s>>2]|0;do if(Db|0){Fa=Db+4|0;Gb=f[Fa>>2]|0;f[Fa>>2]=Gb+-1;if((Gb|0)!=1)break;ki[f[(f[Db>>2]|0)+8>>2]&2047](Db)}while(0);Db=f[Ha>>2]|0;Gb=f[Db>>2]|0;f[w>>2]=f[Db+4>>2];f[Ob>>2]=Gb;uBa(o,w,Yb);rBa(o,Ba<<Oa);Gb=f[_a>>2]|0;Db=f[o>>2]|0;Fa=Gb-Db|0;la=(Fa|0)/28|0;f[(f[q>>2]|0)+(Ib<<2)>>2]=la;kd=Db;Db=Gb;if((Fa|0)>0){Cd=Ga*+n[(f[C>>2]|0)+(Ib<<2)>>2];Fa=0;do{f[kd+(Fa*28|0)+20>>2]=Ib;n[kd+(Fa*28|0)+8>>2]=Cd;Fa=Fa+1|0}while((Fa|0)<(la|0))}if((kd|0)!=(Db|0)){la=kd;do{Fa=f[d>>2]|0;if((Fa|0)==(f[za>>2]|0))kY(e,la);else{f[Fa>>2]=f[la>>2];f[Fa+4>>2]=f[la+4>>2];Ba=Fa+8|0;Fa=la+8|0;f[Ba>>2]=f[Fa>>2];f[Ba+4>>2]=f[Fa+4>>2];f[Ba+8>>2]=f[Fa+8>>2];f[Ba+12>>2]=f[Fa+12>>2];f[Ba+16>>2]=f[Fa+16>>2];f[d>>2]=(f[d>>2]|0)+28}la=la+28|0}while((la|0)!=(Db|0))}Db=f[Nb>>2]|0;do if(Db|0){la=Db+12|0;kd=f[la>>2]|0;f[la>>2]=kd+-1;if((kd|0)!=1)break;CR(r)}while(0);f[Nb>>2]=0;f[Ka>>2]=0;f[Ka+4>>2]=0;f[Ka+8>>2]=0;f[Ka+12>>2]=0;if((f[Rb>>2]|0)>0){Db=f[Ab>>2]|0;kd=0;do{f[Db+(kd<<2)>>2]=0;kd=kd+1|0}while((kd|0)<(f[Rb>>2]|0))}kd=f[Eb>>2]|0;if((kd|0)!=(Qb|0))ZF(kd);kd=f[Mb>>2]|0;do if(kd|0){Db=kd+12|0;la=f[Db>>2]|0;f[Db>>2]=la+-1;if((la|0)!=1)break;CR(k)}while(0);f[Mb>>2]=0;f[Na>>2]=0;f[Na+4>>2]=0;f[Na+8>>2]=0;f[Na+12>>2]=0;if((f[Kb>>2]|0)>0){kd=f[Ha>>2]|0;la=0;do{f[kd+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[Kb>>2]|0))}la=f[Ma>>2]|0;if((la|0)!=(ib|0))ZF(la);Ib=Ib+1|0}while((Ib|0)<(Zb|0))}Ib=(f[d>>2]|0)-(f[e>>2]|0)|0;if(Ib|0){ib=(Ib|0)/28|0;f[r>>2]=1124007936;Ib=r+4|0;Ma=r+8|0;Kb=r+40|0;T=Ib;V=T+36|0;do{f[T>>2]=0;T=T+4|0}while((T|0)<(V|0));f[Kb>>2]=Ma;Ha=r+48|0;Na=r+44|0;f[Na>>2]=Ha;f[Ha>>2]=0;f[r+52>>2]=0;f[s>>2]=1124007936;Mb=s+4|0;f[Mb>>2]=0;f[Mb+4>>2]=0;f[Mb+8>>2]=0;f[Mb+12>>2]=0;f[Mb+16>>2]=0;f[Mb+20>>2]=0;f[Mb+24>>2]=0;f[s+32>>2]=s+8;Mb=s+40|0;f[s+36>>2]=Mb;f[s+44>>2]=0;f[Mb>>2]=0;f[t>>2]=1124007936;Mb=t+4|0;f[Mb>>2]=0;f[Mb+4>>2]=0;f[Mb+8>>2]=0;f[Mb+12>>2]=0;f[Mb+16>>2]=0;f[Mb+20>>2]=0;f[Mb+24>>2]=0;f[t+32>>2]=t+8;Mb=t+40|0;f[t+36>>2]=Mb;f[t+44>>2]=0;f[Mb>>2]=0;f[k>>2]=1;f[k+4>>2]=ib;h0(t,2,k,5,0);if(!dd){Mb=f[D>>2]|0;if(!(Mb&4095))Hd=Mb;else{f[k>>2]=0;f[k+4>>2]=0;T=c$(k,86)|0;U=357941;V=T+86|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));j$(-215,k,358028,357879,134);d$(k);Hd=f[D>>2]|0}dd=(f[d>>2]|0)-(f[e>>2]|0)|0;ib=f[D+16>>2]|0;Ma=((f[ma>>2]|0)>>>0)/((1212424721>>>(Hd<<2&28)&15)>>>0)|0;Mb=k+8|0;f[k>>2]=Mb;Qb=k+4|0;f[Qb>>2]=49;f[Mb>>2]=0;f[k+12>>2]=1;f[k+16>>2]=2;f[k+20>>2]=3;f[k+24>>2]=4;f[k+28>>2]=5;f[k+32>>2]=6;f[k+36>>2]=Ma;Eb=Ma+1|0;f[k+40>>2]=Eb;f[k+44>>2]=Ma+2;f[k+48>>2]=Ma+3;f[k+52>>2]=Ma+4;f[k+56>>2]=Ma+5;f[k+60>>2]=Ma+6;Rb=Ma<<1;f[k+64>>2]=Rb;f[k+68>>2]=Rb|1;f[k+72>>2]=Rb+2;f[k+76>>2]=Rb+3;f[k+80>>2]=Rb+4;f[k+84>>2]=Rb+5;f[k+88>>2]=Rb+6;Rb=Ma*3|0;f[k+92>>2]=Rb;f[k+96>>2]=Rb+1;f[k+100>>2]=Rb+2;f[k+104>>2]=Rb+3;f[k+108>>2]=Rb+4;f[k+112>>2]=Rb+5;f[k+116>>2]=Rb+6;Rb=Ma<<2;f[k+120>>2]=Rb;f[k+124>>2]=Rb|1;f[k+128>>2]=Rb|2;f[k+132>>2]=Rb|3;f[k+136>>2]=Rb+4;f[k+140>>2]=Rb+5;f[k+144>>2]=Rb+6;Rb=Ma*5|0;f[k+148>>2]=Rb;f[k+152>>2]=Rb+1;f[k+156>>2]=Rb+2;f[k+160>>2]=Rb+3;f[k+164>>2]=Rb+4;f[k+168>>2]=Rb+5;f[k+172>>2]=Rb+6;Rb=Ma*6|0;f[k+176>>2]=Rb;f[k+180>>2]=Rb|1;f[k+184>>2]=Rb+2;f[k+188>>2]=Rb+3;f[k+192>>2]=Rb+4;f[k+196>>2]=Rb+5;f[k+200>>2]=Rb+6;Rb=(dd|0)/28|0;if(dd|0){dd=0-Ma|0;Ab=1-Ma|0;Ka=~Ma;Nb=Ma+-1|0;za=f[e>>2]|0;Oa=f[A>>2]|0;Yb=0;do{Ob=wNa(+n[za+(Yb*28|0)>>2])|0;Pb=wNa(+n[za+(Yb*28|0)+4>>2])|0;Jb=f[za+(Yb*28|0)+20>>2]|0;Lb=ib+(Y(Pb+-3+(f[Oa+(Jb<<4)+4>>2]|0)|0,Ma)|0)+Ob+-3|0;Ob=Lb+(f[Oa+(Jb<<4)>>2]|0)|0;Jb=0;Lb=0;Pb=0;jb=0;do{hb=Ob+(f[k+8+(jb<<2)>>2]|0)|0;lb=h[hb+Ab>>0]|0;kb=h[hb+Ka>>0]|0;Xb=h[hb+Eb>>0]|0;zb=h[hb+Nb>>0]|0;ab=lb-kb+((h[hb+1>>0]|0)-(h[hb+-1>>0]|0)<<1)+(Xb-zb)|0;td=Xb-(kb+lb)+zb+((h[hb+Ma>>0]|0)-(h[hb+dd>>0]|0)<<1)|0;Jb=(Y(ab,ab)|0)+Jb|0;Lb=(Y(td,td)|0)+Lb|0;Pb=(Y(td,ab)|0)+Pb|0;jb=jb+1|0}while((jb|0)!=49);Ga=+(Jb|0);Cd=+(Lb|0);X=+(Pb|0);Id=Ga+Cd;n[za+(Yb*28|0)+16>>2]=(Ga*Cd-X*X-Id*(Id*.03999999910593033))*3.847753306718862e-16;Yb=Yb+1|0}while(Yb>>>0<Rb>>>0)}Rb=f[k>>2]|0;if((Rb|0)!=(Mb|0)){if(Rb|0)QYa(Rb);f[k>>2]=Mb;f[Qb>>2]=264}f[k>>2]=0;Rb=k+4|0;f[Rb>>2]=0;f[k+8>>2]=0;ECa(k,Y(f[f[l>>2]>>2]|0,Zb)|0);if(ed){Yb=k+8|0;za=0;dd=0;do{Ma=f[(f[l>>2]|0)+(za<<2)>>2]|0;Nb=f[(f[q>>2]|0)+(za<<2)>>2]|0;Eb=f[_a>>2]|0;Ka=f[o>>2]|0;Ab=(Eb-Ka|0)/28|0;Oa=Ka;Ka=Eb;if(Nb>>>0<=Ab>>>0){do if(Nb>>>0<Ab>>>0){Eb=Oa+(Nb*28|0)|0;if((Ka|0)==(Eb|0))break;f[_a>>2]=Ka+(~(((Ka+-28-Eb|0)>>>0)/28|0)*28|0)}while(0);if(Nb|0){Jd=Oa;nd=289}}else{lY(o,Nb-Ab|0);Jd=f[o>>2]|0;nd=289}if((nd|0)==289){nd=0;Ka=(f[e>>2]|0)+(dd*28|0)|0;Pb=Ka+(Nb*28|0)|0;Lb=Ka;Ka=Jd;while(1){f[Ka>>2]=f[Lb>>2];f[Ka+4>>2]=f[Lb+4>>2];Jb=Ka+8|0;Eb=Lb+8|0;f[Jb>>2]=f[Eb>>2];f[Jb+4>>2]=f[Eb+4>>2];f[Jb+8>>2]=f[Eb+8>>2];f[Jb+12>>2]=f[Eb+12>>2];f[Jb+16>>2]=f[Eb+16>>2];Lb=Lb+28|0;if((Lb|0)==(Pb|0))break;else Ka=Ka+28|0}}dd=Nb+dd|0;rBa(o,Ma);Ka=f[o>>2]|0;Pb=f[_a>>2]|0;if((Ka|0)!=(Pb|0)){Lb=Ka;do{Ka=f[Rb>>2]|0;if((Ka|0)==(f[Yb>>2]|0))kY(k,Lb);else{f[Ka>>2]=f[Lb>>2];f[Ka+4>>2]=f[Lb+4>>2];Ab=Ka+8|0;Oa=Lb+8|0;f[Ab>>2]=f[Oa>>2];f[Ab+4>>2]=f[Oa+4>>2];f[Ab+8>>2]=f[Oa+8>>2];f[Ab+12>>2]=f[Oa+12>>2];f[Ab+16>>2]=f[Oa+16>>2];f[Rb>>2]=Ka+28}Lb=Lb+28|0}while((Lb|0)!=(Pb|0))}za=za+1|0}while((za|0)<(Zb|0));Kd=Yb}else Kd=k+8|0;Yb=f[e>>2]|0;f[e>>2]=f[k>>2];f[k>>2]=Yb;Zb=f[d>>2]|0;f[d>>2]=f[Rb>>2];f[Rb>>2]=Zb;za=e+8|0;dd=f[za>>2]|0;f[za>>2]=f[Kd>>2];f[Kd>>2]=dd;dd=Yb;za=Zb;if(Yb|0){if((za|0)!=(Yb|0))f[Rb>>2]=za+(~(((za+-28-Yb|0)>>>0)/28|0)*28|0);PYa(dd)}}dd=f[e>>2]|0;Yb=(f[d>>2]|0)-dd|0;za=(Yb|0)/28|0;Zb=f[f[aa>>2]>>2]|0;ed=(Zb>>>0)/((1212424721>>>(f[D>>2]<<2&28)&15)>>>0)|0;Qb=dd;do if(Yb|0){dd=D+16|0;Mb=0-Ub|0;Pb=(Wb|0)<2;c:do if((Ub|0)<(Mb|0)){if(Pb){Lb=0;while(1){Id=+VN(0.0,0.0);Ma=f[e>>2]|0;n[Ma+(Lb*28|0)+12>>2]=Id;Lb=Lb+1|0;if(Lb>>>0>=za>>>0){Ld=Ma;break c}}}else{Md=Qb;Nd=Zb;Od=0}while(1){Lb=f[Md+(Od*28|0)+20>>2]|0;Hb=f[A>>2]|0;Ma=wNa(+n[Md+(Od*28|0)+4>>2])|0;Nb=(f[Hb+(Lb<<4)+4>>2]|0)+Ma|0;Ma=wNa(+n[Md+(Od*28|0)>>2])|0;Ka=(f[dd>>2]|0)+(Y(Nb,Nd)|0)+((f[Hb+(Lb<<4)>>2]|0)+Ma)|0;Ma=f[m>>2]|0;Lb=0;Hb=0;Nb=1;while(1){Oa=f[Ma+(Nb<<2)>>2]|0;Ab=0-Oa|0;if((Oa|0)<(Ab|0)){Pd=Hb;Qd=0}else{Eb=Y(Nb,ed)|0;Jb=Hb;ib=Ab;Ab=0;while(1){jb=h[Ka+(ib+Eb)>>0]|0;Ob=h[Ka+(ib-Eb)>>0]|0;ab=jb+Ab-Ob|0;td=(Y(Ob+jb|0,ib)|0)+Jb|0;if((ib|0)<(Oa|0)){Jb=td;ib=ib+1|0;Ab=ab}else{Pd=td;Qd=ab;break}}}Lb=(Y(Qd,Nb)|0)+Lb|0;if((Nb|0)==(Ub|0))break;else{Hb=Pd;Nb=Nb+1|0}}Id=+VN(+(Lb|0),+(Pd|0));Nb=f[e>>2]|0;n[Nb+(Od*28|0)+12>>2]=Id;Hb=Od+1|0;if(Hb>>>0>=za>>>0){Ld=Nb;break c}Md=Nb;Nd=f[f[aa>>2]>>2]|0;Od=Hb}}else{if(Pb){Hb=Qb;Nb=Zb;Ka=0;while(1){Ma=f[Hb+(Ka*28|0)+20>>2]|0;Ab=f[A>>2]|0;ib=wNa(+n[Hb+(Ka*28|0)+4>>2])|0;Jb=(f[Ab+(Ma<<4)+4>>2]|0)+ib|0;ib=wNa(+n[Hb+(Ka*28|0)>>2])|0;Oa=(f[dd>>2]|0)+(Y(Jb,Nb)|0)+((f[Ab+(Ma<<4)>>2]|0)+ib)|0;ib=0;Ma=Mb;while(1){ib=(Y(h[Oa+Ma>>0]|0,Ma)|0)+ib|0;if((Ma|0)>=(Ub|0))break;else Ma=Ma+1|0}Id=+VN(0.0,+(ib|0));Ma=f[e>>2]|0;n[Ma+(Ka*28|0)+12>>2]=Id;Oa=Ka+1|0;if(Oa>>>0>=za>>>0){Ld=Ma;break c}Hb=Ma;Nb=f[f[aa>>2]>>2]|0;Ka=Oa}}else{Rd=Qb;Sd=Zb;Td=0}while(1){Ka=f[Rd+(Td*28|0)+20>>2]|0;Nb=f[A>>2]|0;Hb=wNa(+n[Rd+(Td*28|0)+4>>2])|0;Oa=(f[Nb+(Ka<<4)+4>>2]|0)+Hb|0;Hb=wNa(+n[Rd+(Td*28|0)>>2])|0;Ma=(f[dd>>2]|0)+(Y(Oa,Sd)|0)+((f[Nb+(Ka<<4)>>2]|0)+Hb)|0;Hb=0;Ka=Mb;while(1){Hb=(Y(h[Ma+Ka>>0]|0,Ka)|0)+Hb|0;if((Ka|0)>=(Ub|0))break;else Ka=Ka+1|0}Ka=f[m>>2]|0;ib=0;Nb=Hb;Oa=1;while(1){Lb=f[Ka+(Oa<<2)>>2]|0;Ab=0-Lb|0;if((Lb|0)<(Ab|0)){Ud=Nb;Vd=0}else{Jb=Y(Oa,ed)|0;Eb=Nb;ab=Ab;Ab=0;while(1){td=h[Ma+(ab+Jb)>>0]|0;jb=h[Ma+(ab-Jb)>>0]|0;Ob=td+Ab-jb|0;hb=(Y(jb+td|0,ab)|0)+Eb|0;if((ab|0)<(Lb|0)){Eb=hb;ab=ab+1|0;Ab=Ob}else{Ud=hb;Vd=Ob;break}}}ib=(Y(Vd,Oa)|0)+ib|0;if((Oa|0)==(Ub|0))break;else{Nb=Ud;Oa=Oa+1|0}}Id=+VN(+(ib|0),+(Ud|0));Oa=f[e>>2]|0;n[Oa+(Td*28|0)+12>>2]=Id;Nb=Td+1|0;if(Nb>>>0>=za>>>0){Ld=Oa;break c}Rd=Oa;Sd=f[f[aa>>2]>>2]|0;Td=Nb}}while(0);if((Yb|0)<=0)break;Mb=f[C>>2]|0;dd=0;do{Id=+n[Mb+(f[Ld+(dd*28|0)+20>>2]<<2)>>2];Pb=Ld+(dd*28|0)|0;n[Pb>>2]=Id*+n[Pb>>2];Pb=Ld+(dd*28|0)+4|0;n[Pb>>2]=Id*+n[Pb>>2];dd=dd+1|0}while((dd|0)<(za|0))}while(0);j0(t);j0(s);za=r+36|0;Yb=f[za>>2]|0;do if(Yb|0){Ub=Yb+12|0;ed=f[Ub>>2]|0;f[Ub>>2]=ed+-1;if((ed|0)!=1)break;CR(r)}while(0);f[za>>2]=0;Yb=r+16|0;f[Yb>>2]=0;f[Yb+4>>2]=0;f[Yb+8>>2]=0;f[Yb+12>>2]=0;if((f[Ib>>2]|0)>0){Yb=f[Kb>>2]|0;ed=0;do{f[Yb+(ed<<2)>>2]=0;ed=ed+1|0}while((ed|0)<(f[Ib>>2]|0))}Ib=f[Na>>2]|0;if((Ib|0)!=(Ha|0))ZF(Ib)}Ib=f[q>>2]|0;if(Ib|0){ed=f[Vb>>2]|0;if((ed|0)!=(Ib|0))f[Vb>>2]=ed+(~((ed+-4-Ib|0)>>>2)<<2);PYa(Ib)}Ib=f[o>>2]|0;if(Ib|0){ed=f[_a>>2]|0;if((ed|0)!=(Ib|0))f[_a>>2]=ed+(~(((ed+-28-Ib|0)>>>0)/28|0)*28|0);PYa(Ib)}Ib=f[m>>2]|0;if(Ib|0){ed=f[Sb>>2]|0;if((ed|0)!=(Ib|0))f[Sb>>2]=ed+(~((ed+-4-Ib|0)>>>2)<<2);PYa(Ib)}Ib=f[l>>2]|0;if(Ib|0){ed=f[bb>>2]|0;if((ed|0)!=(Ib|0))f[bb>>2]=ed+(~((ed+-4-Ib|0)>>>2)<<2);PYa(Ib)}}while(0);do if(W){r=mi[f[(f[a>>2]|0)+52>>2]&255](a)|0;s=(f[d>>2]|0)-(f[e>>2]|0)|0;if(!s){oS(g);break}pS(g,(s|0)/28|0,r,0,-1,0,0);f[l>>2]=0;s=l+4|0;f[s>>2]=0;f[l+8>>2]=0;F1a(m|0,0,4096)|0;t=f[S>>2]|0;if((t|0)!=31){Ld=(t|0)/-2|0;Td=((t|0)/2|0)+1|0;t=Td-Ld|0;if((Td|0)==(Ld|0)){Td=0;do{f[m+(Td<<3)>>2]=Ld;f[m+(Td<<3)+4>>2]=Ld;Td=Td+1|0}while((Td|0)!=512);Wd=m}else{Td=882399033;bb=0;Sb=0;while(1){_a=W1a(Td|0,0,-130063606,0)|0;Vb=C1a(_a|0,J|0,bb|0,0)|0;_a=J;f[m+(Sb<<3)>>2]=((Vb>>>0)%(t>>>0)|0)+Ld;Ha=W1a(Vb|0,0,-130063606,0)|0;Td=C1a(Ha|0,J|0,_a|0,0)|0;f[m+(Sb<<3)+4>>2]=((Td>>>0)%(t>>>0)|0)+Ld;Sb=Sb+1|0;if((Sb|0)==512){Wd=m;break}else bb=J}}}else Wd=106116;bb=a+28|0;Sb=f[bb>>2]|0;if((Sb+-2|0)>>>0<3)Xd=Sb;else{f[k>>2]=0;f[k+4>>2]=0;T=c$(k,38)|0;U=358055;V=T+38|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));j$(-215,k,357862,357879,1146);d$(k);Xd=f[bb>>2]|0}d:do if((Xd|0)==2){Sb=l+8|0;Ld=0;do{t=Wd+(Ld<<3)|0;Td=f[s>>2]|0;if((Td|0)==(f[Sb>>2]|0))p8(l,t);else{f[Td>>2]=f[t>>2];f[Td+4>>2]=f[Wd+(Ld<<3)+4>>2];f[s>>2]=Td+8}Ld=Ld+1|0}while((Ld|0)!=512)}else{Ld=mi[f[(f[a>>2]|0)+52>>2]&255](a)|0;Sb=Ld<<2;Td=f[bb>>2]|0;t=Y(Td,Sb)|0;_a=f[s>>2]|0;Ha=f[l>>2]|0;Vb=_a-Ha>>3;Na=Ha;Ha=_a;do if(t>>>0>Vb>>>0)Gda(l,t-Vb|0);else{if(t>>>0>=Vb>>>0)break;_a=Na+(t<<3)|0;if((Ha|0)==(_a|0))break;f[s>>2]=Ha+(~((Ha+-8-_a|0)>>>3)<<3)}while(0);if((Ld|0)>0&(Td|0)>0){Yd=305419896;Zd=0;_d=0}else break;e:while(1){Ha=Y(_d,Td)|0;t=Yd;Na=Zd;Vb=0;while(1){_a=f[l>>2]|0;if((Vb|0)>0){Sd=t;Rd=Na;while(1){Ud=W1a(Sd|0,0,-130063606,0)|0;Vd=C1a(Ud|0,J|0,Rd|0,0)|0;Ud=J;Od=Vd&511;Nd=f[Wd+(Od<<3)>>2]|0;Md=f[Wd+(Od<<3)+4>>2]|0;Od=0;while(1){Pd=Od+Ha|0;if((f[_a+(Pd<<3)>>2]|0)==(Nd|0)?(f[_a+(Pd<<3)+4>>2]|0)==(Md|0):0){$d=Od;break}Pd=Od+1|0;if((Pd|0)<(Vb|0))Od=Pd;else{$d=Pd;break}}if(($d|0)==(Vb|0)){ae=Md;be=Nd;ce=Vd;de=Ud;break}else{Sd=Vd;Rd=Ud}}}else{if(Vb|0)break e;Rd=W1a(t|0,0,-130063606,0)|0;Sd=C1a(Rd|0,J|0,Na|0,0)|0;Rd=Sd&511;ae=f[Wd+(Rd<<3)+4>>2]|0;be=f[Wd+(Rd<<3)>>2]|0;ce=Sd;de=J}Sd=Vb+Ha|0;f[_a+(Sd<<3)>>2]=be;f[_a+(Sd<<3)+4>>2]=ae;Vb=Vb+1|0;if((Vb|0)==(Td|0))break;else{t=ce;Na=de}}_d=_d+1|0;if((_d|0)==(Sb|0))break d;else{Yd=ce;Zd=de}}while(1){}}while(0);if(ya){Sb=o+8|0;Td=o+12|0;Ld=o+4|0;Na=q+8|0;t=q+4|0;Vb=R+4|0;Ha=k+36|0;Sd=k+16|0;Rd=k+4|0;ib=k+40|0;Od=k+44|0;Pd=k+48|0;Qd=0;do{FR(k,D,(f[A>>2]|0)+(Qd<<4)|0);f[Sb>>2]=0;f[Td>>2]=0;f[o>>2]=16842752;f[Ld>>2]=k;Kd=Na;f[Kd>>2]=0;f[Kd+4>>2]=0;f[q>>2]=33619968;f[t>>2]=k;f[R>>2]=7;f[Vb>>2]=7;Hpa(o,q,R,2.0,2.0,4);Kd=f[Ha>>2]|0;do if(Kd|0){Jd=Kd+12|0;nd=f[Jd>>2]|0;f[Jd>>2]=nd+-1;if((nd|0)!=1)break;CR(k)}while(0);f[Ha>>2]=0;f[Sd>>2]=0;f[Sd+4>>2]=0;f[Sd+8>>2]=0;f[Sd+12>>2]=0;if((f[Rd>>2]|0)>0){Kd=f[ib>>2]|0;nd=0;do{f[Kd+(nd<<2)>>2]=0;nd=nd+1|0}while((nd|0)<(f[Rd>>2]|0))}nd=f[Od>>2]|0;if((nd|0)!=(Pd|0))ZF(nd);Qd=Qd+1|0}while((Qd|0)<(oa|0))}do if((NS(g)|0)==65536){Qd=f[g+4>>2]|0;f[o>>2]=f[Qd>>2];Pd=o+4|0;Od=Qd+4|0;f[Pd>>2]=f[Od>>2];Rd=o+8|0;f[Rd>>2]=f[Qd+8>>2];f[o+12>>2]=f[Qd+12>>2];f[o+16>>2]=f[Qd+16>>2];f[o+20>>2]=f[Qd+20>>2];f[o+24>>2]=f[Qd+24>>2];f[o+28>>2]=f[Qd+28>>2];f[o+32>>2]=f[Qd+32>>2];ib=f[Qd+36>>2]|0;f[o+36>>2]=ib;f[o+40>>2]=Rd;Rd=o+48|0;Sd=o+44|0;f[Sd>>2]=Rd;f[Rd>>2]=0;f[o+52>>2]=0;if(ib|0){Rd=ib+12|0;f[Rd>>2]=(f[Rd>>2]|0)+1}if((f[Od>>2]|0)<3){Od=f[Qd+44>>2]|0;Rd=f[Sd>>2]|0;f[Rd>>2]=f[Od>>2];f[Rd+4>>2]=f[Od+4>>2];break}else{f[Pd>>2]=0;BR(o,Qd);break}}else OR(o,g,-1);while(0);Qd=f[bb>>2]|0;Pd=f[ma>>2]|0;Od=f[e>>2]|0;Rd=(f[d>>2]|0)-Od|0;Sd=(Rd|0)/28|0;f:do if((Rd|0)>0){ib=D+16|0;Ha=o+16|0;Vb=o+44|0;t=k+4|0;Na=(r|0)>0;Ld=f[C>>2]|0;Td=Od;Sb=0;while(1){nd=f[Td+(Sb*28|0)+20>>2]|0;Kd=f[A>>2]|0;Id=1.0/+n[Ld+(nd<<2)>>2];X=+n[Td+(Sb*28|0)+12>>2]*.01745329238474369;Cd=+O(+X);Ga=+P(+X);Jd=wNa(Id*+n[Td+(Sb*28|0)+4>>2])|0;Hd=(f[Kd+(nd<<4)+4>>2]|0)+Jd|0;Jd=wNa(Id*+n[Td+(Sb*28|0)>>2])|0;w=(f[ib>>2]|0)+(Y(f[f[aa>>2]>>2]|0,Hd)|0)+((f[Kd+(nd<<4)>>2]|0)+Jd)|0;Jd=f[l>>2]|0;nd=(f[Ha>>2]|0)+(Y(f[f[Vb>>2]>>2]|0,Sb)|0)|0;g:do switch(Qd|0){case 2:{if(Na){ee=0;fe=Jd}else break g;while(1){Id=+(f[fe>>2]|0);X=+(f[fe+4>>2]|0);Kd=wNa(Cd*Id-Ga*X)|0;Hd=w+(Y(wNa(Ga*Id+Cd*X)|0,Pd)|0)+Kd|0;Kd=b[Hd>>0]|0;X=+(f[fe+8>>2]|0);Id=+(f[fe+12>>2]|0);Hd=wNa(Cd*X-Ga*Id)|0;v=w+(Y(wNa(Ga*X+Cd*Id)|0,Pd)|0)+Hd|0;Hd=(Kd&255)<(h[v>>0]|0)&1;Id=+(f[fe+16>>2]|0);X=+(f[fe+20>>2]|0);v=wNa(Cd*Id-Ga*X)|0;Kd=w+(Y(wNa(Ga*Id+Cd*X)|0,Pd)|0)+v|0;v=b[Kd>>0]|0;X=+(f[fe+24>>2]|0);Id=+(f[fe+28>>2]|0);Kd=wNa(Cd*X-Ga*Id)|0;Gd=w+(Y(wNa(Ga*X+Cd*Id)|0,Pd)|0)+Kd|0;Kd=((v&255)<(h[Gd>>0]|0)&1)<<1|Hd;Id=+(f[fe+32>>2]|0);X=+(f[fe+36>>2]|0);Hd=wNa(Cd*Id-Ga*X)|0;Gd=w+(Y(wNa(Ga*Id+Cd*X)|0,Pd)|0)+Hd|0;Hd=b[Gd>>0]|0;X=+(f[fe+40>>2]|0);Id=+(f[fe+44>>2]|0);Gd=wNa(Cd*X-Ga*Id)|0;v=w+(Y(wNa(Ga*X+Cd*Id)|0,Pd)|0)+Gd|0;Gd=Kd|((Hd&255)<(h[v>>0]|0)&1)<<2;Id=+(f[fe+48>>2]|0);X=+(f[fe+52>>2]|0);v=wNa(Cd*Id-Ga*X)|0;Hd=w+(Y(wNa(Ga*Id+Cd*X)|0,Pd)|0)+v|0;v=b[Hd>>0]|0;X=+(f[fe+56>>2]|0);Id=+(f[fe+60>>2]|0);Hd=wNa(Cd*X-Ga*Id)|0;Kd=w+(Y(wNa(Ga*X+Cd*Id)|0,Pd)|0)+Hd|0;Hd=Gd|((v&255)<(h[Kd>>0]|0)&1)<<3;Id=+(f[fe+64>>2]|0);X=+(f[fe+68>>2]|0);Kd=wNa(Cd*Id-Ga*X)|0;v=w+(Y(wNa(Ga*Id+Cd*X)|0,Pd)|0)+Kd|0;Kd=b[v>>0]|0;X=+(f[fe+72>>2]|0);Id=+(f[fe+76>>2]|0);v=wNa(Cd*X-Ga*Id)|0;Gd=w+(Y(wNa(Ga*X+Cd*Id)|0,Pd)|0)+v|0;v=Hd|((Kd&255)<(h[Gd>>0]|0)&1)<<4;Id=+(f[fe+80>>2]|0);X=+(f[fe+84>>2]|0);Gd=wNa(Cd*Id-Ga*X)|0;Kd=w+(Y(wNa(Ga*Id+Cd*X)|0,Pd)|0)+Gd|0;Gd=b[Kd>>0]|0;X=+(f[fe+88>>2]|0);Id=+(f[fe+92>>2]|0);Kd=wNa(Cd*X-Ga*Id)|0;Hd=w+(Y(wNa(Ga*X+Cd*Id)|0,Pd)|0)+Kd|0;Kd=v|((Gd&255)<(h[Hd>>0]|0)&1)<<5;Id=+(f[fe+96>>2]|0);X=+(f[fe+100>>2]|0);Hd=wNa(Cd*Id-Ga*X)|0;Gd=w+(Y(wNa(Ga*Id+Cd*X)|0,Pd)|0)+Hd|0;Hd=b[Gd>>0]|0;X=+(f[fe+104>>2]|0);Id=+(f[fe+108>>2]|0);Gd=wNa(Cd*X-Ga*Id)|0;v=w+(Y(wNa(Ga*X+Cd*Id)|0,Pd)|0)+Gd|0;Gd=Kd|((Hd&255)<(h[v>>0]|0)&1)<<6;Id=+(f[fe+112>>2]|0);X=+(f[fe+116>>2]|0);v=wNa(Cd*Id-Ga*X)|0;Hd=w+(Y(wNa(Ga*Id+Cd*X)|0,Pd)|0)+v|0;v=b[Hd>>0]|0;X=+(f[fe+120>>2]|0);Id=+(f[fe+124>>2]|0);Hd=wNa(Cd*X-Ga*Id)|0;Kd=w+(Y(wNa(Ga*X+Cd*Id)|0,Pd)|0)+Hd|0;b[nd+ee>>0]=Gd|((v&255)<(h[Kd>>0]|0)&1)<<7;ee=ee+1|0;if((ee|0)==(r|0))break;else fe=fe+128|0}break}case 3:{if(Na){ge=0;he=Jd}else break g;while(1){Id=+(f[he>>2]|0);X=+(f[he+4>>2]|0);_a=wNa(Cd*Id-Ga*X)|0;Kd=w+(Y(wNa(Ga*Id+Cd*X)|0,Pd)|0)+_a|0;_a=b[Kd>>0]|0;X=+(f[he+8>>2]|0);Id=+(f[he+12>>2]|0);Kd=wNa(Cd*X-Ga*Id)|0;v=w+(Y(wNa(Ga*X+Cd*Id)|0,Pd)|0)+Kd|0;Kd=b[v>>0]|0;Id=+(f[he+16>>2]|0);X=+(f[he+20>>2]|0);v=wNa(Cd*Id-Ga*X)|0;Gd=w+(Y(wNa(Ga*Id+Cd*X)|0,Pd)|0)+v|0;v=b[Gd>>0]|0;X=+(f[he+24>>2]|0);Id=+(f[he+28>>2]|0);Gd=wNa(Cd*X-Ga*Id)|0;Hd=w+(Y(wNa(Ga*X+Cd*Id)|0,Pd)|0)+Gd|0;Gd=b[Hd>>0]|0;Id=+(f[he+32>>2]|0);X=+(f[he+36>>2]|0);Hd=wNa(Cd*Id-Ga*X)|0;ga=w+(Y(wNa(Ga*Id+Cd*X)|0,Pd)|0)+Hd|0;Hd=b[ga>>0]|0;X=+(f[he+40>>2]|0);Id=+(f[he+44>>2]|0);ga=wNa(Cd*X-Ga*Id)|0;Bd=w+(Y(wNa(Ga*X+Cd*Id)|0,Pd)|0)+ga|0;ga=b[Bd>>0]|0;Id=+(f[he+48>>2]|0);X=+(f[he+52>>2]|0);Bd=wNa(Cd*Id-Ga*X)|0;Fd=w+(Y(wNa(Ga*Id+Cd*X)|0,Pd)|0)+Bd|0;Bd=b[Fd>>0]|0;X=+(f[he+56>>2]|0);Id=+(f[he+60>>2]|0);Fd=wNa(Cd*X-Ga*Id)|0;Ed=w+(Y(wNa(Ga*X+Cd*Id)|0,Pd)|0)+Fd|0;Fd=b[Ed>>0]|0;Id=+(f[he+64>>2]|0);X=+(f[he+68>>2]|0);Ed=wNa(Cd*Id-Ga*X)|0;Dd=w+(Y(wNa(Ga*Id+Cd*X)|0,Pd)|0)+Ed|0;Ed=b[Dd>>0]|0;X=+(f[he+72>>2]|0);Id=+(f[he+76>>2]|0);Dd=wNa(Cd*X-Ga*Id)|0;Z=w+(Y(wNa(Ga*X+Cd*Id)|0,Pd)|0)+Dd|0;Dd=b[Z>>0]|0;Id=+(f[he+80>>2]|0);X=+(f[he+84>>2]|0);Z=wNa(Cd*Id-Ga*X)|0;ba=w+(Y(wNa(Ga*Id+Cd*X)|0,Pd)|0)+Z|0;Z=b[ba>>0]|0;X=+(f[he+88>>2]|0);Id=+(f[he+92>>2]|0);ba=wNa(Cd*X-Ga*Id)|0;zd=w+(Y(wNa(Ga*X+Cd*Id)|0,Pd)|0)+ba|0;ba=b[zd>>0]|0;b[nd+ge>>0]=((ga&255)>(Hd&255)?((ga&255)>(Gd&255)?2:0):(Hd&255)>(Gd&255)&1)<<2|((v&255)>(Kd&255)?((v&255)>(_a&255)?2:0):(Kd&255)>(_a&255)&1)|((Ed&255)>(Fd&255)?((Ed&255)>(Bd&255)?2:0):(Fd&255)>(Bd&255)&1)<<4|((ba&255)>(Z&255)?((ba&255)>(Dd&255)?2:0):(Z&255)>(Dd&255)&1)<<6;ge=ge+1|0;if((ge|0)==(r|0))break;else he=he+96|0}break}case 4:{if(Na){ie=0;je=Jd}else break g;while(1){Id=+(f[je>>2]|0);X=+(f[je+4>>2]|0);Dd=wNa(Cd*Id-Ga*X)|0;Z=w+(Y(wNa(Ga*Id+Cd*X)|0,Pd)|0)+Dd|0;Dd=b[Z>>0]|0;X=+(f[je+8>>2]|0);Id=+(f[je+12>>2]|0);Z=wNa(Cd*X-Ga*Id)|0;ba=w+(Y(wNa(Ga*X+Cd*Id)|0,Pd)|0)+Z|0;Z=b[ba>>0]|0;Id=+(f[je+16>>2]|0);X=+(f[je+20>>2]|0);ba=wNa(Cd*Id-Ga*X)|0;Bd=w+(Y(wNa(Ga*Id+Cd*X)|0,Pd)|0)+ba|0;ba=b[Bd>>0]|0;X=+(f[je+24>>2]|0);Id=+(f[je+28>>2]|0);Bd=wNa(Cd*X-Ga*Id)|0;Fd=w+(Y(wNa(Ga*X+Cd*Id)|0,Pd)|0)+Bd|0;Bd=b[Fd>>0]|0;Fd=(Z&255)>(Dd&255);Ed=(Bd&255)>(ba&255);Id=+(f[je+32>>2]|0);X=+(f[je+36>>2]|0);_a=wNa(Cd*Id-Ga*X)|0;Kd=w+(Y(wNa(Ga*Id+Cd*X)|0,Pd)|0)+_a|0;_a=b[Kd>>0]|0;X=+(f[je+40>>2]|0);Id=+(f[je+44>>2]|0);Kd=wNa(Cd*X-Ga*Id)|0;v=w+(Y(wNa(Ga*X+Cd*Id)|0,Pd)|0)+Kd|0;Kd=b[v>>0]|0;Id=+(f[je+48>>2]|0);X=+(f[je+52>>2]|0);v=wNa(Cd*Id-Ga*X)|0;Gd=w+(Y(wNa(Ga*Id+Cd*X)|0,Pd)|0)+v|0;v=b[Gd>>0]|0;X=+(f[je+56>>2]|0);Id=+(f[je+60>>2]|0);Gd=wNa(Cd*X-Ga*Id)|0;Hd=w+(Y(wNa(Ga*X+Cd*Id)|0,Pd)|0)+Gd|0;Gd=b[Hd>>0]|0;Hd=(Kd&255)>(_a&255);ga=(Gd&255)>(v&255);Id=+(f[je+64>>2]|0);X=+(f[je+68>>2]|0);zd=wNa(Cd*Id-Ga*X)|0;Ad=w+(Y(wNa(Ga*Id+Cd*X)|0,Pd)|0)+zd|0;zd=b[Ad>>0]|0;X=+(f[je+72>>2]|0);Id=+(f[je+76>>2]|0);Ad=wNa(Cd*X-Ga*Id)|0;yd=w+(Y(wNa(Ga*X+Cd*Id)|0,Pd)|0)+Ad|0;Ad=b[yd>>0]|0;Id=+(f[je+80>>2]|0);X=+(f[je+84>>2]|0);yd=wNa(Cd*Id-Ga*X)|0;xd=w+(Y(wNa(Ga*Id+Cd*X)|0,Pd)|0)+yd|0;yd=b[xd>>0]|0;X=+(f[je+88>>2]|0);Id=+(f[je+92>>2]|0);xd=wNa(Cd*X-Ga*Id)|0;vd=w+(Y(wNa(Ga*X+Cd*Id)|0,Pd)|0)+xd|0;xd=b[vd>>0]|0;vd=(Ad&255)>(zd&255);wd=(xd&255)>(yd&255);Id=+(f[je+96>>2]|0);X=+(f[je+100>>2]|0);ud=wNa(Cd*Id-Ga*X)|0;pa=w+(Y(wNa(Ga*Id+Cd*X)|0,Pd)|0)+ud|0;ud=b[pa>>0]|0;X=+(f[je+104>>2]|0);Id=+(f[je+108>>2]|0);pa=wNa(Cd*X-Ga*Id)|0;Q=w+(Y(wNa(Ga*X+Cd*Id)|0,Pd)|0)+pa|0;pa=b[Q>>0]|0;Id=+(f[je+112>>2]|0);X=+(f[je+116>>2]|0);Q=wNa(Cd*Id-Ga*X)|0;i=w+(Y(wNa(Ga*Id+Cd*X)|0,Pd)|0)+Q|0;Q=b[i>>0]|0;X=+(f[je+120>>2]|0);Id=+(f[je+124>>2]|0);i=wNa(Cd*X-Ga*Id)|0;Ib=w+(Y(wNa(Ga*X+Cd*Id)|0,Pd)|0)+i|0;i=b[Ib>>0]|0;Ib=(pa&255)>(ud&255);ed=(i&255)>(Q&255);b[nd+ie>>0]=(((Hd?Kd:_a)&255)>((ga?Gd:v)&255)?(Hd?4:0):ga?12:8)|(((Fd?Z:Dd)&255)>((Ed?Bd:ba)&255)?Fd&1:Ed?3:2)|(((vd?Ad:zd)&255)>((wd?xd:yd)&255)?(vd?16:0):wd?48:32)|(((Ib?pa:ud)&255)>((ed?i:Q)&255)?(Ib?64:0):ed?192:128);ie=ie+1|0;if((ie|0)==(r|0))break;else je=je+128|0}break}default:{f[k>>2]=0;f[t>>2]=0;T=c$(k,38)|0;U=358094;V=T+38|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));j$(-201,k,358133,357879,342);d$(k)}}while(0);nd=Sb+1|0;if((nd|0)>=(Sd|0))break f;Td=f[e>>2]|0;Sb=nd}}while(0);Sd=o+36|0;r=f[Sd>>2]|0;do if(r|0){Pd=r+12|0;Qd=f[Pd>>2]|0;f[Pd>>2]=Qd+-1;if((Qd|0)!=1)break;CR(o)}while(0);f[Sd>>2]=0;r=o+16|0;Qd=o+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[Qd>>2]|0)>0){r=f[o+40>>2]|0;Pd=0;do{f[r+(Pd<<2)>>2]=0;Pd=Pd+1|0}while((Pd|0)<(f[Qd>>2]|0))}Qd=f[o+44>>2]|0;if((Qd|0)!=(o+48|0))ZF(Qd);Qd=f[l>>2]|0;if(Qd|0){Pd=f[s>>2]|0;if((Pd|0)!=(Qd|0))f[s>>2]=Pd+(~((Pd+-8-Qd|0)>>>3)<<3);PYa(Qd)}}while(0);l=f[Ta>>2]|0;do if(l|0){o=l+12|0;e=f[o>>2]|0;f[o>>2]=e+-1;if((e|0)!=1)break;CR(I)}while(0);f[Ta>>2]=0;f[La>>2]=0;f[La+4>>2]=0;f[La+8>>2]=0;f[La+12>>2]=0;if((f[Sa>>2]|0)>0){La=f[Wa>>2]|0;Wa=0;do{f[La+(Wa<<2)>>2]=0;Wa=Wa+1|0}while((Wa|0)<(f[Sa>>2]|0))}Sa=f[Ya>>2]|0;if((Sa|0)!=(Xa|0))ZF(Sa);Sa=f[wa>>2]|0;do if(Sa|0){Xa=Sa+12|0;Ya=f[Xa>>2]|0;f[Xa>>2]=Ya+-1;if((Ya|0)!=1)break;CR(H)}while(0);f[wa>>2]=0;f[va>>2]=0;f[va+4>>2]=0;f[va+8>>2]=0;f[va+12>>2]=0;if((f[xa>>2]|0)>0){va=f[ra>>2]|0;ra=0;do{f[va+(ra<<2)>>2]=0;ra=ra+1|0}while((ra|0)<(f[xa>>2]|0))}xa=f[sa>>2]|0;if((xa|0)!=(qa|0))ZF(xa);j0(G);j0(F);F=E+36|0;G=f[F>>2]|0;do if(G|0){xa=G+12|0;qa=f[xa>>2]|0;f[xa>>2]=qa+-1;if((qa|0)!=1)break;CR(E)}while(0);f[F>>2]=0;F=E+16|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[ha>>2]|0)>0){F=f[fa>>2]|0;fa=0;do{f[F+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[ha>>2]|0))}ha=f[$>>2]|0;if((ha|0)!=(ea|0))ZF(ha);ha=D+36|0;ea=f[ha>>2]|0;do if(ea|0){$=ea+12|0;fa=f[$>>2]|0;f[$>>2]=fa+-1;if((fa|0)!=1)break;CR(D)}while(0);f[ha>>2]=0;ha=D+16|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[da>>2]|0)>0){ha=f[na>>2]|0;na=0;do{f[ha+(na<<2)>>2]=0;na=na+1|0}while((na|0)<(f[da>>2]|0))}da=f[aa>>2]|0;if((da|0)!=(ma|0))ZF(da);da=f[C>>2]|0;if(da|0){C=f[ca>>2]|0;if((C|0)!=(da|0))f[ca>>2]=C+(~((C+-4-da|0)>>>2)<<2);PYa(da)}da=f[B>>2]|0;if(da|0){B=f[ja>>2]|0;if((B|0)!=(da|0))f[ja>>2]=B+(~((B+-4-da|0)>>>2)<<2);PYa(da)}da=f[A>>2]|0;if(da|0){A=f[c>>2]|0;if((A|0)!=(da|0))f[c>>2]=A+(~((A+-16-da|0)>>>4)<<4);PYa(da)}da=f[Ua>>2]|0;do if(da|0){A=da+12|0;c=f[A>>2]|0;f[A>>2]=c+-1;if((c|0)!=1)break;CR(z)}while(0);f[Ua>>2]=0;f[Qa>>2]=0;f[Qa+4>>2]=0;f[Qa+8>>2]=0;f[Qa+12>>2]=0;if((f[Ra>>2]|0)>0){Qa=f[z+40>>2]|0;Ua=0;do{f[Qa+(Ua<<2)>>2]=0;Ua=Ua+1|0}while((Ua|0)<(f[Ra>>2]|0))}Ra=f[z+44>>2]|0;if((Ra|0)!=(z+48|0))ZF(Ra);Ra=f[Aa>>2]|0;do if(Ra|0){z=Ra+12|0;Ua=f[z>>2]|0;f[z>>2]=Ua+-1;if((Ua|0)!=1)break;CR(y)}while(0);f[Aa>>2]=0;f[Da>>2]=0;f[Da+4>>2]=0;f[Da+8>>2]=0;f[Da+12>>2]=0;if((f[ua>>2]|0)>0){Da=f[y+40>>2]|0;Aa=0;do{f[Da+(Aa<<2)>>2]=0;Aa=Aa+1|0}while((Aa|0)<(f[ua>>2]|0))}ua=f[y+44>>2]|0;if((ua|0)!=(y+48|0))ZF(ua)}if(!(f[x+4>>2]|0)){u=j;return}u=j;return}function iCa(a){a=a|0;return 32}function jCa(a){a=a|0;return 0}function kCa(a){a=a|0;return 6}function lCa(a,b){a=a|0;b=b|0;f[a+4>>2]=b;return}function mCa(a){a=a|0;return f[a+4>>2]|0}function nCa(a,b){a=a|0;b=+b;p[a+8>>3]=b;return}function oCa(a){a=a|0;return +(+p[a+8>>3])}function pCa(a,b){a=a|0;b=b|0;f[a+16>>2]=b;return}function qCa(a){a=a|0;return f[a+16>>2]|0}function rCa(a,b){a=a|0;b=b|0;f[a+20>>2]=b;return}function sCa(a){a=a|0;return f[a+20>>2]|0}function tCa(a,b){a=a|0;b=b|0;f[a+24>>2]=b;return}function uCa(a){a=a|0;return f[a+24>>2]|0}function vCa(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function wCa(a){a=a|0;return f[a+28>>2]|0}function xCa(a,b){a=a|0;b=b|0;f[a+32>>2]=b;return}function yCa(a){a=a|0;return f[a+32>>2]|0}function zCa(a,b){a=a|0;b=b|0;f[a+36>>2]=b;return}function ACa(a){a=a|0;return f[a+36>>2]|0}function BCa(a,b){a=a|0;b=b|0;f[a+40>>2]=b;return}function CCa(a){a=a|0;return f[a+40>>2]|0}function DCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+64|0;e=d+56|0;g=d;h=f[a>>2]|0;i=f[a+4>>2]|0;if((h|0)==(i|0)){oS(c);u=d;return}a=i-h|0;f[g>>2]=1124007936;i=g+4|0;f[i>>2]=2;j=g+8|0;f[j>>2]=1;k=g+12|0;f[k>>2]=a;l=g+16|0;f[l>>2]=h;m=g+20|0;f[m>>2]=h;n=g+24|0;o=g+28|0;p=g+40|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[p>>2]=j;q=g+48|0;r=g+44|0;f[r>>2]=q;f[g+52>>2]=0;f[q>>2]=0;if((h|0)==0&(a|0)!=0){f[e>>2]=0;f[e+4>>2]=0;s=c$(e,26)|0;t=358223;v=s+26|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,e,358250,358254,500);d$(e);w=f[g>>2]|16384;x=f[k>>2]|0;y=f[r>>2]|0;z=f[m>>2]|0}else{w=1124024320;x=a;y=q;z=h}f[g>>2]=w;f[y>>2]=x;f[y+4>>2]=1;y=z+(Y(f[j>>2]|0,x)|0)|0;f[o>>2]=y;f[n>>2]=y+(0-x)+x;eL(g,c);c=g+36|0;x=f[c>>2]|0;if(x|0?(y=x+12|0,x=f[y>>2]|0,f[y>>2]=x+-1,(x|0)==1):0)CR(g);f[c>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[i>>2]|0)>0){l=f[p>>2]|0;p=0;do{f[l+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[i>>2]|0))}i=f[r>>2]|0;if((i|0)==(q|0)){u=d;return}ZF(i);u=d;return}function ECa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[a>>2]|0;e=d;if((((f[c>>2]|0)-d|0)/28|0)>>>0>=b>>>0)return;g=a+4|0;if(b>>>0>153391689){h=De(8)|0;UYa(h,358155);f[h>>2]=130560;Of(h|0,21520,875)}h=f[g>>2]|0;i=NYa(b*28|0)|0;j=i+(((h-d|0)/28|0)*28|0)|0;d=j;k=i+(b*28|0)|0;b=h;if((b|0)==(e|0)){l=d;m=h}else{h=j;j=b;b=d;do{i=j;j=j+-28|0;f[h+-28>>2]=f[j>>2];f[h+-24>>2]=f[i+-24>>2];n=h+-20|0;o=i+-20|0;f[n>>2]=f[o>>2];f[n+4>>2]=f[o+4>>2];f[n+8>>2]=f[o+8>>2];f[n+12>>2]=f[o+12>>2];f[n+16>>2]=f[o+16>>2];h=b+-28|0;b=h}while((j|0)!=(e|0));l=b;m=f[a>>2]|0}f[a>>2]=l;f[g>>2]=d;f[c>>2]=k;if(!m)return;PYa(m);return}function FCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>357913941)gXa(a);d=b*12|0;e=NYa(d)|0;f[a>>2]=e;g=e+(b*12|0)|0;f[a+8>>2]=g;F1a(e|0,0,d|0)|0;f[c>>2]=g;return}function GCa(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0;l=NYa(48)|0;WF(l);f[l>>2]=105960;f[l+4>>2]=b;p[l+8>>3]=c;f[l+16>>2]=d;f[l+20>>2]=e;f[l+24>>2]=g;f[l+28>>2]=h;f[l+32>>2]=i;f[l+36>>2]=j;f[l+40>>2]=k;k=NYa(16)|0;j=k+4|0;f[j>>2]=1;f[k>>2]=110244;f[k+8>>2]=l;f[a>>2]=k;f[a+4>>2]=l;f[j>>2]=(f[j>>2]|0)+1;l=f[j>>2]|0;f[j>>2]=l+-1;if((l|0)!=1)return;ki[f[(f[k>>2]|0)+8>>2]&2047](k);return}function HCa(a){a=a|0;PYa(a);return}function ICa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function JCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0;if(!(b&2147483647)){c=b>>31&-822083584;f[a>>2]=c;return}d=(b|0)<0?0-b|0:b;e=d>>>0<65536;g=e?d<<16:d;i=e?16:0;e=g>>>0<16777216;j=((h[358514+((e?g<<8:g)>>>24)>>0]|0)+((e?i|8:i)&255)<<24)+-16777216|0;i=j>>24;e=156-i|0;if((j|0)>100663296&e>>>0<253){c=(d<<i+-7)+(b&-2147483648)+(b|0?e<<23:0)|0;f[a>>2]=c;return}j=d<<i;i=j&127;do if(e>>>0>252){if((e|0)>=0){if(!((e|0)>253|(j+64|0)<0)){k=e;l=i;m=j;break}c=b&-2147483648|2139095040;f[a>>2]=c;return}d=0-e|0;if(d>>>0<31)n=(j<<(e&31)|0)!=0|j>>>d;else n=(j|0)!=0&1;k=0;l=n&127;m=n}else{k=e;l=i;m=j}while(0);j=(m+64|0)>>>7&~(l<<24>>24==64);c=((j|0)==0?0:k<<23)+(j|b&-2147483648)|0;f[a>>2]=c;return}function KCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=f[b>>2]|0;b=c>>>23;d=c&8388607;a:do switch((b&255)<<24>>24){case -1:{e=c>>>31;if(!d){g=R1a(e|0,0,63)|0;i=g;j=J|2146435072;k=a;l=k;f[l>>2]=i;m=k+4|0;n=m;f[n>>2]=j;return}else{g=R1a(e|0,0,63)|0;e=J;o=R1a(c|0,0,29)|0;i=o|g;j=J|e|2146959360;k=a;l=k;f[l>>2]=i;m=k+4|0;n=m;f[n>>2]=j;return}break}case 0:{if(d|0){e=d>>>0<65536;g=e?c<<16:d;o=e?16:0;e=g>>>0<16777216;p=((h[358514+((e?g<<8:g)>>>24)>>0]|0)+((e?o|8:o)&255)<<24)+-134217728>>24;q=0-p|0;r=d<<p;break a}i=R1a(c>>>31|0,0,63)|0;j=J;k=a;l=k;f[l>>2]=i;m=k+4|0;n=m;f[n>>2]=j;return}default:{q=b&255;r=d}}while(0);d=R1a(c>>>31|0,0,63)|0;c=J;b=R1a(q+896|0,0,52)|0;q=J;p=R1a(r|0,0,29)|0;r=C1a(b|0,q|0,p|d|0,J|c|0)|0;i=r;j=J;k=a;l=k;f[l>>2]=i;m=k+4|0;n=m;f[n>>2]=j;return}function LCa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[b>>2]|0;b=f[c>>2]|0;if((b^d|0)<0){MCa(a,d,b);return}else{NCa(a,d,b);return}}function MCa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=b>>>23&255;e=b&8388607;g=c>>>23&255;i=c&8388607;j=d-g|0;a:do if(!j){if((d|0)==255){if(!(i|e))k=-4194304;else break;f[a>>2]=k;return}l=e-i|0;if(!l){k=0;f[a>>2]=k;return}m=(d|0)==0?0:d+-1|0;n=(l|0)<0;o=n?0-l|0:l;l=o>>>0<65536;p=l?o<<16:o;q=l?16:0;l=p>>>0<16777216;r=((h[358514+((l?p<<8:p)>>>24)>>0]|0)+((l?q|8:q)&255)&255)+248|0;q=m-(r<<24>>24)|0;l=(q|0)<0;k=(l?0:q<<23)+(((n?(b|0)>-1:(b|0)<0)&1)<<31)+(o<<((l?m:r)<<24>>24))|0;f[a>>2]=k;return}else{r=e<<7;m=i<<7;do if((j|0)<0){if((g|0)!=255){s=0-j|0;t=g;u=m;v=(d|0?1073741824:r)+r|0;w=(b|0)>-1;break}if(i|0)break a;k=(b&-2147483648)+-8388608|0;f[a>>2]=k;return}else{if((d|0)!=255){s=j;t=d;u=r;v=(g|0?1073741824:m)+m|0;w=(b|0)<0;break}if(!e)k=b;else break a;f[a>>2]=k;return}while(0);if(s>>>0<31)x=(v<<(0-s&31)|0)!=0|v>>>s;else x=(v|0)!=0&1;m=(u|1073741824)-x|0;r=m>>>0<65536;l=r?m<<16:m;o=r?16:0;r=l>>>0<16777216;n=(((r?o|8:o)&255)+(h[358514+((r?l<<8:l)>>>24)>>0]|0)<<24)+-16777216|0;l=n>>24;r=t+-1-l|0;if((n|0)>100663296&r>>>0<253){k=(m<<l+-7)+((w&1)<<31)+(m|0?r<<23:0)|0;f[a>>2]=k;return}n=m<<l;l=n&127;do if(r>>>0>252){if((r|0)>=0){if(!((r|0)>253|(n+64|0)<0)){y=r;z=l;A=n;break}k=(w&1)<<31|2139095040;f[a>>2]=k;return}m=0-r|0;if(m>>>0<31)B=(n<<(r&31)|0)!=0|n>>>m;else B=(n|0)!=0&1;y=0;z=B&127;A=B}else{y=r;z=l;A=n}while(0);n=(A+64|0)>>>7&~(z<<24>>24==64);k=((n|0)==0?0:y<<23)+(n|(w&1)<<31)|0;f[a>>2]=k;return}while(0);k=((b&2143289344|0)==2139095040&(b&4194303|0)!=0?b:(b&2139095040|0)!=2139095040|(e|0)==0?c:b)|4194304;f[a>>2]=k;return}function NCa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=b>>>23;e=d&255;g=b&8388607;h=c>>>23;i=h&255;j=c&8388607;k=e-i|0;a:do if(!k)switch((d&255)<<24>>24){case 0:{l=j+b|0;f[a>>2]=l;return}case -1:{if(!(j|g))l=b;else{m=30;break a}f[a>>2]=l;return}default:{n=(g|16777216)+j|0;if(!(e>>>0<254&(c+b&1|0)==0)){o=e;p=n<<6;break a}l=(e<<23|b&-2147483648)+(n>>>1)|0;f[a>>2]=l;return}}else{n=g<<6;q=j<<6;do if((k|0)<0)if((i|0)!=255){r=(e|0?536870912:n)+n|0;s=0-k|0;if(s>>>0<31){t=i;u=(r<<(d-h&31)|0)!=0|r>>>s;v=q;break}else{t=i;u=(r|0)!=0&1;v=q;break}}else{if(j|0){m=30;break a}l=b&-2147483648|2139095040;f[a>>2]=l;return}else{if((e|0)==255){if(!g)l=b;else{m=30;break a}f[a>>2]=l;return}r=(i|0?536870912:q)+q|0;if(k>>>0<31){t=e;u=n;v=(r<<(0-k&31)|0)!=0|r>>>k;break}else{t=e;u=n;v=(r|0)!=0&1;break}}while(0);n=v+536870912+u|0;q=n>>>0<1073741824;o=(q<<31>>31)+t|0;p=n<<(q&1)}while(0);if((m|0)==30){l=((b&2143289344|0)==2139095040&(b&4194303|0)!=0?b:(b&2139095040|0)!=2139095040|(g|0)==0?c:b)|4194304;f[a>>2]=l;return}c=p&127;do if(o>>>0>252){if((o|0)>=0){if(!((o|0)>253|(p+64|0)<0)){w=o;x=c;y=p;break}l=b&-2147483648|2139095040;f[a>>2]=l;return}g=0-o|0;if(g>>>0<31)z=(p<<(o&31)|0)!=0|p>>>g;else z=(p|0)!=0&1;w=0;x=z&127;y=z}else{w=o;x=c;y=p}while(0);p=(y+64|0)>>>7&~(x<<24>>24==64);l=((p|0)==0?0:w<<23)+(p|b&-2147483648)|0;f[a>>2]=l;return}function OCa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[b>>2]|0;b=f[c>>2]|0;if((b^d|0)<0){NCa(a,d,b);return}else{MCa(a,d,b);return}}function PCa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=f[b>>2]|0;b=f[c>>2]|0;c=d>>>23&255;e=d&8388607;g=b>>>23&255;i=b&8388607;j=b^d;do if((c|0)==255)if((e|0)==0?!((i|0)!=0&(g|0)==255):0){k=g|i;l=24}else l=23;else{if((g|0)==255){if(i|0){l=23;break}k=c|e;l=24;break}if(!c){if(e|0){m=e>>>0<65536;n=m?d<<16:e;o=m?16:0;m=n>>>0<16777216;p=((h[358514+((m?n<<8:n)>>>24)>>0]|0)+((m?o|8:o)&255)<<24)+-134217728>>24;q=1-p|0;r=e<<p;l=11}}else{q=c;r=e;l=11}do if((l|0)==11){if(!g){if(!i)break;p=i>>>0<65536;o=p?b<<16:i;m=p?16:0;p=o>>>0<16777216;n=((h[358514+((p?o<<8:o)>>>24)>>0]|0)+((p?m|8:m)&255)<<24)+-134217728>>24;s=1-n|0;t=i<<n}else{s=g;t=i}n=W1a(t<<8|-2147483648|0,0,r<<7|1073741824|0,0)|0;m=((n&-32768|0)!=0|0!=0)&1|J;n=m>>>0<1073741824;p=s+q+(n?-128:-127)|0;o=m<<(n&1);n=o&127;do if(p>>>0>252){if((p|0)>=0){if(!((p|0)>253|(o+64|0)<0)){u=p;v=n;w=o;break}x=j&-2147483648|2139095040;f[a>>2]=x;return}m=0-p|0;if(m>>>0<31)y=(o<<(p&31)|0)!=0|o>>>m;else y=(o|0)!=0&1;u=0;v=y&127;w=y}else{u=p;v=n;w=o}while(0);o=(w+64|0)>>>7&~(v<<24>>24==64);x=((o|0)==0?0:u<<23)+(o|j&-2147483648)|0;f[a>>2]=x;return}while(0);x=j&-2147483648;f[a>>2]=x;return}while(0);if((l|0)==23){x=((d&2143289344|0)==2139095040&(d&4194303|0)!=0?d:(d&2139095040|0)!=2139095040|(e|0)==0?b:d)|4194304;f[a>>2]=x;return}else if((l|0)==24){x=(k|0)==0?-4194304:j&-2147483648|2139095040;f[a>>2]=x;return}}function QCa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=f[b>>2]|0;b=f[c>>2]|0;c=d>>>23&255;e=d&8388607;g=b>>>23;i=g&255;j=b&8388607;k=b^d;a:do if((c|0)==255)if(!e)if((i|0)==255)if(!j){l=-4194304;f[a>>2]=l;return}else m=22;else m=23;else m=22;else{b:do switch((g&255)<<24>>24){case -1:{if(j|0){m=22;break a}break}case 0:{if(j|0){n=j>>>0<65536;o=n?b<<16:j;p=n?16:0;n=o>>>0<16777216;q=((h[358514+((n?o<<8:o)>>>24)>>0]|0)+((n?p|8:p)&255)<<24)+-134217728>>24;r=1-q|0;s=j<<q;m=10;break b}if(!(c|e))l=-4194304;else{m=23;break a}f[a>>2]=l;return}default:{r=i;s=j;m=10}}while(0);do if((m|0)==10){if(!c){if(!e)break;q=e>>>0<65536;p=q?d<<16:e;n=q?16:0;q=p>>>0<16777216;o=((h[358514+((q?p<<8:p)>>>24)>>0]|0)+((q?n|8:n)&255)<<24)+-134217728>>24;t=1-o|0;u=e<<o}else{t=c;u=e}o=u|8388608;n=s|8388608;q=o>>>0<n>>>0;p=(q?125:126)+(t-r)|0;v=R1a(o|0,0,(q?31:30)|0)|0;q=J;o=U1a(v|0,q|0,n|0,0)|0;w=W1a(o|0,0,n|0,0)|0;n=(o&63|0)==0&((w|0)!=(v|0)|(J|0)!=(q|0))&1|o;o=n&127;do if(p>>>0>252){if((p|0)>=0){if(!((p|0)>253|(n+64|0)<0)){x=p;y=o;z=n;break}l=k&-2147483648|2139095040;f[a>>2]=l;return}q=0-p|0;if(q>>>0<31)A=(n<<(p&31)|0)!=0|n>>>q;else A=(n|0)!=0&1;x=0;y=A&127;z=A}else{x=p;y=o;z=n}while(0);n=(z+64|0)>>>7&~(y<<24>>24==64);l=((n|0)==0?0:x<<23)+(n|k&-2147483648)|0;f[a>>2]=l;return}while(0);l=k&-2147483648;f[a>>2]=l;return}while(0);if((m|0)==22){l=((d&2143289344|0)==2139095040&(d&4194303|0)!=0?d:(d&2139095040|0)!=2139095040|(e|0)==0?b:d)|4194304;f[a>>2]=l;return}else if((m|0)==23){l=k&-2147483648|2139095040;f[a>>2]=l;return}}function RCa(a,b){a=a|0;b=b|0;var c=0,d=0;c=f[b>>2]|0;b=f[a>>2]|0;if(!((c&2139095040|0)!=2139095040|(c&8388607|0)==0)){d=0;return d|0}if(!((b&2139095040|0)!=2139095040|(b&8388607|0)==0)){d=0;return d|0}a=c>>>31;if((a|0)==(b>>>31|0)){d=(c|0)!=(b|0)&(a|0)!=(c>>>0<b>>>0|0);return d|0}else{d=(c|0)<0&((b|c)&2147483647|0)!=0;return d|0}return 0}function SCa(a,b){a=a|0;b=b|0;var c=0,d=0;c=f[a>>2]|0;a=f[b>>2]|0;if(!((c&2139095040|0)!=2139095040|(c&8388607|0)==0)){d=0;return d|0}if(!((a&2139095040|0)!=2139095040|(a&8388607|0)==0)){d=0;return d|0}b=c>>>31;if((b|0)==(a>>>31|0)){d=(c|0)!=(a|0)&(b|0)!=(c>>>0<a>>>0|0);return d|0}else{d=(c|0)<0&((a|c)&2147483647|0)!=0;return d|0}return 0}function TCa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=(e|0)==0;i=g?32:0;j=g?d:e;g=j>>>0<65536;k=g?i|16:i;i=g?j<<16:j;j=i>>>0<16777216;g=((h[358514+((j?i<<8:i)>>>24)>>0]|0)+((j?k|8:k)&255)<<24)+-16777216|0;k=g>>24;j=c-k|0;if((g|0)>150994944&j>>>0<2045){g=R1a(b&1|0,0,63)|0;c=J;i=(d|0)!=0|(e|0)!=0;l=R1a(j|0,0,52)|0;m=i?J:0;n=R1a(d|0,e|0,k+-10|0)|0;o=C1a(n|0,J|0,g|0,c|0)|0;c=C1a(o|0,J|0,(i?l:0)|0,m|0)|0;p=c;q=J;r=a;s=r;f[s>>2]=p;t=r+4|0;u=t;f[u>>2]=q;return}c=R1a(d|0,e|0,k|0)|0;k=J;e=c&1023;do if((j&65535)>>>0>2044){if((j|0)>=0){C1a(c|0,k|0,512,0)|0;if(!((j|0)>2045|(J|0)<0)){v=c;w=k;x=j;y=e;break}d=R1a(b&1|0,0,63)|0;p=d;q=J|2146435072;r=a;s=r;f[s>>2]=p;t=r+4|0;u=t;f[u>>2]=q;return}d=0-j|0;if(d>>>0<63){m=I1a(c|0,k|0,d|0)|0;d=J;l=R1a(c|0,k|0,j&63|0)|0;z=((l|0)!=0|(J|0)!=0)&1|m;A=d}else{z=((c|0)!=0|(k|0)!=0)&1;A=0}v=z;w=A;x=0;y=z&1023}else{v=c;w=k;x=j;y=e}while(0);e=C1a(v|0,w|0,512,0)|0;w=I1a(e|0,J|0,10)|0;e=J;v=w&~((y|0)==512);y=(v|0)==0&(e|0)==0;w=R1a(b&1|0,0,63)|0;b=J;j=R1a(x|0,0,52)|0;x=C1a((y?0:j)|0,(y?0:J)|0,v|w|0,e|b|0)|0;p=x;q=J;r=a;s=r;f[s>>2]=p;t=r+4|0;u=t;f[u>>2]=q;return}function UCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!b){c=0;d=0;e=a;g=e;f[g>>2]=c;i=e+4|0;j=i;f[j>>2]=d;return}k=(b|0)<0?0-b|0:b;l=k>>>0<65536;m=l?k<<16:k;n=l?16:0;l=m>>>0<16777216;o=(h[358514+((l?m<<8:m)>>>24)>>0]|0)+((l?n|8:n)&255)|0;n=R1a(b>>>31|0,0,63)|0;b=J;l=(o<<24)+352321536>>24;o=R1a(1074-l|0,0,52)|0;m=J;p=R1a(k|0,0,l|0)|0;l=C1a(p|0,J|0,n|0,b|0)|0;b=C1a(l|0,J|0,o|0,m|0)|0;c=b;d=J;e=a;g=e;f[g>>2]=c;i=e+4|0;j=i;f[j>>2]=d;return}function VCa(a){a=a|0;var b=0,c=0,d=0;b=f[a>>2]|0;a=b>>>23&255;c=158-a|0;if((c|0)>31){d=0;return d|0}if((c|0)<1){d=(b|0)==-822083584?-2147483648:(b&8388607|0)!=0&(a|0)==255?2147483647:(b>>>31)+2147483647|0;return d|0}else{a=(b<<8|-2147483648)>>>c;d=(b|0)<0?0-a|0:a;return d|0}return 0}function WCa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a>>2]|0;a=b>>>23&255;c=b&8388607;d=(b|0)<0&((c|0)==0|(a|0)!=255);b=(a|0)==0?c:c|8388608;c=170-a|0;do if((c|0)>0)if(c>>>0<63){a=I1a(0,b|0,c|0)|0;e=J;g=R1a(0,b|0,0-c&63|0)|0;h=((g|0)!=0|(J|0)!=0)&1|a;i=e;break}else{h=(b|0)!=0&1;i=0;break}else{h=0;i=b}while(0);b=C1a(h|0,i|0,2048,0)|0;i=J;if(!(i>>>0>4095|(i|0)==4095&b>>>0>4294967295)){c=I1a(b|0,i|0,12)|0;i=(h&4095|0)==2048&0==0&1;h=d?(i|~c)+1|0:c&~i;if(!h){j=0;return j|0}if((h>>>31|0)==(d&1|0)){j=h;return j|0}}j=d?-2147483648:2147483647;return j|0}function XCa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=a;a=f[b>>2]|0;c=f[b+4>>2]|0;b=I1a(a|0,c|0,52)|0;d=b&2047;b=c&1048575;e=(c|0)<0&((a|0)==0&(b|0)==0|(d|0)!=2047);c=(d|0)==0;g=c?a:a;a=c?b:b|1048576;b=1063-d|0;do if((b|0)>0)if(b>>>0<63){d=I1a(g|0,a|0,b|0)|0;c=J;h=R1a(g|0,a|0,0-b&63|0)|0;i=((h|0)!=0|(J|0)!=0)&1|d;j=c;break}else{i=((g|0)!=0|(a|0)!=0)&1;j=0;break}else{i=g;j=a}while(0);a=C1a(i|0,j|0,2048,0)|0;j=J;if(!(j>>>0>4095|(j|0)==4095&a>>>0>4294967295)){g=I1a(a|0,j|0,12)|0;j=(i&4095|0)==2048&0==0&1;i=e?(j|~g)+1|0:g&~j;if(!i){k=0;return k|0}if((i>>>31|0)==(e&1|0)){k=i;return k|0}}k=e?-2147483648:2147483647;return k|0}function YCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=b;b=f[c>>2]|0;d=f[c+4>>2]|0;c=I1a(b|0,d|0,52)|0;e=c&2047;g=d&1048575;if((e|0)==2047){h=d&-2147483648;if((b|0)==0&(g|0)==0){i=h|2139095040;f[a>>2]=i;return}else{j=I1a(b|0,d|0,29)|0;i=h|2143289344|j&8388607;f[a>>2]=i;return}}j=I1a(b|0,g|0,22)|0;g=((b&4194303|0)!=0|0!=0)&1|j;if(!(g|e)){i=d&-2147483648;f[a>>2]=i;return}j=e+-897|0;b=g|1073741824;h=g&127;do if(j>>>0>252){if(e>>>0<897){g=897-e|0;k=g>>>0<31?(b<<(c+31&31)|0)!=0|b>>>g:1;l=0;m=k&127;n=k;break}if((j|0)>253|(b+64|0)<0){i=d&-2147483648|2139095040;f[a>>2]=i;return}else{l=j;m=h;n=b}}else{l=j;m=h;n=b}while(0);b=(n+64|0)>>>7&~(m<<24>>24==64);i=((b|0)==0?0:l<<23)+(b|d&-2147483648)|0;f[a>>2]=i;return}function ZCa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=b;b=f[d>>2]|0;e=f[d+4>>2]|0;d=c;c=f[d>>2]|0;g=f[d+4>>2]|0;d=(e|0)<0;h=I1a(b|0,e|0,63)|0;i=I1a(c|0,g|0,63)|0;if((h|0)==(i|0)){_Ca(a,b,e,c,g,d);return}else{$Ca(a,b,e,c,g,d);return}}function _Ca(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;h=I1a(b|0,c|0,52)|0;i=h&2047;j=c&1048575;k=I1a(d|0,e|0,52)|0;l=k&2047;m=e&1048575;n=i-l|0;a:do if(!n)switch(h&2047){case 0:{o=C1a(d|0,m|0,b|0,c|0)|0;p=J;q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}case 2047:{if((d|b|0)==0&(m|j|0)==0){o=b;p=c}else{u=28;break a}q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}default:{v=R1a(C1a(b|0,j|2097152|0,d|0,m|0)|0,J|0,9)|0;w=J;x=i;break a}}else{y=R1a(b|0,j|0,9)|0;z=J;A=R1a(d|0,m|0,9)|0;B=J;do if((n|0)<0)if((l|0)!=2047){C=(i|0)==0;D=R1a(b|0,j|0,10)|0;E=C?D:y;D=C?J:z|536870912;C=0-n|0;if(C>>>0<63){F=I1a(E|0,D|0,C|0)|0;C=J;G=R1a(E|0,D|0,h-k&63|0)|0;H=A;I=B;K=((G|0)!=0|(J|0)!=0)&1|F;L=C;M=l;break}else{H=A;I=B;K=((E|0)!=0|(D|0)!=0)&1;L=0;M=l;break}}else{if(!((d|0)==0&(m|0)==0)){u=28;break a}D=R1a(g&1|0,0,63)|0;o=D;p=J|2146435072;q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}else{if((i|0)==2047){if((b|0)==0&(j|0)==0){o=b;p=c}else{u=28;break a}q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}D=(l|0)==0;E=R1a(d|0,m|0,10)|0;C=D?E:A;E=D?J:B|536870912;if(n>>>0<63){D=I1a(C|0,E|0,n|0)|0;F=J;G=R1a(C|0,E|0,0-n&63|0)|0;H=((G|0)!=0|(J|0)!=0)&1|D;I=F;K=y;L=z;M=i;break}else{H=((C|0)!=0|(E|0)!=0)&1;I=0;K=y;L=z;M=i;break}}while(0);z=C1a(H|0,I|0,0,536870912)|0;y=C1a(z|0,J|0,K|0,L|0)|0;z=J;B=z>>>0<1073741824|(z|0)==1073741824&y>>>0<0;A=R1a(y|0,z|0,B&1|0)|0;v=A;w=J;x=(B<<31>>31)+M|0}while(0);if((u|0)==28){u=0==0&(c&2146959360|0)==2146435072&((b|0)!=0|(c&524287|0)!=0);M=0!=0|(c&2146435072|0)!=2146435072|(b|0)==0&(j|0)==0;o=u?b:M?d:b;p=(u?c:M?e:c)|524288;q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}c=v&1023;do if((x&65535)>>>0>2044){if((x|0)>=0){C1a(v|0,w|0,512,0)|0;if(!((x|0)>2045|(J|0)<0)){N=v;O=w;P=x;Q=c;break}e=R1a(g&1|0,0,63)|0;o=e;p=J|2146435072;q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}e=0-x|0;if(e>>>0<63){M=I1a(v|0,w|0,e|0)|0;e=J;u=R1a(v|0,w|0,x&63|0)|0;R=((u|0)!=0|(J|0)!=0)&1|M;S=e}else{R=((v|0)!=0|(w|0)!=0)&1;S=0}N=R;O=S;P=0;Q=R&1023}else{N=v;O=w;P=x;Q=c}while(0);c=C1a(N|0,O|0,512,0)|0;O=I1a(c|0,J|0,10)|0;c=J;N=O&~((Q|0)==512);Q=(N|0)==0&(c|0)==0;O=R1a(g&1|0,0,63)|0;g=J;x=R1a(P|0,0,52)|0;P=C1a((Q?0:x)|0,(Q?0:J)|0,N|O|0,c|g|0)|0;o=P;p=J;q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}function $Ca(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;i=I1a(b|0,c|0,52)|0;j=i&2047;k=c&1048575;l=I1a(d|0,e|0,52)|0;m=l&2047;n=e&1048575;o=j-m|0;a:do if(!o){if((j|0)==2047)if((d|b|0)==0&(n|k|0)==0){p=0;q=-524288;break}else{r=19;break}s=B1a(b|0,k|0,d|0,n|0)|0;t=J;if((s|0)==0&(t|0)==0){p=0;q=0}else{u=(j|0)==0?0:j+-1|0;v=(t|0)<0;w=B1a(0,0,s|0,t|0)|0;x=v?w:s;s=v?J:t;t=(s|0)==0;w=t?32:0;y=t?x:s;t=y>>>0<65536;z=t?w|16:w;w=t?y<<16:y;y=w>>>0<16777216;t=((h[358514+((y?w<<8:w)>>>24)>>0]|0)+((y?z|8:z)&255)&255)+245|0;z=u-(t<<24>>24)|0;y=(z|0)<0;w=R1a((v^g)&1|0,0,63)|0;v=J;A=R1a(z|0,0,52)|0;z=C1a((y?0:A)|0,(y?0:J)|0,w|0,v|0)|0;v=J;w=R1a(x|0,s|0,(y?u:t)<<24>>24|0)|0;t=C1a(z|0,v|0,w|0,J|0)|0;p=t;q=J}}else{t=R1a(b|0,k|0,10)|0;w=J;v=R1a(d|0,n|0,10)|0;z=J;do if((o|0)<0){u=g^1;if((m|0)==2047){if(!((d|0)==0&(n|0)==0)){r=19;break a}y=R1a(u&1|0,0,63)|0;p=y;q=J|2146435072;break a}y=(j|0)!=0;s=C1a((y?0:t)|0,(y?1073741824:w)|0,t|0,w|0)|0;y=J;x=0-o|0;if(x>>>0<63){A=I1a(s|0,y|0,x|0)|0;x=J;B=R1a(s|0,y|0,i-l&63|0)|0;C=z;D=v;E=((B|0)!=0|(J|0)!=0)&1|A;F=x;G=m;H=u;break}else{C=z;D=v;E=((s|0)!=0|(y|0)!=0)&1;F=0;G=m;H=u;break}}else{if((j|0)==2047)if((b|0)==0&(k|0)==0){p=b;q=c;break a}else{r=19;break a}u=(m|0)!=0;y=C1a((u?0:v)|0,(u?1073741824:z)|0,v|0,z|0)|0;u=J;if(o>>>0<63){s=I1a(y|0,u|0,o|0)|0;x=J;A=R1a(y|0,u|0,0-o&63|0)|0;C=w;D=t;E=((A|0)!=0|(J|0)!=0)&1|s;F=x;G=j;H=g;break}else{C=w;D=t;E=((y|0)!=0|(u|0)!=0)&1;F=0;G=j;H=g;break}}while(0);t=B1a(D|0,C|1073741824|0,E|0,F|0)|0;TCa(a,H,G+-1|0,t,J);return}while(0);if((r|0)==19){r=0==0&(c&2146959360|0)==2146435072&((b|0)!=0|(c&524287|0)!=0);G=0!=0|(c&2146435072|0)!=2146435072|(b|0)==0&(k|0)==0;p=r?b:G?d:b;q=(r?c:G?e:c)|524288}c=a;f[c>>2]=p;f[c+4>>2]=q;return}function aDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=b;b=f[d>>2]|0;e=f[d+4>>2]|0;d=c;c=f[d>>2]|0;g=f[d+4>>2]|0;d=(e|0)<0;h=I1a(b|0,e|0,63)|0;i=I1a(c|0,g|0,63)|0;if((h|0)==(i|0)){$Ca(a,b,e,c,g,d);return}else{_Ca(a,b,e,c,g,d);return}}function bDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=b;b=f[d>>2]|0;e=f[d+4>>2]|0;d=c;c=f[d>>2]|0;g=f[d+4>>2]|0;d=I1a(b|0,e|0,52)|0;i=d&2047;d=e&1048575;j=I1a(c|0,g|0,52)|0;k=j&2047;j=g&1048575;l=g^e;do if((i|0)==2047)if((b|0)==0&(d|0)==0?!(((c|0)!=0|(j|0)!=0)&(k|0)==2047):0){m=c;n=j;o=k;p=22}else p=21;else{if((k|0)==2047)if((c|0)==0&(j|0)==0){m=b;n=d;o=i;p=22;break}else{p=21;break}if(!i){if(!((b|0)==0&(d|0)==0)){q=(d|0)==0;r=q?32:0;s=q?b:d;q=s>>>0<65536;t=q?r|16:r;r=q?s<<16:s;s=r>>>0<16777216;q=((h[358514+((s?r<<8:r)>>>24)>>0]|0)+((s?t|8:t)&255)<<24)+-184549376>>24;t=R1a(b|0,d|0,q|0)|0;u=t;v=J;w=1-q|0;p=9}}else{u=b;v=d;w=i;p=9}do if((p|0)==9){if(!k){if((c|0)==0&(j|0)==0)break;q=(j|0)==0;t=q?32:0;s=q?c:j;q=s>>>0<65536;r=q?t|16:t;t=q?s<<16:s;s=t>>>0<16777216;q=((h[358514+((s?t<<8:t)>>>24)>>0]|0)+((s?r|8:r)&255)<<24)+-184549376>>24;r=R1a(c|0,j|0,q|0)|0;x=r;y=J;z=1-q|0}else{x=c;y=j;z=k}q=R1a(u|0,v|0,10)|0;r=R1a(x|0,y|0,11)|0;s=I1a(u|0,v|0,22)|0;t=s&-1073741825|1073741824;s=I1a(x|0,y|0,21)|0;A=s&2147483647|-2147483648;s=q&-1024;q=r&-2048;r=W1a(q|0,0,s|0,0)|0;B=J;C=W1a(q|0,0,t|0,0)|0;q=J;D=W1a(A|0,0,s|0,0)|0;s=C1a(D|0,J|0,C|0,q|0)|0;D=J;E=W1a(A|0,0,t|0,0)|0;t=C1a(D|0,(D>>>0<q>>>0|(D|0)==(q|0)&s>>>0<C>>>0)&1|0,E|0,J|0)|0;E=J;C=C1a(0,s|0,r|0,B|0)|0;B=J;r=C1a(t|0,E|0,(B>>>0<s>>>0|(B|0)==(s|0)&C>>>0<0)&1|0,0)|0;s=J;E=r|((C|0)!=0|(B|0)!=0)&1;B=s>>>0<1073741824|(s|0)==1073741824&E>>>0<0;C=z+w+(B?-1024:-1023)|0;r=R1a(E|0,s|0,B&1|0)|0;B=J;s=r&1023;do if((C&65535)>>>0>2044){if((C|0)>=0){C1a(r|0,B|0,512,0)|0;if(!((C|0)>2045|(J|0)<0)){F=r;G=B;H=C;I=s;break}K=0;L=l&-2147483648|2146435072;M=a;N=M;f[N>>2]=K;O=M+4|0;P=O;f[P>>2]=L;return}E=0-C|0;if(E>>>0<63){t=I1a(r|0,B|0,E|0)|0;E=J;q=R1a(r|0,B|0,C&63|0)|0;Q=((q|0)!=0|(J|0)!=0)&1|t;R=E}else{Q=((r|0)!=0|(B|0)!=0)&1;R=0}F=Q;G=R;H=0;I=Q&1023}else{F=r;G=B;H=C;I=s}while(0);s=C1a(F|0,G|0,512,0)|0;C=I1a(s|0,J|0,10)|0;s=J;B=C&~((I|0)==512);C=(B|0)==0&(s|0)==0;r=R1a(H|0,0,52)|0;E=C1a((C?0:r)|0,(C?0:J)|0,B|0,s|l&-2147483648|0)|0;K=E;L=J;M=a;N=M;f[N>>2]=K;O=M+4|0;P=O;f[P>>2]=L;return}while(0);K=0;L=l&-2147483648;M=a;N=M;f[N>>2]=K;O=M+4|0;P=O;f[P>>2]=L;return}while(0);if((p|0)==21){H=0==0&(e&2146959360|0)==2146435072&((b|0)!=0|(e&524287|0)!=0);I=0!=0|(e&2146435072|0)!=2146435072|(b|0)==0&(d|0)==0;K=H?b:I?c:b;L=(H?e:I?g:e)|524288;M=a;N=M;f[N>>2]=K;O=M+4|0;P=O;f[P>>2]=L;return}else if((p|0)==22){p=(o|m|0)==0&(n|0)==0;K=p?0:0;L=p?-524288:l&-2147483648|2146435072;M=a;N=M;f[N>>2]=K;O=M+4|0;P=O;f[P>>2]=L;return}}function cDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=b;b=f[d>>2]|0;e=f[d+4>>2]|0;d=c;c=f[d>>2]|0;g=f[d+4>>2]|0;d=I1a(b|0,e|0,52)|0;i=d&2047;d=e&1048575;j=I1a(c|0,g|0,52)|0;k=j&2047;l=g&1048575;m=g^e;a:do if((i|0)==2047)if((b|0)==0&(d|0)==0)if((k|0)==2047)if((c|0)==0&(l|0)==0){n=0;o=-524288;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}else t=26;else t=27;else t=26;else{b:do switch(j&2047){case 2047:{if(!((c|0)==0&(l|0)==0)){t=26;break a}break}case 0:{if(!((c|0)==0&(l|0)==0)){u=(l|0)==0;v=u?32:0;w=u?c:l;u=w>>>0<65536;x=u?v|16:v;v=u?w<<16:w;w=v>>>0<16777216;u=((h[358514+((w?v<<8:v)>>>24)>>0]|0)+((w?x|8:x)&255)<<24)+-184549376>>24;x=R1a(c|0,l|0,u|0)|0;y=J;z=x;A=1-u|0;t=10;break b}if((i|b|0)==0&(d|0)==0){n=0;o=-524288}else{t=27;break a}p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}default:{y=l;z=c;A=k;t=10}}while(0);do if((t|0)==10){if(!i){if((b|0)==0&(d|0)==0)break;u=(d|0)==0;x=u?32:0;w=u?b:d;u=w>>>0<65536;v=u?x|16:x;x=u?w<<16:w;w=x>>>0<16777216;u=((h[358514+((w?x<<8:x)>>>24)>>0]|0)+((w?v|8:v)&255)<<24)+-184549376>>24;v=R1a(b|0,d|0,u|0)|0;B=J;C=v;D=1-u|0}else{B=d;C=b;D=i}u=B|1048576;v=y|1048576;w=u>>>0<v>>>0|(u|0)==(v|0)&C>>>0<z>>>0;x=(w?1021:1022)+(D-A)|0;E=R1a(C|0,u|0,(w?11:10)|0)|0;w=J;u=I1a(z|0,v|0,21)|0;v=U1a(-1,2147483647,u|0,0)|0;F=v+-2|0;W1a(w|0,0,F|0,0)|0;v=J;G=R1a(v|0,0,1)|0;H=G&-2;G=W1a(H|0,0,u|0,0)|0;I=B1a(E|0,w|0,G|0,J|0)|0;G=R1a(I|0,J|0,28)|0;I=J;w=z<<7&268435328;E=W1a(H|0,0,w|0,0)|0;H=B1a(G|0,I|0,E|0,J|0)|0;E=J;W1a(E|0,0,F|0,0)|0;F=C1a(J|0,0,4,0)|0;I=R1a(F|0,J|0,4)|0;G=C1a(I&-16|0,J&15|0,0,v|0)|0;v=J;do if(0<0|0==0&(G&448)>>>0<64){I=G&-128;K=F<<1&-16;L=W1a(K|0,0,u|0,0)|0;M=B1a(H|0,E|0,L|0,J|0)|0;L=R1a(M|0,J|0,28)|0;M=J;N=W1a(K|0,0,w|0,0)|0;K=B1a(L|0,M|0,N|0,J|0)|0;N=J;if((N|0)<0){M=C1a(I|0,v|0,-128,-1)|0;O=M;P=J;break}else{O=((K|0)!=0|(N|0)!=0)&1|I;P=v;break}}else{O=G;P=v}while(0);v=O&1023;do if((x&65535)>>>0>2044){if((x|0)>=0){C1a(O|0,P|0,512,0)|0;if(!((x|0)>2045|(J|0)<0)){Q=O;R=P;S=x;T=v;break}n=0;o=m&-2147483648|2146435072;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}G=0-x|0;if(G>>>0<63){w=I1a(O|0,P|0,G|0)|0;G=J;E=R1a(O|0,P|0,x&63|0)|0;U=((E|0)!=0|(J|0)!=0)&1|w;V=G}else{U=((O|0)!=0|(P|0)!=0)&1;V=0}Q=U;R=V;S=0;T=U&1023}else{Q=O;R=P;S=x;T=v}while(0);v=C1a(Q|0,R|0,512,0)|0;x=I1a(v|0,J|0,10)|0;v=J;G=x&~((T|0)==512);x=(G|0)==0&(v|0)==0;w=R1a(S|0,0,52)|0;E=C1a((x?0:w)|0,(x?0:J)|0,G|0,v|m&-2147483648|0)|0;n=E;o=J;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}while(0);n=0;o=m&-2147483648;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}while(0);if((t|0)==26){S=0==0&(e&2146959360|0)==2146435072&((b|0)!=0|(e&524287|0)!=0);T=0!=0|(e&2146435072|0)!=2146435072|(b|0)==0&(d|0)==0;n=S?b:T?c:b;o=(S?e:T?g:e)|524288;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}else if((t|0)==27){n=0;o=m&-2147483648|2146435072;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}}function dDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a;a=f[c>>2]|0;d=f[c+4>>2]|0;c=b;b=f[c>>2]|0;e=f[c+4>>2]|0;if(!(0!=0|(d&2146435072|0)!=2146435072|(a|0)==0&(d&1048575|0)==0)){g=0;return g|0}if(!(0!=0|(e&2146435072|0)!=2146435072|(b|0)==0&(e&1048575|0)==0)){g=0;return g|0}g=(a|0)==(b|0)&(d|0)==(e|0)|(b|a|0)==0&((e|d)&2147483647|0)==0;return g|0}function eDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a;a=f[c>>2]|0;d=f[c+4>>2]|0;c=b;b=f[c>>2]|0;e=f[c+4>>2]|0;if(!(0!=0|(d&2146435072|0)!=2146435072|(a|0)==0&(d&1048575|0)==0)){g=0;return g|0}if(!(0!=0|(e&2146435072|0)!=2146435072|(b|0)==0&(e&1048575|0)==0)){g=0;return g|0}c=I1a(a|0,d|0,63)|0;h=I1a(b|0,e|0,63)|0;if((c|0)==(h|0)){g=(a|0)==(b|0)&(d|0)==(e|0)|(c|0)!=((d>>>0<e>>>0|(d|0)==(e|0)&a>>>0<b>>>0)&1|0);return g|0}else{g=(d|0)<0|(b|a|0)==0&((e|d)&2147483647|0)==0;return g|0}return 0}function fDa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;e=f[b>>2]|0;b=f[c>>2]|0;c=f[d>>2]|0;d=e>>>23&255;g=e&8388607;i=b>>>23&255;j=b&8388607;k=c>>>31;l=k&255;m=c>>>23&255;n=c&8388607;o=b^e;p=o>>>31;q=p&255;do if((d|0)==255)if((g|0)==0?!((j|0)!=0&(i|0)==255):0){r=i|j;s=54}else s=53;else{if((i|0)==255){if(j|0){s=53;break}r=d|g;s=54;break}if((m|0)==255){if(!n)t=c;else{u=0;break}f[a>>2]=t;return}if(!d)if(!g)s=59;else{v=g>>>0<65536;w=v?e<<16:g;x=v?16:0;v=w>>>0<16777216;y=((h[358514+((v?w<<8:w)>>>24)>>0]|0)+((v?x|8:x)&255)<<24)+-134217728>>24;z=1-y|0;A=g<<y;s=13}else{z=d;A=g;s=13}a:do if((s|0)==13){if(!i){if(!j){s=59;break}y=j>>>0<65536;x=y?b<<16:j;v=y?16:0;y=x>>>0<16777216;w=((h[358514+((y?x<<8:x)>>>24)>>0]|0)+((y?v|8:v)&255)<<24)+-134217728>>24;B=1-w|0;C=j<<w}else{B=i;C=j}w=W1a(C<<7|1073741824|0,0,A<<7|1073741824|0,0)|0;v=J;y=v>>>0<536870912|(v|0)==536870912&w>>>0<0;x=B+z+(y?-127:-126)|0;D=R1a(w|0,v|0,y&1|0)|0;y=J;do if(!m)if(!n){v=I1a(D|0,y|0,31)|0;E=x+-1|0;F=((D&2147467264|0)!=0|0!=0)&1|v;G=(p|0)!=0;break}else{v=n>>>0<65536;w=v?c<<16:n;H=v?16:0;v=w>>>0<16777216;I=((h[358514+((v?w<<8:w)>>>24)>>0]|0)+((v?H|8:H)&255)<<24)+-134217728>>24;K=1-I|0;L=n<<I;s=20;break}else{K=m;L=n;s=20}while(0);do if((s|0)==20){I=L<<6|536870912;H=x-K|0;if((o^c|0)>-1){if((H|0)<1){v=32-H|0;if(v>>>0<63){w=I1a(D|0,y|0,v|0)|0;M=R1a(D|0,y|0,0-v&63|0)|0;N=((M|0)!=0|(J|0)!=0)&1|w}else N=((D|0)!=0|(y|0)!=0)&1;O=K;P=N+I|0}else{if(H>>>0<63){w=I1a(0,I|0,H|0)|0;M=J;v=R1a(0,I|0,0-H&63|0)|0;Q=((v|0)!=0|(J|0)!=0)&1|w;R=M}else{Q=1;R=0}M=C1a(Q|0,R|0,D|0,y|0)|0;O=x;P=((M|0)!=0|0!=0)&1|J}M=P>>>0<1073741824;E=(M<<31>>31)+O|0;F=P<<(M&1);G=(p|0)!=0;break}do if((H|0)<0){M=0-H|0;if(M>>>0<63){w=I1a(D|0,y|0,M|0)|0;M=J;v=R1a(D|0,y|0,H&63|0)|0;S=((v|0)!=0|(J|0)!=0)&1|w;T=M}else{S=((D|0)!=0|(y|0)!=0)&1;T=0}M=B1a(0,I|0,S|0,T|0)|0;U=J;V=M;W=K;X=l}else{if(!H){M=B1a(D|0,y|0,0,I|0)|0;w=J;if((M|0)==0&(w|0)==0)break a;v=(w|0)<0;Y=B1a(0,0,M|0,w|0)|0;Z=J;_=I1a(M|0,w|0,63)|0;U=v?Z:w;V=v?Y:M;W=x;X=_&255^q;break}if(H>>>0<63){_=I1a(0,I|0,H|0)|0;M=J;Y=R1a(0,I|0,0-H&63|0)|0;$=((Y|0)!=0|(J|0)!=0)&1|_;aa=M}else{$=1;aa=0}M=B1a(D|0,y|0,$|0,aa|0)|0;U=J;V=M;W=x;X=q}while(0);H=(U|0)==0;I=H?32:0;M=H?V:U;H=M>>>0<65536;_=H?I|16:I;I=H?M<<16:M;M=I>>>0<16777216;H=((M?_|8:_)&255)+(h[358514+((M?I<<8:I)>>>24)>>0]|0)<<24;I=W-(H+-16777216>>24)|0;M=H+-553648128|0;H=M>>24;if((M|0)<0){M=0-H&255;_=I1a(V|0,U|0,M|0)|0;Y=R1a(1,0,M|0)|0;M=C1a(Y|0,J|0,-1,-1)|0;E=I;F=((M&V|0)!=0|(J&U|0)!=0)&1|_;G=(X&1)!=0;break}else{E=I;F=V<<H;G=(X&1)!=0;break}}while(0);x=F&127;do if(E>>>0>252){if((E|0)>=0){if(!((E|0)>253|(F+64|0)<0)){ba=E;ca=x;da=F;break}t=(G&1)<<31|2139095040;f[a>>2]=t;return}y=0-E|0;if(y>>>0<31)ea=(F<<(E&31)|0)!=0|F>>>y;else ea=(F|0)!=0&1;ba=0;ca=ea&127;da=ea}else{ba=E;ca=x;da=F}while(0);x=(da+64|0)>>>7&~(ca<<24>>24==64);t=((x|0)==0?0:ba<<23)+(x|(G&1)<<31)|0;f[a>>2]=t;return}while(0);if((s|0)==59?!((o^c|0)<0&(m|n|0)==0):0){t=c;f[a>>2]=t;return}t=0;f[a>>2]=t;return}while(0);if((s|0)==53)u=((e&2143289344|0)==2139095040&(e&4194303|0)!=0?e:(e&2139095040|0)!=2139095040|(g|0)==0?b:e)|4194304;else if((s|0)==54)if(r){r=p<<31|2139095040;if((m|0)!=255){t=r;f[a>>2]=t;return}if(!n)if((p|0)==(k|0)){t=r;f[a>>2]=t;return}else u=-4194304;else u=r}else u=-4194304;t=((u&2143289344|0)==2139095040&(u&4194303|0)!=0?u:(u&2139095040|0)!=2139095040|(u&8388607|0)==0?c:u)|4194304;f[a>>2]=t;return}function gDa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+176|0;e=d+160|0;g=d+144|0;h=d+136|0;i=d+120|0;j=d+104|0;k=d+96|0;l=d+168|0;m=d+152|0;n=d+88|0;o=d+80|0;p=d+128|0;q=d+72|0;r=d+112|0;s=d+64|0;t=d+56|0;v=d+48|0;w=d+40|0;x=d+32|0;y=d+24|0;z=d+16|0;A=d+8|0;B=d;C=c;D=f[C>>2]|0;E=f[C+4>>2]|0;C=E&2147483647;if(C>>>0>2146435072|(C|0)==2146435072&D>>>0>0){F=a;f[F>>2]=-1;f[F+4>>2]=2147483647;u=d;return}if((D|0)==0&(C|0)==2146435072)if((D|0)==0&(E|0)==2146435072&(0!=0|(E&2146435072|0)!=2146435072|(D|0)==0&(E&1048575|0)==0)){E=a;f[E>>2]=0;f[E+4>>2]=2146435072;u=d;return}else{E=a;f[E>>2]=0;f[E+4>>2]=0;u=d;return}if((b[899992]|0)==0?u1a(899992)|0:0){E=e;f[E>>2]=0;f[E+4>>2]=1072693248;cDa(9e5,e,19400)}if((b[900008]|0)==0?u1a(900008)|0:0){e=g;f[e>>2]=-17155599;f[e+4>>2]=1072049730;cDa(900016,g,19400)}if((b[900024]|0)==0?u1a(900024)|0:0){g=h;f[g>>2]=-8215462;f[g+4>>2]=1070514109;cDa(900032,h,19400)}if((b[900040]|0)==0?u1a(900040)|0:0){h=i;f[h>>2]=-668996491;f[h+4>>2]=1068264200;cDa(900048,i,19400)}if((b[900056]|0)==0?u1a(900056)|0:0){i=j;f[i>>2]=726613203;f[i+4>>2]=1065595559;cDa(900064,j,19400)}if((b[900072]|0)==0?u1a(900072)|0:0){j=k;f[j>>2]=359056036;f[j+4>>2]=1062594474;cDa(900080,k,19400)}k=l;f[k>>2]=0;f[k+4>>2]=0;k=f[c+4>>2]|0;j=k&2145386496;if(j>>>0>1083179008|(j|0)==1083179008&0>0){j=k&-2147483648|1091006464;k=l;f[k>>2]=0;f[k+4>>2]=j;G=0;H=j}else{bDa(m,c,19408);c=m;j=f[c>>2]|0;k=f[c+4>>2]|0;c=l;f[c>>2]=j;f[c+4>>2]=k;G=j;H=k}k=I1a(G|0,H|0,52)|0;j=k&2047;k=H&1048575;c=(H|0)<0;i=(G|0)==0&(k|0)==0|(j|0)!=2047;h=c&i;g=(j|0)==0;e=g?G:G;E=g?k:k|1048576;g=1063-j|0;do if((g|0)>0)if(g>>>0<63){D=I1a(e|0,E|0,g|0)|0;C=J;F=R1a(e|0,E|0,0-g&63|0)|0;I=((F|0)!=0|(J|0)!=0)&1|D;K=C;break}else{I=((e|0)!=0|(E|0)!=0)&1;K=0;break}else{I=e;K=E}while(0);E=C1a(I|0,K|0,2048,0)|0;K=J;if(!(K>>>0>4095|(K|0)==4095&E>>>0>4294967295)){e=I1a(E|0,K|0,12)|0;K=(I&4095|0)==2048&0==0&1;I=h?(K|~e)+1|0:e&~K;if(I)if((I>>>31|0)==(h&1|0))L=I;else M=35;else L=0}else M=35;if((M|0)==35)L=h?-2147483648:2147483647;h=L>>6;M=h+1023|0;I=(h|0)<-1023;h=R1a(((M|0)<2047?M:2047)|0,0,52)|0;M=m;f[M>>2]=I?0:h;f[M+4>>2]=I?0:J;do if(j>>>0>=1023){if(j>>>0<=1074){I=R1a(1,0,1075-j|0)|0;M=J;h=C1a(I|0,M|0,-1,-1)|0;K=J;e=I1a(I|0,M|0,1)|0;E=C1a(e|0,J|0,G|0,H|0)|0;e=J;g=(E&h|0)==0&(e&K|0)==0;K=B1a(0,0,I|0,M|0)|0;N=E&K&(g?~I:-1);O=e&J&(g?~M:-1);break}if(i){N=G;O=H}else{M=0==0&(H&2146959360|0)==2146435072&((G|0)!=0|(H&524287|0)!=0);g=0!=0|(H&2146435072|0)!=2146435072;N=M?G:g?0:G;O=(M?H:g?0:H)|524288}}else{g=(G|0)==0&(H&2147483647|0)==0;M=H&-2147483648;e=((G|0)!=0|(k|0)!=0)&(j|0)==1022;N=g?G:e?0:0;O=g?H:e?M|1072693248:M}while(0);j=I1a(G|0,H|0,63)|0;k=I1a(N|0,O|0,63)|0;if((j|0)==(k|0))$Ca(n,G,H,N,O,c);else _Ca(n,G,H,N,O,c);bDa(l,n,19416);bDa(o,m,19400);m=19424+((L&63)<<3)|0;L=f[m+4>>2]|0;n=p;f[n>>2]=f[m>>2];f[n+4>>2]=L;bDa(q,o,p);bDa(s,900080,l);p=s;s=f[p>>2]|0;o=f[p+4>>2]|0;p=900064;L=f[p>>2]|0;n=f[p+4>>2]|0;p=(o|0)<0;m=I1a(s|0,o|0,63)|0;c=I1a(L|0,n|0,63)|0;if((m|0)==(c|0))_Ca(t,s,o,L,n,p);else $Ca(t,s,o,L,n,p);bDa(v,t,l);t=v;v=f[t>>2]|0;p=f[t+4>>2]|0;t=900048;n=f[t>>2]|0;L=f[t+4>>2]|0;t=(p|0)<0;o=I1a(v|0,p|0,63)|0;s=I1a(n|0,L|0,63)|0;if((o|0)==(s|0))_Ca(w,v,p,n,L,t);else $Ca(w,v,p,n,L,t);bDa(x,w,l);w=x;x=f[w>>2]|0;t=f[w+4>>2]|0;w=900032;L=f[w>>2]|0;n=f[w+4>>2]|0;w=(t|0)<0;p=I1a(x|0,t|0,63)|0;v=I1a(L|0,n|0,63)|0;if((p|0)==(v|0))_Ca(y,x,t,L,n,w);else $Ca(y,x,t,L,n,w);bDa(z,y,l);y=z;z=f[y>>2]|0;w=f[y+4>>2]|0;y=900016;n=f[y>>2]|0;L=f[y+4>>2]|0;y=(w|0)<0;t=I1a(z|0,w|0,63)|0;x=I1a(n|0,L|0,63)|0;if((t|0)==(x|0))_Ca(A,z,w,n,L,y);else $Ca(A,z,w,n,L,y);bDa(B,A,l);l=B;B=f[l>>2]|0;A=f[l+4>>2]|0;l=9e5;y=f[l>>2]|0;L=f[l+4>>2]|0;l=(A|0)<0;n=I1a(B|0,A|0,63)|0;w=I1a(y|0,L|0,63)|0;if((n|0)==(w|0))_Ca(r,B,A,y,L,l);else $Ca(r,B,A,y,L,l);bDa(a,q,r);u=d;return}function hDa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=u;u=u+240|0;e=d+232|0;g=d+224|0;i=d+216|0;j=d+208|0;k=d+200|0;l=d+192|0;m=d+184|0;n=d+176|0;o=d+168|0;p=d+160|0;q=d+152|0;r=d+144|0;s=d+128|0;t=d+136|0;v=d+120|0;w=d+112|0;x=d+96|0;y=d+88|0;z=d+80|0;A=d+72|0;B=d+64|0;C=d+56|0;D=d+48|0;E=d+104|0;F=d+40|0;G=d+32|0;H=d+24|0;I=d+16|0;K=d+8|0;L=d;M=c;N=f[M>>2]|0;O=f[M+4>>2]|0;M=O&2147483647;if(!(M>>>0>2146435072|(M|0)==2146435072&N>>>0>0)?(P=O&2146435072,Q=O&1048575,(N|0)==0&(M|0)==0|((O|0)>-1|(O|0)==-1&N>>>0>4294967295|((N|0)!=0|(Q|0)!=0)&(0==0&(P|0)==2146435072))):0){a:do if(0!=0|(P|0)!=2146435072|(N|0)==0&(Q|0)==0?(N|0)==0:0){if((O|0)<0)switch(O|0){case -2147483648:break;default:break a}else switch(O|0){case 0:break;default:break a}M=a;f[M>>2]=0;f[M+4>>2]=-1048576;u=d;return}while(0);if((b[900088]|0)==0?u1a(900088)|0:0){O=900096;f[O>>2]=0;f[O+4>>2]=1072693248}if((b[900104]|0)==0?u1a(900104)|0:0){O=g;f[O>>2]=0;f[O+4>>2]=-1074790400;O=e;f[O>>2]=0;f[O+4>>2]=1073741824;cDa(900112,g,e)}if((b[900120]|0)==0?u1a(900120)|0:0){g=i;f[g>>2]=0;f[g+4>>2]=1072693248;g=e;f[g>>2]=0;f[g+4>>2]=1074266112;cDa(900128,i,e)}if((b[900136]|0)==0?u1a(900136)|0:0){i=j;f[i>>2]=0;f[i+4>>2]=-1074790400;i=e;f[i>>2]=0;f[i+4>>2]=1074790400;cDa(900144,j,e)}if((b[900152]|0)==0?u1a(900152)|0:0){j=k;f[j>>2]=0;f[j+4>>2]=1072693248;j=e;f[j>>2]=0;f[j+4>>2]=1075052544;cDa(900160,k,e)}if((b[900168]|0)==0?u1a(900168)|0:0){k=l;f[k>>2]=0;f[k+4>>2]=-1074790400;k=e;f[k>>2]=0;f[k+4>>2]=1075314688;cDa(900176,l,e)}if((b[900184]|0)==0?u1a(900184)|0:0){l=m;f[l>>2]=0;f[l+4>>2]=1072693248;l=e;f[l>>2]=0;f[l+4>>2]=1075576832;cDa(900192,m,e)}if((b[900200]|0)==0?u1a(900200)|0:0){m=n;f[m>>2]=0;f[m+4>>2]=-1074790400;m=e;f[m>>2]=0;f[m+4>>2]=1075838976;cDa(900208,n,e)}n=c;m=f[n>>2]|0;l=f[n+4>>2]|0;n=I1a(m|0,l|0,44)|0;k=n&255;n=l&4095|1072693248;l=o;f[l>>2]=m;f[l+4>>2]=n;$Ca(o,m,n,0,1072693248,0);n=k<<1;m=4528+(n<<3)|0;l=f[m>>2]|0;j=f[m+4>>2]|0;m=4528+((n|1)<<3)|0;n=f[m+4>>2]|0;i=p;f[i>>2]=f[m>>2];f[i+4>>2]=n;bDa(q,o,p);if((k|0)==255){k=s;f[k>>2]=0;f[k+4>>2]=-1074790400;k=t;f[k>>2]=0;f[k+4>>2]=1082130432;cDa(r,s,t);s=q;k=f[s>>2]|0;p=f[s+4>>2]|0;s=r;o=f[s>>2]|0;n=f[s+4>>2]|0;s=(p|0)<0;i=I1a(k|0,p|0,63)|0;m=I1a(o|0,n|0,63)|0;if((i|0)==(m|0))_Ca(e,k,p,o,n,s);else $Ca(e,k,p,o,n,s);s=e;n=f[s+4>>2]|0;o=q;f[o>>2]=f[s>>2];f[o+4>>2]=n}bDa(e,q,q);n=c;c=I1a(f[n>>2]|0,f[n+4>>2]|0,52)|0;n=c&2047;c=n+-1023|0;if(!c){R=0;S=0}else{o=n>>>0<1023?1023-n|0:c;n=o>>>0<65536;s=n?o<<16:o;p=n?16:0;n=s>>>0<16777216;k=(h[358514+((n?s<<8:s)>>>24)>>0]|0)+((n?p|8:p)&255)|0;p=R1a(c>>>31|0,0,63)|0;c=J;n=(k<<24)+352321536>>24;k=R1a(1074-n|0,0,52)|0;s=J;m=R1a(o|0,0,n|0)|0;n=C1a(m|0,J|0,p|0,c|0)|0;c=C1a(n|0,J|0,k|0,s|0)|0;R=c;S=J}c=r;f[c>>2]=R;f[c+4>>2]=S;bDa(v,19936,r);r=v;v=f[r>>2]|0;S=f[r+4>>2]|0;r=(S|0)<0;c=I1a(v|0,S|0,63)|0;R=I1a(l|0,j|0,63)|0;if((c|0)==(R|0))_Ca(w,v,S,l,j,r);else $Ca(w,v,S,l,j,r);bDa(x,900208,e);r=x;x=f[r>>2]|0;j=f[r+4>>2]|0;r=900176;l=f[r>>2]|0;S=f[r+4>>2]|0;r=(j|0)<0;v=I1a(x|0,j|0,63)|0;R=I1a(l|0,S|0,63)|0;if((v|0)==(R|0))_Ca(y,x,j,l,S,r);else $Ca(y,x,j,l,S,r);bDa(z,y,e);y=z;z=f[y>>2]|0;r=f[y+4>>2]|0;y=900144;S=f[y>>2]|0;l=f[y+4>>2]|0;y=(r|0)<0;j=I1a(z|0,r|0,63)|0;x=I1a(S|0,l|0,63)|0;if((j|0)==(x|0))_Ca(A,z,r,S,l,y);else $Ca(A,z,r,S,l,y);bDa(B,A,e);A=B;B=f[A>>2]|0;y=f[A+4>>2]|0;A=900112;l=f[A>>2]|0;S=f[A+4>>2]|0;A=(y|0)<0;r=I1a(B|0,y|0,63)|0;z=I1a(l|0,S|0,63)|0;if((r|0)==(z|0))_Ca(C,B,y,l,S,A);else $Ca(C,B,y,l,S,A);bDa(t,C,e);C=w;w=f[C>>2]|0;A=f[C+4>>2]|0;C=t;t=f[C>>2]|0;S=f[C+4>>2]|0;C=(A|0)<0;l=I1a(w|0,A|0,63)|0;y=I1a(t|0,S|0,63)|0;if((l|0)==(y|0))_Ca(D,w,A,t,S,C);else $Ca(D,w,A,t,S,C);bDa(F,900192,e);C=F;F=f[C>>2]|0;S=f[C+4>>2]|0;C=900160;t=f[C>>2]|0;A=f[C+4>>2]|0;C=(S|0)<0;w=I1a(F|0,S|0,63)|0;y=I1a(t|0,A|0,63)|0;if((w|0)==(y|0))_Ca(G,F,S,t,A,C);else $Ca(G,F,S,t,A,C);bDa(H,G,e);G=H;H=f[G>>2]|0;C=f[G+4>>2]|0;G=900128;A=f[G>>2]|0;t=f[G+4>>2]|0;G=(C|0)<0;S=I1a(H|0,C|0,63)|0;F=I1a(A|0,t|0,63)|0;if((S|0)==(F|0))_Ca(I,H,C,A,t,G);else $Ca(I,H,C,A,t,G);bDa(K,I,e);e=K;K=f[e>>2]|0;I=f[e+4>>2]|0;e=900096;G=f[e>>2]|0;t=f[e+4>>2]|0;e=(I|0)<0;A=I1a(K|0,I|0,63)|0;C=I1a(G|0,t|0,63)|0;if((A|0)==(C|0))_Ca(L,K,I,G,t,e);else $Ca(L,K,I,G,t,e);bDa(E,L,q);q=D;D=f[q>>2]|0;L=f[q+4>>2]|0;q=E;E=f[q>>2]|0;e=f[q+4>>2]|0;q=(L|0)<0;t=I1a(D|0,L|0,63)|0;G=I1a(E|0,e|0,63)|0;if((t|0)==(G|0))_Ca(a,D,L,E,e,q);else $Ca(a,D,L,E,e,q);u=d;return}q=a;f[q>>2]=-1;f[q+4>>2]=2147483647;u=d;return}function iDa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=u;u=u+64|0;g=e+56|0;h=e+48|0;i=e+40|0;j=e+32|0;k=e+8|0;l=e;m=e+24|0;n=e+16|0;o=c;c=f[o+4>>2]|0;p=m;f[p>>2]=f[o>>2];f[p+4>>2]=c;c=d;d=f[c+4>>2]|0;p=n;f[p>>2]=f[c>>2];f[p+4>>2]=d;if((b[900216]|0)==0?u1a(900216)|0:0){d=900224;f[d>>2]=0;f[d+4>>2]=0}if((b[900232]|0)==0?u1a(900232)|0:0){d=900240;f[d>>2]=0;f[d+4>>2]=1072693248}if((b[900248]|0)==0?u1a(900248)|0:0){d=900256;f[d>>2]=0;f[d+4>>2]=2146435072}if((b[900264]|0)==0?u1a(900264)|0:0){d=900272;f[d>>2]=-1;f[d+4>>2]=2147483647}d=m;m=f[d>>2]|0;p=f[d+4>>2]|0;d=p&2147483647;c=(m|0)==0&(d|0)==2146435072;o=n;q=f[o>>2]|0;r=f[o+4>>2]|0;o=r&2147483647;s=(q|0)==0&(o|0)==2146435072;t=d>>>0>2146435072|(d|0)==2146435072&m>>>0>0;v=o>>>0>2146435072|(o|0)==2146435072&q>>>0>0;w=900224;x=f[w>>2]|0;y=f[w+4>>2]|0;w=y&2146435072;z=y&1048575;A=0!=0|(w|0)!=2146435072|(x|0)==0&(z|0)==0;do if(A?0!=0|(r&2146435072|0)!=2146435072|(q|0)==0&(r&1048575|0)==0:0){B=I1a(x|0,y|0,63)|0;C=I1a(q|0,r|0,63)|0;if((B|0)==(C|0)){D=((x|0)!=(q|0)|(y|0)!=(r|0))&(B|0)!=((y>>>0<r>>>0|(y|0)==(r|0)&x>>>0<q>>>0)&1|0);break}else{D=(y|0)<0&((x|q|0)!=0|((y|r)&2147483647|0)!=0);break}}else D=0;while(0);B=900240;C=f[B>>2]|0;E=f[B+4>>2]|0;B=E&2146435072;F=0!=0|(B|0)!=2146435072;G=E&1048575;H=(C|0)==0&(G|0)==0;do if(F|H?0!=0|(p&2146435072|0)!=2146435072|(m|0)==0&(p&1048575|0)==0:0)if((E|0)>-1|(E|0)==-1&C>>>0>4294967295){I=E>>>0<d>>>0|(E|0)==(d|0)&C>>>0<m>>>0;break}else{I=(C|m|0)!=0|((E|p)&2147483647|0)!=0;break}else I=0;while(0);K=D^I;I=a;f[I>>2]=0;f[I+4>>2]=0;if(v){if((a|0)==900272){u=e;return}v=900272;I=f[v+4>>2]|0;D=a;f[D>>2]=f[v>>2];f[D+4>>2]=I;u=e;return}if(s){if(((m|0)!=0|(p&1048575|0)!=0)&(0==0&(p&2146435072|0)==2146435072)|(F|H)^1){L=t;M=K?900224:900256}else{L=(m|0)==(C|0)&(d|0)==(E|0)|(C|m|0)==0&((E|p)&2147483647|0)==0;M=t?900272:K?900224:900256}K=L?900272:M;if((K|0)==(a|0)){u=e;return}M=K;K=f[M+4>>2]|0;L=a;f[L>>2]=f[M>>2];f[L+4>>2]=K;u=e;return}K=0!=0|(r&2146435072|0)!=2146435072;L=r&1048575;M=(q|0)==0&(L|0)==0;d=K|M;do if(d){if(((x|0)!=0|(z|0)!=0)&(0==0&(w|0)==2146435072)|((q|0)!=(x|0)|(r|0)!=(y|0))&((x|q|0)!=0|((y|r)&2147483647|0)!=0)){if(((C|0)!=0|(G|0)!=0)&(0==0&(B|0)==2146435072)|((q|0)!=(C|0)|(r|0)!=(E|0))&((C|q|0)!=0|((E|r)&2147483647|0)!=0))break;H=a;f[H>>2]=m;f[H+4>>2]=p;u=e;return}if((a|0)==900240){u=e;return}H=a;f[H>>2]=C;f[H+4>>2]=E;u=e;return}while(0);if(t){if((a|0)==900272){u=e;return}t=900272;E=f[t+4>>2]|0;C=a;f[C>>2]=f[t>>2];f[C+4>>2]=E;u=e;return}if(c){do if(d&A){c=I1a(q|0,r|0,63)|0;E=I1a(x|0,y|0,63)|0;if((c|0)==(E|0)){if(!(((q|0)!=(x|0)|(r|0)!=(y|0))&(E|0)!=((r>>>0<y>>>0|(r|0)==(y|0)&q>>>0<x>>>0)&1|0))){N=900256;break}}else if(!((r|0)<0&((x|q|0)!=0|((y|r)&2147483647|0)!=0))){N=900256;break}N=900224}else N=900256;while(0);if((N|0)==(a|0)){u=e;return}E=N;N=f[E+4>>2]|0;c=a;f[c>>2]=f[E>>2];f[c+4>>2]=N;u=e;return}N=I1a(q|0,r|0,52)|0;c=N&2047;do if(c>>>0>=1023){if(c>>>0<=1074){N=R1a(1,0,1075-c|0)|0;E=J;C=C1a(N|0,E|0,-1,-1)|0;t=J;B=I1a(N|0,E|0,1)|0;G=C1a(B|0,J|0,q|0,r|0)|0;B=J;H=(G&C|0)==0&(B&t|0)==0;t=B1a(0,0,N|0,E|0)|0;O=B&J&(H?~E:-1);P=G&t&(H?~N:-1);break}if(M|(c|0)!=2047){O=r;P=q}else{N=0==0&(r&2146959360|0)==2146435072&((q|0)!=0|(r&524287|0)!=0);O=(N?r:K?0:r)|524288;P=N?q:K?0:q}}else{N=(q|0)==0&(o|0)==0;H=r&-2147483648;t=((q|0)!=0|(L|0)!=0)&(c|0)==1022;O=N?r:t?H|1072693248:H;P=N?q:t?0:0}while(0);if(d?!(((P|0)!=0|(O&1048575|0)!=0)&(0==0&(O&2146435072|0)==2146435072)|((q|0)!=(P|0)|(r|0)!=(O|0))&((P|q|0)!=0|((O|r)&2147483647|0)!=0)):0){O=(r|0)<0&(M|(c|0)!=2047);M=(c|0)==0;P=M?q:q;o=M?L:L|1048576;L=1063-c|0;do if((L|0)>0)if(L>>>0<63){c=I1a(P|0,o|0,L|0)|0;M=J;K=R1a(P|0,o|0,0-L&63|0)|0;Q=((K|0)!=0|(J|0)!=0)&1|c;R=M;break}else{Q=((P|0)!=0|(o|0)!=0)&1;R=0;break}else{Q=P;R=o}while(0);o=C1a(Q|0,R|0,2048,0)|0;R=J;if(!(R>>>0>4095|(R|0)==4095&o>>>0>4294967295)){P=I1a(o|0,R|0,12)|0;R=(Q&4095|0)==2048&0==0&1;Q=O?(R|~P)+1|0:P&~R;if(Q)if((Q>>>31|0)==(O&1|0))S=Q;else T=64;else S=0}else T=64;if((T|0)==64)S=O?-2147483648:2147483647;a:do if(0!=0|(p&2146435072|0)!=2146435072|(m|0)==0&(p&1048575|0)==0?(m|0)==0:0){if((p|0)<0)switch(p|0){case -2147483648:break;default:{T=69;break a}}else switch(p|0){case 0:break;default:{T=69;break a}}O=(S|0)<0;Q=(S|0)==0;U=O?0:Q?0:0;V=O?2146435072:Q?1072693248:0}else T=69;while(0);if((T|0)==69){T=h;f[T>>2]=0;f[T+4>>2]=1072693248;T=i;f[T>>2]=m;f[T+4>>2]=p;T=(S|0)>-1?S:0-S|0;if((S|0)<0){S=j;f[S>>2]=0;f[S+4>>2]=1072693248;cDa(g,j,i);j=g;S=f[j+4>>2]|0;Q=i;f[Q>>2]=f[j>>2];f[Q+4>>2]=S}if((T|0)>1){S=T;while(1){if(S&1|0){bDa(g,h,i);T=g;Q=f[T+4>>2]|0;j=h;f[j>>2]=f[T>>2];f[j+4>>2]=Q}bDa(g,i,i);Q=g;j=f[Q+4>>2]|0;T=i;f[T>>2]=f[Q>>2];f[T+4>>2]=j;if(S>>>0>3)S=S>>>1;else break}}bDa(g,h,i);i=g;U=f[i>>2]|0;V=f[i+4>>2]|0}i=a;f[i>>2]=U;f[i+4>>2]=V;u=e;return}if(0!=0|(p&2146435072|0)!=2146435072|(m|0)==0&(p&1048575|0)==0){do if(A){V=I1a(m|0,p|0,63)|0;i=I1a(x|0,y|0,63)|0;if((V|0)==(i|0)){if(!(((m|0)!=(x|0)|(p|0)!=(y|0))&(i|0)!=((p>>>0<y>>>0|(p|0)==(y|0)&m>>>0<x>>>0)&1|0)))break}else if(!((p|0)<0&((x|m|0)!=0|((y|p)&2147483647|0)!=0)))break;if((a|0)==900272){u=e;return}i=900272;V=f[i+4>>2]|0;U=a;f[U>>2]=f[i>>2];f[U+4>>2]=V;u=e;return}while(0);if(!(((x|0)!=0|(z|0)!=0)&(0==0&(w|0)==2146435072)|((m|0)!=(x|0)|(p|0)!=(y|0))&((x|m|0)!=0|((y|p)&2147483647|0)!=0))){do if(d&A){w=I1a(q|0,r|0,63)|0;z=I1a(x|0,y|0,63)|0;if((w|0)!=(z|0)){w=x|q;V=(y|r)&2147483647;if((r|0)<0&((w|0)!=0|(V|0)!=0)){W=900256;break}else{X=w;Y=V}}else{if(((q|0)!=(x|0)|(r|0)!=(y|0))&(z|0)!=((r>>>0<y>>>0|(r|0)==(y|0)&q>>>0<x>>>0)&1|0)){W=900256;break}X=x|q;Y=(y|r)&2147483647}W=(q|0)==(x|0)&(r|0)==(y|0)|(X|0)==0&(Y|0)==0?900240:900224}else W=900224;while(0);if((W|0)==(a|0)){u=e;return}Y=W;W=f[Y+4>>2]|0;X=a;f[X>>2]=f[Y>>2];f[X+4>>2]=W;u=e;return}}W=l;f[W>>2]=m;f[W+4>>2]=p;hDa(h,l);bDa(k,n,h);gDa(g,k);if((g|0)!=(a|0)){k=g;g=f[k+4>>2]|0;h=a;f[h>>2]=f[k>>2];f[h+4>>2]=g}u=e;return}function jDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;c=u;u=u+160|0;d=c+152|0;e=c+144|0;g=c+136|0;h=c+128|0;i=c+120|0;j=c+112|0;k=c+104|0;l=c+96|0;m=c+88|0;n=c+80|0;o=c+72|0;p=c+64|0;q=c+56|0;r=c+48|0;s=c+40|0;t=c+32|0;v=c+24|0;w=c+16|0;x=c+8|0;y=c;z=f[b>>2]|0;b=z&2147483647;if(b>>>0>2139095040){f[a>>2]=2147483647;u=c;return}if((b|0)==2139095040){f[a>>2]=z;u=c;return}A=(z>>>23&255)+-127|0;B=(A|0)%3|0;C=B+-3-(B>>31&-3)|0;B=R1a(C+1023|0,0,52)|0;D=J;E=R1a(z&8388607|0,0,29)|0;F=d;f[F>>2]=B|E;f[F+4>>2]=D|J;D=e;f[D>>2]=1716763248;f[D+4>>2]=1078370462;D=g;f[D>>2]=1712249633;f[D+4>>2]=1076731424;bDa(i,e,d);e=i;i=f[e>>2]|0;D=f[e+4>>2]|0;e=(D|0)<0;if((D|0)>-1|(D|0)==-1&i>>>0>4294967295)_Ca(j,i,D,1818302176,1080559860,e);else $Ca(j,i,D,1818302176,1080559860,e);bDa(k,j,d);j=k;k=f[j>>2]|0;e=f[j+4>>2]|0;j=(e|0)<0;if((e|0)>-1|(e|0)==-1&k>>>0>4294967295)_Ca(l,k,e,1134341652,1079888535,j);else $Ca(l,k,e,1134341652,1079888535,j);bDa(m,l,d);l=m;m=f[l>>2]|0;j=f[l+4>>2]|0;l=(j|0)<0;if((j|0)>-1|(j|0)==-1&m>>>0>4294967295)_Ca(n,m,j,-763202304,1076551024,l);else $Ca(n,m,j,-763202304,1076551024,l);bDa(o,n,d);n=o;o=f[n>>2]|0;l=f[n+4>>2]|0;n=(l|0)<0;if((l|0)>-1|(l|0)==-1&o>>>0>4294967295)_Ca(p,o,l,-2081071827,1069871455,n);else $Ca(p,o,l,-2081071827,1069871455,n);bDa(r,g,d);g=r;r=f[g>>2]|0;n=f[g+4>>2]|0;g=(n|0)<0;if((n|0)>-1|(n|0)==-1&r>>>0>4294967295)_Ca(s,r,n,-1071097835,1080229653,g);else $Ca(s,r,n,-1071097835,1080229653,g);bDa(t,s,d);s=t;t=f[s>>2]|0;g=f[s+4>>2]|0;s=(g|0)<0;if((g|0)>-1|(g|0)==-1&t>>>0>4294967295)_Ca(v,t,g,1786843854,1080365264,s);else $Ca(v,t,g,1786843854,1080365264,s);bDa(w,v,d);v=w;w=f[v>>2]|0;s=f[v+4>>2]|0;v=(s|0)<0;if((s|0)>-1|(s|0)==-1&w>>>0>4294967295)_Ca(x,w,s,-907885707,1078001355,v);else $Ca(x,w,s,-907885707,1078001355,v);bDa(y,x,d);x=y;y=f[x>>2]|0;v=f[x+4>>2]|0;x=(v|0)<0;if((v|0)>-1|(v|0)==-1&y>>>0>4294967295)_Ca(q,y,v,0,1072693248,x);else $Ca(q,y,v,0,1072693248,x);cDa(h,p,q);q=h;h=f[q>>2]|0;p=f[q+4>>2]|0;q=d;f[q>>2]=h;f[q+4>>2]=p;if(!b)G=0;else{b=I1a(h|0,p|0,29)|0;G=b&8388607|(((A-C|0)/3|0)<<23)+(z&-2147483648|1056964608)}f[a>>2]=G;u=c;return}function kDa(a){a=a|0;var b=0;do if(a)if((f[a+12>>2]|0)==7247){b=uDa(a)|0;break}else{b=zDa(a)|0;break}else b=-2;while(0);return b|0}function lDa(a,b){a=a|0;b=b|0;return mDa(a,-1,b)|0}function mDa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+16|0;g=e+8|0;h=e;if(!a){i=0;u=e;return i|0}j=dKa(140)|0;if(!j){i=0;u=e;return i|0}f[j+24>>2]=0;f[j+28>>2]=8192;k=j+80|0;f[k>>2]=0;l=j+12|0;f[l>>2]=0;m=j+60|0;f[m>>2]=-1;n=j+64|0;f[n>>2]=0;o=j+40|0;f[o>>2]=0;p=b[d>>0]|0;a:do if(p<<24>>24){q=p;r=0;s=0;t=0;v=0;w=d;b:while(1){x=q<<24>>24;c:do if((q+-48&255)<10){f[m>>2]=x+-48;y=s;z=r;A=t;B=v}else do switch(x|0){case 43:{C=10;break b;break}case 114:{f[l>>2]=7247;y=7247;z=r;A=t;B=v;break c;break}case 119:{f[l>>2]=31153;y=31153;z=r;A=t;B=v;break c;break}case 97:{f[l>>2]=1;y=1;z=r;A=t;B=v;break c;break}case 84:{f[o>>2]=1;y=s;z=1;A=t;B=v;break c;break}case 101:{y=s;z=r;A=1;B=v;break c;break}case 120:{y=s;z=r;A=t;B=1;break c;break}case 102:{f[n>>2]=1;y=s;z=r;A=t;B=v;break c;break}case 104:{f[n>>2]=2;y=s;z=r;A=t;B=v;break c;break}case 82:{f[n>>2]=3;y=s;z=r;A=t;B=v;break c;break}case 70:{f[n>>2]=4;y=s;z=r;A=t;B=v;break c;break}default:{y=s;z=r;A=t;B=v;break c}}while(0);while(0);w=w+1|0;q=b[w>>0]|0;if(!(q<<24>>24))break;else{r=z;s=y;t=A;v=B}}if((C|0)==10){eKa(j);i=0;u=e;return i|0}d:do if((y|0)<7247)switch(y|0){case 0:{break a;break}default:{}}else{switch(y|0){case 7247:break;default:break d}if(!z){f[o>>2]=1;break}eKa(j);i=0;u=e;return i|0}while(0);v=(xKa(a)|0)+1|0;t=dKa(v)|0;s=j+20|0;f[s>>2]=t;if(!t){eKa(j);i=0;u=e;return i|0}f[h>>2]=a;pLa(t,v,358770,h)|0;v=f[l>>2]|0;do if((c|0)>-1){f[j+16>>2]=c;D=v;E=c}else{f[g>>2]=438;t=AKa(a,((v|0)==7247?0:((v|0)==31153?512:1024)|(B|0?193:65))|(A|0?557056:32768),g)|0;f[j+16>>2]=t;if((t|0)!=-1){D=f[l>>2]|0;E=t;break}eKa(f[s>>2]|0);eKa(j);i=0;u=e;return i|0}while(0);e:do if((D|0)>=7247){switch(D|0){case 7247:break;default:{F=j;C=35;break e}}s=fLa(E,0,1)|0;f[j+48>>2]=(s|0)==-1?0:s;s=f[l>>2]|0;f[j>>2]=0;if((s|0)==7247){f[j+52>>2]=0;f[j+56>>2]=0;F=j+44|0;C=35}}else{switch(D|0){case 1:break;default:{F=j;C=35;break e}}f[l>>2]=31153;F=j;C=35}while(0);if((C|0)==35)f[F>>2]=0;f[j+72>>2]=0;s=f[k>>2]|0;v=j+76|0;if(s|0){if((f[v>>2]|0)!=-4)eKa(s);f[k>>2]=0}f[v>>2]=0;f[j+8>>2]=0;f[j+88>>2]=0;i=j;u=e;return i|0}while(0);eKa(j);i=0;u=e;return i|0}function nDa(a){a=a|0;var b=0,c=0,d=0,e=0;if(!a){b=-1;return b|0}c=a+12|0;if((f[c>>2]|0)!=7247){b=-1;return b|0}d=a+76|0;switch(f[d>>2]|0){case -5:case 0:break;default:{b=-1;return b|0}}if((fLa(f[a+16>>2]|0,f[a+48>>2]|0,0)|0)==-1){b=-1;return b|0}f[a>>2]=0;if((f[c>>2]|0)==7247){f[a+52>>2]=0;f[a+56>>2]=0;f[a+44>>2]=0}f[a+72>>2]=0;c=a+80|0;e=f[c>>2]|0;if(e|0){if((f[d>>2]|0)!=-4)eKa(e);f[c>>2]=0}f[d>>2]=0;f[a+8>>2]=0;f[a+88>>2]=0;b=0;return b|0}function oDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=a+80|0;h=f[g>>2]|0;if(h|0){if((f[a+76>>2]|0)!=-4)eKa(h);f[g>>2]=0}switch(b|0){case 0:case -5:break;default:f[a>>2]=0}h=a+76|0;f[h>>2]=b;if((b|0)==-4|(c|0)==0){u=d;return}b=f[a+20>>2]|0;a=xKa(b)|0;i=dKa(a+3+(xKa(c)|0)|0)|0;f[g>>2]=i;if(!i){f[h>>2]=-4;u=d;return}else{h=xKa(b)|0;g=h+3+(xKa(c)|0)|0;f[e>>2]=b;f[e+4>>2]=358780;f[e+8>>2]=c;pLa(i,g,358773,e)|0;u=d;return}}function pDa(a){a=a|0;var b=0;if((a|0)!=0?(f[a+12>>2]|0)==7247:0)b=f[a+56>>2]|0;else b=0;return b|0}function qDa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=a+44|0;c=a+52|0;d=a+88|0;e=a+24|0;g=a+100|0;h=a+36|0;i=a+96|0;a:while(1){switch(f[b>>2]|0){case 1:{j=5;break a;break}case 0:{if((sDa(a)|0)==-1){k=-1;j=16;break a}if(!(f[b>>2]|0)){k=0;j=16;break a}break}case 2:{f[g>>2]=f[e>>2]<<1;f[i>>2]=f[h>>2];if((rDa(a)|0)==-1){k=-1;j=16;break a}break}default:{}}if(f[a>>2]|0){k=0;j=16;break}if(!(f[c>>2]|0))continue;if(!(f[d>>2]|0)){k=0;j=16;break}}if((j|0)==5){d=f[h>>2]|0;i=f[e>>2]<<1;f[a>>2]=0;e=a+16|0;g=0;do{l=WLa(f[e>>2]|0,d+g|0,i-g|0)|0;if((l|0)<1){j=8;break}g=(f[a>>2]|0)+l|0;f[a>>2]=g}while(g>>>0<i>>>0);do if((j|0)==8){if((l|0)>=0){f[c>>2]=1;break}i=pKa()|0;oDa(a,-1,DKa(f[i>>2]|0)|0);k=-1;return k|0}while(0);f[a+4>>2]=f[h>>2];k=0;return k|0}else if((j|0)==16)return k|0;return 0}function rDa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=a+84|0;c=a+100|0;d=f[c>>2]|0;e=a+88|0;g=a+76|0;h=a+52|0;i=a+32|0;j=a+24|0;k=a+16|0;l=0;a:while(1){if(!(f[e>>2]|0)){switch(f[g>>2]|0){case -5:case 0:break;default:{m=-1;n=20;break a}}if(f[h>>2]|0){n=12;break}o=f[i>>2]|0;p=f[j>>2]|0;q=0;while(1){r=WLa(f[k>>2]|0,o+q|0,p-q|0)|0;if((r|0)<1){n=8;break}s=r+q|0;if(s>>>0<p>>>0)q=s;else{t=s;break}}if((n|0)==8){n=0;if((r|0)<0){n=10;break}f[h>>2]=1;t=q}p=(f[e>>2]|0)+t|0;f[e>>2]=p;f[b>>2]=f[i>>2];if(!p){n=12;break}}p=DDa(b,0)|0;switch(p|0){case 2:case -2:{n=14;break a;break}case -4:{n=15;break a;break}case -3:{n=16;break a;break}default:{}}o=f[c>>2]|0;if((p|0)!=1&(o|0)!=0)l=p;else{u=o;v=p;break}}if((n|0)==10){b=pKa()|0;oDa(a,-1,DKa(f[b>>2]|0)|0);m=-1;return m|0}else if((n|0)==12){oDa(a,-5,358783);u=f[c>>2]|0;v=l}else if((n|0)==14){oDa(a,-2,358806);m=-1;return m|0}else if((n|0)==15){oDa(a,-4,358943);m=-1;return m|0}else if((n|0)==16){l=f[a+108>>2]|0;oDa(a,-3,(l|0)==0?358845:l);m=-1;return m|0}else if((n|0)==20)return m|0;n=d-u|0;f[a>>2]=n;f[a+4>>2]=(f[a+96>>2]|0)+(0-n);if((v|0)!=1){m=0;return m|0}f[a+44>>2]=0;m=0;return m|0}function sDa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+84|0;d=a+24|0;do if(!(f[d>>2]|0)){e=f[a+28>>2]|0;g=dKa(e)|0;h=a+32|0;f[h>>2]=g;i=dKa(e<<1)|0;j=a+36|0;f[j>>2]=i;k=(i|0)==0;if(!((g|0)==0|k)){f[d>>2]=e;f[a+116>>2]=0;f[a+120>>2]=0;f[a+124>>2]=0;e=a+88|0;f[e>>2]=0;f[c>>2]=0;if(!(CDa(c,31,358957,56)|0)){l=e;break}eKa(f[j>>2]|0);eKa(f[h>>2]|0);f[d>>2]=0;oDa(a,-4,358943);m=-1;return m|0}if(k)n=g;else{eKa(i);n=f[h>>2]|0}if(n|0)eKa(n);oDa(a,-4,358943);m=-1;return m|0}else l=a+88|0;while(0);n=f[l>>2]|0;a:do if(n>>>0<2){switch(f[a+76>>2]|0){case -5:case 0:break;default:{m=-1;return m|0}}h=a+52|0;if(!(f[h>>2]|0)){i=a+32|0;if(!n)o=0;else{b[f[i>>2]>>0]=b[f[c>>2]>>0]|0;o=f[l>>2]|0}g=(f[i>>2]|0)+o|0;k=(f[d>>2]|0)-o|0;j=a+16|0;e=0;while(1){p=WLa(f[j>>2]|0,g+e|0,k-e|0)|0;if((p|0)<1){q=19;break}r=p+e|0;if(r>>>0<k>>>0)e=r;else{s=r;break}}do if((q|0)==19){if((p|0)>=0){f[h>>2]=1;s=e;break}k=pKa()|0;oDa(a,-1,DKa(f[k>>2]|0)|0);m=-1;return m|0}while(0);e=(f[l>>2]|0)+s|0;f[l>>2]=e;f[c>>2]=f[i>>2];t=e}else t=n;switch(t|0){case 1:{u=1;break a;break}case 0:{m=0;break}default:{v=t;q=24;break a}}return m|0}else{v=n;q=24}while(0);if((q|0)==24){q=f[c>>2]|0;if((b[q>>0]|0)==31?(b[q+1>>0]|0)==-117:0){ADa(c)|0;f[a+44>>2]=2;f[a+40>>2]=0;m=0;return m|0}else u=v}v=a+40|0;if(!(f[v>>2]|0)){f[l>>2]=0;f[a+52>>2]=1;f[a>>2]=0;m=0;return m|0}else{q=f[a+36>>2]|0;f[a+4>>2]=q;K1a(q|0,f[c>>2]|0,u|0)|0;f[a>>2]=f[l>>2];f[l>>2]=0;f[a+44>>2]=1;f[v>>2]=1;m=0;return m|0}return 0}function tDa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if((a|0)==0|(c|0)==0|(d|0)<1){e=0;return e|0}if((f[a+12>>2]|0)!=7247){e=0;return e|0}switch(f[a+76>>2]|0){case -5:case 0:break;default:{e=0;return e|0}}g=a+72|0;a:do if(f[g>>2]|0?(f[g>>2]=0,h=f[a+68>>2]|0,i=a+88|0,j=a+52|0,k=a+4|0,l=a+8|0,h|0):0){m=h;b:while(1){while(1){n=f[a>>2]|0;if(n|0)break;if(f[j>>2]|0?(f[i>>2]|0)==0:0)break a;if((qDa(a)|0)==-1){e=0;break b}}h=(n|0)<0|(n|0)>(m|0)?m:n;f[a>>2]=n-h;f[k>>2]=(f[k>>2]|0)+h;f[l>>2]=(f[l>>2]|0)+h;m=m-h|0;if(!m)break a}return e|0}while(0);n=d+-1|0;if(!n){e=0;return e|0}d=a+4|0;g=a+8|0;m=f[a>>2]|0;l=c;k=n;while(1){if(!m){if((qDa(a)|0)==-1){e=0;o=21;break}n=f[a>>2]|0;if(!n){o=17;break}else p=n}else p=m;n=p>>>0>k>>>0?k:p;i=f[d>>2]|0;j=BKa(i,10,n)|0;h=(j|0)==0;q=h?n:1-i+j|0;K1a(l|0,i|0,q|0)|0;m=(f[a>>2]|0)-q|0;f[a>>2]=m;f[d>>2]=(f[d>>2]|0)+q;f[g>>2]=(f[g>>2]|0)+q;k=k-q|0;i=l+q|0;if(!(h&(k|0)!=0)){r=i;break}else l=i}if((o|0)==17){f[a+56>>2]=1;r=l}else if((o|0)==21)return e|0;if((r|0)==(c|0)){e=0;return e|0}b[r>>0]=0;e=c;return e|0}function uDa(a){a=a|0;var b=0,c=0,d=0;if(!a){b=-2;return b|0}if((f[a+12>>2]|0)!=7247){b=-2;return b|0}if(f[a+24>>2]|0){FDa(a+84|0)|0;eKa(f[a+36>>2]|0);eKa(f[a+32>>2]|0)}c=(f[a+76>>2]|0)==-5?-5:0;oDa(a,0,0);eKa(f[a+20>>2]|0);d=gLa(f[a+16>>2]|0)|0;eKa(a);b=d|0?-1:c;return b|0}function vDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if(!a){d=0;return d|0}e=a+84|0;if((f[a+12>>2]|0)!=31153){d=0;return d|0}if(f[a+76>>2]|0){d=0;return d|0}if((c|0)<0){oDa(a,-3,358867);d=0;return d|0}if(!c){d=0;return d|0}g=a+24|0;if((f[g>>2]|0)==0?(wDa(a)|0)==-1:0){d=0;return d|0}h=a+72|0;a:do if(f[h>>2]|0){f[h>>2]=0;i=f[a+68>>2]|0;j=a+88|0;if(f[j>>2]|0?(xDa(a,0)|0)==-1:0){d=0;return d|0}if(!i)k=j;else{l=a+32|0;m=a+84|0;n=a+8|0;o=0;p=i;while(1){i=f[g>>2]|0;q=(i|0)<0|(i|0)>(p|0)?p:i;if(!o)F1a(f[l>>2]|0,0,q|0)|0;f[j>>2]=q;f[m>>2]=f[l>>2];f[n>>2]=(f[n>>2]|0)+q;p=p-q|0;if((xDa(a,0)|0)==-1){d=0;break}if(!p){k=j;break a}else o=1}return d|0}}else k=a+88|0;while(0);b:do if((f[g>>2]|0)>>>0<=c>>>0){if(f[k>>2]|0?(xDa(a,0)|0)==-1:0){d=0;return d|0}f[k>>2]=c;f[e>>2]=b;h=a+8|0;f[h>>2]=(f[h>>2]|0)+c;if((xDa(a,0)|0)==-1){d=0;return d|0}}else{h=a+32|0;o=a+8|0;j=b;p=c;while(1){n=f[k>>2]|0;l=f[h>>2]|0;if(!n){f[e>>2]=l;r=l}else r=f[e>>2]|0;m=r+n|0;n=l-m+(f[g>>2]|0)|0;l=n>>>0>p>>>0?p:n;K1a(m|0,j|0,l|0)|0;f[k>>2]=l+(f[k>>2]|0);f[o>>2]=l+(f[o>>2]|0);p=p-l|0;if(!p)break b;if((xDa(a,0)|0)==-1){d=0;break}else j=j+l|0}return d|0}while(0);d=c;return d|0}function wDa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=a+28|0;c=f[b>>2]|0;d=dKa(c)|0;e=a+32|0;f[e>>2]=d;if(!d){oDa(a,-4,358943);g=-1;return g|0}h=a+40|0;if(f[h>>2]|0){f[a+24>>2]=c;g=0;return g|0}i=dKa(c)|0;c=a+36|0;f[c>>2]=i;if(!i){eKa(d);oDa(a,-4,358943);g=-1;return g|0}f[a+116>>2]=0;f[a+120>>2]=0;f[a+124>>2]=0;if(MDa(a+84|0,f[a+60>>2]|0,8,31,8,f[a+64>>2]|0,358957,56)|0){eKa(f[c>>2]|0);eKa(f[e>>2]|0);oDa(a,-4,358943);g=-1;return g|0}e=f[b>>2]|0;b=f[h>>2]|0;f[a+24>>2]=e;if(b|0){g=0;return g|0}f[a+100>>2]=e;e=f[a+36>>2]|0;f[a+96>>2]=e;f[a+4>>2]=e;g=0;return g|0}function xDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=a+84|0;d=a+24|0;if((f[d>>2]|0)==0?(wDa(a)|0)==-1:0){e=-1;return e|0}if(f[a+40>>2]|0){g=a+88|0;h=VLa(f[a+16>>2]|0,f[c>>2]|0,f[g>>2]|0)|0;if((h|0)>=0?(h|0)==(f[g>>2]|0):0){f[g>>2]=0;e=0;return e|0}g=pKa()|0;oDa(a,-1,DKa(f[g>>2]|0)|0);e=-1;return e|0}g=a+100|0;h=a+96|0;i=a+4|0;j=a+36|0;k=a+16|0;a:do switch(b|0){case 0:{l=f[g>>2]|0;while(1){if(!l){m=f[i>>2]|0;n=(f[h>>2]|0)-m|0;if(n){o=VLa(f[k>>2]|0,m,n)|0;if(!((o|0)>-1&(o|0)==(n|0))){p=31;break a}n=f[g>>2]|0;if(n){q=n;r=f[h>>2]|0}else p=12}else p=12;if((p|0)==12){p=0;n=f[d>>2]|0;f[g>>2]=n;o=f[j>>2]|0;f[h>>2]=o;q=n;r=o}f[i>>2]=r;s=q}else s=l;if((UDa(c,0)|0)==-2){p=37;break a}l=f[g>>2]|0;if((s|0)==(l|0)){p=39;break}}break}case 4:{l=f[g>>2]|0;o=0;while(1){if((l|0)==0|(o|0)==1){n=f[i>>2]|0;m=(f[h>>2]|0)-n|0;if(!m)t=l;else{u=VLa(f[k>>2]|0,n,m)|0;if(!((u|0)>-1&(u|0)==(m|0))){p=31;break a}t=f[g>>2]|0}if(!t){m=f[d>>2]|0;f[g>>2]=m;u=f[j>>2]|0;f[h>>2]=u;v=u;w=m}else{v=f[h>>2]|0;w=t}f[i>>2]=v;x=w}else x=l;o=UDa(c,4)|0;if((o|0)==-2){p=37;break a}l=f[g>>2]|0;if((x|0)==(l|0)){p=39;break}}break}default:while(1){l=f[i>>2]|0;o=(f[h>>2]|0)-l|0;if(o|0?(m=VLa(f[k>>2]|0,l,o)|0,!((m|0)>-1&(m|0)==(o|0))):0){p=31;break a}o=f[g>>2]|0;if(!o){m=f[d>>2]|0;f[g>>2]=m;l=f[j>>2]|0;f[h>>2]=l;y=l;z=m}else{y=f[h>>2]|0;z=o}f[i>>2]=y;if((UDa(c,b)|0)==-2){p=37;break a}if((z|0)==(f[g>>2]|0)){p=39;break}}}while(0);if((p|0)==31){g=pKa()|0;oDa(a,-1,DKa(f[g>>2]|0)|0);e=-1;return e|0}else if((p|0)==37){oDa(a,-2,358904);e=-1;return e|0}else if((p|0)==39){if((b|0)!=4){e=0;return e|0}NDa(c)|0;e=0;return e|0}return 0}function yDa(a,b){a=a|0;b=b|0;var c=0,d=0;c=xKa(b)|0;d=vDa(a,b,c)|0;return ((c|0)!=0&(d|0)==0?-1:d)|0}function zDa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!a){b=-2;return b|0}if((f[a+12>>2]|0)!=31153){b=-2;return b|0}c=a+72|0;a:do if(!(f[c>>2]|0))d=0;else{f[c>>2]=0;e=f[a+68>>2]|0;g=a+88|0;if(!((f[g>>2]|0)!=0?(xDa(a,0)|0)==-1:0))h=6;b:do if((h|0)==6){if(!e){d=0;break a}i=a+24|0;j=a+32|0;k=a+84|0;l=a+8|0;m=0;n=e;while(1){o=f[i>>2]|0;p=(o|0)<0|(o|0)>(n|0)?n:o;if(!m)F1a(f[j>>2]|0,0,p|0)|0;f[g>>2]=p;f[k>>2]=f[j>>2];f[l>>2]=(f[l>>2]|0)+p;n=n-p|0;if((xDa(a,0)|0)==-1)break b;if(!n){d=0;break a}else m=1}}while(0);d=f[a+76>>2]|0}while(0);if((xDa(a,4)|0)==-1)q=f[a+76>>2]|0;else q=d;if(f[a+24>>2]|0){if(!(f[a+40>>2]|0)){TDa(a+84|0)|0;eKa(f[a+36>>2]|0)}eKa(f[a+32>>2]|0)}oDa(a,0,0);eKa(f[a+20>>2]|0);d=(gLa(f[a+16>>2]|0)|0)==-1;eKa(a);b=d?-1:q;return b|0}function ADa(a){a=a|0;var b=0,c=0,d=0;if(!a){b=-2;return b|0}c=f[a+28>>2]|0;if(!c){b=-2;return b|0}f[c+40>>2]=0;f[c+44>>2]=0;f[c+48>>2]=0;f[c+28>>2]=0;f[a+20>>2]=0;f[a+8>>2]=0;f[a+24>>2]=0;d=f[c+8>>2]|0;if(d|0)f[a+48>>2]=d&1;f[c>>2]=0;f[c+4>>2]=0;f[c+12>>2]=0;f[c+20>>2]=32768;f[c+32>>2]=0;f[c+56>>2]=0;f[c+60>>2]=0;d=c+1328|0;f[c+108>>2]=d;f[c+80>>2]=d;f[c+76>>2]=d;f[c+7104>>2]=1;f[c+7108>>2]=-1;b=0;return b|0}function BDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;if(!a){c=-2;return c|0}d=a+28|0;e=f[d>>2]|0;if(!e){c=-2;return c|0}if((b|0)<0){g=0-b|0;h=0}else{g=(b|0)<48?b&15:b;h=(b>>>4)+1|0}if(!((g|0)==0|(g&-8|0)==8)){c=-2;return c|0}b=e+52|0;i=f[b>>2]|0;j=e+36|0;if((i|0)!=0?(f[j>>2]|0)!=(g|0):0){Gh[f[a+36>>2]&511](f[a+40>>2]|0,i);f[b>>2]=0;b=f[d>>2]|0;f[e+8>>2]=h;f[j>>2]=g;if(!b){c=-2;return c|0}else k=b}else{f[e+8>>2]=h;f[j>>2]=g;k=e}f[k+40>>2]=0;f[k+44>>2]=0;f[k+48>>2]=0;f[k+28>>2]=0;f[a+20>>2]=0;f[a+8>>2]=0;f[a+24>>2]=0;e=f[k+8>>2]|0;if(e|0)f[a+48>>2]=e&1;f[k>>2]=0;f[k+4>>2]=0;f[k+12>>2]=0;f[k+20>>2]=32768;f[k+32>>2]=0;f[k+56>>2]=0;f[k+60>>2]=0;e=k+1328|0;f[k+108>>2]=e;f[k+80>>2]=e;f[k+76>>2]=e;f[k+7104>>2]=1;f[k+7108>>2]=-1;c=0;return c|0}function CDa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;if(!d){g=-6;return g|0}if((e|0)!=56|(b[d>>0]|0)!=49){g=-6;return g|0}if(!a){g=-2;return g|0}f[a+24>>2]=0;d=a+32|0;e=f[d>>2]|0;if(!e){f[d>>2]=103;f[a+40>>2]=0;h=103}else h=e;e=a+36|0;if(!(f[e>>2]|0))f[e>>2]=387;d=a+40|0;i=ui[h&127](f[d>>2]|0,1,7116)|0;if(!i){g=-4;return g|0}h=a+28|0;f[h>>2]=i;f[i+52>>2]=0;j=BDa(a,c)|0;if(!j){g=0;return g|0}Gh[f[e>>2]&511](f[d>>2]|0,i);f[h>>2]=0;g=j;return g|0}
function x8(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;g=u;u=u+64|0;i=g+16|0;j=g;k=h[e>>0]|0;l=h[e+1>>0]|0;m=h[e+2>>0]|0;n=h[e+3>>0]|0;o=f[a>>2]|0;p=o>>>3;q=f[a+16>>2]|0;r=f[a+48>>2]|0;s=f[a+40>>2]|0;t=f[s+4>>2]|0;v=f[s>>2]|0;s=p&65535;switch(s&511){case 0:case 2:case 3:{if(!(o&7)){o=c;w=C1a(f[o>>2]|0,f[o+4>>2]|0,-131072,-1)|0;o=c;f[o>>2]=w;f[o+4>>2]=J;o=c+8|0;w=o;x=C1a(f[w>>2]|0,f[w+4>>2]|0,-131072,-1)|0;w=o;f[w>>2]=x;f[w+4>>2]=J;w=d;x=C1a(f[w>>2]|0,f[w+4>>2]|0,-131072,-1)|0;w=d;f[w>>2]=x;f[w+4>>2]=J;w=d+8|0;x=w;y=C1a(f[x>>2]|0,f[x+4>>2]|0,-131072,-1)|0;x=w;f[x>>2]=y;f[x+4>>2]=J;x=q+((p&511)+1+r<<1)|0;p=R1a(t|0,((t|0)<0)<<31>>31|0,16)|0;t=C1a(p|0,J|0,-327679,-1)|0;p=J;q=R1a(v|0,((v|0)<0)<<31>>31|0,16)|0;v=C1a(q|0,J|0,-327679,-1)|0;q=j;f[q>>2]=t;f[q+4>>2]=p;p=j+8|0;f[p>>2]=v;f[p+4>>2]=J;if(!(l8(j,c,d)|0)){u=g;return}j=d;p=f[j>>2]|0;v=f[j+4>>2]|0;j=c;q=f[j>>2]|0;t=f[j+4>>2]|0;j=B1a(p|0,v|0,q|0,t|0)|0;y=J;z=w;A=f[z>>2]|0;B=f[z+4>>2]|0;z=o;C=f[z>>2]|0;D=f[z+4>>2]|0;z=B1a(A|0,B|0,C|0,D|0)|0;E=J;F=H1a(j|0,y|0,63)|0;G=J;H=B1a(F^j|0,G^y|0,F|0,G|0)|0;I=J;K=H1a(z|0,E|0,63)|0;L=J;M=B1a(K^z|0,L^E|0,K|0,L|0)|0;N=J;O=(I|0)>(N|0)|(I|0)==(N|0)&H>>>0>M>>>0;if(O){P=B1a(z^F|0,E^G|0,F|0,G|0)|0;E=F&p^q;z=G&v^t;Q=c;f[Q>>2]=E;f[Q+4>>2]=z;Q=d;R=f[Q>>2]^E&F;E=f[Q+4>>2]^z&G;z=d;f[z>>2]=R;f[z+4>>2]=E;z=c;Q=f[z+4>>2]^E&G;E=c;f[E>>2]=f[z>>2]^R&F;f[E+4>>2]=Q;Q=F&A^C;E=G&B^D;R=o;f[R>>2]=Q;f[R+4>>2]=E;R=w;z=f[R>>2]^Q&F;Q=f[R+4>>2]^E&G;E=w;f[E>>2]=z;f[E+4>>2]=Q;E=o;R=f[E>>2]^z&F;F=f[E+4>>2]^Q&G;G=R1a(P|0,J|0,16)|0;P=S1a(G|0,J|0,H|1|0,I|0)|0;I=J;H=d;G=C1a(f[H>>2]|0,f[H+4>>2]|0,65536,0)|0;H=J;Q=d;f[Q>>2]=G;f[Q+4>>2]=H;Q=I1a(G|0,H|0,16)|0;E=J;z=c;S=f[z>>2]|0;T=f[z+4>>2]|0;z=I1a(S|0,T|0,16)|0;U=B1a(Q|0,E|0,z|0,J|0)|0;z=B1a(0,0,P|0,I|0)|0;E=W1a(S&65535|0,0,z|0,J|0)|0;z=H1a(E|0,J|0,16)|0;E=J;Q=C1a(R|0,F|0,32768,0)|0;F=C1a(Q|0,J|0,z|0,E|0)|0;E=J;z=o;f[z>>2]=F;f[z+4>>2]=E;z=I1a(P|0,I|0,11)|0;Q=H1a(S|0,T|0,9)|0;R=J;V=H1a(G|0,H|0,9)|0;W=Q;X=V;Z=S;_=T;$=P;aa=I;ba=F;ca=E;da=65536;ea=0;fa=J;ga=R;ha=U;ia=z&63^((I|0)<0?63:0)}else{I=B1a(K^j|0,L^y|0,K|0,L|0)|0;y=K&p^q;q=L&v^t;t=c;f[t>>2]=y;f[t+4>>2]=q;t=d;v=f[t>>2]^y&K;y=f[t+4>>2]^q&L;q=d;f[q>>2]=v;f[q+4>>2]=y;q=c;t=f[q>>2]^v&K;v=f[q+4>>2]^y&L;y=C^A&K;A=D^B&L;B=o;f[B>>2]=y;f[B+4>>2]=A;B=w;D=f[B>>2]^y&K;y=f[B+4>>2]^A&L;A=w;f[A>>2]=D;f[A+4>>2]=y;A=o;B=f[A+4>>2]^y&L;L=o;f[L>>2]=f[A>>2]^D&K;f[L+4>>2]=B;B=R1a(I|0,J|0,16)|0;I=S1a(B|0,J|0,M|1|0,N|0)|0;N=J;M=w;B=C1a(f[M>>2]|0,f[M+4>>2]|0,65536,0)|0;M=J;L=w;f[L>>2]=B;f[L+4>>2]=M;L=I1a(B|0,M|0,16)|0;w=J;K=o;D=f[K>>2]|0;A=f[K+4>>2]|0;K=I1a(D|0,A|0,16)|0;y=B1a(L|0,w|0,K|0,J|0)|0;K=B1a(0,0,I|0,N|0)|0;w=W1a(D&65535|0,0,K|0,J|0)|0;K=H1a(w|0,J|0,16)|0;w=J;L=C1a(t|0,v|0,32768,0)|0;v=C1a(L|0,J|0,K|0,w|0)|0;w=J;K=c;f[K>>2]=v;f[K+4>>2]=w;K=I1a(I|0,N|0,11)|0;L=I1a(D|0,A|0,9)|0;t=J;C=I1a(B|0,M|0,9)|0;W=L;X=C;Z=v;_=w;$=65536;aa=0;ba=D;ca=A;da=I;ea=N;fa=J;ga=t;ha=y;ia=K&63^((N|0)<0?63:0)}N=W&120;W=X&120;if(!(ia&32))ja=h[223720+ia>>0]|0;else ja=256;ia=ja<<7;X=Y(ja,120-N|4)|0;K=Y(ja,W|4)|0;f[i>>2]=0;f[i+32>>2]=ja;y=B1a(W|0,0,N|0,0)|0;N=J;W=W1a(ja|0,0,y&120|4|0,0)|0;t=I1a(W|0,J|0,8)|0;f[i+12>>2]=t;f[i+4>>2]=t;f[i+8>>2]=X>>>8&511;t=C1a(y|0,N|0,128,0)|0;N=W1a(ja|0,0,t|4|0,J|0)|0;t=I1a(N|0,J|0,8)|0;f[i+16>>2]=t&511;f[i+20>>2]=(X+ia|0)>>>8&511;f[i+24>>2]=K>>>8;f[i+28>>2]=(K+ia|0)>>>8&511;switch(s&511){case 2:{s=(ha|0)>-1;if(O){if(!s){u=g;return}ia=H1a(Z|0,_|0,16)|0;K=W1a(ia|0,J|0,3,0)|0;ia=ba;X=ca;t=ha;N=x+K|0;K=0;while(1){ja=H1a(ia|0,X|0,16)|0;y=C1a(ja|0,J|0,-1,-1)|0;ja=W1a(y|0,J|0,r|0,0)|0;y=N+ja|0;ja=f[i+(((((K|0)>1?2:1)&(K|2))*3|0)+(((t|0)>1?2:1)&(t|2))<<2)>>2]|0;W=I1a(ia|0,X|0,11)|0;ga=W&31;W=(Y(f[51488+((ga|32)<<2)>>2]|0,ja)|0)>>>8&255;fa=h[y>>0]|0;I=(((Y(k-fa|0,W)|0)+127|0)>>>8)+fa|0;fa=y+1|0;A=h[fa>>0]|0;D=(((Y(l-A|0,W)|0)+127|0)>>>8)+A|0;A=y+2|0;w=h[A>>0]|0;v=(((Y(m-w|0,W)|0)+127|0)>>>8)+w|0;w=(((Y(l-(D&255)|0,W)|0)+127|0)>>>8)+D|0;D=(((Y(m-(v&255)|0,W)|0)+127|0)>>>8)+v|0;v=(((Y(k-(I&255)|0,W)|0)+127|0)>>>8)+I&255;b[y>>0]=v;b[fa>>0]=w;b[A>>0]=D;D=y+r|0;y=(Y(f[51488+(ga<<2)>>2]|0,ja)|0)>>>8&255;A=h[D>>0]|0;w=(((Y(k-A|0,y)|0)+127|0)>>>8)+A|0;A=D+1|0;fa=h[A>>0]|0;v=(((Y(l-fa|0,y)|0)+127|0)>>>8)+fa|0;fa=D+2|0;I=h[fa>>0]|0;W=(((Y(m-I|0,y)|0)+127|0)>>>8)+I|0;I=(((Y(l-(v&255)|0,y)|0)+127|0)>>>8)+v|0;v=(((Y(m-(W&255)|0,y)|0)+127|0)>>>8)+W|0;W=(((Y(k-(w&255)|0,y)|0)+127|0)>>>8)+w&255;b[D>>0]=W;b[A>>0]=I;b[fa>>0]=v;v=D+r|0;D=(Y(f[51488+((ga^63)<<2)>>2]|0,ja)|0)>>>8&255;ja=h[v>>0]|0;ga=(((Y(k-ja|0,D)|0)+127|0)>>>8)+ja|0;ja=v+1|0;fa=h[ja>>0]|0;I=(((Y(l-fa|0,D)|0)+127|0)>>>8)+fa|0;fa=v+2|0;A=h[fa>>0]|0;W=(((Y(m-A|0,D)|0)+127|0)>>>8)+A|0;A=(((Y(l-(I&255)|0,D)|0)+127|0)>>>8)+I|0;I=(((Y(m-(W&255)|0,D)|0)+127|0)>>>8)+W|0;W=(((Y(k-(ga&255)|0,D)|0)+127|0)>>>8)+ga&255;b[v>>0]=W;b[ja>>0]=A;b[fa>>0]=I;I=o;ia=C1a(f[I>>2]|0,f[I+4>>2]|0,$|0,aa|0)|0;X=J;I=o;f[I>>2]=ia;f[I+4>>2]=X;if((t|0)<=0)break;else{t=t+-1|0;N=N+3|0;K=K+1|0}}u=g;return}else{if(!s){u=g;return}s=H1a(ba|0,ca|0,16)|0;K=W1a(s|0,J|0,r|0,0)|0;s=Z;N=_;t=ha;X=x+K|0;K=0;while(1){ia=H1a(s|0,N|0,16)|0;I=W1a(ia|0,J|0,3,0)|0;ia=C1a(I|0,J|0,-3,0)|0;I=X+ia|0;ia=f[i+(((((K|0)>1?2:1)&(K|2))*3|0)+(((t|0)>1?2:1)&(t|2))<<2)>>2]|0;fa=I1a(s|0,N|0,11)|0;A=fa&31;fa=(Y(f[51488+((A|32)<<2)>>2]|0,ia)|0)>>>8&255;ja=h[I>>0]|0;W=(((Y(k-ja|0,fa)|0)+127|0)>>>8)+ja|0;ja=I+1|0;v=h[ja>>0]|0;ga=(((Y(l-v|0,fa)|0)+127|0)>>>8)+v|0;v=I+2|0;D=h[v>>0]|0;w=(((Y(m-D|0,fa)|0)+127|0)>>>8)+D|0;D=(((Y(l-(ga&255)|0,fa)|0)+127|0)>>>8)+ga|0;ga=(((Y(m-(w&255)|0,fa)|0)+127|0)>>>8)+w|0;w=(((Y(k-(W&255)|0,fa)|0)+127|0)>>>8)+W&255;b[I>>0]=w;b[ja>>0]=D;b[v>>0]=ga;ga=I+3|0;I=(Y(f[51488+(A<<2)>>2]|0,ia)|0)>>>8&255;v=h[ga>>0]|0;D=(((Y(k-v|0,I)|0)+127|0)>>>8)+v|0;v=ga+1|0;ja=h[v>>0]|0;w=(((Y(l-ja|0,I)|0)+127|0)>>>8)+ja|0;ja=ga+2|0;W=h[ja>>0]|0;fa=(((Y(m-W|0,I)|0)+127|0)>>>8)+W|0;W=(((Y(l-(w&255)|0,I)|0)+127|0)>>>8)+w|0;w=(((Y(m-(fa&255)|0,I)|0)+127|0)>>>8)+fa|0;fa=(((Y(k-(D&255)|0,I)|0)+127|0)>>>8)+D&255;b[ga>>0]=fa;b[v>>0]=W;b[ja>>0]=w;w=ga+3|0;ga=(Y(f[51488+((A^63)<<2)>>2]|0,ia)|0)>>>8&255;ia=h[w>>0]|0;A=(((Y(k-ia|0,ga)|0)+127|0)>>>8)+ia|0;ia=w+1|0;ja=h[ia>>0]|0;W=(((Y(l-ja|0,ga)|0)+127|0)>>>8)+ja|0;ja=w+2|0;v=h[ja>>0]|0;fa=(((Y(m-v|0,ga)|0)+127|0)>>>8)+v|0;v=(((Y(l-(W&255)|0,ga)|0)+127|0)>>>8)+W|0;W=(((Y(m-(fa&255)|0,ga)|0)+127|0)>>>8)+fa|0;fa=(((Y(k-(A&255)|0,ga)|0)+127|0)>>>8)+A&255;b[w>>0]=fa;b[ia>>0]=v;b[ja>>0]=W;W=c;s=C1a(f[W>>2]|0,f[W+4>>2]|0,da|0,ea|0)|0;N=J;W=c;f[W>>2]=s;f[W+4>>2]=N;if((t|0)<=0)break;else{t=t+-1|0;X=X+r|0;K=K+1|0}}u=g;return}break}case 0:{K=(ha|0)>-1;if(O){if(!K){u=g;return}X=I1a(Z|0,_|0,16)|0;t=ba;N=ca;s=ha;W=x+X|0;X=0;while(1){ja=H1a(t|0,N|0,16)|0;v=C1a(ja|0,J|0,-1,-1)|0;ja=W1a(v|0,J|0,r|0,0)|0;v=W+ja|0;ja=f[i+(((((X|0)>1?2:1)&(X|2))*3|0)+(((s|0)>1?2:1)&(s|2))<<2)>>2]|0;ia=I1a(t|0,N|0,11)|0;fa=ia&31;ia=(Y(f[51488+((fa|32)<<2)>>2]|0,ja)|0)>>>8&255;w=h[v>>0]|0;A=(((Y(k-w|0,ia)|0)+127|0)>>>8)+w|0;w=(((Y(k-(A&255)|0,ia)|0)+127|0)>>>8)+A&255;b[v>>0]=w;w=v+r|0;v=(Y(f[51488+(fa<<2)>>2]|0,ja)|0)>>>8&255;A=h[w>>0]|0;ia=(((Y(k-A|0,v)|0)+127|0)>>>8)+A|0;A=(((Y(k-(ia&255)|0,v)|0)+127|0)>>>8)+ia&255;b[w>>0]=A;A=w+r|0;w=(Y(f[51488+((fa^63)<<2)>>2]|0,ja)|0)>>>8&255;ja=h[A>>0]|0;fa=(((Y(k-ja|0,w)|0)+127|0)>>>8)+ja|0;ja=(((Y(k-(fa&255)|0,w)|0)+127|0)>>>8)+fa&255;b[A>>0]=ja;ja=o;t=C1a(f[ja>>2]|0,f[ja+4>>2]|0,$|0,aa|0)|0;N=J;ja=o;f[ja>>2]=t;f[ja+4>>2]=N;if((s|0)<=0)break;else{s=s+-1|0;W=W+1|0;X=X+1|0}}u=g;return}else{if(!K){u=g;return}K=H1a(ba|0,ca|0,16)|0;X=W1a(K|0,J|0,r|0,0)|0;K=Z;W=_;s=ha;N=x+X|0;X=0;while(1){t=I1a(K|0,W|0,16)|0;ja=C1a(t|0,J|0,-1,0)|0;t=N+ja|0;ja=f[i+(((((X|0)>1?2:1)&(X|2))*3|0)+(((s|0)>1?2:1)&(s|2))<<2)>>2]|0;A=I1a(K|0,W|0,11)|0;fa=A&31;A=(Y(f[51488+((fa|32)<<2)>>2]|0,ja)|0)>>>8&255;w=h[t>>0]|0;ia=(((Y(k-w|0,A)|0)+127|0)>>>8)+w|0;w=(((Y(k-(ia&255)|0,A)|0)+127|0)>>>8)+ia&255;b[t>>0]=w;w=t+1|0;t=(Y(f[51488+(fa<<2)>>2]|0,ja)|0)>>>8&255;ia=h[w>>0]|0;A=(((Y(k-ia|0,t)|0)+127|0)>>>8)+ia|0;ia=(((Y(k-(A&255)|0,t)|0)+127|0)>>>8)+A&255;b[w>>0]=ia;ia=w+1|0;w=(Y(f[51488+((fa^63)<<2)>>2]|0,ja)|0)>>>8&255;ja=h[ia>>0]|0;fa=(((Y(k-ja|0,w)|0)+127|0)>>>8)+ja|0;ja=(((Y(k-(fa&255)|0,w)|0)+127|0)>>>8)+fa&255;b[ia>>0]=ja;ja=c;K=C1a(f[ja>>2]|0,f[ja+4>>2]|0,da|0,ea|0)|0;W=J;ja=c;f[ja>>2]=K;f[ja+4>>2]=W;if((s|0)<=0)break;else{s=s+-1|0;N=N+r|0;X=X+1|0}}u=g;return}break}default:{X=(ha|0)>-1;if(O){if(!X){u=g;return}O=H1a(Z|0,_|0,16)|0;N=R1a(O|0,J|0,2)|0;O=ba;s=ca;W=ha;K=x+N|0;N=0;while(1){ja=H1a(O|0,s|0,16)|0;ia=C1a(ja|0,J|0,-1,-1)|0;ja=W1a(ia|0,J|0,r|0,0)|0;ia=K+ja|0;ja=f[i+(((((N|0)>1?2:1)&(N|2))*3|0)+(((W|0)>1?2:1)&(W|2))<<2)>>2]|0;fa=I1a(O|0,s|0,11)|0;w=fa&31;fa=(Y(f[51488+((w|32)<<2)>>2]|0,ja)|0)>>>8&255;A=h[ia>>0]|0;t=(((Y(k-A|0,fa)|0)+127|0)>>>8)+A|0;A=ia+1|0;v=h[A>>0]|0;ga=(((Y(l-v|0,fa)|0)+127|0)>>>8)+v|0;v=ia+2|0;D=h[v>>0]|0;I=(((Y(m-D|0,fa)|0)+127|0)>>>8)+D|0;D=ia+3|0;y=h[D>>0]|0;C=(((Y(n-y|0,fa)|0)+127|0)>>>8)+y|0;y=(((Y(l-(ga&255)|0,fa)|0)+127|0)>>>8)+ga|0;ga=(((Y(m-(I&255)|0,fa)|0)+127|0)>>>8)+I|0;I=(((Y(n-(C&255)|0,fa)|0)+127|0)>>>8)+C|0;C=(((Y(k-(t&255)|0,fa)|0)+127|0)>>>8)+t&255;b[ia>>0]=C;b[A>>0]=y;b[v>>0]=ga;b[D>>0]=I;I=ia+r|0;ia=(Y(f[51488+(w<<2)>>2]|0,ja)|0)>>>8&255;D=h[I>>0]|0;ga=(((Y(k-D|0,ia)|0)+127|0)>>>8)+D|0;D=I+1|0;v=h[D>>0]|0;y=(((Y(l-v|0,ia)|0)+127|0)>>>8)+v|0;v=I+2|0;A=h[v>>0]|0;C=(((Y(m-A|0,ia)|0)+127|0)>>>8)+A|0;A=I+3|0;t=h[A>>0]|0;fa=(((Y(n-t|0,ia)|0)+127|0)>>>8)+t|0;t=(((Y(l-(y&255)|0,ia)|0)+127|0)>>>8)+y|0;y=(((Y(m-(C&255)|0,ia)|0)+127|0)>>>8)+C|0;C=(((Y(n-(fa&255)|0,ia)|0)+127|0)>>>8)+fa|0;fa=(((Y(k-(ga&255)|0,ia)|0)+127|0)>>>8)+ga&255;b[I>>0]=fa;b[D>>0]=t;b[v>>0]=y;b[A>>0]=C;C=I+r|0;I=(Y(f[51488+((w^63)<<2)>>2]|0,ja)|0)>>>8&255;ja=h[C>>0]|0;w=(((Y(k-ja|0,I)|0)+127|0)>>>8)+ja|0;ja=C+1|0;A=h[ja>>0]|0;y=(((Y(l-A|0,I)|0)+127|0)>>>8)+A|0;A=C+2|0;v=h[A>>0]|0;t=(((Y(m-v|0,I)|0)+127|0)>>>8)+v|0;v=C+3|0;D=h[v>>0]|0;fa=(((Y(n-D|0,I)|0)+127|0)>>>8)+D|0;D=(((Y(l-(y&255)|0,I)|0)+127|0)>>>8)+y|0;y=(((Y(m-(t&255)|0,I)|0)+127|0)>>>8)+t|0;t=(((Y(n-(fa&255)|0,I)|0)+127|0)>>>8)+fa|0;fa=(((Y(k-(w&255)|0,I)|0)+127|0)>>>8)+w&255;b[C>>0]=fa;b[ja>>0]=D;b[A>>0]=y;b[v>>0]=t;t=o;O=C1a(f[t>>2]|0,f[t+4>>2]|0,$|0,aa|0)|0;s=J;t=o;f[t>>2]=O;f[t+4>>2]=s;if((W|0)<=0)break;else{W=W+-1|0;K=K+4|0;N=N+1|0}}u=g;return}else{if(!X){u=g;return}X=H1a(ba|0,ca|0,16)|0;ca=W1a(X|0,J|0,r|0,0)|0;X=Z;Z=_;_=ha;ha=x+ca|0;ca=0;while(1){x=H1a(X|0,Z|0,16)|0;ba=R1a(x|0,J|0,2)|0;x=C1a(ba|0,J|0,-4,0)|0;ba=ha+x|0;x=f[i+(((((ca|0)>1?2:1)&(ca|2))*3|0)+(((_|0)>1?2:1)&(_|2))<<2)>>2]|0;N=I1a(X|0,Z|0,11)|0;K=N&31;N=(Y(f[51488+((K|32)<<2)>>2]|0,x)|0)>>>8&255;W=h[ba>>0]|0;s=(((Y(k-W|0,N)|0)+127|0)>>>8)+W|0;W=ba+1|0;O=h[W>>0]|0;o=(((Y(l-O|0,N)|0)+127|0)>>>8)+O|0;O=ba+2|0;aa=h[O>>0]|0;$=(((Y(m-aa|0,N)|0)+127|0)>>>8)+aa|0;aa=ba+3|0;t=h[aa>>0]|0;v=(((Y(n-t|0,N)|0)+127|0)>>>8)+t|0;t=(((Y(l-(o&255)|0,N)|0)+127|0)>>>8)+o|0;o=(((Y(m-($&255)|0,N)|0)+127|0)>>>8)+$|0;$=(((Y(n-(v&255)|0,N)|0)+127|0)>>>8)+v|0;v=(((Y(k-(s&255)|0,N)|0)+127|0)>>>8)+s&255;b[ba>>0]=v;b[W>>0]=t;b[O>>0]=o;b[aa>>0]=$;$=ba+4|0;ba=(Y(f[51488+(K<<2)>>2]|0,x)|0)>>>8&255;aa=h[$>>0]|0;o=(((Y(k-aa|0,ba)|0)+127|0)>>>8)+aa|0;aa=$+1|0;O=h[aa>>0]|0;t=(((Y(l-O|0,ba)|0)+127|0)>>>8)+O|0;O=$+2|0;W=h[O>>0]|0;v=(((Y(m-W|0,ba)|0)+127|0)>>>8)+W|0;W=$+3|0;s=h[W>>0]|0;N=(((Y(n-s|0,ba)|0)+127|0)>>>8)+s|0;s=(((Y(l-(t&255)|0,ba)|0)+127|0)>>>8)+t|0;t=(((Y(m-(v&255)|0,ba)|0)+127|0)>>>8)+v|0;v=(((Y(n-(N&255)|0,ba)|0)+127|0)>>>8)+N|0;N=(((Y(k-(o&255)|0,ba)|0)+127|0)>>>8)+o&255;b[$>>0]=N;b[aa>>0]=s;b[O>>0]=t;b[W>>0]=v;v=$+4|0;$=(Y(f[51488+((K^63)<<2)>>2]|0,x)|0)>>>8&255;x=h[v>>0]|0;K=(((Y(k-x|0,$)|0)+127|0)>>>8)+x|0;x=v+1|0;W=h[x>>0]|0;t=(((Y(l-W|0,$)|0)+127|0)>>>8)+W|0;W=v+2|0;O=h[W>>0]|0;s=(((Y(m-O|0,$)|0)+127|0)>>>8)+O|0;O=v+3|0;aa=h[O>>0]|0;N=(((Y(n-aa|0,$)|0)+127|0)>>>8)+aa|0;aa=(((Y(l-(t&255)|0,$)|0)+127|0)>>>8)+t|0;t=(((Y(m-(s&255)|0,$)|0)+127|0)>>>8)+s|0;s=(((Y(n-(N&255)|0,$)|0)+127|0)>>>8)+N|0;N=(((Y(k-(K&255)|0,$)|0)+127|0)>>>8)+K&255;b[v>>0]=N;b[x>>0]=aa;b[W>>0]=t;b[O>>0]=s;s=c;X=C1a(f[s>>2]|0,f[s+4>>2]|0,da|0,ea|0)|0;Z=J;s=c;f[s>>2]=X;f[s+4>>2]=Z;if((_|0)<=0)break;else{_=_+-1|0;ha=ha+r|0;ca=ca+1|0}}u=g;return}}}}break}default:{}}ca=c;r=I1a(f[ca>>2]|0,f[ca+4>>2]|0,16)|0;ca=c+8|0;c=I1a(f[ca>>2]|0,f[ca+4>>2]|0,16)|0;ca=d;ha=I1a(f[ca>>2]|0,f[ca+4>>2]|0,16)|0;ca=d+8|0;d=I1a(f[ca>>2]|0,f[ca+4>>2]|0,16)|0;v8(a,r,c,ha,d,e,8);u=g;return}function y8(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0;i=u;u=u+128|0;j=i+64|0;k=i+48|0;l=i+32|0;m=i+16|0;n=i;o=1<<h>>1;p=f[a+16>>2]|0;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[a+4>>2]|0;if((q|0)>0)t=f[(f[a+44>>2]|0)+(q+-1<<2)>>2]|0;else t=0;q=(g|0)<16;v=q?32768:65535;w=q?0:0;x=q?32768:0;y=q?0:0;z=d+-1|0;A=c+(z<<4)|0;B=c+(z<<4)+8|0;C=f[B>>2]|0;D=f[B+4>>2]|0;B=16-h|0;E=R1a(f[A>>2]|0,f[A+4>>2]|0,B|0)|0;A=J;F=R1a(C|0,D|0,B|0)|0;D=J;C=c;G=f[C>>2]|0;H=f[C+4>>2]|0;C=c+8|0;I=f[C>>2]|0;K=f[C+4>>2]|0;a:do if((d|0)>0){C=(h|0)==0;L=k+8|0;M=l+8|0;N=m+8|0;O=n+8|0;if((g|0)<9){P=K;Q=K;R=I;S=I;T=K;U=I;V=H;W=H;X=G;Z=G;_=H;$=G;aa=E;ba=A;ca=F;da=D;ea=0;fa=0}else{ga=K;ha=K;ia=I;ja=I;ka=K;la=I;ma=H;na=H;oa=G;pa=G;qa=H;ra=G;sa=E;ta=A;ua=F;va=D;wa=0;xa=0;while(1){ya=(ga|0)<(ha|0)|(ga|0)==(ha|0)&ia>>>0<ja>>>0;za=ya?wa:xa;Aa=ya?ia:ja;Ba=ya?ga:ha;ya=(ka|0)<(ga|0)|(ka|0)==(ga|0)&la>>>0<ia>>>0;Ca=ya?ia:la;Da=ya?ga:ka;ya=(ma|0)<(na|0)|(ma|0)==(na|0)&oa>>>0<pa>>>0;Ea=ya?pa:oa;Fa=ya?na:ma;ya=(qa|0)>(na|0)|(qa|0)==(na|0)&ra>>>0>pa>>>0;Ga=ya?pa:ra;Ha=ya?na:qa;ya=R1a(pa|0,na|0,B|0)|0;Ia=J;Ja=R1a(ia|0,ga|0,B|0)|0;Ka=J;La=m;f[La>>2]=sa;f[La+4>>2]=ta;La=N;f[La>>2]=ua;f[La+4>>2]=va;La=n;f[La>>2]=ya;f[La+4>>2]=Ia;La=O;f[La>>2]=Ja;f[La+4>>2]=Ka;x8(a,m,n,e);La=wa+1|0;if((La|0)==(d|0)){Ma=Aa;Na=Ba;Oa=Ca;Pa=Da;Qa=Ea;Ra=Fa;Sa=Ga;Ta=Ha;Ua=za;break a}Va=c+(La<<4)|0;Wa=c+(La<<4)+8|0;ga=f[Wa+4>>2]|0;ha=Ba;ia=f[Wa>>2]|0;ja=Aa;ka=Da;la=Ca;ma=Fa;na=f[Va+4>>2]|0;oa=Ea;pa=f[Va>>2]|0;qa=Ha;ra=Ga;sa=ya;ta=Ia;ua=Ja;va=Ka;wa=La;xa=za}}while(1){xa=(P|0)<(Q|0)|(P|0)==(Q|0)&R>>>0<S>>>0;wa=xa?ea:fa;va=xa?R:S;ua=xa?P:Q;xa=(T|0)<(P|0)|(T|0)==(P|0)&U>>>0<R>>>0;ta=xa?R:U;sa=xa?P:T;xa=(V|0)<(W|0)|(V|0)==(W|0)&X>>>0<Z>>>0;ra=xa?Z:X;qa=xa?W:V;xa=(_|0)>(W|0)|(_|0)==(W|0)&$>>>0>Z>>>0;pa=xa?Z:$;oa=xa?W:_;xa=R1a(Z|0,W|0,B|0)|0;na=J;ma=R1a(R|0,P|0,B|0)|0;la=J;if(C){ka=I1a(aa|0,ba|0,16)|0;ja=I1a(ca|0,da|0,16)|0;ia=I1a(xa|0,na|0,16)|0;ha=I1a(ma|0,la|0,16)|0;v8(a,ka,ja,ia,ha,e,g)}else{ha=k;f[ha>>2]=aa;f[ha+4>>2]=ba;ha=L;f[ha>>2]=ca;f[ha+4>>2]=da;ha=l;f[ha>>2]=xa;f[ha+4>>2]=na;ha=M;f[ha>>2]=ma;f[ha+4>>2]=la;w8(a,k,l,e)}ha=ea+1|0;if((ha|0)==(d|0)){Ma=va;Na=ua;Oa=ta;Pa=sa;Qa=ra;Ra=qa;Sa=pa;Ta=oa;Ua=wa;break a}ia=c+(ha<<4)|0;ja=c+(ha<<4)+8|0;P=f[ja+4>>2]|0;Q=ua;R=f[ja>>2]|0;S=va;T=sa;U=ta;V=qa;W=f[ia+4>>2]|0;X=ra;Z=f[ia>>2]|0;_=oa;$=pa;aa=xa;ba=na;ca=ma;da=la;ea=ha;fa=wa}}else{Ma=I;Na=K;Oa=I;Pa=K;Qa=G;Ra=H;Sa=G;Ta=H;Ua=0}while(0);H=((o|0)<0)<<31>>31;G=C1a(Ma|0,Na|0,o|0,H|0)|0;Na=H1a(G|0,J|0,h|0)|0;G=C1a(Oa|0,Pa|0,o|0,H|0)|0;Pa=H1a(G|0,J|0,h|0)|0;G=J;if((d|0)<3){u=i;return}Oa=C1a(Qa|0,Ra|0,o|0,H|0)|0;Ra=H1a(Oa|0,J|0,h|0)|0;Oa=J;Oa=C1a(Sa|0,Ta|0,o|0,H|0)|0;Ta=H1a(Oa|0,J|0,h|0)|0;if(!((Ra|Pa|0)>-1&(Ta|0)<(r|0))){u=i;return}if((Na|0)>=(s|0)){u=i;return}Ta=s+-1|0;s=((Ta|0)<0)<<31>>31;Ra=(G|0)>(s|0)|(G|0)==(s|0)&Pa>>>0>Ta>>>0;s=Ra?Ta:Pa;Pa=j+32|0;f[Pa>>2]=Ua;f[j>>2]=Ua;Ua=j+56|0;f[Ua>>2]=Na;Ta=j+24|0;f[Ta>>2]=Na;Ra=j+4|0;f[Ra>>2]=1;G=j+36|0;f[G>>2]=z;z=j+40|0;Oa=z;f[Oa>>2]=-65536;f[Oa+4>>2]=-1;Oa=j+8|0;Sa=Oa;f[Sa>>2]=-65536;f[Sa+4>>2]=-1;Sa=j+48|0;Qa=Sa;f[Qa>>2]=0;f[Qa+4>>2]=0;Qa=j+16|0;Ma=Qa;f[Ma>>2]=0;f[Ma+4>>2]=0;Ma=a+48|0;a=p+(Y(f[Ma>>2]|0,Na)|0)|0;p=r+-1|0;K=(t|0)==1;I=(h|0)==16?0:B;B=-65536;fa=-1;ea=-65536;da=-1;ca=d;ba=a;a=Na;while(1){if(!q?!((a|0)<(s|0)|(a|0)==(Na|0)):0){Xa=da;Ya=fa;Za=ea;_a=B;$a=ca}else ab=18;b:do if((ab|0)==18){ab=0;c:do if((a|0)<(f[Ta>>2]|0)){bb=ea;cb=da;db=ca}else{aa=f[Ra>>2]|0;$=f[j>>2]|0;_=ca;while(1){Z=$+aa|0;eb=Z-((Z|0)<(d|0)?0:d)|0;Z=_;_=_+-1|0;if((Z|0)<=0){bb=ea;cb=da;db=_;break c}Z=c+(eb<<4)+8|0;X=C1a(f[Z>>2]|0,f[Z+4>>2]|0,o|0,H|0)|0;fb=H1a(X|0,J|0,h|0)|0;if((fb|0)>(a|0))break;else $=eb}aa=c+($<<4)|0;X=c+(eb<<4)|0;Z=f[X>>2]|0;W=f[X+4>>2]|0;X=R1a(f[aa>>2]|0,f[aa+4>>2]|0,I|0)|0;aa=J;V=R1a(Z|0,W|0,I|0)|0;f[Ta>>2]=fb;W=B1a(V|0,J|0,X|0,aa|0)|0;V=R1a(W|0,J|0,1)|0;W=fb-a|0;Z=C1a(V|0,J|0,W|0,((W|0)<0)<<31>>31|0)|0;V=W<<1;W=S1a(Z|0,J|0,V|0,((V|0)<0)<<31>>31|0)|0;V=Qa;f[V>>2]=W;f[V+4>>2]=J;V=Oa;f[V>>2]=X;f[V+4>>2]=aa;f[j>>2]=eb;bb=X;cb=aa;db=_}while(0);if((a|0)<(f[Ua>>2]|0)){Xa=cb;Ya=fa;Za=bb;_a=B;$a=db}else{aa=f[G>>2]|0;X=f[Pa>>2]|0;V=db;while(1){W=X+aa|0;gb=W-((W|0)<(d|0)?0:d)|0;W=V;V=V+-1|0;if((W|0)<=0){Xa=cb;Ya=fa;Za=bb;_a=B;$a=V;break b}W=c+(gb<<4)+8|0;Z=C1a(f[W>>2]|0,f[W+4>>2]|0,o|0,H|0)|0;hb=H1a(Z|0,J|0,h|0)|0;if((hb|0)>(a|0))break;else X=gb}aa=c+(X<<4)|0;Z=c+(gb<<4)|0;W=f[Z>>2]|0;U=f[Z+4>>2]|0;Z=R1a(f[aa>>2]|0,f[aa+4>>2]|0,I|0)|0;aa=J;T=R1a(W|0,U|0,I|0)|0;f[Ua>>2]=hb;U=B1a(T|0,J|0,Z|0,aa|0)|0;T=R1a(U|0,J|0,1)|0;U=hb-a|0;W=C1a(T|0,J|0,U|0,((U|0)<0)<<31>>31|0)|0;T=U<<1;U=S1a(W|0,J|0,T|0,((T|0)<0)<<31>>31|0)|0;T=Sa;f[T>>2]=U;f[T+4>>2]=J;T=z;f[T>>2]=Z;f[T+4>>2]=aa;f[Pa>>2]=gb;Xa=cb;Ya=aa;Za=bb;_a=Z;$a=V}}while(0);if(($a|0)<0){ab=35;break}do if((a|0)>-1?(Z=(Xa|0)>(Ya|0)|(Xa|0)==(Ya|0)&Za>>>0>_a>>>0,aa=j+((Z&1)<<5)+8|0,T=C1a(f[aa>>2]|0,f[aa+4>>2]|0,v|0,w|0)|0,aa=I1a(T|0,J|0,16)|0,T=j+(((Z^1)&1)<<5)+8|0,Z=C1a(f[T>>2]|0,f[T+4>>2]|0,x|0,y|0)|0,T=I1a(Z|0,J|0,16)|0,(aa|0)<(r|0)&(T|0)>-1):0){Z=Y((aa|0)>0?aa:0,t)|0;aa=ba+Z|0;U=Y(((T|0)<(r|0)?T:p)+1|0,t)|0;T=ba+U|0;if(K){F1a(aa|0,b[e>>0]|0,T-aa|0)|0;break}if((Z|0)<(U|0)){K1a(aa|0,e|0,t|0)|0;ib=aa+t|0}else ib=aa;if(ib>>>0<T>>>0){U=T;Z=ib;W=t;while(1){K1a(Z|0,aa|0,W|0)|0;Z=Z+W|0;S=W<<1;R=U-Z|0;if(Z>>>0>=T>>>0)break;else W=R>>>0<S>>>0?R:S}}}while(0);W=Qa;T=Oa;ea=C1a(f[T>>2]|0,f[T+4>>2]|0,f[W>>2]|0,f[W+4>>2]|0)|0;da=J;W=Oa;f[W>>2]=ea;f[W+4>>2]=da;W=Sa;T=z;B=C1a(f[T>>2]|0,f[T+4>>2]|0,f[W>>2]|0,f[W+4>>2]|0)|0;fa=J;W=z;f[W>>2]=B;f[W+4>>2]=fa;if((a|0)>=(s|0)){ab=35;break}else{ca=$a;ba=ba+(f[Ma>>2]|0)|0;a=a+1|0}}if((ab|0)==35){u=i;return}}function z8(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;h=f[a+40>>2]|0;i=f[h+4>>2]|0;j=f[h>>2]|0;h=f[a+48>>2]|0;k=f[a+4>>2]|0;if((k|0)>0)l=f[(f[a+44>>2]|0)+(k+-1<<2)>>2]|0;else l=0;k=f[a+16>>2]|0;a=f[c>>2]|0;if((a|0)>=(d|0)&(a|0)<(i-d|0)){m=f[c+4>>2]|0;n=(m|0)<(j-d|0)&(m|0)>=(d|0)}else n=0;if((d|0)<0)return;m=c+4|0;o=(g|0)!=0;g=(l|0)==1;p=i+-1|0;q=a;a=d;r=0;s=0;t=(d<<1)+-1|0;d=1;while(1){u=f[m>>2]|0;v=u-r|0;w=u+r|0;x=u-a|0;y=u+a|0;u=q-a|0;z=q+a|0;A=q-r|0;B=q+r|0;do if(n){C=k+(Y(v,h)|0)|0;D=k+(Y(w,h)|0)|0;E=Y(u,l)|0;F=C+E|0;if(!o){K1a(F|0,e|0,l|0)|0;K1a(D+E|0,e|0,l|0)|0;G=Y(z,l)|0;K1a(C+G|0,e|0,l|0)|0;K1a(D+G|0,e|0,l|0)|0;G=k+(Y(x,h)|0)|0;H=k+(Y(y,h)|0)|0;I=Y(A,l)|0;K1a(G+I|0,e|0,l|0)|0;K1a(H+I|0,e|0,l|0)|0;I=Y(B,l)|0;K1a(G+I|0,e|0,l|0)|0;K1a(H+I|0,e|0,l|0)|0;break}I=Y(z+1|0,l)|0;H=C+I|0;if(!g){C=(I|0)>(E|0);if(C){K1a(F|0,e|0,l|0)|0;J=F+l|0}else J=F;if(J>>>0<H>>>0){G=H;K=J;L=l;while(1){K1a(K|0,F|0,L|0)|0;K=K+L|0;M=L<<1;N=G-K|0;if(K>>>0>=H>>>0)break;else L=N>>>0<M>>>0?N:M}}L=D+E|0;K=D+I|0;if(C){K1a(L|0,e|0,l|0)|0;O=D+E+l|0}else O=L;if(O>>>0<K>>>0){G=K;M=O;N=l;while(1){K1a(M|0,L|0,N|0)|0;M=M+N|0;P=N<<1;Q=G-M|0;if(M>>>0>=K>>>0)break;else N=Q>>>0<P>>>0?Q:P}}}else{F1a(F|0,b[e>>0]|0,H-F|0)|0;F1a(D+E|0,b[e>>0]|0,I-E|0)|0}N=k+(Y(x,h)|0)|0;K=k+(Y(y,h)|0)|0;M=Y(A,l)|0;G=N+M|0;L=Y(B+1|0,l)|0;C=N+L|0;if(g){F1a(G|0,b[e>>0]|0,C-G|0)|0;F1a(K+M|0,b[e>>0]|0,L-M|0)|0;break}N=(L|0)>(M|0);if(N){K1a(G|0,e|0,l|0)|0;R=G+l|0}else R=G;if(R>>>0<C>>>0){P=C;Q=R;S=l;while(1){K1a(Q|0,G|0,S|0)|0;Q=Q+S|0;T=S<<1;U=P-Q|0;if(Q>>>0>=C>>>0)break;else S=U>>>0<T>>>0?U:T}}S=K+M|0;C=K+L|0;if(N){K1a(S|0,e|0,l|0)|0;V=K+M+l|0}else V=S;if(V>>>0<C>>>0){Q=C;P=V;G=l;while(1){K1a(P|0,S|0,G|0)|0;P=P+G|0;E=G<<1;I=Q-P|0;if(P>>>0>=C>>>0)break;else G=I>>>0<E>>>0?I:E}}}else if((u|0)<(i|0)&(z|0)>-1?(x|0)<(j|0)&(y|0)>-1:0){G=o?((u|0)>0?u:0):u;C=o&(z|0)>=(i|0)?p:z;do if(v>>>0<j>>>0){P=k+(Y(v,h)|0)|0;if(!o){if((G|0)>-1)K1a(P+(Y(G,l)|0)|0,e|0,l|0)|0;if((C|0)>=(i|0))break;K1a(P+(Y(C,l)|0)|0,e|0,l|0)|0;break}Q=Y(G,l)|0;S=P+Q|0;M=Y(C+1|0,l)|0;K=P+M|0;if(g){F1a(S|0,b[e>>0]|0,K-S|0)|0;break}if((Q|0)<(M|0)){K1a(S|0,e|0,l|0)|0;W=S+l|0}else W=S;if(W>>>0<K>>>0){M=K;Q=W;P=l;while(1){K1a(Q|0,S|0,P|0)|0;Q=Q+P|0;N=P<<1;L=M-Q|0;if(Q>>>0>=K>>>0)break;else P=L>>>0<N>>>0?L:N}}}while(0);do if(w>>>0<j>>>0){P=k+(Y(w,h)|0)|0;if(!o){if((G|0)>-1)K1a(P+(Y(G,l)|0)|0,e|0,l|0)|0;if((C|0)>=(i|0))break;K1a(P+(Y(C,l)|0)|0,e|0,l|0)|0;break}K=Y(G,l)|0;Q=P+K|0;M=Y(C+1|0,l)|0;S=P+M|0;if(g){F1a(Q|0,b[e>>0]|0,S-Q|0)|0;break}if((K|0)<(M|0)){K1a(Q|0,e|0,l|0)|0;X=Q+l|0}else X=Q;if(X>>>0<S>>>0){M=S;K=X;P=l;while(1){K1a(K|0,Q|0,P|0)|0;K=K+P|0;N=P<<1;L=M-K|0;if(K>>>0>=S>>>0)break;else P=L>>>0<N>>>0?L:N}}}while(0);if((A|0)<(i|0)&(B|0)>-1){C=o?((A|0)>0?A:0):A;G=o&(B|0)>=(i|0)?p:B;do if(x>>>0<j>>>0){P=k+(Y(x,h)|0)|0;if(!o){if((C|0)>-1)K1a(P+(Y(C,l)|0)|0,e|0,l|0)|0;if((G|0)>=(i|0))break;K1a(P+(Y(G,l)|0)|0,e|0,l|0)|0;break}S=Y(C,l)|0;K=P+S|0;M=Y(G+1|0,l)|0;Q=P+M|0;if(g){F1a(K|0,b[e>>0]|0,Q-K|0)|0;break}if((S|0)<(M|0)){K1a(K|0,e|0,l|0)|0;Z=K+l|0}else Z=K;if(Z>>>0<Q>>>0){M=Q;S=Z;P=l;while(1){K1a(S|0,K|0,P|0)|0;S=S+P|0;N=P<<1;L=M-S|0;if(S>>>0>=Q>>>0)break;else P=L>>>0<N>>>0?L:N}}}while(0);if(y>>>0<j>>>0){P=k+(Y(y,h)|0)|0;if(!o){if((C|0)>-1)K1a(P+(Y(C,l)|0)|0,e|0,l|0)|0;if((G|0)>=(i|0))break;K1a(P+(Y(G,l)|0)|0,e|0,l|0)|0;break}Q=Y(C,l)|0;S=P+Q|0;M=Y(G+1|0,l)|0;K=P+M|0;if(g){F1a(S|0,b[e>>0]|0,K-S|0)|0;break}if((Q|0)<(M|0)){K1a(S|0,e|0,l|0)|0;_=S+l|0}else _=S;if(_>>>0<K>>>0){M=K;Q=_;P=l;while(1){K1a(Q|0,S|0,P|0)|0;Q=Q+P|0;N=P<<1;L=M-Q|0;if(Q>>>0>=K>>>0)break;else P=L>>>0<N>>>0?L:N}}}}}while(0);y=s+d|0;x=(y|0)>0;B=(x<<31>>31)+a|0;if((B|0)<=(r|0))break;q=f[c>>2]|0;a=B;r=r+1|0;s=y-(x?t:0)|0;t=t-(x?2:0)|0;d=d+2|0}return}function A8(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;k=u;u=u+80|0;l=k+68|0;m=k+32|0;n=k;o=k+56|0;q=k+16|0;r=k+48|0;s=c;t=f[s>>2]|0;v=f[s+4>>2]|0;s=(v|0)>-1|(v|0)==-1&t>>>0>4294967295;w=B1a(0,0,t|0,v|0)|0;x=s?t:w;w=s?v:J;v=c;f[v>>2]=x;f[v+4>>2]=w;v=c+8|0;c=v;s=f[c>>2]|0;t=f[c+4>>2]|0;c=(t|0)>-1|(t|0)==-1&s>>>0>4294967295;y=B1a(0,0,s|0,t|0)|0;z=c?s:y;y=c?t:J;t=v;f[t>>2]=z;f[t+4>>2]=y;t=(w|0)<(y|0)|(w|0)==(y|0)&x>>>0<z>>>0;v=C1a((t?z:x)|0,(t?y:w)|0,32768,0)|0;t=I1a(v|0,J|0,16)|0;if((t|0)<3)A=90;else A=(t|0)<10?30:(t|0)<15?18:5;f[l>>2]=0;t=l+4|0;f[t>>2]=0;f[l+8>>2]=0;v=b;c=b+8|0;s=c;B=+((f[s>>2]|0)>>>0)+4294967296.0*+(f[s+4>>2]|0);p[m>>3]=+((f[v>>2]|0)>>>0)+4294967296.0*+(f[v+4>>2]|0);p[m+8>>3]=B;p[n>>3]=+(x>>>0)+4294967296.0*+(w|0);p[n+8>>3]=+(z>>>0)+4294967296.0*+(y|0);o8(m,n,d,e,g,A,l);f[o>>2]=0;A=o+4|0;f[A>>2]=0;f[o+8>>2]=0;d=f[t>>2]|0;n=f[l>>2]|0;if((d|0)==(n|0)){C=0;D=0}else{m=q+8|0;y=o+8|0;z=-1;w=-1;x=-1;v=-1;s=d;d=n;n=0;while(1){E=d;F=rNa(+p[E+(n<<4)>>3]*.0000152587890625)|0;G=R1a(F|0,((F|0)<0)<<31>>31|0,16)|0;F=J;H=rNa(+p[E+(n<<4)+8>>3]*.0000152587890625)|0;I=R1a(H|0,((H|0)<0)<<31>>31|0,16)|0;H=J;K=rNa(+p[E+(n<<4)>>3]-(+(G>>>0)+4294967296.0*+(F|0)))|0;L=C1a(K|0,((K|0)<0)<<31>>31|0,G|0,F|0)|0;F=J;G=q;f[G>>2]=L;f[G+4>>2]=F;G=rNa(+p[E+(n<<4)+8>>3]-(+(I>>>0)+4294967296.0*+(H|0)))|0;E=C1a(G|0,((G|0)<0)<<31>>31|0,I|0,H|0)|0;H=J;I=m;f[I>>2]=E;f[I+4>>2]=H;if((L|0)!=(x|0)|(F|0)!=(v|0)|((E|0)!=(z|0)|(H|0)!=(w|0))){I=f[A>>2]|0;if((I|0)==(f[y>>2]|0)){B8(o,q);M=f[t>>2]|0;N=f[l>>2]|0}else{G=I;f[G>>2]=L;f[G+4>>2]=F;F=I+8|0;f[F>>2]=E;f[F+4>>2]=H;f[A>>2]=I+16;M=s;N=d}I=q;H=m;O=N;P=M;Q=f[H>>2]|0;R=f[H+4>>2]|0;S=f[I>>2]|0;T=f[I+4>>2]|0}else{O=d;P=s;Q=z;R=w;S=x;T=v}n=n+1|0;if(n>>>0>=P-O>>4>>>0)break;else{z=Q;w=R;x=S;v=T;s=P;d=O}}C=f[o>>2]|0;D=f[A>>2]|0}if((D-C|0)==16)C8(o,2,b);do if((i|0)<=-1){if((g-e|0)>359){C=f[o>>2]|0;y8(a,C,(f[A>>2]|0)-C>>4,h,j,16);break}C=f[A>>2]|0;if((C|0)==(f[o+8>>2]|0)){B8(o,b);U=f[A>>2]|0}else{D=b;O=f[D+4>>2]|0;d=C;f[d>>2]=f[D>>2];f[d+4>>2]=O;O=c;d=f[O+4>>2]|0;D=C+8|0;f[D>>2]=f[O>>2];f[D+4>>2]=d;d=C+16|0;f[A>>2]=d;U=d}f[q>>2]=0;d=q+4|0;f[d>>2]=0;f[q+8>>2]=0;C=f[o>>2]|0;f[r>>2]=0;f[r+4>>2]=0;E8(a,C,U-C>>4,q,h,j,16,r);F8(a,q,h);C=f[q>>2]|0;if(C|0){D=f[d>>2]|0;if((D|0)!=(C|0))f[d>>2]=D+(~((D+-32-C|0)>>>5)<<5);PYa(C)}}else{C=f[o>>2]|0;D8(a,C,(f[A>>2]|0)-C>>4,0,h,i,j,16)}while(0);j=f[o>>2]|0;if(j|0){o=f[A>>2]|0;if((o|0)!=(j|0))f[A>>2]=o+(~((o+-16-j|0)>>>4)<<4);PYa(j)}j=f[l>>2]|0;if(!j){u=k;return}l=f[t>>2]|0;if((l|0)!=(j|0))f[t>>2]=l+(~((l+-16-j|0)>>>4)<<4);PYa(j);u=k;return}function B8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)gXa(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=De(8)|0;UYa(l,358155);f[l>>2]=130560;Of(l|0,21520,875)}else{n=NYa(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;m=b;k=f[m+4>>2]|0;o=l;f[o>>2]=f[m>>2];f[o+4>>2]=k;k=b+8|0;b=f[k+4>>2]|0;o=n+(g<<4)+8|0;f[o>>2]=f[k>>2];f[o+4>>2]=b;b=l+16|0;if((j|0)==(i|0))p=l;else{o=j+-16-e|0;k=l;g=j;while(1){j=g;g=g+-16|0;n=g;m=f[n+4>>2]|0;q=k+-16|0;f[q>>2]=f[n>>2];f[q+4>>2]=m;m=j+-8|0;j=f[m+4>>2]|0;q=k+-8|0;f[q>>2]=f[m>>2];f[q+4>>2]=j;if((g|0)==(i|0))break;else k=k+-16|0}p=l+(~(o>>>4)<<4)|0}f[a>>2]=p;f[c>>2]=b;f[d>>2]=h;if(!e)return;PYa(e);return}function C8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;do if(e-g>>4>>>0>=b>>>0){i=a+4|0;j=f[i>>2]|0;k=j-g>>4;l=k>>>0<b>>>0;m=l?k:b;n=j;if(m|0){j=c+8|0;o=h;p=m;while(1){m=c;q=f[m+4>>2]|0;r=o;f[r>>2]=f[m>>2];f[r+4>>2]=q;q=j;r=f[q+4>>2]|0;m=o+8|0;f[m>>2]=f[q>>2];f[m+4>>2]=r;p=p+-1|0;if(!p)break;else o=o+16|0}}if(!l){o=h+(b<<4)|0;if((n|0)==(o|0))return;else{s=i;t=n+(~((n+-16-o|0)>>>4)<<4)|0;break}}else{o=b-k|0;p=c+8|0;j=n;r=o;while(1){m=c;q=f[m+4>>2]|0;u=j;f[u>>2]=f[m>>2];f[u+4>>2]=q;q=p;u=f[q+4>>2]|0;m=j+8|0;f[m>>2]=f[q>>2];f[m+4>>2]=u;r=r+-1|0;if(!r)break;else j=j+16|0}s=i;t=n+(o<<4)|0;break}}else{j=g;if(!g)v=e;else{r=a+4|0;p=f[r>>2]|0;if((p|0)!=(h|0))f[r>>2]=p+(~((p+-16-g|0)>>>4)<<4);PYa(j);f[d>>2]=0;f[r>>2]=0;f[a>>2]=0;v=0}if(b>>>0>268435455)gXa(a);r=v>>3;j=v>>4>>>0<134217727?(r>>>0<b>>>0?b:r):268435455;if(j>>>0>268435455)gXa(a);r=NYa(j<<4)|0;p=a+4|0;f[p>>2]=r;f[a>>2]=r;f[d>>2]=r+(j<<4);j=c+8|0;k=r;l=b;while(1){u=c;m=f[u+4>>2]|0;q=k;f[q>>2]=f[u>>2];f[q+4>>2]=m;m=j;q=f[m+4>>2]|0;u=k+8|0;f[u>>2]=f[m>>2];f[u+4>>2]=q;l=l+-1|0;if(!l)break;else k=k+16|0}s=p;t=r+(b<<4)|0}while(0);f[s>>2]=t;return}function D8(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;k=u;u=u+48|0;l=k+32|0;m=k+16|0;n=k;if((c|0)==0|(d|0)<1){u=k;return}o=e?d+-1|0:0;p=(e^1)&1;q=e?2:3;if(!((h|0)>-1&j>>>0<17)){f[l>>2]=0;f[l+4>>2]=0;e=c$(l,49)|0;r=223661;s=e+49|0;do{b[e>>0]=b[r>>0]|0;e=e+1|0;r=r+1|0}while((e|0)<(s|0));j$(-215,l,223711,223392,1726);d$(l)}if((p|0)>=(d|0)){u=k;return}l=c+(o<<4)+8|0;r=c+(o<<4)|0;o=m+8|0;e=n+8|0;s=f[r>>2]|0;t=f[r+4>>2]|0;r=f[l>>2]|0;v=f[l+4>>2]|0;l=q;q=p;while(1){p=c+(q<<4)|0;w=s;s=f[p>>2]|0;x=t;t=f[p+4>>2]|0;p=c+(q<<4)+8|0;y=r;r=f[p>>2]|0;z=v;v=f[p+4>>2]|0;p=m;f[p>>2]=w;f[p+4>>2]=x;x=o;f[x>>2]=y;f[x+4>>2]=z;z=n;f[z>>2]=s;f[z+4>>2]=t;z=e;f[z>>2]=r;f[z+4>>2]=v;u8(a,m,n,g,h,i,l,j);q=q+1|0;if((q|0)==(d|0))break;else l=2}u=k;return}function E8(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;j=u;u=u+96|0;k=j+80|0;l=j+64|0;m=j+32|0;n=j+16|0;o=j;p=(f[i+4>>2]|0)+(1<<h>>1)|0;q=c+-1|0;r=b+(q<<4)|0;s=f[r>>2]|0;t=f[r+4>>2]|0;r=k+8|0;v=b+(q<<4)+8|0;q=f[v>>2]|0;w=f[v+4>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;v=f[i>>2]|0;x=C1a(v|0,((v|0)<0)<<31>>31|0,s|0,t|0)|0;t=16-h|0;s=R1a(x|0,J|0,t|0)|0;x=J;v=k;f[v>>2]=s;f[v+4>>2]=x;v=((p|0)<0)<<31>>31;y=C1a(q|0,w|0,p|0,v|0)|0;w=H1a(y|0,J|0,h|0)|0;y=J;q=r;f[q>>2]=w;f[q+4>>2]=y;q=d+4|0;M8(d,((f[q>>2]|0)-(f[d>>2]|0)>>5)+c|0);if((c|0)<=0){u=j;return}z=l+8|0;A=m+4|0;B=m+8|0;C=m+16|0;D=d+8|0;E=n+8|0;F=o+8|0;if((g|0)<16){G=s;H=x;I=w;K=y;L=0;do{f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;M=b+(L<<4)|0;N=b+(L<<4)+8|0;O=f[N>>2]|0;P=f[N+4>>2]|0;N=f[i>>2]|0;Q=C1a(N|0,((N|0)<0)<<31>>31|0,f[M>>2]|0,f[M+4>>2]|0)|0;M=G;G=R1a(Q|0,J|0,t|0)|0;Q=H;H=J;N=l;f[N>>2]=G;f[N+4>>2]=H;N=C1a(O|0,P|0,p|0,v|0)|0;P=I;I=H1a(N|0,J|0,h|0)|0;N=K;K=J;O=z;f[O>>2]=I;f[O+4>>2]=K;O=C1a(M|0,Q|0,32768,0)|0;R=I1a(O|0,J|0,16)|0;O=C1a(G|0,H|0,32768,0)|0;S=I1a(O|0,J|0,16)|0;v8(a,R,P,S,I,e,g);do if(!((I|0)==(P|0)&(K|0)==(N|0))){S=(K|0)>(N|0)|(K|0)==(N|0)&I>>>0>P>>>0;R=S?k:l;f[m>>2]=f[R+8>>2];f[A>>2]=f[(S?l:k)+8>>2];S=R;R=f[S+4>>2]|0;O=B;f[O>>2]=f[S>>2];f[O+4>>2]=R;R=B1a(G|0,H|0,M|0,Q|0)|0;O=J;S=B1a(I|0,K|0,P|0,N|0)|0;T=S1a(R|0,O|0,S|0,J|0)|0;S=C;f[S>>2]=T;f[S+4>>2]=J;S=f[q>>2]|0;if((S|0)==(f[D>>2]|0)){H8(d,m);break}else{f[S>>2]=f[m>>2];f[S+4>>2]=f[m+4>>2];f[S+8>>2]=f[m+8>>2];f[S+12>>2]=f[m+12>>2];f[S+16>>2]=f[m+16>>2];f[S+20>>2]=f[m+20>>2];f[S+24>>2]=f[m+24>>2];f[S+28>>2]=f[m+28>>2];f[q>>2]=(f[q>>2]|0)+32;break}}while(0);L=L+1|0;N=k;f[N>>2]=G;f[N+4>>2]=H;N=r;f[N>>2]=I;f[N+4>>2]=K}while((L|0)!=(c|0));u=j;return}else{L=w;w=y;y=s;s=x;x=0;do{f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;K=b+(x<<4)|0;I=b+(x<<4)+8|0;H=f[I>>2]|0;G=f[I+4>>2]|0;I=f[i>>2]|0;g=C1a(I|0,((I|0)<0)<<31>>31|0,f[K>>2]|0,f[K+4>>2]|0)|0;K=y;y=R1a(g|0,J|0,t|0)|0;g=s;s=J;I=l;f[I>>2]=y;f[I+4>>2]=s;I=C1a(H|0,G|0,p|0,v|0)|0;G=L;L=H1a(I|0,J|0,h|0)|0;I=w;w=J;H=z;f[H>>2]=L;f[H+4>>2]=w;H=R1a(G|0,I|0,16)|0;N=J;P=R1a(L|0,w|0,16)|0;Q=n;f[Q>>2]=K;f[Q+4>>2]=g;Q=E;f[Q>>2]=H;f[Q+4>>2]=N;N=o;f[N>>2]=y;f[N+4>>2]=s;N=F;f[N>>2]=P;f[N+4>>2]=J;x8(a,n,o,e);do if(!((L|0)==(G|0)&(w|0)==(I|0))){N=(w|0)>(I|0)|(w|0)==(I|0)&L>>>0>G>>>0;P=N?k:l;f[m>>2]=f[P+8>>2];f[A>>2]=f[(N?l:k)+8>>2];N=P;P=f[N+4>>2]|0;Q=B;f[Q>>2]=f[N>>2];f[Q+4>>2]=P;P=B1a(y|0,s|0,K|0,g|0)|0;Q=J;N=B1a(L|0,w|0,G|0,I|0)|0;H=S1a(P|0,Q|0,N|0,J|0)|0;N=C;f[N>>2]=H;f[N+4>>2]=J;N=f[q>>2]|0;if((N|0)==(f[D>>2]|0)){H8(d,m);break}else{f[N>>2]=f[m>>2];f[N+4>>2]=f[m+4>>2];f[N+8>>2]=f[m+8>>2];f[N+12>>2]=f[m+12>>2];f[N+16>>2]=f[m+16>>2];f[N+20>>2]=f[m+20>>2];f[N+24>>2]=f[m+24>>2];f[N+28>>2]=f[m+28>>2];f[q>>2]=(f[q>>2]|0)+32;break}}while(0);x=x+1|0;I=k;f[I>>2]=y;f[I+4>>2]=s;I=r;f[I>>2]=L;f[I+4>>2]=w}while((x|0)!=(c|0));u=j;return}}function F8(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;e=u;u=u+48|0;g=e+32|0;h=e;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;i=c+4|0;j=f[i>>2]|0;k=f[c>>2]|0;l=j-k|0;m=l>>5;n=f[a+40>>2]|0;o=f[n+4>>2]|0;p=f[n>>2]|0;n=f[a+4>>2]|0;q=k;k=j;if((n|0)>0)r=f[(f[a+44>>2]|0)+(n+-1<<2)>>2]|0;else r=0;if((l|0)<64){u=e;return}else{s=2147483647;t=-1;v=-1;w=-1;x=0;y=-2147483648;z=2147483647}while(1){l=q+(x<<5)+8|0;n=f[l>>2]|0;j=f[l+4>>2]|0;l=f[q+(x<<5)+4>>2]|0;A=f[q+(x<<5)>>2]|0;B=l-A|0;C=q+(x<<5)+16|0;D=W1a(B|0,((B|0)<0)<<31>>31|0,f[C>>2]|0,f[C+4>>2]|0)|0;C=C1a(D|0,J|0,n|0,j|0)|0;D=J;z=(A|0)<(z|0)?A:z;y=(y|0)<(l|0)?l:y;l=(j|0)<(s|0)|(j|0)==(s|0)&n>>>0<t>>>0;A=l?n:t;B=l?j:s;l=(v|0)<(j|0)|(v|0)==(j|0)&w>>>0<n>>>0;E=l?n:w;n=l?j:v;j=(D|0)<(B|0)|(D|0)==(B|0)&C>>>0<A>>>0;t=j?C:A;s=j?D:B;B=(n|0)<(D|0)|(n|0)==(D|0)&E>>>0<C>>>0;v=B?D:n;x=x+1|0;if((x|0)>=(m|0))break;else w=B?C:E}if((y|0)<0){u=e;return}if((v|0)<0|(z|0)>=(p|0)){u=e;return}z=R1a(o|0,((o|0)<0)<<31>>31|0,16)|0;v=J;if(!((s|0)<(v|0)|(s|0)==(v|0)&t>>>0<z>>>0)){u=e;return}G8(q,k,g);f[h>>2]=2147483647;g=f[i>>2]|0;if((g|0)==(f[c+8>>2]|0))H8(c,h);else{f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];f[g+8>>2]=f[h+8>>2];f[g+12>>2]=f[h+12>>2];f[g+16>>2]=f[h+16>>2];f[g+20>>2]=f[h+20>>2];f[g+24>>2]=f[h+24>>2];f[g+28>>2]=f[h+28>>2];f[i>>2]=(f[i>>2]|0)+32}i=h+24|0;f[i>>2]=0;g=f[c>>2]|0;k=(y|0)>(p|0)?p:y;y=f[g>>2]|0;if((y|0)>=(k|0)){u=e;return}p=a+16|0;q=a+44|0;a=o+-1|0;z=(r|0)==1;t=0;v=g;g=0;s=y;while(1){a:do if((s|0)<0){y=f[c>>2]|0;w=0;x=v;E=g;C=t;B=h;while(1){b:do if(!C)F=22;else{n=B+24|0;D=C;while(1){if((f[D+4>>2]|0)!=(s|0))break;j=D+24|0;f[n>>2]=f[j>>2];A=f[j>>2]|0;if(!A){F=22;break b}else D=A}if((f[x>>2]|0)<=(s|0)?(A=D+8|0,j=f[A+4>>2]|0,l=x+8|0,G=f[l+4>>2]|0,!((j|0)<(G|0)|((j|0)==(G|0)?(f[A>>2]|0)>>>0<(f[l>>2]|0)>>>0:0))):0)if((E|0)<(m|0)){H=D;I=n;F=24;break}else{K=x;L=E;break a}M=x;N=E;O=f[D+24>>2]|0;P=D}while(0);if((F|0)==22){F=0;if(!((E|0)<(m|0)?(f[x>>2]|0)==(s|0):0)){K=x;L=E;break a}H=0;I=B+24|0;F=24}if((F|0)==24){F=0;f[I>>2]=x;f[x+24>>2]=H;l=E+1|0;M=y+(l<<5)|0;N=l;O=H;P=x}if(w|0){l=B+16|0;A=B+8|0;G=A;j=C1a(f[G>>2]|0,f[G+4>>2]|0,f[l>>2]|0,f[l+4>>2]|0)|0;l=A;f[l>>2]=j;f[l+4>>2]=J;l=P+16|0;j=P+8|0;A=j;G=C1a(f[A>>2]|0,f[A+4>>2]|0,f[l>>2]|0,f[l+4>>2]|0)|0;l=j;f[l>>2]=G;f[l+4>>2]=J}w=w^1;x=M;E=N;C=O;B=P}}else{B=0;C=v;E=g;x=t;w=h;while(1){c:do if(!x)F=31;else{y=w+24|0;l=x;while(1){if((f[l+4>>2]|0)!=(s|0))break;G=l+24|0;f[y>>2]=f[G>>2];j=f[G>>2]|0;if(!j){F=31;break c}else l=j}if((f[C>>2]|0)<=(s|0)?(D=l+8|0,n=f[D+4>>2]|0,j=C+8|0,G=f[j+4>>2]|0,!((n|0)<(G|0)|((n|0)==(G|0)?(f[D>>2]|0)>>>0<(f[j>>2]|0)>>>0:0))):0)if((E|0)<(m|0)){Q=l;R=y;F=40;break}else{K=C;L=E;break a}S=C;T=E;U=f[l+24>>2]|0;V=l}while(0);if((F|0)==31){F=0;if(!((E|0)<(m|0)?(f[C>>2]|0)==(s|0):0)){K=C;L=E;break a}Q=0;R=w+24|0;F=40}if((F|0)==40){F=0;f[R>>2]=C;f[C+24>>2]=Q;j=E+1|0;S=(f[c>>2]|0)+(j<<5)|0;T=j;U=Q;V=C}if(B|0){j=(f[p>>2]|0)+(Y(f[f[q>>2]>>2]|0,s)|0)|0;D=w+8|0;G=D;n=f[G>>2]|0;A=f[G+4>>2]|0;G=V+8|0;W=G;X=f[W>>2]|0;Z=f[W+4>>2]|0;W=(A|0)>(Z|0)|(A|0)==(Z|0)&n>>>0>X>>>0;_=C1a((W?X:n)|0,(W?Z:A)|0,65535,0)|0;$=I1a(_|0,J|0,16)|0;_=I1a((W?n:X)|0,(W?A:Z)|0,16)|0;do if((_|0)>-1&($|0)<(o|0)){Z=Y(($|0)>0?$:0,r)|0;A=j+Z|0;W=Y(((_|0)<(o|0)?_:a)+1|0,r)|0;X=j+W|0;if(z){F1a(A|0,b[d>>0]|0,X-A|0)|0;break}if((Z|0)<(W|0)){K1a(A|0,d|0,r|0)|0;aa=A+r|0}else aa=A;if(aa>>>0<X>>>0){W=X;Z=aa;n=r;while(1){K1a(Z|0,A|0,n|0)|0;Z=Z+n|0;ba=n<<1;ca=W-Z|0;if(Z>>>0>=X>>>0)break;else n=ca>>>0<ba>>>0?ca:ba}}}while(0);j=w+16|0;_=D;$=C1a(f[_>>2]|0,f[_+4>>2]|0,f[j>>2]|0,f[j+4>>2]|0)|0;j=D;f[j>>2]=$;f[j+4>>2]=J;j=V+16|0;$=G;_=C1a(f[$>>2]|0,f[$+4>>2]|0,f[j>>2]|0,f[j+4>>2]|0)|0;j=G;f[j>>2]=_;f[j+4>>2]=J}B=B^1;C=S;E=T;x=U;w=V}}while(0);w=f[i>>2]|0;x=0;E=0;while(1){d:do if((w|0)==(x|0)){da=h;ea=E}else{C=w;B=h;j=E;while(1){_=C+24|0;$=f[_>>2]|0;if(!$){da=B;ea=j;break d}n=C+8|0;X=f[n>>2]|0;Z=f[n+4>>2]|0;n=$;$=B;W=j;while(1){A=n+8|0;l=f[A+4>>2]|0;if(!((Z|0)>(l|0)|((Z|0)==(l|0)?X>>>0>(f[A>>2]|0)>>>0:0)))break;f[$+24>>2]=n;A=n+24|0;f[_>>2]=f[A>>2];f[A>>2]=C;A=f[_>>2]|0;if(!A){da=n;ea=1;break d}else{l=n;n=A;W=1;$=l}}if((n|0)==(x|0)){da=C;ea=W;break}else{$=C;C=n;j=W;B=$}}}while(0);if(!ea)break;w=f[i>>2]|0;if(!((da|0)!=(h|0)&(da|0)!=(w|0)))break;else{x=da;E=ea}}E=s+1|0;if((E|0)>=(k|0))break;t=f[i>>2]|0;v=K;g=L;s=E}u=e;return}function G8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0;d=u;u=u+32|0;e=d;g=a;a=b;a:while(1){b=a;h=a+-32|0;i=a+-64|0;j=a+-24|0;k=a+-16|0;l=g;while(1){m=l;b:while(1){n=m;o=b-n|0;p=o>>5;switch(p|0){case 2:{q=5;break a;break}case 3:{q=11;break a;break}case 4:{q=12;break a;break}case 5:{q=13;break a;break}case 1:case 0:{q=107;break a;break}default:{}}if((o|0)<992){q=15;break a}r=(p|0)/2|0;s=m+(r<<5)|0;if((o|0)>31968){o=(p|0)/4|0;t=K8(m,m+(o<<5)|0,s,s+(o<<5)|0,h,c)|0}else t=I8(m,s,h,c)|0;o=f[m>>2]|0;p=f[s>>2]|0;if((o|0)==(p|0)){v=m+8|0;w=f[v>>2]|0;x=f[v+4>>2]|0;v=m+(r<<5)+8|0;y=f[v>>2]|0;z=f[v+4>>2]|0;if((w|0)==(y|0)&(x|0)==(z|0)){v=m+16|0;A=m+(r<<5)+16|0;B=f[v+4>>2]|0;C=f[A+4>>2]|0;D=f[v>>2]|0;E=f[A>>2]|0}else{B=x;C=z;D=w;E=y}if((B|0)<(C|0)|(B|0)==(C|0)&D>>>0<E>>>0){F=h;G=t;break}}else if((o|0)<(p|0)){F=h;G=t;break}if((m|0)!=(i|0)){y=m+(r<<5)+8|0;w=m+(r<<5)+16|0;r=h;H=i;while(1){z=f[H>>2]|0;if((z|0)==(p|0)){x=r+-24|0;A=f[x>>2]|0;v=f[x+4>>2]|0;x=y;I=f[x>>2]|0;J=f[x+4>>2]|0;if((A|0)==(I|0)&(v|0)==(J|0)){x=r+-16|0;K=w;L=f[x+4>>2]|0;M=f[K+4>>2]|0;N=f[x>>2]|0;O=f[K>>2]|0}else{L=v;M=J;N=A;O=I}if((L|0)<(M|0)|(L|0)==(M|0)&N>>>0<O>>>0){q=77;break b}}else if((z|0)<(p|0)){q=77;break b}z=H+-32|0;if((m|0)==(z|0))break;else{I=H;H=z;r=I}}}r=m+32|0;p=f[h>>2]|0;if((o|0)==(p|0)){w=m+8|0;y=f[w>>2]|0;I=f[w+4>>2]|0;w=j;z=f[w>>2]|0;A=f[w+4>>2]|0;if((y|0)==(z|0)&(I|0)==(A|0)){w=m+16|0;J=k;P=f[w+4>>2]|0;Q=f[J+4>>2]|0;R=f[w>>2]|0;S=f[J>>2]|0}else{P=I;Q=A;R=y;S=z}if((P|0)<(Q|0)|(P|0)==(Q|0)&R>>>0<S>>>0)T=r;else q=46}else if((o|0)<(p|0))T=r;else q=46;if((q|0)==46){q=0;if((r|0)==(h|0)){q=107;break a}p=m+8|0;z=m+16|0;y=r;while(1){r=f[y>>2]|0;if((o|0)==(r|0)){A=p;I=f[A>>2]|0;J=f[A+4>>2]|0;A=y+8|0;w=f[A>>2]|0;v=f[A+4>>2]|0;if((I|0)==(w|0)&(J|0)==(v|0)){A=z;K=y+16|0;U=f[A+4>>2]|0;V=f[K+4>>2]|0;W=f[A>>2]|0;X=f[K>>2]|0}else{U=J;V=v;W=I;X=w}if((U|0)<(V|0)|(U|0)==(V|0)&W>>>0<X>>>0)break}else if((o|0)<(r|0))break;r=y+32|0;if((r|0)==(h|0)){q=107;break a}else y=r}f[e>>2]=f[y>>2];f[e+4>>2]=f[y+4>>2];f[e+8>>2]=f[y+8>>2];f[e+12>>2]=f[y+12>>2];f[e+16>>2]=f[y+16>>2];f[e+20>>2]=f[y+20>>2];f[e+24>>2]=f[y+24>>2];f[e+28>>2]=f[y+28>>2];f[y>>2]=f[h>>2];f[y+4>>2]=f[h+4>>2];f[y+8>>2]=f[h+8>>2];f[y+12>>2]=f[h+12>>2];f[y+16>>2]=f[h+16>>2];f[y+20>>2]=f[h+20>>2];f[y+24>>2]=f[h+24>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];T=y+32|0}if((T|0)==(h|0)){q=107;break a}o=m+8|0;z=m+16|0;p=T;r=h;while(1){w=f[m>>2]|0;I=p;while(1){v=f[I>>2]|0;if((w|0)==(v|0)){J=o;K=f[J>>2]|0;A=f[J+4>>2]|0;J=I+8|0;x=f[J>>2]|0;Y=f[J+4>>2]|0;if((K|0)==(x|0)&(A|0)==(Y|0)){J=z;Z=I+16|0;_=f[J+4>>2]|0;$=f[Z+4>>2]|0;aa=f[J>>2]|0;ba=f[Z>>2]|0}else{_=A;$=Y;aa=K;ba=x}if((_|0)<($|0)|(_|0)==($|0)&aa>>>0<ba>>>0){ca=r;break}}else if((w|0)<(v|0)){ca=r;break}I=I+32|0}while(1){v=ca;ca=ca+-32|0;x=f[ca>>2]|0;if((w|0)!=(x|0))if((w|0)<(x|0)){ca=ca;continue}else break;x=o;K=f[x>>2]|0;Y=f[x+4>>2]|0;x=v+-24|0;A=f[x>>2]|0;Z=f[x+4>>2]|0;if((K|0)==(A|0)&(Y|0)==(Z|0)){x=z;J=v+-16|0;da=f[x+4>>2]|0;ea=f[J+4>>2]|0;fa=f[x>>2]|0;ga=f[J>>2]|0}else{da=Y;ea=Z;fa=K;ga=A}if(!((da|0)<(ea|0)|(da|0)==(ea|0)&fa>>>0<ga>>>0))break}if(I>>>0>=ca>>>0){m=I;continue b};f[e>>2]=f[I>>2];f[e+4>>2]=f[I+4>>2];f[e+8>>2]=f[I+8>>2];f[e+12>>2]=f[I+12>>2];f[e+16>>2]=f[I+16>>2];f[e+20>>2]=f[I+20>>2];f[e+24>>2]=f[I+24>>2];f[e+28>>2]=f[I+28>>2];f[I>>2]=f[ca>>2];f[I+4>>2]=f[ca+4>>2];f[I+8>>2]=f[ca+8>>2];f[I+12>>2]=f[ca+12>>2];f[I+16>>2]=f[ca+16>>2];f[I+20>>2]=f[ca+20>>2];f[I+24>>2]=f[ca+24>>2];f[ca>>2]=f[e>>2];f[ca+4>>2]=f[e+4>>2];f[ca+8>>2]=f[e+8>>2];f[ca+12>>2]=f[e+12>>2];f[ca+16>>2]=f[e+16>>2];f[ca+20>>2]=f[e+20>>2];f[ca+24>>2]=f[e+24>>2];p=I+32|0;r=ca}}if((q|0)==77){q=0;f[e>>2]=f[m>>2];f[e+4>>2]=f[m+4>>2];f[e+8>>2]=f[m+8>>2];f[e+12>>2]=f[m+12>>2];f[e+16>>2]=f[m+16>>2];f[e+20>>2]=f[m+20>>2];f[e+24>>2]=f[m+24>>2];f[e+28>>2]=f[m+28>>2];f[m>>2]=f[H>>2];f[m+4>>2]=f[H+4>>2];f[m+8>>2]=f[H+8>>2];f[m+12>>2]=f[H+12>>2];f[m+16>>2]=f[H+16>>2];f[m+20>>2]=f[H+20>>2];f[m+24>>2]=f[H+24>>2];f[H>>2]=f[e>>2];f[H+4>>2]=f[e+4>>2];f[H+8>>2]=f[e+8>>2];f[H+12>>2]=f[e+12>>2];f[H+16>>2]=f[e+16>>2];f[H+20>>2]=f[e+20>>2];f[H+24>>2]=f[e+24>>2];F=H;G=t+1|0}r=m+32|0;c:do if(r>>>0<F>>>0){p=r;z=F;o=s;y=G;while(1){w=f[o>>2]|0;A=o+8|0;K=o+16|0;Z=p;while(1){Y=f[Z>>2]|0;if((Y|0)==(w|0)){J=Z+8|0;x=f[J>>2]|0;v=f[J+4>>2]|0;J=A;ha=f[J>>2]|0;ia=f[J+4>>2]|0;if((x|0)==(ha|0)&(v|0)==(ia|0)){J=Z+16|0;ja=K;ka=f[J+4>>2]|0;la=f[ja+4>>2]|0;ma=f[J>>2]|0;na=f[ja>>2]|0}else{ka=v;la=ia;ma=x;na=ha}if(!((ka|0)<(la|0)|(ka|0)==(la|0)&ma>>>0<na>>>0)){oa=z;break}}else if((Y|0)>=(w|0)){oa=z;break}Z=Z+32|0}while(1){I=oa;oa=oa+-32|0;Y=f[oa>>2]|0;if((Y|0)!=(w|0))if((Y|0)<(w|0))break;else{oa=oa;continue}Y=I+-24|0;ha=f[Y>>2]|0;x=f[Y+4>>2]|0;Y=A;ia=f[Y>>2]|0;v=f[Y+4>>2]|0;if((ha|0)==(ia|0)&(x|0)==(v|0)){Y=I+-16|0;I=K;pa=f[Y+4>>2]|0;qa=f[I+4>>2]|0;ra=f[Y>>2]|0;sa=f[I>>2]|0}else{pa=x;qa=v;ra=ha;sa=ia}if((pa|0)<(qa|0)|(pa|0)==(qa|0)&ra>>>0<sa>>>0)break}if(Z>>>0>oa>>>0){ta=Z;ua=o;va=y;break c};f[e>>2]=f[Z>>2];f[e+4>>2]=f[Z+4>>2];f[e+8>>2]=f[Z+8>>2];f[e+12>>2]=f[Z+12>>2];f[e+16>>2]=f[Z+16>>2];f[e+20>>2]=f[Z+20>>2];f[e+24>>2]=f[Z+24>>2];f[e+28>>2]=f[Z+28>>2];f[Z>>2]=f[oa>>2];f[Z+4>>2]=f[oa+4>>2];f[Z+8>>2]=f[oa+8>>2];f[Z+12>>2]=f[oa+12>>2];f[Z+16>>2]=f[oa+16>>2];f[Z+20>>2]=f[oa+20>>2];f[Z+24>>2]=f[oa+24>>2];f[oa>>2]=f[e>>2];f[oa+4>>2]=f[e+4>>2];f[oa+8>>2]=f[e+8>>2];f[oa+12>>2]=f[e+12>>2];f[oa+16>>2]=f[e+16>>2];f[oa+20>>2]=f[e+20>>2];f[oa+24>>2]=f[e+24>>2];p=Z+32|0;z=oa;o=(o|0)==(Z|0)?oa:o;y=y+1|0}}else{ta=r;ua=s;va=G}while(0);do if((ta|0)==(ua|0))wa=va;else{r=f[ua>>2]|0;y=f[ta>>2]|0;if((r|0)==(y|0)){o=ua+8|0;z=f[o>>2]|0;p=f[o+4>>2]|0;o=ta+8|0;K=f[o>>2]|0;A=f[o+4>>2]|0;if((z|0)==(K|0)&(p|0)==(A|0)){o=ua+16|0;w=ta+16|0;xa=f[o+4>>2]|0;ya=f[w+4>>2]|0;za=f[o>>2]|0;Aa=f[w>>2]|0}else{xa=p;ya=A;za=z;Aa=K}if(!((xa|0)<(ya|0)|(xa|0)==(ya|0)&za>>>0<Aa>>>0)){wa=va;break}}else if((r|0)>=(y|0)){wa=va;break};f[e>>2]=f[ta>>2];f[e+4>>2]=f[ta+4>>2];f[e+8>>2]=f[ta+8>>2];f[e+12>>2]=f[ta+12>>2];f[e+16>>2]=f[ta+16>>2];f[e+20>>2]=f[ta+20>>2];f[e+24>>2]=f[ta+24>>2];f[e+28>>2]=f[ta+28>>2];f[ta>>2]=f[ua>>2];f[ta+4>>2]=f[ua+4>>2];f[ta+8>>2]=f[ua+8>>2];f[ta+12>>2]=f[ua+12>>2];f[ta+16>>2]=f[ua+16>>2];f[ta+20>>2]=f[ua+20>>2];f[ta+24>>2]=f[ua+24>>2];f[ua>>2]=f[e>>2];f[ua+4>>2]=f[e+4>>2];f[ua+8>>2]=f[e+8>>2];f[ua+12>>2]=f[e+12>>2];f[ua+16>>2]=f[e+16>>2];f[ua+20>>2]=f[e+20>>2];f[ua+24>>2]=f[e+24>>2];wa=va+1|0}while(0);if(!wa){Ba=L8(m,ta,c)|0;y=ta+32|0;if(L8(y,a,c)|0){q=106;break}if(Ba){l=y;continue}}y=ta;if((y-n|0)>=(b-y|0)){q=105;break}G8(m,ta,c);l=ta+32|0}if((q|0)==105){q=0;G8(ta+32|0,a,c);g=m;a=ta;continue}else if((q|0)==106){q=0;if(Ba){q=107;break}else{g=m;a=ta;continue}}}if((q|0)==5){ta=f[h>>2]|0;g=f[m>>2]|0;if((ta|0)==(g|0)){Ba=j;j=f[Ba>>2]|0;n=f[Ba+4>>2]|0;Ba=m+8|0;wa=f[Ba>>2]|0;va=f[Ba+4>>2]|0;if((j|0)==(wa|0)&(n|0)==(va|0)){Ba=k;k=m+16|0;Ca=f[Ba+4>>2]|0;Da=f[k+4>>2]|0;Ea=f[Ba>>2]|0;Fa=f[k>>2]|0}else{Ca=n;Da=va;Ea=j;Fa=wa}if(!((Ca|0)<(Da|0)|(Ca|0)==(Da|0)&Ea>>>0<Fa>>>0)){u=d;return}}else if((ta|0)>=(g|0)){u=d;return};f[e>>2]=f[m>>2];f[e+4>>2]=f[m+4>>2];f[e+8>>2]=f[m+8>>2];f[e+12>>2]=f[m+12>>2];f[e+16>>2]=f[m+16>>2];f[e+20>>2]=f[m+20>>2];f[e+24>>2]=f[m+24>>2];f[e+28>>2]=f[m+28>>2];f[m>>2]=f[h>>2];f[m+4>>2]=f[h+4>>2];f[m+8>>2]=f[h+8>>2];f[m+12>>2]=f[h+12>>2];f[m+16>>2]=f[h+16>>2];f[m+20>>2]=f[h+20>>2];f[m+24>>2]=f[h+24>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];u=d;return}else if((q|0)==11){I8(m,m+32|0,h,c)|0;u=d;return}else if((q|0)==12){J8(m,m+32|0,m+64|0,h,c)|0;u=d;return}else if((q|0)==13){K8(m,m+32|0,m+64|0,m+96|0,h,c)|0;u=d;return}else if((q|0)==15){h=m+64|0;I8(m,m+32|0,h,c)|0;c=m+96|0;if((c|0)==(a|0)){u=d;return}else{Ga=c;Ha=h}while(1){h=f[Ga>>2]|0;c=f[Ha>>2]|0;if((h|0)==(c|0)){e=Ga+8|0;g=f[e>>2]|0;ta=f[e+4>>2]|0;e=Ha+8|0;Fa=f[e>>2]|0;Ea=f[e+4>>2]|0;if((g|0)==(Fa|0)&(ta|0)==(Ea|0)){e=Ga+16|0;Da=Ha+16|0;Ia=f[e+4>>2]|0;Ja=f[Da+4>>2]|0;Ka=f[e>>2]|0;La=f[Da>>2]|0}else{Ia=ta;Ja=Ea;Ka=g;La=Fa}if((Ia|0)<(Ja|0)|(Ia|0)==(Ja|0)&Ka>>>0<La>>>0){Ma=g;Na=ta;q=22}}else if((h|0)<(c|0)){c=Ga+8|0;Ma=f[c>>2]|0;Na=f[c+4>>2]|0;q=22}if((q|0)==22){q=0;c=f[Ga+4>>2]|0;ta=Ga+16|0;g=f[ta>>2]|0;Fa=f[ta+4>>2]|0;ta=f[Ga+24>>2]|0;f[Ga>>2]=f[Ha>>2];f[Ga+4>>2]=f[Ha+4>>2];f[Ga+8>>2]=f[Ha+8>>2];f[Ga+12>>2]=f[Ha+12>>2];f[Ga+16>>2]=f[Ha+16>>2];f[Ga+20>>2]=f[Ha+20>>2];f[Ga+24>>2]=f[Ha+24>>2];d:do if((Ha|0)==(m|0))Oa=m;else{Ea=Ha;while(1){Da=Ea;Ea=Ea+-32|0;e=f[Ea>>2]|0;if((h|0)==(e|0)){Ca=Da+-24|0;wa=f[Ca>>2]|0;j=f[Ca+4>>2]|0;if((Ma|0)==(wa|0)&(Na|0)==(j|0)){Ca=Da+-16|0;Pa=Fa;Qa=f[Ca+4>>2]|0;Ra=g;Sa=f[Ca>>2]|0}else{Pa=Na;Qa=j;Ra=Ma;Sa=wa}if(!((Pa|0)<(Qa|0)|(Pa|0)==(Qa|0)&Ra>>>0<Sa>>>0)){Oa=Da;break d}}else if((h|0)>=(e|0)){Oa=Da;break d};f[Da>>2]=f[Ea>>2];f[Da+4>>2]=f[Ea+4>>2];f[Da+8>>2]=f[Ea+8>>2];f[Da+12>>2]=f[Ea+12>>2];f[Da+16>>2]=f[Ea+16>>2];f[Da+20>>2]=f[Ea+20>>2];f[Da+24>>2]=f[Ea+24>>2];if((Ea|0)==(m|0)){Oa=m;break}}}while(0);f[Oa>>2]=h;f[Oa+4>>2]=c;Ea=Oa+8|0;f[Ea>>2]=Ma;f[Ea+4>>2]=Na;Ea=Oa+16|0;f[Ea>>2]=g;f[Ea+4>>2]=Fa;f[Oa+24>>2]=ta}Ea=Ga+32|0;if((Ea|0)==(a|0))break;else{Da=Ga;Ga=Ea;Ha=Da}}u=d;return}else if((q|0)==107){u=d;return}}function H8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>5;h=g+1|0;if(h>>>0>134217727)gXa(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>4;l=j>>5>>>0<67108863?(k>>>0<h>>>0?h:k):134217727;do if(l)if(l>>>0>134217727){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l<<5)|0;break}else m=0;while(0);k=m+(g<<5)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];f[k+16>>2]=f[b+16>>2];f[k+20>>2]=f[b+20>>2];f[k+24>>2]=f[b+24>>2];f[k+28>>2]=f[b+28>>2];b=k+(0-g<<5)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+32;f[i>>2]=m+(l<<5);if(!d)return;PYa(d);return}function I8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=u;u=u+32|0;e=d;g=f[b>>2]|0;h=f[a>>2]|0;if((g|0)==(h|0)){i=b+8|0;j=f[i>>2]|0;k=f[i+4>>2]|0;i=a+8|0;l=f[i>>2]|0;m=f[i+4>>2]|0;if((j|0)==(l|0)&(k|0)==(m|0)){i=b+16|0;n=a+16|0;o=f[i+4>>2]|0;p=f[n+4>>2]|0;q=f[i>>2]|0;r=f[n>>2]|0}else{o=k;p=m;q=j;r=l}s=(o|0)<(p|0)|(o|0)==(p|0)&q>>>0<r>>>0}else s=(g|0)<(h|0);h=f[c>>2]|0;if((h|0)==(g|0)){r=c+8|0;q=f[r>>2]|0;p=f[r+4>>2]|0;r=b+8|0;o=f[r>>2]|0;l=f[r+4>>2]|0;if((q|0)==(o|0)&(p|0)==(l|0)){r=c+16|0;j=b+16|0;t=f[r+4>>2]|0;v=f[j+4>>2]|0;w=f[r>>2]|0;x=f[j>>2]|0}else{t=p;v=l;w=q;x=o}y=(t|0)<(v|0)|(t|0)==(v|0)&w>>>0<x>>>0}else y=(h|0)<(g|0);if(!s){if(!y){z=0;u=d;return z|0};f[e>>2]=f[b>>2];f[e+4>>2]=f[b+4>>2];f[e+8>>2]=f[b+8>>2];f[e+12>>2]=f[b+12>>2];f[e+16>>2]=f[b+16>>2];f[e+20>>2]=f[b+20>>2];f[e+24>>2]=f[b+24>>2];f[e+28>>2]=f[b+28>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[b+16>>2]=f[c+16>>2];f[b+20>>2]=f[c+20>>2];f[b+24>>2]=f[c+24>>2];f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];f[c+12>>2]=f[e+12>>2];f[c+16>>2]=f[e+16>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];s=f[b>>2]|0;g=f[a>>2]|0;if((s|0)==(g|0)){h=b+8|0;x=f[h>>2]|0;w=f[h+4>>2]|0;h=a+8|0;v=f[h>>2]|0;t=f[h+4>>2]|0;if((x|0)==(v|0)&(w|0)==(t|0)){h=b+16|0;o=a+16|0;A=f[h+4>>2]|0;B=f[o+4>>2]|0;C=f[h>>2]|0;D=f[o>>2]|0}else{A=w;B=t;C=x;D=v}if(!((A|0)<(B|0)|(A|0)==(B|0)&C>>>0<D>>>0)){z=1;u=d;return z|0}}else if((s|0)>=(g|0)){z=1;u=d;return z|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[e+16>>2]=f[a+16>>2];f[e+20>>2]=f[a+20>>2];f[e+24>>2]=f[a+24>>2];f[e+28>>2]=f[a+28>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];f[b+8>>2]=f[e+8>>2];f[b+12>>2]=f[e+12>>2];f[b+16>>2]=f[e+16>>2];f[b+20>>2]=f[e+20>>2];f[b+24>>2]=f[e+24>>2];z=2;u=d;return z|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[e+16>>2]=f[a+16>>2];f[e+20>>2]=f[a+20>>2];f[e+24>>2]=f[a+24>>2];f[e+28>>2]=f[a+28>>2];if(y){f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];f[c+12>>2]=f[e+12>>2];f[c+16>>2]=f[e+16>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];z=1;u=d;return z|0};f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];f[b+8>>2]=f[e+8>>2];f[b+12>>2]=f[e+12>>2];f[b+16>>2]=f[e+16>>2];f[b+20>>2]=f[e+20>>2];f[b+24>>2]=f[e+24>>2];a=f[c>>2]|0;y=f[b>>2]|0;if((a|0)==(y|0)){g=c+8|0;s=f[g>>2]|0;D=f[g+4>>2]|0;g=b+8|0;C=f[g>>2]|0;B=f[g+4>>2]|0;if((s|0)==(C|0)&(D|0)==(B|0)){g=c+16|0;A=b+16|0;E=f[g+4>>2]|0;F=f[A+4>>2]|0;G=f[g>>2]|0;H=f[A>>2]|0}else{E=D;F=B;G=s;H=C}if(!((E|0)<(F|0)|(E|0)==(F|0)&G>>>0<H>>>0)){z=1;u=d;return z|0}}else if((a|0)>=(y|0)){z=1;u=d;return z|0};f[e>>2]=f[b>>2];f[e+4>>2]=f[b+4>>2];f[e+8>>2]=f[b+8>>2];f[e+12>>2]=f[b+12>>2];f[e+16>>2]=f[b+16>>2];f[e+20>>2]=f[b+20>>2];f[e+24>>2]=f[b+24>>2];f[e+28>>2]=f[b+28>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[b+16>>2]=f[c+16>>2];f[b+20>>2]=f[c+20>>2];f[b+24>>2]=f[c+24>>2];f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];f[c+12>>2]=f[e+12>>2];f[c+16>>2]=f[e+16>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];z=2;u=d;return z|0}function J8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+32|0;h=g;i=I8(a,b,c,e)|0;e=f[d>>2]|0;j=f[c>>2]|0;if((e|0)==(j|0)){k=d+8|0;l=f[k>>2]|0;m=f[k+4>>2]|0;k=c+8|0;n=f[k>>2]|0;o=f[k+4>>2]|0;if((l|0)==(n|0)&(m|0)==(o|0)){k=d+16|0;p=c+16|0;q=f[k+4>>2]|0;r=f[p+4>>2]|0;s=f[k>>2]|0;t=f[p>>2]|0}else{q=m;r=o;s=l;t=n}if(!((q|0)<(r|0)|(q|0)==(r|0)&s>>>0<t>>>0)){v=i;u=g;return v|0}}else if((e|0)>=(j|0)){v=i;u=g;return v|0};f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];f[h+8>>2]=f[c+8>>2];f[h+12>>2]=f[c+12>>2];f[h+16>>2]=f[c+16>>2];f[h+20>>2]=f[c+20>>2];f[h+24>>2]=f[c+24>>2];f[h+28>>2]=f[c+28>>2];f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];f[c+8>>2]=f[d+8>>2];f[c+12>>2]=f[d+12>>2];f[c+16>>2]=f[d+16>>2];f[c+20>>2]=f[d+20>>2];f[c+24>>2]=f[d+24>>2];f[d>>2]=f[h>>2];f[d+4>>2]=f[h+4>>2];f[d+8>>2]=f[h+8>>2];f[d+12>>2]=f[h+12>>2];f[d+16>>2]=f[h+16>>2];f[d+20>>2]=f[h+20>>2];f[d+24>>2]=f[h+24>>2];d=i+1|0;j=f[c>>2]|0;e=f[b>>2]|0;if((j|0)==(e|0)){t=c+8|0;s=f[t>>2]|0;r=f[t+4>>2]|0;t=b+8|0;q=f[t>>2]|0;n=f[t+4>>2]|0;if((s|0)==(q|0)&(r|0)==(n|0)){t=c+16|0;l=b+16|0;w=f[t+4>>2]|0;x=f[l+4>>2]|0;y=f[t>>2]|0;z=f[l>>2]|0}else{w=r;x=n;y=s;z=q}if(!((w|0)<(x|0)|(w|0)==(x|0)&y>>>0<z>>>0)){v=d;u=g;return v|0}}else if((j|0)>=(e|0)){v=d;u=g;return v|0};f[h>>2]=f[b>>2];f[h+4>>2]=f[b+4>>2];f[h+8>>2]=f[b+8>>2];f[h+12>>2]=f[b+12>>2];f[h+16>>2]=f[b+16>>2];f[h+20>>2]=f[b+20>>2];f[h+24>>2]=f[b+24>>2];f[h+28>>2]=f[b+28>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[b+16>>2]=f[c+16>>2];f[b+20>>2]=f[c+20>>2];f[b+24>>2]=f[c+24>>2];f[c>>2]=f[h>>2];f[c+4>>2]=f[h+4>>2];f[c+8>>2]=f[h+8>>2];f[c+12>>2]=f[h+12>>2];f[c+16>>2]=f[h+16>>2];f[c+20>>2]=f[h+20>>2];f[c+24>>2]=f[h+24>>2];c=i+2|0;d=f[b>>2]|0;e=f[a>>2]|0;if((d|0)==(e|0)){j=b+8|0;z=f[j>>2]|0;y=f[j+4>>2]|0;j=a+8|0;x=f[j>>2]|0;w=f[j+4>>2]|0;if((z|0)==(x|0)&(y|0)==(w|0)){j=b+16|0;q=a+16|0;A=f[j+4>>2]|0;B=f[q+4>>2]|0;C=f[j>>2]|0;D=f[q>>2]|0}else{A=y;B=w;C=z;D=x}if(!((A|0)<(B|0)|(A|0)==(B|0)&C>>>0<D>>>0)){v=c;u=g;return v|0}}else if((d|0)>=(e|0)){v=c;u=g;return v|0};f[h>>2]=f[a>>2];f[h+4>>2]=f[a+4>>2];f[h+8>>2]=f[a+8>>2];f[h+12>>2]=f[a+12>>2];f[h+16>>2]=f[a+16>>2];f[h+20>>2]=f[a+20>>2];f[h+24>>2]=f[a+24>>2];f[h+28>>2]=f[a+28>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[b>>2]=f[h>>2];f[b+4>>2]=f[h+4>>2];f[b+8>>2]=f[h+8>>2];f[b+12>>2]=f[h+12>>2];f[b+16>>2]=f[h+16>>2];f[b+20>>2]=f[h+20>>2];f[b+24>>2]=f[h+24>>2];v=i+3|0;u=g;return v|0}function K8(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=u;u=u+32|0;i=h;j=J8(a,b,c,d,g)|0;g=f[e>>2]|0;k=f[d>>2]|0;if((g|0)==(k|0)){l=e+8|0;m=f[l>>2]|0;n=f[l+4>>2]|0;l=d+8|0;o=f[l>>2]|0;p=f[l+4>>2]|0;if((m|0)==(o|0)&(n|0)==(p|0)){l=e+16|0;q=d+16|0;r=f[l+4>>2]|0;s=f[q+4>>2]|0;t=f[l>>2]|0;v=f[q>>2]|0}else{r=n;s=p;t=m;v=o}if(!((r|0)<(s|0)|(r|0)==(s|0)&t>>>0<v>>>0)){w=j;u=h;return w|0}}else if((g|0)>=(k|0)){w=j;u=h;return w|0};f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[i+8>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];f[i+16>>2]=f[d+16>>2];f[i+20>>2]=f[d+20>>2];f[i+24>>2]=f[d+24>>2];f[i+28>>2]=f[d+28>>2];f[d>>2]=f[e>>2];f[d+4>>2]=f[e+4>>2];f[d+8>>2]=f[e+8>>2];f[d+12>>2]=f[e+12>>2];f[d+16>>2]=f[e+16>>2];f[d+20>>2]=f[e+20>>2];f[d+24>>2]=f[e+24>>2];f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];f[e+16>>2]=f[i+16>>2];f[e+20>>2]=f[i+20>>2];f[e+24>>2]=f[i+24>>2];e=j+1|0;k=f[d>>2]|0;g=f[c>>2]|0;if((k|0)==(g|0)){v=d+8|0;t=f[v>>2]|0;s=f[v+4>>2]|0;v=c+8|0;r=f[v>>2]|0;o=f[v+4>>2]|0;if((t|0)==(r|0)&(s|0)==(o|0)){v=d+16|0;m=c+16|0;x=f[v+4>>2]|0;y=f[m+4>>2]|0;z=f[v>>2]|0;A=f[m>>2]|0}else{x=s;y=o;z=t;A=r}if(!((x|0)<(y|0)|(x|0)==(y|0)&z>>>0<A>>>0)){w=e;u=h;return w|0}}else if((k|0)>=(g|0)){w=e;u=h;return w|0};f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];f[i+8>>2]=f[c+8>>2];f[i+12>>2]=f[c+12>>2];f[i+16>>2]=f[c+16>>2];f[i+20>>2]=f[c+20>>2];f[i+24>>2]=f[c+24>>2];f[i+28>>2]=f[c+28>>2];f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];f[c+8>>2]=f[d+8>>2];f[c+12>>2]=f[d+12>>2];f[c+16>>2]=f[d+16>>2];f[c+20>>2]=f[d+20>>2];f[c+24>>2]=f[d+24>>2];f[d>>2]=f[i>>2];f[d+4>>2]=f[i+4>>2];f[d+8>>2]=f[i+8>>2];f[d+12>>2]=f[i+12>>2];f[d+16>>2]=f[i+16>>2];f[d+20>>2]=f[i+20>>2];f[d+24>>2]=f[i+24>>2];d=j+2|0;e=f[c>>2]|0;g=f[b>>2]|0;if((e|0)==(g|0)){k=c+8|0;A=f[k>>2]|0;z=f[k+4>>2]|0;k=b+8|0;y=f[k>>2]|0;x=f[k+4>>2]|0;if((A|0)==(y|0)&(z|0)==(x|0)){k=c+16|0;r=b+16|0;B=f[k+4>>2]|0;C=f[r+4>>2]|0;D=f[k>>2]|0;E=f[r>>2]|0}else{B=z;C=x;D=A;E=y}if(!((B|0)<(C|0)|(B|0)==(C|0)&D>>>0<E>>>0)){w=d;u=h;return w|0}}else if((e|0)>=(g|0)){w=d;u=h;return w|0};f[i>>2]=f[b>>2];f[i+4>>2]=f[b+4>>2];f[i+8>>2]=f[b+8>>2];f[i+12>>2]=f[b+12>>2];f[i+16>>2]=f[b+16>>2];f[i+20>>2]=f[b+20>>2];f[i+24>>2]=f[b+24>>2];f[i+28>>2]=f[b+28>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[b+16>>2]=f[c+16>>2];f[b+20>>2]=f[c+20>>2];f[b+24>>2]=f[c+24>>2];f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];c=j+3|0;d=f[b>>2]|0;g=f[a>>2]|0;if((d|0)==(g|0)){e=b+8|0;E=f[e>>2]|0;D=f[e+4>>2]|0;e=a+8|0;C=f[e>>2]|0;B=f[e+4>>2]|0;if((E|0)==(C|0)&(D|0)==(B|0)){e=b+16|0;y=a+16|0;F=f[e+4>>2]|0;G=f[y+4>>2]|0;H=f[e>>2]|0;I=f[y>>2]|0}else{F=D;G=B;H=E;I=C}if(!((F|0)<(G|0)|(F|0)==(G|0)&H>>>0<I>>>0)){w=c;u=h;return w|0}}else if((d|0)>=(g|0)){w=c;u=h;return w|0};f[i>>2]=f[a>>2];f[i+4>>2]=f[a+4>>2];f[i+8>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[b>>2]=f[i>>2];f[b+4>>2]=f[i+4>>2];f[b+8>>2]=f[i+8>>2];f[b+12>>2]=f[i+12>>2];f[b+16>>2]=f[i+16>>2];f[b+20>>2]=f[i+20>>2];f[b+24>>2]=f[i+24>>2];w=j+4|0;u=h;return w|0}function L8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=u;u=u+32|0;e=d;switch(b-a>>5|0){case 2:{g=b+-32|0;h=f[g>>2]|0;i=f[a>>2]|0;if((h|0)==(i|0)){j=b+-24|0;k=f[j>>2]|0;l=f[j+4>>2]|0;j=a+8|0;m=f[j>>2]|0;n=f[j+4>>2]|0;if((k|0)==(m|0)&(l|0)==(n|0)){j=b+-16|0;o=a+16|0;p=f[j+4>>2]|0;q=f[o+4>>2]|0;r=f[j>>2]|0;s=f[o>>2]|0}else{p=l;q=n;r=k;s=m}if(!((p|0)<(q|0)|(p|0)==(q|0)&r>>>0<s>>>0)){t=1;u=d;return t|0}}else if((h|0)>=(i|0)){t=1;u=d;return t|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[e+16>>2]=f[a+16>>2];f[e+20>>2]=f[a+20>>2];f[e+24>>2]=f[a+24>>2];f[e+28>>2]=f[a+28>>2];f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2];f[a+8>>2]=f[g+8>>2];f[a+12>>2]=f[g+12>>2];f[a+16>>2]=f[g+16>>2];f[a+20>>2]=f[g+20>>2];f[a+24>>2]=f[g+24>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];f[g+16>>2]=f[e+16>>2];f[g+20>>2]=f[e+20>>2];f[g+24>>2]=f[e+24>>2];t=1;u=d;return t|0}case 3:{I8(a,a+32|0,b+-32|0,c)|0;t=1;u=d;return t|0}case 4:{J8(a,a+32|0,a+64|0,b+-32|0,c)|0;t=1;u=d;return t|0}case 5:{K8(a,a+32|0,a+64|0,a+96|0,b+-32|0,c)|0;t=1;u=d;return t|0}case 1:case 0:{t=1;u=d;return t|0}default:{g=a+64|0;I8(a,a+32|0,g,c)|0;c=a+96|0;a:do if((c|0)==(b|0)){v=1;w=0}else{i=0;h=c;s=g;while(1){r=f[h>>2]|0;q=f[s>>2]|0;if((r|0)==(q|0)){p=h+8|0;m=f[p>>2]|0;k=f[p+4>>2]|0;p=s+8|0;n=f[p>>2]|0;l=f[p+4>>2]|0;if((m|0)==(n|0)&(k|0)==(l|0)){p=h+16|0;o=s+16|0;x=f[p+4>>2]|0;y=f[o+4>>2]|0;z=f[p>>2]|0;A=f[o>>2]|0}else{x=k;y=l;z=m;A=n}if((x|0)<(y|0)|(x|0)==(y|0)&z>>>0<A>>>0){B=m;C=k;D=19}else E=i}else if((r|0)<(q|0)){q=h+8|0;B=f[q>>2]|0;C=f[q+4>>2]|0;D=19}else E=i;if((D|0)==19){D=0;q=f[h+4>>2]|0;k=h+16|0;m=f[k>>2]|0;n=f[k+4>>2]|0;k=h+24|0;l=f[k+4>>2]|0;o=e;f[o>>2]=f[k>>2];f[o+4>>2]=l;f[h>>2]=f[s>>2];f[h+4>>2]=f[s+4>>2];f[h+8>>2]=f[s+8>>2];f[h+12>>2]=f[s+12>>2];f[h+16>>2]=f[s+16>>2];f[h+20>>2]=f[s+20>>2];f[h+24>>2]=f[s+24>>2];b:do if((s|0)==(a|0))F=a;else{l=s;while(1){o=l;l=l+-32|0;k=f[l>>2]|0;if((r|0)==(k|0)){p=o+-24|0;j=f[p>>2]|0;G=f[p+4>>2]|0;if((B|0)==(j|0)&(C|0)==(G|0)){p=o+-16|0;H=n;I=f[p+4>>2]|0;J=m;K=f[p>>2]|0}else{H=C;I=G;J=B;K=j}if(!((H|0)<(I|0)|(H|0)==(I|0)&J>>>0<K>>>0)){F=o;break b}}else if((r|0)>=(k|0)){F=o;break b};f[o>>2]=f[l>>2];f[o+4>>2]=f[l+4>>2];f[o+8>>2]=f[l+8>>2];f[o+12>>2]=f[l+12>>2];f[o+16>>2]=f[l+16>>2];f[o+20>>2]=f[l+20>>2];f[o+24>>2]=f[l+24>>2];if((l|0)==(a|0)){F=a;break}}}while(0);f[F>>2]=r;f[F+4>>2]=q;l=F+8|0;f[l>>2]=B;f[l+4>>2]=C;l=F+16|0;f[l>>2]=m;f[l+4>>2]=n;f[F+24>>2]=f[e>>2];l=i+1|0;if((l|0)==8){v=0;w=(h+32|0)==(b|0);break a}else E=l}l=h+32|0;if((l|0)==(b|0)){v=1;w=0;break}else{o=h;i=E;h=l;s=o}}}while(0);t=w|v;u=d;return t|0}}return 0}function M8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>5>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>134217727){g=De(8)|0;UYa(g,358155);f[g>>2]=130560;Of(g|0,21520,875)}g=(f[e>>2]|0)-d|0;h=g>>5;i=NYa(b<<5)|0;j=i+(h<<5)|0;k=j+(0-h<<5)|0;if((g|0)>0)K1a(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<5);if(!d)return;PYa(d);return}function N8(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;j=u;u=u+160|0;k=j+152|0;l=j+96|0;m=j+64|0;n=j;_$(k,51744);do if((NS(a)|0)==65536){o=f[a+4>>2]|0;f[l>>2]=f[o>>2];p=l+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=l+8|0;f[r>>2]=f[o+8>>2];f[l+12>>2]=f[o+12>>2];f[l+16>>2]=f[o+16>>2];f[l+20>>2]=f[o+20>>2];f[l+24>>2]=f[o+24>>2];f[l+28>>2]=f[o+28>>2];f[l+32>>2]=f[o+32>>2];s=f[o+36>>2]|0;f[l+36>>2]=s;f[l+40>>2]=r;r=l+48|0;t=l+44|0;f[t>>2]=r;f[r>>2]=0;f[l+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[p>>2]=0;BR(l,o);break}}else OR(l,a,-1);while(0);if((h|0)==16)v=(f[l>>2]&7|0)==0?16:8;else v=h;if((g|0)>=32768){f[m>>2]=0;f[m+4>>2]=0;w=c$(m,26)|0;x=223829;y=w+26|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));j$(-215,m,223856,223392,1856);d$(m)}if(i>>>0>=17){f[m>>2]=0;f[m+4>>2]=0;w=c$(m,31)|0;x=223629;y=w+31|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));j$(-215,m,223856,223392,1857);d$(m)}MS(e,m,f[l>>2]&4095,0);e=f[c>>2]|0;x=((e|0)<0)<<31>>31;w=f[c+4>>2]|0;c=((w|0)<0)<<31>>31;y=n;f[y>>2]=e;f[y+4>>2]=x;y=n+8|0;f[y>>2]=w;f[y+4>>2]=c;y=f[d>>2]|0;h=((y|0)<0)<<31>>31;a=n+16|0;f[a>>2]=y;f[a+4>>2]=h;a=n+24|0;f[a>>2]=w;f[a+4>>2]=c;c=f[d+4>>2]|0;d=((c|0)<0)<<31>>31;a=n+32|0;f[a>>2]=y;f[a+4>>2]=h;h=n+40|0;f[h>>2]=c;f[h+4>>2]=d;h=n+48|0;f[h>>2]=e;f[h+4>>2]=x;x=n+56|0;f[x>>2]=c;f[x+4>>2]=d;if((g|0)>-1)D8(l,n,4,1,m,g,v,i);else y8(l,n,4,m,v,i);i=l+36|0;v=f[i>>2]|0;if(v|0?(m=v+12|0,v=f[m>>2]|0,f[m>>2]=v+-1,(v|0)==1):0)CR(l);f[i>>2]=0;i=l+16|0;v=l+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[v>>2]|0)>0){i=f[l+40>>2]|0;m=0;do{f[i+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[v>>2]|0))}v=f[l+44>>2]|0;if((v|0)!=(l+48|0))ZF(v);if(!(f[k+4>>2]|0)){u=j;return}u=j;return}function O8(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;j=u;u=u+144|0;k=j+128|0;l=j+72|0;m=j+32|0;n=j+16|0;o=j;p=j+64|0;_$(k,51764);do if((NS(a)|0)==65536){q=f[a+4>>2]|0;f[l>>2]=f[q>>2];r=l+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=l+8|0;f[t>>2]=f[q+8>>2];f[l+12>>2]=f[q+12>>2];f[l+16>>2]=f[q+16>>2];f[l+20>>2]=f[q+20>>2];f[l+24>>2]=f[q+24>>2];f[l+28>>2]=f[q+28>>2];f[l+32>>2]=f[q+32>>2];v=f[q+36>>2]|0;f[l+36>>2]=v;f[l+40>>2]=t;t=l+48|0;w=l+44|0;f[w>>2]=t;f[t>>2]=0;f[l+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[r>>2]=0;BR(l,q);break}}else OR(l,a,-1);while(0);if((h|0)==16)x=(f[l>>2]&7|0)==0?16:8;else x=h;if(!((i|0)<17&((g|0)<32768&(i|d|0)>-1))){f[m>>2]=0;f[m+4>>2]=0;h=c$(m,76)|0;a=223948;q=h+76|0;do{b[h>>0]=b[a>>0]|0;h=h+1|0;a=a+1|0}while((h|0)<(q|0));j$(-215,m,224025,223392,1902);d$(m)}MS(e,m,f[l>>2]&4095,0);if((i|0)>0|((g|0)>1|(x|0)!=8)){e=f[c>>2]|0;a=f[c+4>>2]|0;h=16-i|0;i=R1a(e|0,((e|0)<0)<<31>>31|0,h|0)|0;e=J;q=R1a(a|0,((a|0)<0)<<31>>31|0,h|0)|0;a=J;r=R1a(d|0,((d|0)<0)<<31>>31|0,h|0)|0;h=J;s=n;f[s>>2]=i;f[s+4>>2]=e;e=n+8|0;f[e>>2]=q;f[e+4>>2]=a;a=o;f[a>>2]=r;f[a+4>>2]=h;a=o+8|0;f[a>>2]=r;f[a+4>>2]=h;A8(l,n,o,0,0,360,m,g,x)}else{f[p>>2]=f[c>>2];f[p+4>>2]=f[c+4>>2];z8(l,p,d,m,g>>>31)}g=l+36|0;m=f[g>>2]|0;if(m|0?(d=m+12|0,m=f[d>>2]|0,f[d>>2]=m+-1,(m|0)==1):0)CR(l);f[g>>2]=0;g=l+16|0;m=l+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[m>>2]|0)>0){g=f[l+40>>2]|0;d=0;do{f[g+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))ZF(m);if(!(f[k+4>>2]|0)){u=j;return}u=j;return}function P8(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;m=u;u=u+128|0;n=m+120|0;o=m+64|0;p=m+32|0;q=m+16|0;r=m;_$(n,51784);do if((NS(a)|0)==65536){s=f[a+4>>2]|0;f[o>>2]=f[s>>2];t=o+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=o+8|0;f[w>>2]=f[s+8>>2];f[o+12>>2]=f[s+12>>2];f[o+16>>2]=f[s+16>>2];f[o+20>>2]=f[s+20>>2];f[o+24>>2]=f[s+24>>2];f[o+28>>2]=f[s+28>>2];f[o+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[o+36>>2]=x;f[o+40>>2]=w;w=o+48|0;y=o+44|0;f[y>>2]=w;f[w>>2]=0;f[o+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[t>>2]=0;BR(o,s);break}}else OR(o,a,-1);while(0);if((k|0)==16)z=(f[o>>2]&7|0)==0?16:8;else z=k;if(!((f[d>>2]|0)>-1?(l|0)<17&((j|0)<32768?(f[d+4>>2]|l|0)>-1:0):0)){f[p>>2]=0;f[p+4>>2]=0;k=c$(p,100)|0;a=224109;s=k+100|0;do{b[k>>0]=b[a>>0]|0;k=k+1|0;a=a+1|0}while((k|0)<(s|0));j$(-215,p,224210,223392,1934);d$(p)}MS(i,p,f[o>>2]&4095,0);i=rNa(e)|0;a=rNa(g)|0;k=rNa(h)|0;s=f[c>>2]|0;t=f[c+4>>2]|0;c=f[d>>2]|0;v=f[d+4>>2]|0;d=16-l|0;l=R1a(s|0,((s|0)<0)<<31>>31|0,d|0)|0;s=J;w=R1a(t|0,((t|0)<0)<<31>>31|0,d|0)|0;t=J;y=R1a(c|0,((c|0)<0)<<31>>31|0,d|0)|0;c=J;x=R1a(v|0,((v|0)<0)<<31>>31|0,d|0)|0;d=q;f[d>>2]=l;f[d+4>>2]=s;s=q+8|0;f[s>>2]=w;f[s+4>>2]=t;t=r;f[t>>2]=y;f[t+4>>2]=c;c=r+8|0;f[c>>2]=x;f[c+4>>2]=J;A8(o,q,r,i,a,k,p,j,z);z=o+36|0;j=f[z>>2]|0;if(j|0?(p=j+12|0,j=f[p>>2]|0,f[p>>2]=j+-1,(j|0)==1):0)CR(o);f[z>>2]=0;z=o+16|0;j=o+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[j>>2]|0)>0){z=f[o+40>>2]|0;p=0;do{f[z+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[j>>2]|0))}j=f[o+44>>2]|0;if((j|0)!=(o+48|0))ZF(j);if(!(f[n+4>>2]|0)){u=m;return}u=m;return}function Q8(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0.0,y=0;h=u;u=u+128|0;i=h+120|0;j=h+64|0;k=h+32|0;l=h+16|0;m=h;_$(i,51804);do if((NS(a)|0)==65536){o=f[a+4>>2]|0;f[j>>2]=f[o>>2];p=j+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=j+8|0;f[r>>2]=f[o+8>>2];f[j+12>>2]=f[o+12>>2];f[j+16>>2]=f[o+16>>2];f[j+20>>2]=f[o+20>>2];f[j+24>>2]=f[o+24>>2];f[j+28>>2]=f[o+28>>2];f[j+32>>2]=f[o+32>>2];s=f[o+36>>2]|0;f[j+36>>2]=s;f[j+40>>2]=r;r=j+48|0;t=j+44|0;f[t>>2]=r;f[r>>2]=0;f[j+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[p>>2]=0;BR(j,o);break}}else OR(j,a,-1);while(0);if((g|0)==16)v=(f[j>>2]&7|0)==0?16:8;else v=g;g=c+8|0;if(!(+n[g>>2]>=0.0?((e|0)<32768?+n[c+12>>2]>=0.0:0):0)){f[k>>2]=0;f[k+4>>2]=0;a=c$(k,73)|0;o=224321;p=a+73|0;do{b[a>>0]=b[o>>0]|0;a=a+1|0;o=o+1|0}while((a|0)<(p|0));j$(-215,k,224210,223392,1964);d$(k)}MS(d,k,f[j>>2]&4095,0);d=wNa(+n[c+16>>2])|0;w=+n[c>>2];o=wNa(w)|0;x=+n[c+4>>2];a=wNa(x)|0;p=R1a(o|0,((o|0)<0)<<31>>31|0,16)|0;q=J;r=wNa((w-+(o|0))*65536.0)|0;o=C1a(r|0,((r|0)<0)<<31>>31|0,p|0,q|0)|0;q=J;p=R1a(a|0,((a|0)<0)<<31>>31|0,16)|0;r=J;t=wNa((x-+(a|0))*65536.0)|0;a=C1a(t|0,((t|0)<0)<<31>>31|0,p|0,r|0)|0;r=J;x=+n[g>>2];g=wNa(x)|0;w=+n[c+12>>2];c=wNa(w)|0;p=R1a(g|0,((g|0)<0)<<31>>31|0,15)|0;t=J;s=wNa((x-+(g|0))*32768.0)|0;g=C1a(s|0,((s|0)<0)<<31>>31|0,p|0,t|0)|0;t=J;p=R1a(c|0,((c|0)<0)<<31>>31|0,15)|0;s=J;y=wNa((w-+(c|0))*32768.0)|0;c=C1a(y|0,((y|0)<0)<<31>>31|0,p|0,s|0)|0;s=l;f[s>>2]=o;f[s+4>>2]=q;q=l+8|0;f[q>>2]=a;f[q+4>>2]=r;r=m;f[r>>2]=g;f[r+4>>2]=t;t=m+8|0;f[t>>2]=c;f[t+4>>2]=J;A8(j,l,m,d,0,360,k,e,v);v=j+36|0;e=f[v>>2]|0;if(e|0?(k=e+12|0,e=f[k>>2]|0,f[k>>2]=e+-1,(e|0)==1):0)CR(j);f[v>>2]=0;v=j+16|0;e=j+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[e>>2]|0)>0){v=f[j+40>>2]|0;k=0;do{f[v+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[e>>2]|0))}e=f[j+44>>2]|0;if((e|0)!=(j+48|0))ZF(e);if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function R8(a,c,d,e,g,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0;m=u;u=u+128|0;n=m+120|0;o=m+64|0;p=m+16|0;q=m+48|0;r=m;_$(n,51824);s=c+4|0;if(f[s>>2]|0){do if((NS(a)|0)==65536){t=f[a+4>>2]|0;f[o>>2]=f[t>>2];v=o+4|0;w=t+4|0;f[v>>2]=f[w>>2];x=o+8|0;f[x>>2]=f[t+8>>2];f[o+12>>2]=f[t+12>>2];f[o+16>>2]=f[t+16>>2];f[o+20>>2]=f[t+20>>2];f[o+24>>2]=f[t+24>>2];f[o+28>>2]=f[t+28>>2];f[o+32>>2]=f[t+32>>2];y=f[t+36>>2]|0;f[o+36>>2]=y;f[o+40>>2]=x;x=o+48|0;z=o+44|0;f[z>>2]=x;f[x>>2]=0;f[o+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;x=f[z>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[v>>2]=0;BR(o,t);break}}else OR(o,a,-1);while(0);a=S8(e)|0;MS(i,p,f[o>>2]&4095,0);i=0-(f[a>>2]&15)|0;t=rNa(g*65536.0)|0;if((k|0)==16)A=(f[o>>2]&7|0)==0?16:8;else A=k;k=l?0-t|0:t;l=f[d>>2]|0;v=R1a(l|0,((l|0)<0)<<31>>31|0,16)|0;l=J;w=f[d+4>>2]|0;d=R1a(w|0,((w|0)<0)<<31>>31|0,16)|0;w=Y(k,i)|0;i=C1a(d|0,J|0,w|0,((w|0)<0)<<31>>31|0)|0;w=J;f[q>>2]=0;d=q+4|0;f[d>>2]=0;f[q+8>>2]=0;x=q+8|0;z=NYa(16384)|0;y=z;f[q>>2]=y;f[d>>2]=y;f[x>>2]=z+16384;if((f[s>>2]|0)>0){y=(e|0)==3;e=((t|0)<0)<<31>>31;B=((k|0)<0)<<31>>31;C=r+8|0;D=v;v=l;l=0;while(1){E=f[c>>2]|0;F=b[E+l>>0]|0;G=F&255;a:do if(y&F<<24>>24<0){switch(F<<24>>24){case -48:{H=l+1|0;I=b[E+H>>0]|0;if((I+112&255)<48){K=(I&255)+-17|0;L=H;M=127;N=175;break a}else{O=I;P=H}break}case -47:{H=l+1|0;I=b[E+H>>0]|0;if(I<<24>>24<0&(I&255)<144){K=(I&255)+47|0;L=H;M=175;N=191;break a}else{O=I;P=H}break}default:{if((F&255)<=191){K=63;L=l;M=32;N=127;break a}H=l+1|0;I=(b[E+H>>0]|0)==0?l:H;if((F&255)<=223){K=63;L=I;M=32;N=127;break a}H=I+1|0;Q=(b[E+H>>0]|0)==0?I:H;if((F&255)<=239){K=63;L=Q;M=32;N=127;break a}H=Q+1|0;I=(b[E+H>>0]|0)==0?Q:H;if((F&255)<=247){K=63;L=I;M=32;N=127;break a}H=I+1|0;Q=(b[E+H>>0]|0)==0?I:H;if((F&255)<=251){K=63;L=Q;M=32;N=127;break a}H=Q+1|0;K=63;L=(b[E+H>>0]|0)==0?Q:H;M=32;N=127;break a}}K=63;L=O<<24>>24==0?l:P;M=32;N=127}else{K=G;L=l;M=32;N=127}while(0);G=f[59212+(f[a+(((K|0)<(M|0)|(K|0)>=(N|0)?32:K+-31|0)<<2)>>2]<<2)>>2]|0;E=(h[G>>0]|0)+-82|0;F=(h[G+1>>0]|0)+-82|0;H=W1a(F|0,((F|0)<0)<<31>>31|0,t|0,e|0)|0;F=J;Q=W1a(E|0,((E|0)<0)<<31>>31|0,t|0,e|0)|0;E=B1a(D|0,v|0,Q|0,J|0)|0;Q=J;I=f[d>>2]|0;R=f[q>>2]|0;S=I;if(!((I|0)==(R|0)|(S|0)==(R|0)))f[d>>2]=S+(~((S+-16-R|0)>>>4)<<4);R=G+2|0;b:while(1){G=b[R>>0]|0;switch(G<<24>>24){case 0:case 32:break;default:{S=(G&255)+-82|0;I=(h[R+1>>0]|0)+-82|0;T=C1a(W1a(S|0,((S|0)<0)<<31>>31|0,t|0,e|0)|0,J|0,E|0,Q|0)|0;S=J;U=C1a(i|0,w|0,W1a(I|0,((I|0)<0)<<31>>31|0,k|0,B|0)|0,J|0)|0;I=J;V=r;f[V>>2]=T;f[V+4>>2]=S;V=C;f[V>>2]=U;f[V+4>>2]=I;V=f[d>>2]|0;if((V|0)==(f[x>>2]|0))B8(q,r);else{W=V;f[W>>2]=T;f[W+4>>2]=S;S=V+8|0;f[S>>2]=U;f[S+4>>2]=I;f[d>>2]=V+16}R=R+2|0;continue b}}V=f[q>>2]|0;I=(f[d>>2]|0)-V>>4;if(I>>>0>1){D8(o,V,I,0,p,j,A,16);X=b[R>>0]|0}else X=G;if(!(X<<24>>24))break;G=R+1|0;I=f[d>>2]|0;V=f[q>>2]|0;S=I;if((I|0)==(V|0)|(S|0)==(V|0)){R=G;continue}f[d>>2]=S+(~((S+-16-V|0)>>>4)<<4);R=G}D=C1a(E|0,Q|0,H|0,F|0)|0;l=L+1|0;if((l|0)>=(f[s>>2]|0))break;else v=J}v=f[q>>2]|0;if(v|0){Z=v;_=v;$=14}}else{Z=z;_=z;$=14}if(($|0)==14){$=f[d>>2]|0;if(($|0)!=(Z|0))f[d>>2]=$+(~(($+-16-Z|0)>>>4)<<4);PYa(_)}_=o+36|0;Z=f[_>>2]|0;if(Z|0?($=Z+12|0,Z=f[$>>2]|0,f[$>>2]=Z+-1,(Z|0)==1):0)CR(o);f[_>>2]=0;_=o+16|0;Z=o+4|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[Z>>2]|0)>0){_=f[o+40>>2]|0;$=0;do{f[_+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[Z>>2]|0))}Z=f[o+44>>2]|0;if((Z|0)!=(o+48|0))ZF(Z)}if(!(f[n+4>>2]|0)){u=m;return}u=m;return}function S8(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;e=(a&16|0)!=0;switch(a&15){case 0:{g=56324;break}case 1:{g=e?51844:52228;break}case 2:{g=55940;break}case 3:{g=e?52612:52996;break}case 4:{g=e?53636:54020;break}case 5:{g=e?54404:54788;break}case 6:{g=55556;break}case 7:{g=55172;break}default:{f[d>>2]=0;f[d+4>>2]=0;e=c$(d,17)|0;a=224481;h=e+17|0;do{b[e>>0]=b[a>>0]|0;e=e+1|0;a=a+1|0}while((e|0)<(h|0));j$(-211,d,224499,223392,2218);d$(d);g=0}}u=c;return g|0}function T8(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0.0,ka=0.0,la=0.0,ma=0.0;l=u;u=u+368|0;m=l+312|0;n=l+96|0;o=l+64|0;q=l+304|0;r=l+248|0;s=l+192|0;t=l+160|0;v=l+148|0;w=l+136|0;x=l+32|0;y=l;z=l+128|0;_$(q,56708);do if((NS(a)|0)==65536){A=f[a+4>>2]|0;f[r>>2]=f[A>>2];B=r+4|0;C=A+4|0;f[B>>2]=f[C>>2];D=r+8|0;f[D>>2]=f[A+8>>2];f[r+12>>2]=f[A+12>>2];f[r+16>>2]=f[A+16>>2];f[r+20>>2]=f[A+20>>2];f[r+24>>2]=f[A+24>>2];f[r+28>>2]=f[A+28>>2];f[r+32>>2]=f[A+32>>2];E=f[A+36>>2]|0;f[r+36>>2]=E;f[r+40>>2]=D;D=r+48|0;F=r+44|0;f[F>>2]=D;f[D>>2]=0;f[r+52>>2]=0;if(E|0){D=E+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[C>>2]|0)<3){C=f[A+44>>2]|0;D=f[F>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2];break}else{f[B>>2]=0;BR(r,A);break}}else OR(r,a,-1);while(0);do if((NS(i)|0)==65536){a=f[i+4>>2]|0;f[s>>2]=f[a>>2];A=s+4|0;B=a+4|0;f[A>>2]=f[B>>2];C=s+8|0;f[C>>2]=f[a+8>>2];f[s+12>>2]=f[a+12>>2];f[s+16>>2]=f[a+16>>2];f[s+20>>2]=f[a+20>>2];f[s+24>>2]=f[a+24>>2];f[s+28>>2]=f[a+28>>2];f[s+32>>2]=f[a+32>>2];D=f[a+36>>2]|0;f[s+36>>2]=D;f[s+40>>2]=C;C=s+48|0;F=s+44|0;f[F>>2]=C;f[C>>2]=0;f[s+52>>2]=0;if(D|0){C=D+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[B>>2]|0)<3){B=f[a+44>>2]|0;C=f[F>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2];break}else{f[A>>2]=0;BR(s,a);break}}else OR(s,i,-1);while(0);i=f[r+8>>2]|0;a=r+4|0;A=(f[a>>2]|0)==1?1:f[r+12>>2]|0;B=f[r>>2]|0;C=B&4095;F=r+16|0;D=f[F>>2]|0;E=Y((B>>>3&511)+1<<(47696>>>(C<<1&14)&3),A)|0;f[t>>2]=C|1111638016;C=t+4|0;f[C>>2]=E;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=D;f[t+20>>2]=i;f[t+24>>2]=A;A=r+44|0;f[C>>2]=f[f[A>>2]>>2];f[t>>2]=B&20479|1111621632;B=US(c,-1)|0;f[v>>2]=0;C=v+4|0;f[C>>2]=0;f[v+8>>2]=0;f[w>>2]=0;i=w+4|0;f[i>>2]=0;f[w+8>>2]=0;if(B|0){U8(v,B);D=f[i>>2]|0;E=f[w>>2]|0;G=(D-E|0)/20|0;H=E;E=D;if(B>>>0<=G>>>0){if(B>>>0<G>>>0?(D=H+(B*20|0)|0,(E|0)!=(D|0)):0)f[i>>2]=E+(~(((E+-20-D|0)>>>0)/20|0)*20|0)}else V8(w,B-G|0);G=f[v>>2]|0;D=0;do{f[G+(D*56|0)+52>>2]=0;D=D+1|0}while((D|0)!=(B|0));D=(d|0)>-1;if(D){if((B|0)<=(d|0)){f[m>>2]=0;f[m+4>>2]=0;I=c$(m,41)|0;J=224610;K=I+41|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));j$(-215,m,224652,223392,2495);d$(m)}L=d;M=d+1|0}else{L=0;M=B}d=M>>>0>L>>>0;if(d){G=c+4|0;E=m+4|0;H=m+8|0;N=m+12|0;O=m+16|0;P=m+20|0;Q=m+24|0;R=m+28|0;S=m+32|0;T=m+36|0;U=m+40|0;V=m+48|0;W=m+44|0;X=m+52|0;Z=n+4|0;_=L;do{do if((_|0)<0&(NS(c)|0)==65536){$=f[G>>2]|0;f[m>>2]=f[$>>2];aa=$+4|0;f[E>>2]=f[aa>>2];f[H>>2]=f[$+8>>2];f[N>>2]=f[$+12>>2];f[O>>2]=f[$+16>>2];f[P>>2]=f[$+20>>2];f[Q>>2]=f[$+24>>2];f[R>>2]=f[$+28>>2];f[S>>2]=f[$+32>>2];ba=f[$+36>>2]|0;f[T>>2]=ba;f[U>>2]=H;f[W>>2]=V;f[V>>2]=0;f[X>>2]=0;if(ba|0){ca=ba+12|0;f[ca>>2]=(f[ca>>2]|0)+1}if((f[aa>>2]|0)<3){aa=f[$+44>>2]|0;ca=f[W>>2]|0;f[ca>>2]=f[aa>>2];f[ca+4>>2]=f[aa+4>>2];break}else{f[E>>2]=0;BR(m,$);break}}else OR(m,c,_);while(0);if(f[O>>2]|0){$=f[E>>2]|0;if(($|0)<3)da=Y(f[N>>2]|0,f[H>>2]|0)|0;else{aa=f[U>>2]|0;ca=0;ba=1;while(1){ea=Y(f[aa+(ca<<2)>>2]|0,ba)|0;ca=ca+1|0;if((ca|0)==($|0)){da=ea;break}else ba=ea}}if(!(($|0)==0|(da|0)==0)){ba=LS(m,2,4,1)|0;if((ba|0)<=0){f[n>>2]=0;f[Z>>2]=0;I=c$(n,11)|0;J=224665;K=I+11|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));j$(-215,n,224652,223392,2506);d$(n)}EL(20492,56,8,f[O>>2]|0,ba,(f[v>>2]|0)+(_*56|0)|0,(f[w>>2]|0)+(_*20|0)|0)|0}}$=f[T>>2]|0;if($|0?(ca=$+12|0,$=f[ca>>2]|0,f[ca>>2]=$+-1,($|0)==1):0)CR(m);f[T>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[E>>2]|0)>0){$=f[U>>2]|0;ca=0;do{f[$+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[E>>2]|0))}ca=f[W>>2]|0;if((ca|0)!=(V|0))ZF(ca);_=_+1|0}while(_>>>0<M>>>0)}_=s+16|0;V=f[_>>2]|0;do if(V){W=f[s+4>>2]|0;E=(W|0)<3;if(E)fa=Y(f[s+12>>2]|0,f[s+8>>2]|0)|0;else{U=f[s+40>>2]|0;O=0;T=1;while(1){Z=Y(f[U+(O<<2)>>2]|0,T)|0;O=O+1|0;if((O|0)==(W|0)){fa=Z;break}else T=Z}}if(!((j|0)==0|((W|0)==0|(fa|0)==0))){T=M-L|0;if(E)ga=Y(f[s+12>>2]|0,f[s+8>>2]|0)|0;else{O=f[s+40>>2]|0;U=0;Z=1;while(1){da=Y(f[O+(U<<2)>>2]|0,Z)|0;U=U+1|0;if((U|0)==(W|0)){ga=da;break}else Z=da}}if((ga|0)==(B|0)?(f[s>>2]&4095|0)==28:0)ha=V;else{f[m>>2]=0;f[m+4>>2]=0;I=c$(m,95)|0;J=224677;K=I+95|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));j$(-215,m,224652,223392,2520);d$(m);ha=f[_>>2]|0}if((T|0)!=(B|0)){Z=f[ha+(L<<4)+8>>2]|0;if((Z|0)<=-1)break;W8(c,B,ha,Z,v,w);W=f[v>>2]|0;f[W+(L*56|0)+20>>2]=W+(Z*56|0);break}if(d){Z=f[v>>2]|0;W=L;do{U=f[ha+(W<<4)>>2]|0;O=f[ha+(W<<4)+4>>2]|0;E=f[ha+(W<<4)+8>>2]|0;da=f[ha+(W<<4)+12>>2]|0;f[Z+(W*56|0)+12>>2]=U>>>0<B>>>0?Z+(U*56|0)|0:0;f[Z+(W*56|0)+8>>2]=O>>>0<B>>>0?Z+(O*56|0)|0:0;f[Z+(W*56|0)+20>>2]=E>>>0<B>>>0?Z+(E*56|0)|0:0;f[Z+(W*56|0)+16>>2]=da>>>0<B>>>0?Z+(da*56|0)|0:0;W=W+1|0}while((W|0)!=(M|0))}}else ia=60}else ia=60;while(0);if((ia|0)==60?d:0){d=M+-1|0;ia=f[v>>2]|0;B=L;do{ha=B;B=B+1|0;f[ia+(ha*56|0)+12>>2]=ha>>>0<d>>>0?ia+(B*56|0)|0:0;f[ia+(ha*56|0)+8>>2]=ha>>>0>L>>>0?ia+((ha+-1|0)*56|0)|0:0}while((B|0)!=(M|0))}M=(f[v>>2]|0)+(L*56|0)|0;ja=+p[e>>3];p[x>>3]=ja;ka=+p[e+8>>3];p[x+8>>3]=ka;la=+p[e+16>>3];p[x+16>>3]=la;ma=+p[e+24>>3];p[x+24>>3]=ma;p[y>>3]=ja;p[y+8>>3]=ka;p[y+16>>3]=la;p[y+24>>3]=ma;f[z>>2]=f[k>>2];f[z+4>>2]=f[k+4>>2];f[o>>2]=f[x>>2];f[o+4>>2]=f[x+4>>2];f[o+8>>2]=f[x+8>>2];f[o+12>>2]=f[x+12>>2];f[o+16>>2]=f[x+16>>2];f[o+20>>2]=f[x+20>>2];f[o+24>>2]=f[x+24>>2];f[o+28>>2]=f[x+28>>2];f[n>>2]=f[y>>2];f[n+4>>2]=f[y+4>>2];f[n+8>>2]=f[y+8>>2];f[n+12>>2]=f[y+12>>2];f[n+16>>2]=f[y+16>>2];f[n+20>>2]=f[y+20>>2];f[n+24>>2]=f[y+24>>2];f[n+28>>2]=f[y+28>>2];f[m>>2]=f[z>>2];f[m+4>>2]=f[z+4>>2];X8(t,M,o,n,D?0-j|0:j,g,h,m);m=f[w>>2]|0;if(m|0){w=f[i>>2]|0;if((w|0)!=(m|0))f[i>>2]=w+(~(((w+-20-m|0)>>>0)/20|0)*20|0);PYa(m)}}m=f[v>>2]|0;if(m|0){v=f[C>>2]|0;if((v|0)!=(m|0))f[C>>2]=v+(~(((v+-56-m|0)>>>0)/56|0)*56|0);PYa(m)}m=s+36|0;v=f[m>>2]|0;if(v|0?(C=v+12|0,v=f[C>>2]|0,f[C>>2]=v+-1,(v|0)==1):0)CR(s);f[m>>2]=0;m=s+16|0;v=s+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[v>>2]|0)>0){m=f[s+40>>2]|0;C=0;do{f[m+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[v>>2]|0))}v=f[s+44>>2]|0;if((v|0)!=(s+48|0))ZF(v);v=r+36|0;s=f[v>>2]|0;if(s|0?(C=s+12|0,s=f[C>>2]|0,f[C>>2]=s+-1,(s|0)==1):0)CR(r);f[v>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[a>>2]|0)>0){F=f[r+40>>2]|0;v=0;do{f[F+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[a>>2]|0))}a=f[A>>2]|0;if((a|0)!=(r+48|0))ZF(a);if(!(f[q+4>>2]|0)){u=l;return}u=l;return}function U8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/56|0)>>>0>=b>>>0){h=g;i=b;do{j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));h=(f[e>>2]|0)+56|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=(g-i|0)/56|0;g=h+b|0;if(g>>>0>76695844)gXa(a);l=(d-i|0)/56|0;i=l<<1;d=l>>>0<38347922?(i>>>0<g>>>0?g:i):76695844;do if(d)if(d>>>0>76695844){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{m=NYa(d*56|0)|0;break}else m=0;while(0);i=m+(h*56|0)|0;h=m+(d*56|0)|0;d=i;m=b;b=i;do{j=d;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));d=b+56|0;b=d;m=m+-1|0}while((m|0)!=0);m=f[a>>2]|0;d=(f[e>>2]|0)-m|0;j=i+(((d|0)/-56|0)*56|0)|0;if((d|0)>0)K1a(j|0,m|0,d|0)|0;f[a>>2]=j;f[e>>2]=b;f[c>>2]=h;if(!m)return;PYa(m);return}function V8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/20|0)>>>0>=b>>>0){h=g;i=b;do{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;h=(f[e>>2]|0)+20|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=(g-i|0)/20|0;g=h+b|0;if(g>>>0>214748364)gXa(a);j=(d-i|0)/20|0;i=j<<1;d=j>>>0<107374182?(i>>>0<g>>>0?g:i):214748364;do if(d)if(d>>>0>214748364){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{k=NYa(d*20|0)|0;break}else k=0;while(0);i=k+(h*20|0)|0;h=k+(d*20|0)|0;d=i;k=b;b=i;do{f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;d=b+20|0;b=d;k=k+-1|0}while((k|0)!=0);k=f[a>>2]|0;d=(f[e>>2]|0)-k|0;g=i+(((d|0)/-20|0)*20|0)|0;if((d|0)>0)K1a(g|0,k|0,d|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=h;if(!k)return;PYa(k);return}function W8(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+64|0;i=h;if((d|0)<=-1){u=h;return}j=i+16|0;k=i+4|0;l=i+8|0;m=i+12|0;n=i+36|0;o=i+40|0;p=i+44|0;q=i+48|0;r=d;do{OR(i,a,r);d=f[j>>2]|0;s=f[k>>2]|0;if(!d)t=0;else{if((s|0)<3)v=Y(f[m>>2]|0,f[l>>2]|0)|0;else{w=f[o>>2]|0;x=0;y=1;while(1){z=Y(f[w+(x<<2)>>2]|0,y)|0;x=x+1|0;if((x|0)==(s|0)){v=z;break}else y=z}}t=(s|0)==0|(v|0)==0?0:d}if((s|0)<3)A=Y(f[m>>2]|0,f[l>>2]|0)|0;else{y=f[o>>2]|0;x=0;w=1;while(1){z=Y(f[y+(x<<2)>>2]|0,w)|0;x=x+1|0;if((x|0)==(s|0)){A=z;break}else w=z}}EL(20492,56,8,t,A,(f[e>>2]|0)+(r*56|0)|0,(f[g>>2]|0)+(r*20|0)|0)|0;w=c+(r<<4)|0;s=f[w>>2]|0;x=f[c+(r<<4)+4>>2]|0;y=f[c+(r<<4)+8>>2]|0;d=f[c+(r<<4)+12>>2]|0;z=f[e>>2]|0;f[z+(r*56|0)+12>>2]=(s|0)>-1&(s|0)<(b|0)?z+(s*56|0)|0:0;s=f[e>>2]|0;f[s+(r*56|0)+8>>2]=(x|0)>-1&(x|0)<(b|0)?s+(x*56|0)|0:0;x=(y|0)>-1;s=f[e>>2]|0;f[s+(r*56|0)+20>>2]=x&(y|0)<(b|0)?s+(y*56|0)|0:0;s=f[e>>2]|0;f[s+(r*56|0)+16>>2]=(d|0)>-1&(d|0)<(b|0)?s+(d*56|0)|0:0;if(x)W8(a,b,c,y,e,g);y=f[n>>2]|0;if(y|0?(x=y+12|0,y=f[x>>2]|0,f[x>>2]=y+-1,(y|0)==1):0)CR(i);f[n>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[k>>2]|0)>0){y=f[o>>2]|0;x=0;do{f[y+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[k>>2]|0))}x=f[p>>2]|0;if((x|0)!=(q|0))ZF(x);r=f[w>>2]|0}while((r|0)>-1);u=h;return}function X8(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0;l=u;u=u+384|0;m=l+368|0;n=l+356|0;o=l+344|0;q=l+208|0;r=l+176|0;s=l+288|0;t=l+144|0;v=l+112|0;w=l+256|0;x=l+80|0;y=l+96|0;z=l+64|0;A=l+48|0;B=l+32|0;C=l+248|0;D=l+16|0;E=l;F=l+240|0;f[n>>2]=0;G=n+4|0;f[G>>2]=0;f[n+8>>2]=0;f[o>>2]=0;H=o+4|0;f[H>>2]=0;f[o+8>>2]=0;I=+p[d+8>>3];J=+p[d+16>>3];K=+p[d+24>>3];p[q>>3]=+p[d>>3];p[q+8>>3]=I;p[q+16>>3]=J;p[q+24>>3]=K;K=+p[e+8>>3];J=+p[e+16>>3];I=+p[e+24>>3];p[r>>3]=+p[e>>3];p[r+8>>3]=K;p[r+16>>3]=J;p[r+24>>3]=I;JR(s,a,0,1,0,0);a=f[k>>2]|0;e=f[k+4>>2]|0;if((j|0)==16)L=(f[s>>2]&7|0)==0?16:8;else L=j;if(c|0){if((i|0)>=32768){f[w>>2]=0;f[w+4>>2]=0;M=c$(w,26)|0;N=223829;O=M+26|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));j$(-215,w,224773,223392,2579);d$(w)}MS(q,t,f[s>>2]&4095,0);MS(r,v,f[s>>2]&4095,0);r=(g|0)>-2147483646?g:-2147483646;g=(r|0)==2147483647?2147483646:r;r=c+12|0;if((g|0)<0){q=f[r>>2]|0;f[r>>2]=0;P=q;Q=1-g|0}else{P=0;Q=g}bM(m,c,Q);Q=w+12|0;c=x+4|0;g=(i|0)<0;q=w+20|0;j=x+8|0;k=o+8|0;d=(i|0)>-1;R=D+8|0;S=E+8|0;T=x+8|0;U=F+4|0;V=x+4|0;W=y+8|0;X=z+8|0;Y=x+8|0;Z=A+8|0;_=B+8|0;$=C+4|0;while(1){aa=cM(m)|0;if(!aa)break;ba=f[aa+24>>2]|0;ca=f[aa>>2]|0;da=ca&4095;ea=(ca&32768|0)==0?t:v;CL(aa,w,0);if(!(f[Q>>2]|0)){f[x>>2]=0;f[c>>2]=0;M=c$(x,16)|0;N=224788;O=M+16|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));j$(-215,x,224773,223392,2603);d$(x)}if(g?(ca=f[H>>2]|0,fa=f[o>>2]|0,ga=ca,!((ca|0)==(fa|0)|(ga|0)==(fa|0))):0)f[H>>2]=ga+(~((ga+-16-fa|0)>>>4)<<4);fa=f[aa>>2]|0;do if((fa&12288|0)==4096){if(!((fa&16384|0)==0?1:(f[aa+28>>2]|0)!=1)){ga=aa+56|0;ca=f[ga>>2]|0;ha=aa+60|0;ia=f[ha>>2]|0;ja=f[Q>>2]|0;if(!ja)ka=0;else ka=b[ja>>0]|0;la=ka&255;ma=ca+a|0;na=ia+e|0;a:do if((ba|0)>0){if(d){oa=ja;pa=0;qa=la;ra=ma;sa=na;ta=ca;ua=ia;while(1){va=b[oa>>0]|0;wa=oa+1|0;f[Q>>2]=wa;if(wa>>>0>=(f[q>>2]|0)>>>0)LL(w,1);wa=va<<24>>24;if(va<<24>>24==qa<<24>>24){xa=qa;ya=ra;za=sa}else{Aa=y;f[Aa>>2]=ra;f[Aa+4>>2]=((ra|0)<0)<<31>>31;Aa=W;f[Aa>>2]=sa;f[Aa+4>>2]=((sa|0)<0)<<31>>31;Aa=z;f[Aa>>2]=ta;f[Aa+4>>2]=((ta|0)<0)<<31>>31;Aa=X;f[Aa>>2]=ua;f[Aa+4>>2]=((ua|0)<0)<<31>>31;u8(s,y,z,ea,i,L,2,0);xa=va;ya=ta;za=ua}va=pa+1|0;if((va|0)>=(ba|0)){Ba=ya;Ca=za;break a}oa=f[Q>>2]|0;pa=va;qa=xa;ra=ya;sa=za;ta=(f[56728+(wa<<3)>>2]|0)+ta|0;ua=(f[56728+(wa<<3)+4>>2]|0)+ua|0}}else{Da=ja;Ea=0;Fa=la;Ga=ma;Ha=na;Ia=ca;Ja=ia}while(1){ua=b[Da>>0]|0;ta=Da+1|0;f[Q>>2]=ta;if(ta>>>0>=(f[q>>2]|0)>>>0)LL(w,1);ta=ua<<24>>24;if(ua<<24>>24==Fa<<24>>24){Ka=Fa;La=Ga;Ma=Ha}else{sa=((Ia|0)<0)<<31>>31;ra=((Ja|0)<0)<<31>>31;qa=x;f[qa>>2]=Ia;f[qa+4>>2]=sa;qa=Y;f[qa>>2]=Ja;f[qa+4>>2]=ra;qa=f[H>>2]|0;if((qa|0)==(f[k>>2]|0))B8(o,x);else{pa=qa;f[pa>>2]=Ia;f[pa+4>>2]=sa;sa=qa+8|0;f[sa>>2]=Ja;f[sa+4>>2]=ra;f[H>>2]=qa+16}Ka=ua;La=Ia;Ma=Ja}ua=Ea+1|0;if((ua|0)>=(ba|0)){Ba=La;Ca=Ma;break a}Da=f[Q>>2]|0;Ea=ua;Fa=Ka;Ga=La;Ha=Ma;Ia=(f[56728+(ta<<3)>>2]|0)+Ia|0;Ja=(f[56728+(ta<<3)+4>>2]|0)+Ja|0}}else{Ba=ma;Ca=na}while(0);if(d){na=A;f[na>>2]=Ba;f[na+4>>2]=((Ba|0)<0)<<31>>31;na=Z;f[na>>2]=Ca;f[na+4>>2]=((Ca|0)<0)<<31>>31;na=(f[ga>>2]|0)+a|0;ma=(f[ha>>2]|0)+e|0;ia=B;f[ia>>2]=na;f[ia+4>>2]=((na|0)<0)<<31>>31;na=_;f[na>>2]=ma;f[na+4>>2]=((ma|0)<0)<<31>>31;u8(s,A,B,ea,i,L,2,0);break}else{ma=f[o>>2]|0;na=(f[H>>2]|0)-ma>>4;f[C>>2]=a;f[$>>2]=e;E8(s,ma,na,n,t,L,0,C);break}}if((fa&4094|0)==12){if((da|0)==12)Na=fa;else{f[x>>2]=0;f[V>>2]=0;M=c$(x,54)|0;N=224805;O=M+54|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));j$(-215,x,224773,223392,2646);d$(x);Na=f[aa>>2]|0}ha=ba-(Na>>>14&1^1)|0;ga=f[Q>>2]|0;na=ga;ma=na;ia=h[ma>>0]|h[ma+1>>0]<<8|h[ma+2>>0]<<16|h[ma+3>>0]<<24;ma=na+4|0;na=h[ma>>0]|h[ma+1>>0]<<8|h[ma+2>>0]<<16|h[ma+3>>0]<<24;ma=ga+8|0;f[Q>>2]=ma;if(ma>>>0>=(f[q>>2]|0)>>>0)LL(w,1);ma=ia+a|0;ia=na+e|0;if(g){na=((ma|0)<0)<<31>>31;ga=((ia|0)<0)<<31>>31;ca=x;f[ca>>2]=ma;f[ca+4>>2]=na;ca=j;f[ca>>2]=ia;f[ca+4>>2]=ga;ca=f[H>>2]|0;if((ca|0)==(f[k>>2]|0))B8(o,x);else{la=ca;f[la>>2]=ma;f[la+4>>2]=na;na=ca+8|0;f[na>>2]=ia;f[na+4>>2]=ga;f[H>>2]=ca+16}}b:do if((ha|0)>0){if(d){ca=0;ga=ma;na=ia;while(1){la=f[Q>>2]|0;ja=la;ta=ja;ua=h[ta>>0]|h[ta+1>>0]<<8|h[ta+2>>0]<<16|h[ta+3>>0]<<24;ta=ja+4|0;ja=h[ta>>0]|h[ta+1>>0]<<8|h[ta+2>>0]<<16|h[ta+3>>0]<<24;ta=la+8|0;f[Q>>2]=ta;if(ta>>>0>=(f[q>>2]|0)>>>0)LL(w,1);ta=ga;ga=ua+a|0;ua=D;f[ua>>2]=ta;f[ua+4>>2]=((ta|0)<0)<<31>>31;ta=R;f[ta>>2]=na;f[ta+4>>2]=((na|0)<0)<<31>>31;na=ja+e|0;ja=E;f[ja>>2]=ga;f[ja+4>>2]=((ga|0)<0)<<31>>31;ja=S;f[ja>>2]=na;f[ja+4>>2]=((na|0)<0)<<31>>31;u8(s,D,E,ea,i,L,2,0);ca=ca+1|0;if((ca|0)>=(ha|0))break b}}else Oa=0;do{ca=f[Q>>2]|0;na=ca;ga=na;ja=h[ga>>0]|h[ga+1>>0]<<8|h[ga+2>>0]<<16|h[ga+3>>0]<<24;ga=na+4|0;na=h[ga>>0]|h[ga+1>>0]<<8|h[ga+2>>0]<<16|h[ga+3>>0]<<24;ga=ca+8|0;f[Q>>2]=ga;if(ga>>>0>=(f[q>>2]|0)>>>0)LL(w,1);ga=ja+a|0;ja=na+e|0;na=((ga|0)<0)<<31>>31;ca=((ja|0)<0)<<31>>31;ta=x;f[ta>>2]=ga;f[ta+4>>2]=na;ta=T;f[ta>>2]=ja;f[ta+4>>2]=ca;ta=f[H>>2]|0;if((ta|0)==(f[k>>2]|0))B8(o,x);else{ua=ta;f[ua>>2]=ga;f[ua+4>>2]=na;na=ta+8|0;f[na>>2]=ja;f[na+4>>2]=ca;f[H>>2]=ta+16}Oa=Oa+1|0}while((Oa|0)<(ha|0))}while(0);if(g){ha=f[o>>2]|0;ia=(f[H>>2]|0)-ha>>4;f[F>>2]=0;f[U>>2]=0;E8(s,ha,ia,n,t,L,0,F)}}}while(0)}if(g)F8(s,n,t);if(P|0)f[r>>2]=P}P=s+36|0;r=f[P>>2]|0;if(r|0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0)CR(s);f[P>>2]=0;P=s+16|0;r=s+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[r>>2]|0)>0){P=f[s+40>>2]|0;t=0;do{f[P+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[s+44>>2]|0;if((r|0)!=(s+48|0))ZF(r);r=f[o>>2]|0;if(r|0){o=f[H>>2]|0;if((o|0)!=(r|0))f[H>>2]=o+(~((o+-16-r|0)>>>4)<<4);PYa(r)}r=f[n>>2]|0;if(!r){u=l;return}n=f[G>>2]|0;if((n|0)!=(r|0))f[G>>2]=n+(~((n+-32-r|0)>>>5)<<5);PYa(r);u=l;return}function Y8(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;var m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0.0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0;m=u;u=u+432|0;o=m+48|0;q=m+424|0;r=m+368|0;s=m+312|0;t=m+256|0;v=m+32|0;w=m+176|0;x=m+120|0;y=m+64|0;z=m+248|0;A=m;B=m+192|0;_$(q,56792);if(!((d|0)>-1&(e>0.0&g>=0.0))){f[o>>2]=0;f[o+4>>2]=0;C=c$(o,55)|0;D=224975;E=C+55|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));j$(-215,o,225031,225051,365);d$(o)}do if(!(XS(h)|0)){if((RR(h,-1)|0)==0?TS(h,a)|0:0)break;f[o>>2]=0;f[o+4>>2]=0;C=c$(o,102)|0;D=225109;E=C+102|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));j$(-215,o,225031,225051,366);d$(o)}while(0);do if((NS(a)|0)==65536){D=f[a+4>>2]|0;f[r>>2]=f[D>>2];F=r+4|0;G=D+4|0;f[F>>2]=f[G>>2];H=r+8|0;f[H>>2]=f[D+8>>2];f[r+12>>2]=f[D+12>>2];I=r+16|0;f[I>>2]=f[D+16>>2];f[r+20>>2]=f[D+20>>2];f[r+24>>2]=f[D+24>>2];f[r+28>>2]=f[D+28>>2];f[r+32>>2]=f[D+32>>2];J=f[D+36>>2]|0;f[r+36>>2]=J;f[r+40>>2]=H;H=r+48|0;K=r+44|0;f[K>>2]=H;f[H>>2]=0;f[r+52>>2]=0;if(J|0){H=J+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[G>>2]|0)<3){G=f[D+44>>2]|0;H=f[K>>2]|0;f[H>>2]=f[G>>2];f[H+4>>2]=f[G+4>>2];L=I;break}else{f[F>>2]=0;BR(r,D);L=I;break}}else{OR(r,a,-1);L=r+16|0}while(0);f[s>>2]=1124007936;a=s+4|0;I=s+8|0;D=s+40|0;C=a;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[D>>2]=I;I=s+48|0;F=s+44|0;f[F>>2]=I;f[I>>2]=0;f[s+52>>2]=0;f[t>>2]=1124007936;G=t+4|0;H=t+8|0;K=t+40|0;C=G;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[K>>2]=H;H=t+48|0;J=t+44|0;f[J>>2]=H;f[H>>2]=0;f[t+52>>2]=0;if(f[L>>2]|0){M=f[r+4>>2]|0;if((M|0)<3)N=Y(f[r+12>>2]|0,f[r+8>>2]|0)|0;else{O=f[r+40>>2]|0;P=0;Q=1;while(1){R=Y(f[O+(P<<2)>>2]|0,Q)|0;P=P+1|0;if((P|0)==(M|0)){N=R;break}else Q=R}}if(!((M|0)==0|(N|0)==0)){if(k){f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=r;k=v+8|0;f[k>>2]=0;f[k+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=s;A7(o,v,i,j,l,4)}else{f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=r;k=v+8|0;f[k>>2]=0;f[k+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=s;y7(o,v,i,j,4)}p[v>>3]=0.0;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=s;yZ(o,0,v,0,0,h);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=s;j=w+8|0;f[j>>2]=0;f[j+4>>2]=0;f[w>>2]=33619968;f[w+4>>2]=s;+gqa(o,w,+p[v>>3]*e,0.0,3);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=s;v=w+8|0;f[v>>2]=0;f[v+4>>2]=0;f[w>>2]=33619968;f[w+4>>2]=t;f[y>>2]=1124007936;v=y+4|0;j=y+8|0;i=y+40|0;C=v;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[i>>2]=j;j=y+48|0;C=y+44|0;f[C>>2]=j;f[j>>2]=0;f[y+52>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=y;f[z>>2]=-1;f[z+4>>2]=-1;p[A>>3]=1797693134862315708145274.0e284;p[A+8>>3]=1797693134862315708145274.0e284;p[A+16>>3]=1797693134862315708145274.0e284;p[A+24>>3]=1797693134862315708145274.0e284;dka(o,w,x,z,1,0,A);z=y+36|0;E=f[z>>2]|0;if(E|0?(k=E+12|0,E=f[k>>2]|0,f[k>>2]=E+-1,(E|0)==1):0)CR(y);f[z>>2]=0;z=y+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[v>>2]|0)>0){z=f[i>>2]|0;i=0;do{f[z+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[v>>2]|0))}v=f[C>>2]|0;if((v|0)!=(j|0))ZF(v);v=f[r+40>>2]|0;j=f[v+4>>2]|0;C=f[v>>2]|0;f[w>>2]=0;v=w+4|0;f[v>>2]=0;f[w+8>>2]=0;do if((NS(h)|0)==65536){i=f[h+4>>2]|0;f[x>>2]=f[i>>2];z=x+4|0;E=i+4|0;f[z>>2]=f[E>>2];k=x+8|0;f[k>>2]=f[i+8>>2];f[x+12>>2]=f[i+12>>2];f[x+16>>2]=f[i+16>>2];f[x+20>>2]=f[i+20>>2];f[x+24>>2]=f[i+24>>2];f[x+28>>2]=f[i+28>>2];f[x+32>>2]=f[i+32>>2];N=f[i+36>>2]|0;f[x+36>>2]=N;f[x+40>>2]=k;k=x+48|0;M=x+44|0;f[M>>2]=k;f[k>>2]=0;f[x+52>>2]=0;if(N|0){k=N+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[E>>2]|0)<3){E=f[i+44>>2]|0;k=f[M>>2]|0;f[k>>2]=f[E>>2];f[k+4>>2]=f[E+4>>2];break}else{f[z>>2]=0;BR(x,i);break}}else OR(x,h,-1);while(0);h=C+-1|0;if((h|0)>1?(C=s+16|0,i=t+16|0,z=x+16|0,E=j+-1|0,j=w+8|0,k=x+44|0,(E|0)>1):0){M=1;do{N=(f[C>>2]|0)+(Y(f[f[F>>2]>>2]|0,M)|0)|0;Q=(f[i>>2]|0)+(Y(f[f[J>>2]>>2]|0,M)|0)|0;P=f[z>>2]|0;if((P|0)!=0?(O=P+(Y(f[f[k>>2]>>2]|0,M)|0)|0,(O|0)!=0):0){P=1;do{R=N+(P<<2)|0;e=+n[R>>2];do if(e!=0.0){if(!(e==+n[Q+(P<<2)>>2]))break;if(!(b[O+P>>0]|0))break;f[o>>2]=R;S=f[v>>2]|0;if((S|0)==(f[j>>2]|0))Z8(w,o);else{f[S>>2]=R;f[v>>2]=(f[v>>2]|0)+4}}while(0);P=P+1|0}while((P|0)<(E|0))}else{T=1;U=52}if((U|0)==52)while(1){U=0;P=N+(T<<2)|0;e=+n[P>>2];do if(e!=0.0){if(!(e==+n[Q+(T<<2)>>2]))break;f[o>>2]=P;O=f[v>>2]|0;if((O|0)==(f[j>>2]|0))Z8(w,o);else{f[O>>2]=P;f[v>>2]=(f[v>>2]|0)+4}}while(0);T=T+1|0;if((T|0)>=(E|0))break;else U=52}M=M+1|0}while((M|0)<(h|0))}f[y>>2]=0;h=y+4|0;f[h>>2]=0;f[y+8>>2]=0;M=f[v>>2]|0;E=f[w>>2]|0;T=M-E>>2;do if(!T)oS(c);else{_8(E,M,o);if(!(g>=1.0)){j=s+16|0;k=o+4|0;z=y+8|0;if((d|0)>0){i=0;do{C=(f[(f[w>>2]|0)+(i<<2)>>2]|0)-(f[j>>2]|0)|0;Q=f[I>>2]|0;N=(C>>>0)/(Q>>>0)|0;e=+((C-(Y(N,Q)|0)|0)>>>2|0);l=+(N|0);n[o>>2]=e;n[k>>2]=l;N=f[h>>2]|0;if((N|0)==(f[z>>2]|0))$8(y,o);else{n[N>>2]=e;n[N+4>>2]=l;f[h>>2]=N+8}i=i+1|0}while((i|0)!=(d|0)&i>>>0<T>>>0)}else{i=0;do{N=(f[(f[w>>2]|0)+(i<<2)>>2]|0)-(f[j>>2]|0)|0;Q=f[I>>2]|0;C=(N>>>0)/(Q>>>0)|0;l=+((N-(Y(C,Q)|0)|0)>>>2|0);e=+(C|0);n[o>>2]=l;n[k>>2]=e;C=f[h>>2]|0;if((C|0)==(f[z>>2]|0))$8(y,o);else{n[C>>2]=l;n[C+4>>2]=e;f[h>>2]=C+8}i=i+1|0}while(i>>>0<T>>>0)}}else{i=f[r+12>>2]|0;z=f[r+8>>2]|0;k=rNa(g)|0;j=(i+-1+k|0)/(k|0)|0;i=(z+-1+k|0)/(k|0)|0;a9(o,Y(i,j)|0);e=g*g;z=s+16|0;C=j+-1|0;Q=i+-1|0;i=A+4|0;N=A+4|0;P=y+8|0;O=(d|0)>0;R=0;S=0;while(1){V=(f[(f[w>>2]|0)+(R<<2)>>2]|0)-(f[z>>2]|0)|0;W=f[I>>2]|0;X=(V>>>0)/(W>>>0)|0;Z=(V-(Y(X,W)|0)|0)>>>2;W=(Z|0)/(k|0)|0;V=(X|0)/(k|0)|0;_=W+-1|0;$=V+-1|0;aa=W+1|0;ba=V+1|0;ca=(_|0)>0?_:0;_=($|0)>0?$:0;$=(aa|0)<(C|0)?aa:C;aa=(ba|0)<(Q|0)?ba:Q;do if((_|0)<=(aa|0)){ba=f[o>>2]|0;l=+(Z|0);da=+(X|0);if((ca|0)>($|0)){ea=ba;fa=l;ga=da;U=80;break}else{ha=1;ia=_}a:while(1){ja=Y(ia,j)|0;ka=ha;la=ca;while(1){ma=la+ja|0;na=f[ba+(ma*12|0)+4>>2]|0;oa=f[ba+(ma*12|0)>>2]|0;ma=oa;if((na|0)==(oa|0))pa=ka;else{qa=na-oa>>3;oa=ka;na=0;while(1){ra=l-+n[ma+(na<<3)>>2];sa=da-+n[ma+(na<<3)+4>>2];ta=ra*ra+sa*sa<e;ua=oa&(ta^1);na=na+1|0;if(ta){U=79;break a}if(na>>>0>=qa>>>0){pa=ua;break}else oa=ua}}if((la|0)<($|0)){ka=pa;la=la+1|0}else break}if((ia|0)<(aa|0)){ha=pa;ia=ia+1|0}else{U=72;break}}if((U|0)==72){U=0;if(pa){ea=ba;fa=l;ga=da;U=80;break}else{va=S;break}}else if((U|0)==79){U=0;if(ua){ea=ba;fa=l;ga=da;U=80;break}else{va=S;break}}}else{ea=f[o>>2]|0;fa=+(Z|0);ga=+(X|0);U=80}while(0);if((U|0)==80){U=0;X=(Y(V,j)|0)+W|0;n[A>>2]=fa;n[i>>2]=ga;Z=ea+(X*12|0)+4|0;aa=f[Z>>2]|0;if((aa|0)==(f[ea+(X*12|0)+8>>2]|0))$8(ea+(X*12|0)|0,A);else{n[aa>>2]=fa;n[aa+4>>2]=ga;f[Z>>2]=aa+8}n[A>>2]=fa;n[N>>2]=ga;aa=f[h>>2]|0;if((aa|0)==(f[P>>2]|0))$8(y,A);else{n[aa>>2]=fa;n[aa+4>>2]=ga;f[h>>2]=aa+8}aa=S+1|0;if(O&(aa|0)==(d|0))break;else va=aa}R=R+1|0;if(R>>>0>=T>>>0)break;else S=va}S=f[o>>2]|0;if(S|0){R=o+4|0;O=f[R>>2]|0;if((O|0)==(S|0))wa=S;else{P=O;while(1){O=P+-12|0;f[R>>2]=O;N=f[O>>2]|0;if(!N)xa=O;else{O=P+-8|0;i=f[O>>2]|0;if((i|0)!=(N|0))f[O>>2]=i+(~((i+-8-N|0)>>>3)<<3);PYa(N);xa=f[R>>2]|0}if((xa|0)==(S|0))break;else P=xa}wa=f[o>>2]|0}PYa(wa)}}f[B>>2]=1124024333;P=B+4|0;f[P>>2]=2;S=B+8|0;R=f[h>>2]|0;N=f[y>>2]|0;i=R-N|0;f[S>>2]=i>>3;f[B+12>>2]=1;O=B+16|0;j=B+40|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;f[O+16>>2]=0;f[O+20>>2]=0;f[j>>2]=S;S=B+48|0;Q=B+44|0;f[Q>>2]=S;f[S>>2]=0;C=B+52|0;f[C>>2]=0;k=N;if((k|0)!=(R|0)){f[C>>2]=8;f[S>>2]=8;f[O>>2]=k;f[B+20>>2]=k;k=N+i|0;f[B+24>>2]=k;f[B+28>>2]=k}if(aT(c)|0)ya=RR(c,-1)|0;else ya=5;WJ(B,c,ya,1.0,0.0);k=B+36|0;i=f[k>>2]|0;do if(i|0){N=i+12|0;C=f[N>>2]|0;f[N>>2]=C+-1;if((C|0)!=1)break;CR(B)}while(0);f[k>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[P>>2]|0)>0){i=f[j>>2]|0;C=0;do{f[i+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[P>>2]|0))}P=f[Q>>2]|0;if((P|0)==(S|0))break;ZF(P)}while(0);B=f[y>>2]|0;if(B|0){y=f[h>>2]|0;if((y|0)!=(B|0))f[h>>2]=y+(~((y+-8-B|0)>>>3)<<3);PYa(B)}B=x+36|0;y=f[B>>2]|0;if(y|0?(h=y+12|0,y=f[h>>2]|0,f[h>>2]=y+-1,(y|0)==1):0)CR(x);f[B>>2]=0;B=x+16|0;y=x+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[y>>2]|0)>0){B=f[x+40>>2]|0;h=0;do{f[B+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[y>>2]|0))}y=f[x+44>>2]|0;if((y|0)!=(x+48|0))ZF(y);y=f[w>>2]|0;if(y|0){w=f[v>>2]|0;if((w|0)!=(y|0))f[v>>2]=w+(~((w+-4-y|0)>>>2)<<2);PYa(y)}}else U=20}else U=20;if((U|0)==20)oS(c);c=t+36|0;U=f[c>>2]|0;if(U|0?(y=U+12|0,U=f[y>>2]|0,f[y>>2]=U+-1,(U|0)==1):0)CR(t);f[c>>2]=0;c=t+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[G>>2]|0)>0){c=f[K>>2]|0;K=0;do{f[c+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[G>>2]|0))}G=f[J>>2]|0;if((G|0)!=(H|0))ZF(G);G=s+36|0;H=f[G>>2]|0;if(H|0?(J=H+12|0,H=f[J>>2]|0,f[J>>2]=H+-1,(H|0)==1):0)CR(s);f[G>>2]=0;G=s+16|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[a>>2]|0)>0){G=f[D>>2]|0;D=0;do{f[G+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[a>>2]|0))}a=f[F>>2]|0;if((a|0)!=(I|0))ZF(a);a=r+36|0;I=f[a>>2]|0;if(I|0?(F=I+12|0,I=f[F>>2]|0,f[F>>2]=I+-1,(I|0)==1):0)CR(r);f[a>>2]=0;a=r+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[a>>2]|0)>0){L=f[r+40>>2]|0;I=0;do{f[L+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[a>>2]|0))}a=f[r+44>>2]|0;if((a|0)!=(r+48|0))ZF(a);if(!(f[q+4>>2]|0)){u=m;return}u=m;return}function Z8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)gXa(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;PYa(d);return}function _8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=a;a=b;a:while(1){b=a;e=a+-4|0;g=d;while(1){h=g;b:while(1){i=h;j=b-i|0;k=j>>2;switch(k|0){case 2:{l=5;break a;break}case 3:{l=8;break a;break}case 4:{l=24;break a;break}case 5:{l=25;break a;break}case 1:case 0:{l=89;break a;break}default:{}}if((j|0)<124){l=27;break a}m=h+(((k|0)/2|0)<<2)|0;do if((j|0)>3996){o=(k|0)/4|0;p=c9(h,h+(o<<2)|0,m,m+(o<<2)|0,e,c)|0}else{o=f[m>>2]|0;q=f[h>>2]|0;r=+n[o>>2];s=+n[q>>2];t=o;u=q;if(!(r>s))if(r<s)v=0;else v=o>>>0>q>>>0;else v=1;w=f[e>>2]|0;x=+n[w>>2];y=w;if(!(x>r))if(x<r)z=0;else z=w>>>0>o>>>0;else z=1;if(!v){if(!z){p=0;break}f[m>>2]=y;f[e>>2]=t;o=f[m>>2]|0;w=f[h>>2]|0;r=+n[o>>2];x=+n[w>>2];A=w;B=o;if(!(r>x)?o>>>0<=w>>>0|r<x:0){p=1;break}f[h>>2]=B;f[m>>2]=A;p=2;break}if(z){f[h>>2]=y;f[e>>2]=u;p=1;break}f[h>>2]=t;f[m>>2]=u;t=f[e>>2]|0;x=+n[t>>2];y=t;if(!(x>s)?t>>>0<=q>>>0|x<s:0){p=1;break}f[m>>2]=y;f[e>>2]=u;p=2}while(0);C=f[h>>2]|0;k=f[m>>2]|0;s=+n[C>>2];x=+n[k>>2];if(s>x){D=e;E=p;break}if(C>>>0<=k>>>0|s<x)F=e;else{D=e;E=p;break}while(1){F=F+-4|0;if((h|0)==(F|0))break;G=f[F>>2]|0;r=+n[G>>2];if(r>x){l=67;break b}if(!(G>>>0<=k>>>0|r<x)){l=67;break b}}k=h+4|0;j=f[e>>2]|0;x=+n[j>>2];u=j;if(!(s>x)?C>>>0<=j>>>0|s<x:0){if((k|0)==(e|0)){l=89;break a}else H=k;while(1){I=f[H>>2]|0;x=+n[I>>2];if(s>x)break;if(!(C>>>0<=I>>>0|s<x))break;j=H+4|0;if((j|0)==(e|0)){l=89;break a}else H=j}f[H>>2]=u;f[e>>2]=I;J=H+4|0}else J=k;if((J|0)==(e|0)){l=89;break a}else{K=J;L=e}while(1){j=f[h>>2]|0;y=f[K>>2]|0;s=+n[j>>2];x=+n[y>>2];c:do if(s>x)M=K;else{r=x;q=y;t=K;while(1){if(!(j>>>0<=q>>>0|s<r)){M=t;break c}A=t+4|0;q=f[A>>2]|0;r=+n[q>>2];if(s>r){M=A;break}else t=A}}while(0);y=L;while(1){t=y;y=y+-4|0;N=f[y>>2]|0;x=+n[N>>2];if(s>x){y=y;continue}if(j>>>0<=N>>>0|s<x)break}if(M>>>0>=y>>>0){h=M;continue b}j=f[M>>2]|0;f[M>>2]=N;f[y>>2]=j;K=M+4|0;L=y}}if((l|0)==67){l=0;f[h>>2]=G;f[F>>2]=C;D=F;E=p+1|0}k=h+4|0;d:do if(k>>>0<D>>>0){u=k;j=D;t=m;q=E;while(1){A=f[t>>2]|0;s=+n[A>>2];B=u;while(1){O=f[B>>2]|0;x=+n[O>>2];if(!(x>s)?O>>>0<=A>>>0|x<s:0)break;B=B+4|0}y=O;w=j;do{w=w+-4|0;P=f[w>>2]|0;x=+n[P>>2];if(x>s)break}while(P>>>0<=A>>>0|x<s);if(B>>>0>w>>>0){Q=B;R=t;S=q;break d}f[B>>2]=P;f[w>>2]=y;u=B+4|0;j=w;t=(t|0)==(B|0)?w:t;q=q+1|0}}else{Q=k;R=m;S=E}while(0);do if((Q|0)==(R|0))T=S;else{k=f[R>>2]|0;q=f[Q>>2]|0;s=+n[k>>2];x=+n[q>>2];t=q;j=k;if(!(s>x)?!(k>>>0>q>>>0&!(s<x)):0){T=S;break}f[Q>>2]=j;f[R>>2]=t;T=S+1|0}while(0);if(!T){U=e9(h,Q,c)|0;t=Q+4|0;if(e9(t,a,c)|0){l=88;break}if(U){g=t;continue}}t=Q;if((t-i|0)>=(b-t|0)){l=87;break}_8(h,Q,c);g=Q+4|0}if((l|0)==87){l=0;_8(Q+4|0,a,c);d=h;a=Q;continue}else if((l|0)==88){l=0;if(U){l=89;break}else{d=h;a=Q;continue}}}if((l|0)==5){Q=f[e>>2]|0;d=f[h>>2]|0;x=+n[Q>>2];s=+n[d>>2];U=d;i=Q;if(!(x>s)?Q>>>0<=d>>>0|x<s:0)return;f[h>>2]=i;f[e>>2]=U;return}else if((l|0)==8){U=h+4|0;i=f[U>>2]|0;d=f[h>>2]|0;s=+n[i>>2];x=+n[d>>2];Q=i;T=d;if(!(s>x))if(s<x)V=0;else V=i>>>0>d>>>0;else V=1;S=f[e>>2]|0;r=+n[S>>2];R=S;if(!(r>s))if(r<s)W=0;else W=S>>>0>i>>>0;else W=1;if(!V){if(!W)return;f[U>>2]=R;f[e>>2]=Q;V=f[U>>2]|0;i=f[h>>2]|0;s=+n[V>>2];r=+n[i>>2];S=i;E=V;if(!(s>r)?V>>>0<=i>>>0|s<r:0)return;f[h>>2]=E;f[U>>2]=S;return}if(W){f[h>>2]=R;f[e>>2]=T;return}f[h>>2]=Q;f[U>>2]=T;Q=f[e>>2]|0;r=+n[Q>>2];R=Q;if(!(r>x)?Q>>>0<=d>>>0|r<x:0)return;f[U>>2]=R;f[e>>2]=T;return}else if((l|0)==24){b9(h,h+4|0,h+8|0,e,c)|0;return}else if((l|0)==25){c9(h,h+4|0,h+8|0,h+12|0,e,c)|0;return}else if((l|0)==27){d9(h,a,c);return}else if((l|0)==89)return}function $8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)gXa(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>2;m=k>>3>>>0<268435455?(l>>>0<h>>>0?h:l):536870911;do if(m)if(m>>>0>536870911){l=De(8)|0;UYa(l,358155);f[l>>2]=130560;Of(l|0,21520,875)}else{n=NYa(m<<3)|0;break}else n=0;while(0);l=n+(g<<3)|0;h=n+(m<<3)|0;f[l>>2]=f[b>>2];f[n+(g<<3)+4>>2]=f[b+4>>2];b=l+8|0;if((j|0)==(i|0))o=l;else{g=j+-8-e|0;n=l;m=j;do{j=n;n=n+-8|0;k=m;m=m+-8|0;f[n>>2]=f[m>>2];f[j+-4>>2]=f[k+-4>>2]}while((m|0)!=(i|0));o=l+(~(g>>>3)<<3)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;PYa(e);return}function a9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>357913941)gXa(a);d=b*12|0;e=NYa(d)|0;f[a>>2]=e;g=e+(b*12|0)|0;f[a+8>>2]=g;F1a(e|0,0,d|0)|0;f[c>>2]=g;return}function b9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=f[b>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=e;k=g;if(!(h>i))if(h<i)l=0;else l=e>>>0>g>>>0;else l=1;m=f[c>>2]|0;o=+n[m>>2];p=m;if(!(o>h))if(o<h)q=0;else q=m>>>0>e>>>0;else q=1;do if(!l)if(q){f[b>>2]=p;f[c>>2]=j;r=f[b>>2]|0;s=f[a>>2]|0;h=+n[r>>2];o=+n[s>>2];t=s;u=r;if(!(h>o)?r>>>0<=s>>>0|h<o:0){v=e;w=j;x=1;break}f[a>>2]=u;f[b>>2]=t;t=f[c>>2]|0;v=t;w=t;x=2}else{v=m;w=p;x=0}else{if(q){f[a>>2]=p;f[c>>2]=k;v=g;w=k;x=1;break}f[a>>2]=j;f[b>>2]=k;t=f[c>>2]|0;o=+n[t>>2];u=t;if(!(o>i)?t>>>0<=g>>>0|o<i:0){v=t;w=u;x=1;break}f[b>>2]=u;f[c>>2]=k;v=g;w=k;x=2}while(0);k=f[d>>2]|0;i=+n[k>>2];o=+n[v>>2];g=k;if(!(i>o)?k>>>0<=v>>>0|i<o:0){y=x;return y|0}f[c>>2]=g;f[d>>2]=w;w=f[c>>2]|0;d=f[b>>2]|0;o=+n[w>>2];i=+n[d>>2];g=d;v=w;if(!(o>i)?w>>>0<=d>>>0|o<i:0){y=x+1|0;return y|0}f[b>>2]=v;f[c>>2]=g;g=f[b>>2]|0;c=f[a>>2]|0;i=+n[g>>2];o=+n[c>>2];v=c;d=g;if(!(i>o)?!(g>>>0>c>>>0&!(i<o)):0){y=x+2|0;return y|0}f[a>>2]=d;f[b>>2]=v;y=x+3|0;return y|0}function c9(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0.0,k=0.0,l=0,m=0,o=0;h=b9(a,b,c,d,g)|0;g=f[e>>2]|0;i=f[d>>2]|0;j=+n[g>>2];k=+n[i>>2];l=i;m=g;if(!(j>k)?g>>>0<=i>>>0|j<k:0){o=h;return o|0}f[d>>2]=m;f[e>>2]=l;l=f[d>>2]|0;e=f[c>>2]|0;k=+n[l>>2];j=+n[e>>2];m=e;i=l;if(!(k>j)?l>>>0<=e>>>0|k<j:0){o=h+1|0;return o|0}f[c>>2]=i;f[d>>2]=m;m=f[c>>2]|0;d=f[b>>2]|0;j=+n[m>>2];k=+n[d>>2];i=d;e=m;if(!(j>k)?m>>>0<=d>>>0|j<k:0){o=h+2|0;return o|0}f[b>>2]=e;f[c>>2]=i;i=f[b>>2]|0;c=f[a>>2]|0;k=+n[i>>2];j=+n[c>>2];e=c;d=i;if(!(k>j)?!(i>>>0>c>>>0&!(k<j)):0){o=h+3|0;return o|0}f[a>>2]=d;f[b>>2]=e;o=h+4|0;return o|0}function d9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=a+8|0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=e;k=g;if(!(h>i))if(h<i)l=0;else l=e>>>0>g>>>0;else l=1;m=f[c>>2]|0;o=+n[m>>2];p=m;if(!(o>h))if(o<h)q=0;else q=m>>>0>e>>>0;else q=1;do if(!l)if(q){f[d>>2]=p;f[c>>2]=j;if(!(o>i)?m>>>0<=g>>>0|o<i:0){r=j;s=e;break}f[a>>2]=p;f[d>>2]=k;r=j;s=e}else{r=p;s=m}else{if(q){f[a>>2]=p;f[c>>2]=k;r=k;s=g;break}f[a>>2]=j;f[d>>2]=k;if(!(o>i)?m>>>0<=g>>>0|o<i:0){r=p;s=m;break}f[d>>2]=p;f[c>>2]=k;r=k;s=g}while(0);g=a+12|0;if((g|0)==(b|0))return;else{t=s;u=r;v=g;w=c}while(1){c=f[v>>2]|0;i=+n[c>>2];o=+n[t>>2];g=c;if(!(!(i>o)?c>>>0<=t>>>0|i<o:0)){f[v>>2]=u;a:do if((w|0)==(a|0))x=w;else{r=w;s=w;while(1){k=s;s=r+-4|0;p=f[s>>2]|0;o=+n[p>>2];d=p;if(!(i>o)?c>>>0<=p>>>0|i<o:0){x=k;break a}f[k>>2]=d;if((s|0)==(a|0)){x=s;break}else r=s}}while(0);f[x>>2]=g}c=v+4|0;if((c|0)==(b|0))break;s=f[v>>2]|0;r=v;t=s;u=s;v=c;w=r}return}function e9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=g;k=e;if(!(h>i)?e>>>0<=g>>>0|h<i:0){l=1;return l|0}f[a>>2]=k;f[d>>2]=j;l=1;return l|0}case 3:{j=a+4|0;d=b+-4|0;k=f[j>>2]|0;g=f[a>>2]|0;i=+n[k>>2];h=+n[g>>2];e=k;m=g;if(!(i>h))if(i<h)o=0;else o=k>>>0>g>>>0;else o=1;p=f[d>>2]|0;q=+n[p>>2];r=p;if(!(q>i))if(q<i)s=0;else s=p>>>0>k>>>0;else s=1;if(!o){if(!s){l=1;return l|0}f[j>>2]=r;f[d>>2]=e;o=f[j>>2]|0;k=f[a>>2]|0;i=+n[o>>2];q=+n[k>>2];p=k;t=o;if(!(i>q)?o>>>0<=k>>>0|i<q:0){l=1;return l|0}f[a>>2]=t;f[j>>2]=p;l=1;return l|0}if(s){f[a>>2]=r;f[d>>2]=m;l=1;return l|0}f[a>>2]=e;f[j>>2]=m;e=f[d>>2]|0;q=+n[e>>2];r=e;if(!(q>h)?e>>>0<=g>>>0|q<h:0){l=1;return l|0}f[j>>2]=r;f[d>>2]=m;l=1;return l|0}case 4:{b9(a,a+4|0,a+8|0,b+-4|0,c)|0;l=1;return l|0}case 5:{c9(a,a+4|0,a+8|0,a+12|0,b+-4|0,c)|0;l=1;return l|0}case 1:case 0:{l=1;return l|0}default:{c=a+8|0;m=a+4|0;d=f[m>>2]|0;r=f[a>>2]|0;h=+n[d>>2];q=+n[r>>2];j=d;g=r;if(!(h>q))if(h<q)u=0;else u=d>>>0>r>>>0;else u=1;e=f[c>>2]|0;i=+n[e>>2];s=e;if(!(i>h))if(i<h)v=0;else v=e>>>0>d>>>0;else v=1;do if(!u)if(v){f[m>>2]=s;f[c>>2]=j;if(!(i>q)?e>>>0<=r>>>0|i<q:0){w=d;break}f[a>>2]=s;f[m>>2]=g;w=d}else w=e;else{if(v){f[a>>2]=s;f[c>>2]=g;w=r;break}f[a>>2]=j;f[m>>2]=g;if(!(i>q)?e>>>0<=r>>>0|i<q:0){w=e;break}f[m>>2]=s;f[c>>2]=g;w=r}while(0);r=a+12|0;a:do if((r|0)==(b|0)){x=1;y=0}else{g=w;s=0;m=r;e=c;while(1){j=f[m>>2]|0;q=+n[j>>2];i=+n[g>>2];v=j;if(!(q>i)?j>>>0<=g>>>0|q<i:0)z=s;else{f[m>>2]=f[e>>2];b:do if((e|0)==(a|0))A=e;else{d=e;u=e;while(1){p=u;u=d+-4|0;t=f[u>>2]|0;i=+n[t>>2];k=t;if(!(q>i)?j>>>0<=t>>>0|q<i:0){A=p;break b}f[p>>2]=k;if((u|0)==(a|0)){A=u;break}else d=u}}while(0);f[A>>2]=v;j=s+1|0;if((j|0)==8){x=0;y=(m+4|0)==(b|0);break a}else z=j}j=m+4|0;if((j|0)==(b|0)){x=1;y=0;break a}u=m;g=f[m>>2]|0;s=z;m=j;e=u}}while(0);l=y|x;return l|0}}return 0}function f9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;i=+i;Y8(a,b,c,d,e,f,g,3,h,i);return}function g9(a){a=a|0;return}function h9(a){a=a|0;PYa(a);return}function i9(a){a=a|0;return}function j9(a){a=a|0;PYa(a);return}function k9(a){a=a|0;return}function l9(a){a=a|0;return}function m9(a){a=a|0;PYa(a);return}function n9(a){a=a|0;return}function o9(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=56888;b=a+192|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)ki[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+196>>2]=0;b=a+184|0;c=f[b>>2]|0;if(c|0?(e=c+4|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)ki[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+188>>2]=0;b=a+176|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)ki[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+180>>2]=0;b=f[a+164>>2]|0;if(b|0){c=a+168|0;e=f[c>>2]|0;if((e|0)!=(b|0))f[c>>2]=e+(~((e+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+128>>2]|0;if(b|0){e=a+132|0;if((f[e>>2]|0)!=(b|0))f[e>>2]=b;PYa(b)}b=f[a+116>>2]|0;if(b|0){e=a+120|0;if((f[e>>2]|0)!=(b|0))f[e>>2]=b;PYa(b)}b=f[a+104>>2]|0;if(b|0){e=a+108|0;if((f[e>>2]|0)!=(b|0))f[e>>2]=b;PYa(b)}b=f[a+92>>2]|0;if(b|0){e=a+96|0;if((f[e>>2]|0)!=(b|0))f[e>>2]=b;PYa(b)}b=f[a+76>>2]|0;if(!b)return;e=a+80|0;a=f[e>>2]|0;if((a|0)!=(b|0))f[e>>2]=a+(~((a+-4-b|0)>>>2)<<2);PYa(b);return}function p9(a){a=a|0;o9(a);PYa(a);return}function q9(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;g=u;u=u+16|0;h=g;i=f[c>>2]|0;j=a+36|0;f[j>>2]=i;k=f[c+4>>2]|0;c=a+40|0;f[c>>2]=k;l=f[e>>2]|0;m=f[e+4>>2]|0;e=f[d>>2]|0;n=f[d+4>>2]|0;d=a+44|0;f[d>>2]=l;o=a+48|0;f[o>>2]=m;p=a+52|0;f[p>>2]=e;q=a+56|0;f[q>>2]=n;if(((e+l|0)>(i|0)?1:(l|m|e|n|0)<0)|(n+m|0)>(k|0)){f[h>>2]=0;f[h+4>>2]=0;K1a(c$(h,143)|0,225688,143)|0;j$(-215,h,225832,225433,173);d$(h);r=f[p>>2]|0}else r=e;e=a+4|0;k=f[e>>2]|0;m=(k>>>3&511)+1<<(47696>>>(k<<1&14)&3);n=a+12|0;l=f[n>>2]|0;i=(l>>>3&511)+1<<(47696>>>(l<<1&14)&3);l=a+116|0;s=f[l>>2]|0;t=a+120|0;v=(s|0)==(f[t>>2]|0)?0:s;s=a+16|0;w=a+20|0;x=f[w>>2]|0;y=x+3|0;z=a+28|0;A=f[z>>2]|0;B=x-A+-1|0;x=((A|0)<(B|0)?B:A)<<1|1;A=(y|0)<(x|0)?x:y;y=a+32|0;x=f[y>>2]|0;if((x|0)>=(r|0)){B=a+164|0;C=a+168|0;D=f[C>>2]|0;E=f[B>>2]|0;if((A|0)==(D-E>>2|0))F=a+180|0;else{G=B;H=C;I=E;J=D;K=C;L=B;M=7}}else{B=a+168|0;C=a+164|0;G=C;H=B;I=f[C>>2]|0;J=f[B>>2]|0;K=B;L=C;M=7}do if((M|0)==7){C=J-I>>2;B=I;D=J;if(A>>>0<=C>>>0)if(A>>>0<C>>>0?(E=B+(A<<2)|0,(D|0)!=(E|0)):0){f[K>>2]=D+(~((D+-4-E|0)>>>2)<<2);N=x;O=r;P=k}else{N=x;O=r;P=k}else{u9(L,A-C|0);N=f[y>>2]|0;O=f[p>>2]|0;P=f[e>>2]|0}C=(N|0)<(O|0)?O:N;f[y>>2]=C;E=(P>>>3&511)+1|0;D=a+104|0;B=Y(C+-1+(f[s>>2]|0)|0,m)|0;C=a+108|0;Q=f[C>>2]|0;R=f[D>>2]|0;S=Q-R|0;T=R;R=Q;if(B>>>0<=S>>>0){if(B>>>0<S>>>0?(Q=T+B|0,(R|0)!=(Q|0)):0)f[C>>2]=Q}else TR(D,B-S|0);if(!(f[a+72>>2]|0)){if(!v){f[h>>2]=0;f[h+4>>2]=0;U=c$(h,14)|0;V=225838;W=U+14|0;do{b[U>>0]=b[V>>0]|0;U=U+1|0;V=V+1|0}while((U|0)<(W|0));j$(-215,h,225832,225433,191);d$(h)}S=a+128|0;B=f[n>>2]|0;Q=f[y>>2]|0;C=f[s>>2]|0;R=Y((B>>>3&511)+1<<(47696>>>(B<<1&14)&3),Q+63+C|0)|0;B=a+132|0;T=f[B>>2]|0;X=f[S>>2]|0;Z=T-X|0;_=X;$=T;if(R>>>0<=Z>>>0)if(R>>>0<Z>>>0?(T=_+R|0,($|0)!=(T|0)):0){f[B>>2]=T;aa=X;ba=Q;ca=C}else{aa=X;ba=Q;ca=C}else{TR(S,R-Z|0);aa=f[S>>2]|0;ba=f[y>>2]|0;ca=f[s>>2]|0}S=aa+63&-64;Z=Y(ba+-1+ca|0,m)|0;R=a+180|0;C=f[R>>2]|0;if(!C)da=f[D>>2]|0;else da=S;if((Z|0)>0){Q=0;X=(f[t>>2]|0)-(f[l>>2]|0)|0;do{T=Z-Q|0;X=(T|0)<(X|0)?T:X;if((X|0)>0){T=0;do{b[da+(T+Q)>>0]=b[v+T>>0]|0;T=T+1|0}while((T|0)<(X|0))}Q=X+Q|0}while((Z|0)>(Q|0));ea=f[R>>2]|0}else ea=C;if(!ea){Q=f[a+188>>2]|0;Bh[f[(f[Q>>2]|0)+8>>2]&255](Q,f[D>>2]|0,S,f[y>>2]|0,E);fa=R}else fa=R}else fa=a+180|0;if(!(f[fa>>2]|0))ga=0;else ga=(f[s>>2]|0)+-1|0;Q=Y((f[y>>2]|0)+63+ga&-64,i)|0;Z=a+92|0;X=(Y(Q,(f[H>>2]|0)-(f[G>>2]|0)>>2)|0)+64|0;Q=a+96|0;T=f[Q>>2]|0;B=f[Z>>2]|0;$=T-B|0;if(X>>>0>$>>>0){TR(Z,X-$|0);F=fa;break}if(X>>>0<$>>>0?($=B+X|0,(T|0)!=($|0)):0){f[Q>>2]=$;F=fa}else F=fa}while(0);fa=f[p>>2]|0;G=f[F>>2]|0;H=f[s>>2]|0;ga=Y(fa+15+((G|0)==0?0:H+-1|0)&-16,i)|0;i=a+140|0;f[i>>2]=ga;ga=f[a+24>>2]|0;y=f[d>>2]|0;d=ga-y|0;ea=(d|0)>0;da=a+60|0;f[da>>2]=ea?d:0;l=f[j>>2]|0;j=H+-1-ga+y+fa-l|0;fa=(j|0)>0;H=a+64|0;f[H>>2]=fa?j:0;a:do if(ea|fa){j=a+68|0;t=f[j>>2]|0;if(!t){if(!v){f[h>>2]=0;f[h+4>>2]=0;U=c$(h,14)|0;V=225838;W=U+14|0;do{b[U>>0]=b[V>>0]|0;U=U+1|0;V=V+1|0}while((U|0)<(W|0));j$(-215,h,225832,225433,225);d$(h);ha=f[F>>2]|0}else ha=G;if(ha){R=(f[a+168>>2]|0)-(f[a+164>>2]|0)|0;if((R|0)>0)ia=R>>2;else break}else ia=1;R=a+104|0;E=a+92|0;S=ha;D=0;while(1){if(!S)ja=f[R>>2]|0;else ja=((f[E>>2]|0)+63&-64)+(Y(f[i>>2]|0,D)|0)|0;K1a(ja|0,v|0,Y(f[da>>2]|0,m)|0)|0;C=f[H>>2]|0;K1a(ja+(Y((f[p>>2]|0)+-1+(f[s>>2]|0)-C|0,m)|0)|0,v|0,Y(C,m)|0)|0;C=D+1|0;if((C|0)==(ia|0))break a;S=f[F>>2]|0;D=C}}D=((ga|0)<(y|0)?ga:y)-y|0;S=f[a+88>>2]|0;E=f[a+76>>2]|0;b:do if(ea){if((S|0)>0){ka=d;la=t;ma=0}else{lL(0-d|0,l,t)|0;R=f[da>>2]|0;if((R|0)>1){na=R;oa=1}else break;while(1){lL(oa-na|0,l,f[j>>2]|0)|0;oa=oa+1|0;na=f[da>>2]|0;if((oa|0)>=(na|0))break b}}while(1){R=Y((lL(ma-ka|0,l,la)|0)+D|0,S)|0;C=Y(ma,S)|0;ca=0;do{f[E+(ca+C<<2)>>2]=ca+R;ca=ca+1|0}while((ca|0)!=(S|0));ca=ma+1|0;R=f[da>>2]|0;if((ca|0)>=(R|0))break b;ka=R;la=f[j>>2]|0;ma=ca}}while(0);if((f[H>>2]|0)>0){if((S|0)>0)pa=0;else{t=0;while(1){lL(t+l|0,l,f[j>>2]|0)|0;t=t+1|0;if((t|0)>=(f[H>>2]|0))break a}}do{t=Y((lL(pa+l|0,l,f[j>>2]|0)|0)+D|0,S)|0;ca=0;do{R=E+((Y((f[da>>2]|0)+pa|0,S)|0)+ca<<2)|0;f[R>>2]=ca+t;ca=ca+1|0}while((ca|0)!=(S|0));pa=pa+1|0}while((pa|0)<(f[H>>2]|0))}}while(0);f[a+160>>2]=0;f[a+156>>2]=0;H=f[o>>2]|0;o=f[z>>2]|0;z=H-o|0;pa=(z|0)>0?z:0;f[a+148>>2]=pa;z=a+144|0;f[z>>2]=pa;pa=H+-1+(f[q>>2]|0)+(f[w>>2]|0)-o|0;o=f[c>>2]|0;f[a+152>>2]=(o|0)<(pa|0)?o:pa;pa=f[a+196>>2]|0;if(pa|0)ki[f[(f[pa>>2]|0)+12>>2]&2047](pa);pa=f[F>>2]|0;if(!pa){qa=f[z>>2]|0;u=g;return qa|0}ki[f[(f[pa>>2]|0)+12>>2]&2047](pa);qa=f[z>>2]|0;u=g;return qa|0}function r9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;h=f[(f[a>>2]|0)+8>>2]|0;i=f[b+40>>2]|0;b=f[i>>2]|0;f[g>>2]=f[i+4>>2];f[g+4>>2]=b;Jg[h&63](a,c,g,d)|0;u=e;return (f[a+144>>2]|0)-(f[d+4>>2]|0)|0}function s9(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0;i=u;u=u+16|0;j=i;if(!((f[a+36>>2]|0)>0?(f[a+40>>2]|0)>0:0)){f[j>>2]=0;f[j+4>>2]=0;k=c$(j,43)|0;l=225578;m=k+43|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,j,225622,225433,288);d$(j)}n=f[a+76>>2]|0;o=a+4|0;p=f[o>>2]|0;q=(p>>>3&511)+1<<(47696>>>(p<<1&14)&3);p=f[a+88>>2]|0;r=f[a+164>>2]|0;s=(f[a+168>>2]|0)-r>>2;t=((f[a+12>>2]|0)>>>3&511)+1|0;v=a+52|0;w=f[v>>2]|0;x=f[a+16>>2]|0;y=f[a+20>>2]|0;z=f[a+28>>2]|0;A=f[a+60>>2]|0;B=f[a+64>>2]|0;C=f[a+24>>2]|0;D=f[a+44>>2]|0;E=a+180|0;F=(f[E>>2]|0)==0;if((A|0)>0|(B|0)>0)G=(f[a+68>>2]|0)!=0;else G=0;H=c+(Y((C|0)<(D|0)?C:D,0-q|0)|0)|0;D=a+144|0;C=a+156|0;c=(f[a+152>>2]|0)-(f[D>>2]|0)-(f[C>>2]|0)|0;I=(c|0)<(e|0)?c:e;if(!((g|0)!=0&(H|0)!=0&(I|0)>0)){f[j>>2]=0;f[j+4>>2]=0;k=c$(j,23)|0;l=225630;m=k+23|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,j,225622,225433,307);d$(j)}e=s-z|0;c=a+48|0;J=s+1-y|0;K=a+148|0;L=a+92|0;M=a+140|0;N=a+104|0;O=Y(A,q)|0;P=w+-1+x-B|0;x=Y(P-A|0,q)|0;Q=(p<<2|0)==(q|0);R=Y(A,p)|0;A=(R|0)>0;S=Y(B,p)|0;T=(S|0)>0;U=Y(P,p)|0;p=(O|0)>0;V=Y(B,q)|0;B=(V|0)>0;W=Y(P,q)|0;q=a+188|0;P=a+56|0;X=a+160|0;Z=y+-1|0;_=a+196|0;$=a+40|0;aa=a+72|0;ba=a+128|0;a=j+4|0;ca=I;I=g;g=0;da=H;while(1){H=f[D>>2]|0;ea=f[C>>2]|0;fa=e-H-ea+(f[c>>2]|0)|0;ga=(fa|0)>0?fa:J;fa=(ca|0)<(ga|0)?ca:ga;ga=ca-fa|0;ha=fa+-1|0;do if((fa|0)>0){ia=Y(fa,d)|0;if(F){ja=H;ka=ea;la=ha;ma=da;while(1){na=((f[L>>2]|0)+63&-64)+(Y(f[M>>2]|0,(ja-(f[K>>2]|0)+ka|0)%(s|0)|0)|0)|0;oa=f[N>>2]|0;f[C>>2]=ka+1;if((ka|0)>=(s|0)){f[C>>2]=ka;f[D>>2]=ja+1}K1a(oa+O|0,ma|0,x|0)|0;do if(G)if(Q){if(A){pa=0;do{f[oa+(pa<<2)>>2]=f[ma+(f[n+(pa<<2)>>2]<<2)>>2];pa=pa+1|0}while((pa|0)!=(R|0))}if(T)qa=0;else break;do{f[oa+(qa+U<<2)>>2]=f[ma+(f[n+(qa+R<<2)>>2]<<2)>>2];qa=qa+1|0}while((qa|0)!=(S|0))}else{if(p){pa=0;do{b[oa+pa>>0]=b[ma+(f[n+(pa<<2)>>2]|0)>>0]|0;pa=pa+1|0}while((pa|0)!=(O|0))}if(B)ra=0;else break;do{b[oa+(ra+W)>>0]=b[ma+(f[n+(ra+O<<2)>>2]|0)>>0]|0;ra=ra+1|0}while((ra|0)!=(V|0))}while(0);pa=f[q>>2]|0;Bh[f[(f[pa>>2]|0)+8>>2]&255](pa,oa,na,w,((f[o>>2]|0)>>>3&511)+1|0);if((la|0)<=0)break;ja=f[D>>2]|0;ka=f[C>>2]|0;la=la+-1|0;ma=ma+d|0}sa=da+ia|0;break}else{ma=H;la=ea;ka=ha;ja=da;while(1){pa=((f[L>>2]|0)+63&-64)+(Y(f[M>>2]|0,(ma-(f[K>>2]|0)+la|0)%(s|0)|0)|0)|0;f[C>>2]=la+1;if((la|0)>=(s|0)){f[C>>2]=la;f[D>>2]=ma+1}K1a(pa+O|0,ja|0,x|0)|0;do if(G)if(Q){if(A){ta=0;do{f[pa+(ta<<2)>>2]=f[ja+(f[n+(ta<<2)>>2]<<2)>>2];ta=ta+1|0}while((ta|0)!=(R|0))}if(T)ua=0;else break;do{f[pa+(ua+U<<2)>>2]=f[ja+(f[n+(ua+R<<2)>>2]<<2)>>2];ua=ua+1|0}while((ua|0)!=(S|0))}else{if(p){ta=0;do{b[pa+ta>>0]=b[ja+(f[n+(ta<<2)>>2]|0)>>0]|0;ta=ta+1|0}while((ta|0)!=(O|0))}if(B)va=0;else break;do{b[pa+(va+W)>>0]=b[ja+(f[n+(va+O<<2)>>2]|0)>>0]|0;va=va+1|0}while((va|0)!=(V|0))}while(0);if((ka|0)<=0)break;ma=f[D>>2]|0;la=f[C>>2]|0;ka=ka+-1|0;ja=ja+d|0}sa=da+ia|0;break}}else sa=da;while(0);ha=f[X>>2]|0;ea=Z-g+(f[P>>2]|0)-ha|0;H=(ea|0)<(s|0)?ea:s;a:do if((H|0)>0){ea=g-z|0;fa=ha;ja=0;while(1){ka=lL(ea+ja+fa+(f[c>>2]|0)|0,f[$>>2]|0,f[aa>>2]|0)|0;if((ka|0)<0)wa=(f[ba>>2]|0)+63&-64;else{la=f[D>>2]|0;if((ka|0)<(la|0)){f[j>>2]=0;f[a>>2]=0;k=c$(j,14)|0;l=225654;m=k+14|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,j,225622,225433,363);d$(j);xa=f[D>>2]|0}else xa=la;if((ka|0)>=((f[C>>2]|0)+xa|0)){ya=ja;break a}wa=((f[L>>2]|0)+63&-64)+(Y(f[M>>2]|0,(ka-(f[K>>2]|0)|0)%(s|0)|0)|0)|0}f[r+(ja<<2)>>2]=wa;ma=ja+1|0;if((ma|0)>=(H|0)){ya=ma;break a}fa=f[X>>2]|0;ja=ma}}else ya=0;while(0);if((ya|0)<(y|0))break;H=ya-Z|0;ha=f[E>>2]|0;if(!ha){ja=f[_>>2]|0;fa=Y(f[v>>2]|0,t)|0;bh[f[(f[ja>>2]|0)+8>>2]&255](ja,r,I,h,H,fa)}else Xh[f[(f[ha>>2]|0)+8>>2]&127](ha,r,I,h,H,f[v>>2]|0,t);ca=ga;I=I+(Y(H,h)|0)|0;g=H+g|0;da=sa}sa=(f[X>>2]|0)+g|0;f[X>>2]=sa;if((sa|0)<=(f[P>>2]|0)){u=i;return g|0}f[j>>2]=0;f[j+4>>2]=0;k=c$(j,18)|0;l=225669;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,j,225622,225433,380);d$(j);u=i;return g|0}function t9(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+16|0;i=h+8|0;j=h;_$(i,56912);if(!((f[c>>2]&4095|0)==(f[a+4>>2]|0)?(f[d>>2]&4095|0)==(f[a+8>>2]|0):0)){f[j>>2]=0;f[j+4>>2]=0;k=c$(j,46)|0;l=225386;m=k+46|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,j,345174,225433,388);d$(j)}j=Jg[f[(f[a>>2]|0)+12>>2]&63](a,c,e,g)|0;g=f[c+48>>2]|0;e=(f[c+16>>2]|0)+(Y(g,j)|0)|0;bg[f[(f[a>>2]|0)+16>>2]&127](a,e,g,(f[a+152>>2]|0)-(f[a+144>>2]|0)|0,f[d+16>>2]|0,f[d+48>>2]|0)|0;if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function u9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=g;i=b;do{f[h>>2]=0;h=(f[e>>2]|0)+4|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=g-i>>2;g=h+b|0;if(g>>>0>1073741823)gXa(a);j=d-i|0;i=j>>1;d=j>>2>>>0<536870911?(i>>>0<g>>>0?g:i):1073741823;do if(d)if(d>>>0>1073741823){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{k=NYa(d<<2)|0;break}else k=0;while(0);i=k+(h<<2)|0;h=k+(d<<2)|0;d=i;k=b;b=i;do{f[d>>2]=0;d=b+4|0;b=d;k=k+-1|0}while((k|0)!=0);k=f[a>>2]|0;d=(f[e>>2]|0)-k|0;g=i+(0-(d>>2)<<2)|0;if((d|0)>0)K1a(g|0,k|0,d|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=h;if(!k)return;PYa(k);return}function v9(a){a=a|0;f[a>>2]=56820;f[a+8>>2]=-1;f[a+4>>2]=-1;return}function w9(a){a=a|0;f[a>>2]=56840;f[a+8>>2]=-1;f[a+4>>2]=-1;return}function x9(a){a=a|0;var b=0;f[a>>2]=56864;b=a+4|0;f[b>>2]=-1;f[b+4>>2]=-1;f[b+8>>2]=-1;f[b+12>>2]=-1;return}function y9(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0;f[a>>2]=56888;f[a+4>>2]=-1;f[a+8>>2]=-1;f[a+12>>2]=-1;l=a+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[a+36>>2]=-1;f[a+40>>2]=-1;l=a+44|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[a+68>>2]=1;f[a+72>>2]=1;l=a+76|0;m=l+124|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));z9(a,b,c,d,e,g,h,i,j,k);return}function z9(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=u;u=u+16|0;n=m;o=g&4095;p=a+4|0;f[p>>2]=o;q=(g>>>3&511)+1<<(47696>>>(o<<1&14)&3);f[a+8>>2]=h&4095;h=a+12|0;f[h>>2]=i&4095;i=a+176|0;o=f[c>>2]|0;g=f[c+4>>2]|0;if(o|0){c=o+4|0;f[c>>2]=(f[c>>2]|0)+1}c=f[i>>2]|0;f[i>>2]=o;o=a+180|0;f[o>>2]=g;if(c|0?(g=c+4|0,i=f[g>>2]|0,f[g>>2]=i+-1,(i|0)==1):0)ki[f[(f[c>>2]|0)+8>>2]&2047](c);c=a+184|0;i=f[d>>2]|0;g=f[d+4>>2]|0;if(i|0){d=i+4|0;f[d>>2]=(f[d>>2]|0)+1}d=f[c>>2]|0;f[c>>2]=i;i=a+188|0;f[i>>2]=g;if(d|0?(g=d+4|0,c=f[g>>2]|0,f[g>>2]=c+-1,(c|0)==1):0)ki[f[(f[d>>2]|0)+8>>2]&2047](d);d=a+192|0;c=f[e>>2]|0;g=f[e+4>>2]|0;if(c|0){e=c+4|0;f[e>>2]=(f[e>>2]|0)+1}e=f[d>>2]|0;f[d>>2]=c;c=a+196|0;f[c>>2]=g;if(e|0?(g=e+4|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)ki[f[(f[e>>2]|0)+8>>2]&2047](e);e=(k|0)<0?j:k;k=a+68|0;f[k>>2]=j;j=a+72|0;f[j>>2]=e;if((e|0)==3){f[n>>2]=0;f[n+4>>2]=0;r=c$(n,31)|0;s=225873;t=r+31|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-215,n,225905,225433,127);d$(n)}e=f[o>>2]|0;if(!e){d=f[i>>2]|0;if((d|0)!=0?(g=f[c>>2]|0,(g|0)!=0):0){v=d;w=g}else{f[n>>2]=0;f[n+4>>2]=0;r=c$(n,25)|0;s=225910;t=r+25|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-215,n,225905,225433,131);d$(n);v=f[i>>2]|0;w=f[c>>2]|0}c=f[v+4>>2]|0;i=f[w+4>>2]|0;f[a+16>>2]=c;f[a+20>>2]=i;g=f[v+8>>2]|0;v=f[w+8>>2]|0;f[a+24>>2]=g;x=v;y=g;z=c;A=i}else{if((f[h>>2]|0)==(f[p>>2]|0))B=e;else{f[n>>2]=0;f[n+4>>2]=0;r=c$(n,18)|0;s=225936;t=r+18|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-215,n,225905,225433,137);d$(n);B=f[o>>2]|0}o=f[B+4>>2]|0;f[a+16>>2]=o;e=f[B+8>>2]|0;f[a+20>>2]=e;h=f[B+12>>2]|0;f[a+24>>2]=h;x=f[B+16>>2]|0;y=h;z=o;A=e}f[a+28>>2]=x;if((y|x|0)>-1&(y|0)<(z|0)&(x|0)<(A|0))C=z;else{f[n>>2]=0;f[n+4>>2]=0;r=c$(n,83)|0;s=225955;t=r+83|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-215,n,225905,225433,143);d$(n);C=f[a+16>>2]|0}n=q>>>((f[p>>2]|0)>>>1&2);f[a+88>>2]=n;s=C+-1|0;C=(s|0)>1?s:1;s=a+76|0;r=Y(C,n)|0;n=a+80|0;t=f[n>>2]|0;z=f[s>>2]|0;A=t-z>>2;x=z;z=t;if(r>>>0<=A>>>0){if(r>>>0<A>>>0?(t=x+(r<<2)|0,(z|0)!=(t|0)):0)f[n>>2]=z+(~((z+-4-t|0)>>>2)<<2)}else GM(s,r-A|0);f[a+140>>2]=0;f[a+32>>2]=0;A=f[a+128>>2]|0;r=a+132|0;if((f[r>>2]|0)!=(A|0))f[r>>2]=A;if(f[k>>2]|0?f[j>>2]|0:0){D=a+36|0;f[D>>2]=-1;E=a+40|0;f[E>>2]=-1;u=m;return}j=a+116|0;k=Y(C,q)|0;q=a+120|0;A=f[q>>2]|0;r=f[j>>2]|0;s=A-r|0;t=r;r=A;if(k>>>0<=s>>>0)if(k>>>0<s>>>0?(A=t+k|0,(r|0)!=(A|0)):0){f[q>>2]=A;F=t}else F=t;else{TR(j,k-s|0);F=f[j>>2]|0}j=f[p>>2]|0;p=j>>>3&511;s=p+1|0;MS(l,F,(s>>>0>4?24:p<<3)|j&7,Y(s,C)|0);D=a+36|0;f[D>>2]=-1;E=a+40|0;f[E>>2]=-1;u=m;return}function A9(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0;d=u;u=u+128|0;e=d+72|0;g=d+16|0;h=d;do if((NS(a)|0)==65536){i=f[a+4>>2]|0;f[e>>2]=f[i>>2];j=e+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=e+8|0;f[l>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];f[e+16>>2]=f[i+16>>2];f[e+20>>2]=f[i+20>>2];f[e+24>>2]=f[i+24>>2];f[e+28>>2]=f[i+28>>2];f[e+32>>2]=f[i+32>>2];m=f[i+36>>2]|0;f[e+36>>2]=m;f[e+40>>2]=l;l=e+48|0;n=e+44|0;f[n>>2]=l;f[l>>2]=0;f[e+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];o=e;break}else{f[j>>2]=0;BR(e,i);o=e;break}}else{OR(e,a,-1);o=e}while(0);if(f[o>>2]&4088|0){f[g>>2]=0;f[g+4>>2]=0;q=c$(g,23)|0;o=226039;r=q+23|0;do{b[q>>0]=b[o>>0]|0;q=q+1|0;o=o+1|0}while((q|0)<(r|0));j$(-215,g,226063,225433,407);d$(g)}o=e+8|0;a=e+12|0;i=Y(f[a>>2]|0,f[o>>2]|0)|0;f[g>>2]=1124007936;j=g+4|0;k=g+8|0;l=g+40|0;q=j;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[l>>2]=k;k=g+48|0;q=g+44|0;f[q>>2]=k;f[k>>2]=0;f[g+52>>2]=0;r=h+8|0;f[r>>2]=0;f[r+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=g;WJ(e,h,6,1.0,0.0);h=g+16|0;r=f[h>>2]|0;n=f[o>>2]|0;o=f[a>>2]|0;if((n|0)==1|(o|0)==1?(f[c>>2]<<1|1|0)==(o|0):0)s=(f[c+4>>2]<<1|1|0)==(n|0)?15:12;else s=12;if((i|0)>0){n=i+-1|0;c=0;t=0.0;o=s;while(1){v=+p[r+(c<<3)>>3];w=+p[r+(n-c<<3)>>3];a=v!=w?o&-2:o;m=v!=-w?a&-3:a;a=v<0.0?m&-5:m;m=v!=+(rNa(v)|0);x=m?a&-9:a;w=t+v;c=c+1|0;if((c|0)==(i|0)){y=w;z=x;break}else{t=w;o=x}}}else{y=0.0;z=s}s=+L(+(y+-1.0))>(+L(+y)+1.0)*1.1920928955078125e-07;o=s?z&-5:z;z=g+36|0;s=f[z>>2]|0;if(s|0?(i=s+12|0,s=f[i>>2]|0,f[i>>2]=s+-1,(s|0)==1):0)CR(g);f[z>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[j>>2]|0)>0){h=f[l>>2]|0;l=0;do{f[h+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[q>>2]|0;if((j|0)!=(k|0))ZF(j);j=e+36|0;k=f[j>>2]|0;if(k|0?(q=k+12|0,k=f[q>>2]|0,f[q>>2]=k+-1,(k|0)==1):0)CR(e);f[j>>2]=0;j=e+16|0;k=e+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[k>>2]|0)>0){j=f[e+40>>2]|0;q=0;do{f[j+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[k>>2]|0))}k=f[e+44>>2]|0;if((k|0)==(e+48|0)){u=d;return o|0}ZF(k);u=d;return o|0}function B9(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;i=u;u=u+80|0;j=i;k=i+64|0;l=i+8|0;do if((NS(e)|0)==65536){m=f[e+4>>2]|0;f[l>>2]=f[m>>2];n=l+4|0;o=m+4|0;f[n>>2]=f[o>>2];p=l+8|0;f[p>>2]=f[m+8>>2];f[l+12>>2]=f[m+12>>2];f[l+16>>2]=f[m+16>>2];f[l+20>>2]=f[m+20>>2];f[l+24>>2]=f[m+24>>2];f[l+28>>2]=f[m+28>>2];f[l+32>>2]=f[m+32>>2];q=f[m+36>>2]|0;f[l+36>>2]=q;f[l+40>>2]=p;p=l+48|0;r=l+44|0;f[r>>2]=p;f[p>>2]=0;f[l+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[m+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[n>>2]=0;BR(l,m);break}}else OR(l,e,-1);while(0);e=c&7;m=d&7;if(!((((d^c)&4088|0)==0?(m|0)>=((e>>>0>4?e:4)|0):0)?(f[l>>2]&4095|0)==(m|0):0)){f[k>>2]=0;f[k+4>>2]=0;n=c$(k,109)|0;o=226077;p=n+109|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-215,k,226187,225433,3605);d$(k)}o=(e|0)==0;n=o&(m|0)==4;do if(h&3|0?((f[l+12>>2]|0)+(f[l+8>>2]|0)|0)<7:0){if(n){p=NYa(76)|0;C9(p,l,g,h,k);r=NYa(16)|0;q=r+4|0;f[q>>2]=1;f[r>>2]=56940;f[r+8>>2]=p;f[a>>2]=r;f[a+4>>2]=p;f[q>>2]=(f[q>>2]|0)+1;p=f[q>>2]|0;f[q>>2]=p+-1;if((p|0)==1)ki[f[(f[r>>2]|0)+8>>2]&2047](r);break}if((e|0)==5&(m|0)==5){r=NYa(76)|0;D9(r,l,g,h,k);p=NYa(16)|0;q=p+4|0;f[q>>2]=1;f[p>>2]=56960;f[p+8>>2]=r;f[a>>2]=p;f[a+4>>2]=r;f[q>>2]=(f[q>>2]|0)+1;r=f[q>>2]|0;f[q>>2]=r+-1;if((r|0)==1)ki[f[(f[p>>2]|0)+8>>2]&2047](p)}else s=25}else if(n){p=NYa(72)|0;E9(p,l,g,k);r=NYa(16)|0;q=r+4|0;f[q>>2]=1;f[r>>2]=56980;f[r+8>>2]=p;f[a>>2]=r;f[a+4>>2]=p;f[q>>2]=(f[q>>2]|0)+1;p=f[q>>2]|0;f[q>>2]=p+-1;if((p|0)==1)ki[f[(f[r>>2]|0)+8>>2]&2047](r)}else s=25;while(0);do if((s|0)==25){n=(m|0)==5;if(o&n){h=NYa(72)|0;F9(h,l,g,k);r=NYa(16)|0;p=r+4|0;f[p>>2]=1;f[r>>2]=57e3;f[r+8>>2]=h;f[a>>2]=r;f[a+4>>2]=h;f[p>>2]=(f[p>>2]|0)+1;h=f[p>>2]|0;f[p>>2]=h+-1;if((h|0)!=1)break;ki[f[(f[r>>2]|0)+8>>2]&2047](r);break}r=(m|0)==6;if(o&r){h=NYa(72)|0;G9(h,l,g,k);p=NYa(16)|0;q=p+4|0;f[q>>2]=1;f[p>>2]=57020;f[p+8>>2]=h;f[a>>2]=p;f[a+4>>2]=h;f[q>>2]=(f[q>>2]|0)+1;h=f[q>>2]|0;f[q>>2]=h+-1;if((h|0)!=1)break;ki[f[(f[p>>2]|0)+8>>2]&2047](p);break}p=(e|0)==2;if(p&n){h=NYa(72)|0;H9(h,l,g,k);q=NYa(16)|0;t=q+4|0;f[t>>2]=1;f[q>>2]=57040;f[q+8>>2]=h;f[a>>2]=q;f[a+4>>2]=h;f[t>>2]=(f[t>>2]|0)+1;h=f[t>>2]|0;f[t>>2]=h+-1;if((h|0)!=1)break;ki[f[(f[q>>2]|0)+8>>2]&2047](q);break}if(p&r){p=NYa(72)|0;I9(p,l,g,k);q=NYa(16)|0;h=q+4|0;f[h>>2]=1;f[q>>2]=57060;f[q+8>>2]=p;f[a>>2]=q;f[a+4>>2]=p;f[h>>2]=(f[h>>2]|0)+1;p=f[h>>2]|0;f[h>>2]=p+-1;if((p|0)!=1)break;ki[f[(f[q>>2]|0)+8>>2]&2047](q);break}q=(e|0)==3;if(q&n){p=NYa(72)|0;J9(p,l,g,k);h=NYa(16)|0;t=h+4|0;f[t>>2]=1;f[h>>2]=57080;f[h+8>>2]=p;f[a>>2]=h;f[a+4>>2]=p;f[t>>2]=(f[t>>2]|0)+1;p=f[t>>2]|0;f[t>>2]=p+-1;if((p|0)==1)ki[f[(f[h>>2]|0)+8>>2]&2047](h);break}if(q&r){q=NYa(72)|0;K9(q,l,g,k);h=NYa(16)|0;p=h+4|0;f[p>>2]=1;f[h>>2]=57100;f[h+8>>2]=q;f[a>>2]=h;f[a+4>>2]=q;f[p>>2]=(f[p>>2]|0)+1;q=f[p>>2]|0;f[p>>2]=q+-1;if((q|0)!=1)break;ki[f[(f[h>>2]|0)+8>>2]&2047](h);break}h=(e|0)==5;if(h&n){n=NYa(72)|0;L9(n,l,g,k);q=NYa(16)|0;p=q+4|0;f[p>>2]=1;f[q>>2]=57120;f[q+8>>2]=n;f[a>>2]=q;f[a+4>>2]=n;f[p>>2]=(f[p>>2]|0)+1;n=f[p>>2]|0;f[p>>2]=n+-1;if((n|0)==1)ki[f[(f[q>>2]|0)+8>>2]&2047](q);break}if(h&r){h=NYa(72)|0;M9(h,l,g,k);q=NYa(16)|0;n=q+4|0;f[n>>2]=1;f[q>>2]=57140;f[q+8>>2]=h;f[a>>2]=q;f[a+4>>2]=h;f[n>>2]=(f[n>>2]|0)+1;h=f[n>>2]|0;f[n>>2]=h+-1;if((h|0)!=1)break;ki[f[(f[q>>2]|0)+8>>2]&2047](q);break}if(!((e|0)==6&r)){f[j>>2]=c;f[j+4>>2]=d;p$(k,327553,j);j$(-213,k,226187,225433,3644);d$(k);f[a>>2]=0;f[a+4>>2]=0;break}r=NYa(72)|0;N9(r,l,g,k);q=NYa(16)|0;h=q+4|0;f[h>>2]=1;f[q>>2]=57160;f[q+8>>2]=r;f[a>>2]=q;f[a+4>>2]=r;f[h>>2]=(f[h>>2]|0)+1;r=f[h>>2]|0;f[h>>2]=r+-1;if((r|0)==1)ki[f[(f[q>>2]|0)+8>>2]&2047](q)}while(0);a=l+36|0;k=f[a>>2]|0;if(k|0?(g=k+12|0,k=f[g>>2]|0,f[g>>2]=k+-1,(k|0)==1):0)CR(l);f[a>>2]=0;a=l+16|0;k=l+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[k>>2]|0)>0){a=f[l+40>>2]|0;g=0;do{f[a+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[k>>2]|0))}k=f[l+44>>2]|0;if((k|0)==(l+48|0)){u=i;return}ZF(k);u=i;return}function C9(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;Uaa(a,c,d,g);f[a>>2]=57420;f[a+72>>2]=e;if(e&3|0?(f[a+4>>2]|0)<6:0){u=h;return}f[i>>2]=0;f[i+4>>2]=0;a=c$(i,84)|0;e=227579;g=a+84|0;do{b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}while((a|0)<(g|0));j$(-215,i,227664,225433,3112);d$(i);u=h;return}function D9(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;Maa(a,c,d,g);f[a>>2]=57380;f[a+72>>2]=e;if(e&3|0?(f[a+4>>2]|0)<6:0){u=h;return}f[i>>2]=0;f[i+4>>2]=0;a=c$(i,84)|0;e=227579;g=a+84|0;do{b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}while((a|0)<(g|0));j$(-215,i,227664,225433,3112);d$(i);u=h;return}function E9(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=57360;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){CR(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)BR(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;eL(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==4?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=c$(g,77)|0;l=226291;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));j$(-215,g,226369,225433,3053);d$(g);u=e;return}function F9(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=57340;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){CR(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)BR(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;eL(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==5?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=c$(g,77)|0;l=226291;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));j$(-215,g,226369,225433,3053);d$(g);u=e;return}function G9(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=57320;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){CR(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)BR(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;eL(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==6?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=c$(g,77)|0;l=226291;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));j$(-215,g,226369,225433,3053);d$(g);u=e;return}function H9(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=57300;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){CR(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)BR(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;eL(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==5?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=c$(g,77)|0;l=226291;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));j$(-215,g,226369,225433,3053);d$(g);u=e;return}function I9(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=57280;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){CR(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)BR(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;eL(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==6?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=c$(g,77)|0;l=226291;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));j$(-215,g,226369,225433,3053);d$(g);u=e;return}function J9(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=57260;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){CR(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)BR(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;eL(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==5?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=c$(g,77)|0;l=226291;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));j$(-215,g,226369,225433,3053);d$(g);u=e;return}function K9(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=57240;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){CR(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)BR(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;eL(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==6?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=c$(g,77)|0;l=226291;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));j$(-215,g,226369,225433,3053);d$(g);u=e;return}function L9(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=57220;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){CR(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)BR(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;eL(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==5?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=c$(g,77)|0;l=226291;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));j$(-215,g,226369,225433,3053);d$(g);u=e;return}function M9(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=57200;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){CR(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)BR(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;eL(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==6?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=c$(g,77)|0;l=226291;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));j$(-215,g,226369,225433,3053);d$(g);u=e;return}function N9(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=57180;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){CR(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)BR(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;eL(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==6?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=c$(g,77)|0;l=226291;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));j$(-215,g,226369,225433,3053);d$(g);u=e;return}function O9(a){a=a|0;PYa(a);return}function P9(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Q9(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57180;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function R9(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57180;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function S9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0,r=0,s=0.0,t=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)j=0;else{k=0;do{l=b+(k<<3)|0;m=+p[h>>3];n=m*+p[l+8>>3];o=m*+p[l+16>>3];q=m*+p[l+24>>3];p[c+(k<<3)>>3]=m*+p[l>>3];p[c+((k|1)<<3)>>3]=n;p[c+((k|2)<<3)>>3]=o;p[c+((k|3)<<3)>>3]=q;k=k+4|0}while((k|0)<=(d|0));i=a&-4;break}do{k=b+(j<<3)|0;q=+p[h>>3];l=k;r=1;o=q*+p[k>>3];n=q*+p[k+8>>3];m=q*+p[k+16>>3];s=q*+p[k+24>>3];do{l=l+(e<<3)|0;q=+p[h+(r<<3)>>3];o=o+q*+p[l>>3];n=n+q*+p[l+8>>3];m=m+q*+p[l+16>>3];s=s+q*+p[l+24>>3];r=r+1|0}while((r|0)!=(g|0));p[c+(j<<3)>>3]=o;p[c+((j|1)<<3)>>3]=n;p[c+((j|2)<<3)>>3]=m;p[c+((j|3)<<3)>>3]=s;j=j+4|0}while((j|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)t=i;else{d=i;do{p[c+(d<<3)>>3]=+p[h>>3]*+p[b+(d<<3)>>3];d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(t<<3)|0;i=d;j=1;q=+p[h>>3]*+p[d>>3];do{i=i+(e<<3)|0;q=q+ +p[h+(j<<3)>>3]*+p[i>>3];j=j+1|0}while((j|0)!=(g|0));p[c+(t<<3)>>3]=q;t=t+1|0}while((t|0)!=(a|0));return}function T9(a){a=a|0;PYa(a);return}function U9(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function V9(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57200;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function W9(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57200;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function X9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)j=0;else{k=0;do{l=b+(k<<2)|0;m=+p[h>>3];o=m*+n[l+4>>2];q=m*+n[l+8>>2];r=m*+n[l+12>>2];p[c+(k<<3)>>3]=m*+n[l>>2];p[c+((k|1)<<3)>>3]=o;p[c+((k|2)<<3)>>3]=q;p[c+((k|3)<<3)>>3]=r;k=k+4|0}while((k|0)<=(d|0));i=a&-4;break}do{k=b+(j<<2)|0;r=+p[h>>3];l=k;s=1;q=r*+n[k>>2];o=r*+n[k+4>>2];m=r*+n[k+8>>2];t=r*+n[k+12>>2];do{l=l+(e<<2)|0;r=+p[h+(s<<3)>>3];q=q+r*+n[l>>2];o=o+r*+n[l+4>>2];m=m+r*+n[l+8>>2];t=t+r*+n[l+12>>2];s=s+1|0}while((s|0)!=(g|0));p[c+(j<<3)>>3]=q;p[c+((j|1)<<3)>>3]=o;p[c+((j|2)<<3)>>3]=m;p[c+((j|3)<<3)>>3]=t;j=j+4|0}while((j|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)u=i;else{d=i;do{p[c+(d<<3)>>3]=+p[h>>3]*+n[b+(d<<2)>>2];d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(u<<2)|0;i=d;j=1;r=+p[h>>3]*+n[d>>2];do{i=i+(e<<2)|0;r=r+ +p[h+(j<<3)>>3]*+n[i>>2];j=j+1|0}while((j|0)!=(g|0));p[c+(u<<3)>>3]=r;u=u+1|0}while((u|0)!=(a|0));return}function Y9(a){a=a|0;PYa(a);return}function Z9(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function _9(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57220;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function $9(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57220;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function aaa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0.0,t=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)j=0;else{k=0;do{l=b+(k<<2)|0;m=+n[h>>2];o=m*+n[l+4>>2];p=m*+n[l+8>>2];q=m*+n[l+12>>2];n[c+(k<<2)>>2]=m*+n[l>>2];n[c+((k|1)<<2)>>2]=o;n[c+((k|2)<<2)>>2]=p;n[c+((k|3)<<2)>>2]=q;k=k+4|0}while((k|0)<=(d|0));i=a&-4;break}do{k=b+(j<<2)|0;q=+n[h>>2];l=k;r=1;p=q*+n[k>>2];o=q*+n[k+4>>2];m=q*+n[k+8>>2];s=q*+n[k+12>>2];do{l=l+(e<<2)|0;q=+n[h+(r<<2)>>2];p=p+q*+n[l>>2];o=o+q*+n[l+4>>2];m=m+q*+n[l+8>>2];s=s+q*+n[l+12>>2];r=r+1|0}while((r|0)!=(g|0));n[c+(j<<2)>>2]=p;n[c+((j|1)<<2)>>2]=o;n[c+((j|2)<<2)>>2]=m;n[c+((j|3)<<2)>>2]=s;j=j+4|0}while((j|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)t=i;else{d=i;do{n[c+(d<<2)>>2]=+n[h>>2]*+n[b+(d<<2)>>2];d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(t<<2)|0;i=d;j=1;q=+n[h>>2]*+n[d>>2];do{i=i+(e<<2)|0;q=q+ +n[h+(j<<2)>>2]*+n[i>>2];j=j+1|0}while((j|0)!=(g|0));n[c+(t<<2)>>2]=q;t=t+1|0}while((t|0)!=(a|0));return}function baa(a){a=a|0;PYa(a);return}function caa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function daa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57240;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function eaa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57240;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function faa(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0;h=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(g,e)|0;e=a+-4|0;do if((a|0)<4)j=0;else{if((h|0)>1)k=0;else{l=0;do{m=b+(l<<1)|0;n=+p[i>>3];o=n*+(d[m+2>>1]|0);q=n*+(d[m+4>>1]|0);r=n*+(d[m+6>>1]|0);p[c+(l<<3)>>3]=n*+(d[m>>1]|0);p[c+((l|1)<<3)>>3]=o;p[c+((l|2)<<3)>>3]=q;p[c+((l|3)<<3)>>3]=r;l=l+4|0}while((l|0)<=(e|0));j=a&-4;break}do{l=b+(k<<1)|0;r=+p[i>>3];m=l;s=1;q=r*+(d[l>>1]|0);o=r*+(d[l+2>>1]|0);n=r*+(d[l+4>>1]|0);t=r*+(d[l+6>>1]|0);do{m=m+(g<<1)|0;r=+p[i+(s<<3)>>3];q=q+r*+(d[m>>1]|0);o=o+r*+(d[m+2>>1]|0);n=n+r*+(d[m+4>>1]|0);t=t+r*+(d[m+6>>1]|0);s=s+1|0}while((s|0)!=(h|0));p[c+(k<<3)>>3]=q;p[c+((k|1)<<3)>>3]=o;p[c+((k|2)<<3)>>3]=n;p[c+((k|3)<<3)>>3]=t;k=k+4|0}while((k|0)<=(e|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((h|0)>1)u=j;else{e=j;do{p[c+(e<<3)>>3]=+p[i>>3]*+(d[b+(e<<1)>>1]|0);e=e+1|0}while((e|0)!=(a|0));return}do{e=b+(u<<1)|0;j=e;k=1;r=+p[i>>3]*+(d[e>>1]|0);do{j=j+(g<<1)|0;r=r+ +p[i+(k<<3)>>3]*+(d[j>>1]|0);k=k+1|0}while((k|0)!=(h|0));p[c+(u<<3)>>3]=r;u=u+1|0}while((u|0)!=(a|0));return}function gaa(a){a=a|0;PYa(a);return}function haa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function iaa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57260;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function jaa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57260;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function kaa(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0;h=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(g,e)|0;e=a+-4|0;do if((a|0)<4)j=0;else{if((h|0)>1)k=0;else{l=0;do{m=b+(l<<1)|0;o=+n[i>>2];p=o*+(d[m+2>>1]|0);q=o*+(d[m+4>>1]|0);r=o*+(d[m+6>>1]|0);n[c+(l<<2)>>2]=o*+(d[m>>1]|0);n[c+((l|1)<<2)>>2]=p;n[c+((l|2)<<2)>>2]=q;n[c+((l|3)<<2)>>2]=r;l=l+4|0}while((l|0)<=(e|0));j=a&-4;break}do{l=b+(k<<1)|0;r=+n[i>>2];m=l;s=1;q=r*+(d[l>>1]|0);p=r*+(d[l+2>>1]|0);o=r*+(d[l+4>>1]|0);t=r*+(d[l+6>>1]|0);do{m=m+(g<<1)|0;r=+n[i+(s<<2)>>2];q=q+r*+(d[m>>1]|0);p=p+r*+(d[m+2>>1]|0);o=o+r*+(d[m+4>>1]|0);t=t+r*+(d[m+6>>1]|0);s=s+1|0}while((s|0)!=(h|0));n[c+(k<<2)>>2]=q;n[c+((k|1)<<2)>>2]=p;n[c+((k|2)<<2)>>2]=o;n[c+((k|3)<<2)>>2]=t;k=k+4|0}while((k|0)<=(e|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((h|0)>1)u=j;else{e=j;do{n[c+(e<<2)>>2]=+n[i>>2]*+(d[b+(e<<1)>>1]|0);e=e+1|0}while((e|0)!=(a|0));return}do{e=b+(u<<1)|0;j=e;k=1;r=+n[i>>2]*+(d[e>>1]|0);do{j=j+(g<<1)|0;r=r+ +n[i+(k<<2)>>2]*+(d[j>>1]|0);k=k+1|0}while((k|0)!=(h|0));n[c+(u<<2)>>2]=r;u=u+1|0}while((u|0)!=(a|0));return}function laa(a){a=a|0;PYa(a);return}function maa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function naa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57280;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function oaa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57280;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function paa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+(l<<1)|0;n=+p[h>>3];o=n*+(j[m+2>>1]|0);q=n*+(j[m+4>>1]|0);r=n*+(j[m+6>>1]|0);p[c+(l<<3)>>3]=n*+(j[m>>1]|0);p[c+((l|1)<<3)>>3]=o;p[c+((l|2)<<3)>>3]=q;p[c+((l|3)<<3)>>3]=r;l=l+4|0}while((l|0)<=(d|0));i=a&-4;break}do{l=b+(k<<1)|0;r=+p[h>>3];m=l;s=1;q=r*+(j[l>>1]|0);o=r*+(j[l+2>>1]|0);n=r*+(j[l+4>>1]|0);t=r*+(j[l+6>>1]|0);do{m=m+(e<<1)|0;r=+p[h+(s<<3)>>3];q=q+r*+(j[m>>1]|0);o=o+r*+(j[m+2>>1]|0);n=n+r*+(j[m+4>>1]|0);t=t+r*+(j[m+6>>1]|0);s=s+1|0}while((s|0)!=(g|0));p[c+(k<<3)>>3]=q;p[c+((k|1)<<3)>>3]=o;p[c+((k|2)<<3)>>3]=n;p[c+((k|3)<<3)>>3]=t;k=k+4|0}while((k|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)u=i;else{d=i;do{p[c+(d<<3)>>3]=+p[h>>3]*+(j[b+(d<<1)>>1]|0);d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(u<<1)|0;i=d;k=1;r=+p[h>>3]*+(j[d>>1]|0);do{i=i+(e<<1)|0;r=r+ +p[h+(k<<3)>>3]*+(j[i>>1]|0);k=k+1|0}while((k|0)!=(g|0));p[c+(u<<3)>>3]=r;u=u+1|0}while((u|0)!=(a|0));return}function qaa(a){a=a|0;PYa(a);return}function raa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function saa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57300;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function taa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57300;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function uaa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+(l<<1)|0;o=+n[h>>2];p=o*+(j[m+2>>1]|0);q=o*+(j[m+4>>1]|0);r=o*+(j[m+6>>1]|0);n[c+(l<<2)>>2]=o*+(j[m>>1]|0);n[c+((l|1)<<2)>>2]=p;n[c+((l|2)<<2)>>2]=q;n[c+((l|3)<<2)>>2]=r;l=l+4|0}while((l|0)<=(d|0));i=a&-4;break}do{l=b+(k<<1)|0;r=+n[h>>2];m=l;s=1;q=r*+(j[l>>1]|0);p=r*+(j[l+2>>1]|0);o=r*+(j[l+4>>1]|0);t=r*+(j[l+6>>1]|0);do{m=m+(e<<1)|0;r=+n[h+(s<<2)>>2];q=q+r*+(j[m>>1]|0);p=p+r*+(j[m+2>>1]|0);o=o+r*+(j[m+4>>1]|0);t=t+r*+(j[m+6>>1]|0);s=s+1|0}while((s|0)!=(g|0));n[c+(k<<2)>>2]=q;n[c+((k|1)<<2)>>2]=p;n[c+((k|2)<<2)>>2]=o;n[c+((k|3)<<2)>>2]=t;k=k+4|0}while((k|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)u=i;else{d=i;do{n[c+(d<<2)>>2]=+n[h>>2]*+(j[b+(d<<1)>>1]|0);d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(u<<1)|0;i=d;k=1;r=+n[h>>2]*+(j[d>>1]|0);do{i=i+(e<<1)|0;r=r+ +n[h+(k<<2)>>2]*+(j[i>>1]|0);k=k+1|0}while((k|0)!=(g|0));n[c+(u<<2)>>2]=r;u=u+1|0}while((u|0)!=(a|0));return}function vaa(a){a=a|0;PYa(a);return}function waa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function xaa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57320;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function yaa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57320;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function zaa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0;g=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)j=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+l|0;n=+p[i>>3];o=n*+(h[m+1>>0]|0);q=n*+(h[m+2>>0]|0);r=n*+(h[m+3>>0]|0);p[c+(l<<3)>>3]=n*+(h[m>>0]|0);p[c+((l|1)<<3)>>3]=o;p[c+((l|2)<<3)>>3]=q;p[c+((l|3)<<3)>>3]=r;l=l+4|0}while((l|0)<=(d|0));j=a&-4;break}do{l=b+k|0;r=+p[i>>3];m=l;s=1;q=r*+(h[l>>0]|0);o=r*+(h[l+1>>0]|0);n=r*+(h[l+2>>0]|0);t=r*+(h[l+3>>0]|0);do{m=m+e|0;r=+p[i+(s<<3)>>3];q=q+r*+(h[m>>0]|0);o=o+r*+(h[m+1>>0]|0);n=n+r*+(h[m+2>>0]|0);t=t+r*+(h[m+3>>0]|0);s=s+1|0}while((s|0)!=(g|0));p[c+(k<<3)>>3]=q;p[c+((k|1)<<3)>>3]=o;p[c+((k|2)<<3)>>3]=n;p[c+((k|3)<<3)>>3]=t;k=k+4|0}while((k|0)<=(d|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((g|0)>1)u=j;else{d=j;do{p[c+(d<<3)>>3]=+p[i>>3]*+(h[b+d>>0]|0);d=d+1|0}while((d|0)!=(a|0));return}do{d=b+u|0;j=d;k=1;r=+p[i>>3]*+(h[d>>0]|0);do{j=j+e|0;r=r+ +p[i+(k<<3)>>3]*+(h[j>>0]|0);k=k+1|0}while((k|0)!=(g|0));p[c+(u<<3)>>3]=r;u=u+1|0}while((u|0)!=(a|0));return}function Aaa(a){a=a|0;PYa(a);return}function Baa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Caa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57340;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function Daa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57340;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function Eaa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0;g=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)j=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+l|0;o=+n[i>>2];p=o*+(h[m+1>>0]|0);q=o*+(h[m+2>>0]|0);r=o*+(h[m+3>>0]|0);n[c+(l<<2)>>2]=o*+(h[m>>0]|0);n[c+((l|1)<<2)>>2]=p;n[c+((l|2)<<2)>>2]=q;n[c+((l|3)<<2)>>2]=r;l=l+4|0}while((l|0)<=(d|0));j=a&-4;break}do{l=b+k|0;r=+n[i>>2];m=l;s=1;q=r*+(h[l>>0]|0);p=r*+(h[l+1>>0]|0);o=r*+(h[l+2>>0]|0);t=r*+(h[l+3>>0]|0);do{m=m+e|0;r=+n[i+(s<<2)>>2];q=q+r*+(h[m>>0]|0);p=p+r*+(h[m+1>>0]|0);o=o+r*+(h[m+2>>0]|0);t=t+r*+(h[m+3>>0]|0);s=s+1|0}while((s|0)!=(g|0));n[c+(k<<2)>>2]=q;n[c+((k|1)<<2)>>2]=p;n[c+((k|2)<<2)>>2]=o;n[c+((k|3)<<2)>>2]=t;k=k+4|0}while((k|0)<=(d|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((g|0)>1)u=j;else{d=j;do{n[c+(d<<2)>>2]=+n[i>>2]*+(h[b+d>>0]|0);d=d+1|0}while((d|0)!=(a|0));return}do{d=b+u|0;j=d;k=1;r=+n[i>>2]*+(h[d>>0]|0);do{j=j+e|0;r=r+ +n[i+(k<<2)>>2]*+(h[j>>0]|0);k=k+1|0}while((k|0)!=(g|0));n[c+(u<<2)>>2]=r;u=u+1|0}while((u|0)!=(a|0));return}function Faa(a){a=a|0;PYa(a);return}function Gaa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Haa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57360;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function Iaa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57360;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function Jaa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)j=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+l|0;n=f[i>>2]|0;o=Y(h[m>>0]|0,n)|0;p=Y(h[m+1>>0]|0,n)|0;q=Y(h[m+2>>0]|0,n)|0;r=Y(h[m+3>>0]|0,n)|0;f[c+(l<<2)>>2]=o;f[c+((l|1)<<2)>>2]=p;f[c+((l|2)<<2)>>2]=q;f[c+((l|3)<<2)>>2]=r;l=l+4|0}while((l|0)<=(d|0));j=a&-4;break}do{l=b+k|0;r=f[i>>2]|0;q=Y(h[l>>0]|0,r)|0;p=Y(h[l+1>>0]|0,r)|0;o=Y(h[l+2>>0]|0,r)|0;n=l;m=1;s=q;q=p;p=o;o=Y(h[l+3>>0]|0,r)|0;do{n=n+e|0;r=f[i+(m<<2)>>2]|0;s=(Y(h[n>>0]|0,r)|0)+s|0;q=(Y(h[n+1>>0]|0,r)|0)+q|0;p=(Y(h[n+2>>0]|0,r)|0)+p|0;o=(Y(h[n+3>>0]|0,r)|0)+o|0;m=m+1|0}while((m|0)!=(g|0));f[c+(k<<2)>>2]=s;f[c+((k|1)<<2)>>2]=q;f[c+((k|2)<<2)>>2]=p;f[c+((k|3)<<2)>>2]=o;k=k+4|0}while((k|0)<=(d|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((g|0)>1)t=j;else{d=j;do{j=Y(h[b+d>>0]|0,f[i>>2]|0)|0;f[c+(d<<2)>>2]=j;d=d+1|0}while((d|0)!=(a|0));return}do{d=b+t|0;j=d;k=1;m=Y(h[d>>0]|0,f[i>>2]|0)|0;do{j=j+e|0;m=(Y(h[j>>0]|0,f[i+(k<<2)>>2]|0)|0)+m|0;k=k+1|0}while((k|0)!=(g|0));f[c+(t<<2)>>2]=m;t=t+1|0}while((t|0)!=(a|0));return}function Kaa(a){a=a|0;PYa(a);return}function Laa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Maa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=57400;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){CR(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)BR(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;eL(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==5?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=c$(g,77)|0;l=226291;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));j$(-215,g,226369,225433,3053);d$(g);u=e;return}function Naa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57400;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function Oaa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57400;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function Paa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0.0,t=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)j=0;else{k=0;do{l=b+(k<<2)|0;m=+n[h>>2];o=m*+n[l+4>>2];p=m*+n[l+8>>2];q=m*+n[l+12>>2];n[c+(k<<2)>>2]=m*+n[l>>2];n[c+((k|1)<<2)>>2]=o;n[c+((k|2)<<2)>>2]=p;n[c+((k|3)<<2)>>2]=q;k=k+4|0}while((k|0)<=(d|0));i=a&-4;break}do{k=b+(j<<2)|0;q=+n[h>>2];l=k;r=1;p=q*+n[k>>2];o=q*+n[k+4>>2];m=q*+n[k+8>>2];s=q*+n[k+12>>2];do{l=l+(e<<2)|0;q=+n[h+(r<<2)>>2];p=p+q*+n[l>>2];o=o+q*+n[l+4>>2];m=m+q*+n[l+8>>2];s=s+q*+n[l+12>>2];r=r+1|0}while((r|0)!=(g|0));n[c+(j<<2)>>2]=p;n[c+((j|1)<<2)>>2]=o;n[c+((j|2)<<2)>>2]=m;n[c+((j|3)<<2)>>2]=s;j=j+4|0}while((j|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)t=i;else{d=i;do{n[c+(d<<2)>>2]=+n[h>>2]*+n[b+(d<<2)>>2];d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(t<<2)|0;i=d;j=1;q=+n[h>>2]*+n[d>>2];do{i=i+(e<<2)|0;q=q+ +n[h+(j<<2)>>2]*+n[i>>2];j=j+1|0}while((j|0)!=(g|0));n[c+(t<<2)>>2]=q;t=t+1|0}while((t|0)!=(a|0));return}function Qaa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57400;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function Raa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0;g=f[a+4>>2]|0;h=(g|0)/2|0;i=Y(h,e)|0;j=(f[a+28>>2]|0)+(h<<2)|0;k=b+(i<<2)|0;l=Y(e,d)|0;if(!(f[a+72>>2]&1)){a:do switch(g|0){case 3:{m=+n[j+4>>2];a=l+-2|0;d=(l|0)<2;if(+n[j>>2]==0.0&m==1.0){if(d){o=k;p=0;break a}q=0-e|0;r=e+1|0;s=1-e|0;t=a>>>1;u=t<<1;v=b+((i<<2)+(t<<3)+8)|0;t=k;w=0;while(1){x=+n[t+(r<<2)>>2]-+n[t+(s<<2)>>2];n[c+(w<<2)>>2]=+n[t+(e<<2)>>2]-+n[t+(q<<2)>>2];n[c+((w|1)<<2)>>2]=x;w=w+2|0;if((w|0)>(a|0))break;else t=t+8|0}o=v;p=u+2|0;break a}else{if(d){o=k;p=0;break a}t=0-e|0;w=e+1|0;q=1-e|0;s=a>>>1;r=s<<1;y=b+((i<<2)+(s<<3)+8)|0;s=k;z=0;while(1){x=m*(+n[s+(w<<2)>>2]-+n[s+(q<<2)>>2]);n[c+(z<<2)>>2]=m*(+n[s+(e<<2)>>2]-+n[s+(t<<2)>>2]);n[c+((z|1)<<2)>>2]=x;z=z+2|0;if((z|0)>(a|0))break;else s=s+8|0}o=y;p=r+2|0;break a}break}case 5:{m=+n[j+4>>2];x=+n[j+8>>2];s=l+-2|0;if((l|0)<2){o=k;p=0}else{a=0-e|0;z=e<<1;t=a<<1;q=e+1|0;w=1-e|0;d=z|1;u=1-z|0;v=s>>>1;A=v<<1;B=b+((i<<2)+(v<<3)+8)|0;v=k;C=0;while(1){D=m*(+n[v+(q<<2)>>2]-+n[v+(w<<2)>>2])+x*(+n[v+(d<<2)>>2]-+n[v+(u<<2)>>2]);n[c+(C<<2)>>2]=m*(+n[v+(e<<2)>>2]-+n[v+(a<<2)>>2])+x*(+n[v+(z<<2)>>2]-+n[v+(t<<2)>>2]);n[c+((C|1)<<2)>>2]=D;C=C+2|0;if((C|0)>(s|0))break;else v=v+8|0}o=B;p=A+2|0}break}default:{o=k;p=0}}while(0);if((p|0)>=(l|0))return;if((g|0)<2){v=o;s=p;while(1){n[c+(s<<2)>>2]=+n[j>>2]*+n[v>>2];s=s+1|0;if((s|0)==(l|0))break;else v=v+4|0}return}else{E=o;F=p}while(1){p=e;o=1;x=+n[j>>2]*+n[E>>2];while(1){x=x+ +n[j+(o<<2)>>2]*(+n[E+(p<<2)>>2]-+n[E+(0-p<<2)>>2]);if((o|0)>=(h|0))break;else{p=p+e|0;o=o+1|0}}n[c+(F<<2)>>2]=x;F=F+1|0;if((F|0)==(l|0))break;else E=E+4|0}return}b:do switch(g|0){case 1:{if(+n[j>>2]==1.0?(E=l+-2|0,(l|0)>=2):0){F=E>>>1;o=F<<1;p=b+((i<<2)+(F<<3)+8)|0;F=k;A=0;while(1){B=A|1;v=f[k+(B<<2)>>2]|0;f[c+(A<<2)>>2]=f[F>>2];f[c+(B<<2)>>2]=v;v=A+2|0;if((v|0)>(E|0))break;else{F=k+(v<<2)|0;A=v}}G=p;H=o+2|0}else{G=k;H=0}break}case 3:{x=+n[j>>2];m=+n[j+4>>2];A=m==1.0;if(x==2.0&A){F=l+-2|0;if((l|0)<2){G=k;H=0;break b}E=0-e|0;v=1-e|0;B=e+1|0;s=F>>>1;C=s<<1;t=b+((i<<2)+(s<<3)+8)|0;s=k;z=0;while(1){D=+n[s+(B<<2)>>2]+(+n[s+(v<<2)>>2]+ +n[s+4>>2]*2.0);n[c+(z<<2)>>2]=+n[s+(e<<2)>>2]+(+n[s+(E<<2)>>2]+ +n[s>>2]*2.0);n[c+((z|1)<<2)>>2]=D;z=z+2|0;if((z|0)>(F|0))break;else s=s+8|0}G=t;H=C+2|0;break b}s=l+-2|0;F=(l|0)<2;if(x==-2.0&A){if(F){G=k;H=0;break b}z=0-e|0;E=1-e|0;v=e+1|0;B=s>>>1;o=B<<1;p=b+((i<<2)+(B<<3)+8)|0;B=k;a=0;while(1){D=+n[B+(v<<2)>>2]+(+n[B+(E<<2)>>2]-+n[B+4>>2]*2.0);n[c+(a<<2)>>2]=+n[B+(e<<2)>>2]+(+n[B+(z<<2)>>2]-+n[B>>2]*2.0);n[c+((a|1)<<2)>>2]=D;a=a+2|0;if((a|0)>(s|0))break;else B=B+8|0}G=p;H=o+2|0;break b}else{if(F){G=k;H=0;break b}B=0-e|0;a=1-e|0;z=e+1|0;E=s>>>1;v=E<<1;A=b+((i<<2)+(E<<3)+8)|0;E=k;C=0;while(1){D=x*+n[E+4>>2]+m*(+n[E+(a<<2)>>2]+ +n[E+(z<<2)>>2]);n[c+(C<<2)>>2]=x*+n[E>>2]+m*(+n[E+(B<<2)>>2]+ +n[E+(e<<2)>>2]);n[c+((C|1)<<2)>>2]=D;C=C+2|0;if((C|0)>(s|0))break;else E=E+8|0}G=A;H=v+2|0;break b}break}case 5:{m=+n[j>>2];x=+n[j+4>>2];D=+n[j+8>>2];E=l+-2|0;s=(l|0)<2;if(m==-2.0&x==0.0&D==1.0){if(s){G=k;H=0;break b}C=0-e<<1;B=e<<1;z=1-B|0;a=B|1;F=E>>>1;o=F<<1;p=b+((i<<2)+(F<<3)+8)|0;F=k;t=0;while(1){I=+n[F+(z<<2)>>2]-+n[F+4>>2]*2.0+ +n[F+(a<<2)>>2];n[c+(t<<2)>>2]=+n[F+(C<<2)>>2]-+n[F>>2]*2.0+ +n[F+(B<<2)>>2];n[c+((t|1)<<2)>>2]=I;t=t+2|0;if((t|0)>(E|0))break;else F=F+8|0}G=p;H=o+2|0;break b}else{if(s){G=k;H=0;break b}F=0-e|0;t=F<<1;B=e<<1;C=1-e|0;a=e+1|0;z=1-B|0;v=B|1;A=E>>>1;u=A<<1;d=b+((i<<2)+(A<<3)+8)|0;A=k;w=0;while(1){I=m*+n[A+4>>2]+x*(+n[A+(C<<2)>>2]+ +n[A+(a<<2)>>2])+D*(+n[A+(z<<2)>>2]+ +n[A+(v<<2)>>2]);n[c+(w<<2)>>2]=m*+n[A>>2]+x*(+n[A+(F<<2)>>2]+ +n[A+(e<<2)>>2])+D*(+n[A+(t<<2)>>2]+ +n[A+(B<<2)>>2]);n[c+((w|1)<<2)>>2]=I;w=w+2|0;if((w|0)>(E|0))break;else A=A+8|0}G=d;H=u+2|0;break b}break}default:{G=k;H=0}}while(0);if((H|0)>=(l|0))return;if((g|0)<2){g=G;k=H;while(1){n[c+(k<<2)>>2]=+n[j>>2]*+n[g>>2];k=k+1|0;if((k|0)==(l|0))break;else g=g+4|0}return}else{J=G;K=H}while(1){H=e;G=1;D=+n[j>>2]*+n[J>>2];while(1){D=D+ +n[j+(G<<2)>>2]*(+n[J+(H<<2)>>2]+ +n[J+(0-H<<2)>>2]);if((G|0)>=(h|0))break;else{H=H+e|0;G=G+1|0}}n[c+(K<<2)>>2]=D;K=K+1|0;if((K|0)==(l|0))break;else J=J+4|0}return}function Saa(a){a=a|0;PYa(a);return}function Taa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Uaa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=57440;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){CR(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)BR(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;eL(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==4?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=c$(g,77)|0;l=226291;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));j$(-215,g,226369,225433,3053);d$(g);u=e;return}function Vaa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57440;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function Waa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57440;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function Xaa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)j=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+l|0;n=f[i>>2]|0;o=Y(h[m>>0]|0,n)|0;p=Y(h[m+1>>0]|0,n)|0;q=Y(h[m+2>>0]|0,n)|0;r=Y(h[m+3>>0]|0,n)|0;f[c+(l<<2)>>2]=o;f[c+((l|1)<<2)>>2]=p;f[c+((l|2)<<2)>>2]=q;f[c+((l|3)<<2)>>2]=r;l=l+4|0}while((l|0)<=(d|0));j=a&-4;break}do{l=b+k|0;r=f[i>>2]|0;q=Y(h[l>>0]|0,r)|0;p=Y(h[l+1>>0]|0,r)|0;o=Y(h[l+2>>0]|0,r)|0;n=l;m=1;s=q;q=p;p=o;o=Y(h[l+3>>0]|0,r)|0;do{n=n+e|0;r=f[i+(m<<2)>>2]|0;s=(Y(h[n>>0]|0,r)|0)+s|0;q=(Y(h[n+1>>0]|0,r)|0)+q|0;p=(Y(h[n+2>>0]|0,r)|0)+p|0;o=(Y(h[n+3>>0]|0,r)|0)+o|0;m=m+1|0}while((m|0)!=(g|0));f[c+(k<<2)>>2]=s;f[c+((k|1)<<2)>>2]=q;f[c+((k|2)<<2)>>2]=p;f[c+((k|3)<<2)>>2]=o;k=k+4|0}while((k|0)<=(d|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((g|0)>1)t=j;else{d=j;do{j=Y(h[b+d>>0]|0,f[i>>2]|0)|0;f[c+(d<<2)>>2]=j;d=d+1|0}while((d|0)!=(a|0));return}do{d=b+t|0;j=d;k=1;m=Y(h[d>>0]|0,f[i>>2]|0)|0;do{j=j+e|0;m=(Y(h[j>>0]|0,f[i+(k<<2)>>2]|0)|0)+m|0;k=k+1|0}while((k|0)!=(g|0));f[c+(t<<2)>>2]=m;t=t+1|0}while((t|0)!=(a|0));return}function Yaa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57440;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function Zaa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=f[a+4>>2]|0;i=(g|0)/2|0;j=Y(i,e)|0;k=(f[a+28>>2]|0)+(i<<2)|0;l=b+j|0;m=Y(e,d)|0;if(!(f[a+72>>2]&1)){a:do switch(g|0){case 3:{a=f[k+4>>2]|0;d=m+-2|0;n=(m|0)<2;if((f[k>>2]|0)==0&(a|0)==1){if(n){o=l;p=0;break a}q=0-e|0;r=e+1|0;s=1-e|0;t=d&-2;u=j+t+2|0;v=l;w=0;while(1){x=(h[v+r>>0]|0)-(h[v+s>>0]|0)|0;f[c+(w<<2)>>2]=(h[v+e>>0]|0)-(h[v+q>>0]|0);f[c+((w|1)<<2)>>2]=x;w=w+2|0;if((w|0)>(d|0))break;else v=v+2|0}o=b+u|0;p=t+2|0;break a}else{if(n){o=l;p=0;break a}v=0-e|0;w=e+1|0;q=1-e|0;s=d&-2;r=j+s+2|0;x=l;y=0;while(1){z=Y((h[x+e>>0]|0)-(h[x+v>>0]|0)|0,a)|0;A=Y((h[x+w>>0]|0)-(h[x+q>>0]|0)|0,a)|0;f[c+(y<<2)>>2]=z;f[c+((y|1)<<2)>>2]=A;y=y+2|0;if((y|0)>(d|0))break;else x=x+2|0}o=b+r|0;p=s+2|0;break a}break}case 5:{x=f[k+4>>2]|0;d=f[k+8>>2]|0;y=m+-2|0;if((m|0)<2){o=l;p=0}else{a=0-e|0;q=e<<1;w=a<<1;v=e+1|0;n=1-e|0;t=q|1;u=1-q|0;A=y&-2;z=j+A+2|0;B=l;C=0;while(1){D=Y((h[B+e>>0]|0)-(h[B+a>>0]|0)|0,x)|0;E=(Y((h[B+q>>0]|0)-(h[B+w>>0]|0)|0,d)|0)+D|0;D=Y((h[B+v>>0]|0)-(h[B+n>>0]|0)|0,x)|0;F=(Y((h[B+t>>0]|0)-(h[B+u>>0]|0)|0,d)|0)+D|0;f[c+(C<<2)>>2]=E;f[c+((C|1)<<2)>>2]=F;C=C+2|0;if((C|0)>(y|0))break;else B=B+2|0}o=b+z|0;p=A+2|0}break}default:{o=l;p=0}}while(0);if((p|0)>=(m|0))return;if((g|0)<2){B=o;y=p;while(1){C=Y(h[B>>0]|0,f[k>>2]|0)|0;f[c+(y<<2)>>2]=C;y=y+1|0;if((y|0)==(m|0))break;else B=B+1|0}return}else{G=o;H=p}while(1){p=e;o=1;B=Y(h[G>>0]|0,f[k>>2]|0)|0;while(1){B=(Y((h[G+p>>0]|0)-(h[G+(0-p)>>0]|0)|0,f[k+(o<<2)>>2]|0)|0)+B|0;if((o|0)>=(i|0))break;else{p=p+e|0;o=o+1|0}}f[c+(H<<2)>>2]=B;H=H+1|0;if((H|0)==(m|0))break;else G=G+1|0}return}b:do switch(g|0){case 1:{if((f[k>>2]|0)==1?(G=m+-2|0,(m|0)>=2):0){H=G&-2;o=j+H+2|0;p=l;A=0;while(1){z=A|1;y=h[l+z>>0]|0;f[c+(A<<2)>>2]=h[p>>0];f[c+(z<<2)>>2]=y;y=A+2|0;if((y|0)>(G|0))break;else{p=l+y|0;A=y}}I=b+o|0;J=H+2|0}else{I=l;J=0}break}case 3:{A=f[k>>2]|0;p=f[k+4>>2]|0;G=(p|0)==1;if((A|0)==2&G){B=m+-2|0;if((m|0)<2){I=l;J=0;break b}y=0-e|0;z=1-e|0;C=e+1|0;d=B&-2;u=j+d+2|0;t=l;x=0;while(1){n=((h[t+1>>0]|0)<<1)+(h[t+z>>0]|0)+(h[t+C>>0]|0)|0;f[c+(x<<2)>>2]=((h[t>>0]|0)<<1)+(h[t+y>>0]|0)+(h[t+e>>0]|0);f[c+((x|1)<<2)>>2]=n;x=x+2|0;if((x|0)>(B|0))break;else t=t+2|0}I=b+u|0;J=d+2|0;break b}t=m+-2|0;B=(m|0)<2;if((A|0)==-2&G){if(B){I=l;J=0;break b}x=0-e|0;y=1-e|0;C=e+1|0;z=t&-2;H=j+z+2|0;o=l;n=0;while(1){v=(h[o+y>>0]|0)-((h[o+1>>0]|0)<<1)+(h[o+C>>0]|0)|0;f[c+(n<<2)>>2]=(h[o+x>>0]|0)-((h[o>>0]|0)<<1)+(h[o+e>>0]|0);f[c+((n|1)<<2)>>2]=v;n=n+2|0;if((n|0)>(t|0))break;else o=o+2|0}I=b+H|0;J=z+2|0;break b}else{if(B){I=l;J=0;break b}o=0-e|0;n=1-e|0;x=e+1|0;C=t&-2;y=j+C+2|0;G=l;d=0;while(1){u=Y(h[G>>0]|0,A)|0;v=(Y((h[G+e>>0]|0)+(h[G+o>>0]|0)|0,p)|0)+u|0;u=Y(h[G+1>>0]|0,A)|0;w=(Y((h[G+x>>0]|0)+(h[G+n>>0]|0)|0,p)|0)+u|0;f[c+(d<<2)>>2]=v;f[c+((d|1)<<2)>>2]=w;d=d+2|0;if((d|0)>(t|0))break;else G=G+2|0}I=b+y|0;J=C+2|0;break b}break}case 5:{G=f[k>>2]|0;t=f[k+4>>2]|0;d=f[k+8>>2]|0;p=m+-2|0;n=(m|0)<2;if((G|0)==-2&(t|0)==0&(d|0)==1){if(n){I=l;J=0;break b}x=0-e<<1;A=e<<1;o=1-A|0;B=A|1;z=p&-2;H=j+z+2|0;w=l;v=0;while(1){u=Y(h[w>>0]|0,-2)|0;q=Y(h[w+1>>0]|0,-2)|0;a=q+(h[w+o>>0]|0)+(h[w+B>>0]|0)|0;f[c+(v<<2)>>2]=u+(h[w+x>>0]|0)+(h[w+A>>0]|0);f[c+((v|1)<<2)>>2]=a;v=v+2|0;if((v|0)>(p|0))break;else w=w+2|0}I=b+H|0;J=z+2|0;break b}else{if(n){I=l;J=0;break b}w=0-e|0;v=w<<1;A=e<<1;x=1-e|0;B=e+1|0;o=1-A|0;C=A|1;y=p&-2;a=j+y+2|0;u=l;q=0;while(1){s=Y(h[u>>0]|0,G)|0;r=(Y((h[u+e>>0]|0)+(h[u+w>>0]|0)|0,t)|0)+s|0;s=r+(Y((h[u+A>>0]|0)+(h[u+v>>0]|0)|0,d)|0)|0;r=Y(h[u+1>>0]|0,G)|0;F=(Y((h[u+B>>0]|0)+(h[u+x>>0]|0)|0,t)|0)+r|0;r=F+(Y((h[u+C>>0]|0)+(h[u+o>>0]|0)|0,d)|0)|0;f[c+(q<<2)>>2]=s;f[c+((q|1)<<2)>>2]=r;q=q+2|0;if((q|0)>(p|0))break;else u=u+2|0}I=b+a|0;J=y+2|0;break b}break}default:{I=l;J=0}}while(0);if((J|0)>=(m|0))return;if((g|0)<2){g=I;l=J;while(1){b=Y(h[g>>0]|0,f[k>>2]|0)|0;f[c+(l<<2)>>2]=b;l=l+1|0;if((l|0)==(m|0))break;else g=g+1|0}return}else{K=I;L=J}while(1){J=e;I=1;g=Y(h[K>>0]|0,f[k>>2]|0)|0;while(1){g=(Y((h[K+(0-J)>>0]|0)+(h[K+J>>0]|0)|0,f[k+(I<<2)>>2]|0)|0)+g|0;if((I|0)>=(i|0))break;else{J=J+e|0;I=I+1|0}}f[c+(L<<2)>>2]=g;L=L+1|0;if((L|0)==(m|0))break;else K=K+1|0}return}function _aa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;k=u;u=u+80|0;l=k;m=k+72|0;n=k+64|0;o=k+8|0;do if((NS(e)|0)==65536){p=f[e+4>>2]|0;f[o>>2]=f[p>>2];q=o+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=o+8|0;f[s>>2]=f[p+8>>2];f[o+12>>2]=f[p+12>>2];f[o+16>>2]=f[p+16>>2];f[o+20>>2]=f[p+20>>2];f[o+24>>2]=f[p+24>>2];f[o+28>>2]=f[p+28>>2];f[o+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[o+36>>2]=t;f[o+40>>2]=s;s=o+48|0;v=o+44|0;f[v>>2]=s;f[s>>2]=0;f[o+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;BR(o,p);break}}else OR(o,e,-1);while(0);e=c&7;p=d&7;if(!((((d^c)&4088|0)==0?(e|0)>=((p>>>0>4?p:4)|0):0)?(f[o>>2]&4095|0)==(e|0):0)){f[m>>2]=0;f[m+4>>2]=0;q=c$(m,109)|0;r=227980;s=q+109|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));j$(-215,m,228090,225433,3660);d$(m)}do if(!(h&3)){r=(p|0)==0;if((e|0)==4&r){f[n>>2]=j;f[n+4>>2]=(j|0)==0?0:1<<j+-1;q=NYa(84)|0;$aa(q,o,g,i,n,m);s=NYa(16)|0;v=s+4|0;f[v>>2]=1;f[s>>2]=57460;f[s+8>>2]=q;f[a>>2]=s;f[a+4>>2]=q;f[v>>2]=(f[v>>2]|0)+1;q=f[v>>2]|0;f[v>>2]=q+-1;if((q|0)==1)ki[f[(f[s>>2]|0)+8>>2]&2047](s);break}s=(e|0)==5;if(s&r){q=NYa(76)|0;aba(q,o,g,i,m,n);v=NYa(16)|0;t=v+4|0;f[t>>2]=1;f[v>>2]=57480;f[v+8>>2]=q;f[a>>2]=v;f[a+4>>2]=q;f[t>>2]=(f[t>>2]|0)+1;q=f[t>>2]|0;f[t>>2]=q+-1;if((q|0)!=1)break;ki[f[(f[v>>2]|0)+8>>2]&2047](v);break}v=(e|0)==6;if(v&r){r=NYa(80)|0;bba(r,o,g,i,m,n);q=NYa(16)|0;t=q+4|0;f[t>>2]=1;f[q>>2]=57500;f[q+8>>2]=r;f[a>>2]=q;f[a+4>>2]=r;f[t>>2]=(f[t>>2]|0)+1;r=f[t>>2]|0;f[t>>2]=r+-1;if((r|0)!=1)break;ki[f[(f[q>>2]|0)+8>>2]&2047](q);break}q=(p|0)==2;if(s&q){r=NYa(76)|0;cba(r,o,g,i,m,n);t=NYa(16)|0;w=t+4|0;f[w>>2]=1;f[t>>2]=57520;f[t+8>>2]=r;f[a>>2]=t;f[a+4>>2]=r;f[w>>2]=(f[w>>2]|0)+1;r=f[w>>2]|0;f[w>>2]=r+-1;if((r|0)!=1)break;ki[f[(f[t>>2]|0)+8>>2]&2047](t);break}if(v&q){q=NYa(80)|0;dba(q,o,g,i,m,n);t=NYa(16)|0;r=t+4|0;f[r>>2]=1;f[t>>2]=57540;f[t+8>>2]=q;f[a>>2]=t;f[a+4>>2]=q;f[r>>2]=(f[r>>2]|0)+1;q=f[r>>2]|0;f[r>>2]=q+-1;if((q|0)!=1)break;ki[f[(f[t>>2]|0)+8>>2]&2047](t);break}t=(p|0)==3;if(s&t){q=NYa(76)|0;eba(q,o,g,i,m,n);r=NYa(16)|0;w=r+4|0;f[w>>2]=1;f[r>>2]=57560;f[r+8>>2]=q;f[a>>2]=r;f[a+4>>2]=q;f[w>>2]=(f[w>>2]|0)+1;q=f[w>>2]|0;f[w>>2]=q+-1;if((q|0)!=1)break;ki[f[(f[r>>2]|0)+8>>2]&2047](r);break}if(v&t){t=NYa(80)|0;fba(t,o,g,i,m,n);r=NYa(16)|0;q=r+4|0;f[q>>2]=1;f[r>>2]=57580;f[r+8>>2]=t;f[a>>2]=r;f[a+4>>2]=t;f[q>>2]=(f[q>>2]|0)+1;t=f[q>>2]|0;f[q>>2]=t+-1;if((t|0)!=1)break;ki[f[(f[r>>2]|0)+8>>2]&2047](r);break}if(s&(p|0)==5){s=NYa(76)|0;gba(s,o,g,i,m,n);r=NYa(16)|0;t=r+4|0;f[t>>2]=1;f[r>>2]=57600;f[r+8>>2]=s;f[a>>2]=r;f[a+4>>2]=s;f[t>>2]=(f[t>>2]|0)+1;s=f[t>>2]|0;f[t>>2]=s+-1;if((s|0)!=1)break;ki[f[(f[r>>2]|0)+8>>2]&2047](r);break}if(v&(p|0)==6){v=NYa(80)|0;hba(v,o,g,i,m,n);r=NYa(16)|0;s=r+4|0;f[s>>2]=1;f[r>>2]=57620;f[r+8>>2]=v;f[a>>2]=r;f[a+4>>2]=v;f[s>>2]=(f[s>>2]|0)+1;v=f[s>>2]|0;f[s>>2]=v+-1;if((v|0)==1)ki[f[(f[r>>2]|0)+8>>2]&2047](r)}else x=87}else{if(((f[o+12>>2]|0)+(f[o+8>>2]|0)|0)==4){r=(e|0)==4;if(r&(p|0)==0){f[m>>2]=j;f[m+4>>2]=(j|0)==0?0:1<<j+-1;v=NYa(88)|0;iba(v,o,g,i,h,m,n);s=NYa(16)|0;t=s+4|0;f[t>>2]=1;f[s>>2]=57640;f[s+8>>2]=v;f[a>>2]=s;f[a+4>>2]=v;f[t>>2]=(f[t>>2]|0)+1;v=f[t>>2]|0;f[t>>2]=v+-1;if((v|0)==1)ki[f[(f[s>>2]|0)+8>>2]&2047](s);break}if(r&(p|0)==3&(j|0)==0){r=NYa(80)|0;jba(r,o,g,i,h,m,n);s=NYa(16)|0;v=s+4|0;f[v>>2]=1;f[s>>2]=57660;f[s+8>>2]=r;f[a>>2]=s;f[a+4>>2]=r;f[v>>2]=(f[v>>2]|0)+1;r=f[v>>2]|0;f[v>>2]=r+-1;if((r|0)==1)ki[f[(f[s>>2]|0)+8>>2]&2047](s);break}if((e|0)==5&(p|0)==5){s=NYa(80)|0;kba(s,o,g,i,h,m,n);r=NYa(16)|0;v=r+4|0;f[v>>2]=1;f[r>>2]=57680;f[r+8>>2]=s;f[a>>2]=r;f[a+4>>2]=s;f[v>>2]=(f[v>>2]|0)+1;s=f[v>>2]|0;f[v>>2]=s+-1;if((s|0)==1)ki[f[(f[r>>2]|0)+8>>2]&2047](r);break}}r=(p|0)==0;s=(e|0)==4;if(s&r){f[m>>2]=j;f[m+4>>2]=(j|0)==0?0:1<<j+-1;v=NYa(88)|0;lba(v,o,g,i,h,m,n);t=NYa(16)|0;q=t+4|0;f[q>>2]=1;f[t>>2]=57700;f[t+8>>2]=v;f[a>>2]=t;f[a+4>>2]=v;f[q>>2]=(f[q>>2]|0)+1;v=f[q>>2]|0;f[q>>2]=v+-1;if((v|0)==1)ki[f[(f[t>>2]|0)+8>>2]&2047](t);break}t=(e|0)==5;if(t&r){v=NYa(80)|0;mba(v,o,g,i,h,m,n);q=NYa(16)|0;w=q+4|0;f[w>>2]=1;f[q>>2]=57720;f[q+8>>2]=v;f[a>>2]=q;f[a+4>>2]=v;f[w>>2]=(f[w>>2]|0)+1;v=f[w>>2]|0;f[w>>2]=v+-1;if((v|0)!=1)break;ki[f[(f[q>>2]|0)+8>>2]&2047](q);break}q=(e|0)==6;if(q&r){r=NYa(88)|0;nba(r,o,g,i,h,m,n);v=NYa(16)|0;w=v+4|0;f[w>>2]=1;f[v>>2]=57740;f[v+8>>2]=r;f[a>>2]=v;f[a+4>>2]=r;f[w>>2]=(f[w>>2]|0)+1;r=f[w>>2]|0;f[w>>2]=r+-1;if((r|0)!=1)break;ki[f[(f[v>>2]|0)+8>>2]&2047](v);break}v=(p|0)==2;if(t&v){r=NYa(80)|0;oba(r,o,g,i,h,m,n);w=NYa(16)|0;y=w+4|0;f[y>>2]=1;f[w>>2]=57760;f[w+8>>2]=r;f[a>>2]=w;f[a+4>>2]=r;f[y>>2]=(f[y>>2]|0)+1;r=f[y>>2]|0;f[y>>2]=r+-1;if((r|0)!=1)break;ki[f[(f[w>>2]|0)+8>>2]&2047](w);break}if(q&v){v=NYa(88)|0;pba(v,o,g,i,h,m,n);w=NYa(16)|0;r=w+4|0;f[r>>2]=1;f[w>>2]=57780;f[w+8>>2]=v;f[a>>2]=w;f[a+4>>2]=v;f[r>>2]=(f[r>>2]|0)+1;v=f[r>>2]|0;f[r>>2]=v+-1;if((v|0)!=1)break;ki[f[(f[w>>2]|0)+8>>2]&2047](w);break}w=(p|0)==3;if(s&w){s=NYa(80)|0;qba(s,o,g,i,h,m,n);v=NYa(16)|0;r=v+4|0;f[r>>2]=1;f[v>>2]=57800;f[v+8>>2]=s;f[a>>2]=v;f[a+4>>2]=s;f[r>>2]=(f[r>>2]|0)+1;s=f[r>>2]|0;f[r>>2]=s+-1;if((s|0)!=1)break;ki[f[(f[v>>2]|0)+8>>2]&2047](v);break}if(t&w){v=NYa(80)|0;rba(v,o,g,i,h,m,n);s=NYa(16)|0;r=s+4|0;f[r>>2]=1;f[s>>2]=57820;f[s+8>>2]=v;f[a>>2]=s;f[a+4>>2]=v;f[r>>2]=(f[r>>2]|0)+1;v=f[r>>2]|0;f[r>>2]=v+-1;if((v|0)==1)ki[f[(f[s>>2]|0)+8>>2]&2047](s);break}if(q&w){w=NYa(88)|0;sba(w,o,g,i,h,m,n);s=NYa(16)|0;v=s+4|0;f[v>>2]=1;f[s>>2]=57840;f[s+8>>2]=w;f[a>>2]=s;f[a+4>>2]=w;f[v>>2]=(f[v>>2]|0)+1;w=f[v>>2]|0;f[v>>2]=w+-1;if((w|0)!=1)break;ki[f[(f[s>>2]|0)+8>>2]&2047](s);break}if(t&(p|0)==5){t=NYa(80)|0;tba(t,o,g,i,h,m,n);s=NYa(16)|0;w=s+4|0;f[w>>2]=1;f[s>>2]=57860;f[s+8>>2]=t;f[a>>2]=s;f[a+4>>2]=t;f[w>>2]=(f[w>>2]|0)+1;t=f[w>>2]|0;f[w>>2]=t+-1;if((t|0)==1)ki[f[(f[s>>2]|0)+8>>2]&2047](s);break}else{if(!(q&(p|0)==6)){x=87;break}q=NYa(88)|0;uba(q,o,g,i,h,m,n);s=NYa(16)|0;t=s+4|0;f[t>>2]=1;f[s>>2]=57880;f[s+8>>2]=q;f[a>>2]=s;f[a+4>>2]=q;f[t>>2]=(f[t>>2]|0)+1;q=f[t>>2]|0;f[t>>2]=q+-1;if((q|0)!=1)break;ki[f[(f[s>>2]|0)+8>>2]&2047](s);break}}while(0);if((x|0)==87){f[l>>2]=c;f[l+4>>2]=d;p$(m,228112,l);j$(-213,m,228090,225433,3741);d$(m);f[a>>2]=0;f[a+4>>2]=0}a=o+36|0;m=f[a>>2]|0;if(m|0?(l=m+12|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0)CR(o);f[a>>2]=0;a=o+16|0;m=o+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[m>>2]|0)>0){a=f[o+40>>2]|0;l=0;do{f[a+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[m>>2]|0))}m=f[o+44>>2]|0;if((m|0)==(o+48|0)){u=k;return}ZF(m);u=k;return}function $aa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+16|0;i=h;j=a+8|0;f[j>>2]=-1;k=a+4|0;f[k>>2]=-1;f[a>>2]=58356;l=a+12|0;f[l>>2]=1124007936;m=a+16|0;n=a+20|0;o=a+52|0;p=m;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=n;r=a+60|0;s=a+56|0;f[s>>2]=r;t=a+68|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if(f[c>>2]&16384){if((l|0)!=(c|0)){r=c+36|0;v=f[r>>2]|0;if(v){w=v+12|0;f[w>>2]=(f[w>>2]|0)+1;w=a+48|0;v=f[w>>2]|0;if((v|0)!=0?(x=v+12|0,v=f[x>>2]|0,f[x>>2]=v+-1,(v|0)==1):0){CR(l);y=w}else y=w}else y=a+48|0;f[y>>2]=0;w=a+28|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[m>>2]|0)>0){v=f[o>>2]|0;o=0;do{f[v+(o<<2)>>2]=0;o=o+1|0;z=f[m>>2]|0}while((o|0)<(z|0));f[l>>2]=f[c>>2];if((z|0)<3)A=13;else A=15}else{f[l>>2]=f[c>>2];A=13}if((A|0)==13){z=f[c+4>>2]|0;if((z|0)<3){f[m>>2]=z;f[n>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];z=f[c+44>>2]|0;m=f[s>>2]|0;f[m>>2]=f[z>>2];f[m+4>>2]=f[z+4>>2]}else A=15}if((A|0)==15)BR(l,c);f[w>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[y>>2]=f[r>>2]}}else{r=i+8|0;f[r>>2]=0;f[r+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=l;eL(c,i)}f[j>>2]=d;d=f[n>>2]|0;n=f[a+24>>2]|0;f[k>>2]=d+-1+n;k=rNa(e)|0;f[a+80>>2]=k;k=g;g=f[k+4>>2]|0;a=t;f[a>>2]=f[k>>2];f[a+4>>2]=g;if((f[l>>2]&4095|0)==4?(d|0)==1|(n|0)==1:0){u=h;return}f[i>>2]=0;f[i+4>>2]=0;p=c$(i,77)|0;n=229351;q=p+77|0;do{b[p>>0]=b[n>>0]|0;p=p+1|0;n=n+1|0}while((p|0)<(q|0));j$(-215,i,229429,225433,3251);d$(i);u=h;return}function aba(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=58308;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;o=a+52|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){CR(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[o>>2]|0;o=0;do{f[t+(o<<2)>>2]=0;o=o+1|0;y=f[l>>2]|0}while((o|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)BR(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;eL(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;n[a+72>>2]=e;if((f[k>>2]&4095|0)==5?(d|0)==1|(m|0)==1:0){u=h;return}f[g>>2]=0;f[g+4>>2]=0;p=c$(g,77)|0;m=229351;q=p+77|0;do{b[p>>0]=b[m>>0]|0;p=p+1|0;m=m+1|0}while((p|0)<(q|0));j$(-215,g,229429,225433,3251);d$(g);u=h;return}function bba(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=58260;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){CR(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0;y=f[l>>2]|0}while((n|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)BR(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;eL(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;p[a+72>>3]=e;if((f[k>>2]&4095|0)==6?(d|0)==1|(m|0)==1:0){u=h;return}f[g>>2]=0;f[g+4>>2]=0;o=c$(g,77)|0;m=229351;q=o+77|0;do{b[o>>0]=b[m>>0]|0;o=o+1|0;m=m+1|0}while((o|0)<(q|0));j$(-215,g,229429,225433,3251);d$(g);u=h;return}function cba(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=58212;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;o=a+52|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){CR(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[o>>2]|0;o=0;do{f[t+(o<<2)>>2]=0;o=o+1|0;y=f[l>>2]|0}while((o|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)BR(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;eL(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;n[a+72>>2]=e;if((f[k>>2]&4095|0)==5?(d|0)==1|(m|0)==1:0){u=h;return}f[g>>2]=0;f[g+4>>2]=0;p=c$(g,77)|0;m=229351;q=p+77|0;do{b[p>>0]=b[m>>0]|0;p=p+1|0;m=m+1|0}while((p|0)<(q|0));j$(-215,g,229429,225433,3251);d$(g);u=h;return}function dba(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=58164;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){CR(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0;y=f[l>>2]|0}while((n|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)BR(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;eL(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;p[a+72>>3]=e;if((f[k>>2]&4095|0)==6?(d|0)==1|(m|0)==1:0){u=h;return}f[g>>2]=0;f[g+4>>2]=0;o=c$(g,77)|0;m=229351;q=o+77|0;do{b[o>>0]=b[m>>0]|0;o=o+1|0;m=m+1|0}while((o|0)<(q|0));j$(-215,g,229429,225433,3251);d$(g);u=h;return}function eba(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=58068;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;o=a+52|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){CR(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[o>>2]|0;o=0;do{f[t+(o<<2)>>2]=0;o=o+1|0;y=f[l>>2]|0}while((o|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)BR(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;eL(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;n[a+72>>2]=e;if((f[k>>2]&4095|0)==5?(d|0)==1|(m|0)==1:0){u=h;return}f[g>>2]=0;f[g+4>>2]=0;p=c$(g,77)|0;m=229351;q=p+77|0;do{b[p>>0]=b[m>>0]|0;p=p+1|0;m=m+1|0}while((p|0)<(q|0));j$(-215,g,229429,225433,3251);d$(g);u=h;return}function fba(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=58020;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){CR(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0;y=f[l>>2]|0}while((n|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)BR(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;eL(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;p[a+72>>3]=e;if((f[k>>2]&4095|0)==6?(d|0)==1|(m|0)==1:0){u=h;return}f[g>>2]=0;f[g+4>>2]=0;o=c$(g,77)|0;m=229351;q=o+77|0;do{b[o>>0]=b[m>>0]|0;o=o+1|0;m=m+1|0}while((o|0)<(q|0));j$(-215,g,229429,225433,3251);d$(g);u=h;return}function gba(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=57972;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;o=a+52|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){CR(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[o>>2]|0;o=0;do{f[t+(o<<2)>>2]=0;o=o+1|0;y=f[l>>2]|0}while((o|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)BR(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;eL(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;n[a+72>>2]=e;if((f[k>>2]&4095|0)==5?(d|0)==1|(m|0)==1:0){u=h;return}f[g>>2]=0;f[g+4>>2]=0;p=c$(g,77)|0;m=229351;q=p+77|0;do{b[p>>0]=b[m>>0]|0;p=p+1|0;m=m+1|0}while((p|0)<(q|0));j$(-215,g,229429,225433,3251);d$(g);u=h;return}function hba(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=57924;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){CR(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0;y=f[l>>2]|0}while((n|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)BR(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;eL(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;p[a+72>>3]=e;if((f[k>>2]&4095|0)==6?(d|0)==1|(m|0)==1:0){u=h;return}f[g>>2]=0;f[g+4>>2]=0;o=c$(g,77)|0;m=229351;q=o+77|0;do{b[o>>0]=b[m>>0]|0;o=o+1|0;m=m+1|0}while((o|0)<(q|0));j$(-215,g,229429,225433,3251);d$(g);u=h;return}function iba(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;lba(a,c,d,e,g,h,i);f[a>>2]=58524;if((f[a+4>>2]|0)==3){u=j;return}f[k>>2]=0;f[k+4>>2]=0;a=c$(k,16)|0;i=230674;h=a+16|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(h|0));j$(-215,k,230691,225433,3420);d$(k);u=j;return}function jba(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;Zca(a,c,d,e,g,h,i);f[a>>2]=58452;if((f[a+4>>2]|0)==3){u=j;return}f[k>>2]=0;f[k+4>>2]=0;a=c$(k,16)|0;i=230674;h=a+16|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(h|0));j$(-215,k,230691,225433,3420);d$(k);u=j;return}function kba(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;Oca(a,c,d,e,g,h,i);f[a>>2]=58380;if((f[a+4>>2]|0)==3){u=j;return}f[k>>2]=0;f[k+4>>2]=0;a=c$(k,16)|0;i=230674;h=a+16|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(h|0));j$(-215,k,230691,225433,3420);d$(k);u=j;return}function lba(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;$aa(a,c,d,e,h,i);f[a>>2]=58332;f[a+84>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=c$(k,64)|0;a=228297;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));j$(-215,k,228362,225433,3314);d$(k);u=j;return}function mba(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;aba(a,c,d,e,h,i);f[a>>2]=58284;f[a+76>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=c$(k,64)|0;a=228297;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));j$(-215,k,228362,225433,3314);d$(k);u=j;return}function nba(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;bba(a,c,d,e,h,i);f[a>>2]=58236;f[a+80>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=c$(k,64)|0;a=228297;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));j$(-215,k,228362,225433,3314);d$(k);u=j;return}function oba(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;cba(a,c,d,e,h,i);f[a>>2]=58188;f[a+76>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=c$(k,64)|0;a=228297;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));j$(-215,k,228362,225433,3314);d$(k);u=j;return}function pba(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;dba(a,c,d,e,h,i);f[a>>2]=58140;f[a+80>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=c$(k,64)|0;a=228297;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));j$(-215,k,228362,225433,3314);d$(k);u=j;return}function qba(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;Zba(a,c,d,e,h,i);f[a>>2]=58092;f[a+76>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=c$(k,64)|0;a=228297;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));j$(-215,k,228362,225433,3314);d$(k);u=j;return}function rba(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;eba(a,c,d,e,h,i);f[a>>2]=58044;f[a+76>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=c$(k,64)|0;a=228297;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));j$(-215,k,228362,225433,3314);d$(k);u=j;return}function sba(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;fba(a,c,d,e,h,i);f[a>>2]=57996;f[a+80>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=c$(k,64)|0;a=228297;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));j$(-215,k,228362,225433,3314);d$(k);u=j;return}function tba(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;gba(a,c,d,e,h,i);f[a>>2]=57948;f[a+76>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=c$(k,64)|0;a=228297;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));j$(-215,k,228362,225433,3314);d$(k);u=j;return}function uba(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;hba(a,c,d,e,h,i);f[a>>2]=57900;f[a+80>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=c$(k,64)|0;a=228297;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));j$(-215,k,228362,225433,3314);d$(k);u=j;return}function vba(a){a=a|0;PYa(a);return}function wba(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function xba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57924;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function yba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57924;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function zba(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0;h=f[a+28>>2]|0;i=+p[a+72>>3];j=f[a+4>>2]|0;if(!e)return;a=g+-4|0;k=(g|0)<4;l=(j|0)>1;m=g&-4;n=e;e=c;c=b;while(1){n=n+-1|0;a:do if(k)o=0;else{b=f[c>>2]|0;if(l)q=0;else{r=0;while(1){s=+p[h>>3];t=b+(r<<3)|0;u=i+s*+p[t+8>>3];v=i+s*+p[t+16>>3];w=i+s*+p[t+24>>3];p[e+(r<<3)>>3]=i+s*+p[t>>3];p[e+((r|1)<<3)>>3]=u;p[e+((r|2)<<3)>>3]=v;p[e+((r|3)<<3)>>3]=w;r=r+4|0;if((r|0)>(a|0)){o=m;break a}}}do{w=+p[h>>3];r=b+(q<<3)|0;t=1;v=i+w*+p[r>>3];u=i+w*+p[r+8>>3];s=i+w*+p[r+16>>3];x=i+w*+p[r+24>>3];do{r=(f[c+(t<<2)>>2]|0)+(q<<3)|0;w=+p[h+(t<<3)>>3];v=v+w*+p[r>>3];u=u+w*+p[r+8>>3];s=s+w*+p[r+16>>3];x=x+w*+p[r+24>>3];t=t+1|0}while((t|0)!=(j|0));p[e+(q<<3)>>3]=v;p[e+((q|1)<<3)>>3]=u;p[e+((q|2)<<3)>>3]=s;p[e+((q|3)<<3)>>3]=x;q=q+4|0}while((q|0)<=(a|0));o=m}while(0);b:do if((o|0)<(g|0)){b=f[c>>2]|0;if(l)y=o;else{t=o;while(1){p[e+(t<<3)>>3]=i+ +p[h>>3]*+p[b+(t<<3)>>3];t=t+1|0;if((t|0)==(g|0))break b}}do{t=1;w=i+ +p[h>>3]*+p[b+(y<<3)>>3];do{w=w+ +p[h+(t<<3)>>3]*+p[(f[c+(t<<2)>>2]|0)+(y<<3)>>3];t=t+1|0}while((t|0)!=(j|0));p[e+(y<<3)>>3]=w;y=y+1|0}while((y|0)!=(g|0))}while(0);if(!n)break;else{e=e+d|0;c=c+4|0}}return}function Aba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57924;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function Bba(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0;h=f[a+4>>2]|0;i=(h|0)/2|0;j=(f[a+28>>2]|0)+(i<<3)|0;k=+p[a+72>>3];l=b+(i<<2)|0;b=e+-1|0;m=(e|0)==0;if(!(f[a+80>>2]&1)){if(m)return;a=g+-4|0;e=(g|0)<4;n=(h|0)<2;o=g&-4;q=b;r=c;s=l;while(1){a:do if(e)t=0;else{if(n){u=0;while(1){p[r+(u<<3)>>3]=k;p[r+((u|1)<<3)>>3]=k;p[r+((u|2)<<3)>>3]=k;p[r+((u|3)<<3)>>3]=k;u=u+4|0;if((u|0)>(a|0)){t=o;break a}}}else v=0;do{u=1;w=k;x=k;y=k;z=k;while(1){A=(f[s+(u<<2)>>2]|0)+(v<<3)|0;B=(f[s+(0-u<<2)>>2]|0)+(v<<3)|0;C=+p[j+(u<<3)>>3];w=w+C*(+p[A>>3]-+p[B>>3]);x=x+C*(+p[A+8>>3]-+p[B+8>>3]);y=y+C*(+p[A+16>>3]-+p[B+16>>3]);z=z+C*(+p[A+24>>3]-+p[B+24>>3]);if((u|0)>=(i|0))break;else u=u+1|0}p[r+(v<<3)>>3]=w;p[r+((v|1)<<3)>>3]=x;p[r+((v|2)<<3)>>3]=y;p[r+((v|3)<<3)>>3]=z;v=v+4|0}while((v|0)<=(a|0));t=o}while(0);b:do if((t|0)<(g|0)){if(n){u=t;while(1){p[r+(u<<3)>>3]=k;u=u+1|0;if((u|0)==(g|0))break b}}else D=t;do{u=1;C=k;while(1){C=C+ +p[j+(u<<3)>>3]*(+p[(f[s+(u<<2)>>2]|0)+(D<<3)>>3]-+p[(f[s+(0-u<<2)>>2]|0)+(D<<3)>>3]);if((u|0)>=(i|0))break;else u=u+1|0}p[r+(D<<3)>>3]=C;D=D+1|0}while((D|0)!=(g|0))}while(0);if(!q)break;else{q=q+-1|0;r=r+d|0;s=s+4|0}}return}else{if(m)return;m=g+-4|0;s=(g|0)<4;r=(h|0)<2;h=g&-4;q=b;b=c;c=l;while(1){c:do if(s)E=0;else{l=f[c>>2]|0;if(r){D=0;while(1){z=+p[j>>3];t=l+(D<<3)|0;y=k+z*+p[t+8>>3];x=k+z*+p[t+16>>3];w=k+z*+p[t+24>>3];p[b+(D<<3)>>3]=k+z*+p[t>>3];p[b+((D|1)<<3)>>3]=y;p[b+((D|2)<<3)>>3]=x;p[b+((D|3)<<3)>>3]=w;D=D+4|0;if((D|0)>(m|0)){E=h;break c}}}else F=0;do{w=+p[j>>3];D=l+(F<<3)|0;t=1;x=k+w*+p[D>>3];y=k+w*+p[D+8>>3];z=k+w*+p[D+16>>3];G=k+w*+p[D+24>>3];while(1){D=(f[c+(t<<2)>>2]|0)+(F<<3)|0;n=(f[c+(0-t<<2)>>2]|0)+(F<<3)|0;w=+p[j+(t<<3)>>3];x=x+w*(+p[D>>3]+ +p[n>>3]);y=y+w*(+p[D+8>>3]+ +p[n+8>>3]);z=z+w*(+p[D+16>>3]+ +p[n+16>>3]);G=G+w*(+p[D+24>>3]+ +p[n+24>>3]);if((t|0)>=(i|0))break;else t=t+1|0}p[b+(F<<3)>>3]=x;p[b+((F|1)<<3)>>3]=y;p[b+((F|2)<<3)>>3]=z;p[b+((F|3)<<3)>>3]=G;F=F+4|0}while((F|0)<=(m|0));E=h}while(0);d:do if((E|0)<(g|0)){l=f[c>>2]|0;if(r){t=E;while(1){p[b+(t<<3)>>3]=k+ +p[j>>3]*+p[l+(t<<3)>>3];t=t+1|0;if((t|0)==(g|0))break d}}else H=E;do{t=1;C=k+ +p[j>>3]*+p[l+(H<<3)>>3];while(1){C=C+ +p[j+(t<<3)>>3]*(+p[(f[c+(t<<2)>>2]|0)+(H<<3)>>3]+ +p[(f[c+(0-t<<2)>>2]|0)+(H<<3)>>3]);if((t|0)>=(i|0))break;else t=t+1|0}p[b+(H<<3)>>3]=C;H=H+1|0}while((H|0)!=(g|0))}while(0);if(!q)break;else{q=q+-1|0;b=b+d|0;c=c+4|0}}return}}function Cba(a){a=a|0;PYa(a);return}function Dba(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Eba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57972;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function Fba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57972;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function Gba(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0;h=f[a+28>>2]|0;i=+n[a+72>>2];j=f[a+4>>2]|0;if(!e)return;a=g+-4|0;k=(g|0)<4;l=(j|0)>1;m=g&-4;o=e;e=c;c=b;while(1){o=o+-1|0;a:do if(k)p=0;else{b=f[c>>2]|0;if(l)q=0;else{r=0;while(1){s=+n[h>>2];t=b+(r<<2)|0;u=i+s*+n[t+4>>2];v=i+s*+n[t+8>>2];w=i+s*+n[t+12>>2];n[e+(r<<2)>>2]=i+s*+n[t>>2];n[e+((r|1)<<2)>>2]=u;n[e+((r|2)<<2)>>2]=v;n[e+((r|3)<<2)>>2]=w;r=r+4|0;if((r|0)>(a|0)){p=m;break a}}}do{w=+n[h>>2];r=b+(q<<2)|0;t=1;v=i+w*+n[r>>2];u=i+w*+n[r+4>>2];s=i+w*+n[r+8>>2];x=i+w*+n[r+12>>2];do{r=(f[c+(t<<2)>>2]|0)+(q<<2)|0;w=+n[h+(t<<2)>>2];v=v+w*+n[r>>2];u=u+w*+n[r+4>>2];s=s+w*+n[r+8>>2];x=x+w*+n[r+12>>2];t=t+1|0}while((t|0)!=(j|0));n[e+(q<<2)>>2]=v;n[e+((q|1)<<2)>>2]=u;n[e+((q|2)<<2)>>2]=s;n[e+((q|3)<<2)>>2]=x;q=q+4|0}while((q|0)<=(a|0));p=m}while(0);b:do if((p|0)<(g|0)){b=f[c>>2]|0;if(l)y=p;else{t=p;while(1){n[e+(t<<2)>>2]=i+ +n[h>>2]*+n[b+(t<<2)>>2];t=t+1|0;if((t|0)==(g|0))break b}}do{t=1;w=i+ +n[h>>2]*+n[b+(y<<2)>>2];do{w=w+ +n[h+(t<<2)>>2]*+n[(f[c+(t<<2)>>2]|0)+(y<<2)>>2];t=t+1|0}while((t|0)!=(j|0));n[e+(y<<2)>>2]=w;y=y+1|0}while((y|0)!=(g|0))}while(0);if(!o)break;else{e=e+d|0;c=c+4|0}}return}function Hba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57972;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function Iba(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0;h=f[a+4>>2]|0;i=(h|0)/2|0;j=(f[a+28>>2]|0)+(i<<2)|0;k=+n[a+72>>2];l=b+(i<<2)|0;b=e+-1|0;m=(e|0)==0;if(!(f[a+76>>2]&1)){if(m)return;a=g+-4|0;e=(g|0)<4;o=(h|0)<2;p=g&-4;q=b;r=c;s=l;while(1){a:do if(e)t=0;else{if(o){u=0;while(1){n[r+(u<<2)>>2]=k;n[r+((u|1)<<2)>>2]=k;n[r+((u|2)<<2)>>2]=k;n[r+((u|3)<<2)>>2]=k;u=u+4|0;if((u|0)>(a|0)){t=p;break a}}}else v=0;do{u=1;w=k;x=k;y=k;z=k;while(1){A=(f[s+(u<<2)>>2]|0)+(v<<2)|0;B=(f[s+(0-u<<2)>>2]|0)+(v<<2)|0;C=+n[j+(u<<2)>>2];w=w+C*(+n[A>>2]-+n[B>>2]);x=x+C*(+n[A+4>>2]-+n[B+4>>2]);y=y+C*(+n[A+8>>2]-+n[B+8>>2]);z=z+C*(+n[A+12>>2]-+n[B+12>>2]);if((u|0)>=(i|0))break;else u=u+1|0}n[r+(v<<2)>>2]=w;n[r+((v|1)<<2)>>2]=x;n[r+((v|2)<<2)>>2]=y;n[r+((v|3)<<2)>>2]=z;v=v+4|0}while((v|0)<=(a|0));t=p}while(0);b:do if((t|0)<(g|0)){if(o){u=t;while(1){n[r+(u<<2)>>2]=k;u=u+1|0;if((u|0)==(g|0))break b}}else D=t;do{u=1;C=k;while(1){C=C+ +n[j+(u<<2)>>2]*(+n[(f[s+(u<<2)>>2]|0)+(D<<2)>>2]-+n[(f[s+(0-u<<2)>>2]|0)+(D<<2)>>2]);if((u|0)>=(i|0))break;else u=u+1|0}n[r+(D<<2)>>2]=C;D=D+1|0}while((D|0)!=(g|0))}while(0);if(!q)break;else{q=q+-1|0;r=r+d|0;s=s+4|0}}return}else{if(m)return;m=g+-4|0;s=(g|0)<4;r=(h|0)<2;h=g&-4;q=b;b=c;c=l;while(1){c:do if(s)E=0;else{l=f[c>>2]|0;if(r){D=0;while(1){z=+n[j>>2];t=l+(D<<2)|0;y=k+z*+n[t+4>>2];x=k+z*+n[t+8>>2];w=k+z*+n[t+12>>2];n[b+(D<<2)>>2]=k+z*+n[t>>2];n[b+((D|1)<<2)>>2]=y;n[b+((D|2)<<2)>>2]=x;n[b+((D|3)<<2)>>2]=w;D=D+4|0;if((D|0)>(m|0)){E=h;break c}}}else F=0;do{w=+n[j>>2];D=l+(F<<2)|0;t=1;x=k+w*+n[D>>2];y=k+w*+n[D+4>>2];z=k+w*+n[D+8>>2];G=k+w*+n[D+12>>2];while(1){D=(f[c+(t<<2)>>2]|0)+(F<<2)|0;o=(f[c+(0-t<<2)>>2]|0)+(F<<2)|0;w=+n[j+(t<<2)>>2];x=x+w*(+n[D>>2]+ +n[o>>2]);y=y+w*(+n[D+4>>2]+ +n[o+4>>2]);z=z+w*(+n[D+8>>2]+ +n[o+8>>2]);G=G+w*(+n[D+12>>2]+ +n[o+12>>2]);if((t|0)>=(i|0))break;else t=t+1|0}n[b+(F<<2)>>2]=x;n[b+((F|1)<<2)>>2]=y;n[b+((F|2)<<2)>>2]=z;n[b+((F|3)<<2)>>2]=G;F=F+4|0}while((F|0)<=(m|0));E=h}while(0);d:do if((E|0)<(g|0)){l=f[c>>2]|0;if(r){t=E;while(1){n[b+(t<<2)>>2]=k+ +n[j>>2]*+n[l+(t<<2)>>2];t=t+1|0;if((t|0)==(g|0))break d}}else H=E;do{t=1;C=k+ +n[j>>2]*+n[l+(H<<2)>>2];while(1){C=C+ +n[j+(t<<2)>>2]*(+n[(f[c+(t<<2)>>2]|0)+(H<<2)>>2]+ +n[(f[c+(0-t<<2)>>2]|0)+(H<<2)>>2]);if((t|0)>=(i|0))break;else t=t+1|0}n[b+(H<<2)>>2]=C;H=H+1|0}while((H|0)!=(g|0))}while(0);if(!q)break;else{q=q+-1|0;b=b+d|0;c=c+4|0}}return}}function Jba(a){a=a|0;PYa(a);return}function Kba(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Lba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58020;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function Mba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58020;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function Nba(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0;i=f[a+28>>2]|0;j=+p[a+72>>3];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;n=h&-4;o=g;g=c;c=b;while(1){o=o+-1|0;a:do if(l)q=0;else{r=+p[i>>3];b=f[c>>2]|0;if(m)s=0;else{t=0;while(1){u=b+(t<<3)|0;v=j+r*+p[u+8>>3];w=j+r*+p[u+16>>3];x=j+r*+p[u+24>>3];y=rNa(j+r*+p[u>>3])|0;d[g+(t<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=rNa(v)|0;d[g+((t|1)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=rNa(w)|0;d[g+((t|2)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=rNa(x)|0;d[g+((t|3)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;t=t+4|0;if((t|0)>(a|0)){q=n;break a}}}do{t=b+(s<<3)|0;y=1;x=j+r*+p[t>>3];w=j+r*+p[t+8>>3];v=j+r*+p[t+16>>3];z=j+r*+p[t+24>>3];do{t=(f[c+(y<<2)>>2]|0)+(s<<3)|0;A=+p[i+(y<<3)>>3];x=x+A*+p[t>>3];w=w+A*+p[t+8>>3];v=v+A*+p[t+16>>3];z=z+A*+p[t+24>>3];y=y+1|0}while((y|0)!=(k|0));y=rNa(x)|0;d[g+(s<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=rNa(w)|0;d[g+((s|1)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=rNa(v)|0;d[g+((s|2)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=rNa(z)|0;d[g+((s|3)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;s=s+4|0}while((s|0)<=(a|0));q=n}while(0);b:do if((q|0)<(h|0)){r=+p[i>>3];b=f[c>>2]|0;if(m)B=q;else{y=q;while(1){t=rNa(j+r*+p[b+(y<<3)>>3])|0;d[g+(y<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;y=y+1|0;if((y|0)==(h|0))break b}}do{y=1;A=j+r*+p[b+(B<<3)>>3];do{A=A+ +p[i+(y<<3)>>3]*+p[(f[c+(y<<2)>>2]|0)+(B<<3)>>3];y=y+1|0}while((y|0)!=(k|0));y=rNa(A)|0;d[g+(B<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;B=B+1|0}while((B|0)!=(h|0))}while(0);if(!o)break;else{g=g+e|0;c=c+4|0}}return}function Oba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58020;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function Pba(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<3)|0;l=+p[a+72>>3];m=b+(j<<2)|0;b=g+-1|0;n=(g|0)==0;if(f[a+80>>2]&1|0){if(n)return;a=h+-4|0;g=(h|0)<4;o=(i|0)<2;q=h&-4;r=b;s=c;t=m;while(1){a:do if(g)u=0;else{v=+p[k>>3];w=f[t>>2]|0;if(o){x=0;while(1){y=w+(x<<3)|0;z=l+v*+p[y+8>>3];A=l+v*+p[y+16>>3];B=l+v*+p[y+24>>3];C=rNa(l+v*+p[y>>3])|0;d[s+(x<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=rNa(z)|0;d[s+((x|1)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=rNa(A)|0;d[s+((x|2)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=rNa(B)|0;d[s+((x|3)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;x=x+4|0;if((x|0)>(a|0)){u=q;break a}}}else D=0;do{x=w+(D<<3)|0;C=1;B=l+v*+p[x>>3];A=l+v*+p[x+8>>3];z=l+v*+p[x+16>>3];E=l+v*+p[x+24>>3];while(1){x=(f[t+(C<<2)>>2]|0)+(D<<3)|0;y=(f[t+(0-C<<2)>>2]|0)+(D<<3)|0;F=+p[k+(C<<3)>>3];B=B+F*(+p[x>>3]+ +p[y>>3]);A=A+F*(+p[x+8>>3]+ +p[y+8>>3]);z=z+F*(+p[x+16>>3]+ +p[y+16>>3]);E=E+F*(+p[x+24>>3]+ +p[y+24>>3]);if((C|0)>=(j|0))break;else C=C+1|0}C=rNa(B)|0;d[s+(D<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=rNa(A)|0;d[s+((D|1)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=rNa(z)|0;d[s+((D|2)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=rNa(E)|0;d[s+((D|3)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;D=D+4|0}while((D|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){v=+p[k>>3];w=f[t>>2]|0;if(o){C=u;while(1){y=rNa(l+v*+p[w+(C<<3)>>3])|0;d[s+(C<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;C=C+1|0;if((C|0)==(h|0))break b}}else G=u;do{C=1;F=l+v*+p[w+(G<<3)>>3];while(1){F=F+ +p[k+(C<<3)>>3]*(+p[(f[t+(C<<2)>>2]|0)+(G<<3)>>3]+ +p[(f[t+(0-C<<2)>>2]|0)+(G<<3)>>3]);if((C|0)>=(j|0))break;else C=C+1|0}C=rNa(F)|0;d[s+(G<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;G=G+1|0}while((G|0)!=(h|0))}while(0);if(!r)break;else{r=r+-1|0;s=s+e|0;t=t+4|0}}return}if(n)return;n=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=b;b=c;c=m;while(1){c:do if(t)H=0;else{if(s){m=rNa(l)|0;G=((m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768)&65535;m=0;while(1){d[b+(m<<1)>>1]=G;d[b+((m|1)<<1)>>1]=G;d[b+((m|2)<<1)>>1]=G;d[b+((m|3)<<1)>>1]=G;m=m+4|0;if((m|0)>(n|0)){H=i;break c}}}else I=0;do{m=1;v=l;E=l;z=l;A=l;while(1){G=(f[c+(m<<2)>>2]|0)+(I<<3)|0;u=(f[c+(0-m<<2)>>2]|0)+(I<<3)|0;B=+p[k+(m<<3)>>3];v=v+B*(+p[G>>3]-+p[u>>3]);E=E+B*(+p[G+8>>3]-+p[u+8>>3]);z=z+B*(+p[G+16>>3]-+p[u+16>>3]);A=A+B*(+p[G+24>>3]-+p[u+24>>3]);if((m|0)>=(j|0))break;else m=m+1|0}m=rNa(v)|0;d[b+(I<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;m=rNa(E)|0;d[b+((I|1)<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;m=rNa(z)|0;d[b+((I|2)<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;m=rNa(A)|0;d[b+((I|3)<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;I=I+4|0}while((I|0)<=(n|0));H=i}while(0);d:do if((H|0)<(h|0)){if(s){m=rNa(l)|0;u=((m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768)&65535;m=H;while(1){d[b+(m<<1)>>1]=u;m=m+1|0;if((m|0)==(h|0))break d}}else J=H;do{m=1;F=l;while(1){F=F+ +p[k+(m<<3)>>3]*(+p[(f[c+(m<<2)>>2]|0)+(J<<3)>>3]-+p[(f[c+(0-m<<2)>>2]|0)+(J<<3)>>3]);if((m|0)>=(j|0))break;else m=m+1|0}m=rNa(F)|0;d[b+(J<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;J=J+1|0}while((J|0)!=(h|0))}while(0);if(!r)break;else{r=r+-1|0;b=b+e|0;c=c+4|0}}return}function Qba(a){a=a|0;PYa(a);return}function Rba(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Sba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58068;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function Tba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58068;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function Uba(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0;i=f[a+28>>2]|0;j=+n[a+72>>2];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;o=h&-4;p=g;g=c;c=b;while(1){p=p+-1|0;a:do if(l)q=0;else{r=+n[i>>2];b=f[c>>2]|0;if(m)s=0;else{t=0;while(1){u=b+(t<<2)|0;v=j+r*+n[u+4>>2];w=j+r*+n[u+8>>2];x=j+r*+n[u+12>>2];y=wNa(j+r*+n[u>>2])|0;d[g+(t<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=wNa(v)|0;d[g+((t|1)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=wNa(w)|0;d[g+((t|2)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=wNa(x)|0;d[g+((t|3)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;t=t+4|0;if((t|0)>(a|0)){q=o;break a}}}do{t=b+(s<<2)|0;y=1;x=j+r*+n[t>>2];w=j+r*+n[t+4>>2];v=j+r*+n[t+8>>2];z=j+r*+n[t+12>>2];do{t=(f[c+(y<<2)>>2]|0)+(s<<2)|0;A=+n[i+(y<<2)>>2];x=x+A*+n[t>>2];w=w+A*+n[t+4>>2];v=v+A*+n[t+8>>2];z=z+A*+n[t+12>>2];y=y+1|0}while((y|0)!=(k|0));y=wNa(x)|0;d[g+(s<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=wNa(w)|0;d[g+((s|1)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=wNa(v)|0;d[g+((s|2)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=wNa(z)|0;d[g+((s|3)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;s=s+4|0}while((s|0)<=(a|0));q=o}while(0);b:do if((q|0)<(h|0)){r=+n[i>>2];b=f[c>>2]|0;if(m)B=q;else{y=q;while(1){t=wNa(j+r*+n[b+(y<<2)>>2])|0;d[g+(y<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;y=y+1|0;if((y|0)==(h|0))break b}}do{y=1;A=j+r*+n[b+(B<<2)>>2];do{A=A+ +n[i+(y<<2)>>2]*+n[(f[c+(y<<2)>>2]|0)+(B<<2)>>2];y=y+1|0}while((y|0)!=(k|0));y=wNa(A)|0;d[g+(B<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;B=B+1|0}while((B|0)!=(h|0))}while(0);if(!p)break;else{g=g+e|0;c=c+4|0}}return}function Vba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58068;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function Wba(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=+n[a+72>>2];m=b+(j<<2)|0;b=g+-1|0;o=(g|0)==0;if(f[a+76>>2]&1|0){if(o)return;a=h+-4|0;g=(h|0)<4;p=(i|0)<2;q=h&-4;r=b;s=c;t=m;while(1){a:do if(g)u=0;else{v=+n[k>>2];w=f[t>>2]|0;if(p){x=0;while(1){y=w+(x<<2)|0;z=l+v*+n[y+4>>2];A=l+v*+n[y+8>>2];B=l+v*+n[y+12>>2];C=wNa(l+v*+n[y>>2])|0;d[s+(x<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=wNa(z)|0;d[s+((x|1)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=wNa(A)|0;d[s+((x|2)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=wNa(B)|0;d[s+((x|3)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;x=x+4|0;if((x|0)>(a|0)){u=q;break a}}}else D=0;do{x=w+(D<<2)|0;C=1;B=l+v*+n[x>>2];A=l+v*+n[x+4>>2];z=l+v*+n[x+8>>2];E=l+v*+n[x+12>>2];while(1){x=(f[t+(C<<2)>>2]|0)+(D<<2)|0;y=(f[t+(0-C<<2)>>2]|0)+(D<<2)|0;F=+n[k+(C<<2)>>2];B=B+F*(+n[x>>2]+ +n[y>>2]);A=A+F*(+n[x+4>>2]+ +n[y+4>>2]);z=z+F*(+n[x+8>>2]+ +n[y+8>>2]);E=E+F*(+n[x+12>>2]+ +n[y+12>>2]);if((C|0)>=(j|0))break;else C=C+1|0}C=wNa(B)|0;d[s+(D<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=wNa(A)|0;d[s+((D|1)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=wNa(z)|0;d[s+((D|2)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=wNa(E)|0;d[s+((D|3)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;D=D+4|0}while((D|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){v=+n[k>>2];w=f[t>>2]|0;if(p){C=u;while(1){y=wNa(l+v*+n[w+(C<<2)>>2])|0;d[s+(C<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;C=C+1|0;if((C|0)==(h|0))break b}}else G=u;do{C=1;F=l+v*+n[w+(G<<2)>>2];while(1){F=F+ +n[k+(C<<2)>>2]*(+n[(f[t+(C<<2)>>2]|0)+(G<<2)>>2]+ +n[(f[t+(0-C<<2)>>2]|0)+(G<<2)>>2]);if((C|0)>=(j|0))break;else C=C+1|0}C=wNa(F)|0;d[s+(G<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;G=G+1|0}while((G|0)!=(h|0))}while(0);if(!r)break;else{r=r+-1|0;s=s+e|0;t=t+4|0}}return}if(o)return;o=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=b;b=c;c=m;while(1){c:do if(t)H=0;else{if(s){m=wNa(l)|0;G=((m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768)&65535;m=0;while(1){d[b+(m<<1)>>1]=G;d[b+((m|1)<<1)>>1]=G;d[b+((m|2)<<1)>>1]=G;d[b+((m|3)<<1)>>1]=G;m=m+4|0;if((m|0)>(o|0)){H=i;break c}}}else I=0;do{m=1;v=l;E=l;z=l;A=l;while(1){G=(f[c+(m<<2)>>2]|0)+(I<<2)|0;u=(f[c+(0-m<<2)>>2]|0)+(I<<2)|0;B=+n[k+(m<<2)>>2];v=v+B*(+n[G>>2]-+n[u>>2]);E=E+B*(+n[G+4>>2]-+n[u+4>>2]);z=z+B*(+n[G+8>>2]-+n[u+8>>2]);A=A+B*(+n[G+12>>2]-+n[u+12>>2]);if((m|0)>=(j|0))break;else m=m+1|0}m=wNa(v)|0;d[b+(I<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;m=wNa(E)|0;d[b+((I|1)<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;m=wNa(z)|0;d[b+((I|2)<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;m=wNa(A)|0;d[b+((I|3)<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;I=I+4|0}while((I|0)<=(o|0));H=i}while(0);d:do if((H|0)<(h|0)){if(s){m=wNa(l)|0;u=((m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768)&65535;m=H;while(1){d[b+(m<<1)>>1]=u;m=m+1|0;if((m|0)==(h|0))break d}}else J=H;do{m=1;F=l;while(1){F=F+ +n[k+(m<<2)>>2]*(+n[(f[c+(m<<2)>>2]|0)+(J<<2)>>2]-+n[(f[c+(0-m<<2)>>2]|0)+(J<<2)>>2]);if((m|0)>=(j|0))break;else m=m+1|0}m=wNa(F)|0;d[b+(J<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;J=J+1|0}while((J|0)!=(h|0))}while(0);if(!r)break;else{r=r+-1|0;b=b+e|0;c=c+4|0}}return}function Xba(a){a=a|0;PYa(a);return}function Yba(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Zba(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=58116;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[n>>2]=m;q=a+60|0;r=a+56|0;f[r>>2]=q;f[q>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){q=c+36|0;s=f[q>>2]|0;if(s){t=s+12|0;f[t>>2]=(f[t>>2]|0)+1;t=a+48|0;s=f[t>>2]|0;if((s|0)!=0?(v=s+12|0,s=f[v>>2]|0,f[v>>2]=s+-1,(s|0)==1):0){CR(k);w=t}else w=t}else w=a+48|0;f[w>>2]=0;t=a+28|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[l>>2]|0)>0){s=f[n>>2]|0;n=0;do{f[s+(n<<2)>>2]=0;n=n+1|0;x=f[l>>2]|0}while((n|0)<(x|0));f[k>>2]=f[c>>2];if((x|0)<3)y=13;else y=15}else{f[k>>2]=f[c>>2];y=13}if((y|0)==13){x=f[c+4>>2]|0;if((x|0)<3){f[l>>2]=x;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];x=f[c+44>>2]|0;l=f[r>>2]|0;f[l>>2]=f[x>>2];f[l+4>>2]=f[x+4>>2]}else y=15}if((y|0)==15)BR(k,c);f[t>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[w>>2]=f[q>>2]}}else{q=g+8|0;f[q>>2]=0;f[q+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;eL(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;j=rNa(e)|0;f[a+72>>2]=j;if((f[k>>2]&4095|0)==4?(d|0)==1|(m|0)==1:0){u=h;return}f[g>>2]=0;f[g+4>>2]=0;o=c$(g,77)|0;m=229351;p=o+77|0;do{b[o>>0]=b[m>>0]|0;o=o+1|0;m=m+1|0}while((o|0)<(p|0));j$(-215,g,229429,225433,3251);d$(g);u=h;return}function _ba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58116;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function $ba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58116;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function aca(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;i=f[a+28>>2]|0;j=f[a+72>>2]|0;k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;n=h&-4;o=g;g=c;c=b;while(1){o=o+-1|0;a:do if(l)p=0;else{b=f[i>>2]|0;q=f[c>>2]|0;if(m)r=0;else{s=0;while(1){t=q+(s<<2)|0;u=(Y(f[t>>2]|0,b)|0)+j|0;v=(Y(f[t+4>>2]|0,b)|0)+j|0;w=(Y(f[t+8>>2]|0,b)|0)+j|0;x=(Y(f[t+12>>2]|0,b)|0)+j|0;d[g+(s<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;d[g+((s|1)<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[g+((s|2)<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;d[g+((s|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;s=s+4|0;if((s|0)>(a|0)){p=n;break a}}}do{s=q+(r<<2)|0;x=(Y(f[s>>2]|0,b)|0)+j|0;w=(Y(f[s+4>>2]|0,b)|0)+j|0;v=(Y(f[s+8>>2]|0,b)|0)+j|0;u=1;t=x;x=w;w=v;v=(Y(f[s+12>>2]|0,b)|0)+j|0;do{s=(f[c+(u<<2)>>2]|0)+(r<<2)|0;y=f[i+(u<<2)>>2]|0;t=(Y(f[s>>2]|0,y)|0)+t|0;x=(Y(f[s+4>>2]|0,y)|0)+x|0;w=(Y(f[s+8>>2]|0,y)|0)+w|0;v=(Y(f[s+12>>2]|0,y)|0)+v|0;u=u+1|0}while((u|0)!=(k|0));d[g+(r<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;d[g+((r|1)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;d[g+((r|2)<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;d[g+((r|3)<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;r=r+4|0}while((r|0)<=(a|0));p=n}while(0);b:do if((p|0)<(h|0)){b=f[i>>2]|0;q=f[c>>2]|0;if(m)z=p;else{u=p;while(1){y=(Y(f[q+(u<<2)>>2]|0,b)|0)+j|0;d[g+(u<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;u=u+1|0;if((u|0)==(h|0))break b}}do{u=1;y=(Y(f[q+(z<<2)>>2]|0,b)|0)+j|0;do{y=(Y(f[(f[c+(u<<2)>>2]|0)+(z<<2)>>2]|0,f[i+(u<<2)>>2]|0)|0)+y|0;u=u+1|0}while((u|0)!=(k|0));d[g+(z<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;z=z+1|0}while((z|0)!=(h|0))}while(0);if(!o)break;else{g=g+e|0;c=c+4|0}}return}function bca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58116;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function cca(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=f[a+72>>2]|0;m=b+(j<<2)|0;b=g+-1|0;n=(g|0)==0;if(!(f[a+76>>2]&1)){if(n)return;a=h+-4|0;g=(h|0)<4;o=(i|0)<2;p=h&-4;q=((l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768)&65535;r=((l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768)&65535;s=b;t=c;u=m;while(1){a:do if(g)v=0;else{if(o){w=0;while(1){d[t+(w<<1)>>1]=r;d[t+((w|1)<<1)>>1]=r;d[t+((w|2)<<1)>>1]=r;d[t+((w|3)<<1)>>1]=r;w=w+4|0;if((w|0)>(a|0)){v=p;break a}}}else x=0;do{w=1;y=l;z=l;A=l;B=l;while(1){C=(f[u+(w<<2)>>2]|0)+(x<<2)|0;D=(f[u+(0-w<<2)>>2]|0)+(x<<2)|0;E=f[k+(w<<2)>>2]|0;y=(Y((f[C>>2]|0)-(f[D>>2]|0)|0,E)|0)+y|0;z=(Y((f[C+4>>2]|0)-(f[D+4>>2]|0)|0,E)|0)+z|0;A=(Y((f[C+8>>2]|0)-(f[D+8>>2]|0)|0,E)|0)+A|0;B=(Y((f[C+12>>2]|0)-(f[D+12>>2]|0)|0,E)|0)+B|0;if((w|0)>=(j|0))break;else w=w+1|0}d[t+(x<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;d[t+((x|1)<<1)>>1]=(z+32768|0)>>>0<65536?z:(z|0)>0?32767:32768;d[t+((x|2)<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;d[t+((x|3)<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;x=x+4|0}while((x|0)<=(a|0));v=p}while(0);b:do if((v|0)<(h|0)){if(o){w=v;while(1){d[t+(w<<1)>>1]=q;w=w+1|0;if((w|0)==(h|0))break b}}else F=v;do{w=1;E=l;while(1){E=(Y((f[(f[u+(w<<2)>>2]|0)+(F<<2)>>2]|0)-(f[(f[u+(0-w<<2)>>2]|0)+(F<<2)>>2]|0)|0,f[k+(w<<2)>>2]|0)|0)+E|0;if((w|0)>=(j|0))break;else w=w+1|0}d[t+(F<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;F=F+1|0}while((F|0)!=(h|0))}while(0);if(!s)break;else{s=s+-1|0;t=t+e|0;u=u+4|0}}return}else{if(n)return;n=h+-4|0;u=(h|0)<4;t=(i|0)<2;i=h&-4;s=b;b=c;c=m;while(1){c:do if(u)G=0;else{m=f[k>>2]|0;F=f[c>>2]|0;if(t){v=0;while(1){q=F+(v<<2)|0;o=(Y(f[q>>2]|0,m)|0)+l|0;p=(Y(f[q+4>>2]|0,m)|0)+l|0;a=(Y(f[q+8>>2]|0,m)|0)+l|0;x=(Y(f[q+12>>2]|0,m)|0)+l|0;d[b+(v<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;d[b+((v|1)<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[b+((v|2)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;d[b+((v|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;v=v+4|0;if((v|0)>(n|0)){G=i;break c}}}else H=0;do{v=F+(H<<2)|0;x=(Y(f[v>>2]|0,m)|0)+l|0;a=(Y(f[v+4>>2]|0,m)|0)+l|0;p=(Y(f[v+8>>2]|0,m)|0)+l|0;o=1;q=x;x=a;a=p;p=(Y(f[v+12>>2]|0,m)|0)+l|0;while(1){v=(f[c+(o<<2)>>2]|0)+(H<<2)|0;r=(f[c+(0-o<<2)>>2]|0)+(H<<2)|0;g=f[k+(o<<2)>>2]|0;q=(Y((f[r>>2]|0)+(f[v>>2]|0)|0,g)|0)+q|0;x=(Y((f[r+4>>2]|0)+(f[v+4>>2]|0)|0,g)|0)+x|0;a=(Y((f[r+8>>2]|0)+(f[v+8>>2]|0)|0,g)|0)+a|0;p=(Y((f[r+12>>2]|0)+(f[v+12>>2]|0)|0,g)|0)+p|0;if((o|0)>=(j|0))break;else o=o+1|0}d[b+(H<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;d[b+((H|1)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;d[b+((H|2)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;d[b+((H|3)<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;H=H+4|0}while((H|0)<=(n|0));G=i}while(0);d:do if((G|0)<(h|0)){m=f[k>>2]|0;F=f[c>>2]|0;if(t){o=G;while(1){E=(Y(f[F+(o<<2)>>2]|0,m)|0)+l|0;d[b+(o<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;o=o+1|0;if((o|0)==(h|0))break d}}else I=G;do{o=1;E=(Y(f[F+(I<<2)>>2]|0,m)|0)+l|0;while(1){E=(Y((f[(f[c+(0-o<<2)>>2]|0)+(I<<2)>>2]|0)+(f[(f[c+(o<<2)>>2]|0)+(I<<2)>>2]|0)|0,f[k+(o<<2)>>2]|0)|0)+E|0;if((o|0)>=(j|0))break;else o=o+1|0}d[b+(I<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;I=I+1|0}while((I|0)!=(h|0))}while(0);if(!s)break;else{s=s+-1|0;b=b+e|0;c=c+4|0}}return}}function dca(a){a=a|0;PYa(a);return}function eca(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function fca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58164;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function gca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58164;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function hca(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0;i=f[a+28>>2]|0;j=+p[a+72>>3];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;n=h&-4;o=g;g=c;c=b;while(1){o=o+-1|0;a:do if(l)q=0;else{r=+p[i>>3];b=f[c>>2]|0;if(m)s=0;else{t=0;while(1){u=b+(t<<3)|0;v=j+r*+p[u+8>>3];w=j+r*+p[u+16>>3];x=j+r*+p[u+24>>3];y=rNa(j+r*+p[u>>3])|0;d[g+(t<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=rNa(v)|0;d[g+((t|1)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=rNa(w)|0;d[g+((t|2)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=rNa(x)|0;d[g+((t|3)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;t=t+4|0;if((t|0)>(a|0)){q=n;break a}}}do{t=b+(s<<3)|0;y=1;x=j+r*+p[t>>3];w=j+r*+p[t+8>>3];v=j+r*+p[t+16>>3];z=j+r*+p[t+24>>3];do{t=(f[c+(y<<2)>>2]|0)+(s<<3)|0;A=+p[i+(y<<3)>>3];x=x+A*+p[t>>3];w=w+A*+p[t+8>>3];v=v+A*+p[t+16>>3];z=z+A*+p[t+24>>3];y=y+1|0}while((y|0)!=(k|0));y=rNa(x)|0;d[g+(s<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=rNa(w)|0;d[g+((s|1)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=rNa(v)|0;d[g+((s|2)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=rNa(z)|0;d[g+((s|3)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;s=s+4|0}while((s|0)<=(a|0));q=n}while(0);b:do if((q|0)<(h|0)){r=+p[i>>3];b=f[c>>2]|0;if(m)B=q;else{y=q;while(1){t=rNa(j+r*+p[b+(y<<3)>>3])|0;d[g+(y<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;y=y+1|0;if((y|0)==(h|0))break b}}do{y=1;A=j+r*+p[b+(B<<3)>>3];do{A=A+ +p[i+(y<<3)>>3]*+p[(f[c+(y<<2)>>2]|0)+(B<<3)>>3];y=y+1|0}while((y|0)!=(k|0));y=rNa(A)|0;d[g+(B<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;B=B+1|0}while((B|0)!=(h|0))}while(0);if(!o)break;else{g=g+e|0;c=c+4|0}}return}function ica(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58164;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function jca(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<3)|0;l=+p[a+72>>3];m=b+(j<<2)|0;b=g+-1|0;n=(g|0)==0;if(f[a+80>>2]&1|0){if(n)return;a=h+-4|0;g=(h|0)<4;o=(i|0)<2;q=h&-4;r=b;s=c;t=m;while(1){a:do if(g)u=0;else{v=+p[k>>3];w=f[t>>2]|0;if(o){x=0;while(1){y=w+(x<<3)|0;z=l+v*+p[y+8>>3];A=l+v*+p[y+16>>3];B=l+v*+p[y+24>>3];C=rNa(l+v*+p[y>>3])|0;d[s+(x<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=rNa(z)|0;d[s+((x|1)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=rNa(A)|0;d[s+((x|2)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=rNa(B)|0;d[s+((x|3)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;x=x+4|0;if((x|0)>(a|0)){u=q;break a}}}else D=0;do{x=w+(D<<3)|0;C=1;B=l+v*+p[x>>3];A=l+v*+p[x+8>>3];z=l+v*+p[x+16>>3];E=l+v*+p[x+24>>3];while(1){x=(f[t+(C<<2)>>2]|0)+(D<<3)|0;y=(f[t+(0-C<<2)>>2]|0)+(D<<3)|0;F=+p[k+(C<<3)>>3];B=B+F*(+p[x>>3]+ +p[y>>3]);A=A+F*(+p[x+8>>3]+ +p[y+8>>3]);z=z+F*(+p[x+16>>3]+ +p[y+16>>3]);E=E+F*(+p[x+24>>3]+ +p[y+24>>3]);if((C|0)>=(j|0))break;else C=C+1|0}C=rNa(B)|0;d[s+(D<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=rNa(A)|0;d[s+((D|1)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=rNa(z)|0;d[s+((D|2)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=rNa(E)|0;d[s+((D|3)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;D=D+4|0}while((D|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){v=+p[k>>3];w=f[t>>2]|0;if(o){C=u;while(1){y=rNa(l+v*+p[w+(C<<3)>>3])|0;d[s+(C<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;C=C+1|0;if((C|0)==(h|0))break b}}else G=u;do{C=1;F=l+v*+p[w+(G<<3)>>3];while(1){F=F+ +p[k+(C<<3)>>3]*(+p[(f[t+(C<<2)>>2]|0)+(G<<3)>>3]+ +p[(f[t+(0-C<<2)>>2]|0)+(G<<3)>>3]);if((C|0)>=(j|0))break;else C=C+1|0}C=rNa(F)|0;d[s+(G<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;G=G+1|0}while((G|0)!=(h|0))}while(0);if(!r)break;else{r=r+-1|0;s=s+e|0;t=t+4|0}}return}if(n)return;n=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=b;b=c;c=m;while(1){c:do if(t)H=0;else{if(s){m=rNa(l)|0;G=(m>>>0<65536?m:(m|0)>0?65535:0)&65535;m=0;while(1){d[b+(m<<1)>>1]=G;d[b+((m|1)<<1)>>1]=G;d[b+((m|2)<<1)>>1]=G;d[b+((m|3)<<1)>>1]=G;m=m+4|0;if((m|0)>(n|0)){H=i;break c}}}else I=0;do{m=1;v=l;E=l;z=l;A=l;while(1){G=(f[c+(m<<2)>>2]|0)+(I<<3)|0;u=(f[c+(0-m<<2)>>2]|0)+(I<<3)|0;B=+p[k+(m<<3)>>3];v=v+B*(+p[G>>3]-+p[u>>3]);E=E+B*(+p[G+8>>3]-+p[u+8>>3]);z=z+B*(+p[G+16>>3]-+p[u+16>>3]);A=A+B*(+p[G+24>>3]-+p[u+24>>3]);if((m|0)>=(j|0))break;else m=m+1|0}m=rNa(v)|0;d[b+(I<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;m=rNa(E)|0;d[b+((I|1)<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;m=rNa(z)|0;d[b+((I|2)<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;m=rNa(A)|0;d[b+((I|3)<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;I=I+4|0}while((I|0)<=(n|0));H=i}while(0);d:do if((H|0)<(h|0)){if(s){m=rNa(l)|0;u=(m>>>0<65536?m:(m|0)>0?65535:0)&65535;m=H;while(1){d[b+(m<<1)>>1]=u;m=m+1|0;if((m|0)==(h|0))break d}}else J=H;do{m=1;F=l;while(1){F=F+ +p[k+(m<<3)>>3]*(+p[(f[c+(m<<2)>>2]|0)+(J<<3)>>3]-+p[(f[c+(0-m<<2)>>2]|0)+(J<<3)>>3]);if((m|0)>=(j|0))break;else m=m+1|0}m=rNa(F)|0;d[b+(J<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;J=J+1|0}while((J|0)!=(h|0))}while(0);if(!r)break;else{r=r+-1|0;b=b+e|0;c=c+4|0}}return}function kca(a){a=a|0;PYa(a);return}function lca(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function mca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58212;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function nca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58212;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function oca(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0;i=f[a+28>>2]|0;j=+n[a+72>>2];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;o=h&-4;p=g;g=c;c=b;while(1){p=p+-1|0;a:do if(l)q=0;else{r=+n[i>>2];b=f[c>>2]|0;if(m)s=0;else{t=0;while(1){u=b+(t<<2)|0;v=j+r*+n[u+4>>2];w=j+r*+n[u+8>>2];x=j+r*+n[u+12>>2];y=wNa(j+r*+n[u>>2])|0;d[g+(t<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=wNa(v)|0;d[g+((t|1)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=wNa(w)|0;d[g+((t|2)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=wNa(x)|0;d[g+((t|3)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;t=t+4|0;if((t|0)>(a|0)){q=o;break a}}}do{t=b+(s<<2)|0;y=1;x=j+r*+n[t>>2];w=j+r*+n[t+4>>2];v=j+r*+n[t+8>>2];z=j+r*+n[t+12>>2];do{t=(f[c+(y<<2)>>2]|0)+(s<<2)|0;A=+n[i+(y<<2)>>2];x=x+A*+n[t>>2];w=w+A*+n[t+4>>2];v=v+A*+n[t+8>>2];z=z+A*+n[t+12>>2];y=y+1|0}while((y|0)!=(k|0));y=wNa(x)|0;d[g+(s<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=wNa(w)|0;d[g+((s|1)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=wNa(v)|0;d[g+((s|2)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=wNa(z)|0;d[g+((s|3)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;s=s+4|0}while((s|0)<=(a|0));q=o}while(0);b:do if((q|0)<(h|0)){r=+n[i>>2];b=f[c>>2]|0;if(m)B=q;else{y=q;while(1){t=wNa(j+r*+n[b+(y<<2)>>2])|0;d[g+(y<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;y=y+1|0;if((y|0)==(h|0))break b}}do{y=1;A=j+r*+n[b+(B<<2)>>2];do{A=A+ +n[i+(y<<2)>>2]*+n[(f[c+(y<<2)>>2]|0)+(B<<2)>>2];y=y+1|0}while((y|0)!=(k|0));y=wNa(A)|0;d[g+(B<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;B=B+1|0}while((B|0)!=(h|0))}while(0);if(!p)break;else{g=g+e|0;c=c+4|0}}return}function pca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58212;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function qca(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=+n[a+72>>2];m=b+(j<<2)|0;b=g+-1|0;o=(g|0)==0;if(f[a+76>>2]&1|0){if(o)return;a=h+-4|0;g=(h|0)<4;p=(i|0)<2;q=h&-4;r=b;s=c;t=m;while(1){a:do if(g)u=0;else{v=+n[k>>2];w=f[t>>2]|0;if(p){x=0;while(1){y=w+(x<<2)|0;z=l+v*+n[y+4>>2];A=l+v*+n[y+8>>2];B=l+v*+n[y+12>>2];C=wNa(l+v*+n[y>>2])|0;d[s+(x<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=wNa(z)|0;d[s+((x|1)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=wNa(A)|0;d[s+((x|2)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=wNa(B)|0;d[s+((x|3)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;x=x+4|0;if((x|0)>(a|0)){u=q;break a}}}else D=0;do{x=w+(D<<2)|0;C=1;B=l+v*+n[x>>2];A=l+v*+n[x+4>>2];z=l+v*+n[x+8>>2];E=l+v*+n[x+12>>2];while(1){x=(f[t+(C<<2)>>2]|0)+(D<<2)|0;y=(f[t+(0-C<<2)>>2]|0)+(D<<2)|0;F=+n[k+(C<<2)>>2];B=B+F*(+n[x>>2]+ +n[y>>2]);A=A+F*(+n[x+4>>2]+ +n[y+4>>2]);z=z+F*(+n[x+8>>2]+ +n[y+8>>2]);E=E+F*(+n[x+12>>2]+ +n[y+12>>2]);if((C|0)>=(j|0))break;else C=C+1|0}C=wNa(B)|0;d[s+(D<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=wNa(A)|0;d[s+((D|1)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=wNa(z)|0;d[s+((D|2)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=wNa(E)|0;d[s+((D|3)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;D=D+4|0}while((D|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){v=+n[k>>2];w=f[t>>2]|0;if(p){C=u;while(1){y=wNa(l+v*+n[w+(C<<2)>>2])|0;d[s+(C<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;C=C+1|0;if((C|0)==(h|0))break b}}else G=u;do{C=1;F=l+v*+n[w+(G<<2)>>2];while(1){F=F+ +n[k+(C<<2)>>2]*(+n[(f[t+(C<<2)>>2]|0)+(G<<2)>>2]+ +n[(f[t+(0-C<<2)>>2]|0)+(G<<2)>>2]);if((C|0)>=(j|0))break;else C=C+1|0}C=wNa(F)|0;d[s+(G<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;G=G+1|0}while((G|0)!=(h|0))}while(0);if(!r)break;else{r=r+-1|0;s=s+e|0;t=t+4|0}}return}if(o)return;o=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=b;b=c;c=m;while(1){c:do if(t)H=0;else{if(s){m=wNa(l)|0;G=(m>>>0<65536?m:(m|0)>0?65535:0)&65535;m=0;while(1){d[b+(m<<1)>>1]=G;d[b+((m|1)<<1)>>1]=G;d[b+((m|2)<<1)>>1]=G;d[b+((m|3)<<1)>>1]=G;m=m+4|0;if((m|0)>(o|0)){H=i;break c}}}else I=0;do{m=1;v=l;E=l;z=l;A=l;while(1){G=(f[c+(m<<2)>>2]|0)+(I<<2)|0;u=(f[c+(0-m<<2)>>2]|0)+(I<<2)|0;B=+n[k+(m<<2)>>2];v=v+B*(+n[G>>2]-+n[u>>2]);E=E+B*(+n[G+4>>2]-+n[u+4>>2]);z=z+B*(+n[G+8>>2]-+n[u+8>>2]);A=A+B*(+n[G+12>>2]-+n[u+12>>2]);if((m|0)>=(j|0))break;else m=m+1|0}m=wNa(v)|0;d[b+(I<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;m=wNa(E)|0;d[b+((I|1)<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;m=wNa(z)|0;d[b+((I|2)<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;m=wNa(A)|0;d[b+((I|3)<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;I=I+4|0}while((I|0)<=(o|0));H=i}while(0);d:do if((H|0)<(h|0)){if(s){m=wNa(l)|0;u=(m>>>0<65536?m:(m|0)>0?65535:0)&65535;m=H;while(1){d[b+(m<<1)>>1]=u;m=m+1|0;if((m|0)==(h|0))break d}}else J=H;do{m=1;F=l;while(1){F=F+ +n[k+(m<<2)>>2]*(+n[(f[c+(m<<2)>>2]|0)+(J<<2)>>2]-+n[(f[c+(0-m<<2)>>2]|0)+(J<<2)>>2]);if((m|0)>=(j|0))break;else m=m+1|0}m=wNa(F)|0;d[b+(J<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;J=J+1|0}while((J|0)!=(h|0))}while(0);if(!r)break;else{r=r+-1|0;b=b+e|0;c=c+4|0}}return}function rca(a){a=a|0;PYa(a);return}function sca(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function tca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58260;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function uca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58260;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function vca(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0;i=f[a+28>>2]|0;j=+p[a+72>>3];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;n=h&-4;o=g;g=d;d=c;while(1){o=o+-1|0;a:do if(l)q=0;else{if(m)r=0;else{c=0;while(1){s=+p[i>>3];t=(f[d>>2]|0)+(c<<3)|0;u=j+s*+p[t+8>>3];v=j+s*+p[t+16>>3];w=j+s*+p[t+24>>3];x=rNa(j+s*+p[t>>3])|0;b[g+c>>0]=x>>>0<256?x:(x|0)>0?255:0;x=rNa(u)|0;b[g+(c|1)>>0]=x>>>0<256?x:(x|0)>0?255:0;x=rNa(v)|0;b[g+(c|2)>>0]=x>>>0<256?x:(x|0)>0?255:0;x=rNa(w)|0;b[g+(c|3)>>0]=x>>>0<256?x:(x|0)>0?255:0;c=c+4|0;if((c|0)>(a|0)){q=n;break a}}}do{w=+p[i>>3];c=(f[d>>2]|0)+(r<<3)|0;x=1;v=j+w*+p[c>>3];u=j+w*+p[c+8>>3];s=j+w*+p[c+16>>3];y=j+w*+p[c+24>>3];do{c=(f[d+(x<<2)>>2]|0)+(r<<3)|0;w=+p[i+(x<<3)>>3];v=v+w*+p[c>>3];u=u+w*+p[c+8>>3];s=s+w*+p[c+16>>3];y=y+w*+p[c+24>>3];x=x+1|0}while((x|0)!=(k|0));x=rNa(v)|0;b[g+r>>0]=x>>>0<256?x:(x|0)>0?255:0;x=rNa(u)|0;b[g+(r|1)>>0]=x>>>0<256?x:(x|0)>0?255:0;x=rNa(s)|0;b[g+(r|2)>>0]=x>>>0<256?x:(x|0)>0?255:0;x=rNa(y)|0;b[g+(r|3)>>0]=x>>>0<256?x:(x|0)>0?255:0;r=r+4|0}while((r|0)<=(a|0));q=n}while(0);b:do if((q|0)<(h|0)){if(m)z=q;else{x=q;while(1){c=rNa(j+ +p[i>>3]*+p[(f[d>>2]|0)+(x<<3)>>3])|0;b[g+x>>0]=c>>>0<256?c:(c|0)>0?255:0;x=x+1|0;if((x|0)==(h|0))break b}}do{x=1;w=j+ +p[i>>3]*+p[(f[d>>2]|0)+(z<<3)>>3];do{w=w+ +p[i+(x<<3)>>3]*+p[(f[d+(x<<2)>>2]|0)+(z<<3)>>3];x=x+1|0}while((x|0)!=(k|0));x=rNa(w)|0;b[g+z>>0]=x>>>0<256?x:(x|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}while(0);if(!o)break;else{g=g+e|0;d=d+4|0}}return}function wca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58260;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function xca(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0.0,I=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<3)|0;l=+p[a+72>>3];m=c+(j<<2)|0;c=g+-1|0;n=(g|0)==0;if(f[a+80>>2]&1|0){if(n)return;a=h+-4|0;g=(h|0)<4;o=(i|0)<2;q=h&-4;r=c;s=d;t=m;while(1){a:do if(g)u=0;else{if(o){v=0;while(1){w=+p[k>>3];x=(f[t>>2]|0)+(v<<3)|0;y=l+w*+p[x+8>>3];z=l+w*+p[x+16>>3];A=l+w*+p[x+24>>3];B=rNa(l+w*+p[x>>3])|0;b[s+v>>0]=B>>>0<256?B:(B|0)>0?255:0;B=rNa(y)|0;b[s+(v|1)>>0]=B>>>0<256?B:(B|0)>0?255:0;B=rNa(z)|0;b[s+(v|2)>>0]=B>>>0<256?B:(B|0)>0?255:0;B=rNa(A)|0;b[s+(v|3)>>0]=B>>>0<256?B:(B|0)>0?255:0;v=v+4|0;if((v|0)>(a|0)){u=q;break a}}}else C=0;do{A=+p[k>>3];v=(f[t>>2]|0)+(C<<3)|0;B=1;z=l+A*+p[v>>3];y=l+A*+p[v+8>>3];w=l+A*+p[v+16>>3];D=l+A*+p[v+24>>3];while(1){v=(f[t+(B<<2)>>2]|0)+(C<<3)|0;x=(f[t+(0-B<<2)>>2]|0)+(C<<3)|0;A=+p[k+(B<<3)>>3];z=z+A*(+p[v>>3]+ +p[x>>3]);y=y+A*(+p[v+8>>3]+ +p[x+8>>3]);w=w+A*(+p[v+16>>3]+ +p[x+16>>3]);D=D+A*(+p[v+24>>3]+ +p[x+24>>3]);if((B|0)>=(j|0))break;else B=B+1|0}B=rNa(z)|0;b[s+C>>0]=B>>>0<256?B:(B|0)>0?255:0;B=rNa(y)|0;b[s+(C|1)>>0]=B>>>0<256?B:(B|0)>0?255:0;B=rNa(w)|0;b[s+(C|2)>>0]=B>>>0<256?B:(B|0)>0?255:0;B=rNa(D)|0;b[s+(C|3)>>0]=B>>>0<256?B:(B|0)>0?255:0;C=C+4|0}while((C|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){if(o){B=u;while(1){x=rNa(l+ +p[k>>3]*+p[(f[t>>2]|0)+(B<<3)>>3])|0;b[s+B>>0]=x>>>0<256?x:(x|0)>0?255:0;B=B+1|0;if((B|0)==(h|0))break b}}else E=u;do{B=1;A=l+ +p[k>>3]*+p[(f[t>>2]|0)+(E<<3)>>3];while(1){A=A+ +p[k+(B<<3)>>3]*(+p[(f[t+(B<<2)>>2]|0)+(E<<3)>>3]+ +p[(f[t+(0-B<<2)>>2]|0)+(E<<3)>>3]);if((B|0)>=(j|0))break;else B=B+1|0}B=rNa(A)|0;b[s+E>>0]=B>>>0<256?B:(B|0)>0?255:0;E=E+1|0}while((E|0)!=(h|0))}while(0);if(!r)break;else{r=r+-1|0;s=s+e|0;t=t+4|0}}return}if(n)return;n=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=c;c=d;d=m;while(1){c:do if(t)F=0;else{if(s){m=rNa(l)|0;E=(m>>>0<256?m:(m|0)>0?255:0)&255;m=0;while(1){b[c+m>>0]=E;b[c+(m|1)>>0]=E;b[c+(m|2)>>0]=E;b[c+(m|3)>>0]=E;m=m+4|0;if((m|0)>(n|0)){F=i;break c}}}else G=0;do{m=1;D=l;w=l;y=l;z=l;while(1){E=(f[d+(m<<2)>>2]|0)+(G<<3)|0;u=(f[d+(0-m<<2)>>2]|0)+(G<<3)|0;H=+p[k+(m<<3)>>3];D=D+H*(+p[E>>3]-+p[u>>3]);w=w+H*(+p[E+8>>3]-+p[u+8>>3]);y=y+H*(+p[E+16>>3]-+p[u+16>>3]);z=z+H*(+p[E+24>>3]-+p[u+24>>3]);if((m|0)>=(j|0))break;else m=m+1|0}m=rNa(D)|0;b[c+G>>0]=m>>>0<256?m:(m|0)>0?255:0;m=rNa(w)|0;b[c+(G|1)>>0]=m>>>0<256?m:(m|0)>0?255:0;m=rNa(y)|0;b[c+(G|2)>>0]=m>>>0<256?m:(m|0)>0?255:0;m=rNa(z)|0;b[c+(G|3)>>0]=m>>>0<256?m:(m|0)>0?255:0;G=G+4|0}while((G|0)<=(n|0));F=i}while(0);d:do if((F|0)<(h|0)){if(s){m=rNa(l)|0;u=(m>>>0<256?m:(m|0)>0?255:0)&255;m=F;while(1){b[c+m>>0]=u;m=m+1|0;if((m|0)==(h|0))break d}}else I=F;do{m=1;A=l;while(1){A=A+ +p[k+(m<<3)>>3]*(+p[(f[d+(m<<2)>>2]|0)+(I<<3)>>3]-+p[(f[d+(0-m<<2)>>2]|0)+(I<<3)>>3]);if((m|0)>=(j|0))break;else m=m+1|0}m=rNa(A)|0;b[c+I>>0]=m>>>0<256?m:(m|0)>0?255:0;I=I+1|0}while((I|0)!=(h|0))}while(0);if(!r)break;else{r=r+-1|0;c=c+e|0;d=d+4|0}}return}function yca(a){a=a|0;PYa(a);return}function zca(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Aca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58308;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function Bca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58308;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function Cca(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0;i=f[a+28>>2]|0;j=+n[a+72>>2];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;o=h&-4;p=g;g=d;d=c;while(1){p=p+-1|0;a:do if(l)q=0;else{if(m)r=0;else{c=0;while(1){s=+n[i>>2];t=(f[d>>2]|0)+(c<<2)|0;u=j+s*+n[t+4>>2];v=j+s*+n[t+8>>2];w=j+s*+n[t+12>>2];x=wNa(j+s*+n[t>>2])|0;b[g+c>>0]=x>>>0<256?x:(x|0)>0?255:0;x=wNa(u)|0;b[g+(c|1)>>0]=x>>>0<256?x:(x|0)>0?255:0;x=wNa(v)|0;b[g+(c|2)>>0]=x>>>0<256?x:(x|0)>0?255:0;x=wNa(w)|0;b[g+(c|3)>>0]=x>>>0<256?x:(x|0)>0?255:0;c=c+4|0;if((c|0)>(a|0)){q=o;break a}}}do{w=+n[i>>2];c=(f[d>>2]|0)+(r<<2)|0;x=1;v=j+w*+n[c>>2];u=j+w*+n[c+4>>2];s=j+w*+n[c+8>>2];y=j+w*+n[c+12>>2];do{c=(f[d+(x<<2)>>2]|0)+(r<<2)|0;w=+n[i+(x<<2)>>2];v=v+w*+n[c>>2];u=u+w*+n[c+4>>2];s=s+w*+n[c+8>>2];y=y+w*+n[c+12>>2];x=x+1|0}while((x|0)!=(k|0));x=wNa(v)|0;b[g+r>>0]=x>>>0<256?x:(x|0)>0?255:0;x=wNa(u)|0;b[g+(r|1)>>0]=x>>>0<256?x:(x|0)>0?255:0;x=wNa(s)|0;b[g+(r|2)>>0]=x>>>0<256?x:(x|0)>0?255:0;x=wNa(y)|0;b[g+(r|3)>>0]=x>>>0<256?x:(x|0)>0?255:0;r=r+4|0}while((r|0)<=(a|0));q=o}while(0);b:do if((q|0)<(h|0)){if(m)z=q;else{x=q;while(1){c=wNa(j+ +n[i>>2]*+n[(f[d>>2]|0)+(x<<2)>>2])|0;b[g+x>>0]=c>>>0<256?c:(c|0)>0?255:0;x=x+1|0;if((x|0)==(h|0))break b}}do{x=1;w=j+ +n[i>>2]*+n[(f[d>>2]|0)+(z<<2)>>2];do{w=w+ +n[i+(x<<2)>>2]*+n[(f[d+(x<<2)>>2]|0)+(z<<2)>>2];x=x+1|0}while((x|0)!=(k|0));x=wNa(w)|0;b[g+z>>0]=x>>>0<256?x:(x|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}while(0);if(!p)break;else{g=g+e|0;d=d+4|0}}return}function Dca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58308;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function Eca(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0.0,I=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=+n[a+72>>2];m=c+(j<<2)|0;c=g+-1|0;o=(g|0)==0;if(f[a+76>>2]&1|0){if(o)return;a=h+-4|0;g=(h|0)<4;p=(i|0)<2;q=h&-4;r=c;s=d;t=m;while(1){a:do if(g)u=0;else{if(p){v=0;while(1){w=+n[k>>2];x=(f[t>>2]|0)+(v<<2)|0;y=l+w*+n[x+4>>2];z=l+w*+n[x+8>>2];A=l+w*+n[x+12>>2];B=wNa(l+w*+n[x>>2])|0;b[s+v>>0]=B>>>0<256?B:(B|0)>0?255:0;B=wNa(y)|0;b[s+(v|1)>>0]=B>>>0<256?B:(B|0)>0?255:0;B=wNa(z)|0;b[s+(v|2)>>0]=B>>>0<256?B:(B|0)>0?255:0;B=wNa(A)|0;b[s+(v|3)>>0]=B>>>0<256?B:(B|0)>0?255:0;v=v+4|0;if((v|0)>(a|0)){u=q;break a}}}else C=0;do{A=+n[k>>2];v=(f[t>>2]|0)+(C<<2)|0;B=1;z=l+A*+n[v>>2];y=l+A*+n[v+4>>2];w=l+A*+n[v+8>>2];D=l+A*+n[v+12>>2];while(1){v=(f[t+(B<<2)>>2]|0)+(C<<2)|0;x=(f[t+(0-B<<2)>>2]|0)+(C<<2)|0;A=+n[k+(B<<2)>>2];z=z+A*(+n[v>>2]+ +n[x>>2]);y=y+A*(+n[v+4>>2]+ +n[x+4>>2]);w=w+A*(+n[v+8>>2]+ +n[x+8>>2]);D=D+A*(+n[v+12>>2]+ +n[x+12>>2]);if((B|0)>=(j|0))break;else B=B+1|0}B=wNa(z)|0;b[s+C>>0]=B>>>0<256?B:(B|0)>0?255:0;B=wNa(y)|0;b[s+(C|1)>>0]=B>>>0<256?B:(B|0)>0?255:0;B=wNa(w)|0;b[s+(C|2)>>0]=B>>>0<256?B:(B|0)>0?255:0;B=wNa(D)|0;b[s+(C|3)>>0]=B>>>0<256?B:(B|0)>0?255:0;C=C+4|0}while((C|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){if(p){B=u;while(1){x=wNa(l+ +n[k>>2]*+n[(f[t>>2]|0)+(B<<2)>>2])|0;b[s+B>>0]=x>>>0<256?x:(x|0)>0?255:0;B=B+1|0;if((B|0)==(h|0))break b}}else E=u;do{B=1;A=l+ +n[k>>2]*+n[(f[t>>2]|0)+(E<<2)>>2];while(1){A=A+ +n[k+(B<<2)>>2]*(+n[(f[t+(B<<2)>>2]|0)+(E<<2)>>2]+ +n[(f[t+(0-B<<2)>>2]|0)+(E<<2)>>2]);if((B|0)>=(j|0))break;else B=B+1|0}B=wNa(A)|0;b[s+E>>0]=B>>>0<256?B:(B|0)>0?255:0;E=E+1|0}while((E|0)!=(h|0))}while(0);if(!r)break;else{r=r+-1|0;s=s+e|0;t=t+4|0}}return}if(o)return;o=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=c;c=d;d=m;while(1){c:do if(t)F=0;else{if(s){m=wNa(l)|0;E=(m>>>0<256?m:(m|0)>0?255:0)&255;m=0;while(1){b[c+m>>0]=E;b[c+(m|1)>>0]=E;b[c+(m|2)>>0]=E;b[c+(m|3)>>0]=E;m=m+4|0;if((m|0)>(o|0)){F=i;break c}}}else G=0;do{m=1;D=l;w=l;y=l;z=l;while(1){E=(f[d+(m<<2)>>2]|0)+(G<<2)|0;u=(f[d+(0-m<<2)>>2]|0)+(G<<2)|0;H=+n[k+(m<<2)>>2];D=D+H*(+n[E>>2]-+n[u>>2]);w=w+H*(+n[E+4>>2]-+n[u+4>>2]);y=y+H*(+n[E+8>>2]-+n[u+8>>2]);z=z+H*(+n[E+12>>2]-+n[u+12>>2]);if((m|0)>=(j|0))break;else m=m+1|0}m=wNa(D)|0;b[c+G>>0]=m>>>0<256?m:(m|0)>0?255:0;m=wNa(w)|0;b[c+(G|1)>>0]=m>>>0<256?m:(m|0)>0?255:0;m=wNa(y)|0;b[c+(G|2)>>0]=m>>>0<256?m:(m|0)>0?255:0;m=wNa(z)|0;b[c+(G|3)>>0]=m>>>0<256?m:(m|0)>0?255:0;G=G+4|0}while((G|0)<=(o|0));F=i}while(0);d:do if((F|0)<(h|0)){if(s){m=wNa(l)|0;u=(m>>>0<256?m:(m|0)>0?255:0)&255;m=F;while(1){b[c+m>>0]=u;m=m+1|0;if((m|0)==(h|0))break d}}else I=F;do{m=1;A=l;while(1){A=A+ +n[k+(m<<2)>>2]*(+n[(f[d+(m<<2)>>2]|0)+(I<<2)>>2]-+n[(f[d+(0-m<<2)>>2]|0)+(I<<2)>>2]);if((m|0)>=(j|0))break;else m=m+1|0}m=wNa(A)|0;b[c+I>>0]=m>>>0<256?m:(m|0)>0?255:0;I=I+1|0}while((I|0)!=(h|0))}while(0);if(!r)break;else{r=r+-1|0;c=c+e|0;d=d+4|0}}return}function Fca(a){a=a|0;PYa(a);return}function Gca(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Hca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58356;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function Ica(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58356;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function Jca(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;i=f[a+28>>2]|0;j=f[a+80>>2]|0;k=f[a+4>>2]|0;l=a+68|0;a=f[l>>2]|0;m=f[l+4>>2]|0;if(!g)return;l=h+-4|0;n=(h|0)<4;o=(k|0)>1;p=h&-4;q=g;g=d;d=c;while(1){q=q+-1|0;a:do if(n)r=0;else{if(o)s=0;else{c=0;while(1){t=f[i>>2]|0;u=(f[d>>2]|0)+(c<<2)|0;v=(Y(f[u>>2]|0,t)|0)+j|0;w=(Y(f[u+4>>2]|0,t)|0)+j|0;x=(Y(f[u+8>>2]|0,t)|0)+j|0;y=(Y(f[u+12>>2]|0,t)|0)+j|0;t=v+m>>a;b[g+c>>0]=t>>>0<256?t:(t|0)>0?255:0;t=w+m>>a;b[g+(c|1)>>0]=t>>>0<256?t:(t|0)>0?255:0;t=x+m>>a;b[g+(c|2)>>0]=t>>>0<256?t:(t|0)>0?255:0;t=y+m>>a;b[g+(c|3)>>0]=t>>>0<256?t:(t|0)>0?255:0;c=c+4|0;if((c|0)>(l|0)){r=p;break a}}}do{c=f[i>>2]|0;t=(f[d>>2]|0)+(s<<2)|0;y=(Y(f[t>>2]|0,c)|0)+j|0;x=(Y(f[t+4>>2]|0,c)|0)+j|0;w=(Y(f[t+8>>2]|0,c)|0)+j|0;v=1;u=y;y=x;x=w;w=(Y(f[t+12>>2]|0,c)|0)+j|0;do{c=(f[d+(v<<2)>>2]|0)+(s<<2)|0;t=f[i+(v<<2)>>2]|0;u=(Y(f[c>>2]|0,t)|0)+u|0;y=(Y(f[c+4>>2]|0,t)|0)+y|0;x=(Y(f[c+8>>2]|0,t)|0)+x|0;w=(Y(f[c+12>>2]|0,t)|0)+w|0;v=v+1|0}while((v|0)!=(k|0));v=u+m>>a;b[g+s>>0]=v>>>0<256?v:(v|0)>0?255:0;v=y+m>>a;b[g+(s|1)>>0]=v>>>0<256?v:(v|0)>0?255:0;v=x+m>>a;b[g+(s|2)>>0]=v>>>0<256?v:(v|0)>0?255:0;v=w+m>>a;b[g+(s|3)>>0]=v>>>0<256?v:(v|0)>0?255:0;s=s+4|0}while((s|0)<=(l|0));r=p}while(0);b:do if((r|0)<(h|0)){if(o)z=r;else{v=r;while(1){t=(Y(f[(f[d>>2]|0)+(v<<2)>>2]|0,f[i>>2]|0)|0)+j+m>>a;b[g+v>>0]=t>>>0<256?t:(t|0)>0?255:0;v=v+1|0;if((v|0)==(h|0))break b}}do{v=1;t=(Y(f[(f[d>>2]|0)+(z<<2)>>2]|0,f[i>>2]|0)|0)+j|0;do{t=(Y(f[(f[d+(v<<2)>>2]|0)+(z<<2)>>2]|0,f[i+(v<<2)>>2]|0)|0)+t|0;v=v+1|0}while((v|0)!=(k|0));v=t+m>>a;b[g+z>>0]=v>>>0<256?v:(v|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}while(0);if(!q)break;else{g=g+e|0;d=d+4|0}}return}function Kca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58356;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function Lca(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=f[a+80>>2]|0;m=a+68|0;n=f[m>>2]|0;o=f[m+4>>2]|0;m=c+(j<<2)|0;c=g+-1|0;p=(g|0)==0;if(!(f[a+84>>2]&1)){if(p)return;a=h+-4|0;g=(h|0)<4;q=(i|0)<2;r=h&-4;s=l+o>>n;t=(s>>>0<256?s:(s|0)>0?255:0)&255;s=l+o>>n;u=(s>>>0<256?s:(s|0)>0?255:0)&255;s=c;v=d;w=m;while(1){a:do if(g)x=0;else{if(q){y=0;while(1){b[v+y>>0]=u;b[v+(y|1)>>0]=u;b[v+(y|2)>>0]=u;b[v+(y|3)>>0]=u;y=y+4|0;if((y|0)>(a|0)){x=r;break a}}}else z=0;do{y=1;A=l;B=l;C=l;D=l;while(1){E=(f[w+(y<<2)>>2]|0)+(z<<2)|0;F=(f[w+(0-y<<2)>>2]|0)+(z<<2)|0;G=f[k+(y<<2)>>2]|0;A=(Y((f[E>>2]|0)-(f[F>>2]|0)|0,G)|0)+A|0;B=(Y((f[E+4>>2]|0)-(f[F+4>>2]|0)|0,G)|0)+B|0;C=(Y((f[E+8>>2]|0)-(f[F+8>>2]|0)|0,G)|0)+C|0;D=(Y((f[E+12>>2]|0)-(f[F+12>>2]|0)|0,G)|0)+D|0;if((y|0)>=(j|0))break;else y=y+1|0}y=A+o>>n;b[v+z>>0]=y>>>0<256?y:(y|0)>0?255:0;y=B+o>>n;b[v+(z|1)>>0]=y>>>0<256?y:(y|0)>0?255:0;y=C+o>>n;b[v+(z|2)>>0]=y>>>0<256?y:(y|0)>0?255:0;y=D+o>>n;b[v+(z|3)>>0]=y>>>0<256?y:(y|0)>0?255:0;z=z+4|0}while((z|0)<=(a|0));x=r}while(0);b:do if((x|0)<(h|0)){if(q){y=x;while(1){b[v+y>>0]=t;y=y+1|0;if((y|0)==(h|0))break b}}else H=x;do{y=1;G=l;while(1){G=(Y((f[(f[w+(y<<2)>>2]|0)+(H<<2)>>2]|0)-(f[(f[w+(0-y<<2)>>2]|0)+(H<<2)>>2]|0)|0,f[k+(y<<2)>>2]|0)|0)+G|0;if((y|0)>=(j|0))break;else y=y+1|0}y=G+o>>n;b[v+H>>0]=y>>>0<256?y:(y|0)>0?255:0;H=H+1|0}while((H|0)!=(h|0))}while(0);if(!s)break;else{s=s+-1|0;v=v+e|0;w=w+4|0}}return}else{if(p)return;p=h+-4|0;w=(h|0)<4;v=(i|0)<2;i=h&-4;s=c;c=d;d=m;while(1){c:do if(w)I=0;else{if(v){m=0;while(1){H=f[k>>2]|0;x=(f[d>>2]|0)+(m<<2)|0;t=(Y(f[x>>2]|0,H)|0)+l|0;q=(Y(f[x+4>>2]|0,H)|0)+l|0;r=(Y(f[x+8>>2]|0,H)|0)+l|0;a=(Y(f[x+12>>2]|0,H)|0)+l|0;H=t+o>>n;b[c+m>>0]=H>>>0<256?H:(H|0)>0?255:0;H=q+o>>n;b[c+(m|1)>>0]=H>>>0<256?H:(H|0)>0?255:0;H=r+o>>n;b[c+(m|2)>>0]=H>>>0<256?H:(H|0)>0?255:0;H=a+o>>n;b[c+(m|3)>>0]=H>>>0<256?H:(H|0)>0?255:0;m=m+4|0;if((m|0)>(p|0)){I=i;break c}}}else J=0;do{m=f[k>>2]|0;H=(f[d>>2]|0)+(J<<2)|0;a=(Y(f[H>>2]|0,m)|0)+l|0;r=(Y(f[H+4>>2]|0,m)|0)+l|0;q=(Y(f[H+8>>2]|0,m)|0)+l|0;t=1;x=a;a=r;r=q;q=(Y(f[H+12>>2]|0,m)|0)+l|0;while(1){m=(f[d+(t<<2)>>2]|0)+(J<<2)|0;H=(f[d+(0-t<<2)>>2]|0)+(J<<2)|0;z=f[k+(t<<2)>>2]|0;x=(Y((f[H>>2]|0)+(f[m>>2]|0)|0,z)|0)+x|0;a=(Y((f[H+4>>2]|0)+(f[m+4>>2]|0)|0,z)|0)+a|0;r=(Y((f[H+8>>2]|0)+(f[m+8>>2]|0)|0,z)|0)+r|0;q=(Y((f[H+12>>2]|0)+(f[m+12>>2]|0)|0,z)|0)+q|0;if((t|0)>=(j|0))break;else t=t+1|0}t=x+o>>n;b[c+J>>0]=t>>>0<256?t:(t|0)>0?255:0;t=a+o>>n;b[c+(J|1)>>0]=t>>>0<256?t:(t|0)>0?255:0;t=r+o>>n;b[c+(J|2)>>0]=t>>>0<256?t:(t|0)>0?255:0;t=q+o>>n;b[c+(J|3)>>0]=t>>>0<256?t:(t|0)>0?255:0;J=J+4|0}while((J|0)<=(p|0));I=i}while(0);d:do if((I|0)<(h|0)){if(v){t=I;while(1){G=(Y(f[(f[d>>2]|0)+(t<<2)>>2]|0,f[k>>2]|0)|0)+l+o>>n;b[c+t>>0]=G>>>0<256?G:(G|0)>0?255:0;t=t+1|0;if((t|0)==(h|0))break d}}else K=I;do{t=1;G=(Y(f[(f[d>>2]|0)+(K<<2)>>2]|0,f[k>>2]|0)|0)+l|0;while(1){G=(Y((f[(f[d+(0-t<<2)>>2]|0)+(K<<2)>>2]|0)+(f[(f[d+(t<<2)>>2]|0)+(K<<2)>>2]|0)|0,f[k+(t<<2)>>2]|0)|0)+G|0;if((t|0)>=(j|0))break;else t=t+1|0}t=G+o>>n;b[c+K>>0]=t>>>0<256?t:(t|0)>0?255:0;K=K+1|0}while((K|0)!=(h|0))}while(0);if(!s)break;else{s=s+-1|0;c=c+e|0;d=d+4|0}}return}}function Mca(a){a=a|0;PYa(a);return}function Nca(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Oca(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;Uca(a,c,d,e,h,i);f[a>>2]=58428;f[a+76>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=c$(k,64)|0;a=228297;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));j$(-215,k,228362,225433,3314);d$(k);u=j;return}function Pca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58404;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function Qca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58404;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function Rca(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0;h=f[a+28>>2]|0;i=+n[a+72>>2];j=f[a+4>>2]|0;if(!e)return;a=g+-4|0;k=(g|0)<4;l=(j|0)>1;m=g&-4;o=e;e=c;c=b;while(1){o=o+-1|0;a:do if(k)p=0;else{b=f[c>>2]|0;if(l)q=0;else{r=0;while(1){s=+n[h>>2];t=b+(r<<2)|0;u=i+s*+n[t+4>>2];v=i+s*+n[t+8>>2];w=i+s*+n[t+12>>2];n[e+(r<<2)>>2]=i+s*+n[t>>2];n[e+((r|1)<<2)>>2]=u;n[e+((r|2)<<2)>>2]=v;n[e+((r|3)<<2)>>2]=w;r=r+4|0;if((r|0)>(a|0)){p=m;break a}}}do{w=+n[h>>2];r=b+(q<<2)|0;t=1;v=i+w*+n[r>>2];u=i+w*+n[r+4>>2];s=i+w*+n[r+8>>2];x=i+w*+n[r+12>>2];do{r=(f[c+(t<<2)>>2]|0)+(q<<2)|0;w=+n[h+(t<<2)>>2];v=v+w*+n[r>>2];u=u+w*+n[r+4>>2];s=s+w*+n[r+8>>2];x=x+w*+n[r+12>>2];t=t+1|0}while((t|0)!=(j|0));n[e+(q<<2)>>2]=v;n[e+((q|1)<<2)>>2]=u;n[e+((q|2)<<2)>>2]=s;n[e+((q|3)<<2)>>2]=x;q=q+4|0}while((q|0)<=(a|0));p=m}while(0);b:do if((p|0)<(g|0)){b=f[c>>2]|0;if(l)y=p;else{t=p;while(1){n[e+(t<<2)>>2]=i+ +n[h>>2]*+n[b+(t<<2)>>2];t=t+1|0;if((t|0)==(g|0))break b}}do{t=1;w=i+ +n[h>>2]*+n[b+(y<<2)>>2];do{w=w+ +n[h+(t<<2)>>2]*+n[(f[c+(t<<2)>>2]|0)+(y<<2)>>2];t=t+1|0}while((t|0)!=(j|0));n[e+(y<<2)>>2]=w;y=y+1|0}while((y|0)!=(g|0))}while(0);if(!o)break;else{e=e+d|0;c=c+4|0}}return}function Sca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58404;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function Tca(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0.0,l=0.0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0;h=(f[a+4>>2]|0)/2|0;i=(f[a+28>>2]|0)+(h<<2)|0;j=(f[a+76>>2]&1|0)==0;k=+n[i>>2];l=+n[i+4>>2];i=l==1.0;m=k==2.0&i;o=k==-2.0&i;p=k!=0.0;q=p|i?p^1:l==-1.0;r=+n[a+72>>2];if(!e)return;a=l<0.0;p=g+-4|0;i=(g|0)<4;s=g&-4;t=e;e=c;c=b+(h<<2)|0;while(1){t=t+-1|0;h=f[c+-4>>2]|0;b=f[c>>2]|0;c=c+4|0;u=f[c>>2]|0;a:do if(j)if(q){v=a?u:h;w=a?h:u;if(i)x=0;else{y=w;z=v;A=0;do{B=A|1;C=r+(+n[y+(B<<2)>>2]-+n[z+(B<<2)>>2]);n[e+(A<<2)>>2]=r+(+n[y+(A<<2)>>2]-+n[z+(A<<2)>>2]);n[e+(B<<2)>>2]=C;B=A|2;D=A|3;C=r+(+n[y+(D<<2)>>2]-+n[z+(D<<2)>>2]);n[e+(B<<2)>>2]=r+(+n[y+(B<<2)>>2]-+n[z+(B<<2)>>2]);n[e+(D<<2)>>2]=C;A=A+4|0}while((A|0)<=(p|0));x=s}if((x|0)>=(g|0))break;A=w;z=v;y=x;do{n[e+(y<<2)>>2]=r+(+n[A+(y<<2)>>2]-+n[z+(y<<2)>>2]);y=y+1|0}while((y|0)!=(g|0))}else{if(i)E=0;else{y=u;z=h;A=0;do{v=A|1;C=r+l*(+n[y+(v<<2)>>2]-+n[z+(v<<2)>>2]);n[e+(A<<2)>>2]=r+l*(+n[y+(A<<2)>>2]-+n[z+(A<<2)>>2]);n[e+(v<<2)>>2]=C;v=A|2;w=A|3;C=r+l*(+n[y+(w<<2)>>2]-+n[z+(w<<2)>>2]);n[e+(v<<2)>>2]=r+l*(+n[y+(v<<2)>>2]-+n[z+(v<<2)>>2]);n[e+(w<<2)>>2]=C;A=A+4|0}while((A|0)<=(p|0));E=s}if((E|0)>=(g|0))break;A=u;z=h;y=E;do{n[e+(y<<2)>>2]=r+l*(+n[A+(y<<2)>>2]-+n[z+(y<<2)>>2]);y=y+1|0}while((y|0)!=(g|0))}else{if(m){if(i)F=0;else{y=h;z=u;A=0;do{w=A|1;C=r+(+n[z+(w<<2)>>2]+(+n[y+(w<<2)>>2]+ +n[b+(w<<2)>>2]*2.0));n[e+(A<<2)>>2]=r+(+n[z+(A<<2)>>2]+(+n[y+(A<<2)>>2]+ +n[b+(A<<2)>>2]*2.0));n[e+(w<<2)>>2]=C;w=A|2;v=A|3;C=r+(+n[z+(v<<2)>>2]+(+n[y+(v<<2)>>2]+ +n[b+(v<<2)>>2]*2.0));n[e+(w<<2)>>2]=r+(+n[z+(w<<2)>>2]+(+n[y+(w<<2)>>2]+ +n[b+(w<<2)>>2]*2.0));n[e+(v<<2)>>2]=C;A=A+4|0}while((A|0)<=(p|0));F=s}if((F|0)>=(g|0))break;A=h;y=u;z=F;while(1){n[e+(z<<2)>>2]=r+(+n[y+(z<<2)>>2]+(+n[A+(z<<2)>>2]+ +n[b+(z<<2)>>2]*2.0));z=z+1|0;if((z|0)==(g|0))break a}}if(o){if(i)G=0;else{z=h;A=u;y=0;do{v=y|1;C=r+(+n[A+(v<<2)>>2]+(+n[z+(v<<2)>>2]-+n[b+(v<<2)>>2]*2.0));n[e+(y<<2)>>2]=r+(+n[A+(y<<2)>>2]+(+n[z+(y<<2)>>2]-+n[b+(y<<2)>>2]*2.0));n[e+(v<<2)>>2]=C;v=y|2;w=y|3;C=r+(+n[A+(w<<2)>>2]+(+n[z+(w<<2)>>2]-+n[b+(w<<2)>>2]*2.0));n[e+(v<<2)>>2]=r+(+n[A+(v<<2)>>2]+(+n[z+(v<<2)>>2]-+n[b+(v<<2)>>2]*2.0));n[e+(w<<2)>>2]=C;y=y+4|0}while((y|0)<=(p|0));G=s}if((G|0)>=(g|0))break;y=h;z=u;A=G;do{n[e+(A<<2)>>2]=r+(+n[z+(A<<2)>>2]+(+n[y+(A<<2)>>2]-+n[b+(A<<2)>>2]*2.0));A=A+1|0}while((A|0)!=(g|0))}else{if(i)H=0;else{A=h;y=u;z=0;do{w=z|1;C=r+(l*(+n[A+(w<<2)>>2]+ +n[y+(w<<2)>>2])+k*+n[b+(w<<2)>>2]);n[e+(z<<2)>>2]=r+(l*(+n[A+(z<<2)>>2]+ +n[y+(z<<2)>>2])+k*+n[b+(z<<2)>>2]);n[e+(w<<2)>>2]=C;w=z|2;v=z|3;C=r+(l*(+n[A+(v<<2)>>2]+ +n[y+(v<<2)>>2])+k*+n[b+(v<<2)>>2]);n[e+(w<<2)>>2]=r+(l*(+n[A+(w<<2)>>2]+ +n[y+(w<<2)>>2])+k*+n[b+(w<<2)>>2]);n[e+(v<<2)>>2]=C;z=z+4|0}while((z|0)<=(p|0));H=s}if((H|0)>=(g|0))break;z=h;y=u;A=H;do{n[e+(A<<2)>>2]=r+(l*(+n[z+(A<<2)>>2]+ +n[y+(A<<2)>>2])+k*+n[b+(A<<2)>>2]);A=A+1|0}while((A|0)!=(g|0))}}while(0);if(!t)break;else e=e+d|0}return}function Uca(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=58404;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;o=a+52|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){CR(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[o>>2]|0;o=0;do{f[t+(o<<2)>>2]=0;o=o+1|0;y=f[l>>2]|0}while((o|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)BR(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;eL(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;n[a+72>>2]=e;if((f[k>>2]&4095|0)==5?(d|0)==1|(m|0)==1:0){u=h;return}f[g>>2]=0;f[g+4>>2]=0;p=c$(g,77)|0;m=229351;q=p+77|0;do{b[p>>0]=b[m>>0]|0;p=p+1|0;m=m+1|0}while((p|0)<(q|0));j$(-215,g,229429,225433,3251);d$(g);u=h;return}function Vca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58404;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}
function Gia(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;h=f[a+4>>2]|0;a=d>>>2;d=(h|0)>1;if(d&(e|0)>1){i=g+-4|0;j=(g|0)<4;k=(h|0)>2;l=a<<1;m=g&-4;o=c;p=e;q=b;while(1){a:do if(j)r=0;else{s=f[q+4>>2]|0;t=f[q>>2]|0;if(!k){u=f[q+8>>2]|0;v=0;while(1){w=s+(v<<2)|0;x=+n[w>>2];y=+n[w+4>>2];z=+n[w+8>>2];A=+n[w+12>>2];w=t+(v<<2)|0;B=+n[w>>2];n[o+(v<<2)>>2]=B<x?B:x;B=+n[w+4>>2];n[o+((v|1)<<2)>>2]=B<y?B:y;B=+n[w+8>>2];n[o+((v|2)<<2)>>2]=B<z?B:z;B=+n[w+12>>2];n[o+((v|3)<<2)>>2]=B<A?B:A;w=u+(v<<2)|0;B=+n[w>>2];C=v+a|0;n[o+(C<<2)>>2]=B<x?B:x;x=+n[w+4>>2];n[o+(C+1<<2)>>2]=x<y?x:y;y=+n[w+8>>2];n[o+(C+2<<2)>>2]=y<z?y:z;z=+n[w+12>>2];n[o+(C+3<<2)>>2]=z<A?z:A;v=v+4|0;if((v|0)>(i|0)){r=m;break a}}}v=f[q+(h<<2)>>2]|0;u=0;do{C=s+(u<<2)|0;w=2;A=+n[C>>2];z=+n[C+4>>2];y=+n[C+8>>2];x=+n[C+12>>2];do{C=(f[q+(w<<2)>>2]|0)+(u<<2)|0;B=+n[C>>2];A=B<A?B:A;B=+n[C+4>>2];z=B<z?B:z;B=+n[C+8>>2];y=B<y?B:y;B=+n[C+12>>2];x=B<x?B:x;w=w+1|0}while((w|0)!=(h|0));w=t+(u<<2)|0;B=+n[w>>2];n[o+(u<<2)>>2]=B<A?B:A;B=+n[w+4>>2];n[o+((u|1)<<2)>>2]=B<z?B:z;B=+n[w+8>>2];n[o+((u|2)<<2)>>2]=B<y?B:y;B=+n[w+12>>2];n[o+((u|3)<<2)>>2]=B<x?B:x;w=v+(u<<2)|0;B=+n[w>>2];C=u+a|0;n[o+(C<<2)>>2]=B<A?B:A;B=+n[w+4>>2];n[o+(C+1<<2)>>2]=B<z?B:z;B=+n[w+8>>2];n[o+(C+2<<2)>>2]=B<y?B:y;B=+n[w+12>>2];n[o+(C+3<<2)>>2]=B<x?B:x;u=u+4|0}while((u|0)<=(i|0));r=m}while(0);b:do if((r|0)<(g|0)){u=f[q+4>>2]|0;v=f[q>>2]|0;if(!k){t=f[q+8>>2]|0;s=r;while(1){B=+n[u+(s<<2)>>2];D=+n[v+(s<<2)>>2];n[o+(s<<2)>>2]=D<B?D:B;D=+n[t+(s<<2)>>2];n[o+(s+a<<2)>>2]=D<B?D:B;s=s+1|0;if((s|0)==(g|0))break b}}s=f[q+(h<<2)>>2]|0;t=r;do{C=2;B=+n[u+(t<<2)>>2];do{D=+n[(f[q+(C<<2)>>2]|0)+(t<<2)>>2];B=D<B?D:B;C=C+1|0}while((C|0)!=(h|0));x=+n[v+(t<<2)>>2];n[o+(t<<2)>>2]=x<B?x:B;x=+n[s+(t<<2)>>2];n[o+(t+a<<2)>>2]=x<B?x:B;t=t+1|0}while((t|0)!=(g|0))}while(0);t=p+-2|0;s=o+(l<<2)|0;v=q+8|0;if((t|0)>1){o=s;p=t;q=v}else{E=s;F=t;G=v;break}}}else{E=c;F=e;G=b}if((F|0)<=0)return;b=g+-4|0;e=(g|0)<4;c=g&-4;q=E;E=F;F=G;while(1){c:do if(e)H=0;else{G=f[F>>2]|0;if(d)I=0;else{p=0;while(1){o=G+(p<<2)|0;l=f[o+4>>2]|0;r=f[o+8>>2]|0;k=f[o+12>>2]|0;f[q+(p<<2)>>2]=f[o>>2];f[q+((p|1)<<2)>>2]=l;f[q+((p|2)<<2)>>2]=r;f[q+((p|3)<<2)>>2]=k;p=p+4|0;if((p|0)>(b|0)){H=c;break c}}}do{p=G+(I<<2)|0;k=1;x=+n[p>>2];y=+n[p+4>>2];z=+n[p+8>>2];A=+n[p+12>>2];do{p=(f[F+(k<<2)>>2]|0)+(I<<2)|0;D=+n[p>>2];x=D<x?D:x;D=+n[p+4>>2];y=D<y?D:y;D=+n[p+8>>2];z=D<z?D:z;D=+n[p+12>>2];A=D<A?D:A;k=k+1|0}while((k|0)!=(h|0));n[q+(I<<2)>>2]=x;n[q+((I|1)<<2)>>2]=y;n[q+((I|2)<<2)>>2]=z;n[q+((I|3)<<2)>>2]=A;I=I+4|0}while((I|0)<=(b|0));H=c}while(0);d:do if((H|0)<(g|0)){G=f[F>>2]|0;if(d)J=H;else{k=H;while(1){f[q+(k<<2)>>2]=f[G+(k<<2)>>2];k=k+1|0;if((k|0)==(g|0))break d}}do{k=1;B=+n[G+(J<<2)>>2];do{D=+n[(f[F+(k<<2)>>2]|0)+(J<<2)>>2];B=D<B?D:B;k=k+1|0}while((k|0)!=(h|0));n[q+(J<<2)>>2]=B;J=J+1|0}while((J|0)!=(g|0))}while(0);if((E|0)>1){q=q+(a<<2)|0;E=E+-1|0;F=F+4|0}else break}return}function Hia(a){a=a|0;PYa(a);return}function Iia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Jia(a){a=a|0;PYa(a);return}function Kia(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;a=e>>>1;e=(i|0)>1;if(e&(g|0)>1){j=h+-4|0;k=(h|0)<4;l=(i|0)>2;m=a<<1;n=h&-4;o=c;p=g;q=b;while(1){a:do if(k)r=0;else{s=f[q+4>>2]|0;t=f[q>>2]|0;if(!l){u=f[q+8>>2]|0;v=0;while(1){w=s+(v<<1)|0;x=d[w>>1]|0;y=d[w+2>>1]|0;z=d[w+4>>1]|0;A=d[w+6>>1]|0;w=t+(v<<1)|0;B=d[w>>1]|0;d[o+(v<<1)>>1]=B<<16>>16<x<<16>>16?B:x;B=d[w+2>>1]|0;d[o+((v|1)<<1)>>1]=B<<16>>16<y<<16>>16?B:y;B=d[w+4>>1]|0;d[o+((v|2)<<1)>>1]=B<<16>>16<z<<16>>16?B:z;B=d[w+6>>1]|0;d[o+((v|3)<<1)>>1]=B<<16>>16<A<<16>>16?B:A;B=u+(v<<1)|0;w=d[B>>1]|0;C=v+a|0;d[o+(C<<1)>>1]=w<<16>>16<x<<16>>16?w:x;x=d[B+2>>1]|0;d[o+(C+1<<1)>>1]=x<<16>>16<y<<16>>16?x:y;y=d[B+4>>1]|0;d[o+(C+2<<1)>>1]=y<<16>>16<z<<16>>16?y:z;z=d[B+6>>1]|0;d[o+(C+3<<1)>>1]=z<<16>>16<A<<16>>16?z:A;v=v+4|0;if((v|0)>(j|0)){r=n;break a}}}v=f[q+(i<<2)>>2]|0;u=0;do{A=s+(u<<1)|0;z=2;C=d[A>>1]|0;B=d[A+2>>1]|0;y=d[A+4>>1]|0;x=d[A+6>>1]|0;do{A=(f[q+(z<<2)>>2]|0)+(u<<1)|0;w=d[A>>1]|0;C=w<<16>>16<C<<16>>16?w:C;w=d[A+2>>1]|0;B=w<<16>>16<B<<16>>16?w:B;w=d[A+4>>1]|0;y=w<<16>>16<y<<16>>16?w:y;w=d[A+6>>1]|0;x=w<<16>>16<x<<16>>16?w:x;z=z+1|0}while((z|0)!=(i|0));z=t+(u<<1)|0;w=d[z>>1]|0;d[o+(u<<1)>>1]=w<<16>>16<C<<16>>16?w:C;w=d[z+2>>1]|0;d[o+((u|1)<<1)>>1]=w<<16>>16<B<<16>>16?w:B;w=d[z+4>>1]|0;d[o+((u|2)<<1)>>1]=w<<16>>16<y<<16>>16?w:y;w=d[z+6>>1]|0;d[o+((u|3)<<1)>>1]=w<<16>>16<x<<16>>16?w:x;w=v+(u<<1)|0;z=d[w>>1]|0;A=u+a|0;d[o+(A<<1)>>1]=z<<16>>16<C<<16>>16?z:C;z=d[w+2>>1]|0;d[o+(A+1<<1)>>1]=z<<16>>16<B<<16>>16?z:B;z=d[w+4>>1]|0;d[o+(A+2<<1)>>1]=z<<16>>16<y<<16>>16?z:y;z=d[w+6>>1]|0;d[o+(A+3<<1)>>1]=z<<16>>16<x<<16>>16?z:x;u=u+4|0}while((u|0)<=(j|0));r=n}while(0);b:do if((r|0)<(h|0)){u=f[q+4>>2]|0;v=f[q>>2]|0;if(!l){t=f[q+8>>2]|0;s=r;while(1){z=d[u+(s<<1)>>1]|0;A=d[v+(s<<1)>>1]|0;d[o+(s<<1)>>1]=A<<16>>16<z<<16>>16?A:z;A=d[t+(s<<1)>>1]|0;d[o+(s+a<<1)>>1]=A<<16>>16<z<<16>>16?A:z;s=s+1|0;if((s|0)==(h|0))break b}}s=f[q+(i<<2)>>2]|0;t=r;do{z=2;A=d[u+(t<<1)>>1]|0;do{w=d[(f[q+(z<<2)>>2]|0)+(t<<1)>>1]|0;A=w<<16>>16<A<<16>>16?w:A;z=z+1|0}while((z|0)!=(i|0));z=d[v+(t<<1)>>1]|0;d[o+(t<<1)>>1]=z<<16>>16<A<<16>>16?z:A;z=d[s+(t<<1)>>1]|0;d[o+(t+a<<1)>>1]=z<<16>>16<A<<16>>16?z:A;t=t+1|0}while((t|0)!=(h|0))}while(0);t=p+-2|0;s=o+(m<<1)|0;v=q+8|0;if((t|0)>1){o=s;p=t;q=v}else{D=s;E=t;F=v;break}}}else{D=c;E=g;F=b}if((E|0)<=0)return;b=h+-4|0;g=(h|0)<4;c=h&-4;q=D;D=E;E=F;while(1){c:do if(g)G=0;else{F=f[E>>2]|0;if(e)H=0;else{p=0;while(1){o=F+(p<<1)|0;m=d[o+2>>1]|0;r=d[o+4>>1]|0;l=d[o+6>>1]|0;d[q+(p<<1)>>1]=d[o>>1]|0;d[q+((p|1)<<1)>>1]=m;d[q+((p|2)<<1)>>1]=r;d[q+((p|3)<<1)>>1]=l;p=p+4|0;if((p|0)>(b|0)){G=c;break c}}}do{p=F+(H<<1)|0;l=1;r=d[p>>1]|0;m=d[p+2>>1]|0;o=d[p+4>>1]|0;n=d[p+6>>1]|0;do{p=(f[E+(l<<2)>>2]|0)+(H<<1)|0;j=d[p>>1]|0;r=j<<16>>16<r<<16>>16?j:r;j=d[p+2>>1]|0;m=j<<16>>16<m<<16>>16?j:m;j=d[p+4>>1]|0;o=j<<16>>16<o<<16>>16?j:o;j=d[p+6>>1]|0;n=j<<16>>16<n<<16>>16?j:n;l=l+1|0}while((l|0)!=(i|0));d[q+(H<<1)>>1]=r;d[q+((H|1)<<1)>>1]=m;d[q+((H|2)<<1)>>1]=o;d[q+((H|3)<<1)>>1]=n;H=H+4|0}while((H|0)<=(b|0));G=c}while(0);d:do if((G|0)<(h|0)){F=f[E>>2]|0;if(e)I=G;else{l=G;while(1){d[q+(l<<1)>>1]=d[F+(l<<1)>>1]|0;l=l+1|0;if((l|0)==(h|0))break d}}do{l=1;A=d[F+(I<<1)>>1]|0;do{j=d[(f[E+(l<<2)>>2]|0)+(I<<1)>>1]|0;A=j<<16>>16<A<<16>>16?j:A;l=l+1|0}while((l|0)!=(i|0));d[q+(I<<1)>>1]=A;I=I+1|0}while((I|0)!=(h|0))}while(0);if((D|0)>1){q=q+(a<<1)|0;D=D+-1|0;E=E+4|0}else break}return}function Lia(a){a=a|0;PYa(a);return}function Mia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Nia(a){a=a|0;PYa(a);return}function Oia(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;a=e>>>1;e=(i|0)>1;if(e&(g|0)>1){j=h+-4|0;k=(h|0)<4;l=(i|0)>2;m=a<<1;n=h&-4;o=c;p=g;q=b;while(1){a:do if(k)r=0;else{s=f[q+4>>2]|0;t=f[q>>2]|0;if(!l){u=f[q+8>>2]|0;v=0;while(1){w=s+(v<<1)|0;x=d[w>>1]|0;y=d[w+2>>1]|0;z=d[w+4>>1]|0;A=d[w+6>>1]|0;w=t+(v<<1)|0;B=d[w>>1]|0;d[o+(v<<1)>>1]=(B&65535)<(x&65535)?B:x;B=d[w+2>>1]|0;d[o+((v|1)<<1)>>1]=(B&65535)<(y&65535)?B:y;B=d[w+4>>1]|0;d[o+((v|2)<<1)>>1]=(B&65535)<(z&65535)?B:z;B=d[w+6>>1]|0;d[o+((v|3)<<1)>>1]=(B&65535)<(A&65535)?B:A;B=u+(v<<1)|0;w=d[B>>1]|0;C=v+a|0;d[o+(C<<1)>>1]=(w&65535)<(x&65535)?w:x;x=d[B+2>>1]|0;d[o+(C+1<<1)>>1]=(x&65535)<(y&65535)?x:y;y=d[B+4>>1]|0;d[o+(C+2<<1)>>1]=(y&65535)<(z&65535)?y:z;z=d[B+6>>1]|0;d[o+(C+3<<1)>>1]=(z&65535)<(A&65535)?z:A;v=v+4|0;if((v|0)>(j|0)){r=n;break a}}}v=f[q+(i<<2)>>2]|0;u=0;do{A=s+(u<<1)|0;z=2;C=d[A>>1]|0;B=d[A+2>>1]|0;y=d[A+4>>1]|0;x=d[A+6>>1]|0;do{A=(f[q+(z<<2)>>2]|0)+(u<<1)|0;w=d[A>>1]|0;C=(w&65535)<(C&65535)?w:C;w=d[A+2>>1]|0;B=(w&65535)<(B&65535)?w:B;w=d[A+4>>1]|0;y=(w&65535)<(y&65535)?w:y;w=d[A+6>>1]|0;x=(w&65535)<(x&65535)?w:x;z=z+1|0}while((z|0)!=(i|0));z=t+(u<<1)|0;w=d[z>>1]|0;d[o+(u<<1)>>1]=(w&65535)<(C&65535)?w:C;w=d[z+2>>1]|0;d[o+((u|1)<<1)>>1]=(w&65535)<(B&65535)?w:B;w=d[z+4>>1]|0;d[o+((u|2)<<1)>>1]=(w&65535)<(y&65535)?w:y;w=d[z+6>>1]|0;d[o+((u|3)<<1)>>1]=(w&65535)<(x&65535)?w:x;w=v+(u<<1)|0;z=d[w>>1]|0;A=u+a|0;d[o+(A<<1)>>1]=(z&65535)<(C&65535)?z:C;z=d[w+2>>1]|0;d[o+(A+1<<1)>>1]=(z&65535)<(B&65535)?z:B;z=d[w+4>>1]|0;d[o+(A+2<<1)>>1]=(z&65535)<(y&65535)?z:y;z=d[w+6>>1]|0;d[o+(A+3<<1)>>1]=(z&65535)<(x&65535)?z:x;u=u+4|0}while((u|0)<=(j|0));r=n}while(0);b:do if((r|0)<(h|0)){u=f[q+4>>2]|0;v=f[q>>2]|0;if(!l){t=f[q+8>>2]|0;s=r;while(1){z=d[u+(s<<1)>>1]|0;A=d[v+(s<<1)>>1]|0;d[o+(s<<1)>>1]=(A&65535)<(z&65535)?A:z;A=d[t+(s<<1)>>1]|0;d[o+(s+a<<1)>>1]=(A&65535)<(z&65535)?A:z;s=s+1|0;if((s|0)==(h|0))break b}}s=f[q+(i<<2)>>2]|0;t=r;do{z=2;A=d[u+(t<<1)>>1]|0;do{w=d[(f[q+(z<<2)>>2]|0)+(t<<1)>>1]|0;A=(w&65535)<(A&65535)?w:A;z=z+1|0}while((z|0)!=(i|0));z=d[v+(t<<1)>>1]|0;d[o+(t<<1)>>1]=(z&65535)<(A&65535)?z:A;z=d[s+(t<<1)>>1]|0;d[o+(t+a<<1)>>1]=(z&65535)<(A&65535)?z:A;t=t+1|0}while((t|0)!=(h|0))}while(0);t=p+-2|0;s=o+(m<<1)|0;v=q+8|0;if((t|0)>1){o=s;p=t;q=v}else{D=s;E=t;F=v;break}}}else{D=c;E=g;F=b}if((E|0)<=0)return;b=h+-4|0;g=(h|0)<4;c=h&-4;q=D;D=E;E=F;while(1){c:do if(g)G=0;else{F=f[E>>2]|0;if(e)H=0;else{p=0;while(1){o=F+(p<<1)|0;m=d[o+2>>1]|0;r=d[o+4>>1]|0;l=d[o+6>>1]|0;d[q+(p<<1)>>1]=d[o>>1]|0;d[q+((p|1)<<1)>>1]=m;d[q+((p|2)<<1)>>1]=r;d[q+((p|3)<<1)>>1]=l;p=p+4|0;if((p|0)>(b|0)){G=c;break c}}}do{p=F+(H<<1)|0;l=1;r=d[p>>1]|0;m=d[p+2>>1]|0;o=d[p+4>>1]|0;n=d[p+6>>1]|0;do{p=(f[E+(l<<2)>>2]|0)+(H<<1)|0;j=d[p>>1]|0;r=(j&65535)<(r&65535)?j:r;j=d[p+2>>1]|0;m=(j&65535)<(m&65535)?j:m;j=d[p+4>>1]|0;o=(j&65535)<(o&65535)?j:o;j=d[p+6>>1]|0;n=(j&65535)<(n&65535)?j:n;l=l+1|0}while((l|0)!=(i|0));d[q+(H<<1)>>1]=r;d[q+((H|1)<<1)>>1]=m;d[q+((H|2)<<1)>>1]=o;d[q+((H|3)<<1)>>1]=n;H=H+4|0}while((H|0)<=(b|0));G=c}while(0);d:do if((G|0)<(h|0)){F=f[E>>2]|0;if(e)I=G;else{l=G;while(1){d[q+(l<<1)>>1]=d[F+(l<<1)>>1]|0;l=l+1|0;if((l|0)==(h|0))break d}}do{l=1;A=d[F+(I<<1)>>1]|0;do{j=d[(f[E+(l<<2)>>2]|0)+(I<<1)>>1]|0;A=(j&65535)<(A&65535)?j:A;l=l+1|0}while((l|0)!=(i|0));d[q+(I<<1)>>1]=A;I=I+1|0}while((I|0)!=(h|0))}while(0);if((D|0)>1){q=q+(a<<1)|0;D=D+-1|0;E=E+4|0}else break}return}function Pia(a){a=a|0;PYa(a);return}function Qia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Ria(a){a=a|0;PYa(a);return}function Sia(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;j=f[a+4>>2]|0;a=(j|0)>1;if(a&(g|0)>1){k=i+-4|0;l=(i|0)<4;m=(j|0)>2;n=e<<1;o=i&-4;p=d;q=g;r=c;while(1){if(l)s=0;else{t=r+4|0;u=0;do{v=(f[t>>2]|0)+u|0;w=b[v>>0]|0;x=b[v+1>>0]|0;y=b[v+2>>0]|0;z=b[v+3>>0]|0;if(m){v=2;A=w;B=x;C=y;D=z;while(1){E=(f[r+(v<<2)>>2]|0)+u|0;F=A&255;G=F-(h[E>>0]|0)+256|0;if(G>>>0<769)H=h[331268+G>>0]|0;else H=0;G=F-H&255;F=B&255;I=F-(h[E+1>>0]|0)+256|0;if(I>>>0<769)J=h[331268+I>>0]|0;else J=0;I=F-J&255;F=C&255;K=F-(h[E+2>>0]|0)+256|0;if(K>>>0<769)L=h[331268+K>>0]|0;else L=0;K=F-L&255;F=D&255;M=F-(h[E+3>>0]|0)+256|0;if(M>>>0<769)N=h[331268+M>>0]|0;else N=0;M=F-N&255;v=v+1|0;if((v|0)==(j|0)){O=j;P=G;Q=I;R=K;S=M;break}else{A=G;B=I;C=K;D=M}}}else{O=2;P=w;Q=x;R=y;S=z}D=(f[r>>2]|0)+u|0;C=P&255;B=C-(h[D>>0]|0)+256|0;if(B>>>0<769)T=h[331268+B>>0]|0;else T=0;b[p+u>>0]=C-T;B=Q&255;A=B-(h[D+1>>0]|0)+256|0;if(A>>>0<769)U=h[331268+A>>0]|0;else U=0;b[p+(u|1)>>0]=B-U;A=R&255;v=A-(h[D+2>>0]|0)+256|0;if(v>>>0<769)V=h[331268+v>>0]|0;else V=0;b[p+(u|2)>>0]=A-V;v=S&255;M=v-(h[D+3>>0]|0)+256|0;if(M>>>0<769)W=h[331268+M>>0]|0;else W=0;b[p+(u|3)>>0]=v-W;M=(f[r+(O<<2)>>2]|0)+u|0;D=C-(h[M>>0]|0)+256|0;if(D>>>0<769)X=h[331268+D>>0]|0;else X=0;D=u+e|0;b[p+D>>0]=C-X;C=B-(h[M+1>>0]|0)+256|0;if(C>>>0<769)Y=h[331268+C>>0]|0;else Y=0;b[p+(D+1)>>0]=B-Y;B=A-(h[M+2>>0]|0)+256|0;if(B>>>0<769)Z=h[331268+B>>0]|0;else Z=0;b[p+(D+2)>>0]=A-Z;A=v-(h[M+3>>0]|0)+256|0;if(A>>>0<769)_=h[331268+A>>0]|0;else _=0;b[p+(D+3)>>0]=v-_;u=u+4|0}while((u|0)<=(k|0));s=o}a:do if((s|0)<(i|0)){u=r+4|0;if(!m){t=r+8|0;v=s;while(1){D=h[(f[u>>2]|0)+v>>0]|0;A=D-(h[(f[r>>2]|0)+v>>0]|0)+256|0;if(A>>>0<769)$=h[331268+A>>0]|0;else $=0;b[p+v>>0]=D-$;A=D-(h[(f[t>>2]|0)+v>>0]|0)+256|0;if(A>>>0<769)aa=h[331268+A>>0]|0;else aa=0;b[p+(v+e)>>0]=D-aa;v=v+1|0;if((v|0)==(i|0))break a}}v=r+(j<<2)|0;t=s;do{z=2;y=b[(f[u>>2]|0)+t>>0]|0;while(1){x=y&255;w=x-(h[(f[r+(z<<2)>>2]|0)+t>>0]|0)+256|0;if(w>>>0<769)ba=h[331268+w>>0]|0;else ba=0;ca=x-ba|0;z=z+1|0;if((z|0)==(j|0))break;else y=ca&255}y=ca&255;z=y-(h[(f[r>>2]|0)+t>>0]|0)+256|0;if(z>>>0<769)da=h[331268+z>>0]|0;else da=0;b[p+t>>0]=ca-da;z=y-(h[(f[v>>2]|0)+t>>0]|0)+256|0;if(z>>>0<769)ea=h[331268+z>>0]|0;else ea=0;b[p+(t+e)>>0]=ca-ea;t=t+1|0}while((t|0)!=(i|0))}while(0);t=q+-2|0;v=p+n|0;u=r+8|0;if((t|0)>1){p=v;q=t;r=u}else{fa=v;ga=t;ha=u;break}}}else{fa=d;ga=g;ha=c}if((ga|0)<=0)return;c=i+-4|0;g=(i|0)<4;d=i&-4;r=fa;fa=ga;ga=ha;while(1){b:do if(g)ia=0;else{if(a)ja=0;else{ha=0;while(1){q=(f[ga>>2]|0)+ha|0;p=b[q+1>>0]|0;n=b[q+2>>0]|0;ea=b[q+3>>0]|0;b[r+ha>>0]=b[q>>0]|0;b[r+(ha|1)>>0]=p;b[r+(ha|2)>>0]=n;b[r+(ha|3)>>0]=ea;ha=ha+4|0;if((ha|0)>(c|0)){ia=d;break b}}}do{ha=(f[ga>>2]|0)+ja|0;ea=1;n=b[ha>>0]|0;p=b[ha+1>>0]|0;q=b[ha+2>>0]|0;ca=b[ha+3>>0]|0;do{ha=(f[ga+(ea<<2)>>2]|0)+ja|0;da=n&255;ba=da-(h[ha>>0]|0)+256|0;if(ba>>>0<769)ka=h[331268+ba>>0]|0;else ka=0;n=da-ka&255;da=p&255;ba=da-(h[ha+1>>0]|0)+256|0;if(ba>>>0<769)la=h[331268+ba>>0]|0;else la=0;p=da-la&255;da=q&255;ba=da-(h[ha+2>>0]|0)+256|0;if(ba>>>0<769)ma=h[331268+ba>>0]|0;else ma=0;q=da-ma&255;da=ca&255;ba=da-(h[ha+3>>0]|0)+256|0;if(ba>>>0<769)na=h[331268+ba>>0]|0;else na=0;ca=da-na&255;ea=ea+1|0}while((ea|0)!=(j|0));b[r+ja>>0]=n;b[r+(ja|1)>>0]=p;b[r+(ja|2)>>0]=q;b[r+(ja|3)>>0]=ca;ja=ja+4|0}while((ja|0)<=(c|0));ia=d}while(0);c:do if((ia|0)<(i|0)){if(a)oa=ia;else{ea=ia;while(1){b[r+ea>>0]=b[(f[ga>>2]|0)+ea>>0]|0;ea=ea+1|0;if((ea|0)==(i|0))break c}}do{ea=1;da=b[(f[ga>>2]|0)+oa>>0]|0;do{ba=da&255;ha=ba-(h[(f[ga+(ea<<2)>>2]|0)+oa>>0]|0)+256|0;if(ha>>>0<769)pa=h[331268+ha>>0]|0;else pa=0;da=ba-pa&255;ea=ea+1|0}while((ea|0)!=(j|0));b[r+oa>>0]=da;oa=oa+1|0}while((oa|0)!=(i|0))}while(0);if((fa|0)>1){r=r+e|0;fa=fa+-1|0;ga=ga+4|0}else break}return}function Tia(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+80|0;i=h;j=h+64|0;k=h+8|0;do if((NS(e)|0)==65536){l=f[e+4>>2]|0;f[k>>2]=f[l>>2];m=k+4|0;n=l+4|0;f[m>>2]=f[n>>2];o=k+8|0;f[o>>2]=f[l+8>>2];f[k+12>>2]=f[l+12>>2];f[k+16>>2]=f[l+16>>2];f[k+20>>2]=f[l+20>>2];f[k+24>>2]=f[l+24>>2];f[k+28>>2]=f[l+28>>2];f[k+32>>2]=f[l+32>>2];p=f[l+36>>2]|0;f[k+36>>2]=p;q=k+40|0;f[q>>2]=o;o=k+48|0;r=k+44|0;f[r>>2]=o;f[o>>2]=0;f[k+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[l+44>>2]|0;o=f[r>>2]|0;f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2];s=q;break}else{f[m>>2]=0;BR(k,l);s=q;break}}else{OR(k,e,-1);s=k+40|0}while(0);e=d&7;q=f[g>>2]|0;l=g+4|0;m=f[l>>2]|0;n=f[s>>2]|0;o=f[n+4>>2]|0;r=f[n>>2]|0;n=(q|0)==-1?(o|0)/2|0:q;q=(m|0)==-1?(r|0)/2|0:m;if(!((n|0)>-1&(n|0)<(o|0)?!((q|0)<0|(q|0)>=(r|0)):0)){f[j>>2]=0;f[j+4>>2]=0;t=c$(j,52)|0;v=320583;w=t+52|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));j$(-215,j,320636,320652,363);d$(j)}f[g>>2]=n;f[l>>2]=q;q=(c|0)==0;if((c|1|0)!=1){f[j>>2]=0;f[j+4>>2]=0;t=c$(j,39)|0;v=317016;w=t+39|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));j$(-215,j,320709,317079,947);d$(j)}v=(e|0)==0;a:do if(q){if(v){e=NYa(48)|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[l>>2];Uia(e,k,j);t=NYa(16)|0;w=t+4|0;f[w>>2]=1;f[t>>2]=73872;f[t+8>>2]=e;f[a>>2]=t;f[a+4>>2]=e;f[w>>2]=(f[w>>2]|0)+1;e=f[w>>2]|0;f[w>>2]=e+-1;if((e|0)!=1)break;ki[f[(f[t>>2]|0)+8>>2]&2047](t);break}switch(d&7){case 2:{t=NYa(48)|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[l>>2];Via(t,k,j);e=NYa(16)|0;w=e+4|0;f[w>>2]=1;f[e>>2]=73892;f[e+8>>2]=t;f[a>>2]=e;f[a+4>>2]=t;f[w>>2]=(f[w>>2]|0)+1;t=f[w>>2]|0;f[w>>2]=t+-1;if((t|0)!=1)break a;ki[f[(f[e>>2]|0)+8>>2]&2047](e);break a;break}case 3:{e=NYa(48)|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[l>>2];Wia(e,k,j);t=NYa(16)|0;w=t+4|0;f[w>>2]=1;f[t>>2]=73912;f[t+8>>2]=e;f[a>>2]=t;f[a+4>>2]=e;f[w>>2]=(f[w>>2]|0)+1;e=f[w>>2]|0;f[w>>2]=e+-1;if((e|0)!=1)break a;ki[f[(f[t>>2]|0)+8>>2]&2047](t);break a;break}case 5:{t=NYa(48)|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[l>>2];Xia(t,k,j);e=NYa(16)|0;w=e+4|0;f[w>>2]=1;f[e>>2]=73932;f[e+8>>2]=t;f[a>>2]=e;f[a+4>>2]=t;f[w>>2]=(f[w>>2]|0)+1;t=f[w>>2]|0;f[w>>2]=t+-1;if((t|0)!=1)break a;ki[f[(f[e>>2]|0)+8>>2]&2047](e);break a;break}case 6:{e=NYa(48)|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[l>>2];Yia(e,k,j);t=NYa(16)|0;w=t+4|0;f[w>>2]=1;f[t>>2]=73952;f[t+8>>2]=e;f[a>>2]=t;f[a+4>>2]=e;f[w>>2]=(f[w>>2]|0)+1;e=f[w>>2]|0;f[w>>2]=e+-1;if((e|0)!=1)break a;ki[f[(f[t>>2]|0)+8>>2]&2047](t);break a;break}default:{x=38;break a}}}else{if(v){t=NYa(48)|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[l>>2];Zia(t,k,j);e=NYa(16)|0;w=e+4|0;f[w>>2]=1;f[e>>2]=73972;f[e+8>>2]=t;f[a>>2]=e;f[a+4>>2]=t;f[w>>2]=(f[w>>2]|0)+1;t=f[w>>2]|0;f[w>>2]=t+-1;if((t|0)!=1)break;ki[f[(f[e>>2]|0)+8>>2]&2047](e);break}switch(d&7){case 2:{e=NYa(48)|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[l>>2];_ia(e,k,j);t=NYa(16)|0;w=t+4|0;f[w>>2]=1;f[t>>2]=73992;f[t+8>>2]=e;f[a>>2]=t;f[a+4>>2]=e;f[w>>2]=(f[w>>2]|0)+1;e=f[w>>2]|0;f[w>>2]=e+-1;if((e|0)!=1)break a;ki[f[(f[t>>2]|0)+8>>2]&2047](t);break a;break}case 3:{t=NYa(48)|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[l>>2];$ia(t,k,j);e=NYa(16)|0;w=e+4|0;f[w>>2]=1;f[e>>2]=74012;f[e+8>>2]=t;f[a>>2]=e;f[a+4>>2]=t;f[w>>2]=(f[w>>2]|0)+1;t=f[w>>2]|0;f[w>>2]=t+-1;if((t|0)!=1)break a;ki[f[(f[e>>2]|0)+8>>2]&2047](e);break a;break}case 5:{e=NYa(48)|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[l>>2];aja(e,k,j);t=NYa(16)|0;w=t+4|0;f[w>>2]=1;f[t>>2]=74032;f[t+8>>2]=e;f[a>>2]=t;f[a+4>>2]=e;f[w>>2]=(f[w>>2]|0)+1;e=f[w>>2]|0;f[w>>2]=e+-1;if((e|0)!=1)break a;ki[f[(f[t>>2]|0)+8>>2]&2047](t);break a;break}case 6:{t=NYa(48)|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[l>>2];bja(t,k,j);e=NYa(16)|0;w=e+4|0;f[w>>2]=1;f[e>>2]=74052;f[e+8>>2]=t;f[a>>2]=e;f[a+4>>2]=t;f[w>>2]=(f[w>>2]|0)+1;t=f[w>>2]|0;f[w>>2]=t+-1;if((t|0)!=1)break a;ki[f[(f[e>>2]|0)+8>>2]&2047](e);break a;break}default:{x=38;break a}}}while(0);if((x|0)==38){f[i>>2]=d;p$(j,317129,i);j$(-213,j,320709,317079,975);d$(j);f[a>>2]=0;f[a+4>>2]=0}a=k+36|0;j=f[a>>2]|0;if(j|0?(i=j+12|0,j=f[i>>2]|0,f[i>>2]=j+-1,(j|0)==1):0)CR(k);f[a>>2]=0;a=k+16|0;j=k+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[j>>2]|0)>0){a=f[s>>2]|0;s=0;do{f[a+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[j>>2]|0))}j=f[k+44>>2]|0;if((j|0)==(k+48|0)){u=h;return}ZF(j);u=h;return}function Uia(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;x9(a);f[a>>2]=74288;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=c$(g,19)|0;a=320831;d=l+19|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));j$(-215,g,320851,317079,787);d$(g)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;Fda(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else u9(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;PYa(l);u=e;return}function Via(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;x9(a);f[a>>2]=74264;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=c$(g,19)|0;a=320831;d=l+19|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));j$(-215,g,320851,317079,787);d$(g)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;Fda(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else u9(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;PYa(l);u=e;return}function Wia(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;x9(a);f[a>>2]=74240;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=c$(g,19)|0;a=320831;d=l+19|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));j$(-215,g,320851,317079,787);d$(g)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;Fda(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else u9(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;PYa(l);u=e;return}function Xia(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;x9(a);f[a>>2]=74216;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=c$(g,19)|0;a=320831;d=l+19|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));j$(-215,g,320851,317079,787);d$(g)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;Fda(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else u9(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;PYa(l);u=e;return}function Yia(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;x9(a);f[a>>2]=74192;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=c$(g,19)|0;a=320831;d=l+19|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));j$(-215,g,320851,317079,787);d$(g)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;Fda(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else u9(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;PYa(l);u=e;return}function Zia(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;x9(a);f[a>>2]=74168;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=c$(g,19)|0;a=320831;d=l+19|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));j$(-215,g,320851,317079,787);d$(g)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;Fda(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else u9(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;PYa(l);u=e;return}function _ia(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;x9(a);f[a>>2]=74144;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=c$(g,19)|0;a=320831;d=l+19|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));j$(-215,g,320851,317079,787);d$(g)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;Fda(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else u9(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;PYa(l);u=e;return}function $ia(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;x9(a);f[a>>2]=74120;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=c$(g,19)|0;a=320831;d=l+19|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));j$(-215,g,320851,317079,787);d$(g)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;Fda(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else u9(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;PYa(l);u=e;return}function aja(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;x9(a);f[a>>2]=74096;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=c$(g,19)|0;a=320831;d=l+19|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));j$(-215,g,320851,317079,787);d$(g)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;Fda(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else u9(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;PYa(l);u=e;return}function bja(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;x9(a);f[a>>2]=74072;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=c$(g,19)|0;a=320831;d=l+19|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));j$(-215,g,320851,317079,787);d$(g)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;Fda(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else u9(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;PYa(l);u=e;return}function cja(a){a=a|0;PYa(a);return}function dja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function eja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=74072;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function fja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=74072;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function gja(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0;i=f[a+20>>2]|0;j=f[a+32>>2]|0;k=(f[a+24>>2]|0)-i|0;a=k>>3;l=Y(h,g)|0;if((e|0)<=0)return;g=(k|0)>0;m=l+-4|0;n=(l|0)<4;o=(k|0)>8;k=l&-4;q=e;e=c;c=b;while(1){if(g){b=0;do{r=(f[c+(f[i+(b<<3)+4>>2]<<2)>>2]|0)+((Y(f[i+(b<<3)>>2]|0,h)|0)<<3)|0;f[j+(b<<2)>>2]=r;b=b+1|0}while((b|0)<(a|0))}a:do if(n)s=0;else{b=f[j>>2]|0;if(o)t=0;else{r=0;while(1){u=b+(r<<3)|0;v=+p[u+8>>3];w=+p[u+16>>3];x=+p[u+24>>3];p[e+(r<<3)>>3]=+p[u>>3];p[e+((r|1)<<3)>>3]=v;p[e+((r|2)<<3)>>3]=w;p[e+((r|3)<<3)>>3]=x;r=r+4|0;if((r|0)>(m|0)){s=k;break a}}}do{r=b+(t<<3)|0;u=1;x=+p[r>>3];w=+p[r+8>>3];v=+p[r+16>>3];y=+p[r+24>>3];do{r=(f[j+(u<<2)>>2]|0)+(t<<3)|0;z=+p[r>>3];x=x<z?z:x;z=+p[r+8>>3];w=w<z?z:w;z=+p[r+16>>3];v=v<z?z:v;z=+p[r+24>>3];y=y<z?z:y;u=u+1|0}while((u|0)<(a|0));p[e+(t<<3)>>3]=x;p[e+((t|1)<<3)>>3]=w;p[e+((t|2)<<3)>>3]=v;p[e+((t|3)<<3)>>3]=y;t=t+4|0}while((t|0)<=(m|0));s=k}while(0);b:do if((s|0)<(l|0)){b=f[j>>2]|0;if(o)A=s;else{u=s;while(1){p[e+(u<<3)>>3]=+p[b+(u<<3)>>3];u=u+1|0;if((u|0)==(l|0))break b}}do{u=1;z=+p[b+(A<<3)>>3];do{B=+p[(f[j+(u<<2)>>2]|0)+(A<<3)>>3];z=z<B?B:z;u=u+1|0}while((u|0)<(a|0));p[e+(A<<3)>>3]=z;A=A+1|0}while((A|0)!=(l|0))}while(0);if((q|0)>1){q=q+-1|0;e=e+d|0;c=c+4|0}else break}return}function hja(a){a=a|0;PYa(a);return}function ija(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function jja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=74096;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function kja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=74096;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function lja(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0;i=f[a+20>>2]|0;j=f[a+32>>2]|0;k=(f[a+24>>2]|0)-i|0;a=k>>3;l=Y(h,g)|0;if((e|0)<=0)return;g=(k|0)>0;m=l+-4|0;o=(l|0)<4;p=(k|0)>8;k=l&-4;q=e;e=c;c=b;while(1){if(g){b=0;do{r=(f[c+(f[i+(b<<3)+4>>2]<<2)>>2]|0)+((Y(f[i+(b<<3)>>2]|0,h)|0)<<2)|0;f[j+(b<<2)>>2]=r;b=b+1|0}while((b|0)<(a|0))}a:do if(o)s=0;else{b=f[j>>2]|0;if(p)t=0;else{r=0;while(1){u=b+(r<<2)|0;v=f[u+4>>2]|0;w=f[u+8>>2]|0;x=f[u+12>>2]|0;f[e+(r<<2)>>2]=f[u>>2];f[e+((r|1)<<2)>>2]=v;f[e+((r|2)<<2)>>2]=w;f[e+((r|3)<<2)>>2]=x;r=r+4|0;if((r|0)>(m|0)){s=k;break a}}}do{r=b+(t<<2)|0;x=1;y=+n[r>>2];z=+n[r+4>>2];A=+n[r+8>>2];B=+n[r+12>>2];do{r=(f[j+(x<<2)>>2]|0)+(t<<2)|0;C=+n[r>>2];y=y<C?C:y;C=+n[r+4>>2];z=z<C?C:z;C=+n[r+8>>2];A=A<C?C:A;C=+n[r+12>>2];B=B<C?C:B;x=x+1|0}while((x|0)<(a|0));n[e+(t<<2)>>2]=y;n[e+((t|1)<<2)>>2]=z;n[e+((t|2)<<2)>>2]=A;n[e+((t|3)<<2)>>2]=B;t=t+4|0}while((t|0)<=(m|0));s=k}while(0);b:do if((s|0)<(l|0)){b=f[j>>2]|0;if(p)D=s;else{x=s;while(1){f[e+(x<<2)>>2]=f[b+(x<<2)>>2];x=x+1|0;if((x|0)==(l|0))break b}}do{x=1;C=+n[b+(D<<2)>>2];do{E=+n[(f[j+(x<<2)>>2]|0)+(D<<2)>>2];C=C<E?E:C;x=x+1|0}while((x|0)<(a|0));n[e+(D<<2)>>2]=C;D=D+1|0}while((D|0)!=(l|0))}while(0);if((q|0)>1){q=q+-1|0;e=e+d|0;c=c+4|0}else break}return}function mja(a){a=a|0;PYa(a);return}function nja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function oja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=74120;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function pja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=74120;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function qja(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=(f[a+24>>2]|0)-j|0;a=l>>3;m=Y(i,h)|0;if((g|0)<=0)return;h=(l|0)>0;n=m+-4|0;o=(m|0)<4;p=(l|0)>8;l=m&-4;q=g;g=c;c=b;while(1){if(h){b=0;do{r=(f[c+(f[j+(b<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(b<<3)>>2]|0,i)|0)<<1)|0;f[k+(b<<2)>>2]=r;b=b+1|0}while((b|0)<(a|0))}a:do if(o)s=0;else{b=f[k>>2]|0;if(p)t=0;else{r=0;while(1){u=b+(r<<1)|0;v=d[u+2>>1]|0;w=d[u+4>>1]|0;x=d[u+6>>1]|0;d[g+(r<<1)>>1]=d[u>>1]|0;d[g+((r|1)<<1)>>1]=v;d[g+((r|2)<<1)>>1]=w;d[g+((r|3)<<1)>>1]=x;r=r+4|0;if((r|0)>(n|0)){s=l;break a}}}do{r=b+(t<<1)|0;x=1;w=d[r>>1]|0;v=d[r+2>>1]|0;u=d[r+4>>1]|0;y=d[r+6>>1]|0;do{r=(f[k+(x<<2)>>2]|0)+(t<<1)|0;z=d[r>>1]|0;w=w<<16>>16<z<<16>>16?z:w;z=d[r+2>>1]|0;v=v<<16>>16<z<<16>>16?z:v;z=d[r+4>>1]|0;u=u<<16>>16<z<<16>>16?z:u;z=d[r+6>>1]|0;y=y<<16>>16<z<<16>>16?z:y;x=x+1|0}while((x|0)<(a|0));d[g+(t<<1)>>1]=w;d[g+((t|1)<<1)>>1]=v;d[g+((t|2)<<1)>>1]=u;d[g+((t|3)<<1)>>1]=y;t=t+4|0}while((t|0)<=(n|0));s=l}while(0);b:do if((s|0)<(m|0)){b=f[k>>2]|0;if(p)A=s;else{x=s;while(1){d[g+(x<<1)>>1]=d[b+(x<<1)>>1]|0;x=x+1|0;if((x|0)==(m|0))break b}}do{x=1;z=d[b+(A<<1)>>1]|0;do{r=d[(f[k+(x<<2)>>2]|0)+(A<<1)>>1]|0;z=z<<16>>16<r<<16>>16?r:z;x=x+1|0}while((x|0)<(a|0));d[g+(A<<1)>>1]=z;A=A+1|0}while((A|0)!=(m|0))}while(0);if((q|0)>1){q=q+-1|0;g=g+e|0;c=c+4|0}else break}return}function rja(a){a=a|0;PYa(a);return}function sja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function tja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=74144;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function uja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=74144;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function vja(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=(f[a+24>>2]|0)-j|0;a=l>>3;m=Y(i,h)|0;if((g|0)<=0)return;h=(l|0)>0;n=m+-4|0;o=(m|0)<4;p=(l|0)>8;l=m&-4;q=g;g=c;c=b;while(1){if(h){b=0;do{r=(f[c+(f[j+(b<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(b<<3)>>2]|0,i)|0)<<1)|0;f[k+(b<<2)>>2]=r;b=b+1|0}while((b|0)<(a|0))}a:do if(o)s=0;else{b=f[k>>2]|0;if(p)t=0;else{r=0;while(1){u=b+(r<<1)|0;v=d[u+2>>1]|0;w=d[u+4>>1]|0;x=d[u+6>>1]|0;d[g+(r<<1)>>1]=d[u>>1]|0;d[g+((r|1)<<1)>>1]=v;d[g+((r|2)<<1)>>1]=w;d[g+((r|3)<<1)>>1]=x;r=r+4|0;if((r|0)>(n|0)){s=l;break a}}}do{r=b+(t<<1)|0;x=1;w=d[r>>1]|0;v=d[r+2>>1]|0;u=d[r+4>>1]|0;y=d[r+6>>1]|0;do{r=(f[k+(x<<2)>>2]|0)+(t<<1)|0;z=d[r>>1]|0;w=(w&65535)<(z&65535)?z:w;z=d[r+2>>1]|0;v=(v&65535)<(z&65535)?z:v;z=d[r+4>>1]|0;u=(u&65535)<(z&65535)?z:u;z=d[r+6>>1]|0;y=(y&65535)<(z&65535)?z:y;x=x+1|0}while((x|0)<(a|0));d[g+(t<<1)>>1]=w;d[g+((t|1)<<1)>>1]=v;d[g+((t|2)<<1)>>1]=u;d[g+((t|3)<<1)>>1]=y;t=t+4|0}while((t|0)<=(n|0));s=l}while(0);b:do if((s|0)<(m|0)){b=f[k>>2]|0;if(p)A=s;else{x=s;while(1){d[g+(x<<1)>>1]=d[b+(x<<1)>>1]|0;x=x+1|0;if((x|0)==(m|0))break b}}do{x=1;z=d[b+(A<<1)>>1]|0;do{r=d[(f[k+(x<<2)>>2]|0)+(A<<1)>>1]|0;z=(z&65535)<(r&65535)?r:z;x=x+1|0}while((x|0)<(a|0));d[g+(A<<1)>>1]=z;A=A+1|0}while((A|0)!=(m|0))}while(0);if((q|0)>1){q=q+-1|0;g=g+e|0;c=c+4|0}else break}return}function wja(a){a=a|0;PYa(a);return}function xja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function yja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=74168;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function zja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=74168;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function Aja(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=(f[a+24>>2]|0)-k|0;a=m>>3;n=Y(j,i)|0;if((g|0)<=0)return;i=(m|0)>0;o=n+-4|0;p=(n|0)<4;q=(m|0)>8;m=n&-4;r=g;g=d;d=c;while(1){if(i){c=0;do{s=(f[d+(f[k+(c<<3)+4>>2]<<2)>>2]|0)+(Y(f[k+(c<<3)>>2]|0,j)|0)|0;f[l+(c<<2)>>2]=s;c=c+1|0}while((c|0)<(a|0))}a:do if(p)t=0;else{if(q)u=0;else{c=0;while(1){s=(f[l>>2]|0)+c|0;v=b[s+1>>0]|0;w=b[s+2>>0]|0;x=b[s+3>>0]|0;b[g+c>>0]=b[s>>0]|0;b[g+(c|1)>>0]=v;b[g+(c|2)>>0]=w;b[g+(c|3)>>0]=x;c=c+4|0;if((c|0)>(o|0)){t=m;break a}}}do{c=(f[l>>2]|0)+u|0;x=1;w=b[c>>0]|0;v=b[c+1>>0]|0;s=b[c+2>>0]|0;y=b[c+3>>0]|0;do{c=(f[l+(x<<2)>>2]|0)+u|0;z=w&255;A=(h[c>>0]|0)-z+256|0;if(A>>>0<769)B=h[331268+A>>0]|0;else B=0;w=B+z&255;z=v&255;A=(h[c+1>>0]|0)-z+256|0;if(A>>>0<769)C=h[331268+A>>0]|0;else C=0;v=C+z&255;z=s&255;A=(h[c+2>>0]|0)-z+256|0;if(A>>>0<769)D=h[331268+A>>0]|0;else D=0;s=D+z&255;z=y&255;A=(h[c+3>>0]|0)-z+256|0;if(A>>>0<769)E=h[331268+A>>0]|0;else E=0;y=E+z&255;x=x+1|0}while((x|0)<(a|0));b[g+u>>0]=w;b[g+(u|1)>>0]=v;b[g+(u|2)>>0]=s;b[g+(u|3)>>0]=y;u=u+4|0}while((u|0)<=(o|0));t=m}while(0);b:do if((t|0)<(n|0)){if(q)F=t;else{x=t;while(1){b[g+x>>0]=b[(f[l>>2]|0)+x>>0]|0;x=x+1|0;if((x|0)==(n|0))break b}}do{x=1;z=b[(f[l>>2]|0)+F>>0]|0;do{A=z&255;c=(h[(f[l+(x<<2)>>2]|0)+F>>0]|0)-A+256|0;if(c>>>0<769)G=h[331268+c>>0]|0;else G=0;z=G+A&255;x=x+1|0}while((x|0)<(a|0));b[g+F>>0]=z;F=F+1|0}while((F|0)!=(n|0))}while(0);if((r|0)>1){r=r+-1|0;g=g+e|0;d=d+4|0}else break}return}function Bja(a){a=a|0;PYa(a);return}function Cja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Dja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=74192;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function Eja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=74192;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function Fja(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0;i=f[a+20>>2]|0;j=f[a+32>>2]|0;k=(f[a+24>>2]|0)-i|0;a=k>>3;l=Y(h,g)|0;if((e|0)<=0)return;g=(k|0)>0;m=l+-4|0;n=(l|0)<4;o=(k|0)>8;k=l&-4;q=e;e=c;c=b;while(1){if(g){b=0;do{r=(f[c+(f[i+(b<<3)+4>>2]<<2)>>2]|0)+((Y(f[i+(b<<3)>>2]|0,h)|0)<<3)|0;f[j+(b<<2)>>2]=r;b=b+1|0}while((b|0)<(a|0))}a:do if(n)s=0;else{b=f[j>>2]|0;if(o)t=0;else{r=0;while(1){u=b+(r<<3)|0;v=+p[u+8>>3];w=+p[u+16>>3];x=+p[u+24>>3];p[e+(r<<3)>>3]=+p[u>>3];p[e+((r|1)<<3)>>3]=v;p[e+((r|2)<<3)>>3]=w;p[e+((r|3)<<3)>>3]=x;r=r+4|0;if((r|0)>(m|0)){s=k;break a}}}do{r=b+(t<<3)|0;u=1;x=+p[r>>3];w=+p[r+8>>3];v=+p[r+16>>3];y=+p[r+24>>3];do{r=(f[j+(u<<2)>>2]|0)+(t<<3)|0;z=+p[r>>3];x=z<x?z:x;z=+p[r+8>>3];w=z<w?z:w;z=+p[r+16>>3];v=z<v?z:v;z=+p[r+24>>3];y=z<y?z:y;u=u+1|0}while((u|0)<(a|0));p[e+(t<<3)>>3]=x;p[e+((t|1)<<3)>>3]=w;p[e+((t|2)<<3)>>3]=v;p[e+((t|3)<<3)>>3]=y;t=t+4|0}while((t|0)<=(m|0));s=k}while(0);b:do if((s|0)<(l|0)){b=f[j>>2]|0;if(o)A=s;else{u=s;while(1){p[e+(u<<3)>>3]=+p[b+(u<<3)>>3];u=u+1|0;if((u|0)==(l|0))break b}}do{u=1;z=+p[b+(A<<3)>>3];do{B=+p[(f[j+(u<<2)>>2]|0)+(A<<3)>>3];z=B<z?B:z;u=u+1|0}while((u|0)<(a|0));p[e+(A<<3)>>3]=z;A=A+1|0}while((A|0)!=(l|0))}while(0);if((q|0)>1){q=q+-1|0;e=e+d|0;c=c+4|0}else break}return}function Gja(a){a=a|0;PYa(a);return}function Hja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Ija(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=74216;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function Jja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=74216;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function Kja(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0;i=f[a+20>>2]|0;j=f[a+32>>2]|0;k=(f[a+24>>2]|0)-i|0;a=k>>3;l=Y(h,g)|0;if((e|0)<=0)return;g=(k|0)>0;m=l+-4|0;o=(l|0)<4;p=(k|0)>8;k=l&-4;q=e;e=c;c=b;while(1){if(g){b=0;do{r=(f[c+(f[i+(b<<3)+4>>2]<<2)>>2]|0)+((Y(f[i+(b<<3)>>2]|0,h)|0)<<2)|0;f[j+(b<<2)>>2]=r;b=b+1|0}while((b|0)<(a|0))}a:do if(o)s=0;else{b=f[j>>2]|0;if(p)t=0;else{r=0;while(1){u=b+(r<<2)|0;v=f[u+4>>2]|0;w=f[u+8>>2]|0;x=f[u+12>>2]|0;f[e+(r<<2)>>2]=f[u>>2];f[e+((r|1)<<2)>>2]=v;f[e+((r|2)<<2)>>2]=w;f[e+((r|3)<<2)>>2]=x;r=r+4|0;if((r|0)>(m|0)){s=k;break a}}}do{r=b+(t<<2)|0;x=1;y=+n[r>>2];z=+n[r+4>>2];A=+n[r+8>>2];B=+n[r+12>>2];do{r=(f[j+(x<<2)>>2]|0)+(t<<2)|0;C=+n[r>>2];y=C<y?C:y;C=+n[r+4>>2];z=C<z?C:z;C=+n[r+8>>2];A=C<A?C:A;C=+n[r+12>>2];B=C<B?C:B;x=x+1|0}while((x|0)<(a|0));n[e+(t<<2)>>2]=y;n[e+((t|1)<<2)>>2]=z;n[e+((t|2)<<2)>>2]=A;n[e+((t|3)<<2)>>2]=B;t=t+4|0}while((t|0)<=(m|0));s=k}while(0);b:do if((s|0)<(l|0)){b=f[j>>2]|0;if(p)D=s;else{x=s;while(1){f[e+(x<<2)>>2]=f[b+(x<<2)>>2];x=x+1|0;if((x|0)==(l|0))break b}}do{x=1;C=+n[b+(D<<2)>>2];do{E=+n[(f[j+(x<<2)>>2]|0)+(D<<2)>>2];C=E<C?E:C;x=x+1|0}while((x|0)<(a|0));n[e+(D<<2)>>2]=C;D=D+1|0}while((D|0)!=(l|0))}while(0);if((q|0)>1){q=q+-1|0;e=e+d|0;c=c+4|0}else break}return}function Lja(a){a=a|0;PYa(a);return}function Mja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Nja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=74240;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function Oja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=74240;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function Pja(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=(f[a+24>>2]|0)-j|0;a=l>>3;m=Y(i,h)|0;if((g|0)<=0)return;h=(l|0)>0;n=m+-4|0;o=(m|0)<4;p=(l|0)>8;l=m&-4;q=g;g=c;c=b;while(1){if(h){b=0;do{r=(f[c+(f[j+(b<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(b<<3)>>2]|0,i)|0)<<1)|0;f[k+(b<<2)>>2]=r;b=b+1|0}while((b|0)<(a|0))}a:do if(o)s=0;else{b=f[k>>2]|0;if(p)t=0;else{r=0;while(1){u=b+(r<<1)|0;v=d[u+2>>1]|0;w=d[u+4>>1]|0;x=d[u+6>>1]|0;d[g+(r<<1)>>1]=d[u>>1]|0;d[g+((r|1)<<1)>>1]=v;d[g+((r|2)<<1)>>1]=w;d[g+((r|3)<<1)>>1]=x;r=r+4|0;if((r|0)>(n|0)){s=l;break a}}}do{r=b+(t<<1)|0;x=1;w=d[r>>1]|0;v=d[r+2>>1]|0;u=d[r+4>>1]|0;y=d[r+6>>1]|0;do{r=(f[k+(x<<2)>>2]|0)+(t<<1)|0;z=d[r>>1]|0;w=z<<16>>16<w<<16>>16?z:w;z=d[r+2>>1]|0;v=z<<16>>16<v<<16>>16?z:v;z=d[r+4>>1]|0;u=z<<16>>16<u<<16>>16?z:u;z=d[r+6>>1]|0;y=z<<16>>16<y<<16>>16?z:y;x=x+1|0}while((x|0)<(a|0));d[g+(t<<1)>>1]=w;d[g+((t|1)<<1)>>1]=v;d[g+((t|2)<<1)>>1]=u;d[g+((t|3)<<1)>>1]=y;t=t+4|0}while((t|0)<=(n|0));s=l}while(0);b:do if((s|0)<(m|0)){b=f[k>>2]|0;if(p)A=s;else{x=s;while(1){d[g+(x<<1)>>1]=d[b+(x<<1)>>1]|0;x=x+1|0;if((x|0)==(m|0))break b}}do{x=1;z=d[b+(A<<1)>>1]|0;do{r=d[(f[k+(x<<2)>>2]|0)+(A<<1)>>1]|0;z=r<<16>>16<z<<16>>16?r:z;x=x+1|0}while((x|0)<(a|0));d[g+(A<<1)>>1]=z;A=A+1|0}while((A|0)!=(m|0))}while(0);if((q|0)>1){q=q+-1|0;g=g+e|0;c=c+4|0}else break}return}function Qja(a){a=a|0;PYa(a);return}function Rja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Sja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=74264;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function Tja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=74264;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function Uja(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=(f[a+24>>2]|0)-j|0;a=l>>3;m=Y(i,h)|0;if((g|0)<=0)return;h=(l|0)>0;n=m+-4|0;o=(m|0)<4;p=(l|0)>8;l=m&-4;q=g;g=c;c=b;while(1){if(h){b=0;do{r=(f[c+(f[j+(b<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(b<<3)>>2]|0,i)|0)<<1)|0;f[k+(b<<2)>>2]=r;b=b+1|0}while((b|0)<(a|0))}a:do if(o)s=0;else{b=f[k>>2]|0;if(p)t=0;else{r=0;while(1){u=b+(r<<1)|0;v=d[u+2>>1]|0;w=d[u+4>>1]|0;x=d[u+6>>1]|0;d[g+(r<<1)>>1]=d[u>>1]|0;d[g+((r|1)<<1)>>1]=v;d[g+((r|2)<<1)>>1]=w;d[g+((r|3)<<1)>>1]=x;r=r+4|0;if((r|0)>(n|0)){s=l;break a}}}do{r=b+(t<<1)|0;x=1;w=d[r>>1]|0;v=d[r+2>>1]|0;u=d[r+4>>1]|0;y=d[r+6>>1]|0;do{r=(f[k+(x<<2)>>2]|0)+(t<<1)|0;z=d[r>>1]|0;w=(z&65535)<(w&65535)?z:w;z=d[r+2>>1]|0;v=(z&65535)<(v&65535)?z:v;z=d[r+4>>1]|0;u=(z&65535)<(u&65535)?z:u;z=d[r+6>>1]|0;y=(z&65535)<(y&65535)?z:y;x=x+1|0}while((x|0)<(a|0));d[g+(t<<1)>>1]=w;d[g+((t|1)<<1)>>1]=v;d[g+((t|2)<<1)>>1]=u;d[g+((t|3)<<1)>>1]=y;t=t+4|0}while((t|0)<=(n|0));s=l}while(0);b:do if((s|0)<(m|0)){b=f[k>>2]|0;if(p)A=s;else{x=s;while(1){d[g+(x<<1)>>1]=d[b+(x<<1)>>1]|0;x=x+1|0;if((x|0)==(m|0))break b}}do{x=1;z=d[b+(A<<1)>>1]|0;do{r=d[(f[k+(x<<2)>>2]|0)+(A<<1)>>1]|0;z=(r&65535)<(z&65535)?r:z;x=x+1|0}while((x|0)<(a|0));d[g+(A<<1)>>1]=z;A=A+1|0}while((A|0)!=(m|0))}while(0);if((q|0)>1){q=q+-1|0;g=g+e|0;c=c+4|0}else break}return}function Vja(a){a=a|0;PYa(a);return}function Wja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Xja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=74288;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function Yja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=74288;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function Zja(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=(f[a+24>>2]|0)-k|0;a=m>>3;n=Y(j,i)|0;if((g|0)<=0)return;i=(m|0)>0;o=n+-4|0;p=(n|0)<4;q=(m|0)>8;m=n&-4;r=g;g=d;d=c;while(1){if(i){c=0;do{s=(f[d+(f[k+(c<<3)+4>>2]<<2)>>2]|0)+(Y(f[k+(c<<3)>>2]|0,j)|0)|0;f[l+(c<<2)>>2]=s;c=c+1|0}while((c|0)<(a|0))}a:do if(p)t=0;else{if(q)u=0;else{c=0;while(1){s=(f[l>>2]|0)+c|0;v=b[s+1>>0]|0;w=b[s+2>>0]|0;x=b[s+3>>0]|0;b[g+c>>0]=b[s>>0]|0;b[g+(c|1)>>0]=v;b[g+(c|2)>>0]=w;b[g+(c|3)>>0]=x;c=c+4|0;if((c|0)>(o|0)){t=m;break a}}}do{c=(f[l>>2]|0)+u|0;x=1;w=b[c>>0]|0;v=b[c+1>>0]|0;s=b[c+2>>0]|0;y=b[c+3>>0]|0;do{c=(f[l+(x<<2)>>2]|0)+u|0;z=w&255;A=z-(h[c>>0]|0)+256|0;if(A>>>0<769)B=h[331268+A>>0]|0;else B=0;w=z-B&255;z=v&255;A=z-(h[c+1>>0]|0)+256|0;if(A>>>0<769)C=h[331268+A>>0]|0;else C=0;v=z-C&255;z=s&255;A=z-(h[c+2>>0]|0)+256|0;if(A>>>0<769)D=h[331268+A>>0]|0;else D=0;s=z-D&255;z=y&255;A=z-(h[c+3>>0]|0)+256|0;if(A>>>0<769)E=h[331268+A>>0]|0;else E=0;y=z-E&255;x=x+1|0}while((x|0)<(a|0));b[g+u>>0]=w;b[g+(u|1)>>0]=v;b[g+(u|2)>>0]=s;b[g+(u|3)>>0]=y;u=u+4|0}while((u|0)<=(o|0));t=m}while(0);b:do if((t|0)<(n|0)){if(q)F=t;else{x=t;while(1){b[g+x>>0]=b[(f[l>>2]|0)+x>>0]|0;x=x+1|0;if((x|0)==(n|0))break b}}do{x=1;z=b[(f[l>>2]|0)+F>>0]|0;do{A=z&255;c=A-(h[(f[l+(x<<2)>>2]|0)+F>>0]|0)+256|0;if(c>>>0<769)G=h[331268+c>>0]|0;else G=0;z=A-G&255;x=x+1|0}while((x|0)<(a|0));b[g+F>>0]=z;F=F+1|0}while((F|0)!=(n|0))}while(0);if((r|0)>1){r=r+-1|0;g=g+e|0;d=d+4|0}else break}return}function _ja(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;k=u;u=u+144|0;l=k+128|0;m=k+72|0;n=k+64|0;o=k+56|0;q=k;r=k+32|0;s=k+48|0;do if((NS(e)|0)==65536){t=f[e+4>>2]|0;f[m>>2]=f[t>>2];v=m+4|0;w=t+4|0;f[v>>2]=f[w>>2];x=m+8|0;f[x>>2]=f[t+8>>2];f[m+12>>2]=f[t+12>>2];f[m+16>>2]=f[t+16>>2];f[m+20>>2]=f[t+20>>2];f[m+24>>2]=f[t+24>>2];f[m+28>>2]=f[t+28>>2];f[m+32>>2]=f[t+32>>2];y=f[t+36>>2]|0;f[m+36>>2]=y;z=m+40|0;f[z>>2]=x;x=m+48|0;A=m+44|0;f[A>>2]=x;f[x>>2]=0;f[m+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;x=f[A>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];B=z;break}else{f[v>>2]=0;BR(m,t);B=z;break}}else{OR(m,e,-1);B=m+40|0}while(0);e=f[g>>2]|0;z=g+4|0;t=f[z>>2]|0;v=f[B>>2]|0;w=f[v+4>>2]|0;x=f[v>>2]|0;v=(e|0)==-1?(w|0)/2|0:e;e=(t|0)==-1?(x|0)/2|0:t;if(!((v|0)>-1&(v|0)<(w|0)?!((e|0)<0|(e|0)>=(x|0)):0)){f[l>>2]=0;f[l+4>>2]=0;C=c$(l,52)|0;D=320583;E=C+52|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));j$(-215,l,320636,320652,363);d$(l)}f[g>>2]=v;f[z>>2]=e;f[l>>2]=0;e=l+4|0;f[e>>2]=0;f[n>>2]=0;v=n+4|0;f[v>>2]=0;f[o>>2]=0;x=o+4|0;f[x>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=m;w=bZ(q)|0;t=m+8|0;A=f[m+12>>2]|0;if((w|0)==(Y(A,f[t>>2]|0)|0)){rha(q,c,d,A,f[g>>2]|0);A=f[q>>2]|0;w=f[q+4>>2]|0;if(A|0){y=A+4|0;f[y>>2]=(f[y>>2]|0)+1}y=f[l>>2]|0;f[l>>2]=A;f[e>>2]=w;if(y|0?(w=y+4|0,e=f[w>>2]|0,f[w>>2]=e+-1,(e|0)==1):0)ki[f[(f[y>>2]|0)+8>>2]&2047](y);y=f[q>>2]|0;if(y|0?(e=y+4|0,w=f[e>>2]|0,f[e>>2]=w+-1,(w|0)==1):0)ki[f[(f[y>>2]|0)+8>>2]&2047](y);eia(q,c,d,f[t>>2]|0,f[z>>2]|0);t=f[q>>2]|0;y=f[q+4>>2]|0;if(t|0){w=t+4|0;f[w>>2]=(f[w>>2]|0)+1}w=f[n>>2]|0;f[n>>2]=t;f[v>>2]=y;if(w|0?(y=w+4|0,v=f[y>>2]|0,f[y>>2]=v+-1,(v|0)==1):0)ki[f[(f[w>>2]|0)+8>>2]&2047](w);w=f[q>>2]|0;if(w|0?(v=w+4|0,y=f[v>>2]|0,f[v>>2]=y+-1,(y|0)==1):0)ki[f[(f[w>>2]|0)+8>>2]&2047](w)}else{f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=m;f[s>>2]=f[g>>2];f[s+4>>2]=f[z>>2];Tia(q,c,d,r,s);s=f[q>>2]|0;z=f[q+4>>2]|0;if(s|0){g=s+4|0;f[g>>2]=(f[g>>2]|0)+1}g=f[o>>2]|0;f[o>>2]=s;f[x>>2]=z;if(g|0?(z=g+4|0,x=f[z>>2]|0,f[z>>2]=x+-1,(x|0)==1):0)ki[f[(f[g>>2]|0)+8>>2]&2047](g);g=f[q>>2]|0;if(g|0?(x=g+4|0,z=f[x>>2]|0,f[x>>2]=z+-1,(z|0)==1):0)ki[f[(f[g>>2]|0)+8>>2]&2047](g)}F=+p[j>>3];p[q>>3]=F;G=+p[j+8>>3];g=q+8|0;p[g>>3]=G;H=+p[j+16>>3];z=q+16|0;p[z>>3]=H;I=+p[j+24>>3];j=q+24|0;p[j>>3]=I;do if(((h|0)==0|(i|0)==0)&F==1797693134862315708145274.0e284&G==1797693134862315708145274.0e284?!(I!=1797693134862315708145274.0e284|H!=1797693134862315708145274.0e284):0){x=d&7;s=(x|2|0)==2;w=(x|0)==3;y=(x|0)==5;x=d&255;switch(x&7){case 0:case 2:case 3:case 5:case 6:break;default:{f[r>>2]=0;f[r+4>>2]=0;C=c$(r,66)|0;D=322281;E=C+66|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));j$(-215,r,322348,317079,1006);d$(r)}}if(c|0){J=s?0.0:w?-32768.0:y?-3402823466385288598117041.0e14:-1797693134862315708145274.0e284;p[q>>3]=J;p[g>>3]=J;p[z>>3]=J;p[j>>3]=J;break}switch(x&7){case 0:{K=255.0;break}case 2:{K=65535.0;break}default:K=w?32767.0:y?3402823466385288598117041.0e14:1797693134862315708145274.0e284}p[q>>3]=K;p[g>>3]=K;p[z>>3]=K;p[j>>3]=K}while(0);j=NYa(200)|0;y9(j,o,l,n,d,d,d,h,i,q);q=NYa(16)|0;f[q+4>>2]=1;f[q>>2]=58548;f[q+8>>2]=j;f[a>>2]=q;f[a+4>>2]=j;j=f[o>>2]|0;if(j|0?(o=j+4|0,a=f[o>>2]|0,f[o>>2]=a+-1,(a|0)==1):0)ki[f[(f[j>>2]|0)+8>>2]&2047](j);j=f[n>>2]|0;if(j|0?(n=j+4|0,a=f[n>>2]|0,f[n>>2]=a+-1,(a|0)==1):0)ki[f[(f[j>>2]|0)+8>>2]&2047](j);j=f[l>>2]|0;if(j|0?(l=j+4|0,a=f[l>>2]|0,f[l>>2]=a+-1,(a|0)==1):0)ki[f[(f[j>>2]|0)+8>>2]&2047](j);j=m+36|0;a=f[j>>2]|0;if(a|0?(l=a+12|0,a=f[l>>2]|0,f[l>>2]=a+-1,(a|0)==1):0)CR(m);f[j>>2]=0;j=m+16|0;a=m+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[a>>2]|0)>0){j=f[B>>2]|0;B=0;do{f[j+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[a>>2]|0))}a=f[m+44>>2]|0;if((a|0)==(m+48|0)){u=k;return}ZF(a);u=k;return}function $ja(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;g=u;u=u+16|0;h=g;if(c>>>0>=3){f[h>>2]=0;f[h+4>>2]=0;i=c$(h,69)|0;j=322371;k=i+69|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-215,h,322441,317079,1030);d$(h)}l=f[e>>2]|0;m=e+4|0;n=f[m>>2]|0;o=f[d>>2]|0;p=d+4|0;q=f[p>>2]|0;r=(l|0)==-1?(o|0)/2|0:l;l=(n|0)==-1?(q|0)/2|0:n;if((r|0)>-1&(r|0)<(o|0)?!((l|0)<0|(l|0)>=(q|0)):0)s=o;else{f[h>>2]=0;f[h+4>>2]=0;i=c$(h,52)|0;j=320583;k=i+52|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-215,h,320636,320652,363);d$(h);s=f[d>>2]|0}f[e>>2]=r;f[m>>2]=l;l=f[p>>2]|0;r=(s|0)==1&(l|0)==1?0:c;if((r|0)==2){c=(l|0)/2|0;t=+(c|0);v=(s|0)/2|0;w=(l+1|0)>>>0>2?1.0/(t*t):0.0;x=c}else{v=0;w=0.0;x=0}f[a>>2]=1124007936;c=a+8|0;j=a+40|0;i=a+4|0;k=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(k|0));f[j>>2]=c;c=a+48|0;j=a+44|0;f[j>>2]=c;f[c>>2]=0;f[a+52>>2]=0;f[h>>2]=l;f[h+4>>2]=s;AR(a,2,h,0);if((f[p>>2]|0)<=0){u=g;return}h=a+16|0;t=+(v|0);a=Y(x,x)|0;if(!r){s=f[d>>2]|0;l=0;while(1){c=(f[h>>2]|0)+(Y(f[f[j>>2]>>2]|0,l)|0)|0;if((s|0)>0){F1a(c|0,1,s|0)|0;y=f[d>>2]|0;z=s}else{y=s;z=0}if((z|0)<(y|0)){i=z;do{b[c+i>>0]=0;i=i+1|0;k=f[d>>2]|0}while((i|0)<(k|0));A=k}else A=y;l=l+1|0;if((l|0)>=(f[p>>2]|0))break;else s=A}u=g;return}A=(r|0)==1;r=0;do{s=f[h>>2]|0;l=Y(f[f[j>>2]>>2]|0,r)|0;y=s+l|0;do if(A)if((r|0)!=(f[m>>2]|0)){z=f[e>>2]|0;i=z+1|0;if((z|0)>0){B=z;C=i;D=23;break}else{E=0;F=i;D=24;break}}else{E=0;F=f[d>>2]|0;D=24;break}else{i=r-x|0;if((((i|0)>-1?i:0-i|0)|0)<=(x|0)){z=rNa(t*+M(+(w*+(a-(Y(i,i)|0)|0))))|0;i=v-z|0;c=z+v|0;z=f[d>>2]|0;k=(z|0)<=(c|0)?z:c+1|0;if((i|0)>0){B=i;C=k;D=23}else{E=0;F=k;D=24}}else G=0}while(0);if((D|0)==23){D=0;F1a(y|0,0,B|0)|0;E=B;F=C;D=24}if((D|0)==24){D=0;if((F|0)>(E|0)){F1a(s+(E+l)|0,1,F-E|0)|0;G=F}else G=E}if((G|0)<(f[d>>2]|0)){k=G;do{b[y+k>>0]=0;k=k+1|0}while((k|0)<(f[d>>2]|0))}r=r+1|0}while((r|0)<(f[p>>2]|0));u=g;return}function aka(a,b,c,d,e,g,h,i,j,k,l,m,n,o,q,r,s,t,v,w,x,y,z,A,B,C,D,E){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;q=q|0;r=r|0;s=s|0;t=t|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;var F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0;E=u;u=u+224|0;F=E+168|0;G=E+160|0;H=E+152|0;I=E+96|0;J=E+88|0;K=E;L=E+80|0;M=E+72|0;N=E+64|0;O=E+56|0;f[G>>2]=x;f[G+4>>2]=y;CN(F,G,t,v,w);P=+p[C>>3];Q=+p[C+8>>3];R=+p[C+16>>3];S=+p[C+24>>3];f[I+8>>2]=0;f[I+12>>2]=0;f[I>>2]=16842752;f[I+4>>2]=F;f[J>>2]=z;f[J+4>>2]=A;p[K>>3]=P;p[K+8>>3]=Q;p[K+16>>3]=R;p[K+24>>3]=S;_ja(H,a,b,I,J,B,B,K);f[L>>2]=i;f[L+4>>2]=j;CN(I,L,b,d,e);f[M>>2]=i;f[M+4>>2]=j;CN(K,M,c,g,h);f[N>>2]=m;f[N+4>>2]=n;f[O>>2]=k;f[O+4>>2]=l;l=f[H+4>>2]|0;Bh[f[(f[l>>2]|0)+20>>2]&255](l,I,K,O,N);f[N>>2]=r;f[N+4>>2]=s;f[O>>2]=o;f[O+4>>2]=q;if((D|0)>1){q=1;do{Bh[f[(f[l>>2]|0)+20>>2]&255](l,K,K,O,N);q=q+1|0}while((q|0)<(D|0))}D=K+36|0;q=f[D>>2]|0;if(q|0?(N=q+12|0,q=f[N>>2]|0,f[N>>2]=q+-1,(q|0)==1):0)CR(K);f[D>>2]=0;D=K+16|0;q=K+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[q>>2]|0)>0){D=f[K+40>>2]|0;N=0;do{f[D+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[q>>2]|0))}q=f[K+44>>2]|0;if((q|0)!=(K+48|0))ZF(q);q=I+36|0;K=f[q>>2]|0;if(K|0?(N=K+12|0,K=f[N>>2]|0,f[N>>2]=K+-1,(K|0)==1):0)CR(I);f[q>>2]=0;q=I+16|0;K=I+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[K>>2]|0)>0){q=f[I+40>>2]|0;N=0;do{f[q+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[K>>2]|0))}K=f[I+44>>2]|0;if((K|0)!=(I+48|0))ZF(K);K=f[H>>2]|0;if(K|0?(H=K+4|0,I=f[H>>2]|0,f[H>>2]=I+-1,(I|0)==1):0)ki[f[(f[K>>2]|0)+8>>2]&2047](K);K=F+36|0;I=f[K>>2]|0;if(I|0?(H=I+12|0,I=f[H>>2]|0,f[H>>2]=I+-1,(I|0)==1):0)CR(F);f[K>>2]=0;K=F+16|0;I=F+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[I>>2]|0)>0){K=f[F+40>>2]|0;H=0;do{f[K+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[I>>2]|0))}I=f[F+44>>2]|0;if((I|0)==(F+48|0)){u=E;return}ZF(I);u=E;return}function bka(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0;i=u;u=u+16|0;j=i+8|0;k=i;_$(j,74304);f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];cka(0,a,b,c,k,e,g,h);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function cka(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0;k=u;u=u+256|0;l=k+192|0;m=k+184|0;n=k+128|0;o=k+120|0;p=k+112|0;q=k+104|0;r=k+96|0;s=k+32|0;t=k+40|0;v=k+24|0;w=k+16|0;x=k+8|0;y=k;_$(m,74324);do if((NS(e)|0)==65536){z=f[e+4>>2]|0;f[n>>2]=f[z>>2];A=n+4|0;B=z+4|0;f[A>>2]=f[B>>2];C=n+8|0;f[C>>2]=f[z+8>>2];f[n+12>>2]=f[z+12>>2];D=n+16|0;f[D>>2]=f[z+16>>2];f[n+20>>2]=f[z+20>>2];f[n+24>>2]=f[z+24>>2];f[n+28>>2]=f[z+28>>2];f[n+32>>2]=f[z+32>>2];E=f[z+36>>2]|0;f[n+36>>2]=E;f[n+40>>2]=C;C=n+48|0;F=n+44|0;f[F>>2]=C;f[C>>2]=0;f[n+52>>2]=0;if(E|0){C=E+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[B>>2]|0)<3){B=f[z+44>>2]|0;C=f[F>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2];G=D;break}else{f[A>>2]=0;BR(n,z);G=D;break}}else{OR(n,e,-1);G=n+16|0}while(0);if(f[G>>2]|0){e=f[n+4>>2]|0;if((e|0)<3)H=Y(f[n+12>>2]|0,f[n+8>>2]|0)|0;else{D=f[n+40>>2]|0;z=0;A=1;while(1){B=Y(f[D+(z<<2)>>2]|0,A)|0;z=z+1|0;if((z|0)==(e|0)){H=B;break}else A=B}}if(!((e|0)==0|(H|0)==0)){H=f[n+40>>2]|0;I=f[H+4>>2]|0;J=f[H>>2]|0}else{I=3;J=3}}else{I=3;J=3}H=f[g>>2]|0;e=g+4|0;A=f[e>>2]|0;z=(H|0)==-1?(I|0)/2|0:H;H=(A|0)==-1?(J|0)/2|0:A;if(!((z|0)>-1&(z|0)<(I|0)?!((H|0)<0|(H|0)>=(J|0)):0)){f[l>>2]=0;f[l+4>>2]=0;A=c$(l,52)|0;D=320583;B=A+52|0;do{b[A>>0]=b[D>>0]|0;A=A+1|0;D=D+1|0}while((A|0)<(B|0));j$(-215,l,320636,320652,363);d$(l)}f[g>>2]=z;f[e>>2]=H;if((h|0)!=0?(H=n+8|0,z=n+12|0,D=Y(f[z>>2]|0,f[H>>2]|0)|0,(D|0)!=1):0){if(f[G>>2]|0){A=n+4|0;B=f[A>>2]|0;if((B|0)<3)K=D;else{D=f[n+40>>2]|0;C=0;F=1;while(1){E=Y(f[D+(C<<2)>>2]|0,F)|0;C=C+1|0;if((C|0)==(B|0)){K=E;break}else F=E}}if(!((B|0)==0|(K|0)==0))if((h|0)>1?(f[l+8>>2]=0,f[l+12>>2]=0,f[l>>2]=16842752,f[l+4>>2]=n,K=bZ(l)|0,(K|0)==(Y(f[z>>2]|0,f[H>>2]|0)|0)):0){K=Y(f[g>>2]|0,h)|0;B=Y(f[e>>2]|0,h)|0;f[g>>2]=K;f[e>>2]=B;F=h+-1|0;C=(Y(I+-1|0,F)|0)+I|0;I=(Y(J+-1|0,F)|0)+J|0;f[q>>2]=C;f[q+4>>2]=I;f[r>>2]=K;f[r+4>>2]=B;$ja(l,0,q,r);r=l+36|0;q=f[r>>2]|0;if(q|0){B=q+12|0;f[B>>2]=(f[B>>2]|0)+1}B=n+36|0;q=f[B>>2]|0;if(q|0?(K=q+12|0,q=f[K>>2]|0,f[K>>2]=q+-1,(q|0)==1):0)CR(n);f[B>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[A>>2]|0)>0){q=f[n+40>>2]|0;K=0;do{f[q+(K<<2)>>2]=0;K=K+1|0;L=f[A>>2]|0}while((K|0)<(L|0));f[n>>2]=f[l>>2];if((L|0)<3)M=60;else M=62}else{f[n>>2]=f[l>>2];M=60}if((M|0)==60){L=f[l+4>>2]|0;if((L|0)<3){f[A>>2]=L;f[H>>2]=f[l+8>>2];f[z>>2]=f[l+12>>2];L=f[l+44>>2]|0;A=f[n+44>>2]|0;f[A>>2]=f[L>>2];f[A+4>>2]=f[L+4>>2]}else M=62}if((M|0)==62)BR(n,l);L=l+16|0;f[G>>2]=f[L>>2];f[n+20>>2]=f[l+20>>2];f[n+24>>2]=f[l+24>>2];f[n+28>>2]=f[l+28>>2];f[n+32>>2]=f[l+32>>2];A=f[r>>2]|0;f[B>>2]=A;if(A|0?(B=A+12|0,A=f[B>>2]|0,f[B>>2]=A+-1,(A|0)==1):0)CR(l);f[r>>2]=0;r=l+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[r>>2]|0)>0){L=f[l+40>>2]|0;A=0;do{f[L+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[r>>2]|0))}r=f[l+44>>2]|0;if((r|0)!=(l+48|0))ZF(r);N=1}else N=h;else M=26}else M=26;if((M|0)==26){r=h<<1|1;f[o>>2]=r;f[o+4>>2]=r;f[p>>2]=-1;f[p+4>>2]=-1;$ja(l,0,o,p);p=l+36|0;o=f[p>>2]|0;if(o|0){r=o+12|0;f[r>>2]=(f[r>>2]|0)+1}r=n+36|0;o=f[r>>2]|0;if(o|0?(A=o+12|0,o=f[A>>2]|0,f[A>>2]=o+-1,(o|0)==1):0)CR(n);f[r>>2]=0;o=n+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[o>>2]|0)>0){A=f[n+40>>2]|0;L=0;do{f[A+(L<<2)>>2]=0;L=L+1|0;O=f[o>>2]|0}while((L|0)<(O|0));f[n>>2]=f[l>>2];if((O|0)<3)M=36;else M=38}else{f[n>>2]=f[l>>2];M=36}if((M|0)==36){O=f[l+4>>2]|0;if((O|0)<3){f[o>>2]=O;f[H>>2]=f[l+8>>2];f[z>>2]=f[l+12>>2];O=f[l+44>>2]|0;o=f[n+44>>2]|0;f[o>>2]=f[O>>2];f[o+4>>2]=f[O+4>>2]}else M=38}if((M|0)==38)BR(n,l);M=l+16|0;f[G>>2]=f[M>>2];f[n+20>>2]=f[l+20>>2];f[n+24>>2]=f[l+24>>2];f[n+28>>2]=f[l+28>>2];f[n+32>>2]=f[l+32>>2];O=f[p>>2]|0;f[r>>2]=O;if(O|0?(r=O+12|0,O=f[r>>2]|0,f[r>>2]=O+-1,(O|0)==1):0)CR(l);f[p>>2]=0;p=l+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[p>>2]|0)>0){M=f[l+40>>2]|0;O=0;do{f[M+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[p>>2]|0))}p=f[l+44>>2]|0;if((p|0)!=(l+48|0))ZF(p);f[g>>2]=h;f[e>>2]=h;N=1}do if((NS(c)|0)==65536){h=f[c+4>>2]|0;f[l>>2]=f[h>>2];p=l+4|0;O=h+4|0;f[p>>2]=f[O>>2];M=l+8|0;f[M>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];f[l+16>>2]=f[h+16>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];r=f[h+36>>2]|0;f[l+36>>2]=r;o=l+40|0;f[o>>2]=M;M=l+48|0;L=l+44|0;f[L>>2]=M;f[M>>2]=0;f[l+52>>2]=0;if(r|0){M=r+12|0;f[M>>2]=(f[M>>2]|0)+1}if((f[O>>2]|0)<3){O=f[h+44>>2]|0;M=f[L>>2]|0;f[M>>2]=f[O>>2];f[M+4>>2]=f[O+4>>2];P=l;Q=o;break}else{f[p>>2]=0;BR(l,h);P=l;Q=o;break}}else{OR(l,c,-1);P=l;Q=l+40|0}while(0);o=f[Q>>2]|0;h=f[o>>2]|0;f[s>>2]=f[o+4>>2];f[s+4>>2]=h;KS(d,s,f[P>>2]&4095,-1,0,0);do if((NS(d)|0)==65536){s=f[d+4>>2]|0;f[t>>2]=f[s>>2];h=t+4|0;o=s+4|0;f[h>>2]=f[o>>2];p=t+8|0;f[p>>2]=f[s+8>>2];O=t+12|0;f[O>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];f[t+24>>2]=f[s+24>>2];f[t+28>>2]=f[s+28>>2];f[t+32>>2]=f[s+32>>2];M=f[s+36>>2]|0;f[t+36>>2]=M;f[t+40>>2]=p;L=t+48|0;r=t+44|0;f[r>>2]=L;f[L>>2]=0;f[t+52>>2]=0;if(M|0){L=M+12|0;f[L>>2]=(f[L>>2]|0)+1}if((f[o>>2]|0)<3){o=f[s+44>>2]|0;L=f[r>>2]|0;f[L>>2]=f[o>>2];f[L+4>>2]=f[o+4>>2];R=O;S=p;break}else{f[h>>2]=0;BR(t,s);R=O;S=p;break}}else{OR(t,d,-1);R=t+12|0;S=t+8|0}while(0);f[v>>2]=0;p=v+4|0;f[p>>2]=0;O=l+12|0;s=f[O>>2]|0;h=l+8|0;o=f[h>>2]|0;f[w>>2]=s;L=w+4|0;f[L>>2]=o;f[x>>2]=0;r=x+4|0;f[r>>2]=0;M=f[R>>2]|0;R=f[S>>2]|0;f[y>>2]=M;S=y+4|0;f[S>>2]=R;A=(i&16|0)!=0;if(A){T=s;U=o;V=s;W=o;X=0;Z=0;_=M;$=R;aa=0;ba=0}else{KR(l,w,v);KR(t,y,x);T=f[O>>2]|0;U=f[h>>2]|0;V=f[w>>2]|0;W=f[L>>2]|0;X=f[v>>2]|0;Z=f[p>>2]|0;_=f[y>>2]|0;$=f[S>>2]|0;aa=f[x>>2]|0;ba=f[r>>2]|0}r=f[P>>2]|0;P=l+16|0;x=l+48|0;S=t+16|0;y=t+48|0;aka(a,r&4095,f[t>>2]&4095,f[P>>2]|0,f[x>>2]|0,f[S>>2]|0,f[y>>2]|0,T,U,V,W,X,Z,_,$,aa,ba,f[n>>2]&4095,f[G>>2]|0,f[n+48>>2]|0,f[z>>2]|0,f[H>>2]|0,f[g>>2]|0,f[e>>2]|0,i&-17,j,N,(r&32768|0)!=0&(A^1));A=t+36|0;r=f[A>>2]|0;if(r|0?(N=r+12|0,r=f[N>>2]|0,f[N>>2]=r+-1,(r|0)==1):0)CR(t);f[A>>2]=0;A=t+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[A>>2]|0)>0){S=f[t+40>>2]|0;r=0;do{f[S+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[A>>2]|0))}A=f[t+44>>2]|0;if((A|0)!=(y|0))ZF(A);A=l+36|0;y=f[A>>2]|0;if(y|0?(t=y+12|0,y=f[t>>2]|0,f[t>>2]=y+-1,(y|0)==1):0)CR(l);f[A>>2]=0;A=l+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[A>>2]|0)>0){P=f[Q>>2]|0;Q=0;do{f[P+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[A>>2]|0))}A=f[l+44>>2]|0;if((A|0)!=(x|0))ZF(A)}else ZS(c,d);d=n+36|0;c=f[d>>2]|0;if(c|0?(A=c+12|0,c=f[A>>2]|0,f[A>>2]=c+-1,(c|0)==1):0)CR(n);f[d>>2]=0;d=n+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[d>>2]|0)>0){G=f[n+40>>2]|0;c=0;do{f[G+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[n+44>>2]|0;if((d|0)!=(n+48|0))ZF(d);if(!(f[m+4>>2]|0)){u=k;return}u=k;return}function dka(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0;i=u;u=u+16|0;j=i+8|0;k=i;_$(j,74344);f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];cka(1,a,b,c,k,e,g,h);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function eka(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;k=u;u=u+832|0;l=k;m=k+808|0;n=k+728|0;o=k+720|0;p=k+664|0;q=k+800|0;r=k+792|0;s=k+608|0;t=k+552|0;v=k+784|0;w=k+496|0;x=k+440|0;y=k+384|0;z=k+328|0;A=k+272|0;B=k+256|0;C=k+240|0;D=k+224|0;_$(o,74364);do if((NS(e)|0)==65536){E=f[e+4>>2]|0;f[p>>2]=f[E>>2];F=p+4|0;G=E+4|0;f[F>>2]=f[G>>2];H=p+8|0;f[H>>2]=f[E+8>>2];f[p+12>>2]=f[E+12>>2];I=p+16|0;f[I>>2]=f[E+16>>2];f[p+20>>2]=f[E+20>>2];f[p+24>>2]=f[E+24>>2];f[p+28>>2]=f[E+28>>2];f[p+32>>2]=f[E+32>>2];J=f[E+36>>2]|0;f[p+36>>2]=J;f[p+40>>2]=H;H=p+48|0;K=p+44|0;f[K>>2]=H;f[H>>2]=0;f[p+52>>2]=0;if(J|0){H=J+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[G>>2]|0)<3){G=f[E+44>>2]|0;H=f[K>>2]|0;f[H>>2]=f[G>>2];f[H+4>>2]=f[G+4>>2];L=I;break}else{f[F>>2]=0;BR(p,E);L=I;break}}else{OR(p,e,-1);L=p+16|0}while(0);if(f[L>>2]|0){e=f[p+4>>2]|0;if((e|0)<3)M=Y(f[p+12>>2]|0,f[p+8>>2]|0)|0;else{I=f[p+40>>2]|0;E=0;F=1;while(1){G=Y(f[I+(E<<2)>>2]|0,F)|0;E=E+1|0;if((E|0)==(e|0)){M=G;break}else F=G}}if((e|0)==0|(M|0)==0)N=14}else N=14;if((N|0)==14){f[q>>2]=3;f[q+4>>2]=3;f[r>>2]=1;f[r+4>>2]=1;$ja(l,0,q,r);r=l+36|0;q=f[r>>2]|0;if(q|0){M=q+12|0;f[M>>2]=(f[M>>2]|0)+1}M=p+36|0;q=f[M>>2]|0;if(q|0?(e=q+12|0,q=f[e>>2]|0,f[e>>2]=q+-1,(q|0)==1):0)CR(p);f[M>>2]=0;q=p+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[q>>2]|0)>0){e=f[p+40>>2]|0;F=0;do{f[e+(F<<2)>>2]=0;F=F+1|0;O=f[q>>2]|0}while((F|0)<(O|0));f[p>>2]=f[l>>2];if((O|0)<3)N=24;else N=26}else{f[p>>2]=f[l>>2];N=24}if((N|0)==24){O=f[l+4>>2]|0;if((O|0)<3){f[q>>2]=O;f[p+8>>2]=f[l+8>>2];f[p+12>>2]=f[l+12>>2];O=f[l+44>>2]|0;q=f[p+44>>2]|0;f[q>>2]=f[O>>2];f[q+4>>2]=f[O+4>>2]}else N=26}if((N|0)==26)BR(p,l);O=l+16|0;f[L>>2]=f[O>>2];f[p+20>>2]=f[l+20>>2];f[p+24>>2]=f[l+24>>2];f[p+28>>2]=f[l+28>>2];f[p+32>>2]=f[l+32>>2];q=f[r>>2]|0;f[M>>2]=q;if(q|0?(M=q+12|0,q=f[M>>2]|0,f[M>>2]=q+-1,(q|0)==1):0)CR(l);f[r>>2]=0;r=l+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[r>>2]|0)>0){O=f[l+40>>2]|0;q=0;do{f[O+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[r>>2]|0))}r=f[l+44>>2]|0;if((r|0)!=(l+48|0))ZF(r)}do if((NS(a)|0)==65536){r=f[a+4>>2]|0;f[s>>2]=f[r>>2];q=s+4|0;O=r+4|0;f[q>>2]=f[O>>2];M=s+8|0;f[M>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];f[s+16>>2]=f[r+16>>2];f[s+20>>2]=f[r+20>>2];f[s+24>>2]=f[r+24>>2];f[s+28>>2]=f[r+28>>2];f[s+32>>2]=f[r+32>>2];F=f[r+36>>2]|0;f[s+36>>2]=F;e=s+40|0;f[e>>2]=M;M=s+48|0;E=s+44|0;f[E>>2]=M;f[M>>2]=0;f[s+52>>2]=0;if(F|0){M=F+12|0;f[M>>2]=(f[M>>2]|0)+1}if((f[O>>2]|0)<3){O=f[r+44>>2]|0;M=f[E>>2]|0;f[M>>2]=f[O>>2];f[M+4>>2]=f[O+4>>2];P=s;Q=e;break}else{f[q>>2]=0;BR(s,r);P=s;Q=e;break}}else{OR(s,a,-1);P=s;Q=s+40|0}while(0);f[t>>2]=1124007936;a=t+4|0;e=t+8|0;r=t+40|0;q=a;O=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(O|0));f[r>>2]=e;M=t+48|0;E=t+44|0;f[E>>2]=M;f[M>>2]=0;f[t+52>>2]=0;F=f[Q>>2]|0;I=f[F>>2]|0;f[v>>2]=f[F+4>>2];f[v+4>>2]=I;KS(c,v,f[P>>2]&4095,-1,0,0);do if((NS(c)|0)==65536){v=f[c+4>>2]|0;f[w>>2]=f[v>>2];I=w+4|0;F=v+4|0;f[I>>2]=f[F>>2];G=w+8|0;f[G>>2]=f[v+8>>2];f[w+12>>2]=f[v+12>>2];f[w+16>>2]=f[v+16>>2];f[w+20>>2]=f[v+20>>2];f[w+24>>2]=f[v+24>>2];f[w+28>>2]=f[v+28>>2];f[w+32>>2]=f[v+32>>2];H=f[v+36>>2]|0;f[w+36>>2]=H;f[w+40>>2]=G;G=w+48|0;K=w+44|0;f[K>>2]=G;f[G>>2]=0;f[w+52>>2]=0;if(H|0){G=H+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[F>>2]|0)<3){F=f[v+44>>2]|0;G=f[K>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=f[F+4>>2];break}else{f[I>>2]=0;BR(w,v);break}}else OR(w,c,-1);while(0);a:do switch(d|0){case 0:{f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=s;c=x+8|0;f[c>>2]=0;f[c+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=w;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;c=f[g>>2]|0;v=f[g+4>>2]|0;_$(l,74304);f[m>>2]=c;f[m+4>>2]=v;cka(0,n,x,y,m,h,i,j);break}case 1:{f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=s;v=x+8|0;f[v>>2]=0;f[v+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=w;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;v=f[g>>2]|0;c=f[g+4>>2]|0;_$(l,74344);f[m>>2]=v;f[m+4>>2]=c;cka(1,n,x,y,m,h,i,j);break}case 2:{f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=s;c=x+8|0;f[c>>2]=0;f[c+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=w;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;c=f[g>>2]|0;v=g+4|0;I=f[v>>2]|0;_$(l,74304);f[m>>2]=c;f[m+4>>2]=I;cka(0,n,x,y,m,h,i,j);f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=w;I=x+8|0;f[I>>2]=0;f[I+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=w;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;I=f[g>>2]|0;c=f[v>>2]|0;_$(l,74344);f[m>>2]=I;f[m+4>>2]=c;cka(1,n,x,y,m,h,i,j);break}case 3:{f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=s;c=x+8|0;f[c>>2]=0;f[c+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=w;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;c=f[g>>2]|0;I=g+4|0;v=f[I>>2]|0;_$(l,74344);f[m>>2]=c;f[m+4>>2]=v;cka(1,n,x,y,m,h,i,j);f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=w;v=x+8|0;f[v>>2]=0;f[v+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=w;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;v=f[g>>2]|0;c=f[I>>2]|0;_$(l,74304);f[m>>2]=v;f[m+4>>2]=c;cka(0,n,x,y,m,h,i,j);break}case 4:{f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=s;c=x+8|0;f[c>>2]=0;f[c+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=t;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;c=f[g>>2]|0;v=g+4|0;I=f[v>>2]|0;_$(l,74304);f[m>>2]=c;f[m+4>>2]=I;cka(0,n,x,y,m,h,i,j);f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=s;I=x+8|0;f[I>>2]=0;f[I+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=w;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;I=f[g>>2]|0;c=f[v>>2]|0;_$(l,74344);f[m>>2]=I;f[m+4>>2]=c;cka(1,n,x,y,m,h,i,j);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=w;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=t;c=n+8|0;f[c>>2]=0;f[c+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=w;hH(l,m,n,fT()|0,-1);break}case 5:{c=w+16|0;if((f[s+16>>2]|0)!=(f[c>>2]|0)){I=w+36|0;v=f[I>>2]|0;if(v|0){F=v+12|0;f[F>>2]=(f[F>>2]|0)+1}F=t+36|0;v=f[F>>2]|0;if(v|0?(G=v+12|0,v=f[G>>2]|0,f[G>>2]=v+-1,(v|0)==1):0)CR(t);f[F>>2]=0;v=t+16|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[a>>2]|0)>0){G=f[r>>2]|0;K=0;do{f[G+(K<<2)>>2]=0;K=K+1|0;R=f[a>>2]|0}while((K|0)<(R|0));f[t>>2]=f[w>>2];if((R|0)<3)N=83;else N=85}else{f[t>>2]=f[w>>2];N=83}if((N|0)==83){K=f[w+4>>2]|0;if((K|0)<3){f[a>>2]=K;f[e>>2]=f[w+8>>2];f[t+12>>2]=f[w+12>>2];K=f[w+44>>2]|0;G=f[E>>2]|0;f[G>>2]=f[K>>2];f[G+4>>2]=f[K+4>>2]}else N=85}if((N|0)==85)BR(t,w);f[v>>2]=f[c>>2];f[t+20>>2]=f[w+20>>2];f[t+24>>2]=f[w+24>>2];f[t+28>>2]=f[w+28>>2];f[t+32>>2]=f[w+32>>2];f[F>>2]=f[I>>2]}f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=s;K=x+8|0;f[K>>2]=0;f[K+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=t;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;K=f[g>>2]|0;G=g+4|0;H=f[G>>2]|0;_$(l,74304);f[m>>2]=K;f[m+4>>2]=H;cka(0,n,x,y,m,h,i,j);f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=t;H=x+8|0;f[H>>2]=0;f[H+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=t;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;H=f[g>>2]|0;K=f[G>>2]|0;_$(l,74344);f[m>>2]=H;f[m+4>>2]=K;cka(1,n,x,y,m,h,i,j);EQ(l,s,t);K=f[l>>2]|0;Ah[f[(f[K>>2]|0)+12>>2]&255](K,l,w,-1);fj(l);break}case 6:{K=w+16|0;if((f[s+16>>2]|0)!=(f[K>>2]|0)){H=w+36|0;G=f[H>>2]|0;if(G|0){J=G+12|0;f[J>>2]=(f[J>>2]|0)+1}J=t+36|0;G=f[J>>2]|0;if(G|0?(S=G+12|0,G=f[S>>2]|0,f[S>>2]=G+-1,(G|0)==1):0)CR(t);f[J>>2]=0;G=t+16|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[a>>2]|0)>0){S=f[r>>2]|0;T=0;do{f[S+(T<<2)>>2]=0;T=T+1|0;U=f[a>>2]|0}while((T|0)<(U|0));f[t>>2]=f[w>>2];if((U|0)<3)N=103;else N=105}else{f[t>>2]=f[w>>2];N=103}if((N|0)==103){T=f[w+4>>2]|0;if((T|0)<3){f[a>>2]=T;f[e>>2]=f[w+8>>2];f[t+12>>2]=f[w+12>>2];T=f[w+44>>2]|0;S=f[E>>2]|0;f[S>>2]=f[T>>2];f[S+4>>2]=f[T+4>>2]}else N=105}if((N|0)==105)BR(t,w);f[G>>2]=f[K>>2];f[t+20>>2]=f[w+20>>2];f[t+24>>2]=f[w+24>>2];f[t+28>>2]=f[w+28>>2];f[t+32>>2]=f[w+32>>2];f[J>>2]=f[H>>2]}f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=s;T=x+8|0;f[T>>2]=0;f[T+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=t;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;T=f[g>>2]|0;S=g+4|0;I=f[S>>2]|0;_$(l,74344);f[m>>2]=T;f[m+4>>2]=I;cka(1,n,x,y,m,h,i,j);f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=t;I=x+8|0;f[I>>2]=0;f[I+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=t;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;I=f[g>>2]|0;T=f[S>>2]|0;_$(l,74304);f[m>>2]=I;f[m+4>>2]=T;cka(0,n,x,y,m,h,i,j);EQ(l,t,s);T=f[l>>2]|0;Ah[f[(f[T>>2]|0)+12>>2]&255](T,l,w,-1);fj(l);break}case 7:{if(f[P>>2]&4095|0){f[l>>2]=0;f[l+4>>2]=0;q=c$(l,55)|0;V=332814;O=q+55|0;do{b[q>>0]=b[V>>0]|0;q=q+1|0;V=V+1|0}while((q|0)<(O|0));j$(-215,l,322726,317079,2104);d$(l)}f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=p;if((bZ(l)|0)<1){H=l+8|0;f[H>>2]=0;f[H+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=w;eL(s,l);break a}f[n>>2]=1124007936;H=n+4|0;J=n+8|0;K=n+40|0;q=H;O=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(O|0));f[K>>2]=J;G=n+48|0;T=n+44|0;f[T>>2]=G;f[G>>2]=0;f[n+52>>2]=0;f[x>>2]=1124007936;I=x+4|0;S=x+8|0;F=x+40|0;q=I;O=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(O|0));f[F>>2]=S;J=x+48|0;c=x+44|0;f[c>>2]=J;f[J>>2]=0;f[x+52>>2]=0;f[y>>2]=1124007936;v=y+4|0;W=y+8|0;X=y+40|0;q=v;O=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(O|0));f[X>>2]=W;S=y+48|0;Z=y+44|0;f[Z>>2]=S;f[S>>2]=0;f[y+52>>2]=0;f[z>>2]=1124007936;_=z+4|0;$=z+8|0;aa=z+40|0;q=_;O=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(O|0));f[aa>>2]=$;ba=z+48|0;ca=z+44|0;f[ca>>2]=ba;f[ba>>2]=0;f[z+52>>2]=0;QQ(l,p,1.0);da=f[l>>2]|0;Ah[f[(f[da>>2]|0)+12>>2]&255](da,l,n,-1);fj(l);QQ(l,p,-1.0);da=f[l>>2]|0;Ah[f[(f[da>>2]|0)+12>>2]&255](da,l,x,-1);fj(l);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=n;if((bZ(l)|0)>=1){f[A+8>>2]=0;f[A+12>>2]=0;f[A>>2]=16842752;f[A+4>>2]=s;da=B+8|0;f[da>>2]=0;f[da+4>>2]=0;f[B>>2]=33619968;f[B+4>>2]=y;f[C+8>>2]=0;f[C+12>>2]=0;f[C>>2]=16842752;f[C+4>>2]=n;da=f[g>>2]|0;ea=f[g+4>>2]|0;_$(l,74304);f[m>>2]=da;f[m+4>>2]=ea;cka(0,A,B,C,m,h,i,j)}else{ea=s+36|0;da=f[ea>>2]|0;if(da|0){fa=da+12|0;f[fa>>2]=(f[fa>>2]|0)+1}fa=y+36|0;da=f[fa>>2]|0;if(da|0?(ga=da+12|0,da=f[ga>>2]|0,f[ga>>2]=da+-1,(da|0)==1):0)CR(y);f[fa>>2]=0;da=y+16|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[v>>2]|0)>0){ga=f[X>>2]|0;ha=0;do{f[ga+(ha<<2)>>2]=0;ha=ha+1|0;ia=f[v>>2]|0}while((ha|0)<(ia|0));f[y>>2]=f[P>>2];if((ia|0)<3)N=127;else N=129}else{f[y>>2]=f[P>>2];N=127}if((N|0)==127){ha=f[s+4>>2]|0;if((ha|0)<3){f[v>>2]=ha;f[W>>2]=f[s+8>>2];f[y+12>>2]=f[s+12>>2];ha=f[s+44>>2]|0;ga=f[Z>>2]|0;f[ga>>2]=f[ha>>2];f[ga+4>>2]=f[ha+4>>2]}else N=129}if((N|0)==129)BR(y,s);f[da>>2]=f[s+16>>2];f[y+20>>2]=f[s+20>>2];f[y+24>>2]=f[s+24>>2];f[y+28>>2]=f[s+28>>2];f[y+32>>2]=f[s+32>>2];f[fa>>2]=f[ea>>2]}f[A>>2]=1124007936;ha=A+4|0;ga=A+8|0;ja=A+40|0;q=ha;O=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(O|0));f[ja>>2]=ga;ea=A+48|0;fa=A+44|0;f[fa>>2]=ea;f[ea>>2]=0;f[A+52>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=s;da=m+8|0;f[da>>2]=0;f[da+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=A;lG(l,m,fT()|0);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=x;if((bZ(l)|0)>=1){f[B+8>>2]=0;f[B+12>>2]=0;f[B>>2]=16842752;f[B+4>>2]=A;da=C+8|0;f[da>>2]=0;f[da+4>>2]=0;f[C>>2]=33619968;f[C+4>>2]=z;f[D+8>>2]=0;f[D+12>>2]=0;f[D>>2]=16842752;f[D+4>>2]=x;da=f[g>>2]|0;W=f[g+4>>2]|0;_$(l,74304);f[m>>2]=da;f[m+4>>2]=W;cka(0,B,C,D,m,h,i,j)}else{W=A+36|0;da=f[W>>2]|0;if(da|0){ka=da+12|0;f[ka>>2]=(f[ka>>2]|0)+1}ka=z+36|0;da=f[ka>>2]|0;if(da|0?(la=da+12|0,da=f[la>>2]|0,f[la>>2]=da+-1,(da|0)==1):0)CR(z);f[ka>>2]=0;da=z+16|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[_>>2]|0)>0){la=f[aa>>2]|0;ma=0;do{f[la+(ma<<2)>>2]=0;ma=ma+1|0;na=f[_>>2]|0}while((ma|0)<(na|0));f[z>>2]=f[A>>2];if((na|0)<3)N=145;else N=147}else{f[z>>2]=f[A>>2];N=145}if((N|0)==145){ma=f[ha>>2]|0;if((ma|0)<3){f[_>>2]=ma;f[$>>2]=f[ga>>2];f[z+12>>2]=f[A+12>>2];ma=f[fa>>2]|0;la=f[ca>>2]|0;f[la>>2]=f[ma>>2];f[la+4>>2]=f[ma+4>>2]}else N=147}if((N|0)==147)BR(z,A);f[da>>2]=f[A+16>>2];f[z+20>>2]=f[A+20>>2];f[z+24>>2]=f[A+24>>2];f[z+28>>2]=f[A+28>>2];f[z+32>>2]=f[A+32>>2];f[ka>>2]=f[W>>2]}RQ(l,y,z);ma=f[l>>2]|0;Ah[f[(f[ma>>2]|0)+12>>2]&255](ma,l,w,-1);fj(l);ma=A+36|0;la=f[ma>>2]|0;if(la|0?(oa=la+12|0,la=f[oa>>2]|0,f[oa>>2]=la+-1,(la|0)==1):0)CR(A);f[ma>>2]=0;ma=A+16|0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[ha>>2]|0)>0){ma=f[ja>>2]|0;la=0;do{f[ma+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[ha>>2]|0))}ha=f[fa>>2]|0;if((ha|0)!=(ea|0))ZF(ha);ha=z+36|0;la=f[ha>>2]|0;if(la|0?(ma=la+12|0,la=f[ma>>2]|0,f[ma>>2]=la+-1,(la|0)==1):0)CR(z);f[ha>>2]=0;ha=z+16|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[_>>2]|0)>0){ha=f[aa>>2]|0;la=0;do{f[ha+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[_>>2]|0))}_=f[ca>>2]|0;if((_|0)!=(ba|0))ZF(_);_=y+36|0;la=f[_>>2]|0;if(la|0?(ha=la+12|0,la=f[ha>>2]|0,f[ha>>2]=la+-1,(la|0)==1):0)CR(y);f[_>>2]=0;_=y+16|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[v>>2]|0)>0){_=f[X>>2]|0;la=0;do{f[_+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[v>>2]|0))}v=f[Z>>2]|0;if((v|0)!=(S|0))ZF(v);v=x+36|0;la=f[v>>2]|0;do if(la|0){_=la+12|0;X=f[_>>2]|0;f[_>>2]=X+-1;if((X|0)!=1)break;CR(x)}while(0);f[v>>2]=0;la=x+16|0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[I>>2]|0)>0){la=f[F>>2]|0;S=0;do{f[la+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[I>>2]|0))}I=f[c>>2]|0;if((I|0)!=(J|0))ZF(I);I=n+36|0;S=f[I>>2]|0;do if(S|0){la=S+12|0;F=f[la>>2]|0;f[la>>2]=F+-1;if((F|0)!=1)break;CR(n)}while(0);f[I>>2]=0;S=n+16|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[H>>2]|0)>0){S=f[K>>2]|0;J=0;do{f[S+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[H>>2]|0))}H=f[T>>2]|0;if((H|0)!=(G|0))ZF(H);break}default:{f[l>>2]=0;f[l+4>>2]=0;q=c$(l,31)|0;V=322739;O=q+31|0;do{b[q>>0]=b[V>>0]|0;q=q+1|0;V=V+1|0}while((q|0)<(O|0));j$(-5,l,322726,317079,2130);d$(l)}}while(0);l=w+36|0;V=f[l>>2]|0;if(V|0?(q=V+12|0,V=f[q>>2]|0,f[q>>2]=V+-1,(V|0)==1):0)CR(w);f[l>>2]=0;l=w+16|0;V=w+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[V>>2]|0)>0){l=f[w+40>>2]|0;q=0;do{f[l+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[V>>2]|0))}V=f[w+44>>2]|0;if((V|0)!=(w+48|0))ZF(V);V=t+36|0;w=f[V>>2]|0;if(w|0?(q=w+12|0,w=f[q>>2]|0,f[q>>2]=w+-1,(w|0)==1):0)CR(t);f[V>>2]=0;V=t+16|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[a>>2]|0)>0){V=f[r>>2]|0;r=0;do{f[V+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[a>>2]|0))}a=f[E>>2]|0;if((a|0)!=(M|0))ZF(a);a=s+36|0;M=f[a>>2]|0;if(M|0?(E=M+12|0,M=f[E>>2]|0,f[E>>2]=M+-1,(M|0)==1):0)CR(s);f[a>>2]=0;a=s+16|0;M=s+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[M>>2]|0)>0){a=f[Q>>2]|0;Q=0;do{f[a+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[M>>2]|0))}M=f[s+44>>2]|0;if((M|0)!=(s+48|0))ZF(M);M=p+36|0;s=f[M>>2]|0;if(s|0?(Q=s+12|0,s=f[Q>>2]|0,f[Q>>2]=s+-1,(s|0)==1):0)CR(p);f[M>>2]=0;M=p+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[M>>2]|0)>0){L=f[p+40>>2]|0;s=0;do{f[L+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[M>>2]|0))}M=f[p+44>>2]|0;if((M|0)!=(p+48|0))ZF(M);if(!(f[o+4>>2]|0)){u=k;return}u=k;return}function fka(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+144|0;h=g+128|0;i=g+72|0;j=g+64|0;k=g+8|0;l=g;_$(h,74384);if(!e){f[i>>2]=0;f[i+4>>2]=0;m=c$(i,29)|0;n=322868;o=m+29|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,i,322898,322906,1342);d$(i)}do if((NS(a)|0)==65536){n=f[a+4>>2]|0;f[i>>2]=f[n>>2];m=i+4|0;o=n+4|0;f[m>>2]=f[o>>2];p=i+8|0;f[p>>2]=f[n+8>>2];f[i+12>>2]=f[n+12>>2];f[i+16>>2]=f[n+16>>2];f[i+20>>2]=f[n+20>>2];f[i+24>>2]=f[n+24>>2];f[i+28>>2]=f[n+28>>2];f[i+32>>2]=f[n+32>>2];q=f[n+36>>2]|0;f[i+36>>2]=q;f[i+40>>2]=p;p=i+48|0;r=i+44|0;f[r>>2]=p;f[p>>2]=0;f[i+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[n+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[m>>2]=0;BR(i,n);break}}else OR(i,a,-1);while(0);a=f[d>>2]|0;n=f[d+4>>2]|0;if(!(Y(n,a)|0)){s=((f[i+12>>2]|0)+1|0)/2|0;t=((f[i+8>>2]|0)+1|0)/2|0}else{s=a;t=n}f[j>>2]=s;f[j+4>>2]=t;KS(c,j,f[i>>2]&4095,-1,0,0);do if((NS(c)|0)==65536){j=f[c+4>>2]|0;f[k>>2]=f[j>>2];t=k+4|0;s=j+4|0;f[t>>2]=f[s>>2];n=k+8|0;f[n>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];f[k+16>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];a=f[j+36>>2]|0;f[k+36>>2]=a;f[k+40>>2]=n;n=k+48|0;d=k+44|0;f[d>>2]=n;f[n>>2]=0;f[k+52>>2]=0;if(a|0){n=a+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[s>>2]|0)<3){s=f[j+44>>2]|0;n=f[d>>2]|0;f[n>>2]=f[s>>2];f[n+4>>2]=f[s+4>>2];break}else{f[t>>2]=0;BR(k,j);break}}else OR(k,c,-1);while(0);switch(f[i>>2]&7){case 0:{v=187;break}case 3:{v=188;break}case 2:{v=189;break}case 5:{v=190;break}case 6:{v=191;break}default:{f[l>>2]=0;f[l+4>>2]=0;j$(-210,l,322898,322906,1381);d$(l)}}fi[v&255](i,k,e);e=k+36|0;v=f[e>>2]|0;if(v|0?(l=v+12|0,v=f[l>>2]|0,f[l>>2]=v+-1,(v|0)==1):0)CR(k);f[e>>2]=0;e=k+16|0;v=k+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[v>>2]|0)>0){e=f[k+40>>2]|0;l=0;do{f[e+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[v>>2]|0))}v=f[k+44>>2]|0;if((v|0)!=(k+48|0))ZF(v);v=i+36|0;k=f[v>>2]|0;if(k|0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)CR(i);f[v>>2]=0;v=i+16|0;k=i+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[k>>2]|0)>0){v=f[i+40>>2]|0;l=0;do{f[v+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[k>>2]|0))}k=f[i+44>>2]|0;if((k|0)!=(i+48|0))ZF(k);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function gka(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;g=u;u=u+30816|0;h=g+29744|0;i=g+15408|0;j=g+1072|0;k=g+8|0;l=g;m=a+16|0;if(f[m>>2]|0){n=f[a+4>>2]|0;if((n|0)<3)o=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{p=f[a+40>>2]|0;q=0;r=1;while(1){s=Y(f[p+(q<<2)>>2]|0,r)|0;q=q+1|0;if((q|0)==(n|0)){o=s;break}else r=s}}if((n|0)==0|(o|0)==0)t=7}else t=7;if((t|0)==7){f[h>>2]=0;f[h+4>>2]=0;t=c$(h,13)|0;o=322959;n=t+13|0;do{b[t>>0]=b[o>>0]|0;t=t+1|0;o=o+1|0}while((t|0)<(n|0));j$(-215,h,322973,322906,858);d$(h)}o=f[a+40>>2]|0;t=f[o+4>>2]|0;n=f[o>>2]|0;o=f[c+40>>2]|0;r=f[o+4>>2]|0;q=f[o>>2]|0;o=(f[a>>2]|0)>>>3;p=(o&511)+1|0;s=Y(p,r)|0;v=s+15&-16;w=(v*5|0)+16|0;x=h+8|0;f[h>>2]=x;y=h+4|0;f[y>>2]=w;if(w>>>0>264){z=OYa(w>>>0>1073741823?-1:w<<2)|0;f[h>>2]=z;A=z}else A=x;z=A+15&-16;A=k+8|0;f[k>>2]=A;w=k+4|0;f[w>>2]=s;if(s>>>0>264){B=OYa(s>>>0>1073741823?-1:s<<2)|0;f[k>>2]=B;C=B}else C=A;if(!(((t|0)>0&(n|0)>0?(B=(r<<1)-t|0,(((B|0)>-1?B:0-B|0)|0)<3):0)?(B=(q<<1)-n|0,(((B|0)>-1?B:0-B|0)|0)<3):0)){f[l>>2]=0;f[l+4>>2]=0;K1a(c$(l,129)|0,322982,129)|0;j$(-215,l,322973,322906,873);d$(l)}l=((t+-3|0)/2|0)+1|0;B=(r|0)<(l|0)?r:l;l=(B<<1)+-2|0;r=0;do{D=Y(lL(r+-2|0,t,e)|0,p)|0;E=Y(lL(l+r|0,t,e)|0,p)|0;F=Y(r,p)|0;G=0;do{H=G+F|0;f[i+(H<<2)>>2]=G+D;f[j+(H<<2)>>2]=G+E;G=G+1|0}while((G|0)!=(p|0));r=r+1|0}while((r|0)<7);r=Y(p,B)|0;B=(s|0)>0;if(B){t=p<<1;l=0;do{G=(Y(t,(l|0)/(p|0)|0)|0)+((l|0)%(p|0)|0)|0;f[C+(l<<2)>>2]=G;l=l+1|0}while((l|0)!=(s|0))}if((q|0)>0){l=c+16|0;t=c+44|0;c=a+44|0;a=o&65535;o=p<<1;G=p*3|0;E=p<<2;D=-2;F=0;while(1){H=(f[l>>2]|0)+(Y(f[f[t>>2]>>2]|0,F)|0)|0;I=F<<1;J=I+2|0;if((D|0)>(J|0))K=D;else{L=D;while(1){M=z+((Y((L+2|0)%5|0,v)|0)<<2)|0;N=lL(L,n,e)|0;O=(f[m>>2]|0)+(Y(f[f[c>>2]>>2]|0,N)|0)|0;N=p;P=i;Q=0;while(1){if((Q|0)<(N|0)){R=Q;do{f[M+(R<<2)>>2]=((d[O+(f[P+(R+G<<2)>>2]<<1)>>1]|0)+(d[O+(f[P+(R+p<<2)>>2]<<1)>>1]|0)<<2)+((d[O+(f[P+(R+o<<2)>>2]<<1)>>1]|0)*6|0)+(d[O+(f[P+(R<<2)>>2]<<1)>>1]|0)+(d[O+(f[P+(R+E<<2)>>2]<<1)>>1]|0);R=R+1|0}while((R|0)!=(N|0));S=N}else S=Q;if((S|0)==(s|0))break;switch(a&511){case 0:{if((S|0)<(r|0)){R=S;do{T=R<<1;f[M+(R<<2)>>2]=(d[O+(T+-2<<1)>>1]|0)+((d[O+(T<<1)>>1]|0)*6|0)+((d[O+((T|1)<<1)>>1]|0)+(d[O+(T+-1<<1)>>1]|0)<<2)+(d[O+(T+2<<1)>>1]|0);R=R+1|0}while((R|0)<(r|0));U=r}else U=S;break}case 2:{if((S|0)<(r|0)){R=S;while(1){T=O+(R<<1<<1)|0;V=(d[T+-10>>1]|0)+((d[T+2>>1]|0)*6|0)+((d[T+8>>1]|0)+(d[T+-4>>1]|0)<<2)+(d[T+14>>1]|0)|0;W=(d[T+-8>>1]|0)+((d[T+4>>1]|0)*6|0)+((d[T+10>>1]|0)+(d[T+-2>>1]|0)<<2)+(d[T+16>>1]|0)|0;f[M+(R<<2)>>2]=(d[T+-12>>1]|0)+((d[T>>1]|0)*6|0)+((d[T+6>>1]|0)+(d[T+-6>>1]|0)<<2)+(d[T+12>>1]|0);f[M+(R+1<<2)>>2]=V;f[M+(R+2<<2)>>2]=W;W=R+3|0;if((W|0)<(r|0))R=W;else{U=W;break}}}else U=S;break}case 3:{if((S|0)<(r|0)){R=S;while(1){W=O+(R<<1<<1)|0;V=(d[W+-14>>1]|0)+((d[W+2>>1]|0)*6|0)+((d[W+10>>1]|0)+(d[W+-6>>1]|0)<<2)+(d[W+18>>1]|0)|0;f[M+(R<<2)>>2]=(d[W+-16>>1]|0)+((d[W>>1]|0)*6|0)+((d[W+8>>1]|0)+(d[W+-8>>1]|0)<<2)+(d[W+16>>1]|0);f[M+(R+1<<2)>>2]=V;V=(d[W+-10>>1]|0)+((d[W+6>>1]|0)*6|0)+((d[W+14>>1]|0)+(d[W+-2>>1]|0)<<2)+(d[W+22>>1]|0)|0;f[M+(R+2<<2)>>2]=(d[W+-12>>1]|0)+((d[W+4>>1]|0)*6|0)+((d[W+12>>1]|0)+(d[W+-4>>1]|0)<<2)+(d[W+20>>1]|0);f[M+(R+3<<2)>>2]=V;V=R+4|0;if((V|0)<(r|0))R=V;else{U=V;break}}}else U=S;break}default:if((S|0)<(r|0)){R=S;do{V=f[C+(R<<2)>>2]|0;f[M+(R<<2)>>2]=(d[O+(V-o<<1)>>1]|0)+((d[O+(V<<1)>>1]|0)*6|0)+((d[O+(V+p<<1)>>1]|0)+(d[O+(V-p<<1)>>1]|0)<<2)+(d[O+(V+o<<1)>>1]|0);R=R+1|0}while((R|0)<(r|0));U=r}else U=S}N=s;P=j+(0-U<<2)|0;Q=U}Q=L+1|0;if((L|0)<(J|0))L=Q;else{K=Q;break}}}L=z+((Y((I|0)%5|0,v)|0)<<2)|0;Q=z+((Y((I|1|0)%5|0,v)|0)<<2)|0;P=z+((Y((J|0)%5|0,v)|0)<<2)|0;N=z+((Y((I+3|0)%5|0,v)|0)<<2)|0;O=z+((Y((I+4|0)%5|0,v)|0)<<2)|0;if(B){M=0;do{d[H+(M<<1)>>1]=(((f[P+(M<<2)>>2]|0)*6|0)+128+(f[L+(M<<2)>>2]|0)+((f[N+(M<<2)>>2]|0)+(f[Q+(M<<2)>>2]|0)<<2)+(f[O+(M<<2)>>2]|0)|0)>>>8;M=M+1|0}while((M|0)!=(s|0))}F=F+1|0;if((F|0)>=(q|0))break;else D=K}}K=f[k>>2]|0;if((K|0)!=(A|0)){if(K|0)QYa(K);f[k>>2]=A;f[w>>2]=264}w=f[h>>2]|0;if((w|0)==(x|0)){u=g;return}if(w|0)QYa(w);f[h>>2]=x;f[y>>2]=264;u=g;return}function hka(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;g=u;u=u+30816|0;h=g+29744|0;i=g+15408|0;k=g+1072|0;l=g+8|0;m=g;n=a+16|0;if(f[n>>2]|0){o=f[a+4>>2]|0;if((o|0)<3)p=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{q=f[a+40>>2]|0;r=0;s=1;while(1){t=Y(f[q+(r<<2)>>2]|0,s)|0;r=r+1|0;if((r|0)==(o|0)){p=t;break}else s=t}}if((o|0)==0|(p|0)==0)v=7}else v=7;if((v|0)==7){f[h>>2]=0;f[h+4>>2]=0;v=c$(h,13)|0;p=322959;o=v+13|0;do{b[v>>0]=b[p>>0]|0;v=v+1|0;p=p+1|0}while((v|0)<(o|0));j$(-215,h,322973,322906,858);d$(h)}p=f[a+40>>2]|0;v=f[p+4>>2]|0;o=f[p>>2]|0;p=f[c+40>>2]|0;s=f[p+4>>2]|0;r=f[p>>2]|0;p=(f[a>>2]|0)>>>3;q=(p&511)+1|0;t=Y(q,s)|0;w=t+15&-16;x=(w*5|0)+16|0;y=h+8|0;f[h>>2]=y;z=h+4|0;f[z>>2]=x;if(x>>>0>264){A=OYa(x>>>0>1073741823?-1:x<<2)|0;f[h>>2]=A;B=A}else B=y;A=B+15&-16;B=l+8|0;f[l>>2]=B;x=l+4|0;f[x>>2]=t;if(t>>>0>264){C=OYa(t>>>0>1073741823?-1:t<<2)|0;f[l>>2]=C;D=C}else D=B;if(!(((v|0)>0&(o|0)>0?(C=(s<<1)-v|0,(((C|0)>-1?C:0-C|0)|0)<3):0)?(C=(r<<1)-o|0,(((C|0)>-1?C:0-C|0)|0)<3):0)){f[m>>2]=0;f[m+4>>2]=0;K1a(c$(m,129)|0,322982,129)|0;j$(-215,m,322973,322906,873);d$(m)}m=((v+-3|0)/2|0)+1|0;C=(s|0)<(m|0)?s:m;m=(C<<1)+-2|0;s=0;do{E=Y(lL(s+-2|0,v,e)|0,q)|0;F=Y(lL(m+s|0,v,e)|0,q)|0;G=Y(s,q)|0;H=0;do{I=H+G|0;f[i+(I<<2)>>2]=H+E;f[k+(I<<2)>>2]=H+F;H=H+1|0}while((H|0)!=(q|0));s=s+1|0}while((s|0)<7);s=Y(q,C)|0;C=(t|0)>0;if(C){v=q<<1;m=0;do{H=(Y(v,(m|0)/(q|0)|0)|0)+((m|0)%(q|0)|0)|0;f[D+(m<<2)>>2]=H;m=m+1|0}while((m|0)!=(t|0))}if((r|0)>0){m=c+16|0;v=c+44|0;c=a+44|0;a=p&65535;p=q<<1;H=q*3|0;F=q<<2;E=-2;G=0;while(1){I=(f[m>>2]|0)+(Y(f[f[v>>2]>>2]|0,G)|0)|0;J=G<<1;K=J+2|0;if((E|0)>(K|0))L=E;else{M=E;while(1){N=A+((Y((M+2|0)%5|0,w)|0)<<2)|0;O=lL(M,o,e)|0;P=(f[n>>2]|0)+(Y(f[f[c>>2]>>2]|0,O)|0)|0;O=q;Q=i;R=0;while(1){if((R|0)<(O|0)){S=R;do{f[N+(S<<2)>>2]=((j[P+(f[Q+(S+H<<2)>>2]<<1)>>1]|0)+(j[P+(f[Q+(S+q<<2)>>2]<<1)>>1]|0)<<2)+((j[P+(f[Q+(S+p<<2)>>2]<<1)>>1]|0)*6|0)+(j[P+(f[Q+(S<<2)>>2]<<1)>>1]|0)+(j[P+(f[Q+(S+F<<2)>>2]<<1)>>1]|0);S=S+1|0}while((S|0)!=(O|0));T=O}else T=R;if((T|0)==(t|0))break;switch(a&511){case 0:{if((T|0)<(s|0)){S=T;do{U=S<<1;f[N+(S<<2)>>2]=(j[P+(U+-2<<1)>>1]|0)+((j[P+(U<<1)>>1]|0)*6|0)+((j[P+((U|1)<<1)>>1]|0)+(j[P+(U+-1<<1)>>1]|0)<<2)+(j[P+(U+2<<1)>>1]|0);S=S+1|0}while((S|0)<(s|0));V=s}else V=T;break}case 2:{if((T|0)<(s|0)){S=T;while(1){U=P+(S<<1<<1)|0;W=(j[U+-10>>1]|0)+((j[U+2>>1]|0)*6|0)+((j[U+8>>1]|0)+(j[U+-4>>1]|0)<<2)+(j[U+14>>1]|0)|0;X=(j[U+-8>>1]|0)+((j[U+4>>1]|0)*6|0)+((j[U+10>>1]|0)+(j[U+-2>>1]|0)<<2)+(j[U+16>>1]|0)|0;f[N+(S<<2)>>2]=(j[U+-12>>1]|0)+((j[U>>1]|0)*6|0)+((j[U+6>>1]|0)+(j[U+-6>>1]|0)<<2)+(j[U+12>>1]|0);f[N+(S+1<<2)>>2]=W;f[N+(S+2<<2)>>2]=X;X=S+3|0;if((X|0)<(s|0))S=X;else{V=X;break}}}else V=T;break}case 3:{if((T|0)<(s|0)){S=T;while(1){X=P+(S<<1<<1)|0;W=(j[X+-14>>1]|0)+((j[X+2>>1]|0)*6|0)+((j[X+10>>1]|0)+(j[X+-6>>1]|0)<<2)+(j[X+18>>1]|0)|0;f[N+(S<<2)>>2]=(j[X+-16>>1]|0)+((j[X>>1]|0)*6|0)+((j[X+8>>1]|0)+(j[X+-8>>1]|0)<<2)+(j[X+16>>1]|0);f[N+(S+1<<2)>>2]=W;W=(j[X+-10>>1]|0)+((j[X+6>>1]|0)*6|0)+((j[X+14>>1]|0)+(j[X+-2>>1]|0)<<2)+(j[X+22>>1]|0)|0;f[N+(S+2<<2)>>2]=(j[X+-12>>1]|0)+((j[X+4>>1]|0)*6|0)+((j[X+12>>1]|0)+(j[X+-4>>1]|0)<<2)+(j[X+20>>1]|0);f[N+(S+3<<2)>>2]=W;W=S+4|0;if((W|0)<(s|0))S=W;else{V=W;break}}}else V=T;break}default:if((T|0)<(s|0)){S=T;do{W=f[D+(S<<2)>>2]|0;f[N+(S<<2)>>2]=(j[P+(W-p<<1)>>1]|0)+((j[P+(W<<1)>>1]|0)*6|0)+((j[P+(W+q<<1)>>1]|0)+(j[P+(W-q<<1)>>1]|0)<<2)+(j[P+(W+p<<1)>>1]|0);S=S+1|0}while((S|0)<(s|0));V=s}else V=T}O=t;Q=k+(0-V<<2)|0;R=V}R=M+1|0;if((M|0)<(K|0))M=R;else{L=R;break}}}M=A+((Y((J|0)%5|0,w)|0)<<2)|0;R=A+((Y((J|1|0)%5|0,w)|0)<<2)|0;Q=A+((Y((K|0)%5|0,w)|0)<<2)|0;O=A+((Y((J+3|0)%5|0,w)|0)<<2)|0;P=A+((Y((J+4|0)%5|0,w)|0)<<2)|0;if(C){N=0;do{d[I+(N<<1)>>1]=(((f[Q+(N<<2)>>2]|0)*6|0)+128+(f[M+(N<<2)>>2]|0)+((f[O+(N<<2)>>2]|0)+(f[R+(N<<2)>>2]|0)<<2)+(f[P+(N<<2)>>2]|0)|0)>>>8;N=N+1|0}while((N|0)!=(t|0))}G=G+1|0;if((G|0)>=(r|0))break;else E=L}}L=f[l>>2]|0;if((L|0)!=(B|0)){if(L|0)QYa(L);f[l>>2]=B;f[x>>2]=264}x=f[h>>2]|0;if((x|0)==(y|0)){u=g;return}if(x|0)QYa(x);f[h>>2]=y;f[z>>2]=264;u=g;return}function ika(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0.0;e=u;u=u+30816|0;g=e+29744|0;h=e+15408|0;i=e+1072|0;j=e+8|0;k=e;l=a+16|0;if(f[l>>2]|0){m=f[a+4>>2]|0;if((m|0)<3)o=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{p=f[a+40>>2]|0;q=0;r=1;while(1){s=Y(f[p+(q<<2)>>2]|0,r)|0;q=q+1|0;if((q|0)==(m|0)){o=s;break}else r=s}}if((m|0)==0|(o|0)==0)t=7}else t=7;if((t|0)==7){f[g>>2]=0;f[g+4>>2]=0;t=c$(g,13)|0;o=322959;m=t+13|0;do{b[t>>0]=b[o>>0]|0;t=t+1|0;o=o+1|0}while((t|0)<(m|0));j$(-215,g,322973,322906,858);d$(g)}o=f[a+40>>2]|0;t=f[o+4>>2]|0;m=f[o>>2]|0;o=f[c+40>>2]|0;r=f[o+4>>2]|0;q=f[o>>2]|0;o=(f[a>>2]|0)>>>3;p=(o&511)+1|0;s=Y(p,r)|0;v=s+15&-16;w=(v*5|0)+16|0;x=g+8|0;f[g>>2]=x;y=g+4|0;f[y>>2]=w;if(w>>>0>264){z=OYa(w>>>0>1073741823?-1:w<<2)|0;f[g>>2]=z;A=z}else A=x;z=A+15&-16;A=j+8|0;f[j>>2]=A;w=j+4|0;f[w>>2]=s;if(s>>>0>264){B=OYa(s>>>0>1073741823?-1:s<<2)|0;f[j>>2]=B;C=B}else C=A;if(!(((t|0)>0&(m|0)>0?(B=(r<<1)-t|0,(((B|0)>-1?B:0-B|0)|0)<3):0)?(B=(q<<1)-m|0,(((B|0)>-1?B:0-B|0)|0)<3):0)){f[k>>2]=0;f[k+4>>2]=0;K1a(c$(k,129)|0,322982,129)|0;j$(-215,k,322973,322906,873);d$(k)}k=((t+-3|0)/2|0)+1|0;B=(r|0)<(k|0)?r:k;k=(B<<1)+-2|0;r=0;do{D=Y(lL(r+-2|0,t,d)|0,p)|0;E=Y(lL(k+r|0,t,d)|0,p)|0;F=Y(r,p)|0;G=0;do{H=G+F|0;f[h+(H<<2)>>2]=G+D;f[i+(H<<2)>>2]=G+E;G=G+1|0}while((G|0)!=(p|0));r=r+1|0}while((r|0)<7);r=Y(p,B)|0;B=(s|0)>0;if(B){t=p<<1;k=0;do{G=(Y(t,(k|0)/(p|0)|0)|0)+((k|0)%(p|0)|0)|0;f[C+(k<<2)>>2]=G;k=k+1|0}while((k|0)!=(s|0))}if((q|0)>0){k=c+16|0;t=c+44|0;c=a+44|0;a=o&65535;o=p<<1;G=p*3|0;E=p<<2;D=-2;F=0;while(1){H=(f[k>>2]|0)+(Y(f[f[t>>2]>>2]|0,F)|0)|0;I=F<<1;J=I+2|0;if((D|0)>(J|0))K=D;else{L=D;while(1){M=z+((Y((L+2|0)%5|0,v)|0)<<2)|0;N=lL(L,m,d)|0;O=(f[l>>2]|0)+(Y(f[f[c>>2]>>2]|0,N)|0)|0;N=p;P=h;Q=0;while(1){if((Q|0)<(N|0)){R=Q;do{n[M+(R<<2)>>2]=+n[O+(f[P+(R<<2)>>2]<<2)>>2]+(+n[O+(f[P+(R+o<<2)>>2]<<2)>>2]*6.0+(+n[O+(f[P+(R+p<<2)>>2]<<2)>>2]+ +n[O+(f[P+(R+G<<2)>>2]<<2)>>2])*4.0)+ +n[O+(f[P+(R+E<<2)>>2]<<2)>>2];R=R+1|0}while((R|0)!=(N|0));S=N}else S=Q;if((S|0)==(s|0))break;switch(a&511){case 0:{if((S|0)<(r|0)){R=S;do{T=R<<1;n[M+(R<<2)>>2]=+n[O+(T+2<<2)>>2]+(+n[O+(T+-2<<2)>>2]+(+n[O+(T<<2)>>2]*6.0+(+n[O+(T+-1<<2)>>2]+ +n[O+((T|1)<<2)>>2])*4.0));R=R+1|0}while((R|0)<(r|0));U=r}else U=S;break}case 2:{if((S|0)<(r|0)){R=S;while(1){T=O+(R<<1<<2)|0;V=+n[T+28>>2]+(+n[T+-20>>2]+(+n[T+4>>2]*6.0+(+n[T+-8>>2]+ +n[T+16>>2])*4.0));W=+n[T+32>>2]+(+n[T+-16>>2]+(+n[T+8>>2]*6.0+(+n[T+-4>>2]+ +n[T+20>>2])*4.0));n[M+(R<<2)>>2]=+n[T+24>>2]+(+n[T+-24>>2]+(+n[T>>2]*6.0+(+n[T+-12>>2]+ +n[T+12>>2])*4.0));n[M+(R+1<<2)>>2]=V;n[M+(R+2<<2)>>2]=W;T=R+3|0;if((T|0)<(r|0))R=T;else{U=T;break}}}else U=S;break}case 3:{if((S|0)<(r|0)){R=S;while(1){T=O+(R<<1<<2)|0;W=+n[T+36>>2]+(+n[T+-28>>2]+(+n[T+4>>2]*6.0+(+n[T+-12>>2]+ +n[T+20>>2])*4.0));n[M+(R<<2)>>2]=+n[T+32>>2]+(+n[T+-32>>2]+(+n[T>>2]*6.0+(+n[T+-16>>2]+ +n[T+16>>2])*4.0));n[M+(R+1<<2)>>2]=W;W=+n[T+44>>2]+(+n[T+-20>>2]+(+n[T+12>>2]*6.0+(+n[T+-4>>2]+ +n[T+28>>2])*4.0));n[M+(R+2<<2)>>2]=+n[T+40>>2]+(+n[T+-24>>2]+(+n[T+8>>2]*6.0+(+n[T+-8>>2]+ +n[T+24>>2])*4.0));n[M+(R+3<<2)>>2]=W;T=R+4|0;if((T|0)<(r|0))R=T;else{U=T;break}}}else U=S;break}default:if((S|0)<(r|0)){R=S;do{T=f[C+(R<<2)>>2]|0;n[M+(R<<2)>>2]=+n[O+(T+o<<2)>>2]+(+n[O+(T-o<<2)>>2]+(+n[O+(T<<2)>>2]*6.0+(+n[O+(T-p<<2)>>2]+ +n[O+(T+p<<2)>>2])*4.0));R=R+1|0}while((R|0)<(r|0));U=r}else U=S}N=s;P=i+(0-U<<2)|0;Q=U}Q=L+1|0;if((L|0)<(J|0))L=Q;else{K=Q;break}}}L=z+((Y((I|0)%5|0,v)|0)<<2)|0;Q=z+((Y((I|1|0)%5|0,v)|0)<<2)|0;P=z+((Y((J|0)%5|0,v)|0)<<2)|0;N=z+((Y((I+3|0)%5|0,v)|0)<<2)|0;O=z+((Y((I+4|0)%5|0,v)|0)<<2)|0;if(B){M=0;do{n[H+(M<<2)>>2]=(+n[O+(M<<2)>>2]+(+n[L+(M<<2)>>2]+(+n[P+(M<<2)>>2]*6.0+(+n[Q+(M<<2)>>2]+ +n[N+(M<<2)>>2])*4.0)))*.00390625;M=M+1|0}while((M|0)!=(s|0))}F=F+1|0;if((F|0)>=(q|0))break;else D=K}}K=f[j>>2]|0;if((K|0)!=(A|0)){if(K|0)QYa(K);f[j>>2]=A;f[w>>2]=264}w=f[g>>2]|0;if((w|0)==(x|0)){u=e;return}if(w|0)QYa(w);f[g>>2]=x;f[y>>2]=264;u=e;return}function jka(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0.0;e=u;u=u+30848|0;g=e;h=e+16504|0;i=e+2168|0;j=e+1104|0;k=e+1096|0;l=a+16|0;if(f[l>>2]|0){m=f[a+4>>2]|0;if((m|0)<3)n=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{o=f[a+40>>2]|0;q=0;r=1;while(1){s=Y(f[o+(q<<2)>>2]|0,r)|0;q=q+1|0;if((q|0)==(m|0)){n=s;break}else r=s}}if((m|0)==0|(n|0)==0)t=7}else t=7;if((t|0)==7){f[g>>2]=0;f[g+4>>2]=0;t=c$(g,13)|0;n=322959;m=t+13|0;do{b[t>>0]=b[n>>0]|0;t=t+1|0;n=n+1|0}while((t|0)<(m|0));j$(-215,g,322973,322906,858);d$(g)}n=f[a+40>>2]|0;t=f[n+4>>2]|0;m=f[n>>2]|0;n=f[c+40>>2]|0;r=f[n+4>>2]|0;q=f[n>>2]|0;n=(f[a>>2]|0)>>>3;o=(n&511)+1|0;s=Y(o,r)|0;v=s+15&-16;w=(v*5|0)+16|0;x=g+8|0;f[g>>2]=x;y=g+4|0;f[y>>2]=w;if(w>>>0>136){z=OYa(w>>>0>536870911?-1:w<<3)|0;f[g>>2]=z;A=z}else A=x;z=A+15&-16;A=j+8|0;f[j>>2]=A;w=j+4|0;f[w>>2]=s;if(s>>>0>264){B=OYa(s>>>0>1073741823?-1:s<<2)|0;f[j>>2]=B;C=B}else C=A;if(!(((t|0)>0&(m|0)>0?(B=(r<<1)-t|0,(((B|0)>-1?B:0-B|0)|0)<3):0)?(B=(q<<1)-m|0,(((B|0)>-1?B:0-B|0)|0)<3):0)){f[k>>2]=0;f[k+4>>2]=0;K1a(c$(k,129)|0,322982,129)|0;j$(-215,k,322973,322906,873);d$(k)}k=((t+-3|0)/2|0)+1|0;B=(r|0)<(k|0)?r:k;k=(B<<1)+-2|0;r=0;do{D=Y(lL(r+-2|0,t,d)|0,o)|0;E=Y(lL(k+r|0,t,d)|0,o)|0;F=Y(r,o)|0;G=0;do{H=G+F|0;f[h+(H<<2)>>2]=G+D;f[i+(H<<2)>>2]=G+E;G=G+1|0}while((G|0)!=(o|0));r=r+1|0}while((r|0)<7);r=Y(o,B)|0;B=(s|0)>0;if(B){t=o<<1;k=0;do{G=(Y(t,(k|0)/(o|0)|0)|0)+((k|0)%(o|0)|0)|0;f[C+(k<<2)>>2]=G;k=k+1|0}while((k|0)!=(s|0))}if((q|0)>0){k=c+16|0;t=c+44|0;c=a+44|0;a=n&65535;n=o<<1;G=o*3|0;E=o<<2;D=-2;F=0;while(1){H=(f[k>>2]|0)+(Y(f[f[t>>2]>>2]|0,F)|0)|0;I=F<<1;J=I+2|0;if((D|0)>(J|0))K=D;else{L=D;while(1){M=z+((Y((L+2|0)%5|0,v)|0)<<3)|0;N=lL(L,m,d)|0;O=(f[l>>2]|0)+(Y(f[f[c>>2]>>2]|0,N)|0)|0;N=o;P=h;Q=0;while(1){if((Q|0)<(N|0)){R=Q;do{p[M+(R<<3)>>3]=+p[O+(f[P+(R<<2)>>2]<<3)>>3]+(+p[O+(f[P+(R+n<<2)>>2]<<3)>>3]*6.0+(+p[O+(f[P+(R+o<<2)>>2]<<3)>>3]+ +p[O+(f[P+(R+G<<2)>>2]<<3)>>3])*4.0)+ +p[O+(f[P+(R+E<<2)>>2]<<3)>>3];R=R+1|0}while((R|0)!=(N|0));S=N}else S=Q;if((S|0)==(s|0))break;switch(a&511){case 0:{if((S|0)<(r|0)){R=S;do{T=R<<1;p[M+(R<<3)>>3]=+p[O+(T+2<<3)>>3]+(+p[O+(T+-2<<3)>>3]+(+p[O+(T<<3)>>3]*6.0+(+p[O+(T+-1<<3)>>3]+ +p[O+((T|1)<<3)>>3])*4.0));R=R+1|0}while((R|0)<(r|0));U=r}else U=S;break}case 2:{if((S|0)<(r|0)){R=S;while(1){T=O+(R<<1<<3)|0;V=+p[T+56>>3]+(+p[T+-40>>3]+(+p[T+8>>3]*6.0+(+p[T+-16>>3]+ +p[T+32>>3])*4.0));W=+p[T+64>>3]+(+p[T+-32>>3]+(+p[T+16>>3]*6.0+(+p[T+-8>>3]+ +p[T+40>>3])*4.0));p[M+(R<<3)>>3]=+p[T+48>>3]+(+p[T+-48>>3]+(+p[T>>3]*6.0+(+p[T+-24>>3]+ +p[T+24>>3])*4.0));p[M+(R+1<<3)>>3]=V;p[M+(R+2<<3)>>3]=W;T=R+3|0;if((T|0)<(r|0))R=T;else{U=T;break}}}else U=S;break}case 3:{if((S|0)<(r|0)){R=S;while(1){T=O+(R<<1<<3)|0;W=+p[T+72>>3]+(+p[T+-56>>3]+(+p[T+8>>3]*6.0+(+p[T+-24>>3]+ +p[T+40>>3])*4.0));p[M+(R<<3)>>3]=+p[T+64>>3]+(+p[T+-64>>3]+(+p[T>>3]*6.0+(+p[T+-32>>3]+ +p[T+32>>3])*4.0));p[M+(R+1<<3)>>3]=W;W=+p[T+88>>3]+(+p[T+-40>>3]+(+p[T+24>>3]*6.0+(+p[T+-8>>3]+ +p[T+56>>3])*4.0));p[M+(R+2<<3)>>3]=+p[T+80>>3]+(+p[T+-48>>3]+(+p[T+16>>3]*6.0+(+p[T+-16>>3]+ +p[T+48>>3])*4.0));p[M+(R+3<<3)>>3]=W;T=R+4|0;if((T|0)<(r|0))R=T;else{U=T;break}}}else U=S;break}default:if((S|0)<(r|0)){R=S;do{T=f[C+(R<<2)>>2]|0;p[M+(R<<3)>>3]=+p[O+(T+n<<3)>>3]+(+p[O+(T-n<<3)>>3]+(+p[O+(T<<3)>>3]*6.0+(+p[O+(T-o<<3)>>3]+ +p[O+(T+o<<3)>>3])*4.0));R=R+1|0}while((R|0)<(r|0));U=r}else U=S}N=s;P=i+(0-U<<2)|0;Q=U}Q=L+1|0;if((L|0)<(J|0))L=Q;else{K=Q;break}}}L=z+((Y((I|0)%5|0,v)|0)<<3)|0;Q=z+((Y((I|1|0)%5|0,v)|0)<<3)|0;P=z+((Y((J|0)%5|0,v)|0)<<3)|0;N=z+((Y((I+3|0)%5|0,v)|0)<<3)|0;O=z+((Y((I+4|0)%5|0,v)|0)<<3)|0;if(B){M=0;do{p[H+(M<<3)>>3]=(+p[O+(M<<3)>>3]+(+p[L+(M<<3)>>3]+(+p[P+(M<<3)>>3]*6.0+(+p[Q+(M<<3)>>3]+ +p[N+(M<<3)>>3])*4.0)))*.00390625;M=M+1|0}while((M|0)!=(s|0))}F=F+1|0;if((F|0)>=(q|0))break;else D=K}}K=f[j>>2]|0;if((K|0)!=(A|0)){if(K|0)QYa(K);f[j>>2]=A;f[w>>2]=264}w=f[g>>2]|0;if((w|0)==(x|0)){u=e;return}if(w|0)QYa(w);f[g>>2]=x;f[y>>2]=136;u=e;return}function kka(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;e=u;u=u+30816|0;g=e+29744|0;i=e+15408|0;j=e+1072|0;k=e+8|0;l=e;m=a+16|0;if(f[m>>2]|0){n=f[a+4>>2]|0;if((n|0)<3)o=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{p=f[a+40>>2]|0;q=0;r=1;while(1){s=Y(f[p+(q<<2)>>2]|0,r)|0;q=q+1|0;if((q|0)==(n|0)){o=s;break}else r=s}}if((n|0)==0|(o|0)==0)t=7}else t=7;if((t|0)==7){f[g>>2]=0;f[g+4>>2]=0;t=c$(g,13)|0;o=322959;n=t+13|0;do{b[t>>0]=b[o>>0]|0;t=t+1|0;o=o+1|0}while((t|0)<(n|0));j$(-215,g,322973,322906,858);d$(g)}o=f[a+40>>2]|0;t=f[o+4>>2]|0;n=f[o>>2]|0;o=f[c+40>>2]|0;r=f[o+4>>2]|0;q=f[o>>2]|0;o=(f[a>>2]|0)>>>3;p=(o&511)+1|0;s=Y(p,r)|0;v=s+15&-16;w=(v*5|0)+16|0;x=g+8|0;f[g>>2]=x;y=g+4|0;f[y>>2]=w;if(w>>>0>264){z=OYa(w>>>0>1073741823?-1:w<<2)|0;f[g>>2]=z;A=z}else A=x;z=A+15&-16;A=k+8|0;f[k>>2]=A;w=k+4|0;f[w>>2]=s;if(s>>>0>264){B=OYa(s>>>0>1073741823?-1:s<<2)|0;f[k>>2]=B;C=B}else C=A;if(!(((t|0)>0&(n|0)>0?(B=(r<<1)-t|0,(((B|0)>-1?B:0-B|0)|0)<3):0)?(B=(q<<1)-n|0,(((B|0)>-1?B:0-B|0)|0)<3):0)){f[l>>2]=0;f[l+4>>2]=0;K1a(c$(l,129)|0,322982,129)|0;j$(-215,l,322973,322906,873);d$(l)}l=((t+-3|0)/2|0)+1|0;B=(r|0)<(l|0)?r:l;l=(B<<1)+-2|0;r=0;do{D=Y(lL(r+-2|0,t,d)|0,p)|0;E=Y(lL(l+r|0,t,d)|0,p)|0;F=Y(r,p)|0;G=0;do{H=G+F|0;f[i+(H<<2)>>2]=G+D;f[j+(H<<2)>>2]=G+E;G=G+1|0}while((G|0)!=(p|0));r=r+1|0}while((r|0)<7);r=Y(p,B)|0;B=(s|0)>0;if(B){t=p<<1;l=0;do{G=(Y(t,(l|0)/(p|0)|0)|0)+((l|0)%(p|0)|0)|0;f[C+(l<<2)>>2]=G;l=l+1|0}while((l|0)!=(s|0))}if((q|0)>0){l=c+16|0;t=c+44|0;c=a+44|0;a=o&65535;o=p<<1;G=p*3|0;E=p<<2;D=-2;F=0;while(1){H=(f[l>>2]|0)+(Y(f[f[t>>2]>>2]|0,F)|0)|0;I=F<<1;J=I+2|0;if((D|0)>(J|0))K=D;else{L=D;while(1){M=z+((Y((L+2|0)%5|0,v)|0)<<2)|0;N=lL(L,n,d)|0;O=(f[m>>2]|0)+(Y(f[f[c>>2]>>2]|0,N)|0)|0;N=p;P=i;Q=0;while(1){if((Q|0)<(N|0)){R=Q;do{f[M+(R<<2)>>2]=((h[O+(f[P+(R+G<<2)>>2]|0)>>0]|0)+(h[O+(f[P+(R+p<<2)>>2]|0)>>0]|0)<<2)+((h[O+(f[P+(R+o<<2)>>2]|0)>>0]|0)*6|0)+(h[O+(f[P+(R<<2)>>2]|0)>>0]|0)+(h[O+(f[P+(R+E<<2)>>2]|0)>>0]|0);R=R+1|0}while((R|0)!=(N|0));S=N}else S=Q;if((S|0)==(s|0))break;switch(a&511){case 0:{if((S|0)<(r|0)){R=S;do{T=R<<1;f[M+(R<<2)>>2]=(h[O+(T+-2)>>0]|0)+((h[O+T>>0]|0)*6|0)+((h[O+(T|1)>>0]|0)+(h[O+(T+-1)>>0]|0)<<2)+(h[O+(T+2)>>0]|0);R=R+1|0}while((R|0)<(r|0));U=r}else U=S;break}case 2:{if((S|0)<(r|0)){R=S;while(1){T=O+(R<<1)|0;V=(h[T+-5>>0]|0)+((h[T+1>>0]|0)*6|0)+((h[T+4>>0]|0)+(h[T+-2>>0]|0)<<2)+(h[T+7>>0]|0)|0;W=(h[T+-4>>0]|0)+((h[T+2>>0]|0)*6|0)+((h[T+5>>0]|0)+(h[T+-1>>0]|0)<<2)+(h[T+8>>0]|0)|0;f[M+(R<<2)>>2]=(h[T+-6>>0]|0)+((h[T>>0]|0)*6|0)+((h[T+3>>0]|0)+(h[T+-3>>0]|0)<<2)+(h[T+6>>0]|0);f[M+(R+1<<2)>>2]=V;f[M+(R+2<<2)>>2]=W;W=R+3|0;if((W|0)<(r|0))R=W;else{U=W;break}}}else U=S;break}case 3:{if((S|0)<(r|0)){R=S;while(1){W=O+(R<<1)|0;V=(h[W+-7>>0]|0)+((h[W+1>>0]|0)*6|0)+((h[W+5>>0]|0)+(h[W+-3>>0]|0)<<2)+(h[W+9>>0]|0)|0;f[M+(R<<2)>>2]=(h[W+-8>>0]|0)+((h[W>>0]|0)*6|0)+((h[W+4>>0]|0)+(h[W+-4>>0]|0)<<2)+(h[W+8>>0]|0);f[M+(R+1<<2)>>2]=V;V=(h[W+-5>>0]|0)+((h[W+3>>0]|0)*6|0)+((h[W+7>>0]|0)+(h[W+-1>>0]|0)<<2)+(h[W+11>>0]|0)|0;f[M+(R+2<<2)>>2]=(h[W+-6>>0]|0)+((h[W+2>>0]|0)*6|0)+((h[W+6>>0]|0)+(h[W+-2>>0]|0)<<2)+(h[W+10>>0]|0);f[M+(R+3<<2)>>2]=V;V=R+4|0;if((V|0)<(r|0))R=V;else{U=V;break}}}else U=S;break}default:if((S|0)<(r|0)){R=S;do{V=f[C+(R<<2)>>2]|0;f[M+(R<<2)>>2]=(h[O+(V-o)>>0]|0)+((h[O+V>>0]|0)*6|0)+((h[O+(V+p)>>0]|0)+(h[O+(V-p)>>0]|0)<<2)+(h[O+(V+o)>>0]|0);R=R+1|0}while((R|0)<(r|0));U=r}else U=S}N=s;P=j+(0-U<<2)|0;Q=U}Q=L+1|0;if((L|0)<(J|0))L=Q;else{K=Q;break}}}L=z+((Y((I|0)%5|0,v)|0)<<2)|0;Q=z+((Y((I|1|0)%5|0,v)|0)<<2)|0;P=z+((Y((J|0)%5|0,v)|0)<<2)|0;N=z+((Y((I+3|0)%5|0,v)|0)<<2)|0;O=z+((Y((I+4|0)%5|0,v)|0)<<2)|0;if(B){M=0;do{b[H+M>>0]=(((f[P+(M<<2)>>2]|0)*6|0)+128+(f[L+(M<<2)>>2]|0)+((f[N+(M<<2)>>2]|0)+(f[Q+(M<<2)>>2]|0)<<2)+(f[O+(M<<2)>>2]|0)|0)>>>8;M=M+1|0}while((M|0)!=(s|0))}F=F+1|0;if((F|0)>=(q|0))break;else D=K}}K=f[k>>2]|0;if((K|0)!=(A|0)){if(K|0)QYa(K);f[k>>2]=A;f[w>>2]=264}w=f[g>>2]|0;if((w|0)==(x|0)){u=e;return}if(w|0)QYa(w);f[g>>2]=x;f[y>>2]=264;u=e;return}function lka(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+144|0;h=g+128|0;i=g+72|0;j=g+64|0;k=g+8|0;l=g;_$(h,74404);if((e|0)!=4){f[i>>2]=0;f[i+4>>2]=0;m=c$(i,28)|0;n=323173;o=m+28|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,i,323202,322906,1452);d$(i)}do if((NS(a)|0)==65536){n=f[a+4>>2]|0;f[i>>2]=f[n>>2];m=i+4|0;o=n+4|0;f[m>>2]=f[o>>2];p=i+8|0;f[p>>2]=f[n+8>>2];f[i+12>>2]=f[n+12>>2];f[i+16>>2]=f[n+16>>2];f[i+20>>2]=f[n+20>>2];f[i+24>>2]=f[n+24>>2];f[i+28>>2]=f[n+28>>2];f[i+32>>2]=f[n+32>>2];q=f[n+36>>2]|0;f[i+36>>2]=q;f[i+40>>2]=p;p=i+48|0;r=i+44|0;f[r>>2]=p;f[p>>2]=0;f[i+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[n+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[m>>2]=0;BR(i,n);break}}else OR(i,a,-1);while(0);a=f[d>>2]|0;n=f[d+4>>2]|0;if(!(Y(n,a)|0)){s=f[i+12>>2]<<1;t=f[i+8>>2]<<1}else{s=a;t=n}f[j>>2]=s;f[j+4>>2]=t;KS(c,j,f[i>>2]&4095,-1,0,0);do if((NS(c)|0)==65536){j=f[c+4>>2]|0;f[k>>2]=f[j>>2];t=k+4|0;s=j+4|0;f[t>>2]=f[s>>2];n=k+8|0;f[n>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];f[k+16>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];a=f[j+36>>2]|0;f[k+36>>2]=a;f[k+40>>2]=n;n=k+48|0;d=k+44|0;f[d>>2]=n;f[n>>2]=0;f[k+52>>2]=0;if(a|0){n=a+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[s>>2]|0)<3){s=f[j+44>>2]|0;n=f[d>>2]|0;f[n>>2]=f[s>>2];f[n+4>>2]=f[s+4>>2];break}else{f[t>>2]=0;BR(k,j);break}}else OR(k,c,-1);while(0);switch(f[i>>2]&7){case 0:{v=192;break}case 3:{v=193;break}case 2:{v=194;break}case 5:{v=195;break}case 6:{v=196;break}default:{f[l>>2]=0;f[l+4>>2]=0;j$(-210,l,323202,322906,1489);d$(l)}}fi[v&255](i,k,e);e=k+36|0;v=f[e>>2]|0;if(v|0?(l=v+12|0,v=f[l>>2]|0,f[l>>2]=v+-1,(v|0)==1):0)CR(k);f[e>>2]=0;e=k+16|0;v=k+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[v>>2]|0)>0){e=f[k+40>>2]|0;l=0;do{f[e+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[v>>2]|0))}v=f[k+44>>2]|0;if((v|0)!=(k+48|0))ZF(v);v=i+36|0;k=f[v>>2]|0;if(k|0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)CR(i);f[v>>2]=0;v=i+16|0;k=i+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[k>>2]|0)>0){v=f[i+40>>2]|0;l=0;do{f[v+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[k>>2]|0))}k=f[i+44>>2]|0;if((k|0)!=(i+48|0))ZF(k);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function mka(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=u;u=u+2144|0;g=e+1072|0;h=e+8|0;i=e;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[c+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=((f[a>>2]|0)>>>3&511)+1|0;o=(Y(j,m+1|0)|0)+15&-16;p=(o*3|0)+16|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=OYa(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=t+15&-16;t=Y(j,k)|0;p=h+8|0;f[h>>2]=p;v=h+4|0;f[v>>2]=t;if(t>>>0>264){w=OYa(t>>>0>1073741823?-1:t<<2)|0;f[h>>2]=w;x=w}else x=p;w=m-(k<<1)|0;if(!((((w|0)>-1?w:0-w|0)|0)==((m|0)%2|0|0)?(w=n-(l<<1)|0,(((w|0)>-1?w:0-w|0)|0)==((n|0)%2|0|0)):0)){f[i>>2]=0;f[i+4>>2]=0;w=c$(i,119)|0;k=323208;y=w+119|0;do{b[w>>0]=b[k>>0]|0;w=w+1|0;k=k+1|0}while((w|0)<(y|0));j$(-215,i,323328,322906,996);d$(i)}i=Y(j,m)|0;if((t|0)>0){m=j<<1;k=0;do{w=(Y(m,(k|0)/(j|0)|0)|0)+((k|0)%(j|0)|0)|0;f[x+(k<<2)>>2]=w;k=k+1|0}while((k|0)!=(t|0))}if((l|0)>0){k=c+16|0;m=c+44|0;w=n+-1|0;y=(i|0)>0;z=l<<1;A=a+16|0;B=a+44|0;a=(t|0)==(j|0);C=t-j|0;D=(i|0)>(t<<1|0);t=c+12|0;E=(j|0)<(C|0);F=-1;G=0;while(1){H=G<<1;I=f[k>>2]|0;J=f[f[m>>2]>>2]|0;K=I+(Y(J,H)|0)|0;L=H|1;H=I+(Y(J,(w|0)<(L|0)?w:L)|0)|0;L=G;G=G+1|0;if((F|0)>(G|0))M=F;else{J=F;while(1){I=J+1|0;N=s+((Y((I|0)%3|0,o)|0)<<2)|0;O=(lL(J<<1,z,4)|0)/2|0;P=(f[A>>2]|0)+(Y(f[f[B>>2]>>2]|0,O)|0)|0;if(!a){if(D){O=0;do{Q=f[x+(O<<2)>>2]|0;R=d[P+(O<<1)>>1]|0;S=d[P+(O+j<<1)>>1]|0;f[N+(Q<<2)>>2]=(S<<1)+(R*6|0);f[N+(Q+j<<2)>>2]=S+R<<2;R=O+C|0;S=f[x+(R<<2)>>2]|0;Q=d[P+(R<<1)>>1]|0;T=Q<<3;f[N+(S<<2)>>2]=(Q*7|0)+(d[P+(R-j<<1)>>1]|0);f[N+(S+j<<2)>>2]=T;f[N+(O+-1+(f[t>>2]|0)<<2)>>2]=T;O=O+1|0}while((O|0)!=(j|0))}else{O=0;do{T=f[x+(O<<2)>>2]|0;S=d[P+(O<<1)>>1]|0;R=d[P+(O+j<<1)>>1]|0;f[N+(T<<2)>>2]=(R<<1)+(S*6|0);f[N+(T+j<<2)>>2]=R+S<<2;S=O+C|0;R=f[x+(S<<2)>>2]|0;T=d[P+(S<<1)>>1]|0;f[N+(R<<2)>>2]=(T*7|0)+(d[P+(S-j<<1)>>1]|0);f[N+(R+j<<2)>>2]=T<<3;O=O+1|0}while((O|0)!=(j|0))}if(E){O=j;do{T=f[x+(O<<2)>>2]|0;R=d[P+(O<<1)>>1]|0;S=d[P+(O+j<<1)>>1]|0;f[N+(T<<2)>>2]=(R*6|0)+(d[P+(O-j<<1)>>1]|0)+S;f[N+(T+j<<2)>>2]=S+R<<2;O=O+1|0}while((O|0)!=(C|0))}}else{O=0;do{R=d[P+(O<<1)>>1]<<3;f[N+(O+j<<2)>>2]=R;f[N+(O<<2)>>2]=R;O=O+1|0}while((O|0)!=(j|0))}if((J|0)>(L|0)){M=I;break}else J=I}}J=s+((Y((L|0)%3|0,o)|0)<<2)|0;O=s+((Y((G|0)%3|0,o)|0)<<2)|0;N=s+((Y((L+2|0)%3|0,o)|0)<<2)|0;if(y){P=0;do{R=f[O+(P<<2)>>2]|0;S=f[N+(P<<2)>>2]|0;T=((R*6|0)+32+S+(f[J+(P<<2)>>2]|0)|0)>>>6&65535;d[H+(P<<1)>>1]=((S+R<<2)+32|0)>>>6;d[K+(P<<1)>>1]=T;P=P+1|0}while((P|0)!=(i|0))}if((G|0)>=(l|0)){U=z;break}else F=M}}else U=l<<1;if((n|0)>(U|0)?(n=f[c+16>>2]|0,l=f[f[c+44>>2]>>2]|0,c=n+(Y(l,U+-2|0)|0)|0,M=n+(Y(l,U)|0)|0,(i|0)>0):0){U=0;do{d[M+(U<<1)>>1]=d[c+(U<<1)>>1]|0;U=U+1|0}while((U|0)!=(i|0))}i=f[h>>2]|0;if((i|0)!=(p|0)){if(i|0)QYa(i);f[h>>2]=p;f[v>>2]=264}v=f[g>>2]|0;if((v|0)==(q|0)){u=e;return}if(v|0)QYa(v);f[g>>2]=q;f[r>>2]=264;u=e;return}function nka(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=u;u=u+2144|0;g=e+1072|0;h=e+8|0;i=e;k=f[a+40>>2]|0;l=f[k+4>>2]|0;m=f[k>>2]|0;k=f[c+40>>2]|0;n=f[k+4>>2]|0;o=f[k>>2]|0;k=((f[a>>2]|0)>>>3&511)+1|0;p=(Y(k,n+1|0)|0)+15&-16;q=(p*3|0)+16|0;r=g+8|0;f[g>>2]=r;s=g+4|0;f[s>>2]=q;if(q>>>0>264){t=OYa(q>>>0>1073741823?-1:q<<2)|0;f[g>>2]=t;v=t}else v=r;t=v+15&-16;v=Y(k,l)|0;q=h+8|0;f[h>>2]=q;w=h+4|0;f[w>>2]=v;if(v>>>0>264){x=OYa(v>>>0>1073741823?-1:v<<2)|0;f[h>>2]=x;y=x}else y=q;x=n-(l<<1)|0;if(!((((x|0)>-1?x:0-x|0)|0)==((n|0)%2|0|0)?(x=o-(m<<1)|0,(((x|0)>-1?x:0-x|0)|0)==((o|0)%2|0|0)):0)){f[i>>2]=0;f[i+4>>2]=0;x=c$(i,119)|0;l=323208;z=x+119|0;do{b[x>>0]=b[l>>0]|0;x=x+1|0;l=l+1|0}while((x|0)<(z|0));j$(-215,i,323328,322906,996);d$(i)}i=Y(k,n)|0;if((v|0)>0){n=k<<1;l=0;do{x=(Y(n,(l|0)/(k|0)|0)|0)+((l|0)%(k|0)|0)|0;f[y+(l<<2)>>2]=x;l=l+1|0}while((l|0)!=(v|0))}if((m|0)>0){l=c+16|0;n=c+44|0;x=o+-1|0;z=(i|0)>0;A=m<<1;B=a+16|0;C=a+44|0;a=(v|0)==(k|0);D=v-k|0;E=(i|0)>(v<<1|0);v=c+12|0;F=(k|0)<(D|0);G=-1;H=0;while(1){I=H<<1;J=f[l>>2]|0;K=f[f[n>>2]>>2]|0;L=J+(Y(K,I)|0)|0;M=I|1;I=J+(Y(K,(x|0)<(M|0)?x:M)|0)|0;M=H;H=H+1|0;if((G|0)>(H|0))N=G;else{K=G;while(1){J=K+1|0;O=t+((Y((J|0)%3|0,p)|0)<<2)|0;P=(lL(K<<1,A,4)|0)/2|0;Q=(f[B>>2]|0)+(Y(f[f[C>>2]>>2]|0,P)|0)|0;if(!a){if(E){P=0;do{R=f[y+(P<<2)>>2]|0;S=j[Q+(P<<1)>>1]|0;T=j[Q+(P+k<<1)>>1]|0;f[O+(R<<2)>>2]=(T<<1)+(S*6|0);f[O+(R+k<<2)>>2]=T+S<<2;S=P+D|0;T=f[y+(S<<2)>>2]|0;R=j[Q+(S<<1)>>1]|0;U=R<<3;f[O+(T<<2)>>2]=(R*7|0)+(j[Q+(S-k<<1)>>1]|0);f[O+(T+k<<2)>>2]=U;f[O+(P+-1+(f[v>>2]|0)<<2)>>2]=U;P=P+1|0}while((P|0)!=(k|0))}else{P=0;do{U=f[y+(P<<2)>>2]|0;T=j[Q+(P<<1)>>1]|0;S=j[Q+(P+k<<1)>>1]|0;f[O+(U<<2)>>2]=(S<<1)+(T*6|0);f[O+(U+k<<2)>>2]=S+T<<2;T=P+D|0;S=f[y+(T<<2)>>2]|0;U=j[Q+(T<<1)>>1]|0;f[O+(S<<2)>>2]=(U*7|0)+(j[Q+(T-k<<1)>>1]|0);f[O+(S+k<<2)>>2]=U<<3;P=P+1|0}while((P|0)!=(k|0))}if(F){P=k;do{U=f[y+(P<<2)>>2]|0;S=j[Q+(P<<1)>>1]|0;T=j[Q+(P+k<<1)>>1]|0;f[O+(U<<2)>>2]=(S*6|0)+(j[Q+(P-k<<1)>>1]|0)+T;f[O+(U+k<<2)>>2]=T+S<<2;P=P+1|0}while((P|0)!=(D|0))}}else{P=0;do{S=(j[Q+(P<<1)>>1]|0)<<3;f[O+(P+k<<2)>>2]=S;f[O+(P<<2)>>2]=S;P=P+1|0}while((P|0)!=(k|0))}if((K|0)>(M|0)){N=J;break}else K=J}}K=t+((Y((M|0)%3|0,p)|0)<<2)|0;P=t+((Y((H|0)%3|0,p)|0)<<2)|0;O=t+((Y((M+2|0)%3|0,p)|0)<<2)|0;if(z){Q=0;do{S=f[P+(Q<<2)>>2]|0;T=f[O+(Q<<2)>>2]|0;U=((S*6|0)+32+T+(f[K+(Q<<2)>>2]|0)|0)>>>6&65535;d[I+(Q<<1)>>1]=((T+S<<2)+32|0)>>>6;d[L+(Q<<1)>>1]=U;Q=Q+1|0}while((Q|0)!=(i|0))}if((H|0)>=(m|0)){V=A;break}else G=N}}else V=m<<1;if((o|0)>(V|0)?(o=f[c+16>>2]|0,m=f[f[c+44>>2]>>2]|0,c=o+(Y(m,V+-2|0)|0)|0,N=o+(Y(m,V)|0)|0,(i|0)>0):0){V=0;do{d[N+(V<<1)>>1]=d[c+(V<<1)>>1]|0;V=V+1|0}while((V|0)!=(i|0))}i=f[h>>2]|0;if((i|0)!=(q|0)){if(i|0)QYa(i);f[h>>2]=q;f[w>>2]=264}w=f[g>>2]|0;if((w|0)==(r|0)){u=e;return}if(w|0)QYa(w);f[g>>2]=r;f[s>>2]=264;u=e;return}function oka(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0;d=u;u=u+2144|0;e=d+1072|0;g=d+8|0;h=d;i=f[a+40>>2]|0;j=f[i+4>>2]|0;k=f[i>>2]|0;i=f[c+40>>2]|0;l=f[i+4>>2]|0;m=f[i>>2]|0;i=((f[a>>2]|0)>>>3&511)+1|0;o=(Y(i,l+1|0)|0)+15&-16;p=(o*3|0)+16|0;q=e+8|0;f[e>>2]=q;r=e+4|0;f[r>>2]=p;if(p>>>0>264){s=OYa(p>>>0>1073741823?-1:p<<2)|0;f[e>>2]=s;t=s}else t=q;s=t+15&-16;t=Y(i,j)|0;p=g+8|0;f[g>>2]=p;v=g+4|0;f[v>>2]=t;if(t>>>0>264){w=OYa(t>>>0>1073741823?-1:t<<2)|0;f[g>>2]=w;x=w}else x=p;w=l-(j<<1)|0;if(!((((w|0)>-1?w:0-w|0)|0)==((l|0)%2|0|0)?(w=m-(k<<1)|0,(((w|0)>-1?w:0-w|0)|0)==((m|0)%2|0|0)):0)){f[h>>2]=0;f[h+4>>2]=0;w=c$(h,119)|0;j=323208;y=w+119|0;do{b[w>>0]=b[j>>0]|0;w=w+1|0;j=j+1|0}while((w|0)<(y|0));j$(-215,h,323328,322906,996);d$(h)}h=Y(i,l)|0;if((t|0)>0){l=i<<1;j=0;do{w=(Y(l,(j|0)/(i|0)|0)|0)+((j|0)%(i|0)|0)|0;f[x+(j<<2)>>2]=w;j=j+1|0}while((j|0)!=(t|0))}if((k|0)>0){j=c+16|0;l=c+44|0;w=m+-1|0;y=(h|0)>0;z=k<<1;A=a+16|0;B=a+44|0;a=(t|0)==(i|0);C=t-i|0;D=(h|0)>(t<<1|0);t=c+12|0;E=(i|0)<(C|0);F=-1;G=0;while(1){H=G<<1;I=f[j>>2]|0;J=f[f[l>>2]>>2]|0;K=I+(Y(J,H)|0)|0;L=H|1;H=I+(Y(J,(w|0)<(L|0)?w:L)|0)|0;L=G;G=G+1|0;if((F|0)>(G|0))M=F;else{J=F;while(1){I=J+1|0;N=s+((Y((I|0)%3|0,o)|0)<<2)|0;O=(lL(J<<1,z,4)|0)/2|0;P=(f[A>>2]|0)+(Y(f[f[B>>2]>>2]|0,O)|0)|0;if(!a){O=f[t>>2]|0;if(D){Q=0;do{R=f[x+(Q<<2)>>2]|0;S=+n[P+(Q<<2)>>2];T=+n[P+(Q+i<<2)>>2];n[N+(R<<2)>>2]=S*6.0+T*2.0;n[N+(R+i<<2)>>2]=(S+T)*4.0;R=Q+C|0;U=f[x+(R<<2)>>2]|0;T=+n[P+(R<<2)>>2];S=T*8.0;n[N+(U<<2)>>2]=+n[P+(R-i<<2)>>2]+T*7.0;n[N+(U+i<<2)>>2]=S;n[N+(Q+-1+O<<2)>>2]=S;Q=Q+1|0}while((Q|0)!=(i|0))}else{Q=0;do{O=f[x+(Q<<2)>>2]|0;S=+n[P+(Q<<2)>>2];T=+n[P+(Q+i<<2)>>2];n[N+(O<<2)>>2]=S*6.0+T*2.0;n[N+(O+i<<2)>>2]=(S+T)*4.0;O=Q+C|0;U=f[x+(O<<2)>>2]|0;T=+n[P+(O<<2)>>2];n[N+(U<<2)>>2]=+n[P+(O-i<<2)>>2]+T*7.0;n[N+(U+i<<2)>>2]=T*8.0;Q=Q+1|0}while((Q|0)!=(i|0))}if(E){Q=i;do{U=f[x+(Q<<2)>>2]|0;T=+n[P+(Q<<2)>>2];S=+n[P+(Q+i<<2)>>2];n[N+(U<<2)>>2]=S+(+n[P+(Q-i<<2)>>2]+T*6.0);n[N+(U+i<<2)>>2]=(T+S)*4.0;Q=Q+1|0}while((Q|0)!=(C|0))}}else{Q=0;do{S=+n[P+(Q<<2)>>2]*8.0;n[N+(Q+i<<2)>>2]=S;n[N+(Q<<2)>>2]=S;Q=Q+1|0}while((Q|0)!=(i|0))}if((J|0)>(L|0)){M=I;break}else J=I}}J=s+((Y((L|0)%3|0,o)|0)<<2)|0;Q=s+((Y((G|0)%3|0,o)|0)<<2)|0;N=s+((Y((L+2|0)%3|0,o)|0)<<2)|0;if(y){P=0;do{S=+n[Q+(P<<2)>>2];T=+n[N+(P<<2)>>2];V=(T+(S*6.0+ +n[J+(P<<2)>>2]))*.015625;n[H+(P<<2)>>2]=(S+T)*4.0*.015625;n[K+(P<<2)>>2]=V;P=P+1|0}while((P|0)!=(h|0))}if((G|0)>=(k|0)){W=z;break}else F=M}}else W=k<<1;if((m|0)>(W|0)?(m=f[c+16>>2]|0,k=f[f[c+44>>2]>>2]|0,c=m+(Y(k,W+-2|0)|0)|0,M=m+(Y(k,W)|0)|0,(h|0)>0):0){W=0;do{f[M+(W<<2)>>2]=f[c+(W<<2)>>2];W=W+1|0}while((W|0)!=(h|0))}h=f[g>>2]|0;if((h|0)!=(p|0)){if(h|0)QYa(h);f[g>>2]=p;f[v>>2]=264}v=f[e>>2]|0;if((v|0)==(q|0)){u=d;return}if(v|0)QYa(v);f[e>>2]=q;f[r>>2]=264;u=d;return}function pka(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0;d=u;u=u+2176|0;e=d;g=d+1104|0;h=d+1096|0;i=f[a+40>>2]|0;j=f[i+4>>2]|0;k=f[i>>2]|0;i=f[c+40>>2]|0;l=f[i+4>>2]|0;m=f[i>>2]|0;i=((f[a>>2]|0)>>>3&511)+1|0;n=(Y(i,l+1|0)|0)+15&-16;o=(n*3|0)+16|0;q=e+8|0;f[e>>2]=q;r=e+4|0;f[r>>2]=o;if(o>>>0>136){s=OYa(o>>>0>536870911?-1:o<<3)|0;f[e>>2]=s;t=s}else t=q;s=t+15&-16;t=Y(i,j)|0;o=g+8|0;f[g>>2]=o;v=g+4|0;f[v>>2]=t;if(t>>>0>264){w=OYa(t>>>0>1073741823?-1:t<<2)|0;f[g>>2]=w;x=w}else x=o;w=l-(j<<1)|0;if(!((((w|0)>-1?w:0-w|0)|0)==((l|0)%2|0|0)?(w=m-(k<<1)|0,(((w|0)>-1?w:0-w|0)|0)==((m|0)%2|0|0)):0)){f[h>>2]=0;f[h+4>>2]=0;w=c$(h,119)|0;j=323208;y=w+119|0;do{b[w>>0]=b[j>>0]|0;w=w+1|0;j=j+1|0}while((w|0)<(y|0));j$(-215,h,323328,322906,996);d$(h)}h=Y(i,l)|0;if((t|0)>0){l=i<<1;j=0;do{w=(Y(l,(j|0)/(i|0)|0)|0)+((j|0)%(i|0)|0)|0;f[x+(j<<2)>>2]=w;j=j+1|0}while((j|0)!=(t|0))}if((k|0)>0){j=c+16|0;l=c+44|0;w=m+-1|0;y=(h|0)>0;z=k<<1;A=a+16|0;B=a+44|0;a=(t|0)==(i|0);C=t-i|0;D=(h|0)>(t<<1|0);t=c+12|0;E=(i|0)<(C|0);F=-1;G=0;while(1){H=G<<1;I=f[j>>2]|0;J=f[f[l>>2]>>2]|0;K=I+(Y(J,H)|0)|0;L=H|1;H=I+(Y(J,(w|0)<(L|0)?w:L)|0)|0;L=G;G=G+1|0;if((F|0)>(G|0))M=F;else{J=F;while(1){I=J+1|0;N=s+((Y((I|0)%3|0,n)|0)<<3)|0;O=(lL(J<<1,z,4)|0)/2|0;P=(f[A>>2]|0)+(Y(f[f[B>>2]>>2]|0,O)|0)|0;if(!a){O=f[t>>2]|0;if(D){Q=0;do{R=f[x+(Q<<2)>>2]|0;S=+p[P+(Q<<3)>>3];T=+p[P+(Q+i<<3)>>3];p[N+(R<<3)>>3]=S*6.0+T*2.0;p[N+(R+i<<3)>>3]=(S+T)*4.0;R=Q+C|0;U=f[x+(R<<2)>>2]|0;T=+p[P+(R<<3)>>3];S=T*8.0;p[N+(U<<3)>>3]=+p[P+(R-i<<3)>>3]+T*7.0;p[N+(U+i<<3)>>3]=S;p[N+(Q+-1+O<<3)>>3]=S;Q=Q+1|0}while((Q|0)!=(i|0))}else{Q=0;do{O=f[x+(Q<<2)>>2]|0;S=+p[P+(Q<<3)>>3];T=+p[P+(Q+i<<3)>>3];p[N+(O<<3)>>3]=S*6.0+T*2.0;p[N+(O+i<<3)>>3]=(S+T)*4.0;O=Q+C|0;U=f[x+(O<<2)>>2]|0;T=+p[P+(O<<3)>>3];p[N+(U<<3)>>3]=+p[P+(O-i<<3)>>3]+T*7.0;p[N+(U+i<<3)>>3]=T*8.0;Q=Q+1|0}while((Q|0)!=(i|0))}if(E){Q=i;do{U=f[x+(Q<<2)>>2]|0;T=+p[P+(Q<<3)>>3];S=+p[P+(Q+i<<3)>>3];p[N+(U<<3)>>3]=S+(+p[P+(Q-i<<3)>>3]+T*6.0);p[N+(U+i<<3)>>3]=(T+S)*4.0;Q=Q+1|0}while((Q|0)!=(C|0))}}else{Q=0;do{S=+p[P+(Q<<3)>>3]*8.0;p[N+(Q+i<<3)>>3]=S;p[N+(Q<<3)>>3]=S;Q=Q+1|0}while((Q|0)!=(i|0))}if((J|0)>(L|0)){M=I;break}else J=I}}J=s+((Y((L|0)%3|0,n)|0)<<3)|0;Q=s+((Y((G|0)%3|0,n)|0)<<3)|0;N=s+((Y((L+2|0)%3|0,n)|0)<<3)|0;if(y){P=0;do{S=+p[Q+(P<<3)>>3];T=+p[N+(P<<3)>>3];V=(T+(S*6.0+ +p[J+(P<<3)>>3]))*.015625;p[H+(P<<3)>>3]=(S+T)*4.0*.015625;p[K+(P<<3)>>3]=V;P=P+1|0}while((P|0)!=(h|0))}if((G|0)>=(k|0)){W=z;break}else F=M}}else W=k<<1;if((m|0)>(W|0)?(m=f[c+16>>2]|0,k=f[f[c+44>>2]>>2]|0,c=m+(Y(k,W+-2|0)|0)|0,M=m+(Y(k,W)|0)|0,(h|0)>0):0){W=0;do{p[M+(W<<3)>>3]=+p[c+(W<<3)>>3];W=W+1|0}while((W|0)!=(h|0))}h=f[g>>2]|0;if((h|0)!=(o|0)){if(h|0)QYa(h);f[g>>2]=o;f[v>>2]=264}v=f[e>>2]|0;if((v|0)==(q|0)){u=d;return}if(v|0)QYa(v);f[e>>2]=q;f[r>>2]=136;u=d;return}function qka(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=u;u=u+2144|0;e=d+1072|0;g=d+8|0;i=d;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[c+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=((f[a>>2]|0)>>>3&511)+1|0;o=(Y(j,m+1|0)|0)+15&-16;p=(o*3|0)+16|0;q=e+8|0;f[e>>2]=q;r=e+4|0;f[r>>2]=p;if(p>>>0>264){s=OYa(p>>>0>1073741823?-1:p<<2)|0;f[e>>2]=s;t=s}else t=q;s=t+15&-16;t=Y(j,k)|0;p=g+8|0;f[g>>2]=p;v=g+4|0;f[v>>2]=t;if(t>>>0>264){w=OYa(t>>>0>1073741823?-1:t<<2)|0;f[g>>2]=w;x=w}else x=p;w=m-(k<<1)|0;if(!((((w|0)>-1?w:0-w|0)|0)==((m|0)%2|0|0)?(w=n-(l<<1)|0,(((w|0)>-1?w:0-w|0)|0)==((n|0)%2|0|0)):0)){f[i>>2]=0;f[i+4>>2]=0;w=c$(i,119)|0;k=323208;y=w+119|0;do{b[w>>0]=b[k>>0]|0;w=w+1|0;k=k+1|0}while((w|0)<(y|0));j$(-215,i,323328,322906,996);d$(i)}i=Y(j,m)|0;if((t|0)>0){m=j<<1;k=0;do{w=(Y(m,(k|0)/(j|0)|0)|0)+((k|0)%(j|0)|0)|0;f[x+(k<<2)>>2]=w;k=k+1|0}while((k|0)!=(t|0))}if((l|0)>0){k=c+16|0;m=c+44|0;w=n+-1|0;y=(i|0)>0;z=l<<1;A=a+16|0;B=a+44|0;a=(t|0)==(j|0);C=t-j|0;D=(i|0)>(t<<1|0);t=c+12|0;E=(j|0)<(C|0);F=-1;G=0;while(1){H=G<<1;I=f[k>>2]|0;J=f[f[m>>2]>>2]|0;K=I+(Y(J,H)|0)|0;L=H|1;H=I+(Y(J,(w|0)<(L|0)?w:L)|0)|0;L=G;G=G+1|0;if((F|0)>(G|0))M=F;else{J=F;while(1){I=J+1|0;N=s+((Y((I|0)%3|0,o)|0)<<2)|0;O=(lL(J<<1,z,4)|0)/2|0;P=(f[A>>2]|0)+(Y(f[f[B>>2]>>2]|0,O)|0)|0;if(!a){if(D){O=0;do{Q=f[x+(O<<2)>>2]|0;R=h[P+O>>0]|0;S=h[P+(O+j)>>0]|0;f[N+(Q<<2)>>2]=(S<<1)+(R*6|0);f[N+(Q+j<<2)>>2]=S+R<<2;R=O+C|0;S=f[x+(R<<2)>>2]|0;Q=h[P+R>>0]|0;T=Q<<3;f[N+(S<<2)>>2]=(Q*7|0)+(h[P+(R-j)>>0]|0);f[N+(S+j<<2)>>2]=T;f[N+(O+-1+(f[t>>2]|0)<<2)>>2]=T;O=O+1|0}while((O|0)!=(j|0))}else{O=0;do{T=f[x+(O<<2)>>2]|0;S=h[P+O>>0]|0;R=h[P+(O+j)>>0]|0;f[N+(T<<2)>>2]=(R<<1)+(S*6|0);f[N+(T+j<<2)>>2]=R+S<<2;S=O+C|0;R=f[x+(S<<2)>>2]|0;T=h[P+S>>0]|0;f[N+(R<<2)>>2]=(T*7|0)+(h[P+(S-j)>>0]|0);f[N+(R+j<<2)>>2]=T<<3;O=O+1|0}while((O|0)!=(j|0))}if(E){O=j;do{T=f[x+(O<<2)>>2]|0;R=h[P+O>>0]|0;S=h[P+(O+j)>>0]|0;f[N+(T<<2)>>2]=(R*6|0)+(h[P+(O-j)>>0]|0)+S;f[N+(T+j<<2)>>2]=S+R<<2;O=O+1|0}while((O|0)!=(C|0))}}else{O=0;do{R=(h[P+O>>0]|0)<<3;f[N+(O+j<<2)>>2]=R;f[N+(O<<2)>>2]=R;O=O+1|0}while((O|0)!=(j|0))}if((J|0)>(L|0)){M=I;break}else J=I}}J=s+((Y((L|0)%3|0,o)|0)<<2)|0;O=s+((Y((G|0)%3|0,o)|0)<<2)|0;N=s+((Y((L+2|0)%3|0,o)|0)<<2)|0;if(y){P=0;do{R=f[O+(P<<2)>>2]|0;S=f[N+(P<<2)>>2]|0;T=((R*6|0)+32+S+(f[J+(P<<2)>>2]|0)|0)>>>6&255;b[H+P>>0]=((S+R<<2)+32|0)>>>6;b[K+P>>0]=T;P=P+1|0}while((P|0)!=(i|0))}if((G|0)>=(l|0)){U=z;break}else F=M}}else U=l<<1;if((n|0)>(U|0)?(n=f[c+16>>2]|0,l=f[f[c+44>>2]>>2]|0,c=n+(Y(l,U+-2|0)|0)|0,M=n+(Y(l,U)|0)|0,(i|0)>0):0){U=0;do{b[M+U>>0]=b[c+U>>0]|0;U=U+1|0}while((U|0)!=(i|0))}i=f[g>>2]|0;if((i|0)!=(p|0)){if(i|0)QYa(i);f[g>>2]=p;f[v>>2]=264}v=f[e>>2]|0;if((v|0)==(q|0)){u=d;return}if(v|0)QYa(v);f[e>>2]=q;f[r>>2]=264;u=d;return}function rka(a,c,e,g,h,i,j,k,l,m,o,p){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=+m;o=+o;p=p|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0;q=u;u=u+2464|0;r=q+1336|0;s=q+272|0;t=q;v=q+264|0;w=q+200|0;x=q+256|0;y=q+136|0;z=q+192|0;_$(v,74424);if((Y(l,k)|0)<=0?!(m>0.0&o>0.0):0){f[r>>2]=0;f[r+4>>2]=0;A=c$(r,68)|0;B=323394;C=A+68|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));j$(-215,r,323463,323470,2949);d$(r)}if(m<2.220446049250313e-16|o<2.220446049250313e-16){D=+(g|0);E=+(h|0);F=D;G=E;H=+(k|0)/D;I=+(l|0)/E}else{F=+(g|0);G=+(h|0);H=m;I=o}l=a&7;k=(a>>>3&511)+1|0;J=rNa(F*H)|0;K=rNa(G*I)|0;if((Y(K,J)|0)<=0){f[r>>2]=0;f[r+4>>2]=0;A=c$(r,16)|0;B=323521;C=A+16|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));j$(-215,r,323463,323470,2961);d$(r)}G=1.0/H;F=1.0/I;M=rNa(G)|0;N=rNa(F)|0;if(+L(+(G-+(M|0)))<2.220446049250313e-16)O=+L(+(F-+(N|0)))<2.220446049250313e-16;else O=0;f[x>>2]=g;f[x+4>>2]=h;CN(w,x,a,c,e);f[z>>2]=J;f[z+4>>2]=K;CN(y,z,a,i,j);do if(!p){j=f[(f[w+40>>2]|0)+4>>2]|0;i=y+40|0;a=f[i>>2]|0;z=f[a+4>>2]|0;c=f[a>>2]|0;a=r+8|0;f[r>>2]=a;x=r+4|0;f[x>>2]=z;if(z>>>0>264){P=OYa(z>>>0>1073741823?-1:z<<2)|0;f[r>>2]=P;Q=P}else Q=a;P=f[w+4>>2]|0;if((P|0)>0)R=f[(f[w+44>>2]|0)+(P+-1<<2)>>2]|0;else R=0;P=R>>>2;if((z|0)>0){S=j+-1|0;j=0;do{o=G*+(j|0);T=~~o;U=T-(+(T|0)>o&1)|0;T=Y((S|0)<(U|0)?S:U,R)|0;f[Q+(j<<2)>>2]=T;j=j+1|0}while((j|0)!=(z|0))}f[s>>2]=0;f[s+4>>2]=c;ska(t,w,y,Q,P,F);z=f[y+4>>2]|0;if((z|0)<3)V=Y(f[y+12>>2]|0,f[y+8>>2]|0)|0;else{j=f[i>>2]|0;S=0;T=1;while(1){U=Y(f[j+(S<<2)>>2]|0,T)|0;S=S+1|0;if((S|0)==(z|0)){V=U;break}else T=U}}_U(s,t,+(V>>>0)*.0000152587890625);tka(t);T=f[r>>2]|0;if((T|0)!=(a|0)){if(T|0)QYa(T);f[r>>2]=a;f[x>>2]=264}}else{T=(p|0)==1&((N|0)==2&((M|0)==2&O))?3:p;z=(T|0)==3;if(F>=1.0&(G>=1.0&z)){if(O){S=Y(N,M)|0;j=(e>>>0)/((1212424721>>>(f[w>>2]<<2&28)&15)>>>0)|0;i=S+(Y(J,k)|0)|0;P=r+8|0;f[r>>2]=P;c=r+4|0;f[c>>2]=i;if(i>>>0>264){U=OYa(i>>>0>1073741823?-1:i<<2)|0;f[r>>2]=U;W=U}else W=P;U=W+(S<<2)|0;S=f[74444+(l<<2)>>2]|0;if(!(109>>>l&1)){f[s>>2]=0;f[s+4>>2]=0;A=c$(s,9)|0;B=323538;C=A+9|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));j$(-215,s,323463,323470,3107);d$(s)}if((N|0)>0&(M|0)>0){x=0;a=0;while(1){i=Y(a,j)|0;X=x;Z=0;while(1){_=(Y(Z,k)|0)+i|0;f[W+(X<<2)>>2]=_;Z=Z+1|0;if((Z|0)==(M|0))break;else X=X+1|0}a=a+1|0;if((a|0)==(N|0))break;else x=M+x|0}}if((J|0)>0){x=0;do{a=Y(x,k)|0;j=Y(a,M)|0;X=0;do{f[U+(X+a<<2)>>2]=X+j;X=X+1|0}while((X|0)!=(k|0));x=x+1|0}while((x|0)!=(J|0))}bh[S&255](w,y,W,U,M,N);x=f[r>>2]|0;if((x|0)!=(P|0)){if(x|0)QYa(x);f[r>>2]=P;f[c>>2]=264}break}x=f[74476+(l<<2)>>2]|0;if(!((109>>>l&1|0)!=0&k>>>0<5)){f[r>>2]=0;f[r+4>>2]=0;A=c$(r,20)|0;B=323548;C=A+20|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));j$(-215,r,323463,323470,3126);d$(r)}c=h+g<<1;P=r+8|0;f[r>>2]=P;U=r+4|0;f[U>>2]=c;if(c>>>0>93){S=OYa(c>>>0>357913941?-1:c*12|0)|0;f[r>>2]=S;$=S}else $=P;S=$+((g<<1)*12|0)|0;c=uka(g,J,k,G,$)|0;X=uka(h,K,1,F,S)|0;j=K+1|0;a=s+8|0;f[s>>2]=a;Z=s+4|0;f[Z>>2]=j;if(j>>>0>264){i=OYa(j>>>0>1073741823?-1:j<<2)|0;f[s>>2]=i;aa=i}else aa=a;if((X|0)>0){i=0;j=0;while(1){if((j|0)!=0?(f[S+(j*12|0)+4>>2]|0)==(f[S+((j+-1|0)*12|0)+4>>2]|0):0)ba=i;else{f[aa+(i<<2)>>2]=j;ba=i+1|0}j=j+1|0;if((j|0)==(X|0)){ca=ba;break}else i=ba}}else ca=0;f[aa+(ca<<2)>>2]=X;Xh[x&127](w,y,$,c,S,X,aa);i=f[s>>2]|0;if((i|0)!=(a|0)){if(i|0)QYa(i);f[s>>2]=a;f[Z>>2]=264}i=f[r>>2]|0;if((i|0)!=(P|0)){if(i|0)QYa(i);f[r>>2]=P;f[U>>2]=93}break}i=Y(J,k)|0;j=(l|0)==0;_=(T|0)==2;if(!_)if((T|0)!=4)if((T|2|0)==3){da=74540;ea=2;fa=71}else{f[r>>2]=0;f[r+4>>2]=0;A=c$(r,28)|0;B=323569;C=A+28|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));j$(-5,r,323463,323470,3164);d$(r);ga=0;ha=0;fa=72}else{da=74508;ea=8;fa=71}else{da=74572;ea=4;fa=71}if((fa|0)==71){U=f[da+(l<<2)>>2]|0;P=ea>>>1;if(!U){ga=P;ha=ea;fa=72}else{ia=P;ja=U;ka=ea}}if((fa|0)==72){f[r>>2]=0;f[r+4>>2]=0;A=c$(r,9)|0;B=323538;C=A+9|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));j$(-215,r,323463,323470,3167);d$(r);ia=ga;ja=0;ka=ha}U=i+K|0;P=ka<<2;Z=Y(P|4,U)|0;a=r+8|0;f[r>>2]=a;X=r+4|0;f[X>>2]=Z;if(Z>>>0>1032){S=OYa(Z)|0;f[r>>2]=S;la=S}else la=a;S=la+(i<<2)|0;Z=S+(K<<2)|0;c=Y(ka,i)|0;x=Z+(c<<2)|0;ma=Z+(c<<1)|0;if((J|0)>0){c=ia+-1|0;na=s+4|0;oa=s+8|0;pa=s+12|0;qa=(ka|0)>0;ra=Y(ka,k)|0;sa=(T|0)==4;ta=g+-1|0;ua=0;va=J;wa=0;while(1){xa=Y(ra,ua)|0;ya=la+(U+xa<<2)|0;o=+(ua|0);if(z){m=G*o;za=~~m;Aa=za-(+(za|0)>m&1)|0;m=+(ua+1|0)-H*+(Aa+1|0);za=~~m;if(!(m<=0.0)){Ba=m-+(za-(+(za|0)>m&1)|0);Ca=Aa}else{Ba=0.0;Ca=Aa}}else{m=G*(o+.5)+-.5;Aa=~~m;za=Aa-(+(Aa|0)>m&1)|0;Ba=m-+(za|0);Ca=za}a:do if((Ca|0)<(c|0)){za=ua+1|0;if((Ca|0)<0){switch(T|0){case 2:case 4:{Da=Ba;Ea=Ca;Fa=za;break a;break}default:{}}Da=0.0;Ea=0;Fa=za}else{Da=Ba;Ea=Ca;Fa=za}}else{Da=Ba;Ea=Ca;Fa=wa}while(0);b:do if((Ea+ia|0)>=(g|0)){za=(ua|0)<(va|0)?ua:va;if((Ea|0)<(ta|0)){Ga=Da;Ha=Ea;Ia=za}else{switch(T|0){case 2:case 4:{Ga=Da;Ha=Ea;Ia=za;break b;break}default:{}}Ga=0.0;Ha=ta;Ia=za}}else{Ga=Da;Ha=Ea;Ia=va}while(0);za=Y(Ha,k)|0;Aa=Y(ua,k)|0;Ja=0;do{f[la+(Ja+Aa<<2)>>2]=Ja+za;Ja=Ja+1|0}while((Ja|0)!=(k|0));do if(!_)if(sa){vka(Ga,s);break}else{n[s>>2]=1.0-Ga;n[na>>2]=Ga;break}else{m=Ga+1.0;o=m*(m*(3.75-m*.75)+-6.0)+3.0;n[s>>2]=o;m=Ga*(Ga*(Ga*1.25+-2.25))+1.0;n[na>>2]=m;E=1.0-Ga;D=E*(E*(E*1.25+-2.25))+1.0;n[oa>>2]=D;n[pa>>2]=1.0-o-m-D}while(0);if(j){if(qa){Ja=0;do{za=wNa(+n[s+(Ja<<2)>>2]*2048.0)|0;d[Z+(Ja+xa<<1)>>1]=(za+32768|0)>>>0<65536?za:(za|0)>0?32767:32768;Ja=Ja+1|0}while((Ja|0)!=(ka|0));Ka=ka}else Ka=0;if((Ka|0)<(ra|0)){Ja=Ka;do{za=Ja+xa|0;d[Z+(za<<1)>>1]=d[Z+(za-ka<<1)>>1]|0;Ja=Ja+1|0}while((Ja|0)<(ra|0))}}else{if(qa){K1a(ya|0,s|0,P|0)|0;La=ka}else La=0;if((La|0)<(ra|0)){Ja=La;do{za=Ja+xa|0;f[Z+(za<<2)>>2]=f[Z+(za-ka<<2)>>2];Ja=Ja+1|0}while((Ja|0)<(ra|0))}}ua=ua+1|0;if((ua|0)==(J|0)){Ma=Ia;Na=Fa;break}else{va=Ia;wa=Fa}}}else{Ma=J;Na=0}if((K|0)>0){wa=s+4|0;va=s+8|0;ua=s+12|0;ra=(ka|0)>0;qa=(T|0)==4;pa=Y(Y(J,P+4|0)|0,k)|0;oa=0;do{na=Y(ka,oa)|0;sa=la+(K+na<<2)+pa|0;D=+(oa|0);if(z){m=F*D;ta=~~m;c=ta-(+(ta|0)>m&1)|0;m=+(oa+1|0)-I*+(c+1|0);ta=~~m;if(!(m<=0.0)){Oa=m-+(ta-(+(ta|0)>m&1)|0);Pa=c}else{Oa=0.0;Pa=c}}else{m=F*(D+.5)+-.5;c=~~m;ta=c-(+(c|0)>m&1)|0;Oa=m-+(ta|0);Pa=ta}f[S+(oa<<2)>>2]=Pa;do if(!_)if(qa){vka(Oa,s);break}else{n[s>>2]=1.0-Oa;n[wa>>2]=Oa;break}else{m=Oa+1.0;D=m*(m*(3.75-m*.75)+-6.0)+3.0;n[s>>2]=D;m=Oa*(Oa*(Oa*1.25+-2.25))+1.0;n[wa>>2]=m;o=1.0-Oa;E=o*(o*(o*1.25+-2.25))+1.0;n[va>>2]=E;n[ua>>2]=1.0-D-m-E}while(0);if(j){if(ra){ta=0;do{c=wNa(+n[s+(ta<<2)>>2]*2048.0)|0;d[ma+(ta+na<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;ta=ta+1|0}while((ta|0)!=(ka|0))}}else if(ra)K1a(sa|0,s|0,P|0)|0;oa=oa+1|0}while((oa|0)!=(K|0))}_h[ja&127](w,y,la,Z,S,j?ma:x,Na,Ma,ka);oa=f[r>>2]|0;if((oa|0)!=(a|0)){if(oa|0)QYa(oa);f[r>>2]=a;f[X>>2]=1032}}while(0);r=y+36|0;ka=f[r>>2]|0;if(ka|0?(Ma=ka+12|0,ka=f[Ma>>2]|0,f[Ma>>2]=ka+-1,(ka|0)==1):0)CR(y);f[r>>2]=0;r=y+16|0;ka=y+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[ka>>2]|0)>0){r=f[y+40>>2]|0;Ma=0;do{f[r+(Ma<<2)>>2]=0;Ma=Ma+1|0}while((Ma|0)<(f[ka>>2]|0))}ka=f[y+44>>2]|0;if((ka|0)!=(y+48|0))ZF(ka);ka=w+36|0;y=f[ka>>2]|0;if(y|0?(Ma=y+12|0,y=f[Ma>>2]|0,f[Ma>>2]=y+-1,(y|0)==1):0)CR(w);f[ka>>2]=0;ka=w+16|0;y=w+4|0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;if((f[y>>2]|0)>0){ka=f[w+40>>2]|0;Ma=0;do{f[ka+(Ma<<2)>>2]=0;Ma=Ma+1|0}while((Ma|0)<(f[y>>2]|0))}y=f[w+44>>2]|0;if((y|0)!=(w+48|0))ZF(y);if(!(f[v+4>>2]|0)){u=q;return}u=q;return}function ska(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;f[a>>2]=75112;h=a+4|0;f[h>>2]=f[b>>2];i=a+8|0;j=b+4|0;f[i>>2]=f[j>>2];k=a+12|0;f[k>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];l=f[b+36>>2]|0;f[a+40>>2]=l;f[a+44>>2]=k;k=a+52|0;m=a+48|0;f[m>>2]=k;f[k>>2]=0;f[a+56>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[b+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[i>>2]=0;BR(h,b)}b=a+60|0;f[b>>2]=f[c>>2];h=a+64|0;i=c+4|0;f[h>>2]=f[i>>2];j=a+68|0;f[j>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];k=f[c+36>>2]|0;f[a+96>>2]=k;f[a+100>>2]=j;j=a+108|0;m=a+104|0;f[m>>2]=j;f[j>>2]=0;f[a+112>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[c+44>>2]|0;j=f[m>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];n=a+116|0;f[n>>2]=d;o=a+120|0;f[o>>2]=e;q=a+128|0;p[q>>3]=g;return}else{f[h>>2]=0;BR(b,c);n=a+116|0;f[n>>2]=d;o=a+120|0;f[o>>2]=e;q=a+128|0;p[q>>3]=g;return}}function tka(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=75112;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function uka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0.0,i=0,j=0,k=0.0,l=0.0,m=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;if((b|0)<=0){g=0;return g|0}h=+(a|0);i=a+-1|0;a=0;j=0;while(1){k=+(a|0)*d;l=k+d;m=h-k;o=m<d?m:d;p=~~k;q=(+(p|0)<k&1)+p|0;p=~~l;r=p-(+(p|0)>l&1)|0;p=(i|0)<(r|0)?i:r;r=(p|0)<(q|0)?p:q;m=+(r|0)-k;if(m>.001){s=Y(a,c)|0;f[e+(j*12|0)+4>>2]=s;s=Y(r+-1|0,c)|0;f[e+(j*12|0)>>2]=s;n[e+(j*12|0)+8>>2]=m/o;t=j+1|0}else t=j;if((p|0)>(q|0)){q=Y(a,c)|0;m=1.0/o;s=t;u=r;while(1){f[e+(s*12|0)+4>>2]=q;r=Y(u,c)|0;f[e+(s*12|0)>>2]=r;r=s+1|0;n[e+(s*12|0)+8>>2]=m;u=u+1|0;if((u|0)>=(p|0)){v=r;break}else s=r}}else v=t;m=l-+(p|0);if(m>.001){s=Y(a,c)|0;f[e+(v*12|0)+4>>2]=s;s=Y(p,c)|0;f[e+(v*12|0)>>2]=s;k=m>1.0?1.0:m;n[e+(v*12|0)+8>>2]=(o<k?o:k)/o;w=v+1|0}else w=v;a=a+1|0;if((a|0)==(b|0)){g=w;break}else j=w}return g|0}function vka(a,b){a=+a;b=b|0;var c=0.0,d=0.0,e=0.0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0;if(a<1.1920928955078125e-07){f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;n[b+12>>2]=1.0;return}else{c=a+3.0;a=-c*3.141592653589793*.25;d=+P(+a);e=+O(+a);g=e*0.0;h=(d+g)/(a*a);a=-(c+-1.0)*3.141592653589793*.25;i=d*-.7071067811865476;j=e*-.7071067811865476;k=(i+j)/(a*a);a=-(c+-2.0)*3.141592653589793*.25;l=d*0.0;m=(l+e)/(a*a);a=-(c+-3.0)*3.141592653589793*.25;o=d*.7071067811865476;p=(o+j)/(a*a);a=-(c+-4.0)*3.141592653589793*.25;j=(g-d)/(a*a);a=-(c+-5.0)*3.141592653589793*.25;d=e*.7071067811865476;g=(o+d)/(a*a);a=-(c+-6.0)*3.141592653589793*.25;o=(l-e)/(a*a);a=-(c+-7.0)*3.141592653589793*.25;c=(i+d)/(a*a);a=1.0/(h+0.0+k+m+p+j+g+o+c);n[b>>2]=a*h;n[b+4>>2]=a*k;n[b+8>>2]=a*m;n[b+12>>2]=a*p;n[b+16>>2]=a*j;n[b+20>>2]=a*g;n[b+24>>2]=a*o;n[b+28>>2]=a*c;return}}function wka(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Vka(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);Wka(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);Wka(o);u=k;return}function xka(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Qka(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);Rka(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);Rka(o);u=k;return}function yka(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Lka(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);Mka(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);Mka(o);u=k;return}function zka(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Gka(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);Hka(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);Hka(o);u=k;return}function Aka(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Bka(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);Cka(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);Cka(o);u=k;return}function Bka(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=74612;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;BR(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;BR(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=c$(p,18)|0;n=323706;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));j$(-215,p,323725,323470,1485);d$(p);u=o;return}function Cka(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=74612;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function Dka(a){a=a|0;Cka(a);PYa(a);return}function Eka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0,_=0;c=u;u=u+1296|0;d=c+1288|0;e=c;g=c+1224|0;h=c+1160|0;i=c+1096|0;j=((f[a+4>>2]|0)>>>3&511)+1|0;k=a+140|0;l=(f[k>>2]|0)+15&-16;m=a+148|0;o=f[m>>2]|0;q=Y(l,o)|0;r=e+8|0;f[e>>2]=r;s=e+4|0;f[s>>2]=q;if(q>>>0>136){t=OYa(q>>>0>536870911?-1:q<<3)|0;f[e>>2]=t;v=t}else v=r;t=g;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));t=h;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));if((o|0)>0){F1a(i|0,-1,o<<2|0)|0;t=0;do{q=v+((Y(t,l)|0)<<3)|0;f[h+(t<<2)>>2]=q;t=t+1|0}while((t|0)<(o|0))}t=f[b>>2]|0;q=b+4|0;if((t|0)<(f[q>>2]|0)){b=a+120|0;w=a+116|0;x=a+124|0;y=a+132|0;z=a+152|0;A=a+156|0;B=a+76|0;C=a+108|0;D=h+4|0;E=h+8|0;F=h+12|0;G=a+136|0;H=a+20|0;I=a+48|0;J=l<<3;l=o;K=(f[a+128>>2]|0)+((Y(t,o)|0)<<2)|0;o=t;while(1){if((l|0)>0){t=(f[(f[b>>2]|0)+(o<<2)>>2]|0)+1+((l|0)/-2|0)|0;a=l;L=l;M=0;N=0;while(1){O=t+N|0;P=f[G>>2]|0;Q=(O|0)>-1?((O|0)<(P|0)?O:P+-1|0):0;P=(M|0)<(N|0)?N:M;a:do if((P|0)<(a|0)){O=P;while(1){if((O|0)<16?(Q|0)==(f[i+(O<<2)>>2]|0):0)break;R=O+1|0;if((R|0)<(a|0))O=R;else{S=a;T=R;break a}}if((O|0)>(N|0)){K1a(f[h+(N<<2)>>2]|0,f[h+(O<<2)>>2]|0,J|0)|0;S=f[m>>2]|0;T=O}else{S=a;T=O}}else{S=a;T=P}while(0);L=(N|0)<(L|0)&(T|0)==(S|0)?N:L;P=(f[H>>2]|0)+(Y(f[f[I>>2]>>2]|0,Q)|0)|0;f[g+(N<<2)>>2]=P;f[i+(N<<2)>>2]=Q;N=N+1|0;if((N|0)>=(S|0))break;else{a=S;M=T}}if((S|0)>(L|0))Fka(d,g+(L<<2)|0,h+(L<<2)|0,S-L|0,f[w>>2]|0,f[x>>2]|0,f[y>>2]|0,f[k>>2]|0,j,f[z>>2]|0,f[A>>2]|0)}M=(f[B>>2]|0)+(Y(f[C>>2]|0,o)|0)|0;a=f[k>>2]|0;U=+n[K>>2];V=+n[K+4>>2];W=+n[K+8>>2];X=+n[K+12>>2];N=f[h>>2]|0;t=f[D>>2]|0;P=f[E>>2]|0;R=f[F>>2]|0;if((a|0)>0){Z=0;do{p[M+(Z<<3)>>3]=U*+p[N+(Z<<3)>>3]+V*+p[t+(Z<<3)>>3]+W*+p[P+(Z<<3)>>3]+X*+p[R+(Z<<3)>>3];Z=Z+1|0}while((Z|0)!=(a|0))}o=o+1|0;a=f[m>>2]|0;if((o|0)>=(f[q>>2]|0))break;else{l=a;K=K+(a<<2)|0}}_=f[e>>2]|0}else _=v;if((_|0)==(r|0)){u=c;return}if(_|0)QYa(_);f[e>>2]=r;f[s>>2]=136;u=c;return}function Fka(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;if((d|0)<=0)return;a=j<<1;m=0-(i<<2)|0;o=j<<1;q=j*3|0;r=g;g=0;while(1){s=f[b+(g<<2)>>2]|0;t=f[c+(g<<2)>>2]|0;u=r;v=0;w=k;a:while(1){if((w|0)>(v|0)){x=w-v<<2;y=u;z=v;while(1){A=f[e+(z<<2)>>2]|0;B=A-j|0;if(B>>>0<h>>>0)C=B;else{D=B;while(1)if((D|0)<0)D=D+j|0;else{E=D;break}while(1)if((E|0)<(h|0)){C=E;break}else E=E-j|0}F=+p[s+(C<<3)>>3]*+n[y>>2]+0.0;if(A>>>0<h>>>0)G=A;else{D=A;while(1)if((D|0)<0)D=D+j|0;else{H=D;break}while(1)if((H|0)<(h|0)){G=H;break}else H=H-j|0}I=F+ +p[s+(G<<3)>>3]*+n[y+4>>2];D=o+B|0;if(D>>>0<h>>>0)J=D;else{A=D;while(1)if((A|0)<0)A=A+j|0;else{K=A;break}while(1)if((K|0)<(h|0)){J=K;break}else K=K-j|0}F=I+ +p[s+(J<<3)>>3]*+n[y+8>>2];A=q+B|0;if(A>>>0<h>>>0)L=A;else{D=A;while(1)if((D|0)<0)D=D+j|0;else{M=D;break}while(1)if((M|0)<(h|0)){L=M;break}else M=M-j|0}p[t+(z<<3)>>3]=F+ +p[s+(L<<3)>>3]*+n[y+12>>2];z=z+1|0;if((z|0)==(w|0))break;else y=y+16|0}N=u+(x<<2)|0;O=w}else{N=u;O=v}if((w|0)==(i|0))break;if((O|0)<(l|0)){P=N;Q=O}else{u=N;v=O;w=i;continue}while(1){y=f[e+(Q<<2)>>2]|0;p[t+(Q<<3)>>3]=+p[s+(y-j<<3)>>3]*+n[P>>2]+ +p[s+(y<<3)>>3]*+n[P+4>>2]+ +p[s+(y+j<<3)>>3]*+n[P+8>>2]+ +p[s+(y+a<<3)>>3]*+n[P+12>>2];y=Q+1|0;z=P+16|0;if((y|0)<(l|0)){P=z;Q=y}else{u=z;v=l;w=i;continue a}}}g=g+1|0;if((g|0)==(d|0))break;else r=N+(m<<2)|0}return}function Gka(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=74632;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;BR(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;BR(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=c$(p,18)|0;n=323706;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));j$(-215,p,323725,323470,1485);d$(p);u=o;return}function Hka(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=74632;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function Ika(a){a=a|0;Hka(a);PYa(a);return}function Jka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Z=0;c=u;u=u+1264|0;d=c+1256|0;e=c+192|0;g=c+128|0;h=c+64|0;i=c;j=((f[a+4>>2]|0)>>>3&511)+1|0;k=a+140|0;l=(f[k>>2]|0)+15&-16;m=a+148|0;o=f[m>>2]|0;p=Y(l,o)|0;q=e+8|0;f[e>>2]=q;r=e+4|0;f[r>>2]=p;if(p>>>0>264){s=OYa(p>>>0>1073741823?-1:p<<2)|0;f[e>>2]=s;t=s}else t=q;s=g;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){F1a(i|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,l)|0)<<2)|0;f[h+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=h+4|0;D=h+8|0;E=h+12|0;F=a+136|0;G=a+20|0;H=a+48|0;I=l<<2;l=o;J=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;o=s;while(1){if((l|0)>0){s=(f[(f[b>>2]|0)+(o<<2)>>2]|0)+1+((l|0)/-2|0)|0;a=l;K=l;L=0;M=0;while(1){N=s+M|0;O=f[F>>2]|0;P=(N|0)>-1?((N|0)<(O|0)?N:O+-1|0):0;O=(L|0)<(M|0)?M:L;a:do if((O|0)<(a|0)){N=O;while(1){if((N|0)<16?(P|0)==(f[i+(N<<2)>>2]|0):0)break;Q=N+1|0;if((Q|0)<(a|0))N=Q;else{R=a;S=Q;break a}}if((N|0)>(M|0)){K1a(f[h+(M<<2)>>2]|0,f[h+(N<<2)>>2]|0,I|0)|0;R=f[m>>2]|0;S=N}else{R=a;S=N}}else{R=a;S=O}while(0);K=(M|0)<(K|0)&(S|0)==(R|0)?M:K;O=(f[G>>2]|0)+(Y(f[f[H>>2]>>2]|0,P)|0)|0;f[g+(M<<2)>>2]=O;f[i+(M<<2)>>2]=P;M=M+1|0;if((M|0)>=(R|0))break;else{a=R;L=S}}if((R|0)>(K|0))Kka(d,g+(K<<2)|0,h+(K<<2)|0,R-K|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[k>>2]|0,j,f[y>>2]|0,f[z>>2]|0)}L=(f[A>>2]|0)+(Y(f[B>>2]|0,o)|0)|0;a=f[k>>2]|0;T=+n[J>>2];U=+n[J+4>>2];V=+n[J+8>>2];W=+n[J+12>>2];M=f[h>>2]|0;s=f[C>>2]|0;O=f[D>>2]|0;Q=f[E>>2]|0;if((a|0)>0){X=0;do{n[L+(X<<2)>>2]=T*+n[M+(X<<2)>>2]+U*+n[s+(X<<2)>>2]+V*+n[O+(X<<2)>>2]+W*+n[Q+(X<<2)>>2];X=X+1|0}while((X|0)!=(a|0))}o=o+1|0;a=f[m>>2]|0;if((o|0)>=(f[p>>2]|0))break;else{l=a;J=J+(a<<2)|0}}Z=f[e>>2]|0}else Z=t;if((Z|0)==(q|0)){u=c;return}if(Z|0)QYa(Z);f[e>>2]=q;f[r>>2]=264;u=c;return}function Kka(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;if((d|0)<=0)return;a=j<<1;m=0-(i<<2)|0;o=j<<1;p=j*3|0;q=g;g=0;while(1){r=f[b+(g<<2)>>2]|0;s=f[c+(g<<2)>>2]|0;t=q;u=0;v=k;a:while(1){if((v|0)>(u|0)){w=v-u<<2;x=t;y=u;while(1){z=f[e+(y<<2)>>2]|0;A=z-j|0;if(A>>>0<h>>>0)B=A;else{C=A;while(1)if((C|0)<0)C=C+j|0;else{D=C;break}while(1)if((D|0)<(h|0)){B=D;break}else D=D-j|0}E=+n[r+(B<<2)>>2]*+n[x>>2]+0.0;if(z>>>0<h>>>0)F=z;else{C=z;while(1)if((C|0)<0)C=C+j|0;else{G=C;break}while(1)if((G|0)<(h|0)){F=G;break}else G=G-j|0}H=E+ +n[r+(F<<2)>>2]*+n[x+4>>2];C=o+A|0;if(C>>>0<h>>>0)I=C;else{z=C;while(1)if((z|0)<0)z=z+j|0;else{J=z;break}while(1)if((J|0)<(h|0)){I=J;break}else J=J-j|0}E=H+ +n[r+(I<<2)>>2]*+n[x+8>>2];z=p+A|0;if(z>>>0<h>>>0)K=z;else{C=z;while(1)if((C|0)<0)C=C+j|0;else{L=C;break}while(1)if((L|0)<(h|0)){K=L;break}else L=L-j|0}n[s+(y<<2)>>2]=E+ +n[r+(K<<2)>>2]*+n[x+12>>2];y=y+1|0;if((y|0)==(v|0))break;else x=x+16|0}M=t+(w<<2)|0;N=v}else{M=t;N=u}if((v|0)==(i|0))break;if((N|0)<(l|0)){O=M;P=N}else{t=M;u=N;v=i;continue}while(1){x=f[e+(P<<2)>>2]|0;n[s+(P<<2)>>2]=+n[r+(x-j<<2)>>2]*+n[O>>2]+ +n[r+(x<<2)>>2]*+n[O+4>>2]+ +n[r+(x+j<<2)>>2]*+n[O+8>>2]+ +n[r+(x+a<<2)>>2]*+n[O+12>>2];x=P+1|0;y=O+16|0;if((x|0)<(l|0)){O=y;P=x}else{t=y;u=l;v=i;continue a}}}g=g+1|0;if((g|0)==(d|0))break;else q=M+(m<<2)|0}return}function Lka(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=74652;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;BR(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;BR(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=c$(p,18)|0;n=323706;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));j$(-215,p,323725,323470,1485);d$(p);u=o;return}function Mka(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=74652;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function Nka(a){a=a|0;Mka(a);PYa(a);return}function Oka(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0,_=0,$=0;c=u;u=u+1264|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;o=a+148|0;p=f[o>>2]|0;q=Y(m,p)|0;r=g+8|0;f[g>>2]=r;s=g+4|0;f[s>>2]=q;if(q>>>0>264){t=OYa(q>>>0>1073741823?-1:q<<2)|0;f[g>>2]=t;v=t}else v=r;t=h;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));t=i;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));if((p|0)>0){F1a(j|0,-1,p<<2|0)|0;t=0;do{q=v+((Y(t,m)|0)<<2)|0;f[i+(t<<2)>>2]=q;t=t+1|0}while((t|0)<(p|0))}t=f[b>>2]|0;q=b+4|0;if((t|0)<(f[q>>2]|0)){b=a+120|0;w=a+116|0;x=a+124|0;y=a+132|0;z=a+152|0;A=a+156|0;B=a+76|0;C=a+108|0;D=i+4|0;E=i+8|0;F=i+12|0;G=a+136|0;H=a+20|0;I=a+48|0;J=m<<2;m=p;K=(f[a+128>>2]|0)+((Y(t,p)|0)<<2)|0;p=t;while(1){if((m|0)>0){t=(f[(f[b>>2]|0)+(p<<2)>>2]|0)+1+((m|0)/-2|0)|0;a=m;L=m;M=0;N=0;while(1){O=t+N|0;P=f[G>>2]|0;Q=(O|0)>-1?((O|0)<(P|0)?O:P+-1|0):0;P=(M|0)<(N|0)?N:M;a:do if((P|0)<(a|0)){O=P;while(1){if((O|0)<16?(Q|0)==(f[j+(O<<2)>>2]|0):0)break;R=O+1|0;if((R|0)<(a|0))O=R;else{S=a;T=R;break a}}if((O|0)>(N|0)){K1a(f[i+(N<<2)>>2]|0,f[i+(O<<2)>>2]|0,J|0)|0;S=f[o>>2]|0;T=O}else{S=a;T=O}}else{S=a;T=P}while(0);L=(N|0)<(L|0)&(T|0)==(S|0)?N:L;P=(f[H>>2]|0)+(Y(f[f[I>>2]>>2]|0,Q)|0)|0;f[h+(N<<2)>>2]=P;f[j+(N<<2)>>2]=Q;N=N+1|0;if((N|0)>=(S|0))break;else{a=S;M=T}}if((S|0)>(L|0))Pka(e,h+(L<<2)|0,i+(L<<2)|0,S-L|0,f[w>>2]|0,f[x>>2]|0,f[y>>2]|0,f[l>>2]|0,k,f[z>>2]|0,f[A>>2]|0)}M=(f[B>>2]|0)+(Y(f[C>>2]|0,p)|0)|0;a=f[l>>2]|0;U=+n[K>>2];V=+n[K+4>>2];W=+n[K+8>>2];X=+n[K+12>>2];N=f[i>>2]|0;t=f[D>>2]|0;P=f[E>>2]|0;R=f[F>>2]|0;if((a|0)>0){Z=0;do{_=wNa(U*+n[N+(Z<<2)>>2]+V*+n[t+(Z<<2)>>2]+W*+n[P+(Z<<2)>>2]+X*+n[R+(Z<<2)>>2])|0;d[M+(Z<<1)>>1]=(_+32768|0)>>>0<65536?_:(_|0)>0?32767:32768;Z=Z+1|0}while((Z|0)!=(a|0))}p=p+1|0;a=f[o>>2]|0;if((p|0)>=(f[q>>2]|0))break;else{m=a;K=K+(a<<2)|0}}$=f[g>>2]|0}else $=v;if(($|0)==(r|0)){u=c;return}if($|0)QYa($);f[g>>2]=r;f[s>>2]=264;u=c;return}function Pka(a,b,c,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;if((e|0)<=0)return;a=k<<1;o=0-(j<<2)|0;p=k<<1;q=k*3|0;r=h;h=0;while(1){s=f[b+(h<<2)>>2]|0;t=f[c+(h<<2)>>2]|0;u=r;v=0;w=l;a:while(1){if((w|0)>(v|0)){x=w-v<<2;y=u;z=v;while(1){A=f[g+(z<<2)>>2]|0;B=A-k|0;if(B>>>0<i>>>0)C=B;else{D=B;while(1)if((D|0)<0)D=D+k|0;else{E=D;break}while(1)if((E|0)<(i|0)){C=E;break}else E=E-k|0}F=+(d[s+(C<<1)>>1]|0)*+n[y>>2]+0.0;if(A>>>0<i>>>0)G=A;else{D=A;while(1)if((D|0)<0)D=D+k|0;else{H=D;break}while(1)if((H|0)<(i|0)){G=H;break}else H=H-k|0}I=F+ +(d[s+(G<<1)>>1]|0)*+n[y+4>>2];D=p+B|0;if(D>>>0<i>>>0)J=D;else{A=D;while(1)if((A|0)<0)A=A+k|0;else{K=A;break}while(1)if((K|0)<(i|0)){J=K;break}else K=K-k|0}F=I+ +(d[s+(J<<1)>>1]|0)*+n[y+8>>2];A=q+B|0;if(A>>>0<i>>>0)L=A;else{D=A;while(1)if((D|0)<0)D=D+k|0;else{M=D;break}while(1)if((M|0)<(i|0)){L=M;break}else M=M-k|0}n[t+(z<<2)>>2]=F+ +(d[s+(L<<1)>>1]|0)*+n[y+12>>2];z=z+1|0;if((z|0)==(w|0))break;else y=y+16|0}N=u+(x<<2)|0;O=w}else{N=u;O=v}if((w|0)==(j|0))break;if((O|0)<(m|0)){P=N;Q=O}else{u=N;v=O;w=j;continue}while(1){y=f[g+(Q<<2)>>2]|0;n[t+(Q<<2)>>2]=+(d[s+(y-k<<1)>>1]|0)*+n[P>>2]+ +(d[s+(y<<1)>>1]|0)*+n[P+4>>2]+ +(d[s+(y+k<<1)>>1]|0)*+n[P+8>>2]+ +(d[s+(y+a<<1)>>1]|0)*+n[P+12>>2];y=Q+1|0;z=P+16|0;if((y|0)<(m|0)){P=z;Q=y}else{u=z;v=m;w=j;continue a}}}h=h+1|0;if((h|0)==(e|0))break;else r=N+(o<<2)|0}return}function Qka(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=74672;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;BR(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;BR(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=c$(p,18)|0;n=323706;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));j$(-215,p,323725,323470,1485);d$(p);u=o;return}function Rka(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=74672;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function Ska(a){a=a|0;Rka(a);PYa(a);return}function Tka(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0,_=0,$=0;c=u;u=u+1264|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;o=a+148|0;p=f[o>>2]|0;q=Y(m,p)|0;r=g+8|0;f[g>>2]=r;s=g+4|0;f[s>>2]=q;if(q>>>0>264){t=OYa(q>>>0>1073741823?-1:q<<2)|0;f[g>>2]=t;v=t}else v=r;t=h;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));t=i;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));if((p|0)>0){F1a(j|0,-1,p<<2|0)|0;t=0;do{q=v+((Y(t,m)|0)<<2)|0;f[i+(t<<2)>>2]=q;t=t+1|0}while((t|0)<(p|0))}t=f[b>>2]|0;q=b+4|0;if((t|0)<(f[q>>2]|0)){b=a+120|0;w=a+116|0;x=a+124|0;y=a+132|0;z=a+152|0;A=a+156|0;B=a+76|0;C=a+108|0;D=i+4|0;E=i+8|0;F=i+12|0;G=a+136|0;H=a+20|0;I=a+48|0;J=m<<2;m=p;K=(f[a+128>>2]|0)+((Y(t,p)|0)<<2)|0;p=t;while(1){if((m|0)>0){t=(f[(f[b>>2]|0)+(p<<2)>>2]|0)+1+((m|0)/-2|0)|0;a=m;L=m;M=0;N=0;while(1){O=t+N|0;P=f[G>>2]|0;Q=(O|0)>-1?((O|0)<(P|0)?O:P+-1|0):0;P=(M|0)<(N|0)?N:M;a:do if((P|0)<(a|0)){O=P;while(1){if((O|0)<16?(Q|0)==(f[j+(O<<2)>>2]|0):0)break;R=O+1|0;if((R|0)<(a|0))O=R;else{S=a;T=R;break a}}if((O|0)>(N|0)){K1a(f[i+(N<<2)>>2]|0,f[i+(O<<2)>>2]|0,J|0)|0;S=f[o>>2]|0;T=O}else{S=a;T=O}}else{S=a;T=P}while(0);L=(N|0)<(L|0)&(T|0)==(S|0)?N:L;P=(f[H>>2]|0)+(Y(f[f[I>>2]>>2]|0,Q)|0)|0;f[h+(N<<2)>>2]=P;f[j+(N<<2)>>2]=Q;N=N+1|0;if((N|0)>=(S|0))break;else{a=S;M=T}}if((S|0)>(L|0))Uka(e,h+(L<<2)|0,i+(L<<2)|0,S-L|0,f[w>>2]|0,f[x>>2]|0,f[y>>2]|0,f[l>>2]|0,k,f[z>>2]|0,f[A>>2]|0)}M=(f[B>>2]|0)+(Y(f[C>>2]|0,p)|0)|0;a=f[l>>2]|0;U=+n[K>>2];V=+n[K+4>>2];W=+n[K+8>>2];X=+n[K+12>>2];N=f[i>>2]|0;t=f[D>>2]|0;P=f[E>>2]|0;R=f[F>>2]|0;if((a|0)>0){Z=0;do{_=wNa(U*+n[N+(Z<<2)>>2]+V*+n[t+(Z<<2)>>2]+W*+n[P+(Z<<2)>>2]+X*+n[R+(Z<<2)>>2])|0;d[M+(Z<<1)>>1]=_>>>0<65536?_:(_|0)>0?65535:0;Z=Z+1|0}while((Z|0)!=(a|0))}p=p+1|0;a=f[o>>2]|0;if((p|0)>=(f[q>>2]|0))break;else{m=a;K=K+(a<<2)|0}}$=f[g>>2]|0}else $=v;if(($|0)==(r|0)){u=c;return}if($|0)QYa($);f[g>>2]=r;f[s>>2]=264;u=c;return}function Uka(a,b,c,d,e,g,h,i,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;if((d|0)<=0)return;a=k<<1;o=0-(i<<2)|0;p=k<<1;q=k*3|0;r=g;g=0;while(1){s=f[b+(g<<2)>>2]|0;t=f[c+(g<<2)>>2]|0;u=r;v=0;w=l;a:while(1){if((w|0)>(v|0)){x=w-v<<2;y=u;z=v;while(1){A=f[e+(z<<2)>>2]|0;B=A-k|0;if(B>>>0<h>>>0)C=B;else{D=B;while(1)if((D|0)<0)D=D+k|0;else{E=D;break}while(1)if((E|0)<(h|0)){C=E;break}else E=E-k|0}F=+(j[s+(C<<1)>>1]|0)*+n[y>>2]+0.0;if(A>>>0<h>>>0)G=A;else{D=A;while(1)if((D|0)<0)D=D+k|0;else{H=D;break}while(1)if((H|0)<(h|0)){G=H;break}else H=H-k|0}I=F+ +(j[s+(G<<1)>>1]|0)*+n[y+4>>2];D=p+B|0;if(D>>>0<h>>>0)J=D;else{A=D;while(1)if((A|0)<0)A=A+k|0;else{K=A;break}while(1)if((K|0)<(h|0)){J=K;break}else K=K-k|0}F=I+ +(j[s+(J<<1)>>1]|0)*+n[y+8>>2];A=q+B|0;if(A>>>0<h>>>0)L=A;else{D=A;while(1)if((D|0)<0)D=D+k|0;else{M=D;break}while(1)if((M|0)<(h|0)){L=M;break}else M=M-k|0}n[t+(z<<2)>>2]=F+ +(j[s+(L<<1)>>1]|0)*+n[y+12>>2];z=z+1|0;if((z|0)==(w|0))break;else y=y+16|0}N=u+(x<<2)|0;O=w}else{N=u;O=v}if((w|0)==(i|0))break;if((O|0)<(m|0)){P=N;Q=O}else{u=N;v=O;w=i;continue}while(1){y=f[e+(Q<<2)>>2]|0;n[t+(Q<<2)>>2]=+(j[s+(y-k<<1)>>1]|0)*+n[P>>2]+ +(j[s+(y<<1)>>1]|0)*+n[P+4>>2]+ +(j[s+(y+k<<1)>>1]|0)*+n[P+8>>2]+ +(j[s+(y+a<<1)>>1]|0)*+n[P+12>>2];y=Q+1|0;z=P+16|0;if((y|0)<(m|0)){P=z;Q=y}else{u=z;v=m;w=i;continue a}}}g=g+1|0;if((g|0)==(d|0))break;else r=N+(o<<2)|0}return}function Vka(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=74692;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;BR(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;BR(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=c$(p,18)|0;n=323706;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));j$(-215,p,323725,323470,1485);d$(p);u=o;return}function Wka(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=74692;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function Xka(a){a=a|0;Wka(a);PYa(a);return}function Yka(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;e=u;u=u+1264|0;g=e+1256|0;h=e+192|0;i=e+128|0;j=e+64|0;k=e;l=((f[a+4>>2]|0)>>>3&511)+1|0;m=a+140|0;n=(f[m>>2]|0)+15&-16;o=a+148|0;p=f[o>>2]|0;q=Y(n,p)|0;r=h+8|0;f[h>>2]=r;s=h+4|0;f[s>>2]=q;if(q>>>0>264){t=OYa(q>>>0>1073741823?-1:q<<2)|0;f[h>>2]=t;v=t}else v=r;t=i;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));t=j;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));if((p|0)>0){F1a(k|0,-1,p<<2|0)|0;t=0;do{q=v+((Y(t,n)|0)<<2)|0;f[j+(t<<2)>>2]=q;t=t+1|0}while((t|0)<(p|0))}t=f[c>>2]|0;q=c+4|0;if((t|0)<(f[q>>2]|0)){c=a+120|0;w=a+116|0;x=a+124|0;y=a+132|0;z=a+152|0;A=a+156|0;B=a+76|0;C=a+108|0;D=j+4|0;E=j+8|0;F=j+12|0;G=a+136|0;H=a+20|0;I=a+48|0;J=n<<2;n=p;K=(f[a+128>>2]|0)+((Y(t,p)|0)<<1)|0;p=t;while(1){if((n|0)>0){t=(f[(f[c>>2]|0)+(p<<2)>>2]|0)+1+((n|0)/-2|0)|0;a=n;L=n;M=0;N=0;while(1){O=t+N|0;P=f[G>>2]|0;Q=(O|0)>-1?((O|0)<(P|0)?O:P+-1|0):0;P=(M|0)<(N|0)?N:M;a:do if((P|0)<(a|0)){O=P;while(1){if((O|0)<16?(Q|0)==(f[k+(O<<2)>>2]|0):0)break;R=O+1|0;if((R|0)<(a|0))O=R;else{S=a;T=R;break a}}if((O|0)>(N|0)){K1a(f[j+(N<<2)>>2]|0,f[j+(O<<2)>>2]|0,J|0)|0;S=f[o>>2]|0;T=O}else{S=a;T=O}}else{S=a;T=P}while(0);L=(N|0)<(L|0)&(T|0)==(S|0)?N:L;P=(f[H>>2]|0)+(Y(f[f[I>>2]>>2]|0,Q)|0)|0;f[i+(N<<2)>>2]=P;f[k+(N<<2)>>2]=Q;N=N+1|0;if((N|0)>=(S|0))break;else{a=S;M=T}}if((S|0)>(L|0))Zka(g,i+(L<<2)|0,j+(L<<2)|0,S-L|0,f[w>>2]|0,f[x>>2]|0,f[y>>2]|0,f[m>>2]|0,l,f[z>>2]|0,f[A>>2]|0)}M=(f[B>>2]|0)+(Y(f[C>>2]|0,p)|0)|0;a=f[m>>2]|0;N=d[K>>1]|0;t=d[K+2>>1]|0;P=d[K+4>>1]|0;R=d[K+6>>1]|0;U=f[j>>2]|0;V=f[D>>2]|0;W=f[E>>2]|0;X=f[F>>2]|0;if((a|0)>0){Z=0;do{_=Y(f[U+(Z<<2)>>2]|0,N)|0;$=Y(f[V+(Z<<2)>>2]|0,t)|0;aa=Y(f[W+(Z<<2)>>2]|0,P)|0;ba=_+2097152+$+aa+(Y(f[X+(Z<<2)>>2]|0,R)|0)>>22;b[M+Z>>0]=ba>>>0<256?ba:(ba|0)>0?255:0;Z=Z+1|0}while((Z|0)!=(a|0))}p=p+1|0;a=f[o>>2]|0;if((p|0)>=(f[q>>2]|0))break;else{n=a;K=K+(a<<1)|0}}ca=f[h>>2]|0}else ca=v;if((ca|0)==(r|0)){u=e;return}if(ca|0)QYa(ca);f[h>>2]=r;f[s>>2]=264;u=e;return}function Zka(a,b,c,e,g,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;if((e|0)<=0)return;a=l<<1;o=0-(k<<2)|0;p=l<<1;q=l*3|0;r=i;i=0;while(1){s=f[b+(i<<2)>>2]|0;t=f[c+(i<<2)>>2]|0;u=r;v=0;w=m;a:while(1){if((w|0)>(v|0)){x=w-v<<2;y=u;z=v;while(1){A=f[g+(z<<2)>>2]|0;B=A-l|0;if(B>>>0<j>>>0)C=B;else{D=B;while(1)if((D|0)<0)D=D+l|0;else{E=D;break}while(1)if((E|0)<(j|0)){C=E;break}else E=E-l|0}D=Y(d[y>>1]|0,h[s+C>>0]|0)|0;if(A>>>0<j>>>0)F=A;else{G=A;while(1)if((G|0)<0)G=G+l|0;else{H=G;break}while(1)if((H|0)<(j|0)){F=H;break}else H=H-l|0}G=(Y(d[y+2>>1]|0,h[s+F>>0]|0)|0)+D|0;A=p+B|0;if(A>>>0<j>>>0)I=A;else{J=A;while(1)if((J|0)<0)J=J+l|0;else{K=J;break}while(1)if((K|0)<(j|0)){I=K;break}else K=K-l|0}J=(Y(d[y+4>>1]|0,h[s+I>>0]|0)|0)+G|0;D=q+B|0;if(D>>>0<j>>>0)L=D;else{A=D;while(1)if((A|0)<0)A=A+l|0;else{M=A;break}while(1)if((M|0)<(j|0)){L=M;break}else M=M-l|0}A=(Y(d[y+6>>1]|0,h[s+L>>0]|0)|0)+J|0;f[t+(z<<2)>>2]=A;z=z+1|0;if((z|0)==(w|0))break;else y=y+8|0}N=u+(x<<1)|0;O=w}else{N=u;O=v}if((w|0)==(k|0))break;if((O|0)<(n|0)){P=N;Q=O}else{u=N;v=O;w=k;continue}while(1){y=f[g+(Q<<2)>>2]|0;z=Y(d[P>>1]|0,h[s+(y-l)>>0]|0)|0;A=(Y(d[P+2>>1]|0,h[s+y>>0]|0)|0)+z|0;z=A+(Y(d[P+4>>1]|0,h[s+(y+l)>>0]|0)|0)|0;A=z+(Y(d[P+6>>1]|0,h[s+(y+a)>>0]|0)|0)|0;f[t+(Q<<2)>>2]=A;A=Q+1|0;y=P+8|0;if((A|0)<(n|0)){P=y;Q=A}else{u=y;v=n;w=k;continue a}}}i=i+1|0;if((i|0)==(e|0))break;else r=N+(o<<1)|0}return}function _ka(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Bla(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);Cla(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);Cla(o);u=k;return}function $ka(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;vla(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);wla(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);wla(o);u=k;return}function ala(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;pla(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);qla(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);qla(o);u=k;return}function bla(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;jla(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);kla(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);kla(o);u=k;return}function cla(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;dla(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);ela(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);ela(o);u=k;return}function dla(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=74712;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;BR(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;BR(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=c$(p,18)|0;n=323706;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));j$(-215,p,323725,323470,1485);d$(p);u=o;return}function ela(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=74712;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function fla(a){a=a|0;ela(a);PYa(a);return}function gla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1296|0;d=c+1289|0;e=c+1288|0;g=c;h=c+1224|0;i=c+1160|0;j=c+1096|0;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>136){s=OYa(p>>>0>536870911?-1:p<<3)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){F1a(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<3)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<3;m=o;G=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;o=s;while(1){if((m|0)>0){s=(f[(f[b>>2]|0)+(o<<2)>>2]|0)+1+((m|0)/-2|0)|0;a=m;H=m;I=0;J=0;while(1){K=s+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(I|0)<(J|0)?J:I;a:do if((L|0)<(a|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(a|0))K=N;else{O=a;P=N;break a}}if((K|0)>(J|0)){K1a(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=a;P=K}}else{O=a;P=L}while(0);H=(J|0)<(H|0)&(P|0)==(O|0)?J:H;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{a=O;I=P}}if((O|0)>(H|0))hla(d,h+(H<<2)|0,i+(H<<2)|0,O-H|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,o)|0)|0;ila(e,i,I,G,f[l>>2]|0);o=o+1|0;I=f[n>>2]|0;if((o|0)>=(f[p>>2]|0))break;else{m=I;G=G+(I<<2)|0}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)QYa(Q);f[g>>2]=q;f[r>>2]=136;u=c;return}function hla(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0;a:do if((d|0)<2)m=0;else{k=d+-1|0;h=f[b>>2]|0;a=f[c>>2]|0;if((l|0)<=0){o=(i|0)>0;q=h;r=a;s=0;while(1){s=s+1|0;t=q;q=f[b+(s<<2)>>2]|0;u=r;r=f[c+(s<<2)>>2]|0;if(o){v=0;do{w=f[e+(v<<2)>>2]|0;p[u+(v<<3)>>3]=+p[t+(w<<3)>>3];p[r+(v<<3)>>3]=+p[q+(w<<3)>>3];v=v+1|0}while((v|0)!=(i|0))}if((s|0)==(k|0)){m=k;break a}}}s=(l|0)<(i|0);q=h;r=a;o=0;do{o=o+1|0;v=q;q=f[b+(o<<2)>>2]|0;t=r;r=f[c+(o<<2)>>2]|0;u=0;do{w=f[e+(u<<2)>>2]|0;x=u<<1;y=+n[g+(x<<2)>>2];z=+n[g+((x|1)<<2)>>2];x=w+j|0;A=y*+p[q+(w<<3)>>3]+z*+p[q+(x<<3)>>3];p[t+(u<<3)>>3]=y*+p[v+(w<<3)>>3]+z*+p[v+(x<<3)>>3];p[r+(u<<3)>>3]=A;u=u+1|0}while((u|0)!=(l|0));if(s){u=l;do{x=f[e+(u<<2)>>2]|0;p[t+(u<<3)>>3]=+p[v+(x<<3)>>3];p[r+(u<<3)>>3]=+p[q+(x<<3)>>3];u=u+1|0}while((u|0)!=(i|0))}}while((o|0)!=(k|0));m=k}while(0);if((m|0)>=(d|0))return;if((l|0)<=0){k=(i|0)>0;o=m;do{q=f[b+(o<<2)>>2]|0;r=f[c+(o<<2)>>2]|0;if(k){s=0;do{p[r+(s<<3)>>3]=+p[q+(f[e+(s<<2)>>2]<<3)>>3];s=s+1|0}while((s|0)!=(i|0))}o=o+1|0}while((o|0)!=(d|0));return}o=(l|0)<(i|0);k=m;do{m=f[b+(k<<2)>>2]|0;s=f[c+(k<<2)>>2]|0;q=0;do{r=f[e+(q<<2)>>2]|0;a=q<<1;p[s+(q<<3)>>3]=+p[m+(r<<3)>>3]*+n[g+(a<<2)>>2]+ +p[m+(r+j<<3)>>3]*+n[g+((a|1)<<2)>>2];q=q+1|0}while((q|0)!=(l|0));if(o){q=l;do{p[s+(q<<3)>>3]=+p[m+(f[e+(q<<2)>>2]<<3)>>3];q=q+1|0}while((q|0)!=(i|0))}k=k+1|0}while((k|0)!=(d|0));return}function ila(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0.0,h=0.0,i=0,j=0,k=0,l=0.0,m=0,o=0;g=+n[d>>2];h=+n[d+4>>2];d=f[b>>2]|0;a=f[b+4>>2]|0;b=e+-4|0;if((e|0)<4)i=0;else{j=0;do{k=j|1;l=g*+p[d+(k<<3)>>3]+h*+p[a+(k<<3)>>3];p[c+(j<<3)>>3]=g*+p[d+(j<<3)>>3]+h*+p[a+(j<<3)>>3];p[c+(k<<3)>>3]=l;k=j|2;m=j|3;l=g*+p[d+(m<<3)>>3]+h*+p[a+(m<<3)>>3];p[c+(k<<3)>>3]=g*+p[d+(k<<3)>>3]+h*+p[a+(k<<3)>>3];p[c+(m<<3)>>3]=l;j=j+4|0}while((j|0)<=(b|0));i=e&-4}if((i|0)<(e|0))o=i;else return;do{p[c+(o<<3)>>3]=g*+p[d+(o<<3)>>3]+h*+p[a+(o<<3)>>3];o=o+1|0}while((o|0)!=(e|0));return}function jla(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=74732;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;BR(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;BR(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=c$(p,18)|0;n=323706;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));j$(-215,p,323725,323470,1485);d$(p);u=o;return}function kla(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=74732;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function lla(a){a=a|0;kla(a);PYa(a);return}function mla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=OYa(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){F1a(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=o;G=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;o=s;while(1){if((m|0)>0){s=(f[(f[b>>2]|0)+(o<<2)>>2]|0)+1+((m|0)/-2|0)|0;a=m;H=m;I=0;J=0;while(1){K=s+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(I|0)<(J|0)?J:I;a:do if((L|0)<(a|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(a|0))K=N;else{O=a;P=N;break a}}if((K|0)>(J|0)){K1a(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=a;P=K}}else{O=a;P=L}while(0);H=(J|0)<(H|0)&(P|0)==(O|0)?J:H;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{a=O;I=P}}if((O|0)>(H|0))nla(d,h+(H<<2)|0,i+(H<<2)|0,O-H|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,o)|0)|0;ola(e,i,I,G,f[l>>2]|0);o=o+1|0;I=f[n>>2]|0;if((o|0)>=(f[p>>2]|0))break;else{m=I;G=G+(I<<2)|0}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)QYa(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function nla(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0;a:do if((d|0)<2)m=0;else{k=d+-1|0;h=f[b>>2]|0;a=f[c>>2]|0;if((l|0)<=0){o=(i|0)>0;p=h;q=a;r=0;while(1){r=r+1|0;s=p;p=f[b+(r<<2)>>2]|0;t=q;q=f[c+(r<<2)>>2]|0;if(o){u=0;do{v=f[e+(u<<2)>>2]|0;f[t+(u<<2)>>2]=f[s+(v<<2)>>2];f[q+(u<<2)>>2]=f[p+(v<<2)>>2];u=u+1|0}while((u|0)!=(i|0))}if((r|0)==(k|0)){m=k;break a}}}r=(l|0)<(i|0);p=h;q=a;o=0;do{o=o+1|0;u=p;p=f[b+(o<<2)>>2]|0;s=q;q=f[c+(o<<2)>>2]|0;t=0;do{v=f[e+(t<<2)>>2]|0;w=t<<1;x=+n[g+(w<<2)>>2];y=+n[g+((w|1)<<2)>>2];w=v+j|0;z=x*+n[p+(v<<2)>>2]+y*+n[p+(w<<2)>>2];n[s+(t<<2)>>2]=x*+n[u+(v<<2)>>2]+y*+n[u+(w<<2)>>2];n[q+(t<<2)>>2]=z;t=t+1|0}while((t|0)!=(l|0));if(r){t=l;do{w=f[e+(t<<2)>>2]|0;f[s+(t<<2)>>2]=f[u+(w<<2)>>2];f[q+(t<<2)>>2]=f[p+(w<<2)>>2];t=t+1|0}while((t|0)!=(i|0))}}while((o|0)!=(k|0));m=k}while(0);if((m|0)>=(d|0))return;if((l|0)<=0){k=(i|0)>0;o=m;do{p=f[b+(o<<2)>>2]|0;q=f[c+(o<<2)>>2]|0;if(k){r=0;do{f[q+(r<<2)>>2]=f[p+(f[e+(r<<2)>>2]<<2)>>2];r=r+1|0}while((r|0)!=(i|0))}o=o+1|0}while((o|0)!=(d|0));return}o=(l|0)<(i|0);k=m;do{m=f[b+(k<<2)>>2]|0;r=f[c+(k<<2)>>2]|0;p=0;do{q=f[e+(p<<2)>>2]|0;a=p<<1;n[r+(p<<2)>>2]=+n[m+(q<<2)>>2]*+n[g+(a<<2)>>2]+ +n[m+(q+j<<2)>>2]*+n[g+((a|1)<<2)>>2];p=p+1|0}while((p|0)!=(l|0));if(o){p=l;do{f[r+(p<<2)>>2]=f[m+(f[e+(p<<2)>>2]<<2)>>2];p=p+1|0}while((p|0)!=(i|0))}k=k+1|0}while((k|0)!=(d|0));return}function ola(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0.0,h=0.0,i=0,j=0,k=0,l=0.0,m=0,o=0;g=+n[d>>2];h=+n[d+4>>2];d=f[b>>2]|0;a=f[b+4>>2]|0;b=e+-4|0;if((e|0)<4)i=0;else{j=0;do{k=j|1;l=g*+n[d+(k<<2)>>2]+h*+n[a+(k<<2)>>2];n[c+(j<<2)>>2]=g*+n[d+(j<<2)>>2]+h*+n[a+(j<<2)>>2];n[c+(k<<2)>>2]=l;k=j|2;m=j|3;l=g*+n[d+(m<<2)>>2]+h*+n[a+(m<<2)>>2];n[c+(k<<2)>>2]=g*+n[d+(k<<2)>>2]+h*+n[a+(k<<2)>>2];n[c+(m<<2)>>2]=l;j=j+4|0}while((j|0)<=(b|0));i=e&-4}if((i|0)<(e|0))o=i;else return;do{n[c+(o<<2)>>2]=g*+n[d+(o<<2)>>2]+h*+n[a+(o<<2)>>2];o=o+1|0}while((o|0)!=(e|0));return}function pla(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=74752;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;BR(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;BR(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=c$(p,18)|0;n=323706;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));j$(-215,p,323725,323470,1485);d$(p);u=o;return}function qla(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=74752;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function rla(a){a=a|0;qla(a);PYa(a);return}function sla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=OYa(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){F1a(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=o;G=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;o=s;while(1){if((m|0)>0){s=(f[(f[b>>2]|0)+(o<<2)>>2]|0)+1+((m|0)/-2|0)|0;a=m;H=m;I=0;J=0;while(1){K=s+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(I|0)<(J|0)?J:I;a:do if((L|0)<(a|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(a|0))K=N;else{O=a;P=N;break a}}if((K|0)>(J|0)){K1a(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=a;P=K}}else{O=a;P=L}while(0);H=(J|0)<(H|0)&(P|0)==(O|0)?J:H;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{a=O;I=P}}if((O|0)>(H|0))tla(d,h+(H<<2)|0,i+(H<<2)|0,O-H|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,o)|0)|0;ula(e,i,I,G,f[l>>2]|0);o=o+1|0;I=f[n>>2]|0;if((o|0)>=(f[p>>2]|0))break;else{m=I;G=G+(I<<2)|0}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)QYa(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function tla(a,b,c,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0;a:do if((e|0)<2)o=0;else{l=e+-1|0;i=f[b>>2]|0;a=f[c>>2]|0;if((m|0)<=0){p=(j|0)>0;q=i;r=a;s=0;while(1){s=s+1|0;t=q;q=f[b+(s<<2)>>2]|0;u=r;r=f[c+(s<<2)>>2]|0;if(p){v=0;do{w=f[g+(v<<2)>>2]|0;n[u+(v<<2)>>2]=+(d[t+(w<<1)>>1]|0);n[r+(v<<2)>>2]=+(d[q+(w<<1)>>1]|0);v=v+1|0}while((v|0)!=(j|0))}if((s|0)==(l|0)){o=l;break a}}}s=(m|0)<(j|0);q=i;r=a;p=0;do{p=p+1|0;v=q;q=f[b+(p<<2)>>2]|0;t=r;r=f[c+(p<<2)>>2]|0;u=0;do{w=f[g+(u<<2)>>2]|0;x=u<<1;y=+n[h+(x<<2)>>2];z=+n[h+((x|1)<<2)>>2];x=w+k|0;A=y*+(d[q+(w<<1)>>1]|0)+z*+(d[q+(x<<1)>>1]|0);n[t+(u<<2)>>2]=y*+(d[v+(w<<1)>>1]|0)+z*+(d[v+(x<<1)>>1]|0);n[r+(u<<2)>>2]=A;u=u+1|0}while((u|0)!=(m|0));if(s){u=m;do{x=f[g+(u<<2)>>2]|0;n[t+(u<<2)>>2]=+(d[v+(x<<1)>>1]|0);n[r+(u<<2)>>2]=+(d[q+(x<<1)>>1]|0);u=u+1|0}while((u|0)!=(j|0))}}while((p|0)!=(l|0));o=l}while(0);if((o|0)>=(e|0))return;if((m|0)<=0){l=(j|0)>0;p=o;do{q=f[b+(p<<2)>>2]|0;r=f[c+(p<<2)>>2]|0;if(l){s=0;do{n[r+(s<<2)>>2]=+(d[q+(f[g+(s<<2)>>2]<<1)>>1]|0);s=s+1|0}while((s|0)!=(j|0))}p=p+1|0}while((p|0)!=(e|0));return}p=(m|0)<(j|0);l=o;do{o=f[b+(l<<2)>>2]|0;s=f[c+(l<<2)>>2]|0;q=0;do{r=f[g+(q<<2)>>2]|0;a=q<<1;n[s+(q<<2)>>2]=+(d[o+(r<<1)>>1]|0)*+n[h+(a<<2)>>2]+ +(d[o+(r+k<<1)>>1]|0)*+n[h+((a|1)<<2)>>2];q=q+1|0}while((q|0)!=(m|0));if(p){q=m;do{n[s+(q<<2)>>2]=+(d[o+(f[g+(q<<2)>>2]<<1)>>1]|0);q=q+1|0}while((q|0)!=(j|0))}l=l+1|0}while((l|0)!=(e|0));return}function ula(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0.0,i=0.0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0;h=+n[e>>2];i=+n[e+4>>2];e=f[b>>2]|0;a=f[b+4>>2]|0;b=g+-4|0;if((g|0)<4)j=0;else{k=0;do{l=k|1;m=h*+n[e+(l<<2)>>2]+i*+n[a+(l<<2)>>2];o=wNa(h*+n[e+(k<<2)>>2]+i*+n[a+(k<<2)>>2])|0;d[c+(k<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;o=wNa(m)|0;d[c+(l<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;o=k|2;l=k|3;m=h*+n[e+(l<<2)>>2]+i*+n[a+(l<<2)>>2];p=wNa(h*+n[e+(o<<2)>>2]+i*+n[a+(o<<2)>>2])|0;d[c+(o<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;p=wNa(m)|0;d[c+(l<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;k=k+4|0}while((k|0)<=(b|0));j=g&-4}if((j|0)<(g|0))q=j;else return;do{j=wNa(h*+n[e+(q<<2)>>2]+i*+n[a+(q<<2)>>2])|0;d[c+(q<<1)>>1]=(j+32768|0)>>>0<65536?j:(j|0)>0?32767:32768;q=q+1|0}while((q|0)!=(g|0));return}function vla(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=74772;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;BR(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;BR(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=c$(p,18)|0;n=323706;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));j$(-215,p,323725,323470,1485);d$(p);u=o;return}function wla(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=74772;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function xla(a){a=a|0;wla(a);PYa(a);return}function yla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=OYa(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){F1a(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=o;G=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;o=s;while(1){if((m|0)>0){s=(f[(f[b>>2]|0)+(o<<2)>>2]|0)+1+((m|0)/-2|0)|0;a=m;H=m;I=0;J=0;while(1){K=s+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(I|0)<(J|0)?J:I;a:do if((L|0)<(a|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(a|0))K=N;else{O=a;P=N;break a}}if((K|0)>(J|0)){K1a(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=a;P=K}}else{O=a;P=L}while(0);H=(J|0)<(H|0)&(P|0)==(O|0)?J:H;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{a=O;I=P}}if((O|0)>(H|0))zla(d,h+(H<<2)|0,i+(H<<2)|0,O-H|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,o)|0)|0;Ala(e,i,I,G,f[l>>2]|0);o=o+1|0;I=f[n>>2]|0;if((o|0)>=(f[p>>2]|0))break;else{m=I;G=G+(I<<2)|0}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)QYa(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function zla(a,b,c,d,e,g,h,i,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0;a:do if((d|0)<2)o=0;else{l=d+-1|0;h=f[b>>2]|0;a=f[c>>2]|0;if((m|0)<=0){p=(i|0)>0;q=h;r=a;s=0;while(1){s=s+1|0;t=q;q=f[b+(s<<2)>>2]|0;u=r;r=f[c+(s<<2)>>2]|0;if(p){v=0;do{w=f[e+(v<<2)>>2]|0;n[u+(v<<2)>>2]=+(j[t+(w<<1)>>1]|0);n[r+(v<<2)>>2]=+(j[q+(w<<1)>>1]|0);v=v+1|0}while((v|0)!=(i|0))}if((s|0)==(l|0)){o=l;break a}}}s=(m|0)<(i|0);q=h;r=a;p=0;do{p=p+1|0;v=q;q=f[b+(p<<2)>>2]|0;t=r;r=f[c+(p<<2)>>2]|0;u=0;do{w=f[e+(u<<2)>>2]|0;x=u<<1;y=+n[g+(x<<2)>>2];z=+n[g+((x|1)<<2)>>2];x=w+k|0;A=y*+(j[q+(w<<1)>>1]|0)+z*+(j[q+(x<<1)>>1]|0);n[t+(u<<2)>>2]=y*+(j[v+(w<<1)>>1]|0)+z*+(j[v+(x<<1)>>1]|0);n[r+(u<<2)>>2]=A;u=u+1|0}while((u|0)!=(m|0));if(s){u=m;do{x=f[e+(u<<2)>>2]|0;n[t+(u<<2)>>2]=+(j[v+(x<<1)>>1]|0);n[r+(u<<2)>>2]=+(j[q+(x<<1)>>1]|0);u=u+1|0}while((u|0)!=(i|0))}}while((p|0)!=(l|0));o=l}while(0);if((o|0)>=(d|0))return;if((m|0)<=0){l=(i|0)>0;p=o;do{q=f[b+(p<<2)>>2]|0;r=f[c+(p<<2)>>2]|0;if(l){s=0;do{n[r+(s<<2)>>2]=+(j[q+(f[e+(s<<2)>>2]<<1)>>1]|0);s=s+1|0}while((s|0)!=(i|0))}p=p+1|0}while((p|0)!=(d|0));return}p=(m|0)<(i|0);l=o;do{o=f[b+(l<<2)>>2]|0;s=f[c+(l<<2)>>2]|0;q=0;do{r=f[e+(q<<2)>>2]|0;a=q<<1;n[s+(q<<2)>>2]=+(j[o+(r<<1)>>1]|0)*+n[g+(a<<2)>>2]+ +(j[o+(r+k<<1)>>1]|0)*+n[g+((a|1)<<2)>>2];q=q+1|0}while((q|0)!=(m|0));if(p){q=m;do{n[s+(q<<2)>>2]=+(j[o+(f[e+(q<<2)>>2]<<1)>>1]|0);q=q+1|0}while((q|0)!=(i|0))}l=l+1|0}while((l|0)!=(d|0));return}function Ala(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0.0,i=0.0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0;h=+n[e>>2];i=+n[e+4>>2];e=f[b>>2]|0;a=f[b+4>>2]|0;b=g+-4|0;if((g|0)<4)j=0;else{k=0;do{l=k|1;m=h*+n[e+(l<<2)>>2]+i*+n[a+(l<<2)>>2];o=wNa(h*+n[e+(k<<2)>>2]+i*+n[a+(k<<2)>>2])|0;d[c+(k<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;o=wNa(m)|0;d[c+(l<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;o=k|2;l=k|3;m=h*+n[e+(l<<2)>>2]+i*+n[a+(l<<2)>>2];p=wNa(h*+n[e+(o<<2)>>2]+i*+n[a+(o<<2)>>2])|0;d[c+(o<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;p=wNa(m)|0;d[c+(l<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;k=k+4|0}while((k|0)<=(b|0));j=g&-4}if((j|0)<(g|0))q=j;else return;do{j=wNa(h*+n[e+(q<<2)>>2]+i*+n[a+(q<<2)>>2])|0;d[c+(q<<1)>>1]=j>>>0<65536?j:(j|0)>0?65535:0;q=q+1|0}while((q|0)!=(g|0));return}function Bla(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=74792;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;BR(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;BR(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=c$(p,18)|0;n=323706;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));j$(-215,p,323725,323470,1485);d$(p);u=o;return}function Cla(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=74792;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function Dla(a){a=a|0;Cla(a);PYa(a);return}function Ela(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=OYa(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){F1a(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=o;G=(f[a+128>>2]|0)+((Y(s,o)|0)<<1)|0;o=s;while(1){if((m|0)>0){s=(f[(f[b>>2]|0)+(o<<2)>>2]|0)+1+((m|0)/-2|0)|0;a=m;H=m;I=0;J=0;while(1){K=s+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(I|0)<(J|0)?J:I;a:do if((L|0)<(a|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(a|0))K=N;else{O=a;P=N;break a}}if((K|0)>(J|0)){K1a(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=a;P=K}}else{O=a;P=L}while(0);H=(J|0)<(H|0)&(P|0)==(O|0)?J:H;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{a=O;I=P}}if((O|0)>(H|0))Fla(d,h+(H<<2)|0,i+(H<<2)|0,O-H|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,o)|0)|0;Gla(e,i,I,G,f[l>>2]|0);o=o+1|0;I=f[n>>2]|0;if((o|0)>=(f[p>>2]|0))break;else{m=I;G=G+(I<<1)|0}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)QYa(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function Fla(a,b,c,e,g,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;a:do if((e|0)<2)o=0;else{m=e+-1|0;j=f[b>>2]|0;a=f[c>>2]|0;if((n|0)<=0){p=(k|0)>0;q=j;r=a;s=0;while(1){s=s+1|0;t=q;q=f[b+(s<<2)>>2]|0;u=r;r=f[c+(s<<2)>>2]|0;if(p){v=0;do{w=f[g+(v<<2)>>2]|0;f[u+(v<<2)>>2]=h[t+w>>0]<<11;f[r+(v<<2)>>2]=h[q+w>>0]<<11;v=v+1|0}while((v|0)!=(k|0))}if((s|0)==(m|0)){o=m;break a}}}s=(n|0)<(k|0);q=j;r=a;p=0;do{p=p+1|0;v=q;q=f[b+(p<<2)>>2]|0;t=r;r=f[c+(p<<2)>>2]|0;u=0;do{w=f[g+(u<<2)>>2]|0;x=u<<1;y=d[i+(x<<1)>>1]|0;z=d[i+((x|1)<<1)>>1]|0;x=Y(h[v+w>>0]|0,y)|0;A=w+l|0;B=(Y(h[v+A>>0]|0,z)|0)+x|0;x=Y(h[q+w>>0]|0,y)|0;y=(Y(h[q+A>>0]|0,z)|0)+x|0;f[t+(u<<2)>>2]=B;f[r+(u<<2)>>2]=y;u=u+1|0}while((u|0)!=(n|0));if(s){u=n;do{y=f[g+(u<<2)>>2]|0;f[t+(u<<2)>>2]=h[v+y>>0]<<11;f[r+(u<<2)>>2]=h[q+y>>0]<<11;u=u+1|0}while((u|0)!=(k|0))}}while((p|0)!=(m|0));o=m}while(0);if((o|0)>=(e|0))return;if((n|0)<=0){m=(k|0)>0;p=o;do{q=f[b+(p<<2)>>2]|0;r=f[c+(p<<2)>>2]|0;if(m){s=0;do{f[r+(s<<2)>>2]=h[q+(f[g+(s<<2)>>2]|0)>>0]<<11;s=s+1|0}while((s|0)!=(k|0))}p=p+1|0}while((p|0)!=(e|0));return}p=(n|0)<(k|0);m=o;do{o=f[b+(m<<2)>>2]|0;s=f[c+(m<<2)>>2]|0;q=0;do{r=f[g+(q<<2)>>2]|0;a=q<<1;j=Y(d[i+(a<<1)>>1]|0,h[o+r>>0]|0)|0;u=(Y(d[i+((a|1)<<1)>>1]|0,h[o+(r+l)>>0]|0)|0)+j|0;f[s+(q<<2)>>2]=u;q=q+1|0}while((q|0)!=(n|0));if(p){q=n;do{f[s+(q<<2)>>2]=h[o+(f[g+(q<<2)>>2]|0)>>0]<<11;q=q+1|0}while((q|0)!=(k|0))}m=m+1|0}while((m|0)!=(e|0));return}function Gla(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=d[g>>1]|0;i=d[g+2>>1]|0;g=f[c>>2]|0;j=f[c+4>>2]|0;c=h+-4|0;if((h|0)<4)k=0;else{l=a<<16>>16;m=i<<16>>16;n=0;do{o=(Y(f[g+(n<<2)>>2]>>4,l)|0)>>>16;p=(o+2+((Y(f[j+(n<<2)>>2]>>4,m)|0)>>>16)|0)>>>2&255;b[e+n>>0]=p;p=n|1;o=(Y(f[g+(p<<2)>>2]>>4,l)|0)>>>16;q=(o+2+((Y(f[j+(p<<2)>>2]>>4,m)|0)>>>16)|0)>>>2&255;b[e+p>>0]=q;q=n|2;p=(Y(f[g+(q<<2)>>2]>>4,l)|0)>>>16;o=(p+2+((Y(f[j+(q<<2)>>2]>>4,m)|0)>>>16)|0)>>>2&255;b[e+q>>0]=o;o=n|3;q=(Y(f[g+(o<<2)>>2]>>4,l)|0)>>>16;p=(q+2+((Y(f[j+(o<<2)>>2]>>4,m)|0)>>>16)|0)>>>2&255;b[e+o>>0]=p;n=n+4|0}while((n|0)<=(c|0));k=h&-4}if((k|0)>=(h|0))return;c=a<<16>>16;a=i<<16>>16;i=k;do{k=(Y(f[g+(i<<2)>>2]>>4,c)|0)>>>16;n=(k+2+((Y(f[j+(i<<2)>>2]>>4,a)|0)>>>16)|0)>>>2&255;b[e+i>>0]=n;i=i+1|0}while((i|0)!=(h|0));return}function Hla(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;ima(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);jma(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);jma(o);u=k;return}function Ila(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;cma(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);dma(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);dma(o);u=k;return}function Jla(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Yla(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);Zla(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);Zla(o);u=k;return}function Kla(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Sla(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);Tla(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);Tla(o);u=k;return}function Lla(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Mla(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);Nla(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;_U(n,o,y);Nla(o);u=k;return}function Mla(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=74812;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;BR(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;BR(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=c$(p,18)|0;n=323706;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));j$(-215,p,323725,323470,1485);d$(p);u=o;return}function Nla(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=74812;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function Ola(a){a=a|0;Nla(a);PYa(a);return}function Pla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1296|0;d=c+1289|0;e=c+1288|0;g=c;h=c+1224|0;i=c+1160|0;j=c+1096|0;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>136){s=OYa(p>>>0>536870911?-1:p<<3)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){F1a(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<3)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<3;m=o;G=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;o=s;while(1){if((m|0)>0){s=(f[(f[b>>2]|0)+(o<<2)>>2]|0)+1+((m|0)/-2|0)|0;a=m;H=m;I=0;J=0;while(1){K=s+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(I|0)<(J|0)?J:I;a:do if((L|0)<(a|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(a|0))K=N;else{O=a;P=N;break a}}if((K|0)>(J|0)){K1a(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=a;P=K}}else{O=a;P=L}while(0);H=(J|0)<(H|0)&(P|0)==(O|0)?J:H;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{a=O;I=P}}if((O|0)>(H|0))Qla(d,h+(H<<2)|0,i+(H<<2)|0,O-H|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,o)|0)|0;Rla(e,i,I,G,f[l>>2]|0);o=o+1|0;I=f[n>>2]|0;if((o|0)>=(f[p>>2]|0))break;else{m=I;G=G+(I<<2)|0}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)QYa(Q);f[g>>2]=q;f[r>>2]=136;u=c;return}function Qla(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;if((d|0)<=0)return;a=j*3|0;m=j<<1;o=j<<2;q=0-(i<<3)|0;r=g;g=0;while(1){s=f[b+(g<<2)>>2]|0;t=f[c+(g<<2)>>2]|0;u=r;v=0;w=k;a:while(1){if((w|0)>(v|0)){x=w-v<<3;y=u;z=v;while(1){A=f[e+(z<<2)>>2]|0;B=0;C=0.0;do{D=(Y(B+-3|0,j)|0)+A|0;if(D>>>0<h>>>0)E=D;else{F=D;while(1)if((F|0)<0)F=F+j|0;else{G=F;break}while(1)if((G|0)<(h|0)){E=G;break}else G=G-j|0}C=C+ +p[s+(E<<3)>>3]*+n[y+(B<<2)>>2];B=B+1|0}while((B|0)!=8);p[t+(z<<3)>>3]=C;z=z+1|0;if((z|0)==(w|0))break;else y=y+32|0}H=u+(x<<2)|0;I=w}else{H=u;I=v}if((w|0)==(i|0))break;if((I|0)<(l|0)){J=H;K=I}else{u=H;v=I;w=i;continue}while(1){y=f[e+(K<<2)>>2]|0;p[t+(K<<3)>>3]=+p[s+(y-a<<3)>>3]*+n[J>>2]+ +p[s+(y-m<<3)>>3]*+n[J+4>>2]+ +p[s+(y-j<<3)>>3]*+n[J+8>>2]+ +p[s+(y<<3)>>3]*+n[J+12>>2]+ +p[s+(y+j<<3)>>3]*+n[J+16>>2]+ +p[s+(y+m<<3)>>3]*+n[J+20>>2]+ +p[s+(y+a<<3)>>3]*+n[J+24>>2]+ +p[s+(y+o<<3)>>3]*+n[J+28>>2];y=K+1|0;z=J+32|0;if((y|0)<(l|0)){J=z;K=y}else{u=z;v=l;w=i;continue a}}}g=g+1|0;if((g|0)==(d|0))break;else r=H+(q<<2)|0}return}function Rla(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0.0,i=0,j=0,k=0.0,l=0,m=0.0,o=0,q=0.0,r=0,s=0.0,t=0.0,u=0,v=0.0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0;a=e+-4|0;if((e|0)<4)g=0;else{h=+n[d>>2];i=f[b>>2]|0;j=f[b+16>>2]|0;k=+n[d+4>>2];l=f[b+4>>2]|0;m=+n[d+8>>2];o=f[b+8>>2]|0;q=+n[d+12>>2];r=f[b+12>>2]|0;s=+n[d+16>>2];t=+n[d+20>>2];u=f[b+20>>2]|0;v=+n[d+24>>2];w=f[b+24>>2]|0;x=+n[d+28>>2];y=f[b+28>>2]|0;z=0;do{A=z|1;B=z|2;C=z|3;D=h*+p[i+(A<<3)>>3]+k*+p[l+(A<<3)>>3]+m*+p[o+(A<<3)>>3]+q*+p[r+(A<<3)>>3]+s*+p[j+(A<<3)>>3]+t*+p[u+(A<<3)>>3]+v*+p[w+(A<<3)>>3]+x*+p[y+(A<<3)>>3];E=h*+p[i+(B<<3)>>3]+k*+p[l+(B<<3)>>3]+m*+p[o+(B<<3)>>3]+q*+p[r+(B<<3)>>3]+s*+p[j+(B<<3)>>3]+t*+p[u+(B<<3)>>3]+v*+p[w+(B<<3)>>3]+x*+p[y+(B<<3)>>3];F=h*+p[i+(C<<3)>>3]+k*+p[l+(C<<3)>>3]+m*+p[o+(C<<3)>>3]+q*+p[r+(C<<3)>>3]+s*+p[j+(C<<3)>>3]+t*+p[u+(C<<3)>>3]+v*+p[w+(C<<3)>>3]+x*+p[y+(C<<3)>>3];p[c+(z<<3)>>3]=h*+p[i+(z<<3)>>3]+k*+p[l+(z<<3)>>3]+m*+p[o+(z<<3)>>3]+q*+p[r+(z<<3)>>3]+s*+p[j+(z<<3)>>3]+t*+p[u+(z<<3)>>3]+v*+p[w+(z<<3)>>3]+x*+p[y+(z<<3)>>3];p[c+(A<<3)>>3]=D;p[c+(B<<3)>>3]=E;p[c+(C<<3)>>3]=F;z=z+4|0}while((z|0)<=(a|0));g=e&-4}if((g|0)>=(e|0))return;a=f[b>>2]|0;x=+n[d>>2];z=f[b+4>>2]|0;v=+n[d+4>>2];y=f[b+8>>2]|0;t=+n[d+8>>2];w=f[b+12>>2]|0;s=+n[d+12>>2];u=f[b+16>>2]|0;q=+n[d+16>>2];j=f[b+20>>2]|0;m=+n[d+20>>2];r=f[b+24>>2]|0;k=+n[d+24>>2];o=f[b+28>>2]|0;h=+n[d+28>>2];d=g;do{p[c+(d<<3)>>3]=+p[a+(d<<3)>>3]*x+ +p[z+(d<<3)>>3]*v+ +p[y+(d<<3)>>3]*t+ +p[w+(d<<3)>>3]*s+ +p[u+(d<<3)>>3]*q+ +p[j+(d<<3)>>3]*m+ +p[r+(d<<3)>>3]*k+ +p[o+(d<<3)>>3]*h;d=d+1|0}while((d|0)!=(e|0));return}function Sla(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=74832;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;BR(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;BR(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=c$(p,18)|0;n=323706;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));j$(-215,p,323725,323470,1485);d$(p);u=o;return}function Tla(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=74832;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function Ula(a){a=a|0;Tla(a);PYa(a);return}function Vla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=OYa(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){F1a(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=o;G=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;o=s;while(1){if((m|0)>0){s=(f[(f[b>>2]|0)+(o<<2)>>2]|0)+1+((m|0)/-2|0)|0;a=m;H=m;I=0;J=0;while(1){K=s+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(I|0)<(J|0)?J:I;a:do if((L|0)<(a|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(a|0))K=N;else{O=a;P=N;break a}}if((K|0)>(J|0)){K1a(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=a;P=K}}else{O=a;P=L}while(0);H=(J|0)<(H|0)&(P|0)==(O|0)?J:H;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{a=O;I=P}}if((O|0)>(H|0))Wla(d,h+(H<<2)|0,i+(H<<2)|0,O-H|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,o)|0)|0;Xla(e,i,I,G,f[l>>2]|0);o=o+1|0;I=f[n>>2]|0;if((o|0)>=(f[p>>2]|0))break;else{m=I;G=G+(I<<2)|0}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)QYa(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function Wla(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;if((d|0)<=0)return;a=j*3|0;m=j<<1;o=j<<2;p=0-(i<<3)|0;q=g;g=0;while(1){r=f[b+(g<<2)>>2]|0;s=f[c+(g<<2)>>2]|0;t=q;u=0;v=k;a:while(1){if((v|0)>(u|0)){w=v-u<<3;x=t;y=u;while(1){z=f[e+(y<<2)>>2]|0;A=0;B=0.0;do{C=(Y(A+-3|0,j)|0)+z|0;if(C>>>0<h>>>0)D=C;else{E=C;while(1)if((E|0)<0)E=E+j|0;else{F=E;break}while(1)if((F|0)<(h|0)){D=F;break}else F=F-j|0}B=B+ +n[r+(D<<2)>>2]*+n[x+(A<<2)>>2];A=A+1|0}while((A|0)!=8);n[s+(y<<2)>>2]=B;y=y+1|0;if((y|0)==(v|0))break;else x=x+32|0}G=t+(w<<2)|0;H=v}else{G=t;H=u}if((v|0)==(i|0))break;if((H|0)<(l|0)){I=G;J=H}else{t=G;u=H;v=i;continue}while(1){x=f[e+(J<<2)>>2]|0;n[s+(J<<2)>>2]=+n[r+(x-a<<2)>>2]*+n[I>>2]+ +n[r+(x-m<<2)>>2]*+n[I+4>>2]+ +n[r+(x-j<<2)>>2]*+n[I+8>>2]+ +n[r+(x<<2)>>2]*+n[I+12>>2]+ +n[r+(x+j<<2)>>2]*+n[I+16>>2]+ +n[r+(x+m<<2)>>2]*+n[I+20>>2]+ +n[r+(x+a<<2)>>2]*+n[I+24>>2]+ +n[r+(x+o<<2)>>2]*+n[I+28>>2];x=J+1|0;y=I+32|0;if((x|0)<(l|0)){I=y;J=x}else{t=y;u=l;v=i;continue a}}}g=g+1|0;if((g|0)==(d|0))break;else q=G+(p<<2)|0}return}function Xla(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;a=e+-4|0;if((e|0)<4)g=0;else{h=f[b>>2]|0;i=d+4|0;j=f[b+16>>2]|0;k=f[b+20>>2]|0;l=f[b+4>>2]|0;m=d+8|0;o=f[b+8>>2]|0;p=d+12|0;q=f[b+12>>2]|0;r=d+16|0;s=d+20|0;t=d+24|0;u=f[b+24>>2]|0;v=d+28|0;w=f[b+28>>2]|0;x=0;do{y=+n[d>>2];z=x|1;A=x|2;B=x|3;C=+n[i>>2];D=+n[m>>2];E=+n[p>>2];F=+n[r>>2];G=+n[s>>2];H=+n[t>>2];I=+n[v>>2];J=y*+n[h+(z<<2)>>2]+C*+n[l+(z<<2)>>2]+D*+n[o+(z<<2)>>2]+E*+n[q+(z<<2)>>2]+F*+n[j+(z<<2)>>2]+G*+n[k+(z<<2)>>2]+H*+n[u+(z<<2)>>2]+I*+n[w+(z<<2)>>2];K=y*+n[h+(A<<2)>>2]+C*+n[l+(A<<2)>>2]+D*+n[o+(A<<2)>>2]+E*+n[q+(A<<2)>>2]+F*+n[j+(A<<2)>>2]+G*+n[k+(A<<2)>>2]+H*+n[u+(A<<2)>>2]+I*+n[w+(A<<2)>>2];L=y*+n[h+(B<<2)>>2]+C*+n[l+(B<<2)>>2]+D*+n[o+(B<<2)>>2]+E*+n[q+(B<<2)>>2]+F*+n[j+(B<<2)>>2]+G*+n[k+(B<<2)>>2]+H*+n[u+(B<<2)>>2]+I*+n[w+(B<<2)>>2];n[c+(x<<2)>>2]=y*+n[h+(x<<2)>>2]+C*+n[l+(x<<2)>>2]+D*+n[o+(x<<2)>>2]+E*+n[q+(x<<2)>>2]+F*+n[j+(x<<2)>>2]+G*+n[k+(x<<2)>>2]+H*+n[u+(x<<2)>>2]+I*+n[w+(x<<2)>>2];n[c+(z<<2)>>2]=J;n[c+(A<<2)>>2]=K;n[c+(B<<2)>>2]=L;x=x+4|0}while((x|0)<=(a|0));g=e&-4}if((g|0)>=(e|0))return;a=f[b>>2]|0;x=f[b+4>>2]|0;w=d+4|0;u=f[b+8>>2]|0;k=d+8|0;j=f[b+12>>2]|0;q=d+12|0;o=f[b+16>>2]|0;l=d+16|0;h=f[b+20>>2]|0;v=d+20|0;t=f[b+24>>2]|0;s=d+24|0;r=f[b+28>>2]|0;b=d+28|0;p=g;do{n[c+(p<<2)>>2]=+n[a+(p<<2)>>2]*+n[d>>2]+ +n[x+(p<<2)>>2]*+n[w>>2]+ +n[u+(p<<2)>>2]*+n[k>>2]+ +n[j+(p<<2)>>2]*+n[q>>2]+ +n[o+(p<<2)>>2]*+n[l>>2]+ +n[h+(p<<2)>>2]*+n[v>>2]+ +n[t+(p<<2)>>2]*+n[s>>2]+ +n[r+(p<<2)>>2]*+n[b>>2];p=p+1|0}while((p|0)!=(e|0));return}function Yla(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=74852;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;BR(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;BR(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=c$(p,18)|0;n=323706;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));j$(-215,p,323725,323470,1485);d$(p);u=o;return}function Zla(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=74852;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function _la(a){a=a|0;Zla(a);PYa(a);return}function $la(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=OYa(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){F1a(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=o;G=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;o=s;while(1){if((m|0)>0){s=(f[(f[b>>2]|0)+(o<<2)>>2]|0)+1+((m|0)/-2|0)|0;a=m;H=m;I=0;J=0;while(1){K=s+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(I|0)<(J|0)?J:I;a:do if((L|0)<(a|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(a|0))K=N;else{O=a;P=N;break a}}if((K|0)>(J|0)){K1a(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=a;P=K}}else{O=a;P=L}while(0);H=(J|0)<(H|0)&(P|0)==(O|0)?J:H;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{a=O;I=P}}if((O|0)>(H|0))ama(d,h+(H<<2)|0,i+(H<<2)|0,O-H|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,o)|0)|0;bma(e,i,I,G,f[l>>2]|0);o=o+1|0;I=f[n>>2]|0;if((o|0)>=(f[p>>2]|0))break;else{m=I;G=G+(I<<2)|0}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)QYa(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function ama(a,b,c,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;if((e|0)<=0)return;a=k*3|0;o=k<<1;p=k<<2;q=0-(j<<3)|0;r=h;h=0;while(1){s=f[b+(h<<2)>>2]|0;t=f[c+(h<<2)>>2]|0;u=r;v=0;w=l;a:while(1){if((w|0)>(v|0)){x=w-v<<3;y=u;z=v;while(1){A=f[g+(z<<2)>>2]|0;B=0;C=0.0;do{D=(Y(B+-3|0,k)|0)+A|0;if(D>>>0<i>>>0)E=D;else{F=D;while(1)if((F|0)<0)F=F+k|0;else{G=F;break}while(1)if((G|0)<(i|0)){E=G;break}else G=G-k|0}C=C+ +(d[s+(E<<1)>>1]|0)*+n[y+(B<<2)>>2];B=B+1|0}while((B|0)!=8);n[t+(z<<2)>>2]=C;z=z+1|0;if((z|0)==(w|0))break;else y=y+32|0}H=u+(x<<2)|0;I=w}else{H=u;I=v}if((w|0)==(j|0))break;if((I|0)<(m|0)){J=H;K=I}else{u=H;v=I;w=j;continue}while(1){y=f[g+(K<<2)>>2]|0;n[t+(K<<2)>>2]=+(d[s+(y-a<<1)>>1]|0)*+n[J>>2]+ +(d[s+(y-o<<1)>>1]|0)*+n[J+4>>2]+ +(d[s+(y-k<<1)>>1]|0)*+n[J+8>>2]+ +(d[s+(y<<1)>>1]|0)*+n[J+12>>2]+ +(d[s+(y+k<<1)>>1]|0)*+n[J+16>>2]+ +(d[s+(y+o<<1)>>1]|0)*+n[J+20>>2]+ +(d[s+(y+a<<1)>>1]|0)*+n[J+24>>2]+ +(d[s+(y+p<<1)>>1]|0)*+n[J+28>>2];y=K+1|0;z=J+32|0;if((y|0)<(m|0)){J=z;K=y}else{u=z;v=m;w=j;continue a}}}h=h+1|0;if((h|0)==(e|0))break;else r=H+(q<<2)|0}return}function bma(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0.0,l=0,m=0.0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0,v=0.0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0;a=g+-4|0;if((g|0)<4)h=0;else{i=+n[e>>2];j=f[b>>2]|0;k=+n[e+20>>2];l=f[b+20>>2]|0;m=+n[e+4>>2];o=f[b+4>>2]|0;p=+n[e+8>>2];q=f[b+8>>2]|0;r=+n[e+12>>2];s=f[b+12>>2]|0;t=+n[e+16>>2];u=f[b+16>>2]|0;v=+n[e+24>>2];w=f[b+24>>2]|0;x=+n[e+28>>2];y=f[b+28>>2]|0;z=0;do{A=z|1;B=z|2;C=z|3;D=i*+n[j+(A<<2)>>2]+m*+n[o+(A<<2)>>2]+p*+n[q+(A<<2)>>2]+r*+n[s+(A<<2)>>2]+t*+n[u+(A<<2)>>2]+k*+n[l+(A<<2)>>2]+v*+n[w+(A<<2)>>2]+x*+n[y+(A<<2)>>2];E=i*+n[j+(B<<2)>>2]+m*+n[o+(B<<2)>>2]+p*+n[q+(B<<2)>>2]+r*+n[s+(B<<2)>>2]+t*+n[u+(B<<2)>>2]+k*+n[l+(B<<2)>>2]+v*+n[w+(B<<2)>>2]+x*+n[y+(B<<2)>>2];F=i*+n[j+(C<<2)>>2]+m*+n[o+(C<<2)>>2]+p*+n[q+(C<<2)>>2]+r*+n[s+(C<<2)>>2]+t*+n[u+(C<<2)>>2]+k*+n[l+(C<<2)>>2]+v*+n[w+(C<<2)>>2]+x*+n[y+(C<<2)>>2];G=wNa(i*+n[j+(z<<2)>>2]+m*+n[o+(z<<2)>>2]+p*+n[q+(z<<2)>>2]+r*+n[s+(z<<2)>>2]+t*+n[u+(z<<2)>>2]+k*+n[l+(z<<2)>>2]+v*+n[w+(z<<2)>>2]+x*+n[y+(z<<2)>>2])|0;d[c+(z<<1)>>1]=(G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768;G=wNa(D)|0;d[c+(A<<1)>>1]=(G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768;G=wNa(E)|0;d[c+(B<<1)>>1]=(G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768;G=wNa(F)|0;d[c+(C<<1)>>1]=(G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768;z=z+4|0}while((z|0)<=(a|0));h=g&-4}if((h|0)>=(g|0))return;a=f[b>>2]|0;x=+n[e>>2];z=f[b+4>>2]|0;v=+n[e+4>>2];y=f[b+8>>2]|0;k=+n[e+8>>2];w=f[b+12>>2]|0;t=+n[e+12>>2];l=f[b+16>>2]|0;r=+n[e+16>>2];u=f[b+20>>2]|0;p=+n[e+20>>2];s=f[b+24>>2]|0;m=+n[e+24>>2];q=f[b+28>>2]|0;i=+n[e+28>>2];e=h;do{h=wNa(+n[a+(e<<2)>>2]*x+ +n[z+(e<<2)>>2]*v+ +n[y+(e<<2)>>2]*k+ +n[w+(e<<2)>>2]*t+ +n[l+(e<<2)>>2]*r+ +n[u+(e<<2)>>2]*p+ +n[s+(e<<2)>>2]*m+ +n[q+(e<<2)>>2]*i)|0;d[c+(e<<1)>>1]=(h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768;e=e+1|0}while((e|0)!=(g|0));return}function cma(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=74872;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;BR(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;BR(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=c$(p,18)|0;n=323706;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));j$(-215,p,323725,323470,1485);d$(p);u=o;return}function dma(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=74872;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function ema(a){a=a|0;dma(a);PYa(a);return}function fma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=OYa(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){F1a(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=o;G=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;o=s;while(1){if((m|0)>0){s=(f[(f[b>>2]|0)+(o<<2)>>2]|0)+1+((m|0)/-2|0)|0;a=m;H=m;I=0;J=0;while(1){K=s+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(I|0)<(J|0)?J:I;a:do if((L|0)<(a|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(a|0))K=N;else{O=a;P=N;break a}}if((K|0)>(J|0)){K1a(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=a;P=K}}else{O=a;P=L}while(0);H=(J|0)<(H|0)&(P|0)==(O|0)?J:H;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{a=O;I=P}}if((O|0)>(H|0))gma(d,h+(H<<2)|0,i+(H<<2)|0,O-H|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,o)|0)|0;hma(e,i,I,G,f[l>>2]|0);o=o+1|0;I=f[n>>2]|0;if((o|0)>=(f[p>>2]|0))break;else{m=I;G=G+(I<<2)|0}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)QYa(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function gma(a,b,c,d,e,g,h,i,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;if((d|0)<=0)return;a=k*3|0;o=k<<1;p=k<<2;q=0-(i<<3)|0;r=g;g=0;while(1){s=f[b+(g<<2)>>2]|0;t=f[c+(g<<2)>>2]|0;u=r;v=0;w=l;a:while(1){if((w|0)>(v|0)){x=w-v<<3;y=u;z=v;while(1){A=f[e+(z<<2)>>2]|0;B=0;C=0.0;do{D=(Y(B+-3|0,k)|0)+A|0;if(D>>>0<h>>>0)E=D;else{F=D;while(1)if((F|0)<0)F=F+k|0;else{G=F;break}while(1)if((G|0)<(h|0)){E=G;break}else G=G-k|0}C=C+ +(j[s+(E<<1)>>1]|0)*+n[y+(B<<2)>>2];B=B+1|0}while((B|0)!=8);n[t+(z<<2)>>2]=C;z=z+1|0;if((z|0)==(w|0))break;else y=y+32|0}H=u+(x<<2)|0;I=w}else{H=u;I=v}if((w|0)==(i|0))break;if((I|0)<(m|0)){J=H;K=I}else{u=H;v=I;w=i;continue}while(1){y=f[e+(K<<2)>>2]|0;n[t+(K<<2)>>2]=+(j[s+(y-a<<1)>>1]|0)*+n[J>>2]+ +(j[s+(y-o<<1)>>1]|0)*+n[J+4>>2]+ +(j[s+(y-k<<1)>>1]|0)*+n[J+8>>2]+ +(j[s+(y<<1)>>1]|0)*+n[J+12>>2]+ +(j[s+(y+k<<1)>>1]|0)*+n[J+16>>2]+ +(j[s+(y+o<<1)>>1]|0)*+n[J+20>>2]+ +(j[s+(y+a<<1)>>1]|0)*+n[J+24>>2]+ +(j[s+(y+p<<1)>>1]|0)*+n[J+28>>2];y=K+1|0;z=J+32|0;if((y|0)<(m|0)){J=z;K=y}else{u=z;v=m;w=i;continue a}}}g=g+1|0;if((g|0)==(d|0))break;else r=H+(q<<2)|0}return}function hma(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0.0,l=0,m=0.0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0,v=0.0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0;a=g+-4|0;if((g|0)<4)h=0;else{i=+n[e>>2];j=f[b>>2]|0;k=+n[e+20>>2];l=f[b+20>>2]|0;m=+n[e+4>>2];o=f[b+4>>2]|0;p=+n[e+8>>2];q=f[b+8>>2]|0;r=+n[e+12>>2];s=f[b+12>>2]|0;t=+n[e+16>>2];u=f[b+16>>2]|0;v=+n[e+24>>2];w=f[b+24>>2]|0;x=+n[e+28>>2];y=f[b+28>>2]|0;z=0;do{A=z|1;B=z|2;C=z|3;D=i*+n[j+(A<<2)>>2]+m*+n[o+(A<<2)>>2]+p*+n[q+(A<<2)>>2]+r*+n[s+(A<<2)>>2]+t*+n[u+(A<<2)>>2]+k*+n[l+(A<<2)>>2]+v*+n[w+(A<<2)>>2]+x*+n[y+(A<<2)>>2];E=i*+n[j+(B<<2)>>2]+m*+n[o+(B<<2)>>2]+p*+n[q+(B<<2)>>2]+r*+n[s+(B<<2)>>2]+t*+n[u+(B<<2)>>2]+k*+n[l+(B<<2)>>2]+v*+n[w+(B<<2)>>2]+x*+n[y+(B<<2)>>2];F=i*+n[j+(C<<2)>>2]+m*+n[o+(C<<2)>>2]+p*+n[q+(C<<2)>>2]+r*+n[s+(C<<2)>>2]+t*+n[u+(C<<2)>>2]+k*+n[l+(C<<2)>>2]+v*+n[w+(C<<2)>>2]+x*+n[y+(C<<2)>>2];G=wNa(i*+n[j+(z<<2)>>2]+m*+n[o+(z<<2)>>2]+p*+n[q+(z<<2)>>2]+r*+n[s+(z<<2)>>2]+t*+n[u+(z<<2)>>2]+k*+n[l+(z<<2)>>2]+v*+n[w+(z<<2)>>2]+x*+n[y+(z<<2)>>2])|0;d[c+(z<<1)>>1]=G>>>0<65536?G:(G|0)>0?65535:0;G=wNa(D)|0;d[c+(A<<1)>>1]=G>>>0<65536?G:(G|0)>0?65535:0;G=wNa(E)|0;d[c+(B<<1)>>1]=G>>>0<65536?G:(G|0)>0?65535:0;G=wNa(F)|0;d[c+(C<<1)>>1]=G>>>0<65536?G:(G|0)>0?65535:0;z=z+4|0}while((z|0)<=(a|0));h=g&-4}if((h|0)>=(g|0))return;a=f[b>>2]|0;x=+n[e>>2];z=f[b+4>>2]|0;v=+n[e+4>>2];y=f[b+8>>2]|0;k=+n[e+8>>2];w=f[b+12>>2]|0;t=+n[e+12>>2];l=f[b+16>>2]|0;r=+n[e+16>>2];u=f[b+20>>2]|0;p=+n[e+20>>2];s=f[b+24>>2]|0;m=+n[e+24>>2];q=f[b+28>>2]|0;i=+n[e+28>>2];e=h;do{h=wNa(+n[a+(e<<2)>>2]*x+ +n[z+(e<<2)>>2]*v+ +n[y+(e<<2)>>2]*k+ +n[w+(e<<2)>>2]*t+ +n[l+(e<<2)>>2]*r+ +n[u+(e<<2)>>2]*p+ +n[s+(e<<2)>>2]*m+ +n[q+(e<<2)>>2]*i)|0;d[c+(e<<1)>>1]=h>>>0<65536?h:(h|0)>0?65535:0;e=e+1|0}while((e|0)!=(g|0));return}function ima(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=74892;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;BR(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;BR(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=c$(p,18)|0;n=323706;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));j$(-215,p,323725,323470,1485);d$(p);u=o;return}function jma(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=74892;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function kma(a){a=a|0;jma(a);PYa(a);return}function lma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=OYa(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){F1a(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=o;G=(f[a+128>>2]|0)+((Y(s,o)|0)<<1)|0;o=s;while(1){if((m|0)>0){s=(f[(f[b>>2]|0)+(o<<2)>>2]|0)+1+((m|0)/-2|0)|0;a=m;H=m;I=0;J=0;while(1){K=s+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(I|0)<(J|0)?J:I;a:do if((L|0)<(a|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(a|0))K=N;else{O=a;P=N;break a}}if((K|0)>(J|0)){K1a(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=a;P=K}}else{O=a;P=L}while(0);H=(J|0)<(H|0)&(P|0)==(O|0)?J:H;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{a=O;I=P}}if((O|0)>(H|0))mma(d,h+(H<<2)|0,i+(H<<2)|0,O-H|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,o)|0)|0;nma(e,i,I,G,f[l>>2]|0);o=o+1|0;I=f[n>>2]|0;if((o|0)>=(f[p>>2]|0))break;else{m=I;G=G+(I<<1)|0}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)QYa(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function mma(a,b,c,e,g,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;if((e|0)<=0)return;a=l*3|0;o=l<<1;p=l<<2;q=0-(k<<3)|0;r=i;i=0;while(1){s=f[b+(i<<2)>>2]|0;t=f[c+(i<<2)>>2]|0;u=r;v=0;w=m;a:while(1){if((w|0)>(v|0)){x=w-v<<3;y=u;z=v;while(1){A=f[g+(z<<2)>>2]|0;B=0;C=0;do{D=(Y(B+-3|0,l)|0)+A|0;if(D>>>0<j>>>0)E=D;else{F=D;while(1)if((F|0)<0)F=F+l|0;else{G=F;break}while(1)if((G|0)<(j|0)){E=G;break}else G=G-l|0}C=(Y(d[y+(B<<1)>>1]|0,h[s+E>>0]|0)|0)+C|0;B=B+1|0}while((B|0)!=8);f[t+(z<<2)>>2]=C;z=z+1|0;if((z|0)==(w|0))break;else y=y+16|0}H=u+(x<<1)|0;I=w}else{H=u;I=v}if((w|0)==(k|0))break;if((I|0)<(n|0)){J=H;K=I}else{u=H;v=I;w=k;continue}while(1){y=f[g+(K<<2)>>2]|0;z=Y(d[J>>1]|0,h[s+(y-a)>>0]|0)|0;B=(Y(d[J+2>>1]|0,h[s+(y-o)>>0]|0)|0)+z|0;z=B+(Y(d[J+4>>1]|0,h[s+(y-l)>>0]|0)|0)|0;B=z+(Y(d[J+6>>1]|0,h[s+y>>0]|0)|0)|0;z=B+(Y(d[J+8>>1]|0,h[s+(y+l)>>0]|0)|0)|0;B=z+(Y(d[J+10>>1]|0,h[s+(y+o)>>0]|0)|0)|0;z=B+(Y(d[J+12>>1]|0,h[s+(y+a)>>0]|0)|0)|0;B=z+(Y(d[J+14>>1]|0,h[s+(y+p)>>0]|0)|0)|0;f[t+(K<<2)>>2]=B;B=K+1|0;y=J+16|0;if((B|0)<(n|0)){J=y;K=B}else{u=y;v=n;w=k;continue a}}}i=i+1|0;if((i|0)==(e|0))break;else r=H+(q<<1)|0}return}function nma(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;a=h+-4|0;if((h|0)<4)i=0;else{j=g+2|0;k=c+4|0;l=g+4|0;m=c+8|0;n=g+6|0;o=c+12|0;p=g+8|0;q=c+16|0;r=g+10|0;s=c+20|0;t=g+12|0;u=c+24|0;v=g+14|0;w=c+28|0;x=0;do{y=d[g>>1]|0;z=f[c>>2]|0;A=Y(f[z+(x<<2)>>2]|0,y)|0;B=x|1;C=Y(f[z+(B<<2)>>2]|0,y)|0;D=x|2;E=Y(f[z+(D<<2)>>2]|0,y)|0;F=x|3;G=Y(f[z+(F<<2)>>2]|0,y)|0;y=d[j>>1]|0;z=f[k>>2]|0;H=(Y(f[z+(x<<2)>>2]|0,y)|0)+A|0;A=(Y(f[z+(B<<2)>>2]|0,y)|0)+C|0;C=(Y(f[z+(D<<2)>>2]|0,y)|0)+E|0;E=(Y(f[z+(F<<2)>>2]|0,y)|0)+G|0;G=d[l>>1]|0;y=f[m>>2]|0;z=(Y(f[y+(x<<2)>>2]|0,G)|0)+H|0;H=(Y(f[y+(B<<2)>>2]|0,G)|0)+A|0;A=(Y(f[y+(D<<2)>>2]|0,G)|0)+C|0;C=(Y(f[y+(F<<2)>>2]|0,G)|0)+E|0;E=d[n>>1]|0;G=f[o>>2]|0;y=(Y(f[G+(x<<2)>>2]|0,E)|0)+z|0;z=(Y(f[G+(B<<2)>>2]|0,E)|0)+H|0;H=(Y(f[G+(D<<2)>>2]|0,E)|0)+A|0;A=(Y(f[G+(F<<2)>>2]|0,E)|0)+C|0;C=d[p>>1]|0;E=f[q>>2]|0;G=(Y(f[E+(x<<2)>>2]|0,C)|0)+y|0;y=(Y(f[E+(B<<2)>>2]|0,C)|0)+z|0;z=(Y(f[E+(D<<2)>>2]|0,C)|0)+H|0;H=(Y(f[E+(F<<2)>>2]|0,C)|0)+A|0;A=d[r>>1]|0;C=f[s>>2]|0;E=(Y(f[C+(x<<2)>>2]|0,A)|0)+G|0;G=(Y(f[C+(B<<2)>>2]|0,A)|0)+y|0;y=(Y(f[C+(D<<2)>>2]|0,A)|0)+z|0;z=(Y(f[C+(F<<2)>>2]|0,A)|0)+H|0;H=d[t>>1]|0;A=f[u>>2]|0;C=(Y(f[A+(x<<2)>>2]|0,H)|0)+E|0;E=(Y(f[A+(B<<2)>>2]|0,H)|0)+G|0;G=(Y(f[A+(D<<2)>>2]|0,H)|0)+y|0;y=(Y(f[A+(F<<2)>>2]|0,H)|0)+z|0;z=d[v>>1]|0;H=f[w>>2]|0;A=(Y(f[H+(x<<2)>>2]|0,z)|0)+C|0;C=(Y(f[H+(B<<2)>>2]|0,z)|0)+E|0;E=(Y(f[H+(D<<2)>>2]|0,z)|0)+G|0;G=(Y(f[H+(F<<2)>>2]|0,z)|0)+y|0;y=A+2097152>>22;b[e+x>>0]=y>>>0<256?y:(y|0)>0?255:0;y=C+2097152>>22;b[e+B>>0]=y>>>0<256?y:(y|0)>0?255:0;y=E+2097152>>22;b[e+D>>0]=y>>>0<256?y:(y|0)>0?255:0;y=G+2097152>>22;b[e+F>>0]=y>>>0<256?y:(y|0)>0?255:0;x=x+4|0}while((x|0)<=(a|0));i=h&-4}if((i|0)>=(h|0))return;a=c+4|0;x=g+2|0;w=c+8|0;v=g+4|0;u=c+12|0;t=g+6|0;s=c+16|0;r=g+8|0;q=c+20|0;p=g+10|0;o=c+24|0;n=g+12|0;m=c+28|0;l=g+14|0;k=i;do{i=Y(d[g>>1]|0,f[(f[c>>2]|0)+(k<<2)>>2]|0)|0;j=Y(d[x>>1]|0,f[(f[a>>2]|0)+(k<<2)>>2]|0)|0;y=Y(d[v>>1]|0,f[(f[w>>2]|0)+(k<<2)>>2]|0)|0;F=Y(d[t>>1]|0,f[(f[u>>2]|0)+(k<<2)>>2]|0)|0;G=Y(d[r>>1]|0,f[(f[s>>2]|0)+(k<<2)>>2]|0)|0;D=Y(d[p>>1]|0,f[(f[q>>2]|0)+(k<<2)>>2]|0)|0;E=Y(d[n>>1]|0,f[(f[o>>2]|0)+(k<<2)>>2]|0)|0;B=i+2097152+j+y+F+G+D+E+(Y(d[l>>1]|0,f[(f[m>>2]|0)+(k<<2)>>2]|0)|0)>>22;b[e+k>>0]=B>>>0<256?B:(B|0)>0?255:0;k=k+1|0}while((k|0)!=(h|0));return}function oma(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;i=u;u=u+48|0;j=i+32|0;k=i;l=f[b+8>>2]|0;f[j>>2]=0;f[j+4>>2]=l;f[k>>2]=74992;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+20>>2]=d;f[k+16>>2]=e;f[k+24>>2]=g;f[k+28>>2]=h;h=f[b+4>>2]|0;if((h|0)<3){m=Y(f[b+12>>2]|0,l)|0;n=+(m>>>0);o=n*.0000152587890625;_U(j,k,o);u=i;return}l=f[b+40>>2]|0;b=0;g=1;while(1){e=Y(f[l+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(h|0)){m=e;break}else g=e}n=+(m>>>0);o=n*.0000152587890625;_U(j,k,o);u=i;return}function pma(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;i=u;u=u+48|0;j=i+32|0;k=i;l=f[b+8>>2]|0;f[j>>2]=0;f[j+4>>2]=l;f[k>>2]=74972;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+20>>2]=d;f[k+16>>2]=e;f[k+24>>2]=g;f[k+28>>2]=h;h=f[b+4>>2]|0;if((h|0)<3){m=Y(f[b+12>>2]|0,l)|0;n=+(m>>>0);o=n*.0000152587890625;_U(j,k,o);u=i;return}l=f[b+40>>2]|0;b=0;g=1;while(1){e=Y(f[l+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(h|0)){m=e;break}else g=e}n=+(m>>>0);o=n*.0000152587890625;_U(j,k,o);u=i;return}function qma(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;i=u;u=u+48|0;j=i+32|0;k=i;l=f[b+8>>2]|0;f[j>>2]=0;f[j+4>>2]=l;f[k>>2]=74952;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+20>>2]=d;f[k+16>>2]=e;f[k+24>>2]=g;f[k+28>>2]=h;h=f[b+4>>2]|0;if((h|0)<3){m=Y(f[b+12>>2]|0,l)|0;n=+(m>>>0);o=n*.0000152587890625;_U(j,k,o);u=i;return}l=f[b+40>>2]|0;b=0;g=1;while(1){e=Y(f[l+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(h|0)){m=e;break}else g=e}n=+(m>>>0);o=n*.0000152587890625;_U(j,k,o);u=i;return}function rma(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;i=u;u=u+48|0;j=i+32|0;k=i;l=f[b+8>>2]|0;f[j>>2]=0;f[j+4>>2]=l;f[k>>2]=74932;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+20>>2]=d;f[k+16>>2]=e;f[k+24>>2]=g;f[k+28>>2]=h;h=f[b+4>>2]|0;if((h|0)<3){m=Y(f[b+12>>2]|0,l)|0;n=+(m>>>0);o=n*.0000152587890625;_U(j,k,o);u=i;return}l=f[b+40>>2]|0;b=0;g=1;while(1){e=Y(f[l+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(h|0)){m=e;break}else g=e}n=+(m>>>0);o=n*.0000152587890625;_U(j,k,o);u=i;return}function sma(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;i=u;u=u+48|0;j=i+32|0;k=i;l=f[b+8>>2]|0;f[j>>2]=0;f[j+4>>2]=l;f[k>>2]=74912;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+20>>2]=d;f[k+16>>2]=e;f[k+24>>2]=g;f[k+28>>2]=h;h=f[b+4>>2]|0;if((h|0)<3){m=Y(f[b+12>>2]|0,l)|0;n=+(m>>>0);o=n*.0000152587890625;_U(j,k,o);u=i;return}l=f[b+40>>2]|0;b=0;g=1;while(1){e=Y(f[l+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(h|0)){m=e;break}else g=e}n=+(m>>>0);o=n*.0000152587890625;_U(j,k,o);u=i;return}function tma(a){a=a|0;PYa(a);return}function uma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0.0,O=0,P=0.0,Q=0,R=0;c=u;u=u+1104|0;d=c;e=a+8|0;g=f[e>>2]|0;h=(f[g>>2]|0)>>>3;i=(h&511)+1|0;j=Y(i,f[(f[g+40>>2]|0)+4>>2]|0)|0;g=j<<1;k=d+8|0;f[d>>2]=k;l=d+4|0;f[l>>2]=g;if(g>>>0>136){m=OYa(g>>>0>536870911?-1:g<<3)|0;f[d>>2]=m;o=m}else o=k;m=f[a+12>>2]|0;g=f[a+20>>2]|0;q=o+(j<<3)|0;r=f[a+28>>2]|0;s=f[r+(f[b>>2]<<2)>>2]|0;t=f[r+(f[b+4>>2]<<2)>>2]|0;b=a+16|0;r=f[(f[b>>2]|0)+(s*12|0)+4>>2]|0;v=(j|0)>0;if(v)F1a(q|0,0,j<<3|0)|0;a:do if((s|0)<(t|0)){w=f[b>>2]|0;x=f[a+4>>2]|0;y=f[x+16>>2]|0;z=f[f[x+44>>2]>>2]|0;x=h&65535;A=(g|0)>0;B=j<<3;C=s;D=r;while(1){E=+n[w+(C*12|0)+8>>2];F=f[w+(C*12|0)+4>>2]|0;G=y+(Y(z,f[w+(C*12|0)>>2]|0)|0)|0;if(v)F1a(o|0,0,B|0)|0;switch(x&511){case 0:{if(A){H=0;do{I=o+(f[m+(H*12|0)+4>>2]<<3)|0;p[I>>3]=+p[I>>3]+ +n[m+(H*12|0)+8>>2]*+p[G+(f[m+(H*12|0)>>2]<<3)>>3];H=H+1|0}while((H|0)!=(g|0))}break}case 1:{if(A){H=0;do{I=f[m+(H*12|0)>>2]|0;J=f[m+(H*12|0)+4>>2]|0;K=+n[m+(H*12|0)+8>>2];L=o+(J<<3)|0;M=o+(J+1<<3)|0;N=+p[M>>3]+K*+p[G+(I+1<<3)>>3];p[L>>3]=+p[L>>3]+K*+p[G+(I<<3)>>3];p[M>>3]=N;H=H+1|0}while((H|0)!=(g|0))}break}case 2:{if(A){H=0;do{M=f[m+(H*12|0)>>2]|0;I=f[m+(H*12|0)+4>>2]|0;N=+n[m+(H*12|0)+8>>2];L=o+(I<<3)|0;J=o+(I+1<<3)|0;K=+p[J>>3]+N*+p[G+(M+1<<3)>>3];O=o+(I+2<<3)|0;P=+p[O>>3]+N*+p[G+(M+2<<3)>>3];p[L>>3]=+p[L>>3]+N*+p[G+(M<<3)>>3];p[J>>3]=K;p[O>>3]=P;H=H+1|0}while((H|0)!=(g|0))}break}case 3:{if(A){H=0;do{O=f[m+(H*12|0)>>2]|0;J=f[m+(H*12|0)+4>>2]|0;P=+n[m+(H*12|0)+8>>2];M=o+(J<<3)|0;L=o+(J+1<<3)|0;K=+p[L>>3]+P*+p[G+(O+1<<3)>>3];p[M>>3]=+p[M>>3]+P*+p[G+(O<<3)>>3];p[L>>3]=K;L=o+(J+2<<3)|0;M=o+(J+3<<3)|0;K=+p[M>>3]+P*+p[G+(O+3<<3)>>3];p[L>>3]=+p[L>>3]+P*+p[G+(O+2<<3)>>3];p[M>>3]=K;H=H+1|0}while((H|0)!=(g|0))}break}default:if(A){H=0;do{M=f[m+(H*12|0)>>2]|0;O=f[m+(H*12|0)+4>>2]|0;K=+n[m+(H*12|0)+8>>2];L=0;do{J=o+(L+O<<3)|0;p[J>>3]=+p[J>>3]+K*+p[G+(L+M<<3)>>3];L=L+1|0}while((L|0)!=(i|0));H=H+1|0}while((H|0)!=(g|0))}}if((F|0)==(D|0))if(v){H=0;do{G=q+(H<<3)|0;p[G>>3]=+p[G>>3]+E*+p[o+(H<<3)>>3];H=H+1|0}while((H|0)!=(j|0));Q=D}else Q=D;else{H=f[e>>2]|0;G=(f[H+16>>2]|0)+(Y(f[f[H+44>>2]>>2]|0,D)|0)|0;if(v){H=0;do{L=q+(H<<3)|0;p[G+(H<<3)>>3]=+p[L>>3];p[L>>3]=E*+p[o+(H<<3)>>3];H=H+1|0}while((H|0)!=(j|0));Q=F}else Q=F}C=C+1|0;if((C|0)==(t|0)){R=Q;break a}else D=Q}}else R=r;while(0);r=f[e>>2]|0;e=(f[r+16>>2]|0)+(Y(f[f[r+44>>2]>>2]|0,R)|0)|0;if(v){v=0;do{p[e+(v<<3)>>3]=+p[q+(v<<3)>>3];v=v+1|0}while((v|0)!=(j|0))}j=f[d>>2]|0;if((j|0)==(k|0)){u=c;return}if(j|0)QYa(j);f[d>>2]=k;f[l>>2]=136;u=c;return}function vma(a){a=a|0;PYa(a);return}function wma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0,O=0.0,P=0,Q=0;c=u;u=u+1072|0;d=c;e=a+8|0;g=f[e>>2]|0;h=(f[g>>2]|0)>>>3;i=(h&511)+1|0;j=Y(i,f[(f[g+40>>2]|0)+4>>2]|0)|0;g=j<<1;k=d+8|0;f[d>>2]=k;l=d+4|0;f[l>>2]=g;if(g>>>0>264){m=OYa(g>>>0>1073741823?-1:g<<2)|0;f[d>>2]=m;o=m}else o=k;m=f[a+12>>2]|0;g=f[a+20>>2]|0;p=o+(j<<2)|0;q=f[a+28>>2]|0;r=f[q+(f[b>>2]<<2)>>2]|0;s=f[q+(f[b+4>>2]<<2)>>2]|0;b=a+16|0;q=f[(f[b>>2]|0)+(r*12|0)+4>>2]|0;t=(j|0)>0;if(t)F1a(p|0,0,j<<2|0)|0;a:do if((r|0)<(s|0)){v=f[b>>2]|0;w=f[a+4>>2]|0;x=f[w+16>>2]|0;y=f[f[w+44>>2]>>2]|0;w=h&65535;z=(g|0)>0;A=j<<2;B=r;C=q;while(1){D=+n[v+(B*12|0)+8>>2];E=f[v+(B*12|0)+4>>2]|0;F=x+(Y(y,f[v+(B*12|0)>>2]|0)|0)|0;if(t)F1a(o|0,0,A|0)|0;switch(w&511){case 0:{if(z){G=0;do{H=o+(f[m+(G*12|0)+4>>2]<<2)|0;n[H>>2]=+n[H>>2]+ +n[m+(G*12|0)+8>>2]*+n[F+(f[m+(G*12|0)>>2]<<2)>>2];G=G+1|0}while((G|0)!=(g|0))}break}case 1:{if(z){G=0;do{H=f[m+(G*12|0)>>2]|0;I=f[m+(G*12|0)+4>>2]|0;J=+n[m+(G*12|0)+8>>2];K=o+(I<<2)|0;L=o+(I+1<<2)|0;M=+n[L>>2]+J*+n[F+(H+1<<2)>>2];n[K>>2]=+n[K>>2]+J*+n[F+(H<<2)>>2];n[L>>2]=M;G=G+1|0}while((G|0)!=(g|0))}break}case 2:{if(z){G=0;do{L=f[m+(G*12|0)>>2]|0;H=f[m+(G*12|0)+4>>2]|0;M=+n[m+(G*12|0)+8>>2];K=o+(H<<2)|0;I=o+(H+1<<2)|0;J=+n[I>>2]+M*+n[F+(L+1<<2)>>2];N=o+(H+2<<2)|0;O=+n[N>>2]+M*+n[F+(L+2<<2)>>2];n[K>>2]=+n[K>>2]+M*+n[F+(L<<2)>>2];n[I>>2]=J;n[N>>2]=O;G=G+1|0}while((G|0)!=(g|0))}break}case 3:{if(z){G=0;do{N=f[m+(G*12|0)>>2]|0;I=f[m+(G*12|0)+4>>2]|0;O=+n[m+(G*12|0)+8>>2];L=o+(I<<2)|0;K=o+(I+1<<2)|0;J=+n[K>>2]+O*+n[F+(N+1<<2)>>2];n[L>>2]=+n[L>>2]+O*+n[F+(N<<2)>>2];n[K>>2]=J;K=o+(I+2<<2)|0;L=o+(I+3<<2)|0;J=+n[L>>2]+O*+n[F+(N+3<<2)>>2];n[K>>2]=+n[K>>2]+O*+n[F+(N+2<<2)>>2];n[L>>2]=J;G=G+1|0}while((G|0)!=(g|0))}break}default:if(z){G=0;do{L=f[m+(G*12|0)>>2]|0;N=f[m+(G*12|0)+4>>2]|0;J=+n[m+(G*12|0)+8>>2];K=0;do{I=o+(K+N<<2)|0;n[I>>2]=+n[I>>2]+J*+n[F+(K+L<<2)>>2];K=K+1|0}while((K|0)!=(i|0));G=G+1|0}while((G|0)!=(g|0))}}if((E|0)==(C|0))if(t){G=0;do{F=p+(G<<2)|0;n[F>>2]=+n[F>>2]+D*+n[o+(G<<2)>>2];G=G+1|0}while((G|0)!=(j|0));P=C}else P=C;else{G=f[e>>2]|0;F=(f[G+16>>2]|0)+(Y(f[f[G+44>>2]>>2]|0,C)|0)|0;if(t){G=0;do{K=p+(G<<2)|0;f[F+(G<<2)>>2]=f[K>>2];n[K>>2]=D*+n[o+(G<<2)>>2];G=G+1|0}while((G|0)!=(j|0));P=E}else P=E}B=B+1|0;if((B|0)==(s|0)){Q=P;break a}else C=P}}else Q=q;while(0);q=f[e>>2]|0;e=(f[q+16>>2]|0)+(Y(f[f[q+44>>2]>>2]|0,Q)|0)|0;if(t){t=0;do{f[e+(t<<2)>>2]=f[p+(t<<2)>>2];t=t+1|0}while((t|0)!=(j|0))}j=f[d>>2]|0;if((j|0)==(k|0)){u=c;return}if(j|0)QYa(j);f[d>>2]=k;f[l>>2]=264;u=c;return}function xma(a){a=a|0;PYa(a);return}function yma(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0.0,O=0,P=0.0,Q=0,R=0;c=u;u=u+1072|0;e=c;g=a+8|0;h=f[g>>2]|0;i=(f[h>>2]|0)>>>3;j=(i&511)+1|0;k=Y(j,f[(f[h+40>>2]|0)+4>>2]|0)|0;h=k<<1;l=e+8|0;f[e>>2]=l;m=e+4|0;f[m>>2]=h;if(h>>>0>264){o=OYa(h>>>0>1073741823?-1:h<<2)|0;f[e>>2]=o;p=o}else p=l;o=f[a+12>>2]|0;h=f[a+20>>2]|0;q=p+(k<<2)|0;r=f[a+28>>2]|0;s=f[r+(f[b>>2]<<2)>>2]|0;t=f[r+(f[b+4>>2]<<2)>>2]|0;b=a+16|0;r=f[(f[b>>2]|0)+(s*12|0)+4>>2]|0;v=(k|0)>0;if(v)F1a(q|0,0,k<<2|0)|0;a:do if((s|0)<(t|0)){w=f[b>>2]|0;x=f[a+4>>2]|0;y=f[x+16>>2]|0;z=f[f[x+44>>2]>>2]|0;x=i&65535;A=(h|0)>0;B=k<<2;C=s;D=r;while(1){E=+n[w+(C*12|0)+8>>2];F=f[w+(C*12|0)+4>>2]|0;G=y+(Y(z,f[w+(C*12|0)>>2]|0)|0)|0;if(v)F1a(p|0,0,B|0)|0;switch(x&511){case 0:{if(A){H=0;do{I=p+(f[o+(H*12|0)+4>>2]<<2)|0;n[I>>2]=+n[I>>2]+ +n[o+(H*12|0)+8>>2]*+(d[G+(f[o+(H*12|0)>>2]<<1)>>1]|0);H=H+1|0}while((H|0)!=(h|0))}break}case 1:{if(A){H=0;do{I=f[o+(H*12|0)>>2]|0;J=f[o+(H*12|0)+4>>2]|0;K=+n[o+(H*12|0)+8>>2];L=p+(J<<2)|0;M=p+(J+1<<2)|0;N=+n[M>>2]+K*+(d[G+(I+1<<1)>>1]|0);n[L>>2]=+n[L>>2]+K*+(d[G+(I<<1)>>1]|0);n[M>>2]=N;H=H+1|0}while((H|0)!=(h|0))}break}case 2:{if(A){H=0;do{M=f[o+(H*12|0)>>2]|0;I=f[o+(H*12|0)+4>>2]|0;N=+n[o+(H*12|0)+8>>2];L=p+(I<<2)|0;J=p+(I+1<<2)|0;K=+n[J>>2]+N*+(d[G+(M+1<<1)>>1]|0);O=p+(I+2<<2)|0;P=+n[O>>2]+N*+(d[G+(M+2<<1)>>1]|0);n[L>>2]=+n[L>>2]+N*+(d[G+(M<<1)>>1]|0);n[J>>2]=K;n[O>>2]=P;H=H+1|0}while((H|0)!=(h|0))}break}case 3:{if(A){H=0;do{O=f[o+(H*12|0)>>2]|0;J=f[o+(H*12|0)+4>>2]|0;P=+n[o+(H*12|0)+8>>2];M=p+(J<<2)|0;L=p+(J+1<<2)|0;K=+n[L>>2]+P*+(d[G+(O+1<<1)>>1]|0);n[M>>2]=+n[M>>2]+P*+(d[G+(O<<1)>>1]|0);n[L>>2]=K;L=p+(J+2<<2)|0;M=p+(J+3<<2)|0;K=+n[M>>2]+P*+(d[G+(O+3<<1)>>1]|0);n[L>>2]=+n[L>>2]+P*+(d[G+(O+2<<1)>>1]|0);n[M>>2]=K;H=H+1|0}while((H|0)!=(h|0))}break}default:if(A){H=0;do{M=f[o+(H*12|0)>>2]|0;O=f[o+(H*12|0)+4>>2]|0;K=+n[o+(H*12|0)+8>>2];L=0;do{J=p+(L+O<<2)|0;n[J>>2]=+n[J>>2]+K*+(d[G+(L+M<<1)>>1]|0);L=L+1|0}while((L|0)!=(j|0));H=H+1|0}while((H|0)!=(h|0))}}if((F|0)==(D|0))if(v){H=0;do{G=q+(H<<2)|0;n[G>>2]=+n[G>>2]+E*+n[p+(H<<2)>>2];H=H+1|0}while((H|0)!=(k|0));Q=D}else Q=D;else{H=f[g>>2]|0;G=(f[H+16>>2]|0)+(Y(f[f[H+44>>2]>>2]|0,D)|0)|0;if(v){H=0;do{L=q+(H<<2)|0;M=wNa(+n[L>>2])|0;d[G+(H<<1)>>1]=(M+32768|0)>>>0<65536?M:(M|0)>0?32767:32768;n[L>>2]=E*+n[p+(H<<2)>>2];H=H+1|0}while((H|0)!=(k|0));Q=F}else Q=F}C=C+1|0;if((C|0)==(t|0)){R=Q;break a}else D=Q}}else R=r;while(0);r=f[g>>2]|0;g=(f[r+16>>2]|0)+(Y(f[f[r+44>>2]>>2]|0,R)|0)|0;if(v){v=0;do{R=wNa(+n[q+(v<<2)>>2])|0;d[g+(v<<1)>>1]=(R+32768|0)>>>0<65536?R:(R|0)>0?32767:32768;v=v+1|0}while((v|0)!=(k|0))}k=f[e>>2]|0;if((k|0)==(l|0)){u=c;return}if(k|0)QYa(k);f[e>>2]=l;f[m>>2]=264;u=c;return}function zma(a){a=a|0;PYa(a);return}function Ama(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0;c=u;u=u+1072|0;e=c;g=a+8|0;h=f[g>>2]|0;i=(f[h>>2]|0)>>>3;k=(i&511)+1|0;l=Y(k,f[(f[h+40>>2]|0)+4>>2]|0)|0;h=l<<1;m=e+8|0;f[e>>2]=m;o=e+4|0;f[o>>2]=h;if(h>>>0>264){p=OYa(h>>>0>1073741823?-1:h<<2)|0;f[e>>2]=p;q=p}else q=m;p=f[a+12>>2]|0;h=f[a+20>>2]|0;r=q+(l<<2)|0;s=f[a+28>>2]|0;t=f[s+(f[b>>2]<<2)>>2]|0;v=f[s+(f[b+4>>2]<<2)>>2]|0;b=a+16|0;s=f[(f[b>>2]|0)+(t*12|0)+4>>2]|0;w=(l|0)>0;if(w)F1a(r|0,0,l<<2|0)|0;a:do if((t|0)<(v|0)){x=f[b>>2]|0;y=f[a+4>>2]|0;z=f[y+16>>2]|0;A=f[f[y+44>>2]>>2]|0;y=i&65535;B=(h|0)>0;C=l<<2;D=t;E=s;while(1){F=+n[x+(D*12|0)+8>>2];G=f[x+(D*12|0)+4>>2]|0;H=z+(Y(A,f[x+(D*12|0)>>2]|0)|0)|0;if(w)F1a(q|0,0,C|0)|0;switch(y&511){case 0:{if(B){I=0;do{J=q+(f[p+(I*12|0)+4>>2]<<2)|0;n[J>>2]=+n[J>>2]+ +n[p+(I*12|0)+8>>2]*+(j[H+(f[p+(I*12|0)>>2]<<1)>>1]|0);I=I+1|0}while((I|0)!=(h|0))}break}case 1:{if(B){I=0;do{J=f[p+(I*12|0)>>2]|0;K=f[p+(I*12|0)+4>>2]|0;L=+n[p+(I*12|0)+8>>2];M=q+(K<<2)|0;N=q+(K+1<<2)|0;O=+n[N>>2]+L*+(j[H+(J+1<<1)>>1]|0);n[M>>2]=+n[M>>2]+L*+(j[H+(J<<1)>>1]|0);n[N>>2]=O;I=I+1|0}while((I|0)!=(h|0))}break}case 2:{if(B){I=0;do{N=f[p+(I*12|0)>>2]|0;J=f[p+(I*12|0)+4>>2]|0;O=+n[p+(I*12|0)+8>>2];M=q+(J<<2)|0;K=q+(J+1<<2)|0;L=+n[K>>2]+O*+(j[H+(N+1<<1)>>1]|0);P=q+(J+2<<2)|0;Q=+n[P>>2]+O*+(j[H+(N+2<<1)>>1]|0);n[M>>2]=+n[M>>2]+O*+(j[H+(N<<1)>>1]|0);n[K>>2]=L;n[P>>2]=Q;I=I+1|0}while((I|0)!=(h|0))}break}case 3:{if(B){I=0;do{P=f[p+(I*12|0)>>2]|0;K=f[p+(I*12|0)+4>>2]|0;Q=+n[p+(I*12|0)+8>>2];N=q+(K<<2)|0;M=q+(K+1<<2)|0;L=+n[M>>2]+Q*+(j[H+(P+1<<1)>>1]|0);n[N>>2]=+n[N>>2]+Q*+(j[H+(P<<1)>>1]|0);n[M>>2]=L;M=q+(K+2<<2)|0;N=q+(K+3<<2)|0;L=+n[N>>2]+Q*+(j[H+(P+3<<1)>>1]|0);n[M>>2]=+n[M>>2]+Q*+(j[H+(P+2<<1)>>1]|0);n[N>>2]=L;I=I+1|0}while((I|0)!=(h|0))}break}default:if(B){I=0;do{N=f[p+(I*12|0)>>2]|0;P=f[p+(I*12|0)+4>>2]|0;L=+n[p+(I*12|0)+8>>2];M=0;do{K=q+(M+P<<2)|0;n[K>>2]=+n[K>>2]+L*+(j[H+(M+N<<1)>>1]|0);M=M+1|0}while((M|0)!=(k|0));I=I+1|0}while((I|0)!=(h|0))}}if((G|0)==(E|0))if(w){I=0;do{H=r+(I<<2)|0;n[H>>2]=+n[H>>2]+F*+n[q+(I<<2)>>2];I=I+1|0}while((I|0)!=(l|0));R=E}else R=E;else{I=f[g>>2]|0;H=(f[I+16>>2]|0)+(Y(f[f[I+44>>2]>>2]|0,E)|0)|0;if(w){I=0;do{M=r+(I<<2)|0;N=wNa(+n[M>>2])|0;d[H+(I<<1)>>1]=N>>>0<65536?N:(N|0)>0?65535:0;n[M>>2]=F*+n[q+(I<<2)>>2];I=I+1|0}while((I|0)!=(l|0));R=G}else R=G}D=D+1|0;if((D|0)==(v|0)){S=R;break a}else E=R}}else S=s;while(0);s=f[g>>2]|0;g=(f[s+16>>2]|0)+(Y(f[f[s+44>>2]>>2]|0,S)|0)|0;if(w){w=0;do{S=wNa(+n[r+(w<<2)>>2])|0;d[g+(w<<1)>>1]=S>>>0<65536?S:(S|0)>0?65535:0;w=w+1|0}while((w|0)!=(l|0))}l=f[e>>2]|0;if((l|0)==(m|0)){u=c;return}if(l|0)QYa(l);f[e>>2]=m;f[o>>2]=264;u=c;return}function Bma(a){a=a|0;PYa(a);return}function Cma(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0,O=0.0,P=0,Q=0;d=u;u=u+1072|0;e=d;g=a+8|0;i=f[g>>2]|0;j=(f[i>>2]|0)>>>3;k=(j&511)+1|0;l=Y(k,f[(f[i+40>>2]|0)+4>>2]|0)|0;i=l<<1;m=e+8|0;f[e>>2]=m;o=e+4|0;f[o>>2]=i;if(i>>>0>264){p=OYa(i>>>0>1073741823?-1:i<<2)|0;f[e>>2]=p;q=p}else q=m;p=f[a+12>>2]|0;i=f[a+20>>2]|0;r=q+(l<<2)|0;s=f[a+28>>2]|0;t=f[s+(f[c>>2]<<2)>>2]|0;v=f[s+(f[c+4>>2]<<2)>>2]|0;c=a+16|0;s=f[(f[c>>2]|0)+(t*12|0)+4>>2]|0;w=(l|0)>0;if(w)F1a(r|0,0,l<<2|0)|0;a:do if((t|0)<(v|0)){x=a+4|0;y=j&65535;z=(i|0)>0;A=l<<2;B=t;C=s;while(1){D=f[c>>2]|0;E=+n[D+(B*12|0)+8>>2];F=f[D+(B*12|0)+4>>2]|0;G=f[x>>2]|0;H=(f[G+16>>2]|0)+(Y(f[f[G+44>>2]>>2]|0,f[D+(B*12|0)>>2]|0)|0)|0;if(w)F1a(q|0,0,A|0)|0;switch(y&511){case 0:{if(z){D=0;do{G=q+(f[p+(D*12|0)+4>>2]<<2)|0;n[G>>2]=+n[G>>2]+ +n[p+(D*12|0)+8>>2]*+(h[H+(f[p+(D*12|0)>>2]|0)>>0]|0);D=D+1|0}while((D|0)!=(i|0))}break}case 1:{if(z){D=0;do{G=f[p+(D*12|0)>>2]|0;I=f[p+(D*12|0)+4>>2]|0;J=+n[p+(D*12|0)+8>>2];K=q+(I<<2)|0;L=q+(I+1<<2)|0;M=+n[L>>2]+J*+(h[H+(G+1)>>0]|0);n[K>>2]=+n[K>>2]+J*+(h[H+G>>0]|0);n[L>>2]=M;D=D+1|0}while((D|0)!=(i|0))}break}case 2:{if(z){D=0;do{L=f[p+(D*12|0)>>2]|0;G=f[p+(D*12|0)+4>>2]|0;M=+n[p+(D*12|0)+8>>2];K=q+(G<<2)|0;I=q+(G+1<<2)|0;J=+n[I>>2]+M*+(h[H+(L+1)>>0]|0);N=q+(G+2<<2)|0;O=+n[N>>2]+M*+(h[H+(L+2)>>0]|0);n[K>>2]=+n[K>>2]+M*+(h[H+L>>0]|0);n[I>>2]=J;n[N>>2]=O;D=D+1|0}while((D|0)!=(i|0))}break}case 3:{if(z){D=0;do{N=f[p+(D*12|0)>>2]|0;I=f[p+(D*12|0)+4>>2]|0;O=+n[p+(D*12|0)+8>>2];L=q+(I<<2)|0;K=q+(I+1<<2)|0;J=+n[K>>2]+O*+(h[H+(N+1)>>0]|0);n[L>>2]=+n[L>>2]+O*+(h[H+N>>0]|0);n[K>>2]=J;K=q+(I+2<<2)|0;L=q+(I+3<<2)|0;J=+n[L>>2]+O*+(h[H+(N+3)>>0]|0);n[K>>2]=+n[K>>2]+O*+(h[H+(N+2)>>0]|0);n[L>>2]=J;D=D+1|0}while((D|0)!=(i|0))}break}default:if(z){D=0;do{L=f[p+(D*12|0)>>2]|0;N=f[p+(D*12|0)+4>>2]|0;J=+n[p+(D*12|0)+8>>2];K=0;do{I=q+(K+N<<2)|0;n[I>>2]=+n[I>>2]+J*+(h[H+(K+L)>>0]|0);K=K+1|0}while((K|0)!=(k|0));D=D+1|0}while((D|0)!=(i|0))}}if((F|0)==(C|0))if(w){D=0;do{H=r+(D<<2)|0;n[H>>2]=+n[H>>2]+E*+n[q+(D<<2)>>2];D=D+1|0}while((D|0)!=(l|0));P=C}else P=C;else{D=f[g>>2]|0;H=(f[D+16>>2]|0)+(Y(f[f[D+44>>2]>>2]|0,C)|0)|0;if(w){D=0;do{K=r+(D<<2)|0;L=wNa(+n[K>>2])|0;b[H+D>>0]=L>>>0<256?L:(L|0)>0?255:0;n[K>>2]=E*+n[q+(D<<2)>>2];D=D+1|0}while((D|0)!=(l|0));P=F}else P=F}B=B+1|0;if((B|0)==(v|0)){Q=P;break a}else C=P}}else Q=s;while(0);s=f[g>>2]|0;g=(f[s+16>>2]|0)+(Y(f[f[s+44>>2]>>2]|0,Q)|0)|0;if(w){w=0;do{Q=wNa(+n[r+(w<<2)>>2])|0;b[g+w>>0]=Q>>>0<256?Q:(Q|0)>0?255:0;w=w+1|0}while((w|0)!=(l|0))}l=f[e>>2]|0;if((l|0)==(m|0)){u=d;return}if(l|0)QYa(l);f[e>>2]=m;f[o>>2]=264;u=d;return}function Dma(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+144|0;i=h+136|0;j=h;k=b+8|0;l=f[k>>2]|0;f[i>>2]=0;f[i+4>>2]=l;_ma(j,a,b,e,g,c,d);d=f[b+4>>2]|0;if((d|0)<3)m=Y(f[b+12>>2]|0,f[k>>2]|0)|0;else{k=f[b+40>>2]|0;b=0;c=1;while(1){g=Y(f[k+(b<<2)>>2]|0,c)|0;b=b+1|0;if((b|0)==(d|0)){m=g;break}else c=g}}_U(i,j,+(m>>>0)*.0000152587890625);$ma(j);u=h;return}function Ema(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+144|0;i=h+136|0;j=h;k=b+8|0;l=f[k>>2]|0;f[i>>2]=0;f[i+4>>2]=l;Vma(j,a,b,e,g,c,d);d=f[b+4>>2]|0;if((d|0)<3)m=Y(f[b+12>>2]|0,f[k>>2]|0)|0;else{k=f[b+40>>2]|0;b=0;c=1;while(1){g=Y(f[k+(b<<2)>>2]|0,c)|0;b=b+1|0;if((b|0)==(d|0)){m=g;break}else c=g}}_U(i,j,+(m>>>0)*.0000152587890625);Wma(j);u=h;return}function Fma(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+144|0;i=h+136|0;j=h;k=b+8|0;l=f[k>>2]|0;f[i>>2]=0;f[i+4>>2]=l;Qma(j,a,b,e,g,c,d);d=f[b+4>>2]|0;if((d|0)<3)m=Y(f[b+12>>2]|0,f[k>>2]|0)|0;else{k=f[b+40>>2]|0;b=0;c=1;while(1){g=Y(f[k+(b<<2)>>2]|0,c)|0;b=b+1|0;if((b|0)==(d|0)){m=g;break}else c=g}}_U(i,j,+(m>>>0)*.0000152587890625);Rma(j);u=h;return}function Gma(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+144|0;i=h+136|0;j=h;k=b+8|0;l=f[k>>2]|0;f[i>>2]=0;f[i+4>>2]=l;Mma(j,a,b,e,g,c,d);d=f[b+4>>2]|0;if((d|0)<3)m=Y(f[b+12>>2]|0,f[k>>2]|0)|0;else{k=f[b+40>>2]|0;b=0;c=1;while(1){g=Y(f[k+(b<<2)>>2]|0,c)|0;b=b+1|0;if((b|0)==(d|0)){m=g;break}else c=g}}_U(i,j,+(m>>>0)*.0000152587890625);Nma(j);u=h;return}function Hma(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+144|0;i=h+136|0;j=h;k=b+8|0;l=f[k>>2]|0;f[i>>2]=0;f[i+4>>2]=l;Ima(j,a,b,e,g,c,d);d=f[b+4>>2]|0;if((d|0)<3)m=Y(f[b+12>>2]|0,f[k>>2]|0)|0;else{k=f[b+40>>2]|0;b=0;c=1;while(1){g=Y(f[k+(b<<2)>>2]|0,c)|0;b=b+1|0;if((b|0)==(d|0)){m=g;break}else c=g}}_U(i,j,+(m>>>0)*.0000152587890625);Jma(j);u=h;return}function Ima(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f[a>>2]=75012;i=a+4|0;f[i>>2]=f[b>>2];j=a+8|0;k=b+4|0;f[j>>2]=f[k>>2];l=a+12|0;f[l>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];m=f[b+36>>2]|0;f[a+40>>2]=m;f[a+44>>2]=l;l=a+52|0;n=a+48|0;f[n>>2]=l;f[l>>2]=0;f[a+56>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[b+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;BR(i,b)}b=a+60|0;f[b>>2]=f[c>>2];i=a+64|0;j=c+4|0;f[i>>2]=f[j>>2];k=a+68|0;f[k>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];l=f[c+36>>2]|0;f[a+96>>2]=l;f[a+100>>2]=k;k=a+108|0;n=a+104|0;f[n>>2]=k;f[k>>2]=0;f[a+112>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[c+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}else{f[i>>2]=0;BR(b,c);o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}}function Jma(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=75012;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function Kma(a){a=a|0;Jma(a);PYa(a);return}function Lma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0,W=0.0,X=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0.0;c=f[a+44>>2]|0;d=f[c+4>>2]|0;e=f[c>>2]|0;c=((f[a+4>>2]|0)>>>3&511)+1|0;g=a+116|0;h=f[g>>2]|0;i=a+120|0;j=f[i>>2]|0;k=Y(j,h)|0;l=Y((d|0)/(h|0)|0,c)|0;h=Y(c,f[(f[a+100>>2]|0)+4>>2]|0)|0;m=Y(c,d)|0;d=f[b>>2]|0;n=f[b+4>>2]|0;if((d|0)>=(n|0))return;b=f[a+76>>2]|0;o=f[a+108>>2]|0;q=a+20|0;r=a+48|0;s=a+128|0;t=k+-4|0;u=(k|0)<4;v=1.0/+(k|0);w=a+124|0;a=(h|0)>0;x=h<<3;y=k&-4;z=(y|0)<(k|0);A=(k|0)>0;B=d;D=0;while(1){E=b+(Y(o,d+D|0)|0)|0;F=b+(Y(o,B)|0)|0;G=Y(j,B)|0;H=(G+j|0)<=(e|0)?l:0;a:do if((G|0)<(e|0)){b:do if((H|0)>0){I=(f[q>>2]|0)+(Y(f[f[r>>2]>>2]|0,G)|0)|0;J=f[s>>2]|0;if(u){K=0;while(1){L=I+(f[J+(K<<2)>>2]<<3)|0;if(A){M=f[w>>2]|0;N=0;O=0.0;while(1){P=O+ +p[L+(f[M+(N<<2)>>2]<<3)>>3];N=N+1|0;if((N|0)==(k|0)){Q=P;break}else O=P}}else Q=0.0;p[F+(K<<3)>>3]=v*Q;K=K+1|0;if((K|0)==(H|0)){R=H;break b}}}K=f[w>>2]|0;N=0;do{M=I+(f[J+(N<<2)>>2]<<3)|0;L=0;O=0.0;do{O=O+(+p[M+(f[K+(L<<2)>>2]<<3)>>3]+ +p[M+(f[K+((L|1)<<2)>>2]<<3)>>3]+ +p[M+(f[K+((L|2)<<2)>>2]<<3)>>3]+ +p[M+(f[K+((L|3)<<2)>>2]<<3)>>3]);L=L+4|0}while((L|0)<=(t|0));if(z){L=y;P=O;while(1){S=P+ +p[M+(f[K+(L<<2)>>2]<<3)>>3];L=L+1|0;if((L|0)==(k|0)){T=S;break}else P=S}}else T=O;p[F+(N<<3)>>3]=v*T;N=N+1|0}while((N|0)!=(H|0));R=H}else R=0;while(0);if((R|0)<(h|0)){N=f[s>>2]|0;K=f[i>>2]|0;if((K|0)>0)U=R;else{J=R;while(1){I=F+(J<<3)|0;if((f[N+(J<<2)>>2]|0)>=(m|0))p[I>>3]=0.0;p[I>>3]=C;J=J+1|0;if((J|0)==(h|0))break a}}do{J=f[N+(U<<2)>>2]|0;c:do if((J|0)<(m|0)){I=0;P=0.0;L=0;while(1){M=L+G|0;if((M|0)>=(e|0)){V=I;W=P;break c}X=(f[q>>2]|0)+(Y(f[f[r>>2]>>2]|0,M)|0)+(J<<3)|0;M=Y(f[g>>2]|0,c)|0;if((M|0)>0){Z=I;S=P;_=0;while(1){$=S+ +p[X+(_<<3)>>3];aa=Z+1|0;_=_+c|0;if(!((_+J|0)<(m|0)&(_|0)<(M|0))){ba=aa;ca=$;break}else{Z=aa;S=$}}}else{ba=I;ca=P}L=L+1|0;if((L|0)>=(K|0)){V=ba;W=ca;break}else{I=ba;P=ca}}}else{p[F+(U<<3)>>3]=0.0;V=0;W=0.0}while(0);p[F+(U<<3)>>3]=W/+(V|0);U=U+1|0}while((U|0)!=(h|0))}}else if(a)F1a(E|0,0,x|0)|0;while(0);B=B+1|0;if((B|0)>=(n|0))break;else D=D+1|0}return}function Mma(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f[a>>2]=75032;i=a+4|0;f[i>>2]=f[b>>2];j=a+8|0;k=b+4|0;f[j>>2]=f[k>>2];l=a+12|0;f[l>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];m=f[b+36>>2]|0;f[a+40>>2]=m;f[a+44>>2]=l;l=a+52|0;n=a+48|0;f[n>>2]=l;f[l>>2]=0;f[a+56>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[b+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;BR(i,b)}b=a+60|0;f[b>>2]=f[c>>2];i=a+64|0;j=c+4|0;f[i>>2]=f[j>>2];k=a+68|0;f[k>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];l=f[c+36>>2]|0;f[a+96>>2]=l;f[a+100>>2]=k;k=a+108|0;n=a+104|0;f[n>>2]=k;f[k>>2]=0;f[a+112>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[c+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}else{f[i>>2]=0;BR(b,c);o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}}function Nma(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=75032;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function Oma(a){a=a|0;Nma(a);PYa(a);return}function Pma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0,W=0.0,X=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0.0;c=f[a+44>>2]|0;d=f[c+4>>2]|0;e=f[c>>2]|0;c=((f[a+4>>2]|0)>>>3&511)+1|0;g=a+116|0;h=f[g>>2]|0;i=a+120|0;j=f[i>>2]|0;k=Y(j,h)|0;l=1.0/+(k|0);m=Y((d|0)/(h|0)|0,c)|0;h=Y(c,f[(f[a+100>>2]|0)+4>>2]|0)|0;o=Y(c,d)|0;d=f[b>>2]|0;p=f[b+4>>2]|0;if((d|0)>=(p|0))return;b=f[a+76>>2]|0;q=f[a+108>>2]|0;r=a+20|0;s=a+48|0;t=a+128|0;u=k+-4|0;v=(k|0)<4;w=a+124|0;a=(h|0)>0;x=h<<2;y=k&-4;z=(y|0)<(k|0);A=(k|0)>0;B=d;D=0;while(1){E=b+(Y(q,d+D|0)|0)|0;F=b+(Y(q,B)|0)|0;G=Y(j,B)|0;H=(G+j|0)<=(e|0)?m:0;a:do if((G|0)<(e|0)){b:do if((H|0)>0){I=(f[r>>2]|0)+(Y(f[f[s>>2]>>2]|0,G)|0)|0;J=f[t>>2]|0;if(v){K=0;while(1){L=I+(f[J+(K<<2)>>2]<<2)|0;if(A){M=f[w>>2]|0;N=0;O=0.0;while(1){P=O+ +n[L+(f[M+(N<<2)>>2]<<2)>>2];N=N+1|0;if((N|0)==(k|0)){Q=P;break}else O=P}}else Q=0.0;n[F+(K<<2)>>2]=l*Q;K=K+1|0;if((K|0)==(H|0)){R=H;break b}}}K=f[w>>2]|0;N=0;do{M=I+(f[J+(N<<2)>>2]<<2)|0;L=0;O=0.0;do{O=O+(+n[M+(f[K+(L<<2)>>2]<<2)>>2]+ +n[M+(f[K+((L|1)<<2)>>2]<<2)>>2]+ +n[M+(f[K+((L|2)<<2)>>2]<<2)>>2]+ +n[M+(f[K+((L|3)<<2)>>2]<<2)>>2]);L=L+4|0}while((L|0)<=(u|0));if(z){L=y;P=O;while(1){S=P+ +n[M+(f[K+(L<<2)>>2]<<2)>>2];L=L+1|0;if((L|0)==(k|0)){T=S;break}else P=S}}else T=O;n[F+(N<<2)>>2]=l*T;N=N+1|0}while((N|0)!=(H|0));R=H}else R=0;while(0);if((R|0)<(h|0)){N=f[t>>2]|0;K=f[i>>2]|0;if((K|0)>0)U=R;else{J=R;while(1){I=F+(J<<2)|0;if((f[N+(J<<2)>>2]|0)>=(o|0))n[I>>2]=0.0;n[I>>2]=C;J=J+1|0;if((J|0)==(h|0))break a}}do{J=f[N+(U<<2)>>2]|0;c:do if((J|0)<(o|0)){I=0;P=0.0;L=0;while(1){M=L+G|0;if((M|0)>=(e|0)){V=I;W=P;break c}X=(f[r>>2]|0)+(Y(f[f[s>>2]>>2]|0,M)|0)+(J<<2)|0;M=Y(f[g>>2]|0,c)|0;if((M|0)>0){Z=I;S=P;_=0;while(1){$=S+ +n[X+(_<<2)>>2];aa=Z+1|0;_=_+c|0;if(!((_+J|0)<(o|0)&(_|0)<(M|0))){ba=aa;ca=$;break}else{Z=aa;S=$}}}else{ba=I;ca=P}L=L+1|0;if((L|0)>=(K|0)){V=ba;W=ca;break}else{I=ba;P=ca}}}else{n[F+(U<<2)>>2]=0.0;V=0;W=0.0}while(0);n[F+(U<<2)>>2]=W/+(V|0);U=U+1|0}while((U|0)!=(h|0))}}else if(a)F1a(E|0,0,x|0)|0;while(0);B=B+1|0;if((B|0)>=(p|0))break;else D=D+1|0}return}function Qma(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f[a>>2]=75052;i=a+4|0;f[i>>2]=f[b>>2];j=a+8|0;k=b+4|0;f[j>>2]=f[k>>2];l=a+12|0;f[l>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];m=f[b+36>>2]|0;f[a+40>>2]=m;f[a+44>>2]=l;l=a+52|0;n=a+48|0;f[n>>2]=l;f[l>>2]=0;f[a+56>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[b+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;BR(i,b)}b=a+60|0;f[b>>2]=f[c>>2];i=a+64|0;j=c+4|0;f[i>>2]=f[j>>2];k=a+68|0;f[k>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];l=f[c+36>>2]|0;f[a+96>>2]=l;f[a+100>>2]=k;k=a+108|0;n=a+104|0;f[n>>2]=k;f[k>>2]=0;f[a+112>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[c+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}else{f[i>>2]=0;BR(b,c);o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}}function Rma(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=75052;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function Sma(a){a=a|0;Rma(a);PYa(a);return}function Tma(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0,X=0,Z=0.0,_=0,$=0,aa=0.0,ba=0,ca=0,da=0.0;e=u;u=u+32|0;g=e;h=f[a+44>>2]|0;i=f[h+4>>2]|0;j=f[h>>2]|0;h=(f[a+4>>2]|0)>>>3;k=(h&511)+1|0;l=a+116|0;m=f[l>>2]|0;n=a+120|0;o=f[n>>2]|0;p=Y(o,m)|0;q=1.0/+(p|0);r=Y((i|0)/(m|0)|0,k)|0;s=Y(k,f[(f[a+100>>2]|0)+4>>2]|0)|0;t=Y(k,i)|0;i=f[a+52>>2]|0;f[g>>2]=m;f[g+4>>2]=o;f[g+8>>2]=k;f[g+16>>2]=i;a:do if((m|0)==2&(o|0)==2){switch(h&511){case 2:case 0:{v=1;break a;break}default:{}}v=(k|0)==4&1}else v=0;while(0);b[g+12>>0]=v;v=f[c>>2]|0;h=c+4|0;if((v|0)>=(f[h>>2]|0)){u=e;return}c=a+76|0;m=a+108|0;i=a+20|0;w=a+48|0;x=a+128|0;y=p+-4|0;z=(p|0)<4;A=a+124|0;a=(s|0)>0;B=s<<1;D=p&-4;E=(D|0)<(p|0);F=(p|0)>0;G=o;o=v;while(1){v=(f[c>>2]|0)+(Y(f[m>>2]|0,o)|0)|0;H=Y(G,o)|0;I=(H+G|0)<=(j|0)?r:0;b:do if((H|0)<(j|0)){J=Uma(g,(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,H)|0)|0,v,I)|0;c:do if((J|0)<(I|0)){K=(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,H)|0)|0;L=f[x>>2]|0;if(z){M=J;while(1){N=K+(f[L+(M<<2)>>2]<<1)|0;if(F){O=f[A>>2]|0;P=0;Q=0.0;while(1){R=Q+ +(d[N+(f[O+(P<<2)>>2]<<1)>>1]|0);P=P+1|0;if((P|0)==(p|0)){S=R;break}else Q=R}}else S=0.0;P=wNa(q*S)|0;d[v+(M<<1)>>1]=(P+32768|0)>>>0<65536?P:(P|0)>0?32767:32768;M=M+1|0;if((M|0)==(I|0)){T=I;break c}}}M=f[A>>2]|0;P=J;do{O=K+(f[L+(P<<2)>>2]<<1)|0;N=0;Q=0.0;do{Q=Q+ +((d[O+(f[M+((N|1)<<2)>>2]<<1)>>1]|0)+(d[O+(f[M+(N<<2)>>2]<<1)>>1]|0)+(d[O+(f[M+((N|2)<<2)>>2]<<1)>>1]|0)+(d[O+(f[M+((N|3)<<2)>>2]<<1)>>1]|0)|0);N=N+4|0}while((N|0)<=(y|0));if(E){N=D;R=Q;while(1){U=R+ +(d[O+(f[M+(N<<2)>>2]<<1)>>1]|0);N=N+1|0;if((N|0)==(p|0)){V=U;break}else R=U}}else V=Q;N=wNa(q*V)|0;d[v+(P<<1)>>1]=(N+32768|0)>>>0<65536?N:(N|0)>0?32767:32768;P=P+1|0}while((P|0)!=(I|0));T=I}else T=J;while(0);if((T|0)<(s|0)){J=f[x>>2]|0;P=f[n>>2]|0;if((P|0)>0)W=T;else{M=wNa(C)|0;L=((M+32768|0)>>>0<65536?M:(M|0)>0?32767:32768)&65535;M=T;while(1){K=v+(M<<1)|0;if((f[J+(M<<2)>>2]|0)>=(t|0))d[K>>1]=0;d[K>>1]=L;M=M+1|0;if((M|0)==(s|0))break b}}do{M=f[J+(W<<2)>>2]|0;d:do if((M|0)<(t|0)){L=0;R=0.0;K=0;while(1){N=K+H|0;if((N|0)>=(j|0)){X=L;Z=R;break d}O=(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,N)|0)+(M<<1)|0;N=Y(f[l>>2]|0,k)|0;if((N|0)>0){_=L;U=R;$=0;while(1){aa=U+ +(d[O+($<<1)>>1]|0);ba=_+1|0;$=$+k|0;if(!(($+M|0)<(t|0)&($|0)<(N|0))){ca=ba;da=aa;break}else{_=ba;U=aa}}}else{ca=L;da=R}K=K+1|0;if((K|0)>=(P|0)){X=ca;Z=da;break}else{L=ca;R=da}}}else{d[v+(W<<1)>>1]=0;X=0;Z=0.0}while(0);M=wNa(Z/+(X|0))|0;d[v+(W<<1)>>1]=(M+32768|0)>>>0<65536?M:(M|0)>0?32767:32768;W=W+1|0}while((W|0)!=(s|0))}}else if(a)F1a(v|0,0,B|0)|0;while(0);v=o+1|0;if((v|0)>=(f[h>>2]|0))break;G=f[n>>2]|0;o=v}u=e;return}function Uma(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=u;u=u+16|0;i=h;if(!(b[a+12>>0]|0)){j=0;u=h;return j|0}k=c+(f[a+16>>2]|0)|0;switch(f[a+8>>2]|0){case 1:{if((g|0)>0)l=0;else{j=0;u=h;return j|0}do{a=l<<1;m=a|1;d[e+(l<<1)>>1]=((d[c+(a<<1)>>1]|0)+2+(d[c+(m<<1)>>1]|0)+(d[k+(a<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)|0)>>>2;l=l+1|0}while((l|0)!=(g|0));j=g;u=h;return j|0}case 3:{if((g|0)>0)n=0;else{j=0;u=h;return j|0}while(1){l=n<<1;m=l+3|0;d[e+(n<<1)>>1]=((d[c+(l<<1)>>1]|0)+2+(d[c+(m<<1)>>1]|0)+(d[k+(l<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)|0)>>>2;m=l|1;a=l+4|0;d[e+(n+1<<1)>>1]=((d[c+(m<<1)>>1]|0)+2+(d[c+(a<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)+(d[k+(a<<1)>>1]|0)|0)>>>2;a=l+2|0;m=l+5|0;d[e+(n+2<<1)>>1]=((d[c+(a<<1)>>1]|0)+2+(d[c+(m<<1)>>1]|0)+(d[k+(a<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)|0)>>>2;m=n+3|0;if((m|0)<(g|0))n=m;else{j=m;break}}u=h;return j|0}case 4:break;default:{f[i>>2]=0;f[i+4>>2]=0;n=c$(i,7)|0;b[n>>0]=b[325727]|0;b[n+1>>0]=b[325728]|0;b[n+2>>0]=b[325729]|0;b[n+3>>0]=b[325730]|0;b[n+4>>0]=b[325731]|0;b[n+5>>0]=b[325732]|0;b[n+6>>0]=b[325733]|0;j$(-215,i,373355,323470,2164);d$(i)}}if((g|0)>0)o=0;else{j=0;u=h;return j|0}do{i=o<<1;n=i|4;d[e+(o<<1)>>1]=((d[c+(i<<1)>>1]|0)+2+(d[c+(n<<1)>>1]|0)+(d[k+(i<<1)>>1]|0)+(d[k+(n<<1)>>1]|0)|0)>>>2;n=i|1;m=i|5;d[e+((o|1)<<1)>>1]=((d[c+(n<<1)>>1]|0)+2+(d[c+(m<<1)>>1]|0)+(d[k+(n<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)|0)>>>2;m=i|2;n=i|6;d[e+((o|2)<<1)>>1]=((d[c+(m<<1)>>1]|0)+2+(d[c+(n<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)+(d[k+(n<<1)>>1]|0)|0)>>>2;n=i|3;m=i|7;d[e+((o|3)<<1)>>1]=((d[c+(n<<1)>>1]|0)+2+(d[c+(m<<1)>>1]|0)+(d[k+(n<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)|0)>>>2;o=o+4|0}while((o|0)<(g|0));j=g+3&-4;u=h;return j|0}
function era(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+160|0;e=d+152|0;g=d+136|0;h=d+88|0;i=d+44|0;j=d;k=d+144|0;$X(g,c,338958);l=g+4|0;aY(h,f[g>>2]|0,f[l>>2]|0,0);m=f[g>>2]|0;n=f[l>>2]|0;aY(i,m,n,bY(g)|0);g=a+4|0;n=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(n|0));g=h+40|0;n=h+4|0;m=i+4|0;l=h+20|0;o=i+20|0;p=i+40|0;q=j+20|0;r=e+4|0;s=e+4|0;t=e+4|0;v=e+4|0;w=e+4|0;x=0;while(1){y=f[h>>2]|0;if((((y|0)==(f[i>>2]|0)?(f[n>>2]|0)==(f[m>>2]|0):0)?(f[l>>2]|0)==(f[o>>2]|0):0)?(f[g>>2]|0)==(f[p>>2]|0):0)break;aY(j,y,f[l>>2]|0,0);y=f[q>>2]|0;f[e>>2]=f[j>>2];f[r>>2]=y;oY(e,a+4+(x*20|0)|0,0);y=cY(j)|0;z=f[j+20>>2]|0;f[e>>2]=f[j>>2];f[s>>2]=z;oY(e,a+4+(x*20|0)+4|0,0);z=cY(y)|0;y=f[j+20>>2]|0;f[e>>2]=f[j>>2];f[t>>2]=y;oY(e,a+4+(x*20|0)+8|0,0);y=cY(z)|0;z=f[j+20>>2]|0;f[e>>2]=f[j>>2];f[v>>2]=z;oY(e,a+4+(x*20|0)+12|0,0);z=cY(y)|0;y=f[j+20>>2]|0;f[e>>2]=f[j>>2];f[w>>2]=y;pY(e,a+4+(x*20|0)+16|0,0.0);cY(z)|0;cY(h)|0;x=x+1|0}$X(k,c,338964);oY(k,e,0);b[a>>0]=(f[e>>2]|0)!=0&1;u=d;return 1}function fra(a){a=a|0;PYa(a);return}function gra(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+8>>2]|0;if(b|0){c=f[b>>2]|0;if(c|0){d=b+4|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-64-c|0)>>>6)<<6);PYa(c)}PYa(b)}ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function hra(a){a=a|0;PYa(a);return}function ira(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+8>>2]|0;if(b|0){c=f[b>>2]|0;if(c|0){d=b+4|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-64-c|0)>>>6)<<6);PYa(c)}PYa(b)}ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function jra(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=76892;b=a+372|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)ki[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+376>>2]=0;b=a+364|0;c=f[b>>2]|0;if(c|0?(e=c+4|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)ki[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+368>>2]=0;b=a+356|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;g=a+360|0;f[g>>2]=0;vqa(a);return}d=c+4|0;e=f[d>>2]|0;f[d>>2]=e+-1;if((e|0)!=1){f[b>>2]=0;g=a+360|0;f[g>>2]=0;vqa(a);return}ki[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;g=a+360|0;f[g>>2]=0;vqa(a);return}function kra(a){a=a|0;jra(a);PYa(a);return}function lra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+112|0;e=d+56|0;g=d+64|0;h=d+8|0;i=d;f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];xqa(a,0,e)|0;e=a+356|0;c=a+360|0;if(!(f[c>>2]|0)){j=NYa(12)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;k=NYa(16)|0;l=k+4|0;f[l>>2]=1;f[k>>2]=76972;f[k+8>>2]=j;f[l>>2]=(f[l>>2]|0)+1;m=f[e>>2]|0;f[e>>2]=k;f[c>>2]=j;if(m|0?(j=m+4|0,e=f[j>>2]|0,f[j>>2]=e+-1,(e|0)==1):0)ki[f[(f[m>>2]|0)+8>>2]&2047](m);m=f[l>>2]|0;f[l>>2]=m+-1;if((m|0)==1)ki[f[(f[k>>2]|0)+8>>2]&2047](k)}k=a+364|0;m=a+368|0;if(!(f[m>>2]|0)){l=NYa(12)|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=NYa(16)|0;j=e+4|0;f[j>>2]=1;f[e>>2]=76992;f[e+8>>2]=l;f[j>>2]=(f[j>>2]|0)+1;n=f[k>>2]|0;f[k>>2]=e;f[m>>2]=l;if(n|0?(l=n+4|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0)ki[f[(f[n>>2]|0)+8>>2]&2047](n);n=f[j>>2]|0;f[j>>2]=n+-1;if((n|0)==1)ki[f[(f[e>>2]|0)+8>>2]&2047](e)}e=a+372|0;n=a+376|0;if(!(f[n>>2]|0)){j=NYa(12)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;m=NYa(16)|0;l=m+4|0;f[l>>2]=1;f[m>>2]=76992;f[m+8>>2]=j;f[l>>2]=(f[l>>2]|0)+1;k=f[e>>2]|0;f[e>>2]=m;f[n>>2]=j;if(k|0?(j=k+4|0,n=f[j>>2]|0,f[j>>2]=n+-1,(n|0)==1):0)ki[f[(f[k>>2]|0)+8>>2]&2047](k);k=f[l>>2]|0;f[l>>2]=k+-1;if((k|0)==1)ki[f[(f[m>>2]|0)+8>>2]&2047](m)}m=f[c>>2]|0;k=bY(b)|0;l=m+4|0;n=f[l>>2]|0;j=f[m>>2]|0;e=n-j>>4;o=j;j=n;if(k>>>0<=e>>>0){if(k>>>0<e>>>0?(n=o+(k<<4)|0,(j|0)!=(n|0)):0)f[l>>2]=j+(~((j+-16-n|0)>>>4)<<4)}else Bra(m,k-e|0);f[a+380>>2]=0;e=b+4|0;aY(g,f[b>>2]|0,f[e>>2]|0,0);k=f[b>>2]|0;m=f[e>>2]|0;aY(h,k,m,bY(b)|0);b=f[c>>2]|0;c=g+40|0;m=g+4|0;k=h+4|0;e=g+20|0;n=h+20|0;j=h+40|0;l=i+4|0;o=0;while(1){p=f[g>>2]|0;q=p;if((((p|0)==(f[h>>2]|0)?(f[m>>2]|0)==(f[k>>2]|0):0)?(f[e>>2]|0)==(f[n>>2]|0):0)?(f[c>>2]|0)==(f[j>>2]|0):0)break;p=(f[b>>2]|0)+(o<<4)|0;r=f[e>>2]|0;f[i>>2]=q;f[l>>2]=r;Cra(p,i)|0;cY(g)|0;o=o+1|0}f[a+40>>2]=1;o=a+24|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if(!(uU()|0)){u=d;return 1}f[o>>2]=8;f[a+28>>2]=8;u=d;return 1}function mra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=NYa(388)|0;ura(c);d=NYa(16)|0;e=d+4|0;f[e>>2]=1;f[d>>2]=76952;f[d+8>>2]=c;g=d;h=c;ara(c,b)|0;i=c+356|0;j=f[b+356>>2]|0;k=f[b+360>>2]|0;if(j|0){l=j+4|0;f[l>>2]=(f[l>>2]|0)+1}l=f[i>>2]|0;f[i>>2]=j;f[c+360>>2]=k;if(l|0?(k=l+4|0,j=f[k>>2]|0,f[k>>2]=j+-1,(j|0)==1):0)ki[f[(f[l>>2]|0)+8>>2]&2047](l);l=c+364|0;j=f[b+364>>2]|0;k=f[b+368>>2]|0;if(j|0){i=j+4|0;f[i>>2]=(f[i>>2]|0)+1}i=f[l>>2]|0;f[l>>2]=j;f[c+368>>2]=k;if(i|0?(k=i+4|0,j=f[k>>2]|0,f[k>>2]=j+-1,(j|0)==1):0)ki[f[(f[i>>2]|0)+8>>2]&2047](i);i=c+372|0;j=f[b+372>>2]|0;k=f[b+376>>2]|0;if(j|0){l=j+4|0;f[l>>2]=(f[l>>2]|0)+1}l=f[i>>2]|0;f[i>>2]=j;f[c+376>>2]=k;if(l|0?(k=l+4|0,j=f[k>>2]|0,f[k>>2]=j+-1,(j|0)==1):0)ki[f[(f[l>>2]|0)+8>>2]&2047](l);l=b+380|0;b=f[l+4>>2]|0;j=c+380|0;f[j>>2]=f[l>>2];f[j+4>>2]=b;f[a>>2]=g;f[a+4>>2]=h;f[e>>2]=(f[e>>2]|0)+1;h=f[e>>2]|0;f[e>>2]=h+-1;if((h|0)!=1)return;ki[f[(f[d>>2]|0)+8>>2]&2047](d);return}function nra(a){a=a|0;return 1}function ora(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;if((d|0)>-1?(h=f[a+352>>2]|0,i=f[h+4>>2]|0,j=f[h>>2]|0,((i-j|0)/20|0|0)>(d|0)):0){k=j;l=i;m=h}else{f[g>>2]=0;f[g+4>>2]=0;h=c$(g,50)|0;i=334949;j=h+50|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-215,g,335413,334674,868);d$(g);g=f[a+352>>2]|0;k=f[g>>2]|0;l=f[g+4>>2]|0;m=g}if(((l-k|0)/20|0)>>>0<=d>>>0)hXa(m);m=k;k=f[c>>2]|0;if((k|0)<0){n=0;u=e;return n|0}l=f[c+4>>2]|0;if((l|0)<0){n=0;u=e;return n|0}if(((f[a+8>>2]|0)+k|0)>=(f[m+(d*20|0)+4>>2]|0)){n=0;u=e;return n|0}if(((f[a+12>>2]|0)+l|0)>=(f[m+(d*20|0)+8>>2]|0)){n=0;u=e;return n|0}c=(f[a+60>>2]|0)+(Y(f[f[a+88>>2]>>2]|0,l)|0)+(k<<2)|0;f[a+384>>2]=c+(f[m+(d*20|0)+12>>2]<<2);n=1;u=e;return n|0}function pra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+380>>2]|0;d=f[a+384>>2]|0;a=f[d+(f[c+(b<<6)+20>>2]<<2)>>2]|0;e=f[d+(f[c+(b<<6)+24>>2]<<2)>>2]|0;g=f[d+(f[c+(b<<6)+36>>2]<<2)>>2]|0;h=f[d+(f[c+(b<<6)+40>>2]<<2)>>2]|0;i=a-e-g+h|0;j=f[d+(f[c+(b<<6)+4>>2]<<2)>>2]|0;k=f[d+(f[c+(b<<6)+16>>2]<<2)>>2]|0;l=f[d+(f[c+(b<<6)+8>>2]<<2)>>2]|0;m=f[d+(f[c+(b<<6)+28>>2]<<2)>>2]|0;n=f[d+(f[c+(b<<6)+44>>2]<<2)>>2]|0;o=f[d+(f[c+(b<<6)+56>>2]<<2)>>2]|0;p=f[d+(f[c+(b<<6)+52>>2]<<2)>>2]|0;q=f[d+(f[c+(b<<6)+32>>2]<<2)>>2]|0;return ((e-a+j-l|0)>=(i|0)?64:0)|(((f[d+(f[c+(b<<6)>>2]<<2)>>2]|0)+a-j-k|0)>=(i|0)?128:0)|((l-e-(f[d+(f[c+(b<<6)+12>>2]<<2)>>2]|0)+m|0)>=(i|0)?32:0)|((e-h-m+n|0)>=(i|0)?16:0)|((h-n-o+(f[d+(f[c+(b<<6)+60>>2]<<2)>>2]|0)|0)>=(i|0)?8:0)|((g-h+o-p|0)>=(i|0)?4:0)|(g-a+k-q|0)>=(i|0)|((p-g+q-(f[d+(f[c+(b<<6)+48>>2]<<2)>>2]|0)|0)>=(i|0)?2:0)|0}function qra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+80|0;e=d+24|0;g=d+8|0;h=d;i=f[a+352>>2]|0;j=f[i>>2]|0;if((((f[i+4>>2]|0)-j|0)/20|0)>>>0<=b>>>0)hXa(i);i=j;if((NS(c)|0)==655360){j=f[i+(b*20|0)+12>>2]|0;k=f[a+16>>2]|0;l=f[i+(b*20|0)+4>>2]|0;m=f[i+(b*20|0)+8>>2]|0;f[g>>2]=(j|0)%(k|0)|0;f[g+4>>2]=(j|0)/(k|0)|0;f[g+8>>2]=l;f[g+12>>2]=m;g0(e,a+204|0,g);m=g+8|0;f[m>>2]=0;f[m+4>>2]=0;f[g>>2]=34209792;f[g+4>>2]=e;m=fT()|0;aqa(c,g,m,fT()|0,4,-1);j0(e);u=d;return}f[h>>2]=f[i+(b*20|0)+4>>2];f[h+4>>2]=f[i+(b*20|0)+8>>2];CN(e,h,4,(f[a+60>>2]|0)+(f[i+(b*20|0)+12>>2]<<2)|0,f[a+92>>2]|0);a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=e;a=fT()|0;aqa(c,g,a,fT()|0,4,-1);a=e+36|0;g=f[a>>2]|0;if(g|0?(c=g+12|0,g=f[c>>2]|0,f[c>>2]=g+-1,(g|0)==1):0)CR(e);f[a>>2]=0;a=e+16|0;g=e+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[g>>2]|0)>0){a=f[e+40>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[g>>2]|0))}g=f[e+44>>2]|0;if((g|0)!=(e+48|0))ZF(g);u=d;return}function rra(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=f[a+16>>2]|0;c=f[a+360>>2]|0;d=(f[c+4>>2]|0)-(f[c>>2]|0)>>4;e=a+368|0;g=f[e>>2]|0;h=g+4|0;i=f[h>>2]|0;j=f[g>>2]|0;k=i-j>>6;l=j;j=i;if(d>>>0<=k>>>0){if(d>>>0<k>>>0?(i=l+(d<<6)|0,(j|0)!=(i|0)):0)f[h>>2]=j+(~((j+-64-i|0)>>>6)<<6);i=f[g>>2]|0;f[a+380>>2]=i;if(!d){m=g;n=a+252|0;tra(m,n);return}else{o=i;p=g}}else{sra(g,d-k|0);k=f[e>>2]|0;e=f[k>>2]|0;f[a+380>>2]=e;o=e;p=k}k=o;o=f[c>>2]|0;c=0;do{e=f[o+(c<<4)>>2]|0;g=f[o+(c<<4)+4>>2]|0;i=f[o+(c<<4)+8>>2]|0;j=f[o+(c<<4)+12>>2]|0;h=Y(g,b)|0;f[k+(c<<6)>>2]=h+e;l=i+e|0;f[k+(c<<6)+4>>2]=l+h;q=Y(j+g|0,b)|0;f[k+(c<<6)+16>>2]=q+e;f[k+(c<<6)+20>>2]=q+l;r=(i<<1)+e|0;f[k+(c<<6)+8>>2]=r+h;s=r+i|0;f[k+(c<<6)+12>>2]=s+h;f[k+(c<<6)+24>>2]=q+r;f[k+(c<<6)+28>>2]=s+q;q=(j<<1)+g|0;g=Y(q,b)|0;f[k+(c<<6)+40>>2]=g+r;f[k+(c<<6)+44>>2]=g+s;h=Y(q+j|0,b)|0;f[k+(c<<6)+56>>2]=h+r;f[k+(c<<6)+60>>2]=h+s;f[k+(c<<6)+32>>2]=g+e;f[k+(c<<6)+36>>2]=g+l;f[k+(c<<6)+48>>2]=h+e;f[k+(c<<6)+52>>2]=h+l;c=c+1|0}while((c|0)!=(d|0));m=p;n=a+252|0;tra(m,n);return}function sra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>6>>>0>=b>>>0){h=g;i=b;do{j=h;k=j+64|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));h=(f[e>>2]|0)+64|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=g-i>>6;g=h+b|0;if(g>>>0>67108863)gXa(a);l=d-i|0;i=l>>5;d=l>>6>>>0<33554431?(i>>>0<g>>>0?g:i):67108863;do if(d)if(d>>>0>67108863){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{m=NYa(d<<6)|0;break}else m=0;while(0);i=m+(h<<6)|0;h=m+(d<<6)|0;d=i;m=b;b=i;do{j=d;k=j+64|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));d=b+64|0;b=d;m=m+-1|0}while((m|0)!=0);m=f[a>>2]|0;d=(f[e>>2]|0)-m|0;j=i+(0-(d>>6)<<6)|0;if((d|0)>0)K1a(j|0,m|0,d|0)|0;f[a>>2]=j;f[e>>2]=b;f[c>>2]=h;if(!m)return;PYa(m);return}function tra(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+80|0;e=d+56|0;g=d;h=f[a>>2]|0;i=a+4|0;j=f[i>>2]|0;if((h|0)==(j|0)){k=c+24|0;l=f[k>>2]|0;if(l|0?(m=l+8|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)k0(c);l=c+4|0;if((f[l>>2]|0)>0){m=f[c+32>>2]|0;n=0;do{f[m+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[l>>2]|0))}f[k>>2]=0;o=f[i>>2]|0;p=f[a>>2]|0}else{o=j;p=h}h=o-p|0;o=p;f[g>>2]=1124007936;j=g+4|0;f[j>>2]=2;a=g+8|0;f[a>>2]=1;i=g+12|0;f[i>>2]=h;k=g+16|0;f[k>>2]=o;l=g+20|0;f[l>>2]=o;n=g+24|0;m=g+28|0;q=g+40|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[q>>2]=a;r=g+48|0;s=g+44|0;f[s>>2]=r;f[g+52>>2]=0;f[r>>2]=0;if((p|0)==0&(h|0)!=0){f[e>>2]=0;f[e+4>>2]=0;p=c$(e,26)|0;t=358223;v=p+26|0;do{b[p>>0]=b[t>>0]|0;p=p+1|0;t=t+1|0}while((p|0)<(v|0));j$(-215,e,358250,358254,500);d$(e);w=f[g>>2]|16384;x=f[i>>2]|0;y=f[s>>2]|0;z=f[l>>2]|0}else{w=1124024320;x=h;y=r;z=o}f[g>>2]=w;f[y>>2]=x;f[y+4>>2]=1;y=z+(Y(f[a>>2]|0,x)|0)|0;f[m>>2]=y;f[n>>2]=y+(0-x)+x;x=e+8|0;f[x>>2]=0;f[x+4>>2]=0;f[e>>2]=34209792;f[e+4>>2]=c;eL(g,e);e=g+36|0;c=f[e>>2]|0;if(c|0?(x=c+12|0,c=f[x>>2]|0,f[x>>2]=c+-1,(c|0)==1):0)CR(g);f[e>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[q>>2]|0;q=0;do{f[k+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[j>>2]|0))}j=f[s>>2]|0;if((j|0)==(r|0)){u=d;return}ZF(j);u=d;return}function ura(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=a+8|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[a+44>>2]=1124007936;b=a+52|0;c=a+84|0;d=a+48|0;e=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));f[c>>2]=b;b=a+92|0;f[a+88>>2]=b;f[b>>2]=0;f[a+96>>2]=0;f[a+100>>2]=1124007936;b=a+108|0;c=a+140|0;d=a+104|0;e=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));f[c>>2]=b;b=a+148|0;f[a+144>>2]=b;f[b>>2]=0;f[a+152>>2]=0;f[a+156>>2]=1124007936;b=a+160|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+188>>2]=a+164;b=a+196|0;f[a+192>>2]=b;f[a+200>>2]=0;f[b>>2]=0;f[a+204>>2]=1124007936;b=a+208|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+236>>2]=a+212;b=a+244|0;f[a+240>>2]=b;f[a+248>>2]=0;f[b>>2]=0;f[a+252>>2]=1124007936;b=a+256|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+284>>2]=a+260;b=a+292|0;f[a+288>>2]=b;f[a+296>>2]=0;f[b>>2]=0;f[a+300>>2]=1124007936;b=a+304|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+332>>2]=a+308;b=a+340|0;f[a+336>>2]=b;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[a>>2]=76892;b=a+356|0;c=a+364|0;d=a+368|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;e=NYa(12)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=NYa(16)|0;h=g+4|0;f[h>>2]=1;f[g>>2]=76972;f[g+8>>2]=e;f[h>>2]=(f[h>>2]|0)+1;i=f[b>>2]|0;f[b>>2]=g;f[a+360>>2]=e;if(i|0?(e=i+4|0,b=f[e>>2]|0,f[e>>2]=b+-1,(b|0)==1):0)ki[f[(f[i>>2]|0)+8>>2]&2047](i);i=f[h>>2]|0;f[h>>2]=i+-1;if((i|0)==1)ki[f[(f[g>>2]|0)+8>>2]&2047](g);g=NYa(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;i=NYa(16)|0;h=i+4|0;f[h>>2]=1;f[i>>2]=76992;f[i+8>>2]=g;f[h>>2]=(f[h>>2]|0)+1;b=f[c>>2]|0;f[c>>2]=i;f[d>>2]=g;if(b|0?(g=b+4|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)ki[f[(f[b>>2]|0)+8>>2]&2047](b);b=f[h>>2]|0;f[h>>2]=b+-1;if((b|0)==1)ki[f[(f[i>>2]|0)+8>>2]&2047](i);i=NYa(12)|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b=NYa(16)|0;h=b+4|0;f[h>>2]=1;f[b>>2]=76712;f[b+8>>2]=i;d=a+348|0;f[h>>2]=(f[h>>2]|0)+1;g=f[d>>2]|0;f[d>>2]=b;f[a+352>>2]=i;if(g|0?(i=g+4|0,d=f[i>>2]|0,f[i>>2]=d+-1,(d|0)==1):0)ki[f[(f[g>>2]|0)+8>>2]&2047](g);g=f[h>>2]|0;f[h>>2]=g+-1;if((g|0)!=1){j=a+380|0;f[j>>2]=0;k=a+384|0;f[k>>2]=0;return}ki[f[(f[b>>2]|0)+8>>2]&2047](b);j=a+380|0;f[j>>2]=0;k=a+384|0;f[k>>2]=0;return}function vra(a){a=a|0;PYa(a);return}function wra(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function xra(a){a=a|0;PYa(a);return}function yra(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+8>>2]|0;if(b|0){c=f[b>>2]|0;if(c|0){d=b+4|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-64-c|0)>>>6)<<6);PYa(c)}PYa(b)}ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function zra(a){a=a|0;PYa(a);return}function Ara(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+8>>2]|0;if(b|0){c=f[b>>2]|0;if(c|0){d=b+4|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-16-c|0)>>>4)<<4);PYa(c)}PYa(b)}ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Bra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>4>>>0>=b>>>0){h=g;i=b;do{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;h=(f[e>>2]|0)+16|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=g-i>>4;g=h+b|0;if(g>>>0>268435455)gXa(a);j=d-i|0;i=j>>3;d=j>>4>>>0<134217727?(i>>>0<g>>>0?g:i):268435455;do if(d)if(d>>>0>268435455){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{k=NYa(d<<4)|0;break}else k=0;while(0);i=k+(h<<4)|0;h=i;g=k+(d<<4)|0;d=i;k=b;b=h;do{f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;d=b+16|0;b=d;k=k+-1|0}while((k|0)!=0);k=g;g=f[a>>2]|0;d=f[e>>2]|0;j=g;if((d|0)==(g|0)){l=h;m=j}else{h=d+-16-j|0;j=i;n=d;while(1){d=n;n=n+-16|0;f[j+-16>>2]=f[n>>2];f[j+-12>>2]=f[d+-12>>2];f[j+-8>>2]=f[d+-8>>2];f[j+-4>>2]=f[d+-4>>2];if((n|0)==(g|0))break;else j=j+-16|0}l=i+(~(h>>>4)<<4)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=b;f[c>>2]=k;if(!m)return;PYa(m);return}function Cra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+64|0;d=c+56|0;e=c+48|0;g=c;$X(e,b,335733);aY(g,f[e>>2]|0,f[e+4>>2]|0,0);e=f[g+20>>2]|0;f[d>>2]=f[g>>2];f[d+4>>2]=e;oY(d,a,0);e=cY(g)|0;b=f[g+20>>2]|0;f[d>>2]=f[g>>2];f[d+4>>2]=b;oY(d,a+4|0,0);b=cY(e)|0;e=f[g+20>>2]|0;f[d>>2]=f[g>>2];f[d+4>>2]=e;oY(d,a+8|0,0);e=cY(b)|0;b=f[g+20>>2]|0;f[d>>2]=f[g>>2];f[d+4>>2]=b;oY(d,a+12|0,0);cY(e)|0;u=c;return 1}function Dra(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=77012;V$(a+416|0);j0(a+368|0);j0(a+320|0);j0(a+272|0);j0(a+224|0);j0(a+176|0);j0(a+128|0);b=a+120|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)ki[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+124>>2]=0;b=a+112|0;c=f[b>>2]|0;if(c|0?(e=c+4|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)ki[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+116>>2]=0;b=a+104|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)ki[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+108>>2]=0;msa(a+4|0);OF(a);return}function Era(a){a=a|0;Dra(a);PYa(a);return}function Fra(a,b){a=a|0;b=b|0;nsa(a,b)|0;return}function Gra(a){a=a|0;var b=0;if(f[a+116>>2]|0){b=0;return b|0}b=(f[a+32>>2]|0)==(f[a+36>>2]|0);return b|0}function Hra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+240|0;d=c+132|0;e=c+88|0;g=c+44|0;h=c+8|0;i=c;j=a+112|0;k=f[j>>2]|0;if(k|0?(l=k+4|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0)ki[f[(f[k>>2]|0)+8>>2]&2047](k);f[j>>2]=0;k=a+116|0;f[k>>2]=0;m=d;l=m+100|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(l|0));m=a+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;if((m|0)!=(d|0)){hsa(a+32|0,0,0);isa(a+44|0,f[d+40>>2]|0,f[d+44>>2]|0);jsa(a+56|0,f[d+52>>2]|0,f[d+56>>2]|0);tD(a+68|0,f[d+64>>2]|0,f[d+68>>2]|0);ksa(a+80|0,f[d+76>>2]|0,f[d+80>>2]|0);lsa(a+92|0,f[d+88>>2]|0,f[d+92>>2]|0)}msa(d);m=a+104|0;l=f[m>>2]|0;if(l|0?(n=l+4|0,o=f[n>>2]|0,f[n>>2]=o+-1,(o|0)==1):0)ki[f[(f[l>>2]|0)+8>>2]&2047](l);f[m>>2]=0;f[a+108>>2]=0;f[d>>2]=0;f[d+4>>2]=0;VX(h,b,0,d);d$(d);if(!(gV(h)|0)){p=0;dV(h);u=c;return p|0}XX(d,h,0);m=d+4|0;aY(e,f[d>>2]|0,f[m>>2]|0,0);l=f[d>>2]|0;o=f[m>>2]|0;aY(g,l,o,bY(d)|0);d=f[e>>2]|0;o=d;if((((d|0)==(f[g>>2]|0)?(f[e+4>>2]|0)==(f[g+4>>2]|0):0)?(f[e+20>>2]|0)==(f[g+20>>2]|0):0)?(f[e+40>>2]|0)==(f[g+40>>2]|0):0){f[i>>2]=0;f[i+4>>2]=0}else{g=f[e+20>>2]|0;f[i>>2]=o;f[i+4>>2]=g}if(nsa(a,i)|0){p=1;dV(h);u=c;return p|0}hV(h);i=f[b>>2]|0;b=UX((i|0)==0?5694105:i,0,0,0)|0;if(!b)q=0;else{i=NYa(16)|0;f[i+4>>2]=1;f[i>>2]=77392;f[i+8>>2]=b;q=i}i=f[j>>2]|0;f[j>>2]=q;f[k>>2]=b;if(i|0?(b=i+4|0,q=f[b>>2]|0,f[b>>2]=q+-1,(q|0)==1):0)ki[f[(f[i>>2]|0)+8>>2]&2047](i);p=(f[k>>2]|0)!=0;dV(h);u=c;return p|0}function Ira(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=u;u=u+48|0;k=j+40|0;l=j+28|0;m=j+16|0;n=j+8|0;o=j;_$(k,77364);f[l>>2]=0;p=l+4|0;f[p>>2]=0;f[l+8>>2]=0;f[m>>2]=0;q=m+4|0;f[q>>2]=0;f[m+8>>2]=0;r=f[(f[a>>2]|0)+44>>2]|0;f[n>>2]=f[h>>2];f[n+4>>2]=f[h+4>>2];f[o>>2]=f[i>>2];f[o+4>>2]=f[i+4>>2];Kg[r&3](a,b,c,l,m,d,e,g,n,o,0);o=f[m>>2]|0;if(o|0){m=f[q>>2]|0;if((m|0)!=(o|0))f[q>>2]=m+(~((m+-8-o|0)>>>3)<<3);PYa(o)}o=f[l>>2]|0;if(o|0){l=f[p>>2]|0;if((l|0)!=(o|0))f[p>>2]=l+(~((l+-4-o|0)>>>2)<<2);PYa(o)}if(!(f[k+4>>2]|0)){u=j;return}u=j;return}function Jra(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;l=u;u=u+160|0;m=l+136|0;n=l+128|0;o=l+72|0;p=l+56|0;q=l+32|0;r=l+48|0;s=l+24|0;t=l+16|0;v=l+8|0;w=l;_$(n,77324);do if((NS(c)|0)==65536){x=f[c+4>>2]|0;f[o>>2]=f[x>>2];y=o+4|0;z=x+4|0;f[y>>2]=f[z>>2];A=o+8|0;f[A>>2]=f[x+8>>2];f[o+12>>2]=f[x+12>>2];f[o+16>>2]=f[x+16>>2];f[o+20>>2]=f[x+20>>2];f[o+24>>2]=f[x+24>>2];f[o+28>>2]=f[x+28>>2];f[o+32>>2]=f[x+32>>2];B=f[x+36>>2]|0;f[o+36>>2]=B;f[o+40>>2]=A;A=o+48|0;C=o+44|0;f[C>>2]=A;f[A>>2]=0;f[o+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[x+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;BR(o,x);break}}else OR(o,c,-1);while(0);if(!(g>1.0?!(f[o>>2]&7|0):0)){f[m>>2]=0;f[m+4>>2]=0;c=c$(m,37)|0;x=337381;y=c+37|0;do{b[c>>0]=b[x>>0]|0;c=c+1|0;x=x+1|0}while((c|0)<(y|0));j$(-215,m,335797,334674,1424);d$(m)}if(!(mi[f[(f[a>>2]|0)+20>>2]&255](a)|0)){f[p>>2]=0;x=p+4|0;f[x>>2]=0;f[p+8>>2]=0;f[q>>2]=0;c=q+4|0;f[c>>2]=0;f[q+8>>2]=0;if(mi[f[(f[a>>2]|0)+48>>2]&255](a)|0){f[m>>2]=0;y=m+4|0;f[y>>2]=0;f[m+8>>2]=0;z=f[a+112>>2]|0;f[r>>2]=z;A=r+4|0;f[A>>2]=f[a+116>>2];if(z|0){C=z+4|0;f[C>>2]=(f[C>>2]|0)+1}f[s>>2]=f[j>>2];f[s+4>>2]=f[j+4>>2];f[t>>2]=f[k>>2];f[t+4>>2]=f[k+4>>2];Rra(o,r,d,p,q,m,g,h,i,s,t,0);t=f[r>>2]|0;if(t|0?(s=t+4|0,i=f[s>>2]|0,f[s>>2]=i+-1,(i|0)==1):0)ki[f[(f[t>>2]|0)+8>>2]&2047](t);f[r>>2]=0;f[A>>2]=0;A=f[y>>2]|0;r=f[m>>2]|0;t=(A-r|0)/20|0;i=e+4|0;s=f[i>>2]|0;C=f[e>>2]|0;z=s-C>>2;B=C;C=s;s=r;r=A;if(t>>>0<=z>>>0)if(t>>>0<z>>>0?(A=B+(t<<2)|0,(C|0)!=(A|0)):0){f[i>>2]=C+(~((C+-4-A|0)>>>2)<<2);D=s;E=r;F=B}else{D=s;E=r;F=B}else{GM(e,t-z|0);D=f[m>>2]|0;E=f[y>>2]|0;F=f[e>>2]|0}if((D|0)!=(E|0)){z=D;t=F;while(1){f[t>>2]=f[z+16>>2];z=z+20|0;if((z|0)==(E|0))break;else t=t+4|0}}if(D|0){if((E|0)!=(D|0))f[y>>2]=E+(~(((E+-20-D|0)>>>0)/20|0)*20|0);PYa(D)}}else{f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=o;f[v>>2]=f[j>>2];f[v+4>>2]=f[j+4>>2];f[w>>2]=f[k>>2];f[w+4>>2]=f[k+4>>2];Sra(a,m,d,p,q,g,v,w,0);_$(m,77344);Tra(d,h,.2,e,0)}e=f[q>>2]|0;if(e|0){q=f[c>>2]|0;if((q|0)!=(e|0))f[c>>2]=q+(~((q+-8-e|0)>>>3)<<3);PYa(e)}e=f[p>>2]|0;if(e|0){p=f[x>>2]|0;if((p|0)!=(e|0))f[x>>2]=p+(~((p+-4-e|0)>>>2)<<2);PYa(e)}}e=o+36|0;p=f[e>>2]|0;if(p|0?(x=p+12|0,p=f[x>>2]|0,f[x>>2]=p+-1,(p|0)==1):0)CR(o);f[e>>2]=0;e=o+16|0;p=o+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[p>>2]|0)>0){e=f[o+40>>2]|0;x=0;do{f[e+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[p>>2]|0))}p=f[o+44>>2]|0;if((p|0)!=(o+48|0))ZF(p);if(!(f[n+4>>2]|0)){u=l;return}u=l;return}function Kra(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;n=u;u=u+128|0;o=n+64|0;p=n+56|0;q=n+16|0;r=n+48|0;s=n+40|0;t=n+32|0;v=n+8|0;w=n;_$(p,77084);if(!(h>1.0?!(VS(c,-1)|0):0)){f[o>>2]=0;f[o+4>>2]=0;x=c$(o,38)|0;y=335758;z=x+38|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));j$(-215,o,335797,334674,1376);d$(o)}do if(!(mi[f[(f[a>>2]|0)+20>>2]&255](a)|0)){if(!(mi[f[(f[a>>2]|0)+48>>2]&255](a)|0)){f[v>>2]=f[k>>2];f[v+4>>2]=f[k+4>>2];f[w>>2]=f[l>>2];f[w+4>>2]=f[l+4>>2];Sra(a,c,d,e,g,h,v,w,m);if(m){_$(o,77104);Tra(d,i,.2,e,g);break}else{_$(o,77124);Tra(d,i,.2,0,0);break}}do if((NS(c)|0)==65536){y=f[c+4>>2]|0;f[o>>2]=f[y>>2];x=o+4|0;z=y+4|0;f[x>>2]=f[z>>2];A=o+8|0;f[A>>2]=f[y+8>>2];f[o+12>>2]=f[y+12>>2];f[o+16>>2]=f[y+16>>2];f[o+20>>2]=f[y+20>>2];f[o+24>>2]=f[y+24>>2];f[o+28>>2]=f[y+28>>2];f[o+32>>2]=f[y+32>>2];B=f[y+36>>2]|0;f[o+36>>2]=B;f[o+40>>2]=A;A=o+48|0;C=o+44|0;f[C>>2]=A;f[A>>2]=0;f[o+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[y+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[x>>2]=0;BR(o,y);break}}else OR(o,c,-1);while(0);f[q>>2]=0;y=q+4|0;f[y>>2]=0;f[q+8>>2]=0;x=f[a+112>>2]|0;f[r>>2]=x;z=r+4|0;f[z>>2]=f[a+116>>2];if(x|0){A=x+4|0;f[A>>2]=(f[A>>2]|0)+1}f[s>>2]=f[k>>2];f[s+4>>2]=f[k+4>>2];f[t>>2]=f[l>>2];f[t+4>>2]=f[l+4>>2];Rra(o,r,d,e,g,q,h,i,j,s,t,m);A=f[r>>2]|0;if(A|0?(x=A+4|0,C=f[x>>2]|0,f[x>>2]=C+-1,(C|0)==1):0)ki[f[(f[A>>2]|0)+8>>2]&2047](A);f[r>>2]=0;f[z>>2]=0;z=f[q>>2]|0;if(z|0){A=f[y>>2]|0;if((A|0)!=(z|0))f[y>>2]=A+(~(((A+-20-z|0)>>>0)/20|0)*20|0);PYa(z)}z=o+36|0;A=f[z>>2]|0;if(A|0?(y=A+12|0,A=f[y>>2]|0,f[y>>2]=A+-1,(A|0)==1):0)CR(o);f[z>>2]=0;z=o+16|0;A=o+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[A>>2]|0)>0){z=f[o+40>>2]|0;y=0;do{f[z+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[A>>2]|0))}A=f[o+44>>2]|0;if((A|0)!=(o+48|0))ZF(A)}while(0);if(!(f[p+4>>2]|0)){u=n;return}u=n;return}function Lra(a){a=a|0;return (f[a+116>>2]|0)!=0|0}function Mra(a,b){a=a|0;b=b|0;f[a>>2]=f[b+24>>2];f[a+4>>2]=f[b+28>>2];return}function Nra(a){a=a|0;var b=0;b=f[a+108>>2]|0;return mi[f[(f[b>>2]|0)+16>>2]&255](b)|0}function Ora(a){a=a|0;return f[a+116>>2]|0}function Pra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a+120|0;d=f[b>>2]|0;e=f[b+4>>2]|0;if(d|0){b=d+4|0;f[b>>2]=(f[b>>2]|0)+1}b=f[c>>2]|0;f[c>>2]=d;f[a+124>>2]=e;if(!b)return;e=b+4|0;a=f[e>>2]|0;f[e>>2]=a+-1;if((a|0)!=1)return;ki[f[(f[b>>2]|0)+8>>2]&2047](b);return}function Qra(a,b){a=a|0;b=b|0;var c=0;c=f[b+120>>2]|0;f[a>>2]=c;f[a+4>>2]=f[b+124>>2];if(!c)return;b=c+4|0;f[b>>2]=(f[b>>2]|0)+1;return}function Rra(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;o=u;u=u+64|0;p=o+56|0;q=o;r=o+8|0;s=o+48|0;t=o+40|0;v=pL(0)|0;if(!v)w=0;else{x=NYa(16)|0;f[x+4>>2]=1;f[x>>2]=49084;f[x+8>>2]=v;w=x}x=f[a+8>>2]|0;y=(f[a+4>>2]|0)==1?1:f[a+12>>2]|0;z=f[a>>2]|0;A=z&4095;B=f[a+16>>2]|0;C=Y((z>>>3&511)+1<<(47696>>>(A<<1&14)&3),y)|0;f[r>>2]=A|1111638016;A=r+4|0;f[A>>2]=C;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=B;f[r+20>>2]=x;f[r+24>>2]=y;f[A>>2]=f[f[a+44>>2]>>2];f[r>>2]=z&20479|1111621632;z=f[c+4>>2]|0;f[s>>2]=f[l>>2];f[s+4>>2]=f[l+4>>2];f[t>>2]=f[m>>2];f[t+4>>2]=f[m+4>>2];f[q>>2]=f[s>>2];f[q+4>>2]=f[s+4>>2];f[p>>2]=f[t>>2];f[p+4>>2]=f[t+4>>2];t=ita(r,z,v,e,g,i,j,k,q,p,n)|0;if(!t){D=q;E=0}else{if((f[t+28>>2]|0)!=20){f[p>>2]=0;f[p+4>>2]=0;n=c$(p,39)|0;k=337105;j=n+39|0;do{b[n>>0]=b[k>>0]|0;n=n+1|0;k=k+1|0}while((n|0)<(j|0));j$(-215,p,337145,337149,2974);d$(p)}D=q;E=f[t+24>>2]|0}D=h+4|0;k=f[D>>2]|0;n=f[h>>2]|0;j=(k-n|0)/20|0;g=n;n=k;if(E>>>0<=j>>>0){if(E>>>0<j>>>0?(k=g+(E*20|0)|0,(n|0)!=(k|0)):0)f[D>>2]=n+(~(((n+-20-k|0)>>>0)/20|0)*20|0)}else fsa(h,E-j|0);if((t|0)!=0&(E|0)!=0){E=f[h>>2]|0;j=q;f[j>>2]=0;f[j+4>>2]=1073741823;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];BL(t,E,p)|0}p=f[D>>2]|0;E=f[h>>2]|0;t=(p-E|0)/20|0;q=d+4|0;j=f[q>>2]|0;k=f[d>>2]|0;n=j-k>>4;g=k;k=j;j=E;E=p;if(t>>>0<=n>>>0)if(t>>>0<n>>>0?(p=g+(t<<4)|0,(k|0)!=(p|0)):0){f[q>>2]=k+(~((k+-16-p|0)>>>4)<<4);F=j;G=E;H=g}else{F=j;G=E;H=g}else{gsa(d,t-n|0);F=f[h>>2]|0;G=f[D>>2]|0;H=f[d>>2]|0}if((F|0)!=(G|0)){d=F;F=H;while(1){H=f[d+4>>2]|0;D=f[d+8>>2]|0;h=f[d+12>>2]|0;f[F>>2]=f[d>>2];f[F+4>>2]=H;f[F+8>>2]=D;f[F+12>>2]=h;d=d+20|0;if((d|0)==(G|0))break;else F=F+16|0}}if(!w){u=o;return}F=w+4|0;G=f[F>>2]|0;f[F>>2]=G+-1;if((G|0)!=1){u=o;return}ki[f[(f[w>>2]|0)+8>>2]&2047](w);u=o;return}function Sra(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0;k=u;u=u+1360|0;l=k+1352|0;m=k+1344|0;o=k+1336|0;q=k+1324|0;r=k+1312|0;s=k+1256|0;t=k;v=k+1200|0;w=k+136|0;x=k+24|0;y=k+16|0;_$(l,77164);QR(m,b,-1);Gh[f[(f[a>>2]|0)+52>>2]&511](o,a);z=i+4|0;if((f[z>>2]|0)!=0?(f[i>>2]|0)!=0:0){A=m+4|0;B=f[A>>2]|0;C=A}else{f[i>>2]=f[m>>2];A=m+4|0;D=f[A>>2]|0;f[z>>2]=D;B=D;C=A}A=o+4|0;D=f[A>>2]|0;if((B|0)>=(D|0)?(E=f[m>>2]|0,F=f[o>>2]|0,(E|0)>=(F|0)):0){f[q>>2]=0;G=q+4|0;f[G>>2]=0;f[q+8>>2]=0;f[r>>2]=0;H=r+4|0;f[H>>2]=0;f[r+8>>2]=0;I=q+8|0;J=NYa(4096)|0;K=J;L=J+4096|0;f[q>>2]=K;f[G>>2]=K;f[I>>2]=L;M=r+8|0;N=NYa(4096)|0;O=N;f[r>>2]=O;f[H>>2]=O;f[M>>2]=N+4096;N=rNa(+(F|0))|0;a:do if(!((N|0)>(E|0)|(rNa(+(D|0))|0)>(B|0))){O=J;P=L;Q=E;R=D;S=F;T=1.0;while(1){U=T;n[s>>2]=U;if((O|0)==(P|0)){Xra(q,s);V=f[o>>2]|0;W=f[A>>2]|0;X=f[m>>2]|0}else{n[O>>2]=U;f[G>>2]=O+4;V=S;W=R;X=Q}U=T*g;Z=rNa(U*+(V|0))|0;_=rNa(U*+(W|0))|0;if((Z|0)>(X|0)?1:(_|0)>(f[C>>2]|0))break;O=f[G>>2]|0;P=f[I>>2]|0;Q=X;R=W;S=V;T=U}S=f[G>>2]|0;R=f[q>>2]|0;Q=R;P=S;if((S|0)!=(R|0)){O=h+4|0;T=+n[Q>>2];_=wNa(+(V|0)*T)|0;if((_|0)>(f[i>>2]|0)){$=G;aa=Q;ba=Q;ca=Q;da=P;ea=S;fa=R}else{Z=S;S=R;ga=Q;ha=P;ia=Q;ja=Q;U=T;ka=Q;la=_;_=wNa(T*+(W|0))|0;ma=0;while(1){if((_|0)>(f[z>>2]|0)){$=G;aa=ja;ba=ia;ca=ga;da=ha;ea=Z;fa=S;break a}do if((la|0)>=(f[h>>2]|0)?(_|0)>=(f[O>>2]|0):0){na=f[H>>2]|0;if((na|0)==(f[M>>2]|0)){Xra(r,ka);oa=f[G>>2]|0;pa=f[q>>2]|0;qa=pa;ra=qa;sa=qa;ta=oa;ua=qa;va=pa;wa=oa;break}else{n[na>>2]=U;f[H>>2]=na+4;ra=ja;sa=ia;ta=ha;ua=ga;va=S;wa=Z;break}}else{ra=ja;sa=ia;ta=ha;ua=ga;va=S;wa=Z}while(0);ma=ma+1|0;if(ma>>>0>=wa-va>>2>>>0){$=G;aa=ra;ba=sa;ca=ua;da=ta;ea=wa;fa=va;break a}na=f[A>>2]|0;ka=va+(ma<<2)|0;U=+n[ka>>2];la=wNa(+(f[o>>2]|0)*U)|0;_=wNa(U*+(na|0))|0;if((la|0)>(f[i>>2]|0)){$=G;aa=ra;ba=sa;ca=ua;da=ta;ea=wa;fa=va;break}else{Z=wa;S=va;ga=ua;ha=ta;ia=sa;ja=ra}}}}else{$=G;aa=Q;ba=Q;ca=Q;da=P;ea=R;fa=R}}else{$=G;aa=J;ba=J;ca=J;da=J;ea=K;fa=K}while(0);if(!((ca|0)==(da|0)?1:(f[r>>2]|0)!=(f[H>>2]|0))){f[s>>2]=0;da=s+4|0;f[da>>2]=0;f[s+8>>2]=0;if((ea|0)!=(fa|0)){ca=h+4|0;K=s+8|0;J=aa;ra=fa;fa=ea;ea=ba;ba=0;sa=0;ta=0;while(1){g=+n[ea+(ta<<2)>>2];ua=wNa(+(f[o>>2]|0)*g)|0;va=wNa(g*+(f[A>>2]|0))|0;wa=(f[h>>2]|0)-ua|0;ua=Y(wa,wa)|0;wa=(f[ca>>2]|0)-va|0;g=+((Y(wa,wa)|0)+ua|0);p[t>>3]=g;if((ba|0)==(sa|0)){Wra(s,t);ua=f[q>>2]|0;xa=ua;ya=ua;za=f[$>>2]|0}else{p[ba>>3]=g;f[da>>2]=ba+8;xa=J;ya=ra;za=fa}ua=ta+1|0;if(ua>>>0>=za-ya>>2>>>0)break;J=xa;ra=ya;fa=za;ea=ya;ba=f[da>>2]|0;sa=f[K>>2]|0;ta=ua}ta=f[s>>2]|0;K=ta;if((f[da>>2]|0)==(ta|0)){Aa=K;Ba=xa;Ca=0}else{sa=(f[da>>2]|0)-ta>>3;ta=0;ba=0;while(1){ya=+p[K+(ba<<3)>>3]>+p[K+(ta<<3)>>3]?ta:ba;ta=ta+1|0;if(ta>>>0>=sa>>>0){Aa=K;Ba=xa;Ca=ya;break}else ba=ya}}}else{Aa=0;Ba=aa;Ca=0}aa=Ba+(Ca<<2)|0;Ca=f[H>>2]|0;if((Ca|0)==(f[M>>2]|0)){Xra(r,aa);Da=f[s>>2]|0}else{f[Ca>>2]=f[aa>>2];f[H>>2]=Ca+4;Da=Aa}if(Da|0){Aa=f[da>>2]|0;if((Aa|0)!=(Da|0))f[da>>2]=Aa+(~((Aa+-8-Da|0)>>>3)<<3);PYa(Da)}}Da=f[c>>2]|0;Aa=c+4|0;da=f[Aa>>2]|0;if((da|0)!=(Da|0))f[Aa>>2]=da+(~((da+-16-Da|0)>>>4)<<4);Da=f[d>>2]|0;da=d+4|0;Aa=f[da>>2]|0;if((Aa|0)!=(Da|0))f[da>>2]=Aa+(~((Aa+-4-Da|0)>>>2)<<2);Da=f[e>>2]|0;Aa=e+4|0;da=f[Aa>>2]|0;if((da|0)!=(Da|0))f[Aa>>2]=da+(~((da+-8-Da|0)>>>3)<<3);f[s>>2]=1124007936;Da=s+4|0;da=s+8|0;Aa=s+40|0;Ca=Da;aa=Ca+36|0;do{f[Ca>>2]=0;Ca=Ca+4|0}while((Ca|0)<(aa|0));f[Aa>>2]=da;M=s+48|0;Ba=s+44|0;f[Ba>>2]=M;f[M>>2]=0;f[s+52>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;do if((WS(b,-1)|0)<=1){if((NS(b)|0)!=65536){ba=v+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=s;ZS(b,v);break}do if((NS(b)|0)==65536){ba=f[b+4>>2]|0;f[v>>2]=f[ba>>2];xa=v+4|0;K=ba+4|0;f[xa>>2]=f[K>>2];sa=v+8|0;f[sa>>2]=f[ba+8>>2];f[v+12>>2]=f[ba+12>>2];f[v+16>>2]=f[ba+16>>2];f[v+20>>2]=f[ba+20>>2];f[v+24>>2]=f[ba+24>>2];f[v+28>>2]=f[ba+28>>2];f[v+32>>2]=f[ba+32>>2];ta=v+36|0;ya=f[ba+36>>2]|0;f[ta>>2]=ya;f[v+40>>2]=sa;sa=v+48|0;ea=v+44|0;f[ea>>2]=sa;f[sa>>2]=0;f[v+52>>2]=0;if(ya|0){sa=ya+12|0;f[sa>>2]=(f[sa>>2]|0)+1}if((f[K>>2]|0)<3){K=f[ba+44>>2]|0;sa=f[ea>>2]|0;f[sa>>2]=f[K>>2];f[sa+4>>2]=f[K+4>>2];Ea=ta;break}else{f[xa>>2]=0;BR(v,ba);Ea=ta;break}}else{OR(v,b,-1);Ea=v+36|0}while(0);R=f[Ea>>2]|0;if(R|0){P=R+12|0;f[P>>2]=(f[P>>2]|0)+1}P=s+36|0;R=f[P>>2]|0;if(R|0?(Q=R+12|0,R=f[Q>>2]|0,f[Q>>2]=R+-1,(R|0)==1):0)CR(s);f[P>>2]=0;R=s+16|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[Da>>2]|0)>0){Q=f[Aa>>2]|0;ta=0;do{f[Q+(ta<<2)>>2]=0;ta=ta+1|0;Fa=f[Da>>2]|0}while((ta|0)<(Fa|0));f[s>>2]=f[v>>2];if((Fa|0)<3)Ga=71;else Ga=73}else{f[s>>2]=f[v>>2];Ga=71}if((Ga|0)==71){ta=f[v+4>>2]|0;if((ta|0)<3){f[Da>>2]=ta;f[da>>2]=f[v+8>>2];f[s+12>>2]=f[v+12>>2];ta=f[v+44>>2]|0;Q=f[Ba>>2]|0;f[Q>>2]=f[ta>>2];f[Q+4>>2]=f[ta+4>>2]}else Ga=73}if((Ga|0)==73)BR(s,v);ta=v+16|0;f[R>>2]=f[ta>>2];f[s+20>>2]=f[v+20>>2];f[s+24>>2]=f[v+24>>2];f[s+28>>2]=f[v+28>>2];f[s+32>>2]=f[v+32>>2];Q=f[Ea>>2]|0;f[P>>2]=Q;if(Q|0?(ba=Q+12|0,Q=f[ba>>2]|0,f[ba>>2]=Q+-1,(Q|0)==1):0)CR(v);f[Ea>>2]=0;Q=v+4|0;f[ta>>2]=0;f[ta+4>>2]=0;f[ta+8>>2]=0;f[ta+12>>2]=0;if((f[Q>>2]|0)>0){ta=f[v+40>>2]|0;ba=0;do{f[ta+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[Q>>2]|0))}Q=f[v+44>>2]|0;if((Q|0)!=(v+48|0))ZF(Q)}else{Q=v+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=s;f6(b,v,6,0)}while(0);f[t>>2]=16842752;b=t+4|0;f[b>>2]=s;f[t+8>>2]=0;f[t+12>>2]=0;Ea=a+108|0;da=f[Ea>>2]|0;if(ui[f[(f[da>>2]|0)+20>>2]&127](da,t,r)|0){da=f[Ea>>2]|0;ki[f[(f[da>>2]|0)+32>>2]&2047](da);f[v>>2]=1124007936;da=v+4|0;Fa=v+8|0;Q=v+40|0;Ca=da;aa=Ca+36|0;do{f[Ca>>2]=0;Ca=Ca+4|0}while((Ca|0)<(aa|0));f[Q>>2]=Fa;Ca=v+48|0;aa=v+44|0;f[aa>>2]=Ca;f[Ca>>2]=0;f[v+52>>2]=0;ba=f[a+124>>2]|0;if(ba|0){ta=f[(f[ba>>2]|0)+8>>2]|0;do if((NS(t)|0)==65536){P=f[b>>2]|0;f[x>>2]=f[P>>2];R=x+4|0;xa=P+4|0;f[R>>2]=f[xa>>2];K=x+8|0;f[K>>2]=f[P+8>>2];f[x+12>>2]=f[P+12>>2];f[x+16>>2]=f[P+16>>2];f[x+20>>2]=f[P+20>>2];f[x+24>>2]=f[P+24>>2];f[x+28>>2]=f[P+28>>2];f[x+32>>2]=f[P+32>>2];sa=f[P+36>>2]|0;f[x+36>>2]=sa;f[x+40>>2]=K;K=x+48|0;ea=x+44|0;f[ea>>2]=K;f[K>>2]=0;f[x+52>>2]=0;if(sa|0){K=sa+12|0;f[K>>2]=(f[K>>2]|0)+1}if((f[xa>>2]|0)<3){xa=f[P+44>>2]|0;K=f[ea>>2]|0;f[K>>2]=f[xa>>2];f[K+4>>2]=f[xa+4>>2];break}else{f[R>>2]=0;BR(x,P);break}}else OR(x,t,-1);while(0);fi[ta&255](w,ba,x);ba=w+36|0;ta=f[ba>>2]|0;if(ta|0){t=ta+12|0;f[t>>2]=(f[t>>2]|0)+1}t=v+36|0;ta=f[t>>2]|0;if(ta|0?(b=ta+12|0,ta=f[b>>2]|0,f[b>>2]=ta+-1,(ta|0)==1):0)CR(v);f[t>>2]=0;ta=v+16|0;f[ta>>2]=0;f[ta+4>>2]=0;f[ta+8>>2]=0;f[ta+12>>2]=0;if((f[da>>2]|0)>0){b=f[Q>>2]|0;P=0;do{f[b+(P<<2)>>2]=0;P=P+1|0;Ha=f[da>>2]|0}while((P|0)<(Ha|0));f[v>>2]=f[w>>2];if((Ha|0)<3)Ga=103;else Ga=105}else{f[v>>2]=f[w>>2];Ga=103}if((Ga|0)==103){Ha=f[w+4>>2]|0;if((Ha|0)<3){f[da>>2]=Ha;f[Fa>>2]=f[w+8>>2];f[v+12>>2]=f[w+12>>2];Fa=f[w+44>>2]|0;Ha=f[aa>>2]|0;f[Ha>>2]=f[Fa>>2];f[Ha+4>>2]=f[Fa+4>>2]}else Ga=105}if((Ga|0)==105)BR(v,w);Ga=w+16|0;f[ta>>2]=f[Ga>>2];f[v+20>>2]=f[w+20>>2];f[v+24>>2]=f[w+24>>2];f[v+28>>2]=f[w+28>>2];f[v+32>>2]=f[w+32>>2];ta=f[ba>>2]|0;f[t>>2]=ta;do if(ta|0){t=ta+12|0;Fa=f[t>>2]|0;f[t>>2]=Fa+-1;if((Fa|0)!=1)break;CR(w)}while(0);f[ba>>2]=0;ba=w+4|0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[Ga+8>>2]=0;f[Ga+12>>2]=0;if((f[ba>>2]|0)>0){Ga=f[w+40>>2]|0;ta=0;do{f[Ga+(ta<<2)>>2]=0;ta=ta+1|0}while((ta|0)<(f[ba>>2]|0))}ba=f[w+44>>2]|0;if((ba|0)!=(w+48|0))ZF(ba);ba=x+36|0;ta=f[ba>>2]|0;do if(ta|0){Ga=ta+12|0;Fa=f[Ga>>2]|0;f[Ga>>2]=Fa+-1;if((Fa|0)!=1)break;CR(x)}while(0);f[ba>>2]=0;ba=x+16|0;ta=x+4|0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[ta>>2]|0)>0){ba=f[x+40>>2]|0;Fa=0;do{f[ba+(Fa<<2)>>2]=0;Fa=Fa+1|0}while((Fa|0)<(f[ta>>2]|0))}ta=f[x+44>>2]|0;if((ta|0)!=(x+48|0))ZF(ta)}ta=(f[H>>2]|0)-(f[r>>2]|0)>>2;Fa=w+8|0;f[w>>2]=Fa;ba=w+4|0;f[ba>>2]=ta;if(ta>>>0>264){Ga=OYa(ta>>>0>1073741823?-1:ta<<2)|0;f[w>>2]=Ga;Ia=Ga}else Ia=Fa;Ga=$qa(f[Ea>>2]|0,0)|0;Ea=a+28|0;t=(f[Ga+4>>2]|0)-(f[a+24>>2]|0)|0;g=+(((t|0)>0?t:0)|0)*.03125;t=~~g;Ha=(+(t|0)<g&1)+t|0;if(ta|0){t=Ha+-1|0;P=0;do{b=(f[Ga+(P*20|0)+8>>2]|0)-(f[Ea>>2]|0)|0;R=f[Ga+(P*20|0)+16>>2]|0;xa=(t+((((b|0)>0?b:0)|0)/(R|0)|0)|0)/(Ha|0)|0;b=Y((xa|0)>1?xa:1,R)|0;f[Ia+(P<<2)>>2]=b;P=P+1|0}while((P|0)!=(ta|0))}Yra(x,a,ta,Ha,Ga,Ia,c,d,e,j,v,a+416|0);f[y>>2]=0;f[y+4>>2]=Ha;_U(y,x,-1.0);Zra(x);x=f[w>>2]|0;if((x|0)!=(Fa|0)){if(x|0)QYa(x);f[w>>2]=Fa;f[ba>>2]=264}ba=v+36|0;Fa=f[ba>>2]|0;if(Fa|0?(w=Fa+12|0,Fa=f[w>>2]|0,f[w>>2]=Fa+-1,(Fa|0)==1):0)CR(v);f[ba>>2]=0;ba=v+16|0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[da>>2]|0)>0){ba=f[Q>>2]|0;Q=0;do{f[ba+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[da>>2]|0))}da=f[aa>>2]|0;if((da|0)!=(Ca|0))ZF(da)}da=s+36|0;Ca=f[da>>2]|0;if(Ca|0?(aa=Ca+12|0,Ca=f[aa>>2]|0,f[aa>>2]=Ca+-1,(Ca|0)==1):0)CR(s);f[da>>2]=0;da=s+16|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[Da>>2]|0)>0){da=f[Aa>>2]|0;Aa=0;do{f[da+(Aa<<2)>>2]=0;Aa=Aa+1|0}while((Aa|0)<(f[Da>>2]|0))}Da=f[Ba>>2]|0;if((Da|0)!=(M|0))ZF(Da);Da=f[r>>2]|0;if(Da|0){r=f[H>>2]|0;if((r|0)!=(Da|0))f[H>>2]=r+(~((r+-4-Da|0)>>>2)<<2);PYa(Da)}Da=f[q>>2]|0;if(Da|0){q=f[G>>2]|0;if((q|0)!=(Da|0))f[G>>2]=q+(~((q+-4-Da|0)>>>2)<<2);PYa(Da)}}if(!(f[l+4>>2]|0)){u=k;return}u=k;return}function Tra(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;g=u;u=u+112|0;h=g+16|0;i=g+104|0;j=g+92|0;k=g+8|0;l=g+80|0;m=g+68|0;n=g+56|0;o=g+40|0;q=g+32|0;r=g;s=g+28|0;_$(i,77144);if((b|0)>=1?(t=a+4|0,(f[a>>2]|0)!=(f[t>>2]|0)):0){f[j>>2]=0;v=j+4|0;f[v>>2]=0;f[j+8>>2]=0;p[k>>3]=c;f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];k=Ura(a,j,h)|0;f[h>>2]=0;w=h+4|0;f[w>>2]=0;f[h+8>>2]=0;x=(k|0)==0;do if(!x)if(k>>>0>268435455)gXa(h);else{y=k<<4;z=NYa(y)|0;f[h>>2]=z;f[h+8>>2]=z+(k<<4);F1a(z|0,0,y|0)|0;f[w>>2]=z+y;A=z;break}else A=0;while(0);f[l>>2]=0;z=l+4|0;f[z>>2]=0;f[l+8>>2]=0;if(x)B=0;else{y=k<<2;C=NYa(y)|0;f[l>>2]=C;D=C+(k<<2)|0;f[l+8>>2]=D;F1a(C|0,0,y|0)|0;f[z>>2]=D;B=C}f[m>>2]=0;C=m+4|0;f[C>>2]=0;f[m+8>>2]=0;if(x)E=0;else{D=k<<2;y=NYa(D)|0;f[m>>2]=y;F=y+(k<<2)|0;f[m+8>>2]=F;F1a(y|0,0,D|0)|0;f[C>>2]=F;E=y}f[n>>2]=0;y=n+4|0;f[y>>2]=0;f[n+8>>2]=0;if(x)G=0;else{x=NYa(k<<3)|0;f[y>>2]=x;f[n>>2]=x;F=x+(k<<3)|0;f[n+8>>2]=F;D=x;H=k;while(1){p[D>>3]=2.2250738585072014e-308;H=H+-1|0;if(!H)break;else D=D+8|0}f[y>>2]=F;G=x}x=f[j>>2]|0;F=(f[v>>2]|0)-x|0;D=F>>2;H=(F|0)>0;F=x;if(H){x=f[a>>2]|0;I=0;do{J=f[F+(I<<2)>>2]|0;K=A+(J<<4)|0;f[K>>2]=(f[K>>2]|0)+(f[x+(I<<4)>>2]|0);K=A+(J<<4)+4|0;f[K>>2]=(f[K>>2]|0)+(f[x+(I<<4)+4>>2]|0);K=A+(J<<4)+8|0;f[K>>2]=(f[K>>2]|0)+(f[x+(I<<4)+8>>2]|0);K=A+(J<<4)+12|0;f[K>>2]=(f[K>>2]|0)+(f[x+(I<<4)+12>>2]|0);K=B+(J<<2)|0;f[K>>2]=(f[K>>2]|0)+1;I=I+1|0}while((I|0)<(D|0))}I=(e|0)!=0;x=(d|0)!=0;if(x&I?(K=f[d>>2]|0,(K|0)!=(f[d+4>>2]|0)):0){J=f[e>>2]|0;L=(J|0)==(f[e+4>>2]|0);if(L|H^1){M=G;N=L}else{L=f[n>>2]|0;H=0;do{O=f[F+(H<<2)>>2]|0;P=f[K+(H<<2)>>2]|0;Q=E+(O<<2)|0;R=f[Q>>2]|0;if((P|0)<=(R|0)){if((P|0)==(R|0)?(S=+p[J+(H<<3)>>3],R=L+(O<<3)|0,S>+p[R>>3]):0)p[R>>3]=S}else{f[Q>>2]=P;p[L+(O<<3)>>3]=+p[J+(H<<3)>>3]}H=H+1|0}while((H|0)<(D|0));M=L;N=0}}else{M=G;N=1}G=(k|0)>0;if(G){L=0;do{D=A+(L<<4)|0;H=A+(L<<4)+4|0;J=f[H>>2]|0;K=A+(L<<4)+8|0;F=f[K>>2]|0;O=A+(L<<4)+12|0;P=f[O>>2]|0;S=1.0/+(f[B+(L<<2)>>2]|0);Q=wNa(+(f[D>>2]|0)*S)|0;R=wNa(+(J|0)*S)|0;J=wNa(+(F|0)*S)|0;F=wNa(+(P|0)*S)|0;f[D>>2]=Q;f[H>>2]=R;f[K>>2]=J;f[O>>2]=F;L=L+1|0}while((L|0)!=(k|0))}L=f[a>>2]|0;F=f[t>>2]|0;if((F|0)!=(L|0))f[t>>2]=F+(~((F+-16-L|0)>>>4)<<4);if(x?(L=f[d>>2]|0,F=d+4|0,O=f[F>>2]|0,(O|0)!=(L|0)):0)f[F>>2]=O+(~((O+-4-L|0)>>>2)<<2);if(I?(L=f[e>>2]|0,O=e+4|0,F=f[O>>2]|0,(F|0)!=(L|0)):0)f[O>>2]=F+(~((F+-8-L|0)>>>3)<<3);if(G){G=o+4|0;L=o+8|0;F=o+12|0;O=a+8|0;J=N?q:s;N=d+4|0;K=d+8|0;R=e+4|0;H=e+8|0;Q=f[n>>2]|0;D=f[l>>2]|0;P=f[m>>2]|0;T=A;A=B;B=E;E=0;while(1){U=f[T+(E<<4)>>2]|0;f[o>>2]=U;V=f[T+(E<<4)+4>>2]|0;f[G>>2]=V;W=f[T+(E<<4)+8>>2]|0;f[L>>2]=W;X=f[T+(E<<4)+12>>2]|0;f[F>>2]=X;Y=f[A+(E<<2)>>2]|0;f[q>>2]=Y;p[r>>3]=+p[Q+(E<<3)>>3];f[s>>2]=f[B+(E<<2)>>2];do if((Y|0)>(b|0)){Z=f[h>>2]|0;_=W+U|0;$=X+V|0;aa=(Y|0)>3?Y:3;a:do if((Y|0)<3){ba=0;while(1){do if((ba|0)!=(E|0)?(f[A+(ba<<2)>>2]|0)>(b|0):0){ca=f[Z+(ba<<4)>>2]|0;da=f[Z+(ba<<4)+4>>2]|0;ea=f[Z+(ba<<4)+8>>2]|0;fa=f[Z+(ba<<4)+12>>2]|0;ga=rNa(+(ea|0)*c)|0;ha=rNa(+(fa|0)*c)|0;if((U|0)<(ca-ga|0)|(V|0)<(da-ha|0))break;if((_|0)>(ea+ca+ga|0))break;if(($|0)<=(fa+da+ha|0)){ia=ba;break a}}while(0);ha=ba+1|0;if((ha|0)<(k|0))ba=ha;else{ia=ha;break}}}else{ba=0;while(1){ha=f[A+(ba<<2)>>2]|0;do if((ba|0)!=(E|0)&(ha|0)>(b|0)){da=f[Z+(ba<<4)>>2]|0;fa=f[Z+(ba<<4)+4>>2]|0;ga=f[Z+(ba<<4)+8>>2]|0;ca=f[Z+(ba<<4)+12>>2]|0;ea=rNa(+(ga|0)*c)|0;ja=rNa(+(ca|0)*c)|0;if((U|0)<(da-ea|0)|(V|0)<(fa-ja|0))break;if((_|0)>(ga+da+ea|0))break;if((ha|0)>(aa|0)?($|0)<=(ca+fa+ja|0):0){ia=ba;break a}}while(0);ha=ba+1|0;if((ha|0)<(k|0))ba=ha;else{ia=ha;break}}}while(0);if((ia|0)==(k|0)){$=f[t>>2]|0;if(($|0)==(f[O>>2]|0))Vra(a,o);else{f[$>>2]=U;f[$+4>>2]=V;f[$+8>>2]=W;f[$+12>>2]=X;f[t>>2]=$+16}do if(x){$=f[N>>2]|0;if(($|0)==(f[K>>2]|0)){VU(d,J);break}else{f[$>>2]=f[J>>2];f[N>>2]=$+4;break}}while(0);if(!I)break;$=f[R>>2]|0;if(($|0)==(f[H>>2]|0)){Wra(e,r);break}else{p[$>>3]=+p[r>>3];f[R>>2]=$+8;break}}}while(0);X=E+1|0;if((X|0)>=(k|0))break;T=f[h>>2]|0;A=D;B=P;E=X}ka=f[n>>2]|0}else ka=M;if(ka|0){M=f[y>>2]|0;if((M|0)!=(ka|0))f[y>>2]=M+(~((M+-8-ka|0)>>>3)<<3);PYa(ka)}ka=f[m>>2]|0;if(ka|0){m=f[C>>2]|0;if((m|0)!=(ka|0))f[C>>2]=m+(~((m+-4-ka|0)>>>2)<<2);PYa(ka)}ka=f[l>>2]|0;if(ka|0){l=f[z>>2]|0;if((l|0)!=(ka|0))f[z>>2]=l+(~((l+-4-ka|0)>>>2)<<2);PYa(ka)}ka=f[h>>2]|0;if(ka|0){h=f[w>>2]|0;if((h|0)!=(ka|0))f[w>>2]=h+(~((h+-16-ka|0)>>>4)<<4);PYa(ka)}ka=f[j>>2]|0;if(ka|0){j=f[v>>2]|0;if((j|0)!=(ka|0))f[v>>2]=j+(~((j+-4-ka|0)>>>2)<<2);PYa(ka)}}else la=3;do if((la|0)==3?!((d|0)==0|(e|0)!=0):0){ka=(f[a+4>>2]|0)-(f[a>>2]|0)>>4;j=d+4|0;v=f[j>>2]|0;h=f[d>>2]|0;w=v-h>>2;l=h;h=v;if(ka>>>0<=w>>>0){if(ka>>>0<w>>>0?(v=l+(ka<<2)|0,(h|0)!=(v|0)):0)f[j>>2]=h+(~((h+-4-v|0)>>>2)<<2);if(!ka)break}else GM(d,ka-w|0);w=f[d>>2]|0;v=0;do{f[w+(v<<2)>>2]=1;v=v+1|0}while((v|0)!=(ka|0))}while(0);if(!(f[i+4>>2]|0)){u=g;return}u=g;return}function Ura(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;e=u;u=u+32|0;g=e+8|0;h=e;i=f[a>>2]|0;j=(f[a+4>>2]|0)-i|0;a=j>>4;k=i;i=j>>3;f[g>>2]=0;l=g+4|0;f[l>>2]=0;f[g+8>>2]=0;do if(i)if(i>>>0>1073741823)gXa(g);else{m=j>>1;n=NYa(m)|0;f[g>>2]=n;o=n+(i<<2)|0;f[g+8>>2]=o;F1a(n|0,0,m|0)|0;f[l>>2]=o;q=n;break}else q=0;while(0);i=(j|0)>0;if(i){j=0;do{f[q+(j<<3)>>2]=-1;f[q+(j<<3)+4>>2]=0;j=j+1|0}while((j|0)<(a|0));if(i){j=h+4|0;n=0;do{o=n;while(1){m=f[q+(o<<3)>>2]|0;if((m|0)>-1)o=m;else break}m=k+(n<<4)+8|0;r=k+(n<<4)+12|0;s=k+(n<<4)|0;t=k+(n<<4)+4|0;v=q+(n<<3)|0;w=0;x=o;while(1){if(((((n|0)!=(w|0)?(y=f[k+(w<<4)+8>>2]|0,z=f[m>>2]|0,A=f[k+(w<<4)+12>>2]|0,B=f[r>>2]|0,C=+p[d>>3]*+(((B|0)>(A|0)?A:B)+((z|0)>(y|0)?y:z)|0)*.5,D=f[s>>2]|0,E=f[k+(w<<4)>>2]|0,F=D-E|0,+(((F|0)>-1?F:0-F|0)|0)<=C):0)?(F=f[t>>2]|0,G=f[k+(w<<4)+4>>2]|0,H=F-G|0,+(((H|0)>-1?H:0-H|0)|0)<=C):0)?(H=z-y+D-E|0,+(((H|0)>-1?H:0-H|0)|0)<=C):0)?(H=B-A+F-G|0,+(((H|0)>-1?H:0-H|0)|0)<=C):0){H=w;while(1){I=q+(H<<3)|0;G=f[I>>2]|0;if((G|0)>-1)H=G;else break}if((H|0)!=(x|0)){G=f[q+(x<<3)+4>>2]|0;F=q+(H<<3)+4|0;A=f[F>>2]|0;if((G|0)>(A|0)){f[I>>2]=x;J=x}else{f[q+(x<<3)>>2]=H;f[F>>2]=((G|0)==(A|0)&1)+A;J=H}if((f[q+(J<<3)>>2]|0)>=0){f[h>>2]=0;f[j>>2]=0;A=c$(h,23)|0;G=335873;F=A+23|0;do{b[A>>0]=b[G>>0]|0;A=A+1|0;G=G+1|0}while((A|0)<(F|0));j$(-215,h,335897,335907,490);d$(h)}G=q+(w<<3)|0;A=f[G>>2]|0;if((A|0)>-1){F=A;A=G;do{f[A>>2]=J;A=q+(F<<3)|0;F=f[A>>2]|0}while((F|0)>-1)}F=f[v>>2]|0;if((F|0)>-1){A=F;F=v;do{f[F>>2]=J;F=q+(A<<3)|0;A=f[F>>2]|0}while((A|0)>-1);K=J}else K=J}else K=x}else K=x;w=w+1|0;if((w|0)>=(a|0))break;else x=K}n=n+1|0}while((n|0)<(a|0))}}n=c+4|0;K=f[n>>2]|0;J=f[c>>2]|0;h=K-J>>2;j=J;J=K;if(a>>>0<=h>>>0){if(a>>>0<h>>>0?(K=j+(a<<2)|0,(J|0)!=(K|0)):0)f[n>>2]=J+(~((J+-4-K|0)>>>2)<<2)}else GM(c,a-h|0);if(i){i=f[c>>2]|0;c=0;h=0;while(1){K=c;while(1){J=f[q+(K<<3)>>2]|0;if((J|0)>-1)K=J;else break}J=q+(K<<3)+4|0;n=f[J>>2]|0;if((n|0)>-1){j=~h;f[J>>2]=j;L=j;M=h+1|0}else{L=n;M=h}f[i+(c<<2)>>2]=~L;c=c+1|0;if((c|0)>=(a|0)){N=M;break}else h=M}}else N=0;M=f[g>>2]|0;if(!M){u=e;return N|0}g=f[l>>2]|0;if((g|0)!=(M|0))f[l>>2]=g+(~((g+-4-M|0)>>>2)<<2);PYa(M);u=e;return N|0}function Vra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)gXa(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=De(8)|0;UYa(l,358155);f[l>>2]=130560;Of(l|0,21520,875)}else{n=NYa(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;f[l>>2]=f[b>>2];f[n+(g<<4)+4>>2]=f[b+4>>2];f[n+(g<<4)+8>>2]=f[b+8>>2];f[n+(g<<4)+12>>2]=f[b+12>>2];b=l+16|0;if((j|0)==(i|0))o=l;else{g=j+-16-e|0;n=l;m=j;while(1){j=m;m=m+-16|0;f[n+-16>>2]=f[m>>2];f[n+-12>>2]=f[j+-12>>2];f[n+-8>>2]=f[j+-8>>2];f[n+-4>>2]=f[j+-4>>2];if((m|0)==(i|0))break;else n=n+-16|0}o=l+(~(g>>>4)<<4)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;PYa(e);return}function Wra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)gXa(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;p[k>>3]=+p[b>>3];b=k+(0-g<<3)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;PYa(d);return}function Xra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)gXa(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;PYa(d);return}function Yra(a,b,c,d,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f[a>>2]=77192;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;n=a+48|0;f[n>>2]=1124007936;o=a+52|0;p=a+56|0;q=a+88|0;r=o;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=p;r=a+96|0;s=a+92|0;f[s>>2]=r;f[r>>2]=0;f[a+100>>2]=0;f[a+4>>2]=b;f[a+12>>2]=c;f[a+16>>2]=d;f[a+20>>2]=e;f[a+24>>2]=g;f[a+8>>2]=h;f[a+28>>2]=k?i:0;f[a+32>>2]=k?j:0;if((n|0)==(l|0)){t=a+104|0;f[t>>2]=m;return}j=l+36|0;k=f[j>>2]|0;if(k){i=k+12|0;f[i>>2]=(f[i>>2]|0)+1;i=a+84|0;k=f[i>>2]|0;if((k|0)!=0?(h=k+12|0,k=f[h>>2]|0,f[h>>2]=k+-1,(k|0)==1):0){CR(n);u=i}else u=i}else u=a+84|0;f[u>>2]=0;i=a+64|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[o>>2]|0)>0){k=f[q>>2]|0;q=0;do{f[k+(q<<2)>>2]=0;q=q+1|0;v=f[o>>2]|0}while((q|0)<(v|0));f[n>>2]=f[l>>2];if((v|0)<3)w=12;else w=14}else{f[n>>2]=f[l>>2];w=12}if((w|0)==12){v=f[l+4>>2]|0;if((v|0)<3){f[o>>2]=v;f[p>>2]=f[l+8>>2];f[a+60>>2]=f[l+12>>2];p=f[l+44>>2]|0;v=f[s>>2]|0;f[v>>2]=f[p>>2];f[v+4>>2]=f[p+4>>2]}else w=14}if((w|0)==14)BR(n,l);f[i>>2]=f[l+16>>2];f[a+68>>2]=f[l+20>>2];f[a+72>>2]=f[l+24>>2];f[a+76>>2]=f[l+28>>2];f[a+80>>2]=f[l+32>>2];f[u>>2]=f[j>>2];t=a+104|0;f[t>>2]=m;return}function Zra(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=77192;b=a+48|0;c=a+84|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+64|0;b=a+52|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+88>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+92>>2]|0;if((b|0)!=(a+96|0))ZF(b);b=f[a+36>>2]|0;if(!b)return;d=a+40|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-4-b|0)>>>2)<<2);PYa(b);return}function _ra(a){a=a|0;Zra(a);PYa(a);return}function $ra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0;c=u;u=u+48|0;d=c+40|0;e=c+32|0;g=c;h=c+8|0;i=c+16|0;_$(d,77204);j=a+4|0;k=f[(f[j>>2]|0)+108>>2]|0;Gh[f[(f[k>>2]|0)+12>>2]&511](e,k);p[g>>3]=0.0;k=f[j>>2]|0;l=f[k+24>>2]|0;m=f[k+28>>2]|0;k=a+12|0;o=f[k>>2]|0;if((o|0)>0){q=a+20|0;r=a+24|0;s=b+4|0;t=+(l|0);v=+(m|0);w=h+4|0;x=a+28|0;y=a+104|0;z=a+8|0;A=i+4|0;B=i+8|0;C=i+12|0;D=i+4|0;E=i+8|0;F=i+12|0;G=a+32|0;a=o;o=0;while(1){H=f[q>>2]|0;I=+n[H+(o*20|0)>>2];J=f[H+(o*20|0)+16>>2]|0;K=f[(f[r>>2]|0)+(o<<2)>>2]|0;L=Y(f[b>>2]|0,K)|0;M=(f[H+(o*20|0)+4>>2]|0)-l|0;N=(M|0)>0;O=N?M:0;M=(f[H+(o*20|0)+8>>2]|0)-m|0;H=(M|0)>0?M:0;M=Y(f[s>>2]|0,K)|0;K=(H|0)<(M|0)?H:M;M=wNa(t*I)|0;H=wNa(v*I)|0;if((L|0)<(K|0)){P=L;do{if(N){Q=I*+(P|0);L=0;do{R=f[j>>2]|0;f[h>>2]=L;f[w>>2]=P;S=asa(R,e,h,o,g)|0;if(!(f[x>>2]|0))if((S|0)>0){W$(f[y>>2]|0);R=f[z>>2]|0;T=wNa(I*+(L|0))|0;U=wNa(Q)|0;f[i>>2]=T;f[A>>2]=U;f[B>>2]=M;f[C>>2]=H;V=R+4|0;W=f[V>>2]|0;if((W|0)==(f[R+8>>2]|0))Vra(R,i);else{f[W>>2]=T;f[W+4>>2]=U;f[W+8>>2]=M;f[W+12>>2]=H;f[V>>2]=W+16}X$(f[y>>2]|0);X=S}else X=S;else{W=f[j>>2]|0;if((S|0)==1){V=f[W+36>>2]|0;U=f[W+32>>2]|0;Z=U;_=V;$=(V-U|0)/-12|0}else{Z=f[W+32>>2]|0;_=f[W+36>>2]|0;$=S}S=(_-Z|0)/12|0;if((S|0)==(0-$|0)){W$(f[y>>2]|0);W=f[z>>2]|0;U=wNa(I*+(L|0))|0;V=wNa(Q)|0;f[i>>2]=U;f[D>>2]=V;f[E>>2]=M;f[F>>2]=H;T=W+4|0;R=f[T>>2]|0;if((R|0)==(f[W+8>>2]|0))Vra(W,i);else{f[R>>2]=U;f[R+4>>2]=V;f[R+8>>2]=M;f[R+12>>2]=H;f[T>>2]=R+16}R=f[x>>2]|0;f[i>>2]=S;T=R+4|0;V=f[T>>2]|0;if((V|0)==(f[R+8>>2]|0))VU(R,i);else{f[V>>2]=S;f[T>>2]=V+4}V=f[G>>2]|0;T=V+4|0;S=f[T>>2]|0;if((S|0)==(f[V+8>>2]|0))Wra(V,g);else{p[S>>3]=+p[g>>3];f[T>>2]=S+8}X$(f[y>>2]|0);X=$}else X=$}L=L+J+((X|0)==0?J:0)|0}while((L|0)<(O|0))}P=P+J|0}while((P|0)<(K|0));aa=f[k>>2]|0}else aa=a;o=o+1|0;if((o|0)>=(aa|0))break;else a=aa}}aa=f[e>>2]|0;if(aa|0?(e=aa+4|0,a=f[e>>2]|0,f[e>>2]=a+-1,(a|0)==1):0)ki[f[(f[aa>>2]|0)+8>>2]&2047](aa);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function asa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+16|0;h=g+8|0;i=g;_$(h,77224);j=f[b+4>>2]|0;k=f[(f[j>>2]|0)+24>>2]|0;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];do if(ui[k&127](j,i,d)|0){c=f[a+8>>2]|0;l=(c|0)==0;if((f[a+20>>2]|0)==1){if(l){m=bsa(a,b,e)|0;break}if((c|0)!=1){m=-2;break}m=csa(a,b,e)|0;break}else{if(l){m=dsa(a,b,e)|0;break}if((c|0)!=1){m=-2;break}m=esa(a,b,e)|0;break}}else m=-1;while(0);if(!(f[h+4>>2]|0)){u=g;return m|0}u=g;return m|0}function bsa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0,x=0;e=u;u=u+16|0;g=e+8|0;h=e;_$(g,77304);i=a+92|0;j=f[i>>2]|0;if((j|0)==(f[a+96>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;k=c$(h,28)|0;l=336421;m=k+28|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,h,336601,335013,580);d$(h);o=f[i>>2]|0}else o=j;j=f[c+4>>2]|0;c=f[a+32>>2]|0;i=(f[a+36>>2]|0)-c|0;a=(i|0)/12|0;a:do if((i|0)>0){h=o;l=0;while(1){k=f[c+(l*12|0)+4>>2]|0;if((k|0)>0){m=0;q=0.0;while(1){r=+_qa(j,f[h+(m<<4)>>2]|0);s=q+ +n[(r<+n[h+(m<<4)+4>>2]?h+(m<<4)+8|0:h+(m<<4)+12|0)>>2];m=m+1|0;if((m|0)>=(k|0)){t=s;break}else q=s}}else t=0.0;if(t<+n[c+(l*12|0)+8>>2])break;m=l+1|0;if((m|0)<(a|0)){h=h+(k<<4)|0;l=m}else{v=t;w=9;break a}}p[d>>3]=t;x=0-l|0}else{v=0.0;w=9}while(0);if((w|0)==9){p[d>>3]=v;x=1}if(!(f[g+4>>2]|0)){u=e;return x|0}u=e;return x|0}function csa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0,S=0;e=u;u=u+16|0;g=e+8|0;h=e;_$(g,77284);i=a+92|0;if((f[i>>2]|0)==(f[a+96>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,28)|0;k=336421;l=j+28|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,h,336450,335013,619);d$(h)}h=f[a+32>>2]|0;k=(f[a+36>>2]|0)-h|0;j=(k|0)/12|0;l=f[c+4>>2]|0;c=((f[a+12>>2]|0)+31|0)/32|0;m=h;a:do if((k|0)>0){h=l+380|0;o=l+384|0;q=f[i>>2]|0;r=f[a+80>>2]|0;s=0;while(1){t=f[m+(s*12|0)+4>>2]|0;if((t|0)>0){v=f[h>>2]|0;w=f[o>>2]|0;x=0.0;y=0;while(1){z=f[q+(y<<4)>>2]|0;A=f[w+(f[v+(z<<6)+20>>2]<<2)>>2]|0;B=f[w+(f[v+(z<<6)+24>>2]<<2)>>2]|0;C=f[w+(f[v+(z<<6)+36>>2]<<2)>>2]|0;D=f[w+(f[v+(z<<6)+40>>2]<<2)>>2]|0;E=A-B-C+D|0;F=f[w+(f[v+(z<<6)+4>>2]<<2)>>2]|0;G=f[w+(f[v+(z<<6)+16>>2]<<2)>>2]|0;H=f[w+(f[v+(z<<6)+8>>2]<<2)>>2]|0;I=f[w+(f[v+(z<<6)+28>>2]<<2)>>2]|0;J=f[w+(f[v+(z<<6)+44>>2]<<2)>>2]|0;K=f[w+(f[v+(z<<6)+56>>2]<<2)>>2]|0;L=f[w+(f[v+(z<<6)+52>>2]<<2)>>2]|0;M=f[w+(f[v+(z<<6)+32>>2]<<2)>>2]|0;N=r+((Y(y,c)|0)<<2)+((((B-A+F-H|0)>=(E|0)?2:0)|(((f[w+(f[v+(z<<6)>>2]<<2)>>2]|0)+A-F-G|0)>=(E|0)?4:0)|(H-B-(f[w+(f[v+(z<<6)+12>>2]<<2)>>2]|0)+I|0)>=(E|0))<<2)|0;O=x+ +n[(1<<(((D-J-K+(f[w+(f[v+(z<<6)+60>>2]<<2)>>2]|0)|0)>=(E|0)?8:0)|((B-D-I+J|0)>=(E|0)?16:0)|((C-D+K-L|0)>=(E|0)?4:0)|(C-A+G-M|0)>=(E|0)|((L-C+M-(f[w+(f[v+(z<<6)+48>>2]<<2)>>2]|0)|0)>=(E|0)?2:0))&f[N>>2]|0?q+(y<<4)+8|0:q+(y<<4)+12|0)>>2];y=y+1|0;if((y|0)==(t|0)){P=O;break}else x=O}}else P=0.0;if(P<+n[m+(s*12|0)+8>>2])break;r=r+((Y(t,c)|0)<<2)|0;y=s+1|0;if((y|0)>=(j|0)){Q=P;R=11;break a}else{q=q+(t<<4)|0;s=y}}p[d>>3]=P;S=0-s|0}else{Q=0.0;R=11}while(0);if((R|0)==11){p[d>>3]=Q;S=1}if(!(f[g+4>>2]|0)){u=e;return S|0}u=e;return S|0}function dsa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0;d=u;u=u+16|0;e=d;_$(e,77264);g=f[a+32>>2]|0;h=(f[a+36>>2]|0)-g|0;i=(h|0)/12|0;j=f[b+4>>2]|0;b=f[a+68>>2]|0;k=f[a+56>>2]|0;l=f[a+44>>2]|0;a=g;a:do if((h|0)>0){g=0;m=0;o=0;while(1){q=f[a+(o*12|0)+4>>2]|0;p[c>>3]=0.0;if((q|0)>0){r=a+(o*12|0)|0;s=g;t=m;v=0;while(1){w=(f[r>>2]|0)+v|0;x=0;do{y=x+t|0;z=+_qa(j,f[k+(y<<4)>>2]|0);x=f[(z<+n[k+(y<<4)+4>>2]?k+(y<<4)+8|0:k+(y<<4)+12|0)>>2]|0}while((x|0)>0);z=+p[c>>3]+ +n[b+(s-x<<2)>>2];p[c>>3]=z;y=f[l+(w<<2)>>2]|0;A=y+t|0;B=s+1+y|0;v=v+1|0;if((v|0)>=(q|0)){C=z;D=B;E=A;break}else{s=B;t=A}}}else{C=0.0;D=g;E=m}if(C<+n[a+(o*12|0)+8>>2]){F=0-o|0;break a}o=o+1|0;if((o|0)>=(i|0)){F=1;break}else{g=D;m=E}}}else F=1;while(0);if(!(f[e+4>>2]|0)){u=d;return F|0}u=d;return F|0}function esa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0.0,U=0,V=0,W=0,X=0;d=u;u=u+16|0;e=d;_$(e,77244);g=f[a+32>>2]|0;h=(f[a+36>>2]|0)-g|0;i=(h|0)/12|0;j=f[b+4>>2]|0;b=((f[a+12>>2]|0)+31|0)/32|0;k=f[a+80>>2]|0;l=f[a+68>>2]|0;m=f[a+56>>2]|0;o=f[a+44>>2]|0;a=g;if((h|0)>0){h=j+380|0;g=j+384|0;j=0;q=0;r=0;while(1){s=f[a+(r*12|0)+4>>2]|0;if((s|0)>0){t=f[a+(r*12|0)>>2]|0;v=f[h>>2]|0;w=f[g>>2]|0;x=0.0;y=j;z=q;A=0;while(1){B=0;do{C=B+z|0;D=f[m+(C<<4)>>2]|0;E=f[w+(f[v+(D<<6)+20>>2]<<2)>>2]|0;F=f[w+(f[v+(D<<6)+24>>2]<<2)>>2]|0;G=f[w+(f[v+(D<<6)+36>>2]<<2)>>2]|0;H=f[w+(f[v+(D<<6)+40>>2]<<2)>>2]|0;I=E-F-G+H|0;J=f[w+(f[v+(D<<6)+4>>2]<<2)>>2]|0;K=f[w+(f[v+(D<<6)+16>>2]<<2)>>2]|0;L=f[w+(f[v+(D<<6)+8>>2]<<2)>>2]|0;M=f[w+(f[v+(D<<6)+28>>2]<<2)>>2]|0;N=f[w+(f[v+(D<<6)+44>>2]<<2)>>2]|0;O=f[w+(f[v+(D<<6)+56>>2]<<2)>>2]|0;P=f[w+(f[v+(D<<6)+52>>2]<<2)>>2]|0;Q=f[w+(f[v+(D<<6)+32>>2]<<2)>>2]|0;R=k+((Y(C,b)|0)<<2)+((((F-E+J-L|0)>=(I|0)?2:0)|(((f[w+(f[v+(D<<6)>>2]<<2)>>2]|0)+E-J-K|0)>=(I|0)?4:0)|(L-F-(f[w+(f[v+(D<<6)+12>>2]<<2)>>2]|0)+M|0)>=(I|0))<<2)|0;B=f[(1<<(((H-N-O+(f[w+(f[v+(D<<6)+60>>2]<<2)>>2]|0)|0)>=(I|0)?8:0)|((F-H-M+N|0)>=(I|0)?16:0)|((G-H+O-P|0)>=(I|0)?4:0)|(G-E+K-Q|0)>=(I|0)|((P-G+Q-(f[w+(f[v+(D<<6)+48>>2]<<2)>>2]|0)|0)>=(I|0)?2:0))&f[R>>2]|0?m+(C<<4)+8|0:m+(C<<4)+12|0)>>2]|0}while((B|0)>0);S=x+ +n[l+(y-B<<2)>>2];C=f[o+(t+A<<2)>>2]|0;R=C+z|0;I=y+1+C|0;A=A+1|0;if((A|0)==(s|0)){T=S;U=I;V=R;break}else{x=S;y=I;z=R}}}else{T=0.0;U=j;V=q}if(T<+n[a+(r*12|0)+8>>2]){W=0-r|0;break}r=r+1|0;if((r|0)>=(i|0)){W=1;break}else{j=U;q=V}}p[c>>3]=T;X=W}else X=1;if(!(f[e+4>>2]|0)){u=d;return X|0}u=d;return X|0}function fsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/20|0)>>>0>=b>>>0){h=g;i=b;do{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;h=(f[e>>2]|0)+20|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=(g-i|0)/20|0;g=h+b|0;if(g>>>0>214748364)gXa(a);j=(d-i|0)/20|0;i=j<<1;d=j>>>0<107374182?(i>>>0<g>>>0?g:i):214748364;do if(d)if(d>>>0>214748364){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{k=NYa(d*20|0)|0;break}else k=0;while(0);i=k+(h*20|0)|0;h=k+(d*20|0)|0;d=i;k=b;b=i;do{f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;d=b+20|0;b=d;k=k+-1|0}while((k|0)!=0);k=f[a>>2]|0;d=(f[e>>2]|0)-k|0;g=i+(((d|0)/-20|0)*20|0)|0;if((d|0)>0)K1a(g|0,k|0,d|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=h;if(!k)return;PYa(k);return}function gsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>4>>>0>=b>>>0){h=g;i=b;do{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;h=(f[e>>2]|0)+16|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=g-i>>4;g=h+b|0;if(g>>>0>268435455)gXa(a);j=d-i|0;i=j>>3;d=j>>4>>>0<134217727?(i>>>0<g>>>0?g:i):268435455;do if(d)if(d>>>0>268435455){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{k=NYa(d<<4)|0;break}else k=0;while(0);i=k+(h<<4)|0;h=i;g=k+(d<<4)|0;d=i;k=b;b=h;do{f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;d=b+16|0;b=d;k=k+-1|0}while((k|0)!=0);k=g;g=f[a>>2]|0;d=f[e>>2]|0;j=g;if((d|0)==(g|0)){l=h;m=j}else{h=d+-16-j|0;j=i;n=d;while(1){d=n;n=n+-16|0;f[j+-16>>2]=f[n>>2];f[j+-12>>2]=f[d+-12>>2];f[j+-8>>2]=f[d+-8>>2];f[j+-4>>2]=f[d+-4>>2];if((n|0)==(g|0))break;else j=j+-16|0}l=i+(~(h>>>4)<<4)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=b;f[c>>2]=k;if(!m)return;PYa(m);return}function hsa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=(g|0)/12|0;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=((j-k|0)/12|0)>>>0){m=a+4|0;n=((f[m>>2]|0)-k|0)/12|0;o=h>>>0>n>>>0;p=o?b+(n*12|0)|0:c;c=p;n=c-e|0;if(n|0)M1a(k|0,b|0,n|0)|0;e=l+(((n|0)/12|0)*12|0)|0;if(o){o=d-c|0;if((o|0)<=0)return;K1a(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(((o>>>0)/12|0)*12|0);return}else{o=f[m>>2]|0;if((o|0)==(e|0))return;f[m>>2]=o+(~(((o+-12-e|0)>>>0)/12|0)*12|0);return}}e=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~(((o+-12-k|0)>>>0)/12|0)*12|0);PYa(e);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>357913941)gXa(a);j=(q|0)/12|0;q=j<<1;e=j>>>0<178956970?(q>>>0<h>>>0?h:q):357913941;if(e>>>0>357913941)gXa(a);q=NYa(e*12|0)|0;h=a+4|0;f[h>>2]=q;f[a>>2]=q;f[i>>2]=q+(e*12|0);if((g|0)<=0)return;K1a(q|0,b|0,g|0)|0;f[h>>2]=q+(((g>>>0)/12|0)*12|0);return}function isa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>2;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>2>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>2;o=h>>>0>n>>>0;p=o?b+(n<<2)|0:c;c=p;n=c-e|0;e=n>>2;if(e|0)M1a(k|0,b|0,n|0)|0;n=l+(e<<2)|0;if(o){o=d-c|0;if((o|0)<=0)return;K1a(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>2<<2);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-4-n|0)>>>2)<<2);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-4-k|0)>>>2)<<2);PYa(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>1073741823)gXa(a);j=q>>1;n=q>>2>>>0<536870911?(j>>>0<h>>>0?h:j):1073741823;if(n>>>0>1073741823)gXa(a);j=NYa(n<<2)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<2);if((g|0)<=0)return;K1a(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>2<<2);return}function jsa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>4;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>4>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>4;o=h>>>0>n>>>0;p=o?b+(n<<4)|0:c;c=p;n=c-e|0;e=n>>4;if(e|0)M1a(k|0,b|0,n|0)|0;n=l+(e<<4)|0;if(o){o=d-c|0;if((o|0)<=0)return;K1a(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>4<<4);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-16-n|0)>>>4)<<4);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-16-k|0)>>>4)<<4);PYa(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>268435455)gXa(a);j=q>>3;n=q>>4>>>0<134217727?(j>>>0<h>>>0?h:j):268435455;if(n>>>0>268435455)gXa(a);j=NYa(n<<4)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<4);if((g|0)<=0)return;K1a(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>4<<4);return}function ksa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>2;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>2>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>2;o=h>>>0>n>>>0;p=o?b+(n<<2)|0:c;c=p;n=c-e|0;e=n>>2;if(e|0)M1a(k|0,b|0,n|0)|0;n=l+(e<<2)|0;if(o){o=d-c|0;if((o|0)<=0)return;K1a(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>2<<2);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-4-n|0)>>>2)<<2);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-4-k|0)>>>2)<<2);PYa(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>1073741823)gXa(a);j=q>>1;n=q>>2>>>0<536870911?(j>>>0<h>>>0?h:j):1073741823;if(n>>>0>1073741823)gXa(a);j=NYa(n<<2)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<2);if((g|0)<=0)return;K1a(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>2<<2);return}function lsa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>4;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>4>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>4;o=h>>>0>n>>>0;p=o?b+(n<<4)|0:c;c=p;n=c-e|0;e=n>>4;if(e|0)M1a(k|0,b|0,n|0)|0;n=l+(e<<4)|0;if(o){o=d-c|0;if((o|0)<=0)return;K1a(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>4<<4);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-16-n|0)>>>4)<<4);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-16-k|0)>>>4)<<4);PYa(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>268435455)gXa(a);j=q>>3;n=q>>4>>>0<134217727?(j>>>0<h>>>0?h:j):268435455;if(n>>>0>268435455)gXa(a);j=NYa(n<<4)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<4);if((g|0)<=0)return;K1a(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>4<<4);return}function msa(a){a=a|0;var b=0,c=0,d=0;b=f[a+88>>2]|0;if(b|0){c=a+92|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-16-b|0)>>>4)<<4);PYa(b)}b=f[a+76>>2]|0;if(b|0){d=a+80|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+64>>2]|0;if(b|0){c=a+68|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+52>>2]|0;if(b|0){d=a+56|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-16-b|0)>>>4)<<4);PYa(b)}b=f[a+40>>2]|0;if(b|0){c=a+44|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+28>>2]|0;if(!b)return;d=a+32|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~(((a+-12-b|0)>>>0)/12|0)*12|0);PYa(b);return}function nsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c+8|0;e=c;g=a+224|0;h=a+248|0;i=f[h>>2]|0;if(i|0?(j=i+8|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)k0(g);g=a+228|0;if((f[g>>2]|0)>0){i=f[a+256>>2]|0;j=0;do{f[i+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[g>>2]|0))}f[h>>2]=0;h=a+272|0;g=a+296|0;j=f[g>>2]|0;if(j|0?(i=j+8|0,j=f[i>>2]|0,f[i>>2]=j+-1,(j|0)==1):0)k0(h);h=a+276|0;if((f[h>>2]|0)>0){j=f[a+304>>2]|0;i=0;do{f[j+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[h>>2]|0))}f[g>>2]=0;g=a+320|0;h=a+344|0;i=f[h>>2]|0;if(i|0?(j=i+8|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)k0(g);g=a+324|0;if((f[g>>2]|0)>0){i=f[a+352>>2]|0;j=0;do{f[i+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[g>>2]|0))}f[h>>2]=0;if(!(qsa(a+4|0,b)|0)){k=0;u=c;return k|0}rsa(d,f[a+8>>2]|0);h=a+104|0;g=f[d>>2]|0;j=f[d+4>>2]|0;if(g|0){i=g+4|0;f[i>>2]=(f[i>>2]|0)+1}i=f[h>>2]|0;f[h>>2]=g;g=a+108|0;f[g>>2]=j;if(i|0?(j=i+4|0,h=f[j>>2]|0,f[j>>2]=h+-1,(h|0)==1):0)ki[f[(f[i>>2]|0)+8>>2]&2047](i);i=f[d>>2]|0;if(i|0?(h=i+4|0,j=f[h>>2]|0,f[h>>2]=j+-1,(j|0)==1):0)ki[f[(f[i>>2]|0)+8>>2]&2047](i);$X(d,b,337837);if(!(f[d+4>>2]|0))l=0;else{b=f[g>>2]|0;g=f[(f[b>>2]|0)+8>>2]|0;f[e>>2]=f[a+24>>2];f[e+4>>2]=f[a+28>>2];l=ui[g&127](b,d,e)|0}k=l;u=c;return k|0}function osa(a){a=a|0;PYa(a);return}function psa(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[c>>2]=f[a+8>>2];$sa(c);if(!a){u=b;return}ki[f[(f[a>>2]|0)+4>>2]&2047](a);u=b;return}function qsa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0;d=u;u=u+512|0;e=d+16|0;g=d+480|0;h=d+464|0;i=d+504|0;j=d+496|0;k=d+8|0;l=d+488|0;m=d+420|0;o=d+376|0;p=d;q=d+352|0;r=d+472|0;s=d+292|0;t=d+248|0;v=d+232|0;w=d+216|0;x=d+200|0;y=d+196|0;z=d+152|0;A=d+108|0;B=d+64|0;C=d+368|0;D=d+344|0;E=d+336|0;F=d+60|0;G=d+240|0;H=d+224|0;I=d+208|0;$X(e,c,337846);f[g>>2]=0;f[g+4>>2]=0;rY(e,g,g);J=f[g>>2]|0;if((J|0)!=337856?KKa((J|0)==0?5694105:J,337856)|0:0){K=0;d$(g);u=d;return K|0}f[a>>2]=0;$X(e,c,337862);f[h>>2]=0;f[h+4>>2]=0;rY(e,h,h);J=f[h>>2]|0;do if((J|0)!=337874?(L=(J|0)==0?5694105:J,(KKa(L,337874)|0)!=0):0){if((J|0)!=337879?KKa(L,337879)|0:0){if((J|0)!=337883?KKa(L,337883)|0:0){M=0;break}f[a+4>>2]=2;f[e>>2]=0;f[e+4>>2]=0;N=c$(e,35)|0;O=337887;P=N+35|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));j$(-213,e,345363,334674,1472);d$(e);Q=12;break}f[a+4>>2]=1;Q=12}else Q=5;while(0);if((Q|0)==5){f[a+4>>2]=0;Q=12}if((Q|0)==12){$X(i,c,337923);oY(i,e,0);i=a+20|0;f[i>>2]=f[e>>2];$X(j,c,337929);oY(j,e,0);j=f[e>>2]|0;f[a+24>>2]=j;if(!((j|0)>0?(f[i>>2]|0)>0:0)){f[e>>2]=0;f[e+4>>2]=0;N=c$(e,47)|0;O=337936;P=N+47|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));j$(-215,e,345363,334674,1479);d$(e)}$X(k,c,337984);i=k+4|0;if((f[i>>2]|0)!=0?($X(l,k,337998),oY(l,e,0),l=f[e>>2]|0,f[a+8>>2]=l,j=(l+31|0)/32|0,J=(l|0)>0,l=J?j+3|0:4,$X(e,c,338902),c=e,L=f[c>>2]|0,R=f[c+4>>2]|0,c=k,f[c>>2]=L,f[c+4>>2]=R,!(R>>>0<1|(R|0)==1&L>>>0<0)):0){L=a+28|0;ssa(L,bY(k)|0);R=a+40|0;c=f[R>>2]|0;S=a+44|0;T=f[S>>2]|0;if((T|0)!=(c|0))f[S>>2]=T+(~((T+-4-c|0)>>>2)<<2);c=a+52|0;T=f[c>>2]|0;U=a+56|0;V=f[U>>2]|0;if((V|0)!=(T|0))f[U>>2]=V+(~((V+-16-T|0)>>>4)<<4);T=a+88|0;V=f[T>>2]|0;W=a+92|0;X=f[W>>2]|0;if((X|0)!=(V|0))f[W>>2]=X+(~((X+-16-V|0)>>>4)<<4);aY(m,f[k>>2]|0,f[i>>2]|0,0);V=f[k>>2]|0;X=f[i>>2]|0;aY(o,V,X,bY(k)|0);k=a+12|0;f[k>>2]=2147483647;X=a+16|0;f[X>>2]=0;V=m+4|0;i=o+4|0;Z=m+20|0;_=o+20|0;$=m+40|0;aa=o+40|0;ba=p+4|0;ca=q+8|0;da=q+4|0;ea=a+32|0;fa=a+36|0;ga=s+4|0;ha=t+4|0;ia=s+20|0;ja=t+20|0;ka=s+40|0;la=t+40|0;ma=v+4|0;na=w+4|0;oa=x+4|0;pa=a+48|0;qa=a+64|0;ra=a+68|0;sa=a+76|0;ta=a+80|0;ua=z+4|0;va=A+4|0;wa=z+20|0;xa=A+20|0;ya=z+40|0;za=A+40|0;Aa=C+4|0;Ba=B+8|0;Ca=D+4|0;Da=B+12|0;Ea=E+4|0;Fa=a+60|0;Ga=H+4|0;Ha=B+4|0;Ia=G+4|0;Ja=a+84|0;Ka=I+4|0;La=a+72|0;Ma=0;a:while(1){Na=f[m>>2]|0;Oa=Na;if((((Na|0)==(f[o>>2]|0)?(f[V>>2]|0)==(f[i>>2]|0):0)?(f[Z>>2]|0)==(f[_>>2]|0):0)?(f[$>>2]|0)==(f[aa>>2]|0):0){Q=73;break}Na=f[Z>>2]|0;f[p>>2]=Oa;f[ba>>2]=Na;$X(r,p,338010);pY(r,e,0.0);n[ca>>2]=+n[e>>2]+-9.999999747378752e-06;$X(e,p,338025);Na=e;Oa=f[Na>>2]|0;Pa=f[Na+4>>2]|0;Na=p;f[Na>>2]=Oa;f[Na+4>>2]=Pa;if(Pa>>>0<1|(Pa|0)==1&Oa>>>0<0){Q=29;break}Oa=bY(p)|0;f[da>>2]=Oa;f[q>>2]=(f[S>>2]|0)-(f[R>>2]|0)>>2;Oa=f[ea>>2]|0;if((Oa|0)==(f[fa>>2]|0))tsa(L,q);else{f[Oa>>2]=f[q>>2];f[Oa+4>>2]=f[q+4>>2];f[Oa+8>>2]=f[q+8>>2];f[ea>>2]=(f[ea>>2]|0)+12}Oa=f[L>>2]|0;usa(R,(f[Oa+(Ma*12|0)+4>>2]|0)+(f[Oa+(Ma*12|0)>>2]|0)|0);aY(s,f[p>>2]|0,f[ba>>2]|0,0);Oa=f[p>>2]|0;Pa=f[ba>>2]|0;aY(t,Oa,Pa,bY(p)|0);while(1){Pa=f[s>>2]|0;Oa=Pa;if((((Pa|0)==(f[t>>2]|0)?(f[ga>>2]|0)==(f[ha>>2]|0):0)?(f[ia>>2]|0)==(f[ja>>2]|0):0)?(f[ka>>2]|0)==(f[la>>2]|0):0)break;Pa=f[ia>>2]|0;f[v>>2]=Oa;f[ma>>2]=Pa;$X(w,v,338041);$X(x,v,338055);if((f[na>>2]|0)==0|(f[oa>>2]|0)==0){Q=71;break a}Pa=(bY(w)|0)/(l|0)|0;f[y>>2]=Pa;Oa=f[k>>2]|0;f[k>>2]=(Pa|0)<(Oa|0)?Pa:Oa;Oa=f[X>>2]|0;f[X>>2]=(Oa|0)<(Pa|0)?Pa:Oa;Oa=f[S>>2]|0;if((Oa|0)==(f[pa>>2]|0))vsa(R,y);else{f[Oa>>2]=Pa;f[S>>2]=Oa+4}wsa(c,((f[U>>2]|0)-(f[c>>2]|0)>>4)+(f[y>>2]|0)|0);Oa=f[ra>>2]|0;Pa=f[qa>>2]|0;xsa(qa,(Oa-Pa>>2)+(bY(x)|0)|0);if(J)ysa(sa,((f[ta>>2]|0)-(f[sa>>2]|0)>>2)+(Y(f[y>>2]|0,j)|0)|0);aY(z,f[w>>2]|0,f[na>>2]|0,0);Pa=f[w>>2]|0;Oa=f[na>>2]|0;aY(A,Pa,Oa,bY(w)|0);b:while(1){Oa=f[z>>2]|0;Pa=Oa;do if((Oa|0)==(f[A>>2]|0)){if((f[ua>>2]|0)!=(f[va>>2]|0))break;if((f[wa>>2]|0)!=(f[xa>>2]|0))break;if((f[ya>>2]|0)==(f[za>>2]|0))break b}while(0);Oa=f[wa>>2]|0;f[C>>2]=Pa;f[Aa>>2]=Oa;oY(C,e,0);f[Ba>>2]=f[e>>2];cY(z)|0;Oa=f[wa>>2]|0;f[D>>2]=f[z>>2];f[Ca>>2]=Oa;oY(D,e,0);f[Da>>2]=f[e>>2];cY(z)|0;Oa=f[wa>>2]|0;f[E>>2]=f[z>>2];f[Ea>>2]=Oa;oY(E,e,0);f[B>>2]=f[e>>2];cY(z)|0;if(J){Oa=0;while(1){if((Oa|0)>=(j|0))break;Na=f[wa>>2]|0;f[G>>2]=f[z>>2];f[Ia>>2]=Na;oY(G,e,0);Na=f[e>>2]|0;f[F>>2]=Na;Qa=f[ta>>2]|0;if((Qa|0)==(f[Ja>>2]|0))VU(sa,F);else{f[Qa>>2]=Na;f[ta>>2]=Qa+4}cY(z)|0;Oa=Oa+1|0}n[Ha>>2]=0.0}else{Oa=f[wa>>2]|0;f[H>>2]=f[z>>2];f[Ga>>2]=Oa;pY(H,e,0.0);f[Ha>>2]=f[e>>2];cY(z)|0}Oa=f[U>>2]|0;if((Oa|0)==(f[Fa>>2]|0))zsa(c,B);else{f[Oa>>2]=f[B>>2];f[Oa+4>>2]=f[B+4>>2];f[Oa+8>>2]=f[B+8>>2];f[Oa+12>>2]=f[B+12>>2];f[U>>2]=(f[U>>2]|0)+16}}aY(e,f[x>>2]|0,f[oa>>2]|0,0);N=z;O=e;P=N+44|0;do{f[N>>2]=f[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(P|0));Oa=f[x>>2]|0;Pa=f[oa>>2]|0;aY(B,Oa,Pa,bY(x)|0);N=A;O=B;P=N+44|0;do{f[N>>2]=f[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(P|0));c:while(1){Pa=f[z>>2]|0;Oa=Pa;do if((Pa|0)==(f[A>>2]|0)){if((f[ua>>2]|0)!=(f[va>>2]|0))break;if((f[wa>>2]|0)!=(f[xa>>2]|0))break;if((f[ya>>2]|0)==(f[za>>2]|0))break c}while(0);Pa=f[wa>>2]|0;f[I>>2]=Oa;f[Ka>>2]=Pa;pY(I,e,0.0);Pa=f[e>>2]|0;f[B>>2]=Pa;Qa=f[ra>>2]|0;if((Qa|0)==(f[La>>2]|0))Xra(qa,B);else{f[Qa>>2]=Pa;f[ra>>2]=Qa+4}cY(z)|0}cY(s)|0}cY(m)|0;Ma=Ma+1|0}d:do if((Q|0)==29)Ra=0;else if((Q|0)==71)Ra=0;else if((Q|0)==73)if((f[X>>2]|0)==1?(Ma=f[L>>2]|0,m=(f[ea>>2]|0)-Ma|0,s=(m|0)/12|0,(m|0)!=0):0){m=a+64|0;z=e+4|0;ra=e+8|0;B=e+12|0;qa=a+96|0;La=Ma;Ma=0;I=0;Ka=0;while(1){wa=f[La+(Ka*12|0)+4>>2]|0;if((wa|0)>0){za=0;ya=Ma;xa=I;while(1){va=f[c>>2]|0;ua=f[va+(xa<<4)+4>>2]|0;A=f[m>>2]|0;O=f[A+(ya<<2)>>2]|0;N=f[A+(ya+1<<2)>>2]|0;f[e>>2]=f[va+(xa<<4)>>2];f[z>>2]=ua;f[ra>>2]=O;f[B>>2]=N;N=f[W>>2]|0;if((N|0)==(f[qa>>2]|0))Asa(T,e);else{f[N>>2]=f[e>>2];f[N+4>>2]=f[e+4>>2];f[N+8>>2]=f[e+8>>2];f[N+12>>2]=f[e+12>>2];f[W>>2]=(f[W>>2]|0)+16}za=za+1|0;N=xa+1|0;O=ya+2|0;if((za|0)>=(wa|0)){Sa=O;Ta=N;break}else{ya=O;xa=N}}}else{Sa=Ma;Ta=I}xa=Ka+1|0;if(xa>>>0>=s>>>0){Ra=1;break d}La=f[L>>2]|0;Ma=Sa;I=Ta;Ka=xa}}else Ra=1;while(0);Ua=Ra}else Ua=0;M=Ua}d$(h);K=M;d$(g);u=d;return K|0}function rsa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;switch(c|0){case 0:{c=NYa(436)|0;d=c+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[c+44>>2]=1124007936;d=c+52|0;e=c+84|0;g=c+48|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=c+92|0;f[c+88>>2]=d;f[d>>2]=0;f[c+96>>2]=0;f[c+100>>2]=1124007936;d=c+108|0;e=c+140|0;g=c+104|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=c+148|0;f[c+144>>2]=d;f[d>>2]=0;f[c+152>>2]=0;f[c+156>>2]=1124007936;d=c+160|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[c+188>>2]=c+164;d=c+196|0;f[c+192>>2]=d;f[c+200>>2]=0;f[d>>2]=0;f[c+204>>2]=1124007936;d=c+208|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[c+236>>2]=c+212;d=c+244|0;f[c+240>>2]=d;f[c+248>>2]=0;f[d>>2]=0;f[c+252>>2]=1124007936;d=c+256|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[c+284>>2]=c+260;d=c+292|0;f[c+288>>2]=d;f[c+296>>2]=0;f[d>>2]=0;f[c+300>>2]=1124007936;d=c+304|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[c+332>>2]=c+308;d=c+340|0;f[c+336>>2]=d;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[c>>2]=76732;d=c+356|0;e=c+24|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;g=c+392|0;h=g+40|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=4;f[c+28>>2]=2;f[c+32>>2]=0;f[c+36>>2]=0;f[c+40>>2]=0;f[c+384>>2]=0;f[c+388>>2]=0;n[c+432>>2]=0.0;b[c+380>>0]=0;e=NYa(16)|0;f[e+4>>2]=1;f[e>>2]=76832;f[e+8>>2]=c;f[a>>2]=e;f[a+4>>2]=c;return}case 1:{c=NYa(388)|0;ura(c);e=NYa(16)|0;f[e+4>>2]=1;f[e>>2]=76952;f[e+8>>2]=c;f[a>>2]=e;f[a+4>>2]=c;return}default:{f[a>>2]=0;f[a+4>>2]=0;return}}}function ssa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+8|0;d=f[a>>2]|0;if((((f[c>>2]|0)-d|0)/12|0)>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>357913941){g=De(8)|0;UYa(g,358155);f[g>>2]=130560;Of(g|0,21520,875)}g=(f[e>>2]|0)-d|0;h=NYa(b*12|0)|0;i=h+(((g|0)/12|0)*12|0)|0;j=i+(((g|0)/-12|0)*12|0)|0;if((g|0)>0)K1a(j|0,d|0,g|0)|0;f[a>>2]=j;f[e>>2]=i;f[c>>2]=h+(b*12|0);if(!d)return;PYa(d);return}function tsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=(e|0)/12|0;h=g+1|0;if(h>>>0>357913941)gXa(a);i=a+8|0;j=((f[i>>2]|0)-d|0)/12|0;k=j<<1;l=j>>>0<178956970?(k>>>0<h>>>0?h:k):357913941;do if(l)if(l>>>0>357913941){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l*12|0)|0;break}else m=0;while(0);k=m+(g*12|0)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];b=k+(((e|0)/-12|0)*12|0)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+12;f[i>>2]=m+(l*12|0);if(!d)return;PYa(d);return}function usa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>2>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>1073741823){g=De(8)|0;UYa(g,358155);f[g>>2]=130560;Of(g|0,21520,875)}g=(f[e>>2]|0)-d|0;h=g>>2;i=NYa(b<<2)|0;j=i+(h<<2)|0;k=j+(0-h<<2)|0;if((g|0)>0)K1a(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<2);if(!d)return;PYa(d);return}function vsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)gXa(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;PYa(d);return}function wsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>4>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>268435455){g=De(8)|0;UYa(g,358155);f[g>>2]=130560;Of(g|0,21520,875)}g=(f[e>>2]|0)-d|0;h=g>>4;i=NYa(b<<4)|0;j=i+(h<<4)|0;k=j+(0-h<<4)|0;if((g|0)>0)K1a(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<4);if(!d)return;PYa(d);return}function xsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>2>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>1073741823){g=De(8)|0;UYa(g,358155);f[g>>2]=130560;Of(g|0,21520,875)}g=(f[e>>2]|0)-d|0;h=g>>2;i=NYa(b<<2)|0;j=i+(h<<2)|0;k=j+(0-h<<2)|0;if((g|0)>0)K1a(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<2);if(!d)return;PYa(d);return}function ysa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>2>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>1073741823){g=De(8)|0;UYa(g,358155);f[g>>2]=130560;Of(g|0,21520,875)}g=(f[e>>2]|0)-d|0;h=g>>2;i=NYa(b<<2)|0;j=i+(h<<2)|0;k=j+(0-h<<2)|0;if((g|0)>0)K1a(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<2);if(!d)return;PYa(d);return}function zsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)gXa(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;PYa(d);return}function Asa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)gXa(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;PYa(d);return}function Bsa(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;d=u;u=u+16|0;e=d;_$(e,77124);Tra(a,b,c,0,0);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function Csa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0;e=u;u=u+16|0;g=e;_$(g,77344);Tra(a,c,d,b,0);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Dsa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0;g=u;u=u+16|0;h=g;_$(h,77104);Tra(a,d,e,b,c);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function Esa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0;g=u;u=u+192|0;h=g+172|0;i=g+160|0;j=g+148|0;k=g+136|0;l=g+88|0;m=g;n=g+120|0;o=g+112|0;_$(o,77404);q=f[e>>2]|0;r=f[e+4>>2]|0;e=a+4|0;s=f[e>>2]|0;t=f[a>>2]|0;v=s-t|0;w=v>>4;f[h>>2]=0;x=h+4|0;f[x>>2]=0;f[h+8>>2]=0;y=(w|0)==0;z=t;A=s;do if(!y)if(w>>>0>178956970)gXa(h);else{s=w*24|0;B=NYa(s)|0;f[h>>2]=B;f[h+8>>2]=B+(w*24|0);F1a(B|0,0,s|0)|0;f[x>>2]=B+s;C=B;break}else C=0;while(0);f[i>>2]=0;B=i+4|0;f[B>>2]=0;f[i+8>>2]=0;f[j>>2]=0;s=j+4|0;f[s>>2]=0;f[j+8>>2]=0;if(y)D=0;else{y=v>>1;E=NYa(y)|0;f[j>>2]=E;F=E+(w<<3)|0;f[j+8>>2]=F;F1a(E|0,0,y|0)|0;f[s>>2]=F;D=E}f[k>>2]=0;E=k+4|0;f[E>>2]=0;f[k+8>>2]=0;if((v|0)>0){v=f[b>>2]|0;F=f[c>>2]|0;c=0;do{p[D+(c<<3)>>3]=+p[v+(c<<3)>>3];y=(f[z+(c<<4)+12>>2]|0)+(f[z+(c<<4)+4>>2]<<1)|0;G=rNa(+((f[z+(c<<4)+8>>2]|0)+(f[z+(c<<4)>>2]<<1)|0)*.5)|0;H=+(rNa(+(y|0)*.5)|0);I=+W(+(+p[F+(c<<3)>>3]));p[C+(c*24|0)>>3]=+(G|0);p[C+(c*24|0)+8>>3]=H;p[C+(c*24|0)+16>>3]=I;c=c+1|0}while((c|0)<(w|0))}if((A|0)!=(z|0))f[e>>2]=A+(~((A+-16-t|0)>>>4)<<4);t=f[b>>2]|0;A=b+4|0;z=f[A>>2]|0;if((z|0)!=(t|0))f[A>>2]=z+(~((z+-8-t|0)>>>3)<<3);p[l>>3]=8.0;p[l+8>>3]=16.0;p[l+16>>3]=.26236426446749106;Fsa(m,l,h,j,1.0e-05,100);Gsa(m,i,k,1.0);l=f[i>>2]|0;if((f[B>>2]|0)!=(l|0)){t=n+4|0;z=n+8|0;w=n+12|0;c=a+8|0;C=b+8|0;I=+(q|0);H=+(r|0);r=l;l=0;do{q=r;J=+V(+(+p[q+(l*24|0)+16>>3]));F=~~(I*J);v=~~(H*J);D=~~(+p[q+(l*24|0)>>3]-+((F|0)/2|0|0));G=~~(+p[q+(l*24|0)+8>>3]-+((v|0)/2|0|0));f[n>>2]=D;f[t>>2]=G;f[z>>2]=F;f[w>>2]=v;q=f[k>>2]|0;do if(+p[q+(l<<3)>>3]>d){y=f[e>>2]|0;if((y|0)==(f[c>>2]|0)){Vra(a,n);K=f[k>>2]|0}else{f[y>>2]=D;f[y+4>>2]=G;f[y+8>>2]=F;f[y+12>>2]=v;f[e>>2]=y+16;K=q}y=K+(l<<3)|0;L=f[A>>2]|0;if((L|0)==(f[C>>2]|0)){Wra(b,y);break}else{p[L>>3]=+p[y>>3];f[A>>2]=L+8;break}}while(0);l=l+1|0;r=f[i>>2]|0}while(l>>>0<(((f[B>>2]|0)-r|0)/24|0)>>>0)}r=f[m+64>>2]|0;if(r|0){l=m+68|0;A=f[l>>2]|0;if((A|0)!=(r|0))f[l>>2]=A+(~(((A+-24-r|0)>>>0)/24|0)*24|0);PYa(r)}r=f[m+52>>2]|0;if(r|0){A=m+56|0;l=f[A>>2]|0;if((l|0)!=(r|0))f[A>>2]=l+(~(((l+-24-r|0)>>>0)/24|0)*24|0);PYa(r)}r=f[m+12>>2]|0;if(r|0){l=m+16|0;A=f[l>>2]|0;if((A|0)!=(r|0))f[l>>2]=A+(~((A+-8-r|0)>>>3)<<3);PYa(r)}r=f[m>>2]|0;if(r|0){A=m+4|0;m=f[A>>2]|0;if((m|0)!=(r|0))f[A>>2]=m+(~(((m+-24-r|0)>>>0)/24|0)*24|0);PYa(r)}r=f[k>>2]|0;if(r|0){k=f[E>>2]|0;if((k|0)!=(r|0))f[E>>2]=k+(~((k+-8-r|0)>>>3)<<3);PYa(r)}r=f[j>>2]|0;if(r|0){j=f[s>>2]|0;if((j|0)!=(r|0))f[s>>2]=j+(~((j+-8-r|0)>>>3)<<3);PYa(r)}r=f[i>>2]|0;if(r|0){i=f[B>>2]|0;if((i|0)!=(r|0))f[B>>2]=i+(~(((i+-24-r|0)>>>0)/24|0)*24|0);PYa(r)}r=f[h>>2]|0;if(r|0){h=f[x>>2]|0;if((h|0)!=(r|0))f[x>>2]=h+(~(((h+-24-r|0)>>>0)/24|0)*24|0);PYa(r)}if(!(f[o+4>>2]|0)){u=g;return}u=g;return}function Fsa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0;h=u;u=u+48|0;i=h+24|0;j=h;k=a+4|0;l=a+12|0;m=a+52|0;n=a+56|0;o=a+64|0;q=a+68|0;r=a;s=r+48|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;p[a+24>>3]=+p[b>>3];r=a+32|0;p[r>>3]=+p[b+8>>3];s=a+40|0;p[s>>3]=+p[b+16>>3];if((l|0)!=(d|0))Jsa(l,f[d>>2]|0,f[d+4>>2]|0);if((a|0)==(c|0))t=c+4|0;else{d=c+4|0;Ksa(a,f[c>>2]|0,f[d>>2]|0);t=d}d=((f[t>>2]|0)-(f[c>>2]|0)|0)/24|0;c=a+48|0;f[c>>2]=d;t=f[n>>2]|0;l=f[m>>2]|0;b=(t-l|0)/24|0;v=l;l=t;if(d>>>0<=b>>>0)if(d>>>0<b>>>0?(t=v+(d*24|0)|0,(l|0)!=(t|0)):0){f[n>>2]=l+(~(((l+-24-t|0)>>>0)/24|0)*24|0);w=d}else w=d;else{Lsa(m,d-b|0);w=f[c>>2]|0}c=f[q>>2]|0;b=f[o>>2]|0;d=(c-b|0)/24|0;t=b;b=c;if(w>>>0<=d>>>0){if(w>>>0<d>>>0?(c=t+(w*24|0)|0,(b|0)!=(c|0)):0)f[q>>2]=b+(~(((b+-24-c|0)>>>0)/24|0)*24|0)}else Lsa(o,w-d|0);d=a+76|0;f[d>>2]=g;g=a+80|0;p[g>>3]=e;w=f[a>>2]|0;if((f[k>>2]|0)==(w|0)){u=h;return}c=i+8|0;b=i+16|0;q=i+8|0;t=i+16|0;l=j+8|0;n=j+16|0;v=a+24|0;x=w;w=0;do{Msa(i,a,x+(w*24|0)|0);y=f[m>>2]|0;z=y+(w*24|0)|0;p[z>>3]=+p[i>>3];A=y+(w*24|0)+8|0;p[A>>3]=+p[c>>3];B=y+(w*24|0)+16|0;p[B>>3]=+p[b>>3];e=+p[z>>3];C=+p[A>>3];D=+p[B>>3];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;if((f[d>>2]|0)>0){E=e;F=C;G=D;B=0;do{p[i>>3]=E;p[q>>3]=F;p[t>>3]=G;Msa(j,a,i);E=+p[j>>3];F=+p[l>>3];G=+p[n>>3];H=+p[t>>3];I=+V(+H);J=(+p[i>>3]-E)/(+p[v>>3]*I);K=(+p[q>>3]-F)/(+p[r>>3]*I);I=(H-G)/+p[s>>3];B=B+1|0;if(I*I+(K*K+J*J)<=+p[g>>3])break}while((B|0)<(f[d>>2]|0));L=E;M=F;N=G;O=f[m>>2]|0}else{L=e;M=C;N=D;O=y}B=f[o>>2]|0;p[B+(w*24|0)>>3]=L;p[B+(w*24|0)+8>>3]=M;p[B+(w*24|0)+16>>3]=N;x=f[a>>2]|0;J=+p[x+(w*24|0)+8>>3];K=+p[x+(w*24|0)+16>>3];B=O+(w*24|0)|0;p[B>>3]=+p[B>>3]-+p[x+(w*24|0)>>3];B=O+(w*24|0)+8|0;p[B>>3]=+p[B>>3]-J;B=O+(w*24|0)+16|0;p[B>>3]=+p[B>>3]-K;w=w+1|0}while(w>>>0<(((f[k>>2]|0)-x|0)/24|0)>>>0);u=h;return}function Gsa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0;e=a+64|0;g=a+68|0;h=f[e>>2]|0;i=b+4|0;if((f[g>>2]|0)!=(h|0)){j=b+8|0;k=a+24|0;l=a+32|0;m=a+40|0;n=h;h=0;while(1){o=n;q=f[i>>2]|0;r=f[b>>2]|0;s=r;t=q;a:do if((q|0)==(r|0))u=14;else{v=+p[k>>3];w=+p[l>>3];x=+p[m>>3];y=(q-r|0)/24|0;z=+p[o+(h*24|0)>>3];A=+p[o+(h*24|0)+8>>3];B=+p[o+(h*24|0)+16>>3];C=0;while(1){D=+p[s+(C*24|0)+16>>3];E=+V(+D);F=(+p[s+(C*24|0)>>3]-z)/(v*E);G=(+p[s+(C*24|0)+8>>3]-A)/(w*E);E=(D-B)/x;C=C+1|0;if(E*E+(G*G+F*F)<d){H=n;break a}if(C>>>0>=y>>>0){u=14;break}}}while(0);do if((u|0)==14){u=0;s=o+(h*24|0)|0;if((t|0)==(f[j>>2]|0)){Hsa(b,s);H=f[e>>2]|0;break}else{p[t>>3]=+p[s>>3];p[t+8>>3]=+p[o+(h*24|0)+8>>3];p[t+16>>3]=+p[o+(h*24|0)+16>>3];f[i>>2]=t+24;H=n;break}}while(0);h=h+1|0;if(h>>>0>=(((f[g>>2]|0)-H|0)/24|0)>>>0)break;else n=H}}H=f[i>>2]|0;n=f[b>>2]|0;g=(H-n|0)/24|0;h=c+4|0;e=f[h>>2]|0;j=f[c>>2]|0;u=e-j>>3;m=j;j=e;e=n;if(g>>>0<=u>>>0)if(g>>>0<u>>>0?(l=m+(g<<3)|0,(j|0)!=(l|0)):0){f[h>>2]=j+(~((j+-8-l|0)>>>3)<<3);I=H;J=n;K=e}else{I=H;J=n;K=e}else{Mfa(c,g-u|0);u=f[b>>2]|0;I=f[i>>2]|0;J=u;K=u}if((I|0)==(J|0))return;J=K;K=0;do{d=+Isa(a,J+(K*24|0)|0);p[(f[c>>2]|0)+(K<<3)>>3]=d;K=K+1|0;J=f[b>>2]|0}while(K>>>0<(((f[i>>2]|0)-J|0)/24|0)>>>0);return}function Hsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/24|0;h=g+1|0;i=e;j=d;if(h>>>0>178956970)gXa(a);d=a+8|0;k=((f[d>>2]|0)-e|0)/24|0;l=k<<1;m=k>>>0<89478485?(l>>>0<h>>>0?h:l):178956970;do if(m)if(m>>>0>178956970){l=De(8)|0;UYa(l,358155);f[l>>2]=130560;Of(l|0,21520,875)}else{n=NYa(m*24|0)|0;break}else n=0;while(0);l=n+(g*24|0)|0;h=n+(m*24|0)|0;p[l>>3]=+p[b>>3];p[n+(g*24|0)+8>>3]=+p[b+8>>3];p[n+(g*24|0)+16>>3]=+p[b+16>>3];b=l+24|0;if((j|0)==(i|0))o=l;else{g=l;l=j;while(1){j=l;l=l+-24|0;p[g+-24>>3]=+p[l>>3];p[g+-16>>3]=+p[j+-16>>3];p[g+-8>>3]=+p[j+-8>>3];j=g+-24|0;if((l|0)==(i|0)){o=j;break}else g=j}}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;PYa(e);return}function Isa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0;c=f[a+4>>2]|0;d=f[a>>2]|0;e=d;if((c|0)==(d|0)){g=0.0;return +g}h=+p[a+24>>3];i=+p[a+32>>3];j=+p[a+40>>3];k=+p[b>>3];l=+p[b+8>>3];m=+p[b+16>>3];b=f[a+12>>2]|0;a=(c-d|0)/24|0;d=0;n=0.0;while(1){o=+p[e+(d*24|0)+16>>3];q=+V(+o);r=h*q;s=i*q;q=(+p[e+(d*24|0)>>3]-k)/r;t=(+p[e+(d*24|0)+8>>3]-l)/s;u=(o-m)/j;o=n+ +p[b+(d<<3)>>3]*+V(+((q*q+t*t+u*u)*-.5))/+M(+(j+(r+s)));d=d+1|0;if(d>>>0>=a>>>0){g=o;break}else n=o}return +g}function Jsa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>3;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>3>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>3;o=h>>>0>n>>>0;p=o?b+(n<<3)|0:c;c=p;n=c-e|0;e=n>>3;if(e|0)M1a(k|0,b|0,n|0)|0;n=l+(e<<3)|0;if(o){o=d-c|0;if((o|0)<=0)return;K1a(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>3<<3);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-8-n|0)>>>3)<<3);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-8-k|0)>>>3)<<3);PYa(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>536870911)gXa(a);j=q>>2;n=q>>3>>>0<268435455?(j>>>0<h>>>0?h:j):536870911;if(n>>>0>536870911)gXa(a);j=NYa(n<<3)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<3);if((g|0)<=0)return;K1a(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>3<<3);return}function Ksa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;d=(c-b|0)/24|0;e=a+8|0;g=f[e>>2]|0;h=f[a>>2]|0;i=h;if(d>>>0<=((g-h|0)/24|0)>>>0){j=a+4|0;k=f[j>>2]|0;l=(k-h|0)/24|0;m=d>>>0>l>>>0;n=b+(l*24|0)|0;l=m?n:c;o=k;if((l|0)==(b|0))q=i;else{k=b;r=i;while(1){p[r>>3]=+p[k>>3];p[r+8>>3]=+p[k+8>>3];p[r+16>>3]=+p[k+16>>3];k=k+24|0;s=r+24|0;if((k|0)==(l|0)){q=s;break}else r=s}}if(!m){if((o|0)==(q|0))return;f[j>>2]=o+(~(((o+-24-q|0)>>>0)/24|0)*24|0);return}if((l|0)==(c|0))return;l=f[j>>2]|0;q=n;do{p[l>>3]=+p[q>>3];p[l+8>>3]=+p[q+8>>3];p[l+16>>3]=+p[q+16>>3];q=q+24|0;l=l+24|0}while((q|0)!=(c|0));f[j>>2]=l;return}l=h;if(!h)t=g;else{g=a+4|0;j=f[g>>2]|0;if((j|0)!=(i|0))f[g>>2]=j+(~(((j+-24-h|0)>>>0)/24|0)*24|0);PYa(l);f[e>>2]=0;f[g>>2]=0;f[a>>2]=0;t=0}if(d>>>0>178956970)gXa(a);g=(t|0)/24|0;t=g<<1;l=g>>>0<89478485?(t>>>0<d>>>0?d:t):178956970;if(l>>>0>178956970)gXa(a);t=NYa(l*24|0)|0;d=a+4|0;f[d>>2]=t;f[a>>2]=t;f[e>>2]=t+(l*24|0);if((b|0)==(c|0))return;l=t;t=b;do{p[l>>3]=+p[t>>3];p[l+8>>3]=+p[t+8>>3];p[l+16>>3]=+p[t+16>>3];t=t+24|0;l=l+24|0}while((t|0)!=(c|0));f[d>>2]=l;return}function Lsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/24|0)>>>0>=b>>>0){h=g;i=b;do{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;h=(f[e>>2]|0)+24|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=(g-i|0)/24|0;g=h+b|0;if(g>>>0>178956970)gXa(a);j=(d-i|0)/24|0;i=j<<1;d=j>>>0<89478485?(i>>>0<g>>>0?g:i):178956970;do if(d)if(d>>>0>178956970){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{k=NYa(d*24|0)|0;break}else k=0;while(0);i=k+(h*24|0)|0;h=i;g=k+(d*24|0)|0;d=i;k=b;b=h;do{f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;d=b+24|0;b=d;k=k+-1|0}while((k|0)!=0);k=g;g=f[a>>2]|0;d=f[e>>2]|0;if((d|0)==(g|0)){l=h;m=g}else{h=i;i=d;do{d=i;i=i+-24|0;p[h+-24>>3]=+p[i>>3];p[h+-16>>3]=+p[d+-16>>3];p[h+-8>>3]=+p[d+-8>>3];h=h+-24|0}while((i|0)!=(g|0));l=h;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=b;f[c>>2]=k;if(!m)return;PYa(m);return}function Msa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,N=0.0,O=0.0;d=a+8|0;e=a+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;g=f[b+4>>2]|0;h=f[b>>2]|0;i=h;if((g|0)==(h|0)){j=0.0;k=0.0;l=0.0;m=0.0;n=0.0;o=0.0;q=j/m;p[a>>3]=q;r=k/o;p[d>>3]=r;s=l/n;p[e>>3]=s;return}t=+p[c>>3];u=+p[c+8>>3];v=+p[b+24>>3];w=+p[b+32>>3];x=+p[b+40>>3];y=+p[c+16>>3]/x;c=f[b+12>>2]|0;b=(g-h|0)/24|0;z=0.0;A=0.0;B=0.0;h=0;C=0.0;D=0.0;E=0.0;do{F=+p[i+(h*24|0)+16>>3];G=+V(+F);H=v*G;I=w*G;G=+p[i+(h*24|0)>>3]/H;J=+p[i+(h*24|0)+8>>3]/I;K=F/x;F=G-t/H;L=J-u/I;N=K-y;O=+p[c+(h<<3)>>3]*+V(+((N*N+(F*F+L*L))*-.5))/+M(+(x+(H+I)));z=z+G*O;A=J*O+A;B=K*O+B;C=C+O/H;E=E+O/I;D=D+O/x;h=h+1|0}while(h>>>0<b>>>0);p[a>>3]=z;p[d>>3]=A;p[e>>3]=B;j=z;k=A;l=B;m=C;n=D;o=E;q=j/m;p[a>>3]=q;r=k/o;p[d>>3]=r;s=l/n;p[e>>3]=s;return}function Nsa(a){a=a|0;var b=0,c=0,d=0;WF(a);f[a>>2]=77012;b=a+128|0;c=a+4|0;d=c+124|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[b>>2]=1124007936;b=a+132|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+160>>2]=a+136;b=a+168|0;f[a+164>>2]=b;f[a+172>>2]=0;f[b>>2]=0;f[a+176>>2]=1124007936;b=a+180|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+208>>2]=a+184;b=a+216|0;f[a+212>>2]=b;f[a+220>>2]=0;f[b>>2]=0;f[a+224>>2]=1124007936;b=a+228|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+256>>2]=a+232;b=a+264|0;f[a+260>>2]=b;f[a+268>>2]=0;f[b>>2]=0;f[a+272>>2]=1124007936;b=a+276|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+304>>2]=a+280;b=a+312|0;f[a+308>>2]=b;f[a+316>>2]=0;f[b>>2]=0;f[a+320>>2]=1124007936;b=a+324|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+352>>2]=a+328;b=a+360|0;f[a+356>>2]=b;f[a+364>>2]=0;f[b>>2]=0;f[a+368>>2]=1124007936;b=a+372|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+400>>2]=a+376;b=a+408|0;f[a+404>>2]=b;f[a+412>>2]=0;f[b>>2]=0;U$(a+416|0);return}function Osa(a){a=a|0;f[a>>2]=0;f[a+4>>2]=0;return}function Psa(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;Qsa(a,b)|0;return}function Qsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=NYa(420)|0;Nsa(c);d=NYa(16)|0;e=d+4|0;f[e>>2]=1;f[d>>2]=77432;f[d+8>>2]=c;f[e>>2]=(f[e>>2]|0)+1;g=f[a>>2]|0;f[a>>2]=d;h=a+4|0;f[h>>2]=c;if(g|0?(c=g+4|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)ki[f[(f[g>>2]|0)+8>>2]&2047](g);g=f[e>>2]|0;f[e>>2]=g+-1;if((g|0)==1)ki[f[(f[d>>2]|0)+8>>2]&2047](d);d=f[h>>2]|0;if($h[f[(f[d>>2]|0)+32>>2]&255](d,b)|0){b=f[h>>2]|0;if(!b){j=0;return j|0}j=(mi[f[(f[b>>2]|0)+20>>2]&255](b)|0)^1;return j|0}b=f[a>>2]|0;if(b|0?(d=b+4|0,g=f[d>>2]|0,f[d>>2]=g+-1,(g|0)==1):0)ki[f[(f[b>>2]|0)+8>>2]&2047](b);f[a>>2]=0;f[h>>2]=0;j=0;return j|0}function Rsa(a){a=a|0;PYa(a);return}function Ssa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Tsa(a){a=a|0;var b=0,c=0,d=0;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)ki[f[(f[b>>2]|0)+8>>2]&2047](b);f[a>>2]=0;f[a+4>>2]=0;return}function Usa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;if(!b){c=1;return c|0}c=mi[f[(f[b>>2]|0)+20>>2]&255](b)|0;return c|0}function Vsa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=u;u=u+16|0;h=g;i=c+4|0;j=(f[i>>2]|0)-(f[c>>2]|0)>>4;k=f[a>>2]|0;l=f[a+4>>2]|0;a=(d|0)!=0;if(a?((f[d+4>>2]|0)-(f[d>>2]|0)>>2|0)!=(j|0):0){f[h>>2]=0;f[h+4>>2]=0;m=c$(h,14)|0;n=338321;o=m+14|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,h,338336,334674,1659);d$(h)}q=(e|0)!=0;if(q?((f[e+4>>2]|0)-(f[e>>2]|0)>>3|0)!=(j|0):0){f[h>>2]=0;f[h+4>>2]=0;m=c$(h,14)|0;n=338348;o=m+14|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,h,338336,334674,1663);d$(h)}a:do if(j){h=d+4|0;n=e+4|0;m=f[c>>2]|0;if(!a){o=q^1;r=0;s=0;while(1){t=f[m+(r<<4)>>2]|0;v=(t|0)>0?t:0;w=f[m+(r<<4)+4>>2]|0;x=(w|0)>0?w:0;y=(f[m+(r<<4)+8>>2]|0)+t|0;t=((y|0)<(k|0)?y:k)-v|0;y=(f[m+(r<<4)+12>>2]|0)+w|0;w=((y|0)<(l|0)?y:l)-x|0;y=(t|0)<1|(w|0)<1;z=y?0:w;w=y?0:t;if((w|0)<1|(z|0)<1)A=s;else{f[m+(s<<4)>>2]=y?0:v;f[m+(s<<4)+4>>2]=y?0:x;f[m+(s<<4)+8>>2]=w;f[m+(s<<4)+12>>2]=z;if(!(r>>>0<=s>>>0|o)){z=f[e>>2]|0;w=(f[n>>2]|0)-z>>3;if(w>>>0<=r>>>0){B=25;break}x=z;if(w>>>0<=s>>>0){B=27;break}p[x+(s<<3)>>3]=+p[x+(r<<3)>>3]}A=s+1|0}r=r+1|0;if(r>>>0>=j>>>0){C=A;break a}else s=A}if((B|0)==25)hXa(e);else if((B|0)==27)hXa(e)}else{D=0;E=0}while(1){s=f[m+(D<<4)>>2]|0;r=(s|0)>0?s:0;o=f[m+(D<<4)+4>>2]|0;x=(o|0)>0?o:0;w=(f[m+(D<<4)+8>>2]|0)+s|0;s=((w|0)<(k|0)?w:k)-r|0;w=(f[m+(D<<4)+12>>2]|0)+o|0;o=((w|0)<(l|0)?w:l)-x|0;w=(s|0)<1|(o|0)<1;z=w?0:o;o=w?0:s;if((o|0)<1|(z|0)<1)F=E;else{f[m+(E<<4)>>2]=w?0:r;f[m+(E<<4)+4>>2]=w?0:x;f[m+(E<<4)+8>>2]=o;f[m+(E<<4)+12>>2]=z;if(D>>>0>E>>>0){z=f[d>>2]|0;o=(f[h>>2]|0)-z>>2;if(o>>>0<=D>>>0){B=22;break}x=z;if(o>>>0<=E>>>0){B=23;break}f[x+(E<<2)>>2]=f[x+(D<<2)>>2];if(q){x=f[e>>2]|0;o=(f[n>>2]|0)-x>>3;if(o>>>0<=D>>>0){B=25;break}z=x;if(o>>>0<=E>>>0){B=27;break}p[z+(E<<3)>>3]=+p[z+(D<<3)>>3]}}F=E+1|0}D=D+1|0;if(D>>>0>=j>>>0){C=F;break a}else E=F}if((B|0)==22)hXa(d);else if((B|0)==23)hXa(d);else if((B|0)==25)hXa(e);else if((B|0)==27)hXa(e)}else C=0;while(0);if(C>>>0>=j>>>0){u=g;return}j=f[i>>2]|0;B=f[c>>2]|0;F=j-B>>4;E=B;B=j;if(C>>>0<=F>>>0){if(C>>>0<F>>>0?(j=E+(C<<4)|0,(B|0)!=(j|0)):0)f[i>>2]=B+(~((B+-16-j|0)>>>4)<<4)}else gsa(c,C-F|0);do if(a){F=d+4|0;c=f[F>>2]|0;j=f[d>>2]|0;B=c-j>>2;i=c;if(C>>>0>B>>>0){GM(d,C-B|0);break}if(C>>>0<B>>>0?(B=j+(C<<2)|0,(i|0)!=(B|0)):0)f[F>>2]=i+(~((i+-4-B|0)>>>2)<<2)}while(0);if(!q){u=g;return}q=e+4|0;d=f[q>>2]|0;a=f[e>>2]|0;B=d-a>>3;i=d;if(C>>>0>B>>>0){Mfa(e,C-B|0);u=g;return}if(C>>>0>=B>>>0){u=g;return}B=a+(C<<3)|0;if((i|0)==(B|0)){u=g;return}f[q>>2]=i+(~((i+-8-B|0)>>>3)<<3);u=g;return}function Wsa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=u;u=u+48|0;l=k+32|0;m=k+24|0;n=k+16|0;o=k+8|0;p=k;_$(l,77444);q=a+4|0;a=f[q>>2]|0;if(!((a|0)!=0?!(mi[f[(f[a>>2]|0)+20>>2]&255](a)|0):0)){f[m>>2]=0;f[m+4>>2]=0;a=c$(m,8)|0;r=a;b[r>>0]=33;b[r+1>>0]=101;b[r+2>>0]=109;b[r+3>>0]=112;r=a+4|0;b[r>>0]=116;b[r+1>>0]=121;b[r+2>>0]=40;b[r+3>>0]=41;j$(-215,m,335797,334674,1698);d$(m)}m=f[q>>2]|0;q=f[(f[m>>2]|0)+36>>2]|0;f[n>>2]=f[i>>2];f[n+4>>2]=f[i+4>>2];f[o>>2]=f[j>>2];f[o+4>>2]=f[j+4>>2];ch[q&3](m,c,d,e,g,h,n,o);QR(p,c,-1);Vsa(p,d,0,0);if(!(f[l+4>>2]|0)){u=k;return}u=k;return}function Xsa(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;l=u;u=u+48|0;m=l+32|0;n=l+24|0;o=l+16|0;p=l+8|0;q=l;_$(m,77464);r=a+4|0;a=f[r>>2]|0;if(!((a|0)!=0?!(mi[f[(f[a>>2]|0)+20>>2]&255](a)|0):0)){f[n>>2]=0;f[n+4>>2]=0;a=c$(n,8)|0;s=a;b[s>>0]=33;b[s+1>>0]=101;b[s+2>>0]=109;b[s+3>>0]=112;s=a+4|0;b[s>>0]=116;b[s+1>>0]=121;b[s+2>>0]=40;b[s+3>>0]=41;j$(-215,n,335797,334674,1712);d$(n)}n=f[r>>2]|0;r=f[(f[n>>2]|0)+40>>2]|0;f[o>>2]=f[j>>2];f[o+4>>2]=f[j+4>>2];f[p>>2]=f[k>>2];f[p+4>>2]=f[k+4>>2];Tg[r&7](n,c,d,e,g,h,i,o,p);QR(q,c,-1);Vsa(q,d,e,0);if(!(f[m+4>>2]|0)){u=l;return}u=l;return}function Ysa(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;n=u;u=u+48|0;o=n+32|0;p=n+24|0;q=n+16|0;r=n+8|0;s=n;_$(o,77484);t=a+4|0;a=f[t>>2]|0;if(!((a|0)!=0?!(mi[f[(f[a>>2]|0)+20>>2]&255](a)|0):0)){f[p>>2]=0;f[p+4>>2]=0;a=c$(p,8)|0;v=a;b[v>>0]=33;b[v+1>>0]=101;b[v+2>>0]=109;b[v+3>>0]=112;v=a+4|0;b[v>>0]=116;b[v+1>>0]=121;b[v+2>>0]=40;b[v+3>>0]=41;j$(-215,p,335797,334674,1729);d$(p)}p=f[t>>2]|0;t=f[(f[p>>2]|0)+44>>2]|0;f[q>>2]=f[k>>2];f[q+4>>2]=f[k+4>>2];f[r>>2]=f[l>>2];f[r+4>>2]=f[l+4>>2];Kg[t&3](p,c,d,e,g,h,i,j,q,r,m);QR(s,c,-1);Vsa(s,d,e,g);if(!(f[o+4>>2]|0)){u=n;return}u=n;return}function Zsa(){RX(1973304,338756,230,956,161,156,231);Fd(946,1973304,x|0)|0;return}function _sa(a){a=a|0;var b=0;if(!a)b=0;else b=(f[a>>2]&-65536|0)==1112539136;return b&1|0}function $sa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;if(!a)return;b=f[a>>2]|0;if(!b)return;c=b+4|0;if((f[c>>2]|0)>0){d=b+32|0;e=0;do{g=f[d>>2]|0;h=f[g+(e*24|0)+8>>2]|0;if((f[g+(e*24|0)>>2]|0)>0){g=h;i=0;while(1){$F(f[g+(i*24|0)+4>>2]|0);f[(f[(f[d>>2]|0)+(e*24|0)+8>>2]|0)+(i*24|0)+4>>2]=0;i=i+1|0;j=f[d>>2]|0;k=f[j+(e*24|0)+8>>2]|0;if((i|0)>=(f[j+(e*24|0)>>2]|0)){l=k;break}else g=k}}else l=h;$F(l);f[(f[d>>2]|0)+(e*24|0)+8>>2]=0;e=e+1|0}while((e|0)<(f[c>>2]|0))}c=b+36|0;b=f[c>>2]|0;if(b|0){$F(b);f[c>>2]=0}$F(f[a>>2]|0);f[a>>2]=0;return}function ata(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0;d=u;u=u+752|0;e=d+352|0;g=d+344|0;h=d+336|0;i=d+328|0;j=d+312|0;k=d+296|0;l=d+280|0;m=d+264|0;o=d+248|0;q=d+232|0;r=d+216|0;s=d+200|0;t=d+184|0;v=d+168|0;w=d+152|0;x=d+136|0;y=d+120|0;z=d+104|0;A=d+88|0;B=d+72|0;C=d+56|0;D=d+40|0;E=d+24|0;F=d+16|0;G=d+8|0;H=d;I=d+496|0;J=d+464|0;K=d+432|0;L=d+400|0;M=d+368|0;N=d+360|0;O=CX(a,c,338902)|0;if(!((O|0)!=0?(f[O>>2]&7|0)==5:0)){f[K>>2]=0;f[K+4>>2]=0;P=c$(K,19)|0;Q=339049;R=P+19|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));j$(-2,K,339069,338846,1790);d$(K)}S=O+8|0;O=f[(f[S>>2]|0)+24>>2]|0;T=dta(O)|0;U=CX(a,c,338897)|0;if(((U|0)!=0?(f[U>>2]&7|0)==5:0)?(c=U+8|0,V=f[c>>2]|0,(f[V+24>>2]|0)==2):0){W=V;X=c}else{f[K>>2]=0;f[K+4>>2]=0;P=c$(K,34)|0;Q=339091;R=P+34|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));j$(-2,K,339069,338846,1798);d$(K);c=U+8|0;W=f[c>>2]|0;X=c}c=AL(W,0)|0;if((f[c>>2]&7|0)==1?(W=f[c+8>>2]|0,(W|0)>=1):0)Y=W;else{f[K>>2]=0;f[K+4>>2]=0;P=c$(K,49)|0;Q=339126;R=P+49|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));j$(-2,K,339069,338846,1801);d$(K);Y=f[c+8>>2]|0}c=T+8|0;f[c>>2]=Y;Y=AL(f[X>>2]|0,1)|0;if((f[Y>>2]&7|0)==1?(X=f[Y+8>>2]|0,(X|0)>=1):0)Z=X;else{f[K>>2]=0;f[K+4>>2]=0;P=c$(K,50)|0;Q=339176;R=P+50|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));j$(-2,K,339069,338846,1805);d$(K);Z=f[Y+8>>2]|0}Y=T+12|0;f[Y>>2]=Z;CL(f[S>>2]|0,J,0);if((O|0)<=0){u=d;return T|0}S=J+12|0;Z=L+4|0;Q=T+32|0;P=L+4|0;R=L+4|0;X=L+4|0;W=J+20|0;U=T+4|0;V=K+12|0;_=M+4|0;$=K+20|0;aa=M+4|0;ba=L+12|0;ca=N+4|0;da=N+4|0;ea=N+4|0;fa=N+4|0;ga=N+4|0;ha=N+4|0;ia=N+4|0;ja=N+4|0;ka=N+4|0;la=N+4|0;ma=L+20|0;na=N+4|0;oa=N+4|0;pa=M+12|0;qa=N+4|0;ra=N+4|0;sa=N+4|0;ta=N+4|0;ua=M+20|0;va=N+4|0;wa=N+4|0;xa=N+4|0;ya=L+4|0;za=0;do{Aa=f[S>>2]|0;if((f[Aa>>2]&7|0)!=6){f[H>>2]=za;SLa(I,339227,H)|0;f[L>>2]=0;f[ya>>2]=0;Ba=xKa(I)|0;if(Ba|0)K1a(c$(L,Ba)|0,I|0,Ba|0)|0;j$(-2,L,339069,338846,1819);d$(L)}Ba=CX(a,Aa,338918)|0;if(((Ba|0)!=0?(f[Ba>>2]&7|0)==5:0)?(Ca=Ba+8|0,Da=f[(f[Ca>>2]|0)+24>>2]|0,(Da|0)>=1):0){Ea=Da;Fa=Ca}else{f[G>>2]=za;SLa(I,339244,G)|0;f[L>>2]=0;f[Z>>2]=0;Ca=xKa(I)|0;if(Ca|0)K1a(c$(L,Ca)|0,I|0,Ca|0)|0;j$(-2,L,339069,338846,1827);d$(L);Ca=Ba+8|0;Ea=f[(f[Ca>>2]|0)+24>>2]|0;Fa=Ca}Ca=_F(Ea*24|0)|0;Ba=f[Q>>2]|0;f[Ba+(za*24|0)+8>>2]=Ca;Da=f[Fa>>2]|0;Ga=f[Da+24>>2]|0;if((Ga|0)>0){Ha=0;do{f[Ca+(Ha*24|0)+4>>2]=0;Ha=Ha+1|0;Ia=f[Fa>>2]|0;Ja=f[Ia+24>>2]|0}while((Ha|0)<(Ja|0));Ka=Ja;La=Ia}else{Ka=Ga;La=Da}f[Ba+(za*24|0)>>2]=Ka;CL(La,K,0);if((f[(f[Fa>>2]|0)+24>>2]|0)>0){Ha=0;do{Ca=f[(f[Q>>2]|0)+(za*24|0)+8>>2]|0;Ia=f[V>>2]|0;if((f[Ia>>2]&7|0)==5?(Ja=Ia+8|0,Ma=f[(f[Ja>>2]|0)+24>>2]|0,(Ma|0)>=1):0){Na=Ma;Oa=Ja}else{f[F>>2]=za;f[F+4>>2]=Ha;SLa(I,339291,F)|0;f[M>>2]=0;f[_>>2]=0;Ja=xKa(I)|0;if(Ja|0)K1a(c$(M,Ja)|0,I|0,Ja|0)|0;j$(-2,M,339069,338846,1853);d$(M);Ja=Ia+8|0;Na=f[(f[Ja>>2]|0)+24>>2]|0;Oa=Ja}Ja=Ca+(Ha*24|0)|0;f[Ja>>2]=Na;Ia=_F(Na*80|4)|0;Ma=Ca+(Ha*24|0)+4|0;f[Ma>>2]=Ia;Pa=f[Ja>>2]|0;Qa=Ia+(Pa<<6)|0;Ia=Ca+(Ha*24|0)+8|0;f[Ia>>2]=Qa;Ra=Qa+(Pa<<2)|0;Qa=Ca+(Ha*24|0)+12|0;f[Qa>>2]=Ra;Sa=Ra+(Pa<<2)|0;Ra=Ca+(Ha*24|0)+16|0;f[Ra>>2]=Sa;Ta=Ca+(Ha*24|0)+20|0;f[Ta>>2]=Sa+(Pa<<2);CL(f[Oa>>2]|0,L,0);if((f[(f[Oa>>2]|0)+24>>2]|0)>0){Pa=0;Sa=0;while(1){Ca=f[ba>>2]|0;if((f[Ca>>2]&7|0)!=6){f[E>>2]=Pa;f[E+4>>2]=za;f[E+8>>2]=Ha;SLa(I,339346,E)|0;f[N>>2]=0;f[xa>>2]=0;Ua=xKa(I)|0;if(Ua|0)K1a(c$(N,Ua)|0,I|0,Ua|0)|0;j$(-2,N,339069,338846,1881);d$(N)}Ua=CX(a,Ca,338950)|0;if(!((Ua|0)!=0?(f[Ua>>2]&7|0)==6:0)){f[D>>2]=za;f[D+4>>2]=Ha;f[D+8>>2]=Pa;SLa(I,339399,D)|0;f[N>>2]=0;f[ca>>2]=0;Va=xKa(I)|0;if(Va|0)K1a(c$(N,Va)|0,I|0,Va|0)|0;j$(-2,N,339069,338846,1888);d$(N)}Va=CX(a,Ua,338958)|0;do if(Va){if((f[Va>>2]&7|0)!=5){Wa=47;break}Xa=Va+8|0;Ya=f[Xa>>2]|0;if(((f[Ya+24>>2]|0)+-1|0)>>>0<=2){Za=Ya;_a=Xa}else Wa=47}else Wa=47;while(0);if((Wa|0)==47){Wa=0;f[C>>2]=za;f[C+4>>2]=Ha;f[C+8>>2]=Pa;SLa(I,339461,C)|0;f[N>>2]=0;f[da>>2]=0;Xa=xKa(I)|0;if(Xa|0)K1a(c$(N,Xa)|0,I|0,Xa|0)|0;j$(-2,N,339069,338846,1897);d$(N);Xa=Va+8|0;Za=f[Xa>>2]|0;_a=Xa}CL(Za,M,0);Xa=f[(f[_a>>2]|0)+24>>2]|0;if((Xa|0)>0){Ya=0;do{$a=f[pa>>2]|0;if((f[$a>>2]&7|0)==5?(ab=$a+8|0,bb=f[ab>>2]|0,(f[bb+24>>2]|0)==5):0){cb=bb;db=ab}else{f[B>>2]=Ya;f[B+4>>2]=za;f[B+8>>2]=Ha;f[B+12>>2]=Pa;SLa(I,339526,B)|0;f[N>>2]=0;f[wa>>2]=0;ab=xKa(I)|0;if(ab|0)K1a(c$(N,ab)|0,I|0,ab|0)|0;j$(-2,N,339069,338846,1910);d$(N);ab=$a+8|0;cb=f[ab>>2]|0;db=ab}ab=f[cb+52>>2]|0;do if(!ab)Wa=60;else{if(!(f[ab+12>>2]|0)){Wa=60;break}eb=f[ab+16>>2]|0}while(0);if((Wa|0)==60){Wa=0;eb=AL(f[db>>2]|0,0)|0}if((f[eb>>2]&7|0)==1?(ab=f[eb+8>>2]|0,(ab|0)>=0):0)fb=ab;else{f[A>>2]=za;f[A+4>>2]=Ha;f[A+8>>2]=Pa;f[A+12>>2]=Ya;SLa(I,339588,A)|0;f[N>>2]=0;f[qa>>2]=0;ab=xKa(I)|0;if(ab|0)K1a(c$(N,ab)|0,I|0,ab|0)|0;j$(-2,N,339069,338846,1918);d$(N);fb=f[eb+8>>2]|0}ab=f[db>>2]|0;$a=f[ab+52>>2]|0;do if(!$a)Wa=69;else{if((f[$a+12>>2]|0)>>>0<=1){Wa=69;break}gb=(f[$a+16>>2]|0)+16|0}while(0);if((Wa|0)==69){Wa=0;gb=AL(ab,1)|0}if((f[gb>>2]&7|0)==1?($a=f[gb+8>>2]|0,($a|0)>=0):0)hb=$a;else{f[z>>2]=za;f[z+4>>2]=Ha;f[z+8>>2]=Pa;f[z+12>>2]=Ya;SLa(I,339669,z)|0;f[N>>2]=0;f[ra>>2]=0;$a=xKa(I)|0;if($a|0)K1a(c$(N,$a)|0,I|0,$a|0)|0;j$(-2,N,339069,338846,1926);d$(N);hb=f[gb+8>>2]|0}$a=f[db>>2]|0;bb=f[$a+52>>2]|0;do if(!bb)Wa=78;else{if((f[bb+12>>2]|0)>>>0<=2){Wa=78;break}ib=(f[bb+16>>2]|0)+32|0}while(0);if((Wa|0)==78){Wa=0;ib=AL($a,2)|0}do if((f[ib>>2]&7|0)==1){bb=f[ib+8>>2]|0;if((bb|0)<1){Wa=82;break}if((bb+fb|0)<=(f[c>>2]|0))jb=bb;else Wa=82}else Wa=82;while(0);if((Wa|0)==82){Wa=0;f[y>>2]=za;f[y+4>>2]=Ha;f[y+8>>2]=Pa;f[y+12>>2]=Ya;SLa(I,339750,y)|0;f[N>>2]=0;f[sa>>2]=0;$a=xKa(I)|0;if($a|0)K1a(c$(N,$a)|0,I|0,$a|0)|0;j$(-2,N,339069,338846,1936);d$(N);jb=f[ib+8>>2]|0}$a=f[db>>2]|0;bb=f[$a+52>>2]|0;do if(!bb)Wa=88;else{if((f[bb+12>>2]|0)>>>0<=3){Wa=88;break}kb=(f[bb+16>>2]|0)+48|0}while(0);if((Wa|0)==88){Wa=0;kb=AL($a,3)|0}do if((f[kb>>2]&7|0)==1){bb=f[kb+8>>2]|0;if((bb|0)<1){Wa=92;break}if((bb+hb|0)<=(f[Y>>2]|0))lb=bb;else Wa=92}else Wa=92;while(0);if((Wa|0)==92){Wa=0;f[x>>2]=za;f[x+4>>2]=Ha;f[x+8>>2]=Pa;f[x+12>>2]=Ya;SLa(I,339865,x)|0;f[N>>2]=0;f[ta>>2]=0;$a=xKa(I)|0;if($a|0)K1a(c$(N,$a)|0,I|0,$a|0)|0;j$(-2,N,339069,338846,1946);d$(N);lb=f[kb+8>>2]|0}$a=f[db>>2]|0;bb=f[$a+52>>2]|0;do if(!bb)Wa=98;else{if((f[bb+12>>2]|0)>>>0<=4){Wa=98;break}mb=(f[bb+16>>2]|0)+64|0}while(0);if((Wa|0)==98){Wa=0;mb=AL($a,4)|0}if((f[mb>>2]&7|0)!=2){f[w>>2]=za;f[w+4>>2]=Ha;f[w+8>>2]=Pa;f[w+12>>2]=Ya;SLa(I,339983,w)|0;f[N>>2]=0;f[va>>2]=0;bb=xKa(I)|0;if(bb|0)K1a(c$(N,bb)|0,I|0,bb|0)|0;j$(-2,N,339069,338846,1954);d$(N)}bb=f[Ma>>2]|0;n[bb+(Pa<<6)+4+(Ya*20|0)+16>>2]=+p[mb+8>>3];f[bb+(Pa<<6)+4+(Ya*20|0)>>2]=fb;f[bb+(Pa<<6)+4+(Ya*20|0)+4>>2]=hb;f[bb+(Pa<<6)+4+(Ya*20|0)+8>>2]=jb;f[bb+(Pa<<6)+4+(Ya*20|0)+12>>2]=lb;bb=(f[pa>>2]|0)+16|0;f[pa>>2]=bb;if(bb>>>0>=(f[ua>>2]|0)>>>0)LL(M,1);Ya=Ya+1|0;nb=f[(f[_a>>2]|0)+24>>2]|0}while((Ya|0)<(nb|0));if((nb|0)<3){ob=nb;Wa=106}}else{ob=Xa;Wa=106}if((Wa|0)==106)while(1){Wa=0;Ya=f[Ma>>2]|0;n[Ya+(Pa<<6)+4+(ob*20|0)+16>>2]=0.0;Va=Ya+(Pa<<6)+4+(ob*20|0)|0;f[Va>>2]=0;f[Va+4>>2]=0;f[Va+8>>2]=0;f[Va+12>>2]=0;ob=ob+1|0;if((ob|0)==3)break;else Wa=106}Xa=CX(a,Ua,338964)|0;if(!((Xa|0)!=0?(f[Xa>>2]&7|0)==1:0)){f[v>>2]=za;f[v+4>>2]=Ha;f[v+8>>2]=Pa;SLa(I,340049,v)|0;f[N>>2]=0;f[ea>>2]=0;Va=xKa(I)|0;if(Va|0)K1a(c$(N,Va)|0,I|0,Va|0)|0;j$(-2,N,339069,338846,1973);d$(N)}f[(f[Ma>>2]|0)+(Pa<<6)>>2]=(f[Xa+8>>2]|0)!=0&1;Xa=CX(a,Ca,338971)|0;if(!((Xa|0)!=0?(f[Xa>>2]&7|0)==2:0)){f[t>>2]=za;f[t+4>>2]=Ha;f[t+8>>2]=Pa;SLa(I,340101,t)|0;f[N>>2]=0;f[fa>>2]=0;Va=xKa(I)|0;if(Va|0)K1a(c$(N,Va)|0,I|0,Va|0)|0;j$(-2,N,339069,338846,1981);d$(N)}n[(f[Ia>>2]|0)+(Pa<<2)>>2]=+p[Xa+8>>3];Xa=CX(a,Ca,338981)|0;if(!Xa){Va=CX(a,Ca,338991)|0;if(!Va){f[r>>2]=za;f[r+4>>2]=Ha;f[r+8>>2]=Pa;SLa(I,340227,r)|0;f[N>>2]=0;f[ga>>2]=0;Ya=xKa(I)|0;if(Ya|0)K1a(c$(N,Ya)|0,I|0,Ya|0)|0;j$(-2,N,339069,338846,2004);d$(N)}if((f[Va>>2]&7|0)!=2){f[q>>2]=za;f[q+4>>2]=Ha;f[q+8>>2]=Pa;SLa(I,340299,q)|0;f[N>>2]=0;f[ia>>2]=0;Ya=xKa(I)|0;if(Ya|0)K1a(c$(N,Ya)|0,I|0,Ya|0)|0;j$(-2,N,339069,338846,2010);d$(N)}if((Sa|0)>(f[Ja>>2]|0)){f[o>>2]=za;f[o+4>>2]=Ha;f[o+8>>2]=Pa;SLa(I,340360,o)|0;f[N>>2]=0;f[ha>>2]=0;Ya=xKa(I)|0;if(Ya|0)K1a(c$(N,Ya)|0,I|0,Ya|0)|0;j$(-2,N,339069,338846,2017);d$(N)}f[(f[Qa>>2]|0)+(Pa<<2)>>2]=0-Sa;n[(f[Ta>>2]|0)+(Sa<<2)>>2]=+p[Va+8>>3];pb=Sa+1|0}else{do if((f[Xa>>2]&7|0)==1){Va=f[Xa+8>>2]|0;if((Va|0)<=(Pa|0)){Wa=121;break}if((Va|0)<(f[(f[Oa>>2]|0)+24>>2]|0))qb=Va;else Wa=121}else Wa=121;while(0);if((Wa|0)==121){Wa=0;f[s>>2]=za;f[s+4>>2]=Ha;f[s+8>>2]=Pa;SLa(I,340161,s)|0;f[N>>2]=0;f[oa>>2]=0;Ua=xKa(I)|0;if(Ua|0)K1a(c$(N,Ua)|0,I|0,Ua|0)|0;j$(-2,N,339069,338846,1992);d$(N);qb=f[Xa+8>>2]|0}f[(f[Qa>>2]|0)+(Pa<<2)>>2]=qb;pb=Sa}Ua=CX(a,Ca,339e3)|0;if(!Ua){Va=CX(a,Ca,339011)|0;if(!Va){f[l>>2]=za;f[l+4>>2]=Ha;f[l+8>>2]=Pa;SLa(I,340499,l)|0;f[N>>2]=0;f[ja>>2]=0;Ya=xKa(I)|0;if(Ya|0)K1a(c$(N,Ya)|0,I|0,Ya|0)|0;j$(-2,N,339069,338846,2042);d$(N)}if((f[Va>>2]&7|0)!=2){f[k>>2]=za;f[k+4>>2]=Ha;f[k+8>>2]=Pa;SLa(I,340573,k)|0;f[N>>2]=0;f[la>>2]=0;Ya=xKa(I)|0;if(Ya|0)K1a(c$(N,Ya)|0,I|0,Ya|0)|0;j$(-2,N,339069,338846,2048);d$(N)}if((pb|0)>(f[Ja>>2]|0)){f[j>>2]=za;f[j+4>>2]=Ha;f[j+8>>2]=Pa;SLa(I,340360,j)|0;f[N>>2]=0;f[ka>>2]=0;Ya=xKa(I)|0;if(Ya|0)K1a(c$(N,Ya)|0,I|0,Ya|0)|0;j$(-2,N,339069,338846,2055);d$(N)}f[(f[Ra>>2]|0)+(Pa<<2)>>2]=0-pb;n[(f[Ta>>2]|0)+(pb<<2)>>2]=+p[Va+8>>3];rb=pb+1|0}else{do if((f[Ua>>2]&7|0)==1){Va=f[Ua+8>>2]|0;if((Va|0)<=(Pa|0)){Wa=142;break}if((Va|0)<(f[(f[Oa>>2]|0)+24>>2]|0))sb=Va;else Wa=142}else Wa=142;while(0);if((Wa|0)==142){Wa=0;f[m>>2]=za;f[m+4>>2]=Ha;f[m+8>>2]=Pa;SLa(I,340432,m)|0;f[N>>2]=0;f[na>>2]=0;Ca=xKa(I)|0;if(Ca|0)K1a(c$(N,Ca)|0,I|0,Ca|0)|0;j$(-2,N,339069,338846,2030);d$(N);sb=f[Ua+8>>2]|0}f[(f[Ra>>2]|0)+(Pa<<2)>>2]=sb;rb=pb}Ca=(f[ba>>2]|0)+16|0;f[ba>>2]=Ca;if(Ca>>>0>=(f[ma>>2]|0)>>>0)LL(L,1);Pa=Pa+1|0;if((Pa|0)>=(f[(f[Oa>>2]|0)+24>>2]|0)){tb=rb;break}else Sa=rb}}else tb=0;if((tb|0)!=((f[Ja>>2]|0)+1|0)){f[i>>2]=za;f[i+4>>2]=Ha;SLa(I,340635,i)|0;f[M>>2]=0;f[aa>>2]=0;Sa=xKa(I)|0;if(Sa|0)K1a(c$(M,Sa)|0,I|0,Sa|0)|0;j$(-2,M,339069,338846,2067);d$(M)}Sa=(f[V>>2]|0)+16|0;f[V>>2]=Sa;if(Sa>>>0>=(f[$>>2]|0)>>>0)LL(K,1);Ha=Ha+1|0}while((Ha|0)<(f[(f[Fa>>2]|0)+24>>2]|0))}Ha=CX(a,Aa,339021)|0;if(!((Ha|0)!=0?(f[Ha>>2]&7|0)==2:0)){f[h>>2]=za;SLa(I,340697,h)|0;f[L>>2]=0;f[P>>2]=0;Ba=xKa(I)|0;if(Ba|0)K1a(c$(L,Ba)|0,I|0,Ba|0)|0;j$(-2,L,339069,338846,2077);d$(L)}n[(f[Q>>2]|0)+(za*24|0)+4>>2]=+p[Ha+8>>3];Ha=CX(a,Aa,339037)|0;if((((Ha|0)!=0?(f[Ha>>2]&7|0)==1:0)?(Ba=f[Ha+8>>2]|0,(Ba|0)>=-1):0)?(Ba|0)<(f[U>>2]|0):0)ub=Ba;else{f[g>>2]=za;SLa(I,340745,g)|0;f[L>>2]=0;f[R>>2]=0;Ba=xKa(I)|0;if(Ba|0)K1a(c$(L,Ba)|0,I|0,Ba|0)|0;j$(-2,L,339069,338846,2089);d$(L);ub=f[Ha+8>>2]|0}Ha=CX(a,Aa,339044)|0;if((((Ha|0)!=0?(f[Ha>>2]&7|0)==1:0)?(Ba=f[Ha+8>>2]|0,(Ba|0)>=-1):0)?(Ba|0)<(f[U>>2]|0):0)vb=Ba;else{f[e>>2]=za;SLa(I,340787,e)|0;f[L>>2]=0;f[X>>2]=0;Ba=xKa(I)|0;if(Ba|0)K1a(c$(L,Ba)|0,I|0,Ba|0)|0;j$(-2,L,339069,338846,2097);d$(L);vb=f[Ha+8>>2]|0}Ha=f[Q>>2]|0;f[Ha+(za*24|0)+20>>2]=ub;f[Ha+(za*24|0)+12>>2]=vb;f[Ha+(za*24|0)+16>>2]=-1;if((ub|0)!=-1?(Ba=Ha+(ub*24|0)+16|0,(f[Ba>>2]|0)==-1):0)f[Ba>>2]=za;Ba=(f[S>>2]|0)+16|0;f[S>>2]=Ba;if(Ba>>>0>=(f[W>>2]|0)>>>0)LL(J,1);za=za+1|0}while((za|0)<(O|0));u=d;return T|0}function bta(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;g=u;u=u+368|0;h=g+104|0;i=g+16|0;j=g+8|0;k=g;l=g+112|0;m=g+24|0;o=g+96|0;p=g+88|0;q=g+80|0;r=g+72|0;s=g+64|0;t=g+56|0;v=g+48|0;w=g+40|0;x=g+32|0;y=e;e=f[y+4>>2]|0;z=m;f[z>>2]=f[y>>2];f[z+4>>2]=e;f[h>>2]=f[m>>2];f[h+4>>2]=f[m+4>>2];nX(a,c,6,338756,h);f[o>>2]=0;f[o+4>>2]=0;f[h>>2]=f[o>>2];f[h+4>>2]=f[o+4>>2];nX(a,338897,13,0,h);HX(a,0,f[d+8>>2]|0);HX(a,0,f[d+12>>2]|0);kV(a);f[p>>2]=0;f[p+4>>2]=0;f[h>>2]=f[p>>2];f[h+4>>2]=f[p+4>>2];nX(a,338902,5,0,h);p=d+4|0;if((f[p>>2]|0)<=0){kV(a);kV(a);u=g;return}o=q+4|0;c=r+4|0;m=d+32|0;d=s+4|0;e=t+4|0;z=v+4|0;y=w+4|0;A=x+4|0;B=0;do{f[q>>2]=0;f[o>>2]=0;f[h>>2]=f[q>>2];f[h+4>>2]=f[q+4>>2];nX(a,0,6,0,h);f[k>>2]=B;SLa(l,338909,k)|0;QX(a,l,1);f[r>>2]=0;f[c>>2]=0;f[h>>2]=f[r>>2];f[h+4>>2]=f[r+4>>2];nX(a,338918,5,0,h);C=f[m>>2]|0;if((f[C+(B*24|0)>>2]|0)>0){D=C;C=0;do{E=f[D+(B*24|0)+8>>2]|0;f[s>>2]=0;f[d>>2]=0;f[h>>2]=f[s>>2];f[h+4>>2]=f[s+4>>2];nX(a,0,5,0,h);f[j>>2]=C;SLa(l,338924,j)|0;QX(a,l,1);F=E+(C*24|0)|0;if((f[F>>2]|0)>0){G=E+(C*24|0)+4|0;H=E+(C*24|0)+8|0;I=E+(C*24|0)+12|0;J=E+(C*24|0)+16|0;K=E+(C*24|0)+20|0;E=0;do{L=f[G>>2]|0;f[t>>2]=0;f[e>>2]=0;f[h>>2]=f[t>>2];f[h+4>>2]=f[t+4>>2];nX(a,0,6,0,h);if(!E){M=l;N=338940;O=M+10|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0))}else{f[i>>2]=E;SLa(l,338932,i)|0}QX(a,l,1);f[v>>2]=0;f[z>>2]=0;f[h>>2]=f[v>>2];f[h+4>>2]=f[v+4>>2];nX(a,338950,6,0,h);f[w>>2]=0;f[y>>2]=0;f[h>>2]=f[w>>2];f[h+4>>2]=f[w+4>>2];nX(a,338958,5,0,h);N=L+(E<<6)+12|0;if((f[N>>2]|0?(f[x>>2]=0,f[A>>2]=0,f[h>>2]=f[x>>2],f[h+4>>2]=f[x+4>>2],nX(a,0,13,0,h),HX(a,0,f[L+(E<<6)+4>>2]|0),HX(a,0,f[L+(E<<6)+8>>2]|0),HX(a,0,f[N>>2]|0),HX(a,0,f[L+(E<<6)+16>>2]|0),PX(a,0,+n[L+(E<<6)+20>>2]),kV(a),N=L+(E<<6)+32|0,f[N>>2]|0):0)?(f[x>>2]=0,f[A>>2]=0,f[h>>2]=f[x>>2],f[h+4>>2]=f[x+4>>2],nX(a,0,13,0,h),HX(a,0,f[L+(E<<6)+24>>2]|0),HX(a,0,f[L+(E<<6)+28>>2]|0),HX(a,0,f[N>>2]|0),HX(a,0,f[L+(E<<6)+36>>2]|0),PX(a,0,+n[L+(E<<6)+40>>2]),kV(a),N=L+(E<<6)+52|0,f[N>>2]|0):0){f[x>>2]=0;f[A>>2]=0;f[h>>2]=f[x>>2];f[h+4>>2]=f[x+4>>2];nX(a,0,13,0,h);HX(a,0,f[L+(E<<6)+44>>2]|0);HX(a,0,f[L+(E<<6)+48>>2]|0);HX(a,0,f[N>>2]|0);HX(a,0,f[L+(E<<6)+56>>2]|0);PX(a,0,+n[L+(E<<6)+60>>2]);kV(a)}kV(a);HX(a,338964,f[L+(E<<6)>>2]|0);kV(a);PX(a,338971,+n[(f[H>>2]|0)+(E<<2)>>2]);N=f[(f[I>>2]|0)+(E<<2)>>2]|0;if((N|0)>0)HX(a,338981,N);else PX(a,338991,+n[(f[K>>2]|0)+(0-N<<2)>>2]);N=f[(f[J>>2]|0)+(E<<2)>>2]|0;if((N|0)>0)HX(a,339e3,N);else PX(a,339011,+n[(f[K>>2]|0)+(0-N<<2)>>2]);kV(a);E=E+1|0}while((E|0)<(f[F>>2]|0))}kV(a);C=C+1|0;D=f[m>>2]|0}while((C|0)<(f[D+(B*24|0)>>2]|0))}kV(a);PX(a,339021,+n[(f[m>>2]|0)+(B*24|0)+4>>2]);HX(a,339037,f[(f[m>>2]|0)+(B*24|0)+20>>2]|0);HX(a,339044,f[(f[m>>2]|0)+(B*24|0)+12>>2]|0);kV(a);B=B+1|0}while((B|0)<(f[p>>2]|0));kV(a);kV(a);u=g;return}function cta(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;b=f[a+4>>2]|0;c=dta(b)|0;d=a+8|0;e=f[d+4>>2]|0;g=c+8|0;f[g>>2]=f[d>>2];f[g+4>>2]=e;if((b|0)<=0)return c|0;e=a+32|0;a=c+32|0;g=f[a>>2]|0;d=0;while(1){h=f[e>>2]|0;f[g+(d*24|0)+20>>2]=f[h+(d*24|0)+20>>2];f[g+(d*24|0)+12>>2]=f[h+(d*24|0)+12>>2];f[g+(d*24|0)+16>>2]=f[h+(d*24|0)+16>>2];f[g+(d*24|0)+4>>2]=f[h+(d*24|0)+4>>2];f[g+(d*24|0)>>2]=0;i=_F((f[h+(d*24|0)>>2]|0)*24|0)|0;h=f[a>>2]|0;f[h+(d*24|0)+8>>2]=i;j=f[e>>2]|0;k=f[j+(d*24|0)>>2]|0;f[h+(d*24|0)>>2]=k;l=(k|0)>0;a:do if(l){m=0;do{f[i+(m*24|0)+4>>2]=0;m=m+1|0}while((m|0)<(k|0));if(l){m=j;n=i;o=0;while(1){p=f[m+(d*24|0)+8>>2]|0;q=f[p+(o*24|0)>>2]|0;r=n+(o*24|0)|0;f[r>>2]=q;s=_F(q*80|4)|0;q=n+(o*24|0)+4|0;f[q>>2]=s;t=f[r>>2]|0;u=s+(t<<6)|0;v=n+(o*24|0)+8|0;f[v>>2]=u;w=u+(t<<2)|0;u=n+(o*24|0)+12|0;f[u>>2]=w;x=w+(t<<2)|0;w=n+(o*24|0)+16|0;f[w>>2]=x;y=x+(t<<2)|0;x=n+(o*24|0)+20|0;f[x>>2]=y;b:do if((t|0)>0){z=p+(o*24|0)+4|0;A=p+(o*24|0)+8|0;B=p+(o*24|0)+12|0;C=p+(o*24|0)+16|0;D=p+(o*24|0)+20|0;E=s;F=0;while(1){G=E+(F<<6)|0;H=(f[z>>2]|0)+(F<<6)|0;I=G+64|0;do{f[G>>2]=f[H>>2];G=G+4|0;H=H+4|0}while((G|0)<(I|0));f[(f[v>>2]|0)+(F<<2)>>2]=f[(f[A>>2]|0)+(F<<2)>>2];f[(f[u>>2]|0)+(F<<2)>>2]=f[(f[B>>2]|0)+(F<<2)>>2];f[(f[w>>2]|0)+(F<<2)>>2]=f[(f[C>>2]|0)+(F<<2)>>2];H=f[D>>2]|0;G=f[x>>2]|0;f[G+(F<<2)>>2]=f[H+(F<<2)>>2];I=F+1|0;J=f[r>>2]|0;if((I|0)>=(J|0)){K=J;L=H;M=G;break b}E=f[q>>2]|0;F=I}}else{K=t;L=f[p+(o*24|0)+20>>2]|0;M=y}while(0);f[M+(K<<2)>>2]=f[L+(K<<2)>>2];y=o+1|0;p=f[a>>2]|0;if((y|0)>=(f[p+(d*24|0)>>2]|0)){N=p;break a}m=f[e>>2]|0;n=f[p+(d*24|0)+8>>2]|0;o=y}}else N=h}else N=h;while(0);d=d+1|0;if((d|0)==(b|0))break;else g=N}return c|0}function dta(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;e=(a*24|0)+40|0;if((a|0)<1){f[d>>2]=0;f[d+4>>2]=0;g=c$(d,35)|0;h=338779;i=g+35|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j$(-211,d,338815,338846,114);d$(d)}d=_F(e)|0;F1a(d|0,0,e|0)|0;f[d+32>>2]=d+40;f[d>>2]=1112539136;f[d+4>>2]=a;u=c;return d|0}function eta(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0.0,Aa=0.0,Ba=0.0,Ca=0,Da=0;h=u;u=u+144|0;i=h+112|0;j=h+84|0;k=h+56|0;l=h+52|0;m=h+48|0;o=h;f[l>>2]=0;f[m>>2]=0;q=(a|0)!=0;if(!(q?(f[a>>2]&-65536|0)==1112539136:0)){r=q?-5:-27;f[o>>2]=0;f[o+4>>2]=0;s=c$(o,26)|0;t=340827;v=s+26|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(r,o,340854,338846,411);d$(o)}if(g<=0.0){f[o>>2]=0;f[o+4>>2]=0;s=c$(o,22)|0;t=340890;v=s+22|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-211,o,340854,338846,414);d$(o)}r=F0(c,i,l,0)|0;i=F0(d,j,m,0)|0;if(f[m>>2]|f[l>>2]|0){f[o>>2]=0;f[o+4>>2]=0;s=c$(o,20)|0;t=340913;v=s+20|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-24,o,340854,338846,420);d$(o)}l=r+20|0;if(!((f[l>>2]|0)==(f[i+20>>2]|0)?(f[r+24>>2]|0)==(f[i+24>>2]|0):0)){f[o>>2]=0;f[o+4>>2]=0;s=c$(o,43)|0;t=340934;v=s+43|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-209,o,340854,338846,423);d$(o)}if(!((f[i>>2]&4095|0)==6?(f[r>>2]&4095|0)==4:0)){f[o>>2]=0;f[o+4>>2]=0;s=c$(o,77)|0;t=340978;v=s+77|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-210,o,340854,338846,428);d$(o)}j=a+36|0;d=f[j>>2]|0;if(!d){fta(a);w=f[j>>2]|0}else w=d;if(!(f[w+4>>2]|0)){x=r+4|0;y=e}else{d=F0(e,k,m,0)|0;if((f[d>>2]&4095|0)!=4){f[o>>2]=0;f[o+4>>2]=0;s=c$(o,77)|0;t=340978;v=s+77|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-210,o,340854,338846,441);d$(o)}m=r+4|0;if((f[m>>2]|0)!=(f[d+4>>2]|0)){f[o>>2]=0;f[o+4>>2]=0;s=c$(o,62)|0;t=341056;v=s+62|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-209,o,340854,338846,445);d$(o)}if(!((f[l>>2]|0)==(f[d+20>>2]|0)?(f[r+24>>2]|0)==(f[d+24>>2]|0):0)){f[o>>2]=0;f[o+4>>2]=0;s=c$(o,43)|0;t=340934;v=s+43|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-209,o,340854,338846,448);d$(o)}t=w+72|0;f[t>>2]=f[d>>2];f[t+4>>2]=f[d+4>>2];f[t+8>>2]=f[d+8>>2];f[t+12>>2]=f[d+12>>2];f[t+16>>2]=f[d+16>>2];f[t+20>>2]=f[d+20>>2];f[t+24>>2]=f[d+24>>2];x=m;y=d}p[a+24>>3]=g;d=a+8|0;m=rNa(+(f[d>>2]|0)*g)|0;f[a+16>>2]=m;m=a+12|0;t=rNa(+(f[m>>2]|0)*g)|0;f[a+20>>2]=t;t=w+16|0;f[t>>2]=f[r>>2];f[t+4>>2]=f[r+4>>2];f[t+8>>2]=f[r+8>>2];f[t+12>>2]=f[r+12>>2];f[t+16>>2]=f[r+16>>2];f[t+20>>2]=f[r+20>>2];f[t+24>>2]=f[r+24>>2];t=w+44|0;f[t>>2]=f[i>>2];f[t+4>>2]=f[i+4>>2];f[t+8>>2]=f[i+8>>2];f[t+12>>2]=f[i+12>>2];f[t+16>>2]=f[i+16>>2];f[t+20>>2]=f[i+20>>2];f[t+24>>2]=f[i+24>>2];t=rNa(g)|0;l=rNa(+((f[d>>2]|0)+-2|0)*g)|0;d=rNa(+((f[m>>2]|0)+-2|0)*g)|0;z=1.0/+(Y(d,l)|0);p[w+8>>3]=z;m=r+16|0;r=f[x>>2]|0;k=Y(r,t)|0;e=t<<2;f[w+120>>2]=(f[m>>2]|0)+k+e;j=l+t|0;l=j<<2;f[w+124>>2]=(f[m>>2]|0)+k+l;k=d+t|0;d=Y(r,k)|0;f[w+128>>2]=(f[m>>2]|0)+d+e;f[w+132>>2]=(f[m>>2]|0)+d+l;l=i+16|0;d=f[i+4>>2]|0;i=Y(d,t)|0;e=t<<3;f[w+104>>2]=(f[l>>2]|0)+i+e;t=j<<3;f[w+108>>2]=(f[l>>2]|0)+i+t;i=Y(d,k)|0;f[w+112>>2]=(f[l>>2]|0)+i+e;f[w+116>>2]=(f[l>>2]|0)+i+t;t=f[a+4>>2]|0;if((t|0)<=0){u=h;return}i=w+100|0;w=a+32|0;a=o+4|0;l=o+8|0;e=o+12|0;k=y+16|0;d=y+4|0;y=o+16|0;j=o+24|0;r=o+28|0;c=o+20|0;q=o+32|0;A=o+40|0;B=o+44|0;C=o+36|0;D=f[i>>2]|0;E=0;while(1){if((f[D+(E*28|0)>>2]|0)>0){F=D;G=0;while(1){H=f[F+(E*28|0)+8>>2]|0;if((f[H+(G*12|0)>>2]|0)>0){I=H;H=F;J=0;while(1){K=f[(f[(f[w>>2]|0)+(E*24|0)+8>>2]|0)+(G*24|0)+4>>2]|0;L=f[I+(G*12|0)+4>>2]|0;s=o;v=s+48|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(v|0));if(f[L+(J*72|0)>>2]|0){M=K+(J<<6)+4|0;f[o>>2]=f[M>>2];f[o+4>>2]=f[M+4>>2];f[o+8>>2]=f[M+8>>2];f[o+12>>2]=f[M+12>>2];M=f[l>>2]|0;N=M+-1|0;O=f[o>>2]|0;P=f[e>>2]|0;Q=P+-1|0;R=f[a>>2]|0;if(f[L+(J*72|0)+20>>2]|0){S=K+(J<<6)+24|0;f[y>>2]=f[S>>2];f[y+4>>2]=f[S+4>>2];f[y+8>>2]=f[S+8>>2];f[y+12>>2]=f[S+12>>2];S=(f[j>>2]|0)+-1|0;T=(N>>>0>=S>>>0?S^N:0)^N;S=(f[y>>2]|0)-O+-1|0;U=(T>>>0>=S>>>0?T^S:0)^T;T=(f[r>>2]|0)+-1|0;S=(Q>>>0>=T>>>0?T^Q:0)^Q;T=(f[c>>2]|0)-R+-1|0;V=(S>>>0>=T>>>0?S^T:0)^S;if(!(f[L+(J*72|0)+40>>2]|0)){W=M;X=P;Z=O;_=R;$=V;aa=U;ba=2}else{S=K+(J<<6)+44|0;f[q>>2]=f[S>>2];f[q+4>>2]=f[S+4>>2];f[q+8>>2]=f[S+8>>2];f[q+12>>2]=f[S+12>>2];S=(f[A>>2]|0)+-1|0;T=(U>>>0>=S>>>0?S^U:0)^U;U=(f[q>>2]|0)-O+-1|0;S=(f[B>>2]|0)+-1|0;ca=(V>>>0>=S>>>0?S^V:0)^V;V=(f[C>>2]|0)-R+-1|0;W=M;X=P;Z=O;_=R;$=(ca>>>0>=V>>>0?ca^V:0)^ca;aa=(T>>>0>=U>>>0?T^U:0)^T;ba=3}}else{W=M;X=P;Z=O;_=R;$=Q;aa=N;ba=1}}else{W=0;X=0;Z=0;_=0;$=-1;aa=-1;ba=0}N=aa+1|0;Q=$+1|0;R=(W|0)/(N|0)|0;O=(X|0)/(Q|0)|0;if((R|0)<1){P=(rNa(+(W|0)*g)|0)/(R|0)|0;da=1;ea=P;fa=rNa(+(Z|0)*g)|0}else{da=0;ea=0;fa=0}if((O|0)<1){P=(rNa(+(X|0)*g)|0)/(O|0)|0;ga=1;ha=P;ia=rNa(+(_|0)*g)|0}else{ga=0;ha=0;ia=0}if(!ba){ja=H;ka=0.0;la=0.0}else{P=(da|0)==0;O=(ga|0)==0;R=(f[K+(J<<6)>>2]|0)!=0;ma=z*(R?.5:1.0);M=Z;T=W;na=0.0;U=0;oa=0.0;while(1){if(P){ca=rNa(+(M|0)*g)|0;pa=rNa(+(T|0)*g)|0;qa=ca}else{pa=(Y(T,ea)|0)/(N|0)|0;qa=((Y(M-Z|0,ea)|0)/(N|0)|0)+fa|0}ca=f[o+(U<<4)+4>>2]|0;V=f[o+(U<<4)+12>>2]|0;if(O){S=rNa(+(ca|0)*g)|0;ra=rNa(+(V|0)*g)|0;sa=S}else{ra=(Y(V,ha)|0)/(Q|0)|0;sa=((Y(ca-_|0,ha)|0)/(Q|0)|0)+ia|0}ca=qa<<2;V=pa+qa|0;S=ra+sa|0;ta=V<<2;if(R){ua=f[d>>2]|0;va=sa+pa|0;wa=(f[k>>2]|0)+(Y(ua,va)|0)+ta|0;f[L+(J*72|0)+(U*20|0)+8>>2]=wa;wa=(f[k>>2]|0)+(Y(ua,va+ra|0)|0)+(V-ra<<2)|0;f[L+(J*72|0)+(U*20|0)+12>>2]=wa;wa=(f[k>>2]|0)+(Y(ua,sa)|0)+ca|0;f[L+(J*72|0)+(U*20|0)>>2]=wa;xa=(f[k>>2]|0)+(Y(ua,S)|0)+(qa-ra<<2)|0;ya=L+(J*72|0)+(U*20|0)+4|0}else{ua=f[x>>2]|0;wa=Y(ua,sa)|0;f[L+(J*72|0)+(U*20|0)>>2]=(f[m>>2]|0)+wa+ca;f[L+(J*72|0)+(U*20|0)+4>>2]=(f[m>>2]|0)+wa+ta;wa=Y(ua,S)|0;f[L+(J*72|0)+(U*20|0)+8>>2]=(f[m>>2]|0)+wa+ca;xa=(f[m>>2]|0)+wa+ta|0;ya=L+(J*72|0)+(U*20|0)+12|0}f[ya>>2]=xa;za=ma*+n[K+(J<<6)+4+(U*20|0)+16>>2];n[L+(J*72|0)+(U*20|0)+16>>2]=za;if(!U){Aa=+(Y(ra,pa)|0);Ba=oa}else{Aa=na;Ba=oa+ +(ra|0)*(+(pa|0)*za)}ta=U+1|0;if((ta|0)==(ba|0))break;M=f[o+(ta<<4)>>2]|0;T=f[o+(ta<<4)+8>>2]|0;na=Aa;U=ta;oa=Ba}ja=f[i>>2]|0;ka=Aa;la=Ba}n[L+(J*72|0)+16>>2]=-la/ka;J=J+1|0;I=f[ja+(E*28|0)+8>>2]|0;if((J|0)>=(f[I+(G*12|0)>>2]|0)){Ca=ja;break}else H=ja}}else Ca=F;G=G+1|0;if((G|0)>=(f[Ca+(E*28|0)>>2]|0)){Da=Ca;break}else F=Ca}}else Da=D;E=E+1|0;if((E|0)>=(t|0))break;else D=Da}u=h;return}function fta(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0;c=u;u=u+1040|0;d=c+8|0;e=c;g=c+32|0;h=c+24|0;i=(a|0)!=0;if(!(i?(f[a>>2]&-65536|0)==1112539136:0)){j=i?-5:-27;f[h>>2]=0;f[h+4>>2]=0;k=c$(h,26)|0;l=340827;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(j,h,341119,338846,174);d$(h)}j=a+36|0;if(f[j>>2]|0){f[h>>2]=0;f[h+4>>2]=0;k=c$(h,36)|0;l=341153;m=k+36|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-2,h,341119,338846,177);d$(h)}i=a+32|0;if(!(f[i>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;j$(-27,h,341119,338846,180);d$(h)}o=a+4|0;if((f[o>>2]|0)<1){f[h>>2]=0;f[h+4>>2]=0;k=c$(h,33)|0;l=341190;m=k+33|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-211,h,341119,338846,183);d$(h);l=f[o>>2]|0;p=a+8|0;if((l|0)>0){q=f[p>>2]|0;r=f[p+4>>2]|0;s=11}else{t=l;v=0;w=0;x=0}}else{l=a+8|0;q=f[l>>2]|0;r=f[l+4>>2]|0;s=11}if((s|0)==11){l=h+4|0;a=h+4|0;p=0;y=0;z=0;A=0;while(1){B=f[i>>2]|0;C=B+(y*24|0)|0;D=B+(y*24|0)+8|0;if((f[D>>2]|0)!=0?(B=f[C>>2]|0,(B|0)>=1):0){E=B+z|0;F=C;s=18}else{f[e>>2]=y;SLa(g,341224,e)|0;f[h>>2]=0;f[l>>2]=0;B=xKa(g)|0;if(B|0)K1a(c$(h,B)|0,g|0,B|0)|0;j$(-2,h,341119,338846,198);d$(h);B=f[C>>2]|0;G=B+z|0;if((B|0)>0){E=G;F=C;s=18}else{H=G;I=p;J=A}}if((s|0)==18){s=0;G=p;C=0;B=A;while(1){K=f[D>>2]|0;M=K+(C*24|0)|0;N=f[M>>2]|0;O=N+B|0;if((N|0)>0){N=K+(C*24|0)+4|0;K=G;P=0;while(1){Q=K;R=0;while(1){S=f[N>>2]|0;T=f[S+(P<<6)+4+(R*20|0)+8>>2]|0;a:do if(!T)U=Q;else{V=f[S+(P<<6)+4+(R*20|0)>>2]|0;W=f[S+(P<<6)+4+(R*20|0)+4>>2]|0;X=f[S+(P<<6)+4+(R*20|0)+12>>2]|0;Y=(f[S+(P<<6)>>2]|0)!=0;Z=Q|Y;do if(!((V+T|0)>(q|0)|(W|T|X|0)<0)){if(!Y)if((V|0)<0|(X+W|0)>(r|0))break;else{U=Z;break a}if((V|0)>=(X|0)?(W+T+X|0)<=(r|0):0){U=Z;break a}}while(0);f[d>>2]=R;f[d+4>>2]=C;f[d+8>>2]=y;SLa(g,341322,d)|0;f[h>>2]=0;f[a>>2]=0;X=xKa(g)|0;if(X|0)K1a(c$(h,X)|0,g|0,X|0)|0;j$(-27,h,341119,338846,230);d$(h);U=Z}while(0);R=R+1|0;if((R|0)>=3)break;else Q=U}P=P+1|0;if((P|0)>=(f[M>>2]|0)){_=U;break}else K=U}}else _=G;C=C+1|0;if((C|0)>=(f[F>>2]|0)){H=E;I=_;J=O;break}else{G=_;B=O}}}y=y+1|0;B=f[o>>2]|0;if((y|0)>=(B|0)){t=B;v=I;w=H;x=J;break}else{p=I;z=H;A=J}}}J=_F((x*72|0)+144+(w*12|0)+(w+x<<2)+(t*28|0)|0)|0;F1a(J+8|0,0,136)|0;t=f[o>>2]|0;f[J>>2]=t;x=J+144|0;A=J+100|0;f[A>>2]=x;H=x+(t*28|0)|0;z=J+141|0;b[z>>0]=1;f[J+4>>2]=v&1;v=J+140|0;b[v>>0]=0;if((t|0)<=0){f[j>>2]=J;$F(0);$F(0);$F(0);$F(0);$F(0);$F(0);u=c;return}I=x;x=t;t=H;p=H+(w*12|0)|0;w=0;while(1){H=f[i>>2]|0;y=H+(w*24|0)|0;_=f[y>>2]|0;f[I+(w*28|0)>>2]=_;n[I+(w*28|0)+4>>2]=+n[H+(w*24|0)+4>>2]+-9.999999747378752e-05;E=I+(w*28|0)+8|0;f[E>>2]=t;F=I+(w*28|0)+12|0;f[F>>2]=1;U=t+(_*12|0)|0;h=f[H+(w*24|0)+20>>2]|0;f[I+(w*28|0)+24>>2]=(h|0)==-1?0:I+(h*28|0)|0;h=f[H+(w*24|0)+12>>2]|0;g=(h|0)==-1?0:I+(h*28|0)|0;f[I+(w*28|0)+16>>2]=g;h=f[H+(w*24|0)+16>>2]|0;f[I+(w*28|0)+20>>2]=(h|0)==-1?0:I+(h*28|0)|0;b[v>>0]=(g|0)!=0|b[v>>0];if((_|0)>0){_=H+(w*24|0)+8|0;H=t;g=p;h=0;while(1){a=f[_>>2]|0;d=f[a+(h*24|0)>>2]|0;r=g+(d*72|0)|0;f[H+(h*12|0)>>2]=d;q=H+(h*12|0)+4|0;f[q>>2]=g;f[H+(h*12|0)+8>>2]=r;b:do if((d|0)>0){s=a+(h*24|0)+4|0;l=a+(h*24|0)+8|0;e=a+(h*24|0)+12|0;B=a+(h*24|0)+16|0;G=g;C=0;while(1){D=f[s>>2]|0;k=G+(C*72|0)|0;m=k+72|0;do{f[k>>2]=-1;k=k+4|0}while((k|0)<(m|0));f[G+(C*72|0)+60>>2]=f[(f[l>>2]|0)+(C<<2)>>2];f[G+(C*72|0)+64>>2]=f[(f[e>>2]|0)+(C<<2)>>2];f[G+(C*72|0)+68>>2]=f[(f[B>>2]|0)+(C<<2)>>2];if((!(+L(+(+n[D+(C<<6)+60>>2]))<2.220446049250313e-16)?(f[D+(C<<6)+52>>2]|0)!=0:0)?(f[D+(C<<6)+56>>2]|0)!=0:0)f[F>>2]=0;else{K=G+(C*72|0)+40|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;f[K+16>>2]=0}K=C+1|0;if((K|0)==(d|0))break b;G=f[q>>2]|0;C=K}}while(0);K1a(r|0,f[a+(h*24|0)+20>>2]|0,(d<<2)+4|0)|0;$=r+(d<<2)+4+3&-4;b[z>>0]=(d|0)==1&(b[z>>0]|0)!=0&1;q=h+1|0;if((q|0)>=(f[y>>2]|0))break;H=f[E>>2]|0;g=$;h=q}aa=f[o>>2]|0;ba=$}else{aa=x;ba=p}h=w+1|0;if((h|0)>=(aa|0))break;I=f[A>>2]|0;x=aa;t=U;p=ba;w=h}f[j>>2]=J;$F(0);$F(0);$F(0);$F(0);$F(0);$F(0);u=c;return}function gta(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0.0,s=0.0,t=0.0,v=0.0,w=0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0.0;h=u;u=u+16|0;i=h;j=(a|0)!=0;if(!(j?(f[a>>2]&-65536|0)==1112539136:0)){k=j?-5:-27;f[i>>2]=0;f[i+4>>2]=0;l=c$(i,23)|0;m=341440;o=l+23|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));j$(k,i,341464,338846,684);d$(i)}k=f[a+36>>2]|0;if(!k){f[i>>2]=0;f[i+4>>2]=0;l=c$(i,76)|0;m=341494;o=l+76|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));j$(-27,i,341464,338846,689);d$(i)}if((d|c|0)<0){q=-1;u=h;return q|0}if(((f[a+16>>2]|0)+c|0)>=(f[k+40>>2]|0)){q=-1;u=h;return q|0}if(((f[a+20>>2]|0)+d|0)>=(f[k+36>>2]|0)){q=-1;u=h;return q|0}a=(Y((f[k+20>>2]|0)>>>2,d)|0)+c|0;i=(Y((f[k+48>>2]|0)>>>3,d)|0)+c|0;r=+p[k+8>>3];s=r*+((f[(f[k+120>>2]|0)+(a<<2)>>2]|0)-(f[(f[k+124>>2]|0)+(a<<2)>>2]|0)-(f[(f[k+128>>2]|0)+(a<<2)>>2]|0)+(f[(f[k+132>>2]|0)+(a<<2)>>2]|0)|0);t=r*(+p[(f[k+104>>2]|0)+(i<<3)>>3]-+p[(f[k+108>>2]|0)+(i<<3)>>3]-+p[(f[k+112>>2]|0)+(i<<3)>>3]+ +p[(f[k+116>>2]|0)+(i<<3)>>3])-s*s;if(!(t>=0.0))v=1.0;else v=+M(+t);if(b[k+140>>0]|0){i=f[k+100>>2]|0;if(!i){q=1;u=h;return q|0}else w=i;a:while(1){p[e>>3]=0.0;i=f[w>>2]|0;if((i|0)>0){c=f[w+8>>2]|0;t=0.0;d=0;while(1){s=+hta(c+(d*12|0)|0,v,a)+t;p[e>>3]=s;d=d+1|0;if((d|0)>=(i|0)){x=s;break}else t=s}}else x=0.0;if(x>=+n[w+4>>2]){i=f[w+20>>2]|0;if(!i){q=1;y=43;break}else{w=i;continue}}else z=w;while(1){i=f[z+16>>2]|0;if(i|0){w=i;continue a}z=f[z+24>>2]|0;if(!z){q=0;y=43;break a}}}if((y|0)==43){u=h;return q|0}}z=f[k>>2]|0;w=(z|0)>(g|0);if(!(b[k+141>>0]|0)){if(!w){q=1;u=h;return q|0}i=f[k+100>>2]|0;d=g;while(1){p[e>>3]=0.0;c=f[i+(d*28|0)>>2]|0;if((c|0)>0){m=f[i+(d*28|0)+8>>2]|0;x=0.0;l=0;while(1){t=+hta(m+(l*12|0)|0,v,a)+x;p[e>>3]=t;l=l+1|0;if((l|0)>=(c|0)){A=t;break}else x=t}}else A=0.0;if(A<+n[i+(d*28|0)+4>>2]){q=0-d|0;y=43;break}d=d+1|0;if((d|0)>=(z|0)){q=1;y=43;break}}if((y|0)==43){u=h;return q|0}}if(!w){q=1;u=h;return q|0}w=f[k+100>>2]|0;k=g;while(1){g=f[w+(k*28|0)>>2]|0;d=(g|0)>0;if(!(f[w+(k*28|0)+12>>2]|0))if(d){i=f[w+(k*28|0)+8>>2]|0;A=0.0;c=0;while(1){l=f[i+(c*12|0)+4>>2]|0;x=+n[l+16>>2]*+((f[(f[l>>2]|0)+(a<<2)>>2]|0)-(f[(f[l+4>>2]|0)+(a<<2)>>2]|0)-(f[(f[l+8>>2]|0)+(a<<2)>>2]|0)+(f[(f[l+12>>2]|0)+(a<<2)>>2]|0)|0)+ +n[l+36>>2]*+((f[(f[l+20>>2]|0)+(a<<2)>>2]|0)-(f[(f[l+24>>2]|0)+(a<<2)>>2]|0)-(f[(f[l+28>>2]|0)+(a<<2)>>2]|0)+(f[(f[l+32>>2]|0)+(a<<2)>>2]|0)|0);m=f[l+40>>2]|0;if(!m)B=x;else B=x+ +n[l+56>>2]*+((f[m+(a<<2)>>2]|0)-(f[(f[l+44>>2]|0)+(a<<2)>>2]|0)-(f[(f[l+48>>2]|0)+(a<<2)>>2]|0)+(f[(f[l+52>>2]|0)+(a<<2)>>2]|0)|0);x=A+ +n[(f[i+(c*12|0)+8>>2]|0)+((B>=v*+n[l+60>>2]&1)<<2)>>2];c=c+1|0;if((c|0)>=(g|0)){C=x;break}else A=x}}else C=0.0;else if(d){c=f[w+(k*28|0)+8>>2]|0;A=0.0;i=0;while(1){l=f[c+(i*12|0)+4>>2]|0;x=A+ +n[(f[c+(i*12|0)+8>>2]|0)+((+n[l+16>>2]*+((f[(f[l>>2]|0)+(a<<2)>>2]|0)-(f[(f[l+4>>2]|0)+(a<<2)>>2]|0)-(f[(f[l+8>>2]|0)+(a<<2)>>2]|0)+(f[(f[l+12>>2]|0)+(a<<2)>>2]|0)|0)+ +n[l+36>>2]*+((f[(f[l+20>>2]|0)+(a<<2)>>2]|0)-(f[(f[l+24>>2]|0)+(a<<2)>>2]|0)-(f[(f[l+28>>2]|0)+(a<<2)>>2]|0)+(f[(f[l+32>>2]|0)+(a<<2)>>2]|0)|0)>=v*+n[l+60>>2]&1)<<2)>>2];i=i+1|0;if((i|0)>=(g|0)){C=x;break}else A=x}}else C=0.0;if(C<+n[w+(k*28|0)+4>>2]){y=35;break}g=k+1|0;if((g|0)<(z|0))k=g;else{y=42;break}}if((y|0)==35){p[e>>3]=C;q=0-k|0;u=h;return q|0}else if((y|0)==42){p[e>>3]=C;q=1;u=h;return q|0}return 0}function hta(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0.0,h=0,i=0.0;d=f[a+4>>2]|0;e=0;do{g=+n[d+(e*72|0)+16>>2]*+((f[(f[d+(e*72|0)>>2]|0)+(c<<2)>>2]|0)-(f[(f[d+(e*72|0)+4>>2]|0)+(c<<2)>>2]|0)-(f[(f[d+(e*72|0)+8>>2]|0)+(c<<2)>>2]|0)+(f[(f[d+(e*72|0)+12>>2]|0)+(c<<2)>>2]|0)|0)+ +n[d+(e*72|0)+36>>2]*+((f[(f[d+(e*72|0)+20>>2]|0)+(c<<2)>>2]|0)-(f[(f[d+(e*72|0)+24>>2]|0)+(c<<2)>>2]|0)-(f[(f[d+(e*72|0)+28>>2]|0)+(c<<2)>>2]|0)+(f[(f[d+(e*72|0)+32>>2]|0)+(c<<2)>>2]|0)|0);h=f[d+(e*72|0)+40>>2]|0;if(!h)i=g;else i=g+ +n[d+(e*72|0)+56>>2]*+((f[h+(c<<2)>>2]|0)-(f[(f[d+(e*72|0)+44>>2]|0)+(c<<2)>>2]|0)-(f[(f[d+(e*72|0)+48>>2]|0)+(c<<2)>>2]|0)+(f[(f[d+(e*72|0)+52>>2]|0)+(c<<2)>>2]|0)|0);e=f[(i<+n[d+(e*72|0)+60>>2]*b?d+(e*72|0)+64|0:d+(e*72|0)+68|0)>>2]|0}while((e|0)>0);return +(+n[(f[a+8>>2]|0)+(0-e<<2)>>2])}function ita(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0.0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0.0,Ub=0.0,Vb=0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0;n=u;u=u+704|0;o=n+696|0;q=n+664|0;r=n+652|0;s=n+640|0;t=n+628|0;v=n+624|0;w=n+620|0;x=n+592|0;y=n+564|0;z=n+536|0;A=n+176|0;B=n+508|0;C=n+480|0;D=n+424|0;E=n+352|0;F=n+344|0;G=n;H=n+288|0;I=n+232|0;J=n+408|0;_$(o,77524);f[r>>2]=0;K=r+4|0;f[K>>2]=0;f[r+8>>2]=0;f[s>>2]=0;L=s+4|0;f[L>>2]=0;f[s+8>>2]=0;f[t>>2]=0;M=t+4|0;f[M>>2]=0;f[t+8>>2]=0;N=(j&1|0)!=0;O=j&4;P=(O|0)!=0;Q=(j&8|0)!=0;U$(w);R=(c|0)!=0;if(!(R?(f[c>>2]&-65536|0)==1112539136:0)){f[x>>2]=0;f[x+4>>2]=0;S=c$(x,26)|0;T=341649;U=S+26|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));j$(R?-5:-27,x,341676,338846,1238);d$(x)}if(!d){f[x>>2]=0;f[x+4>>2]=0;S=c$(x,20)|0;T=341702;U=S+20|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));j$(-27,x,341676,338846,1241);d$(x)}R=F0(a,q,v,0)|0;if(f[v>>2]|0){f[x>>2]=0;f[x+4>>2]=0;S=c$(x,20)|0;T=340913;U=S+20|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));j$(-24,x,341676,338846,1245);d$(x)}if(f[R>>2]&7|0){f[x>>2]=0;f[x+4>>2]=0;S=c$(x,31)|0;T=341723;U=S+31|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));j$(-210,x,341676,338846,1248);d$(x)}if(h<=1.0){f[x>>2]=0;f[x+4>>2]=0;S=c$(x,24)|0;T=341755;U=S+24|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));j$(-211,x,341676,338846,1251);d$(x)}T=l+4|0;S=f[T>>2]|0;if((S|0)!=0?(U=f[l>>2]|0,(U|0)!=0):0){v=R+20|0;q=R+24|0;V=f[v>>2]|0;W=U;X=f[q>>2]|0;Z=S;_=q;$=v}else{v=R+20|0;q=f[v>>2]|0;f[T>>2]=q;S=R+24|0;U=f[S>>2]|0;f[l>>2]=U;V=q;W=U;X=U;Z=q;_=S;$=v}v=t0(V,X,0)|0;if(!v)aa=0;else{X=NYa(16)|0;f[X+4>>2]=1;f[X>>2]=72624;f[X+8>>2]=v;aa=X}X=t0((f[$>>2]|0)+1|0,(f[_>>2]|0)+1|0,4)|0;if(!X)ba=0;else{V=NYa(16)|0;f[V+4>>2]=1;f[V>>2]=72624;f[V+8>>2]=X;ba=V}V=t0((f[$>>2]|0)+1|0,(f[_>>2]|0)+1|0,6)|0;if(!V)ca=0;else{S=NYa(16)|0;f[S+4>>2]=1;f[S>>2]=72624;f[S+8>>2]=V;ca=S}S=c+36|0;q=f[S>>2]|0;if(!q){fta(c);da=f[S>>2]|0}else da=q;if(!(f[da+4>>2]|0)){ea=0;fa=0}else{da=t0((f[$>>2]|0)+1|0,(f[_>>2]|0)+1|0,4)|0;if(!da)ga=0;else{_=NYa(16)|0;f[_+4>>2]=1;f[_>>2]=72624;f[_+8>>2]=da;ga=_}ea=ga;fa=da}da=yL(0,56,20,d)|0;if(!(f[R>>2]&4088))ha=R;else{g6(R,v,6);ha=v}a:do if((j&6|0)==2){R=f[c+8>>2]|0;d=f[c+12>>2]|0;ga=ha+20|0;_=ha+24|0;$=t0((f[ga>>2]|0)+1|0,(f[_>>2]|0)+1|0,0)|0;if(!$)ia=0;else{q=NYa(16)|0;f[q+4>>2]=1;f[q>>2]=72624;f[q+8>>2]=$;ia=q}ja=+(R|0);ka=+(d|0);q=R+-2|0;S=d+-2|0;U=k+4|0;a=$+16|0;$=x+4|0;la=x+8|0;ma=x+12|0;na=x+16|0;oa=x+20|0;pa=x+24|0;qa=X+16|0;ra=y+4|0;sa=y+8|0;ta=y+12|0;ua=y+16|0;va=y+20|0;wa=y+24|0;xa=V+16|0;ya=z+4|0;za=z+8|0;Aa=z+12|0;Ba=z+16|0;Ca=z+20|0;Da=z+24|0;Ea=(fa|0)==0;Fa=A+4|0;Ga=A+8|0;Ha=A+12|0;Ia=A+16|0;Ja=A+20|0;Ka=A+24|0;La=v+16|0;Ma=C+4|0;Na=C+8|0;Oa=C+12|0;Pa=C+16|0;Qa=C+20|0;Ra=C+24|0;Sa=F+4|0;Ta=J+4|0;Ua=J+8|0;Va=J+12|0;Wa=I+36|0;Xa=I+16|0;Ya=I+4|0;Za=I+40|0;_a=I+44|0;$a=I+48|0;ab=H+36|0;bb=H+16|0;cb=H+4|0;db=H+40|0;eb=H+44|0;fb=H+48|0;gb=E+36|0;hb=E+16|0;ib=E+4|0;jb=E+40|0;kb=E+44|0;lb=E+48|0;mb=D+36|0;nb=D+16|0;ob=D+4|0;pb=D+40|0;qb=D+44|0;rb=D+48|0;sb=fa+16|0;tb=B+4|0;ub=B+8|0;vb=B+12|0;wb=B+16|0;xb=B+20|0;yb=B+24|0;zb=1.0;while(1){Ab=rNa(ja*zb)|0;Bb=rNa(ka*zb)|0;Cb=rNa(+(f[_>>2]|0)/zb)|0;Db=rNa(+(f[ga>>2]|0)/zb)|0;Eb=Cb-R|0;Fb=Eb+1|0;Gb=Db-d|0;Hb=Gb+1|0;if((Eb|0)<0){Ib=78;break}if((Gb|0)<0){Ib=77;break}if((Ab|0)>(f[l>>2]|0)){Ib=80;break}if((Bb|0)>(f[T>>2]|0)){Ib=79;break}do if((Ab|0)>=(f[k>>2]|0)){if((Bb|0)<(f[U>>2]|0)){Ib=75;break}Eb=f[a>>2]|0;f[x>>2]=1111638016;f[$>>2]=Cb;f[la>>2]=0;f[ma>>2]=0;f[na>>2]=Eb;f[oa>>2]=Db;f[pa>>2]=Cb;Eb=Db+1|0;Jb=Cb+1|0;Kb=f[qa>>2]|0;Lb=Jb<<2;f[y>>2]=1111638020;f[ra>>2]=Lb;f[sa>>2]=0;f[ta>>2]=0;f[ua>>2]=Kb;f[va>>2]=Eb;f[wa>>2]=Jb;Kb=f[xa>>2]|0;f[z>>2]=1111638022;f[ya>>2]=Jb<<3;f[za>>2]=0;f[Aa>>2]=0;f[Ba>>2]=Kb;f[Ca>>2]=Eb;f[Da>>2]=Jb;if(Ea)Mb=0;else{Kb=f[sb>>2]|0;f[B>>2]=1111638020;f[tb>>2]=Lb;f[ub>>2]=0;f[vb>>2]=0;f[wb>>2]=Kb;f[xb>>2]=Eb;f[yb>>2]=Jb;Mb=B}f[A>>2]=1111638021;f[Fa>>2]=Fb<<2;f[Ga>>2]=0;f[Ha>>2]=0;f[Ia>>2]=0;f[Ja>>2]=Hb;f[Ka>>2]=Fb;Jb=f[La>>2]|0;f[C>>2]=1111638016;f[Ma>>2]=Fb;f[Na>>2]=0;f[Oa>>2]=0;f[Pa>>2]=Jb;f[Qa>>2]=Hb;f[Ra>>2]=Fb;gna(ha,x,1);dqa(x,y,z,Mb);Jb=zb>2.0?1:2;Eb=((Y((Fb|0)/(Jb|0)|0,Gb+Jb|0)|0)/(Jb|0)|0)+500|0;Kb=(Eb|0)<1e3?1:(Eb|0)/1e3|0;Eb=(Kb|0)<100?Kb:100;eta(c,y,z,Mb,1.0);JR(D,A,0,1,0,0);JR(E,C,0,1,0,0);f[F>>2]=0;f[Sa>>2]=Eb;Kb=Jb+-1+((Eb+Gb|0)/(Eb|0)|0)|0;JR(H,y,0,1,0,0);JR(I,z,0,1,0,0);f[J>>2]=1;f[Ta>>2]=1;f[Ua>>2]=q;f[Va>>2]=S;jta(G,c,Kb-((Kb|0)%(Jb|0)|0)|0,zb,H,I,D,E,J,r,e,g,m,w);_U(F,G,-1.0);kta(G);Jb=f[Wa>>2]|0;do if(Jb|0){Kb=Jb+12|0;Eb=f[Kb>>2]|0;f[Kb>>2]=Eb+-1;if((Eb|0)!=1)break;CR(I)}while(0);f[Wa>>2]=0;f[Xa>>2]=0;f[Xa+4>>2]=0;f[Xa+8>>2]=0;f[Xa+12>>2]=0;if((f[Ya>>2]|0)>0){Jb=f[Za>>2]|0;Eb=0;do{f[Jb+(Eb<<2)>>2]=0;Eb=Eb+1|0}while((Eb|0)<(f[Ya>>2]|0))}Eb=f[_a>>2]|0;if((Eb|0)!=($a|0))ZF(Eb);Eb=f[ab>>2]|0;do if(Eb|0){Jb=Eb+12|0;Kb=f[Jb>>2]|0;f[Jb>>2]=Kb+-1;if((Kb|0)!=1)break;CR(H)}while(0);f[ab>>2]=0;f[bb>>2]=0;f[bb+4>>2]=0;f[bb+8>>2]=0;f[bb+12>>2]=0;if((f[cb>>2]|0)>0){Eb=f[db>>2]|0;Kb=0;do{f[Eb+(Kb<<2)>>2]=0;Kb=Kb+1|0}while((Kb|0)<(f[cb>>2]|0))}Kb=f[eb>>2]|0;if((Kb|0)!=(fb|0))ZF(Kb);Kb=f[gb>>2]|0;do if(Kb|0){Eb=Kb+12|0;Jb=f[Eb>>2]|0;f[Eb>>2]=Jb+-1;if((Jb|0)!=1)break;CR(E)}while(0);f[gb>>2]=0;f[hb>>2]=0;f[hb+4>>2]=0;f[hb+8>>2]=0;f[hb+12>>2]=0;if((f[ib>>2]|0)>0){Kb=f[jb>>2]|0;Jb=0;do{f[Kb+(Jb<<2)>>2]=0;Jb=Jb+1|0}while((Jb|0)<(f[ib>>2]|0))}Jb=f[kb>>2]|0;if((Jb|0)!=(lb|0))ZF(Jb);Jb=f[mb>>2]|0;do if(Jb|0){Kb=Jb+12|0;Eb=f[Kb>>2]|0;f[Kb>>2]=Eb+-1;if((Eb|0)!=1)break;CR(D)}while(0);f[mb>>2]=0;f[nb>>2]=0;f[nb+4>>2]=0;f[nb+8>>2]=0;f[nb+12>>2]=0;if((f[ob>>2]|0)>0){Jb=f[pb>>2]|0;Eb=0;do{f[Jb+(Eb<<2)>>2]=0;Eb=Eb+1|0}while((Eb|0)<(f[ob>>2]|0))}Eb=f[qb>>2]|0;if((Eb|0)!=(rb|0))ZF(Eb)}else Ib=75;while(0);if((Ib|0)==75)Ib=0;zb=zb*h}if((Ib|0)==77){Nb=ia;Ob=0;break}else if((Ib|0)==78){Nb=ia;Ob=0;break}else if((Ib|0)==79){Nb=ia;Ob=0;break}else if((Ib|0)==80){Nb=ia;Ob=0;break}}else{rb=fa;dqa(ha,X,V,rb);if(N){qb=ha+24|0;ob=t0((f[ha+20>>2]|0)+1|0,(f[qb>>2]|0)+1|0,4)|0;if(!ob)Pb=0;else{pb=NYa(16)|0;f[pb+4>>2]=1;f[pb>>2]=72624;f[pb+8>>2]=ob;Pb=pb}H1(ha,v,0.0,50.0,3);dqa(v,ob,0,0);Qb=qb;Rb=Pb;Sb=ob}else{Qb=ha+24|0;Rb=0;Sb=0}ob=c+8|0;qb=f[ob>>2]|0;zb=+(qb|0);pb=f[Qb>>2]|0;ka=+(pb+-10|0);if(zb<ka){ja=+(f[c+12>>2]|0);Tb=+((f[ha+20>>2]|0)+-10|0);nb=0;Ub=1.0;while(1){if(!(Ub*ja<Tb)){Vb=nb;Wb=Ub;break}mb=nb+1|0;Xb=Ub*h;if(Xb*zb<ka){nb=mb;Ub=Xb}else{Vb=mb;Wb=Xb;break}}Ub=1.0/h;ka=P?Ub:h;if((Vb|0)>0){nb=c+12|0;mb=ha+20|0;lb=k+4|0;kb=Sb;ib=kb+16|0;jb=kb+4|0;kb=x+4|0;hb=x+8|0;gb=x+12|0;fb=X+16|0;eb=X+4|0;cb=y+4|0;db=y+8|0;bb=y+12|0;ab=z+4|0;$a=A+20|0;_a=A+24|0;Ya=A+28|0;Za=A+4|0;Xa=A+8|0;Wa=A+16|0;S=A+36|0;Va=A+40|0;q=A+44|0;Ua=A+48|0;Ta=(i|0)>1?i:1;Sa=r+8|0;Ra=z+4|0;Qa=z+8|0;Pa=z+12|0;zb=Q?.6:.4;Oa=qb;Na=pb;Ma=f[k>>2]|0;La=Vb;Tb=P?Ub*Wb:1.0;Ka=0;Ja=0;Ia=0;Ha=0;while(1){Ga=La+-1|0;Ub=Tb>2.0?Tb:2.0;Fa=rNa(Tb*+(Oa|0))|0;yb=rNa(Tb*+(f[nb>>2]|0))|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;xb=rNa(+(Na-Fa|0)/Ub)|0;wb=rNa(+((f[mb>>2]|0)-yb|0)/Ub)|0;do if((Fa|0)<(Ma|0))Ib=94;else{if((yb|0)<(f[lb>>2]|0)){Ib=94;break}if((Fa|0)>(W|0)|(yb|0)>(Z|0))if(P){Yb=Ma;Zb=Ka;_b=Ja;$b=Ia;ac=Ha;break}else{Nb=0;Ob=Rb;break a}eta(c,X,V,rb,Tb);oL(v);if(N){ja=+(Fa|0);vb=rNa(ja*.15)|0;Xb=+(yb|0);ub=rNa(Xb*.15)|0;tb=rNa(ja*.7)|0;sb=rNa(Xb*.7)|0;Ea=f[ib>>2]|0;Da=f[jb>>2]|0;Ca=Ea+(Y(Da,ub)|0)+(vb<<2)|0;f[x>>2]=Ca;f[kb>>2]=Ca+(tb<<2);Ca=sb+ub|0;sb=Ea+(Y(Da,Ca)|0)+(vb<<2)|0;f[hb>>2]=sb;f[gb>>2]=sb+(tb<<2);sb=f[fb>>2]|0;Da=f[eb>>2]|0;Ea=sb+(Y(Da,ub)|0)+(vb<<2)|0;f[y>>2]=Ea;f[cb>>2]=Ea+(tb<<2);Ea=sb+(Y(Da,Ca)|0)+(vb<<2)|0;f[db>>2]=Ea;f[bb>>2]=Ea+(tb<<2)}tb=Y(Ha,Ia)|0;if((tb|0)>0){Ea=rNa(+(Ja|0)/Ub)|0;vb=rNa(+(Ha+Ja-yb|0)/Ub)|0;Ca=rNa(+(Ka|0)/Ub)|0;bc=rNa(+(Ia+Ka-Fa|0)/Ub)|0;cc=vb;dc=Ca;ec=Ea}else{bc=xb;cc=wb;dc=0;ec=0}f[z>>2]=ec;f[ab>>2]=cc;Ea=f[eb>>2]|0;f[A>>2]=77552;f[Za>>2]=c;f[$a>>2]=Fa;f[_a>>2]=yb;Ca=Ya;f[Ca>>2]=dc;f[Ca+4>>2]=bc;p[Xa>>3]=Ub;f[Wa>>2]=Ea;f[S>>2]=x;f[Va>>2]=y;f[q>>2]=r;f[Ua>>2]=w;_U(z,A,-1.0);if(!P){Yb=Ma;Zb=Ka;_b=Ja;$b=Ia;ac=Ha;break}Ea=f[r>>2]|0;Ca=f[K>>2]|0;if((Ea|0)==(Ca|0)){Yb=Ma;Zb=Ka;_b=Ja;$b=Ia;ac=Ha;break}if(tb|0){Yb=Ma;Zb=Ka;_b=Ja;$b=Ia;ac=Ha;break}tb=Ca-Ea>>4;vb=f[L>>2]|0;Da=f[s>>2]|0;sb=vb-Da>>4;ub=Da;Da=vb;do if(tb>>>0>sb>>>0){gsa(s,tb-sb|0);fc=f[r>>2]|0;gc=f[K>>2]|0}else{if(tb>>>0>=sb>>>0){fc=Ea;gc=Ca;break}vb=ub+(tb<<4)|0;if((Da|0)==(vb|0)){fc=Ea;gc=Ca;break}f[L>>2]=Da+(~((Da+-16-vb|0)>>>4)<<4);fc=Ea;gc=Ca}while(0);if((fc|0)!=(gc|0)){Ca=fc;Ea=f[s>>2]|0;while(1){f[Ea>>2]=f[Ca>>2];f[Ea+4>>2]=f[Ca+4>>2];f[Ea+8>>2]=f[Ca+8>>2];f[Ea+12>>2]=f[Ca+12>>2];Ca=Ca+16|0;if((Ca|0)==(gc|0))break;else Ea=Ea+16|0}}Bsa(s,Ta,.2);Ea=f[s>>2]|0;Ca=f[L>>2]|0;if((Ea|0)==(Ca|0)){Yb=Ma;Zb=Ka;_b=Ja;$b=Ia;ac=Ha;break}Da=Ca-Ea>>4;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if(!Da){hc=0;ic=0;jc=0;kc=0}else{Ca=0;tb=0;ub=0;sb=0;vb=0;while(1){Ba=f[Ea+(vb<<4)+8>>2]|0;Aa=f[Ea+(vb<<4)+12>>2]|0;if((Y(Aa,Ba)|0)>(Y(tb,Ca)|0)){za=f[Ea+(vb<<4)>>2]|0;f[z>>2]=za;ya=f[Ea+(vb<<4)+4>>2]|0;f[Ra>>2]=ya;f[Qa>>2]=Ba;f[Pa>>2]=Aa;lc=ya;mc=za;nc=Aa;oc=Ba}else{lc=ub;mc=sb;nc=tb;oc=Ca}vb=vb+1|0;if((vb|0)==(Da|0)){hc=mc;ic=lc;jc=oc;kc=nc;break}else{Ca=oc;tb=nc;ub=lc;sb=mc}}}sb=f[K>>2]|0;if((sb|0)==(f[Sa>>2]|0))Vra(r,z);else{f[sb>>2]=hc;f[sb+4>>2]=ic;f[sb+8>>2]=jc;f[sb+12>>2]=kc;f[K>>2]=sb+16}sb=f[z>>2]|0;ub=f[Ra>>2]|0;tb=f[Qa>>2]|0;Ca=f[Pa>>2]|0;Xb=+(tb|0);Da=rNa(Xb*.2)|0;ja=+(Ca|0);vb=rNa(ja*.2)|0;Ea=sb-Da|0;sb=(Ea|0)>0?Ea:0;Ea=ub-vb|0;ub=(Ea|0)>0?Ea:0;Ea=(Da<<1)+tb|0;tb=(f[Qb>>2]|0)+-1-sb|0;Da=(vb<<1)+Ca|0;Ca=(f[mb>>2]|0)+-1-ub|0;vb=rNa(zb*Xb)|0;f[k>>2]=vb;Ba=rNa(zb*ja)|0;f[lb>>2]=Ba;Yb=vb;Zb=sb;_b=ub;$b=(tb|0)<(Ea|0)?tb:Ea;ac=(Ca|0)<(Da|0)?Ca:Da}while(0);if((Ib|0)==94){Ib=0;if(P){Nb=0;Ob=Rb;break a}else{Yb=Ma;Zb=Ka;_b=Ja;$b=Ia;ac=Ha}}if((La|0)<=1){Nb=0;Ob=Rb;break a}Oa=f[ob>>2]|0;Na=f[Qb>>2]|0;Ma=Yb;La=Ga;Tb=ka*Tb;Ka=Zb;Ja=_b;Ia=$b;Ha=ac}}else{Nb=0;Ob=Rb}}else{Nb=0;Ob=Rb}}while(0);Rb=f[K>>2]|0;ac=f[r>>2]|0;$b=Rb-ac>>4;_b=f[L>>2]|0;Zb=f[s>>2]|0;Yb=_b-Zb>>4;Qb=Zb;Zb=_b;_b=ac;ac=Rb;if($b>>>0<=Yb>>>0)if($b>>>0<Yb>>>0?(Rb=Qb+($b<<4)|0,(Zb|0)!=(Rb|0)):0){f[L>>2]=Zb+(~((Zb+-16-Rb|0)>>>4)<<4);pc=_b;qc=ac}else{pc=_b;qc=ac}else{gsa(s,$b-Yb|0);pc=f[r>>2]|0;qc=f[K>>2]|0}if((pc|0)!=(qc|0)){Yb=pc;pc=f[s>>2]|0;while(1){f[pc>>2]=f[Yb>>2];f[pc+4>>2]=f[Yb+4>>2];f[pc+8>>2]=f[Yb+8>>2];f[pc+12>>2]=f[Yb+12>>2];Yb=Yb+16|0;if((Yb|0)==(qc|0))break;else pc=pc+16|0}}do if(O|i)if(m){Dsa(s,e,g,i,.2);break}else{Csa(s,t,(i|0)>1?i:1,.2);break}else{pc=(f[L>>2]|0)-(f[s>>2]|0)>>4;f[x>>2]=0;qc=f[M>>2]|0;Yb=f[t>>2]|0;$b=qc-Yb>>2;ac=Yb;Yb=qc;do if(pc>>>0<=$b>>>0){if(pc>>>0<$b>>>0){qc=ac+(pc<<2)|0;if((Yb|0)==(qc|0))break;f[M>>2]=Yb+(~((Yb+-4-qc|0)>>>2)<<2)}}else Gs(t,pc-$b|0,x);while(0)}while(0);i=f[L>>2]|0;g=f[s>>2]|0;e=(i|0)==(g|0);if(P){P=g;if(!e){m=x+4|0;O=x+8|0;$b=x+12|0;pc=x+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[x+16>>2]=0;Yb=f[t>>2]|0;ac=i-g>>4;i=0;qc=0;_b=0;while(1){Rb=f[P+(_b<<4)+8>>2]|0;Zb=f[P+(_b<<4)+12>>2]|0;if((Y(Zb,Rb)|0)>(Y(qc,i)|0)){Qb=f[P+(_b<<4)+4>>2]|0;f[x>>2]=f[P+(_b<<4)>>2];f[m>>2]=Qb;f[O>>2]=Rb;f[$b>>2]=Zb;f[pc>>2]=f[Yb+(_b<<2)>>2];rc=Zb;sc=Rb}else{rc=qc;sc=i}_b=_b+1|0;if(_b>>>0>=ac>>>0)break;else{i=sc;qc=rc}}NL(da,x)|0}}else if(!e){e=x+4|0;rc=x+8|0;qc=x+12|0;sc=x+16|0;i=g;g=0;do{ac=i;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;_b=f[ac+(g<<4)+4>>2]|0;Yb=f[ac+(g<<4)+8>>2]|0;pc=f[ac+(g<<4)+12>>2]|0;f[x>>2]=f[ac+(g<<4)>>2];f[e>>2]=_b;f[rc>>2]=Yb;f[qc>>2]=pc;pc=f[t>>2]|0;if((pc|0)==(f[M>>2]|0))tc=0;else tc=f[pc+(g<<2)>>2]|0;f[sc>>2]=tc;NL(da,x)|0;g=g+1|0;i=f[s>>2]|0}while(g>>>0<(f[L>>2]|0)-i>>4>>>0)}V$(w);w=f[t>>2]|0;if(w|0){t=f[M>>2]|0;if((t|0)!=(w|0))f[M>>2]=t+(~((t+-4-w|0)>>>2)<<2);PYa(w)}w=f[s>>2]|0;if(w|0){s=f[L>>2]|0;if((s|0)!=(w|0))f[L>>2]=s+(~((s+-16-w|0)>>>4)<<4);PYa(w)}w=f[r>>2]|0;if(w|0){r=f[K>>2]|0;if((r|0)!=(w|0))f[K>>2]=r+(~((r+-16-w|0)>>>4)<<4);PYa(w)}w=Nb;do if(Nb|0){r=w+4|0;K=f[r>>2]|0;f[r>>2]=K+-1;if((K|0)!=1)break;ki[f[(f[Nb>>2]|0)+8>>2]&2047](w)}while(0);w=Ob;do if(Ob|0){Nb=w+4|0;K=f[Nb>>2]|0;f[Nb>>2]=K+-1;if((K|0)!=1)break;ki[f[(f[Ob>>2]|0)+8>>2]&2047](w)}while(0);w=ca;do if(ca|0){Ob=w+4|0;K=f[Ob>>2]|0;f[Ob>>2]=K+-1;if((K|0)!=1)break;ki[f[(f[ca>>2]|0)+8>>2]&2047](w)}while(0);w=ea;do if(ea|0){ca=w+4|0;K=f[ca>>2]|0;f[ca>>2]=K+-1;if((K|0)!=1)break;ki[f[(f[ea>>2]|0)+8>>2]&2047](w)}while(0);w=ba;do if(ba|0){ea=w+4|0;K=f[ea>>2]|0;f[ea>>2]=K+-1;if((K|0)!=1)break;ki[f[(f[ba>>2]|0)+8>>2]&2047](w)}while(0);w=aa;do if(aa|0){ba=w+4|0;K=f[ba>>2]|0;f[ba>>2]=K+-1;if((K|0)!=1)break;ki[f[(f[aa>>2]|0)+8>>2]&2047](w)}while(0);if(!(f[o+4>>2]|0)){u=n;return da|0}u=n;return da|0}function jta(a,b,c,d,e,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;f[a>>2]=77592;q=a+24|0;f[q>>2]=1124007936;r=a+28|0;s=a+32|0;t=a+64|0;u=r;v=u+36|0;do{f[u>>2]=0;u=u+4|0}while((u|0)<(v|0));f[t>>2]=s;w=a+72|0;x=a+68|0;f[x>>2]=w;f[w>>2]=0;f[a+76>>2]=0;w=a+80|0;f[w>>2]=1124007936;y=a+84|0;z=a+88|0;A=a+120|0;u=y;v=u+36|0;do{f[u>>2]=0;u=u+4|0}while((u|0)<(v|0));f[A>>2]=z;u=a+128|0;v=a+124|0;f[v>>2]=u;f[u>>2]=0;f[a+132>>2]=0;u=a+144|0;f[u>>2]=0;f[u+4>>2]=0;f[u+8>>2]=0;f[u+12>>2]=0;f[a+4>>2]=b;f[a+8>>2]=c;p[a+16>>3]=d;if((q|0)!=(e|0)){c=e+36|0;b=f[c>>2]|0;if(b){B=b+12|0;f[B>>2]=(f[B>>2]|0)+1;B=a+60|0;b=f[B>>2]|0;if((b|0)!=0?(C=b+12|0,b=f[C>>2]|0,f[C>>2]=b+-1,(b|0)==1):0){CR(q);D=B}else D=B}else D=a+60|0;f[D>>2]=0;B=a+40|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[r>>2]|0)>0){b=f[t>>2]|0;t=0;do{f[b+(t<<2)>>2]=0;t=t+1|0;E=f[r>>2]|0}while((t|0)<(E|0));f[q>>2]=f[e>>2];if((E|0)<3)F=12;else F=14}else{f[q>>2]=f[e>>2];F=12}if((F|0)==12){E=f[e+4>>2]|0;if((E|0)<3){f[r>>2]=E;f[s>>2]=f[e+8>>2];f[a+36>>2]=f[e+12>>2];s=f[e+44>>2]|0;E=f[x>>2]|0;f[E>>2]=f[s>>2];f[E+4>>2]=f[s+4>>2]}else F=14}if((F|0)==14)BR(q,e);f[B>>2]=f[e+16>>2];f[a+44>>2]=f[e+20>>2];f[a+48>>2]=f[e+24>>2];f[a+52>>2]=f[e+28>>2];f[a+56>>2]=f[e+32>>2];f[D>>2]=f[c>>2]}if((w|0)==(g|0)){G=a+136|0;f[G>>2]=h;H=a+140|0;f[H>>2]=i;I=f[j>>2]|0;f[u>>2]=I;J=j+4|0;K=f[J>>2]|0;L=a+148|0;f[L>>2]=K;M=j+8|0;N=f[M>>2]|0;O=a+152|0;f[O>>2]=N;P=j+12|0;Q=f[P>>2]|0;R=a+156|0;f[R>>2]=Q;S=a+160|0;f[S>>2]=k;T=n?l:0;U=a+164|0;f[U>>2]=T;V=n?m:0;W=a+168|0;f[W>>2]=V;X=a+172|0;f[X>>2]=o;return}c=g+36|0;D=f[c>>2]|0;if(D|0){e=D+12|0;f[e>>2]=(f[e>>2]|0)+1}e=a+116|0;D=f[e>>2]|0;if(D|0?(B=D+12|0,D=f[B>>2]|0,f[B>>2]=D+-1,(D|0)==1):0)CR(w);f[e>>2]=0;D=a+96|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[y>>2]|0)>0){B=f[A>>2]|0;A=0;do{f[B+(A<<2)>>2]=0;A=A+1|0;Y=f[y>>2]|0}while((A|0)<(Y|0));f[w>>2]=f[g>>2];if((Y|0)<3)F=27;else F=29}else{f[w>>2]=f[g>>2];F=27}if((F|0)==27){Y=f[g+4>>2]|0;if((Y|0)<3){f[y>>2]=Y;f[z>>2]=f[g+8>>2];f[a+92>>2]=f[g+12>>2];z=f[g+44>>2]|0;Y=f[v>>2]|0;f[Y>>2]=f[z>>2];f[Y+4>>2]=f[z+4>>2]}else F=29}if((F|0)==29)BR(w,g);f[D>>2]=f[g+16>>2];f[a+100>>2]=f[g+20>>2];f[a+104>>2]=f[g+24>>2];f[a+108>>2]=f[g+28>>2];f[a+112>>2]=f[g+32>>2];f[e>>2]=f[c>>2];G=a+136|0;f[G>>2]=h;H=a+140|0;f[H>>2]=i;I=f[j>>2]|0;f[u>>2]=I;J=j+4|0;K=f[J>>2]|0;L=a+148|0;f[L>>2]=K;M=j+8|0;N=f[M>>2]|0;O=a+152|0;f[O>>2]=N;P=j+12|0;Q=f[P>>2]|0;R=a+156|0;f[R>>2]=Q;S=a+160|0;f[S>>2]=k;T=n?l:0;U=a+164|0;f[U>>2]=T;V=n?m:0;W=a+168|0;f[W>>2]=V;X=a+172|0;f[X>>2]=o;return}function kta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=77592;b=a+80|0;c=a+116|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+96|0;b=a+84|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+120>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+124>>2]|0;if((b|0)!=(a+128|0))ZF(b);b=a+24|0;d=a+60|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+40|0;b=a+28|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+64>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0))return;ZF(b);return}function lta(a){a=a|0;PYa(a);return}function mta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0.0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;c=u;u=u+80|0;d=c+64|0;e=c;g=c+56|0;h=c+32|0;i=c+12|0;j=c+52|0;k=c+48|0;l=c+44|0;m=c+40|0;n=c+24|0;o=c+8|0;_$(h,77564);q=f[b>>2]|0;r=f[b+4>>2]|0;b=f[a+36>>2]|0;s=f[b>>2]|0;t=f[b+4>>2]|0;v=f[b+8>>2]|0;w=f[b+12>>2]|0;b=f[a+40>>2]|0;x=f[b>>2]|0;y=f[b+4>>2]|0;z=f[b+8>>2]|0;A=f[b+12>>2]|0;b=(s|0)==0;B=(f[a+16>>2]|0)>>>2;f[i>>2]=0;C=i+4|0;f[C>>2]=0;f[i+8>>2]=0;if((q|0)<(r|0)){D=a+8|0;E=a+28|0;F=a+32|0;G=a+4|0;H=d+4|0;H=a+20|0;I=a+24|0;J=d+4|0;K=d+8|0;L=d+12|0;M=i+8|0;N=a+48|0;O=a+44|0;P=f[F>>2]|0;Q=q;while(1){R=+p[D>>3];q=rNa(+(Q|0)*R)|0;S=f[E>>2]|0;a:do if((S|0)<(P|0)){T=Y(q,B)|0;U=R;V=P;W=S;while(1){X=rNa(+(W|0)*U)|0;if(!b?(Z=X+T|0,((f[s+(Z<<2)>>2]|0)-(f[t+(Z<<2)>>2]|0)-(f[v+(Z<<2)>>2]|0)+(f[w+(Z<<2)>>2]|0)|0)<100?1:((f[x+(Z<<2)>>2]|0)-(f[y+(Z<<2)>>2]|0)-(f[z+(Z<<2)>>2]|0)+(f[A+(Z<<2)>>2]|0)|0)<20):0){_=V;$=2}else{Z=f[G>>2]|0;_$(d,77504);aa=gta(Z,X,q,e,0)|0;if((aa|0)>0){Z=f[H>>2]|0;ba=f[I>>2]|0;f[d>>2]=X;f[J>>2]=q;f[K>>2]=Z;f[L>>2]=ba;ca=f[C>>2]|0;if((ca|0)==(f[M>>2]|0)){Vra(i,d);da=f[C>>2]|0}else{f[ca>>2]=X;f[ca+4>>2]=q;f[ca+8>>2]=Z;f[ca+12>>2]=ba;ba=ca+16|0;f[C>>2]=ba;da=ba}if(da-(f[i>>2]|0)>>4>>>0>99?(W$(f[N>>2]|0),ba=f[O>>2]|0,f[j>>2]=f[ba+4>>2],f[k>>2]=f[i>>2],f[l>>2]=f[C>>2],f[g>>2]=f[j>>2],f[e>>2]=f[k>>2],f[d>>2]=f[l>>2],nta(ba,g,e,d)|0,X$(f[N>>2]|0),ba=f[i>>2]|0,ca=f[C>>2]|0,(ca|0)!=(ba|0)):0)f[C>>2]=ca+(~((ca+-16-ba|0)>>>4)<<4)}_=f[F>>2]|0;$=aa|0?1:2}aa=$+W|0;if((aa|0)>=(_|0)){ea=_;break a}U=+p[D>>3];V=_;W=aa}}else ea=P;while(0);Q=Q+1|0;if((Q|0)>=(r|0))break;else P=ea}ea=f[i>>2]|0;if((f[C>>2]|0)==(ea|0))fa=ea;else{ea=a+48|0;W$(f[ea>>2]|0);P=f[a+44>>2]|0;f[m>>2]=f[P+4>>2];f[n>>2]=f[i>>2];f[o>>2]=f[C>>2];f[g>>2]=f[m>>2];f[e>>2]=f[n>>2];f[d>>2]=f[o>>2];nta(P,g,e,d)|0;X$(f[ea>>2]|0);fa=f[i>>2]|0}if(fa|0){i=f[C>>2]|0;if((i|0)!=(fa|0))f[C>>2]=i+(~((i+-16-fa|0)>>>4)<<4);PYa(fa)}}if(!(f[h+4>>2]|0)){u=c;return}u=c;return}function nta(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=f[a>>2]|0;g=e;h=(f[b>>2]|0)-g|0;b=h>>4;i=e+(b<<4)|0;j=f[c>>2]|0;c=f[d>>2]|0;d=c-j|0;k=d>>4;l=j;m=c;if((d|0)<=0){n=i;return n|0}d=a+8|0;o=f[d>>2]|0;p=a+4|0;q=f[p>>2]|0;r=q;if((k|0)<=(o-r>>4|0)){s=i;t=r-s|0;u=t>>4;if((k|0)>(u|0)){v=l+(u<<4)|0;u=v;if((v|0)==(m|0))w=q;else{x=m+-16-u|0;y=v;v=q;while(1){f[v>>2]=f[y>>2];f[v+4>>2]=f[y+4>>2];f[v+8>>2]=f[y+8>>2];f[v+12>>2]=f[y+12>>2];y=y+16|0;if((y|0)==(m|0))break;else v=v+16|0}v=q+((x>>>4)+1<<4)|0;f[p>>2]=v;w=v}if((t|0)>0){z=w;A=u}else{n=i;return n|0}}else{z=q;A=c}c=z-(i+(k<<4))>>4;u=i+(c<<4)|0;if(u>>>0<q>>>0){w=(q+(0-c<<4)+~s|0)>>>4;s=z;t=u;while(1){f[s>>2]=f[t>>2];f[s+4>>2]=f[t+4>>2];f[s+8>>2]=f[t+8>>2];f[s+12>>2]=f[t+12>>2];t=t+16|0;if(t>>>0>=q>>>0)break;else s=s+16|0}f[p>>2]=z+(w+1<<4)}if(c|0){c=u;u=z;do{z=c;c=c+-16|0;w=u;u=u+-16|0;f[u>>2]=f[c>>2];f[w+-12>>2]=f[z+-12>>2];f[w+-8>>2]=f[z+-8>>2];f[w+-4>>2]=f[z+-4>>2]}while((c|0)!=(i|0))}c=A;if((l|0)==(c|0)){n=i;return n|0}else{B=l;C=i}while(1){f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2];f[C+8>>2]=f[B+8>>2];f[C+12>>2]=f[B+12>>2];B=B+16|0;if((B|0)==(c|0)){n=i;break}else C=C+16|0}return n|0}C=(r-g>>4)+k|0;if(C>>>0>268435455)gXa(a);k=o-g|0;o=k>>3;r=k>>4>>>0<134217727?(o>>>0<C>>>0?C:o):268435455;o=i;C=h>>4;do if(r)if(r>>>0>268435455){h=De(8)|0;UYa(h,358155);f[h>>2]=130560;Of(h|0,21520,875)}else{D=NYa(r<<4)|0;break}else D=0;while(0);h=D+(C<<4)|0;C=D+(r<<4)|0;if((l|0)==(m|0))E=h;else{r=((m+-16-j|0)>>>4)+1|0;j=l;l=h;while(1){f[l>>2]=f[j>>2];f[l+4>>2]=f[j+4>>2];f[l+8>>2]=f[j+8>>2];f[l+12>>2]=f[j+12>>2];j=j+16|0;if((j|0)==(m|0))break;else l=l+16|0}E=h+(r<<4)|0}if(!b)F=h;else{b=i+-16-g|0;g=h;r=i;while(1){l=r;r=r+-16|0;f[g+-16>>2]=f[r>>2];f[g+-12>>2]=f[l+-12>>2];f[g+-8>>2]=f[l+-8>>2];f[g+-4>>2]=f[l+-4>>2];if((r|0)==(e|0))break;else g=g+-16|0}F=h+(~(b>>>4)<<4)|0}b=F;if((q|0)==(i|0))G=E;else{F=q+-16-o|0;o=E;g=i;while(1){f[o>>2]=f[g>>2];f[o+4>>2]=f[g+4>>2];f[o+8>>2]=f[g+8>>2];f[o+12>>2]=f[g+12>>2];g=g+16|0;if((g|0)==(q|0))break;else o=o+16|0}G=E+((F>>>4)+1<<4)|0}f[a>>2]=b;f[p>>2]=G;f[d>>2]=C;if(!e){n=h;return n|0}PYa(e);n=h;return n|0}function ota(a){a=a|0;kta(a);PYa(a);return}function pta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0;c=u;u=u+176|0;d=c+160|0;e=c+152|0;g=c+148|0;h=c+72|0;i=c+56|0;j=c+40|0;k=c+24|0;l=c;m=c+144|0;n=c+140|0;o=c+136|0;q=c+132|0;r=c+128|0;s=c+124|0;t=c+120|0;v=c+116|0;w=c+112|0;x=c+108|0;y=c+104|0;z=c+100|0;A=c+96|0;B=c+92|0;C=c+88|0;D=c+84|0;E=c+80|0;F=c+68|0;G=c+52|0;H=c+36|0;I=c+20|0;J=c+16|0;K=c+12|0;L=c+8|0;_$(h,77604);M=a+4|0;N=f[M>>2]|0;O=f[N+8>>2]|0;P=f[N+12>>2]|0;N=a+16|0;Q=+p[N>>3];R=rNa(+(O|0)*Q)|0;S=rNa(+(P|0)*Q)|0;T=f[a+8>>2]|0;U=Y(T,f[b>>2]|0)|0;V=Y(f[b+4>>2]|0,T)|0;T=(f[a+32>>2]|0)+~P|0;P=(T|0)<(V|0)?T:V;if((P|0)>(U|0)?(V=f[a+36>>2]|0,(V|0)>(O+1|0)):0){T=V+~O|0;O=Q>2.0?1:2;f[i>>2]=0;V=i+4|0;f[V>>2]=0;f[i+8>>2]=0;f[j>>2]=0;b=j+4|0;f[b>>2]=0;f[j+8>>2]=0;f[k>>2]=0;W=k+4|0;f[W>>2]=0;f[k+8>>2]=0;X=(T|0)>0;Z=a+164|0;_=d+4|0;$=d+8|0;aa=d+12|0;ba=i+8|0;ca=a+172|0;da=a+160|0;ea=d+4|0;fa=d+8|0;ga=d+12|0;ha=j+8|0;ia=k+8|0;ja=a+168|0;ka=U;do{if(X){Q=+(ka|0);U=0;do{la=gta(f[M>>2]|0,U,ka,l,0)|0;if(!(f[Z>>2]|0)){if((la|0)>0){ma=+p[N>>3];na=rNa(+(U|0)*ma)|0;oa=rNa(Q*ma)|0;f[d>>2]=na;f[_>>2]=oa;f[$>>2]=R;f[aa>>2]=S;pa=f[V>>2]|0;if((pa|0)==(f[ba>>2]|0)){Vra(i,d);qa=f[V>>2]|0}else{f[pa>>2]=na;f[pa+4>>2]=oa;f[pa+8>>2]=R;f[pa+12>>2]=S;oa=pa+16|0;f[V>>2]=oa;qa=oa}if(qa-(f[i>>2]|0)>>4>>>0>99?(W$(f[ca>>2]|0),oa=f[da>>2]|0,f[x>>2]=f[oa+4>>2],f[y>>2]=f[i>>2],f[z>>2]=f[V>>2],f[g>>2]=f[x>>2],f[e>>2]=f[y>>2],f[d>>2]=f[z>>2],nta(oa,g,e,d)|0,X$(f[ca>>2]|0),oa=f[i>>2]|0,pa=f[V>>2]|0,(pa|0)!=(oa|0)):0)f[V>>2]=pa+(~((pa+-16-oa|0)>>>4)<<4)}}else{oa=f[(f[M>>2]|0)+4>>2]|0;pa=(la|0)==1?0-oa|0:la;if((pa+oa|0)<4){ma=+p[N>>3];oa=rNa(+(U|0)*ma)|0;la=rNa(Q*ma)|0;f[d>>2]=oa;f[ea>>2]=la;f[fa>>2]=R;f[ga>>2]=S;na=f[V>>2]|0;if((na|0)==(f[ba>>2]|0))Vra(i,d);else{f[na>>2]=oa;f[na+4>>2]=la;f[na+8>>2]=R;f[na+12>>2]=S;f[V>>2]=na+16}na=0-pa|0;f[d>>2]=na;pa=f[b>>2]|0;if((pa|0)==(f[ha>>2]|0))VU(j,d);else{f[pa>>2]=na;f[b>>2]=pa+4}pa=f[W>>2]|0;if((pa|0)==(f[ia>>2]|0))Wra(k,l);else{p[pa>>3]=+p[l>>3];f[W>>2]=pa+8}if((f[V>>2]|0)-(f[i>>2]|0)>>4>>>0>99){W$(f[ca>>2]|0);pa=f[da>>2]|0;f[m>>2]=f[pa+4>>2];f[n>>2]=f[i>>2];f[o>>2]=f[V>>2];f[g>>2]=f[m>>2];f[e>>2]=f[n>>2];f[d>>2]=f[o>>2];nta(pa,g,e,d)|0;pa=f[Z>>2]|0;f[q>>2]=f[pa+4>>2];f[r>>2]=f[j>>2];f[s>>2]=f[b>>2];f[g>>2]=f[q>>2];f[e>>2]=f[r>>2];f[d>>2]=f[s>>2];qta(pa,g,e,d)|0;pa=f[ja>>2]|0;f[t>>2]=f[pa+4>>2];f[v>>2]=f[k>>2];f[w>>2]=f[W>>2];f[g>>2]=f[t>>2];f[e>>2]=f[v>>2];f[d>>2]=f[w>>2];rta(pa,g,e,d)|0;X$(f[ca>>2]|0);pa=f[i>>2]|0;na=f[V>>2]|0;if((na|0)!=(pa|0))f[V>>2]=na+(~((na+-16-pa|0)>>>4)<<4);pa=f[j>>2]|0;na=f[b>>2]|0;if((na|0)!=(pa|0))f[b>>2]=na+(~((na+-4-pa|0)>>>2)<<2);pa=f[k>>2]|0;na=f[W>>2]|0;if((na|0)!=(pa|0))f[W>>2]=na+(~((na+-8-pa|0)>>>3)<<3)}}}U=U+O|0}while((U|0)<(T|0))}ka=ka+O|0}while((ka|0)<(P|0));if((f[b>>2]|0)==(f[j>>2]|0)){if((f[V>>2]|0)!=(f[i>>2]|0)){P=a+172|0;W$(f[P>>2]|0);ka=f[a+160>>2]|0;f[J>>2]=f[ka+4>>2];f[K>>2]=f[i>>2];f[L>>2]=f[V>>2];f[g>>2]=f[J>>2];f[e>>2]=f[K>>2];f[d>>2]=f[L>>2];nta(ka,g,e,d)|0;X$(f[P>>2]|0)}}else{P=a+172|0;W$(f[P>>2]|0);ka=f[a+160>>2]|0;f[A>>2]=f[ka+4>>2];f[B>>2]=f[i>>2];f[C>>2]=f[V>>2];f[g>>2]=f[A>>2];f[e>>2]=f[B>>2];f[d>>2]=f[C>>2];nta(ka,g,e,d)|0;ka=f[a+164>>2]|0;f[D>>2]=f[ka+4>>2];f[E>>2]=f[j>>2];f[F>>2]=f[b>>2];f[g>>2]=f[D>>2];f[e>>2]=f[E>>2];f[d>>2]=f[F>>2];qta(ka,g,e,d)|0;ka=f[a+168>>2]|0;f[G>>2]=f[ka+4>>2];f[H>>2]=f[k>>2];f[I>>2]=f[W>>2];f[g>>2]=f[G>>2];f[e>>2]=f[H>>2];f[d>>2]=f[I>>2];rta(ka,g,e,d)|0;X$(f[P>>2]|0)}P=f[k>>2]|0;if(P|0){k=f[W>>2]|0;if((k|0)!=(P|0))f[W>>2]=k+(~((k+-8-P|0)>>>3)<<3);PYa(P)}P=f[j>>2]|0;if(P|0){j=f[b>>2]|0;if((j|0)!=(P|0))f[b>>2]=j+(~((j+-4-P|0)>>>2)<<2);PYa(P)}P=f[i>>2]|0;if(P|0){i=f[V>>2]|0;if((i|0)!=(P|0))f[V>>2]=i+(~((i+-16-P|0)>>>4)<<4);PYa(P)}}if(!(f[h+4>>2]|0)){u=c;return}u=c;return}function qta(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=f[a>>2]|0;g=e;h=(f[b>>2]|0)-g|0;b=e+(h>>2<<2)|0;i=f[c>>2]|0;j=f[d>>2]|0;d=j-i|0;k=d>>2;l=j;if((d|0)<=0){m=b;return m|0}d=a+8|0;n=f[d>>2]|0;o=a+4|0;p=f[o>>2]|0;q=p;if((k|0)<=(n-q>>2|0)){r=b;s=q-r|0;t=s>>2;if((k|0)>(t|0)){u=i+(t<<2)|0;t=u;if((u|0)==(l|0))v=p;else{w=l+-4-t|0;x=u;u=p;while(1){f[u>>2]=f[x>>2];x=x+4|0;if((x|0)==(l|0))break;else u=u+4|0}u=p+((w>>>2)+1<<2)|0;f[o>>2]=u;v=u}if((s|0)>0){y=v;z=t}else{m=b;return m|0}}else{y=p;z=j}j=y-(b+(k<<2))|0;t=j>>2;v=b+(t<<2)|0;if(v>>>0<p>>>0){s=(p+(0-t<<2)+~r|0)>>>2;r=y;u=v;while(1){f[r>>2]=f[u>>2];u=u+4|0;if(u>>>0>=p>>>0)break;else r=r+4|0}f[o>>2]=y+(s+1<<2)}if(!t)A=i;else{M1a(y+(0-t<<2)|0,b|0,j|0)|0;A=f[c>>2]|0}c=z-A|0;if(!c){m=b;return m|0}M1a(b|0,A|0,c|0)|0;m=b;return m|0}c=(q-g>>2)+k|0;if(c>>>0>1073741823)gXa(a);k=n-g|0;g=k>>1;n=k>>2>>>0<536870911?(g>>>0<c>>>0?c:g):1073741823;g=b;c=h>>2;do if(n)if(n>>>0>1073741823){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{B=NYa(n<<2)|0;break}else B=0;while(0);k=B+(c<<2)|0;A=B+(n<<2)|0;n=i;if((n|0)==(l|0))C=k;else{B=((l+-4-i|0)>>>2)+1|0;i=n;n=k;while(1){f[n>>2]=f[i>>2];i=i+4|0;if((i|0)==(l|0))break;else n=n+4|0}C=k+(B<<2)|0}B=k+(0-c<<2)|0;if((h|0)>0)K1a(B|0,e|0,h|0)|0;h=q-g|0;if((h|0)>0){K1a(C|0,b|0,h|0)|0;D=C+(h>>>2<<2)|0}else D=C;f[a>>2]=B;f[o>>2]=D;f[d>>2]=A;if(!e){m=k;return m|0}PYa(e);m=k;return m|0}function rta(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=f[a>>2]|0;g=e;h=(f[b>>2]|0)-g|0;b=e+(h>>3<<3)|0;i=f[c>>2]|0;j=f[d>>2]|0;d=j-i|0;k=d>>3;l=j;if((d|0)<=0){m=b;return m|0}d=a+8|0;n=f[d>>2]|0;o=a+4|0;q=f[o>>2]|0;r=q;if((k|0)<=(n-r>>3|0)){s=b;t=r-s|0;u=t>>3;if((k|0)>(u|0)){v=i+(u<<3)|0;u=v;if((v|0)==(l|0))w=q;else{x=l+-8-u|0;y=v;v=q;while(1){p[v>>3]=+p[y>>3];y=y+8|0;if((y|0)==(l|0))break;else v=v+8|0}v=q+((x>>>3)+1<<3)|0;f[o>>2]=v;w=v}if((t|0)>0){z=w;A=u}else{m=b;return m|0}}else{z=q;A=j}j=z-(b+(k<<3))|0;u=j>>3;w=b+(u<<3)|0;if(w>>>0<q>>>0){t=(q+(0-u<<3)+~s|0)>>>3;s=z;v=w;while(1){p[s>>3]=+p[v>>3];v=v+8|0;if(v>>>0>=q>>>0)break;else s=s+8|0}f[o>>2]=z+(t+1<<3)}if(!u)B=i;else{M1a(z+(0-u<<3)|0,b|0,j|0)|0;B=f[c>>2]|0}c=A-B|0;if(!c){m=b;return m|0}M1a(b|0,B|0,c|0)|0;m=b;return m|0}c=(r-g>>3)+k|0;if(c>>>0>536870911)gXa(a);k=n-g|0;g=k>>2;n=k>>3>>>0<268435455?(g>>>0<c>>>0?c:g):536870911;g=b;c=h>>3;do if(n)if(n>>>0>536870911){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{C=NYa(n<<3)|0;break}else C=0;while(0);k=C+(c<<3)|0;B=C+(n<<3)|0;n=i;if((n|0)==(l|0))D=k;else{C=((l+-8-i|0)>>>3)+1|0;i=n;n=k;while(1){p[n>>3]=+p[i>>3];i=i+8|0;if((i|0)==(l|0))break;else n=n+8|0}D=k+(C<<3)|0}C=k+(0-c<<3)|0;if((h|0)>0)K1a(C|0,e|0,h|0)|0;h=r-g|0;if((h|0)>0){K1a(D|0,b|0,h|0)|0;E=D+(h>>>3<<3)|0}else E=D;f[a>>2]=C;f[o>>2]=E;f[d>>2]=B;if(!e){m=k;return m|0}PYa(e);m=k;return m|0}function sta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=77632;b=a+268|0;c=a+304|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+284|0;b=a+272|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+308>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+312>>2]|0;if((b|0)!=(a+316|0))ZF(b);b=a+212|0;d=a+248|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+228|0;b=a+216|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+252>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+256>>2]|0;if((b|0)!=(a+260|0))ZF(b);b=a+156|0;c=a+192|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+172|0;b=a+160|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+196>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+200>>2]|0;if((b|0)!=(a+204|0))ZF(b);b=a+100|0;d=a+136|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+116|0;b=a+104|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+140>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+144>>2]|0;if((b|0)!=(a+148|0))ZF(b);b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+16>>2]|0;if(b|0){d=a+20|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~(((c+-12-b|0)>>>0)/12|0)*12|0);PYa(b)}b=f[a+4>>2]|0;if(!b)return;c=a+8|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~(((a+-44-b|0)>>>0)/44|0)*44|0);PYa(b);return}function tta(a){a=a|0;sta(a);PYa(a);return}function uta(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0,N=0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0.0,Z=0.0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;j=u;u=u+2208|0;k=j+1136|0;l=j+1072|0;m=j+1064|0;o=j+1080|0;q=j;r=a+324|0;f[r>>2]=c;s=a+52|0;f[s>>2]=f[i>>2];t=a+56|0;f[t>>2]=f[i+4>>2];i=a+28|0;b[i>>0]=h&1;h=f[(f[c>>2]|0)+52>>2]|0;f[l>>2]=f[e>>2];v=e+4|0;f[l+4>>2]=f[v>>2];f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];bh[h&255](c,d,a+212|0,a+268|0,l,m);m=f[v>>2]|0;f[a+92>>2]=f[e>>2];f[a+96>>2]=m;m=f[r>>2]|0;e=f[m+4>>2]|0;f[a+44>>2]=e;v=f[m+8>>2]|0;f[a+48>>2]=v;l=f[m+12>>2]|0;d=f[m+16>>2]|0;c=f[m+20>>2]|0;h=f[m+24>>2]|0;g=f[m+28>>2]|0;w=f[m+32>>2]|0;x=f[m+36>>2]|0;m=Y(d,l)|0;y=a+60|0;f[y>>2]=((e-l|0)/(c|0)|0)+1;e=a+64|0;f[e>>2]=((v-d|0)/(h|0)|0)+1;z=(l|0)/(g|0)|0;A=(d|0)/(w|0)|0;B=a+68|0;f[B>>2]=z;C=a+72|0;f[C>>2]=A;D=Y(Y(z,x)|0,A)|0;A=a+76|0;f[A>>2]=D;do if(b[i>>0]|0){z=(((f[a+224>>2]|0)-l|0)/(f[s>>2]|0)|0)+1|0;E=((v|0)/(f[t>>2]|0)|0)+1|0;F=a+100|0;G=Y(z,D)|0;if(!(((((f[a+104>>2]|0)<3?(f[a+108>>2]|0)==(E|0):0)?(f[a+112>>2]|0)==(G|0):0)?(f[F>>2]&4095|0)==5:0)?(f[a+116>>2]|0)!=0:0)){f[k>>2]=E;f[k+4>>2]=G;AR(F,2,k,5)}F=a+156|0;if(!(((((f[a+160>>2]|0)<3?(f[a+164>>2]|0)==(E|0):0)?(f[a+168>>2]|0)==(z|0):0)?(f[F>>2]&4095|0)==0:0)?(f[a+172>>2]|0)!=0:0)){f[k>>2]=E;f[k+4>>2]=z;AR(F,2,k,0)}F=f[a+108>>2]|0;z=a+32|0;E=a+36|0;G=f[E>>2]|0;H=f[z>>2]|0;I=G-H>>2;J=H;H=G;if(F>>>0<=I>>>0){if(F>>>0<I>>>0?(G=J+(F<<2)|0,(H|0)!=(G|0)):0)f[E>>2]=H+(~((H+-4-G|0)>>>2)<<2);if(!F)break}else GM(z,F-I|0);F1a(f[z>>2]|0,-1,F<<2|0)|0}while(0);f[o>>2]=1124007936;D=o+4|0;t=o+8|0;v=o+40|0;s=D;i=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(i|0));f[v>>2]=t;t=o+48|0;F=o+44|0;f[F>>2]=t;f[t>>2]=0;f[o+52>>2]=0;f[k>>2]=d;f[k+4>>2]=l;AR(o,2,k,5);z=f[r>>2]|0;K=+p[z+48>>3];if(K>0.0)L=K;else L=+((f[z+16>>2]|0)+(f[z+12>>2]|0)|0)*.125;K=L;L=1.0/(K*K*2.0);z=k+8|0;f[k>>2]=z;r=k+4|0;f[r>>2]=d;if(d>>>0>264){I=OYa(d>>>0>1073741823?-1:d<<2)|0;f[k>>2]=I;M=I}else M=z;I=q+8|0;f[q>>2]=I;G=q+4|0;f[G>>2]=l;if(l>>>0>264){H=OYa(l>>>0>1073741823?-1:l<<2)|0;f[q>>2]=H;N=H}else N=I;K=+(d|0)*.5;O=+(l|0)*.5;H=(d|0)>0;if(H){E=0;do{P=+(E|0)-K;n[M+(E<<2)>>2]=P*P;E=E+1|0}while((E|0)!=(d|0))}E=(l|0)>0;if(E){J=0;do{K=+(J|0)-O;n[N+(J<<2)>>2]=K*K;J=J+1|0}while((J|0)!=(l|0))}if(H?(J=f[o+16>>2]|0,E):0){Q=f[f[F>>2]>>2]|0;R=0;do{S=M+(R<<2)|0;T=J+(Y(Q,R)|0)|0;U=0;do{O=+V(+-(L*(+n[S>>2]+ +n[N+(U<<2)>>2])));n[T+(U<<2)>>2]=O;U=U+1|0}while((U|0)!=(l|0));R=R+1|0}while((R|0)!=(d|0))}if((N|0)==(I|0))W=M;else{QYa(N);N=f[k>>2]|0;f[q>>2]=I;f[G>>2]=264;W=N}if((W|0)!=(z|0)){if(W|0)QYa(W);f[k>>2]=z;f[r>>2]=264}r=a+16|0;z=Y(f[e>>2]|0,f[y>>2]|0)|0;k=a+20|0;W=f[k>>2]|0;N=f[r>>2]|0;G=(W-N|0)/12|0;I=N;N=W;if(z>>>0<=G>>>0){if(z>>>0<G>>>0?(W=I+(z*12|0)|0,(N|0)!=(W|0)):0)f[k>>2]=N+(~(((N+-12-W|0)>>>0)/12|0)*12|0)}else wta(r,z-G|0);G=a+4|0;z=m*3|0;W=a+8|0;N=f[W>>2]|0;k=f[G>>2]|0;I=(N-k|0)/44|0;q=k;k=N;if(z>>>0<=I>>>0){if(z>>>0<I>>>0?(N=q+(z*44|0)|0,(k|0)!=(N|0)):0)f[W>>2]=k+(~(((k+-44-N|0)>>>0)/44|0)*44|0)}else xta(G,z-I|0);I=a+88|0;f[I>>2]=0;z=a+84|0;f[z>>2]=0;N=a+80|0;f[N>>2]=0;if(E){L=+(g|0);O=+(w|0);w=m<<1;g=a+224|0;E=a+280|0;a=f[o+16>>2]|0;k=f[F>>2]|0;W=0;do{if(H){K=(+(W|0)+.5)/L+-.5;q=~~K;M=q-(+(q|0)>K&1)|0;q=M+1|0;P=K-+(M|0);K=1.0-P;R=0;do{X=(+(R|0)+.5)/O+-.5;Q=~~X;J=Q-(+(Q|0)>X&1)|0;Q=J+1|0;Z=X-+(J|0);U=f[B>>2]|0;T=M>>>0<U>>>0;do if(T&q>>>0<U>>>0){S=f[C>>2]|0;_=J>>>0<S>>>0;if(_&Q>>>0<S>>>0){$=f[I>>2]|0;f[I>>2]=$+1;aa=$+w|0;$=f[G>>2]|0;ba=Y((Y(S,M)|0)+J|0,x)|0;f[$+(aa*44|0)+8>>2]=ba;X=1.0-Z;n[$+(aa*44|0)+24>>2]=K*X;ba=Y((Y(f[C>>2]|0,q)|0)+J|0,x)|0;f[$+(aa*44|0)+12>>2]=ba;n[$+(aa*44|0)+28>>2]=P*X;ba=Y((Y(f[C>>2]|0,M)|0)+Q|0,x)|0;f[$+(aa*44|0)+16>>2]=ba;n[$+(aa*44|0)+32>>2]=K*Z;ba=Y((Y(f[C>>2]|0,q)|0)+Q|0,x)|0;f[$+(aa*44|0)+20>>2]=ba;ca=3;da=P*Z;ea=$+(aa*44|0)|0;break}else{aa=f[z>>2]|0;f[z>>2]=aa+1;$=aa+m|0;aa=f[G>>2]|0;X=_?1.0-Z:Z;ba=_?J:Q;_=Y(ba+(Y(S,M)|0)|0,x)|0;f[aa+($*44|0)+8>>2]=_;n[aa+($*44|0)+24>>2]=K*X;_=Y((Y(f[C>>2]|0,q)|0)+ba|0,x)|0;f[aa+($*44|0)+12>>2]=_;n[aa+($*44|0)+28>>2]=P*X;f[aa+($*44|0)+20>>2]=0;f[aa+($*44|0)+16>>2]=0;n[aa+($*44|0)+36>>2]=0.0;ca=2;da=0.0;ea=aa+($*44|0)|0;break}}else{X=T?K:P;$=T?M:q;aa=f[C>>2]|0;_=J>>>0<aa>>>0;if(_&Q>>>0<aa>>>0){ba=f[z>>2]|0;f[z>>2]=ba+1;S=ba+m|0;ba=f[G>>2]|0;fa=Y((Y(aa,$)|0)+J|0,x)|0;f[ba+(S*44|0)+8>>2]=fa;n[ba+(S*44|0)+24>>2]=(1.0-Z)*X;fa=Y((Y(f[C>>2]|0,$)|0)+Q|0,x)|0;f[ba+(S*44|0)+12>>2]=fa;n[ba+(S*44|0)+28>>2]=Z*X;f[ba+(S*44|0)+20>>2]=0;f[ba+(S*44|0)+16>>2]=0;n[ba+(S*44|0)+36>>2]=0.0;ca=2;da=0.0;ea=ba+(S*44|0)|0;break}else{S=f[N>>2]|0;f[N>>2]=S+1;ba=f[G>>2]|0;fa=Y((_?J:Q)+(Y(aa,$)|0)|0,x)|0;f[ba+(S*44|0)+8>>2]=fa;n[ba+(S*44|0)+24>>2]=X*(_?1.0-Z:Z);f[ba+(S*44|0)+20>>2]=0;f[ba+(S*44|0)+16>>2]=0;f[ba+(S*44|0)+12>>2]=0;n[ba+(S*44|0)+36>>2]=0.0;n[ba+(S*44|0)+32>>2]=0.0;ca=1;da=0.0;ea=ba+(S*44|0)|0;break}}while(0);n[ea+24+(ca<<2)>>2]=da;Q=(Y(f[g>>2]|0,R)|0)+W<<1;f[ea>>2]=Q;Q=(Y(f[E>>2]|0,R)|0)+W<<1;f[ea+4>>2]=Q;Q=a+(Y(f[k>>2]|0,R)|0)+(W<<2)|0;f[ea+40>>2]=f[Q>>2];R=R+1|0}while((R|0)!=(d|0))}W=W+1|0}while((W|0)!=(l|0));l=f[z>>2]|0;if((l|0)>0){W=0;do{d=f[G>>2]|0;s=d+(((f[N>>2]|0)+W|0)*44|0)|0;ga=d+((W+m|0)*44|0)|0;i=s+44|0;do{f[s>>2]=f[ga>>2];s=s+4|0;ga=ga+4|0}while((s|0)<(i|0));W=W+1|0;d=f[z>>2]|0}while((W|0)<(d|0));ha=d}else ha=l}else ha=0;l=f[I>>2]|0;if((l|0)>0){W=m<<1;m=f[G>>2]|0;s=m+(((f[N>>2]|0)+ha|0)*44|0)|0;ga=m+(W*44|0)|0;i=s+44|0;do{f[s>>2]=f[ga>>2];s=s+4|0;ga=ga+4|0}while((s|0)<(i|0));m=f[I>>2]|0;if((m|0)>1){d=1;do{ea=f[G>>2]|0;s=ea+(((f[N>>2]|0)+d+(f[z>>2]|0)|0)*44|0)|0;ga=ea+((d+W|0)*44|0)|0;i=s+44|0;do{f[s>>2]=f[ga>>2];s=s+4|0;ga=ga+4|0}while((s|0)<(i|0));d=d+1|0;ea=f[I>>2]|0}while((d|0)<(ea|0));ia=ea}else ia=m;ja=ia;ka=f[z>>2]|0}else{ja=l;ka=ha}ha=ka+(f[N>>2]|0)|0;f[z>>2]=ha;f[I>>2]=ha+ja;ja=f[y>>2]|0;if((ja|0)>0?(y=f[e>>2]|0,(y|0)>0):0){e=f[r>>2]|0;r=f[A>>2]|0;A=0;do{ha=Y(A,c)|0;I=Y(y,A)|0;z=0;do{N=I+z|0;ka=Y(r,N)|0;f[e+(N*12|0)>>2]=ka;ka=Y(z,h)|0;f[e+(N*12|0)+4>>2]=ha;f[e+(N*12|0)+8>>2]=ka;z=z+1|0}while((z|0)<(y|0));A=A+1|0}while((A|0)<(ja|0))}ja=o+36|0;A=f[ja>>2]|0;if(A|0?(y=A+12|0,A=f[y>>2]|0,f[y>>2]=A+-1,(A|0)==1):0)CR(o);f[ja>>2]=0;ja=o+16|0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[D>>2]|0)>0){ja=f[v>>2]|0;v=0;do{f[ja+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[D>>2]|0))}D=f[F>>2]|0;if((D|0)==(t|0)){u=j;return}ZF(D);u=j;return}function vta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,q=0,r=0.0,t=0.0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+16|0;d=c+4|0;e=c;g=f[a+76>>2]|0;h=g+-4|0;i=0;j=0.0;k=0.0;l=0.0;m=0.0;do{o=+n[b+(i<<2)>>2];j=j+o*o;o=+n[b+((i|1)<<2)>>2];k=k+o*o;o=+n[b+((i|2)<<2)>>2];l=l+o*o;o=+n[b+((i|3)<<2)>>2];m=m+o*o;i=i+4|0}while(i>>>0<=h>>>0);o=m+l+(k+j);if(i>>>0<g>>>0){q=i;j=o;while(1){k=+n[b+(q<<2)>>2];l=j+k*k;q=q+1|0;if((q|0)==(g|0)){r=l;break}else j=l}}else r=o;o=1.0/(+(g>>>0)*.10000000149011612+ +M(+r));r=+p[(f[a+324>>2]|0)+64>>3];n[d>>2]=r;a=0;j=0.0;l=0.0;k=0.0;m=0.0;do{q=b+(a<<2)|0;t=o*+n[q>>2];n[e>>2]=t;i=f[(r<t?d:e)>>2]|0;f[q>>2]=i;q=b+((a|1)<<2)|0;t=o*+n[q>>2];n[e>>2]=t;v=f[(r<t?d:e)>>2]|0;f[q>>2]=v;q=b+((a|2)<<2)|0;t=o*+n[q>>2];n[e>>2]=t;w=f[(r<t?d:e)>>2]|0;f[q>>2]=w;q=b+((a|3)<<2)|0;t=o*+n[q>>2];n[e>>2]=t;x=f[(r<t?d:e)>>2]|0;f[q>>2]=x;t=(f[s>>2]=i,+n[s>>2]);j=j+t*t;t=(f[s>>2]=v,+n[s>>2]);l=l+t*t;t=(f[s>>2]=w,+n[s>>2]);k=k+t*t;t=(f[s>>2]=x,+n[s>>2]);m=m+t*t;a=a+4|0}while(a>>>0<=h>>>0);t=m+k+(l+j);if(a>>>0<g>>>0){h=a;j=t;while(1){a=b+(h<<2)|0;l=o*+n[a>>2];n[e>>2]=l;x=f[(r<l?d:e)>>2]|0;f[a>>2]=x;l=(f[s>>2]=x,+n[s>>2]);k=j+l*l;h=h+1|0;if((h|0)==(g|0)){y=k;break}else j=k}}else y=t;t=1.0/(+M(+y)+1.0000000474974513e-03);if(!g){u=c;return}else z=0;do{h=b+(z<<2)|0;n[h>>2]=t*+n[h>>2];z=z+1|0}while((z|0)!=(g|0));u=c;return}function wta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/12|0)>>>0>=b>>>0){F1a(g|0,0,b*12|0)|0;f[e>>2]=h+(b*12|0);return}i=f[a>>2]|0;j=(g-i|0)/12|0;g=j+b|0;k=i;if(g>>>0>357913941)gXa(a);l=(d-i|0)/12|0;d=l<<1;m=l>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(m)if(m>>>0>357913941){d=De(8)|0;UYa(d,358155);f[d>>2]=130560;Of(d|0,21520,875)}else{n=NYa(m*12|0)|0;break}else n=0;while(0);d=n+(j*12|0)|0;j=n+(m*12|0)|0;F1a(d|0,0,b*12|0)|0;m=d+(b*12|0)|0;if((h|0)==(k|0)){o=d;p=i}else{i=d;d=h;do{h=d;d=d+-12|0;f[i+-12>>2]=f[d>>2];f[i+-8>>2]=f[h+-8>>2];f[i+-4>>2]=f[h+-4>>2];i=i+-12|0}while((d|0)!=(k|0));o=i;p=f[a>>2]|0}f[a>>2]=o;f[e>>2]=m;f[c>>2]=j;if(!p)return;PYa(p);return}function xta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/44|0)>>>0>=b>>>0){h=g;i=b;do{j=h;k=j+44|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));h=(f[e>>2]|0)+44|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=(g-i|0)/44|0;g=h+b|0;if(g>>>0>97612893)gXa(a);l=(d-i|0)/44|0;i=l<<1;d=l>>>0<48806446?(i>>>0<g>>>0?g:i):97612893;do if(d)if(d>>>0>97612893){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{m=NYa(d*44|0)|0;break}else m=0;while(0);i=m+(h*44|0)|0;h=m+(d*44|0)|0;d=i;m=b;b=i;do{j=d;k=j+44|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));d=b+44|0;b=d;m=m+-1|0}while((m|0)!=0);m=f[a>>2]|0;d=(f[e>>2]|0)-m|0;j=i+(((d|0)/-44|0)*44|0)|0;if((d|0)>0)K1a(j|0,m|0,d|0)|0;f[a>>2]=j;f[e>>2]=b;f[c>>2]=h;if(!m)return;PYa(m);return}function yta(a){a=a|0;var b=0,c=0;f[a>>2]=77656;j0(a+88|0);b=f[a+76>>2]|0;if(!b)return;c=a+80|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);PYa(b);return}function zta(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77656;j0(a+88|0);b=f[a+76>>2]|0;if(!b){PYa(a);return}c=a+80|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b);PYa(a);return}function Ata(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0;d=u;u=u+128|0;e=d+112|0;g=d+56|0;h=d;do if((NS(c)|0)==65536){i=f[c+4>>2]|0;f[g>>2]=f[i>>2];j=g+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=g+8|0;f[l>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];f[g+16>>2]=f[i+16>>2];f[g+20>>2]=f[i+20>>2];f[g+24>>2]=f[i+24>>2];f[g+28>>2]=f[i+28>>2];f[g+32>>2]=f[i+32>>2];m=f[i+36>>2]|0;f[g+36>>2]=m;f[g+40>>2]=l;l=g+48|0;o=g+44|0;f[o>>2]=l;f[l>>2]=0;f[g+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];break}else{f[j>>2]=0;BR(g,i);break}}else OR(g,c,-1);while(0);c=a+76|0;i=e+8|0;f[i>>2]=0;f[i+4>>2]=0;f[e>>2]=-2113732603;f[e+4>>2]=c;WJ(g,e,5,1.0,0.0);i=g+36|0;j=f[i>>2]|0;if(j|0?(k=j+12|0,j=f[k>>2]|0,f[k>>2]=j+-1,(j|0)==1):0)CR(g);f[i>>2]=0;i=g+16|0;j=g+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[j>>2]|0)>0){i=f[g+40>>2]|0;k=0;do{f[i+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[j>>2]|0))}j=f[g+44>>2]|0;if((j|0)!=(g+48|0))ZF(j);j=a+80|0;g=(f[j>>2]|0)-(f[c>>2]|0)>>2;k=Tta(a)|0;if(!((g|0)==(k+1|0)|((g|0)==0|(g|0)==(k|0)))){f[e>>2]=0;f[e+4>>2]=0;p=c$(e,19)|0;k=344336;q=p+19|0;do{b[p>>0]=b[k>>0]|0;p=p+1|0;k=k+1|0}while((p|0)<(q|0));j$(-215,e,344356,342312,117);d$(e)}k=(f[j>>2]|0)-(f[c>>2]|0)>>2;f[h>>2]=1124007936;g=h+4|0;i=h+8|0;l=h+40|0;p=g;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[l>>2]=i;i=h+48|0;p=h+44|0;f[p>>2]=i;f[i>>2]=0;f[h+52>>2]=0;f[e>>2]=1;f[e+4>>2]=k;AR(h,2,e,5);k=f[a+12>>2]|0;q=f[a+16>>2]|0;o=Y(Y((k|0)/(f[a+28>>2]|0)|0,f[a+36>>2]|0)|0,(q|0)/(f[a+32>>2]|0)|0)|0;m=f[a+20>>2]|0;r=f[a+24>>2]|0;s=((f[a+4>>2]|0)-k+m|0)/(m|0)|0;m=((f[a+8>>2]|0)-q+r|0)/(r|0)|0;if((m|0)>0?(r=f[h+16>>2]|0,q=(o|0)==0,(s|0)>0):0){k=f[c>>2]|0;t=0;do{v=Y(t,s)|0;if(!q){w=0;do{x=k+((Y((Y(w,m)|0)+t|0,o)|0)<<2)|0;y=r+((Y(w+v|0,o)|0)<<2)|0;z=0;do{f[y+(z<<2)>>2]=f[x+(z<<2)>>2];z=z+1|0}while((z|0)!=(o|0));w=w+1|0}while((w|0)!=(s|0))}t=t+1|0}while((t|0)!=(m|0))}m=Tta(a)|0;t=f[c>>2]|0;if((f[j>>2]|0)-t>>2>>>0>m>>>0)A=+n[t+(m<<2)>>2];else A=0.0;n[a+136>>2]=A;m=e+8|0;f[m>>2]=0;f[m+4>>2]=0;f[e>>2]=34209792;f[e+4>>2]=a+88;eL(h,e);e=h+36|0;a=f[e>>2]|0;if(a|0?(m=a+12|0,a=f[m>>2]|0,f[m>>2]=a+-1,(a|0)==1):0)CR(h);f[e>>2]=0;e=h+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[g>>2]|0)>0){e=f[l>>2]|0;l=0;do{f[e+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[g>>2]|0))}g=f[p>>2]|0;if((g|0)==(i|0)){u=d;return}ZF(g);u=d;return}function Bta(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+192|0;e=d+140|0;g=d+96|0;h=d+8|0;i=d+88|0;j=d+80|0;k=d+72|0;l=d+64|0;m=d+56|0;n=d;if((nY(c)|0)!=6){o=0;u=d;return o|0}$X(i,c,344184);aY(h,f[i>>2]|0,f[i+4>>2]|0,0);i=h+20|0;p=f[i>>2]|0;f[e>>2]=f[h>>2];f[e+4>>2]=p;oY(e,a+4|0,0);p=cY(h)|0;q=f[h+20>>2]|0;f[e>>2]=f[h>>2];f[e+4>>2]=q;oY(e,a+8|0,0);cY(p)|0;$X(j,c,344192);aY(e,f[j>>2]|0,f[j+4>>2]|0,0);j=h;p=e;q=j+44|0;do{f[j>>2]=f[p>>2];j=j+4|0;p=p+4|0}while((j|0)<(q|0));r=f[i>>2]|0;f[e>>2]=f[h>>2];f[e+4>>2]=r;oY(e,a+12|0,0);r=cY(h)|0;s=f[h+20>>2]|0;f[e>>2]=f[h>>2];f[e+4>>2]=s;oY(e,a+16|0,0);cY(r)|0;$X(k,c,344202);aY(e,f[k>>2]|0,f[k+4>>2]|0,0);j=h;p=e;q=j+44|0;do{f[j>>2]=f[p>>2];j=j+4|0;p=p+4|0}while((j|0)<(q|0));k=f[i>>2]|0;f[e>>2]=f[h>>2];f[e+4>>2]=k;oY(e,a+20|0,0);k=cY(h)|0;r=f[h+20>>2]|0;f[e>>2]=f[h>>2];f[e+4>>2]=r;oY(e,a+24|0,0);cY(k)|0;$X(l,c,344318);aY(e,f[l>>2]|0,f[l+4>>2]|0,0);j=h;p=e;q=j+44|0;do{f[j>>2]=f[p>>2];j=j+4|0;p=p+4|0}while((j|0)<(q|0));l=f[i>>2]|0;f[e>>2]=f[h>>2];f[e+4>>2]=l;oY(e,a+28|0,0);l=cY(h)|0;i=f[h+20>>2]|0;f[e>>2]=f[h>>2];f[e+4>>2]=i;oY(e,a+32|0,0);cY(l)|0;$X(e,c,344214);oY(e,a+36|0,0);$X(e,c,344220);oY(e,a+40|0,0);$X(e,c,344327);qY(e,a+48|0,0.0);$X(e,c,344234);oY(e,a+56|0,0);$X(e,c,344252);qY(e,a+64|0,0.0);$X(g,c,344267);oY(g,e,0);b[a+72>>0]=(f[e>>2]|0)!=0&1;$X(e,c,344283);oY(e,a+140|0,0);$X(m,c,344291);if(!(f[m+4>>2]|0))b[a+144>>0]=0;else{$X(g,c,344291);oY(g,e,0);b[a+144>>0]=(f[e>>2]|0)!=0&1}$X(n,c,344306);if((nY(n)|0)==5?(c=a+76|0,aY(g,f[n>>2]|0,f[n+4>>2]|0,0),f[e>>2]=g,bua(e,c,2147483647),g=(f[a+80>>2]|0)-(f[c>>2]|0)>>2,c=Tta(a)|0,!((g|0)==(c+1|0)|((g|0)==0|(g|0)==(c|0)))):0){f[e>>2]=0;f[e+4>>2]=0;j=c$(e,19)|0;p=344336;q=j+19|0;do{b[j>>0]=b[p>>0]|0;j=j+1|0;p=p+1|0}while((j|0)<(q|0));j$(-215,e,345363,342312,167);d$(e)}o=1;u=d;return o|0}function Cta(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0.0,r=0,s=0;e=u;u=u+16|0;g=e+8|0;i=e;if(f[d+4>>2]|0)YX(c,d)|0;f[g>>2]=0;f[g+4>>2]=0;d=c$(g,27)|0;j=344156;k=d+27|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));l=YX(c,g)|0;d$(g);f[g>>2]=0;f[g+4>>2]=0;m=c$(g,7)|0;b[m>>0]=b[344184]|0;b[m+1>>0]=b[344185]|0;b[m+2>>0]=b[344186]|0;b[m+3>>0]=b[344187]|0;b[m+4>>0]=b[344188]|0;b[m+5>>0]=b[344189]|0;b[m+6>>0]=b[344190]|0;m=YX(l,g)|0;d$(g);l=$ta(m,a+4|0)|0;f[g>>2]=0;f[g+4>>2]=0;d=c$(g,9)|0;j=344192;k=d+9|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));m=YX(l,g)|0;d$(g);l=$ta(m,a+12|0)|0;f[g>>2]=0;f[g+4>>2]=0;d=c$(g,11)|0;j=344202;k=d+11|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));m=YX(l,g)|0;d$(g);l=$ta(m,a+20|0)|0;f[g>>2]=0;f[g+4>>2]=0;m=c$(g,8)|0;n=m;b[n>>0]=99;b[n+1>>0]=101;b[n+2>>0]=108;b[n+3>>0]=108;n=m+4|0;b[n>>0]=83;b[n+1>>0]=105;b[n+2>>0]=122;b[n+3>>0]=101;n=YX(l,g)|0;d$(g);l=$ta(n,a+28|0)|0;f[g>>2]=0;f[g+4>>2]=0;n=c$(g,5)|0;b[n>>0]=b[344214]|0;b[n+1>>0]=b[344215]|0;b[n+2>>0]=b[344216]|0;b[n+3>>0]=b[344217]|0;b[n+4>>0]=b[344218]|0;n=YX(l,g)|0;d$(g);l=a+36|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](n)|0){m=c+32|0;if((f[m>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=c$(g,30)|0;j=354672;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));j$(-2,g,373532,354703,1186);d$(g)}eY(n,c+12|0,f[l>>2]|0);if(f[m>>2]&4|0)f[m>>2]=6}f[g>>2]=0;f[g+4>>2]=0;d=c$(g,13)|0;j=344220;k=d+13|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));m=YX(n,g)|0;d$(g);n=a+40|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](m)|0){l=c+32|0;if((f[l>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=c$(g,30)|0;j=354672;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));j$(-2,g,373532,354703,1186);d$(g)}eY(m,c+12|0,f[n>>2]|0);if(f[l>>2]&4|0)f[l>>2]=6}f[g>>2]=0;f[g+4>>2]=0;l=c$(g,8)|0;n=l;b[n>>0]=119;b[n+1>>0]=105;b[n+2>>0]=110;b[n+3>>0]=83;n=l+4|0;b[n>>0]=105;b[n+1>>0]=103;b[n+2>>0]=109;b[n+3>>0]=97;n=YX(m,g)|0;d$(g);o=+p[a+48>>3];if(o>0.0)q=o;else q=+((f[a+16>>2]|0)+(f[a+12>>2]|0)|0)*.125;if(mi[f[(f[c>>2]|0)+12>>2]&255](n)|0){m=c+32|0;if((f[m>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=c$(g,30)|0;j=354672;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));j$(-2,g,373532,354703,1186);d$(g)}gY(n,c+12|0,q);if(f[m>>2]&4|0)f[m>>2]=6}f[g>>2]=0;f[g+4>>2]=0;d=c$(g,17)|0;j=344234;k=d+17|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));m=YX(n,g)|0;d$(g);n=a+56|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](m)|0){l=c+32|0;if((f[l>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=c$(g,30)|0;j=354672;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));j$(-2,g,373532,354703,1186);d$(g)}eY(m,c+12|0,f[n>>2]|0);if(f[l>>2]&4|0)f[l>>2]=6}f[g>>2]=0;f[g+4>>2]=0;d=c$(g,14)|0;j=344252;k=d+14|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));l=YX(m,g)|0;d$(g);m=a+64|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](l)|0){n=c+32|0;if((f[n>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=c$(g,30)|0;j=354672;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));j$(-2,g,373532,354703,1186);d$(g)}gY(l,c+12|0,+p[m>>3]);if(f[n>>2]&4|0)f[n>>2]=6}f[g>>2]=0;f[g+4>>2]=0;d=c$(g,15)|0;j=344267;k=d+15|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));n=YX(l,g)|0;d$(g);l=a+72|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](n)|0){m=c+32|0;if((f[m>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=c$(g,30)|0;j=354672;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));j$(-2,g,373532,354703,1186);d$(g)}eY(n,c+12|0,h[l>>0]|0);if(f[m>>2]&4|0)f[m>>2]=6}f[g>>2]=0;f[g+4>>2]=0;m=c$(g,7)|0;b[m>>0]=b[344283]|0;b[m+1>>0]=b[344284]|0;b[m+2>>0]=b[344285]|0;b[m+3>>0]=b[344286]|0;b[m+4>>0]=b[344287]|0;b[m+5>>0]=b[344288]|0;b[m+6>>0]=b[344289]|0;m=YX(n,g)|0;d$(g);n=a+140|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](m)|0){l=c+32|0;if((f[l>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=c$(g,30)|0;j=354672;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));j$(-2,g,373532,354703,1186);d$(g)}eY(m,c+12|0,f[n>>2]|0);if(f[l>>2]&4|0)f[l>>2]=6}f[g>>2]=0;f[g+4>>2]=0;d=c$(g,14)|0;j=344291;k=d+14|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));l=YX(m,g)|0;d$(g);m=a+144|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](l)|0){n=c+32|0;if((f[n>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=c$(g,30)|0;j=354672;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));j$(-2,g,373532,354703,1186);d$(g)}eY(l,c+12|0,h[m>>0]|0);if(f[n>>2]&4|0)f[n>>2]=6}n=a+76|0;if((f[n>>2]|0)==(f[a+80>>2]|0)){f[g>>2]=0;r=g+4|0;f[r>>2]=0;s=c$(g,1)|0;b[s>>0]=125;YX(c,g)|0;d$(g);u=e;return}f[g>>2]=0;f[g+4>>2]=0;d=c$(g,11)|0;j=344306;k=d+11|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));a=YX(c,g)|0;d$(g);if(!(mi[f[(f[c>>2]|0)+12>>2]&255](a)|0)){f[g>>2]=0;r=g+4|0;f[r>>2]=0;s=c$(g,1)|0;b[s>>0]=125;YX(c,g)|0;d$(g);u=e;return}m=c+32|0;if((f[m>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=c$(g,30)|0;j=354672;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));j$(-2,g,373532,354703,1186);d$(g)}f[g>>2]=0;f[g+4>>2]=0;iY(i,a,c+12|0,13,g);d$(g);f[g>>2]=a;aua(g,n);jY(i);if(!(f[m>>2]&4)){f[g>>2]=0;r=g+4|0;f[r>>2]=0;s=c$(g,1)|0;b[s>>0]=125;YX(c,g)|0;d$(g);u=e;return}f[m>>2]=6;f[g>>2]=0;r=g+4|0;f[r>>2]=0;s=c$(g,1)|0;b[s>>0]=125;YX(c,g)|0;d$(g);u=e;return}function Dta(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+144|0;e=d+136|0;g=d+88|0;h=d+44|0;i=d+8|0;j=d;f[e>>2]=0;f[e+4>>2]=0;VX(i,b,0,e);d$(e);if(f[c+4>>2]|0){_X(j,i,c);k=f[a>>2]|0;l=k+12|0;m=f[l>>2]|0;n=$h[m&255](a,j)|0;dV(i);u=d;return n|0}XX(e,i,0);c=e+4|0;aY(g,f[e>>2]|0,f[c>>2]|0,0);b=f[e>>2]|0;o=f[c>>2]|0;aY(h,b,o,bY(e)|0);e=f[g>>2]|0;o=e;if((((e|0)==(f[h>>2]|0)?(f[g+4>>2]|0)==(f[h+4>>2]|0):0)?(f[g+20>>2]|0)==(f[h+20>>2]|0):0)?(f[g+40>>2]|0)==(f[h+40>>2]|0):0){f[j>>2]=0;f[j+4>>2]=0}else{h=f[g+20>>2]|0;f[j>>2]=o;f[j+4>>2]=h}k=f[a>>2]|0;l=k+12|0;m=f[l>>2]|0;n=$h[m&255](a,j)|0;dV(i);u=d;return n|0}function Eta(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+48|0;e=d+8|0;g=d;f[g>>2]=0;f[g+4>>2]=0;VX(e,b,1,g);d$(g);h=f[(f[a>>2]|0)+16>>2]|0;i=f[c+4>>2]|0;if(i){j=f[c>>2]|0;f[g>>2]=j;f[g+4>>2]=i;if(j|0){i=j+-4|0;f[i>>2]=(f[i>>2]|0)+1}}else NX(g,b);fi[h&255](a,e,g);d$(g);dV(e);u=d;return}function Fta(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;f[c+4>>2]=f[a+4>>2];f[c+8>>2]=f[a+8>>2];f[c+12>>2]=f[a+12>>2];f[c+16>>2]=f[a+16>>2];f[c+20>>2]=f[a+20>>2];f[c+24>>2]=f[a+24>>2];f[c+28>>2]=f[a+28>>2];f[c+32>>2]=f[a+32>>2];f[c+36>>2]=f[a+36>>2];f[c+40>>2]=f[a+40>>2];p[c+48>>3]=+p[a+48>>3];f[c+56>>2]=f[a+56>>2];p[c+64>>3]=+p[a+64>>3];b[c+72>>0]=b[a+72>>0]|0;if((c|0)==(a|0)){d=a+140|0;e=f[d>>2]|0;g=c+140|0;f[g>>2]=e;h=a+144|0;i=b[h>>0]|0;j=c+144|0;b[j>>0]=i;return}tD(c+76|0,f[a+76>>2]|0,f[a+80>>2]|0);d=a+140|0;e=f[d>>2]|0;g=c+140|0;f[g>>2]=e;h=a+144|0;i=b[h>>0]|0;j=c+144|0;b[j>>0]=i;return}function Gta(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=u;u=u+416|0;i=h+408|0;j=h+400|0;k=h+392|0;l=h+336|0;m=h+8|0;n=h;_$(i,77940);o=f[d>>2]|0;p=d+4|0;q=f[p>>2]|0;if(!(q|o)){r=f[a+28>>2]|0;f[d>>2]=r;s=f[a+32>>2]|0;f[p>>2]=s;t=r;v=s}else{t=o;v=q}q=f[a+20>>2]|0;o=(t|0)<(q|0);s=o?q:t;r=o?t:q;if((r|0)>0){q=s;t=r;while(1){r=(q|0)%(t|0)|0;if((r|0)>0){o=t;t=r;q=o}else{w=t;break}}}else w=s;s=f[a+24>>2]|0;t=(v|0)<(s|0);q=t?s:v;o=t?v:s;if((o|0)>0){s=q;v=o;while(1){o=(s|0)%(v|0)|0;if((o|0)>0){t=v;v=o;s=t}else{x=v;break}}}else x=q;f[j>>2]=w;w=j+4|0;f[w>>2]=x;QR(k,b,-1);x=g+4|0;q=(f[x>>2]|0)-(f[g>>2]|0)>>3;v=f[e>>2]|0;s=f[j>>2]|0;t=s+-1+((v|0)>0?v:0)&0-s;f[e>>2]=t;s=e+4|0;v=f[s>>2]|0;o=f[w>>2]|0;w=o+-1+((v|0)>0?v:0)&0-o;f[s>>2]=w;o=(t<<1)+(f[k>>2]|0)|0;t=(w<<1)+(f[k+4>>2]|0)|0;do if((NS(b)|0)==65536){k=f[b+4>>2]|0;f[l>>2]=f[k>>2];w=l+4|0;v=k+4|0;f[w>>2]=f[v>>2];r=l+8|0;f[r>>2]=f[k+8>>2];f[l+12>>2]=f[k+12>>2];f[l+16>>2]=f[k+16>>2];f[l+20>>2]=f[k+20>>2];f[l+24>>2]=f[k+24>>2];f[l+28>>2]=f[k+28>>2];f[l+32>>2]=f[k+32>>2];y=f[k+36>>2]|0;f[l+36>>2]=y;f[l+40>>2]=r;r=l+48|0;z=l+44|0;f[z>>2]=r;f[r>>2]=0;f[l+52>>2]=0;if(y|0){r=y+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[v>>2]|0)<3){v=f[k+44>>2]|0;r=f[z>>2]|0;f[r>>2]=f[v>>2];f[r+4>>2]=f[v+4>>2];break}else{f[w>>2]=0;BR(l,k);break}}else OR(l,b,-1);while(0);b=(q|0)==0;Sta(m,a,l,e,e,b,j);if(b)A=Y(((t-(f[m+48>>2]|0)|0)/(f[p>>2]|0)|0)+1|0,((o-(f[m+44>>2]|0)|0)/(f[d>>2]|0)|0)+1|0)|0;else A=q;q=f[m+16>>2]|0;t=Y(f[m+64>>2]|0,f[m+60>>2]|0)|0;b=f[m+76>>2]|0;j=Tta(a)|0;k=Y(j,A)|0;w=c+4|0;v=f[w>>2]|0;r=f[c>>2]|0;z=v-r>>2;y=r;r=v;if(k>>>0<=z>>>0){if(k>>>0<z>>>0?(v=y+(k<<2)|0,(r|0)!=(v|0)):0)f[w>>2]=r+(~((r+-4-v|0)>>>2)<<2)}else _ta(c,k-z|0);if(A|0?(z=m+44|0,k=l+12|0,v=a+4|0,r=l+8|0,w=a+8|0,a=n+4|0,y=b<<2,(t|0)>0):0){b=0;do{B=Y(b,j)|0;C=(f[c>>2]|0)+(B<<2)|0;B=f[g>>2]|0;if((B|0)!=(f[x>>2]|0)){D=f[B+(b<<3)>>2]|0;E=f[B+(b<<3)+4>>2]|0;B=f[e>>2]|0;if((((D|0)>=(0-B|0)?(D|0)<=((f[k>>2]|0)+B-(f[v>>2]|0)|0):0)?(B=f[s>>2]|0,(E|0)>=(0-B|0)):0)?(E|0)<=((f[r>>2]|0)+B-(f[w>>2]|0)|0):0){F=D;G=E;H=33}}else{E=f[d>>2]|0;D=((o-(f[z>>2]|0)|0)/(E|0)|0)+1|0;B=(b|0)/(D|0)|0;I=Y(b-(Y(D,B)|0)|0,E)|0;E=Y(f[p>>2]|0,B)|0;F=I-(f[e>>2]|0)|0;G=E-(f[s>>2]|0)|0;H=33}if((H|0)==33){H=0;E=0;do{I=(f[q+(E*12|0)+8>>2]|0)+G|0;B=C+(f[q+(E*12|0)>>2]<<2)|0;f[n>>2]=(f[q+(E*12|0)+4>>2]|0)+F;f[a>>2]=I;I=Uta(m,n,B)|0;if((I|0)!=(B|0))K1a(B|0,I|0,y|0)|0;E=E+1|0}while((E|0)<(t|0))}b=b+1|0}while(b>>>0<A>>>0)}sta(m);m=l+36|0;A=f[m>>2]|0;if(A|0?(b=A+12|0,A=f[b>>2]|0,f[b>>2]=A+-1,(A|0)==1):0)CR(l);f[m>>2]=0;m=l+16|0;A=l+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[A>>2]|0)>0){m=f[l+40>>2]|0;b=0;do{f[m+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[A>>2]|0))}A=f[l+44>>2]|0;if((A|0)!=(l+48|0))ZF(A);if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function Hta(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0.0;k=u;u=u+384|0;l=k+376|0;m=k+368|0;o=k+40|0;q=k+24|0;r=k+16|0;s=k;t=k+8|0;_$(l,77920);v=f[d>>2]|0;w=d+4|0;x=f[w>>2]|0;if((x|0)!=(v|0))f[w>>2]=x+(~((x+-8-v|0)>>>3)<<3);v=f[e>>2]|0;x=e+4|0;y=f[x>>2]|0;if((y|0)!=(v|0))f[x>>2]=y+(~((y+-8-v|0)>>>3)<<3);v=a+76|0;y=a+80|0;if((f[v>>2]|0)!=(f[y>>2]|0)){z=f[h>>2]|0;A=h+4|0;B=f[A>>2]|0;if(!(B|z)){C=f[a+28>>2]|0;f[h>>2]=C;D=f[a+32>>2]|0;f[A>>2]=D;E=C;F=D}else{E=z;F=B}B=f[a+20>>2]|0;z=(E|0)<(B|0);D=z?B:E;C=z?E:B;if((C|0)>0){B=D;E=C;while(1){C=(B|0)%(E|0)|0;if((C|0)>0){z=E;E=C;B=z}else{G=E;break}}}else G=D;D=f[a+24>>2]|0;E=(F|0)<(D|0);B=E?D:F;z=E?F:D;if((z|0)>0){D=B;F=z;while(1){z=(D|0)%(F|0)|0;if((z|0)>0){E=F;F=z;D=E}else{H=F;break}}}else H=B;f[m>>2]=G;B=m+4|0;f[B>>2]=H;F=j+4|0;D=(f[F>>2]|0)-(f[j>>2]|0)>>3;E=f[i>>2]|0;z=G+-1+((E|0)>0?E:0)&0-G;f[i>>2]=z;G=i+4|0;E=f[G>>2]|0;C=H+-1+((E|0)>0?E:0)&0-H;f[G>>2]=C;H=c+12|0;E=(z<<1)+(f[H>>2]|0)|0;z=c+8|0;I=(C<<1)+(f[z>>2]|0)|0;C=(D|0)==0;Sta(o,a,c,i,i,C,m);if(C)J=Y(((I-(f[o+48>>2]|0)|0)/(f[A>>2]|0)|0)+1|0,((E-(f[o+44>>2]|0)|0)/(f[h>>2]|0)|0)+1|0)|0;else J=D;D=f[o+16>>2]|0;I=Y(f[o+64>>2]|0,f[o+60>>2]|0)|0;C=f[o+76>>2]|0;c=Tta(a)|0;K=f[v>>2]|0;if((f[y>>2]|0)-K>>2>>>0>c>>>0)L=+n[K+(c<<2)>>2];else L=0.0;M=L;f[q>>2]=0;c=q+4|0;f[c>>2]=0;f[q+8>>2]=0;do if(C)if(C>>>0>1073741823)gXa(q);else{K=C<<2;y=NYa(K)|0;f[q>>2]=y;N=y+(C<<2)|0;f[q+8>>2]=N;F1a(y|0,0,K|0)|0;f[c>>2]=N;O=y;P=y;break}else{O=0;P=0}while(0);if(!J){Q=P;R=O}else{O=r+4|0;P=o+44|0;y=s+4|0;N=(I|0)>0;K=t+4|0;S=C+-4|0;T=(C|0)<4;U=d+8|0;V=e+8|0;W=a+4|0;X=a+8|0;a=C&-4;Z=(C|0)>0;_=(a|0)<(C|0);$=0;do{f[r>>2]=0;f[O>>2]=0;aa=f[j>>2]|0;do if((aa|0)!=(f[F>>2]|0)){ba=f[aa+($<<3)>>2]|0;f[r>>2]=ba;ca=f[aa+($<<3)+4>>2]|0;f[O>>2]=ca;da=f[i>>2]|0;if((((ba|0)>=(0-da|0)?(ba|0)<=((f[H>>2]|0)+da-(f[W>>2]|0)|0):0)?(da=f[G>>2]|0,(ca|0)>=(0-da|0)):0)?(ca|0)<=((f[z>>2]|0)+da-(f[X>>2]|0)|0):0)ea=35}else{da=f[h>>2]|0;ca=((E-(f[P>>2]|0)|0)/(da|0)|0)+1|0;ba=($|0)/(ca|0)|0;fa=Y($-(Y(ca,ba)|0)|0,da)|0;da=Y(f[A>>2]|0,ba)|0;ba=fa-(f[i>>2]|0)|0;fa=da-(f[G>>2]|0)|0;f[r>>2]=ba;f[O>>2]=fa;if(((ba|0)%(f[m>>2]|0)|0|0)==0?((fa|0)%(f[B>>2]|0)|0|0)==0:0){ea=35;break}f[s>>2]=0;f[y>>2]=0;fa=c$(s,65)|0;ba=343815;da=fa+65|0;do{b[fa>>0]=b[ba>>0]|0;fa=fa+1|0;ba=ba+1|0}while((fa|0)<(da|0));j$(-215,s,356368,342312,1708);d$(s);ea=35}while(0);if((ea|0)==35){ea=0;p[s>>3]=M;aa=f[v>>2]|0;do if(N)if(T){ba=0;fa=aa;while(1){da=(f[D+(ba*12|0)+8>>2]|0)+(f[O>>2]|0)|0;f[t>>2]=(f[D+(ba*12|0)+4>>2]|0)+(f[r>>2]|0);f[K>>2]=da;da=Uta(o,t,f[q>>2]|0)|0;if(Z){L=+p[s>>3];ca=0;do{L=L+ +n[da+(ca<<2)>>2]*+n[fa+(ca<<2)>>2];ca=ca+1|0}while((ca|0)!=(C|0));p[s>>3]=L}ba=ba+1|0;if((ba|0)>=(I|0))break;else fa=fa+(C<<2)|0}ga=+p[s>>3];break}else{fa=0;ba=aa;while(1){ca=(f[D+(fa*12|0)+8>>2]|0)+(f[O>>2]|0)|0;f[t>>2]=(f[D+(fa*12|0)+4>>2]|0)+(f[r>>2]|0);f[K>>2]=ca;ca=Uta(o,t,f[q>>2]|0)|0;ha=+p[s>>3];da=0;do{ia=da|1;ja=da|2;ka=da|3;ha=ha+(+n[ca+(da<<2)>>2]*+n[ba+(da<<2)>>2]+ +n[ca+(ia<<2)>>2]*+n[ba+(ia<<2)>>2]+ +n[ca+(ja<<2)>>2]*+n[ba+(ja<<2)>>2]+ +n[ca+(ka<<2)>>2]*+n[ba+(ka<<2)>>2]);da=da+4|0}while((da|0)<=(S|0));p[s>>3]=ha;if(_){L=ha;da=a;do{L=L+ +n[ca+(da<<2)>>2]*+n[ba+(da<<2)>>2];da=da+1|0}while((da|0)!=(C|0));p[s>>3]=L;la=L}else la=ha;fa=fa+1|0;if((fa|0)>=(I|0)){ga=la;break}else ba=ba+(C<<2)|0}}else ga=M;while(0);do if(ga>=g){aa=f[w>>2]|0;if((aa|0)==(f[U>>2]|0))p8(d,r);else{f[aa>>2]=f[r>>2];f[aa+4>>2]=f[O>>2];f[w>>2]=aa+8}aa=f[x>>2]|0;if((aa|0)==(f[V>>2]|0)){Wra(e,s);break}else{p[aa>>3]=+p[s>>3];f[x>>2]=aa+8;break}}while(0)}$=$+1|0}while($>>>0<J>>>0);J=f[q>>2]|0;Q=J;R=J}if(Q|0){J=f[c>>2]|0;if((J|0)!=(Q|0))f[c>>2]=J+(~((J+-4-Q|0)>>>2)<<2);PYa(R)}sta(o)}if(!(f[l+4>>2]|0)){u=k;return}u=k;return}function Ita(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i+8|0;m=i;_$(j,77900);f[k>>2]=0;n=k+4|0;f[n>>2]=0;f[k+8>>2]=0;o=f[(f[a>>2]|0)+36>>2]|0;f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];Zf[o&7](a,b,c,k,d,l,m,h);h=f[k>>2]|0;if(h|0){k=f[n>>2]|0;if((k|0)!=(h|0))f[n>>2]=k+(~((k+-8-h|0)>>>3)<<3);PYa(h)}if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function Jta(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0.0,O=0,P=0.0,Q=0,R=0;l=u;u=u+288|0;m=l+272|0;n=l+112|0;o=l+264|0;q=l+252|0;r=l+240|0;s=l+228|0;t=l+216|0;v=l+204|0;w=l+200|0;x=l+144|0;y=l+136|0;z=l;A=l+128|0;B=l+120|0;_$(m,77840);p[n>>3]=1.0;QR(o,b,-1);f[q>>2]=0;C=q+4|0;f[C>>2]=0;f[q+8>>2]=0;D=a+140|0;a:do if((f[D>>2]|0)>0){E=q+8|0;F=a+4|0;G=o+4|0;H=a+8|0;if(!(i<=1.0)){I=0;J=0;K=1.0;L=0}else{Wra(q,n);M=0;break}while(1){if((I|0)==(J|0))Wra(q,n);else{p[I>>3]=K;f[C>>2]=I+8}N=+p[n>>3];O=rNa(+(f[o>>2]|0)/N)|0;if((O|0)<(f[F>>2]|0)){M=L;break a}O=rNa(+(f[G>>2]|0)/N)|0;if((O|0)<(f[H>>2]|0)){M=L;break a}P=N*i;p[n>>3]=P;O=L+1|0;if((O|0)>=(f[D>>2]|0)){M=O;break a}I=f[C>>2]|0;J=f[E>>2]|0;K=P;L=O}}else M=0;while(0);L=(M|0)>1?M:1;M=f[C>>2]|0;J=f[q>>2]|0;I=M-J>>3;D=J;J=M;if(L>>>0<=I>>>0){if(L>>>0<I>>>0?(M=D+(L<<3)|0,(J|0)!=(M|0)):0)f[C>>2]=J+(~((J+-8-M|0)>>>3)<<3)}else Mfa(q,L-I|0);I=g+4|0;if(!(f[I>>2]|f[g>>2])){f[g>>2]=f[a+20>>2];f[I>>2]=f[a+24>>2]}f[r>>2]=0;I=r+4|0;f[I>>2]=0;f[r+8>>2]=0;f[s>>2]=0;L=s+4|0;f[L>>2]=0;f[s+8>>2]=0;f[t>>2]=0;M=t+4|0;f[M>>2]=0;f[t+8>>2]=0;f[v>>2]=0;J=v+4|0;f[J>>2]=0;f[v+8>>2]=0;U$(w);do if((NS(b)|0)==65536){D=f[b+4>>2]|0;f[x>>2]=f[D>>2];n=x+4|0;E=D+4|0;f[n>>2]=f[E>>2];H=x+8|0;f[H>>2]=f[D+8>>2];f[x+12>>2]=f[D+12>>2];f[x+16>>2]=f[D+16>>2];f[x+20>>2]=f[D+20>>2];f[x+24>>2]=f[D+24>>2];f[x+28>>2]=f[D+28>>2];f[x+32>>2]=f[D+32>>2];G=f[D+36>>2]|0;f[x+36>>2]=G;f[x+40>>2]=H;H=x+48|0;F=x+44|0;f[F>>2]=H;f[H>>2]=0;f[x+52>>2]=0;if(G|0){H=G+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[E>>2]|0)<3){E=f[D+44>>2]|0;H=f[F>>2]|0;f[H>>2]=f[E>>2];f[H+4>>2]=f[E+4>>2];break}else{f[n>>2]=0;BR(x,D);break}}else OR(x,b,-1);while(0);b=f[q>>2]|0;D=(f[C>>2]|0)-b>>3;f[y>>2]=0;f[y+4>>2]=D;Vta(z,a,x,e,g,h,b,r,w,t,s);_U(y,z,-1.0);y=f[s>>2]|0;b=f[L>>2]|0;if((y|0)!=(b|0)){h=v+8|0;g=y;do{y=f[J>>2]|0;if((y|0)==(f[h>>2]|0))Wra(v,g);else{p[y>>3]=+p[g>>3];f[J>>2]=y+8}g=g+8|0}while((g|0)!=(b|0))}b=f[c>>2]|0;g=c+4|0;h=f[g>>2]|0;if((h|0)==(b|0))Q=b;else{y=h+(~((h+-16-b|0)>>>4)<<4)|0;f[g>>2]=y;Q=y}y=f[r>>2]|0;b=f[I>>2]|0;b:do if((y|0)!=(b|0)){h=c+8|0;D=Q;n=y;while(1){if((D|0)==(f[h>>2]|0))Vra(c,n);else{f[D>>2]=f[n>>2];f[D+4>>2]=f[n+4>>2];f[D+8>>2]=f[n+8>>2];f[D+12>>2]=f[n+12>>2];f[g>>2]=D+16}E=n+16|0;if((E|0)==(b|0))break b;D=f[g>>2]|0;n=E}}while(0);g=f[d>>2]|0;b=d+4|0;y=f[b>>2]|0;if((y|0)==(g|0))R=g;else{Q=y+(~((y+-8-g|0)>>>3)<<3)|0;f[b>>2]=Q;R=Q}Q=f[t>>2]|0;g=f[M>>2]|0;c:do if((Q|0)!=(g|0)){y=d+8|0;n=R;D=Q;while(1){if((n|0)==(f[y>>2]|0))Wra(d,D);else{p[n>>3]=+p[D>>3];f[b>>2]=n+8}h=D+8|0;if((h|0)==(g|0))break c;n=f[b>>2]|0;D=h}}while(0);if(k){f[A>>2]=f[a+4>>2];f[A+4>>2]=f[a+8>>2];Esa(c,d,v,j,A)}else Wta(0,c,d,~~j,.2);f[B>>2]=f[o>>2];f[B+4>>2]=f[o+4>>2];Vsa(B,c,0,d);f[z>>2]=77868;d=z+8|0;c=z+44|0;B=f[c>>2]|0;if(B|0?(o=B+12|0,B=f[o>>2]|0,f[o>>2]=B+-1,(B|0)==1):0)CR(d);f[c>>2]=0;c=z+24|0;d=z+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[d>>2]|0)>0){c=f[z+48>>2]|0;B=0;do{f[c+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[d>>2]|0))}d=f[z+52>>2]|0;if((d|0)!=(z+56|0))ZF(d);d=x+36|0;z=f[d>>2]|0;if(z|0?(B=z+12|0,z=f[B>>2]|0,f[B>>2]=z+-1,(z|0)==1):0)CR(x);f[d>>2]=0;d=x+16|0;z=x+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[z>>2]|0)>0){d=f[x+40>>2]|0;B=0;do{f[d+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[z>>2]|0))}z=f[x+44>>2]|0;if((z|0)!=(x+48|0))ZF(z);V$(w);w=f[v>>2]|0;if(w|0){v=f[J>>2]|0;if((v|0)!=(w|0))f[J>>2]=v+(~((v+-8-w|0)>>>3)<<3);PYa(w)}w=f[t>>2]|0;if(w|0){t=f[M>>2]|0;if((t|0)!=(w|0))f[M>>2]=t+(~((t+-8-w|0)>>>3)<<3);PYa(w)}w=f[s>>2]|0;if(w|0){s=f[L>>2]|0;if((s|0)!=(w|0))f[L>>2]=s+(~((s+-8-w|0)>>>3)<<3);PYa(w)}w=f[r>>2]|0;if(w|0){r=f[I>>2]|0;if((r|0)!=(w|0))f[I>>2]=r+(~((r+-16-w|0)>>>4)<<4);PYa(w)}w=f[q>>2]|0;if(w|0){q=f[C>>2]|0;if((q|0)!=(w|0))f[C>>2]=q+(~((q+-8-w|0)>>>3)<<3);PYa(w)}if(!(f[m+4>>2]|0)){u=l;return}u=l;return}function Kta(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=+h;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=u;u=u+48|0;l=k+32|0;m=k+16|0;n=k+8|0;o=k;_$(l,77820);f[m>>2]=0;p=m+4|0;f[p>>2]=0;f[m+8>>2]=0;q=f[(f[a>>2]|0)+44>>2]|0;f[n>>2]=f[e>>2];f[n+4>>2]=f[e+4>>2];f[o>>2]=f[g>>2];f[o+4>>2]=f[g+4>>2];zg[q&3](a,b,c,m,d,n,o,h,i,j);j=f[m>>2]|0;if(j|0){m=f[p>>2]|0;if((m|0)!=(j|0))f[p>>2]=m+(~((m+-8-j|0)>>>3)<<3);PYa(j)}if(!(f[l+4>>2]|0)){u=k;return}u=k;return}function Lta(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0;j=u;u=u+2496|0;k=j+2480|0;l=j+2472|0;m=j+2464|0;o=j+2456|0;p=j+2400|0;q=j+1336|0;r=j+272|0;s=j+216|0;t=j+160|0;v=j+104|0;w=j+48|0;x=j+32|0;y=j+16|0;z=j;_$(l,77800);switch(f[c>>2]&4095){case 16:case 0:break;default:{f[k>>2]=0;f[k+4>>2]=0;A=c$(k,74)|0;B=342996;C=A+74|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));j$(-215,k,343071,342312,241);d$(k)}}D=f[c+12>>2]|0;E=f[g>>2]|0;F=f[i>>2]|0;G=E+D+F|0;H=g+4|0;I=(f[H>>2]|0)+(f[c+8>>2]|0)+(f[i+4>>2]|0)|0;if(!(((((f[d+4>>2]|0)<3?(f[d+8>>2]|0)==(I|0):0)?(f[d+12>>2]|0)==(G|0):0)?(f[d>>2]&4095|0)==13:0)?(f[d+16>>2]|0)!=0:0)){f[k>>2]=I;f[k+4>>2]=G;AR(d,2,k,13)}if(!(((((f[e+4>>2]|0)<3?(f[e+8>>2]|0)==(I|0):0)?(f[e+12>>2]|0)==(G|0):0)?(f[e>>2]&4095|0)==8:0)?(f[e+16>>2]|0)!=0:0)){f[k>>2]=I;f[k+4>>2]=G;AR(e,2,k,8)}f[m>>2]=0;i=m+4|0;f[i>>2]=0;f[o>>2]=0;J=o+4|0;f[J>>2]=0;KR(c,m,o);K=(f[c>>2]|0)>>>3&511;f[p>>2]=1124007936;L=p+4|0;N=p+8|0;O=p+40|0;A=L;C=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));f[O>>2]=N;N=p+48|0;P=p+44|0;f[P>>2]=N;f[N>>2]=0;f[p+52>>2]=0;f[k>>2]=1;f[k+4>>2]=256;AR(p,2,k,5);Q=p+16|0;R=f[Q>>2]|0;if(!(b[a+72>>0]|0)){S=0;do{n[R+(S<<2)>>2]=+(S|0);S=S+1|0}while((S|0)!=256)}else{S=0;do{T=+M(+(+(S|0)));n[R+(S<<2)>>2]=T;S=S+1|0}while((S|0)!=256)}S=G+4+I|0;U=q+8|0;f[q>>2]=U;V=q+4|0;f[V>>2]=S;if(S>>>0>264){W=OYa(S>>>0>1073741823?-1:S<<2)|0;f[q>>2]=W;X=W}else X=U;W=X+4|0;S=W+(G<<2)+8|0;if((G|0)>=-1){Z=-1;while(1){_=lL(Z-(f[g>>2]|0)+(f[o>>2]|0)|0,f[m>>2]|0,4)|0;f[W+(Z<<2)>>2]=_-(f[o>>2]|0);if((Z|0)<(G|0))Z=Z+1|0;else break}}if((I|0)>=-1){Z=-1;while(1){o=lL(Z-(f[H>>2]|0)+(f[J>>2]|0)|0,f[i>>2]|0,4)|0;f[S+(Z<<2)>>2]=o-(f[J>>2]|0);if((Z|0)<(I|0))Z=Z+1|0;else break}}Z=G<<2;J=r+8|0;f[r>>2]=J;i=r+4|0;f[i>>2]=Z;if(Z>>>0>264){H=OYa(Z>>>0>1073741823?-1:Z<<2)|0;f[r>>2]=H;$=H}else $=J;H=s+4|0;f[H>>2]=2;Z=s+8|0;f[Z>>2]=1;f[s+12>>2]=G;o=s+16|0;f[o>>2]=$;f[s+20>>2]=$;m=s+24|0;g=s+40|0;_=m+8|0;f[_>>2]=0;f[_+4>>2]=0;f[g>>2]=Z;_=s+48|0;aa=s+44|0;f[aa>>2]=_;ba=(G|0)!=0;ca=G<<2;f[s>>2]=1124024325;f[_>>2]=ca;f[s+52>>2]=4;da=$+(Y(f[Z>>2]|0,ca)|0)|0;f[s+28>>2]=da;f[m>>2]=da+(0-ca)+ca;ca=$+(G<<2)|0;f[t>>2]=1124007941;da=t+4|0;f[da>>2]=2;m=t+8|0;f[m>>2]=1;Z=t+12|0;f[Z>>2]=G;ea=t+16|0;f[ea>>2]=ca;fa=t+20|0;f[fa>>2]=ca;ga=t+24|0;ha=t+28|0;ia=t+40|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;f[ia>>2]=m;ja=t+48|0;ka=t+44|0;f[ka>>2]=ja;f[t+52>>2]=0;f[ja>>2]=0;if(ba&(ca|0)==0){f[k>>2]=0;f[k+4>>2]=0;A=c$(k,26)|0;B=358223;C=A+26|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));j$(-215,k,358250,358254,500);d$(k);la=f[Z>>2]|0;ma=f[t>>2]|0;na=f[ka>>2]|0;oa=f[fa>>2]|0}else{la=G;ma=1124007941;na=ja;oa=ca}ca=la<<2;f[t>>2]=ma|16384;f[na>>2]=ca;f[na+4>>2]=4;na=oa+(Y(f[m>>2]|0,ca)|0)|0;f[ha>>2]=na;f[ga>>2]=na+(0-ca)+ca;ca=G<<1;na=$+(ca<<2)|0;f[v>>2]=1124007941;ga=v+4|0;f[ga>>2]=2;ha=v+8|0;f[ha>>2]=1;m=v+12|0;f[m>>2]=G;oa=v+16|0;f[oa>>2]=na;ma=v+20|0;f[ma>>2]=na;la=v+24|0;fa=v+28|0;Z=v+40|0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;f[Z>>2]=ha;pa=v+48|0;qa=v+44|0;f[qa>>2]=pa;f[v+52>>2]=0;f[pa>>2]=0;if(ba&(na|0)==0){f[k>>2]=0;f[k+4>>2]=0;A=c$(k,26)|0;B=358223;C=A+26|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));j$(-215,k,358250,358254,500);d$(k);ra=f[m>>2]|0;sa=f[v>>2]|0;ta=f[qa>>2]|0;ua=f[ma>>2]|0}else{ra=G;sa=1124007941;ta=pa;ua=na}na=ra<<2;f[v>>2]=sa|16384;f[ta>>2]=na;f[ta+4>>2]=4;ta=ua+(Y(f[ha>>2]|0,na)|0)|0;f[fa>>2]=ta;f[la>>2]=ta+(0-na)+na;na=G*3|0;ta=$+(na<<2)|0;f[w>>2]=1124007941;la=w+4|0;f[la>>2]=2;fa=w+8|0;f[fa>>2]=1;ha=w+12|0;f[ha>>2]=G;ua=w+16|0;f[ua>>2]=ta;sa=w+20|0;f[sa>>2]=ta;ra=w+24|0;ma=w+28|0;m=w+40|0;f[ra>>2]=0;f[ra+4>>2]=0;f[ra+8>>2]=0;f[ra+12>>2]=0;f[m>>2]=fa;va=w+48|0;wa=w+44|0;f[wa>>2]=va;f[w+52>>2]=0;f[va>>2]=0;if(ba&(ta|0)==0){f[k>>2]=0;f[k+4>>2]=0;A=c$(k,26)|0;B=358223;C=A+26|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));j$(-215,k,358250,358254,500);d$(k);xa=f[ha>>2]|0;ya=f[w>>2]|0;za=f[wa>>2]|0;Aa=f[sa>>2]|0}else{xa=G;ya=1124007941;za=va;Aa=ta}ta=xa<<2;f[w>>2]=ya|16384;f[za>>2]=ta;f[za+4>>2]=4;za=Aa+(Y(f[fa>>2]|0,ta)|0)|0;f[ma>>2]=za;f[ra>>2]=za+(0-ta)+ta;if((K|0)==2&(G|0)>-2){ta=F+E+D+1|0;D=0;while(1){E=X+(D<<2)|0;f[E>>2]=(f[E>>2]|0)*3;if((D|0)==(ta|0))break;else D=D+1|0}}D=a+36|0;T=+(f[D>>2]|0)/(b[a+144>>0]|0?6.283185307179586:3.141592653589793);if((I|0)>0){a=c+16|0;ta=c+44|0;X=c+48|0;c=d+16|0;E=d+44|0;d=e+16|0;F=e+44|0;e=(K|0)==0;K=k+8|0;za=k+12|0;ra=k+4|0;ma=x+8|0;fa=x+12|0;Aa=x+4|0;ya=y+8|0;xa=y+4|0;sa=z+8|0;ha=z+4|0;ba=(G|0)>0;Ba=k+4|0;Ca=0;do{Da=f[a>>2]|0;Ea=Da+(Y(f[f[ta>>2]>>2]|0,f[S+(Ca<<2)>>2]|0)|0)|0;Fa=f[X>>2]|0;Ga=Da+(Y(f[S+(Ca+-1<<2)>>2]|0,Fa)|0)|0;Ha=Ca;Ca=Ca+1|0;Ia=Da+(Y(f[S+(Ca<<2)>>2]|0,Fa)|0)|0;Fa=(f[c>>2]|0)+(Y(f[f[E>>2]>>2]|0,Ha)|0)|0;Da=(f[d>>2]|0)+(Y(f[f[F>>2]>>2]|0,Ha)|0)|0;if(e){if(ba){Ha=f[W>>2]|0;Ja=0;do{Ka=Ja;Ja=Ja+1|0;La=Ha;Ha=f[W+(Ja<<2)>>2]|0;n[$+(Ka<<2)>>2]=+n[R+(h[Ea+Ha>>0]<<2)>>2]-+n[R+(h[Ea+(f[W+(Ka+-1<<2)>>2]|0)>>0]<<2)>>2];n[$+(Ka+G<<2)>>2]=+n[R+(h[Ia+La>>0]<<2)>>2]-+n[R+(h[Ga+La>>0]<<2)>>2]}while((Ja|0)!=(G|0))}}else if(ba){Ja=f[W>>2]|0;Ha=0;do{La=Ha;Ha=Ha+1|0;Ka=Ja;Ja=f[W+(Ha<<2)>>2]|0;Ma=Ea+Ja|0;Na=Ea+(f[W+(La+-1<<2)>>2]|0)|0;Oa=+n[R+(h[Ma+2>>0]<<2)>>2]-+n[R+(h[Na+2>>0]<<2)>>2];Pa=Ka+2|0;Qa=+n[R+(h[Ia+Pa>>0]<<2)>>2]-+n[R+(h[Ga+Pa>>0]<<2)>>2];Ra=Oa*Oa+Qa*Qa;Sa=+n[R+(h[Ma+1>>0]<<2)>>2]-+n[R+(h[Na+1>>0]<<2)>>2];Pa=Ka+1|0;Ta=+n[R+(h[Ia+Pa>>0]<<2)>>2]-+n[R+(h[Ga+Pa>>0]<<2)>>2];Ua=Sa*Sa+Ta*Ta;Pa=Ra<Ua;Va=+n[R+(h[Ma>>0]<<2)>>2]-+n[R+(h[Na>>0]<<2)>>2];Wa=+n[R+(h[Ia+Ka>>0]<<2)>>2]-+n[R+(h[Ga+Ka>>0]<<2)>>2];Ka=(Pa?Ua:Ra)<Va*Va+Wa*Wa;n[$+(La<<2)>>2]=Ka?Va:Pa?Sa:Oa;n[$+(La+G<<2)>>2]=Ka?Wa:Pa?Ta:Qa}while((Ha|0)!=(G|0))}f[K>>2]=0;f[za>>2]=0;f[k>>2]=16842752;f[ra>>2]=s;f[ma>>2]=0;f[fa>>2]=0;f[x>>2]=16842752;f[Aa>>2]=t;Ha=ya;f[Ha>>2]=0;f[Ha+4>>2]=0;f[y>>2]=33619968;f[xa>>2]=v;Ha=sa;f[Ha>>2]=0;f[Ha+4>>2]=0;f[z>>2]=33619968;f[ha>>2]=w;kN(k,x,y,z,0);if(ba){Ha=0;do{Qa=+n[$+(Ha+ca<<2)>>2];Ta=T*+n[$+(Ha+na<<2)>>2]+-.5;Ga=~~Ta;Ia=Ga-(+(Ga|0)>Ta&1)|0;Wa=Ta-+(Ia|0);Ga=Ha<<1;n[Fa+(Ga<<2)>>2]=Qa*(1.0-Wa);Ea=Ga|1;n[Fa+(Ea<<2)>>2]=Qa*Wa;Ja=f[D>>2]|0;if((Ia|0)<0)Xa=Ia+Ja|0;else Xa=Ia-((Ia|0)<(Ja|0)?0:Ja)|0;if(Xa>>>0>=Ja>>>0){f[k>>2]=0;f[Ba>>2]=0;A=c$(k,32)|0;B=343087;C=A+32|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));j$(-215,k,343071,342312,543);d$(k)}b[Da+Ga>>0]=Xa;Ja=Xa+1|0;b[Da+Ea>>0]=(Ja|0)<(f[D>>2]|0)?Ja&255:0;Ha=Ha+1|0}while((Ha|0)<(G|0))}}while((Ca|0)<(I|0))}I=w+36|0;Ca=f[I>>2]|0;if(Ca|0?(G=Ca+12|0,Ca=f[G>>2]|0,f[G>>2]=Ca+-1,(Ca|0)==1):0)CR(w);f[I>>2]=0;f[ua>>2]=0;f[ua+4>>2]=0;f[ua+8>>2]=0;f[ua+12>>2]=0;if((f[la>>2]|0)>0){ua=f[m>>2]|0;m=0;do{f[ua+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[la>>2]|0))}la=f[wa>>2]|0;if((la|0)!=(va|0))ZF(la);la=v+36|0;va=f[la>>2]|0;if(va|0?(wa=va+12|0,va=f[wa>>2]|0,f[wa>>2]=va+-1,(va|0)==1):0)CR(v);f[la>>2]=0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((f[ga>>2]|0)>0){oa=f[Z>>2]|0;Z=0;do{f[oa+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[ga>>2]|0))}ga=f[qa>>2]|0;if((ga|0)!=(pa|0))ZF(ga);ga=t+36|0;pa=f[ga>>2]|0;do if(pa|0){qa=pa+12|0;Z=f[qa>>2]|0;f[qa>>2]=Z+-1;if((Z|0)!=1)break;CR(t)}while(0);f[ga>>2]=0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[da>>2]|0)>0){ea=f[ia>>2]|0;ia=0;do{f[ea+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[da>>2]|0))}da=f[ka>>2]|0;if((da|0)!=(ja|0))ZF(da);da=s+36|0;ja=f[da>>2]|0;do if(ja|0){ka=ja+12|0;ia=f[ka>>2]|0;f[ka>>2]=ia+-1;if((ia|0)!=1)break;CR(s)}while(0);f[da>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[H>>2]|0)>0){o=f[g>>2]|0;g=0;do{f[o+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[H>>2]|0))}H=f[aa>>2]|0;if((H|0)!=(_|0))ZF(H);H=f[r>>2]|0;if((H|0)!=(J|0)){if(H|0)QYa(H);f[r>>2]=J;f[i>>2]=264}i=f[q>>2]|0;if((i|0)!=(U|0)){if(i|0)QYa(i);f[q>>2]=U;f[V>>2]=264}V=p+36|0;U=f[V>>2]|0;do if(U|0){q=U+12|0;i=f[q>>2]|0;f[q>>2]=i+-1;if((i|0)!=1)break;CR(p)}while(0);f[V>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[L>>2]|0)>0){Q=f[O>>2]|0;O=0;do{f[Q+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[L>>2]|0))}L=f[P>>2]|0;if((L|0)!=(N|0))ZF(L);if(!(f[l+4>>2]|0)){u=j;return}u=j;return}function Mta(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0;j=u;u=u+384|0;k=j+376|0;l=j+368|0;m=j+40|0;o=j+24|0;q=j+16|0;r=j;s=j+8|0;_$(k,77780);t=f[d>>2]|0;v=d+4|0;w=f[v>>2]|0;if((w|0)!=(t|0))f[v>>2]=w+(~((w+-8-t|0)>>>3)<<3);t=f[e>>2]|0;w=e+4|0;x=f[w>>2]|0;if((x|0)!=(t|0))f[w>>2]=x+(~((x+-8-t|0)>>>3)<<3);t=a+76|0;x=a+80|0;if((f[t>>2]|0)!=(f[x>>2]|0)?(y=f[c>>2]|0,z=f[c+4>>2]|0,A=z,B=y,(y|0)!=(z|0)):0){z=f[h>>2]|0;y=h+4|0;C=f[y>>2]|0;if(!(C|z)){D=f[a+28>>2]|0;f[h>>2]=D;E=f[a+32>>2]|0;f[y>>2]=E;F=D;G=E}else{F=z;G=C}C=f[a+20>>2]|0;z=(F|0)<(C|0);E=z?C:F;D=z?F:C;if((D|0)>0){C=E;F=D;while(1){D=(C|0)%(F|0)|0;if((D|0)>0){z=F;F=D;C=z}else{H=F;break}}}else H=E;E=f[a+24>>2]|0;F=(G|0)<(E|0);C=F?E:G;z=F?G:E;if((z|0)>0){E=C;G=z;while(1){z=(E|0)%(G|0)|0;if((z|0)>0){F=G;G=z;E=F}else{I=G;break}}}else I=C;f[l>>2]=H;f[l+4>>2]=I;C=A-B>>3;B=f[i>>2]|0;A=H+-1+((B|0)>0?B:0)&0-H;f[i>>2]=A;H=i+4|0;B=f[H>>2]|0;G=I+-1+((B|0)>0?B:0)&0-I;f[H>>2]=G;I=b+12|0;B=(A<<1)+(f[I>>2]|0)|0;A=b+8|0;E=(G<<1)+(f[A>>2]|0)|0;Sta(m,a,b,i,i,1,l);if(!C)J=Y(((E-(f[m+48>>2]|0)|0)/(f[y>>2]|0)|0)+1|0,((B-(f[m+44>>2]|0)|0)/(f[h>>2]|0)|0)+1|0)|0;else J=C;C=f[m+16>>2]|0;h=Y(f[m+64>>2]|0,f[m+60>>2]|0)|0;B=f[m+76>>2]|0;y=Tta(a)|0;E=f[t>>2]|0;if((f[x>>2]|0)-E>>2>>>0>y>>>0)K=+n[E+(y<<2)>>2];else K=0.0;L=K;f[o>>2]=0;y=o+4|0;f[y>>2]=0;f[o+8>>2]=0;do if(B)if(B>>>0>1073741823)gXa(o);else{E=B<<2;x=NYa(E)|0;f[o>>2]=x;l=x+(B<<2)|0;f[o+8>>2]=l;F1a(x|0,0,E|0)|0;f[y>>2]=l;M=x;N=x;break}else{M=0;N=0}while(0);if(!J){O=N;P=M}else{M=q+4|0;N=e+8|0;x=a+4|0;l=a+8|0;a=(h|0)>0;E=s+4|0;b=B+-4|0;G=(B|0)<4;F=d+8|0;z=B&-4;D=(B|0)>0;Q=(z|0)<(B|0);R=0;do{f[q>>2]=0;f[M>>2]=0;S=f[c>>2]|0;T=f[S+(R<<3)>>2]|0;f[q>>2]=T;U=f[S+(R<<3)+4>>2]|0;f[M>>2]=U;S=f[i>>2]|0;if((((T|0)>=(0-S|0)?(T|0)<=((f[I>>2]|0)+S-(f[x>>2]|0)|0):0)?(S=f[H>>2]|0,(U|0)>=(0-S|0)):0)?(U|0)<=((f[A>>2]|0)+S-(f[l>>2]|0)|0):0){p[r>>3]=L;S=f[t>>2]|0;a:do if(a){if(G){V=0;W=T;X=U;Z=S;while(1){_=(f[C+(V*12|0)+8>>2]|0)+X|0;f[s>>2]=(f[C+(V*12|0)+4>>2]|0)+W;f[E>>2]=_;_=Uta(m,s,f[o>>2]|0)|0;if(D){K=+p[r>>3];$=0;do{K=K+ +n[_+($<<2)>>2]*+n[Z+($<<2)>>2];$=$+1|0}while(($|0)!=(B|0));p[r>>3]=K}$=V+1|0;if(($|0)>=(h|0))break a;V=$;W=f[q>>2]|0;X=f[M>>2]|0;Z=Z+(B<<2)|0}}else{aa=0;ba=T;ca=U;da=S}while(1){Z=(f[C+(aa*12|0)+8>>2]|0)+ca|0;f[s>>2]=(f[C+(aa*12|0)+4>>2]|0)+ba;f[E>>2]=Z;Z=Uta(m,s,f[o>>2]|0)|0;ea=+p[r>>3];X=0;do{W=X|1;V=X|2;$=X|3;ea=ea+(+n[Z+(X<<2)>>2]*+n[da+(X<<2)>>2]+ +n[Z+(W<<2)>>2]*+n[da+(W<<2)>>2]+ +n[Z+(V<<2)>>2]*+n[da+(V<<2)>>2]+ +n[Z+($<<2)>>2]*+n[da+($<<2)>>2]);X=X+4|0}while((X|0)<=(b|0));p[r>>3]=ea;if(Q){K=ea;X=z;do{K=K+ +n[Z+(X<<2)>>2]*+n[da+(X<<2)>>2];X=X+1|0}while((X|0)!=(B|0));p[r>>3]=K}X=aa+1|0;if((X|0)>=(h|0))break a;aa=X;ba=f[q>>2]|0;ca=f[M>>2]|0;da=da+(B<<2)|0}}while(0);S=f[w>>2]|0;if((S|0)==(f[N>>2]|0))Wra(e,r);else{p[S>>3]=+p[r>>3];f[w>>2]=S+8}do if(+p[r>>3]>=g){S=f[v>>2]|0;if((S|0)==(f[F>>2]|0)){p8(d,q);break}else{f[S>>2]=f[q>>2];f[S+4>>2]=f[M>>2];f[v>>2]=S+8;break}}while(0)}else{p[r>>3]=-10.0;S=f[w>>2]|0;if((S|0)==(f[N>>2]|0))Wra(e,r);else{p[S>>3]=-10.0;f[w>>2]=S+8}}R=R+1|0}while(R>>>0<J>>>0);J=f[o>>2]|0;O=J;P=J}if(O|0){J=f[y>>2]|0;if((J|0)!=(O|0))f[y>>2]=J+(~((J+-4-O|0)>>>2)<<2);PYa(P)}sta(m)}if(!(f[k+4>>2]|0)){u=j;return}u=j;return}function Nta(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=u;u=u+144|0;i=h+128|0;j=h+116|0;k=h+112|0;l=h+104|0;m=h;n=h+96|0;_$(i,77720);f[j>>2]=0;o=j+4|0;f[o>>2]=0;f[j+8>>2]=0;U$(k);p=(f[d+4>>2]|0)-(f[d>>2]|0)>>5;f[l>>2]=0;f[l+4>>2]=p;f[n>>2]=8;f[n+4>>2]=8;Ota(m,a,b,e,n,d,j,k);_U(l,m,-1.0);f[m>>2]=77748;l=m+8|0;d=m+44|0;n=f[d>>2]|0;if(n|0?(b=n+12|0,n=f[b>>2]|0,f[b>>2]=n+-1,(n|0)==1):0)CR(l);f[d>>2]=0;d=m+24|0;l=m+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[l>>2]|0)>0){d=f[m+48>>2]|0;n=0;do{f[d+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[l>>2]|0))}l=f[m+52>>2]|0;if((l|0)!=(m+56|0))ZF(l);l=f[o>>2]|0;m=f[j>>2]|0;n=l-m>>4;d=c+4|0;b=f[d>>2]|0;a=f[c>>2]|0;p=b-a>>4;q=a;a=b;b=m;m=l;if(n>>>0<=p>>>0)if(n>>>0<p>>>0?(l=q+(n<<4)|0,(a|0)!=(l|0)):0){f[d>>2]=a+(~((a+-16-l|0)>>>4)<<4);r=b;s=m}else{r=b;s=m}else{gsa(c,n-p|0);r=f[j>>2]|0;s=f[o>>2]|0}if((r|0)!=(s|0)){p=r;r=f[c>>2]|0;while(1){f[r>>2]=f[p>>2];f[r+4>>2]=f[p+4>>2];f[r+8>>2]=f[p+8>>2];f[r+12>>2]=f[p+12>>2];p=p+16|0;if((p|0)==(s|0))break;else r=r+16|0}}Bsa(c,g,.2);V$(k);k=f[j>>2]|0;if(k|0){j=f[o>>2]|0;if((j|0)!=(k|0))f[o>>2]=j+(~((j+-16-k|0)>>>4)<<4);PYa(k)}if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function Ota(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f[a>>2]=77748;j=a+8|0;f[j>>2]=1124007936;k=a+12|0;l=a+16|0;m=a+48|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;n=a+56|0;o=a+52|0;f[o>>2]=n;f[n>>2]=0;f[a+60>>2]=0;n=a+76|0;f[n>>2]=0;q=a+80|0;f[q>>2]=0;f[a+4>>2]=b;if((j|0)==(c|0)){r=a+64|0;p[r>>3]=d;s=f[e>>2]|0;f[n>>2]=s;t=e+4|0;u=f[t>>2]|0;f[q>>2]=u;v=a+72|0;f[v>>2]=g;w=a+84|0;f[w>>2]=h;x=a+88|0;f[x>>2]=i;return}b=c+36|0;y=f[b>>2]|0;if(y){z=y+12|0;f[z>>2]=(f[z>>2]|0)+1;z=a+44|0;y=f[z>>2]|0;if((y|0)!=0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0){CR(j);B=z}else B=z}else B=a+44|0;f[B>>2]=0;z=a+24|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[k>>2]|0)>0){y=f[m>>2]|0;m=0;do{f[y+(m<<2)>>2]=0;m=m+1|0;C=f[k>>2]|0}while((m|0)<(C|0));f[j>>2]=f[c>>2];if((C|0)<3)D=12;else D=14}else{f[j>>2]=f[c>>2];D=12}if((D|0)==12){C=f[c+4>>2]|0;if((C|0)<3){f[k>>2]=C;f[l>>2]=f[c+8>>2];f[a+20>>2]=f[c+12>>2];l=f[c+44>>2]|0;C=f[o>>2]|0;f[C>>2]=f[l>>2];f[C+4>>2]=f[l+4>>2]}else D=14}if((D|0)==14)BR(j,c);f[z>>2]=f[c+16>>2];f[a+28>>2]=f[c+20>>2];f[a+32>>2]=f[c+24>>2];f[a+36>>2]=f[c+28>>2];f[a+40>>2]=f[c+32>>2];f[B>>2]=f[b>>2];r=a+64|0;p[r>>3]=d;s=f[e>>2]|0;f[n>>2]=s;t=e+4|0;u=f[t>>2]|0;f[q>>2]=u;v=a+72|0;f[v>>2]=g;w=a+84|0;f[w>>2]=h;x=a+88|0;f[x>>2]=i;return}function Pta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=77748;b=a+8|0;c=a+44|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+24|0;b=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+48>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+52>>2]|0;if((b|0)==(a+56|0))return;ZF(b);return}function Qta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=77748;b=a+8|0;c=a+44|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+24|0;b=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+48>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+52>>2]|0;if((b|0)==(a+56|0)){PYa(a);return}ZF(b);PYa(a);return}function Rta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0;c=u;u=u+256|0;d=c+232|0;e=c+224|0;g=c+168|0;h=c+104|0;i=c+160|0;j=c+48|0;k=c+40|0;l=c+24|0;m=c+16|0;n=c+8|0;o=c;_$(e,77760);q=f[b>>2]|0;r=f[b+4>>2]|0;b=a+8|0;s=a+20|0;t=a+72|0;v=+p[f[f[t>>2]>>2]>>3];w=+(f[s>>2]|0)/v;x=~~w;y=(+(x|0)<w&1)+x|0;x=a+16|0;w=+(f[x>>2]|0)/v;z=~~w;A=(+(z|0)<w&1)+z|0;z=f[b>>2]&4095;f[g>>2]=1124007936;B=g+4|0;C=g+8|0;D=g+40|0;E=B;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[D>>2]=C;C=g+48|0;E=g+44|0;f[E>>2]=C;f[C>>2]=0;f[g+52>>2]=0;f[d>>2]=A;f[d+4>>2]=y;AR(g,2,d,z);f[d>>2]=0;z=d+4|0;f[z>>2]=0;f[d+8>>2]=0;if((q|0)<(r|0)){y=i+4|0;A=g+16|0;F=a+48|0;G=k+4|0;H=a+24|0;I=a+56|0;J=j+36|0;K=h+36|0;L=h+16|0;M=h+4|0;N=h+40|0;O=j+4|0;P=j+8|0;Q=h+8|0;R=j+12|0;S=h+12|0;T=j+44|0;U=h+44|0;V=j+16|0;W=j+20|0;X=h+20|0;Y=j+24|0;Z=h+24|0;_=j+28|0;$=h+28|0;aa=j+32|0;ba=h+32|0;ca=j+40|0;da=j+48|0;ea=a+4|0;fa=a+64|0;ga=n+4|0;ha=a+76|0;ia=o+4|0;ja=a+80|0;ka=a+88|0;la=h+48|0;ma=a+84|0;a=j+4|0;na=j+8|0;oa=j+12|0;pa=j+8|0;qa=j+12|0;ra=j+4|0;sa=l+8|0;ta=l+4|0;ua=m+4|0;va=q;do{w=+p[(f[f[t>>2]>>2]|0)+(va<<5)>>3];q=rNa(+(f[s>>2]|0)/w)|0;wa=rNa(+(f[x>>2]|0)/w)|0;f[i>>2]=q;f[y>>2]=wa;CN(h,i,f[b>>2]&4095,f[A>>2]|0,0);xa=f[F>>2]|0;if((wa|0)==(f[xa>>2]|0)?(q|0)==(f[xa+4>>2]|0):0){f[k>>2]=q;f[G>>2]=wa;CN(j,k,f[b>>2]&4095,f[H>>2]|0,f[I>>2]|0);xa=f[J>>2]|0;if(xa|0){ya=xa+12|0;f[ya>>2]=(f[ya>>2]|0)+1}ya=f[K>>2]|0;if(ya|0?(xa=ya+12|0,ya=f[xa>>2]|0,f[xa>>2]=ya+-1,(ya|0)==1):0)CR(h);f[K>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[M>>2]|0)>0){ya=f[N>>2]|0;xa=0;do{f[ya+(xa<<2)>>2]=0;xa=xa+1|0;za=f[M>>2]|0}while((xa|0)<(za|0));f[h>>2]=f[j>>2];if((za|0)<3)Aa=14;else Aa=16}else{f[h>>2]=f[j>>2];Aa=14}if((Aa|0)==14){Aa=0;xa=f[O>>2]|0;if((xa|0)<3){f[M>>2]=xa;f[Q>>2]=f[P>>2];f[S>>2]=f[R>>2];xa=f[T>>2]|0;ya=f[U>>2]|0;f[ya>>2]=f[xa>>2];f[ya+4>>2]=f[xa+4>>2]}else Aa=16}if((Aa|0)==16){Aa=0;BR(h,j)}f[L>>2]=f[V>>2];f[X>>2]=f[W>>2];f[Z>>2]=f[Y>>2];f[$>>2]=f[_>>2];f[ba>>2]=f[aa>>2];xa=f[J>>2]|0;f[K>>2]=xa;if(xa|0?(ya=xa+12|0,xa=f[ya>>2]|0,f[ya>>2]=xa+-1,(xa|0)==1):0)CR(j);f[J>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[O>>2]|0)>0){xa=f[ca>>2]|0;ya=0;do{f[xa+(ya<<2)>>2]=0;ya=ya+1|0}while((ya|0)<(f[O>>2]|0))}ya=f[T>>2]|0;if((ya|0)!=(da|0))ZF(ya)}else{f[pa>>2]=0;f[qa>>2]=0;f[j>>2]=16842752;f[ra>>2]=b;ya=sa;f[ya>>2]=0;f[ya+4>>2]=0;f[l>>2]=33619968;f[ta>>2]=h;f[m>>2]=q;f[ua>>2]=wa;fna(j,l,m,0.0,0.0,1)}ya=f[ea>>2]|0;xa=f[(f[ya>>2]|0)+56>>2]|0;Ba=f[f[t>>2]>>2]|0;v=+p[fa>>3];f[n>>2]=0;f[ga>>2]=0;f[o>>2]=f[ha>>2];f[ia>>2]=f[ja>>2];Th[xa&7](ya,h,Ba+(va<<5)+8|0,d,Ba+(va<<5)+20|0,v,n,o);Ba=f[ea>>2]|0;ya=rNa(w*+(f[Ba+4>>2]|0))|0;xa=rNa(w*+(f[Ba+8>>2]|0))|0;W$(f[ka>>2]|0);Ba=f[z>>2]|0;Ca=f[d>>2]|0;if((Ba|0)!=(Ca|0)){Da=Ca;Ca=Ba;Ba=0;while(1){Ea=Da;Fa=f[ma>>2]|0;Ga=rNa(w*+(f[Ea+(Ba<<3)>>2]|0))|0;Ha=rNa(w*+(f[Ea+(Ba<<3)+4>>2]|0))|0;f[j>>2]=Ga;f[a>>2]=Ha;f[na>>2]=ya;f[oa>>2]=xa;Ea=Fa+4|0;Ia=f[Ea>>2]|0;if((Ia|0)==(f[Fa+8>>2]|0)){Vra(Fa,j);Ja=f[d>>2]|0;Ka=f[z>>2]|0}else{f[Ia>>2]=Ga;f[Ia+4>>2]=Ha;f[Ia+8>>2]=ya;f[Ia+12>>2]=xa;f[Ea>>2]=Ia+16;Ja=Da;Ka=Ca}Ba=Ba+1|0;if(Ba>>>0>=Ka-Ja>>3>>>0)break;else{Da=Ja;Ca=Ka}}}X$(f[ka>>2]|0);Ca=f[K>>2]|0;if(Ca|0?(Da=Ca+12|0,Ca=f[Da>>2]|0,f[Da>>2]=Ca+-1,(Ca|0)==1):0)CR(h);f[K>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[M>>2]|0)>0){Ca=f[N>>2]|0;Da=0;do{f[Ca+(Da<<2)>>2]=0;Da=Da+1|0}while((Da|0)<(f[M>>2]|0))}Da=f[U>>2]|0;if((Da|0)!=(la|0))ZF(Da);va=va+1|0}while((va|0)<(r|0));r=f[d>>2]|0;if(r|0){d=f[z>>2]|0;if((d|0)!=(r|0))f[z>>2]=d+(~((d+-8-r|0)>>>3)<<3);PYa(r)}}r=g+36|0;d=f[r>>2]|0;if(d|0?(z=d+12|0,d=f[z>>2]|0,f[z>>2]=d+-1,(d|0)==1):0)CR(g);f[r>>2]=0;r=g+16|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[B>>2]|0)>0){r=f[D>>2]|0;D=0;do{f[r+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[B>>2]|0))}B=f[E>>2]|0;if((B|0)!=(C|0))ZF(B);if(!(f[e+4>>2]|0)){u=c;return}u=c;return}function Sta(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;f[a>>2]=77632;i=a+4|0;j=a+32|0;f[a+92>>2]=0;f[a+96>>2]=0;k=a+100|0;l=a+108|0;m=a+140|0;n=a+104|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;n=j;o=n+44|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=a+148|0;f[a+144>>2]=l;f[l>>2]=0;f[a+152>>2]=0;f[k>>2]=1124007941;k=a+156|0;l=a+164|0;m=a+196|0;n=a+160|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=a+204|0;f[a+200>>2]=l;f[l>>2]=0;f[a+208>>2]=0;f[k>>2]=1124007936;f[a+212>>2]=1124007936;k=a+220|0;l=a+252|0;n=a+216|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[l>>2]=k;k=a+260|0;f[a+256>>2]=k;f[k>>2]=0;f[a+264>>2]=0;f[a+268>>2]=1124007936;k=a+276|0;l=a+308|0;n=a+272|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[l>>2]=k;k=a+316|0;f[a+312>>2]=k;f[k>>2]=0;f[a+320>>2]=0;Xh[f[(f[a>>2]|0)+8>>2]&127](a,b,c,d,e,g,h);return}function Tta(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+16|0;d=c;e=a+12|0;g=f[e>>2]|0;h=a+28|0;if(((g|0)%(f[h>>2]|0)|0|0)==0?((f[a+16>>2]|0)%(f[a+32>>2]|0)|0|0)==0:0)i=g;else{f[d>>2]=0;f[d+4>>2]=0;j=c$(d,80)|0;k=342599;l=j+80|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,d,342680,342312,90);d$(d);i=f[e>>2]|0}g=a+4|0;m=f[g>>2]|0;n=a+20|0;o=f[n>>2]|0;if(((m-i|0)%(o|0)|0|0)==0?(p=f[a+8>>2]|0,q=f[a+16>>2]|0,r=f[a+24>>2]|0,((p-q|0)%(r|0)|0|0)==0):0){s=i;t=q;v=m;w=o;x=p;y=r}else{f[d>>2]=0;f[d+4>>2]=0;j=c$(d,123)|0;k=342698;l=j+123|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,d,342680,342312,92);d$(d);s=f[e>>2]|0;t=f[a+16>>2]|0;v=f[g>>2]|0;w=f[n>>2]|0;x=f[a+8>>2]|0;y=f[a+24>>2]|0}n=Y((s|0)/(f[h>>2]|0)|0,f[a+36>>2]|0)|0;h=Y(Y(Y(n,(t|0)/(f[a+32>>2]|0)|0)|0,((v-s|0)/(w|0)|0)+1|0)|0,((x-t|0)/(y|0)|0)+1|0)|0;u=c;return h|0}function Uta(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0,H=0.0,I=0.0,J=0;e=u;u=u+96|0;g=e;i=e+88|0;j=e+32|0;k=f[a+96>>2]|0;l=(f[c>>2]|0)+(f[a+92>>2]|0)|0;f[c>>2]=l;m=c+4|0;o=(f[m>>2]|0)+k|0;f[m>>2]=o;do if(b[a+28>>0]|0){k=a+52|0;p=f[k>>2]|0;if(((l|0)%(p|0)|0|0)==0?(q=f[a+56>>2]|0,((o|0)%(q|0)|0|0)==0):0){r=p;s=l;t=q;v=o}else{f[g>>2]=0;f[g+4>>2]=0;q=c$(g,63)|0;p=342526;w=q+63|0;do{b[q>>0]=b[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(w|0));j$(-215,g,342590,342312,875);d$(g);r=f[k>>2]|0;s=f[c>>2]|0;t=f[a+56>>2]|0;v=f[m>>2]|0}p=(s|0)/(r|0)|0;q=((v|0)/(t|0)|0|0)%(f[a+108>>2]|0)|0;w=a+32|0;if((v|0)!=(f[(f[w>>2]|0)+(q<<2)>>2]|0)){f[g>>2]=q;f[g+4>>2]=q+1;f[i>>2]=-2147483648;f[i+4>>2]=2147483647;DR(j,a+156|0,g,i);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;gL(j,g)|0;f[(f[w>>2]|0)+(q<<2)>>2]=f[m>>2];w=j+36|0;x=f[w>>2]|0;if(x|0?(y=x+12|0,x=f[y>>2]|0,f[y>>2]=x+-1,(x|0)==1):0)CR(j);f[w>>2]=0;w=j+16|0;x=j+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[x>>2]|0)>0){w=f[j+40>>2]|0;y=0;do{f[w+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[x>>2]|0))}x=f[j+44>>2]|0;if((x|0)!=(j+48|0))ZF(x)}x=(f[a+116>>2]|0)+(Y(f[f[a+144>>2]>>2]|0,q)|0)|0;y=a+76|0;w=x+((Y(f[y>>2]|0,p)|0)<<2)|0;x=(f[a+172>>2]|0)+(Y(f[f[a+200>>2]>>2]|0,q)|0)+p|0;if(!(b[x>>0]|0)){b[x>>0]=1;z=f[m>>2]|0;A=f[c>>2]|0;B=w;C=y;break}else{D=w;u=e;return D|0}}else{z=o;A=l;B=d;C=a+76|0}while(0);d=f[a+80>>2]|0;l=f[a+84>>2]|0;o=f[a+88>>2]|0;c=A<<1;A=(f[a+228>>2]|0)+(Y(f[f[a+256>>2]>>2]|0,z)|0)+(c<<2)|0;m=(f[a+284>>2]|0)+(Y(f[f[a+312>>2]>>2]|0,z)|0)+c|0;F1a(B|0,0,f[C>>2]<<2|0)|0;C=f[a+4>>2]|0;if((d|0)>0){c=0;do{z=A+(f[C+(c*44|0)>>2]<<2)|0;E=+n[C+(c*44|0)+40>>2]*+n[C+(c*44|0)+24>>2];j=m+(f[C+(c*44|0)+4>>2]|0)|0;g=B+(f[C+(c*44|0)+8>>2]<<2)|0;i=g+(h[j>>0]<<2)|0;v=g+(h[j+1>>0]<<2)|0;F=+n[v>>2]+E*+n[z+4>>2];n[i>>2]=+n[i>>2]+E*+n[z>>2];n[v>>2]=F;c=c+1|0}while((c|0)!=(d|0));G=d}else G=0;if((G|0)<(l|0)){d=G;do{c=A+(f[C+(d*44|0)>>2]<<2)|0;F=+n[c>>2];E=+n[c+4>>2];c=m+(f[C+(d*44|0)+4>>2]|0)|0;v=h[c>>0]|0;z=h[c+1>>0]|0;c=B+(f[C+(d*44|0)+8>>2]<<2)|0;i=C+(d*44|0)+40|0;H=+n[i>>2]*+n[C+(d*44|0)+24>>2];j=c+(v<<2)|0;g=c+(z<<2)|0;I=+n[g>>2]+E*H;n[j>>2]=+n[j>>2]+F*H;n[g>>2]=I;g=B+(f[C+(d*44|0)+12>>2]<<2)|0;I=+n[i>>2]*+n[C+(d*44|0)+28>>2];i=g+(v<<2)|0;v=g+(z<<2)|0;H=+n[v>>2]+E*I;n[i>>2]=+n[i>>2]+F*I;n[v>>2]=H;d=d+1|0}while((d|0)!=(l|0));J=l}else J=G;if((J|0)<(o|0)){G=J;do{J=A+(f[C+(G*44|0)>>2]<<2)|0;H=+n[J>>2];I=+n[J+4>>2];J=m+(f[C+(G*44|0)+4>>2]|0)|0;l=h[J>>0]|0;d=h[J+1>>0]|0;J=B+(f[C+(G*44|0)+8>>2]<<2)|0;v=C+(G*44|0)+40|0;F=+n[v>>2]*+n[C+(G*44|0)+24>>2];i=J+(l<<2)|0;z=J+(d<<2)|0;E=+n[z>>2]+I*F;n[i>>2]=+n[i>>2]+H*F;n[z>>2]=E;z=B+(f[C+(G*44|0)+12>>2]<<2)|0;E=+n[v>>2]*+n[C+(G*44|0)+28>>2];i=z+(l<<2)|0;J=z+(d<<2)|0;F=+n[J>>2]+I*E;n[i>>2]=+n[i>>2]+H*E;n[J>>2]=F;J=B+(f[C+(G*44|0)+16>>2]<<2)|0;F=+n[v>>2]*+n[C+(G*44|0)+32>>2];i=J+(l<<2)|0;z=J+(d<<2)|0;E=+n[z>>2]+I*F;n[i>>2]=+n[i>>2]+H*F;n[z>>2]=E;z=B+(f[C+(G*44|0)+20>>2]<<2)|0;E=+n[v>>2]*+n[C+(G*44|0)+36>>2];v=z+(l<<2)|0;l=z+(d<<2)|0;F=+n[l>>2]+I*E;n[v>>2]=+n[v>>2]+H*E;n[l>>2]=F;G=G+1|0}while((G|0)!=(o|0))}Gh[f[(f[a>>2]|0)+12>>2]&511](a,B);D=B;u=e;return D|0}function Vta(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;f[a>>2]=77868;m=a+8|0;f[m>>2]=1124007936;n=a+12|0;o=a+16|0;q=a+48|0;r=n;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=o;r=a+56|0;s=a+52|0;f[s>>2]=r;f[r>>2]=0;f[a+60>>2]=0;r=a+72|0;t=a+76|0;u=a+80|0;v=a+84|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[a+4>>2]=b;if((m|0)==(c|0)){w=a+64|0;p[w>>3]=d;x=f[e>>2]|0;f[r>>2]=x;y=e+4|0;z=f[y>>2]|0;f[t>>2]=z;A=f[g>>2]|0;f[u>>2]=A;B=g+4|0;C=f[B>>2]|0;f[v>>2]=C;D=a+88|0;f[D>>2]=h;E=a+92|0;f[E>>2]=i;F=a+96|0;f[F>>2]=k;G=a+100|0;f[G>>2]=l;H=a+104|0;f[H>>2]=j;return}b=c+36|0;I=f[b>>2]|0;if(I){J=I+12|0;f[J>>2]=(f[J>>2]|0)+1;J=a+44|0;I=f[J>>2]|0;if((I|0)!=0?(K=I+12|0,I=f[K>>2]|0,f[K>>2]=I+-1,(I|0)==1):0){CR(m);L=J}else L=J}else L=a+44|0;f[L>>2]=0;J=a+24|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[n>>2]|0)>0){I=f[q>>2]|0;q=0;do{f[I+(q<<2)>>2]=0;q=q+1|0;M=f[n>>2]|0}while((q|0)<(M|0));f[m>>2]=f[c>>2];if((M|0)<3)N=12;else N=14}else{f[m>>2]=f[c>>2];N=12}if((N|0)==12){M=f[c+4>>2]|0;if((M|0)<3){f[n>>2]=M;f[o>>2]=f[c+8>>2];f[a+20>>2]=f[c+12>>2];o=f[c+44>>2]|0;M=f[s>>2]|0;f[M>>2]=f[o>>2];f[M+4>>2]=f[o+4>>2]}else N=14}if((N|0)==14)BR(m,c);f[J>>2]=f[c+16>>2];f[a+28>>2]=f[c+20>>2];f[a+32>>2]=f[c+24>>2];f[a+36>>2]=f[c+28>>2];f[a+40>>2]=f[c+32>>2];f[L>>2]=f[b>>2];w=a+64|0;p[w>>3]=d;x=f[e>>2]|0;f[r>>2]=x;y=e+4|0;z=f[y>>2]|0;f[t>>2]=z;A=f[g>>2]|0;f[u>>2]=A;B=g+4|0;C=f[B>>2]|0;f[v>>2]=C;D=a+88|0;f[D>>2]=h;E=a+92|0;f[E>>2]=i;F=a+96|0;f[F>>2]=k;G=a+100|0;f[G>>2]=l;H=a+104|0;f[H>>2]=j;return}function Wta(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;a=u;u=u+96|0;h=a+16|0;i=a+88|0;j=a+72|0;k=a+8|0;l=a+60|0;m=a+48|0;n=a+32|0;o=a;_$(i,77880);if((e|0)>=1?(q=f[c>>2]|0,r=c+4|0,s=f[r>>2]|0,(q|0)!=(s|0)):0){t=d+4|0;if((s-q>>4|0)!=((f[t>>2]|0)-(f[d>>2]|0)>>3|0)){f[h>>2]=0;f[h+4>>2]=0;q=c$(h,33)|0;s=343355;v=q+33|0;do{b[q>>0]=b[s>>0]|0;q=q+1|0;s=s+1|0}while((q|0)<(v|0));j$(-215,h,343389,342312,3793);d$(h)}f[j>>2]=0;s=j+4|0;f[s>>2]=0;f[j+8>>2]=0;p[k>>3]=g;f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];k=Ura(c,j,h)|0;f[h>>2]=0;q=h+4|0;f[q>>2]=0;f[h+8>>2]=0;v=(k|0)==0;do if(!v)if(k>>>0>134217727)gXa(h);else{w=k<<5;x=NYa(w)|0;f[h>>2]=x;f[h+8>>2]=x+(k<<5);F1a(x|0,0,w|0)|0;f[q>>2]=x+w;y=x;break}else y=0;while(0);f[l>>2]=0;x=l+4|0;f[x>>2]=0;f[l+8>>2]=0;if(v)z=0;else{w=k<<2;A=NYa(w)|0;f[l>>2]=A;B=A+(k<<2)|0;f[l+8>>2]=B;F1a(A|0,0,w|0)|0;f[x>>2]=B;z=A}f[m>>2]=0;A=m+4|0;f[A>>2]=0;f[m+8>>2]=0;if(v){C=0;D=0}else{v=NYa(k<<3)|0;f[A>>2]=v;f[m>>2]=v;B=v+(k<<3)|0;f[m+8>>2]=B;w=v;E=k;while(1){p[w>>3]=-1797693134862315708145274.0e284;E=E+-1|0;if(!E)break;else w=w+8|0}f[A>>2]=B;C=v;D=v}v=f[j>>2]|0;B=(f[s>>2]|0)-v|0;w=B>>2;E=v;if((B|0)>0){B=0;do{v=f[E+(B<<2)>>2]|0;F=f[c>>2]|0;G=y+(v<<5)|0;p[G>>3]=+(f[F+(B<<4)>>2]|0)+ +p[G>>3];G=y+(v<<5)+8|0;p[G>>3]=+(f[F+(B<<4)+4>>2]|0)+ +p[G>>3];G=y+(v<<5)+16|0;p[G>>3]=+(f[F+(B<<4)+8>>2]|0)+ +p[G>>3];G=y+(v<<5)+24|0;p[G>>3]=+(f[F+(B<<4)+12>>2]|0)+ +p[G>>3];G=D+(v<<3)|0;H=+p[G>>3];I=+p[(f[d>>2]|0)+(B<<3)>>3];p[G>>3]=H<I?I:H;G=z+(v<<2)|0;f[G>>2]=(f[G>>2]|0)+1;B=B+1|0}while((B|0)<(w|0))}w=(k|0)>0;if(w){B=0;do{E=y+(B<<5)|0;G=y+(B<<5)+8|0;v=y+(B<<5)+16|0;F=y+(B<<5)+24|0;H=1.0/+(f[z+(B<<2)>>2]|0);I=+p[G>>3]*H;J=+p[v>>3]*H;K=+p[F>>3]*H;p[E>>3]=+p[E>>3]*H;p[G>>3]=I;p[v>>3]=J;p[F>>3]=K;B=B+1|0}while((B|0)!=(k|0))}B=f[c>>2]|0;F=f[r>>2]|0;if((F|0)!=(B|0))f[r>>2]=F+(~((F+-16-B|0)>>>4)<<4);B=f[d>>2]|0;F=f[t>>2]|0;if((F|0)!=(B|0))f[t>>2]=F+(~((F+-8-B|0)>>>3)<<3);if(w){w=n+4|0;B=n+8|0;F=n+12|0;v=c+8|0;G=d+8|0;E=f[l>>2]|0;L=f[m>>2]|0;M=y;y=z;z=D;N=0;while(1){O=rNa(+p[M+(N<<5)>>3])|0;P=rNa(+p[M+(N<<5)+8>>3])|0;Q=rNa(+p[M+(N<<5)+16>>3])|0;R=rNa(+p[M+(N<<5)+24>>3])|0;f[n>>2]=O;f[w>>2]=P;f[B>>2]=Q;f[F>>2]=R;S=f[y+(N<<2)>>2]|0;p[o>>3]=+p[z+(N<<3)>>3];do if((S|0)>(e|0)){T=f[h>>2]|0;U=Q+O|0;V=R+P|0;W=(S|0)>3?S:3;a:do if((S|0)<3){X=0;while(1){do if((X|0)!=(N|0)?(f[y+(X<<2)>>2]|0)>(e|0):0){Y=rNa(+p[T+(X<<5)>>3])|0;Z=rNa(+p[T+(X<<5)+8>>3])|0;_=rNa(+p[T+(X<<5)+16>>3])|0;$=rNa(+p[T+(X<<5)+24>>3])|0;aa=rNa(+(_|0)*g)|0;ba=rNa(+($|0)*g)|0;if((O|0)<(Y-aa|0)|(P|0)<(Z-ba|0))break;if((U|0)>(_+Y+aa|0))break;if((V|0)<=($+Z+ba|0)){ca=X;break a}}while(0);ba=X+1|0;if((ba|0)<(k|0))X=ba;else{ca=ba;break}}}else{X=0;while(1){ba=f[y+(X<<2)>>2]|0;do if((X|0)!=(N|0)&(ba|0)>(e|0)){Z=rNa(+p[T+(X<<5)>>3])|0;$=rNa(+p[T+(X<<5)+8>>3])|0;aa=rNa(+p[T+(X<<5)+16>>3])|0;Y=rNa(+p[T+(X<<5)+24>>3])|0;_=rNa(+(aa|0)*g)|0;da=rNa(+(Y|0)*g)|0;if((O|0)<(Z-_|0)|(P|0)<($-da|0))break;if((U|0)>(aa+Z+_|0))break;if((ba|0)>(W|0)?(V|0)<=(Y+$+da|0):0){ca=X;break a}}while(0);ba=X+1|0;if((ba|0)<(k|0))X=ba;else{ca=ba;break}}}while(0);if((ca|0)==(k|0)){V=f[r>>2]|0;if((V|0)==(f[v>>2]|0))Vra(c,n);else{f[V>>2]=O;f[V+4>>2]=P;f[V+8>>2]=Q;f[V+12>>2]=R;f[r>>2]=V+16}V=f[t>>2]|0;if((V|0)==(f[G>>2]|0)){Wra(d,o);break}else{p[V>>3]=+p[o>>3];f[t>>2]=V+8;break}}}while(0);R=N+1|0;if((R|0)>=(k|0))break;M=f[h>>2]|0;y=E;z=L;N=R}N=f[m>>2]|0;ea=N;fa=N}else{ea=D;fa=C}if(ea|0){C=f[A>>2]|0;if((C|0)!=(ea|0))f[A>>2]=C+(~((C+-8-ea|0)>>>3)<<3);PYa(fa)}fa=f[l>>2]|0;if(fa|0){l=f[x>>2]|0;if((l|0)!=(fa|0))f[x>>2]=l+(~((l+-4-fa|0)>>>2)<<2);PYa(fa)}fa=f[h>>2]|0;if(fa|0){h=f[q>>2]|0;if((h|0)!=(fa|0))f[q>>2]=h+(~((h+-32-fa|0)>>>5)<<5);PYa(fa)}fa=f[j>>2]|0;if(fa|0){j=f[s>>2]|0;if((j|0)!=(fa|0))f[s>>2]=j+(~((j+-4-fa|0)>>>2)<<2);PYa(fa)}}if(!(f[i+4>>2]|0)){u=a;return}u=a;return}function Xta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=77868;b=a+8|0;c=a+44|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+24|0;b=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+48>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+52>>2]|0;if((b|0)==(a+56|0))return;ZF(b);return}function Yta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=77868;b=a+8|0;c=a+44|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+24|0;b=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+48>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+52>>2]|0;if((b|0)==(a+56|0)){PYa(a);return}ZF(b);PYa(a);return}function Zta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0;c=u;u=u+272|0;d=c+248|0;e=c+192|0;g=c+176|0;h=c;i=c+112|0;j=c+168|0;k=c+56|0;l=c+48|0;m=c+32|0;n=c+24|0;o=c+16|0;q=c+8|0;r=f[b>>2]|0;s=f[b+4>>2]|0;do if((r|0)<=0)if((s|0)>1){t=+p[(f[a+88>>2]|0)+(r+1<<3)>>3];break}else{b=f[a+20>>2]|0;v=f[a+16>>2]|0;t=+(((b|0)<(v|0)?v:b)|0);break}else t=+p[(f[a+88>>2]|0)+(r<<3)>>3];while(0);b=a+8|0;v=a+20|0;w=+(f[v>>2]|0)/t;x=~~w;y=(+(x|0)<w&1)+x|0;x=a+16|0;w=+(f[x>>2]|0)/t;z=~~w;A=(+(z|0)<w&1)+z|0;z=f[b>>2]&4095;f[e>>2]=1124007936;B=e+4|0;C=e+8|0;D=e+40|0;E=B;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[D>>2]=C;C=e+48|0;E=e+44|0;f[E>>2]=C;f[C>>2]=0;f[e+52>>2]=0;f[d>>2]=A;f[d+4>>2]=y;AR(e,2,d,z);f[d>>2]=0;z=d+4|0;f[z>>2]=0;f[d+8>>2]=0;f[g>>2]=0;y=g+4|0;f[y>>2]=0;f[g+8>>2]=0;if((r|0)<(s|0)){A=a+88|0;F=j+4|0;G=e+16|0;H=a+48|0;I=l+4|0;J=a+24|0;K=a+56|0;L=k+36|0;M=i+36|0;N=i+16|0;O=i+4|0;P=i+40|0;Q=k+4|0;R=k+8|0;S=i+8|0;T=k+12|0;U=i+12|0;V=k+44|0;W=i+44|0;X=k+16|0;Y=k+20|0;Z=i+20|0;_=k+24|0;$=i+24|0;aa=k+28|0;ba=i+28|0;ca=k+32|0;da=i+32|0;ea=k+40|0;fa=k+48|0;ga=a+4|0;ha=a+64|0;ia=a+72|0;ja=o+4|0;ka=a+76|0;la=a+80|0;ma=q+4|0;na=a+84|0;oa=k+4|0;pa=k+8|0;qa=a+104|0;ra=a+96|0;sa=i+48|0;ta=a+92|0;ua=k+4|0;va=k+8|0;wa=k+12|0;xa=a+100|0;a=k+8|0;ya=k+12|0;za=k+4|0;Aa=m+8|0;Ba=m+4|0;Ca=n+4|0;Da=r;do{w=+p[(f[A>>2]|0)+(Da<<3)>>3];p[h>>3]=w;r=rNa(+(f[v>>2]|0)/w)|0;Ea=rNa(+(f[x>>2]|0)/w)|0;f[j>>2]=r;f[F>>2]=Ea;CN(i,j,f[b>>2]&4095,f[G>>2]|0,0);Fa=f[H>>2]|0;if((Ea|0)==(f[Fa>>2]|0)?(r|0)==(f[Fa+4>>2]|0):0){f[l>>2]=r;f[I>>2]=Ea;CN(k,l,f[b>>2]&4095,f[J>>2]|0,f[K>>2]|0);Fa=f[L>>2]|0;if(Fa|0){Ga=Fa+12|0;f[Ga>>2]=(f[Ga>>2]|0)+1}Ga=f[M>>2]|0;if(Ga|0?(Fa=Ga+12|0,Ga=f[Fa>>2]|0,f[Fa>>2]=Ga+-1,(Ga|0)==1):0)CR(i);f[M>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[O>>2]|0)>0){Ga=f[P>>2]|0;Fa=0;do{f[Ga+(Fa<<2)>>2]=0;Fa=Fa+1|0;Ha=f[O>>2]|0}while((Fa|0)<(Ha|0));f[i>>2]=f[k>>2];if((Ha|0)<3)Ia=19;else Ia=21}else{f[i>>2]=f[k>>2];Ia=19}if((Ia|0)==19){Ia=0;Fa=f[Q>>2]|0;if((Fa|0)<3){f[O>>2]=Fa;f[S>>2]=f[R>>2];f[U>>2]=f[T>>2];Fa=f[V>>2]|0;Ga=f[W>>2]|0;f[Ga>>2]=f[Fa>>2];f[Ga+4>>2]=f[Fa+4>>2]}else Ia=21}if((Ia|0)==21){Ia=0;BR(i,k)}f[N>>2]=f[X>>2];f[Z>>2]=f[Y>>2];f[$>>2]=f[_>>2];f[ba>>2]=f[aa>>2];f[da>>2]=f[ca>>2];Fa=f[L>>2]|0;f[M>>2]=Fa;if(Fa|0?(Ga=Fa+12|0,Fa=f[Ga>>2]|0,f[Ga>>2]=Fa+-1,(Fa|0)==1):0)CR(k);f[L>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[Q>>2]|0)>0){Fa=f[ea>>2]|0;Ga=0;do{f[Fa+(Ga<<2)>>2]=0;Ga=Ga+1|0}while((Ga|0)<(f[Q>>2]|0))}Ga=f[V>>2]|0;if((Ga|0)!=(fa|0))ZF(Ga)}else{f[a>>2]=0;f[ya>>2]=0;f[k>>2]=16842752;f[za>>2]=b;Ga=Aa;f[Ga>>2]=0;f[Ga+4>>2]=0;f[m>>2]=33619968;f[Ba>>2]=i;f[n>>2]=r;f[Ca>>2]=Ea;fna(k,m,n,0.0,0.0,1)}Ga=f[ga>>2]|0;Fa=f[(f[Ga>>2]|0)+36>>2]|0;w=+p[ha>>3];f[o>>2]=f[ia>>2];f[ja>>2]=f[ka>>2];f[q>>2]=f[la>>2];f[ma>>2]=f[na>>2];f[k>>2]=0;f[oa>>2]=0;f[pa>>2]=0;Zf[Fa&7](Ga,i,d,g,w,o,q,k);Ga=f[k>>2]|0;if(Ga|0){Fa=f[oa>>2]|0;if((Fa|0)!=(Ga|0))f[oa>>2]=Fa+(~((Fa+-8-Ga|0)>>>3)<<3);PYa(Ga)}Ga=f[ga>>2]|0;w=+p[h>>3];Fa=rNa(+(f[Ga+4>>2]|0)*w)|0;Ja=rNa(w*+(f[Ga+8>>2]|0))|0;W$(f[qa>>2]|0);Ga=f[d>>2]|0;if((f[z>>2]|0)!=(Ga|0)){Ka=Ga;Ga=0;do{La=Ka;Ma=f[ta>>2]|0;w=+p[h>>3];Na=rNa(+(f[La+(Ga<<3)>>2]|0)*w)|0;Oa=rNa(w*+(f[La+(Ga<<3)+4>>2]|0))|0;f[k>>2]=Na;f[ua>>2]=Oa;f[va>>2]=Fa;f[wa>>2]=Ja;La=Ma+4|0;Pa=f[La>>2]|0;if((Pa|0)==(f[Ma+8>>2]|0))Vra(Ma,k);else{f[Pa>>2]=Na;f[Pa+4>>2]=Oa;f[Pa+8>>2]=Fa;f[Pa+12>>2]=Ja;f[La>>2]=Pa+16}Pa=f[xa>>2]|0;do if(Pa|0){La=Pa+4|0;Oa=f[La>>2]|0;if((Oa|0)==(f[Pa+8>>2]|0)){Wra(Pa,h);break}else{p[Oa>>3]=+p[h>>3];f[La>>2]=Oa+8;break}}while(0);Ga=Ga+1|0;Ka=f[d>>2]|0}while(Ga>>>0<(f[z>>2]|0)-Ka>>3>>>0)}X$(f[qa>>2]|0);if(f[ra>>2]|0?(f[g>>2]|0)!=(f[y>>2]|0):0){W$(f[qa>>2]|0);Ka=f[z>>2]|0;Ga=f[d>>2]|0;if((Ka|0)!=(Ga|0)){Ja=Ga;Ga=Ka;Ka=0;while(1){Fa=f[ra>>2]|0;Ea=(f[g>>2]|0)+(Ka<<3)|0;r=Fa+4|0;Pa=f[r>>2]|0;if((Pa|0)==(f[Fa+8>>2]|0)){Wra(Fa,Ea);Qa=f[d>>2]|0;Ra=f[z>>2]|0}else{p[Pa>>3]=+p[Ea>>3];f[r>>2]=Pa+8;Qa=Ja;Ra=Ga}Ka=Ka+1|0;if(Ka>>>0>=Ra-Qa>>3>>>0)break;else{Ja=Qa;Ga=Ra}}}X$(f[qa>>2]|0)}Ga=f[M>>2]|0;if(Ga|0?(Ja=Ga+12|0,Ga=f[Ja>>2]|0,f[Ja>>2]=Ga+-1,(Ga|0)==1):0)CR(i);f[M>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[O>>2]|0)>0){Ga=f[P>>2]|0;Ja=0;do{f[Ga+(Ja<<2)>>2]=0;Ja=Ja+1|0}while((Ja|0)<(f[O>>2]|0))}Ja=f[W>>2]|0;if((Ja|0)!=(sa|0))ZF(Ja);Da=Da+1|0}while((Da|0)<(s|0));s=f[g>>2]|0;if(s|0){g=f[y>>2]|0;if((g|0)!=(s|0))f[y>>2]=g+(~((g+-8-s|0)>>>3)<<3);PYa(s)}}s=f[d>>2]|0;if(s|0){d=f[z>>2]|0;if((d|0)!=(s|0))f[z>>2]=d+(~((d+-8-s|0)>>>3)<<3);PYa(s)}s=e+36|0;d=f[s>>2]|0;if(d|0?(z=d+12|0,d=f[z>>2]|0,f[z>>2]=d+-1,(d|0)==1):0)CR(e);f[s>>2]=0;s=e+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[B>>2]|0)>0){s=f[D>>2]|0;D=0;do{f[s+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[B>>2]|0))}B=f[E>>2]|0;if((B|0)==(C|0)){u=c;return}ZF(B);u=c;return}function _ta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){F1a(g|0,0,b<<2|0)|0;f[e>>2]=g+(b<<2);return}h=f[a>>2]|0;i=g-h|0;g=i>>2;j=g+b|0;if(j>>>0>1073741823)gXa(a);k=d-h|0;d=k>>1;l=k>>2>>>0<536870911?(d>>>0<j>>>0?j:d):1073741823;do if(l)if(l>>>0>1073741823){d=De(8)|0;UYa(d,358155);f[d>>2]=130560;Of(d|0,21520,875)}else{m=NYa(l<<2)|0;break}else m=0;while(0);d=m+(g<<2)|0;F1a(d|0,0,b<<2|0)|0;j=d+(0-g<<2)|0;if((i|0)>0)K1a(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<2);f[c>>2]=m+(l<<2);if(!h)return;PYa(h);return}function $ta(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d+8|0;g=d;if(!(mi[f[(f[a>>2]|0)+12>>2]&255](a)|0)){u=d;return a|0}h=a+32|0;if((f[h>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;i=c$(e,30)|0;j=354672;k=i+30|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-2,e,373532,354703,1186);d$(e)}f[g>>2]=0;f[g+4>>2]=0;iY(e,a,a+12|0,13,g);d$(g);hY(a,f[c>>2]|0);hY(a,f[c+4>>2]|0);jY(e);if(!(f[h>>2]&4)){u=d;return a|0}f[h>>2]=6;u=d;return a|0}function aua(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d+8|0;g=d;b[e>>0]=49;b[e+1>>0]=102;b[e+2>>0]=0;h=f[a>>2]|0;f[g>>2]=0;f[g+4>>2]=0;a=xKa(e)|0;if(a|0)K1a(c$(g,a)|0,e|0,a|0)|0;a=f[c>>2]|0;e=f[c+4>>2]|0;ZX(h,g,(a|0)==(e|0)?0:a,e-a|0);d$(g);u=d;return}function bua(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+16|0;g=e+8|0;h=e;i=f[a>>2]|0;j=f[i+40>>2]|0;b[g>>0]=49;b[g+1>>0]=102;b[g+2>>0]=0;k=j>>>0>d>>>0?d:j;j=c+4|0;d=f[j>>2]|0;l=f[c>>2]|0;m=d-l>>2;n=l;l=d;if(k>>>0<=m>>>0)if(k>>>0<m>>>0?(d=n+(k<<2)|0,(l|0)!=(d|0)):0){f[j>>2]=l+(~((l+-4-d|0)>>>2)<<2);o=i}else o=i;else{_ta(c,k-m|0);o=f[a>>2]|0}f[h>>2]=0;f[h+4>>2]=0;a=xKa(g)|0;if(!a){p=f[c>>2]|0;q=f[j>>2]|0;r=(p|0)==(q|0);s=r?0:p;t=k<<2;dY(o,h,s,t)|0;d$(h);u=e;return}K1a(c$(h,a)|0,g|0,a|0)|0;p=f[c>>2]|0;q=f[j>>2]|0;r=(p|0)==(q|0);s=r?0:p;t=k<<2;dY(o,h,s,t)|0;d$(h);u=e;return}function cua(){RX(1973324,344392,232,957,162,157,233);Fd(946,1973324,x|0)|0;return}function dua(a){a=a|0;if((b[899832]|0)==0?u1a(899832)|0:0){f[224960]=77656;f[224961]=64;f[224962]=128;f[224963]=16;f[224964]=16;f[224965]=8;f[224966]=8;f[224967]=8;f[224968]=8;f[224969]=9;f[224970]=1;p[112486]=-1.0;f[224974]=0;p[112488]=.2;b[899912]=1;f[224979]=0;f[224980]=0;f[224981]=0;f[224982]=1124007936;f[224983]=0;f[224984]=0;f[224985]=0;f[224986]=0;f[224987]=0;f[224988]=0;f[224989]=0;f[224990]=899936;f[224991]=899968;f[224993]=0;f[224992]=0;n[224994]=-1.0;f[224995]=64;b[899984]=0;Fd(670,899840,x|0)|0}return (f[f[19490]>>2]|0)==(f[a>>2]|0)|0}function eua(a){a=a|0;var b=0;if(!a)return;b=f[a>>2]|0;if(!b)return;ki[f[(f[b>>2]|0)+4>>2]&2047](b);f[a>>2]=0;return}function fua(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[e>>2]=a;f[e+4>>2]=c;c=NYa(152)|0;f[c>>2]=77656;f[c+4>>2]=64;f[c+8>>2]=128;f[c+12>>2]=16;f[c+16>>2]=16;f[c+20>>2]=8;f[c+24>>2]=8;f[c+28>>2]=8;f[c+32>>2]=8;f[c+36>>2]=9;f[c+40>>2]=1;p[c+48>>3]=-1.0;f[c+56>>2]=0;p[c+64>>3]=.2;b[c+72>>0]=1;f[c+76>>2]=0;f[c+80>>2]=0;f[c+84>>2]=0;f[c+88>>2]=1124007936;a=c+92|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[c+120>>2]=c+96;a=c+128|0;f[c+124>>2]=a;f[c+132>>2]=0;f[a>>2]=0;n[c+136>>2]=-1.0;f[c+140>>2]=64;b[c+144>>0]=0;if(Bta(c,e)|0){g=c;u=d;return g|0}ki[f[(f[c>>2]|0)+4>>2]&2047](c);g=0;u=d;return g|0}function gua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;d=u;u=u+48|0;e=d+8|0;g=d;if(!((a|0)!=0&(c|0)!=0)){u=d;return}WX(e,a,0);a=f[(f[c>>2]|0)+16>>2]|0;f[g>>2]=0;f[g+4>>2]=0;if(b|0?(h=xKa(b)|0,h|0):0)K1a(c$(g,h)|0,b|0,h|0)|0;fi[a&255](c,e,g);d$(g);dV(e);u=d;return}function hua(a){a=a|0;var b=0,c=0,d=0;if(!a){b=0;return b|0}c=NYa(152)|0;f[c>>2]=77656;d=c+4|0;f[c+76>>2]=0;f[c+80>>2]=0;f[c+84>>2]=0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;f[c+88>>2]=1124007936;d=c+92|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[c+120>>2]=c+96;d=c+128|0;f[c+124>>2]=d;f[c+132>>2]=0;f[d>>2]=0;Gh[f[(f[a>>2]|0)+28>>2]&511](a,c);b=c;return b|0}function iua(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=0;b=a+4|0;f[b>>2]=0;f[a+8>>2]=0;c=NYa(15124)|0;f[b>>2]=c;f[a>>2]=c;d=c+15124|0;f[a+8>>2]=d;a=c;c=77964;while(1){f[a>>2]=f[c>>2];c=c+4|0;if((c|0)==93088)break;else a=a+4|0}f[b>>2]=d;return}function jua(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=0;b=a+4|0;f[b>>2]=0;f[a+8>>2]=0;c=NYa(7924)|0;f[b>>2]=c;f[a>>2]=c;d=c+7924|0;f[a+8>>2]=d;a=c;c=93088;while(1){f[a>>2]=f[c>>2];c=c+4|0;if((c|0)==101012)break;else a=a+4|0}f[b>>2]=d;return}function kua(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=101020;d$(a+184|0);b=a+72|0;c=a+108|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+88|0;b=a+76|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+112>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+116>>2]|0;if((b|0)!=(a+120|0))ZF(b);b=a+16|0;d=a+52|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+32|0;b=a+20|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+56>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+60>>2]|0;if((b|0)==(a+64|0)){OF(a);return}ZF(b);OF(a);return}function lua(a){a=a|0;kua(a);PYa(a);return}function mua(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;XF(a,c);f[e>>2]=0;f[e+4>>2]=0;g=c$(e,4)|0;b[g>>0]=110;b[g+1>>0]=97;b[g+2>>0]=109;b[g+3>>0]=101;g=YX(c,e)|0;d$(e);i=YX(g,a+184|0)|0;f[e>>2]=0;f[e+4>>2]=0;g=c$(e,7)|0;b[g>>0]=b[345368]|0;b[g+1>>0]=b[345369]|0;b[g+2>>0]=b[345370]|0;b[g+3>>0]=b[345371]|0;b[g+4>>0]=b[345372]|0;b[g+5>>0]=b[345373]|0;b[g+6>>0]=b[345374]|0;g=YX(i,e)|0;d$(e);i=a+132|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](g)|0){j=c+32|0;if((f[j>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=c$(e,30)|0;l=354672;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-2,e,373532,354703,1186);d$(e)}eY(g,c+12|0,f[i>>2]|0);if(f[j>>2]&4|0)f[j>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=c$(e,9)|0;l=345376;m=k+9|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j=YX(g,e)|0;d$(e);g=a+136|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](j)|0){i=c+32|0;if((f[i>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=c$(e,30)|0;l=354672;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-2,e,373532,354703,1186);d$(e)}eY(j,c+12|0,f[g>>2]|0);if(f[i>>2]&4|0)f[i>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=c$(e,15)|0;l=345386;m=k+15|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));i=YX(j,e)|0;d$(e);j=a+152|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](i)|0){g=c+32|0;if((f[g>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=c$(e,30)|0;l=354672;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-2,e,373532,354703,1186);d$(e)}fY(i,c+12|0,+n[j>>2]);if(f[g>>2]&4|0)f[g>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=c$(e,12)|0;l=345402;m=k+12|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));g=YX(i,e)|0;d$(e);i=a+144|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](g)|0){j=c+32|0;if((f[j>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=c$(e,30)|0;l=354672;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-2,e,373532,354703,1186);d$(e)}gY(g,c+12|0,+p[i>>3]);if(f[j>>2]&4|0)f[j>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=c$(e,15)|0;l=345415;m=k+15|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j=YX(g,e)|0;d$(e);g=a+156|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](j)|0){i=c+32|0;if((f[i>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=c$(e,30)|0;l=354672;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-2,e,373532,354703,1186);d$(e)}fY(j,c+12|0,+n[g>>2]);if(f[i>>2]&4|0)f[i>>2]=6}f[e>>2]=0;f[e+4>>2]=0;i=c$(e,7)|0;b[i>>0]=b[345431]|0;b[i+1>>0]=b[345432]|0;b[i+2>>0]=b[345433]|0;b[i+3>>0]=b[345434]|0;b[i+4>>0]=b[345435]|0;b[i+5>>0]=b[345436]|0;b[i+6>>0]=b[345437]|0;i=YX(j,e)|0;d$(e);j=a+160|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](i)|0){g=c+32|0;if((f[g>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=c$(e,30)|0;l=354672;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-2,e,373532,354703,1186);d$(e)}fY(i,c+12|0,+n[j>>2]);if(f[g>>2]&4|0)f[g>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=c$(e,6)|0;b[g>>0]=b[345439]|0;b[g+1>>0]=b[345440]|0;b[g+2>>0]=b[345441]|0;b[g+3>>0]=b[345442]|0;b[g+4>>0]=b[345443]|0;b[g+5>>0]=b[345444]|0;g=YX(i,e)|0;d$(e);i=a+164|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](g)|0){j=c+32|0;if((f[j>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=c$(e,30)|0;l=354672;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-2,e,373532,354703,1186);d$(e)}fY(g,c+12|0,+n[i>>2]);if(f[j>>2]&4|0)f[j>>2]=6}f[e>>2]=0;f[e+4>>2]=0;j=c$(e,6)|0;b[j>>0]=b[345446]|0;b[j+1>>0]=b[345447]|0;b[j+2>>0]=b[345448]|0;b[j+3>>0]=b[345449]|0;b[j+4>>0]=b[345450]|0;b[j+5>>0]=b[345451]|0;j=YX(g,e)|0;d$(e);g=a+168|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](j)|0){i=c+32|0;if((f[i>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=c$(e,30)|0;l=354672;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-2,e,373532,354703,1186);d$(e)}fY(j,c+12|0,+n[g>>2]);if(f[i>>2]&4|0)f[i>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=c$(e,28)|0;l=345453;m=k+28|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));i=YX(j,e)|0;d$(e);j=a+172|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](i)|0){g=c+32|0;if((f[g>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=c$(e,30)|0;l=354672;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-2,e,373532,354703,1186);d$(e)}fY(i,c+12|0,+n[j>>2]);if(f[g>>2]&4|0)f[g>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=c$(e,13)|0;l=345482;m=k+13|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));g=YX(i,e)|0;d$(e);i=h[a+176>>0]|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](g)|0){j=c+32|0;if((f[j>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=c$(e,30)|0;l=354672;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-2,e,373532,354703,1186);d$(e)}eY(g,c+12|0,i);if(f[j>>2]&4|0)f[j>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=c$(e,11)|0;l=345496;m=k+11|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j=YX(g,e)|0;d$(e);g=h[a+177>>0]|0;if(mi[f[(f[c>>2]|0)+12>>2]&255](j)|0){i=c+32|0;if((f[i>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=c$(e,30)|0;l=354672;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-2,e,373532,354703,1186);d$(e)}eY(j,c+12|0,g);if(f[i>>2]&4|0)f[i>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=c$(e,15)|0;l=345508;m=k+15|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));i=YX(j,e)|0;d$(e);j=a+180|0;if(!(mi[f[(f[c>>2]|0)+12>>2]&255](i)|0)){u=d;return}a=c+32|0;if((f[a>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=c$(e,30)|0;l=354672;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-2,e,373532,354703,1186);d$(e)}fY(i,c+12|0,+n[j>>2]);if(!(f[a>>2]&4)){u=d;return}f[a>>2]=6;u=d;return}function nua(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+112|0;e=d;g=d+8|0;h=d+104|0;i=d+96|0;j=d+88|0;k=d+80|0;l=d+72|0;m=d+64|0;n=d+56|0;o=d+48|0;q=d+40|0;r=d+32|0;s=d+24|0;t=d+16|0;$X(g,c,345330);f[e>>2]=0;f[e+4>>2]=0;rY(g,e,e);g=f[e>>2]|0;v=f[a+184>>2]|0;if((g|0)!=(v|0)){w=(KKa((g|0)==0?5694105:g,(v|0)==0?5694105:v)|0)==0;d$(e);if(!w){f[e>>2]=0;f[e+4>>2]=0;w=c$(e,27)|0;v=345335;g=w+27|0;do{b[w>>0]=b[v>>0]|0;w=w+1|0;v=v+1|0}while((w|0)<(g|0));j$(-215,e,345363,344667,307);d$(e)}}else d$(e);$X(h,c,345368);oY(h,e,0);f[a+132>>2]=f[e>>2];$X(i,c,345376);oY(i,e,0);f[a+136>>2]=f[e>>2];$X(j,c,345386);pY(j,e,0.0);f[a+152>>2]=f[e>>2];$X(k,c,345402);qY(k,e,0.0);p[a+144>>3]=+p[e>>3];$X(l,c,345415);pY(l,e,0.0);f[a+156>>2]=f[e>>2];$X(m,c,345431);pY(m,e,0.0);f[a+160>>2]=f[e>>2];$X(n,c,345439);pY(n,e,0.0);f[a+164>>2]=f[e>>2];$X(o,c,345446);pY(o,e,0.0);f[a+168>>2]=f[e>>2];$X(q,c,345453);pY(q,e,0.0);f[a+172>>2]=f[e>>2];$X(r,c,345482);oY(r,e,0);b[a+176>>0]=(f[e>>2]|0)!=0&1;$X(s,c,345496);oY(s,e,0);s=f[e>>2]|0;b[a+177>>0]=s>>>0<256?s:(s|0)>0?255:0;$X(t,c,345508);pY(t,e,0.0);f[a+180>>2]=f[e>>2];u=d;return}function oua(a,c,d,e){a=a|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0;g=u;u=u+224|0;h=g+208|0;i=g+152|0;j=g+144|0;k=g+80|0;l=g+88|0;m=g+72|0;o=g;_$(h,101236);q=a+128|0;do if(!(e>=1.0|(f[q>>2]|0)==0)){QR(i,c,-1);if(!((f[i>>2]|0)!=(f[a+4>>2]|0)?1:(f[i+4>>2]|0)!=(f[a+8>>2]|0))?(r=RR(c,-1)|0,(r|0)==(f[a+12>>2]|0)):0)break;else{s=5;break}}else s=5;while(0);if((s|0)==5){QR(j,c,-1);Sua(a,j,RR(c,-1)|0)}do if((NS(c)|0)==65536){j=f[c+4>>2]|0;f[i>>2]=f[j>>2];s=i+4|0;r=j+4|0;f[s>>2]=f[r>>2];t=i+8|0;f[t>>2]=f[j+8>>2];f[i+12>>2]=f[j+12>>2];f[i+16>>2]=f[j+16>>2];f[i+20>>2]=f[j+20>>2];f[i+24>>2]=f[j+24>>2];f[i+28>>2]=f[j+28>>2];f[i+32>>2]=f[j+32>>2];v=f[j+36>>2]|0;f[i+36>>2]=v;w=i+40|0;f[w>>2]=t;t=i+48|0;x=i+44|0;f[x>>2]=t;f[t>>2]=0;f[i+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[r>>2]|0)<3){r=f[j+44>>2]|0;t=f[x>>2]|0;f[t>>2]=f[r>>2];f[t+4>>2]=f[r+4>>2];y=w;break}else{f[s>>2]=0;BR(i,j);y=w;break}}else{OR(i,c,-1);y=i+40|0}while(0);c=f[y>>2]|0;w=f[c>>2]|0;f[k>>2]=f[c+4>>2];f[k+4>>2]=w;KS(d,k,0,-1,0,0);do if((NS(d)|0)==65536){k=f[d+4>>2]|0;f[l>>2]=f[k>>2];w=l+4|0;c=k+4|0;f[w>>2]=f[c>>2];j=l+8|0;f[j>>2]=f[k+8>>2];f[l+12>>2]=f[k+12>>2];f[l+16>>2]=f[k+16>>2];f[l+20>>2]=f[k+20>>2];f[l+24>>2]=f[k+24>>2];f[l+28>>2]=f[k+28>>2];f[l+32>>2]=f[k+32>>2];s=f[k+36>>2]|0;f[l+36>>2]=s;f[l+40>>2]=j;j=l+48|0;r=l+44|0;f[r>>2]=j;f[j>>2]=0;f[l+52>>2]=0;if(s|0){j=s+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[c>>2]|0)<3){c=f[k+44>>2]|0;j=f[r>>2]|0;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];break}else{f[w>>2]=0;BR(l,k);break}}else OR(l,d,-1);while(0);d=f[q>>2]|0;k=d+1|0;f[q>>2]=k;if(e>=0.0&(d|0)>0)z=e;else{d=k<<1;k=f[a+132>>2]|0;z=1.0/+(((k|0)<(d|0)?k:d)|0)}if(!(z>=0.0)){f[m>>2]=0;f[m+4>>2]=0;d=c$(m,17)|0;k=345156;q=d+17|0;do{b[d>>0]=b[k>>0]|0;d=d+1|0;k=k+1|0}while((d|0)<(q|0));j$(-215,m,345174,344667,865);d$(m)}k=i+8|0;d=f[k>>2]|0;f[m>>2]=0;f[m+4>>2]=d;q=f[a+32>>2]|0;w=f[a+136>>2]|0;c=Y(w<<3,d)|0;d=f[i+12>>2]|0;j=q+(Y(c,d)|0)|0;c=f[a+88>>2]|0;e=+p[a+144>>3];r=f[a+152>>2]|0;s=f[a+156>>2]|0;t=f[a+160>>2]|0;A=+n[a+164>>2];B=+n[a+168>>2];C=-(z*+n[a+172>>2]);x=f[a+180>>2]|0;v=b[a+176>>0]|0;D=b[a+177>>0]|0;f[o>>2]=101264;f[o+4>>2]=i;f[o+8>>2]=l;f[o+12>>2]=q;f[o+16>>2]=j;f[o+20>>2]=c;f[o+24>>2]=w;n[o+28>>2]=z;n[o+32>>2]=e;f[o+36>>2]=r;f[o+40>>2]=s;f[o+44>>2]=t;n[o+48>>2]=A>B?B:A;n[o+52>>2]=A<B?B:A;n[o+56>>2]=C;f[o+60>>2]=x;b[o+64>>0]=v;b[o+65>>0]=D;D=i+4|0;v=f[D>>2]|0;if((v|0)<3)E=Y(d,f[k>>2]|0)|0;else{k=f[y>>2]|0;d=0;x=1;while(1){t=Y(f[k+(d<<2)>>2]|0,x)|0;d=d+1|0;if((d|0)==(v|0)){E=t;break}else x=t}}_U(m,o,+(E>>>0)*.0000152587890625);E=l+36|0;o=f[E>>2]|0;if(o|0?(m=o+12|0,o=f[m>>2]|0,f[m>>2]=o+-1,(o|0)==1):0)CR(l);f[E>>2]=0;E=l+16|0;o=l+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[o>>2]|0)>0){E=f[l+40>>2]|0;m=0;do{f[E+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[o>>2]|0))}o=f[l+44>>2]|0;if((o|0)!=(l+48|0))ZF(o);o=i+36|0;l=f[o>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)CR(i);f[o>>2]=0;o=i+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[D>>2]|0)>0){o=f[y>>2]|0;y=0;do{f[o+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[D>>2]|0))}D=f[i+44>>2]|0;if((D|0)!=(i+48|0))ZF(D);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function pua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;e=a+12|0;g=f[e>>2]|0;switch(g|0){case 21:case 5:case 16:case 0:{h=g;break}default:{f[d>>2]=0;f[d+4>>2]=0;K1a(c$(d,228)|0,344419,228)|0;j$(-215,d,344648,344667,924);d$(d);h=f[e>>2]|0}}switch(h|0){case 0:{Oua(a,b);u=c;return}case 16:{Pua(a,b);u=c;return}case 5:{Qua(a,b);u=c;return}case 21:{Rua(a,b);u=c;return}default:{u=c;return}}}function qua(a){a=a|0;return f[a+132>>2]|0}function rua(a,b){a=a|0;b=b|0;f[a+132>>2]=b;return}function sua(a){a=a|0;return f[a+136>>2]|0}function tua(a,b){a=a|0;b=b|0;f[a+136>>2]=b;return}function uua(a){a=a|0;return +(+n[a+152>>2])}function vua(a,b){a=a|0;b=+b;n[a+152>>2]=b;return}function wua(a){a=a|0;return +(+p[a+144>>3])}function xua(a,b){a=a|0;b=+b;p[a+144>>3]=b;return}function yua(a){a=a|0;return +(+n[a+156>>2])}function zua(a,b){a=a|0;b=+b;n[a+156>>2]=b;return}function Aua(a){a=a|0;return +(+n[a+160>>2])}function Bua(a,b){a=a|0;b=+b;n[a+160>>2]=b;return}function Cua(a){a=a|0;return +(+n[a+164>>2])}function Dua(a,b){a=a|0;b=+b;n[a+164>>2]=b;return}function Eua(a){a=a|0;return +(+n[a+168>>2])}function Fua(a,b){a=a|0;b=+b;n[a+168>>2]=b;return}function Gua(a){a=a|0;return +(+n[a+172>>2])}function Hua(a,b){a=a|0;b=+b;n[a+172>>2]=b;return}function Iua(a){a=a|0;return (b[a+176>>0]|0)!=0|0}function Jua(a,c){a=a|0;c=c|0;var d=0;d=a+176|0;if(!((b[d>>0]|0)!=0^c))return;b[d>>0]=c&1;return}function Kua(a){a=a|0;return h[a+177>>0]|0|0}function Lua(a,c){a=a|0;c=c|0;b[a+177>>0]=c;return}function Mua(a){a=a|0;return +(+n[a+180>>2])}function Nua(a,b){a=a|0;b=+b;n[a+180>>2]=b;return}function Oua(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,M=0,N=0,O=0,P=0;d=u;u=u+112|0;e=d+96|0;g=d+88|0;h=d+32|0;i=d;_$(g,101216);j=a+4|0;k=f[j>>2]|0;l=a+8|0;m=f[l>>2]|0;o=f[a+12>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;f[h>>2]=1124007936;p=h+4|0;q=h+8|0;r=h+40|0;s=p;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[r>>2]=q;s=h+48|0;t=h+44|0;f[t>>2]=s;f[s>>2]=0;f[h+52>>2]=0;f[e>>2]=m;f[e+4>>2]=k;AR(h,2,e,o&4095);gL(h,i)|0;i=f[a+32>>2]|0;o=Y(f[l>>2]|0,f[j>>2]|0)|0;j=a+136|0;l=i+((Y(o,f[j>>2]|0)|0)<<3)|0;o=f[q>>2]|0;if((o|0)>0){e=h+12|0;k=a+88|0;m=a+116|0;v=h+16|0;w=a+152|0;a=o;o=f[e>>2]|0;x=0;y=0;while(1){if((o|0)>0){z=0;A=x;do{B=(f[k>>2]|0)+(Y(f[f[m>>2]>>2]|0,y)|0)+z|0;C=b[B>>0]|0;B=(C&255)+A|0;if(!(C<<24>>24)){D=0.0;E=0.0}else{F=+n[w>>2];G=0.0;C=A;H=0.0;while(1){I=+n[i+(C<<3)>>2];J=G+I*+n[l+(C<<2)>>2];K=H+I;C=C+1|0;if(!(!(K>F)&(C|0)<(B|0))){D=J;E=K;break}else{G=J;H=K}}}B=+L(+E)>1.1920928955078125e-07;C=wNa(D*(B?1.0/E:0.0))|0;B=(f[v>>2]|0)+(Y(f[f[t>>2]>>2]|0,y)|0)+z|0;b[B>>0]=C>>>0<256?C:(C|0)>0?255:0;A=(f[j>>2]|0)+A|0;z=z+1|0;M=f[e>>2]|0}while((z|0)<(M|0));N=f[q>>2]|0;O=M;P=A}else{N=a;O=o;P=x}y=y+1|0;if((y|0)>=(N|0))break;else{a=N;o=O;x=P}}}eL(h,c);c=h+36|0;P=f[c>>2]|0;if(P|0?(x=P+12|0,P=f[x>>2]|0,f[x>>2]=P+-1,(P|0)==1):0)CR(h);f[c>>2]=0;c=h+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){c=f[r>>2]|0;r=0;do{f[c+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[t>>2]|0;if((p|0)!=(s|0))ZF(p);if(!(f[g+4>>2]|0)){u=d;return}u=d;return}function Pua(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,M=0.0,N=0.0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0,V=0,W=0,X=0;d=u;u=u+112|0;e=d+96|0;g=d+88|0;h=d+32|0;i=d;_$(g,101196);j=a+4|0;k=f[j>>2]|0;l=a+8|0;m=f[l>>2]|0;o=f[a+12>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;f[h>>2]=1124007936;p=h+4|0;q=h+8|0;r=h+40|0;s=p;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[r>>2]=q;s=h+48|0;t=h+44|0;f[t>>2]=s;f[s>>2]=0;f[h+52>>2]=0;f[e>>2]=m;f[e+4>>2]=k;AR(h,2,e,o&4095);gL(h,i)|0;i=f[a+32>>2]|0;o=Y(f[l>>2]|0,f[j>>2]|0)|0;j=a+136|0;l=i+((Y(o,f[j>>2]|0)|0)<<3)|0;o=f[q>>2]|0;if((o|0)>0){e=h+12|0;k=a+88|0;m=a+116|0;v=h+16|0;w=a+152|0;a=o;o=f[e>>2]|0;x=0;y=0;while(1){if((o|0)>0){z=0;A=x;do{B=(f[k>>2]|0)+(Y(f[f[m>>2]>>2]|0,y)|0)+z|0;C=b[B>>0]|0;B=(C&255)+A|0;if(!(C<<24>>24)){D=0.0;E=0.0;F=0.0;G=0.0}else{H=+n[w>>2];I=0.0;J=0.0;K=0.0;C=A;M=0.0;while(1){N=+n[i+(C<<3)>>2];O=C*3|0;P=I+N*+n[l+(O<<2)>>2];Q=J+N*+n[l+(O+1<<2)>>2];R=K+N*+n[l+(O+2<<2)>>2];S=M+N;C=C+1|0;if(!(!(S>H)&(C|0)<(B|0))){D=P;E=Q;F=R;G=S;break}else{I=P;J=Q;K=R;M=S}}}B=+L(+G)>1.1920928955078125e-07;M=B?1.0/G:0.0;B=wNa(D*M)|0;C=wNa(E*M)|0;O=wNa(M*F)|0;T=(f[v>>2]|0)+(Y(f[f[t>>2]>>2]|0,y)|0)|0;b[T+(z*3|0)>>0]=B>>>0<256?B:(B|0)>0?255:0;b[T+(z*3|0)+1>>0]=C>>>0<256?C:(C|0)>0?255:0;b[T+(z*3|0)+2>>0]=O>>>0<256?O:(O|0)>0?255:0;A=(f[j>>2]|0)+A|0;z=z+1|0;U=f[e>>2]|0}while((z|0)<(U|0));V=f[q>>2]|0;W=U;X=A}else{V=a;W=o;X=x}y=y+1|0;if((y|0)>=(V|0))break;else{a=V;o=W;x=X}}}eL(h,c);c=h+36|0;X=f[c>>2]|0;if(X|0?(x=X+12|0,X=f[x>>2]|0,f[x>>2]=X+-1,(X|0)==1):0)CR(h);f[c>>2]=0;c=h+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){c=f[r>>2]|0;r=0;do{f[c+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[t>>2]|0;if((p|0)!=(s|0))ZF(p);if(!(f[g+4>>2]|0)){u=d;return}u=d;return}function Qua(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,M=0,N=0,O=0,P=0;d=u;u=u+112|0;e=d+96|0;g=d+88|0;h=d+32|0;i=d;_$(g,101176);j=a+4|0;k=f[j>>2]|0;l=a+8|0;m=f[l>>2]|0;o=f[a+12>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;f[h>>2]=1124007936;p=h+4|0;q=h+8|0;r=h+40|0;s=p;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[r>>2]=q;s=h+48|0;t=h+44|0;f[t>>2]=s;f[s>>2]=0;f[h+52>>2]=0;f[e>>2]=m;f[e+4>>2]=k;AR(h,2,e,o&4095);gL(h,i)|0;i=f[a+32>>2]|0;o=Y(f[l>>2]|0,f[j>>2]|0)|0;j=a+136|0;l=i+((Y(o,f[j>>2]|0)|0)<<3)|0;o=f[q>>2]|0;if((o|0)>0){e=h+12|0;k=a+88|0;m=a+116|0;v=h+16|0;w=a+152|0;a=o;o=f[e>>2]|0;x=0;y=0;while(1){if((o|0)>0){z=0;A=x;do{B=(f[k>>2]|0)+(Y(f[f[m>>2]>>2]|0,y)|0)+z|0;C=b[B>>0]|0;B=(C&255)+A|0;if(!(C<<24>>24)){D=0.0;E=0.0}else{F=+n[w>>2];G=0.0;C=A;H=0.0;while(1){I=+n[i+(C<<3)>>2];J=G+I*+n[l+(C<<2)>>2];K=H+I;C=C+1|0;if(!(!(K>F)&(C|0)<(B|0))){D=J;E=K;break}else{G=J;H=K}}}B=+L(+E)>1.1920928955078125e-07;C=(f[v>>2]|0)+(Y(f[f[t>>2]>>2]|0,y)|0)+(z<<2)|0;n[C>>2]=D*(B?1.0/E:0.0);A=(f[j>>2]|0)+A|0;z=z+1|0;M=f[e>>2]|0}while((z|0)<(M|0));N=f[q>>2]|0;O=M;P=A}else{N=a;O=o;P=x}y=y+1|0;if((y|0)>=(N|0))break;else{a=N;o=O;x=P}}}eL(h,c);c=h+36|0;P=f[c>>2]|0;if(P|0?(x=P+12|0,P=f[x>>2]|0,f[x>>2]=P+-1,(P|0)==1):0)CR(h);f[c>>2]=0;c=h+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){c=f[r>>2]|0;r=0;do{f[c+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[t>>2]|0;if((p|0)!=(s|0))ZF(p);if(!(f[g+4>>2]|0)){u=d;return}u=d;return}function Rua(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,M=0.0,N=0.0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0,V=0,W=0;d=u;u=u+112|0;e=d+96|0;g=d+88|0;h=d+32|0;i=d;_$(g,101156);j=a+4|0;k=f[j>>2]|0;l=a+8|0;m=f[l>>2]|0;o=f[a+12>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;f[h>>2]=1124007936;p=h+4|0;q=h+8|0;r=h+40|0;s=p;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[r>>2]=q;s=h+48|0;t=h+44|0;f[t>>2]=s;f[s>>2]=0;f[h+52>>2]=0;f[e>>2]=m;f[e+4>>2]=k;AR(h,2,e,o&4095);gL(h,i)|0;i=f[a+32>>2]|0;o=Y(f[l>>2]|0,f[j>>2]|0)|0;j=a+136|0;l=i+((Y(o,f[j>>2]|0)|0)<<3)|0;o=f[q>>2]|0;if((o|0)>0){e=h+12|0;k=a+88|0;m=a+116|0;v=h+16|0;w=a+152|0;a=o;o=f[e>>2]|0;x=0;y=0;while(1){if((o|0)>0){z=0;A=x;do{B=(f[k>>2]|0)+(Y(f[f[m>>2]>>2]|0,y)|0)+z|0;C=b[B>>0]|0;B=(C&255)+A|0;if(!(C<<24>>24)){D=0.0;E=0.0;F=0.0;G=0.0}else{H=+n[w>>2];I=0.0;J=0.0;K=0.0;C=A;M=0.0;while(1){N=+n[i+(C<<3)>>2];O=C*3|0;P=I+N*+n[l+(O<<2)>>2];Q=J+N*+n[l+(O+1<<2)>>2];R=K+N*+n[l+(O+2<<2)>>2];S=M+N;C=C+1|0;if(!(!(S>H)&(C|0)<(B|0))){D=P;E=Q;F=R;G=S;break}else{I=P;J=Q;K=R;M=S}}}B=+L(+G)>1.1920928955078125e-07;M=B?1.0/G:0.0;B=(f[v>>2]|0)+(Y(f[f[t>>2]>>2]|0,y)|0)|0;n[B+(z*12|0)>>2]=D*M;n[B+(z*12|0)+4>>2]=E*M;n[B+(z*12|0)+8>>2]=M*F;A=(f[j>>2]|0)+A|0;z=z+1|0;T=f[e>>2]|0}while((z|0)<(T|0));U=f[q>>2]|0;V=T;W=A}else{U=a;V=o;W=x}y=y+1|0;if((y|0)>=(U|0))break;else{a=U;o=V;x=W}}}eL(h,c);c=h+36|0;W=f[c>>2]|0;if(W|0?(x=W+12|0,W=f[x>>2]|0,f[x>>2]=W+-1,(W|0)==1):0)CR(h);f[c>>2]=0;c=h+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){c=f[r>>2]|0;r=0;do{f[c+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[t>>2]|0;if((p|0)!=(s|0))ZF(p);if(!(f[g+4>>2]|0)){u=d;return}u=d;return}function Sua(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+32|0;g=e;h=a+4|0;f[h>>2]=f[c>>2];i=a+8|0;f[i>>2]=f[c+4>>2];f[a+12>>2]=d;f[a+128>>2]=0;c=d>>>3&511;if((c+1|0)>>>0>=513){f[g>>2]=0;f[g+4>>2]=0;j=c$(g,16)|0;k=345199;l=j+16|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,g,345216,344667,192);d$(g)}d=a+136|0;m=f[d>>2]|0;if((m|0)<256)n=m;else{f[g>>2]=0;f[g+4>>2]=0;j=c$(g,16)|0;k=345227;l=j+16|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,g,345216,344667,193);d$(g);n=f[d>>2]|0}d=a+16|0;k=f[i>>2]|0;j=f[h>>2]|0;l=Y(Y(Y(k,c+3|0)|0,j)|0,n)|0;if(((((f[a+20>>2]|0)<3?(f[a+24>>2]|0)==1:0)?(f[a+28>>2]|0)==(l|0):0)?(f[d>>2]&4095|0)==5:0)?(f[a+32>>2]|0)!=0:0){o=k;p=j}else{f[g>>2]=1;f[g+4>>2]=l;AR(d,2,g,5);o=f[i>>2]|0;p=f[h>>2]|0}h=a+72|0;if(((((f[a+76>>2]|0)<3?(f[a+80>>2]|0)==(o|0):0)?(f[a+84>>2]|0)==(p|0):0)?(f[h>>2]&4095|0)==0:0)?f[a+88>>2]|0:0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;gL(h,g)|0;u=e;return}f[g>>2]=o;f[g+4>>2]=p;AR(h,2,g,0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;gL(h,g)|0;u=e;return}function Tua(a){a=a|0;PYa(a);return}function Uua(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0,Na=0,Oa=0,Pa=0.0,Qa=0.0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0.0,eb=0.0,fb=0,gb=0,hb=0;d=u;u=u+3248|0;e=d+3224|0;g=d+3168|0;i=d+2104|0;j=d+56|0;k=d;l=f[c>>2]|0;m=f[c+4>>2]|0;c=a+4|0;o=f[c>>2]|0;p=f[o+12>>2]|0;q=((f[o>>2]|0)>>>3&511)+1|0;r=Y(p,q)|0;s=i+8|0;f[i>>2]=s;t=i+4|0;f[t>>2]=r;if(r>>>0>264){v=OYa(r>>>0>1073741823?-1:r<<2)|0;f[i>>2]=v;w=v}else w=s;v=a+28|0;x=1.0-+n[v>>2];a:do if((l|0)<(m|0)){r=a+16|0;y=a+24|0;z=a+12|0;A=a+20|0;B=a+8|0;C=(p|0)>0;D=a+64|0;E=a+32|0;F=a+36|0;G=a+60|0;H=a+65|0;I=a+44|0;J=a+56|0;K=(q|0)==3;M=j+4|0;N=j+8|0;O=a+40|0;P=a+48|0;Q=a+52|0;R=e+4|0;S=g+4|0;T=(q<<3)+-3|0;U=e+8|0;V=e+4|0;W=g+36|0;X=g+16|0;Z=g+4|0;_=g+40|0;$=g+44|0;aa=g+48|0;ba=k+36|0;ca=k+16|0;da=k+4|0;ea=k+40|0;fa=k+44|0;ga=k+48|0;ha=o;ia=w;ja=l;while(1){if((f[ha>>2]&7|0)!=5){f[e>>2]=ja;f[R>>2]=ja+1;f[g>>2]=-2147483648;f[S>>2]=2147483647;DR(k,ha,e,g);$i(g,1,p,T,ia,0);ka=U;f[ka>>2]=0;f[ka+4>>2]=0;f[e>>2]=-1040121856;f[V>>2]=g;WJ(k,e,5,1.0,0.0);ka=f[W>>2]|0;if(ka|0?(la=ka+12|0,ka=f[la>>2]|0,f[la>>2]=ka+-1,(ka|0)==1):0)CR(g);f[W>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[Z>>2]|0)>0){ka=f[_>>2]|0;la=0;do{f[ka+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[Z>>2]|0))}la=f[$>>2]|0;if((la|0)!=(aa|0))ZF(la);la=f[ba>>2]|0;if(la|0?(ka=la+12|0,la=f[ka>>2]|0,f[ka>>2]=la+-1,(la|0)==1):0)CR(k);f[ba>>2]=0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[da>>2]|0)>0){la=f[ea>>2]|0;ka=0;do{f[la+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[da>>2]|0))}ka=f[fa>>2]|0;if((ka|0)==(ga|0))ma=ia;else{ZF(ka);ma=ia}}else ma=(f[ha+16>>2]|0)+(Y(f[f[ha+44>>2]>>2]|0,ja)|0)|0;ka=Y(f[y>>2]|0,p)|0;la=(f[A>>2]|0)+(Y(ja,p)|0)|0;na=f[B>>2]|0;oa=(f[na+16>>2]|0)+(Y(f[f[na+44>>2]>>2]|0,ja)|0)|0;if(C){na=(f[z>>2]|0)+((Y(ka,ja)|0)<<3)|0;pa=ma;qa=na;na=(f[r>>2]|0)+((Y(Y(ja,q)|0,ka)|0)<<2)|0;ka=0;while(1){ra=la+ka|0;sa=b[ra>>0]|0;ta=sa&255;if(!(sa<<24>>24)){ua=0;va=0;wa=ta;xa=0.0}else{sa=pa+4|0;ya=pa+8|0;za=+n[J>>2];Aa=0;Ba=0;Ca=na;Da=0;Ea=ta;Fa=0.0;while(1){Ga=x*+n[qa+(Da<<3)>>2]+za;b:do if(!Ba){ta=qa+(Da<<3)+4|0;Ha=+n[ta>>2];if(K){Ia=+n[Ca>>2]-+n[pa>>2];n[j>>2]=Ia;Ja=+n[Ca+4>>2]-+n[sa>>2];n[M>>2]=Ja;Ka=+n[Ca+8>>2]-+n[ya>>2];n[N>>2]=Ka;La=Ka*Ka+(Ia*Ia+Ja*Ja)}else{Ma=0;Ja=0.0;while(1){Ia=+n[Ca+(Ma<<2)>>2]-+n[pa+(Ma<<2)>>2];n[j+(Ma<<2)>>2]=Ia;Ka=Ja+Ia*Ia;Ma=Ma+1|0;if((Ma|0)==(q|0)){La=Ka;break}else Ja=Ka}}if(Fa<+n[F>>2]?La<Ha*+n[E>>2]:0)Na=1;else Na=Aa;if(La<Ha*+n[O>>2]){Ja=+n[v>>2];Ka=Ga+Ja;Ia=Ja/Ka;Ma=0;do{Oa=Ca+(Ma<<2)|0;n[Oa>>2]=+n[Oa>>2]-Ia*+n[j+(Ma<<2)>>2];Ma=Ma+1|0}while((Ma|0)!=(q|0));Ja=Ha+(La-Ha)*Ia;Pa=+n[P>>2];Qa=Ja<Pa?Pa:Ja;Ja=+n[Q>>2];n[ta>>2]=Qa>Ja?Ja:Qa;if((Da|0)>0){Ma=Da;Oa=0;while(1){Ra=Ma;Ma=Ma+-1|0;Sa=qa+(Ma<<3)|0;if(Ka<+n[Sa>>2]){Ta=Na;Ua=1;Va=Oa;Wa=Ka;break b}Xa=qa+(Ra<<3)|0;Ya=Xa;Za=f[Ya>>2]|0;_a=f[Ya+4>>2]|0;Ya=Sa;$a=f[Ya+4>>2]|0;ab=Xa;f[ab>>2]=f[Ya>>2];f[ab+4>>2]=$a;$a=Sa;f[$a>>2]=Za;f[$a+4>>2]=_a;_a=Y(Ra,q)|0;$a=Y(Ma,q)|0;Za=0;do{Sa=na+(Za+_a<<2)|0;ab=na+(Za+$a<<2)|0;Ya=f[Sa>>2]|0;f[Sa>>2]=f[ab>>2];f[ab>>2]=Ya;Za=Za+1|0}while((Za|0)!=(q|0));Za=Oa+1|0;if((Ra|0)<=1){Ta=Na;Ua=1;Va=Za;Wa=Ka;break}else Oa=Za}}else{Ta=Na;Ua=1;Va=0;Wa=Ka}}else{Ta=Na;Ua=0;Va=0;Wa=Ga}}else{Ta=Aa;Ua=1;Va=0;Wa=Ga}while(0);za=+n[J>>2];Oa=Wa<-za;Ma=(Oa<<31>>31)+Ea|0;Ga=Oa?0.0:Wa;n[qa+(Da-Va<<3)>>2]=Ga;Ia=Fa+Ga;Da=Da+1|0;if((Da|0)>=(Ma|0)){ua=Ta;va=Ua;wa=Ma;xa=Ia;break}else{Aa=Ta;Ba=Ua;Ca=Ca+(q<<2)|0;Ea=Ma;Fa=Ia}}}Ea=+L(+xa)>1.1920928955078125e-07;Fa=Ea?1.0/xa:0.0;if((wa|0)>0){Ea=0;do{Ca=qa+(Ea<<3)|0;n[Ca>>2]=Fa*+n[Ca>>2];Ea=Ea+1|0}while((Ea|0)!=(wa|0))}c:do if(!va?(Fa=+n[v>>2],Fa>0.0):0){Ea=f[y>>2]|0;Ca=(wa|0)==(Ea|0);Ba=((Ca^1)&1)+wa|0;Aa=Ca?Ea+-1|0:wa;Ea=qa+(Aa<<3)|0;if((Ba|0)!=1){n[Ea>>2]=Fa;Ca=Ba+-1|0;if((Ba|0)>1){Da=0;do{ya=qa+(Da<<3)|0;n[ya>>2]=x*+n[ya>>2];Da=Da+1|0}while((Da|0)<(Ca|0))}}else n[Ea>>2]=1.0;Ca=Y(Aa,q)|0;Da=0;do{f[na+(Da+Ca<<2)>>2]=f[pa+(Da<<2)>>2];Da=Da+1|0}while((Da|0)!=(q|0));f[qa+(Aa<<3)+4>>2]=f[I>>2];if((Ba|0)>1){Da=Ba;while(1){Ca=Da+-2|0;Da=Da+-1|0;Ea=qa+(Ca<<3)|0;if(+n[v>>2]<+n[Ea>>2]){bb=Ba;break c}ya=qa+(Da<<3)|0;sa=ya;Ma=f[sa>>2]|0;Oa=f[sa+4>>2]|0;sa=Ea;ta=f[sa+4>>2]|0;Za=ya;f[Za>>2]=f[sa>>2];f[Za+4>>2]=ta;ta=Ea;f[ta>>2]=Ma;f[ta+4>>2]=Oa;Oa=Y(Da,q)|0;ta=Y(Ca,q)|0;Ca=0;do{Ma=na+(Ca+Oa<<2)|0;Ea=na+(Ca+ta<<2)|0;Za=f[Ma>>2]|0;f[Ma>>2]=f[Ea>>2];f[Ea>>2]=Za;Ca=Ca+1|0}while((Ca|0)!=(q|0));if((Da|0)<=1){bb=Ba;break}}}else bb=Ba}else bb=wa;while(0);b[ra>>0]=bb;d:do if(!ua)if((b[D>>0]|0)!=0?(Ka=+n[E>>2],Fa=+n[F>>2],za=+n[G>>2],(bb|0)>0):0){Da=na;Aa=0;Ca=0;Ia=0.0;while(1){Ga=+n[qa+(Aa<<3)>>2];Ha=+n[qa+(Aa<<3)+4>>2];ta=0;Qa=0.0;Ja=0.0;do{Pa=+n[Da+(ta<<2)>>2];Ja=Ja+ +n[pa+(ta<<2)>>2]*Pa;Qa=Qa+Pa*Pa;ta=ta+1|0}while((ta|0)!=(q|0));if(Qa==0.0){cb=255;break d}if(!(!(Ja<=Qa)|!(Ja>=za*Qa))){Pa=Ja/Qa;ta=0;db=0.0;do{eb=Pa*+n[Da+(ta<<2)>>2]-+n[pa+(ta<<2)>>2];db=db+eb*eb;ta=ta+1|0}while((ta|0)!=(q|0));ta=db<Pa*(Ka*Ha*Pa);fb=Ca|ta;if(ta)break;else gb=fb}else gb=Ca;Ia=Ia+Ga;if(Ia>Fa){cb=255;break d}Aa=Aa+1|0;if((Aa|0)>=(bb|0)){cb=255;break d}else{Da=Da+(q<<2)|0;Ca=gb}}if(fb)cb=h[H>>0]|0;else cb=255}else cb=255;else cb=0;while(0);b[oa+ka>>0]=cb;ka=ka+1|0;ra=f[y>>2]|0;na=na+((Y(ra,q)|0)<<2)|0;if((ka|0)==(p|0))break;else{pa=pa+(q<<2)|0;qa=qa+(ra<<3)|0}}}qa=ja+1|0;pa=f[i>>2]|0;if((qa|0)>=(m|0)){hb=pa;break a}ha=f[c>>2]|0;ia=pa;ja=qa}}else hb=w;while(0);if((hb|0)==(s|0)){u=d;return}if(hb|0)QYa(hb);f[i>>2]=s;f[t>>2]=264;u=d;return}function Vua(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0;e=NYa(192)|0;Wua(e,b,c,d);d=NYa(16)|0;b=d+4|0;f[b>>2]=1;f[d>>2]=101284;f[d+8>>2]=e;f[a>>2]=d;f[a+4>>2]=e;f[b>>2]=(f[b>>2]|0)+1;e=f[b>>2]|0;f[b>>2]=e+-1;if((e|0)!=1)return;ki[f[(f[d>>2]|0)+8>>2]&2047](d);return}function Wua(a,c,d,e){a=a|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=e&1;WF(a);f[a>>2]=101020;e=a+4|0;h=a+8|0;f[a+16>>2]=1124007936;i=a+24|0;j=a+56|0;k=a+20|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+64|0;f[a+60>>2]=i;f[i>>2]=0;f[a+68>>2]=0;f[a+72>>2]=1124007936;i=a+80|0;j=a+112|0;k=a+76|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+120|0;f[a+116>>2]=i;f[i>>2]=0;f[a+124>>2]=0;i=a+184|0;f[i>>2]=0;f[a+188>>2]=0;f[e>>2]=0;f[h>>2]=0;f[a+12>>2]=0;f[a+128>>2]=0;f[a+132>>2]=(c|0)>0?c:500;p[a+144>>3]=d>0.0?d:16.0;b[a+176>>0]=g;f[a+136>>2]=5;n[a+152>>2]=.8999999761581421;n[a+160>>2]=15.0;n[a+168>>2]=75.0;n[a+164>>2]=4.0;n[a+156>>2]=9.0;n[a+172>>2]=.05000000074505806;b[a+177>>0]=127;n[a+180>>2]=.5;d$(i);k=c$(i,25)|0;i=345648;l=k+25|0;do{b[k>>0]=b[i>>0]|0;k=k+1|0;i=i+1|0}while((k|0)<(l|0));return}function Xua(a){a=a|0;PYa(a);return}function Yua(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Zua(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;e=u;u=u+432|0;g=e+424|0;h=e+368|0;i=e+320|0;j=e+264|0;k=e;l=e+248|0;m=e+192|0;_$(g,101296);f[h>>2]=1124007936;n=h+4|0;o=h+8|0;q=h+40|0;r=n;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=o;t=h+48|0;v=h+44|0;f[v>>2]=t;f[t>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;w=i+4|0;x=i+8|0;y=i+20|0;z=i+24|0;A=i+28|0;B=i+32|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;f[w+16>>2]=0;f[w+20>>2]=0;f[w+24>>2]=0;f[B>>2]=x;C=i+40|0;D=i+36|0;f[D>>2]=C;f[i+44>>2]=0;f[C>>2]=0;C=(NS(a)|0)==655360;if(C){OS(j,a,-1);E=j+24|0;F=f[E>>2]|0;if(F|0){G=F+8|0;f[G>>2]=(f[G>>2]|0)+1}G=f[z>>2]|0;if(G|0?(F=G+8|0,G=f[F>>2]|0,f[F>>2]=G+-1,(G|0)==1):0)k0(i);if((f[w>>2]|0)>0){G=f[B>>2]|0;F=0;do{f[G+(F<<2)>>2]=0;F=F+1|0;H=f[w>>2]|0}while((F|0)<(H|0));f[z>>2]=0;f[i>>2]=f[j>>2];if((H|0)<3)I=12;else I=14}else{f[z>>2]=0;f[i>>2]=f[j>>2];I=12}if((I|0)==12){H=f[j+4>>2]|0;if((H|0)<3){f[w>>2]=H;f[x>>2]=f[j+8>>2];f[i+12>>2]=f[j+12>>2];x=f[j+36>>2]|0;H=f[D>>2]|0;f[H>>2]=f[x>>2];f[H+4>>2]=f[x+4>>2]}else I=14}if((I|0)==14)i0(i,j);f[i+16>>2]=f[j+16>>2];if(!(f[y>>2]|0))f[y>>2]=f[j+20>>2];f[z>>2]=f[E>>2];f[A>>2]=f[j+28>>2];A=f[i>>2]|0;E=f[B>>2]|0;B=f[E+4>>2]|0;z=f[E>>2]|0;j0(j);J=A;K=B;M=z}else{do if((NS(a)|0)==65536){z=f[a+4>>2]|0;f[j>>2]=f[z>>2];B=j+4|0;A=z+4|0;f[B>>2]=f[A>>2];E=j+8|0;f[E>>2]=f[z+8>>2];f[j+12>>2]=f[z+12>>2];f[j+16>>2]=f[z+16>>2];f[j+20>>2]=f[z+20>>2];f[j+24>>2]=f[z+24>>2];f[j+28>>2]=f[z+28>>2];f[j+32>>2]=f[z+32>>2];y=j+36|0;x=f[z+36>>2]|0;f[y>>2]=x;f[j+40>>2]=E;E=j+48|0;H=j+44|0;f[H>>2]=E;f[E>>2]=0;f[j+52>>2]=0;if(x|0){E=x+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[A>>2]|0)<3){A=f[z+44>>2]|0;E=f[H>>2]|0;f[E>>2]=f[A>>2];f[E+4>>2]=f[A+4>>2];N=y;break}else{f[B>>2]=0;BR(j,z);N=y;break}}else{OR(j,a,-1);N=j+36|0}while(0);a=f[N>>2]|0;if(a|0){y=a+12|0;f[y>>2]=(f[y>>2]|0)+1}y=h+36|0;a=f[y>>2]|0;if(a|0?(z=a+12|0,a=f[z>>2]|0,f[z>>2]=a+-1,(a|0)==1):0)CR(h);f[y>>2]=0;a=h+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[n>>2]|0)>0){z=f[q>>2]|0;B=0;do{f[z+(B<<2)>>2]=0;B=B+1|0;O=f[n>>2]|0}while((B|0)<(O|0));f[h>>2]=f[j>>2];if((O|0)<3)I=35;else I=37}else{f[h>>2]=f[j>>2];I=35}if((I|0)==35){O=f[j+4>>2]|0;if((O|0)<3){f[n>>2]=O;f[o>>2]=f[j+8>>2];f[h+12>>2]=f[j+12>>2];o=f[j+44>>2]|0;O=f[v>>2]|0;f[O>>2]=f[o>>2];f[O+4>>2]=f[o+4>>2]}else I=37}if((I|0)==37)BR(h,j);o=j+16|0;f[a>>2]=f[o>>2];f[h+20>>2]=f[j+20>>2];f[h+24>>2]=f[j+24>>2];f[h+28>>2]=f[j+28>>2];f[h+32>>2]=f[j+32>>2];a=f[N>>2]|0;f[y>>2]=a;y=f[h>>2]|0;O=f[q>>2]|0;B=f[O+4>>2]|0;z=f[O>>2]|0;if(a|0?(O=a+12|0,a=f[O>>2]|0,f[O>>2]=a+-1,(a|0)==1):0)CR(j);f[N>>2]=0;N=j+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[N>>2]|0)>0){o=f[j+40>>2]|0;a=0;do{f[o+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[N>>2]|0))}N=f[j+44>>2]|0;if((N|0)!=(j+48|0))ZF(N);J=y;K=B;M=z}f[j>>2]=f[c>>2];z=j+4|0;B=c+4|0;f[z>>2]=f[B>>2];y=j+8|0;N=c+8|0;a=f[N>>2]|0;f[y>>2]=a;o=j+12|0;O=c+12|0;A=f[O>>2]|0;f[o>>2]=A;if(!(J&4088)){P=A;Q=a}else{f[k>>2]=0;f[k+4>>2]=0;a=c$(k,7)|0;b[a>>0]=b[345674]|0;b[a+1>>0]=b[345675]|0;b[a+2>>0]=b[345676]|0;b[a+3>>0]=b[345677]|0;b[a+4>>0]=b[345678]|0;b[a+5>>0]=b[345679]|0;b[a+6>>0]=b[345680]|0;j$(-215,k,345682,345692,61);d$(k);P=f[O>>2]|0;Q=f[N>>2]|0}if((P|0)<1|(Q|0)<1){f[k>>2]=0;f[k+4>>2]=0;r=c$(k,35)|0;a=345743;s=r+35|0;do{b[r>>0]=b[a>>0]|0;r=r+1|0;a=a+1|0}while((r|0)<(s|0));j$(-5,k,345682,345692,64);d$(k);R=f[N>>2]|0;S=f[O>>2]|0}else{R=Q;S=P}P=f[c>>2]|0;Q=f[B>>2]|0;a=(P|0)>0?P:0;r=(Q|0)>0?Q:0;s=R+P|0;P=((K|0)<(s|0)?K:s)-a|0;s=S+Q|0;Q=((M|0)<(s|0)?M:s)-r|0;s=(P|0)<1|(Q|0)<1;f[c>>2]=s?0:a;f[B>>2]=s?0:r;f[N>>2]=s?0:P;f[O>>2]=s?0:Q;Q=f[d>>2]|0;if(!(Q&2))T=1.0;else{U=+p[d+8>>3];T=U<0.0?0.0:U}s=rNa(T*T)|0;P=((s|0)<0)<<31>>31;if(!(Q&1))V=100;else{Q=f[d+4>>2]|0;V=(Q|0)>1?Q:1}Q=(K|0)/2|0;d=(M|0)/2|0;r=l+8|0;a=l+12|0;S=l+4|0;R=k+8|0;A=k+16|0;J=l+8|0;E=l+12|0;H=l+4|0;x=m+36|0;D=m+16|0;w=m+4|0;F=m+40|0;G=m+44|0;W=m+48|0;X=f[y>>2]|0;Z=f[o>>2]|0;_=f[j>>2]|0;$=f[z>>2]|0;aa=0;while(1){ba=(_|0)>0?_:0;ca=($|0)>0?$:0;da=X+_|0;ea=((K|0)<(da|0)?K:da)-ba|0;da=Z+$|0;fa=((M|0)<(da|0)?M:da)-ca|0;da=(ea|0)<1|(fa|0)<1;ga=da?0:fa;ha=da?0:ea;f[j>>2]=da?0:ba;f[z>>2]=da?0:ca;f[y>>2]=ha;f[o>>2]=ga;if((ca|ba|0)==0|da?da|(ea|fa|0)==0:0){f[j>>2]=Q;f[z>>2]=d}f[y>>2]=(ha|0)>1?ha:1;f[o>>2]=(ga|0)>1?ga:1;if(!C){FR(m,h,j);f[J>>2]=0;f[E>>2]=0;f[l>>2]=16842752;f[H>>2]=m;kha(k,l,0);ga=f[x>>2]|0;if(ga|0?(ha=ga+12|0,ga=f[ha>>2]|0,f[ha>>2]=ga+-1,(ga|0)==1):0)CR(m);f[x>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[w>>2]|0)>0){ga=f[F>>2]|0;ha=0;do{f[ga+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[w>>2]|0))}ha=f[G>>2]|0;if((ha|0)!=(W|0))ZF(ha)}else{g0(m,i,j);f[r>>2]=0;f[a>>2]=0;f[l>>2]=17432576;f[S>>2]=m;kha(k,l,0);j0(m)}T=+p[k>>3];if(+L(+T)<2.220446049250313e-16){I=72;break}ha=rNa(+p[R>>3]/T-+(f[N>>2]|0)*.5)|0;ga=rNa(+p[A>>3]/T-+(f[O>>2]|0)*.5)|0;fa=f[j>>2]|0;ea=fa+ha|0;X=f[y>>2]|0;ha=K-X|0;da=(ea|0)>0?ea:0;_=(ha|0)<(da|0)?ha:da;da=f[z>>2]|0;ha=da+ga|0;Z=f[o>>2]|0;ga=M-Z|0;ea=(ha|0)>0?ha:0;$=(ga|0)<(ea|0)?ga:ea;ea=_-fa|0;fa=$-da|0;f[j>>2]=_;f[z>>2]=$;if(0<(P|0)|(0==(P|0)?((Y(fa,fa)|0)+(Y(ea,ea)|0)|0)>>>0<s>>>0:0)){I=72;break}ea=aa+1|0;if((ea|0)>=(V|0)){ia=ea;break}else aa=ea}if((I|0)==72)ia=aa;f[c>>2]=f[j>>2];f[B>>2]=f[z>>2];f[N>>2]=f[y>>2];f[O>>2]=f[o>>2];j0(i);i=h+36|0;o=f[i>>2]|0;if(o|0?(O=o+12|0,o=f[O>>2]|0,f[O>>2]=o+-1,(o|0)==1):0)CR(h);f[i>>2]=0;i=h+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[n>>2]|0)>0){i=f[q>>2]|0;q=0;do{f[i+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[n>>2]|0))}n=f[v>>2]|0;if((n|0)!=(t|0))ZF(n);if(!(f[g+4>>2]|0)){u=e;return ia|0}u=e;return ia|0}function _ua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0;e=u;u=u+384|0;g=e;h=e+368|0;i=e+312|0;j=e+264|0;k=e+248|0;l=e+192|0;_$(h,101316);f[i>>2]=1124007936;m=i+4|0;o=i+8|0;q=i+40|0;r=m;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=o;r=i+48|0;s=i+44|0;f[s>>2]=r;f[r>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;t=j+4|0;v=j+8|0;w=j+20|0;x=j+24|0;y=j+28|0;z=j+32|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=0;f[t+20>>2]=0;f[t+24>>2]=0;f[z>>2]=v;A=j+40|0;B=j+36|0;f[B>>2]=A;f[j+44>>2]=0;f[A>>2]=0;A=(NS(b)|0)==655360;if(A){OS(g,b,-1);C=g+24|0;D=f[C>>2]|0;if(D|0){E=D+8|0;f[E>>2]=(f[E>>2]|0)+1}E=f[x>>2]|0;if(E|0?(D=E+8|0,E=f[D>>2]|0,f[D>>2]=E+-1,(E|0)==1):0)k0(j);if((f[t>>2]|0)>0){E=f[z>>2]|0;D=0;do{f[E+(D<<2)>>2]=0;D=D+1|0;F=f[t>>2]|0}while((D|0)<(F|0));f[x>>2]=0;f[j>>2]=f[g>>2];if((F|0)<3)G=12;else G=14}else{f[x>>2]=0;f[j>>2]=f[g>>2];G=12}if((G|0)==12){F=f[g+4>>2]|0;if((F|0)<3){f[t>>2]=F;f[v>>2]=f[g+8>>2];f[j+12>>2]=f[g+12>>2];v=f[g+36>>2]|0;F=f[B>>2]|0;f[F>>2]=f[v>>2];f[F+4>>2]=f[v+4>>2]}else G=14}if((G|0)==14)i0(j,g);f[j+16>>2]=f[g+16>>2];if(!(f[w>>2]|0))f[w>>2]=f[g+20>>2];f[x>>2]=f[C>>2];f[y>>2]=f[g+28>>2];y=f[z>>2]|0;z=f[y+4>>2]|0;C=f[y>>2]|0;j0(g);H=z;I=C}else{do if((NS(b)|0)==65536){C=f[b+4>>2]|0;f[g>>2]=f[C>>2];z=g+4|0;y=C+4|0;f[z>>2]=f[y>>2];x=g+8|0;f[x>>2]=f[C+8>>2];f[g+12>>2]=f[C+12>>2];f[g+16>>2]=f[C+16>>2];f[g+20>>2]=f[C+20>>2];f[g+24>>2]=f[C+24>>2];f[g+28>>2]=f[C+28>>2];f[g+32>>2]=f[C+32>>2];w=g+36|0;v=f[C+36>>2]|0;f[w>>2]=v;f[g+40>>2]=x;x=g+48|0;F=g+44|0;f[F>>2]=x;f[x>>2]=0;f[g+52>>2]=0;if(v|0){x=v+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[y>>2]|0)<3){y=f[C+44>>2]|0;x=f[F>>2]|0;f[x>>2]=f[y>>2];f[x+4>>2]=f[y+4>>2];J=w;break}else{f[z>>2]=0;BR(g,C);J=w;break}}else{OR(g,b,-1);J=g+36|0}while(0);w=f[J>>2]|0;if(w|0){C=w+12|0;f[C>>2]=(f[C>>2]|0)+1}C=i+36|0;w=f[C>>2]|0;if(w|0?(z=w+12|0,w=f[z>>2]|0,f[z>>2]=w+-1,(w|0)==1):0)CR(i);f[C>>2]=0;w=i+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[m>>2]|0)>0){z=f[q>>2]|0;y=0;do{f[z+(y<<2)>>2]=0;y=y+1|0;K=f[m>>2]|0}while((y|0)<(K|0));f[i>>2]=f[g>>2];if((K|0)<3)G=35;else G=37}else{f[i>>2]=f[g>>2];G=35}if((G|0)==35){K=f[g+4>>2]|0;if((K|0)<3){f[m>>2]=K;f[o>>2]=f[g+8>>2];f[i+12>>2]=f[g+12>>2];o=f[g+44>>2]|0;K=f[s>>2]|0;f[K>>2]=f[o>>2];f[K+4>>2]=f[o+4>>2]}else G=37}if((G|0)==37)BR(i,g);G=g+16|0;f[w>>2]=f[G>>2];f[i+20>>2]=f[g+20>>2];f[i+24>>2]=f[g+24>>2];f[i+28>>2]=f[g+28>>2];f[i+32>>2]=f[g+32>>2];w=f[J>>2]|0;f[C>>2]=w;C=f[q>>2]|0;o=f[C+4>>2]|0;K=f[C>>2]|0;if(w|0?(C=w+12|0,w=f[C>>2]|0,f[C>>2]=w+-1,(w|0)==1):0)CR(g);f[J>>2]=0;J=g+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[J>>2]|0)>0){G=f[g+40>>2]|0;w=0;do{f[G+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[J>>2]|0))}J=f[g+44>>2]|0;if((J|0)!=(g+48|0))ZF(J);H=o;I=K};f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];f[g+8>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];Zua(b,c,g)|0;b=f[c>>2]|0;d=(b|0)<10?0:b+-10|0;f[c>>2]=d;b=c+4|0;K=f[b>>2]|0;o=(K|0)<10?0:K+-10|0;f[b>>2]=o;K=c+8|0;J=(f[K>>2]|0)+20|0;f[K>>2]=(d+J|0)>(H|0)?H-d|0:J;J=c+12|0;d=(f[J>>2]|0)+20|0;f[J>>2]=(o+d|0)>(I|0)?I-o|0:d;if(!A){FR(l,i,c);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=l;kha(g,k,0);A=l+36|0;d=f[A>>2]|0;if(d|0?(o=d+12|0,d=f[o>>2]|0,f[o>>2]=d+-1,(d|0)==1):0)CR(l);f[A>>2]=0;A=l+16|0;d=l+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[d>>2]|0)>0){A=f[l+40>>2]|0;o=0;do{f[A+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[d>>2]|0))}d=f[l+44>>2]|0;if((d|0)!=(l+48|0))ZF(d)}else{g0(l,j,c);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=17432576;f[k+4>>2]=l;kha(g,k,0);j0(l)}N=+p[g>>3];Q=+p[g+88>>3];R=+p[g+80>>3];S=+p[g+96>>3];if(+L(+N)<2.220446049250313e-16){f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0}else{T=+p[g+16>>3];V=1.0/N;l=rNa(V*+p[g+8>>3]+ +(f[c>>2]|0))|0;g=rNa(V*T+ +(f[b>>2]|0))|0;T=Q*V;N=V*R-V*S;W=+U(+(T*2.0),+(N+ +M(+(T*(T*4.0)+N*N))));N=+O(+W);T=+P(+W);X=N*N;Y=Q*(N*2.0*T);Q=T*T;Z=+M(+(V*(S*Q+(R*X+Y))))*4.0;_=+M(+(V*(S*X+(R*Q-Y))))*4.0;if(Z<_){$=T;aa=_;ba=N;ca=1.5707963267948966-W;da=Z}else{$=N;aa=Z;ba=T;ca=W;da=_}k=rNa(+L(+($*aa)))|0;d=rNa(+L(+(ba*da)))|0;o=((k|0)<(d|0)?d:k)+2|0;k=H-l<<1;d=(o|0)>(k|0)?k:o;o=rNa(+L(+(ba*aa)))|0;k=rNa(+L(+($*da)))|0;A=((o|0)<(k|0)?k:o)+2|0;o=I-g<<1;k=(A|0)>(o|0)?o:A;A=l-((d|0)/2|0)|0;l=(A|0)>0?A:0;f[c>>2]=l;c=g-((k|0)/2|0)|0;g=(c|0)>0?c:0;f[b>>2]=g;b=H-l|0;H=(b|0)>(d|0)?d:b;f[K>>2]=H;K=I-g|0;I=(K|0)>(k|0)?k:K;f[J>>2]=I;$=aa;aa=da;da=(ca+1.5707963267948966)*180.0/3.141592653589793;if(da<0.0){ca=da;while(1){ba=ca+360.0;if(ba<0.0)ca=ba;else{ea=ba;break}}}else ea=da;if(!(ea>=360.0))fa=ea;else{da=ea;while(1){ea=da+-360.0;if(!(ea>=360.0)){fa=ea;break}else da=ea}}n[a>>2]=+(l|0)+ +(H|0)*.5;n[a+4>>2]=+(g|0)+ +(I|0)*.5;n[a+8>>2]=aa;n[a+12>>2]=$;n[a+16>>2]=!(fa>=180.0)?fa:fa+-180.0}j0(j);j=i+36|0;a=f[j>>2]|0;if(a|0?(I=a+12|0,a=f[I>>2]|0,f[I>>2]=a+-1,(a|0)==1):0)CR(i);f[j>>2]=0;j=i+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[m>>2]|0)>0){j=f[q>>2]|0;q=0;do{f[j+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[m>>2]|0))}m=f[s>>2]|0;if((m|0)!=(r|0))ZF(m);if(!(f[h+4>>2]|0)){u=e;return}u=e;return}
function Wca(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0;h=f[a+4>>2]|0;i=(h|0)/2|0;j=(f[a+28>>2]|0)+(i<<2)|0;k=+n[a+72>>2];l=b+(i<<2)|0;b=e+-1|0;m=(e|0)==0;if(!(f[a+76>>2]&1)){if(m)return;a=g+-4|0;e=(g|0)<4;o=(h|0)<2;p=g&-4;q=b;r=c;s=l;while(1){a:do if(e)t=0;else{if(o){u=0;while(1){n[r+(u<<2)>>2]=k;n[r+((u|1)<<2)>>2]=k;n[r+((u|2)<<2)>>2]=k;n[r+((u|3)<<2)>>2]=k;u=u+4|0;if((u|0)>(a|0)){t=p;break a}}}else v=0;do{u=1;w=k;x=k;y=k;z=k;while(1){A=(f[s+(u<<2)>>2]|0)+(v<<2)|0;B=(f[s+(0-u<<2)>>2]|0)+(v<<2)|0;C=+n[j+(u<<2)>>2];w=w+C*(+n[A>>2]-+n[B>>2]);x=x+C*(+n[A+4>>2]-+n[B+4>>2]);y=y+C*(+n[A+8>>2]-+n[B+8>>2]);z=z+C*(+n[A+12>>2]-+n[B+12>>2]);if((u|0)>=(i|0))break;else u=u+1|0}n[r+(v<<2)>>2]=w;n[r+((v|1)<<2)>>2]=x;n[r+((v|2)<<2)>>2]=y;n[r+((v|3)<<2)>>2]=z;v=v+4|0}while((v|0)<=(a|0));t=p}while(0);b:do if((t|0)<(g|0)){if(o){u=t;while(1){n[r+(u<<2)>>2]=k;u=u+1|0;if((u|0)==(g|0))break b}}else D=t;do{u=1;C=k;while(1){C=C+ +n[j+(u<<2)>>2]*(+n[(f[s+(u<<2)>>2]|0)+(D<<2)>>2]-+n[(f[s+(0-u<<2)>>2]|0)+(D<<2)>>2]);if((u|0)>=(i|0))break;else u=u+1|0}n[r+(D<<2)>>2]=C;D=D+1|0}while((D|0)!=(g|0))}while(0);if(!q)break;else{q=q+-1|0;r=r+d|0;s=s+4|0}}return}else{if(m)return;m=g+-4|0;s=(g|0)<4;r=(h|0)<2;h=g&-4;q=b;b=c;c=l;while(1){c:do if(s)E=0;else{l=f[c>>2]|0;if(r){D=0;while(1){z=+n[j>>2];t=l+(D<<2)|0;y=k+z*+n[t+4>>2];x=k+z*+n[t+8>>2];w=k+z*+n[t+12>>2];n[b+(D<<2)>>2]=k+z*+n[t>>2];n[b+((D|1)<<2)>>2]=y;n[b+((D|2)<<2)>>2]=x;n[b+((D|3)<<2)>>2]=w;D=D+4|0;if((D|0)>(m|0)){E=h;break c}}}else F=0;do{w=+n[j>>2];D=l+(F<<2)|0;t=1;x=k+w*+n[D>>2];y=k+w*+n[D+4>>2];z=k+w*+n[D+8>>2];G=k+w*+n[D+12>>2];while(1){D=(f[c+(t<<2)>>2]|0)+(F<<2)|0;o=(f[c+(0-t<<2)>>2]|0)+(F<<2)|0;w=+n[j+(t<<2)>>2];x=x+w*(+n[D>>2]+ +n[o>>2]);y=y+w*(+n[D+4>>2]+ +n[o+4>>2]);z=z+w*(+n[D+8>>2]+ +n[o+8>>2]);G=G+w*(+n[D+12>>2]+ +n[o+12>>2]);if((t|0)>=(i|0))break;else t=t+1|0}n[b+(F<<2)>>2]=x;n[b+((F|1)<<2)>>2]=y;n[b+((F|2)<<2)>>2]=z;n[b+((F|3)<<2)>>2]=G;F=F+4|0}while((F|0)<=(m|0));E=h}while(0);d:do if((E|0)<(g|0)){l=f[c>>2]|0;if(r){t=E;while(1){n[b+(t<<2)>>2]=k+ +n[j>>2]*+n[l+(t<<2)>>2];t=t+1|0;if((t|0)==(g|0))break d}}else H=E;do{t=1;C=k+ +n[j>>2]*+n[l+(H<<2)>>2];while(1){C=C+ +n[j+(t<<2)>>2]*(+n[(f[c+(t<<2)>>2]|0)+(H<<2)>>2]+ +n[(f[c+(0-t<<2)>>2]|0)+(H<<2)>>2]);if((t|0)>=(i|0))break;else t=t+1|0}n[b+(H<<2)>>2]=C;H=H+1|0}while((H|0)!=(g|0))}while(0);if(!q)break;else{q=q+-1|0;b=b+d|0;c=c+4|0}}return}}function Xca(a){a=a|0;PYa(a);return}function Yca(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Zca(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;dda(a,c,d,e,h,i);f[a>>2]=58500;f[a+76>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=c$(k,64)|0;a=228297;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));j$(-215,k,228362,225433,3314);d$(k);u=j;return}function _ca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58476;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;ZF(b);return}function $ca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58476;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function ada(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;i=f[a+28>>2]|0;j=f[a+72>>2]|0;k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;n=h&-4;o=g;g=c;c=b;while(1){o=o+-1|0;a:do if(l)p=0;else{b=f[i>>2]|0;q=f[c>>2]|0;if(m)r=0;else{s=0;while(1){t=q+(s<<2)|0;u=(Y(f[t>>2]|0,b)|0)+j|0;v=(Y(f[t+4>>2]|0,b)|0)+j|0;w=(Y(f[t+8>>2]|0,b)|0)+j|0;x=(Y(f[t+12>>2]|0,b)|0)+j|0;d[g+(s<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;d[g+((s|1)<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[g+((s|2)<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;d[g+((s|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;s=s+4|0;if((s|0)>(a|0)){p=n;break a}}}do{s=q+(r<<2)|0;x=(Y(f[s>>2]|0,b)|0)+j|0;w=(Y(f[s+4>>2]|0,b)|0)+j|0;v=(Y(f[s+8>>2]|0,b)|0)+j|0;u=1;t=x;x=w;w=v;v=(Y(f[s+12>>2]|0,b)|0)+j|0;do{s=(f[c+(u<<2)>>2]|0)+(r<<2)|0;y=f[i+(u<<2)>>2]|0;t=(Y(f[s>>2]|0,y)|0)+t|0;x=(Y(f[s+4>>2]|0,y)|0)+x|0;w=(Y(f[s+8>>2]|0,y)|0)+w|0;v=(Y(f[s+12>>2]|0,y)|0)+v|0;u=u+1|0}while((u|0)!=(k|0));d[g+(r<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;d[g+((r|1)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;d[g+((r|2)<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;d[g+((r|3)<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;r=r+4|0}while((r|0)<=(a|0));p=n}while(0);b:do if((p|0)<(h|0)){b=f[i>>2]|0;q=f[c>>2]|0;if(m)z=p;else{u=p;while(1){y=(Y(f[q+(u<<2)>>2]|0,b)|0)+j|0;d[g+(u<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;u=u+1|0;if((u|0)==(h|0))break b}}do{u=1;y=(Y(f[q+(z<<2)>>2]|0,b)|0)+j|0;do{y=(Y(f[(f[c+(u<<2)>>2]|0)+(z<<2)>>2]|0,f[i+(u<<2)>>2]|0)|0)+y|0;u=u+1|0}while((u|0)!=(k|0));d[g+(z<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;z=z+1|0}while((z|0)!=(h|0))}while(0);if(!o)break;else{g=g+e|0;c=c+4|0}}return}function bda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58476;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function cda(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=(f[a+4>>2]|0)/2|0;j=(f[a+28>>2]|0)+(i<<2)|0;k=(f[a+76>>2]&1|0)==0;l=f[j>>2]|0;m=f[j+4>>2]|0;j=(m|0)==1;n=(l|0)==2&j;o=(l|0)==-2&j;p=(l|0)==0&(j|(m|0)==-1);j=f[a+72>>2]|0;if(!g)return;a=(m|0)<0;q=h+-4|0;r=(h|0)<4;s=h&-4;t=g;g=c;c=b+(i<<2)|0;while(1){t=t+-1|0;i=f[c+-4>>2]|0;b=f[c>>2]|0;c=c+4|0;u=f[c>>2]|0;a:do if(k)if(p){v=a?u:i;w=a?i:u;if(r)x=0;else{y=w;z=v;A=0;do{B=(f[y+(A<<2)>>2]|0)-(f[z+(A<<2)>>2]|0)+j|0;C=A|1;D=(f[y+(C<<2)>>2]|0)-(f[z+(C<<2)>>2]|0)+j|0;d[g+(A<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;d[g+(C<<1)>>1]=(D+32768|0)>>>0<65536?D:(D|0)>0?32767:32768;D=A|2;C=(f[y+(D<<2)>>2]|0)-(f[z+(D<<2)>>2]|0)+j|0;B=A|3;E=(f[y+(B<<2)>>2]|0)-(f[z+(B<<2)>>2]|0)+j|0;d[g+(D<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;d[g+(B<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;A=A+4|0}while((A|0)<=(q|0));x=s}if((x|0)>=(h|0))break;A=w;z=v;y=x;do{E=(f[A+(y<<2)>>2]|0)-(f[z+(y<<2)>>2]|0)+j|0;d[g+(y<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;y=y+1|0}while((y|0)!=(h|0))}else{if(r)F=0;else{y=u;z=i;A=0;do{v=(Y((f[y+(A<<2)>>2]|0)-(f[z+(A<<2)>>2]|0)|0,m)|0)+j|0;w=A|1;E=(Y((f[y+(w<<2)>>2]|0)-(f[z+(w<<2)>>2]|0)|0,m)|0)+j|0;d[g+(A<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[g+(w<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;E=A|2;w=(Y((f[y+(E<<2)>>2]|0)-(f[z+(E<<2)>>2]|0)|0,m)|0)+j|0;v=A|3;B=(Y((f[y+(v<<2)>>2]|0)-(f[z+(v<<2)>>2]|0)|0,m)|0)+j|0;d[g+(E<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;d[g+(v<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;A=A+4|0}while((A|0)<=(q|0));F=s}if((F|0)>=(h|0))break;A=u;z=i;y=F;do{B=(Y((f[A+(y<<2)>>2]|0)-(f[z+(y<<2)>>2]|0)|0,m)|0)+j|0;d[g+(y<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;y=y+1|0}while((y|0)!=(h|0))}else{if(n){if(r)G=0;else{y=i;z=u;A=0;do{B=(f[y+(A<<2)>>2]|0)+j+(f[b+(A<<2)>>2]<<1)+(f[z+(A<<2)>>2]|0)|0;v=A|1;w=(f[y+(v<<2)>>2]|0)+j+(f[b+(v<<2)>>2]<<1)+(f[z+(v<<2)>>2]|0)|0;d[g+(A<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;d[g+(v<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;w=A|2;v=(f[y+(w<<2)>>2]|0)+j+(f[b+(w<<2)>>2]<<1)+(f[z+(w<<2)>>2]|0)|0;B=A|3;E=(f[y+(B<<2)>>2]|0)+j+(f[b+(B<<2)>>2]<<1)+(f[z+(B<<2)>>2]|0)|0;d[g+(w<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[g+(B<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;A=A+4|0}while((A|0)<=(q|0));G=s}if((G|0)>=(h|0))break;A=i;z=u;y=G;while(1){E=(f[A+(y<<2)>>2]|0)+j+(f[b+(y<<2)>>2]<<1)+(f[z+(y<<2)>>2]|0)|0;d[g+(y<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;y=y+1|0;if((y|0)==(h|0))break a}}if(o){if(r)H=0;else{y=i;z=u;A=0;do{E=(f[y+(A<<2)>>2]|0)+j-(f[b+(A<<2)>>2]<<1)+(f[z+(A<<2)>>2]|0)|0;B=A|1;v=(f[y+(B<<2)>>2]|0)+j-(f[b+(B<<2)>>2]<<1)+(f[z+(B<<2)>>2]|0)|0;d[g+(A<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;d[g+(B<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;v=A|2;B=(f[y+(v<<2)>>2]|0)+j-(f[b+(v<<2)>>2]<<1)+(f[z+(v<<2)>>2]|0)|0;E=A|3;w=(f[y+(E<<2)>>2]|0)+j-(f[b+(E<<2)>>2]<<1)+(f[z+(E<<2)>>2]|0)|0;d[g+(v<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;d[g+(E<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;A=A+4|0}while((A|0)<=(q|0));H=s}if((H|0)>=(h|0))break;A=i;z=u;y=H;do{w=(f[A+(y<<2)>>2]|0)+j-(f[b+(y<<2)>>2]<<1)+(f[z+(y<<2)>>2]|0)|0;d[g+(y<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;y=y+1|0}while((y|0)!=(h|0))}else{if(r)I=0;else{y=i;z=u;A=0;do{w=Y((f[z+(A<<2)>>2]|0)+(f[y+(A<<2)>>2]|0)|0,m)|0;E=(Y(f[b+(A<<2)>>2]|0,l)|0)+j+w|0;w=A|1;B=Y((f[z+(w<<2)>>2]|0)+(f[y+(w<<2)>>2]|0)|0,m)|0;v=(Y(f[b+(w<<2)>>2]|0,l)|0)+j+B|0;d[g+(A<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;d[g+(w<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;v=A|2;w=Y((f[z+(v<<2)>>2]|0)+(f[y+(v<<2)>>2]|0)|0,m)|0;E=(Y(f[b+(v<<2)>>2]|0,l)|0)+j+w|0;w=A|3;B=Y((f[z+(w<<2)>>2]|0)+(f[y+(w<<2)>>2]|0)|0,m)|0;C=(Y(f[b+(w<<2)>>2]|0,l)|0)+j+B|0;d[g+(v<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;d[g+(w<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;A=A+4|0}while((A|0)<=(q|0));I=s}if((I|0)>=(h|0))break;A=i;y=u;z=I;do{C=Y((f[y+(z<<2)>>2]|0)+(f[A+(z<<2)>>2]|0)|0,m)|0;w=(Y(f[b+(z<<2)>>2]|0,l)|0)+j+C|0;d[g+(z<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;z=z+1|0}while((z|0)!=(h|0))}}while(0);if(!t)break;else g=g+e|0}return}function dda(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=58476;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[n>>2]=m;q=a+60|0;r=a+56|0;f[r>>2]=q;f[q>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){q=c+36|0;s=f[q>>2]|0;if(s){t=s+12|0;f[t>>2]=(f[t>>2]|0)+1;t=a+48|0;s=f[t>>2]|0;if((s|0)!=0?(v=s+12|0,s=f[v>>2]|0,f[v>>2]=s+-1,(s|0)==1):0){CR(k);w=t}else w=t}else w=a+48|0;f[w>>2]=0;t=a+28|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[l>>2]|0)>0){s=f[n>>2]|0;n=0;do{f[s+(n<<2)>>2]=0;n=n+1|0;x=f[l>>2]|0}while((n|0)<(x|0));f[k>>2]=f[c>>2];if((x|0)<3)y=13;else y=15}else{f[k>>2]=f[c>>2];y=13}if((y|0)==13){x=f[c+4>>2]|0;if((x|0)<3){f[l>>2]=x;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];x=f[c+44>>2]|0;l=f[r>>2]|0;f[l>>2]=f[x>>2];f[l+4>>2]=f[x+4>>2]}else y=15}if((y|0)==15)BR(k,c);f[t>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[w>>2]=f[q>>2]}}else{q=g+8|0;f[q>>2]=0;f[q+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;eL(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;j=rNa(e)|0;f[a+72>>2]=j;if((f[k>>2]&4095|0)==4?(d|0)==1|(m|0)==1:0){u=h;return}f[g>>2]=0;f[g+4>>2]=0;o=c$(g,77)|0;m=229351;p=o+77|0;do{b[o>>0]=b[m>>0]|0;o=o+1|0;m=m+1|0}while((o|0)<(p|0));j$(-215,g,229429,225433,3251);d$(g);u=h;return}function eda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58476;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function fda(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=f[a+72>>2]|0;m=b+(j<<2)|0;b=g+-1|0;n=(g|0)==0;if(!(f[a+76>>2]&1)){if(n)return;a=h+-4|0;g=(h|0)<4;o=(i|0)<2;p=h&-4;q=((l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768)&65535;r=((l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768)&65535;s=b;t=c;u=m;while(1){a:do if(g)v=0;else{if(o){w=0;while(1){d[t+(w<<1)>>1]=r;d[t+((w|1)<<1)>>1]=r;d[t+((w|2)<<1)>>1]=r;d[t+((w|3)<<1)>>1]=r;w=w+4|0;if((w|0)>(a|0)){v=p;break a}}}else x=0;do{w=1;y=l;z=l;A=l;B=l;while(1){C=(f[u+(w<<2)>>2]|0)+(x<<2)|0;D=(f[u+(0-w<<2)>>2]|0)+(x<<2)|0;E=f[k+(w<<2)>>2]|0;y=(Y((f[C>>2]|0)-(f[D>>2]|0)|0,E)|0)+y|0;z=(Y((f[C+4>>2]|0)-(f[D+4>>2]|0)|0,E)|0)+z|0;A=(Y((f[C+8>>2]|0)-(f[D+8>>2]|0)|0,E)|0)+A|0;B=(Y((f[C+12>>2]|0)-(f[D+12>>2]|0)|0,E)|0)+B|0;if((w|0)>=(j|0))break;else w=w+1|0}d[t+(x<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;d[t+((x|1)<<1)>>1]=(z+32768|0)>>>0<65536?z:(z|0)>0?32767:32768;d[t+((x|2)<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;d[t+((x|3)<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;x=x+4|0}while((x|0)<=(a|0));v=p}while(0);b:do if((v|0)<(h|0)){if(o){w=v;while(1){d[t+(w<<1)>>1]=q;w=w+1|0;if((w|0)==(h|0))break b}}else F=v;do{w=1;E=l;while(1){E=(Y((f[(f[u+(w<<2)>>2]|0)+(F<<2)>>2]|0)-(f[(f[u+(0-w<<2)>>2]|0)+(F<<2)>>2]|0)|0,f[k+(w<<2)>>2]|0)|0)+E|0;if((w|0)>=(j|0))break;else w=w+1|0}d[t+(F<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;F=F+1|0}while((F|0)!=(h|0))}while(0);if(!s)break;else{s=s+-1|0;t=t+e|0;u=u+4|0}}return}else{if(n)return;n=h+-4|0;u=(h|0)<4;t=(i|0)<2;i=h&-4;s=b;b=c;c=m;while(1){c:do if(u)G=0;else{m=f[k>>2]|0;F=f[c>>2]|0;if(t){v=0;while(1){q=F+(v<<2)|0;o=(Y(f[q>>2]|0,m)|0)+l|0;p=(Y(f[q+4>>2]|0,m)|0)+l|0;a=(Y(f[q+8>>2]|0,m)|0)+l|0;x=(Y(f[q+12>>2]|0,m)|0)+l|0;d[b+(v<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;d[b+((v|1)<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[b+((v|2)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;d[b+((v|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;v=v+4|0;if((v|0)>(n|0)){G=i;break c}}}else H=0;do{v=F+(H<<2)|0;x=(Y(f[v>>2]|0,m)|0)+l|0;a=(Y(f[v+4>>2]|0,m)|0)+l|0;p=(Y(f[v+8>>2]|0,m)|0)+l|0;o=1;q=x;x=a;a=p;p=(Y(f[v+12>>2]|0,m)|0)+l|0;while(1){v=(f[c+(o<<2)>>2]|0)+(H<<2)|0;r=(f[c+(0-o<<2)>>2]|0)+(H<<2)|0;g=f[k+(o<<2)>>2]|0;q=(Y((f[r>>2]|0)+(f[v>>2]|0)|0,g)|0)+q|0;x=(Y((f[r+4>>2]|0)+(f[v+4>>2]|0)|0,g)|0)+x|0;a=(Y((f[r+8>>2]|0)+(f[v+8>>2]|0)|0,g)|0)+a|0;p=(Y((f[r+12>>2]|0)+(f[v+12>>2]|0)|0,g)|0)+p|0;if((o|0)>=(j|0))break;else o=o+1|0}d[b+(H<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;d[b+((H|1)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;d[b+((H|2)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;d[b+((H|3)<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;H=H+4|0}while((H|0)<=(n|0));G=i}while(0);d:do if((G|0)<(h|0)){m=f[k>>2]|0;F=f[c>>2]|0;if(t){o=G;while(1){E=(Y(f[F+(o<<2)>>2]|0,m)|0)+l|0;d[b+(o<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;o=o+1|0;if((o|0)==(h|0))break d}}else I=G;do{o=1;E=(Y(f[F+(I<<2)>>2]|0,m)|0)+l|0;while(1){E=(Y((f[(f[c+(0-o<<2)>>2]|0)+(I<<2)>>2]|0)+(f[(f[c+(o<<2)>>2]|0)+(I<<2)>>2]|0)|0,f[k+(o<<2)>>2]|0)|0)+E|0;if((o|0)>=(j|0))break;else o=o+1|0}d[b+(I<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;I=I+1|0}while((I|0)!=(h|0))}while(0);if(!s)break;else{s=s+-1|0;b=b+e|0;c=c+4|0}}return}}function gda(a){a=a|0;PYa(a);return}function hda(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function ida(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58356;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){PYa(a);return}ZF(b);PYa(a);return}function jda(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;i=(f[a+4>>2]|0)/2|0;j=(f[a+28>>2]|0)+(i<<2)|0;k=(f[a+84>>2]&1|0)==0;l=f[j>>2]|0;m=f[j+4>>2]|0;j=(m|0)==1;n=(l|0)==2&j;o=(l|0)==-2&j;p=(l|0)==0&(j|(m|0)==-1);j=a+68|0;q=f[j>>2]|0;if(!g)return;r=(m|0)<0;s=h+-4|0;t=(h|0)<4;u=(f[j+4>>2]|0)+(f[a+80>>2]|0)|0;a=h&-4;j=g;g=d;d=c+(i<<2)|0;while(1){j=j+-1|0;i=f[d+-4>>2]|0;c=f[d>>2]|0;d=d+4|0;v=f[d>>2]|0;a:do if(k)if(p){w=r?v:i;x=r?i:v;if(t)y=0;else{z=x;A=w;B=0;do{C=B|1;D=f[z+(C<<2)>>2]|0;E=f[A+(C<<2)>>2]|0;F=u+(f[z+(B<<2)>>2]|0)-(f[A+(B<<2)>>2]|0)>>q;b[g+B>>0]=F>>>0<256?F:(F|0)>0?255:0;F=u+D-E>>q;b[g+C>>0]=F>>>0<256?F:(F|0)>0?255:0;F=B|2;C=B|3;E=f[z+(C<<2)>>2]|0;D=f[A+(C<<2)>>2]|0;G=u+(f[z+(F<<2)>>2]|0)-(f[A+(F<<2)>>2]|0)>>q;b[g+F>>0]=G>>>0<256?G:(G|0)>0?255:0;G=u+E-D>>q;b[g+C>>0]=G>>>0<256?G:(G|0)>0?255:0;B=B+4|0}while((B|0)<=(s|0));y=a}if((y|0)>=(h|0))break;B=x;A=w;z=y;do{G=u+(f[B+(z<<2)>>2]|0)-(f[A+(z<<2)>>2]|0)>>q;b[g+z>>0]=G>>>0<256?G:(G|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}else{if(t)H=0;else{z=v;A=i;B=0;do{w=Y((f[z+(B<<2)>>2]|0)-(f[A+(B<<2)>>2]|0)|0,m)|0;x=B|1;G=Y((f[z+(x<<2)>>2]|0)-(f[A+(x<<2)>>2]|0)|0,m)|0;C=u+w>>q;b[g+B>>0]=C>>>0<256?C:(C|0)>0?255:0;C=u+G>>q;b[g+x>>0]=C>>>0<256?C:(C|0)>0?255:0;C=B|2;x=Y((f[z+(C<<2)>>2]|0)-(f[A+(C<<2)>>2]|0)|0,m)|0;G=B|3;w=Y((f[z+(G<<2)>>2]|0)-(f[A+(G<<2)>>2]|0)|0,m)|0;D=u+x>>q;b[g+C>>0]=D>>>0<256?D:(D|0)>0?255:0;D=u+w>>q;b[g+G>>0]=D>>>0<256?D:(D|0)>0?255:0;B=B+4|0}while((B|0)<=(s|0));H=a}if((H|0)>=(h|0))break;B=v;A=i;z=H;do{D=u+(Y((f[B+(z<<2)>>2]|0)-(f[A+(z<<2)>>2]|0)|0,m)|0)>>q;b[g+z>>0]=D>>>0<256?D:(D|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}else{if(n){if(t)I=0;else{z=i;A=v;B=0;do{D=B|1;G=f[z+(D<<2)>>2]|0;w=f[c+(D<<2)>>2]<<1;C=f[A+(D<<2)>>2]|0;x=u+(f[z+(B<<2)>>2]|0)+(f[c+(B<<2)>>2]<<1)+(f[A+(B<<2)>>2]|0)>>q;b[g+B>>0]=x>>>0<256?x:(x|0)>0?255:0;x=u+G+w+C>>q;b[g+D>>0]=x>>>0<256?x:(x|0)>0?255:0;x=B|2;D=B|3;C=f[z+(D<<2)>>2]|0;w=f[c+(D<<2)>>2]<<1;G=f[A+(D<<2)>>2]|0;E=u+(f[z+(x<<2)>>2]|0)+(f[c+(x<<2)>>2]<<1)+(f[A+(x<<2)>>2]|0)>>q;b[g+x>>0]=E>>>0<256?E:(E|0)>0?255:0;E=u+C+w+G>>q;b[g+D>>0]=E>>>0<256?E:(E|0)>0?255:0;B=B+4|0}while((B|0)<=(s|0));I=a}if((I|0)>=(h|0))break;B=i;A=v;z=I;while(1){E=u+(f[B+(z<<2)>>2]|0)+(f[c+(z<<2)>>2]<<1)+(f[A+(z<<2)>>2]|0)>>q;b[g+z>>0]=E>>>0<256?E:(E|0)>0?255:0;z=z+1|0;if((z|0)==(h|0))break a}}if(o){if(t)J=0;else{z=i;A=v;B=0;do{E=B|1;D=f[z+(E<<2)>>2]|0;G=f[c+(E<<2)>>2]<<1;w=f[A+(E<<2)>>2]|0;C=u+(f[z+(B<<2)>>2]|0)-(f[c+(B<<2)>>2]<<1)+(f[A+(B<<2)>>2]|0)>>q;b[g+B>>0]=C>>>0<256?C:(C|0)>0?255:0;C=u+D-G+w>>q;b[g+E>>0]=C>>>0<256?C:(C|0)>0?255:0;C=B|2;E=B|3;w=f[z+(E<<2)>>2]|0;G=f[c+(E<<2)>>2]<<1;D=f[A+(E<<2)>>2]|0;x=u+(f[z+(C<<2)>>2]|0)-(f[c+(C<<2)>>2]<<1)+(f[A+(C<<2)>>2]|0)>>q;b[g+C>>0]=x>>>0<256?x:(x|0)>0?255:0;x=u+w-G+D>>q;b[g+E>>0]=x>>>0<256?x:(x|0)>0?255:0;B=B+4|0}while((B|0)<=(s|0));J=a}if((J|0)>=(h|0))break;B=i;A=v;z=J;do{x=u+(f[B+(z<<2)>>2]|0)-(f[c+(z<<2)>>2]<<1)+(f[A+(z<<2)>>2]|0)>>q;b[g+z>>0]=x>>>0<256?x:(x|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}else{if(t)K=0;else{z=i;A=v;B=0;do{x=Y((f[A+(B<<2)>>2]|0)+(f[z+(B<<2)>>2]|0)|0,m)|0;E=Y(f[c+(B<<2)>>2]|0,l)|0;D=B|1;G=Y((f[A+(D<<2)>>2]|0)+(f[z+(D<<2)>>2]|0)|0,m)|0;w=Y(f[c+(D<<2)>>2]|0,l)|0;C=u+E+x>>q;b[g+B>>0]=C>>>0<256?C:(C|0)>0?255:0;C=u+w+G>>q;b[g+D>>0]=C>>>0<256?C:(C|0)>0?255:0;C=B|2;D=Y((f[A+(C<<2)>>2]|0)+(f[z+(C<<2)>>2]|0)|0,m)|0;G=Y(f[c+(C<<2)>>2]|0,l)|0;w=B|3;x=Y((f[A+(w<<2)>>2]|0)+(f[z+(w<<2)>>2]|0)|0,m)|0;E=Y(f[c+(w<<2)>>2]|0,l)|0;F=u+G+D>>q;b[g+C>>0]=F>>>0<256?F:(F|0)>0?255:0;F=u+E+x>>q;b[g+w>>0]=F>>>0<256?F:(F|0)>0?255:0;B=B+4|0}while((B|0)<=(s|0));K=a}if((K|0)>=(h|0))break;B=i;z=v;A=K;do{F=Y((f[z+(A<<2)>>2]|0)+(f[B+(A<<2)>>2]|0)|0,m)|0;w=u+(Y(f[c+(A<<2)>>2]|0,l)|0)+F>>q;b[g+A>>0]=w>>>0<256?w:(w|0)>0?255:0;A=A+1|0}while((A|0)!=(h|0))}}while(0);if(!j)break;else g=g+e|0}return}function kda(a){a=a|0;PYa(a);return}function lda(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function mda(a){a=a|0;PYa(a);return}function nda(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function oda(a){a=a|0;PYa(a);return}function pda(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function qda(a){a=a|0;PYa(a);return}function rda(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function sda(a){a=a|0;PYa(a);return}function tda(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function uda(a){a=a|0;PYa(a);return}function vda(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function wda(a){a=a|0;PYa(a);return}function xda(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function yda(a){a=a|0;PYa(a);return}function zda(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Ada(a){a=a|0;PYa(a);return}function Bda(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Cda(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;m=u;u=u+288|0;n=m+232|0;o=m+176|0;p=m+120|0;q=m+112|0;r=m+104|0;s=m+48|0;t=m+32|0;v=m+16|0;w=m;do if((NS(e)|0)==65536){x=f[e+4>>2]|0;f[n>>2]=f[x>>2];y=n+4|0;z=x+4|0;f[y>>2]=f[z>>2];A=n+8|0;f[A>>2]=f[x+8>>2];f[n+12>>2]=f[x+12>>2];f[n+16>>2]=f[x+16>>2];f[n+20>>2]=f[x+20>>2];f[n+24>>2]=f[x+24>>2];f[n+28>>2]=f[x+28>>2];f[n+32>>2]=f[x+32>>2];B=f[x+36>>2]|0;f[n+36>>2]=B;f[n+40>>2]=A;A=n+48|0;C=n+44|0;f[C>>2]=A;f[A>>2]=0;f[n+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[x+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;BR(n,x);break}}else OR(n,e,-1);while(0);do if((NS(g)|0)==65536){e=f[g+4>>2]|0;f[o>>2]=f[e>>2];x=o+4|0;y=e+4|0;f[x>>2]=f[y>>2];z=o+8|0;f[z>>2]=f[e+8>>2];f[o+12>>2]=f[e+12>>2];f[o+16>>2]=f[e+16>>2];f[o+20>>2]=f[e+20>>2];f[o+24>>2]=f[e+24>>2];f[o+28>>2]=f[e+28>>2];f[o+32>>2]=f[e+32>>2];A=f[e+36>>2]|0;f[o+36>>2]=A;f[o+40>>2]=z;z=o+48|0;C=o+44|0;f[C>>2]=z;f[z>>2]=0;f[o+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[e+44>>2]|0;z=f[C>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;BR(o,e);break}}else OR(o,g,-1);while(0);g=c&4095;e=d&4095;x=c&7;y=d&7;z=c>>>3&511;if((z|0)!=(d>>>3&511|0)){f[p>>2]=0;f[p+4>>2]=0;D=c$(p,50)|0;d=232367;E=D+50|0;do{b[D>>0]=b[d>>0]|0;D=D+1|0;d=d+1|0}while((D|0)<(E|0));j$(-215,p,232418,225433,3759);d$(p)}d=n+8|0;c=o+8|0;C=o+12|0;A=(f[c>>2]|0)+-1+(f[C>>2]|0)|0;B=f[h>>2]|0;if((B|0)<0){F=((f[d>>2]|0)+-1+(f[n+12>>2]|0)|0)/2|0;f[h>>2]=F;G=F}else G=B;B=h+4|0;if((f[B>>2]|0)<0)f[B>>2]=(A|0)/2|0;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=n;A=(f[d>>2]|0)==1;f[q>>2]=A?G:0;f[q+4>>2]=A?0:G;G=A9(p,q)|0;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=o;q=(f[c>>2]|0)==1;A=f[B>>2]|0;f[r>>2]=q?A:0;f[r+4>>2]=q?0:A;A=A9(p,r)|0;f[p>>2]=1124007936;r=p+4|0;q=p+8|0;F=p+40|0;D=r;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[F>>2]=q;H=p+48|0;I=p+44|0;f[I>>2]=H;f[H>>2]=0;f[p+52>>2]=0;f[s>>2]=1124007936;J=s+4|0;K=s+8|0;L=s+40|0;D=J;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[L>>2]=K;D=s+48|0;E=s+44|0;f[E>>2]=D;f[D>>2]=0;f[s+52>>2]=0;M=x>>>0<y>>>0?y:x;N=(M|0)>5?M:5;do if(!x){M=(y|0)==0;if(!((G|0)==5&(A|0)==5&M)){if((G&3|0)==0|(A&3|0)==0){O=26;break}if(!((G&8&A|0)!=0&(y|0)==3)){O=26;break}}P=M?8:0;M=t+8|0;f[M>>2]=0;f[M+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=p;Q=+(1<<P|0);WJ(n,t,4,Q,0.0);M=t+8|0;f[M>>2]=0;f[M+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=s;WJ(o,t,4,Q,0.0);M=P<<1;R=+(1<<M|0)*i;S=4;T=M}else O=26;while(0);do if((O|0)==26){if((f[n>>2]&4095|0)==(N|0)){y=n+36|0;x=f[y>>2]|0;if(x){M=x+12|0;f[M>>2]=(f[M>>2]|0)+1;M=p+36|0;x=f[M>>2]|0;if((x|0)!=0?(P=x+12|0,x=f[P>>2]|0,f[P>>2]=x+-1,(x|0)==1):0){CR(p);U=M}else U=M}else U=p+36|0;f[U>>2]=0;M=p+16|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[r>>2]|0)>0){x=f[F>>2]|0;P=0;do{f[x+(P<<2)>>2]=0;P=P+1|0;V=f[r>>2]|0}while((P|0)<(V|0));f[p>>2]=f[n>>2];if((V|0)<3)O=38;else O=40}else{f[p>>2]=f[n>>2];O=38}if((O|0)==38){P=f[n+4>>2]|0;if((P|0)<3){f[r>>2]=P;f[q>>2]=f[d>>2];f[p+12>>2]=f[n+12>>2];P=f[n+44>>2]|0;x=f[I>>2]|0;f[x>>2]=f[P>>2];f[x+4>>2]=f[P+4>>2]}else O=40}if((O|0)==40)BR(p,n);f[M>>2]=f[n+16>>2];f[p+20>>2]=f[n+20>>2];f[p+24>>2]=f[n+24>>2];f[p+28>>2]=f[n+28>>2];f[p+32>>2]=f[n+32>>2];f[U>>2]=f[y>>2]}else{P=t+8|0;f[P>>2]=0;f[P+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=p;WJ(n,t,N,1.0,0.0)}if((f[o>>2]&4095|0)!=(N|0)){P=t+8|0;f[P>>2]=0;f[P+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=s;WJ(o,t,N,1.0,0.0);R=i;S=N;T=0;break}P=o+36|0;x=f[P>>2]|0;if(x|0){W=x+12|0;f[W>>2]=(f[W>>2]|0)+1}W=s+36|0;x=f[W>>2]|0;if(x|0?(X=x+12|0,x=f[X>>2]|0,f[X>>2]=x+-1,(x|0)==1):0)CR(s);f[W>>2]=0;x=s+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[J>>2]|0)>0){X=f[L>>2]|0;Y=0;do{f[X+(Y<<2)>>2]=0;Y=Y+1|0;Z=f[J>>2]|0}while((Y|0)<(Z|0));f[s>>2]=f[o>>2];if((Z|0)<3)O=54;else O=56}else{f[s>>2]=f[o>>2];O=54}if((O|0)==54){Y=f[o+4>>2]|0;if((Y|0)<3){f[J>>2]=Y;f[K>>2]=f[c>>2];f[s+12>>2]=f[C>>2];Y=f[o+44>>2]|0;X=f[E>>2]|0;f[X>>2]=f[Y>>2];f[X+4>>2]=f[Y+4>>2]}else O=56}if((O|0)==56)BR(s,o);f[x>>2]=f[o+16>>2];f[s+20>>2]=f[o+20>>2];f[s+24>>2]=f[o+24>>2];f[s+28>>2]=f[o+28>>2];f[s+32>>2]=f[o+32>>2];f[W>>2]=f[P>>2];R=i;S=N;T=0}while(0);N=S&7|z<<3;f[v+8>>2]=0;f[v+12>>2]=0;f[v>>2]=16842752;f[v+4>>2]=p;B9(t,g,N,v,f[h>>2]|0,G);f[w+8>>2]=0;f[w+12>>2]=0;f[w>>2]=16842752;f[w+4>>2]=s;_aa(v,N,e,w,f[B>>2]|0,A,R,T);T=NYa(200)|0;f[w>>2]=0;f[w+4>>2]=0;y9(T,w,t,v,g,e,N,j,k,l);l=NYa(16)|0;f[l+4>>2]=1;f[l>>2]=58548;f[l+8>>2]=T;f[a>>2]=l;f[a+4>>2]=T;T=f[v>>2]|0;if(T|0?(v=T+4|0,a=f[v>>2]|0,f[v>>2]=a+-1,(a|0)==1):0)ki[f[(f[T>>2]|0)+8>>2]&2047](T);T=f[t>>2]|0;if(T|0?(t=T+4|0,a=f[t>>2]|0,f[t>>2]=a+-1,(a|0)==1):0)ki[f[(f[T>>2]|0)+8>>2]&2047](T);T=s+36|0;a=f[T>>2]|0;if(a|0?(t=a+12|0,a=f[t>>2]|0,f[t>>2]=a+-1,(a|0)==1):0)CR(s);f[T>>2]=0;T=s+16|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[J>>2]|0)>0){T=f[L>>2]|0;L=0;do{f[T+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[J>>2]|0))}J=f[E>>2]|0;if((J|0)!=(D|0))ZF(J);J=p+36|0;D=f[J>>2]|0;if(D|0?(E=D+12|0,D=f[E>>2]|0,f[E>>2]=D+-1,(D|0)==1):0)CR(p);f[J>>2]=0;J=p+16|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[r>>2]|0)>0){J=f[F>>2]|0;F=0;do{f[J+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[r>>2]|0))}r=f[I>>2]|0;if((r|0)!=(H|0))ZF(r);r=o+36|0;H=f[r>>2]|0;if(H|0?(I=H+12|0,H=f[I>>2]|0,f[I>>2]=H+-1,(H|0)==1):0)CR(o);f[r>>2]=0;r=o+16|0;H=o+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[H>>2]|0)>0){r=f[o+40>>2]|0;I=0;do{f[r+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[H>>2]|0))}H=f[o+44>>2]|0;if((H|0)!=(o+48|0))ZF(H);H=n+36|0;o=f[H>>2]|0;if(o|0?(I=o+12|0,o=f[I>>2]|0,f[I>>2]=o+-1,(o|0)==1):0)CR(n);f[H>>2]=0;H=n+16|0;o=n+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[o>>2]|0)>0){H=f[n+40>>2]|0;I=0;do{f[H+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[o>>2]|0))}o=f[n+44>>2]|0;if((o|0)==(n+48|0)){u=m;return}ZF(o);u=m;return}function Dda(a){a=a|0;PYa(a);return}function Eda(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Fda(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0;e=u;u=u+16|0;g=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;h=bZ(g)|0;i=f[a>>2]|0;j=(h|0)==0?1:h;h=i&65535;switch(h&4095){case 0:case 4:case 5:case 6:break;default:{f[g>>2]=0;f[g+4>>2]=0;k=c$(g,52)|0;l=232518;m=k+52|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,g,232571,225433,3826);d$(g)}}g=c+4|0;l=f[g>>2]|0;k=f[c>>2]|0;m=l-k>>3;o=k;k=l;if(j>>>0<=m>>>0){if(j>>>0<m>>>0?(l=o+(j<<3)|0,(k|0)!=(l|0)):0)f[g>>2]=k+(~((k+-8-l|0)>>>3)<<3)}else Gda(c,j-m|0);m=Y((i>>>3&511)+1<<(47696>>>(i<<1&14)&3),j)|0;j=d+4|0;i=f[j>>2]|0;l=f[d>>2]|0;k=i-l|0;g=l;l=i;if(m>>>0<=k>>>0)if(m>>>0<k>>>0?(i=g+m|0,(l|0)!=(i|0)):0){f[j>>2]=i;q=g}else q=g;else{TR(d,m-k|0);q=f[d>>2]|0}d=a+8|0;if((f[d>>2]|0)<=0){u=e;return}k=a+16|0;m=a+44|0;g=a+12|0;a=(h&4095)==0;i=f[g>>2]|0;j=0;l=0;while(1){o=(f[k>>2]|0)+(Y(f[f[m>>2]>>2]|0,j)|0)|0;a:do if((i|0)>0){if(a){r=i;s=0;t=l;while(1){v=b[o+s>>0]|0;if(!(v<<24>>24)){w=r;x=t}else{y=f[c>>2]|0;f[y+(t<<3)>>2]=s;f[y+(t<<3)+4>>2]=j;b[q+t>>0]=v;w=f[g>>2]|0;x=t+1|0}s=s+1|0;if((s|0)>=(w|0)){z=w;A=x;break a}else{r=w;t=x}}}t=f[c>>2]|0;r=i;s=0;v=l;while(1){switch(h&4095){case 5:{B=+n[o+(s<<2)>>2];if(B==0.0){C=r;D=v}else{f[t+(v<<3)>>2]=s;f[t+(v<<3)+4>>2]=j;n[q+(v<<2)>>2]=B;C=r;D=v+1|0}break}case 4:{y=f[o+(s<<2)>>2]|0;if(!y){C=r;D=v}else{f[t+(v<<3)>>2]=s;f[t+(v<<3)+4>>2]=j;f[q+(v<<2)>>2]=y;C=f[g>>2]|0;D=v+1|0}break}default:{B=+p[o+(s<<3)>>3];if(B==0.0){C=r;D=v}else{f[t+(v<<3)>>2]=s;f[t+(v<<3)+4>>2]=j;p[q+(v<<3)>>3]=B;C=r;D=v+1|0}}}s=s+1|0;if((s|0)>=(C|0)){z=C;A=D;break a}else{r=C;v=D}}}else{z=i;A=l}while(0);j=j+1|0;if((j|0)>=(f[d>>2]|0))break;else{i=z;l=A}}u=e;return}function Gda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(d-g>>3>>>0>=b>>>0){F1a(g|0,0,b<<3|0)|0;f[e>>2]=h+(b<<3);return}i=f[a>>2]|0;j=g-i>>3;g=j+b|0;k=i;if(g>>>0>536870911)gXa(a);l=d-i|0;d=l>>2;m=l>>3>>>0<268435455?(d>>>0<g>>>0?g:d):536870911;do if(m)if(m>>>0>536870911){d=De(8)|0;UYa(d,358155);f[d>>2]=130560;Of(d|0,21520,875)}else{n=NYa(m<<3)|0;break}else n=0;while(0);d=n+(j<<3)|0;j=n+(m<<3)|0;F1a(d|0,0,b<<3|0)|0;m=d+(b<<3)|0;if((h|0)==(k|0)){o=d;p=i}else{b=h+-8-i|0;i=d;n=h;while(1){h=n;n=n+-8|0;f[i+-8>>2]=f[n>>2];f[i+-4>>2]=f[h+-4>>2];if((n|0)==(k|0))break;else i=i+-8|0}o=d+(~(b>>>3)<<3)|0;p=f[a>>2]|0}f[a>>2]=o;f[e>>2]=m;f[c>>2]=j;if(!p)return;PYa(p);return}function Hda(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;j=u;u=u+144|0;k=j;l=j+120|0;m=j+137|0;n=j+136|0;o=j+64|0;p=j+8|0;do if((NS(e)|0)==65536){q=f[e+4>>2]|0;f[o>>2]=f[q>>2];r=o+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=o+8|0;f[t>>2]=f[q+8>>2];f[o+12>>2]=f[q+12>>2];f[o+16>>2]=f[q+16>>2];f[o+20>>2]=f[q+20>>2];f[o+24>>2]=f[q+24>>2];f[o+28>>2]=f[q+28>>2];f[o+32>>2]=f[q+32>>2];v=f[q+36>>2]|0;f[o+36>>2]=v;f[o+40>>2]=t;t=o+48|0;w=o+44|0;f[w>>2]=t;f[t>>2]=0;f[o+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];x=o;break}else{f[r>>2]=0;BR(o,q);x=o;break}}else{OR(o,e,-1);x=o}while(0);e=c&7;q=d&7;if(q>>>0<e>>>0|((d^c)&4088|0)!=0){f[l>>2]=0;f[l+4>>2]=0;y=c$(l,69)|0;z=232590;A=y+69|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));j$(-215,l,232660,225433,4428);d$(l)}r=f[g>>2]|0;s=g+4|0;t=f[s>>2]|0;w=o+40|0;v=f[w>>2]|0;B=f[v+4>>2]|0;C=f[v>>2]|0;v=(r|0)==-1?(B|0)/2|0:r;r=(t|0)==-1?(C|0)/2|0:t;if(!((v|0)>-1&(v|0)<(B|0)?!((r|0)<0|(r|0)>=(C|0)):0)){f[l>>2]=0;f[l+4>>2]=0;y=c$(l,52)|0;z=320583;A=y+52|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));j$(-215,l,320636,320652,363);d$(l)}f[g>>2]=v;f[s>>2]=r;r=(e|0)==6;v=(q|0)==6;z=r|v?6:5;f[p>>2]=1124007936;C=p+4|0;B=p+8|0;t=p+40|0;y=C;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[t>>2]=B;y=p+48|0;A=p+44|0;f[A>>2]=y;f[y>>2]=0;f[p+52>>2]=0;D=f[x>>2]&4095;if((D|0)==(z|0)){E=o+36|0;F=f[E>>2]|0;if(F){G=F+12|0;f[G>>2]=(f[G>>2]|0)+1;G=p+36|0;F=f[G>>2]|0;if((F|0)!=0?(H=F+12|0,F=f[H>>2]|0,f[H>>2]=F+-1,(F|0)==1):0){CR(p);I=G}else I=G}else I=p+36|0;f[I>>2]=0;G=p+16|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[C>>2]|0)>0){F=f[t>>2]|0;H=0;do{f[F+(H<<2)>>2]=0;H=H+1|0;J=f[C>>2]|0}while((H|0)<(J|0));f[p>>2]=f[x>>2];if((J|0)<3)K=24;else K=26}else{f[p>>2]=f[x>>2];K=24}if((K|0)==24){x=f[o+4>>2]|0;if((x|0)<3){f[C>>2]=x;f[B>>2]=f[o+8>>2];f[p+12>>2]=f[o+12>>2];B=f[o+44>>2]|0;x=f[A>>2]|0;f[x>>2]=f[B>>2];f[x+4>>2]=f[B+4>>2]}else K=26}if((K|0)==26)BR(p,o);f[G>>2]=f[o+16>>2];f[p+20>>2]=f[o+20>>2];f[p+24>>2]=f[o+24>>2];f[p+28>>2]=f[o+28>>2];f[p+32>>2]=f[o+32>>2];f[I>>2]=f[E>>2]}else{E=l+8|0;f[E>>2]=0;f[E+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=p;WJ(o,l,z,(D|0)==4?1.0/+(1<<i|0):1.0,0.0)}i=(e|0)==0;do if(!((d|c)&7)){D=NYa(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Ida(D,p,l,h,m,n);z=NYa(16)|0;E=z+4|0;f[E>>2]=1;f[z>>2]=58568;f[z+8>>2]=D;f[a>>2]=z;f[a+4>>2]=D;f[E>>2]=(f[E>>2]|0)+1;D=f[E>>2]|0;f[E>>2]=D+-1;if((D|0)==1)ki[f[(f[z>>2]|0)+8>>2]&2047](z)}else{z=(q|0)==2;if(i&z){D=NYa(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Jda(D,p,l,h,m,n);E=NYa(16)|0;I=E+4|0;f[I>>2]=1;f[E>>2]=58588;f[E+8>>2]=D;f[a>>2]=E;f[a+4>>2]=D;f[I>>2]=(f[I>>2]|0)+1;D=f[I>>2]|0;f[I>>2]=D+-1;if((D|0)!=1)break;ki[f[(f[E>>2]|0)+8>>2]&2047](E);break}E=(q|0)==3;if(i&E){D=NYa(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Kda(D,p,l,h,m,n);I=NYa(16)|0;G=I+4|0;f[G>>2]=1;f[I>>2]=58608;f[I+8>>2]=D;f[a>>2]=I;f[a+4>>2]=D;f[G>>2]=(f[G>>2]|0)+1;D=f[G>>2]|0;f[G>>2]=D+-1;if((D|0)==1)ki[f[(f[I>>2]|0)+8>>2]&2047](I);break}I=(q|0)==5;if(i&I){D=NYa(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Lda(D,p,l,h,m,n);G=NYa(16)|0;K=G+4|0;f[K>>2]=1;f[G>>2]=58628;f[G+8>>2]=D;f[a>>2]=G;f[a+4>>2]=D;f[K>>2]=(f[K>>2]|0)+1;D=f[K>>2]|0;f[K>>2]=D+-1;if((D|0)!=1)break;ki[f[(f[G>>2]|0)+8>>2]&2047](G);break}if(i&v){G=NYa(72)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Mda(G,p,l,h,m,n);D=NYa(16)|0;K=D+4|0;f[K>>2]=1;f[D>>2]=58648;f[D+8>>2]=G;f[a>>2]=D;f[a+4>>2]=G;f[K>>2]=(f[K>>2]|0)+1;G=f[K>>2]|0;f[K>>2]=G+-1;if((G|0)!=1)break;ki[f[(f[D>>2]|0)+8>>2]&2047](D);break}D=(e|0)==2;if(D&z){z=NYa(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Nda(z,p,l,h,m,n);G=NYa(16)|0;K=G+4|0;f[K>>2]=1;f[G>>2]=58668;f[G+8>>2]=z;f[a>>2]=G;f[a+4>>2]=z;f[K>>2]=(f[K>>2]|0)+1;z=f[K>>2]|0;f[K>>2]=z+-1;if((z|0)!=1)break;ki[f[(f[G>>2]|0)+8>>2]&2047](G);break}if(D&I){G=NYa(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Oda(G,p,l,h,m,n);z=NYa(16)|0;K=z+4|0;f[K>>2]=1;f[z>>2]=58688;f[z+8>>2]=G;f[a>>2]=z;f[a+4>>2]=G;f[K>>2]=(f[K>>2]|0)+1;G=f[K>>2]|0;f[K>>2]=G+-1;if((G|0)!=1)break;ki[f[(f[z>>2]|0)+8>>2]&2047](z);break}if(D&v){D=NYa(72)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Pda(D,p,l,h,m,n);z=NYa(16)|0;G=z+4|0;f[G>>2]=1;f[z>>2]=58708;f[z+8>>2]=D;f[a>>2]=z;f[a+4>>2]=D;f[G>>2]=(f[G>>2]|0)+1;D=f[G>>2]|0;f[G>>2]=D+-1;if((D|0)!=1)break;ki[f[(f[z>>2]|0)+8>>2]&2047](z);break}z=(e|0)==3;if(z&E){E=NYa(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Qda(E,p,l,h,m,n);D=NYa(16)|0;G=D+4|0;f[G>>2]=1;f[D>>2]=58728;f[D+8>>2]=E;f[a>>2]=D;f[a+4>>2]=E;f[G>>2]=(f[G>>2]|0)+1;E=f[G>>2]|0;f[G>>2]=E+-1;if((E|0)!=1)break;ki[f[(f[D>>2]|0)+8>>2]&2047](D);break}if(z&I){D=NYa(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Rda(D,p,l,h,m,n);E=NYa(16)|0;G=E+4|0;f[G>>2]=1;f[E>>2]=58748;f[E+8>>2]=D;f[a>>2]=E;f[a+4>>2]=D;f[G>>2]=(f[G>>2]|0)+1;D=f[G>>2]|0;f[G>>2]=D+-1;if((D|0)!=1)break;ki[f[(f[E>>2]|0)+8>>2]&2047](E);break}if(z&v){z=NYa(72)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Sda(z,p,l,h,m,n);E=NYa(16)|0;D=E+4|0;f[D>>2]=1;f[E>>2]=58768;f[E+8>>2]=z;f[a>>2]=E;f[a+4>>2]=z;f[D>>2]=(f[D>>2]|0)+1;z=f[D>>2]|0;f[D>>2]=z+-1;if((z|0)!=1)break;ki[f[(f[E>>2]|0)+8>>2]&2047](E);break}if((e|0)==5&I){I=NYa(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Tda(I,p,l,h,m,n);E=NYa(16)|0;z=E+4|0;f[z>>2]=1;f[E>>2]=58788;f[E+8>>2]=I;f[a>>2]=E;f[a+4>>2]=I;f[z>>2]=(f[z>>2]|0)+1;I=f[z>>2]|0;f[z>>2]=I+-1;if((I|0)==1)ki[f[(f[E>>2]|0)+8>>2]&2047](E);break}if(!(r&v)){f[k>>2]=c;f[k+4>>2]=d;p$(l,232676,k);j$(-213,l,232660,225433,4493);d$(l);f[a>>2]=0;f[a+4>>2]=0;break}E=NYa(72)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];Uda(E,p,l,h,m,n);I=NYa(16)|0;z=I+4|0;f[z>>2]=1;f[I>>2]=58808;f[I+8>>2]=E;f[a>>2]=I;f[a+4>>2]=E;f[z>>2]=(f[z>>2]|0)+1;E=f[z>>2]|0;f[z>>2]=E+-1;if((E|0)==1)ki[f[(f[I>>2]|0)+8>>2]&2047](I)}while(0);a=p+36|0;n=f[a>>2]|0;if(n|0?(m=n+12|0,n=f[m>>2]|0,f[m>>2]=n+-1,(n|0)==1):0)CR(p);f[a>>2]=0;a=p+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[C>>2]|0)>0){a=f[t>>2]|0;t=0;do{f[a+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[C>>2]|0))}C=f[A>>2]|0;if((C|0)!=(y|0))ZF(C);C=o+36|0;y=f[C>>2]|0;if(y|0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0)CR(o);f[C>>2]=0;C=o+16|0;y=o+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[y>>2]|0)>0){C=f[w>>2]|0;w=0;do{f[C+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[y>>2]|0))}y=f[o+44>>2]|0;if((y|0)==(o+48|0)){u=j;return}ZF(y);u=j;return}function Ida(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=59116;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=c$(g,36)|0;a=232853;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));j$(-215,g,232890,225433,3887);d$(g)}Fda(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){u9(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Jda(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=59092;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=c$(g,36)|0;a=232853;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));j$(-215,g,232890,225433,3887);d$(g)}Fda(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){u9(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Kda(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=59068;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=c$(g,36)|0;a=232853;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));j$(-215,g,232890,225433,3887);d$(g)}Fda(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){u9(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Lda(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=59044;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=c$(g,36)|0;a=232853;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));j$(-215,g,232890,225433,3887);d$(g)}Fda(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){u9(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Mda(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=59020;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;n=a+48|0;o=j;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;p[a+56>>3]=e;if((f[c>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;o=c$(g,36)|0;a=232853;q=o+36|0;do{b[o>>0]=b[a>>0]|0;o=o+1|0;a=a+1|0}while((o|0)<(q|0));j$(-215,g,232890,225433,3887);d$(g)}Fda(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[n>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){u9(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[n>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Nda(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=58996;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=c$(g,36)|0;a=232853;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));j$(-215,g,232890,225433,3887);d$(g)}Fda(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){u9(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Oda(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=58972;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=c$(g,36)|0;a=232853;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));j$(-215,g,232890,225433,3887);d$(g)}Fda(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){u9(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Pda(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=58948;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;n=a+48|0;o=j;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;p[a+56>>3]=e;if((f[c>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;o=c$(g,36)|0;a=232853;q=o+36|0;do{b[o>>0]=b[a>>0]|0;o=o+1|0;a=a+1|0}while((o|0)<(q|0));j$(-215,g,232890,225433,3887);d$(g)}Fda(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[n>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){u9(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[n>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Qda(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=58924;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=c$(g,36)|0;a=232853;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));j$(-215,g,232890,225433,3887);d$(g)}Fda(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){u9(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Rda(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=58900;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=c$(g,36)|0;a=232853;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));j$(-215,g,232890,225433,3887);d$(g)}Fda(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){u9(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Sda(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=58876;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;n=a+48|0;o=j;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;p[a+56>>3]=e;if((f[c>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;o=c$(g,36)|0;a=232853;q=o+36|0;do{b[o>>0]=b[a>>0]|0;o=o+1|0;a=a+1|0}while((o|0)<(q|0));j$(-215,g,232890,225433,3887);d$(g)}Fda(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[n>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){u9(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[n>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Tda(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=58852;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=c$(g,36)|0;a=232853;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));j$(-215,g,232890,225433,3887);d$(g)}Fda(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){u9(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Uda(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=58828;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;n=a+48|0;o=j;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;p[a+56>>3]=e;if((f[c>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;o=c$(g,36)|0;a=232853;q=o+36|0;do{b[o>>0]=b[a>>0]|0;o=o+1|0;a=a+1|0}while((o|0)<(q|0));j$(-215,g,232890,225433,3887);d$(g)}Fda(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[n>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){u9(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[n>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Vda(a){a=a|0;PYa(a);return}function Wda(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Xda(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58828;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function Yda(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58828;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function Zda(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0;i=+p[a+56>>3];j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=f[a+44>>2]|0;m=(f[a+24>>2]|0)-j|0;a=m>>3;n=Y(h,g)|0;if((e|0)<=0)return;g=(m|0)>0;m=n+-4|0;o=(n|0)<4;q=n&-4;r=e;e=c;c=b;while(1){if(g){b=0;do{s=(f[c+(f[j+(b<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(b<<3)>>2]|0,h)|0)<<3)|0;f[l+(b<<2)>>2]=s;b=b+1|0}while((b|0)<(a|0))}a:do if(o)t=0;else{if(g)u=0;else{b=0;while(1){p[e+(b<<3)>>3]=i;p[e+((b|1)<<3)>>3]=i;p[e+((b|2)<<3)>>3]=i;p[e+((b|3)<<3)>>3]=i;b=b+4|0;if((b|0)>(m|0)){t=q;break a}}}do{b=0;v=i;w=i;x=i;y=i;do{s=(f[l+(b<<2)>>2]|0)+(u<<3)|0;z=+p[k+(b<<3)>>3];v=v+z*+p[s>>3];w=w+z*+p[s+8>>3];x=x+z*+p[s+16>>3];y=y+z*+p[s+24>>3];b=b+1|0}while((b|0)<(a|0));p[e+(u<<3)>>3]=v;p[e+((u|1)<<3)>>3]=w;p[e+((u|2)<<3)>>3]=x;p[e+((u|3)<<3)>>3]=y;u=u+4|0}while((u|0)<=(m|0));t=q}while(0);b:do if((t|0)<(n|0)){if(g)A=t;else{b=t;while(1){p[e+(b<<3)>>3]=i;b=b+1|0;if((b|0)==(n|0))break b}}do{b=0;z=i;do{z=z+ +p[k+(b<<3)>>3]*+p[(f[l+(b<<2)>>2]|0)+(A<<3)>>3];b=b+1|0}while((b|0)<(a|0));p[e+(A<<3)>>3]=z;A=A+1|0}while((A|0)!=(n|0))}while(0);if((r|0)>1){r=r+-1|0;e=e+d|0;c=c+4|0}else break}return}function _da(a){a=a|0;PYa(a);return}function $da(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function aea(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58852;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function bea(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58852;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function cea(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0;i=+n[a+56>>2];j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=f[a+44>>2]|0;m=(f[a+24>>2]|0)-j|0;a=m>>3;o=Y(h,g)|0;if((e|0)<=0)return;g=(m|0)>0;m=o+-4|0;p=(o|0)<4;q=o&-4;r=e;e=c;c=b;while(1){if(g){b=0;do{s=(f[c+(f[j+(b<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(b<<3)>>2]|0,h)|0)<<2)|0;f[l+(b<<2)>>2]=s;b=b+1|0}while((b|0)<(a|0))}a:do if(p)t=0;else{if(g)u=0;else{b=0;while(1){n[e+(b<<2)>>2]=i;n[e+((b|1)<<2)>>2]=i;n[e+((b|2)<<2)>>2]=i;n[e+((b|3)<<2)>>2]=i;b=b+4|0;if((b|0)>(m|0)){t=q;break a}}}do{b=0;v=i;w=i;x=i;y=i;do{s=(f[l+(b<<2)>>2]|0)+(u<<2)|0;z=+n[k+(b<<2)>>2];v=v+z*+n[s>>2];w=w+z*+n[s+4>>2];x=x+z*+n[s+8>>2];y=y+z*+n[s+12>>2];b=b+1|0}while((b|0)<(a|0));n[e+(u<<2)>>2]=v;n[e+((u|1)<<2)>>2]=w;n[e+((u|2)<<2)>>2]=x;n[e+((u|3)<<2)>>2]=y;u=u+4|0}while((u|0)<=(m|0));t=q}while(0);b:do if((t|0)<(o|0)){if(g)A=t;else{b=t;while(1){n[e+(b<<2)>>2]=i;b=b+1|0;if((b|0)==(o|0))break b}}do{b=0;z=i;do{z=z+ +n[k+(b<<2)>>2]*+n[(f[l+(b<<2)>>2]|0)+(A<<2)>>2];b=b+1|0}while((b|0)<(a|0));n[e+(A<<2)>>2]=z;A=A+1|0}while((A|0)!=(o|0))}while(0);if((r|0)>1){r=r+-1|0;e=e+d|0;c=c+4|0}else break}return}function dea(a){a=a|0;PYa(a);return}function eea(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function fea(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58876;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function gea(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58876;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function hea(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;j=+p[a+56>>3];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;n=(f[a+24>>2]|0)-k|0;a=n>>3;o=Y(i,h)|0;if((g|0)<=0)return;h=(n|0)>0;n=o+-4|0;q=(o|0)<4;r=o&-4;s=g;g=c;c=b;while(1){if(h){b=0;do{t=(f[c+(f[k+(b<<3)+4>>2]<<2)>>2]|0)+((Y(f[k+(b<<3)>>2]|0,i)|0)<<1)|0;f[m+(b<<2)>>2]=t;b=b+1|0}while((b|0)<(a|0))}a:do if(q)u=0;else{if(h)v=0;else{b=0;while(1){p[g+(b<<3)>>3]=j;p[g+((b|1)<<3)>>3]=j;p[g+((b|2)<<3)>>3]=j;p[g+((b|3)<<3)>>3]=j;b=b+4|0;if((b|0)>(n|0)){u=r;break a}}}do{b=0;w=j;x=j;y=j;z=j;do{t=(f[m+(b<<2)>>2]|0)+(v<<1)|0;A=+p[l+(b<<3)>>3];w=w+A*+(d[t>>1]|0);x=x+A*+(d[t+2>>1]|0);y=y+A*+(d[t+4>>1]|0);z=z+A*+(d[t+6>>1]|0);b=b+1|0}while((b|0)<(a|0));p[g+(v<<3)>>3]=w;p[g+((v|1)<<3)>>3]=x;p[g+((v|2)<<3)>>3]=y;p[g+((v|3)<<3)>>3]=z;v=v+4|0}while((v|0)<=(n|0));u=r}while(0);b:do if((u|0)<(o|0)){if(h)B=u;else{b=u;while(1){p[g+(b<<3)>>3]=j;b=b+1|0;if((b|0)==(o|0))break b}}do{b=0;A=j;do{A=A+ +p[l+(b<<3)>>3]*+(d[(f[m+(b<<2)>>2]|0)+(B<<1)>>1]|0);b=b+1|0}while((b|0)<(a|0));p[g+(B<<3)>>3]=A;B=B+1|0}while((B|0)!=(o|0))}while(0);if((s|0)>1){s=s+-1|0;g=g+e|0;c=c+4|0}else break}return}function iea(a){a=a|0;PYa(a);return}function jea(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function kea(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58900;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function lea(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58900;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function mea(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;j=+n[a+56>>2];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;o=(f[a+24>>2]|0)-k|0;a=o>>3;p=Y(i,h)|0;if((g|0)<=0)return;h=(o|0)>0;o=p+-4|0;q=(p|0)<4;r=p&-4;s=g;g=c;c=b;while(1){if(h){b=0;do{t=(f[c+(f[k+(b<<3)+4>>2]<<2)>>2]|0)+((Y(f[k+(b<<3)>>2]|0,i)|0)<<1)|0;f[m+(b<<2)>>2]=t;b=b+1|0}while((b|0)<(a|0))}a:do if(q)u=0;else{if(h)v=0;else{b=0;while(1){n[g+(b<<2)>>2]=j;n[g+((b|1)<<2)>>2]=j;n[g+((b|2)<<2)>>2]=j;n[g+((b|3)<<2)>>2]=j;b=b+4|0;if((b|0)>(o|0)){u=r;break a}}}do{b=0;w=j;x=j;y=j;z=j;do{t=(f[m+(b<<2)>>2]|0)+(v<<1)|0;A=+n[l+(b<<2)>>2];w=w+A*+(d[t>>1]|0);x=x+A*+(d[t+2>>1]|0);y=y+A*+(d[t+4>>1]|0);z=z+A*+(d[t+6>>1]|0);b=b+1|0}while((b|0)<(a|0));n[g+(v<<2)>>2]=w;n[g+((v|1)<<2)>>2]=x;n[g+((v|2)<<2)>>2]=y;n[g+((v|3)<<2)>>2]=z;v=v+4|0}while((v|0)<=(o|0));u=r}while(0);b:do if((u|0)<(p|0)){if(h)B=u;else{b=u;while(1){n[g+(b<<2)>>2]=j;b=b+1|0;if((b|0)==(p|0))break b}}do{b=0;A=j;do{A=A+ +n[l+(b<<2)>>2]*+(d[(f[m+(b<<2)>>2]|0)+(B<<1)>>1]|0);b=b+1|0}while((b|0)<(a|0));n[g+(B<<2)>>2]=A;B=B+1|0}while((B|0)!=(p|0))}while(0);if((s|0)>1){s=s+-1|0;g=g+e|0;c=c+4|0}else break}return}function nea(a){a=a|0;PYa(a);return}function oea(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function pea(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58924;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function qea(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58924;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function rea(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;j=+n[a+56>>2];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;o=(f[a+24>>2]|0)-k|0;a=o>>3;p=Y(i,h)|0;if((g|0)<=0)return;h=(o|0)>0;o=p+-4|0;q=(p|0)<4;r=p&-4;s=g;g=c;c=b;while(1){if(h){b=0;do{t=(f[c+(f[k+(b<<3)+4>>2]<<2)>>2]|0)+((Y(f[k+(b<<3)>>2]|0,i)|0)<<1)|0;f[m+(b<<2)>>2]=t;b=b+1|0}while((b|0)<(a|0))}a:do if(q)u=0;else{if(h)v=0;else{b=wNa(j)|0;t=((b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768)&65535;b=0;while(1){d[g+(b<<1)>>1]=t;d[g+((b|1)<<1)>>1]=t;d[g+((b|2)<<1)>>1]=t;d[g+((b|3)<<1)>>1]=t;b=b+4|0;if((b|0)>(o|0)){u=r;break a}}}do{b=0;w=j;x=j;y=j;z=j;do{t=(f[m+(b<<2)>>2]|0)+(v<<1)|0;A=+n[l+(b<<2)>>2];w=w+A*+(d[t>>1]|0);x=x+A*+(d[t+2>>1]|0);y=y+A*+(d[t+4>>1]|0);z=z+A*+(d[t+6>>1]|0);b=b+1|0}while((b|0)<(a|0));b=wNa(w)|0;d[g+(v<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=wNa(x)|0;d[g+((v|1)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=wNa(y)|0;d[g+((v|2)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=wNa(z)|0;d[g+((v|3)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;v=v+4|0}while((v|0)<=(o|0));u=r}while(0);b:do if((u|0)<(p|0)){if(h)B=u;else{b=wNa(j)|0;t=((b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768)&65535;b=u;while(1){d[g+(b<<1)>>1]=t;b=b+1|0;if((b|0)==(p|0))break b}}do{b=0;A=j;do{A=A+ +n[l+(b<<2)>>2]*+(d[(f[m+(b<<2)>>2]|0)+(B<<1)>>1]|0);b=b+1|0}while((b|0)<(a|0));b=wNa(A)|0;d[g+(B<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;B=B+1|0}while((B|0)!=(p|0))}while(0);if((s|0)>1){s=s+-1|0;g=g+e|0;c=c+4|0}else break}return}function sea(a){a=a|0;PYa(a);return}function tea(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function uea(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58948;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function vea(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58948;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function wea(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;i=+p[a+56>>3];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;n=(f[a+24>>2]|0)-k|0;a=n>>3;o=Y(h,g)|0;if((e|0)<=0)return;g=(n|0)>0;n=o+-4|0;q=(o|0)<4;r=o&-4;s=e;e=c;c=b;while(1){if(g){b=0;do{t=(f[c+(f[k+(b<<3)+4>>2]<<2)>>2]|0)+((Y(f[k+(b<<3)>>2]|0,h)|0)<<1)|0;f[m+(b<<2)>>2]=t;b=b+1|0}while((b|0)<(a|0))}a:do if(q)u=0;else{if(g)v=0;else{b=0;while(1){p[e+(b<<3)>>3]=i;p[e+((b|1)<<3)>>3]=i;p[e+((b|2)<<3)>>3]=i;p[e+((b|3)<<3)>>3]=i;b=b+4|0;if((b|0)>(n|0)){u=r;break a}}}do{b=0;w=i;x=i;y=i;z=i;do{t=(f[m+(b<<2)>>2]|0)+(v<<1)|0;A=+p[l+(b<<3)>>3];w=w+A*+(j[t>>1]|0);x=x+A*+(j[t+2>>1]|0);y=y+A*+(j[t+4>>1]|0);z=z+A*+(j[t+6>>1]|0);b=b+1|0}while((b|0)<(a|0));p[e+(v<<3)>>3]=w;p[e+((v|1)<<3)>>3]=x;p[e+((v|2)<<3)>>3]=y;p[e+((v|3)<<3)>>3]=z;v=v+4|0}while((v|0)<=(n|0));u=r}while(0);b:do if((u|0)<(o|0)){if(g)B=u;else{b=u;while(1){p[e+(b<<3)>>3]=i;b=b+1|0;if((b|0)==(o|0))break b}}do{b=0;A=i;do{A=A+ +p[l+(b<<3)>>3]*+(j[(f[m+(b<<2)>>2]|0)+(B<<1)>>1]|0);b=b+1|0}while((b|0)<(a|0));p[e+(B<<3)>>3]=A;B=B+1|0}while((B|0)!=(o|0))}while(0);if((s|0)>1){s=s+-1|0;e=e+d|0;c=c+4|0}else break}return}function xea(a){a=a|0;PYa(a);return}function yea(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function zea(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58972;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function Aea(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58972;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function Bea(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;i=+n[a+56>>2];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;o=(f[a+24>>2]|0)-k|0;a=o>>3;p=Y(h,g)|0;if((e|0)<=0)return;g=(o|0)>0;o=p+-4|0;q=(p|0)<4;r=p&-4;s=e;e=c;c=b;while(1){if(g){b=0;do{t=(f[c+(f[k+(b<<3)+4>>2]<<2)>>2]|0)+((Y(f[k+(b<<3)>>2]|0,h)|0)<<1)|0;f[m+(b<<2)>>2]=t;b=b+1|0}while((b|0)<(a|0))}a:do if(q)u=0;else{if(g)v=0;else{b=0;while(1){n[e+(b<<2)>>2]=i;n[e+((b|1)<<2)>>2]=i;n[e+((b|2)<<2)>>2]=i;n[e+((b|3)<<2)>>2]=i;b=b+4|0;if((b|0)>(o|0)){u=r;break a}}}do{b=0;w=i;x=i;y=i;z=i;do{t=(f[m+(b<<2)>>2]|0)+(v<<1)|0;A=+n[l+(b<<2)>>2];w=w+A*+(j[t>>1]|0);x=x+A*+(j[t+2>>1]|0);y=y+A*+(j[t+4>>1]|0);z=z+A*+(j[t+6>>1]|0);b=b+1|0}while((b|0)<(a|0));n[e+(v<<2)>>2]=w;n[e+((v|1)<<2)>>2]=x;n[e+((v|2)<<2)>>2]=y;n[e+((v|3)<<2)>>2]=z;v=v+4|0}while((v|0)<=(o|0));u=r}while(0);b:do if((u|0)<(p|0)){if(g)B=u;else{b=u;while(1){n[e+(b<<2)>>2]=i;b=b+1|0;if((b|0)==(p|0))break b}}do{b=0;A=i;do{A=A+ +n[l+(b<<2)>>2]*+(j[(f[m+(b<<2)>>2]|0)+(B<<1)>>1]|0);b=b+1|0}while((b|0)<(a|0));n[e+(B<<2)>>2]=A;B=B+1|0}while((B|0)!=(p|0))}while(0);if((s|0)>1){s=s+-1|0;e=e+d|0;c=c+4|0}else break}return}function Cea(a){a=a|0;PYa(a);return}function Dea(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Eea(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58996;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function Fea(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58996;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function Gea(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0;k=+n[a+56>>2];l=f[a+20>>2]|0;m=f[a+32>>2]|0;o=f[a+44>>2]|0;p=(f[a+24>>2]|0)-l|0;a=p>>3;q=Y(i,h)|0;if((g|0)<=0)return;h=(p|0)>0;p=q+-4|0;r=(q|0)<4;s=q&-4;t=g;g=c;c=b;while(1){if(h){b=0;do{u=(f[c+(f[l+(b<<3)+4>>2]<<2)>>2]|0)+((Y(f[l+(b<<3)>>2]|0,i)|0)<<1)|0;f[o+(b<<2)>>2]=u;b=b+1|0}while((b|0)<(a|0))}a:do if(r)v=0;else{if(h)w=0;else{b=wNa(k)|0;u=(b>>>0<65536?b:(b|0)>0?65535:0)&65535;b=0;while(1){d[g+(b<<1)>>1]=u;d[g+((b|1)<<1)>>1]=u;d[g+((b|2)<<1)>>1]=u;d[g+((b|3)<<1)>>1]=u;b=b+4|0;if((b|0)>(p|0)){v=s;break a}}}do{b=0;x=k;y=k;z=k;A=k;do{u=(f[o+(b<<2)>>2]|0)+(w<<1)|0;B=+n[m+(b<<2)>>2];x=x+B*+(j[u>>1]|0);y=y+B*+(j[u+2>>1]|0);z=z+B*+(j[u+4>>1]|0);A=A+B*+(j[u+6>>1]|0);b=b+1|0}while((b|0)<(a|0));b=wNa(x)|0;d[g+(w<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=wNa(y)|0;d[g+((w|1)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=wNa(z)|0;d[g+((w|2)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=wNa(A)|0;d[g+((w|3)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;w=w+4|0}while((w|0)<=(p|0));v=s}while(0);b:do if((v|0)<(q|0)){if(h)C=v;else{b=wNa(k)|0;u=(b>>>0<65536?b:(b|0)>0?65535:0)&65535;b=v;while(1){d[g+(b<<1)>>1]=u;b=b+1|0;if((b|0)==(q|0))break b}}do{b=0;B=k;do{B=B+ +n[m+(b<<2)>>2]*+(j[(f[o+(b<<2)>>2]|0)+(C<<1)>>1]|0);b=b+1|0}while((b|0)<(a|0));b=wNa(B)|0;d[g+(C<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;C=C+1|0}while((C|0)!=(q|0))}while(0);if((t|0)>1){t=t+-1|0;g=g+e|0;c=c+4|0}else break}return}function Hea(a){a=a|0;PYa(a);return}function Iea(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Jea(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=59020;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function Kea(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=59020;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function Lea(a,b,c,d,e,g,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;j=+p[a+56>>3];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;n=(f[a+24>>2]|0)-k|0;a=n>>3;o=Y(i,g)|0;if((e|0)<=0)return;g=(n|0)>0;n=o+-4|0;q=(o|0)<4;r=o&-4;s=e;e=c;c=b;while(1){if(g){b=0;do{t=(f[c+(f[k+(b<<3)+4>>2]<<2)>>2]|0)+(Y(f[k+(b<<3)>>2]|0,i)|0)|0;f[m+(b<<2)>>2]=t;b=b+1|0}while((b|0)<(a|0))}a:do if(q)u=0;else{if(g)v=0;else{b=0;while(1){p[e+(b<<3)>>3]=j;p[e+((b|1)<<3)>>3]=j;p[e+((b|2)<<3)>>3]=j;p[e+((b|3)<<3)>>3]=j;b=b+4|0;if((b|0)>(n|0)){u=r;break a}}}do{b=0;w=j;x=j;y=j;z=j;do{t=(f[m+(b<<2)>>2]|0)+v|0;A=+p[l+(b<<3)>>3];w=w+A*+(h[t>>0]|0);x=x+A*+(h[t+1>>0]|0);y=y+A*+(h[t+2>>0]|0);z=z+A*+(h[t+3>>0]|0);b=b+1|0}while((b|0)<(a|0));p[e+(v<<3)>>3]=w;p[e+((v|1)<<3)>>3]=x;p[e+((v|2)<<3)>>3]=y;p[e+((v|3)<<3)>>3]=z;v=v+4|0}while((v|0)<=(n|0));u=r}while(0);b:do if((u|0)<(o|0)){if(g)B=u;else{b=u;while(1){p[e+(b<<3)>>3]=j;b=b+1|0;if((b|0)==(o|0))break b}}do{b=0;A=j;do{A=A+ +p[l+(b<<3)>>3]*+(h[(f[m+(b<<2)>>2]|0)+B>>0]|0);b=b+1|0}while((b|0)<(a|0));p[e+(B<<3)>>3]=A;B=B+1|0}while((B|0)!=(o|0))}while(0);if((s|0)>1){s=s+-1|0;e=e+d|0;c=c+4|0}else break}return}function Mea(a){a=a|0;PYa(a);return}function Nea(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Oea(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=59044;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function Pea(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=59044;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function Qea(a,b,c,d,e,g,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;j=+n[a+56>>2];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;o=(f[a+24>>2]|0)-k|0;a=o>>3;p=Y(i,g)|0;if((e|0)<=0)return;g=(o|0)>0;o=p+-4|0;q=(p|0)<4;r=p&-4;s=e;e=c;c=b;while(1){if(g){b=0;do{t=(f[c+(f[k+(b<<3)+4>>2]<<2)>>2]|0)+(Y(f[k+(b<<3)>>2]|0,i)|0)|0;f[m+(b<<2)>>2]=t;b=b+1|0}while((b|0)<(a|0))}a:do if(q)u=0;else{if(g)v=0;else{b=0;while(1){n[e+(b<<2)>>2]=j;n[e+((b|1)<<2)>>2]=j;n[e+((b|2)<<2)>>2]=j;n[e+((b|3)<<2)>>2]=j;b=b+4|0;if((b|0)>(o|0)){u=r;break a}}}do{b=0;w=j;x=j;y=j;z=j;do{t=(f[m+(b<<2)>>2]|0)+v|0;A=+n[l+(b<<2)>>2];w=w+A*+(h[t>>0]|0);x=x+A*+(h[t+1>>0]|0);y=y+A*+(h[t+2>>0]|0);z=z+A*+(h[t+3>>0]|0);b=b+1|0}while((b|0)<(a|0));n[e+(v<<2)>>2]=w;n[e+((v|1)<<2)>>2]=x;n[e+((v|2)<<2)>>2]=y;n[e+((v|3)<<2)>>2]=z;v=v+4|0}while((v|0)<=(o|0));u=r}while(0);b:do if((u|0)<(p|0)){if(g)B=u;else{b=u;while(1){n[e+(b<<2)>>2]=j;b=b+1|0;if((b|0)==(p|0))break b}}do{b=0;A=j;do{A=A+ +n[l+(b<<2)>>2]*+(h[(f[m+(b<<2)>>2]|0)+B>>0]|0);b=b+1|0}while((b|0)<(a|0));n[e+(B<<2)>>2]=A;B=B+1|0}while((B|0)!=(p|0))}while(0);if((s|0)>1){s=s+-1|0;e=e+d|0;c=c+4|0}else break}return}function Rea(a){a=a|0;PYa(a);return}function Sea(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Tea(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=59068;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function Uea(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=59068;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function Vea(a,b,c,e,g,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0;k=+n[a+56>>2];l=f[a+20>>2]|0;m=f[a+32>>2]|0;o=f[a+44>>2]|0;p=(f[a+24>>2]|0)-l|0;a=p>>3;q=Y(j,i)|0;if((g|0)<=0)return;i=(p|0)>0;p=q+-4|0;r=(q|0)<4;s=q&-4;t=g;g=c;c=b;while(1){if(i){b=0;do{u=(f[c+(f[l+(b<<3)+4>>2]<<2)>>2]|0)+(Y(f[l+(b<<3)>>2]|0,j)|0)|0;f[o+(b<<2)>>2]=u;b=b+1|0}while((b|0)<(a|0))}a:do if(r)v=0;else{if(i)w=0;else{b=wNa(k)|0;u=((b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768)&65535;b=0;while(1){d[g+(b<<1)>>1]=u;d[g+((b|1)<<1)>>1]=u;d[g+((b|2)<<1)>>1]=u;d[g+((b|3)<<1)>>1]=u;b=b+4|0;if((b|0)>(p|0)){v=s;break a}}}do{b=0;x=k;y=k;z=k;A=k;do{u=(f[o+(b<<2)>>2]|0)+w|0;B=+n[m+(b<<2)>>2];x=x+B*+(h[u>>0]|0);y=y+B*+(h[u+1>>0]|0);z=z+B*+(h[u+2>>0]|0);A=A+B*+(h[u+3>>0]|0);b=b+1|0}while((b|0)<(a|0));b=wNa(x)|0;d[g+(w<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=wNa(y)|0;d[g+((w|1)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=wNa(z)|0;d[g+((w|2)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=wNa(A)|0;d[g+((w|3)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;w=w+4|0}while((w|0)<=(p|0));v=s}while(0);b:do if((v|0)<(q|0)){if(i)C=v;else{b=wNa(k)|0;u=((b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768)&65535;b=v;while(1){d[g+(b<<1)>>1]=u;b=b+1|0;if((b|0)==(q|0))break b}}do{b=0;B=k;do{B=B+ +n[m+(b<<2)>>2]*+(h[(f[o+(b<<2)>>2]|0)+C>>0]|0);b=b+1|0}while((b|0)<(a|0));b=wNa(B)|0;d[g+(C<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;C=C+1|0}while((C|0)!=(q|0))}while(0);if((t|0)>1){t=t+-1|0;g=g+e|0;c=c+4|0}else break}return}function Wea(a){a=a|0;PYa(a);return}function Xea(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Yea(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=59092;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function Zea(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=59092;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function _ea(a,b,c,e,g,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0;k=+n[a+56>>2];l=f[a+20>>2]|0;m=f[a+32>>2]|0;o=f[a+44>>2]|0;p=(f[a+24>>2]|0)-l|0;a=p>>3;q=Y(j,i)|0;if((g|0)<=0)return;i=(p|0)>0;p=q+-4|0;r=(q|0)<4;s=q&-4;t=g;g=c;c=b;while(1){if(i){b=0;do{u=(f[c+(f[l+(b<<3)+4>>2]<<2)>>2]|0)+(Y(f[l+(b<<3)>>2]|0,j)|0)|0;f[o+(b<<2)>>2]=u;b=b+1|0}while((b|0)<(a|0))}a:do if(r)v=0;else{if(i)w=0;else{b=wNa(k)|0;u=(b>>>0<65536?b:(b|0)>0?65535:0)&65535;b=0;while(1){d[g+(b<<1)>>1]=u;d[g+((b|1)<<1)>>1]=u;d[g+((b|2)<<1)>>1]=u;d[g+((b|3)<<1)>>1]=u;b=b+4|0;if((b|0)>(p|0)){v=s;break a}}}do{b=0;x=k;y=k;z=k;A=k;do{u=(f[o+(b<<2)>>2]|0)+w|0;B=+n[m+(b<<2)>>2];x=x+B*+(h[u>>0]|0);y=y+B*+(h[u+1>>0]|0);z=z+B*+(h[u+2>>0]|0);A=A+B*+(h[u+3>>0]|0);b=b+1|0}while((b|0)<(a|0));b=wNa(x)|0;d[g+(w<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=wNa(y)|0;d[g+((w|1)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=wNa(z)|0;d[g+((w|2)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=wNa(A)|0;d[g+((w|3)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;w=w+4|0}while((w|0)<=(p|0));v=s}while(0);b:do if((v|0)<(q|0)){if(i)C=v;else{b=wNa(k)|0;u=(b>>>0<65536?b:(b|0)>0?65535:0)&65535;b=v;while(1){d[g+(b<<1)>>1]=u;b=b+1|0;if((b|0)==(q|0))break b}}do{b=0;B=k;do{B=B+ +n[m+(b<<2)>>2]*+(h[(f[o+(b<<2)>>2]|0)+C>>0]|0);b=b+1|0}while((b|0)<(a|0));b=wNa(B)|0;d[g+(C<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;C=C+1|0}while((C|0)!=(q|0))}while(0);if((t|0)>1){t=t+-1|0;g=g+e|0;c=c+4|0}else break}return}function $ea(a){a=a|0;PYa(a);return}function afa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function bfa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=59116;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function cfa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=59116;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;PYa(b)}b=f[a+20>>2]|0;if(!b){PYa(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function dfa(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0;k=+n[a+56>>2];l=f[a+20>>2]|0;m=f[a+32>>2]|0;o=f[a+44>>2]|0;p=(f[a+24>>2]|0)-l|0;a=p>>3;q=Y(j,i)|0;if((g|0)<=0)return;i=(p|0)>0;p=q+-4|0;r=(q|0)<4;s=q&-4;t=g;g=d;d=c;while(1){if(i){c=0;do{u=(f[d+(f[l+(c<<3)+4>>2]<<2)>>2]|0)+(Y(f[l+(c<<3)>>2]|0,j)|0)|0;f[o+(c<<2)>>2]=u;c=c+1|0}while((c|0)<(a|0))}a:do if(r)v=0;else{if(i)w=0;else{c=wNa(k)|0;u=(c>>>0<256?c:(c|0)>0?255:0)&255;c=0;while(1){b[g+c>>0]=u;b[g+(c|1)>>0]=u;b[g+(c|2)>>0]=u;b[g+(c|3)>>0]=u;c=c+4|0;if((c|0)>(p|0)){v=s;break a}}}do{c=0;x=k;y=k;z=k;A=k;do{u=(f[o+(c<<2)>>2]|0)+w|0;B=+n[m+(c<<2)>>2];x=x+B*+(h[u>>0]|0);y=y+B*+(h[u+1>>0]|0);z=z+B*+(h[u+2>>0]|0);A=A+B*+(h[u+3>>0]|0);c=c+1|0}while((c|0)<(a|0));c=wNa(x)|0;b[g+w>>0]=c>>>0<256?c:(c|0)>0?255:0;c=wNa(y)|0;b[g+(w|1)>>0]=c>>>0<256?c:(c|0)>0?255:0;c=wNa(z)|0;b[g+(w|2)>>0]=c>>>0<256?c:(c|0)>0?255:0;c=wNa(A)|0;b[g+(w|3)>>0]=c>>>0<256?c:(c|0)>0?255:0;w=w+4|0}while((w|0)<=(p|0));v=s}while(0);b:do if((v|0)<(q|0)){if(i)C=v;else{c=wNa(k)|0;u=(c>>>0<256?c:(c|0)>0?255:0)&255;c=v;while(1){b[g+c>>0]=u;c=c+1|0;if((c|0)==(q|0))break b}}do{c=0;B=k;do{B=B+ +n[m+(c<<2)>>2]*+(h[(f[o+(c<<2)>>2]|0)+C>>0]|0);c=c+1|0}while((c|0)<(a|0));c=wNa(B)|0;b[g+C>>0]=c>>>0<256?c:(c|0)>0?255:0;C=C+1|0}while((C|0)!=(q|0))}while(0);if((t|0)>1){t=t+-1|0;g=g+e|0;d=d+4|0}else break}return}function efa(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;l=u;u=u+160|0;m=l+96|0;n=l+40|0;o=l+32|0;p=l+8|0;q=l+24|0;r=l;do if((NS(e)|0)==65536){s=f[e+4>>2]|0;f[m>>2]=f[s>>2];t=m+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=m+8|0;f[w>>2]=f[s+8>>2];f[m+12>>2]=f[s+12>>2];f[m+16>>2]=f[s+16>>2];f[m+20>>2]=f[s+20>>2];f[m+24>>2]=f[s+24>>2];f[m+28>>2]=f[s+28>>2];f[m+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[m+36>>2]=x;f[m+40>>2]=w;w=m+48|0;y=m+44|0;f[y>>2]=w;f[w>>2]=0;f[m+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[t>>2]=0;BR(m,s);break}}else OR(m,e,-1);while(0);e=c&4095;s=d&4095;if((d^c)&4088|0){f[n>>2]=0;f[n+4>>2]=0;c=c$(n,50)|0;d=232367;t=c+50|0;do{b[c>>0]=b[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(t|0));j$(-215,n,234723,225433,4509);d$(n)}f[n>>2]=f[m>>2];d=n+4|0;c=m+4|0;t=f[c>>2]|0;f[d>>2]=t;v=n+8|0;f[v>>2]=f[m+8>>2];f[n+12>>2]=f[m+12>>2];w=n+16|0;y=m+16|0;f[w>>2]=f[y>>2];f[n+20>>2]=f[m+20>>2];f[n+24>>2]=f[m+24>>2];f[n+28>>2]=f[m+28>>2];f[n+32>>2]=f[m+32>>2];x=n+36|0;z=m+36|0;A=f[z>>2]|0;f[x>>2]=A;B=n+40|0;f[B>>2]=v;v=n+48|0;C=n+44|0;f[C>>2]=v;f[v>>2]=0;f[n+52>>2]=0;if(!A)D=t;else{t=A+12|0;f[t>>2]=(f[t>>2]|0)+1;D=f[c>>2]|0}if((D|0)<3){D=f[m+44>>2]|0;t=f[C>>2]|0;f[t>>2]=f[D>>2];f[t+4>>2]=f[D+4>>2]}else{f[d>>2]=0;BR(n,m)}f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=n;f[q>>2]=f[g>>2];f[q+4>>2]=f[g+4>>2];Hda(o,e,s,p,q,h,0);f[p>>2]=0;f[p+4>>2]=0;f[r>>2]=0;f[r+4>>2]=0;q=NYa(200)|0;y9(q,o,p,r,e,s,e,i,j,k);k=NYa(16)|0;f[k+4>>2]=1;f[k>>2]=58548;f[k+8>>2]=q;f[a>>2]=k;f[a+4>>2]=q;q=f[o>>2]|0;if(q|0?(o=q+4|0,a=f[o>>2]|0,f[o>>2]=a+-1,(a|0)==1):0)ki[f[(f[q>>2]|0)+8>>2]&2047](q);q=f[x>>2]|0;if(q|0?(a=q+12|0,q=f[a>>2]|0,f[a>>2]=q+-1,(q|0)==1):0)CR(n);f[x>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[d>>2]|0)>0){w=f[B>>2]|0;B=0;do{f[w+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[d>>2]|0))}d=f[C>>2]|0;if((d|0)!=(v|0))ZF(d);d=f[z>>2]|0;if(d|0?(v=d+12|0,d=f[v>>2]|0,f[v>>2]=d+-1,(d|0)==1):0)CR(m);f[z>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[c>>2]|0)>0){y=f[m+40>>2]|0;z=0;do{f[y+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[c>>2]|0))}c=f[m+44>>2]|0;if((c|0)==(m+48|0)){u=l;return}ZF(c);u=l;return}function ffa(a,b,c,d,e,g,h,i,j,k,l,m,n,o,q,r,s,t,v,w,x,y){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;q=q|0;r=r|0;s=s|0;t=t|0;v=v|0;w=+w;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;y=u;u=u+496|0;z=y+432|0;A=y+56|0;B=y+376|0;C=y+320|0;D=y+264|0;E=y;F=y+208|0;G=y+200|0;H=y+144|0;I=y+136|0;J=y+128|0;K=y+120|0;L=y+104|0;M=y+88|0;N=y+80|0;O=y+72|0;P=y+64|0;p[A>>3]=w;if((Y(s,r)|0)<=49){f[A>>2]=r;f[A+4>>2]=s;CN(z,A,c,o,q);f[C+8>>2]=0;f[C+12>>2]=0;f[C>>2]=16842752;f[C+4>>2]=z;f[D>>2]=t;f[D+4>>2]=v;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;f[E+16>>2]=0;f[E+20>>2]=0;f[E+24>>2]=0;f[E+28>>2]=0;efa(B,a,b,C,D,w,x&-17,-1,E);f[F>>2]=i;f[F+4>>2]=j;CN(C,F,a,d,e);f[G>>2]=i;f[G+4>>2]=j;CN(E,G,b,g,h);Q=f[B+4>>2]|0;R=f[(f[Q>>2]|0)+20>>2]|0;f[H>>2]=k;f[H+4>>2]=l;f[I>>2]=m;f[I+4>>2]=n;Bh[R&255](Q,C,E,H,I);Q=E+36|0;R=f[Q>>2]|0;if(R|0?(n=R+12|0,R=f[n>>2]|0,f[n>>2]=R+-1,(R|0)==1):0)CR(E);f[Q>>2]=0;Q=E+16|0;R=E+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[R>>2]|0)>0){Q=f[E+40>>2]|0;n=0;do{f[Q+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[R>>2]|0))}R=f[E+44>>2]|0;if((R|0)!=(E+48|0))ZF(R);R=C+36|0;n=f[R>>2]|0;if(n|0?(Q=n+12|0,n=f[Q>>2]|0,f[Q>>2]=n+-1,(n|0)==1):0)CR(C);f[R>>2]=0;R=C+16|0;n=C+4|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[n>>2]|0)>0){R=f[C+40>>2]|0;Q=0;do{f[R+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[n>>2]|0))}n=f[C+44>>2]|0;if((n|0)!=(C+48|0))ZF(n);n=f[B>>2]|0;if(n|0?(Q=n+4|0,R=f[Q>>2]|0,f[Q>>2]=R+-1,(R|0)==1):0)ki[f[(f[n>>2]|0)+8>>2]&2047](n);n=z+36|0;R=f[n>>2]|0;if(R|0?(Q=R+12|0,R=f[Q>>2]|0,f[Q>>2]=R+-1,(R|0)==1):0)CR(z);f[n>>2]=0;n=z+16|0;R=z+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[R>>2]|0)>0){n=f[z+40>>2]|0;Q=0;do{f[n+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[R>>2]|0))}R=f[z+44>>2]|0;if((R|0)!=(z+48|0))ZF(R);u=y;return}f[C>>2]=r;f[C+4>>2]=s;CN(B,C,c,o,q);f[E>>2]=i;f[E+4>>2]=j;CN(D,E,a,d,e);f[G>>2]=i;f[G+4>>2]=j;CN(F,G,b,g,h);f[H>>2]=1124007936;G=H+4|0;e=H+8|0;E=H+40|0;q=G;o=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(o|0));f[E>>2]=e;q=H+48|0;o=H+44|0;f[o>>2]=q;f[q>>2]=0;f[H+52>>2]=0;c=a>>>3&511;a=b&4088;C=b&7;if((c|0)!=0&+p[A>>3]!=0.0){if((C+-5|0)>>>0>1|(d|0)==(g|0)){s=(C|0)==6?6:5;f[z>>2]=j;f[z+4>>2]=i;AR(H,2,z,s|a);S=s}else{f[I>>2]=i;f[I+4>>2]=j;CN(z,I,b,g,h);I=z+36|0;s=f[I>>2]|0;if(s|0){a=s+12|0;f[a>>2]=(f[a>>2]|0)+1}a=H+36|0;s=f[a>>2]|0;if(s|0?(r=s+12|0,s=f[r>>2]|0,f[r>>2]=s+-1,(s|0)==1):0)CR(H);f[a>>2]=0;s=H+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[G>>2]|0)>0){r=f[E>>2]|0;R=0;do{f[r+(R<<2)>>2]=0;R=R+1|0;T=f[G>>2]|0}while((R|0)<(T|0));f[H>>2]=f[z>>2];if((T|0)<3)U=14;else U=16}else{f[H>>2]=f[z>>2];U=14}if((U|0)==14){T=f[z+4>>2]|0;if((T|0)<3){f[G>>2]=T;f[e>>2]=f[z+8>>2];f[H+12>>2]=f[z+12>>2];T=f[z+44>>2]|0;R=f[o>>2]|0;f[R>>2]=f[T>>2];f[R+4>>2]=f[T+4>>2]}else U=16}if((U|0)==16)BR(H,z);T=z+16|0;f[s>>2]=f[T>>2];f[H+20>>2]=f[z+20>>2];f[H+24>>2]=f[z+24>>2];f[H+28>>2]=f[z+28>>2];f[H+32>>2]=f[z+32>>2];s=f[I>>2]|0;f[a>>2]=s;if(s|0?(a=s+12|0,s=f[a>>2]|0,f[a>>2]=s+-1,(s|0)==1):0)CR(z);f[I>>2]=0;I=z+4|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[I>>2]|0)>0){T=f[z+40>>2]|0;s=0;do{f[T+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[I>>2]|0))}I=f[z+44>>2]|0;if((I|0)!=(z+48|0))ZF(I);S=C}I=f[D+40>>2]|0;s=f[I>>2]|0;f[J>>2]=f[I+4>>2];f[J+4>>2]=s;f[K>>2]=t;f[K+4>>2]=v;eqa(D,B,H,J,S|c<<3,K,0.0,x);f[z+8>>2]=0;f[z+12>>2]=0;f[z>>2]=16842752;f[z+4>>2]=H;f[L>>2]=-1056833530;f[L+4>>2]=A;f[L+8>>2]=1;f[L+12>>2]=1;K=M+8|0;f[K>>2]=0;f[K+4>>2]=0;f[M>>2]=33619968;f[M+4>>2]=H;TG(z,L,M,fT()|0,-1);if((f[H+16>>2]|0)!=(g|0)){M=z+8|0;f[M>>2]=0;f[M+4>>2]=0;f[z>>2]=33619968;f[z+4>>2]=F;WJ(H,z,f[F>>2]&4095,1.0,0.0)}}else{if((d|0)!=(g|0)){f[N>>2]=i;f[N+4>>2]=j;CN(z,N,b,g,h);h=z+36|0;N=f[h>>2]|0;if(N|0){d=N+12|0;f[d>>2]=(f[d>>2]|0)+1}d=H+36|0;N=f[d>>2]|0;if(N|0?(M=N+12|0,N=f[M>>2]|0,f[M>>2]=N+-1,(N|0)==1):0)CR(H);f[d>>2]=0;N=H+16|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[G>>2]|0)>0){M=f[E>>2]|0;L=0;do{f[M+(L<<2)>>2]=0;L=L+1|0;V=f[G>>2]|0}while((L|0)<(V|0));f[H>>2]=f[z>>2];if((V|0)<3)U=40;else U=42}else{f[H>>2]=f[z>>2];U=40}if((U|0)==40){V=f[z+4>>2]|0;if((V|0)<3){f[G>>2]=V;f[e>>2]=f[z+8>>2];f[H+12>>2]=f[z+12>>2];e=f[z+44>>2]|0;V=f[o>>2]|0;f[V>>2]=f[e>>2];f[V+4>>2]=f[e+4>>2]}else U=42}if((U|0)==42)BR(H,z);U=z+16|0;f[N>>2]=f[U>>2];f[H+20>>2]=f[z+20>>2];f[H+24>>2]=f[z+24>>2];f[H+28>>2]=f[z+28>>2];f[H+32>>2]=f[z+32>>2];N=f[h>>2]|0;f[d>>2]=N;if(N|0?(d=N+12|0,N=f[d>>2]|0,f[d>>2]=N+-1,(N|0)==1):0)CR(z);f[h>>2]=0;h=z+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[h>>2]|0)>0){U=f[z+40>>2]|0;N=0;do{f[U+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[h>>2]|0))}h=f[z+44>>2]|0;if((h|0)!=(z+48|0))ZF(h)}else{f[z>>2]=j;f[z+4>>2]=i;AR(H,2,z,b&4095)}b=f[D+40>>2]|0;i=f[b>>2]|0;f[O>>2]=f[b+4>>2];f[O+4>>2]=i;f[P>>2]=t;f[P+4>>2]=v;eqa(D,B,H,O,c<<3|C,P,+p[A>>3],x);if((f[H+16>>2]|0)!=(g|0)){g=z+8|0;f[g>>2]=0;f[g+4>>2]=0;f[z>>2]=33619968;f[z+4>>2]=F;eL(H,z)}}z=H+36|0;g=f[z>>2]|0;if(g|0?(x=g+12|0,g=f[x>>2]|0,f[x>>2]=g+-1,(g|0)==1):0)CR(H);f[z>>2]=0;z=H+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[G>>2]|0)>0){z=f[E>>2]|0;E=0;do{f[z+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[G>>2]|0))}G=f[o>>2]|0;if((G|0)!=(q|0))ZF(G);G=F+36|0;q=f[G>>2]|0;if(q|0?(o=q+12|0,q=f[o>>2]|0,f[o>>2]=q+-1,(q|0)==1):0)CR(F);f[G>>2]=0;G=F+16|0;q=F+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[q>>2]|0)>0){G=f[F+40>>2]|0;o=0;do{f[G+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[q>>2]|0))}q=f[F+44>>2]|0;if((q|0)!=(F+48|0))ZF(q);q=D+36|0;F=f[q>>2]|0;if(F|0?(o=F+12|0,F=f[o>>2]|0,f[o>>2]=F+-1,(F|0)==1):0)CR(D);f[q>>2]=0;q=D+16|0;F=D+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[F>>2]|0)>0){q=f[D+40>>2]|0;o=0;do{f[q+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[F>>2]|0))}F=f[D+44>>2]|0;if((F|0)!=(D+48|0))ZF(F);F=B+36|0;D=f[F>>2]|0;if(D|0?(o=D+12|0,D=f[o>>2]|0,f[o>>2]=D+-1,(D|0)==1):0)CR(B);f[F>>2]=0;F=B+16|0;D=B+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[D>>2]|0)>0){F=f[B+40>>2]|0;o=0;do{f[F+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[D>>2]|0))}D=f[B+44>>2]|0;if((D|0)!=(B+48|0))ZF(D);u=y;return}function gfa(a,b,c,d,e,g,h,i,j,k,l,m,n,o,p,q,r,s,t,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;v=+v;w=w|0;var x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;x=u;u=u+320|0;y=x+256|0;z=x+248|0;A=x+192|0;B=x+184|0;C=x+176|0;D=x+120|0;E=x+64|0;F=x+56|0;G=x;H=x+48|0;I=x+40|0;J=x+32|0;f[z>>2]=p;f[z+4>>2]=1;CN(y,z,c,o,0);f[B>>2]=r;f[B+4>>2]=1;CN(A,B,c,q,0);f[D+8>>2]=0;f[D+12>>2]=0;f[D>>2]=16842752;f[D+4>>2]=y;f[E+8>>2]=0;f[E+12>>2]=0;f[E>>2]=16842752;f[E+4>>2]=A;f[F>>2]=s;f[F+4>>2]=t;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;f[G+16>>2]=0;f[G+20>>2]=0;f[G+24>>2]=0;f[G+28>>2]=0;Cda(C,a,b,D,E,F,v,w&-17,-1,G);f[H>>2]=i;f[H+4>>2]=j;CN(D,H,a,d,e);f[I>>2]=i;f[I+4>>2]=j;CN(E,I,b,g,h);h=f[C+4>>2]|0;g=f[(f[h>>2]|0)+20>>2]|0;f[G>>2]=k;f[G+4>>2]=l;f[J>>2]=m;f[J+4>>2]=n;Bh[g&255](h,D,E,G,J);J=E+36|0;G=f[J>>2]|0;if(G|0?(h=G+12|0,G=f[h>>2]|0,f[h>>2]=G+-1,(G|0)==1):0)CR(E);f[J>>2]=0;J=E+16|0;G=E+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[G>>2]|0)>0){J=f[E+40>>2]|0;h=0;do{f[J+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[G>>2]|0))}G=f[E+44>>2]|0;if((G|0)!=(E+48|0))ZF(G);G=D+36|0;E=f[G>>2]|0;if(E|0?(h=E+12|0,E=f[h>>2]|0,f[h>>2]=E+-1,(E|0)==1):0)CR(D);f[G>>2]=0;G=D+16|0;E=D+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[E>>2]|0)>0){G=f[D+40>>2]|0;h=0;do{f[G+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[E>>2]|0))}E=f[D+44>>2]|0;if((E|0)!=(D+48|0))ZF(E);E=f[C>>2]|0;if(E|0?(C=E+4|0,D=f[C>>2]|0,f[C>>2]=D+-1,(D|0)==1):0)ki[f[(f[E>>2]|0)+8>>2]&2047](E);E=A+36|0;D=f[E>>2]|0;if(D|0?(C=D+12|0,D=f[C>>2]|0,f[C>>2]=D+-1,(D|0)==1):0)CR(A);f[E>>2]=0;E=A+16|0;D=A+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[D>>2]|0)>0){E=f[A+40>>2]|0;C=0;do{f[E+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[D>>2]|0))}D=f[A+44>>2]|0;if((D|0)!=(A+48|0))ZF(D);D=y+36|0;A=f[D>>2]|0;if(A|0?(C=A+12|0,A=f[C>>2]|0,f[C>>2]=A+-1,(A|0)==1):0)CR(y);f[D>>2]=0;D=y+16|0;A=y+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[A>>2]|0)>0){D=f[y+40>>2]|0;C=0;do{f[D+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[A>>2]|0))}A=f[y+44>>2]|0;if((A|0)==(y+48|0)){u=x;return}ZF(A);u=x;return}function hfa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=u;u=u+208|0;k=j+192|0;l=j+184|0;m=j+128|0;n=j+72|0;o=j+8|0;p=j+16|0;q=j;_$(l,59132);do if((NS(a)|0)==65536){r=f[a+4>>2]|0;f[m>>2]=f[r>>2];s=m+4|0;t=r+4|0;f[s>>2]=f[t>>2];v=m+8|0;f[v>>2]=f[r+8>>2];f[m+12>>2]=f[r+12>>2];f[m+16>>2]=f[r+16>>2];f[m+20>>2]=f[r+20>>2];f[m+24>>2]=f[r+24>>2];f[m+28>>2]=f[r+28>>2];f[m+32>>2]=f[r+32>>2];w=f[r+36>>2]|0;f[m+36>>2]=w;f[m+40>>2]=v;v=m+48|0;x=m+44|0;f[x>>2]=v;f[v>>2]=0;f[m+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[r+44>>2]|0;v=f[x>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];break}else{f[s>>2]=0;BR(m,r);break}}else OR(m,a,-1);while(0);do if((NS(e)|0)==65536){a=f[e+4>>2]|0;f[n>>2]=f[a>>2];r=n+4|0;s=a+4|0;f[r>>2]=f[s>>2];t=n+8|0;f[t>>2]=f[a+8>>2];f[n+12>>2]=f[a+12>>2];f[n+16>>2]=f[a+16>>2];f[n+20>>2]=f[a+20>>2];f[n+24>>2]=f[a+24>>2];f[n+28>>2]=f[a+28>>2];f[n+32>>2]=f[a+32>>2];v=f[a+36>>2]|0;f[n+36>>2]=v;f[n+40>>2]=t;t=n+48|0;x=n+44|0;f[x>>2]=t;f[t>>2]=0;f[n+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[a+44>>2]|0;t=f[x>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[r>>2]=0;BR(n,a);break}}else OR(n,e,-1);while(0);e=f[m>>2]|0;a=m+40|0;r=f[a>>2]|0;s=f[r>>2]|0;f[o>>2]=f[r+4>>2];f[o+4>>2]=s;KS(c,o,e&4088|((d|0)<0?e:d)&7,-1,0,0);do if((NS(c)|0)==65536){d=f[c+4>>2]|0;f[p>>2]=f[d>>2];e=p+4|0;o=d+4|0;f[e>>2]=f[o>>2];s=p+8|0;f[s>>2]=f[d+8>>2];f[p+12>>2]=f[d+12>>2];f[p+16>>2]=f[d+16>>2];f[p+20>>2]=f[d+20>>2];f[p+24>>2]=f[d+24>>2];f[p+28>>2]=f[d+28>>2];f[p+32>>2]=f[d+32>>2];r=f[d+36>>2]|0;f[p+36>>2]=r;f[p+40>>2]=s;s=p+48|0;t=p+44|0;f[t>>2]=s;f[s>>2]=0;f[p+52>>2]=0;if(r|0){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[o>>2]|0)<3){o=f[d+44>>2]|0;s=f[t>>2]|0;f[s>>2]=f[o>>2];f[s+4>>2]=f[o+4>>2];break}else{f[e>>2]=0;BR(p,d);break}}else OR(p,c,-1);while(0);c=f[g>>2]|0;d=f[g+4>>2]|0;g=n+40|0;e=f[g>>2]|0;o=f[e+4>>2]|0;s=f[e>>2]|0;e=(c|0)==-1?(o|0)/2|0:c;c=(d|0)==-1?(s|0)/2|0:d;if(!((e|0)>-1&(e|0)<(o|0)?!((c|0)<0|(c|0)>=(s|0)):0)){f[k>>2]=0;f[k+4>>2]=0;s=c$(k,52)|0;o=320583;d=s+52|0;do{b[s>>0]=b[o>>0]|0;s=s+1|0;o=o+1|0}while((s|0)<(d|0));j$(-215,k,320636,320652,363);d$(k)}f[k>>2]=0;o=k+4|0;f[o>>2]=0;s=f[m+12>>2]|0;d=f[m+8>>2]|0;f[q>>2]=s;t=q+4|0;f[t>>2]=d;if(!(i&16)){KR(m,q,k);y=f[q>>2]|0;z=f[t>>2]|0;A=f[k>>2]|0;B=f[o>>2]|0}else{y=s;z=d;A=0;B=0}d=f[m>>2]|0;s=m+16|0;o=m+48|0;k=p+16|0;t=p+48|0;q=n+16|0;r=n+48|0;ffa(d&4095,f[p>>2]&4095,f[n>>2]&4095,f[s>>2]|0,f[o>>2]|0,f[k>>2]|0,f[t>>2]|0,f[p+12>>2]|0,f[p+8>>2]|0,y,z,A,B,f[q>>2]|0,f[r>>2]|0,f[n+12>>2]|0,f[n+8>>2]|0,e,c,h,i,(d&32768|0)!=0);d=p+36|0;i=f[d>>2]|0;if(i|0?(c=i+12|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)CR(p);f[d>>2]=0;d=p+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[d>>2]|0)>0){k=f[p+40>>2]|0;i=0;do{f[k+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[d>>2]|0))}d=f[p+44>>2]|0;if((d|0)!=(t|0))ZF(d);d=n+36|0;t=f[d>>2]|0;if(t|0?(p=t+12|0,t=f[p>>2]|0,f[p>>2]=t+-1,(t|0)==1):0)CR(n);f[d>>2]=0;d=n+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[d>>2]|0)>0){q=f[g>>2]|0;g=0;do{f[q+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[d>>2]|0))}d=f[n+44>>2]|0;if((d|0)!=(r|0))ZF(d);d=m+36|0;r=f[d>>2]|0;if(r|0?(n=r+12|0,r=f[n>>2]|0,f[n>>2]=r+-1,(r|0)==1):0)CR(m);f[d>>2]=0;d=m+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[d>>2]|0)>0){s=f[a>>2]|0;a=0;do{f[s+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[d>>2]|0))}d=f[m+44>>2]|0;if((d|0)!=(o|0))ZF(d);if(!(f[l+4>>2]|0)){u=j;return}u=j;return}function ifa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=u;u=u+384|0;l=k+368|0;m=k+360|0;n=k+304|0;o=k+248|0;p=k+184|0;q=k+240|0;r=k+128|0;s=k+120|0;t=k+112|0;v=k+56|0;w=k;_$(m,59152);do if((NS(a)|0)==65536){x=f[a+4>>2]|0;f[n>>2]=f[x>>2];y=n+4|0;z=x+4|0;f[y>>2]=f[z>>2];A=n+8|0;f[A>>2]=f[x+8>>2];f[n+12>>2]=f[x+12>>2];f[n+16>>2]=f[x+16>>2];f[n+20>>2]=f[x+20>>2];f[n+24>>2]=f[x+24>>2];f[n+28>>2]=f[x+28>>2];f[n+32>>2]=f[x+32>>2];B=f[x+36>>2]|0;f[n+36>>2]=B;f[n+40>>2]=A;A=n+48|0;C=n+44|0;f[C>>2]=A;f[A>>2]=0;f[n+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[x+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;BR(n,x);break}}else OR(n,a,-1);while(0);do if((NS(e)|0)==65536){a=f[e+4>>2]|0;f[o>>2]=f[a>>2];x=o+4|0;y=a+4|0;f[x>>2]=f[y>>2];z=o+8|0;f[z>>2]=f[a+8>>2];f[o+12>>2]=f[a+12>>2];f[o+16>>2]=f[a+16>>2];f[o+20>>2]=f[a+20>>2];f[o+24>>2]=f[a+24>>2];f[o+28>>2]=f[a+28>>2];f[o+32>>2]=f[a+32>>2];A=f[a+36>>2]|0;f[o+36>>2]=A;f[o+40>>2]=z;z=o+48|0;C=o+44|0;f[C>>2]=z;f[z>>2]=0;f[o+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[a+44>>2]|0;z=f[C>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;BR(o,a);break}}else OR(o,e,-1);while(0);do if((NS(g)|0)==65536){e=f[g+4>>2]|0;f[p>>2]=f[e>>2];a=p+4|0;x=e+4|0;f[a>>2]=f[x>>2];y=p+8|0;f[y>>2]=f[e+8>>2];f[p+12>>2]=f[e+12>>2];f[p+16>>2]=f[e+16>>2];f[p+20>>2]=f[e+20>>2];f[p+24>>2]=f[e+24>>2];f[p+28>>2]=f[e+28>>2];f[p+32>>2]=f[e+32>>2];z=f[e+36>>2]|0;f[p+36>>2]=z;f[p+40>>2]=y;y=p+48|0;C=p+44|0;f[C>>2]=y;f[y>>2]=0;f[p+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[e+44>>2]|0;y=f[C>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[a>>2]=0;BR(p,e);break}}else OR(p,g,-1);while(0);g=f[n>>2]|0;e=n+40|0;a=f[e>>2]|0;x=f[a>>2]|0;f[q>>2]=f[a+4>>2];f[q+4>>2]=x;KS(c,q,g&4088|((d|0)<0?g:d)&7,-1,0,0);do if((NS(c)|0)==65536){d=f[c+4>>2]|0;f[r>>2]=f[d>>2];g=r+4|0;q=d+4|0;f[g>>2]=f[q>>2];x=r+8|0;f[x>>2]=f[d+8>>2];f[r+12>>2]=f[d+12>>2];f[r+16>>2]=f[d+16>>2];f[r+20>>2]=f[d+20>>2];f[r+24>>2]=f[d+24>>2];f[r+28>>2]=f[d+28>>2];f[r+32>>2]=f[d+32>>2];a=f[d+36>>2]|0;f[r+36>>2]=a;f[r+40>>2]=x;x=r+48|0;y=r+44|0;f[y>>2]=x;f[x>>2]=0;f[r+52>>2]=0;if(a|0){x=a+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[q>>2]|0)<3){q=f[d+44>>2]|0;x=f[y>>2]|0;f[x>>2]=f[q>>2];f[x+4>>2]=f[q+4>>2];break}else{f[g>>2]=0;BR(r,d);break}}else OR(r,c,-1);while(0);f[s>>2]=0;c=s+4|0;f[c>>2]=0;d=f[n+8>>2]|0;f[t>>2]=f[n+12>>2];g=t+4|0;f[g>>2]=d;if(!(j&16))KR(n,t,s);d=f[o>>2]|0;do if(!((f[p>>2]^d)&4095)){if((f[o+12>>2]|0)!=1?(f[o+8>>2]|0)!=1:0){D=36;break}if((f[p+12>>2]|0)!=1?(f[p+8>>2]|0)!=1:0)D=36;else E=d}else D=36;while(0);if((D|0)==36){f[l>>2]=0;f[l+4>>2]=0;F=c$(l,120)|0;D=234822;G=F+120|0;do{b[F>>0]=b[D>>0]|0;F=F+1|0;D=D+1|0}while((F|0)<(G|0));j$(-215,l,234943,225433,4948);d$(l);E=f[o>>2]|0}do if(E&16384){f[v>>2]=E;D=v+4|0;d=o+4|0;q=f[d>>2]|0;f[D>>2]=q;x=v+8|0;f[x>>2]=f[o+8>>2];f[v+12>>2]=f[o+12>>2];f[v+16>>2]=f[o+16>>2];f[v+20>>2]=f[o+20>>2];f[v+24>>2]=f[o+24>>2];f[v+28>>2]=f[o+28>>2];f[v+32>>2]=f[o+32>>2];y=f[o+36>>2]|0;f[v+36>>2]=y;f[v+40>>2]=x;x=v+48|0;a=v+44|0;f[a>>2]=x;f[x>>2]=0;f[v+52>>2]=0;if(!y)H=q;else{q=y+12|0;f[q>>2]=(f[q>>2]|0)+1;H=f[d>>2]|0}if((H|0)<3){d=f[o+44>>2]|0;q=f[a>>2]|0;f[q>>2]=f[d>>2];f[q+4>>2]=f[d+4>>2];break}else{f[D>>2]=0;BR(v,o);break}}else{f[v>>2]=1124007936;D=v+8|0;d=v+40|0;F=v+4|0;G=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(G|0));f[d>>2]=D;q=v+48|0;f[v+44>>2]=q;f[q>>2]=0;f[v+52>>2]=0;q=l+8|0;f[q>>2]=0;f[q+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=v;eL(o,l)}while(0);H=f[p>>2]|0;do if(H&16384){f[w>>2]=H;E=w+4|0;q=p+4|0;a=f[q>>2]|0;f[E>>2]=a;y=w+8|0;x=p+8|0;f[y>>2]=f[x>>2];C=p+12|0;f[w+12>>2]=f[C>>2];z=w+16|0;f[z>>2]=f[p+16>>2];f[w+20>>2]=f[p+20>>2];f[w+24>>2]=f[p+24>>2];f[w+28>>2]=f[p+28>>2];f[w+32>>2]=f[p+32>>2];A=f[p+36>>2]|0;f[w+36>>2]=A;f[w+40>>2]=y;y=w+48|0;B=w+44|0;f[B>>2]=y;f[y>>2]=0;f[w+52>>2]=0;if(!A)I=a;else{a=A+12|0;f[a>>2]=(f[a>>2]|0)+1;I=f[q>>2]|0}if((I|0)<3){q=f[p+44>>2]|0;a=f[B>>2]|0;f[a>>2]=f[q>>2];f[a+4>>2]=f[q+4>>2];J=C;K=z;L=x;break}else{f[E>>2]=0;BR(w,p);J=C;K=z;L=x;break}}else{f[w>>2]=1124007936;x=w+8|0;z=w+40|0;F=w+4|0;G=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(G|0));f[z>>2]=x;D=w+48|0;f[w+44>>2]=D;f[D>>2]=0;f[w+52>>2]=0;D=l+8|0;f[D>>2]=0;f[D+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=w;eL(p,l);J=p+12|0;K=w+16|0;L=p+8|0}while(0);l=n+16|0;F=n+48|0;G=r+16|0;I=r+48|0;H=v+16|0;gfa(f[n>>2]&4095,f[r>>2]&4095,f[o>>2]&4095,f[l>>2]|0,f[F>>2]|0,f[G>>2]|0,f[I>>2]|0,f[r+12>>2]|0,f[r+8>>2]|0,f[t>>2]|0,f[g>>2]|0,f[s>>2]|0,f[c>>2]|0,f[H>>2]|0,(f[o+12>>2]|0)+-1+(f[o+8>>2]|0)|0,f[K>>2]|0,(f[J>>2]|0)+-1+(f[L>>2]|0)|0,f[h>>2]|0,f[h+4>>2]|0,i,j&-17);j=w+36|0;h=f[j>>2]|0;if(h|0?(L=h+12|0,h=f[L>>2]|0,f[L>>2]=h+-1,(h|0)==1):0)CR(w);f[j>>2]=0;j=w+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[j>>2]|0)>0){K=f[w+40>>2]|0;h=0;do{f[K+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[j>>2]|0))}j=f[w+44>>2]|0;if((j|0)!=(w+48|0))ZF(j);j=v+36|0;w=f[j>>2]|0;if(w|0?(h=w+12|0,w=f[h>>2]|0,f[h>>2]=w+-1,(w|0)==1):0)CR(v);f[j>>2]=0;j=v+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[j>>2]|0)>0){H=f[v+40>>2]|0;w=0;do{f[H+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[j>>2]|0))}j=f[v+44>>2]|0;if((j|0)!=(v+48|0))ZF(j);j=r+36|0;v=f[j>>2]|0;if(v|0?(w=v+12|0,v=f[w>>2]|0,f[w>>2]=v+-1,(v|0)==1):0)CR(r);f[j>>2]=0;j=r+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[j>>2]|0)>0){G=f[r+40>>2]|0;v=0;do{f[G+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[j>>2]|0))}j=f[r+44>>2]|0;if((j|0)!=(I|0))ZF(j);j=p+36|0;I=f[j>>2]|0;if(I|0?(r=I+12|0,I=f[r>>2]|0,f[r>>2]=I+-1,(I|0)==1):0)CR(p);f[j>>2]=0;j=p+16|0;I=p+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[I>>2]|0)>0){j=f[p+40>>2]|0;r=0;do{f[j+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[I>>2]|0))}I=f[p+44>>2]|0;if((I|0)!=(p+48|0))ZF(I);I=o+36|0;p=f[I>>2]|0;do if(p|0){r=p+12|0;j=f[r>>2]|0;f[r>>2]=j+-1;if((j|0)!=1)break;CR(o)}while(0);f[I>>2]=0;I=o+16|0;p=o+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[p>>2]|0)>0){I=f[o+40>>2]|0;j=0;do{f[I+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[p>>2]|0))}p=f[o+44>>2]|0;if((p|0)!=(o+48|0))ZF(p);p=n+36|0;o=f[p>>2]|0;do if(o|0){j=o+12|0;I=f[j>>2]|0;f[j>>2]=I+-1;if((I|0)!=1)break;CR(n)}while(0);f[p>>2]=0;p=n+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[p>>2]|0)>0){l=f[e>>2]|0;e=0;do{f[l+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[p>>2]|0))}p=f[n+44>>2]|0;if((p|0)!=(F|0))ZF(p);if(!(f[m+4>>2]|0)){u=k;return}u=k;return}function jfa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0.0,N=0.0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0;e=u;u=u+80|0;g=e+64|0;h=e+8|0;i=e;_$(g,59172);do if((NS(a)|0)==65536){j=f[a+4>>2]|0;f[h>>2]=f[j>>2];k=h+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=h+8|0;f[m>>2]=f[j+8>>2];f[h+12>>2]=f[j+12>>2];f[h+16>>2]=f[j+16>>2];f[h+20>>2]=f[j+20>>2];f[h+24>>2]=f[j+24>>2];f[h+28>>2]=f[j+28>>2];f[h+32>>2]=f[j+32>>2];o=f[j+36>>2]|0;f[h+36>>2]=o;f[h+40>>2]=m;m=h+48|0;p=h+44|0;f[p>>2]=m;f[m>>2]=0;f[h+52>>2]=0;if(o|0){m=o+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[p>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;BR(h,j);break}}else OR(h,a,-1);while(0);a=LS(h,2,-1,1)|0;j=f[h>>2]&7;if(!((a|0)>-1&(j|1|0)==5)){f[i>>2]=0;f[i+4>>2]=0;k=c$(i,40)|0;l=235103;m=k+40|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,i,235144,235050,103);d$(i)}i=(j|0)==5;q=+n[c>>2];j=wNa(q)|0;r=+n[c+4>>2];c=wNa(r)|0;a:do if(!a)t=d?-1797693134862315708145274.0e284:-1.0;else{l=f[h+16>>2]|0;k=a+-1|0;m=f[l+(k<<3)>>2]|0;if(+(j|0)==q&((i|d)^1)&+(c|0)==r){b:do if((a|0)>0){p=0;o=0;v=m;w=f[l+(k<<3)+4>>2]|0;while(1){x=v;v=f[l+(o<<3)>>2]|0;y=w;w=f[l+(o<<3)+4>>2]|0;z=(w|0)>(c|0);if((c|0)<(y|0))if(z)A=19;else A=18;else if(z)A=18;else A=19;if((A|0)==18){A=0;if((j|0)>(x|0)&(v|0)<(j|0))A=19;else{z=(Y(v-x|0,c-y|0)|0)-(Y(w-y|0,j-x|0)|0)|0;B=(z|0)==0;C=B&1;D=((((w|0)<(y|0)?0-z|0:z)|0)>0&(B^1)&1)+p|0}}do if((A|0)==19){A=0;if((c|0)==(w|0)){if((j|0)==(v|0)){C=1;D=p;break}if((c|0)==(y|0)){if(!((j|0)<(x|0)|(j|0)>(v|0))){C=1;D=p;break}if(!((j|0)>(x|0)|(v|0)>(j|0))){C=1;D=p;break}}}C=4;D=p}while(0);switch(C&7){case 4:case 0:break;default:{t=0.0;break a}}o=o+1|0;if((o|0)>=(a|0)){E=D;break b}else p=D}}else E=0;while(0);t=+((E<<1&2)+-1|0);break}p=f[l+(k<<3)+4>>2]|0;if(i){F=(f[s>>2]=p,+n[s>>2]);G=m;H=p}else{I=+(p|0);p=(n[s>>2]=+(m|0),f[s>>2]|0);F=I;G=p;H=(n[s>>2]=I,f[s>>2]|0)}p=(a|0)>0;if(!d){if(p)if(i){I=F;o=0;v=0;w=G;while(1){x=w;w=f[l+(v<<3)>>2]|0;J=(f[s>>2]=w,+n[s>>2]);K=I;I=+n[l+(v<<3)+4>>2];if((!(K<=r)|!(I<=r)?!(K>r&I>r):0)?(L=(f[s>>2]=x,+n[s>>2]),!(L<q&J<q)):0){N=(J-L)*(r-K)-(I-K)*(q-L);if(N==0.0){t=0.0;break a}O=((I<K?-N:N)>0.0&1)+o|0}else if(r==I){if(q==J){t=0.0;break a}if(r==K){K=(f[s>>2]=x,+n[s>>2]);if(!(!(K<=q)|!(q<=J))){t=0.0;break a}if(!(!(J<=q)|!(q<=K))){t=0.0;break a}else O=o}else O=o}else O=o;v=v+1|0;if((v|0)>=(a|0)){P=O;break}else o=O}}else{I=F;o=0;v=0;w=G;while(1){K=+(f[l+(v<<3)>>2]|0);J=I;I=+(f[l+(v<<3)+4>>2]|0);m=w;w=(n[s>>2]=K,f[s>>2]|0);if((!(J<=r)|!(I<=r)?!(J>r&I>r):0)?(N=(f[s>>2]=m,+n[s>>2]),!(N<q&K<q)):0){L=(K-N)*(r-J)-(I-J)*(q-N);if(L==0.0){t=0.0;break a}Q=((I<J?-L:L)>0.0&1)+o|0}else if(r==I){if(q==K){t=0.0;break a}if(r==J){J=(f[s>>2]=m,+n[s>>2]);if(!(!(J<=q)|!(q<=K))){t=0.0;break a}if(!(!(K<=q)|!(q<=J))){t=0.0;break a}else Q=o}else Q=o}else Q=o;v=v+1|0;if((v|0)>=(a|0)){P=Q;break}else o=Q}}else P=0;t=+((P<<1&2)+-1|0);break}c:do if(p)if(i){o=0;v=0;I=1.0;J=3402823466385288598117041.0e14;w=G;m=H;while(1){k=w;w=f[l+(v<<3)>>2]|0;K=(f[s>>2]=w,+n[s>>2]);x=m;m=f[l+(v<<3)+4>>2]|0;L=(f[s>>2]=m,+n[s>>2]);N=(f[s>>2]=k,+n[s>>2]);R=K-N;S=(f[s>>2]=x,+n[s>>2]);T=L-S;U=T;V=q-N;W=r-S;X=q-K;Z=r-L;do if(!(R*V+U*W<=0.0))if(!(R*X+U*Z>=0.0)){_=R*W-U*V;$=R*R+U*U;aa=_*_;break}else{$=1.0;aa=X*X+Z*Z;break}else{$=1.0;aa=V*V+W*W}while(0);if(I*aa<J*$)if(aa==0.0){ba=o;ca=$;da=aa;break c}else{ea=$;fa=aa}else{ea=I;fa=J}if((!(S<=r)|!(L<=r)?!(S>r&L>r):0)?!(N<q&K<q):0){Z=R*W-U*V;ga=((T<0.0?-Z:Z)>0.0&1)+o|0}else ga=o;v=v+1|0;if((v|0)>=(a|0)){ba=ga;ca=ea;da=fa;break}else{o=ga;I=ea;J=fa}}}else{o=0;v=0;J=1.0;I=3402823466385288598117041.0e14;m=G;w=H;while(1){Z=+(f[l+(v<<3)>>2]|0);X=+(f[l+(v<<3)+4>>2]|0);x=m;m=(n[s>>2]=Z,f[s>>2]|0);k=w;w=(n[s>>2]=X,f[s>>2]|0);_=(f[s>>2]=x,+n[s>>2]);ha=Z-_;ia=(f[s>>2]=k,+n[s>>2]);ja=X-ia;ka=ja;la=q-_;ma=r-ia;na=q-Z;oa=r-X;do if(!(ha*la+ka*ma<=0.0))if(!(ha*na+ka*oa>=0.0)){pa=ha*ma-ka*la;qa=ha*ha+ka*ka;ra=pa*pa;break}else{qa=1.0;ra=na*na+oa*oa;break}else{qa=1.0;ra=la*la+ma*ma}while(0);if(J*ra<I*qa)if(ra==0.0){ba=o;ca=qa;da=ra;break c}else{sa=qa;ta=ra}else{sa=J;ta=I}if((!(ia<=r)|!(X<=r)?!(ia>r&X>r):0)?!(_<q&Z<q):0){oa=ha*ma-ka*la;ua=((ja<0.0?-oa:oa)>0.0&1)+o|0}else ua=o;v=v+1|0;if((v|0)>=(a|0)){ba=ua;ca=sa;da=ta;break}else{o=ua;J=sa;I=ta}}}else{ba=0;ca=1.0;da=3402823466385288598117041.0e14}while(0);I=+M(+(da/ca));t=(ba&1|0)==0?-I:I}while(0);ba=h+36|0;ua=f[ba>>2]|0;if(ua|0?(a=ua+12|0,ua=f[a>>2]|0,f[a>>2]=ua+-1,(ua|0)==1):0)CR(h);f[ba>>2]=0;ba=h+16|0;ua=h+4|0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[ua>>2]|0)>0){ba=f[h+40>>2]|0;a=0;do{f[ba+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[ua>>2]|0))}ua=f[h+44>>2]|0;if((ua|0)!=(h+48|0))ZF(ua);if(!(f[g+4>>2]|0)){u=e;return +t}u=e;return +t}function kfa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+48|0;e=d+32|0;g=d;f[a>>2]=1124007936;h=a+4|0;i=a+8|0;j=a+40|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;m=a+48|0;n=a+44|0;f[n>>2]=m;f[m>>2]=0;f[a+52>>2]=0;m=c+16|0;o=(f[m>>2]|0)==0;q=f[c+4>>2]|0;do if(!o){if((q|0)<3)r=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{s=f[c+40>>2]|0;t=0;v=1;while(1){w=Y(f[s+(t<<2)>>2]|0,v)|0;t=t+1|0;if((t|0)==(q|0)){r=w;break}else v=w}}if(!((q|0)==0|(r|0)==0)){if(((f[c>>2]&4095|0)==6?(f[c+8>>2]|0)==1:0)?(f[c+12>>2]|0)==65:0)break;f[e>>2]=0;f[e+4>>2]=0;k=c$(e,72)|0;v=235216;l=k+72|0;do{b[k>>0]=b[v>>0]|0;k=k+1|0;v=v+1|0}while((k|0)<(l|0));j$(-5,e,235289,235293,96);d$(e)}else x=7}else x=7;while(0);if((x|0)==7){if(!((((q|0)<3?(f[c+8>>2]|0)==1:0)?(f[c+12>>2]|0)==65:0)?!((f[c>>2]&4095|0)!=6|o):0)){f[e>>2]=1;f[e+4>>2]=65;AR(c,2,e,6)}f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[e>>2]=-1056833530;f[e+4>>2]=g;f[e+8>>2]=1;f[e+12>>2]=4;hL(c,e,fT()|0)|0}if((a|0)==(c|0))y=f[a+16>>2]|0;else{e=c+36|0;g=f[e>>2]|0;if(g|0){o=g+12|0;f[o>>2]=(f[o>>2]|0)+1}o=a+36|0;g=f[o>>2]|0;if(g|0?(q=g+12|0,g=f[q>>2]|0,f[q>>2]=g+-1,(g|0)==1):0)CR(a);f[o>>2]=0;g=a+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[h>>2]|0)>0){q=f[j>>2]|0;j=0;do{f[q+(j<<2)>>2]=0;j=j+1|0;z=f[h>>2]|0}while((j|0)<(z|0));f[a>>2]=f[c>>2];if((z|0)<3)x=29;else x=31}else{f[a>>2]=f[c>>2];x=29}if((x|0)==29){z=f[c+4>>2]|0;if((z|0)<3){f[h>>2]=z;f[i>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];i=f[c+44>>2]|0;z=f[n>>2]|0;f[z>>2]=f[i>>2];f[z+4>>2]=f[i+4>>2]}else x=31}if((x|0)==31)BR(a,c);x=f[m>>2]|0;f[g>>2]=x;f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];f[o>>2]=f[e>>2];y=x}x=a+56|0;f[x>>2]=y;f[a+60>>2]=y+40;f[a+64>>2]=y+160;if(+p[y>>3]>0.0){lfa(a,0);A=f[x>>2]|0}else A=y;if(+p[A+8>>3]>0.0){lfa(a,1);B=f[x>>2]|0}else B=A;if(+p[B+16>>3]>0.0){lfa(a,2);C=f[x>>2]|0}else C=B;if(+p[C+24>>3]>0.0){lfa(a,3);D=f[x>>2]|0}else D=C;if(!(+p[D+32>>3]>0.0)){E=a+972|0;f[E>>2]=0;u=d;return}lfa(a,4);E=a+972|0;f[E>>2]=0;u=d;return}function lfa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0.0,j=0,k=0.0,l=0,m=0.0,n=0,o=0.0,q=0,r=0,s=0.0,t=0,v=0.0,w=0,x=0.0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;if(!(+p[(f[a+56>>2]|0)+(c<<3)>>3]>0.0)){u=d;return}g=(f[a+64>>2]|0)+(c*9<<3)|0;h=g+32|0;i=+p[h>>3];j=g+64|0;k=+p[j>>3];l=g+40|0;m=+p[l>>3];n=g+56|0;o=+p[n>>3];q=g+8|0;r=g+24|0;s=+p[r>>3];t=g+48|0;v=+p[t>>3];w=g+16|0;x=+p[w>>3]*(o*s-i*v)+(+p[g>>3]*(i*k-m*o)-+p[q>>3]*(k*s-m*v));p[a+432+(c<<3)>>3]=x;if(!(x>2.220446049250313e-16)){f[e>>2]=0;f[e+4>>2]=0;y=c$(e,45)|0;z=235345;A=y+45|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));j$(-215,e,235391,235293,217);d$(e)}p[a+72+(c*72|0)>>3]=(+p[h>>3]*+p[j>>3]-+p[l>>3]*+p[n>>3])/x;p[a+72+(c*72|0)+24>>3]=-(+p[r>>3]*+p[j>>3]-+p[l>>3]*+p[t>>3])/x;p[a+72+(c*72|0)+48>>3]=(+p[r>>3]*+p[n>>3]-+p[h>>3]*+p[t>>3])/x;p[a+72+(c*72|0)+8>>3]=-(+p[q>>3]*+p[j>>3]-+p[w>>3]*+p[n>>3])/x;p[a+72+(c*72|0)+32>>3]=(+p[g>>3]*+p[j>>3]-+p[w>>3]*+p[t>>3])/x;p[a+72+(c*72|0)+56>>3]=-(+p[g>>3]*+p[n>>3]-+p[q>>3]*+p[t>>3])/x;p[a+72+(c*72|0)+16>>3]=(+p[q>>3]*+p[l>>3]-+p[w>>3]*+p[h>>3])/x;p[a+72+(c*72|0)+40>>3]=-(+p[g>>3]*+p[l>>3]-+p[w>>3]*+p[r>>3])/x;p[a+72+(c*72|0)+64>>3]=(+p[g>>3]*+p[h>>3]-+p[q>>3]*+p[r>>3])/x;u=d;return}function mfa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0.0,i=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,q=0.0;e=u;u=u+16|0;g=e;if(!(+p[(f[a+56>>2]|0)+(c<<3)>>3]>0.0)){h=0.0;u=e;return +h}i=a+432+(c<<3)|0;j=+p[i>>3];if(j>2.220446049250313e-16)k=j;else{f[g>>2]=0;f[g+4>>2]=0;l=c$(g,55)|0;m=235415;n=l+55|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-215,g,373355,235293,123);d$(g);k=+p[i>>3]}i=(f[a+60>>2]|0)+(c*3<<3)|0;j=+p[d>>3]-+p[i>>3];o=+p[d+8>>3]-+p[i+8>>3];q=+p[d+16>>3]-+p[i+16>>3];h=1.0/+M(+k)*+V(+((j*(j*+p[a+72+(c*72|0)>>3]+o*+p[a+72+(c*72|0)+24>>3]+q*+p[a+72+(c*72|0)+48>>3])+o*(j*+p[a+72+(c*72|0)+8>>3]+o*+p[a+72+(c*72|0)+32>>3]+q*+p[a+72+(c*72|0)+56>>3])+q*(j*+p[a+72+(c*72|0)+16>>3]+o*+p[a+72+(c*72|0)+40>>3]+q*+p[a+72+(c*72|0)+64>>3]))*-.5));u=e;return +h}function nfa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0;b=a+56|0;c=a+972|0;d=a+60|0;e=a+64|0;g=0;do{h=f[a+952+(g<<2)>>2]|0;i=f[b>>2]|0;if(!h)p[i+(g<<3)>>3]=0.0;else{j=+(h|0);p[i+(g<<3)>>3]=j/+(f[c>>2]|0);i=(f[d>>2]|0)+(g*3<<3)|0;k=+p[a+472+(g*24|0)>>3]/j;p[i>>3]=k;h=i+8|0;p[h>>3]=+p[a+472+(g*24|0)+8>>3]/j;l=i+16|0;p[l>>3]=+p[a+472+(g*24|0)+16>>3]/j;m=(f[e>>2]|0)+(g*9<<3)|0;n=+p[a+592+(g*72|0)>>3]/j-k*k;p[m>>3]=n;k=+p[a+592+(g*72|0)+8>>3]/j-+p[i>>3]*+p[h>>3];p[m+8>>3]=k;o=+p[a+592+(g*72|0)+16>>3]/j-+p[i>>3]*+p[l>>3];p[m+16>>3]=o;q=+p[a+592+(g*72|0)+24>>3]/j-+p[h>>3]*+p[i>>3];p[m+24>>3]=q;r=+p[h>>3];s=+p[a+592+(g*72|0)+32>>3]/j-r*r;t=m+32|0;p[t>>3]=s;r=+p[a+592+(g*72|0)+40>>3]/j-+p[h>>3]*+p[l>>3];p[m+40>>3]=r;u=+p[a+592+(g*72|0)+48>>3]/j-+p[l>>3]*+p[i>>3];p[m+48>>3]=u;v=+p[a+592+(g*72|0)+56>>3]/j-+p[l>>3]*+p[h>>3];p[m+56>>3]=v;w=+p[l>>3];x=+p[a+592+(g*72|0)+64>>3]/j-w*w;l=m+64|0;p[l>>3]=x;if(o*(v*q-s*u)+(n*(x*s-r*v)-k*(x*q-r*u))<=2.220446049250313e-16){p[m>>3]=n+.01;p[t>>3]=s+.01;p[l>>3]=x+.01}lfa(a,g)}g=g+1|0}while((g|0)!=5);return}function ofa(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0.0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0.0,Hb=0,Ib=0,Jb=0,Kb=0.0,Lb=0.0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0;k=u;u=u+2544|0;l=k+2072|0;m=k+2016|0;o=k+2488|0;q=k+2432|0;r=k+2376|0;s=k+2304|0;t=k+2248|0;v=k+1984|0;w=k+1968|0;x=k+2232|0;y=k+1952|0;z=k+2224|0;A=k+2168|0;B=k+976|0;C=k;D=k+2112|0;E=k+2360|0;_$(z,59192);do if((NS(a)|0)==65536){F=f[a+4>>2]|0;f[A>>2]=f[F>>2];G=A+4|0;H=F+4|0;f[G>>2]=f[H>>2];I=A+8|0;f[I>>2]=f[F+8>>2];f[A+12>>2]=f[F+12>>2];f[A+16>>2]=f[F+16>>2];f[A+20>>2]=f[F+20>>2];f[A+24>>2]=f[F+24>>2];f[A+28>>2]=f[F+28>>2];f[A+32>>2]=f[F+32>>2];J=f[F+36>>2]|0;f[A+36>>2]=J;f[A+40>>2]=I;I=A+48|0;K=A+44|0;f[K>>2]=I;f[I>>2]=0;f[A+52>>2]=0;if(J|0){I=J+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[H>>2]|0)<3){H=f[F+44>>2]|0;I=f[K>>2]|0;f[I>>2]=f[H>>2];f[I+4>>2]=f[H+4>>2];break}else{f[G>>2]=0;BR(A,F);break}}else OR(A,a,-1);while(0);a=_S(c,-1)|0;c=_S(e,-1)|0;e=_S(g,-1)|0;g=A+16|0;if(f[g>>2]|0){F=f[A+4>>2]|0;if((F|0)<3)L=Y(f[A+12>>2]|0,f[A+8>>2]|0)|0;else{G=f[A+40>>2]|0;H=0;I=1;while(1){K=Y(f[G+(H<<2)>>2]|0,I)|0;H=H+1|0;if((H|0)==(F|0)){L=K;break}else I=K}}if((F|0)==0|(L|0)==0)M=14}else M=14;if((M|0)==14){f[l>>2]=0;f[l+4>>2]=0;N=c$(l,14)|0;O=235471;P=N+14|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));j$(-5,l,235486,235293,541);d$(l)}if((f[A>>2]&4095|0)!=16){f[l>>2]=0;f[l+4>>2]=0;N=c$(l,28)|0;O=235494;P=N+28|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));j$(-5,l,235486,235293,543);d$(l)}kfa(B,c);kfa(C,e);e=A+40|0;c=f[e>>2]|0;L=f[c+4>>2]|0;F=f[c>>2]|0;f[D>>2]=1124007936;c=D+4|0;I=D+8|0;H=D+40|0;N=c;P=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));f[H>>2]=I;I=D+48|0;G=D+44|0;f[G>>2]=I;f[I>>2]=0;f[D+52>>2]=0;f[l>>2]=F;F=l+4|0;f[F>>2]=L;AR(D,2,l,4);if((j|1|0)==1){if(!j){L=f[e>>2]|0;K=f[L+4>>2]|0;J=f[L>>2]|0;f[E>>2]=f[d>>2];L=E+4|0;f[L>>2]=f[d+4>>2];Q=E+8|0;f[Q>>2]=f[d+8>>2];R=E+12|0;f[R>>2]=f[d+12>>2];if(!(((((f[a+4>>2]|0)<3?(f[a+8>>2]|0)==(J|0):0)?(f[a+12>>2]|0)==(K|0):0)?(f[a>>2]&4095|0)==0:0)?(f[a+16>>2]|0)!=0:0)){f[l>>2]=J;f[F>>2]=K;AR(a,2,l,0)}p[m>>3]=0.0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;hL(a,l,fT()|0)|0;d=f[E>>2]|0;S=(d|0)>0?d:0;f[E>>2]=S;d=f[L>>2]|0;T=(d|0)>0?d:0;f[L>>2]=T;L=K-S|0;S=f[Q>>2]|0;f[Q>>2]=(L|0)<(S|0)?L:S;S=J-T|0;T=f[R>>2]|0;f[R>>2]=(S|0)<(T|0)?S:T;FR(o,a,E);p[m>>3]=3.0;E=m+8|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;f[E+16>>2]=0;f[E+20>>2]=0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=4;hL(o,l,fT()|0)|0;E=o+36|0;T=f[E>>2]|0;if(T|0?(S=T+12|0,T=f[S>>2]|0,f[S>>2]=T+-1,(T|0)==1):0)CR(o);f[E>>2]=0;E=o+16|0;T=o+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[T>>2]|0)>0){E=f[o+40>>2]|0;S=0;do{f[E+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[T>>2]|0))}T=f[o+44>>2]|0;if((T|0)!=(o+48|0))ZF(T)}else pfa(A,a);f[m>>2]=1124007936;T=m+4|0;S=m+8|0;E=m+40|0;N=T;P=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));f[E>>2]=S;S=m+48|0;R=m+44|0;f[R>>2]=S;f[S>>2]=0;f[m+52>>2]=0;f[o>>2]=1124007936;J=o+4|0;L=o+8|0;Q=o+40|0;N=J;P=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));f[Q>>2]=L;L=o+48|0;K=o+44|0;f[K>>2]=L;f[L>>2]=0;f[o+52>>2]=0;f[q>>2]=0;d=q+4|0;f[d>>2]=0;f[q+8>>2]=0;f[r>>2]=0;U=r+4|0;f[U>>2]=0;f[r+8>>2]=0;X=A+8|0;Z=f[X>>2]|0;if((Z|0)>0){_=A+12|0;$=a+16|0;aa=a+44|0;ba=A+44|0;ca=l+4|0;da=l+8|0;ea=r+8|0;fa=l+4|0;ga=l+8|0;ha=q+8|0;ia=Z;Z=f[_>>2]|0;ja=0;while(1){if((Z|0)>0){ka=0;do{la=(f[$>>2]|0)+(Y(f[f[aa>>2]>>2]|0,ja)|0)+ka|0;switch(b[la>>0]|0){case 2:case 0:{la=(f[g>>2]|0)+(Y(f[f[ba>>2]>>2]|0,ja)|0)|0;ma=+(h[la+(ka*3|0)>>0]|0);n[l>>2]=ma;n[fa>>2]=+(h[la+(ka*3|0)+1>>0]|0);n[ga>>2]=+(h[la+(ka*3|0)+2>>0]|0);la=f[d>>2]|0;if((la|0)==(f[ha>>2]|0))qfa(q,l);else{n[la>>2]=ma;f[la+4>>2]=f[fa>>2];f[la+8>>2]=f[ga>>2];f[d>>2]=la+12}break}default:{la=(f[g>>2]|0)+(Y(f[f[ba>>2]>>2]|0,ja)|0)|0;ma=+(h[la+(ka*3|0)>>0]|0);n[l>>2]=ma;n[ca>>2]=+(h[la+(ka*3|0)+1>>0]|0);n[da>>2]=+(h[la+(ka*3|0)+2>>0]|0);la=f[U>>2]|0;if((la|0)==(f[ea>>2]|0))qfa(r,l);else{n[la>>2]=ma;f[la+4>>2]=f[ca>>2];f[la+8>>2]=f[da>>2];f[U>>2]=la+12}}}ka=ka+1|0;na=f[_>>2]|0}while((ka|0)<(na|0));oa=na;pa=f[X>>2]|0}else{oa=Z;pa=ia}ja=ja+1|0;if((ja|0)>=(pa|0))break;else{ia=pa;Z=oa}}oa=f[q>>2]|0;Z=f[d>>2]|0;pa=Z;ia=oa;if((oa|0)!=(Z|0)?(f[r>>2]|0)!=(f[U>>2]|0):0){qa=d;ra=q;sa=ia;ta=pa}else M=53}else M=53;if((M|0)==53){f[l>>2]=0;f[l+4>>2]=0;N=c$(l,42)|0;O=235523;P=N+42|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));j$(-215,l,235566,235293,380);d$(l);qa=d;ra=q;sa=f[q>>2]|0;ta=f[d>>2]|0}pa=ta-sa|0;ta=sa;f[s>>2]=1124007941;ia=s+4|0;f[ia>>2]=2;Z=s+8|0;f[Z>>2]=(pa|0)/12|0;oa=s+12|0;f[oa>>2]=3;ja=s+16|0;f[ja>>2]=ta;X=s+20|0;f[X>>2]=ta;na=s+24|0;_=s+28|0;da=s+40|0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;f[da>>2]=Z;ca=s+48|0;ea=s+44|0;f[ea>>2]=ca;f[s+52>>2]=0;f[ca>>2]=0;if((sa|0)==0&(pa|0)!=0){f[l>>2]=0;f[l+4>>2]=0;N=c$(l,26)|0;O=358223;P=N+26|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));j$(-215,l,358250,358254,500);d$(l);ua=f[oa>>2]|0;va=f[s>>2]|0;wa=f[ea>>2]|0;xa=f[X>>2]|0}else{ua=3;va=1124007941;wa=ca;xa=ta}ta=ua<<2;f[s>>2]=va|16384;f[wa>>2]=ta;f[wa+4>>2]=4;wa=xa+(Y(f[Z>>2]|0,ta)|0)|0;f[_>>2]=wa;f[na>>2]=wa+(0-ta)+ta;f[t+8>>2]=0;f[t+12>>2]=0;f[t>>2]=16842752;f[t+4>>2]=s;ta=v+8|0;f[ta>>2]=0;f[ta+4>>2]=0;f[v>>2]=50397184;f[v+4>>2]=m;f[w>>2]=1;f[w+4>>2]=10;p[w+8>>3]=0.0;ta=fT()|0;f[l>>2]=f[w>>2];f[l+4>>2]=f[w+4>>2];f[l+8>>2]=f[w+8>>2];f[l+12>>2]=f[w+12>>2];+SM(t,5,v,l,0,2,ta);ta=f[r>>2]|0;w=(f[U>>2]|0)-ta|0;wa=ta;f[t>>2]=1124007941;na=t+4|0;f[na>>2]=2;_=t+8|0;f[_>>2]=(w|0)/12|0;Z=t+12|0;f[Z>>2]=3;xa=t+16|0;f[xa>>2]=wa;va=t+20|0;f[va>>2]=wa;ua=t+24|0;X=t+28|0;oa=t+40|0;f[ua>>2]=0;f[ua+4>>2]=0;f[ua+8>>2]=0;f[ua+12>>2]=0;f[oa>>2]=_;pa=t+48|0;sa=t+44|0;f[sa>>2]=pa;f[t+52>>2]=0;f[pa>>2]=0;if((ta|0)==0&(w|0)!=0){f[l>>2]=0;f[l+4>>2]=0;N=c$(l,26)|0;O=358223;P=N+26|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));j$(-215,l,358250,358254,500);d$(l);ya=f[Z>>2]|0;za=f[t>>2]|0;Aa=f[sa>>2]|0;Ba=f[va>>2]|0}else{ya=3;za=1124007941;Aa=pa;Ba=wa}wa=ya<<2;f[t>>2]=za|16384;f[Aa>>2]=wa;f[Aa+4>>2]=4;Aa=Ba+(Y(f[_>>2]|0,wa)|0)|0;f[X>>2]=Aa;f[ua>>2]=Aa+(0-wa)+wa;f[v+8>>2]=0;f[v+12>>2]=0;f[v>>2]=16842752;f[v+4>>2]=t;wa=x+8|0;f[wa>>2]=0;f[wa+4>>2]=0;f[x>>2]=50397184;f[x+4>>2]=o;f[y>>2]=1;f[y+4>>2]=10;p[y+8>>3]=0.0;wa=fT()|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2];f[l+8>>2]=f[y+8>>2];f[l+12>>2]=f[y+12>>2];+SM(v,5,x,l,0,2,wa);F1a(B+472|0,0,504)|0;wa=f[ra>>2]|0;ra=(f[qa>>2]|0)-wa|0;qa=wa;if((ra|0)>0){wa=f[m+16>>2]|0;x=f[R>>2]|0;y=B+972|0;Aa=(ra>>>0)/12|0;ra=0;do{ua=wa+(Y(f[x>>2]|0,ra)|0)|0;X=f[ua>>2]|0;ma=+n[qa+(ra*12|0)>>2];Ca=+n[qa+(ra*12|0)+4>>2];Da=+n[qa+(ra*12|0)+8>>2];ua=B+472+(X*24|0)|0;p[ua>>3]=ma+ +p[ua>>3];ua=B+472+(X*24|0)+8|0;p[ua>>3]=Ca+ +p[ua>>3];ua=B+472+(X*24|0)+16|0;p[ua>>3]=Da+ +p[ua>>3];ua=B+592+(X*72|0)|0;p[ua>>3]=ma*ma+ +p[ua>>3];Ea=ma*Ca;ua=B+592+(X*72|0)+8|0;p[ua>>3]=Ea+ +p[ua>>3];Fa=ma*Da;ua=B+592+(X*72|0)+16|0;p[ua>>3]=Fa+ +p[ua>>3];ua=B+592+(X*72|0)+24|0;p[ua>>3]=Ea+ +p[ua>>3];ua=B+592+(X*72|0)+32|0;p[ua>>3]=Ca*Ca+ +p[ua>>3];Ea=Ca*Da;ua=B+592+(X*72|0)+40|0;p[ua>>3]=Ea+ +p[ua>>3];ua=B+592+(X*72|0)+48|0;p[ua>>3]=Fa+ +p[ua>>3];ua=B+592+(X*72|0)+56|0;p[ua>>3]=Ea+ +p[ua>>3];ua=B+592+(X*72|0)+64|0;p[ua>>3]=Da*Da+ +p[ua>>3];ua=B+952+(X<<2)|0;f[ua>>2]=(f[ua>>2]|0)+1;f[y>>2]=(f[y>>2]|0)+1;ra=ra+1|0}while((ra|0)<(Aa|0))}nfa(B);F1a(C+472|0,0,504)|0;Aa=f[r>>2]|0;ra=(f[U>>2]|0)-Aa|0;y=Aa;if((ra|0)>0){Aa=f[o+16>>2]|0;qa=f[K>>2]|0;x=C+972|0;wa=(ra>>>0)/12|0;ra=0;do{ua=Aa+(Y(f[qa>>2]|0,ra)|0)|0;X=f[ua>>2]|0;Da=+n[y+(ra*12|0)>>2];Ea=+n[y+(ra*12|0)+4>>2];Fa=+n[y+(ra*12|0)+8>>2];ua=C+472+(X*24|0)|0;p[ua>>3]=Da+ +p[ua>>3];ua=C+472+(X*24|0)+8|0;p[ua>>3]=Ea+ +p[ua>>3];ua=C+472+(X*24|0)+16|0;p[ua>>3]=Fa+ +p[ua>>3];ua=C+592+(X*72|0)|0;p[ua>>3]=Da*Da+ +p[ua>>3];Ca=Da*Ea;ua=C+592+(X*72|0)+8|0;p[ua>>3]=Ca+ +p[ua>>3];ma=Da*Fa;ua=C+592+(X*72|0)+16|0;p[ua>>3]=ma+ +p[ua>>3];ua=C+592+(X*72|0)+24|0;p[ua>>3]=Ca+ +p[ua>>3];ua=C+592+(X*72|0)+32|0;p[ua>>3]=Ea*Ea+ +p[ua>>3];Ca=Ea*Fa;ua=C+592+(X*72|0)+40|0;p[ua>>3]=Ca+ +p[ua>>3];ua=C+592+(X*72|0)+48|0;p[ua>>3]=ma+ +p[ua>>3];ua=C+592+(X*72|0)+56|0;p[ua>>3]=Ca+ +p[ua>>3];ua=C+592+(X*72|0)+64|0;p[ua>>3]=Fa*Fa+ +p[ua>>3];ua=C+952+(X<<2)|0;f[ua>>2]=(f[ua>>2]|0)+1;f[x>>2]=(f[x>>2]|0)+1;ra=ra+1|0}while((ra|0)<(wa|0))}nfa(C);wa=t+36|0;ra=f[wa>>2]|0;if(ra|0?(x=ra+12|0,ra=f[x>>2]|0,f[x>>2]=ra+-1,(ra|0)==1):0)CR(t);f[wa>>2]=0;f[xa>>2]=0;f[xa+4>>2]=0;f[xa+8>>2]=0;f[xa+12>>2]=0;if((f[na>>2]|0)>0){xa=f[oa>>2]|0;oa=0;do{f[xa+(oa<<2)>>2]=0;oa=oa+1|0}while((oa|0)<(f[na>>2]|0))}na=f[sa>>2]|0;if((na|0)!=(pa|0))ZF(na);na=s+36|0;pa=f[na>>2]|0;if(pa|0?(sa=pa+12|0,pa=f[sa>>2]|0,f[sa>>2]=pa+-1,(pa|0)==1):0)CR(s);f[na>>2]=0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[ia>>2]|0)>0){ja=f[da>>2]|0;da=0;do{f[ja+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[ia>>2]|0))}ia=f[ea>>2]|0;if((ia|0)!=(ca|0))ZF(ia);ia=f[r>>2]|0;if(ia|0){ca=f[U>>2]|0;if((ca|0)!=(ia|0))f[U>>2]=ca+(~(((ca+-12-ia|0)>>>0)/12|0)*12|0);PYa(ia)}ia=f[q>>2]|0;if(ia|0){ca=f[d>>2]|0;if((ca|0)!=(ia|0))f[d>>2]=ca+(~(((ca+-12-ia|0)>>>0)/12|0)*12|0);PYa(ia)}ia=o+36|0;ca=f[ia>>2]|0;do if(ca|0){d=ca+12|0;U=f[d>>2]|0;f[d>>2]=U+-1;if((U|0)!=1)break;CR(o)}while(0);f[ia>>2]=0;ia=o+16|0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[J>>2]|0)>0){ia=f[Q>>2]|0;Q=0;do{f[ia+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[J>>2]|0))}J=f[K>>2]|0;if((J|0)!=(L|0))ZF(J);J=m+36|0;L=f[J>>2]|0;do if(L|0){K=L+12|0;Q=f[K>>2]|0;f[K>>2]=Q+-1;if((Q|0)!=1)break;CR(m)}while(0);f[J>>2]=0;J=m+16|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[T>>2]|0)>0){J=f[E>>2]|0;E=0;do{f[J+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[T>>2]|0))}T=f[R>>2]|0;if((T|0)!=(S|0))ZF(T)}if((i|0)>=1){if((j|0)==2)pfa(A,a);j=A+8|0;T=f[j>>2]|0;S=A+12|0;R=f[S>>2]|0;if((T|0)>0){E=(R|0)>0;J=f[g>>2]|0;L=f[A+44>>2]|0;Q=R+-1|0;Fa=0.0;K=0;while(1){a:do if(E){ia=f[L>>2]|0;ca=J+(Y(ia,K)|0)|0;U=J+(Y(ia,K+-1|0)|0)|0;if((K|0)>0){Ga=Fa;Ha=0}else{Ca=Fa;ia=0;while(1){if((ia|0)>0){d=ia+-1|0;ma=+(h[ca+(ia*3|0)>>0]|0)-+(h[ca+(d*3|0)>>0]|0);Ea=+(h[ca+(ia*3|0)+1>>0]|0)-+(h[ca+(d*3|0)+1>>0]|0);Da=+(h[ca+(ia*3|0)+2>>0]|0)-+(h[ca+(d*3|0)+2>>0]|0);Ia=Ca+(ma*ma+0.0+Ea*Ea+Da*Da)}else Ia=Ca;ia=ia+1|0;if((ia|0)==(R|0)){Ja=Ia;break a}else Ca=Ia}}while(1){Ca=+(h[ca+(Ha*3|0)>>0]|0);Da=+(h[ca+(Ha*3|0)+1>>0]|0);Ea=+(h[ca+(Ha*3|0)+2>>0]|0);if((Ha|0)>0){ia=Ha+-1|0;ma=Ca-+(h[ca+(ia*3|0)>>0]|0);Ka=Da-+(h[ca+(ia*3|0)+1>>0]|0);La=Ea-+(h[ca+(ia*3|0)+2>>0]|0);Ma=Ca-+(h[U+(ia*3|0)>>0]|0);Na=Da-+(h[U+(ia*3|0)+1>>0]|0);Oa=Ea-+(h[U+(ia*3|0)+2>>0]|0);Pa=Ga+(ma*ma+0.0+Ka*Ka+La*La)+(Ma*Ma+0.0+Na*Na+Oa*Oa)}else Pa=Ga;Oa=Ca-+(h[U+(Ha*3|0)>>0]|0);Na=Da-+(h[U+(Ha*3|0)+1>>0]|0);Ma=Ea-+(h[U+(Ha*3|0)+2>>0]|0);La=Pa+(Oa*Oa+0.0+Na*Na+Ma*Ma);ia=Ha;Ha=Ha+1|0;if((ia|0)<(Q|0)){Ma=Ca-+(h[U+(Ha*3|0)>>0]|0);Ca=Da-+(h[U+(Ha*3|0)+1>>0]|0);Da=Ea-+(h[U+(Ha*3|0)+2>>0]|0);Qa=La+(Ma*Ma+0.0+Ca*Ca+Da*Da)}else Qa=La;if((Ha|0)==(R|0)){Ja=Qa;break}else Ga=Qa}}else Ja=Fa;while(0);K=K+1|0;if((K|0)==(T|0))break;else Fa=Ja}if(!(Ja<=2.220446049250313e-16))Ra=1.0/(Ja*2.0/+((Y(T,-3)|0)+2+(Y(R,(T<<2)+-3|0)|0)|0));else Ra=0.0}else Ra=0.0;f[q>>2]=1124007936;K=q+4|0;Ha=q+8|0;Q=q+40|0;N=K;P=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));f[Q>>2]=Ha;Ha=q+48|0;J=q+44|0;f[J>>2]=Ha;f[Ha>>2]=0;f[q+52>>2]=0;f[r>>2]=1124007936;L=r+4|0;E=r+8|0;U=r+40|0;N=L;P=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));f[U>>2]=E;ca=r+48|0;ia=r+44|0;f[ia>>2]=ca;f[ca>>2]=0;f[r+52>>2]=0;f[s>>2]=1124007936;d=s+4|0;ea=s+8|0;da=s+40|0;N=d;P=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));f[da>>2]=ea;ja=s+48|0;na=s+44|0;f[na>>2]=ja;f[ja>>2]=0;f[s+52>>2]=0;f[t>>2]=1124007936;pa=t+4|0;sa=t+8|0;oa=t+40|0;N=pa;P=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));f[oa>>2]=sa;xa=t+48|0;wa=t+44|0;f[wa>>2]=xa;f[xa>>2]=0;f[t+52>>2]=0;f[l>>2]=T;f[F>>2]=R;AR(q,2,l,6);R=f[j>>2]|0;T=f[S>>2]|0;ra=f[E>>2]|0;if((((f[L>>2]|0)<3&(ra|0)==(R|0)?(f[r+12>>2]|0)==(T|0):0)?(f[r>>2]&4095|0)==6:0)?(f[r+16>>2]|0)!=0:0){Sa=ra;Ta=T;Ua=R}else{f[l>>2]=R;f[F>>2]=T;AR(r,2,l,6);T=f[j>>2]|0;Sa=T;Ta=f[S>>2]|0;Ua=T}if(((((f[d>>2]|0)<3?(f[ea>>2]|0)==(Sa|0):0)?(f[s+12>>2]|0)==(Ta|0):0)?(f[s>>2]&4095|0)==6:0)?(f[s+16>>2]|0)!=0:0){Va=Sa;Wa=Ta;Xa=Ua}else{f[l>>2]=Sa;f[F>>2]=Ta;AR(s,2,l,6);Ta=f[j>>2]|0;Va=Ta;Wa=f[S>>2]|0;Xa=Ta}if(((((f[pa>>2]|0)<3?(f[sa>>2]|0)==(Va|0):0)?(f[t+12>>2]|0)==(Wa|0):0)?(f[t>>2]&4095|0)==6:0)?(f[t+16>>2]|0)!=0:0){Ya=Va;Za=Xa}else{f[l>>2]=Va;f[F>>2]=Wa;AR(t,2,l,6);Wa=f[j>>2]|0;Ya=Wa;Za=Wa}if((Ya|0)>0){Wa=A+44|0;F=q+16|0;Va=r+16|0;Xa=s+16|0;sa=t+16|0;Ta=f[S>>2]|0;Sa=(Ta|0)>0;Ua=0;do{if(Sa){ea=(Ua|0)>0;T=f[g>>2]|0;R=f[f[Wa>>2]>>2]|0;ra=T+(Y(R,Ua)|0)|0;E=T+(Y(R,Ua+-1|0)|0)|0;R=0;while(1){Ja=+(h[ra+(R*3|0)>>0]|0);Fa=+(h[ra+(R*3|0)+1>>0]|0);Qa=+(h[ra+(R*3|0)+2>>0]|0);T=R+-1|0;do if((R|0)>0){Ga=Ja-+(h[ra+(T*3|0)>>0]|0);Pa=Fa-+(h[ra+(T*3|0)+1>>0]|0);Ia=Qa-+(h[ra+(T*3|0)+2>>0]|0);La=+V(+-(Ra*(Ga*Ga+0.0+Pa*Pa+Ia*Ia)))*50.0;x=(f[F>>2]|0)+(Y(f[f[J>>2]>>2]|0,Ua)|0)+(R<<3)|0;p[x>>3]=La;if(ea){La=Ja-+(h[E+(T*3|0)>>0]|0);Ia=Fa-+(h[E+(T*3|0)+1>>0]|0);Pa=Qa-+(h[E+(T*3|0)+2>>0]|0);Ga=+V(+-(Ra*(La*La+0.0+Ia*Ia+Pa*Pa)))*35.35533966440824;x=(f[Va>>2]|0)+(Y(f[f[ia>>2]>>2]|0,Ua)|0)+(R<<3)|0;p[x>>3]=Ga;M=152;break}else{x=(f[Va>>2]|0)+(Y(f[f[ia>>2]>>2]|0,Ua)|0)+(R<<3)|0;p[x>>3]=0.0;M=151;break}}else{x=(f[F>>2]|0)+(Y(f[f[J>>2]>>2]|0,Ua)|0)+(R<<3)|0;p[x>>3]=0.0;x=(f[Va>>2]|0)+(Y(f[f[ia>>2]>>2]|0,Ua)|0)+(R<<3)|0;p[x>>3]=0.0;if(ea)M=152;else M=151}while(0);if((M|0)==151){M=0;T=(f[Xa>>2]|0)+(Y(f[f[na>>2]>>2]|0,Ua)|0)+(R<<3)|0;p[T>>3]=0.0;_a=0.0;$a=R+1|0}else if((M|0)==152){M=0;Ga=Ja-+(h[E+(R*3|0)>>0]|0);Pa=Fa-+(h[E+(R*3|0)+1>>0]|0);Ia=Qa-+(h[E+(R*3|0)+2>>0]|0);La=+V(+-(Ra*(Ga*Ga+0.0+Pa*Pa+Ia*Ia)))*50.0;T=(f[Xa>>2]|0)+(Y(f[f[na>>2]>>2]|0,Ua)|0)+(R<<3)|0;p[T>>3]=La;T=R+1|0;if((T|0)<(Ta|0)){La=Ja-+(h[E+(T*3|0)>>0]|0);Ia=Fa-+(h[E+(T*3|0)+1>>0]|0);Pa=Qa-+(h[E+(T*3|0)+2>>0]|0);_a=+V(+-(Ra*(La*La+0.0+Ia*Ia+Pa*Pa)))*35.35533966440824;$a=T}else{_a=0.0;$a=T}}T=(f[sa>>2]|0)+(Y(f[f[wa>>2]>>2]|0,Ua)|0)+(R<<3)|0;p[T>>3]=_a;if(($a|0)<(Ta|0))R=$a;else break}}Ua=Ua+1|0}while((Ua|0)!=(Ya|0))}b:do if((i|0)>0){Ya=A+44|0;Ua=a+16|0;$a=a+44|0;Ta=l+8|0;sa=l+16|0;Xa=D+16|0;Va=l+8|0;F=l+16|0;Wa=B+472|0;Sa=C+472|0;R=v+12|0;E=v+24|0;ea=v+4|0;ra=v+8|0;T=B+56|0;x=l+8|0;y=l+16|0;qa=C+56|0;Aa=l+8|0;ua=l+16|0;X=q+16|0;_=r+16|0;Ba=s+16|0;za=t+16|0;ya=a+8|0;va=a+12|0;Z=l+4|0;w=v+12|0;ta=v+16|0;ba=Za;ga=0;while(1){f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;f[v+16>>2]=0;f[v+20>>2]=0;f[v+24>>2]=0;f[v+28>>2]=0;if((ba|0)>0){fa=f[S>>2]|0;ha=ba;aa=0;while(1){if((fa|0)>0){$=0;do{ka=(f[g>>2]|0)+(Y(f[f[Ya>>2]>>2]|0,aa)|0)|0;_a=+(h[ka+($*3|0)>>0]|0);Ra=+(h[ka+($*3|0)+1>>0]|0);Pa=+(h[ka+($*3|0)+2>>0]|0);ka=(f[Ua>>2]|0)+(Y(f[f[$a>>2]>>2]|0,aa)|0)+$|0;switch(b[ka>>0]|0){case 2:case 0:{p[l>>3]=_a;p[Va>>3]=Ra;p[F>>3]=Pa;Ia=+mfa(B,0,l);La=Ia>0.0?Ia:0.0;p[l>>3]=_a;p[Va>>3]=Ra;p[F>>3]=Pa;Ia=+mfa(B,1,l);ka=Ia>La;Ga=ka?Ia:La;p[l>>3]=_a;p[Va>>3]=Ra;p[F>>3]=Pa;La=+mfa(B,2,l);la=La>Ga;Ia=la?La:Ga;p[l>>3]=_a;p[Va>>3]=Ra;p[F>>3]=Pa;Ga=+mfa(B,3,l);ab=Ga>Ia;p[l>>3]=_a;p[Va>>3]=Ra;p[F>>3]=Pa;La=+mfa(B,4,l);bb=La>(ab?Ga:Ia)?4:ab?3:la?2:ka&1;break}default:{p[l>>3]=_a;p[Ta>>3]=Ra;p[sa>>3]=Pa;Ia=+mfa(C,0,l);Ga=Ia>0.0?Ia:0.0;p[l>>3]=_a;p[Ta>>3]=Ra;p[sa>>3]=Pa;Ia=+mfa(C,1,l);ka=Ia>Ga;La=ka?Ia:Ga;p[l>>3]=_a;p[Ta>>3]=Ra;p[sa>>3]=Pa;Ga=+mfa(C,2,l);la=Ga>La;Ia=la?Ga:La;p[l>>3]=_a;p[Ta>>3]=Ra;p[sa>>3]=Pa;La=+mfa(C,3,l);ab=La>Ia;p[l>>3]=_a;p[Ta>>3]=Ra;p[sa>>3]=Pa;Pa=+mfa(C,4,l);bb=Pa>(ab?La:Ia)?4:ab?3:la?2:ka&1}}ka=(f[Xa>>2]|0)+(Y(f[f[G>>2]>>2]|0,aa)|0)+($<<2)|0;f[ka>>2]=bb;$=$+1|0;cb=f[S>>2]|0}while(($|0)<(cb|0));db=f[j>>2]|0;eb=cb}else{db=ha;eb=fa}aa=aa+1|0;if((aa|0)>=(db|0)){fb=db;break}else{fa=eb;ha=db}}}else fb=ba;F1a(Wa|0,0,504)|0;F1a(Sa|0,0,504)|0;ha=fb;fa=0;while(1){if((ha|0)>0){aa=C+472+(fa*24|0)|0;$=C+472+(fa*24|0)+8|0;ka=C+472+(fa*24|0)+16|0;la=C+592+(fa*72|0)|0;ab=C+592+(fa*72|0)+8|0;gb=C+592+(fa*72|0)+16|0;hb=C+592+(fa*72|0)+24|0;ib=C+592+(fa*72|0)+32|0;jb=C+592+(fa*72|0)+40|0;kb=C+592+(fa*72|0)+48|0;lb=C+592+(fa*72|0)+56|0;mb=B+472+(fa*24|0)|0;nb=B+472+(fa*24|0)+8|0;ob=B+472+(fa*24|0)+16|0;pb=B+592+(fa*72|0)|0;qb=B+592+(fa*72|0)+8|0;rb=B+592+(fa*72|0)+16|0;sb=B+592+(fa*72|0)+24|0;tb=B+592+(fa*72|0)+32|0;ub=B+592+(fa*72|0)+40|0;vb=B+592+(fa*72|0)+48|0;wb=B+592+(fa*72|0)+56|0;xb=f[S>>2]|0;yb=(xb|0)>0;zb=ha;Ab=0;while(1){if(yb){Bb=f[Xa>>2]|0;Cb=f[G>>2]|0;Db=0;while(1){Eb=Bb+(Y(f[Cb>>2]|0,Ab)|0)+(Db<<2)|0;if((f[Eb>>2]|0)==(fa|0)){Eb=(f[Ua>>2]|0)+(Y(f[f[$a>>2]>>2]|0,Ab)|0)+Db|0;switch(b[Eb>>0]|0){case 2:case 0:{Eb=(f[g>>2]|0)+(Y(f[f[Ya>>2]>>2]|0,Ab)|0)|0;Qa=+(h[Eb+(Db*3|0)>>0]|0);Fa=+(h[Eb+(Db*3|0)+1>>0]|0);Ja=+(h[Eb+(Db*3|0)+2>>0]|0);p[mb>>3]=Qa+ +p[mb>>3];p[nb>>3]=Fa+ +p[nb>>3];p[ob>>3]=Ja+ +p[ob>>3];p[pb>>3]=Qa*Qa+ +p[pb>>3];Ia=Qa*Fa;p[qb>>3]=Ia+ +p[qb>>3];La=Qa*Ja;p[rb>>3]=La+ +p[rb>>3];p[sb>>3]=Ia+ +p[sb>>3];p[tb>>3]=Fa*Fa+ +p[tb>>3];Ia=Fa*Ja;p[ub>>3]=Ia+ +p[ub>>3];p[vb>>3]=La+ +p[vb>>3];p[wb>>3]=Ia+ +p[wb>>3];Fb=B;Gb=Ja*Ja;break}default:{Eb=(f[g>>2]|0)+(Y(f[f[Ya>>2]>>2]|0,Ab)|0)|0;Ja=+(h[Eb+(Db*3|0)>>0]|0);Ia=+(h[Eb+(Db*3|0)+1>>0]|0);La=+(h[Eb+(Db*3|0)+2>>0]|0);p[aa>>3]=Ja+ +p[aa>>3];p[$>>3]=Ia+ +p[$>>3];p[ka>>3]=La+ +p[ka>>3];p[la>>3]=Ja*Ja+ +p[la>>3];Fa=Ja*Ia;p[ab>>3]=Fa+ +p[ab>>3];Qa=Ja*La;p[gb>>3]=Qa+ +p[gb>>3];p[hb>>3]=Fa+ +p[hb>>3];p[ib>>3]=Ia*Ia+ +p[ib>>3];Fa=Ia*La;p[jb>>3]=Fa+ +p[jb>>3];p[kb>>3]=Qa+ +p[kb>>3];p[lb>>3]=Fa+ +p[lb>>3];Fb=C;Gb=La*La}}Eb=Fb+592+(fa*72|0)+64|0;p[Eb>>3]=Gb+ +p[Eb>>3];Eb=Fb+952+(fa<<2)|0;f[Eb>>2]=(f[Eb>>2]|0)+1;Eb=Fb+972|0;f[Eb>>2]=(f[Eb>>2]|0)+1}Db=Db+1|0;if((Db|0)>=(xb|0)){Hb=fb;break}}}else Hb=zb;Ab=Ab+1|0;if((Ab|0)>=(Hb|0)){Ib=Hb;break}else zb=Hb}}else Ib=ha;fa=fa+1|0;if((fa|0)==5)break;else ha=Ib}nfa(B);nfa(C);ha=f[S>>2]|0;fa=f[j>>2]|0;rfa(v,Y(fa,ha)|0);sfa(R,((Y(fa+ha|0,-3)|0)+(Y(ha<<2,fa)|0)<<1)+6|0);p[E>>3]=0.0;fa=f[j>>2]|0;if((fa|0)>0){ha=f[S>>2]|0;zb=fa;fa=0;while(1){if((ha|0)>0){Ab=(fa|0)>0;xb=0;do{N=l;P=N+40|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));lb=f[ea>>2]|0;if((lb|0)==(f[ra>>2]|0)){tfa(v,l);Jb=f[ea>>2]|0}else{N=lb;O=l;P=N+40|0;do{f[N>>2]=f[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(P|0));kb=lb+40|0;f[ea>>2]=kb;Jb=kb}kb=(Jb-(f[v>>2]|0)|0)/40|0;jb=kb+-1|0;ib=(f[g>>2]|0)+(Y(f[f[Ya>>2]>>2]|0,fa)|0)|0;hb=(f[Ua>>2]|0)+(Y(f[f[$a>>2]>>2]|0,fa)|0)+xb|0;gb=b[hb>>0]|0;if((gb&-2)<<24>>24==2){La=+(h[ib+(xb*3|0)>>0]|0);Fa=+(h[ib+(xb*3|0)+1>>0]|0);Qa=+(h[ib+(xb*3|0)+2>>0]|0);Ia=+p[f[T>>2]>>3];p[l>>3]=La;p[x>>3]=Fa;p[y>>3]=Qa;Ja=+mfa(B,0,l);Pa=+p[(f[T>>2]|0)+8>>3];p[l>>3]=La;p[x>>3]=Fa;p[y>>3]=Qa;Ra=+mfa(B,1,l);_a=+p[(f[T>>2]|0)+16>>3];p[l>>3]=La;p[x>>3]=Fa;p[y>>3]=Qa;Ga=+mfa(B,2,l);Da=+p[(f[T>>2]|0)+24>>3];p[l>>3]=La;p[x>>3]=Fa;p[y>>3]=Qa;Ca=+mfa(B,3,l);Ma=+p[(f[T>>2]|0)+32>>3];p[l>>3]=La;p[x>>3]=Fa;p[y>>3]=Qa;Ea=-+W(+(Ia*Ja+0.0+Pa*Ra+_a*Ga+Da*Ca+Ma*+mfa(B,4,l)));Ma=+p[f[qa>>2]>>3];p[l>>3]=La;p[Aa>>3]=Fa;p[ua>>3]=Qa;Ca=+mfa(C,0,l);Da=+p[(f[qa>>2]|0)+8>>3];p[l>>3]=La;p[Aa>>3]=Fa;p[ua>>3]=Qa;Ga=+mfa(C,1,l);_a=+p[(f[qa>>2]|0)+16>>3];p[l>>3]=La;p[Aa>>3]=Fa;p[ua>>3]=Qa;Ra=+mfa(C,2,l);Pa=+p[(f[qa>>2]|0)+24>>3];p[l>>3]=La;p[Aa>>3]=Fa;p[ua>>3]=Qa;Ja=+mfa(C,3,l);Ia=+p[(f[qa>>2]|0)+32>>3];p[l>>3]=La;p[Aa>>3]=Fa;p[ua>>3]=Qa;Kb=Ea;Lb=-+W(+(Ma*Ca+0.0+Da*Ga+_a*Ra+Pa*Ja+Ia*+mfa(C,4,l)))}else{ib=gb<<24>>24==0;Kb=ib?0.0:450.0;Lb=ib?450.0:0.0}ufa(v,jb,Kb,Lb);do if((xb|0)<=0){if(Ab)M=198}else{ib=(f[X>>2]|0)+(Y(f[f[J>>2]>>2]|0,fa)|0)+(xb<<3)|0;Ia=+p[ib>>3];ib=kb+-2|0;vfa(v,jb,ib,Ia,Ia);if(!Ab)break;gb=(f[_>>2]|0)+(Y(f[f[ia>>2]>>2]|0,fa)|0)+(xb<<3)|0;Ia=+p[gb>>3];vfa(v,jb,ib-(f[S>>2]|0)|0,Ia,Ia);M=198}while(0);do if((M|0)==198){M=0;lb=(f[Ba>>2]|0)+(Y(f[f[na>>2]>>2]|0,fa)|0)+(xb<<3)|0;Ia=+p[lb>>3];vfa(v,jb,jb-(f[S>>2]|0)|0,Ia,Ia);lb=f[S>>2]|0;if((xb|0)>=(lb+-1|0))break;ib=(f[za>>2]|0)+(Y(f[f[wa>>2]>>2]|0,fa)|0)+(xb<<3)|0;Ia=+p[ib>>3];vfa(v,jb,kb-lb|0,Ia,Ia)}while(0);xb=xb+1|0;Mb=f[S>>2]|0}while((xb|0)<(Mb|0));Nb=f[j>>2]|0;Ob=Mb}else{Nb=zb;Ob=ha}fa=fa+1|0;if((fa|0)>=(Nb|0))break;else{ha=Ob;zb=Nb}}}+wfa(v);zb=f[ya>>2]|0;if((zb|0)>0){ha=f[va>>2]|0;fa=zb;zb=0;while(1){if((ha|0)>0){xb=ha;Ab=0;while(1){kb=f[Ua>>2]|0;jb=f[f[$a>>2]>>2]|0;lb=kb+(Y(jb,zb)|0)+Ab|0;if((b[lb>>0]&-2)<<24>>24==2){lb=(Y(xb,zb)|0)+Ab|0;do if((lb|0)>-1){ib=f[v>>2]|0;if((((f[ea>>2]|0)-ib|0)/40|0|0)<=(lb|0)){M=210;break}Pb=ib;Qb=jb;Rb=kb}else M=210;while(0);if((M|0)==210){M=0;f[l>>2]=0;f[Z>>2]=0;N=c$(l,26)|0;O=235575;P=N+26|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));j$(-215,l,235602,235618,381);d$(l);Pb=f[v>>2]|0;Qb=f[f[$a>>2]>>2]|0;Rb=f[Ua>>2]|0}kb=(b[Pb+(lb*40|0)+32>>0]|0)==0;jb=kb?m:o;f[jb>>2]=Ab;f[jb+4>>2]=zb;jb=Rb+(Y(Qb,zb)|0)+Ab|0;b[jb>>0]=kb?3:2;Sb=f[va>>2]|0}else Sb=xb;Ab=Ab+1|0;if((Ab|0)>=(Sb|0))break;else xb=Sb}Tb=f[ya>>2]|0;Ub=Sb}else{Tb=fa;Ub=ha}zb=zb+1|0;if((zb|0)>=(Tb|0))break;else{ha=Ub;fa=Tb}}}fa=f[w>>2]|0;if(fa|0){ha=f[ta>>2]|0;if((ha|0)!=(fa|0))f[ta>>2]=ha+(~((ha+-16-fa|0)>>>4)<<4);PYa(fa)}fa=f[v>>2]|0;if(fa|0){ha=f[ea>>2]|0;if((ha|0)!=(fa|0))f[ea>>2]=ha+(~(((ha+-40-fa|0)>>>0)/40|0)*40|0);PYa(fa)}fa=ga+1|0;if((fa|0)>=(i|0))break b;ba=f[j>>2]|0;ga=fa}}while(0);j=t+36|0;i=f[j>>2]|0;if(i|0?(v=i+12|0,i=f[v>>2]|0,f[v>>2]=i+-1,(i|0)==1):0)CR(t);f[j>>2]=0;j=t+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[pa>>2]|0)>0){j=f[oa>>2]|0;oa=0;do{f[j+(oa<<2)>>2]=0;oa=oa+1|0}while((oa|0)<(f[pa>>2]|0))}pa=f[wa>>2]|0;if((pa|0)!=(xa|0))ZF(pa);pa=s+36|0;xa=f[pa>>2]|0;if(xa|0?(wa=xa+12|0,xa=f[wa>>2]|0,f[wa>>2]=xa+-1,(xa|0)==1):0)CR(s);f[pa>>2]=0;pa=s+16|0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[d>>2]|0)>0){pa=f[da>>2]|0;da=0;do{f[pa+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[d>>2]|0))}d=f[na>>2]|0;if((d|0)!=(ja|0))ZF(d);d=r+36|0;ja=f[d>>2]|0;do if(ja|0){na=ja+12|0;da=f[na>>2]|0;f[na>>2]=da+-1;if((da|0)!=1)break;CR(r)}while(0);f[d>>2]=0;d=r+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[L>>2]|0)>0){d=f[U>>2]|0;U=0;do{f[d+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[L>>2]|0))}L=f[ia>>2]|0;if((L|0)!=(ca|0))ZF(L);L=q+36|0;ca=f[L>>2]|0;do if(ca|0){ia=ca+12|0;U=f[ia>>2]|0;f[ia>>2]=U+-1;if((U|0)!=1)break;CR(q)}while(0);f[L>>2]=0;L=q+16|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[K>>2]|0)>0){L=f[Q>>2]|0;Q=0;do{f[L+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[K>>2]|0))}K=f[J>>2]|0;if((K|0)!=(Ha|0))ZF(K)}K=D+36|0;Ha=f[K>>2]|0;if(Ha|0?(J=Ha+12|0,Ha=f[J>>2]|0,f[J>>2]=Ha+-1,(Ha|0)==1):0)CR(D);f[K>>2]=0;K=D+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[c>>2]|0)>0){K=f[H>>2]|0;H=0;do{f[K+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[c>>2]|0))}c=f[G>>2]|0;if((c|0)!=(I|0))ZF(c);c=C+36|0;I=f[c>>2]|0;if(I|0?(G=I+12|0,I=f[G>>2]|0,f[G>>2]=I+-1,(I|0)==1):0)CR(C);f[c>>2]=0;c=C+16|0;I=C+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[I>>2]|0)>0){c=f[C+40>>2]|0;G=0;do{f[c+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[I>>2]|0))}I=f[C+44>>2]|0;if((I|0)!=(C+48|0))ZF(I);I=B+36|0;C=f[I>>2]|0;if(C|0?(G=C+12|0,C=f[G>>2]|0,f[G>>2]=C+-1,(C|0)==1):0)CR(B);f[I>>2]=0;I=B+16|0;C=B+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[C>>2]|0)>0){I=f[B+40>>2]|0;G=0;do{f[I+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[C>>2]|0))}C=f[B+44>>2]|0;if((C|0)!=(B+48|0))ZF(C);C=A+36|0;B=f[C>>2]|0;if(B|0?(G=B+12|0,B=f[G>>2]|0,f[G>>2]=B+-1,(B|0)==1):0)CR(A);f[C>>2]=0;C=A+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[C>>2]|0)>0){g=f[e>>2]|0;e=0;do{f[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[C>>2]|0))}C=f[A+44>>2]|0;if((C|0)!=(A+48|0))ZF(C);if(!(f[z+4>>2]|0)){u=k;return}u=k;return}function pfa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+16|0;e=d;g=c+16|0;if(f[g>>2]|0){i=f[c+4>>2]|0;if((i|0)<3)j=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{k=f[c+40>>2]|0;l=0;m=1;while(1){n=Y(f[k+(l<<2)>>2]|0,m)|0;l=l+1|0;if((l|0)==(i|0)){j=n;break}else m=n}}if((i|0)==0|(j|0)==0)o=7}else o=7;if((o|0)==7){f[e>>2]=0;f[e+4>>2]=0;p=c$(e,13)|0;q=235766;r=p+13|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-5,e,235780,235293,326);d$(e)}if(f[c>>2]&4095|0){f[e>>2]=0;f[e+4>>2]=0;p=c$(e,27)|0;q=235790;r=p+27|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-5,e,235780,235293,328);d$(e)}o=c+12|0;if((f[o>>2]|0)==(f[a+12>>2]|0)?(j=c+8|0,i=f[j>>2]|0,(i|0)==(f[a+8>>2]|0)):0){s=i;t=j}else{f[e>>2]=0;f[e+4>>2]=0;p=c$(e,43)|0;q=235818;r=p+43|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-5,e,235780,235293,330);d$(e);j=c+8|0;s=f[j>>2]|0;t=j}if((s|0)<=0){u=d;return}s=c+44|0;c=e+4|0;j=f[o>>2]|0;i=0;while(1){if((j|0)>0){a=j;m=0;while(1){l=(f[g>>2]|0)+(Y(f[f[s>>2]>>2]|0,i)|0)+m|0;if((h[l>>0]|0)<4)v=a;else{f[e>>2]=0;f[c>>2]=0;p=c$(e,75)|0;q=235862;r=p+75|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-5,e,235780,235293,338);d$(e);v=f[o>>2]|0}m=m+1|0;if((m|0)>=(v|0)){w=v;break}else a=v}}else w=j;i=i+1|0;if((i|0)>=(f[t>>2]|0))break;else j=w}u=d;return}function qfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/12|0;h=g+1|0;i=e;j=d;if(h>>>0>357913941)gXa(a);d=a+8|0;k=((f[d>>2]|0)-e|0)/12|0;l=k<<1;m=k>>>0<178956970?(l>>>0<h>>>0?h:l):357913941;do if(m)if(m>>>0>357913941){l=De(8)|0;UYa(l,358155);f[l>>2]=130560;Of(l|0,21520,875)}else{n=NYa(m*12|0)|0;break}else n=0;while(0);l=n+(g*12|0)|0;h=n+(m*12|0)|0;f[l>>2]=f[b>>2];f[n+(g*12|0)+4>>2]=f[b+4>>2];f[n+(g*12|0)+8>>2]=f[b+8>>2];b=l+12|0;if((j|0)==(i|0))o=l;else{g=l;l=j;while(1){j=g+-12|0;n=l;l=l+-12|0;f[j>>2]=f[l>>2];f[g+-8>>2]=f[n+-8>>2];f[g+-4>>2]=f[n+-4>>2];if((l|0)==(i|0)){o=j;break}else g=j}}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;PYa(e);return}function rfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+8|0;d=f[a>>2]|0;if((((f[c>>2]|0)-d|0)/40|0)>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>107374182){g=De(8)|0;UYa(g,358155);f[g>>2]=130560;Of(g|0,21520,875)}g=(f[e>>2]|0)-d|0;h=NYa(b*40|0)|0;i=h+(((g|0)/40|0)*40|0)|0;j=i+(((g|0)/-40|0)*40|0)|0;if((g|0)>0)K1a(j|0,d|0,g|0)|0;f[a>>2]=j;f[e>>2]=i;f[c>>2]=h+(b*40|0);if(!d)return;PYa(d);return}function sfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>4>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>268435455){g=De(8)|0;UYa(g,358155);f[g>>2]=130560;Of(g|0,21520,875)}g=(f[e>>2]|0)-d|0;h=g>>4;i=NYa(b<<4)|0;j=i+(h<<4)|0;k=j+(0-h<<4)|0;if((g|0)>0)K1a(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<4);if(!d)return;PYa(d);return}function tfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=(e|0)/40|0;h=g+1|0;if(h>>>0>107374182)gXa(a);i=a+8|0;j=((f[i>>2]|0)-d|0)/40|0;k=j<<1;l=j>>>0<53687091?(k>>>0<h>>>0?h:k):107374182;do if(l)if(l>>>0>107374182){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l*40|0)|0;break}else m=0;while(0);k=m+(g*40|0)|0;g=m+(l*40|0)|0;l=k;m=b;b=l+40|0;do{f[l>>2]=f[m>>2];l=l+4|0;m=m+4|0}while((l|0)<(b|0));m=k+(((e|0)/-40|0)*40|0)|0;if((e|0)>0)K1a(m|0,d|0,e|0)|0;f[a>>2]=m;f[c>>2]=k+40;f[i>>2]=g;if(!d)return;PYa(d);return}function ufa(a,c,d,e){a=a|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0;g=u;u=u+16|0;h=g;if((c|0)>-1?(i=f[a>>2]|0,(((f[a+4>>2]|0)-i|0)/40|0|0)>(c|0)):0)j=i;else{f[h>>2]=0;f[h+4>>2]=0;i=c$(h,26)|0;k=235575;l=i+26|0;do{b[i>>0]=b[k>>0]|0;i=i+1|0;k=k+1|0}while((i|0)<(l|0));j$(-215,h,235751,235618,141);d$(h);j=f[a>>2]|0}m=+p[j+(c*40|0)+24>>3];h=m>0.0;n=h?e:e-m;e=h?m+d:d;h=a+24|0;p[h>>3]=+p[h>>3]+(e<n?e:n);p[j+(c*40|0)+24>>3]=e-n;u=g;return}function vfa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=+e;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;h=u;u=u+32|0;i=h+16|0;j=h;if(!((c|0)>-1?(((f[a+4>>2]|0)-(f[a>>2]|0)|0)/40|0|0)>(c|0):0)){f[i>>2]=0;f[i+4>>2]=0;k=c$(i,26)|0;l=235575;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,i,235692,235618,116);d$(i)}if(!((d|0)>-1?(((f[a+4>>2]|0)-(f[a>>2]|0)|0)/40|0|0)>(d|0):0)){f[i>>2]=0;f[i+4>>2]=0;k=c$(i,26)|0;l=235701;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,i,235692,235618,117);d$(i)}if(!(e>=0.0&g>=0.0)){f[i>>2]=0;f[i+4>>2]=0;k=c$(i,15)|0;l=235728;m=k+15|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,i,235692,235618,118);d$(i)}if((c|0)==(d|0)){f[i>>2]=0;f[i+4>>2]=0;l=c$(i,6)|0;b[l>>0]=b[235744]|0;b[l+1>>0]=b[235745]|0;b[l+2>>0]=b[235746]|0;b[l+3>>0]=b[235747]|0;b[l+4>>0]=b[235748]|0;b[l+5>>0]=b[235749]|0;j$(-215,i,235692,235618,119);d$(i)}l=a+12|0;k=a+16|0;m=f[k>>2]|0;n=f[l>>2]|0;if((m|0)==(n|0)){yfa(l,2);o=f[k>>2]|0;q=f[l>>2]|0}else{o=m;q=n}f[i>>2]=d;n=(f[a>>2]|0)+(c*40|0)+8|0;f[i+4>>2]=f[n>>2];p[i+8>>3]=e;f[n>>2]=o-q>>4;q=a+20|0;if((o|0)==(f[q>>2]|0)){zfa(l,i);n=f[k>>2]|0;r=n;s=n}else{n=o;f[n>>2]=f[i>>2];f[n+4>>2]=f[i+4>>2];f[n+8>>2]=f[i+8>>2];f[n+12>>2]=f[i+12>>2];i=(f[k>>2]|0)+16|0;f[k>>2]=i;r=i;s=i}f[j>>2]=c;c=(f[a>>2]|0)+(d*40|0)+8|0;f[j+4>>2]=f[c>>2];p[j+8>>3]=g;f[c>>2]=r-(f[l>>2]|0)>>4;if((s|0)==(f[q>>2]|0)){zfa(l,j);u=h;return}else{f[s>>2]=f[j>>2];f[s+4>>2]=f[j+4>>2];f[s+8>>2]=f[j+8>>2];f[s+12>>2]=f[j+12>>2];f[k>>2]=(f[k>>2]|0)+16;u=h;return}}function wfa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0;c=u;u=u+80|0;d=c;e=c+56|0;g=c+52|0;h=c+48|0;i=c+40|0;f[d>>2]=d;j=f[a>>2]|0;k=f[a+12>>2]|0;f[e>>2]=0;l=e+4|0;f[l>>2]=0;f[e+8>>2]=0;m=(f[a+4>>2]|0)-j|0;if((m|0)>0){n=(m>>>0)/40|0;m=0;o=d;while(1){q=j+(m*40|0)|0;f[j+(m*40|0)+12>>2]=0;r=+p[j+(m*40|0)+24>>3];if(r!=0.0){f[o>>2]=q;f[j+(m*40|0)+16>>2]=1;b[j+(m*40|0)+32>>0]=r<0.0&1;s=-1;t=q}else{s=0;t=o}f[j+(m*40|0)+4>>2]=s;m=m+1|0;if((m|0)>=(n|0))break;else o=t}v=f[d>>2]|0;w=t}else{v=d;w=d}f[w>>2]=d;f[d>>2]=0;t=i+4|0;o=i+4|0;n=i+4|0;m=a+24|0;a=e+8|0;a:do if((v|0)==(d|0))x=0;else{s=0;q=0;y=v;z=w;while(1){A=-1;B=y;C=z;while(1){f[g>>2]=B;if(!(f[B+4>>2]|0)){D=B;E=A;F=C}else{G=b[B+32>>0]|0;H=f[B+8>>2]|0;b:do if(!H){I=A;J=C}else{K=G&255;M=H;N=C;while(1){O=M^K;do if(!(+p[k+(O<<4)+8>>3]==0.0)){P=f[k+(M<<4)>>2]|0;Q=j+(P*40|0)|0;f[h>>2]=Q;R=j+(P*40|0)+4|0;S=j+(P*40|0)+32|0;if(!(f[R>>2]|0)){b[S>>0]=G;f[j+(P*40|0)+4>>2]=M^1;T=f[g>>2]|0;f[j+(P*40|0)+12>>2]=f[T+12>>2];f[j+(P*40|0)+16>>2]=(f[T+16>>2]|0)+1;if(f[Q>>2]|0){U=N;break}f[Q>>2]=d;Q=f[h>>2]|0;f[N>>2]=Q;U=Q;break}if((b[S>>0]|0)!=G<<24>>24){I=O;J=N;break b}S=f[g>>2]|0;Q=(f[S+16>>2]|0)+1|0;if((f[j+(P*40|0)+16>>2]|0)>(Q|0)?(T=f[S+12>>2]|0,(f[j+(P*40|0)+12>>2]|0)<=(T|0)):0){f[R>>2]=M^1;f[j+(P*40|0)+12>>2]=T;f[j+(P*40|0)+16>>2]=Q;U=N}else U=N}else U=N;while(0);M=f[k+(M<<4)+4>>2]|0;if(!M){I=A;J=U;break}else N=U}}while(0);if((I|0)>0){V=I;W=B;X=J;break}D=f[g>>2]|0;E=I;F=J}B=f[B>>2]|0;f[D>>2]=0;if((B|0)==(d|0)){Y=24;break}else{A=E;C=F}}if((Y|0)==24){Y=0;if((E|0)<1){x=s;break a}else{V=E;W=d;X=F}}C=k+(V<<4)+8|0;r=+p[C>>3];if(!(r>0.0)){f[i>>2]=0;f[t>>2]=0;Z=c$(i,13)|0;_=235670;$=Z+13|0;do{b[Z>>0]=b[_>>0]|0;Z=Z+1|0;_=_+1|0}while((Z|0)<($|0));j$(-215,i,235684,235618,244);d$(i)}A=V^1;B=k+(A<<4)|0;G=f[B>>2]|0;f[g>>2]=j+(G*40|0);H=f[j+(G*40|0)+4>>2]|0;if((H|0)<0){aa=G;ba=r}else{G=H;ca=r;while(1){da=+p[k+((G^1)<<4)+8>>3];ea=ca>da?da:ca;if(!(ea>0.0)){f[i>>2]=0;f[n>>2]=0;Z=c$(i,13)|0;_=235670;$=Z+13|0;do{b[Z>>0]=b[_>>0]|0;Z=Z+1|0;_=_+1|0}while((Z|0)<($|0));j$(-215,i,235684,235618,254);d$(i)}H=f[k+(G<<4)>>2]|0;f[g>>2]=j+(H*40|0);G=f[j+(H*40|0)+4>>2]|0;if((G|0)<0){aa=H;ba=ea;break}else ca=ea}}ca=+L(+(+p[j+(aa*40|0)+24>>3]));r=ba>ca?ca:ba;if(!(r>0.0)){f[i>>2]=0;f[o>>2]=0;Z=c$(i,13)|0;_=235670;$=Z+13|0;do{b[Z>>0]=b[_>>0]|0;Z=Z+1|0;_=_+1|0}while((Z|0)<($|0));j$(-215,i,235684,235618,258);d$(i)}G=k+(V<<4)|0;H=f[G>>2]|0;f[g>>2]=j+(H*40|0);N=f[j+(H*40|0)+4>>2]|0;if((N|0)<0){fa=H;ga=r}else{H=N;ca=r;while(1){da=+p[k+(H<<4)+8>>3];ha=ca>da?da:ca;if(!(ha>0.0)){f[i>>2]=0;f[n>>2]=0;Z=c$(i,13)|0;_=235670;$=Z+13|0;do{b[Z>>0]=b[_>>0]|0;Z=Z+1|0;_=_+1|0}while((Z|0)<($|0));j$(-215,i,235684,235618,254);d$(i)}N=f[k+(H<<4)>>2]|0;f[g>>2]=j+(N*40|0);H=f[j+(N*40|0)+4>>2]|0;if((H|0)<0){fa=N;ga=ha;break}else ca=ha}}ca=+L(+(+p[j+(fa*40|0)+24>>3]));r=ga>ca?ca:ga;if(!(r>0.0)){f[i>>2]=0;f[o>>2]=0;Z=c$(i,13)|0;_=235670;$=Z+13|0;do{b[Z>>0]=b[_>>0]|0;Z=Z+1|0;_=_+1|0}while((Z|0)<($|0));j$(-215,i,235684,235618,258);d$(i)}p[C>>3]=+p[C>>3]-r;H=k+(A<<4)+8|0;p[H>>3]=r+ +p[H>>3];p[m>>3]=r+ +p[m>>3];H=f[B>>2]|0;N=j+(H*40|0)|0;f[g>>2]=N;M=f[j+(H*40|0)+4>>2]|0;K=N;if((M|0)<0){ia=H;ja=K}else{H=M;M=K;while(1){K=k+(H<<4)+8|0;p[K>>3]=r+ +p[K>>3];K=k+((H^1)<<4)+8|0;ca=+p[K>>3]-r;p[K>>3]=ca;if(ca==0.0){K=f[l>>2]|0;if((K|0)==(f[a>>2]|0))xfa(e,g);else{f[K>>2]=M;f[l>>2]=(f[l>>2]|0)+4}f[(f[g>>2]|0)+4>>2]=-2}K=f[k+(H<<4)>>2]|0;N=j+(K*40|0)|0;f[g>>2]=N;H=f[j+(K*40|0)+4>>2]|0;O=N;if((H|0)<0){ia=K;ja=O;break}else M=O}}M=j+(ia*40|0)+24|0;ca=+p[M>>3]-r;p[M>>3]=ca;if(ca==0.0){M=f[l>>2]|0;if((M|0)==(f[a>>2]|0))xfa(e,g);else{f[M>>2]=ja;f[l>>2]=(f[l>>2]|0)+4}f[(f[g>>2]|0)+4>>2]=-2}M=f[G>>2]|0;H=j+(M*40|0)|0;f[g>>2]=H;B=f[j+(M*40|0)+4>>2]|0;A=H;if((B|0)<0){ka=M;la=A}else{M=B;B=A;while(1){A=k+((M^1)<<4)+8|0;p[A>>3]=r+ +p[A>>3];A=k+(M<<4)+8|0;ca=+p[A>>3]-r;p[A>>3]=ca;if(ca==0.0){A=f[l>>2]|0;if((A|0)==(f[a>>2]|0))xfa(e,g);else{f[A>>2]=B;f[l>>2]=(f[l>>2]|0)+4}f[(f[g>>2]|0)+4>>2]=-2}A=f[k+(M<<4)>>2]|0;H=j+(A*40|0)|0;f[g>>2]=H;M=f[j+(A*40|0)+4>>2]|0;C=H;if((M|0)<0){ka=A;la=C;break}else B=C}}B=j+(ka*40|0)+24|0;ca=r+ +p[B>>3];p[B>>3]=ca;if(ca==0.0){B=f[l>>2]|0;if((B|0)==(f[a>>2]|0))xfa(e,g);else{f[B>>2]=la;f[l>>2]=(f[l>>2]|0)+4}f[(f[g>>2]|0)+4>>2]=-2}q=q+1|0;B=f[e>>2]|0;M=f[l>>2]|0;c:do if((B|0)==(M|0)){ma=B;na=X}else{G=M;C=B;A=X;while(1){H=G;while(1){H=H+-4|0;oa=f[H>>2]|0;f[l>>2]=H;pa=b[oa+32>>0]|0;qa=oa+8|0;O=f[qa>>2]|0;if(!O){Y=51;break}K=(pa^1)&255;N=0;Q=O;O=2147483647;while(1){d:do if(+p[k+((Q^K)<<4)+8>>3]==0.0){ra=N;sa=O}else{P=f[k+(Q<<4)>>2]|0;T=j+(P*40|0)|0;f[h>>2]=T;if((b[j+(P*40|0)+32>>0]|0)!=pa<<24>>24){ra=N;sa=O;break}if(!(f[j+(P*40|0)+4>>2]|0)){ra=N;sa=O;break}R=j+(P*40|0)+12|0;e:do if((f[R>>2]|0)==(q|0)){ta=P;ua=0;Y=57}else{S=T;va=0;wa=R;while(1){xa=f[S+4>>2]|0;ya=va+1|0;if((xa|0)<0)break;za=f[k+(xa<<4)>>2]|0;Aa=j+(za*40|0)|0;f[h>>2]=Aa;Ba=j+(za*40|0)+12|0;if((f[Ba>>2]|0)==(q|0)){ta=za;ua=ya;Y=57;break e}else{S=Aa;va=ya;wa=Ba}}if((xa|0)==-2){ra=N;sa=O;break d}f[wa>>2]=q;f[S+16>>2]=1;Ca=ya}while(0);if((Y|0)==57){Y=0;Ca=(f[j+(ta*40|0)+16>>2]|0)+ua|0}R=Ca+1|0;if((R|0)==2147483647){ra=N;sa=O;break}va=(R|0)<(O|0);Ba=va?Q:N;Aa=va?R:O;f[h>>2]=T;va=j+(P*40|0)+12|0;if((f[va>>2]|0)==(q|0)){ra=Ba;sa=Aa;break}else{Da=P;Ea=R;Fa=va}do{f[Fa>>2]=q;Ea=Ea+-1|0;f[j+(Da*40|0)+16>>2]=Ea;Da=f[k+(f[j+(Da*40|0)+4>>2]<<4)>>2]|0;Fa=j+(Da*40|0)+12|0}while((f[Fa>>2]|0)!=(q|0));f[h>>2]=j+(Da*40|0);ra=Ba;sa=Aa}while(0);Q=f[k+(Q<<4)+4>>2]|0;if(!Q)break;else{N=ra;O=sa}}f[oa+4>>2]=ra;O=oa+12|0;if((ra|0)<=0){Ga=O;break}f[O>>2]=q;f[oa+16>>2]=sa;if((C|0)==(H|0)){ma=C;na=A;break c}}if((Y|0)==51){Y=0;f[oa+4>>2]=0;Ga=oa+12|0}f[Ga>>2]=0;O=f[qa>>2]|0;if(!O){Ha=H;Ia=A}else{N=(pa^1)&255;Q=O;O=A;while(1){K=f[k+(Q<<4)>>2]|0;P=j+(K*40|0)|0;f[h>>2]=P;T=f[j+(K*40|0)+4>>2]|0;do if(T|0?(b[j+(K*40|0)+32>>0]|0)==pa<<24>>24:0){do if(+p[k+((Q^N)<<4)+8>>3]!=0.0){if(f[P>>2]|0){Ja=O;break}f[P>>2]=d;va=f[h>>2]|0;f[O>>2]=va;Ja=va}else Ja=O;while(0);if((T|0)<=0){Ka=Ja;break}if((j+((f[k+(T<<4)>>2]|0)*40|0)|0)!=(oa|0)){Ka=Ja;break}va=f[l>>2]|0;if((va|0)==(f[a>>2]|0))xfa(e,h);else{f[va>>2]=f[h>>2];f[l>>2]=(f[l>>2]|0)+4}f[(f[h>>2]|0)+4>>2]=-2;Ka=Ja}else Ka=O;while(0);Q=f[k+(Q<<4)+4>>2]|0;if(!Q)break;else O=Ka}Ha=f[l>>2]|0;Ia=Ka}C=f[e>>2]|0;if((C|0)==(Ha|0)){ma=Ha;na=Ia;break}else{G=Ha;A=Ia}}}while(0);if((W|0)==(d|0)){x=ma;break}else{s=ma;y=W;z=na}}}while(0);ga=+p[m>>3];if(!x){u=c;return +ga}m=f[l>>2]|0;if((m|0)!=(x|0))f[l>>2]=m+(~((m+-4-x|0)>>>2)<<2);PYa(x);u=c;return +ga}function xfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)gXa(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;PYa(d);return}function yfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>4>>>0>=b>>>0){h=g;i=b;do{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;h=(f[e>>2]|0)+16|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=g-i>>4;g=h+b|0;if(g>>>0>268435455)gXa(a);j=d-i|0;i=j>>3;d=j>>4>>>0<134217727?(i>>>0<g>>>0?g:i):268435455;do if(d)if(d>>>0>268435455){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{k=NYa(d<<4)|0;break}else k=0;while(0);i=k+(h<<4)|0;h=k+(d<<4)|0;d=i;k=b;b=i;do{f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;d=b+16|0;b=d;k=k+-1|0}while((k|0)!=0);k=f[a>>2]|0;d=(f[e>>2]|0)-k|0;g=i+(0-(d>>4)<<4)|0;if((d|0)>0)K1a(g|0,k|0,d|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=h;if(!k)return;PYa(k);return}function zfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)gXa(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;PYa(d);return}function Afa(){RX(1628972,311720,228,955,160,155,229);Fd(946,1628972,x|0)|0;return}function Bfa(a){a=a|0;var b=0;if((a|0)!=0?(f[a>>2]&-65536|0)==1111818240:0)b=(f[a+4>>2]|0)!=0;else b=0;return b&1|0}function Cfa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;j$(-27,d,312214,311778,2903);d$(d)}e=f[a>>2]|0;if(!e){u=c;return}if((f[e>>2]&-65536|0)==1111818240?(g=e+4|0,(f[g>>2]|0)!=0):0)h=g;else{f[d>>2]=0;f[d+4>>2]=0;g=c$(d,24)|0;i=311899;j=g+24|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));j$(-5,d,312214,311778,2910);d$(d);h=e+4|0}f[a>>2]=0;a=f[h>>2]|0;if((a|0)!=0?(f[a>>2]&-65536|0)==1111752704:0)I0(h);else{L0(a);f[h>>2]=0}h=e+264|0;a=f[h>>2]|0;if(a|0){$F(a);f[h>>2]=0}$F(e);u=c;return}function Dfa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+272|0;e=d+136|0;g=d+8|0;h=d;i=_F(544)|0;j=CX(a,c,312091)|0;a:do if(!j)k=0;else switch(f[j>>2]&7){case 1:{k=f[j+8>>2]|0;break a;break}case 2:{k=rNa(+p[j+8>>3])|0;break a;break}default:{k=2147483647;break a}}while(0);j=CX(a,c,312096)|0;b:do if(!j)l=0;else switch(f[j>>2]&7){case 1:{l=f[j+8>>2]|0;break b;break}case 2:{l=rNa(+p[j+8>>3])|0;break b;break}default:{l=2147483647;break b}}while(0);j=CX(a,c,312107)|0;c:do if(!j)m=0;else switch(f[j>>2]&7){case 1:{m=f[j+8>>2]|0;break c;break}case 2:{m=rNa(+p[j+8>>3])|0;break c;break}default:{m=2147483647;break c}}while(0);j=(l|0)!=0;l=(m|0)!=0;f[i>>2]=k|(j?1024:0)|(l?2048:0)|1111818240;do if(!k){m=LX(a,CX(a,c,312119)|0,0)|0;f[e>>2]=m;if(((m|0)!=0?(f[m>>2]&-65536|0)==1111687168:0)?(f[m+16>>2]|0)!=0:0){n=m;o=m}else{f[h>>2]=0;f[h+4>>2]=0;q=c$(h,16)|0;r=312137;s=q+16|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));j$(-2,h,312154,311778,4008);d$(h);m=f[e>>2]|0;n=m;o=m}m=f[n+4>>2]|0;if((m|0)>0){t=n+4|0;v=0;do{f[g+(v<<2)>>2]=f[n+20+(v<<3)>>2];v=v+1|0;w=f[t>>2]|0}while((v|0)<(w|0));x=w}else x=m;v=i+268|0;z0(v,x,g,f[n>>2]|0,f[n+16>>2]|0)|0;f[i+4>>2]=v;f[i+276>>2]=f[n+8>>2];d:do if(o|0){v=f[o>>2]&-65536;if((v|0)>=1111687168){switch(v|0){case 1111687168:break;default:break d}if(!(f[o+16>>2]|0))break;t=f[o+8>>2]|0;if(!t)break;f[t>>2]=(f[t>>2]|0)+1;break}switch(v|0){case 1111621632:break;default:break d}if((((f[o+24>>2]|0)>0?(f[o+20>>2]|0)>0:0)?f[o+16>>2]|0:0)?(v=f[o+8>>2]|0,v|0):0)f[v>>2]=(f[v>>2]|0)+1}while(0);x0(e)}else{m=LX(a,CX(a,c,312123)|0,0)|0;f[i+4>>2]=m;if(m|0?(f[m>>2]&-65536|0)==1111752704:0)break;f[e>>2]=0;f[e+4>>2]=0;q=c$(e,22)|0;r=312166;s=q+22|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));j$(-2,e,312154,311778,4029);d$(e)}while(0);if(!l){u=d;return i|0}l=P0(f[i+4>>2]|0,e)|0;o=(l|0)>0;if(o){n=0;x=0;while(1){k=x+1+(f[e+(n<<2)>>2]|0)|0;n=n+1|0;if((n|0)==(l|0)){y=k;break}else x=k}}else y=0;x=CX(a,c,312128)|0;if(!x){f[h>>2]=0;f[h+4>>2]=0;q=c$(h,24)|0;r=312189;s=q+24|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));j$(-2,h,312154,311778,4046);d$(h)}FX(a,x,g);if(!j){j=_F(y+l<<2)|0;y=i+264|0;f[y>>2]=j;if(o?(x=j+(l<<2)|0,f[j>>2]=x,GX(a,g,(f[e>>2]|0)+1|0,x,312135),(l|0)!=1):0){j=e;h=x;x=1;do{h=h+((f[j>>2]|0)+1<<2)|0;f[(f[y>>2]|0)+(x<<2)>>2]=h;j=e+(x<<2)|0;GX(a,g,(f[j>>2]|0)+1|0,h,312135);x=x+1|0}while((x|0)!=(l|0))}}else{if(o){o=i+8|0;x=0;do{GX(a,g,2,o+(x<<3)|0,312135);x=x+1|0}while((x|0)!=(l|0))}f[i+264>>2]=0}u=d;return i|0}function Efa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+176|0;e=d+160|0;g=d+8|0;h=d+152|0;i=d+144|0;j=d+136|0;k=d;f[h>>2]=0;f[h+4>>2]=0;f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];nX(a,b,6,311720,e);b=f[c>>2]|0;h=b&1024;l=(h|0)==0;m=b&2048;n=(m|0)==0;HX(a,312091,b&1);HX(a,312096,h>>>10);HX(a,312107,m>>>11);m=c+4|0;h=f[m>>2]|0;if((h|0)!=0?(f[h>>2]&-65536|0)==1111752704:0){f[j>>2]=0;f[j+4>>2]=0;f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];TX(a,312123,h,e)}else{f[i>>2]=0;f[i+4>>2]=0;f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];TX(a,312119,c+268|0,e)}if(n){kV(a);u=d;return}n=P0(f[m>>2]|0,g)|0;f[k>>2]=0;f[k+4>>2]=0;f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];nX(a,312128,13,0,e);e=(n|0)>0;if(l){if(e){l=c+264|0;k=0;do{oX(a,f[(f[l>>2]|0)+(k<<2)>>2]|0,(f[g+(k<<2)>>2]|0)+1|0,312135);k=k+1|0}while((k|0)!=(n|0))}}else if(e){e=c+8|0;c=0;do{oX(a,e+(c<<3)|0,2,312135);c=c+1|0}while((c|0)!=(n|0))}kV(a);kV(a);u=d;return}function Ffa(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[c>>2]=0;Gfa(a,c);u=b;return f[c>>2]|0}function Gfa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+256|0;e=d+128|0;g=d;if(!c){f[e>>2]=0;f[e+4>>2]=0;h=c$(e,34)|0;i=311732;j=h+34|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-27,e,311767,311778,3293);d$(e)}k=f[c>>2]|0;do if(((a|0)!=0?(f[a>>2]&-65536|0)==1111818240:0)?(l=a+4|0,m=f[l>>2]|0,(m|0)!=0):0){if(k|0){if((f[k>>2]&-65536|0)!=1111818240){n=9;break}if(!(f[k+4>>2]|0)){n=9;break}}o=e;p=m;q=l;n=11}else n=9;while(0);if((n|0)==9){f[e>>2]=0;f[e+4>>2]=0;h=c$(e,27)|0;i=311832;j=h+27|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-5,e,311767,311778,3298);d$(e);i=a+4|0;h=f[i>>2]|0;if(!h){r=0;s=e;t=i}else{o=e;p=h;q=i;n=11}}if((n|0)==11){r=(f[p>>2]&-65536|0)==1111752704;s=o;t=q}q=P0(f[t>>2]|0,e)|0;do if(k){o=f[k+4>>2]|0;if(!o){if(r){n=22;break}}else if(r^(f[o>>2]&-65536|0)==1111752704){n=22;break}if((q|0)!=(P0(o,g)|0)){n=22;break}a:do if((q|0)>0){o=0;while(1){if((f[e+(o<<2)>>2]|0)!=(f[g+(o<<2)>>2]|0)){v=o;break a}s=o+1|0;if((s|0)<(q|0))o=s;else{v=s;break}}}else v=0;while(0);if((v|0)==(q|0))w=k;else n=22}else n=22;while(0);if((n|0)==22){Cfa(c);n=Hfa(q,e,r&1,0,0)|0;f[c>>2]=n;w=n}n=f[a>>2]|0;if(!(n&2048)){x=f[t>>2]|0;y=w+4|0;z=f[y>>2]|0;nL(x,z,0);u=d;return}if(!(n&1024))A=f[a+264>>2]|0;else{if((q|0)>0){c=0;do{f[g+(c<<2)>>2]=a+8+(c<<3);c=c+1|0}while((c|0)!=(q|0))}A=g}Ifa(w,A,n>>>10&1);x=f[t>>2]|0;y=w+4|0;z=f[y>>2]|0;nL(x,z,0);u=d;return}function Hfa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=u;u=u+16|0;i=h;if(a>>>0>32){f[i>>2]=0;f[i+4>>2]=0;j=c$(i,36)|0;k=311997;l=j+36|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-19,i,312034,311778,2844);d$(i)}if(!c){f[i>>2]=0;f[i+4>>2]=0;j=c$(i,20)|0;k=312047;l=j+20|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-9,i,312034,311778,2847);d$(i)}m=_F(544)|0;f[m>>2]=((g|0)==0?1111818240:1111819264)|d&1;f[m+264>>2]=0;n=m+4|0;f[n>>2]=0;switch(d|0){case 0:{d=m+268|0;o=z0(d,a,c,5,0)|0;f[n>>2]=o;v0(d);break}case 1:{d=H0(a,c,5)|0;f[n>>2]=d;break}default:{f[i>>2]=0;f[i+4>>2]=0;j=c$(i,22)|0;k=312068;l=j+22|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-5,i,312034,311778,2863);d$(i)}}if(!e){u=h;return m|0}Ifa(m,e,g);u=h;return m|0}function Ifa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0;e=u;u=u+144|0;g=e+8|0;h=e;if(!c){f[h>>2]=0;f[h+4>>2]=0;i=c$(h,19)|0;j=311860;k=i+19|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-27,h,311880,311778,3363);d$(h)}if(((a|0)!=0?(f[a>>2]&-65536|0)==1111818240:0)?(l=f[a+4>>2]|0,(l|0)!=0):0)m=l;else{f[h>>2]=0;f[h+4>>2]=0;i=c$(h,24)|0;j=311899;k=i+24|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-5,h,311880,311778,3366);d$(h);m=f[a+4>>2]|0}l=P0(m,g)|0;m=(l|0)>0;if(m){o=0;p=0;while(1){q=p+1+(f[g+(o<<2)>>2]|0)|0;o=o+1|0;if((o|0)==(l|0)){r=q;break}else p=q}}else r=0;if(d|0){if(m){d=h+4|0;p=0;do{o=c+(p<<2)|0;q=f[o>>2]|0;if(!q){f[h>>2]=0;f[d>>2]=0;i=c$(h,32)|0;j=311924;k=i+32|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-27,h,311880,311778,3377);d$(h);s=f[o>>2]|0}else s=q;f[a+8+(p<<3)>>2]=f[s>>2];f[a+8+(p<<3)+4>>2]=f[s+4>>2];p=p+1|0}while((p|0)<(l|0))}t=f[a>>2]|3072;v=a;f[v>>2]=t;u=e;return}p=a+264|0;s=f[p>>2]|0;if(!s){d=_F(r+l<<2)|0;f[p>>2]=d;w=d}else w=s;if(m){m=h+4|0;s=h+4|0;d=w+(l<<2)|0;w=0;while(1){r=c+(w<<2)|0;if(!(f[r>>2]|0)){f[h>>2]=0;f[m>>2]=0;i=c$(h,32)|0;j=311924;k=i+32|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-27,h,311880,311778,3401);d$(h)}q=g+(w<<2)|0;o=f[q>>2]|0;if((o|0)<0)x=o;else{y=o;o=0;z=-3402823466385288598117041.0e14;while(1){A=z;z=+n[(f[r>>2]|0)+(o<<2)>>2];if(!(z<=A))B=y;else{f[h>>2]=0;f[s>>2]=0;i=c$(h,39)|0;j=311957;k=i+39|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-211,h,311880,311778,3407);d$(h);B=f[q>>2]|0}n[d+(o<<2)>>2]=z;if((o|0)>=(B|0)){x=B;break}else{y=B;o=o+1|0}}}f[(f[p>>2]|0)+(w<<2)>>2]=d;w=w+1|0;if((w|0)>=(l|0))break;else d=d+(x+1<<2)|0}}t=f[a>>2]&-3073|2048;v=a;f[v>>2]=t;u=e;return}function Jfa(a,c,d,e,g,i,k,l,m,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;m=m|0;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0,cb=0,db=0,eb=0.0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0;q=u;u=u+1568|0;r=q;s=q+536|0;t=q+408|0;v=q+344|0;w=q+288|0;x=q+352|0;y=q+232|0;z=q+176|0;A=q+160|0;B=q+148|0;C=q+136|0;D=q+128|0;_$(v,72416);do if((NS(e)|0)==65536){E=f[e+4>>2]|0;f[w>>2]=f[E>>2];F=w+4|0;G=E+4|0;f[F>>2]=f[G>>2];H=w+8|0;f[H>>2]=f[E+8>>2];f[w+12>>2]=f[E+12>>2];f[w+16>>2]=f[E+16>>2];f[w+20>>2]=f[E+20>>2];f[w+24>>2]=f[E+24>>2];f[w+28>>2]=f[E+28>>2];f[w+32>>2]=f[E+32>>2];I=f[E+36>>2]|0;f[w+36>>2]=I;f[w+40>>2]=H;H=w+48|0;J=w+44|0;f[J>>2]=H;f[H>>2]=0;f[w+52>>2]=0;if(I|0){H=I+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[G>>2]|0)<3){G=f[E+44>>2]|0;H=f[J>>2]|0;f[H>>2]=f[G>>2];f[H+4>>2]=f[G+4>>2];break}else{f[F>>2]=0;BR(w,E);break}}else OR(w,e,-1);while(0);e=(i|0)>0;if(!(e&(k|0)!=0)){f[r>>2]=0;f[r+4>>2]=0;K=c$(r,20)|0;L=312228;M=K+20|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));j$(-215,r,312249,311778,1457);d$(r)}do if((NS(g)|0)==65536){E=f[g+4>>2]|0;f[x>>2]=f[E>>2];F=x+4|0;G=E+4|0;f[F>>2]=f[G>>2];H=x+8|0;f[H>>2]=f[E+8>>2];f[x+12>>2]=f[E+12>>2];J=x+16|0;f[J>>2]=f[E+16>>2];f[x+20>>2]=f[E+20>>2];f[x+24>>2]=f[E+24>>2];f[x+28>>2]=f[E+28>>2];f[x+32>>2]=f[E+32>>2];I=x+36|0;N=f[E+36>>2]|0;f[I>>2]=N;f[x+40>>2]=H;H=x+48|0;O=x+44|0;f[O>>2]=H;f[H>>2]=0;f[x+52>>2]=0;if(N|0){H=N+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[G>>2]|0)<3){G=f[E+44>>2]|0;H=f[O>>2]|0;f[H>>2]=f[G>>2];f[H+4>>2]=f[G+4>>2];P=J;Q=O;R=I;break}else{f[F>>2]=0;BR(x,E);P=J;Q=O;R=I;break}}else{OR(x,g,-1);P=x+16|0;Q=x+44|0;R=x+36|0}while(0);I=f[P>>2]|0;O=f[R>>2]|0;if(O|0?(J=O+12|0,O=f[J>>2]|0,f[J>>2]=O+-1,(O|0)==1):0)CR(x);f[R>>2]=0;R=x+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[R>>2]|0)>0){P=f[x+40>>2]|0;O=0;do{f[P+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[R>>2]|0))}R=f[Q>>2]|0;if((R|0)!=(x+48|0))ZF(R);MR(g,i,k,5,-1,0,0);do if((NS(g)|0)==65536){k=f[g+4>>2]|0;f[y>>2]=f[k>>2];R=y+4|0;x=k+4|0;f[R>>2]=f[x>>2];Q=y+8|0;f[Q>>2]=f[k+8>>2];O=y+12|0;f[O>>2]=f[k+12>>2];P=y+16|0;f[P>>2]=f[k+16>>2];J=y+20|0;f[J>>2]=f[k+20>>2];E=y+24|0;f[E>>2]=f[k+24>>2];F=y+28|0;f[F>>2]=f[k+28>>2];G=y+32|0;f[G>>2]=f[k+32>>2];H=y+36|0;N=f[k+36>>2]|0;f[H>>2]=N;f[y+40>>2]=Q;S=y+48|0;T=y+44|0;f[T>>2]=S;f[S>>2]=0;f[y+52>>2]=0;if(N|0){S=N+12|0;f[S>>2]=(f[S>>2]|0)+1}if((f[x>>2]|0)<3){x=f[k+44>>2]|0;S=f[T>>2]|0;f[S>>2]=f[x>>2];f[S+4>>2]=f[x+4>>2];U=J;V=E;W=F;X=G;Z=H;_=O;$=P;aa=R;ba=y;ca=Q;da=H;break}else{f[R>>2]=0;BR(y,k);U=J;V=E;W=F;X=G;Z=H;_=O;$=P;aa=R;ba=y;ca=Q;da=H;break}}else{OR(y,g,-1);H=y+36|0;U=y+20|0;V=y+24|0;W=y+28|0;X=y+32|0;Z=H;_=y+12|0;$=y+16|0;aa=y+4|0;ba=y;ca=y+8|0;da=H}while(0);g=f[$>>2]|0;f[z>>2]=f[ba>>2];ba=z+4|0;H=f[aa>>2]|0;f[ba>>2]=H;Q=z+8|0;f[Q>>2]=f[ca>>2];f[z+12>>2]=f[_>>2];_=z+16|0;f[_>>2]=g;f[z+20>>2]=f[U>>2];f[z+24>>2]=f[V>>2];f[z+28>>2]=f[W>>2];f[z+32>>2]=f[X>>2];X=z+36|0;W=f[Z>>2]|0;f[X>>2]=W;Z=z+40|0;f[Z>>2]=Q;Q=z+48|0;V=z+44|0;f[V>>2]=Q;f[Q>>2]=0;f[z+52>>2]=0;if(!W)ea=H;else{H=W+12|0;f[H>>2]=(f[H>>2]|0)+1;ea=f[aa>>2]|0}if((ea|0)<3){ea=f[y+44>>2]|0;H=f[V>>2]|0;f[H>>2]=f[ea>>2];f[H+4>>2]=f[ea+4>>2]}else{f[ba>>2]=0;BR(z,y)}f[z>>2]=f[z>>2]&-4096|4;if((I|0)==(g|0)&o){o=r+8|0;f[o>>2]=0;f[o+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=z;WJ(y,r,4,1.0,0.0)}else{f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;f[r+24>>2]=0;f[r+28>>2]=0;gL(y,r)|0}f[A>>2]=0;o=A+4|0;f[o>>2]=0;f[A+8>>2]=0;f[B>>2]=0;g=B+4|0;f[g>>2]=0;f[B+8>>2]=0;f[C>>2]=0;I=C+4|0;f[I>>2]=0;f[C+8>>2]=0;f[D>>2]=0;ea=D+4|0;f[ea>>2]=0;H=w+16|0;if(f[H>>2]|0){W=f[w+4>>2]|0;if((W|0)<3)fa=Y(f[w+12>>2]|0,f[w+8>>2]|0)|0;else{U=f[w+40>>2]|0;ca=0;R=1;while(1){P=Y(f[U+(ca<<2)>>2]|0,R)|0;ca=ca+1|0;if((ca|0)==(W|0)){fa=P;break}else R=P}}if(!((W|0)==0|(fa|0)==0)?f[w>>2]&4095|0:0){f[r>>2]=0;f[r+4>>2]=0;K=c$(r,72)|0;L=312258;M=K+72|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));j$(-215,r,312249,311778,1484);d$(r)}}fa=y+40|0;Kfa(a,c,d,w,i,f[fa>>2]|0,l,m,A,B,D,C);d=m?f[C>>2]|0:0;switch(f[a>>2]&7){case 0:{a=f[D>>2]|0;c=f[ea>>2]|0;W=f[A>>2]|0;R=f[B>>2]|0;ca=f[_>>2]|0;U=f[W+(i<<2)>>2]|0;P=f[R+((i<<1|1)<<2)>>2]|0;f[r>>2]=0;O=r+4|0;f[O>>2]=0;f[r+8>>2]=0;f[s>>2]=1123876864;f[s+4>>2]=0;Lfa(z,s,i,l,d,m,0,r);G=f[r>>2]|0;switch(i|0){case 1:{F=f[R>>2]|0;E=f[R+4>>2]|0;F1a(s|0,0,1024)|0;a:do if(!c)ga=0;else{J=f[W>>2]|0;k=(F|0)==1;x=F<<1;S=(a|0)<4;T=a+-4|0;if((a|0)<=0){N=a&-4;ha=Y(F,N)|0;ia=c;ja=U;ka=J;while(1){ia=ia+-1|0;do if(!ja){do if(k){if(S){la=ka;ma=0;break}else{na=ka;oa=0}while(1){pa=h[ka+(oa|1)>>0]|0;qa=s+(h[na>>0]<<2)|0;f[qa>>2]=(f[qa>>2]|0)+1;qa=s+(pa<<2)|0;f[qa>>2]=(f[qa>>2]|0)+1;qa=h[ka+(oa|3)>>0]|0;pa=s+(h[ka+(oa|2)>>0]<<2)|0;f[pa>>2]=(f[pa>>2]|0)+1;pa=s+(qa<<2)|0;f[pa>>2]=(f[pa>>2]|0)+1;pa=oa+4|0;if((pa|0)>(T|0))break;else{na=ka+pa|0;oa=pa}}la=ka+N|0;ma=N}else{if(S){la=ka;ma=0;break}else{ra=ka;sa=0}while(1){pa=h[ra+F>>0]|0;qa=s+(h[ra>>0]<<2)|0;f[qa>>2]=(f[qa>>2]|0)+1;qa=s+(pa<<2)|0;f[qa>>2]=(f[qa>>2]|0)+1;qa=ra+x|0;pa=h[qa+F>>0]|0;ta=s+(h[qa>>0]<<2)|0;f[ta>>2]=(f[ta>>2]|0)+1;ta=s+(pa<<2)|0;f[ta>>2]=(f[ta>>2]|0)+1;sa=sa+4|0;if((sa|0)>(T|0))break;else ra=qa+x|0}la=ka+ha|0;ma=N}while(0);if((a|0)<=(ma|0)){ua=la;break}qa=Y(F,a-ma|0)|0;ta=la;pa=ma;while(1){va=s+(h[ta>>0]<<2)|0;f[va>>2]=(f[va>>2]|0)+1;pa=pa+1|0;if((pa|0)==(a|0))break;else ta=ta+F|0}ua=la+qa|0}else ua=ka;while(0);if(!ia){ga=0;break a}else{ja=ja+P|0;ka=ua+E|0}}}ka=Y(a,F)|0;ja=a&-4;ia=Y(F,ja)|0;N=c;ha=U;ta=J;while(1){N=N+-1|0;do if(!ha){do if(k){if(S){wa=ta;xa=0;break}else{ya=ta;za=0}while(1){pa=h[ta+(za|1)>>0]|0;va=s+(h[ya>>0]<<2)|0;f[va>>2]=(f[va>>2]|0)+1;va=s+(pa<<2)|0;f[va>>2]=(f[va>>2]|0)+1;va=h[ta+(za|3)>>0]|0;pa=s+(h[ta+(za|2)>>0]<<2)|0;f[pa>>2]=(f[pa>>2]|0)+1;pa=s+(va<<2)|0;f[pa>>2]=(f[pa>>2]|0)+1;pa=za+4|0;if((pa|0)>(T|0))break;else{ya=ta+pa|0;za=pa}}wa=ta+ja|0;xa=ja}else{if(S){wa=ta;xa=0;break}else{Aa=ta;Ba=0}while(1){pa=h[Aa+F>>0]|0;va=s+(h[Aa>>0]<<2)|0;f[va>>2]=(f[va>>2]|0)+1;va=s+(pa<<2)|0;f[va>>2]=(f[va>>2]|0)+1;va=Aa+x|0;pa=h[va+F>>0]|0;Ca=s+(h[va>>0]<<2)|0;f[Ca>>2]=(f[Ca>>2]|0)+1;Ca=s+(pa<<2)|0;f[Ca>>2]=(f[Ca>>2]|0)+1;Ba=Ba+4|0;if((Ba|0)>(T|0))break;else Aa=va+x|0}wa=ta+ia|0;xa=ja}while(0);if((a|0)<=(xa|0)){Da=wa;break}qa=Y(F,a-xa|0)|0;va=wa;Ca=xa;while(1){pa=s+(h[va>>0]<<2)|0;f[pa>>2]=(f[pa>>2]|0)+1;Ca=Ca+1|0;if((Ca|0)==(a|0))break;else va=va+F|0}Da=wa+qa|0}else{va=ta;Ca=0;while(1){if(b[ha+Ca>>0]|0){pa=s+(h[va>>0]<<2)|0;f[pa>>2]=(f[pa>>2]|0)+1}Ca=Ca+1|0;if((Ca|0)==(a|0))break;else va=va+F|0}Da=ta+ka|0}while(0);if(!N){ga=0;break}else{ha=ha+P|0;ta=Da+E|0}}}while(0);do{E=f[G+(ga<<2)>>2]|0;Da=ca+E|0;if(E>>>0<1073741824)f[Da>>2]=(f[Da>>2]|0)+(f[s+(ga<<2)>>2]|0);ga=ga+1|0}while((ga|0)!=256);Ea=145;break}case 2:{ga=f[R>>2]|0;Da=f[R+4>>2]|0;E=f[R+8>>2]|0;F=f[R+12>>2]|0;if((c|0)!=0&(a|0)>0){wa=a+-1|0;xa=Y(ga,wa)|0;Aa=Y(E,wa)|0;wa=c;Ba=U;za=f[W>>2]|0;ya=f[W+4>>2]|0;while(1){wa=wa+-1|0;if(!Ba){ua=za;la=ya;ma=0;while(1){ra=(f[G+((h[la>>0]|256)<<2)>>2]|0)+(f[G+(h[ua>>0]<<2)>>2]|0)|0;if(ra>>>0<1073741824){sa=ca+ra|0;f[sa>>2]=(f[sa>>2]|0)+1}ma=ma+1|0;if((ma|0)==(a|0))break;else{ua=ua+ga|0;la=la+E|0}}}else{la=za;ua=ya;ma=0;while(1){do if(b[Ba+ma>>0]|0){sa=(f[G+((h[ua>>0]|256)<<2)>>2]|0)+(f[G+(h[la>>0]<<2)>>2]|0)|0;if(sa>>>0>=1073741824)break;ra=ca+sa|0;f[ra>>2]=(f[ra>>2]|0)+1}while(0);ma=ma+1|0;if((ma|0)==(a|0))break;else{la=la+ga|0;ua=ua+E|0}}}if(!wa){Ea=144;break}else{Ba=Ba+P|0;za=za+xa+ga+Da|0;ya=ya+Aa+E+F|0}}}else Ea=144;break}case 3:{F=f[R>>2]|0;E=f[R+4>>2]|0;Aa=f[R+8>>2]|0;ya=f[R+12>>2]|0;Da=f[R+16>>2]|0;ga=f[R+20>>2]|0;if((c|0)!=0&(a|0)>0){xa=a+-1|0;za=Y(Da,xa)|0;Ba=Y(Aa,xa)|0;wa=Y(F,xa)|0;xa=c;ua=U;la=f[W>>2]|0;ma=f[W+4>>2]|0;ra=f[W+8>>2]|0;while(1){xa=xa+-1|0;if(!ua){sa=la;oa=ma;na=ra;ta=0;while(1){ha=(f[G+((h[oa>>0]|256)<<2)>>2]|0)+(f[G+(h[sa>>0]<<2)>>2]|0)+(f[G+((h[na>>0]|512)<<2)>>2]|0)|0;if(ha>>>0<1073741824){N=ca+ha|0;f[N>>2]=(f[N>>2]|0)+1}ta=ta+1|0;if((ta|0)==(a|0))break;else{sa=sa+F|0;oa=oa+Aa|0;na=na+Da|0}}}else{na=la;oa=ma;sa=ra;ta=0;while(1){do if(b[ua+ta>>0]|0){N=(f[G+((h[oa>>0]|256)<<2)>>2]|0)+(f[G+(h[na>>0]<<2)>>2]|0)+(f[G+((h[sa>>0]|512)<<2)>>2]|0)|0;if(N>>>0>=1073741824)break;ha=ca+N|0;f[ha>>2]=(f[ha>>2]|0)+1}while(0);ta=ta+1|0;if((ta|0)==(a|0))break;else{na=na+F|0;oa=oa+Aa|0;sa=sa+Da|0}}}if(!xa){Ea=144;break}else{ua=ua+P|0;la=la+wa+F+E|0;ma=ma+Ba+Aa+ya|0;ra=ra+za+Da+ga|0}}}else Ea=144;break}default:if(!c)Ea=144;else{ga=(i|0)==0;Da=(a|0)>0;za=c;c=U;while(1){za=za+-1|0;do if(!c)if(Da){if(e)Fa=0;else{if(!ga)break;U=f[ca>>2]|0;ra=0;do{U=U+1|0;ra=ra+1|0}while((ra|0)!=(a|0));f[ca>>2]=U;Ea=141;break}do{ra=ca;ya=0;while(1){Aa=W+(ya<<2)|0;Ba=f[Aa>>2]|0;ma=f[G+((h[Ba>>0]|ya<<8)<<2)>>2]|0;if(ma>>>0>1073741823){Ga=ra;Ha=ya;break}E=ra+ma|0;f[Aa>>2]=Ba+(f[R+(ya<<1<<2)>>2]|0);Ba=ya+1|0;if((Ba|0)<(i|0)){ra=E;ya=Ba}else{Ga=E;Ha=Ba;break}}do if((Ha|0)==(i|0))f[Ga>>2]=(f[Ga>>2]|0)+1;else{if((Ha|0)<(i|0))Ia=Ha;else break;do{ya=W+(Ia<<2)|0;f[ya>>2]=(f[ya>>2]|0)+(f[R+(Ia<<1<<2)>>2]|0);Ia=Ia+1|0}while((Ia|0)!=(i|0))}while(0);Fa=Fa+1|0}while((Fa|0)!=(a|0));Ea=141}else Ea=141;else if(Da){if(e)Ja=0;else{if(!ga)break;U=f[ca>>2]|0;ya=0;do{U=U+1|0;ya=ya+1|0}while((ya|0)!=(a|0));f[ca>>2]=U;Ea=141;break}while(1){b:do if(!(b[c+Ja>>0]|0)){Ka=ca;La=0}else{ya=ca;ra=0;while(1){Ba=W+(ra<<2)|0;E=f[Ba>>2]|0;Aa=f[G+((h[E>>0]|ra<<8)<<2)>>2]|0;if(Aa>>>0>1073741823){Ka=ya;La=ra;break b}ma=ya+Aa|0;f[Ba>>2]=E+(f[R+(ra<<1<<2)>>2]|0);E=ra+1|0;if((E|0)<(i|0)){ya=ma;ra=E}else{Ka=ma;La=E;break}}}while(0);do if((La|0)==(i|0))f[Ka>>2]=(f[Ka>>2]|0)+1;else{if((La|0)<(i|0))Ma=La;else break;do{ra=W+(Ma<<2)|0;f[ra>>2]=(f[ra>>2]|0)+(f[R+(Ma<<1<<2)>>2]|0);Ma=Ma+1|0}while((Ma|0)!=(i|0))}while(0);Ja=Ja+1|0;if((Ja|0)==(a|0)){Ea=141;break}}}else Ea=141;while(0);if((Ea|0)==141?(Ea=0,e):0){U=0;do{ra=W+(U<<2)|0;f[ra>>2]=(f[ra>>2]|0)+(f[R+((U<<1|1)<<2)>>2]|0);U=U+1|0}while((U|0)!=(i|0))}if(!za){Ea=144;break}else c=c+P|0}}}if((Ea|0)==144?G|0:0)Ea=145;if((Ea|0)==145){P=f[O>>2]|0;if((P|0)!=(G|0))f[O>>2]=P+(~((P+-4-G|0)>>>2)<<2);PYa(G)}break}case 2:{G=f[D>>2]|0;P=f[ea>>2]|0;O=f[A>>2]|0;c=f[B>>2]|0;za=f[_>>2]|0;R=f[O+(i<<2)>>2]|0;W=f[c+((i<<1|1)<<2)>>2]|0;a=i<<2;if(e){Ja=f[V>>2]|0;K1a(s|0,f[Z>>2]|0,a|0)|0;K1a(t|0,Ja|0,a|0)|0}c:do if(!m){if(!l){f[r>>2]=0;f[r+4>>2]=0;K=c$(r,55)|0;L=312331;M=K+55|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));j$(-5,r,312387,311778,989);d$(r);break}if(e)K1a(r|0,l|0,a|0)|0;if(P|0){Ja=(G|0)>0;Ma=(i|0)==0;La=(i|0)==0;Ka=P;ca=R;while(1){Ka=Ka+-1|0;d:do if(Ja)if(!ca){if(e)Na=0;else{ga=0;while(1){if(Ma)f[za>>2]=(f[za>>2]|0)+1;ga=ga+1|0;if((ga|0)==(G|0))break d}}do{ga=za;Da=0;while(1){Fa=O+(Da<<2)|0;Ia=f[Fa>>2]|0;Oa=+(j[Ia>>1]|0);Ha=f[r+(Da<<2)>>2]|0;Ga=f[s+(Da<<2)>>2]|0;U=-1;while(1){ra=U+1|0;if(!(Oa>=+n[Ha+(ra<<2)>>2])){Pa=U;break}if((ra|0)<(Ga|0))U=ra;else{Pa=ra;break}}if(Pa>>>0>=Ga>>>0){Qa=ga;Ra=Da;break}f[Fa>>2]=Ia+(f[c+(Da<<1<<2)>>2]<<1);U=ga+(Y(f[t+(Da<<2)>>2]|0,Pa)|0)|0;Ha=Da+1|0;if((Ha|0)<(i|0)){ga=U;Da=Ha}else{Qa=U;Ra=Ha;break}}do if((Ra|0)==(i|0))f[Qa>>2]=(f[Qa>>2]|0)+1;else{if((Ra|0)<(i|0))Sa=Ra;else break;do{Da=O+(Sa<<2)|0;f[Da>>2]=(f[Da>>2]|0)+(f[c+(Sa<<1<<2)>>2]<<1);Sa=Sa+1|0}while((Sa|0)!=(i|0))}while(0);Na=Na+1|0}while((Na|0)!=(G|0))}else{if(e)Ta=0;else{Ia=0;while(1){if(La)f[za>>2]=(f[za>>2]|0)+1;Ia=Ia+1|0;if((Ia|0)==(G|0))break d}}do{e:do if(!(b[ca+Ta>>0]|0)){Ua=za;Va=0}else{Ia=za;Fa=0;while(1){Ga=O+(Fa<<2)|0;Da=f[Ga>>2]|0;Oa=+(j[Da>>1]|0);ga=f[r+(Fa<<2)>>2]|0;Ha=f[s+(Fa<<2)>>2]|0;U=-1;while(1){ra=U+1|0;if(!(Oa>=+n[ga+(ra<<2)>>2])){Wa=U;break}if((ra|0)<(Ha|0))U=ra;else{Wa=ra;break}}if(Wa>>>0>=Ha>>>0){Ua=Ia;Va=Fa;break e}f[Ga>>2]=Da+(f[c+(Fa<<1<<2)>>2]<<1);U=Ia+(Y(f[t+(Fa<<2)>>2]|0,Wa)|0)|0;ga=Fa+1|0;if((ga|0)<(i|0)){Ia=U;Fa=ga}else{Ua=U;Va=ga;break}}}while(0);do if((Va|0)==(i|0))f[Ua>>2]=(f[Ua>>2]|0)+1;else{if((Va|0)<(i|0))Xa=Va;else break;do{Fa=O+(Xa<<2)|0;f[Fa>>2]=(f[Fa>>2]|0)+(f[c+(Xa<<1<<2)>>2]<<1);Xa=Xa+1|0}while((Xa|0)!=(i|0))}while(0);Ta=Ta+1|0}while((Ta|0)!=(G|0))}while(0);if(e){Fa=0;do{Ia=O+(Fa<<2)|0;f[Ia>>2]=(f[Ia>>2]|0)+(f[c+((Fa<<1|1)<<2)>>2]<<1);Fa=Fa+1|0}while((Fa|0)!=(i|0))}if(!Ka)break;else ca=ca+W|0}}}else switch(i|0){case 1:{Oa=+p[d>>3];Ya=+p[d+8>>3];ca=f[s>>2]|0;Ka=f[c>>2]|0;La=f[c+4>>2]|0;if(!P)break c;if((G|0)<=0)break c;Ma=Y(Ka,G+-1|0)|0;Ja=P;Fa=R;Ia=f[O>>2]|0;while(1){Ja=Ja+-1|0;if(!Fa){ga=Ia;U=0;while(1){Za=Ya+Oa*+(j[ga>>1]|0);ra=~~Za;ya=ra-(+(ra|0)>Za&1)|0;ra=za+(ya<<2)|0;if(ya>>>0<ca>>>0)f[ra>>2]=(f[ra>>2]|0)+1;U=U+1|0;if((U|0)==(G|0))break;else ga=ga+(Ka<<1)|0}}else{ga=Ia;U=0;while(1){do if(b[Fa+U>>0]|0){Za=Ya+Oa*+(j[ga>>1]|0);ra=~~Za;ya=ra-(+(ra|0)>Za&1)|0;ra=za+(ya<<2)|0;if(ya>>>0>=ca>>>0)break;f[ra>>2]=(f[ra>>2]|0)+1}while(0);U=U+1|0;if((U|0)==(G|0))break;else ga=ga+(Ka<<1)|0}}if(!Ja)break;else{Fa=Fa+W|0;Ia=Ia+(Ma<<1)+(Ka<<1)+(La<<1)|0}}break}case 2:{Oa=+p[d>>3];Ya=+p[d+8>>3];Za=+p[d+16>>3];_a=+p[d+24>>3];La=f[s>>2]|0;Ka=f[s+4>>2]|0;Ma=f[c>>2]|0;Ia=f[c+4>>2]|0;Fa=f[c+8>>2]|0;Ja=f[c+12>>2]|0;ca=f[t>>2]|0;if(!((P|0)!=0&(G|0)>0))break c;ga=G+-1|0;U=Y(Ma,ga)|0;ra=Y(Fa,ga)|0;ga=P;ya=R;E=f[O>>2]|0;ma=f[O+4>>2]|0;while(1){ga=ga+-1|0;if(!ya){Ba=E;Aa=ma;F=0;while(1){$a=Ya+Oa*+(j[Ba>>1]|0);wa=~~$a;la=wa-(+(wa|0)>$a&1)|0;$a=_a+Za*+(j[Aa>>1]|0);wa=~~$a;ua=wa-(+(wa|0)>$a&1)|0;wa=za+(Y(la,ca)|0)+(ua<<2)|0;if(la>>>0<La>>>0&ua>>>0<Ka>>>0)f[wa>>2]=(f[wa>>2]|0)+1;F=F+1|0;if((F|0)==(G|0))break;else{Ba=Ba+(Ma<<1)|0;Aa=Aa+(Fa<<1)|0}}}else{Aa=E;Ba=ma;F=0;while(1){do if(b[ya+F>>0]|0){$a=Ya+Oa*+(j[Aa>>1]|0);wa=~~$a;ua=wa-(+(wa|0)>$a&1)|0;$a=_a+Za*+(j[Ba>>1]|0);wa=~~$a;la=wa-(+(wa|0)>$a&1)|0;wa=za+(Y(ua,ca)|0)+(la<<2)|0;if(!(ua>>>0<La>>>0&la>>>0<Ka>>>0))break;f[wa>>2]=(f[wa>>2]|0)+1}while(0);F=F+1|0;if((F|0)==(G|0))break;else{Aa=Aa+(Ma<<1)|0;Ba=Ba+(Fa<<1)|0}}}if(!ga)break;else{ya=ya+W|0;E=E+(U<<1)+(Ma<<1)+(Ia<<1)|0;ma=ma+(ra<<1)+(Fa<<1)+(Ja<<1)|0}}break}case 3:{Za=+p[d>>3];_a=+p[d+8>>3];Oa=+p[d+16>>3];Ya=+p[d+24>>3];$a=+p[d+32>>3];ab=+p[d+40>>3];Ja=f[s>>2]|0;Fa=f[s+4>>2]|0;ra=f[s+8>>2]|0;ma=f[c>>2]|0;Ia=f[c+4>>2]|0;Ma=f[c+8>>2]|0;U=f[c+12>>2]|0;E=f[c+16>>2]|0;ya=f[c+20>>2]|0;ga=f[t>>2]|0;Ka=f[t+4>>2]|0;if(!P)break c;La=(G|0)>0;ca=Y(G,ma)|0;Ba=Y(G,Ma)|0;Aa=Y(G,E)|0;F=P;wa=R;la=f[O>>2]|0;ua=f[O+4>>2]|0;xa=f[O+8>>2]|0;while(1){F=F+-1|0;do if(!wa){if(!La){bb=la;cb=ua;db=xa;break}sa=ua+(Ba<<1)|0;oa=la;na=ua;ta=xa;ha=0;while(1){eb=_a+Za*+(j[oa>>1]|0);N=~~eb;ka=N-(+(N|0)>eb&1)|0;eb=Ya+Oa*+(j[na>>1]|0);N=~~eb;ja=N-(+(N|0)>eb&1)|0;eb=ab+$a*+(j[ta>>1]|0);N=~~eb;ia=N-(+(N|0)>eb&1)|0;N=za+(Y(ka,ga)|0)+(Y(ja,Ka)|0)+(ia<<2)|0;if(ka>>>0<Ja>>>0&ja>>>0<Fa>>>0&ia>>>0<ra>>>0)f[N>>2]=(f[N>>2]|0)+1;ha=ha+1|0;if((ha|0)==(G|0))break;else{oa=oa+(ma<<1)|0;na=na+(Ma<<1)|0;ta=ta+(E<<1)|0}}bb=la+(ca<<1)|0;cb=sa;db=xa+(Aa<<1)|0}else{if(!La){bb=la;cb=ua;db=xa;break}ta=ua+(Ba<<1)|0;na=la;oa=ua;ha=xa;N=0;while(1){do if(b[wa+N>>0]|0){eb=_a+Za*+(j[na>>1]|0);ia=~~eb;ja=ia-(+(ia|0)>eb&1)|0;eb=Ya+Oa*+(j[oa>>1]|0);ia=~~eb;ka=ia-(+(ia|0)>eb&1)|0;eb=ab+$a*+(j[ha>>1]|0);ia=~~eb;x=ia-(+(ia|0)>eb&1)|0;ia=za+(Y(ja,ga)|0)+(Y(ka,Ka)|0)+(x<<2)|0;if(!(ja>>>0<Ja>>>0&ka>>>0<Fa>>>0&x>>>0<ra>>>0))break;f[ia>>2]=(f[ia>>2]|0)+1}while(0);N=N+1|0;if((N|0)==(G|0))break;else{na=na+(ma<<1)|0;oa=oa+(Ma<<1)|0;ha=ha+(E<<1)|0}}bb=la+(ca<<1)|0;cb=ta;db=xa+(Aa<<1)|0}while(0);if(!F)break;else{wa=wa+W|0;la=bb+(Ia<<1)|0;ua=cb+(U<<1)|0;xa=db+(ya<<1)|0}}break}default:{if(!P)break c;ya=(i|0)==0;xa=(G|0)>0;U=P;ua=R;while(1){U=U+-1|0;do if(!ua){if(!xa){Ea=224;break}if(e)fb=0;else{if(!ya)break;Ia=f[za>>2]|0;la=0;do{Ia=Ia+1|0;la=la+1|0}while((la|0)!=(G|0));f[za>>2]=Ia;Ea=224;break}do{la=za;ta=0;while(1){wa=O+(ta<<2)|0;F=f[wa>>2]|0;Aa=ta<<1;$a=+(j[F>>1]|0)*+p[d+(Aa<<3)>>3]+ +p[d+((Aa|1)<<3)>>3];ca=~~$a;E=ca-(+(ca|0)>$a&1)|0;if(E>>>0>=(f[s+(ta<<2)>>2]|0)>>>0){gb=la;hb=ta;break}f[wa>>2]=F+(f[c+(Aa<<2)>>2]<<1);Aa=la+(Y(f[t+(ta<<2)>>2]|0,E)|0)|0;E=ta+1|0;if((E|0)<(i|0)){la=Aa;ta=E}else{gb=Aa;hb=E;break}}do if((hb|0)==(i|0))f[gb>>2]=(f[gb>>2]|0)+1;else{if((hb|0)<(i|0))ib=hb;else break;do{ta=O+(ib<<2)|0;f[ta>>2]=(f[ta>>2]|0)+(f[c+(ib<<1<<2)>>2]<<1);ib=ib+1|0}while((ib|0)!=(i|0))}while(0);fb=fb+1|0}while((fb|0)!=(G|0));Ea=224}else{if(!xa){Ea=224;break}if(e)jb=0;else{if(!ya)break;Ia=f[za>>2]|0;ta=0;do{Ia=Ia+1|0;ta=ta+1|0}while((ta|0)!=(G|0));f[za>>2]=Ia;Ea=224;break}while(1){f:do if(!(b[ua+jb>>0]|0)){kb=za;lb=0}else{ta=za;la=0;while(1){E=O+(la<<2)|0;Aa=f[E>>2]|0;F=la<<1;$a=+(j[Aa>>1]|0)*+p[d+(F<<3)>>3]+ +p[d+((F|1)<<3)>>3];wa=~~$a;ca=wa-(+(wa|0)>$a&1)|0;if(ca>>>0>=(f[s+(la<<2)>>2]|0)>>>0){kb=ta;lb=la;break f}f[E>>2]=Aa+(f[c+(F<<2)>>2]<<1);F=ta+(Y(f[t+(la<<2)>>2]|0,ca)|0)|0;ca=la+1|0;if((ca|0)<(i|0)){ta=F;la=ca}else{kb=F;lb=ca;break}}}while(0);do if((lb|0)==(i|0))f[kb>>2]=(f[kb>>2]|0)+1;else{if((lb|0)<(i|0))mb=lb;else break;do{la=O+(mb<<2)|0;f[la>>2]=(f[la>>2]|0)+(f[c+(mb<<1<<2)>>2]<<1);mb=mb+1|0}while((mb|0)!=(i|0))}while(0);jb=jb+1|0;if((jb|0)==(G|0)){Ea=224;break}}}while(0);do if((Ea|0)==224){Ea=0;if(e)nb=0;else break;do{Ia=O+(nb<<2)|0;f[Ia>>2]=(f[Ia>>2]|0)+(f[c+((nb<<1|1)<<2)>>2]<<1);nb=nb+1|0}while((nb|0)!=(i|0))}while(0);if(!U)break;else ua=ua+W|0}}}while(0);break}case 5:{W=f[D>>2]|0;D=f[ea>>2]|0;ea=f[A>>2]|0;nb=f[B>>2]|0;c=f[_>>2]|0;O=f[ea+(i<<2)>>2]|0;G=f[nb+((i<<1|1)<<2)>>2]|0;jb=i<<2;if(e){mb=f[V>>2]|0;K1a(s|0,f[Z>>2]|0,jb|0)|0;K1a(t|0,mb|0,jb|0)|0}g:do if(!m){if(!l){f[r>>2]=0;f[r+4>>2]=0;K=c$(r,55)|0;L=312331;M=K+55|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));j$(-5,r,312387,311778,989);d$(r);break}if(e)K1a(r|0,l|0,jb|0)|0;if(D|0){mb=(W|0)>0;lb=(i|0)==0;kb=(i|0)==0;za=D;fb=O;while(1){za=za+-1|0;h:do if(mb)if(!fb){if(e)ob=0;else{ib=0;while(1){if(lb)f[c>>2]=(f[c>>2]|0)+1;ib=ib+1|0;if((ib|0)==(W|0))break h}}do{ib=c;hb=0;while(1){gb=ea+(hb<<2)|0;R=f[gb>>2]|0;$a=+n[R>>2];P=f[r+(hb<<2)>>2]|0;db=f[s+(hb<<2)>>2]|0;cb=-1;while(1){bb=cb+1|0;if(!($a>=+n[P+(bb<<2)>>2])){pb=cb;break}if((bb|0)<(db|0))cb=bb;else{pb=bb;break}}if(pb>>>0>=db>>>0){qb=ib;rb=hb;break}f[gb>>2]=R+(f[nb+(hb<<1<<2)>>2]<<2);cb=ib+(Y(f[t+(hb<<2)>>2]|0,pb)|0)|0;P=hb+1|0;if((P|0)<(i|0)){ib=cb;hb=P}else{qb=cb;rb=P;break}}do if((rb|0)==(i|0))f[qb>>2]=(f[qb>>2]|0)+1;else{if((rb|0)<(i|0))sb=rb;else break;do{hb=ea+(sb<<2)|0;f[hb>>2]=(f[hb>>2]|0)+(f[nb+(sb<<1<<2)>>2]<<2);sb=sb+1|0}while((sb|0)!=(i|0))}while(0);ob=ob+1|0}while((ob|0)!=(W|0))}else{if(e)tb=0;else{R=0;while(1){if(kb)f[c>>2]=(f[c>>2]|0)+1;R=R+1|0;if((R|0)==(W|0))break h}}do{i:do if(!(b[fb+tb>>0]|0)){ub=c;vb=0}else{R=c;gb=0;while(1){db=ea+(gb<<2)|0;hb=f[db>>2]|0;$a=+n[hb>>2];ib=f[r+(gb<<2)>>2]|0;P=f[s+(gb<<2)>>2]|0;cb=-1;while(1){bb=cb+1|0;if(!($a>=+n[ib+(bb<<2)>>2])){wb=cb;break}if((bb|0)<(P|0))cb=bb;else{wb=bb;break}}if(wb>>>0>=P>>>0){ub=R;vb=gb;break i}f[db>>2]=hb+(f[nb+(gb<<1<<2)>>2]<<2);cb=R+(Y(f[t+(gb<<2)>>2]|0,wb)|0)|0;ib=gb+1|0;if((ib|0)<(i|0)){R=cb;gb=ib}else{ub=cb;vb=ib;break}}}while(0);do if((vb|0)==(i|0))f[ub>>2]=(f[ub>>2]|0)+1;else{if((vb|0)<(i|0))xb=vb;else break;do{gb=ea+(xb<<2)|0;f[gb>>2]=(f[gb>>2]|0)+(f[nb+(xb<<1<<2)>>2]<<2);xb=xb+1|0}while((xb|0)!=(i|0))}while(0);tb=tb+1|0}while((tb|0)!=(W|0))}while(0);if(e){gb=0;do{R=ea+(gb<<2)|0;f[R>>2]=(f[R>>2]|0)+(f[nb+((gb<<1|1)<<2)>>2]<<2);gb=gb+1|0}while((gb|0)!=(i|0))}if(!za)break;else fb=fb+G|0}}}else switch(i|0){case 1:{$a=+p[d>>3];ab=+p[d+8>>3];fb=f[s>>2]|0;za=f[nb>>2]|0;kb=f[nb+4>>2]|0;if(!D)break g;if((W|0)<=0)break g;lb=Y(za,W+-1|0)|0;mb=D;gb=O;R=f[ea>>2]|0;while(1){mb=mb+-1|0;if(!gb){ib=R;cb=0;while(1){Oa=ab+$a*+n[ib>>2];Da=~~Oa;Ga=Da-(+(Da|0)>Oa&1)|0;Da=c+(Ga<<2)|0;if(Ga>>>0<fb>>>0)f[Da>>2]=(f[Da>>2]|0)+1;cb=cb+1|0;if((cb|0)==(W|0))break;else ib=ib+(za<<2)|0}}else{ib=R;cb=0;while(1){do if(b[gb+cb>>0]|0){Oa=ab+$a*+n[ib>>2];Da=~~Oa;Ga=Da-(+(Da|0)>Oa&1)|0;Da=c+(Ga<<2)|0;if(Ga>>>0>=fb>>>0)break;f[Da>>2]=(f[Da>>2]|0)+1}while(0);cb=cb+1|0;if((cb|0)==(W|0))break;else ib=ib+(za<<2)|0}}if(!mb)break;else{gb=gb+G|0;R=R+(lb<<2)+(za<<2)+(kb<<2)|0}}break}case 2:{$a=+p[d>>3];ab=+p[d+8>>3];Oa=+p[d+16>>3];Ya=+p[d+24>>3];kb=f[s>>2]|0;za=f[s+4>>2]|0;lb=f[nb>>2]|0;R=f[nb+4>>2]|0;gb=f[nb+8>>2]|0;mb=f[nb+12>>2]|0;fb=f[t>>2]|0;if(!((D|0)!=0&(W|0)>0))break g;ib=W+-1|0;cb=Y(lb,ib)|0;Da=Y(gb,ib)|0;ib=D;Ga=O;Ha=f[ea>>2]|0;bb=f[ea+4>>2]|0;while(1){ib=ib+-1|0;if(!Ga){Ta=Ha;Xa=bb;Va=0;while(1){Za=ab+$a*+n[Ta>>2];Ua=~~Za;Wa=Ua-(+(Ua|0)>Za&1)|0;Za=Ya+Oa*+n[Xa>>2];Ua=~~Za;Na=Ua-(+(Ua|0)>Za&1)|0;Ua=c+(Y(Wa,fb)|0)+(Na<<2)|0;if(Wa>>>0<kb>>>0&Na>>>0<za>>>0)f[Ua>>2]=(f[Ua>>2]|0)+1;Va=Va+1|0;if((Va|0)==(W|0))break;else{Ta=Ta+(lb<<2)|0;Xa=Xa+(gb<<2)|0}}}else{Xa=Ha;Ta=bb;Va=0;while(1){do if(b[Ga+Va>>0]|0){Za=ab+$a*+n[Xa>>2];Ua=~~Za;Na=Ua-(+(Ua|0)>Za&1)|0;Za=Ya+Oa*+n[Ta>>2];Ua=~~Za;Wa=Ua-(+(Ua|0)>Za&1)|0;Ua=c+(Y(Na,fb)|0)+(Wa<<2)|0;if(!(Na>>>0<kb>>>0&Wa>>>0<za>>>0))break;f[Ua>>2]=(f[Ua>>2]|0)+1}while(0);Va=Va+1|0;if((Va|0)==(W|0))break;else{Xa=Xa+(lb<<2)|0;Ta=Ta+(gb<<2)|0}}}if(!ib)break;else{Ga=Ga+G|0;Ha=Ha+(cb<<2)+(lb<<2)+(R<<2)|0;bb=bb+(Da<<2)+(gb<<2)+(mb<<2)|0}}break}case 3:{Oa=+p[d>>3];Ya=+p[d+8>>3];$a=+p[d+16>>3];ab=+p[d+24>>3];Za=+p[d+32>>3];_a=+p[d+40>>3];mb=f[s>>2]|0;gb=f[s+4>>2]|0;Da=f[s+8>>2]|0;bb=f[nb>>2]|0;R=f[nb+4>>2]|0;lb=f[nb+8>>2]|0;cb=f[nb+12>>2]|0;Ha=f[nb+16>>2]|0;Ga=f[nb+20>>2]|0;ib=f[t>>2]|0;za=f[t+4>>2]|0;if(!D)break g;kb=(W|0)>0;fb=Y(W,bb)|0;Ta=Y(W,lb)|0;Xa=Y(W,Ha)|0;Va=D;Ua=O;Wa=f[ea>>2]|0;Na=f[ea+4>>2]|0;Sa=f[ea+8>>2]|0;while(1){Va=Va+-1|0;do if(!Ua){if(!kb){yb=Wa;zb=Na;Ab=Sa;break}Ra=Na+(Ta<<2)|0;Qa=Wa;Pa=Na;a=Sa;ua=0;while(1){eb=Ya+Oa*+n[Qa>>2];U=~~eb;ya=U-(+(U|0)>eb&1)|0;eb=ab+$a*+n[Pa>>2];U=~~eb;xa=U-(+(U|0)>eb&1)|0;eb=_a+Za*+n[a>>2];U=~~eb;Ia=U-(+(U|0)>eb&1)|0;U=c+(Y(ya,ib)|0)+(Y(xa,za)|0)+(Ia<<2)|0;if(ya>>>0<mb>>>0&xa>>>0<gb>>>0&Ia>>>0<Da>>>0)f[U>>2]=(f[U>>2]|0)+1;ua=ua+1|0;if((ua|0)==(W|0))break;else{Qa=Qa+(bb<<2)|0;Pa=Pa+(lb<<2)|0;a=a+(Ha<<2)|0}}yb=Wa+(fb<<2)|0;zb=Ra;Ab=Sa+(Xa<<2)|0}else{if(!kb){yb=Wa;zb=Na;Ab=Sa;break}a=Na+(Ta<<2)|0;Pa=Wa;Qa=Na;ua=Sa;U=0;while(1){do if(b[Ua+U>>0]|0){eb=Ya+Oa*+n[Pa>>2];Ia=~~eb;xa=Ia-(+(Ia|0)>eb&1)|0;eb=ab+$a*+n[Qa>>2];Ia=~~eb;ya=Ia-(+(Ia|0)>eb&1)|0;eb=_a+Za*+n[ua>>2];Ia=~~eb;la=Ia-(+(Ia|0)>eb&1)|0;Ia=c+(Y(xa,ib)|0)+(Y(ya,za)|0)+(la<<2)|0;if(!(xa>>>0<mb>>>0&ya>>>0<gb>>>0&la>>>0<Da>>>0))break;f[Ia>>2]=(f[Ia>>2]|0)+1}while(0);U=U+1|0;if((U|0)==(W|0))break;else{Pa=Pa+(bb<<2)|0;Qa=Qa+(lb<<2)|0;ua=ua+(Ha<<2)|0}}yb=Wa+(fb<<2)|0;zb=a;Ab=Sa+(Xa<<2)|0}while(0);if(!Va)break;else{Ua=Ua+G|0;Wa=yb+(R<<2)|0;Na=zb+(cb<<2)|0;Sa=Ab+(Ga<<2)|0}}break}default:{if(!D)break g;Ga=(i|0)==0;Sa=(W|0)>0;cb=D;Na=O;while(1){cb=cb+-1|0;do if(!Na){if(!Sa){Ea=345;break}if(e)Bb=0;else{if(!Ga)break;R=f[c>>2]|0;Wa=0;do{R=R+1|0;Wa=Wa+1|0}while((Wa|0)!=(W|0));f[c>>2]=R;Ea=345;break}do{Wa=c;a=0;while(1){Ua=ea+(a<<2)|0;Va=f[Ua>>2]|0;Xa=a<<1;Za=+n[Va>>2]*+p[d+(Xa<<3)>>3]+ +p[d+((Xa|1)<<3)>>3];fb=~~Za;Ha=fb-(+(fb|0)>Za&1)|0;if(Ha>>>0>=(f[s+(a<<2)>>2]|0)>>>0){Cb=Wa;Db=a;break}f[Ua>>2]=Va+(f[nb+(Xa<<2)>>2]<<2);Xa=Wa+(Y(f[t+(a<<2)>>2]|0,Ha)|0)|0;Ha=a+1|0;if((Ha|0)<(i|0)){Wa=Xa;a=Ha}else{Cb=Xa;Db=Ha;break}}do if((Db|0)==(i|0))f[Cb>>2]=(f[Cb>>2]|0)+1;else{if((Db|0)<(i|0))Eb=Db;else break;do{a=ea+(Eb<<2)|0;f[a>>2]=(f[a>>2]|0)+(f[nb+(Eb<<1<<2)>>2]<<2);Eb=Eb+1|0}while((Eb|0)!=(i|0))}while(0);Bb=Bb+1|0}while((Bb|0)!=(W|0));Ea=345}else{if(!Sa){Ea=345;break}if(e)Fb=0;else{if(!Ga)break;R=f[c>>2]|0;a=0;do{R=R+1|0;a=a+1|0}while((a|0)!=(W|0));f[c>>2]=R;Ea=345;break}while(1){j:do if(!(b[Na+Fb>>0]|0)){Gb=c;Hb=0}else{a=c;Wa=0;while(1){Ha=ea+(Wa<<2)|0;Xa=f[Ha>>2]|0;Va=Wa<<1;Za=+n[Xa>>2]*+p[d+(Va<<3)>>3]+ +p[d+((Va|1)<<3)>>3];Ua=~~Za;fb=Ua-(+(Ua|0)>Za&1)|0;if(fb>>>0>=(f[s+(Wa<<2)>>2]|0)>>>0){Gb=a;Hb=Wa;break j}f[Ha>>2]=Xa+(f[nb+(Va<<2)>>2]<<2);Va=a+(Y(f[t+(Wa<<2)>>2]|0,fb)|0)|0;fb=Wa+1|0;if((fb|0)<(i|0)){a=Va;Wa=fb}else{Gb=Va;Hb=fb;break}}}while(0);do if((Hb|0)==(i|0))f[Gb>>2]=(f[Gb>>2]|0)+1;else{if((Hb|0)<(i|0))Ib=Hb;else break;do{Wa=ea+(Ib<<2)|0;f[Wa>>2]=(f[Wa>>2]|0)+(f[nb+(Ib<<1<<2)>>2]<<2);Ib=Ib+1|0}while((Ib|0)!=(i|0))}while(0);Fb=Fb+1|0;if((Fb|0)==(W|0)){Ea=345;break}}}while(0);do if((Ea|0)==345){Ea=0;if(e)Jb=0;else break;do{R=ea+(Jb<<2)|0;f[R>>2]=(f[R>>2]|0)+(f[nb+((Jb<<1|1)<<2)>>2]<<2);Jb=Jb+1|0}while((Jb|0)!=(i|0))}while(0);if(!cb)break;else Na=Na+G|0}}}while(0);break}default:{f[r>>2]=0;f[r+4>>2]=0;j$(-210,r,312249,311778,1498);d$(r)}}G=r+8|0;f[G>>2]=0;f[G+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=y;WJ(z,r,5,1.0,0.0);r=f[C>>2]|0;if(r|0){C=f[I>>2]|0;if((C|0)!=(r|0))f[I>>2]=C+(~((C+-8-r|0)>>>3)<<3);PYa(r)}r=f[B>>2]|0;if(r|0){B=f[g>>2]|0;if((B|0)!=(r|0))f[g>>2]=B+(~((B+-4-r|0)>>>2)<<2);PYa(r)}r=f[A>>2]|0;if(r|0){A=f[o>>2]|0;if((A|0)!=(r|0))f[o>>2]=A+(~((A+-4-r|0)>>>2)<<2);PYa(r)}r=f[X>>2]|0;if(r|0?(A=r+12|0,r=f[A>>2]|0,f[A>>2]=r+-1,(r|0)==1):0)CR(z);f[X>>2]=0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[ba>>2]|0)>0){_=f[Z>>2]|0;Z=0;do{f[_+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[ba>>2]|0))}ba=f[V>>2]|0;if((ba|0)!=(Q|0))ZF(ba);ba=f[da>>2]|0;if(ba|0?(Q=ba+12|0,ba=f[Q>>2]|0,f[Q>>2]=ba+-1,(ba|0)==1):0)CR(y);f[da>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[aa>>2]|0)>0){$=f[fa>>2]|0;fa=0;do{f[$+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[aa>>2]|0))}aa=f[y+44>>2]|0;if((aa|0)!=(y+48|0))ZF(aa);aa=w+36|0;y=f[aa>>2]|0;do if(y|0){fa=y+12|0;$=f[fa>>2]|0;f[fa>>2]=$+-1;if(($|0)!=1)break;CR(w)}while(0);f[aa>>2]=0;aa=w+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[aa>>2]|0)>0){H=f[w+40>>2]|0;y=0;do{f[H+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[aa>>2]|0))}aa=f[w+44>>2]|0;if((aa|0)!=(w+48|0))ZF(aa);if(!(f[v+4>>2]|0)){u=q;return}u=q;return}function Kfa(a,c,d,e,g,h,i,j,k,l,m,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0.0,$=0.0;q=u;u=u+16|0;r=q;s=(d|0)!=0;if(!(s|(c|0)==(g|0))){f[r>>2]=0;f[r+4>>2]=0;t=c$(r,32)|0;v=312421;w=t+32|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));j$(-215,r,312454,311778,128);d$(r)}x=f[a+40>>2]|0;y=f[x>>2]|0;f[m>>2]=f[x+4>>2];x=m+4|0;f[x>>2]=y;y=f[a>>2]|0;z=y&7;A=1212424721>>>(y<<2&28)&15;y=g+1|0;B=k+4|0;C=f[B>>2]|0;D=f[k>>2]|0;E=C-D>>2;F=D;D=C;if(y>>>0<=E>>>0){if(y>>>0<E>>>0?(C=F+(y<<2)|0,(D|0)!=(C|0)):0)f[B>>2]=D+(~((D+-4-C|0)>>>2)<<2)}else u9(k,y-E|0);E=y<<1;y=l+4|0;C=f[y>>2]|0;D=f[l>>2]|0;B=C-D>>2;F=D;D=C;if(E>>>0<=B>>>0){if(E>>>0<B>>>0?(C=F+(E<<2)|0,(D|0)!=(C|0)):0)f[y>>2]=D+(~((D+-4-C|0)>>>2)<<2)}else GM(l,E-B|0);B=(g|0)>0;if(B){E=r+4|0;C=(c|0)>0;D=r+4|0;y=r+4|0;F=r+4|0;G=0;H=1;while(1){a:do if(!s)if(!(f[a+(G*56|0)>>2]&4088)){I=0;J=G}else{f[r>>2]=0;f[F>>2]=0;t=c$(r,25)|0;v=312472;w=t+25|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));j$(-215,r,312454,311778,143);d$(r);I=0;J=G}else{K=f[d+(G<<2)>>2]|0;if((K|0)<=-1){f[r>>2]=0;f[E>>2]=0;L=c$(r,6)|0;b[L>>0]=b[312498]|0;b[L+1>>0]=b[312499]|0;b[L+2>>0]=b[312500]|0;b[L+3>>0]=b[312501]|0;b[L+4>>0]=b[312502]|0;b[L+5>>0]=b[312503]|0;j$(-215,r,312454,311778,148);d$(r)}if(C){L=K;M=0;while(1){N=(f[a+(M*56|0)>>2]|0)>>>3&511;if((L|0)<=(N|0)){I=L;J=M;break a}O=L+-1-N|0;N=M+1|0;if((N|0)<(c|0)){L=O;M=N}else{P=O;Q=N;break}}}else{P=K;Q=0}f[r>>2]=0;f[D>>2]=0;t=c$(r,11)|0;v=312505;w=t+11|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));j$(-215,r,312454,311778,152);d$(r);I=P;J=Q}while(0);K=a+(J*56|0)|0;M=f[a+(J*56|0)+40>>2]|0;if(((f[M>>2]|0)==(f[x>>2]|0)?(f[M+4>>2]|0)==(f[m>>2]|0):0)?(M=f[K>>2]|0,(M&7|0)==(z|0)):0)R=M;else{f[r>>2]=0;f[y>>2]=0;t=c$(r,56)|0;v=312517;w=t+56|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));j$(-215,r,312454,311778,155);d$(r);R=f[K>>2]|0}M=H&(R&16384|0)!=0;L=(f[a+(J*56|0)+16>>2]|0)+(Y(I,A)|0)|0;f[(f[k>>2]|0)+(G<<2)>>2]=L;L=(R>>>3&511)+1|0;N=G<<1;O=f[l>>2]|0;f[O+(N<<2)>>2]=L;S=(((f[a+(J*56|0)+48>>2]|0)>>>0)/(A>>>0)|0)-(Y(L,f[m>>2]|0)|0)|0;f[O+((N|1)<<2)>>2]=S;G=G+1|0;if((G|0)>=(g|0)){T=M;break}else H=M}}else T=1;H=e+16|0;do if(!(f[H>>2]|0)){if(T)U=42}else{G=f[e+4>>2]|0;if((G|0)<3)V=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{A=f[e+40>>2]|0;J=0;a=1;while(1){R=Y(f[A+(J<<2)>>2]|0,a)|0;J=J+1|0;if((J|0)==(G|0)){V=R;break}else a=R}}if((G|0)==0|(V|0)==0)if(T){U=42;break}else break;a=f[e+40>>2]|0;if(!(((f[a>>2]|0)==(f[x>>2]|0)?(f[a+4>>2]|0)==(f[m>>2]|0):0)?!(f[e>>2]&4088|0):0)){f[r>>2]=0;f[r+4>>2]=0;t=c$(r,45)|0;v=312574;w=t+45|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));j$(-215,r,312454,311778,165);d$(r)}if(T)W=(f[e>>2]&16384|0)!=0;else W=0;f[(f[k>>2]|0)+(g<<2)>>2]=f[H>>2];G=g<<1;a=f[l>>2]|0;f[a+(G<<2)>>2]=1;f[a+((G|1)<<2)>>2]=((f[e+48>>2]|0)>>>0)/((1212424721>>>(f[e>>2]<<2&28)&15)>>>0)|0;if(W)U=42}while(0);if((U|0)==42){U=Y(f[m>>2]|0,f[x>>2]|0)|0;f[m>>2]=U;f[x>>2]=1}if(!i){if(z|0){f[r>>2]=0;f[r+4>>2]=0;t=c$(r,10)|0;v=347832;w=t+10|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));j$(-215,r,312454,311778,182);d$(r)}z=g<<1;x=o+4|0;U=f[x>>2]|0;m=f[o>>2]|0;W=U-m>>3;e=m;m=U;if(z>>>0<=W>>>0){if(z>>>0<W>>>0?(U=e+(z<<3)|0,(m|0)!=(U|0)):0)f[x>>2]=m+(~((m+-8-U|0)>>>3)<<3)}else Mfa(o,z-W|0);if(!B){u=q;return}W=f[o>>2]|0;z=0;do{U=z<<1;p[W+(U<<3)>>3]=+(f[h+(z<<2)>>2]|0)*.00390625;p[W+((U|1)<<3)>>3]=0.0;z=z+1|0}while((z|0)!=(g|0));u=q;return}if(!j){if(!B){u=q;return}j=r+4|0;z=0;do{W=f[h+(z<<2)>>2]|0;if(W|0){U=i+(z<<2)|0;m=0;do{x=f[U>>2]|0;e=m;m=m+1|0;if(!(+n[x+(e<<2)>>2]<+n[x+(m<<2)>>2])){f[r>>2]=0;f[j>>2]=0;t=c$(r,29)|0;v=312661;w=t+29|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));j$(-215,r,312454,311778,209);d$(r)}}while(m>>>0<W>>>0)}z=z+1|0}while((z|0)<(g|0));u=q;return}z=g<<1;j=o+4|0;W=f[j>>2]|0;m=f[o>>2]|0;U=W-m>>3;x=m;m=W;if(z>>>0<=U>>>0){if(z>>>0<U>>>0?(W=x+(z<<3)|0,(m|0)!=(W|0)):0)f[j>>2]=m+(~((m+-8-W|0)>>>3)<<3)}else Mfa(o,z-U|0);if(!B){u=q;return}B=r+4|0;U=0;do{z=i+(U<<2)|0;W=f[z>>2]|0;if((W|0)!=0?(X=+n[W>>2],Z=+n[W+4>>2],X<Z):0){_=X;$=Z}else{f[r>>2]=0;f[B>>2]=0;t=c$(r,40)|0;v=312620;w=t+40|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));j$(-215,r,312454,311778,196);d$(r);W=f[z>>2]|0;_=+n[W>>2];$=+n[W+4>>2]}Z=_;X=+(f[h+(U<<2)>>2]|0)/($-Z);W=U<<1;m=f[o>>2]|0;p[m+(W<<3)>>3]=X;p[m+((W|1)<<3)>>3]=-(Z*X);U=U+1|0}while((U|0)<(g|0));u=q;return}function Lfa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;k=u;u=u+16|0;l=k;m=d<<8;o=j+4|0;q=f[o>>2]|0;r=f[j>>2]|0;s=q-r>>2;t=r;r=q;if(m>>>0<=s>>>0)if(m>>>0<s>>>0?(q=t+(m<<2)|0,(r|0)!=(q|0)):0){f[o>>2]=r+(~((r+-4-q|0)>>>2)<<2);v=t}else v=t;else{cU(j,m-s|0);v=f[j>>2]|0}if(h){if((d|0)<=0){u=k;return}h=f[c+4>>2]|0;j=(h|0)==0;s=f[a+40>>2]|0;m=f[a+44>>2]|0;if(i)w=0;else{t=0;do{q=t<<1;x=+p[g+(q<<3)>>3];y=+p[g+((q|1)<<3)>>3];q=f[s+(t<<2)>>2]|0;r=f[m+(t<<2)>>2]|0;o=t<<8;z=0;do{A=y+x*+(z|0);B=~~A;C=B-(+(B|0)>A&1)|0;B=Y(C,r)|0;f[v+(z+o<<2)>>2]=C>>>0<q>>>0?B:1073741824;z=z+1|0}while((z|0)!=256);t=t+1|0}while((t|0)!=(d|0));u=k;return}do{t=w<<1;x=+p[g+(t<<3)>>3];y=+p[g+((t|1)<<3)>>3];if(j)D=0;else D=f[h+48+(w<<2)>>2]|0;t=w<<8;m=0;do{A=y+x*+(m|0);s=~~A;z=s-(+(s|0)>A&1)|0;f[v+(m+t<<2)>>2]=z>>>0<D>>>0?z:1073741824;m=m+1|0}while((m|0)!=256);w=w+1|0}while((w|0)!=(d|0));u=k;return}if(!e){f[l>>2]=0;f[l+4>>2]=0;w=c$(l,55)|0;D=312331;h=w+55|0;do{b[w>>0]=b[D>>0]|0;w=w+1|0;D=D+1|0}while((w|0)<(h|0));j$(-5,l,312397,311778,116);d$(l);u=k;return}if((d|0)<=0){u=k;return}l=f[c+4>>2]|0;c=(l|0)==0;D=f[a+40>>2]|0;w=f[a+44>>2]|0;if(i)E=0;else{i=0;do{a=f[e+(i<<2)>>2]|0;x=+n[a>>2];h=~~x;j=(+(h|0)<x&1)+h|0;h=f[D+(i<<2)>>2]|0;g=f[w+(i<<2)>>2]|0;m=i<<8;t=-1;z=0;s=(j|0)<256?j:256;j=1073741824;while(1){if((z|0)<(s|0)){q=z;do{f[v+(q+m<<2)>>2]=j;q=q+1|0}while((q|0)!=(s|0));F=s}else F=z;q=t+1|0;if(q>>>0>=h>>>0)break;x=+n[a+(t+2<<2)>>2];o=~~x;r=(+(o|0)<x&1)+o|0;t=q;z=F;s=(r|0)<256?r:256;j=Y(q,g)|0}if((F|0)<256){g=F;do{f[v+(g+m<<2)>>2]=1073741824;g=g+1|0}while((g|0)!=256)}i=i+1|0}while((i|0)!=(d|0));u=k;return}do{i=f[e+(E<<2)>>2]|0;x=+n[i>>2];F=~~x;w=(+(F|0)<x&1)+F|0;if(c)G=0;else G=f[l+48+(E<<2)>>2]|0;F=E<<8;D=-1;g=0;m=(w|0)<256?w:256;w=1073741824;while(1){if((g|0)<(m|0)){j=g;do{f[v+(j+F<<2)>>2]=w;j=j+1|0}while((j|0)!=(m|0));H=m}else H=g;j=D+1|0;if(j>>>0>=G>>>0)break;x=+n[i+(D+2<<2)>>2];s=~~x;z=(+(s|0)<x&1)+s|0;D=j;g=H;m=(z|0)<256?z:256;w=j}if((H|0)<256){w=H;do{f[v+(w+F<<2)>>2]=1073741824;w=w+1|0}while((w|0)!=256)}E=E+1|0}while((E|0)!=(d|0));u=k;return}function Mfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){F1a(g|0,0,b<<3|0)|0;f[e>>2]=g+(b<<3);return}h=f[a>>2]|0;i=g-h|0;g=i>>3;j=g+b|0;if(j>>>0>536870911)gXa(a);k=d-h|0;d=k>>2;l=k>>3>>>0<268435455?(d>>>0<j>>>0?j:d):536870911;do if(l)if(l>>>0>536870911){d=De(8)|0;UYa(d,358155);f[d>>2]=130560;Of(d|0,21520,875)}else{m=NYa(l<<3)|0;break}else m=0;while(0);d=m+(g<<3)|0;F1a(d|0,0,b<<3|0)|0;j=d+(0-g<<3)|0;if((i|0)>0)K1a(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<3);f[c>>2]=m+(l<<3);if(!h)return;PYa(h);return}function Nfa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;j=u;u=u+1664|0;k=j+1648|0;l=j+1520|0;m=j+56|0;n=j;_$(k,72436);o=(f[g+4>>2]|0)-(f[g>>2]|0)|0;p=o>>2;q=(f[h+4>>2]|0)-(f[h>>2]|0)|0;r=q>>2;s=(f[c+4>>2]|0)-(f[c>>2]|0)>>2;t=US(a,-1)|0;v=(t|0)>0;if(!((o|0)>0&v)){f[l>>2]=0;f[l+4>>2]=0;w=c$(l,23)|0;x=312815;y=w+23|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));j$(-215,l,312249,311778,1780);d$(l)}do if((r|0)!=(o>>1|0)){if((r|0)==0?(VS(a,0)|0)==0:0)break;f[l>>2]=0;f[l+4>>2]=0;w=c$(l,51)|0;x=312839;y=w+51|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));j$(-215,l,312249,311778,1781);d$(l)}while(0);o=(s|0)==0;if(!(o|(s|0)==(p|0))){f[l>>2]=0;f[l+4>>2]=0;w=c$(l,23)|0;x=312891;y=w+23|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));j$(-215,l,312249,311778,1782);d$(l)}if((q|0)>0?(x=(r|0)/2|0,(q|0)>4):0){q=f[h>>2]|0;h=0;do{f[l+(h<<2)>>2]=q+(h<<1<<2);h=h+1|0}while((h|0)<(x|0))}PI(m,t);if(v){v=n+4|0;x=n+8|0;h=n+12|0;q=n+16|0;w=n+20|0;y=n+24|0;s=n+28|0;z=n+32|0;A=n+36|0;B=n+40|0;C=n+48|0;D=n+44|0;E=0;do{OR(n,a,E);F=f[m>>2]|0;G=F+(E*56|0)|0;if((G|0)!=(n|0)){H=f[A>>2]|0;if(H|0){I=H+12|0;f[I>>2]=(f[I>>2]|0)+1}I=F+(E*56|0)+36|0;H=f[I>>2]|0;if(H|0?(J=H+12|0,H=f[J>>2]|0,f[J>>2]=H+-1,(H|0)==1):0)CR(G);f[I>>2]=0;H=F+(E*56|0)+16|0;J=F+(E*56|0)+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[J>>2]|0)>0){K=f[F+(E*56|0)+40>>2]|0;L=0;do{f[K+(L<<2)>>2]=0;L=L+1|0;M=f[J>>2]|0}while((L|0)<(M|0));f[G>>2]=f[n>>2];if((M|0)<3)N=27;else N=29}else{f[G>>2]=f[n>>2];N=27}if((N|0)==27){N=0;L=f[v>>2]|0;if((L|0)<3){f[J>>2]=L;f[F+(E*56|0)+8>>2]=f[x>>2];f[F+(E*56|0)+12>>2]=f[h>>2];L=f[D>>2]|0;K=f[F+(E*56|0)+44>>2]|0;f[K>>2]=f[L>>2];f[K+4>>2]=f[L+4>>2]}else N=29}if((N|0)==29){N=0;BR(G,n)}f[H>>2]=f[q>>2];f[F+(E*56|0)+20>>2]=f[w>>2];f[F+(E*56|0)+24>>2]=f[y>>2];f[F+(E*56|0)+28>>2]=f[s>>2];f[F+(E*56|0)+32>>2]=f[z>>2];f[I>>2]=f[A>>2]}L=f[A>>2]|0;if(L|0?(K=L+12|0,L=f[K>>2]|0,f[K>>2]=L+-1,(L|0)==1):0)CR(n);f[A>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[v>>2]|0)>0){L=f[B>>2]|0;K=0;do{f[L+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[v>>2]|0))}K=f[D>>2]|0;if((K|0)!=(C|0))ZF(K);E=E+1|0}while((E|0)<(t|0));O=m}else O=m;Jfa(f[O>>2]|0,t,o?0:f[c>>2]|0,d,e,p,f[g>>2]|0,r|0?l:0,1,i);QI(m);if(!(f[k+4>>2]|0)){u=j;return}u=j;return}function Ofa(a,c,e,g,i,k,l,m){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=+l;m=m|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0,wa=0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0.0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0,Xa=0,Ya=0,Za=0;o=u;u=u+688|0;q=o+560|0;r=o+304|0;s=o+176|0;t=o+168|0;v=o+104|0;w=o+88|0;x=o+76|0;y=o+64|0;z=o+56|0;A=o+160|0;B=o;_$(t,72456);do if((NS(g)|0)==65536){C=f[g+4>>2]|0;f[v>>2]=f[C>>2];D=v+4|0;E=C+4|0;f[D>>2]=f[E>>2];F=v+8|0;f[F>>2]=f[C+8>>2];f[v+12>>2]=f[C+12>>2];f[v+16>>2]=f[C+16>>2];f[v+20>>2]=f[C+20>>2];f[v+24>>2]=f[C+24>>2];f[v+28>>2]=f[C+28>>2];f[v+32>>2]=f[C+32>>2];G=f[C+36>>2]|0;f[v+36>>2]=G;f[v+40>>2]=F;F=v+48|0;H=v+44|0;f[H>>2]=F;f[F>>2]=0;f[v+52>>2]=0;if(G|0){F=G+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[E>>2]|0)<3){E=f[C+44>>2]|0;F=f[H>>2]|0;f[F>>2]=f[E>>2];f[F+4>>2]=f[E+4>>2];I=D;break}else{f[D>>2]=0;BR(v,C);I=D;break}}else{OR(v,g,-1);I=v+4|0}while(0);f[w>>2]=0;g=w+4|0;f[g>>2]=0;f[w+8>>2]=0;f[x>>2]=0;D=x+4|0;f[D>>2]=0;f[x+8>>2]=0;f[y>>2]=0;C=y+4|0;f[C>>2]=0;f[y+8>>2]=0;f[z>>2]=0;E=z+4|0;f[E>>2]=0;F=f[I>>2]|0;if((F|0)!=2)if((F|0)>0){J=F;K=11}else{L=0;M=F;K=17}else{J=(f[(f[v+40>>2]|0)+4>>2]|0)==1?1:2;K=11}if((K|0)==11)if(f[v+16>>2]|0){if((F|0)<3)N=Y(f[v+12>>2]|0,f[v+8>>2]|0)|0;else{H=f[v+40>>2]|0;G=0;O=1;while(1){P=Y(f[H+(G<<2)>>2]|0,O)|0;G=G+1|0;if((G|0)==(F|0)){N=P;break}else O=P}}if(!((F|0)==0|(N|0)==0)){Q=1;R=J}else{L=1;M=J;K=17}}else{L=1;M=J;K=17}if((K|0)==17){f[q>>2]=0;f[q+4>>2]=0;S=c$(q,25)|0;T=313064;U=S+25|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));j$(-215,q,313090,311778,2111);d$(q);Q=L;R=M}M=f[a+40>>2]|0;L=f[M>>2]|0;f[A>>2]=f[M+4>>2];f[A+4>>2]=L;KS(i,A,f[a>>2]&7,-1,0,0);do if((NS(i)|0)==65536){A=f[i+4>>2]|0;f[B>>2]=f[A>>2];L=B+4|0;M=A+4|0;f[L>>2]=f[M>>2];J=B+8|0;f[J>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];f[B+32>>2]=f[A+32>>2];N=f[A+36>>2]|0;f[B+36>>2]=N;f[B+40>>2]=J;J=B+48|0;F=B+44|0;f[F>>2]=J;f[J>>2]=0;f[B+52>>2]=0;if(N|0){J=N+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[M>>2]|0)<3){M=f[A+44>>2]|0;J=f[F>>2]|0;f[J>>2]=f[M>>2];f[J+4>>2]=f[M+4>>2];break}else{f[L>>2]=0;BR(B,A);break}}else OR(B,i,-1);while(0);i=v+40|0;Kfa(a,c,e,B,R,f[i>>2]|0,k,m,w,x,z,y);e=m?f[y>>2]|0:0;switch(f[a>>2]&7){case 0:{a=f[z>>2]|0;c=f[E>>2]|0;V=l;A=f[w>>2]|0;L=f[x>>2]|0;M=f[v+16>>2]|0;J=f[A+(R<<2)>>2]|0;F=f[L+((R<<1|1)<<2)>>2]|0;f[q>>2]=0;N=q+4|0;f[N>>2]=0;f[q+8>>2]=0;f[r>>2]=1123876864;f[r+4>>2]=0;Lfa(v,r,R,k,e,m,0,q);O=f[q>>2]|0;switch(R|0){case 1:{G=f[L>>2]|0;H=f[L+4>>2]|0;F1a(r|0,0,256)|0;P=f[A>>2]|0;W=0;do{X=f[O+(W<<2)>>2]|0;if(X>>>0<1073741824){Z=wNa(V*+n[M+X>>2])|0;b[r+W>>0]=Z>>>0<256?Z:(Z|0)>0?255:0}W=W+1|0}while((W|0)!=256);W=c+-1|0;a:do if(c|0){Z=G<<1;X=(a|0)<4;_=a+-4|0;if((G|0)==1){if(X){$=(a|0)>0;aa=W;ba=J;ca=P;while(1){if($){da=ca;ea=0;while(1){b[ba+ea>>0]=b[r+(h[da>>0]|0)>>0]|0;ea=ea+1|0;if((ea|0)==(a|0))break;else da=da+1|0}fa=ca+a|0}else fa=ca;if(!aa)break a;else{aa=aa+-1|0;ba=ba+F|0;ca=fa+H|0}}}ca=a&-4;ba=(ca|0)<(a|0);aa=W;$=J;da=P;while(1){ea=da;ga=0;while(1){ha=ga|1;ia=b[r+(h[da+ha>>0]|0)>>0]|0;b[$+ga>>0]=b[r+(h[ea>>0]|0)>>0]|0;b[$+ha>>0]=ia;ia=ga|2;ha=ga|3;ja=b[r+(h[da+ha>>0]|0)>>0]|0;b[$+ia>>0]=b[r+(h[da+ia>>0]|0)>>0]|0;b[$+ha>>0]=ja;ja=ga+4|0;if((ja|0)>(_|0))break;else{ea=da+ja|0;ga=ja}}if(ba){ga=da+ca|0;ea=ca;while(1){b[$+ea>>0]=b[r+(h[ga>>0]|0)>>0]|0;ea=ea+1|0;if((ea|0)==(a|0)){ka=a;break}else ga=ga+1|0}}else ka=ca;if(!aa)break;else{aa=aa+-1|0;$=$+F|0;da=da+ka+H|0}}}else{if(X){da=Y(a,G)|0;$=(a|0)>0;aa=W;ca=J;ba=P;while(1){if($){ga=ba;ea=0;while(1){b[ca+ea>>0]=b[r+(h[ga>>0]|0)>>0]|0;ea=ea+1|0;if((ea|0)==(a|0))break;else ga=ga+G|0}la=ba+da|0}else la=ba;if(!aa)break a;else{aa=aa+-1|0;ca=ca+F|0;ba=la+H|0}}}ba=a&-4;ca=Y(G,ba)|0;aa=Y(a,G)|0;da=(ba|0)<(a|0);$=W;X=J;ga=P;while(1){ea=ga;ja=0;while(1){ha=b[r+(h[ea+G>>0]|0)>>0]|0;b[X+ja>>0]=b[r+(h[ea>>0]|0)>>0]|0;b[X+(ja|1)>>0]=ha;ha=ea+Z|0;ia=b[r+(h[ha+G>>0]|0)>>0]|0;b[X+(ja|2)>>0]=b[r+(h[ha>>0]|0)>>0]|0;b[X+(ja|3)>>0]=ia;ja=ja+4|0;if((ja|0)>(_|0))break;else ea=ha+Z|0}if(da){ea=ga+ca|0;ja=ba;while(1){b[X+ja>>0]=b[r+(h[ea>>0]|0)>>0]|0;ja=ja+1|0;if((ja|0)==(a|0)){ma=aa;break}else ea=ea+G|0}}else ma=ca;if(!$)break;else{$=$+-1|0;X=X+F|0;ga=ga+ma+H|0}}}}while(0);break}case 2:{H=f[L>>2]|0;ma=f[L+4>>2]|0;G=f[L+8>>2]|0;P=f[L+12>>2]|0;if((c|0)!=0&(a|0)>0){W=Y(a,H)|0;la=Y(a,G)|0;ka=c;fa=J;ga=f[A>>2]|0;X=f[A+4>>2]|0;while(1){$=ga+W|0;ca=ga;aa=X;ba=0;while(1){da=(f[O+((h[aa>>0]|0|256)<<2)>>2]|0)+(f[O+((h[ca>>0]|0)<<2)>>2]|0)|0;if(da>>>0<1073741824){Z=wNa(V*+n[M+da>>2])|0;na=(Z>>>0<256?Z:(Z|0)>0?255:0)&255}else na=0;b[fa+ba>>0]=na;ba=ba+1|0;if((ba|0)==(a|0))break;else{ca=ca+H|0;aa=aa+G|0}}ka=ka+-1|0;if(!ka)break;else{fa=fa+F|0;ga=$+ma|0;X=X+la+P|0}}}break}case 3:{P=f[L>>2]|0;la=f[L+4>>2]|0;X=f[L+8>>2]|0;ma=f[L+12>>2]|0;ga=f[L+16>>2]|0;fa=f[L+20>>2]|0;if((c|0)!=0&(a|0)>0){ka=Y(a,P)|0;G=Y(a,X)|0;H=Y(a,ga)|0;na=c;W=J;aa=f[A>>2]|0;ca=f[A+4>>2]|0;ba=f[A+8>>2]|0;while(1){na=na+-1|0;Z=ca+G|0;da=aa;_=ca;ea=ba;ja=0;while(1){ha=(f[O+((h[_>>0]|0|256)<<2)>>2]|0)+(f[O+((h[da>>0]|0)<<2)>>2]|0)+(f[O+((h[ea>>0]|0|512)<<2)>>2]|0)|0;if(ha>>>0<1073741824){ia=wNa(V*+n[M+ha>>2])|0;oa=(ia>>>0<256?ia:(ia|0)>0?255:0)&255}else oa=0;b[W+ja>>0]=oa;ja=ja+1|0;if((ja|0)==(a|0))break;else{da=da+P|0;_=_+X|0;ea=ea+ga|0}}if(!na)break;else{W=W+F|0;aa=aa+ka+la|0;ca=Z+ma|0;ba=ba+H+fa|0}}}break}default:if(c|0){fa=(R|0)==0;H=(a|0)>0;ba=c;c=J;ma=0;while(1){ca=J+(Y(F,ma)|0)|0;ba=ba+-1|0;b:do if(H){if(!Q)if(fa){la=0;while(1){ka=wNa(V*+n[M>>2])|0;b[c+la>>0]=ka>>>0<256?ka:(ka|0)>0?255:0;la=la+1|0;if((la|0)==(a|0)){K=89;break b}}}else{F1a(ca|0,0,a|0)|0;break}else pa=0;do{la=M;ka=0;while(1){aa=A+(ka<<2)|0;W=f[aa>>2]|0;na=f[O+((h[W>>0]|0|ka<<8)<<2)>>2]|0;if(na>>>0>1073741823){qa=la;ra=ka;break}ga=la+na|0;f[aa>>2]=W+(f[L+(ka<<1<<2)>>2]|0);W=ka+1|0;if((W|0)<(R|0)){la=ga;ka=W}else{qa=ga;ra=W;break}}if((ra|0)!=(R|0)){b[c+pa>>0]=0;if((ra|0)<(R|0)){ka=ra;do{la=A+(ka<<2)|0;f[la>>2]=(f[la>>2]|0)+(f[L+(ka<<1<<2)>>2]|0);ka=ka+1|0}while((ka|0)!=(R|0))}}else{ka=wNa(V*+n[qa>>2])|0;b[c+pa>>0]=ka>>>0<256?ka:(ka|0)>0?255:0}pa=pa+1|0}while((pa|0)!=(a|0));K=89}else K=89;while(0);if((K|0)==89?(K=0,Q):0){ca=0;do{Z=A+(ca<<2)|0;f[Z>>2]=(f[Z>>2]|0)+(f[L+((ca<<1|1)<<2)>>2]|0);ca=ca+1|0}while((ca|0)!=(R|0))}if(!ba)break;else{c=c+F|0;ma=ma+1|0}}}}ma=f[q>>2]|0;if(ma|0){F=f[N>>2]|0;if((F|0)!=(ma|0))f[N>>2]=F+(~((F+-4-ma|0)>>>2)<<2);PYa(ma)}break}case 2:{ma=f[z>>2]|0;F=f[E>>2]|0;V=l;N=f[w>>2]|0;c=f[x>>2]|0;ba=f[v+16>>2]|0;L=f[N+(R<<2)>>2]|0;A=f[c+((R<<1|1)<<2)>>2]|0;a=R<<2;if(Q){pa=f[v+44>>2]|0;K1a(r|0,f[i>>2]|0,a|0)|0;K1a(s|0,pa|0,a|0)|0}c:do if(!m){if(!k){f[q>>2]=0;f[q+4>>2]=0;S=c$(q,55)|0;T=312331;U=S+55|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));j$(-5,q,313106,311778,1969);d$(q);break}if(Q)K1a(q|0,k|0,a|0)|0;if(F|0){pa=(ma|0)>0;qa=(R|0)==0;ra=ma<<1;O=F;M=L;fa=0;while(1){H=L+((Y(A,fa)|0)<<1)|0;O=O+-1|0;d:do if(pa){if(Q)sa=0;else{if(!qa){F1a(H|0,0,ra|0)|0;break}J=wNa(V*+n[ba>>2])|0;ca=(J>>>0<65536?J:(J|0)>0?65535:0)&65535;J=0;while(1){d[M+(J<<1)>>1]=ca;J=J+1|0;if((J|0)==(ma|0)){K=163;break d}}}do{J=ba;ca=0;while(1){Z=N+(ca<<2)|0;ka=f[Z>>2]|0;ta=+(j[ka>>1]|0);la=f[q+(ca<<2)>>2]|0;W=f[r+(ca<<2)>>2]|0;ga=-1;while(1){aa=ga+1|0;if(!(ta>=+n[la+(aa<<2)>>2])){ua=ga;break}if((aa|0)<(W|0))ga=aa;else{ua=aa;break}}if(ua>>>0>=W>>>0){va=J;wa=ca;break}f[Z>>2]=ka+(f[c+(ca<<1<<2)>>2]<<1);ga=J+(Y(f[s+(ca<<2)>>2]|0,ua)|0)|0;la=ca+1|0;if((la|0)<(R|0)){J=ga;ca=la}else{va=ga;wa=la;break}}if((wa|0)!=(R|0)){d[M+(sa<<1)>>1]=0;if((wa|0)<(R|0)){ca=wa;do{J=N+(ca<<2)|0;f[J>>2]=(f[J>>2]|0)+(f[c+(ca<<1<<2)>>2]<<1);ca=ca+1|0}while((ca|0)!=(R|0))}}else{ca=wNa(V*+n[va>>2])|0;d[M+(sa<<1)>>1]=ca>>>0<65536?ca:(ca|0)>0?65535:0}sa=sa+1|0}while((sa|0)!=(ma|0));K=163}else K=163;while(0);if((K|0)==163?(K=0,Q):0){H=0;do{ca=N+(H<<2)|0;f[ca>>2]=(f[ca>>2]|0)+(f[c+((H<<1|1)<<2)>>2]<<1);H=H+1|0}while((H|0)!=(R|0))}if(!O)break;else{M=M+(A<<1)|0;fa=fa+1|0}}}}else switch(R|0){case 1:{ta=+p[e>>3];xa=+p[e+8>>3];fa=f[r>>2]|0;M=f[c>>2]|0;O=f[c+4>>2]|0;if(!F)break c;if((ma|0)<=0)break c;ra=Y(ma,M)|0;qa=L;pa=F;H=f[N>>2]|0;while(1){pa=pa+-1|0;ca=H;J=0;while(1){ya=xa+ta*+(j[ca>>1]|0);la=~~ya;ga=la-(+(la|0)>ya&1)|0;if(ga>>>0<fa>>>0){la=wNa(V*+n[ba+(ga<<2)>>2])|0;za=(la>>>0<65536?la:(la|0)>0?65535:0)&65535}else za=0;d[qa+(J<<1)>>1]=za;J=J+1|0;if((J|0)==(ma|0))break;else ca=ca+(M<<1)|0}if(!pa)break;else{qa=qa+(A<<1)|0;H=H+(ra<<1)+(O<<1)|0}}break}case 2:{ta=+p[e>>3];xa=+p[e+8>>3];ya=+p[e+16>>3];Aa=+p[e+24>>3];O=f[r>>2]|0;ra=f[r+4>>2]|0;H=f[c>>2]|0;qa=f[c+4>>2]|0;pa=f[c+8>>2]|0;M=f[c+12>>2]|0;fa=f[s>>2]|0;if(!((ma|0)>0&(F|0)!=0))break c;ca=Y(ma,H)|0;J=Y(ma,pa)|0;la=L;ga=F;aa=f[N>>2]|0;na=f[N+4>>2]|0;while(1){X=aa+(ca<<1)|0;P=aa;oa=na;G=0;while(1){Ba=xa+ta*+(j[P>>1]|0);ea=~~Ba;_=ea-(+(ea|0)>Ba&1)|0;Ba=Aa+ya*+(j[oa>>1]|0);ea=~~Ba;da=ea-(+(ea|0)>Ba&1)|0;if(_>>>0<O>>>0&da>>>0<ra>>>0){ea=ba+(Y(_,fa)|0)+(da<<2)|0;da=wNa(V*+n[ea>>2])|0;Ca=(da>>>0<65536?da:(da|0)>0?65535:0)&65535}else Ca=0;d[la+(G<<1)>>1]=Ca;G=G+1|0;if((G|0)==(ma|0))break;else{P=P+(H<<1)|0;oa=oa+(pa<<1)|0}}ga=ga+-1|0;if(!ga)break;else{la=la+(A<<1)|0;aa=X+(qa<<1)|0;na=na+(J<<1)+(M<<1)|0}}break}case 3:{ya=+p[e>>3];Aa=+p[e+8>>3];ta=+p[e+16>>3];xa=+p[e+24>>3];Ba=+p[e+32>>3];Da=+p[e+40>>3];M=f[r>>2]|0;J=f[r+4>>2]|0;na=f[r+8>>2]|0;qa=f[c>>2]|0;aa=f[c+4>>2]|0;la=f[c+8>>2]|0;ga=f[c+12>>2]|0;pa=f[c+16>>2]|0;H=f[c+20>>2]|0;fa=f[s>>2]|0;ra=f[s+4>>2]|0;if(!((ma|0)>0&(F|0)!=0))break c;O=Y(ma,qa)|0;ca=Y(ma,la)|0;oa=Y(ma,pa)|0;P=L;G=F;da=f[N>>2]|0;ea=f[N+4>>2]|0;_=f[N+8>>2]|0;while(1){G=G+-1|0;ja=ea+(ca<<1)|0;$=da;ia=ea;ha=_;Ea=0;while(1){Fa=Aa+ya*+(j[$>>1]|0);Ga=~~Fa;Ha=Ga-(+(Ga|0)>Fa&1)|0;Fa=xa+ta*+(j[ia>>1]|0);Ga=~~Fa;Ia=Ga-(+(Ga|0)>Fa&1)|0;Fa=Da+Ba*+(j[ha>>1]|0);Ga=~~Fa;Ja=Ga-(+(Ga|0)>Fa&1)|0;if(Ha>>>0<M>>>0&Ia>>>0<J>>>0&Ja>>>0<na>>>0){Ga=ba+(Y(Ha,fa)|0)+(Y(Ia,ra)|0)+(Ja<<2)|0;Ja=wNa(V*+n[Ga>>2])|0;Ka=(Ja>>>0<65536?Ja:(Ja|0)>0?65535:0)&65535}else Ka=0;d[P+(Ea<<1)>>1]=Ka;Ea=Ea+1|0;if((Ea|0)==(ma|0))break;else{$=$+(qa<<1)|0;ia=ia+(la<<1)|0;ha=ha+(pa<<1)|0}}if(!G)break;else{P=P+(A<<1)|0;da=da+(O<<1)+(aa<<1)|0;ea=ja+(ga<<1)|0;_=_+(oa<<1)+(H<<1)|0}}break}default:{if(!F)break c;H=(k|0)==0;oa=(ma|0)>0;_=F;ga=L;while(1){_=_+-1|0;if(oa){ea=0;do{e:do if(Q){if(H){aa=ba;O=0;while(1){da=N+(O<<2)|0;P=f[da>>2]|0;G=O<<1;Ba=+(j[P>>1]|0)*+p[e+(G<<3)>>3]+ +p[e+((G|1)<<3)>>3];pa=~~Ba;la=pa-(+(pa|0)>Ba&1)|0;if(la>>>0>=(f[r+(O<<2)>>2]|0)>>>0){La=aa;Ma=O;break e}f[da>>2]=P+(f[c+(G<<2)>>2]<<1);G=aa+(Y(f[s+(O<<2)>>2]|0,la)|0)|0;la=O+1|0;if((la|0)<(R|0)){aa=G;O=la}else{La=G;Ma=la;break e}}}else{Na=ba;Oa=0}while(1){O=N+(Oa<<2)|0;aa=f[O>>2]|0;la=d[aa>>1]|0;G=Oa<<1;Ba=+(la&65535)*+p[e+(G<<3)>>3]+ +p[e+((G|1)<<3)>>3];P=~~Ba;da=P-(+(P|0)>Ba&1)|0;if(da>>>0>=(f[r+(Oa<<2)>>2]|0)>>>0){La=Na;Ma=Oa;break e}if(+(la&65535)>=+n[(f[k+(Oa<<2)>>2]|0)+4>>2]){La=Na;Ma=Oa;break e}f[O>>2]=aa+(f[c+(G<<2)>>2]<<1);G=Na+(Y(f[s+(Oa<<2)>>2]|0,da)|0)|0;da=Oa+1|0;if((da|0)<(R|0)){Na=G;Oa=da}else{La=G;Ma=da;break}}}else{La=ba;Ma=0}while(0);if((Ma|0)!=(R|0)){d[ga+(ea<<1)>>1]=0;if((Ma|0)<(R|0)){da=Ma;do{G=N+(da<<2)|0;f[G>>2]=(f[G>>2]|0)+(f[c+(da<<1<<2)>>2]<<1);da=da+1|0}while((da|0)!=(R|0))}}else{da=wNa(V*+n[La>>2])|0;d[ga+(ea<<1)>>1]=da>>>0<65536?da:(da|0)>0?65535:0}ea=ea+1|0}while((ea|0)!=(ma|0))}if(Q){ea=0;do{ja=N+(ea<<2)|0;f[ja>>2]=(f[ja>>2]|0)+(f[c+((ea<<1|1)<<2)>>2]<<1);ea=ea+1|0}while((ea|0)!=(R|0))}if(!_)break;else ga=ga+(A<<1)|0}}}while(0);break}case 5:{A=f[z>>2]|0;z=f[E>>2]|0;V=l;E=f[w>>2]|0;c=f[x>>2]|0;N=f[v+16>>2]|0;ma=f[E+(R<<2)>>2]|0;La=f[c+((R<<1|1)<<2)>>2]|0;Ma=R<<2;if(Q){ba=f[v+44>>2]|0;K1a(r|0,f[i>>2]|0,Ma|0)|0;K1a(s|0,ba|0,Ma|0)|0}f:do if(!m){if(!k){f[q>>2]=0;f[q+4>>2]=0;S=c$(q,55)|0;T=312331;U=S+55|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));j$(-5,q,313106,311778,1969);d$(q);break}if(Q)K1a(q|0,k|0,Ma|0)|0;if(z|0){ba=(A|0)>0;Oa=(R|0)==0;Na=A<<2;L=z;F=ma;Ka=0;while(1){Ca=ma+((Y(La,Ka)|0)<<2)|0;L=L+-1|0;g:do if(ba){if(!Q)if(Oa){za=0;while(1){n[F+(za<<2)>>2]=V*+n[N>>2];za=za+1|0;if((za|0)==(A|0)){K=234;break g}}}else{F1a(Ca|0,0,Na|0)|0;break}else Pa=0;do{za=N;sa=0;while(1){va=E+(sa<<2)|0;wa=f[va>>2]|0;l=+n[wa>>2];ua=f[q+(sa<<2)>>2]|0;a=f[r+(sa<<2)>>2]|0;ga=-1;while(1){_=ga+1|0;if(!(l>=+n[ua+(_<<2)>>2])){Qa=ga;break}if((_|0)<(a|0))ga=_;else{Qa=_;break}}if(Qa>>>0>=a>>>0){Ra=za;Sa=sa;break}f[va>>2]=wa+(f[c+(sa<<1<<2)>>2]<<2);ga=za+(Y(f[s+(sa<<2)>>2]|0,Qa)|0)|0;ua=sa+1|0;if((ua|0)<(R|0)){za=ga;sa=ua}else{Ra=ga;Sa=ua;break}}if((Sa|0)!=(R|0)){n[F+(Pa<<2)>>2]=0.0;if((Sa|0)<(R|0)){sa=Sa;do{za=E+(sa<<2)|0;f[za>>2]=(f[za>>2]|0)+(f[c+(sa<<1<<2)>>2]<<2);sa=sa+1|0}while((sa|0)!=(R|0))}}else n[F+(Pa<<2)>>2]=V*+n[Ra>>2];Pa=Pa+1|0}while((Pa|0)!=(A|0));K=234}else K=234;while(0);if((K|0)==234?(K=0,Q):0){Ca=0;do{sa=E+(Ca<<2)|0;f[sa>>2]=(f[sa>>2]|0)+(f[c+((Ca<<1|1)<<2)>>2]<<2);Ca=Ca+1|0}while((Ca|0)!=(R|0))}if(!L)break;else{F=F+(La<<2)|0;Ka=Ka+1|0}}}}else switch(R|0){case 1:{l=+p[e>>3];Ba=+p[e+8>>3];Ka=f[r>>2]|0;F=f[c>>2]|0;L=f[c+4>>2]|0;if(!z)break f;if((A|0)<=0)break f;Na=Y(A,F)|0;Oa=ma;ba=z;Ca=f[E>>2]|0;while(1){ba=ba+-1|0;sa=Ca;za=0;while(1){Da=Ba+l*+n[sa>>2];ua=~~Da;ga=ua-(+(ua|0)>Da&1)|0;if(ga>>>0<Ka>>>0)Ta=V*+n[N+(ga<<2)>>2];else Ta=0.0;n[Oa+(za<<2)>>2]=Ta;za=za+1|0;if((za|0)==(A|0))break;else sa=sa+(F<<2)|0}if(!ba)break;else{Oa=Oa+(La<<2)|0;Ca=Ca+(Na<<2)+(L<<2)|0}}break}case 2:{l=+p[e>>3];Ba=+p[e+8>>3];Da=+p[e+16>>3];ta=+p[e+24>>3];L=f[r>>2]|0;Na=f[r+4>>2]|0;Ca=f[c>>2]|0;Oa=f[c+4>>2]|0;ba=f[c+8>>2]|0;F=f[c+12>>2]|0;Ka=f[s>>2]|0;if(!((A|0)>0&(z|0)!=0))break f;sa=Y(A,Ca)|0;za=Y(A,ba)|0;ga=ma;ua=z;ka=f[E>>2]|0;Z=f[E+4>>2]|0;while(1){W=ka+(sa<<2)|0;_=ka;H=Z;oa=0;while(1){xa=Ba+l*+n[_>>2];ea=~~xa;ja=ea-(+(ea|0)>xa&1)|0;xa=ta+Da*+n[H>>2];ea=~~xa;da=ea-(+(ea|0)>xa&1)|0;if(ja>>>0<L>>>0&da>>>0<Na>>>0){ea=N+(Y(ja,Ka)|0)+(da<<2)|0;Ua=V*+n[ea>>2]}else Ua=0.0;n[ga+(oa<<2)>>2]=Ua;oa=oa+1|0;if((oa|0)==(A|0))break;else{_=_+(Ca<<2)|0;H=H+(ba<<2)|0}}ua=ua+-1|0;if(!ua)break;else{ga=ga+(La<<2)|0;ka=W+(Oa<<2)|0;Z=Z+(za<<2)+(F<<2)|0}}break}case 3:{Da=+p[e>>3];ta=+p[e+8>>3];l=+p[e+16>>3];Ba=+p[e+24>>3];xa=+p[e+32>>3];ya=+p[e+40>>3];F=f[r>>2]|0;za=f[r+4>>2]|0;Z=f[r+8>>2]|0;Oa=f[c>>2]|0;ka=f[c+4>>2]|0;ga=f[c+8>>2]|0;ua=f[c+12>>2]|0;ba=f[c+16>>2]|0;Ca=f[c+20>>2]|0;Ka=f[s>>2]|0;Na=f[s+4>>2]|0;if(!((A|0)>0&(z|0)!=0))break f;L=Y(A,Oa)|0;sa=Y(A,ga)|0;H=Y(A,ba)|0;_=ma;oa=z;ea=f[E>>2]|0;da=f[E+4>>2]|0;ja=f[E+8>>2]|0;while(1){oa=oa+-1|0;G=da+(sa<<2)|0;aa=ea;O=da;la=ja;P=0;while(1){Aa=ta+Da*+n[aa>>2];pa=~~Aa;qa=pa-(+(pa|0)>Aa&1)|0;Aa=Ba+l*+n[O>>2];pa=~~Aa;ra=pa-(+(pa|0)>Aa&1)|0;Aa=ya+xa*+n[la>>2];pa=~~Aa;fa=pa-(+(pa|0)>Aa&1)|0;if(qa>>>0<F>>>0&ra>>>0<za>>>0&fa>>>0<Z>>>0){pa=N+(Y(qa,Ka)|0)+(Y(ra,Na)|0)+(fa<<2)|0;Va=V*+n[pa>>2]}else Va=0.0;n[_+(P<<2)>>2]=Va;P=P+1|0;if((P|0)==(A|0))break;else{aa=aa+(Oa<<2)|0;O=O+(ga<<2)|0;la=la+(ba<<2)|0}}if(!oa)break;else{_=_+(La<<2)|0;ea=ea+(L<<2)+(ka<<2)|0;da=G+(ua<<2)|0;ja=ja+(H<<2)+(Ca<<2)|0}}break}default:{if(!z)break f;Ca=(k|0)==0;H=(A|0)>0;ja=z;ua=ma;while(1){ja=ja+-1|0;if(H){da=0;do{h:do if(Q){if(Ca){ka=N;L=0;while(1){ea=E+(L<<2)|0;_=f[ea>>2]|0;oa=L<<1;xa=+n[_>>2]*+p[e+(oa<<3)>>3]+ +p[e+((oa|1)<<3)>>3];ba=~~xa;ga=ba-(+(ba|0)>xa&1)|0;if(ga>>>0>=(f[r+(L<<2)>>2]|0)>>>0){Wa=ka;Xa=L;break h}f[ea>>2]=_+(f[c+(oa<<2)>>2]<<2);oa=ka+(Y(f[s+(L<<2)>>2]|0,ga)|0)|0;ga=L+1|0;if((ga|0)<(R|0)){ka=oa;L=ga}else{Wa=oa;Xa=ga;break h}}}else{Ya=N;Za=0}while(1){L=E+(Za<<2)|0;ka=f[L>>2]|0;xa=+n[ka>>2];ga=Za<<1;ya=xa*+p[e+(ga<<3)>>3]+ +p[e+((ga|1)<<3)>>3];oa=~~ya;_=oa-(+(oa|0)>ya&1)|0;if(_>>>0>=(f[r+(Za<<2)>>2]|0)>>>0){Wa=Ya;Xa=Za;break h}if(xa>=+n[(f[k+(Za<<2)>>2]|0)+4>>2]){Wa=Ya;Xa=Za;break h}f[L>>2]=ka+(f[c+(ga<<2)>>2]<<2);ga=Ya+(Y(f[s+(Za<<2)>>2]|0,_)|0)|0;_=Za+1|0;if((_|0)<(R|0)){Ya=ga;Za=_}else{Wa=ga;Xa=_;break}}}else{Wa=N;Xa=0}while(0);if((Xa|0)!=(R|0)){n[ua+(da<<2)>>2]=0.0;if((Xa|0)<(R|0)){_=Xa;do{ga=E+(_<<2)|0;f[ga>>2]=(f[ga>>2]|0)+(f[c+(_<<1<<2)>>2]<<2);_=_+1|0}while((_|0)!=(R|0))}}else n[ua+(da<<2)>>2]=V*+n[Wa>>2];da=da+1|0}while((da|0)!=(A|0))}if(Q){da=0;do{G=E+(da<<2)|0;f[G>>2]=(f[G>>2]|0)+(f[c+((da<<1|1)<<2)>>2]<<2);da=da+1|0}while((da|0)!=(R|0))}if(!ja)break;else ua=ua+(La<<2)|0}}}while(0);break}default:{f[q>>2]=0;f[q+4>>2]=0;j$(-210,q,313090,311778,2126);d$(q)}}q=B+36|0;La=f[q>>2]|0;if(La|0?(R=La+12|0,La=f[R>>2]|0,f[R>>2]=La+-1,(La|0)==1):0)CR(B);f[q>>2]=0;q=B+16|0;La=B+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[La>>2]|0)>0){q=f[B+40>>2]|0;R=0;do{f[q+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[La>>2]|0))}La=f[B+44>>2]|0;if((La|0)!=(B+48|0))ZF(La);La=f[y>>2]|0;if(La|0){y=f[C>>2]|0;if((y|0)!=(La|0))f[C>>2]=y+(~((y+-8-La|0)>>>3)<<3);PYa(La)}La=f[x>>2]|0;if(La|0){x=f[D>>2]|0;if((x|0)!=(La|0))f[D>>2]=x+(~((x+-4-La|0)>>>2)<<2);PYa(La)}La=f[w>>2]|0;if(La|0){w=f[g>>2]|0;if((w|0)!=(La|0))f[g>>2]=w+(~((w+-4-La|0)>>>2)<<2);PYa(La)}La=v+36|0;w=f[La>>2]|0;if(w|0?(g=w+12|0,w=f[g>>2]|0,f[g>>2]=w+-1,(w|0)==1):0)CR(v);f[La>>2]=0;La=v+16|0;f[La>>2]=0;f[La+4>>2]=0;f[La+8>>2]=0;f[La+12>>2]=0;if((f[I>>2]|0)>0){La=f[i>>2]|0;i=0;do{f[La+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[I>>2]|0))}I=f[v+44>>2]|0;if((I|0)!=(v+48|0))ZF(I);if(!(f[t+4>>2]|0)){u=o;return}u=o;return}function Pfa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;i=u;u=u+3696|0;j=i+3688|0;k=i+3632|0;l=i+3576|0;m=i+1520|0;n=i+56|0;o=i;_$(j,72476);do if((NS(d)|0)==65536){p=f[d+4>>2]|0;f[k>>2]=f[p>>2];q=k+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=k+8|0;f[s>>2]=f[p+8>>2];f[k+12>>2]=f[p+12>>2];f[k+16>>2]=f[p+16>>2];f[k+20>>2]=f[p+20>>2];f[k+24>>2]=f[p+24>>2];f[k+28>>2]=f[p+28>>2];f[k+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[k+36>>2]=t;f[k+40>>2]=s;s=k+48|0;v=k+44|0;f[v>>2]=s;f[s>>2]=0;f[k+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];w=k;break}else{f[q>>2]=0;BR(k,p);w=k;break}}else{OR(k,d,-1);w=k}while(0);f[l>>2]=1124007936;p=l+4|0;q=l+8|0;r=l+40|0;s=p;v=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(v|0));f[r>>2]=q;t=l+48|0;x=l+44|0;f[x>>2]=t;f[t>>2]=0;f[l+52>>2]=0;y=f[w>>2]|0;z=y>>>3&511;A=z+1|0;if(z){if(!(y&16384)){f[m>>2]=0;f[m+4>>2]=0;s=c$(m,17)|0;B=313235;v=s+17|0;do{b[s>>0]=b[B>>0]|0;s=s+1|0;B=B+1|0}while((s|0)<(v|0));j$(-215,m,313090,311778,2468);d$(m);C=f[w>>2]|0}else C=y;y=f[k+4>>2]|0;K1a(m|0,f[k+40>>2]|0,y<<2|0)|0;f[m+(y<<2)>>2]=A;GR(n,y+1|0,m,C&7,f[k+16>>2]|0,0);C=n+36|0;y=f[C>>2]|0;if(y|0){A=y+12|0;f[A>>2]=(f[A>>2]|0)+1}A=l+36|0;y=f[A>>2]|0;if(y|0?(z=y+12|0,y=f[z>>2]|0,f[z>>2]=y+-1,(y|0)==1):0)CR(l);f[A>>2]=0;y=l+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[p>>2]|0)>0){z=f[r>>2]|0;D=0;do{f[z+(D<<2)>>2]=0;D=D+1|0;E=f[p>>2]|0}while((D|0)<(E|0));f[l>>2]=f[n>>2];if((E|0)<3)F=21;else F=23}else{f[l>>2]=f[n>>2];F=21}if((F|0)==21){E=f[n+4>>2]|0;if((E|0)<3){f[p>>2]=E;f[q>>2]=f[n+8>>2];f[l+12>>2]=f[n+12>>2];E=f[n+44>>2]|0;D=f[x>>2]|0;f[D>>2]=f[E>>2];f[D+4>>2]=f[E+4>>2]}else F=23}if((F|0)==23)BR(l,n);E=n+16|0;f[y>>2]=f[E>>2];f[l+20>>2]=f[n+20>>2];f[l+24>>2]=f[n+24>>2];f[l+28>>2]=f[n+28>>2];f[l+32>>2]=f[n+32>>2];y=f[C>>2]|0;f[A>>2]=y;if(y|0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0)CR(n);f[C>>2]=0;C=n+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[C>>2]|0)>0){E=f[n+40>>2]|0;y=0;do{f[E+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[C>>2]|0))}C=f[n+44>>2]|0;if((C|0)!=(n+48|0))ZF(C)}else{C=k+36|0;y=f[C>>2]|0;if(y){E=y+12|0;f[E>>2]=(f[E>>2]|0)+1;E=l+36|0;y=f[E>>2]|0;if((y|0)!=0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0){CR(l);G=E}else G=E}else G=l+36|0;f[G>>2]=0;E=l+16|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[p>>2]|0)>0){y=f[r>>2]|0;A=0;do{f[y+(A<<2)>>2]=0;A=A+1|0;H=f[p>>2]|0}while((A|0)<(H|0));f[l>>2]=f[w>>2];if((H|0)<3)F=43;else F=45}else{f[l>>2]=f[w>>2];F=43}if((F|0)==43){w=f[k+4>>2]|0;if((w|0)<3){f[p>>2]=w;f[q>>2]=f[k+8>>2];f[l+12>>2]=f[k+12>>2];w=f[k+44>>2]|0;H=f[x>>2]|0;f[H>>2]=f[w>>2];f[H+4>>2]=f[w+4>>2]}else F=45}if((F|0)==45)BR(l,k);f[E>>2]=f[k+16>>2];f[l+20>>2]=f[k+20>>2];f[l+24>>2]=f[k+24>>2];f[l+28>>2]=f[k+28>>2];f[l+32>>2]=f[k+32>>2];f[G>>2]=f[C>>2]}C=(f[q>>2]|0)==1;q=(f[l+12>>2]|0)==1;G=C|q;E=f[p>>2]|0;w=(f[g+4>>2]|0)-(f[g>>2]|0)|0;H=w>>2;A=(f[c+4>>2]|0)-(f[c>>2]|0)>>2;y=US(a,-1)|0;D=(y|0)>0;if(!D){f[m>>2]=0;f[m+4>>2]=0;s=c$(m,11)|0;B=313253;v=s+11|0;do{b[s>>0]=b[B>>0]|0;s=s+1|0;B=B+1|0}while((s|0)<(v|0));j$(-215,m,313090,311778,2481);d$(m)}do if((H|0)!=(E<<1|0)?(H|0)!=2|(C|q)^1:0){if((H|0)==0?(VS(a,0)|0)==0:0)break;f[m>>2]=0;f[m+4>>2]=0;s=c$(m,72)|0;B=313265;v=s+72|0;do{b[s>>0]=b[B>>0]|0;s=s+1|0;B=B+1|0}while((s|0)<(v|0));j$(-215,m,313090,311778,2482);d$(m)}while(0);q=(A|0)==0;if(!(q|(A|0)==(E|0))?(A|0)!=1|G^1:0){f[m>>2]=0;f[m+4>>2]=0;s=c$(m,44)|0;B=313338;v=s+44|0;do{b[s>>0]=b[B>>0]|0;s=s+1|0;B=B+1|0}while((s|0)<(v|0));j$(-215,m,313090,311778,2483);d$(m)}if((w|0)>0?(B=(H|0)/2|0,(w|0)>4):0){w=f[g>>2]|0;g=0;do{f[m+(g<<2)>>2]=w+(g<<1<<2);g=g+1|0}while((g|0)<(B|0))}PI(n,y);if(D){D=o+4|0;B=o+8|0;g=o+12|0;w=o+16|0;s=o+20|0;v=o+24|0;G=o+28|0;A=o+32|0;E=o+36|0;C=o+40|0;z=o+48|0;I=o+44|0;J=0;do{OR(o,a,J);K=f[n>>2]|0;L=K+(J*56|0)|0;if((L|0)!=(o|0)){M=f[E>>2]|0;if(M|0){N=M+12|0;f[N>>2]=(f[N>>2]|0)+1}N=K+(J*56|0)+36|0;M=f[N>>2]|0;if(M|0?(O=M+12|0,M=f[O>>2]|0,f[O>>2]=M+-1,(M|0)==1):0)CR(L);f[N>>2]=0;M=K+(J*56|0)+16|0;O=K+(J*56|0)+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[O>>2]|0)>0){P=f[K+(J*56|0)+40>>2]|0;Q=0;do{f[P+(Q<<2)>>2]=0;Q=Q+1|0;R=f[O>>2]|0}while((Q|0)<(R|0));f[L>>2]=f[o>>2];if((R|0)<3)F=75;else F=77}else{f[L>>2]=f[o>>2];F=75}if((F|0)==75){F=0;Q=f[D>>2]|0;if((Q|0)<3){f[O>>2]=Q;f[K+(J*56|0)+8>>2]=f[B>>2];f[K+(J*56|0)+12>>2]=f[g>>2];Q=f[I>>2]|0;P=f[K+(J*56|0)+44>>2]|0;f[P>>2]=f[Q>>2];f[P+4>>2]=f[Q+4>>2]}else F=77}if((F|0)==77){F=0;BR(L,o)}f[M>>2]=f[w>>2];f[K+(J*56|0)+20>>2]=f[s>>2];f[K+(J*56|0)+24>>2]=f[v>>2];f[K+(J*56|0)+28>>2]=f[G>>2];f[K+(J*56|0)+32>>2]=f[A>>2];f[N>>2]=f[E>>2]}Q=f[E>>2]|0;if(Q|0?(P=Q+12|0,Q=f[P>>2]|0,f[P>>2]=Q+-1,(Q|0)==1):0)CR(o);f[E>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[D>>2]|0)>0){Q=f[C>>2]|0;P=0;do{f[Q+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[D>>2]|0))}P=f[I>>2]|0;if((P|0)!=(z|0))ZF(P);J=J+1|0}while((J|0)<(y|0));S=n}else S=n;Ofa(f[S>>2]|0,y,q?0:f[c>>2]|0,d,e,H|0?m:0,h,1);QI(n);n=l+36|0;m=f[n>>2]|0;if(m|0?(H=m+12|0,m=f[H>>2]|0,f[H>>2]=m+-1,(m|0)==1):0)CR(l);f[n>>2]=0;n=l+16|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[p>>2]|0)>0){n=f[r>>2]|0;r=0;do{f[n+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[x>>2]|0;if((p|0)!=(t|0))ZF(p);p=k+36|0;t=f[p>>2]|0;if(t|0?(x=t+12|0,t=f[x>>2]|0,f[x>>2]=t+-1,(t|0)==1):0)CR(k);f[p>>2]=0;p=k+16|0;t=k+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[t>>2]|0)>0){p=f[k+40>>2]|0;x=0;do{f[p+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[t>>2]|0))}t=f[k+44>>2]|0;if((t|0)!=(k+48|0))ZF(t);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function Qfa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0.0,J=0.0,K=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0,ba=0.0;e=u;u=u+288|0;g=e+280|0;h=e+224|0;i=e+168|0;j=e+152|0;k=e+40|0;l=e+8|0;m=e;_$(g,72496);do if((NS(a)|0)==65536){o=f[a+4>>2]|0;f[h>>2]=f[o>>2];p=h+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=h+8|0;f[r>>2]=f[o+8>>2];f[h+12>>2]=f[o+12>>2];f[h+16>>2]=f[o+16>>2];f[h+20>>2]=f[o+20>>2];f[h+24>>2]=f[o+24>>2];f[h+28>>2]=f[o+28>>2];f[h+32>>2]=f[o+32>>2];s=f[o+36>>2]|0;f[h+36>>2]=s;f[h+40>>2]=r;r=h+48|0;t=h+44|0;f[t>>2]=r;f[r>>2]=0;f[h+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[p>>2]=0;BR(h,o);break}}else OR(h,a,-1);while(0);do if((NS(c)|0)==65536){a=f[c+4>>2]|0;f[i>>2]=f[a>>2];o=i+4|0;p=a+4|0;f[o>>2]=f[p>>2];q=i+8|0;f[q>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];r=f[a+36>>2]|0;f[i+36>>2]=r;f[i+40>>2]=q;q=i+48|0;t=i+44|0;f[t>>2]=q;f[q>>2]=0;f[i+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[a+44>>2]|0;q=f[t>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[o>>2]=0;BR(i,a);break}}else OR(i,c,-1);while(0);f[j>>2]=h;f[j+4>>2]=i;f[j+8>>2]=0;f[k>>2]=1124007936;c=k+8|0;a=k+40|0;o=k+4|0;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[a>>2]=c;c=k+48|0;f[k+44>>2]=c;f[c>>2]=0;f[k+52>>2]=0;f[k+56>>2]=1124007936;c=k+64|0;a=k+96|0;o=k+60|0;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[a>>2]=c;c=k+104|0;f[k+100>>2]=c;f[c>>2]=0;f[k+108>>2]=0;aU(l,j,k,-1);j=f[h>>2]|0;if(!((j&7|0)==5?((f[i>>2]^j)&4095|0)==0:0)){f[m>>2]=0;f[m+4>>2]=0;o=c$(m,41)|0;v=313515;p=o+41|0;do{b[o>>0]=b[v>>0]|0;o=o+1|0;v=v+1|0}while((o|0)<(p|0));j$(-215,m,313557,311778,2514);d$(m)}j=l+4|0;c=f[j>>2]|0;if(!((f[c>>2]&16384|0)!=0?(f[c+56>>2]&16384|0)!=0:0)){f[m>>2]=0;f[m+4>>2]=0;o=c$(m,58)|0;v=313569;p=o+58|0;do{b[o>>0]=b[v>>0]|0;o=o+1|0;v=v+1|0}while((o|0)<(p|0));j$(-215,m,313557,311778,2518);d$(m)}c=l+16|0;a=(d|0)==1;q=m+4|0;t=0;w=0.0;x=0.0;y=0.0;z=0.0;A=0.0;B=0.0;while(1){if(t>>>0>=(f[c>>2]|0)>>>0)break;r=f[j>>2]|0;s=f[r+16>>2]|0;C=f[r+72>>2]|0;D=Y(f[r+12>>2]|0,f[r+8>>2]|0)|0;r=Y(D,((f[h>>2]|0)>>>3&511)+1|0)|0;switch(d|0){case 1:case 4:{if((r|0)>0)if(a){D=0;E=w;while(1){F=+n[s+(D<<2)>>2];G=F-+n[C+(D<<2)>>2];H=+L(+F)>2.220446049250313e-16;I=H?E+G*G/F:E;D=D+1|0;if((D|0)==(r|0)){J=I;K=x;N=y;O=z;P=A;Q=B;break}else E=I}}else{D=0;E=w;while(1){I=+n[s+(D<<2)>>2];F=+n[C+(D<<2)>>2];G=I-F;R=I+F;H=+L(+R)>2.220446049250313e-16;F=H?E+G*G/R:E;D=D+1|0;if((D|0)==(r|0)){J=F;K=x;N=y;O=z;P=A;Q=B;break}else E=F}}else{J=w;K=x;N=y;O=z;P=A;Q=B}break}case 0:{if((r|0)>0){D=0;E=x;F=y;R=z;G=A;I=B;while(1){S=+n[s+(D<<2)>>2];T=+n[C+(D<<2)>>2];U=R+S*T;V=E+S;X=F+S*S;S=G+T;Z=I+T*T;D=D+1|0;if((D|0)==(r|0)){J=w;K=V;N=X;O=U;P=S;Q=Z;break}else{E=V;F=X;R=U;G=S;I=Z}}}else{J=w;K=x;N=y;O=z;P=A;Q=B}break}case 2:{if((r|0)>0){D=0;I=w;while(1){G=+n[C+(D<<2)>>2];R=+n[s+(D<<2)>>2];F=I+(G<R?G:R);D=D+1|0;if((D|0)==(r|0)){J=F;K=x;N=y;O=z;P=A;Q=B;break}else I=F}}else{J=w;K=x;N=y;O=z;P=A;Q=B}break}case 3:{if((r|0)>0){D=0;I=w;F=x;R=A;while(1){G=+n[s+(D<<2)>>2];E=+n[C+(D<<2)>>2];Z=I+ +M(+(G*E));S=F+G;G=R+E;D=D+1|0;if((D|0)==(r|0)){J=Z;K=S;N=y;O=z;P=G;Q=B;break}else{I=Z;F=S;R=G}}}else{J=w;K=x;N=y;O=z;P=A;Q=B}break}case 5:{if((r|0)>0){D=0;R=w;while(1){F=+n[s+(D<<2)>>2];I=F;G=+n[C+(D<<2)>>2];if(!(+L(+F)<=2.220446049250313e-16)){H=!(+L(+G)<=2.220446049250313e-16);_=R+I*+W(+(I/(H?G:1.0e-10)))}else _=R;D=D+1|0;if((D|0)==(r|0)){J=_;K=x;N=y;O=z;P=A;Q=B;break}else R=_}}else{J=w;K=x;N=y;O=z;P=A;Q=B}break}default:{f[m>>2]=0;f[q>>2]=0;o=c$(m,25)|0;v=316604;p=o+25|0;do{b[o>>0]=b[v>>0]|0;o=o+1|0;v=v+1|0}while((o|0)<(p|0));j$(-5,m,313557,311778,2687);d$(m);J=w;K=x;N=y;O=z;P=A;Q=B}}tR(l)|0;t=t+1|0;w=J;x=K;y=N;z=O;A=P;B=Q}switch(d|0){case 4:{$=w*2.0;break}case 0:{d=f[h+4>>2]|0;if((d|0)<3)aa=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;else{t=f[h+40>>2]|0;l=0;m=1;while(1){v=Y(f[t+(l<<2)>>2]|0,m)|0;l=l+1|0;if((l|0)==(d|0)){aa=v;break}else m=v}}Q=1.0/+(aa>>>0);P=(y-x*x*Q)*(B-A*A*Q);if(+L(+P)>2.220446049250313e-16)$=(z-A*x*Q)/+M(+P);else $=1.0;break}case 3:{P=A*x;if(+L(+P)>1.1920928955078125e-07)ba=1.0/+M(+P);else ba=1.0;P=1.0-w*ba;$=+M(+(P<0.0?0.0:P));break}default:$=w}aa=k+56|0;m=k+92|0;d=f[m>>2]|0;if(d|0?(l=d+12|0,d=f[l>>2]|0,f[l>>2]=d+-1,(d|0)==1):0)CR(aa);f[m>>2]=0;m=k+72|0;aa=k+60|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[aa>>2]|0)>0){m=f[k+96>>2]|0;d=0;do{f[m+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[aa>>2]|0))}aa=f[k+100>>2]|0;if((aa|0)!=(k+104|0))ZF(aa);aa=k+36|0;d=f[aa>>2]|0;if(d|0?(m=d+12|0,d=f[m>>2]|0,f[m>>2]=d+-1,(d|0)==1):0)CR(k);f[aa>>2]=0;aa=k+16|0;d=k+4|0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[d>>2]|0)>0){aa=f[k+40>>2]|0;m=0;do{f[aa+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[d>>2]|0))}d=f[k+44>>2]|0;if((d|0)!=(k+48|0))ZF(d);d=i+36|0;k=f[d>>2]|0;if(k|0?(m=k+12|0,k=f[m>>2]|0,f[m>>2]=k+-1,(k|0)==1):0)CR(i);f[d>>2]=0;d=i+16|0;k=i+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[k>>2]|0)>0){d=f[i+40>>2]|0;m=0;do{f[d+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[i+44>>2]|0;if((k|0)!=(i+48|0))ZF(k);k=h+36|0;i=f[k>>2]|0;if(i|0?(m=i+12|0,i=f[m>>2]|0,f[m>>2]=i+-1,(i|0)==1):0)CR(h);f[k>>2]=0;k=h+16|0;i=h+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[i>>2]|0)>0){k=f[h+40>>2]|0;m=0;do{f[k+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)!=(h+48|0))ZF(i);if(!(f[g+4>>2]|0)){u=e;return +$}u=e;return +$}function Rfa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0;d=u;u=u+2256|0;e=d+2240|0;g=d+2184|0;h=d+2176|0;i=d+2120|0;j=d+2112|0;k=d+1088|0;l=d+64|0;m=d+48|0;n=d+32|0;o=d+24|0;q=d+8|0;r=d;_$(e,72516);if(RR(a,-1)|0){f[g>>2]=0;f[g+4>>2]=0;s=c$(g,56)|0;t=313680;v=s+56|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,g,313737,311778,3913);d$(g)}if(!(XS(a)|0)){do if((NS(a)|0)==65536){t=f[a+4>>2]|0;f[g>>2]=f[t>>2];s=g+4|0;v=t+4|0;f[s>>2]=f[v>>2];w=g+8|0;f[w>>2]=f[t+8>>2];f[g+12>>2]=f[t+12>>2];f[g+16>>2]=f[t+16>>2];f[g+20>>2]=f[t+20>>2];f[g+24>>2]=f[t+24>>2];f[g+28>>2]=f[t+28>>2];f[g+32>>2]=f[t+32>>2];x=f[t+36>>2]|0;f[g+36>>2]=x;y=g+40|0;f[y>>2]=w;w=g+48|0;z=g+44|0;f[z>>2]=w;f[w>>2]=0;f[g+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[t+44>>2]|0;w=f[z>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];A=g;B=y;break}else{f[s>>2]=0;BR(g,t);A=g;B=y;break}}else{OR(g,a,-1);A=g;B=g+40|0}while(0);a=f[B>>2]|0;y=f[a>>2]|0;f[h>>2]=f[a+4>>2];f[h+4>>2]=y;KS(c,h,f[A>>2]&4095,-1,0,0);do if((NS(c)|0)==65536){A=f[c+4>>2]|0;f[i>>2]=f[A>>2];h=i+4|0;y=A+4|0;f[h>>2]=f[y>>2];a=i+8|0;f[a>>2]=f[A+8>>2];f[i+12>>2]=f[A+12>>2];f[i+16>>2]=f[A+16>>2];f[i+20>>2]=f[A+20>>2];f[i+24>>2]=f[A+24>>2];f[i+28>>2]=f[A+28>>2];f[i+32>>2]=f[A+32>>2];t=f[A+36>>2]|0;f[i+36>>2]=t;f[i+40>>2]=a;a=i+48|0;s=i+44|0;f[s>>2]=a;f[a>>2]=0;f[i+52>>2]=0;if(t|0){a=t+12|0;f[a>>2]=(f[a>>2]|0)+1}if((f[y>>2]|0)<3){y=f[A+44>>2]|0;a=f[s>>2]|0;f[a>>2]=f[y>>2];f[a+4>>2]=f[y+4>>2];break}else{f[h>>2]=0;BR(i,A);break}}else OR(i,c,-1);while(0);U$(j);F1a(k|0,0,1024)|0;f[m>>2]=72544;f[m+4>>2]=g;f[m+8>>2]=k;f[m+12>>2]=j;f[n>>2]=72564;f[n+4>>2]=g;f[n+8>>2]=i;f[n+12>>2]=l;c=g+8|0;A=f[c>>2]|0;f[o>>2]=0;f[o+4>>2]=A;h=g+4|0;y=f[h>>2]|0;if((y|0)<3)C=Y(f[g+12>>2]|0,A)|0;else{A=f[B>>2]|0;a=0;s=1;while(1){t=Y(f[A+(a<<2)>>2]|0,s)|0;a=a+1|0;if((a|0)==(y|0)){C=t;break}else s=t}}if(C>>>0>307199){_U(o,m,-1.0);D=0}else{Sfa(m,o);D=0}while(1){E=f[k+(D<<2)>>2]|0;F=D+1|0;if(!E)D=F;else break}m=f[h>>2]|0;C=(m|0)<3;if(C)G=Y(f[g+12>>2]|0,f[c>>2]|0)|0;else{s=f[B>>2]|0;y=0;a=1;while(1){A=Y(f[s+(y<<2)>>2]|0,a)|0;y=y+1|0;if((y|0)==(m|0)){G=A;break}else a=A}}do if((G|0)!=(E|0)){H=255.0/+(G-E|0);f[l+(D<<2)>>2]=0;if((F|0)<256){a=F;y=0;do{y=(f[k+(a<<2)>>2]|0)+y|0;s=wNa(H*+(y|0))|0;f[l+(a<<2)>>2]=(s>>>0<256?s:(s|0)>0?255:0)&255;a=a+1|0}while((a|0)!=256)}if(C)I=Y(f[g+12>>2]|0,f[c>>2]|0)|0;else{a=f[B>>2]|0;y=0;s=1;while(1){A=Y(f[a+(y<<2)>>2]|0,s)|0;y=y+1|0;if((y|0)==(m|0)){I=A;break}else s=A}}if(I>>>0>307199){_U(o,n,-1.0);break}else{Tfa(n,o);break}}else{p[r>>3]=+(D|0);f[q>>2]=-1056833530;f[q+4>>2]=r;f[q+8>>2]=1;f[q+12>>2]=1;hL(i,q,fT()|0)|0}while(0);V$(j);j=i+36|0;q=f[j>>2]|0;if(q|0?(r=q+12|0,q=f[r>>2]|0,f[r>>2]=q+-1,(q|0)==1):0)CR(i);f[j>>2]=0;j=i+16|0;q=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[q>>2]|0)>0){j=f[i+40>>2]|0;r=0;do{f[j+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[q>>2]|0))}q=f[i+44>>2]|0;if((q|0)!=(i+48|0))ZF(q);q=g+36|0;i=f[q>>2]|0;if(i|0?(r=i+12|0,i=f[r>>2]|0,f[r>>2]=i+-1,(i|0)==1):0)CR(g);f[q>>2]=0;q=g+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[h>>2]|0)>0){q=f[B>>2]|0;B=0;do{f[q+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)!=(g+48|0))ZF(h)}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function Sfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+1024|0;d=c;F1a(d|0,0,1024)|0;e=f[a+4>>2]|0;g=f[e+48>>2]|0;i=f[b>>2]|0;j=(f[b+4>>2]|0)-i|0;b=(f[e>>2]&16384|0)!=0;k=Y(b?j:1,f[e+12>>2]|0)|0;l=(f[e+16>>2]|0)+(Y(f[f[e+44>>2]>>2]|0,i)|0)|0;i=b?1:j;j=i+-1|0;a:do if(i|0){b=k+-4|0;if((k|0)<4){e=(k|0)>0;m=j;n=l;while(1){if(e){o=0;do{p=d+((h[n+o>>0]|0)<<2)|0;f[p>>2]=(f[p>>2]|0)+1;o=o+1|0}while((o|0)!=(k|0))}if(!m)break a;else{m=m+-1|0;n=n+g|0}}}n=k&-4;m=(n|0)<(k|0);e=j;o=l;while(1){p=0;do{q=h[o+(p|1)>>0]|0;r=d+((h[o+p>>0]|0)<<2)|0;f[r>>2]=(f[r>>2]|0)+1;r=d+(q<<2)|0;f[r>>2]=(f[r>>2]|0)+1;r=h[o+(p|3)>>0]|0;q=d+((h[o+(p|2)>>0]|0)<<2)|0;f[q>>2]=(f[q>>2]|0)+1;q=d+(r<<2)|0;f[q>>2]=(f[q>>2]|0)+1;p=p+4|0}while((p|0)<=(b|0));if(m){p=n;do{q=d+((h[o+p>>0]|0)<<2)|0;f[q>>2]=(f[q>>2]|0)+1;p=p+1|0}while((p|0)!=(k|0))}if(!e)break;else{e=e+-1|0;o=o+g|0}}}while(0);g=f[a+12>>2]|0;W$(g);k=f[a+8>>2]|0;a=0;do{l=k+(a<<2)|0;f[l>>2]=(f[l>>2]|0)+(f[d+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=256);X$(g);u=c;return}function Tfa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=f[a+4>>2]|0;e=f[d+48>>2]|0;g=f[a+8>>2]|0;i=f[g+48>>2]|0;j=f[d+12>>2]|0;k=f[c>>2]|0;l=(f[c+4>>2]|0)-k|0;c=f[a+12>>2]|0;if(!(f[d>>2]&16384)){m=l;n=j}else{a=(f[g>>2]&16384|0)!=0;o=Y(a?l:1,j)|0;m=a?1:l;n=o}o=(f[d+16>>2]|0)+(Y(f[f[d+44>>2]>>2]|0,k)|0)|0;d=(f[g+16>>2]|0)+(Y(f[f[g+44>>2]>>2]|0,k)|0)|0;k=m+-1|0;if(!m)return;m=n+-4|0;if((n|0)<4){g=(n|0)>0;l=k;a=d;j=o;while(1){if(g){p=0;do{b[a+p>>0]=f[c+((h[j+p>>0]|0)<<2)>>2];p=p+1|0}while((p|0)!=(n|0))}if(!l)break;else{l=l+-1|0;a=a+i|0;j=j+e|0}}return}j=n&-4;a=(j|0)<(n|0);l=k;k=d;d=o;while(1){o=0;do{g=o|1;p=f[c+((h[d+g>>0]|0)<<2)>>2]|0;b[k+o>>0]=f[c+((h[d+o>>0]|0)<<2)>>2];b[k+g>>0]=p;p=o|2;g=o|3;q=f[c+((h[d+g>>0]|0)<<2)>>2]|0;b[k+p>>0]=f[c+((h[d+p>>0]|0)<<2)>>2];b[k+g>>0]=q;o=o+4|0}while((o|0)<=(m|0));if(a){o=j;do{b[k+o>>0]=f[c+((h[d+o>>0]|0)<<2)>>2];o=o+1|0}while((o|0)!=(n|0))}if(!l)break;else{l=l+-1|0;k=k+i|0;d=d+e|0}}return}function Ufa(a){a=a|0;PYa(a);return}function Vfa(a){a=a|0;PYa(a);return}function Wfa(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;h=+h;i=+i;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0,y=0,z=0;k=u;u=u+144|0;l=k+128|0;m=k+72|0;n=k+56|0;o=k;_$(l,72576);do if((NS(a)|0)==65536){p=f[a+4>>2]|0;f[m>>2]=f[p>>2];q=m+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=m+8|0;f[s>>2]=f[p+8>>2];f[m+12>>2]=f[p+12>>2];f[m+16>>2]=f[p+16>>2];f[m+20>>2]=f[p+20>>2];f[m+24>>2]=f[p+24>>2];f[m+28>>2]=f[p+28>>2];f[m+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[m+36>>2]=t;f[m+40>>2]=s;s=m+48|0;v=m+44|0;f[v>>2]=s;f[s>>2]=0;f[m+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;BR(m,p);break}}else OR(m,a,-1);while(0);f[n>>2]=0;a=n+4|0;f[a>>2]=0;f[n+8>>2]=0;w=c;c=d;if(g==0.0&h==0.0)Xfa(m,w,c,e,n,2147483647,i,j);else{p=rNa(g)|0;Yfa(m,w,c,e,p,rNa(h)|0,n,2147483647,i,j)}f[o>>2]=1124024333;p=o+4|0;f[p>>2]=2;e=o+8|0;q=f[a>>2]|0;r=f[n>>2]|0;s=q-r|0;f[e>>2]=s>>3;f[o+12>>2]=1;v=o+16|0;t=o+40|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;f[v+16>>2]=0;f[v+20>>2]=0;f[t>>2]=e;e=o+48|0;x=o+44|0;f[x>>2]=e;f[e>>2]=0;y=o+52|0;f[y>>2]=0;z=r;if((z|0)!=(q|0)){f[y>>2]=8;f[e>>2]=8;f[v>>2]=z;f[o+20>>2]=z;z=r+s|0;f[o+24>>2]=z;f[o+28>>2]=z}eL(o,b);b=o+36|0;z=f[b>>2]|0;if(z|0?(s=z+12|0,z=f[s>>2]|0,f[s>>2]=z+-1,(z|0)==1):0)CR(o);f[b>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[p>>2]|0)>0){v=f[t>>2]|0;t=0;do{f[v+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[p>>2]|0))}p=f[x>>2]|0;if((p|0)!=(e|0))ZF(p);p=f[n>>2]|0;if(p|0){n=f[a>>2]|0;if((n|0)!=(p|0))f[a>>2]=n+(~((n+-8-p|0)>>>3)<<3);PYa(p)}p=m+36|0;n=f[p>>2]|0;if(n|0?(a=n+12|0,n=f[a>>2]|0,f[a>>2]=n+-1,(n|0)==1):0)CR(m);f[p>>2]=0;p=m+16|0;n=m+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[n>>2]|0)>0){p=f[m+40>>2]|0;a=0;do{f[p+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[n>>2]|0))}n=f[m+44>>2]|0;if((n|0)!=(m+48|0))ZF(n);if(!(f[l+4>>2]|0)){u=k;return}u=k;return}function Xfa(a,c,d,e,g,h,i,j){a=a|0;c=+c;d=+d;e=e|0;g=g|0;h=h|0;i=+i;j=+j;var k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0,Q=0,R=0,S=0,T=0,U=0;k=u;u=u+3216|0;l=k;m=k+2152|0;o=k+2136|0;p=k+1072|0;q=k+8|0;r=1.0/c;if(f[a>>2]&4095|0){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,55)|0;t=313854;v=s+55|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,l,313988,313925,86);d$(l)}w=f[a+16>>2]|0;x=f[a+48>>2]|0;y=f[a+12>>2]|0;z=f[a+8>>2]|0;if(j<i){f[l>>2]=0;f[l+4>>2]=0;s=c$(l,40)|0;t=314007;v=s+40|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-5,l,313988,313925,94);d$(l)}t=rNa((j-i)/d)|0;s=wNa(+(z+y<<1|1|0)/c)|0;v=t+2|0;a=s+2|0;A=Y(a,v)|0;B=m+8|0;f[m>>2]=B;C=m+4|0;f[C>>2]=A;if(A>>>0>264){D=OYa(A>>>0>1073741823?-1:A<<2)|0;f[m>>2]=D;E=D}else E=B;f[o>>2]=0;D=o+4|0;f[D>>2]=0;f[o+8>>2]=0;A=p+8|0;f[p>>2]=A;F=p+4|0;G=t>>>0>264;f[F>>2]=t;if(G){H=OYa(t>>>0>1073741823?-1:t<<2)|0;f[p>>2]=H;I=H}else I=A;H=q+8|0;f[q>>2]=H;J=q+4|0;f[J>>2]=t;if(G){G=OYa(t>>>0>1073741823?-1:t<<2)|0;f[q>>2]=G;K=G}else K=H;F1a(E|0,0,Y(v<<2,a)|0)|0;j=i;v=(t|0)>0;if(v){i=r;r=j;G=0;while(1){L=r;M=i*+P(+L);n[I+(G<<2)>>2]=M;M=i*+O(+L);n[K+(G<<2)>>2]=M;G=G+1|0;if((G|0)==(t|0))break;else r=r+d}}if((z|0)>0?(G=((s+-1|0)/2|0)+1|0,(y|0)>0):0){N=0;do{Q=Y(N,x)|0;r=+(N|0);if(v){R=0;do{if(b[w+(R+Q)>>0]|0){i=+(R|0);S=0;do{T=S;S=S+1|0;U=E+(G+(Y(S,a)|0)+(wNa(i*+n[K+(T<<2)>>2]+r*+n[I+(T<<2)>>2])|0)<<2)|0;f[U>>2]=(f[U>>2]|0)+1}while((S|0)!=(t|0))}R=R+1|0}while((R|0)!=(y|0))}N=N+1|0}while((N|0)!=(z|0))}if((s|0)>0?(z=-2-s|0,N=o+8|0,v):0){v=0;do{y=0;do{y=y+1|0;I=(Y(y,a)|0)+v|0;K=I+1|0;f[l>>2]=K;G=f[E+(K<<2)>>2]|0;do if(((((G|0)>(e|0)?(G|0)>(f[E+(I<<2)>>2]|0):0)?(G|0)>=(f[E+(I+2<<2)>>2]|0):0)?(G|0)>(f[E+(z+K<<2)>>2]|0):0)?(G|0)>=(f[E+(a+K<<2)>>2]|0):0){w=f[D>>2]|0;if((w|0)==(f[N>>2]|0)){VU(o,l);break}else{f[w>>2]=K;f[D>>2]=w+4;break}}while(0)}while((y|0)<(t|0));v=v+1|0}while((v|0)<(s|0))}v=f[o>>2]|0;t=f[D>>2]|0;f[l>>2]=E;$fa(v,t,l);t=f[o>>2]|0;v=(f[D>>2]|0)-t>>2;E=(v|0)<(h|0)?v:h;r=1.0/+(a|0);a:do if((E|0)>0){i=+(s+-1|0)*.5;h=l+4|0;v=g+4|0;N=g+8|0;z=t;e=0;while(1){y=f[z+(e<<2)>>2]|0;M=r*+(y|0);K=~~M;G=K-(+(K|0)>M&1)|0;M=(+(y+-1-(Y(G,a)|0)|0)-i)*c;n[l>>2]=M;n[h>>2]=j+ +(G+-1|0)*d;G=f[v>>2]|0;if((G|0)==(f[N>>2]|0))_fa(g,l);else{n[G>>2]=M;f[G+4>>2]=f[h>>2];f[v>>2]=G+8}G=e+1|0;if((G|0)>=(E|0))break a;z=f[o>>2]|0;e=G}}while(0);E=f[q>>2]|0;if((E|0)!=(H|0)){if(E|0)QYa(E);f[q>>2]=H;f[J>>2]=264}J=f[p>>2]|0;if((J|0)!=(A|0)){if(J|0)QYa(J);f[p>>2]=A;f[F>>2]=264}F=f[o>>2]|0;if(F|0){o=f[D>>2]|0;if((o|0)!=(F|0))f[D>>2]=o+(~((o+-4-F|0)>>>2)<<2);PYa(F)}F=f[m>>2]|0;if((F|0)==(B|0)){u=k;return}if(F|0)QYa(F);f[m>>2]=B;f[C>>2]=264;u=k;return}function Yfa(a,c,d,e,g,i,j,k,l,m){a=a|0;c=+c;d=+d;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,N=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0,ja=0,ka=0,la=0.0,ma=0.0,na=0.0,oa=0,pa=0,qa=0.0,ra=0.0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0;o=u;u=u+96|0;p=o+72|0;q=o+60|0;r=o+48|0;s=o+36|0;t=o+24|0;v=o+12|0;w=o;x=Y(i,g)|0;f[p>>2]=0;y=p+4|0;f[y>>2]=0;f[p+8>>2]=0;if(f[a>>2]&4095|0){f[q>>2]=0;f[q+4>>2]=0;z=c$(q,55)|0;A=313854;B=z+55|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-215,q,313910,313925,224);d$(q)}if((k|0)<=0){f[q>>2]=0;f[q+4>>2]=0;z=c$(q,12)|0;A=313975;B=z+12|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-215,q,313910,313925,225);d$(q)}A=(e|0)<255?e:255;e=f[a+16>>2]|0;z=f[a+48>>2]|0;B=f[a+12>>2]|0;C=f[a+8>>2]|0;D=1.0/c;E=1.0/d;F=+(g|0);G=c/F;H=d/+(i|0);I=1.0/G;J=1.0/H;K=+(B|0);N=+(C|0);P=D*+M(+(K*K+N*N));g=~~P;Q=g-(+(g|0)>P&1)|0;P=E;N=P*6.283185307179586;g=~~N;R=g-(+(g|0)>N&1)|0;f[q>>2]=A;n[q+4>>2]=-1.0;n[q+8>>2]=0.0;g=f[y>>2]|0;S=p+8|0;if((g|0)==(f[S>>2]|0))Zfa(p,q);else{f[g>>2]=f[q>>2];f[g+4>>2]=f[q+4>>2];f[g+8>>2]=f[q+8>>2];f[y>>2]=(f[y>>2]|0)+12}g=Y(i*5|0,R)|0;f[q>>2]=0;T=q+4|0;f[T>>2]=0;f[q+8>>2]=0;if(!g)U=0;else{if(g>>>0>1073741823)gXa(q);V=g<<2;W=NYa(V)|0;f[q>>2]=W;X=W+(g<<2)|0;f[q+8>>2]=X;F1a(W|0,0,V|0)|0;f[T>>2]=X;X=0;do{N=+O(+(H*+(X|0)*.20000000298023224));n[W+(X<<2)>>2]=N;X=X+1|0}while((X|0)!=(g|0));U=W}W=Y(Q,R)|0;f[r>>2]=0;g=r+4|0;f[g>>2]=0;f[r+8>>2]=0;if(!W)Z=0;else{if((W|0)<0)gXa(r);X=NYa(W)|0;f[g>>2]=X;f[r>>2]=X;f[r+8>>2]=X+W;V=X;X=W;do{b[V>>0]=0;V=(f[g>>2]|0)+1|0;f[g>>2]=V;X=X+-1|0}while((X|0)!=0);Z=f[r>>2]|0}X=(C|0)>0;if(X&(B|0)>0){V=0;_=0;while(1){$=Y(_,z)|0;aa=0;ba=V;do{ba=((b[e+(aa+$)>>0]|0)!=0&1)+ba|0;aa=aa+1|0}while((aa|0)!=(B|0));_=_+1|0;if((_|0)==(C|0)){ca=ba;break}else V=ba}}else ca=0;f[s>>2]=0;V=s+4|0;f[V>>2]=0;f[s+8>>2]=0;_=(ca|0)==0;do if(!_)if(ca>>>0>1073741823)gXa(s);else{aa=ca<<2;$=NYa(aa)|0;f[s>>2]=$;da=$+(ca<<2)|0;f[s+8>>2]=da;F1a($|0,0,aa|0)|0;f[V>>2]=da;ea=$;break}else ea=0;while(0);f[t>>2]=0;$=t+4|0;f[$>>2]=0;f[t+8>>2]=0;if(_){fa=0;ga=0}else{_=ca<<2;da=NYa(_)|0;f[t>>2]=da;aa=da+(ca<<2)|0;f[t+8>>2]=aa;F1a(da|0,0,_|0)|0;f[$>>2]=aa;fa=da;ga=da}if(X){X=(B|0)>0;da=0;aa=0;while(1){if(X){_=Y(aa,z)|0;N=+(aa|0)+.5;K=N;ha=K*K;ia=0;ja=da;while(1){if(b[e+(ia+_)>>0]|0){f[ea+(ja<<2)>>2]=ia;f[fa+(ja<<2)>>2]=aa;ka=ja+1|0;K=+(ia|0)+.5;la=+L(+(+yN(N,K)*.01745329238474369));ma=K;K=+M(+(ha+ma*ma));ma=D*K;na=P*(la+1.5707963267948966);oa=~~na;pa=Z+(oa-(+(oa|0)>na&1))|0;b[pa>>0]=(b[pa>>0]|0)+1<<24>>24;na=c/K;K=na<d?na:d;na=E*K;qa=3.141592653589793/K;pa=~~qa;oa=pa-(+(pa|0)>qa&1)|0;if((oa|0)>1){pa=-1;qa=-1.5707963705062866;ra=E*(la+K);sa=1;while(1){qa=K+qa;ta=~~ra;ua=pa;pa=(Y(~~(ma*+O(+qa)),R)|0)+(ta-(+(ta|0)>ra&1))|0;ta=Z+pa|0;b[ta>>0]=((pa|0)!=(ua|0)&1)+(h[ta>>0]|0);sa=sa+1|0;if((sa|0)==(oa|0)){va=ka;break}else ra=na+ra}}else va=ka}else va=ja;ia=ia+1|0;if((ia|0)>=(B|0)){wa=va;break}else ja=va}}else wa=da;aa=aa+1|0;if((aa|0)>=(C|0))break;else da=wa}}wa=(Q|0)>0;if(wa&(R|0)>0){da=0;C=0;while(1){aa=Y(C,R)|0;va=da;B=0;do{va=((h[Z+(B+aa)>>0]|0)>(A|0)&1)+va|0;B=B+1|0}while((B|0)!=(R|0));C=C+1|0;if((C|0)==(Q|0)){xa=va;break}else da=va}}else xa=0;if((xa*100|0)>(W|0)){Xfa(a,c,d,A,j,k,l,m);ya=fa;za=ga}else{ga=x+2|0;f[v>>2]=0;a=v+4|0;f[a>>2]=0;f[v+8>>2]=0;if(!ga)Aa=0;else{if((x|0)<-2)gXa(v);W=NYa(ga)|0;f[a>>2]=W;f[v>>2]=W;f[v+8>>2]=W+ga;xa=W;W=ga;do{b[xa>>0]=0;xa=(f[a>>2]|0)+1|0;f[a>>2]=xa;W=W+-1|0}while((W|0)!=0);Aa=f[v>>2]|0}W=Aa+1|0;if(wa){wa=(R|0)>0;Aa=(ca|0)>0;m=J;xa=(i|0)>0;ga=(x|0)>0;da=w+4|0;C=w+8|0;B=0;while(1){if(wa){aa=Y(B,R)|0;J=+(B|0);l=F*J;E=J*c;e=0;do{do if((h[Z+(e+aa)>>0]|0)>(A|0)){F1a(W|0,0,x|0)|0;a:do if(Aa){z=Y(e,i)|0;if(xa)Ba=0;else{X=0;while(1){+yN(+(f[fa+(X<<2)>>2]|0)+.5,+(f[ea+(X<<2)>>2]|0)+.5);X=X+1|0;if((X|0)>=(ca|0))break a}}do{J=+(f[fa+(Ba<<2)>>2]|0)+.5;P=+(f[ea+(Ba<<2)>>2]|0)+.5;D=P;ha=J;N=I*+M(+(ha*ha+D*D));D=m*(+L(+(+yN(J,P)*.01745329238474369))+1.5707963267948966);X=~~D;ja=0;ia=(z-X+(+(X|0)>D&1)|0)*5|0;while(1){D=N*+n[U+(((ia|0)>-1?ia:0-ia|0)<<2)>>2]-l;X=~~D;_=(Y(X-(+(X|0)>D&1)|0,i)|0)+ja|0;X=_>>31&~_^_;_=W+(((X|0)>=(x|0)?X^x:0)^X)|0;b[_>>0]=(b[_>>0]|0)+1<<24>>24;ja=ja+1|0;if((ja|0)==(i|0))break;else ia=ia+5|0}Ba=Ba+1|0}while((Ba|0)<(ca|0))}while(0);if(!ga)break;N=+(e|0)*d;z=f[y>>2]|0;ia=f[p>>2]|0;ja=ia;_=z;X=ia;ia=z;z=0;while(1){ba=_-ja|0;oa=((ba|0)/12|0)+-1|0;if((ba|0)>=12){sa=b[W+z>>0]|0;if((f[X+(oa*12|0)>>2]|0)<(sa&255|0)){Ca=sa;Da=70}else{Ea=ia;Fa=X;Ga=X;Ha=_}}else{Ca=b[W+z>>0]|0;Da=70}if((Da|0)==70){Da=0;f[w>>2]=Ca&255;n[da>>2]=E+G*+((z|0)/(i|0)|0|0);n[C>>2]=N+H*+((z|0)%(i|0)|0|0)+-1.5707963705062866;if((ia|0)==(f[S>>2]|0))Zfa(p,w);else{f[ia>>2]=f[w>>2];f[ia+4>>2]=f[w+4>>2];f[ia+8>>2]=f[w+8>>2];f[y>>2]=(f[y>>2]|0)+12}b:do if((ba|0)>0){sa=oa;while(1){pa=f[p>>2]|0;ta=pa+(sa*12|0)|0;if((f[ta>>2]|0)>(f[w>>2]|0)){Ia=sa;break b}ua=pa+((sa+1|0)*12|0)|0;f[ua>>2]=f[ta>>2];f[ua+4>>2]=f[ta+4>>2];f[ua+8>>2]=f[ta+8>>2];ta=sa+-1|0;if((sa|0)>0)sa=ta;else{Ia=ta;break}}}else Ia=oa;while(0);oa=(f[p>>2]|0)+((Ia+1|0)*12|0)|0;f[oa>>2]=f[w>>2];f[oa+4>>2]=f[w+4>>2];f[oa+8>>2]=f[w+8>>2];oa=f[y>>2]|0;ba=f[p>>2]|0;sa=oa;if(((oa-ba|0)/12|0|0)>(k|0)){ta=sa+-12|0;f[y>>2]=ta;Ja=ta;Ka=ta}else{Ja=sa;Ka=oa}Ea=Ja;Fa=ba;Ga=ba;Ha=Ka}z=z+1|0;if((z|0)>=(x|0))break;else{ja=Ga;_=Ha;X=Fa;ia=Ea}}}while(0);e=e+1|0}while((e|0)<(R|0))}B=B+1|0;if((B|0)>=(Q|0)){La=p;Ma=y;break}}}else{La=p;Ma=y}Q=f[Ma>>2]|0;B=f[La>>2]|0;if((Q|0)!=(B|0)){R=w+4|0;Ea=j+4|0;Fa=j+8|0;Ha=B;B=Q;Q=0;while(1){Ga=Ha;if(+n[Ga+(Q*12|0)+4>>2]<0.0){Na=Ha;Oa=B}else{x=f[Ga+(Q*12|0)+4>>2]|0;Ka=f[Ga+(Q*12|0)+8>>2]|0;f[w>>2]=x;f[R>>2]=Ka;Ka=f[Ea>>2]|0;if((Ka|0)==(f[Fa>>2]|0)){_fa(j,w);Pa=f[Ma>>2]|0;Qa=f[La>>2]|0}else{f[Ka>>2]=x;f[Ka+4>>2]=f[R>>2];f[Ea>>2]=Ka+8;Pa=B;Qa=Ha}Na=Qa;Oa=Pa}Q=Q+1|0;if(Q>>>0>=((Oa-Na|0)/12|0)>>>0)break;else{Ha=Na;B=Oa}}}Oa=f[v>>2]|0;if(Oa|0){if((f[a>>2]|0)!=(Oa|0))f[a>>2]=Oa;PYa(Oa)}Oa=f[t>>2]|0;ya=Oa;za=Oa}if(ya|0){Oa=f[$>>2]|0;if((Oa|0)!=(ya|0))f[$>>2]=Oa+(~((Oa+-4-ya|0)>>>2)<<2);PYa(za)}za=f[s>>2]|0;if(za|0){s=f[V>>2]|0;if((s|0)!=(za|0))f[V>>2]=s+(~((s+-4-za|0)>>>2)<<2);PYa(za)}za=f[r>>2]|0;if(za|0){if((f[g>>2]|0)!=(za|0))f[g>>2]=za;PYa(za)}za=f[q>>2]|0;if(za|0){q=f[T>>2]|0;if((q|0)!=(za|0))f[T>>2]=q+(~((q+-4-za|0)>>>2)<<2);PYa(za)}za=f[p>>2]|0;if(!za){u=o;return}p=f[y>>2]|0;if((p|0)!=(za|0))f[y>>2]=p+(~(((p+-12-za|0)>>>0)/12|0)*12|0);PYa(za);u=o;return}function Zfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=(e|0)/12|0;h=g+1|0;if(h>>>0>357913941)gXa(a);i=a+8|0;j=((f[i>>2]|0)-d|0)/12|0;k=j<<1;l=j>>>0<178956970?(k>>>0<h>>>0?h:k):357913941;do if(l)if(l>>>0>357913941){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{m=NYa(l*12|0)|0;break}else m=0;while(0);k=m+(g*12|0)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];b=k+(((e|0)/-12|0)*12|0)|0;if((e|0)>0)K1a(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+12;f[i>>2]=m+(l*12|0);if(!d)return;PYa(d);return}function _fa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)gXa(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>2;m=k>>3>>>0<268435455?(l>>>0<h>>>0?h:l):536870911;do if(m)if(m>>>0>536870911){l=De(8)|0;UYa(l,358155);f[l>>2]=130560;Of(l|0,21520,875)}else{n=NYa(m<<3)|0;break}else n=0;while(0);l=n+(g<<3)|0;h=n+(m<<3)|0;f[l>>2]=f[b>>2];f[n+(g<<3)+4>>2]=f[b+4>>2];b=l+8|0;if((j|0)==(i|0))o=l;else{g=j+-8-e|0;n=l;m=j;do{j=n;n=n+-8|0;k=m;m=m+-8|0;f[n>>2]=f[m>>2];f[j+-4>>2]=f[k+-4>>2]}while((m|0)!=(i|0));o=l+(~(g>>>3)<<3)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;PYa(e);return}function $fa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=a;a=b;a:while(1){b=a;e=a+-4|0;g=d;while(1){h=g;b:while(1){i=h;j=b-i|0;k=j>>2;switch(k|0){case 2:{l=5;break a;break}case 3:{l=7;break a;break}case 4:{l=15;break a;break}case 5:{l=16;break a;break}case 1:case 0:{l=63;break a;break}default:{}}if((j|0)<124){l=18;break a}m=h+(((k|0)/2|0)<<2)|0;do if((j|0)<=3996){n=f[m>>2]|0;o=f[h>>2]|0;p=f[c>>2]|0;q=f[p+(n<<2)>>2]|0;r=p+(o<<2)|0;s=f[r>>2]|0;t=f[e>>2]|0;u=f[p+(t<<2)>>2]|0;v=(u|0)>(q|0)|(t|0)<(n|0)&(u|0)==(q|0);if(!((q|0)>(s|0)|(n|0)<(o|0)&(q|0)==(s|0))){if(!v){w=p;x=0;break}f[m>>2]=t;f[e>>2]=n;s=f[m>>2]|0;q=f[h>>2]|0;u=f[p+(s<<2)>>2]|0;y=f[p+(q<<2)>>2]|0;if(!((u|0)>(y|0)|(s|0)<(q|0)&(u|0)==(y|0))){w=p;x=1;break}f[h>>2]=s;f[m>>2]=q;w=p;x=2;break}if(v){f[h>>2]=t;f[e>>2]=o;w=p;x=1;break}f[h>>2]=n;f[m>>2]=o;n=f[e>>2]|0;t=f[p+(n<<2)>>2]|0;v=f[r>>2]|0;if((t|0)>(v|0)|(n|0)<(o|0)&(t|0)==(v|0)){f[m>>2]=n;f[e>>2]=o;w=p;x=2}else{w=p;x=1}}else{p=(k|0)/4|0;o=bga(h,h+(p<<2)|0,m,m+(p<<2)|0,e,c)|0;w=f[c>>2]|0;x=o}while(0);z=f[h>>2]|0;k=f[m>>2]|0;j=f[w+(z<<2)>>2]|0;o=f[w+(k<<2)>>2]|0;if((j|0)>(o|0)|(z|0)<(k|0)&(j|0)==(o|0)){A=e;B=x;break}o=f[c>>2]|0;j=o+(k<<2)|0;C=e;while(1){C=C+-4|0;if((h|0)==(C|0))break;D=f[C>>2]|0;p=f[o+(D<<2)>>2]|0;n=f[j>>2]|0;if((p|0)>(n|0)|(D|0)<(k|0)&(p|0)==(n|0)){l=45;break b}}k=h+4|0;j=f[e>>2]|0;n=f[o+(z<<2)>>2]|0;p=f[o+(j<<2)>>2]|0;if((n|0)>(p|0)|(z|0)<(j|0)&(n|0)==(p|0))E=k;else{if((k|0)==(e|0)){l=63;break a}else F=k;while(1){G=f[F>>2]|0;k=f[o+(G<<2)>>2]|0;if((n|0)>(k|0)|(z|0)<(G|0)&(n|0)==(k|0))break;k=F+4|0;if((k|0)==(e|0)){l=63;break a}else F=k}f[F>>2]=j;f[e>>2]=G;E=F+4|0}if((E|0)==(e|0)){l=63;break a}n=f[c>>2]|0;o=E;k=e;while(1){p=f[h>>2]|0;v=f[n+(p<<2)>>2]|0;t=o;while(1){H=f[t>>2]|0;r=f[n+(H<<2)>>2]|0;I=t+4|0;if((v|0)>(r|0)|(p|0)<(H|0)&(v|0)==(r|0)){J=k;break}else t=I}do{J=J+-4|0;K=f[J>>2]|0;r=f[n+(K<<2)>>2]|0}while((v|0)>(r|0)|(p|0)<(K|0)&(v|0)==(r|0));if(t>>>0>=J>>>0){h=t;continue b}f[t>>2]=K;f[J>>2]=H;o=I;k=J}}if((l|0)==45){l=0;f[h>>2]=D;f[C>>2]=z;A=C;B=x+1|0}k=h+4|0;c:do if(k>>>0<A>>>0){o=f[c>>2]|0;n=k;j=A;v=m;p=B;while(1){r=f[v>>2]|0;q=f[o+(r<<2)>>2]|0;s=n;while(1){L=f[s>>2]|0;y=f[o+(L<<2)>>2]|0;M=s+4|0;if((y|0)>(q|0)|(L|0)<(r|0)&(y|0)==(q|0))s=M;else{N=j;break}}do{N=N+-4|0;O=f[N>>2]|0;t=f[o+(O<<2)>>2]|0}while(!((t|0)>(q|0)|(O|0)<(r|0)&(t|0)==(q|0)));if(s>>>0>N>>>0){P=s;Q=v;R=p;break c}f[s>>2]=O;f[N>>2]=L;n=M;j=N;v=(v|0)==(s|0)?N:v;p=p+1|0}}else{P=k;Q=m;R=B}while(0);if((P|0)!=(Q|0)?(k=f[Q>>2]|0,p=f[P>>2]|0,v=f[c>>2]|0,j=f[v+(k<<2)>>2]|0,n=f[v+(p<<2)>>2]|0,(j|0)>(n|0)|(k|0)<(p|0)&(j|0)==(n|0)):0){f[P>>2]=k;f[Q>>2]=p;S=R+1|0}else S=R;if(!S){T=dga(h,P,c)|0;p=P+4|0;if(dga(p,a,c)|0){l=62;break}if(T){g=p;continue}}p=P;if((p-i|0)>=(b-p|0)){l=61;break}$fa(h,P,c);g=P+4|0}if((l|0)==61){l=0;$fa(P+4|0,a,c);d=h;a=P;continue}else if((l|0)==62){l=0;if(T){l=63;break}else{d=h;a=P;continue}}}if((l|0)==5){P=f[e>>2]|0;d=f[h>>2]|0;T=f[c>>2]|0;i=f[T+(P<<2)>>2]|0;S=f[T+(d<<2)>>2]|0;if(!((i|0)>(S|0)|(P|0)<(d|0)&(i|0)==(S|0)))return;f[h>>2]=P;f[e>>2]=d;return}else if((l|0)==7){d=h+4|0;P=f[d>>2]|0;S=f[h>>2]|0;i=f[c>>2]|0;T=f[i+(P<<2)>>2]|0;R=i+(S<<2)|0;Q=f[R>>2]|0;B=f[e>>2]|0;m=f[i+(B<<2)>>2]|0;N=(m|0)>(T|0)|(B|0)<(P|0)&(m|0)==(T|0);if(!((T|0)>(Q|0)|(P|0)<(S|0)&(T|0)==(Q|0))){if(!N)return;f[d>>2]=B;f[e>>2]=P;Q=f[d>>2]|0;T=f[h>>2]|0;m=f[i+(Q<<2)>>2]|0;M=f[i+(T<<2)>>2]|0;if(!((m|0)>(M|0)|(Q|0)<(T|0)&(m|0)==(M|0)))return;f[h>>2]=Q;f[d>>2]=T;return}if(N){f[h>>2]=B;f[e>>2]=S;return}f[h>>2]=P;f[d>>2]=S;P=f[e>>2]|0;B=f[i+(P<<2)>>2]|0;i=f[R>>2]|0;if(!((B|0)>(i|0)|(P|0)<(S|0)&(B|0)==(i|0)))return;f[d>>2]=P;f[e>>2]=S;return}else if((l|0)==15){aga(h,h+4|0,h+8|0,e,c)|0;return}else if((l|0)==16){bga(h,h+4|0,h+8|0,h+12|0,e,c)|0;return}else if((l|0)==18){cga(h,a,c);return}else if((l|0)==63)return}function aga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=f[b>>2]|0;h=f[a>>2]|0;i=f[e>>2]|0;e=f[i+(g<<2)>>2]|0;j=i+(h<<2)|0;k=f[j>>2]|0;l=f[c>>2]|0;m=f[i+(l<<2)>>2]|0;n=(m|0)>(e|0)|(l|0)<(g|0)&(m|0)==(e|0);do if((e|0)>(k|0)|(g|0)<(h|0)&(e|0)==(k|0)){if(n){f[a>>2]=l;f[c>>2]=h;o=h;p=1;break}f[a>>2]=g;f[b>>2]=h;m=f[c>>2]|0;q=f[i+(m<<2)>>2]|0;r=f[j>>2]|0;if((q|0)>(r|0)|(m|0)<(h|0)&(q|0)==(r|0)){f[b>>2]=m;f[c>>2]=h;o=h;p=2}else{o=m;p=1}}else if(n){f[b>>2]=l;f[c>>2]=g;m=f[b>>2]|0;r=f[a>>2]|0;q=f[i+(m<<2)>>2]|0;s=f[i+(r<<2)>>2]|0;if((q|0)>(s|0)|(m|0)<(r|0)&(q|0)==(s|0)){f[a>>2]=m;f[b>>2]=r;o=f[c>>2]|0;p=2}else{o=g;p=1}}else{o=l;p=0}while(0);l=f[d>>2]|0;g=f[i+(l<<2)>>2]|0;n=f[i+(o<<2)>>2]|0;if(!((g|0)>(n|0)|(l|0)<(o|0)&(g|0)==(n|0))){t=p;return t|0}f[c>>2]=l;f[d>>2]=o;o=f[c>>2]|0;d=f[b>>2]|0;l=f[i+(o<<2)>>2]|0;n=f[i+(d<<2)>>2]|0;if(!((l|0)>(n|0)|(o|0)<(d|0)&(l|0)==(n|0))){t=p+1|0;return t|0}f[b>>2]=o;f[c>>2]=d;d=f[b>>2]|0;c=f[a>>2]|0;o=f[i+(d<<2)>>2]|0;n=f[i+(c<<2)>>2]|0;if(!((o|0)>(n|0)|(d|0)<(c|0)&(o|0)==(n|0))){t=p+2|0;return t|0}f[a>>2]=d;f[b>>2]=c;t=p+3|0;return t|0}function bga(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=aga(a,b,c,d,g)|0;i=f[e>>2]|0;j=f[d>>2]|0;k=f[g>>2]|0;g=f[k+(i<<2)>>2]|0;l=f[k+(j<<2)>>2]|0;if(!((g|0)>(l|0)|(i|0)<(j|0)&(g|0)==(l|0))){m=h;return m|0}f[d>>2]=i;f[e>>2]=j;j=f[d>>2]|0;e=f[c>>2]|0;i=f[k+(j<<2)>>2]|0;l=f[k+(e<<2)>>2]|0;if(!((i|0)>(l|0)|(j|0)<(e|0)&(i|0)==(l|0))){m=h+1|0;return m|0}f[c>>2]=j;f[d>>2]=e;e=f[c>>2]|0;d=f[b>>2]|0;j=f[k+(e<<2)>>2]|0;l=f[k+(d<<2)>>2]|0;if(!((j|0)>(l|0)|(e|0)<(d|0)&(j|0)==(l|0))){m=h+2|0;return m|0}f[b>>2]=e;f[c>>2]=d;d=f[b>>2]|0;c=f[a>>2]|0;e=f[k+(d<<2)>>2]|0;l=f[k+(c<<2)>>2]|0;if(!((e|0)>(l|0)|(d|0)<(c|0)&(e|0)==(l|0))){m=h+3|0;return m|0}f[a>>2]=d;f[b>>2]=c;m=h+4|0;return m|0}function cga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=a+8|0;e=a+4|0;g=f[e>>2]|0;h=f[a>>2]|0;i=f[c>>2]|0;j=f[i+(g<<2)>>2]|0;k=i+(h<<2)|0;l=f[k>>2]|0;m=f[d>>2]|0;n=i+(m<<2)|0;o=f[n>>2]|0;p=(o|0)>(j|0)|(m|0)<(g|0)&(o|0)==(j|0);do if((j|0)>(l|0)|(g|0)<(h|0)&(j|0)==(l|0)){if(p){f[a>>2]=m;f[d>>2]=h;q=h;break}f[a>>2]=g;f[e>>2]=h;o=f[n>>2]|0;r=f[k>>2]|0;if((o|0)>(r|0)|(m|0)<(h|0)&(o|0)==(r|0)){f[e>>2]=m;f[d>>2]=h;q=h}else q=m}else if(p){f[e>>2]=m;f[d>>2]=g;r=f[n>>2]|0;o=f[k>>2]|0;if((r|0)>(o|0)|(m|0)<(h|0)&(r|0)==(o|0)){f[a>>2]=m;f[e>>2]=h;q=g}else q=g}else q=m;while(0);m=a+12|0;if((m|0)==(b|0))return;else{s=i;t=q;u=m;v=d}while(1){d=f[u>>2]|0;m=f[s+(d<<2)>>2]|0;q=f[s+(t<<2)>>2]|0;if((m|0)>(q|0)|(d|0)<(t|0)&(m|0)==(q|0)){q=f[c>>2]|0;m=q+(d<<2)|0;i=t;g=u;h=v;while(1){f[g>>2]=i;if((h|0)==(a|0)){w=a;break}e=h+-4|0;i=f[e>>2]|0;k=f[m>>2]|0;n=f[q+(i<<2)>>2]|0;if(!((k|0)>(n|0)|(d|0)<(i|0)&(k|0)==(n|0))){w=h;break}else{n=h;h=e;g=n}}f[w>>2]=d;x=q}else x=s;g=u+4|0;if((g|0)==(b|0))break;h=u;s=x;t=f[u>>2]|0;u=g;v=h}return}function dga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=f[c>>2]|0;i=f[h+(e<<2)>>2]|0;j=f[h+(g<<2)>>2]|0;if(!((i|0)>(j|0)|(e|0)<(g|0)&(i|0)==(j|0))){k=1;return k|0}f[a>>2]=e;f[d>>2]=g;k=1;return k|0}case 3:{g=a+4|0;d=b+-4|0;e=f[g>>2]|0;j=f[a>>2]|0;i=f[c>>2]|0;h=f[i+(e<<2)>>2]|0;l=i+(j<<2)|0;m=f[l>>2]|0;n=f[d>>2]|0;o=f[i+(n<<2)>>2]|0;p=(o|0)>(h|0)|(n|0)<(e|0)&(o|0)==(h|0);if(!((h|0)>(m|0)|(e|0)<(j|0)&(h|0)==(m|0))){if(!p){k=1;return k|0}f[g>>2]=n;f[d>>2]=e;m=f[g>>2]|0;h=f[a>>2]|0;o=f[i+(m<<2)>>2]|0;q=f[i+(h<<2)>>2]|0;if(!((o|0)>(q|0)|(m|0)<(h|0)&(o|0)==(q|0))){k=1;return k|0}f[a>>2]=m;f[g>>2]=h;k=1;return k|0}if(p){f[a>>2]=n;f[d>>2]=j;k=1;return k|0}f[a>>2]=e;f[g>>2]=j;e=f[d>>2]|0;n=f[i+(e<<2)>>2]|0;i=f[l>>2]|0;if(!((n|0)>(i|0)|(e|0)<(j|0)&(n|0)==(i|0))){k=1;return k|0}f[g>>2]=e;f[d>>2]=j;k=1;return k|0}case 4:{aga(a,a+4|0,a+8|0,b+-4|0,c)|0;k=1;return k|0}case 5:{bga(a,a+4|0,a+8|0,a+12|0,b+-4|0,c)|0;k=1;return k|0}case 1:case 0:{k=1;return k|0}default:{j=a+8|0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;i=f[c>>2]|0;n=f[i+(e<<2)>>2]|0;l=i+(g<<2)|0;p=f[l>>2]|0;h=f[j>>2]|0;m=i+(h<<2)|0;q=f[m>>2]|0;o=(q|0)>(n|0)|(h|0)<(e|0)&(q|0)==(n|0);do if((n|0)>(p|0)|(e|0)<(g|0)&(n|0)==(p|0)){if(o){f[a>>2]=h;f[j>>2]=g;r=g;break}f[a>>2]=e;f[d>>2]=g;q=f[m>>2]|0;s=f[l>>2]|0;if((q|0)>(s|0)|(h|0)<(g|0)&(q|0)==(s|0)){f[d>>2]=h;f[j>>2]=g;r=g}else r=h}else if(o){f[d>>2]=h;f[j>>2]=e;s=f[m>>2]|0;q=f[l>>2]|0;if((s|0)>(q|0)|(h|0)<(g|0)&(s|0)==(q|0)){f[a>>2]=h;f[d>>2]=g;r=e}else r=e}else r=h;while(0);h=a+12|0;a:do if((h|0)==(b|0)){t=1;u=0}else{e=i;g=r;d=0;l=h;m=j;while(1){o=f[l>>2]|0;p=f[e+(o<<2)>>2]|0;n=f[e+(g<<2)>>2]|0;if((p|0)>(n|0)|(o|0)<(g|0)&(p|0)==(n|0)){n=f[c>>2]|0;p=n+(o<<2)|0;q=g;s=l;v=m;while(1){f[s>>2]=q;if((v|0)==(a|0)){w=a;break}x=v+-4|0;q=f[x>>2]|0;y=f[p>>2]|0;z=f[n+(q<<2)>>2]|0;if(!((y|0)>(z|0)|(o|0)<(q|0)&(y|0)==(z|0))){w=v;break}else{z=v;v=x;s=z}}f[w>>2]=o;s=d+1|0;if((s|0)==8){t=0;u=(l+4|0)==(b|0);break a}else{A=n;B=s}}else{A=e;B=d}s=l+4|0;if((s|0)==(b|0)){t=1;u=0;break a}v=l;e=A;g=f[l>>2]|0;d=B;l=s;m=v}}while(0);k=u|t;return k|0}}return 0}function ega(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;i=u;u=u+144|0;j=i+128|0;k=i+72|0;l=i+56|0;m=i;_$(j,72596);do if((NS(a)|0)==65536){n=f[a+4>>2]|0;f[k>>2]=f[n>>2];o=k+4|0;p=n+4|0;f[o>>2]=f[p>>2];q=k+8|0;f[q>>2]=f[n+8>>2];f[k+12>>2]=f[n+12>>2];f[k+16>>2]=f[n+16>>2];f[k+20>>2]=f[n+20>>2];f[k+24>>2]=f[n+24>>2];f[k+28>>2]=f[n+28>>2];f[k+32>>2]=f[n+32>>2];r=f[n+36>>2]|0;f[k+36>>2]=r;f[k+40>>2]=q;q=k+48|0;s=k+44|0;f[s>>2]=q;f[q>>2]=0;f[k+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[n+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[o>>2]=0;BR(k,n);break}}else OR(k,a,-1);while(0);f[l>>2]=0;a=l+4|0;f[a>>2]=0;f[l+8>>2]=0;n=rNa(g)|0;fga(k,c,d,e,n,rNa(h)|0,l,2147483647);f[m>>2]=1124024348;n=m+4|0;f[n>>2]=2;e=m+8|0;o=f[a>>2]|0;p=f[l>>2]|0;q=o-p|0;f[e>>2]=q>>4;f[m+12>>2]=1;s=m+16|0;r=m+40|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[s+16>>2]=0;f[s+20>>2]=0;f[r>>2]=e;e=m+48|0;t=m+44|0;f[t>>2]=e;f[e>>2]=0;v=m+52|0;f[v>>2]=0;w=p;if((w|0)!=(o|0)){f[v>>2]=16;f[e>>2]=16;f[s>>2]=w;f[m+20>>2]=w;w=p+q|0;f[m+24>>2]=w;f[m+28>>2]=w}eL(m,b);b=m+36|0;w=f[b>>2]|0;if(w|0?(q=w+12|0,w=f[q>>2]|0,f[q>>2]=w+-1,(w|0)==1):0)CR(m);f[b>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[n>>2]|0)>0){s=f[r>>2]|0;r=0;do{f[s+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[n>>2]|0))}n=f[t>>2]|0;if((n|0)!=(e|0))ZF(n);n=f[l>>2]|0;if(n|0){l=f[a>>2]|0;if((l|0)!=(n|0))f[a>>2]=l+(~((l+-16-n|0)>>>4)<<4);PYa(n)}n=k+36|0;l=f[n>>2]|0;if(l|0?(a=l+12|0,l=f[a>>2]|0,f[a>>2]=l+-1,(l|0)==1):0)CR(k);f[n>>2]=0;n=k+16|0;l=k+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[l>>2]|0)>0){n=f[k+40>>2]|0;a=0;do{f[n+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))ZF(l);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function fga(a,c,d,e,g,h,i,j){a=a|0;c=+c;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,M=0,N=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;k=u;u=u+416|0;l=k+392|0;m=k+384|0;o=k+328|0;p=k;q=k+272|0;r=k+256|0;s=k+240|0;t=k+224|0;f[m>>2]=0;v=m+4|0;f[v>>2]=0;w=1.0/c;if(f[a>>2]&4095|0){f[l>>2]=0;f[l+4>>2]=0;x=c$(l,57)|0;y=314146;z=x+57|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));j$(-215,l,314204,313925,424);d$(l)}y=f[a+12>>2]|0;A=f[a+8>>2]|0;B=d;C=rNa(3.141592653589793/B)|0;D=wNa(+(A+y<<1|1|0)/c)|0;XQ(p,C,D,4);f[o>>2]=1124007936;E=o+4|0;F=o+8|0;G=o+40|0;x=E;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[G>>2]=F;F=o+48|0;H=o+44|0;f[H>>2]=F;f[F>>2]=0;f[o+52>>2]=0;I=f[p>>2]|0;Ah[f[(f[I>>2]|0)+12>>2]&255](I,p,o,-1);fj(p);f[q>>2]=1124007936;p=q+4|0;I=q+8|0;K=q+40|0;x=p;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[K>>2]=I;I=q+48|0;x=q+44|0;f[x>>2]=I;f[I>>2]=0;f[q+52>>2]=0;f[l>>2]=A;f[l+4>>2]=y;AR(q,2,l,0);z=C<<1;f[l>>2]=0;M=l+4|0;f[M>>2]=0;f[l+8>>2]=0;if(C){if(z>>>0>1073741823)gXa(l);N=C<<3;Q=NYa(N)|0;f[l>>2]=Q;R=Q+(z<<2)|0;f[l+8>>2]=R;F1a(Q|0,0,N|0)|0;f[M>>2]=R;R=(C|0)>0;if(R){c=w;N=0;do{w=B*+(N|0);d=c*+O(+w);z=N<<1;n[Q+(z<<2)>>2]=d;d=c*+P(+w);n[Q+((z|1)<<2)>>2]=d;N=N+1|0}while((N|0)!=(C|0));S=Q;T=R}else{S=Q;T=0}}else{S=0;T=0}Q=q+16|0;R=f[Q>>2]|0;f[r>>2]=0;N=r+4|0;f[N>>2]=0;f[r+8>>2]=0;f[v>>2]=0;do if((A|0)>0){z=a+16|0;U=a+44|0;V=r+8|0;if((y|0)>0){W=R;X=0}else{Z=0;do Z=Z+1|0;while((Z|0)<(A|0));f[m>>2]=0;f[v>>2]=Z;_=0;$=0;aa=0;break}while(1){ba=(f[z>>2]|0)+(Y(f[f[U>>2]>>2]|0,X)|0)|0;ca=W+(Y(f[f[x>>2]>>2]|0,X)|0)|0;f[m>>2]=0;da=0;do{ea=ca+da|0;do if(b[ba+da>>0]|0){b[ea>>0]=1;fa=f[N>>2]|0;if((fa|0)==(f[V>>2]|0)){p8(r,m);break}else{f[fa>>2]=f[m>>2];f[fa+4>>2]=f[v>>2];f[N>>2]=fa+8;break}}else b[ea>>0]=0;while(0);da=(f[m>>2]|0)+1|0;f[m>>2]=da}while((da|0)<(y|0));da=(f[v>>2]|0)+1|0;f[v>>2]=da;if((da|0)>=(A|0))break;W=f[Q>>2]|0;X=da}V=f[r>>2]|0;_=V;$=V;aa=f[N>>2]|0}else{_=0;$=0;aa=0}while(0);X=aa-$|0;a:do if((X|0)>0){$=e+-1|0;aa=o+16|0;W=(D+-1|0)/2|0;v=s+8|0;m=s+12|0;a=s+4|0;V=t+4|0;U=t+8|0;z=t+12|0;Z=i+4|0;da=i+8|0;ba=T^1;ca=-1;ea=-1;fa=_;ga=X>>>3;while(1){ha=W1a(ca|0,0,-130063606,0)|0;ia=C1a(ha|0,J|0,ea|0,0)|0;ha=J;ja=(ia>>>0)%(ga>>>0)|0;ka=f[fa+(ja<<3)>>2]|0;la=f[fa+(ja<<3)+4>>2]|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;ma=f[aa>>2]|0;na=ga+-1|0;f[fa+(ja<<3)>>2]=f[fa+(na<<3)>>2];f[fa+(ja<<3)+4>>2]=f[fa+(na<<3)+4>>2];ja=R+((Y(la,y)|0)+ka)|0;if(!((b[ja>>0]|0)==0|ba)){c=+(ka|0);B=+(la|0);ja=ma;ma=0;oa=$;pa=0;while(1){qa=pa<<1;ra=ja+((wNa(c*+n[S+(qa<<2)>>2]+B*+n[S+((qa|1)<<2)>>2])|0)+W<<2)|0;qa=f[ra>>2]|0;sa=qa+1|0;f[ra>>2]=sa;ra=(oa|0)>(qa|0);ma=ra?ma:pa;oa=ra?oa:sa;pa=pa+1|0;if((pa|0)==(C|0))break;else ja=ja+(D<<2)|0}if((oa|0)>=(e|0)){ja=ma<<1;B=+n[S+((ja|1)<<2)>>2];c=+n[S+(ja<<2)>>2];d=+L(+-B);w=+L(+c);if(d>w){ta=B<-0.0?1:-1;ua=wNa(c*65536.0/d)|0;va=ka;wa=0;xa=la<<16|32768}else{ta=wNa(B*-65536.0/w)|0;ua=c>0.0?1:-1;va=ka<<16|32768;wa=1;xa=la}ja=0-ta|0;pa=0-ua|0;sa=xa>>16;ra=va>>16;if(((wa?ra:va)|0)>=0){qa=f[a>>2]|0;ya=f[s>>2]|0;b:do if(wa){za=0;Aa=xa;Ba=qa;Ca=ra;Da=ya;Ea=va;while(1){if(!((Aa|0)<(A|0)&((Ca|0)<(y|0)&(Aa|0)>-1))){Fa=Ba;Ga=Da;break b}Ha=R+(Y(Aa,y)|0)+Ca|0;if(!(b[Ha>>0]|0))if((za|0)<(h|0)){Ia=za+1|0;Ja=Ba;Ka=Da}else{Fa=Ba;Ga=Da;break b}else{Ia=0;Ja=Aa;Ka=Ca}Ea=Ea+ta|0;Ca=Ea>>16;if((Ca|0)<0){Fa=Ja;Ga=Ka;break}else{za=Ia;Aa=Aa+ua|0;Ba=Ja;Da=Ka}}}else{Da=0;Ba=sa;Aa=qa;za=va;Ca=ya;Ea=xa;while(1){if(!((Ba|0)<(A|0)&((za|0)<(y|0)&(Ba|0)>-1))){Fa=Aa;Ga=Ca;break b}Ha=R+(Y(Ba,y)|0)+za|0;if(!(b[Ha>>0]|0))if((Da|0)<(h|0)){La=Da+1|0;Ma=Aa;Na=Ca}else{Fa=Aa;Ga=Ca;break b}else{La=0;Ma=Ba;Na=za}za=za+ta|0;Ha=Ea+ua|0;if((za|0)<0){Fa=Ma;Ga=Na;break}else{Da=La;Ba=Ha>>16;Aa=Ma;Ca=Na;Ea=Ha}}}while(0);f[a>>2]=Fa;f[s>>2]=Ga;ya=f[m>>2]|0;qa=f[v>>2]|0;c:do if(wa){la=0;ka=xa;ma=ya;oa=ra;Ea=qa;Ca=va;while(1){if(!((ka|0)<(A|0)&((oa|0)<(y|0)&(ka|0)>-1))){Oa=ma;Pa=Ea;break c}Aa=R+(Y(ka,y)|0)+oa|0;if(!(b[Aa>>0]|0))if((la|0)<(h|0)){Qa=la+1|0;Ra=ma;Sa=Ea}else{Oa=ma;Pa=Ea;break c}else{Qa=0;Ra=ka;Sa=oa}Ca=Ca-ta|0;oa=Ca>>16;if((oa|0)<0){Oa=Ra;Pa=Sa;break}else{la=Qa;ka=ka-ua|0;ma=Ra;Ea=Sa}}}else{Ea=0;ma=sa;ka=ya;la=va;oa=qa;Ca=xa;while(1){if(!((ma|0)<(A|0)&((la|0)<(y|0)&(ma|0)>-1))){Oa=ka;Pa=oa;break c}Aa=R+(Y(ma,y)|0)+la|0;if(!(b[Aa>>0]|0))if((Ea|0)<(h|0)){Ta=Ea+1|0;Ua=ka;Va=oa}else{Oa=ka;Pa=oa;break c}else{Ta=0;Ua=ma;Va=la}la=la-ta|0;Aa=Ca-ua|0;if((la|0)<0){Oa=Ua;Pa=Va;break}else{Ea=Ta;ma=Aa>>16;ka=Ua;oa=Va;Ca=Aa}}}while(0);f[m>>2]=Oa;f[v>>2]=Pa}qa=(f[v>>2]|0)-(f[s>>2]|0)|0;if((((qa|0)>-1?qa:0-qa|0)|0)<(g|0)){qa=(f[m>>2]|0)-(f[a>>2]|0)|0;Wa=(((qa|0)>-1?qa:0-qa|0)|0)>=(g|0)}else Wa=1;qa=Wa&T;ya=0;do{sa=(ya|0)==1;ra=sa?ja:ta;Ca=sa?pa:ua;sa=s+(ya<<3)|0;oa=s+(ya<<3)+4|0;d:do if(wa){ka=va;ma=xa;while(1){Ea=ka>>16;la=R+(Y(ma,y)|0)+Ea|0;if(b[la>>0]|0){if(qa){c=+(Ea|0);w=+(ma|0);Aa=f[aa>>2]|0;Ba=0;while(1){Da=Ba<<1;za=Aa+((wNa(c*+n[S+(Da<<2)>>2]+w*+n[S+((Da|1)<<2)>>2])|0)+W<<2)|0;f[za>>2]=(f[za>>2]|0)+-1;Ba=Ba+1|0;if((Ba|0)==(C|0))break;else Aa=Aa+(D<<2)|0}}b[la>>0]=0}if((ma|0)==(f[oa>>2]|0)?(Ea|0)==(f[sa>>2]|0):0)break d;ka=ka+ra|0;ma=ma+Ca|0}}else{if(Wa){Xa=va;Ya=xa}else{ma=f[oa>>2]|0;ka=f[sa>>2]|0;Aa=va;Ba=xa;while(1){za=Ba>>16;Da=R+(Y(za,y)|0)+Aa|0;if(b[Da>>0]|0)b[Da>>0]=0;if((za|0)==(ma|0)&(Aa|0)==(ka|0))break d;Aa=Aa+ra|0;Ba=Ba+Ca|0}}while(1){Ba=Ya>>16;Aa=R+(Y(Ba,y)|0)+Xa|0;if(b[Aa>>0]|0){if(T){w=+(Xa|0);c=+(Ba|0);ka=f[aa>>2]|0;ma=0;while(1){za=ma<<1;Da=ka+((wNa(w*+n[S+(za<<2)>>2]+c*+n[S+((za|1)<<2)>>2])|0)+W<<2)|0;f[Da>>2]=(f[Da>>2]|0)+-1;ma=ma+1|0;if((ma|0)==(C|0))break;else ka=ka+(D<<2)|0}}b[Aa>>0]=0}if((Ba|0)==(f[oa>>2]|0)?(Xa|0)==(f[sa>>2]|0):0)break d;Xa=Xa+ra|0;Ya=Ya+Ca|0}}while(0);ya=ya+1|0}while((ya|0)!=2);if(Wa){ya=f[s>>2]|0;qa=f[a>>2]|0;pa=f[v>>2]|0;ja=f[m>>2]|0;f[t>>2]=ya;f[V>>2]=qa;f[U>>2]=pa;f[z>>2]=ja;ja=f[Z>>2]|0;if((ja|0)==(f[da>>2]|0)){w7(i,t);Za=f[Z>>2]|0}else{f[ja>>2]=ya;f[ja+4>>2]=f[V>>2];f[ja+8>>2]=f[U>>2];f[ja+12>>2]=f[z>>2];ya=ja+16|0;f[Z>>2]=ya;Za=ya}if((Za-(f[i>>2]|0)>>4|0)>=(j|0))break}}}if((ga|0)<=1)break a;ca=ia;ea=ha;fa=f[r>>2]|0;ga=na}}while(0);j=f[r>>2]|0;if(j|0){r=f[N>>2]|0;if((r|0)!=(j|0))f[N>>2]=r+(~((r+-8-j|0)>>>3)<<3);PYa(j)}j=f[l>>2]|0;if(j|0){l=f[M>>2]|0;if((l|0)!=(j|0))f[M>>2]=l+(~((l+-4-j|0)>>>2)<<2);PYa(j)}j=q+36|0;l=f[j>>2]|0;if(l|0?(M=l+12|0,l=f[M>>2]|0,f[M>>2]=l+-1,(l|0)==1):0)CR(q);f[j>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[p>>2]|0)>0){Q=f[K>>2]|0;K=0;do{f[Q+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[p>>2]|0))}p=f[x>>2]|0;if((p|0)!=(I|0))ZF(p);p=o+36|0;I=f[p>>2]|0;if(I|0?(x=I+12|0,I=f[x>>2]|0,f[x>>2]=I+-1,(I|0)==1):0)CR(o);f[p>>2]=0;p=o+16|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[E>>2]|0)>0){p=f[G>>2]|0;G=0;do{f[p+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[E>>2]|0))}E=f[H>>2]|0;if((E|0)==(F|0)){u=k;return}ZF(E);u=k;return}function gga(a,c,e,g,i,j,k,l,m){a=a|0;c=c|0;e=e|0;g=+g;i=+i;j=+j;k=+k;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0.0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0.0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0.0,Fa=0.0,Ga=0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0;o=u;u=u+176|0;p=o+8|0;q=o+160|0;r=o+128|0;s=o;t=o+40|0;v=o+20|0;w=rNa(j)|0;x=rNa(k)|0;y=F0(a,o+96|0,0,0)|0;if(f[y>>2]&4094|0){f[p>>2]=0;f[p+4>>2]=0;z=c$(p,46)|0;A=314547;B=z+46|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-5,p,314594,313925,1241);d$(p)}a=(c|0)==0;if(a){f[p>>2]=0;f[p+4>>2]=0;z=c$(p,16)|0;A=314311;B=z+16|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-27,p,314594,313925,1244);d$(p)}if(g<=0.0|i<=0.0|(w|0)<1|(x|0)<1){f[p>>2]=0;f[p+4>>2]=0;z=c$(p,76)|0;A=314609;B=z+76|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-211,p,314594,313925,1247);d$(p)}C=(l|0)>0?l:0;if((m|0)<1){l=f[y+20>>2]|0;D=f[y+24>>2]|0;E=(l|0)<(D|0)?D:l}else E=(C|0)<(m|0)?m:C+2|0;a:do if(!a){m=f[c>>2]|0;l=m&-65536;if((l|0)>=1116274688){switch(l|0){case 1116274688:break;default:{F=15;break a}}G=yL(21,56,12,c)|0;H=2147483647;I=0;J=1;break}switch(l|0){case 1111621632:break;default:{F=15;break a}}if(((f[c+24>>2]|0)>0?(f[c+20>>2]|0)>0:0)?(f[c+16>>2]|0)!=0:0){K=m;F=17}else F=15}else F=15;while(0);if((F|0)==15){f[p>>2]=0;f[p+4>>2]=0;z=c$(p,43)|0;A=314328;B=z+43|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-5,p,314372,314387,121);d$(p);K=f[c>>2]|0;F=17}if((F|0)==17){do if(K&16384){a=f[c+20>>2]|0;if((a|0)==1)if((K&4095|0)==21){L=1;break}else{F=21;break}else if((K&4095|0)==21?(f[c+24>>2]|0)==1:0){L=a;break}else{F=21;break}}else F=21;while(0);if((F|0)==21){f[p>>2]=0;f[p+4>>2]=0;z=c$(p,84)|0;A=314439;B=z+84|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-5,p,314594,313925,1269);d$(p);L=f[c+20>>2]|0}F=EL(21,56,12,f[c+16>>2]|0,L+-1+(f[c+24>>2]|0)|0,t,v)|0;v=f[t+24>>2]|0;RL(F);G=t;H=v;I=c;J=0}if((e|0)==3){k=g;g=i;f[q>>2]=0;e=q+4|0;f[e>>2]=0;f[q+8>>2]=0;i=+(C|0);j=i*i;i=+(E|0);N=i*i;c=y+20|0;v=y+24|0;t=t0(f[c>>2]|0,f[v>>2]|0,0)|0;if(!t)O=0;else{F=NYa(16)|0;f[F+4>>2]=1;f[F>>2]=72624;f[F+8>>2]=t;O=F}H1(y,t,(w|0)<2?1.0:+((w|0)/2|0|0),+(w|0),3);w=t0(f[c>>2]|0,f[v>>2]|0,3)|0;if(!w)P=0;else{F=NYa(16)|0;f[F+4>>2]=1;f[F>>2]=72624;f[F+8>>2]=w;P=F}F=t0(f[c>>2]|0,f[v>>2]|0,3)|0;if(!F)Q=0;else{L=NYa(16)|0;f[L+4>>2]=1;f[L>>2]=72624;f[L+8>>2]=F;Q=L}e8(y,w,1,0,3);e8(y,F,0,1,3);R=k<1.0?1.0:k;k=1.0/R;S=k*+(f[c>>2]|0);y=~~S;T=k*+(f[v>>2]|0);L=~~T;K=t0(y+2+(+(y|0)<S&1)|0,L+2+(+(L|0)<T&1)|0,4)|0;if(!K)U=0;else{L=NYa(16)|0;f[L+4>>2]=1;f[L>>2]=72624;f[L+8>>2]=K;U=L}oL(K);L=pL(0)|0;if(!L)V=0;else{y=NYa(16)|0;f[y+4>>2]=1;f[y>>2]=49084;f[y+8>>2]=L;V=y}y=yL(12,56,8,L)|0;a=yL(4,56,4,L)|0;L=f[c>>2]|0;c=f[v>>2]|0;v=f[K+20>>2]|0;m=v+-2|0;l=f[K+24>>2]|0;D=l+-2|0;W=f[K+16>>2]|0;X=(f[K+4>>2]|0)>>>2;if((L|0)>0){K=t+16|0;Z=t+4|0;t=w+16|0;_=w+4|0;w=F+16|0;$=F+4|0;F=(c|0)>0;aa=p+4|0;ba=(C|0)>(E|0);ca=0;do{da=(f[K>>2]|0)+(Y(f[Z>>2]|0,ca)|0)|0;ea=(f[t>>2]|0)+(Y(f[_>>2]|0,ca)|0)|0;fa=(f[w>>2]|0)+(Y(f[$>>2]|0,ca)|0)|0;b:do if(F){T=k*+(ca|0)*1024.0;if(ba){ga=0;while(1){f[p>>2]=0;f[aa>>2]=0;if(!((b[da+ga>>0]|0)==0?1:(d[fa+(ga<<1)>>1]|d[ea+(ga<<1)>>1])<<16>>16==0)){f[p>>2]=ga;f[aa>>2]=ca;NL(y,p)|0}ga=ga+1|0;if((ga|0)>=(c|0))break b}}else ha=0;do{f[p>>2]=0;f[aa>>2]=0;ga=d[ea+(ha<<1)>>1]|0;S=+(ga<<16>>16);ia=d[fa+(ha<<1)>>1]|0;ja=+(ia<<16>>16);if(!((b[da+ha>>0]|0)==0|(ia|ga)<<16>>16==0)){ka=+M(+(S*S+ja*ja));ga=wNa(k*S*1024.0/ka)|0;ia=wNa(k*ja*1024.0/ka)|0;la=wNa(k*+(ha|0)*1024.0)|0;ma=wNa(T)|0;na=Y(ga,C)|0;oa=Y(ia,C)|0;pa=C;qa=la+na|0;ra=ma+oa|0;while(1){sa=qa>>10;ta=ra>>10;if(!(sa>>>0<D>>>0&ta>>>0<m>>>0))break;ua=W+((Y(ta,X)|0)+sa<<2)|0;f[ua>>2]=(f[ua>>2]|0)+1;if((pa|0)<(E|0)){pa=pa+1|0;qa=qa+ga|0;ra=ra+ia|0}else break}ra=C;qa=la-na|0;pa=ma-oa|0;while(1){ua=qa>>10;sa=pa>>10;if(!(ua>>>0<D>>>0&sa>>>0<m>>>0))break;ta=W+((Y(sa,X)|0)+ua<<2)|0;f[ta>>2]=(f[ta>>2]|0)+1;if((ra|0)<(E|0)){ra=ra+1|0;qa=qa-ga|0;pa=pa-ia|0}else break}f[p>>2]=ha;f[aa>>2]=ca;NL(y,p)|0}ha=ha+1|0}while((ha|0)<(c|0))}while(0);ca=ca+1|0}while((ca|0)<(L|0))}L=f[y+24>>2]|0;c:do if(L){ca=v+-3|0;if((ca|0)>1?(c=l+-3|0,(c|0)>1):0){ha=1;do{aa=Y(ha,l)|0;E=1;do{X=E+aa|0;f[p>>2]=X;m=f[W+(X<<2)>>2]|0;do if((m|0)>(x|0)){if((m|0)<=(f[W+(X+-1<<2)>>2]|0))break;if((m|0)<(f[W+(X+1<<2)>>2]|0))break;if((m|0)<=(f[W+(X-l<<2)>>2]|0))break;if((m|0)<(f[W+(X+l<<2)>>2]|0))break;NL(a,p)|0}while(0);E=E+1|0}while((E|0)<(c|0));ha=ha+1|0}while((ha|0)<(ca|0))}ca=a+24|0;ha=f[ca>>2]|0;if(ha){c=(ha|0)<(L|0)?L:ha;E=f[e>>2]|0;aa=f[q>>2]|0;X=E-aa>>2;m=aa;D=E;E=aa;do if(c>>>0<=X>>>0)if(c>>>0<X>>>0){aa=m+(c<<2)|0;if((D|0)==(aa|0)){va=E;break}f[e>>2]=D+(~((D+-4-aa|0)>>>2)<<2);va=E}else va=E;else{GM(q,c-X|0);va=f[q>>2]|0}while(0);X=s;f[X>>2]=0;f[X+4>>2]=0;f[s+4>>2]=1073741823;f[p>>2]=f[s>>2];f[p+4>>2]=f[s+4>>2];BL(a,va,p)|0;X=f[q>>2]|0;f[p>>2]=W;$fa(X,X+(ha<<2)|0,p);RL(a);PL(a,f[q>>2]|0,ha,0);X=t0(1,L,5)|0;if(!X)wa=0;else{c=NYa(16)|0;f[c+4>>2]=1;f[c>>2]=72624;f[c+8>>2]=X;wa=c}c=f[X+16>>2]|0;k=R>g?R:g;T=k*k;if((f[ca>>2]|0)>0){E=G+24|0;D=(L|0)>0;m=X+24|0;aa=p+4|0;C=p+8|0;ba=r+12|0;F=r+20|0;$=0;while(1){w=AL(a,$)|0;_=f[w>>2]|0;w=(_|0)/(l|0)|0;k=R*(+(_-(Y(w,l)|0)|0)+.5);ka=R*(+(w|0)+.5);w=f[E>>2]|0;d:do if((w|0)>0){_=0;while(1){t=AL(G,_)|0;ja=+n[t>>2]-k;S=+n[t+4>>2]-ka;if(ja*ja+S*S<T)break;t=_+1|0;Z=f[E>>2]|0;if((t|0)<(Z|0))_=t;else{xa=Z;ya=t;break d}}xa=f[E>>2]|0;ya=_}else{xa=w;ya=0}while(0);do if((ya|0)>=(xa|0)){CL(y,r,0);if(D){za=0;Aa=0}else break;while(1){w=f[ba>>2]|0;t=w;Z=t;K=h[Z>>0]|h[Z+1>>0]<<8|h[Z+2>>0]<<16|h[Z+3>>0]<<24;Z=t+4|0;t=h[Z>>0]|h[Z+1>>0]<<8|h[Z+2>>0]<<16|h[Z+3>>0]<<24;Z=w+8|0;f[ba>>2]=Z;if(Z>>>0>=(f[F>>2]|0)>>>0)LL(r,1);S=k-+(K|0);ja=ka-+(t|0);Ba=S*S+ja*ja;if(!(j<=Ba)|!(Ba<=N))Ca=Aa;else{n[c+(Aa<<2)>>2]=Ba;f[(f[q>>2]|0)+(Aa<<2)>>2]=Aa;Ca=Aa+1|0}za=za+1|0;if((za|0)>=(L|0))break;else Aa=Ca}_=Ca+-1|0;if(!Ca)break;f[m>>2]=Ca;zN(X,X,.5);t=f[q>>2]|0;f[p>>2]=c;$fa(t,t+(Ca<<2)|0,p);t=f[q>>2]|0;K=Ca+-2|0;e:do if((K|0)>-1){Z=K;w=0;Ba=0.0;ja=+n[c+(f[t+(_<<2)>>2]<<2)>>2];da=_;while(1){S=+n[c+(f[t+(Z<<2)>>2]<<2)>>2];if(S>i){Da=w;Ea=Ba;break e}do if(S-ja>R){Fa=+n[c+(f[t+(((Z+da|0)/2|0)<<2)>>2]<<2)>>2];fa=da-Z|0;if(!(Ba*+(fa|0)>=+(w|0)*Fa)?!(Ba<1.1920928955078125e-07)|(fa|0)<(w|0):0){Ga=w;Ha=Ba;Ia=S;Ja=Z;break}Ga=fa;Ha=Fa;Ia=S;Ja=Z}else{Ga=w;Ha=Ba;Ia=ja;Ja=da}while(0);if((Z|0)>0){Z=Z+-1|0;w=Ga;Ba=Ha;ja=Ia;da=Ja}else{Da=Ga;Ea=Ha;break}}}else{Da=0;Ea=0.0}while(0);if((Da|0)<=(x|0))break;n[p>>2]=k;n[aa>>2]=ka;n[C>>2]=Ea;NL(G,p)|0;if((f[E>>2]|0)>(H|0)){Ka=wa;break c}}while(0);$=$+1|0;if(($|0)>=(f[ca>>2]|0)){Ka=wa;break}}}else Ka=wa}else Ka=0}else Ka=0;while(0);wa=V;if(V|0?(H=wa+4|0,x=f[H>>2]|0,f[H>>2]=x+-1,(x|0)==1):0)ki[f[(f[V>>2]|0)+8>>2]&2047](wa);wa=f[q>>2]|0;if(wa|0){q=f[e>>2]|0;if((q|0)!=(wa|0))f[e>>2]=q+(~((q+-4-wa|0)>>>2)<<2);PYa(wa)}wa=Ka;if(Ka|0?(q=wa+4|0,e=f[q>>2]|0,f[q>>2]=e+-1,(e|0)==1):0)ki[f[(f[Ka>>2]|0)+8>>2]&2047](wa);wa=U;if(U|0?(Ka=wa+4|0,e=f[Ka>>2]|0,f[Ka>>2]=e+-1,(e|0)==1):0)ki[f[(f[U>>2]|0)+8>>2]&2047](wa);wa=O;do if(O|0){U=wa+4|0;e=f[U>>2]|0;f[U>>2]=e+-1;if((e|0)!=1)break;ki[f[(f[O>>2]|0)+8>>2]&2047](wa)}while(0);wa=Q;do if(Q|0){O=wa+4|0;e=f[O>>2]|0;f[O>>2]=e+-1;if((e|0)!=1)break;ki[f[(f[Q>>2]|0)+8>>2]&2047](wa)}while(0);wa=P;do if(P|0){Q=wa+4|0;e=f[Q>>2]|0;f[Q>>2]=e+-1;if((e|0)!=1)break;ki[f[(f[P>>2]|0)+8>>2]&2047](wa)}while(0)}else{f[p>>2]=0;f[p+4>>2]=0;z=c$(p,22)|0;A=314524;B=z+22|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-5,p,314594,313925,1285);d$(p)}if(J){La=G;u=o;return La|0}J=I+24|0;p=I+20|0;f[((f[J>>2]|0)>(f[p>>2]|0)?J:p)>>2]=f[G+24>>2];La=0;u=o;return La|0}function hga(a){a=a|0;PYa(a);return}function iga(a){a=a|0;_0(a+12|0,f[a+8>>2]|0);if(!a)return;ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function jga(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=+h;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=u;u=u+176|0;l=k+160|0;m=k+104|0;n=k;o=k+96|0;p=k+40|0;q=k+8|0;_$(o,72636);r=pL(4096)|0;if(!r)s=0;else{t=NYa(16)|0;f[t+4>>2]=1;f[t>>2]=49084;f[t+8>>2]=r;s=t}do if((NS(a)|0)==65536){t=f[a+4>>2]|0;f[p>>2]=f[t>>2];v=p+4|0;w=t+4|0;f[v>>2]=f[w>>2];x=p+8|0;f[x>>2]=f[t+8>>2];y=p+12|0;f[y>>2]=f[t+12>>2];z=p+16|0;f[z>>2]=f[t+16>>2];f[p+20>>2]=f[t+20>>2];f[p+24>>2]=f[t+24>>2];f[p+28>>2]=f[t+28>>2];f[p+32>>2]=f[t+32>>2];A=f[t+36>>2]|0;f[p+36>>2]=A;f[p+40>>2]=x;B=p+48|0;C=p+44|0;f[C>>2]=B;f[B>>2]=0;f[p+52>>2]=0;if(A|0){B=A+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;B=f[C>>2]|0;f[B>>2]=f[w>>2];f[B+4>>2]=f[w+4>>2];D=z;E=y;F=z;G=v;H=p;I=C;J=x;break}else{f[v>>2]=0;BR(p,t);D=z;E=y;F=z;G=v;H=p;I=C;J=x;break}}else{OR(p,a,-1);x=p+16|0;D=x;E=p+12|0;F=x;G=p+4|0;H=p;I=p+44|0;J=p+8|0}while(0);a=f[J>>2]|0;J=(f[G>>2]|0)==1?1:f[E>>2]|0;E=f[H>>2]|0;H=E&4095;x=f[D>>2]|0;D=Y((E>>>3&511)+1<<(47696>>>(H<<1&14)&3),J)|0;f[q>>2]=H|1111638016;H=q+4|0;f[H>>2]=D;f[q+8>>2]=0;f[q+12>>2]=0;f[q+16>>2]=x;f[q+20>>2]=a;f[q+24>>2]=J;f[H>>2]=f[f[I>>2]>>2];f[q>>2]=E&20479|1111621632;E=gga(q,r,c,d,e,g,h,i,j)|0;if((E|0)!=0?(j=f[E+24>>2]|0,(j|0)>0):0){pS(b,1,j,f[E>>2]|0,-1,1,0);do if((NS(b)|0)==65536){j=f[b+4>>2]|0;f[m>>2]=f[j>>2];i=m+4|0;c=j+4|0;f[i>>2]=f[c>>2];r=m+8|0;f[r>>2]=f[j+8>>2];f[m+12>>2]=f[j+12>>2];q=m+16|0;f[q>>2]=f[j+16>>2];f[m+20>>2]=f[j+20>>2];f[m+24>>2]=f[j+24>>2];f[m+28>>2]=f[j+28>>2];f[m+32>>2]=f[j+32>>2];H=f[j+36>>2]|0;f[m+36>>2]=H;f[m+40>>2]=r;r=m+48|0;J=m+44|0;f[J>>2]=r;f[r>>2]=0;f[m+52>>2]=0;if(H|0){r=H+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[c>>2]|0)<3){c=f[j+44>>2]|0;r=f[J>>2]|0;f[r>>2]=f[c>>2];f[r+4>>2]=f[c+4>>2];K=q;L=J;break}else{f[i>>2]=0;BR(m,j);K=q;L=J;break}}else{OR(m,b,-1);K=m+16|0;L=m+44|0}while(0);J=f[K>>2]|0;q=n;f[q>>2]=0;f[q+4>>2]=0;f[n+4>>2]=1073741823;f[l>>2]=f[n>>2];f[l+4>>2]=f[n+4>>2];BL(E,J,l)|0;l=m+36|0;J=f[l>>2]|0;if(J|0?(E=J+12|0,J=f[E>>2]|0,f[E>>2]=J+-1,(J|0)==1):0)CR(m);f[l>>2]=0;l=m+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[l>>2]|0)>0){K=f[m+40>>2]|0;J=0;do{f[K+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[l>>2]|0))}l=f[L>>2]|0;if((l|0)!=(m+48|0))ZF(l)}else oS(b);b=p+36|0;l=f[b>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)CR(p);f[b>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[G>>2]|0)>0){F=f[p+40>>2]|0;b=0;do{f[F+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[G>>2]|0))}G=f[I>>2]|0;if((G|0)!=(p+48|0))ZF(G);if(s|0?(G=s+4|0,p=f[G>>2]|0,f[G>>2]=p+-1,(p|0)==1):0)ki[f[(f[s>>2]|0)+8>>2]&2047](s);if(!(f[o+4>>2]|0)){u=k;return}u=k;return}function kga(){var a=0;if(((((lga(1,0)|0)!=0?(lga(1,1)|0)!=0:0)?(lga(2,0)|0)!=0:0)?(lga(2,1)|0)!=0:0)?(lga(4,0)|0)!=0:0)a=(lga(4,1)|0)!=0&1;else a=0;b[5689975]=a;return}
function fHa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;c=f[a+404>>2]|0;e=(f[a+288>>2]|0)+-1|0;g=a+76|0;if((f[g>>2]|0)<=0){h=gHa(a,b)|0;return h|0}i=a+4|0;j=c+8|0;k=a+420|0;l=0;m=f[a+84>>2]|0;while(1){n=m+12|0;o=f[n>>2]|0;p=Y(o,f[j>>2]|0)|0;q=uh[f[(f[i>>2]|0)+32>>2]&63](a,f[c+64+(l<<2)>>2]|0,p,o,1)|0;if((f[j>>2]|0)>>>0<e>>>0)r=f[n>>2]|0;else{o=f[n>>2]|0;p=((f[m+32>>2]|0)>>>0)%(o>>>0)|0;r=(p|0)==0?o:p}p=f[m+28>>2]|0;o=f[m+8>>2]|0;s=(p>>>0)%(o>>>0)|0;t=(s|0)>0?o-s|0:s;s=f[(f[k>>2]|0)+4+(l<<2)>>2]|0;a:do if((r|0)>0){u=b+(l<<2)|0;v=m+40|0;w=t<<7;if((t|0)>0)x=0;else{y=0;while(1){z=Y(f[v>>2]|0,y)|0;Xh[s&127](a,m,f[u>>2]|0,f[q+(y<<2)>>2]|0,z,0,p);y=y+1|0;if((y|0)==(r|0))break a}}do{y=f[q+(x<<2)>>2]|0;z=Y(f[v>>2]|0,x)|0;Xh[s&127](a,m,f[u>>2]|0,y,z,0,p);z=y+(p<<7)|0;F1a(z|0,0,w|0)|0;y=d[z+-128>>1]|0;A=0;do{d[z+(A<<7)>>1]=y;A=A+1|0}while((A|0)!=(t|0));x=x+1|0}while((x|0)!=(r|0))}while(0);b:do if((f[j>>2]|0)==(e|0)?(s=t+p|0,w=(s>>>0)/(o>>>0)|0,(r|0)<(f[n>>2]|0)):0){u=s<<7;v=o+-1|0;A=(o|0)>0;if(o>>>0>s>>>0){s=r;while(1){F1a(f[q+(s<<2)>>2]|0,0,u|0)|0;s=s+1|0;if((s|0)>=(f[n>>2]|0))break b}}else B=r;do{s=f[q+(B<<2)>>2]|0;y=f[q+(B+-1<<2)>>2]|0;F1a(s|0,0,u|0)|0;if(A){z=0;C=y;y=s;while(1){s=d[C+(v<<7)>>1]|0;D=0;do{d[y+(D<<7)>>1]=s;D=D+1|0}while((D|0)!=(o|0));z=z+1|0;if(z>>>0>=w>>>0)break;else{C=C+(o<<7)|0;y=y+(o<<7)|0}}}B=B+1|0}while((B|0)<(f[n>>2]|0))}while(0);l=l+1|0;if((l|0)>=(f[g>>2]|0))break;else m=m+88|0}h=gHa(a,b)|0;return h|0}function gHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=u;u=u+16|0;c=b;d=a+404|0;e=f[d>>2]|0;g=a+292|0;h=f[g>>2]|0;if((h|0)>0){i=a+4|0;j=e+8|0;k=0;do{l=f[a+296+(k<<2)>>2]|0;m=f[l+12>>2]|0;n=Y(m,f[j>>2]|0)|0;o=uh[f[(f[i>>2]|0)+32>>2]&63](a,f[e+64+(f[l+4>>2]<<2)>>2]|0,n,m,0)|0;f[c+(k<<2)>>2]=o;k=k+1|0;o=f[g>>2]|0}while((k|0)<(o|0));p=o}else p=h;h=e+16|0;k=f[h>>2]|0;i=e+20|0;j=f[i>>2]|0;do if((k|0)<(j|0)){o=e+12|0;m=a+312|0;n=a+424|0;l=e+24|0;q=f[o>>2]|0;r=f[m>>2]|0;s=j;t=k;a:while(1){if(q>>>0<r>>>0){v=q;while(1){w=f[g>>2]|0;if((w|0)>0){x=0;y=0;while(1){z=f[a+296+(y<<2)>>2]|0;A=f[z+56>>2]|0;B=Y(A,v)|0;C=f[z+60>>2]|0;if((C|0)>0?(z=f[c+(y<<2)>>2]|0,(A|0)>0):0){D=x;E=0;while(1){F=D;G=(f[z+(E+t<<2)>>2]|0)+(B<<7)|0;H=0;while(1){I=F;F=F+1|0;f[e+24+(I<<2)>>2]=G;H=H+1|0;if((H|0)>=(A|0))break;else G=G+128|0}E=E+1|0;if((E|0)>=(C|0)){J=F;break}else D=F}}else J=x;y=y+1|0;if((y|0)>=(w|0))break;else x=J}}if(!($h[f[(f[n>>2]|0)+4>>2]&255](a,l)|0))break a;x=v+1|0;K=f[m>>2]|0;if(x>>>0<K>>>0)v=x;else break}L=f[i>>2]|0;M=K}else{L=s;M=r}f[o>>2]=0;x=t+1|0;if((x|0)<(L|0)){q=0;r=M;s=L;t=x}else{N=19;break}}if((N|0)==19){O=f[g>>2]|0;break}f[h>>2]=t;f[o>>2]=v;P=0;u=b;return P|0}else O=p;while(0);p=e+8|0;f[p>>2]=(f[p>>2]|0)+1;p=f[d>>2]|0;if((O|0)>1)Q=1;else{O=f[a+296>>2]|0;Q=f[((f[p+8>>2]|0)>>>0<((f[a+288>>2]|0)+-1|0)>>>0?O+12|0:O+76|0)>>2]|0}f[p+20>>2]=Q;f[p+12>>2]=0;f[p+16>>2]=0;P=1;u=b;return P|0}function hHa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=ui[f[f[a+4>>2]>>2]&127](a,1,12)|0;f[a+412>>2]=b;f[b>>2]=1004;c=a+40|0;switch(f[c>>2]|0){case 1:{if((f[a+36>>2]|0)!=1){d=f[a>>2]|0;f[d+20>>2]=10;ki[f[d>>2]&2047](a)}break}case 2:{if((f[a+36>>2]|0)!=3){d=f[a>>2]|0;f[d+20>>2]=10;ki[f[d>>2]&2047](a)}break}case 3:{if((f[a+36>>2]|0)!=3){d=f[a>>2]|0;f[d+20>>2]=10;ki[f[d>>2]&2047](a)}break}case 5:case 4:{if((f[a+36>>2]|0)!=4){d=f[a>>2]|0;f[d+20>>2]=10;ki[f[d>>2]&2047](a)}break}default:if((f[a+36>>2]|0)<1){d=f[a>>2]|0;f[d+20>>2]=10;ki[f[d>>2]&2047](a)}}d=a+260|0;e=a+80|0;if(f[d>>2]|0?(f[e>>2]|0)!=2:0){g=f[a>>2]|0;f[g+20>>2]=28;ki[f[g>>2]&2047](a)}g=f[e>>2]|0;switch(g|0){case 1:{if((f[a+76>>2]|0)!=1){e=f[a>>2]|0;f[e+20>>2]=11;ki[f[e>>2]&2047](a)}switch(f[c>>2]|0){case 3:case 1:{f[b+4>>2]=137;return}case 2:{f[b>>2]=1005;f[b+4>>2]=138;return}default:{e=f[a>>2]|0;f[e+20>>2]=28;ki[f[e>>2]&2047](a);return}}break}case 2:{if((f[a+76>>2]|0)!=3){e=f[a>>2]|0;f[e+20>>2]=11;ki[f[e>>2]&2047](a)}if((f[c>>2]|0)!=2){e=f[a>>2]|0;f[e+20>>2]=28;ki[f[e>>2]&2047](a);return}switch(f[d>>2]|0){case 0:{f[b+4>>2]=139;return}case 1:{f[b+4>>2]=140;return}default:{d=f[a>>2]|0;f[d+20>>2]=28;ki[f[d>>2]&2047](a);return}}break}case 3:{if((f[a+76>>2]|0)!=3){d=f[a>>2]|0;f[d+20>>2]=11;ki[f[d>>2]&2047](a)}switch(f[c>>2]|0){case 2:{f[b>>2]=1005;f[b+4>>2]=141;return}case 3:{f[b+4>>2]=142;return}default:{d=f[a>>2]|0;f[d+20>>2]=28;ki[f[d>>2]&2047](a);return}}break}case 4:{if((f[a+76>>2]|0)!=4){d=f[a>>2]|0;f[d+20>>2]=11;ki[f[d>>2]&2047](a)}if((f[c>>2]|0)==4){f[b+4>>2]=142;return}else{d=f[a>>2]|0;f[d+20>>2]=28;ki[f[d>>2]&2047](a);return}break}case 5:{if((f[a+76>>2]|0)!=4){d=f[a>>2]|0;f[d+20>>2]=11;ki[f[d>>2]&2047](a)}switch(f[c>>2]|0){case 4:{f[b>>2]=1005;f[b+4>>2]=143;return}case 5:{f[b+4>>2]=142;return}default:{d=f[a>>2]|0;f[d+20>>2]=28;ki[f[d>>2]&2047](a);return}}break}default:{if(!((g|0)==(f[c>>2]|0)?(f[a+76>>2]|0)==(f[a+36>>2]|0):0)){c=f[a>>2]|0;f[c+20>>2]=28;ki[f[c>>2]&2047](a)}f[b+4>>2]=142;return}}}function iHa(a){a=a|0;return}function jHa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=f[a+36>>2]|0;i=f[a+28>>2]|0;if((g|0)<1|(i|0)==0)return;else{j=g;k=c;l=e}while(1){e=j;j=j+-1|0;c=f[(f[d>>2]|0)+(l<<2)>>2]|0;g=0;a=f[k>>2]|0;while(1){b[c+g>>0]=b[a>>0]|0;g=g+1|0;if((g|0)==(i|0))break;else a=a+h|0}if((e|0)<=1)break;else{k=k+4|0;l=l+1|0}}return}function kHa(a){a=a|0;var b=0,c=0;b=f[a+412>>2]|0;c=ui[f[f[a+4>>2]>>2]&127](a,1,8192)|0;f[b+8>>2]=c;b=0;do{f[c+(b<<2)>>2]=b*19595;f[c+(b+256<<2)>>2]=b*38470;f[c+(b+512<<2)>>2]=(b*7471|0)+32768;a=Y(b,-11059)|0;f[c+(b+768<<2)>>2]=a;a=Y(b,-21709)|0;f[c+(b+1024<<2)>>2]=a;f[c+(b+1280<<2)>>2]=(b<<15)+8421375;a=Y(b,-27439)|0;f[c+(b+1536<<2)>>2]=a;a=Y(b,-5329)|0;f[c+(b+1792<<2)>>2]=a;b=b+1|0}while((b|0)!=256);return}function lHa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0;i=f[(f[a+412>>2]|0)+8>>2]|0;j=f[a+28>>2]|0;if((g|0)<1|(j|0)==0)return;else{k=g;l=c;m=e}while(1){e=k;k=k+-1|0;c=f[(f[d>>2]|0)+(m<<2)>>2]|0;g=0;a=f[l>>2]|0;while(1){b[c+g>>0]=((f[i+((h[a+1>>0]|0|256)<<2)>>2]|0)+(f[i+((h[a>>0]|0)<<2)>>2]|0)+(f[i+((h[a+2>>0]|0|512)<<2)>>2]|0)|0)>>>16;g=g+1|0;if((g|0)==(j|0))break;else a=a+3|0}if((e|0)<=1)break;else{l=l+4|0;m=m+1|0}}return}function mHa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=f[a+28>>2]|0;if((g|0)<=0)return;a=d+4|0;i=d+8|0;if(!h)return;else{j=g;k=c;l=e}while(1){e=j;j=j+-1|0;c=f[(f[d>>2]|0)+(l<<2)>>2]|0;g=f[(f[a>>2]|0)+(l<<2)>>2]|0;m=f[(f[i>>2]|0)+(l<<2)>>2]|0;n=0;o=f[k>>2]|0;while(1){b[c+n>>0]=b[o>>0]|0;b[g+n>>0]=b[o+1>>0]|0;b[m+n>>0]=b[o+2>>0]|0;n=n+1|0;if((n|0)==(h|0))break;else o=o+3|0}if((e|0)<=1)break;else{k=k+4|0;l=l+1|0}}return}function nHa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=f[a+28>>2]|0;if((g|0)<=0)return;a=d+4|0;j=d+8|0;if(!i)return;else{k=g;l=c;m=e}while(1){e=k;k=k+-1|0;c=f[(f[d>>2]|0)+(m<<2)>>2]|0;g=f[(f[a>>2]|0)+(m<<2)>>2]|0;n=f[(f[j>>2]|0)+(m<<2)>>2]|0;o=0;p=f[l>>2]|0;while(1){q=b[p+1>>0]|0;r=q&255;s=h[p+2>>0]|0;b[c+o>>0]=(h[p>>0]|0)+128-r;b[g+o>>0]=q;b[n+o>>0]=128-r+s;o=o+1|0;if((o|0)==(i|0))break;else p=p+3|0}if((e|0)<=1)break;else{l=l+4|0;m=m+1|0}}return}function oHa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;i=f[(f[a+412>>2]|0)+8>>2]|0;j=f[a+28>>2]|0;if((g|0)<=0)return;a=d+4|0;k=d+8|0;if(!j)return;else{l=g;m=c;n=e}while(1){e=l;l=l+-1|0;c=f[(f[d>>2]|0)+(n<<2)>>2]|0;g=f[(f[a>>2]|0)+(n<<2)>>2]|0;o=f[(f[k>>2]|0)+(n<<2)>>2]|0;p=0;q=f[m>>2]|0;while(1){r=h[q>>0]|0;s=h[q+1>>0]|0;t=h[q+2>>0]|0;b[c+p>>0]=((f[i+((s|256)<<2)>>2]|0)+(f[i+(r<<2)>>2]|0)+(f[i+((t|512)<<2)>>2]|0)|0)>>>16;b[g+p>>0]=((f[i+((s|1024)<<2)>>2]|0)+(f[i+((r|768)<<2)>>2]|0)+(f[i+((t|1280)<<2)>>2]|0)|0)>>>16;b[o+p>>0]=((f[i+((s|1536)<<2)>>2]|0)+(f[i+((r|1280)<<2)>>2]|0)+(f[i+((t|1792)<<2)>>2]|0)|0)>>>16;p=p+1|0;if((p|0)==(j|0))break;else q=q+3|0}if((e|0)<=1)break;else{m=m+4|0;n=n+1|0}}return}function pHa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=f[a+76>>2]|0;i=f[a+28>>2]|0;if((g|0)<=0)return;a=(i|0)==0;if((h|0)>0){j=g;k=c;l=e}else return;while(1){e=j;j=j+-1|0;if(!a){c=0;do{g=0;m=(f[k>>2]|0)+c|0;n=f[(f[d+(c<<2)>>2]|0)+(l<<2)>>2]|0;while(1){b[n>>0]=b[m>>0]|0;g=g+1|0;if((g|0)==(i|0))break;else{m=m+h|0;n=n+1|0}}c=c+1|0}while((c|0)!=(h|0))}if((e|0)<=1)break;else{k=k+4|0;l=l+1|0}}return}function qHa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=f[(f[a+412>>2]|0)+8>>2]|0;i=f[a+28>>2]|0;if((g|0)<=0)return;a=d+4|0;j=d+8|0;k=d+12|0;if(!i)return;else{l=g;m=c;n=e}while(1){e=l;l=l+-1|0;c=f[(f[d>>2]|0)+(n<<2)>>2]|0;g=f[(f[a>>2]|0)+(n<<2)>>2]|0;o=f[(f[j>>2]|0)+(n<<2)>>2]|0;p=f[(f[k>>2]|0)+(n<<2)>>2]|0;q=0;r=f[m>>2]|0;while(1){s=~b[r>>0]&255;t=~b[r+1>>0]&255;u=~b[r+2>>0]&255;b[p+q>>0]=b[r+3>>0]|0;b[c+q>>0]=((f[h+((t|256)<<2)>>2]|0)+(f[h+(s<<2)>>2]|0)+(f[h+((u|512)<<2)>>2]|0)|0)>>>16;b[g+q>>0]=((f[h+((t|1024)<<2)>>2]|0)+(f[h+((s|768)<<2)>>2]|0)+(f[h+((u|1280)<<2)>>2]|0)|0)>>>16;b[o+q>>0]=((f[h+((t|1536)<<2)>>2]|0)+(f[h+((s|1280)<<2)>>2]|0)+(f[h+((u|1792)<<2)>>2]|0)|0)>>>16;q=q+1|0;if((q|0)==(i|0))break;else r=r+4|0}if((e|0)<=1)break;else{m=m+4|0;n=n+1|0}}return}function rHa(a){a=a|0;var b=0;b=ui[f[f[a+4>>2]>>2]&127](a,1,156)|0;f[a+420>>2]=b;f[b>>2]=1006;f[b+84>>2]=0;f[b+140>>2]=0;f[b+88>>2]=0;f[b+144>>2]=0;f[b+92>>2]=0;f[b+148>>2]=0;f[b+96>>2]=0;f[b+152>>2]=0;return}function sHa(a){a=a|0;var b=0,c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0;b=f[a+420>>2]|0;c=a+76|0;if((f[c>>2]|0)<=0)return;e=a+4|0;g=a+4|0;h=a+4|0;i=a+232|0;k=0;l=f[a+84>>2]|0;m=0;while(1){o=f[l+36>>2]|0;q=l+40|0;a:do switch((o<<8)+(f[q>>2]|0)|0){case 257:{f[b+44+(k<<2)>>2]=201;r=0;break}case 514:{f[b+44+(k<<2)>>2]=202;r=0;break}case 771:{f[b+44+(k<<2)>>2]=203;r=0;break}case 1028:{f[b+44+(k<<2)>>2]=204;r=0;break}case 1285:{f[b+44+(k<<2)>>2]=205;r=0;break}case 1542:{f[b+44+(k<<2)>>2]=206;r=0;break}case 1799:{f[b+44+(k<<2)>>2]=207;r=0;break}case 2313:{f[b+44+(k<<2)>>2]=208;r=0;break}case 2570:{f[b+44+(k<<2)>>2]=209;r=0;break}case 2827:{f[b+44+(k<<2)>>2]=210;r=0;break}case 3084:{f[b+44+(k<<2)>>2]=211;r=0;break}case 3341:{f[b+44+(k<<2)>>2]=212;r=0;break}case 3598:{f[b+44+(k<<2)>>2]=213;r=0;break}case 3855:{f[b+44+(k<<2)>>2]=214;r=0;break}case 4112:{f[b+44+(k<<2)>>2]=215;r=0;break}case 4104:{f[b+44+(k<<2)>>2]=216;r=0;break}case 3591:{f[b+44+(k<<2)>>2]=217;r=0;break}case 3078:{f[b+44+(k<<2)>>2]=218;r=0;break}case 2565:{f[b+44+(k<<2)>>2]=219;r=0;break}case 2052:{f[b+44+(k<<2)>>2]=220;r=0;break}case 1539:{f[b+44+(k<<2)>>2]=221;r=0;break}case 1026:{f[b+44+(k<<2)>>2]=222;r=0;break}case 513:{f[b+44+(k<<2)>>2]=223;r=0;break}case 2064:{f[b+44+(k<<2)>>2]=224;r=0;break}case 1806:{f[b+44+(k<<2)>>2]=225;r=0;break}case 1548:{f[b+44+(k<<2)>>2]=226;r=0;break}case 1290:{f[b+44+(k<<2)>>2]=227;r=0;break}case 1032:{f[b+44+(k<<2)>>2]=228;r=0;break}case 774:{f[b+44+(k<<2)>>2]=229;r=0;break}case 516:{f[b+44+(k<<2)>>2]=230;r=0;break}case 258:{f[b+44+(k<<2)>>2]=231;r=0;break}case 2056:{switch(f[i>>2]|0){case 0:{f[b+44+(k<<2)>>2]=232;r=0;break a;break}case 1:{f[b+44+(k<<2)>>2]=233;r=1;break a;break}case 2:{f[b+100+(k<<2)>>2]=234;r=2;break a;break}default:{s=f[a>>2]|0;f[s+20>>2]=49;ki[f[s>>2]&2047](a);r=m;break a}}break}default:{s=f[a>>2]|0;f[s+20>>2]=7;f[s+24>>2]=o;f[s+28>>2]=f[q>>2];ki[f[s>>2]&2047](a);r=m}}while(0);q=f[l+16>>2]|0;if(!(q>>>0<=3?(f[a+88+(q<<2)>>2]|0)!=0:0)){o=f[a>>2]|0;f[o+20>>2]=54;f[o+24>>2]=q;ki[f[o>>2]&2047](a)}o=f[a+88+(q<<2)>>2]|0;switch(r|0){case 0:{s=b+84+(q<<2)|0;if(!(f[s>>2]|0)){t=ui[f[f[e>>2]>>2]&127](a,1,256)|0;f[s>>2]=t}t=f[s>>2]|0;s=0;do{f[t+(s<<2)>>2]=j[o+(s<<1)>>1]<<3;s=s+1|0}while((s|0)!=64);f[b+4+(k<<2)>>2]=105;break}case 1:{s=b+84+(q<<2)|0;if(!(f[s>>2]|0)){t=ui[f[f[g>>2]>>2]&127](a,1,256)|0;f[s>>2]=t}t=f[s>>2]|0;s=0;do{u=(Y(d[134434+(s<<1)>>1]|0,j[o+(s<<1)>>1]|0)|0)+1024>>11;f[t+(s<<2)>>2]=u;s=s+1|0}while((s|0)!=64);f[b+4+(k<<2)>>2]=105;break}case 2:{s=b+140+(q<<2)|0;if(!(f[s>>2]|0)){t=ui[f[f[h>>2]>>2]&127](a,1,256)|0;f[s>>2]=t}t=f[s>>2]|0;s=0;u=0;while(1){v=+p[19944+(u<<3)>>3];n[t+(s<<2)>>2]=1.0/(+(j[o+(s<<1)>>1]|0)*v*8.0);w=s|1;n[t+(w<<2)>>2]=1.0/(+(j[o+(w<<1)>>1]|0)*v*1.387039845*8.0);x=w+1|0;n[t+(x<<2)>>2]=1.0/(+(j[o+(x<<1)>>1]|0)*v*1.306562965*8.0);x=s|3;n[t+(x<<2)>>2]=1.0/(+(j[o+(x<<1)>>1]|0)*v*1.175875602*8.0);w=x+1|0;n[t+(w<<2)>>2]=1.0/(+(j[o+(w<<1)>>1]|0)*v*8.0);w=x+2|0;n[t+(w<<2)>>2]=1.0/(+(j[o+(w<<1)>>1]|0)*v*.785694958*8.0);w=x+3|0;n[t+(w<<2)>>2]=1.0/(+(j[o+(w<<1)>>1]|0)*v*.5411961*8.0);w=s|7;n[t+(w<<2)>>2]=1.0/(+(j[o+(w<<1)>>1]|0)*v*.275899379*8.0);u=u+1|0;if((u|0)==8)break;else s=s+8|0}f[b+4+(k<<2)>>2]=106;break}default:{s=f[a>>2]|0;f[s+20>>2]=49;ki[f[s>>2]&2047](a)}}k=k+1|0;if((k|0)>=(f[c>>2]|0))break;else{l=l+88|0;m=r}}return}function tHa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=u;u=u+256|0;k=j;l=f[a+420>>2]|0;a=f[l+44+(f[b+4>>2]<<2)>>2]|0;m=f[l+84+(f[b+16>>2]<<2)>>2]|0;l=c+(g<<2)|0;if(!i){u=j;return}g=b+36|0;b=0;c=h;while(1){fi[a&255](k,l,c);h=0;do{n=f[m+(h<<2)>>2]|0;o=f[k+(h<<2)>>2]|0;p=n>>1;if((o|0)>=0){q=o+p|0;if((q|0)<(n|0))r=0;else r=(q|0)/(n|0)|0}else{q=p-o|0;if((q|0)<(n|0))s=0;else s=(q|0)/(n|0)|0;r=0-s|0}d[e+(b<<7)+(h<<1)>>1]=r;h=h+1|0}while((h|0)!=64);b=b+1|0;if((b|0)==(i|0))break;else c=(f[g>>2]|0)+c|0}u=j;return}function uHa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+256|0;k=j;l=f[a+420>>2]|0;a=f[l+100+(f[b+4>>2]<<2)>>2]|0;m=f[l+140+(f[b+16>>2]<<2)>>2]|0;l=c+(g<<2)|0;if(!i){u=j;return}g=b+36|0;b=0;c=h;while(1){fi[a&255](k,l,c);h=0;do{d[e+(b<<7)+(h<<1)>>1]=~~(+n[k+(h<<2)>>2]*+n[m+(h<<2)>>2]+16384.5)+49152;h=h+1|0}while((h|0)!=64);b=b+1|0;if((b|0)==(i|0))break;else c=(f[g>>2]|0)+c|0}u=j;return}function vHa(a){a=a|0;var b=0;b=ui[f[f[a+4>>2]>>2]&127](a,1,140)|0;f[a+424>>2]=b;f[b>>2]=400;f[b+60>>2]=0;f[b+44>>2]=0;f[b+92>>2]=0;f[b+76>>2]=0;f[b+64>>2]=0;f[b+48>>2]=0;f[b+96>>2]=0;f[b+80>>2]=0;f[b+68>>2]=0;f[b+52>>2]=0;f[b+100>>2]=0;f[b+84>>2]=0;f[b+72>>2]=0;f[b+56>>2]=0;f[b+104>>2]=0;f[b+88>>2]=0;if(!(f[a+268>>2]|0))return;f[b+136>>2]=0;return}function wHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=f[a+424>>2]|0;d=(b|0)!=0;f[c+8>>2]=d?1008:1007;if(!(f[a+268>>2]|0))f[c+4>>2]=d?180:179;else{f[c+120>>2]=a;f[c+108>>2]=b;b=(f[a+364>>2]|0)==0;e=c+4|0;do if(f[a+372>>2]|0){if(b){f[e>>2]=177;break}f[e>>2]=178;g=c+136|0;if(!(f[g>>2]|0)){h=ui[f[f[a+4>>2]>>2]&127](a,1,1e3)|0;f[g>>2]=h}}else f[e>>2]=b?176:175;while(0);f[c+124>>2]=f[(f[a+296>>2]|0)+24>>2];f[c+128>>2]=0;f[c+132>>2]=0}b=a+292|0;if((f[b>>2]|0)<=0){i=c+12|0;f[i>>2]=0;j=c+16|0;f[j>>2]=0;k=a+236|0;l=f[k>>2]|0;m=c+36|0;f[m>>2]=l;n=c+40|0;f[n>>2]=0;return}e=a+364|0;h=a+372|0;g=a+4|0;o=a+368|0;if(d)p=0;else{d=0;do{q=f[a+296+(d<<2)>>2]|0;if((f[e>>2]|0)==0?(f[h>>2]|0)==0:0){r=f[q+20>>2]|0;FHa(a,1,r,c+44+(r<<2)|0);f[c+20+(d<<2)>>2]=0}if(f[o>>2]|0){r=f[q+24>>2]|0;FHa(a,0,r,c+60+(r<<2)|0)}d=d+1|0}while((d|0)<(f[b>>2]|0));i=c+12|0;f[i>>2]=0;j=c+16|0;f[j>>2]=0;k=a+236|0;l=f[k>>2]|0;m=c+36|0;f[m>>2]=l;n=c+40|0;f[n>>2]=0;return}do{d=f[a+296+(p<<2)>>2]|0;if((f[e>>2]|0)==0?(f[h>>2]|0)==0:0){r=f[d+20>>2]|0;if(r>>>0>3){q=f[a>>2]|0;f[q+20>>2]=52;f[q+24>>2]=r;ki[f[q>>2]&2047](a)}q=c+76+(r<<2)|0;r=f[q>>2]|0;if(!r){s=ui[f[f[g>>2]>>2]&127](a,1,1028)|0;f[q>>2]=s;t=s}else t=r;F1a(t|0,0,1028)|0;f[c+20+(p<<2)>>2]=0}if(f[o>>2]|0){r=f[d+24>>2]|0;if(r>>>0>3){d=f[a>>2]|0;f[d+20>>2]=52;f[d+24>>2]=r;ki[f[d>>2]&2047](a)}d=c+92+(r<<2)|0;r=f[d>>2]|0;if(!r){s=ui[f[f[g>>2]>>2]&127](a,1,1028)|0;f[d>>2]=s;u=s}else u=r;F1a(u|0,0,1028)|0}p=p+1|0}while((p|0)<(f[b>>2]|0));i=c+12|0;f[i>>2]=0;j=c+16|0;f[j>>2]=0;k=a+236|0;l=f[k>>2]|0;m=c+36|0;f[m>>2]=l;n=c+40|0;f[n>>2]=0;return}function xHa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=u;u=u+32|0;c=b+16|0;d=b;e=f[a+424>>2]|0;if(f[a+268>>2]|0)HHa(e);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;g=a+292|0;if((f[g>>2]|0)<=0){u=b;return}h=a+364|0;i=a+372|0;j=a+368|0;k=0;do{l=f[a+296+(k<<2)>>2]|0;if(((f[h>>2]|0)==0?(f[i>>2]|0)==0:0)?(m=f[l+20>>2]|0,n=c+(m<<2)|0,(f[n>>2]|0)==0):0){o=a+120+(m<<2)|0;p=f[o>>2]|0;if(!p){q=HEa(a)|0;f[o>>2]=q;r=q}else r=p;LHa(a,r,f[e+76+(m<<2)>>2]|0);f[n>>2]=1}if(f[j>>2]|0?(n=f[l+24>>2]|0,l=d+(n<<2)|0,(f[l>>2]|0)==0):0){m=a+136+(n<<2)|0;p=f[m>>2]|0;if(!p){q=HEa(a)|0;f[m>>2]=q;s=q}else s=p;LHa(a,s,f[e+92+(n<<2)>>2]|0);f[l>>2]=1}k=k+1|0}while((k|0)<(f[g>>2]|0));u=b;return}function yHa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=u;u=u+16|0;d=c;e=f[a+424>>2]|0;g=a+24|0;h=f[g>>2]|0;i=f[h>>2]|0;j=f[h+4>>2]|0;if(f[a+268>>2]|0){h=e+112|0;f[h>>2]=i;k=e+116|0;f[k>>2]=j;HHa(e);KHa(e);l=f[g>>2]|0;f[l>>2]=f[h>>2];f[l+4>>2]=f[k>>2];u=c;return}k=e+12|0;l=f[k>>2]|0;h=e+16|0;m=f[h>>2]|0;n=e+20|0;f[d>>2]=f[n>>2];f[d+4>>2]=f[n+4>>2];f[d+8>>2]=f[n+8>>2];f[d+12>>2]=f[n+12>>2];a:do if((m|0)>0){e=m+7|0;o=127<<17-m|l;p=i;q=j;while(1){r=o>>>16;s=r&255;t=p;v=t+1|0;b[t>>0]=r;r=q+-1|0;if(!r){t=f[g>>2]|0;if(!(mi[f[t+12>>2]&255](a)|0)){w=v;break}x=f[t>>2]|0;y=f[t+4>>2]|0}else{x=v;y=r}if((s|0)==255){s=x;r=s+1|0;b[s>>0]=0;s=y+-1|0;if(!s){v=f[g>>2]|0;if(!(mi[f[v+12>>2]&255](a)|0)){w=r;break}z=f[v>>2]|0;A=f[v+4>>2]|0}else{z=r;A=s}}else{z=x;A=y}e=e+-8|0;if((e|0)<=7){B=z;C=A;D=0;E=0;break a}else{o=o<<8;p=z;q=A}}q=f[a>>2]|0;f[q+20>>2]=25;ki[f[q>>2]&2047](a);B=w;C=0;D=l;E=m}else{B=i;C=j;D=0;E=0}while(0);j=f[g>>2]|0;f[j>>2]=B;f[j+4>>2]=C;f[k>>2]=D;f[h>>2]=E;f[n>>2]=f[d>>2];f[n+4>>2]=f[d+4>>2];f[n+8>>2]=f[d+8>>2];f[n+12>>2]=f[d+12>>2];u=c;return}function zHa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=f[a+424>>2]|0;g=f[a+376>>2]|0;h=a+24|0;i=f[h>>2]|0;j=e+112|0;f[j>>2]=f[i>>2];k=e+116|0;f[k>>2]=f[i+4>>2];i=a+236|0;if(f[i>>2]|0?(f[e+36>>2]|0)==0:0)GHa(e,f[e+40>>2]|0);l=a+320|0;if((f[l>>2]|0)>0){m=e+108|0;n=0;do{o=f[a+324+(n<<2)>>2]|0;p=f[a+296+(o<<2)>>2]|0;q=d[f[c+(n<<2)>>2]>>1]>>g;r=e+20+(o<<2)|0;o=q-(f[r>>2]|0)|0;f[r>>2]=q;q=(o>>31)+o|0;r=(o|0)<0?0-o|0:o;if(r){o=0;s=r;while(1){t=o+1|0;s=s>>1;if(!s)break;else o=t}if((o|0)>10){s=f[a>>2]|0;f[s+20>>2]=6;ki[f[s>>2]&2047](a);u=t}else u=t}else u=0;s=f[p+20>>2]|0;if(!(f[m>>2]|0)){r=f[e+44+(s<<2)>>2]|0;IHa(e,f[r+(u<<2)>>2]|0,b[r+1024+u>>0]|0)}else{r=(f[e+76+(s<<2)>>2]|0)+(u<<2)|0;f[r>>2]=(f[r>>2]|0)+1}if(u|0)IHa(e,q,u);n=n+1|0}while((n|0)<(f[l>>2]|0))}l=f[h>>2]|0;f[l>>2]=f[j>>2];f[l+4>>2]=f[k>>2];k=f[i>>2]|0;if(!k)return 1;i=e+36|0;l=f[i>>2]|0;if(!l){f[i>>2]=k;j=e+40|0;f[j>>2]=(f[j>>2]|0)+1&7;v=k}else v=l;f[i>>2]=v+-1;return 1}function AHa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=f[a+424>>2]|0;g=a+24|0;h=f[g>>2]|0;i=e+112|0;f[i>>2]=f[h>>2];j=e+116|0;f[j>>2]=f[h+4>>2];h=a+236|0;if(f[h>>2]|0?(f[e+36>>2]|0)==0:0)GHa(e,f[e+40>>2]|0);k=f[a+368>>2]|0;l=f[a+376>>2]|0;m=f[a+384>>2]|0;n=f[c>>2]|0;c=f[a+364>>2]|0;if((c|0)<=(k|0)){o=e+128|0;p=e+124|0;q=e+108|0;r=c;c=0;while(1){s=d[n+(f[m+(r<<2)>>2]<<1)>>1]|0;t=s<<16>>16;do if(!(s<<16>>16))u=c+1|0;else{if(s<<16>>16<0){v=0-t>>l;w=v;x=~v}else{v=t>>l;w=v;x=v}if(!w){u=c+1|0;break}if(f[o>>2]|0)HHa(e);if((c|0)>15){v=c;do{y=f[p>>2]|0;if(!(f[q>>2]|0)){z=f[e+60+(y<<2)>>2]|0;IHa(e,f[z+960>>2]|0,b[z+1264>>0]|0)}else{z=(f[e+92+(y<<2)>>2]|0)+960|0;f[z>>2]=(f[z>>2]|0)+1}v=v+-16|0}while((v|0)>15);A=c&15}else A=c;v=1;z=w;while(1){z=z>>1;if(!z)break;else v=v+1|0}if((v|0)>10){z=f[a>>2]|0;f[z+20>>2]=6;ki[f[z>>2]&2047](a)}z=f[p>>2]|0;y=v+(A<<4)|0;if(!(f[q>>2]|0)){B=f[e+60+(z<<2)>>2]|0;IHa(e,f[B+(y<<2)>>2]|0,b[B+1024+y>>0]|0)}else{B=(f[e+92+(z<<2)>>2]|0)+(y<<2)|0;f[B>>2]=(f[B>>2]|0)+1}IHa(e,x,v);u=0}while(0);if((r|0)<(k|0)){r=r+1|0;c=u}else break}if((u|0)>0?(u=e+128|0,c=(f[u>>2]|0)+1|0,f[u>>2]=c,(c|0)==32767):0)HHa(e)}c=f[g>>2]|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[j>>2];j=f[h>>2]|0;if(!j)return 1;h=e+36|0;c=f[h>>2]|0;if(!c){f[h>>2]=j;i=e+40|0;f[i>>2]=(f[i>>2]|0)+1&7;C=j}else C=c;f[h>>2]=C+-1;return 1}function BHa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=f[a+424>>2]|0;g=f[a+376>>2]|0;h=a+24|0;i=f[h>>2]|0;j=e+112|0;f[j>>2]=f[i>>2];k=e+116|0;f[k>>2]=f[i+4>>2];i=a+236|0;if(f[i>>2]|0?(f[e+36>>2]|0)==0:0)GHa(e,f[e+40>>2]|0);l=a+320|0;a=f[l>>2]|0;if((a|0)>0){m=e+16|0;n=e+108|0;o=e+12|0;p=e+120|0;q=a;a=0;while(1){if(!(f[n>>2]|0)){r=f[m>>2]|0;s=r+1|0;t=((d[f[c+(a<<2)>>2]>>1]|0)>>>g&1)<<23-r|f[o>>2];if((s|0)>7){r=s;u=t;do{v=u>>>16;w=v&255;x=f[j>>2]|0;f[j>>2]=x+1;b[x>>0]=v;v=(f[k>>2]|0)+-1|0;f[k>>2]=v;if(!v){v=f[p>>2]|0;x=f[v+24>>2]|0;if(!(mi[f[x+12>>2]&255](v)|0)){v=f[p>>2]|0;y=f[v>>2]|0;f[y+20>>2]=25;ki[f[y>>2]&2047](v)}f[j>>2]=f[x>>2];f[k>>2]=f[x+4>>2]}if((w|0)==255?(w=f[j>>2]|0,f[j>>2]=w+1,b[w>>0]=0,w=(f[k>>2]|0)+-1|0,f[k>>2]=w,(w|0)==0):0){w=f[p>>2]|0;x=f[w+24>>2]|0;if(!(mi[f[x+12>>2]&255](w)|0)){w=f[p>>2]|0;v=f[w>>2]|0;f[v+20>>2]=25;ki[f[v>>2]&2047](w)}f[j>>2]=f[x>>2];f[k>>2]=f[x+4>>2]}u=u<<8;r=r+-8|0}while((r|0)>7);z=f[l>>2]|0;A=s&7;B=u}else{z=q;A=s;B=t}f[o>>2]=B;f[m>>2]=A;C=z}else C=q;a=a+1|0;if((a|0)>=(C|0))break;else q=C}}C=f[h>>2]|0;f[C>>2]=f[j>>2];f[C+4>>2]=f[k>>2];k=f[i>>2]|0;if(!k)return 1;i=e+36|0;C=f[i>>2]|0;if(!C){f[i>>2]=k;j=e+40|0;f[j>>2]=(f[j>>2]|0)+1&7;D=k}else D=C;f[i>>2]=D+-1;return 1}function CHa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;e=u;u=u+256|0;g=e;h=f[a+424>>2]|0;i=a+24|0;k=f[i>>2]|0;l=h+112|0;f[l>>2]=f[k>>2];m=h+116|0;f[m>>2]=f[k+4>>2];k=a+236|0;if(f[k>>2]|0?(f[h+36>>2]|0)==0:0)GHa(h,f[h+40>>2]|0);n=f[a+368>>2]|0;o=f[a+376>>2]|0;p=f[a+384>>2]|0;q=f[c>>2]|0;c=f[a+364>>2]|0;a=(c|0)>(n|0);if(!a){r=0;s=c;while(1){t=d[q+(f[p+(s<<2)>>2]<<1)>>1]|0;v=t<<16>>16;w=(t<<16>>16<0?0-v|0:v)>>o;f[g+(s<<2)>>2]=w;r=(w|0)==1?s:r;if((s|0)>=(n|0))break;else s=s+1|0}s=h+136|0;o=h+132|0;if(a){x=o;y=0;z=0}else{a=h+124|0;w=h+108|0;v=h+16|0;t=h+12|0;A=h+120|0;B=0;C=(f[s>>2]|0)+(f[o>>2]|0)|0;D=c;c=0;while(1){E=f[g+(D<<2)>>2]|0;do if(!E){F=B;G=C;H=c+1|0}else{if((D|0)>(r|0)|(c|0)<16){I=B;J=C;K=c}else{L=B;M=C;N=c;while(1){HHa(h);O=f[a>>2]|0;a:do if(!(f[w>>2]|0)){P=f[h+60+(O<<2)>>2]|0;IHa(h,f[P+960>>2]|0,b[P+1264>>0]|0);P=N+-16|0;if((L|0)!=0&(f[w>>2]|0)==0){Q=0;R=M;S=L;while(1){if(!Q){T=f[v>>2]|0;U=T+1|0;V=(b[R>>0]&1)<<23-T|f[t>>2];if((U|0)>7){T=U;W=V;do{X=W>>>16;Y=X&255;Z=f[l>>2]|0;f[l>>2]=Z+1;b[Z>>0]=X;X=(f[m>>2]|0)+-1|0;f[m>>2]=X;if(!X){X=f[A>>2]|0;Z=f[X+24>>2]|0;if(!(mi[f[Z+12>>2]&255](X)|0)){X=f[A>>2]|0;_=f[X>>2]|0;f[_+20>>2]=25;ki[f[_>>2]&2047](X)}f[l>>2]=f[Z>>2];f[m>>2]=f[Z+4>>2]}do if((Y|0)==255){Z=f[l>>2]|0;f[l>>2]=Z+1;b[Z>>0]=0;Z=(f[m>>2]|0)+-1|0;f[m>>2]=Z;if(Z|0)break;Z=f[A>>2]|0;X=f[Z+24>>2]|0;if(!(mi[f[X+12>>2]&255](Z)|0)){Z=f[A>>2]|0;_=f[Z>>2]|0;f[_+20>>2]=25;ki[f[_>>2]&2047](Z)}f[l>>2]=f[X>>2];f[m>>2]=f[X+4>>2]}while(0);W=W<<8;T=T+-8|0}while((T|0)>7);$=U&7;aa=W}else{$=U;aa=V}f[t>>2]=aa;f[v>>2]=$}T=S+-1|0;if(!T){ba=P;break a}Q=f[w>>2]|0;R=R+1|0;S=T}}else ba=P}else{S=(f[h+92+(O<<2)>>2]|0)+960|0;f[S>>2]=(f[S>>2]|0)+1;ba=N+-16|0}while(0);O=f[s>>2]|0;if((ba|0)<16){I=0;J=O;K=ba;break}else{L=0;M=O;N=ba}}}if((E|0)>1){b[J+I>>0]=E&1;F=I+1|0;G=J;H=K;break}HHa(h);N=f[a>>2]|0;M=K<<4|1;b:do if(!(f[w>>2]|0)){L=f[h+60+(N<<2)>>2]|0;IHa(h,f[L+(M<<2)>>2]|0,b[L+1024+M>>0]|0);if(!(f[w>>2]|0)){L=f[v>>2]|0;O=L+1|0;S=(((j[q+(f[p+(D<<2)>>2]<<1)>>1]|0)>>>15^1)&65535)<<23-L|f[t>>2];if((O|0)>7){L=O;R=S;do{Q=R>>>16;T=Q&255;Y=f[l>>2]|0;f[l>>2]=Y+1;b[Y>>0]=Q;Q=(f[m>>2]|0)+-1|0;f[m>>2]=Q;if(!Q){Q=f[A>>2]|0;Y=f[Q+24>>2]|0;if(!(mi[f[Y+12>>2]&255](Q)|0)){Q=f[A>>2]|0;X=f[Q>>2]|0;f[X+20>>2]=25;ki[f[X>>2]&2047](Q)}f[l>>2]=f[Y>>2];f[m>>2]=f[Y+4>>2]}if((T|0)==255?(T=f[l>>2]|0,f[l>>2]=T+1,b[T>>0]=0,T=(f[m>>2]|0)+-1|0,f[m>>2]=T,(T|0)==0):0){T=f[A>>2]|0;Y=f[T+24>>2]|0;if(!(mi[f[Y+12>>2]&255](T)|0)){T=f[A>>2]|0;Q=f[T>>2]|0;f[Q+20>>2]=25;ki[f[Q>>2]&2047](T)}f[l>>2]=f[Y>>2];f[m>>2]=f[Y+4>>2]}R=R<<8;L=L+-8|0}while((L|0)>7);ca=f[w>>2]|0;da=O&7;ea=R}else{ca=0;da=O;ea=S}f[t>>2]=ea;f[v>>2]=da;if((I|0)!=0&(ca|0)==0){L=0;Y=J;T=I;while(1){if(!L){Q=f[v>>2]|0;X=Q+1|0;Z=(b[Y>>0]&1)<<23-Q|f[t>>2];if((X|0)>7){Q=X;_=Z;do{fa=_>>>16;ga=fa&255;ha=f[l>>2]|0;f[l>>2]=ha+1;b[ha>>0]=fa;fa=(f[m>>2]|0)+-1|0;f[m>>2]=fa;if(!fa){fa=f[A>>2]|0;ha=f[fa+24>>2]|0;if(!(mi[f[ha+12>>2]&255](fa)|0)){fa=f[A>>2]|0;ia=f[fa>>2]|0;f[ia+20>>2]=25;ki[f[ia>>2]&2047](fa)}f[l>>2]=f[ha>>2];f[m>>2]=f[ha+4>>2]}do if((ga|0)==255){ha=f[l>>2]|0;f[l>>2]=ha+1;b[ha>>0]=0;ha=(f[m>>2]|0)+-1|0;f[m>>2]=ha;if(ha|0)break;ha=f[A>>2]|0;fa=f[ha+24>>2]|0;if(!(mi[f[fa+12>>2]&255](ha)|0)){ha=f[A>>2]|0;ia=f[ha>>2]|0;f[ia+20>>2]=25;ki[f[ia>>2]&2047](ha)}f[l>>2]=f[fa>>2];f[m>>2]=f[fa+4>>2]}while(0);_=_<<8;Q=Q+-8|0}while((Q|0)>7);ja=X&7;ka=_}else{ja=X;ka=Z}f[t>>2]=ka;f[v>>2]=ja}Q=T+-1|0;if(!Q)break b;L=f[w>>2]|0;Y=Y+1|0;T=Q}}}}else{T=(f[h+92+(N<<2)>>2]|0)+(M<<2)|0;f[T>>2]=(f[T>>2]|0)+1}while(0);F=0;G=f[s>>2]|0;H=0}while(0);if((D|0)<(n|0)){B=F;C=G;D=D+1|0;c=H}else{x=o;y=F;z=H;break}}}}else{x=h+132|0;y=0;z=0}if((y|0)!=0|(z|0)>0?(z=h+128|0,H=(f[z>>2]|0)+1|0,f[z>>2]=H,z=(f[x>>2]|0)+y|0,f[x>>2]=z,(H|0)==32767|z>>>0>937):0)HHa(h);z=f[i>>2]|0;f[z>>2]=f[l>>2];f[z+4>>2]=f[m>>2];m=f[k>>2]|0;if(!m){u=e;return 1}k=h+36|0;z=f[k>>2]|0;if(!z){f[k>>2]=m;l=h+40|0;f[l>>2]=(f[l>>2]|0)+1&7;la=m}else la=z;f[k>>2]=la+-1;u=e;return 1}function DHa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=f[a+424>>2]|0;e=a+236|0;g=f[e>>2]|0;if(g|0){h=c+36|0;i=f[h>>2]|0;if(!i){j=a+292|0;if((f[j>>2]|0)>0){k=0;do{f[c+20+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[j>>2]|0));l=f[e>>2]|0}else l=g;f[h>>2]=l;m=l}else m=i;f[h>>2]=m+-1}m=a+320|0;if((f[m>>2]|0)<=0)return 1;h=a+388|0;i=a+384|0;l=0;do{g=f[a+324+(l<<2)>>2]|0;e=f[a+296+(g<<2)>>2]|0;j=b+(l<<2)|0;k=f[j>>2]|0;n=c+20+(g<<2)|0;g=f[c+76+(f[e+20>>2]<<2)>>2]|0;o=f[c+92+(f[e+24>>2]<<2)>>2]|0;e=f[h>>2]|0;p=f[i>>2]|0;q=(d[k>>1]|0)-(f[n>>2]|0)|0;r=(q|0)<0?0-q|0:q;if(r){q=0;s=r;while(1){t=q+1|0;s=s>>1;if(!s)break;else q=t}if((q|0)>10){s=f[a>>2]|0;f[s+20>>2]=6;ki[f[s>>2]&2047](a);u=t}else u=t}else u=0;s=g+(u<<2)|0;f[s>>2]=(f[s>>2]|0)+1;if((e|0)>=1){s=o+960|0;r=1;v=0;while(1){w=d[k+(f[p+(r<<2)>>2]<<1)>>1]|0;x=w<<16>>16;if(!(w<<16>>16))y=v+1|0;else{z=v+-16|0;A=z>>>4;if((v|0)>15){f[s>>2]=A+1+(f[s>>2]|0);B=z-(A<<4)|0}else B=v;A=1;z=w<<16>>16<0?0-x|0:x;while(1){z=z>>1;if(!z)break;else A=A+1|0}if((A|0)>10){z=f[a>>2]|0;f[z+20>>2]=6;ki[f[z>>2]&2047](a)}z=o+(A+(B<<4)<<2)|0;f[z>>2]=(f[z>>2]|0)+1;y=0}if((r|0)==(e|0))break;else{r=r+1|0;v=y}}if((y|0)>0)f[o>>2]=(f[o>>2]|0)+1}f[n>>2]=d[f[j>>2]>>1];l=l+1|0}while((l|0)<(f[m>>2]|0));return 1}function EHa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0;e=u;u=u+48|0;g=e;h=f[a+424>>2]|0;i=a+24|0;j=f[i>>2]|0;k=f[j>>2]|0;f[g>>2]=k;l=f[j+4>>2]|0;j=g+4|0;f[j>>2]=l;m=g+8|0;n=h+12|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];f[m+12>>2]=f[n+12>>2];f[m+16>>2]=f[n+16>>2];f[m+20>>2]=f[n+20>>2];o=g+32|0;f[o>>2]=a;p=a+236|0;q=k;if((f[p>>2]|0)!=0?(f[h+36>>2]|0)==0:0){k=f[h+40>>2]|0;r=g+12|0;s=f[r>>2]|0;t=g+8|0;do if((s|0)>0){v=q;w=s+7|0;x=f[t>>2]|127<<17-s;while(1){y=x>>>16;z=y&255;f[g>>2]=v+1;b[v>>0]=y;y=(f[j>>2]|0)+-1|0;f[j>>2]=y;if(!y){y=f[o>>2]|0;A=f[y+24>>2]|0;if(!(mi[f[A+12>>2]&255](y)|0)){B=0;C=115;break}f[g>>2]=f[A>>2];f[j>>2]=f[A+4>>2]}if((z|0)==255?(z=f[g>>2]|0,f[g>>2]=z+1,b[z>>0]=0,z=(f[j>>2]|0)+-1|0,f[j>>2]=z,(z|0)==0):0){z=f[o>>2]|0;A=f[z+24>>2]|0;if(!(mi[f[A+12>>2]&255](z)|0)){B=0;C=115;break}f[g>>2]=f[A>>2];f[j>>2]=f[A+4>>2]}A=w+-8|0;if((A|0)<=7){C=15;break}v=f[g>>2]|0;w=A;x=x<<8}if((C|0)==15){D=f[g>>2]|0;E=g;break}else if((C|0)==115){u=e;return B|0}}else{D=q;E=g}while(0);f[t>>2]=0;f[r>>2]=0;f[E>>2]=D+1;b[D>>0]=-1;D=(f[j>>2]|0)+-1|0;f[j>>2]=D;do if(!D){r=f[o>>2]|0;t=f[r+24>>2]|0;if(!(mi[f[t+12>>2]&255](r)|0)){B=0;u=e;return B|0}else{r=f[t>>2]|0;f[g>>2]=r;f[j>>2]=f[t+4>>2];F=r;break}}else F=f[E>>2]|0;while(0);f[E>>2]=F+1;b[F>>0]=k+208;k=(f[j>>2]|0)+-1|0;f[j>>2]=k;F=f[o>>2]|0;do if(!k){E=f[F+24>>2]|0;if(!(mi[f[E+12>>2]&255](F)|0)){B=0;u=e;return B|0}else{f[g>>2]=f[E>>2];D=f[E+4>>2]|0;f[j>>2]=D;G=D;break}}else G=k;while(0);if((f[F+292>>2]|0)>0){k=0;do{f[g+16+(k<<2)>>2]=0;k=k+1|0;D=f[o>>2]|0}while((k|0)<(f[D+292>>2]|0));H=G;I=D}else{H=G;I=F}}else{H=l;I=a}l=a+320|0;a:do if((f[l>>2]|0)>0){F=g+12|0;G=g+8|0;k=H;D=I;E=0;b:while(1){r=f[a+324+(E<<2)>>2]|0;t=f[a+296+(r<<2)>>2]|0;q=c+(E<<2)|0;s=f[q>>2]|0;x=g+16+(r<<2)|0;r=f[h+44+(f[t+20>>2]<<2)>>2]|0;w=f[h+60+(f[t+24>>2]<<2)>>2]|0;t=f[D+388>>2]|0;v=f[D+384>>2]|0;A=(d[s>>1]|0)-(f[x>>2]|0)|0;z=(A>>31)+A|0;y=(A|0)<0?0-A|0:A;if(y){A=0;J=y;while(1){K=A+1|0;J=J>>1;if(!J)break;else A=K}if((A|0)>10){J=f[D>>2]|0;f[J+20>>2]=6;ki[f[J>>2]&2047](D);L=K}else L=K}else L=0;J=f[r+(L<<2)>>2]|0;y=b[r+1024+L>>0]|0;M=y<<24>>24;N=f[F>>2]|0;if(!(y<<24>>24)){y=f[D>>2]|0;f[y+20>>2]=41;ki[f[y>>2]&2047](D)}y=N+M|0;N=f[G>>2]|((1<<M)+-1&J)<<24-y;if((y|0)>7){J=y;M=N;while(1){O=M>>>16;P=O&255;Q=f[g>>2]|0;f[g>>2]=Q+1;b[Q>>0]=O;O=(f[j>>2]|0)+-1|0;f[j>>2]=O;if(!O){Q=f[o>>2]|0;R=f[Q+24>>2]|0;if(!(mi[f[R+12>>2]&255](Q)|0)){B=0;C=115;break b}f[g>>2]=f[R>>2];Q=f[R+4>>2]|0;f[j>>2]=Q;S=Q}else S=O;if((P|0)==255){P=f[g>>2]|0;f[g>>2]=P+1;b[P>>0]=0;P=(f[j>>2]|0)+-1|0;f[j>>2]=P;if(!P){O=f[o>>2]|0;Q=f[O+24>>2]|0;if(!(mi[f[Q+12>>2]&255](O)|0)){B=0;C=115;break b}f[g>>2]=f[Q>>2];O=f[Q+4>>2]|0;f[j>>2]=O;T=O}else T=P}else T=S;P=M<<8;O=J+-8|0;if((O|0)>7){J=O;M=P}else{U=T;V=P;W=O;break}}}else{U=k;V=N;W=y}f[G>>2]=V;f[F>>2]=W;if(!L){X=U;Y=V;Z=W}else{M=W+L|0;J=((1<<L)+-1&z)<<24-M|V;if((M|0)>7){r=M;A=J;while(1){O=A>>>16;P=O&255;Q=f[g>>2]|0;f[g>>2]=Q+1;b[Q>>0]=O;O=(f[j>>2]|0)+-1|0;f[j>>2]=O;if(!O){Q=f[o>>2]|0;R=f[Q+24>>2]|0;if(!(mi[f[R+12>>2]&255](Q)|0)){B=0;C=115;break b}f[g>>2]=f[R>>2];Q=f[R+4>>2]|0;f[j>>2]=Q;_=Q}else _=O;if((P|0)==255){P=f[g>>2]|0;f[g>>2]=P+1;b[P>>0]=0;P=(f[j>>2]|0)+-1|0;f[j>>2]=P;if(!P){O=f[o>>2]|0;Q=f[O+24>>2]|0;if(!(mi[f[Q+12>>2]&255](O)|0)){B=0;C=115;break b}f[g>>2]=f[Q>>2];O=f[Q+4>>2]|0;f[j>>2]=O;$=O}else $=P}else $=_;P=A<<8;O=r+-8|0;if((O|0)>7){r=O;A=P}else{aa=$;ba=O;ca=P;break}}}else{aa=U;ba=M;ca=J}f[G>>2]=ca;f[F>>2]=ba;X=aa;Y=ca;Z=ba}if((t|0)>=1){A=w+960|0;r=w+1264|0;z=X;y=Y;N=Z;P=1;O=0;while(1){Q=d[s+(f[v+(P<<2)>>2]<<1)>>1]|0;R=Q<<16>>16;if(!(Q<<16>>16)){da=y;ea=N;fa=z;ga=O+1|0}else{if((O|0)>15){ha=y;ia=N;ja=z;ka=O;while(1){la=f[A>>2]|0;ma=b[r>>0]|0;na=ma<<24>>24;if(!(ma<<24>>24)){ma=f[o>>2]|0;oa=f[ma>>2]|0;f[oa+20>>2]=41;ki[f[oa>>2]&2047](ma)}ma=na+ia|0;oa=ha|((1<<na)+-1&la)<<24-ma;if((ma|0)>7){la=ma;na=oa;while(1){pa=na>>>16;qa=pa&255;ra=f[g>>2]|0;f[g>>2]=ra+1;b[ra>>0]=pa;pa=(f[j>>2]|0)+-1|0;f[j>>2]=pa;if(!pa){ra=f[o>>2]|0;sa=f[ra+24>>2]|0;if(!(mi[f[sa+12>>2]&255](ra)|0)){B=0;C=115;break b}f[g>>2]=f[sa>>2];ra=f[sa+4>>2]|0;f[j>>2]=ra;ta=ra}else ta=pa;do if((qa|0)==255){pa=f[g>>2]|0;f[g>>2]=pa+1;b[pa>>0]=0;pa=(f[j>>2]|0)+-1|0;f[j>>2]=pa;if(pa|0){ua=pa;break}pa=f[o>>2]|0;ra=f[pa+24>>2]|0;if(!(mi[f[ra+12>>2]&255](pa)|0)){B=0;C=115;break b}f[g>>2]=f[ra>>2];pa=f[ra+4>>2]|0;f[j>>2]=pa;ua=pa}else ua=ta;while(0);qa=na<<8;pa=la+-8|0;if((pa|0)>7){la=pa;na=qa}else{va=ua;wa=pa;xa=qa;break}}}else{va=ja;wa=ma;xa=oa}f[G>>2]=xa;f[F>>2]=wa;na=ka+-16|0;if((na|0)>15){ha=xa;ia=wa;ja=va;ka=na}else{ya=wa;za=xa;Aa=va;Ba=na;break}}}else{ya=N;za=y;Aa=z;Ba=O}ka=Q<<16>>16>>15;ja=1;ia=Q<<16>>16<0?0-R|0:R;while(1){ia=ia>>1;if(!ia)break;else ja=ja+1|0}ia=(ka<<16>>16)+R|0;if((ja|0)>10){Q=f[o>>2]|0;ha=f[Q>>2]|0;f[ha+20>>2]=6;ki[f[ha>>2]&2047](Q)}Q=ja+(Ba<<4)|0;ha=f[w+(Q<<2)>>2]|0;na=b[w+1024+Q>>0]|0;Q=na<<24>>24;if(!(na<<24>>24)){na=f[o>>2]|0;la=f[na>>2]|0;f[la+20>>2]=41;ki[f[la>>2]&2047](na)}na=Q+ya|0;la=za|((1<<Q)+-1&ha)<<24-na;if((na|0)>7){ha=na;Q=la;while(1){qa=Q>>>16;pa=qa&255;ra=f[g>>2]|0;f[g>>2]=ra+1;b[ra>>0]=qa;qa=(f[j>>2]|0)+-1|0;f[j>>2]=qa;if(!qa){ra=f[o>>2]|0;sa=f[ra+24>>2]|0;if(!(mi[f[sa+12>>2]&255](ra)|0)){B=0;C=115;break b}f[g>>2]=f[sa>>2];ra=f[sa+4>>2]|0;f[j>>2]=ra;Ca=ra}else Ca=qa;do if((pa|0)==255){qa=f[g>>2]|0;f[g>>2]=qa+1;b[qa>>0]=0;qa=(f[j>>2]|0)+-1|0;f[j>>2]=qa;if(qa|0){Da=qa;break}qa=f[o>>2]|0;ra=f[qa+24>>2]|0;if(!(mi[f[ra+12>>2]&255](qa)|0)){B=0;C=115;break b}f[g>>2]=f[ra>>2];qa=f[ra+4>>2]|0;f[j>>2]=qa;Da=qa}else Da=Ca;while(0);pa=Q<<8;oa=ha+-8|0;if((oa|0)>7){ha=oa;Q=pa}else{Ea=Da;Fa=oa;Ga=pa;break}}}else{Ea=Aa;Fa=na;Ga=la}f[G>>2]=Ga;f[F>>2]=Fa;Q=Fa+ja|0;ha=((1<<ja)+-1&ia)<<24-Q|Ga;if((Q|0)>7){R=Q;ka=ha;while(1){pa=ka>>>16;oa=pa&255;ma=f[g>>2]|0;f[g>>2]=ma+1;b[ma>>0]=pa;pa=(f[j>>2]|0)+-1|0;f[j>>2]=pa;if(!pa){ma=f[o>>2]|0;qa=f[ma+24>>2]|0;if(!(mi[f[qa+12>>2]&255](ma)|0)){B=0;C=115;break b}f[g>>2]=f[qa>>2];ma=f[qa+4>>2]|0;f[j>>2]=ma;Ha=ma}else Ha=pa;do if((oa|0)==255){pa=f[g>>2]|0;f[g>>2]=pa+1;b[pa>>0]=0;pa=(f[j>>2]|0)+-1|0;f[j>>2]=pa;if(pa|0){Ia=pa;break}pa=f[o>>2]|0;ma=f[pa+24>>2]|0;if(!(mi[f[ma+12>>2]&255](pa)|0)){B=0;C=115;break b}f[g>>2]=f[ma>>2];pa=f[ma+4>>2]|0;f[j>>2]=pa;Ia=pa}else Ia=Ha;while(0);oa=ka<<8;pa=R+-8|0;if((pa|0)>7){R=pa;ka=oa}else{Ja=Ia;Ka=pa;La=oa;break}}}else{Ja=Ea;Ka=Q;La=ha}f[G>>2]=La;f[F>>2]=Ka;da=La;ea=Ka;fa=Ja;ga=0}if((P|0)<(t|0)){z=fa;y=da;N=ea;P=P+1|0;O=ga}else break}if((ga|0)>0){O=f[w>>2]|0;P=b[w+1024>>0]|0;N=P<<24>>24;if(!(P<<24>>24)){P=f[o>>2]|0;y=f[P>>2]|0;f[y+20>>2]=41;ki[f[y>>2]&2047](P)}P=N+ea|0;y=da|((1<<N)+-1&O)<<24-P;if((P|0)>7){O=P;N=y;while(1){z=N>>>16;t=z&255;r=f[g>>2]|0;f[g>>2]=r+1;b[r>>0]=z;z=(f[j>>2]|0)+-1|0;f[j>>2]=z;if(!z){r=f[o>>2]|0;A=f[r+24>>2]|0;if(!(mi[f[A+12>>2]&255](r)|0)){B=0;C=115;break b}f[g>>2]=f[A>>2];r=f[A+4>>2]|0;f[j>>2]=r;Ma=r}else Ma=z;if((t|0)==255){t=f[g>>2]|0;f[g>>2]=t+1;b[t>>0]=0;t=(f[j>>2]|0)+-1|0;f[j>>2]=t;if(!t){z=f[o>>2]|0;r=f[z+24>>2]|0;if(!(mi[f[r+12>>2]&255](z)|0)){B=0;C=115;break b}f[g>>2]=f[r>>2];z=f[r+4>>2]|0;f[j>>2]=z;Na=z}else Na=t}else Na=Ma;t=N<<8;z=O+-8|0;if((z|0)>7){O=z;N=t}else{Oa=Na;Pa=z;Qa=t;break}}}else{Oa=fa;Pa=P;Qa=y}f[G>>2]=Qa;f[F>>2]=Pa;Ra=Oa}else Ra=fa}else Ra=X;f[x>>2]=d[f[q>>2]>>1];N=E+1|0;if((N|0)>=(f[l>>2]|0)){Sa=Ra;break a}k=Ra;D=f[o>>2]|0;E=N}if((C|0)==115){u=e;return B|0}}else Sa=H;while(0);H=f[i>>2]|0;f[H>>2]=f[g>>2];f[H+4>>2]=Sa;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2];f[n+8>>2]=f[m+8>>2];f[n+12>>2]=f[m+12>>2];f[n+16>>2]=f[m+16>>2];f[n+20>>2]=f[m+20>>2];m=f[p>>2]|0;if(!m){B=1;u=e;return B|0}p=h+36|0;n=f[p>>2]|0;if(!n){f[p>>2]=m;Sa=h+40|0;f[Sa>>2]=(f[Sa>>2]|0)+1&7;Ta=m}else Ta=n;f[p>>2]=Ta+-1;B=1;u=e;return B|0}function FHa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;g=u;u=u+1296|0;i=g+1028|0;j=g;if(d>>>0>3){k=f[a>>2]|0;f[k+20>>2]=52;f[k+24>>2]=d;ki[f[k>>2]&2047](a)}k=(c|0)!=0;c=f[(k?a+120+(d<<2)|0:a+136+(d<<2)|0)>>2]|0;if(!c){l=f[a>>2]|0;f[l+20>>2]=52;f[l+24>>2]=d;ki[f[l>>2]&2047](a)}l=f[e>>2]|0;if(!l){d=ui[f[f[a+4>>2]>>2]&127](a,1,1280)|0;f[e>>2]=d;m=a;n=d}else{m=a;n=l}l=1;d=0;while(1){e=b[c+l>>0]|0;o=e&255;p=o+d|0;if((p|0)>256){q=f[a>>2]|0;f[q+20>>2]=9;ki[f[q>>2]&2047](m)}if(!(e<<24>>24))r=d;else{F1a(i+d|0,l&255|0,o|0)|0;r=p}l=l+1|0;if((l|0)==17)break;else d=r}b[i+r>>0]=0;d=b[i>>0]|0;if(d<<24>>24){l=d;p=0;o=0;e=d<<24>>24;while(1){if((l<<24>>24|0)==(e|0)){d=p;q=o;while(1){s=q+1|0;f[j+(q<<2)>>2]=d;t=d+1|0;v=b[i+s>>0]|0;if((v<<24>>24|0)==(e|0)){d=t;q=s}else{w=v;x=t;y=s;break}}}else{w=l;x=p;y=o}if((x|0)>=(1<<e|0)){q=f[a>>2]|0;f[q+20>>2]=9;ki[f[q>>2]&2047](m)}if(!(w<<24>>24))break;else{l=w;p=x<<1;o=y;e=e+1|0}}}F1a(n+1024|0,0,256)|0;e=k?15:255;if((r|0)>0)z=0;else{u=g;return}do{k=h[c+17+z>>0]|0;y=n+1024+k|0;if(!(k>>>0<=e>>>0?!(b[y>>0]|0):0)){o=f[a>>2]|0;f[o+20>>2]=9;ki[f[o>>2]&2047](m)}f[n+(k<<2)>>2]=f[j+(z<<2)>>2];b[y>>0]=b[i+z>>0]|0;z=z+1|0}while((z|0)!=(r|0));u=g;return}function GHa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;HHa(a);if(!(f[a+108>>2]|0)){KHa(a);d=a+112|0;e=f[d>>2]|0;f[d>>2]=e+1;b[e>>0]=-1;e=a+116|0;g=(f[e>>2]|0)+-1|0;f[e>>2]=g;if(!g){g=a+120|0;h=f[g>>2]|0;i=f[h+24>>2]|0;if(!(mi[f[i+12>>2]&255](h)|0)){h=f[g>>2]|0;g=f[h>>2]|0;f[g+20>>2]=25;ki[f[g>>2]&2047](h)}h=f[i>>2]|0;f[d>>2]=h;f[e>>2]=f[i+4>>2];j=h}else j=f[d>>2]|0;f[d>>2]=j+1;b[j>>0]=c+208;c=(f[e>>2]|0)+-1|0;f[e>>2]=c;if(!c){c=a+120|0;j=f[c>>2]|0;h=f[j+24>>2]|0;if(!(mi[f[h+12>>2]&255](j)|0)){j=f[c>>2]|0;c=f[j>>2]|0;f[c+20>>2]=25;ki[f[c>>2]&2047](j)}f[d>>2]=f[h>>2];f[e>>2]=f[h+4>>2]}}h=a+120|0;e=f[h>>2]|0;if(f[e+364>>2]|0){f[a+128>>2]=0;f[a+132>>2]=0;return}if((f[e+292>>2]|0)>0)k=0;else return;do{f[a+20+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[(f[h>>2]|0)+292>>2]|0));return}function HHa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=a+128|0;d=f[c>>2]|0;if(!d)return;else{e=0;g=d}while(1){g=g>>1;if(!g)break;else e=e+1|0}if((e|0)>14){g=f[a+120>>2]|0;d=f[g>>2]|0;f[d+20>>2]=41;ki[f[d>>2]&2047](g)}g=f[a+124>>2]|0;d=e<<4;h=a+108|0;if(!(f[h>>2]|0)){i=f[a+60+(g<<2)>>2]|0;IHa(a,f[i+(d<<2)>>2]|0,b[i+1024+d>>0]|0)}else{i=(f[a+92+(g<<2)>>2]|0)+(d<<2)|0;f[i>>2]=(f[i>>2]|0)+1}if(e|0)IHa(a,f[c>>2]|0,e);f[c>>2]=0;c=a+132|0;e=f[c>>2]|0;a:do if((e|0)!=0&(f[h>>2]|0)==0){i=a+16|0;d=a+12|0;g=a+112|0;j=a+116|0;k=a+120|0;l=0;m=f[a+136>>2]|0;n=e;while(1){if(!l){o=f[i>>2]|0;p=o+1|0;q=(b[m>>0]&1)<<23-o|f[d>>2];if((p|0)>7){o=p;r=q;do{s=r>>>16;t=s&255;u=f[g>>2]|0;f[g>>2]=u+1;b[u>>0]=s;s=(f[j>>2]|0)+-1|0;f[j>>2]=s;if(!s){s=f[k>>2]|0;u=f[s+24>>2]|0;if(!(mi[f[u+12>>2]&255](s)|0)){s=f[k>>2]|0;v=f[s>>2]|0;f[v+20>>2]=25;ki[f[v>>2]&2047](s)}f[g>>2]=f[u>>2];f[j>>2]=f[u+4>>2]}if((t|0)==255?(t=f[g>>2]|0,f[g>>2]=t+1,b[t>>0]=0,t=(f[j>>2]|0)+-1|0,f[j>>2]=t,(t|0)==0):0){t=f[k>>2]|0;u=f[t+24>>2]|0;if(!(mi[f[u+12>>2]&255](t)|0)){t=f[k>>2]|0;s=f[t>>2]|0;f[s+20>>2]=25;ki[f[s>>2]&2047](t)}f[g>>2]=f[u>>2];f[j>>2]=f[u+4>>2]}r=r<<8;o=o+-8|0}while((o|0)>7);w=p&7;x=r}else{w=p;x=q}f[d>>2]=x;f[i>>2]=w}o=n+-1|0;if(!o)break a;l=f[h>>2]|0;m=m+1|0;n=o}}while(0);f[c>>2]=0;return}function IHa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=a+16|0;g=f[e>>2]|0;if(!d){h=f[a+120>>2]|0;i=f[h>>2]|0;f[i+20>>2]=41;ki[f[i>>2]&2047](h)}if(f[a+108>>2]|0)return;h=g+d|0;i=a+12|0;j=f[i>>2]|((1<<d)+-1&c)<<24-h;if((h|0)>7){c=a+112|0;k=a+116|0;l=a+120|0;m=g+d|0;d=h;g=j;do{n=g>>>16;o=n&255;p=f[c>>2]|0;f[c>>2]=p+1;b[p>>0]=n;n=(f[k>>2]|0)+-1|0;f[k>>2]=n;if(!n){n=f[l>>2]|0;p=f[n+24>>2]|0;if(!(mi[f[p+12>>2]&255](n)|0)){n=f[l>>2]|0;q=f[n>>2]|0;f[q+20>>2]=25;ki[f[q>>2]&2047](n)}f[c>>2]=f[p>>2];f[k>>2]=f[p+4>>2]}if((o|0)==255?(o=f[c>>2]|0,f[c>>2]=o+1,b[o>>0]=0,o=(f[k>>2]|0)+-1|0,f[k>>2]=o,(o|0)==0):0)JHa(a);g=g<<8;d=d+-8|0}while((d|0)>7);r=m&7;s=g}else{r=h;s=j}f[i>>2]=s;f[e>>2]=r;return}function JHa(a){a=a|0;var b=0,c=0,d=0;b=a+120|0;c=f[b>>2]|0;d=f[c+24>>2]|0;if(!(mi[f[d+12>>2]&255](c)|0)){c=f[b>>2]|0;b=f[c>>2]|0;f[b+20>>2]=25;ki[f[b>>2]&2047](c)}f[a+112>>2]=f[d>>2];f[a+116>>2]=f[d+4>>2];return}function KHa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+16|0;if(f[a+108>>2]|0){d=a+12|0;f[d>>2]=0;f[c>>2]=0;return}e=f[c>>2]|0;g=e+7|0;h=a+12|0;i=127<<17-e|f[h>>2];if((g|0)>7){e=a+112|0;j=a+116|0;k=a+120|0;a=g;l=i;do{m=l>>>16;n=m&255;o=f[e>>2]|0;f[e>>2]=o+1;b[o>>0]=m;m=(f[j>>2]|0)+-1|0;f[j>>2]=m;if(!m){m=f[k>>2]|0;o=f[m+24>>2]|0;if(!(mi[f[o+12>>2]&255](m)|0)){m=f[k>>2]|0;p=f[m>>2]|0;f[p+20>>2]=25;ki[f[p>>2]&2047](m)}f[e>>2]=f[o>>2];f[j>>2]=f[o+4>>2]}if((n|0)==255?(n=f[e>>2]|0,f[e>>2]=n+1,b[n>>0]=0,n=(f[j>>2]|0)+-1|0,f[j>>2]=n,(n|0)==0):0){n=f[k>>2]|0;o=f[n+24>>2]|0;if(!(mi[f[o+12>>2]&255](n)|0)){n=f[k>>2]|0;m=f[n>>2]|0;f[m+20>>2]=25;ki[f[m>>2]&2047](n)}f[e>>2]=f[o>>2];f[j>>2]=f[o+4>>2]}l=l<<8;a=a+-8|0}while((a|0)>7);q=g&7;r=l}else{q=g;r=i}f[h>>2]=r;f[c>>2]=q;d=h;f[d>>2]=0;f[c>>2]=0;return}function LHa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+2096|0;g=e+2056|0;i=e+1028|0;j=e;k=g;l=k+33|0;do{b[k>>0]=0;k=k+1|0}while((k|0)<(l|0));F1a(i|0,0,1028)|0;F1a(j|0,-1,1028)|0;f[d+1024>>2]=1;a:while(1){m=-1;n=0;o=1e9;while(1){p=f[d+(n<<2)>>2]|0;q=(p|0)==0|(p|0)>(o|0);m=q?m:n;n=n+1|0;if((n|0)==257){r=-1;s=0;t=1e9;break}else o=q?o:p}while(1){o=f[d+(s<<2)>>2]|0;n=(s|0)==(m|0)|((o|0)==0|(o|0)>(t|0));r=n?r:s;s=s+1|0;if((s|0)==257)break;else t=n?t:o}if((r|0)<0)break;o=d+(r<<2)|0;n=d+(m<<2)|0;f[n>>2]=(f[n>>2]|0)+(f[o>>2]|0);f[o>>2]=0;o=m;do{n=i+(o<<2)|0;f[n>>2]=(f[n>>2]|0)+1;v=j+(o<<2)|0;o=f[v>>2]|0}while((o|0)>-1);f[v>>2]=r;o=r;while(1){m=i+(o<<2)|0;f[m>>2]=(f[m>>2]|0)+1;m=f[j+(o<<2)>>2]|0;if((m|0)>-1)o=m;else continue a}}j=0;do{r=f[i+(j<<2)>>2]|0;if(r|0){if((r|0)>32){v=f[a>>2]|0;f[v+20>>2]=40;ki[f[v>>2]&2047](a)}v=g+r|0;b[v>>0]=(b[v>>0]|0)+1<<24>>24}j=j+1|0}while((j|0)!=257);w=32;while(1){j=g+w|0;a=b[j>>0]|0;if(!(a<<24>>24))x=w+-1|0;else{v=w+-2|0;r=w+-1|0;d=g+r|0;t=a&255;while(1){a=v;while(1){y=g+a|0;if(!(b[y>>0]|0))a=a+-1|0;else break}b[j>>0]=t+254;b[d>>0]=(b[d>>0]|0)+1<<24>>24;s=g+(a+1)|0;b[s>>0]=(h[s>>0]|0)+2;b[y>>0]=(b[y>>0]|0)+-1<<24>>24;s=b[j>>0]|0;if(!(s<<24>>24)){x=r;break}else t=s&255}}if((x|0)>16)w=x;else{z=16;break}}while(1){A=g+z|0;B=b[A>>0]|0;if(!(B<<24>>24))z=z+-1|0;else break}b[A>>0]=B+-1<<24>>24;k=c;B=g;l=k+17|0;do{b[k>>0]=b[B>>0]|0;k=k+1|0;B=B+1|0}while((k|0)<(l|0));B=1;k=0;while(1){l=0;g=k;while(1){if((f[i+(l<<2)>>2]|0)==(B|0)){b[c+17+g>>0]=l;C=g+1|0}else C=g;l=l+1|0;if((l|0)==256)break;else g=C}B=B+1|0;if((B|0)==33)break;else k=C}f[c+276>>2]=0;u=e;return}function MHa(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=ui[f[f[c>>2]>>2]&127](a,1,188)|0;f[a+468>>2]=d;f[d>>2]=1009;f[d+56>>2]=0;f[d+120>>2]=0;f[d+60>>2]=0;f[d+124>>2]=0;f[d+64>>2]=0;f[d+128>>2]=0;f[d+68>>2]=0;f[d+132>>2]=0;f[d+72>>2]=0;f[d+136>>2]=0;f[d+76>>2]=0;f[d+140>>2]=0;f[d+80>>2]=0;f[d+144>>2]=0;f[d+84>>2]=0;f[d+148>>2]=0;f[d+88>>2]=0;f[d+152>>2]=0;f[d+92>>2]=0;f[d+156>>2]=0;f[d+96>>2]=0;f[d+160>>2]=0;f[d+100>>2]=0;f[d+164>>2]=0;f[d+104>>2]=0;f[d+168>>2]=0;f[d+108>>2]=0;f[d+172>>2]=0;f[d+112>>2]=0;f[d+176>>2]=0;f[d+116>>2]=0;f[d+180>>2]=0;b[d+184>>0]=113;if(!(f[a+224>>2]|0))return;d=a+36|0;e=ui[f[f[c>>2]>>2]&127](a,1,f[d>>2]<<8)|0;f[a+160>>2]=e;if((f[d>>2]|0)>0)g=0;else return;do{F1a(e+(g<<8)|0,-1,256)|0;g=g+1|0}while((g|0)<(f[d>>2]|0));return}function NHa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;c=f[a+468>>2]|0;d=a+224|0;e=a+412|0;g=f[e>>2]|0;h=(g|0)==0;do if(f[d>>2]|0){i=a+416|0;j=f[i>>2]|0;if(h)if(!j)k=7;else k=8;else if(((j|0)>=(g|0)?(j|0)<=(f[a+436>>2]|0):0)?(f[a+340>>2]|0)==1:0)k=7;else k=8;if((k|0)==7?(j=f[a+420>>2]|0,l=f[a+424>>2]|0,(l|0)>13|(j|0)!=0&(j+-1|0)!=(l|0)):0)k=8;if((k|0)==8){l=f[a>>2]|0;f[l+20>>2]=17;f[l+24>>2]=g;f[l+28>>2]=f[i>>2];f[l+32>>2]=f[a+420>>2];f[l+36>>2]=f[a+424>>2];ki[f[l>>2]&2047](a)}l=a+340|0;j=f[l>>2]|0;if((j|0)>0){m=a+160|0;n=a+420|0;o=a+424|0;p=0;do{q=f[(f[a+344+(p<<2)>>2]|0)+4>>2]|0;r=f[m>>2]|0;s=f[e>>2]|0;if(s)if((f[r+(q<<8)>>2]|0)<0){t=f[a>>2]|0;f[t+20>>2]=118;f[t+24>>2]=q;f[t+28>>2]=0;Gh[f[t+4>>2]&511](a,-1);u=f[e>>2]|0}else u=s;else u=0;if((u|0)<=(f[i>>2]|0)){s=u;while(1){t=r+(q<<8)+(s<<2)|0;v=f[t>>2]|0;if((f[n>>2]|0)!=(((v|0)>0?v:0)|0)){v=f[a>>2]|0;f[v+20>>2]=118;f[v+24>>2]=q;f[v+28>>2]=s;Gh[f[v+4>>2]&511](a,-1)}f[t>>2]=f[o>>2];if((s|0)<(f[i>>2]|0))s=s+1|0;else break}}p=p+1|0;s=f[l>>2]|0}while((p|0)<(s|0));w=s;x=n}else{w=j;x=a+420|0}n=(f[e>>2]|0)==0;p=c+4|0;if(!(f[x>>2]|0)){f[p>>2]=n?182:181;y=w;z=l;break}else{f[p>>2]=n?184:183;y=w;z=l;break}}else{if((h?(f[a+420>>2]|0)==0:0)?(f[a+424>>2]|0)==0:0){n=f[a+416>>2]|0;if((n|0)<64?(n|0)!=(f[a+436>>2]|0):0)k=28}else k=28;if((k|0)==28){n=f[a>>2]|0;f[n+20>>2]=125;Gh[f[n+4>>2]&511](a,-1)}f[c+4>>2]=185;n=a+340|0;y=f[n>>2]|0;z=n}while(0);if((y|0)<=0){A=c+8|0;f[A>>2]=0;B=c+12|0;f[B>>2]=0;C=c+16|0;f[C>>2]=-16;D=a+280|0;E=f[D>>2]|0;F=c+52|0;f[F>>2]=E;return}y=a+4|0;h=a+436|0;w=a+420|0;x=0;do{u=f[a+344+(x<<2)>>2]|0;if(f[d>>2]|0)if(!(f[e>>2]|0))if(!(f[w>>2]|0))k=35;else k=41;else k=42;else k=35;if((k|0)==35){k=0;g=f[u+20>>2]|0;if(g>>>0>15){n=f[a>>2]|0;f[n+20>>2]=50;f[n+24>>2]=g;ki[f[n>>2]&2047](a)}n=c+56+(g<<2)|0;g=f[n>>2]|0;if(!g){p=ui[f[f[y>>2]>>2]&127](a,1,64)|0;f[n>>2]=p;G=p}else G=g;g=G;p=g+64|0;do{b[g>>0]=0;g=g+1|0}while((g|0)<(p|0));f[c+20+(x<<2)>>2]=0;f[c+36+(x<<2)>>2]=0;if(!(f[d>>2]|0)){if(f[h>>2]|0)k=42}else k=41}if((k|0)==41?(k=0,f[e>>2]|0):0)k=42;if((k|0)==42){k=0;g=f[u+24>>2]|0;if(g>>>0>15){p=f[a>>2]|0;f[p+20>>2]=50;f[p+24>>2]=g;ki[f[p>>2]&2047](a)}p=c+120+(g<<2)|0;g=f[p>>2]|0;if(!g){l=ui[f[f[y>>2]>>2]&127](a,1,256)|0;f[p>>2]=l;H=l}else H=g;F1a(H|0,0,256)|0}x=x+1|0}while((x|0)<(f[z>>2]|0));A=c+8|0;f[A>>2]=0;B=c+12|0;f[B>>2]=0;C=c+16|0;f[C>>2]=-16;D=a+280|0;E=f[D>>2]|0;F=c+52|0;f[F>>2]=E;return}function OHa(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=f[a+468>>2]|0;g=a+280|0;if(f[g>>2]|0){i=e+52|0;j=f[i>>2]|0;if(!j){if(!(mi[f[(f[a+464>>2]|0)+8>>2]&255](a)|0)){k=f[a>>2]|0;f[k+20>>2]=25;ki[f[k>>2]&2047](a)}k=a+340|0;if((f[k>>2]|0)>0){l=a+224|0;m=a+436|0;n=a+412|0;o=a+420|0;p=0;do{q=f[a+344+(p<<2)>>2]|0;if(f[l>>2]|0)if(!(f[n>>2]|0)){if(!(f[o>>2]|0))r=10}else r=13;else r=10;do if((r|0)==10){r=0;s=f[e+56+(f[q+20>>2]<<2)>>2]|0;t=s+64|0;do{b[s>>0]=0;s=s+1|0}while((s|0)<(t|0));f[e+20+(p<<2)>>2]=0;f[e+36+(p<<2)>>2]=0;if(!(f[l>>2]|0))if(!(f[m>>2]|0))break;else{r=13;break}else if(!(f[n>>2]|0))break;else{r=13;break}}while(0);if((r|0)==13){r=0;F1a(f[e+120+(f[q+24>>2]<<2)>>2]|0,0,256)|0}p=p+1|0}while((p|0)<(f[k>>2]|0))}f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=-16;k=f[g>>2]|0;f[i>>2]=k;u=k}else u=j;f[i>>2]=u+-1}u=e+16|0;if((f[u>>2]|0)==-1)return 1;i=a+368|0;if((f[i>>2]|0)<=0)return 1;j=a+424|0;k=0;a:while(1){g=f[c+(k<<2)>>2]|0;p=f[a+372+(k<<2)>>2]|0;n=f[(f[a+344+(p<<2)>>2]|0)+20>>2]|0;m=e+56+(n<<2)|0;l=e+36+(p<<2)|0;o=(f[m>>2]|0)+(f[l>>2]|0)|0;if(!(THa(a,o)|0)){f[l>>2]=0;v=f[e+20+(p<<2)>>2]|0}else{s=THa(a,o+1|0)|0;t=o+2+s|0;o=THa(a,t)|0;if(o){w=(f[m>>2]|0)+20|0;if(!(THa(a,w)|0)){x=o;y=w}else{m=o;o=w;while(1){w=m<<1;if((w|0)==32768)break a;z=o+1|0;if(!(THa(a,z)|0)){x=w;y=z;break}else{m=w;o=z}}}}else{x=0;y=t}if((x|0)<(1<<(h[a+232+n>>0]|0)>>1|0))A=0;else A=((x|0)>(1<<(h[a+248+n>>0]|0)>>1|0)?12:4)+(s<<2)|0;f[l>>2]=A;o=y+14|0;m=x>>1;if(!m)B=x;else{q=m;m=x;while(1){z=(THa(a,o)|0)==0;w=(z?0:q)|m;q=q>>1;if(!q){B=w;break}else m=w}}m=e+20+(p<<2)|0;q=(f[m>>2]|0)+((s|0)==0?B+1|0:~B)|0;f[m>>2]=q;v=q}d[g>>1]=v<<f[j>>2];k=k+1|0;if((k|0)>=(f[i>>2]|0)){r=33;break}}if((r|0)==33)return 1;r=f[a>>2]|0;f[r+20>>2]=117;Gh[f[r+4>>2]&511](a,-1);f[u>>2]=-1;return 1}function PHa(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=f[a+468>>2]|0;g=a+280|0;if(f[g>>2]|0){i=e+52|0;j=f[i>>2]|0;if(!j){if(!(mi[f[(f[a+464>>2]|0)+8>>2]&255](a)|0)){k=f[a>>2]|0;f[k+20>>2]=25;ki[f[k>>2]&2047](a)}k=a+340|0;if((f[k>>2]|0)>0){l=a+224|0;m=a+436|0;n=a+412|0;o=a+420|0;p=0;do{q=f[a+344+(p<<2)>>2]|0;if(f[l>>2]|0)if(!(f[n>>2]|0)){if(!(f[o>>2]|0))r=10}else r=13;else r=10;do if((r|0)==10){r=0;s=f[e+56+(f[q+20>>2]<<2)>>2]|0;t=s+64|0;do{b[s>>0]=0;s=s+1|0}while((s|0)<(t|0));f[e+20+(p<<2)>>2]=0;f[e+36+(p<<2)>>2]=0;if(!(f[l>>2]|0))if(!(f[m>>2]|0))break;else{r=13;break}else if(!(f[n>>2]|0))break;else{r=13;break}}while(0);if((r|0)==13){r=0;F1a(f[e+120+(f[q+24>>2]<<2)>>2]|0,0,256)|0}p=p+1|0}while((p|0)<(f[k>>2]|0))}f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=-16;k=f[g>>2]|0;f[i>>2]=k;u=k}else u=j;f[i>>2]=u+-1}u=e+16|0;if((f[u>>2]|0)==-1)return 1;i=f[a+432>>2]|0;j=f[c>>2]|0;c=f[(f[a+344>>2]|0)+24>>2]|0;k=e+120+(c<<2)|0;g=a+416|0;p=e+184|0;e=a+424|0;n=a+264+c|0;c=(f[a+412>>2]|0)+-1|0;a:while(1){m=(f[k>>2]|0)+(c*3|0)|0;if(!(THa(a,m)|0)){v=c;w=m}else{r=32;break}while(1){x=v+1|0;if(THa(a,w+1|0)|0)break;if((x|0)<(f[g>>2]|0)){v=x;w=w+3|0}else{r=22;break a}}q=THa(a,p)|0;m=w+2|0;l=THa(a,m)|0;if(l){if(THa(a,m)|0){o=l<<1;s=(f[k>>2]|0)+((v|0)<(h[n>>0]|0|0)?189:217)|0;if(!(THa(a,s)|0)){y=o;z=s}else{t=o;o=s;while(1){s=t<<1;if((s|0)==32768){r=27;break a}A=o+1|0;if(!(THa(a,A)|0)){y=s;z=A;break}else{t=s;o=A}}}}else{y=l;z=m}o=z+14|0;t=y>>1;if(!t)B=y;else{A=t;t=y;while(1){s=(THa(a,o)|0)==0;C=(s?0:A)|t;A=A>>1;if(!A){B=C;break}else t=C}}}else B=0;d[j+(f[i+(x<<2)>>2]<<1)>>1]=((q|0)==0?B+1|0:~B)<<f[e>>2];if((x|0)<(f[g>>2]|0))c=x;else{r=32;break}}if((r|0)==22){x=f[a>>2]|0;f[x+20>>2]=117;Gh[f[x+4>>2]&511](a,-1);f[u>>2]=-1;return 1}else if((r|0)==27){x=f[a>>2]|0;f[x+20>>2]=117;Gh[f[x+4>>2]&511](a,-1);f[u>>2]=-1;return 1}else if((r|0)==32)return 1;return 0}function QHa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=f[a+468>>2]|0;g=a+280|0;if(f[g>>2]|0){h=e+52|0;i=f[h>>2]|0;if(!i){if(!(mi[f[(f[a+464>>2]|0)+8>>2]&255](a)|0)){k=f[a>>2]|0;f[k+20>>2]=25;ki[f[k>>2]&2047](a)}k=a+340|0;if((f[k>>2]|0)>0){l=a+224|0;m=a+436|0;n=a+412|0;o=a+420|0;p=0;do{q=f[a+344+(p<<2)>>2]|0;if(f[l>>2]|0)if(!(f[n>>2]|0)){if(!(f[o>>2]|0))r=10}else r=13;else r=10;do if((r|0)==10){r=0;s=f[e+56+(f[q+20>>2]<<2)>>2]|0;t=s+64|0;do{b[s>>0]=0;s=s+1|0}while((s|0)<(t|0));f[e+20+(p<<2)>>2]=0;f[e+36+(p<<2)>>2]=0;if(!(f[l>>2]|0))if(!(f[m>>2]|0))break;else{r=13;break}else if(!(f[n>>2]|0))break;else{r=13;break}}while(0);if((r|0)==13){r=0;F1a(f[e+120+(f[q+24>>2]<<2)>>2]|0,0,256)|0}p=p+1|0}while((p|0)<(f[k>>2]|0))}f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=-16;k=f[g>>2]|0;f[h>>2]=k;u=k}else u=i;f[h>>2]=u+-1}u=e+184|0;e=1<<f[a+424>>2];h=a+368|0;if((f[h>>2]|0)>0)v=0;else return 1;do{if(THa(a,u)|0){i=f[c+(v<<2)>>2]|0;d[i>>1]=j[i>>1]|0|e}v=v+1|0}while((v|0)<(f[h>>2]|0));return 1}function RHa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=f[a+468>>2]|0;g=a+280|0;if(f[g>>2]|0){h=e+52|0;i=f[h>>2]|0;if(!i){if(!(mi[f[(f[a+464>>2]|0)+8>>2]&255](a)|0)){j=f[a>>2]|0;f[j+20>>2]=25;ki[f[j>>2]&2047](a)}j=a+340|0;if((f[j>>2]|0)>0){k=a+224|0;l=a+436|0;m=a+412|0;n=a+420|0;o=0;do{p=f[a+344+(o<<2)>>2]|0;if(f[k>>2]|0)if(!(f[m>>2]|0)){if(!(f[n>>2]|0))q=10}else q=13;else q=10;do if((q|0)==10){q=0;r=f[e+56+(f[p+20>>2]<<2)>>2]|0;s=r+64|0;do{b[r>>0]=0;r=r+1|0}while((r|0)<(s|0));f[e+20+(o<<2)>>2]=0;f[e+36+(o<<2)>>2]=0;if(!(f[k>>2]|0))if(!(f[l>>2]|0))break;else{q=13;break}else if(!(f[m>>2]|0))break;else{q=13;break}}while(0);if((q|0)==13){q=0;F1a(f[e+120+(f[p+24>>2]<<2)>>2]|0,0,256)|0}o=o+1|0}while((o|0)<(f[j>>2]|0))}f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=-16;j=f[g>>2]|0;f[h>>2]=j;t=j}else t=i;f[h>>2]=t+-1}t=e+16|0;if((f[t>>2]|0)==-1)return 1;h=f[a+432>>2]|0;i=f[c>>2]|0;c=f[(f[a+344>>2]|0)+24>>2]|0;j=f[a+424>>2]|0;g=1<<j;o=-1<<j;j=a+416|0;m=f[j>>2]|0;while(1){if(d[i+(f[h+(m<<2)>>2]<<1)>>1]|0){u=m;break}m=m+-1|0;if(!m){u=0;break}}m=e+120+(c<<2)|0;c=e+184|0;e=(f[a+412>>2]|0)+-1|0;a:while(1){l=(f[m>>2]|0)+(e*3|0)|0;if((e|0)>=(u|0)?(THa(a,l)|0)!=0:0){q=33;break}else{v=e;w=l}while(1){v=v+1|0;x=i+(f[h+(v<<2)>>2]<<1)|0;if(d[x>>1]|0){q=25;break}if(THa(a,w+1|0)|0){q=28;break}if((v|0)>=(f[j>>2]|0)){q=30;break a}else w=w+3|0}if((q|0)==25){q=0;if(THa(a,w+2|0)|0){p=d[x>>1]|0;y=(p<<16>>16<0?o:g)+(p&65535)|0;q=31}}else if((q|0)==28){q=0;p=(THa(a,c)|0)==0;y=p?g:o;q=31}if((q|0)==31){q=0;d[x>>1]=y}if((v|0)<(f[j>>2]|0))e=v;else{q=33;break}}if((q|0)==30){v=f[a>>2]|0;f[v+20>>2]=117;Gh[f[v+4>>2]&511](a,-1);f[t>>2]=-1;return 1}else if((q|0)==33)return 1;return 0}function SHa(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;e=f[a+468>>2]|0;g=a+280|0;if(f[g>>2]|0){i=e+52|0;j=f[i>>2]|0;if(!j){if(!(mi[f[(f[a+464>>2]|0)+8>>2]&255](a)|0)){k=f[a>>2]|0;f[k+20>>2]=25;ki[f[k>>2]&2047](a)}k=a+340|0;if((f[k>>2]|0)>0){l=a+224|0;m=a+436|0;n=a+412|0;o=a+420|0;p=0;do{q=f[a+344+(p<<2)>>2]|0;if(f[l>>2]|0)if(!(f[n>>2]|0)){if(!(f[o>>2]|0))r=10}else r=13;else r=10;do if((r|0)==10){r=0;s=f[e+56+(f[q+20>>2]<<2)>>2]|0;t=s+64|0;do{b[s>>0]=0;s=s+1|0}while((s|0)<(t|0));f[e+20+(p<<2)>>2]=0;f[e+36+(p<<2)>>2]=0;if(!(f[l>>2]|0))if(!(f[m>>2]|0))break;else{r=13;break}else if(!(f[n>>2]|0))break;else{r=13;break}}while(0);if((r|0)==13){r=0;F1a(f[e+120+(f[q+24>>2]<<2)>>2]|0,0,256)|0}p=p+1|0}while((p|0)<(f[k>>2]|0))}f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=-16;k=f[g>>2]|0;f[i>>2]=k;u=k}else u=j;f[i>>2]=u+-1}u=e+16|0;if((f[u>>2]|0)==-1)return 1;i=f[a+432>>2]|0;j=a+368|0;if((f[j>>2]|0)<=0)return 1;k=a+436|0;g=e+184|0;p=0;a:while(1){n=f[c+(p<<2)>>2]|0;m=f[a+372+(p<<2)>>2]|0;l=f[a+344+(m<<2)>>2]|0;o=f[l+20>>2]|0;s=e+56+(o<<2)|0;t=e+36+(m<<2)|0;v=(f[s>>2]|0)+(f[t>>2]|0)|0;if(!(THa(a,v)|0)){f[t>>2]=0;w=f[e+20+(m<<2)>>2]|0}else{x=THa(a,v+1|0)|0;y=v+2+x|0;v=THa(a,y)|0;if(v){z=(f[s>>2]|0)+20|0;if(!(THa(a,z)|0)){A=v;B=z}else{s=v;v=z;while(1){z=s<<1;if((z|0)==32768){r=25;break a}C=v+1|0;if(!(THa(a,C)|0)){A=z;B=C;break}else{s=z;v=C}}}}else{A=0;B=y}if((A|0)<(1<<(h[a+232+o>>0]|0)>>1|0))D=0;else D=((A|0)>(1<<(h[a+248+o>>0]|0)>>1|0)?12:4)+(x<<2)|0;f[t>>2]=D;v=B+14|0;s=A>>1;if(!s)E=A;else{q=s;s=A;while(1){C=(THa(a,v)|0)==0;z=(C?0:q)|s;q=q>>1;if(!q){E=z;break}else s=z}}s=e+20+(m<<2)|0;q=(f[s>>2]|0)+((x|0)==0?E+1|0:~E)|0;f[s>>2]=q;w=q}d[n>>1]=w;b:do if(f[k>>2]|0){q=f[l+24>>2]|0;s=e+120+(q<<2)|0;v=a+264+q|0;q=0;while(1){t=(f[s>>2]|0)+(q*3|0)|0;if(!(THa(a,t)|0)){F=q;G=t}else break b;while(1){H=F+1|0;if(THa(a,G+1|0)|0)break;if((H|0)<(f[k>>2]|0)){F=H;G=G+3|0}else{r=37;break a}}t=THa(a,g)|0;o=G+2|0;y=THa(a,o)|0;if(y){if(THa(a,o)|0){z=y<<1;C=(f[s>>2]|0)+((F|0)<(h[v>>0]|0|0)?189:217)|0;if(!(THa(a,C)|0)){I=z;J=C}else{K=z;z=C;while(1){C=K<<1;if((C|0)==32768){r=42;break a}L=z+1|0;if(!(THa(a,L)|0)){I=C;J=L;break}else{K=C;z=L}}}}else{I=y;J=o}z=J+14|0;K=I>>1;if(!K)M=I;else{L=K;K=I;while(1){C=(THa(a,z)|0)==0;N=(C?0:L)|K;L=L>>1;if(!L){M=N;break}else K=N}}}else M=0;d[n+(f[i+(H<<2)>>2]<<1)>>1]=(t|0)==0?M+1|0:M^65535;if((H|0)<(f[k>>2]|0))q=H;else break}}while(0);p=p+1|0;if((p|0)>=(f[j>>2]|0)){r=48;break}}if((r|0)==25){j=f[a>>2]|0;f[j+20>>2]=117;Gh[f[j+4>>2]&511](a,-1);f[u>>2]=-1;return 1}else if((r|0)==37){j=f[a>>2]|0;f[j+20>>2]=117;Gh[f[j+4>>2]&511](a,-1);f[u>>2]=-1;return 1}else if((r|0)==42){j=f[a>>2]|0;f[j+20>>2]=117;Gh[f[j+4>>2]&511](a,-1);f[u>>2]=-1;return 1}else if((r|0)==48)return 1;return 0}function THa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[a+468>>2]|0;e=d+12|0;g=f[e>>2]|0;i=d+16|0;if((g|0)<32768){j=a+440|0;k=a+24|0;l=d+8|0;m=f[i>>2]|0;while(1){n=m+-1|0;f[i>>2]=n;if((m|0)<1){a:do if(!(f[j>>2]|0)){o=f[k>>2]|0;p=o+4|0;if((f[p>>2]|0)==0?(mi[f[o+12>>2]&255](a)|0)==0:0){q=f[a>>2]|0;f[q+20>>2]=25;ki[f[q>>2]&2047](a)}f[p>>2]=(f[p>>2]|0)+-1;p=f[o>>2]|0;f[o>>2]=p+1;o=b[p>>0]|0;p=o&255;if(o<<24>>24==-1){b:while(1){o=f[k>>2]|0;q=o+4|0;if((f[q>>2]|0)==0?(mi[f[o+12>>2]&255](a)|0)==0:0){r=f[a>>2]|0;f[r+20>>2]=25;ki[f[r>>2]&2047](a)}f[q>>2]=(f[q>>2]|0)+-1;q=f[o>>2]|0;f[o>>2]=q+1;s=b[q>>0]|0;switch(s<<24>>24){case 0:{t=255;break a;break}case -1:break;default:break b}}f[j>>2]=s&255;t=0}else t=p}else t=0;while(0);f[l>>2]=f[l>>2]<<8|t;q=f[i>>2]|0;o=q+8|0;f[i>>2]=o;if((q|0)<-8){r=q+9|0;f[i>>2]=r;if(!r){f[e>>2]=32768;u=0}else u=r}else u=o}else u=n;o=f[e>>2]<<1;f[e>>2]=o;if((o|0)<32768)m=u;else{v=o;w=u;x=l;break}}}else{v=g;w=f[i>>2]|0;x=d+8|0}d=h[c>>0]|0;i=f[122404+((d&127)<<2)>>2]|0;g=i>>8;l=i>>16;u=v-l|0;f[e>>2]=u;v=u<<w;w=f[x>>2]|0;if((w|0)>=(v|0)){f[x>>2]=w-v;f[e>>2]=l;e=d&128;if((u|0)<(l|0)){b[c>>0]=e^g;y=d;z=y>>7;return z|0}else{b[c>>0]=e^i;y=d^128;z=y>>7;return z|0}}if((u|0)>=32768){y=d;z=y>>7;return z|0}e=d&128;if((u|0)<(l|0)){b[c>>0]=e^i;y=d^128;z=y>>7;return z|0}else{b[c>>0]=e^g;y=d;z=y>>7;return z|0}return 0}function UHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=ui[f[f[c>>2]>>2]&127](a,1,116)|0;f[a+452>>2]=d;f[d>>2]=1010;f[d+8>>2]=1011;f[d+112>>2]=0;if(!b){b=ui[f[(f[c>>2]|0)+4>>2]&127](a,1,1280)|0;f[d+32>>2]=b;f[d+36>>2]=b+128;f[d+40>>2]=b+256;f[d+44>>2]=b+384;f[d+48>>2]=b+512;f[d+52>>2]=b+640;f[d+56>>2]=b+768;f[d+60>>2]=b+896;f[d+64>>2]=b+1024;f[d+68>>2]=b+1152;if(!(f[a+436>>2]|0))F1a(b|0,0,1280)|0;f[d+4>>2]=253;f[d+12>>2]=187;f[d+16>>2]=0;return}b=a+36|0;if((f[b>>2]|0)>0){e=a+224|0;g=d+72|0;h=0;i=f[a+216>>2]|0;while(1){j=i+12|0;k=f[j>>2]|0;l=(f[e>>2]|0)==0?k:k*3|0;k=f[(f[c>>2]|0)+20>>2]|0;m=RGa(f[i+28>>2]|0,f[i+8>>2]|0)|0;n=RGa(f[i+32>>2]|0,f[j>>2]|0)|0;j=bg[k&127](a,1,1,m,n,l)|0;f[g+(h<<2)>>2]=j;h=h+1|0;if((h|0)>=(f[b>>2]|0)){o=g;break}else i=i+88|0}}else o=d+72|0;f[d+4>>2]=252;f[d+12>>2]=186;f[d+16>>2]=o;return}function VHa(a){a=a|0;var b=0,c=0,d=0;f[a+148>>2]=0;b=f[a+452>>2]|0;if((f[a+340>>2]|0)>1)c=1;else{d=f[a+344>>2]|0;c=f[((f[a+332>>2]|0)!=1?d+12|0:d+76|0)>>2]|0}f[b+28>>2]=c;f[b+20>>2]=0;f[b+24>>2]=0;return}function WHa(a){a=a|0;var b=0,c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=f[a+452>>2]|0;if(!(f[b+16>>2]|0)){c=a+156|0;f[c>>2]=0;return}a:do if(((f[a+80>>2]|0)!=0?(f[a+224>>2]|0)!=0:0)?(e=a+160|0,(f[e>>2]|0)!=0):0){g=b+112|0;h=f[g>>2]|0;if(!h){i=a+36|0;j=ui[f[f[a+4>>2]>>2]&127](a,1,(f[i>>2]|0)*24|0)|0;f[g>>2]=j;k=j;l=i}else{k=h;l=a+36|0}if((f[l>>2]|0)>0){h=0;i=k;j=f[a+216>>2]|0;g=0;while(1){m=f[j+80>>2]|0;if(!m){n=20;break a}if(!(d[m>>1]|0)){n=20;break a}if(!(d[m+2>>1]|0)){n=20;break a}if(!(d[m+16>>1]|0)){n=20;break a}if(!(d[m+32>>1]|0)){n=20;break a}if(!(d[m+18>>1]|0)){n=20;break a}if(!(d[m+4>>1]|0)){n=20;break a}m=f[e>>2]|0;if((f[m+(h<<8)>>2]|0)<0){n=20;break a}o=m+(h<<8)+4|0;f[i+4>>2]=f[o>>2];p=f[o>>2]|0;o=m+(h<<8)+8|0;f[i+8>>2]=f[o>>2];q=f[o>>2]|p;p=m+(h<<8)+12|0;f[i+12>>2]=f[p>>2];o=q|f[p>>2];p=m+(h<<8)+16|0;f[i+16>>2]=f[p>>2];q=o|f[p>>2];p=m+(h<<8)+20|0;f[i+20>>2]=f[p>>2];g=(q|f[p>>2]|0)==0?g:1;h=h+1|0;if((h|0)>=(f[l>>2]|0))break;else{i=i+24|0;j=j+88|0}}if(g)r=188;else n=20}else n=20}else n=20;while(0);if((n|0)==20)r=186;f[b+12>>2]=r;c=a+156|0;f[c>>2]=0;return}function XHa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;b=u;u=u+16|0;c=b;d=a+452|0;e=f[d>>2]|0;g=a+340|0;if((f[g>>2]|0)>0){h=a+4|0;i=a+148|0;j=0;do{k=f[a+344+(j<<2)>>2]|0;l=f[k+12>>2]|0;m=Y(l,f[i>>2]|0)|0;n=uh[f[(f[h>>2]|0)+32>>2]&63](a,f[e+72+(f[k+4>>2]<<2)>>2]|0,m,l,1)|0;f[c+(j<<2)>>2]=n;j=j+1|0}while((j|0)<(f[g>>2]|0))}j=e+24|0;h=f[j>>2]|0;i=e+28|0;n=f[i>>2]|0;a:do if((h|0)<(n|0)){l=e+20|0;m=a+360|0;k=a+468|0;o=e+32|0;p=f[l>>2]|0;q=f[m>>2]|0;r=n;s=h;b:while(1){if(p>>>0<q>>>0){t=p;while(1){v=f[g>>2]|0;if((v|0)>0){w=0;x=0;while(1){y=f[a+344+(x<<2)>>2]|0;z=f[y+56>>2]|0;A=Y(z,t)|0;B=f[y+60>>2]|0;if((B|0)>0?(y=f[c+(x<<2)>>2]|0,(z|0)>0):0){C=w;D=0;while(1){E=C;F=(f[y+(D+s<<2)>>2]|0)+(A<<7)|0;G=0;while(1){H=E;E=E+1|0;f[e+32+(H<<2)>>2]=F;G=G+1|0;if((G|0)>=(z|0))break;else F=F+128|0}D=D+1|0;if((D|0)>=(B|0)){I=E;break}else C=E}}else I=w;x=x+1|0;if((x|0)>=(v|0))break;else w=I}}if(!($h[f[(f[k>>2]|0)+4>>2]&255](a,o)|0))break b;w=t+1|0;J=f[m>>2]|0;if(w>>>0<J>>>0)t=w;else break}K=f[i>>2]|0;L=J}else{K=r;L=q}f[l>>2]=0;w=s+1|0;if((w|0)<(K|0)){p=0;q=L;r=K;s=w}else break a}f[j>>2]=s;f[l>>2]=t;M=0;u=b;return M|0}while(0);t=a+148|0;j=(f[t>>2]|0)+1|0;f[t>>2]=j;t=f[a+332>>2]|0;if(j>>>0>=t>>>0){ki[f[(f[a+460>>2]|0)+12>>2]&2047](a);M=4;u=b;return M|0}K=f[d>>2]|0;if((f[g>>2]|0)>1)N=1;else{g=f[a+344>>2]|0;N=f[(j>>>0<(t+-1|0)>>>0?g+12|0:g+76|0)>>2]|0}f[K+28>>2]=N;f[K+20>>2]=0;f[K+24>>2]=0;M=3;u=b;return M|0}function YHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=f[a+452>>2]|0;d=a+332|0;e=(f[d>>2]|0)+-1|0;g=a+144|0;h=a+152|0;i=a+460|0;j=a+148|0;k=a+156|0;while(1){l=f[g>>2]|0;m=f[h>>2]|0;if((l|0)>=(m|0)){if((l|0)!=(m|0))break;if((f[j>>2]|0)>>>0>(f[k>>2]|0)>>>0)break}if(!(mi[f[f[i>>2]>>2]&255](a)|0)){n=0;o=19;break}}if((o|0)==19)return n|0;o=a+36|0;if((f[o>>2]|0)>0){i=a+4|0;j=a+472|0;h=0;g=f[a+216>>2]|0;while(1){if(f[g+52>>2]|0){m=g+12|0;l=f[m>>2]|0;p=Y(l,f[k>>2]|0)|0;q=uh[f[(f[i>>2]|0)+32>>2]&63](a,f[c+72+(h<<2)>>2]|0,p,l,0)|0;l=f[m>>2]|0;if((f[k>>2]|0)>>>0<e>>>0)r=l;else{m=((f[g+32>>2]|0)>>>0)%(l>>>0)|0;r=(m|0)==0?l:m}m=f[(f[j>>2]|0)+4+(h<<2)>>2]|0;if((r|0)>0){l=g+28|0;p=g+40|0;s=g+36|0;t=f[l>>2]|0;u=0;v=f[b+(h<<2)>>2]|0;while(1){if(!t)w=0;else{x=0;y=f[q+(u<<2)>>2]|0;z=0;while(1){Bh[m&255](a,g,y,v,z);x=x+1|0;A=f[l>>2]|0;if(x>>>0>=A>>>0){w=A;break}else{y=y+128|0;z=(f[s>>2]|0)+z|0}}}u=u+1|0;if((u|0)==(r|0))break;else{t=w;v=v+(f[p>>2]<<2)|0}}}}h=h+1|0;if((h|0)>=(f[o>>2]|0))break;else g=g+88|0}}g=(f[k>>2]|0)+1|0;f[k>>2]=g;n=g>>>0<(f[d>>2]|0)>>>0?3:4;return n|0}function ZHa(a){a=a|0;return 0}function _Ha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;c=a+452|0;d=f[c>>2]|0;e=(f[a+360>>2]|0)+-1|0;g=a+332|0;h=f[g>>2]|0;i=h+-1|0;j=d+24|0;k=f[j>>2]|0;l=d+28|0;m=f[l>>2]|0;do if((k|0)<(m|0)){n=d+20|0;o=a+436|0;p=a+468|0;q=d+32|0;r=a+340|0;s=a+472|0;t=a+148|0;u=a+368|0;v=m;w=f[n>>2]|0;x=k;a:while(1){if(w>>>0>e>>>0)y=v;else{z=w;while(1){if(f[o>>2]|0)F1a(f[q>>2]|0,0,f[u>>2]<<7|0)|0;if(!($h[f[(f[p>>2]|0)+4>>2]&255](a,q)|0))break a;A=f[r>>2]|0;if((A|0)>0){B=z>>>0<e>>>0;C=A;A=0;D=0;while(1){E=f[a+344+(D<<2)>>2]|0;b:do if(f[E+52>>2]|0){F=f[E+4>>2]|0;G=f[(f[s>>2]|0)+4+(F<<2)>>2]|0;H=E+56|0;I=f[(B?H:E+72|0)>>2]|0;J=E+40|0;K=Y(f[E+68>>2]|0,z)|0;L=E+60|0;M=f[L>>2]|0;if((M|0)>0){N=f[J>>2]|0;O=E+76|0;P=E+36|0;if((I|0)<=0){Q=f[H>>2]|0;R=A;S=0;while(1){T=Q+R|0;S=S+1|0;if((S|0)>=(M|0)){U=C;V=T;break b}else R=T}}R=M;S=N;Q=A;T=(f[b+(F<<2)>>2]|0)+((Y(N,x)|0)<<2)|0;W=0;while(1){if((f[t>>2]|0)>>>0>=i>>>0?(W+x|0)>=(f[O>>2]|0):0){X=S;Z=R}else{_=K;$=0;aa=21}if((aa|0)==21){while(1){aa=0;Bh[G&255](a,E,f[d+32+($+Q<<2)>>2]|0,T,_);$=$+1|0;if(($|0)==(I|0))break;else{_=(f[P>>2]|0)+_|0;aa=21}}X=f[J>>2]|0;Z=f[L>>2]|0}Q=(f[H>>2]|0)+Q|0;W=W+1|0;if((W|0)>=(Z|0))break;else{R=Z;S=X;T=T+(X<<2)|0}}U=f[r>>2]|0;V=Q}else{U=C;V=A}}else{U=C;V=(f[E+64>>2]|0)+A|0}while(0);D=D+1|0;if((D|0)>=(U|0))break;else{C=U;A=V}}}A=z+1|0;if(A>>>0>e>>>0)break;else z=A}y=f[l>>2]|0}f[n>>2]=0;A=x+1|0;if((A|0)<(y|0)){v=y;w=0;x=A}else{aa=28;break}}if((aa|0)==28){ba=f[g>>2]|0;ca=t;break}f[j>>2]=x;f[n>>2]=z;da=0;return da|0}else{ba=h;ca=a+148|0}while(0);h=a+156|0;f[h>>2]=(f[h>>2]|0)+1;h=(f[ca>>2]|0)+1|0;f[ca>>2]=h;if(h>>>0>=ba>>>0){ki[f[(f[a+460>>2]|0)+12>>2]&2047](a);da=4;return da|0}ca=f[c>>2]|0;if((f[a+340>>2]|0)>1)ea=1;else{c=f[a+344>>2]|0;ea=f[(h>>>0<(ba+-1|0)>>>0?c+12|0:c+76|0)>>2]|0}f[ca+28>>2]=ea;f[ca+20>>2]=0;f[ca+24>>2]=0;da=3;return da|0}function $Ha(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0;c=u;u=u+128|0;e=c;g=f[a+452>>2]|0;h=a+332|0;i=(f[h>>2]|0)+-1|0;k=a+144|0;l=a+152|0;m=a+460|0;n=a+412|0;o=a+148|0;p=a+156|0;while(1){q=f[k>>2]|0;r=f[l>>2]|0;if((q|0)>(r|0))break;s=f[m>>2]|0;if(f[s+20>>2]|0)break;if((q|0)==(r|0)?(f[o>>2]|0)>>>0>((f[p>>2]|0)+((f[n>>2]|0)==0&1)|0)>>>0:0)break;if(!(mi[f[s>>2]&255](a)|0)){t=0;v=54;break}}if((v|0)==54){u=c;return t|0}v=a+36|0;if((f[v>>2]|0)>0){n=a+4|0;o=g+112|0;m=a+472|0;l=e+4|0;k=e+18|0;s=e+32|0;r=e+16|0;q=e+2|0;w=0;x=f[a+216>>2]|0;while(1){if(f[x+52>>2]|0){y=f[p>>2]|0;z=x+12|0;A=f[z>>2]|0;if(y>>>0<i>>>0){B=A<<1;C=A;D=0}else{E=((f[x+32>>2]|0)>>>0)%(A>>>0)|0;F=(E|0)==0?A:E;B=F;C=F;D=1}F=f[g+72+(w<<2)>>2]|0;E=f[(f[n>>2]|0)+32>>2]|0;if(!y){G=uh[E&63](a,F,0,B,0)|0;H=1}else{I=Y(A,y+-1|0)|0;y=uh[E&63](a,F,I,A+B|0,0)|0;G=y+(f[z>>2]<<2)|0;H=0}z=(f[o>>2]|0)+(w*6<<2)|0;y=f[x+80>>2]|0;A=j[y>>1]|0;I=j[y+2>>1]|0;F=j[y+16>>1]|0;E=j[y+32>>1]|0;J=j[y+18>>1]|0;K=j[y+4>>1]|0;y=f[(f[m>>2]|0)+4+(w<<2)>>2]|0;if((C|0)>0){L=(H|0)!=0;M=(D|0)!=0;N=C+-1|0;O=x+28|0;P=z+4|0;Q=z+8|0;R=z+12|0;S=z+16|0;T=z+20|0;z=x+36|0;U=A*9|0;V=K<<7;W=K<<8;K=A*5|0;X=J<<7;Z=J<<8;J=E<<7;_=E<<8;E=A*36|0;A=F<<7;$=F<<8;F=I<<7;aa=I<<8;I=x+40|0;ba=0;ca=f[b+(w<<2)>>2]|0;while(1){da=f[G+(ba<<2)>>2]|0;if(L&(ba|0)==0)ea=da;else ea=f[G+(ba+-1<<2)>>2]|0;if(M&(ba|0)==(N|0))fa=da;else fa=f[G+(ba+1<<2)>>2]|0;ga=d[ea>>1]|0;ha=d[da>>1]|0;ia=d[fa>>1]|0;ja=(f[O>>2]|0)+-1|0;ka=ga;la=ga;ga=ha;ma=ha;ha=ia;na=ia;ia=0;oa=da;da=fa;pa=0;qa=ea;while(1){TGa(oa,e,1);if(ia>>>0<ja>>>0){ra=d[qa+128>>1]|0;sa=d[oa+128>>1]|0;ta=d[da+128>>1]|0}else{ra=la;sa=ma;ta=na}ua=f[P>>2]|0;if((ua|0)!=0&(d[q>>1]|0)==0){va=Y(E,ga-sa|0)|0;wa=(ua|0)>0;if((va|0)>-1){xa=(va+F|0)/(aa|0)|0;ya=1<<ua;za=wa?((xa|0)<(ya|0)?xa:ya+-1|0):xa}else{xa=(F-va|0)/(aa|0)|0;va=1<<ua;za=0-(wa?((xa|0)<(va|0)?xa:va+-1|0):xa)|0}d[q>>1]=za}xa=f[Q>>2]|0;if((xa|0)!=0&(d[r>>1]|0)==0){va=Y(E,la-na|0)|0;wa=(xa|0)>0;if((va|0)>-1){ua=(va+A|0)/($|0)|0;ya=1<<xa;Aa=wa?((ua|0)<(ya|0)?ua:ya+-1|0):ua}else{ua=(A-va|0)/($|0)|0;va=1<<xa;Aa=0-(wa?((ua|0)<(va|0)?ua:va+-1|0):ua)|0}d[r>>1]=Aa}ua=f[R>>2]|0;if((ua|0)!=0&(d[s>>1]|0)==0){va=Y(U,la-(ma<<1)+na|0)|0;wa=(ua|0)>0;if((va|0)>-1){xa=(va+J|0)/(_|0)|0;ya=1<<ua;Ba=wa?((xa|0)<(ya|0)?xa:ya+-1|0):xa}else{xa=(J-va|0)/(_|0)|0;va=1<<ua;Ba=0-(wa?((xa|0)<(va|0)?xa:va+-1|0):xa)|0}d[s>>1]=Ba}xa=f[S>>2]|0;if((xa|0)!=0&(d[k>>1]|0)==0){va=Y(K,ka-ha-ra+ta|0)|0;wa=(xa|0)>0;if((va|0)>-1){ua=(va+X|0)/(Z|0)|0;ya=1<<xa;Ca=wa?((ua|0)<(ya|0)?ua:ya+-1|0):ua}else{ua=(X-va|0)/(Z|0)|0;va=1<<xa;Ca=0-(wa?((ua|0)<(va|0)?ua:va+-1|0):ua)|0}d[k>>1]=Ca}ua=f[T>>2]|0;if((ua|0)!=0&(d[l>>1]|0)==0){va=Y(U,ga-(ma<<1)+sa|0)|0;wa=(ua|0)>0;if((va|0)>-1){xa=(va+V|0)/(W|0)|0;ya=1<<ua;Da=wa?((xa|0)<(ya|0)?xa:ya+-1|0):xa}else{xa=(V-va|0)/(W|0)|0;va=1<<ua;Da=0-(wa?((xa|0)<(va|0)?xa:va+-1|0):xa)|0}d[l>>1]=Da}Bh[y&255](a,x,e,ca,pa);ia=ia+1|0;if(ia>>>0>ja>>>0)break;else{xa=na;va=ma;wa=la;la=ra;ma=sa;na=ta;oa=oa+128|0;da=da+128|0;pa=(f[z>>2]|0)+pa|0;qa=qa+128|0;ha=xa;ga=va;ka=wa}}ba=ba+1|0;if((ba|0)==(C|0))break;else ca=ca+(f[I>>2]<<2)|0}}}w=w+1|0;if((w|0)>=(f[v>>2]|0))break;else x=x+88|0}}x=(f[p>>2]|0)+1|0;f[p>>2]=x;t=x>>>0<(f[h>>2]|0)>>>0?3:4;u=c;return t|0}function aIa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=a+4|0;c=ui[f[f[b>>2]>>2]&127](a,1,28)|0;d=a+480|0;f[d>>2]=c;f[c>>2]=1012;e=a+40|0;switch(f[e>>2]|0){case 1:{if((f[a+36>>2]|0)!=1){g=f[a>>2]|0;f[g+20>>2]=11;ki[f[g>>2]&2047](a)}break}case 3:case 2:{if((f[a+36>>2]|0)!=3){g=f[a>>2]|0;f[g+20>>2]=11;ki[f[g>>2]&2047](a)}break}case 5:case 4:{if((f[a+36>>2]|0)!=4){g=f[a>>2]|0;f[g+20>>2]=11;ki[f[g>>2]&2047](a)}break}default:if((f[a+36>>2]|0)<1){g=f[a>>2]|0;f[g+20>>2]=11;ki[f[g>>2]&2047](a)}}g=a+304|0;if(f[g>>2]|0?(f[e>>2]|0)!=2:0){h=f[a>>2]|0;f[h+20>>2]=28;ki[f[h>>2]&2047](a)}h=f[a+44>>2]|0;a:do switch(h|0){case 1:{f[a+120>>2]=1;switch(f[e>>2]|0){case 3:case 1:{f[c+4>>2]=144;i=f[a+36>>2]|0;if((i|0)<=1)break a;j=f[a+216>>2]|0;k=1;do{f[j+(k*88|0)+52>>2]=0;k=k+1|0}while((k|0)<(i|0));break}case 2:{switch(f[g>>2]|0){case 0:{f[c+4>>2]=145;break}case 1:{f[c+4>>2]=146;break}default:{i=f[a>>2]|0;f[i+20>>2]=28;ki[f[i>>2]&2047](a)}}i=f[d>>2]|0;k=ui[f[f[b>>2]>>2]&127](a,1,3072)|0;f[i+24>>2]=k;i=0;do{f[k+(i<<2)>>2]=i*19595;f[k+(i+256<<2)>>2]=i*38470;f[k+(i+512<<2)>>2]=(i*7471|0)+32768;i=i+1|0}while((i|0)!=256);break}default:{i=f[a>>2]|0;f[i+20>>2]=28;ki[f[i>>2]&2047](a);break a}}break}case 2:{f[a+120>>2]=3;switch(f[e>>2]|0){case 3:{f[c+4>>2]=147;i=f[d>>2]|0;k=ui[f[f[b>>2]>>2]&127](a,1,1024)|0;j=i+8|0;f[j>>2]=k;k=ui[f[f[b>>2]>>2]&127](a,1,1024)|0;l=i+12|0;f[l>>2]=k;k=ui[f[f[b>>2]>>2]&127](a,1,1024)|0;m=i+16|0;f[m>>2]=k;k=ui[f[f[b>>2]>>2]&127](a,1,1024)|0;f[i+20>>2]=k;i=f[j>>2]|0;j=f[l>>2]|0;l=f[m>>2]|0;m=0;n=-128;while(1){f[i+(m<<2)>>2]=(n*91881|0)+32768>>16;f[j+(m<<2)>>2]=(n*116130|0)+32768>>16;o=Y(n,-46802)|0;f[l+(m<<2)>>2]=o;o=(Y(n,-22554)|0)+32768|0;f[k+(m<<2)>>2]=o;m=m+1|0;if((m|0)==256)break;else n=n+1|0}break}case 1:{f[c+4>>2]=148;break a;break}case 2:{switch(f[g>>2]|0){case 0:{f[c+4>>2]=149;break a;break}case 1:{f[c+4>>2]=150;break a;break}default:{n=f[a>>2]|0;f[n+20>>2]=28;ki[f[n>>2]&2047](a);break a}}break}default:{n=f[a>>2]|0;f[n+20>>2]=28;ki[f[n>>2]&2047](a);break a}}break}case 4:{f[a+120>>2]=4;switch(f[e>>2]|0){case 5:{f[c+4>>2]=151;n=f[d>>2]|0;m=ui[f[f[b>>2]>>2]&127](a,1,1024)|0;k=n+8|0;f[k>>2]=m;m=ui[f[f[b>>2]>>2]&127](a,1,1024)|0;l=n+12|0;f[l>>2]=m;m=ui[f[f[b>>2]>>2]&127](a,1,1024)|0;j=n+16|0;f[j>>2]=m;m=ui[f[f[b>>2]>>2]&127](a,1,1024)|0;f[n+20>>2]=m;n=f[k>>2]|0;k=f[l>>2]|0;l=f[j>>2]|0;j=0;i=-128;while(1){f[n+(j<<2)>>2]=(i*91881|0)+32768>>16;f[k+(j<<2)>>2]=(i*116130|0)+32768>>16;o=Y(i,-46802)|0;f[l+(j<<2)>>2]=o;o=(Y(i,-22554)|0)+32768|0;f[m+(j<<2)>>2]=o;j=j+1|0;if((j|0)==256)break;else i=i+1|0}break}case 4:{f[c+4>>2]=152;break a;break}default:{i=f[a>>2]|0;f[i+20>>2]=28;ki[f[i>>2]&2047](a);break a}}break}default:if((h|0)==(f[e>>2]|0)){f[a+120>>2]=f[a+36>>2];f[c+4>>2]=152;break a}else{i=f[a>>2]|0;f[i+20>>2]=28;ki[f[i>>2]&2047](a);break a}}while(0);if(f[a+84>>2]|0){p=1;q=a+124|0;f[q>>2]=p;return}p=f[a+120>>2]|0;q=a+124|0;f[q>>2]=p;return}function bIa(a){a=a|0;return}function cIa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;SGa(f[b>>2]|0,c,d,0,e,f[a+112>>2]|0);return}function dIa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;i=f[(f[a+480>>2]|0)+24>>2]|0;j=f[a+112>>2]|0;if((g|0)<=0)return;a=c+4|0;k=c+8|0;if(!j)return;else{l=g;m=d;n=e}while(1){e=l;l=l+-1|0;d=f[(f[c>>2]|0)+(m<<2)>>2]|0;g=f[(f[a>>2]|0)+(m<<2)>>2]|0;o=f[(f[k>>2]|0)+(m<<2)>>2]|0;m=m+1|0;p=f[n>>2]|0;q=0;do{b[p+q>>0]=((f[i+((h[g+q>>0]|0|256)<<2)>>2]|0)+(f[i+((h[d+q>>0]|0)<<2)>>2]|0)+(f[i+((h[o+q>>0]|0|512)<<2)>>2]|0)|0)>>>16;q=q+1|0}while((q|0)!=(j|0));if((e|0)<=1)break;else n=n+4|0}return}function eIa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;i=f[(f[a+480>>2]|0)+24>>2]|0;j=f[a+112>>2]|0;if((g|0)<=0)return;a=c+4|0;k=c+8|0;if(!j)return;else{l=g;m=d;n=e}while(1){e=l;l=l+-1|0;d=f[(f[c>>2]|0)+(m<<2)>>2]|0;g=f[(f[a>>2]|0)+(m<<2)>>2]|0;o=f[(f[k>>2]|0)+(m<<2)>>2]|0;m=m+1|0;p=f[n>>2]|0;q=0;do{r=h[g+q>>0]|0;b[p+q>>0]=((f[i+((r|256)<<2)>>2]|0)+(f[i+(((h[d+q>>0]|0)+128+r&255)<<2)>>2]|0)+(f[i+((r+128+(h[o+q>>0]|0)&255|512)<<2)>>2]|0)|0)>>>16;q=q+1|0}while((q|0)!=(j|0));if((e|0)<=1)break;else n=n+4|0}return}function fIa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;i=f[a+480>>2]|0;j=f[a+112>>2]|0;k=f[a+336>>2]|0;a=f[i+8>>2]|0;l=f[i+12>>2]|0;m=f[i+16>>2]|0;n=f[i+20>>2]|0;if((g|0)<=0)return;i=c+4|0;o=c+8|0;if(!j)return;else{p=g;q=d;r=e}while(1){e=p;p=p+-1|0;d=f[(f[c>>2]|0)+(q<<2)>>2]|0;g=f[(f[i>>2]|0)+(q<<2)>>2]|0;s=f[(f[o>>2]|0)+(q<<2)>>2]|0;q=q+1|0;t=0;u=f[r>>2]|0;while(1){v=h[d+t>>0]|0;w=h[g+t>>0]|0;x=h[s+t>>0]|0;b[u>>0]=b[k+((f[a+(x<<2)>>2]|0)+v)>>0]|0;b[u+1>>0]=b[k+(((f[m+(x<<2)>>2]|0)+(f[n+(w<<2)>>2]|0)>>16)+v)>>0]|0;b[u+2>>0]=b[k+((f[l+(w<<2)>>2]|0)+v)>>0]|0;t=t+1|0;if((t|0)==(j|0))break;else u=u+3|0}if((e|0)<=1)break;else r=r+4|0}return}function gIa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=f[a+112>>2]|0;if((g|0)<1|(h|0)==0)return;else{i=g;j=d;k=e}while(1){e=i;i=i+-1|0;d=f[(f[c>>2]|0)+(j<<2)>>2]|0;g=0;a=f[k>>2]|0;while(1){l=b[d+g>>0]|0;b[a+2>>0]=l;b[a+1>>0]=l;b[a>>0]=l;g=g+1|0;if((g|0)==(h|0))break;else a=a+3|0}if((e|0)<=1)break;else{j=j+1|0;k=k+4|0}}return}function hIa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=f[a+112>>2]|0;if((g|0)<=0)return;a=c+4|0;i=c+8|0;if(!h)return;else{j=g;k=d;l=e}while(1){e=j;j=j+-1|0;d=f[(f[c>>2]|0)+(k<<2)>>2]|0;g=f[(f[a>>2]|0)+(k<<2)>>2]|0;m=f[(f[i>>2]|0)+(k<<2)>>2]|0;k=k+1|0;n=0;o=f[l>>2]|0;while(1){b[o>>0]=b[d+n>>0]|0;b[o+1>>0]=b[g+n>>0]|0;b[o+2>>0]=b[m+n>>0]|0;n=n+1|0;if((n|0)==(h|0))break;else o=o+3|0}if((e|0)<=1)break;else l=l+4|0}return}function iIa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=f[a+112>>2]|0;if((g|0)<=0)return;a=c+4|0;j=c+8|0;if(!i)return;else{k=g;l=d;m=e}while(1){e=k;k=k+-1|0;d=f[(f[c>>2]|0)+(l<<2)>>2]|0;g=f[(f[a>>2]|0)+(l<<2)>>2]|0;n=f[(f[j>>2]|0)+(l<<2)>>2]|0;l=l+1|0;o=0;p=f[m>>2]|0;while(1){q=b[g+o>>0]|0;r=q&255;s=h[n+o>>0]|0;b[p>>0]=(h[d+o>>0]|0)+128+r;b[p+1>>0]=q;b[p+2>>0]=r+128+s;o=o+1|0;if((o|0)==(i|0))break;else p=p+3|0}if((e|0)<=1)break;else m=m+4|0}return}function jIa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;i=f[a+480>>2]|0;j=f[a+112>>2]|0;k=f[a+336>>2]|0;a=f[i+8>>2]|0;l=f[i+12>>2]|0;m=f[i+16>>2]|0;n=f[i+20>>2]|0;if((g|0)<=0)return;i=c+4|0;o=c+8|0;p=c+12|0;if(!j)return;else{q=g;r=d;s=e}while(1){e=q;q=q+-1|0;d=f[(f[c>>2]|0)+(r<<2)>>2]|0;g=f[(f[i>>2]|0)+(r<<2)>>2]|0;t=f[(f[o>>2]|0)+(r<<2)>>2]|0;u=f[(f[p>>2]|0)+(r<<2)>>2]|0;r=r+1|0;v=0;w=f[s>>2]|0;while(1){x=h[g+v>>0]|0;y=h[t+v>>0]|0;z=~b[d+v>>0]&255;b[w>>0]=b[k+(z-(f[a+(y<<2)>>2]|0))>>0]|0;b[w+1>>0]=b[k+(z-((f[m+(y<<2)>>2]|0)+(f[n+(x<<2)>>2]|0)>>16))>>0]|0;b[w+2>>0]=b[k+(z-(f[l+(x<<2)>>2]|0))>>0]|0;b[w+3>>0]=b[u+v>>0]|0;v=v+1|0;if((v|0)==(j|0))break;else w=w+4|0}if((e|0)<=1)break;else s=s+4|0}return}function kIa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=f[a+36>>2]|0;i=f[a+112>>2]|0;if((g|0)<=0)return;a=(i|0)==0;if((h|0)>0){j=g;k=d;l=e}else return;while(1){e=j;j=j+-1|0;if(!a){d=0;do{g=0;m=f[(f[c+(d<<2)>>2]|0)+(k<<2)>>2]|0;n=(f[l>>2]|0)+d|0;while(1){b[n>>0]=b[m>>0]|0;g=g+1|0;if((g|0)==(i|0))break;else{m=m+1|0;n=n+h|0}}d=d+1|0}while((d|0)!=(h|0))}if((e|0)<=1)break;else{k=k+1|0;l=l+4|0}}return}function lIa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=a+4|0;c=ui[f[f[b>>2]>>2]&127](a,1,84)|0;f[a+472>>2]=c;f[c>>2]=1013;d=a+36|0;if((f[d>>2]|0)<=0)return;e=c+44|0;c=0;g=f[a+216>>2]|0;while(1){h=ui[f[f[b>>2]>>2]&127](a,1,256)|0;f[g+84>>2]=h;F1a(h|0,0,256)|0;f[e+(c<<2)>>2]=-1;c=c+1|0;if((c|0)>=(f[d>>2]|0))break;else g=g+88|0}return}function mIa(a){a=a|0;var b=0,c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0.0,u=0,v=0;b=f[a+472>>2]|0;c=a+36|0;if((f[c>>2]|0)<=0)return;e=a+72|0;g=0;h=f[a+216>>2]|0;i=0;k=0;while(1){l=f[h+36>>2]|0;m=h+40|0;a:do switch((l<<8)+(f[m>>2]|0)|0){case 257:{o=0;q=153;break}case 514:{o=0;q=154;break}case 771:{o=0;q=155;break}case 1028:{o=0;q=156;break}case 1285:{o=0;q=157;break}case 1542:{o=0;q=158;break}case 1799:{o=0;q=159;break}case 2313:{o=0;q=160;break}case 2570:{o=0;q=161;break}case 2827:{o=0;q=162;break}case 3084:{o=0;q=163;break}case 3341:{o=0;q=164;break}case 3598:{o=0;q=165;break}case 3855:{o=0;q=166;break}case 4112:{o=0;q=167;break}case 4104:{o=0;q=168;break}case 3591:{o=0;q=169;break}case 3078:{o=0;q=170;break}case 2565:{o=0;q=171;break}case 2052:{o=0;q=172;break}case 1539:{o=0;q=173;break}case 1026:{o=0;q=174;break}case 513:{o=0;q=175;break}case 2064:{o=0;q=176;break}case 1806:{o=0;q=177;break}case 1548:{o=0;q=178;break}case 1290:{o=0;q=179;break}case 1032:{o=0;q=180;break}case 774:{o=0;q=181;break}case 516:{o=0;q=182;break}case 258:{o=0;q=183;break}case 2056:{r=f[e>>2]|0;switch(r|0){case 0:{o=0;q=184;break a;break}case 1:{o=r;q=185;break a;break}case 2:{o=r;q=186;break a;break}default:{r=f[a>>2]|0;f[r+20>>2]=49;ki[f[r>>2]&2047](a);o=i;q=k;break a}}break}default:{r=f[a>>2]|0;f[r+20>>2]=7;f[r+24>>2]=l;f[r+28>>2]=f[m>>2];ki[f[r>>2]&2047](a);o=i;q=k}}while(0);f[b+4+(g<<2)>>2]=q;b:do if((f[h+52>>2]|0?(m=b+44+(g<<2)|0,(f[m>>2]|0)!=(o|0)):0)?(l=f[h+80>>2]|0,l|0):0){f[m>>2]=o;switch(o|0){case 0:{m=f[h+84>>2]|0;r=0;do{f[m+(r<<2)>>2]=j[l+(r<<1)>>1];r=r+1|0}while((r|0)!=64);break}case 1:{r=f[h+84>>2]|0;m=0;do{s=(Y(d[134434+(m<<1)>>1]|0,j[l+(m<<1)>>1]|0)|0)+2048>>12;f[r+(m<<2)>>2]=s;m=m+1|0}while((m|0)!=64);break}case 2:{m=f[h+84>>2]|0;r=0;s=0;while(1){t=+p[19944+(s<<3)>>3];n[m+(r<<2)>>2]=+(j[l+(r<<1)>>1]|0)*t*.125;u=r|1;n[m+(u<<2)>>2]=+(j[l+(u<<1)>>1]|0)*t*1.387039845*.125;v=u+1|0;n[m+(v<<2)>>2]=+(j[l+(v<<1)>>1]|0)*t*1.306562965*.125;v=r|3;n[m+(v<<2)>>2]=+(j[l+(v<<1)>>1]|0)*t*1.175875602*.125;u=v+1|0;n[m+(u<<2)>>2]=+(j[l+(u<<1)>>1]|0)*t*.125;u=v+2|0;n[m+(u<<2)>>2]=+(j[l+(u<<1)>>1]|0)*t*.785694958*.125;u=v+3|0;n[m+(u<<2)>>2]=+(j[l+(u<<1)>>1]|0)*t*.5411961*.125;u=r|7;n[m+(u<<2)>>2]=+(j[l+(u<<1)>>1]|0)*t*.275899379*.125;s=s+1|0;if((s|0)==8)break;else r=r+8|0}break}default:{r=f[a>>2]|0;f[r+20>>2]=49;ki[f[r>>2]&2047](a);break b}}}while(0);g=g+1|0;if((g|0)>=(f[c>>2]|0))break;else{h=h+88|0;i=o;k=q}}return}function nIa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+4|0;c=ui[f[f[b>>2]>>2]&127](a,1,216)|0;f[a+468>>2]=c;f[c>>2]=1014;if(!(f[a+224>>2]|0)){f[c+80>>2]=0;f[c+64>>2]=0;f[c+84>>2]=0;f[c+68>>2]=0;f[c+88>>2]=0;f[c+72>>2]=0;f[c+92>>2]=0;f[c+76>>2]=0;return}d=a+36|0;e=ui[f[f[b>>2]>>2]&127](a,1,f[d>>2]<<8)|0;f[a+160>>2]=e;if((f[d>>2]|0)>0){a=0;do{F1a(e+(a<<8)|0,-1,256)|0;a=a+1|0}while((a|0)<(f[d>>2]|0))}d=c+44|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;return}function oIa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=f[a+468>>2]|0;c=a+412|0;d=f[c>>2]|0;e=(d|0)==0;if(!(f[a+224>>2]|0)){if((e?(f[a+420>>2]|0)==0:0)?(f[a+424>>2]|0)==0:0){g=f[a+416>>2]|0;if((f[a+220>>2]|0)!=0|(g|0)<64?(g|0)!=(f[a+436>>2]|0):0)h=34}else h=34;if((h|0)==34){g=f[a>>2]|0;f[g+20>>2]=125;Gh[f[g+4>>2]&511](a,-1)}g=a+436|0;f[b+4>>2]=(f[g>>2]|0)!=63?194:193;i=a+340|0;if((f[i>>2]|0)>0){j=0;do{k=f[a+344+(j<<2)>>2]|0;l=f[k+20>>2]|0;tIa(a,1,l,b+64+(l<<2)|0);if(f[g>>2]|0){l=f[k+24>>2]|0;tIa(a,0,l,b+80+(l<<2)|0)}f[b+20+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[i>>2]|0))}i=a+368|0;if((f[i>>2]|0)>0)m=0;else{n=b+12|0;f[n>>2]=0;o=b+8|0;f[o>>2]=0;p=b+36|0;f[p>>2]=0;q=a+280|0;r=f[q>>2]|0;s=b+40|0;f[s>>2]=r;return}do{j=f[a+344+(f[a+372+(m<<2)>>2]<<2)>>2]|0;f[b+96+(m<<2)>>2]=f[b+64+(f[j+20>>2]<<2)>>2];f[b+136+(m<<2)>>2]=f[b+80+(f[j+24>>2]<<2)>>2];a:do if(!(f[j+52>>2]|0))t=0;else{l=f[j+40>>2]|0;k=f[j+36>>2]|0;switch(f[g>>2]|0){case 0:{t=1;break a;break}case 3:{u=121528+(((l|0)!=1&1)<<3)+(((k|0)!=1&1)<<2)|0;break}case 8:{v=l+-1|0;w=k+-1|0;u=121544+((v>>>0<2?v:2)*12|0)+((w>>>0<2?w:2)<<2)|0;break}case 15:{w=l+-1|0;v=k+-1|0;u=121580+((w>>>0<3?w:3)<<4)+((v>>>0<3?v:3)<<2)|0;break}case 24:{v=l+-1|0;w=k+-1|0;u=121644+((v>>>0<4?v:4)*20|0)+((w>>>0<4?w:4)<<2)|0;break}case 35:{w=l+-1|0;v=k+-1|0;u=121744+((w>>>0<5?w:5)*24|0)+((v>>>0<5?v:5)<<2)|0;break}case 48:{v=l+-1|0;w=k+-1|0;u=121888+((v>>>0<6?v:6)*28|0)+((w>>>0<6?w:6)<<2)|0;break}default:{w=l+-1|0;l=k+-1|0;u=122084+((w>>>0<7?w:7)<<5)+((l>>>0<7?l:7)<<2)|0}}t=(f[u>>2]|0)+1|0}while(0);f[b+176+(m<<2)>>2]=t;m=m+1|0}while((m|0)<(f[i>>2]|0));n=b+12|0;f[n>>2]=0;o=b+8|0;f[o>>2]=0;p=b+36|0;f[p>>2]=0;q=a+280|0;r=f[q>>2]|0;s=b+40|0;f[s>>2]=r;return}i=a+416|0;m=f[i>>2]|0;if(e)if(!m)h=7;else h=8;else if(((m|0)>=(d|0)?(m|0)<=(f[a+436>>2]|0):0)?(f[a+340>>2]|0)==1:0)h=7;else h=8;if((h|0)==7?(m=f[a+420>>2]|0,e=f[a+424>>2]|0,(e|0)>13|(m|0)!=0&(m+-1|0)!=(e|0)):0)h=8;if((h|0)==8){h=f[a>>2]|0;f[h+20>>2]=17;f[h+24>>2]=d;f[h+28>>2]=f[i>>2];f[h+32>>2]=f[a+420>>2];f[h+36>>2]=f[a+424>>2];ki[f[h>>2]&2047](a)}h=a+340|0;d=f[h>>2]|0;if((d|0)>0){e=a+160|0;m=a+420|0;t=a+424|0;u=0;do{g=f[(f[a+344+(u<<2)>>2]|0)+4>>2]|0;j=f[e>>2]|0;l=f[c>>2]|0;if(l)if((f[j+(g<<8)>>2]|0)<0){w=f[a>>2]|0;f[w+20>>2]=118;f[w+24>>2]=g;f[w+28>>2]=0;Gh[f[w+4>>2]&511](a,-1);x=f[c>>2]|0}else x=l;else x=0;if((x|0)<=(f[i>>2]|0)){l=x;while(1){w=j+(g<<8)+(l<<2)|0;k=f[w>>2]|0;if((f[m>>2]|0)!=(((k|0)>0?k:0)|0)){k=f[a>>2]|0;f[k+20>>2]=118;f[k+24>>2]=g;f[k+28>>2]=l;Gh[f[k+4>>2]&511](a,-1)}f[w>>2]=f[t>>2];if((l|0)<(f[i>>2]|0))l=l+1|0;else break}}u=u+1|0;l=f[h>>2]|0}while((u|0)<(l|0));y=l;z=m}else{y=d;z=a+420|0}d=f[c>>2]|0;m=(d|0)==0;f[b+4>>2]=(f[z>>2]|0)==0?(m?192:191):m?190:189;b:do if((y|0)>0){m=b+60|0;u=d;i=0;while(1){t=f[a+344+(i<<2)>>2]|0;if(!u){if(!(f[z>>2]|0)){x=f[t+20>>2]|0;tIa(a,1,x,b+44+(x<<2)|0)}}else{x=f[t+24>>2]|0;t=b+44+(x<<2)|0;tIa(a,0,x,t);f[m>>2]=f[t>>2]}f[b+20+(i<<2)>>2]=0;t=i+1|0;if((t|0)>=(f[h>>2]|0))break b;u=f[c>>2]|0;i=t}}while(0);f[b+16>>2]=0;n=b+12|0;f[n>>2]=0;o=b+8|0;f[o>>2]=0;p=b+36|0;f[p>>2]=0;q=a+280|0;r=f[q>>2]|0;s=b+40|0;f[s>>2]=r;return}function pIa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;c=u;u=u+32|0;e=c;g=f[a+468>>2]|0;h=1<<f[a+424>>2];i=a+280|0;if(f[i>>2]|0?(k=g+40|0,(f[k>>2]|0)==0):0){l=g+12|0;m=f[a+464>>2]|0;n=m+24|0;f[n>>2]=(f[n>>2]|0)+((f[l>>2]|0)/8|0);f[l>>2]=0;if(!(mi[f[m+8>>2]&255](a)|0)){o=0;u=c;return o|0}m=a+340|0;if((f[m>>2]|0)>0){l=0;do{f[g+20+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[m>>2]|0))}f[g+16>>2]=0;f[k>>2]=f[i>>2];if(!(f[a+440>>2]|0))f[g+36>>2]=0}f[e+16>>2]=a;i=a+24|0;k=f[i>>2]|0;m=f[k>>2]|0;f[e>>2]=m;l=f[k+4>>2]|0;n=e+4|0;f[n>>2]=l;p=g+8|0;q=f[p>>2]|0;r=g+12|0;s=f[r>>2]|0;t=a+368|0;do if((f[t>>2]|0)>0){a=e+8|0;v=e+12|0;w=s;x=0;y=q;while(1){z=f[b+(x<<2)>>2]|0;if((w|0)<1){if(!(wIa(e,y,w,1)|0)){o=0;A=18;break}B=f[v>>2]|0;C=f[a>>2]|0}else{B=w;C=y}w=B+-1|0;if(1<<w&C|0)d[z>>1]=j[z>>1]|0|h;x=x+1|0;if((x|0)>=(f[t>>2]|0)){A=16;break}else y=C}if((A|0)==16){D=f[e>>2]|0;E=f[i>>2]|0;F=f[n>>2]|0;G=w;H=C;break}else if((A|0)==18){u=c;return o|0}}else{D=m;E=k;F=l;G=s;H=q}while(0);f[E>>2]=D;f[E+4>>2]=F;f[p>>2]=H;f[r>>2]=G;G=g+40|0;f[G>>2]=(f[G>>2]|0)+-1;o=1;u=c;return o|0}function qIa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0;c=u;u=u+288|0;e=c+256|0;g=c;i=f[a+468>>2]|0;j=a+280|0;if(f[j>>2]|0?(k=i+40|0,(f[k>>2]|0)==0):0){l=i+12|0;m=f[a+464>>2]|0;n=m+24|0;f[n>>2]=(f[n>>2]|0)+((f[l>>2]|0)/8|0);f[l>>2]=0;if(!(mi[f[m+8>>2]&255](a)|0)){o=0;u=c;return o|0}m=a+340|0;if((f[m>>2]|0)>0){l=0;do{f[i+20+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[m>>2]|0))}f[i+16>>2]=0;f[k>>2]=f[j>>2];if(!(f[a+440>>2]|0))f[i+36>>2]=0}do if(!(f[i+36>>2]|0)){j=f[a+416>>2]|0;k=f[a+424>>2]|0;m=1<<k;l=-1<<k;k=f[a+432>>2]|0;f[e+16>>2]=a;n=a+24|0;p=f[n>>2]|0;f[e>>2]=f[p>>2];q=e+4|0;f[q>>2]=f[p+4>>2];p=i+8|0;r=f[p>>2]|0;s=i+12|0;t=f[s>>2]|0;v=i+16|0;w=f[v>>2]|0;x=f[b>>2]|0;y=f[i+60>>2]|0;z=f[a+412>>2]|0;A=e+8|0;B=e+12|0;a:do if(!w){C=t;D=r;E=z;F=0;b:while(1){if((C|0)<8){if(!(wIa(e,D,C,0)|0)){G=F;break a}H=f[A>>2]|0;I=f[B>>2]|0;if((I|0)<8){J=I;K=H;L=1;M=17}else{N=I;O=H;M=15}}else{N=C;O=D;M=15}if((M|0)==15){M=0;H=O>>N+-8&255;I=f[y+144+(H<<2)>>2]|0;if(!I){J=N;K=O;L=9;M=17}else{P=N-I|0;Q=O;R=h[y+1168+H>>0]|0}}if((M|0)==17){M=0;H=xIa(e,K,J,y,L)|0;if((H|0)<0){G=F;break a}P=f[B>>2]|0;Q=f[A>>2]|0;R=H}S=R>>4;switch(R&15){case 0:{if((S|0)==15){T=P;U=Q;V=15;W=0}else break b;break}case 1:{M=21;break}default:{H=f[a>>2]|0;f[H+20>>2]=121;Gh[f[H+4>>2]&511](a,-1);M=21}}if((M|0)==21){M=0;if((P|0)<1){if(!(wIa(e,Q,P,1)|0)){G=F;break a}X=f[B>>2]|0;Y=f[A>>2]|0}else{X=P;Y=Q}H=X+-1|0;T=H;U=Y;V=S;W=(1<<H&Y|0)==0?l:m}H=T;I=U;Z=E;_=V;while(1){$=x+(f[k+(Z<<2)>>2]<<1)|0;if(!(d[$>>1]|0))if((_|0)<1){aa=H;ba=I;ca=Z;break}else{da=H;ea=I;fa=_+-1|0}else{if((H|0)<1){if(!(wIa(e,I,H,1)|0)){G=F;break a}ga=f[B>>2]|0;ha=f[A>>2]|0}else{ga=H;ha=I}ia=ga+-1|0;if((1<<ia&ha|0)!=0?(ja=d[$>>1]|0,ka=ja<<16>>16,(ka&m|0)==0):0){d[$>>1]=(ja<<16>>16>-1?m:l)+ka;da=ia;ea=ha;fa=_}else{da=ia;ea=ha;fa=_}}ia=Z+1|0;if((Z|0)<(j|0)){H=da;I=ea;Z=ia;_=fa}else{aa=da;ba=ea;ca=ia;break}}if(!W)la=F;else{_=f[k+(ca<<2)>>2]|0;d[x+(_<<1)>>1]=W;f[g+(F<<2)>>2]=_;la=F+1|0}if((ca|0)<(j|0)){C=aa;D=ba;E=ca+1|0;F=la}else{ma=0;na=aa;oa=ba;M=54;break a}}D=1<<S;if(S){if((P|0)<(S|0)){if(!(wIa(e,Q,P,S)|0)){G=F;break}pa=f[B>>2]|0;qa=f[A>>2]|0}else{pa=P;qa=Q}C=pa-S|0;_=(qa>>C&f[122340+(S<<2)>>2])+D|0;if(!_){ma=0;na=C;oa=qa;M=54}else{ra=_;sa=C;ta=qa;ua=E;va=F;M=44}}else{ra=D;sa=P;ta=Q;ua=E;va=F;M=44}}else{ra=w;sa=t;ta=r;ua=z;va=0;M=44}while(0);c:do if((M|0)==44){z=sa;r=ta;t=ua;while(1){w=x+(f[k+(t<<2)>>2]<<1)|0;if(d[w>>1]|0){if((z|0)<1){if(!(wIa(e,r,z,1)|0)){G=va;break c}wa=f[B>>2]|0;xa=f[A>>2]|0}else{wa=z;xa=r}y=wa+-1|0;if((1<<y&xa|0)!=0?(D=d[w>>1]|0,C=D<<16>>16,(C&m|0)==0):0){d[w>>1]=(D<<16>>16>-1?m:l)+C;ya=y;za=xa}else{ya=y;za=xa}}else{ya=z;za=r}if((t|0)<(j|0)){z=ya;r=za;t=t+1|0}else break}ma=ra+-1|0;na=ya;oa=za;M=54}while(0);if((M|0)==54){j=f[n>>2]|0;f[j>>2]=f[e>>2];f[j+4>>2]=f[q>>2];f[p>>2]=oa;f[s>>2]=na;f[v>>2]=ma;break}if(!G){o=0;u=c;return o|0}else Aa=G;do{Aa=Aa+-1|0;d[x+(f[g+(Aa<<2)>>2]<<1)>>1]=0}while((Aa|0)!=0);o=0;u=c;return o|0}while(0);Aa=i+40|0;f[Aa>>2]=(f[Aa>>2]|0)+-1;o=1;u=c;return o|0}function rIa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;c=u;u=u+48|0;e=c+20|0;g=c;i=f[a+468>>2]|0;j=f[a+424>>2]|0;k=a+280|0;if(f[k>>2]|0?(l=i+40|0,(f[l>>2]|0)==0):0){m=i+12|0;n=f[a+464>>2]|0;o=n+24|0;f[o>>2]=(f[o>>2]|0)+((f[m>>2]|0)/8|0);f[m>>2]=0;if(!(mi[f[n+8>>2]&255](a)|0)){p=0;u=c;return p|0}n=a+340|0;if((f[n>>2]|0)>0){m=0;do{f[i+20+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[n>>2]|0))}f[i+16>>2]=0;f[l>>2]=f[k>>2];if(!(f[a+440>>2]|0))f[i+36>>2]=0}if(!(f[i+36>>2]|0)){f[e+16>>2]=a;k=a+24|0;l=f[k>>2]|0;n=f[l>>2]|0;f[e>>2]=n;m=f[l+4>>2]|0;o=e+4|0;f[o>>2]=m;q=i+8|0;r=f[q>>2]|0;s=i+12|0;t=f[s>>2]|0;v=i+16|0;f[g>>2]=f[v>>2];f[g+4>>2]=f[v+4>>2];f[g+8>>2]=f[v+8>>2];f[g+12>>2]=f[v+12>>2];f[g+16>>2]=f[v+16>>2];w=a+368|0;do if((f[w>>2]|0)>0){x=e+8|0;y=e+12|0;z=t;A=0;B=r;while(1){C=f[b+(A<<2)>>2]|0;D=f[a+372+(A<<2)>>2]|0;E=f[i+44+(f[(f[a+344+(D<<2)>>2]|0)+20>>2]<<2)>>2]|0;if((z|0)<8){if(!(wIa(e,B,z,0)|0)){p=0;F=27;break}G=f[x>>2]|0;H=f[y>>2]|0;if((H|0)<8){I=H;J=G;K=1;F=16}else{L=H;M=G;F=14}}else{L=z;M=B;F=14}if((F|0)==14){F=0;G=M>>L+-8&255;H=f[E+144+(G<<2)>>2]|0;if(!H){I=L;J=M;K=9;F=16}else{N=L-H|0;O=M;P=h[E+1168+G>>0]|0}}if((F|0)==16){F=0;G=xIa(e,J,I,E,K)|0;if((G|0)<0){p=0;F=27;break}N=f[y>>2]|0;O=f[x>>2]|0;P=G}if(!P){Q=N;R=O;S=0}else{if((N|0)<(P|0)){if(!(wIa(e,O,N,P)|0)){p=0;F=27;break}T=f[y>>2]|0;U=f[x>>2]|0}else{T=N;U=O}G=T-P|0;E=f[122340+(P<<2)>>2]|0;H=U>>G&E;Q=G;R=U;S=H-((H|0)>(f[122340+(P+-1<<2)>>2]|0)?0:E)|0}E=g+4+(D<<2)|0;D=(f[E>>2]|0)+S|0;f[E>>2]=D;d[C>>1]=D<<j;A=A+1|0;if((A|0)>=(f[w>>2]|0)){F=24;break}else{z=Q;B=R}}if((F|0)==24){V=f[e>>2]|0;W=f[k>>2]|0;X=f[o>>2]|0;Y=Q;Z=R;break}else if((F|0)==27){u=c;return p|0}}else{V=n;W=l;X=m;Y=t;Z=r}while(0);f[W>>2]=V;f[W+4>>2]=X;f[q>>2]=Z;f[s>>2]=Y;f[v>>2]=f[g>>2];f[v+4>>2]=f[g+4>>2];f[v+8>>2]=f[g+8>>2];f[v+12>>2]=f[g+12>>2];f[v+16>>2]=f[g+16>>2]}g=i+40|0;f[g>>2]=(f[g>>2]|0)+-1;p=1;u=c;return p|0}function sIa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;c=u;u=u+32|0;e=c;g=f[a+468>>2]|0;i=a+280|0;if(f[i>>2]|0?(j=g+40|0,(f[j>>2]|0)==0):0){k=g+12|0;l=f[a+464>>2]|0;m=l+24|0;f[m>>2]=(f[m>>2]|0)+((f[k>>2]|0)/8|0);f[k>>2]=0;if(!(mi[f[l+8>>2]&255](a)|0)){n=0;u=c;return n|0}l=a+340|0;if((f[l>>2]|0)>0){k=0;do{f[g+20+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[l>>2]|0))}f[g+16>>2]=0;f[j>>2]=f[i>>2];if(!(f[a+440>>2]|0))f[g+36>>2]=0}if(!(f[g+36>>2]|0)){i=f[a+416>>2]|0;j=f[a+424>>2]|0;l=f[a+432>>2]|0;k=g+16|0;m=f[k>>2]|0;if(!m){f[e+16>>2]=a;o=a+24|0;p=f[o>>2]|0;f[e>>2]=f[p>>2];q=e+4|0;f[q>>2]=f[p+4>>2];p=g+8|0;r=f[p>>2]|0;s=g+12|0;t=f[s>>2]|0;v=f[b>>2]|0;b=f[g+60>>2]|0;w=f[a+412>>2]|0;a:do if((w|0)<=(i|0)){a=e+8|0;x=e+12|0;y=t;z=r;A=w;b:while(1){if((y|0)<8){if(!(wIa(e,z,y,0)|0)){n=0;B=35;break}C=f[a>>2]|0;D=f[x>>2]|0;if((D|0)<8){E=D;F=C;G=1;B=18}else{H=D;I=C;B=16}}else{H=y;I=z;B=16}if((B|0)==16){B=0;C=I>>H+-8&255;D=f[b+144+(C<<2)>>2]|0;if(!D){E=H;F=I;G=9;B=18}else{J=H-D|0;K=I;L=h[b+1168+C>>0]|0}}if((B|0)==18){B=0;C=xIa(e,F,E,b,G)|0;if((C|0)<0){n=0;B=35;break}J=f[x>>2]|0;K=f[a>>2]|0;L=C}M=L>>4;C=L&15;if(!C){switch(M|0){case 0:{N=0;O=J;P=K;break a;break}case 15:break;default:{B=26;break b}}Q=J;R=K;S=A+15|0}else{D=M+A|0;if((J|0)<(C|0)){if(!(wIa(e,K,J,C)|0)){n=0;B=35;break}T=f[x>>2]|0;U=f[a>>2]|0}else{T=J;U=K}V=T-C|0;W=f[122340+(C<<2)>>2]|0;X=U>>V&W;d[v+(f[l+(D<<2)>>2]<<1)>>1]=X-((X|0)>(f[122340+(C+-1<<2)>>2]|0)?0:W)<<j;Q=V;R=U;S=D}if((S|0)<(i|0)){y=Q;z=R;A=S+1|0}else{N=0;O=Q;P=R;break a}}if((B|0)==26){A=1<<M;do if((J|0)<(M|0))if(!(wIa(e,K,J,M)|0)){n=0;u=c;return n|0}else{Y=f[x>>2]|0;Z=f[a>>2]|0;break}else{Y=J;Z=K}while(0);a=Y-M|0;N=A+-1+(Z>>a&f[122340+(M<<2)>>2])|0;O=a;P=Z;break}else if((B|0)==35){u=c;return n|0}}else{N=0;O=t;P=r}while(0);r=f[o>>2]|0;f[r>>2]=f[e>>2];f[r+4>>2]=f[q>>2];f[p>>2]=P;f[s>>2]=O;_=N}else _=m+-1|0;f[k>>2]=_}_=g+40|0;f[_>>2]=(f[_>>2]|0)+-1;n=1;u=c;return n|0}function tIa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=u;u=u+1296|0;i=g+1028|0;j=g;if(d>>>0>3){k=f[a>>2]|0;f[k+20>>2]=52;f[k+24>>2]=d;ki[f[k>>2]&2047](a)}k=(c|0)!=0;c=f[(k?a+180+(d<<2)|0:a+196+(d<<2)|0)>>2]|0;if(!c){l=f[a>>2]|0;f[l+20>>2]=52;f[l+24>>2]=d;ki[f[l>>2]&2047](a)}l=f[e>>2]|0;if(!l){d=ui[f[f[a+4>>2]>>2]&127](a,1,1424)|0;f[e>>2]=d;m=a;n=d}else{m=a;n=l}f[n+140>>2]=c;l=1;d=0;while(1){e=b[c+l>>0]|0;o=e&255;p=o+d|0;if((p|0)>256){q=f[a>>2]|0;f[q+20>>2]=9;ki[f[q>>2]&2047](m)}if(!(e<<24>>24))r=d;else{F1a(i+d|0,l&255|0,o|0)|0;r=p}l=l+1|0;if((l|0)==17)break;else d=r}b[i+r>>0]=0;d=b[i>>0]|0;if(!(d<<24>>24)){s=1;t=0}else{l=d;p=0;o=0;e=d<<24>>24;while(1){if((l<<24>>24|0)==(e|0)){d=p;q=o;while(1){v=q+1|0;f[j+(q<<2)>>2]=d;w=d+1|0;x=b[i+v>>0]|0;if((x<<24>>24|0)==(e|0)){d=w;q=v}else{y=x;z=w;A=v;break}}}else{y=l;z=p;A=o}if((z|0)>=(1<<e|0)){q=f[a>>2]|0;f[q+20>>2]=9;ki[f[q>>2]&2047](m)}if(!(y<<24>>24)){s=1;t=0;break}else{l=y;p=z<<1;o=A;e=e+1|0}}}while(1){e=c+s|0;if(!(b[e>>0]|0)){B=-1;C=t}else{f[n+72+(s<<2)>>2]=t-(f[j+(t<<2)>>2]|0);A=(h[e>>0]|0)+t|0;B=f[j+(A+-1<<2)>>2]|0;C=A}f[n+(s<<2)>>2]=B;s=s+1|0;if((s|0)==17)break;else t=C}f[n+68>>2]=1048575;F1a(n+144|0,0,1024)|0;C=1;t=0;while(1){s=c+C|0;if(!(b[s>>0]|0))D=t;else{B=8-C|0;A=1<<B;e=1;o=t;while(1){z=c+17+o|0;p=A;y=f[j+(o<<2)>>2]<<B;while(1){f[n+144+(y<<2)>>2]=C;b[n+1168+y>>0]=b[z>>0]|0;if((p|0)>1){p=p+-1|0;y=y+1|0}else break}y=o+1|0;if((e|0)<(h[s>>0]|0)){e=e+1|0;o=y}else{D=y;break}}}C=C+1|0;if((C|0)==9)break;else t=D}if(k&(r|0)>0)E=0;else{u=g;return}do{if((h[c+17+E>>0]|0)>15){k=f[a>>2]|0;f[k+20>>2]=9;ki[f[k>>2]&2047](m)}E=E+1|0}while((E|0)!=(r|0));u=g;return}function uIa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0;c=u;u=u+48|0;e=c+20|0;g=c;i=f[a+468>>2]|0;j=a+280|0;if(f[j>>2]|0?(k=i+40|0,(f[k>>2]|0)==0):0){l=i+12|0;m=f[a+464>>2]|0;n=m+24|0;f[n>>2]=(f[n>>2]|0)+((f[l>>2]|0)/8|0);f[l>>2]=0;if(!(mi[f[m+8>>2]&255](a)|0)){o=0;u=c;return o|0}m=a+340|0;if((f[m>>2]|0)>0){l=0;do{f[i+20+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[m>>2]|0))}f[i+16>>2]=0;f[k>>2]=f[j>>2];if(!(f[a+440>>2]|0))f[i+36>>2]=0}if(!(f[i+36>>2]|0)){j=f[a+432>>2]|0;k=f[a+436>>2]|0;f[e+16>>2]=a;m=a+24|0;l=f[m>>2]|0;n=f[l>>2]|0;f[e>>2]=n;p=f[l+4>>2]|0;q=e+4|0;f[q>>2]=p;r=i+8|0;s=f[r>>2]|0;t=i+12|0;v=f[t>>2]|0;w=i+16|0;f[g>>2]=f[w>>2];f[g+4>>2]=f[w+4>>2];f[g+8>>2]=f[w+8>>2];f[g+12>>2]=f[w+12>>2];f[g+16>>2]=f[w+16>>2];x=a+368|0;do if((f[x>>2]|0)>0){y=e+8|0;z=e+12|0;A=v;B=0;C=s;a:while(1){D=f[b+(B<<2)>>2]|0;E=f[i+96+(B<<2)>>2]|0;if((A|0)<8){if(!(wIa(e,C,A,0)|0)){o=0;F=64;break}G=f[y>>2]|0;H=f[z>>2]|0;if((H|0)<8){I=H;J=G;K=1;F=16}else{L=H;M=G;F=14}}else{L=A;M=C;F=14}if((F|0)==14){F=0;G=M>>L+-8&255;H=f[E+144+(G<<2)>>2]|0;if(!H){I=L;J=M;K=9;F=16}else{N=L-H|0;O=M;P=h[E+1168+G>>0]|0}}if((F|0)==16){F=0;G=xIa(e,J,I,E,K)|0;if((G|0)<0){o=0;F=64;break}N=f[z>>2]|0;O=f[y>>2]|0;P=G}G=f[i+136+(B<<2)>>2]|0;E=f[i+176+(B<<2)>>2]|0;H=(P|0)!=0;b:do if(!E)if(H){if((N|0)<(P|0)){if(!(wIa(e,O,N,P)|0)){o=0;F=64;break a}Q=f[z>>2]|0;R=f[y>>2]|0}else{Q=N;R=O}S=Q-P|0;T=R;U=1;F=45}else{S=N;T=O;U=1;F=45}else{if(H){if((N|0)<(P|0)){if(!(wIa(e,O,N,P)|0)){o=0;F=64;break a}V=f[z>>2]|0;W=f[y>>2]|0}else{V=N;W=O}X=V-P|0;Y=f[122340+(P<<2)>>2]|0;Z=W>>X&Y;_=X;$=W;aa=Z-((Z|0)>(f[122340+(P+-1<<2)>>2]|0)?0:Y)|0}else{_=N;$=O;aa=0}Y=g+4+(f[a+372+(B<<2)>>2]<<2)|0;Z=(f[Y>>2]|0)+aa|0;f[Y>>2]=Z;d[D>>1]=Z;if((E|0)>1){Z=_;Y=$;X=1;while(1){if((Z|0)<8){if(!(wIa(e,Y,Z,0)|0)){o=0;F=64;break a}ba=f[y>>2]|0;ca=f[z>>2]|0;if((ca|0)<8){da=ca;ea=ba;fa=1;F=30}else{ga=ca;ha=ba;F=28}}else{ga=Z;ha=Y;F=28}if((F|0)==28){F=0;ba=ha>>ga+-8&255;ca=f[G+144+(ba<<2)>>2]|0;if(!ca){da=ga;ea=ha;fa=9;F=30}else{ia=ga-ca|0;ja=ha;ka=h[G+1168+ba>>0]|0}}if((F|0)==30){F=0;ba=xIa(e,ea,da,G,fa)|0;if((ba|0)<0){o=0;F=64;break a}ia=f[z>>2]|0;ja=f[y>>2]|0;ka=ba}ba=ka>>4;ca=ka&15;if(!ca){if((ba|0)!=15){la=ia;ma=ja;break b}na=ia;oa=ja;pa=X+15|0}else{qa=ba+X|0;if((ia|0)<(ca|0)){if(!(wIa(e,ja,ia,ca)|0)){o=0;F=64;break a}ra=f[z>>2]|0;sa=f[y>>2]|0}else{ra=ia;sa=ja}ba=ra-ca|0;ta=f[122340+(ca<<2)>>2]|0;ua=sa>>ba&ta;d[D+(f[j+(qa<<2)>>2]<<1)>>1]=ua-((ua|0)>(f[122340+(ca+-1<<2)>>2]|0)?0:ta);na=ba;oa=sa;pa=qa}qa=pa+1|0;if((qa|0)<(E|0)){Z=na;Y=oa;X=qa}else{S=na;T=oa;U=qa;F=45;break}}}else{S=_;T=$;U=1;F=45}}while(0);c:do if((F|0)==45){F=0;if((U|0)>(k|0)){la=S;ma=T}else{E=S;D=T;H=U;while(1){if((E|0)<8){if(!(wIa(e,D,E,0)|0)){o=0;F=64;break a}X=f[y>>2]|0;Y=f[z>>2]|0;if((Y|0)<8){va=Y;wa=X;xa=1;F=51}else{ya=Y;za=X;F=49}}else{ya=E;za=D;F=49}if((F|0)==49){F=0;X=za>>ya+-8&255;Y=f[G+144+(X<<2)>>2]|0;if(!Y){va=ya;wa=za;xa=9;F=51}else{Aa=ya-Y|0;Ba=za;Ca=h[G+1168+X>>0]|0}}if((F|0)==51){F=0;X=xIa(e,wa,va,G,xa)|0;if((X|0)<0){o=0;F=64;break a}Aa=f[z>>2]|0;Ba=f[y>>2]|0;Ca=X}X=Ca>>4;Y=Ca&15;if(!Y)if((X|0)==15){Da=Aa;Ea=Ba;Fa=15}else{la=Aa;ma=Ba;break c}else{if((Aa|0)<(Y|0)){if(!(wIa(e,Ba,Aa,Y)|0)){o=0;F=64;break a}Ga=f[z>>2]|0;Ha=f[y>>2]|0}else{Ga=Aa;Ha=Ba}Da=Ga-Y|0;Ea=Ha;Fa=X}H=H+1+Fa|0;if((H|0)>(k|0)){la=Da;ma=Ea;break}else{E=Da;D=Ea}}}}while(0);B=B+1|0;if((B|0)>=(f[x>>2]|0)){F=61;break}else{A=la;C=ma}}if((F|0)==61){Ia=f[e>>2]|0;Ja=f[m>>2]|0;Ka=f[q>>2]|0;La=la;Ma=ma;break}else if((F|0)==64){u=c;return o|0}}else{Ia=n;Ja=l;Ka=p;La=v;Ma=s}while(0);f[Ja>>2]=Ia;f[Ja+4>>2]=Ka;f[r>>2]=Ma;f[t>>2]=La;f[w>>2]=f[g>>2];f[w+4>>2]=f[g+4>>2];f[w+8>>2]=f[g+8>>2];f[w+12>>2]=f[g+12>>2];f[w+16>>2]=f[g+16>>2]}g=i+40|0;f[g>>2]=(f[g>>2]|0)+-1;o=1;u=c;return o|0}function vIa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0;c=u;u=u+48|0;e=c+20|0;g=c;i=f[a+468>>2]|0;j=a+280|0;if(f[j>>2]|0?(k=i+40|0,(f[k>>2]|0)==0):0){l=i+12|0;m=f[a+464>>2]|0;n=m+24|0;f[n>>2]=(f[n>>2]|0)+((f[l>>2]|0)/8|0);f[l>>2]=0;if(!(mi[f[m+8>>2]&255](a)|0)){o=0;u=c;return o|0}m=a+340|0;if((f[m>>2]|0)>0){l=0;do{f[i+20+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[m>>2]|0))}f[i+16>>2]=0;f[k>>2]=f[j>>2];if(!(f[a+440>>2]|0))f[i+36>>2]=0}if(!(f[i+36>>2]|0)){f[e+16>>2]=a;j=a+24|0;k=f[j>>2]|0;m=f[k>>2]|0;f[e>>2]=m;l=f[k+4>>2]|0;n=e+4|0;f[n>>2]=l;p=i+8|0;q=f[p>>2]|0;r=i+12|0;s=f[r>>2]|0;t=i+16|0;f[g>>2]=f[t>>2];f[g+4>>2]=f[t+4>>2];f[g+8>>2]=f[t+8>>2];f[g+12>>2]=f[t+12>>2];f[g+16>>2]=f[t+16>>2];v=a+368|0;do if((f[v>>2]|0)>0){w=e+8|0;x=e+12|0;y=s;z=0;A=q;a:while(1){B=f[b+(z<<2)>>2]|0;C=f[i+96+(z<<2)>>2]|0;if((y|0)<8){if(!(wIa(e,A,y,0)|0)){o=0;D=64;break}E=f[w>>2]|0;F=f[x>>2]|0;if((F|0)<8){G=F;H=E;I=1;D=16}else{J=F;K=E;D=14}}else{J=y;K=A;D=14}if((D|0)==14){D=0;E=K>>J+-8&255;F=f[C+144+(E<<2)>>2]|0;if(!F){G=J;H=K;I=9;D=16}else{L=J-F|0;M=K;N=h[C+1168+E>>0]|0}}if((D|0)==16){D=0;E=xIa(e,H,G,C,I)|0;if((E|0)<0){o=0;D=64;break}L=f[x>>2]|0;M=f[w>>2]|0;N=E}E=f[i+136+(z<<2)>>2]|0;C=f[i+176+(z<<2)>>2]|0;F=(N|0)!=0;b:do if(!C)if(F){if((L|0)<(N|0)){if(!(wIa(e,M,L,N)|0)){o=0;D=64;break a}O=f[x>>2]|0;P=f[w>>2]|0}else{O=L;P=M}Q=O-N|0;R=P;S=1;D=46}else{Q=L;R=M;S=1;D=46}else{if(F){if((L|0)<(N|0)){if(!(wIa(e,M,L,N)|0)){o=0;D=64;break a}T=f[x>>2]|0;U=f[w>>2]|0}else{T=L;U=M}V=T-N|0;W=f[122340+(N<<2)>>2]|0;X=U>>V&W;Y=V;Z=U;_=X-((X|0)>(f[122340+(N+-1<<2)>>2]|0)?0:W)|0}else{Y=L;Z=M;_=0}W=g+4+(f[a+372+(z<<2)>>2]<<2)|0;X=(f[W>>2]|0)+_|0;f[W>>2]=X;d[B>>1]=X;if((C|0)>1){X=Y;W=Z;V=1;while(1){if((X|0)<8){if(!(wIa(e,W,X,0)|0)){o=0;D=64;break a}$=f[w>>2]|0;aa=f[x>>2]|0;if((aa|0)<8){ba=aa;ca=$;da=1;D=30}else{ea=aa;fa=$;D=28}}else{ea=X;fa=W;D=28}if((D|0)==28){D=0;$=fa>>ea+-8&255;aa=f[E+144+($<<2)>>2]|0;if(!aa){ba=ea;ca=fa;da=9;D=30}else{ga=ea-aa|0;ha=fa;ia=h[E+1168+$>>0]|0}}if((D|0)==30){D=0;$=xIa(e,ca,ba,E,da)|0;if(($|0)<0){o=0;D=64;break a}ga=f[x>>2]|0;ha=f[w>>2]|0;ia=$}$=ia>>4;aa=ia&15;if(!aa){if(($|0)!=15){ja=ga;ka=ha;break b}la=ga;ma=ha;na=V+15|0}else{oa=$+V|0;if((ga|0)<(aa|0)){if(!(wIa(e,ha,ga,aa)|0)){o=0;D=64;break a}pa=f[x>>2]|0;qa=f[w>>2]|0}else{pa=ga;qa=ha}$=pa-aa|0;ra=f[122340+(aa<<2)>>2]|0;sa=qa>>$&ra;d[B+(f[120268+(oa<<2)>>2]<<1)>>1]=sa-((sa|0)>(f[122340+(aa+-1<<2)>>2]|0)?0:ra);la=$;ma=qa;na=oa}V=na+1|0;if((V|0)>=(C|0))break;else{X=la;W=ma}}if((V|0)<64){Q=la;R=ma;S=V;D=46}else{ja=la;ka=ma}}else{Q=Y;R=Z;S=1;D=46}}while(0);c:do if((D|0)==46)while(1){D=0;if((Q|0)<8){if(!(wIa(e,R,Q,0)|0)){o=0;D=64;break a}C=f[w>>2]|0;B=f[x>>2]|0;if((B|0)<8){ta=B;ua=C;va=1;D=51}else{wa=B;xa=C;D=49}}else{wa=Q;xa=R;D=49}if((D|0)==49){D=0;C=xa>>wa+-8&255;B=f[E+144+(C<<2)>>2]|0;if(!B){ta=wa;ua=xa;va=9;D=51}else{ya=wa-B|0;za=xa;Aa=h[E+1168+C>>0]|0}}if((D|0)==51){D=0;C=xIa(e,ua,ta,E,va)|0;if((C|0)<0){o=0;D=64;break a}ya=f[x>>2]|0;za=f[w>>2]|0;Aa=C}C=Aa>>4;B=Aa&15;if(!B)if((C|0)==15){Ba=ya;Ca=za;Da=15}else{ja=ya;ka=za;break c}else{if((ya|0)<(B|0)){if(!(wIa(e,za,ya,B)|0)){o=0;D=64;break a}Ea=f[x>>2]|0;Fa=f[w>>2]|0}else{Ea=ya;Fa=za}Ba=Ea-B|0;Ca=Fa;Da=C}S=S+1+Da|0;if((S|0)>=64){ja=Ba;ka=Ca;break}else{Q=Ba;R=Ca;D=46}}while(0);z=z+1|0;if((z|0)>=(f[v>>2]|0)){D=61;break}else{y=ja;A=ka}}if((D|0)==61){Ga=f[e>>2]|0;Ha=f[j>>2]|0;Ia=f[n>>2]|0;Ja=ja;Ka=ka;break}else if((D|0)==64){u=c;return o|0}}else{Ga=m;Ha=k;Ia=l;Ja=s;Ka=q}while(0);f[Ha>>2]=Ga;f[Ha+4>>2]=Ia;f[p>>2]=Ka;f[r>>2]=Ja;f[t>>2]=f[g>>2];f[t+4>>2]=f[g+4>>2];f[t+8>>2]=f[g+8>>2];f[t+12>>2]=f[g+12>>2];f[t+16>>2]=f[g+16>>2]}g=i+40|0;f[g>>2]=(f[g>>2]|0)+-1;o=1;u=c;return o|0}function wIa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;g=f[a>>2]|0;h=a+4|0;i=f[h>>2]|0;j=f[a+16>>2]|0;k=j+440|0;a:do if(!(f[k>>2]|0))if((d|0)<25){l=j+24|0;m=d;n=i;o=c;p=g;b:while(1){if(!n){if(!(mi[f[(f[l>>2]|0)+12>>2]&255](j)|0)){q=0;r=19;break}s=f[l>>2]|0;t=f[s+4>>2]|0;u=f[s>>2]|0}else{t=n;u=p}s=t+-1|0;v=u+1|0;w=b[u>>0]|0;x=w&255;c:do if(w<<24>>24==-1){y=s;z=v;while(1){if(!y){if(!(mi[f[(f[l>>2]|0)+12>>2]&255](j)|0)){q=0;r=19;break b}A=f[l>>2]|0;B=f[A+4>>2]|0;C=f[A>>2]|0}else{B=y;C=z}D=B+-1|0;E=C+1|0;F=b[C>>0]|0;switch(F<<24>>24){case 0:{G=D;H=255;I=E;break c;break}case -1:{y=D;z=E;break}default:{r=13;break b}}}}else{G=s;H=x;I=v}while(0);v=H|o<<8;x=m+8|0;if((x|0)<25){m=x;n=G;o=v;p=I}else{J=x;K=G;L=v;M=I;break a}}if((r|0)==13){f[k>>2]=F&255;N=m;O=D;P=o;Q=E;r=14;break}else if((r|0)==19)return q|0}else{J=d;K=i;L=c;M=g}else{N=d;O=i;P=c;Q=g;r=14}while(0);if((r|0)==14)if((N|0)<(e|0)){e=j+468|0;if(!(f[(f[e>>2]|0)+36>>2]|0)){r=f[j>>2]|0;f[r+20>>2]=120;Gh[f[r+4>>2]&511](j,-1);f[(f[e>>2]|0)+36>>2]=1}J=25;K=O;L=P<<25-N;M=Q}else{J=N;K=O;L=P;M=Q}f[a>>2]=M;f[h>>2]=K;f[a+8>>2]=L;f[a+12>>2]=J;q=1;return q|0}function xIa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;do if((c|0)<(e|0))if(!(wIa(a,b,c,e)|0)){g=-1;return g|0}else{i=f[a+12>>2]|0;j=f[a+8>>2]|0;break}else{i=c;j=b}while(0);b=i-e|0;i=j>>b&f[122340+(e<<2)>>2];c=a+8|0;k=a+12|0;a:do if((i|0)>(f[d+(e<<2)>>2]|0)){l=b;m=i;n=j;o=e;while(1){p=m<<1;if((l|0)<1){if(!(wIa(a,n,l,1)|0)){g=-1;break}q=f[k>>2]|0;r=f[c>>2]|0}else{q=l;r=n}s=q+-1|0;t=r>>>s&1|p;p=o+1|0;if((t|0)>(f[d+(p<<2)>>2]|0)){l=s;m=t;n=r;o=p}else{u=s;v=t;w=r;x=p;break a}}return g|0}else{u=b;v=i;w=j;x=e}while(0);f[c>>2]=w;f[k>>2]=u;if((x|0)>16){u=f[a+16>>2]|0;a=f[u>>2]|0;f[a+20>>2]=121;Gh[f[a+4>>2]&511](u,-1);g=0;return g|0}else{g=h[(f[d+72+(x<<2)>>2]|0)+v+((f[d+140>>2]|0)+17)>>0]|0;return g|0}return 0}function yIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+4|0;d=ui[f[f[c>>2]>>2]&127](a,1,80)|0;e=a+448|0;f[e>>2]=d;f[d>>2]=401;if(b|0){b=f[a>>2]|0;f[b+20>>2]=3;ki[f[b>>2]&2047](a)}b=a+328|0;g=f[b>>2]|0;if(!(f[(f[a+476>>2]|0)+8>>2]|0)){h=a+36|0;i=f[h>>2]|0;j=g;k=g;l=h}else{if((g|0)<2){h=f[a>>2]|0;f[h+20>>2]=48;ki[f[h>>2]&2047](a);m=f[b>>2]|0}else m=g;g=f[e>>2]|0;e=a+36|0;h=ui[f[f[c>>2]>>2]&127](a,1,f[e>>2]<<3)|0;n=g+56|0;f[n>>2]=h;o=f[e>>2]|0;p=g+60|0;f[p>>2]=h+(o<<2);if((o|0)>0){h=m+4|0;m=0;g=f[a+216>>2]|0;while(1){q=Y(f[g+40>>2]|0,f[g+12>>2]|0)|0;r=(q|0)/(f[b>>2]|0)|0;q=Y(r,h)|0;s=(ui[f[f[c>>2]>>2]&127](a,1,q<<3)|0)+(r<<2)|0;f[(f[n>>2]|0)+(m<<2)>>2]=s;f[(f[p>>2]|0)+(m<<2)>>2]=s+(q<<2);m=m+1|0;q=f[e>>2]|0;if((m|0)>=(q|0)){t=q;break}else g=g+88|0}}else t=o;o=f[b>>2]|0;i=t;j=o;k=o+2|0;l=e}if((i|0)<=0)return;i=d+8|0;d=j;j=0;e=f[a+216>>2]|0;while(1){o=(Y(f[e+40>>2]|0,f[e+12>>2]|0)|0)/(d|0)|0;t=Y(f[e+36>>2]|0,f[e+28>>2]|0)|0;g=Y(o,k)|0;o=Jg[f[(f[c>>2]|0)+8>>2]&63](a,1,t,g)|0;f[i+(j<<2)>>2]=o;o=j+1|0;if((o|0)>=(f[l>>2]|0))break;d=f[b>>2]|0;j=o;e=e+88|0}return}function zIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=f[a+448>>2]|0;switch(b|0){case 0:{b=c+4|0;if(!(f[(f[a+476>>2]|0)+8>>2]|0))f[b>>2]=181;else{f[b>>2]=180;b=f[a+328>>2]|0;d=f[a+36>>2]|0;if((d|0)>0){e=c+56|0;g=c+60|0;h=b+2|0;i=b+-2|0;j=0;k=f[a+216>>2]|0;while(1){l=(Y(f[k+40>>2]|0,f[k+12>>2]|0)|0)/(b|0)|0;m=f[(f[e>>2]|0)+(j<<2)>>2]|0;n=f[(f[g>>2]|0)+(j<<2)>>2]|0;o=f[c+8+(j<<2)>>2]|0;p=Y(l,h)|0;if((p|0)>0){q=0;do{r=f[o+(q<<2)>>2]|0;f[n+(q<<2)>>2]=r;f[m+(q<<2)>>2]=r;q=q+1|0}while((q|0)!=(p|0))}p=l<<1;if((l|0)>0){q=Y(l,b)|0;r=Y(l,i)|0;s=0;do{t=s+q|0;u=s+r|0;f[n+(u<<2)>>2]=f[o+(t<<2)>>2];f[n+(t<<2)>>2]=f[o+(u<<2)>>2];s=s+1|0}while((s|0)<(p|0));p=0;do{f[m+(p-l<<2)>>2]=f[m>>2];p=p+1|0}while((p|0)!=(l|0))}j=j+1|0;if((j|0)==(d|0))break;else k=k+88|0}}f[c+64>>2]=0;f[c+68>>2]=0;f[c+76>>2]=0}f[c+48>>2]=0;f[c+52>>2]=0;return}case 2:{f[c+4>>2]=182;return}default:{c=f[a>>2]|0;f[c+20>>2]=3;ki[f[c>>2]&2047](a);return}}}function AIa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=a+448|0;g=f[e>>2]|0;h=g+48|0;do if(!(f[h>>2]|0))if(!($h[f[(f[a+452>>2]|0)+12>>2]&255](a,f[g+56+(f[g+64>>2]<<2)>>2]|0)|0))return;else{f[h>>2]=1;i=g+76|0;f[i>>2]=(f[i>>2]|0)+1;break}while(0);i=g+68|0;switch(f[i>>2]|0){case 2:{j=g+52|0;k=g+72|0;Xh[f[(f[a+456>>2]|0)+4>>2]&127](a,f[g+56+(f[g+64>>2]<<2)>>2]|0,j,f[k>>2]|0,b,c,d);if((f[j>>2]|0)>>>0<(f[k>>2]|0)>>>0)return;f[i>>2]=0;if((f[c>>2]|0)>>>0<d>>>0){l=j;m=k;n=9}else return;break}case 0:{l=g+52|0;m=g+72|0;n=9;break}case 1:{o=g+52|0;p=g+72|0;break}default:return}if((n|0)==9){f[l>>2]=0;n=f[a+328>>2]|0;f[m>>2]=n+-1;if((f[g+76>>2]|0)==(f[a+332>>2]|0)?(k=f[e>>2]|0,j=f[a+36>>2]|0,(j|0)>0):0){q=k+72|0;r=k+64|0;s=0;t=f[a+216>>2]|0;while(1){u=Y(f[t+40>>2]|0,f[t+12>>2]|0)|0;v=(u|0)/(n|0)|0;w=((f[t+48>>2]|0)>>>0)%(u>>>0)|0;x=(w|0)==0?u:w;if(!s)f[q>>2]=((x+-1|0)/(v|0)|0)+1;w=f[(f[k+56+(f[r>>2]<<2)>>2]|0)+(s<<2)>>2]|0;u=v<<1;if((v|0)>0){v=w+(x+-1<<2)|0;y=0;do{f[w+(y+x<<2)>>2]=f[v>>2];y=y+1|0}while((y|0)<(u|0))}s=s+1|0;if((s|0)==(j|0))break;else t=t+88|0}}f[i>>2]=1;o=l;p=m}m=g+64|0;Xh[f[(f[a+456>>2]|0)+4>>2]&127](a,f[g+56+(f[m>>2]<<2)>>2]|0,o,f[p>>2]|0,b,c,d);if((f[o>>2]|0)>>>0<(f[p>>2]|0)>>>0)return;if((f[g+76>>2]|0)==1){g=f[e>>2]|0;e=f[a+328>>2]|0;d=f[a+36>>2]|0;if((d|0)>0){c=g+56|0;b=g+60|0;g=e+1|0;l=e+2|0;t=0;j=f[a+216>>2]|0;while(1){s=(Y(f[j+40>>2]|0,f[j+12>>2]|0)|0)/(e|0)|0;r=f[(f[c>>2]|0)+(t<<2)>>2]|0;k=f[(f[b>>2]|0)+(t<<2)>>2]|0;if((s|0)>0){q=Y(s,g)|0;n=Y(s,l)|0;u=0;do{y=u+q|0;v=u-s|0;f[r+(v<<2)>>2]=f[r+(y<<2)>>2];f[k+(v<<2)>>2]=f[k+(y<<2)>>2];y=u+n|0;f[r+(y<<2)>>2]=f[r+(u<<2)>>2];f[k+(y<<2)>>2]=f[k+(u<<2)>>2];u=u+1|0}while((u|0)!=(s|0))}t=t+1|0;if((t|0)==(d|0)){z=e;break}else j=j+88|0}}else z=e}else z=f[a+328>>2]|0;f[m>>2]=f[m>>2]^1;f[h>>2]=0;f[o>>2]=z+1;f[p>>2]=z+2;f[i>>2]=2;return}function BIa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=f[a+448>>2]|0;g=e+48|0;do if(!(f[g>>2]|0)){h=e+8|0;if(!($h[f[(f[a+452>>2]|0)+12>>2]&255](a,h)|0))return;else{f[g>>2]=1;i=h;break}}else i=e+8|0;while(0);h=f[a+328>>2]|0;j=e+52|0;Xh[f[(f[a+456>>2]|0)+4>>2]&127](a,i,j,h,b,c,d);if((f[j>>2]|0)>>>0<h>>>0)return;f[g>>2]=0;f[j>>2]=0;return}function CIa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Xh[f[(f[a+456>>2]|0)+4>>2]&127](a,0,0,0,b,c,d);return}function DIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0.0,l=0,m=0.0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0;d=0;e=a;while(1){g=(f[b+(d<<2)>>2]|0)+c|0;i=h[g>>0]|0;j=h[g+7>>0]|0;k=+(j+i|0);l=i-j|0;m=+(l|0);j=h[g+1>>0]|0;i=h[g+6>>0]|0;o=+(i+j|0);p=j-i|0;i=h[g+2>>0]|0;j=h[g+5>>0]|0;q=+(j+i|0);r=i-j|0;j=h[g+3>>0]|0;i=h[g+4>>0]|0;s=+(i+j|0);t=k+s;u=k-s;s=o+q;n[e>>2]=s+t+-1024.0;n[e+16>>2]=t-s;s=(o-q+u)*.7071067690849304;n[e+8>>2]=u+s;n[e+24>>2]=u-s;s=+(r+j-i|0);u=+(p+l|0);q=(s-u)*.3826834261417389;o=s*.5411961078643799+q;s=u*1.3065630197525024+q;q=+(r+p|0)*.7071067690849304;u=m+q;t=m-q;n[e+20>>2]=t+o;n[e+12>>2]=t-o;n[e+4>>2]=u+s;n[e+28>>2]=u-s;d=d+1|0;if((d|0)==8){v=7;w=a;break}else e=e+32|0}while(1){s=+n[w>>2];e=w+224|0;u=+n[e>>2];o=s+u;t=s-u;a=w+32|0;u=+n[a>>2];d=w+192|0;s=+n[d>>2];q=u+s;m=u-s;c=w+64|0;s=+n[c>>2];b=w+160|0;u=+n[b>>2];k=s+u;x=s-u;p=w+96|0;u=+n[p>>2];r=w+128|0;s=+n[r>>2];y=u+s;z=o+y;A=o-y;y=q+k;n[w>>2]=y+z;n[r>>2]=z-y;y=(q-k+A)*.7071067690849304;n[c>>2]=A+y;n[d>>2]=A-y;y=x+(u-s);s=t+m;u=(y-s)*.3826834261417389;A=y*.5411961078643799+u;y=s*1.3065630197525024+u;u=(m+x)*.7071067690849304;x=t+u;m=t-u;n[b>>2]=m+A;n[p>>2]=m-A;n[a>>2]=x+y;n[e>>2]=x-y;if((v|0)>0){v=v+-1|0;w=w+4|0}else break}return}function EIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=0;e=a;while(1){g=(f[b+(d<<2)>>2]|0)+c|0;i=h[g>>0]|0;j=h[g+7>>0]|0;k=j+i|0;l=i-j|0;j=h[g+1>>0]|0;i=h[g+6>>0]|0;m=i+j|0;n=j-i|0;i=h[g+2>>0]|0;j=h[g+5>>0]|0;o=j+i|0;p=i-j|0;j=h[g+3>>0]|0;i=h[g+4>>0]|0;g=i+j|0;q=g+k|0;r=k-g|0;g=o+m|0;f[e>>2]=(g|-1024)+q;f[e+16>>2]=q-g;g=(m-o+r|0)*181>>8;f[e+8>>2]=g+r;f[e+24>>2]=r-g;g=j-i+p|0;i=n+l|0;j=(g-i|0)*98>>8;r=j+(g*139>>8)|0;g=j+(i*334>>8)|0;i=(p+n|0)*181>>8;n=i+l|0;p=l-i|0;f[e+20>>2]=r+p;f[e+12>>2]=p-r;f[e+4>>2]=g+n;f[e+28>>2]=n-g;d=d+1|0;if((d|0)==8){s=7;t=a;break}else e=e+32|0}while(1){e=f[t>>2]|0;a=t+224|0;d=f[a>>2]|0;c=d+e|0;b=e-d|0;d=t+32|0;e=f[d>>2]|0;g=t+192|0;n=f[g>>2]|0;r=n+e|0;p=e-n|0;n=t+64|0;e=f[n>>2]|0;i=t+160|0;l=f[i>>2]|0;j=l+e|0;o=e-l|0;l=t+96|0;e=f[l>>2]|0;m=t+128|0;q=f[m>>2]|0;k=q+e|0;u=k+c|0;v=c-k|0;k=j+r|0;f[t>>2]=u+k;f[m>>2]=u-k;k=(r-j+v|0)*181>>8;f[n>>2]=k+v;f[g>>2]=v-k;k=e-q+o|0;q=p+b|0;e=(k-q|0)*98>>8;v=e+(k*139>>8)|0;k=e+(q*334>>8)|0;q=(o+p|0)*181>>8;p=q+b|0;o=b-q|0;f[i>>2]=v+o;f[l>>2]=o-v;f[d>>2]=k+p;f[a>>2]=p-k;if((s|0)>0){s=s+-1|0;t=t+4|0}else break}return}function FIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=0;e=a;while(1){g=(f[b+(d<<2)>>2]|0)+c|0;i=h[g>>0]|0;j=h[g+7>>0]|0;k=j+i|0;l=h[g+1>>0]|0;m=h[g+6>>0]|0;n=m+l|0;o=h[g+2>>0]|0;p=h[g+5>>0]|0;q=p+o|0;r=h[g+3>>0]|0;s=h[g+4>>0]|0;g=s+r|0;t=g+k|0;u=k-g|0;g=q+n|0;k=n-q|0;q=i-j|0;j=l-m|0;m=o-p|0;p=r-s|0;f[e>>2]=(t+g<<2)+-4096;f[e+16>>2]=t-g<<2;g=((u+k|0)*4433|0)+1024|0;f[e+8>>2]=g+(u*6270|0)>>11;u=g+(Y(k,-15137)|0)>>11;f[e+24>>2]=u;u=m+q|0;k=p+j|0;g=((k+u|0)*9633|0)+1024|0;t=Y(p+q|0,-7373)|0;s=Y(m+j|0,-20995)|0;r=g+(Y(u,-3196)|0)|0;u=g+(Y(k,-16069)|0)|0;f[e+4>>2]=t+(q*12299|0)+r>>11;f[e+12>>2]=s+(j*25172|0)+u>>11;f[e+20>>2]=s+(m*16819|0)+r>>11;f[e+28>>2]=t+(p*2446|0)+u>>11;d=d+1|0;if((d|0)==8){v=7;w=a;break}else e=e+32|0}while(1){e=f[w>>2]|0;a=w+224|0;d=f[a>>2]|0;c=d+e|0;b=w+32|0;u=f[b>>2]|0;p=w+192|0;t=f[p>>2]|0;r=t+u|0;m=w+64|0;s=f[m>>2]|0;j=w+160|0;q=f[j>>2]|0;k=q+s|0;g=w+96|0;o=f[g>>2]|0;l=w+128|0;i=f[l>>2]|0;n=i+o|0;x=c+2+n|0;y=c-n|0;n=k+r|0;c=r-k|0;k=e-d|0;d=u-t|0;t=s-q|0;q=o-i|0;f[w>>2]=x+n>>2;f[l>>2]=x-n>>2;n=((y+c|0)*4433|0)+16384|0;f[m>>2]=n+(y*6270|0)>>15;y=n+(Y(c,-15137)|0)>>15;f[p>>2]=y;y=t+k|0;p=q+d|0;c=((p+y|0)*9633|0)+16384|0;n=Y(q+k|0,-7373)|0;m=Y(t+d|0,-20995)|0;x=c+(Y(y,-3196)|0)|0;y=c+(Y(p,-16069)|0)|0;f[b>>2]=n+(k*12299|0)+x>>15;f[g>>2]=m+(d*25172|0)+y>>15;f[j>>2]=m+(t*16819|0)+x>>15;f[a>>2]=n+(q*2446|0)+y>>15;if((v|0)>0){v=v+-1|0;w=w+4|0}else break}return}function GIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;F1a(a|0,0,256)|0;d=0;e=a;while(1){g=(f[b+(d<<2)>>2]|0)+c|0;i=h[g>>0]|0;j=h[g+6>>0]|0;k=j+i|0;l=h[g+1>>0]|0;m=h[g+5>>0]|0;n=m+l|0;o=h[g+2>>0]|0;p=h[g+4>>0]|0;q=p+o|0;r=h[g+3>>0]|0;g=i-j|0;j=l-m|0;m=o-p|0;p=q+k|0;f[e>>2]=(r+n+p<<2)+-3584;o=((Y(r,-4)|0)+p|0)*2896|0;p=(k-q|0)*7542|0;l=(n-q|0)*2578|0;f[e+8>>2]=p+1024+l+o>>11;q=((k-n|0)*7223|0)+1024|0;k=q+l+(Y(n-(r<<1)|0,-5793)|0)>>11;f[e+16>>2]=k;f[e+24>>2]=q-p+o>>11;o=(j+g|0)*7663|0;p=(g-j|0)*1395|0;q=Y(m+j|0,-11295)|0;j=(m+g|0)*5027|0;f[e+4>>2]=1024-p+o+j>>11;f[e+12>>2]=p+1024+o+q>>11;f[e+20>>2]=(m*15326|0)+1024+j+q>>11;d=d+1|0;if((d|0)==7){s=0;t=a;break}else e=e+32|0}while(1){e=f[t>>2]|0;a=t+192|0;d=f[a>>2]|0;c=d+e|0;b=t+32|0;q=f[b>>2]|0;j=t+160|0;m=f[j>>2]|0;o=m+q|0;p=t+64|0;g=f[p>>2]|0;k=t+128|0;r=f[k>>2]|0;n=r+g|0;l=t+96|0;i=f[l>>2]|0;u=e-d|0;d=q-m|0;m=g-r|0;r=n+c|0;f[t>>2]=((i+o+r|0)*10700|0)+16384>>15;g=((Y(i,-4)|0)+r|0)*3783|0;r=(c-n|0)*9850|0;q=(o-n|0)*3367|0;f[p>>2]=r+16384+q+g>>15;p=((c-o|0)*9434|0)+16384|0;c=p+q+(Y(o-(i<<1)|0,-7566)|0)>>15;f[k>>2]=c;f[a>>2]=p-r+g>>15;g=(d+u|0)*10009|0;r=(u-d|0)*1822|0;p=Y(m+d|0,-14752)|0;d=(m+u|0)*6565|0;f[b>>2]=16384-r+g+d>>15;f[l>>2]=r+16384+g+p>>15;f[j>>2]=(m*20017|0)+16384+d+p>>15;s=s+1|0;if((s|0)==7)break;else t=t+4|0}return}function HIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;F1a(a|0,0,256)|0;d=0;e=a;while(1){g=(f[b+(d<<2)>>2]|0)+c|0;i=h[g>>0]|0;j=h[g+5>>0]|0;k=j+i|0;l=h[g+1>>0]|0;m=h[g+4>>0]|0;n=m+l|0;o=h[g+2>>0]|0;p=h[g+3>>0]|0;g=p+o|0;q=g+k|0;r=i-j|0;j=l-m|0;m=o-p|0;f[e>>2]=(q+n<<2)+-3072;f[e+8>>2]=((k-g|0)*10033|0)+1024>>11;g=(((Y(n,-2)|0)+q|0)*5793|0)+1024>>11;f[e+16>>2]=g;g=((m+r|0)*2998|0)+1024>>11;f[e+4>>2]=g+(j+r<<2);f[e+12>>2]=r-j-m<<2;f[e+20>>2]=g+(m-j<<2);d=d+1|0;if((d|0)==6){s=0;t=a;break}else e=e+32|0}while(1){e=f[t>>2]|0;a=t+160|0;d=f[a>>2]|0;c=d+e|0;b=t+32|0;j=f[b>>2]|0;m=t+128|0;g=f[m>>2]|0;r=g+j|0;q=t+64|0;n=f[q>>2]|0;k=t+96|0;p=f[k>>2]|0;o=p+n|0;l=o+c|0;i=e-d|0;d=j-g|0;g=n-p|0;f[t>>2]=((l+r|0)*14564|0)+16384>>15;f[q>>2]=((c-o|0)*17837|0)+16384>>15;o=(((Y(r,-2)|0)+l|0)*10298|0)+16384>>15;f[m>>2]=o;o=(g+i|0)*5331|0;f[b>>2]=((d+i|0)*14564|0)+16384+o>>15;f[k>>2]=((i-d-g|0)*14564|0)+16384>>15;f[a>>2]=((g-d|0)*14564|0)+16384+o>>15;s=s+1|0;if((s|0)==6)break;else t=t+4|0}return}function IIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;F1a(a|0,0,256)|0;d=0;e=a;while(1){g=(f[b+(d<<2)>>2]|0)+c|0;i=h[g>>0]|0;j=h[g+4>>0]|0;k=j+i|0;l=h[g+1>>0]|0;m=h[g+3>>0]|0;n=m+l|0;o=h[g+2>>0]|0;g=n+k|0;p=i-j|0;j=l-m|0;f[e>>2]=(g+o<<3)+-5120;m=(g-(o<<2)|0)*2896|0;o=((k-n|0)*6476|0)+512|0;f[e+8>>2]=o+m>>10;f[e+16>>2]=o-m>>10;m=(j+p|0)*6810|0;f[e+4>>2]=(p*4209|0)+512+m>>10;p=(Y(j,-17828)|0)+512+m>>10;f[e+12>>2]=p;d=d+1|0;if((d|0)==5){q=0;r=a;break}else e=e+32|0}while(1){e=f[r>>2]|0;a=r+128|0;d=f[a>>2]|0;c=d+e|0;b=r+32|0;p=f[b>>2]|0;m=r+96|0;j=f[m>>2]|0;o=j+p|0;n=r+64|0;k=f[n>>2]|0;g=o+c|0;l=e-d|0;d=p-j|0;f[r>>2]=((g+k|0)*10486|0)+16384>>15;j=(g-(k<<2)|0)*3707|0;k=((c-o|0)*8290|0)+16384|0;f[n>>2]=k+j>>15;f[a>>2]=k-j>>15;j=(d+l|0)*8716|0;f[b>>2]=(l*5387|0)+16384+j>>15;l=(Y(d,-22820)|0)+16384+j>>15;f[m>>2]=l;q=q+1|0;if((q|0)==5)break;else r=r+4|0}return}function JIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;F1a(a|0,0,256)|0;d=(f[b>>2]|0)+c|0;e=h[d>>0]|0;g=h[d+3>>0]|0;i=g+e|0;j=h[d+1>>0]|0;k=h[d+2>>0]|0;d=k+j|0;l=e-g|0;g=j-k|0;f[a>>2]=(d+i<<4)+-8192;f[a+8>>2]=i-d<<4;d=((g+l|0)*4433|0)+256|0;i=a+4|0;f[i>>2]=d+(l*6270|0)>>9;l=d+(Y(g,-15137)|0)>>9;f[a+12>>2]=l;l=a+32|0;g=(f[b+4>>2]|0)+c|0;d=h[g>>0]|0;k=h[g+3>>0]|0;j=k+d|0;e=h[g+1>>0]|0;m=h[g+2>>0]|0;g=m+e|0;n=d-k|0;k=e-m|0;f[l>>2]=(g+j<<4)+-8192;f[a+40>>2]=j-g<<4;g=((k+n|0)*4433|0)+256|0;f[a+36>>2]=g+(n*6270|0)>>9;n=g+(Y(k,-15137)|0)>>9;f[a+44>>2]=n;n=(f[b+8>>2]|0)+c|0;k=h[n>>0]|0;g=h[n+3>>0]|0;j=g+k|0;m=h[n+1>>0]|0;e=h[n+2>>0]|0;n=e+m|0;d=k-g|0;g=m-e|0;e=(n+j<<4)+-8192|0;f[a+64>>2]=e;f[a+72>>2]=j-n<<4;n=((g+d|0)*4433|0)+256|0;j=n+(d*6270|0)>>9;f[a+68>>2]=j;d=n+(Y(g,-15137)|0)>>9;f[a+76>>2]=d;d=(f[b+12>>2]|0)+c|0;c=h[d>>0]|0;b=h[d+3>>0]|0;g=b+c|0;n=h[d+1>>0]|0;m=h[d+2>>0]|0;d=m+n|0;k=c-b|0;b=n-m|0;m=(d+g<<4)+-8192|0;n=g-d<<4;d=((b+k|0)*4433|0)+256|0;g=d+(k*6270|0)>>9;k=d+(Y(b,-15137)|0)>>9;f[a+108>>2]=k;b=f[a>>2]|0;d=b+2+m|0;c=f[l>>2]|0;o=e+c|0;p=b-m|0;m=c-e|0;f[a>>2]=o+d>>2;f[a+64>>2]=d-o>>2;o=((m+p|0)*4433|0)+16384|0;f[l>>2]=o+(p*6270|0)>>15;p=o+(Y(m,-15137)|0)>>15;f[a+96>>2]=p;p=f[i>>2]|0;m=p+2+g|0;o=a+36|0;l=f[o>>2]|0;d=j+l|0;e=p-g|0;g=l-j|0;f[i>>2]=d+m>>2;f[a+68>>2]=m-d>>2;d=((g+e|0)*4433|0)+16384|0;f[o>>2]=d+(e*6270|0)>>15;e=d+(Y(g,-15137)|0)>>15;f[a+100>>2]=e;e=a+8|0;g=f[e>>2]|0;d=g+2+n|0;o=a+40|0;m=f[o>>2]|0;i=a+72|0;j=f[i>>2]|0;l=j+m|0;p=g-n|0;n=m-j|0;f[e>>2]=l+d>>2;f[i>>2]=d-l>>2;l=((n+p|0)*4433|0)+16384|0;f[o>>2]=l+(p*6270|0)>>15;p=l+(Y(n,-15137)|0)>>15;f[a+104>>2]=p;p=a+12|0;n=f[p>>2]|0;l=n+2+k|0;o=a+44|0;d=f[o>>2]|0;i=a+76|0;e=f[i>>2]|0;j=e+d|0;m=n-k|0;k=d-e|0;f[p>>2]=j+l>>2;f[i>>2]=l-j>>2;j=((k+m|0)*4433|0)+16384|0;f[o>>2]=j+(m*6270|0)>>15;m=j+(Y(k,-15137)|0)>>15;f[a+108>>2]=m;return}function KIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;F1a(a|0,0,256)|0;d=(f[b>>2]|0)+c|0;e=h[d>>0]|0;g=h[d+2>>0]|0;i=g+e|0;j=h[d+1>>0]|0;d=(i+j<<4)+-6144|0;f[a>>2]=d;k=(((Y(j,-2)|0)+i|0)*5793|0)+256>>9;f[a+8>>2]=k;k=((e-g|0)*10033|0)+256>>9;g=a+4|0;f[g>>2]=k;e=a+32|0;i=(f[b+4>>2]|0)+c|0;j=h[i>>0]|0;l=h[i+2>>0]|0;m=l+j|0;n=h[i+1>>0]|0;i=(m+n<<4)+-6144|0;f[e>>2]=i;o=(((Y(n,-2)|0)+m|0)*5793|0)+256>>9;f[a+40>>2]=o;m=((j-l|0)*10033|0)+256>>9;f[a+36>>2]=m;l=(f[b+8>>2]|0)+c|0;c=h[l>>0]|0;b=h[l+2>>0]|0;j=b+c|0;n=h[l+1>>0]|0;l=(j+n<<4)+-6144|0;p=(((Y(n,-2)|0)+j|0)*5793|0)+256>>9;j=((c-b|0)*10033|0)+256>>9;b=l+d|0;f[a>>2]=((b+i|0)*14564|0)+16384>>15;c=(((Y(i,-2)|0)+b|0)*10298|0)+16384>>15;f[a+64>>2]=c;f[e>>2]=((d-l|0)*17837|0)+16384>>15;l=j+k|0;f[g>>2]=((l+m|0)*14564|0)+16384>>15;g=(((Y(m,-2)|0)+l|0)*10298|0)+16384>>15;f[a+68>>2]=g;f[a+36>>2]=((k-j|0)*17837|0)+16384>>15;j=a+8|0;k=f[j>>2]|0;g=p+k|0;f[j>>2]=((g+o|0)*14564|0)+16384>>15;j=(((Y(o,-2)|0)+g|0)*10298|0)+16384>>15;f[a+72>>2]=j;f[a+40>>2]=((k-p|0)*17837|0)+16384>>15;return}function LIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0;F1a(a|0,0,256)|0;d=(f[b>>2]|0)+c|0;e=h[d>>0]|0;g=h[d+1>>0]|0;d=g+e|0;i=e-g|0;g=(f[b+4>>2]|0)+c|0;c=h[g>>0]|0;b=h[g+1>>0]|0;g=b+c|0;e=c-b|0;f[a>>2]=(g+d<<4)+-8192;f[a+32>>2]=d-g<<4;f[a+4>>2]=e+i<<4;f[a+36>>2]=i-e<<4;return}function MIa(a,b,c){a=a|0;b=b|0;c=c|0;F1a(a|0,0,256)|0;f[a>>2]=((h[(f[b>>2]|0)+c>>0]|0)<<6)+-8192;return}function NIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+32|0;e=d;g=0;i=a;a:while(1){j=(f[b+(g<<2)>>2]|0)+c|0;k=h[j>>0]|0;l=h[j+8>>0]|0;m=l+k|0;n=h[j+1>>0]|0;o=h[j+7>>0]|0;p=o+n|0;q=h[j+2>>0]|0;r=h[j+6>>0]|0;s=r+q|0;t=h[j+3>>0]|0;v=h[j+5>>0]|0;w=v+t|0;x=h[j+4>>0]|0;j=k-l|0;l=q-r|0;r=t-v|0;v=s+m+w|0;t=x+p|0;f[i>>2]=(v+t<<1)+-2304;q=(((Y(t,-2)|0)+v|0)*5793|0)+2048>>12;f[i+24>>2]=q;q=((Y(x,-2)|0)+p|0)*5793|0;p=((m-s|0)*10887|0)+2048|0;f[i+8>>2]=p+((s-w|0)*8875|0)+q>>12;f[i+16>>2]=p+((w-m|0)*2012|0)-q>>12;f[i+12>>2]=((j-l-r|0)*10033|0)+2048>>12;q=(n-o|0)*10033|0;o=(l+j|0)*7447|0;n=(r+j|0)*3962|0;f[i+4>>2]=q+2048+o+n>>12;j=(l-r|0)*11409|0;r=2048-q|0;f[i+20>>2]=r+o-j>>12;f[i+28>>2]=r+n+j>>12;switch(g|0){case 7:{g=8;i=e;continue a;break}case 8:{y=7;z=a;A=e;break a;break}default:{}}g=g+1|0;i=i+32|0}while(1){i=f[z>>2]|0;g=f[A>>2]|0;e=g+i|0;a=z+32|0;c=f[a>>2]|0;b=z+224|0;j=f[b>>2]|0;n=j+c|0;r=z+64|0;o=f[r>>2]|0;q=z+192|0;l=f[q>>2]|0;m=l+o|0;w=z+96|0;p=f[w>>2]|0;s=z+160|0;x=f[s>>2]|0;v=x+p|0;t=z+128|0;k=f[t>>2]|0;B=i-g|0;g=o-l|0;l=p-x|0;x=m+e+v|0;p=k+n|0;f[z>>2]=((x+p|0)*12945|0)+16384>>15;o=(((Y(p,-2)|0)+x|0)*9154|0)+16384>>15;f[q>>2]=o;o=((Y(k,-2)|0)+n|0)*9154|0;n=((e-m|0)*17203|0)+16384|0;f[r>>2]=n+((m-v|0)*14024|0)+o>>15;f[t>>2]=n+((v-e|0)*3179|0)-o>>15;f[w>>2]=((B-g-l|0)*15855|0)+16384>>15;w=(c-j|0)*15855|0;j=(g+B|0)*11768|0;c=(l+B|0)*6262|0;f[a>>2]=w+16384+j+c>>15;a=(g-l|0)*18029|0;l=16384-w|0;f[s>>2]=l+j-a>>15;f[b>>2]=l+c+a>>15;if((y|0)>0){y=y+-1|0;z=z+4|0;A=A+4|0}else break}u=d;return}function OIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+64|0;e=d;g=0;i=a;a:while(1){j=(f[b+(g<<2)>>2]|0)+c|0;k=h[j>>0]|0;l=h[j+9>>0]|0;m=l+k|0;n=h[j+1>>0]|0;o=h[j+8>>0]|0;p=o+n|0;q=h[j+2>>0]|0;r=h[j+7>>0]|0;s=r+q|0;t=h[j+3>>0]|0;v=h[j+6>>0]|0;w=v+t|0;x=h[j+4>>0]|0;y=h[j+5>>0]|0;j=y+x|0;z=j+m|0;A=m-j|0;j=w+p|0;m=p-w|0;w=k-l|0;l=n-o|0;o=q-r|0;r=t-v|0;v=x-y|0;f[i>>2]=(j+s+z<<1)+-2560;y=s<<1;s=(Y(j-y|0,-3580)|0)+2048+((z-y|0)*9373|0)>>12;f[i+16>>2]=s;s=(A+m|0)*6810|0;f[i+8>>2]=(A*4209|0)+2048+s>>12;A=(Y(m,-17828)|0)+2048+s>>12;f[i+24>>2]=A;A=v+w|0;s=l-r|0;f[i+20>>2]=A-(s+o)<<1;m=o<<13;f[i+4>>2]=(w*11443|0)+2048+(l*10323|0)+m+(r*5260|0)+(v*1812|0)>>12;o=(s<<12)-m+((A+s|0)*2531|0)|0;s=((w-v|0)*7791|0)+(Y(r+l|0,-4815)|0)+2048|0;f[i+12>>2]=s+o>>12;f[i+28>>2]=s-o>>12;switch(g|0){case 7:{g=8;i=e;continue a;break}case 9:{B=7;C=a;D=e;break a;break}default:{}}g=g+1|0;i=i+32|0}while(1){i=f[C>>2]|0;g=f[D+32>>2]|0;e=g+i|0;a=C+32|0;c=f[a>>2]|0;b=f[D>>2]|0;o=b+c|0;s=C+64|0;l=f[s>>2]|0;r=C+224|0;v=f[r>>2]|0;w=v+l|0;A=C+96|0;m=f[A>>2]|0;y=C+192|0;z=f[y>>2]|0;j=z+m|0;x=C+128|0;t=f[x>>2]|0;q=C+160|0;n=f[q>>2]|0;k=n+t|0;p=k+e|0;E=e-k|0;k=j+o|0;e=o-j|0;j=i-g|0;g=c-b|0;b=l-v|0;v=m-z|0;z=t-n|0;f[C>>2]=((k+w+p|0)*10486|0)+16384>>15;n=w<<1;w=(Y(k-n|0,-4582)|0)+16384+((p-n|0)*11997|0)>>15;f[x>>2]=w;w=(E+e|0)*8716|0;f[s>>2]=(E*5387|0)+16384+w>>15;E=(Y(e,-22820)|0)+16384+w>>15;f[y>>2]=E;E=z+j|0;y=g-v|0;f[q>>2]=((E-(y+b)|0)*10486|0)+16384>>15;q=b*10486|0;f[a>>2]=(j*14647|0)+16384+(g*13213|0)+q+(v*6732|0)+(z*2320|0)>>15;a=(y*5243|0)-q+((E+y|0)*3240|0)|0;y=((j-z|0)*9973|0)+(Y(v+g|0,-6163)|0)+16384|0;f[A>>2]=y+a>>15;f[r>>2]=y-a>>15;if((B|0)>0){B=B+-1|0;C=C+4|0;D=D+4|0}else break}u=d;return}function PIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+96|0;e=d;g=0;i=a;a:while(1){j=(f[b+(g<<2)>>2]|0)+c|0;k=h[j>>0]|0;l=h[j+10>>0]|0;m=l+k|0;n=h[j+1>>0]|0;o=h[j+9>>0]|0;p=o+n|0;q=h[j+2>>0]|0;r=h[j+8>>0]|0;s=r+q|0;t=h[j+3>>0]|0;v=h[j+7>>0]|0;w=v+t|0;x=h[j+4>>0]|0;y=h[j+6>>0]|0;z=y+x|0;A=h[j+5>>0]|0;j=k-l|0;l=n-o|0;o=q-r|0;r=t-v|0;v=x-y|0;f[i>>2]=(p+m+s+w+z+A<<1)+-2816;y=A<<1;A=m-y|0;m=p-y|0;p=s-y|0;s=w-y|0;w=z-y|0;y=((A+s|0)*11116|0)+((p+w|0)*1649|0)|0;z=(m-s|0)*7587|0;x=(A-m|0)*9746|0;t=(Y(s,-8342)|0)+2048+(Y(w,-11395)|0)+z+y>>12;f[i+8>>2]=t;t=(m*511|0)+2048+(Y(p,-11116)|0)+(w*4813|0)+x+z>>12;f[i+16>>2]=t;t=(Y(A,-13275)|0)+2048+(Y(p,-6461)|0)+x+y>>12;f[i+24>>2]=t;t=(l+j|0)*10538|0;y=(o+j|0)*8756|0;x=(r+j|0)*6263|0;p=Y(o+l|0,-6263)|0;A=Y(r+l|0,-11467)|0;z=Y(v,-8756)|0;w=(r+o|0)*3264|0;m=Y(o,-16294)|0;o=Y(v,-10538)|0;s=(Y(j,-14090)|0)+2048+t+y+x+(v*3264|0)>>12;f[i+4>>2]=s;f[i+12>>2]=(l*10456|0)+2048+t+p+A+z>>12;f[i+20>>2]=m+2048+p+y+w+(v*11467|0)>>12;f[i+28>>2]=(r*10695|0)+2048+w+A+x+o>>12;switch(g|0){case 7:{g=8;i=e;continue a;break}case 10:{B=7;C=a;D=e;break a;break}default:{}}g=g+1|0;i=i+32|0}while(1){i=f[C>>2]|0;g=f[D+64>>2]|0;e=g+i|0;a=C+32|0;c=f[a>>2]|0;b=f[D+32>>2]|0;o=b+c|0;x=C+64|0;A=f[x>>2]|0;w=f[D>>2]|0;r=w+A|0;v=C+96|0;y=f[v>>2]|0;p=C+224|0;m=f[p>>2]|0;z=m+y|0;t=C+128|0;l=f[t>>2]|0;s=C+192|0;j=f[s>>2]|0;q=j+l|0;n=C+160|0;k=f[n>>2]|0;E=i-g|0;g=c-b|0;b=A-w|0;w=y-m|0;m=l-j|0;f[C>>2]=((o+e+r+z+q+k|0)*8666|0)+16384>>15;j=k<<1;k=e-j|0;e=o-j|0;o=r-j|0;r=z-j|0;z=q-j|0;j=((k+r|0)*11759|0)+((o+z|0)*1744|0)|0;q=(e-r|0)*8026|0;l=(k-e|0)*10310|0;y=(Y(r,-8825)|0)+16384+(Y(z,-12054)|0)+q+j>>15;f[x>>2]=y;y=(e*540|0)+16384+(Y(o,-11759)|0)+(z*5091|0)+l+q>>15;f[t>>2]=y;y=(Y(k,-14043)|0)+16384+(Y(o,-6835)|0)+l+j>>15;f[s>>2]=y;y=(g+E|0)*11148|0;s=(b+E|0)*9262|0;j=(w+E|0)*6626|0;l=Y(b+g|0,-6626)|0;o=Y(w+g|0,-12131)|0;k=Y(m,-9262)|0;t=(w+b|0)*3453|0;q=Y(b,-17237)|0;b=Y(m,-11148)|0;z=(Y(E,-14905)|0)+16384+y+s+j+(m*3453|0)>>15;f[a>>2]=z;f[v>>2]=(g*11061|0)+16384+y+l+o+k>>15;f[n>>2]=q+16384+l+s+t+(m*12131|0)>>15;f[p>>2]=(w*11314|0)+16384+t+o+j+b>>15;if((B|0)>0){B=B+-1|0;C=C+4|0;D=D+4|0}else break}u=d;return}function QIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=u;u=u+128|0;e=d;g=0;i=a;a:while(1){j=(f[b+(g<<2)>>2]|0)+c|0;k=h[j>>0]|0;l=h[j+11>>0]|0;m=l+k|0;n=h[j+1>>0]|0;o=h[j+10>>0]|0;p=o+n|0;q=h[j+2>>0]|0;r=h[j+9>>0]|0;s=r+q|0;t=h[j+3>>0]|0;v=h[j+8>>0]|0;w=v+t|0;x=h[j+4>>0]|0;y=h[j+7>>0]|0;z=y+x|0;A=h[j+5>>0]|0;B=h[j+6>>0]|0;j=B+A|0;C=j+m|0;D=m-j|0;j=p-z|0;m=w+s|0;E=s-w|0;w=k-l|0;l=n-o|0;o=q-r|0;r=t-v|0;v=x-y|0;y=A-B|0;f[i>>2]=(p|-1536)+m+z+C;f[i+24>>2]=D-(j+E);f[i+16>>2]=((C-m|0)*10033|0)+4096>>13;f[i+8>>2]=4096-E+j+((D+E|0)*11190|0)>>13;E=(v+l|0)*4433|0;D=E+(l*6270|0)|0;l=E+(Y(v,-15137)|0)|0;v=(o+w|0)*9191|0;E=(r+w|0)*7053|0;j=Y(r+o|0,-1512)|0;m=Y(o,-19165)|0;C=Y(y,-9191)|0;z=Y(y+o|0,-4433)|0;o=(Y(w,-4758)|0)+4096+v+E+D+(y*1512|0)>>13;f[i+4>>2]=o;f[i+12>>2]=((w-r|0)*10703|0)+4096+l+z>>13;f[i+20>>2]=m+4096+v+j-l+(y*7053|0)>>13;f[i+28>>2]=(r*5946|0)+4096+j+E-D+C>>13;switch(g|0){case 7:{g=8;i=e;continue a;break}case 11:{F=7;G=a;H=e;break a;break}default:{}}g=g+1|0;i=i+32|0}while(1){i=f[G>>2]|0;g=f[H+96>>2]|0;e=g+i|0;a=G+32|0;c=f[a>>2]|0;b=f[H+64>>2]|0;C=b+c|0;D=G+64|0;E=f[D>>2]|0;j=f[H+32>>2]|0;r=j+E|0;y=G+96|0;l=f[y>>2]|0;v=f[H>>2]|0;m=v+l|0;z=G+128|0;w=f[z>>2]|0;o=G+224|0;p=f[o>>2]|0;B=p+w|0;A=G+160|0;x=f[A>>2]|0;t=G+192|0;q=f[t>>2]|0;n=q+x|0;k=n+e|0;s=e-n|0;n=C-B|0;e=m+r|0;I=r-m|0;m=i-g|0;g=c-b|0;b=E-j|0;j=l-v|0;v=w-p|0;p=x-q|0;f[G>>2]=((e+C+B+k|0)*7282|0)+8192>>14;f[t>>2]=((s-(n+I)|0)*7282|0)+8192>>14;f[z>>2]=((k-e|0)*8918|0)+8192>>14;f[D>>2]=((n-I|0)*7282|0)+8192+((s+I|0)*9947|0)>>14;I=(v+g|0)*3941|0;s=I+(g*5573|0)|0;g=I+(Y(v,-13455)|0)|0;v=(b+m|0)*8170|0;I=(j+m|0)*6269|0;n=Y(j+b|0,-1344)|0;D=Y(b,-17036)|0;e=Y(p,-8170)|0;k=Y(p+b|0,-3941)|0;b=(Y(m,-4229)|0)+8192+v+I+s+(p*1344|0)>>14;f[a>>2]=b;f[y>>2]=((m-j|0)*9514|0)+8192+g+k>>14;f[A>>2]=D+8192+v+n-g+(p*6269|0)>>14;f[o>>2]=(j*5285|0)+8192+n+I-s+e>>14;if((F|0)>0){F=F+-1|0;G=G+4|0;H=H+4|0}else break}u=d;return}function RIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=u;u=u+160|0;e=d;g=0;i=a;a:while(1){j=(f[b+(g<<2)>>2]|0)+c|0;k=h[j>>0]|0;l=h[j+12>>0]|0;m=l+k|0;n=h[j+1>>0]|0;o=h[j+11>>0]|0;p=o+n|0;q=h[j+2>>0]|0;r=h[j+10>>0]|0;s=r+q|0;t=h[j+3>>0]|0;v=h[j+9>>0]|0;w=v+t|0;x=h[j+4>>0]|0;y=h[j+8>>0]|0;z=y+x|0;A=h[j+5>>0]|0;B=h[j+7>>0]|0;C=B+A|0;D=h[j+6>>0]|0;j=k-l|0;l=n-o|0;o=q-r|0;r=t-v|0;v=x-y|0;y=A-B|0;f[i>>2]=m+-1664+p+s+w+z+C+D;B=D<<1;D=m-B|0;m=p-B|0;p=s-B|0;s=w-B|0;w=z-B|0;z=C-B|0;B=(m*8672|0)+4096+(D*11249|0)+(p*4108|0)+(Y(s,-1396)|0)+(Y(w,-6581)|0)+(Y(z,-10258)|0)>>13;f[i+8>>2]=B;B=((D-p|0)*9465|0)+(Y(s-w|0,-3570)|0)+(Y(m-z|0,-2592)|0)|0;C=((D+p|0)*793|0)+(Y(s+w|0,-7678)|0)+((m+z|0)*3989|0)|0;f[i+16>>2]=C+4096+B>>13;f[i+24>>2]=4096-C+B>>13;B=(l+j|0)*10832|0;C=(o+j|0)*9534|0;z=((y+v|0)*2773|0)+((r+j|0)*7682|0)|0;m=((v-y|0)*7682|0)+(Y(o+l|0,-2773)|0)|0;w=Y(r+l|0,-9534)|0;s=Y(v,-19183)|0;p=Y(r+o|0,-5384)|0;D=Y(o,-12879)|0;o=Y(y,-14273)|0;A=(Y(j,-16549)|0)+4096+B+C+(v*2611|0)+z>>13;f[i+4>>2]=A;f[i+12>>2]=(l*6859|0)+4096+B+w+s+m>>13;f[i+20>>2]=D+4096+C+p+(y*18515|0)+m>>13;f[i+28>>2]=(r*18068|0)+4096+p+w+o+z>>13;switch(g|0){case 7:{g=8;i=e;continue a;break}case 12:{E=7;F=a;G=e;break a;break}default:{}}g=g+1|0;i=i+32|0}while(1){i=f[F>>2]|0;g=f[G+128>>2]|0;e=g+i|0;a=F+32|0;c=f[a>>2]|0;b=f[G+96>>2]|0;z=b+c|0;o=F+64|0;w=f[o>>2]|0;p=f[G+64>>2]|0;r=p+w|0;m=F+96|0;y=f[m>>2]|0;C=f[G+32>>2]|0;D=C+y|0;s=F+128|0;B=f[s>>2]|0;l=f[G>>2]|0;A=l+B|0;v=F+160|0;j=f[v>>2]|0;x=F+224|0;t=f[x>>2]|0;q=t+j|0;n=F+192|0;k=f[n>>2]|0;H=i-g|0;g=c-b|0;b=w-p|0;p=y-C|0;C=B-l|0;l=j-t|0;f[F>>2]=((z+e+r+D+A+q+k|0)*6205|0)+8192>>14;t=k<<1;k=e-t|0;e=z-t|0;z=r-t|0;r=D-t|0;D=A-t|0;A=q-t|0;t=(e*6568|0)+8192+(k*8520|0)+(z*3112|0)+(Y(r,-1058)|0)+(Y(D,-4985)|0)+(Y(A,-7770)|0)>>14;f[o>>2]=t;t=((k-z|0)*7169|0)+(Y(r-D|0,-2704)|0)+(Y(e-A|0,-1963)|0)|0;o=((k+z|0)*601|0)+(Y(r+D|0,-5816)|0)+((e+A|0)*3021|0)|0;f[s>>2]=o+8192+t>>14;f[n>>2]=8192-o+t>>14;t=(g+H|0)*8204|0;o=(b+H|0)*7221|0;n=((l+C|0)*2100|0)+((p+H|0)*5819|0)|0;s=((C-l|0)*5819|0)+(Y(b+g|0,-2100)|0)|0;A=Y(p+g|0,-7221)|0;e=Y(C,-14529)|0;D=Y(p+b|0,-4078)|0;r=Y(b,-9754)|0;b=Y(l,-10811)|0;z=(Y(H,-12534)|0)+8192+t+o+(C*1978|0)+n>>14;f[a>>2]=z;f[m>>2]=(g*5195|0)+8192+t+A+e+s>>14;f[v>>2]=r+8192+o+D+(l*14023|0)+s>>14;f[x>>2]=(p*13685|0)+8192+D+A+b+n>>14;if((E|0)>0){E=E+-1|0;F=F+4|0;G=G+4|0}else break}u=d;return}function SIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=u;u=u+192|0;e=d;g=0;i=a;a:while(1){j=(f[b+(g<<2)>>2]|0)+c|0;k=h[j>>0]|0;l=h[j+13>>0]|0;m=l+k|0;n=h[j+1>>0]|0;o=h[j+12>>0]|0;p=o+n|0;q=h[j+2>>0]|0;r=h[j+11>>0]|0;s=r+q|0;t=h[j+3>>0]|0;v=h[j+10>>0]|0;w=v+t|0;x=h[j+4>>0]|0;y=h[j+9>>0]|0;z=y+x|0;A=h[j+5>>0]|0;B=h[j+8>>0]|0;C=B+A|0;D=h[j+6>>0]|0;E=h[j+7>>0]|0;j=E+D|0;F=j+m|0;G=m-j|0;j=C+p|0;m=p-C|0;C=z+s|0;p=s-z|0;z=k-l|0;l=n-o|0;o=q-r|0;r=t-v|0;v=x-y|0;y=A-B|0;B=D-E|0;f[i>>2]=w+-1792+C+j+F;E=w<<1;w=(Y(C-E|0,-7223)|0)+4096+((j-E|0)*2578|0)+((F-E|0)*10438|0)>>13;f[i+16>>2]=w;w=(G+m|0)*9058|0;f[i+8>>2]=(p*5027|0)+4096+(G*2237|0)+w>>13;G=(Y(p,-11295)|0)+4096+(Y(m,-14084)|0)+w>>13;f[i+24>>2]=G;G=o+l|0;w=y-v|0;f[i+28>>2]=z-G+r-w-B;m=r<<13;r=(w*11512|0)-m+(Y(G,-1297)|0)|0;G=((B+v|0)*6164|0)+((o+z|0)*9810|0)|0;w=(Y(o,-19447)|0)+4096+(v*9175|0)+r+G>>13;f[i+20>>2]=w;w=((y-B|0)*3826|0)+((l+z|0)*10935|0)|0;v=(Y(l,-3474)|0)+4096+(Y(y,-25148)|0)+r+w>>13;f[i+12>>2]=v;v=(m|4096)+B+(Y(B+z|0,-9232)|0)+w+G>>13;f[i+4>>2]=v;switch(g|0){case 7:{g=8;i=e;continue a;break}case 13:{H=7;I=a;J=e;break a;break}default:{}}g=g+1|0;i=i+32|0}while(1){i=f[I>>2]|0;g=f[J+160>>2]|0;e=g+i|0;a=I+32|0;c=f[a>>2]|0;b=f[J+128>>2]|0;v=b+c|0;G=I+64|0;w=f[G>>2]|0;z=f[J+96>>2]|0;B=z+w|0;m=I+96|0;r=f[m>>2]|0;y=f[J+64>>2]|0;l=y+r|0;o=I+128|0;p=f[o>>2]|0;E=f[J+32>>2]|0;F=E+p|0;j=I+160|0;C=f[j>>2]|0;D=f[J>>2]|0;A=D+C|0;x=I+192|0;t=f[x>>2]|0;q=I+224|0;n=f[q>>2]|0;k=n+t|0;s=k+e|0;K=e-k|0;k=A+v|0;e=v-A|0;A=F+B|0;v=B-F|0;F=i-g|0;g=c-b|0;b=w-z|0;z=r-y|0;y=p-E|0;E=C-D|0;D=t-n|0;f[I>>2]=((A+l+k+s|0)*5350|0)+8192>>14;n=l<<1;l=(Y(A-n|0,-4717)|0)+8192+((k-n|0)*1684|0)+((s-n|0)*6817|0)>>14;f[o>>2]=l;l=(K+e|0)*5915|0;f[G>>2]=(v*3283|0)+8192+(K*1461|0)+l>>14;K=(Y(v,-7376)|0)+8192+(Y(e,-9198)|0)+l>>14;f[x>>2]=K;K=b+g|0;x=E-y|0;f[q>>2]=((F-K+z-x-D|0)*5350|0)+8192>>14;q=z*5350|0;z=(x*7518|0)-q+(Y(K,-847)|0)|0;K=((D+y|0)*4025|0)+((b+F|0)*6406|0)|0;x=(Y(b,-12700)|0)+8192+(y*5992|0)+z+K>>14;f[j>>2]=x;x=((E-D|0)*2499|0)+((g+F|0)*7141|0)|0;j=(Y(g,-2269)|0)+8192+(Y(E,-16423)|0)+z+x>>14;f[m>>2]=j;j=(Y(F,-6029)|0)+8192+q+(Y(D,-679)|0)+x+K>>14;f[a>>2]=j;if((H|0)>0){H=H+-1|0;I=I+4|0;J=J+4|0}else break}u=d;return}function TIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=u;u=u+224|0;e=d;g=0;i=a;a:while(1){j=(f[b+(g<<2)>>2]|0)+c|0;k=h[j>>0]|0;l=h[j+14>>0]|0;m=l+k|0;n=h[j+1>>0]|0;o=h[j+13>>0]|0;p=o+n|0;q=h[j+2>>0]|0;r=h[j+12>>0]|0;s=r+q|0;t=h[j+3>>0]|0;v=h[j+11>>0]|0;w=v+t|0;x=h[j+4>>0]|0;y=h[j+10>>0]|0;z=y+x|0;A=h[j+5>>0]|0;B=h[j+9>>0]|0;C=B+A|0;D=h[j+6>>0]|0;E=h[j+8>>0]|0;F=E+D|0;G=h[j+7>>0]|0;j=k-l|0;l=n-o|0;o=q-r|0;r=t-v|0;v=x-y|0;y=A-B|0;B=D-E|0;E=z+m+C|0;D=w+p+F|0;A=G+s|0;f[i>>2]=E+-1920+D+A;x=A<<1;A=(Y(D-x|0,-3580)|0)+4096+((E-x|0)*9373|0)>>13;f[i+24>>2]=A;A=((z+p|0)>>>1)+s+(Y(G,-2)|0)|0;G=Y(m-A|0,-748)|0;s=((p-z|0)*6476|0)+((m-w|0)*11332|0)+((F-C|0)*7752|0)+4096|0;m=s+(Y(F-A|0,-18336)|0)+((w-A|0)*12543|0)>>13;f[i+8>>2]=m;f[i+16>>2]=s+G+((C-A|0)*6541|0)>>13;A=o*10033|0;C=((y+r|0)*4712|0)+((v+l|0)*11018|0)+((j-B|0)*11522|0)|0;G=Y(j,-2912)|0;s=Y(l,-17828)|0;m=Y(y,-7121)|0;w=A+4096+(r*3897|0)+(Y(v,-4209)|0)+(B*13930|0)+C>>13;f[i+4>>2]=w;f[i+12>>2]=((j-v-y|0)*11018|0)+4096+((l-r-B|0)*6810|0)>>13;f[i+20>>2]=((j-o-r+y+B|0)*10033|0)+4096>>13;f[i+28>>2]=G+4096+s-A+m+C>>13;switch(g|0){case 7:{g=8;i=e;continue a;break}case 14:{H=7;I=a;J=e;break a;break}default:{}}g=g+1|0;i=i+32|0}while(1){i=f[I>>2]|0;g=f[J+192>>2]|0;e=g+i|0;a=I+32|0;c=f[a>>2]|0;b=f[J+160>>2]|0;C=b+c|0;m=I+64|0;A=f[m>>2]|0;s=f[J+128>>2]|0;G=s+A|0;B=I+96|0;y=f[B>>2]|0;r=f[J+96>>2]|0;o=r+y|0;j=I+128|0;l=f[j>>2]|0;v=f[J+64>>2]|0;w=v+l|0;F=I+160|0;z=f[F>>2]|0;p=f[J+32>>2]|0;x=p+z|0;E=I+192|0;D=f[E>>2]|0;t=f[J>>2]|0;q=t+D|0;n=I+224|0;k=f[n>>2]|0;K=i-g|0;g=c-b|0;b=A-s|0;s=y-r|0;r=l-v|0;v=z-p|0;p=D-t|0;t=w+e+x|0;D=o+C+q|0;z=k+G|0;f[I>>2]=((D+t+z|0)*9321|0)+16384>>15;l=z<<1;z=(Y(D-l|0,-4073)|0)+16384+((t-l|0)*10664|0)>>15;f[E>>2]=z;z=(w+C>>1)+G+(Y(k,-2)|0)|0;k=Y(e-z|0,-852)|0;G=((C-w|0)*7369|0)+((e-o|0)*12893|0)+((q-x|0)*8820|0)+16384|0;e=G+(Y(q-z|0,-20862)|0)+((o-z|0)*14271|0)>>15;f[m>>2]=e;f[j>>2]=G+k+((x-z|0)*7442|0)>>15;z=b*11415|0;x=((v+s|0)*5361|0)+((r+g|0)*12536|0)+((K-p|0)*13109|0)|0;k=Y(K,-3314)|0;G=Y(g,-20284)|0;j=Y(v,-8102)|0;e=z+16384+(s*4434|0)+(Y(r,-4788)|0)+(p*15850|0)+x>>15;f[a>>2]=e;f[B>>2]=((K-r-v|0)*12536|0)+16384+((g-s-p|0)*7748|0)>>15;f[F>>2]=((K-b-s+v+p|0)*11415|0)+16384>>15;f[n>>2]=k+16384+G-z+j+x>>15;if((H|0)>0){H=H+-1|0;I=I+4|0;J=J+4|0}else break}u=d;return}function UIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=u;u=u+256|0;e=d;g=0;i=a;a:while(1){j=(f[b+(g<<2)>>2]|0)+c|0;k=h[j>>0]|0;l=h[j+15>>0]|0;m=l+k|0;n=h[j+1>>0]|0;o=h[j+14>>0]|0;p=o+n|0;q=h[j+2>>0]|0;r=h[j+13>>0]|0;s=r+q|0;t=h[j+3>>0]|0;v=h[j+12>>0]|0;w=v+t|0;x=h[j+4>>0]|0;y=h[j+11>>0]|0;z=y+x|0;A=h[j+5>>0]|0;B=h[j+10>>0]|0;C=B+A|0;D=h[j+6>>0]|0;E=h[j+9>>0]|0;F=E+D|0;G=h[j+7>>0]|0;H=h[j+8>>0]|0;j=H+G|0;I=j+m|0;J=m-j|0;j=F+p|0;m=p-F|0;F=C+s|0;p=s-C|0;C=z+w|0;s=w-z|0;z=k-l|0;l=n-o|0;o=q-r|0;r=t-v|0;v=x-y|0;y=A-B|0;B=D-E|0;E=G-H|0;f[i>>2]=(F+C+j+I<<2)+-8192;f[i+16>>2]=((j-F|0)*4433|0)+1024+((I-C|0)*10703|0)>>11;C=((J-p|0)*11363|0)+((s-m|0)*2260|0)|0;f[i+8>>2]=(p*17799|0)+1024+(m*11893|0)+C>>11;m=(Y(s,-8697)|0)+1024+(Y(J,-1730)|0)+C>>11;f[i+24>>2]=m;m=((B-E|0)*3363|0)+((l+z|0)*11086|0)|0;C=((E+y|0)*5461|0)+((o+z|0)*10217|0)|0;J=((v-E|0)*7350|0)+((r+z|0)*8956|0)|0;s=((B-y|0)*11529|0)+((o+l|0)*1136|0)|0;p=(Y(B+v|0,-10217)|0)+(Y(r+l|0,-5461)|0)|0;I=((y-v|0)*3363|0)+(Y(r+o|0,-11086)|0)|0;F=Y(B,-13631)|0;B=Y(o,-9222)|0;o=(Y(z,-18730)|0)+1024+(E*6387|0)+C+m+J>>11;f[i+4>>2]=o;f[i+12>>2]=(l*589|0)+1024+F+p+s+m>>11;f[i+20>>2]=B+1024+(y*10055|0)+I+s+C>>11;f[i+28>>2]=(r*8728|0)+1024+(v*17760|0)+I+p+J>>11;switch(g|0){case 7:{g=8;i=e;continue a;break}case 15:{K=7;L=a;M=e;break a;break}default:{}}g=g+1|0;i=i+32|0}while(1){i=f[L>>2]|0;g=f[M+224>>2]|0;e=g+i|0;a=L+32|0;c=f[a>>2]|0;b=f[M+192>>2]|0;J=b+c|0;p=L+64|0;I=f[p>>2]|0;v=f[M+160>>2]|0;r=v+I|0;C=L+96|0;s=f[C>>2]|0;y=f[M+128>>2]|0;B=y+s|0;m=L+128|0;F=f[m>>2]|0;l=f[M+96>>2]|0;o=l+F|0;E=L+160|0;z=f[E>>2]|0;j=f[M+64>>2]|0;H=j+z|0;G=L+192|0;D=f[G>>2]|0;A=f[M+32>>2]|0;x=A+D|0;t=L+224|0;q=f[t>>2]|0;n=f[M>>2]|0;k=n+q|0;w=k+e|0;N=e-k|0;k=x+J|0;e=J-x|0;x=H+r|0;J=r-H|0;H=o+B|0;r=B-o|0;o=i-g|0;g=c-b|0;b=I-v|0;v=s-y|0;y=F-l|0;l=z-j|0;j=D-A|0;A=q-n|0;f[L>>2]=H+8+x+k+w>>4;f[m>>2]=((k-x|0)*4433|0)+65536+((w-H|0)*10703|0)>>17;H=((N-J|0)*11363|0)+((r-e|0)*2260|0)|0;f[p>>2]=(J*17799|0)+65536+(e*11893|0)+H>>17;e=(Y(r,-8697)|0)+65536+(Y(N,-1730)|0)+H>>17;f[G>>2]=e;e=((j-A|0)*3363|0)+((g+o|0)*11086|0)|0;G=((A+l|0)*5461|0)+((b+o|0)*10217|0)|0;H=((y-A|0)*7350|0)+((v+o|0)*8956|0)|0;N=((j-l|0)*11529|0)+((b+g|0)*1136|0)|0;r=(Y(j+y|0,-10217)|0)+(Y(v+g|0,-5461)|0)|0;J=((l-y|0)*3363|0)+(Y(v+b|0,-11086)|0)|0;p=Y(j,-13631)|0;j=Y(b,-9222)|0;b=(Y(o,-18730)|0)+65536+(A*6387|0)+G+e+H>>17;f[a>>2]=b;f[C>>2]=(g*589|0)+65536+p+r+N+e>>17;f[E>>2]=j+65536+(l*10055|0)+J+N+G>>17;f[t>>2]=(v*8728|0)+65536+(y*17760|0)+J+r+H>>17;if((K|0)>0){K=K+-1|0;L=L+4|0;M=M+4|0}else break}u=d;return}function VIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=0;e=a;while(1){g=(f[b+(d<<2)>>2]|0)+c|0;i=h[g>>0]|0;j=h[g+15>>0]|0;k=j+i|0;l=h[g+1>>0]|0;m=h[g+14>>0]|0;n=m+l|0;o=h[g+2>>0]|0;p=h[g+13>>0]|0;q=p+o|0;r=h[g+3>>0]|0;s=h[g+12>>0]|0;t=s+r|0;u=h[g+4>>0]|0;v=h[g+11>>0]|0;w=v+u|0;x=h[g+5>>0]|0;y=h[g+10>>0]|0;z=y+x|0;A=h[g+6>>0]|0;B=h[g+9>>0]|0;C=B+A|0;D=h[g+7>>0]|0;E=h[g+8>>0]|0;g=E+D|0;F=g+k|0;G=k-g|0;g=C+n|0;k=n-C|0;C=z+q|0;n=q-z|0;z=w+t|0;q=t-w|0;w=i-j|0;j=l-m|0;m=o-p|0;p=r-s|0;s=u-v|0;v=x-y|0;y=A-B|0;B=D-E|0;f[e>>2]=(C+z+g+F<<2)+-8192;f[e+16>>2]=((g-C|0)*4433|0)+1024+((F-z|0)*10703|0)>>11;z=((G-n|0)*11363|0)+((q-k|0)*2260|0)|0;f[e+8>>2]=(n*17799|0)+1024+(k*11893|0)+z>>11;k=(Y(q,-8697)|0)+1024+(Y(G,-1730)|0)+z>>11;f[e+24>>2]=k;k=((y-B|0)*3363|0)+((j+w|0)*11086|0)|0;z=((B+v|0)*5461|0)+((m+w|0)*10217|0)|0;G=((s-B|0)*7350|0)+((p+w|0)*8956|0)|0;q=((y-v|0)*11529|0)+((m+j|0)*1136|0)|0;n=(Y(y+s|0,-10217)|0)+(Y(p+j|0,-5461)|0)|0;F=((v-s|0)*3363|0)+(Y(p+m|0,-11086)|0)|0;C=Y(y,-13631)|0;y=Y(m,-9222)|0;m=(Y(w,-18730)|0)+1024+(B*6387|0)+z+k+G>>11;f[e+4>>2]=m;f[e+12>>2]=(j*589|0)+1024+C+n+q+k>>11;f[e+20>>2]=y+1024+(v*10055|0)+F+q+z>>11;f[e+28>>2]=(p*8728|0)+1024+(s*17760|0)+F+n+G>>11;d=d+1|0;if((d|0)==8){H=7;I=a;break}else e=e+32|0}while(1){e=f[I>>2]|0;a=I+224|0;d=f[a>>2]|0;c=d+e|0;b=I+32|0;G=f[b>>2]|0;n=I+192|0;F=f[n>>2]|0;s=F+G|0;p=I+64|0;z=f[p>>2]|0;q=I+160|0;v=f[q>>2]|0;y=v+z|0;k=I+96|0;C=f[k>>2]|0;j=I+128|0;m=f[j>>2]|0;B=m+C|0;w=B+c|0;g=c-B|0;B=y+s|0;c=s-y|0;y=e-d|0;d=G-F|0;F=z-v|0;v=C-m|0;f[I>>2]=B+4+w>>3;f[j>>2]=4-B+w>>3;w=(g+c|0)*4433|0;f[p>>2]=(g*6270|0)+32768+w>>16;g=(Y(c,-15137)|0)+32768+w>>16;f[n>>2]=g;g=F+y|0;n=v+d|0;w=(n+g|0)*9633|0;c=Y(v+y|0,-7373)|0;p=Y(F+d|0,-20995)|0;B=w+(Y(g,-3196)|0)|0;g=w+(Y(n,-16069)|0)|0;f[b>>2]=(y*12299|0)+32768+c+B>>16;f[k>>2]=(d*25172|0)+32768+p+g>>16;f[q>>2]=(F*16819|0)+32768+p+B>>16;f[a>>2]=(v*2446|0)+32768+c+g>>16;if((H|0)>0){H=H+-1|0;I=I+4|0}else break}return}function WIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=a+224|0;g=e+32|0;do{b[e>>0]=0;e=e+1|0}while((e|0)<(g|0));e=0;g=a;while(1){i=(f[c+(e<<2)>>2]|0)+d|0;j=h[i>>0]|0;k=h[i+13>>0]|0;l=k+j|0;m=h[i+1>>0]|0;n=h[i+12>>0]|0;o=n+m|0;p=h[i+2>>0]|0;q=h[i+11>>0]|0;r=q+p|0;s=h[i+3>>0]|0;t=h[i+10>>0]|0;u=t+s|0;v=h[i+4>>0]|0;w=h[i+9>>0]|0;x=w+v|0;y=h[i+5>>0]|0;z=h[i+8>>0]|0;A=z+y|0;B=h[i+6>>0]|0;C=h[i+7>>0]|0;i=C+B|0;D=i+l|0;E=l-i|0;i=A+o|0;l=o-A|0;A=x+r|0;o=r-x|0;x=j-k|0;k=m-n|0;n=p-q|0;q=s-t|0;t=v-w|0;w=y-z|0;z=B-C|0;f[g>>2]=(A+u+i+D<<2)+-7168;C=u<<1;u=(Y(A-C|0,-7223)|0)+1024+((i-C|0)*2578|0)+((D-C|0)*10438|0)>>11;f[g+16>>2]=u;u=(E+l|0)*9058|0;f[g+8>>2]=(o*5027|0)+1024+(E*2237|0)+u>>11;E=(Y(o,-11295)|0)+1024+(Y(l,-14084)|0)+u>>11;f[g+24>>2]=E;E=n+k|0;u=w-t|0;f[g+28>>2]=x-E+q-u-z<<2;l=q<<13;q=(u*11512|0)-l+(Y(E,-1297)|0)|0;E=((z+t|0)*6164|0)+((n+x|0)*9810|0)|0;u=(Y(n,-19447)|0)+1024+(t*9175|0)+q+E>>11;f[g+20>>2]=u;u=((w-z|0)*3826|0)+((k+x|0)*10935|0)|0;t=(Y(k,-3474)|0)+1024+(Y(w,-25148)|0)+q+u>>11;f[g+12>>2]=t;t=(l|1024)+z+(Y(z+x|0,-9232)|0)+u+E>>11;f[g+4>>2]=t;e=e+1|0;if((e|0)==7){F=7;G=a;break}else g=g+32|0}while(1){g=f[G>>2]|0;a=G+192|0;e=f[a>>2]|0;d=e+g|0;c=G+32|0;t=f[c>>2]|0;E=G+160|0;u=f[E>>2]|0;x=u+t|0;z=G+64|0;l=f[z>>2]|0;q=G+128|0;w=f[q>>2]|0;k=w+l|0;n=G+96|0;o=f[n>>2]|0;C=g-e|0;e=t-u|0;u=l-w|0;w=k+d|0;f[G>>2]=((o+x+w|0)*10700|0)+32768>>16;l=((Y(o,-4)|0)+w|0)*3783|0;w=(d-k|0)*9850|0;t=(x-k|0)*3367|0;f[z>>2]=w+32768+t+l>>16;z=((d-x|0)*9434|0)+32768|0;d=z+t+(Y(x-(o<<1)|0,-7566)|0)>>16;f[q>>2]=d;f[a>>2]=z-w+l>>16;l=(e+C|0)*10009|0;w=(C-e|0)*1822|0;z=Y(u+e|0,-14752)|0;e=(u+C|0)*6565|0;f[c>>2]=32768-w+l+e>>16;f[n>>2]=w+32768+l+z>>16;f[E>>2]=(u*20017|0)+32768+e+z>>16;if((F|0)>0){F=F+-1|0;G=G+4|0}else break}return}function XIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=a+192|0;g=e+64|0;do{b[e>>0]=0;e=e+1|0}while((e|0)<(g|0));e=0;g=a;while(1){i=(f[c+(e<<2)>>2]|0)+d|0;j=h[i>>0]|0;k=h[i+11>>0]|0;l=k+j|0;m=h[i+1>>0]|0;n=h[i+10>>0]|0;o=n+m|0;p=h[i+2>>0]|0;q=h[i+9>>0]|0;r=q+p|0;s=h[i+3>>0]|0;t=h[i+8>>0]|0;u=t+s|0;v=h[i+4>>0]|0;w=h[i+7>>0]|0;x=w+v|0;y=h[i+5>>0]|0;z=h[i+6>>0]|0;i=z+y|0;A=i+l|0;B=l-i|0;i=o-x|0;l=u+r|0;C=r-u|0;u=j-k|0;k=m-n|0;n=p-q|0;q=s-t|0;t=v-w|0;w=y-z|0;f[g>>2]=(l+o+x+A<<2)+-6144;f[g+24>>2]=B-(i+C)<<2;f[g+16>>2]=((A-l|0)*10033|0)+1024>>11;f[g+8>>2]=1024-C+i+((B+C|0)*11190|0)>>11;C=(t+k|0)*4433|0;B=C+(k*6270|0)|0;k=C+(Y(t,-15137)|0)|0;t=(n+u|0)*9191|0;C=(q+u|0)*7053|0;i=Y(q+n|0,-1512)|0;l=Y(n,-19165)|0;A=Y(w,-9191)|0;x=Y(w+n|0,-4433)|0;n=(Y(u,-4758)|0)+1024+t+C+B+(w*1512|0)>>11;f[g+4>>2]=n;f[g+12>>2]=((u-q|0)*10703|0)+1024+k+x>>11;f[g+20>>2]=l+1024+t+i-k+(w*7053|0)>>11;f[g+28>>2]=(q*5946|0)+1024+i+C-B+A>>11;e=e+1|0;if((e|0)==6){D=7;E=a;break}else g=g+32|0}while(1){g=f[E>>2]|0;a=E+160|0;e=f[a>>2]|0;d=e+g|0;c=E+32|0;A=f[c>>2]|0;B=E+128|0;C=f[B>>2]|0;i=C+A|0;q=E+64|0;w=f[q>>2]|0;k=E+96|0;t=f[k>>2]|0;l=t+w|0;x=l+d|0;u=g-e|0;e=A-C|0;C=w-t|0;f[E>>2]=((x+i|0)*14564|0)+32768>>16;f[q>>2]=((d-l|0)*17837|0)+32768>>16;l=(((Y(i,-2)|0)+x|0)*10298|0)+32768>>16;f[B>>2]=l;l=(C+u|0)*5331|0;f[c>>2]=((e+u|0)*14564|0)+32768+l>>16;f[k>>2]=((u-e-C|0)*14564|0)+32768>>16;f[a>>2]=((C-e|0)*14564|0)+32768+l>>16;if((D|0)>0){D=D+-1|0;E=E+4|0}else break}return}function YIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=a+160|0;g=e+96|0;do{b[e>>0]=0;e=e+1|0}while((e|0)<(g|0));e=0;g=a;while(1){i=(f[c+(e<<2)>>2]|0)+d|0;j=h[i>>0]|0;k=h[i+9>>0]|0;l=k+j|0;m=h[i+1>>0]|0;n=h[i+8>>0]|0;o=n+m|0;p=h[i+2>>0]|0;q=h[i+7>>0]|0;r=q+p|0;s=h[i+3>>0]|0;t=h[i+6>>0]|0;u=t+s|0;v=h[i+4>>0]|0;w=h[i+5>>0]|0;i=w+v|0;x=i+l|0;y=l-i|0;i=u+o|0;l=o-u|0;u=j-k|0;k=m-n|0;n=p-q|0;q=s-t|0;t=v-w|0;f[g>>2]=(i+r+x<<2)+-5120;w=r<<1;r=(Y(i-w|0,-3580)|0)+1024+((x-w|0)*9373|0)>>11;f[g+16>>2]=r;r=(y+l|0)*6810|0;f[g+8>>2]=(y*4209|0)+1024+r>>11;y=(Y(l,-17828)|0)+1024+r>>11;f[g+24>>2]=y;y=t+u|0;r=k-q|0;f[g+20>>2]=y-(r+n)<<2;l=n<<13;f[g+4>>2]=(u*11443|0)+1024+(k*10323|0)+l+(q*5260|0)+(t*1812|0)>>11;n=(r<<12)-l+((y+r|0)*2531|0)|0;r=((u-t|0)*7791|0)+(Y(q+k|0,-4815)|0)+1024|0;f[g+12>>2]=r+n>>11;f[g+28>>2]=r-n>>11;e=e+1|0;if((e|0)==5){z=7;A=a;break}else g=g+32|0}while(1){g=f[A>>2]|0;a=A+128|0;e=f[a>>2]|0;d=e+g|0;c=A+32|0;n=f[c>>2]|0;r=A+96|0;k=f[r>>2]|0;q=k+n|0;t=A+64|0;u=f[t>>2]|0;y=q+d|0;l=g-e|0;e=n-k|0;f[A>>2]=((y+u|0)*10486|0)+16384>>15;k=(y-(u<<2)|0)*3707|0;u=((d-q|0)*8290|0)+16384|0;f[t>>2]=u+k>>15;f[a>>2]=u-k>>15;k=(e+l|0)*8716|0;f[c>>2]=(l*5387|0)+16384+k>>15;l=(Y(e,-22820)|0)+16384+k>>15;f[r>>2]=l;if((z|0)>0){z=z+-1|0;A=A+4|0}else break}return}function ZIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=a+128|0;g=e+128|0;do{b[e>>0]=0;e=e+1|0}while((e|0)<(g|0));e=0;g=a;while(1){i=(f[c+(e<<2)>>2]|0)+d|0;j=h[i>>0]|0;k=h[i+7>>0]|0;l=k+j|0;m=h[i+1>>0]|0;n=h[i+6>>0]|0;o=n+m|0;p=h[i+2>>0]|0;q=h[i+5>>0]|0;r=q+p|0;s=h[i+3>>0]|0;t=h[i+4>>0]|0;i=t+s|0;u=i+l|0;v=l-i|0;i=r+o|0;l=o-r|0;r=j-k|0;k=m-n|0;n=p-q|0;q=s-t|0;f[g>>2]=(u+i<<3)+-8192;f[g+16>>2]=u-i<<3;i=((v+l|0)*4433|0)+512|0;f[g+8>>2]=i+(v*6270|0)>>10;v=i+(Y(l,-15137)|0)>>10;f[g+24>>2]=v;v=n+r|0;l=q+k|0;i=((l+v|0)*9633|0)+512|0;u=Y(q+r|0,-7373)|0;t=Y(n+k|0,-20995)|0;s=i+(Y(v,-3196)|0)|0;v=i+(Y(l,-16069)|0)|0;f[g+4>>2]=u+(r*12299|0)+s>>10;f[g+12>>2]=t+(k*25172|0)+v>>10;f[g+20>>2]=t+(n*16819|0)+s>>10;f[g+28>>2]=u+(q*2446|0)+v>>10;e=e+1|0;if((e|0)==4){w=7;x=a;break}else g=g+32|0}while(1){g=f[x>>2]|0;a=x+96|0;e=f[a>>2]|0;d=g+2+e|0;c=x+32|0;v=f[c>>2]|0;q=x+64|0;u=f[q>>2]|0;s=u+v|0;n=g-e|0;e=v-u|0;f[x>>2]=s+d>>2;f[q>>2]=d-s>>2;s=((e+n|0)*4433|0)+16384|0;f[c>>2]=s+(n*6270|0)>>15;n=s+(Y(e,-15137)|0)>>15;f[a>>2]=n;if((w|0)>0){w=w+-1|0;x=x+4|0}else break}return}function _Ia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;F1a(a|0,0,256)|0;d=(f[b>>2]|0)+c|0;e=h[d>>0]|0;g=h[d+5>>0]|0;i=g+e|0;j=h[d+1>>0]|0;k=h[d+4>>0]|0;l=k+j|0;m=h[d+2>>0]|0;n=h[d+3>>0]|0;d=n+m|0;o=d+i|0;p=e-g|0;g=j-k|0;k=m-n|0;f[a>>2]=(o+l<<3)+-6144;f[a+8>>2]=((i-d|0)*10033|0)+512>>10;d=(((Y(l,-2)|0)+o|0)*5793|0)+512>>10;f[a+16>>2]=d;d=((k+p|0)*2998|0)+512>>10;o=a+4|0;f[o>>2]=d+(g+p<<3);f[a+12>>2]=p-g-k<<3;f[a+20>>2]=d+(k-g<<3);g=a+32|0;k=(f[b+4>>2]|0)+c|0;d=h[k>>0]|0;p=h[k+5>>0]|0;l=p+d|0;i=h[k+1>>0]|0;n=h[k+4>>0]|0;m=n+i|0;j=h[k+2>>0]|0;e=h[k+3>>0]|0;k=e+j|0;q=k+l|0;r=d-p|0;p=i-n|0;n=j-e|0;e=(q+m<<3)+-6144|0;f[g>>2]=e;f[a+40>>2]=((l-k|0)*10033|0)+512>>10;k=(((Y(m,-2)|0)+q|0)*5793|0)+512>>10;f[a+48>>2]=k;k=((n+r|0)*2998|0)+512>>10;q=k+(p+r<<3)|0;f[a+36>>2]=q;f[a+44>>2]=r-p-n<<3;f[a+52>>2]=k+(n-p<<3);p=(f[b+8>>2]|0)+c|0;c=h[p>>0]|0;b=h[p+5>>0]|0;n=b+c|0;k=h[p+1>>0]|0;r=h[p+4>>0]|0;m=r+k|0;l=h[p+2>>0]|0;j=h[p+3>>0]|0;p=j+l|0;i=p+n|0;d=c-b|0;b=k-r|0;r=l-j|0;j=(i+m<<3)+-6144|0;l=((n-p|0)*10033|0)+512>>10;p=(((Y(m,-2)|0)+i|0)*5793|0)+512>>10;f[a+80>>2]=p;p=((r+d|0)*2998|0)+512>>10;i=p+(b+d<<3)|0;m=d-b-r<<3;f[a+84>>2]=p+(r-b<<3);b=f[a>>2]|0;r=j+b|0;f[a>>2]=((r+e|0)*14564|0)+16384>>15;p=(((Y(e,-2)|0)+r|0)*10298|0)+16384>>15;f[a+64>>2]=p;f[g>>2]=((b-j|0)*17837|0)+16384>>15;j=f[o>>2]|0;b=i+j|0;f[o>>2]=((b+q|0)*14564|0)+16384>>15;o=(((Y(q,-2)|0)+b|0)*10298|0)+16384>>15;f[a+68>>2]=o;f[a+36>>2]=((j-i|0)*17837|0)+16384>>15;i=a+8|0;j=f[i>>2]|0;o=l+j|0;b=a+40|0;q=f[b>>2]|0;f[i>>2]=((o+q|0)*14564|0)+16384>>15;i=(((Y(q,-2)|0)+o|0)*10298|0)+16384>>15;f[a+72>>2]=i;f[b>>2]=((j-l|0)*17837|0)+16384>>15;l=a+12|0;j=f[l>>2]|0;b=m+j|0;i=a+44|0;o=f[i>>2]|0;f[l>>2]=((b+o|0)*14564|0)+16384>>15;l=(((Y(o,-2)|0)+b|0)*10298|0)+16384>>15;f[a+76>>2]=l;f[i>>2]=((j-m|0)*17837|0)+16384>>15;m=a+16|0;j=f[m>>2]|0;i=a+80|0;l=f[i>>2]|0;b=l+j|0;o=a+48|0;q=f[o>>2]|0;f[m>>2]=((b+q|0)*14564|0)+16384>>15;m=(((Y(q,-2)|0)+b|0)*10298|0)+16384>>15;f[i>>2]=m;f[o>>2]=((j-l|0)*17837|0)+16384>>15;l=a+20|0;j=f[l>>2]|0;o=a+84|0;m=f[o>>2]|0;i=m+j|0;b=a+52|0;a=f[b>>2]|0;f[l>>2]=((i+a|0)*14564|0)+16384>>15;l=(((Y(a,-2)|0)+i|0)*10298|0)+16384>>15;f[o>>2]=l;f[b>>2]=((j-m|0)*17837|0)+16384>>15;return}function $Ia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;F1a(a|0,0,256)|0;d=(f[b>>2]|0)+c|0;e=h[d>>0]|0;g=h[d+3>>0]|0;i=g+e|0;j=h[d+1>>0]|0;k=h[d+2>>0]|0;d=k+j|0;l=e-g|0;g=j-k|0;k=d+i<<5;f[a>>2]=k+-16384;j=i-d<<5;f[a+8>>2]=j;d=((g+l|0)*4433|0)+128|0;i=d+(l*6270|0)>>8;l=a+4|0;f[l>>2]=i;e=d+(Y(g,-15137)|0)>>8;f[a+12>>2]=e;g=(f[b+4>>2]|0)+c|0;c=h[g>>0]|0;b=h[g+3>>0]|0;d=b+c|0;m=h[g+1>>0]|0;n=h[g+2>>0]|0;g=n+m|0;o=c-b|0;b=m-n|0;n=(g+d<<5)+-16384|0;m=d-g<<5;g=((b+o|0)*4433|0)+128|0;d=g+(o*6270|0)>>8;o=g+(Y(b,-15137)|0)>>8;b=k+-16382|0;f[a>>2]=b+n>>2;f[a+32>>2]=b-n>>2;n=i+2|0;f[l>>2]=n+d>>2;f[a+36>>2]=n-d>>2;d=j|2;f[a+8>>2]=d+m>>2;f[a+40>>2]=d-m>>2;m=e+2|0;f[a+12>>2]=m+o>>2;f[a+44>>2]=m-o>>2;return}function aJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;F1a(a|0,0,256)|0;d=(f[b>>2]|0)+c|0;c=h[d>>0]|0;b=h[d+1>>0]|0;f[a>>2]=(b+c<<5)+-8192;f[a+4>>2]=c-b<<5;return}function bJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=u;u=u+256|0;e=d;g=0;i=a;a:while(1){j=(f[b+(g<<2)>>2]|0)+c|0;k=h[j>>0]|0;l=h[j+7>>0]|0;m=l+k|0;n=h[j+1>>0]|0;o=h[j+6>>0]|0;p=o+n|0;q=h[j+2>>0]|0;r=h[j+5>>0]|0;s=r+q|0;t=h[j+3>>0]|0;v=h[j+4>>0]|0;j=v+t|0;w=j+m|0;x=m-j|0;j=s+p|0;m=p-s|0;s=k-l|0;l=n-o|0;o=q-r|0;r=t-v|0;f[i>>2]=(w+j<<2)+-4096;f[i+16>>2]=w-j<<2;j=(x+m|0)*4433|0;f[i+8>>2]=(x*6270|0)+1024+j>>11;x=(Y(m,-15137)|0)+1024+j>>11;f[i+24>>2]=x;x=o+s|0;j=r+l|0;m=(j+x|0)*9633|0;w=Y(r+s|0,-7373)|0;v=Y(o+l|0,-20995)|0;t=m+(Y(x,-3196)|0)|0;x=m+(Y(j,-16069)|0)|0;f[i+4>>2]=(s*12299|0)+1024+w+t>>11;f[i+12>>2]=(l*25172|0)+1024+v+x>>11;f[i+20>>2]=(o*16819|0)+1024+v+t>>11;f[i+28>>2]=(r*2446|0)+1024+w+x>>11;switch(g|0){case 7:{g=8;i=e;continue a;break}case 15:{y=7;z=a;A=e;break a;break}default:{}}g=g+1|0;i=i+32|0}while(1){i=f[z>>2]|0;g=f[A+224>>2]|0;e=g+i|0;a=z+32|0;c=f[a>>2]|0;b=f[A+192>>2]|0;x=b+c|0;w=z+64|0;r=f[w>>2]|0;t=f[A+160>>2]|0;v=t+r|0;o=z+96|0;l=f[o>>2]|0;s=f[A+128>>2]|0;j=s+l|0;m=z+128|0;q=f[m>>2]|0;n=f[A+96>>2]|0;k=n+q|0;p=z+160|0;B=f[p>>2]|0;C=f[A+64>>2]|0;D=C+B|0;E=z+192|0;F=f[E>>2]|0;G=f[A+32>>2]|0;H=G+F|0;I=z+224|0;J=f[I>>2]|0;K=f[A>>2]|0;L=K+J|0;M=L+e|0;N=e-L|0;L=H+x|0;e=x-H|0;H=D+v|0;x=v-D|0;D=k+j|0;v=j-k|0;k=i-g|0;g=c-b|0;b=r-t|0;t=l-s|0;s=q-n|0;n=B-C|0;C=F-G|0;G=J-K|0;f[z>>2]=D+4+H+L+M>>3;f[m>>2]=((L-H|0)*4433|0)+32768+((M-D|0)*10703|0)>>16;D=((N-x|0)*11363|0)+((v-e|0)*2260|0)|0;f[w>>2]=(x*17799|0)+32768+(e*11893|0)+D>>16;e=(Y(v,-8697)|0)+32768+(Y(N,-1730)|0)+D>>16;f[E>>2]=e;e=((C-G|0)*3363|0)+((g+k|0)*11086|0)|0;E=((G+n|0)*5461|0)+((b+k|0)*10217|0)|0;D=((s-G|0)*7350|0)+((t+k|0)*8956|0)|0;N=((C-n|0)*11529|0)+((b+g|0)*1136|0)|0;v=(Y(C+s|0,-10217)|0)+(Y(t+g|0,-5461)|0)|0;x=((n-s|0)*3363|0)+(Y(t+b|0,-11086)|0)|0;w=Y(C,-13631)|0;C=Y(b,-9222)|0;b=(Y(k,-18730)|0)+32768+(G*6387|0)+E+e+D>>16;f[a>>2]=b;f[o>>2]=(g*589|0)+32768+w+v+N+e>>16;f[p>>2]=C+32768+(n*10055|0)+x+N+E>>16;f[I>>2]=(t*8728|0)+32768+(s*17760|0)+x+v+D>>16;if((y|0)>0){y=y+-1|0;z=z+4|0;A=A+4|0}else break}u=d;return}function cJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=u;u=u+192|0;e=d;F1a(a|0,0,256)|0;g=0;i=a;a:while(1){j=(f[b+(g<<2)>>2]|0)+c|0;k=h[j>>0]|0;l=h[j+6>>0]|0;m=l+k|0;n=h[j+1>>0]|0;o=h[j+5>>0]|0;p=o+n|0;q=h[j+2>>0]|0;r=h[j+4>>0]|0;s=r+q|0;t=h[j+3>>0]|0;j=k-l|0;l=n-o|0;o=q-r|0;r=s+m|0;f[i>>2]=(t+p+r<<2)+-3584;q=((Y(t,-4)|0)+r|0)*2896|0;r=(m-s|0)*7542|0;n=(p-s|0)*2578|0;f[i+8>>2]=r+1024+n+q>>11;s=((m-p|0)*7223|0)+1024|0;m=s+n+(Y(p-(t<<1)|0,-5793)|0)>>11;f[i+16>>2]=m;f[i+24>>2]=s-r+q>>11;q=(l+j|0)*7663|0;r=(j-l|0)*1395|0;s=Y(o+l|0,-11295)|0;l=(o+j|0)*5027|0;f[i+4>>2]=1024-r+q+l>>11;f[i+12>>2]=r+1024+q+s>>11;f[i+20>>2]=(o*15326|0)+1024+l+s>>11;switch(g|0){case 7:{g=8;i=e;continue a;break}case 13:{v=0;w=a;x=e;break a;break}default:{}}g=g+1|0;i=i+32|0}while(1){i=f[w>>2]|0;g=f[x+160>>2]|0;e=g+i|0;a=w+32|0;c=f[a>>2]|0;b=f[x+128>>2]|0;s=b+c|0;l=w+64|0;o=f[l>>2]|0;q=f[x+96>>2]|0;r=q+o|0;j=w+96|0;m=f[j>>2]|0;t=f[x+64>>2]|0;p=t+m|0;n=w+128|0;k=f[n>>2]|0;y=f[x+32>>2]|0;z=y+k|0;A=w+160|0;B=f[A>>2]|0;C=f[x>>2]|0;D=C+B|0;E=w+192|0;F=f[E>>2]|0;G=w+224|0;H=f[G>>2]|0;I=H+F|0;J=I+e|0;K=e-I|0;I=D+s|0;e=s-D|0;D=z+r|0;s=r-z|0;z=i-g|0;g=c-b|0;b=o-q|0;q=m-t|0;t=k-y|0;y=B-C|0;C=F-H|0;f[w>>2]=((D+p+I+J|0)*5350|0)+16384>>15;H=p<<1;p=(Y(D-H|0,-4717)|0)+16384+((I-H|0)*1684|0)+((J-H|0)*6817|0)>>15;f[n>>2]=p;p=(K+e|0)*5915|0;f[l>>2]=(s*3283|0)+16384+(K*1461|0)+p>>15;K=(Y(s,-7376)|0)+16384+(Y(e,-9198)|0)+p>>15;f[E>>2]=K;K=b+g|0;E=y-t|0;f[G>>2]=((z-K+q-E-C|0)*5350|0)+16384>>15;G=q*5350|0;q=(E*7518|0)-G+(Y(K,-847)|0)|0;K=((C+t|0)*4025|0)+((b+z|0)*6406|0)|0;E=(Y(b,-12700)|0)+16384+(t*5992|0)+q+K>>15;f[A>>2]=E;E=((y-C|0)*2499|0)+((g+z|0)*7141|0)|0;A=(Y(g,-2269)|0)+16384+(Y(y,-16423)|0)+q+E>>15;f[j>>2]=A;A=(Y(z,-6029)|0)+16384+G+(Y(C,-679)|0)+E+K>>15;f[a>>2]=A;v=v+1|0;if((v|0)==7)break;else{w=w+4|0;x=x+4|0}}u=d;return}function dJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=u;u=u+128|0;e=d;F1a(a|0,0,256)|0;g=0;i=a;a:while(1){j=(f[b+(g<<2)>>2]|0)+c|0;k=h[j>>0]|0;l=h[j+5>>0]|0;m=l+k|0;n=h[j+1>>0]|0;o=h[j+4>>0]|0;p=o+n|0;q=h[j+2>>0]|0;r=h[j+3>>0]|0;j=r+q|0;s=j+m|0;t=k-l|0;l=n-o|0;o=q-r|0;f[i>>2]=(s+p<<2)+-3072;f[i+8>>2]=((m-j|0)*10033|0)+1024>>11;j=(((Y(p,-2)|0)+s|0)*5793|0)+1024>>11;f[i+16>>2]=j;j=((o+t|0)*2998|0)+1024>>11;f[i+4>>2]=j+(l+t<<2);f[i+12>>2]=t-l-o<<2;f[i+20>>2]=j+(o-l<<2);switch(g|0){case 7:{g=8;i=e;continue a;break}case 11:{v=0;w=a;x=e;break a;break}default:{}}g=g+1|0;i=i+32|0}while(1){i=f[w>>2]|0;g=f[x+96>>2]|0;e=g+i|0;a=w+32|0;c=f[a>>2]|0;b=f[x+64>>2]|0;l=b+c|0;o=w+64|0;j=f[o>>2]|0;t=f[x+32>>2]|0;s=t+j|0;p=w+96|0;m=f[p>>2]|0;r=f[x>>2]|0;q=r+m|0;n=w+128|0;k=f[n>>2]|0;y=w+224|0;z=f[y>>2]|0;A=z+k|0;B=w+160|0;C=f[B>>2]|0;D=w+192|0;E=f[D>>2]|0;F=E+C|0;G=F+e|0;H=e-F|0;F=l-A|0;e=q+s|0;I=s-q|0;q=i-g|0;g=c-b|0;b=j-t|0;t=m-r|0;r=k-z|0;z=C-E|0;f[w>>2]=((e+l+A+G|0)*7282|0)+16384>>15;f[D>>2]=((H-(F+I)|0)*7282|0)+16384>>15;f[n>>2]=((G-e|0)*8918|0)+16384>>15;f[o>>2]=((F-I|0)*7282|0)+16384+((H+I|0)*9947|0)>>15;I=(r+g|0)*3941|0;H=I+(g*5573|0)|0;g=I+(Y(r,-13455)|0)|0;r=(b+q|0)*8170|0;I=(t+q|0)*6269|0;F=Y(t+b|0,-1344)|0;o=Y(b,-17036)|0;e=Y(z,-8170)|0;G=Y(z+b|0,-3941)|0;b=(Y(q,-4229)|0)+16384+r+I+H+(z*1344|0)>>15;f[a>>2]=b;f[p>>2]=((q-t|0)*9514|0)+16384+g+G>>15;f[B>>2]=o+16384+r+F-g+(z*6269|0)>>15;f[y>>2]=(t*5285|0)+16384+F+I-H+e>>15;v=v+1|0;if((v|0)==6)break;else{w=w+4|0;x=x+4|0}}u=d;return}function eJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+64|0;e=d;F1a(a|0,0,256)|0;g=0;i=a;a:while(1){j=(f[b+(g<<2)>>2]|0)+c|0;k=h[j>>0]|0;l=h[j+4>>0]|0;m=l+k|0;n=h[j+1>>0]|0;o=h[j+3>>0]|0;p=o+n|0;q=h[j+2>>0]|0;j=p+m|0;r=k-l|0;l=n-o|0;f[i>>2]=(j+q<<2)+-2560;o=(j-(q<<2)|0)*2896|0;q=((m-p|0)*6476|0)+1024|0;f[i+8>>2]=q+o>>11;f[i+16>>2]=q-o>>11;o=(l+r|0)*6810|0;f[i+4>>2]=(r*4209|0)+1024+o>>11;r=(Y(l,-17828)|0)+1024+o>>11;f[i+12>>2]=r;switch(g|0){case 7:{g=8;i=e;continue a;break}case 9:{s=0;t=a;v=e;break a;break}default:{}}g=g+1|0;i=i+32|0}while(1){i=f[t>>2]|0;g=f[v+32>>2]|0;e=g+i|0;a=t+32|0;c=f[a>>2]|0;b=f[v>>2]|0;r=b+c|0;o=t+64|0;l=f[o>>2]|0;q=t+224|0;p=f[q>>2]|0;m=p+l|0;j=t+96|0;n=f[j>>2]|0;k=t+192|0;w=f[k>>2]|0;x=w+n|0;y=t+128|0;z=f[y>>2]|0;A=t+160|0;B=f[A>>2]|0;C=B+z|0;D=C+e|0;E=e-C|0;C=x+r|0;e=r-x|0;x=i-g|0;g=c-b|0;b=l-p|0;p=n-w|0;w=z-B|0;f[t>>2]=((C+m+D|0)*10486|0)+16384>>15;B=m<<1;m=(Y(C-B|0,-4582)|0)+16384+((D-B|0)*11997|0)>>15;f[y>>2]=m;m=(E+e|0)*8716|0;f[o>>2]=(E*5387|0)+16384+m>>15;E=(Y(e,-22820)|0)+16384+m>>15;f[k>>2]=E;E=w+x|0;k=g-p|0;f[A>>2]=((E-(k+b)|0)*10486|0)+16384>>15;A=b*10486|0;f[a>>2]=(x*14647|0)+16384+(g*13213|0)+A+(p*6732|0)+(w*2320|0)>>15;a=(k*5243|0)-A+((E+k|0)*3240|0)|0;k=((x-w|0)*9973|0)+(Y(p+g|0,-6163)|0)+16384|0;f[j>>2]=k+a>>15;f[q>>2]=k-a>>15;s=s+1|0;if((s|0)==5)break;else{t=t+4|0;v=v+4|0}}u=d;return}function fJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;F1a(a|0,0,256)|0;d=0;e=a;while(1){g=(f[b+(d<<2)>>2]|0)+c|0;i=h[g>>0]|0;j=h[g+3>>0]|0;k=j+i|0;l=h[g+1>>0]|0;m=h[g+2>>0]|0;g=m+l|0;n=i-j|0;j=l-m|0;f[e>>2]=(g+k<<3)+-4096;f[e+8>>2]=k-g<<3;g=((j+n|0)*4433|0)+512|0;f[e+4>>2]=g+(n*6270|0)>>10;n=g+(Y(j,-15137)|0)>>10;f[e+12>>2]=n;d=d+1|0;if((d|0)==8){o=0;p=a;break}else e=e+32|0}while(1){e=f[p>>2]|0;a=p+224|0;d=f[a>>2]|0;c=d+e|0;b=p+32|0;n=f[b>>2]|0;j=p+192|0;g=f[j>>2]|0;k=g+n|0;m=p+64|0;l=f[m>>2]|0;i=p+160|0;q=f[i>>2]|0;r=q+l|0;s=p+96|0;t=f[s>>2]|0;u=p+128|0;v=f[u>>2]|0;w=v+t|0;x=c+2+w|0;y=c-w|0;w=r+k|0;c=k-r|0;r=e-d|0;d=n-g|0;g=l-q|0;q=t-v|0;f[p>>2]=x+w>>2;f[u>>2]=x-w>>2;w=((y+c|0)*4433|0)+16384|0;f[m>>2]=w+(y*6270|0)>>15;y=w+(Y(c,-15137)|0)>>15;f[j>>2]=y;y=g+r|0;j=q+d|0;c=((j+y|0)*9633|0)+16384|0;w=Y(q+r|0,-7373)|0;m=Y(g+d|0,-20995)|0;x=c+(Y(y,-3196)|0)|0;y=c+(Y(j,-16069)|0)|0;f[b>>2]=w+(r*12299|0)+x>>15;f[s>>2]=m+(d*25172|0)+y>>15;f[i>>2]=m+(g*16819|0)+x>>15;f[a>>2]=w+(q*2446|0)+y>>15;o=o+1|0;if((o|0)==4)break;else p=p+4|0}return}function gJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;F1a(a|0,0,256)|0;d=(f[b>>2]|0)+c|0;e=h[d>>0]|0;g=h[d+2>>0]|0;i=g+e|0;j=h[d+1>>0]|0;f[a>>2]=(i+j<<3)+-3072;d=(((Y(j,-2)|0)+i|0)*5793|0)+512>>10;f[a+8>>2]=d;d=a+4|0;f[d>>2]=((e-g|0)*10033|0)+512>>10;g=a+32|0;e=(f[b+4>>2]|0)+c|0;i=h[e>>0]|0;j=h[e+2>>0]|0;k=j+i|0;l=h[e+1>>0]|0;f[g>>2]=(k+l<<3)+-3072;e=(((Y(l,-2)|0)+k|0)*5793|0)+512>>10;f[a+40>>2]=e;f[a+36>>2]=((i-j|0)*10033|0)+512>>10;j=(f[b+8>>2]|0)+c|0;i=h[j>>0]|0;e=h[j+2>>0]|0;k=e+i|0;l=h[j+1>>0]|0;f[a+64>>2]=(k+l<<3)+-3072;j=(((Y(l,-2)|0)+k|0)*5793|0)+512>>10;f[a+72>>2]=j;f[a+68>>2]=((i-e|0)*10033|0)+512>>10;e=(f[b+12>>2]|0)+c|0;i=h[e>>0]|0;j=h[e+2>>0]|0;k=j+i|0;l=h[e+1>>0]|0;f[a+96>>2]=(k+l<<3)+-3072;e=(((Y(l,-2)|0)+k|0)*5793|0)+512>>10;f[a+104>>2]=e;f[a+100>>2]=((i-j|0)*10033|0)+512>>10;j=(f[b+16>>2]|0)+c|0;i=h[j>>0]|0;e=h[j+2>>0]|0;k=e+i|0;l=h[j+1>>0]|0;f[a+128>>2]=(k+l<<3)+-3072;j=(((Y(l,-2)|0)+k|0)*5793|0)+512>>10;f[a+136>>2]=j;f[a+132>>2]=((i-e|0)*10033|0)+512>>10;e=(f[b+20>>2]|0)+c|0;c=h[e>>0]|0;b=h[e+2>>0]|0;i=b+c|0;j=h[e+1>>0]|0;f[a+160>>2]=(i+j<<3)+-3072;e=(((Y(j,-2)|0)+i|0)*5793|0)+512>>10;f[a+168>>2]=e;e=((c-b|0)*10033|0)+512>>10;f[a+164>>2]=e;b=f[a>>2]|0;c=a+160|0;i=f[c>>2]|0;j=i+b|0;k=f[g>>2]|0;l=a+128|0;m=f[l>>2]|0;n=m+k|0;o=a+64|0;p=f[o>>2]|0;q=a+96|0;r=f[q>>2]|0;s=r+p|0;t=s+j|0;u=b-i|0;i=k-m|0;m=p-r|0;f[a>>2]=((t+n|0)*14564|0)+16384>>15;f[o>>2]=((j-s|0)*17837|0)+16384>>15;s=(((Y(n,-2)|0)+t|0)*10298|0)+16384>>15;f[l>>2]=s;s=(m+u|0)*5331|0;f[g>>2]=((i+u|0)*14564|0)+16384+s>>15;f[q>>2]=((u-i-m|0)*14564|0)+16384>>15;f[c>>2]=((m-i|0)*14564|0)+16384+s>>15;s=f[d>>2]|0;i=e+s|0;m=a+36|0;c=f[m>>2]|0;u=a+132|0;q=f[u>>2]|0;g=q+c|0;l=a+68|0;t=f[l>>2]|0;n=a+100|0;j=f[n>>2]|0;o=j+t|0;r=o+i|0;p=s-e|0;e=c-q|0;q=t-j|0;f[d>>2]=((r+g|0)*14564|0)+16384>>15;f[l>>2]=((i-o|0)*17837|0)+16384>>15;o=(((Y(g,-2)|0)+r|0)*10298|0)+16384>>15;f[u>>2]=o;o=(q+p|0)*5331|0;f[m>>2]=((e+p|0)*14564|0)+16384+o>>15;f[n>>2]=((p-e-q|0)*14564|0)+16384>>15;f[a+164>>2]=((q-e|0)*14564|0)+16384+o>>15;o=a+8|0;e=f[o>>2]|0;q=a+168|0;p=f[q>>2]|0;n=p+e|0;m=a+40|0;u=f[m>>2]|0;r=a+136|0;g=f[r>>2]|0;i=g+u|0;l=a+72|0;d=f[l>>2]|0;j=a+104|0;a=f[j>>2]|0;t=a+d|0;c=t+n|0;s=e-p|0;p=u-g|0;g=d-a|0;f[o>>2]=((c+i|0)*14564|0)+16384>>15;f[l>>2]=((n-t|0)*17837|0)+16384>>15;t=(((Y(i,-2)|0)+c|0)*10298|0)+16384>>15;f[r>>2]=t;t=(g+s|0)*5331|0;f[m>>2]=((p+s|0)*14564|0)+16384+t>>15;f[j>>2]=((s-p-g|0)*14564|0)+16384>>15;f[q>>2]=((g-p|0)*14564|0)+16384+t>>15;return}function hJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;F1a(a|0,0,256)|0;d=(f[b>>2]|0)+c|0;e=h[d>>0]|0;g=h[d+1>>0]|0;d=(g+e<<3)+-2048|0;f[a>>2]=d;i=e-g<<3;g=a+4|0;f[g>>2]=i;e=a+32|0;j=(f[b+4>>2]|0)+c|0;k=h[j>>0]|0;l=h[j+1>>0]|0;j=(l+k<<3)+-2048|0;f[e>>2]=j;m=k-l<<3;f[a+36>>2]=m;l=(f[b+8>>2]|0)+c|0;k=h[l>>0]|0;n=h[l+1>>0]|0;l=(n+k<<3)+-2048|0;f[a+64>>2]=l;o=k-n<<3;f[a+68>>2]=o;n=(f[b+12>>2]|0)+c|0;c=h[n>>0]|0;b=h[n+1>>0]|0;n=(b+c<<3)+-2048|0;k=c-b<<3;b=n+d|0;c=l+j|0;p=d-n|0;n=j-l|0;f[a>>2]=c+b;f[a+64>>2]=b-c;c=((n+p|0)*4433|0)+4096|0;f[e>>2]=c+(p*6270|0)>>13;p=c+(Y(n,-15137)|0)>>13;f[a+96>>2]=p;p=k+i|0;n=o+m|0;c=i-k|0;k=m-o|0;f[g>>2]=n+p;f[a+68>>2]=p-n;n=((k+c|0)*4433|0)+4096|0;f[a+36>>2]=n+(c*6270|0)>>13;c=n+(Y(k,-15137)|0)>>13;f[a+100>>2]=c;return}function iJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;F1a(a|0,0,256)|0;d=h[(f[b>>2]|0)+c>>0]|0;e=h[(f[b+4>>2]|0)+c>>0]|0;f[a>>2]=(e+d<<5)+-8192;f[a+32>>2]=d-e<<5;return}function jJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0,G=0;i=u;u=u+256|0;j=i;k=f[a+336>>2]|0;a=8;l=e;e=f[c+84>>2]|0;c=j;while(1){m=d[l+16>>1]|0;o=d[l+32>>1]|0;if(!((m|o)<<16>>16))if(((((d[l+48>>1]|0)==0?(d[l+64>>1]|0)==0:0)?(d[l+80>>1]|0)==0:0)?(d[l+96>>1]|0)==0:0)?(d[l+112>>1]|0)==0:0){p=+(d[l>>1]|0)*+n[e>>2];n[c>>2]=p;n[c+32>>2]=p;n[c+64>>2]=p;n[c+96>>2]=p;n[c+128>>2]=p;n[c+160>>2]=p;n[c+192>>2]=p;q=56;r=p}else{s=0;t=9}else{s=o;t=9}if((t|0)==9){t=0;p=+(d[l>>1]|0)*+n[e>>2];v=+(s<<16>>16)*+n[e+64>>2];w=+(d[l+64>>1]|0)*+n[e+128>>2];x=+(d[l+96>>1]|0)*+n[e+192>>2];y=p+w;z=p-w;w=v+x;p=(v-x)*1.4142135381698608-w;x=y+w;v=y-w;w=z+p;y=z-p;p=+(m<<16>>16)*+n[e+32>>2];z=+(d[l+48>>1]|0)*+n[e+96>>2];A=+(d[l+80>>1]|0)*+n[e+160>>2];B=+(d[l+112>>1]|0)*+n[e+224>>2];C=z+A;D=A-z;z=p+B;A=p-B;B=C+z;p=(D+A)*1.8477590084075928;E=p-D*2.613126039505005-B;D=(z-C)*1.4142135381698608-E;C=p-A*1.0823922157287598-D;n[c>>2]=x+B;n[c+224>>2]=x-B;n[c+32>>2]=w+E;n[c+192>>2]=w-E;n[c+64>>2]=y+D;n[c+160>>2]=y-D;n[c+96>>2]=v+C;q=32;r=v-C}n[c+(q<<2)>>2]=r;if((a|0)>1){a=a+-1|0;l=l+2|0;e=e+4|0;c=c+4|0}else{F=0;G=j;break}}while(1){j=(f[g+(F<<2)>>2]|0)+h|0;r=+n[G>>2]+128.5;C=+n[G+16>>2];v=r+C;D=r-C;C=+n[G+8>>2];r=+n[G+24>>2];y=C+r;E=(C-r)*1.4142135381698608-y;r=v+y;C=v-y;y=D+E;v=D-E;E=+n[G+20>>2];D=+n[G+12>>2];w=E+D;B=E-D;D=+n[G+4>>2];E=+n[G+28>>2];x=D+E;A=D-E;E=w+x;D=(B+A)*1.8477590084075928;p=D-B*2.613126039505005-E;B=(x-w)*1.4142135381698608-p;w=D-A*1.0823922157287598-B;b[j>>0]=b[k+(~~(r+E)&1023)>>0]|0;b[j+7>>0]=b[k+(~~(r-E)&1023)>>0]|0;b[j+1>>0]=b[k+(~~(y+p)&1023)>>0]|0;b[j+6>>0]=b[k+(~~(y-p)&1023)>>0]|0;b[j+2>>0]=b[k+(~~(v+B)&1023)>>0]|0;b[j+5>>0]=b[k+(~~(v-B)&1023)>>0]|0;b[j+3>>0]=b[k+(~~(C+w)&1023)>>0]|0;b[j+4>>0]=b[k+(~~(C-w)&1023)>>0]|0;F=F+1|0;if((F|0)==8)break;else G=G+32|0}u=i;return}function kJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+256|0;j=i;k=f[a+336>>2]|0;a=8;l=e;e=f[c+84>>2]|0;c=j;while(1){m=d[l+16>>1]|0;n=d[l+32>>1]|0;if(!((m|n)<<16>>16))if(((((d[l+48>>1]|0)==0?(d[l+64>>1]|0)==0:0)?(d[l+80>>1]|0)==0:0)?(d[l+96>>1]|0)==0:0)?(d[l+112>>1]|0)==0:0){o=Y(d[l>>1]|0,f[e>>2]|0)|0;f[c>>2]=o;f[c+32>>2]=o;f[c+64>>2]=o;f[c+96>>2]=o;f[c+128>>2]=o;f[c+160>>2]=o;f[c+192>>2]=o;p=56;q=o}else{r=0;s=9}else{r=n;s=9}if((s|0)==9){s=0;n=Y(d[l>>1]|0,f[e>>2]|0)|0;o=Y(r<<16>>16,f[e+64>>2]|0)|0;t=Y(d[l+64>>1]|0,f[e+128>>2]|0)|0;v=Y(d[l+96>>1]|0,f[e+192>>2]|0)|0;w=t+n|0;x=n-t|0;t=v+o|0;n=((o-v|0)*362>>8)-t|0;v=t+w|0;o=w-t|0;t=n+x|0;w=x-n|0;n=Y(m<<16>>16,f[e+32>>2]|0)|0;m=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;x=Y(d[l+80>>1]|0,f[e+160>>2]|0)|0;y=Y(d[l+112>>1]|0,f[e+224>>2]|0)|0;z=x+m|0;A=x-m|0;m=y+n|0;x=n-y|0;y=m+z|0;n=(x+A|0)*473>>8;B=((Y(A,-669)|0)>>8)-y+n|0;A=((m-z|0)*362>>8)-B|0;z=A+((x*277>>8)-n)|0;f[c>>2]=y+v;f[c+224>>2]=v-y;f[c+32>>2]=B+t;f[c+192>>2]=t-B;f[c+64>>2]=A+w;f[c+160>>2]=w-A;f[c+128>>2]=z+o;p=24;q=o-z|0}f[c+(p<<2)>>2]=q;if((a|0)>1){a=a+-1|0;l=l+2|0;e=e+4|0;c=c+4|0}else break}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=f[e+4>>2]|0;a=f[e+8>>2]|0;if(!(l|a))if(((((f[e+12>>2]|0)==0?(f[e+16>>2]|0)==0:0)?(f[e+20>>2]|0)==0:0)?(f[e+24>>2]|0)==0:0)?(f[e+28>>2]|0)==0:0){q=b[c+((f[e>>2]|0)>>>5&1023)>>0]|0;b[j>>0]=q;F1a(j+1|0,q|0,6)|0;C=q;D=7}else{E=0;s=19}else{E=a;s=19}if((s|0)==19){s=0;a=f[e>>2]|0;q=f[e+16>>2]|0;p=q+a|0;r=a-q|0;q=f[e+24>>2]|0;a=q+E|0;z=((E-q|0)*362>>8)-a|0;q=a+p|0;o=p-a|0;a=z+r|0;p=r-z|0;z=f[e+20>>2]|0;r=f[e+12>>2]|0;A=r+z|0;w=z-r|0;r=f[e+28>>2]|0;z=r+l|0;B=l-r|0;r=z+A|0;l=(B+w|0)*473>>8;t=((Y(w,-669)|0)>>8)-r+l|0;w=((z-A|0)*362>>8)-t|0;A=w+((B*277>>8)-l)|0;b[j>>0]=b[c+((r+q|0)>>>5&1023)>>0]|0;b[j+7>>0]=b[c+((q-r|0)>>>5&1023)>>0]|0;b[j+1>>0]=b[c+((t+a|0)>>>5&1023)>>0]|0;b[j+6>>0]=b[c+((a-t|0)>>>5&1023)>>0]|0;b[j+2>>0]=b[c+((w+p|0)>>>5&1023)>>0]|0;b[j+5>>0]=b[c+((p-w|0)>>>5&1023)>>0]|0;b[j+4>>0]=b[c+((A+o|0)>>>5&1023)>>0]|0;C=b[c+((o-A|0)>>>5&1023)>>0]|0;D=3}b[j+D>>0]=C;k=k+1|0;if((k|0)==8)break;else e=e+32|0}u=i;return}function lJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+256|0;j=i;k=f[a+336>>2]|0;a=8;l=e;e=f[c+84>>2]|0;c=j;while(1){m=d[l+16>>1]|0;n=d[l+32>>1]|0;if(!((m|n)<<16>>16))if(((((d[l+48>>1]|0)==0?(d[l+64>>1]|0)==0:0)?(d[l+80>>1]|0)==0:0)?(d[l+96>>1]|0)==0:0)?(d[l+112>>1]|0)==0:0){o=Y(f[e>>2]<<2,d[l>>1]|0)|0;f[c>>2]=o;f[c+32>>2]=o;f[c+64>>2]=o;f[c+96>>2]=o;f[c+128>>2]=o;f[c+160>>2]=o;f[c+192>>2]=o;p=56;q=o}else{r=0;s=9}else{r=n;s=9}if((s|0)==9){s=0;n=Y(r<<16>>16,f[e+64>>2]|0)|0;o=Y(d[l+96>>1]|0,f[e+192>>2]|0)|0;t=(o+n|0)*4433|0;v=t+(n*6270|0)|0;n=t+(Y(o,-15137)|0)|0;o=Y(f[e+128>>2]<<13,d[l+64>>1]|0)|0;t=Y(f[e>>2]<<13,d[l>>1]|0)|0|1024;w=o+t|0;x=t-o|0;o=w+v|0;t=w-v|0;v=x+n|0;w=x-n|0;n=Y(d[l+112>>1]|0,f[e+224>>2]|0)|0;x=Y(d[l+80>>1]|0,f[e+160>>2]|0)|0;y=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;z=Y(m<<16>>16,f[e+32>>2]|0)|0;m=y+n|0;A=z+x|0;B=(A+m|0)*9633|0;C=B+(Y(m,-16069)|0)|0;m=B+(Y(A,-3196)|0)|0;A=Y(z+n|0,-7373)|0;B=A+(n*2446|0)+C|0;n=A+(z*12299|0)+m|0;z=Y(y+x|0,-20995)|0;A=z+(x*16819|0)+m|0;m=z+(y*25172|0)+C|0;f[c>>2]=n+o>>11;f[c+224>>2]=o-n>>11;f[c+32>>2]=m+v>>11;f[c+192>>2]=v-m>>11;f[c+64>>2]=A+w>>11;f[c+160>>2]=w-A>>11;f[c+96>>2]=B+t>>11;p=32;q=t-B>>11}f[c+(p<<2)>>2]=q;if((a|0)>1){a=a+-1|0;l=l+2|0;e=e+4|0;c=c+4|0}else break}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=f[e+4>>2]|0;a=f[e+8>>2]|0;if(!(l|a))if(((((f[e+12>>2]|0)==0?(f[e+16>>2]|0)==0:0)?(f[e+20>>2]|0)==0:0)?(f[e+24>>2]|0)==0:0)?(f[e+28>>2]|0)==0:0){q=b[c+(((f[e>>2]|0)+16|0)>>>5&1023)>>0]|0;b[j>>0]=q;F1a(j+1|0,q|0,6)|0;D=q;E=7}else{F=0;s=19}else{F=a;s=19}if((s|0)==19){s=0;a=f[e+24>>2]|0;q=(a+F|0)*4433|0;p=q+(F*6270|0)|0;r=q+(Y(a,-15137)|0)|0;a=(f[e>>2]|0)+16|0;q=f[e+16>>2]|0;B=a+q<<13;t=a-q<<13;q=B+p|0;a=B-p|0;p=t+r|0;B=t-r|0;r=f[e+28>>2]|0;t=f[e+20>>2]|0;A=f[e+12>>2]|0;w=A+r|0;m=l+t|0;v=(m+w|0)*9633|0;n=v+(Y(w,-16069)|0)|0;w=v+(Y(m,-3196)|0)|0;m=Y(l+r|0,-7373)|0;v=m+(r*2446|0)+n|0;r=m+(l*12299|0)+w|0;l=Y(A+t|0,-20995)|0;m=l+(t*16819|0)+w|0;w=l+(A*25172|0)+n|0;b[j>>0]=b[c+((r+q|0)>>>18&1023)>>0]|0;b[j+7>>0]=b[c+((q-r|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((w+p|0)>>>18&1023)>>0]|0;b[j+6>>0]=b[c+((p-w|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+((m+B|0)>>>18&1023)>>0]|0;b[j+5>>0]=b[c+((B-m|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((v+a|0)>>>18&1023)>>0]|0;D=b[c+((a-v|0)>>>18&1023)>>0]|0;E=4}b[j+E>>0]=D;k=k+1|0;if((k|0)==8)break;else e=e+32|0}u=i;return}function mJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;i=u;u=u+208|0;j=i;k=f[a+336>>2]|0;a=0;l=e;e=f[c+84>>2]|0;c=j;while(1){m=Y(f[e>>2]<<13,d[l>>1]|0)|0|1024;n=Y(d[l+32>>1]|0,f[e+64>>2]|0)|0;o=Y(d[l+64>>1]|0,f[e+128>>2]|0)|0;p=Y(d[l+96>>1]|0,f[e+192>>2]|0)|0;q=(o-p|0)*7223|0;r=(n-o|0)*2578|0;s=(Y(o,-15083)|0)+m+r+q|0;t=p+n|0;v=(t*10438|0)+m|0;w=q+(Y(p,-637)|0)+v|0;p=r+(Y(n,-20239)|0)+v|0;v=Y(d[l+16>>1]|0,f[e+32>>2]|0)|0;n=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;r=Y(d[l+80>>1]|0,f[e+160>>2]|0)|0;q=(n+v|0)*7663|0;x=(v-n|0)*1395|0;y=Y(r+n|0,-11295)|0;n=q+x+y|0;z=(r+v|0)*5027|0;v=z+(q-x)|0;x=z+(r*15326|0)+y|0;f[c>>2]=v+w>>11;f[c+168>>2]=w-v>>11;f[c+28>>2]=n+s>>11;f[c+140>>2]=s-n>>11;f[c+56>>2]=x+p>>11;f[c+112>>2]=p-x>>11;f[c+84>>2]=((o-t|0)*11585|0)+m>>11;a=a+1|0;if((a|0)==7)break;else{l=l+2|0;e=e+4|0;c=c+4|0}}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=(f[e>>2]<<13)+131072|0;a=f[e+8>>2]|0;m=f[e+16>>2]|0;t=f[e+24>>2]|0;o=(m-t|0)*7223|0;x=(a-m|0)*2578|0;p=(Y(m,-15083)|0)+l+x+o|0;n=t+a|0;s=(n*10438|0)+l|0;v=o+(Y(t,-637)|0)+s|0;t=x+(Y(a,-20239)|0)+s|0;s=f[e+4>>2]|0;a=f[e+12>>2]|0;x=f[e+20>>2]|0;o=(a+s|0)*7663|0;w=(s-a|0)*1395|0;y=Y(x+a|0,-11295)|0;a=o+w+y|0;r=(x+s|0)*5027|0;s=o-w+r|0;w=r+(x*15326|0)+y|0;b[j>>0]=b[c+((s+v|0)>>>18&1023)>>0]|0;b[j+6>>0]=b[c+((v-s|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((a+p|0)>>>18&1023)>>0]|0;b[j+5>>0]=b[c+((p-a|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+((w+t|0)>>>18&1023)>>0]|0;b[j+4>>0]=b[c+((t-w|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((((m-n|0)*11585|0)+l|0)>>>18&1023)>>0]|0;k=k+1|0;if((k|0)==7)break;else e=e+28|0}u=i;return}function nJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;i=u;u=u+144|0;j=i;k=f[a+336>>2]|0;a=0;l=e;e=f[c+84>>2]|0;c=j;while(1){m=Y(f[e>>2]<<13,d[l>>1]|0)|0|1024;n=Y((f[e+128>>2]|0)*5793|0,d[l+64>>1]|0)|0;o=n+m|0;p=(Y(n,-2)|0)+m>>11;m=Y((f[e+64>>2]|0)*10033|0,d[l+32>>1]|0)|0;n=m+o|0;q=o-m|0;m=Y(d[l+16>>1]|0,f[e+32>>2]|0)|0;o=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;r=Y(d[l+80>>1]|0,f[e+160>>2]|0)|0;s=(r+m|0)*2998|0;t=s+(o+m<<13)|0;v=s+(r-o<<13)|0;s=m-o-r<<2;f[c>>2]=t+n>>11;f[c+120>>2]=n-t>>11;f[c+24>>2]=s+p;f[c+96>>2]=p-s;f[c+48>>2]=v+q>>11;f[c+72>>2]=q-v>>11;a=a+1|0;if((a|0)==6)break;else{l=l+2|0;e=e+4|0;c=c+4|0}}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=(f[e>>2]<<13)+131072|0;a=(f[e+16>>2]|0)*5793|0;v=l+a|0;q=l-a-a|0;a=(f[e+8>>2]|0)*10033|0;l=v+a|0;s=v-a|0;a=f[e+4>>2]|0;v=f[e+12>>2]|0;p=f[e+20>>2]|0;t=(p+a|0)*2998|0;n=t+(v+a<<13)|0;r=t+(p-v<<13)|0;t=a-v-p<<13;b[j>>0]=b[c+((n+l|0)>>>18&1023)>>0]|0;b[j+5>>0]=b[c+((l-n|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((t+q|0)>>>18&1023)>>0]|0;b[j+4>>0]=b[c+((q-t|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+((r+s|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((s-r|0)>>>18&1023)>>0]|0;k=k+1|0;if((k|0)==6)break;else e=e+24|0}u=i;return}function oJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=u;u=u+112|0;j=i;k=f[a+336>>2]|0;a=0;l=e;e=f[c+84>>2]|0;c=j;while(1){m=Y(f[e>>2]<<13,d[l>>1]|0)|0|1024;n=Y(d[l+32>>1]|0,f[e+64>>2]|0)|0;o=Y(d[l+64>>1]|0,f[e+128>>2]|0)|0;p=(o+n|0)*6476|0;q=n-o|0;o=(q*2896|0)+m|0;n=o+p|0;r=o-p|0;p=(Y(q,-11584)|0)+m|0;m=Y(d[l+16>>1]|0,f[e+32>>2]|0)|0;q=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;o=(q+m|0)*6810|0;s=o+(m*4209|0)|0;m=o+(Y(q,-17828)|0)|0;f[c>>2]=s+n>>11;f[c+80>>2]=n-s>>11;f[c+20>>2]=m+r>>11;f[c+60>>2]=r-m>>11;f[c+40>>2]=p>>11;a=a+1|0;if((a|0)==5)break;else{l=l+2|0;e=e+4|0;c=c+4|0}}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=(f[e>>2]<<13)+131072|0;a=f[e+8>>2]|0;p=f[e+16>>2]|0;m=(p+a|0)*6476|0;r=a-p|0;p=(r*2896|0)+l|0;a=p+m|0;s=p-m|0;m=(Y(r,-11584)|0)+l|0;l=f[e+4>>2]|0;r=f[e+12>>2]|0;p=(r+l|0)*6810|0;n=p+(l*4209|0)|0;l=p+(Y(r,-17828)|0)|0;b[j>>0]=b[c+((n+a|0)>>>18&1023)>>0]|0;b[j+4>>0]=b[c+((a-n|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((l+s|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((s-l|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+(m>>>18&1023)>>0]|0;k=k+1|0;if((k|0)==5)break;else e=e+20|0}u=i;return}function pJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;i=u;u=u+64|0;j=i;k=f[a+336>>2]|0;a=f[c+84>>2]|0;c=Y(d[e>>1]|0,f[a>>2]|0)|0;l=Y(d[e+32>>1]|0,f[a+64>>2]|0)|0;m=l+c<<2;n=c-l<<2;l=Y(d[e+16>>1]|0,f[a+32>>2]|0)|0;c=Y(d[e+48>>1]|0,f[a+96>>2]|0)|0;o=((c+l|0)*4433|0)+1024|0;p=o+(l*6270|0)>>11;l=o+(Y(c,-15137)|0)>>11;f[j>>2]=p+m;f[j+48>>2]=m-p;p=j+16|0;f[p>>2]=l+n;f[j+32>>2]=n-l;l=j+4|0;n=Y(d[e+2>>1]|0,f[a+4>>2]|0)|0;m=Y(d[e+34>>1]|0,f[a+68>>2]|0)|0;c=m+n<<2;o=n-m<<2;m=Y(d[e+18>>1]|0,f[a+36>>2]|0)|0;n=Y(d[e+50>>1]|0,f[a+100>>2]|0)|0;q=((n+m|0)*4433|0)+1024|0;r=q+(m*6270|0)>>11;m=q+(Y(n,-15137)|0)>>11;f[l>>2]=r+c;f[j+52>>2]=c-r;f[j+20>>2]=m+o;f[j+36>>2]=o-m;m=Y(d[e+4>>1]|0,f[a+8>>2]|0)|0;o=Y(d[e+36>>1]|0,f[a+72>>2]|0)|0;r=o+m<<2;c=m-o<<2;o=Y(d[e+20>>1]|0,f[a+40>>2]|0)|0;m=Y(d[e+52>>1]|0,f[a+104>>2]|0)|0;n=((m+o|0)*4433|0)+1024|0;q=n+(o*6270|0)>>11;o=n+(Y(m,-15137)|0)>>11;m=q+r|0;f[j+8>>2]=m;f[j+56>>2]=r-q;f[j+24>>2]=o+c;f[j+40>>2]=c-o;o=Y(d[e+6>>1]|0,f[a+12>>2]|0)|0;c=Y(d[e+38>>1]|0,f[a+76>>2]|0)|0;q=c+o<<2;r=o-c<<2;c=Y(d[e+22>>1]|0,f[a+44>>2]|0)|0;o=Y(d[e+54>>1]|0,f[a+108>>2]|0)|0;a=((o+c|0)*4433|0)+1024|0;e=a+(c*6270|0)>>11;c=a+(Y(o,-15137)|0)>>11;o=e+q|0;f[j+12>>2]=o;f[j+60>>2]=q-e;e=c+r|0;f[j+28>>2]=e;f[j+44>>2]=r-c;c=k+128|0;k=(f[g>>2]|0)+h|0;r=(f[j>>2]|0)+16|0;q=r+m<<13;a=r-m<<13;m=f[l>>2]|0;l=(o+m|0)*4433|0;r=l+(m*6270|0)|0;m=l+(Y(o,-15137)|0)|0;b[k>>0]=b[c+((r+q|0)>>>18&1023)>>0]|0;b[k+3>>0]=b[c+((q-r|0)>>>18&1023)>>0]|0;b[k+1>>0]=b[c+((m+a|0)>>>18&1023)>>0]|0;b[k+2>>0]=b[c+((a-m|0)>>>18&1023)>>0]|0;m=(f[g+4>>2]|0)+h|0;a=(f[p>>2]|0)+16|0;p=f[j+24>>2]|0;k=a+p<<13;r=a-p<<13;p=f[j+20>>2]|0;a=(e+p|0)*4433|0;q=a+(p*6270|0)|0;p=a+(Y(e,-15137)|0)|0;b[m>>0]=b[c+((q+k|0)>>>18&1023)>>0]|0;b[m+3>>0]=b[c+((k-q|0)>>>18&1023)>>0]|0;b[m+1>>0]=b[c+((p+r|0)>>>18&1023)>>0]|0;b[m+2>>0]=b[c+((r-p|0)>>>18&1023)>>0]|0;p=(f[g+8>>2]|0)+h|0;r=(f[j+32>>2]|0)+16|0;m=f[j+40>>2]|0;q=r+m<<13;k=r-m<<13;m=f[j+36>>2]|0;r=f[j+44>>2]|0;e=(r+m|0)*4433|0;a=e+(m*6270|0)|0;m=e+(Y(r,-15137)|0)|0;b[p>>0]=b[c+((a+q|0)>>>18&1023)>>0]|0;b[p+3>>0]=b[c+((q-a|0)>>>18&1023)>>0]|0;b[p+1>>0]=b[c+((m+k|0)>>>18&1023)>>0]|0;b[p+2>>0]=b[c+((k-m|0)>>>18&1023)>>0]|0;m=(f[g+12>>2]|0)+h|0;h=(f[j+48>>2]|0)+16|0;g=f[j+56>>2]|0;k=h+g<<13;p=h-g<<13;g=f[j+52>>2]|0;h=f[j+60>>2]|0;j=(h+g|0)*4433|0;a=j+(g*6270|0)|0;g=j+(Y(h,-15137)|0)|0;b[m>>0]=b[c+((a+k|0)>>>18&1023)>>0]|0;b[m+3>>0]=b[c+((k-a|0)>>>18&1023)>>0]|0;b[m+1>>0]=b[c+((g+p|0)>>>18&1023)>>0]|0;b[m+2>>0]=b[c+((p-g|0)>>>18&1023)>>0]|0;u=i;return}function qJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;i=u;u=u+48|0;j=i;k=f[a+336>>2]|0;a=f[c+84>>2]|0;c=Y(f[a>>2]<<13,d[e>>1]|0)|0|1024;l=Y((f[a+64>>2]|0)*5793|0,d[e+32>>1]|0)|0;m=l+c|0;n=(Y(l,-2)|0)+c|0;c=Y((f[a+32>>2]|0)*10033|0,d[e+16>>1]|0)|0;l=c+m>>11;f[j>>2]=l;f[j+24>>2]=m-c>>11;c=j+12|0;f[c>>2]=n>>11;n=Y(f[a+4>>2]<<13,d[e+2>>1]|0)|0|1024;m=Y((f[a+68>>2]|0)*5793|0,d[e+34>>1]|0)|0;o=m+n|0;p=(Y(m,-2)|0)+n|0;n=Y((f[a+36>>2]|0)*10033|0,d[e+18>>1]|0)|0;m=n+o>>11;f[j+4>>2]=m;f[j+28>>2]=o-n>>11;n=p>>11;f[j+16>>2]=n;p=Y(f[a+8>>2]<<13,d[e+4>>1]|0)|0|1024;o=Y((f[a+72>>2]|0)*5793|0,d[e+36>>1]|0)|0;q=o+p|0;r=(Y(o,-2)|0)+p|0;p=Y((f[a+40>>2]|0)*10033|0,d[e+20>>1]|0)|0;e=p+q>>11;f[j+8>>2]=e;a=q-p>>11;f[j+32>>2]=a;p=r>>11;f[j+20>>2]=p;r=k+128|0;k=(f[g>>2]|0)+h|0;q=(l<<13)+131072|0;l=q+(e*5793|0)|0;o=(Y(e,-11586)|0)+q|0;q=m*10033|0;b[k>>0]=b[r+((l+q|0)>>>18&1023)>>0]|0;b[k+2>>0]=b[r+((l-q|0)>>>18&1023)>>0]|0;b[k+1>>0]=b[r+(o>>>18&1023)>>0]|0;o=(f[g+4>>2]|0)+h|0;k=(f[c>>2]<<13)+131072|0;c=k+(p*5793|0)|0;q=(Y(p,-11586)|0)+k|0;k=n*10033|0;b[o>>0]=b[r+((c+k|0)>>>18&1023)>>0]|0;b[o+2>>0]=b[r+((c-k|0)>>>18&1023)>>0]|0;b[o+1>>0]=b[r+(q>>>18&1023)>>0]|0;q=(f[g+8>>2]|0)+h|0;h=(f[j+24>>2]<<13)+131072|0;g=h+(a*5793|0)|0;o=(Y(a,-11586)|0)+h|0;h=(f[j+28>>2]|0)*10033|0;b[q>>0]=b[r+((g+h|0)>>>18&1023)>>0]|0;b[q+2>>0]=b[r+((g-h|0)>>>18&1023)>>0]|0;b[q+1>>0]=b[r+(o>>>18&1023)>>0]|0;u=i;return}function rJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=(f[a+336>>2]|0)+128|0;a=f[c+84>>2]|0;c=Y(d[e>>1]|0,f[a>>2]|0)|0;j=Y(d[e+16>>1]|0,f[a+32>>2]|0)|0;k=c+4|0;c=j+k|0;l=k-j|0;j=Y(d[e+2>>1]|0,f[a+4>>2]|0)|0;k=Y(d[e+18>>1]|0,f[a+36>>2]|0)|0;a=k+j|0;e=j-k|0;k=(f[g>>2]|0)+h|0;b[k>>0]=b[i+((a+c|0)>>>3&1023)>>0]|0;b[k+1>>0]=b[i+((c-a|0)>>>3&1023)>>0]|0;a=(f[g+4>>2]|0)+h|0;b[a>>0]=b[i+((e+l|0)>>>3&1023)>>0]|0;b[a+1>>0]=b[i+((l-e|0)>>>3&1023)>>0]|0;return}function sJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0;i=(f[a+336>>2]|0)+128+(((Y(d[e>>1]|0,f[f[c+84>>2]>>2]|0)|0)+4|0)>>>3&1023)|0;b[(f[g>>2]|0)+h>>0]=b[i>>0]|0;return}function tJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;i=u;u=u+288|0;j=i;k=f[a+336>>2]|0;a=0;l=e;e=f[c+84>>2]|0;c=j;while(1){m=Y(f[e>>2]<<13,d[l>>1]|0)|0|1024;n=Y(d[l+32>>1]|0,f[e+64>>2]|0)|0;o=Y(d[l+64>>1]|0,f[e+128>>2]|0)|0;p=Y((f[e+192>>2]|0)*5793|0,d[l+96>>1]|0)|0;q=p+m|0;r=m-p-p|0;p=n-o|0;m=r+(p*5793|0)|0;s=(Y(p,-11586)|0)+r|0;r=(o+n|0)*10887|0;p=n*8875|0;n=o*2012|0;o=r-n+q|0;t=q-r+p|0;r=q-p+n|0;n=Y(d[l+16>>1]|0,f[e+32>>2]|0)|0;p=Y(d[l+80>>1]|0,f[e+160>>2]|0)|0;q=Y(d[l+112>>1]|0,f[e+224>>2]|0)|0;v=Y(Y(f[e+96>>2]|0,-10033)|0,d[l+48>>1]|0)|0;w=(p+n|0)*7447|0;x=(q+n|0)*3962|0;y=w-v+x|0;z=(p-q|0)*11409|0;A=v-z+w|0;w=z+v+x|0;x=(n-p-q|0)*10033|0;f[c>>2]=y+o>>11;f[c+256>>2]=o-y>>11;f[c+32>>2]=x+m>>11;f[c+224>>2]=m-x>>11;f[c+64>>2]=A+t>>11;f[c+192>>2]=t-A>>11;f[c+96>>2]=w+r>>11;f[c+160>>2]=r-w>>11;f[c+128>>2]=s>>11;a=a+1|0;if((a|0)==8)break;else{l=l+2|0;e=e+4|0;c=c+4|0}}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=(f[e>>2]<<13)+131072|0;a=f[e+8>>2]|0;s=f[e+16>>2]|0;w=(f[e+24>>2]|0)*5793|0;r=w+l|0;A=l-w-w|0;w=a-s|0;l=A+(w*5793|0)|0;t=(Y(w,-11586)|0)+A|0;A=(s+a|0)*10887|0;w=a*8875|0;a=s*2012|0;s=A-a+r|0;x=r-A+w|0;A=r-w+a|0;a=f[e+4>>2]|0;w=f[e+20>>2]|0;r=f[e+28>>2]|0;m=Y(f[e+12>>2]|0,-10033)|0;y=(w+a|0)*7447|0;o=(r+a|0)*3962|0;q=y-m+o|0;p=(w-r|0)*11409|0;n=m-p+y|0;y=p+m+o|0;o=(a-w-r|0)*10033|0;b[j>>0]=b[c+((q+s|0)>>>18&1023)>>0]|0;b[j+8>>0]=b[c+((s-q|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((o+l|0)>>>18&1023)>>0]|0;b[j+7>>0]=b[c+((l-o|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+((n+x|0)>>>18&1023)>>0]|0;b[j+6>>0]=b[c+((x-n|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((y+A|0)>>>18&1023)>>0]|0;b[j+5>>0]=b[c+((A-y|0)>>>18&1023)>>0]|0;b[j+4>>0]=b[c+(t>>>18&1023)>>0]|0;k=k+1|0;if((k|0)==9)break;else e=e+32|0}u=i;return}function uJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;i=u;u=u+320|0;j=i;k=f[a+336>>2]|0;a=0;l=e;e=f[c+84>>2]|0;c=j;while(1){m=Y(f[e>>2]<<13,d[l>>1]|0)|0|1024;n=Y(d[l+64>>1]|0,f[e+128>>2]|0)|0;o=(n*9373|0)+m|0;p=(Y(n,-3580)|0)+m|0;q=(Y(n,-11586)|0)+m>>11;m=Y(d[l+32>>1]|0,f[e+64>>2]|0)|0;n=Y(d[l+96>>1]|0,f[e+192>>2]|0)|0;r=(n+m|0)*6810|0;s=r+(m*4209|0)|0;m=r+(Y(n,-17828)|0)|0;n=s+o|0;r=o-s|0;s=m+p|0;o=p-m|0;m=Y(d[l+16>>1]|0,f[e+32>>2]|0)|0;p=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;t=Y(d[l+80>>1]|0,f[e+160>>2]|0)|0;v=Y(d[l+112>>1]|0,f[e+224>>2]|0)|0;w=v+p|0;x=p-v|0;v=x*2531|0;p=t<<13;y=w*7791|0;z=v+p|0;A=y+(m*11443|0)+z|0;B=(m*1812|0)-y+z|0;z=w*4815|0;w=p-v-(x<<12)|0;v=m-t-x<<2;x=(m*10323|0)-z-w|0;t=w+((m*5260|0)-z)|0;f[c>>2]=A+n>>11;f[c+288>>2]=n-A>>11;f[c+32>>2]=x+s>>11;f[c+256>>2]=s-x>>11;f[c+64>>2]=v+q;f[c+224>>2]=q-v;f[c+96>>2]=t+o>>11;f[c+192>>2]=o-t>>11;f[c+128>>2]=B+r>>11;f[c+160>>2]=r-B>>11;a=a+1|0;if((a|0)==8)break;else{l=l+2|0;e=e+4|0;c=c+4|0}}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=(f[e>>2]<<13)+131072|0;a=f[e+16>>2]|0;B=l+(a*9373|0)|0;r=l+(Y(a,-3580)|0)|0;t=l+(Y(a,-11586)|0)|0;a=f[e+8>>2]|0;l=f[e+24>>2]|0;o=(l+a|0)*6810|0;v=o+(a*4209|0)|0;a=o+(Y(l,-17828)|0)|0;l=v+B|0;o=B-v|0;v=a+r|0;B=r-a|0;a=f[e+4>>2]|0;r=f[e+12>>2]|0;q=f[e+20>>2]<<13;x=f[e+28>>2]|0;s=x+r|0;A=r-x|0;x=A*2531|0;r=s*7791|0;n=x+q|0;z=r+(a*11443|0)+n|0;m=(a*1812|0)-r+n|0;n=s*4815|0;s=q-x-(A<<12)|0;x=(a-A<<13)-q|0;q=(a*10323|0)-n-s|0;A=s+((a*5260|0)-n)|0;b[j>>0]=b[c+((z+l|0)>>>18&1023)>>0]|0;b[j+9>>0]=b[c+((l-z|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((q+v|0)>>>18&1023)>>0]|0;b[j+8>>0]=b[c+((v-q|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+((x+t|0)>>>18&1023)>>0]|0;b[j+7>>0]=b[c+((t-x|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((A+B|0)>>>18&1023)>>0]|0;b[j+6>>0]=b[c+((B-A|0)>>>18&1023)>>0]|0;b[j+4>>0]=b[c+((m+o|0)>>>18&1023)>>0]|0;b[j+5>>0]=b[c+((o-m|0)>>>18&1023)>>0]|0;k=k+1|0;if((k|0)==10)break;else e=e+32|0}u=i;return}function vJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;i=u;u=u+352|0;j=i;k=f[a+336>>2]|0;a=0;l=e;e=f[c+84>>2]|0;c=j;while(1){m=Y(f[e>>2]<<13,d[l>>1]|0)|0|1024;n=Y(d[l+32>>1]|0,f[e+64>>2]|0)|0;o=Y(d[l+64>>1]|0,f[e+128>>2]|0)|0;p=Y(d[l+96>>1]|0,f[e+192>>2]|0)|0;q=(o-p|0)*20862|0;r=(o-n|0)*3529|0;s=p+n|0;t=s-o|0;v=(t*11116|0)+m|0;w=r+(Y(o,-14924)|0)+q+v|0;x=q+(p*17333|0)+v|0;q=r+(Y(n,-12399)|0)+v|0;r=v+(Y(s,-9467)|0)|0;s=r+(Y(p,-6461)|0)|0;p=(o*15929|0)+(Y(n,-11395)|0)+r|0;r=(Y(t,-11585)|0)+m|0;m=Y(d[l+16>>1]|0,f[e+32>>2]|0)|0;t=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;n=Y(d[l+80>>1]|0,f[e+160>>2]|0)|0;o=Y(d[l+112>>1]|0,f[e+224>>2]|0)|0;v=t+m|0;y=(n+v+o|0)*3264|0;z=v*7274|0;v=(n+m|0)*5492|0;A=y+((o+m|0)*3e3|0)|0;B=z+(Y(m,-7562)|0)+v+A|0;m=y+(Y(n+t|0,-9527)|0)|0;C=v+(Y(n,-9766)|0)+m|0;v=Y(o+t|0,-14731)|0;D=z+(t*16984|0)+v+m|0;m=v+(o*17223|0)+A|0;A=(n*8203|0)+(Y(t,-12019)|0)+(Y(o,-13802)|0)+y|0;f[c>>2]=B+x>>11;f[c+320>>2]=x-B>>11;f[c+32>>2]=D+w>>11;f[c+288>>2]=w-D>>11;f[c+64>>2]=C+s>>11;f[c+256>>2]=s-C>>11;f[c+96>>2]=m+q>>11;f[c+224>>2]=q-m>>11;f[c+128>>2]=A+p>>11;f[c+192>>2]=p-A>>11;f[c+160>>2]=r>>11;a=a+1|0;if((a|0)==8)break;else{l=l+2|0;e=e+4|0;c=c+4|0}}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=(f[e>>2]<<13)+131072|0;a=f[e+8>>2]|0;r=f[e+16>>2]|0;A=f[e+24>>2]|0;p=(r-A|0)*20862|0;m=(r-a|0)*3529|0;q=A+a|0;C=q-r|0;s=(C*11116|0)+l|0;D=m+(Y(r,-14924)|0)+p+s|0;w=p+(A*17333|0)+s|0;p=m+(Y(a,-12399)|0)+s|0;m=s+(Y(q,-9467)|0)|0;q=m+(Y(A,-6461)|0)|0;A=(r*15929|0)+(Y(a,-11395)|0)+m|0;m=(Y(C,-11585)|0)+l|0;l=f[e+4>>2]|0;C=f[e+12>>2]|0;a=f[e+20>>2]|0;r=f[e+28>>2]|0;s=C+l|0;B=(s+a+r|0)*3264|0;x=s*7274|0;s=(a+l|0)*5492|0;y=B+((r+l|0)*3e3|0)|0;o=x+(Y(l,-7562)|0)+s+y|0;l=B+(Y(a+C|0,-9527)|0)|0;t=s+(Y(a,-9766)|0)+l|0;s=Y(r+C|0,-14731)|0;n=x+(C*16984|0)+s+l|0;l=s+(r*17223|0)+y|0;y=(a*8203|0)+(Y(C,-12019)|0)+(Y(r,-13802)|0)+B|0;b[j>>0]=b[c+((o+w|0)>>>18&1023)>>0]|0;b[j+10>>0]=b[c+((w-o|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((n+D|0)>>>18&1023)>>0]|0;b[j+9>>0]=b[c+((D-n|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+((t+q|0)>>>18&1023)>>0]|0;b[j+8>>0]=b[c+((q-t|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((l+p|0)>>>18&1023)>>0]|0;b[j+7>>0]=b[c+((p-l|0)>>>18&1023)>>0]|0;b[j+4>>0]=b[c+((y+A|0)>>>18&1023)>>0]|0;b[j+6>>0]=b[c+((A-y|0)>>>18&1023)>>0]|0;b[j+5>>0]=b[c+(m>>>18&1023)>>0]|0;k=k+1|0;if((k|0)==11)break;else e=e+32|0}u=i;return}function wJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;i=u;u=u+384|0;j=i;k=f[a+336>>2]|0;a=0;l=e;e=f[c+84>>2]|0;c=j;while(1){m=Y(f[e>>2]<<13,d[l>>1]|0)|0|1024;n=Y((f[e+128>>2]|0)*10033|0,d[l+64>>1]|0)|0;o=n+m|0;p=m-n|0;n=Y(d[l+32>>1]|0,f[e+64>>2]|0)|0;q=Y(f[e+192>>2]<<13,d[l+96>>1]|0)|0;r=(n<<13)-q|0;s=r+m|0;t=m-r|0;r=q+(n*11190|0)|0;m=r+o|0;v=o-r|0;r=(n*2998|0)-q|0;q=r+p|0;n=p-r|0;r=Y(d[l+16>>1]|0,f[e+32>>2]|0)|0;p=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;o=Y(d[l+80>>1]|0,f[e+160>>2]|0)|0;w=Y(d[l+112>>1]|0,f[e+224>>2]|0)|0;x=p*10703|0;y=Y(p,-4433)|0;z=o+r|0;A=(w+z|0)*7053|0;B=A+(z*2139|0)|0;z=x+(r*2295|0)+B|0;C=Y(w+o|0,-8565)|0;D=(Y(o,-12112)|0)+y+C+B|0;B=(w*12998|0)-x+A+C|0;C=y+(Y(r,-5540)|0)+(Y(w,-16244)|0)+A|0;A=r-w|0;w=p-o|0;o=(A+w|0)*4433|0;p=o+(A*6270|0)|0;A=o+(Y(w,-15137)|0)|0;f[c>>2]=z+m>>11;f[c+352>>2]=m-z>>11;f[c+32>>2]=p+s>>11;f[c+320>>2]=s-p>>11;f[c+64>>2]=D+q>>11;f[c+288>>2]=q-D>>11;f[c+96>>2]=B+n>>11;f[c+256>>2]=n-B>>11;f[c+128>>2]=A+t>>11;f[c+224>>2]=t-A>>11;f[c+160>>2]=C+v>>11;f[c+192>>2]=v-C>>11;a=a+1|0;if((a|0)==8)break;else{l=l+2|0;e=e+4|0;c=c+4|0}}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=(f[e>>2]<<13)+131072|0;a=(f[e+16>>2]|0)*10033|0;C=l+a|0;v=l-a|0;a=f[e+8>>2]|0;A=f[e+24>>2]<<13;t=(a<<13)-A|0;B=t+l|0;n=l-t|0;t=A+(a*11190|0)|0;l=t+C|0;D=C-t|0;t=(a*2998|0)-A|0;A=t+v|0;a=v-t|0;t=f[e+4>>2]|0;v=f[e+12>>2]|0;C=f[e+20>>2]|0;q=f[e+28>>2]|0;p=v*10703|0;s=Y(v,-4433)|0;z=C+t|0;m=(z+q|0)*7053|0;w=m+(z*2139|0)|0;z=p+(t*2295|0)+w|0;o=Y(q+C|0,-8565)|0;r=(Y(C,-12112)|0)+s+o+w|0;w=(q*12998|0)-p+m+o|0;o=s+(Y(t,-5540)|0)+(Y(q,-16244)|0)+m|0;m=t-q|0;q=v-C|0;C=(m+q|0)*4433|0;v=C+(m*6270|0)|0;m=C+(Y(q,-15137)|0)|0;b[j>>0]=b[c+((z+l|0)>>>18&1023)>>0]|0;b[j+11>>0]=b[c+((l-z|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((v+B|0)>>>18&1023)>>0]|0;b[j+10>>0]=b[c+((B-v|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+((r+A|0)>>>18&1023)>>0]|0;b[j+9>>0]=b[c+((A-r|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((w+a|0)>>>18&1023)>>0]|0;b[j+8>>0]=b[c+((a-w|0)>>>18&1023)>>0]|0;b[j+4>>0]=b[c+((m+n|0)>>>18&1023)>>0]|0;b[j+7>>0]=b[c+((n-m|0)>>>18&1023)>>0]|0;b[j+5>>0]=b[c+((o+D|0)>>>18&1023)>>0]|0;b[j+6>>0]=b[c+((D-o|0)>>>18&1023)>>0]|0;k=k+1|0;if((k|0)==12)break;else e=e+32|0}u=i;return}function xJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=u;u=u+416|0;j=i;k=f[a+336>>2]|0;a=0;l=e;e=f[c+84>>2]|0;c=j;while(1){m=Y(f[e>>2]<<13,d[l>>1]|0)|0|1024;n=Y(d[l+32>>1]|0,f[e+64>>2]|0)|0;o=Y(d[l+64>>1]|0,f[e+128>>2]|0)|0;p=Y(d[l+96>>1]|0,f[e+192>>2]|0)|0;q=p+o|0;r=o-p|0;p=q*9465|0;o=(r*793|0)+m|0;s=p+(n*11249|0)+o|0;t=(n*4108|0)-p+o|0;o=q*2592|0;p=(r*3989|0)+m|0;v=(n*8672|0)-o+p|0;w=o+(Y(n,-10258)|0)+p|0;p=q*3570|0;q=m+(Y(r,-7678)|0)|0;o=(Y(n,-1396)|0)-p+q|0;x=p+(Y(n,-6581)|0)+q|0;q=Y(d[l+16>>1]|0,f[e+32>>2]|0)|0;p=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;y=Y(d[l+80>>1]|0,f[e+160>>2]|0)|0;z=Y(d[l+112>>1]|0,f[e+224>>2]|0)|0;A=(p+q|0)*10832|0;B=(y+q|0)*9534|0;C=z+q|0;D=C*7682|0;E=A+(Y(q,-16549)|0)+B+D|0;F=Y(y+p|0,-2773)|0;G=Y(z+p|0,-9534)|0;H=A+(p*6859|0)+F+G|0;A=Y(z+y|0,-5384)|0;I=F+(Y(y,-12879)|0)+B+A|0;B=G+(z*18068|0)+D+A|0;A=C*2773|0;C=(y-p|0)*7682|0;D=(Y(p,-3818)|0)+(q*2611|0)+C+A|0;q=C+(y*3150|0)+(Y(z,-14273)|0)+A|0;f[c>>2]=E+s>>11;f[c+384>>2]=s-E>>11;f[c+32>>2]=H+v>>11;f[c+352>>2]=v-H>>11;f[c+64>>2]=I+t>>11;f[c+320>>2]=t-I>>11;f[c+96>>2]=B+o>>11;f[c+288>>2]=o-B>>11;f[c+128>>2]=D+x>>11;f[c+256>>2]=x-D>>11;f[c+160>>2]=q+w>>11;f[c+224>>2]=w-q>>11;f[c+192>>2]=((r-n|0)*11585|0)+m>>11;a=a+1|0;if((a|0)==8)break;else{l=l+2|0;e=e+4|0;c=c+4|0}}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=(f[e>>2]<<13)+131072|0;a=f[e+8>>2]|0;m=f[e+16>>2]|0;n=f[e+24>>2]|0;r=n+m|0;q=m-n|0;n=r*9465|0;m=(q*793|0)+l|0;w=n+(a*11249|0)+m|0;D=(a*4108|0)-n+m|0;m=r*2592|0;n=(q*3989|0)+l|0;x=(a*8672|0)-m+n|0;B=m+(Y(a,-10258)|0)+n|0;n=r*3570|0;r=l+(Y(q,-7678)|0)|0;m=(Y(a,-1396)|0)-n+r|0;o=n+(Y(a,-6581)|0)+r|0;r=f[e+4>>2]|0;n=f[e+12>>2]|0;I=f[e+20>>2]|0;t=f[e+28>>2]|0;H=(n+r|0)*10832|0;v=(I+r|0)*9534|0;E=t+r|0;s=E*7682|0;A=H+(Y(r,-16549)|0)+v+s|0;z=Y(I+n|0,-2773)|0;y=Y(t+n|0,-9534)|0;C=H+(n*6859|0)+z+y|0;H=Y(t+I|0,-5384)|0;p=z+(Y(I,-12879)|0)+v+H|0;v=y+(t*18068|0)+s+H|0;H=E*2773|0;E=(I-n|0)*7682|0;s=(Y(n,-3818)|0)+(r*2611|0)+E+H|0;r=E+(I*3150|0)+(Y(t,-14273)|0)+H|0;b[j>>0]=b[c+((A+w|0)>>>18&1023)>>0]|0;b[j+12>>0]=b[c+((w-A|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((C+x|0)>>>18&1023)>>0]|0;b[j+11>>0]=b[c+((x-C|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+((p+D|0)>>>18&1023)>>0]|0;b[j+10>>0]=b[c+((D-p|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((v+m|0)>>>18&1023)>>0]|0;b[j+9>>0]=b[c+((m-v|0)>>>18&1023)>>0]|0;b[j+4>>0]=b[c+((s+o|0)>>>18&1023)>>0]|0;b[j+8>>0]=b[c+((o-s|0)>>>18&1023)>>0]|0;b[j+5>>0]=b[c+((r+B|0)>>>18&1023)>>0]|0;b[j+7>>0]=b[c+((B-r|0)>>>18&1023)>>0]|0;b[j+6>>0]=b[c+((((q-a|0)*11585|0)+l|0)>>>18&1023)>>0]|0;k=k+1|0;if((k|0)==13)break;else e=e+32|0}u=i;return}function yJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;i=u;u=u+448|0;j=i;k=f[a+336>>2]|0;a=0;l=e;e=f[c+84>>2]|0;c=j;while(1){m=Y(f[e>>2]<<13,d[l>>1]|0)|0|1024;n=Y(d[l+64>>1]|0,f[e+128>>2]|0)|0;o=(n*10438|0)+m|0;p=(n*2578|0)+m|0;q=(Y(n,-7223)|0)+m|0;r=(Y(n,-11586)|0)+m>>11;m=Y(d[l+32>>1]|0,f[e+64>>2]|0)|0;n=Y(d[l+96>>1]|0,f[e+192>>2]|0)|0;s=(n+m|0)*9058|0;t=s+(m*2237|0)|0;v=s+(Y(n,-14084)|0)|0;s=(Y(n,-11295)|0)+(m*5027|0)|0;m=t+o|0;n=o-t|0;t=v+p|0;o=p-v|0;v=s+q|0;p=q-s|0;s=Y(d[l+16>>1]|0,f[e+32>>2]|0)|0;q=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;w=Y(d[l+80>>1]|0,f[e+160>>2]|0)|0;x=Y(d[l+112>>1]|0,f[e+224>>2]|0)|0;y=x<<13;z=w+s|0;A=(q+s|0)*10935|0;B=z*9810|0;C=A+(Y(s,-9232)|0)+B+y|0;D=z*6164|0;z=s-q|0;E=(z*3826|0)-y|0;F=D+(Y(s,-8693)|0)+E|0;s=(Y(w+q|0,-1297)|0)-y|0;G=A+(Y(q,-3474)|0)+s|0;A=B+(Y(w,-19447)|0)+s|0;s=(w-q|0)*11512|0;B=s+(Y(w,-13850)|0)+D+y|0;y=s+(q*5529|0)+E|0;E=z-w+x<<2;f[c>>2]=C+m>>11;f[c+416>>2]=m-C>>11;f[c+32>>2]=G+t>>11;f[c+384>>2]=t-G>>11;f[c+64>>2]=A+v>>11;f[c+352>>2]=v-A>>11;f[c+96>>2]=E+r;f[c+320>>2]=r-E;f[c+128>>2]=B+p>>11;f[c+288>>2]=p-B>>11;f[c+160>>2]=y+o>>11;f[c+256>>2]=o-y>>11;f[c+192>>2]=F+n>>11;f[c+224>>2]=n-F>>11;a=a+1|0;if((a|0)==8)break;else{l=l+2|0;e=e+4|0;c=c+4|0}}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=(f[e>>2]<<13)+131072|0;a=f[e+16>>2]|0;F=l+(a*10438|0)|0;n=l+(a*2578|0)|0;y=l+(Y(a,-7223)|0)|0;o=l+(Y(a,-11586)|0)|0;a=f[e+8>>2]|0;l=f[e+24>>2]|0;B=(l+a|0)*9058|0;p=B+(a*2237|0)|0;E=B+(Y(l,-14084)|0)|0;B=(Y(l,-11295)|0)+(a*5027|0)|0;a=p+F|0;l=F-p|0;p=E+n|0;F=n-E|0;E=B+y|0;n=y-B|0;B=f[e+4>>2]|0;y=f[e+12>>2]|0;r=f[e+20>>2]|0;A=f[e+28>>2]<<13;v=r+B|0;G=(y+B|0)*10935|0;t=v*9810|0;C=G+(Y(B,-9232)|0)+t+A|0;m=v*6164|0;v=B-y|0;x=(v*3826|0)-A|0;w=m+(Y(B,-8693)|0)+x|0;B=(Y(r+y|0,-1297)|0)-A|0;z=G+(Y(y,-3474)|0)+B|0;G=t+(Y(r,-19447)|0)+B|0;B=(r-y|0)*11512|0;t=A+(Y(r,-13850)|0)+B+m|0;m=B+(y*5529|0)+x|0;x=(v-r<<13)+A|0;b[j>>0]=b[c+((C+a|0)>>>18&1023)>>0]|0;b[j+13>>0]=b[c+((a-C|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((z+p|0)>>>18&1023)>>0]|0;b[j+12>>0]=b[c+((p-z|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+((G+E|0)>>>18&1023)>>0]|0;b[j+11>>0]=b[c+((E-G|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((x+o|0)>>>18&1023)>>0]|0;b[j+10>>0]=b[c+((o-x|0)>>>18&1023)>>0]|0;b[j+4>>0]=b[c+((t+n|0)>>>18&1023)>>0]|0;b[j+9>>0]=b[c+((n-t|0)>>>18&1023)>>0]|0;b[j+5>>0]=b[c+((m+F|0)>>>18&1023)>>0]|0;b[j+8>>0]=b[c+((F-m|0)>>>18&1023)>>0]|0;b[j+6>>0]=b[c+((w+l|0)>>>18&1023)>>0]|0;b[j+7>>0]=b[c+((l-w|0)>>>18&1023)>>0]|0;k=k+1|0;if((k|0)==14)break;else e=e+32|0}u=i;return}function zJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;i=u;u=u+480|0;j=i;k=f[a+336>>2]|0;a=0;l=e;e=f[c+84>>2]|0;c=j;while(1){m=Y(f[e>>2]<<13,d[l>>1]|0)|0|1024;n=Y(d[l+32>>1]|0,f[e+64>>2]|0)|0;o=Y(d[l+64>>1]|0,f[e+128>>2]|0)|0;p=Y(d[l+96>>1]|0,f[e+192>>2]|0)|0;q=(Y(p,-3580)|0)+m|0;r=(p*9373|0)+m|0;s=(Y(p,-11586)|0)+m|0;m=n-o|0;p=o+n|0;o=p*10958|0;t=m*374|0;v=n*11795|0;n=t+o+r|0;w=v-o+t+q|0;t=p*4482|0;o=Y(m,-3271)|0;x=r-t+o|0;y=t-v+o+q|0;o=p*6476|0;p=m*2896|0;v=p+o+q|0;q=r-o+p|0;p=s+(m*5792|0)|0;o=(Y(m,-11584)|0)+s|0;s=Y(d[l+16>>1]|0,f[e+32>>2]|0)|0;m=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;r=Y((f[e+160>>2]|0)*10033|0,d[l+80>>1]|0)|0;t=Y(d[l+112>>1]|0,f[e+224>>2]|0)|0;z=m-t|0;A=(z+s|0)*6810|0;B=A+(s*4209|0)|0;C=A+(Y(z,-17828)|0)|0;z=Y(m,-6810)|0;A=Y(m,-11018)|0;m=s-t|0;D=(m*11522|0)+r|0;E=(t*20131|0)-A+D|0;F=z+(Y(s,-9113)|0)+D|0;D=(m*10033|0)-r|0;m=(t+s|0)*4712|0;G=z+(s*3897|0)-r+m|0;s=r+A+(Y(t,-7121)|0)+m|0;f[c>>2]=E+n>>11;f[c+448>>2]=n-E>>11;f[c+32>>2]=B+v>>11;f[c+416>>2]=v-B>>11;f[c+64>>2]=D+p>>11;f[c+384>>2]=p-D>>11;f[c+96>>2]=G+w>>11;f[c+352>>2]=w-G>>11;f[c+128>>2]=C+q>>11;f[c+320>>2]=q-C>>11;f[c+160>>2]=s+x>>11;f[c+288>>2]=x-s>>11;f[c+192>>2]=F+y>>11;f[c+256>>2]=y-F>>11;f[c+224>>2]=o>>11;a=a+1|0;if((a|0)==8)break;else{l=l+2|0;e=e+4|0;c=c+4|0}}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=(f[e>>2]<<13)+131072|0;a=f[e+8>>2]|0;o=f[e+16>>2]|0;F=f[e+24>>2]|0;y=(Y(F,-3580)|0)+l|0;s=(F*9373|0)+l|0;x=(Y(F,-11586)|0)+l|0;l=a-o|0;F=o+a|0;o=F*10958|0;C=l*374|0;q=a*11795|0;a=C+o+s|0;G=q-o+C+y|0;C=F*4482|0;o=Y(l,-3271)|0;w=s-C+o|0;D=C-q+o+y|0;o=F*6476|0;F=l*2896|0;q=F+o+y|0;y=s-o+F|0;F=x+(l*5792|0)|0;o=(Y(l,-11584)|0)+x|0;x=f[e+4>>2]|0;l=f[e+12>>2]|0;s=(f[e+20>>2]|0)*10033|0;C=f[e+28>>2]|0;p=l-C|0;B=(p+x|0)*6810|0;v=B+(x*4209|0)|0;E=B+(Y(p,-17828)|0)|0;p=Y(l,-6810)|0;B=Y(l,-11018)|0;l=x-C|0;n=(l*11522|0)+s|0;m=(C*20131|0)-B+n|0;t=p+(Y(x,-9113)|0)+n|0;n=(l*10033|0)-s|0;l=(C+x|0)*4712|0;A=p+(x*3897|0)-s+l|0;x=s+B+(Y(C,-7121)|0)+l|0;b[j>>0]=b[c+((m+a|0)>>>18&1023)>>0]|0;b[j+14>>0]=b[c+((a-m|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((v+q|0)>>>18&1023)>>0]|0;b[j+13>>0]=b[c+((q-v|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+((n+F|0)>>>18&1023)>>0]|0;b[j+12>>0]=b[c+((F-n|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((A+G|0)>>>18&1023)>>0]|0;b[j+11>>0]=b[c+((G-A|0)>>>18&1023)>>0]|0;b[j+4>>0]=b[c+((E+y|0)>>>18&1023)>>0]|0;b[j+10>>0]=b[c+((y-E|0)>>>18&1023)>>0]|0;b[j+5>>0]=b[c+((x+w|0)>>>18&1023)>>0]|0;b[j+9>>0]=b[c+((w-x|0)>>>18&1023)>>0]|0;b[j+6>>0]=b[c+((t+D|0)>>>18&1023)>>0]|0;b[j+8>>0]=b[c+((D-t|0)>>>18&1023)>>0]|0;b[j+7>>0]=b[c+(o>>>18&1023)>>0]|0;k=k+1|0;if((k|0)==15)break;else e=e+32|0}u=i;return}function AJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;i=u;u=u+512|0;j=i;k=f[a+336>>2]|0;a=0;l=e;e=f[c+84>>2]|0;c=j;while(1){m=Y(f[e>>2]<<13,d[l>>1]|0)|0|1024;n=Y(d[l+64>>1]|0,f[e+128>>2]|0)|0;o=n*10703|0;p=n*4433|0;n=o+m|0;q=m-o|0;o=p+m|0;r=m-p|0;p=Y(d[l+32>>1]|0,f[e+64>>2]|0)|0;m=Y(d[l+96>>1]|0,f[e+192>>2]|0)|0;s=p-m|0;t=s*2260|0;v=s*11363|0;s=v+(m*20995|0)|0;w=t+(p*7373|0)|0;x=v+(Y(p,-4926)|0)|0;p=t+(Y(m,-4176)|0)|0;m=s+n|0;t=n-s|0;s=w+o|0;n=o-w|0;w=x+r|0;o=r-x|0;x=p+q|0;r=q-p|0;p=Y(d[l+16>>1]|0,f[e+32>>2]|0)|0;q=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;v=Y(d[l+80>>1]|0,f[e+160>>2]|0)|0;y=Y(d[l+112>>1]|0,f[e+224>>2]|0)|0;z=v+p|0;A=(q+p|0)*11086|0;B=z*10217|0;C=(y+p|0)*8956|0;D=(p-y|0)*7350|0;E=z*5461|0;z=(p-q|0)*3363|0;F=A+(Y(p,-18730)|0)+B+C|0;G=z+(Y(p,-15038)|0)+E+D|0;p=(v+q|0)*1136|0;H=(v-q|0)*11529|0;I=y+q|0;J=Y(I,-5461)|0;K=A+(q*589|0)+p+J|0;A=Y(I,-10217)|0;I=z+(q*16154|0)+H+A|0;q=Y(y+v|0,-11086)|0;z=p+(Y(v,-9222)|0)+B+q|0;B=J+(y*8728|0)+C+q|0;q=(y-v|0)*3363|0;C=A+(y*25733|0)+D+q|0;D=H+(Y(v,-6278)|0)+E+q|0;f[c>>2]=F+m>>11;f[c+480>>2]=m-F>>11;f[c+32>>2]=K+s>>11;f[c+448>>2]=s-K>>11;f[c+64>>2]=z+w>>11;f[c+416>>2]=w-z>>11;f[c+96>>2]=B+x>>11;f[c+384>>2]=x-B>>11;f[c+128>>2]=C+r>>11;f[c+352>>2]=r-C>>11;f[c+160>>2]=D+o>>11;f[c+320>>2]=o-D>>11;f[c+192>>2]=I+n>>11;f[c+288>>2]=n-I>>11;f[c+224>>2]=G+t>>11;f[c+256>>2]=t-G>>11;a=a+1|0;if((a|0)==8)break;else{l=l+2|0;e=e+4|0;c=c+4|0}}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=(f[e>>2]<<13)+131072|0;a=f[e+16>>2]|0;G=a*10703|0;t=a*4433|0;a=l+G|0;I=l-G|0;G=l+t|0;n=l-t|0;t=f[e+8>>2]|0;l=f[e+24>>2]|0;D=t-l|0;o=D*2260|0;C=D*11363|0;D=C+(l*20995|0)|0;r=o+(t*7373|0)|0;B=C+(Y(t,-4926)|0)|0;t=o+(Y(l,-4176)|0)|0;l=D+a|0;o=a-D|0;D=r+G|0;a=G-r|0;r=B+n|0;G=n-B|0;B=t+I|0;n=I-t|0;t=f[e+4>>2]|0;I=f[e+12>>2]|0;C=f[e+20>>2]|0;x=f[e+28>>2]|0;z=C+t|0;w=(I+t|0)*11086|0;K=z*10217|0;s=(x+t|0)*8956|0;F=(t-x|0)*7350|0;m=z*5461|0;z=(t-I|0)*3363|0;q=w+(Y(t,-18730)|0)+K+s|0;E=z+(Y(t,-15038)|0)+m+F|0;t=(C+I|0)*1136|0;v=(C-I|0)*11529|0;H=x+I|0;y=Y(H,-5461)|0;A=w+(I*589|0)+t+y|0;w=Y(H,-10217)|0;H=z+(I*16154|0)+v+w|0;I=Y(x+C|0,-11086)|0;z=t+(Y(C,-9222)|0)+K+I|0;K=y+(x*8728|0)+s+I|0;I=(x-C|0)*3363|0;s=w+(x*25733|0)+F+I|0;F=v+(Y(C,-6278)|0)+m+I|0;b[j>>0]=b[c+((q+l|0)>>>18&1023)>>0]|0;b[j+15>>0]=b[c+((l-q|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((A+D|0)>>>18&1023)>>0]|0;b[j+14>>0]=b[c+((D-A|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+((z+r|0)>>>18&1023)>>0]|0;b[j+13>>0]=b[c+((r-z|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((K+B|0)>>>18&1023)>>0]|0;b[j+12>>0]=b[c+((B-K|0)>>>18&1023)>>0]|0;b[j+4>>0]=b[c+((s+n|0)>>>18&1023)>>0]|0;b[j+11>>0]=b[c+((n-s|0)>>>18&1023)>>0]|0;b[j+5>>0]=b[c+((F+G|0)>>>18&1023)>>0]|0;b[j+10>>0]=b[c+((G-F|0)>>>18&1023)>>0]|0;b[j+6>>0]=b[c+((H+a|0)>>>18&1023)>>0]|0;b[j+9>>0]=b[c+((a-H|0)>>>18&1023)>>0]|0;b[j+7>>0]=b[c+((E+o|0)>>>18&1023)>>0]|0;b[j+8>>0]=b[c+((o-E|0)>>>18&1023)>>0]|0;k=k+1|0;if((k|0)==16)break;else e=e+32|0}u=i;return}function BJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=u;u=u+256|0;j=i;k=f[a+336>>2]|0;a=8;l=e;e=f[c+84>>2]|0;c=j;while(1){m=d[l+16>>1]|0;n=d[l+32>>1]|0;if(!((m|n)<<16>>16))if(((((d[l+48>>1]|0)==0?(d[l+64>>1]|0)==0:0)?(d[l+80>>1]|0)==0:0)?(d[l+96>>1]|0)==0:0)?(d[l+112>>1]|0)==0:0){o=Y(f[e>>2]<<2,d[l>>1]|0)|0;f[c>>2]=o;f[c+32>>2]=o;f[c+64>>2]=o;f[c+96>>2]=o;f[c+128>>2]=o;f[c+160>>2]=o;f[c+192>>2]=o;p=56;q=o}else{r=0;s=9}else{r=n;s=9}if((s|0)==9){s=0;n=Y(r<<16>>16,f[e+64>>2]|0)|0;o=Y(d[l+96>>1]|0,f[e+192>>2]|0)|0;t=(o+n|0)*4433|0;v=t+(n*6270|0)|0;n=t+(Y(o,-15137)|0)|0;o=Y(f[e+128>>2]<<13,d[l+64>>1]|0)|0;t=Y(f[e>>2]<<13,d[l>>1]|0)|0|1024;w=o+t|0;x=t-o|0;o=w+v|0;t=w-v|0;v=x+n|0;w=x-n|0;n=Y(d[l+112>>1]|0,f[e+224>>2]|0)|0;x=Y(d[l+80>>1]|0,f[e+160>>2]|0)|0;y=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;z=Y(m<<16>>16,f[e+32>>2]|0)|0;m=y+n|0;A=z+x|0;B=(A+m|0)*9633|0;C=B+(Y(m,-16069)|0)|0;m=B+(Y(A,-3196)|0)|0;A=Y(z+n|0,-7373)|0;B=A+(n*2446|0)+C|0;n=A+(z*12299|0)+m|0;z=Y(y+x|0,-20995)|0;A=z+(x*16819|0)+m|0;m=z+(y*25172|0)+C|0;f[c>>2]=n+o>>11;f[c+224>>2]=o-n>>11;f[c+32>>2]=m+v>>11;f[c+192>>2]=v-m>>11;f[c+64>>2]=A+w>>11;f[c+160>>2]=w-A>>11;f[c+96>>2]=B+t>>11;p=32;q=t-B>>11}f[c+(p<<2)>>2]=q;if((a|0)>1){a=a+-1|0;l=l+2|0;e=e+4|0;c=c+4|0}else break}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=(f[e>>2]<<13)+131072|0;a=f[e+16>>2]|0;q=a*10703|0;p=a*4433|0;a=l+q|0;r=l-q|0;q=l+p|0;s=l-p|0;p=f[e+8>>2]|0;l=f[e+24>>2]|0;B=p-l|0;t=B*2260|0;A=B*11363|0;B=A+(l*20995|0)|0;w=t+(p*7373|0)|0;m=A+(Y(p,-4926)|0)|0;p=t+(Y(l,-4176)|0)|0;l=B+a|0;t=a-B|0;B=w+q|0;a=q-w|0;w=m+s|0;q=s-m|0;m=p+r|0;s=r-p|0;p=f[e+4>>2]|0;r=f[e+12>>2]|0;A=f[e+20>>2]|0;v=f[e+28>>2]|0;n=A+p|0;o=(r+p|0)*11086|0;C=n*10217|0;y=(v+p|0)*8956|0;z=(p-v|0)*7350|0;x=n*5461|0;n=(p-r|0)*3363|0;D=o+(Y(p,-18730)|0)+C+y|0;E=n+(Y(p,-15038)|0)+x+z|0;p=(A+r|0)*1136|0;F=(A-r|0)*11529|0;G=v+r|0;H=Y(G,-5461)|0;I=o+(r*589|0)+p+H|0;o=Y(G,-10217)|0;G=n+(r*16154|0)+F+o|0;r=Y(v+A|0,-11086)|0;n=p+(Y(A,-9222)|0)+C+r|0;C=H+(v*8728|0)+y+r|0;r=(v-A|0)*3363|0;y=o+(v*25733|0)+z+r|0;z=F+(Y(A,-6278)|0)+x+r|0;b[j>>0]=b[c+((D+l|0)>>>18&1023)>>0]|0;b[j+15>>0]=b[c+((l-D|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((I+B|0)>>>18&1023)>>0]|0;b[j+14>>0]=b[c+((B-I|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+((n+w|0)>>>18&1023)>>0]|0;b[j+13>>0]=b[c+((w-n|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((C+m|0)>>>18&1023)>>0]|0;b[j+12>>0]=b[c+((m-C|0)>>>18&1023)>>0]|0;b[j+4>>0]=b[c+((y+s|0)>>>18&1023)>>0]|0;b[j+11>>0]=b[c+((s-y|0)>>>18&1023)>>0]|0;b[j+5>>0]=b[c+((z+q|0)>>>18&1023)>>0]|0;b[j+10>>0]=b[c+((q-z|0)>>>18&1023)>>0]|0;b[j+6>>0]=b[c+((G+a|0)>>>18&1023)>>0]|0;b[j+9>>0]=b[c+((a-G|0)>>>18&1023)>>0]|0;b[j+7>>0]=b[c+((E+t|0)>>>18&1023)>>0]|0;b[j+8>>0]=b[c+((t-E|0)>>>18&1023)>>0]|0;k=k+1|0;if((k|0)==8)break;else e=e+32|0}u=i;return}function CJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;i=u;u=u+224|0;j=i;k=f[a+336>>2]|0;a=0;l=e;e=f[c+84>>2]|0;c=j;while(1){m=Y(f[e>>2]<<13,d[l>>1]|0)|0|1024;n=Y(d[l+32>>1]|0,f[e+64>>2]|0)|0;o=Y(d[l+64>>1]|0,f[e+128>>2]|0)|0;p=Y(d[l+96>>1]|0,f[e+192>>2]|0)|0;q=(o-p|0)*7223|0;r=(n-o|0)*2578|0;s=(Y(o,-15083)|0)+m+r+q|0;t=p+n|0;v=(t*10438|0)+m|0;w=q+(Y(p,-637)|0)+v|0;p=r+(Y(n,-20239)|0)+v|0;v=Y(d[l+16>>1]|0,f[e+32>>2]|0)|0;n=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;r=Y(d[l+80>>1]|0,f[e+160>>2]|0)|0;q=(n+v|0)*7663|0;x=(v-n|0)*1395|0;y=Y(r+n|0,-11295)|0;n=q+x+y|0;z=(r+v|0)*5027|0;v=z+(q-x)|0;x=z+(r*15326|0)+y|0;f[c>>2]=v+w>>11;f[c+192>>2]=w-v>>11;f[c+32>>2]=n+s>>11;f[c+160>>2]=s-n>>11;f[c+64>>2]=x+p>>11;f[c+128>>2]=p-x>>11;f[c+96>>2]=((o-t|0)*11585|0)+m>>11;a=a+1|0;if((a|0)==8)break;else{l=l+2|0;e=e+4|0;c=c+4|0}}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=(f[e>>2]<<13)+131072|0;a=f[e+16>>2]|0;m=l+(a*10438|0)|0;t=l+(a*2578|0)|0;o=l+(Y(a,-7223)|0)|0;x=l+(Y(a,-11586)|0)|0;a=f[e+8>>2]|0;l=f[e+24>>2]|0;p=(l+a|0)*9058|0;n=p+(a*2237|0)|0;s=p+(Y(l,-14084)|0)|0;p=(Y(l,-11295)|0)+(a*5027|0)|0;a=n+m|0;l=m-n|0;n=s+t|0;m=t-s|0;s=p+o|0;t=o-p|0;p=f[e+4>>2]|0;o=f[e+12>>2]|0;v=f[e+20>>2]|0;w=f[e+28>>2]<<13;y=v+p|0;r=(o+p|0)*10935|0;z=y*9810|0;q=r+(Y(p,-9232)|0)+z+w|0;A=y*6164|0;y=p-o|0;B=(y*3826|0)-w|0;C=A+(Y(p,-8693)|0)+B|0;p=(Y(v+o|0,-1297)|0)-w|0;D=r+(Y(o,-3474)|0)+p|0;r=z+(Y(v,-19447)|0)+p|0;p=(v-o|0)*11512|0;z=w+(Y(v,-13850)|0)+p+A|0;A=p+(o*5529|0)+B|0;B=(y-v<<13)+w|0;b[j>>0]=b[c+((q+a|0)>>>18&1023)>>0]|0;b[j+13>>0]=b[c+((a-q|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((D+n|0)>>>18&1023)>>0]|0;b[j+12>>0]=b[c+((n-D|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+((r+s|0)>>>18&1023)>>0]|0;b[j+11>>0]=b[c+((s-r|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((B+x|0)>>>18&1023)>>0]|0;b[j+10>>0]=b[c+((x-B|0)>>>18&1023)>>0]|0;b[j+4>>0]=b[c+((z+t|0)>>>18&1023)>>0]|0;b[j+9>>0]=b[c+((t-z|0)>>>18&1023)>>0]|0;b[j+5>>0]=b[c+((A+m|0)>>>18&1023)>>0]|0;b[j+8>>0]=b[c+((m-A|0)>>>18&1023)>>0]|0;b[j+6>>0]=b[c+((C+l|0)>>>18&1023)>>0]|0;b[j+7>>0]=b[c+((l-C|0)>>>18&1023)>>0]|0;k=k+1|0;if((k|0)==7)break;else e=e+32|0}u=i;return}function DJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;i=u;u=u+192|0;j=i;k=f[a+336>>2]|0;a=0;l=e;e=f[c+84>>2]|0;c=j;while(1){m=Y(f[e>>2]<<13,d[l>>1]|0)|0|1024;n=Y((f[e+128>>2]|0)*5793|0,d[l+64>>1]|0)|0;o=n+m|0;p=(Y(n,-2)|0)+m>>11;m=Y((f[e+64>>2]|0)*10033|0,d[l+32>>1]|0)|0;n=m+o|0;q=o-m|0;m=Y(d[l+16>>1]|0,f[e+32>>2]|0)|0;o=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;r=Y(d[l+80>>1]|0,f[e+160>>2]|0)|0;s=(r+m|0)*2998|0;t=s+(o+m<<13)|0;v=s+(r-o<<13)|0;s=m-o-r<<2;f[c>>2]=t+n>>11;f[c+160>>2]=n-t>>11;f[c+32>>2]=s+p;f[c+128>>2]=p-s;f[c+64>>2]=v+q>>11;f[c+96>>2]=q-v>>11;a=a+1|0;if((a|0)==8)break;else{l=l+2|0;e=e+4|0;c=c+4|0}}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=(f[e>>2]<<13)+131072|0;a=(f[e+16>>2]|0)*10033|0;v=l+a|0;q=l-a|0;a=f[e+8>>2]|0;s=f[e+24>>2]<<13;p=(a<<13)-s|0;t=p+l|0;n=l-p|0;p=s+(a*11190|0)|0;l=p+v|0;r=v-p|0;p=(a*2998|0)-s|0;s=p+q|0;a=q-p|0;p=f[e+4>>2]|0;q=f[e+12>>2]|0;v=f[e+20>>2]|0;o=f[e+28>>2]|0;m=q*10703|0;w=Y(q,-4433)|0;x=v+p|0;y=(x+o|0)*7053|0;z=y+(x*2139|0)|0;x=m+(p*2295|0)+z|0;A=Y(o+v|0,-8565)|0;B=(Y(v,-12112)|0)+w+A+z|0;z=(o*12998|0)-m+y+A|0;A=w+(Y(p,-5540)|0)+(Y(o,-16244)|0)+y|0;y=p-o|0;o=q-v|0;v=(y+o|0)*4433|0;q=v+(y*6270|0)|0;y=v+(Y(o,-15137)|0)|0;b[j>>0]=b[c+((x+l|0)>>>18&1023)>>0]|0;b[j+11>>0]=b[c+((l-x|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((q+t|0)>>>18&1023)>>0]|0;b[j+10>>0]=b[c+((t-q|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+((B+s|0)>>>18&1023)>>0]|0;b[j+9>>0]=b[c+((s-B|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((z+a|0)>>>18&1023)>>0]|0;b[j+8>>0]=b[c+((a-z|0)>>>18&1023)>>0]|0;b[j+4>>0]=b[c+((y+n|0)>>>18&1023)>>0]|0;b[j+7>>0]=b[c+((n-y|0)>>>18&1023)>>0]|0;b[j+5>>0]=b[c+((A+r|0)>>>18&1023)>>0]|0;b[j+6>>0]=b[c+((r-A|0)>>>18&1023)>>0]|0;k=k+1|0;if((k|0)==6)break;else e=e+32|0}u=i;return}function EJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;i=u;u=u+160|0;j=i;k=f[a+336>>2]|0;a=0;l=e;e=f[c+84>>2]|0;c=j;while(1){m=Y(f[e>>2]<<13,d[l>>1]|0)|0|1024;n=Y(d[l+32>>1]|0,f[e+64>>2]|0)|0;o=Y(d[l+64>>1]|0,f[e+128>>2]|0)|0;p=(o+n|0)*6476|0;q=n-o|0;o=(q*2896|0)+m|0;n=o+p|0;r=o-p|0;p=(Y(q,-11584)|0)+m|0;m=Y(d[l+16>>1]|0,f[e+32>>2]|0)|0;q=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;o=(q+m|0)*6810|0;s=o+(m*4209|0)|0;m=o+(Y(q,-17828)|0)|0;f[c>>2]=s+n>>11;f[c+128>>2]=n-s>>11;f[c+32>>2]=m+r>>11;f[c+96>>2]=r-m>>11;f[c+64>>2]=p>>11;a=a+1|0;if((a|0)==8)break;else{l=l+2|0;e=e+4|0;c=c+4|0}}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=(f[e>>2]<<13)+131072|0;a=f[e+16>>2]|0;p=l+(a*9373|0)|0;m=l+(Y(a,-3580)|0)|0;r=l+(Y(a,-11586)|0)|0;a=f[e+8>>2]|0;l=f[e+24>>2]|0;s=(l+a|0)*6810|0;n=s+(a*4209|0)|0;a=s+(Y(l,-17828)|0)|0;l=n+p|0;s=p-n|0;n=a+m|0;p=m-a|0;a=f[e+4>>2]|0;m=f[e+12>>2]|0;q=f[e+20>>2]<<13;o=f[e+28>>2]|0;t=o+m|0;v=m-o|0;o=v*2531|0;m=t*7791|0;w=o+q|0;x=m+(a*11443|0)+w|0;y=(a*1812|0)-m+w|0;w=t*4815|0;t=q-o-(v<<12)|0;o=(a-v<<13)-q|0;q=(a*10323|0)-w-t|0;v=t+((a*5260|0)-w)|0;b[j>>0]=b[c+((x+l|0)>>>18&1023)>>0]|0;b[j+9>>0]=b[c+((l-x|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((q+n|0)>>>18&1023)>>0]|0;b[j+8>>0]=b[c+((n-q|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+((o+r|0)>>>18&1023)>>0]|0;b[j+7>>0]=b[c+((r-o|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((v+p|0)>>>18&1023)>>0]|0;b[j+6>>0]=b[c+((p-v|0)>>>18&1023)>>0]|0;b[j+4>>0]=b[c+((y+s|0)>>>18&1023)>>0]|0;b[j+5>>0]=b[c+((s-y|0)>>>18&1023)>>0]|0;k=k+1|0;if((k|0)==5)break;else e=e+32|0}u=i;return}function FJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;i=u;u=u+128|0;j=i;k=f[a+336>>2]|0;a=0;l=e;e=f[c+84>>2]|0;c=j;while(1){m=Y(d[l>>1]|0,f[e>>2]|0)|0;n=Y(d[l+32>>1]|0,f[e+64>>2]|0)|0;o=n+m<<2;p=m-n<<2;n=Y(d[l+16>>1]|0,f[e+32>>2]|0)|0;m=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;q=((m+n|0)*4433|0)+1024|0;r=q+(n*6270|0)>>11;n=q+(Y(m,-15137)|0)>>11;f[c>>2]=r+o;f[c+96>>2]=o-r;f[c+32>>2]=n+p;f[c+64>>2]=p-n;a=a+1|0;if((a|0)==8)break;else{l=l+2|0;e=e+4|0;c=c+4|0}}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=f[e+8>>2]|0;a=f[e+24>>2]|0;n=(a+l|0)*4433|0;p=n+(l*6270|0)|0;l=n+(Y(a,-15137)|0)|0;a=(f[e>>2]|0)+16|0;n=f[e+16>>2]|0;r=a+n<<13;o=a-n<<13;n=r+p|0;a=r-p|0;p=o+l|0;r=o-l|0;l=f[e+28>>2]|0;o=f[e+20>>2]|0;m=f[e+12>>2]|0;q=f[e+4>>2]|0;s=m+l|0;t=q+o|0;v=(t+s|0)*9633|0;w=v+(Y(s,-16069)|0)|0;s=v+(Y(t,-3196)|0)|0;t=Y(q+l|0,-7373)|0;v=t+(l*2446|0)+w|0;l=t+(q*12299|0)+s|0;q=Y(m+o|0,-20995)|0;t=q+(o*16819|0)+s|0;s=q+(m*25172|0)+w|0;b[j>>0]=b[c+((l+n|0)>>>18&1023)>>0]|0;b[j+7>>0]=b[c+((n-l|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((s+p|0)>>>18&1023)>>0]|0;b[j+6>>0]=b[c+((p-s|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+((t+r|0)>>>18&1023)>>0]|0;b[j+5>>0]=b[c+((r-t|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((v+a|0)>>>18&1023)>>0]|0;b[j+4>>0]=b[c+((a-v|0)>>>18&1023)>>0]|0;k=k+1|0;if((k|0)==4)break;else e=e+32|0}u=i;return}function GJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=u;u=u+80|0;j=i;k=f[a+336>>2]|0;a=f[c+84>>2]|0;c=Y(f[a>>2]<<13,d[e>>1]|0)|0|1024;l=Y((f[a+64>>2]|0)*5793|0,d[e+32>>1]|0)|0;m=l+c|0;n=(Y(l,-2)|0)+c|0;c=Y((f[a+32>>2]|0)*10033|0,d[e+16>>1]|0)|0;f[j>>2]=c+m>>11;f[j+48>>2]=m-c>>11;f[j+24>>2]=n>>11;n=Y(f[a+4>>2]<<13,d[e+2>>1]|0)|0|1024;c=Y((f[a+68>>2]|0)*5793|0,d[e+34>>1]|0)|0;m=c+n|0;l=(Y(c,-2)|0)+n|0;n=Y((f[a+36>>2]|0)*10033|0,d[e+18>>1]|0)|0;f[j+4>>2]=n+m>>11;f[j+52>>2]=m-n>>11;f[j+28>>2]=l>>11;l=Y(f[a+8>>2]<<13,d[e+4>>1]|0)|0|1024;n=Y((f[a+72>>2]|0)*5793|0,d[e+36>>1]|0)|0;m=n+l|0;c=(Y(n,-2)|0)+l|0;l=Y((f[a+40>>2]|0)*10033|0,d[e+20>>1]|0)|0;f[j+8>>2]=l+m>>11;f[j+56>>2]=m-l>>11;f[j+32>>2]=c>>11;c=Y(f[a+12>>2]<<13,d[e+6>>1]|0)|0|1024;l=Y((f[a+76>>2]|0)*5793|0,d[e+38>>1]|0)|0;m=l+c|0;n=(Y(l,-2)|0)+c|0;c=Y((f[a+44>>2]|0)*10033|0,d[e+22>>1]|0)|0;f[j+12>>2]=c+m>>11;f[j+60>>2]=m-c>>11;f[j+36>>2]=n>>11;n=Y(f[a+16>>2]<<13,d[e+8>>1]|0)|0|1024;c=Y((f[a+80>>2]|0)*5793|0,d[e+40>>1]|0)|0;m=c+n|0;l=(Y(c,-2)|0)+n|0;n=Y((f[a+48>>2]|0)*10033|0,d[e+24>>1]|0)|0;f[j+16>>2]=n+m>>11;f[j+64>>2]=m-n>>11;f[j+40>>2]=l>>11;l=Y(f[a+20>>2]<<13,d[e+10>>1]|0)|0|1024;n=Y((f[a+84>>2]|0)*5793|0,d[e+42>>1]|0)|0;m=n+l|0;c=(Y(n,-2)|0)+l|0;l=Y((f[a+52>>2]|0)*10033|0,d[e+26>>1]|0)|0;f[j+20>>2]=l+m>>11;f[j+68>>2]=m-l>>11;f[j+44>>2]=c>>11;c=k+128|0;k=0;l=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;m=(f[l>>2]<<13)+131072|0;e=(f[l+16>>2]|0)*5793|0;a=m+e|0;n=m-e-e|0;e=(f[l+8>>2]|0)*10033|0;m=a+e|0;o=a-e|0;e=f[l+4>>2]|0;a=f[l+12>>2]|0;p=f[l+20>>2]|0;q=(p+e|0)*2998|0;r=q+(a+e<<13)|0;s=q+(p-a<<13)|0;q=e-a-p<<13;b[j>>0]=b[c+((r+m|0)>>>18&1023)>>0]|0;b[j+5>>0]=b[c+((m-r|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((q+n|0)>>>18&1023)>>0]|0;b[j+4>>0]=b[c+((n-q|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+((s+o|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((o-s|0)>>>18&1023)>>0]|0;k=k+1|0;if((k|0)==3)break;else l=l+24|0}u=i;return}function HJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;i=u;u=u+32|0;j=i;k=f[a+336>>2]|0;a=f[c+84>>2]|0;c=Y(d[e>>1]|0,f[a>>2]|0)|0;l=Y(d[e+16>>1]|0,f[a+32>>2]|0)|0;m=l+c|0;f[j>>2]=m;n=j+16|0;f[n>>2]=c-l;l=Y(d[e+2>>1]|0,f[a+4>>2]|0)|0;c=Y(d[e+18>>1]|0,f[a+36>>2]|0)|0;o=c+l|0;f[j+4>>2]=o;p=l-c|0;f[j+20>>2]=p;c=Y(d[e+4>>1]|0,f[a+8>>2]|0)|0;l=Y(d[e+20>>1]|0,f[a+40>>2]|0)|0;q=l+c|0;f[j+8>>2]=q;r=c-l|0;f[j+24>>2]=r;l=Y(d[e+6>>1]|0,f[a+12>>2]|0)|0;c=Y(d[e+22>>1]|0,f[a+44>>2]|0)|0;a=c+l|0;f[j+12>>2]=a;e=l-c|0;f[j+28>>2]=e;j=k+128|0;k=(f[g>>2]|0)+h|0;c=m+4|0;m=c+q<<13;l=c-q<<13;q=(a+o|0)*4433|0;c=q+(o*6270|0)|0;o=q+(Y(a,-15137)|0)|0;b[k>>0]=b[j+((c+m|0)>>>16&1023)>>0]|0;b[k+3>>0]=b[j+((m-c|0)>>>16&1023)>>0]|0;b[k+1>>0]=b[j+((o+l|0)>>>16&1023)>>0]|0;b[k+2>>0]=b[j+((l-o|0)>>>16&1023)>>0]|0;o=(f[g+4>>2]|0)+h|0;h=(f[n>>2]|0)+4|0;n=h+r<<13;g=h-r<<13;r=(e+p|0)*4433|0;h=r+(p*6270|0)|0;p=r+(Y(e,-15137)|0)|0;b[o>>0]=b[j+((h+n|0)>>>16&1023)>>0]|0;b[o+3>>0]=b[j+((n-h|0)>>>16&1023)>>0]|0;b[o+1>>0]=b[j+((p+g|0)>>>16&1023)>>0]|0;b[o+2>>0]=b[j+((g-p|0)>>>16&1023)>>0]|0;u=i;return}function IJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0;i=(f[a+336>>2]|0)+128|0;a=f[c+84>>2]|0;c=(f[g>>2]|0)+h|0;h=(Y(d[e>>1]|0,f[a>>2]|0)|0)+4|0;g=Y(d[e+2>>1]|0,f[a+4>>2]|0)|0;b[c>>0]=b[i+((g+h|0)>>>3&1023)>>0]|0;b[c+1>>0]=b[i+((h-g|0)>>>3&1023)>>0]|0;return}function JJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;i=u;u=u+512|0;j=i;k=f[a+336>>2]|0;a=0;l=e;e=f[c+84>>2]|0;c=j;while(1){m=Y(f[e>>2]<<13,d[l>>1]|0)|0|1024;n=Y(d[l+64>>1]|0,f[e+128>>2]|0)|0;o=n*10703|0;p=n*4433|0;n=o+m|0;q=m-o|0;o=p+m|0;r=m-p|0;p=Y(d[l+32>>1]|0,f[e+64>>2]|0)|0;m=Y(d[l+96>>1]|0,f[e+192>>2]|0)|0;s=p-m|0;t=s*2260|0;v=s*11363|0;s=v+(m*20995|0)|0;w=t+(p*7373|0)|0;x=v+(Y(p,-4926)|0)|0;p=t+(Y(m,-4176)|0)|0;m=s+n|0;t=n-s|0;s=w+o|0;n=o-w|0;w=x+r|0;o=r-x|0;x=p+q|0;r=q-p|0;p=Y(d[l+16>>1]|0,f[e+32>>2]|0)|0;q=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;v=Y(d[l+80>>1]|0,f[e+160>>2]|0)|0;y=Y(d[l+112>>1]|0,f[e+224>>2]|0)|0;z=v+p|0;A=(q+p|0)*11086|0;B=z*10217|0;C=(y+p|0)*8956|0;D=(p-y|0)*7350|0;E=z*5461|0;z=(p-q|0)*3363|0;F=A+(Y(p,-18730)|0)+B+C|0;G=z+(Y(p,-15038)|0)+E+D|0;p=(v+q|0)*1136|0;H=(v-q|0)*11529|0;I=y+q|0;J=Y(I,-5461)|0;K=A+(q*589|0)+p+J|0;A=Y(I,-10217)|0;I=z+(q*16154|0)+H+A|0;q=Y(y+v|0,-11086)|0;z=p+(Y(v,-9222)|0)+B+q|0;B=J+(y*8728|0)+C+q|0;q=(y-v|0)*3363|0;C=A+(y*25733|0)+D+q|0;D=H+(Y(v,-6278)|0)+E+q|0;f[c>>2]=F+m>>11;f[c+480>>2]=m-F>>11;f[c+32>>2]=K+s>>11;f[c+448>>2]=s-K>>11;f[c+64>>2]=z+w>>11;f[c+416>>2]=w-z>>11;f[c+96>>2]=B+x>>11;f[c+384>>2]=x-B>>11;f[c+128>>2]=C+r>>11;f[c+352>>2]=r-C>>11;f[c+160>>2]=D+o>>11;f[c+320>>2]=o-D>>11;f[c+192>>2]=I+n>>11;f[c+288>>2]=n-I>>11;f[c+224>>2]=G+t>>11;f[c+256>>2]=t-G>>11;a=a+1|0;if((a|0)==8)break;else{l=l+2|0;e=e+4|0;c=c+4|0}}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=f[e+8>>2]|0;a=f[e+24>>2]|0;G=(a+l|0)*4433|0;t=G+(l*6270|0)|0;l=G+(Y(a,-15137)|0)|0;a=(f[e>>2]|0)+16|0;G=f[e+16>>2]|0;I=a+G<<13;n=a-G<<13;G=I+t|0;a=I-t|0;t=n+l|0;I=n-l|0;l=f[e+28>>2]|0;n=f[e+20>>2]|0;D=f[e+12>>2]|0;o=f[e+4>>2]|0;C=D+l|0;r=o+n|0;B=(r+C|0)*9633|0;x=B+(Y(C,-16069)|0)|0;C=B+(Y(r,-3196)|0)|0;r=Y(o+l|0,-7373)|0;B=r+(l*2446|0)+x|0;l=r+(o*12299|0)+C|0;o=Y(D+n|0,-20995)|0;r=o+(n*16819|0)+C|0;C=o+(D*25172|0)+x|0;b[j>>0]=b[c+((l+G|0)>>>18&1023)>>0]|0;b[j+7>>0]=b[c+((G-l|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((C+t|0)>>>18&1023)>>0]|0;b[j+6>>0]=b[c+((t-C|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+((r+I|0)>>>18&1023)>>0]|0;b[j+5>>0]=b[c+((I-r|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((B+a|0)>>>18&1023)>>0]|0;b[j+4>>0]=b[c+((a-B|0)>>>18&1023)>>0]|0;k=k+1|0;if((k|0)==16)break;else e=e+32|0}u=i;return}function KJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;i=u;u=u+400|0;j=i;k=f[a+336>>2]|0;a=0;l=e;e=f[c+84>>2]|0;c=j;while(1){m=Y(f[e>>2]<<13,d[l>>1]|0)|0|1024;n=Y(d[l+64>>1]|0,f[e+128>>2]|0)|0;o=(n*10438|0)+m|0;p=(n*2578|0)+m|0;q=(Y(n,-7223)|0)+m|0;r=(Y(n,-11586)|0)+m>>11;m=Y(d[l+32>>1]|0,f[e+64>>2]|0)|0;n=Y(d[l+96>>1]|0,f[e+192>>2]|0)|0;s=(n+m|0)*9058|0;t=s+(m*2237|0)|0;v=s+(Y(n,-14084)|0)|0;s=(Y(n,-11295)|0)+(m*5027|0)|0;m=t+o|0;n=o-t|0;t=v+p|0;o=p-v|0;v=s+q|0;p=q-s|0;s=Y(d[l+16>>1]|0,f[e+32>>2]|0)|0;q=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;w=Y(d[l+80>>1]|0,f[e+160>>2]|0)|0;x=Y(d[l+112>>1]|0,f[e+224>>2]|0)|0;y=x<<13;z=w+s|0;A=(q+s|0)*10935|0;B=z*9810|0;C=A+(Y(s,-9232)|0)+B+y|0;D=z*6164|0;z=s-q|0;E=(z*3826|0)-y|0;F=D+(Y(s,-8693)|0)+E|0;s=(Y(w+q|0,-1297)|0)-y|0;G=A+(Y(q,-3474)|0)+s|0;A=B+(Y(w,-19447)|0)+s|0;s=(w-q|0)*11512|0;B=s+(Y(w,-13850)|0)+D+y|0;y=s+(q*5529|0)+E|0;E=z-w+x<<2;f[c>>2]=C+m>>11;f[c+364>>2]=m-C>>11;f[c+28>>2]=G+t>>11;f[c+336>>2]=t-G>>11;f[c+56>>2]=A+v>>11;f[c+308>>2]=v-A>>11;f[c+84>>2]=E+r;f[c+280>>2]=r-E;f[c+112>>2]=B+p>>11;f[c+252>>2]=p-B>>11;f[c+140>>2]=y+o>>11;f[c+224>>2]=o-y>>11;f[c+168>>2]=F+n>>11;f[c+196>>2]=n-F>>11;a=a+1|0;if((a|0)==7)break;else{l=l+2|0;e=e+4|0;c=c+4|0}}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=(f[e>>2]<<13)+131072|0;a=f[e+8>>2]|0;F=f[e+16>>2]|0;n=f[e+24>>2]|0;y=(F-n|0)*7223|0;o=(a-F|0)*2578|0;B=(Y(F,-15083)|0)+l+o+y|0;p=n+a|0;E=(p*10438|0)+l|0;r=y+(Y(n,-637)|0)+E|0;n=o+(Y(a,-20239)|0)+E|0;E=f[e+4>>2]|0;a=f[e+12>>2]|0;o=f[e+20>>2]|0;y=(a+E|0)*7663|0;A=(E-a|0)*1395|0;v=Y(o+a|0,-11295)|0;a=y+A+v|0;G=(o+E|0)*5027|0;E=y-A+G|0;A=G+(o*15326|0)+v|0;b[j>>0]=b[c+((E+r|0)>>>18&1023)>>0]|0;b[j+6>>0]=b[c+((r-E|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((a+B|0)>>>18&1023)>>0]|0;b[j+5>>0]=b[c+((B-a|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+((A+n|0)>>>18&1023)>>0]|0;b[j+4>>0]=b[c+((n-A|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((((F-p|0)*11585|0)+l|0)>>>18&1023)>>0]|0;k=k+1|0;if((k|0)==14)break;else e=e+28|0}u=i;return}function LJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;i=u;u=u+288|0;j=i;k=f[a+336>>2]|0;a=0;l=e;e=f[c+84>>2]|0;c=j;while(1){m=Y(f[e>>2]<<13,d[l>>1]|0)|0|1024;n=Y((f[e+128>>2]|0)*10033|0,d[l+64>>1]|0)|0;o=n+m|0;p=m-n|0;n=Y(d[l+32>>1]|0,f[e+64>>2]|0)|0;q=Y(f[e+192>>2]<<13,d[l+96>>1]|0)|0;r=(n<<13)-q|0;s=r+m|0;t=m-r|0;r=q+(n*11190|0)|0;m=r+o|0;v=o-r|0;r=(n*2998|0)-q|0;q=r+p|0;n=p-r|0;r=Y(d[l+16>>1]|0,f[e+32>>2]|0)|0;p=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;o=Y(d[l+80>>1]|0,f[e+160>>2]|0)|0;w=Y(d[l+112>>1]|0,f[e+224>>2]|0)|0;x=p*10703|0;y=Y(p,-4433)|0;z=o+r|0;A=(w+z|0)*7053|0;B=A+(z*2139|0)|0;z=x+(r*2295|0)+B|0;C=Y(w+o|0,-8565)|0;D=(Y(o,-12112)|0)+y+C+B|0;B=(w*12998|0)-x+A+C|0;C=y+(Y(r,-5540)|0)+(Y(w,-16244)|0)+A|0;A=r-w|0;w=p-o|0;o=(A+w|0)*4433|0;p=o+(A*6270|0)|0;A=o+(Y(w,-15137)|0)|0;f[c>>2]=z+m>>11;f[c+264>>2]=m-z>>11;f[c+24>>2]=p+s>>11;f[c+240>>2]=s-p>>11;f[c+48>>2]=D+q>>11;f[c+216>>2]=q-D>>11;f[c+72>>2]=B+n>>11;f[c+192>>2]=n-B>>11;f[c+96>>2]=A+t>>11;f[c+168>>2]=t-A>>11;f[c+120>>2]=C+v>>11;f[c+144>>2]=v-C>>11;a=a+1|0;if((a|0)==6)break;else{l=l+2|0;e=e+4|0;c=c+4|0}}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=(f[e>>2]<<13)+131072|0;a=(f[e+16>>2]|0)*5793|0;C=l+a|0;v=l-a-a|0;a=(f[e+8>>2]|0)*10033|0;l=C+a|0;A=C-a|0;a=f[e+4>>2]|0;C=f[e+12>>2]|0;t=f[e+20>>2]|0;B=(t+a|0)*2998|0;n=B+(C+a<<13)|0;D=B+(t-C<<13)|0;B=a-C-t<<13;b[j>>0]=b[c+((n+l|0)>>>18&1023)>>0]|0;b[j+5>>0]=b[c+((l-n|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((B+v|0)>>>18&1023)>>0]|0;b[j+4>>0]=b[c+((v-B|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+((D+A|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((A-D|0)>>>18&1023)>>0]|0;k=k+1|0;if((k|0)==12)break;else e=e+24|0}u=i;return}function MJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;i=u;u=u+208|0;j=i;k=f[a+336>>2]|0;a=0;l=e;e=f[c+84>>2]|0;c=j;while(1){m=Y(f[e>>2]<<13,d[l>>1]|0)|0|1024;n=Y(d[l+64>>1]|0,f[e+128>>2]|0)|0;o=(n*9373|0)+m|0;p=(Y(n,-3580)|0)+m|0;q=(Y(n,-11586)|0)+m>>11;m=Y(d[l+32>>1]|0,f[e+64>>2]|0)|0;n=Y(d[l+96>>1]|0,f[e+192>>2]|0)|0;r=(n+m|0)*6810|0;s=r+(m*4209|0)|0;m=r+(Y(n,-17828)|0)|0;n=s+o|0;r=o-s|0;s=m+p|0;o=p-m|0;m=Y(d[l+16>>1]|0,f[e+32>>2]|0)|0;p=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;t=Y(d[l+80>>1]|0,f[e+160>>2]|0)|0;v=Y(d[l+112>>1]|0,f[e+224>>2]|0)|0;w=v+p|0;x=p-v|0;v=x*2531|0;p=t<<13;y=w*7791|0;z=v+p|0;A=y+(m*11443|0)+z|0;B=(m*1812|0)-y+z|0;z=w*4815|0;w=p-v-(x<<12)|0;v=m-t-x<<2;x=(m*10323|0)-z-w|0;t=w+((m*5260|0)-z)|0;f[c>>2]=A+n>>11;f[c+180>>2]=n-A>>11;f[c+20>>2]=x+s>>11;f[c+160>>2]=s-x>>11;f[c+40>>2]=v+q;f[c+140>>2]=q-v;f[c+60>>2]=t+o>>11;f[c+120>>2]=o-t>>11;f[c+80>>2]=B+r>>11;f[c+100>>2]=r-B>>11;a=a+1|0;if((a|0)==5)break;else{l=l+2|0;e=e+4|0;c=c+4|0}}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=(f[e>>2]<<13)+131072|0;a=f[e+8>>2]|0;B=f[e+16>>2]|0;r=(B+a|0)*6476|0;t=a-B|0;B=(t*2896|0)+l|0;a=B+r|0;o=B-r|0;r=(Y(t,-11584)|0)+l|0;l=f[e+4>>2]|0;t=f[e+12>>2]|0;B=(t+l|0)*6810|0;v=B+(l*4209|0)|0;l=B+(Y(t,-17828)|0)|0;b[j>>0]=b[c+((v+a|0)>>>18&1023)>>0]|0;b[j+4>>0]=b[c+((a-v|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((l+o|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((o-l|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+(r>>>18&1023)>>0]|0;k=k+1|0;if((k|0)==10)break;else e=e+20|0}u=i;return}function NJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;i=u;u=u+128|0;j=i;k=f[a+336>>2]|0;a=4;l=e;e=f[c+84>>2]|0;c=j;while(1){m=d[l+16>>1]|0;n=d[l+32>>1]|0;if(!((m|n)<<16>>16))if(((((d[l+48>>1]|0)==0?(d[l+64>>1]|0)==0:0)?(d[l+80>>1]|0)==0:0)?(d[l+96>>1]|0)==0:0)?(d[l+112>>1]|0)==0:0){o=Y(f[e>>2]<<2,d[l>>1]|0)|0;f[c>>2]=o;f[c+16>>2]=o;f[c+32>>2]=o;f[c+48>>2]=o;f[c+64>>2]=o;f[c+80>>2]=o;f[c+96>>2]=o;p=28;q=o}else{r=0;s=9}else{r=n;s=9}if((s|0)==9){s=0;n=Y(r<<16>>16,f[e+64>>2]|0)|0;o=Y(d[l+96>>1]|0,f[e+192>>2]|0)|0;t=(o+n|0)*4433|0;v=t+(n*6270|0)|0;n=t+(Y(o,-15137)|0)|0;o=Y(f[e+128>>2]<<13,d[l+64>>1]|0)|0;t=Y(f[e>>2]<<13,d[l>>1]|0)|0|1024;w=o+t|0;x=t-o|0;o=w+v|0;t=w-v|0;v=x+n|0;w=x-n|0;n=Y(d[l+112>>1]|0,f[e+224>>2]|0)|0;x=Y(d[l+80>>1]|0,f[e+160>>2]|0)|0;y=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;z=Y(m<<16>>16,f[e+32>>2]|0)|0;m=y+n|0;A=z+x|0;B=(A+m|0)*9633|0;C=B+(Y(m,-16069)|0)|0;m=B+(Y(A,-3196)|0)|0;A=Y(z+n|0,-7373)|0;B=A+(n*2446|0)+C|0;n=A+(z*12299|0)+m|0;z=Y(y+x|0,-20995)|0;A=z+(x*16819|0)+m|0;m=z+(y*25172|0)+C|0;f[c>>2]=n+o>>11;f[c+112>>2]=o-n>>11;f[c+16>>2]=m+v>>11;f[c+96>>2]=v-m>>11;f[c+32>>2]=A+w>>11;f[c+80>>2]=w-A>>11;f[c+48>>2]=B+t>>11;p=16;q=t-B>>11}f[c+(p<<2)>>2]=q;if((a|0)>1){a=a+-1|0;l=l+2|0;e=e+4|0;c=c+4|0}else break}c=k+128|0;k=0;e=j;while(1){j=(f[g+(k<<2)>>2]|0)+h|0;l=(f[e>>2]|0)+16|0;a=f[e+8>>2]|0;q=l+a<<13;p=l-a<<13;a=f[e+4>>2]|0;l=f[e+12>>2]|0;r=(l+a|0)*4433|0;s=r+(a*6270|0)|0;a=r+(Y(l,-15137)|0)|0;b[j>>0]=b[c+((s+q|0)>>>18&1023)>>0]|0;b[j+3>>0]=b[c+((q-s|0)>>>18&1023)>>0]|0;b[j+1>>0]=b[c+((a+p|0)>>>18&1023)>>0]|0;b[j+2>>0]=b[c+((p-a|0)>>>18&1023)>>0]|0;k=k+1|0;if((k|0)==8)break;else e=e+16|0}u=i;return}function OJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;i=u;u=u+80|0;j=i;k=f[a+336>>2]|0;a=0;l=e;e=f[c+84>>2]|0;c=j;while(1){m=Y(f[e>>2]<<13,d[l>>1]|0)|0|1024;n=Y((f[e+128>>2]|0)*5793|0,d[l+64>>1]|0)|0;o=n+m|0;p=(Y(n,-2)|0)+m>>11;m=Y((f[e+64>>2]|0)*10033|0,d[l+32>>1]|0)|0;n=m+o|0;q=o-m|0;m=Y(d[l+16>>1]|0,f[e+32>>2]|0)|0;o=Y(d[l+48>>1]|0,f[e+96>>2]|0)|0;r=Y(d[l+80>>1]|0,f[e+160>>2]|0)|0;s=(r+m|0)*2998|0;t=s+(o+m<<13)|0;v=s+(r-o<<13)|0;s=m-o-r<<2;f[c>>2]=t+n>>11;f[c+60>>2]=n-t>>11;f[c+12>>2]=s+p;f[c+48>>2]=p-s;f[c+24>>2]=v+q>>11;f[c+36>>2]=q-v>>11;a=a+1|0;if((a|0)==3)break;else{l=l+2|0;e=e+4|0;c=c+4|0}}c=k+128|0;k=(f[g>>2]|0)+h|0;e=(f[j>>2]<<13)+131072|0;l=f[j+8>>2]|0;a=e+(l*5793|0)|0;v=(Y(l,-11586)|0)+e|0;e=(f[j+4>>2]|0)*10033|0;b[k>>0]=b[c+((a+e|0)>>>18&1023)>>0]|0;b[k+2>>0]=b[c+((a-e|0)>>>18&1023)>>0]|0;b[k+1>>0]=b[c+(v>>>18&1023)>>0]|0;v=(f[g+4>>2]|0)+h|0;k=(f[j+12>>2]<<13)+131072|0;e=f[j+20>>2]|0;a=k+(e*5793|0)|0;l=(Y(e,-11586)|0)+k|0;k=(f[j+16>>2]|0)*10033|0;b[v>>0]=b[c+((a+k|0)>>>18&1023)>>0]|0;b[v+2>>0]=b[c+((a-k|0)>>>18&1023)>>0]|0;b[v+1>>0]=b[c+(l>>>18&1023)>>0]|0;l=(f[g+8>>2]|0)+h|0;v=(f[j+24>>2]<<13)+131072|0;k=f[j+32>>2]|0;a=v+(k*5793|0)|0;e=(Y(k,-11586)|0)+v|0;v=(f[j+28>>2]|0)*10033|0;b[l>>0]=b[c+((a+v|0)>>>18&1023)>>0]|0;b[l+2>>0]=b[c+((a-v|0)>>>18&1023)>>0]|0;b[l+1>>0]=b[c+(e>>>18&1023)>>0]|0;e=(f[g+12>>2]|0)+h|0;l=(f[j+36>>2]<<13)+131072|0;v=f[j+44>>2]|0;a=l+(v*5793|0)|0;k=(Y(v,-11586)|0)+l|0;l=(f[j+40>>2]|0)*10033|0;b[e>>0]=b[c+((a+l|0)>>>18&1023)>>0]|0;b[e+2>>0]=b[c+((a-l|0)>>>18&1023)>>0]|0;b[e+1>>0]=b[c+(k>>>18&1023)>>0]|0;k=(f[g+16>>2]|0)+h|0;e=(f[j+48>>2]<<13)+131072|0;l=f[j+56>>2]|0;a=e+(l*5793|0)|0;v=(Y(l,-11586)|0)+e|0;e=(f[j+52>>2]|0)*10033|0;b[k>>0]=b[c+((a+e|0)>>>18&1023)>>0]|0;b[k+2>>0]=b[c+((a-e|0)>>>18&1023)>>0]|0;b[k+1>>0]=b[c+(v>>>18&1023)>>0]|0;v=(f[g+20>>2]|0)+h|0;h=(f[j+60>>2]<<13)+131072|0;g=f[j+68>>2]|0;k=h+(g*5793|0)|0;e=(Y(g,-11586)|0)+h|0;h=(f[j+64>>2]|0)*10033|0;b[v>>0]=b[c+((k+h|0)>>>18&1023)>>0]|0;b[v+2>>0]=b[c+((k-h|0)>>>18&1023)>>0]|0;b[v+1>>0]=b[c+(e>>>18&1023)>>0]|0;u=i;return}function PJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;i=u;u=u+32|0;j=i;k=f[a+336>>2]|0;a=f[c+84>>2]|0;c=Y(d[e>>1]|0,f[a>>2]|0)|0;l=Y(d[e+32>>1]|0,f[a+64>>2]|0)|0;m=l+c<<13;n=c-l<<13;l=Y(d[e+16>>1]|0,f[a+32>>2]|0)|0;c=Y(d[e+48>>1]|0,f[a+96>>2]|0)|0;o=(c+l|0)*4433|0;p=o+(l*6270|0)|0;l=o+(Y(c,-15137)|0)|0;c=p+m|0;f[j>>2]=c;f[j+24>>2]=m-p;p=l+n|0;f[j+8>>2]=p;m=n-l|0;f[j+16>>2]=m;l=Y(d[e+2>>1]|0,f[a+4>>2]|0)|0;n=Y(d[e+34>>1]|0,f[a+68>>2]|0)|0;o=n+l<<13;q=l-n<<13;n=Y(d[e+18>>1]|0,f[a+36>>2]|0)|0;l=Y(d[e+50>>1]|0,f[a+100>>2]|0)|0;a=(l+n|0)*4433|0;e=a+(n*6270|0)|0;n=a+(Y(l,-15137)|0)|0;l=e+o|0;f[j+4>>2]=l;a=o-e|0;f[j+28>>2]=a;e=n+q|0;f[j+12>>2]=e;o=q-n|0;f[j+20>>2]=o;n=k+128|0;k=(f[g>>2]|0)+h|0;q=c+32768|0;b[k>>0]=b[n+((q+l|0)>>>16&1023)>>0]|0;b[k+1>>0]=b[n+((q-l|0)>>>16&1023)>>0]|0;l=(f[g+4>>2]|0)+h|0;q=p+32768|0;b[l>>0]=b[n+((q+e|0)>>>16&1023)>>0]|0;b[l+1>>0]=b[n+((q-e|0)>>>16&1023)>>0]|0;e=(f[g+8>>2]|0)+h|0;q=m+32768|0;b[e>>0]=b[n+((q+o|0)>>>16&1023)>>0]|0;b[e+1>>0]=b[n+((q-o|0)>>>16&1023)>>0]|0;o=(f[g+12>>2]|0)+h|0;h=(f[j+24>>2]|0)+32768|0;b[o>>0]=b[n+((h+a|0)>>>16&1023)>>0]|0;b[o+1>>0]=b[n+((h-a|0)>>>16&1023)>>0]|0;u=i;return}function QJa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=(f[a+336>>2]|0)+128|0;a=f[c+84>>2]|0;c=(Y(d[e>>1]|0,f[a>>2]|0)|0)+4|0;j=Y(d[e+16>>1]|0,f[a+32>>2]|0)|0;b[(f[g>>2]|0)+h>>0]=b[i+((j+c|0)>>>3&1023)>>0]|0;b[(f[g+4>>2]|0)+h>>0]=b[i+((c-j|0)>>>3&1023)>>0]|0;return}function RJa(a,b){a=a|0;b=b|0;return dKa(b)|0}function SJa(a,b,c){a=a|0;b=b|0;c=c|0;eKa(b);return}function TJa(a,b){a=a|0;b=b|0;return dKa(b)|0}function UJa(a,b,c){a=a|0;b=b|0;c=c|0;eKa(b);return}function VJa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return (f[(f[a+4>>2]|0)+44>>2]|0)-d|0}function WJa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;d=WMa()|0;f[c+12>>2]=d;if(!d){d=f[a>>2]|0;f[d+20>>2]=65;e=d+24|0;d=e+80|0;do{b[e>>0]=0;e=e+1|0}while((e|0)<(d|0));ki[f[f[a>>2]>>2]&2047](a)}f[c>>2]=187;f[c+4>>2]=188;f[c+8>>2]=402;return}function XJa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0;g=b+12|0;if(RMa(f[g>>2]|0,d,0)|0){d=f[a>>2]|0;f[d+20>>2]=67;ki[f[d>>2]&2047](a)}if((MMa(c,1,e,f[g>>2]|0)|0)==(e|0))return;e=f[a>>2]|0;f[e+20>>2]=66;ki[f[e>>2]&2047](a);return}function YJa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0;g=b+12|0;if(RMa(f[g>>2]|0,d,0)|0){d=f[a>>2]|0;f[d+20>>2]=67;ki[f[d>>2]&2047](a)}if((xMa(c,1,e,f[g>>2]|0)|0)==(e|0))return;e=f[a>>2]|0;f[e+20>>2]=68;ki[f[e>>2]&2047](a);return}function ZJa(a,b){a=a|0;b=b|0;GMa(f[b+12>>2]|0)|0;return}function _Ja(a){a=a|0;return 1073741824}function $Ja(a){a=a|0;return}function aKa(){bKa(0);return}function bKa(a){a=a|0;qf(21584,374450);Xd(21600,374455,1,1,0);Ce(21608,374224,1,-128,127);Ce(21624,374229,1,-128,127);Ce(21616,374241,1,0,255);Ce(21632,374255,2,-32768,32767);Ce(21640,374261,2,0,65535);Ce(21648,374460,4,-2147483648,2147483647);Ce(21656,374464,4,0,-1);Ce(21664,374477,4,-2147483648,2147483647);Ce(21672,374482,4,0,-1);Gf(21680,374506,4);Gf(21688,374618,8);wd(9696,373833);wd(20008,365716);xf(20032,4,365749);$d(8736,365762);gf(9584,0,365778);gf(20056,0,365808);gf(9576,1,365845);gf(9600,2,365884);gf(9592,3,365915);gf(9608,4,365955);gf(20064,5,365984);gf(20072,4,366022);gf(20080,5,366052);gf(20056,0,366091);gf(9576,1,366123);gf(9600,2,366156);gf(9592,3,366189);gf(9608,4,366223);gf(20064,5,366256);gf(9616,6,366290);gf(9624,7,366321);gf(20088,7,366353);return}function cKa(a){a=a|0;return cLa(f[a+4>>2]|0)|0}function dKa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0;b=u;u=u+16|0;c=b;do if(a>>>0<245){d=a>>>0<11?16:a+11&-8;e=d>>>3;g=f[493378]|0;h=g>>>e;if(h&3|0){i=(h&1^1)+e|0;j=1973552+(i<<1<<2)|0;k=j+8|0;l=f[k>>2]|0;m=l+8|0;n=f[m>>2]|0;if((j|0)==(n|0))f[493378]=g&~(1<<i);else{f[n+12>>2]=j;f[k>>2]=n}n=i<<3;f[l+4>>2]=n|3;i=l+n+4|0;f[i>>2]=f[i>>2]|1;o=m;u=b;return o|0}m=f[493380]|0;if(d>>>0>m>>>0){if(h|0){i=2<<e;n=h<<e&(i|0-i);i=(n&0-n)+-1|0;n=i>>>12&16;e=i>>>n;i=e>>>5&8;h=e>>>i;e=h>>>2&4;l=h>>>e;h=l>>>1&2;k=l>>>h;l=k>>>1&1;j=(i|n|e|h|l)+(k>>>l)|0;l=1973552+(j<<1<<2)|0;k=l+8|0;h=f[k>>2]|0;e=h+8|0;n=f[e>>2]|0;if((l|0)==(n|0)){i=g&~(1<<j);f[493378]=i;p=i}else{f[n+12>>2]=l;f[k>>2]=n;p=g}n=(j<<3)-d|0;f[h+4>>2]=d|3;j=h+d|0;f[j+4>>2]=n|1;f[j+n>>2]=n;if(m|0){h=f[493383]|0;k=m>>>3;l=1973552+(k<<1<<2)|0;i=1<<k;if(!(p&i)){f[493378]=p|i;q=l+8|0;r=l}else{i=l+8|0;q=i;r=f[i>>2]|0}f[q>>2]=h;f[r+12>>2]=h;f[h+8>>2]=r;f[h+12>>2]=l}f[493380]=n;f[493383]=j;o=e;u=b;return o|0}e=f[493379]|0;if(e){j=(e&0-e)+-1|0;n=j>>>12&16;l=j>>>n;j=l>>>5&8;h=l>>>j;l=h>>>2&4;i=h>>>l;h=i>>>1&2;k=i>>>h;i=k>>>1&1;s=f[1973816+((j|n|l|h|i)+(k>>>i)<<2)>>2]|0;i=(f[s+4>>2]&-8)-d|0;k=f[s+16+(((f[s+16>>2]|0)==0&1)<<2)>>2]|0;if(!k){t=i;v=s}else{h=k;k=i;i=s;while(1){s=(f[h+4>>2]&-8)-d|0;l=s>>>0<k>>>0;n=l?s:k;s=l?h:i;h=f[h+16+(((f[h+16>>2]|0)==0&1)<<2)>>2]|0;if(!h){t=n;v=s;break}else{k=n;i=s}}}i=v+d|0;if(v>>>0<i>>>0){k=f[v+24>>2]|0;h=f[v+12>>2]|0;do if((h|0)==(v|0)){s=v+20|0;n=f[s>>2]|0;if(!n){l=v+16|0;j=f[l>>2]|0;if(!j){w=0;break}else{x=j;y=l}}else{x=n;y=s}while(1){s=x+20|0;n=f[s>>2]|0;if(n|0){x=n;y=s;continue}s=x+16|0;n=f[s>>2]|0;if(!n)break;else{x=n;y=s}}f[y>>2]=0;w=x}else{s=f[v+8>>2]|0;f[s+12>>2]=h;f[h+8>>2]=s;w=h}while(0);do if(k|0){h=f[v+28>>2]|0;s=1973816+(h<<2)|0;if((v|0)==(f[s>>2]|0)){f[s>>2]=w;if(!w){f[493379]=e&~(1<<h);break}}else{f[k+16+(((f[k+16>>2]|0)!=(v|0)&1)<<2)>>2]=w;if(!w)break}f[w+24>>2]=k;h=f[v+16>>2]|0;if(h|0){f[w+16>>2]=h;f[h+24>>2]=w}h=f[v+20>>2]|0;if(h|0){f[w+20>>2]=h;f[h+24>>2]=w}}while(0);if(t>>>0<16){k=t+d|0;f[v+4>>2]=k|3;e=v+k+4|0;f[e>>2]=f[e>>2]|1}else{f[v+4>>2]=d|3;f[i+4>>2]=t|1;f[i+t>>2]=t;if(m|0){e=f[493383]|0;k=m>>>3;h=1973552+(k<<1<<2)|0;s=1<<k;if(!(g&s)){f[493378]=g|s;z=h+8|0;A=h}else{s=h+8|0;z=s;A=f[s>>2]|0}f[z>>2]=e;f[A+12>>2]=e;f[e+8>>2]=A;f[e+12>>2]=h}f[493380]=t;f[493383]=i}o=v+8|0;u=b;return o|0}else B=d}else B=d}else B=d}else if(a>>>0<=4294967231){h=a+11|0;e=h&-8;s=f[493379]|0;if(s){k=0-e|0;n=h>>>8;if(n)if(e>>>0>16777215)C=31;else{h=(n+1048320|0)>>>16&8;l=n<<h;n=(l+520192|0)>>>16&4;j=l<<n;l=(j+245760|0)>>>16&2;D=14-(n|h|l)+(j<<l>>>15)|0;C=e>>>(D+7|0)&1|D<<1}else C=0;D=f[1973816+(C<<2)>>2]|0;a:do if(!D){E=k;F=0;G=0;H=57}else{l=k;j=0;h=e<<((C|0)==31?0:25-(C>>>1)|0);n=D;I=0;while(1){J=(f[n+4>>2]&-8)-e|0;if(J>>>0<l>>>0)if(!J){K=0;L=n;M=n;H=61;break a}else{N=J;O=n}else{N=l;O=I}J=f[n+20>>2]|0;n=f[n+16+(h>>>31<<2)>>2]|0;P=(J|0)==0|(J|0)==(n|0)?j:J;J=(n|0)==0;if(J){E=N;F=P;G=O;H=57;break}else{l=N;j=P;h=h<<((J^1)&1);I=O}}}while(0);if((H|0)==57){if((F|0)==0&(G|0)==0){D=2<<C;k=s&(D|0-D);if(!k){B=e;break}D=(k&0-k)+-1|0;k=D>>>12&16;d=D>>>k;D=d>>>5&8;i=d>>>D;d=i>>>2&4;g=i>>>d;i=g>>>1&2;m=g>>>i;g=m>>>1&1;Q=f[1973816+((D|k|d|i|g)+(m>>>g)<<2)>>2]|0;R=0}else{Q=F;R=G}if(!Q){S=E;T=R}else{K=E;L=Q;M=R;H=61}}if((H|0)==61)while(1){H=0;g=(f[L+4>>2]&-8)-e|0;m=g>>>0<K>>>0;i=m?g:K;g=m?L:M;L=f[L+16+(((f[L+16>>2]|0)==0&1)<<2)>>2]|0;if(!L){S=i;T=g;break}else{K=i;M=g;H=61}}if((T|0)!=0?S>>>0<((f[493380]|0)-e|0)>>>0:0){g=T+e|0;if(T>>>0>=g>>>0){o=0;u=b;return o|0}i=f[T+24>>2]|0;m=f[T+12>>2]|0;do if((m|0)==(T|0)){d=T+20|0;k=f[d>>2]|0;if(!k){D=T+16|0;I=f[D>>2]|0;if(!I){U=0;break}else{V=I;W=D}}else{V=k;W=d}while(1){d=V+20|0;k=f[d>>2]|0;if(k|0){V=k;W=d;continue}d=V+16|0;k=f[d>>2]|0;if(!k)break;else{V=k;W=d}}f[W>>2]=0;U=V}else{d=f[T+8>>2]|0;f[d+12>>2]=m;f[m+8>>2]=d;U=m}while(0);do if(i){m=f[T+28>>2]|0;d=1973816+(m<<2)|0;if((T|0)==(f[d>>2]|0)){f[d>>2]=U;if(!U){d=s&~(1<<m);f[493379]=d;X=d;break}}else{f[i+16+(((f[i+16>>2]|0)!=(T|0)&1)<<2)>>2]=U;if(!U){X=s;break}}f[U+24>>2]=i;d=f[T+16>>2]|0;if(d|0){f[U+16>>2]=d;f[d+24>>2]=U}d=f[T+20>>2]|0;if(d){f[U+20>>2]=d;f[d+24>>2]=U;X=s}else X=s}else X=s;while(0);do if(S>>>0>=16){f[T+4>>2]=e|3;f[g+4>>2]=S|1;f[g+S>>2]=S;s=S>>>3;if(S>>>0<256){i=1973552+(s<<1<<2)|0;d=f[493378]|0;m=1<<s;if(!(d&m)){f[493378]=d|m;Y=i+8|0;Z=i}else{m=i+8|0;Y=m;Z=f[m>>2]|0}f[Y>>2]=g;f[Z+12>>2]=g;f[g+8>>2]=Z;f[g+12>>2]=i;break}i=S>>>8;if(i)if(S>>>0>16777215)_=31;else{m=(i+1048320|0)>>>16&8;d=i<<m;i=(d+520192|0)>>>16&4;s=d<<i;d=(s+245760|0)>>>16&2;k=14-(i|m|d)+(s<<d>>>15)|0;_=S>>>(k+7|0)&1|k<<1}else _=0;k=1973816+(_<<2)|0;f[g+28>>2]=_;d=g+16|0;f[d+4>>2]=0;f[d>>2]=0;d=1<<_;if(!(X&d)){f[493379]=X|d;f[k>>2]=g;f[g+24>>2]=k;f[g+12>>2]=g;f[g+8>>2]=g;break}d=S<<((_|0)==31?0:25-(_>>>1)|0);s=f[k>>2]|0;while(1){if((f[s+4>>2]&-8|0)==(S|0)){H=97;break}$=s+16+(d>>>31<<2)|0;k=f[$>>2]|0;if(!k){H=96;break}else{d=d<<1;s=k}}if((H|0)==96){f[$>>2]=g;f[g+24>>2]=s;f[g+12>>2]=g;f[g+8>>2]=g;break}else if((H|0)==97){d=s+8|0;k=f[d>>2]|0;f[k+12>>2]=g;f[d>>2]=g;f[g+8>>2]=k;f[g+12>>2]=s;f[g+24>>2]=0;break}}else{k=S+e|0;f[T+4>>2]=k|3;d=T+k+4|0;f[d>>2]=f[d>>2]|1}while(0);o=T+8|0;u=b;return o|0}else B=e}else B=e}else B=-1;while(0);T=f[493380]|0;if(T>>>0>=B>>>0){S=T-B|0;$=f[493383]|0;if(S>>>0>15){_=$+B|0;f[493383]=_;f[493380]=S;f[_+4>>2]=S|1;f[_+S>>2]=S;f[$+4>>2]=B|3}else{f[493380]=0;f[493383]=0;f[$+4>>2]=T|3;S=$+T+4|0;f[S>>2]=f[S>>2]|1}o=$+8|0;u=b;return o|0}$=f[493381]|0;if($>>>0>B>>>0){S=$-B|0;f[493381]=S;T=f[493384]|0;_=T+B|0;f[493384]=_;f[_+4>>2]=S|1;f[T+4>>2]=B|3;o=T+8|0;u=b;return o|0}if(!(f[493496]|0)){f[493498]=4096;f[493497]=4096;f[493499]=-1;f[493500]=-1;f[493501]=0;f[493489]=0;T=c&-16^1431655768;f[c>>2]=T;f[493496]=T;aa=4096}else aa=f[493498]|0;T=B+48|0;c=B+47|0;S=aa+c|0;_=0-aa|0;aa=S&_;if(aa>>>0<=B>>>0){o=0;u=b;return o|0}X=f[493488]|0;if(X|0?(Z=f[493486]|0,Y=Z+aa|0,Y>>>0<=Z>>>0|Y>>>0>X>>>0):0){o=0;u=b;return o|0}b:do if(!(f[493489]&4)){X=f[493384]|0;c:do if(X){Y=1973960;while(1){Z=f[Y>>2]|0;if(Z>>>0<=X>>>0?(ba=Y+4|0,(Z+(f[ba>>2]|0)|0)>>>0>X>>>0):0)break;Z=f[Y+8>>2]|0;if(!Z){H=118;break c}else Y=Z}s=S-$&_;if(s>>>0<2147483647){Z=L1a(s|0)|0;if((Z|0)==((f[Y>>2]|0)+(f[ba>>2]|0)|0))if((Z|0)==(-1|0))ca=s;else{da=Z;ea=s;H=135;break b}else{fa=Z;ga=s;H=126}}else ca=0}else H=118;while(0);do if((H|0)==118){X=L1a(0)|0;if((X|0)!=(-1|0)?(e=X,s=f[493497]|0,Z=s+-1|0,U=((Z&e|0)==0?0:(Z+e&0-s)-e|0)+aa|0,e=f[493486]|0,s=U+e|0,U>>>0>B>>>0&U>>>0<2147483647):0){Z=f[493488]|0;if(Z|0?s>>>0<=e>>>0|s>>>0>Z>>>0:0){ca=0;break}Z=L1a(U|0)|0;if((Z|0)==(X|0)){da=X;ea=U;H=135;break b}else{fa=Z;ga=U;H=126}}else ca=0}while(0);do if((H|0)==126){U=0-ga|0;if(!(T>>>0>ga>>>0&(ga>>>0<2147483647&(fa|0)!=(-1|0))))if((fa|0)==(-1|0)){ca=0;break}else{da=fa;ea=ga;H=135;break b}Z=f[493498]|0;X=c-ga+Z&0-Z;if(X>>>0>=2147483647){da=fa;ea=ga;H=135;break b}if((L1a(X|0)|0)==(-1|0)){L1a(U|0)|0;ca=0;break}else{da=fa;ea=X+ga|0;H=135;break b}}while(0);f[493489]=f[493489]|4;ha=ca;H=133}else{ha=0;H=133}while(0);if(((H|0)==133?aa>>>0<2147483647:0)?(ca=L1a(aa|0)|0,aa=L1a(0)|0,ga=aa-ca|0,fa=ga>>>0>(B+40|0)>>>0,!((ca|0)==(-1|0)|fa^1|ca>>>0<aa>>>0&((ca|0)!=(-1|0)&(aa|0)!=(-1|0))^1)):0){da=ca;ea=fa?ga:ha;H=135}if((H|0)==135){ha=(f[493486]|0)+ea|0;f[493486]=ha;if(ha>>>0>(f[493487]|0)>>>0)f[493487]=ha;ha=f[493384]|0;do if(ha){ga=1973960;while(1){ia=f[ga>>2]|0;ja=ga+4|0;ka=f[ja>>2]|0;if((da|0)==(ia+ka|0)){H=145;break}fa=f[ga+8>>2]|0;if(!fa)break;else ga=fa}if(((H|0)==145?(f[ga+12>>2]&8|0)==0:0)?ha>>>0<da>>>0&ha>>>0>=ia>>>0:0){f[ja>>2]=ka+ea;fa=ha+8|0;ca=(fa&7|0)==0?0:0-fa&7;fa=ha+ca|0;aa=(f[493381]|0)+(ea-ca)|0;f[493384]=fa;f[493381]=aa;f[fa+4>>2]=aa|1;f[fa+aa+4>>2]=40;f[493385]=f[493500];break}if(da>>>0<(f[493382]|0)>>>0)f[493382]=da;aa=da+ea|0;fa=1973960;while(1){if((f[fa>>2]|0)==(aa|0)){H=153;break}ca=f[fa+8>>2]|0;if(!ca)break;else fa=ca}if((H|0)==153?(f[fa+12>>2]&8|0)==0:0){f[fa>>2]=da;ga=fa+4|0;f[ga>>2]=(f[ga>>2]|0)+ea;ga=da+8|0;ca=da+((ga&7|0)==0?0:0-ga&7)|0;ga=aa+8|0;c=aa+((ga&7|0)==0?0:0-ga&7)|0;ga=ca+B|0;T=c-ca-B|0;f[ca+4>>2]=B|3;do if((c|0)!=(ha|0)){if((c|0)==(f[493383]|0)){ba=(f[493380]|0)+T|0;f[493380]=ba;f[493383]=ga;f[ga+4>>2]=ba|1;f[ga+ba>>2]=ba;break}ba=f[c+4>>2]|0;if((ba&3|0)==1){_=ba&-8;$=ba>>>3;d:do if(ba>>>0<256){S=f[c+8>>2]|0;X=f[c+12>>2]|0;if((X|0)==(S|0)){f[493378]=f[493378]&~(1<<$);break}else{f[S+12>>2]=X;f[X+8>>2]=S;break}}else{S=f[c+24>>2]|0;X=f[c+12>>2]|0;do if((X|0)==(c|0)){U=c+16|0;Z=U+4|0;s=f[Z>>2]|0;if(!s){e=f[U>>2]|0;if(!e){la=0;break}else{ma=e;na=U}}else{ma=s;na=Z}while(1){Z=ma+20|0;s=f[Z>>2]|0;if(s|0){ma=s;na=Z;continue}Z=ma+16|0;s=f[Z>>2]|0;if(!s)break;else{ma=s;na=Z}}f[na>>2]=0;la=ma}else{Z=f[c+8>>2]|0;f[Z+12>>2]=X;f[X+8>>2]=Z;la=X}while(0);if(!S)break;X=f[c+28>>2]|0;Z=1973816+(X<<2)|0;do if((c|0)!=(f[Z>>2]|0)){f[S+16+(((f[S+16>>2]|0)!=(c|0)&1)<<2)>>2]=la;if(!la)break d}else{f[Z>>2]=la;if(la|0)break;f[493379]=f[493379]&~(1<<X);break d}while(0);f[la+24>>2]=S;X=c+16|0;Z=f[X>>2]|0;if(Z|0){f[la+16>>2]=Z;f[Z+24>>2]=la}Z=f[X+4>>2]|0;if(!Z)break;f[la+20>>2]=Z;f[Z+24>>2]=la}while(0);oa=c+_|0;pa=_+T|0}else{oa=c;pa=T}$=oa+4|0;f[$>>2]=f[$>>2]&-2;f[ga+4>>2]=pa|1;f[ga+pa>>2]=pa;$=pa>>>3;if(pa>>>0<256){ba=1973552+($<<1<<2)|0;Y=f[493378]|0;Z=1<<$;if(!(Y&Z)){f[493378]=Y|Z;qa=ba+8|0;ra=ba}else{Z=ba+8|0;qa=Z;ra=f[Z>>2]|0}f[qa>>2]=ga;f[ra+12>>2]=ga;f[ga+8>>2]=ra;f[ga+12>>2]=ba;break}ba=pa>>>8;do if(!ba)sa=0;else{if(pa>>>0>16777215){sa=31;break}Z=(ba+1048320|0)>>>16&8;Y=ba<<Z;$=(Y+520192|0)>>>16&4;X=Y<<$;Y=(X+245760|0)>>>16&2;s=14-($|Z|Y)+(X<<Y>>>15)|0;sa=pa>>>(s+7|0)&1|s<<1}while(0);ba=1973816+(sa<<2)|0;f[ga+28>>2]=sa;_=ga+16|0;f[_+4>>2]=0;f[_>>2]=0;_=f[493379]|0;s=1<<sa;if(!(_&s)){f[493379]=_|s;f[ba>>2]=ga;f[ga+24>>2]=ba;f[ga+12>>2]=ga;f[ga+8>>2]=ga;break}s=pa<<((sa|0)==31?0:25-(sa>>>1)|0);_=f[ba>>2]|0;while(1){if((f[_+4>>2]&-8|0)==(pa|0)){H=194;break}ta=_+16+(s>>>31<<2)|0;ba=f[ta>>2]|0;if(!ba){H=193;break}else{s=s<<1;_=ba}}if((H|0)==193){f[ta>>2]=ga;f[ga+24>>2]=_;f[ga+12>>2]=ga;f[ga+8>>2]=ga;break}else if((H|0)==194){s=_+8|0;ba=f[s>>2]|0;f[ba+12>>2]=ga;f[s>>2]=ga;f[ga+8>>2]=ba;f[ga+12>>2]=_;f[ga+24>>2]=0;break}}else{ba=(f[493381]|0)+T|0;f[493381]=ba;f[493384]=ga;f[ga+4>>2]=ba|1}while(0);o=ca+8|0;u=b;return o|0}ga=1973960;while(1){T=f[ga>>2]|0;if(T>>>0<=ha>>>0?(ua=T+(f[ga+4>>2]|0)|0,ua>>>0>ha>>>0):0)break;ga=f[ga+8>>2]|0}ga=ua+-47|0;ca=ga+8|0;T=ga+((ca&7|0)==0?0:0-ca&7)|0;ca=ha+16|0;ga=T>>>0<ca>>>0?ha:T;T=ga+8|0;c=da+8|0;aa=(c&7|0)==0?0:0-c&7;c=da+aa|0;fa=ea+-40-aa|0;f[493384]=c;f[493381]=fa;f[c+4>>2]=fa|1;f[c+fa+4>>2]=40;f[493385]=f[493500];fa=ga+4|0;f[fa>>2]=27;f[T>>2]=f[493490];f[T+4>>2]=f[493491];f[T+8>>2]=f[493492];f[T+12>>2]=f[493493];f[493490]=da;f[493491]=ea;f[493493]=0;f[493492]=T;T=ga+24|0;do{c=T;T=T+4|0;f[T>>2]=7}while((c+8|0)>>>0<ua>>>0);if((ga|0)!=(ha|0)){T=ga-ha|0;f[fa>>2]=f[fa>>2]&-2;f[ha+4>>2]=T|1;f[ga>>2]=T;c=T>>>3;if(T>>>0<256){aa=1973552+(c<<1<<2)|0;ba=f[493378]|0;s=1<<c;if(!(ba&s)){f[493378]=ba|s;va=aa+8|0;wa=aa}else{s=aa+8|0;va=s;wa=f[s>>2]|0}f[va>>2]=ha;f[wa+12>>2]=ha;f[ha+8>>2]=wa;f[ha+12>>2]=aa;break}aa=T>>>8;if(aa)if(T>>>0>16777215)xa=31;else{s=(aa+1048320|0)>>>16&8;ba=aa<<s;aa=(ba+520192|0)>>>16&4;c=ba<<aa;ba=(c+245760|0)>>>16&2;Y=14-(aa|s|ba)+(c<<ba>>>15)|0;xa=T>>>(Y+7|0)&1|Y<<1}else xa=0;Y=1973816+(xa<<2)|0;f[ha+28>>2]=xa;f[ha+20>>2]=0;f[ca>>2]=0;ba=f[493379]|0;c=1<<xa;if(!(ba&c)){f[493379]=ba|c;f[Y>>2]=ha;f[ha+24>>2]=Y;f[ha+12>>2]=ha;f[ha+8>>2]=ha;break}c=T<<((xa|0)==31?0:25-(xa>>>1)|0);ba=f[Y>>2]|0;while(1){if((f[ba+4>>2]&-8|0)==(T|0)){H=216;break}ya=ba+16+(c>>>31<<2)|0;Y=f[ya>>2]|0;if(!Y){H=215;break}else{c=c<<1;ba=Y}}if((H|0)==215){f[ya>>2]=ha;f[ha+24>>2]=ba;f[ha+12>>2]=ha;f[ha+8>>2]=ha;break}else if((H|0)==216){c=ba+8|0;T=f[c>>2]|0;f[T+12>>2]=ha;f[c>>2]=ha;f[ha+8>>2]=T;f[ha+12>>2]=ba;f[ha+24>>2]=0;break}}}else{T=f[493382]|0;if((T|0)==0|da>>>0<T>>>0)f[493382]=da;f[493490]=da;f[493491]=ea;f[493493]=0;f[493387]=f[493496];f[493386]=-1;T=0;do{c=1973552+(T<<1<<2)|0;f[c+12>>2]=c;f[c+8>>2]=c;T=T+1|0}while((T|0)!=32);T=da+8|0;ba=(T&7|0)==0?0:0-T&7;T=da+ba|0;c=ea+-40-ba|0;f[493384]=T;f[493381]=c;f[T+4>>2]=c|1;f[T+c+4>>2]=40;f[493385]=f[493500]}while(0);ea=f[493381]|0;if(ea>>>0>B>>>0){da=ea-B|0;f[493381]=da;ea=f[493384]|0;ha=ea+B|0;f[493384]=ha;f[ha+4>>2]=da|1;f[ea+4>>2]=B|3;o=ea+8|0;u=b;return o|0}}ea=pKa()|0;f[ea>>2]=12;o=0;u=b;return o|0}function eKa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;if(!a)return;b=a+-8|0;c=f[493382]|0;d=f[a+-4>>2]|0;a=d&-8;e=b+a|0;do if(!(d&1)){g=f[b>>2]|0;if(!(d&3))return;h=b+(0-g)|0;i=g+a|0;if(h>>>0<c>>>0)return;if((h|0)==(f[493383]|0)){j=e+4|0;k=f[j>>2]|0;if((k&3|0)!=3){l=h;m=h;n=i;break}f[493380]=i;f[j>>2]=k&-2;f[h+4>>2]=i|1;f[h+i>>2]=i;return}k=g>>>3;if(g>>>0<256){g=f[h+8>>2]|0;j=f[h+12>>2]|0;if((j|0)==(g|0)){f[493378]=f[493378]&~(1<<k);l=h;m=h;n=i;break}else{f[g+12>>2]=j;f[j+8>>2]=g;l=h;m=h;n=i;break}}g=f[h+24>>2]|0;j=f[h+12>>2]|0;do if((j|0)==(h|0)){k=h+16|0;o=k+4|0;p=f[o>>2]|0;if(!p){q=f[k>>2]|0;if(!q){r=0;break}else{s=q;t=k}}else{s=p;t=o}while(1){o=s+20|0;p=f[o>>2]|0;if(p|0){s=p;t=o;continue}o=s+16|0;p=f[o>>2]|0;if(!p)break;else{s=p;t=o}}f[t>>2]=0;r=s}else{o=f[h+8>>2]|0;f[o+12>>2]=j;f[j+8>>2]=o;r=j}while(0);if(g){j=f[h+28>>2]|0;o=1973816+(j<<2)|0;if((h|0)==(f[o>>2]|0)){f[o>>2]=r;if(!r){f[493379]=f[493379]&~(1<<j);l=h;m=h;n=i;break}}else{f[g+16+(((f[g+16>>2]|0)!=(h|0)&1)<<2)>>2]=r;if(!r){l=h;m=h;n=i;break}}f[r+24>>2]=g;j=h+16|0;o=f[j>>2]|0;if(o|0){f[r+16>>2]=o;f[o+24>>2]=r}o=f[j+4>>2]|0;if(o){f[r+20>>2]=o;f[o+24>>2]=r;l=h;m=h;n=i}else{l=h;m=h;n=i}}else{l=h;m=h;n=i}}else{l=b;m=b;n=a}while(0);if(l>>>0>=e>>>0)return;a=e+4|0;b=f[a>>2]|0;if(!(b&1))return;if(!(b&2)){r=f[493383]|0;if((e|0)==(f[493384]|0)){s=(f[493381]|0)+n|0;f[493381]=s;f[493384]=m;f[m+4>>2]=s|1;if((m|0)!=(r|0))return;f[493383]=0;f[493380]=0;return}if((e|0)==(r|0)){r=(f[493380]|0)+n|0;f[493380]=r;f[493383]=l;f[m+4>>2]=r|1;f[l+r>>2]=r;return}r=(b&-8)+n|0;s=b>>>3;do if(b>>>0<256){t=f[e+8>>2]|0;c=f[e+12>>2]|0;if((c|0)==(t|0)){f[493378]=f[493378]&~(1<<s);break}else{f[t+12>>2]=c;f[c+8>>2]=t;break}}else{t=f[e+24>>2]|0;c=f[e+12>>2]|0;do if((c|0)==(e|0)){d=e+16|0;o=d+4|0;j=f[o>>2]|0;if(!j){p=f[d>>2]|0;if(!p){u=0;break}else{v=p;w=d}}else{v=j;w=o}while(1){o=v+20|0;j=f[o>>2]|0;if(j|0){v=j;w=o;continue}o=v+16|0;j=f[o>>2]|0;if(!j)break;else{v=j;w=o}}f[w>>2]=0;u=v}else{o=f[e+8>>2]|0;f[o+12>>2]=c;f[c+8>>2]=o;u=c}while(0);if(t|0){c=f[e+28>>2]|0;i=1973816+(c<<2)|0;if((e|0)==(f[i>>2]|0)){f[i>>2]=u;if(!u){f[493379]=f[493379]&~(1<<c);break}}else{f[t+16+(((f[t+16>>2]|0)!=(e|0)&1)<<2)>>2]=u;if(!u)break}f[u+24>>2]=t;c=e+16|0;i=f[c>>2]|0;if(i|0){f[u+16>>2]=i;f[i+24>>2]=u}i=f[c+4>>2]|0;if(i|0){f[u+20>>2]=i;f[i+24>>2]=u}}}while(0);f[m+4>>2]=r|1;f[l+r>>2]=r;if((m|0)==(f[493383]|0)){f[493380]=r;return}else x=r}else{f[a>>2]=b&-2;f[m+4>>2]=n|1;f[l+n>>2]=n;x=n}n=x>>>3;if(x>>>0<256){l=1973552+(n<<1<<2)|0;b=f[493378]|0;a=1<<n;if(!(b&a)){f[493378]=b|a;y=l+8|0;z=l}else{a=l+8|0;y=a;z=f[a>>2]|0}f[y>>2]=m;f[z+12>>2]=m;f[m+8>>2]=z;f[m+12>>2]=l;return}l=x>>>8;if(l)if(x>>>0>16777215)A=31;else{z=(l+1048320|0)>>>16&8;y=l<<z;l=(y+520192|0)>>>16&4;a=y<<l;y=(a+245760|0)>>>16&2;b=14-(l|z|y)+(a<<y>>>15)|0;A=x>>>(b+7|0)&1|b<<1}else A=0;b=1973816+(A<<2)|0;f[m+28>>2]=A;f[m+20>>2]=0;f[m+16>>2]=0;y=f[493379]|0;a=1<<A;do if(y&a){z=x<<((A|0)==31?0:25-(A>>>1)|0);l=f[b>>2]|0;while(1){if((f[l+4>>2]&-8|0)==(x|0)){B=73;break}C=l+16+(z>>>31<<2)|0;n=f[C>>2]|0;if(!n){B=72;break}else{z=z<<1;l=n}}if((B|0)==72){f[C>>2]=m;f[m+24>>2]=l;f[m+12>>2]=m;f[m+8>>2]=m;break}else if((B|0)==73){z=l+8|0;t=f[z>>2]|0;f[t+12>>2]=m;f[z>>2]=m;f[m+8>>2]=t;f[m+12>>2]=l;f[m+24>>2]=0;break}}else{f[493379]=y|a;f[b>>2]=m;f[m+24>>2]=b;f[m+12>>2]=m;f[m+8>>2]=m}while(0);m=(f[493386]|0)+-1|0;f[493386]=m;if(!m)D=1973968;else return;while(1){m=f[D>>2]|0;if(!m)break;else D=m+8|0}f[493386]=-1;return}function fKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if(!a){c=dKa(b)|0;return c|0}if(b>>>0>4294967231){d=pKa()|0;f[d>>2]=12;c=0;return c|0}d=gKa(a+-8|0,b>>>0<11?16:b+11&-8)|0;if(d|0){c=d+8|0;return c|0}d=dKa(b)|0;if(!d){c=0;return c|0}e=f[a+-4>>2]|0;g=(e&-8)-((e&3|0)==0?8:4)|0;K1a(d|0,a|0,(g>>>0<b>>>0?g:b)|0)|0;eKa(a);c=d;return c|0}function gKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+4|0;d=f[c>>2]|0;e=d&-8;g=a+e|0;if(!(d&3)){if(b>>>0<256){h=0;return h|0}if(e>>>0>=(b+4|0)>>>0?(e-b|0)>>>0<=f[493498]<<1>>>0:0){h=a;return h|0}h=0;return h|0}if(e>>>0>=b>>>0){i=e-b|0;if(i>>>0<=15){h=a;return h|0}j=a+b|0;f[c>>2]=d&1|b|2;f[j+4>>2]=i|3;k=j+i+4|0;f[k>>2]=f[k>>2]|1;hKa(j,i);h=a;return h|0}if((g|0)==(f[493384]|0)){i=(f[493381]|0)+e|0;j=i-b|0;k=a+b|0;if(i>>>0<=b>>>0){h=0;return h|0}f[c>>2]=d&1|b|2;f[k+4>>2]=j|1;f[493384]=k;f[493381]=j;h=a;return h|0}if((g|0)==(f[493383]|0)){j=(f[493380]|0)+e|0;if(j>>>0<b>>>0){h=0;return h|0}k=j-b|0;i=d&1;if(k>>>0>15){l=a+b|0;m=l+k|0;f[c>>2]=i|b|2;f[l+4>>2]=k|1;f[m>>2]=k;n=m+4|0;f[n>>2]=f[n>>2]&-2;o=l;p=k}else{f[c>>2]=i|j|2;i=a+j+4|0;f[i>>2]=f[i>>2]|1;o=0;p=0}f[493380]=p;f[493383]=o;h=a;return h|0}o=f[g+4>>2]|0;if(o&2|0){h=0;return h|0}p=(o&-8)+e|0;if(p>>>0<b>>>0){h=0;return h|0}e=p-b|0;i=o>>>3;do if(o>>>0<256){j=f[g+8>>2]|0;k=f[g+12>>2]|0;if((k|0)==(j|0)){f[493378]=f[493378]&~(1<<i);break}else{f[j+12>>2]=k;f[k+8>>2]=j;break}}else{j=f[g+24>>2]|0;k=f[g+12>>2]|0;do if((k|0)==(g|0)){l=g+16|0;n=l+4|0;m=f[n>>2]|0;if(!m){q=f[l>>2]|0;if(!q){r=0;break}else{s=q;t=l}}else{s=m;t=n}while(1){n=s+20|0;m=f[n>>2]|0;if(m|0){s=m;t=n;continue}n=s+16|0;m=f[n>>2]|0;if(!m)break;else{s=m;t=n}}f[t>>2]=0;r=s}else{n=f[g+8>>2]|0;f[n+12>>2]=k;f[k+8>>2]=n;r=k}while(0);if(j|0){k=f[g+28>>2]|0;n=1973816+(k<<2)|0;if((g|0)==(f[n>>2]|0)){f[n>>2]=r;if(!r){f[493379]=f[493379]&~(1<<k);break}}else{f[j+16+(((f[j+16>>2]|0)!=(g|0)&1)<<2)>>2]=r;if(!r)break}f[r+24>>2]=j;k=g+16|0;n=f[k>>2]|0;if(n|0){f[r+16>>2]=n;f[n+24>>2]=r}n=f[k+4>>2]|0;if(n|0){f[r+20>>2]=n;f[n+24>>2]=r}}}while(0);r=d&1;if(e>>>0<16){f[c>>2]=p|r|2;d=a+p+4|0;f[d>>2]=f[d>>2]|1;h=a;return h|0}else{d=a+b|0;f[c>>2]=r|b|2;f[d+4>>2]=e|3;b=d+e+4|0;f[b>>2]=f[b>>2]|1;hKa(d,e);h=a;return h|0}return 0}function hKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=a+b|0;d=f[a+4>>2]|0;do if(!(d&1)){e=f[a>>2]|0;if(!(d&3))return;g=a+(0-e)|0;h=e+b|0;if((g|0)==(f[493383]|0)){i=c+4|0;j=f[i>>2]|0;if((j&3|0)!=3){k=g;l=h;break}f[493380]=h;f[i>>2]=j&-2;f[g+4>>2]=h|1;f[g+h>>2]=h;return}j=e>>>3;if(e>>>0<256){e=f[g+8>>2]|0;i=f[g+12>>2]|0;if((i|0)==(e|0)){f[493378]=f[493378]&~(1<<j);k=g;l=h;break}else{f[e+12>>2]=i;f[i+8>>2]=e;k=g;l=h;break}}e=f[g+24>>2]|0;i=f[g+12>>2]|0;do if((i|0)==(g|0)){j=g+16|0;m=j+4|0;n=f[m>>2]|0;if(!n){o=f[j>>2]|0;if(!o){p=0;break}else{q=o;r=j}}else{q=n;r=m}while(1){m=q+20|0;n=f[m>>2]|0;if(n|0){q=n;r=m;continue}m=q+16|0;n=f[m>>2]|0;if(!n)break;else{q=n;r=m}}f[r>>2]=0;p=q}else{m=f[g+8>>2]|0;f[m+12>>2]=i;f[i+8>>2]=m;p=i}while(0);if(e){i=f[g+28>>2]|0;m=1973816+(i<<2)|0;if((g|0)==(f[m>>2]|0)){f[m>>2]=p;if(!p){f[493379]=f[493379]&~(1<<i);k=g;l=h;break}}else{f[e+16+(((f[e+16>>2]|0)!=(g|0)&1)<<2)>>2]=p;if(!p){k=g;l=h;break}}f[p+24>>2]=e;i=g+16|0;m=f[i>>2]|0;if(m|0){f[p+16>>2]=m;f[m+24>>2]=p}m=f[i+4>>2]|0;if(m){f[p+20>>2]=m;f[m+24>>2]=p;k=g;l=h}else{k=g;l=h}}else{k=g;l=h}}else{k=a;l=b}while(0);b=c+4|0;a=f[b>>2]|0;if(!(a&2)){p=f[493383]|0;if((c|0)==(f[493384]|0)){q=(f[493381]|0)+l|0;f[493381]=q;f[493384]=k;f[k+4>>2]=q|1;if((k|0)!=(p|0))return;f[493383]=0;f[493380]=0;return}if((c|0)==(p|0)){p=(f[493380]|0)+l|0;f[493380]=p;f[493383]=k;f[k+4>>2]=p|1;f[k+p>>2]=p;return}p=(a&-8)+l|0;q=a>>>3;do if(a>>>0<256){r=f[c+8>>2]|0;d=f[c+12>>2]|0;if((d|0)==(r|0)){f[493378]=f[493378]&~(1<<q);break}else{f[r+12>>2]=d;f[d+8>>2]=r;break}}else{r=f[c+24>>2]|0;d=f[c+12>>2]|0;do if((d|0)==(c|0)){m=c+16|0;i=m+4|0;n=f[i>>2]|0;if(!n){j=f[m>>2]|0;if(!j){s=0;break}else{t=j;u=m}}else{t=n;u=i}while(1){i=t+20|0;n=f[i>>2]|0;if(n|0){t=n;u=i;continue}i=t+16|0;n=f[i>>2]|0;if(!n)break;else{t=n;u=i}}f[u>>2]=0;s=t}else{i=f[c+8>>2]|0;f[i+12>>2]=d;f[d+8>>2]=i;s=d}while(0);if(r|0){d=f[c+28>>2]|0;h=1973816+(d<<2)|0;if((c|0)==(f[h>>2]|0)){f[h>>2]=s;if(!s){f[493379]=f[493379]&~(1<<d);break}}else{f[r+16+(((f[r+16>>2]|0)!=(c|0)&1)<<2)>>2]=s;if(!s)break}f[s+24>>2]=r;d=c+16|0;h=f[d>>2]|0;if(h|0){f[s+16>>2]=h;f[h+24>>2]=s}h=f[d+4>>2]|0;if(h|0){f[s+20>>2]=h;f[h+24>>2]=s}}}while(0);f[k+4>>2]=p|1;f[k+p>>2]=p;if((k|0)==(f[493383]|0)){f[493380]=p;return}else v=p}else{f[b>>2]=a&-2;f[k+4>>2]=l|1;f[k+l>>2]=l;v=l}l=v>>>3;if(v>>>0<256){a=1973552+(l<<1<<2)|0;b=f[493378]|0;p=1<<l;if(!(b&p)){f[493378]=b|p;w=a+8|0;x=a}else{p=a+8|0;w=p;x=f[p>>2]|0}f[w>>2]=k;f[x+12>>2]=k;f[k+8>>2]=x;f[k+12>>2]=a;return}a=v>>>8;if(a)if(v>>>0>16777215)y=31;else{x=(a+1048320|0)>>>16&8;w=a<<x;a=(w+520192|0)>>>16&4;p=w<<a;w=(p+245760|0)>>>16&2;b=14-(a|x|w)+(p<<w>>>15)|0;y=v>>>(b+7|0)&1|b<<1}else y=0;b=1973816+(y<<2)|0;f[k+28>>2]=y;f[k+20>>2]=0;f[k+16>>2]=0;w=f[493379]|0;p=1<<y;if(!(w&p)){f[493379]=w|p;f[b>>2]=k;f[k+24>>2]=b;f[k+12>>2]=k;f[k+8>>2]=k;return}p=v<<((y|0)==31?0:25-(y>>>1)|0);y=f[b>>2]|0;while(1){if((f[y+4>>2]&-8|0)==(v|0)){z=69;break}A=y+16+(p>>>31<<2)|0;b=f[A>>2]|0;if(!b){z=68;break}else{p=p<<1;y=b}}if((z|0)==68){f[A>>2]=k;f[k+24>>2]=y;f[k+12>>2]=k;f[k+8>>2]=k;return}else if((z|0)==69){z=y+8|0;A=f[z>>2]|0;f[A+12>>2]=k;f[z>>2]=k;f[k+8>>2]=A;f[k+12>>2]=y;f[k+24>>2]=0;return}}function iKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a>>>0>16?a:16;if(!(c+-1&c))d=c;else{a=16;while(1)if(a>>>0<c>>>0)a=a<<1;else{d=a;break}}if((-64-d|0)>>>0<=b>>>0){a=pKa()|0;f[a>>2]=12;e=0;return e|0}a=b>>>0<11?16:b+11&-8;b=dKa(a+12+d|0)|0;if(!b){e=0;return e|0}c=b+-8|0;do if(b&d+-1){g=(b+d+-1&0-d)+-8|0;h=c;i=(g-h|0)>>>0>15?g:g+d|0;g=i-h|0;h=b+-4|0;j=f[h>>2]|0;k=(j&-8)-g|0;if(!(j&3)){f[i>>2]=(f[c>>2]|0)+g;f[i+4>>2]=k;l=i;m=i;break}else{j=i+4|0;f[j>>2]=k|f[j>>2]&1|2;n=i+k+4|0;f[n>>2]=f[n>>2]|1;f[h>>2]=g|f[h>>2]&1|2;f[j>>2]=f[j>>2]|1;hKa(c,g);l=i;m=i;break}}else{l=c;m=c}while(0);c=m+4|0;m=f[c>>2]|0;if(m&3|0?(b=m&-8,b>>>0>(a+16|0)>>>0):0){d=b-a|0;b=l+a|0;f[c>>2]=a|m&1|2;f[b+4>>2]=d|3;m=b+d+4|0;f[m>>2]=f[m>>2]|1;hKa(b,d)}e=l+8|0;return e|0}function jKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;do if((b|0)!=8){d=b>>>2;if((b&3|0)!=0|(d|0)==0){e=22;return e|0}if(d+1073741823&d|0){e=22;return e|0}if((-64-b|0)>>>0<c>>>0){e=12;return e|0}else{g=iKa(b>>>0>16?b:16,c)|0;break}}else g=dKa(c)|0;while(0);if(!g){e=12;return e|0}f[a>>2]=g;e=0;return e|0}function kKa(){return 1974008}function lKa(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;d=tKa(f[a+60>>2]|0)|0;f[c>>2]=d;d=oKa(pe(6,c|0)|0)|0;u=b;return d|0}function mKa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+32|0;g=e;f[a+36>>2]=20;if((f[a>>2]&64|0)==0?(f[g>>2]=f[a+60>>2],f[g+4>>2]=21523,f[g+8>>2]=e+16,ze(54,g|0)|0):0)b[a+75>>0]=-1;g=sKa(a,c,d)|0;u=e;return g|0}function nKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d;g=d+20|0;f[e>>2]=f[a+60>>2];f[e+4>>2]=0;f[e+8>>2]=b;f[e+12>>2]=g;f[e+16>>2]=c;if((oKa(Kd(140,e|0)|0)|0)<0){f[g>>2]=-1;h=-1}else h=f[g>>2]|0;u=d;return h|0}function oKa(a){a=a|0;var b=0,c=0;if(a>>>0>4294963200){b=pKa()|0;f[b>>2]=0-a;c=-1}else c=a;return c|0}function pKa(){return (qKa()|0)+64|0}function qKa(){return rKa()|0}function rKa(){return 122988}function sKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+48|0;e=d+16|0;g=d;h=d+32|0;i=a+28|0;j=f[i>>2]|0;f[h>>2]=j;k=a+20|0;l=(f[k>>2]|0)-j|0;f[h+4>>2]=l;f[h+8>>2]=b;f[h+12>>2]=c;b=l+c|0;l=a+60|0;f[g>>2]=f[l>>2];f[g+4>>2]=h;f[g+8>>2]=2;j=oKa(Nd(146,g|0)|0)|0;a:do if((b|0)!=(j|0)){g=j;m=h;n=2;o=b;while(1){if((g|0)<0)break;o=o-g|0;p=f[m+4>>2]|0;q=g>>>0>p>>>0;r=q?m+8|0:m;s=(q<<31>>31)+n|0;t=g-(q?p:0)|0;f[r>>2]=(f[r>>2]|0)+t;p=r+4|0;f[p>>2]=(f[p>>2]|0)-t;f[e>>2]=f[l>>2];f[e+4>>2]=r;f[e+8>>2]=s;g=oKa(Nd(146,e|0)|0)|0;if((o|0)==(g|0)){v=3;break a}else{m=r;n=s}}f[a+16>>2]=0;f[i>>2]=0;f[k>>2]=0;f[a>>2]=f[a>>2]|32;if((n|0)==2)w=0;else w=c-(f[m+4>>2]|0)|0}else v=3;while(0);if((v|0)==3){v=f[a+44>>2]|0;f[a+16>>2]=v+(f[a+48>>2]|0);f[i>>2]=v;f[k>>2]=v;w=c}u=d;return w|0}function tKa(a){a=a|0;return a|0}function uKa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+32|0;g=e;h=e+16|0;f[h>>2]=c;i=h+4|0;j=a+48|0;k=f[j>>2]|0;f[i>>2]=d-((k|0)!=0&1);l=a+44|0;f[h+8>>2]=f[l>>2];f[h+12>>2]=k;f[g>>2]=f[a+60>>2];f[g+4>>2]=h;f[g+8>>2]=2;h=oKa(Md(145,g|0)|0)|0;if((h|0)>=1){g=f[i>>2]|0;if(h>>>0>g>>>0){i=f[l>>2]|0;l=a+4|0;f[l>>2]=i;f[a+8>>2]=i+(h-g);if(!(f[j>>2]|0))m=d;else{f[l>>2]=i+1;b[c+(d+-1)>>0]=b[i>>0]|0;m=d}}else m=h}else{f[a>>2]=f[a>>2]|h&48^16;m=h}u=e;return m|0}function vKa(a){a=a|0;return wKa(a,0,0)|0}function wKa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=xKa(a)|0;a:do if(!(h>>>0<6|(h+-6|0)>>>0<c>>>0)?(i=a+h+(0-c)+-6|0,(yKa(i,366671,6)|0)==0):0){j=d&-2097348|194;k=100;do{zKa(i)|0;f[g>>2]=384;l=AKa(a,j,g)|0;if((l|0)>-1){m=l;break a}k=k+-1|0;if(!k)break;l=pKa()|0}while((f[l>>2]|0)==17);b[i>>0]=b[366671]|0;b[i+1>>0]=b[366672]|0;b[i+2>>0]=b[366673]|0;b[i+3>>0]=b[366674]|0;b[i+4>>0]=b[366675]|0;b[i+5>>0]=b[366676]|0;m=-1}else n=3;while(0);if((n|0)==3){n=pKa()|0;f[n>>2]=22;m=-1}u=e;return m|0}function xKa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a;a:do if(!(c&3)){d=a;e=4}else{g=c;h=a;while(1){if(!(b[h>>0]|0)){i=g;break a}j=h+1|0;g=j;if(!(g&3)){d=j;e=4;break}else h=j}}while(0);if((e|0)==4){e=d;while(1){k=f[e>>2]|0;if(!((k&-2139062144^-2139062144)&k+-16843009))e=e+4|0;else break}if(!((k&255)<<24>>24))l=e;else{k=e;while(1){e=k+1|0;if(!(b[e>>0]|0)){l=e;break}else k=e}}i=l}return i-c|0}function yKa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;a:do if(!d)e=0;else{f=a;g=d;h=c;while(1){i=b[f>>0]|0;j=b[h>>0]|0;if(i<<24>>24!=j<<24>>24)break;g=g+-1|0;if(!g){e=0;break a}else{f=f+1|0;h=h+1|0}}e=(i&255)-(j&255)|0}while(0);return e|0}function zKa(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;He(0,d|0)|0;e=0;g=(f[d+4>>2]|0)*65537^(d>>>4)+a;while(1){b[a+e>>0]=(g&15)+65|g<<1&32;e=e+1|0;if((e|0)==6)break;else g=g>>>5}u=c;return a|0}function AKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+48|0;e=d+16|0;g=d;h=d+32|0;if(!(b&4194368))i=0;else{f[h>>2]=c;c=(f[h>>2]|0)+(4-1)&~(4-1);j=f[c>>2]|0;f[h>>2]=c+4;i=j}f[g>>2]=a;f[g+4>>2]=b|32768;f[g+8>>2]=i;i=qe(5,g|0)|0;if(!((b&524288|0)==0|(i|0)<0)){f[e>>2]=i;f[e+4>>2]=2;f[e+8>>2]=1;bd(221,e|0)|0}e=oKa(i)|0;u=d;return e|0}function BKa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=c&255;g=(d|0)!=0;a:do if(g&(a&3|0)!=0){h=c&255;i=d;j=a;while(1){if((b[j>>0]|0)==h<<24>>24){k=i;l=j;m=6;break a}n=j+1|0;o=i+-1|0;p=(o|0)!=0;if(p&(n&3|0)!=0){i=o;j=n}else{q=o;r=n;s=p;m=5;break}}}else{q=d;r=a;s=g;m=5}while(0);if((m|0)==5)if(s){k=q;l=r;m=6}else{t=0;u=r}b:do if((m|0)==6){r=c&255;if((b[l>>0]|0)==r<<24>>24){t=k;u=l}else{q=Y(e,16843009)|0;c:do if(k>>>0>3){s=k;g=l;while(1){a=f[g>>2]^q;if((a&-2139062144^-2139062144)&a+-16843009|0)break;a=g+4|0;d=s+-4|0;if(d>>>0>3){s=d;g=a}else{v=d;w=a;m=11;break c}}x=s;y=g}else{v=k;w=l;m=11}while(0);if((m|0)==11)if(!v){t=0;u=w;break}else{x=v;y=w}while(1){if((b[y>>0]|0)==r<<24>>24){t=x;u=y;break b}q=y+1|0;x=x+-1|0;if(!x){t=0;u=q;break}else y=q}}}while(0);return (t|0?u:0)|0}function CKa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=c;do if(!((e^a)&3)){g=(d|0)!=0;a:do if(g&(e&3|0)!=0){h=a;i=d;j=c;while(1){k=b[j>>0]|0;b[h>>0]=k;if(!(k<<24>>24)){l=h;m=i;n=j;break a}k=i+-1|0;o=j+1|0;p=h+1|0;q=(k|0)!=0;if(q&(o&3|0)!=0){h=p;i=k;j=o}else{r=p;s=k;t=o;u=q;v=5;break}}}else{r=a;s=d;t=c;u=g;v=5}while(0);if((v|0)==5)if(u){l=r;m=s;n=t}else{w=r;x=0;break}if(!(b[n>>0]|0)){w=l;x=m}else{b:do if(m>>>0>3){g=m;j=l;i=n;while(1){h=f[i>>2]|0;if((h&-2139062144^-2139062144)&h+-16843009|0){y=g;z=j;A=i;break b}f[j>>2]=h;h=g+-4|0;q=i+4|0;o=j+4|0;if(h>>>0>3){g=h;j=o;i=q}else{y=h;z=o;A=q;break}}}else{y=m;z=l;A=n}while(0);B=z;C=y;D=A;v=11}}else{B=a;C=d;D=c;v=11}while(0);c:do if((v|0)==11)if(!C){w=B;x=0}else{c=B;d=C;a=D;while(1){A=b[a>>0]|0;b[c>>0]=A;if(!(A<<24>>24)){w=c;x=d;break c}d=d+-1|0;A=c+1|0;if(!d){w=A;x=0;break}else{c=A;a=a+1|0}}}while(0);F1a(w|0,0,x|0)|0;return w|0}function DKa(a){a=a|0;var b=0;b=(EKa()|0)+188|0;return FKa(a,f[b>>2]|0)|0}function EKa(){return rKa()|0}function FKa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0;d=0;while(1){if((h[366678+d>>0]|0)==(a|0)){e=2;break}g=d+1|0;if((g|0)==87){i=87;j=366766;e=5;break}else d=g}if((e|0)==2)if(!d)k=366766;else{i=d;j=366766;e=5}if((e|0)==5)while(1){e=0;d=j;do{a=d;d=d+1|0}while((b[a>>0]|0)!=0);i=i+-1|0;if(!i){k=d;break}else{j=d;e=5}}return GKa(k,f[c+20>>2]|0)|0}function GKa(a,b){a=a|0;b=b|0;return HKa(a,b)|0}function HKa(a,b){a=a|0;b=b|0;var c=0;if(!b)c=0;else c=IKa(f[b>>2]|0,f[b+4>>2]|0,a)|0;return (c|0?c:a)|0}function IKa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=(f[a>>2]|0)+1794895138|0;g=JKa(f[a+8>>2]|0,e)|0;h=JKa(f[a+12>>2]|0,e)|0;i=JKa(f[a+16>>2]|0,e)|0;a:do if((g>>>0<c>>>2>>>0?(j=c-(g<<2)|0,h>>>0<j>>>0&i>>>0<j>>>0):0)?((i|h)&3|0)==0:0){j=h>>>2;k=i>>>2;l=0;m=g;while(1){n=m>>>1;o=l+n|0;p=o<<1;q=p+j|0;r=JKa(f[a+(q<<2)>>2]|0,e)|0;s=JKa(f[a+(q+1<<2)>>2]|0,e)|0;if(!(s>>>0<c>>>0&r>>>0<(c-s|0)>>>0)){t=0;break a}if(b[a+(s+r)>>0]|0){t=0;break a}r=KKa(d,a+s|0)|0;if(!r)break;s=(r|0)<0;if((m|0)==1){t=0;break a}else{l=s?l:o;m=s?n:m-n|0}}m=p+k|0;l=JKa(f[a+(m<<2)>>2]|0,e)|0;j=JKa(f[a+(m+1<<2)>>2]|0,e)|0;if(j>>>0<c>>>0&l>>>0<(c-j|0)>>>0)t=(b[a+(j+l)>>0]|0)==0?a+j|0:0;else t=0}else t=0;while(0);return t|0}function JKa(a,b){a=a|0;b=b|0;var c=0;c=Q1a(a|0)|0;return ((b|0)==0?a:c)|0}function KKa(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0;d=b[a>>0]|0;e=b[c>>0]|0;if(d<<24>>24==0?1:d<<24>>24!=e<<24>>24){f=e;g=d}else{d=a;a=c;do{d=d+1|0;a=a+1|0;c=b[d>>0]|0;e=b[a>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=e<<24>>24));f=e;g=c}return (g&255)-(f&255)|0}function LKa(a){a=a|0;var b=0;b=a;while(1)if(!(f[b>>2]|0))break;else b=b+4|0;return b-a>>2|0}function MKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;if(c|0){d=a;e=c;c=b;while(1){e=e+-1|0;f[d>>2]=f[c>>2];if(!e)break;else{d=d+4|0;c=c+4|0}}}return a|0}function NKa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;if(c|0){d=a;e=c;while(1){e=e+-1|0;f[d>>2]=b;if(!e)break;else d=d+4|0}}return a|0}function OKa(a){a=a|0;var b=0;b=(PKa(a)|0)==0;return (b?a:a|32)|0}function PKa(a){a=a|0;return (a+-65|0)>>>0<26|0}function QKa(a,b){a=a|0;b=b|0;return RKa(a,b,(xKa(a)|0)+1|0)|0}function RKa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0;e=c&255;c=d;while(1){if(!c){f=0;break}c=c+-1|0;d=a+c|0;if((b[d>>0]|0)==e<<24>>24){f=d;break}}return f|0}function SKa(a,c){a=a|0;c=c|0;var d=0,e=0,f=0;d=b[c>>0]|0;do if(d<<24>>24){e=TKa(a,d<<24>>24)|0;if(e)if(b[c+1>>0]|0)if(b[e+1>>0]|0){if(!(b[c+2>>0]|0)){f=UKa(e,c)|0;break}if(b[e+2>>0]|0){if(!(b[c+3>>0]|0)){f=VKa(e,c)|0;break}if(b[e+3>>0]|0)if(!(b[c+4>>0]|0)){f=WKa(e,c)|0;break}else{f=XKa(e,c)|0;break}else f=0}else f=0}else f=0;else f=e;else f=0}else f=a;while(0);return f|0}function TKa(a,c){a=a|0;c=c|0;var d=0;d=YKa(a,c)|0;return ((b[d>>0]|0)==(c&255)<<24>>24?d:0)|0}function UKa(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0;d=(h[c>>0]|0)<<8|(h[c+1>>0]|0);c=a;e=h[a>>0]|0;while(1){a=c+1|0;f=b[a>>0]|0;if(!(f<<24>>24)){g=0;break}e=f&255|e<<8&65280;if((e|0)==(d|0)){g=c;break}else c=a}return g|0}function VKa(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,j=0;d=(h[c+1>>0]|0)<<16|(h[c>>0]|0)<<24|(h[c+2>>0]|0)<<8;c=a+2|0;e=b[c>>0]|0;f=(h[a+1>>0]|0)<<16|(h[a>>0]|0)<<24|(e&255)<<8;a=e<<24>>24!=0;if((f|0)==(d|0)|a^1){g=c;i=a}else{a=c;c=f;while(1){f=a+1|0;e=b[f>>0]|0;c=(e&255|c)<<8;j=e<<24>>24!=0;if((c|0)==(d|0)|j^1){g=f;i=j;break}else a=f}}return (i?g+-2|0:0)|0}function WKa(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,j=0;d=(h[c+1>>0]|0)<<16|(h[c>>0]|0)<<24|(h[c+2>>0]|0)<<8|(h[c+3>>0]|0);c=a+3|0;e=b[c>>0]|0;f=e&255|((h[a+1>>0]|0)<<16|(h[a>>0]|0)<<24|(h[a+2>>0]|0)<<8);a=e<<24>>24!=0;if((f|0)==(d|0)|a^1){g=c;i=a}else{a=c;c=f;while(1){f=a+1|0;e=b[f>>0]|0;c=e&255|c<<8;j=e<<24>>24!=0;if((c|0)==(d|0)|j^1){g=f;i=j;break}else a=f}}return (i?g+-3|0:0)|0}function XKa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=u;u=u+1056|0;e=d+1024|0;g=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;h=b[c>>0]|0;a:do if(h<<24>>24){i=h;j=h&255;k=0;while(1){if(!(b[a+k>>0]|0)){l=0;break a}m=e+(((i&255)>>>5&255)<<2)|0;f[m>>2]=f[m>>2]|1<<(i&31);k=k+1|0;f[g+(j<<2)>>2]=k;m=b[c+k>>0]|0;if(!(m<<24>>24))break;else{i=m;j=m&255}}j=k>>>0>1;if(j){i=1;m=-1;n=0;b:while(1){o=i;p=n;q=1;while(1){r=o;s=p;c:while(1){t=r;v=1;while(1){w=b[c+(v+m)>>0]|0;x=b[c+t>>0]|0;if(w<<24>>24!=x<<24>>24)break c;if((v|0)==(q|0))break;v=v+1|0;y=v+s|0;if(y>>>0>=k>>>0){z=m;A=q;break b}else t=y}v=q+s|0;r=v+1|0;if(r>>>0>=k>>>0){z=m;A=q;break b}else s=v}r=t-m|0;if((w&255)<=(x&255))break;o=t+1|0;if(o>>>0>=k>>>0){z=m;A=r;break b}else{p=t;q=r}}i=s+2|0;if(i>>>0>=k>>>0){z=s;A=1;break}else{m=s;n=s+1|0}}if(j){n=1;m=-1;i=0;while(1){q=n;p=i;o=1;while(1){r=q;B=p;d:while(1){C=r;v=1;while(1){D=b[c+(v+m)>>0]|0;E=b[c+C>>0]|0;if(D<<24>>24!=E<<24>>24)break d;if((v|0)==(o|0))break;v=v+1|0;y=v+B|0;if(y>>>0>=k>>>0){F=z;G=m;H=k;I=A;J=o;K=27;break a}else C=y}v=o+B|0;r=v+1|0;if(r>>>0>=k>>>0){F=z;G=m;H=k;I=A;J=o;K=27;break a}else B=v}r=C-m|0;if((D&255)>=(E&255))break;q=C+1|0;if(q>>>0>=k>>>0){F=z;G=m;H=k;I=A;J=r;K=27;break a}else{p=C;o=r}}n=B+2|0;if(n>>>0>=k>>>0){F=z;G=B;H=k;I=A;J=1;K=27;break}else{m=B;i=B+1|0}}}else{F=z;G=-1;H=k;I=A;J=1;K=27}}else{F=-1;G=-1;H=k;I=1;J=1;K=27}}else{F=-1;G=-1;H=0;I=1;J=1;K=27}while(0);e:do if((K|0)==27){A=(G+1|0)>>>0>(F+1|0)>>>0;z=A?J:I;B=A?G:F;A=B+1|0;if(!(yKa(c,c+z|0,A)|0)){L=H-z|0;M=z}else{z=H-B+-1|0;L=0;M=(B>>>0>z>>>0?B:z)+1|0}z=H|63;C=H+-1|0;E=(L|0)!=0;D=H-M|0;s=a;t=0;x=a;while(1){w=s;do if((x-w|0)>>>0<H>>>0){h=BKa(x,0,z)|0;if(h)if((h-w|0)>>>0<H>>>0){l=0;break e}else{N=h;break}else{N=x+z|0;break}}else N=x;while(0);w=b[s+C>>0]|0;f:do if(!(1<<(w&31)&f[e+(((w&255)>>>5&255)<<2)>>2])){O=H;P=0}else{h=H-(f[g+((w&255)<<2)>>2]|0)|0;if(h|0){O=E&(t|0)!=0&h>>>0<M>>>0?D:h;P=0;break}h=A>>>0>t>>>0?A:t;i=b[c+h>>0]|0;g:do if(!(i<<24>>24))Q=A;else{m=i;n=h;while(1){if(m<<24>>24!=(b[s+n>>0]|0))break;j=n+1|0;m=b[c+j>>0]|0;if(!(m<<24>>24)){Q=A;break g}else n=j}O=n-B|0;P=0;break f}while(0);while(1){if(Q>>>0<=t>>>0){l=s;break e}Q=Q+-1|0;if((b[c+Q>>0]|0)!=(b[s+Q>>0]|0)){O=M;P=L;break}}}while(0);s=s+O|0;t=P;x=N}}while(0);u=d;return l|0}function YKa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=c&255;a:do if(!d)e=a+(xKa(a)|0)|0;else{if(!(a&3))g=a;else{h=c&255;i=a;while(1){j=b[i>>0]|0;if(j<<24>>24==0?1:j<<24>>24==h<<24>>24){e=i;break a}j=i+1|0;if(!(j&3)){g=j;break}else i=j}}i=Y(d,16843009)|0;h=f[g>>2]|0;b:do if(!((h&-2139062144^-2139062144)&h+-16843009)){j=h;k=g;while(1){l=j^i;if((l&-2139062144^-2139062144)&l+-16843009|0){m=k;break b}l=k+4|0;j=f[l>>2]|0;if((j&-2139062144^-2139062144)&j+-16843009|0){m=l;break}else k=l}}else m=g;while(0);i=c&255;h=m;while(1){k=b[h>>0]|0;if(k<<24>>24==0?1:k<<24>>24==i<<24>>24){e=h;break}else h=h+1|0}}while(0);return e|0}function ZKa(a,b){a=a|0;b=b|0;_Ka(a,b)|0;return a|0}function _Ka(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=c;a:do if(!((d^a)&3)){if(!(d&3)){e=a;g=c}else{h=a;i=c;while(1){j=b[i>>0]|0;b[h>>0]=j;if(!(j<<24>>24)){k=h;break a}j=i+1|0;l=h+1|0;if(!(j&3)){e=l;g=j;break}else{h=l;i=j}}}i=f[g>>2]|0;if(!((i&-2139062144^-2139062144)&i+-16843009)){h=i;i=e;j=g;while(1){l=j+4|0;m=i+4|0;f[i>>2]=h;h=f[l>>2]|0;if((h&-2139062144^-2139062144)&h+-16843009|0){n=m;o=l;break}else{i=m;j=l}}}else{n=e;o=g}p=n;q=o;r=8}else{p=a;q=c;r=8}while(0);if((r|0)==8){r=b[q>>0]|0;b[p>>0]=r;if(!(r<<24>>24))k=p;else{r=p;p=q;while(1){p=p+1|0;q=r+1|0;c=b[p>>0]|0;b[q>>0]=c;if(!(c<<24>>24)){k=q;break}else r=q}}}return k|0}function $Ka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;if(a-b>>2>>>0>=c>>>0){if(c|0){d=a;e=c;g=b;while(1){e=e+-1|0;f[d>>2]=f[g>>2];if(!e)break;else{d=d+4|0;g=g+4|0}}}}else{g=c;do{g=g+-1|0;f[a+(g<<2)>>2]=f[b+(g<<2)>>2]}while((g|0)!=0)}return a|0}function aLa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;if(!d)e=0;else{f=b[a>>0]|0;g=f&255;h=b[c>>0]|0;i=h&255;a:do if(!(f<<24>>24)){j=g;k=i}else{l=h;m=f;n=g;o=i;p=a;q=d;r=c;while(1){q=q+-1|0;if(!(m<<24>>24==l<<24>>24&((q|0)!=0&l<<24>>24!=0))){j=n;k=o;break a}p=p+1|0;r=r+1|0;m=b[p>>0]|0;s=m&255;l=b[r>>0]|0;t=l&255;if(!(m<<24>>24)){j=s;k=t;break}else{n=s;o=t}}}while(0);e=j-k|0}return e|0}function bLa(a,b,c){a=a|0;b=b|0;c=c|0;CKa(a,b,c)|0;return a|0}function cLa(a){a=a|0;var b=0,c=0,d=0;b=(xKa(a)|0)+1|0;c=dKa(b)|0;if(!c)d=0;else{K1a(c|0,a|0,b|0)|0;d=c}return d|0}function dLa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;eLa();f[d>>2]=a;f[d+4>>2]=b;b=oKa(fe(91,d|0)|0)|0;u=c;return b|0}function eLa(){return}function fLa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d;g=d+20|0;f[e>>2]=a;f[e+4>>2]=0;f[e+8>>2]=b;f[e+12>>2]=g;f[e+16>>2]=c;c=(oKa(Kd(140,e|0)|0)|0)!=0;u=d;return (c?-1:f[g>>2]|0)|0}function gLa(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;d=tKa(a)|0;f[c>>2]=d;d=pe(6,c|0)|0;c=oKa((d|0)==-4?0:d)|0;u=b;return c|0}function hLa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=iLa(a,b,c,-1,-1)|0;return d|0}function iLa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+128|0;h=g;f[h>>2]=0;i=h+4|0;f[i>>2]=a;f[h+44>>2]=a;j=h+8|0;f[j>>2]=(a|0)<0?-1:a+2147483647|0;f[h+76>>2]=-1;jLa(h,0);k=kLa(h,c,1,d,e)|0;if(b|0)f[b>>2]=a+((f[i>>2]|0)+(f[h+108>>2]|0)-(f[j>>2]|0));u=g;return k|0}function jLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;f[a+104>>2]=b;c=f[a+8>>2]|0;d=f[a+4>>2]|0;e=c-d|0;f[a+108>>2]=e;f[a+100>>2]=(b|0)!=0&(e|0)>(b|0)?d+b|0:c;return}function kLa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;a:do if(c>>>0>36){i=pKa()|0;f[i>>2]=22;j=0;k=0}else{i=a+4|0;l=a+100|0;do{m=f[i>>2]|0;if(m>>>0<(f[l>>2]|0)>>>0){f[i>>2]=m+1;n=h[m>>0]|0}else n=lLa(a)|0}while((mLa(n)|0)!=0);b:do switch(n|0){case 43:case 45:{m=((n|0)==45)<<31>>31;o=f[i>>2]|0;if(o>>>0<(f[l>>2]|0)>>>0){f[i>>2]=o+1;p=h[o>>0]|0;q=m;break b}else{p=lLa(a)|0;q=m;break b}break}default:{p=n;q=0}}while(0);m=(c|0)==0;do if((c|16|0)==16&(p|0)==48){o=f[i>>2]|0;if(o>>>0<(f[l>>2]|0)>>>0){f[i>>2]=o+1;r=h[o>>0]|0}else r=lLa(a)|0;if((r|32|0)!=120)if(m){s=8;t=r;u=46;break}else{v=c;w=r;u=32;break}o=f[i>>2]|0;if(o>>>0<(f[l>>2]|0)>>>0){f[i>>2]=o+1;x=h[o>>0]|0}else x=lLa(a)|0;if((h[368571+x>>0]|0)>15){o=(f[l>>2]|0)!=0;if(o)f[i>>2]=(f[i>>2]|0)+-1;if(!d){jLa(a,0);j=0;k=0;break a}if(!o){j=0;k=0;break a}f[i>>2]=(f[i>>2]|0)+-1;j=0;k=0;break a}else{s=16;t=x;u=46}}else{o=m?10:c;if((h[368571+p>>0]|0)>>>0<o>>>0){v=o;w=p;u=32}else{if(f[l>>2]|0)f[i>>2]=(f[i>>2]|0)+-1;jLa(a,0);o=pKa()|0;f[o>>2]=22;j=0;k=0;break a}}while(0);c:do if((u|0)==32)if((v|0)==10){m=w+-48|0;if(m>>>0<10){o=m;m=0;do{m=(m*10|0)+o|0;y=f[i>>2]|0;if(y>>>0<(f[l>>2]|0)>>>0){f[i>>2]=y+1;z=h[y>>0]|0}else z=lLa(a)|0;o=z+-48|0}while(o>>>0<10&m>>>0<429496729);A=m;B=0;C=z}else{A=0;B=0;C=w}o=C+-48|0;if(o>>>0<10){y=A;D=B;E=C;F=o;while(1){o=W1a(y|0,D|0,10,0)|0;G=J;H=((F|0)<0)<<31>>31;I=~H;if(G>>>0>I>>>0|(G|0)==(I|0)&o>>>0>~F>>>0){K=y;L=D;M=10;N=E;u=72;break c}y=C1a(o|0,G|0,F|0,H|0)|0;D=J;H=f[i>>2]|0;if(H>>>0<(f[l>>2]|0)>>>0){f[i>>2]=H+1;O=h[H>>0]|0}else O=lLa(a)|0;F=O+-48|0;if(!(F>>>0<10&(D>>>0<429496729|(D|0)==429496729&y>>>0<2576980378)))break;else E=O}if(F>>>0>9){P=D;Q=y;R=q}else{K=y;L=D;M=10;N=O;u=72}}else{P=B;Q=A;R=q}}else{s=v;t=w;u=46}while(0);d:do if((u|0)==46){if(!(s+-1&s)){E=b[368827+((s*23|0)>>>5&7)>>0]|0;m=b[368571+t>>0]|0;H=m&255;if(H>>>0<s>>>0){G=H;H=0;do{H=G|H<<E;o=f[i>>2]|0;if(o>>>0<(f[l>>2]|0)>>>0){f[i>>2]=o+1;S=h[o>>0]|0}else S=lLa(a)|0;T=b[368571+S>>0]|0;G=T&255}while(H>>>0<134217728&G>>>0<s>>>0);U=T;V=0;W=H;X=S}else{U=m;V=0;W=0;X=t}G=I1a(-1,-1,E|0)|0;D=J;if((U&255)>>>0>=s>>>0|(V>>>0>D>>>0|(V|0)==(D|0)&W>>>0>G>>>0)){K=W;L=V;M=s;N=X;u=72;break}else{Z=W;_=V;$=U}while(1){y=R1a(Z|0,_|0,E|0)|0;F=J;o=$&255|y;y=f[i>>2]|0;if(y>>>0<(f[l>>2]|0)>>>0){f[i>>2]=y+1;aa=h[y>>0]|0}else aa=lLa(a)|0;$=b[368571+aa>>0]|0;if(($&255)>>>0>=s>>>0|(F>>>0>D>>>0|(F|0)==(D|0)&o>>>0>G>>>0)){K=o;L=F;M=s;N=aa;u=72;break d}else{Z=o;_=F}}}G=b[368571+t>>0]|0;D=G&255;if(D>>>0<s>>>0){E=D;D=0;do{D=E+(Y(D,s)|0)|0;m=f[i>>2]|0;if(m>>>0<(f[l>>2]|0)>>>0){f[i>>2]=m+1;ba=h[m>>0]|0}else ba=lLa(a)|0;ca=b[368571+ba>>0]|0;E=ca&255}while(D>>>0<119304647&E>>>0<s>>>0);da=D;ea=0;fa=ca;ga=ba}else{da=0;ea=0;fa=G;ga=t}if((fa&255)>>>0<s>>>0){E=U1a(-1,-1,s|0,0)|0;m=J;H=fa;F=ea;o=da;y=ga;while(1){if(F>>>0>m>>>0|(F|0)==(m|0)&o>>>0>E>>>0){K=o;L=F;M=s;N=y;u=72;break d}I=W1a(o|0,F|0,s|0,0)|0;ha=J;ia=H&255;if(ha>>>0>4294967295|(ha|0)==-1&I>>>0>~ia>>>0){K=o;L=F;M=s;N=y;u=72;break d}ja=C1a(ia|0,0,I|0,ha|0)|0;ha=J;I=f[i>>2]|0;if(I>>>0<(f[l>>2]|0)>>>0){f[i>>2]=I+1;ka=h[I>>0]|0}else ka=lLa(a)|0;H=b[368571+ka>>0]|0;if((H&255)>>>0>=s>>>0){K=ja;L=ha;M=s;N=ka;u=72;break}else{F=ha;o=ja;y=ka}}}else{K=da;L=ea;M=s;N=ga;u=72}}while(0);if((u|0)==72)if((h[368571+N>>0]|0)>>>0<M>>>0){do{y=f[i>>2]|0;if(y>>>0<(f[l>>2]|0)>>>0){f[i>>2]=y+1;la=h[y>>0]|0}else la=lLa(a)|0}while((h[368571+la>>0]|0)>>>0<M>>>0);y=pKa()|0;f[y>>2]=34;P=g;Q=e;R=(e&1|0)==0&0==0?q:0}else{P=L;Q=K;R=q}if(f[l>>2]|0)f[i>>2]=(f[i>>2]|0)+-1;if(!(P>>>0<g>>>0|(P|0)==(g|0)&Q>>>0<e>>>0)){if(!((e&1|0)!=0|0!=0|(R|0)!=0)){y=pKa()|0;f[y>>2]=34;y=C1a(e|0,g|0,-1,-1)|0;j=J;k=y;break}if(P>>>0>g>>>0|(P|0)==(g|0)&Q>>>0>e>>>0){y=pKa()|0;f[y>>2]=34;j=g;k=e;break}}y=((R|0)<0)<<31>>31;o=B1a(Q^R|0,P^y|0,R|0,y|0)|0;j=J;k=o}while(0);J=j;return k|0}function lLa(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+104|0;d=f[c>>2]|0;if((d|0)!=0?(f[a+108>>2]|0)>=(d|0):0)e=4;else{d=nLa(a)|0;if((d|0)>=0){g=f[c>>2]|0;c=a+8|0;if(g){i=f[c>>2]|0;j=f[a+4>>2]|0;k=a+108|0;l=g-(f[k>>2]|0)|0;g=i;if((i-j|0)<(l|0)){m=g;n=g;o=j;p=k}else{m=j+(l+-1)|0;n=g;o=j;p=k}}else{k=f[c>>2]|0;m=k;n=k;o=f[a+4>>2]|0;p=a+108|0}f[a+100>>2]=m;if(n|0)f[p>>2]=n+1-o+(f[p>>2]|0);p=o+-1|0;if((h[p>>0]|0|0)==(d|0))q=d;else{b[p>>0]=d;q=d}}else e=4}if((e|0)==4){f[a+100>>2]=0;q=-1}return q|0}function mLa(a){a=a|0;return ((a|0)==32|(a+-9|0)>>>0<5)&1|0}function nLa(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;if((oLa(a)|0)==0?(ui[f[a+32>>2]&127](a,c,1)|0)==1:0)d=h[c>>0]|0;else d=-1;u=b;return d|0}function oLa(a){a=a|0;var c=0,d=0,e=0;c=a+74|0;d=b[c>>0]|0;b[c>>0]=d+255|d;d=a+20|0;c=a+28|0;if((f[d>>2]|0)>>>0>(f[c>>2]|0)>>>0)ui[f[a+36>>2]&127](a,0,0)|0;f[a+16>>2]=0;f[c>>2]=0;f[d>>2]=0;d=f[a>>2]|0;if(!(d&4)){c=(f[a+44>>2]|0)+(f[a+48>>2]|0)|0;f[a+8>>2]=c;f[a+4>>2]=c;e=d<<27>>31}else{f[a>>2]=d|32;e=-1}return e|0}function pLa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=d;d=qLa(a,b,c,g)|0;u=e;return d|0}function qLa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+128|0;h=g+124|0;i=g;j=i;k=123768;l=j+124|0;do{f[j>>2]=f[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));if((c+-1|0)>>>0>2147483646)if(!c){m=1;n=h;o=4}else{h=pKa()|0;f[h>>2]=75;p=-1}else{m=c;n=a;o=4}if((o|0)==4){o=-2-n|0;a=m>>>0>o>>>0?o:m;f[i+48>>2]=a;m=i+20|0;f[m>>2]=n;f[i+44>>2]=n;o=n+a|0;n=i+16|0;f[n>>2]=o;f[i+28>>2]=o;o=rLa(i,d,e)|0;if(!a)p=o;else{a=f[m>>2]|0;b[a+(((a|0)==(f[n>>2]|0))<<31>>31)>>0]=0;p=o}}u=g;return p|0}function rLa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+224|0;g=e+120|0;h=e+80|0;i=e;j=e+136|0;k=h;l=k+40|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[g>>2]=f[d>>2];if((sLa(0,c,g,i,h)|0)<0)m=-1;else{if((f[a+76>>2]|0)>-1)n=tLa(a)|0;else n=0;d=f[a>>2]|0;k=d&32;if((b[a+74>>0]|0)<1)f[a>>2]=d&-33;d=a+48|0;if(!(f[d>>2]|0)){l=a+44|0;o=f[l>>2]|0;f[l>>2]=j;p=a+28|0;f[p>>2]=j;q=a+20|0;f[q>>2]=j;f[d>>2]=80;r=a+16|0;f[r>>2]=j+80;j=sLa(a,c,g,i,h)|0;if(!o)s=j;else{ui[f[a+36>>2]&127](a,0,0)|0;t=(f[q>>2]|0)==0?-1:j;f[l>>2]=o;f[d>>2]=0;f[r>>2]=0;f[p>>2]=0;f[q>>2]=0;s=t}}else s=sLa(a,c,g,i,h)|0;h=f[a>>2]|0;f[a>>2]=h|k;if(n|0)uLa(a);m=(h&32|0)==0?s:-1}u=e;return m|0}
function Jpa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0;e=u;u=u+128|0;g=e+120|0;i=e+100|0;j=e;k=f[a+16>>2]|0;l=f[c+16>>2]|0;m=f[a+48>>2]|0;n=f[c+48>>2]|0;o=f[c+40>>2]|0;c=f[o+4>>2]|0;p=f[o>>2]|0;o=(f[a>>2]|0)>>>3;a=o&511;q=a+1|0;b[g>>0]=0;switch(d|0){case 3:{d=(p|0)==1;if((c|0)==1|d){r=p+c|0;s=r+-1|0;t=d?q:m;v=d?0:m-q|0;w=d?q:n;if((r|0)<=1){u=e;return}d=0-t|0;x=r+-2|0;r=l;y=0;z=k;while(1){A=(y|0)>0?d:0;B=(y|0)<(x|0)?t:0;C=0;D=z;while(1){E=h[D+A>>0]|0;F=h[D>>0]|0;G=E-F+256|0;if(G>>>0<769)H=h[331268+G>>0]|0;else H=0;G=H+F|0;F=G-(h[D+B>>0]|0)+256|0;if(F>>>0<769)I=h[331268+F>>0]|0;else I=0;F=G-I|0;G=(E|256)-H-F|0;if(G>>>0<769)J=h[331268+G>>0]|0;else J=0;b[r+C>>0]=J+F;C=C+1|0;if((C|0)==(q|0))break;else D=D+1|0}y=y+1|0;if((y|0)>=(s|0))break;else{r=r+w|0;z=z+q+v|0}}u=e;return}v=Y(q,c)|0;if((p|0)<=0){u=e;return}z=p+-1|0;w=(o|-512)^511;r=w+-1+v|0;s=v-q|0;y=l;J=0;while(1){H=J+-1|0;I=k+(Y((H|0)>0?H:0,m)|0)|0;H=k+(Y(J,m)|0)|0;J=J+1|0;t=k+(Y((z|0)<(J|0)?z:J,m)|0)|0;x=0;d=b[g>>0]&1?q:v;a:while(1){if((x|0)<(d|0)){D=x;do{C=D-((D|0)>(a|0)?q:0)|0;B=((D|0)<(s|0)?q:0)+D|0;A=h[I+C>>0]|0;F=h[I+D>>0]|0;G=h[I+B>>0]|0;E=h[H+C>>0]|0;K=h[H+D>>0]|0;L=h[H+B>>0]|0;M=h[t+C>>0]|0;C=h[t+D>>0]|0;N=h[t+B>>0]|0;B=F-G+256|0;if(B>>>0<769)O=h[331268+B>>0]|0;else O=0;B=O+G|0;G=F-O|0;F=K-L+256|0;if(F>>>0<769)P=h[331268+F>>0]|0;else P=0;F=P+L|0;L=K-P|0;K=C-N+256|0;if(K>>>0<769)Q=h[331268+K>>0]|0;else Q=0;K=Q+N|0;N=C-Q|0;C=A-G+256|0;if(C>>>0<769)R=h[331268+C>>0]|0;else R=0;C=R+G|0;G=E-L+256|0;if(G>>>0<769)S=h[331268+G>>0]|0;else S=0;G=S+L|0;L=E-S|0;E=M-N+256|0;if(E>>>0<769)T=h[331268+E>>0]|0;else T=0;E=T+N|0;N=M-T|0;M=C-B+256|0;if(M>>>0<769)U=h[331268+M>>0]|0;else U=0;M=U+B|0;B=G-F+256|0;if(B>>>0<769)V=h[331268+B>>0]|0;else V=0;B=V+F|0;F=G-V|0;G=E-K+256|0;if(G>>>0<769)W=h[331268+G>>0]|0;else W=0;G=E-W|0;E=(A|256)-R-L|0;if(E>>>0<769)X=h[331268+E>>0]|0;else X=0;E=256-K+B-W|0;if(E>>>0<769)Z=h[331268+E>>0]|0;else Z=0;E=F-G+256|0;if(E>>>0<769)_=h[331268+E>>0]|0;else _=0;E=F-_|0;F=L+256-N+X|0;if(F>>>0<769)$=h[331268+F>>0]|0;else $=0;F=C+256-U-E|0;if(F>>>0<769)aa=h[331268+F>>0]|0;else aa=0;F=aa+E|0;E=M+256-B+Z|0;if(E>>>0<769)ba=h[331268+E>>0]|0;else ba=0;E=M-ba|0;M=256-G-_+F|0;if(M>>>0<769)ca=h[331268+M>>0]|0;else ca=0;M=F-ca|0;F=M-E+256|0;if(F>>>0<769)da=h[331268+F>>0]|0;else da=0;F=M-da|0;M=N+256+$-F|0;if(M>>>0<769)ea=h[331268+M>>0]|0;else ea=0;M=ea+F|0;F=256-E-da+M|0;if(F>>>0<769)fa=h[331268+F>>0]|0;else fa=0;b[y+D>>0]=M-fa;D=D+1|0}while((D|0)!=(d|0));ga=d}else ga=x;if((d|0)==(v|0))break;if((ga|0)>(r|0)){x=ga;d=v;continue}else ha=ga;while(1){D=I+ha|0;M=h[D+w>>0]|0;F=h[D>>0]|0;E=h[D+q>>0]|0;D=H+ha|0;N=h[D+w>>0]|0;G=h[D>>0]|0;B=h[D+q>>0]|0;D=t+ha|0;C=h[D+w>>0]|0;L=h[D>>0]|0;K=h[D+q>>0]|0;D=F-E+256|0;if(D>>>0<769)ia=h[331268+D>>0]|0;else ia=0;D=ia+E|0;E=F-ia|0;F=G-B+256|0;if(F>>>0<769)ja=h[331268+F>>0]|0;else ja=0;F=ja+B|0;B=G-ja|0;G=L-K+256|0;if(G>>>0<769)ka=h[331268+G>>0]|0;else ka=0;G=ka+K|0;K=L-ka|0;L=M-E+256|0;if(L>>>0<769)la=h[331268+L>>0]|0;else la=0;L=la+E|0;E=N-B+256|0;if(E>>>0<769)ma=h[331268+E>>0]|0;else ma=0;E=ma+B|0;B=N-ma|0;N=C-K+256|0;if(N>>>0<769)na=h[331268+N>>0]|0;else na=0;N=na+K|0;K=C-na|0;C=L-D+256|0;if(C>>>0<769)oa=h[331268+C>>0]|0;else oa=0;C=oa+D|0;D=E-F+256|0;if(D>>>0<769)pa=h[331268+D>>0]|0;else pa=0;D=pa+F|0;F=E-pa|0;E=N-G+256|0;if(E>>>0<769)qa=h[331268+E>>0]|0;else qa=0;E=N-qa|0;N=(M|256)-la-B|0;if(N>>>0<769)ra=h[331268+N>>0]|0;else ra=0;N=256-G+D-qa|0;if(N>>>0<769)sa=h[331268+N>>0]|0;else sa=0;N=F-E+256|0;if(N>>>0<769)ta=h[331268+N>>0]|0;else ta=0;N=F-ta|0;F=B+256-K+ra|0;if(F>>>0<769)ua=h[331268+F>>0]|0;else ua=0;F=L+256-oa-N|0;if(F>>>0<769)va=h[331268+F>>0]|0;else va=0;F=va+N|0;N=C+256-D+sa|0;if(N>>>0<769)wa=h[331268+N>>0]|0;else wa=0;N=C-wa|0;C=256-E-ta+F|0;if(C>>>0<769)xa=h[331268+C>>0]|0;else xa=0;C=F-xa|0;F=C-N+256|0;if(F>>>0<769)ya=h[331268+F>>0]|0;else ya=0;F=C-ya|0;C=K+256+ua-F|0;if(C>>>0<769)za=h[331268+C>>0]|0;else za=0;C=za+F|0;F=256-N-ya+C|0;if(F>>>0<769)Aa=h[331268+F>>0]|0;else Aa=0;b[y+ha>>0]=C-Aa;C=ha+1|0;if((ha|0)<(r|0))ha=C;else{x=C;d=v;continue a}}}if((J|0)==(p|0))break;else y=y+n|0}u=e;return}case 5:{y=(p|0)==1;if((c|0)==1|y){J=p+c|0;v=J+-1|0;ha=y?q:m;r=y?0:m-q|0;Aa=y?q:n;if((J|0)<=1){u=e;return}y=0-ha|0;ya=y<<1;za=J+-2|0;ua=J+-3|0;J=ha<<1;xa=l;ta=0;wa=k;while(1){sa=(ta|0)>0?y:0;va=(ta|0)>1?ya:sa;oa=(ta|0)<(za|0)?ha:0;ra=(ta|0)<(ua|0)?J:oa;qa=0;la=wa;while(1){pa=h[la+va>>0]|0;na=h[la+sa>>0]|0;ma=h[la>>0]|0;ka=h[la+oa>>0]|0;ja=h[la+ra>>0]|0;ia=pa-na+256|0;if(ia>>>0<769)Ba=h[331268+ia>>0]|0;else Ba=0;ia=ka-ja+256|0;if(ia>>>0<769)Ca=h[331268+ia>>0]|0;else Ca=0;ia=Ca+ja|0;ja=ka-Ca|0;ka=ma-ja+256|0;if(ka>>>0<769)Da=h[331268+ka>>0]|0;else Da=0;ka=Da+ja|0;ja=ma-Da|0;ma=ka-ia+256|0;if(ma>>>0<769)Ea=h[331268+ma>>0]|0;else Ea=0;ma=(pa|256)-Ba-ja|0;if(ma>>>0<769)Fa=h[331268+ma>>0]|0;else Fa=0;ma=Fa+ja|0;ja=256-ia-Ea+ma|0;if(ja>>>0<769)Ga=h[331268+ja>>0]|0;else Ga=0;ja=ma-Ga|0;ma=Ba+na+256|0;na=ma-ka+Ea|0;if(na>>>0<769)Ha=h[331268+na>>0]|0;else Ha=0;na=ma-ja-Ha|0;if(na>>>0<769)Ia=h[331268+na>>0]|0;else Ia=0;b[xa+qa>>0]=Ia+ja;qa=qa+1|0;if((qa|0)==(q|0))break;else la=la+1|0}ta=ta+1|0;if((ta|0)>=(v|0))break;else{xa=xa+Aa|0;wa=wa+q+r|0}}u=e;return}r=Y(q,c)|0;if((p|0)<=0){u=e;return}c=i+4|0;wa=i+8|0;Aa=p+-1|0;xa=i+12|0;v=i+16|0;ta=q<<1;Ia=0-ta|0;Ha=r+-1-ta|0;Ea=(o|-512)^511;o=j+4|0;Ba=j+8|0;Ga=j+16|0;Fa=j+20|0;Da=j+12|0;Ca=j+28|0;J=j+32|0;ua=j+24|0;ha=j+40|0;za=j+44|0;ya=j+36|0;y=j+52|0;la=j+56|0;qa=j+48|0;ra=j+64|0;oa=j+68|0;sa=j+60|0;va=j+76|0;ja=j+80|0;na=j+72|0;ma=j+84|0;ka=j+88|0;ia=j+92|0;pa=j+96|0;w=r-q|0;ga=r-ta|0;fa=j+4|0;da=j+8|0;ea=j+16|0;$=j+20|0;ca=j+12|0;_=j+28|0;ba=j+32|0;Z=j+24|0;aa=j+40|0;U=j+44|0;X=j+36|0;W=j+52|0;R=j+56|0;V=j+48|0;T=j+64|0;S=j+68|0;Q=j+60|0;P=j+76|0;O=j+80|0;s=j+72|0;z=j+84|0;d=j+88|0;x=j+92|0;t=j+96|0;H=l;l=0;while(1){I=l+-2|0;C=k+(Y((I|0)>0?I:0,m)|0)|0;f[i>>2]=C;C=l+-1|0;I=k+(Y((C|0)>0?C:0,m)|0)|0;f[c>>2]=I;I=k+(Y(l,m)|0)|0;f[wa>>2]=I;I=l;l=l+1|0;C=k+(Y((Aa|0)<(l|0)?Aa:l,m)|0)|0;f[xa>>2]=C;C=I+2|0;I=k+(Y((Aa|0)<(C|0)?Aa:C,m)|0)|0;f[v>>2]=I;I=0;C=b[g>>0]&1?ta:r;b:while(1){if((I|0)<(C|0)){F=I;do{N=F-((F|0)>(a|0)?q:0)|0;K=(F|0)<(ta|0)?N:F-ta|0;E=((F|0)<(w|0)?q:0)+F|0;D=(F|0)<(ga|0)?F+ta|0:E;L=f[i>>2]|0;f[j>>2]=h[L+K>>0];B=h[L+N>>0]|0;f[fa>>2]=B;G=h[L+F>>0]|0;f[da>>2]=G;M=h[L+E>>0]|0;f[ca>>2]=M;A=h[L+D>>0]|0;f[ea>>2]=A;L=f[c>>2]|0;Ja=h[L+K>>0]|0;f[$>>2]=Ja;Ka=h[L+N>>0]|0;f[Z>>2]=Ka;La=h[L+F>>0]|0;f[_>>2]=La;Ma=h[L+E>>0]|0;f[ba>>2]=Ma;Na=h[L+D>>0]|0;f[X>>2]=Na;L=f[wa>>2]|0;Oa=h[L+K>>0]|0;f[aa>>2]=Oa;Pa=h[L+N>>0]|0;f[U>>2]=Pa;Qa=h[L+F>>0]|0;f[V>>2]=Qa;Ra=h[L+E>>0]|0;f[W>>2]=Ra;Sa=h[L+D>>0]|0;f[R>>2]=Sa;L=f[xa>>2]|0;Ta=h[L+K>>0]|0;f[Q>>2]=Ta;Ua=h[L+N>>0]|0;f[T>>2]=Ua;Va=h[L+F>>0]|0;f[S>>2]=Va;Wa=h[L+E>>0]|0;f[s>>2]=Wa;Xa=h[L+D>>0]|0;f[P>>2]=Xa;L=f[v>>2]|0;Ya=h[L+K>>0]|0;f[O>>2]=Ya;K=h[L+N>>0]|0;f[z>>2]=K;N=h[L+F>>0]|0;f[d>>2]=N;Za=h[L+E>>0]|0;f[x>>2]=Za;E=h[L+D>>0]|0;f[t>>2]=E;D=B-G+256|0;if(D>>>0<769)_a=h[331268+D>>0]|0;else _a=0;D=_a+G|0;f[da>>2]=D;G=(f[fa>>2]|0)-_a|0;f[fa>>2]=G;B=f[j>>2]|0;L=B-G+256|0;if(L>>>0<769)$a=h[331268+L>>0]|0;else $a=0;L=$a+G|0;f[fa>>2]=L;G=B-$a|0;f[j>>2]=G;B=L-D+256|0;if(B>>>0<769)ab=h[331268+B>>0]|0;else ab=0;B=ab+D|0;f[da>>2]=B;D=L-ab|0;f[fa>>2]=D;L=A-Ja+256|0;if(L>>>0<769)bb=h[331268+L>>0]|0;else bb=0;L=bb+Ja|0;f[$>>2]=L;Ja=A-bb|0;f[ea>>2]=Ja;A=M-Ja+256|0;if(A>>>0<769)cb=h[331268+A>>0]|0;else cb=0;A=cb+Ja|0;f[ea>>2]=A;Ja=M-cb|0;f[ca>>2]=Ja;M=A-L+256|0;if(M>>>0<769)db=h[331268+M>>0]|0;else db=0;M=db+L|0;f[$>>2]=M;L=A-db|0;f[ea>>2]=L;A=G-Ja+256|0;if(A>>>0<769)eb=h[331268+A>>0]|0;else eb=0;A=eb+Ja|0;f[ca>>2]=A;Ja=G-eb|0;f[j>>2]=Ja;G=B-M+256|0;if(G>>>0<769)fb=h[331268+G>>0]|0;else fb=0;G=fb+M|0;f[$>>2]=G;M=B-fb|0;f[da>>2]=M;B=M-A+256|0;if(B>>>0<769)gb=h[331268+B>>0]|0;else gb=0;B=gb+A|0;f[ca>>2]=B;A=M-gb|0;f[da>>2]=A;M=D-L+256|0;if(M>>>0<769)hb=h[331268+M>>0]|0;else hb=0;M=hb+L|0;f[ea>>2]=M;L=D-hb|0;f[fa>>2]=L;D=L-A+256|0;if(D>>>0<769)ib=h[331268+D>>0]|0;else ib=0;D=ib+A|0;f[da>>2]=D;A=L-ib|0;f[fa>>2]=A;L=B-M+256|0;if(L>>>0<769)jb=h[331268+L>>0]|0;else jb=0;L=jb+M|0;f[ea>>2]=L;M=B-jb|0;f[ca>>2]=M;B=La-Ma+256|0;if(B>>>0<769)kb=h[331268+B>>0]|0;else kb=0;B=kb+Ma|0;f[ba>>2]=B;Ma=La-kb|0;f[_>>2]=Ma;La=Ka-Ma+256|0;if(La>>>0<769)lb=h[331268+La>>0]|0;else lb=0;La=lb+Ma|0;f[_>>2]=La;Ma=Ka-lb|0;f[Z>>2]=Ma;Ka=La-B+256|0;if(Ka>>>0<769)mb=h[331268+Ka>>0]|0;else mb=0;Ka=mb+B|0;f[ba>>2]=Ka;B=La-mb|0;f[_>>2]=B;La=Oa-Pa+256|0;if(La>>>0<769)nb=h[331268+La>>0]|0;else nb=0;La=nb+Pa|0;f[U>>2]=La;Pa=Oa-nb|0;f[aa>>2]=Pa;Oa=Na-Pa+256|0;if(Oa>>>0<769)ob=h[331268+Oa>>0]|0;else ob=0;Oa=ob+Pa|0;f[aa>>2]=Oa;Pa=Na-ob|0;f[X>>2]=Pa;Na=Oa-La+256|0;if(Na>>>0<769)pb=h[331268+Na>>0]|0;else pb=0;Na=pb+La|0;f[U>>2]=Na;La=Oa-pb|0;f[aa>>2]=La;Oa=Ma-Pa+256|0;if(Oa>>>0<769)qb=h[331268+Oa>>0]|0;else qb=0;Oa=qb+Pa|0;f[X>>2]=Oa;Pa=Ma-qb|0;f[Z>>2]=Pa;Ma=Ka-Na+256|0;if(Ma>>>0<769)rb=h[331268+Ma>>0]|0;else rb=0;Ma=rb+Na|0;f[U>>2]=Ma;Na=Ka-rb|0;f[ba>>2]=Na;Ka=Na-Oa+256|0;if(Ka>>>0<769)sb=h[331268+Ka>>0]|0;else sb=0;Ka=sb+Oa|0;f[X>>2]=Ka;Oa=Na-sb|0;f[ba>>2]=Oa;Na=B-La+256|0;if(Na>>>0<769)tb=h[331268+Na>>0]|0;else tb=0;Na=tb+La|0;f[aa>>2]=Na;La=B-tb|0;f[_>>2]=La;B=La-Oa+256|0;if(B>>>0<769)ub=h[331268+B>>0]|0;else ub=0;B=ub+Oa|0;f[ba>>2]=B;Oa=La-ub|0;f[_>>2]=Oa;La=Ka-Na+256|0;if(La>>>0<769)vb=h[331268+La>>0]|0;else vb=0;La=vb+Na|0;f[aa>>2]=La;Na=Ka-vb|0;f[X>>2]=Na;Ka=Ja-Pa+256|0;if(Ka>>>0<769)wb=h[331268+Ka>>0]|0;else wb=0;Ka=wb+Pa|0;f[Z>>2]=Ka;Pa=Ja-wb|0;f[j>>2]=Pa;Ja=L-La+256|0;if(Ja>>>0<769)xb=h[331268+Ja>>0]|0;else xb=0;Ja=xb+La|0;f[aa>>2]=Ja;La=L-xb|0;f[ea>>2]=La;L=La-Ka+256|0;if(L>>>0<769)yb=h[331268+L>>0]|0;else yb=0;L=yb+Ka|0;f[Z>>2]=L;Ka=La-yb|0;f[ea>>2]=Ka;La=D-B+256|0;if(La>>>0<769)zb=h[331268+La>>0]|0;else zb=0;La=zb+B|0;f[ba>>2]=La;B=D-zb|0;f[da>>2]=B;D=B-Ka+256|0;if(D>>>0<769)Ab=h[331268+D>>0]|0;else Ab=0;D=Ab+Ka|0;f[ea>>2]=D;Ka=B-Ab|0;f[da>>2]=Ka;B=L-La+256|0;if(B>>>0<769)Bb=h[331268+B>>0]|0;else Bb=0;B=Bb+La|0;f[ba>>2]=B;La=L-Bb|0;f[Z>>2]=La;L=A-Oa+256|0;if(L>>>0<769)Cb=h[331268+L>>0]|0;else Cb=0;L=Cb+Oa|0;f[_>>2]=L;Oa=A-Cb|0;f[fa>>2]=Oa;A=G-Ma+256|0;if(A>>>0<769)Db=h[331268+A>>0]|0;else Db=0;A=Db+Ma|0;f[U>>2]=A;Ma=G-Db|0;f[$>>2]=Ma;G=Ma-L+256|0;if(G>>>0<769)Eb=h[331268+G>>0]|0;else Eb=0;G=Eb+L|0;f[_>>2]=G;L=Ma-Eb|0;f[$>>2]=L;Ma=M-Na+256|0;if(Ma>>>0<769)Fb=h[331268+Ma>>0]|0;else Fb=0;Ma=Fb+Na|0;f[X>>2]=Ma;Na=M-Fb|0;f[ca>>2]=Na;M=Na-L+256|0;if(M>>>0<769)Gb=h[331268+M>>0]|0;else Gb=0;M=Gb+L|0;f[$>>2]=M;L=Na-Gb|0;f[ca>>2]=L;Na=G-Ma+256|0;if(Na>>>0<769)Hb=h[331268+Na>>0]|0;else Hb=0;Na=Hb+Ma|0;f[X>>2]=Na;Ma=G-Hb|0;f[_>>2]=Ma;G=Oa-Ka+256|0;if(G>>>0<769)Ib=h[331268+G>>0]|0;else Ib=0;G=Ib+Ka|0;f[da>>2]=G;Ka=Oa-Ib|0;f[fa>>2]=Ka;Oa=L-D+256|0;if(Oa>>>0<769)Jb=h[331268+Oa>>0]|0;else Jb=0;Oa=Jb+D|0;f[ea>>2]=Oa;D=L-Jb|0;f[ca>>2]=D;L=M-La+256|0;if(L>>>0<769)Kb=h[331268+L>>0]|0;else Kb=0;L=Kb+La|0;f[Z>>2]=L;La=M-Kb|0;f[$>>2]=La;M=Ma-B+256|0;if(M>>>0<769)Lb=h[331268+M>>0]|0;else Lb=0;M=Lb+B|0;f[ba>>2]=M;B=Ma-Lb|0;f[_>>2]=B;Ma=Na-Ja+256|0;if(Ma>>>0<769)Mb=h[331268+Ma>>0]|0;else Mb=0;Ma=Mb+Ja|0;f[aa>>2]=Ma;Ja=Na-Mb|0;f[X>>2]=Ja;Na=Ra-Sa+256|0;if(Na>>>0<769)Nb=h[331268+Na>>0]|0;else Nb=0;Na=Nb+Sa|0;f[R>>2]=Na;Sa=Ra-Nb|0;f[W>>2]=Sa;Ra=Qa-Sa+256|0;if(Ra>>>0<769)Ob=h[331268+Ra>>0]|0;else Ob=0;Ra=Ob+Sa|0;f[W>>2]=Ra;Sa=Qa-Ob|0;f[V>>2]=Sa;Qa=Ra-Na+256|0;if(Qa>>>0<769)Pb=h[331268+Qa>>0]|0;else Pb=0;Qa=Pb+Na|0;f[R>>2]=Qa;Na=Ra-Pb|0;f[W>>2]=Na;Ra=Ua-Va+256|0;if(Ra>>>0<769)Qb=h[331268+Ra>>0]|0;else Qb=0;Ra=Qb+Va|0;f[S>>2]=Ra;Va=Ua-Qb|0;f[T>>2]=Va;Ua=Ta-Va+256|0;if(Ua>>>0<769)Rb=h[331268+Ua>>0]|0;else Rb=0;Ua=Rb+Va|0;f[T>>2]=Ua;Va=Ta-Rb|0;f[Q>>2]=Va;Ta=Ua-Ra+256|0;if(Ta>>>0<769)Sb=h[331268+Ta>>0]|0;else Sb=0;Ta=Sb+Ra|0;f[S>>2]=Ta;Ra=Ua-Sb|0;f[T>>2]=Ra;Ua=Sa-Va+256|0;if(Ua>>>0<769)Tb=h[331268+Ua>>0]|0;else Tb=0;Ua=Tb+Va|0;f[Q>>2]=Ua;Va=Sa-Tb|0;f[V>>2]=Va;Sa=Qa-Ta+256|0;if(Sa>>>0<769)Ub=h[331268+Sa>>0]|0;else Ub=0;Sa=Ub+Ta|0;f[S>>2]=Sa;Ta=Qa-Ub|0;f[R>>2]=Ta;Qa=Ta-Ua+256|0;if(Qa>>>0<769)Vb=h[331268+Qa>>0]|0;else Vb=0;Qa=Vb+Ua|0;f[Q>>2]=Qa;Ua=Ta-Vb|0;f[R>>2]=Ua;Ta=Na-Ra+256|0;if(Ta>>>0<769)Wb=h[331268+Ta>>0]|0;else Wb=0;Ta=Wb+Ra|0;f[T>>2]=Ta;Ra=Na-Wb|0;f[W>>2]=Ra;Na=Ra-Ua+256|0;if(Na>>>0<769)Xb=h[331268+Na>>0]|0;else Xb=0;Na=Xb+Ua|0;f[R>>2]=Na;Ua=Ra-Xb|0;f[W>>2]=Ua;Ra=Qa-Ta+256|0;if(Ra>>>0<769)Yb=h[331268+Ra>>0]|0;else Yb=0;Ra=Yb+Ta|0;f[T>>2]=Ra;Ta=Qa-Yb|0;f[Q>>2]=Ta;Qa=Xa-Ya+256|0;if(Qa>>>0<769)Zb=h[331268+Qa>>0]|0;else Zb=0;Qa=Zb+Ya|0;f[O>>2]=Qa;Ya=Xa-Zb|0;f[P>>2]=Ya;Xa=Wa-Ya+256|0;if(Xa>>>0<769)_b=h[331268+Xa>>0]|0;else _b=0;Xa=_b+Ya|0;f[P>>2]=Xa;Ya=Wa-_b|0;f[s>>2]=Ya;Wa=Xa-Qa+256|0;if(Wa>>>0<769)$b=h[331268+Wa>>0]|0;else $b=0;Wa=$b+Qa|0;f[O>>2]=Wa;Qa=Xa-$b|0;f[P>>2]=Qa;Xa=K-N+256|0;if(Xa>>>0<769)ac=h[331268+Xa>>0]|0;else ac=0;Xa=ac+N|0;f[d>>2]=Xa;N=K-ac|0;f[z>>2]=N;K=Za-E+256|0;if(K>>>0<769)bc=h[331268+K>>0]|0;else bc=0;K=bc+E|0;f[t>>2]=K;E=Za-bc|0;f[x>>2]=E;Za=N-E+256|0;if(Za>>>0<769)cc=h[331268+Za>>0]|0;else cc=0;Za=cc+E|0;f[x>>2]=Za;E=N-cc|0;f[z>>2]=E;N=Xa-K+256|0;if(N>>>0<769)dc=h[331268+N>>0]|0;else dc=0;N=dc+K|0;f[t>>2]=N;K=Xa-dc|0;f[d>>2]=K;Xa=K-Za+256|0;if(Xa>>>0<769)ec=h[331268+Xa>>0]|0;else ec=0;Xa=ec+Za|0;f[x>>2]=Xa;Za=K-ec|0;f[d>>2]=Za;K=Ya-E+256|0;if(K>>>0<769)fc=h[331268+K>>0]|0;else fc=0;K=fc+E|0;f[z>>2]=K;E=Ya-fc|0;f[s>>2]=E;Ya=Wa-Xa+256|0;if(Ya>>>0<769)gc=h[331268+Ya>>0]|0;else gc=0;Ya=gc+Xa|0;f[x>>2]=Ya;Xa=Wa-gc|0;f[O>>2]=Xa;Wa=Xa-K+256|0;if(Wa>>>0<769)hc=h[331268+Wa>>0]|0;else hc=0;Wa=hc+K|0;f[z>>2]=Wa;K=Xa-hc|0;f[O>>2]=K;Xa=Qa-Za+256|0;if(Xa>>>0<769)ic=h[331268+Xa>>0]|0;else ic=0;Xa=ic+Za|0;f[d>>2]=Xa;Za=Qa-ic|0;f[P>>2]=Za;Qa=Xa-N+256|0;if(Qa>>>0<769)jc=h[331268+Qa>>0]|0;else jc=0;Qa=jc+N|0;f[t>>2]=Qa;N=Xa-jc|0;f[d>>2]=N;Xa=Za-K+256|0;if(Xa>>>0<769)kc=h[331268+Xa>>0]|0;else kc=0;Xa=kc+K|0;f[O>>2]=Xa;K=Za-kc|0;f[P>>2]=K;Za=Wa-N+256|0;if(Za>>>0<769)lc=h[331268+Za>>0]|0;else lc=0;Za=lc+N|0;f[d>>2]=Za;N=Wa-lc|0;f[z>>2]=N;Wa=Ya-Qa+256|0;if(Wa>>>0<769)mc=h[331268+Wa>>0]|0;else mc=0;Wa=mc+Qa|0;f[t>>2]=Wa;Qa=Ya-mc|0;f[x>>2]=Qa;Ya=Va-E+256|0;if(Ya>>>0<769)nc=h[331268+Ya>>0]|0;else nc=0;Ya=nc+E|0;f[s>>2]=Ya;E=Va-nc|0;f[V>>2]=E;Va=Ra-Za+256|0;if(Va>>>0<769)oc=h[331268+Va>>0]|0;else oc=0;Va=oc+Za|0;f[d>>2]=Va;Za=Ra-oc|0;f[T>>2]=Za;Ra=Za-Ya+256|0;if(Ra>>>0<769)pc=h[331268+Ra>>0]|0;else pc=0;Ra=pc+Ya|0;f[s>>2]=Ra;Ya=Za-pc|0;f[T>>2]=Ya;Za=Na-Xa+256|0;if(Za>>>0<769)qc=h[331268+Za>>0]|0;else qc=0;Za=qc+Xa|0;f[O>>2]=Za;Xa=Na-qc|0;f[R>>2]=Xa;Na=Za-Wa+256|0;if(Na>>>0<769)rc=h[331268+Na>>0]|0;else rc=0;Na=rc+Wa|0;f[t>>2]=Na;Wa=Za-rc|0;f[O>>2]=Wa;Za=Xa-Ya+256|0;if(Za>>>0<769)sc=h[331268+Za>>0]|0;else sc=0;Za=sc+Ya|0;f[T>>2]=Za;Ya=Xa-sc|0;f[R>>2]=Ya;Xa=Ra-Wa+256|0;if(Xa>>>0<769)tc=h[331268+Xa>>0]|0;else tc=0;Xa=tc+Wa|0;f[O>>2]=Xa;Wa=Ra-tc|0;f[s>>2]=Wa;Ra=Va-Na+256|0;if(Ra>>>0<769)uc=h[331268+Ra>>0]|0;else uc=0;Ra=uc+Na|0;f[t>>2]=Ra;Na=Va-uc|0;f[d>>2]=Na;Va=Ua-K+256|0;if(Va>>>0<769)vc=h[331268+Va>>0]|0;else vc=0;Va=vc+K|0;f[P>>2]=Va;K=Ua-vc|0;f[W>>2]=K;Ua=Sa-Qa+256|0;if(Ua>>>0<769)wc=h[331268+Ua>>0]|0;else wc=0;Ua=wc+Qa|0;f[x>>2]=Ua;Qa=Sa-wc|0;f[S>>2]=Qa;Sa=Qa-Va+256|0;if(Sa>>>0<769)xc=h[331268+Sa>>0]|0;else xc=0;Sa=xc+Va|0;f[P>>2]=Sa;Va=Qa-xc|0;f[S>>2]=Va;Qa=Ta-N+256|0;if(Qa>>>0<769)yc=h[331268+Qa>>0]|0;else yc=0;Qa=yc+N|0;f[z>>2]=Qa;N=Ta-yc|0;f[Q>>2]=N;Ta=N-Va+256|0;if(Ta>>>0<769)zc=h[331268+Ta>>0]|0;else zc=0;Ta=zc+Va|0;f[S>>2]=Ta;Va=N-zc|0;f[Q>>2]=Va;N=Sa-Qa+256|0;if(N>>>0<769)Ac=h[331268+N>>0]|0;else Ac=0;N=Ac+Qa|0;f[z>>2]=N;Qa=Sa-Ac|0;f[P>>2]=Qa;Sa=K-Ya+256|0;if(Sa>>>0<769)Bc=h[331268+Sa>>0]|0;else Bc=0;Sa=Bc+Ya|0;f[R>>2]=Sa;Ya=K-Bc|0;f[W>>2]=Ya;K=Va-Za+256|0;if(K>>>0<769)Cc=h[331268+K>>0]|0;else Cc=0;K=Cc+Za|0;f[T>>2]=K;Za=Va-Cc|0;f[Q>>2]=Za;Va=Ta-Wa+256|0;if(Va>>>0<769)Dc=h[331268+Va>>0]|0;else Dc=0;Va=Dc+Wa|0;f[s>>2]=Va;Wa=Ta-Dc|0;f[S>>2]=Wa;Ta=Qa-Xa+256|0;if(Ta>>>0<769)Ec=h[331268+Ta>>0]|0;else Ec=0;Ta=Ec+Xa|0;f[O>>2]=Ta;Xa=Qa-Ec|0;f[P>>2]=Xa;Qa=N-Na+256|0;if(Qa>>>0<769)Fc=h[331268+Qa>>0]|0;else Fc=0;Qa=Fc+Na|0;f[d>>2]=Qa;Na=N-Fc|0;f[z>>2]=Na;N=Ua-Ra+256|0;if(N>>>0<769)Gc=h[331268+N>>0]|0;else Gc=0;N=Gc+Ra|0;f[t>>2]=N;Ra=Ua-Gc|0;f[x>>2]=Ra;Ua=Pa-E+256|0;if(Ua>>>0<769)Hc=h[331268+Ua>>0]|0;else Hc=0;Ua=Hc+E|0;f[V>>2]=Ua;f[j>>2]=Pa-Hc;Pa=M-Ta+256|0;if(Pa>>>0<769)Ic=h[331268+Pa>>0]|0;else Ic=0;f[O>>2]=Ic+Ta;Ta=M-Ic|0;f[ba>>2]=Ta;M=Ta-Ua+256|0;if(M>>>0<769)Jc=h[331268+M>>0]|0;else Jc=0;M=Jc+Ua|0;f[V>>2]=M;f[ba>>2]=Ta-Jc;Ta=Oa-K+256|0;if(Ta>>>0<769)Kc=h[331268+Ta>>0]|0;else Kc=0;Ta=Kc+K|0;f[T>>2]=Ta;f[ea>>2]=Oa-Kc;Oa=Ta-N+256|0;if(Oa>>>0<769)Lc=h[331268+Oa>>0]|0;else Lc=0;f[t>>2]=Lc+N;N=Ta-Lc|0;f[T>>2]=N;Ta=M-N+256|0;if(Ta>>>0<769)Mc=h[331268+Ta>>0]|0;else Mc=0;f[T>>2]=Mc+N;N=M-Mc|0;f[V>>2]=N;M=G-Sa+256|0;if(M>>>0<769)Nc=h[331268+M>>0]|0;else Nc=0;M=Nc+Sa|0;f[R>>2]=M;f[da>>2]=G-Nc;G=Ma-Qa+256|0;if(G>>>0<769)Oc=h[331268+G>>0]|0;else Oc=0;f[d>>2]=Oc+Qa;Qa=Ma-Oc|0;f[aa>>2]=Qa;Ma=Qa-M+256|0;if(Ma>>>0<769)Pc=h[331268+Ma>>0]|0;else Pc=0;f[R>>2]=Pc+M;M=Qa-Pc|0;f[aa>>2]=M;Qa=L-Va+256|0;if(Qa>>>0<769)Qc=h[331268+Qa>>0]|0;else Qc=0;f[s>>2]=Qc+Va;Va=L-Qc|0;f[Z>>2]=Va;L=Va-M+256|0;if(L>>>0<769)Rc=h[331268+L>>0]|0;else Rc=0;L=Rc+M|0;f[aa>>2]=L;f[Z>>2]=Va-Rc;Va=L-N+256|0;if(Va>>>0<769)Sc=h[331268+Va>>0]|0;else Sc=0;Va=Sc+N|0;f[V>>2]=Va;f[aa>>2]=L-Sc;L=Ka-Ya+256|0;if(L>>>0<769)Tc=h[331268+L>>0]|0;else Tc=0;L=Tc+Ya|0;f[W>>2]=L;f[fa>>2]=Ka-Tc;Ka=Ja-Na+256|0;if(Ka>>>0<769)Uc=h[331268+Ka>>0]|0;else Uc=0;f[z>>2]=Uc+Na;Na=Ja-Uc|0;f[X>>2]=Na;Ja=Na-L+256|0;if(Ja>>>0<769)Vc=h[331268+Ja>>0]|0;else Vc=0;Ja=Vc+L|0;f[W>>2]=Ja;f[X>>2]=Na-Vc;Na=La-Wa+256|0;if(Na>>>0<769)Wc=h[331268+Na>>0]|0;else Wc=0;Na=Wc+Wa|0;f[S>>2]=Na;f[$>>2]=La-Wc;La=Ja-Na+256|0;if(La>>>0<769)Xc=h[331268+La>>0]|0;else Xc=0;f[S>>2]=Xc+Na;Na=Ja-Xc|0;f[W>>2]=Na;Ja=D-Za+256|0;if(Ja>>>0<769)Yc=h[331268+Ja>>0]|0;else Yc=0;Ja=Yc+Za|0;f[Q>>2]=Ja;f[ca>>2]=D-Yc;D=A-Ra+256|0;if(D>>>0<769)Zc=h[331268+D>>0]|0;else Zc=0;f[x>>2]=Zc+Ra;Ra=A-Zc|0;f[U>>2]=Ra;A=Ra-Ja+256|0;if(A>>>0<769)_c=h[331268+A>>0]|0;else _c=0;f[Q>>2]=_c+Ja;Ja=Ra-_c|0;f[U>>2]=Ja;Ra=B-Xa+256|0;if(Ra>>>0<769)$c=h[331268+Ra>>0]|0;else $c=0;f[P>>2]=$c+Xa;Xa=B-$c|0;f[_>>2]=Xa;B=Xa-Ja+256|0;if(B>>>0<769)ad=h[331268+B>>0]|0;else ad=0;B=ad+Ja|0;f[U>>2]=B;f[_>>2]=Xa-ad;Xa=B-Na+256|0;if(Xa>>>0<769)bd=h[331268+Xa>>0]|0;else bd=0;f[W>>2]=bd+Na;Na=B-bd|0;f[U>>2]=Na;B=Na-Va+256|0;if(B>>>0<769)cd=h[331268+B>>0]|0;else cd=0;b[H+F>>0]=cd+Va;F=F+1|0}while((F|0)!=(C|0));dd=C}else dd=I;if((C|0)==(r|0))break;if((dd|0)>(Ha|0)){I=dd;C=r;continue}else ed=dd;while(1){F=(f[i>>2]|0)+ed|0;f[j>>2]=h[F+Ia>>0];Va=h[F+Ea>>0]|0;f[o>>2]=Va;B=h[F>>0]|0;f[Ba>>2]=B;Na=h[F+q>>0]|0;f[Da>>2]=Na;Xa=h[F+ta>>0]|0;f[Ga>>2]=Xa;F=(f[c>>2]|0)+ed|0;Ja=h[F+Ia>>0]|0;f[Fa>>2]=Ja;Ra=h[F+Ea>>0]|0;f[ua>>2]=Ra;A=h[F>>0]|0;f[Ca>>2]=A;D=h[F+q>>0]|0;f[J>>2]=D;Za=h[F+ta>>0]|0;f[ya>>2]=Za;F=(f[wa>>2]|0)+ed|0;La=h[F+Ia>>0]|0;f[ha>>2]=La;Wa=h[F+Ea>>0]|0;f[za>>2]=Wa;L=h[F>>0]|0;f[qa>>2]=L;Ka=h[F+q>>0]|0;f[y>>2]=Ka;Ya=h[F+ta>>0]|0;f[la>>2]=Ya;F=(f[xa>>2]|0)+ed|0;N=h[F+Ia>>0]|0;f[sa>>2]=N;M=h[F+Ea>>0]|0;f[ra>>2]=M;Qa=h[F>>0]|0;f[oa>>2]=Qa;Ma=h[F+q>>0]|0;f[na>>2]=Ma;G=h[F+ta>>0]|0;f[va>>2]=G;F=(f[v>>2]|0)+ed|0;Sa=h[F+Ia>>0]|0;f[ja>>2]=Sa;Ta=h[F+Ea>>0]|0;f[ma>>2]=Ta;Oa=h[F>>0]|0;f[ka>>2]=Oa;K=h[F+q>>0]|0;f[ia>>2]=K;Ua=h[F+ta>>0]|0;f[pa>>2]=Ua;F=Va-B+256|0;if(F>>>0<769)fd=h[331268+F>>0]|0;else fd=0;F=fd+B|0;f[Ba>>2]=F;B=(f[o>>2]|0)-fd|0;f[o>>2]=B;Va=f[j>>2]|0;Pa=Va-B+256|0;if(Pa>>>0<769)gd=h[331268+Pa>>0]|0;else gd=0;Pa=gd+B|0;f[o>>2]=Pa;B=Va-gd|0;f[j>>2]=B;Va=Pa-F+256|0;if(Va>>>0<769)hd=h[331268+Va>>0]|0;else hd=0;Va=hd+F|0;f[Ba>>2]=Va;F=Pa-hd|0;f[o>>2]=F;Pa=Xa-Ja+256|0;if(Pa>>>0<769)id=h[331268+Pa>>0]|0;else id=0;Pa=id+Ja|0;f[Fa>>2]=Pa;Ja=Xa-id|0;f[Ga>>2]=Ja;Xa=Na-Ja+256|0;if(Xa>>>0<769)jd=h[331268+Xa>>0]|0;else jd=0;Xa=jd+Ja|0;f[Ga>>2]=Xa;Ja=Na-jd|0;f[Da>>2]=Ja;Na=Xa-Pa+256|0;if(Na>>>0<769)kd=h[331268+Na>>0]|0;else kd=0;Na=kd+Pa|0;f[Fa>>2]=Na;Pa=Xa-kd|0;f[Ga>>2]=Pa;Xa=B-Ja+256|0;if(Xa>>>0<769)ld=h[331268+Xa>>0]|0;else ld=0;Xa=ld+Ja|0;f[Da>>2]=Xa;Ja=B-ld|0;f[j>>2]=Ja;B=Va-Na+256|0;if(B>>>0<769)md=h[331268+B>>0]|0;else md=0;B=md+Na|0;f[Fa>>2]=B;Na=Va-md|0;f[Ba>>2]=Na;Va=Na-Xa+256|0;if(Va>>>0<769)nd=h[331268+Va>>0]|0;else nd=0;Va=nd+Xa|0;f[Da>>2]=Va;Xa=Na-nd|0;f[Ba>>2]=Xa;Na=F-Pa+256|0;if(Na>>>0<769)od=h[331268+Na>>0]|0;else od=0;Na=od+Pa|0;f[Ga>>2]=Na;Pa=F-od|0;f[o>>2]=Pa;F=Pa-Xa+256|0;if(F>>>0<769)pd=h[331268+F>>0]|0;else pd=0;F=pd+Xa|0;f[Ba>>2]=F;Xa=Pa-pd|0;f[o>>2]=Xa;Pa=Va-Na+256|0;if(Pa>>>0<769)qd=h[331268+Pa>>0]|0;else qd=0;Pa=qd+Na|0;f[Ga>>2]=Pa;Na=Va-qd|0;f[Da>>2]=Na;Va=A-D+256|0;if(Va>>>0<769)rd=h[331268+Va>>0]|0;else rd=0;Va=rd+D|0;f[J>>2]=Va;D=A-rd|0;f[Ca>>2]=D;A=Ra-D+256|0;if(A>>>0<769)sd=h[331268+A>>0]|0;else sd=0;A=sd+D|0;f[Ca>>2]=A;D=Ra-sd|0;f[ua>>2]=D;Ra=A-Va+256|0;if(Ra>>>0<769)td=h[331268+Ra>>0]|0;else td=0;Ra=td+Va|0;f[J>>2]=Ra;Va=A-td|0;f[Ca>>2]=Va;A=La-Wa+256|0;if(A>>>0<769)ud=h[331268+A>>0]|0;else ud=0;A=ud+Wa|0;f[za>>2]=A;Wa=La-ud|0;f[ha>>2]=Wa;La=Za-Wa+256|0;if(La>>>0<769)vd=h[331268+La>>0]|0;else vd=0;La=vd+Wa|0;f[ha>>2]=La;Wa=Za-vd|0;f[ya>>2]=Wa;Za=La-A+256|0;if(Za>>>0<769)wd=h[331268+Za>>0]|0;else wd=0;Za=wd+A|0;f[za>>2]=Za;A=La-wd|0;f[ha>>2]=A;La=D-Wa+256|0;if(La>>>0<769)xd=h[331268+La>>0]|0;else xd=0;La=xd+Wa|0;f[ya>>2]=La;Wa=D-xd|0;f[ua>>2]=Wa;D=Ra-Za+256|0;if(D>>>0<769)yd=h[331268+D>>0]|0;else yd=0;D=yd+Za|0;f[za>>2]=D;Za=Ra-yd|0;f[J>>2]=Za;Ra=Za-La+256|0;if(Ra>>>0<769)zd=h[331268+Ra>>0]|0;else zd=0;Ra=zd+La|0;f[ya>>2]=Ra;La=Za-zd|0;f[J>>2]=La;Za=Va-A+256|0;if(Za>>>0<769)Ad=h[331268+Za>>0]|0;else Ad=0;Za=Ad+A|0;f[ha>>2]=Za;A=Va-Ad|0;f[Ca>>2]=A;Va=A-La+256|0;if(Va>>>0<769)Bd=h[331268+Va>>0]|0;else Bd=0;Va=Bd+La|0;f[J>>2]=Va;La=A-Bd|0;f[Ca>>2]=La;A=Ra-Za+256|0;if(A>>>0<769)Cd=h[331268+A>>0]|0;else Cd=0;A=Cd+Za|0;f[ha>>2]=A;Za=Ra-Cd|0;f[ya>>2]=Za;Ra=Ja-Wa+256|0;if(Ra>>>0<769)Dd=h[331268+Ra>>0]|0;else Dd=0;Ra=Dd+Wa|0;f[ua>>2]=Ra;Wa=Ja-Dd|0;f[j>>2]=Wa;Ja=Pa-A+256|0;if(Ja>>>0<769)Ed=h[331268+Ja>>0]|0;else Ed=0;Ja=Ed+A|0;f[ha>>2]=Ja;A=Pa-Ed|0;f[Ga>>2]=A;Pa=A-Ra+256|0;if(Pa>>>0<769)Fd=h[331268+Pa>>0]|0;else Fd=0;Pa=Fd+Ra|0;f[ua>>2]=Pa;Ra=A-Fd|0;f[Ga>>2]=Ra;A=F-Va+256|0;if(A>>>0<769)Gd=h[331268+A>>0]|0;else Gd=0;A=Gd+Va|0;f[J>>2]=A;Va=F-Gd|0;f[Ba>>2]=Va;F=Va-Ra+256|0;if(F>>>0<769)Hd=h[331268+F>>0]|0;else Hd=0;F=Hd+Ra|0;f[Ga>>2]=F;Ra=Va-Hd|0;f[Ba>>2]=Ra;Va=Pa-A+256|0;if(Va>>>0<769)Id=h[331268+Va>>0]|0;else Id=0;Va=Id+A|0;f[J>>2]=Va;A=Pa-Id|0;f[ua>>2]=A;Pa=Xa-La+256|0;if(Pa>>>0<769)Jd=h[331268+Pa>>0]|0;else Jd=0;Pa=Jd+La|0;f[Ca>>2]=Pa;La=Xa-Jd|0;f[o>>2]=La;Xa=B-D+256|0;if(Xa>>>0<769)Kd=h[331268+Xa>>0]|0;else Kd=0;Xa=Kd+D|0;f[za>>2]=Xa;D=B-Kd|0;f[Fa>>2]=D;B=D-Pa+256|0;if(B>>>0<769)Ld=h[331268+B>>0]|0;else Ld=0;B=Ld+Pa|0;f[Ca>>2]=B;Pa=D-Ld|0;f[Fa>>2]=Pa;D=Na-Za+256|0;if(D>>>0<769)Md=h[331268+D>>0]|0;else Md=0;D=Md+Za|0;f[ya>>2]=D;Za=Na-Md|0;f[Da>>2]=Za;Na=Za-Pa+256|0;if(Na>>>0<769)Nd=h[331268+Na>>0]|0;else Nd=0;Na=Nd+Pa|0;f[Fa>>2]=Na;Pa=Za-Nd|0;f[Da>>2]=Pa;Za=B-D+256|0;if(Za>>>0<769)Od=h[331268+Za>>0]|0;else Od=0;Za=Od+D|0;f[ya>>2]=Za;D=B-Od|0;f[Ca>>2]=D;B=La-Ra+256|0;if(B>>>0<769)Pd=h[331268+B>>0]|0;else Pd=0;B=Pd+Ra|0;f[Ba>>2]=B;Ra=La-Pd|0;f[o>>2]=Ra;La=Pa-F+256|0;if(La>>>0<769)Qd=h[331268+La>>0]|0;else Qd=0;La=Qd+F|0;f[Ga>>2]=La;F=Pa-Qd|0;f[Da>>2]=F;Pa=Na-A+256|0;if(Pa>>>0<769)Rd=h[331268+Pa>>0]|0;else Rd=0;Pa=Rd+A|0;f[ua>>2]=Pa;A=Na-Rd|0;f[Fa>>2]=A;Na=D-Va+256|0;if(Na>>>0<769)Sd=h[331268+Na>>0]|0;else Sd=0;Na=Sd+Va|0;f[J>>2]=Na;Va=D-Sd|0;f[Ca>>2]=Va;D=Za-Ja+256|0;if(D>>>0<769)Td=h[331268+D>>0]|0;else Td=0;D=Td+Ja|0;f[ha>>2]=D;Ja=Za-Td|0;f[ya>>2]=Ja;Za=Ka-Ya+256|0;if(Za>>>0<769)Ud=h[331268+Za>>0]|0;else Ud=0;Za=Ud+Ya|0;f[la>>2]=Za;Ya=Ka-Ud|0;f[y>>2]=Ya;Ka=L-Ya+256|0;if(Ka>>>0<769)Vd=h[331268+Ka>>0]|0;else Vd=0;Ka=Vd+Ya|0;f[y>>2]=Ka;Ya=L-Vd|0;f[qa>>2]=Ya;L=Ka-Za+256|0;if(L>>>0<769)Wd=h[331268+L>>0]|0;else Wd=0;L=Wd+Za|0;f[la>>2]=L;Za=Ka-Wd|0;f[y>>2]=Za;Ka=M-Qa+256|0;if(Ka>>>0<769)Xd=h[331268+Ka>>0]|0;else Xd=0;Ka=Xd+Qa|0;f[oa>>2]=Ka;Qa=M-Xd|0;f[ra>>2]=Qa;M=N-Qa+256|0;if(M>>>0<769)Yd=h[331268+M>>0]|0;else Yd=0;M=Yd+Qa|0;f[ra>>2]=M;Qa=N-Yd|0;f[sa>>2]=Qa;N=M-Ka+256|0;if(N>>>0<769)Zd=h[331268+N>>0]|0;else Zd=0;N=Zd+Ka|0;f[oa>>2]=N;Ka=M-Zd|0;f[ra>>2]=Ka;M=Ya-Qa+256|0;if(M>>>0<769)_d=h[331268+M>>0]|0;else _d=0;M=_d+Qa|0;f[sa>>2]=M;Qa=Ya-_d|0;f[qa>>2]=Qa;Ya=L-N+256|0;if(Ya>>>0<769)$d=h[331268+Ya>>0]|0;else $d=0;Ya=$d+N|0;f[oa>>2]=Ya;N=L-$d|0;f[la>>2]=N;L=N-M+256|0;if(L>>>0<769)ae=h[331268+L>>0]|0;else ae=0;L=ae+M|0;f[sa>>2]=L;M=N-ae|0;f[la>>2]=M;N=Za-Ka+256|0;if(N>>>0<769)be=h[331268+N>>0]|0;else be=0;N=be+Ka|0;f[ra>>2]=N;Ka=Za-be|0;f[y>>2]=Ka;Za=Ka-M+256|0;if(Za>>>0<769)ce=h[331268+Za>>0]|0;else ce=0;Za=ce+M|0;f[la>>2]=Za;M=Ka-ce|0;f[y>>2]=M;Ka=L-N+256|0;if(Ka>>>0<769)de=h[331268+Ka>>0]|0;else de=0;Ka=de+N|0;f[ra>>2]=Ka;N=L-de|0;f[sa>>2]=N;L=G-Sa+256|0;if(L>>>0<769)ee=h[331268+L>>0]|0;else ee=0;L=ee+Sa|0;f[ja>>2]=L;Sa=G-ee|0;f[va>>2]=Sa;G=Ma-Sa+256|0;if(G>>>0<769)fe=h[331268+G>>0]|0;else fe=0;G=fe+Sa|0;f[va>>2]=G;Sa=Ma-fe|0;f[na>>2]=Sa;Ma=G-L+256|0;if(Ma>>>0<769)ge=h[331268+Ma>>0]|0;else ge=0;Ma=ge+L|0;f[ja>>2]=Ma;L=G-ge|0;f[va>>2]=L;G=Ta-Oa+256|0;if(G>>>0<769)he=h[331268+G>>0]|0;else he=0;G=he+Oa|0;f[ka>>2]=G;Oa=Ta-he|0;f[ma>>2]=Oa;Ta=K-Ua+256|0;if(Ta>>>0<769)ie=h[331268+Ta>>0]|0;else ie=0;Ta=ie+Ua|0;f[pa>>2]=Ta;Ua=K-ie|0;f[ia>>2]=Ua;K=Oa-Ua+256|0;if(K>>>0<769)je=h[331268+K>>0]|0;else je=0;K=je+Ua|0;f[ia>>2]=K;Ua=Oa-je|0;f[ma>>2]=Ua;Oa=G-Ta+256|0;if(Oa>>>0<769)ke=h[331268+Oa>>0]|0;else ke=0;Oa=ke+Ta|0;f[pa>>2]=Oa;Ta=G-ke|0;f[ka>>2]=Ta;G=Ta-K+256|0;if(G>>>0<769)le=h[331268+G>>0]|0;else le=0;G=le+K|0;f[ia>>2]=G;K=Ta-le|0;f[ka>>2]=K;Ta=Sa-Ua+256|0;if(Ta>>>0<769)me=h[331268+Ta>>0]|0;else me=0;Ta=me+Ua|0;f[ma>>2]=Ta;Ua=Sa-me|0;f[na>>2]=Ua;Sa=Ma-G+256|0;if(Sa>>>0<769)ne=h[331268+Sa>>0]|0;else ne=0;Sa=ne+G|0;f[ia>>2]=Sa;G=Ma-ne|0;f[ja>>2]=G;Ma=G-Ta+256|0;if(Ma>>>0<769)oe=h[331268+Ma>>0]|0;else oe=0;Ma=oe+Ta|0;f[ma>>2]=Ma;Ta=G-oe|0;f[ja>>2]=Ta;G=L-K+256|0;if(G>>>0<769)pe=h[331268+G>>0]|0;else pe=0;G=pe+K|0;f[ka>>2]=G;K=L-pe|0;f[va>>2]=K;L=G-Oa+256|0;if(L>>>0<769)qe=h[331268+L>>0]|0;else qe=0;L=qe+Oa|0;f[pa>>2]=L;Oa=G-qe|0;f[ka>>2]=Oa;G=K-Ta+256|0;if(G>>>0<769)re=h[331268+G>>0]|0;else re=0;G=re+Ta|0;f[ja>>2]=G;Ta=K-re|0;f[va>>2]=Ta;K=Ma-Oa+256|0;if(K>>>0<769)se=h[331268+K>>0]|0;else se=0;K=se+Oa|0;f[ka>>2]=K;Oa=Ma-se|0;f[ma>>2]=Oa;Ma=Sa-L+256|0;if(Ma>>>0<769)te=h[331268+Ma>>0]|0;else te=0;Ma=te+L|0;f[pa>>2]=Ma;L=Sa-te|0;f[ia>>2]=L;Sa=Qa-Ua+256|0;if(Sa>>>0<769)ue=h[331268+Sa>>0]|0;else ue=0;Sa=ue+Ua|0;f[na>>2]=Sa;Ua=Qa-ue|0;f[qa>>2]=Ua;Qa=Ka-K+256|0;if(Qa>>>0<769)ve=h[331268+Qa>>0]|0;else ve=0;Qa=ve+K|0;f[ka>>2]=Qa;K=Ka-ve|0;f[ra>>2]=K;Ka=K-Sa+256|0;if(Ka>>>0<769)we=h[331268+Ka>>0]|0;else we=0;Ka=we+Sa|0;f[na>>2]=Ka;Sa=K-we|0;f[ra>>2]=Sa;K=Za-G+256|0;if(K>>>0<769)xe=h[331268+K>>0]|0;else xe=0;K=xe+G|0;f[ja>>2]=K;G=Za-xe|0;f[la>>2]=G;Za=K-Ma+256|0;if(Za>>>0<769)ye=h[331268+Za>>0]|0;else ye=0;Za=ye+Ma|0;f[pa>>2]=Za;Ma=K-ye|0;f[ja>>2]=Ma;K=G-Sa+256|0;if(K>>>0<769)ze=h[331268+K>>0]|0;else ze=0;K=ze+Sa|0;f[ra>>2]=K;Sa=G-ze|0;f[la>>2]=Sa;G=Ka-Ma+256|0;if(G>>>0<769)Ae=h[331268+G>>0]|0;else Ae=0;G=Ae+Ma|0;f[ja>>2]=G;Ma=Ka-Ae|0;f[na>>2]=Ma;Ka=Qa-Za+256|0;if(Ka>>>0<769)Be=h[331268+Ka>>0]|0;else Be=0;Ka=Be+Za|0;f[pa>>2]=Ka;Za=Qa-Be|0;f[ka>>2]=Za;Qa=M-Ta+256|0;if(Qa>>>0<769)Ce=h[331268+Qa>>0]|0;else Ce=0;Qa=Ce+Ta|0;f[va>>2]=Qa;Ta=M-Ce|0;f[y>>2]=Ta;M=Ya-L+256|0;if(M>>>0<769)De=h[331268+M>>0]|0;else De=0;M=De+L|0;f[ia>>2]=M;L=Ya-De|0;f[oa>>2]=L;Ya=L-Qa+256|0;if(Ya>>>0<769)Ee=h[331268+Ya>>0]|0;else Ee=0;Ya=Ee+Qa|0;f[va>>2]=Ya;Qa=L-Ee|0;f[oa>>2]=Qa;L=N-Oa+256|0;if(L>>>0<769)Fe=h[331268+L>>0]|0;else Fe=0;L=Fe+Oa|0;f[ma>>2]=L;Oa=N-Fe|0;f[sa>>2]=Oa;N=Oa-Qa+256|0;if(N>>>0<769)Ge=h[331268+N>>0]|0;else Ge=0;N=Ge+Qa|0;f[oa>>2]=N;Qa=Oa-Ge|0;f[sa>>2]=Qa;Oa=Ya-L+256|0;if(Oa>>>0<769)He=h[331268+Oa>>0]|0;else He=0;Oa=He+L|0;f[ma>>2]=Oa;L=Ya-He|0;f[va>>2]=L;Ya=Ta-Sa+256|0;if(Ya>>>0<769)Ie=h[331268+Ya>>0]|0;else Ie=0;Ya=Ie+Sa|0;f[la>>2]=Ya;Sa=Ta-Ie|0;f[y>>2]=Sa;Ta=Qa-K+256|0;if(Ta>>>0<769)Je=h[331268+Ta>>0]|0;else Je=0;Ta=Je+K|0;f[ra>>2]=Ta;K=Qa-Je|0;f[sa>>2]=K;Qa=N-Ma+256|0;if(Qa>>>0<769)Ke=h[331268+Qa>>0]|0;else Ke=0;Qa=Ke+Ma|0;f[na>>2]=Qa;Ma=N-Ke|0;f[oa>>2]=Ma;N=L-G+256|0;if(N>>>0<769)Le=h[331268+N>>0]|0;else Le=0;N=Le+G|0;f[ja>>2]=N;G=L-Le|0;f[va>>2]=G;L=Oa-Za+256|0;if(L>>>0<769)Me=h[331268+L>>0]|0;else Me=0;L=Me+Za|0;f[ka>>2]=L;Za=Oa-Me|0;f[ma>>2]=Za;Oa=M-Ka+256|0;if(Oa>>>0<769)Ne=h[331268+Oa>>0]|0;else Ne=0;Oa=Ne+Ka|0;f[pa>>2]=Oa;Ka=M-Ne|0;f[ia>>2]=Ka;M=Wa-Ua+256|0;if(M>>>0<769)Oe=h[331268+M>>0]|0;else Oe=0;M=Oe+Ua|0;f[qa>>2]=M;f[j>>2]=Wa-Oe;Wa=Na-N+256|0;if(Wa>>>0<769)Pe=h[331268+Wa>>0]|0;else Pe=0;f[ja>>2]=Pe+N;N=Na-Pe|0;f[J>>2]=N;Na=N-M+256|0;if(Na>>>0<769)Qe=h[331268+Na>>0]|0;else Qe=0;Na=Qe+M|0;f[qa>>2]=Na;f[J>>2]=N-Qe;N=La-Ta+256|0;if(N>>>0<769)Re=h[331268+N>>0]|0;else Re=0;N=Re+Ta|0;f[ra>>2]=N;f[Ga>>2]=La-Re;La=N-Oa+256|0;if(La>>>0<769)Se=h[331268+La>>0]|0;else Se=0;f[pa>>2]=Se+Oa;Oa=N-Se|0;f[ra>>2]=Oa;N=Na-Oa+256|0;if(N>>>0<769)Te=h[331268+N>>0]|0;else Te=0;f[ra>>2]=Te+Oa;Oa=Na-Te|0;f[qa>>2]=Oa;Na=B-Ya+256|0;if(Na>>>0<769)Ue=h[331268+Na>>0]|0;else Ue=0;Na=Ue+Ya|0;f[la>>2]=Na;f[Ba>>2]=B-Ue;B=D-L+256|0;if(B>>>0<769)Ve=h[331268+B>>0]|0;else Ve=0;f[ka>>2]=Ve+L;L=D-Ve|0;f[ha>>2]=L;D=L-Na+256|0;if(D>>>0<769)We=h[331268+D>>0]|0;else We=0;f[la>>2]=We+Na;Na=L-We|0;f[ha>>2]=Na;L=Pa-Qa+256|0;if(L>>>0<769)Xe=h[331268+L>>0]|0;else Xe=0;f[na>>2]=Xe+Qa;Qa=Pa-Xe|0;f[ua>>2]=Qa;Pa=Qa-Na+256|0;if(Pa>>>0<769)Ye=h[331268+Pa>>0]|0;else Ye=0;Pa=Ye+Na|0;f[ha>>2]=Pa;f[ua>>2]=Qa-Ye;Qa=Pa-Oa+256|0;if(Qa>>>0<769)Ze=h[331268+Qa>>0]|0;else Ze=0;Qa=Ze+Oa|0;f[qa>>2]=Qa;f[ha>>2]=Pa-Ze;Pa=Ra-Sa+256|0;if(Pa>>>0<769)_e=h[331268+Pa>>0]|0;else _e=0;Pa=_e+Sa|0;f[y>>2]=Pa;f[o>>2]=Ra-_e;Ra=Ja-Za+256|0;if(Ra>>>0<769)$e=h[331268+Ra>>0]|0;else $e=0;f[ma>>2]=$e+Za;Za=Ja-$e|0;f[ya>>2]=Za;Ja=Za-Pa+256|0;if(Ja>>>0<769)af=h[331268+Ja>>0]|0;else af=0;Ja=af+Pa|0;f[y>>2]=Ja;f[ya>>2]=Za-af;Za=A-Ma+256|0;if(Za>>>0<769)bf=h[331268+Za>>0]|0;else bf=0;Za=bf+Ma|0;f[oa>>2]=Za;f[Fa>>2]=A-bf;A=Ja-Za+256|0;if(A>>>0<769)cf=h[331268+A>>0]|0;else cf=0;f[oa>>2]=cf+Za;Za=Ja-cf|0;f[y>>2]=Za;Ja=F-K+256|0;if(Ja>>>0<769)df=h[331268+Ja>>0]|0;else df=0;Ja=df+K|0;f[sa>>2]=Ja;f[Da>>2]=F-df;F=Xa-Ka+256|0;if(F>>>0<769)ef=h[331268+F>>0]|0;else ef=0;f[ia>>2]=ef+Ka;Ka=Xa-ef|0;f[za>>2]=Ka;Xa=Ka-Ja+256|0;if(Xa>>>0<769)ff=h[331268+Xa>>0]|0;else ff=0;f[sa>>2]=ff+Ja;Ja=Ka-ff|0;f[za>>2]=Ja;Ka=Va-G+256|0;if(Ka>>>0<769)gf=h[331268+Ka>>0]|0;else gf=0;f[va>>2]=gf+G;G=Va-gf|0;f[Ca>>2]=G;Va=G-Ja+256|0;if(Va>>>0<769)hf=h[331268+Va>>0]|0;else hf=0;Va=hf+Ja|0;f[za>>2]=Va;f[Ca>>2]=G-hf;G=Va-Za+256|0;if(G>>>0<769)jf=h[331268+G>>0]|0;else jf=0;f[y>>2]=jf+Za;Za=Va-jf|0;f[za>>2]=Za;Va=Za-Qa+256|0;if(Va>>>0<769)kf=h[331268+Va>>0]|0;else kf=0;b[H+ed>>0]=kf+Qa;Qa=ed+1|0;if((ed|0)<(Ha|0))ed=Qa;else{I=Qa;C=r;continue b}}}if((l|0)==(p|0))break;else H=H+n|0}u=e;return}default:{u=e;return}}}function Kpa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,W=0,X=0.0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0,ea=0,fa=0;i=u;u=u+384|0;j=i+104|0;k=i+88|0;l=i+328|0;m=i+32|0;o=i+280|0;q=i;r=i+272|0;s=i+320|0;t=i+216|0;v=i+160|0;_$(r,76404);QR(s,a,-1);KS(c,s,RR(a,-1)|0,-1,0,0);do if((NS(a)|0)==65536){s=f[a+4>>2]|0;f[t>>2]=f[s>>2];w=t+4|0;x=s+4|0;f[w>>2]=f[x>>2];y=t+8|0;f[y>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];f[t+24>>2]=f[s+24>>2];f[t+28>>2]=f[s+28>>2];f[t+32>>2]=f[s+32>>2];z=f[s+36>>2]|0;f[t+36>>2]=z;f[t+40>>2]=y;y=t+48|0;A=t+44|0;f[A>>2]=y;f[y>>2]=0;f[t+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[s+44>>2]|0;y=f[A>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[w>>2]=0;BR(t,s);break}}else OR(t,a,-1);while(0);do if((NS(c)|0)==65536){a=f[c+4>>2]|0;f[v>>2]=f[a>>2];s=v+4|0;w=a+4|0;f[s>>2]=f[w>>2];x=v+8|0;f[x>>2]=f[a+8>>2];f[v+12>>2]=f[a+12>>2];f[v+16>>2]=f[a+16>>2];f[v+20>>2]=f[a+20>>2];f[v+24>>2]=f[a+24>>2];f[v+28>>2]=f[a+28>>2];f[v+32>>2]=f[a+32>>2];y=f[a+36>>2]|0;f[v+36>>2]=y;f[v+40>>2]=x;x=v+48|0;A=v+44|0;f[A>>2]=x;f[x>>2]=0;f[v+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[a+44>>2]|0;x=f[A>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[s>>2]=0;BR(v,a);break}}else OR(v,c,-1);while(0);c=f[t>>2]|0;switch(c&7){case 0:{a=(c>>>3&511)+1|0;s=f[f[t+40>>2]>>2]|0;switch(c&4095){case 16:case 0:{if((f[t+16>>2]|0)==(f[v+16>>2]|0))B=18;break}default:B=18}if((B|0)==18){f[j>>2]=0;f[j+4>>2]=0;K1a(c$(j,140)|0,330367,140)|0;j$(-215,j,330508,327502,3457);d$(j)}C=!(e<=0.0)?e:1.0;D=!(g<=0.0)?g:1.0;E=-.5/(C*C);C=-.5/(D*D);if((d|0)<1)F=rNa(D*1.5)|0;else F=d>>>1;w=(F|0)>1?F:1;F=w<<1|1;f[j>>2]=1124007936;x=j+4|0;A=j+8|0;y=j+40|0;G=x;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[y>>2]=A;A=j+48|0;z=j+44|0;f[z>>2]=A;f[A>>2]=0;f[j+52>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=t;I=l+8|0;f[I>>2]=0;f[I+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=j;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;mL(k,l,w,w,w,w,h,m);I=a<<8;J=a<<10;K=NYa(J)|0;F1a(K|0,0,J|0)|0;J=Y(F,F)|0;f[k>>2]=0;F=k+4|0;f[F>>2]=0;f[k+8>>2]=0;if(J>>>0>1073741823)gXa(k);N=J<<2;O=NYa(N)|0;f[k>>2]=O;P=O+(J<<2)|0;f[k+8>>2]=P;F1a(O|0,0,N|0)|0;f[F>>2]=P;P=NYa(N)|0;F1a(P|0,0,N|0)|0;N=0;do{D=+V(+(E*+(Y(N,N)|0)));n[K+(N<<2)>>2]=D;N=N+1|0}while((N|0)!=(I|0));I=0-w|0;if((w|0)<(I|0))Q=0;else{E=+(w|0);N=f[A>>2]|0;J=I;R=0;while(1){D=+(J|0);S=D*D;T=Y(J,N)|0;U=I;W=R;while(1){D=+(U|0);X=+M(+(S+D*D));if(X>E)Z=W;else{_=(Y(U,a)|0)+T|0;D=+V(+(C*(X*X)));n[O+(W<<2)>>2]=D;f[P+(W<<2)>>2]=_;Z=W+1|0}if((U|0)<(w|0)){U=U+1|0;W=Z}else break}if((J|0)<(w|0)){J=J+1|0;R=Z}else{Q=Z;break}}}f[l>>2]=76432;f[l+4>>2]=j;f[l+8>>2]=v;f[l+12>>2]=w;f[l+16>>2]=Q;f[l+20>>2]=P;f[l+24>>2]=O;f[l+28>>2]=K;f[m>>2]=0;f[m+4>>2]=s;s=f[v+4>>2]|0;if((s|0)<3)$=Y(f[v+12>>2]|0,f[v+8>>2]|0)|0;else{O=f[v+40>>2]|0;Q=0;w=1;while(1){Z=Y(f[O+(Q<<2)>>2]|0,w)|0;Q=Q+1|0;if((Q|0)==(s|0)){$=Z;break}else w=Z}}_U(m,l,+($>>>0)*.0000152587890625);PYa(P);P=f[k>>2]|0;if(P|0){$=f[F>>2]|0;if(($|0)!=(P|0))f[F>>2]=$+(~(($+-4-P|0)>>>2)<<2);PYa(P)}PYa(K);K=j+36|0;P=f[K>>2]|0;if(P|0?($=P+12|0,P=f[$>>2]|0,f[$>>2]=P+-1,(P|0)==1):0)CR(j);f[K>>2]=0;K=j+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[x>>2]|0)>0){K=f[y>>2]|0;y=0;do{f[K+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[x>>2]|0))}x=f[z>>2]|0;if((x|0)!=(A|0))ZF(x);break}case 5:{x=(c>>>3&511)+1|0;p[j>>3]=-1.0;p[k>>3]=1.0;A=f[f[t+40>>2]>>2]|0;switch(c&4095){case 21:case 5:{if((f[t+16>>2]|0)==(f[v+16>>2]|0))B=52;break}default:B=52}if((B|0)==52){f[l>>2]=0;f[l+4>>2]=0;K1a(c$(l,140)|0,330527,140)|0;j$(-215,l,330668,327502,3716);d$(l)}C=!(e<=0.0)?e:1.0;e=!(g<=0.0)?g:1.0;g=-.5/(C*C);E=-.5/(e*e);if((d|0)<1)aa=rNa(e*1.5)|0;else aa=d>>>1;d=(aa|0)>1?aa:1;aa=d<<1|1;kS(m,t,1,0);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=m;yZ(l,j,k,0,0,fT()|0);B=m+36|0;c=f[B>>2]|0;if(c|0?(z=c+12|0,c=f[z>>2]|0,f[z>>2]=c+-1,(c|0)==1):0)CR(m);f[B>>2]=0;B=m+16|0;c=m+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[c>>2]|0)>0){B=f[m+40>>2]|0;z=0;do{f[B+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[c>>2]|0))}c=f[m+44>>2]|0;if((c|0)!=(m+48|0))ZF(c);if(!(+L(+(+p[j>>3]-+p[k>>3]))<1.1920928955078125e-07)){f[l>>2]=1124007936;c=l+4|0;z=l+8|0;B=l+40|0;G=c;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[B>>2]=z;z=l+48|0;y=l+44|0;f[y>>2]=z;f[z>>2]=0;f[l+52>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=t;K=o+8|0;f[K>>2]=0;f[K+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=l;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q+16>>2]=0;f[q+20>>2]=0;f[q+24>>2]=0;f[q+28>>2]=0;mL(m,o,d,d,d,d,h,q);h=m+8|0;f[h>>2]=0;f[h+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=l;xN(m,C*-5.0);h=Y(aa,aa)|0;f[m>>2]=0;aa=m+4|0;f[aa>>2]=0;f[m+8>>2]=0;if(h>>>0>1073741823)gXa(m);K=h<<2;P=NYa(K)|0;f[m>>2]=P;$=P+(h<<2)|0;f[m+8>>2]=$;F1a(P|0,0,K|0)|0;f[aa>>2]=$;$=NYa(K)|0;F1a($|0,0,K|0)|0;C=+p[k>>3];e=+p[j>>3];k=x<<12;K=k|2;h=K<<2;F=NYa(h)|0;F1a(F|0,0,h|0)|0;S=+(k|0)/(+(x|0)*(C-e));k=0;e=1.0;while(1){if(e>0.0){C=+(k|0)/S;D=+V(+(g*(C*C)));ba=D;ca=D}else{ba=0.0;ca=e}n[F+(k<<2)>>2]=ba;k=k+1|0;if((k|0)==(K|0))break;else e=ca}K=0-d|0;if((d|0)<(K|0))da=0;else{ca=+(d|0);k=(f[z>>2]|0)>>>2;h=K;w=0;while(1){e=+(h|0);ba=e*e;s=Y(h,k)|0;Q=K;O=w;while(1){e=+(Q|0);g=+M(+(ba+e*e));if(g>ca)ea=O;else{Z=(Y(Q,x)|0)+s|0;e=+V(+(E*(g*g)));n[P+(O<<2)>>2]=e;f[$+(O<<2)>>2]=Z;ea=O+1|0}if((Q|0)<(d|0)){Q=Q+1|0;O=ea}else break}if((h|0)<(d|0)){h=h+1|0;w=ea}else{da=ea;break}}}f[o>>2]=76452;f[o+4>>2]=x;f[o+8>>2]=d;f[o+12>>2]=da;f[o+16>>2]=$;f[o+20>>2]=l;f[o+24>>2]=v;n[o+28>>2]=S;f[o+32>>2]=P;f[o+36>>2]=F;f[q>>2]=0;f[q+4>>2]=A;A=f[v+4>>2]|0;if((A|0)<3)fa=Y(f[v+12>>2]|0,f[v+8>>2]|0)|0;else{P=f[v+40>>2]|0;da=0;d=1;while(1){x=Y(f[P+(da<<2)>>2]|0,d)|0;da=da+1|0;if((da|0)==(A|0)){fa=x;break}else d=x}}_U(q,o,+(fa>>>0)*.0000152587890625);PYa(F);PYa($);$=f[m>>2]|0;if($|0){m=f[aa>>2]|0;if((m|0)!=($|0))f[aa>>2]=m+(~((m+-4-$|0)>>>2)<<2);PYa($)}$=l+36|0;m=f[$>>2]|0;if(m|0?(aa=m+12|0,m=f[aa>>2]|0,f[aa>>2]=m+-1,(m|0)==1):0)CR(l);f[$>>2]=0;$=l+16|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[c>>2]|0)>0){$=f[B>>2]|0;B=0;do{f[$+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[c>>2]|0))}c=f[y>>2]|0;if((c|0)!=(z|0))ZF(c)}else{c=l+8|0;f[c>>2]=0;f[c+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=v;eL(t,l)}break}default:{f[j>>2]=0;f[j+4>>2]=0;G=c$(j,61)|0;l=330688;H=G+61|0;do{b[G>>0]=b[l>>0]|0;G=G+1|0;l=l+1|0}while((G|0)<(H|0));j$(-210,j,330750,327502,3912);d$(j)}}j=v+36|0;l=f[j>>2]|0;if(l|0?(G=l+12|0,l=f[G>>2]|0,f[G>>2]=l+-1,(l|0)==1):0)CR(v);f[j>>2]=0;j=v+16|0;l=v+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[l>>2]|0)>0){j=f[v+40>>2]|0;G=0;do{f[j+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[l>>2]|0))}l=f[v+44>>2]|0;if((l|0)!=(v+48|0))ZF(l);l=t+36|0;v=f[l>>2]|0;if(v|0?(G=v+12|0,v=f[G>>2]|0,f[G>>2]=v+-1,(v|0)==1):0)CR(t);f[l>>2]=0;l=t+16|0;v=t+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[v>>2]|0)>0){l=f[t+40>>2]|0;G=0;do{f[l+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[v>>2]|0))}v=f[t+44>>2]|0;if((v|0)!=(t+48|0))ZF(v);if(!(f[r+4>>2]|0)){u=i;return}u=i;return}function Lpa(a){a=a|0;PYa(a);return}function Mpa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0.0,K=0.0,M=0.0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0,$=0.0,aa=0.0;d=u;u=u+16|0;e=d;g=a+24|0;h=f[g>>2]|0;i=f[(f[h+40>>2]|0)+4>>2]|0;j=f[c>>2]|0;k=c+4|0;if((j|0)>=(f[k>>2]|0)){u=d;return}c=a+20|0;l=a+8|0;m=a+4|0;o=e+4|0;p=i*3|0;q=(i|0)>0;r=a+12|0;s=a+16|0;t=a+28|0;v=a+32|0;w=a+36|0;a=h;h=j;while(1){j=f[c>>2]|0;x=f[l>>2]|0;y=(f[j+16>>2]|0)+(Y(f[f[j+44>>2]>>2]|0,x+h|0)|0)|0;j=f[m>>2]|0;z=y+((Y(j,x)|0)<<2)|0;x=(f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,h)|0)|0;a:do switch(j|0){case 1:{if(q){y=f[r>>2]|0;if((y|0)<=0){A=0;while(1){n[x+(A<<2)>>2]=C;A=A+1|0;if((A|0)==(i|0))break a}}A=f[s>>2]|0;B=f[v>>2]|0;D=f[w>>2]|0;E=0;do{F=+n[z+(E<<2)>>2];G=+n[t>>2];H=0;I=0.0;J=0.0;do{K=+n[z+((f[A+(H<<2)>>2]|0)+E<<2)>>2];M=+L(+(K-F))*G;N=~~M;O=N-(+(N|0)>M&1)|0;P=+n[D+(O<<2)>>2];Q=+n[B+(H<<2)>>2]*(P+(+n[D+(O+1<<2)>>2]-P)*(M-+(O|0)));I=I+K*Q;J=J+Q;H=H+1|0}while((H|0)<(y|0));n[x+(E<<2)>>2]=I/J;E=E+1|0}while((E|0)!=(i|0))}break}case 3:{R=12;break}default:{f[e>>2]=0;f[o>>2]=0;E=c$(e,7)|0;b[E>>0]=b[330766]|0;b[E+1>>0]=b[330767]|0;b[E+2>>0]=b[330768]|0;b[E+3>>0]=b[330769]|0;b[E+4>>0]=b[330770]|0;b[E+5>>0]=b[330771]|0;b[E+6>>0]=b[330772]|0;j$(-215,e,373355,327502,3601);d$(e);R=12}}while(0);b:do if((R|0)==12?(R=0,q):0){j=f[r>>2]|0;if((j|0)<=0){E=0;while(1){n[x+(E<<2)>>2]=C;n[x+(E+1<<2)>>2]=C;n[x+(E+2<<2)>>2]=C;E=E+3|0;if((E|0)>=(p|0))break b}}E=f[s>>2]|0;y=f[v>>2]|0;D=f[w>>2]|0;B=0;do{A=z+(B<<2)|0;G=+n[A>>2];H=B+1|0;F=+n[z+(H<<2)>>2];O=B+2|0;Q=+n[z+(O<<2)>>2];K=+n[t>>2];N=0;M=0.0;P=0.0;S=0.0;T=0.0;do{U=A+(f[E+(N<<2)>>2]<<2)|0;V=+n[U>>2];W=+n[U+4>>2];X=+n[U+8>>2];Z=(+L(+(V-G))+ +L(+(W-F))+ +L(+(X-Q)))*K;U=~~Z;_=U-(+(U|0)>Z&1)|0;$=+n[D+(_<<2)>>2];aa=+n[y+(N<<2)>>2]*($+(+n[D+(_+1<<2)>>2]-$)*(Z-+(_|0)));M=M+V*aa;P=P+W*aa;S=S+X*aa;T=T+aa;N=N+1|0}while((N|0)<(j|0));K=1.0/T;n[x+(B<<2)>>2]=K*M;n[x+(H<<2)>>2]=P*K;n[x+(O<<2)>>2]=S*K;B=B+3|0}while((B|0)<(p|0))}while(0);x=h+1|0;if((x|0)>=(f[k>>2]|0))break;a=f[g>>2]|0;h=x}u=d;return}function Npa(a){a=a|0;PYa(a);return}function Opa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0;d=a+8|0;e=f[d>>2]|0;g=(f[e>>2]|0)>>>3&511;i=g+1|0;j=f[(f[e+40>>2]|0)+4>>2]|0;k=f[c>>2]|0;l=c+4|0;if((k|0)>=(f[l>>2]|0))return;c=a+4|0;m=a+12|0;o=(g|0)==0;g=(j|0)>0;p=a+16|0;q=a+20|0;r=a+24|0;s=a+28|0;a=j*3|0;t=e;e=k;while(1){k=f[c>>2]|0;u=f[m>>2]|0;v=(f[k+16>>2]|0)+(Y(f[f[k+44>>2]>>2]|0,u+e|0)|0)+(Y(u,i)|0)|0;u=(f[t+16>>2]|0)+(Y(f[f[t+44>>2]>>2]|0,e)|0)|0;if(o){if(g){k=0;do{w=h[v+k>>0]|0;x=f[p>>2]|0;if((x|0)>0){y=f[q>>2]|0;z=f[r>>2]|0;A=f[s>>2]|0;B=0;C=0.0;D=0.0;while(1){E=b[v+((f[y+(B<<2)>>2]|0)+k)>>0]|0;F=(E&255)-w|0;G=+n[z+(B<<2)>>2]*+n[A+(((F|0)>-1?F:0-F|0)<<2)>>2];H=C+ +(E&255)*G;I=D+G;B=B+1|0;if((B|0)>=(x|0)){J=H;K=I;break}else{C=H;D=I}}}else{J=0.0;K=0.0}x=(wNa(J/K)|0)&255;b[u+k>>0]=x;k=k+1|0}while((k|0)!=(j|0))}}else if(g){k=0;do{x=v+k|0;B=h[x>>0]|0;A=k+1|0;z=h[v+A>>0]|0;w=k+2|0;y=h[v+w>>0]|0;E=f[p>>2]|0;if((E|0)>0){F=f[q>>2]|0;L=f[r>>2]|0;M=f[s>>2]|0;N=0;D=0.0;C=0.0;I=0.0;H=0.0;while(1){O=x+(f[F+(N<<2)>>2]|0)|0;P=b[O>>0]|0;Q=b[O+1>>0]|0;R=b[O+2>>0]|0;O=(P&255)-B|0;S=(Q&255)-z|0;T=(R&255)-y|0;G=+n[L+(N<<2)>>2]*+n[M+(((S|0)>-1?S:0-S|0)+((O|0)>-1?O:0-O|0)+((T|0)>-1?T:0-T|0)<<2)>>2];U=D+ +(P&255)*G;V=C+ +(Q&255)*G;W=I+ +(R&255)*G;X=H+G;N=N+1|0;if((N|0)>=(E|0)){Z=U;_=V;$=W;aa=X;break}else{D=U;C=V;I=W;H=X}}}else{Z=0.0;_=0.0;$=0.0;aa=0.0}H=1.0/aa;E=wNa(Z*H)|0;N=wNa(_*H)|0;M=wNa($*H)|0;b[u+k>>0]=E;b[u+A>>0]=N;b[u+w>>0]=M;k=k+3|0}while((k|0)<(a|0))}k=e+1|0;if((k|0)>=(f[l>>2]|0))break;t=f[d>>2]|0;e=k}return}function Ppa(a,b,c,d,e,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,v=0;p=u;u=u+16|0;q=p;r=(a|0)==0;s=r&(b|0)==4;t=(c|0)==6;if(s&t){Qpa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}v=(c|0)==5;if(s&v){Rpa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if(s&(c|0)==4){Spa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}c=(b|0)==5;s=r&c;if(s&t){Tpa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if(s&v){Upa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}s=(b|0)==6;if(r&s&t){Vpa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if((a|0)==2&s&t){Wpa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if((a|0)==3&s&t){Xpa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}r=(a|0)==5;b=r&c;if(b&t){Ypa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if(b&v){Zpa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if(r&s&t){_pa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if((a|0)==6&s&t){$pa(d,e,g,h,i,j,k,l,m,n,o);u=p;return}else{f[q>>2]=0;f[q+4>>2]=0;j$(-210,q,330919,330928,488);d$(q);u=p;return}}function Qpa(a,c,d,e,g,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;o=u;u=u+1072|0;q=0-n|0;r=o;s=e>>>2;e=k>>>2;k=0-e|0;t=i>>>3;i=Y(n,l)|0;l=i+n|0;v=l<<2;F1a(d|0,0,v|0)|0;w=d+(s+n<<2)|0;if(!g)x=0;else{F1a(g|0,0,l<<3|0)|0;x=g+(t+n<<3)|0}if(!j)y=0;else{F1a(j|0,0,v|0)|0;y=j+(e+n<<2)|0}j=(y|0)==0;if((x|0)==0&j){if((m|0)<=0){u=o;return}v=(i|0)>0;g=c-n|0;z=s-n|0;if((n|0)<=0){u=o;return}A=n+-1|0;B=n<<2;C=a;D=w;E=0;while(1){if(v){F=0;G=C;H=D;while(1){f[H+(q<<2)>>2]=0;I=0;J=0;do{I=(h[G+J>>0]|0)+I|0;f[H+(J<<2)>>2]=I+(f[H+(J-s<<2)>>2]|0);J=J+n|0}while((J|0)<(i|0));F=F+1|0;if((F|0)==(n|0))break;else{G=G+1|0;H=H+4|0}}}else F1a(D+(q<<2)|0,0,B|0)|0;E=E+1|0;if((E|0)==(m|0))break;else{C=C+A+1+g|0;D=D+(A<<2)+4+(z<<2)|0}}u=o;return}if(j){if((m|0)<=0){u=o;return}j=(i|0)>0;z=c-n|0;A=s-n|0;D=t-n|0;if((n|0)<=0){u=o;return}g=n+-1|0;C=x;E=a;B=w;v=0;while(1){if(j){H=0;G=C;F=E;J=B;while(1){f[J+(q<<2)>>2]=0;p[G+(q<<3)>>3]=0.0;I=0;K=0.0;L=0;do{M=b[F+L>>0]|0;I=(M&255)+I|0;N=+(M&255);K=K+N*N;N=+p[G+(L-t<<3)>>3]+K;f[J+(L<<2)>>2]=I+(f[J+(L-s<<2)>>2]|0);p[G+(L<<3)>>3]=N;L=L+n|0}while((L|0)<(i|0));H=H+1|0;if((H|0)==(n|0))break;else{G=G+8|0;F=F+1|0;J=J+4|0}}}else{J=0;F=C;G=B;while(1){f[G+(q<<2)>>2]=0;p[F+(q<<3)>>3]=0.0;J=J+1|0;if((J|0)==(n|0))break;else{F=F+8|0;G=G+4|0}}}v=v+1|0;if((v|0)==(m|0))break;else{C=C+(g<<3)+8+(D<<3)|0;E=E+g+1+z|0;B=B+(g<<2)+4+(A<<2)|0}}u=o;return}A=r+8|0;f[r>>2]=A;g=r+4|0;f[g>>2]=l;if(l>>>0>264){B=OYa(l>>>0>1073741823?-1:l<<2)|0;f[r>>2]=B;O=B}else O=A;B=(n|0)>0;do if(B){l=(i|0)==(n|0);z=s+(n<<1)|0;E=y+(n<<2)|0;if((i|0)>0){P=O;Q=0;R=x;S=a;T=w;U=y}else{D=O;C=0;v=x;j=w;G=y;while(1){f[G+(q<<2)>>2]=0;f[j+(q<<2)>>2]=0;if(l)f[D+(n<<2)>>2]=0;if(!v)V=0;else{p[v+(q<<3)>>3]=0.0;V=v+8|0}C=C+1|0;if((C|0)==(n|0))break;else{D=D+4|0;v=V;j=j+4|0;G=G+4|0}}W=O+(n<<2)|0;X=V;Z=a+n|0;_=d+(z<<2)|0;$=E;break}while(1){f[U+(q<<2)>>2]=0;f[T+(q<<2)>>2]=0;G=(R|0)!=0;if(G){j=0;K=0.0;v=0;do{D=b[S+v>>0]|0;C=D&255;f[U+(v<<2)>>2]=C;f[P+(v<<2)>>2]=C;j=C+j|0;N=+(D&255);K=K+N*N;f[T+(v<<2)>>2]=j;p[R+(v<<3)>>3]=K;v=v+n|0}while((v|0)<(i|0))}else{v=0;j=0;do{D=h[S+j>>0]|0;f[U+(j<<2)>>2]=D;f[P+(j<<2)>>2]=D;v=D+v|0;f[T+(j<<2)>>2]=v;j=j+n|0}while((j|0)<(i|0))}if(l)f[P+(n<<2)>>2]=0;if(G){p[R+(q<<3)>>3]=0.0;aa=R+8|0}else aa=0;Q=Q+1|0;if((Q|0)==(n|0))break;else{P=P+4|0;R=aa;S=S+1|0;T=T+4|0;U=U+4|0}}W=O+(n<<2)|0;X=aa;Z=a+n|0;_=d+(z<<2)|0;$=E}else{W=O;X=x;Z=a;_=w;$=y}while(0);if((m|0)>1){y=c-n|0;w=s-n|0;a=e-n|0;x=t-n|0;d=0-s|0;aa=0-t|0;U=i-n|0;T=(U|0)>(n|0);S=e+n|0;R=(i|0)>(n|0);i=W;W=X;X=Z;Z=_;_=$;$=1;while(1){P=X+y|0;Q=Z+(w<<2)|0;V=_+(a<<2)|0;l=i+(q<<2)|0;j=(W|0)==0?0:W+(x<<3)|0;if(B){v=Z+(s<<2)|0;D=l;C=0;F=j;J=P;H=Q;L=V;while(1){I=b[J>>0]|0;M=I&255;K=+(I&255);N=K*K;f[H+(q<<2)>>2]=0;I=(F|0)!=0;if(I)p[F+(q<<3)>>3]=0.0;ba=L+(k<<2)|0;f[L+(q<<2)>>2]=f[ba>>2];f[H>>2]=(f[H+(d<<2)>>2]|0)+M;if(I)p[F>>3]=N+ +p[F+(aa<<3)>>3];f[L>>2]=(f[ba>>2]|0)+M+(f[D+(n<<2)>>2]|0);if(T)if(I){ba=M;K=N;ca=M;da=n;while(1){ea=f[D+(da<<2)>>2]|0;f[D+(da-n<<2)>>2]=ea+ca;fa=b[J+da>>0]|0;ga=fa&255;ha=+(fa&255);fa=ga+ba|0;ia=K+ha*ha;f[H+(da<<2)>>2]=fa+(f[H+(da-s<<2)>>2]|0);p[F+(da<<3)>>3]=ia+ +p[F+(da-t<<3)>>3];ja=da+n|0;f[L+(da<<2)>>2]=ga+ea+(f[D+(ja<<2)>>2]|0)+(f[L+(da-S<<2)>>2]|0);if((ja|0)<(U|0)){ba=fa;K=ia;ca=ga;da=ja}else{ka=fa;la=ia;ma=ga;na=ja;break}}}else{da=M;K=N;ca=M;ba=n;while(1){G=f[D+(ba<<2)>>2]|0;f[D+(ba-n<<2)>>2]=G+ca;ja=b[J+ba>>0]|0;ga=ja&255;ia=+(ja&255);ja=ga+da|0;ha=K+ia*ia;f[H+(ba<<2)>>2]=ja+(f[H+(ba-s<<2)>>2]|0);fa=ba+n|0;f[L+(ba<<2)>>2]=ga+G+(f[D+(fa<<2)>>2]|0)+(f[L+(ba-S<<2)>>2]|0);if((fa|0)<(U|0)){da=ja;K=ha;ca=ga;ba=fa}else{ka=ja;la=ha;ma=ga;na=fa;break}}}else{ka=M;la=N;ma=M;na=n}if(R){ba=D+(na<<2)|0;ca=f[ba>>2]|0;f[D+(na-n<<2)>>2]=ca+ma;da=b[J+na>>0]|0;fa=da&255;f[H+(na<<2)>>2]=fa+ka+(f[H+(na-s<<2)>>2]|0);K=+(da&255);if(I)p[F+(na<<3)>>3]=la+K*K+ +p[F+(na-t<<3)>>3];f[L+(na<<2)>>2]=fa+ca+(f[L+(na-S<<2)>>2]|0);f[ba>>2]=fa}F=I?F+8|0:0;C=C+1|0;if((C|0)==(n|0))break;else{D=D+4|0;J=J+1|0;H=H+4|0;L=L+4|0}}oa=i;pa=F;qa=X+c|0;ra=v;sa=_+(e<<2)|0}else{oa=l;pa=j;qa=P;ra=Q;sa=V}$=$+1|0;if(($|0)==(m|0))break;else{i=oa;W=pa;X=qa;Z=ra;_=sa}}}if((O|0)!=(A|0)){QYa(O);f[r>>2]=A;f[g>>2]=264}u=o;return}function Rpa(a,c,d,e,g,i,j,k,l,m,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;p=u;u=u+1072|0;q=0-o|0;r=p;s=e>>>2;e=k>>>2;k=0-e|0;t=i>>>2;i=Y(o,l)|0;l=i+o|0;v=l<<2;F1a(d|0,0,v|0)|0;w=d+(s+o<<2)|0;if(!g)x=0;else{F1a(g|0,0,v|0)|0;x=g+(t+o<<2)|0}if(!j)y=0;else{F1a(j|0,0,v|0)|0;y=j+(e+o<<2)|0}j=(y|0)==0;if((x|0)==0&j){if((m|0)<=0){u=p;return}v=(i|0)>0;g=c-o|0;z=s-o|0;if((o|0)<=0){u=p;return}A=o+-1|0;B=o<<2;C=a;D=w;E=0;while(1){if(v){F=0;G=C;H=D;while(1){f[H+(q<<2)>>2]=0;I=0;J=0;do{I=(h[G+J>>0]|0)+I|0;f[H+(J<<2)>>2]=I+(f[H+(J-s<<2)>>2]|0);J=J+o|0}while((J|0)<(i|0));F=F+1|0;if((F|0)==(o|0))break;else{G=G+1|0;H=H+4|0}}}else F1a(D+(q<<2)|0,0,B|0)|0;E=E+1|0;if((E|0)==(m|0))break;else{C=C+A+1+g|0;D=D+(A<<2)+4+(z<<2)|0}}u=p;return}if(j){if((m|0)<=0){u=p;return}j=(i|0)>0;z=c-o|0;A=s-o|0;D=t-o|0;if((o|0)<=0){u=p;return}g=o+-1|0;C=x;E=a;B=w;v=0;while(1){if(j){H=0;G=C;F=E;J=B;while(1){f[J+(q<<2)>>2]=0;n[G+(q<<2)>>2]=0.0;I=0;K=0.0;L=0;do{M=b[F+L>>0]|0;I=(M&255)+I|0;N=+(M&255);K=K+N*N;N=+n[G+(L-t<<2)>>2]+K;f[J+(L<<2)>>2]=I+(f[J+(L-s<<2)>>2]|0);n[G+(L<<2)>>2]=N;L=L+o|0}while((L|0)<(i|0));H=H+1|0;if((H|0)==(o|0))break;else{G=G+4|0;F=F+1|0;J=J+4|0}}}else{J=0;F=C;G=B;while(1){f[G+(q<<2)>>2]=0;n[F+(q<<2)>>2]=0.0;J=J+1|0;if((J|0)==(o|0))break;else{F=F+4|0;G=G+4|0}}}v=v+1|0;if((v|0)==(m|0))break;else{C=C+(g<<2)+4+(D<<2)|0;E=E+g+1+z|0;B=B+(g<<2)+4+(A<<2)|0}}u=p;return}A=r+8|0;f[r>>2]=A;g=r+4|0;f[g>>2]=l;if(l>>>0>264){B=OYa(l>>>0>1073741823?-1:l<<2)|0;f[r>>2]=B;O=B}else O=A;B=(o|0)>0;do if(B){l=(i|0)==(o|0);z=s+(o<<1)|0;E=y+(o<<2)|0;if((i|0)>0){P=O;Q=0;R=x;S=a;T=w;U=y}else{D=O;C=0;v=x;j=w;G=y;while(1){f[G+(q<<2)>>2]=0;f[j+(q<<2)>>2]=0;if(l)f[D+(o<<2)>>2]=0;if(!v)V=0;else{n[v+(q<<2)>>2]=0.0;V=v+4|0}C=C+1|0;if((C|0)==(o|0))break;else{D=D+4|0;v=V;j=j+4|0;G=G+4|0}}W=O+(o<<2)|0;X=V;Z=a+o|0;_=d+(z<<2)|0;$=E;break}while(1){f[U+(q<<2)>>2]=0;f[T+(q<<2)>>2]=0;G=(R|0)!=0;if(G){j=0;K=0.0;v=0;do{D=b[S+v>>0]|0;C=D&255;f[U+(v<<2)>>2]=C;f[P+(v<<2)>>2]=C;j=C+j|0;N=+(D&255);K=K+N*N;f[T+(v<<2)>>2]=j;n[R+(v<<2)>>2]=K;v=v+o|0}while((v|0)<(i|0))}else{v=0;j=0;do{D=h[S+j>>0]|0;f[U+(j<<2)>>2]=D;f[P+(j<<2)>>2]=D;v=D+v|0;f[T+(j<<2)>>2]=v;j=j+o|0}while((j|0)<(i|0))}if(l)f[P+(o<<2)>>2]=0;if(G){n[R+(q<<2)>>2]=0.0;aa=R+4|0}else aa=0;Q=Q+1|0;if((Q|0)==(o|0))break;else{P=P+4|0;R=aa;S=S+1|0;T=T+4|0;U=U+4|0}}W=O+(o<<2)|0;X=aa;Z=a+o|0;_=d+(z<<2)|0;$=E}else{W=O;X=x;Z=a;_=w;$=y}while(0);if((m|0)>1){y=c-o|0;w=s-o|0;a=e-o|0;x=t-o|0;d=0-s|0;aa=0-t|0;U=i-o|0;T=(U|0)>(o|0);S=e+o|0;R=(i|0)>(o|0);i=W;W=X;X=Z;Z=_;_=$;$=1;while(1){P=X+y|0;Q=Z+(w<<2)|0;V=_+(a<<2)|0;l=i+(q<<2)|0;j=(W|0)==0?0:W+(x<<2)|0;if(B){v=Z+(s<<2)|0;D=l;C=0;F=j;J=P;H=Q;L=V;while(1){I=b[J>>0]|0;M=I&255;K=+(I&255);N=K*K;f[H+(q<<2)>>2]=0;I=(F|0)!=0;if(I)n[F+(q<<2)>>2]=0.0;ba=L+(k<<2)|0;f[L+(q<<2)>>2]=f[ba>>2];f[H>>2]=(f[H+(d<<2)>>2]|0)+M;if(I)n[F>>2]=N+ +n[F+(aa<<2)>>2];f[L>>2]=(f[ba>>2]|0)+M+(f[D+(o<<2)>>2]|0);if(T)if(I){ba=M;K=N;ca=M;da=o;while(1){ea=f[D+(da<<2)>>2]|0;f[D+(da-o<<2)>>2]=ea+ca;fa=b[J+da>>0]|0;ga=fa&255;ha=+(fa&255);fa=ga+ba|0;ia=K+ha*ha;f[H+(da<<2)>>2]=fa+(f[H+(da-s<<2)>>2]|0);n[F+(da<<2)>>2]=ia+ +n[F+(da-t<<2)>>2];ja=da+o|0;f[L+(da<<2)>>2]=ga+ea+(f[D+(ja<<2)>>2]|0)+(f[L+(da-S<<2)>>2]|0);if((ja|0)<(U|0)){ba=fa;K=ia;ca=ga;da=ja}else{ka=fa;la=ia;ma=ga;na=ja;break}}}else{da=M;K=N;ca=M;ba=o;while(1){G=f[D+(ba<<2)>>2]|0;f[D+(ba-o<<2)>>2]=G+ca;ja=b[J+ba>>0]|0;ga=ja&255;ia=+(ja&255);ja=ga+da|0;ha=K+ia*ia;f[H+(ba<<2)>>2]=ja+(f[H+(ba-s<<2)>>2]|0);fa=ba+o|0;f[L+(ba<<2)>>2]=ga+G+(f[D+(fa<<2)>>2]|0)+(f[L+(ba-S<<2)>>2]|0);if((fa|0)<(U|0)){da=ja;K=ha;ca=ga;ba=fa}else{ka=ja;la=ha;ma=ga;na=fa;break}}}else{ka=M;la=N;ma=M;na=o}if(R){ba=D+(na<<2)|0;ca=f[ba>>2]|0;f[D+(na-o<<2)>>2]=ca+ma;da=b[J+na>>0]|0;fa=da&255;f[H+(na<<2)>>2]=fa+ka+(f[H+(na-s<<2)>>2]|0);K=+(da&255);if(I)n[F+(na<<2)>>2]=la+K*K+ +n[F+(na-t<<2)>>2];f[L+(na<<2)>>2]=fa+ca+(f[L+(na-S<<2)>>2]|0);f[ba>>2]=fa}F=I?F+4|0:0;C=C+1|0;if((C|0)==(o|0))break;else{D=D+4|0;J=J+1|0;H=H+4|0;L=L+4|0}}oa=i;pa=F;qa=X+c|0;ra=v;sa=_+(e<<2)|0}else{oa=l;pa=j;qa=P;ra=Q;sa=V}$=$+1|0;if(($|0)==(m|0))break;else{i=oa;W=pa;X=qa;Z=ra;_=sa}}}if((O|0)!=(A|0)){QYa(O);f[r>>2]=A;f[g>>2]=264}u=p;return}function Spa(a,b,c,d,e,g,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;n=u;u=u+1072|0;o=0-m|0;p=n;q=d>>>2;d=j>>>2;j=0-d|0;r=g>>>2;g=Y(m,k)|0;k=g+m|0;s=k<<2;F1a(c|0,0,s|0)|0;t=c+(q+m<<2)|0;if(!e)v=0;else{F1a(e|0,0,s|0)|0;v=e+(r+m<<2)|0}if(!i)w=0;else{F1a(i|0,0,s|0)|0;w=i+(d+m<<2)|0}i=(w|0)==0;if((v|0)==0&i){if((l|0)<=0){u=n;return}s=(g|0)>0;e=b-m|0;x=q-m|0;if((m|0)<=0){u=n;return}y=m+-1|0;z=m<<2;A=a;B=t;C=0;while(1){if(s){D=0;E=A;F=B;while(1){f[F+(o<<2)>>2]=0;G=0;H=0;do{G=(h[E+H>>0]|0)+G|0;f[F+(H<<2)>>2]=G+(f[F+(H-q<<2)>>2]|0);H=H+m|0}while((H|0)<(g|0));D=D+1|0;if((D|0)==(m|0))break;else{E=E+1|0;F=F+4|0}}}else F1a(B+(o<<2)|0,0,z|0)|0;C=C+1|0;if((C|0)==(l|0))break;else{A=A+y+1+e|0;B=B+(y<<2)+4+(x<<2)|0}}u=n;return}if(i){if((l|0)<=0){u=n;return}i=(g|0)>0;x=b-m|0;y=q-m|0;B=r-m|0;if((m|0)<=0){u=n;return}e=m+-1|0;A=v;C=a;z=t;s=0;while(1){if(i){F=0;E=A;D=C;H=z;while(1){f[H+(o<<2)>>2]=0;f[E+(o<<2)>>2]=0;G=0;I=0;J=0;do{K=h[D+J>>0]|0;G=K+G|0;I=(Y(K,K)|0)+I|0;K=I+(f[E+(J-r<<2)>>2]|0)|0;f[H+(J<<2)>>2]=G+(f[H+(J-q<<2)>>2]|0);f[E+(J<<2)>>2]=K;J=J+m|0}while((J|0)<(g|0));F=F+1|0;if((F|0)==(m|0))break;else{E=E+4|0;D=D+1|0;H=H+4|0}}}else{H=0;D=A;E=z;while(1){f[E+(o<<2)>>2]=0;f[D+(o<<2)>>2]=0;H=H+1|0;if((H|0)==(m|0))break;else{D=D+4|0;E=E+4|0}}}s=s+1|0;if((s|0)==(l|0))break;else{A=A+(e<<2)+4+(B<<2)|0;C=C+e+1+x|0;z=z+(e<<2)+4+(y<<2)|0}}u=n;return}y=p+8|0;f[p>>2]=y;e=p+4|0;f[e>>2]=k;if(k>>>0>264){z=OYa(k>>>0>1073741823?-1:k<<2)|0;f[p>>2]=z;L=z}else L=y;z=(m|0)>0;do if(z){k=(g|0)==(m|0);x=q+(m<<1)|0;C=w+(m<<2)|0;if((g|0)>0){M=L;N=0;O=v;P=a;Q=t;R=w}else{B=L;A=0;s=v;i=t;E=w;while(1){f[E+(o<<2)>>2]=0;f[i+(o<<2)>>2]=0;if(k)f[B+(m<<2)>>2]=0;if(!s)S=0;else{f[s+(o<<2)>>2]=0;S=s+4|0}A=A+1|0;if((A|0)==(m|0))break;else{B=B+4|0;s=S;i=i+4|0;E=E+4|0}}T=L+(m<<2)|0;U=S;V=a+m|0;W=c+(x<<2)|0;X=C;break}while(1){f[R+(o<<2)>>2]=0;f[Q+(o<<2)>>2]=0;E=(O|0)!=0;if(E){i=0;s=0;B=0;do{A=h[P+B>>0]|0;f[R+(B<<2)>>2]=A;f[M+(B<<2)>>2]=A;i=A+i|0;s=(Y(A,A)|0)+s|0;f[Q+(B<<2)>>2]=i;f[O+(B<<2)>>2]=s;B=B+m|0}while((B|0)<(g|0))}else{B=0;s=0;do{i=h[P+s>>0]|0;f[R+(s<<2)>>2]=i;f[M+(s<<2)>>2]=i;B=i+B|0;f[Q+(s<<2)>>2]=B;s=s+m|0}while((s|0)<(g|0))}if(k)f[M+(m<<2)>>2]=0;if(E){f[O+(o<<2)>>2]=0;Z=O+4|0}else Z=0;N=N+1|0;if((N|0)==(m|0))break;else{M=M+4|0;O=Z;P=P+1|0;Q=Q+4|0;R=R+4|0}}T=L+(m<<2)|0;U=Z;V=a+m|0;W=c+(x<<2)|0;X=C}else{T=L;U=v;V=a;W=t;X=w}while(0);if((l|0)>1){w=b-m|0;t=q-m|0;a=d-m|0;v=r-m|0;c=0-q|0;Z=0-r|0;R=g-m|0;Q=(R|0)>(m|0);P=d+m|0;O=(g|0)>(m|0);g=T;T=U;U=V;V=W;W=X;X=1;while(1){M=U+w|0;N=V+(t<<2)|0;S=W+(a<<2)|0;k=g+(o<<2)|0;s=(T|0)==0?0:T+(v<<2)|0;if(z){B=V+(q<<2)|0;i=k;A=0;D=s;H=M;F=N;J=S;while(1){G=h[H>>0]|0;I=Y(G,G)|0;f[F+(o<<2)>>2]=0;K=(D|0)!=0;if(K)f[D+(o<<2)>>2]=0;_=J+(j<<2)|0;f[J+(o<<2)>>2]=f[_>>2];f[F>>2]=(f[F+(c<<2)>>2]|0)+G;if(K)f[D>>2]=(f[D+(Z<<2)>>2]|0)+I;f[J>>2]=(f[_>>2]|0)+G+(f[i+(m<<2)>>2]|0);if(Q)if(K){_=G;$=I;aa=G;ba=m;while(1){ca=f[i+(ba<<2)>>2]|0;f[i+(ba-m<<2)>>2]=ca+aa;da=h[H+ba>>0]|0;ea=da+_|0;fa=(Y(da,da)|0)+$|0;f[F+(ba<<2)>>2]=ea+(f[F+(ba-q<<2)>>2]|0);f[D+(ba<<2)>>2]=(f[D+(ba-r<<2)>>2]|0)+fa;ga=ba+m|0;f[J+(ba<<2)>>2]=da+ca+(f[i+(ga<<2)>>2]|0)+(f[J+(ba-P<<2)>>2]|0);if((ga|0)<(R|0)){_=ea;$=fa;aa=da;ba=ga}else{ha=ea;ia=fa;ja=da;ka=ga;break}}}else{ba=G;aa=I;$=G;_=m;while(1){E=f[i+(_<<2)>>2]|0;f[i+(_-m<<2)>>2]=E+$;ga=h[H+_>>0]|0;da=ga+ba|0;fa=(Y(ga,ga)|0)+aa|0;f[F+(_<<2)>>2]=da+(f[F+(_-q<<2)>>2]|0);ea=_+m|0;f[J+(_<<2)>>2]=ga+E+(f[i+(ea<<2)>>2]|0)+(f[J+(_-P<<2)>>2]|0);if((ea|0)<(R|0)){ba=da;aa=fa;$=ga;_=ea}else{ha=da;ia=fa;ja=ga;ka=ea;break}}}else{ha=G;ia=I;ja=G;ka=m}if(O){_=i+(ka<<2)|0;$=f[_>>2]|0;f[i+(ka-m<<2)>>2]=$+ja;aa=h[H+ka>>0]|0;f[F+(ka<<2)>>2]=aa+ha+(f[F+(ka-q<<2)>>2]|0);if(K){ba=(Y(aa,aa)|0)+ia|0;f[D+(ka<<2)>>2]=ba+(f[D+(ka-r<<2)>>2]|0)}f[J+(ka<<2)>>2]=aa+$+(f[J+(ka-P<<2)>>2]|0);f[_>>2]=aa}D=K?D+4|0:0;A=A+1|0;if((A|0)==(m|0))break;else{i=i+4|0;H=H+1|0;F=F+4|0;J=J+4|0}}la=g;ma=D;na=U+b|0;oa=B;pa=W+(d<<2)|0}else{la=k;ma=s;na=M;oa=N;pa=S}X=X+1|0;if((X|0)==(l|0))break;else{g=la;T=ma;U=na;V=oa;W=pa}}}if((L|0)!=(y|0)){QYa(L);f[p>>2]=y;f[e>>2]=264}u=n;return}function Tpa(a,c,d,e,g,i,j,k,l,m,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0;q=u;u=u+1072|0;r=0-o|0;s=q;t=e>>>2;e=k>>>2;k=0-e|0;v=i>>>3;i=Y(o,l)|0;l=i+o|0;w=l<<2;F1a(d|0,0,w|0)|0;x=d+(t+o<<2)|0;if(!g)y=0;else{F1a(g|0,0,l<<3|0)|0;y=g+(v+o<<3)|0}if(!j)z=0;else{F1a(j|0,0,w|0)|0;z=j+(e+o<<2)|0}j=(z|0)==0;if((y|0)==0&j){if((m|0)<=0){u=q;return}w=(i|0)>0;g=c-o|0;A=t-o|0;if((o|0)<=0){u=q;return}B=o+-1|0;C=o<<2;D=a;E=x;F=0;while(1){if(w){G=0;H=D;I=E;while(1){n[I+(r<<2)>>2]=0.0;J=0.0;K=0;do{J=J+ +(h[H+K>>0]|0);n[I+(K<<2)>>2]=+n[I+(K-t<<2)>>2]+J;K=K+o|0}while((K|0)<(i|0));G=G+1|0;if((G|0)==(o|0))break;else{H=H+1|0;I=I+4|0}}}else F1a(E+(r<<2)|0,0,C|0)|0;F=F+1|0;if((F|0)==(m|0))break;else{D=D+B+1+g|0;E=E+(B<<2)+4+(A<<2)|0}}u=q;return}if(j){if((m|0)<=0){u=q;return}j=(i|0)>0;A=c-o|0;B=t-o|0;E=v-o|0;if((o|0)<=0){u=q;return}g=o+-1|0;D=y;F=a;C=x;w=0;while(1){if(j){I=0;H=D;G=F;K=C;while(1){n[K+(r<<2)>>2]=0.0;p[H+(r<<3)>>3]=0.0;J=0.0;L=0.0;M=0;do{N=b[G+M>>0]|0;J=J+ +(N&255);O=+(N&255);L=L+O*O;O=+p[H+(M-v<<3)>>3]+L;n[K+(M<<2)>>2]=+n[K+(M-t<<2)>>2]+J;p[H+(M<<3)>>3]=O;M=M+o|0}while((M|0)<(i|0));I=I+1|0;if((I|0)==(o|0))break;else{H=H+8|0;G=G+1|0;K=K+4|0}}}else{K=0;G=D;H=C;while(1){n[H+(r<<2)>>2]=0.0;p[G+(r<<3)>>3]=0.0;K=K+1|0;if((K|0)==(o|0))break;else{G=G+8|0;H=H+4|0}}}w=w+1|0;if((w|0)==(m|0))break;else{D=D+(g<<3)+8+(E<<3)|0;F=F+g+1+A|0;C=C+(g<<2)+4+(B<<2)|0}}u=q;return}B=s+8|0;f[s>>2]=B;g=s+4|0;f[g>>2]=l;if(l>>>0>264){C=OYa(l>>>0>1073741823?-1:l<<2)|0;f[s>>2]=C;P=C}else P=B;C=(o|0)>0;do if(C){l=(i|0)==(o|0);A=t+(o<<1)|0;F=z+(o<<2)|0;if((i|0)>0){Q=P;R=0;S=y;T=a;U=x;V=z}else{E=P;D=0;w=y;j=x;H=z;while(1){n[H+(r<<2)>>2]=0.0;n[j+(r<<2)>>2]=0.0;if(l)n[E+(o<<2)>>2]=0.0;if(!w)W=0;else{p[w+(r<<3)>>3]=0.0;W=w+8|0}D=D+1|0;if((D|0)==(o|0))break;else{E=E+4|0;w=W;j=j+4|0;H=H+4|0}}X=P+(o<<2)|0;Z=W;_=a+o|0;$=d+(A<<2)|0;aa=F;break}while(1){n[V+(r<<2)>>2]=0.0;n[U+(r<<2)>>2]=0.0;H=(S|0)!=0;if(H){J=0.0;L=0.0;j=0;do{w=b[T+j>>0]|0;O=+(w&255);n[V+(j<<2)>>2]=O;n[Q+(j<<2)>>2]=O;J=J+O;O=+(w&255);L=L+O*O;n[U+(j<<2)>>2]=J;p[S+(j<<3)>>3]=L;j=j+o|0}while((j|0)<(i|0))}else{L=0.0;j=0;do{J=+(h[T+j>>0]|0);n[V+(j<<2)>>2]=J;n[Q+(j<<2)>>2]=J;L=L+J;n[U+(j<<2)>>2]=L;j=j+o|0}while((j|0)<(i|0))}if(l)n[Q+(o<<2)>>2]=0.0;if(H){p[S+(r<<3)>>3]=0.0;ba=S+8|0}else ba=0;R=R+1|0;if((R|0)==(o|0))break;else{Q=Q+4|0;S=ba;T=T+1|0;U=U+4|0;V=V+4|0}}X=P+(o<<2)|0;Z=ba;_=a+o|0;$=d+(A<<2)|0;aa=F}else{X=P;Z=y;_=a;$=x;aa=z}while(0);if((m|0)>1){z=c-o|0;x=t-o|0;a=e-o|0;y=v-o|0;d=0-t|0;ba=0-v|0;V=i-o|0;U=(V|0)>(o|0);T=e+o|0;S=(i|0)>(o|0);i=X;X=Z;Z=_;_=$;$=aa;aa=1;while(1){Q=Z+z|0;R=_+(x<<2)|0;W=$+(a<<2)|0;l=i+(r<<2)|0;j=(X|0)==0?0:X+(y<<3)|0;if(C){w=_+(t<<2)|0;E=l;D=0;G=j;K=Q;I=R;M=W;while(1){N=b[K>>0]|0;L=+(N&255);J=+(N&255);O=J*J;n[I+(r<<2)>>2]=0.0;N=(G|0)!=0;if(N)p[G+(r<<3)>>3]=0.0;ca=M+(k<<2)|0;f[M+(r<<2)>>2]=f[ca>>2];n[I>>2]=L+ +n[I+(d<<2)>>2];if(N)p[G>>3]=O+ +p[G+(ba<<3)>>3];n[M>>2]=L+ +n[ca>>2]+ +n[E+(o<<2)>>2];if(U)if(N){J=L;da=O;ea=L;ca=o;while(1){fa=+n[E+(ca<<2)>>2];n[E+(ca-o<<2)>>2]=ea+fa;ga=b[K+ca>>0]|0;ha=+(ga&255);ia=+(ga&255);ja=J+ha;ka=da+ia*ia;n[I+(ca<<2)>>2]=+n[I+(ca-t<<2)>>2]+ja;p[G+(ca<<3)>>3]=ka+ +p[G+(ca-v<<3)>>3];ga=ca+o|0;n[M+(ca<<2)>>2]=fa+(ha+ +n[E+(ga<<2)>>2]+ +n[M+(ca-T<<2)>>2]);if((ga|0)<(V|0)){J=ja;da=ka;ea=ha;ca=ga}else{la=ja;ma=ka;na=ha;oa=ga;break}}}else{ea=L;da=O;J=L;ca=o;while(1){ha=+n[E+(ca<<2)>>2];n[E+(ca-o<<2)>>2]=J+ha;H=b[K+ca>>0]|0;ka=+(H&255);ja=+(H&255);fa=ea+ka;ia=da+ja*ja;n[I+(ca<<2)>>2]=+n[I+(ca-t<<2)>>2]+fa;H=ca+o|0;n[M+(ca<<2)>>2]=ha+(ka+ +n[E+(H<<2)>>2]+ +n[M+(ca-T<<2)>>2]);if((H|0)<(V|0)){ea=fa;da=ia;J=ka;ca=H}else{la=fa;ma=ia;na=ka;oa=H;break}}}else{la=L;ma=O;na=L;oa=o}if(S){ca=E+(oa<<2)|0;J=+n[ca>>2];n[E+(oa-o<<2)>>2]=na+J;H=b[K+oa>>0]|0;da=+(H&255);n[I+(oa<<2)>>2]=+n[I+(oa-t<<2)>>2]+(la+da);ea=+(H&255);if(N)p[G+(oa<<3)>>3]=ma+ea*ea+ +p[G+(oa-v<<3)>>3];n[M+(oa<<2)>>2]=J+da+ +n[M+(oa-T<<2)>>2];n[ca>>2]=da}G=N?G+8|0:0;D=D+1|0;if((D|0)==(o|0))break;else{E=E+4|0;K=K+1|0;I=I+4|0;M=M+4|0}}pa=i;qa=G;ra=Z+c|0;sa=w;ta=$+(e<<2)|0}else{pa=l;qa=j;ra=Q;sa=R;ta=W}aa=aa+1|0;if((aa|0)==(m|0))break;else{i=pa;X=qa;Z=ra;_=sa;$=ta}}}if((P|0)!=(B|0)){QYa(P);f[s>>2]=B;f[g>>2]=264}u=q;return}function Upa(a,b,c,d,e,g,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;o=u;u=u+1072|0;p=0-m|0;q=o;r=d>>>2;d=j>>>2;j=0-d|0;s=g>>>2;g=Y(m,k)|0;k=g+m|0;t=k<<2;F1a(c|0,0,t|0)|0;v=c+(r+m<<2)|0;if(!e)w=0;else{F1a(e|0,0,t|0)|0;w=e+(s+m<<2)|0}if(!i)x=0;else{F1a(i|0,0,t|0)|0;x=i+(d+m<<2)|0}i=(x|0)==0;if((w|0)==0&i){if((l|0)<=0){u=o;return}t=(g|0)>0;e=b-m|0;y=r-m|0;if((m|0)<=0){u=o;return}z=m+-1|0;A=m<<2;B=a;C=v;D=0;while(1){if(t){E=0;F=B;G=C;while(1){n[G+(p<<2)>>2]=0.0;H=0.0;I=0;do{H=H+ +(h[F+I>>0]|0);n[G+(I<<2)>>2]=+n[G+(I-r<<2)>>2]+H;I=I+m|0}while((I|0)<(g|0));E=E+1|0;if((E|0)==(m|0))break;else{F=F+1|0;G=G+4|0}}}else F1a(C+(p<<2)|0,0,A|0)|0;D=D+1|0;if((D|0)==(l|0))break;else{B=B+z+1+e|0;C=C+(z<<2)+4+(y<<2)|0}}u=o;return}if(i){if((l|0)<=0){u=o;return}i=(g|0)>0;y=b-m|0;z=r-m|0;C=s-m|0;if((m|0)<=0){u=o;return}e=m+-1|0;B=w;D=a;A=v;t=0;while(1){if(i){G=0;F=B;E=D;I=A;while(1){n[I+(p<<2)>>2]=0.0;n[F+(p<<2)>>2]=0.0;H=0.0;J=0.0;K=0;do{L=+(h[E+K>>0]|0);H=H+L;J=J+L*L;L=+n[F+(K-s<<2)>>2]+J;n[I+(K<<2)>>2]=+n[I+(K-r<<2)>>2]+H;n[F+(K<<2)>>2]=L;K=K+m|0}while((K|0)<(g|0));G=G+1|0;if((G|0)==(m|0))break;else{F=F+4|0;E=E+1|0;I=I+4|0}}}else{I=0;E=B;F=A;while(1){n[F+(p<<2)>>2]=0.0;n[E+(p<<2)>>2]=0.0;I=I+1|0;if((I|0)==(m|0))break;else{E=E+4|0;F=F+4|0}}}t=t+1|0;if((t|0)==(l|0))break;else{B=B+(e<<2)+4+(C<<2)|0;D=D+e+1+y|0;A=A+(e<<2)+4+(z<<2)|0}}u=o;return}z=q+8|0;f[q>>2]=z;e=q+4|0;f[e>>2]=k;if(k>>>0>264){A=OYa(k>>>0>1073741823?-1:k<<2)|0;f[q>>2]=A;M=A}else M=z;A=(m|0)>0;do if(A){k=(g|0)==(m|0);y=r+(m<<1)|0;D=x+(m<<2)|0;if((g|0)>0){N=M;O=0;P=w;Q=a;R=v;S=x}else{C=M;B=0;t=w;i=v;F=x;while(1){n[F+(p<<2)>>2]=0.0;n[i+(p<<2)>>2]=0.0;if(k)n[C+(m<<2)>>2]=0.0;if(!t)T=0;else{n[t+(p<<2)>>2]=0.0;T=t+4|0}B=B+1|0;if((B|0)==(m|0))break;else{C=C+4|0;t=T;i=i+4|0;F=F+4|0}}U=M+(m<<2)|0;V=T;W=a+m|0;X=c+(y<<2)|0;Z=D;break}while(1){n[S+(p<<2)>>2]=0.0;n[R+(p<<2)>>2]=0.0;F=(P|0)!=0;if(F){H=0.0;J=0.0;i=0;do{L=+(h[Q+i>>0]|0);n[S+(i<<2)>>2]=L;n[N+(i<<2)>>2]=L;H=H+L;J=J+L*L;n[R+(i<<2)>>2]=H;n[P+(i<<2)>>2]=J;i=i+m|0}while((i|0)<(g|0))}else{J=0.0;i=0;do{H=+(h[Q+i>>0]|0);n[S+(i<<2)>>2]=H;n[N+(i<<2)>>2]=H;J=J+H;n[R+(i<<2)>>2]=J;i=i+m|0}while((i|0)<(g|0))}if(k)n[N+(m<<2)>>2]=0.0;if(F){n[P+(p<<2)>>2]=0.0;_=P+4|0}else _=0;O=O+1|0;if((O|0)==(m|0))break;else{N=N+4|0;P=_;Q=Q+1|0;R=R+4|0;S=S+4|0}}U=M+(m<<2)|0;V=_;W=a+m|0;X=c+(y<<2)|0;Z=D}else{U=M;V=w;W=a;X=v;Z=x}while(0);if((l|0)>1){x=b-m|0;v=r-m|0;a=d-m|0;w=s-m|0;c=0-r|0;_=0-s|0;S=g-m|0;R=(S|0)>(m|0);Q=d+m|0;P=(g|0)>(m|0);g=U;U=V;V=W;W=X;X=Z;Z=1;while(1){N=V+x|0;O=W+(v<<2)|0;T=X+(a<<2)|0;k=g+(p<<2)|0;i=(U|0)==0?0:U+(w<<2)|0;if(A){t=W+(r<<2)|0;C=k;B=0;E=i;I=N;G=O;K=T;while(1){J=+(h[I>>0]|0);H=J*J;n[G+(p<<2)>>2]=0.0;$=(E|0)!=0;if($)n[E+(p<<2)>>2]=0.0;aa=K+(j<<2)|0;f[K+(p<<2)>>2]=f[aa>>2];n[G>>2]=J+ +n[G+(c<<2)>>2];if($)n[E>>2]=H+ +n[E+(_<<2)>>2];n[K>>2]=J+ +n[aa>>2]+ +n[C+(m<<2)>>2];if(R)if($){L=J;ba=H;ca=J;aa=m;while(1){da=+n[C+(aa<<2)>>2];n[C+(aa-m<<2)>>2]=ca+da;ea=+(h[I+aa>>0]|0);fa=L+ea;ga=ba+ea*ea;n[G+(aa<<2)>>2]=+n[G+(aa-r<<2)>>2]+fa;n[E+(aa<<2)>>2]=ga+ +n[E+(aa-s<<2)>>2];ha=aa+m|0;n[K+(aa<<2)>>2]=da+(ea+ +n[C+(ha<<2)>>2]+ +n[K+(aa-Q<<2)>>2]);if((ha|0)<(S|0)){L=fa;ba=ga;ca=ea;aa=ha}else{ia=fa;ja=ga;ka=ea;la=ha;break}}}else{ca=J;ba=H;L=J;aa=m;while(1){ea=+n[C+(aa<<2)>>2];n[C+(aa-m<<2)>>2]=L+ea;ga=+(h[I+aa>>0]|0);fa=ca+ga;da=ba+ga*ga;n[G+(aa<<2)>>2]=+n[G+(aa-r<<2)>>2]+fa;F=aa+m|0;n[K+(aa<<2)>>2]=ea+(ga+ +n[C+(F<<2)>>2]+ +n[K+(aa-Q<<2)>>2]);if((F|0)<(S|0)){ca=fa;ba=da;L=ga;aa=F}else{ia=fa;ja=da;ka=ga;la=F;break}}}else{ia=J;ja=H;ka=J;la=m}if(P){aa=C+(la<<2)|0;L=+n[aa>>2];n[C+(la-m<<2)>>2]=ka+L;ba=+(h[I+la>>0]|0);n[G+(la<<2)>>2]=+n[G+(la-r<<2)>>2]+(ia+ba);if($)n[E+(la<<2)>>2]=ja+ba*ba+ +n[E+(la-s<<2)>>2];n[K+(la<<2)>>2]=L+ba+ +n[K+(la-Q<<2)>>2];n[aa>>2]=ba}E=$?E+4|0:0;B=B+1|0;if((B|0)==(m|0))break;else{C=C+4|0;I=I+1|0;G=G+4|0;K=K+4|0}}ma=g;na=E;oa=V+b|0;pa=t;qa=X+(d<<2)|0}else{ma=k;na=i;oa=N;pa=O;qa=T}Z=Z+1|0;if((Z|0)==(l|0))break;else{g=ma;U=na;V=oa;W=pa;X=qa}}}if((M|0)!=(z|0)){QYa(M);f[q>>2]=z;f[e>>2]=264}u=o;return}function Vpa(a,b,c,d,e,g,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;n=u;u=u+1104|0;o=0-m|0;q=n;r=d>>>3;d=j>>>3;j=0-d|0;s=g>>>3;g=Y(m,k)|0;k=g+m|0;t=k<<3;F1a(c|0,0,t|0)|0;v=c+(r+m<<3)|0;if(!e)w=0;else{F1a(e|0,0,t|0)|0;w=e+(s+m<<3)|0}if(!i)x=0;else{F1a(i|0,0,t|0)|0;x=i+(d+m<<3)|0}i=(x|0)==0;if((w|0)==0&i){if((l|0)<=0){u=n;return}t=(g|0)>0;e=b-m|0;y=r-m|0;if((m|0)<=0){u=n;return}z=m+-1|0;A=m<<3;B=a;C=v;D=0;while(1){if(t){E=0;F=B;G=C;while(1){p[G+(o<<3)>>3]=0.0;H=0.0;I=0;do{H=H+ +(h[F+I>>0]|0);p[G+(I<<3)>>3]=+p[G+(I-r<<3)>>3]+H;I=I+m|0}while((I|0)<(g|0));E=E+1|0;if((E|0)==(m|0))break;else{F=F+1|0;G=G+8|0}}}else F1a(C+(o<<3)|0,0,A|0)|0;D=D+1|0;if((D|0)==(l|0))break;else{B=B+z+1+e|0;C=C+(z<<3)+8+(y<<3)|0}}u=n;return}if(i){if((l|0)<=0){u=n;return}i=(g|0)>0;y=b-m|0;z=r-m|0;C=s-m|0;if((m|0)<=0){u=n;return}e=m+-1|0;B=w;D=a;A=v;t=0;while(1){if(i){G=0;F=B;E=D;I=A;while(1){p[I+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;H=0.0;J=0.0;K=0;do{L=+(h[E+K>>0]|0);H=H+L;J=J+L*L;L=+p[F+(K-s<<3)>>3]+J;p[I+(K<<3)>>3]=+p[I+(K-r<<3)>>3]+H;p[F+(K<<3)>>3]=L;K=K+m|0}while((K|0)<(g|0));G=G+1|0;if((G|0)==(m|0))break;else{F=F+8|0;E=E+1|0;I=I+8|0}}}else{I=0;E=B;F=A;while(1){p[F+(o<<3)>>3]=0.0;p[E+(o<<3)>>3]=0.0;I=I+1|0;if((I|0)==(m|0))break;else{E=E+8|0;F=F+8|0}}}t=t+1|0;if((t|0)==(l|0))break;else{B=B+(e<<3)+8+(C<<3)|0;D=D+e+1+y|0;A=A+(e<<3)+8+(z<<3)|0}}u=n;return}z=q+8|0;f[q>>2]=z;e=q+4|0;f[e>>2]=k;if(k>>>0>136){A=OYa(k>>>0>536870911?-1:k<<3)|0;f[q>>2]=A;M=A}else M=z;A=(m|0)>0;do if(A){k=(g|0)==(m|0);y=r+(m<<1)|0;D=x+(m<<3)|0;if((g|0)>0){N=M;O=0;P=w;Q=a;R=v;S=x}else{C=M;B=0;t=w;i=v;F=x;while(1){p[F+(o<<3)>>3]=0.0;p[i+(o<<3)>>3]=0.0;if(k)p[C+(m<<3)>>3]=0.0;if(!t)T=0;else{p[t+(o<<3)>>3]=0.0;T=t+8|0}B=B+1|0;if((B|0)==(m|0))break;else{C=C+8|0;t=T;i=i+8|0;F=F+8|0}}U=M+(m<<3)|0;V=T;W=a+m|0;X=c+(y<<3)|0;Z=D;break}while(1){p[S+(o<<3)>>3]=0.0;p[R+(o<<3)>>3]=0.0;F=(P|0)!=0;if(F){H=0.0;J=0.0;i=0;do{L=+(h[Q+i>>0]|0);p[S+(i<<3)>>3]=L;p[N+(i<<3)>>3]=L;H=H+L;J=J+L*L;p[R+(i<<3)>>3]=H;p[P+(i<<3)>>3]=J;i=i+m|0}while((i|0)<(g|0))}else{J=0.0;i=0;do{H=+(h[Q+i>>0]|0);p[S+(i<<3)>>3]=H;p[N+(i<<3)>>3]=H;J=J+H;p[R+(i<<3)>>3]=J;i=i+m|0}while((i|0)<(g|0))}if(k)p[N+(m<<3)>>3]=0.0;if(F){p[P+(o<<3)>>3]=0.0;_=P+8|0}else _=0;O=O+1|0;if((O|0)==(m|0))break;else{N=N+8|0;P=_;Q=Q+1|0;R=R+8|0;S=S+8|0}}U=M+(m<<3)|0;V=_;W=a+m|0;X=c+(y<<3)|0;Z=D}else{U=M;V=w;W=a;X=v;Z=x}while(0);if((l|0)>1){x=b-m|0;v=r-m|0;a=d-m|0;w=s-m|0;c=0-r|0;_=0-s|0;S=g-m|0;R=(S|0)>(m|0);Q=d+m|0;P=(g|0)>(m|0);g=U;U=V;V=W;W=X;X=Z;Z=1;while(1){N=V+x|0;O=W+(v<<3)|0;T=X+(a<<3)|0;k=g+(o<<3)|0;i=(U|0)==0?0:U+(w<<3)|0;if(A){t=W+(r<<3)|0;C=k;B=0;E=i;I=N;G=O;K=T;while(1){J=+(h[I>>0]|0);H=J*J;p[G+(o<<3)>>3]=0.0;$=(E|0)!=0;if($)p[E+(o<<3)>>3]=0.0;aa=K+(j<<3)|0;p[K+(o<<3)>>3]=+p[aa>>3];p[G>>3]=J+ +p[G+(c<<3)>>3];if($)p[E>>3]=H+ +p[E+(_<<3)>>3];p[K>>3]=J+ +p[aa>>3]+ +p[C+(m<<3)>>3];if(R)if($){L=J;ba=H;ca=J;aa=m;while(1){da=+p[C+(aa<<3)>>3];p[C+(aa-m<<3)>>3]=ca+da;ea=+(h[I+aa>>0]|0);fa=L+ea;ga=ba+ea*ea;p[G+(aa<<3)>>3]=+p[G+(aa-r<<3)>>3]+fa;p[E+(aa<<3)>>3]=ga+ +p[E+(aa-s<<3)>>3];ha=aa+m|0;p[K+(aa<<3)>>3]=da+(ea+ +p[C+(ha<<3)>>3]+ +p[K+(aa-Q<<3)>>3]);if((ha|0)<(S|0)){L=fa;ba=ga;ca=ea;aa=ha}else{ia=fa;ja=ga;ka=ea;la=ha;break}}}else{ca=J;ba=H;L=J;aa=m;while(1){ea=+p[C+(aa<<3)>>3];p[C+(aa-m<<3)>>3]=L+ea;ga=+(h[I+aa>>0]|0);fa=ca+ga;da=ba+ga*ga;p[G+(aa<<3)>>3]=+p[G+(aa-r<<3)>>3]+fa;F=aa+m|0;p[K+(aa<<3)>>3]=ea+(ga+ +p[C+(F<<3)>>3]+ +p[K+(aa-Q<<3)>>3]);if((F|0)<(S|0)){ca=fa;ba=da;L=ga;aa=F}else{ia=fa;ja=da;ka=ga;la=F;break}}}else{ia=J;ja=H;ka=J;la=m}if(P){aa=C+(la<<3)|0;L=+p[aa>>3];p[C+(la-m<<3)>>3]=ka+L;ba=+(h[I+la>>0]|0);p[G+(la<<3)>>3]=+p[G+(la-r<<3)>>3]+(ia+ba);if($)p[E+(la<<3)>>3]=ja+ba*ba+ +p[E+(la-s<<3)>>3];p[K+(la<<3)>>3]=L+ba+ +p[K+(la-Q<<3)>>3];p[aa>>3]=ba}E=$?E+8|0:0;B=B+1|0;if((B|0)==(m|0))break;else{C=C+8|0;I=I+1|0;G=G+8|0;K=K+8|0}}ma=g;na=E;oa=V+b|0;pa=t;qa=X+(d<<3)|0}else{ma=k;na=i;oa=N;pa=O;qa=T}Z=Z+1|0;if((Z|0)==(l|0))break;else{g=ma;U=na;V=oa;W=pa;X=qa}}}if((M|0)!=(z|0)){QYa(M);f[q>>2]=z;f[e>>2]=136}u=n;return}function Wpa(a,b,c,d,e,g,h,i,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;n=u;u=u+1104|0;o=0-m|0;q=n;r=b>>>1;b=d>>>3;d=i>>>3;i=0-d|0;s=g>>>3;g=Y(m,k)|0;k=g+m|0;t=k<<3;F1a(c|0,0,t|0)|0;v=c+(b+m<<3)|0;if(!e)w=0;else{F1a(e|0,0,t|0)|0;w=e+(s+m<<3)|0}if(!h)x=0;else{F1a(h|0,0,t|0)|0;x=h+(d+m<<3)|0}h=(x|0)==0;if((w|0)==0&h){if((l|0)<=0){u=n;return}t=(g|0)>0;e=r-m|0;y=b-m|0;if((m|0)<=0){u=n;return}z=m+-1|0;A=m<<3;B=a;C=v;D=0;while(1){if(t){E=0;F=B;G=C;while(1){p[G+(o<<3)>>3]=0.0;H=0.0;I=0;do{H=H+ +(j[F+(I<<1)>>1]|0);p[G+(I<<3)>>3]=+p[G+(I-b<<3)>>3]+H;I=I+m|0}while((I|0)<(g|0));E=E+1|0;if((E|0)==(m|0))break;else{F=F+2|0;G=G+8|0}}}else F1a(C+(o<<3)|0,0,A|0)|0;D=D+1|0;if((D|0)==(l|0))break;else{B=B+(z<<1)+2+(e<<1)|0;C=C+(z<<3)+8+(y<<3)|0}}u=n;return}if(h){if((l|0)<=0){u=n;return}h=(g|0)>0;y=r-m|0;z=b-m|0;C=s-m|0;if((m|0)<=0){u=n;return}e=m+-1|0;B=w;D=a;A=v;t=0;while(1){if(h){G=0;F=B;E=D;I=A;while(1){p[I+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;H=0.0;J=0.0;K=0;do{L=+(j[E+(K<<1)>>1]|0);H=H+L;J=J+L*L;L=+p[F+(K-s<<3)>>3]+J;p[I+(K<<3)>>3]=+p[I+(K-b<<3)>>3]+H;p[F+(K<<3)>>3]=L;K=K+m|0}while((K|0)<(g|0));G=G+1|0;if((G|0)==(m|0))break;else{F=F+8|0;E=E+2|0;I=I+8|0}}}else{I=0;E=B;F=A;while(1){p[F+(o<<3)>>3]=0.0;p[E+(o<<3)>>3]=0.0;I=I+1|0;if((I|0)==(m|0))break;else{E=E+8|0;F=F+8|0}}}t=t+1|0;if((t|0)==(l|0))break;else{B=B+(e<<3)+8+(C<<3)|0;D=D+(e<<1)+2+(y<<1)|0;A=A+(e<<3)+8+(z<<3)|0}}u=n;return}z=q+8|0;f[q>>2]=z;e=q+4|0;f[e>>2]=k;if(k>>>0>136){A=OYa(k>>>0>536870911?-1:k<<3)|0;f[q>>2]=A;M=A}else M=z;A=(m|0)>0;do if(A){k=(g|0)==(m|0);y=b+(m<<1)|0;D=x+(m<<3)|0;if((g|0)>0){N=M;O=0;P=w;Q=a;R=v;S=x}else{C=M;B=0;t=w;h=v;F=x;while(1){p[F+(o<<3)>>3]=0.0;p[h+(o<<3)>>3]=0.0;if(k)p[C+(m<<3)>>3]=0.0;if(!t)T=0;else{p[t+(o<<3)>>3]=0.0;T=t+8|0}B=B+1|0;if((B|0)==(m|0))break;else{C=C+8|0;t=T;h=h+8|0;F=F+8|0}}U=M+(m<<3)|0;V=T;W=a+(m<<1)|0;X=c+(y<<3)|0;Z=D;break}while(1){p[S+(o<<3)>>3]=0.0;p[R+(o<<3)>>3]=0.0;F=(P|0)!=0;if(F){H=0.0;J=0.0;h=0;do{L=+(j[Q+(h<<1)>>1]|0);p[S+(h<<3)>>3]=L;p[N+(h<<3)>>3]=L;H=H+L;J=J+L*L;p[R+(h<<3)>>3]=H;p[P+(h<<3)>>3]=J;h=h+m|0}while((h|0)<(g|0))}else{J=0.0;h=0;do{H=+(j[Q+(h<<1)>>1]|0);p[S+(h<<3)>>3]=H;p[N+(h<<3)>>3]=H;J=J+H;p[R+(h<<3)>>3]=J;h=h+m|0}while((h|0)<(g|0))}if(k)p[N+(m<<3)>>3]=0.0;if(F){p[P+(o<<3)>>3]=0.0;_=P+8|0}else _=0;O=O+1|0;if((O|0)==(m|0))break;else{N=N+8|0;P=_;Q=Q+2|0;R=R+8|0;S=S+8|0}}U=M+(m<<3)|0;V=_;W=a+(m<<1)|0;X=c+(y<<3)|0;Z=D}else{U=M;V=w;W=a;X=v;Z=x}while(0);if((l|0)>1){x=r-m|0;v=b-m|0;a=d-m|0;w=s-m|0;c=0-b|0;_=0-s|0;S=g-m|0;R=(S|0)>(m|0);Q=d+m|0;P=(g|0)>(m|0);g=U;U=V;V=W;W=X;X=Z;Z=1;while(1){N=V+(x<<1)|0;O=W+(v<<3)|0;T=X+(a<<3)|0;k=g+(o<<3)|0;h=(U|0)==0?0:U+(w<<3)|0;if(A){t=W+(b<<3)|0;C=k;B=0;E=h;I=N;G=O;K=T;while(1){J=+(j[I>>1]|0);H=J*J;p[G+(o<<3)>>3]=0.0;$=(E|0)!=0;if($)p[E+(o<<3)>>3]=0.0;aa=K+(i<<3)|0;p[K+(o<<3)>>3]=+p[aa>>3];p[G>>3]=J+ +p[G+(c<<3)>>3];if($)p[E>>3]=H+ +p[E+(_<<3)>>3];p[K>>3]=J+ +p[aa>>3]+ +p[C+(m<<3)>>3];if(R)if($){L=J;ba=H;ca=J;aa=m;while(1){da=+p[C+(aa<<3)>>3];p[C+(aa-m<<3)>>3]=ca+da;ea=+(j[I+(aa<<1)>>1]|0);fa=L+ea;ga=ba+ea*ea;p[G+(aa<<3)>>3]=+p[G+(aa-b<<3)>>3]+fa;p[E+(aa<<3)>>3]=ga+ +p[E+(aa-s<<3)>>3];ha=aa+m|0;p[K+(aa<<3)>>3]=da+(ea+ +p[C+(ha<<3)>>3]+ +p[K+(aa-Q<<3)>>3]);if((ha|0)<(S|0)){L=fa;ba=ga;ca=ea;aa=ha}else{ia=fa;ja=ga;ka=ea;la=ha;break}}}else{ca=J;ba=H;L=J;aa=m;while(1){ea=+p[C+(aa<<3)>>3];p[C+(aa-m<<3)>>3]=L+ea;ga=+(j[I+(aa<<1)>>1]|0);fa=ca+ga;da=ba+ga*ga;p[G+(aa<<3)>>3]=+p[G+(aa-b<<3)>>3]+fa;F=aa+m|0;p[K+(aa<<3)>>3]=ea+(ga+ +p[C+(F<<3)>>3]+ +p[K+(aa-Q<<3)>>3]);if((F|0)<(S|0)){ca=fa;ba=da;L=ga;aa=F}else{ia=fa;ja=da;ka=ga;la=F;break}}}else{ia=J;ja=H;ka=J;la=m}if(P){aa=C+(la<<3)|0;L=+p[aa>>3];p[C+(la-m<<3)>>3]=ka+L;ba=+(j[I+(la<<1)>>1]|0);p[G+(la<<3)>>3]=+p[G+(la-b<<3)>>3]+(ia+ba);if($)p[E+(la<<3)>>3]=ja+ba*ba+ +p[E+(la-s<<3)>>3];p[K+(la<<3)>>3]=L+ba+ +p[K+(la-Q<<3)>>3];p[aa>>3]=ba}E=$?E+8|0:0;B=B+1|0;if((B|0)==(m|0))break;else{C=C+8|0;I=I+2|0;G=G+8|0;K=K+8|0}}ma=g;na=E;oa=V+(r<<1)|0;pa=t;qa=X+(d<<3)|0}else{ma=k;na=h;oa=N;pa=O;qa=T}Z=Z+1|0;if((Z|0)==(l|0))break;else{g=ma;U=na;V=oa;W=pa;X=qa}}}if((M|0)!=(z|0)){QYa(M);f[q>>2]=z;f[e>>2]=136}u=n;return}function Xpa(a,b,c,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;n=u;u=u+1104|0;o=0-m|0;q=n;r=b>>>1;b=e>>>3;e=j>>>3;j=0-e|0;s=h>>>3;h=Y(m,k)|0;k=h+m|0;t=k<<3;F1a(c|0,0,t|0)|0;v=c+(b+m<<3)|0;if(!g)w=0;else{F1a(g|0,0,t|0)|0;w=g+(s+m<<3)|0}if(!i)x=0;else{F1a(i|0,0,t|0)|0;x=i+(e+m<<3)|0}i=(x|0)==0;if((w|0)==0&i){if((l|0)<=0){u=n;return}t=(h|0)>0;g=r-m|0;y=b-m|0;if((m|0)<=0){u=n;return}z=m+-1|0;A=m<<3;B=a;C=v;D=0;while(1){if(t){E=0;F=B;G=C;while(1){p[G+(o<<3)>>3]=0.0;H=0.0;I=0;do{H=H+ +(d[F+(I<<1)>>1]|0);p[G+(I<<3)>>3]=+p[G+(I-b<<3)>>3]+H;I=I+m|0}while((I|0)<(h|0));E=E+1|0;if((E|0)==(m|0))break;else{F=F+2|0;G=G+8|0}}}else F1a(C+(o<<3)|0,0,A|0)|0;D=D+1|0;if((D|0)==(l|0))break;else{B=B+(z<<1)+2+(g<<1)|0;C=C+(z<<3)+8+(y<<3)|0}}u=n;return}if(i){if((l|0)<=0){u=n;return}i=(h|0)>0;y=r-m|0;z=b-m|0;C=s-m|0;if((m|0)<=0){u=n;return}g=m+-1|0;B=w;D=a;A=v;t=0;while(1){if(i){G=0;F=B;E=D;I=A;while(1){p[I+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;H=0.0;J=0.0;K=0;do{L=+(d[E+(K<<1)>>1]|0);H=H+L;J=J+L*L;L=+p[F+(K-s<<3)>>3]+J;p[I+(K<<3)>>3]=+p[I+(K-b<<3)>>3]+H;p[F+(K<<3)>>3]=L;K=K+m|0}while((K|0)<(h|0));G=G+1|0;if((G|0)==(m|0))break;else{F=F+8|0;E=E+2|0;I=I+8|0}}}else{I=0;E=B;F=A;while(1){p[F+(o<<3)>>3]=0.0;p[E+(o<<3)>>3]=0.0;I=I+1|0;if((I|0)==(m|0))break;else{E=E+8|0;F=F+8|0}}}t=t+1|0;if((t|0)==(l|0))break;else{B=B+(g<<3)+8+(C<<3)|0;D=D+(g<<1)+2+(y<<1)|0;A=A+(g<<3)+8+(z<<3)|0}}u=n;return}z=q+8|0;f[q>>2]=z;g=q+4|0;f[g>>2]=k;if(k>>>0>136){A=OYa(k>>>0>536870911?-1:k<<3)|0;f[q>>2]=A;M=A}else M=z;A=(m|0)>0;do if(A){k=(h|0)==(m|0);y=b+(m<<1)|0;D=x+(m<<3)|0;if((h|0)>0){N=M;O=0;P=w;Q=a;R=v;S=x}else{C=M;B=0;t=w;i=v;F=x;while(1){p[F+(o<<3)>>3]=0.0;p[i+(o<<3)>>3]=0.0;if(k)p[C+(m<<3)>>3]=0.0;if(!t)T=0;else{p[t+(o<<3)>>3]=0.0;T=t+8|0}B=B+1|0;if((B|0)==(m|0))break;else{C=C+8|0;t=T;i=i+8|0;F=F+8|0}}U=M+(m<<3)|0;V=T;W=a+(m<<1)|0;X=c+(y<<3)|0;Z=D;break}while(1){p[S+(o<<3)>>3]=0.0;p[R+(o<<3)>>3]=0.0;F=(P|0)!=0;if(F){H=0.0;J=0.0;i=0;do{L=+(d[Q+(i<<1)>>1]|0);p[S+(i<<3)>>3]=L;p[N+(i<<3)>>3]=L;H=H+L;J=J+L*L;p[R+(i<<3)>>3]=H;p[P+(i<<3)>>3]=J;i=i+m|0}while((i|0)<(h|0))}else{J=0.0;i=0;do{H=+(d[Q+(i<<1)>>1]|0);p[S+(i<<3)>>3]=H;p[N+(i<<3)>>3]=H;J=J+H;p[R+(i<<3)>>3]=J;i=i+m|0}while((i|0)<(h|0))}if(k)p[N+(m<<3)>>3]=0.0;if(F){p[P+(o<<3)>>3]=0.0;_=P+8|0}else _=0;O=O+1|0;if((O|0)==(m|0))break;else{N=N+8|0;P=_;Q=Q+2|0;R=R+8|0;S=S+8|0}}U=M+(m<<3)|0;V=_;W=a+(m<<1)|0;X=c+(y<<3)|0;Z=D}else{U=M;V=w;W=a;X=v;Z=x}while(0);if((l|0)>1){x=r-m|0;v=b-m|0;a=e-m|0;w=s-m|0;c=0-b|0;_=0-s|0;S=h-m|0;R=(S|0)>(m|0);Q=e+m|0;P=(h|0)>(m|0);h=U;U=V;V=W;W=X;X=Z;Z=1;while(1){N=V+(x<<1)|0;O=W+(v<<3)|0;T=X+(a<<3)|0;k=h+(o<<3)|0;i=(U|0)==0?0:U+(w<<3)|0;if(A){t=W+(b<<3)|0;C=k;B=0;E=i;I=N;G=O;K=T;while(1){J=+(d[I>>1]|0);H=J*J;p[G+(o<<3)>>3]=0.0;$=(E|0)!=0;if($)p[E+(o<<3)>>3]=0.0;aa=K+(j<<3)|0;p[K+(o<<3)>>3]=+p[aa>>3];p[G>>3]=J+ +p[G+(c<<3)>>3];if($)p[E>>3]=H+ +p[E+(_<<3)>>3];p[K>>3]=J+ +p[aa>>3]+ +p[C+(m<<3)>>3];if(R)if($){L=J;ba=H;ca=J;aa=m;while(1){da=+p[C+(aa<<3)>>3];p[C+(aa-m<<3)>>3]=ca+da;ea=+(d[I+(aa<<1)>>1]|0);fa=L+ea;ga=ba+ea*ea;p[G+(aa<<3)>>3]=+p[G+(aa-b<<3)>>3]+fa;p[E+(aa<<3)>>3]=ga+ +p[E+(aa-s<<3)>>3];ha=aa+m|0;p[K+(aa<<3)>>3]=da+(ea+ +p[C+(ha<<3)>>3]+ +p[K+(aa-Q<<3)>>3]);if((ha|0)<(S|0)){L=fa;ba=ga;ca=ea;aa=ha}else{ia=fa;ja=ga;ka=ea;la=ha;break}}}else{ca=J;ba=H;L=J;aa=m;while(1){ea=+p[C+(aa<<3)>>3];p[C+(aa-m<<3)>>3]=L+ea;ga=+(d[I+(aa<<1)>>1]|0);fa=ca+ga;da=ba+ga*ga;p[G+(aa<<3)>>3]=+p[G+(aa-b<<3)>>3]+fa;F=aa+m|0;p[K+(aa<<3)>>3]=ea+(ga+ +p[C+(F<<3)>>3]+ +p[K+(aa-Q<<3)>>3]);if((F|0)<(S|0)){ca=fa;ba=da;L=ga;aa=F}else{ia=fa;ja=da;ka=ga;la=F;break}}}else{ia=J;ja=H;ka=J;la=m}if(P){aa=C+(la<<3)|0;L=+p[aa>>3];p[C+(la-m<<3)>>3]=ka+L;ba=+(d[I+(la<<1)>>1]|0);p[G+(la<<3)>>3]=+p[G+(la-b<<3)>>3]+(ia+ba);if($)p[E+(la<<3)>>3]=ja+ba*ba+ +p[E+(la-s<<3)>>3];p[K+(la<<3)>>3]=L+ba+ +p[K+(la-Q<<3)>>3];p[aa>>3]=ba}E=$?E+8|0:0;B=B+1|0;if((B|0)==(m|0))break;else{C=C+8|0;I=I+2|0;G=G+8|0;K=K+8|0}}ma=h;na=E;oa=V+(r<<1)|0;pa=t;qa=X+(e<<3)|0}else{ma=k;na=i;oa=N;pa=O;qa=T}Z=Z+1|0;if((Z|0)==(l|0))break;else{h=ma;U=na;V=oa;W=pa;X=qa}}}if((M|0)!=(z|0)){QYa(M);f[q>>2]=z;f[g>>2]=136}u=n;return}function Ypa(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0,ja=0.0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;m=u;u=u+1072|0;o=0-l|0;q=m;r=b>>>2;b=d>>>2;d=i>>>2;i=0-d|0;s=g>>>3;g=Y(l,j)|0;j=g+l|0;t=j<<2;F1a(c|0,0,t|0)|0;v=c+(b+l<<2)|0;if(!e)w=0;else{F1a(e|0,0,j<<3|0)|0;w=e+(s+l<<3)|0}if(!h)x=0;else{F1a(h|0,0,t|0)|0;x=h+(d+l<<2)|0}h=(x|0)==0;if((w|0)==0&h){if((k|0)<=0){u=m;return}t=(g|0)>0;e=r-l|0;y=b-l|0;if((l|0)<=0){u=m;return}z=l+-1|0;A=l<<2;B=a;C=v;D=0;while(1){if(t){E=0;F=B;G=C;while(1){n[G+(o<<2)>>2]=0.0;H=0.0;I=0;do{H=H+ +n[F+(I<<2)>>2];n[G+(I<<2)>>2]=+n[G+(I-b<<2)>>2]+H;I=I+l|0}while((I|0)<(g|0));E=E+1|0;if((E|0)==(l|0))break;else{F=F+4|0;G=G+4|0}}}else F1a(C+(o<<2)|0,0,A|0)|0;D=D+1|0;if((D|0)==(k|0))break;else{B=B+(z<<2)+4+(e<<2)|0;C=C+(z<<2)+4+(y<<2)|0}}u=m;return}if(h){if((k|0)<=0){u=m;return}h=(g|0)>0;y=r-l|0;z=b-l|0;C=s-l|0;if((l|0)<=0){u=m;return}e=l+-1|0;B=w;D=a;A=v;t=0;while(1){if(h){G=0;F=B;E=D;I=A;while(1){n[I+(o<<2)>>2]=0.0;p[F+(o<<3)>>3]=0.0;H=0.0;J=0.0;K=0;do{L=+n[E+(K<<2)>>2];H=H+L;M=L;J=J+M*M;M=+p[F+(K-s<<3)>>3]+J;n[I+(K<<2)>>2]=+n[I+(K-b<<2)>>2]+H;p[F+(K<<3)>>3]=M;K=K+l|0}while((K|0)<(g|0));G=G+1|0;if((G|0)==(l|0))break;else{F=F+8|0;E=E+4|0;I=I+4|0}}}else{I=0;E=B;F=A;while(1){n[F+(o<<2)>>2]=0.0;p[E+(o<<3)>>3]=0.0;I=I+1|0;if((I|0)==(l|0))break;else{E=E+8|0;F=F+4|0}}}t=t+1|0;if((t|0)==(k|0))break;else{B=B+(e<<3)+8+(C<<3)|0;D=D+(e<<2)+4+(y<<2)|0;A=A+(e<<2)+4+(z<<2)|0}}u=m;return}z=q+8|0;f[q>>2]=z;e=q+4|0;f[e>>2]=j;if(j>>>0>264){A=OYa(j>>>0>1073741823?-1:j<<2)|0;f[q>>2]=A;N=A}else N=z;A=(l|0)>0;do if(A){j=(g|0)==(l|0);y=b+(l<<1)|0;D=x+(l<<2)|0;if((g|0)>0){O=N;P=0;Q=w;R=a;S=v;T=x}else{C=N;B=0;t=w;h=v;F=x;while(1){n[F+(o<<2)>>2]=0.0;n[h+(o<<2)>>2]=0.0;if(j)n[C+(l<<2)>>2]=0.0;if(!t)U=0;else{p[t+(o<<3)>>3]=0.0;U=t+8|0}B=B+1|0;if((B|0)==(l|0))break;else{C=C+4|0;t=U;h=h+4|0;F=F+4|0}}V=N+(l<<2)|0;W=U;X=a+(l<<2)|0;Z=c+(y<<2)|0;_=D;break}while(1){n[T+(o<<2)>>2]=0.0;n[S+(o<<2)>>2]=0.0;F=(Q|0)!=0;if(F){H=0.0;J=0.0;h=0;do{M=+n[R+(h<<2)>>2];n[T+(h<<2)>>2]=M;n[O+(h<<2)>>2]=M;H=H+M;L=M;J=J+L*L;n[S+(h<<2)>>2]=H;p[Q+(h<<3)>>3]=J;h=h+l|0}while((h|0)<(g|0))}else{J=0.0;h=0;do{H=+n[R+(h<<2)>>2];n[T+(h<<2)>>2]=H;n[O+(h<<2)>>2]=H;J=J+H;n[S+(h<<2)>>2]=J;h=h+l|0}while((h|0)<(g|0))}if(j)n[O+(l<<2)>>2]=0.0;if(F){p[Q+(o<<3)>>3]=0.0;$=Q+8|0}else $=0;P=P+1|0;if((P|0)==(l|0))break;else{O=O+4|0;Q=$;R=R+4|0;S=S+4|0;T=T+4|0}}V=N+(l<<2)|0;W=$;X=a+(l<<2)|0;Z=c+(y<<2)|0;_=D}else{V=N;W=w;X=a;Z=v;_=x}while(0);if((k|0)>1){x=r-l|0;v=b-l|0;a=d-l|0;w=s-l|0;c=0-b|0;$=0-s|0;T=g-l|0;S=(T|0)>(l|0);R=d+l|0;Q=(g|0)>(l|0);g=V;V=W;W=X;X=Z;Z=_;_=1;while(1){O=W+(x<<2)|0;P=X+(v<<2)|0;U=Z+(a<<2)|0;j=g+(o<<2)|0;h=(V|0)==0?0:V+(w<<3)|0;if(A){t=X+(b<<2)|0;C=j;B=0;E=h;I=O;G=P;K=U;while(1){J=+n[I>>2];H=J;L=H*H;n[G+(o<<2)>>2]=0.0;aa=(E|0)!=0;if(aa)p[E+(o<<3)>>3]=0.0;ba=K+(i<<2)|0;f[K+(o<<2)>>2]=f[ba>>2];n[G>>2]=J+ +n[G+(c<<2)>>2];if(aa)p[E>>3]=L+ +p[E+($<<3)>>3];n[K>>2]=J+ +n[ba>>2]+ +n[C+(l<<2)>>2];if(S)if(aa){H=J;M=L;ca=J;ba=l;while(1){da=+n[C+(ba<<2)>>2];n[C+(ba-l<<2)>>2]=ca+da;ea=+n[I+(ba<<2)>>2];fa=ea;ga=H+ea;ha=M+fa*fa;n[G+(ba<<2)>>2]=+n[G+(ba-b<<2)>>2]+ga;p[E+(ba<<3)>>3]=ha+ +p[E+(ba-s<<3)>>3];ia=ba+l|0;n[K+(ba<<2)>>2]=da+(ea+ +n[C+(ia<<2)>>2]+ +n[K+(ba-R<<2)>>2]);if((ia|0)<(T|0)){H=ga;M=ha;ca=ea;ba=ia}else{ja=ga;ka=ha;la=ea;ma=ia;break}}}else{ca=J;M=L;H=J;ba=l;while(1){ea=+n[C+(ba<<2)>>2];n[C+(ba-l<<2)>>2]=H+ea;ha=+n[I+(ba<<2)>>2];ga=ha;da=ca+ha;fa=M+ga*ga;n[G+(ba<<2)>>2]=+n[G+(ba-b<<2)>>2]+da;F=ba+l|0;n[K+(ba<<2)>>2]=ea+(ha+ +n[C+(F<<2)>>2]+ +n[K+(ba-R<<2)>>2]);if((F|0)<(T|0)){ca=da;M=fa;H=ha;ba=F}else{ja=da;ka=fa;la=ha;ma=F;break}}}else{ja=J;ka=L;la=J;ma=l}if(Q){ba=C+(ma<<2)|0;H=+n[ba>>2];n[C+(ma-l<<2)>>2]=la+H;M=+n[I+(ma<<2)>>2];ca=M;n[G+(ma<<2)>>2]=+n[G+(ma-b<<2)>>2]+(ja+M);if(aa)p[E+(ma<<3)>>3]=ka+ca*ca+ +p[E+(ma-s<<3)>>3];n[K+(ma<<2)>>2]=H+M+ +n[K+(ma-R<<2)>>2];n[ba>>2]=M}E=aa?E+8|0:0;B=B+1|0;if((B|0)==(l|0))break;else{C=C+4|0;I=I+4|0;G=G+4|0;K=K+4|0}}na=g;oa=E;pa=W+(r<<2)|0;qa=t;ra=Z+(d<<2)|0}else{na=j;oa=h;pa=O;qa=P;ra=U}_=_+1|0;if((_|0)==(k|0))break;else{g=na;V=oa;W=pa;X=qa;Z=ra}}}if((N|0)!=(z|0)){QYa(N);f[q>>2]=z;f[e>>2]=264}u=m;return}function Zpa(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0.0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;m=u;u=u+1072|0;o=0-l|0;p=m;q=b>>>2;b=d>>>2;d=i>>>2;i=0-d|0;r=g>>>2;g=Y(l,j)|0;j=g+l|0;s=j<<2;F1a(c|0,0,s|0)|0;t=c+(b+l<<2)|0;if(!e)v=0;else{F1a(e|0,0,s|0)|0;v=e+(r+l<<2)|0}if(!h)w=0;else{F1a(h|0,0,s|0)|0;w=h+(d+l<<2)|0}h=(w|0)==0;if((v|0)==0&h){if((k|0)<=0){u=m;return}s=(g|0)>0;e=q-l|0;x=b-l|0;if((l|0)<=0){u=m;return}y=l+-1|0;z=l<<2;A=a;B=t;C=0;while(1){if(s){D=0;E=A;F=B;while(1){n[F+(o<<2)>>2]=0.0;G=0.0;H=0;do{G=G+ +n[E+(H<<2)>>2];n[F+(H<<2)>>2]=+n[F+(H-b<<2)>>2]+G;H=H+l|0}while((H|0)<(g|0));D=D+1|0;if((D|0)==(l|0))break;else{E=E+4|0;F=F+4|0}}}else F1a(B+(o<<2)|0,0,z|0)|0;C=C+1|0;if((C|0)==(k|0))break;else{A=A+(y<<2)+4+(e<<2)|0;B=B+(y<<2)+4+(x<<2)|0}}u=m;return}if(h){if((k|0)<=0){u=m;return}h=(g|0)>0;x=q-l|0;y=b-l|0;B=r-l|0;if((l|0)<=0){u=m;return}e=l+-1|0;A=v;C=a;z=t;s=0;while(1){if(h){F=0;E=A;D=C;H=z;while(1){n[H+(o<<2)>>2]=0.0;n[E+(o<<2)>>2]=0.0;G=0.0;I=0.0;J=0;do{K=+n[D+(J<<2)>>2];G=G+K;I=I+K*K;K=+n[E+(J-r<<2)>>2]+I;n[H+(J<<2)>>2]=+n[H+(J-b<<2)>>2]+G;n[E+(J<<2)>>2]=K;J=J+l|0}while((J|0)<(g|0));F=F+1|0;if((F|0)==(l|0))break;else{E=E+4|0;D=D+4|0;H=H+4|0}}}else{H=0;D=A;E=z;while(1){n[E+(o<<2)>>2]=0.0;n[D+(o<<2)>>2]=0.0;H=H+1|0;if((H|0)==(l|0))break;else{D=D+4|0;E=E+4|0}}}s=s+1|0;if((s|0)==(k|0))break;else{A=A+(e<<2)+4+(B<<2)|0;C=C+(e<<2)+4+(x<<2)|0;z=z+(e<<2)+4+(y<<2)|0}}u=m;return}y=p+8|0;f[p>>2]=y;e=p+4|0;f[e>>2]=j;if(j>>>0>264){z=OYa(j>>>0>1073741823?-1:j<<2)|0;f[p>>2]=z;L=z}else L=y;z=(l|0)>0;do if(z){j=(g|0)==(l|0);x=b+(l<<1)|0;C=w+(l<<2)|0;if((g|0)>0){M=L;N=0;O=v;P=a;Q=t;R=w}else{B=L;A=0;s=v;h=t;E=w;while(1){n[E+(o<<2)>>2]=0.0;n[h+(o<<2)>>2]=0.0;if(j)n[B+(l<<2)>>2]=0.0;if(!s)S=0;else{n[s+(o<<2)>>2]=0.0;S=s+4|0}A=A+1|0;if((A|0)==(l|0))break;else{B=B+4|0;s=S;h=h+4|0;E=E+4|0}}T=L+(l<<2)|0;U=S;V=a+(l<<2)|0;W=c+(x<<2)|0;X=C;break}while(1){n[R+(o<<2)>>2]=0.0;n[Q+(o<<2)>>2]=0.0;E=(O|0)!=0;if(E){G=0.0;I=0.0;h=0;do{K=+n[P+(h<<2)>>2];n[R+(h<<2)>>2]=K;n[M+(h<<2)>>2]=K;G=G+K;I=I+K*K;n[Q+(h<<2)>>2]=G;n[O+(h<<2)>>2]=I;h=h+l|0}while((h|0)<(g|0))}else{I=0.0;h=0;do{G=+n[P+(h<<2)>>2];n[R+(h<<2)>>2]=G;n[M+(h<<2)>>2]=G;I=I+G;n[Q+(h<<2)>>2]=I;h=h+l|0}while((h|0)<(g|0))}if(j)n[M+(l<<2)>>2]=0.0;if(E){n[O+(o<<2)>>2]=0.0;Z=O+4|0}else Z=0;N=N+1|0;if((N|0)==(l|0))break;else{M=M+4|0;O=Z;P=P+4|0;Q=Q+4|0;R=R+4|0}}T=L+(l<<2)|0;U=Z;V=a+(l<<2)|0;W=c+(x<<2)|0;X=C}else{T=L;U=v;V=a;W=t;X=w}while(0);if((k|0)>1){w=q-l|0;t=b-l|0;a=d-l|0;v=r-l|0;c=0-b|0;Z=0-r|0;R=g-l|0;Q=(R|0)>(l|0);P=d+l|0;O=(g|0)>(l|0);g=T;T=U;U=V;V=W;W=X;X=1;while(1){M=U+(w<<2)|0;N=V+(t<<2)|0;S=W+(a<<2)|0;j=g+(o<<2)|0;h=(T|0)==0?0:T+(v<<2)|0;if(z){s=V+(b<<2)|0;B=j;A=0;D=h;H=M;F=N;J=S;while(1){I=+n[H>>2];G=I*I;n[F+(o<<2)>>2]=0.0;_=(D|0)!=0;if(_)n[D+(o<<2)>>2]=0.0;$=J+(i<<2)|0;f[J+(o<<2)>>2]=f[$>>2];n[F>>2]=I+ +n[F+(c<<2)>>2];if(_)n[D>>2]=G+ +n[D+(Z<<2)>>2];n[J>>2]=I+ +n[$>>2]+ +n[B+(l<<2)>>2];if(Q)if(_){K=I;aa=G;ba=I;$=l;while(1){ca=+n[B+($<<2)>>2];n[B+($-l<<2)>>2]=ba+ca;da=+n[H+($<<2)>>2];ea=K+da;fa=aa+da*da;n[F+($<<2)>>2]=+n[F+($-b<<2)>>2]+ea;n[D+($<<2)>>2]=fa+ +n[D+($-r<<2)>>2];ga=$+l|0;n[J+($<<2)>>2]=ca+(da+ +n[B+(ga<<2)>>2]+ +n[J+($-P<<2)>>2]);if((ga|0)<(R|0)){K=ea;aa=fa;ba=da;$=ga}else{ha=ea;ia=fa;ja=da;ka=ga;break}}}else{ba=I;aa=G;K=I;$=l;while(1){da=+n[B+($<<2)>>2];n[B+($-l<<2)>>2]=K+da;fa=+n[H+($<<2)>>2];ea=ba+fa;ca=aa+fa*fa;n[F+($<<2)>>2]=+n[F+($-b<<2)>>2]+ea;E=$+l|0;n[J+($<<2)>>2]=da+(fa+ +n[B+(E<<2)>>2]+ +n[J+($-P<<2)>>2]);if((E|0)<(R|0)){ba=ea;aa=ca;K=fa;$=E}else{ha=ea;ia=ca;ja=fa;ka=E;break}}}else{ha=I;ia=G;ja=I;ka=l}if(O){$=B+(ka<<2)|0;K=+n[$>>2];n[B+(ka-l<<2)>>2]=ja+K;aa=+n[H+(ka<<2)>>2];n[F+(ka<<2)>>2]=+n[F+(ka-b<<2)>>2]+(ha+aa);if(_)n[D+(ka<<2)>>2]=ia+aa*aa+ +n[D+(ka-r<<2)>>2];n[J+(ka<<2)>>2]=K+aa+ +n[J+(ka-P<<2)>>2];n[$>>2]=aa}D=_?D+4|0:0;A=A+1|0;if((A|0)==(l|0))break;else{B=B+4|0;H=H+4|0;F=F+4|0;J=J+4|0}}la=g;ma=D;na=U+(q<<2)|0;oa=s;pa=W+(d<<2)|0}else{la=j;ma=h;na=M;oa=N;pa=S}X=X+1|0;if((X|0)==(k|0))break;else{g=la;T=ma;U=na;V=oa;W=pa}}}if((L|0)!=(y|0)){QYa(L);f[p>>2]=y;f[e>>2]=264}u=m;return}function _pa(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;m=u;u=u+1104|0;o=0-l|0;q=m;r=b>>>2;b=d>>>3;d=i>>>3;i=0-d|0;s=g>>>3;g=Y(l,j)|0;j=g+l|0;t=j<<3;F1a(c|0,0,t|0)|0;v=c+(b+l<<3)|0;if(!e)w=0;else{F1a(e|0,0,t|0)|0;w=e+(s+l<<3)|0}if(!h)x=0;else{F1a(h|0,0,t|0)|0;x=h+(d+l<<3)|0}h=(x|0)==0;if((w|0)==0&h){if((k|0)<=0){u=m;return}t=(g|0)>0;e=r-l|0;y=b-l|0;if((l|0)<=0){u=m;return}z=l+-1|0;A=l<<3;B=a;C=v;D=0;while(1){if(t){E=0;F=B;G=C;while(1){p[G+(o<<3)>>3]=0.0;H=0.0;I=0;do{H=H+ +n[F+(I<<2)>>2];p[G+(I<<3)>>3]=+p[G+(I-b<<3)>>3]+H;I=I+l|0}while((I|0)<(g|0));E=E+1|0;if((E|0)==(l|0))break;else{F=F+4|0;G=G+8|0}}}else F1a(C+(o<<3)|0,0,A|0)|0;D=D+1|0;if((D|0)==(k|0))break;else{B=B+(z<<2)+4+(e<<2)|0;C=C+(z<<3)+8+(y<<3)|0}}u=m;return}if(h){if((k|0)<=0){u=m;return}h=(g|0)>0;y=r-l|0;z=b-l|0;C=s-l|0;if((l|0)<=0){u=m;return}e=l+-1|0;B=w;D=a;A=v;t=0;while(1){if(h){G=0;F=B;E=D;I=A;while(1){p[I+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;H=0.0;J=0.0;K=0;do{L=+n[E+(K<<2)>>2];H=H+L;J=J+L*L;L=+p[F+(K-s<<3)>>3]+J;p[I+(K<<3)>>3]=+p[I+(K-b<<3)>>3]+H;p[F+(K<<3)>>3]=L;K=K+l|0}while((K|0)<(g|0));G=G+1|0;if((G|0)==(l|0))break;else{F=F+8|0;E=E+4|0;I=I+8|0}}}else{I=0;E=B;F=A;while(1){p[F+(o<<3)>>3]=0.0;p[E+(o<<3)>>3]=0.0;I=I+1|0;if((I|0)==(l|0))break;else{E=E+8|0;F=F+8|0}}}t=t+1|0;if((t|0)==(k|0))break;else{B=B+(e<<3)+8+(C<<3)|0;D=D+(e<<2)+4+(y<<2)|0;A=A+(e<<3)+8+(z<<3)|0}}u=m;return}z=q+8|0;f[q>>2]=z;e=q+4|0;f[e>>2]=j;if(j>>>0>136){A=OYa(j>>>0>536870911?-1:j<<3)|0;f[q>>2]=A;M=A}else M=z;A=(l|0)>0;do if(A){j=(g|0)==(l|0);y=b+(l<<1)|0;D=x+(l<<3)|0;if((g|0)>0){N=M;O=0;P=w;Q=a;R=v;S=x}else{C=M;B=0;t=w;h=v;F=x;while(1){p[F+(o<<3)>>3]=0.0;p[h+(o<<3)>>3]=0.0;if(j)p[C+(l<<3)>>3]=0.0;if(!t)T=0;else{p[t+(o<<3)>>3]=0.0;T=t+8|0}B=B+1|0;if((B|0)==(l|0))break;else{C=C+8|0;t=T;h=h+8|0;F=F+8|0}}U=M+(l<<3)|0;V=T;W=a+(l<<2)|0;X=c+(y<<3)|0;Z=D;break}while(1){p[S+(o<<3)>>3]=0.0;p[R+(o<<3)>>3]=0.0;F=(P|0)!=0;if(F){H=0.0;J=0.0;h=0;do{L=+n[Q+(h<<2)>>2];p[S+(h<<3)>>3]=L;p[N+(h<<3)>>3]=L;H=H+L;J=J+L*L;p[R+(h<<3)>>3]=H;p[P+(h<<3)>>3]=J;h=h+l|0}while((h|0)<(g|0))}else{J=0.0;h=0;do{H=+n[Q+(h<<2)>>2];p[S+(h<<3)>>3]=H;p[N+(h<<3)>>3]=H;J=J+H;p[R+(h<<3)>>3]=J;h=h+l|0}while((h|0)<(g|0))}if(j)p[N+(l<<3)>>3]=0.0;if(F){p[P+(o<<3)>>3]=0.0;_=P+8|0}else _=0;O=O+1|0;if((O|0)==(l|0))break;else{N=N+8|0;P=_;Q=Q+4|0;R=R+8|0;S=S+8|0}}U=M+(l<<3)|0;V=_;W=a+(l<<2)|0;X=c+(y<<3)|0;Z=D}else{U=M;V=w;W=a;X=v;Z=x}while(0);if((k|0)>1){x=r-l|0;v=b-l|0;a=d-l|0;w=s-l|0;c=0-b|0;_=0-s|0;S=g-l|0;R=(S|0)>(l|0);Q=d+l|0;P=(g|0)>(l|0);g=U;U=V;V=W;W=X;X=Z;Z=1;while(1){N=V+(x<<2)|0;O=W+(v<<3)|0;T=X+(a<<3)|0;j=g+(o<<3)|0;h=(U|0)==0?0:U+(w<<3)|0;if(A){t=W+(b<<3)|0;C=j;B=0;E=h;I=N;G=O;K=T;while(1){J=+n[I>>2];H=J*J;p[G+(o<<3)>>3]=0.0;$=(E|0)!=0;if($)p[E+(o<<3)>>3]=0.0;aa=K+(i<<3)|0;p[K+(o<<3)>>3]=+p[aa>>3];p[G>>3]=J+ +p[G+(c<<3)>>3];if($)p[E>>3]=H+ +p[E+(_<<3)>>3];p[K>>3]=J+ +p[aa>>3]+ +p[C+(l<<3)>>3];if(R)if($){L=J;ba=H;ca=J;aa=l;while(1){da=+p[C+(aa<<3)>>3];p[C+(aa-l<<3)>>3]=ca+da;ea=+n[I+(aa<<2)>>2];fa=L+ea;ga=ba+ea*ea;p[G+(aa<<3)>>3]=+p[G+(aa-b<<3)>>3]+fa;p[E+(aa<<3)>>3]=ga+ +p[E+(aa-s<<3)>>3];ha=aa+l|0;p[K+(aa<<3)>>3]=da+(ea+ +p[C+(ha<<3)>>3]+ +p[K+(aa-Q<<3)>>3]);if((ha|0)<(S|0)){L=fa;ba=ga;ca=ea;aa=ha}else{ia=fa;ja=ga;ka=ea;la=ha;break}}}else{ca=J;ba=H;L=J;aa=l;while(1){ea=+p[C+(aa<<3)>>3];p[C+(aa-l<<3)>>3]=L+ea;ga=+n[I+(aa<<2)>>2];fa=ca+ga;da=ba+ga*ga;p[G+(aa<<3)>>3]=+p[G+(aa-b<<3)>>3]+fa;F=aa+l|0;p[K+(aa<<3)>>3]=ea+(ga+ +p[C+(F<<3)>>3]+ +p[K+(aa-Q<<3)>>3]);if((F|0)<(S|0)){ca=fa;ba=da;L=ga;aa=F}else{ia=fa;ja=da;ka=ga;la=F;break}}}else{ia=J;ja=H;ka=J;la=l}if(P){aa=C+(la<<3)|0;L=+p[aa>>3];p[C+(la-l<<3)>>3]=ka+L;ba=+n[I+(la<<2)>>2];p[G+(la<<3)>>3]=+p[G+(la-b<<3)>>3]+(ia+ba);if($)p[E+(la<<3)>>3]=ja+ba*ba+ +p[E+(la-s<<3)>>3];p[K+(la<<3)>>3]=L+ba+ +p[K+(la-Q<<3)>>3];p[aa>>3]=ba}E=$?E+8|0:0;B=B+1|0;if((B|0)==(l|0))break;else{C=C+8|0;I=I+4|0;G=G+8|0;K=K+8|0}}ma=g;na=E;oa=V+(r<<2)|0;pa=t;qa=X+(d<<3)|0}else{ma=j;na=h;oa=N;pa=O;qa=T}Z=Z+1|0;if((Z|0)==(k|0))break;else{g=ma;U=na;V=oa;W=pa;X=qa}}}if((M|0)!=(z|0)){QYa(M);f[q>>2]=z;f[e>>2]=136}u=m;return}function $pa(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0.0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;m=u;u=u+1104|0;n=0-l|0;o=m;q=b>>>3;b=d>>>3;d=i>>>3;i=0-d|0;r=g>>>3;g=Y(l,j)|0;j=g+l|0;s=j<<3;F1a(c|0,0,s|0)|0;t=c+(b+l<<3)|0;if(!e)v=0;else{F1a(e|0,0,s|0)|0;v=e+(r+l<<3)|0}if(!h)w=0;else{F1a(h|0,0,s|0)|0;w=h+(d+l<<3)|0}h=(w|0)==0;if((v|0)==0&h){if((k|0)<=0){u=m;return}s=(g|0)>0;e=q-l|0;x=b-l|0;if((l|0)<=0){u=m;return}y=l+-1|0;z=l<<3;A=a;B=t;C=0;while(1){if(s){D=0;E=A;F=B;while(1){p[F+(n<<3)>>3]=0.0;G=0.0;H=0;do{G=G+ +p[E+(H<<3)>>3];p[F+(H<<3)>>3]=+p[F+(H-b<<3)>>3]+G;H=H+l|0}while((H|0)<(g|0));D=D+1|0;if((D|0)==(l|0))break;else{E=E+8|0;F=F+8|0}}}else F1a(B+(n<<3)|0,0,z|0)|0;C=C+1|0;if((C|0)==(k|0))break;else{A=A+(y<<3)+8+(e<<3)|0;B=B+(y<<3)+8+(x<<3)|0}}u=m;return}if(h){if((k|0)<=0){u=m;return}h=(g|0)>0;x=q-l|0;y=b-l|0;B=r-l|0;if((l|0)<=0){u=m;return}e=l+-1|0;A=v;C=a;z=t;s=0;while(1){if(h){F=0;E=A;D=C;H=z;while(1){p[H+(n<<3)>>3]=0.0;p[E+(n<<3)>>3]=0.0;G=0.0;I=0.0;J=0;do{K=+p[D+(J<<3)>>3];G=G+K;I=I+K*K;K=+p[E+(J-r<<3)>>3]+I;p[H+(J<<3)>>3]=+p[H+(J-b<<3)>>3]+G;p[E+(J<<3)>>3]=K;J=J+l|0}while((J|0)<(g|0));F=F+1|0;if((F|0)==(l|0))break;else{E=E+8|0;D=D+8|0;H=H+8|0}}}else{H=0;D=A;E=z;while(1){p[E+(n<<3)>>3]=0.0;p[D+(n<<3)>>3]=0.0;H=H+1|0;if((H|0)==(l|0))break;else{D=D+8|0;E=E+8|0}}}s=s+1|0;if((s|0)==(k|0))break;else{A=A+(e<<3)+8+(B<<3)|0;C=C+(e<<3)+8+(x<<3)|0;z=z+(e<<3)+8+(y<<3)|0}}u=m;return}y=o+8|0;f[o>>2]=y;e=o+4|0;f[e>>2]=j;if(j>>>0>136){z=OYa(j>>>0>536870911?-1:j<<3)|0;f[o>>2]=z;L=z}else L=y;z=(l|0)>0;do if(z){j=(g|0)==(l|0);x=b+(l<<1)|0;C=w+(l<<3)|0;if((g|0)>0){M=L;N=0;O=v;P=a;Q=t;R=w}else{B=L;A=0;s=v;h=t;E=w;while(1){p[E+(n<<3)>>3]=0.0;p[h+(n<<3)>>3]=0.0;if(j)p[B+(l<<3)>>3]=0.0;if(!s)S=0;else{p[s+(n<<3)>>3]=0.0;S=s+8|0}A=A+1|0;if((A|0)==(l|0))break;else{B=B+8|0;s=S;h=h+8|0;E=E+8|0}}T=L+(l<<3)|0;U=S;V=a+(l<<3)|0;W=c+(x<<3)|0;X=C;break}while(1){p[R+(n<<3)>>3]=0.0;p[Q+(n<<3)>>3]=0.0;E=(O|0)!=0;if(E){G=0.0;I=0.0;h=0;do{K=+p[P+(h<<3)>>3];p[R+(h<<3)>>3]=K;p[M+(h<<3)>>3]=K;G=G+K;I=I+K*K;p[Q+(h<<3)>>3]=G;p[O+(h<<3)>>3]=I;h=h+l|0}while((h|0)<(g|0))}else{I=0.0;h=0;do{G=+p[P+(h<<3)>>3];p[R+(h<<3)>>3]=G;p[M+(h<<3)>>3]=G;I=I+G;p[Q+(h<<3)>>3]=I;h=h+l|0}while((h|0)<(g|0))}if(j)p[M+(l<<3)>>3]=0.0;if(E){p[O+(n<<3)>>3]=0.0;Z=O+8|0}else Z=0;N=N+1|0;if((N|0)==(l|0))break;else{M=M+8|0;O=Z;P=P+8|0;Q=Q+8|0;R=R+8|0}}T=L+(l<<3)|0;U=Z;V=a+(l<<3)|0;W=c+(x<<3)|0;X=C}else{T=L;U=v;V=a;W=t;X=w}while(0);if((k|0)>1){w=q-l|0;t=b-l|0;a=d-l|0;v=r-l|0;c=0-b|0;Z=0-r|0;R=g-l|0;Q=(R|0)>(l|0);P=d+l|0;O=(g|0)>(l|0);g=T;T=U;U=V;V=W;W=X;X=1;while(1){M=U+(w<<3)|0;N=V+(t<<3)|0;S=W+(a<<3)|0;j=g+(n<<3)|0;h=(T|0)==0?0:T+(v<<3)|0;if(z){s=V+(b<<3)|0;B=j;A=0;D=h;H=M;F=N;J=S;while(1){I=+p[H>>3];G=I*I;p[F+(n<<3)>>3]=0.0;_=(D|0)!=0;if(_)p[D+(n<<3)>>3]=0.0;$=J+(i<<3)|0;p[J+(n<<3)>>3]=+p[$>>3];p[F>>3]=I+ +p[F+(c<<3)>>3];if(_)p[D>>3]=G+ +p[D+(Z<<3)>>3];p[J>>3]=I+ +p[$>>3]+ +p[B+(l<<3)>>3];if(Q)if(_){K=I;aa=G;ba=I;$=l;while(1){ca=+p[B+($<<3)>>3];p[B+($-l<<3)>>3]=ba+ca;da=+p[H+($<<3)>>3];ea=K+da;fa=aa+da*da;p[F+($<<3)>>3]=+p[F+($-b<<3)>>3]+ea;p[D+($<<3)>>3]=fa+ +p[D+($-r<<3)>>3];ga=$+l|0;p[J+($<<3)>>3]=ca+(da+ +p[B+(ga<<3)>>3]+ +p[J+($-P<<3)>>3]);if((ga|0)<(R|0)){K=ea;aa=fa;ba=da;$=ga}else{ha=ea;ia=fa;ja=da;ka=ga;break}}}else{ba=I;aa=G;K=I;$=l;while(1){da=+p[B+($<<3)>>3];p[B+($-l<<3)>>3]=K+da;fa=+p[H+($<<3)>>3];ea=ba+fa;ca=aa+fa*fa;p[F+($<<3)>>3]=+p[F+($-b<<3)>>3]+ea;E=$+l|0;p[J+($<<3)>>3]=da+(fa+ +p[B+(E<<3)>>3]+ +p[J+($-P<<3)>>3]);if((E|0)<(R|0)){ba=ea;aa=ca;K=fa;$=E}else{ha=ea;ia=ca;ja=fa;ka=E;break}}}else{ha=I;ia=G;ja=I;ka=l}if(O){$=B+(ka<<3)|0;K=+p[$>>3];p[B+(ka-l<<3)>>3]=ja+K;aa=+p[H+(ka<<3)>>3];p[F+(ka<<3)>>3]=+p[F+(ka-b<<3)>>3]+(ha+aa);if(_)p[D+(ka<<3)>>3]=ia+aa*aa+ +p[D+(ka-r<<3)>>3];p[J+(ka<<3)>>3]=K+aa+ +p[J+(ka-P<<3)>>3];p[$>>3]=aa}D=_?D+8|0:0;A=A+1|0;if((A|0)==(l|0))break;else{B=B+8|0;H=H+8|0;F=F+8|0;J=J+8|0}}la=g;ma=D;na=U+(q<<3)|0;oa=s;pa=W+(d<<3)|0}else{la=j;ma=h;na=M;oa=N;pa=S}X=X+1|0;if((X|0)==(k|0))break;else{g=la;T=ma;U=na;V=oa;W=pa}}}if((L|0)!=(y|0)){QYa(L);f[o>>2]=y;f[e>>2]=136}u=m;return}function aqa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;h=u;u=u+320|0;i=h+312|0;j=h+304|0;k=h+240|0;l=h+248|0;m=h+184|0;n=h+128|0;o=h+72|0;p=h+8|0;q=h+16|0;r=h;_$(i,76464);s=RR(a,-1)|0;t=s&7;v=s>>>3&511;s=v+1|0;w=((e|0)<1?((t|0)==0?4:6):e)&7;e=(g|0)<1?6:g&7;QR(j,a,-1);g=(f[j>>2]|0)+1|0;x=(f[j+4>>2]|0)+1|0;f[k>>2]=g;f[k+4>>2]=x;j=v<<3;v=w|j;KS(b,k,v,-1,0,0);do if((NS(a)|0)==65536){k=f[a+4>>2]|0;f[l>>2]=f[k>>2];y=l+4|0;z=k+4|0;f[y>>2]=f[z>>2];A=l+8|0;f[A>>2]=f[k+8>>2];f[l+12>>2]=f[k+12>>2];f[l+16>>2]=f[k+16>>2];f[l+20>>2]=f[k+20>>2];f[l+24>>2]=f[k+24>>2];f[l+28>>2]=f[k+28>>2];f[l+32>>2]=f[k+32>>2];B=f[k+36>>2]|0;f[l+36>>2]=B;f[l+40>>2]=A;A=l+48|0;C=l+44|0;f[C>>2]=A;f[A>>2]=0;f[l+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[k+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;BR(l,k);break}}else OR(l,a,-1);while(0);do if((NS(b)|0)==65536){a=f[b+4>>2]|0;f[m>>2]=f[a>>2];k=m+4|0;y=a+4|0;f[k>>2]=f[y>>2];z=m+8|0;f[z>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];A=f[a+36>>2]|0;f[m+36>>2]=A;f[m+40>>2]=z;z=m+48|0;C=m+44|0;f[C>>2]=z;f[z>>2]=0;f[m+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[a+44>>2]|0;z=f[C>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[k>>2]=0;BR(m,a);break}}else OR(m,b,-1);while(0);f[n>>2]=1124007936;b=n+4|0;a=n+8|0;k=n+40|0;y=b;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[k>>2]=a;C=n+48|0;A=n+44|0;f[A>>2]=C;f[C>>2]=0;f[n+52>>2]=0;f[o>>2]=1124007936;B=o+4|0;D=o+8|0;E=o+40|0;y=B;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[E>>2]=D;y=o+48|0;z=o+44|0;f[z>>2]=y;f[y>>2]=0;f[o+52>>2]=0;if(dT(c)|0){f[p>>2]=g;f[p+4>>2]=x;KS(c,p,j|e,-1,0,0);do if((NS(c)|0)==65536){j=f[c+4>>2]|0;f[q>>2]=f[j>>2];p=q+4|0;F=j+4|0;f[p>>2]=f[F>>2];G=q+8|0;f[G>>2]=f[j+8>>2];f[q+12>>2]=f[j+12>>2];f[q+16>>2]=f[j+16>>2];f[q+20>>2]=f[j+20>>2];f[q+24>>2]=f[j+24>>2];f[q+28>>2]=f[j+28>>2];f[q+32>>2]=f[j+32>>2];H=q+36|0;I=f[j+36>>2]|0;f[H>>2]=I;f[q+40>>2]=G;G=q+48|0;J=q+44|0;f[J>>2]=G;f[G>>2]=0;f[q+52>>2]=0;if(I|0){G=I+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[F>>2]|0)<3){F=f[j+44>>2]|0;G=f[J>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=f[F+4>>2];K=H;break}else{f[p>>2]=0;BR(q,j);K=H;break}}else{OR(q,c,-1);K=q+36|0}while(0);c=f[K>>2]|0;if(c|0){H=c+12|0;f[H>>2]=(f[H>>2]|0)+1}H=n+36|0;c=f[H>>2]|0;if(c|0?(j=c+12|0,c=f[j>>2]|0,f[j>>2]=c+-1,(c|0)==1):0)CR(n);f[H>>2]=0;c=n+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){j=f[k>>2]|0;p=0;do{f[j+(p<<2)>>2]=0;p=p+1|0;L=f[b>>2]|0}while((p|0)<(L|0));f[n>>2]=f[q>>2];if((L|0)<3)M=33;else M=35}else{f[n>>2]=f[q>>2];M=33}if((M|0)==33){L=f[q+4>>2]|0;if((L|0)<3){f[b>>2]=L;f[a>>2]=f[q+8>>2];f[n+12>>2]=f[q+12>>2];a=f[q+44>>2]|0;L=f[A>>2]|0;f[L>>2]=f[a>>2];f[L+4>>2]=f[a+4>>2]}else M=35}if((M|0)==35)BR(n,q);a=q+16|0;f[c>>2]=f[a>>2];f[n+20>>2]=f[q+20>>2];f[n+24>>2]=f[q+24>>2];f[n+28>>2]=f[q+28>>2];f[n+32>>2]=f[q+32>>2];c=f[K>>2]|0;f[H>>2]=c;if(c|0?(H=c+12|0,c=f[H>>2]|0,f[H>>2]=c+-1,(c|0)==1):0)CR(q);f[K>>2]=0;K=q+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[K>>2]|0)>0){a=f[q+40>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[K>>2]|0))}K=f[q+44>>2]|0;if((K|0)!=(q+48|0))ZF(K)}if(dT(d)|0){f[r>>2]=g;f[r+4>>2]=x;KS(d,r,v,-1,0,0);do if((NS(d)|0)==65536){v=f[d+4>>2]|0;f[q>>2]=f[v>>2];r=q+4|0;x=v+4|0;f[r>>2]=f[x>>2];g=q+8|0;f[g>>2]=f[v+8>>2];f[q+12>>2]=f[v+12>>2];f[q+16>>2]=f[v+16>>2];f[q+20>>2]=f[v+20>>2];f[q+24>>2]=f[v+24>>2];f[q+28>>2]=f[v+28>>2];f[q+32>>2]=f[v+32>>2];K=q+36|0;c=f[v+36>>2]|0;f[K>>2]=c;f[q+40>>2]=g;g=q+48|0;a=q+44|0;f[a>>2]=g;f[g>>2]=0;f[q+52>>2]=0;if(c|0){g=c+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[x>>2]|0)<3){x=f[v+44>>2]|0;g=f[a>>2]|0;f[g>>2]=f[x>>2];f[g+4>>2]=f[x+4>>2];N=K;break}else{f[r>>2]=0;BR(q,v);N=K;break}}else{OR(q,d,-1);N=q+36|0}while(0);d=f[N>>2]|0;if(d|0){K=d+12|0;f[K>>2]=(f[K>>2]|0)+1}K=o+36|0;d=f[K>>2]|0;if(d|0?(v=d+12|0,d=f[v>>2]|0,f[v>>2]=d+-1,(d|0)==1):0)CR(o);f[K>>2]=0;d=o+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[B>>2]|0)>0){v=f[E>>2]|0;r=0;do{f[v+(r<<2)>>2]=0;r=r+1|0;O=f[B>>2]|0}while((r|0)<(O|0));f[o>>2]=f[q>>2];if((O|0)<3)M=64;else M=66}else{f[o>>2]=f[q>>2];M=64}if((M|0)==64){O=f[q+4>>2]|0;if((O|0)<3){f[B>>2]=O;f[D>>2]=f[q+8>>2];f[o+12>>2]=f[q+12>>2];D=f[q+44>>2]|0;O=f[z>>2]|0;f[O>>2]=f[D>>2];f[O+4>>2]=f[D+4>>2]}else M=66}if((M|0)==66)BR(o,q);M=q+16|0;f[d>>2]=f[M>>2];f[o+20>>2]=f[q+20>>2];f[o+24>>2]=f[q+24>>2];f[o+28>>2]=f[q+28>>2];f[o+32>>2]=f[q+32>>2];D=f[N>>2]|0;f[K>>2]=D;if(D|0?(K=D+12|0,D=f[K>>2]|0,f[K>>2]=D+-1,(D|0)==1):0)CR(q);f[N>>2]=0;N=q+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[N>>2]|0)>0){M=f[q+40>>2]|0;D=0;do{f[M+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[N>>2]|0))}N=f[q+44>>2]|0;if((N|0)!=(q+48|0))ZF(N);P=d}else P=o+16|0;d=l+16|0;N=l+44|0;q=l+48|0;D=m+16|0;M=m+44|0;K=m+48|0;O=n+16|0;Ppa(t,w,e,f[d>>2]|0,f[q>>2]|0,f[D>>2]|0,f[K>>2]|0,f[O>>2]|0,f[C>>2]|0,f[P>>2]|0,f[y>>2]|0,f[l+12>>2]|0,f[l+8>>2]|0,s);s=o+36|0;e=f[s>>2]|0;if(e|0?(w=e+12|0,e=f[w>>2]|0,f[w>>2]=e+-1,(e|0)==1):0)CR(o);f[s>>2]=0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[B>>2]|0)>0){P=f[E>>2]|0;E=0;do{f[P+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[B>>2]|0))}B=f[z>>2]|0;if((B|0)!=(y|0))ZF(B);B=n+36|0;y=f[B>>2]|0;if(y|0?(z=y+12|0,y=f[z>>2]|0,f[z>>2]=y+-1,(y|0)==1):0)CR(n);f[B>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[b>>2]|0)>0){O=f[k>>2]|0;k=0;do{f[O+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[b>>2]|0))}b=f[A>>2]|0;if((b|0)!=(C|0))ZF(b);b=m+36|0;C=f[b>>2]|0;if(C|0?(A=C+12|0,C=f[A>>2]|0,f[A>>2]=C+-1,(C|0)==1):0)CR(m);f[b>>2]=0;b=m+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[b>>2]|0)>0){D=f[m+40>>2]|0;m=0;do{f[D+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[b>>2]|0))}b=f[M>>2]|0;if((b|0)!=(K|0))ZF(b);b=l+36|0;K=f[b>>2]|0;if(K|0?(M=K+12|0,K=f[M>>2]|0,f[M>>2]=K+-1,(K|0)==1):0)CR(l);f[b>>2]=0;b=l+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[l+40>>2]|0;l=0;do{f[d+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[b>>2]|0))}b=f[N>>2]|0;if((b|0)!=(q|0))ZF(b);if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function bqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;_$(e,76484);g=fT()|0;aqa(a,b,g,fT()|0,c,-1);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function cqa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;_$(h,76504);aqa(a,b,c,fT()|0,d,e);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function dqa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;g=u;u=u+496|0;h=g+440|0;i=g+384|0;j=g+328|0;k=g+272|0;l=g+216|0;m=g+160|0;n=g+104|0;o=g+48|0;p=g+32|0;q=g+16|0;r=g;JR(h,a,0,1,0,0);JR(i,c,0,1,0,0);f[j>>2]=f[i>>2];c=j+4|0;a=i+4|0;s=f[a>>2]|0;f[c>>2]=s;t=j+8|0;f[t>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];v=j+16|0;w=i+16|0;f[v>>2]=f[w>>2];f[j+20>>2]=f[i+20>>2];f[j+24>>2]=f[i+24>>2];f[j+28>>2]=f[i+28>>2];f[j+32>>2]=f[i+32>>2];x=j+36|0;y=i+36|0;z=f[y>>2]|0;f[x>>2]=z;A=j+40|0;f[A>>2]=t;t=j+48|0;B=j+44|0;f[B>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(!z)C=s;else{s=z+12|0;f[s>>2]=(f[s>>2]|0)+1;C=f[a>>2]|0}if((C|0)<3){C=f[i+44>>2]|0;s=f[B>>2]|0;f[s>>2]=f[C>>2];f[s+4>>2]=f[C+4>>2]}else{f[c>>2]=0;BR(j,i)}f[k>>2]=1124007936;C=k+4|0;s=k+8|0;z=k+40|0;D=C;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[z>>2]=s;F=k+48|0;G=k+44|0;f[G>>2]=F;f[F>>2]=0;f[k+52>>2]=0;f[l>>2]=1124007936;H=l+4|0;I=l+8|0;J=l+40|0;D=H;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[J>>2]=I;K=l+48|0;L=l+44|0;f[L>>2]=K;f[K>>2]=0;f[l+52>>2]=0;f[m>>2]=1124007936;M=m+4|0;N=m+8|0;O=m+40|0;D=M;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[O>>2]=N;P=m+48|0;Q=m+44|0;f[Q>>2]=P;f[P>>2]=0;f[m+52>>2]=0;f[n>>2]=1124007936;R=n+4|0;S=n+8|0;T=n+40|0;D=R;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[T>>2]=S;U=n+48|0;V=n+44|0;f[V>>2]=U;f[U>>2]=0;f[n+52>>2]=0;if(!d)W=0;else{JR(o,d,0,1,0,0);d=o+36|0;X=f[d>>2]|0;if(X|0){Y=X+12|0;f[Y>>2]=(f[Y>>2]|0)+1}Y=l+36|0;X=f[Y>>2]|0;if(X|0?(Z=X+12|0,X=f[Z>>2]|0,f[Z>>2]=X+-1,(X|0)==1):0)CR(l);f[Y>>2]=0;X=l+16|0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[H>>2]|0)>0){Z=f[J>>2]|0;_=0;do{f[Z+(_<<2)>>2]=0;_=_+1|0;$=f[H>>2]|0}while((_|0)<($|0));f[l>>2]=f[o>>2];if(($|0)<3)aa=17;else aa=19}else{f[l>>2]=f[o>>2];aa=17}if((aa|0)==17){$=f[o+4>>2]|0;if(($|0)<3){f[H>>2]=$;f[I>>2]=f[o+8>>2];f[l+12>>2]=f[o+12>>2];$=f[o+44>>2]|0;_=f[L>>2]|0;f[_>>2]=f[$>>2];f[_+4>>2]=f[$+4>>2]}else aa=19}if((aa|0)==19)BR(l,o);$=o+16|0;f[X>>2]=f[$>>2];_=l+20|0;f[_>>2]=f[o+20>>2];Z=l+24|0;f[Z>>2]=f[o+24>>2];ba=l+28|0;f[ba>>2]=f[o+28>>2];ca=l+32|0;f[ca>>2]=f[o+32>>2];da=f[d>>2]|0;f[Y>>2]=da;if(da|0){ea=da+12|0;f[ea>>2]=(f[ea>>2]|0)+1}ea=k+36|0;da=f[ea>>2]|0;if(da|0?(fa=da+12|0,da=f[fa>>2]|0,f[fa>>2]=da+-1,(da|0)==1):0)CR(k);f[ea>>2]=0;da=k+16|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[C>>2]|0)>0){fa=f[z>>2]|0;ga=0;do{f[fa+(ga<<2)>>2]=0;ga=ga+1|0;ha=f[C>>2]|0}while((ga|0)<(ha|0));f[k>>2]=f[l>>2];if((ha|0)<3)aa=30;else aa=32}else{f[k>>2]=f[l>>2];aa=30}if((aa|0)==30){ha=f[H>>2]|0;if((ha|0)<3){f[C>>2]=ha;f[s>>2]=f[I>>2];f[k+12>>2]=f[l+12>>2];I=f[L>>2]|0;s=f[G>>2]|0;f[s>>2]=f[I>>2];f[s+4>>2]=f[I+4>>2]}else aa=32}if((aa|0)==32)BR(k,l);f[da>>2]=f[X>>2];f[k+20>>2]=f[_>>2];f[k+24>>2]=f[Z>>2];f[k+28>>2]=f[ba>>2];f[k+32>>2]=f[ca>>2];f[ea>>2]=f[Y>>2];Y=f[d>>2]|0;if(Y|0?(ea=Y+12|0,Y=f[ea>>2]|0,f[ea>>2]=Y+-1,(Y|0)==1):0)CR(o);f[d>>2]=0;d=o+4|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[d>>2]|0)>0){$=f[o+40>>2]|0;Y=0;do{f[$+(Y<<2)>>2]=0;Y=Y+1|0}while((Y|0)<(f[d>>2]|0))}d=f[o+44>>2]|0;if((d|0)!=(o+48|0))ZF(d);W=l}if(!e)ia=0;else{JR(o,e,0,1,0,0);e=o+36|0;d=f[e>>2]|0;if(d|0){Y=d+12|0;f[Y>>2]=(f[Y>>2]|0)+1}Y=n+36|0;d=f[Y>>2]|0;if(d|0?($=d+12|0,d=f[$>>2]|0,f[$>>2]=d+-1,(d|0)==1):0)CR(n);f[Y>>2]=0;d=n+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[R>>2]|0)>0){$=f[T>>2]|0;ea=0;do{f[$+(ea<<2)>>2]=0;ea=ea+1|0;ja=f[R>>2]|0}while((ea|0)<(ja|0));f[n>>2]=f[o>>2];if((ja|0)<3)aa=53;else aa=55}else{f[n>>2]=f[o>>2];aa=53}if((aa|0)==53){ja=f[o+4>>2]|0;if((ja|0)<3){f[R>>2]=ja;f[S>>2]=f[o+8>>2];f[n+12>>2]=f[o+12>>2];ja=f[o+44>>2]|0;ea=f[V>>2]|0;f[ea>>2]=f[ja>>2];f[ea+4>>2]=f[ja+4>>2]}else aa=55}if((aa|0)==55)BR(n,o);ja=o+16|0;f[d>>2]=f[ja>>2];ea=n+20|0;f[ea>>2]=f[o+20>>2];$=n+24|0;f[$>>2]=f[o+24>>2];ca=n+28|0;f[ca>>2]=f[o+28>>2];ba=n+32|0;f[ba>>2]=f[o+32>>2];Z=f[e>>2]|0;f[Y>>2]=Z;if(Z|0){_=Z+12|0;f[_>>2]=(f[_>>2]|0)+1}_=m+36|0;Z=f[_>>2]|0;if(Z|0?(X=Z+12|0,Z=f[X>>2]|0,f[X>>2]=Z+-1,(Z|0)==1):0)CR(m);f[_>>2]=0;Z=m+16|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[M>>2]|0)>0){X=f[O>>2]|0;da=0;do{f[X+(da<<2)>>2]=0;da=da+1|0;ka=f[M>>2]|0}while((da|0)<(ka|0));f[m>>2]=f[n>>2];if((ka|0)<3)aa=66;else aa=68}else{f[m>>2]=f[n>>2];aa=66}if((aa|0)==66){ka=f[R>>2]|0;if((ka|0)<3){f[M>>2]=ka;f[N>>2]=f[S>>2];f[m+12>>2]=f[n+12>>2];S=f[V>>2]|0;N=f[Q>>2]|0;f[N>>2]=f[S>>2];f[N+4>>2]=f[S+4>>2]}else aa=68}if((aa|0)==68)BR(m,n);f[Z>>2]=f[d>>2];f[m+20>>2]=f[ea>>2];f[m+24>>2]=f[$>>2];f[m+28>>2]=f[ca>>2];f[m+32>>2]=f[ba>>2];f[_>>2]=f[Y>>2];Y=f[e>>2]|0;if(Y|0?(_=Y+12|0,Y=f[_>>2]|0,f[_>>2]=Y+-1,(Y|0)==1):0)CR(o);f[e>>2]=0;e=o+4|0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[e>>2]|0)>0){ja=f[o+40>>2]|0;Y=0;do{f[ja+(Y<<2)>>2]=0;Y=Y+1|0}while((Y|0)<(f[e>>2]|0))}e=f[o+44>>2]|0;if((e|0)!=(o+48|0))ZF(e);ia=n}f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=h;e=p+8|0;f[e>>2]=0;f[e+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=i;e=q+8|0;f[e>>2]=0;f[e+4>>2]=0;if(!W){f[q>>2]=33554432;f[q+4>>2]=0}else{f[q>>2]=33619968;f[q+4>>2]=W}W=r+8|0;f[W>>2]=0;f[W+4>>2]=0;if(!ia){f[r>>2]=33554432;f[r+4>>2]=0}else{f[r>>2]=33619968;f[r+4>>2]=ia}aqa(o,p,q,r,f[i>>2]&7,-1);if(!(((f[w>>2]|0)==(f[v>>2]|0)?(f[l+16>>2]|0)==(f[k+16>>2]|0):0)?(f[n+16>>2]|0)==(f[m+16>>2]|0):0)){f[o>>2]=0;f[o+4>>2]=0;D=c$(o,81)|0;r=331175;E=D+81|0;do{b[D>>0]=b[r>>0]|0;D=D+1|0;r=r+1|0}while((D|0)<(E|0));j$(-215,o,331257,330928,579);d$(o)}o=n+36|0;r=f[o>>2]|0;if(r|0?(D=r+12|0,r=f[D>>2]|0,f[D>>2]=r+-1,(r|0)==1):0)CR(n);f[o>>2]=0;o=n+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[R>>2]|0)>0){o=f[T>>2]|0;T=0;do{f[o+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[R>>2]|0))}R=f[V>>2]|0;if((R|0)!=(U|0))ZF(R);R=m+36|0;U=f[R>>2]|0;if(U|0?(V=U+12|0,U=f[V>>2]|0,f[V>>2]=U+-1,(U|0)==1):0)CR(m);f[R>>2]=0;R=m+16|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[M>>2]|0)>0){R=f[O>>2]|0;O=0;do{f[R+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[M>>2]|0))}M=f[Q>>2]|0;if((M|0)!=(P|0))ZF(M);M=l+36|0;P=f[M>>2]|0;if(P|0?(Q=P+12|0,P=f[Q>>2]|0,f[Q>>2]=P+-1,(P|0)==1):0)CR(l);f[M>>2]=0;M=l+16|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[H>>2]|0)>0){M=f[J>>2]|0;J=0;do{f[M+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[H>>2]|0))}H=f[L>>2]|0;if((H|0)!=(K|0))ZF(H);H=k+36|0;K=f[H>>2]|0;if(K|0?(L=K+12|0,K=f[L>>2]|0,f[L>>2]=K+-1,(K|0)==1):0)CR(k);f[H>>2]=0;H=k+16|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[C>>2]|0)>0){H=f[z>>2]|0;z=0;do{f[H+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[C>>2]|0))}C=f[G>>2]|0;if((C|0)!=(F|0))ZF(C);C=f[x>>2]|0;do if(C|0){F=C+12|0;G=f[F>>2]|0;f[F>>2]=G+-1;if((G|0)!=1)break;CR(j)}while(0);f[x>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[c>>2]|0)>0){v=f[A>>2]|0;A=0;do{f[v+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[c>>2]|0))}c=f[B>>2]|0;if((c|0)!=(t|0))ZF(c);c=f[y>>2]|0;do if(c|0){t=c+12|0;B=f[t>>2]|0;f[t>>2]=B+-1;if((B|0)!=1)break;CR(i)}while(0);f[y>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[a>>2]|0)>0){w=f[i+40>>2]|0;y=0;do{f[w+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[a>>2]|0))}a=f[i+44>>2]|0;if((a|0)!=(i+48|0))ZF(a);a=h+36|0;i=f[a>>2]|0;do if(i|0){y=i+12|0;w=f[y>>2]|0;f[y>>2]=w+-1;if((w|0)!=1)break;CR(h)}while(0);f[a>>2]=0;a=h+16|0;i=h+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[i>>2]|0)>0){a=f[h+40>>2]|0;w=0;do{f[a+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)==(h+48|0)){u=g;return}ZF(i);u=g;return}function eqa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0;k=u;u=u+816|0;l=k+88|0;m=k+792|0;n=k+736|0;o=k+732|0;p=k+728|0;q=k+672|0;r=k+616|0;s=k+608|0;t=k+552|0;v=k+496|0;w=k+440|0;x=k+32|0;y=k+384|0;z=k+328|0;A=k+272|0;B=k+216|0;C=k+160|0;D=k;E=k+144|0;f[m>>2]=0;F=m+4|0;f[F>>2]=0;f[m+8>>2]=0;f[n>>2]=f[c>>2];G=n+4|0;H=c+4|0;I=f[H>>2]|0;f[G>>2]=I;J=n+8|0;f[J>>2]=f[c+8>>2];K=n+12|0;f[K>>2]=f[c+12>>2];L=n+16|0;f[L>>2]=f[c+16>>2];M=n+20|0;f[M>>2]=f[c+20>>2];N=n+24|0;f[N>>2]=f[c+24>>2];O=n+28|0;f[O>>2]=f[c+28>>2];P=n+32|0;f[P>>2]=f[c+32>>2];Q=n+36|0;R=f[c+36>>2]|0;f[Q>>2]=R;S=n+40|0;f[S>>2]=J;T=n+48|0;U=n+44|0;f[U>>2]=T;f[T>>2]=0;f[n+52>>2]=0;if(!R)V=I;else{I=R+12|0;f[I>>2]=(f[I>>2]|0)+1;V=f[H>>2]|0}if((V|0)<3){V=f[c+44>>2]|0;H=f[U>>2]|0;f[H>>2]=f[V>>2];f[H+4>>2]=f[V+4>>2]}else{f[G>>2]=0;BR(n,c)}V=f[a>>2]|0;H=V&7;I=V>>>3;V=I&511;R=f[n>>2]|0;W=R&7;f[o>>2]=W;X=R>>>3&511;R=X+1|0;Z=g&7;f[p>>2]=Z;_=g>>>3;$=_&511;aa=a+4|0;if(!((f[aa>>2]|0)<3&(f[G>>2]|0)<3?(f[d+4>>2]|0)<3:0)){f[l>>2]=0;f[l+4>>2]=0;ba=c$(l,50)|0;ca=332037;da=ba+50|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));j$(-215,l,332088,332098,579);d$(l)}if((H|0)!=(W|0)){ea=H>>>0>5?H:5;if((W|0)==(ea|0))fa=W;else{W=l+8|0;f[W>>2]=0;f[W+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=n;WJ(c,l,ea,1.0,0.0);ea=f[n>>2]&7;f[o>>2]=ea;fa=ea}}else fa=H;if(!((H|0)==(fa|0)|(fa|0)==5)){f[l>>2]=0;f[l+4>>2]=0;ba=c$(l,30)|0;ca=332153;da=ba+30|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));j$(-215,l,332088,332098,587);d$(l)}ea=e+4|0;c=a+8|0;if(!((f[ea>>2]|0)<((f[J>>2]|0)+(f[c>>2]|0)|0)?(f[e>>2]|0)<((f[K>>2]|0)+(f[a+12>>2]|0)|0):0)){f[l>>2]=0;f[l+4>>2]=0;ba=c$(l,91)|0;ca=332184;da=ba+91|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));j$(-215,l,332088,332098,589);d$(l)}W=($|0)==0;if(!(W|i==0.0)){f[l>>2]=0;f[l+4>>2]=0;ba=c$(l,22)|0;ca=332276;da=ba+22|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));j$(-215,l,332088,332098,591);d$(l)}$=f[e>>2]|0;e=f[ea>>2]|0;ea=g&4095;if(!(((((f[d+4>>2]|0)<3?(f[d+8>>2]|0)==(e|0):0)?(f[d+12>>2]|0)==($|0):0)?(f[d>>2]&4095|0)==(ea|0):0)?(f[d+16>>2]|0)!=0:0)){f[l>>2]=e;f[l+4>>2]=$;AR(d,2,l,ea)}if(H>>>0>1)ga=6;else{ea=fa>>>0>5?fa:5;ga=(ea|0)<(Z|0)?Z:ea}ea=f[K>>2]|0;$=rNa(+(ea|0)*4.5)|0;e=256-ea+1|0;g=($|0)<(e|0)?e:$;$=d+12|0;e=f[$>>2]|0;ha=f[J>>2]|0;ia=rNa(+(ha|0)*4.5)|0;ja=256-ha+1|0;ha=(ia|0)<(ja|0)?ja:ia;ia=d+8|0;ja=f[ia>>2]|0;ka=RM(ea+-1+((e|0)<(g|0)?e:g)|0)|0;g=(ka|0)>2?ka:2;ka=RM(((ja|0)<(ha|0)?ja:ha)+-1+(f[J>>2]|0)|0)|0;if((g|0)<1|(ka|0)<1){f[l>>2]=0;f[l+4>>2]=0;ba=c$(l,28)|0;ca=332299;da=ba+28|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));j$(-211,l,332088,332098,608);d$(l)}ha=g-(f[K>>2]|0)|0;ja=f[$>>2]|0;e=(ha|0)>=(ja|0)?ja:ha+1|0;ha=ka-(f[J>>2]|0)|0;ja=f[ia>>2]|0;ea=(ha|0)>=(ja|0)?ja:ha+1|0;ha=Y(ka,R)|0;f[q>>2]=1124007936;R=q+4|0;ja=q+8|0;la=q+40|0;ba=R;da=ba+36|0;do{f[ba>>2]=0;ba=ba+4|0}while((ba|0)<(da|0));f[la>>2]=ja;ja=q+48|0;ma=q+44|0;f[ma>>2]=ja;f[ja>>2]=0;f[q+52>>2]=0;na=ga&4095;f[l>>2]=ha;ha=l+4|0;f[ha>>2]=g;AR(q,2,l,na);f[r>>2]=1124007936;oa=r+4|0;pa=r+8|0;qa=r+40|0;ba=oa;da=ba+36|0;do{f[ba>>2]=0;ba=ba+4|0}while((ba|0)<(da|0));f[qa>>2]=pa;pa=r+48|0;ra=r+44|0;f[ra>>2]=pa;f[pa>>2]=0;f[r+52>>2]=0;f[l>>2]=ka;f[ha>>2]=g;AR(r,2,l,na);na=(X|0)!=0;if((fa|0)==(ga|0)|na^1)sa=0;else sa=Y(f[K>>2]<<(47696>>>(fa<<1)&3),f[J>>2]|0)|0;fa=(V|0)!=0;ha=(H|0)==(ga|0);if(ha|fa^1)ta=sa;else{ua=(Y(ea+-1+(f[J>>2]|0)|0,e+-1+(f[K>>2]|0)|0)|0)<<(47696>>>(H<<1)&3);ta=(sa|0)<(ua|0)?ua:sa}if(((I|_)&511|0)==0|(Z|0)==(ga|0))va=ta;else{_=(Y(ea,e)|0)<<(47696>>>(Z<<1)&3);va=(ta|0)<(_|0)?_:ta}ta=f[F>>2]|0;_=f[m>>2]|0;Z=ta-_|0;I=_;_=ta;if(va>>>0<=Z>>>0){if(va>>>0<Z>>>0?(ta=I+va|0,(_|0)!=(ta|0)):0)f[F>>2]=ta}else TR(m,va-Z|0);BM(s,g,ka,f[q>>2]&7,1,1,1024,f[J>>2]|0);Z=t+4|0;va=t+8|0;ta=t+12|0;_=t+16|0;I=t+20|0;sa=t+24|0;ua=t+28|0;wa=t+32|0;xa=t+36|0;ya=t+40|0;za=t+48|0;Aa=t+44|0;Ba=t+52|0;Ca=l+4|0;Da=l+8|0;Ea=l+12|0;Fa=l+4|0;Ga=l+8|0;Ha=l+12|0;Ia=x+4|0;Ja=w+4|0;Ka=x+8|0;La=w+8|0;Ma=x+12|0;Na=w+12|0;Oa=x+16|0;Pa=w+16|0;Qa=x+20|0;Ra=w+20|0;Sa=x+24|0;Ta=w+24|0;Ua=x+28|0;Va=w+28|0;Wa=x+32|0;Xa=w+32|0;Ya=x+36|0;Za=w+36|0;_a=x+40|0;$a=x+48|0;ab=x+44|0;bb=x+52|0;cb=w+44|0;db=l+4|0;eb=l+4|0;fb=v+12|0;gb=x+4|0;hb=y+4|0;ib=l+36|0;jb=l+16|0;kb=l+4|0;lb=l+40|0;mb=l+44|0;nb=l+48|0;ob=s+4|0;pb=v+16|0;qb=v+48|0;rb=w+40|0;sb=w+48|0;tb=v+36|0;ub=v+4|0;vb=v+40|0;wb=v+44|0;xb=l+8|0;yb=l+4|0;zb=0;while(1){Ab=Y(zb,ka)|0;f[t>>2]=f[n>>2];Bb=f[G>>2]|0;f[Z>>2]=Bb;f[va>>2]=f[J>>2];f[ta>>2]=f[K>>2];f[_>>2]=f[L>>2];f[I>>2]=f[M>>2];f[sa>>2]=f[N>>2];f[ua>>2]=f[O>>2];f[wa>>2]=f[P>>2];Cb=f[Q>>2]|0;f[xa>>2]=Cb;f[ya>>2]=va;f[Aa>>2]=za;f[za>>2]=0;f[Ba>>2]=0;if(!Cb)Db=Bb;else{Bb=Cb+12|0;f[Bb>>2]=(f[Bb>>2]|0)+1;Db=f[G>>2]|0}if((Db|0)<3){Bb=f[U>>2]|0;Cb=f[Aa>>2]|0;f[Cb>>2]=f[Bb>>2];f[Cb+4>>2]=f[Bb+4>>2]}else{f[Z>>2]=0;BR(t,n)}f[l>>2]=0;f[Ca>>2]=Ab;f[Da>>2]=g;f[Ea>>2]=ka;FR(v,q,l);Bb=f[K>>2]|0;Cb=f[J>>2]|0;f[l>>2]=0;f[Fa>>2]=Ab;f[Ga>>2]=Bb;f[Ha>>2]=Cb;FR(w,q,l);if(na){Cb=f[o>>2]|0;do if((Cb|0)==(ga|0)){f[x>>2]=f[w>>2];Bb=f[Ja>>2]|0;f[Ia>>2]=Bb;f[Ka>>2]=f[La>>2];f[Ma>>2]=f[Na>>2];f[Oa>>2]=f[Pa>>2];f[Qa>>2]=f[Ra>>2];f[Sa>>2]=f[Ta>>2];f[Ua>>2]=f[Va>>2];f[Wa>>2]=f[Xa>>2];Ab=f[Za>>2]|0;f[Ya>>2]=Ab;f[_a>>2]=Ka;f[ab>>2]=$a;f[$a>>2]=0;f[bb>>2]=0;if(!Ab)Eb=Bb;else{Bb=Ab+12|0;f[Bb>>2]=(f[Bb>>2]|0)+1;Eb=f[Ja>>2]|0}if((Eb|0)<3){Bb=f[cb>>2]|0;Ab=f[ab>>2]|0;f[Ab>>2]=f[Bb>>2];f[Ab+4>>2]=f[Bb+4>>2];break}else{f[Ia>>2]=0;BR(x,w);break}}else{Bb=f[S>>2]|0;Ab=f[Bb+4>>2]|0;Fb=f[Bb>>2]|0;Bb=f[m>>2]|0;Gb=Cb&4095|1124007936;f[x>>2]=Gb;f[Ia>>2]=2;f[Ka>>2]=Fb;f[Ma>>2]=Ab;f[Oa>>2]=Bb;f[Qa>>2]=Bb;f[Sa>>2]=0;f[Sa+4>>2]=0;f[Sa+8>>2]=0;f[Sa+12>>2]=0;f[_a>>2]=Ka;f[ab>>2]=$a;f[bb>>2]=0;f[$a>>2]=0;if((Y(Fb,Ab)|0)!=0&(Bb|0)==0){f[l>>2]=0;f[eb>>2]=0;ba=c$(l,26)|0;ca=358223;da=ba+26|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));j$(-215,l,358250,358254,533);d$(l);Hb=f[Ma>>2]|0;Ib=f[x>>2]|0;Jb=f[ab>>2]|0;Kb=f[Qa>>2]|0}else{Hb=Ab;Ib=Gb;Jb=$a;Kb=Bb}Fb=(Cb>>>3&511)+1<<(47696>>>(Cb<<1&14)&3);Lb=Y(Hb,Fb)|0;f[x>>2]=Ib|16384;f[Jb>>2]=Lb;f[Jb+4>>2]=Fb;Fb=Kb+(Y(f[Ka>>2]|0,Lb)|0)|0;f[Ua>>2]=Fb;f[Sa>>2]=Fb+(0-Lb)+Lb}while(0);Cb=f[Ya>>2]|0;if(Cb|0){Lb=Cb+12|0;f[Lb>>2]=(f[Lb>>2]|0)+1}Lb=f[xa>>2]|0;do if(Lb|0){Cb=Lb+12|0;Fb=f[Cb>>2]|0;f[Cb>>2]=Fb+-1;if((Fb|0)!=1)break;CR(t)}while(0);f[xa>>2]=0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[Z>>2]|0)>0){Lb=f[ya>>2]|0;Fb=0;do{f[Lb+(Fb<<2)>>2]=0;Fb=Fb+1|0;Mb=f[Z>>2]|0}while((Fb|0)<(Mb|0));f[t>>2]=f[x>>2];if((Mb|0)<3)Nb=66;else Nb=68}else{f[t>>2]=f[x>>2];Nb=66}do if((Nb|0)==66){Nb=0;Fb=f[Ia>>2]|0;if((Fb|0)>=3){Nb=68;break}f[Z>>2]=Fb;f[va>>2]=f[Ka>>2];f[ta>>2]=f[Ma>>2];Fb=f[ab>>2]|0;Lb=f[Aa>>2]|0;f[Lb>>2]=f[Fb>>2];f[Lb+4>>2]=f[Fb+4>>2]}while(0);if((Nb|0)==68){Nb=0;BR(t,x)}f[_>>2]=f[Oa>>2];f[I>>2]=f[Qa>>2];f[sa>>2]=f[Sa>>2];f[ua>>2]=f[Ua>>2];f[wa>>2]=f[Wa>>2];Fb=f[Ya>>2]|0;f[xa>>2]=Fb;do if(Fb|0){Lb=Fb+12|0;Cb=f[Lb>>2]|0;f[Lb>>2]=Cb+-1;if((Cb|0)!=1)break;CR(x)}while(0);f[Ya>>2]=0;f[Oa>>2]=0;f[Oa+4>>2]=0;f[Oa+8>>2]=0;f[Oa+12>>2]=0;if((f[Ia>>2]|0)>0){Fb=f[_a>>2]|0;Cb=0;do{f[Fb+(Cb<<2)>>2]=0;Cb=Cb+1|0}while((Cb|0)<(f[Ia>>2]|0))}Cb=f[ab>>2]|0;if((Cb|0)!=($a|0))ZF(Cb);f[l>>2]=zb;f[db>>2]=0;II(n,1,t,1,l,1)}if((f[Pa>>2]|0)!=(f[_>>2]|0)){Cb=xb;f[Cb>>2]=0;f[Cb+4>>2]=0;f[l>>2]=33619968;f[yb>>2]=w;WJ(t,l,f[w>>2]&7,1.0,0.0)}Cb=f[fb>>2]|0;Fb=f[K>>2]|0;if((Cb|0)>(Fb|0)){Lb=f[J>>2]|0;f[x>>2]=0;f[gb>>2]=Lb;f[y>>2]=Fb;f[hb>>2]=Cb;DR(l,v,x,y);f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[x+16>>2]=0;f[x+20>>2]=0;f[x+24>>2]=0;f[x+28>>2]=0;gL(l,x)|0;Cb=f[ib>>2]|0;do if(Cb|0){Fb=Cb+12|0;Lb=f[Fb>>2]|0;f[Fb>>2]=Lb+-1;if((Lb|0)!=1)break;CR(l)}while(0);f[ib>>2]=0;f[jb>>2]=0;f[jb+4>>2]=0;f[jb+8>>2]=0;f[jb+12>>2]=0;if((f[kb>>2]|0)>0){Cb=f[lb>>2]|0;Lb=0;do{f[Cb+(Lb<<2)>>2]=0;Lb=Lb+1|0}while((Lb|0)<(f[kb>>2]|0))}Lb=f[mb>>2]|0;if((Lb|0)!=(nb|0))ZF(Lb)}Lb=f[ob>>2]|0;Cb=f[pb>>2]|0;Fb=f[qb>>2]|0;Bh[f[f[Lb>>2]>>2]&255](Lb,Cb,Fb,Cb,Fb);Fb=f[Za>>2]|0;do if(Fb|0){Cb=Fb+12|0;Lb=f[Cb>>2]|0;f[Cb>>2]=Lb+-1;if((Lb|0)!=1)break;CR(w)}while(0);f[Za>>2]=0;f[Pa>>2]=0;f[Pa+4>>2]=0;f[Pa+8>>2]=0;f[Pa+12>>2]=0;if((f[Ja>>2]|0)>0){Fb=f[rb>>2]|0;Lb=0;do{f[Fb+(Lb<<2)>>2]=0;Lb=Lb+1|0}while((Lb|0)<(f[Ja>>2]|0))}Lb=f[cb>>2]|0;if((Lb|0)!=(sb|0))ZF(Lb);Lb=f[tb>>2]|0;do if(Lb|0){Fb=Lb+12|0;Cb=f[Fb>>2]|0;f[Fb>>2]=Cb+-1;if((Cb|0)!=1)break;CR(v)}while(0);f[tb>>2]=0;f[pb>>2]=0;f[pb+4>>2]=0;f[pb+8>>2]=0;f[pb+12>>2]=0;if((f[ub>>2]|0)>0){Lb=f[vb>>2]|0;Cb=0;do{f[Lb+(Cb<<2)>>2]=0;Cb=Cb+1|0}while((Cb|0)<(f[ub>>2]|0))}Cb=f[wb>>2]|0;if((Cb|0)!=(qb|0))ZF(Cb);Cb=f[xa>>2]|0;do if(Cb|0){Lb=Cb+12|0;Fb=f[Lb>>2]|0;f[Lb>>2]=Fb+-1;if((Fb|0)!=1)break;CR(t)}while(0);f[xa>>2]=0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[Z>>2]|0)>0){Cb=f[ya>>2]|0;Fb=0;do{f[Cb+(Fb<<2)>>2]=0;Fb=Fb+1|0}while((Fb|0)<(f[Z>>2]|0))}Fb=f[Aa>>2]|0;if((Fb|0)!=(za|0))ZF(Fb);if((zb|0)<(X|0))zb=zb+1|0;else break}zb=(e+-1+(f[$>>2]|0)|0)/(e|0)|0;X=ea+-1|0;za=Y((X+(f[ia>>2]|0)|0)/(ea|0)|0,zb)|0;Aa=f[a+40>>2]|0;Z=f[Aa>>2]|0;f[t>>2]=f[Aa+4>>2];Aa=t+4|0;f[Aa>>2]=Z;f[v>>2]=0;Z=v+4|0;f[Z>>2]=0;f[w>>2]=f[a>>2];ya=w+4|0;_=f[aa>>2]|0;f[ya>>2]=_;xa=w+8|0;f[xa>>2]=f[c>>2];qb=w+12|0;wb=a+12|0;f[qb>>2]=f[wb>>2];ub=w+16|0;f[ub>>2]=f[a+16>>2];f[w+20>>2]=f[a+20>>2];f[w+24>>2]=f[a+24>>2];f[w+28>>2]=f[a+28>>2];f[w+32>>2]=f[a+32>>2];vb=w+36|0;pb=f[a+36>>2]|0;f[vb>>2]=pb;tb=w+40|0;f[tb>>2]=xa;sb=w+48|0;cb=w+44|0;f[cb>>2]=sb;f[sb>>2]=0;f[w+52>>2]=0;if(!pb)Ob=_;else{_=pb+12|0;f[_>>2]=(f[_>>2]|0)+1;Ob=f[aa>>2]|0}if((Ob|0)<3){Ob=f[a+44>>2]|0;aa=f[cb>>2]|0;f[aa>>2]=f[Ob>>2];f[aa+4>>2]=f[Ob+4>>2]}else{f[ya>>2]=0;BR(w,a)}if(!(j&16)){KR(a,t,v);a=f[Z>>2]|0;Ob=f[v>>2]|0;LR(w,a,(f[Aa>>2]|0)-a-(f[c>>2]|0)|0,Ob,(f[t>>2]|0)-Ob-(f[wb>>2]|0)|0)|0}wb=j|16;BM(l,g,ka,ga,1,1,1024,X+(f[J>>2]|0)|0);X=f[l>>2]|0;j=f[l+4>>2]|0;Ob=(X|0)==0;t=X;if(Ob){Pb=t;Qb=l}else{c=t+4|0;f[c>>2]=(f[c>>2]|0)+1;Pb=f[l>>2]|0;Qb=l}do if(Pb|0){c=Pb+4|0;a=f[c>>2]|0;f[c>>2]=a+-1;if((a|0)!=1)break;ki[f[(f[Pb>>2]|0)+8>>2]&2047](Pb)}while(0);f[Qb>>2]=0;BM(l,g,ka,ga,1,1,1027,ea);Qb=f[l>>2]|0;Pb=f[l+4>>2]|0;a=(Qb|0)==0;c=Qb;if(a){Rb=c;Sb=l}else{Aa=c+4|0;f[Aa>>2]=(f[Aa>>2]|0)+1;Rb=f[l>>2]|0;Sb=l}do if(Rb|0){Aa=Rb+4|0;aa=f[Aa>>2]|0;f[Aa>>2]=aa+-1;if((aa|0)!=1)break;ki[f[(f[Rb>>2]|0)+8>>2]&2047](Rb)}while(0);f[Sb>>2]=0;if((za|0)>0){Sb=h+4|0;Rb=l+4|0;aa=y+4|0;Aa=l+4|0;_=l+8|0;pb=l+12|0;Ja=l+4|0;rb=l+8|0;Pa=l+12|0;Za=l+4|0;ob=l+8|0;nb=l+12|0;mb=B+4|0;kb=x+4|0;lb=B+8|0;jb=x+8|0;ib=B+12|0;hb=x+12|0;gb=B+16|0;fb=x+16|0;yb=B+20|0;xb=x+20|0;db=B+24|0;$a=x+24|0;ab=B+28|0;Ia=x+28|0;_a=B+32|0;Oa=x+32|0;Ya=B+36|0;Wa=x+36|0;wa=B+40|0;Ua=B+48|0;ua=B+44|0;Sa=B+52|0;sa=x+44|0;Qa=C+4|0;I=z+4|0;Ma=C+8|0;ta=z+8|0;Ka=C+12|0;va=z+12|0;Mb=C+16|0;Kb=z+16|0;Jb=C+20|0;Ib=z+20|0;Hb=C+24|0;eb=z+24|0;bb=C+28|0;Eb=z+28|0;Xa=C+32|0;Va=z+32|0;Ta=C+36|0;Ra=z+36|0;Na=C+40|0;La=C+48|0;o=C+44|0;Ha=C+52|0;Ga=z+44|0;Fa=l+4|0;Ea=H|1124007936;Da=l+4|0;Ca=47696>>>(H<<1)&3;H=1<<Ca;Db=l+8|0;Ba=l+12|0;P=l+4|0;O=C+8|0;N=C+4|0;M=y+8|0;Fb=y+12|0;Cb=r+16|0;Lb=C+4|0;Tb=C+8|0;Ub=C+12|0;Vb=C+8|0;Wb=C+12|0;Xb=C+4|0;Yb=D+8|0;Zb=D+12|0;_b=D+4|0;$b=E+8|0;ac=E+4|0;bc=D+4|0;cc=D+8|0;dc=D+12|0;ec=C+36|0;fc=C+4|0;gc=C+8|0;hc=C+12|0;ic=C+44|0;jc=C+16|0;kc=C+20|0;lc=C+24|0;mc=C+28|0;nc=C+32|0;oc=C+40|0;pc=C+48|0;qc=C+8|0;rc=C+4|0;sc=C+8|0;tc=C+12|0;uc=C+4|0;vc=D+8|0;wc=D+12|0;xc=D+4|0;yc=E+8|0;zc=E+4|0;Ac=C+4|0;Bc=C+8|0;Cc=C+12|0;Dc=C+16|0;Ec=C+20|0;Fc=C+24|0;Gc=C+28|0;Hc=C+40|0;Ic=C+48|0;Jc=C+44|0;Kc=D+8|0;Lc=D+4|0;Mc=C+36|0;Nc=C+32|0;Oc=l+36|0;Pc=l+16|0;Qc=l+4|0;Rc=l+40|0;Sc=l+44|0;Tc=l+48|0;Uc=C+4|0;Vc=C+4|0;Wc=C+8|0;Xc=C+12|0;Yc=C+16|0;Zc=C+20|0;_c=C+24|0;$c=C+28|0;ad=C+40|0;bd=C+48|0;cd=C+44|0;dd=D+8|0;ed=D+4|0;fd=C+36|0;gd=C+32|0;hd=C+8|0;id=C+12|0;jd=C+4|0;kd=D+8|0;ld=D+4|0;md=l+8|0;nd=l+12|0;od=l+4|0;pd=C+8|0;qd=C+4|0;rd=l+8|0;sd=l+4|0;td=A+36|0;ud=A+16|0;vd=A+4|0;wd=A+40|0;xd=A+44|0;yd=A+48|0;zd=z+40|0;Ad=z+48|0;Bd=y+36|0;Cd=y+16|0;Dd=y+4|0;Ed=y+40|0;Fd=y+44|0;Gd=y+48|0;Hd=x+40|0;Id=x+48|0;Jd=Fc+8|0;Kd=C+52|0;Ld=_c+8|0;Md=C+52|0;Nd=0;do{Od=Y((Nd|0)%(zb|0)|0,e)|0;Pd=Y((Nd|0)/(zb|0)|0,ea)|0;Qd=(f[$>>2]|0)-Od|0;Rd=(Qd|0)<(e|0)?Qd:e;Qd=(f[ia>>2]|0)-Pd|0;Sd=(Qd|0)<(ea|0)?Qd:ea;Td=(f[K>>2]|0)+-1+Rd|0;Ud=(f[J>>2]|0)+-1+Sd|0;Vd=Od-(f[h>>2]|0)+(f[v>>2]|0)|0;Wd=Pd-(f[Sb>>2]|0)+(f[Z>>2]|0)|0;Xd=(Vd|0)>0?Vd:0;Yd=(Wd|0)>0?Wd:0;Zd=Vd+Td|0;_d=f[qb>>2]|0;$d=(Zd|0)<(_d|0)?Zd:_d;_d=Wd+Ud|0;Zd=f[xa>>2]|0;ae=(_d|0)<(Zd|0)?_d:Zd;f[l>>2]=Yd;f[Rb>>2]=ae;f[y>>2]=Xd;f[aa>>2]=$d;DR(x,w,l,y);f[l>>2]=0;f[Aa>>2]=0;f[_>>2]=Td;f[pb>>2]=Ud;FR(y,r,l);Zd=Xd-Vd|0;Vd=Yd-Wd|0;Wd=$d-Xd|0;Xd=ae-Yd|0;f[l>>2]=Zd;f[Ja>>2]=Vd;f[rb>>2]=Wd;f[Pa>>2]=Xd;FR(z,r,l);f[l>>2]=Od;f[Za>>2]=Pd;f[ob>>2]=Rd;f[nb>>2]=Sd;FR(A,d,l);Pd=(Y(Xd,Wd)|0)!=0;Od=(Wd|0)<(Td|0)|(Xd|0)<(Ud|0);Td=(ea|0)<=(Qd|0);Qd=0;while(1){f[B>>2]=f[x>>2];Yd=f[kb>>2]|0;f[mb>>2]=Yd;f[lb>>2]=f[jb>>2];f[ib>>2]=f[hb>>2];f[gb>>2]=f[fb>>2];f[yb>>2]=f[xb>>2];f[db>>2]=f[$a>>2];f[ab>>2]=f[Ia>>2];f[_a>>2]=f[Oa>>2];ae=f[Wa>>2]|0;f[Ya>>2]=ae;f[wa>>2]=lb;f[ua>>2]=Ua;f[Ua>>2]=0;f[Sa>>2]=0;if(!ae)be=Yd;else{Yd=ae+12|0;f[Yd>>2]=(f[Yd>>2]|0)+1;be=f[kb>>2]|0}if((be|0)<3){Yd=f[sa>>2]|0;ae=f[ua>>2]|0;f[ae>>2]=f[Yd>>2];f[ae+4>>2]=f[Yd+4>>2]}else{f[mb>>2]=0;BR(B,x)};f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;gL(r,l)|0;if(fa){do if(ha){f[C>>2]=f[z>>2];Yd=f[I>>2]|0;f[Qa>>2]=Yd;f[Ma>>2]=f[ta>>2];f[Ka>>2]=f[va>>2];f[Mb>>2]=f[Kb>>2];f[Jb>>2]=f[Ib>>2];f[Hb>>2]=f[eb>>2];f[bb>>2]=f[Eb>>2];f[Xa>>2]=f[Va>>2];ae=f[Ra>>2]|0;f[Ta>>2]=ae;f[Na>>2]=Ma;f[o>>2]=La;f[La>>2]=0;f[Ha>>2]=0;if(!ae)ce=Yd;else{Yd=ae+12|0;f[Yd>>2]=(f[Yd>>2]|0)+1;ce=f[I>>2]|0}if((ce|0)<3){Yd=f[Ga>>2]|0;ae=f[o>>2]|0;f[ae>>2]=f[Yd>>2];f[ae+4>>2]=f[Yd+4>>2];break}else{f[Qa>>2]=0;BR(C,z);break}}else{Yd=f[m>>2]|0;f[C>>2]=Ea;f[Qa>>2]=2;f[Ma>>2]=Xd;f[Ka>>2]=Wd;f[Mb>>2]=Yd;f[Jb>>2]=Yd;f[Hb>>2]=0;f[Hb+4>>2]=0;f[Hb+8>>2]=0;f[Hb+12>>2]=0;f[Na>>2]=Ma;f[o>>2]=La;f[Ha>>2]=0;f[La>>2]=0;if(Pd&(Yd|0)==0){f[l>>2]=0;f[Da>>2]=0;ba=c$(l,26)|0;ca=358223;da=ba+26|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));j$(-215,l,358250,358254,500);d$(l);de=f[Ka>>2]|0;ee=f[C>>2]|0;fe=f[o>>2]|0;ge=f[Jb>>2]|0}else{de=Wd;ee=Ea;fe=La;ge=Yd}ae=de<<Ca;f[C>>2]=ee|16384;f[fe>>2]=ae;f[fe+4>>2]=H;$d=ge+(Y(f[Ma>>2]|0,ae)|0)|0;f[bb>>2]=$d;f[Hb>>2]=$d+(0-ae)+ae}while(0);Bb=f[Ta>>2]|0;if(Bb|0){Gb=Bb+12|0;f[Gb>>2]=(f[Gb>>2]|0)+1}Gb=f[Ya>>2]|0;do if(Gb|0){Bb=Gb+12|0;Ab=f[Bb>>2]|0;f[Bb>>2]=Ab+-1;if((Ab|0)!=1)break;CR(B)}while(0);f[Ya>>2]=0;f[gb>>2]=0;f[gb+4>>2]=0;f[gb+8>>2]=0;f[gb+12>>2]=0;if((f[mb>>2]|0)>0){Gb=f[wa>>2]|0;Ab=0;do{f[Gb+(Ab<<2)>>2]=0;Ab=Ab+1|0;he=f[mb>>2]|0}while((Ab|0)<(he|0));f[B>>2]=f[C>>2];if((he|0)<3)Nb=162;else Nb=164}else{f[B>>2]=f[C>>2];Nb=162}do if((Nb|0)==162){Nb=0;Ab=f[Qa>>2]|0;if((Ab|0)>=3){Nb=164;break}f[mb>>2]=Ab;f[lb>>2]=f[Ma>>2];f[ib>>2]=f[Ka>>2];Ab=f[o>>2]|0;Gb=f[ua>>2]|0;f[Gb>>2]=f[Ab>>2];f[Gb+4>>2]=f[Ab+4>>2]}while(0);if((Nb|0)==164){Nb=0;BR(B,C)}f[gb>>2]=f[Mb>>2];f[yb>>2]=f[Jb>>2];f[db>>2]=f[Hb>>2];f[ab>>2]=f[bb>>2];f[_a>>2]=f[Xa>>2];Ab=f[Ta>>2]|0;f[Ya>>2]=Ab;do if(Ab|0){Gb=Ab+12|0;Bb=f[Gb>>2]|0;f[Gb>>2]=Bb+-1;if((Bb|0)!=1)break;CR(C)}while(0);f[Ta>>2]=0;f[Mb>>2]=0;f[Mb+4>>2]=0;f[Mb+8>>2]=0;f[Mb+12>>2]=0;if((f[Qa>>2]|0)>0){Ab=f[Na>>2]|0;Bb=0;do{f[Ab+(Bb<<2)>>2]=0;Bb=Bb+1|0}while((Bb|0)<(f[Qa>>2]|0))}Bb=f[o>>2]|0;if((Bb|0)!=(La|0))ZF(Bb);f[l>>2]=Qd;f[Fa>>2]=0;II(x,1,B,1,l,1)}if((f[Kb>>2]|0)!=(f[gb>>2]|0)){Bb=rd;f[Bb>>2]=0;f[Bb+4>>2]=0;f[l>>2]=33619968;f[sd>>2]=z;WJ(B,l,f[z>>2]&7,1.0,0.0)}if(Od){f[Db>>2]=0;f[Ba>>2]=0;f[l>>2]=16842752;f[P>>2]=z;Bb=O;f[Bb>>2]=0;f[Bb+4>>2]=0;f[C>>2]=33619968;f[N>>2]=y;Bb=f[M>>2]|0;Ab=f[ta>>2]|0;Gb=f[Fb>>2]|0;ae=f[va>>2]|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;f[D+16>>2]=0;f[D+20>>2]=0;f[D+24>>2]=0;f[D+28>>2]=0;mL(l,C,Vd,Bb-Vd-Ab|0,Zd,Gb-Zd-ae|0,wb,D)}if(Td){ae=f[Cb>>2]|0;Gb=f[pa>>2]|0;Bh[f[f[j>>2]>>2]&255](j,ae,Gb,ae,Gb)}else{f[md>>2]=0;f[nd>>2]=0;f[l>>2]=16842752;f[od>>2]=r;Gb=pd;f[Gb>>2]=0;f[Gb+4>>2]=0;f[C>>2]=33619968;f[qd>>2]=r;PM(l,C,0,Ud)}Gb=Y(Qd,ka)|0;f[C>>2]=0;f[Lb>>2]=na?Gb:0;f[Tb>>2]=g;f[Ub>>2]=ka;FR(l,q,C);f[Vb>>2]=0;f[Wb>>2]=0;f[C>>2]=16842752;f[Xb>>2]=r;f[Yb>>2]=0;f[Zb>>2]=0;f[D>>2]=16842752;f[_b>>2]=l;Gb=$b;f[Gb>>2]=0;f[Gb+4>>2]=0;f[E>>2]=33619968;f[ac>>2]=r;QM(C,D,E,0,1);if(Td){Gb=f[Cb>>2]|0;ae=f[pa>>2]|0;Bh[f[f[Pb>>2]>>2]&255](Pb,Gb,ae,Gb,ae)}else{f[hd>>2]=0;f[id>>2]=0;f[C>>2]=16842752;f[jd>>2]=r;ae=kd;f[ae>>2]=0;f[ae+4>>2]=0;f[D>>2]=33619968;f[ld>>2]=r;PM(C,D,3,Sd)}f[D>>2]=0;f[bc>>2]=0;f[cc>>2]=Rd;f[dc>>2]=Sd;FR(C,r,D);ae=f[ec>>2]|0;if(ae|0){Gb=ae+12|0;f[Gb>>2]=(f[Gb>>2]|0)+1}Gb=f[Ya>>2]|0;do if(Gb|0){ae=Gb+12|0;Ab=f[ae>>2]|0;f[ae>>2]=Ab+-1;if((Ab|0)!=1)break;CR(B)}while(0);f[Ya>>2]=0;f[gb>>2]=0;f[gb+4>>2]=0;f[gb+8>>2]=0;f[gb+12>>2]=0;if((f[mb>>2]|0)>0){Gb=f[wa>>2]|0;Ab=0;do{f[Gb+(Ab<<2)>>2]=0;Ab=Ab+1|0;ie=f[mb>>2]|0}while((Ab|0)<(ie|0));f[B>>2]=f[C>>2];if((ie|0)<3)Nb=194;else Nb=196}else{f[B>>2]=f[C>>2];Nb=194}do if((Nb|0)==194){Nb=0;Ab=f[fc>>2]|0;if((Ab|0)>=3){Nb=196;break}f[mb>>2]=Ab;f[lb>>2]=f[gc>>2];f[ib>>2]=f[hc>>2];Ab=f[ic>>2]|0;Gb=f[ua>>2]|0;f[Gb>>2]=f[Ab>>2];f[Gb+4>>2]=f[Ab+4>>2]}while(0);if((Nb|0)==196){Nb=0;BR(B,C)}f[gb>>2]=f[jc>>2];f[yb>>2]=f[kc>>2];f[db>>2]=f[lc>>2];f[ab>>2]=f[mc>>2];f[_a>>2]=f[nc>>2];Ab=f[ec>>2]|0;f[Ya>>2]=Ab;do if(Ab|0){Gb=Ab+12|0;ae=f[Gb>>2]|0;f[Gb>>2]=ae+-1;if((ae|0)!=1)break;CR(C)}while(0);f[ec>>2]=0;f[jc>>2]=0;f[jc+4>>2]=0;f[jc+8>>2]=0;f[jc+12>>2]=0;if((f[fc>>2]|0)>0){Ab=f[oc>>2]|0;ae=0;do{f[Ab+(ae<<2)>>2]=0;ae=ae+1|0}while((ae|0)<(f[fc>>2]|0))}ae=f[ic>>2]|0;if((ae|0)!=(pc|0))ZF(ae);do if(W){if(!Qd){ae=qc;f[ae>>2]=0;f[ae+4>>2]=0;f[C>>2]=33619968;f[rc>>2]=A;WJ(B,C,f[p>>2]|0,1.0,i);break}ae=f[p>>2]|0;if((ga|0)!=(ae|0)){Ab=f[m>>2]|0;f[Ac>>2]=2;f[Bc>>2]=Sd;f[Cc>>2]=Rd;f[Dc>>2]=Ab;f[Ec>>2]=Ab;Gb=Jd;f[Gb>>2]=0;f[Gb+4>>2]=0;f[Hc>>2]=Bc;f[Jc>>2]=Ic;Gb=(ae>>>3&511)+1<<(47696>>>(ae<<1&14)&3);Bb=Y(Gb,Rd)|0;f[C>>2]=ae&4095|1124024320;f[Ic>>2]=Bb;f[Kd>>2]=Gb;Gb=Ab+(Y(Sd,Bb)|0)|0;f[Gc>>2]=Gb;f[Fc>>2]=Gb+(0-Bb)+Bb;Bb=Kc;f[Bb>>2]=0;f[Bb+4>>2]=0;f[D>>2]=33619968;f[Lc>>2]=C;WJ(B,D,ae,1.0,0.0);ae=f[Mc>>2]|0;if(ae|0){Bb=ae+12|0;f[Bb>>2]=(f[Bb>>2]|0)+1}Bb=f[Ya>>2]|0;do if(Bb|0){ae=Bb+12|0;Gb=f[ae>>2]|0;f[ae>>2]=Gb+-1;if((Gb|0)!=1)break;CR(B)}while(0);f[Ya>>2]=0;f[gb>>2]=0;f[gb+4>>2]=0;f[gb+8>>2]=0;f[gb+12>>2]=0;if((f[mb>>2]|0)>0){Bb=f[wa>>2]|0;Yd=0;do{f[Bb+(Yd<<2)>>2]=0;Yd=Yd+1|0;je=f[mb>>2]|0}while((Yd|0)<(je|0));f[B>>2]=f[C>>2];if((je|0)<3)Nb=243;else Nb=245}else{f[B>>2]=f[C>>2];Nb=243}do if((Nb|0)==243){Nb=0;Yd=f[Ac>>2]|0;if((Yd|0)>=3){Nb=245;break}f[mb>>2]=Yd;f[lb>>2]=f[Bc>>2];f[ib>>2]=f[Cc>>2];Yd=f[Jc>>2]|0;Bb=f[ua>>2]|0;f[Bb>>2]=f[Yd>>2];f[Bb+4>>2]=f[Yd+4>>2]}while(0);if((Nb|0)==245){Nb=0;BR(B,C)}f[gb>>2]=f[Dc>>2];f[yb>>2]=f[Ec>>2];f[db>>2]=f[Fc>>2];f[ab>>2]=f[Gc>>2];f[_a>>2]=f[Nc>>2];Yd=f[Mc>>2]|0;f[Ya>>2]=Yd;do if(Yd|0){Bb=Yd+12|0;Gb=f[Bb>>2]|0;f[Bb>>2]=Gb+-1;if((Gb|0)!=1)break;CR(C)}while(0);f[Mc>>2]=0;f[Dc>>2]=0;f[Dc+4>>2]=0;f[Dc+8>>2]=0;f[Dc+12>>2]=0;if((f[Ac>>2]|0)>0){Yd=f[Hc>>2]|0;Gb=0;do{f[Yd+(Gb<<2)>>2]=0;Gb=Gb+1|0}while((Gb|0)<(f[Ac>>2]|0))}Gb=f[Jc>>2]|0;if((Gb|0)!=(Ic|0))ZF(Gb)}f[sc>>2]=0;f[tc>>2]=0;f[C>>2]=16842752;f[uc>>2]=B;f[vc>>2]=0;f[wc>>2]=0;f[D>>2]=16842752;f[xc>>2]=A;Gb=yc;f[Gb>>2]=0;f[Gb+4>>2]=0;f[E>>2]=33619968;f[zc>>2]=A;TG(C,D,E,fT()|0,-1)}else{Gb=f[p>>2]|0;if((Gb|0)!=(ga|0)){Yd=f[m>>2]|0;f[Vc>>2]=2;f[Wc>>2]=Sd;f[Xc>>2]=Rd;f[Yc>>2]=Yd;f[Zc>>2]=Yd;Bb=Ld;f[Bb>>2]=0;f[Bb+4>>2]=0;f[ad>>2]=Wc;f[cd>>2]=bd;Bb=(Gb>>>3&511)+1<<(47696>>>(Gb<<1&14)&3);ae=Y(Bb,Rd)|0;f[C>>2]=Gb&4095|1124024320;f[bd>>2]=ae;f[Md>>2]=Bb;Bb=Yd+(Y(Sd,ae)|0)|0;f[$c>>2]=Bb;f[_c>>2]=Bb+(0-ae)+ae;ae=dd;f[ae>>2]=0;f[ae+4>>2]=0;f[D>>2]=33619968;f[ed>>2]=C;WJ(B,D,Gb,1.0,i);Gb=f[fd>>2]|0;if(Gb|0){ae=Gb+12|0;f[ae>>2]=(f[ae>>2]|0)+1}ae=f[Ya>>2]|0;do if(ae|0){Gb=ae+12|0;Bb=f[Gb>>2]|0;f[Gb>>2]=Bb+-1;if((Bb|0)!=1)break;CR(B)}while(0);f[Ya>>2]=0;f[gb>>2]=0;f[gb+4>>2]=0;f[gb+8>>2]=0;f[gb+12>>2]=0;if((f[mb>>2]|0)>0){ae=f[wa>>2]|0;Bb=0;do{f[ae+(Bb<<2)>>2]=0;Bb=Bb+1|0;ke=f[mb>>2]|0}while((Bb|0)<(ke|0));f[B>>2]=f[C>>2];if((ke|0)<3)Nb=217;else Nb=219}else{f[B>>2]=f[C>>2];Nb=217}do if((Nb|0)==217){Nb=0;Bb=f[Vc>>2]|0;if((Bb|0)>=3){Nb=219;break}f[mb>>2]=Bb;f[lb>>2]=f[Wc>>2];f[ib>>2]=f[Xc>>2];Bb=f[cd>>2]|0;ae=f[ua>>2]|0;f[ae>>2]=f[Bb>>2];f[ae+4>>2]=f[Bb+4>>2]}while(0);if((Nb|0)==219){Nb=0;BR(B,C)}f[gb>>2]=f[Yc>>2];f[yb>>2]=f[Zc>>2];f[db>>2]=f[_c>>2];f[ab>>2]=f[$c>>2];f[_a>>2]=f[gd>>2];Bb=f[fd>>2]|0;f[Ya>>2]=Bb;do if(Bb|0){ae=Bb+12|0;Gb=f[ae>>2]|0;f[ae>>2]=Gb+-1;if((Gb|0)!=1)break;CR(C)}while(0);f[fd>>2]=0;f[Yc>>2]=0;f[Yc+4>>2]=0;f[Yc+8>>2]=0;f[Yc+12>>2]=0;if((f[Vc>>2]|0)>0){Bb=f[ad>>2]|0;Gb=0;do{f[Bb+(Gb<<2)>>2]=0;Gb=Gb+1|0}while((Gb|0)<(f[Vc>>2]|0))}Gb=f[cd>>2]|0;if((Gb|0)!=(bd|0))ZF(Gb)}f[C>>2]=0;f[Uc>>2]=Qd;II(B,1,A,1,C,1)}while(0);Gb=f[Oc>>2]|0;do if(Gb|0){Bb=Gb+12|0;ae=f[Bb>>2]|0;f[Bb>>2]=ae+-1;if((ae|0)!=1)break;CR(l)}while(0);f[Oc>>2]=0;f[Pc>>2]=0;f[Pc+4>>2]=0;f[Pc+8>>2]=0;f[Pc+12>>2]=0;if((f[Qc>>2]|0)>0){Gb=f[Rc>>2]|0;ae=0;do{f[Gb+(ae<<2)>>2]=0;ae=ae+1|0}while((ae|0)<(f[Qc>>2]|0))}ae=f[Sc>>2]|0;if((ae|0)!=(Tc|0))ZF(ae);ae=f[Ya>>2]|0;do if(ae|0){Gb=ae+12|0;Bb=f[Gb>>2]|0;f[Gb>>2]=Bb+-1;if((Bb|0)!=1)break;CR(B)}while(0);f[Ya>>2]=0;f[gb>>2]=0;f[gb+4>>2]=0;f[gb+8>>2]=0;f[gb+12>>2]=0;if((f[mb>>2]|0)>0){ae=f[wa>>2]|0;Bb=0;do{f[ae+(Bb<<2)>>2]=0;Bb=Bb+1|0}while((Bb|0)<(f[mb>>2]|0))}Bb=f[ua>>2]|0;if((Bb|0)!=(Ua|0))ZF(Bb);if((Qd|0)<(V|0))Qd=Qd+1|0;else break}Qd=f[td>>2]|0;do if(Qd|0){Sd=Qd+12|0;Rd=f[Sd>>2]|0;f[Sd>>2]=Rd+-1;if((Rd|0)!=1)break;CR(A)}while(0);f[td>>2]=0;f[ud>>2]=0;f[ud+4>>2]=0;f[ud+8>>2]=0;f[ud+12>>2]=0;if((f[vd>>2]|0)>0){Qd=f[wd>>2]|0;Rd=0;do{f[Qd+(Rd<<2)>>2]=0;Rd=Rd+1|0}while((Rd|0)<(f[vd>>2]|0))}Rd=f[xd>>2]|0;if((Rd|0)!=(yd|0))ZF(Rd);Rd=f[Ra>>2]|0;do if(Rd|0){Qd=Rd+12|0;Sd=f[Qd>>2]|0;f[Qd>>2]=Sd+-1;if((Sd|0)!=1)break;CR(z)}while(0);f[Ra>>2]=0;f[Kb>>2]=0;f[Kb+4>>2]=0;f[Kb+8>>2]=0;f[Kb+12>>2]=0;if((f[I>>2]|0)>0){Rd=f[zd>>2]|0;Sd=0;do{f[Rd+(Sd<<2)>>2]=0;Sd=Sd+1|0}while((Sd|0)<(f[I>>2]|0))}Sd=f[Ga>>2]|0;if((Sd|0)!=(Ad|0))ZF(Sd);Sd=f[Bd>>2]|0;do if(Sd|0){Rd=Sd+12|0;Qd=f[Rd>>2]|0;f[Rd>>2]=Qd+-1;if((Qd|0)!=1)break;CR(y)}while(0);f[Bd>>2]=0;f[Cd>>2]=0;f[Cd+4>>2]=0;f[Cd+8>>2]=0;f[Cd+12>>2]=0;if((f[Dd>>2]|0)>0){Sd=f[Ed>>2]|0;Qd=0;do{f[Sd+(Qd<<2)>>2]=0;Qd=Qd+1|0}while((Qd|0)<(f[Dd>>2]|0))}Qd=f[Fd>>2]|0;if((Qd|0)!=(Gd|0))ZF(Qd);Qd=f[Wa>>2]|0;do if(Qd|0){Sd=Qd+12|0;Rd=f[Sd>>2]|0;f[Sd>>2]=Rd+-1;if((Rd|0)!=1)break;CR(x)}while(0);f[Wa>>2]=0;f[fb>>2]=0;f[fb+4>>2]=0;f[fb+8>>2]=0;f[fb+12>>2]=0;if((f[kb>>2]|0)>0){Qd=f[Hd>>2]|0;Rd=0;do{f[Qd+(Rd<<2)>>2]=0;Rd=Rd+1|0}while((Rd|0)<(f[kb>>2]|0))}Rd=f[sa>>2]|0;if((Rd|0)!=(Id|0))ZF(Rd);Nd=Nd+1|0}while((Nd|0)<(za|0))}do if(!a){za=c+4|0;Nd=f[za>>2]|0;f[za>>2]=Nd+-1;if((Nd|0)!=1)break;ki[f[(f[Qb>>2]|0)+8>>2]&2047](c)}while(0);do if(!Ob){c=t+4|0;Qb=f[c>>2]|0;f[c>>2]=Qb+-1;if((Qb|0)!=1)break;ki[f[(f[X>>2]|0)+8>>2]&2047](t)}while(0);t=f[vb>>2]|0;do if(t|0){X=t+12|0;Ob=f[X>>2]|0;f[X>>2]=Ob+-1;if((Ob|0)!=1)break;CR(w)}while(0);f[vb>>2]=0;f[ub>>2]=0;f[ub+4>>2]=0;f[ub+8>>2]=0;f[ub+12>>2]=0;if((f[ya>>2]|0)>0){ub=f[tb>>2]|0;tb=0;do{f[ub+(tb<<2)>>2]=0;tb=tb+1|0}while((tb|0)<(f[ya>>2]|0))}ya=f[cb>>2]|0;if((ya|0)!=(sb|0))ZF(ya);ya=f[s>>2]|0;do if(ya|0){s=ya+4|0;sb=f[s>>2]|0;f[s>>2]=sb+-1;if((sb|0)!=1)break;ki[f[(f[ya>>2]|0)+8>>2]&2047](ya)}while(0);ya=r+36|0;sb=f[ya>>2]|0;do if(sb|0){s=sb+12|0;cb=f[s>>2]|0;f[s>>2]=cb+-1;if((cb|0)!=1)break;CR(r)}while(0);f[ya>>2]=0;ya=r+16|0;f[ya>>2]=0;f[ya+4>>2]=0;f[ya+8>>2]=0;f[ya+12>>2]=0;if((f[oa>>2]|0)>0){ya=f[qa>>2]|0;qa=0;do{f[ya+(qa<<2)>>2]=0;qa=qa+1|0}while((qa|0)<(f[oa>>2]|0))}oa=f[ra>>2]|0;if((oa|0)!=(pa|0))ZF(oa);oa=q+36|0;pa=f[oa>>2]|0;do if(pa|0){ra=pa+12|0;qa=f[ra>>2]|0;f[ra>>2]=qa+-1;if((qa|0)!=1)break;CR(q)}while(0);f[oa>>2]=0;oa=q+16|0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((f[R>>2]|0)>0){oa=f[la>>2]|0;la=0;do{f[oa+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[R>>2]|0))}R=f[ma>>2]|0;if((R|0)!=(ja|0))ZF(R);R=f[Q>>2]|0;do if(R|0){ja=R+12|0;ma=f[ja>>2]|0;f[ja>>2]=ma+-1;if((ma|0)!=1)break;CR(n)}while(0);f[Q>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[G>>2]|0)>0){L=f[S>>2]|0;S=0;do{f[L+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[G>>2]|0))}G=f[U>>2]|0;if((G|0)!=(T|0))ZF(G);G=f[m>>2]|0;if(!G){u=k;return}if((f[F>>2]|0)!=(G|0))f[F>>2]=G;PYa(G);u=k;return}function fqa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0,Sa=0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0;h=u;u=u+2192|0;i=h+1360|0;j=h+2136|0;k=h+1328|0;l=h+1272|0;m=h+1216|0;o=h+2080|0;q=h+2024|0;r=h+1912|0;s=h+1840|0;t=h+992|0;v=h+1768|0;w=h+768|0;x=h+1712|0;y=h+544|0;z=h+512|0;A=h+480|0;B=h+256|0;C=h+32|0;D=h+1656|0;E=h+1648|0;F=h+1640|0;G=h+1632|0;H=h+1624|0;I=h;J=h+1616|0;K=h+1608|0;N=h+1600|0;O=h+1592|0;P=h+1584|0;Q=h+2016|0;R=h+2008|0;S=h+2e3|0;T=h+1992|0;U=h+1984|0;V=h+1976|0;W=h+1968|0;X=h+1904|0;Z=h+1896|0;_=h+1832|0;$=h+1824|0;_$(P,76524);if(XS(g)|0){aa=RR(a,-1)|0;ba=(aa>>>3&511)+1|0;if(e>>>0>=6){f[i>>2]=0;f[i+4>>2]=0;ca=c$(i,55)|0;da=332328;ea=ca+55|0;do{b[ca>>0]=b[da>>0]|0;ca=ca+1|0;da=da+1|0}while((ca|0)<(ea|0));j$(-215,i,332474,332098,1101);d$(i)}switch(aa&7){case 0:case 5:{if(!((aa|0)==(RR(c,-1)|0)?(nS(a,-1)|0)<3:0))fa=134;break}default:fa=134}if((fa|0)==134){f[i>>2]=0;f[i+4>>2]=0;ca=c$(i,71)|0;da=332402;ea=ca+71|0;do{b[ca>>0]=b[da>>0]|0;ca=ca+1|0;da=da+1|0}while((ca|0)<(ea|0));j$(-215,i,332474,332098,1102);d$(i)}QR(Q,a,-1);aa=f[Q+4>>2]|0;QR(R,c,-1);if((aa|0)>=(f[R+4>>2]|0)?(QR(S,a,-1),R=f[S>>2]|0,QR(T,c,-1),(R|0)>=(f[T>>2]|0)):0)ga=0;else fa=137;do if((fa|0)==137){QR(U,a,-1);T=f[U+4>>2]|0;QR(V,c,-1);if((T|0)<=(f[V+4>>2]|0)?(QR(W,a,-1),T=f[W>>2]|0,QR(X,c,-1),(T|0)<=(f[X>>2]|0)):0){ga=1;break}f[i>>2]=0;f[i+4>>2]=0;ca=c$(i,86)|0;da=332488;ea=ca+86|0;do{b[ca>>0]=b[da>>0]|0;ca=ca+1|0;da=da+1|0}while((ca|0)<(ea|0));j$(-215,i,332474,332098,1107);d$(i);ga=1}while(0);do if((NS(a)|0)==65536){X=f[a+4>>2]|0;f[r>>2]=f[X>>2];W=r+4|0;V=X+4|0;f[W>>2]=f[V>>2];U=r+8|0;f[U>>2]=f[X+8>>2];f[r+12>>2]=f[X+12>>2];f[r+16>>2]=f[X+16>>2];f[r+20>>2]=f[X+20>>2];f[r+24>>2]=f[X+24>>2];f[r+28>>2]=f[X+28>>2];f[r+32>>2]=f[X+32>>2];T=f[X+36>>2]|0;f[r+36>>2]=T;f[r+40>>2]=U;U=r+48|0;R=r+44|0;f[R>>2]=U;f[U>>2]=0;f[r+52>>2]=0;if(T|0){U=T+12|0;f[U>>2]=(f[U>>2]|0)+1}if((f[V>>2]|0)<3){V=f[X+44>>2]|0;U=f[R>>2]|0;f[U>>2]=f[V>>2];f[U+4>>2]=f[V+4>>2];break}else{f[W>>2]=0;BR(r,X);break}}else OR(r,a,-1);while(0);do if((NS(c)|0)==65536){X=f[c+4>>2]|0;f[s>>2]=f[X>>2];W=s+4|0;V=X+4|0;f[W>>2]=f[V>>2];U=s+8|0;f[U>>2]=f[X+8>>2];f[s+12>>2]=f[X+12>>2];f[s+16>>2]=f[X+16>>2];f[s+20>>2]=f[X+20>>2];f[s+24>>2]=f[X+24>>2];f[s+28>>2]=f[X+28>>2];f[s+32>>2]=f[X+32>>2];R=f[X+36>>2]|0;f[s+36>>2]=R;f[s+40>>2]=U;U=s+48|0;T=s+44|0;f[T>>2]=U;f[U>>2]=0;f[s+52>>2]=0;if(R|0){U=R+12|0;f[U>>2]=(f[U>>2]|0)+1}if((f[V>>2]|0)<3){V=f[X+44>>2]|0;U=f[T>>2]|0;f[U>>2]=f[V>>2];f[U+4>>2]=f[V+4>>2];break}else{f[W>>2]=0;BR(s,X);break}}else OR(s,c,-1);while(0);if(ga){f[i>>2]=f[r>>2];ga=i+4|0;X=r+4|0;W=f[X>>2]|0;f[ga>>2]=W;V=i+8|0;U=r+8|0;f[V>>2]=f[U>>2];T=i+12|0;R=r+12|0;f[T>>2]=f[R>>2];S=i+16|0;aa=r+16|0;f[S>>2]=f[aa>>2];Q=i+20|0;ha=r+20|0;f[Q>>2]=f[ha>>2];ia=i+24|0;ja=r+24|0;f[ia>>2]=f[ja>>2];ka=i+28|0;la=r+28|0;f[ka>>2]=f[la>>2];ma=i+32|0;na=r+32|0;f[ma>>2]=f[na>>2];oa=i+36|0;pa=r+36|0;qa=f[pa>>2]|0;f[oa>>2]=qa;ra=i+40|0;f[ra>>2]=V;sa=i+48|0;ta=i+44|0;f[ta>>2]=sa;f[sa>>2]=0;f[i+52>>2]=0;if(!qa)ua=W;else{W=qa+12|0;f[W>>2]=(f[W>>2]|0)+1;ua=f[X>>2]|0}if((ua|0)<3){ua=f[r+44>>2]|0;W=f[ta>>2]|0;f[W>>2]=f[ua>>2];f[W+4>>2]=f[ua+4>>2]}else{f[ga>>2]=0;BR(i,r)}ua=s+36|0;W=f[ua>>2]|0;if(W|0){qa=W+12|0;f[qa>>2]=(f[qa>>2]|0)+1}qa=f[pa>>2]|0;if(qa|0?(W=qa+12|0,qa=f[W>>2]|0,f[W>>2]=qa+-1,(qa|0)==1):0)CR(r);f[pa>>2]=0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[X>>2]|0)>0){qa=f[r+40>>2]|0;W=0;do{f[qa+(W<<2)>>2]=0;W=W+1|0;va=f[X>>2]|0}while((W|0)<(va|0));f[r>>2]=f[s>>2];if((va|0)<3)fa=171;else fa=173}else{f[r>>2]=f[s>>2];fa=171}if((fa|0)==171){va=f[s+4>>2]|0;if((va|0)<3){f[X>>2]=va;f[U>>2]=f[s+8>>2];f[R>>2]=f[s+12>>2];va=f[s+44>>2]|0;X=f[r+44>>2]|0;f[X>>2]=f[va>>2];f[X+4>>2]=f[va+4>>2]}else fa=173}if((fa|0)==173)BR(r,s);va=s+16|0;f[aa>>2]=f[va>>2];aa=s+20|0;f[ha>>2]=f[aa>>2];ha=s+24|0;f[ja>>2]=f[ha>>2];ja=s+28|0;f[la>>2]=f[ja>>2];la=s+32|0;f[na>>2]=f[la>>2];na=f[ua>>2]|0;f[pa>>2]=na;pa=f[oa>>2]|0;if(!pa)wa=na;else{na=pa+12|0;f[na>>2]=(f[na>>2]|0)+1;wa=f[ua>>2]|0}if(wa|0?(na=wa+12|0,wa=f[na>>2]|0,f[na>>2]=wa+-1,(wa|0)==1):0)CR(s);f[ua>>2]=0;wa=s+4|0;f[va>>2]=0;f[va+4>>2]=0;f[va+8>>2]=0;f[va+12>>2]=0;if((f[wa>>2]|0)>0){na=f[s+40>>2]|0;pa=0;do{f[na+(pa<<2)>>2]=0;pa=pa+1|0;xa=f[wa>>2]|0}while((pa|0)<(xa|0));f[s>>2]=f[i>>2];if((xa|0)<3)fa=184;else fa=186}else{f[s>>2]=f[i>>2];fa=184}if((fa|0)==184){xa=f[ga>>2]|0;if((xa|0)<3){f[wa>>2]=xa;f[s+8>>2]=f[V>>2];f[s+12>>2]=f[T>>2];T=f[ta>>2]|0;V=f[s+44>>2]|0;f[V>>2]=f[T>>2];f[V+4>>2]=f[T+4>>2]}else fa=186}if((fa|0)==186)BR(s,i);f[va>>2]=f[S>>2];f[aa>>2]=f[Q>>2];f[ha>>2]=f[ia>>2];f[ja>>2]=f[ka>>2];f[la>>2]=f[ma>>2];ma=f[oa>>2]|0;f[ua>>2]=ma;if(ma|0?(ua=ma+12|0,ma=f[ua>>2]|0,f[ua>>2]=ma+-1,(ma|0)==1):0)CR(i);f[oa>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[ga>>2]|0)>0){S=f[ra>>2]|0;ra=0;do{f[S+(ra<<2)>>2]=0;ra=ra+1|0}while((ra|0)<(f[ga>>2]|0))}ga=f[ta>>2]|0;if((ga|0)!=(sa|0))ZF(ga);ya=R;za=U}else{ya=r+12|0;za=r+8|0}U=s+12|0;R=s+8|0;ga=(f[za>>2]|0)+1-(f[R>>2]|0)|0;f[Z>>2]=(f[ya>>2]|0)+1-(f[U>>2]|0);f[Z+4>>2]=ga;KS(d,Z,5,-1,0,0);do if((NS(d)|0)==65536){Z=f[d+4>>2]|0;f[t>>2]=f[Z>>2];ga=t+4|0;ya=Z+4|0;f[ga>>2]=f[ya>>2];za=t+8|0;f[za>>2]=f[Z+8>>2];f[t+12>>2]=f[Z+12>>2];f[t+16>>2]=f[Z+16>>2];f[t+20>>2]=f[Z+20>>2];f[t+24>>2]=f[Z+24>>2];f[t+28>>2]=f[Z+28>>2];f[t+32>>2]=f[Z+32>>2];sa=f[Z+36>>2]|0;f[t+36>>2]=sa;ta=t+40|0;f[ta>>2]=za;za=t+48|0;ra=t+44|0;f[ra>>2]=za;f[za>>2]=0;f[t+52>>2]=0;if(sa|0){za=sa+12|0;f[za>>2]=(f[za>>2]|0)+1}if((f[ya>>2]|0)<3){ya=f[Z+44>>2]|0;za=f[ra>>2]|0;f[za>>2]=f[ya>>2];f[za+4>>2]=f[ya+4>>2];Aa=t;Ba=ta;break}else{f[ga>>2]=0;BR(t,Z);Aa=t;Ba=ta;break}}else{OR(t,d,-1);Aa=t;Ba=t+40|0}while(0);ta=f[Ba>>2]|0;Z=f[ta>>2]|0;f[_>>2]=f[ta+4>>2];f[_+4>>2]=Z;Z=f[Aa>>2]&4095;f[$>>2]=0;f[$+4>>2]=0;eqa(r,s,t,_,Z,$,0.0,0);switch(e|0){case 2:break;case 3:{Ca=0;fa=205;break}default:{Ca=(e|1|0)==5?1:2;fa=205}}if((fa|0)==205){$=(e|0)==5;Da=1.0/(+(f[R>>2]|0)*+(f[U>>2]|0));f[i>>2]=1124007936;Z=i+4|0;_=i+8|0;Aa=i+40|0;ca=Z;ea=ca+36|0;do{f[ca>>2]=0;ca=ca+4|0}while((ca|0)<(ea|0));f[Aa>>2]=_;_=i+48|0;ta=i+44|0;f[ta>>2]=_;f[_>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;ga=j+4|0;ya=j+8|0;za=j+40|0;ca=ga;ea=ca+36|0;do{f[ca>>2]=0;ca=ca+4|0}while((ca|0)<(ea|0));f[za>>2]=ya;ya=j+48|0;ra=j+44|0;f[ra>>2]=ya;f[ya>>2]=0;f[j+52>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;do if((e|0)==4){f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=r;sa=o+8|0;f[sa>>2]=0;f[sa+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=i;bqa(m,o,6);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=s;hZ(m,o,fT()|0);f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2];f[k+8>>2]=f[m+8>>2];f[k+12>>2]=f[m+12>>2];f[k+16>>2]=f[m+16>>2];f[k+20>>2]=f[m+20>>2];f[k+24>>2]=f[m+24>>2];f[k+28>>2]=f[m+28>>2];Ea=0;Fa=0;Ga=0;Ha=0;Ia=0.0;Ja=0.0;fa=214}else{f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=r;sa=o+8|0;f[sa>>2]=0;f[sa+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=i;sa=q+8|0;f[sa>>2]=0;f[sa+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=j;cqa(m,o,q,6,-1);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=s;f[o>>2]=-1040056314;f[o+4>>2]=k;f[o+8>>2]=1;f[o+12>>2]=4;f[q>>2]=-1040056314;f[q+4>>2]=l;f[q+8>>2]=1;f[q+12>>2]=4;iZ(m,o,q,fT()|0);Ka=+p[l>>3];La=+p[l+8>>3];Ma=+p[l+16>>3];Na=+p[l+24>>3];Oa=Ka*Ka+La*La+Ma*Ma+Na*Na;if($&Oa<2.220446049250313e-16){p[m>>3]=1.0;p[m+8>>3]=1.0;p[m+16>>3]=1.0;p[m+24>>3]=1.0;gL(t,m)|0;break}Na=+p[k>>3];Ma=+p[k+8>>3];La=+p[k+16>>3];Ka=+p[k+24>>3];Pa=Oa+Na*Na+Ma*Ma+La*La+Ka*Ka;if((Ca|0)==1)Qa=Oa;else{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;Qa=Pa}Oa=Pa/Da;Pa=+M(+Qa)/+M(+Da);sa=j+16|0;S=f[sa>>2]|0;if(!S){f[m>>2]=0;f[m+4>>2]=0;ca=c$(m,16)|0;da=332575;ea=ca+16|0;do{b[ca>>0]=b[da>>0]|0;ca=ca+1|0;da=da+1|0}while((ca|0)<(ea|0));j$(-215,m,332592,332098,892);d$(m);Ra=f[sa>>2]|0}else Ra=S;oa=Y(f[U>>2]|0,ba)|0;ma=Ra+(Y(f[ya>>2]|0,f[R>>2]|0)|0)|0;Ea=Ra;Fa=Ra+(oa<<3)|0;Ga=ma;Ha=ma+(oa<<3)|0;Ia=Pa;Ja=Oa;fa=214}while(0);if((fa|0)==214){Ra=i+16|0;$=f[Ra>>2]|0;if(!$){f[m>>2]=0;f[m+4>>2]=0;ca=c$(m,14)|0;da=332613;ea=ca+14|0;do{b[ca>>0]=b[da>>0]|0;ca=ca+1|0;da=da+1|0}while((ca|0)<(ea|0));j$(-215,m,332592,332098,899);d$(m);Sa=f[Ra>>2]|0}else Sa=$;$=Y(f[U>>2]|0,ba)|0;U=Sa+($<<3)|0;Ra=f[_>>2]|0;oa=Sa+(Y(Ra,f[R>>2]|0)|0)|0;R=oa+($<<3)|0;$=(Sa|0)==0?0:Ra>>>3;Ra=(f[j+16>>2]|0)==0?0:(f[ya>>2]|0)>>>3;ma=f[t+8>>2]|0;if((ma|0)>0){ua=f[t+16>>2]|0;la=f[f[t+44>>2]>>2]|0;ka=f[t+12>>2]|0;ja=(ka|0)>0;Qa=+((e|0)==1&1);ia=Ca&255;Ca=0;do{ha=ua+(Y(Ca,la)|0)|0;Q=Y(Ca,Ra)|0;a:do if(ja)switch(ia&3){case 1:{aa=Y(Ca,$)|0;va=Q;T=0;while(1){V=ha+(T<<2)|0;xa=0;Ka=+n[V>>2];La=0.0;do{wa=xa+aa|0;Ma=+p[Sa+(wa<<3)>>3]-+p[U+(wa<<3)>>3]-+p[oa+(wa<<3)>>3]+ +p[R+(wa<<3)>>3];La=La+Ma*Ma;Ka=Ka-Ma*+p[k+(xa<<3)>>3];xa=xa+1|0}while((xa|0)!=(ba|0));Ma=Da*La;switch(e|0){case 1:case 3:case 5:{xa=0;Na=0.0;while(1){wa=xa+va|0;Ta=Na+(+p[Ea+(wa<<3)>>3]-+p[Fa+(wa<<3)>>3]-+p[Ga+(wa<<3)>>3]+ +p[Ha+(wa<<3)>>3]);xa=xa+1|0;if((xa|0)==(ba|0)){Ua=Ta;break}else Na=Ta}break}default:Ua=0.0}b:do switch(e|0){case 1:case 3:case 5:{Na=Ua-Ma;La=Ia*+M(+(Na<0.0?0.0:Na));Na=+L(+Ka);if(Na<La){Va=Ka/La;break b}if(!(Na<La*1.125)){Va=Qa;break b}Va=Ka>0.0?1.0:-1.0;break}default:Va=Ka}while(0);n[V>>2]=Va;T=T+1|0;if((T|0)==(ka|0))break a;else{aa=aa+ba|0;va=va+ba|0}}break}case 2:{va=Q;aa=0;while(1){T=ha+(aa<<2)|0;Ka=+n[T>>2];xa=0;Ma=0.0;do{wa=xa+va|0;Ma=Ma+(+p[Ea+(wa<<3)>>3]-+p[Fa+(wa<<3)>>3]-+p[Ga+(wa<<3)>>3]+ +p[Ha+(wa<<3)>>3]);xa=xa+1|0}while((xa|0)!=(ba|0));La=Ja+(Ma-Ka*2.0);Na=La<0.0?0.0:La;c:do switch(e|0){case 1:case 3:case 5:{La=Ia*+M(+(Ma<0.0?0.0:Ma));Ta=+L(+Na);if(Ta<La){Wa=Na/La;break c}if(!(Ta<La*1.125)){Wa=Qa;break c}Wa=Na>0.0?1.0:-1.0;break}default:Wa=Na}while(0);n[T>>2]=Wa;aa=aa+1|0;if((aa|0)==(ka|0))break a;else va=va+ba|0}break}default:{va=Q;aa=0;while(1){xa=ha+(aa<<2)|0;Na=+n[xa>>2];Ma=Na;switch(e|0){case 1:case 3:case 5:{V=0;Ka=0.0;while(1){wa=V+va|0;La=Ka+(+p[Ea+(wa<<3)>>3]-+p[Fa+(wa<<3)>>3]-+p[Ga+(wa<<3)>>3]+ +p[Ha+(wa<<3)>>3]);V=V+1|0;if((V|0)==(ba|0)){Xa=La;break}else Ka=La}break}default:Xa=0.0}d:do switch(e|0){case 1:case 3:case 5:{Ka=Ia*+M(+(Xa<0.0?0.0:Xa));La=+L(+Na);if(La<Ka){Ya=Ma/Ka;break d}if(!(La<Ka*1.125)){Ya=Qa;break d}Ya=Na>0.0?1.0:-1.0;break}default:Ya=Ma}while(0);n[xa>>2]=Ya;aa=aa+1|0;if((aa|0)==(ka|0))break a;else va=va+ba|0}}}while(0);Ca=Ca+1|0}while((Ca|0)!=(ma|0))}}ma=j+36|0;Ca=f[ma>>2]|0;if(Ca|0?(ba=Ca+12|0,Ca=f[ba>>2]|0,f[ba>>2]=Ca+-1,(Ca|0)==1):0)CR(j);f[ma>>2]=0;ma=j+16|0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[ga>>2]|0)>0){ma=f[za>>2]|0;za=0;do{f[ma+(za<<2)>>2]=0;za=za+1|0}while((za|0)<(f[ga>>2]|0))}ga=f[ra>>2]|0;if((ga|0)!=(ya|0))ZF(ga);ga=i+36|0;ya=f[ga>>2]|0;if(ya|0?(ra=ya+12|0,ya=f[ra>>2]|0,f[ra>>2]=ya+-1,(ya|0)==1):0)CR(i);f[ga>>2]=0;ga=i+16|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[Z>>2]|0)>0){ga=f[Aa>>2]|0;Aa=0;do{f[ga+(Aa<<2)>>2]=0;Aa=Aa+1|0}while((Aa|0)<(f[Z>>2]|0))}Z=f[ta>>2]|0;if((Z|0)!=(_|0))ZF(Z)}Z=t+36|0;_=f[Z>>2]|0;if(_|0?(ta=_+12|0,_=f[ta>>2]|0,f[ta>>2]=_+-1,(_|0)==1):0)CR(t);f[Z>>2]=0;Z=t+16|0;_=t+4|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[_>>2]|0)>0){Z=f[Ba>>2]|0;Ba=0;do{f[Z+(Ba<<2)>>2]=0;Ba=Ba+1|0}while((Ba|0)<(f[_>>2]|0))}_=f[t+44>>2]|0;if((_|0)!=(t+48|0))ZF(_);_=s+36|0;Ba=f[_>>2]|0;if(Ba|0?(Z=Ba+12|0,Ba=f[Z>>2]|0,f[Z>>2]=Ba+-1,(Ba|0)==1):0)CR(s);f[_>>2]=0;_=s+16|0;Ba=s+4|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[Ba>>2]|0)>0){_=f[s+40>>2]|0;Z=0;do{f[_+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[Ba>>2]|0))}Ba=f[s+44>>2]|0;if((Ba|0)!=(s+48|0))ZF(Ba);Ba=r+36|0;Z=f[Ba>>2]|0;if(Z|0?(_=Z+12|0,Z=f[_>>2]|0,f[_>>2]=Z+-1,(Z|0)==1):0)CR(r);f[Ba>>2]=0;Ba=r+16|0;Z=r+4|0;f[Ba>>2]=0;f[Ba+4>>2]=0;f[Ba+8>>2]=0;f[Ba+12>>2]=0;if((f[Z>>2]|0)>0){Ba=f[r+40>>2]|0;_=0;do{f[Ba+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[Z>>2]|0))}Z=f[r+44>>2]|0;if((Z|0)!=(r+48|0))ZF(Z)}else{Z=RR(a,-1)|0;_=Z&7;Ba=Z&4088;if(e>>>0>=6){f[i>>2]=0;f[i+4>>2]=0;ca=c$(i,55)|0;da=332328;ea=ca+55|0;do{b[ca>>0]=b[da>>0]|0;ca=ca+1|0;da=da+1|0}while((ca|0)<(ea|0));j$(-215,i,332384,332098,768);d$(i)}ta=(_|0)==0;switch(Z&7){case 0:case 5:{if(!((Z|0)==(RR(c,-1)|0)?(nS(a,-1)|0)<3:0))fa=7;break}default:fa=7}if((fa|0)==7){f[i>>2]=0;f[i+4>>2]=0;ca=c$(i,71)|0;da=332402;ea=ca+71|0;do{b[ca>>0]=b[da>>0]|0;ca=ca+1|0;da=da+1|0}while((ca|0)<(ea|0));j$(-215,i,332384,332098,769);d$(i)}do if((NS(a)|0)==65536){da=f[a+4>>2]|0;f[l>>2]=f[da>>2];fa=l+4|0;Z=da+4|0;f[fa>>2]=f[Z>>2];_=l+8|0;f[_>>2]=f[da+8>>2];f[l+12>>2]=f[da+12>>2];f[l+16>>2]=f[da+16>>2];f[l+20>>2]=f[da+20>>2];f[l+24>>2]=f[da+24>>2];f[l+28>>2]=f[da+28>>2];f[l+32>>2]=f[da+32>>2];Aa=f[da+36>>2]|0;f[l+36>>2]=Aa;f[l+40>>2]=_;_=l+48|0;ga=l+44|0;f[ga>>2]=_;f[_>>2]=0;f[l+52>>2]=0;if(Aa|0){_=Aa+12|0;f[_>>2]=(f[_>>2]|0)+1}if((f[Z>>2]|0)<3){Z=f[da+44>>2]|0;_=f[ga>>2]|0;f[_>>2]=f[Z>>2];f[_+4>>2]=f[Z+4>>2];break}else{f[fa>>2]=0;BR(l,da);break}}else OR(l,a,-1);while(0);do if((NS(c)|0)==65536){a=f[c+4>>2]|0;f[m>>2]=f[a>>2];da=m+4|0;fa=a+4|0;f[da>>2]=f[fa>>2];Z=m+8|0;f[Z>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];_=f[a+36>>2]|0;f[m+36>>2]=_;f[m+40>>2]=Z;Z=m+48|0;ga=m+44|0;f[ga>>2]=Z;f[Z>>2]=0;f[m+52>>2]=0;if(_|0){Z=_+12|0;f[Z>>2]=(f[Z>>2]|0)+1}if((f[fa>>2]|0)<3){fa=f[a+44>>2]|0;Z=f[ga>>2]|0;f[Z>>2]=f[fa>>2];f[Z+4>>2]=f[fa+4>>2];break}else{f[da>>2]=0;BR(m,a);break}}else OR(m,c,-1);while(0);do if((NS(g)|0)==65536){c=f[g+4>>2]|0;f[o>>2]=f[c>>2];a=o+4|0;da=c+4|0;f[a>>2]=f[da>>2];fa=o+8|0;f[fa>>2]=f[c+8>>2];f[o+12>>2]=f[c+12>>2];f[o+16>>2]=f[c+16>>2];f[o+20>>2]=f[c+20>>2];f[o+24>>2]=f[c+24>>2];f[o+28>>2]=f[c+28>>2];f[o+32>>2]=f[c+32>>2];Z=f[c+36>>2]|0;f[o+36>>2]=Z;f[o+40>>2]=fa;fa=o+48|0;ga=o+44|0;f[ga>>2]=fa;f[fa>>2]=0;f[o+52>>2]=0;if(Z|0){fa=Z+12|0;f[fa>>2]=(f[fa>>2]|0)+1}if((f[da>>2]|0)<3){da=f[c+44>>2]|0;fa=f[ga>>2]|0;f[fa>>2]=f[da>>2];f[fa+4>>2]=f[da+4>>2];break}else{f[a>>2]=0;BR(o,c);break}}else OR(o,g,-1);while(0);g=f[m>>2]|0;c=f[l>>2]&4088;if(ta){a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=l;WJ(l,i,Ba|5,.00392156862745098,0.0)}if(!(g&7)){Ba=i+8|0;f[Ba>>2]=0;f[Ba+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=m;WJ(m,i,g&4088|5,.00392156862745098,0.0)}if(ta){f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=o;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;f[j>>2]=-1056833530;f[j+4>>2]=k;f[j+8>>2]=1;f[j+12>>2]=4;ta=q+8|0;f[ta>>2]=0;f[ta+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=o;pI(i,j,q,5);ta=i+8|0;f[ta>>2]=0;f[ta+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;WJ(o,i,c|5,.00392156862745098,0.0)}c=m+12|0;ta=(f[l+12>>2]|0)-(f[c>>2]|0)+1|0;g=m+8|0;Ba=(f[l+8>>2]|0)-(f[g>>2]|0)+1|0;f[r>>2]=ta;f[r+4>>2]=Ba;KS(d,r,5,-1,0,0);do if((NS(d)|0)==65536){r=f[d+4>>2]|0;f[q>>2]=f[r>>2];a=q+4|0;da=r+4|0;f[a>>2]=f[da>>2];fa=q+8|0;f[fa>>2]=f[r+8>>2];f[q+12>>2]=f[r+12>>2];f[q+16>>2]=f[r+16>>2];f[q+20>>2]=f[r+20>>2];f[q+24>>2]=f[r+24>>2];f[q+28>>2]=f[r+28>>2];f[q+32>>2]=f[r+32>>2];ga=f[r+36>>2]|0;f[q+36>>2]=ga;f[q+40>>2]=fa;fa=q+48|0;Z=q+44|0;f[Z>>2]=fa;f[fa>>2]=0;f[q+52>>2]=0;if(ga|0){fa=ga+12|0;f[fa>>2]=(f[fa>>2]|0)+1}if((f[da>>2]|0)<3){da=f[r+44>>2]|0;fa=f[Z>>2]|0;f[fa>>2]=f[da>>2];f[fa+4>>2]=f[da+4>>2];break}else{f[a>>2]=0;BR(q,r);break}}else OR(q,d,-1);while(0);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=l;WQ(t,l,i,1.0);f[s>>2]=1124007936;d=s+4|0;r=s+8|0;a=s+40|0;ca=d;ea=ca+36|0;do{f[ca>>2]=0;ca=ca+4|0}while((ca|0)<(ea|0));f[a>>2]=r;r=s+48|0;da=s+44|0;f[da>>2]=r;f[r>>2]=0;f[s+52>>2]=0;fa=f[t>>2]|0;Ah[f[(f[fa>>2]|0)+12>>2]&255](fa,t,s,-1);fj(t);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=o;WQ(w,o,i,1.0);f[v>>2]=1124007936;t=v+4|0;fa=v+8|0;Z=v+40|0;ca=t;ea=ca+36|0;do{f[ca>>2]=0;ca=ca+4|0}while((ca|0)<(ea|0));f[Z>>2]=fa;fa=v+48|0;ga=v+44|0;f[ga>>2]=fa;f[fa>>2]=0;f[v+52>>2]=0;_=f[w>>2]|0;Ah[f[(f[_>>2]|0)+12>>2]&255](_,w,v,-1);fj(w);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=o;WQ(y,m,i,1.0);f[x>>2]=1124007936;w=x+4|0;_=x+8|0;Aa=x+40|0;ca=w;ea=ca+36|0;do{f[ca>>2]=0;ca=ca+4|0}while((ca|0)<(ea|0));f[Aa>>2]=_;_=x+48|0;ya=x+44|0;f[ya>>2]=_;f[_>>2]=0;f[x+52>>2]=0;ra=f[y>>2]|0;Ah[f[(f[ra>>2]|0)+12>>2]&255](ra,y,x,-1);fj(y);f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;f[z+16>>2]=0;f[z+20>>2]=0;f[z+24>>2]=0;f[z+28>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;f[A+16>>2]=0;f[A+20>>2]=0;f[A+24>>2]=0;f[A+28>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=x;f[j>>2]=-1040056314;f[j+4>>2]=z;f[j+8>>2]=1;f[j+12>>2]=4;f[k>>2]=-1040056314;f[k+4>>2]=A;f[k+8>>2]=1;f[k+12>>2]=4;iZ(i,j,k,fT()|0);Ya=+p[A>>3];Qa=+p[A+8>>3];Xa=+p[A+16>>3];Ia=+p[A+24>>3];Wa=+p[z>>3];Ja=+p[z+8>>3];Va=+p[z+16>>3];Ua=+p[z+24>>3];Da=(Ya*Ya+Qa*Qa+Xa*Xa+Ia*Ia+(Wa*Wa+Ja*Ja+Va*Va+Ua*Ua))*(+(f[g>>2]|0)*+(f[c>>2]|0));e:do switch(e|0){case 0:{f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=v;WQ(C,m,i,1.0);f[B>>2]=1124007936;c=B+4|0;g=B+8|0;z=B+40|0;ca=c;ea=ca+36|0;do{f[ca>>2]=0;ca=ca+4|0}while((ca|0)<(ea|0));f[z>>2]=g;A=B+48|0;y=B+44|0;f[y>>2]=A;f[A>>2]=0;f[B+52>>2]=0;ra=f[C>>2]|0;Ah[f[(f[ra>>2]|0)+12>>2]&255](ra,C,B,-1);fj(C);f[D>>2]=1124007936;ra=D+4|0;za=D+8|0;ma=D+40|0;ca=ra;ea=ca+36|0;do{f[ca>>2]=0;ca=ca+4|0}while((ca|0)<(ea|0));f[ma>>2]=za;g=D+48|0;Ca=D+44|0;f[Ca>>2]=g;f[g>>2]=0;f[D+52>>2]=0;f[i>>2]=Ba;f[i+4>>2]=ta;AR(D,2,i,5);ba=f[ma>>2]|0;ka=f[ba>>2]|0;f[E>>2]=f[ba+4>>2];f[E+4>>2]=ka;ka=f[D>>2]&4095;f[F>>2]=0;f[F+4>>2]=0;eqa(l,B,D,E,ka,F,0.0,0);ka=f[q+40>>2]|0;ba=f[ka>>2]|0;f[G>>2]=f[ka+4>>2];f[G+4>>2]=ba;ba=f[q>>2]&4095;f[H>>2]=0;f[H+4>>2]=0;eqa(s,o,q,G,ba,H,0.0,0);LQ(i,D,2.0);ba=f[i>>2]|0;fi[f[(f[ba>>2]|0)+28>>2]&255](ba,i,q);fj(i);p[I>>3]=Da;ba=I+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;f[ba+16>>2]=0;f[ba+20>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=q;f[j>>2]=-1056833530;f[j+4>>2]=I;f[j+8>>2]=1;f[j+12>>2]=4;ba=k+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=q;TG(i,j,k,fT()|0,-1);ba=D+36|0;ka=f[ba>>2]|0;if(ka|0?(Ha=ka+12|0,ka=f[Ha>>2]|0,f[Ha>>2]=ka+-1,(ka|0)==1):0)CR(D);f[ba>>2]=0;ba=D+16|0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[ra>>2]|0)>0){ba=f[ma>>2]|0;ka=0;do{f[ba+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[ra>>2]|0))}ra=f[Ca>>2]|0;if((ra|0)!=(g|0))ZF(ra);ra=B+36|0;ka=f[ra>>2]|0;if(ka|0?(ba=ka+12|0,ka=f[ba>>2]|0,f[ba>>2]=ka+-1,(ka|0)==1):0)CR(B);f[ra>>2]=0;ra=B+16|0;f[ra>>2]=0;f[ra+4>>2]=0;f[ra+8>>2]=0;f[ra+12>>2]=0;if((f[c>>2]|0)>0){ra=f[z>>2]|0;ka=0;do{f[ra+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[c>>2]|0))}c=f[y>>2]|0;if((c|0)!=(A|0))ZF(c);break}case 3:{if(Da<2.220446049250313e-16){p[i>>3]=1.0;p[i+8>>3]=1.0;p[i+16>>3]=1.0;p[i+24>>3]=1.0;gL(q,i)|0;break e}f[j>>2]=1124007936;c=j+4|0;ka=j+8|0;ra=j+40|0;ca=c;ea=ca+36|0;do{f[ca>>2]=0;ca=ca+4|0}while((ca|0)<(ea|0));f[ra>>2]=ka;A=j+48|0;y=j+44|0;f[y>>2]=A;f[A>>2]=0;f[j+52>>2]=0;f[i>>2]=Ba;f[i+4>>2]=ta;AR(j,2,i,5);z=f[ra>>2]|0;g=f[z>>2]|0;f[J>>2]=f[z+4>>2];f[J+4>>2]=g;g=f[j>>2]&4095;f[K>>2]=0;f[K+4>>2]=0;eqa(s,v,j,J,g,K,0.0,0);g=f[q+40>>2]|0;z=f[g>>2]|0;f[N>>2]=f[g+4>>2];f[N+4>>2]=z;z=f[q>>2]&4095;f[O>>2]=0;f[O+4>>2]=0;eqa(l,x,q,N,z,O,0.0,0);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=j;z=k+8|0;f[z>>2]=0;f[z+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=j;wN(i,k);OQ(B,1.0,j);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=-1056571392;f[k+4>>2]=B;WQ(i,q,k,1.0);z=f[i>>2]|0;Ah[f[(f[z>>2]|0)+12>>2]&255](z,i,q,-1);fj(i);fj(B);Ua=+M(+Da);z=i+8|0;f[z>>2]=0;f[z+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=q;WJ(q,i,-1,1.0/Ua,0.0);z=j+36|0;g=f[z>>2]|0;if(g|0?(Ca=g+12|0,g=f[Ca>>2]|0,f[Ca>>2]=g+-1,(g|0)==1):0)CR(j);f[z>>2]=0;z=j+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[c>>2]|0)>0){z=f[ra>>2]|0;g=0;do{f[z+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[c>>2]|0))}c=f[y>>2]|0;if((c|0)!=(A|0))ZF(c);break}default:{f[i>>2]=0;f[i+4>>2]=0;j$(-213,i,332384,332098,841);d$(i)}}while(0);i=x+36|0;j=f[i>>2]|0;if(j|0?(B=j+12|0,j=f[B>>2]|0,f[B>>2]=j+-1,(j|0)==1):0)CR(x);f[i>>2]=0;i=x+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[w>>2]|0)>0){i=f[Aa>>2]|0;Aa=0;do{f[i+(Aa<<2)>>2]=0;Aa=Aa+1|0}while((Aa|0)<(f[w>>2]|0))}w=f[ya>>2]|0;if((w|0)!=(_|0))ZF(w);w=v+36|0;_=f[w>>2]|0;if(_|0?(ya=_+12|0,_=f[ya>>2]|0,f[ya>>2]=_+-1,(_|0)==1):0)CR(v);f[w>>2]=0;w=v+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[t>>2]|0)>0){w=f[Z>>2]|0;Z=0;do{f[w+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[t>>2]|0))}t=f[ga>>2]|0;if((t|0)!=(fa|0))ZF(t);t=s+36|0;fa=f[t>>2]|0;if(fa|0?(ga=fa+12|0,fa=f[ga>>2]|0,f[ga>>2]=fa+-1,(fa|0)==1):0)CR(s);f[t>>2]=0;t=s+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[d>>2]|0)>0){t=f[a>>2]|0;a=0;do{f[t+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[d>>2]|0))}d=f[da>>2]|0;if((d|0)!=(r|0))ZF(d);d=q+36|0;r=f[d>>2]|0;do if(r|0){da=r+12|0;a=f[da>>2]|0;f[da>>2]=a+-1;if((a|0)!=1)break;CR(q)}while(0);f[d>>2]=0;d=q+16|0;r=q+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[r>>2]|0)>0){d=f[q+40>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[r>>2]|0))}r=f[q+44>>2]|0;if((r|0)!=(q+48|0))ZF(r);r=o+36|0;q=f[r>>2]|0;do if(q|0){a=q+12|0;d=f[a>>2]|0;f[a>>2]=d+-1;if((d|0)!=1)break;CR(o)}while(0);f[r>>2]=0;r=o+16|0;q=o+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[q>>2]|0)>0){r=f[o+40>>2]|0;d=0;do{f[r+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[q>>2]|0))}q=f[o+44>>2]|0;if((q|0)!=(o+48|0))ZF(q);q=m+36|0;o=f[q>>2]|0;do if(o|0){d=o+12|0;r=f[d>>2]|0;f[d>>2]=r+-1;if((r|0)!=1)break;CR(m)}while(0);f[q>>2]=0;q=m+16|0;o=m+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[o>>2]|0)>0){q=f[m+40>>2]|0;r=0;do{f[q+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[o>>2]|0))}o=f[m+44>>2]|0;if((o|0)!=(m+48|0))ZF(o);o=l+36|0;m=f[o>>2]|0;do if(m|0){r=m+12|0;q=f[r>>2]|0;f[r>>2]=q+-1;if((q|0)!=1)break;CR(l)}while(0);f[o>>2]=0;o=l+16|0;m=l+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[m>>2]|0)>0){o=f[l+40>>2]|0;q=0;do{f[o+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))ZF(m)}if(!(f[P+4>>2]|0)){u=h;return}u=h;return}function gqa(a,c,d,e,g){a=a|0;c=c|0;d=+d;e=+e;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0,na=0.0,oa=0.0,pa=0,qa=0.0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0;i=u;u=u+1376|0;j=i+344|0;k=i+336|0;l=i+280|0;m=i+272|0;n=i+144|0;o=i;q=i+216|0;r=i+160|0;_$(k,76544);do if((NS(a)|0)==65536){s=f[a+4>>2]|0;f[l>>2]=f[s>>2];t=l+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=l+8|0;f[w>>2]=f[s+8>>2];f[l+12>>2]=f[s+12>>2];f[l+16>>2]=f[s+16>>2];f[l+20>>2]=f[s+20>>2];f[l+24>>2]=f[s+24>>2];f[l+28>>2]=f[s+28>>2];f[l+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[l+36>>2]=x;f[l+40>>2]=w;w=l+48|0;y=l+44|0;f[y>>2]=w;f[w>>2]=0;f[l+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[t>>2]=0;BR(l,s);break}}else OR(l,a,-1);while(0);a=g&7;switch(g&-8|0){case 24:{f[j>>2]=0;f[j+4>>2]=0;z=c$(j,57)|0;A=332705;B=z+57|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-215,j,338971,332763,1399);d$(j);C=d;break}case 8:{s=f[l>>2]|0;if(!(s&4095))D=s;else{f[j>>2]=0;f[j+4>>2]=0;z=c$(j,55)|0;A=332814;B=z+55|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-215,j,338971,332763,1402);d$(j);D=f[l>>2]|0}s=f[l+40>>2]|0;t=f[s+4>>2]|0;v=f[s>>2]|0;s=(D&16384|0)!=0;D=Y(v,t)|0;w=s?D:t;t=s?1:v;v=s?D:f[l+48>>2]|0;F1a(j|0,0,1024)|0;a:do if((t|0)>0){s=f[l+16>>2]|0;y=w+-4|0;if((w|0)<4){if((w|0)>0)E=0;else{F=0;G=0.0;break}while(1){x=s+(Y(E,v)|0)|0;H=0;do{I=j+((h[x+H>>0]|0)<<2)|0;f[I>>2]=(f[I>>2]|0)+1;H=H+1|0}while((H|0)!=(w|0));E=E+1|0;if((E|0)==(t|0)){F=0;G=0.0;break a}}}H=w&-4;if((H|0)<(w|0))J=0;else{x=0;while(1){I=s+(Y(x,v)|0)|0;K=0;do{L=h[I+(K|1)>>0]|0;M=j+((h[I+K>>0]|0)<<2)|0;f[M>>2]=(f[M>>2]|0)+1;M=j+(L<<2)|0;f[M>>2]=(f[M>>2]|0)+1;M=h[I+(K|3)>>0]|0;L=j+((h[I+(K|2)>>0]|0)<<2)|0;f[L>>2]=(f[L>>2]|0)+1;L=j+(M<<2)|0;f[L>>2]=(f[L>>2]|0)+1;K=K+4|0}while((K|0)<=(y|0));x=x+1|0;if((x|0)==(t|0)){F=0;G=0.0;break a}}}do{x=s+(Y(J,v)|0)|0;K=0;do{I=h[x+(K|1)>>0]|0;L=j+((h[x+K>>0]|0)<<2)|0;f[L>>2]=(f[L>>2]|0)+1;L=j+(I<<2)|0;f[L>>2]=(f[L>>2]|0)+1;L=h[x+(K|3)>>0]|0;I=j+((h[x+(K|2)>>0]|0)<<2)|0;f[I>>2]=(f[I>>2]|0)+1;I=j+(L<<2)|0;f[I>>2]=(f[I>>2]|0)+1;K=K+4|0}while((K|0)<=(y|0));N=H;do{K=j+((h[x+N>>0]|0)<<2)|0;f[K>>2]=(f[K>>2]|0)+1;N=N+1|0}while((N|0)!=(w|0));J=J+1|0}while((J|0)!=(t|0));F=0;G=0.0}else{F=0;G=0.0}while(0);do{G=G+ +(F|0)*+(f[j+(F<<2)>>2]|0);F=F+1|0}while((F|0)!=256);O=1.0/+(D|0);P=O*G;D=0;G=0.0;Q=0.0;R=0.0;S=0.0;while(1){T=O*+(f[j+(D<<2)>>2]|0);U=R*S;S=S+T;V=1.0-S;if(!((V<S?V:S)<1.1920928955078125e-07)?!((S<V?V:S)>.9999998807907104):0){W=+(D|0);X=(U+W*T)/S;T=X-(P-S*X)/V;Z=T*(S*V*T);F=Z>G;_=F?Z:G;$=F?W:Q;aa=X}else{_=G;$=Q;aa=U}D=D+1|0;if((D|0)==256)break;else{G=_;Q=$;R=aa}}C=$;break}case 16:{D=f[l>>2]|0;if(!(D&4095))ba=D;else{f[j>>2]=0;f[j+4>>2]=0;z=c$(j,55)|0;A=332814;B=z+55|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-215,j,338971,332763,1407);d$(j);ba=f[l>>2]|0}A=f[l+40>>2]|0;z=f[A+4>>2]|0;B=f[A>>2]|0;A=(ba&16384|0)!=0;ba=Y(B,z)|0;D=A?1:B;B=A?ba:z;z=A?ba:f[l+48>>2]|0;F1a(j|0,0,1024)|0;b:do if((D|0)>0){ba=f[l+16>>2]|0;A=B+-4|0;if((B|0)<4){if((B|0)>0)ca=0;else{da=0;break}while(1){F=ba+(Y(ca,z)|0)|0;t=0;do{J=j+((h[F+t>>0]|0)<<2)|0;f[J>>2]=(f[J>>2]|0)+1;t=t+1|0}while((t|0)!=(B|0));ca=ca+1|0;if((ca|0)==(D|0)){da=0;break b}}}t=B&-4;if((t|0)<(B|0))ea=0;else{F=0;while(1){J=ba+(Y(F,z)|0)|0;w=0;do{N=h[J+(w|1)>>0]|0;v=j+((h[J+w>>0]|0)<<2)|0;f[v>>2]=(f[v>>2]|0)+1;v=j+(N<<2)|0;f[v>>2]=(f[v>>2]|0)+1;v=h[J+(w|3)>>0]|0;N=j+((h[J+(w|2)>>0]|0)<<2)|0;f[N>>2]=(f[N>>2]|0)+1;N=j+(v<<2)|0;f[N>>2]=(f[N>>2]|0)+1;w=w+4|0}while((w|0)<=(A|0));F=F+1|0;if((F|0)==(D|0)){da=0;break b}}}do{F=ba+(Y(ea,z)|0)|0;w=0;do{J=h[F+(w|1)>>0]|0;N=j+((h[F+w>>0]|0)<<2)|0;f[N>>2]=(f[N>>2]|0)+1;N=j+(J<<2)|0;f[N>>2]=(f[N>>2]|0)+1;N=h[F+(w|3)>>0]|0;J=j+((h[F+(w|2)>>0]|0)<<2)|0;f[J>>2]=(f[J>>2]|0)+1;J=j+(N<<2)|0;f[J>>2]=(f[J>>2]|0)+1;w=w+4|0}while((w|0)<=(A|0));fa=t;do{w=j+((h[F+fa>>0]|0)<<2)|0;f[w>>2]=(f[w>>2]|0)+1;fa=fa+1|0}while((fa|0)!=(B|0));ea=ea+1|0}while((ea|0)!=(D|0));da=0}else da=0;while(0);while(1){if((f[j+(da<<2)>>2]|0)>0){ga=da;break}da=da+1|0;if((da|0)>=256){ga=0;break}}da=(((ga|0)>0)<<31>>31)+ga|0;ga=255;while(1){if((f[j+(ga<<2)>>2]|0)>0){ha=ga;break}if((ga|0)>1)ga=ga+-1|0;else{ha=0;break}}ga=(ha|0)<255;D=0;ea=0;B=0;do{fa=f[j+(D<<2)>>2]|0;z=(fa|0)>(ea|0);B=z?D:B;ea=z?fa:ea;D=D+1|0}while((D|0)!=256);D=(ga&1)+ha|0;if((B-da|0)<(D-B|0)){ha=0;ga=255;do{fa=j+(ha<<2)|0;z=f[fa>>2]|0;ca=j+(ga<<2)|0;f[fa>>2]=f[ca>>2];f[ca>>2]=z;ha=ha+1|0;ga=ga+-1|0}while((ha|0)<(ga|0));ia=1;ja=255-D|0;ka=255-B|0}else{ia=0;ja=da;ka=B}$=+(ja|0);aa=+(ea|0);R=+(ja-ka|0);if((ja|0)<(ka|0)){Q=0.0;ea=ja;_=$;while(1){ea=ea+1|0;G=+(ea|0);S=aa*G+R*+(f[j+(ea<<2)>>2]|0);ja=S>Q;P=ja?G:_;if((ea|0)==(ka|0)){la=P;break}else{Q=ja?S:Q;_=P}}}else la=$;$=la+-1.0;C=ia?255.0-$:$;break}default:C=d}ia=l+40|0;ka=f[ia>>2]|0;ea=f[ka>>2]|0;f[m>>2]=f[ka+4>>2];f[m+4>>2]=ea;KS(c,m,f[l>>2]&4095,-1,0,0);do if((NS(c)|0)==65536){m=f[c+4>>2]|0;f[j>>2]=f[m>>2];ea=j+4|0;ka=m+4|0;f[ea>>2]=f[ka>>2];ja=j+8|0;f[ja>>2]=f[m+8>>2];f[j+12>>2]=f[m+12>>2];f[j+16>>2]=f[m+16>>2];f[j+20>>2]=f[m+20>>2];f[j+24>>2]=f[m+24>>2];f[j+28>>2]=f[m+28>>2];f[j+32>>2]=f[m+32>>2];B=f[m+36>>2]|0;f[j+36>>2]=B;f[j+40>>2]=ja;ja=j+48|0;da=j+44|0;f[da>>2]=ja;f[ja>>2]=0;f[j+52>>2]=0;if(B|0){ja=B+12|0;f[ja>>2]=(f[ja>>2]|0)+1}if((f[ka>>2]|0)<3){ka=f[m+44>>2]|0;ja=f[da>>2]|0;f[ja>>2]=f[ka>>2];f[ja+4>>2]=f[ka+4>>2];break}else{f[ea>>2]=0;BR(j,m);break}}else OR(j,c,-1);while(0);c=f[l>>2]|0;c:do switch(c&7){case 0:{m=~~C;ea=m-(+(m|0)>C&1)|0;d=+(ea|0);m=rNa(e)|0;ka=(a|0)==2;ja=ka?ea:m;m=ja>>>0<256?ja:(ja|0)>0?255:0;ja=m&255;da=(ea|0)>254;if(ea>>>0<=254){ma=c;na=+(m&255);oa=d;pa=100;break c}if((a|1|0)!=1?!((ka|(a|0)==4)&(ea|0)<0|(a|0)==3&da):0){ea=n+8|0;f[ea>>2]=0;f[ea+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=j;eL(l,n);qa=d;break c}switch(g&7){case 0:{ra=da?0:ja;break}case 1:{ra=da?ja:0;break}default:ra=0}p[o>>3]=+(ra|0);f[n>>2]=-1056833530;f[n+4>>2]=o;f[n+8>>2]=1;f[n+12>>2]=1;hL(j,n,fT()|0)|0;qa=d;break}case 3:{ja=~~C;da=ja-(+(ja|0)>C&1)|0;d=+(da|0);ja=rNa(e)|0;ea=(a|0)==2;ka=ea?da:ja;ja=(ka+32768|0)>>>0<65536?ka:(ka|0)>0?32767:32768;ka=ja<<16>>16;m=(da|0)>32766;if((da+32768|0)>>>0<=65534){ma=c;na=+((ja&65535)<<16>>16);oa=d;pa=100;break c}if((a|1|0)!=1?!((ea|(a|0)==4)&(da|0)<-32768|(a|0)==3&m):0){da=n+8|0;f[da>>2]=0;f[da+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=j;eL(l,n);qa=d;break c}switch(g&7){case 0:{sa=m?0:ka;break}case 1:{sa=m?ka:0;break}default:sa=0}p[o>>3]=+(sa|0);f[n>>2]=-1056833530;f[n+4>>2]=o;f[n+8>>2]=1;f[n+12>>2]=1;hL(j,n,fT()|0)|0;qa=d;break}case 2:{ka=~~C;m=ka-(+(ka|0)>C&1)|0;d=+(m|0);ka=rNa(e)|0;da=(a|0)==2?m:ka;ka=da>>>0<65536?da:(da|0)>0?65535:0;da=ka&65535;ea=(m|0)>65534;if(m>>>0<=65534){ma=c;na=+(ka&65535);oa=d;pa=100;break c}ka=g&255;d:do if((a|1|0)==1)pa=93;else{switch(ka&7){case 2:case 4:{if((a|0)==3&ea|(m|0)<0){pa=93;break d}break}default:if((a|0)==3&ea){ta=0;break d}}ja=n+8|0;f[ja>>2]=0;f[ja+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=j;eL(l,n);qa=d;break c}while(0);e:do if((pa|0)==93)switch(ka&7){case 0:{ta=ea?0:da;break e;break}case 1:{ta=ea?da:0;break e;break}default:{ta=0;break e}}while(0);p[o>>3]=+(ta|0);f[n>>2]=-1056833530;f[n+4>>2]=o;f[n+8>>2]=1;f[n+12>>2]=1;hL(j,n,fT()|0)|0;qa=d;break}case 6:case 5:{ma=c;na=e;oa=C;pa=100;break}default:{f[n>>2]=0;f[n+4>>2]=0;j$(-210,n,338971,332763,1505);d$(n);ma=f[l>>2]|0;na=e;oa=C;pa=100}}while(0);if((pa|0)==100){pa=j+8|0;c=f[pa>>2]|0;f[n>>2]=0;f[n+4>>2]=c;f[q>>2]=ma;ma=q+4|0;c=l+4|0;ta=f[c>>2]|0;f[ma>>2]=ta;g=q+8|0;f[g>>2]=f[l+8>>2];f[q+12>>2]=f[l+12>>2];sa=q+16|0;f[sa>>2]=f[l+16>>2];f[q+20>>2]=f[l+20>>2];f[q+24>>2]=f[l+24>>2];f[q+28>>2]=f[l+28>>2];f[q+32>>2]=f[l+32>>2];ra=q+36|0;da=f[l+36>>2]|0;f[ra>>2]=da;ea=q+40|0;f[ea>>2]=g;g=q+48|0;ka=q+44|0;f[ka>>2]=g;f[g>>2]=0;f[q+52>>2]=0;if(!da)ua=ta;else{ta=da+12|0;f[ta>>2]=(f[ta>>2]|0)+1;ua=f[c>>2]|0}if((ua|0)<3){ua=f[l+44>>2]|0;c=f[ka>>2]|0;f[c>>2]=f[ua>>2];f[c+4>>2]=f[ua+4>>2]}else{f[ma>>2]=0;BR(q,l)}f[r>>2]=f[j>>2];ua=r+4|0;c=j+4|0;ta=f[c>>2]|0;f[ua>>2]=ta;da=r+8|0;f[da>>2]=f[pa>>2];m=j+12|0;f[r+12>>2]=f[m>>2];ja=r+16|0;f[ja>>2]=f[j+16>>2];f[r+20>>2]=f[j+20>>2];f[r+24>>2]=f[j+24>>2];f[r+28>>2]=f[j+28>>2];f[r+32>>2]=f[j+32>>2];B=r+36|0;D=f[j+36>>2]|0;f[B>>2]=D;ga=r+40|0;f[ga>>2]=da;da=r+48|0;ha=r+44|0;f[ha>>2]=da;f[da>>2]=0;f[r+52>>2]=0;if(!D)va=ta;else{ta=D+12|0;f[ta>>2]=(f[ta>>2]|0)+1;va=f[c>>2]|0}if((va|0)<3){va=f[j+44>>2]|0;ta=f[ha>>2]|0;f[ta>>2]=f[va>>2];f[ta+4>>2]=f[va+4>>2]}else{f[ua>>2]=0;BR(r,j)}hqa(o,q,r,oa,na,a);a=f[c>>2]|0;if((a|0)<3)wa=Y(f[m>>2]|0,f[pa>>2]|0)|0;else{pa=f[j+40>>2]|0;m=0;c=1;while(1){va=Y(f[pa+(m<<2)>>2]|0,c)|0;m=m+1|0;if((m|0)==(a|0)){wa=va;break}else c=va}}_U(n,o,+(wa>>>0)*.0000152587890625);iqa(o);o=f[B>>2]|0;if(o|0?(wa=o+12|0,o=f[wa>>2]|0,f[wa>>2]=o+-1,(o|0)==1):0)CR(r);f[B>>2]=0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[ua>>2]|0)>0){ja=f[ga>>2]|0;ga=0;do{f[ja+(ga<<2)>>2]=0;ga=ga+1|0}while((ga|0)<(f[ua>>2]|0))}ua=f[ha>>2]|0;if((ua|0)!=(da|0))ZF(ua);ua=f[ra>>2]|0;if(ua|0?(da=ua+12|0,ua=f[da>>2]|0,f[da>>2]=ua+-1,(ua|0)==1):0)CR(q);f[ra>>2]=0;f[sa>>2]=0;f[sa+4>>2]=0;f[sa+8>>2]=0;f[sa+12>>2]=0;if((f[ma>>2]|0)>0){sa=f[ea>>2]|0;ea=0;do{f[sa+(ea<<2)>>2]=0;ea=ea+1|0}while((ea|0)<(f[ma>>2]|0))}ma=f[ka>>2]|0;if((ma|0)!=(g|0))ZF(ma);qa=oa}ma=j+36|0;g=f[ma>>2]|0;if(g|0?(ka=g+12|0,g=f[ka>>2]|0,f[ka>>2]=g+-1,(g|0)==1):0)CR(j);f[ma>>2]=0;ma=j+16|0;g=j+4|0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[g>>2]|0)>0){ma=f[j+40>>2]|0;ka=0;do{f[ma+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[g>>2]|0))}g=f[j+44>>2]|0;if((g|0)!=(j+48|0))ZF(g);g=l+36|0;j=f[g>>2]|0;if(j|0?(ka=j+12|0,j=f[ka>>2]|0,f[ka>>2]=j+-1,(j|0)==1):0)CR(l);f[g>>2]=0;g=l+16|0;j=l+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[j>>2]|0)>0){g=f[ia>>2]|0;ia=0;do{f[g+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[j>>2]|0))}j=f[l+44>>2]|0;if((j|0)!=(l+48|0))ZF(j);if(!(f[k+4>>2]|0)){u=i;return +qa}u=i;return +qa}function hqa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f[a>>2]=76572;h=a+4|0;f[h>>2]=1124007936;i=a+8|0;j=a+12|0;k=a+44|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;n=a+52|0;o=a+48|0;f[o>>2]=n;f[n>>2]=0;f[a+56>>2]=0;n=a+60|0;f[n>>2]=1124007936;q=a+64|0;r=a+68|0;s=a+100|0;l=q;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[s>>2]=r;l=a+108|0;m=a+104|0;f[m>>2]=l;f[l>>2]=0;f[a+112>>2]=0;if((h|0)!=(b|0)){l=b+36|0;t=f[l>>2]|0;if(t){u=t+12|0;f[u>>2]=(f[u>>2]|0)+1;u=a+40|0;t=f[u>>2]|0;if((t|0)!=0?(v=t+12|0,t=f[v>>2]|0,f[v>>2]=t+-1,(t|0)==1):0){CR(h);w=u}else w=u}else w=a+40|0;f[w>>2]=0;u=a+20|0;f[u>>2]=0;f[u+4>>2]=0;f[u+8>>2]=0;f[u+12>>2]=0;if((f[i>>2]|0)>0){t=f[k>>2]|0;k=0;do{f[t+(k<<2)>>2]=0;k=k+1|0;x=f[i>>2]|0}while((k|0)<(x|0));f[h>>2]=f[b>>2];if((x|0)<3)y=12;else y=14}else{f[h>>2]=f[b>>2];y=12}if((y|0)==12){x=f[b+4>>2]|0;if((x|0)<3){f[i>>2]=x;f[j>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];j=f[b+44>>2]|0;x=f[o>>2]|0;f[x>>2]=f[j>>2];f[x+4>>2]=f[j+4>>2]}else y=14}if((y|0)==14)BR(h,b);f[u>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];f[w>>2]=f[l>>2]}if((n|0)==(c|0)){z=a+120|0;p[z>>3]=d;A=a+128|0;p[A>>3]=e;B=a+136|0;f[B>>2]=g;return}l=c+36|0;w=f[l>>2]|0;if(w|0){b=w+12|0;f[b>>2]=(f[b>>2]|0)+1}b=a+96|0;w=f[b>>2]|0;if(w|0?(u=w+12|0,w=f[u>>2]|0,f[u>>2]=w+-1,(w|0)==1):0)CR(n);f[b>>2]=0;w=a+76|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[q>>2]|0)>0){u=f[s>>2]|0;s=0;do{f[u+(s<<2)>>2]=0;s=s+1|0;C=f[q>>2]|0}while((s|0)<(C|0));f[n>>2]=f[c>>2];if((C|0)<3)y=27;else y=29}else{f[n>>2]=f[c>>2];y=27}if((y|0)==27){C=f[c+4>>2]|0;if((C|0)<3){f[q>>2]=C;f[r>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];r=f[c+44>>2]|0;C=f[m>>2]|0;f[C>>2]=f[r>>2];f[C+4>>2]=f[r+4>>2]}else y=29}if((y|0)==29)BR(n,c);f[w>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];f[b>>2]=f[l>>2];z=a+120|0;p[z>>3]=d;A=a+128|0;p[A>>3]=e;B=a+136|0;f[B>>2]=g;return}function iqa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=76572;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function jqa(a){a=a|0;iqa(a);PYa(a);return}function kqa(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0;e=u;u=u+384|0;g=e+120|0;i=e+112|0;k=e+56|0;l=e;m=f[c>>2]|0;o=f[c+4>>2]|0;f[g>>2]=m;f[g+4>>2]=o;f[i>>2]=-2147483648;f[i+4>>2]=2147483647;DR(k,a+4|0,g,i);f[g>>2]=m;f[g+4>>2]=o;f[i>>2]=-2147483648;f[i+4>>2]=2147483647;DR(l,a+60|0,g,i);i=f[k>>2]|0;a:do switch(i&7){case 0:{o=~~+p[a+120>>3]&255;m=~~+p[a+128>>3]&255;c=f[a+136>>2]|0;q=f[k+40>>2]|0;r=f[q>>2]|0;s=Y(f[q+4>>2]|0,(i>>>3&511)+1|0)|0;q=f[k+48>>2]|0;t=f[l+48>>2]|0;if(!(i&16384)){v=t;w=s;x=r;y=q}else{z=(f[l>>2]&16384|0)!=0;A=Y(s,r)|0;v=z?A:t;w=z?A:s;x=z?1:r;y=z?A:q}q=k+16|0;A=l+16|0;if((w|0)>0){z=o&255;r=z+1|0;F1a(g|0,0,256)|0;switch(c|0){case 0:{F1a(g|0,0,r|0)|0;if(r>>>0<256)F1a(g+r|0,m|0,z^255|0)|0;break}case 1:{F1a(g|0,m|0,r|0)|0;if(r>>>0<256)F1a(g+r|0,0,z^255|0)|0;break}case 2:{m=0;do{b[g+m>>0]=m;m=m+1|0}while((m|0)!=(r|0));if(r>>>0<256)F1a(g+r|0,o|0,z^255|0)|0;break}case 3:{F1a(g|0,0,r|0)|0;if(r>>>0<256){m=r;do{b[g+m>>0]=m;m=m+1|0}while((m|0)!=256)}break}case 4:{m=0;do{b[g+m>>0]=m;m=m+1|0}while((m|0)!=(r|0));if(r>>>0<256)F1a(g+r|0,0,z^255|0)|0;break}default:{}}m=f[q>>2]|0;o=f[A>>2]|0;b:do if((x|0)>0){c=w+-4|0;if((w|0)<4){s=o;t=0;B=m;while(1){C=0;do{b[s+C>>0]=b[g+(h[B+C>>0]|0)>>0]|0;C=C+1|0}while((C|0)!=(w|0));t=t+1|0;if((t|0)==(x|0))break b;else{s=s+v|0;B=B+y|0}}}B=w&-4;if((B|0)<(w|0)){D=o;E=0;F=m}else{s=o;t=0;C=m;while(1){G=0;do{H=G|1;I=b[g+(h[C+H>>0]|0)>>0]|0;b[s+G>>0]=b[g+(h[C+G>>0]|0)>>0]|0;b[s+H>>0]=I;I=G|2;H=G|3;J=b[g+(h[C+H>>0]|0)>>0]|0;b[s+I>>0]=b[g+(h[C+I>>0]|0)>>0]|0;b[s+H>>0]=J;G=G+4|0}while((G|0)<=(c|0));t=t+1|0;if((t|0)==(x|0))break b;else{s=s+v|0;C=C+y|0}}}while(1){C=0;do{s=C|1;t=b[g+(h[F+s>>0]|0)>>0]|0;b[D+C>>0]=b[g+(h[F+C>>0]|0)>>0]|0;b[D+s>>0]=t;t=C|2;s=C|3;G=b[g+(h[F+s>>0]|0)>>0]|0;b[D+t>>0]=b[g+(h[F+t>>0]|0)>>0]|0;b[D+s>>0]=G;C=C+4|0}while((C|0)<=(c|0));K=B;do{b[D+K>>0]=b[g+(h[F+K>>0]|0)>>0]|0;K=K+1|0}while((K|0)!=(w|0));E=E+1|0;if((E|0)==(x|0))break;else{D=D+v|0;F=F+y|0}}}while(0)}break}case 3:{m=~~+p[a+120>>3];o=~~+p[a+128>>3];A=f[k+40>>2]|0;q=f[A>>2]|0;z=Y(f[A+4>>2]|0,(i>>>3&511)+1|0)|0;A=f[k+16>>2]|0;r=f[l+16>>2]|0;B=(f[k+48>>2]|0)>>>1;c=(f[l+48>>2]|0)>>>1;if(!(i&16384)){L=c;M=z;N=q;O=B}else{C=(f[l>>2]&16384|0)!=0;G=Y(z,q)|0;L=C?G:c;M=C?G:z;N=C?1:q;O=C?G:B}switch(f[a+136>>2]|0){case 0:{if((M|0)>0&(N|0)>0){P=r;Q=0;R=A}else break a;while(1){B=0;do{d[P+(B<<1)>>1]=(d[R+(B<<1)>>1]|0)>m<<16>>16?o:0;B=B+1|0}while((B|0)!=(M|0));Q=Q+1|0;if((Q|0)==(N|0))break;else{P=P+(L<<1)|0;R=R+(O<<1)|0}}break}case 1:{if((M|0)>0&(N|0)>0){S=r;T=0;U=A}else break a;while(1){B=0;do{d[S+(B<<1)>>1]=(d[U+(B<<1)>>1]|0)>m<<16>>16?0:o;B=B+1|0}while((B|0)!=(M|0));T=T+1|0;if((T|0)==(N|0))break;else{S=S+(L<<1)|0;U=U+(O<<1)|0}}break}case 2:{if((M|0)>0&(N|0)>0){V=r;W=0;X=A}else break a;while(1){o=0;do{B=d[X+(o<<1)>>1]|0;d[V+(o<<1)>>1]=B<<16>>16>m<<16>>16?m:B;o=o+1|0}while((o|0)!=(M|0));W=W+1|0;if((W|0)==(N|0))break;else{V=V+(L<<1)|0;X=X+(O<<1)|0}}break}case 3:{if((M|0)>0&(N|0)>0){Z=r;_=0;$=A}else break a;while(1){o=0;do{B=d[$+(o<<1)>>1]|0;d[Z+(o<<1)>>1]=B<<16>>16>m<<16>>16?B:0;o=o+1|0}while((o|0)!=(M|0));_=_+1|0;if((_|0)==(N|0))break;else{Z=Z+(L<<1)|0;$=$+(O<<1)|0}}break}case 4:{if((M|0)>0&(N|0)>0){aa=r;ba=0;ca=A}else break a;while(1){o=0;do{B=d[ca+(o<<1)>>1]|0;d[aa+(o<<1)>>1]=B<<16>>16>m<<16>>16?0:B;o=o+1|0}while((o|0)!=(M|0));ba=ba+1|0;if((ba|0)==(N|0))break;else{aa=aa+(L<<1)|0;ca=ca+(O<<1)|0}}break}default:{f[g>>2]=0;f[g+4>>2]=0;j$(-5,g,332870,332763,120);d$(g);break a}}break}case 2:{m=~~+p[a+120>>3]&65535;A=~~+p[a+128>>3]&65535;r=f[k+40>>2]|0;o=f[r>>2]|0;B=Y(f[r+4>>2]|0,(i>>>3&511)+1|0)|0;r=((f[k+48>>2]|0)>>>0)/((1212424721>>>(i<<2&28)&15)>>>0)|0;G=f[l>>2]|0;C=((f[l+48>>2]|0)>>>0)/((1212424721>>>(G<<2&28)&15)>>>0)|0;q=(i&16384|0)==0;z=(G&16384|0)!=0;G=Y(B,o)|0;c=q?B:z?G:B;B=q?o:z?1:o;o=q?C:z?G:C;C=q?r:z?G:r;r=f[k+16>>2]|0;G=f[l+16>>2]|0;switch(f[a+136>>2]|0){case 0:{if((c|0)>0&(B|0)>0){da=G;ea=0;fa=r}else break a;while(1){z=0;do{d[da+(z<<1)>>1]=(j[fa+(z<<1)>>1]|0)>(m&65535)?A:0;z=z+1|0}while((z|0)!=(c|0));ea=ea+1|0;if((ea|0)==(B|0))break;else{da=da+(o<<1)|0;fa=fa+(C<<1)|0}}break}case 1:{if((c|0)>0&(B|0)>0){ga=G;ha=0;ia=r}else break a;while(1){z=0;do{d[ga+(z<<1)>>1]=(j[ia+(z<<1)>>1]|0)>(m&65535)?0:A;z=z+1|0}while((z|0)!=(c|0));ha=ha+1|0;if((ha|0)==(B|0))break;else{ga=ga+(o<<1)|0;ia=ia+(C<<1)|0}}break}case 2:{if((c|0)>0&(B|0)>0){ja=G;ka=0;la=r}else break a;while(1){A=0;do{z=d[la+(A<<1)>>1]|0;d[ja+(A<<1)>>1]=(z&65535)>(m&65535)?m:z;A=A+1|0}while((A|0)!=(c|0));ka=ka+1|0;if((ka|0)==(B|0))break;else{ja=ja+(o<<1)|0;la=la+(C<<1)|0}}break}case 3:{if((c|0)>0&(B|0)>0){ma=G;na=0;oa=r}else break a;while(1){A=0;do{z=d[oa+(A<<1)>>1]|0;d[ma+(A<<1)>>1]=(z&65535)>(m&65535)?z:0;A=A+1|0}while((A|0)!=(c|0));na=na+1|0;if((na|0)==(B|0))break;else{ma=ma+(o<<1)|0;oa=oa+(C<<1)|0}}break}case 4:{if((c|0)>0&(B|0)>0){pa=G;qa=0;ra=r}else break a;while(1){A=0;do{z=d[ra+(A<<1)>>1]|0;d[pa+(A<<1)>>1]=(z&65535)>(m&65535)?0:z;A=A+1|0}while((A|0)!=(c|0));qa=qa+1|0;if((qa|0)==(B|0))break;else{pa=pa+(o<<1)|0;ra=ra+(C<<1)|0}}break}default:{f[g>>2]=0;f[g+4>>2]=0;j$(-5,g,332870,332763,120);d$(g);break a}}break}case 5:{sa=+p[a+120>>3];ta=+p[a+128>>3];C=f[k+40>>2]|0;o=f[C>>2]|0;B=Y(f[C+4>>2]|0,(i>>>3&511)+1|0)|0;C=f[k+16>>2]|0;c=f[l+16>>2]|0;m=(f[k+48>>2]|0)>>>2;r=(f[l+48>>2]|0)>>>2;if(!(i&16384)){ua=B;va=o}else{G=(f[l>>2]&16384|0)!=0;A=Y(G?o:1,B)|0;ua=A;va=G?1:o}switch(f[a+136>>2]|0){case 0:{if((ua|0)>0&(va|0)>0){wa=c;xa=0;ya=C}else break a;while(1){o=0;do{n[wa+(o<<2)>>2]=+n[ya+(o<<2)>>2]>sa?ta:0.0;o=o+1|0}while((o|0)!=(ua|0));xa=xa+1|0;if((xa|0)==(va|0))break;else{wa=wa+(r<<2)|0;ya=ya+(m<<2)|0}}break}case 1:{if((ua|0)>0&(va|0)>0){za=c;Aa=0;Ba=C}else break a;while(1){o=0;do{n[za+(o<<2)>>2]=!(+n[Ba+(o<<2)>>2]<=sa)?0.0:ta;o=o+1|0}while((o|0)!=(ua|0));Aa=Aa+1|0;if((Aa|0)==(va|0))break;else{za=za+(r<<2)|0;Ba=Ba+(m<<2)|0}}break}case 2:{if((ua|0)>0&(va|0)>0){Ca=c;Da=0;Ea=C}else break a;while(1){o=0;do{ta=+n[Ea+(o<<2)>>2];n[Ca+(o<<2)>>2]=ta>sa?sa:ta;o=o+1|0}while((o|0)!=(ua|0));Da=Da+1|0;if((Da|0)==(va|0))break;else{Ca=Ca+(r<<2)|0;Ea=Ea+(m<<2)|0}}break}case 3:{if((ua|0)>0&(va|0)>0){Fa=c;Ga=0;Ha=C}else break a;while(1){o=0;do{ta=+n[Ha+(o<<2)>>2];n[Fa+(o<<2)>>2]=ta>sa?ta:0.0;o=o+1|0}while((o|0)!=(ua|0));Ga=Ga+1|0;if((Ga|0)==(va|0))break;else{Fa=Fa+(r<<2)|0;Ha=Ha+(m<<2)|0}}break}case 4:{if((ua|0)>0&(va|0)>0){Ia=c;Ja=0;Ka=C}else break a;while(1){o=0;do{ta=+n[Ka+(o<<2)>>2];n[Ia+(o<<2)>>2]=!(ta<=sa)?0.0:ta;o=o+1|0}while((o|0)!=(ua|0));Ja=Ja+1|0;if((Ja|0)==(va|0))break;else{Ia=Ia+(r<<2)|0;Ka=Ka+(m<<2)|0}}break}default:{f[g>>2]=0;f[g+4>>2]=0;j$(-5,g,332870,332763,120);d$(g);break a}}break}case 6:{sa=+p[a+120>>3];ta=+p[a+128>>3];m=f[k+40>>2]|0;r=f[m>>2]|0;C=Y(f[m+4>>2]|0,(i>>>3&511)+1|0)|0;m=f[k+16>>2]|0;c=f[l+16>>2]|0;o=(f[k+48>>2]|0)>>>3;G=(f[l+48>>2]|0)>>>3;if(!(i&16384)){La=C;Ma=r}else{A=(f[l>>2]&16384|0)!=0;B=Y(A?r:1,C)|0;La=B;Ma=A?1:r}switch(f[a+136>>2]|0){case 0:{if((La|0)>0&(Ma|0)>0){Na=c;Oa=0;Pa=m}else break a;while(1){r=0;do{p[Na+(r<<3)>>3]=+p[Pa+(r<<3)>>3]>sa?ta:0.0;r=r+1|0}while((r|0)!=(La|0));Oa=Oa+1|0;if((Oa|0)==(Ma|0))break;else{Na=Na+(G<<3)|0;Pa=Pa+(o<<3)|0}}break}case 1:{if((La|0)>0&(Ma|0)>0){Qa=c;Ra=0;Sa=m}else break a;while(1){r=0;do{p[Qa+(r<<3)>>3]=!(+p[Sa+(r<<3)>>3]<=sa)?0.0:ta;r=r+1|0}while((r|0)!=(La|0));Ra=Ra+1|0;if((Ra|0)==(Ma|0))break;else{Qa=Qa+(G<<3)|0;Sa=Sa+(o<<3)|0}}break}case 2:{if((La|0)>0&(Ma|0)>0){Ta=c;Ua=0;Va=m}else break a;while(1){r=0;do{ta=+p[Va+(r<<3)>>3];p[Ta+(r<<3)>>3]=ta>sa?sa:ta;r=r+1|0}while((r|0)!=(La|0));Ua=Ua+1|0;if((Ua|0)==(Ma|0))break;else{Ta=Ta+(G<<3)|0;Va=Va+(o<<3)|0}}break}case 3:{if((La|0)>0&(Ma|0)>0){Wa=c;Xa=0;Ya=m}else break a;while(1){r=0;do{ta=+p[Ya+(r<<3)>>3];p[Wa+(r<<3)>>3]=ta>sa?ta:0.0;r=r+1|0}while((r|0)!=(La|0));Xa=Xa+1|0;if((Xa|0)==(Ma|0))break;else{Wa=Wa+(G<<3)|0;Ya=Ya+(o<<3)|0}}break}case 4:{if((La|0)>0&(Ma|0)>0){Za=c;_a=0;$a=m}else break a;while(1){r=0;do{ta=+p[$a+(r<<3)>>3];p[Za+(r<<3)>>3]=!(ta<=sa)?0.0:ta;r=r+1|0}while((r|0)!=(La|0));_a=_a+1|0;if((_a|0)==(Ma|0))break;else{Za=Za+(G<<3)|0;$a=$a+(o<<3)|0}}break}default:{f[g>>2]=0;f[g+4>>2]=0;j$(-5,g,332870,332763,120);d$(g);break a}}break}default:{}}while(0);g=l+36|0;$a=f[g>>2]|0;if($a|0?(Za=$a+12|0,$a=f[Za>>2]|0,f[Za>>2]=$a+-1,($a|0)==1):0)CR(l);f[g>>2]=0;g=l+16|0;$a=l+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[$a>>2]|0)>0){g=f[l+40>>2]|0;Za=0;do{f[g+(Za<<2)>>2]=0;Za=Za+1|0}while((Za|0)<(f[$a>>2]|0))}$a=f[l+44>>2]|0;if(($a|0)!=(l+48|0))ZF($a);$a=k+36|0;l=f[$a>>2]|0;if(l|0?(Za=l+12|0,l=f[Za>>2]|0,f[Za>>2]=l+-1,(l|0)==1):0)CR(k);f[$a>>2]=0;$a=k+16|0;l=k+4|0;f[$a>>2]=0;f[$a+4>>2]=0;f[$a+8>>2]=0;f[$a+12>>2]=0;if((f[l>>2]|0)>0){$a=f[k+40>>2]|0;Za=0;do{f[$a+(Za<<2)>>2]=0;Za=Za+1|0}while((Za|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)==(k+48|0)){u=e;return}ZF(l);u=e;return}function lqa(a,c,d,e,g,i,j){a=a|0;c=c|0;d=+d;e=e|0;g=g|0;i=i|0;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;k=u;u=u+1072|0;l=k+1056|0;m=k+1e3|0;n=k+944|0;o=k+936|0;p=k;q=k+160|0;r=k+96|0;s=k+928|0;t=k+152|0;v=k+72|0;w=k+56|0;x=k+88|0;_$(l,76584);do if((NS(a)|0)==65536){y=f[a+4>>2]|0;f[m>>2]=f[y>>2];z=m+4|0;A=y+4|0;f[z>>2]=f[A>>2];B=m+8|0;f[B>>2]=f[y+8>>2];f[m+12>>2]=f[y+12>>2];f[m+16>>2]=f[y+16>>2];f[m+20>>2]=f[y+20>>2];f[m+24>>2]=f[y+24>>2];f[m+28>>2]=f[y+28>>2];f[m+32>>2]=f[y+32>>2];C=f[y+36>>2]|0;f[m+36>>2]=C;f[m+40>>2]=B;B=m+48|0;D=m+44|0;f[D>>2]=B;f[B>>2]=0;f[m+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[y+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];E=m;break}else{f[z>>2]=0;BR(m,y);E=m;break}}else{OR(m,a,-1);E=m}while(0);if(f[E>>2]&4095|0){f[n>>2]=0;f[n+4>>2]=0;F=c$(n,55)|0;G=332814;H=F+55|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));j$(-215,n,332974,332763,1520);d$(n)}if(!((i|0)>1&((i|0)%2|0|0)==1)){f[n>>2]=0;f[n+4>>2]=0;F=c$(n,35)|0;G=332992;H=F+35|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));j$(-215,n,332974,332763,1521);d$(n)}a=m+40|0;y=f[a>>2]|0;z=f[y+4>>2]|0;A=f[y>>2]|0;f[o>>2]=z;f[o+4>>2]=A;KS(c,o,f[E>>2]&4095,-1,0,0);do if((NS(c)|0)==65536){o=f[c+4>>2]|0;f[n>>2]=f[o>>2];y=n+4|0;B=o+4|0;f[y>>2]=f[B>>2];D=n+8|0;f[D>>2]=f[o+8>>2];f[n+12>>2]=f[o+12>>2];f[n+16>>2]=f[o+16>>2];f[n+20>>2]=f[o+20>>2];f[n+24>>2]=f[o+24>>2];f[n+28>>2]=f[o+28>>2];f[n+32>>2]=f[o+32>>2];C=f[o+36>>2]|0;f[n+36>>2]=C;f[n+40>>2]=D;D=n+48|0;I=n+44|0;f[I>>2]=D;f[D>>2]=0;f[n+52>>2]=0;if(C|0){D=C+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[B>>2]|0)<3){B=f[o+44>>2]|0;D=f[I>>2]|0;f[D>>2]=f[B>>2];f[D+4>>2]=f[B+4>>2];break}else{f[y>>2]=0;BR(n,o);break}}else OR(n,c,-1);while(0);if(!(d<0.0)){f[p>>2]=1124007936;c=p+4|0;o=p+8|0;y=p+40|0;F=c;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[y>>2]=o;B=p+48|0;D=p+44|0;f[D>>2]=B;f[B>>2]=0;f[p+52>>2]=0;I=m+16|0;C=n+16|0;if((f[I>>2]|0)!=(f[C>>2]|0)){J=n+36|0;K=f[J>>2]|0;if(K){L=K+12|0;f[L>>2]=(f[L>>2]|0)+1;L=p+36|0;K=f[L>>2]|0;if((K|0)!=0?(M=K+12|0,K=f[M>>2]|0,f[M>>2]=K+-1,(K|0)==1):0){CR(p);N=L}else N=L}else N=p+36|0;f[N>>2]=0;L=p+16|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[c>>2]|0)>0){K=f[y>>2]|0;M=0;do{f[K+(M<<2)>>2]=0;M=M+1|0;O=f[c>>2]|0}while((M|0)<(O|0));f[p>>2]=f[n>>2];if((O|0)<3)P=32;else P=34}else{f[p>>2]=f[n>>2];P=32}if((P|0)==32){O=f[n+4>>2]|0;if((O|0)<3){f[c>>2]=O;f[o>>2]=f[n+8>>2];f[p+12>>2]=f[n+12>>2];o=f[n+44>>2]|0;O=f[D>>2]|0;f[O>>2]=f[o>>2];f[O+4>>2]=f[o+4>>2]}else P=34}if((P|0)==34)BR(p,n);f[L>>2]=f[C>>2];f[p+20>>2]=f[n+20>>2];f[p+24>>2]=f[n+24>>2];f[p+28>>2]=f[n+28>>2];f[p+32>>2]=f[n+32>>2];f[N>>2]=f[J>>2]}switch(e|0){case 0:{f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=m;e=r+8|0;f[e>>2]=0;f[e+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=p;e=f[E>>2]&4095;f[s>>2]=i;f[s+4>>2]=i;f[t>>2]=-1;f[t+4>>2]=-1;Dpa(q,r,e,s,t,1,1);break}case 1:{f[q>>2]=1124007936;t=q+4|0;s=q+8|0;e=q+40|0;F=t;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[e>>2]=s;J=q+48|0;N=q+44|0;f[N>>2]=J;f[J>>2]=0;f[q+52>>2]=0;f[r>>2]=1124007936;L=r+4|0;o=r+8|0;O=r+40|0;F=L;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[O>>2]=o;M=r+48|0;K=r+44|0;f[K>>2]=M;f[M>>2]=0;f[r+52>>2]=0;Q=v+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=q;WJ(m,v,5,1.0,0.0);Q=q+36|0;R=f[Q>>2]|0;if(R|0){S=R+12|0;f[S>>2]=(f[S>>2]|0)+1}S=r+36|0;R=f[S>>2]|0;if(R|0?(T=R+12|0,R=f[T>>2]|0,f[T>>2]=R+-1,(R|0)==1):0)CR(r);f[S>>2]=0;R=r+16|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[L>>2]|0)>0){T=f[O>>2]|0;U=0;do{f[T+(U<<2)>>2]=0;U=U+1|0;V=f[L>>2]|0}while((U|0)<(V|0));f[r>>2]=f[q>>2];if((V|0)<3)P=48;else P=50}else{f[r>>2]=f[q>>2];P=48}if((P|0)==48){V=f[t>>2]|0;if((V|0)<3){f[L>>2]=V;f[o>>2]=f[s>>2];f[r+12>>2]=f[q+12>>2];s=f[N>>2]|0;o=f[K>>2]|0;f[o>>2]=f[s>>2];f[o+4>>2]=f[s+4>>2]}else P=50}if((P|0)==50)BR(r,q);s=q+16|0;f[R>>2]=f[s>>2];f[r+20>>2]=f[q+20>>2];f[r+24>>2]=f[q+24>>2];f[r+28>>2]=f[q+28>>2];f[r+32>>2]=f[q+32>>2];f[S>>2]=f[Q>>2];f[v+8>>2]=0;f[v+12>>2]=0;f[v>>2]=16842752;f[v+4>>2]=q;o=w+8|0;f[o>>2]=0;f[o+4>>2]=0;f[w>>2]=33619968;f[w+4>>2]=r;f[x>>2]=i;f[x+4>>2]=i;Hpa(v,w,x,0.0,0.0,1);x=v+8|0;f[x>>2]=0;f[x+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=p;WJ(r,v,f[E>>2]&4095,1.0,0.0);v=f[S>>2]|0;if(v|0?(x=v+12|0,v=f[x>>2]|0,f[x>>2]=v+-1,(v|0)==1):0)CR(r);f[S>>2]=0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[L>>2]|0)>0){R=f[O>>2]|0;O=0;do{f[R+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[L>>2]|0))}L=f[K>>2]|0;if((L|0)!=(M|0))ZF(L);L=f[Q>>2]|0;if(L|0?(M=L+12|0,L=f[M>>2]|0,f[M>>2]=L+-1,(L|0)==1):0)CR(q);f[Q>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[t>>2]|0)>0){s=f[e>>2]|0;e=0;do{f[s+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[t>>2]|0))}t=f[N>>2]|0;if((t|0)!=(J|0))ZF(t);break}default:{f[q>>2]=0;f[q+4>>2]=0;F=c$(q,45)|0;G=333028;H=F+45|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));j$(-206,q,332974,332763,1550);d$(q)}}t=rNa(d)|0;J=(t>>>0<256?t:(t|0)>0?255:0)&255;t=~~j;d=+(t|0);do if(!g){N=0-(t+(d<j&1))|0;e=0;do{b[q+e>>0]=(e+-255|0)>(N|0)?J:0;e=e+1|0}while((e|0)!=768);W=q}else{if((g|0)!=1){f[r>>2]=0;f[r+4>>2]=0;F=c$(r,34)|0;G=333074;H=F+34|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));j$(-206,r,332974,332763,1564);d$(r);W=q;break}e=(d>j&1)-t|0;N=0;do{b[q+N>>0]=(N+-255|0)<=(e|0)?J:0;N=N+1|0}while((N|0)!=768);W=q}while(0);if((f[E>>2]&16384|0)!=0?(f[p>>2]&16384|0)!=0:0){E=(f[n>>2]&16384|0)!=0;W=Y(E?A:1,z)|0;if(E){X=W;Z=1;P=80}else{_=W;P=79}}else{_=z;P=79}if((P|0)==79?(A|0)>0:0){X=_;Z=A;P=80}if((P|0)==80?(P=m+44|0,A=p+16|0,_=n+44|0,(X|0)>0):0){z=0;do{W=(f[I>>2]|0)+(Y(f[f[P>>2]>>2]|0,z)|0)|0;E=(f[A>>2]|0)+(Y(f[f[D>>2]>>2]|0,z)|0)|0;J=(f[C>>2]|0)+(Y(f[f[_>>2]>>2]|0,z)|0)|0;t=0;do{b[J+t>>0]=b[q+((h[W+t>>0]|0)+255-(h[E+t>>0]|0))>>0]|0;t=t+1|0}while((t|0)!=(X|0));z=z+1|0}while((z|0)!=(Z|0))}Z=p+36|0;z=f[Z>>2]|0;if(z|0?(X=z+12|0,z=f[X>>2]|0,f[X>>2]=z+-1,(z|0)==1):0)CR(p);f[Z>>2]=0;Z=p+16|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[c>>2]|0)>0){Z=f[y>>2]|0;y=0;do{f[Z+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[c>>2]|0))}c=f[D>>2]|0;if((c|0)!=(B|0))ZF(c)}else{f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;f[p+28>>2]=0;gL(n,p)|0}p=n+36|0;c=f[p>>2]|0;if(c|0?(B=c+12|0,c=f[B>>2]|0,f[B>>2]=c+-1,(c|0)==1):0)CR(n);f[p>>2]=0;p=n+16|0;c=n+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[c>>2]|0)>0){p=f[n+40>>2]|0;B=0;do{f[p+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[c>>2]|0))}c=f[n+44>>2]|0;if((c|0)!=(n+48|0))ZF(c);c=m+36|0;n=f[c>>2]|0;if(n|0?(B=n+12|0,n=f[B>>2]|0,f[B>>2]=n+-1,(n|0)==1):0)CR(m);f[c>>2]=0;c=m+16|0;n=m+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[n>>2]|0)>0){c=f[a>>2]|0;a=0;do{f[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[n>>2]|0))}n=f[m+44>>2]|0;if((n|0)!=(m+48|0))ZF(n);if(!(f[l+4>>2]|0)){u=k;return}u=k;return}function mqa(a,c,d,e,g){a=a|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0;h=u;u=u+208|0;i=h+144|0;j=h+88|0;k=h+32|0;l=h+16|0;m=h;JR(i,a,0,1,0,0);JR(j,c,0,1,0,0);f[k>>2]=f[j>>2];c=k+4|0;a=j+4|0;n=f[a>>2]|0;f[c>>2]=n;o=k+8|0;f[o>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];p=k+16|0;q=j+16|0;f[p>>2]=f[q>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];r=k+36|0;s=j+36|0;t=f[s>>2]|0;f[r>>2]=t;v=k+40|0;f[v>>2]=o;o=k+48|0;w=k+44|0;f[w>>2]=o;f[o>>2]=0;f[k+52>>2]=0;if(!t)x=n;else{n=t+12|0;f[n>>2]=(f[n>>2]|0)+1;x=f[a>>2]|0}if((x|0)<3){x=f[j+44>>2]|0;n=f[w>>2]|0;f[n>>2]=f[x>>2];f[n+4>>2]=f[x+4>>2]}else{f[c>>2]=0;BR(k,j)}x=i+40|0;n=f[x>>2]|0;t=f[n+-4>>2]|0;y=j+40|0;z=f[y>>2]|0;a:do if((t|0)==(f[z+-4>>2]|0)){if((t|0)==2){if((f[n>>2]|0)!=(f[z>>2]|0)){A=15;break}if((f[n+4>>2]|0)!=(f[z+4>>2]|0)){A=15;break}}else if((t|0)>0){B=0;do{if((f[n+(B<<2)>>2]|0)!=(f[z+(B<<2)>>2]|0)){A=15;break a}B=B+1|0}while((B|0)<(t|0))}B=f[i>>2]|0;C=f[j>>2]|0;if(!(((C^B)&4088|0)==0?(D=C&7,(B&7|0)==(D|0)|(D|0)==0):0))A=15}else A=15;while(0);if((A|0)==15){f[l>>2]=0;f[l+4>>2]=0;A=c$(l,108)|0;t=333192;z=A+108|0;do{b[A>>0]=b[t>>0]|0;A=A+1|0;t=t+1|0}while((A|0)<(z|0));j$(-215,l,333301,332763,1589);d$(l)}f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=i;t=m+8|0;f[t>>2]=0;f[t+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=j;E=+gqa(l,m,d,e,g);if((f[p>>2]|0)!=(f[q>>2]|0)){g=l+8|0;f[g>>2]=0;f[g+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=k;WJ(j,l,f[k>>2]&7,1.0,0.0)}l=f[r>>2]|0;if(l|0?(g=l+12|0,l=f[g>>2]|0,f[g>>2]=l+-1,(l|0)==1):0)CR(k);f[r>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[c>>2]|0)>0){p=f[v>>2]|0;v=0;do{f[p+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[c>>2]|0))}c=f[w>>2]|0;if((c|0)!=(o|0))ZF(c);c=f[s>>2]|0;if(c|0?(o=c+12|0,c=f[o>>2]|0,f[o>>2]=c+-1,(c|0)==1):0)CR(j);f[s>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[a>>2]|0)>0){q=f[y>>2]|0;y=0;do{f[q+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[a>>2]|0))}a=f[j+44>>2]|0;if((a|0)!=(j+48|0))ZF(a);a=i+36|0;j=f[a>>2]|0;if(j|0?(y=j+12|0,j=f[y>>2]|0,f[y>>2]=j+-1,(j|0)==1):0)CR(i);f[a>>2]=0;a=i+16|0;j=i+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[j>>2]|0)>0){a=f[x>>2]|0;x=0;do{f[a+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)==(i+48|0)){u=h;return +E}ZF(j);u=h;return +E}function nqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+128|0;g=e+72|0;h=e+16|0;i=e;do if((NS(b)|0)==65536){j=f[b+4>>2]|0;f[g>>2]=f[j>>2];k=g+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=g+8|0;f[m>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];f[g+32>>2]=f[j+32>>2];n=f[j+36>>2]|0;f[g+36>>2]=n;f[g+40>>2]=m;m=g+48|0;o=g+44|0;f[o>>2]=m;f[m>>2]=0;f[g+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;BR(g,j);break}}else OR(g,b,-1);while(0);do if(!d?(b=f[g>>2]|0,(b&4095|0)==6):0){f[a>>2]=b;b=a+4|0;j=g+4|0;k=f[j>>2]|0;f[b>>2]=k;l=a+8|0;f[l>>2]=f[g+8>>2];f[a+12>>2]=f[g+12>>2];f[a+16>>2]=f[g+16>>2];f[a+20>>2]=f[g+20>>2];f[a+24>>2]=f[g+24>>2];f[a+28>>2]=f[g+28>>2];f[a+32>>2]=f[g+32>>2];m=g+36|0;o=f[m>>2]|0;f[a+36>>2]=o;f[a+40>>2]=l;l=a+48|0;n=a+44|0;f[n>>2]=l;f[l>>2]=0;f[a+52>>2]=0;if(!o)q=k;else{k=o+12|0;f[k>>2]=(f[k>>2]|0)+1;q=f[j>>2]|0}if((q|0)<3){j=f[g+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];r=m;break}else{f[b>>2]=0;BR(a,g);r=m;break}}else s=15;while(0);if((s|0)==15){f[h>>2]=1124007936;s=h+4|0;q=h+8|0;m=h+40|0;b=s;j=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(j|0));f[m>>2]=q;b=h+48|0;j=h+44|0;f[j>>2]=b;f[b>>2]=0;f[h+52>>2]=0;k=i+8|0;f[k>>2]=0;f[k+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=h;WJ(g,i,6,1.0,0.0);if(d){d=h+16|0;i=f[d>>2]|0;p[i+16>>3]=+((f[c>>2]|0)+-1|0)*.5;p[i+40>>3]=+((f[c+4>>2]|0)+-1|0)*.5;t=i;v=d}else{d=h+16|0;t=f[d>>2]|0;v=d}f[a>>2]=f[h>>2];d=a+4|0;i=f[s>>2]|0;f[d>>2]=i;c=a+8|0;f[c>>2]=f[q>>2];f[a+12>>2]=f[h+12>>2];f[a+16>>2]=t;f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];t=h+36|0;q=f[t>>2]|0;f[a+36>>2]=q;f[a+40>>2]=c;c=a+48|0;k=a+44|0;f[k>>2]=c;f[c>>2]=0;f[a+52>>2]=0;if(!q)w=i;else{i=q+12|0;f[i>>2]=(f[i>>2]|0)+1;w=f[s>>2]|0}if((w|0)<3){w=f[j>>2]|0;i=f[k>>2]|0;f[i>>2]=f[w>>2];f[i+4>>2]=f[w+4>>2]}else{f[d>>2]=0;BR(a,h)}a=f[t>>2]|0;if(a|0?(d=a+12|0,a=f[d>>2]|0,f[d>>2]=a+-1,(a|0)==1):0)CR(h);f[t>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[s>>2]|0)>0){v=f[m>>2]|0;m=0;do{f[v+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[s>>2]|0))}s=f[j>>2]|0;if((s|0)!=(b|0))ZF(s);r=g+36|0}s=f[r>>2]|0;if(s|0?(b=s+12|0,s=f[b>>2]|0,f[b>>2]=s+-1,(s|0)==1):0)CR(g);f[r>>2]=0;r=g+16|0;s=g+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[s>>2]|0)>0){r=f[g+40>>2]|0;b=0;do{f[r+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[s>>2]|0))}s=f[g+44>>2]|0;if((s|0)==(g+48|0)){u=e;return}ZF(s);u=e;return}function oqa(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0;l=u;u=u+1552|0;m=l+672|0;o=l+1536|0;q=l+1480|0;r=l+1424|0;s=l+1368|0;t=l+1304|0;v=l+1360|0;w=l+1248|0;x=l+1184|0;y=l+1240|0;z=l+1128|0;A=l+448|0;B=l+1072|0;C=l+1016|0;D=l+1008|0;E=l+952|0;F=l+224|0;G=l;H=l+896|0;do if((NS(a)|0)==65536){I=f[a+4>>2]|0;f[q>>2]=f[I>>2];J=q+4|0;K=I+4|0;f[J>>2]=f[K>>2];L=q+8|0;f[L>>2]=f[I+8>>2];f[q+12>>2]=f[I+12>>2];f[q+16>>2]=f[I+16>>2];f[q+20>>2]=f[I+20>>2];f[q+24>>2]=f[I+24>>2];f[q+28>>2]=f[I+28>>2];f[q+32>>2]=f[I+32>>2];M=f[I+36>>2]|0;f[q+36>>2]=M;f[q+40>>2]=L;L=q+48|0;N=q+44|0;f[N>>2]=L;f[L>>2]=0;f[q+52>>2]=0;if(M|0){L=M+12|0;f[L>>2]=(f[L>>2]|0)+1}if((f[K>>2]|0)<3){K=f[I+44>>2]|0;L=f[N>>2]|0;f[L>>2]=f[K>>2];f[L+4>>2]=f[K+4>>2];break}else{f[J>>2]=0;BR(q,I);break}}else OR(q,a,-1);while(0);do if((NS(c)|0)==65536){a=f[c+4>>2]|0;f[r>>2]=f[a>>2];I=r+4|0;J=a+4|0;f[I>>2]=f[J>>2];K=r+8|0;f[K>>2]=f[a+8>>2];f[r+12>>2]=f[a+12>>2];f[r+16>>2]=f[a+16>>2];f[r+20>>2]=f[a+20>>2];f[r+24>>2]=f[a+24>>2];f[r+28>>2]=f[a+28>>2];f[r+32>>2]=f[a+32>>2];L=f[a+36>>2]|0;f[r+36>>2]=L;f[r+40>>2]=K;K=r+48|0;N=r+44|0;f[N>>2]=K;f[K>>2]=0;f[r+52>>2]=0;if(L|0){K=L+12|0;f[K>>2]=(f[K>>2]|0)+1}if((f[J>>2]|0)<3){J=f[a+44>>2]|0;K=f[N>>2]|0;f[K>>2]=f[J>>2];f[K+4>>2]=f[J+4>>2];break}else{f[I>>2]=0;BR(r,a);break}}else OR(r,c,-1);while(0);do if((NS(e)|0)==65536){c=f[e+4>>2]|0;f[s>>2]=f[c>>2];a=s+4|0;I=c+4|0;f[a>>2]=f[I>>2];J=s+8|0;f[J>>2]=f[c+8>>2];f[s+12>>2]=f[c+12>>2];f[s+16>>2]=f[c+16>>2];f[s+20>>2]=f[c+20>>2];f[s+24>>2]=f[c+24>>2];f[s+28>>2]=f[c+28>>2];f[s+32>>2]=f[c+32>>2];K=f[c+36>>2]|0;f[s+36>>2]=K;f[s+40>>2]=J;J=s+48|0;N=s+44|0;f[N>>2]=J;f[J>>2]=0;f[s+52>>2]=0;if(K|0){J=K+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[I>>2]|0)<3){I=f[c+44>>2]|0;J=f[N>>2]|0;f[J>>2]=f[I>>2];f[J+4>>2]=f[I+4>>2];break}else{f[a>>2]=0;BR(s,c);break}}else OR(s,e,-1);while(0);do if((NS(g)|0)==65536){e=f[g+4>>2]|0;f[t>>2]=f[e>>2];c=t+4|0;a=e+4|0;f[c>>2]=f[a>>2];I=t+8|0;f[I>>2]=f[e+8>>2];f[t+12>>2]=f[e+12>>2];f[t+16>>2]=f[e+16>>2];f[t+20>>2]=f[e+20>>2];f[t+24>>2]=f[e+24>>2];f[t+28>>2]=f[e+28>>2];f[t+32>>2]=f[e+32>>2];J=f[e+36>>2]|0;f[t+36>>2]=J;f[t+40>>2]=I;I=t+48|0;N=t+44|0;f[N>>2]=I;f[I>>2]=0;f[t+52>>2]=0;if(J|0){I=J+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[a>>2]|0)<3){a=f[e+44>>2]|0;I=f[N>>2]|0;f[I>>2]=f[a>>2];f[I+4>>2]=f[a+4>>2];break}else{f[c>>2]=0;BR(t,e);break}}else OR(t,g,-1);while(0);g=(i|0)<1?11:i;i=(g|0)==11;e=(g|0)==5;switch(g|0){case 5:case 11:case 13:break;default:{f[m>>2]=0;f[m+4>>2]=0;K1a(c$(m,161)|0,333313,161)|0;j$(-215,m,333475,333499,73);d$(m)}}f[v>>2]=f[h>>2];c=h+4|0;f[v+4>>2]=f[c>>2];KS(j,v,g,-1,0,0);do if((NS(j)|0)==65536){v=f[j+4>>2]|0;f[w>>2]=f[v>>2];a=w+4|0;I=v+4|0;f[a>>2]=f[I>>2];N=w+8|0;f[N>>2]=f[v+8>>2];f[w+12>>2]=f[v+12>>2];f[w+16>>2]=f[v+16>>2];f[w+20>>2]=f[v+20>>2];f[w+24>>2]=f[v+24>>2];f[w+28>>2]=f[v+28>>2];f[w+32>>2]=f[v+32>>2];J=f[v+36>>2]|0;f[w+36>>2]=J;f[w+40>>2]=N;N=w+48|0;K=w+44|0;f[K>>2]=N;f[N>>2]=0;f[w+52>>2]=0;if(J|0){N=J+12|0;f[N>>2]=(f[N>>2]|0)+1}if((f[I>>2]|0)<3){I=f[v+44>>2]|0;N=f[K>>2]|0;f[N>>2]=f[I>>2];f[N+4>>2]=f[I+4>>2];break}else{f[a>>2]=0;BR(w,v);break}}else OR(w,j,-1);while(0);f[x>>2]=1124007936;j=x+4|0;v=x+8|0;a=x+40|0;I=j;N=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(N|0));f[a>>2]=v;K=x+48|0;J=x+44|0;f[J>>2]=K;f[K>>2]=0;f[x+52>>2]=0;if((g|0)!=13){f[y>>2]=f[h>>2];f[y+4>>2]=f[c>>2];KS(k,y,i?2:5,-1,0,0);do if((NS(k)|0)==65536){y=f[k+4>>2]|0;f[m>>2]=f[y>>2];g=m+4|0;L=y+4|0;f[g>>2]=f[L>>2];M=m+8|0;f[M>>2]=f[y+8>>2];f[m+12>>2]=f[y+12>>2];f[m+16>>2]=f[y+16>>2];f[m+20>>2]=f[y+20>>2];f[m+24>>2]=f[y+24>>2];f[m+28>>2]=f[y+28>>2];f[m+32>>2]=f[y+32>>2];Q=m+36|0;R=f[y+36>>2]|0;f[Q>>2]=R;f[m+40>>2]=M;M=m+48|0;S=m+44|0;f[S>>2]=M;f[M>>2]=0;f[m+52>>2]=0;if(R|0){M=R+12|0;f[M>>2]=(f[M>>2]|0)+1}if((f[L>>2]|0)<3){L=f[y+44>>2]|0;M=f[S>>2]|0;f[M>>2]=f[L>>2];f[M+4>>2]=f[L+4>>2];T=Q;break}else{f[g>>2]=0;BR(m,y);T=Q;break}}else{OR(m,k,-1);T=m+36|0}while(0);Q=f[T>>2]|0;if(Q|0){y=Q+12|0;f[y>>2]=(f[y>>2]|0)+1}y=x+36|0;Q=f[y>>2]|0;if(Q|0?(g=Q+12|0,Q=f[g>>2]|0,f[g>>2]=Q+-1,(Q|0)==1):0)CR(x);f[y>>2]=0;Q=x+16|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[j>>2]|0)>0){g=f[a>>2]|0;L=0;do{f[g+(L<<2)>>2]=0;L=L+1|0;U=f[j>>2]|0}while((L|0)<(U|0));f[x>>2]=f[m>>2];if((U|0)<3)V=56;else V=58}else{f[x>>2]=f[m>>2];V=56}if((V|0)==56){U=f[m+4>>2]|0;if((U|0)<3){f[j>>2]=U;f[v>>2]=f[m+8>>2];f[x+12>>2]=f[m+12>>2];U=f[m+44>>2]|0;L=f[J>>2]|0;f[L>>2]=f[U>>2];f[L+4>>2]=f[U+4>>2]}else V=58}if((V|0)==58)BR(x,m);U=m+16|0;f[Q>>2]=f[U>>2];f[x+20>>2]=f[m+20>>2];f[x+24>>2]=f[m+24>>2];f[x+28>>2]=f[m+28>>2];f[x+32>>2]=f[m+32>>2];Q=f[T>>2]|0;f[y>>2]=Q;if(Q|0?(y=Q+12|0,Q=f[y>>2]|0,f[y>>2]=Q+-1,(Q|0)==1):0)CR(m);f[T>>2]=0;T=m+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[T>>2]|0)>0){U=f[m+40>>2]|0;Q=0;do{f[U+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[T>>2]|0))}T=f[m+44>>2]|0;if((T|0)!=(m+48|0))ZF(T)}else oS(k);aR(A,3,3,6);pqa(z,A);fj(A);qqa(B,q);A=C+4|0;k=C+8|0;T=C+40|0;I=A;N=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(N|0));f[T>>2]=k;k=C+48|0;Q=C+44|0;f[Q>>2]=k;f[k>>2]=0;f[C+52>>2]=0;f[C>>2]=1124007942;U=t+16|0;if(f[U>>2]|0){y=f[t+4>>2]|0;if((y|0)<3)W=Y(f[t+12>>2]|0,f[t+8>>2]|0)|0;else{L=f[t+40>>2]|0;g=0;M=1;while(1){S=Y(f[L+(g<<2)>>2]|0,M)|0;g=g+1|0;if((g|0)==(y|0)){W=S;break}else M=S}}if(!((y|0)==0|(W|0)==0)){qqa(m,t);rqa(C,m)|0;W=m+36|0;y=f[W>>2]|0;if(y|0?(M=y+12|0,y=f[M>>2]|0,f[M>>2]=y+-1,(y|0)==1):0)CR(m);f[W>>2]=0;W=m+16|0;y=m+4|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[y>>2]|0)>0){W=f[m+40>>2]|0;M=0;do{f[W+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[y>>2]|0))}y=f[m+44>>2]|0;if((y|0)!=(m+48|0))ZF(y)}else V=84}else V=84;if((V|0)==84){f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=-2130640890;f[o+4>>2]=B;f[D>>2]=f[h>>2];f[D+4>>2]=f[c>>2];nqa(m,o,D,1);sqa(C,m)|0;D=m+36|0;y=f[D>>2]|0;if(y|0?(M=y+12|0,y=f[M>>2]|0,f[M>>2]=y+-1,(y|0)==1):0)CR(m);f[D>>2]=0;D=m+16|0;y=m+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[y>>2]|0)>0){D=f[m+40>>2]|0;M=0;do{f[D+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[y>>2]|0))}y=f[m+44>>2]|0;if((y|0)!=(m+48|0))ZF(y)}y=s+16|0;if(f[y>>2]|0){M=f[s+4>>2]|0;if((M|0)<3)X=Y(f[s+12>>2]|0,f[s+8>>2]|0)|0;else{D=f[s+40>>2]|0;W=0;g=1;while(1){L=Y(f[D+(W<<2)>>2]|0,g)|0;W=W+1|0;if((W|0)==(M|0)){X=L;break}else g=L}}if(!((M|0)==0|(X|0)==0)){qqa(m,s);rqa(z,m)|0;X=m+36|0;M=f[X>>2]|0;if(M|0?(g=M+12|0,M=f[g>>2]|0,f[g>>2]=M+-1,(M|0)==1):0)CR(m);f[X>>2]=0;X=m+16|0;M=m+4|0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[M>>2]|0)>0){X=f[m+40>>2]|0;g=0;do{f[X+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[M>>2]|0))}M=f[m+44>>2]|0;if((M|0)!=(m+48|0))ZF(M)}}M=r+16|0;g=(f[M>>2]|0)==0;X=r+4|0;W=f[X>>2]|0;if(!g){if((W|0)<3)Z=Y(f[r+12>>2]|0,f[r+8>>2]|0)|0;else{D=f[r+40>>2]|0;L=0;S=1;while(1){R=Y(f[D+(L<<2)>>2]|0,S)|0;L=L+1|0;if((L|0)==(W|0)){Z=R;break}else S=R}}if(!((W|0)==0|(Z|0)==0)){qqa(m,r);Z=m+36|0;S=f[Z>>2]|0;if(S|0){L=S+12|0;f[L>>2]=(f[L>>2]|0)+1}L=r+36|0;S=f[L>>2]|0;if(S|0?(D=S+12|0,S=f[D>>2]|0,f[D>>2]=S+-1,(S|0)==1):0)CR(r);f[L>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[X>>2]|0)>0){S=f[r+40>>2]|0;D=0;do{f[S+(D<<2)>>2]=0;D=D+1|0;_=f[X>>2]|0}while((D|0)<(_|0));f[r>>2]=f[m>>2];if((_|0)<3)V=124;else V=126}else{f[r>>2]=f[m>>2];V=124}if((V|0)==124){_=f[m+4>>2]|0;if((_|0)<3){f[X>>2]=_;f[r+8>>2]=f[m+8>>2];f[r+12>>2]=f[m+12>>2];_=f[m+44>>2]|0;X=f[r+44>>2]|0;f[X>>2]=f[_>>2];f[X+4>>2]=f[_+4>>2]}else V=126}if((V|0)==126)BR(r,m);_=m+16|0;f[M>>2]=f[_>>2];f[r+20>>2]=f[m+20>>2];f[r+24>>2]=f[m+24>>2];f[r+28>>2]=f[m+28>>2];f[r+32>>2]=f[m+32>>2];X=f[Z>>2]|0;f[L>>2]=X;if(X|0?(L=X+12|0,X=f[L>>2]|0,f[L>>2]=X+-1,(X|0)==1):0)CR(m);f[Z>>2]=0;Z=m+4|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[Z>>2]|0)>0){_=f[m+40>>2]|0;X=0;do{f[_+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[Z>>2]|0))}Z=f[m+44>>2]|0;if((Z|0)!=(m+48|0))ZF(Z)}else V=136}else V=136;if((V|0)==136){if(!((((W|0)<3?(f[r+8>>2]|0)==14:0)?(f[r+12>>2]|0)==1:0)?!((f[r>>2]&4095|0)!=6|g):0))V=140;if((V|0)==140){f[m>>2]=14;f[m+4>>2]=1;AR(r,2,m,6)};f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;gL(r,m)|0}V=B+40|0;g=f[V>>2]|0;if(!(((f[g>>2]|0)==3?(f[g+4>>2]|0)==3:0)?(g=f[z+40>>2]|0,(f[g>>2]|0)==3?(f[g+4>>2]|0)==3:0):0)){f[m>>2]=0;f[m+4>>2]=0;I=c$(m,45)|0;$=333553;N=I+45|0;do{b[I>>0]=b[$>>0]|0;I=I+1|0;$=$+1|0}while((I|0)<(N|0));j$(-215,m,333475,333499,103);d$(m)}g=f[T>>2]|0;if(!((f[g>>2]|0)==3?((f[g+4>>2]|0)+-3|0)>>>0<2:0)){f[m>>2]=0;f[m+4>>2]=0;I=c$(m,49)|0;$=333599;N=I+49|0;do{b[I>>0]=b[$>>0]|0;I=I+1|0;$=$+1|0}while((I|0)<(N|0));j$(-215,m,333475,333499,104);d$(m)}f[m>>2]=-2147483648;f[m+4>>2]=2147483647;f[o>>2]=0;f[o+4>>2]=3;DR(H,C,m,o);KQ(G,H,z);BQ(F,G,0);pqa(E,F);fj(F);fj(G);G=H+36|0;F=f[G>>2]|0;if(F|0?(o=F+12|0,F=f[o>>2]|0,f[o>>2]=F+-1,(F|0)==1):0)CR(H);f[G>>2]=0;G=H+16|0;F=H+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[F>>2]|0)>0){G=f[H+40>>2]|0;o=0;do{f[G+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[F>>2]|0))}F=f[H+44>>2]|0;if((F|0)!=(H+48|0))ZF(F);F=E+16|0;H=f[F>>2]|0;o=B+16|0;G=f[o>>2]|0;g=B+44|0;aa=+p[G+16>>3];W=G+(f[f[g>>2]>>2]|0)|0;ba=+p[W+16>>3];ca=+p[G>>3];da=+p[W+8>>3];W=r+40|0;G=f[W>>2]|0;Z=f[G+4>>2]|0;X=f[G>>2]|0;G=(Z|0)==1;if(!(G&(X|0)==4)?(_=(X|0)==1,!((Z|0)==14&_|(G&(X|0)==14|((Z|0)==12&_|(G&(X|0)==12|((Z|0)==8&_|(G&(X|0)==8|((Z|0)==5&_|((Z|0)==4&_|G&(X|0)==5))))))))):0){f[m>>2]=0;f[m+4>>2]=0;K1a(c$(m,350)|0,333649,350)|0;j$(-215,m,333475,333499,115);d$(m)}X=r+8|0;G=f[X>>2]|0;if((G|0)!=1)if(!(f[r>>2]&16384)){UQ(m,r);_=f[m>>2]|0;Ah[f[(f[_>>2]|0)+12>>2]&255](_,m,r,-1);fj(m);ea=f[X>>2]|0}else ea=G;else ea=1;G=f[M>>2]|0;X=r+44|0;fa=+p[G>>3];ga=+p[G+8>>3];ha=+p[G+16>>3];ia=+p[G+24>>3];_=(f[r+12>>2]|0)+-1+ea|0;do if((_|0)>4){ja=+p[G+32>>3];if((_|0)>7){ka=+p[G+40>>3];la=+p[G+48>>3];ma=+p[G+56>>3];if((_|0)>11){na=+p[G+64>>3];oa=+p[G+72>>3];pa=+p[G+80>>3];qa=+p[G+88>>3];if((_|0)<=13){ra=ja;sa=ka;ta=la;ua=ma;va=na;wa=oa;xa=pa;ya=qa;za=0.0;Aa=0.0;break}ra=ja;sa=ka;ta=la;ua=ma;va=na;wa=oa;xa=pa;ya=qa;za=+p[G+96>>3];Aa=+p[G+104>>3]}else{ra=ja;sa=ka;ta=la;ua=ma;va=0.0;wa=0.0;xa=0.0;ya=0.0;za=0.0;Aa=0.0}}else{ra=ja;sa=0.0;ta=0.0;ua=0.0;va=0.0;wa=0.0;xa=0.0;ya=0.0;za=0.0;Aa=0.0}}else{ra=0.0;sa=0.0;ta=0.0;ua=0.0;va=0.0;wa=0.0;xa=0.0;ya=0.0;za=0.0;Aa=0.0}while(0);ja=+O(+za);ma=+P(+za);za=+O(+Aa);la=+P(+Aa);Aa=la*0.0;ka=za+0.0-Aa;qa=za*0.0;pa=qa+0.0;oa=ja*0.0;na=ma*la+(oa+pa);Ba=ma*0.0;Ca=Ba+pa-ja*la;pa=ja+0.0-Ba;Da=oa+(ma+0.0);Ea=qa+(la+0.0);la=Aa+0.0;Aa=oa+la-ma*za;ma=ja*za+(Ba+la);la=-Ca;Ba=-Da;za=Ea*la+(ka*ma+0.0);ja=pa*0.0;oa=Aa*la+(ja+(na*ma+0.0));qa=Da*0.0;Fa=ma*la+(qa+(Ca*ma+0.0));la=ka*0.0+0.0;ka=Ea*Ba+(la+ma*0.0);Ga=na*0.0+0.0;na=Aa*Ba+(Ga+pa*ma);pa=Ca*0.0+0.0;Ca=ma*Ba+(pa+Da*ma);Da=Ea+la;la=Aa+(ja+Ga);Ga=ma+(qa+pa);if((f[c>>2]|0)>0){G=w+16|0;_=w+44|0;ea=x+16|0;Z=H+8|0;L=H+16|0;D=H+32|0;S=H+40|0;R=H+56|0;Ha=H+64|0;Ia=m+4|0;Ja=m+4|0;Ka=m+4|0;La=H+24|0;Ma=H+48|0;Na=x+12|0;Oa=0;do{Pa=(f[G>>2]|0)+(Y(f[f[_>>2]>>2]|0,Oa)|0)|0;Qa=f[ea>>2]|0;do if(!Qa)Ra=0;else{Sa=f[j>>2]|0;if((Sa|0)<3)Ta=Y(f[Na>>2]|0,f[v>>2]|0)|0;else{Ua=f[a>>2]|0;Va=0;Wa=1;while(1){Xa=Y(f[Ua+(Va<<2)>>2]|0,Wa)|0;Va=Va+1|0;if((Va|0)==(Sa|0)){Ta=Xa;break}else Wa=Xa}}if((Sa|0)==0|(Ta|0)==0){Ra=0;break}Ra=Qa+(Y(f[f[J>>2]>>2]|0,Oa)|0)|0}while(0);pa=+(Oa|0);qa=pa*+p[Z>>3]+ +p[L>>3];ma=pa*+p[D>>3]+ +p[S>>3];ja=pa*+p[R>>3]+ +p[Ha>>3];do if(!i)if(e){if((Pa|0)!=0&(Ra|0)!=0)break;f[m>>2]=0;f[Ja>>2]=0;I=c$(m,22)|0;$=334021;N=I+22|0;do{b[I>>0]=b[$>>0]|0;I=I+1|0;$=$+1|0}while((I|0)<(N|0));j$(-215,m,333475,333499,157);d$(m);break}else{if(Pa|0)break;f[m>>2]=0;f[Ka>>2]=0;Sa=c$(m,8)|0;Qa=Sa;b[Qa>>0]=109;b[Qa+1>>0]=49;b[Qa+2>>0]=32;b[Qa+3>>0]=33;Qa=Sa+4|0;b[Qa>>0]=61;b[Qa+1>>0]=32;b[Qa+2>>0]=48;b[Qa+3>>0]=76;j$(-215,m,333475,333499,159);d$(m);break}else{if((Pa|0)!=0&(Ra|0)!=0)break;f[m>>2]=0;f[Ia>>2]=0;I=c$(m,20)|0;$=334e3;N=I+20|0;do{b[I>>0]=b[$>>0]|0;I=I+1|0;$=$+1|0}while((I|0)<(N|0));j$(-215,m,333475,333499,155);d$(m)}while(0);Qa=f[h>>2]|0;if((Qa|0)>0){pa=+p[H>>3];Aa=+p[La>>3];Ea=+p[Ma>>3];Ba=ja;Ya=qa;Za=ma;Sa=0;while(1){_a=1.0/Ba;$a=Ya*_a;ab=Za*_a;_a=$a*$a;bb=ab*ab;cb=_a+bb;db=ab*($a*2.0);eb=(cb*(fa+cb*(ga+ra*cb))+1.0)/(cb*(sa+cb*(ta+ua*cb))+1.0);fb=cb*(wa*cb)+(va*cb+(ia*(cb+_a*2.0)+(ha*db+$a*eb)));$a=cb*(ya*cb)+(xa*cb+(ia*db+(ha*(cb+bb*2.0)+ab*eb)));eb=Ga+(la*$a+(Da*fb+0.0));ab=eb!=0.0?1.0/eb:1.0;eb=aa+(Fa+(oa*$a+(za*fb+0.0)))*(ca*ab);bb=ba+(Ca+(na*$a+(ka*fb+0.0)))*(da*ab);if(i){Wa=rNa(eb*32.0)|0;Va=rNa(bb*32.0)|0;d[Pa+(Sa<<2)>>1]=Wa>>>5;d[Pa+((Sa<<1|1)<<1)>>1]=Va>>>5;d[Ra+(Sa<<1)>>1]=Va<<5&992|Wa&31}else{ab=eb;if(e){n[Pa+(Sa<<2)>>2]=ab;gb=Ra+(Sa<<2)|0}else{Wa=Sa<<1;n[Pa+(Wa<<2)>>2]=ab;gb=Pa+((Wa|1)<<2)|0}n[gb>>2]=bb}Sa=Sa+1|0;if((Sa|0)>=(Qa|0))break;else{Ba=Ba+Ea;Ya=Ya+pa;Za=Za+Aa}}}Oa=Oa+1|0}while((Oa|0)<(f[c>>2]|0))}c=E+36|0;Oa=f[c>>2]|0;do if(Oa|0){gb=Oa+12|0;Ra=f[gb>>2]|0;f[gb>>2]=Ra+-1;if((Ra|0)!=1)break;CR(E)}while(0);f[c>>2]=0;c=E+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[c>>2]|0)>0){F=f[E+40>>2]|0;Oa=0;do{f[F+(Oa<<2)>>2]=0;Oa=Oa+1|0}while((Oa|0)<(f[c>>2]|0))}c=f[E+44>>2]|0;if((c|0)!=(E+48|0))ZF(c);c=C+36|0;E=f[c>>2]|0;do if(E|0){Oa=E+12|0;F=f[Oa>>2]|0;f[Oa>>2]=F+-1;if((F|0)!=1)break;CR(C)}while(0);f[c>>2]=0;c=C+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[A>>2]|0)>0){c=f[T>>2]|0;T=0;do{f[c+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[A>>2]|0))}A=f[Q>>2]|0;if((A|0)!=(k|0))ZF(A);A=B+36|0;k=f[A>>2]|0;do if(k|0){Q=k+12|0;T=f[Q>>2]|0;f[Q>>2]=T+-1;if((T|0)!=1)break;CR(B)}while(0);f[A>>2]=0;A=B+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[A>>2]|0)>0){o=f[V>>2]|0;V=0;do{f[o+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[A>>2]|0))}A=f[g>>2]|0;if((A|0)!=(B+48|0))ZF(A);A=z+36|0;B=f[A>>2]|0;do if(B|0){g=B+12|0;V=f[g>>2]|0;f[g>>2]=V+-1;if((V|0)!=1)break;CR(z)}while(0);f[A>>2]=0;A=z+16|0;B=z+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[B>>2]|0)>0){A=f[z+40>>2]|0;V=0;do{f[A+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[B>>2]|0))}B=f[z+44>>2]|0;if((B|0)!=(z+48|0))ZF(B);B=x+36|0;z=f[B>>2]|0;do if(z|0){V=z+12|0;A=f[V>>2]|0;f[V>>2]=A+-1;if((A|0)!=1)break;CR(x)}while(0);f[B>>2]=0;B=x+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[j>>2]|0)>0){B=f[a>>2]|0;a=0;do{f[B+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[j>>2]|0))}j=f[J>>2]|0;if((j|0)!=(K|0))ZF(j);j=w+36|0;K=f[j>>2]|0;do if(K|0){J=K+12|0;a=f[J>>2]|0;f[J>>2]=a+-1;if((a|0)!=1)break;CR(w)}while(0);f[j>>2]=0;j=w+16|0;K=w+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[K>>2]|0)>0){j=f[w+40>>2]|0;a=0;do{f[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[K>>2]|0))}K=f[w+44>>2]|0;if((K|0)!=(w+48|0))ZF(K);K=t+36|0;w=f[K>>2]|0;do if(w|0){a=w+12|0;j=f[a>>2]|0;f[a>>2]=j+-1;if((j|0)!=1)break;CR(t)}while(0);f[K>>2]=0;K=t+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[K>>2]|0)>0){U=f[t+40>>2]|0;w=0;do{f[U+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[K>>2]|0))}K=f[t+44>>2]|0;if((K|0)!=(t+48|0))ZF(K);K=s+36|0;t=f[K>>2]|0;do if(t|0){w=t+12|0;U=f[w>>2]|0;f[w>>2]=U+-1;if((U|0)!=1)break;CR(s)}while(0);f[K>>2]=0;K=s+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[K>>2]|0)>0){y=f[s+40>>2]|0;t=0;do{f[y+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[K>>2]|0))}K=f[s+44>>2]|0;if((K|0)!=(s+48|0))ZF(K);K=r+36|0;s=f[K>>2]|0;do if(s|0){t=s+12|0;y=f[t>>2]|0;f[t>>2]=y+-1;if((y|0)!=1)break;CR(r)}while(0);f[K>>2]=0;K=r+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[K>>2]|0)>0){M=f[W>>2]|0;W=0;do{f[M+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[K>>2]|0))}K=f[X>>2]|0;if((K|0)!=(r+48|0))ZF(K);K=q+36|0;r=f[K>>2]|0;do if(r|0){X=r+12|0;W=f[X>>2]|0;f[X>>2]=W+-1;if((W|0)!=1)break;CR(q)}while(0);f[K>>2]=0;K=q+16|0;r=q+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[r>>2]|0)>0){K=f[q+40>>2]|0;W=0;do{f[K+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[r>>2]|0))}r=f[q+44>>2]|0;if((r|0)==(q+48|0)){u=l;return}ZF(r);u=l;return}function pqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=a+40|0;e=a+4|0;g=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[d>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;f[a>>2]=1124007942;c=f[b>>2]|0;Ah[f[(f[c>>2]|0)+12>>2]&255](c,b,a,6);return}function qqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=a+40|0;e=a+4|0;g=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[d>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;f[a>>2]=1124007942;sqa(a,b)|0;return}function rqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;if((a|0)==(b|0))return a|0;c=b+36|0;d=f[c>>2]|0;if(d|0){e=d+12|0;f[e>>2]=(f[e>>2]|0)+1}e=a+36|0;d=f[e>>2]|0;if(d|0?(g=d+12|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)CR(a);f[e>>2]=0;d=a+16|0;g=a+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[g>>2]|0)>0){h=f[a+40>>2]|0;i=0;do{f[h+(i<<2)>>2]=0;i=i+1|0;j=f[g>>2]|0}while((i|0)<(j|0));f[a>>2]=f[b>>2];if((j|0)<3)k=12;else k=14}else{f[a>>2]=f[b>>2];k=12}if((k|0)==12){j=f[b+4>>2]|0;if((j|0)<3){f[g>>2]=j;f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];j=f[b+44>>2]|0;g=f[a+44>>2]|0;f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2]}else k=14}if((k|0)==14)BR(a,b);f[d>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];f[e>>2]=f[c>>2];return a|0}function sqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+64|0;d=c;e=f[b>>2]|0;if((e&4095|0)!=6){if((e&7|0)!=6){e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[d>>2]=-2113863674;f[d+4>>2]=a;WJ(b,d,6,1.0,0.0);g=a;u=c;return g|0}lS(d,b,1,f[b+4>>2]|0,0);e=sqa(a,d)|0;h=d+36|0;i=f[h>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)CR(d);f[h>>2]=0;h=d+16|0;i=d+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[i>>2]|0)>0){h=f[d+40>>2]|0;j=0;do{f[h+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[i>>2]|0))}i=f[d+44>>2]|0;if((i|0)!=(d+48|0))ZF(i);g=e;u=c;return g|0}if((a|0)==(b|0)){g=a;u=c;return g|0}e=b+36|0;i=f[e>>2]|0;if(i|0){d=i+12|0;f[d>>2]=(f[d>>2]|0)+1}d=a+36|0;i=f[d>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)CR(a);f[d>>2]=0;i=a+16|0;j=a+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[j>>2]|0)>0){h=f[a+40>>2]|0;k=0;do{f[h+(k<<2)>>2]=0;k=k+1|0;l=f[j>>2]|0}while((k|0)<(l|0));f[a>>2]=f[b>>2];if((l|0)<3)m=13;else m=15}else{f[a>>2]=f[b>>2];m=13}if((m|0)==13){l=f[b+4>>2]|0;if((l|0)<3){f[j>>2]=l;f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];l=f[b+44>>2]|0;j=f[a+44>>2]|0;f[j>>2]=f[l>>2];f[j+4>>2]=f[l+4>>2]}else m=15}if((m|0)==15)BR(a,b);f[i>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];f[d>>2]=f[e>>2];g=a;u=c;return g|0}function tqa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0;h=u;u=u+1136|0;i=h+256|0;j=h+1112|0;k=h+1096|0;l=h+1040|0;m=h+984|0;n=h+928|0;o=h+872|0;q=h+1104|0;r=h+816|0;s=h+760|0;t=h+704|0;v=h+648|0;w=h+592|0;x=h+536|0;y=h+32|0;z=h+472|0;A=h+416|0;B=h+360|0;C=h+344|0;D=h+328|0;E=h+528|0;F=h;G=h+312|0;_$(k,76604);do if((NS(a)|0)==65536){H=f[a+4>>2]|0;f[l>>2]=f[H>>2];I=l+4|0;J=H+4|0;f[I>>2]=f[J>>2];K=l+8|0;f[K>>2]=f[H+8>>2];f[l+12>>2]=f[H+12>>2];f[l+16>>2]=f[H+16>>2];f[l+20>>2]=f[H+20>>2];f[l+24>>2]=f[H+24>>2];f[l+28>>2]=f[H+28>>2];f[l+32>>2]=f[H+32>>2];L=f[H+36>>2]|0;f[l+36>>2]=L;f[l+40>>2]=K;K=l+48|0;M=l+44|0;f[M>>2]=K;f[K>>2]=0;f[l+52>>2]=0;if(L|0){K=L+12|0;f[K>>2]=(f[K>>2]|0)+1}if((f[J>>2]|0)<3){J=f[H+44>>2]|0;K=f[M>>2]|0;f[K>>2]=f[J>>2];f[K+4>>2]=f[J+4>>2];break}else{f[I>>2]=0;BR(l,H);break}}else OR(l,a,-1);while(0);do if((NS(d)|0)==65536){a=f[d+4>>2]|0;f[m>>2]=f[a>>2];H=m+4|0;I=a+4|0;f[H>>2]=f[I>>2];J=m+8|0;f[J>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];K=f[a+36>>2]|0;f[m+36>>2]=K;f[m+40>>2]=J;J=m+48|0;M=m+44|0;f[M>>2]=J;f[J>>2]=0;f[m+52>>2]=0;if(K|0){J=K+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[I>>2]|0)<3){I=f[a+44>>2]|0;J=f[M>>2]|0;f[J>>2]=f[I>>2];f[J+4>>2]=f[I+4>>2];break}else{f[H>>2]=0;BR(m,a);break}}else OR(m,d,-1);while(0);do if((NS(e)|0)==65536){d=f[e+4>>2]|0;f[n>>2]=f[d>>2];a=n+4|0;H=d+4|0;f[a>>2]=f[H>>2];I=n+8|0;f[I>>2]=f[d+8>>2];f[n+12>>2]=f[d+12>>2];f[n+16>>2]=f[d+16>>2];f[n+20>>2]=f[d+20>>2];f[n+24>>2]=f[d+24>>2];f[n+28>>2]=f[d+28>>2];f[n+32>>2]=f[d+32>>2];J=f[d+36>>2]|0;f[n+36>>2]=J;f[n+40>>2]=I;I=n+48|0;M=n+44|0;f[M>>2]=I;f[I>>2]=0;f[n+52>>2]=0;if(J|0){I=J+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[H>>2]|0)<3){H=f[d+44>>2]|0;I=f[M>>2]|0;f[I>>2]=f[H>>2];f[I+4>>2]=f[H+4>>2];break}else{f[a>>2]=0;BR(n,d);break}}else OR(n,e,-1);while(0);do if((NS(g)|0)==65536){e=f[g+4>>2]|0;f[o>>2]=f[e>>2];d=o+4|0;a=e+4|0;f[d>>2]=f[a>>2];H=o+8|0;f[H>>2]=f[e+8>>2];f[o+12>>2]=f[e+12>>2];f[o+16>>2]=f[e+16>>2];f[o+20>>2]=f[e+20>>2];f[o+24>>2]=f[e+24>>2];f[o+28>>2]=f[e+28>>2];f[o+32>>2]=f[e+32>>2];I=f[e+36>>2]|0;f[o+36>>2]=I;f[o+40>>2]=H;H=o+48|0;M=o+44|0;f[M>>2]=H;f[H>>2]=0;f[o+52>>2]=0;if(I|0){H=I+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[a>>2]|0)<3){a=f[e+44>>2]|0;H=f[M>>2]|0;f[H>>2]=f[a>>2];f[H+4>>2]=f[a+4>>2];break}else{f[d>>2]=0;BR(o,e);break}}else OR(o,g,-1);while(0);g=l+40|0;e=f[g>>2]|0;d=f[e>>2]|0;f[q>>2]=f[e+4>>2];f[q+4>>2]=d;KS(c,q,f[l>>2]&4095,-1,0,0);do if((NS(c)|0)==65536){q=f[c+4>>2]|0;f[r>>2]=f[q>>2];d=r+4|0;e=q+4|0;f[d>>2]=f[e>>2];a=r+8|0;f[a>>2]=f[q+8>>2];f[r+12>>2]=f[q+12>>2];H=r+16|0;f[H>>2]=f[q+16>>2];f[r+20>>2]=f[q+20>>2];f[r+24>>2]=f[q+24>>2];f[r+28>>2]=f[q+28>>2];f[r+32>>2]=f[q+32>>2];M=f[q+36>>2]|0;f[r+36>>2]=M;f[r+40>>2]=a;a=r+48|0;I=r+44|0;f[I>>2]=a;f[a>>2]=0;f[r+52>>2]=0;if(M|0){a=M+12|0;f[a>>2]=(f[a>>2]|0)+1}if((f[e>>2]|0)<3){e=f[q+44>>2]|0;a=f[I>>2]|0;f[a>>2]=f[e>>2];f[a+4>>2]=f[e+4>>2];N=H;break}else{f[d>>2]=0;BR(r,q);N=H;break}}else{OR(r,c,-1);N=r+16|0}while(0);c=l+16|0;if((f[N>>2]|0)==(f[c>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;O=c$(i,20)|0;H=334044;P=O+20|0;do{b[O>>0]=b[H>>0]|0;O=O+1|0;H=H+1|0}while((O|0)<(P|0));j$(-215,i,334065,333499,212);d$(i)}H=l+12|0;q=f[H>>2]|0;d=4096/(((q|0)>1?q:1)>>>0)|0;e=l+8|0;a=f[e>>2]|0;I=d>>>0>1?d:1;d=(a|0)<(I|0)?a:I;f[s>>2]=1124007936;I=s+4|0;a=s+8|0;M=s+40|0;O=I;P=O+36|0;do{f[O>>2]=0;O=O+4|0}while((O|0)<(P|0));f[M>>2]=a;a=s+48|0;J=s+44|0;f[J>>2]=a;f[a>>2]=0;f[s+52>>2]=0;f[i>>2]=d;K=i+4|0;f[K>>2]=q;AR(s,2,i,11);q=f[H>>2]|0;f[t>>2]=1124007936;L=t+4|0;Q=t+8|0;R=t+40|0;O=L;P=O+36|0;do{f[O>>2]=0;O=O+4|0}while((O|0)<(P|0));f[R>>2]=Q;Q=t+48|0;S=t+44|0;f[S>>2]=Q;f[Q>>2]=0;f[t+52>>2]=0;f[i>>2]=d;f[K>>2]=q;AR(t,2,i,2);q=v+4|0;T=v+8|0;U=v+40|0;O=q;P=O+36|0;do{f[O>>2]=0;O=O+4|0}while((O|0)<(P|0));f[U>>2]=T;T=v+48|0;V=v+44|0;f[V>>2]=T;f[T>>2]=0;f[v+52>>2]=0;f[v>>2]=1124007942;W=w+4|0;X=w+8|0;Z=w+40|0;O=W;P=O+36|0;do{f[O>>2]=0;O=O+4|0}while((O|0)<(P|0));f[Z>>2]=X;X=w+48|0;O=w+44|0;f[O>>2]=X;f[X>>2]=0;f[w+52>>2]=0;f[w>>2]=1124007942;aR(y,3,3,6);pqa(x,y);fj(y);y=i+8|0;f[y>>2]=0;f[y+4>>2]=0;f[i>>2]=-2113863674;f[i+4>>2]=v;WJ(m,i,6,1.0,0.0);y=n+16|0;P=(f[y>>2]|0)==0;_=n+4|0;$=f[_>>2]|0;if(!P){if(($|0)<3)aa=Y(f[n+12>>2]|0,f[n+8>>2]|0)|0;else{ba=f[n+40>>2]|0;ca=0;da=1;while(1){ea=Y(f[ba+(ca<<2)>>2]|0,da)|0;ca=ca+1|0;if((ca|0)==($|0)){aa=ea;break}else da=ea}}if(!(($|0)==0|(aa|0)==0)){qqa(i,n);aa=i+36|0;da=f[aa>>2]|0;if(da|0){ca=da+12|0;f[ca>>2]=(f[ca>>2]|0)+1}ca=n+36|0;da=f[ca>>2]|0;if(da|0?(ba=da+12|0,da=f[ba>>2]|0,f[ba>>2]=da+-1,(da|0)==1):0)CR(n);f[ca>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[_>>2]|0)>0){da=f[n+40>>2]|0;ba=0;do{f[da+(ba<<2)>>2]=0;ba=ba+1|0;fa=f[_>>2]|0}while((ba|0)<(fa|0));f[n>>2]=f[i>>2];if((fa|0)<3)ga=54;else ga=56}else{f[n>>2]=f[i>>2];ga=54}if((ga|0)==54){fa=f[i+4>>2]|0;if((fa|0)<3){f[_>>2]=fa;f[n+8>>2]=f[i+8>>2];f[n+12>>2]=f[i+12>>2];fa=f[i+44>>2]|0;_=f[n+44>>2]|0;f[_>>2]=f[fa>>2];f[_+4>>2]=f[fa+4>>2]}else ga=56}if((ga|0)==56)BR(n,i);fa=i+16|0;f[y>>2]=f[fa>>2];f[n+20>>2]=f[i+20>>2];f[n+24>>2]=f[i+24>>2];f[n+28>>2]=f[i+28>>2];f[n+32>>2]=f[i+32>>2];_=f[aa>>2]|0;f[ca>>2]=_;if(_|0?(ca=_+12|0,_=f[ca>>2]|0,f[ca>>2]=_+-1,(_|0)==1):0)CR(i);f[aa>>2]=0;aa=i+4|0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[aa>>2]|0)>0){fa=f[i+40>>2]|0;_=0;do{f[fa+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[aa>>2]|0))}aa=f[i+44>>2]|0;if((aa|0)!=(i+48|0))ZF(aa)}else ga=66}else ga=66;if((ga|0)==66){if(!(((($|0)<3?(f[n+8>>2]|0)==5:0)?(f[n+12>>2]|0)==1:0)?!((f[n>>2]&4095|0)!=6|P):0))ga=70;if((ga|0)==70){f[i>>2]=5;f[K>>2]=1;AR(n,2,i,6)};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;gL(n,i)|0}K=o+16|0;if(f[K>>2]|0){P=f[o+4>>2]|0;if((P|0)<3)ha=Y(f[o+12>>2]|0,f[o+8>>2]|0)|0;else{$=f[o+40>>2]|0;aa=0;_=1;while(1){fa=Y(f[$+(aa<<2)>>2]|0,_)|0;aa=aa+1|0;if((aa|0)==(P|0)){ha=fa;break}else _=fa}}if(!((P|0)==0|(ha|0)==0)){ha=i+8|0;f[ha>>2]=0;f[ha+4>>2]=0;f[i>>2]=-2113863674;f[i+4>>2]=w;WJ(o,i,6,1.0,0.0)}else ga=79}else ga=79;if((ga|0)==79){ga=i+8|0;f[ga>>2]=0;f[ga+4>>2]=0;f[i>>2]=-2113863674;f[i+4>>2]=w;eL(v,i)}ga=w+16|0;ia=+p[(f[ga>>2]|0)+(f[f[O>>2]>>2]|0)+16>>3];ha=f[e>>2]|0;if((ha|0)>0){P=i+4|0;_=j+4|0;aa=i+4|0;$=j+4|0;fa=i+4|0;ca=j+4|0;ba=i+8|0;da=i+12|0;ea=i+4|0;ja=j+8|0;ka=j+12|0;la=j+4|0;ma=C+8|0;na=C+12|0;oa=C+4|0;pa=D+8|0;qa=D+12|0;ra=D+4|0;sa=E+4|0;ta=F+8|0;ua=F+4|0;va=G+8|0;wa=G+4|0;xa=i+8|0;ya=i+12|0;za=i+4|0;Aa=j+8|0;Ba=j+4|0;Ca=C+8|0;Da=C+12|0;Ea=C+4|0;Fa=D+8|0;Ga=D+12|0;Ha=D+4|0;Ia=B+36|0;Ja=B+16|0;Ka=B+4|0;La=B+40|0;Ma=B+44|0;Na=B+48|0;Oa=A+36|0;Pa=A+16|0;Qa=A+4|0;Ra=A+40|0;Sa=A+44|0;Ta=A+48|0;Ua=z+36|0;Va=z+16|0;Wa=z+4|0;Xa=z+40|0;Ya=z+44|0;Za=z+48|0;_a=ha;ha=0;do{$a=_a-ha|0;ab=($a|0)<(d|0)?$a:d;p[(f[ga>>2]|0)+(f[f[O>>2]>>2]|0)+16>>3]=ia-+(ha|0);f[i>>2]=0;f[P>>2]=ab;f[j>>2]=-2147483648;f[_>>2]=2147483647;DR(z,s,i,j);f[i>>2]=0;f[aa>>2]=ab;f[j>>2]=-2147483648;f[$>>2]=2147483647;DR(A,t,i,j);f[i>>2]=ha;f[fa>>2]=ab+ha;f[j>>2]=-2147483648;f[ca>>2]=2147483647;DR(B,r,i,j);f[ba>>2]=0;f[da>>2]=0;f[i>>2]=-2130640890;f[ea>>2]=v;f[ja>>2]=0;f[ka>>2]=0;f[j>>2]=16842752;f[la>>2]=n;f[ma>>2]=0;f[na>>2]=0;f[C>>2]=-2130640890;f[oa>>2]=x;f[pa>>2]=0;f[qa>>2]=0;f[D>>2]=-2130640890;f[ra>>2]=w;f[E>>2]=f[H>>2];f[sa>>2]=ab;ab=f[z>>2]&4095;$a=ta;f[$a>>2]=0;f[$a+4>>2]=0;f[F>>2]=33619968;f[ua>>2]=z;$a=va;f[$a>>2]=0;f[$a+4>>2]=0;f[G>>2]=33619968;f[wa>>2]=A;oqa(i,j,C,D,E,ab,F,G);f[xa>>2]=0;f[ya>>2]=0;f[i>>2]=16842752;f[za>>2]=l;ab=Aa;f[ab>>2]=0;f[ab+4>>2]=0;f[j>>2]=33619968;f[Ba>>2]=B;f[Ca>>2]=0;f[Da>>2]=0;f[C>>2]=16842752;f[Ea>>2]=z;f[Fa>>2]=0;f[Ga>>2]=0;f[D>>2]=16842752;f[Ha>>2]=A;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;f[F+16>>2]=0;f[F+20>>2]=0;f[F+24>>2]=0;f[F+28>>2]=0;mga(i,j,C,D,1,0,F);ab=f[Ia>>2]|0;if(ab|0?($a=ab+12|0,ab=f[$a>>2]|0,f[$a>>2]=ab+-1,(ab|0)==1):0)CR(B);f[Ia>>2]=0;f[Ja>>2]=0;f[Ja+4>>2]=0;f[Ja+8>>2]=0;f[Ja+12>>2]=0;if((f[Ka>>2]|0)>0){ab=f[La>>2]|0;$a=0;do{f[ab+($a<<2)>>2]=0;$a=$a+1|0}while(($a|0)<(f[Ka>>2]|0))}$a=f[Ma>>2]|0;if(($a|0)!=(Na|0))ZF($a);$a=f[Oa>>2]|0;if($a|0?(ab=$a+12|0,$a=f[ab>>2]|0,f[ab>>2]=$a+-1,($a|0)==1):0)CR(A);f[Oa>>2]=0;f[Pa>>2]=0;f[Pa+4>>2]=0;f[Pa+8>>2]=0;f[Pa+12>>2]=0;if((f[Qa>>2]|0)>0){$a=f[Ra>>2]|0;ab=0;do{f[$a+(ab<<2)>>2]=0;ab=ab+1|0}while((ab|0)<(f[Qa>>2]|0))}ab=f[Sa>>2]|0;if((ab|0)!=(Ta|0))ZF(ab);ab=f[Ua>>2]|0;if(ab|0?($a=ab+12|0,ab=f[$a>>2]|0,f[$a>>2]=ab+-1,(ab|0)==1):0)CR(z);f[Ua>>2]=0;f[Va>>2]=0;f[Va+4>>2]=0;f[Va+8>>2]=0;f[Va+12>>2]=0;if((f[Wa>>2]|0)>0){ab=f[Xa>>2]|0;$a=0;do{f[ab+($a<<2)>>2]=0;$a=$a+1|0}while(($a|0)<(f[Wa>>2]|0))}$a=f[Ya>>2]|0;if(($a|0)!=(Za|0))ZF($a);ha=ha+d|0;_a=f[e>>2]|0}while((_a|0)>(ha|0))}ha=x+36|0;_a=f[ha>>2]|0;if(_a|0?(e=_a+12|0,_a=f[e>>2]|0,f[e>>2]=_a+-1,(_a|0)==1):0)CR(x);f[ha>>2]=0;ha=x+16|0;_a=x+4|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[_a>>2]|0)>0){ha=f[x+40>>2]|0;e=0;do{f[ha+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[_a>>2]|0))}_a=f[x+44>>2]|0;if((_a|0)!=(x+48|0))ZF(_a);_a=w+36|0;x=f[_a>>2]|0;if(x|0?(e=x+12|0,x=f[e>>2]|0,f[e>>2]=x+-1,(x|0)==1):0)CR(w);f[_a>>2]=0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[W>>2]|0)>0){ga=f[Z>>2]|0;Z=0;do{f[ga+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[W>>2]|0))}W=f[O>>2]|0;if((W|0)!=(X|0))ZF(W);W=v+36|0;X=f[W>>2]|0;if(X|0?(O=X+12|0,X=f[O>>2]|0,f[O>>2]=X+-1,(X|0)==1):0)CR(v);f[W>>2]=0;W=v+16|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[q>>2]|0)>0){W=f[U>>2]|0;U=0;do{f[W+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[q>>2]|0))}q=f[V>>2]|0;if((q|0)!=(T|0))ZF(q);q=t+36|0;T=f[q>>2]|0;do if(T|0){V=T+12|0;U=f[V>>2]|0;f[V>>2]=U+-1;if((U|0)!=1)break;CR(t)}while(0);f[q>>2]=0;q=t+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[L>>2]|0)>0){q=f[R>>2]|0;R=0;do{f[q+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[L>>2]|0))}L=f[S>>2]|0;if((L|0)!=(Q|0))ZF(L);L=s+36|0;Q=f[L>>2]|0;do if(Q|0){S=Q+12|0;R=f[S>>2]|0;f[S>>2]=R+-1;if((R|0)!=1)break;CR(s)}while(0);f[L>>2]=0;L=s+16|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[I>>2]|0)>0){L=f[M>>2]|0;M=0;do{f[L+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[I>>2]|0))}I=f[J>>2]|0;if((I|0)!=(a|0))ZF(I);I=r+36|0;a=f[I>>2]|0;do if(a|0){J=a+12|0;M=f[J>>2]|0;f[J>>2]=M+-1;if((M|0)!=1)break;CR(r)}while(0);f[I>>2]=0;I=r+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[I>>2]|0)>0){N=f[r+40>>2]|0;a=0;do{f[N+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[I>>2]|0))}I=f[r+44>>2]|0;if((I|0)!=(r+48|0))ZF(I);I=o+36|0;r=f[I>>2]|0;do if(r|0){a=r+12|0;N=f[a>>2]|0;f[a>>2]=N+-1;if((N|0)!=1)break;CR(o)}while(0);f[I>>2]=0;I=o+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[I>>2]|0)>0){K=f[o+40>>2]|0;r=0;do{f[K+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[I>>2]|0))}I=f[o+44>>2]|0;if((I|0)!=(o+48|0))ZF(I);I=n+36|0;o=f[I>>2]|0;do if(o|0){r=o+12|0;K=f[r>>2]|0;f[r>>2]=K+-1;if((K|0)!=1)break;CR(n)}while(0);f[I>>2]=0;I=n+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[I>>2]|0)>0){y=f[n+40>>2]|0;o=0;do{f[y+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[I>>2]|0))}I=f[n+44>>2]|0;if((I|0)!=(n+48|0))ZF(I);I=m+36|0;n=f[I>>2]|0;do if(n|0){o=n+12|0;y=f[o>>2]|0;f[o>>2]=y+-1;if((y|0)!=1)break;CR(m)}while(0);f[I>>2]=0;I=m+16|0;n=m+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[n>>2]|0)>0){I=f[m+40>>2]|0;y=0;do{f[I+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[n>>2]|0))}n=f[m+44>>2]|0;if((n|0)!=(m+48|0))ZF(n);n=l+36|0;m=f[n>>2]|0;do if(m|0){y=m+12|0;I=f[y>>2]|0;f[y>>2]=I+-1;if((I|0)!=1)break;CR(l)}while(0);f[n>>2]=0;n=l+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[n>>2]|0)>0){c=f[g>>2]|0;g=0;do{f[c+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[n>>2]|0))}n=f[l+44>>2]|0;if((n|0)!=(l+48|0))ZF(n);if(!(f[k+4>>2]|0)){u=h;return}u=h;return}function uqa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;g=u;u=u+48|0;h=g+8|0;i=g;if(!((c|0)!=0&(d|0)!=0&(e|0)!=0)){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,45)|0;k=334155;l=j+45|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,h,334201,334219,47);d$(h);if(!c){m=c;n=h;o=8}else{p=c;q=h;o=4}}else{p=c;q=h;o=4}if((o|0)==4){r=f[c>>2]|0;if((((r&-65536|0)==1111621632?(f[c+24>>2]|0)>0:0)?(f[c+20>>2]|0)>0:0)?(f[c+16>>2]|0)!=0:0){s=p;t=q;v=r}else{m=p;n=q;o=8}}if((o|0)==8){f[i>>2]=0;f[i+4>>2]=0;j=c$(i,33)|0;k=334269;l=j+33|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-5,i,334201,334219,54);d$(i);s=m;t=n;v=f[c>>2]|0}if((v&4088|0)==0?(f[c+24>>2]|0)==2:0){S0(c,h,2,0)|0;w=h}else w=s;s=f[w>>2]|0;h=s&4095;if((s&4094|0)!=12){f[i>>2]=0;f[i+4>>2]=0;j=c$(i,87)|0;k=334303;l=j+87|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-210,i,334201,334219,63);d$(i)}c=w+24|0;v=f[c>>2]|0;if(!((v|0)!=1?(f[w+20>>2]|0)!=1:0))o=16;if((o|0)==16?f[w>>2]&16384|0:0){x=v;y=a&28672;z=h|y;A=s>>>3;B=A&511;C=B+1|0;D=s<<1;E=D&14;F=47696>>>E;G=F&3;H=C<<G;I=w+16|0;J=f[I>>2]|0;K=w+20|0;L=f[K>>2]|0;M=Y(L,x)|0;EL(z,88,H,J,M,d,e)|0;u=g;return d|0}f[i>>2]=0;f[i+4>>2]=0;j=c$(i,75)|0;k=334391;l=j+75|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-5,i,334201,334219,68);d$(i);x=f[c>>2]|0;y=a&28672;z=h|y;A=s>>>3;B=A&511;C=B+1|0;D=s<<1;E=D&14;F=47696>>>E;G=F&3;H=C<<G;I=w+16|0;J=f[I>>2]|0;K=w+20|0;L=f[K>>2]|0;M=Y(L,x)|0;EL(z,88,H,J,M,d,e)|0;u=g;return d|0}function vqa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=76632;b=a+348|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)ki[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+352>>2]=0;j0(a+300|0);j0(a+252|0);j0(a+204|0);j0(a+156|0);b=a+100|0;c=a+136|0;e=f[c>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)CR(b);f[c>>2]=0;c=a+116|0;b=a+104|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+140>>2]|0;e=0;do{f[c+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[b>>2]|0))}b=f[a+144>>2]|0;if((b|0)!=(a+148|0))ZF(b);b=a+44|0;e=a+80|0;c=f[e>>2]|0;if(c|0?(d=c+12|0,c=f[d>>2]|0,f[d>>2]=c+-1,(c|0)==1):0)CR(b);f[e>>2]=0;e=a+60|0;b=a+48|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[b>>2]|0)>0){e=f[a+84>>2]|0;c=0;do{f[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+88>>2]|0;if((b|0)==(a+92|0))return;ZF(b);return}function wqa(a){a=a|0;vqa(a);PYa(a);return}function xqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;f[a+8>>2]=f[c>>2];f[a+12>>2]=f[c+4>>2];c=a+24|0;b=a+348|0;d=a+352|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;c=f[d>>2]|0;if(c|0){a=f[c>>2]|0;e=c+4|0;c=f[e>>2]|0;if((c|0)==(a|0))return 1;f[e>>2]=c+(~(((c+-20-a|0)>>>0)/20|0)*20|0);return 1}a=NYa(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=NYa(16)|0;e=c+4|0;f[e>>2]=1;f[c>>2]=76712;f[c+8>>2]=a;f[e>>2]=(f[e>>2]|0)+1;g=f[b>>2]|0;f[b>>2]=c;f[d>>2]=a;if(g|0?(a=g+4|0,d=f[a>>2]|0,f[a>>2]=d+-1,(d|0)==1):0)ki[f[(f[g>>2]|0)+8>>2]&2047](g);g=f[e>>2]|0;f[e>>2]=g+-1;if((g|0)!=1)return 1;ki[f[(f[c>>2]|0)+8>>2]&2047](c);return 1}function yqa(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;return}function zqa(a){a=a|0;return -1}function Aqa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0;e=u;u=u+224|0;g=e+176|0;h=e+168|0;i=e+152|0;j=e+160|0;k=e+144|0;l=e+80|0;m=e+136|0;o=e+16|0;p=e;q=e+72|0;_$(h,76684);QR(i,c,-1);f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];i=Jqa(a,j,d)|0;d=a+352|0;j=f[d>>2]|0;r=f[j+4>>2]|0;s=f[j>>2]|0;t=r-s|0;v=(t|0)/20|0;if(!t)w=0;else{if((r|0)==(s|0))hXa(j);j=s;s=f[j+8>>2]|0;r=a+100|0;t=a+112|0;x=(f[j+4>>2]|0)+15&-16;j=f[t>>2]|0;y=(j|0)<(x|0)?x:j;j=a+108|0;x=f[j>>2]|0;z=(x|0)<(s|0)?s:x;f[k>>2]=z;if(i){ki[f[(f[a>>2]|0)+48>>2]&2047](a);Kqa(f[d>>2]|0,a+300|0)}do if((NS(c)|0)==655360?(Y(f[a+28>>2]|0,f[a+24>>2]|0)|0)>0:0){i=a+204|0;x=Y(f[a+40>>2]|0,f[a+20>>2]|0)|0;s=f[a+16>>2]|0;if(!(((((f[a+208>>2]|0)<3?(f[a+212>>2]|0)==(x|0):0)?(f[a+216>>2]|0)==(s|0):0)?(f[i>>2]&4095|0)==4:0)?(f[a+228>>2]|0)!=0:0)){f[g>>2]=x;f[g+4>>2]=s;h0(i,2,g,4,0)}i=a+156|0;if(!(((((f[a+160>>2]|0)<3?(f[a+164>>2]|0)==(z|0):0)?(f[a+168>>2]|0)==(y|0):0)?(f[i>>2]&4095|0)==0:0)?(f[a+180>>2]|0)!=0:0)){f[g>>2]=z;f[g+4>>2]=y;h0(i,2,g,0,0)}s=l+4|0;x=l+8|0;A=l+12|0;B=l+8|0;C=l+4|0;D=g+32|0;E=m+4|0;F=l+8|0;G=l+12|0;H=l+4|0;I=0;while(1){J=f[d>>2]|0;K=f[J>>2]|0;if((((f[J+4>>2]|0)-K|0)/20|0)>>>0<=I>>>0){L=22;break}M=K;K=(f[M+(I*20|0)+4>>2]|0)+-1|0;N=(f[M+(I*20|0)+8>>2]|0)+-1|0;f[l>>2]=0;f[s>>2]=0;f[x>>2]=K;f[A>>2]=N;g0(g,i,l);N=B;f[N>>2]=0;f[N+4>>2]=0;f[l>>2]=34209792;f[C>>2]=g;N=f[D>>2]|0;K=f[N>>2]|0;f[m>>2]=f[N+4>>2];f[E>>2]=K;O=1.0/+n[M+(I*20|0)>>2];fna(c,l,m,O,O,1);M=f[(f[a>>2]|0)+44>>2]|0;f[F>>2]=0;f[G>>2]=0;f[l>>2]=17432576;f[H>>2]=g;fi[M&255](a,I,l);j0(g);I=I+1|0;if(I>>>0>=v>>>0){L=24;break}}if((L|0)==22)hXa(J);else if((L|0)==24){f[a+4>>2]=2;break}}else L=25;while(0);if((L|0)==25){do if((NS(c)|0)==65536){J=f[c+4>>2]|0;f[l>>2]=f[J>>2];m=l+4|0;z=J+4|0;f[m>>2]=f[z>>2];I=l+8|0;f[I>>2]=f[J+8>>2];f[l+12>>2]=f[J+12>>2];f[l+16>>2]=f[J+16>>2];f[l+20>>2]=f[J+20>>2];f[l+24>>2]=f[J+24>>2];f[l+28>>2]=f[J+28>>2];f[l+32>>2]=f[J+32>>2];H=f[J+36>>2]|0;f[l+36>>2]=H;f[l+40>>2]=I;I=l+48|0;G=l+44|0;f[G>>2]=I;f[I>>2]=0;f[l+52>>2]=0;if(H|0){I=H+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[z>>2]|0)<3){z=f[J+44>>2]|0;I=f[G>>2]|0;f[I>>2]=f[z>>2];f[I+4>>2]=f[z+4>>2];break}else{f[m>>2]=0;BR(l,J);break}}else OR(l,c,-1);while(0);c=a+44|0;J=Y(f[a+40>>2]|0,f[a+20>>2]|0)|0;m=f[a+16>>2]|0;if(!(((((f[a+48>>2]|0)<3?(f[a+52>>2]|0)==(J|0):0)?(f[a+56>>2]|0)==(m|0):0)?(f[c>>2]&4095|0)==4:0)?(f[a+60>>2]|0)!=0:0)){f[g>>2]=J;f[g+4>>2]=m;AR(c,2,g,4)}c=f[k>>2]|0;if(!(((((f[a+104>>2]|0)<3?(f[j>>2]|0)==(c|0):0)?(f[t>>2]|0)==(y|0):0)?(f[r>>2]&4095|0)==0:0)?(f[a+116>>2]|0)!=0:0)){f[g>>2]=c;f[g+4>>2]=y;AR(r,2,g,0)}r=a+116|0;y=o+4|0;c=o+8|0;t=o+12|0;j=o+16|0;k=o+20|0;m=o+24|0;J=o+28|0;z=o+40|0;I=o+48|0;G=o+44|0;H=o+52|0;F=g+4|0;E=g+8|0;D=g+12|0;C=g+4|0;B=p+8|0;i=p+4|0;A=q+4|0;x=g+8|0;s=g+12|0;M=g+4|0;K=o+36|0;N=0;do{P=f[d>>2]|0;Q=f[P>>2]|0;if((((f[P+4>>2]|0)-Q|0)/20|0)>>>0<=N>>>0){L=46;break}R=Q;Q=(f[R+(N*20|0)+8>>2]|0)+-1|0;S=(f[R+(N*20|0)+4>>2]|0)+-1|0;T=f[r>>2]|0;f[o>>2]=1124007936;f[y>>2]=2;f[c>>2]=Q;f[t>>2]=S;f[j>>2]=T;f[k>>2]=T;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[z>>2]=c;f[G>>2]=I;f[H>>2]=0;f[I>>2]=0;if((T|0)==0&(Y(S,Q)|0)!=0){f[g>>2]=0;f[F>>2]=0;Q=c$(g,26)|0;U=358223;V=Q+26|0;do{b[Q>>0]=b[U>>0]|0;Q=Q+1|0;U=U+1|0}while((Q|0)<(V|0));j$(-215,g,358250,358254,500);d$(g);W=f[o>>2]|0;X=f[t>>2]|0;Z=f[G>>2]|0;_=f[k>>2]|0;$=f[z>>2]|0}else{W=1124007936;X=S;Z=I;_=T;$=c}f[o>>2]=W|16384;f[Z>>2]=X;f[Z+4>>2]=1;U=_+(Y(f[c>>2]|0,X)|0)|0;f[J>>2]=U;f[m>>2]=U+(0-X)+X;f[E>>2]=0;f[D>>2]=0;f[g>>2]=16842752;f[C>>2]=l;U=B;f[U>>2]=0;f[U+4>>2]=0;f[p>>2]=33619968;f[i>>2]=o;U=f[$>>2]|0;f[q>>2]=f[$+4>>2];f[A>>2]=U;O=1.0/+n[R+(N*20|0)>>2];fna(g,p,q,O,O,1);U=f[(f[a>>2]|0)+44>>2]|0;f[x>>2]=0;f[s>>2]=0;f[g>>2]=16842752;f[M>>2]=o;fi[U&255](a,N,g);U=f[K>>2]|0;if(U|0?(Q=U+12|0,U=f[Q>>2]|0,f[Q>>2]=U+-1,(U|0)==1):0)CR(o);f[K>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[y>>2]|0)>0){U=f[z>>2]|0;Q=0;do{f[U+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[y>>2]|0))}Q=f[G>>2]|0;if((Q|0)!=(I|0))ZF(Q);N=N+1|0}while(N>>>0<v>>>0);if((L|0)==46)hXa(P);f[a+4>>2]=1;a=l+36|0;P=f[a>>2]|0;if(P|0?(L=P+12|0,P=f[L>>2]|0,f[L>>2]=P+-1,(P|0)==1):0)CR(l);f[a>>2]=0;a=l+16|0;P=l+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[P>>2]|0)>0){a=f[l+40>>2]|0;L=0;do{f[a+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[P>>2]|0))}P=f[l+44>>2]|0;if((P|0)!=(l+48|0))ZF(P)}w=1}if(!(f[h+4>>2]|0)){u=e;return w|0}u=e;return w|0}function Bqa(a,b,c){a=a|0;b=b|0;c=c|0;return 1}function Cqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+16|0;d=c;e=a+4|0;if(!(f[e>>2]&2)){g=d+8|0;f[g>>2]=0;f[g+4>>2]=0;f[d>>2]=34209792;f[d+4>>2]=a+204;eL(a+44|0,d);f[e>>2]=f[e>>2]|2}e=f[b>>2]|0;d=b+4|0;while(1){g=f[d>>2]|0;if((g|0)==(e|0))break;h=g+-48|0;f[d>>2]=h;j0(h)}h=a+300|0;g=b+8|0;if((e|0)==(f[g>>2]|0)){Iqa(b,h);i=f[d>>2]|0}else{f[e>>2]=f[h>>2];j=e+4|0;k=a+304|0;f[j>>2]=f[k>>2];l=e+8|0;f[l>>2]=f[a+308>>2];f[e+12>>2]=f[a+312>>2];f[e+16>>2]=f[a+316>>2];f[e+20>>2]=f[a+320>>2];m=f[a+324>>2]|0;f[e+24>>2]=m;f[e+28>>2]=f[a+328>>2];f[e+32>>2]=l;l=e+40|0;n=e+36|0;f[n>>2]=l;f[e+44>>2]=0;f[l>>2]=0;if(m|0){l=m+8|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[a+336>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;i0(e,h)}h=(f[d>>2]|0)+48|0;f[d>>2]=h;i=h}h=a+204|0;if((i|0)==(f[g>>2]|0)){Iqa(b,h);o=f[d>>2]|0}else{f[i>>2]=f[h>>2];e=i+4|0;j=a+208|0;f[e>>2]=f[j>>2];k=i+8|0;f[k>>2]=f[a+212>>2];f[i+12>>2]=f[a+216>>2];f[i+16>>2]=f[a+220>>2];f[i+20>>2]=f[a+224>>2];l=f[a+228>>2]|0;f[i+24>>2]=l;f[i+28>>2]=f[a+232>>2];f[i+32>>2]=k;k=i+40|0;n=i+36|0;f[n>>2]=k;f[i+44>>2]=0;f[k>>2]=0;if(l|0){k=l+8|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[a+240>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[e>>2]=0;i0(i,h)}h=(f[d>>2]|0)+48|0;f[d>>2]=h;o=h}h=a+252|0;if((o|0)==(f[g>>2]|0)){Iqa(b,h);u=c;return}f[o>>2]=f[h>>2];b=o+4|0;g=a+256|0;f[b>>2]=f[g>>2];i=o+8|0;f[i>>2]=f[a+260>>2];f[o+12>>2]=f[a+264>>2];f[o+16>>2]=f[a+268>>2];f[o+20>>2]=f[a+272>>2];e=f[a+276>>2]|0;f[o+24>>2]=e;f[o+28>>2]=f[a+280>>2];f[o+32>>2]=i;i=o+40|0;j=o+36|0;f[j>>2]=i;f[o+44>>2]=0;f[i>>2]=0;if(e|0){i=e+8|0;f[i>>2]=(f[i>>2]|0)+1}if((f[g>>2]|0)<3){g=f[a+288>>2]|0;a=f[j>>2]|0;f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2]}else{f[b>>2]=0;i0(o,h)}f[d>>2]=(f[d>>2]|0)+48;u=c;return}function Dqa(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+16|0;c=b;d=a+4|0;if(f[d>>2]&1|0){u=b;return}e=c+8|0;f[e>>2]=0;f[e+4>>2]=0;f[c>>2]=33619968;f[c+4>>2]=a+44;p0(a+204|0,c);f[d>>2]=f[d>>2]|1;u=b;return}function Eqa(a,b){a=a|0;b=b|0;return 0.0}function Fqa(a,b){a=a|0;b=b|0;return 0}function Gqa(a,b,c){a=a|0;b=b|0;c=c|0;return}function Hqa(a){a=a|0;return}function Iqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/48|0;g=e+1|0;if(g>>>0>89478485)gXa(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/48|0;d=i<<1;j=i>>>0<44739242?(d>>>0<g>>>0?g:d):89478485;do if(j)if(j>>>0>89478485){d=De(8)|0;UYa(d,358155);f[d>>2]=130560;Of(d|0,21520,875)}else{k=NYa(j*48|0)|0;break}else k=0;while(0);d=k+(e*48|0)|0;g=d;i=k+(j*48|0)|0;f[d>>2]=f[b>>2];j=k+(e*48|0)+4|0;l=b+4|0;m=f[l>>2]|0;f[j>>2]=m;n=k+(e*48|0)+8|0;f[n>>2]=f[b+8>>2];f[k+(e*48|0)+12>>2]=f[b+12>>2];f[k+(e*48|0)+16>>2]=f[b+16>>2];f[k+(e*48|0)+20>>2]=f[b+20>>2];o=f[b+24>>2]|0;f[k+(e*48|0)+24>>2]=o;f[k+(e*48|0)+28>>2]=f[b+28>>2];f[k+(e*48|0)+32>>2]=n;n=k+(e*48|0)+40|0;p=k+(e*48|0)+36|0;f[p>>2]=n;f[k+(e*48|0)+44>>2]=0;f[n>>2]=0;if(!o)q=m;else{m=o+8|0;f[m>>2]=(f[m>>2]|0)+1;q=f[l>>2]|0}if((q|0)<3){q=f[b+36>>2]|0;l=f[p>>2]|0;f[l>>2]=f[q>>2];f[l+4>>2]=f[q+4>>2]}else{f[j>>2]=0;i0(d,b)}b=d+48|0;j=f[a>>2]|0;q=f[c>>2]|0;if((q|0)==(j|0)){r=g;s=j;t=q}else{l=d;d=q;q=g;do{g=l+-48|0;p=d;d=d+-48|0;f[g>>2]=f[d>>2];m=l+-44|0;o=p+-44|0;f[m>>2]=f[o>>2];n=l+-40|0;f[n>>2]=f[p+-40>>2];f[l+-36>>2]=f[p+-36>>2];f[l+-32>>2]=f[p+-32>>2];f[l+-28>>2]=f[p+-28>>2];e=f[p+-24>>2]|0;f[l+-24>>2]=e;f[l+-20>>2]=f[p+-20>>2];f[l+-16>>2]=n;n=l+-8|0;k=l+-12|0;f[k>>2]=n;f[l+-4>>2]=0;f[n>>2]=0;if(e|0){n=e+8|0;f[n>>2]=(f[n>>2]|0)+1}if((f[o>>2]|0)<3){o=f[p+-12>>2]|0;p=f[k>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2]}else{f[m>>2]=0;i0(g,d)}l=q+-48|0;q=l}while((d|0)!=(j|0));r=q;s=f[a>>2]|0;t=f[c>>2]|0}f[a>>2]=r;f[c>>2]=b;f[h>>2]=i;i=s;h=t;while(1){t=h;if((t|0)==(i|0))break;b=t+-48|0;j0(b);h=b}if(!s)return;PYa(s);return}function Jqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=a+348|0;e=a+352|0;if(!(f[e>>2]|0)){g=NYa(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=NYa(16)|0;i=h+4|0;f[i>>2]=1;f[h>>2]=76712;f[h+8>>2]=g;f[i>>2]=(f[i>>2]|0)+1;j=f[d>>2]|0;f[d>>2]=h;f[e>>2]=g;if(j|0?(g=j+4|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)ki[f[(f[j>>2]|0)+8>>2]&2047](j);j=f[i>>2]|0;f[i>>2]=j+-1;if((j|0)==1)ki[f[(f[h>>2]|0)+8>>2]&2047](h)}h=f[c>>2]|0;j=(f[c+4>>2]|0)-h>>2;i=f[e>>2]|0;d=i+4|0;g=f[d>>2]|0;k=f[i>>2]|0;l=(g-k|0)/20|0;m=k;k=g;g=h;if(j>>>0<=l>>>0)if(j>>>0<l>>>0?(h=m+(j*20|0)|0,(k|0)!=(h|0)):0){f[d>>2]=k+(~(((k+-20-h|0)>>>0)/20|0)*20|0);o=g}else o=g;else{Lqa(i,j-l|0);o=f[c>>2]|0}i=a+16|0;g=f[i>>2]|0;h=a+20|0;a=f[h>>2]|0;k=(wNa(+(f[b>>2]|0)/+n[o>>2])|0)+62&-32;o=(g|0)<(k|0);f[i>>2]=o?k:g;g=(j|0)!=(l|0)|o;if(!j){p=a;q=0;r=0;s=g;t=q+r|0;u=(p|0)<(t|0);v=u?t:p;f[h>>2]=v;w=(v|0)!=(a|0);x=s|w;return x|0}o=f[e>>2]|0;e=f[o>>2]|0;l=((f[o+4>>2]|0)-e|0)/20|0;k=e;e=f[c>>2]|0;c=b+4|0;d=0;m=0;y=0;z=0;A=g;while(1){if(l>>>0<=d>>>0){B=15;break}g=k+(d*20|0)|0;if(!A){C=+n[e+(d<<2)>>2];if(+L(+(+n[g>>2]-C))>C*1.1920928955078125e-05){D=C;E=1;F=g}else{D=C;E=0;F=g}}else{D=+n[e+(d<<2)>>2];E=1;F=g}g=wNa(+(f[b>>2]|0)/D)|0;G=wNa(+(f[c>>2]|0)/D)|0;f[k+(d*20|0)+16>>2]=D>=2.0?1:2;n[F>>2]=D;H=g+1|0;g=G+1|0;f[k+(d*20|0)+4>>2]=H;f[k+(d*20|0)+8>>2]=g;G=(d|0)==0?g:m;I=f[i>>2]|0;J=(H+y|0)>(I|0);K=J?0:y;z=(J?G:0)+z|0;m=J?g:G;G=(Y(z,I)|0)+K|0;f[k+(d*20|0)+12>>2]=G;d=d+1|0;if(d>>>0>=j>>>0)break;else{y=K+H|0;A=E}}if((B|0)==15)hXa(o);p=f[h>>2]|0;q=m;r=z;s=E;t=q+r|0;u=(p|0)<(t|0);v=u?t:p;f[h>>2]=v;w=(v|0)!=(a|0);x=s|w;return x|0}function Kqa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+80|0;e=d+56|0;g=d;h=f[a>>2]|0;i=a+4|0;j=f[i>>2]|0;if((h|0)==(j|0)){k=c+24|0;l=f[k>>2]|0;if(l|0?(m=l+8|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)k0(c);l=c+4|0;if((f[l>>2]|0)>0){m=f[c+32>>2]|0;n=0;do{f[m+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[l>>2]|0))}f[k>>2]=0;o=f[i>>2]|0;p=f[a>>2]|0}else{o=j;p=h}h=o-p|0;o=p;f[g>>2]=1124007936;j=g+4|0;f[j>>2]=2;a=g+8|0;f[a>>2]=1;i=g+12|0;f[i>>2]=h;k=g+16|0;f[k>>2]=o;l=g+20|0;f[l>>2]=o;n=g+24|0;m=g+28|0;q=g+40|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[q>>2]=a;r=g+48|0;s=g+44|0;f[s>>2]=r;f[g+52>>2]=0;f[r>>2]=0;if((p|0)==0&(h|0)!=0){f[e>>2]=0;f[e+4>>2]=0;p=c$(e,26)|0;t=358223;v=p+26|0;do{b[p>>0]=b[t>>0]|0;p=p+1|0;t=t+1|0}while((p|0)<(v|0));j$(-215,e,358250,358254,500);d$(e);w=f[g>>2]|16384;x=f[i>>2]|0;y=f[s>>2]|0;z=f[l>>2]|0}else{w=1124024320;x=h;y=r;z=o}f[g>>2]=w;f[y>>2]=x;f[y+4>>2]=1;y=z+(Y(f[a>>2]|0,x)|0)|0;f[m>>2]=y;f[n>>2]=y+(0-x)+x;x=e+8|0;f[x>>2]=0;f[x+4>>2]=0;f[e>>2]=34209792;f[e+4>>2]=c;eL(g,e);e=g+36|0;c=f[e>>2]|0;if(c|0?(x=c+12|0,c=f[x>>2]|0,f[x>>2]=c+-1,(c|0)==1):0)CR(g);f[e>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[q>>2]|0;q=0;do{f[k+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[j>>2]|0))}j=f[s>>2]|0;if((j|0)==(r|0)){u=d;return}ZF(j);u=d;return}function Lqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/20|0)>>>0>=b>>>0){h=g;i=b;do{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;h=(f[e>>2]|0)+20|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=(g-i|0)/20|0;g=h+b|0;if(g>>>0>214748364)gXa(a);j=(d-i|0)/20|0;i=j<<1;d=j>>>0<107374182?(i>>>0<g>>>0?g:i):214748364;do if(d)if(d>>>0>214748364){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{k=NYa(d*20|0)|0;break}else k=0;while(0);i=k+(h*20|0)|0;h=i;g=k+(d*20|0)|0;d=i;k=b;b=h;do{f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;d=b+20|0;b=d;k=k+-1|0}while((k|0)!=0);k=g;g=f[a>>2]|0;d=f[e>>2]|0;if((d|0)==(g|0)){l=h;m=g}else{j=i;i=d;d=h;do{h=i;i=i+-20|0;f[j+-20>>2]=f[i>>2];f[j+-16>>2]=f[h+-16>>2];f[j+-12>>2]=f[h+-12>>2];n=h+-8|0;h=f[n+4>>2]|0;o=j+-8|0;f[o>>2]=f[n>>2];f[o+4>>2]=h;j=d+-20|0;d=j}while((i|0)!=(g|0));l=d;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=b;f[c>>2]=k;if(!m)return;PYa(m);return}function Mqa(a){a=a|0;PYa(a);return}function Nqa(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+8>>2]|0;if(b|0){c=f[b>>2]|0;if(c|0){d=b+4|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~(((e+-20-c|0)>>>0)/20|0)*20|0);PYa(c)}PYa(b)}ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Oqa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=76732;b=a+372|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)ki[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+376>>2]=0;b=a+364|0;c=f[b>>2]|0;if(c|0?(e=c+4|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)ki[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+368>>2]=0;b=a+356|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;g=a+360|0;f[g>>2]=0;vqa(a);return}d=c+4|0;e=f[d>>2]|0;f[d>>2]=e+-1;if((e|0)!=1){f[b>>2]=0;g=a+360|0;f[g>>2]=0;vqa(a);return}ki[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;g=a+360|0;f[g>>2]=0;vqa(a);return}function Pqa(a){a=a|0;Oqa(a);PYa(a);return}function Qqa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+64|0;g=e+8|0;h=e+16|0;i=e;f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];xqa(a,0,g)|0;g=bY(c)|0;d=(g|0)==0;if(d){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,5)|0;b[j>>0]=b[335146]|0;b[j+1>>0]=b[335147]|0;b[j+2>>0]=b[335148]|0;b[j+3>>0]=b[335149]|0;b[j+4>>0]=b[335150]|0;j$(-215,h,345363,334674,585);d$(h)}j=a+356|0;k=a+360|0;if(!(f[k>>2]|0)){l=NYa(12)|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;m=NYa(16)|0;n=m+4|0;f[n>>2]=1;f[m>>2]=76852;f[m+8>>2]=l;f[n>>2]=(f[n>>2]|0)+1;o=f[j>>2]|0;f[j>>2]=m;f[k>>2]=l;if(o|0?(l=o+4|0,j=f[l>>2]|0,f[l>>2]=j+-1,(j|0)==1):0)ki[f[(f[o>>2]|0)+8>>2]&2047](o);o=f[n>>2]|0;f[n>>2]=o+-1;if((o|0)==1)ki[f[(f[m>>2]|0)+8>>2]&2047](m)}m=a+364|0;o=a+368|0;if(!(f[o>>2]|0)){n=NYa(12)|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;j=NYa(16)|0;l=j+4|0;f[l>>2]=1;f[j>>2]=76872;f[j+8>>2]=n;f[l>>2]=(f[l>>2]|0)+1;p=f[m>>2]|0;f[m>>2]=j;f[o>>2]=n;if(p|0?(n=p+4|0,o=f[n>>2]|0,f[n>>2]=o+-1,(o|0)==1):0)ki[f[(f[p>>2]|0)+8>>2]&2047](p);p=f[l>>2]|0;f[l>>2]=p+-1;if((p|0)==1)ki[f[(f[j>>2]|0)+8>>2]&2047](j)}j=a+372|0;p=a+376|0;if(!(f[p>>2]|0)){l=NYa(12)|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;o=NYa(16)|0;n=o+4|0;f[n>>2]=1;f[o>>2]=76872;f[o+8>>2]=l;f[n>>2]=(f[n>>2]|0)+1;m=f[j>>2]|0;f[j>>2]=o;f[p>>2]=l;if(m|0?(l=m+4|0,p=f[l>>2]|0,f[l>>2]=p+-1,(p|0)==1):0)ki[f[(f[m>>2]|0)+8>>2]&2047](m);m=f[n>>2]|0;f[n>>2]=m+-1;if((m|0)==1)ki[f[(f[o>>2]|0)+8>>2]&2047](o)}o=f[k>>2]|0;m=o+4|0;n=f[m>>2]|0;p=f[o>>2]|0;l=n-p>>6;j=p;p=n;if(g>>>0<=l>>>0){if(g>>>0<l>>>0?(n=j+(g<<6)|0,(p|0)!=(n|0)):0)f[m>>2]=p+(~((p+-64-n|0)>>>6)<<6)}else dra(o,g-l|0);aY(h,f[c>>2]|0,f[c+4>>2]|0,0);c=a+380|0;b[c>>0]=0;l=f[k>>2]|0;f[a+16>>2]=0;f[a+20>>2]=0;k=a+252|0;o=a+276|0;n=f[o>>2]|0;if(n|0?(p=n+8|0,n=f[p>>2]|0,f[p>>2]=n+-1,(n|0)==1):0)k0(k);k=a+256|0;if((f[k>>2]|0)>0){n=f[a+284>>2]|0;p=0;do{f[n+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[k>>2]|0))}f[o>>2]=0;if(!d){d=h+20|0;o=i+4|0;k=0;do{p=(f[l>>2]|0)+(k<<6)|0;n=f[d>>2]|0;f[i>>2]=f[h>>2];f[o>>2]=n;era(p,i)|0;if(b[(f[l>>2]|0)+(k<<6)>>0]|0)b[c>>0]=1;k=k+1|0;cY(h)|0}while((k|0)!=(g|0))}f[a+40>>2]=b[c>>0]|0?3:2;c=a+8|0;g=(f[c>>2]|0)+-2|0;k=a+12|0;h=(f[k>>2]|0)+-2|0;f[a+408>>2]=1;f[a+412>>2]=1;f[a+416>>2]=g;f[a+420>>2]=h;h=a+32|0;g=a+36|0;l=a+24|0;i=a+28|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if(!(uU()|0)){u=e;return 1}if(((BU(wU()|0)|0)!=1?(BU(wU()|0)|0)!=2:0)?(BU(wU()|0)|0)!=3:0){u=e;return 1}f[l>>2]=8;f[i>>2]=8;i=(f[c>>2]|0)+8|0;c=(f[k>>2]|0)+8|0;f[h>>2]=i;f[g>>2]=c;if((Y(c,i)|0)<=1024){u=e;return 1}f[h>>2]=0;f[g>>2]=0;u=e;return 1}function Rqa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0;d=NYa(436)|0;e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[d+44>>2]=1124007936;e=d+52|0;g=d+84|0;h=d+48|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=d+92|0;f[d+88>>2]=e;f[e>>2]=0;f[d+96>>2]=0;f[d+100>>2]=1124007936;e=d+108|0;g=d+140|0;h=d+104|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=d+148|0;f[d+144>>2]=e;f[e>>2]=0;f[d+152>>2]=0;f[d+156>>2]=1124007936;e=d+160|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[d+188>>2]=d+164;e=d+196|0;f[d+192>>2]=e;f[d+200>>2]=0;f[e>>2]=0;f[d+204>>2]=1124007936;e=d+208|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[d+236>>2]=d+212;e=d+244|0;f[d+240>>2]=e;f[d+248>>2]=0;f[e>>2]=0;f[d+252>>2]=1124007936;e=d+256|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[d+284>>2]=d+260;e=d+292|0;f[d+288>>2]=e;f[d+296>>2]=0;f[e>>2]=0;f[d+300>>2]=1124007936;e=d+304|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[d+332>>2]=d+308;e=d+340|0;f[d+336>>2]=e;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[d>>2]=76732;e=d+356|0;g=d+24|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;h=d+392|0;i=h+40|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=4;f[d+28>>2]=2;f[d+32>>2]=0;f[d+36>>2]=0;f[d+40>>2]=0;f[d+384>>2]=0;f[d+388>>2]=0;n[d+432>>2]=0.0;g=d+380|0;b[g>>0]=0;h=NYa(16)|0;i=h+4|0;f[i>>2]=1;f[h>>2]=76832;f[h+8>>2]=d;j=h;k=d;ara(d,c)|0;l=f[c+356>>2]|0;m=f[c+360>>2]|0;if(l|0){o=l+4|0;f[o>>2]=(f[o>>2]|0)+1}o=f[e>>2]|0;f[e>>2]=l;f[d+360>>2]=m;if(o|0?(m=o+4|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)ki[f[(f[o>>2]|0)+8>>2]&2047](o);o=d+364|0;l=f[c+364>>2]|0;m=f[c+368>>2]|0;if(l|0){e=l+4|0;f[e>>2]=(f[e>>2]|0)+1}e=f[o>>2]|0;f[o>>2]=l;f[d+368>>2]=m;if(e|0?(m=e+4|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)ki[f[(f[e>>2]|0)+8>>2]&2047](e);e=d+372|0;l=f[c+372>>2]|0;m=f[c+376>>2]|0;if(l|0){o=l+4|0;f[o>>2]=(f[o>>2]|0)+1}o=f[e>>2]|0;f[e>>2]=l;f[d+376>>2]=m;if(o|0?(m=o+4|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)ki[f[(f[o>>2]|0)+8>>2]&2047](o);o=c+380|0;f[g>>2]=f[o>>2];f[g+4>>2]=f[o+4>>2];f[g+8>>2]=f[o+8>>2];f[g+12>>2]=f[o+12>>2];f[g+16>>2]=f[o+16>>2];f[g+20>>2]=f[o+20>>2];f[g+24>>2]=f[o+24>>2];f[d+408>>2]=f[c+408>>2];f[d+412>>2]=f[c+412>>2];f[d+416>>2]=f[c+416>>2];f[d+420>>2]=f[c+420>>2];o=d+424|0;d=c+424|0;f[o>>2]=f[d>>2];f[o+4>>2]=f[d+4>>2];f[o+8>>2]=f[d+8>>2];f[a>>2]=j;f[a+4>>2]=k;f[i>>2]=(f[i>>2]|0)+1;k=f[i>>2]|0;f[i>>2]=k+-1;if((k|0)!=1)return;ki[f[(f[h>>2]|0)+8>>2]&2047](h);return}function Sqa(a){a=a|0;return 0}function Tqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0.0;d=$qa(a,c)|0;c=f[b>>2]|0;if((c|0)<0){e=0;return e|0}g=f[b+4>>2]|0;if((g|0)<0){e=0;return e|0}if(((f[a+8>>2]|0)+c|0)>=(f[d+4>>2]|0)){e=0;return e|0}if(((f[a+12>>2]|0)+g|0)>=(f[d+8>>2]|0)){e=0;return e|0}b=(f[a+60>>2]|0)+(Y(f[f[a+88>>2]>>2]|0,g)|0)+(c<<2)|0;c=b+(f[d+12>>2]<<2)|0;f[a+424>>2]=c;d=c+(f[a+388>>2]<<2)|0;b=f[a+392>>2]|0;g=f[a+396>>2]|0;h=f[a+400>>2]|0;i=f[a+404>>2]|0;j=+(Y(f[a+420>>2]|0,f[a+416>>2]|0)|0);k=+((f[c+(b<<2)>>2]|0)-(f[c+(g<<2)>>2]|0)-(f[c+(h<<2)>>2]|0)+(f[c+(i<<2)>>2]|0)|0);l=+(((f[d+(b<<2)>>2]|0)-(f[d+(g<<2)>>2]|0)-(f[d+(h<<2)>>2]|0)+(f[d+(i<<2)>>2]|0)|0)>>>0)*j-k*k;if(l>0.0){k=1.0/+M(+l);n[a+432>>2]=k;e=j*k<.1;return e|0}else{n[a+432>>2]=1.0;e=0;return e|0}return 0}function Uqa(a,b){a=a|0;b=b|0;return +(+_qa(a,b))}function Vqa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+256|0;g=e+240|0;i=e+184|0;j=e+128|0;k=e+72|0;l=e+56|0;m=e+24|0;n=e;o=e+48|0;p=e+40|0;q=e+16|0;_$(g,76804);r=f[a+352>>2]|0;s=f[r>>2]|0;if((((f[r+4>>2]|0)-s|0)/20|0)>>>0<=c>>>0)hXa(r);r=s;s=a+380|0;t=a+16|0;v=(Y(f[a+20>>2]|0,f[t>>2]|0)|0)<<h[s>>0];w=a+388|0;f[w>>2]=v;if((NS(d)|0)!=655360){v=r+(c*20|0)+4|0;f[o>>2]=f[v>>2];x=r+(c*20|0)+8|0;f[o+4>>2]=f[x>>2];y=a+92|0;CN(i,o,4,(f[a+60>>2]|0)+(f[r+(c*20|0)+12>>2]<<2)|0,f[y>>2]|0);f[p>>2]=f[v>>2];f[p+4>>2]=f[x>>2];o=i+16|0;z=i+44|0;CN(j,p,4,(f[o>>2]|0)+(f[w>>2]<<2)|0,f[y>>2]|0);if(b[s>>0]|0){f[q>>2]=f[v>>2];f[q+4>>2]=f[x>>2];CN(k,q,4,(f[o>>2]|0)+(f[a+384>>2]<<2)|0,f[y>>2]|0);y=l+8|0;f[y>>2]=0;f[y+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=i;y=m+8|0;f[y>>2]=0;f[y+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=j;y=n+8|0;f[y>>2]=0;f[y+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=k;aqa(d,l,m,n,4,4);y=k+36|0;q=f[y>>2]|0;if(q|0?(x=q+12|0,q=f[x>>2]|0,f[x>>2]=q+-1,(q|0)==1):0)CR(k);f[y>>2]=0;y=k+16|0;q=k+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[q>>2]|0)>0){y=f[k+40>>2]|0;x=0;do{f[y+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[q>>2]|0))}q=f[k+44>>2]|0;if((q|0)!=(k+48|0))ZF(q)}else{q=k+8|0;f[q>>2]=0;f[q+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=i;q=l+8|0;f[q>>2]=0;f[q+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=j;aqa(d,k,l,fT()|0,4,4)}q=j+36|0;x=f[q>>2]|0;if(x|0?(y=x+12|0,x=f[y>>2]|0,f[y>>2]=x+-1,(x|0)==1):0)CR(j);f[q>>2]=0;q=j+16|0;x=j+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[x>>2]|0)>0){q=f[j+40>>2]|0;y=0;do{f[q+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[x>>2]|0))}x=f[j+44>>2]|0;if((x|0)!=(j+48|0))ZF(x);x=i+36|0;y=f[x>>2]|0;if(y|0?(q=y+12|0,y=f[q>>2]|0,f[q>>2]=y+-1,(y|0)==1):0)CR(i);f[x>>2]=0;x=i+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[x>>2]|0)>0){o=f[i+40>>2]|0;y=0;do{f[o+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[x>>2]|0))}x=f[z>>2]|0;if((x|0)!=(i+48|0))ZF(x)}else{x=f[r+(c*20|0)+12>>2]|0;z=f[t>>2]|0;y=(x|0)%(z|0)|0;o=(x|0)/(z|0)|0;x=f[w>>2]|0;w=a+204|0;q=r+(c*20|0)+4|0;v=f[q>>2]|0;p=r+(c*20|0)+8|0;c=f[p>>2]|0;f[j>>2]=y;f[j+4>>2]=o;f[j+8>>2]=v;f[j+12>>2]=c;g0(i,w,j);c=f[q>>2]|0;v=f[p>>2]|0;f[k>>2]=y;f[k+4>>2]=((x|0)/(z|0)|0)+o;f[k+8>>2]=c;f[k+12>>2]=v;g0(j,w,k);f[j>>2]=f[j>>2]&-8|4;do if(!(b[s>>0]|0)){v=j+24|0;c=f[v>>2]|0;z=k+8|0;f[z>>2]=0;f[z+4>>2]=0;f[k>>2]=34209792;f[k+4>>2]=i;z=l+8|0;f[z>>2]=0;f[z+4>>2]=0;f[l>>2]=34209792;f[l+4>>2]=j;aqa(d,k,l,fT()|0,4,4);if(((f[v>>2]|0)==(c|0)?(c=f[j+32>>2]|0,(f[c>>2]|0)==(f[p>>2]|0)?(f[c+4>>2]|0)==(f[q>>2]|0):0):0)?(f[j>>2]&4095|0)==4:0)break;f[k>>2]=0;f[k+4>>2]=0;c=c$(k,56)|0;v=334811;z=c+56|0;do{b[c>>0]=b[v>>0]|0;c=c+1|0;v=v+1|0}while((c|0)<(z|0));j$(-215,k,334868,334674,659);d$(k)}else{v=((f[a+384>>2]|0)/(f[t>>2]|0)|0)+o|0;c=f[q>>2]|0;z=f[p>>2]|0;f[l>>2]=y;f[l+4>>2]=v;f[l+8>>2]=c;f[l+12>>2]=z;g0(k,w,l);z=l+8|0;f[z>>2]=0;f[z+4>>2]=0;f[l>>2]=34209792;f[l+4>>2]=i;z=m+8|0;f[z>>2]=0;f[z+4>>2]=0;f[m>>2]=34209792;f[m+4>>2]=j;z=n+8|0;f[z>>2]=0;f[z+4>>2]=0;f[n>>2]=34209792;f[n+4>>2]=k;aqa(d,l,m,n,4,4);j0(k)}while(0);j0(j);j0(i)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Wqa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+16|0;d=c;_$(d,76784);e=f[a+16>>2]|0;if(b[a+380>>0]|0){g=Y(f[a+20>>2]|0,e)|0;f[a+384>>2]=g}g=f[a+408>>2]|0;h=f[a+412>>2]|0;i=Y(h,e)|0;f[a+392>>2]=i+g;j=(f[a+416>>2]|0)+g|0;f[a+396>>2]=j+i;i=Y((f[a+420>>2]|0)+h|0,e)|0;f[a+400>>2]=i+g;f[a+404>>2]=j+i;i=f[a+360>>2]|0;j=(f[i+4>>2]|0)-(f[i>>2]|0)>>6;g=a+368|0;h=f[g>>2]|0;k=h+4|0;l=f[k>>2]|0;m=f[h>>2]|0;n=l-m>>6;o=m;m=l;if(j>>>0<=n>>>0){if(j>>>0<n>>>0?(l=o+(j<<6)|0,(m|0)!=(l|0)):0)f[k>>2]=m+(~((m+-64-l|0)>>>6)<<6);l=f[h>>2]|0;m=a+428|0;f[m>>2]=l;if(!j)p=1;else{q=l;r=m;s=9}}else{Xqa(h,j-n|0);n=f[f[g>>2]>>2]|0;g=a+428|0;f[g>>2]=n;q=n;r=g;s=9}if((s|0)==9){s=a+384|0;Yqa(q,f[i>>2]|0,e,f[s>>2]|0);if((j|0)==1)p=0;else{q=1;do{Yqa((f[r>>2]|0)+(q<<6)|0,(f[i>>2]|0)+(q<<6)|0,e,f[s>>2]|0);q=q+1|0}while((q|0)!=(j|0));p=0}}q=a+376|0;s=f[q>>2]|0;r=s+4|0;g=f[r>>2]|0;n=f[s>>2]|0;h=g-n>>6;m=n;n=g;if(j>>>0<=h>>>0)if(j>>>0<h>>>0?(g=m+(j<<6)|0,(n|0)!=(g|0)):0){f[r>>2]=n+(~((n+-64-g|0)>>>6)<<6);t=s}else t=s;else{Xqa(s,j-h|0);t=f[q>>2]|0}a:do if(p)v=t;else{h=a+32|0;s=a+384|0;g=t;n=0;while(1){r=f[g>>2]|0;if((f[g+4>>2]|0)-r>>6>>>0<=n>>>0)break;m=f[h>>2]|0;Yqa(r+(n<<6)|0,(f[i>>2]|0)+(n<<6)|0,(m|0)>0?m:e,f[s>>2]|0);n=n+1|0;m=f[q>>2]|0;if(n>>>0>=j>>>0){v=m;break a}else g=m}hXa(g)}while(0);Zqa(v,a+252|0);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function Xqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>6>>>0>=b>>>0){h=g;i=b;do{j=h;k=j+60|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));h=(f[e>>2]|0)+64|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=g-i>>6;g=h+b|0;if(g>>>0>67108863)gXa(a);l=d-i|0;i=l>>5;d=l>>6>>>0<33554431?(i>>>0<g>>>0?g:i):67108863;do if(d)if(d>>>0>67108863){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{m=NYa(d<<6)|0;break}else m=0;while(0);i=m+(h<<6)|0;h=m+(d<<6)|0;d=i;m=b;b=i;do{j=d;k=j+60|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));d=b+64|0;b=d;m=m+-1|0}while((m|0)!=0);m=f[a>>2]|0;d=(f[e>>2]|0)-m|0;j=i+(0-(d>>6)<<6)|0;if((d|0)>0)K1a(j|0,m|0,d|0)|0;f[a>>2]=j;f[e>>2]=b;f[c>>2]=h;if(!m)return;PYa(m);return}function Yqa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f[a+48>>2]=f[c+20>>2];g=c+24|0;f[a+52>>2]=f[c+40>>2];h=c+44|0;f[a+56>>2]=f[c+60>>2];i=c+4|0;j=f[i>>2]|0;if(!(b[c>>0]|0)){k=c+8|0;l=(Y(f[k>>2]|0,d)|0)+j|0;f[a>>2]=l;l=c+12|0;m=(f[l>>2]|0)+(f[i>>2]|0)+(Y(f[k>>2]|0,d)|0)|0;f[a+4>>2]=m;m=c+16|0;n=(Y((f[m>>2]|0)+(f[k>>2]|0)|0,d)|0)+(f[i>>2]|0)|0;f[a+8>>2]=n;n=(f[l>>2]|0)+(f[i>>2]|0)+(Y((f[m>>2]|0)+(f[k>>2]|0)|0,d)|0)|0;f[a+12>>2]=n;n=c+28|0;k=(Y(f[n>>2]|0,d)|0)+(f[g>>2]|0)|0;f[a+16>>2]=k;k=c+32|0;m=(f[k>>2]|0)+(f[g>>2]|0)+(Y(f[n>>2]|0,d)|0)|0;f[a+20>>2]=m;m=c+36|0;l=(Y((f[m>>2]|0)+(f[n>>2]|0)|0,d)|0)+(f[g>>2]|0)|0;f[a+24>>2]=l;l=(f[k>>2]|0)+(f[g>>2]|0)+(Y((f[m>>2]|0)+(f[n>>2]|0)|0,d)|0)|0;f[a+28>>2]=l;l=c+48|0;n=(Y(f[l>>2]|0,d)|0)+(f[h>>2]|0)|0;f[a+32>>2]=n;n=c+52|0;m=(f[n>>2]|0)+(f[h>>2]|0)+(Y(f[l>>2]|0,d)|0)|0;f[a+36>>2]=m;m=c+56|0;k=(Y((f[m>>2]|0)+(f[l>>2]|0)|0,d)|0)+(f[h>>2]|0)|0;f[a+40>>2]=k;o=f[l>>2]|0;p=f[m>>2]|0;q=(f[n>>2]|0)+(f[h>>2]|0)|0;r=p+o|0;s=Y(r,d)|0;t=s+q|0;u=a+44|0;f[u>>2]=t;return}else{n=c+8|0;m=j+e+(Y(f[n>>2]|0,d)|0)|0;f[a>>2]=m;m=c+16|0;j=f[m>>2]|0;l=(f[i>>2]|0)+e-j+(Y((f[n>>2]|0)+j|0,d)|0)|0;f[a+4>>2]=l;l=c+12|0;j=f[l>>2]|0;k=(f[i>>2]|0)+e+j+(Y((f[n>>2]|0)+j|0,d)|0)|0;f[a+8>>2]=k;k=f[l>>2]|0;l=f[m>>2]|0;m=(f[i>>2]|0)+e+k-l+(Y(l+k+(f[n>>2]|0)|0,d)|0)|0;f[a+12>>2]=m;m=c+28|0;n=(f[g>>2]|0)+e+(Y(f[m>>2]|0,d)|0)|0;f[a+16>>2]=n;n=c+36|0;k=f[n>>2]|0;l=(f[g>>2]|0)+e-k+(Y((f[m>>2]|0)+k|0,d)|0)|0;f[a+20>>2]=l;l=c+32|0;k=f[l>>2]|0;i=(f[g>>2]|0)+e+k+(Y((f[m>>2]|0)+k|0,d)|0)|0;f[a+24>>2]=i;i=f[l>>2]|0;l=f[n>>2]|0;n=(f[g>>2]|0)+e+i-l+(Y(l+i+(f[m>>2]|0)|0,d)|0)|0;f[a+28>>2]=n;n=c+48|0;m=(f[h>>2]|0)+e+(Y(f[n>>2]|0,d)|0)|0;f[a+32>>2]=m;m=c+56|0;i=f[m>>2]|0;l=(f[h>>2]|0)+e-i+(Y((f[n>>2]|0)+i|0,d)|0)|0;f[a+36>>2]=l;l=c+52|0;c=f[l>>2]|0;i=(f[h>>2]|0)+e+c+(Y((f[n>>2]|0)+c|0,d)|0)|0;f[a+40>>2]=i;i=f[l>>2]|0;l=f[m>>2]|0;o=(f[n>>2]|0)+i|0;p=l;q=(f[h>>2]|0)+e+i-l|0;r=p+o|0;s=Y(r,d)|0;t=s+q|0;u=a+44|0;f[u>>2]=t;return}}function Zqa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+80|0;e=d+56|0;g=d;h=f[a>>2]|0;i=a+4|0;j=f[i>>2]|0;if((h|0)==(j|0)){k=c+24|0;l=f[k>>2]|0;if(l|0?(m=l+8|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)k0(c);l=c+4|0;if((f[l>>2]|0)>0){m=f[c+32>>2]|0;n=0;do{f[m+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[l>>2]|0))}f[k>>2]=0;o=f[i>>2]|0;p=f[a>>2]|0}else{o=j;p=h}h=o-p|0;o=p;f[g>>2]=1124007936;j=g+4|0;f[j>>2]=2;a=g+8|0;f[a>>2]=1;i=g+12|0;f[i>>2]=h;k=g+16|0;f[k>>2]=o;l=g+20|0;f[l>>2]=o;n=g+24|0;m=g+28|0;q=g+40|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[q>>2]=a;r=g+48|0;s=g+44|0;f[s>>2]=r;f[g+52>>2]=0;f[r>>2]=0;if((p|0)==0&(h|0)!=0){f[e>>2]=0;f[e+4>>2]=0;p=c$(e,26)|0;t=358223;v=p+26|0;do{b[p>>0]=b[t>>0]|0;p=p+1|0;t=t+1|0}while((p|0)<(v|0));j$(-215,e,358250,358254,500);d$(e);w=f[g>>2]|16384;x=f[i>>2]|0;y=f[s>>2]|0;z=f[l>>2]|0}else{w=1124024320;x=h;y=r;z=o}f[g>>2]=w;f[y>>2]=x;f[y+4>>2]=1;y=z+(Y(f[a>>2]|0,x)|0)|0;f[m>>2]=y;f[n>>2]=y+(0-x)+x;x=e+8|0;f[x>>2]=0;f[x+4>>2]=0;f[e>>2]=34209792;f[e+4>>2]=c;eL(g,e);e=g+36|0;c=f[e>>2]|0;if(c|0?(x=c+12|0,c=f[x>>2]|0,f[x>>2]=c+-1,(c|0)==1):0)CR(g);f[e>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[q>>2]|0;q=0;do{f[k+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[j>>2]|0))}j=f[s>>2]|0;if((j|0)==(r|0)){u=d;return}ZF(j);u=d;return}function _qa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,g=0.0,h=0.0,i=0,j=0.0,k=0.0;c=f[a+428>>2]|0;d=f[a+424>>2]|0;e=+n[c+(b<<6)+48>>2]*+((f[d+(f[c+(b<<6)>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+4>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+8>>2]<<2)>>2]|0)+(f[d+(f[c+(b<<6)+12>>2]<<2)>>2]|0)|0)+ +n[c+(b<<6)+52>>2]*+((f[d+(f[c+(b<<6)+16>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+20>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+24>>2]<<2)>>2]|0)+(f[d+(f[c+(b<<6)+28>>2]<<2)>>2]|0)|0);g=+n[c+(b<<6)+56>>2];if(!(g!=0.0)){h=e;i=a+432|0;j=+n[i>>2];k=h*j;return +k}h=e+g*+((f[d+(f[c+(b<<6)+32>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+36>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+40>>2]<<2)>>2]|0)+(f[d+(f[c+(b<<6)+44>>2]<<2)>>2]|0)|0);i=a+432|0;j=+n[i>>2];k=h*j;return +k}function $qa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;if((c|0)>-1?(g=f[a+352>>2]|0,h=f[g+4>>2]|0,i=f[g>>2]|0,((h-i|0)/20|0|0)>(c|0)):0){j=i;k=h;l=g}else{f[e>>2]=0;f[e+4>>2]=0;g=c$(e,50)|0;h=334949;i=g+50|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j$(-215,e,335e3,335013,46);d$(e);e=f[a+352>>2]|0;j=f[e>>2]|0;k=f[e+4>>2]|0;l=e}if(((k-j|0)/20|0)>>>0>c>>>0){u=d;return j+(c*20|0)|0}else hXa(l);return 0}function ara(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];f[a+36>>2]=f[b+36>>2];f[a+40>>2]=f[b+40>>2];c=a+44|0;d=b+44|0;e=(a|0)==(b|0);do if(!e){g=b+80|0;h=f[g>>2]|0;if(h|0){i=h+12|0;f[i>>2]=(f[i>>2]|0)+1}i=a+80|0;h=f[i>>2]|0;if(h|0?(j=h+12|0,h=f[j>>2]|0,f[j>>2]=h+-1,(h|0)==1):0)CR(c);f[i>>2]=0;h=a+60|0;j=a+48|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[j>>2]|0)>0){k=f[a+84>>2]|0;l=0;do{f[k+(l<<2)>>2]=0;l=l+1|0;m=f[j>>2]|0}while((l|0)<(m|0));f[c>>2]=f[d>>2];if((m|0)<3)n=12;else n=14}else{f[c>>2]=f[d>>2];n=12}if((n|0)==12){l=f[b+48>>2]|0;if((l|0)<3){f[j>>2]=l;f[a+52>>2]=f[b+52>>2];f[a+56>>2]=f[b+56>>2];l=f[b+88>>2]|0;k=f[a+88>>2]|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2]}else n=14}if((n|0)==14)BR(c,d);f[h>>2]=f[b+60>>2];f[a+64>>2]=f[b+64>>2];f[a+68>>2]=f[b+68>>2];f[a+72>>2]=f[b+72>>2];f[a+76>>2]=f[b+76>>2];f[i>>2]=f[g>>2];l=a+100|0;k=b+100|0;if(!e){o=b+136|0;p=f[o>>2]|0;if(p|0){q=p+12|0;f[q>>2]=(f[q>>2]|0)+1}q=a+136|0;p=f[q>>2]|0;if(p|0?(r=p+12|0,p=f[r>>2]|0,f[r>>2]=p+-1,(p|0)==1):0)CR(l);f[q>>2]=0;p=a+116|0;r=a+104|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[r>>2]|0)>0){s=f[a+140>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0;u=f[r>>2]|0}while((t|0)<(u|0));f[l>>2]=f[k>>2];if((u|0)<3)n=26;else n=28}else{f[l>>2]=f[k>>2];n=26}if((n|0)==26){t=f[b+104>>2]|0;if((t|0)<3){f[r>>2]=t;f[a+108>>2]=f[b+108>>2];f[a+112>>2]=f[b+112>>2];t=f[b+144>>2]|0;s=f[a+144>>2]|0;f[s>>2]=f[t>>2];f[s+4>>2]=f[t+4>>2]}else n=28}if((n|0)==28)BR(l,k);f[p>>2]=f[b+116>>2];f[a+120>>2]=f[b+120>>2];f[a+124>>2]=f[b+124>>2];f[a+128>>2]=f[b+128>>2];f[a+132>>2]=f[b+132>>2];f[q>>2]=f[o>>2];t=a+156|0;s=b+156|0;if(!e){g=b+180|0;i=f[g>>2]|0;if(i|0){h=i+8|0;f[h>>2]=(f[h>>2]|0)+1}h=a+180|0;i=f[h>>2]|0;if(i|0?(j=i+8|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)k0(t);i=a+160|0;if((f[i>>2]|0)>0){j=f[a+188>>2]|0;v=0;do{f[j+(v<<2)>>2]=0;v=v+1|0;w=f[i>>2]|0}while((v|0)<(w|0));f[h>>2]=0;f[t>>2]=f[s>>2];if((w|0)<3)n=40;else n=42}else{f[h>>2]=0;f[t>>2]=f[s>>2];n=40}if((n|0)==40){v=f[b+160>>2]|0;if((v|0)<3){f[i>>2]=v;f[a+164>>2]=f[b+164>>2];f[a+168>>2]=f[b+168>>2];v=f[b+192>>2]|0;j=f[a+192>>2]|0;f[j>>2]=f[v>>2];f[j+4>>2]=f[v+4>>2]}else n=42}if((n|0)==42)i0(t,s);f[a+172>>2]=f[b+172>>2];v=a+176|0;if(!(f[v>>2]|0))f[v>>2]=f[b+176>>2];f[h>>2]=f[g>>2];f[a+184>>2]=f[b+184>>2];v=a+204|0;j=b+204|0;if(!e){o=b+228|0;q=f[o>>2]|0;if(q|0){p=q+8|0;f[p>>2]=(f[p>>2]|0)+1}p=a+228|0;q=f[p>>2]|0;if(q|0?(k=q+8|0,q=f[k>>2]|0,f[k>>2]=q+-1,(q|0)==1):0)k0(v);q=a+208|0;if((f[q>>2]|0)>0){k=f[a+236>>2]|0;l=0;do{f[k+(l<<2)>>2]=0;l=l+1|0;x=f[q>>2]|0}while((l|0)<(x|0));f[p>>2]=0;f[v>>2]=f[j>>2];if((x|0)<3)n=56;else n=58}else{f[p>>2]=0;f[v>>2]=f[j>>2];n=56}if((n|0)==56){l=f[b+208>>2]|0;if((l|0)<3){f[q>>2]=l;f[a+212>>2]=f[b+212>>2];f[a+216>>2]=f[b+216>>2];l=f[b+240>>2]|0;k=f[a+240>>2]|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2]}else n=58}if((n|0)==58)i0(v,j);f[a+220>>2]=f[b+220>>2];l=a+224|0;if(!(f[l>>2]|0))f[l>>2]=f[b+224>>2];f[p>>2]=f[o>>2];f[a+232>>2]=f[b+232>>2];l=a+252|0;k=b+252|0;if(!e){g=b+276|0;h=f[g>>2]|0;if(h|0){s=h+8|0;f[s>>2]=(f[s>>2]|0)+1}s=a+276|0;h=f[s>>2]|0;do if(h|0){t=h+8|0;i=f[t>>2]|0;f[t>>2]=i+-1;if((i|0)!=1)break;k0(l)}while(0);h=a+256|0;if((f[h>>2]|0)>0){o=f[a+284>>2]|0;p=0;do{f[o+(p<<2)>>2]=0;p=p+1|0;y=f[h>>2]|0}while((p|0)<(y|0));f[s>>2]=0;f[l>>2]=f[k>>2];if((y|0)<3)n=72;else n=74}else{f[s>>2]=0;f[l>>2]=f[k>>2];n=72}do if((n|0)==72){p=f[b+256>>2]|0;if((p|0)>=3){n=74;break}f[h>>2]=p;f[a+260>>2]=f[b+260>>2];f[a+264>>2]=f[b+264>>2];p=f[b+288>>2]|0;o=f[a+288>>2]|0;f[o>>2]=f[p>>2];f[o+4>>2]=f[p+4>>2]}while(0);if((n|0)==74)i0(l,k);f[a+268>>2]=f[b+268>>2];h=a+272|0;if(!(f[h>>2]|0))f[h>>2]=f[b+272>>2];f[s>>2]=f[g>>2];f[a+280>>2]=f[b+280>>2];h=a+300|0;p=b+300|0;if(e)break;o=b+324|0;j=f[o>>2]|0;if(j|0){v=j+8|0;f[v>>2]=(f[v>>2]|0)+1}v=a+324|0;j=f[v>>2]|0;do if(j|0){q=j+8|0;i=f[q>>2]|0;f[q>>2]=i+-1;if((i|0)!=1)break;k0(h)}while(0);j=a+304|0;if((f[j>>2]|0)>0){g=f[a+332>>2]|0;s=0;do{f[g+(s<<2)>>2]=0;s=s+1|0;z=f[j>>2]|0}while((s|0)<(z|0));f[v>>2]=0;f[h>>2]=f[p>>2];if((z|0)<3)n=88;else n=90}else{f[v>>2]=0;f[h>>2]=f[p>>2];n=88}do if((n|0)==88){s=f[b+304>>2]|0;if((s|0)>=3){n=90;break}f[j>>2]=s;f[a+308>>2]=f[b+308>>2];f[a+312>>2]=f[b+312>>2];s=f[b+336>>2]|0;g=f[a+336>>2]|0;f[g>>2]=f[s>>2];f[g+4>>2]=f[s+4>>2]}while(0);if((n|0)==90)i0(h,p);f[a+316>>2]=f[b+316>>2];j=a+320|0;if(!(f[j>>2]|0))f[j>>2]=f[b+320>>2];f[v>>2]=f[o>>2];f[a+328>>2]=f[b+328>>2]}}}}}while(0);n=a+348|0;z=f[b+348>>2]|0;e=f[b+352>>2]|0;if(z|0){b=z+4|0;f[b>>2]=(f[b>>2]|0)+1}b=f[n>>2]|0;f[n>>2]=z;f[a+352>>2]=e;if(!b)return a|0;e=b+4|0;z=f[e>>2]|0;f[e>>2]=z+-1;if((z|0)!=1)return a|0;ki[f[(f[b>>2]|0)+8>>2]&2047](b);return a|0}function bra(a){a=a|0;PYa(a);return}function cra(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function dra(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>6>>>0>=c>>>0){i=h;j=c;do{b[i>>0]=0;k=i+4|0;l=k+60|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));i=(f[g>>2]|0)+64|0;f[g>>2]=i;j=j+-1|0}while((j|0)!=0);return}j=f[a>>2]|0;i=h-j>>6;h=i+c|0;if(h>>>0>67108863)gXa(a);m=e-j|0;j=m>>5;e=m>>6>>>0<33554431?(j>>>0<h>>>0?h:j):67108863;do if(e)if(e>>>0>67108863){j=De(8)|0;UYa(j,358155);f[j>>2]=130560;Of(j|0,21520,875)}else{n=NYa(e<<6)|0;break}else n=0;while(0);j=n+(i<<6)|0;i=j;h=n+(e<<6)|0;e=j;n=c;c=i;do{b[e>>0]=0;k=e+4|0;l=k+60|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));e=c+64|0;c=e;n=n+-1|0}while((n|0)!=0);n=h;h=f[a>>2]|0;e=f[g>>2]|0;k=h;if((e|0)==(h|0)){o=i;p=k}else{i=e+-64-k|0;k=j;l=e;while(1){e=l;l=l+-64|0;b[k+-64>>0]=b[l>>0]|0;f[k+-60>>2]=f[e+-60>>2];f[k+-56>>2]=f[e+-56>>2];f[k+-52>>2]=f[e+-52>>2];f[k+-48>>2]=f[e+-48>>2];f[k+-44>>2]=f[e+-44>>2];f[k+-40>>2]=f[e+-40>>2];f[k+-36>>2]=f[e+-36>>2];f[k+-32>>2]=f[e+-32>>2];f[k+-28>>2]=f[e+-28>>2];f[k+-24>>2]=f[e+-24>>2];f[k+-20>>2]=f[e+-20>>2];f[k+-16>>2]=f[e+-16>>2];f[k+-12>>2]=f[e+-12>>2];f[k+-8>>2]=f[e+-8>>2];f[k+-4>>2]=f[e+-4>>2];if((l|0)==(h|0))break;else k=k+-64|0}o=j+(~(i>>>6)<<6)|0;p=f[a>>2]|0}f[a>>2]=o;f[g>>2]=c;f[d>>2]=n;if(!p)return;PYa(p);return}
function vK(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0,s=0,t=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>2;b=h>>>1;h=c+-1|0;if(!c)return;if((e|0)<4){if((e|0)>0){m=h;o=g;q=a}else return;while(1){c=0;do{i=wNa(l+k*+n[q+(c<<2)>>2])|0;d[o+(c<<1)>>1]=(i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768;c=c+1|0}while((c|0)!=(e|0));if(!m)break;else{m=m+-1|0;o=o+(b<<1)|0;q=q+(j<<2)|0}}return}q=e+-4|0;o=(((q|0)>3?q:3)&2147483644)+4|0;m=(o|0)<(e|0);c=h;h=g;g=a;while(1){a=0;do{i=wNa(l+k*+n[g+(a<<2)>>2])|0;r=a|1;s=wNa(l+k*+n[g+(r<<2)>>2])|0;d[h+(a<<1)>>1]=(i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768;d[h+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;s=a|2;r=wNa(l+k*+n[g+(s<<2)>>2])|0;i=a|3;t=wNa(l+k*+n[g+(i<<2)>>2])|0;d[h+(s<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;d[h+(i<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;a=a+4|0}while((a|0)<=(q|0));if(m){a=o;do{t=wNa(l+k*+n[g+(a<<2)>>2])|0;d[h+(a<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;a=a+1|0}while((a|0)!=(e|0))}if(!c)break;else{c=c+-1|0;h=h+(b<<1)|0;g=g+(j<<2)|0}}return}function wK(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;c=f[i+4>>2]|0;i=b>>>3;b=h>>>1;h=c+-1|0;if(!c)return;k=+p[j>>3];l=+p[j+8>>3];if((e|0)<4){if((e|0)>0){m=h;n=g;o=a}else return;while(1){j=0;do{c=rNa(l+k*+p[o+(j<<3)>>3])|0;d[n+(j<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;j=j+1|0}while((j|0)!=(e|0));if(!m)break;else{m=m+-1|0;n=n+(b<<1)|0;o=o+(i<<3)|0}}return}o=e+-4|0;n=(((o|0)>3?o:3)&2147483644)+4|0;m=(n|0)<(e|0);j=h;h=g;g=a;while(1){a=0;do{c=rNa(l+k*+p[g+(a<<3)>>3])|0;q=a|1;r=rNa(l+k*+p[g+(q<<3)>>3])|0;d[h+(a<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;d[h+(q<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;r=a|2;q=rNa(l+k*+p[g+(r<<3)>>3])|0;c=a|3;s=rNa(l+k*+p[g+(c<<3)>>3])|0;d[h+(r<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;d[h+(c<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;a=a+4|0}while((a|0)<=(o|0));if(m){a=n;do{s=rNa(l+k*+p[g+(a<<3)>>3])|0;d[h+(a<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;a=a+1|0}while((a|0)!=(e|0))}if(!j)break;else{j=j+-1|0;h=h+(b<<1)|0;g=g+(i<<3)|0}}return}function xK(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;d=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=g>>>2;if(!c)return;g=d+-4|0;if((d|0)<4){i=(d|0)>0;m=c;n=e;o=a;while(1){m=m+-1|0;if(i){q=0;do{r=wNa(l+k*+(h[o+q>>0]|0))|0;f[n+(q<<2)>>2]=r;q=q+1|0}while((q|0)!=(d|0))}if(!m)break;else{n=n+(j<<2)|0;o=o+b|0}}return}o=d&-4;n=(o|0)<(d|0);m=c;c=e;e=a;while(1){a=0;do{i=wNa(l+k*+(h[e+a>>0]|0))|0;q=a|1;r=wNa(l+k*+(h[e+q>>0]|0))|0;f[c+(a<<2)>>2]=i;f[c+(q<<2)>>2]=r;r=a|2;q=wNa(l+k*+(h[e+r>>0]|0))|0;i=a|3;s=wNa(l+k*+(h[e+i>>0]|0))|0;f[c+(r<<2)>>2]=q;f[c+(i<<2)>>2]=s;a=a+4|0}while((a|0)<=(g|0));m=m+-1|0;if(n){a=o;do{s=wNa(l+k*+(h[e+a>>0]|0))|0;f[c+(a<<2)>>2]=s;a=a+1|0}while((a|0)!=(d|0))}if(!m)break;else{c=c+(j<<2)|0;e=e+b|0}}return}function yK(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=h>>>2;if(!d)return;h=e+-4|0;if((e|0)<4){i=(e|0)>0;m=d;n=g;o=a;while(1){m=m+-1|0;if(i){q=0;do{r=wNa(l+k*+(b[o+q>>0]|0))|0;f[n+(q<<2)>>2]=r;q=q+1|0}while((q|0)!=(e|0))}if(!m)break;else{n=n+(j<<2)|0;o=o+c|0}}return}o=e&-4;n=(o|0)<(e|0);m=d;d=g;g=a;while(1){a=0;do{i=wNa(l+k*+(b[g+a>>0]|0))|0;q=a|1;r=wNa(l+k*+(b[g+q>>0]|0))|0;f[d+(a<<2)>>2]=i;f[d+(q<<2)>>2]=r;r=a|2;q=wNa(l+k*+(b[g+r>>0]|0))|0;i=a|3;s=wNa(l+k*+(b[g+i>>0]|0))|0;f[d+(r<<2)>>2]=q;f[d+(i<<2)>>2]=s;a=a+4|0}while((a|0)<=(h|0));m=m+-1|0;if(n){a=o;do{s=wNa(l+k*+(b[g+a>>0]|0))|0;f[d+(a<<2)>>2]=s;a=a+1|0}while((a|0)!=(e|0))}if(!m)break;else{d=d+(j<<2)|0;g=g+c|0}}return}function zK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;d=f[h>>2]|0;c=f[h+4>>2]|0;k=+p[i>>3];l=+p[i+8>>3];i=b>>>1;b=g>>>2;if(!c)return;g=d+-4|0;if((d|0)<4){h=(d|0)>0;m=c;n=e;o=a;while(1){m=m+-1|0;if(h){q=0;do{r=wNa(l+k*+(j[o+(q<<1)>>1]|0))|0;f[n+(q<<2)>>2]=r;q=q+1|0}while((q|0)!=(d|0))}if(!m)break;else{n=n+(b<<2)|0;o=o+(i<<1)|0}}return}o=d&-4;n=(o|0)<(d|0);m=c;c=e;e=a;while(1){a=0;do{h=wNa(l+k*+(j[e+(a<<1)>>1]|0))|0;q=a|1;r=wNa(l+k*+(j[e+(q<<1)>>1]|0))|0;f[c+(a<<2)>>2]=h;f[c+(q<<2)>>2]=r;r=a|2;q=wNa(l+k*+(j[e+(r<<1)>>1]|0))|0;h=a|3;s=wNa(l+k*+(j[e+(h<<1)>>1]|0))|0;f[c+(r<<2)>>2]=q;f[c+(h<<2)>>2]=s;a=a+4|0}while((a|0)<=(g|0));m=m+-1|0;if(n){a=o;do{s=wNa(l+k*+(j[e+(a<<1)>>1]|0))|0;f[c+(a<<2)>>2]=s;a=a+1|0}while((a|0)!=(d|0))}if(!m)break;else{c=c+(b<<2)|0;e=e+(i<<1)|0}}return}function AK(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>1;b=h>>>2;if((c|0)!=0&(e|0)>0){m=c;n=g;o=a}else return;while(1){a=0;do{g=wNa(l+k*+(d[o+(a<<1)>>1]|0))|0;f[n+(a<<2)>>2]=g;a=a+1|0}while((a|0)!=(e|0));m=m+-1|0;if(!m)break;else{n=n+(b<<2)|0;o=o+(j<<1)|0}}return}function BK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>2;if(!c)return;g=d+-4|0;if((d|0)<4){h=(d|0)>0;l=c;m=e;n=a;while(1){l=l+-1|0;if(h){o=0;do{q=rNa(k+j*+(f[n+(o<<2)>>2]|0))|0;f[m+(o<<2)>>2]=q;o=o+1|0}while((o|0)!=(d|0))}if(!l)break;else{m=m+(b<<2)|0;n=n+(i<<2)|0}}return}n=d&-4;m=(n|0)<(d|0);l=c;c=e;e=a;while(1){a=0;do{h=rNa(k+j*+(f[e+(a<<2)>>2]|0))|0;o=a|1;q=rNa(k+j*+(f[e+(o<<2)>>2]|0))|0;f[c+(a<<2)>>2]=h;f[c+(o<<2)>>2]=q;q=a|2;o=rNa(k+j*+(f[e+(q<<2)>>2]|0))|0;h=a|3;r=rNa(k+j*+(f[e+(h<<2)>>2]|0))|0;f[c+(q<<2)>>2]=o;f[c+(h<<2)>>2]=r;a=a+4|0}while((a|0)<=(g|0));l=l+-1|0;if(m){a=n;do{r=rNa(k+j*+(f[e+(a<<2)>>2]|0))|0;f[c+(a<<2)>>2]=r;a=a+1|0}while((a|0)!=(d|0))}if(!l)break;else{c=c+(b<<2)|0;e=e+(i<<2)|0}}return}function CK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>2;if(!c)return;g=d+-4|0;if((d|0)<4){h=(d|0)>0;l=c;m=e;o=a;while(1){l=l+-1|0;if(h){q=0;do{r=wNa(k+j*+n[o+(q<<2)>>2])|0;f[m+(q<<2)>>2]=r;q=q+1|0}while((q|0)!=(d|0))}if(!l)break;else{m=m+(b<<2)|0;o=o+(i<<2)|0}}return}o=d&-4;m=(o|0)<(d|0);l=c;c=e;e=a;while(1){a=0;do{h=wNa(k+j*+n[e+(a<<2)>>2])|0;q=a|1;r=wNa(k+j*+n[e+(q<<2)>>2])|0;f[c+(a<<2)>>2]=h;f[c+(q<<2)>>2]=r;r=a|2;q=wNa(k+j*+n[e+(r<<2)>>2])|0;h=a|3;s=wNa(k+j*+n[e+(h<<2)>>2])|0;f[c+(r<<2)>>2]=q;f[c+(h<<2)>>2]=s;a=a+4|0}while((a|0)<=(g|0));l=l+-1|0;if(m){a=o;do{s=wNa(k+j*+n[e+(a<<2)>>2])|0;f[c+(a<<2)>>2]=s;a=a+1|0}while((a|0)!=(d|0))}if(!l)break;else{c=c+(b<<2)|0;e=e+(i<<2)|0}}return}function DK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>3;b=g>>>2;if(!c)return;g=d+-4|0;if((d|0)<4){h=(d|0)>0;l=c;m=e;n=a;while(1){l=l+-1|0;if(h){o=0;do{q=rNa(k+j*+p[n+(o<<3)>>3])|0;f[m+(o<<2)>>2]=q;o=o+1|0}while((o|0)!=(d|0))}if(!l)break;else{m=m+(b<<2)|0;n=n+(i<<3)|0}}return}n=d&-4;m=(n|0)<(d|0);l=c;c=e;e=a;while(1){a=0;do{h=rNa(k+j*+p[e+(a<<3)>>3])|0;o=a|1;q=rNa(k+j*+p[e+(o<<3)>>3])|0;f[c+(a<<2)>>2]=h;f[c+(o<<2)>>2]=q;q=a|2;o=rNa(k+j*+p[e+(q<<3)>>3])|0;h=a|3;r=rNa(k+j*+p[e+(h<<3)>>3])|0;f[c+(q<<2)>>2]=o;f[c+(h<<2)>>2]=r;a=a+4|0}while((a|0)<=(g|0));l=l+-1|0;if(m){a=n;do{r=rNa(k+j*+p[e+(a<<3)>>3])|0;f[c+(a<<2)>>2]=r;a=a+1|0}while((a|0)!=(d|0))}if(!l)break;else{c=c+(b<<2)|0;e=e+(i<<3)|0}}return}function EK(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0,s=0.0;d=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=g>>>2;if(!c)return;g=d+-4|0;if((d|0)<4){i=(d|0)>0;m=c;o=e;q=a;while(1){m=m+-1|0;if(i){r=0;do{n[o+(r<<2)>>2]=l+k*+(h[q+r>>0]|0);r=r+1|0}while((r|0)!=(d|0))}if(!m)break;else{o=o+(j<<2)|0;q=q+b|0}}return}q=d&-4;o=(q|0)<(d|0);m=c;c=e;e=a;while(1){a=0;do{i=a|1;s=l+k*+(h[e+i>>0]|0);n[c+(a<<2)>>2]=l+k*+(h[e+a>>0]|0);n[c+(i<<2)>>2]=s;i=a|2;r=a|3;s=l+k*+(h[e+r>>0]|0);n[c+(i<<2)>>2]=l+k*+(h[e+i>>0]|0);n[c+(r<<2)>>2]=s;a=a+4|0}while((a|0)<=(g|0));m=m+-1|0;if(o){a=q;do{n[c+(a<<2)>>2]=l+k*+(h[e+a>>0]|0);a=a+1|0}while((a|0)!=(d|0))}if(!m)break;else{c=c+(j<<2)|0;e=e+b|0}}return}function FK(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0,s=0.0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=h>>>2;if(!d)return;h=e+-4|0;if((e|0)<4){i=(e|0)>0;m=d;o=g;q=a;while(1){m=m+-1|0;if(i){r=0;do{n[o+(r<<2)>>2]=l+k*+(b[q+r>>0]|0);r=r+1|0}while((r|0)!=(e|0))}if(!m)break;else{o=o+(j<<2)|0;q=q+c|0}}return}q=e&-4;o=(q|0)<(e|0);m=d;d=g;g=a;while(1){a=0;do{i=a|1;s=l+k*+(b[g+i>>0]|0);n[d+(a<<2)>>2]=l+k*+(b[g+a>>0]|0);n[d+(i<<2)>>2]=s;i=a|2;r=a|3;s=l+k*+(b[g+r>>0]|0);n[d+(i<<2)>>2]=l+k*+(b[g+i>>0]|0);n[d+(r<<2)>>2]=s;a=a+4|0}while((a|0)<=(h|0));m=m+-1|0;if(o){a=q;do{n[d+(a<<2)>>2]=l+k*+(b[g+a>>0]|0);a=a+1|0}while((a|0)!=(e|0))}if(!m)break;else{d=d+(j<<2)|0;g=g+c|0}}return}function GK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0;d=f[h>>2]|0;c=f[h+4>>2]|0;k=+p[i>>3];l=+p[i+8>>3];i=b>>>1;b=g>>>2;g=c+-1|0;if(!c)return;if((d|0)<4){if((d|0)>0){m=g;o=e;q=a}else return;while(1){c=0;do{n[o+(c<<2)>>2]=l+k*+(j[q+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(d|0));if(!m)break;else{m=m+-1|0;o=o+(b<<2)|0;q=q+(i<<1)|0}}return}q=d+-4|0;o=(((q|0)>3?q:3)&2147483644)+4|0;if((o|0)<(d|0)){r=g;s=e;t=a}else{m=g;g=e;e=a;while(1){a=0;do{c=a|1;u=l+k*+(j[e+(c<<1)>>1]|0);n[g+(a<<2)>>2]=l+k*+(j[e+(a<<1)>>1]|0);n[g+(c<<2)>>2]=u;c=a|2;h=a|3;u=l+k*+(j[e+(h<<1)>>1]|0);n[g+(c<<2)>>2]=l+k*+(j[e+(c<<1)>>1]|0);n[g+(h<<2)>>2]=u;a=a+4|0}while((a|0)<=(q|0));if(!m)break;else{m=m+-1|0;g=g+(b<<2)|0;e=e+(i<<1)|0}}return}while(1){e=0;do{g=e|1;u=l+k*+(j[t+(g<<1)>>1]|0);n[s+(e<<2)>>2]=l+k*+(j[t+(e<<1)>>1]|0);n[s+(g<<2)>>2]=u;g=e|2;m=e|3;u=l+k*+(j[t+(m<<1)>>1]|0);n[s+(g<<2)>>2]=l+k*+(j[t+(g<<1)>>1]|0);n[s+(m<<2)>>2]=u;e=e+4|0}while((e|0)<=(q|0));v=o;do{n[s+(v<<2)>>2]=l+k*+(j[t+(v<<1)>>1]|0);v=v+1|0}while((v|0)!=(d|0));if(!r)break;else{r=r+-1|0;s=s+(b<<2)|0;t=t+(i<<1)|0}}return}function HK(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>1;b=h>>>2;h=c+-1|0;if(!c)return;if((e|0)<4){if((e|0)>0){m=h;o=g;q=a}else return;while(1){c=0;do{n[o+(c<<2)>>2]=l+k*+(d[q+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(e|0));if(!m)break;else{m=m+-1|0;o=o+(b<<2)|0;q=q+(j<<1)|0}}return}q=e+-4|0;o=(((q|0)>3?q:3)&2147483644)+4|0;if((o|0)<(e|0)){r=h;s=g;t=a}else{m=h;h=g;g=a;while(1){a=0;do{c=a|1;u=l+k*+(d[g+(c<<1)>>1]|0);n[h+(a<<2)>>2]=l+k*+(d[g+(a<<1)>>1]|0);n[h+(c<<2)>>2]=u;c=a|2;i=a|3;u=l+k*+(d[g+(i<<1)>>1]|0);n[h+(c<<2)>>2]=l+k*+(d[g+(c<<1)>>1]|0);n[h+(i<<2)>>2]=u;a=a+4|0}while((a|0)<=(q|0));if(!m)break;else{m=m+-1|0;h=h+(b<<2)|0;g=g+(j<<1)|0}}return}while(1){g=0;do{h=g|1;u=l+k*+(d[t+(h<<1)>>1]|0);n[s+(g<<2)>>2]=l+k*+(d[t+(g<<1)>>1]|0);n[s+(h<<2)>>2]=u;h=g|2;m=g|3;u=l+k*+(d[t+(m<<1)>>1]|0);n[s+(h<<2)>>2]=l+k*+(d[t+(h<<1)>>1]|0);n[s+(m<<2)>>2]=u;g=g+4|0}while((g|0)<=(q|0));v=o;do{n[s+(v<<2)>>2]=l+k*+(d[t+(v<<1)>>1]|0);v=v+1|0}while((v|0)!=(e|0));if(!r)break;else{r=r+-1|0;s=s+(b<<2)|0;t=t+(j<<1)|0}}return}function IK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0.0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>2;if(!c)return;g=d+-4|0;h=(((g|0)>3?g:3)&2147483644)+4|0;if((d|0)<4){l=(d|0)>0;m=c;o=e;q=a;while(1){m=m+-1|0;if(l){r=0;do{n[o+(r<<2)>>2]=k+j*+(f[q+(r<<2)>>2]|0);r=r+1|0}while((r|0)!=(d|0))}if(!m)break;else{o=o+(b<<2)|0;q=q+(i<<2)|0}}return}q=(h|0)<(d|0);o=c;c=e;e=a;while(1){a=0;do{m=a|1;s=k+j*+(f[e+(m<<2)>>2]|0);n[c+(a<<2)>>2]=k+j*+(f[e+(a<<2)>>2]|0);n[c+(m<<2)>>2]=s;m=a|2;l=a|3;s=k+j*+(f[e+(l<<2)>>2]|0);n[c+(m<<2)>>2]=k+j*+(f[e+(m<<2)>>2]|0);n[c+(l<<2)>>2]=s;a=a+4|0}while((a|0)<=(g|0));o=o+-1|0;if(q){a=h;do{n[c+(a<<2)>>2]=k+j*+(f[e+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=(d|0))}if(!o)break;else{c=c+(b<<2)|0;e=e+(i<<2)|0}}return}function JK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0.0,u=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>2;g=c+-1|0;if(!c)return;if((d|0)<4){if((d|0)>0){l=g;m=e;o=a}else return;while(1){c=0;do{n[m+(c<<2)>>2]=k+j*+n[o+(c<<2)>>2];c=c+1|0}while((c|0)!=(d|0));if(!l)break;else{l=l+-1|0;m=m+(b<<2)|0;o=o+(i<<2)|0}}return}o=d+-4|0;m=(((o|0)>3?o:3)&2147483644)+4|0;if((m|0)<(d|0)){q=g;r=e;s=a}else{l=g;g=e;e=a;while(1){a=0;do{c=a|1;t=k+j*+n[e+(c<<2)>>2];n[g+(a<<2)>>2]=k+j*+n[e+(a<<2)>>2];n[g+(c<<2)>>2]=t;c=a|2;h=a|3;t=k+j*+n[e+(h<<2)>>2];n[g+(c<<2)>>2]=k+j*+n[e+(c<<2)>>2];n[g+(h<<2)>>2]=t;a=a+4|0}while((a|0)<=(o|0));if(!l)break;else{l=l+-1|0;g=g+(b<<2)|0;e=e+(i<<2)|0}}return}while(1){e=0;do{g=e|1;t=k+j*+n[s+(g<<2)>>2];n[r+(e<<2)>>2]=k+j*+n[s+(e<<2)>>2];n[r+(g<<2)>>2]=t;g=e|2;l=e|3;t=k+j*+n[s+(l<<2)>>2];n[r+(g<<2)>>2]=k+j*+n[s+(g<<2)>>2];n[r+(l<<2)>>2]=t;e=e+4|0}while((e|0)<=(o|0));u=m;do{n[r+(u<<2)>>2]=k+j*+n[s+(u<<2)>>2];u=u+1|0}while((u|0)!=(d|0));if(!q)break;else{q=q+-1|0;r=r+(b<<2)|0;s=s+(i<<2)|0}}return}function KK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0.0,u=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>3;b=g>>>2;g=c+-1|0;if(!c)return;if((d|0)<4){if((d|0)>0){l=g;m=e;o=a}else return;while(1){c=0;do{n[m+(c<<2)>>2]=k+j*+p[o+(c<<3)>>3];c=c+1|0}while((c|0)!=(d|0));if(!l)break;else{l=l+-1|0;m=m+(b<<2)|0;o=o+(i<<3)|0}}return}o=d+-4|0;m=(((o|0)>3?o:3)&2147483644)+4|0;if((m|0)<(d|0)){q=g;r=e;s=a}else{l=g;g=e;e=a;while(1){a=0;do{c=a|1;t=k+j*+p[e+(c<<3)>>3];n[g+(a<<2)>>2]=k+j*+p[e+(a<<3)>>3];n[g+(c<<2)>>2]=t;c=a|2;h=a|3;t=k+j*+p[e+(h<<3)>>3];n[g+(c<<2)>>2]=k+j*+p[e+(c<<3)>>3];n[g+(h<<2)>>2]=t;a=a+4|0}while((a|0)<=(o|0));if(!l)break;else{l=l+-1|0;g=g+(b<<2)|0;e=e+(i<<3)|0}}return}while(1){e=0;do{g=e|1;t=k+j*+p[s+(g<<3)>>3];n[r+(e<<2)>>2]=k+j*+p[s+(e<<3)>>3];n[r+(g<<2)>>2]=t;g=e|2;l=e|3;t=k+j*+p[s+(l<<3)>>3];n[r+(g<<2)>>2]=k+j*+p[s+(g<<3)>>3];n[r+(l<<2)>>2]=t;e=e+4|0}while((e|0)<=(o|0));u=m;do{n[r+(u<<2)>>2]=k+j*+p[s+(u<<3)>>3];u=u+1|0}while((u|0)!=(d|0));if(!q)break;else{q=q+-1|0;r=r+(b<<2)|0;s=s+(i<<3)|0}}return}function LK(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0.0;d=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=g>>>3;if(!c)return;g=d+-4|0;if((d|0)<4){i=(d|0)>0;m=c;n=e;o=a;while(1){m=m+-1|0;if(i){q=0;do{p[n+(q<<3)>>3]=l+k*+(h[o+q>>0]|0);q=q+1|0}while((q|0)!=(d|0))}if(!m)break;else{n=n+(j<<3)|0;o=o+b|0}}return}o=d&-4;n=(o|0)<(d|0);m=c;c=e;e=a;while(1){a=0;do{i=a|1;r=l+k*+(h[e+i>>0]|0);p[c+(a<<3)>>3]=l+k*+(h[e+a>>0]|0);p[c+(i<<3)>>3]=r;i=a|2;q=a|3;r=l+k*+(h[e+q>>0]|0);p[c+(i<<3)>>3]=l+k*+(h[e+i>>0]|0);p[c+(q<<3)>>3]=r;a=a+4|0}while((a|0)<=(g|0));m=m+-1|0;if(n){a=o;do{p[c+(a<<3)>>3]=l+k*+(h[e+a>>0]|0);a=a+1|0}while((a|0)!=(d|0))}if(!m)break;else{c=c+(j<<3)|0;e=e+b|0}}return}function MK(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0.0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=h>>>3;if(!d)return;h=e+-4|0;if((e|0)<4){i=(e|0)>0;m=d;n=g;o=a;while(1){m=m+-1|0;if(i){q=0;do{p[n+(q<<3)>>3]=l+k*+(b[o+q>>0]|0);q=q+1|0}while((q|0)!=(e|0))}if(!m)break;else{n=n+(j<<3)|0;o=o+c|0}}return}o=e&-4;n=(o|0)<(e|0);m=d;d=g;g=a;while(1){a=0;do{i=a|1;r=l+k*+(b[g+i>>0]|0);p[d+(a<<3)>>3]=l+k*+(b[g+a>>0]|0);p[d+(i<<3)>>3]=r;i=a|2;q=a|3;r=l+k*+(b[g+q>>0]|0);p[d+(i<<3)>>3]=l+k*+(b[g+i>>0]|0);p[d+(q<<3)>>3]=r;a=a+4|0}while((a|0)<=(h|0));m=m+-1|0;if(n){a=o;do{p[d+(a<<3)>>3]=l+k*+(b[g+a>>0]|0);a=a+1|0}while((a|0)!=(e|0))}if(!m)break;else{d=d+(j<<3)|0;g=g+c|0}}return}function NK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,u=0;d=f[h>>2]|0;c=f[h+4>>2]|0;k=+p[i>>3];l=+p[i+8>>3];i=b>>>1;b=g>>>3;g=c+-1|0;if(!c)return;if((d|0)<4){if((d|0)>0){m=g;n=e;o=a}else return;while(1){c=0;do{p[n+(c<<3)>>3]=l+k*+(j[o+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(d|0));if(!m)break;else{m=m+-1|0;n=n+(b<<3)|0;o=o+(i<<1)|0}}return}o=d+-4|0;n=(((o|0)>3?o:3)&2147483644)+4|0;if((n|0)<(d|0)){q=g;r=e;s=a}else{m=g;g=e;e=a;while(1){a=0;do{c=a|1;t=l+k*+(j[e+(c<<1)>>1]|0);p[g+(a<<3)>>3]=l+k*+(j[e+(a<<1)>>1]|0);p[g+(c<<3)>>3]=t;c=a|2;h=a|3;t=l+k*+(j[e+(h<<1)>>1]|0);p[g+(c<<3)>>3]=l+k*+(j[e+(c<<1)>>1]|0);p[g+(h<<3)>>3]=t;a=a+4|0}while((a|0)<=(o|0));if(!m)break;else{m=m+-1|0;g=g+(b<<3)|0;e=e+(i<<1)|0}}return}while(1){e=0;do{g=e|1;t=l+k*+(j[s+(g<<1)>>1]|0);p[r+(e<<3)>>3]=l+k*+(j[s+(e<<1)>>1]|0);p[r+(g<<3)>>3]=t;g=e|2;m=e|3;t=l+k*+(j[s+(m<<1)>>1]|0);p[r+(g<<3)>>3]=l+k*+(j[s+(g<<1)>>1]|0);p[r+(m<<3)>>3]=t;e=e+4|0}while((e|0)<=(o|0));u=n;do{p[r+(u<<3)>>3]=l+k*+(j[s+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(d|0));if(!q)break;else{q=q+-1|0;r=r+(b<<3)|0;s=s+(i<<1)|0}}return}function OK(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,u=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>1;b=h>>>3;h=c+-1|0;if(!c)return;if((e|0)<4){if((e|0)>0){m=h;n=g;o=a}else return;while(1){c=0;do{p[n+(c<<3)>>3]=l+k*+(d[o+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(e|0));if(!m)break;else{m=m+-1|0;n=n+(b<<3)|0;o=o+(j<<1)|0}}return}o=e+-4|0;n=(((o|0)>3?o:3)&2147483644)+4|0;if((n|0)<(e|0)){q=h;r=g;s=a}else{m=h;h=g;g=a;while(1){a=0;do{c=a|1;t=l+k*+(d[g+(c<<1)>>1]|0);p[h+(a<<3)>>3]=l+k*+(d[g+(a<<1)>>1]|0);p[h+(c<<3)>>3]=t;c=a|2;i=a|3;t=l+k*+(d[g+(i<<1)>>1]|0);p[h+(c<<3)>>3]=l+k*+(d[g+(c<<1)>>1]|0);p[h+(i<<3)>>3]=t;a=a+4|0}while((a|0)<=(o|0));if(!m)break;else{m=m+-1|0;h=h+(b<<3)|0;g=g+(j<<1)|0}}return}while(1){g=0;do{h=g|1;t=l+k*+(d[s+(h<<1)>>1]|0);p[r+(g<<3)>>3]=l+k*+(d[s+(g<<1)>>1]|0);p[r+(h<<3)>>3]=t;h=g|2;m=g|3;t=l+k*+(d[s+(m<<1)>>1]|0);p[r+(h<<3)>>3]=l+k*+(d[s+(h<<1)>>1]|0);p[r+(m<<3)>>3]=t;g=g+4|0}while((g|0)<=(o|0));u=n;do{p[r+(u<<3)>>3]=l+k*+(d[s+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(e|0));if(!q)break;else{q=q+-1|0;r=r+(b<<3)|0;s=s+(j<<1)|0}}return}function PK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0.0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>3;if(!c)return;g=d+-4|0;h=(((g|0)>3?g:3)&2147483644)+4|0;if((d|0)<4){l=(d|0)>0;m=c;n=e;o=a;while(1){m=m+-1|0;if(l){q=0;do{p[n+(q<<3)>>3]=k+j*+(f[o+(q<<2)>>2]|0);q=q+1|0}while((q|0)!=(d|0))}if(!m)break;else{n=n+(b<<3)|0;o=o+(i<<2)|0}}return}o=(h|0)<(d|0);n=c;c=e;e=a;while(1){a=0;do{m=a|1;r=k+j*+(f[e+(m<<2)>>2]|0);p[c+(a<<3)>>3]=k+j*+(f[e+(a<<2)>>2]|0);p[c+(m<<3)>>3]=r;m=a|2;l=a|3;r=k+j*+(f[e+(l<<2)>>2]|0);p[c+(m<<3)>>3]=k+j*+(f[e+(m<<2)>>2]|0);p[c+(l<<3)>>3]=r;a=a+4|0}while((a|0)<=(g|0));n=n+-1|0;if(o){a=h;do{p[c+(a<<3)>>3]=k+j*+(f[e+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=(d|0))}if(!n)break;else{c=c+(b<<3)|0;e=e+(i<<2)|0}}return}function QK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0.0,u=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>3;g=c+-1|0;if(!c)return;if((d|0)<4){if((d|0)>0){l=g;m=e;o=a}else return;while(1){c=0;do{p[m+(c<<3)>>3]=k+j*+n[o+(c<<2)>>2];c=c+1|0}while((c|0)!=(d|0));if(!l)break;else{l=l+-1|0;m=m+(b<<3)|0;o=o+(i<<2)|0}}return}o=d+-4|0;m=(((o|0)>3?o:3)&2147483644)+4|0;if((m|0)<(d|0)){q=g;r=e;s=a}else{l=g;g=e;e=a;while(1){a=0;do{c=a|1;t=k+j*+n[e+(c<<2)>>2];p[g+(a<<3)>>3]=k+j*+n[e+(a<<2)>>2];p[g+(c<<3)>>3]=t;c=a|2;h=a|3;t=k+j*+n[e+(h<<2)>>2];p[g+(c<<3)>>3]=k+j*+n[e+(c<<2)>>2];p[g+(h<<3)>>3]=t;a=a+4|0}while((a|0)<=(o|0));if(!l)break;else{l=l+-1|0;g=g+(b<<3)|0;e=e+(i<<2)|0}}return}while(1){e=0;do{g=e|1;t=k+j*+n[s+(g<<2)>>2];p[r+(e<<3)>>3]=k+j*+n[s+(e<<2)>>2];p[r+(g<<3)>>3]=t;g=e|2;l=e|3;t=k+j*+n[s+(l<<2)>>2];p[r+(g<<3)>>3]=k+j*+n[s+(g<<2)>>2];p[r+(l<<3)>>3]=t;e=e+4|0}while((e|0)<=(o|0));u=m;do{p[r+(u<<3)>>3]=k+j*+n[s+(u<<2)>>2];u=u+1|0}while((u|0)!=(d|0));if(!q)break;else{q=q+-1|0;r=r+(b<<3)|0;s=s+(i<<2)|0}}return}function RK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>3;b=g>>>3;g=c+-1|0;if(!c)return;if((d|0)<4){if((d|0)>0){l=g;m=e;n=a}else return;while(1){c=0;do{p[m+(c<<3)>>3]=k+j*+p[n+(c<<3)>>3];c=c+1|0}while((c|0)!=(d|0));if(!l)break;else{l=l+-1|0;m=m+(b<<3)|0;n=n+(i<<3)|0}}return}n=d+-4|0;m=(((n|0)>3?n:3)&2147483644)+4|0;if((m|0)<(d|0)){o=g;q=e;r=a}else{l=g;g=e;e=a;while(1){a=0;do{c=a|1;s=k+j*+p[e+(c<<3)>>3];p[g+(a<<3)>>3]=k+j*+p[e+(a<<3)>>3];p[g+(c<<3)>>3]=s;c=a|2;h=a|3;s=k+j*+p[e+(h<<3)>>3];p[g+(c<<3)>>3]=k+j*+p[e+(c<<3)>>3];p[g+(h<<3)>>3]=s;a=a+4|0}while((a|0)<=(n|0));if(!l)break;else{l=l+-1|0;g=g+(b<<3)|0;e=e+(i<<3)|0}}return}while(1){e=0;do{g=e|1;s=k+j*+p[r+(g<<3)>>3];p[q+(e<<3)>>3]=k+j*+p[r+(e<<3)>>3];p[q+(g<<3)>>3]=s;g=e|2;l=e|3;s=k+j*+p[r+(l<<3)>>3];p[q+(g<<3)>>3]=k+j*+p[r+(g<<3)>>3];p[q+(l<<3)>>3]=s;e=e+4|0}while((e|0)<=(n|0));t=m;do{p[q+(t<<3)>>3]=k+j*+p[r+(t<<3)>>3];t=t+1|0}while((t|0)!=(d|0));if(!o)break;else{o=o+-1|0;q=q+(b<<3)|0;r=r+(i<<3)|0}}return}function SK(a){a=a|0;return}function TK(a,c,d,e,g,h,i){a=a|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0.0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=u;u=u+144|0;k=j+128|0;l=j+56|0;m=j;n=j+112|0;_$(k,31740);switch(g|0){case 32:{p[l>>3]=0.0;p[m>>3]=0.0;o=d>e?e:d;qZ(a,l,m,0,0,i);q=+p[l>>3];r=+p[m>>3]-q;s=((d<e?e:d)-o)*(r>2.220446049250313e-16?1.0/r:0.0);t=s;v=o-q*s;break}case 1:case 2:case 4:{s=+zZ(a,g,i);t=s>2.220446049250313e-16?d/s:0.0;v=0.0;break}default:{f[l>>2]=0;f[l+4>>2]=0;w=c$(l,29)|0;g=159626;x=w+29|0;do{b[w>>0]=b[g>>0]|0;w=w+1|0;g=g+1|0}while((w|0)<(x|0));j$(-5,l,159656,158478,5777);d$(l);t=1.0;v=0.0}}g=(RR(a,-1)|0)&7;if((h|0)<0)if(aT(c)|0)y=VS(c,-1)|0;else y=g;else y=h;do if((NS(a)|0)==65536){h=f[a+4>>2]|0;f[l>>2]=f[h>>2];g=l+4|0;z=h+4|0;f[g>>2]=f[z>>2];A=l+8|0;f[A>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];f[l+16>>2]=f[h+16>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];B=f[h+36>>2]|0;f[l+36>>2]=B;f[l+40>>2]=A;A=l+48|0;C=l+44|0;f[C>>2]=A;f[A>>2]=0;f[l+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[h+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[g>>2]=0;BR(l,h);break}}else OR(l,a,-1);while(0);if(!(XS(i)|0)){f[m>>2]=1124007936;a=m+4|0;h=m+8|0;g=m+40|0;w=a;x=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(x|0));f[g>>2]=h;h=m+48|0;w=m+44|0;f[w>>2]=h;f[h>>2]=0;f[m+52>>2]=0;x=n+8|0;f[x>>2]=0;f[x+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=m;WJ(l,n,y,t,v);fL(m,c,i);i=m+36|0;n=f[i>>2]|0;if(n|0?(x=n+12|0,n=f[x>>2]|0,f[x>>2]=n+-1,(n|0)==1):0)CR(m);f[i>>2]=0;i=m+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[a>>2]|0)>0){i=f[g>>2]|0;g=0;do{f[i+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[a>>2]|0))}a=f[w>>2]|0;if((a|0)!=(h|0))ZF(a)}else WJ(l,c,y,t,v);y=l+36|0;c=f[y>>2]|0;if(c|0?(a=c+12|0,c=f[a>>2]|0,f[a>>2]=c+-1,(c|0)==1):0)CR(l);f[y>>2]=0;y=l+16|0;c=l+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[c>>2]|0)>0){y=f[l+40>>2]|0;a=0;do{f[y+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[c>>2]|0))}c=f[l+44>>2]|0;if((c|0)!=(l+48|0))ZF(c);if(!(f[k+4>>2]|0)){u=j;return}u=j;return}function UK(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if((k|0)!=0&(j|0)>0){l=g;m=a;n=k;o=d}else return;while(1){d=0;do{if(b[o+d>>0]|0)b[l+d>>0]=b[m+d>>0]|0;d=d+1|0}while((d|0)!=(j|0));n=n+-1|0;if(!n)break;else{l=l+h|0;m=m+c|0;o=o+e|0}}return}function VK(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;k=f[j>>2]|0;l=f[j+4>>2]|0;if((l|0)!=0&(k|0)>0){m=l;n=h;o=a;p=e}else return;while(1){e=0;do{if(b[p+e>>0]|0)d[n+(e<<1)>>1]=d[o+(e<<1)>>1]|0;e=e+1|0}while((e|0)!=(k|0));m=m+-1|0;if(!m)break;else{n=n+i|0;o=o+c|0;p=p+g|0}}return}function WK(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=g;n=a;o=k;p=d;while(1){o=o+-1|0;if(l){q=0;do{if(b[p+q>>0]|0){r=m+(q*3|0)|0;s=n+(q*3|0)|0;b[r>>0]=b[s>>0]|0;b[r+1>>0]=b[s+1>>0]|0;b[r+2>>0]=b[s+2>>0]|0}q=q+1|0}while((q|0)!=(j|0))}if(!o)break;else{m=m+h|0;n=n+c|0;p=p+e|0}}return}p=j&-4;n=(p|0)<(j|0);m=g;g=a;a=k;k=d;while(1){d=0;do{if(b[k+d>>0]|0){o=m+(d*3|0)|0;l=g+(d*3|0)|0;b[o>>0]=b[l>>0]|0;b[o+1>>0]=b[l+1>>0]|0;b[o+2>>0]=b[l+2>>0]|0}l=d|1;if(b[k+l>>0]|0){o=m+(l*3|0)|0;q=g+(l*3|0)|0;b[o>>0]=b[q>>0]|0;b[o+1>>0]=b[q+1>>0]|0;b[o+2>>0]=b[q+2>>0]|0}q=d|2;if(b[k+q>>0]|0){o=m+(q*3|0)|0;l=g+(q*3|0)|0;b[o>>0]=b[l>>0]|0;b[o+1>>0]=b[l+1>>0]|0;b[o+2>>0]=b[l+2>>0]|0}l=d|3;if(b[k+l>>0]|0){o=m+(l*3|0)|0;q=g+(l*3|0)|0;b[o>>0]=b[q>>0]|0;b[o+1>>0]=b[q+1>>0]|0;b[o+2>>0]=b[q+2>>0]|0}d=d+4|0}while((d|0)<=(i|0));a=a+-1|0;if(n){d=p;do{if(b[k+d>>0]|0){q=m+(d*3|0)|0;o=g+(d*3|0)|0;b[q>>0]=b[o>>0]|0;b[q+1>>0]=b[o+1>>0]|0;b[q+2>>0]=b[o+2>>0]|0}d=d+1|0}while((d|0)!=(j|0))}if(!a)break;else{m=m+h|0;g=g+c|0;k=k+e|0}}return}function XK(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=g;n=a;o=k;p=d;while(1){o=o+-1|0;if(l){q=0;do{if(b[p+q>>0]|0)f[m+(q<<2)>>2]=f[n+(q<<2)>>2];q=q+1|0}while((q|0)!=(j|0))}if(!o)break;else{m=m+h|0;n=n+c|0;p=p+e|0}}return}p=j&-4;n=(p|0)<(j|0);m=g;g=a;a=k;k=d;while(1){d=0;do{if(b[k+d>>0]|0)f[m+(d<<2)>>2]=f[g+(d<<2)>>2];o=d|1;if(b[k+o>>0]|0)f[m+(o<<2)>>2]=f[g+(o<<2)>>2];o=d|2;if(b[k+o>>0]|0)f[m+(o<<2)>>2]=f[g+(o<<2)>>2];o=d|3;if(b[k+o>>0]|0)f[m+(o<<2)>>2]=f[g+(o<<2)>>2];d=d+4|0}while((d|0)<=(i|0));a=a+-1|0;if(n){d=p;do{if(b[k+d>>0]|0)f[m+(d<<2)>>2]=f[g+(d<<2)>>2];d=d+1|0}while((d|0)!=(j|0))}if(!a)break;else{m=m+h|0;g=g+c|0;k=k+e|0}}return}function YK(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=f[j>>2]|0;l=f[j+4>>2]|0;if(!l)return;j=k+-4|0;if((k|0)<4){m=(k|0)>0;n=h;o=a;p=l;q=e;while(1){p=p+-1|0;if(m){r=0;do{if(b[q+r>>0]|0){s=n+(r*6|0)|0;t=o+(r*6|0)|0;d[s>>1]=d[t>>1]|0;d[s+2>>1]=d[t+2>>1]|0;d[s+4>>1]=d[t+4>>1]|0}r=r+1|0}while((r|0)!=(k|0))}if(!p)break;else{n=n+i|0;o=o+c|0;q=q+g|0}}return}q=k&-4;o=(q|0)<(k|0);n=h;h=a;a=l;l=e;while(1){e=0;do{if(b[l+e>>0]|0){p=n+(e*6|0)|0;m=h+(e*6|0)|0;d[p>>1]=d[m>>1]|0;d[p+2>>1]=d[m+2>>1]|0;d[p+4>>1]=d[m+4>>1]|0}m=e|1;if(b[l+m>>0]|0){p=n+(m*6|0)|0;r=h+(m*6|0)|0;d[p>>1]=d[r>>1]|0;d[p+2>>1]=d[r+2>>1]|0;d[p+4>>1]=d[r+4>>1]|0}r=e|2;if(b[l+r>>0]|0){p=n+(r*6|0)|0;m=h+(r*6|0)|0;d[p>>1]=d[m>>1]|0;d[p+2>>1]=d[m+2>>1]|0;d[p+4>>1]=d[m+4>>1]|0}m=e|3;if(b[l+m>>0]|0){p=n+(m*6|0)|0;r=h+(m*6|0)|0;d[p>>1]=d[r>>1]|0;d[p+2>>1]=d[r+2>>1]|0;d[p+4>>1]=d[r+4>>1]|0}e=e+4|0}while((e|0)<=(j|0));a=a+-1|0;if(o){e=q;do{if(b[l+e>>0]|0){r=n+(e*6|0)|0;p=h+(e*6|0)|0;d[r>>1]=d[p>>1]|0;d[r+2>>1]=d[p+2>>1]|0;d[r+4>>1]=d[p+4>>1]|0}e=e+1|0}while((e|0)!=(k|0))}if(!a)break;else{n=n+i|0;h=h+c|0;l=l+g|0}}return}function ZK(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=g;n=a;o=k;p=d;while(1){o=o+-1|0;if(l){q=0;do{if(b[p+q>>0]|0){r=n+(q<<3)|0;s=f[r+4>>2]|0;t=m+(q<<3)|0;f[t>>2]=f[r>>2];f[t+4>>2]=s}q=q+1|0}while((q|0)!=(j|0))}if(!o)break;else{m=m+h|0;n=n+c|0;p=p+e|0}}return}p=j&-4;n=(p|0)<(j|0);m=g;g=a;a=k;k=d;while(1){d=0;do{if(b[k+d>>0]|0){o=g+(d<<3)|0;l=f[o+4>>2]|0;q=m+(d<<3)|0;f[q>>2]=f[o>>2];f[q+4>>2]=l}l=d|1;if(b[k+l>>0]|0){q=g+(l<<3)|0;o=f[q+4>>2]|0;s=m+(l<<3)|0;f[s>>2]=f[q>>2];f[s+4>>2]=o}o=d|2;if(b[k+o>>0]|0){s=g+(o<<3)|0;q=f[s+4>>2]|0;l=m+(o<<3)|0;f[l>>2]=f[s>>2];f[l+4>>2]=q}q=d|3;if(b[k+q>>0]|0){l=g+(q<<3)|0;s=f[l+4>>2]|0;o=m+(q<<3)|0;f[o>>2]=f[l>>2];f[o+4>>2]=s}d=d+4|0}while((d|0)<=(i|0));a=a+-1|0;if(n){d=p;do{if(b[k+d>>0]|0){s=g+(d<<3)|0;o=f[s+4>>2]|0;l=m+(d<<3)|0;f[l>>2]=f[s>>2];f[l+4>>2]=o}d=d+1|0}while((d|0)!=(j|0))}if(!a)break;else{m=m+h|0;g=g+c|0;k=k+e|0}}return}function _K(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=g;n=a;o=k;p=d;while(1){o=o+-1|0;if(l){q=0;do{if(b[p+q>>0]|0){r=m+(q*12|0)|0;s=n+(q*12|0)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2]}q=q+1|0}while((q|0)!=(j|0))}if(!o)break;else{m=m+h|0;n=n+c|0;p=p+e|0}}return}p=j&-4;n=(p|0)<(j|0);m=g;g=a;a=k;k=d;while(1){d=0;do{if(b[k+d>>0]|0){o=m+(d*12|0)|0;l=g+(d*12|0)|0;f[o>>2]=f[l>>2];f[o+4>>2]=f[l+4>>2];f[o+8>>2]=f[l+8>>2]}l=d|1;if(b[k+l>>0]|0){o=m+(l*12|0)|0;q=g+(l*12|0)|0;f[o>>2]=f[q>>2];f[o+4>>2]=f[q+4>>2];f[o+8>>2]=f[q+8>>2]}q=d|2;if(b[k+q>>0]|0){o=m+(q*12|0)|0;l=g+(q*12|0)|0;f[o>>2]=f[l>>2];f[o+4>>2]=f[l+4>>2];f[o+8>>2]=f[l+8>>2]}l=d|3;if(b[k+l>>0]|0){o=m+(l*12|0)|0;q=g+(l*12|0)|0;f[o>>2]=f[q>>2];f[o+4>>2]=f[q+4>>2];f[o+8>>2]=f[q+8>>2]}d=d+4|0}while((d|0)<=(i|0));a=a+-1|0;if(n){d=p;do{if(b[k+d>>0]|0){q=m+(d*12|0)|0;o=g+(d*12|0)|0;f[q>>2]=f[o>>2];f[q+4>>2]=f[o+4>>2];f[q+8>>2]=f[o+8>>2]}d=d+1|0}while((d|0)!=(j|0))}if(!a)break;else{m=m+h|0;g=g+c|0;k=k+e|0}}return}function $K(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=g;n=a;o=k;p=d;while(1){o=o+-1|0;if(l){q=0;do{if(b[p+q>>0]|0){r=m+(q<<4)|0;s=n+(q<<4)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2]}q=q+1|0}while((q|0)!=(j|0))}if(!o)break;else{m=m+h|0;n=n+c|0;p=p+e|0}}return}p=j&-4;n=(p|0)<(j|0);m=g;g=a;a=k;k=d;while(1){d=0;do{if(b[k+d>>0]|0){o=m+(d<<4)|0;l=g+(d<<4)|0;f[o>>2]=f[l>>2];f[o+4>>2]=f[l+4>>2];f[o+8>>2]=f[l+8>>2];f[o+12>>2]=f[l+12>>2]}l=d|1;if(b[k+l>>0]|0){o=m+(l<<4)|0;q=g+(l<<4)|0;f[o>>2]=f[q>>2];f[o+4>>2]=f[q+4>>2];f[o+8>>2]=f[q+8>>2];f[o+12>>2]=f[q+12>>2]}q=d|2;if(b[k+q>>0]|0){o=m+(q<<4)|0;l=g+(q<<4)|0;f[o>>2]=f[l>>2];f[o+4>>2]=f[l+4>>2];f[o+8>>2]=f[l+8>>2];f[o+12>>2]=f[l+12>>2]}l=d|3;if(b[k+l>>0]|0){o=m+(l<<4)|0;q=g+(l<<4)|0;f[o>>2]=f[q>>2];f[o+4>>2]=f[q+4>>2];f[o+8>>2]=f[q+8>>2];f[o+12>>2]=f[q+12>>2]}d=d+4|0}while((d|0)<=(i|0));a=a+-1|0;if(n){d=p;do{if(b[k+d>>0]|0){q=m+(d<<4)|0;o=g+(d<<4)|0;f[q>>2]=f[o>>2];f[q+4>>2]=f[o+4>>2];f[q+8>>2]=f[o+8>>2];f[q+12>>2]=f[o+12>>2]}d=d+1|0}while((d|0)!=(j|0))}if(!a)break;else{m=m+h|0;g=g+c|0;k=k+e|0}}return}function aL(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=g;n=a;o=k;p=d;while(1){o=o+-1|0;if(l){q=0;do{if(b[p+q>>0]|0){r=m+(q*24|0)|0;s=n+(q*24|0)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2];f[r+16>>2]=f[s+16>>2];f[r+20>>2]=f[s+20>>2]}q=q+1|0}while((q|0)!=(j|0))}if(!o)break;else{m=m+h|0;n=n+c|0;p=p+e|0}}return}p=j&-4;n=(p|0)<(j|0);m=g;g=a;a=k;k=d;while(1){d=0;do{if(b[k+d>>0]|0){o=m+(d*24|0)|0;l=g+(d*24|0)|0;f[o>>2]=f[l>>2];f[o+4>>2]=f[l+4>>2];f[o+8>>2]=f[l+8>>2];f[o+12>>2]=f[l+12>>2];f[o+16>>2]=f[l+16>>2];f[o+20>>2]=f[l+20>>2]}l=d|1;if(b[k+l>>0]|0){o=m+(l*24|0)|0;q=g+(l*24|0)|0;f[o>>2]=f[q>>2];f[o+4>>2]=f[q+4>>2];f[o+8>>2]=f[q+8>>2];f[o+12>>2]=f[q+12>>2];f[o+16>>2]=f[q+16>>2];f[o+20>>2]=f[q+20>>2]}q=d|2;if(b[k+q>>0]|0){o=m+(q*24|0)|0;l=g+(q*24|0)|0;f[o>>2]=f[l>>2];f[o+4>>2]=f[l+4>>2];f[o+8>>2]=f[l+8>>2];f[o+12>>2]=f[l+12>>2];f[o+16>>2]=f[l+16>>2];f[o+20>>2]=f[l+20>>2]}l=d|3;if(b[k+l>>0]|0){o=m+(l*24|0)|0;q=g+(l*24|0)|0;f[o>>2]=f[q>>2];f[o+4>>2]=f[q+4>>2];f[o+8>>2]=f[q+8>>2];f[o+12>>2]=f[q+12>>2];f[o+16>>2]=f[q+16>>2];f[o+20>>2]=f[q+20>>2]}d=d+4|0}while((d|0)<=(i|0));a=a+-1|0;if(n){d=p;do{if(b[k+d>>0]|0){q=m+(d*24|0)|0;o=g+(d*24|0)|0;f[q>>2]=f[o>>2];f[q+4>>2]=f[o+4>>2];f[q+8>>2]=f[o+8>>2];f[q+12>>2]=f[o+12>>2];f[q+16>>2]=f[o+16>>2];f[q+20>>2]=f[o+20>>2]}d=d+1|0}while((d|0)!=(j|0))}if(!a)break;else{m=m+h|0;g=g+c|0;k=k+e|0}}return}function bL(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=g;n=a;o=k;p=d;while(1){o=o+-1|0;if(l){q=0;do{if(b[p+q>>0]|0){r=m+(q<<5)|0;s=n+(q<<5)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2];f[r+16>>2]=f[s+16>>2];f[r+20>>2]=f[s+20>>2];f[r+24>>2]=f[s+24>>2];f[r+28>>2]=f[s+28>>2]}q=q+1|0}while((q|0)!=(j|0))}if(!o)break;else{m=m+h|0;n=n+c|0;p=p+e|0}}return}p=j&-4;n=(p|0)<(j|0);m=g;g=a;a=k;k=d;while(1){d=0;do{if(b[k+d>>0]|0){o=m+(d<<5)|0;l=g+(d<<5)|0;f[o>>2]=f[l>>2];f[o+4>>2]=f[l+4>>2];f[o+8>>2]=f[l+8>>2];f[o+12>>2]=f[l+12>>2];f[o+16>>2]=f[l+16>>2];f[o+20>>2]=f[l+20>>2];f[o+24>>2]=f[l+24>>2];f[o+28>>2]=f[l+28>>2]}l=d|1;if(b[k+l>>0]|0){o=m+(l<<5)|0;q=g+(l<<5)|0;f[o>>2]=f[q>>2];f[o+4>>2]=f[q+4>>2];f[o+8>>2]=f[q+8>>2];f[o+12>>2]=f[q+12>>2];f[o+16>>2]=f[q+16>>2];f[o+20>>2]=f[q+20>>2];f[o+24>>2]=f[q+24>>2];f[o+28>>2]=f[q+28>>2]}q=d|2;if(b[k+q>>0]|0){o=m+(q<<5)|0;l=g+(q<<5)|0;f[o>>2]=f[l>>2];f[o+4>>2]=f[l+4>>2];f[o+8>>2]=f[l+8>>2];f[o+12>>2]=f[l+12>>2];f[o+16>>2]=f[l+16>>2];f[o+20>>2]=f[l+20>>2];f[o+24>>2]=f[l+24>>2];f[o+28>>2]=f[l+28>>2]}l=d|3;if(b[k+l>>0]|0){o=m+(l<<5)|0;q=g+(l<<5)|0;f[o>>2]=f[q>>2];f[o+4>>2]=f[q+4>>2];f[o+8>>2]=f[q+8>>2];f[o+12>>2]=f[q+12>>2];f[o+16>>2]=f[q+16>>2];f[o+20>>2]=f[q+20>>2];f[o+24>>2]=f[q+24>>2];f[o+28>>2]=f[q+28>>2]}d=d+4|0}while((d|0)<=(i|0));a=a+-1|0;if(n){d=p;do{if(b[k+d>>0]|0){q=m+(d<<5)|0;o=g+(d<<5)|0;f[q>>2]=f[o>>2];f[q+4>>2]=f[o+4>>2];f[q+8>>2]=f[o+8>>2];f[q+12>>2]=f[o+12>>2];f[q+16>>2]=f[o+16>>2];f[q+20>>2]=f[o+20>>2];f[q+24>>2]=f[o+24>>2];f[q+28>>2]=f[o+28>>2]}d=d+1|0}while((d|0)!=(j|0))}if(!a)break;else{m=m+h|0;g=g+c|0;k=k+e|0}}return}function cL(a){a=a|0;var b=0;if(a>>>0<33){b=f[31760+(a<<2)>>2]|0;return ((b|0)==0?142:b)|0}else return 142;return 0}function dL(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;k=f[j>>2]|0;j=i+4|0;l=f[j>>2]|0;m=l+-1|0;f[j>>2]=m;if(!l)return;l=f[i>>2]|0;if(!k){n=(l|0)>0;o=m;do{if(n){p=0;do p=p+1|0;while((p|0)<(l|0))}p=o;o=o+-1|0}while((p|0)!=0);f[j>>2]=o;return}else{q=l;r=m;s=g;t=a;u=d}while(1){if((q|0)>0){d=q;a=s;g=t;m=0;while(1){if(!(b[u+m>>0]|0))v=d;else{l=0;do{b[a+l>>0]=b[g+l>>0]|0;l=l+1|0}while((l|0)!=(k|0));v=f[i>>2]|0}m=m+1|0;if((m|0)>=(v|0))break;else{d=v;a=a+k|0;g=g+k|0}}w=v;x=f[j>>2]|0}else{w=q;x=r}r=x+-1|0;f[j>>2]=r;if(!x)break;else{q=w;s=s+h|0;t=t+c|0;u=u+e|0}}return}function eL(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+352|0;e=d+344|0;g=d+288|0;h=d+160|0;i=d+32|0;j=d;_$(e,31892);k=RR(c,-1)|0;if(aT(c)|0?(l=f[a>>2]|0,(k|0)!=(l&4095|0)):0){if((l^k)&4088|0){f[g>>2]=0;f[g+4>>2]=0;m=c$(g,55)|0;n=201054;o=m+55|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,g,201110,159753,260);d$(g)}WJ(a,c,k,1.0,0.0)}else p=6;do if((p|0)==6){if((NS(c)|0)==655360){k=a+16|0;if(f[k>>2]|0){l=a+4|0;q=f[l>>2]|0;if((q|0)<3)r=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{s=f[a+40>>2]|0;t=0;v=1;while(1){w=Y(f[s+(t<<2)>>2]|0,v)|0;t=t+1|0;if((t|0)==(q|0)){r=w;break}else v=w}}if(!((q|0)==0|(r|0)==0)){v=a+40|0;MR(c,q,f[v>>2]|0,f[a>>2]&4095,-1,0,0);OS(g,c,-1);t=g+24|0;if(!(f[t>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=c$(h,11)|0;n=159799;o=m+11|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,h,201110,159753,274);d$(h)}m=h;o=m+128|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));q=f[l>>2]|0;if((q|0)>0)x=f[(f[a+44>>2]|0)+(q+-1<<2)>>2]|0;else x=0;if(q>>>0<32)y=q;else{f[j>>2]=0;f[j+4>>2]=0;m=c$(j,22)|0;n=159811;o=m+22|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,j,201110,159753,276);d$(j);y=f[l>>2]|0}if(!y)z=0;else{q=f[v>>2]|0;s=0;do{f[h+(s<<2)>>2]=f[q+(s<<2)>>2];s=s+1|0}while(s>>>0<y>>>0);z=y}s=h+(z+-1<<2)|0;q=Y(f[s>>2]|0,x)|0;f[s>>2]=q;s0(g,i);q=f[l>>2]|0;s=i+(q+-1<<2)|0;v=Y(f[s>>2]|0,x)|0;f[s>>2]=v;v=f[t>>2]|0;s=f[v+4>>2]|0;Oh[f[(f[s>>2]|0)+32>>2]&255](s,v,f[k>>2]|0,q,h,i,f[g+36>>2]|0,f[a+44>>2]|0);j0(g);break}}oS(c);break}q=a+4|0;v=f[q>>2]|0;if((v|0)>=3){s=a+40|0;MR(c,v,f[s>>2]|0,f[a>>2]&4095,-1,0,0);do if((NS(c)|0)==65536){v=f[c+4>>2]|0;f[g>>2]=f[v>>2];w=g+4|0;A=v+4|0;f[w>>2]=f[A>>2];B=g+8|0;f[B>>2]=f[v+8>>2];f[g+12>>2]=f[v+12>>2];C=g+16|0;f[C>>2]=f[v+16>>2];f[g+20>>2]=f[v+20>>2];f[g+24>>2]=f[v+24>>2];f[g+28>>2]=f[v+28>>2];f[g+32>>2]=f[v+32>>2];D=f[v+36>>2]|0;f[g+36>>2]=D;f[g+40>>2]=B;B=g+48|0;E=g+44|0;f[E>>2]=B;f[B>>2]=0;f[g+52>>2]=0;if(D|0){B=D+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[v+44>>2]|0;B=f[E>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];F=C;break}else{f[w>>2]=0;BR(g,v);F=C;break}}else{OR(g,c,-1);F=g+16|0}while(0);if((f[a+16>>2]|0)!=(f[F>>2]|0)){k=f[q>>2]|0;if((k|0)<3)G=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{t=f[s>>2]|0;l=0;C=1;while(1){v=Y(f[t+(l<<2)>>2]|0,C)|0;l=l+1|0;if((l|0)==(k|0)){G=v;break}else C=v}}if(G|0){f[h>>2]=a;f[h+4>>2]=g;bU(j,h,i,2);C=f[q>>2]|0;if((C|0)>0)H=f[(f[a+44>>2]|0)+(C+-1<<2)>>2]|0;else H=0;C=Y(H,f[j+20>>2]|0)|0;k=j+16|0;l=i+4|0;t=0;while(1){if(t>>>0>=(f[k>>2]|0)>>>0)break;K1a(f[l>>2]|0,f[i>>2]|0,C|0)|0;tR(j)|0;t=t+1|0}}}t=g+36|0;C=f[t>>2]|0;if(C|0?(l=C+12|0,C=f[l>>2]|0,f[l>>2]=C+-1,(C|0)==1):0)CR(g);f[t>>2]=0;t=g+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[t>>2]|0)>0){C=f[g+40>>2]|0;l=0;do{f[C+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[t>>2]|0))}t=f[g+44>>2]|0;if((t|0)!=(g+48|0))ZF(t);break}t=a+8|0;l=a+12|0;pS(c,f[t>>2]|0,f[l>>2]|0,f[a>>2]&4095,-1,0,0);do if((NS(c)|0)==65536){C=f[c+4>>2]|0;f[g>>2]=f[C>>2];k=g+4|0;s=C+4|0;f[k>>2]=f[s>>2];v=g+8|0;f[v>>2]=f[C+8>>2];f[g+12>>2]=f[C+12>>2];w=g+16|0;f[w>>2]=f[C+16>>2];f[g+20>>2]=f[C+20>>2];f[g+24>>2]=f[C+24>>2];f[g+28>>2]=f[C+28>>2];f[g+32>>2]=f[C+32>>2];A=f[C+36>>2]|0;f[g+36>>2]=A;f[g+40>>2]=v;v=g+48|0;B=g+44|0;f[B>>2]=v;f[v>>2]=0;f[g+52>>2]=0;if(A|0){v=A+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[s>>2]|0)<3){s=f[C+44>>2]|0;v=f[B>>2]|0;f[v>>2]=f[s>>2];f[v+4>>2]=f[s+4>>2];I=w;break}else{f[k>>2]=0;BR(g,C);I=w;break}}else{OR(g,c,-1);I=g+16|0}while(0);w=a+16|0;if(((f[w>>2]|0)!=(f[I>>2]|0)?(f[t>>2]|0)>0:0)?(f[l>>2]|0)>0:0){if(!(((NS(c)|0)!=196608?(NS(c)|0)!=786432:0)?(NS(c)|0)!=917504:0)){C=g+4|0;k=f[C>>2]|0;if((k|0)<3)K=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{s=f[g+40>>2]|0;v=0;B=1;while(1){A=Y(f[s+(v<<2)>>2]|0,B)|0;v=v+1|0;if((v|0)==(k|0)){K=A;break}else B=A}}kS(h,g,0,K);B=h+36|0;k=f[B>>2]|0;if(k|0){v=k+12|0;f[v>>2]=(f[v>>2]|0)+1}v=g+36|0;k=f[v>>2]|0;if(k|0?(s=k+12|0,k=f[s>>2]|0,f[s>>2]=k+-1,(k|0)==1):0)CR(g);f[v>>2]=0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[C>>2]|0)>0){k=f[g+40>>2]|0;s=0;do{f[k+(s<<2)>>2]=0;s=s+1|0;L=f[C>>2]|0}while((s|0)<(L|0));f[g>>2]=f[h>>2];if((L|0)<3)p=52;else p=54}else{f[g>>2]=f[h>>2];p=52}if((p|0)==52){s=f[h+4>>2]|0;if((s|0)<3){f[C>>2]=s;f[g+8>>2]=f[h+8>>2];f[g+12>>2]=f[h+12>>2];s=f[h+44>>2]|0;k=f[g+44>>2]|0;f[k>>2]=f[s>>2];f[k+4>>2]=f[s+4>>2]}else p=54}if((p|0)==54)BR(g,h);s=h+16|0;f[I>>2]=f[s>>2];f[g+20>>2]=f[h+20>>2];f[g+24>>2]=f[h+24>>2];f[g+28>>2]=f[h+28>>2];f[g+32>>2]=f[h+32>>2];k=f[B>>2]|0;f[v>>2]=k;if(k|0?(A=k+12|0,k=f[A>>2]|0,f[A>>2]=k+-1,(k|0)==1):0)CR(h);f[B>>2]=0;k=h+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){s=f[h+40>>2]|0;A=0;do{f[s+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[k>>2]|0))}k=f[h+44>>2]|0;if((k|0)!=(h+48|0))ZF(k)}k=f[w>>2]|0;A=f[I>>2]|0;s=f[a>>2]|0;B=f[g>>2]|0;v=f[l>>2]|0;C=f[t>>2]|0;E=W1a(C|0,((C|0)<0)<<31>>31|0,v|0,((v|0)<0)<<31>>31|0)|0;if((s&16384&B|0)!=0?(E|0)==(E|0)&(((E|0)<0)<<31>>31|0)==(J|0):0){M=E;N=1}else{M=v;N=C}C=f[q>>2]|0;if((C|0)>0)O=f[(f[a+44>>2]|0)+(C+-1<<2)>>2]|0;else O=0;C=Y(O,M)|0;if(N|0){v=a+48|0;E=g+48|0;B=A;A=k;k=N;while(1){k=k+-1|0;K1a(B|0,A|0,C|0)|0;if(!k)break;else{B=B+(f[E>>2]|0)|0;A=A+(f[v>>2]|0)|0}}}}v=g+36|0;A=f[v>>2]|0;if(A|0?(E=A+12|0,A=f[E>>2]|0,f[E>>2]=A+-1,(A|0)==1):0)CR(g);f[v>>2]=0;v=g+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[v>>2]|0)>0){A=f[g+40>>2]|0;E=0;do{f[A+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[v>>2]|0))}v=f[g+44>>2]|0;if((v|0)!=(g+48|0))ZF(v)}while(0);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function fL(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0;e=u;u=u+288|0;g=e+280|0;h=e+224|0;i=e+168|0;j=e+112|0;k=e;l=e+104|0;m=e+88|0;n=e+72|0;o=e+32|0;p=e+64|0;_$(g,31912);do if((NS(d)|0)==65536){q=f[d+4>>2]|0;f[h>>2]=f[q>>2];r=h+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=h+8|0;f[t>>2]=f[q+8>>2];f[h+12>>2]=f[q+12>>2];v=h+16|0;f[v>>2]=f[q+16>>2];f[h+20>>2]=f[q+20>>2];f[h+24>>2]=f[q+24>>2];f[h+28>>2]=f[q+28>>2];f[h+32>>2]=f[q+32>>2];w=f[q+36>>2]|0;f[h+36>>2]=w;f[h+40>>2]=t;t=h+48|0;x=h+44|0;f[x>>2]=t;f[t>>2]=0;f[h+52>>2]=0;if(w|0){t=w+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;t=f[x>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];y=v;break}else{f[r>>2]=0;BR(h,q);y=v;break}}else{OR(h,d,-1);y=h+16|0}while(0);if(f[y>>2]|0){d=f[h>>2]|0;v=d>>>3&511;q=v+1|0;if(!((d&7|0)==0?((v|0)==0?1:(v|0)==((f[a>>2]|0)>>>3&511|0)):0)){f[i>>2]=0;f[i+4>>2]=0;z=c$(i,44)|0;A=159874;B=z+44|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-215,i,201110,159753,381);d$(i)}d=(v|0)==0;v=a+4|0;if((f[v>>2]|0)<3?(r=f[a+40>>2]|0,s=f[h+40>>2]|0,!((f[r>>2]|0)==(f[s>>2]|0)?(f[r+4>>2]|0)==(f[s+4>>2]|0):0)):0){f[i>>2]=0;f[i+4>>2]=0;z=c$(i,21)|0;A=159919;B=z+21|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-215,i,201110,159753,385);d$(i)}do if((NS(c)|0)==65536){A=f[c+4>>2]|0;f[j>>2]=f[A>>2];z=j+4|0;B=A+4|0;f[z>>2]=f[B>>2];s=j+8|0;f[s>>2]=f[A+8>>2];f[j+12>>2]=f[A+12>>2];r=j+16|0;f[r>>2]=f[A+16>>2];f[j+20>>2]=f[A+20>>2];f[j+24>>2]=f[A+24>>2];f[j+28>>2]=f[A+28>>2];f[j+32>>2]=f[A+32>>2];t=j+36|0;x=f[A+36>>2]|0;f[t>>2]=x;f[j+40>>2]=s;s=j+48|0;w=j+44|0;f[w>>2]=s;f[s>>2]=0;f[j+52>>2]=0;if(x|0){s=x+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[B>>2]|0)<3){B=f[A+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[B>>2];f[s+4>>2]=f[B+4>>2];C=r;D=t;break}else{f[z>>2]=0;BR(j,A);C=r;D=t;break}}else{OR(j,c,-1);C=j+16|0;D=j+36|0}while(0);t=f[C>>2]|0;r=f[D>>2]|0;if(r|0?(A=r+12|0,r=f[A>>2]|0,f[A>>2]=r+-1,(r|0)==1):0)CR(j);f[D>>2]=0;D=j+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[D>>2]|0)>0){C=f[j+40>>2]|0;r=0;do{f[C+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[D>>2]|0))}D=f[j+44>>2]|0;if((D|0)!=(j+48|0))ZF(D);MR(c,f[v>>2]|0,f[a+40>>2]|0,f[a>>2]&4095,-1,0,0);do if((NS(c)|0)==65536){D=f[c+4>>2]|0;f[i>>2]=f[D>>2];j=i+4|0;r=D+4|0;f[j>>2]=f[r>>2];C=i+8|0;f[C>>2]=f[D+8>>2];f[i+12>>2]=f[D+12>>2];A=i+16|0;f[A>>2]=f[D+16>>2];f[i+20>>2]=f[D+20>>2];f[i+24>>2]=f[D+24>>2];f[i+28>>2]=f[D+28>>2];f[i+32>>2]=f[D+32>>2];z=f[D+36>>2]|0;f[i+36>>2]=z;f[i+40>>2]=C;C=i+48|0;B=i+44|0;f[B>>2]=C;f[C>>2]=0;f[i+52>>2]=0;if(z|0){C=z+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[r>>2]|0)<3){r=f[D+44>>2]|0;C=f[B>>2]|0;f[C>>2]=f[r>>2];f[C+4>>2]=f[r+4>>2];E=A;break}else{f[j>>2]=0;BR(i,D);E=A;break}}else{OR(i,c,-1);E=i+16|0}while(0);if((f[E>>2]|0)!=(t|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;gL(i,k)|0}if(d){d=f[v>>2]|0;if((d|0)>0){t=f[(f[a+44>>2]|0)+(d+-1<<2)>>2]|0;f[k>>2]=t;if(t>>>0<33){F=d;G=t;H=45}else{I=d;K=142}}else{L=d;M=0;H=43}}else{L=f[v>>2]|0;M=1212424721>>>(f[a>>2]<<2&28)&15;H=43}if((H|0)==43){f[k>>2]=M;F=L;G=M;H=45}if((H|0)==45){H=f[31760+(G<<2)>>2]|0;I=F;K=(H|0)==0?142:H}if((I|0)<3){I=f[a>>2]|0;H=f[i>>2]|0;F=f[h>>2]|0;G=f[a+12>>2]|0;M=f[a+8>>2]|0;L=W1a(G|0,((G|0)<0)<<31>>31|0,q|0,0)|0;v=W1a(L|0,J|0,M|0,((M|0)<0)<<31>>31|0)|0;if((I&16384&H&F|0)!=0?(v|0)==(v|0)&(((v|0)<0)<<31>>31|0)==(J|0):0){N=v;O=1}else{N=Y(G,q)|0;O=M}M=f[a+16>>2]|0;G=f[a+48>>2]|0;v=f[y>>2]|0;F=f[h+48>>2]|0;H=f[E>>2]|0;I=f[i+48>>2]|0;f[l>>2]=N;f[l+4>>2]=O;Oh[K&255](M,G,v,F,H,I,l,k)}else{f[m>>2]=a;f[m+4>>2]=i;f[m+8>>2]=h;f[m+12>>2]=0;bU(o,m,n,-1);m=Y(f[o+20>>2]|0,q)|0;q=o+16|0;l=n+8|0;I=n+4|0;H=p+4|0;F=0;while(1){if(F>>>0>=(f[q>>2]|0)>>>0)break;v=f[n>>2]|0;G=f[l>>2]|0;M=f[I>>2]|0;f[p>>2]=m;f[H>>2]=1;Oh[K&255](v,0,G,0,M,0,p,k);tR(o)|0;F=F+1|0}}F=i+36|0;o=f[F>>2]|0;if(o|0?(k=o+12|0,o=f[k>>2]|0,f[k>>2]=o+-1,(o|0)==1):0)CR(i);f[F>>2]=0;F=i+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[F>>2]|0)>0){E=f[i+40>>2]|0;o=0;do{f[E+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[F>>2]|0))}F=f[i+44>>2]|0;if((F|0)!=(i+48|0))ZF(F)}else eL(a,c);c=h+36|0;a=f[c>>2]|0;if(a|0?(F=a+12|0,a=f[F>>2]|0,f[F>>2]=a+-1,(a|0)==1):0)CR(h);f[c>>2]=0;c=h+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[c>>2]|0)>0){y=f[h+40>>2]|0;a=0;do{f[y+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[c>>2]|0))}c=f[h+44>>2]|0;if((c|0)!=(h+48|0))ZF(c);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function gL(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+160|0;e=d+144|0;g=d+140|0;h=d+136|0;i=d+104|0;j=d;k=d+96|0;_$(e,31932);f[g>>2]=a;bU(i,g,h,1);g=f[a+4>>2]|0;if((g|0)>0)l=f[(f[a+44>>2]|0)+(g+-1<<2)>>2]|0;else l=0;g=Y(l,f[i+20>>2]|0)|0;l=c;a:do if((((f[l>>2]|0)==0&(f[l+4>>2]|0)==0?(m=c+8|0,(f[m>>2]|0)==0&(f[m+4>>2]|0)==0):0)?(m=c+16|0,(f[m>>2]|0)==0&(f[m+4>>2]|0)==0):0)?(m=c+24|0,(f[m>>2]|0)==0&(f[m+4>>2]|0)==0):0){m=i+16|0;n=0;while(1){if(n>>>0>=(f[m>>2]|0)>>>0)break a;F1a(f[h>>2]|0,0,g|0)|0;tR(i)|0;n=n+1|0}}else o=10;while(0);if((o|0)==10?(o=i+16|0,f[o>>2]|0):0){MS(c,j,f[a>>2]&4095,12);c=(1212424721>>>(f[a>>2]<<2&28)&15)*12|0;if(g|0){l=k+4|0;n=0;do{m=g-n|0;p=c>>>0>m>>>0?m:c;if(p>>>0>=97){f[k>>2]=0;f[l>>2]=0;m=c$(k,20)|0;q=159941;r=m+20|0;do{b[m>>0]=b[q>>0]|0;m=m+1|0;q=q+1|0}while((m|0)<(r|0));j$(-215,k,373345,159753,442);d$(k)}K1a((f[h>>2]|0)+n|0,j|0,p|0)|0;n=n+c|0}while(g>>>0>n>>>0)}if((f[o>>2]|0)>>>0>1){n=a+16|0;c=1;do{tR(i)|0;K1a(f[h>>2]|0,f[n>>2]|0,g|0)|0;c=c+1|0}while(c>>>0<(f[o>>2]|0)>>>0)}}if(!(f[e+4>>2]|0)){u=d;return a|0}u=d;return a|0}function hL(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;e=u;u=u+1232|0;g=e+1224|0;h=e+1168|0;i=e+1112|0;j=e+1104|0;k=e+1088|0;l=e;m=e+1048|0;n=e+8|0;o=e+1080|0;_$(g,31952);if(f[a+16>>2]|0){p=a+4|0;q=f[p>>2]|0;if((q|0)<3)r=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{s=f[a+40>>2]|0;t=0;v=1;while(1){w=Y(f[s+(t<<2)>>2]|0,v)|0;t=t+1|0;if((t|0)==(q|0)){r=w;break}else v=w}}if(!((q|0)==0|(r|0)==0)){do if((NS(c)|0)==65536){r=f[c+4>>2]|0;f[h>>2]=f[r>>2];q=h+4|0;v=r+4|0;f[q>>2]=f[v>>2];t=h+8|0;f[t>>2]=f[r+8>>2];f[h+12>>2]=f[r+12>>2];f[h+16>>2]=f[r+16>>2];f[h+20>>2]=f[r+20>>2];f[h+24>>2]=f[r+24>>2];f[h+28>>2]=f[r+28>>2];f[h+32>>2]=f[r+32>>2];s=f[r+36>>2]|0;f[h+36>>2]=s;f[h+40>>2]=t;t=h+48|0;w=h+44|0;f[w>>2]=t;f[t>>2]=0;f[h+52>>2]=0;if(s|0){t=s+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[v>>2]|0)<3){v=f[r+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[v>>2];f[t+4>>2]=f[v+4>>2];break}else{f[q>>2]=0;BR(h,r);break}}else OR(h,c,-1);while(0);do if((NS(d)|0)==65536){c=f[d+4>>2]|0;f[i>>2]=f[c>>2];r=i+4|0;q=c+4|0;f[r>>2]=f[q>>2];v=i+8|0;f[v>>2]=f[c+8>>2];f[i+12>>2]=f[c+12>>2];f[i+16>>2]=f[c+16>>2];f[i+20>>2]=f[c+20>>2];f[i+24>>2]=f[c+24>>2];f[i+28>>2]=f[c+28>>2];f[i+32>>2]=f[c+32>>2];t=f[c+36>>2]|0;f[i+36>>2]=t;f[i+40>>2]=v;v=i+48|0;w=i+44|0;f[w>>2]=v;f[v>>2]=0;f[i+52>>2]=0;if(t|0){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[q>>2]|0)<3){q=f[c+44>>2]|0;v=f[w>>2]|0;f[v>>2]=f[q>>2];f[v+4>>2]=f[q+4>>2];break}else{f[r>>2]=0;BR(i,c);break}}else OR(i,d,-1);while(0);d=f[a>>2]|0;c=h+4|0;if(((f[c>>2]|0)<=2?(r=f[h>>2]|0,(r&16384|0)!=0):0)?(q=f[h+40>>2]|0,v=f[q+4>>2]|0,w=f[q>>2]|0,q=(v|0)==1,t=(w|0)==1,q|t):0){s=(d>>>3&511)+1|0;if(!((v|0)==(s|0)&t|q&(t|(w|0)==(s|0)))?s>>>0>4|(r&4095|0)!=6|q&(w|0)==4^1:0)x=26}else x=26;if((x|0)==26){f[j>>2]=0;f[j+4>>2]=0;y=c$(j,60)|0;z=160058;A=y+60|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));j$(-215,j,176170,159753,514);d$(j)}w=(f[a>>2]|0)>>>3&511;q=f[i>>2]|0;r=q>>>3&511;s=r+1|0;t=i+16|0;a:do if(f[t>>2]|0){v=f[i+4>>2]|0;if((v|0)<3)B=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{d=f[i+40>>2]|0;C=0;D=1;while(1){E=Y(f[d+(C<<2)>>2]|0,D)|0;C=C+1|0;if((C|0)==(v|0)){B=E;break}else D=E}}if(!((v|0)==0|(B|0)==0)){b:do if(((q&7|0)==0?(r|0)==0|(r|0)==(w|0):0)?(D=f[a+40>>2]|0,C=f[D+-4>>2]|0,d=f[i+40>>2]|0,(C|0)==(f[d+-4>>2]|0)):0){if((C|0)==2){if((f[D>>2]|0)!=(f[d>>2]|0))break;if((f[D+4>>2]|0)==(f[d+4>>2]|0))break a;else break}if((C|0)>0)F=0;else break a;while(1){if((f[D+(F<<2)>>2]|0)!=(f[d+(F<<2)>>2]|0))break b;F=F+1|0;if((F|0)>=(C|0))break a}}while(0);f[j>>2]=0;f[j+4>>2]=0;y=c$(j,83)|0;z=160119;A=y+83|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));j$(-215,j,176170,159753,516);d$(j)}}while(0);if(!r){r=f[p>>2]|0;if((r|0)>0){p=f[(f[a+44>>2]|0)+(r+-1<<2)>>2]|0;f[j>>2]=p;if(p>>>0<33){G=p;x=48}else H=142}else{I=0;x=46}}else{I=1212424721>>>(f[a>>2]<<2&28)&15;x=46}if((x|0)==46){f[j>>2]=I;G=I;x=48}if((x|0)==48){I=f[31760+(G<<2)>>2]|0;H=(I|0)==0?142:I}f[k>>2]=a;if(f[t>>2]|0){I=f[i+4>>2]|0;if((I|0)<3)J=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{G=f[i+40>>2]|0;p=0;r=1;while(1){z=Y(f[G+(p<<2)>>2]|0,r)|0;p=p+1|0;if((p|0)==(I|0)){J=z;break}else r=z}}r=k+4|0;if((I|0)==0|(J|0)==0){K=r;x=56}else{L=i;M=r}}else{K=k+4|0;x=56}if((x|0)==56){L=0;M=K}f[M>>2]=L;f[k+8>>2]=0;L=l;f[L>>2]=0;f[L+4>>2]=0;bU(m,k,l,-1);k=Y(f[m+20>>2]|0,s)|0;L=f[j>>2]|0;M=((L+1023|0)>>>0)/(L>>>0)|0;K=(M|0)<(k|0)?M:k;M=K-((K|0)%(s|0)|0)|0;x=(Y(M,L)|0)+32|0;L=n+8|0;f[n>>2]=L;r=n+4|0;f[r>>2]=x;if(x>>>0>1032){J=OYa(x)|0;f[n>>2]=J;N=J}else N=L;J=N+7&-8;aG(h,f[a>>2]&4095,J,(K|0)/(s|0)|0);s=m+16|0;K=l+4|0;N=o+4|0;c:do if((k|0)>0){x=0;while(1){if(x>>>0>=(f[s>>2]|0)>>>0)break c;I=f[l>>2]|0;p=0;do{G=k-p|0;z=(G|0)<(M|0)?G:M;G=Y(f[j>>2]|0,z)|0;y=f[K>>2]|0;if(!y)K1a(I|0,J|0,G|0)|0;else{f[o>>2]=z;f[N>>2]=1;Oh[H&255](J,0,y,0,I,0,o,j);f[K>>2]=(f[K>>2]|0)+z}I=(f[l>>2]|0)+G|0;f[l>>2]=I;p=p+M|0}while((k|0)>(p|0));tR(m)|0;x=x+1|0}}else{x=0;while(1){if(x>>>0>=(f[s>>2]|0)>>>0)break c;tR(m)|0;x=x+1|0}}while(0);m=f[n>>2]|0;if((m|0)!=(L|0)){if(m|0)QYa(m);f[n>>2]=L;f[r>>2]=1032}r=i+36|0;L=f[r>>2]|0;if(L|0?(n=L+12|0,L=f[n>>2]|0,f[n>>2]=L+-1,(L|0)==1):0)CR(i);f[r>>2]=0;r=i+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[r>>2]|0)>0){t=f[i+40>>2]|0;L=0;do{f[t+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[r>>2]|0))}r=f[i+44>>2]|0;if((r|0)!=(i+48|0))ZF(r);r=h+36|0;i=f[r>>2]|0;if(i|0?(L=i+12|0,i=f[L>>2]|0,f[L>>2]=i+-1,(i|0)==1):0)CR(h);f[r>>2]=0;r=h+16|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[c>>2]|0)>0){r=f[h+40>>2]|0;i=0;do{f[r+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[c>>2]|0))}c=f[h+44>>2]|0;if((c|0)!=(h+48|0))ZF(c)}}if(!(f[g+4>>2]|0)){u=e;return a|0}u=e;return a|0}function iL(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;e=u;u=u+160|0;g=e+144|0;h=e+136|0;i=e+72|0;j=e+128|0;k=e+16|0;l=e+8|0;m=e;_$(g,31972);if((nS(a,-1)|0)>=3){f[h>>2]=0;f[h+4>>2]=0;n=c$(h,16)|0;o=176760;p=n+16|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-215,h,160251,159753,733);d$(h)}QR(h,a,-1);o=f[h>>2]|0;if((d|0)<0)q=(f[h+4>>2]|0)==1?1:(o|0)==1?0:d;else q=d;d=(o|0)==1;if((!((q|0)>0&d)?(o=h+4|0,n=(f[o>>2]|0)==1,!((q|0)==0&n)):0)?(p=(q|0)<0,!(p&d&n)):0){do if((NS(a)|0)==65536){n=f[a+4>>2]|0;f[i>>2]=f[n>>2];d=i+4|0;r=n+4|0;f[d>>2]=f[r>>2];s=i+8|0;f[s>>2]=f[n+8>>2];f[i+12>>2]=f[n+12>>2];f[i+16>>2]=f[n+16>>2];f[i+20>>2]=f[n+20>>2];f[i+24>>2]=f[n+24>>2];f[i+28>>2]=f[n+28>>2];f[i+32>>2]=f[n+32>>2];t=f[n+36>>2]|0;f[i+36>>2]=t;f[i+40>>2]=s;s=i+48|0;v=i+44|0;f[v>>2]=s;f[s>>2]=0;f[i+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[n+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];w=i;break}else{f[d>>2]=0;BR(i,n);w=i;break}}else{OR(i,a,-1);w=i}while(0);n=f[w>>2]|0;w=n&4095;f[j>>2]=f[h>>2];f[j+4>>2]=f[o>>2];KS(c,j,w,-1,0,0);do if((NS(c)|0)==65536){j=f[c+4>>2]|0;f[k>>2]=f[j>>2];o=k+4|0;h=j+4|0;f[o>>2]=f[h>>2];d=k+8|0;f[d>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];r=k+16|0;f[r>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];s=f[j+36>>2]|0;f[k+36>>2]=s;f[k+40>>2]=d;d=k+48|0;v=k+44|0;f[v>>2]=d;f[d>>2]=0;f[k+52>>2]=0;if(s|0){t=s+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[h>>2]|0)<3){h=f[j+44>>2]|0;t=f[v>>2]|0;f[t>>2]=f[h>>2];f[t+4>>2]=f[h+4>>2];x=d;y=r;z=v;break}else{f[o>>2]=0;BR(k,j);x=d;y=r;z=v;break}}else{OR(k,c,-1);x=k+48|0;y=k+16|0;z=k+44|0}while(0);v=(n>>>3&511)+1<<(47696>>>(w<<1&14)&3);w=i+16|0;n=f[w>>2]|0;r=i+44|0;d=i+48|0;j=f[d>>2]|0;o=f[y>>2]|0;h=f[x>>2]|0;t=i+40|0;s=f[t>>2]|0;A=f[s+4>>2]|0;B=f[s>>2]|0;a:do if((q|0)<1){s=B+-1|0;C=Y(A,v)|0;if((B|0)>0){D=o+(Y(s,h)|0)|0;E=n+(Y(s,j)|0)|0;s=0-j|0;F=0-h|0;G=C+-4|0;H=C+-16|0;I=(B+1|0)/2|0;if((C|0)<16){J=C&-4;K=(C|0)<4;L=o;M=D;N=n;O=E;P=0;while(1){if(((L|N|O|M)&3|0)!=0|K)Q=0;else{R=0;do{S=f[N+R>>2]|0;f[L+R>>2]=f[O+R>>2];f[M+R>>2]=S;R=R+4|0}while((R|0)<=(G|0));Q=J}if((Q|0)<(C|0)){R=Q;do{S=b[N+R>>0]|0;b[L+R>>0]=b[O+R>>0]|0;b[M+R>>0]=S;R=R+1|0}while((R|0)!=(C|0))}P=P+1|0;if((P|0)>=(I|0))break a;else{L=L+h|0;M=M+F|0;N=N+j|0;O=O+s|0}}}O=C&-16;N=(O|0)>(G|0);M=o;L=D;P=n;J=E;K=0;while(1){if(!((M|P|J|L)&3)){R=0;do{S=P+R|0;T=f[S>>2]|0;U=J+R|0;V=M+R|0;f[V>>2]=f[U>>2];W=L+R|0;f[W>>2]=T;T=f[S+4>>2]|0;f[V+4>>2]=f[U+4>>2];f[W+4>>2]=T;T=f[S+8>>2]|0;f[V+8>>2]=f[U+8>>2];f[W+8>>2]=T;T=f[S+12>>2]|0;f[V+12>>2]=f[U+12>>2];f[W+12>>2]=T;R=R+16|0}while((R|0)<=(H|0));if(N)X=O;else{R=O;while(1){T=f[P+R>>2]|0;f[M+R>>2]=f[J+R>>2];f[L+R>>2]=T;T=R+4|0;if((T|0)>(G|0)){X=T;break}else R=T}}}else X=0;if((X|0)<(C|0)){R=X;do{T=b[P+R>>0]|0;b[M+R>>0]=b[J+R>>0]|0;b[L+R>>0]=T;R=R+1|0}while((R|0)!=(C|0))}K=K+1|0;if((K|0)>=(I|0))break;else{M=M+h|0;L=L+F|0;P=P+j|0;J=J+s|0}}}}else{f[l>>2]=A;f[l+4>>2]=B;jL(n,j,o,h,l,v)}while(0);if(p){p=f[y>>2]|0;l=f[x>>2]|0;h=f[k+40>>2]|0;o=f[h>>2]|0;f[m>>2]=f[h+4>>2];f[m+4>>2]=o;jL(p,l,p,l,m,v)}v=k+36|0;m=f[v>>2]|0;if(m|0?(l=m+12|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0)CR(k);f[v>>2]=0;v=k+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[v>>2]|0)>0){y=f[k+40>>2]|0;k=0;do{f[y+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[v>>2]|0))}v=f[z>>2]|0;if((v|0)!=(x|0))ZF(v);v=i+36|0;x=f[v>>2]|0;if(x|0?(z=x+12|0,x=f[z>>2]|0,f[z>>2]=x+-1,(x|0)==1):0)CR(i);f[v>>2]=0;v=i+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[v>>2]|0)>0){w=f[t>>2]|0;t=0;do{f[w+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[v>>2]|0))}v=f[r>>2]|0;if((v|0)!=(d|0))ZF(v)}else ZS(a,c);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function jL(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;i=u;u=u+1072|0;j=i;k=f[g>>2]|0;l=Y((k+1|0)/2|0,h)|0;m=Y(k,h)|0;n=j+8|0;f[j>>2]=n;o=j+4|0;f[o>>2]=m;if(m>>>0>264){p=OYa(m>>>0>1073741823?-1:m<<2)|0;f[j>>2]=p;q=p}else q=n;a:do if((k|0)>0){if(!h){p=0;while(1){p=p+1|0;if((p|0)>=(k|0))break a}}p=f[g>>2]|0;m=(h|0)==1;r=k;s=0;while(1){t=~s;v=Y(s,h)|0;w=Y(r+t|0,h)|0;f[q+(v<<2)>>2]=w;if(!m){w=Y((f[g>>2]|0)+t|0,h)|0;t=1;do{f[q+(t+v<<2)>>2]=w+t;t=t+1|0}while((t|0)!=(h|0))}t=s+1|0;if((t|0)<(p|0)){r=p;s=t}else break}}while(0);h=g+4|0;g=f[h>>2]|0;k=g+-1|0;f[h>>2]=k;do if(!g)x=q;else{if((l|0)>0){y=d;z=a}else{s=k;do{p=s;s=s+-1|0}while((p|0)!=0);f[h>>2]=s;x=q;break}while(1){p=0;do{r=f[q+(p<<2)>>2]|0;m=b[z+p>>0]|0;b[y+p>>0]=b[z+r>>0]|0;b[y+r>>0]=m;p=p+1|0}while((p|0)!=(l|0));p=f[h>>2]|0;f[h>>2]=p+-1;if(!p)break;else{y=y+e|0;z=z+c|0}}x=f[j>>2]|0}while(0);if((x|0)==(n|0)){u=i;return}if(x|0)QYa(x);f[j>>2]=n;f[o>>2]=264;u=i;return}function kL(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;g=u;u=u+128|0;h=g+120|0;i=g+112|0;j=g+56|0;k=g;_$(h,31992);l=a+4|0;m=e+4|0;if((f[l>>2]|0)==(f[m>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;n=c$(i,30)|0;o=160300;p=n+30|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-215,i,160331,159753,853);d$(i)}if((nS(a,-1)|0)>=3){f[i>>2]=0;f[i+4>>2]=0;n=c$(i,16)|0;o=176760;p=n+16|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-215,i,160331,159753,854);d$(i)}if(!((c|0)>0&(d|0)>0)){f[i>>2]=0;f[i+4>>2]=0;n=c$(i,16)|0;o=160338;p=n+16|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-215,i,160331,159753,855);d$(i)}QR(i,a,-1);o=i+4|0;n=f[o>>2]|0;p=f[i>>2]|0;pS(e,Y(n,c)|0,Y(p,d)|0,RR(a,-1)|0,-1,0,0);do if((NS(a)|0)==65536){d=f[l>>2]|0;f[j>>2]=f[d>>2];p=j+4|0;c=d+4|0;f[p>>2]=f[c>>2];n=j+8|0;f[n>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];f[j+16>>2]=f[d+16>>2];f[j+20>>2]=f[d+20>>2];f[j+24>>2]=f[d+24>>2];f[j+28>>2]=f[d+28>>2];f[j+32>>2]=f[d+32>>2];q=f[d+36>>2]|0;f[j+36>>2]=q;f[j+40>>2]=n;n=j+48|0;r=j+44|0;f[r>>2]=n;f[n>>2]=0;f[j+52>>2]=0;if(q|0){n=q+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[c>>2]|0)<3){c=f[d+44>>2]|0;n=f[r>>2]|0;f[n>>2]=f[c>>2];f[n+4>>2]=f[c+4>>2];break}else{f[p>>2]=0;BR(j,d);break}}else OR(j,a,-1);while(0);do if((NS(e)|0)==65536){a=f[m>>2]|0;f[k>>2]=f[a>>2];l=k+4|0;d=a+4|0;f[l>>2]=f[d>>2];p=k+8|0;f[p>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];c=f[a+36>>2]|0;f[k+36>>2]=c;n=k+40|0;f[n>>2]=p;p=k+48|0;r=k+44|0;f[r>>2]=p;f[p>>2]=0;f[k+52>>2]=0;if(c|0){p=c+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[d>>2]|0)<3){d=f[a+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[d>>2];f[p+4>>2]=f[d+4>>2];s=n;break}else{f[l>>2]=0;BR(k,a);s=n;break}}else{OR(k,e,-1);s=k+40|0}while(0);e=f[s>>2]|0;m=f[e+4>>2]|0;n=f[e>>2]|0;e=j+4|0;a=f[e>>2]|0;if((a|0)>0)t=f[(f[j+44>>2]|0)+(a+-1<<2)>>2]|0;else t=0;a=Y(f[i>>2]|0,t)|0;f[i>>2]=a;l=Y(t,m)|0;m=f[o>>2]|0;a:do if((m|0)>0){t=k+16|0;d=k+44|0;p=j+16|0;r=j+44|0;if((l|0)>0){v=a;w=0}else{c=0;while(1){q=c+1|0;if((q|0)<(m|0))c=q;else{x=m;y=q;break a}}}while(1){c=v;q=0;do{z=(f[t>>2]|0)+(Y(f[f[d>>2]>>2]|0,w)|0)+q|0;K1a(z|0,(f[p>>2]|0)+(Y(f[f[r>>2]>>2]|0,w)|0)|0,c|0)|0;c=f[i>>2]|0;q=c+q|0}while((q|0)<(l|0));q=w+1|0;z=f[o>>2]|0;if((q|0)<(z|0)){v=c;w=q}else{x=z;y=q;break}}}else{x=m;y=0}while(0);if((y|0)<(n|0)?(m=k+16|0,w=k+44|0,v=f[m>>2]|0,i=f[f[w>>2]>>2]|0,K1a(v+(Y(i,y)|0)|0,v+(Y(y-x|0,i)|0)|0,l|0)|0,i=y+1|0,(i|0)!=(n|0)):0){y=i;do{i=f[m>>2]|0;x=f[f[w>>2]>>2]|0;K1a(i+(Y(x,y)|0)|0,i+(Y(y-(f[o>>2]|0)|0,x)|0)|0,l|0)|0;y=y+1|0}while((y|0)!=(n|0))}n=k+36|0;y=f[n>>2]|0;if(y|0?(l=y+12|0,y=f[l>>2]|0,f[l>>2]=y+-1,(y|0)==1):0)CR(k);f[n>>2]=0;n=k+16|0;y=k+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[y>>2]|0)>0){n=f[s>>2]|0;s=0;do{f[n+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[y>>2]|0))}y=f[k+44>>2]|0;if((y|0)!=(k+48|0))ZF(y);y=j+36|0;k=f[y>>2]|0;if(k|0?(s=k+12|0,k=f[s>>2]|0,f[s>>2]=k+-1,(k|0)==1):0)CR(j);f[y>>2]=0;y=j+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[e>>2]|0)>0){y=f[j+40>>2]|0;k=0;do{f[y+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[e>>2]|0))}e=f[j+44>>2]|0;if((e|0)!=(j+48|0))ZF(e);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function lL(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;if(a>>>0<c>>>0){h=a;u=e;return h|0}switch(d|0){case 1:{h=(a|0)<0?0:c+-1|0;u=e;return h|0}case 2:case 4:{i=(d|0)==4;d=i&1;if((c|0)==1){h=0;u=e;return h|0}j=(c<<1)+-1+(i<<31>>31)|0;i=a;while(1){k=(i|0)<0?d+~i|0:j-i|0;if(k>>>0<c>>>0){h=k;break}else i=k}u=e;return h|0}case 3:{if((c|0)<=0){f[g>>2]=0;f[g+4>>2]=0;i=c$(g,7)|0;b[i>>0]=b[184007]|0;b[i+1>>0]=b[184008]|0;b[i+2>>0]=b[184009]|0;b[i+3>>0]=b[184010]|0;b[i+4>>0]=b[184011]|0;b[i+5>>0]=b[184012]|0;b[i+6>>0]=b[184013]|0;j$(-215,g,160406,159753,927);d$(g)}i=a-c|0;if((a|0)<0)l=~i+a+((i+1|0)%(c|0)|0)|0;else l=a;if((l|0)<(c|0)){h=l;u=e;return h|0}h=(l|0)%(c|0)|0;u=e;return h|0}case 0:{h=-1;u=e;return h|0}default:{f[g>>2]=0;f[g+4>>2]=0;c=c$(g,31)|0;l=160424;i=c+31|0;do{b[c>>0]=b[l>>0]|0;c=c+1|0;l=l+1|0}while((c|0)<(i|0));j$(-5,g,160406,159753,936);d$(g);h=a;u=e;return h|0}}return 0}function mL(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;k=u;u=u+2288|0;l=k+1216|0;m=k+1208|0;n=k+1152|0;o=k+1096|0;q=k;_$(m,32012);if((e|d|g|h|0)<=-1){f[l>>2]=0;f[l+4>>2]=0;r=c$(l,50)|0;s=160456;t=r+50|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-215,l,160507,159753,1172);d$(l)}do if((NS(a)|0)==65536){v=f[a+4>>2]|0;f[n>>2]=f[v>>2];w=n+4|0;x=v+4|0;f[w>>2]=f[x>>2];y=n+8|0;f[y>>2]=f[v+8>>2];f[n+12>>2]=f[v+12>>2];f[n+16>>2]=f[v+16>>2];f[n+20>>2]=f[v+20>>2];f[n+24>>2]=f[v+24>>2];f[n+28>>2]=f[v+28>>2];f[n+32>>2]=f[v+32>>2];z=f[v+36>>2]|0;f[n+36>>2]=z;f[n+40>>2]=y;y=n+48|0;A=n+44|0;f[A>>2]=y;f[y>>2]=0;f[n+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[v+44>>2]|0;y=f[A>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];B=n;break}else{f[w>>2]=0;BR(n,v);B=n;break}}else{OR(n,a,-1);B=n}while(0);a=f[B>>2]|0;if((i&16|0)==0&(a&32768|0)!=0){f[l>>2]=0;v=l+4|0;f[v>>2]=0;f[o>>2]=0;w=o+4|0;f[w>>2]=0;KR(n,l,o);x=f[w>>2]|0;w=(x|0)>(d|0)?d:x;y=n+8|0;A=(f[v>>2]|0)-(f[y>>2]|0)-x|0;x=(A|0)>(e|0)?e:A;A=f[o>>2]|0;v=(A|0)>(g|0)?g:A;z=n+12|0;C=(f[l>>2]|0)-(f[z>>2]|0)-A|0;A=(C|0)>(h|0)?h:C;LR(n,w,x,v,A)|0;D=e-x|0;E=z;F=g-v|0;G=h-A|0;H=y;I=d-w|0}else{D=e;E=n+12|0;F=g;G=h;H=n+8|0;I=d}pS(c,I+D+(f[H>>2]|0)|0,F+G+(f[E>>2]|0)|0,a&4095,-1,0,0);do if((NS(c)|0)==65536){a=f[c+4>>2]|0;f[o>>2]=f[a>>2];E=o+4|0;H=a+4|0;f[E>>2]=f[H>>2];d=o+8|0;f[d>>2]=f[a+8>>2];f[o+12>>2]=f[a+12>>2];f[o+16>>2]=f[a+16>>2];f[o+20>>2]=f[a+20>>2];f[o+24>>2]=f[a+24>>2];f[o+28>>2]=f[a+28>>2];f[o+32>>2]=f[a+32>>2];h=f[a+36>>2]|0;f[o+36>>2]=h;f[o+40>>2]=d;d=o+48|0;g=o+44|0;f[g>>2]=d;f[d>>2]=0;f[o+52>>2]=0;if(h|0){d=h+12|0;f[d>>2]=(f[d>>2]|0)+1}if((f[H>>2]|0)<3){H=f[a+44>>2]|0;d=f[g>>2]|0;f[d>>2]=f[H>>2];f[d+4>>2]=f[H+4>>2];break}else{f[E>>2]=0;BR(o,a);break}}else OR(o,c,-1);while(0);do if(F|G|D|I){c=i&-17;if(!c){a=f[B>>2]|0;E=(a>>>3&511)+1|0;H=q+8|0;f[q>>2]=H;d=q+4|0;f[d>>2]=E;if(E>>>0<=136)if(E>>>0>4){J=H;K=87}else{L=a;M=H;N=E}else{g=OYa(E<<3)|0;f[q>>2]=g;J=g;K=87}do if((K|0)==87){O=+p[j>>3];if((O==+p[j+8>>3]?O==+p[j+16>>3]:0)?O==+p[j+24>>3]:0){L=a;M=J;N=1;break}f[l>>2]=0;f[l+4>>2]=0;r=c$(l,68)|0;s=160522;t=r+68|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-215,l,160507,159753,1220);d$(l);L=f[B>>2]|0;M=f[q>>2]|0;N=1}while(0);MS(j,M,L&7|(N<<3)+-8,E);a=f[n+16>>2]|0;g=f[n+48>>2]|0;h=f[n+40>>2]|0;e=f[h+4>>2]|0;w=f[h>>2]|0;h=f[o+16>>2]|0;y=f[o+48>>2]|0;A=f[o+40>>2]|0;v=f[A+4>>2]|0;z=f[A>>2]|0;A=f[n+4>>2]|0;if((A|0)>0)P=f[(f[n+44>>2]|0)+(A+-1<<2)>>2]|0;else P=0;A=f[q>>2]|0;x=Y(P,v)|0;C=l+8|0;f[l>>2]=C;Q=l+4|0;f[Q>>2]=x;if(x>>>0>1032){R=OYa(x)|0;f[l>>2]=R;S=R}else S=C;R=v-(e+F)|0;T=z-I-w|0;if((v|0)>0&(P|0)>0){z=0;do{U=Y(z,P)|0;V=0;do{b[S+(V+U)>>0]=b[A+V>>0]|0;V=V+1|0}while((V|0)!=(P|0));z=z+1|0}while((z|0)!=(v|0))}v=Y(P,e)|0;z=Y(P,F)|0;A=Y(P,R)|0;E=h+(Y(y,I)|0)|0;if((w|0)>0){V=0-z|0;U=E+z|0;W=0;X=a;while(1){if((U|0)!=(X|0))K1a(U|0,X|0,v|0)|0;K1a(U+V|0,S|0,z|0)|0;K1a(U+v|0,S|0,A|0)|0;W=W+1|0;if((W|0)==(w|0))break;else{U=U+y|0;X=X+g|0}}}if((I|0)>0){g=0;do{K1a(E+(Y(g-I|0,y)|0)|0,S|0,x|0)|0;g=g+1|0}while((g|0)!=(I|0))}if((T|0)>0){g=0;do{K1a(E+(Y(g+w|0,y)|0)|0,S|0,x|0)|0;g=g+1|0}while((g|0)!=(T|0))}T=f[l>>2]|0;if((T|0)!=(C|0)){if(T|0)QYa(T);f[l>>2]=C;f[Q>>2]=1032}T=f[q>>2]|0;if((T|0)!=(H|0)){if(T|0)QYa(T);f[q>>2]=H;f[d>>2]=136}break}T=f[n+16>>2]|0;g=f[n+48>>2]|0;x=f[n+40>>2]|0;y=f[x+4>>2]|0;w=f[x>>2]|0;x=f[o+16>>2]|0;E=f[o+48>>2]|0;X=f[o+40>>2]|0;U=f[X+4>>2]|0;W=f[X>>2]|0;X=f[n+4>>2]|0;if((X|0)>0)Z=f[(f[n+44>>2]|0)+(X+-1<<2)>>2]|0;else Z=0;X=((T|g|E|x|Z)&3|0)==0;A=X?4:1;v=X?(Z|0)/4|0:Z;z=U-y|0;V=Y(v,z)|0;a=l+8|0;f[l>>2]=a;h=l+4|0;f[h>>2]=V;if(V>>>0>264){R=OYa(V>>>0>1073741823?-1:V<<2)|0;f[l>>2]=R;_=R}else _=a;R=z-F|0;z=W-I-w|0;a:do if((F|0)>0){if((v|0)>0)$=0;else{W=0;while(1){lL(W-F|0,y,c)|0;W=W+1|0;if((W|0)>=(F|0))break a}}do{W=Y(lL($-F|0,y,c)|0,v)|0;V=Y($,v)|0;e=0;do{f[_+(e+V<<2)>>2]=e+W;e=e+1|0}while((e|0)!=(v|0));$=$+1|0}while(($|0)<(F|0))}while(0);b:do if((R|0)>0){if((v|0)>0)aa=0;else{d=0;while(1){lL(d+y|0,y,c)|0;d=d+1|0;if((d|0)>=(R|0))break b}}do{d=Y(lL(aa+y|0,y,c)|0,v)|0;H=Y(aa+F|0,v)|0;Q=0;do{f[_+(Q+H<<2)>>2]=Q+d;Q=Q+1|0}while((Q|0)!=(v|0));aa=aa+1|0}while((aa|0)<(R|0))}while(0);Q=Y(v,y)|0;d=Y(v,U)|0;H=Y(v,F)|0;C=Y(v,R)|0;e=x+(Y(E,I)|0)|0;W=e+(Y(H,A)|0)|0;c:do if((w|0)>0){V=(H|0)>0;ba=(C|0)>0;ca=Y(Q,A)|0;if(!X){if(V){da=W;ea=0;fa=T;while(1){if((da|0)==(fa|0))ga=0;else{K1a(da|0,fa|0,ca|0)|0;ga=0}do{b[da+(ga-H)>>0]=b[fa+(f[_+(ga<<2)>>2]|0)>>0]|0;ga=ga+1|0}while((ga|0)!=(H|0));if(ba){ha=0;do{b[da+(ha+Q)>>0]=b[fa+(f[_+(ha+H<<2)>>2]|0)>>0]|0;ha=ha+1|0}while((ha|0)!=(C|0))}ea=ea+1|0;if((ea|0)==(w|0))break c;else{da=da+E|0;fa=fa+g|0}}}if(ba){ia=W;ja=0;ka=T}else{fa=W;da=0;ea=T;while(1){if((fa|0)!=(ea|0))K1a(fa|0,ea|0,ca|0)|0;da=da+1|0;if((da|0)==(w|0))break c;else{fa=fa+E|0;ea=ea+g|0}}}while(1){if((ia|0)==(ka|0))la=0;else{K1a(ia|0,ka|0,ca|0)|0;la=0}do{b[ia+(la+Q)>>0]=b[ka+(f[_+(la+H<<2)>>2]|0)>>0]|0;la=la+1|0}while((la|0)!=(C|0));ja=ja+1|0;if((ja|0)==(w|0))break c;else{ia=ia+E|0;ka=ka+g|0}}}if(V){ea=W;fa=0;da=T;while(1){if((ea|0)!=(da|0))K1a(ea|0,da|0,ca|0)|0;ha=0;do{f[ea+(ha-H<<2)>>2]=f[da+(f[_+(ha<<2)>>2]<<2)>>2];ha=ha+1|0}while((ha|0)!=(H|0));if(ba){ha=0;do{f[ea+(ha+Q<<2)>>2]=f[da+(f[_+(ha+H<<2)>>2]<<2)>>2];ha=ha+1|0}while((ha|0)!=(C|0))}fa=fa+1|0;if((fa|0)==(w|0))break c;else{ea=ea+E|0;da=da+g|0}}}if(ba){ma=W;na=0;oa=T}else{da=W;ea=0;fa=T;while(1){if((da|0)!=(fa|0))K1a(da|0,fa|0,ca|0)|0;ea=ea+1|0;if((ea|0)==(w|0))break c;else{da=da+E|0;fa=fa+g|0}}}while(1){if((ma|0)!=(oa|0))K1a(ma|0,oa|0,ca|0)|0;fa=0;do{f[ma+(fa+Q<<2)>>2]=f[oa+(f[_+(fa+H<<2)>>2]<<2)>>2];fa=fa+1|0}while((fa|0)!=(C|0));na=na+1|0;if((na|0)==(w|0))break;else{ma=ma+E|0;oa=oa+g|0}}}while(0);g=Y(d,A)|0;if((I|0)>0){C=0;do{H=C-I|0;K1a(e+(Y(H,E)|0)|0,e+(Y(lL(H,w,c)|0,E)|0)|0,g|0)|0;C=C+1|0}while((C|0)<(I|0))}if((z|0)>0){C=0;do{A=C+w|0;K1a(e+(Y(A,E)|0)|0,e+(Y(lL(A,w,c)|0,E)|0)|0,g|0)|0;C=C+1|0}while((C|0)<(z|0))}z=f[l>>2]|0;if((z|0)!=(a|0)){if(z|0)QYa(z);f[l>>2]=a;f[h>>2]=264}}else{if((f[n+16>>2]|0)==(f[o+16>>2]|0)?(f[n+48>>2]|0)==(f[o+48>>2]|0):0)break;z=l+8|0;f[z>>2]=0;f[z+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=o;eL(n,l)}while(0);l=o+36|0;I=f[l>>2]|0;if(I|0?(oa=I+12|0,I=f[oa>>2]|0,f[oa>>2]=I+-1,(I|0)==1):0)CR(o);f[l>>2]=0;l=o+16|0;I=o+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[I>>2]|0)>0){l=f[o+40>>2]|0;oa=0;do{f[l+(oa<<2)>>2]=0;oa=oa+1|0}while((oa|0)<(f[I>>2]|0))}I=f[o+44>>2]|0;if((I|0)!=(o+48|0))ZF(I);I=n+36|0;o=f[I>>2]|0;if(o|0?(oa=o+12|0,o=f[oa>>2]|0,f[oa>>2]=o+-1,(o|0)==1):0)CR(n);f[I>>2]=0;I=n+16|0;o=n+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[o>>2]|0)>0){I=f[n+40>>2]|0;oa=0;do{f[I+(oa<<2)>>2]=0;oa=oa+1|0}while((oa|0)<(f[o>>2]|0))}o=f[n+44>>2]|0;if((o|0)!=(n+48|0))ZF(o);if(!(f[m+4>>2]|0)){u=k;return}u=k;return}function nL(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=u;u=u+208|0;g=e+144|0;h=e+88|0;i=e+72|0;j=e+56|0;k=e;l=(a|0)!=0;if((l?(c|0?(f[a>>2]&-65536|0)==1111752704:0):0)?(f[c>>2]&-65536|0)==1111752704:0){if(d|0){f[g>>2]=0;f[g+4>>2]=0;m=c$(g,12)|0;n=160681;o=m+12|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,g,160694,159753,1236);d$(g)}p=a+4|0;f[c+4>>2]=f[p>>2];K1a(c+36|0,a+36|0,f[p>>2]<<2|0)|0;f[c+28>>2]=f[a+28>>2];f[c+32>>2]=f[a+32>>2];p=c+16|0;WL(f[p>>2]|0);q=c+24|0;r=f[q>>2]|0;s=c+20|0;if((f[(f[a+16>>2]|0)+60>>2]|0)<(r*3|0)){t=s;v=r;w=f[s>>2]|0}else{$F(f[s>>2]|0);f[s>>2]=0;r=f[a+24>>2]|0;f[q>>2]=r;x=_F(r<<2)|0;f[s>>2]=x;t=s;v=f[q>>2]|0;w=x}F1a(w|0,0,v<<2|0)|0;v=K0(a,h)|0;a:do if(v|0){w=h+4|0;x=h+8|0;s=v;while(1){r=f[p>>2]|0;y=r+56|0;z=f[y>>2]|0;f[g>>2]=z;if(!z){VL(r,0,g)|0;A=f[p>>2]|0;B=f[g>>2]|0}else{f[y>>2]=f[z+4>>2];f[z>>2]=f[z>>2]&67108863;y=r+60|0;f[y>>2]=(f[y>>2]|0)+1;A=r;B=z}z=(f[q>>2]|0)+-1&f[s>>2];K1a(B|0,s|0,f[A+28>>2]|0)|0;r=(f[t>>2]|0)+(z<<2)|0;f[B+4>>2]=f[r>>2];f[r>>2]=B;r=f[(f[w>>2]|0)+4>>2]|0;if(!r){z=(f[x>>2]|0)+1|0;f[x>>2]=z;y=f[h>>2]|0;C=f[y+24>>2]|0;if((z|0)>=(C|0))break a;D=f[y+20>>2]|0;y=z;while(1){E=f[D+(y<<2)>>2]|0;if(E|0)break;z=y+1|0;if((z|0)<(C|0))y=z;else break a}f[x>>2]=y;F=E}else F=r;f[w>>2]=F;s=F}}while(0);u=e;return}JR(g,a,0,1,1,0);JR(h,c,0,1,1,0);b:do if(((f[h>>2]^f[g>>2])&7|0)==0?(F=f[g+40>>2]|0,E=f[F+-4>>2]|0,B=f[h+40>>2]|0,(E|0)==(f[B+-4>>2]|0)):0){if((E|0)==2){if((f[F>>2]|0)!=(f[B>>2]|0)){G=30;break}if((f[F+4>>2]|0)==(f[B+4>>2]|0))break;else{G=30;break}}if((E|0)>0){t=0;do{if((f[F+(t<<2)>>2]|0)!=(f[B+(t<<2)>>2]|0)){G=30;break b}t=t+1|0}while((t|0)<(E|0))}}else G=30;while(0);if((G|0)==30){f[i>>2]=0;f[i+4>>2]=0;m=c$(i,50)|0;n=160701;o=m+50|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,i,160694,159753,1270);d$(i)}if((l?(f[a>>2]|0)==112:0)?(f[a+68>>2]|0)!=0:0)H=Y0(a)|0;else H=0;if(((c|0)!=0?(f[c>>2]|0)==112:0)?(f[c+68>>2]|0)!=0:0)I=Y0(c)|0;else I=0;c=(I|0)==0;do if(!(I|H)){if((f[h>>2]^f[g>>2])&4088|0){f[i>>2]=0;f[i+4>>2]=0;m=c$(i,32)|0;n=160825;o=m+32|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,i,160694,159753,1288);d$(i)}if(!d){a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=h;eL(g,i);break}a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=h;JR(k,d,0,1,0,0);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=k;fL(g,i,j);a=k+36|0;l=f[a>>2]|0;if(l|0?(E=l+12|0,l=f[E>>2]|0,f[E>>2]=l+-1,(l|0)==1):0)CR(k);f[a>>2]=0;a=k+16|0;l=k+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[l>>2]|0)>0){a=f[k+40>>2]|0;E=0;do{f[a+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))ZF(l)}else{if((H|0)==0?(f[g>>2]&4088|0)!=0:0)G=44;else G=42;if(((G|0)==42?c:0)?f[h>>2]&4088|0:0)G=44;if((G|0)==44){f[i>>2]=0;f[i+4>>2]=0;m=c$(i,72)|0;n=160752;o=m+72|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,i,160694,159753,1281);d$(i)}l=H+-1|0;f[i>>2]=(l|0)>0?l:0;l=I+-1|0;f[i+4>>2]=(l|0)>0?l:0;II(g,1,h,1,i,1)}while(0);i=h+36|0;I=f[i>>2]|0;if(I|0?(H=I+12|0,I=f[H>>2]|0,f[H>>2]=I+-1,(I|0)==1):0)CR(h);f[i>>2]=0;i=h+16|0;I=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[I>>2]|0)>0){i=f[h+40>>2]|0;H=0;do{f[i+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[I>>2]|0))}I=f[h+44>>2]|0;if((I|0)!=(h+48|0))ZF(I);I=g+36|0;h=f[I>>2]|0;if(h|0?(H=h+12|0,h=f[H>>2]|0,f[H>>2]=h+-1,(h|0)==1):0)CR(g);f[I>>2]=0;I=g+16|0;h=g+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[h>>2]|0)>0){I=f[g+40>>2]|0;H=0;do{f[I+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)!=(g+48|0))ZF(h);u=e;return}function oL(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+96|0;c=b+32|0;d=b;if(a|0?(f[a>>2]&-65536|0)==1111752704:0){WL(f[a+16>>2]|0);e=f[a+20>>2]|0;if(!e){u=b;return}F1a(e|0,0,f[a+24>>2]<<2|0)|0;u=b;return}JR(c,a,0,1,0,0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;gL(c,d)|0;d=c+36|0;a=f[d>>2]|0;if(a|0?(e=a+12|0,a=f[e>>2]|0,f[e>>2]=a+-1,(a|0)==1):0)CR(c);f[d>>2]=0;d=c+16|0;a=c+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[a>>2]|0)>0){d=f[c+40>>2]|0;e=0;do{f[d+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[a>>2]|0))}a=f[c+44>>2]|0;if((a|0)!=(c+48|0))ZF(a);u=b;return}function pL(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;d=_F(24)|0;if(!d){f[c>>2]=0;f[c+4>>2]=0;j$(-27,c,160858,160876,92);d$(c)}c=d+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[d>>2]=1116274688;f[d+16>>2]=(a|0)<1?65408:a+7&-8;u=b;return d|0}function qL(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;j$(-27,c,160929,160876,121);d$(c)}d=f[a+16>>2]|0;e=_F(24)|0;if(!e){f[c>>2]=0;f[c+4>>2]=0;j$(-27,c,160858,160876,92);d$(c)}c=e+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[e>>2]=1116274688;f[e+16>>2]=(d|0)<1?65408:d+7&-8;f[e+12>>2]=a;u=b;return e|0}function rL(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;j$(-27,c,160953,160876,183);d$(c)}c=f[a>>2]|0;f[a>>2]=0;if(!c){u=b;return}a=c+12|0;d=f[a>>2]|0;if(!d)e=0;else e=f[d+8>>2]|0;g=c+4|0;h=f[g>>2]|0;a:do if(!h)i=c+20|0;else{j=c+16|0;k=c+20|0;l=h;m=d;n=e;while(1){o=l+4|0;p=f[o>>2]|0;if(!m){q=l;r=p;while(1){$F(q);if(!r){i=k;break a}s=f[a>>2]|0;t=r+4|0;v=f[t>>2]|0;if(!s){w=r;r=v;q=w}else{x=r;y=v;z=s;A=t;break}}}else{x=l;y=p;z=m;A=o}if(!n){f[z+8>>2]=x;f[z+4>>2]=x;f[A>>2]=0;f[x>>2]=0;f[k>>2]=(f[j>>2]|0)+-8}else{f[x>>2]=n;r=n+4|0;q=f[r>>2]|0;f[A>>2]=q;if(q|0)f[q>>2]=x;f[r>>2]=x}if(!y){i=k;break}else{l=y;m=z;n=x}}}while(0);f[g>>2]=0;f[c+8>>2]=0;f[i>>2]=0;$F(c);u=b;return}function sL(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;j$(-27,c,160973,160876,200);d$(c)}c=f[a+12>>2]|0;d=a+4|0;e=f[d>>2]|0;if(!c){f[a+8>>2]=e;if(!e)g=0;else g=(f[a+16>>2]|0)+-8|0;f[a+20>>2]=g;u=b;return}if(!e)h=a+20|0;else{g=a+16|0;i=a+20|0;j=c+8|0;k=c+4|0;l=e;e=f[c+8>>2]|0;while(1){c=l+4|0;m=f[c>>2]|0;if(!e){f[j>>2]=l;f[k>>2]=l;f[c>>2]=0;f[l>>2]=0;f[i>>2]=(f[g>>2]|0)+-8}else{f[l>>2]=e;n=e+4|0;o=f[n>>2]|0;f[c>>2]=o;if(o|0)f[o>>2]=l;f[n>>2]=l}if(!m){h=i;break}else{n=l;l=m;e=n}}}f[d>>2]=0;f[a+8>>2]=0;f[h>>2]=0;u=b;return}function tL(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;if(!((a|0)!=0&(b|0)!=0)){f[d>>2]=0;f[d+4>>2]=0;j$(-27,d,160991,160876,276);d$(d)}f[b>>2]=f[a+8>>2];f[b+4>>2]=f[a+20>>2];u=c;return}function uL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;if(!((a|0)!=0&(b|0)!=0)){f[d>>2]=0;f[d+4>>2]=0;j$(-27,d,161011,160876,288);d$(d)}e=b+4|0;g=f[e>>2]|0;h=a+16|0;if((g|0)>(f[h>>2]|0)){f[d>>2]=0;f[d+4>>2]=0;j$(-201,d,161011,160876,290);d$(d);i=f[e>>2]|0}else i=g;g=f[b>>2]|0;b=a+8|0;f[b>>2]=g;e=a+20|0;f[e>>2]=i;if(g|0){u=c;return}g=f[a+4>>2]|0;f[b>>2]=g;if(!g)j=0;else j=(f[h>>2]|0)+-8|0;f[e>>2]=j;u=c;return}function vL(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;if(!a){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,20)|0;h=219787;i=g+20|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j$(-27,e,161034,160876,327);d$(e)}if((c|0)<0){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,35)|0;h=161052;i=g+35|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j$(-211,e,161034,160876,330);d$(e)}j=a+20|0;k=f[j>>2]|0;l=a+16|0;if(k>>>0>=c>>>0){m=k;n=a+8|0;o=f[n>>2]|0;p=f[l>>2]|0;q=o+p|0;r=0-m|0;s=q+r|0;t=m-c|0;v=t&-8;f[j>>2]=v;u=d;return s|0}if(((f[l>>2]|0)+-8&-8)>>>0<c>>>0){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,37)|0;h=161088;i=g+37|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j$(-211,e,161034,160876,338);d$(e)}wL(a);m=f[j>>2]|0;n=a+8|0;o=f[n>>2]|0;p=f[l>>2]|0;q=o+p|0;r=0-m|0;s=q+r|0;t=m-c|0;v=t&-8;f[j>>2]=v;u=d;return s|0}function wL(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;j$(-27,c,161126,160876,218);d$(c)}d=a+8|0;e=f[d>>2]|0;if((e|0)!=0?(g=f[e+4>>2]|0,(g|0)!=0):0)h=g;else{g=f[a+12>>2]|0;if(!g)i=_F(f[a+16>>2]|0)|0;else{e=g+8|0;f[c>>2]=f[e>>2];j=g+20|0;f[c+4>>2]=f[j>>2];wL(g);k=f[e>>2]|0;uL(g,c);c=f[e>>2]|0;l=c;if((k|0)!=(c|0)){m=k+4|0;f[c+4>>2]=f[m>>2];c=f[m>>2]|0;if(c|0)f[c>>2]=l}else{f[g+4>>2]=0;f[e>>2]=0;f[j>>2]=0}i=k}f[i+4>>2]=0;k=f[d>>2]|0;f[i>>2]=k;if(!k){f[a+4>>2]=i;n=d}else n=k+4|0;f[n>>2]=i;i=f[(f[d>>2]|0)+4>>2]|0;if(!i){o=a+16|0;p=f[o>>2]|0;q=p+-8|0;r=a+20|0;f[r>>2]=q;u=b;return}else h=i}f[d>>2]=h;o=a+16|0;p=f[o>>2]|0;q=p+-8|0;r=a+20|0;f[r>>2]=q;u=b;return}function xL(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=a;f[g>>2]=0;f[g+4>>2]=0;if((e|0)>-1)h=e;else h=xKa(d)|0;f[a>>2]=h;e=vL(c,h+1|0)|0;f[a+4>>2]=e;K1a(e|0,d|0,h|0)|0;b[e+h>>0]=0;return}function yL(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+16|0;h=g;if(!e){f[h>>2]=0;f[h+4>>2]=0;j$(-27,h,161144,160876,377);d$(h)}if(c>>>0<56|(d|0)==0){f[h>>2]=0;f[h+4>>2]=0;j$(-201,h,161144,160876,379);d$(h)}i=vL(e,c)|0;F1a(i|0,0,c|0)|0;f[i+4>>2]=c;f[i>>2]=a&65535|1117323264;c=(a>>>3&511)+1<<(47696>>>(a<<1&14)&3);a:do if(c|0){switch(a&4095){case 0:case 7:{break a;break}default:{}}if((c|0)!=(d|0)){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,110)|0;k=161156;l=j+110|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-201,h,161144,160876,395);d$(h)}}while(0);f[i+28>>2]=d;f[i+44>>2]=e;zL(i,1024/(d>>>0)|0);u=g;return i|0}function zL(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;if(!((a|0)!=0?(f[a+44>>2]|0)!=0:0)){f[e>>2]=0;f[e+4>>2]=0;j$(-27,e,161267,160876,415);d$(e)}if((c|0)<0){f[e>>2]=0;f[e+4>>2]=0;j$(-211,e,161267,160876,417);d$(e)}g=(f[(f[a+44>>2]|0)+16>>2]|0)+-28&-8;h=f[a+28>>2]|0;if(!c){i=1024/(h|0)|0;j=(i|0)>1?i:1}else j=c;if((Y(j,h)|0)<=(g|0)){k=j;l=a+40|0;f[l>>2]=k;u=d;return}j=(g|0)/(h|0)|0;if(j|0){k=j;l=a+40|0;f[l>>2]=k;u=d;return}f[e>>2]=0;f[e+4>>2]=0;j=c$(e,60)|0;h=161285;g=j+60|0;do{b[j>>0]=b[h>>0]|0;j=j+1|0;h=h+1|0}while((j|0)<(g|0));j$(-211,e,161267,160876,433);d$(e);k=0;l=a+40|0;f[l>>2]=k;u=d;return}function AL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[a+24>>2]|0;if(c>>>0<=b>>>0){d=((b|0)<0?c:0)+b|0;e=d-((d|0)>=(c|0)?c:0)|0;if(e>>>0<c>>>0)g=e;else{h=0;return h|0}}else g=b;b=f[a+52>>2]|0;if((g<<1|0)<=(c|0)){e=f[b+12>>2]|0;if((g|0)<(e|0)){i=b;j=g}else{d=e;e=b;k=g;while(1){l=f[e+4>>2]|0;m=k-d|0;d=f[l+12>>2]|0;if((m|0)<(d|0)){i=l;j=m;break}else{e=l;k=m}}}}else{k=b;b=c;do{k=f[k>>2]|0;b=b-(f[k+12>>2]|0)|0}while((g|0)<(b|0));i=k;j=g-b|0}h=(f[i+16>>2]|0)+(Y(f[a+28>>2]|0,j)|0)|0;return h|0}function BL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+48|0;e=d+8|0;g=d;if(!((a|0)!=0&(b|0)!=0)){f[g>>2]=0;f[g+4>>2]=0;j$(-27,g,161378,160876,551);d$(g)}g=f[a+28>>2]|0;h=c;c=f[h>>2]|0;i=f[h+4>>2]|0;h=f[a+24>>2]|0;if((i|0)==(c|0))j=0;else j=i-c+((c|0)<0?0-h|0:0)+((i|0)<1?h:0)|0;while(1)if((j|0)<0)j=j+h|0;else break;i=Y((j|0)>(h|0)?h:j,g)|0;if(!i){k=0;u=d;return k|0}CL(a,e,0);DL(e,c,0);c=e+20|0;a=e+12|0;j=e+8|0;e=f[c>>2]|0;h=f[a>>2]|0;l=b;m=i;while(1){i=e-h|0;n=(i|0)>(m|0)?m:i;K1a(l|0,h|0,n|0)|0;i=f[(f[j>>2]|0)+4>>2]|0;f[j>>2]=i;h=f[i+16>>2]|0;f[a>>2]=h;e=h+(Y(f[i+12>>2]|0,g)|0)|0;f[c>>2]=e;m=m-n|0;if((m|0)<=0){k=b;break}else l=l+n|0}u=d;return k|0}function CL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d;if((b|0)!=0?(g=b+4|0,f[g>>2]=0,f[g+4>>2]=0,f[g+8>>2]=0,f[g+12>>2]=0,f[g+16>>2]=0,(a|0)!=0):0)h=g;else{f[e>>2]=0;f[e+4>>2]=0;j$(-27,e,161412,160876,945);d$(e);h=b+4|0}f[b>>2]=32;f[h>>2]=a;h=f[a+52>>2]|0;if(!h){e=b+8|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;u=d;return}e=f[h>>2]|0;g=f[h+16>>2]|0;i=b+12|0;f[i>>2]=g;j=f[e+16>>2]|0;k=f[a+28>>2]|0;a=j+(Y((f[e+12>>2]|0)+-1|0,k)|0)|0;l=b+28|0;f[l>>2]=a;f[b+24>>2]=f[h+8>>2];if(!c){m=h;n=g}else{f[i>>2]=a;f[l>>2]=g;m=e;n=j}f[b+8>>2]=m;f[b+16>>2]=n;j=n+(Y(f[m+12>>2]|0,k)|0)|0;f[b+20>>2]=j;u=d;return}function DL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=u;u=u+16|0;e=d;if((a|0)!=0?(g=a+4|0,h=f[g>>2]|0,(h|0)!=0):0){i=h;j=g}else{f[e>>2]=0;f[e+4>>2]=0;j$(-27,e,161394,160876,1045);d$(e);g=a+4|0;i=f[g>>2]|0;j=g}g=f[i+24>>2]|0;h=f[i+28>>2]|0;if(c|0){c=a+12|0;i=f[c>>2]|0;k=Y(h,b)|0;l=a+8|0;m=f[l>>2]|0;n=i+k|0;if((k|0)>0){o=a+20|0;p=f[o>>2]|0;if(n>>>0<p>>>0)q=n;else{r=p;p=m;s=k;t=i;do{s=s+t-r|0;p=f[p+4>>2]|0;t=f[p+16>>2]|0;v=Y(f[p+12>>2]|0,h)|0;r=t+v|0}while((s|0)>=(v|0));f[l>>2]=p;f[a+16>>2]=t;f[o>>2]=r;q=t+s|0}}else{s=a+16|0;t=f[s>>2]|0;if(n>>>0<t>>>0){r=t;t=m;m=k;k=i;do{m=m+k-r|0;t=f[t>>2]|0;r=f[t+16>>2]|0;k=r+(Y(f[t+12>>2]|0,h)|0)|0;w=k+m|0}while(w>>>0<r>>>0);f[l>>2]=t;f[s>>2]=r;f[a+20>>2]=k;q=w}else q=n}f[c>>2]=q;u=d;return}if((b|0)>=0)if((g|0)<=(b|0)){q=b-g|0;if((q|0)<(g|0))x=q;else{f[e>>2]=0;f[e+4>>2]=0;j$(-211,e,161394,160876,1062);d$(e);x=q}}else x=b;else{if((b|0)<(0-g|0)){f[e>>2]=0;f[e+4>>2]=0;j$(-211,e,161394,160876,1055);d$(e)}x=g+b|0}b=f[(f[j>>2]|0)+52>>2]|0;j=f[b+12>>2]|0;a:do if((x|0)<(j|0)){y=j;z=b;A=x}else{if((x<<1|0)>(g|0)){B=b;C=g}else{e=b;q=j;c=x;while(1){n=f[e+4>>2]|0;w=c-q|0;k=f[n+12>>2]|0;if((w|0)<(k|0)){y=k;z=n;A=w;break a}else{e=n;q=k;c=w}}}do{B=f[B>>2]|0;D=f[B+12>>2]|0;C=C-D|0}while((x|0)<(C|0));y=D;z=B;A=x-C|0}while(0);C=f[z+16>>2]|0;x=C+(Y(A,h)|0)|0;f[a+12>>2]=x;x=a+8|0;if((f[x>>2]|0)==(z|0)){u=d;return}f[x>>2]=z;f[a+16>>2]=C;z=C+(Y(y,h)|0)|0;f[a+20>>2]=z;u=d;return}function EL(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=u;u=u+16|0;k=j;if((c|0)<56|(d|0)<1|(g|0)<0){f[k>>2]=0;f[k+4>>2]=0;j$(-201,k,161427,160876,590);d$(k)}if(!((h|0)!=0?!((g|0)>0&((e|0)==0|(i|0)==0)):0)){f[k>>2]=0;f[k+4>>2]=0;j$(-27,k,161427,160876,593);d$(k)}F1a(h|0,0,c|0)|0;f[h+4>>2]=c;f[h>>2]=a&65535|1117323264;c=(a>>>3&511)+1<<(47696>>>(a<<1&14)&3);if(!((c|0)==(d|0)|((a&4095|0)==0|(c|0)==0))){f[k>>2]=0;f[k+4>>2]=0;c=c$(k,106)|0;a=161451;l=c+106|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(l|0));j$(-201,k,161427,160876,607);d$(k)}f[h+28>>2]=d;f[h+24>>2]=g;k=e+(Y(g,d)|0)|0;f[h+36>>2]=k;f[h+32>>2]=k;if((g|0)<=0){u=j;return h|0}f[h+52>>2]=i;f[i+4>>2]=i;f[i>>2]=i;f[i+8>>2]=0;f[i+12>>2]=g;f[i+16>>2]=e;u=j;return h|0}function FL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;if(!((a|0)!=0&(b|0)!=0)){f[d>>2]=0;f[d+4>>2]=0;j$(-27,d,161558,160876,820);d$(d)}d=b+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[b>>2]=24;f[b+4>>2]=a;d=f[a+52>>2]|0;if(!d)e=0;else e=f[d>>2]|0;f[b+8>>2]=e;f[b+12>>2]=f[a+36>>2];f[b+20>>2]=f[a+32>>2];u=c;return}function GL(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+16|0;h=g;i=(e|0)!=0;if(!((d|0)!=0&i)){f[h>>2]=0;f[h+4>>2]=0;j$(-27,h,161577,160876,838);d$(h)}j=yL(a,b,c,d)|0;if(!(i&(j|0)!=0)){f[h>>2]=0;f[h+4>>2]=0;j$(-27,h,161558,160876,820);d$(h)}h=e+8|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[e>>2]=24;f[e+4>>2]=j;i=f[j+52>>2]|0;if(!i)k=0;else k=f[i>>2]|0;f[h>>2]=k;f[e+12>>2]=f[j+36>>2];f[e+20>>2]=f[j+32>>2];u=g;return}function HL(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;j$(-27,c,161593,160876,850);d$(c)}c=f[a+4>>2]|0;d=f[a+12>>2]|0;f[c+36>>2]=d;e=f[a+8>>2]|0;if(!e){u=b;return}a=f[c+52>>2]|0;f[e+12>>2]=(d-(f[e+16>>2]|0)|0)/(f[c+28>>2]|0)|0;e=a;d=0;do{d=(f[e+12>>2]|0)+d|0;e=f[e+4>>2]|0}while((e|0)!=(a|0));f[c+24>>2]=d;u=b;return}function IL(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;j$(-27,c,161610,160876,881);d$(c)}HL(a);c=f[a+4>>2]|0;if((f[a+8>>2]|0?(d=f[c+44>>2]|0,d|0):0)?(e=(f[d+8>>2]|0)+(f[d+16>>2]|0)|0,g=d+20|0,d=c+32|0,(e+(0-(f[g>>2]|0))-(f[d>>2]|0)|0)>>>0<8):0){h=f[c+36>>2]|0;f[g>>2]=e-h&-8;f[d>>2]=h}f[a+12>>2]=0;u=b;return c|0}function JL(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+16|0;c=b;if((a|0)!=0?(d=f[a+4>>2]|0,(d|0)!=0):0)e=d;else{f[c>>2]=0;f[c+4>>2]=0;j$(-27,c,161624,160876,912);d$(c);e=f[a+4>>2]|0}HL(a);KL(e,0);f[a+8>>2]=f[f[e+52>>2]>>2];f[a+12>>2]=f[e+36>>2];f[a+20>>2]=f[e+32>>2];u=b;return}function KL(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;if(!a){f[e>>2]=0;f[e+4>>2]=0;j$(-27,e,161641,160876,637);d$(e)}g=a+48|0;h=f[g>>2]|0;if(!h){i=a+28|0;j=f[i>>2]|0;k=f[a+40>>2]|0;l=f[a+44>>2]|0;if((f[a+24>>2]|0)>=(k<<2|0))zL(a,k<<1);if(!l){f[e>>2]=0;f[e+4>>2]=0;m=c$(e,37)|0;n=161652;o=m+37|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-27,e,161641,160876,650);d$(e)}e=(f[l+8>>2]|0)+(f[l+16>>2]|0)|0;n=l+20|0;m=f[n>>2]|0;o=a+32|0;p=f[o>>2]|0;if((e+(0-m)-p|0)>>>0<8?!(c|0?1:(m|0)<(f[i>>2]|0)):0){q=(m|0)/(j|0)|0;r=p+(Y((q|0)>(k|0)?k:q,j)|0)|0;f[o>>2]=r;f[n>>2]=e-r&-8;u=d;return}r=(Y(k,j)|0)+24|0;do if((m|0)<(r|0))if((m|0)<((Y((k|0)>5?(k|0)/3|0:1,j)|0)+32|0)){wL(l);s=r;break}else{s=m-((m+-24|0)%(f[i>>2]|0)|0)|0;break}else s=r;while(0);r=vL(l,s)|0;f[r+16>>2]=r+20+7&-8;f[r+12>>2]=s+-24;f[r+4>>2]=0;f[r>>2]=0;t=r}else{f[g>>2]=f[h+4>>2];t=h}h=a+52|0;g=f[h>>2]|0;if(!g){f[h>>2]=t;v=t;w=t;x=t}else{f[t>>2]=f[g>>2];f[g>>2]=t;v=t;w=g;x=(f[t>>2]|0)+4|0}f[t+4>>2]=w;f[x>>2]=t;x=f[t+12>>2]|0;w=t+16|0;g=f[w>>2]|0;r=f[v>>2]|0;if(c){c=(x|0)/(f[a+28>>2]|0)|0;v=g+x|0;f[w>>2]=v;if((t|0)==(r|0)){f[a+36>>2]=v;f[a+32>>2]=v;y=f[h>>2]|0}else{f[h>>2]=t;y=t}f[t+8>>2]=c;h=f[t+4>>2]|0;if((h|0)==(y|0))z=y;else{v=h;do{f[v+8>>2]=(f[v+8>>2]|0)+c;v=f[v+4>>2]|0}while((v|0)!=(y|0));z=y}}else{f[a+36>>2]=g;f[a+32>>2]=g+x;if((t|0)==(r|0))A=0;else A=(f[r+12>>2]|0)+(f[r+8>>2]|0)|0;f[t+8>>2]=A;z=t}f[z+12>>2]=0;u=d;return}function LL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;j$(-27,d,161690,160876,995);d$(d)}d=a+8|0;e=f[d>>2]|0;g=f[(f[a+4>>2]|0)+28>>2]|0;if((b|0)>0){b=f[e+4>>2]|0;f[d>>2]=b;h=f[b+16>>2]|0;i=h;j=f[b+12>>2]|0;k=h}else{h=f[e>>2]|0;f[d>>2]=h;d=f[h+16>>2]|0;e=f[h+12>>2]|0;i=d;j=e;k=d+(Y(e+-1|0,g)|0)|0}f[a+12>>2]=k;f[a+16>>2]=i;k=i+(Y(j,g)|0)|0;f[a+20>>2]=k;u=c;return}function ML(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;if((a|0)!=0?(e=f[a+12>>2]|0,(e|0)!=0):0)g=e;else{f[d>>2]=0;f[d+4>>2]=0;j$(-27,d,161707,160876,1020);d$(d);g=f[a+12>>2]|0}d=f[(f[a+4>>2]|0)+28>>2]|0;e=g-(f[a+16>>2]|0)|0;if((d|0)<33?(g=d+-1|0,(-2147450741>>>g&1|0)!=0):0)h=e>>b[161346+g>>0];else h=(e|0)/(d|0)|0;u=c;return (f[(f[a+8>>2]|0)+8>>2]|0)+h-(f[a+24>>2]|0)|0}function NL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;j$(-27,d,161725,160876,1138);d$(d)}d=f[a+28>>2]|0;e=a+36|0;g=f[e>>2]|0;if(g>>>0<(f[a+32>>2]|0)>>>0)h=g;else{KL(a,0);h=f[e>>2]|0}if(b|0)K1a(h|0,b|0,d|0)|0;b=(f[f[a+52>>2]>>2]|0)+12|0;f[b>>2]=(f[b>>2]|0)+1;b=a+24|0;f[b>>2]=(f[b>>2]|0)+1;f[e>>2]=h+d;u=c;return h|0}function OL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;j$(-27,d,161735,160876,1169);d$(d)}e=a+24|0;if((f[e>>2]|0)<1){f[d>>2]=0;f[d+4>>2]=0;j$(-201,d,161735,160876,1171);d$(d)}d=a+28|0;g=f[d>>2]|0;h=a+36|0;i=(f[h>>2]|0)+(0-g)|0;f[h>>2]=i;if(b|0)K1a(b|0,i|0,g|0)|0;f[h>>2]=i;f[e>>2]=(f[e>>2]|0)+-1;g=a+52|0;b=f[g>>2]|0;j=f[b>>2]|0;k=j+12|0;l=(f[k>>2]|0)+-1|0;f[k>>2]=l;if(l|0){u=c;return}l=f[d>>2]|0;d=a+32|0;if((b|0)==(j|0)){m=f[d>>2]|0;n=b+16|0;o=(Y(f[b+8>>2]|0,l)|0)+(m-(f[n>>2]|0))|0;f[b+12>>2]=o;f[n>>2]=m+(0-o);f[g>>2]=0;f[d>>2]=0;f[h>>2]=0;f[e>>2]=0;p=b}else{f[k>>2]=(f[d>>2]|0)-i;i=f[j>>2]|0;k=(f[i+16>>2]|0)+(Y(f[i+12>>2]|0,l)|0)|0;f[h>>2]=k;f[d>>2]=k;k=j+4|0;f[i+4>>2]=f[k>>2];f[f[k>>2]>>2]=i;p=j}j=a+48|0;f[p+4>>2]=f[j>>2];f[j>>2]=p;u=c;return}function PL(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;g=u;u=u+16|0;h=g;if(!a){f[h>>2]=0;f[h+4>>2]=0;i=c$(h,21)|0;j=161744;k=i+21|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-27,h,161766,160876,1459);d$(h)}if((d|0)<0){f[h>>2]=0;f[h+4>>2]=0;i=c$(h,38)|0;j=161781;k=i+38|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-201,h,161766,160876,1461);d$(h)}h=f[a+28>>2]|0;if(!e){if((d|0)<=0){u=g;return}e=a+32|0;j=a+36|0;i=a+52|0;k=a+24|0;l=d;m=c;while(1){n=f[j>>2]|0;o=((f[e>>2]|0)-n|0)/(h|0)|0;p=(o|0)>(l|0)?l:o;if((p|0)>0){o=(f[f[i>>2]>>2]|0)+12|0;f[o>>2]=(f[o>>2]|0)+p;f[k>>2]=(f[k>>2]|0)+p;o=l-p|0;q=Y(p,h)|0;if(!m){r=n;s=0}else{K1a(n|0,m|0,q|0)|0;r=f[j>>2]|0;s=m+q|0}f[j>>2]=r+q;if((o|0)>0){t=o;v=s}else break}else{t=l;v=m}KL(a,0);l=t;m=v}u=g;return}v=a+52|0;m=f[v>>2]|0;if((d|0)<=0){u=g;return}t=a+24|0;if(!c){l=m;s=d;while(1){if((l|0)!=0?(r=f[l+8>>2]|0,(r|0)!=0):0){w=r;x=l}else{KL(a,1);r=f[v>>2]|0;w=f[r+8>>2]|0;x=r}r=(w|0)>(s|0)?s:w;s=s-r|0;f[x+8>>2]=w-r;j=x+12|0;f[j>>2]=(f[j>>2]|0)+r;f[t>>2]=(f[t>>2]|0)+r;j=Y(r,h)|0;r=x+16|0;f[r>>2]=(f[r>>2]|0)+(0-j);if((s|0)<=0)break;else l=x}u=g;return}else{x=m;m=d;while(1){if((x|0)!=0?(d=f[x+8>>2]|0,(d|0)!=0):0){y=d;z=x}else{KL(a,1);d=f[v>>2]|0;y=f[d+8>>2]|0;z=d}d=(y|0)>(m|0)?m:y;m=m-d|0;f[z+8>>2]=y-d;l=z+12|0;f[l>>2]=(f[l>>2]|0)+d;f[t>>2]=(f[t>>2]|0)+d;l=Y(d,h)|0;d=z+16|0;s=(f[d>>2]|0)+(0-l)|0;f[d>>2]=s;K1a(s|0,c+(Y(m,h)|0)|0,l|0)|0;if((m|0)<=0)break;else x=z}u=g;return}}function QL(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=u;u=u+16|0;h=g;if(!a){f[h>>2]=0;f[h+4>>2]=0;i=c$(h,21)|0;j=161744;k=i+21|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-27,h,161820,160876,1528);d$(h)}if((d|0)<0){f[h>>2]=0;f[h+4>>2]=0;i=c$(h,38)|0;j=161781;k=i+38|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-201,h,161820,160876,1530);d$(h)}h=a+24|0;j=f[h>>2]|0;i=(j|0)<(d|0)?j:d;if(!e){if(!c)l=0;else l=c+(Y(f[a+28>>2]|0,i)|0)|0;if((i|0)<=0){u=g;return}e=a+52|0;d=a+28|0;k=a+36|0;m=a+32|0;n=a+48|0;o=f[e>>2]|0;p=j;q=i;r=l;while(1){l=f[o>>2]|0;s=l+12|0;t=f[s>>2]|0;v=(t|0)>(q|0)?q:t;w=t-v|0;f[s>>2]=w;f[h>>2]=p-v;s=q-v|0;t=Y(f[d>>2]|0,v)|0;v=0-t|0;x=(f[k>>2]|0)+v|0;f[k>>2]=x;if(!r){y=o;z=l;A=w;B=0}else{w=r+v|0;K1a(w|0,x|0,t|0)|0;t=f[e>>2]|0;x=f[t>>2]|0;y=t;z=x;A=f[x+12>>2]|0;B=w}w=z+12|0;if(!A){x=f[d>>2]|0;if((y|0)==(z|0)){t=f[m>>2]|0;v=z+16|0;l=(Y(f[z+8>>2]|0,x)|0)+(t-(f[v>>2]|0))|0;f[w>>2]=l;f[v>>2]=t+(0-l);f[e>>2]=0;f[m>>2]=0;f[k>>2]=0;f[h>>2]=0;C=z+4|0;D=0}else{f[w>>2]=(f[m>>2]|0)-(f[k>>2]|0);w=f[z>>2]|0;l=(f[w+16>>2]|0)+(Y(f[w+12>>2]|0,x)|0)|0;f[k>>2]=l;f[m>>2]=l;l=z+4|0;f[w+4>>2]=f[l>>2];f[f[l>>2]>>2]=w;C=l;D=y}f[C>>2]=f[n>>2];f[n>>2]=z;E=D}else E=y;if((s|0)<=0)break;o=E;p=f[h>>2]|0;q=s;r=B}u=g;return}else{if((i|0)<=0){u=g;return}B=a+52|0;r=a+28|0;q=a+32|0;p=a+36|0;E=a+48|0;a=f[B>>2]|0;o=a;y=j;j=a;a=i;i=c;while(1){c=o+12|0;D=f[c>>2]|0;z=(D|0)>(a|0)?a:D;f[c>>2]=D-z;f[h>>2]=y-z;D=a-z|0;c=o+8|0;f[c>>2]=(f[c>>2]|0)+z;c=Y(f[r>>2]|0,z)|0;if(!i){F=o;G=j;H=0}else{K1a(i|0,f[o+16>>2]|0,c|0)|0;z=f[B>>2]|0;F=z;G=z;H=i+c|0}z=F+16|0;f[z>>2]=(f[z>>2]|0)+c;if(!(f[F+12>>2]|0)){c=f[G>>2]|0;z=f[r>>2]|0;if((G|0)==(c|0)){n=f[q>>2]|0;C=G+16|0;m=(Y(f[G+8>>2]|0,z)|0)+(n-(f[C>>2]|0))|0;f[G+12>>2]=m;f[C>>2]=n+(0-m);f[B>>2]=0;f[q>>2]=0;f[p>>2]=0;f[h>>2]=0;I=G+4|0;J=0}else{m=G+8|0;n=f[m>>2]|0;C=Y(n,z)|0;f[G+12>>2]=C;z=G+16|0;f[z>>2]=(f[z>>2]|0)+(0-C);f[m>>2]=0;m=G+4|0;C=f[m>>2]|0;z=C;if((C|0)!=(G|0)){k=C;do{e=k+8|0;f[e>>2]=(f[e>>2]|0)-n;k=f[k+4>>2]|0}while((k|0)!=(G|0))}f[B>>2]=z;f[c+4>>2]=z;f[f[m>>2]>>2]=c;I=m;J=C}f[I>>2]=f[E>>2];f[E>>2]=G;K=J;L=J}else{K=G;L=F}if((D|0)<=0)break;o=L;y=f[h>>2]|0;j=K;a=D;i=H}u=g;return}}function RL(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;j$(-27,c,161834,160876,1596);d$(c)}QL(a,0,f[a+24>>2]|0,0);u=b;return}function SL(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;g=u;u=u+48|0;h=g+8|0;i=g;if(!((a|0)!=0?(f[a>>2]&-65536|0)==1117323264:0)){f[i>>2]=0;f[i+4>>2]=0;j=c$(i,23)|0;k=161845;l=j+23|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-5,i,161869,160876,1610);d$(i)}if(!d){m=f[a+44>>2]|0;if(!m){f[i>>2]=0;f[i+4>>2]=0;j=c$(i,20)|0;k=219787;l=j+20|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-27,i,161869,160876,1616);d$(i);n=0}else n=m}else n=d;d=f[a+28>>2]|0;m=c;o=f[m>>2]|0;p=f[m+4>>2]|0;m=f[a+24>>2]|0;if((p|0)==(o|0))q=0;else q=p-o+((o|0)<0?0-m|0:0)+((p|0)<1?m:0)|0;while(1)if((q|0)<0)q=q+m|0;else break;p=(q|0)>(m|0)?m:q;if((o|0)>=0)if((o|0)<(m|0))r=o;else{s=o-m|0;t=14}else{s=m+o|0;t=14}if((t|0)==14){f[c>>2]=s;r=s}if(!(p>>>0<=m>>>0?!((p|0)!=0&r>>>0>=m>>>0):0)){f[i>>2]=0;f[i+4>>2]=0;j=c$(i,18)|0;k=161880;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-211,i,161869,160876,1627);d$(i)}i=yL(f[a>>2]|0,f[a+4>>2]|0,d,n)|0;if((p|0)<=0){u=g;return i|0}CL(a,h,0);DL(h,r,0);r=h+12|0;a=f[r>>2]|0;k=((f[h+20>>2]|0)-a|0)/(d|0)|0;d=i+52|0;j=i+24|0;l=h+8|0;if(!e){v=k;w=0;x=0;y=p}else{e=a;a=k;k=p;while(1){p=(a|0)>(k|0)?k:a;PL(i,e,p,0);k=k-p|0;p=f[(f[l>>2]|0)+4>>2]|0;f[l>>2]=p;e=f[p+16>>2]|0;f[r>>2]=e;if((k|0)<=0)break;else a=f[p+12>>2]|0}u=g;return i|0}while(1){a=(v|0)>(y|0)?y:v;k=x;x=vL(n,20)|0;if(!w){f[x+4>>2]=x;f[x>>2]=x;f[d>>2]=x;z=0;A=x}else{f[x>>2]=k;f[x+4>>2]=w;f[w>>2]=x;f[k+4>>2]=x;z=(f[k+12>>2]|0)+(f[k+8>>2]|0)|0;A=w}f[x+8>>2]=z;f[x+16>>2]=f[r>>2];f[x+12>>2]=a;f[j>>2]=(f[j>>2]|0)+a;y=y-a|0;a=f[(f[l>>2]|0)+4>>2]|0;f[l>>2]=a;f[r>>2]=f[a+16>>2];if((y|0)<=0)break;else{v=f[a+12>>2]|0;w=A}}u=g;return i|0}function TL(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0;e=u;u=u+1792|0;g=e+1760|0;h=e+1728|0;i=e+192|0;j=e+160|0;k=e+128|0;l=e+96|0;m=e+64|0;n=e+32|0;o=e;p=(a|0)!=0;if(!(p?(f[a>>2]&-65536|0)==1117323264:0)){q=p?-5:-27;f[j>>2]=0;f[j+4>>2]=0;r=c$(j,18)|0;s=161899;t=r+18|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(q,j,161918,160876,1921);d$(j)}if(!c){f[j>>2]=0;f[j+4>>2]=0;r=c$(j,21)|0;s=161928;t=r+21|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-27,j,161918,160876,1924);d$(j)}s=a+24|0;if((f[s>>2]|0)<2){u=e;return}r=f[a+28>>2]|0;t=r*7|0;CL(a,g,0);f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];f[h+12>>2]=f[g+12>>2];f[h+16>>2]=f[g+16>>2];f[h+20>>2]=f[g+20>>2];f[h+24>>2]=f[g+24>>2];f[h+28>>2]=f[g+28>>2];a=g+8|0;f[i>>2]=f[a>>2];q=g+12|0;p=f[q>>2]|0;f[i+4>>2]=p;v=g+16|0;w=f[v>>2]|0;f[i+8>>2]=w;x=g+20|0;y=f[x>>2]|0;f[i+12>>2]=y;z=h+12|0;A=0-r|0;B=(f[z>>2]|0)+A|0;f[z>>2]=B;C=h+16|0;D=f[C>>2]|0;E=h+8|0;if(B>>>0<D>>>0){F=h+4|0;G=f[(f[F>>2]|0)+28>>2]|0;H=f[f[E>>2]>>2]|0;f[E>>2]=H;I=f[H+16>>2]|0;J=f[H+12>>2]|0;K=I+(Y(J+-1|0,G)|0)|0;f[z>>2]=K;f[C>>2]=I;L=I+(Y(J,G)|0)|0;G=h+20|0;f[G>>2]=L;M=I;N=K;O=G;P=F;Q=E;R=H;S=L;T=G}else{G=h+20|0;M=D;N=B;O=G;P=h+4|0;Q=E;R=f[E>>2]|0;S=f[G>>2]|0;T=G}G=N;N=M;f[i+16>>2]=R;f[i+20>>2]=G;f[i+24>>2]=N;f[i+28>>2]=S;M=n+12|0;B=(r|0)>0;D=g+4|0;L=m+12|0;H=m+16|0;F=m+8|0;K=m+4|0;I=m+20|0;J=k+12|0;U=k+20|0;V=k+8|0;W=k+4|0;X=k+16|0;Z=n+20|0;_=o+12|0;$=o+20|0;aa=o+8|0;ba=o+4|0;ca=o+16|0;da=n+8|0;ea=n+4|0;fa=n+16|0;ga=j+8|0;ha=j+12|0;ia=j+16|0;ja=j+20|0;ka=l+8|0;la=l+12|0;ma=l+16|0;na=l+20|0;oa=(r|0)<1;pa=B^1;qa=(r|0)==1;ra=(r|0)==1;sa=(r|0)==1;ta=(r|0)==1;ua=p;p=w;w=y;y=R;R=G;G=N;N=S;S=0;while(1){va=f[i+(S<<5)>>2]|0;f[a>>2]=va;f[q>>2]=ua;f[v>>2]=p;f[x>>2]=w;f[Q>>2]=y;f[z>>2]=R;f[C>>2]=G;f[O>>2]=N;wa=va;va=y;xa=S+-1|0;a:while(1){if((wa|0)==(va|0))ya=(f[z>>2]|0)+r-(f[q>>2]|0)|0;else{za=ML(h)|0;ya=Y(za+1-(ML(g)|0)|0,r)|0}if((ya|0)<=(t|0)){Aa=xa;Ba=18;break};f[n>>2]=f[g>>2];f[n+4>>2]=f[g+4>>2];f[n+8>>2]=f[g+8>>2];f[n+12>>2]=f[g+12>>2];f[n+16>>2]=f[g+16>>2];f[n+20>>2]=f[g+20>>2];f[n+24>>2]=f[g+24>>2];f[n+28>>2]=f[g+28>>2];f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];f[j+8>>2]=f[g+8>>2];f[j+12>>2]=f[g+12>>2];f[j+16>>2]=f[g+16>>2];f[j+20>>2]=f[g+20>>2];f[j+24>>2]=f[g+24>>2];f[j+28>>2]=f[g+28>>2];f[m>>2]=f[h>>2];f[m+4>>2]=f[h+4>>2];f[m+8>>2]=f[h+8>>2];f[m+12>>2]=f[h+12>>2];f[m+16>>2]=f[h+16>>2];f[m+20>>2]=f[h+20>>2];f[m+24>>2]=f[h+24>>2];f[m+28>>2]=f[h+28>>2];f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[l+8>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];f[l+16>>2]=f[h+16>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];za=(ya|0)/(r|0)|0;do if((za|0)>40){Ca=za>>>3;Da=f[M>>2]|0;DL(n,Ca,1);Ea=f[M>>2]|0;DL(n,Ca,1);Fa=f[M>>2]|0;Ga=(ui[c&127](Da,Ea,d)|0)<0;Ha=ui[c&127](Ea,Fa,d)|0;if(Ga)if((Ha|0)<0)Ia=Ea;else{Ga=(ui[c&127](Da,Fa,d)|0)<0;Ia=Ga?Fa:Da}else if((Ha|0)>0)Ia=Ea;else{Ea=(ui[c&127](Da,Fa,d)|0)<0;Ia=Ea?Da:Fa}Fa=za>>>1;Da=Ca*3|0;DL(n,Fa-Da|0,1);Ea=f[M>>2]|0;DL(n,Ca,1);Ha=f[M>>2]|0;DL(n,Ca,1);Ga=f[M>>2]|0;Ja=(ui[c&127](Ea,Ha,d)|0)<0;Ka=ui[c&127](Ha,Ga,d)|0;if(Ja)if((Ka|0)<0)La=Ha;else{Ja=(ui[c&127](Ea,Ga,d)|0)<0;La=Ja?Ga:Ea}else if((Ka|0)>0)La=Ha;else{Ha=(ui[c&127](Ea,Ga,d)|0)<0;La=Ha?Ea:Ga}DL(n,za+-1-Fa-Da|0,1);Da=f[M>>2]|0;DL(n,Ca,1);Fa=f[M>>2]|0;DL(n,Ca,1);Ca=f[M>>2]|0;Ga=(ui[c&127](Da,Fa,d)|0)<0;Ea=ui[c&127](Fa,Ca,d)|0;if(Ga){if((Ea|0)<0){Ma=Ia;Na=La;Oa=Fa;break}Ga=(ui[c&127](Da,Ca,d)|0)<0;Ma=Ia;Na=La;Oa=Ga?Ca:Da;break}else{if((Ea|0)>0){Ma=Ia;Na=La;Oa=Fa;break}Fa=(ui[c&127](Da,Ca,d)|0)<0;Ma=Ia;Na=La;Oa=Fa?Da:Ca;break}}else{Ca=f[M>>2]|0;Da=(za|0)/2|0;DL(n,Da,1);Fa=f[M>>2]|0;DL(n,za+-1-Da|0,1);Ma=Ca;Na=Fa;Oa=f[M>>2]|0}while(0);za=(ui[c&127](Ma,Na,d)|0)<0;Fa=ui[c&127](Na,Oa,d)|0;if(za)if((Fa|0)<0)Pa=Na;else{za=(ui[c&127](Ma,Oa,d)|0)<0;Pa=za?Oa:Ma}else if((Fa|0)>0)Pa=Na;else{Fa=(ui[c&127](Ma,Oa,d)|0)<0;Pa=Fa?Ma:Oa};f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2];f[g+8>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];Fa=f[q>>2]|0;if((Pa|0)==(Fa|0)|pa)Qa=Fa;else{za=Fa;Fa=0;while(1){Ca=Pa+Fa|0;Da=b[Ca>>0]|0;b[Ca>>0]=b[za+Fa>>0]|0;b[(f[q>>2]|0)+Fa>>0]=Da;Fa=Fa+1|0;Da=f[q>>2]|0;if((Fa|0)==(r|0)){Qa=Da;break}else za=Da}}za=Qa+r|0;f[q>>2]=za;if(za>>>0<(f[x>>2]|0)>>>0)Ra=za;else{za=f[(f[D>>2]|0)+28>>2]|0;Fa=f[(f[a>>2]|0)+4>>2]|0;f[a>>2]=Fa;Da=f[Fa+16>>2]|0;Ca=f[Fa+12>>2]|0;f[q>>2]=Da;f[v>>2]=Da;Fa=Da+(Y(Ca,za)|0)|0;f[x>>2]=Fa;Ra=Da};f[k>>2]=f[g>>2];f[k+4>>2]=f[g+4>>2];f[k+8>>2]=f[g+8>>2];f[k+12>>2]=f[g+12>>2];f[k+16>>2]=f[g+16>>2];f[k+20>>2]=f[g+20>>2];f[k+24>>2]=f[g+24>>2];f[k+28>>2]=f[g+28>>2];Da=Ra;Fa=f[z>>2]|0;za=0;while(1){b:do if((Da|0)==(Fa|0))Sa=za;else{if(B){Ta=Da;Ua=za}else{Ca=Da;Ea=za;while(1){Ga=ui[c&127](Ca,Qa,d)|0;if((Ga|0)>=1){Sa=Ea;break b}do if(!Ga){Ha=(f[J>>2]|0)+r|0;f[J>>2]=Ha;if(Ha>>>0<(f[U>>2]|0)>>>0){Va=1;break}Ha=f[(f[W>>2]|0)+28>>2]|0;Ka=f[(f[V>>2]|0)+4>>2]|0;f[V>>2]=Ka;Ja=f[Ka+16>>2]|0;Wa=f[Ka+12>>2]|0;f[J>>2]=Ja;f[X>>2]=Ja;Ka=Ja+(Y(Wa,Ha)|0)|0;f[U>>2]=Ka;Va=1}else Va=Ea;while(0);Ga=(f[q>>2]|0)+r|0;f[q>>2]=Ga;if(Ga>>>0<(f[x>>2]|0)>>>0)Xa=Ga;else{Ga=f[(f[D>>2]|0)+28>>2]|0;Ka=f[(f[a>>2]|0)+4>>2]|0;f[a>>2]=Ka;Ha=f[Ka+16>>2]|0;Wa=f[Ka+12>>2]|0;f[q>>2]=Ha;f[v>>2]=Ha;Ka=Ha+(Y(Wa,Ga)|0)|0;f[x>>2]=Ka;Xa=Ha}if((Xa|0)==(f[z>>2]|0)){Sa=Va;break b}else{Ca=Xa;Ea=Va}}}while(1){Ea=ui[c&127](Ta,Qa,d)|0;if((Ea|0)>=1){Sa=Ua;break b}do if(!Ea){Ca=f[J>>2]|0;Ha=f[q>>2]|0;do if((Ca|0)==(Ha|0))Ya=Ca;else{Ka=b[Ca>>0]|0;b[Ca>>0]=b[Ha>>0]|0;b[f[q>>2]>>0]=Ka;Ka=f[J>>2]|0;if(sa){Ya=Ka;break}else{Za=Ka;_a=1}while(1){Ka=Za+_a|0;Ga=b[Ka>>0]|0;b[Ka>>0]=b[(f[q>>2]|0)+_a>>0]|0;b[(f[q>>2]|0)+_a>>0]=Ga;_a=_a+1|0;Ga=f[J>>2]|0;if((_a|0)==(r|0)){Ya=Ga;break}else Za=Ga}}while(0);Ha=Ya+r|0;f[J>>2]=Ha;if(Ha>>>0<(f[U>>2]|0)>>>0){$a=1;break}Ha=f[(f[W>>2]|0)+28>>2]|0;Ca=f[(f[V>>2]|0)+4>>2]|0;f[V>>2]=Ca;Ga=f[Ca+16>>2]|0;Ka=f[Ca+12>>2]|0;f[J>>2]=Ga;f[X>>2]=Ga;Ca=Ga+(Y(Ka,Ha)|0)|0;f[U>>2]=Ca;$a=1}else $a=Ua;while(0);Ea=(f[q>>2]|0)+r|0;f[q>>2]=Ea;if(Ea>>>0<(f[x>>2]|0)>>>0)ab=Ea;else{Ea=f[(f[D>>2]|0)+28>>2]|0;Ca=f[(f[a>>2]|0)+4>>2]|0;f[a>>2]=Ca;Ha=f[Ca+16>>2]|0;Ka=f[Ca+12>>2]|0;f[q>>2]=Ha;f[v>>2]=Ha;Ca=Ha+(Y(Ka,Ea)|0)|0;f[x>>2]=Ca;ab=Ha}if((ab|0)==(f[z>>2]|0)){Sa=$a;break}else{Ta=ab;Ua=$a}}}while(0);Ha=f[z>>2]|0;c:do if((f[q>>2]|0)==(Ha|0))bb=Sa;else{if(B){cb=Ha;db=Sa}else{Ca=Ha;Ea=Sa;while(1){Ka=ui[c&127](Ca,Qa,d)|0;if((Ka|0)<=-1){bb=Ea;break c}do if(!Ka){Ga=(f[L>>2]|0)+A|0;f[L>>2]=Ga;if(Ga>>>0>=(f[H>>2]|0)>>>0){eb=1;break}Ga=f[(f[K>>2]|0)+28>>2]|0;Wa=f[f[F>>2]>>2]|0;f[F>>2]=Wa;Ja=f[Wa+16>>2]|0;fb=f[Wa+12>>2]|0;Wa=Ja+(Y(fb+-1|0,Ga)|0)|0;f[L>>2]=Wa;f[H>>2]=Ja;Wa=Ja+(Y(fb,Ga)|0)|0;f[I>>2]=Wa;eb=1}else eb=Ea;while(0);Ka=(f[z>>2]|0)+A|0;f[z>>2]=Ka;if(Ka>>>0<(f[C>>2]|0)>>>0){Wa=f[(f[P>>2]|0)+28>>2]|0;Ga=f[f[E>>2]>>2]|0;f[E>>2]=Ga;fb=f[Ga+16>>2]|0;Ja=f[Ga+12>>2]|0;Ga=fb+(Y(Ja+-1|0,Wa)|0)|0;f[z>>2]=Ga;f[C>>2]=fb;gb=fb+(Y(Ja,Wa)|0)|0;f[T>>2]=gb;hb=Ga}else hb=Ka;if((f[q>>2]|0)==(hb|0)){bb=eb;break c}else{Ca=hb;Ea=eb}}}while(1){Ea=ui[c&127](cb,Qa,d)|0;if((Ea|0)<=-1){bb=db;break c}do if(!Ea){Ca=f[L>>2]|0;Ka=f[z>>2]|0;do if((Ca|0)==(Ka|0))ib=Ca;else{Ga=b[Ca>>0]|0;b[Ca>>0]=b[Ka>>0]|0;b[f[z>>2]>>0]=Ga;Ga=f[L>>2]|0;if(ra){ib=Ga;break}else{jb=Ga;kb=1}while(1){Ga=jb+kb|0;gb=b[Ga>>0]|0;b[Ga>>0]=b[(f[z>>2]|0)+kb>>0]|0;b[(f[z>>2]|0)+kb>>0]=gb;kb=kb+1|0;gb=f[L>>2]|0;if((kb|0)==(r|0)){ib=gb;break}else jb=gb}}while(0);Ka=ib+A|0;f[L>>2]=Ka;if(Ka>>>0>=(f[H>>2]|0)>>>0){lb=1;break}Ka=f[(f[K>>2]|0)+28>>2]|0;Ca=f[f[F>>2]>>2]|0;f[F>>2]=Ca;gb=f[Ca+16>>2]|0;Ga=f[Ca+12>>2]|0;Ca=gb+(Y(Ga+-1|0,Ka)|0)|0;f[L>>2]=Ca;f[H>>2]=gb;Ca=gb+(Y(Ga,Ka)|0)|0;f[I>>2]=Ca;lb=1}else lb=db;while(0);Ea=(f[z>>2]|0)+A|0;f[z>>2]=Ea;if(Ea>>>0<(f[C>>2]|0)>>>0){Ca=f[(f[P>>2]|0)+28>>2]|0;Ka=f[f[E>>2]>>2]|0;f[E>>2]=Ka;Ga=f[Ka+16>>2]|0;gb=f[Ka+12>>2]|0;Ka=Ga+(Y(gb+-1|0,Ca)|0)|0;f[z>>2]=Ka;f[C>>2]=Ga;Wa=Ga+(Y(gb,Ca)|0)|0;f[T>>2]=Wa;mb=Ka}else mb=Ea;if((f[q>>2]|0)==(mb|0)){bb=lb;break}else{cb=mb;db=lb}}}while(0);nb=f[q>>2]|0;Ha=f[z>>2]|0;if((nb|0)==(Ha|0)){Ba=107;break}if(B){Ea=b[nb>>0]|0;b[nb>>0]=b[Ha>>0]|0;b[f[z>>2]>>0]=Ea;Ea=f[q>>2]|0;if(qa)ob=Ea;else{Ha=Ea;Ea=1;while(1){Ka=Ha+Ea|0;Wa=b[Ka>>0]|0;b[Ka>>0]=b[(f[z>>2]|0)+Ea>>0]|0;b[(f[z>>2]|0)+Ea>>0]=Wa;Ea=Ea+1|0;Wa=f[q>>2]|0;if((Ea|0)==(r|0)){ob=Wa;break}else Ha=Wa}}}else ob=nb;Ha=ob+r|0;f[q>>2]=Ha;if(Ha>>>0<(f[x>>2]|0)>>>0)pb=Ha;else{Ha=f[(f[D>>2]|0)+28>>2]|0;Ea=f[(f[a>>2]|0)+4>>2]|0;f[a>>2]=Ea;Wa=f[Ea+16>>2]|0;Ka=f[Ea+12>>2]|0;f[q>>2]=Wa;f[v>>2]=Wa;Ea=Wa+(Y(Ka,Ha)|0)|0;f[x>>2]=Ea;pb=Wa}Wa=f[z>>2]|0;Ea=Wa+A|0;f[z>>2]=Ea;if(Ea>>>0<(f[C>>2]|0)>>>0){Ha=f[(f[P>>2]|0)+28>>2]|0;Ka=f[f[E>>2]>>2]|0;f[E>>2]=Ka;Ca=f[Ka+16>>2]|0;gb=f[Ka+12>>2]|0;Ka=Ca+(Y(gb+-1|0,Ha)|0)|0;f[z>>2]=Ka;f[C>>2]=Ca;Ga=Ca+(Y(gb,Ha)|0)|0;f[T>>2]=Ga;qb=Ka}else qb=Ea;if((pb|0)==(Wa|0)){Ba=126;break}else{Da=pb;Fa=qb;za=1}}if((Ba|0)==107){Ba=0;za=ui[c&127](nb,Qa,d)|0;if(!za){Fa=f[J>>2]|0;Da=f[q>>2]|0;if(!((Fa|0)==(Da|0)|oa)){Wa=b[Fa>>0]|0;b[Fa>>0]=b[Da>>0]|0;b[f[q>>2]>>0]=Wa;Wa=f[J>>2]|0;if(ta)rb=Wa;else{Da=Wa;Wa=1;while(1){Ea=Da+Wa|0;Ka=b[Ea>>0]|0;b[Ea>>0]=b[(f[q>>2]|0)+Wa>>0]|0;b[(f[q>>2]|0)+Wa>>0]=Ka;Wa=Wa+1|0;Ka=f[J>>2]|0;if((Wa|0)==(r|0)){rb=Ka;break}else Da=Ka}}}else rb=Fa;Da=rb+r|0;f[J>>2]=Da;if(Da>>>0<(f[U>>2]|0)>>>0)sb=1;else{Da=f[(f[W>>2]|0)+28>>2]|0;Wa=f[(f[V>>2]|0)+4>>2]|0;f[V>>2]=Wa;Ka=f[Wa+16>>2]|0;Ea=f[Wa+12>>2]|0;f[J>>2]=Ka;f[X>>2]=Ka;Wa=Ka+(Y(Ea,Da)|0)|0;f[U>>2]=Wa;sb=1}}else sb=bb;if((za|0)<1){Wa=(f[q>>2]|0)+r|0;f[q>>2]=Wa;if(Wa>>>0>=(f[x>>2]|0)>>>0){Wa=f[(f[D>>2]|0)+28>>2]|0;Da=f[(f[a>>2]|0)+4>>2]|0;f[a>>2]=Da;Ea=f[Da+16>>2]|0;Ka=f[Da+12>>2]|0;f[q>>2]=Ea;f[v>>2]=Ea;Da=Ea+(Y(Ka,Wa)|0)|0;f[x>>2]=Da}}else{Da=(f[z>>2]|0)+A|0;f[z>>2]=Da;if(Da>>>0<(f[C>>2]|0)>>>0){Da=f[(f[P>>2]|0)+28>>2]|0;Wa=f[f[E>>2]>>2]|0;f[E>>2]=Wa;Ka=f[Wa+16>>2]|0;Ea=f[Wa+12>>2]|0;Wa=Ka+(Y(Ea+-1|0,Da)|0)|0;f[z>>2]=Wa;f[C>>2]=Ka;Wa=Ka+(Y(Ea,Da)|0)|0;f[T>>2]=Wa}}if(!sb){f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2];f[g+8>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];f[h>>2]=f[l>>2];f[h+4>>2]=f[l+4>>2];f[h+8>>2]=f[l+8>>2];f[h+12>>2]=f[l+12>>2];f[h+16>>2]=f[l+16>>2];f[h+20>>2]=f[l+20>>2];f[h+24>>2]=f[l+24>>2];f[h+28>>2]=f[l+28>>2];tb=6;ub=xa}else Ba=126}do if((Ba|0)==126){Ba=0;Wa=ML(g)|0;if(!Wa)vb=f[s>>2]|0;else vb=Wa;Wa=ML(j)|0;Da=ML(k)|0;if(!Da)wb=f[s>>2]|0;else wb=Da;Da=vb-wb|0;Ea=wb-Wa|0;Wa=(Da|0)>(Ea|0)?Ea:Da;do if((Wa|0)>0){f[n>>2]=f[j>>2];f[n+4>>2]=f[j+4>>2];f[n+8>>2]=f[j+8>>2];f[n+12>>2]=f[j+12>>2];f[n+16>>2]=f[j+16>>2];f[n+20>>2]=f[j+20>>2];f[n+24>>2]=f[j+24>>2];f[n+28>>2]=f[j+28>>2];f[o>>2]=f[g>>2];f[o+4>>2]=f[g+4>>2];f[o+8>>2]=f[g+8>>2];f[o+12>>2]=f[g+12>>2];f[o+16>>2]=f[g+16>>2];f[o+20>>2]=f[g+20>>2];f[o+24>>2]=f[g+24>>2];f[o+28>>2]=f[g+28>>2];DL(o,0-Wa|0,1);Ea=f[M>>2]|0;if(B){Ka=Ea;Ga=0;while(1){Ha=Ka;gb=0;do{Ca=Ha+gb|0;Ja=b[Ca>>0]|0;b[Ca>>0]=b[(f[_>>2]|0)+gb>>0]|0;b[(f[_>>2]|0)+gb>>0]=Ja;gb=gb+1|0;Ha=f[M>>2]|0}while((gb|0)!=(r|0));gb=Ha+r|0;f[M>>2]=gb;if(gb>>>0<(f[Z>>2]|0)>>>0)xb=gb;else{gb=f[(f[ea>>2]|0)+28>>2]|0;Ja=f[(f[da>>2]|0)+4>>2]|0;f[da>>2]=Ja;Ca=f[Ja+16>>2]|0;fb=f[Ja+12>>2]|0;f[M>>2]=Ca;f[fa>>2]=Ca;Ja=Ca+(Y(fb,gb)|0)|0;f[Z>>2]=Ja;xb=Ca}Ca=(f[_>>2]|0)+r|0;f[_>>2]=Ca;if(Ca>>>0>=(f[$>>2]|0)>>>0){Ca=f[(f[ba>>2]|0)+28>>2]|0;Ja=f[(f[aa>>2]|0)+4>>2]|0;f[aa>>2]=Ja;gb=f[Ja+16>>2]|0;fb=f[Ja+12>>2]|0;f[_>>2]=gb;f[ca>>2]=gb;Ja=gb+(Y(fb,Ca)|0)|0;f[$>>2]=Ja}Ga=Ga+1|0;if((Ga|0)>=(Wa|0))break;else Ka=xb}}else{Ka=(f[ba>>2]|0)+28|0;Ga=(f[ea>>2]|0)+28|0;Ja=Ea;Ca=f[Z>>2]|0;fb=f[_>>2]|0;gb=0;while(1){yb=Ja+r|0;if(yb>>>0<Ca>>>0){zb=yb;Ab=Ca}else{yb=f[Ga>>2]|0;Bb=f[(f[da>>2]|0)+4>>2]|0;f[da>>2]=Bb;Cb=f[Bb+16>>2]|0;Db=f[Bb+12>>2]|0;f[fa>>2]=Cb;Bb=Cb+(Y(Db,yb)|0)|0;f[Z>>2]=Bb;zb=Cb;Ab=Bb}Bb=fb+r|0;if(Bb>>>0<(f[$>>2]|0)>>>0)Eb=Bb;else{Bb=f[Ka>>2]|0;Cb=f[(f[aa>>2]|0)+4>>2]|0;f[aa>>2]=Cb;yb=f[Cb+16>>2]|0;Db=f[Cb+12>>2]|0;f[ca>>2]=yb;Cb=yb+(Y(Db,Bb)|0)|0;f[$>>2]=Cb;Eb=yb}gb=gb+1|0;if((gb|0)>=(Wa|0))break;else{Ja=zb;Ca=Ab;fb=Eb}}f[M>>2]=zb;f[_>>2]=Eb;break}}while(0);Wa=ML(h)|0;fb=ML(l)|0;Ca=ML(m)|0;Ja=fb-Ca|0;fb=Ca-Wa|0;Wa=(Ja|0)>(fb|0)?fb:Ja;do if((Wa|0)>0){f[n>>2]=f[g>>2];f[n+4>>2]=f[g+4>>2];f[n+8>>2]=f[g+8>>2];f[n+12>>2]=f[g+12>>2];f[n+16>>2]=f[g+16>>2];f[n+20>>2]=f[g+20>>2];f[n+24>>2]=f[g+24>>2];f[n+28>>2]=f[g+28>>2];f[o>>2]=f[l>>2];f[o+4>>2]=f[l+4>>2];f[o+8>>2]=f[l+8>>2];f[o+12>>2]=f[l+12>>2];f[o+16>>2]=f[l+16>>2];f[o+20>>2]=f[l+20>>2];f[o+24>>2]=f[l+24>>2];f[o+28>>2]=f[l+28>>2];DL(o,1-Wa|0,1);Ja=f[M>>2]|0;if(B){Ca=Ja;gb=0;while(1){Ka=Ca;Ga=0;do{Ea=Ka+Ga|0;yb=b[Ea>>0]|0;b[Ea>>0]=b[(f[_>>2]|0)+Ga>>0]|0;b[(f[_>>2]|0)+Ga>>0]=yb;Ga=Ga+1|0;Ka=f[M>>2]|0}while((Ga|0)!=(r|0));Ga=Ka+r|0;f[M>>2]=Ga;if(Ga>>>0<(f[Z>>2]|0)>>>0)Fb=Ga;else{Ga=f[(f[ea>>2]|0)+28>>2]|0;Ha=f[(f[da>>2]|0)+4>>2]|0;f[da>>2]=Ha;yb=f[Ha+16>>2]|0;Ea=f[Ha+12>>2]|0;f[M>>2]=yb;f[fa>>2]=yb;Ha=yb+(Y(Ea,Ga)|0)|0;f[Z>>2]=Ha;Fb=yb}yb=(f[_>>2]|0)+r|0;f[_>>2]=yb;if(yb>>>0>=(f[$>>2]|0)>>>0){yb=f[(f[ba>>2]|0)+28>>2]|0;Ha=f[(f[aa>>2]|0)+4>>2]|0;f[aa>>2]=Ha;Ga=f[Ha+16>>2]|0;Ea=f[Ha+12>>2]|0;f[_>>2]=Ga;f[ca>>2]=Ga;Ha=Ga+(Y(Ea,yb)|0)|0;f[$>>2]=Ha}gb=gb+1|0;if((gb|0)>=(Wa|0))break;else Ca=Fb}}else{Ca=(f[ba>>2]|0)+28|0;gb=(f[ea>>2]|0)+28|0;Ha=Ja;yb=f[Z>>2]|0;Ea=f[_>>2]|0;Ga=0;while(1){Cb=Ha+r|0;if(Cb>>>0<yb>>>0){Gb=Cb;Hb=yb}else{Cb=f[gb>>2]|0;Bb=f[(f[da>>2]|0)+4>>2]|0;f[da>>2]=Bb;Db=f[Bb+16>>2]|0;Ib=f[Bb+12>>2]|0;f[fa>>2]=Db;Bb=Db+(Y(Ib,Cb)|0)|0;f[Z>>2]=Bb;Gb=Db;Hb=Bb}Bb=Ea+r|0;if(Bb>>>0<(f[$>>2]|0)>>>0)Jb=Bb;else{Bb=f[Ca>>2]|0;Db=f[(f[aa>>2]|0)+4>>2]|0;f[aa>>2]=Db;Cb=f[Db+16>>2]|0;Ib=f[Db+12>>2]|0;f[ca>>2]=Cb;Db=Cb+(Y(Ib,Bb)|0)|0;f[$>>2]=Db;Jb=Cb}Ga=Ga+1|0;if((Ga|0)>=(Wa|0))break;else{Ha=Gb;yb=Hb;Ea=Jb}}f[M>>2]=Gb;f[_>>2]=Jb;break}}while(0);Wa=(fb|0)>1;if((Da|0)<=1){if(!Wa){tb=4;ub=xa;break}f[h>>2]=f[l>>2];f[h+4>>2]=f[l+4>>2];f[h+8>>2]=f[l+8>>2];f[h+12>>2]=f[l+12>>2];f[h+16>>2]=f[l+16>>2];f[h+20>>2]=f[l+20>>2];f[h+24>>2]=f[l+24>>2];f[h+28>>2]=f[l+28>>2];f[g>>2]=f[l>>2];f[g+4>>2]=f[l+4>>2];f[g+8>>2]=f[l+8>>2];f[g+12>>2]=f[l+12>>2];f[g+16>>2]=f[l+16>>2];f[g+20>>2]=f[l+20>>2];f[g+24>>2]=f[l+24>>2];f[g+28>>2]=f[l+28>>2];DL(g,1-fb|0,1);tb=0;ub=xa;break}if(!Wa){f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];f[h+8>>2]=f[j+8>>2];f[h+12>>2]=f[j+12>>2];f[h+16>>2]=f[j+16>>2];f[h+20>>2]=f[j+20>>2];f[h+24>>2]=f[j+24>>2];f[h+28>>2]=f[j+28>>2];f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2];f[g+8>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];DL(h,Da+-1|0,1);tb=0;ub=xa;break}Wa=xa+1|0;if((Da|0)>(fb|0)){f[i+(Wa<<5)>>2]=f[ga>>2];f[i+(Wa<<5)+4>>2]=f[ha>>2];f[i+(Wa<<5)+8>>2]=f[ia>>2];f[i+(Wa<<5)+12>>2]=f[ja>>2];DL(j,Da+-1|0,1);f[i+(Wa<<5)+16>>2]=f[ga>>2];f[i+(Wa<<5)+20>>2]=f[ha>>2];f[i+(Wa<<5)+24>>2]=f[ia>>2];f[i+(Wa<<5)+28>>2]=f[ja>>2];f[h>>2]=f[l>>2];f[h+4>>2]=f[l+4>>2];f[h+8>>2]=f[l+8>>2];f[h+12>>2]=f[l+12>>2];f[h+16>>2]=f[l+16>>2];f[h+20>>2]=f[l+20>>2];f[h+24>>2]=f[l+24>>2];f[h+28>>2]=f[l+28>>2];f[g>>2]=f[l>>2];f[g+4>>2]=f[l+4>>2];f[g+8>>2]=f[l+8>>2];f[g+12>>2]=f[l+12>>2];f[g+16>>2]=f[l+16>>2];f[g+20>>2]=f[l+20>>2];f[g+24>>2]=f[l+24>>2];f[g+28>>2]=f[l+28>>2];DL(g,1-fb|0,1);tb=0;ub=Wa;break}else{f[i+(Wa<<5)+16>>2]=f[ka>>2];f[i+(Wa<<5)+20>>2]=f[la>>2];f[i+(Wa<<5)+24>>2]=f[ma>>2];f[i+(Wa<<5)+28>>2]=f[na>>2];DL(l,1-fb|0,1);f[i+(Wa<<5)>>2]=f[ka>>2];f[i+(Wa<<5)+4>>2]=f[la>>2];f[i+(Wa<<5)+8>>2]=f[ma>>2];f[i+(Wa<<5)+12>>2]=f[na>>2];f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];f[h+8>>2]=f[j+8>>2];f[h+12>>2]=f[j+12>>2];f[h+16>>2]=f[j+16>>2];f[h+20>>2]=f[j+20>>2];f[h+24>>2]=f[j+24>>2];f[h+28>>2]=f[j+28>>2];f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2];f[g+8>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];DL(h,Da+-1|0,1);tb=0;ub=Wa;break}}while(0);switch(tb&7){case 6:{Aa=ub;Ba=18;break a;break}case 0:break;default:if(tb|0){Kb=ub;break a}}wa=f[a>>2]|0;va=f[E>>2]|0;xa=ub}d:do if((Ba|0)==18){Ba=0;xa=f[D>>2]|0;va=f[a>>2]|0;wa=f[v>>2]|0;za=f[x>>2]|0;Fa=(f[q>>2]|0)+r|0;if(Fa>>>0<za>>>0){Lb=Fa;Mb=wa;Nb=za;Ob=va}else{za=f[va+4>>2]|0;Fa=f[za+16>>2]|0;Lb=Fa;Mb=Fa;Nb=Fa+(Y(f[za+12>>2]|0,f[xa+28>>2]|0)|0)|0;Ob=za}za=(f[z>>2]|0)+r|0;f[z>>2]=za;if(za>>>0>=(f[T>>2]|0)>>>0){za=f[(f[P>>2]|0)+28>>2]|0;Fa=f[(f[E>>2]|0)+4>>2]|0;f[E>>2]=Fa;Wa=f[Fa+16>>2]|0;Ea=f[Fa+12>>2]|0;f[z>>2]=Wa;f[C>>2]=Wa;Fa=Wa+(Y(Ea,za)|0)|0;f[T>>2]=Fa}Fa=xa+28|0;xa=wa;wa=va;va=Lb;za=Mb;Ea=Nb;Wa=Ob;while(1){yb=Ea;if(B){Ha=xa;Ga=wa;Ca=va;while(1){if((Ca|0)==(f[z>>2]|0)){Kb=Aa;break d}gb=(Ga|0)==(Wa|0)?Ha:za;e:do if((Ca|0)==(f[q>>2]|0)){Pb=gb;Qb=Wa}else{Ja=gb;Cb=Wa;Db=Ca;while(1){Bb=Db+A|0;if(Bb>>>0<Ja>>>0){Ib=f[Cb>>2]|0;Rb=f[Ib+16>>2]|0;Sb=Rb;Tb=Ib;Ub=Rb+(Y((f[Ib+12>>2]|0)+-1|0,f[Fa>>2]|0)|0)|0}else{Sb=Ja;Tb=Cb;Ub=Bb}if((ui[c&127](Ub,Db,d)|0)<1){Pb=Sb;Qb=Tb;break e}else Vb=0;do{Bb=Ub+Vb|0;Ib=b[Bb>>0]|0;Rb=Db+Vb|0;b[Bb>>0]=b[Rb>>0]|0;b[Rb>>0]=Ib;Vb=Vb+1|0}while((Vb|0)!=(r|0));if((Ub|0)==(f[q>>2]|0)){Pb=Sb;Qb=Tb;break}else{Ja=Sb;Cb=Tb;Db=Ub}}}while(0);Ca=Ca+r|0;if(Ca>>>0>=yb>>>0){Wb=Pb;Xb=Qb;break}else{Ha=Pb;Ga=Qb}}}else{Ga=xa;Ha=wa;Ca=va;while(1){if((Ca|0)==(f[z>>2]|0)){Kb=Aa;break d}Da=(Ha|0)==(Wa|0)?Ga:za;if((Ca|0)==(f[q>>2]|0)){Yb=Da;Zb=Wa}else{fb=Da;Da=Wa;gb=Ca;while(1){Db=gb+A|0;if(Db>>>0<fb>>>0){Cb=f[Da>>2]|0;Ja=f[Cb+16>>2]|0;_b=Ja;$b=Cb;ac=Ja+(Y((f[Cb+12>>2]|0)+-1|0,f[Fa>>2]|0)|0)|0}else{_b=fb;$b=Da;ac=Db}Db=(ui[c&127](ac,gb,d)|0)<1;if(Db|(ac|0)==(f[q>>2]|0)){Yb=_b;Zb=$b;break}else{fb=_b;Da=$b;gb=ac}}}Ca=Ca+r|0;if(Ca>>>0>=yb>>>0){Wb=Yb;Xb=Zb;break}else{Ga=Yb;Ha=Zb}}}Ha=f[Wa+4>>2]|0;Ga=f[Ha+16>>2]|0;xa=Wb;wa=Xb;va=Ga;za=Ga;Ea=Ga+(Y(f[Ha+12>>2]|0,f[Fa>>2]|0)|0)|0;Wa=Ha}}while(0);if((Kb|0)<=-1)break;ua=f[i+(Kb<<5)+4>>2]|0;p=f[i+(Kb<<5)+8>>2]|0;w=f[i+(Kb<<5)+12>>2]|0;y=f[i+(Kb<<5)+16>>2]|0;R=f[i+(Kb<<5)+20>>2]|0;G=f[i+(Kb<<5)+24>>2]|0;N=f[i+(Kb<<5)+28>>2]|0;S=Kb}u=e;return}function UL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;if(!d){f[g>>2]=0;f[g+4>>2]=0;j$(-27,g,161950,160876,2486);d$(g)}if(!((b|0)>63&(c|0)>7&(c&3|0)==0)){f[g>>2]=0;f[g+4>>2]=0;j$(-201,g,161950,160876,2490);d$(g)}g=yL(a,b,c,d)|0;f[g>>2]=f[g>>2]&65535|1117257728;u=e;return g|0}function VL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;if(!a){f[e>>2]=0;f[e+4>>2]=0;j$(-27,e,161962,160876,2507);d$(e)}e=a+56|0;g=f[e>>2]|0;if(!g){h=a+24|0;i=f[h>>2]|0;j=f[a+28>>2]|0;KL(a,0);k=a+36|0;l=f[k>>2]|0;f[e>>2]=l;m=l+j|0;n=f[a+32>>2]|0;if(m>>>0>n>>>0){o=i;p=l}else{q=m;m=i;i=l;while(1){f[i>>2]=m|-2147483648;f[i+4>>2]=q;r=m+1|0;s=q+j|0;if(s>>>0>n>>>0){o=r;p=q;break}else{t=q;q=s;m=r;i=t}}}f[p+(0-j)+4>>2]=0;j=(f[f[a+52>>2]>>2]|0)+12|0;f[j>>2]=o-(f[h>>2]|0)+(f[j>>2]|0);f[h>>2]=o;f[k>>2]=n;v=l}else v=g;f[e>>2]=f[v+4>>2];e=f[v>>2]&67108863;if(b|0)K1a(v|0,b|0,f[a+28>>2]|0)|0;f[v>>2]=e;b=a+60|0;f[b>>2]=(f[b>>2]|0)+1;if(!c){u=d;return e|0}f[c>>2]=v;u=d;return e|0}function WL(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;j$(-27,c,161834,160876,1596);d$(c)}QL(a,0,f[a+24>>2]|0,0);f[a+56>>2]=0;f[a+60>>2]=0;u=b;return}function XL(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;if((c|0)<8|((b|0)<68|(d|0)<24)){f[h>>2]=0;f[h+4>>2]=0;j$(-201,h,161971,160876,2586);d$(h)}h=UL(a,b,c,e)|0;c=UL(0,64,d,e)|0;f[h+64>>2]=c;u=g;return h|0}function YL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;if(!a){f[e>>2]=0;f[e+4>>2]=0;j$(-27,e,161985,160876,2620);d$(e)}e=a+56|0;g=f[e>>2]|0;if(!g){h=a+24|0;i=f[h>>2]|0;j=f[a+28>>2]|0;KL(a,0);k=a+36|0;l=f[k>>2]|0;f[e>>2]=l;m=l+j|0;n=f[a+32>>2]|0;if(m>>>0>n>>>0){o=i;p=l}else{q=m;m=i;i=l;while(1){f[i>>2]=m|-2147483648;f[i+4>>2]=q;r=m+1|0;s=q+j|0;if(s>>>0>n>>>0){o=r;p=q;break}else{t=q;q=s;m=r;i=t}}}f[p+(0-j)+4>>2]=0;j=(f[f[a+52>>2]>>2]|0)+12|0;f[j>>2]=o-(f[h>>2]|0)+(f[j>>2]|0);f[h>>2]=o;f[k>>2]=n;f[e>>2]=f[l+4>>2];f[l>>2]=f[l>>2]&67108863;n=a+60|0;f[n>>2]=(f[n>>2]|0)+1;if(!l){v=0;w=-1}else{x=l;y=8}}else{f[e>>2]=f[g+4>>2];f[g>>2]=f[g>>2]&67108863;e=a+60|0;f[e>>2]=(f[e>>2]|0)+1;x=g;y=8}if((y|0)==8){if(b|0)K1a(x+8|0,b+8|0,(f[a+28>>2]|0)+-8|0)|0;f[x+4>>2]=0;v=x;w=f[x>>2]|0}if(!c){u=d;return w|0}f[c>>2]=v;u=d;return w|0}function ZL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;if(!((a|0)!=0&(b|0)!=0&(c|0)!=0)){f[e>>2]=0;f[e+4>>2]=0;j$(-27,e,161999,160876,2705);d$(e)}if((b|0)==(c|0)){g=0;u=d;return g|0}if(!(f[a>>2]&16384)){a=(f[b>>2]&67108863)>>>0>(f[c>>2]&67108863)>>>0;h=a?b:c;i=a?c:b}else{h=c;i=b}b=f[i+4>>2]|0;if(!b){g=0;u=d;return g|0}else j=b;while(1){b=f[j+20>>2]|0;if((b|0)==(h|0)){g=j;k=9;break}j=f[j+8+(((i|0)==(b|0)&1)<<2)>>2]|0;if(!j){g=0;k=9;break}}if((k|0)==9){u=d;return g|0}return 0}function _L(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0;h=u;u=u+16|0;i=h;if(!a){f[i>>2]=0;f[i+4>>2]=0;j=c$(i,21)|0;k=162020;l=j+21|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-27,i,162042,160876,2762);d$(i)}if(!(f[a>>2]&16384)){m=(f[c>>2]&67108863)>>>0>(f[d>>2]&67108863)>>>0;o=m?c:d;p=m?d:c}else{o=d;p=c}c=ZL(a,p,o)|0;if(c|0){if(!g){q=0;u=h;return q|0}f[g>>2]=c;q=0;u=h;return q|0}if((p|0)==(o|0)){c=o|0?-5:-27;f[i>>2]=0;f[i+4>>2]=0;j=c$(i,41)|0;k=162062;l=j+41|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(c,i,162042,160876,2782);d$(i)}c=a+64|0;a=f[c>>2]|0;k=a+56|0;j=f[k>>2]|0;do if(!j){if((a|0)==0?(f[i>>2]=0,f[i+4>>2]=0,j$(-27,i,161962,160876,2507),d$(i),l=f[k>>2]|0,l|0):0){r=l;break}l=a+24|0;d=f[l>>2]|0;m=f[a+28>>2]|0;KL(a,0);s=a+36|0;t=f[s>>2]|0;f[k>>2]=t;v=t+m|0;w=f[a+32>>2]|0;if(v>>>0>w>>>0){x=d;y=t}else{z=v;v=d;d=t;while(1){f[d>>2]=v|-2147483648;f[d+4>>2]=z;A=v+1|0;B=z+m|0;if(B>>>0>w>>>0){x=A;y=z;break}else{C=z;z=B;v=A;d=C}}}f[y+(0-m)+4>>2]=0;d=(f[f[a+52>>2]>>2]|0)+12|0;f[d>>2]=x-(f[l>>2]|0)+(f[d>>2]|0);f[l>>2]=x;f[s>>2]=w;r=t}else r=j;while(0);j=r+4|0;f[k>>2]=f[j>>2];f[r>>2]=f[r>>2]&67108863;k=a+60|0;f[k>>2]=(f[k>>2]|0)+1;f[r+16>>2]=p;f[r+20>>2]=o;k=p+4|0;f[r+8>>2]=f[k>>2];p=o+4|0;f[r+12>>2]=f[p>>2];f[p>>2]=r;f[k>>2]=r;k=(f[(f[c>>2]|0)+28>>2]|0)+-24|0;c=(k|0)>0;if(!e)if(c){F1a(r+24|0,0,k|0)|0;D=1.0}else D=1.0;else{if(c)K1a(r+24|0,e+24|0,k|0)|0;D=+n[e+4>>2]}n[j>>2]=D;if(!g){q=1;u=h;return q|0}f[g>>2]=r;q=1;u=h;return q|0}function $L(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+8|0;g=d;if(!((a|0)!=0?(f[a>>2]&-53248|0)==1117261824:0)){f[g>>2]=0;f[g+4>>2]=0;h=c$(g,21)|0;i=162104;j=h+21|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-5,g,162126,160876,3262);d$(g)}if(!c){k=f[a+44>>2]|0;if(!k){f[g>>2]=0;f[g+4>>2]=0;h=c$(g,20)|0;i=219787;j=h+20|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-27,g,162126,160876,3268);d$(g);l=0}else l=k}else l=c;c=f[a+28>>2]|0;k=a+64|0;i=f[(f[k>>2]|0)+28>>2]|0;h=a+24|0;j=_F(f[h>>2]<<2)|0;m=_F(f[h>>2]<<2)|0;n=a+4|0;o=XL(f[a>>2]|0,f[n>>2]|0,c,i,l)|0;K1a(o+4624|0,a+4624|0,(f[n>>2]|0)+-68|0)|0;CL(a,e,0);if((f[h>>2]|0)>0){n=e+12|0;l=e+20|0;p=e+8|0;q=e+4|0;r=e+16|0;s=f[n>>2]|0;t=0;v=0;while(1){if((f[s>>2]|0)>-1){f[g>>2]=0;YL(o,s,g)|0;w=f[s>>2]|0;x=f[g>>2]|0;f[x>>2]=w;f[j+(v<<2)>>2]=w;f[s>>2]=v;f[m+(v<<2)>>2]=x;y=f[n>>2]|0;z=v+1|0}else{y=s;z=v}x=y+c|0;f[n>>2]=x;if(x>>>0<(f[l>>2]|0)>>>0)A=x;else{x=f[(f[q>>2]|0)+28>>2]|0;w=f[(f[p>>2]|0)+4>>2]|0;f[p>>2]=w;B=f[w+16>>2]|0;C=f[w+12>>2]|0;f[n>>2]=B;f[r>>2]=B;w=B+(Y(C,x)|0)|0;f[l>>2]=w;A=B}t=t+1|0;if((t|0)>=(f[h>>2]|0))break;else{s=A;v=z}}}CL(f[k>>2]|0,e,0);if((f[(f[k>>2]|0)+24>>2]|0)>0){z=e+12|0;v=e+20|0;A=e+8|0;s=e+4|0;h=e+16|0;t=f[z>>2]|0;l=0;while(1){if((f[t>>2]|0)>-1){f[g>>2]=0;_L(o,f[m+(f[f[t+16>>2]>>2]<<2)>>2]|0,f[m+(f[f[t+20>>2]>>2]<<2)>>2]|0,t,g)|0;f[f[g>>2]>>2]=f[t>>2];D=f[z>>2]|0}else D=t;r=D+i|0;f[z>>2]=r;if(r>>>0<(f[v>>2]|0)>>>0)E=r;else{r=f[(f[s>>2]|0)+28>>2]|0;n=f[(f[A>>2]|0)+4>>2]|0;f[A>>2]=n;p=f[n+16>>2]|0;q=f[n+12>>2]|0;f[z>>2]=p;f[h>>2]=p;n=p+(Y(q,r)|0)|0;f[v>>2]=n;E=p}l=l+1|0;if((l|0)>=(f[(f[k>>2]|0)+24>>2]|0))break;else t=E}}CL(a,e,0);a=f[(f[k>>2]|0)+24>>2]|0;if((a|0)<=0){$F(j);$F(m);F=S$()|0;G=(F|0)<0;H=G?0:o;u=d;return H|0}k=e+12|0;E=e+20|0;t=e+8|0;l=e+4|0;v=e+16|0;e=f[k>>2]|0;h=0;z=0;while(1){if((f[e>>2]|0)>-1){f[e>>2]=f[j+(z<<2)>>2];I=z+1|0}else I=z;A=e+c|0;f[k>>2]=A;if(A>>>0<(f[E>>2]|0)>>>0)J=A;else{A=f[(f[l>>2]|0)+28>>2]|0;s=f[(f[t>>2]|0)+4>>2]|0;f[t>>2]=s;i=f[s+16>>2]|0;D=f[s+12>>2]|0;f[k>>2]=i;f[v>>2]=i;s=i+(Y(D,A)|0)|0;f[E>>2]=s;J=i}h=h+1|0;if((h|0)>=(a|0))break;else{e=J;z=I}}$F(j);$F(m);F=S$()|0;G=(F|0)<0;H=G?0:o;u=d;return H|0}function aM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+16|0;g=e;if(!d){f[g>>2]=0;f[g+4>>2]=0;h=c$(g,20)|0;i=219787;j=h+20|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-27,g,162139,160876,3346);d$(g)}i=yL(0,c,4,d)|0;if(!a){u=e;return i|0}d=a;a=0;while(1){c=f[d+20>>2]|0;if(c){h=a+1|0;if((h|0)==2147483647){k=2147483646;l=d;m=7}else{n=c;o=h}}else{k=a;l=d;m=7}a:do if((m|0)==7){while(1){m=0;p=f[l+12>>2]|0;if(p|0)break;h=k+-1|0;if((k|0)<1){n=0;o=h;break a}else{k=h;l=f[l+16>>2]|0;m=7}}n=(l|0)==0?0:p;o=k}while(0);f[g>>2]=d;NL(i,g)|0;if(!n)break;else{d=n;a=o}}u=e;return i|0}function bM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;if(!((a|0)!=0&(b|0)!=0)){f[e>>2]=0;f[e+4>>2]=0;j$(-27,e,162155,160876,3443);d$(e)}if((c|0)<0){f[e>>2]=0;f[e+4>>2]=0;j$(-211,e,162155,160876,3446);d$(e)}f[a>>2]=b;f[a+4>>2]=0;f[a+8>>2]=c;u=d;return}function cM(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;e=c$(d,21)|0;g=202902;h=e+21|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));j$(-27,d,162178,160876,3462);d$(d)}d=f[a>>2]|0;g=a+4|0;e=f[g>>2]|0;a:do if(d){h=f[d+20>>2]|0;if((h|0)!=0?(i=e+1|0,(i|0)<(f[a+8>>2]|0)):0){j=i;k=h;break}else{l=e;m=d}while(1){n=f[m+12>>2]|0;if(n|0)break;h=l+-1|0;if((l|0)<1){j=h;k=0;break a}else{l=h;m=f[m+16>>2]|0}}if(!m){j=l;k=0}else{j=l;k=(f[a+8>>2]|0)==0?0:n}}else{j=e;k=d}while(0);f[a>>2]=k;f[g>>2]=j;u=c;return d|0}function dM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;if(!((a|0)!=0&(b|0)!=0)){f[e>>2]=0;f[e+4>>2]=0;j$(-27,e,162193,160876,3392);d$(e)}f[a+16>>2]=(b|0)!=(c|0)?b:0;c=b+20|0;b=f[c>>2]|0;f[a+12>>2]=b;if(!b){f[c>>2]=a;u=d;return}f[b+8>>2]=a;f[c>>2]=a;u=d;return}function eM(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=NYa(12)|0;f[j>>2]=32040;f[j+4>>2]=0;b[j+8>>0]=0;fM(j);PYa(j);j=NYa(2296)|0;f[j>>2]=32060;k=j+8|0;b[j+48>>0]=0;f[j+44>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;d[k+32>>1]=0;b[k+34>>0]=0;k=(w$(4)|0)&1;b[j+43>>0]=k;f[j+192>>2]=j+200;f[j+196>>2]=1032;f[j+1232>>2]=j+1240;f[j+1236>>2]=264;f[j+12>>2]=j+56;gM(j,c,e,g,h,i);i=NYa(16)|0;f[i+4>>2]=1;f[i>>2]=32080;f[i+8>>2]=j;f[a>>2]=i;f[a+4>>2]=j;return}function fM(a){a=a|0;f[a>>2]=32040;return}function gM(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0;i=a+8|0;j=a+36|0;k=f[j>>2]|0;l=(g&128|0)==0;m=(e|0)==5?8:16;n=a+40|0;o=g&1;b[n>>0]=o;q=(g&32|0)!=0;b[a+42>>0]=(g&144|0)==16&1;r=a+16|0;p[r>>3]=1.0;f[a+32>>2]=c;f[j>>2]=c;b[a+48>>0]=0;s=(k|0)!=(c|0);k=a+12|0;t=f[k>>2]|0;if(s){if((c|0)>=6){u=(c+-1^c)+1>>1;if((u|0)>1){f[t>>2]=u;if((u|0)!=(c|0)?(v=(c>>>0)/(u>>>0)|0,(v|0)>1):0){w=3;x=v;y=1;z=8}else A=1}else{w=3;x=c;y=0;z=8}a:do if((z|0)==8){b:while(1){z=0;v=w;while(1){B=(x|0)/(v|0)|0;if((Y(B,v)|0)==(x|0))break;u=v+2|0;if((Y(u,u)|0)>(x|0))break b;else v=u}u=y+1|0;f[t+(y<<2)>>2]=v;if((B|0)>1){w=v;x=B;y=u;z=8}else{A=u;break a}}f[t+(y<<2)>>2]=x;A=y+1|0}while(0);y=f[t>>2]&1^1;x=(y+A|0)/2|0;if((y|0)<(x|0)){B=A+-1+y|0;w=y;do{y=t+(w<<2)|0;u=f[y>>2]|0;C=t+(B-w<<2)|0;f[y>>2]=f[C>>2];f[C>>2]=u;w=w+1|0}while((w|0)!=(x|0));D=A}else D=A}else{f[t>>2]=c;D=1}f[i>>2]=D;A=(f[t>>2]|0)==(f[t+(D+-1<<2)>>2]|0);if(!s)if(A)E=1;else{F=i;z=18}else{G=A;H=i;z=19}}else if((f[t>>2]|0)==(f[t+((f[i>>2]|0)+-1<<2)>>2]|0))E=1;else{F=i;z=18}if((z|0)==18)if(o<<24>>24==0|q^1)E=0;else{G=0;H=F;z=19}if((z|0)==19){F=a+192|0;o=Y(f[j>>2]|0,m)|0;i=a+196|0;if((f[i>>2]|0)>>>0<o>>>0){t=f[F>>2]|0;A=a+200|0;if((t|0)==(A|0))I=t;else{if(t|0)QYa(t);f[F>>2]=A;f[i>>2]=1032;I=A}f[i>>2]=o;if(o>>>0>1032){A=OYa(o)|0;f[F>>2]=A;J=A}else J=I}else{f[i>>2]=o;J=f[F>>2]|0}F=a+28|0;f[F>>2]=J;J=a+1232|0;o=f[j>>2]|0;i=a+1236|0;if((f[i>>2]|0)>>>0<o>>>0){I=f[J>>2]|0;A=a+1240|0;if((I|0)==(A|0))K=I;else{if(I|0)QYa(I);f[J>>2]=A;f[i>>2]=264;K=A}f[i>>2]=o;if(o>>>0>264){A=OYa(o>>>0>1073741823?-1:o<<2)|0;f[J>>2]=A;L=A}else L=K}else{f[i>>2]=o;L=f[J>>2]|0}f[a+24>>2]=L;if(l)M=q&(b[n>>0]|0)!=0;else M=0;jM(f[j>>2]|0,f[H>>2]|0,f[k>>2]|0,L,m,f[F>>2]|0,M&1);E=G}do if(!h)z=44;else{if(l){if(E|(b[h>>0]|0)==0?(c&1|0)==0|q^1:0){z=44;break}}else if(E){N=1;O=0;break}b[h>>0]=1;z=44}while(0);if((z|0)==44){z=l^1;if(z|q^1){N=z;O=0}else{N=0;O=(b[n>>0]|0)==0?1:2}}f[a+44>>2]=f[32092+(((e|0)==6?O+3|0:O)<<2)>>2];if((g&66|0)!=2)return;P=1.0/+(Y((g&4|0)==0|N?d:1,c)|0);p[r>>3]=P;return}function hM(a){a=a|0;PYa(a);return}function iM(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+8>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function jM(a,b,c,d,e,g,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,N=0.0,O=0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0;j=u;u=u+272|0;k=j+136|0;l=j;m=f[c>>2]|0;do if((a|0)<6){f[d>>2]=0;o=a+-1|0;f[d+(o<<2)>>2]=o;if((a|0)==4){f[d+4>>2]=2;f[d+8>>2]=1;q=2;break}if((o|0)>1)r=1;else{u=j;return}do{f[d+(r<<2)>>2]=r;r=r+1|0}while((r|0)!=(o|0));if((a|0)!=5){u=j;return}if((e|0)==16){p[g>>3]=1.0;p[g+8>>3]=0.0;u=j;return}else{f[g>>2]=1065353216;f[g+4>>2]=0;u=j;return}}else{f[l+(b<<2)>>2]=1;f[k+(b<<2)>>2]=0;if((b|0)>0){F1a(k|0,0,b<<2|0)|0;o=0;do{s=b-o|0;t=s+-1|0;v=Y(f[c+(t<<2)>>2]|0,f[l+(s<<2)>>2]|0)|0;f[l+(t<<2)>>2]=v;o=o+1|0}while((o|0)!=(b|0))}if(!i)w=d;else w=(m|0)==(f[c+(b+-1<<2)>>2]|0)?d:g;a:do if(!(m&1)){o=f[l+4>>2]|0;v=Y(o,m)|0;t=v>>1;s=0;while(1)if(1<<s>>>0<m>>>0)s=s+1|0;else break;x=v>>2;do if((m|0)>=3)if((m|0)<257){y=10-s|0;z=m+-4|0;if((m|0)<4)break;else A=0;do{B=Y((h[162372+(A>>2)>>0]|0)>>>y,o)|0;f[w+(A<<2)>>2]=B;C=B+t|0;f[w+((A|1)<<2)>>2]=C;f[w+((A|2)<<2)>>2]=B+x;f[w+((A|3)<<2)>>2]=C+x;A=A+4|0}while((A|0)<=(z|0))}else{z=34-s|0;y=0;do{C=Y(((h[162372+(y>>>10&255)>>0]|0)<<16|(h[162372+(y>>>2&255)>>0]|0)<<24|(h[162372+(y>>>18&255)>>0]|0)<<8|(h[162372+(y>>26)>>0]|0))>>>z,o)|0;f[w+(y<<2)>>2]=C;B=C+t|0;f[w+((y|1)<<2)>>2]=B;f[w+((y|2)<<2)>>2]=C+x;f[w+((y|3)<<2)>>2]=B+x;y=y+4|0}while((y|0)<(m|0))}else{f[w>>2]=0;f[w+4>>2]=t}while(0);t=k+4|0;f[t>>2]=(f[t>>2]|0)+1;if((b|0)>1?(x=f[l+8>>2]|0,(m|0)<(a|0)):0){o=c+4|0;if((m|0)>0){v=m;y=x;b:while(1){z=0;do{f[w+(z+v<<2)>>2]=(f[w+(z<<2)>>2]|0)+y;z=z+1|0}while((z|0)!=(m|0));z=v+m|0;if((z|0)>=(a|0)){D=s;break a}B=x+y|0;C=(f[t>>2]|0)+1|0;f[t>>2]=C;if((C|0)<(f[o>>2]|0)){v=z;y=B;continue}else{E=t;F=B;G=1}while(1){f[E>>2]=0;B=(f[l+(G+2<<2)>>2]|0)+F-(f[l+(G<<2)>>2]|0)|0;C=G+1|0;H=k+(C<<2)|0;I=(f[H>>2]|0)+1|0;f[H>>2]=I;if((I|0)<(f[c+(C<<2)>>2]|0)){v=z;y=B;continue b}else{E=H;F=B;G=C}}}}else{y=m<<1;if((y|0)>=(a|0)){D=s;break}v=f[o>>2]|0;x=y;do{y=(f[t>>2]|0)+1|0;f[t>>2]=y;if((y|0)>=(v|0)){y=t;z=1;do{f[y>>2]=0;z=z+1|0;y=k+(z<<2)|0;C=(f[y>>2]|0)+1|0;f[y>>2]=C}while((C|0)>=(f[c+(z<<2)>>2]|0))}x=x+m|0}while((x|0)<(a|0));D=s}}else D=s}else{f[w>>2]=0;if((a|0)>1){x=f[l+4>>2]|0;t=1;v=0;while(1){o=x+v|0;z=(f[k>>2]|0)+1|0;f[k>>2]=z;if((z|0)<(f[c>>2]|0))J=o;else{z=k;y=o;o=0;while(1){f[z>>2]=0;C=(f[l+(o+2<<2)>>2]|0)+y-(f[l+(o<<2)>>2]|0)|0;o=o+1|0;z=k+(o<<2)|0;B=(f[z>>2]|0)+1|0;f[z>>2]=B;if((B|0)<(f[c+(o<<2)>>2]|0)){J=C;break}else y=C}}f[w+(t<<2)>>2]=J;t=t+1|0;if((t|0)==(a|0)){D=0;break}else v=J}}else D=0}while(0);if((w|0)!=(d|0)?(f[d>>2]=0,v=a&1,(v|0)<(a|0)):0){t=v;do{v=t+1|0;x=f[w+(v<<2)>>2]|0;f[d+(f[w+(t<<2)>>2]<<2)>>2]=t;f[d+(x<<2)>>2]=v;t=t+2|0}while((t|0)<(a|0));q=D}else q=D}while(0);if(!(a+-1&a)){K=+p[10416+(q<<4)>>3];L=-+p[10416+(q<<4)+8>>3]}else{N=+P(+(-6.283185307179586/+(a|0)));K=+M(+(1.0-N*N));L=N}q=(a+1|0)/2|0;D=(a&1|0)==0;if((e|0)==16){p[g>>3]=1.0;p[g+8>>3]=0.0;if(D){p[g+(q<<4)>>3]=-1.0;p[g+(q<<4)+8>>3]=0.0}if((a|0)>2){O=1;Q=K;R=L}else{u=j;return}while(1){p[g+(O<<4)>>3]=Q;p[g+(O<<4)+8>>3]=R;e=a-O|0;p[g+(e<<4)>>3]=Q;p[g+(e<<4)+8>>3]=-R;N=K*R+L*Q;O=O+1|0;if((O|0)>=(q|0))break;else{Q=K*Q-L*R;R=N}}u=j;return}else{n[g>>2]=1.0;n[g+4>>2]=0.0;if(D){n[g+(q<<3)>>2]=-1.0;n[g+(q<<3)+4>>2]=0.0}if((a|0)>2){S=1;T=K;U=L}else{u=j;return}while(1){R=T;n[g+(S<<3)>>2]=R;Q=U;n[g+(S<<3)+4>>2]=Q;D=a-S|0;n[g+(D<<3)>>2]=R;n[g+(D<<3)+4>>2]=-Q;Q=K*U+L*T;S=S+1|0;if((S|0)>=(q|0))break;else{T=K*T-L*U;U=Q}}u=j;return}}function kM(a,b,c){a=a|0;b=b|0;c=c|0;uM(a,b,c);return}function lM(a,b,c){a=a|0;b=b|0;c=c|0;vM(a,b,c);return}function mM(a,b,c){a=a|0;b=b|0;c=c|0;tM(a,b,c);return}function nM(a,b,c){a=a|0;b=b|0;c=c|0;rM(a,b,c);return}function oM(a,b,c){a=a|0;b=b|0;c=c|0;sM(a,b,c);return}function pM(a,b,c){a=a|0;b=b|0;c=c|0;qM(a,b,c);return}function qM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0.0,O=0.0,P=0;e=u;u=u+48|0;g=e;h=f[a+28>>2]|0;i=(b[a+34>>0]|0)!=0;j=+p[a+8>>3];if(i){k=c+8|0;l=+p[k>>3];m=+p[c>>3];p[k>>3]=m;n=m;o=l;q=k}else{n=+p[c>>3];o=0.0;q=c}a:do switch(h|0){case 1:{p[d>>3]=j*n;break}case 2:{l=+p[q+8>>3];p[d+8>>3]=j*(n-l);p[d>>3]=j*(n+l);break}default:{c=h+1>>1;if(h&1|0){k=q+-8|0;p[d>>3]=n;p[d+8>>3]=0.0;if((c|0)>1){r=f[a+16>>2]|0;s=1;do{t=f[r+(s<<2)>>2]|0;v=f[r+(h-s<<2)>>2]|0;l=+p[k+(s<<4)>>3];m=+p[k+(s<<4)+8>>3];p[d+(t<<4)>>3]=l;p[d+(t<<4)+8>>3]=-m;p[d+(v<<4)>>3]=l;p[d+(v<<4)+8>>3]=m;s=s+1|0}while((s|0)!=(c|0))}w=g;x=a;y=w+48|0;do{f[w>>2]=f[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=1;p[g+8>>3]=1.0;f[g+28>>2]=h;rM(g,d,d);p[d>>3]=j*+p[d>>3];if((h|0)>1){s=1;do{k=s<<1;m=j*+p[d+(k+2<<3)>>3];p[d+(s<<3)>>3]=j*+p[d+(k<<3)>>3];p[d+(s+1<<3)>>3]=m;s=s+2|0}while((s|0)<(h|0))}break a}s=(q|0)==(d|0);k=f[a+20>>2]|0;m=+p[q+8>>3];l=+p[q+(h+-1<<3)>>3];p[d>>3]=n+l;p[d+8>>3]=l-n;r=k+16|0;do if((c|0)>2){if(s){v=k;t=2;l=m;z=r;while(1){A=h-t|0;B=+p[d+(A+-1<<3)>>3];C=l+B;D=d+(t<<3)|0;E=+p[D>>3];F=d+(A<<3)|0;G=+p[F>>3];H=E-G;I=l-B;B=E+G;G=+p[z>>3];E=+p[v+24>>3];J=I*G+B*E;K=B*G-I*E;L=d+((t|1)<<3)|0;l=+p[L>>3];p[D>>3]=C-K;p[L>>3]=-H-J;p[F>>3]=C+K;p[d+(A+1<<3)>>3]=H-J;t=t+2|0;if((t|0)>=(c|0))break;else{A=z;z=z+16|0;v=A}}M=c+1&-2;N=l;break}v=f[a+16>>2]|0;z=k;t=2;J=m;A=r;while(1){F=h-t|0;H=+p[q+(F+-1<<3)>>3];K=J+H;C=+p[q+(t<<3)>>3];E=+p[q+(F<<3)>>3];I=C-E;G=J-H;H=C+E;E=+p[A>>3];C=+p[z+24>>3];B=G*E+H*C;O=H*E-G*C;J=+p[q+((t|1)<<3)>>3];F=t>>1;L=f[v+(F<<2)>>2]|0;p[d+(L<<3)>>3]=K-O;p[d+(L+1<<3)>>3]=-I-B;L=f[v+(c-F<<2)>>2]|0;p[d+(L<<3)>>3]=K+O;p[d+(L+1<<3)>>3]=I-B;t=t+2|0;if((t|0)>=(c|0))break;else{L=A;A=A+16|0;z=L}}M=c+1&-2;N=J}else{M=2;N=m}while(0);if((M|0)<=(c|0)){m=+p[q+(c<<3)>>3]*2.0;if(s)P=c;else P=f[(f[a+16>>2]|0)+(c<<2)>>2]<<1;p[d+(P<<3)>>3]=N*2.0;p[d+(P+1<<3)>>3]=m}r=a+4|0;k=f[r>>2]|0;z=f[k>>2]>>1;f[k>>2]=z;w=g;x=a;y=w+48|0;do{f[w>>2]=f[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));k=(z|0)==1&1;A=g+4|0;f[A>>2]=(f[A>>2]|0)+(k<<2);f[g>>2]=(f[g>>2]|0)-k;b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=(s^1)&1;p[g+8>>3]=1.0;f[g+28>>2]=c;rM(g,d,d);k=f[r>>2]|0;f[k>>2]=f[k>>2]<<1;if((h|0)>0){k=0;do{A=d+(k<<3)|0;t=d+((k|1)<<3)|0;m=-(j*+p[t>>3]);p[A>>3]=j*+p[A>>3];p[t>>3]=m;k=k+2|0}while((k|0)<(h|0))}}}while(0);if(!i){u=e;return}p[q>>3]=o;u=e;return}function rM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0,S=0.0,T=0.0,U=0.0,V=0.0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;e=u;u=u+1168|0;g=e;h=f[a+20>>2]|0;i=f[a+16>>2]|0;j=a+28|0;k=f[j>>2]|0;l=(b[a+32>>0]|0)!=0;m=a+24|0;n=f[m>>2]|0;o=+p[a+8>>3];if((n|0)!=(k|0))if((n|0)==(k<<1|0))q=2;else q=(n|0)/(k|0)|0;else q=1;do if((d|0)==(c|0)){a:do if(!(b[a+33>>0]|0)){r=f[a+4>>2]|0;s=f[a>>2]|0;if((f[r>>2]|0)==(f[r+(s+-1<<2)>>2]|0))t=s;else{f[g>>2]=0;f[g+4>>2]=0;s=c$(g,33)|0;r=162289;v=s+33|0;do{b[s>>0]=b[r>>0]|0;s=s+1|0;r=r+1|0}while((s|0)<(v|0));j$(-215,g,162323,162327,657);d$(g);t=f[a>>2]|0}if((t|0)!=1){if((k|0)>0){w=0;x=i}else break;while(1){r=f[x>>2]|0;if((r|0)>(w|0)){s=d+(w<<4)|0;y=+p[s>>3];z=+p[d+(w<<4)+8>>3];v=d+(r<<4)|0;f[s>>2]=f[v>>2];f[s+4>>2]=f[v+4>>2];f[s+8>>2]=f[v+8>>2];f[s+12>>2]=f[v+12>>2];p[v>>3]=y;p[d+(r<<4)+8>>3]=z}w=w+1|0;if((w|0)==(k|0))break a;else x=x+(q<<2)|0}}if((k&3|0)==0?(r=(k|0)/2|0,v=d+(r<<4)|0,(k|0)>1):0){s=q<<1;A=0;B=i;while(1){C=f[B>>2]|0;D=A|1;E=d+(D<<4)|0;z=+p[E>>3];y=+p[d+(D<<4)+8>>3];F=v+(C<<4)|0;f[E>>2]=f[F>>2];f[E+4>>2]=f[F+4>>2];f[E+8>>2]=f[F+8>>2];f[E+12>>2]=f[F+12>>2];p[F>>3]=z;p[F+8>>3]=y;if((C|0)>(A|0)){F=d+(A<<4)|0;y=+p[F>>3];z=+p[d+(A<<4)+8>>3];E=d+(C<<4)|0;f[F>>2]=f[E>>2];f[F+4>>2]=f[E+4>>2];f[F+8>>2]=f[E+8>>2];f[F+12>>2]=f[E+12>>2];p[E>>3]=y;p[d+(C<<4)+8>>3]=z;E=v+(D<<4)|0;z=+p[E>>3];y=+p[E+8>>3];D=v+(C+1<<4)|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2];f[E+8>>2]=f[D+8>>2];f[E+12>>2]=f[D+12>>2];p[D>>3]=z;p[D+8>>3]=y}A=A+2|0;if((A|0)>=(r|0))break;else B=B+(s<<2)|0}}}while(0);if(l){s=k+-2|0;if((k|0)<2)G=0;else{B=0;do{r=d+(B<<4)+8|0;A=d+((B|1)<<4)+8|0;y=-+p[A>>3];p[r>>3]=-+p[r>>3];p[A>>3]=y;B=B+2|0}while((B|0)<=(s|0));G=k&-2}s=d+(k+-1<<4)+8|0;if((G|0)<(k|0))p[s>>3]=-+p[s>>3]}}else{s=k+-2|0;B=(k|0)<2;if(l){if(B)H=0;else{A=q<<1;r=0;v=i;while(1){D=f[v>>2]|0;E=f[v+(q<<2)>>2]|0;y=-+p[c+(D<<4)+8>>3];p[d+(r<<4)>>3]=+p[c+(D<<4)>>3];p[d+(r<<4)+8>>3]=y;y=-+p[c+(E<<4)+8>>3];D=r|1;p[d+(D<<4)>>3]=+p[c+(E<<4)>>3];p[d+(D<<4)+8>>3]=y;r=r+2|0;if((r|0)>(s|0))break;else v=v+(A<<2)|0}H=k&-2}if((H|0)>=(k|0))break;A=k+-1|0;y=-+p[c+(A<<4)+8>>3];p[d+(H<<4)>>3]=+p[c+(A<<4)>>3];p[d+(H<<4)+8>>3]=y;break}else{if(B)I=0;else{A=q<<1;v=0;r=i;while(1){D=f[r+(q<<2)>>2]|0;E=c+(f[r>>2]<<4)|0;C=d+(v<<4)|0;f[C>>2]=f[E>>2];f[C+4>>2]=f[E+4>>2];f[C+8>>2]=f[E+8>>2];f[C+12>>2]=f[E+12>>2];E=c+(D<<4)|0;D=d+((v|1)<<4)|0;f[D>>2]=f[E>>2];f[D+4>>2]=f[E+4>>2];f[D+8>>2]=f[E+8>>2];f[D+12>>2]=f[E+12>>2];v=v+2|0;if((v|0)>(s|0))break;else r=r+(A<<2)|0}I=k&-2}A=k+-1|0;if((I|0)>=(k|0))break;r=c+(A<<4)|0;s=d+(A<<4)|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];f[s+8>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];break}}while(0);c=a+4|0;k=f[c>>2]|0;I=f[k>>2]|0;q=I&1;if(!q){if((I|0)<4){J=n;K=1}else{i=f[j>>2]|0;H=(i|0)>0;G=n;x=4;w=1;while(1){t=(G|0)/4|0;if(H){r=w<<1;s=(w|0)>1;A=0;do{v=d+(A<<4)|0;B=v+(r<<4)|0;y=+p[B>>3];E=B+8|0;z=+p[E>>3];D=B+(w<<4)|0;L=+p[D>>3];C=D+8|0;M=+p[C>>3];N=y+L;O=z+M;P=z-M;M=L-y;y=+p[v>>3];F=d+(A<<4)+8|0;L=+p[F>>3];Q=v+(w<<4)|0;z=+p[Q>>3];R=Q+8|0;S=+p[R>>3];T=y+z;U=L+S;V=y-z;z=L-S;p[v>>3]=N+T;p[F>>3]=O+U;p[B>>3]=T-N;p[E>>3]=U-O;p[Q>>3]=P+V;p[R>>3]=M+z;p[D>>3]=V-P;p[C>>3]=z-M;if(s){C=t;D=1;while(1){R=v+(D<<4)|0;Q=R+(r<<4)|0;E=R+(w<<4)|0;M=+p[E>>3];B=C<<1;z=+p[h+(B<<4)>>3];F=E+8|0;P=+p[F>>3];V=+p[h+(B<<4)+8>>3];O=M*z-P*V;U=z*P+M*V;V=+p[Q>>3];M=+p[h+(C<<4)+8>>3];B=Q+8|0;P=+p[B>>3];z=+p[h+(C<<4)>>3];N=V*M+P*z;T=V*z-M*P;W=Q+(w<<4)|0;P=+p[W>>3];X=C*3|0;M=+p[h+(X<<4)+8>>3];Z=W+8|0;z=+p[Z>>3];V=+p[h+(X<<4)>>3];S=P*M+z*V;L=P*V-M*z;z=T+L;M=N+S;V=N-S;S=L-T;T=+p[R>>3];X=R+8|0;L=+p[X>>3];N=O+T;P=U+L;y=T-O;O=L-U;p[R>>3]=N+z;p[X>>3]=P+M;p[Q>>3]=N-z;p[B>>3]=P-M;p[E>>3]=y+V;p[F>>3]=O+S;p[W>>3]=y-V;p[Z>>3]=O-S;D=D+1|0;if((D|0)==(w|0))break;else C=C+t|0}}A=A+x|0}while((A|0)<(i|0))}A=x<<2;if((A|0)>(I|0)){J=t;K=x;break}else{r=x;G=t;x=A;w=r}}}if((K|0)<(I|0)){w=f[j>>2]|0;x=(w|0)>0;G=J;i=K;while(1){H=i<<1;r=(G|0)/2|0;b:do if(x){if((i|0)>1)_=0;else{A=0;while(1){s=d+(A<<4)|0;S=+p[s>>3];C=s+(i<<4)|0;O=+p[C>>3];D=d+(A<<4)+8|0;V=+p[D>>3];v=C+8|0;y=+p[v>>3];p[s>>3]=S+O;p[D>>3]=V+y;p[C>>3]=S-O;p[v>>3]=V-y;A=A+H|0;if((A|0)>=(w|0))break b}}do{A=d+(_<<4)|0;y=+p[A>>3];v=A+(i<<4)|0;V=+p[v>>3];C=d+(_<<4)+8|0;O=+p[C>>3];D=v+8|0;S=+p[D>>3];p[A>>3]=y+V;p[C>>3]=O+S;p[v>>3]=y-V;p[D>>3]=O-S;D=r;v=1;while(1){C=A+(v<<4)|0;s=C+(i<<4)|0;S=+p[s>>3];O=+p[h+(D<<4)>>3];Z=s+8|0;V=+p[Z>>3];y=+p[h+(D<<4)+8>>3];M=S*O-V*y;P=O*V+S*y;y=+p[C>>3];W=C+8|0;S=+p[W>>3];p[C>>3]=y+M;p[W>>3]=S+P;p[s>>3]=y-M;p[Z>>3]=S-P;v=v+1|0;if((v|0)==(i|0))break;else D=D+r|0}_=_+H|0}while((_|0)<(w|0))}while(0);if((H|0)<(I|0)){G=r;i=H}else{$=r;aa=H;break}}}else{$=J;aa=K}}else{$=n;aa=1}n=q^1;c:do if((n|0)<(f[a>>2]|0)){q=g+8|0;K=g+4|0;J=k;i=$;G=n;I=aa;while(1){w=f[J+(G<<2)>>2]|0;_=Y(w,I)|0;x=(i|0)/(w|0)|0;d:do switch(w|0){case 3:{t=f[j>>2]|0;if((t|0)>0){D=I<<1;if((I|0)>1)ba=0;else{v=0;while(1){A=d+(v<<4)|0;Z=A+(I<<4)|0;P=+p[Z>>3];s=A+(D<<4)|0;S=+p[s>>3];M=P+S;W=Z+8|0;y=+p[W>>3];C=s+8|0;V=+p[C>>3];O=y+V;z=+p[A>>3];F=d+(v<<4)+8|0;N=+p[F>>3];U=(y-V)*.8660254037844386;V=(S-P)*.8660254037844386;p[A>>3]=M+z;p[F>>3]=O+N;P=z-M*.5;M=N-O*.5;p[Z>>3]=P+U;p[W>>3]=V+M;p[s>>3]=P-U;p[C>>3]=M-V;v=v+_|0;if((v|0)>=(t|0))break d}}do{v=d+(ba<<4)|0;C=v+(I<<4)|0;V=+p[C>>3];s=v+(D<<4)|0;M=+p[s>>3];U=V+M;W=C+8|0;P=+p[W>>3];Z=s+8|0;O=+p[Z>>3];N=P+O;z=+p[v>>3];F=d+(ba<<4)+8|0;S=+p[F>>3];y=(P-O)*.8660254037844386;O=(M-V)*.8660254037844386;p[v>>3]=U+z;p[F>>3]=N+S;V=z-U*.5;U=S-N*.5;p[C>>3]=V+y;p[W>>3]=O+U;p[s>>3]=V-y;p[Z>>3]=U-O;Z=x;s=1;while(1){W=v+(s<<4)|0;C=W+(I<<4)|0;O=+p[C>>3];U=+p[h+(Z<<4)>>3];F=C+8|0;y=+p[F>>3];V=+p[h+(Z<<4)+8>>3];N=O*U-y*V;S=U*y+O*V;A=W+(D<<4)|0;V=+p[A>>3];E=Z<<1;O=+p[h+(E<<4)>>3];B=A+8|0;y=+p[B>>3];U=+p[h+(E<<4)+8>>3];z=V*O-y*U;M=O*y+V*U;U=N+z;V=S+M;y=(S-M)*.8660254037844386;M=(z-N)*.8660254037844386;N=+p[W>>3];E=W+8|0;z=+p[E>>3];p[W>>3]=N+U;p[E>>3]=z+V;S=N-U*.5;U=z-V*.5;p[C>>3]=y+S;p[F>>3]=M+U;p[A>>3]=S-y;p[B>>3]=U-M;s=s+1|0;if((s|0)==(I|0))break;else Z=Z+x|0}ba=ba+_|0}while((ba|0)<(t|0))}break}case 5:{t=f[j>>2]|0;if((t|0)>0){D=(I|0)>0;Z=I<<1;s=0;do{if(D){v=d+(s<<4)|0;B=0;A=0;while(1){F=v+(A<<4)|0;C=F+(Z<<4)|0;E=C+(Z<<4)|0;W=F+(I<<4)|0;M=+p[W>>3];U=+p[h+(B<<4)>>3];Q=W+8|0;y=+p[Q>>3];S=+p[h+(B<<4)+8>>3];V=M*U-y*S;z=U*y+M*S;S=+p[E>>3];X=B<<2;M=+p[h+(X<<4)>>3];R=E+8|0;y=+p[R>>3];U=+p[h+(X<<4)+8>>3];N=S*M-y*U;O=M*y+S*U;U=V+N;S=z+O;y=V-N;N=z-O;X=C+(I<<4)|0;O=+p[X>>3];ca=B*3|0;z=+p[h+(ca<<4)>>3];da=X+8|0;V=+p[da>>3];M=+p[h+(ca<<4)+8>>3];P=O*z-V*M;L=z*V+O*M;M=+p[C>>3];ca=B<<1;O=+p[h+(ca<<4)>>3];ea=C+8|0;V=+p[ea>>3];z=+p[h+(ca<<4)+8>>3];T=M*O-V*z;fa=O*V+M*z;z=P+T;M=L+fa;V=P-T;T=L-fa;fa=+p[F>>3];ca=F+8|0;L=+p[ca>>3];P=U+z;O=S+M;p[F>>3]=fa+P;p[ca>>3]=L+O;ga=fa-P*.25;P=L-O*.25;O=(U-z)*.5590169943749475;z=(S-M)*.5590169943749475;M=(N+T)*.9510565162951535;S=(y+V)*-.9510565162951535;U=M-N*.36327126400268045;N=y*.36327126400268045+S;y=M-T*1.5388417685876268;T=V*1.5388417685876268+S;S=O+ga;V=z+P;M=ga-O;O=P-z;p[W>>3]=y+S;p[Q>>3]=T+V;p[E>>3]=S-y;p[R>>3]=V-T;p[C>>3]=U+M;p[ea>>3]=N+O;p[X>>3]=M-U;p[da>>3]=O-N;A=A+1|0;if((A|0)==(I|0))break;else B=B+x|0}}s=s+_|0}while((s|0)<(t|0))}break}default:{t=w+-1|0;s=(t|0)/2|0;Z=(f[m>>2]|0)/(w|0)|0;D=s<<1;F1a(q|0,0,1152)|0;f[g>>2]=q;f[K>>2]=D;if(D>>>0>72){B=OYa(D>>>0>268435455?-1:D<<4)|0;F1a(B|0,0,s<<5|0)|0;f[g>>2]=B;ha=B}else ha=q;B=ha+(s<<4)|0;D=f[j>>2]|0;if((D|0)>0){A=(I|0)>0;v=(w|0)<3;da=(t|0)>1;t=D;D=0;while(1){if(A){X=d+(D<<4)|0;ea=0;C=0;while(1){R=X+(C<<4)|0;N=+p[R>>3];E=R+8|0;O=+p[E>>3];if(!C){if(!v){Q=I;W=1;U=N;M=O;while(1){ca=R+(Q<<4)|0;T=+p[ca>>3];F=R+(_-Q<<4)|0;V=+p[F>>3];y=T+V;S=+p[ca+8>>3];z=+p[F+8>>3];P=S+z;ga=U+y;L=M+P;F=W+-1|0;p[ha+(F<<4)>>3]=y;p[ha+(F<<4)+8>>3]=S-z;ca=B+(F<<4)|0;p[ca>>3]=T-V;p[ca+8>>3]=P;if((W|0)<(s|0)){Q=Q+I|0;W=W+1|0;U=ga;M=L}else{ia=ga;ja=L;ka=82;break}}}}else{W=h+((Y(ea,w)|0)<<4)|0;if(!v){Q=ea;ca=I;F=1;M=N;U=O;while(1){la=R+(ca<<4)|0;L=+p[la>>3];ga=+p[h+(Q<<4)>>3];P=+p[la+8>>3];V=+p[h+(Q<<4)+8>>3];T=L*ga-P*V;z=ga*P+L*V;la=R+(_-ca<<4)|0;V=+p[la>>3];ma=W+(0-Q<<4)|0;L=+p[ma>>3];P=+p[la+8>>3];ga=+p[ma+8>>3];S=V*L-P*ga;y=L*P+V*ga;ga=T+S;V=z+y;P=M+ga;L=U+V;ma=F+-1|0;p[ha+(ma<<4)>>3]=ga;p[ha+(ma<<4)+8>>3]=z-y;la=B+(ma<<4)|0;p[la>>3]=T-S;p[la+8>>3]=V;if((F|0)<(s|0)){Q=Q+ea|0;ca=ca+I|0;F=F+1|0;M=P;U=L}else{ia=P;ja=L;ka=82;break}}}}e:do if((ka|0)==82?(ka=0,p[R>>3]=ia,p[E>>3]=ja,!v):0){if(da){na=I;oa=1}else{F=I;ca=1;while(1){Q=R+(F<<4)|0;p[Q>>3]=N;p[Q+8>>3]=O;Q=R+(_-F<<4)|0;p[Q>>3]=N;p[Q+8>>3]=O;if((ca|0)<(s|0)){F=F+I|0;ca=ca+1|0}else break e}}while(1){ca=Y(oa,Z)|0;F=f[m>>2]|0;Q=ca;W=0;U=N;M=O;L=N;P=O;while(1){V=+p[h+(Q<<4)>>3];S=V*+p[ha+(W<<4)>>3];T=+p[h+(Q<<4)+8>>3];y=T*+p[ha+(W<<4)+8>>3];la=B+(W<<4)|0;z=V*+p[la+8>>3];V=T*+p[la>>3];L=L+(S+y);U=U+(S-y);P=P+(z-V);M=M+(z+V);la=Q+ca|0;W=W+1|0;if((W|0)>=(s|0))break;else Q=la-((la|0)>=(F|0)?F:0)|0}F=R+(na<<4)|0;p[F>>3]=U;p[F+8>>3]=M;F=R+(_-na<<4)|0;p[F>>3]=L;p[F+8>>3]=P;if((oa|0)<(s|0)){na=na+I|0;oa=oa+1|0}else break}}while(0);C=C+1|0;if((C|0)==(I|0))break;else ea=ea+x|0}pa=f[j>>2]|0}else pa=t;D=D+_|0;if((D|0)>=(pa|0))break;else t=pa}}if((ha|0)!=(q|0)){QYa(ha);f[g>>2]=q;f[K>>2]=72}}}while(0);w=G+1|0;if((w|0)>=(f[a>>2]|0))break c;J=f[c>>2]|0;i=x;G=w;I=_}}while(0);if(o!=1.0){ja=l?-o:o;c=f[j>>2]|0;if((c|0)>0)qa=0;else{u=e;return}do{a=d+(qa<<4)|0;g=d+(qa<<4)+8|0;ia=ja*+p[g>>3];p[a>>3]=o*+p[a>>3];p[g>>3]=ia;qa=qa+1|0}while((qa|0)<(c|0));u=e;return}if(!l){u=e;return}l=f[j>>2]|0;if((l|0)<2)ra=0;else{j=l+-2|0;c=((j|0)>1?j:1)&2147483646;qa=0;do{g=d+(qa<<4)+8|0;a=d+((qa|1)<<4)+8|0;o=-+p[a>>3];p[g>>3]=-+p[g>>3];p[a>>3]=o;qa=qa+2|0}while((qa|0)<=(j|0));ra=c+2|0}c=d+(l+-1<<4)+8|0;if((ra|0)>=(l|0)){u=e;return}p[c>>3]=-+p[c>>3];u=e;return}function sM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,n=0.0,o=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0.0;e=u;u=u+48|0;g=e;h=f[a+28>>2]|0;i=b[a+34>>0]|0;j=i<<24>>24!=0;k=i&255;l=+p[a+8>>3];i=d+(k<<3)|0;d=(h|0)==1;do if(d){p[i>>3]=l*+p[c>>3];m=i}else{if((h|0)==2){n=+p[c>>3];o=+p[c+8>>3];p[i+8>>3]=l*(n-o);p[i>>3]=l*(n+o);m=i;break}if(h&1|0){q=i+(0-k<<3)|0;p[q>>3]=l*+p[c>>3];r=q+8|0;p[r>>3]=0.0;if((h|0)>1){s=f[a+16>>2]|0;t=1;do{v=t+1|0;o=l*+p[c+(f[s+(v<<2)>>2]<<3)>>3];p[q+(t<<4)>>3]=l*+p[c+(f[s+(t<<2)>>2]<<3)>>3];p[q+(t<<4)+8>>3]=0.0;p[q+(v<<4)>>3]=o;p[q+(v<<4)+8>>3]=0.0;t=t+2|0}while((t|0)<(h|0))}w=g;x=a;y=w+48|0;do{f[w>>2]=f[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=1;p[g+8>>3]=1.0;rM(g,q,q);if(!j)p[r>>3]=+p[q>>3];m=q;break}o=l*.5;t=h>>1;s=a+4|0;v=f[s>>2]|0;z=f[v>>2]>>1;f[v>>2]=z;w=g;x=a;y=w+48|0;do{f[w>>2]=f[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));q=(z|0)==1&1;r=g+4|0;f[r>>2]=(f[r>>2]|0)+(q<<2);f[g>>2]=(f[g>>2]|0)-q;b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=0;p[g+8>>3]=1.0;f[g+28>>2]=t;rM(g,c,i);q=f[s>>2]|0;f[q>>2]=f[q>>2]<<1;n=+p[i>>3];q=i+8|0;A=+p[q>>3];p[i>>3]=l*(n+A);B=l*(n-A);p[q>>3]=B;q=i+(t<<3)|0;A=+p[q>>3];r=i+(h+-1<<3)|0;n=+p[r>>3];p[r>>3]=B;if((t|0)>2){r=2;B=n;v=f[a+20>>2]|0;do{C=v;v=v+16|0;D=+p[i+((r|1)<<3)>>3];E=o*(B+D);F=h-r|0;G=i+(F<<3)|0;H=+p[G>>3];I=i+(r<<3)|0;J=+p[I>>3];K=o*(H-J);L=o*(H+J);J=o*(D-B);D=+p[v>>3];H=+p[C+24>>3];M=E*D-K*H;N=E*H+D*K;C=i+(F+-1<<3)|0;B=+p[C>>3];p[i+(r+-1<<3)>>3]=L+M;p[C>>3]=L-M;p[I>>3]=J+N;p[G>>3]=N-J;r=r+2|0}while((r|0)<(t|0));O=t+1&-2;P=B}else{O=2;P=n}if((O|0)<=(t|0)){p[i+(t+-1<<3)>>3]=l*A;p[q>>3]=-(l*P)}m=i}while(0);if(!j){u=e;return}if(!(d|(h&1|0)==0)){u=e;return}p[m+-8>>3]=+p[m>>3];p[m>>3]=0.0;if((h|0)<=1){u=e;return}p[m+(h<<3)>>3]=0.0;u=e;return}function tM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0.0,k=0,l=0.0,m=0,o=0.0,q=0.0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0,P=0.0,Q=0.0,R=0;e=u;u=u+48|0;g=e;h=f[a+28>>2]|0;i=(b[a+34>>0]|0)!=0;j=+p[a+8>>3];if(i){k=c+4|0;l=+n[k>>2];m=f[c>>2]|0;f[k>>2]=m;o=(f[s>>2]=m,+n[s>>2]);q=l;r=k}else{o=+n[c>>2];q=0.0;r=c}a:do switch(h|0){case 1:{n[d>>2]=j*o;break}case 2:{l=+n[r+4>>2];n[d+4>>2]=j*(o-l);n[d>>2]=j*(o+l);break}default:{c=h+1>>1;if(h&1|0){k=r+-4|0;n[d>>2]=o;n[d+4>>2]=0.0;if((c|0)>1){m=f[a+16>>2]|0;t=1;do{v=f[m+(t<<2)>>2]|0;w=f[m+(h-t<<2)>>2]|0;x=f[k+(t<<3)>>2]|0;l=+n[k+(t<<3)+4>>2];f[d+(v<<3)>>2]=x;n[d+(v<<3)+4>>2]=-l;f[d+(w<<3)>>2]=x;n[d+(w<<3)+4>>2]=l;t=t+1|0}while((t|0)!=(c|0))}y=g;z=a;A=y+48|0;do{f[y>>2]=f[z>>2];y=y+4|0;z=z+4|0}while((y|0)<(A|0));b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=1;p[g+8>>3]=1.0;f[g+28>>2]=h;uM(g,d,d);n[d>>2]=j*+n[d>>2];if((h|0)>1){t=1;do{k=t<<1;l=j*+n[d+(k+2<<2)>>2];n[d+(t<<2)>>2]=j*+n[d+(k<<2)>>2];n[d+(t+1<<2)>>2]=l;t=t+2|0}while((t|0)<(h|0))}break a}t=(r|0)==(d|0);k=f[a+20>>2]|0;l=+n[r+4>>2];B=+n[r+(h+-1<<2)>>2];n[d>>2]=o+B;n[d+4>>2]=B-o;m=k+8|0;do if((c|0)>2){if(t){w=k;x=2;B=l;v=m;while(1){C=h-x|0;D=+n[d+(C+-1<<2)>>2];E=B+D;F=d+(x<<2)|0;G=+n[F>>2];H=d+(C<<2)|0;I=+n[H>>2];J=G-I;K=B-D;D=G+I;I=+n[v>>2];G=+n[w+12>>2];L=K*I+D*G;M=D*I-K*G;N=d+((x|1)<<2)|0;B=+n[N>>2];n[F>>2]=E-M;n[N>>2]=-J-L;n[H>>2]=E+M;n[d+(C+1<<2)>>2]=J-L;x=x+2|0;if((x|0)>=(c|0))break;else{C=v;v=v+8|0;w=C}}O=c+1&-2;P=B;break}w=f[a+16>>2]|0;v=k;x=2;L=l;C=m;while(1){H=h-x|0;J=+n[r+(H+-1<<2)>>2];M=L+J;E=+n[r+(x<<2)>>2];G=+n[r+(H<<2)>>2];K=E-G;I=L-J;J=E+G;G=+n[C>>2];E=+n[v+12>>2];D=I*G+J*E;Q=J*G-I*E;L=+n[r+((x|1)<<2)>>2];H=x>>1;N=f[w+(H<<2)>>2]|0;n[d+(N<<2)>>2]=M-Q;n[d+(N+1<<2)>>2]=-K-D;N=f[w+(c-H<<2)>>2]|0;n[d+(N<<2)>>2]=M+Q;n[d+(N+1<<2)>>2]=K-D;x=x+2|0;if((x|0)>=(c|0))break;else{N=C;C=C+8|0;v=N}}O=c+1&-2;P=L}else{O=2;P=l}while(0);if((O|0)<=(c|0)){l=+n[r+(c<<2)>>2]*2.0;if(t)R=c;else R=f[(f[a+16>>2]|0)+(c<<2)>>2]<<1;n[d+(R<<2)>>2]=P*2.0;n[d+(R+1<<2)>>2]=l}m=a+4|0;k=f[m>>2]|0;v=f[k>>2]>>1;f[k>>2]=v;y=g;z=a;A=y+48|0;do{f[y>>2]=f[z>>2];y=y+4|0;z=z+4|0}while((y|0)<(A|0));k=(v|0)==1&1;C=g+4|0;f[C>>2]=(f[C>>2]|0)+(k<<2);f[g>>2]=(f[g>>2]|0)-k;b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=(t^1)&1;p[g+8>>3]=1.0;f[g+28>>2]=c;uM(g,d,d);k=f[m>>2]|0;f[k>>2]=f[k>>2]<<1;if((h|0)>0){k=0;do{C=d+(k<<2)|0;x=d+((k|1)<<2)|0;l=-(j*+n[x>>2]);n[C>>2]=j*+n[C>>2];n[x>>2]=l;k=k+2|0}while((k|0)<(h|0))}}}while(0);if(!i){u=e;return}n[r>>2]=q;u=e;return}function uM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;e=u;u=u+1104|0;g=e;h=f[a+20>>2]|0;i=f[a+16>>2]|0;j=a+28|0;k=f[j>>2]|0;l=(b[a+32>>0]|0)!=0;m=a+24|0;o=f[m>>2]|0;q=+p[a+8>>3];if((o|0)!=(k|0))if((o|0)==(k<<1|0))r=2;else r=(o|0)/(k|0)|0;else r=1;do if((d|0)==(c|0)){a:do if(!(b[a+33>>0]|0)){s=f[a+4>>2]|0;t=f[a>>2]|0;if((f[s>>2]|0)==(f[s+(t+-1<<2)>>2]|0))v=t;else{f[g>>2]=0;f[g+4>>2]=0;t=c$(g,33)|0;s=162289;w=t+33|0;do{b[t>>0]=b[s>>0]|0;t=t+1|0;s=s+1|0}while((t|0)<(w|0));j$(-215,g,162323,162327,657);d$(g);v=f[a>>2]|0}if((v|0)!=1){if((k|0)>0){x=0;y=i}else break;while(1){s=f[y>>2]|0;if((s|0)>(x|0)){t=d+(x<<3)|0;w=f[t>>2]|0;z=f[d+(x<<3)+4>>2]|0;A=d+(s<<3)|0;B=A;C=f[B+4>>2]|0;D=t;f[D>>2]=f[B>>2];f[D+4>>2]=C;f[A>>2]=w;f[d+(s<<3)+4>>2]=z}x=x+1|0;if((x|0)==(k|0))break a;else y=y+(r<<2)|0}}if((k&3|0)==0?(z=(k|0)/2|0,s=d+(z<<3)|0,(k|0)>1):0){w=r<<1;A=0;C=i;while(1){D=f[C>>2]|0;B=A|1;t=d+(B<<3)|0;E=f[t>>2]|0;F=f[d+(B<<3)+4>>2]|0;G=s+(D<<3)|0;H=G;I=f[H+4>>2]|0;J=t;f[J>>2]=f[H>>2];f[J+4>>2]=I;f[G>>2]=E;f[G+4>>2]=F;if((D|0)>(A|0)){F=d+(A<<3)|0;G=f[F>>2]|0;E=f[d+(A<<3)+4>>2]|0;I=d+(D<<3)|0;J=I;H=f[J+4>>2]|0;t=F;f[t>>2]=f[J>>2];f[t+4>>2]=H;f[I>>2]=G;f[d+(D<<3)+4>>2]=E;E=s+(B<<3)|0;B=f[E>>2]|0;G=f[E+4>>2]|0;I=s+(D+1<<3)|0;D=I;H=f[D+4>>2]|0;t=E;f[t>>2]=f[D>>2];f[t+4>>2]=H;f[I>>2]=B;f[I+4>>2]=G}A=A+2|0;if((A|0)>=(z|0))break;else C=C+(w<<2)|0}}}while(0);if(l){w=k+-2|0;if((k|0)<2)K=0;else{C=0;do{z=d+(C<<3)+4|0;A=d+((C|1)<<3)+4|0;L=-+n[A>>2];n[z>>2]=-+n[z>>2];n[A>>2]=L;C=C+2|0}while((C|0)<=(w|0));K=k&-2}w=d+(k+-1<<3)+4|0;if((K|0)<(k|0))n[w>>2]=-+n[w>>2]}}else{w=k+-2|0;C=(k|0)<2;if(l){if(C)M=0;else{A=r<<1;z=0;s=i;while(1){G=f[s>>2]|0;I=f[s+(r<<2)>>2]|0;L=-+n[c+(G<<3)+4>>2];f[d+(z<<3)>>2]=f[c+(G<<3)>>2];n[d+(z<<3)+4>>2]=L;L=-+n[c+(I<<3)+4>>2];G=z|1;f[d+(G<<3)>>2]=f[c+(I<<3)>>2];n[d+(G<<3)+4>>2]=L;z=z+2|0;if((z|0)>(w|0))break;else s=s+(A<<2)|0}M=k&-2}if((M|0)>=(k|0))break;A=k+-1|0;L=-+n[c+(A<<3)+4>>2];f[d+(M<<3)>>2]=f[c+(A<<3)>>2];n[d+(M<<3)+4>>2]=L;break}else{if(C)N=0;else{A=r<<1;s=0;z=i;while(1){G=f[z+(r<<2)>>2]|0;I=c+(f[z>>2]<<3)|0;B=f[I+4>>2]|0;H=d+(s<<3)|0;f[H>>2]=f[I>>2];f[H+4>>2]=B;B=c+(G<<3)|0;G=f[B+4>>2]|0;H=d+((s|1)<<3)|0;f[H>>2]=f[B>>2];f[H+4>>2]=G;s=s+2|0;if((s|0)>(w|0))break;else z=z+(A<<2)|0}N=k&-2}A=k+-1|0;if((N|0)>=(k|0))break;z=c+(A<<3)|0;w=f[z+4>>2]|0;s=d+(A<<3)|0;f[s>>2]=f[z>>2];f[s+4>>2]=w;break}}while(0);c=a+4|0;k=f[c>>2]|0;N=f[k>>2]|0;r=N&1;if(!r){if((N|0)<4){O=o;P=1}else{i=f[j>>2]|0;M=(i|0)>0;K=o;y=4;x=1;while(1){v=(K|0)/4|0;if(M){w=x<<1;s=(x|0)>1;z=0;do{A=d+(z<<3)|0;C=A+(w<<3)|0;L=+n[C>>2];G=C+4|0;Q=+n[G>>2];H=C+(x<<3)|0;R=+n[H>>2];B=H+4|0;S=+n[B>>2];T=L+R;U=Q+S;V=Q-S;S=R-L;L=+n[A>>2];I=d+(z<<3)+4|0;R=+n[I>>2];t=A+(x<<3)|0;Q=+n[t>>2];D=t+4|0;W=+n[D>>2];X=L+Q;Z=R+W;_=L-Q;Q=R-W;n[A>>2]=T+X;n[I>>2]=U+Z;n[C>>2]=X-T;n[G>>2]=Z-U;n[t>>2]=V+_;n[D>>2]=S+Q;n[H>>2]=_-V;n[B>>2]=Q-S;if(s){B=v;H=1;while(1){D=A+(H<<3)|0;t=D+(w<<3)|0;G=D+(x<<3)|0;S=+n[G>>2];C=B<<1;Q=+n[h+(C<<3)>>2];I=G+4|0;V=+n[I>>2];_=+n[h+(C<<3)+4>>2];U=S*Q-V*_;Z=Q*V+S*_;_=+n[t>>2];S=+n[h+(B<<3)+4>>2];C=t+4|0;V=+n[C>>2];Q=+n[h+(B<<3)>>2];T=_*S+V*Q;X=_*Q-S*V;E=t+(x<<3)|0;V=+n[E>>2];J=B*3|0;S=+n[h+(J<<3)+4>>2];F=E+4|0;Q=+n[F>>2];_=+n[h+(J<<3)>>2];W=V*S+Q*_;R=V*_-S*Q;Q=X+R;S=T+W;_=T-W;W=R-X;X=+n[D>>2];J=D+4|0;R=+n[J>>2];T=U+X;V=Z+R;L=X-U;U=R-Z;n[D>>2]=T+Q;n[J>>2]=V+S;n[t>>2]=T-Q;n[C>>2]=V-S;n[G>>2]=L+_;n[I>>2]=U+W;n[E>>2]=L-_;n[F>>2]=U-W;H=H+1|0;if((H|0)==(x|0))break;else B=B+v|0}}z=z+y|0}while((z|0)<(i|0))}z=y<<2;if((z|0)>(N|0)){O=v;P=y;break}else{w=y;K=v;y=z;x=w}}}if((P|0)<(N|0)){x=f[j>>2]|0;y=(x|0)>0;K=O;i=P;while(1){M=i<<1;w=(K|0)/2|0;b:do if(y){if((i|0)>1)$=0;else{z=0;while(1){s=d+(z<<3)|0;W=+n[s>>2];B=s+(i<<3)|0;U=+n[B>>2];H=d+(z<<3)+4|0;_=+n[H>>2];A=B+4|0;L=+n[A>>2];n[s>>2]=W+U;n[H>>2]=_+L;n[B>>2]=W-U;n[A>>2]=_-L;z=z+M|0;if((z|0)>=(x|0))break b}}do{z=d+($<<3)|0;L=+n[z>>2];A=z+(i<<3)|0;_=+n[A>>2];B=d+($<<3)+4|0;U=+n[B>>2];H=A+4|0;W=+n[H>>2];n[z>>2]=L+_;n[B>>2]=U+W;n[A>>2]=L-_;n[H>>2]=U-W;H=w;A=1;while(1){B=z+(A<<3)|0;s=B+(i<<3)|0;W=+n[s>>2];U=+n[h+(H<<3)>>2];F=s+4|0;_=+n[F>>2];L=+n[h+(H<<3)+4>>2];S=W*U-_*L;V=U*_+W*L;L=+n[B>>2];E=B+4|0;W=+n[E>>2];n[B>>2]=L+S;n[E>>2]=W+V;n[s>>2]=L-S;n[F>>2]=W-V;A=A+1|0;if((A|0)==(i|0))break;else H=H+w|0}$=$+M|0}while(($|0)<(x|0))}while(0);if((M|0)<(N|0)){K=w;i=M}else{aa=w;ba=M;break}}}else{aa=O;ba=P}}else{aa=o;ba=1}o=r^1;c:do if((o|0)<(f[a>>2]|0)){r=g+8|0;P=g+4|0;O=k;i=aa;K=o;N=ba;while(1){x=f[O+(K<<2)>>2]|0;$=Y(x,N)|0;y=(i|0)/(x|0)|0;d:do switch(x|0){case 3:{v=f[j>>2]|0;if((v|0)>0){H=N<<1;if((N|0)>1)ca=0;else{A=0;while(1){z=d+(A<<3)|0;F=z+(N<<3)|0;V=+n[F>>2];s=z+(H<<3)|0;W=+n[s>>2];S=V+W;E=F+4|0;L=+n[E>>2];B=s+4|0;_=+n[B>>2];U=L+_;Q=+n[z>>2];I=d+(A<<3)+4|0;T=+n[I>>2];Z=(L-_)*.8660253882408142;_=(W-V)*.8660253882408142;n[z>>2]=S+Q;n[I>>2]=U+T;V=Q-S*.5;S=T-U*.5;n[F>>2]=V+Z;n[E>>2]=_+S;n[s>>2]=V-Z;n[B>>2]=S-_;A=A+$|0;if((A|0)>=(v|0))break d}}do{A=d+(ca<<3)|0;B=A+(N<<3)|0;_=+n[B>>2];s=A+(H<<3)|0;S=+n[s>>2];Z=_+S;E=B+4|0;V=+n[E>>2];F=s+4|0;U=+n[F>>2];T=V+U;Q=+n[A>>2];I=d+(ca<<3)+4|0;W=+n[I>>2];L=(V-U)*.8660253882408142;U=(S-_)*.8660253882408142;n[A>>2]=Z+Q;n[I>>2]=T+W;_=Q-Z*.5;Z=W-T*.5;n[B>>2]=_+L;n[E>>2]=U+Z;n[s>>2]=_-L;n[F>>2]=Z-U;F=y;s=1;while(1){E=A+(s<<3)|0;B=E+(N<<3)|0;U=+n[B>>2];Z=+n[h+(F<<3)>>2];I=B+4|0;L=+n[I>>2];_=+n[h+(F<<3)+4>>2];T=U*Z-L*_;W=Z*L+U*_;z=E+(H<<3)|0;_=+n[z>>2];G=F<<1;U=+n[h+(G<<3)>>2];C=z+4|0;L=+n[C>>2];Z=+n[h+(G<<3)+4>>2];Q=_*U-L*Z;S=U*L+_*Z;Z=T+Q;_=W+S;L=(W-S)*.8660253882408142;S=(Q-T)*.8660253882408142;T=+n[E>>2];G=E+4|0;Q=+n[G>>2];n[E>>2]=T+Z;n[G>>2]=Q+_;W=T-Z*.5;Z=Q-_*.5;n[B>>2]=L+W;n[I>>2]=S+Z;n[z>>2]=W-L;n[C>>2]=Z-S;s=s+1|0;if((s|0)==(N|0))break;else F=F+y|0}ca=ca+$|0}while((ca|0)<(v|0))}break}case 5:{v=f[j>>2]|0;if((v|0)>0){H=(N|0)>0;F=N<<1;s=0;do{if(H){A=d+(s<<3)|0;C=0;z=0;while(1){I=A+(z<<3)|0;B=I+(F<<3)|0;G=B+(F<<3)|0;E=I+(N<<3)|0;S=+n[E>>2];Z=+n[h+(C<<3)>>2];t=E+4|0;L=+n[t>>2];W=+n[h+(C<<3)+4>>2];_=S*Z-L*W;Q=Z*L+S*W;W=+n[G>>2];J=C<<2;S=+n[h+(J<<3)>>2];D=G+4|0;L=+n[D>>2];Z=+n[h+(J<<3)+4>>2];T=W*S-L*Z;U=S*L+W*Z;Z=_+T;W=Q+U;L=_-T;T=Q-U;J=B+(N<<3)|0;U=+n[J>>2];da=C*3|0;Q=+n[h+(da<<3)>>2];ea=J+4|0;_=+n[ea>>2];S=+n[h+(da<<3)+4>>2];V=U*Q-_*S;R=Q*_+U*S;S=+n[B>>2];da=C<<1;U=+n[h+(da<<3)>>2];fa=B+4|0;_=+n[fa>>2];Q=+n[h+(da<<3)+4>>2];X=S*U-_*Q;ga=U*_+S*Q;Q=V+X;S=R+ga;_=V-X;X=R-ga;ga=+n[I>>2];da=I+4|0;R=+n[da>>2];V=Z+Q;U=W+S;n[I>>2]=ga+V;n[da>>2]=R+U;ha=ga-V*.25;V=R-U*.25;U=(Z-Q)*.55901700258255;Q=(W-S)*.55901700258255;S=(T+X)*.9510565400123596;W=(L+_)*-.9510565400123596;Z=S-T*.3632712662220001;T=L*.3632712662220001+W;L=S-X*1.538841724395752;X=_*1.538841724395752+W;W=U+ha;_=Q+V;S=ha-U;U=V-Q;n[E>>2]=L+W;n[t>>2]=X+_;n[G>>2]=W-L;n[D>>2]=_-X;n[B>>2]=Z+S;n[fa>>2]=T+U;n[J>>2]=S-Z;n[ea>>2]=U-T;z=z+1|0;if((z|0)==(N|0))break;else C=C+y|0}}s=s+$|0}while((s|0)<(v|0))}break}default:{v=x+-1|0;s=(v|0)/2|0;F=(f[m>>2]|0)/(x|0)|0;H=s<<1;F1a(r|0,0,1088)|0;f[g>>2]=r;f[P>>2]=H;if(H>>>0>136){C=OYa(H>>>0>536870911?-1:H<<3)|0;F1a(C|0,0,s<<4|0)|0;f[g>>2]=C;ia=C}else ia=r;C=ia+(s<<3)|0;H=f[j>>2]|0;if((H|0)>0){z=(N|0)>0;A=(x|0)<3;ea=(v|0)>1;v=H;H=0;while(1){if(z){J=d+(H<<3)|0;fa=0;B=0;while(1){D=J+(B<<3)|0;T=+n[D>>2];G=D+4|0;U=+n[G>>2];if(!B){if(!A){t=N;E=1;Z=T;S=U;while(1){da=D+(t<<3)|0;X=+n[da>>2];I=D+($-t<<3)|0;_=+n[I>>2];L=X+_;W=+n[da+4>>2];Q=+n[I+4>>2];V=W+Q;ha=Z+L;R=S+V;I=E+-1|0;n[ia+(I<<3)>>2]=L;n[ia+(I<<3)+4>>2]=W-Q;da=C+(I<<3)|0;n[da>>2]=X-_;n[da+4>>2]=V;if((E|0)<(s|0)){t=t+N|0;E=E+1|0;Z=ha;S=R}else{ja=ha;ka=R;la=82;break}}}}else{E=h+((Y(fa,x)|0)<<3)|0;if(!A){t=fa;da=N;I=1;S=T;Z=U;while(1){ma=D+(da<<3)|0;R=+n[ma>>2];ha=+n[h+(t<<3)>>2];V=+n[ma+4>>2];_=+n[h+(t<<3)+4>>2];X=R*ha-V*_;Q=ha*V+R*_;ma=D+($-da<<3)|0;_=+n[ma>>2];na=E+(0-t<<3)|0;R=+n[na>>2];V=+n[ma+4>>2];ha=+n[na+4>>2];W=_*R-V*ha;L=R*V+_*ha;ha=X+W;_=Q+L;V=S+ha;R=Z+_;na=I+-1|0;n[ia+(na<<3)>>2]=ha;n[ia+(na<<3)+4>>2]=Q-L;ma=C+(na<<3)|0;n[ma>>2]=X-W;n[ma+4>>2]=_;if((I|0)<(s|0)){t=t+fa|0;da=da+N|0;I=I+1|0;S=V;Z=R}else{ja=V;ka=R;la=82;break}}}}e:do if((la|0)==82?(la=0,n[D>>2]=ja,n[G>>2]=ka,!A):0){if(ea){oa=N;pa=1}else{I=N;da=1;while(1){t=D+(I<<3)|0;n[t>>2]=T;n[t+4>>2]=U;t=D+($-I<<3)|0;n[t>>2]=T;n[t+4>>2]=U;if((da|0)<(s|0)){I=I+N|0;da=da+1|0}else break e}}while(1){da=Y(pa,F)|0;I=f[m>>2]|0;t=da;E=0;Z=T;S=U;R=T;V=U;while(1){_=+n[h+(t<<3)>>2];W=_*+n[ia+(E<<3)>>2];X=+n[h+(t<<3)+4>>2];L=X*+n[ia+(E<<3)+4>>2];ma=C+(E<<3)|0;Q=_*+n[ma+4>>2];_=X*+n[ma>>2];R=R+(W+L);Z=Z+(W-L);V=V+(Q-_);S=S+(Q+_);ma=t+da|0;E=E+1|0;if((E|0)>=(s|0))break;else t=ma-((ma|0)>=(I|0)?I:0)|0}I=D+(oa<<3)|0;n[I>>2]=Z;n[I+4>>2]=S;I=D+($-oa<<3)|0;n[I>>2]=R;n[I+4>>2]=V;if((pa|0)<(s|0)){oa=oa+N|0;pa=pa+1|0}else break}}while(0);B=B+1|0;if((B|0)==(N|0))break;else fa=fa+y|0}qa=f[j>>2]|0}else qa=v;H=H+$|0;if((H|0)>=(qa|0))break;else v=qa}}if((ia|0)!=(r|0)){QYa(ia);f[g>>2]=r;f[P>>2]=136}}}while(0);x=K+1|0;if((x|0)>=(f[a>>2]|0))break c;O=f[c>>2]|0;i=y;K=x;N=$}}while(0);if(q!=1.0){ka=l?-q:q;c=f[j>>2]|0;if((c|0)>0)ra=0;else{u=e;return}do{a=d+(ra<<3)|0;g=d+(ra<<3)+4|0;ja=ka*+n[g>>2];n[a>>2]=q*+n[a>>2];n[g>>2]=ja;ra=ra+1|0}while((ra|0)<(c|0));u=e;return}if(!l){u=e;return}l=f[j>>2]|0;if((l|0)<2)sa=0;else{j=l+-2|0;c=((j|0)>1?j:1)&2147483646;ra=0;do{g=d+(ra<<3)+4|0;a=d+((ra|1)<<3)+4|0;q=-+n[a>>2];n[g>>2]=-+n[g>>2];n[a>>2]=q;ra=ra+2|0}while((ra|0)<=(j|0));sa=c+2|0}c=d+(l+-1<<3)+4|0;if((sa|0)>=(l|0)){u=e;return}n[c>>2]=-+n[c>>2];u=e;return}function vM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,o=0.0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0.0,G=0,H=0,I=0.0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0;e=u;u=u+48|0;g=e;h=f[a+28>>2]|0;i=b[a+34>>0]|0;j=i<<24>>24!=0;k=i&255;l=+p[a+8>>3];i=d+(k<<2)|0;d=(h|0)==1;do if(d){n[i>>2]=l*+n[c>>2];m=i}else{if((h|0)==2){o=+n[c>>2];q=+n[c+4>>2];n[i+4>>2]=l*(o-q);n[i>>2]=l*(o+q);m=i;break}if(h&1|0){r=i+(0-k<<2)|0;n[r>>2]=l*+n[c>>2];s=r+4|0;n[s>>2]=0.0;if((h|0)>1){t=f[a+16>>2]|0;v=1;do{w=v+1|0;q=l*+n[c+(f[t+(w<<2)>>2]<<2)>>2];n[r+(v<<3)>>2]=l*+n[c+(f[t+(v<<2)>>2]<<2)>>2];n[r+(v<<3)+4>>2]=0.0;n[r+(w<<3)>>2]=q;n[r+(w<<3)+4>>2]=0.0;v=v+2|0}while((v|0)<(h|0))}x=g;y=a;z=x+48|0;do{f[x>>2]=f[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=1;p[g+8>>3]=1.0;uM(g,r,r);if(!j)f[s>>2]=f[r>>2];m=r;break}q=l*.5;v=h>>1;t=a+4|0;w=f[t>>2]|0;A=f[w>>2]>>1;f[w>>2]=A;x=g;y=a;z=x+48|0;do{f[x>>2]=f[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));r=(A|0)==1&1;s=g+4|0;f[s>>2]=(f[s>>2]|0)+(r<<2);f[g>>2]=(f[g>>2]|0)-r;b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=0;p[g+8>>3]=1.0;f[g+28>>2]=v;uM(g,c,i);r=f[t>>2]|0;f[r>>2]=f[r>>2]<<1;o=+n[i>>2];r=i+4|0;B=+n[r>>2];n[i>>2]=l*(o+B);C=l*(o-B);n[r>>2]=C;r=i+(v<<2)|0;B=+n[r>>2];s=i+(h+-1<<2)|0;o=+n[s>>2];n[s>>2]=C;if((v|0)>2){s=2;C=o;w=f[a+20>>2]|0;do{D=w;w=w+8|0;E=+n[i+((s|1)<<2)>>2];F=q*(C+E);G=h-s|0;H=i+(G<<2)|0;I=+n[H>>2];J=i+(s<<2)|0;K=+n[J>>2];L=q*(I-K);M=q*(I+K);K=q*(E-C);E=+n[w>>2];I=+n[D+12>>2];N=F*E-L*I;O=F*I+E*L;D=i+(G+-1<<2)|0;C=+n[D>>2];n[i+(s+-1<<2)>>2]=M+N;n[D>>2]=M-N;n[J>>2]=K+O;n[H>>2]=O-K;s=s+2|0}while((s|0)<(v|0));P=v+1&-2;Q=C}else{P=2;Q=o}if((P|0)<=(v|0)){n[i+(v+-1<<2)>>2]=l*B;n[r>>2]=-(l*Q)}m=i}while(0);if(!j){u=e;return}if(!(d|(h&1|0)==0)){u=e;return}f[m+-4>>2]=f[m>>2];n[m>>2]=0.0;if((h|0)<=1){u=e;return}n[m+(h<<2)>>2]=0.0;u=e;return}function wM(a,b,c){a=a|0;b=b|0;c=c|0;fi[f[a+44>>2]&255](a+8|0,b,c);return}function xM(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=32060;b=a+1232|0;c=f[b>>2]|0;d=a+1240|0;if((c|0)!=(d|0)){if(c|0)QYa(c);f[b>>2]=d;f[a+1236>>2]=264}d=a+192|0;b=f[d>>2]|0;c=a+200|0;if((b|0)==(c|0))return;if(b|0)QYa(b);f[d>>2]=c;f[a+196>>2]=1032;return}function yM(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=32060;b=a+1232|0;c=f[b>>2]|0;d=a+1240|0;if((c|0)!=(d|0)){if(c|0)QYa(c);f[b>>2]=d;f[a+1236>>2]=264}d=f[a+192>>2]|0;if((d|0)==(a+200|0)|(d|0)==0){PYa(a);return}QYa(d);PYa(a);return}function zM(a,b,c){a=a|0;b=b|0;c=c|0;return}function AM(a){a=a|0;PYa(a);return}function BM(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;k=u;u=u+16|0;l=k;m=NYa(12)|0;f[m>>2]=32124;f[m+4>>2]=0;b[m+8>>0]=0;CM(m);PYa(m);if((c|0)==1&(j|0)>0){f[l>>2]=0;f[l+4>>2]=0;K1a(c$(l,190)|0,162691,190)|0;j$(-213,l,357830,162327,3311);d$(l)}l=NYa(4244)|0;f[l>>2]=32144;m=l+4|0;f[l+60>>2]=0;f[l+64>>2]=0;f[l+68>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[l+84>>2]=l+92;f[l+88>>2]=1032;f[l+1124>>2]=l+1132;f[l+1128>>2]=1032;f[l+2164>>2]=l+2172;f[l+2168>>2]=1032;f[l+3204>>2]=l+3212;f[l+3208>>2]=1032;b[l+20>>0]=0;b[l+21>>0]=0;b[l+22>>0]=0;m=l+24|0;f[l+52>>2]=0;b[l+56>>0]=0;b[l+57>>0]=0;b[l+72>>0]=0;f[l+76>>2]=0;f[l+80>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;b[m+24>>0]=0;DM(l,c,d,e,g,h,i,j);j=NYa(16)|0;f[j+4>>2]=1;f[j>>2]=32164;f[j+8>>2]=l;f[a>>2]=j;f[a+4>>2]=l;u=k;return}function CM(a){a=a|0;f[a>>2]=32124;return}function DM(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;l=u;u=u+16|0;m=l;n=(g|0)!=(i|0);f[a+52>>2]=k;k=a+24|0;f[k>>2]=c;o=a+28|0;f[o>>2]=d;p=a+44|0;f[p>>2]=e;f[a+76>>2]=g;f[a+80>>2]=i;q=j&1;r=q&255;s=(g|0)==1;t=(i|0)==1;v=s&t;if(!q)if(!v){q=(i|0)==2;if(!(s&q))if((g|0)==2&q)w=3;else x=8;else w=2}else w=1;else if(!v){v=(g|0)==2;if(!(v&t))if(v&(i|0)==2)w=6;else x=8;else w=5}else w=4;if((x|0)==8)w=0;i=a+32|0;f[i>>2]=w;v=a+22|0;b[v>>0]=r;r=a+56|0;t=j>>>2&1;b[r>>0]=t;g=a+57|0;b[g>>0]=j>>>1&1;q=a+20|0;b[q>>0]=0;s=a+21|0;b[s>>0]=0;y=a+48|0;b[y>>0]=(w|0)!=6&(w|0)!=3&1;z=(e|0)==5?4:8;e=a+36|0;f[e>>2]=z;A=z<<1;z=a+40|0;f[z>>2]=A;switch(w&7){case 3:case 6:{f[e>>2]=A;break}default:{}}do if(!(t<<24>>24)){A=(d|0)>1;if(A&(c|0)==1){B=2-(j>>>9&1)|0;x=15;break}if((d|0)!=1){e=a+60|0;if(A&(c|0)>1){A=a+64|0;C=f[A>>2]|0;D=f[e>>2]|0;E=C-D>>2;F=D;G=C;if(E>>>0>=2)if((E|0)!=2?(C=F+8|0,(G|0)!=(C|0)):0){f[A>>2]=G+(~((G+-4-C|0)>>>2)<<2);H=w;I=F;J=D}else{H=w;I=F;J=D}else{GM(e,2-E|0);E=f[e>>2]|0;H=f[i>>2]|0;I=E;J=E}E=(H&-2|0)==4;f[I>>2]=E&1;f[I+4>>2]=(E^1)&1;K=J;L=e}else{M=0;N=e;x=23}}else{B=1;x=15}}else{B=1;x=15}while(0);if((x|0)==15){M=B;N=a+60|0;x=23}if((x|0)==23){x=a+64|0;B=f[x>>2]|0;J=f[N>>2]|0;I=B;switch(B-J>>2|0){case 0:{GM(N,1);break}case 1:break;default:{B=J+4|0;if((I|0)!=(B|0))f[x>>2]=I+(~((I+-4-B|0)>>>2)<<2)}}f[f[a+60>>2]>>2]=(M|0)==2&1;K=f[N>>2]|0;L=N}N=L+4|0;M=(f[N>>2]|0)-K>>2;if(!M){u=l;return}K=a+4|0;B=m+4|0;I=a+8|0;x=a+88|0;J=a+84|0;H=a+92|0;i=a+12|0;w=m+4|0;c=a+16|0;d=a+2168|0;t=a+2164|0;e=a+2172|0;E=a+3208|0;D=a+3204|0;F=a+3212|0;C=a+1128|0;G=a+1124|0;A=a+1132|0;a=f[L>>2]|0;O=n;n=(j&1024|0)!=0;j=0;P=M;do{M=(j|0)==1;n=M|n;O=O&(M^1);M=j;j=j+1|0;Q=h[v>>0]|0;R=(b[g>>0]|0)==0?Q:Q|2;Q=(b[r>>0]|0)==0;S=Q?R:R|4;R=O?S|16:S;S=(b[y>>0]|0)==0?R:R|32;R=(j|0)==(P|0)?S:S|64;S=f[k>>2]|0;T=f[o>>2]|0;do if(!(f[a+(M<<2)>>2]|0)){U=(S|0)!=1|Q^1;V=U?S:T;b[q>>0]=n&1;eM(m,V,U?T:1,f[p>>2]|0,R,q);U=f[m>>2]|0;W=f[B>>2]|0;if(U|0){X=U+4|0;f[X>>2]=(f[X>>2]|0)+1}X=f[K>>2]|0;f[K>>2]=U;f[I>>2]=W;if(X|0?(W=X+4|0,U=f[W>>2]|0,f[W>>2]=U+-1,(U|0)==1):0)ki[f[(f[X>>2]|0)+8>>2]&2047](X);X=f[m>>2]|0;if(X|0?(U=X+4|0,W=f[U>>2]|0,f[U>>2]=W+-1,(W|0)==1):0)ki[f[(f[X>>2]|0)+8>>2]&2047](X);if(b[q>>0]|0){X=Y(f[z>>2]|0,V)|0;if((f[x>>2]|0)>>>0>=X>>>0){f[x>>2]=X;break}V=f[J>>2]|0;if((V|0)!=(H|0)){if(V|0)QYa(V);f[J>>2]=H;f[x>>2]=1032}f[x>>2]=X;if(X>>>0>1032){V=OYa(X)|0;f[J>>2]=V}}}else{b[s>>0]=n&1;eM(m,T,S,f[p>>2]|0,R|128,s);V=f[m>>2]|0;X=f[w>>2]|0;if(V|0){W=V+4|0;f[W>>2]=(f[W>>2]|0)+1}W=f[i>>2]|0;f[i>>2]=V;f[c>>2]=X;if(W|0?(X=W+4|0,V=f[X>>2]|0,f[X>>2]=V+-1,(V|0)==1):0)ki[f[(f[W>>2]|0)+8>>2]&2047](W);W=f[m>>2]|0;if(W|0?(V=W+4|0,X=f[V>>2]|0,f[V>>2]=X+-1,(X|0)==1):0)ki[f[(f[W>>2]|0)+8>>2]&2047](W);do if(b[s>>0]|0){W=Y(f[z>>2]|0,T)|0;if((f[C>>2]|0)>>>0>=W>>>0){f[C>>2]=W;break}X=f[G>>2]|0;if((X|0)!=(A|0)){if(X|0)QYa(X);f[G>>2]=A;f[C>>2]=1032}f[C>>2]=W;if(W>>>0>1032){X=OYa(W)|0;f[G>>2]=X}}while(0);X=Y(f[z>>2]|0,T)|0;if((f[d>>2]|0)>>>0<X>>>0){W=f[t>>2]|0;if((W|0)!=(e|0)){if(W|0)QYa(W);f[t>>2]=e;f[d>>2]=1032}f[d>>2]=X;if(X>>>0>1032){W=OYa(X)|0;f[t>>2]=W}}else f[d>>2]=X;X=Y(f[z>>2]|0,T)|0;if((f[E>>2]|0)>>>0>=X>>>0){f[E>>2]=X;break}W=f[D>>2]|0;if((W|0)!=(F|0)){if(W|0)QYa(W);f[D>>2]=F;f[E>>2]=1032}f[E>>2]=X;if(X>>>0>1032){W=OYa(X)|0;f[D>>2]=W}}while(0);a=f[L>>2]|0;P=(f[N>>2]|0)-a>>2}while(j>>>0<P>>>0);u=l;return}function EM(a){a=a|0;PYa(a);return}function FM(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+8>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function GM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){F1a(g|0,0,b<<2|0)|0;f[e>>2]=g+(b<<2);return}h=f[a>>2]|0;i=g-h|0;g=i>>2;j=g+b|0;if(j>>>0>1073741823)gXa(a);k=d-h|0;d=k>>1;l=k>>2>>>0<536870911?(d>>>0<j>>>0?j:d):1073741823;do if(l)if(l>>>0>1073741823){d=De(8)|0;UYa(d,358155);f[d>>2]=130560;Of(d|0,21520,875)}else{m=NYa(l<<2)|0;break}else m=0;while(0);d=m+(g<<2)|0;F1a(d|0,0,b<<2|0)|0;j=d+(0-g<<2)|0;if((i|0)>0)K1a(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<2);f[c>>2]=m+(l<<2);if(!h)return;PYa(h);return}function HM(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=a+60|0;h=a+64|0;i=f[g>>2]|0;j=(f[h>>2]|0)-i>>2;if(!j)return;k=a+76|0;l=a+80|0;m=i;i=b;b=c;c=0;n=j;do{j=f[l>>2]|0;o=(c|0)==1;p=o?j:f[k>>2]|0;b=o?e:b;i=o?d:i;o=c;c=c+1|0;q=(c|0)==(n|0);if(!(f[m+(o<<2)>>2]|0))KM(a,i,b,d,e,(p|0)!=(j|0),q);else LM(a,i,b,d,e,p,j,q);m=f[g>>2]|0;n=(f[h>>2]|0)-m>>2}while(c>>>0<n>>>0);return}function IM(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=32144;b=a+3204|0;c=f[b>>2]|0;d=a+3212|0;if((c|0)!=(d|0)){if(c|0)QYa(c);f[b>>2]=d;f[a+3208>>2]=1032}d=a+2164|0;b=f[d>>2]|0;c=a+2172|0;if((b|0)!=(c|0)){if(b|0)QYa(b);f[d>>2]=c;f[a+2168>>2]=1032}c=a+1124|0;d=f[c>>2]|0;b=a+1132|0;if((d|0)!=(b|0)){if(d|0)QYa(d);f[c>>2]=b;f[a+1128>>2]=1032}b=a+84|0;c=f[b>>2]|0;d=a+92|0;if((c|0)!=(d|0)){if(c|0)QYa(c);f[b>>2]=d;f[a+88>>2]=1032}d=f[a+60>>2]|0;if(d|0){b=a+64|0;c=f[b>>2]|0;if((c|0)!=(d|0))f[b>>2]=c+(~((c+-4-d|0)>>>2)<<2);PYa(d)}d=a+12|0;c=f[d>>2]|0;if(c|0?(b=c+4|0,e=f[b>>2]|0,f[b>>2]=e+-1,(e|0)==1):0)ki[f[(f[c>>2]|0)+8>>2]&2047](c);f[d>>2]=0;f[a+16>>2]=0;d=a+4|0;c=f[d>>2]|0;if(!c){f[d>>2]=0;g=a+8|0;f[g>>2]=0;return}e=c+4|0;b=f[e>>2]|0;f[e>>2]=b+-1;if((b|0)!=1){f[d>>2]=0;g=a+8|0;f[g>>2]=0;return}ki[f[(f[c>>2]|0)+8>>2]&2047](c);f[d>>2]=0;g=a+8|0;f[g>>2]=0;return}function JM(a){a=a|0;IM(a);PYa(a);return}function KM(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=f[a+24>>2]|0;k=f[a+28>>2]|0;if((j|0)==1?(b[a+56>>0]|0)==0:0){l=1;m=k}else{l=k;m=j}j=a+36|0;k=f[j>>2]|0;o=Y(k,m)|0;q=a+20|0;r=b[q>>0]|0;if(!(r<<24>>24))s=0;else s=(m|0)>1&(m&1|0)!=0&(f[a+32>>2]|0)==1?k:0;if((b[a+22>>0]|0)!=0|h^1)t=o;else t=(f[(m&1|0?j:a+40|0)>>2]|0)+o|0;o=f[a+52>>2]|0;j=(o|0)<1|(o|0)>(l|0)?l:o;o=(j|0)>0;a:do if(o){h=a+8|0;k=a+84|0;u=r;v=0;while(1){w=c+(Y(v,d)|0)|0;x=e+(Y(v,g)|0)|0;if(!(u<<24>>24))y=x;else y=f[k>>2]|0;z=f[h>>2]|0;fi[f[f[z>>2]>>2]&255](z,w,y);if(b[q>>0]|0)K1a(x|0,y+s|0,t|0)|0;x=v+1|0;if((x|0)==(j|0)){A=j;break a}u=b[q>>0]|0;v=x}}else A=0;while(0);if((A|0)<(l|0)){q=A;do{F1a(e+(Y(q,g)|0)|0,0,t|0)|0;q=q+1|0}while((q|0)!=(l|0))}if(!i)return;if((f[a+32>>2]|0)!=2)return;if((f[a+44>>2]|0)==5){a=g>>>2;if(!o)return;i=(m+1|0)/2|0;if((m|0)>2)B=0;else return;do{l=e+((Y(B,a)|0)<<2)|0;q=1;do{t=q<<1;A=m-q<<1;f[l+(A<<2)>>2]=f[l+(t<<2)>>2];n[l+((A|1)<<2)>>2]=-+n[l+((t|1)<<2)>>2];q=q+1|0}while((q|0)<(i|0));B=B+1|0}while((B|0)!=(j|0));return}else{B=g>>>3;if(!o)return;o=(m+1|0)/2|0;if((m|0)>2)C=0;else return;do{g=e+((Y(C,B)|0)<<3)|0;i=1;do{a=i<<1;q=m-i<<1;p[g+(q<<3)>>3]=+p[g+(a<<3)>>3];p[g+((q|1)<<3)>>3]=-+p[g+((a|1)<<3)>>3];i=i+1|0}while((i|0)<(o|0));C=C+1|0}while((C|0)!=(j|0));return}}function LM(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0;k=f[a+28>>2]|0;l=f[a+24>>2]|0;m=a+2164|0;o=f[m>>2]|0;q=a+3204|0;r=f[q>>2]|0;if(!(b[a+21>>0]|0)){s=o;t=r}else{s=r;t=f[a+1124>>2]|0}if(!(b[a+48>>0]|0)){u=0;v=l;w=e;x=c}else{y=(l&1|0)==0;z=(l+1|0)/2|0;A=a+22|0;a:do if(!(b[A>>0]|0)){B=a+40|0;F1a(o|0,0,Y(f[B>>2]|0,k)|0)|0;C=f[m>>2]|0;D=a+36|0;E=d>>>2;F=(f[B>>2]|0)>>>2;switch(f[D>>2]|0){case 4:{if((k|0)>0){G=C;H=0;I=c;while(1){f[G>>2]=f[I>>2];H=H+1|0;if((H|0)==(k|0))break;else{G=G+(F<<2)|0;I=I+(E<<2)|0}}}break}case 8:{if((k|0)>0){I=C;G=0;H=c;while(1){J=f[H+4>>2]|0;f[I>>2]=f[H>>2];f[I+4>>2]=J;G=G+1|0;if((G|0)==(k|0))break;else{I=I+(F<<2)|0;H=H+(E<<2)|0}}}break}case 16:{if((k|0)>0){H=C;I=0;G=c;while(1){J=f[G+4>>2]|0;f[H>>2]=f[G>>2];f[H+4>>2]=J;J=f[G+12>>2]|0;f[H+8>>2]=f[G+8>>2];f[H+12>>2]=J;I=I+1|0;if((I|0)==(k|0))break;else{H=H+(F<<2)|0;G=G+(E<<2)|0}}}break}default:{}}G=c+(Y(f[D>>2]|0,i)|0)|0;if(y){F1a(f[q>>2]|0,0,Y(f[B>>2]|0,k)|0)|0;F=f[D>>2]|0;H=G+(Y(F,l+-2|0)|0)|0;I=f[q>>2]|0;C=(f[B>>2]|0)>>>2;switch(F|0){case 4:{if((k|0)>0){K=I;L=0;M=H}else{N=I;O=G;P=56;break a}while(1){f[K>>2]=f[M>>2];L=L+1|0;if((L|0)==(k|0)){Q=G;P=54;break}else{K=K+(C<<2)|0;M=M+(E<<2)|0}}break}case 8:{if((k|0)>0){R=I;S=0;T=H}else{N=I;O=G;P=56;break a}while(1){B=f[T+4>>2]|0;f[R>>2]=f[T>>2];f[R+4>>2]=B;S=S+1|0;if((S|0)==(k|0)){Q=G;P=54;break}else{R=R+(C<<2)|0;T=T+(E<<2)|0}}break}case 16:{if((k|0)>0){U=I;V=0;W=H}else{N=I;O=G;P=56;break a}while(1){B=f[W+4>>2]|0;f[U>>2]=f[W>>2];f[U+4>>2]=B;B=f[W+12>>2]|0;f[U+8>>2]=f[W+8>>2];f[U+12>>2]=B;V=V+1|0;if((V|0)==(k|0)){Q=G;P=54;break}else{U=U+(C<<2)|0;W=W+(E<<2)|0}}break}default:{N=I;O=G;P=56;break a}}}else X=G}else{if((h|0)!=1){E=a+40|0;C=f[E>>2]|0;H=d>>>2;B=C>>>2;switch(C|0){case 4:{if((k|0)>0){C=o;D=0;F=c;while(1){f[C>>2]=f[F>>2];D=D+1|0;if((D|0)==(k|0))break;else{C=C+(B<<2)|0;F=F+(H<<2)|0}}}break}case 8:{if((k|0)>0){F=o;C=0;D=c;while(1){G=f[D+4>>2]|0;f[F>>2]=f[D>>2];f[F+4>>2]=G;C=C+1|0;if((C|0)==(k|0))break;else{F=F+(B<<2)|0;D=D+(H<<2)|0}}}break}case 16:{if((k|0)>0){D=o;F=0;C=c;while(1){G=f[C+4>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=G;G=f[C+12>>2]|0;f[D+8>>2]=f[C+8>>2];f[D+12>>2]=G;F=F+1|0;if((F|0)==(k|0))break;else{D=D+(B<<2)|0;C=C+(H<<2)|0}}}break}default:{}}b:do if(y){C=f[E>>2]|0;B=c+(Y(C,z)|0)|0;D=C>>>2;switch(C|0){case 4:{if((k|0)>0){Z=r;_=0;$=B}else break b;while(1){f[Z>>2]=f[$>>2];_=_+1|0;if((_|0)==(k|0))break;else{Z=Z+(D<<2)|0;$=$+(H<<2)|0}}break}case 8:{if((k|0)>0){aa=r;ba=0;ca=B}else break b;while(1){C=f[ca+4>>2]|0;f[aa>>2]=f[ca>>2];f[aa+4>>2]=C;ba=ba+1|0;if((ba|0)==(k|0))break;else{aa=aa+(D<<2)|0;ca=ca+(H<<2)|0}}break}case 16:{if((k|0)>0){da=r;ea=0;fa=B}else break b;while(1){C=f[fa+4>>2]|0;f[da>>2]=f[fa>>2];f[da+4>>2]=C;C=f[fa+12>>2]|0;f[da+8>>2]=f[fa+8>>2];f[da+12>>2]=C;ea=ea+1|0;if((ea|0)==(k|0))break;else{da=da+(D<<2)|0;fa=fa+(H<<2)|0}}break}default:break b}}while(0);Q=c+(f[E>>2]|0)|0;P=54;break}H=a+36|0;D=f[H>>2]|0;B=d>>>2;C=D>>>2;switch(D|0){case 4:{if((k|0)>0){D=o;F=0;G=c;while(1){f[D>>2]=f[G>>2];F=F+1|0;if((F|0)==(k|0))break;else{D=D+(C<<2)|0;G=G+(B<<2)|0}}}break}case 8:{if((k|0)>0){G=o;D=0;F=c;while(1){E=f[F+4>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=E;D=D+1|0;if((D|0)==(k|0))break;else{G=G+(C<<2)|0;F=F+(B<<2)|0}}}break}case 16:{if((k|0)>0){F=o;G=0;D=c;while(1){E=f[D+4>>2]|0;f[F>>2]=f[D>>2];f[F+4>>2]=E;E=f[D+12>>2]|0;f[F+8>>2]=f[D+8>>2];f[F+12>>2]=E;G=G+1|0;if((G|0)==(k|0))break;else{F=F+(C<<2)|0;D=D+(B<<2)|0}}}break}default:{}}MM(o,k,f[H>>2]|0);if(y){D=f[H>>2]|0;C=c+(Y(D,l+-1|0)|0)|0;F=f[q>>2]|0;G=D>>>2;switch(D|0){case 4:{if((k|0)>0){D=F;E=0;I=C;while(1){f[D>>2]=f[I>>2];E=E+1|0;if((E|0)==(k|0))break;else{D=D+(G<<2)|0;I=I+(B<<2)|0}}}break}case 8:{if((k|0)>0){I=F;D=0;E=C;while(1){J=f[E+4>>2]|0;f[I>>2]=f[E>>2];f[I+4>>2]=J;D=D+1|0;if((D|0)==(k|0))break;else{I=I+(G<<2)|0;E=E+(B<<2)|0}}}break}case 16:{if((k|0)>0){E=F;I=0;D=C;while(1){J=f[D+4>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=J;J=f[D+12>>2]|0;f[E+8>>2]=f[D+8>>2];f[E+12>>2]=J;I=I+1|0;if((I|0)==(k|0))break;else{E=E+(G<<2)|0;D=D+(B<<2)|0}}}break}default:{}}MM(F,k,f[H>>2]|0)}Q=c+(f[H>>2]|0)|0;P=54}while(0);if((P|0)==54)if(y){N=f[q>>2]|0;O=Q;P=56}else X=Q;if((P|0)==56){P=f[a+16>>2]|0;fi[f[f[P>>2]>>2]&255](P,N,t);X=O}O=f[a+16>>2]|0;fi[f[f[O>>2]>>2]&255](O,f[m>>2]|0,s);c:do if((i|0)==1)if(!(b[A>>0]|0)){O=a+36|0;N=f[O>>2]|0;K1a(s+N|0,s|0,N|0)|0;N=f[O>>2]|0;P=s+N|0;Q=N>>>2;c=g>>>2;switch(N|0){case 4:{if((k|0)>0){N=e;o=0;fa=P;while(1){f[N>>2]=f[fa>>2];o=o+1|0;if((o|0)==(k|0))break;else{N=N+(c<<2)|0;fa=fa+(Q<<2)|0}}}break}case 8:{if((k|0)>0){fa=e;N=0;o=P;while(1){H=f[o+4>>2]|0;f[fa>>2]=f[o>>2];f[fa+4>>2]=H;N=N+1|0;if((N|0)==(k|0))break;else{fa=fa+(c<<2)|0;o=o+(Q<<2)|0}}}break}case 16:{if((k|0)>0){o=e;fa=0;N=P;while(1){H=f[N+4>>2]|0;f[o>>2]=f[N>>2];f[o+4>>2]=H;H=f[N+12>>2]|0;f[o+8>>2]=f[N+8>>2];f[o+12>>2]=H;fa=fa+1|0;if((fa|0)==(k|0))break;else{o=o+(c<<2)|0;N=N+(Q<<2)|0}}}break}default:{}}if(!y){ga=O;break}Q=f[O>>2]|0;K1a(t+Q|0,t|0,Q|0)|0;Q=f[O>>2]|0;N=t+Q|0;o=e+(Y(Q,l+-1|0)|0)|0;fa=Q>>>2;switch(Q|0){case 4:{if((k|0)>0){ha=o;ia=0;ja=N}else{ga=O;break c}while(1){f[ha>>2]=f[ja>>2];ia=ia+1|0;if((ia|0)==(k|0)){ga=O;break}else{ha=ha+(c<<2)|0;ja=ja+(fa<<2)|0}}break}case 8:{if((k|0)>0){ka=o;la=0;ma=N}else{ga=O;break c}while(1){Q=f[ma+4>>2]|0;f[ka>>2]=f[ma>>2];f[ka+4>>2]=Q;la=la+1|0;if((la|0)==(k|0)){ga=O;break}else{ka=ka+(c<<2)|0;ma=ma+(fa<<2)|0}}break}case 16:{if((k|0)>0){na=o;oa=0;pa=N}else{ga=O;break c}while(1){Q=f[pa+4>>2]|0;f[na>>2]=f[pa>>2];f[na+4>>2]=Q;Q=f[pa+12>>2]|0;f[na+8>>2]=f[pa+8>>2];f[na+12>>2]=Q;oa=oa+1|0;if((oa|0)==(k|0)){ga=O;break}else{na=na+(c<<2)|0;pa=pa+(fa<<2)|0}}break}default:{ga=O;break c}}}else{fa=a+40|0;c=a+36|0;N=(f[fa>>2]|0)>>>2;o=g>>>2;switch(f[c>>2]|0){case 4:{if((k|0)>0){Q=e;P=0;H=s;while(1){f[Q>>2]=f[H>>2];P=P+1|0;if((P|0)==(k|0))break;else{Q=Q+(o<<2)|0;H=H+(N<<2)|0}}}break}case 8:{if((k|0)>0){H=e;Q=0;P=s;while(1){O=f[P+4>>2]|0;f[H>>2]=f[P>>2];f[H+4>>2]=O;Q=Q+1|0;if((Q|0)==(k|0))break;else{H=H+(o<<2)|0;P=P+(N<<2)|0}}}break}case 16:{if((k|0)>0){P=e;H=0;Q=s;while(1){O=f[Q+4>>2]|0;f[P>>2]=f[Q>>2];f[P+4>>2]=O;O=f[Q+12>>2]|0;f[P+8>>2]=f[Q+8>>2];f[P+12>>2]=O;H=H+1|0;if((H|0)==(k|0))break;else{P=P+(o<<2)|0;Q=Q+(N<<2)|0}}}break}default:{}}if(!y){ga=c;break}N=f[c>>2]|0;Q=e+(Y(N,l+-1|0)|0)|0;P=(f[fa>>2]|0)>>>2;switch(N|0){case 4:{if((k|0)>0){qa=Q;ra=0;sa=t}else{ga=c;break c}while(1){f[qa>>2]=f[sa>>2];ra=ra+1|0;if((ra|0)==(k|0)){ga=c;break}else{qa=qa+(o<<2)|0;sa=sa+(P<<2)|0}}break}case 8:{if((k|0)>0){ta=Q;ua=0;va=t}else{ga=c;break c}while(1){fa=f[va+4>>2]|0;f[ta>>2]=f[va>>2];f[ta+4>>2]=fa;ua=ua+1|0;if((ua|0)==(k|0)){ga=c;break}else{ta=ta+(o<<2)|0;va=va+(P<<2)|0}}break}case 16:{if((k|0)>0){wa=Q;xa=0;ya=t}else{ga=c;break c}while(1){fa=f[ya+4>>2]|0;f[wa>>2]=f[ya>>2];f[wa+4>>2]=fa;fa=f[ya+12>>2]|0;f[wa+8>>2]=f[ya+8>>2];f[wa+12>>2]=fa;xa=xa+1|0;if((xa|0)==(k|0)){ga=c;break}else{wa=wa+(o<<2)|0;ya=ya+(P<<2)|0}}break}default:{ga=c;break c}}}else{P=a+40|0;o=f[P>>2]|0;Q=o>>>2;fa=g>>>2;switch(o|0){case 4:{if((k|0)>0){o=e;N=0;H=s;while(1){f[o>>2]=f[H>>2];N=N+1|0;if((N|0)==(k|0))break;else{o=o+(fa<<2)|0;H=H+(Q<<2)|0}}}break}case 8:{if((k|0)>0){H=e;o=0;N=s;while(1){c=f[N+4>>2]|0;f[H>>2]=f[N>>2];f[H+4>>2]=c;o=o+1|0;if((o|0)==(k|0))break;else{H=H+(fa<<2)|0;N=N+(Q<<2)|0}}}break}case 16:{if((k|0)>0){N=e;H=0;o=s;while(1){c=f[o+4>>2]|0;f[N>>2]=f[o>>2];f[N+4>>2]=c;c=f[o+12>>2]|0;f[N+8>>2]=f[o+8>>2];f[N+12>>2]=c;H=H+1|0;if((H|0)==(k|0))break;else{N=N+(fa<<2)|0;o=o+(Q<<2)|0}}}break}default:{}}if(y){Q=f[P>>2]|0;o=e+(Y(Q,z)|0)|0;N=Q>>>2;switch(Q|0){case 4:{if((k|0)>0){za=o;Aa=0;Ba=t}else{ga=P;break c}while(1){f[za>>2]=f[Ba>>2];Aa=Aa+1|0;if((Aa|0)==(k|0)){ga=P;break}else{za=za+(fa<<2)|0;Ba=Ba+(N<<2)|0}}break}case 8:{if((k|0)>0){Ca=o;Da=0;Ea=t}else{ga=P;break c}while(1){Q=f[Ea+4>>2]|0;f[Ca>>2]=f[Ea>>2];f[Ca+4>>2]=Q;Da=Da+1|0;if((Da|0)==(k|0)){ga=P;break}else{Ca=Ca+(fa<<2)|0;Ea=Ea+(N<<2)|0}}break}case 16:{if((k|0)>0){Fa=o;Ga=0;Ha=t}else{ga=P;break c}while(1){Q=f[Ha+4>>2]|0;f[Fa>>2]=f[Ha>>2];f[Fa+4>>2]=Q;Q=f[Ha+12>>2]|0;f[Fa+8>>2]=f[Ha+8>>2];f[Fa+12>>2]=Q;Ga=Ga+1|0;if((Ga|0)==(k|0)){ga=P;break}else{Fa=Fa+(fa<<2)|0;Ha=Ha+(N<<2)|0}}break}default:{ga=P;break c}}}else ga=P}while(0);u=1;v=z;w=e+(f[ga>>2]|0)|0;x=X}if((u|0)<(v|0)){X=a+40|0;ga=d>>>2;d=a+16|0;z=(k|0)>0;Ha=k<<1;Fa=k<<2;Ga=g>>>2;Ea=w;w=u;u=x;while(1){x=(w+1|0)<(v|0);Ca=f[m>>2]|0;d:do if(x){Da=f[q>>2]|0;switch(f[X>>2]|0){case 4:{if(z){Ba=0;za=u;while(1){Aa=f[za+4>>2]|0;f[Ca+(Ba<<2)>>2]=f[za>>2];f[Da+(Ba<<2)>>2]=Aa;Ba=Ba+1|0;if((Ba|0)==(k|0))break;else za=za+(ga<<2)|0}}break}case 8:{if(z){za=0;Ba=u;while(1){Aa=f[Ba+4>>2]|0;f[Ca+(za<<2)>>2]=f[Ba>>2];y=za|1;f[Ca+(y<<2)>>2]=Aa;Aa=f[Ba+12>>2]|0;f[Da+(za<<2)>>2]=f[Ba+8>>2];f[Da+(y<<2)>>2]=Aa;za=za+2|0;if((za|0)>=(Ha|0))break;else Ba=Ba+(ga<<2)|0}}break}case 16:{if(z){Ba=0;za=u;while(1){Aa=f[za+4>>2]|0;f[Ca+(Ba<<2)>>2]=f[za>>2];y=Ba|1;f[Ca+(y<<2)>>2]=Aa;Aa=f[za+12>>2]|0;ya=Ba|2;f[Ca+(ya<<2)>>2]=f[za+8>>2];wa=Ba|3;f[Ca+(wa<<2)>>2]=Aa;Aa=f[za+20>>2]|0;f[Da+(Ba<<2)>>2]=f[za+16>>2];f[Da+(y<<2)>>2]=Aa;Aa=f[za+28>>2]|0;f[Da+(ya<<2)>>2]=f[za+24>>2];f[Da+(wa<<2)>>2]=Aa;Ba=Ba+4|0;if((Ba|0)>=(Fa|0))break;else za=za+(ga<<2)|0}}break}default:{}}za=f[d>>2]|0;fi[f[f[za>>2]>>2]&255](za,Da,t);Ia=f[m>>2]|0}else{za=f[X>>2]|0;Ba=za>>>2;switch(za|0){case 4:{if(z){Ja=Ca;Ka=0;La=u}else{Ia=Ca;break d}while(1){f[Ja>>2]=f[La>>2];Ka=Ka+1|0;if((Ka|0)==(k|0)){Ia=Ca;break}else{Ja=Ja+(Ba<<2)|0;La=La+(ga<<2)|0}}break}case 8:{if(z){Ma=Ca;Na=0;Oa=u}else{Ia=Ca;break d}while(1){Da=f[Oa+4>>2]|0;f[Ma>>2]=f[Oa>>2];f[Ma+4>>2]=Da;Na=Na+1|0;if((Na|0)==(k|0)){Ia=Ca;break}else{Ma=Ma+(Ba<<2)|0;Oa=Oa+(ga<<2)|0}}break}case 16:{if(z){Pa=Ca;Qa=0;Ra=u}else{Ia=Ca;break d}while(1){Da=f[Ra+4>>2]|0;f[Pa>>2]=f[Ra>>2];f[Pa+4>>2]=Da;Da=f[Ra+12>>2]|0;f[Pa+8>>2]=f[Ra+8>>2];f[Pa+12>>2]=Da;Qa=Qa+1|0;if((Qa|0)==(k|0)){Ia=Ca;break}else{Pa=Pa+(Ba<<2)|0;Ra=Ra+(ga<<2)|0}}break}default:{Ia=Ca;break d}}}while(0);Ca=f[d>>2]|0;fi[f[f[Ca>>2]>>2]&255](Ca,Ia,s);Ca=f[X>>2]|0;e:do if(x)switch(Ca|0){case 4:{if(z){Sa=Ea;Ta=0}else break e;while(1){P=f[t+(Ta<<2)>>2]|0;f[Sa>>2]=f[s+(Ta<<2)>>2];f[Sa+4>>2]=P;Ta=Ta+1|0;if((Ta|0)==(k|0))break;else Sa=Sa+(Ga<<2)|0}break}case 8:{if(z){Ua=Ea;Va=0}else break e;while(1){P=Va|1;Ba=f[s+(P<<2)>>2]|0;f[Ua>>2]=f[s+(Va<<2)>>2];f[Ua+4>>2]=Ba;Ba=f[t+(P<<2)>>2]|0;f[Ua+8>>2]=f[t+(Va<<2)>>2];f[Ua+12>>2]=Ba;Va=Va+2|0;if((Va|0)>=(Ha|0))break;else Ua=Ua+(Ga<<2)|0}break}case 16:{if(z){Wa=Ea;Xa=0}else break e;while(1){Ba=Xa|1;P=f[s+(Ba<<2)>>2]|0;f[Wa>>2]=f[s+(Xa<<2)>>2];f[Wa+4>>2]=P;P=Xa|2;Da=Xa|3;za=f[s+(Da<<2)>>2]|0;f[Wa+8>>2]=f[s+(P<<2)>>2];f[Wa+12>>2]=za;za=f[t+(Ba<<2)>>2]|0;f[Wa+16>>2]=f[t+(Xa<<2)>>2];f[Wa+20>>2]=za;za=f[t+(Da<<2)>>2]|0;f[Wa+24>>2]=f[t+(P<<2)>>2];f[Wa+28>>2]=za;Xa=Xa+4|0;if((Xa|0)>=(Fa|0))break;else Wa=Wa+(Ga<<2)|0}break}default:break e}else{za=Ca>>>2;switch(Ca|0){case 4:{if(z){Ya=Ea;Za=0;_a=s}else break e;while(1){f[Ya>>2]=f[_a>>2];Za=Za+1|0;if((Za|0)==(k|0))break;else{Ya=Ya+(Ga<<2)|0;_a=_a+(za<<2)|0}}break}case 8:{if(z){$a=Ea;ab=0;bb=s}else break e;while(1){P=f[bb+4>>2]|0;f[$a>>2]=f[bb>>2];f[$a+4>>2]=P;ab=ab+1|0;if((ab|0)==(k|0))break;else{$a=$a+(Ga<<2)|0;bb=bb+(za<<2)|0}}break}case 16:{if(z){cb=Ea;db=0;eb=s}else break e;while(1){P=f[eb+4>>2]|0;f[cb>>2]=f[eb>>2];f[cb+4>>2]=P;P=f[eb+12>>2]|0;f[cb+8>>2]=f[eb+8>>2];f[cb+12>>2]=P;db=db+1|0;if((db|0)==(k|0))break;else{cb=cb+(Ga<<2)|0;eb=eb+(za<<2)|0}}break}default:break e}}while(0);Ca=f[X>>2]<<1;w=w+2|0;if((w|0)>=(v|0))break;else{Ea=Ea+Ca|0;u=u+Ca|0}}}if(!j)return;if((f[a+32>>2]|0)!=2)return;if((f[a+44>>2]|0)==5){a=g>>>2;if((k|0)<=0)return;j=(l+1|0)/2|0;if((l|0)>2)fb=0;else return;do{u=e+((Y(fb,a)|0)<<2)|0;Ea=e+((Y(k-fb|0,a)|0)<<2)|0;v=(fb|0)==0|(fb<<1|0)==(k|0)?u:Ea;Ea=1;do{w=Ea<<1;X=l-Ea<<1;f[u+(X<<2)>>2]=f[v+(w<<2)>>2];n[u+((X|1)<<2)>>2]=-+n[v+((w|1)<<2)>>2];Ea=Ea+1|0}while((Ea|0)<(j|0));fb=fb+1|0}while((fb|0)!=(k|0));return}else{fb=g>>>3;if((k|0)<=0)return;g=(l+1|0)/2|0;if((l|0)>2)gb=0;else return;do{j=e+((Y(gb,fb)|0)<<3)|0;a=e+((Y(k-gb|0,fb)|0)<<3)|0;Ea=(gb|0)==0|(gb<<1|0)==(k|0)?j:a;a=1;do{v=a<<1;u=l-a<<1;p[j+(u<<3)>>3]=+p[Ea+(v<<3)>>3];p[j+((u|1)<<3)>>3]=-+p[Ea+((v|1)<<3)>>3];a=a+1|0}while((a|0)<(g|0));gb=gb+1|0}while((gb|0)!=(k|0));return}}function MM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;if((c|0)==4){c=b+1|0;d=(c|0)/2|0;if((b|0)>2){e=1;do{g=e<<1;h=b-e<<1;f[a+(h<<2)>>2]=f[a+(g+-1<<2)>>2];n[a+((h|1)<<2)>>2]=-+n[a+(g<<2)>>2];e=e+1|0}while((e|0)<(d|0))}d=b+-1|0;if(!(b&1)){f[a+(b<<2)>>2]=f[a+(d<<2)>>2];n[a+(c<<2)>>2]=0.0;i=d}else i=b;if((i|0)>1){d=i;do{i=d;d=d+-1|0;f[a+(i<<2)>>2]=f[a+(d<<2)>>2]}while((d|0)>1)}n[a+4>>2]=0.0;return}else{d=b+1|0;i=(d|0)/2|0;if((b|0)>2){c=1;do{e=c<<1;g=b-c<<1;p[a+(g<<3)>>3]=+p[a+(e+-1<<3)>>3];p[a+((g|1)<<3)>>3]=-+p[a+(e<<3)>>3];c=c+1|0}while((c|0)<(i|0))}i=b+-1|0;if(!(b&1)){p[a+(b<<3)>>3]=+p[a+(i<<3)>>3];p[a+(d<<3)>>3]=0.0;j=i}else j=b;if((j|0)>1){b=j;do{j=b;b=b+-1|0;p[a+(j<<3)>>3]=+p[a+(b<<3)>>3]}while((b|0)>1)}p[a+8>>3]=0.0;return}}function NM(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return}function OM(a){a=a|0;PYa(a);return}function PM(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=u;u=u+208|0;h=g+200|0;i=g+144|0;j=g+88|0;k=g+32|0;l=g+24|0;m=g+16|0;n=g;o=g+8|0;_$(h,32176);do if((NS(a)|0)==65536){p=f[a+4>>2]|0;f[i>>2]=f[p>>2];q=i+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=i+8|0;f[s>>2]=f[p+8>>2];t=i+12|0;f[t>>2]=f[p+12>>2];v=i+16|0;f[v>>2]=f[p+16>>2];w=i+20|0;f[w>>2]=f[p+20>>2];x=i+24|0;f[x>>2]=f[p+24>>2];y=i+28|0;f[y>>2]=f[p+28>>2];z=i+32|0;f[z>>2]=f[p+32>>2];A=i+36|0;B=f[p+36>>2]|0;f[A>>2]=B;f[i+40>>2]=s;C=i+48|0;D=i+44|0;f[D>>2]=C;f[C>>2]=0;f[i+52>>2]=0;if(B|0){C=B+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;C=f[D>>2]|0;f[C>>2]=f[r>>2];f[C+4>>2]=f[r+4>>2];E=w;F=x;G=y;H=z;I=A;J=v;K=t;L=v;M=q;N=i;O=s;P=A;break}else{f[q>>2]=0;BR(i,p);E=w;F=x;G=y;H=z;I=A;J=v;K=t;L=v;M=q;N=i;O=s;P=A;break}}else{OR(i,a,-1);A=i+16|0;s=i+36|0;E=i+20|0;F=i+24|0;G=i+28|0;H=i+32|0;I=s;J=A;K=i+12|0;L=A;M=i+4|0;N=i;O=i+8|0;P=s}while(0);f[j>>2]=f[N>>2];N=j+4|0;a=f[M>>2]|0;f[N>>2]=a;s=j+8|0;f[s>>2]=f[O>>2];O=j+12|0;f[O>>2]=f[K>>2];K=j+16|0;f[K>>2]=f[J>>2];f[j+20>>2]=f[E>>2];f[j+24>>2]=f[F>>2];f[j+28>>2]=f[G>>2];f[j+32>>2]=f[H>>2];H=j+36|0;G=f[I>>2]|0;f[H>>2]=G;I=j+40|0;f[I>>2]=s;F=j+48|0;E=j+44|0;f[E>>2]=F;f[F>>2]=0;f[j+52>>2]=0;if(!G)Q=a;else{a=G+12|0;f[a>>2]=(f[a>>2]|0)+1;Q=f[M>>2]|0}if((Q|0)<3){Q=f[i+44>>2]|0;a=f[E>>2]|0;f[a>>2]=f[Q>>2];f[a+4>>2]=f[Q+4>>2]}else{f[N>>2]=0;BR(j,i)}Q=(d&1|0)==0;a=f[j>>2]|0;G=a&4095;J=a&7;switch(a&4095){case 5:case 6:case 13:case 14:break;default:{f[k>>2]=0;f[k+4>>2]=0;K1a(c$(k,208)|0,163010,208)|0;j$(-215,k,163219,162327,3343);d$(k)}}if(d&64|0?(f[j>>2]&4088|0)!=8:0){f[k>>2]=0;f[k+4>>2]=0;a=c$(k,53)|0;A=163223;q=a+53|0;do{b[a>>0]=b[A>>0]|0;a=a+1|0;A=A+1|0}while((a|0)<(q|0));j$(-215,k,163219,162327,3346);d$(k)}A=(f[j>>2]|0)>>>3&511;if(Q)if((d&16|0)==0|(A|0)!=0)R=23;else{Q=f[I>>2]|0;a=f[Q>>2]|0;f[l>>2]=f[Q+4>>2];f[l+4>>2]=a;KS(c,l,J|8,-1,0,0)}else if((d&32|0)==0|(A|0)!=1)R=23;else{A=f[I>>2]|0;l=f[A>>2]|0;f[m>>2]=f[A+4>>2];f[m+4>>2]=l;KS(c,m,J,-1,0,0)}if((R|0)==23){R=f[I>>2]|0;m=f[R>>2]|0;f[n>>2]=f[R+4>>2];f[n+4>>2]=m;KS(c,n,G,-1,0,0)}do if((NS(c)|0)==65536){G=f[c+4>>2]|0;f[k>>2]=f[G>>2];n=k+4|0;m=G+4|0;f[n>>2]=f[m>>2];R=k+8|0;f[R>>2]=f[G+8>>2];f[k+12>>2]=f[G+12>>2];f[k+16>>2]=f[G+16>>2];f[k+20>>2]=f[G+20>>2];f[k+24>>2]=f[G+24>>2];f[k+28>>2]=f[G+28>>2];f[k+32>>2]=f[G+32>>2];l=f[G+36>>2]|0;f[k+36>>2]=l;f[k+40>>2]=R;R=k+48|0;A=k+44|0;f[A>>2]=R;f[R>>2]=0;f[k+52>>2]=0;if(l|0){R=l+12|0;f[R>>2]=(f[R>>2]|0)+1}if((f[m>>2]|0)<3){m=f[G+44>>2]|0;R=f[A>>2]|0;f[R>>2]=f[m>>2];f[R+4>>2]=f[m+4>>2];break}else{f[n>>2]=0;BR(k,G);break}}else OR(k,c,-1);while(0);c=f[j>>2]|0;G=f[k>>2]|0;n=d&7|((c&16384|0)==0?0:G>>>5&512);d=k+16|0;BM(o,f[O>>2]|0,f[s>>2]|0,J,(c>>>3&511)+1|0,(G>>>3&511)+1|0,(f[K>>2]|0)==(f[d>>2]|0)?n|1024:n,e);e=f[o+4>>2]|0;n=k+48|0;Bh[f[f[e>>2]>>2]&255](e,f[K>>2]|0,f[F>>2]|0,f[d>>2]|0,f[n>>2]|0);e=f[o>>2]|0;if(e|0?(o=e+4|0,G=f[o>>2]|0,f[o>>2]=G+-1,(G|0)==1):0)ki[f[(f[e>>2]|0)+8>>2]&2047](e);e=k+36|0;G=f[e>>2]|0;if(G|0?(o=G+12|0,G=f[o>>2]|0,f[o>>2]=G+-1,(G|0)==1):0)CR(k);f[e>>2]=0;e=k+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[e>>2]|0)>0){d=f[k+40>>2]|0;G=0;do{f[d+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[e>>2]|0))}e=f[k+44>>2]|0;if((e|0)!=(n|0))ZF(e);e=f[H>>2]|0;if(e|0?(n=e+12|0,e=f[n>>2]|0,f[n>>2]=e+-1,(e|0)==1):0)CR(j);f[H>>2]=0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[N>>2]|0)>0){K=f[I>>2]|0;I=0;do{f[K+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[N>>2]|0))}N=f[E>>2]|0;if((N|0)!=(F|0))ZF(N);N=f[P>>2]|0;if(N|0?(F=N+12|0,N=f[F>>2]|0,f[F>>2]=N+-1,(N|0)==1):0)CR(i);f[P>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[M>>2]|0)>0){L=f[i+40>>2]|0;P=0;do{f[L+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[M>>2]|0))}M=f[i+44>>2]|0;if((M|0)!=(i+48|0))ZF(M);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function QM(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;h=u;u=u+256|0;i=h+232|0;j=h+224|0;k=h+168|0;l=h+112|0;m=h+56|0;o=h;_$(j,32196);do if((NS(a)|0)==65536){q=f[a+4>>2]|0;f[k>>2]=f[q>>2];r=k+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=k+8|0;f[t>>2]=f[q+8>>2];f[k+12>>2]=f[q+12>>2];f[k+16>>2]=f[q+16>>2];f[k+20>>2]=f[q+20>>2];f[k+24>>2]=f[q+24>>2];f[k+28>>2]=f[q+28>>2];f[k+32>>2]=f[q+32>>2];v=f[q+36>>2]|0;f[k+36>>2]=v;f[k+40>>2]=t;t=k+48|0;w=k+44|0;f[w>>2]=t;f[t>>2]=0;f[k+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[r>>2]=0;BR(k,q);break}}else OR(k,a,-1);while(0);do if((NS(c)|0)==65536){a=f[c+4>>2]|0;f[l>>2]=f[a>>2];q=l+4|0;r=a+4|0;f[q>>2]=f[r>>2];s=l+8|0;f[s>>2]=f[a+8>>2];f[l+12>>2]=f[a+12>>2];f[l+16>>2]=f[a+16>>2];f[l+20>>2]=f[a+20>>2];f[l+24>>2]=f[a+24>>2];f[l+28>>2]=f[a+28>>2];f[l+32>>2]=f[a+32>>2];t=f[a+36>>2]|0;f[l+36>>2]=t;f[l+40>>2]=s;s=l+48|0;w=l+44|0;f[w>>2]=s;f[s>>2]=0;f[l+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[a+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];x=l;break}else{f[q>>2]=0;BR(l,a);x=l;break}}else{OR(l,c,-1);x=l}while(0);c=f[k>>2]|0;a=c&7;q=c>>>3&511;r=q+1|0;s=c&4095;w=k+8|0;t=f[w>>2]|0;v=k+12|0;y=f[v>>2]|0;if(!((s|0)==(f[x>>2]&4095|0)?(z=f[k+40>>2]|0,A=f[l+40>>2]|0,(f[z>>2]|0)==(f[A>>2]|0)?(f[z+4>>2]|0)==(f[A+4>>2]|0):0):0)){f[i>>2]=0;f[i+4>>2]=0;B=c$(i,49)|0;A=163325;C=B+49|0;do{b[B>>0]=b[A>>0]|0;B=B+1|0;A=A+1|0}while((B|0)<(C|0));j$(-215,i,163375,162327,3549);d$(i)}switch(c&4095){case 5:case 6:case 13:case 14:break;default:{f[i>>2]=0;f[i+4>>2]=0;K1a(c$(i,208)|0,163010,208)|0;j$(-215,i,163375,162327,3550);d$(i)}}pS(d,f[w>>2]|0,f[v>>2]|0,s,-1,0,0);do if((NS(d)|0)==65536){s=f[d+4>>2]|0;f[m>>2]=f[s>>2];v=m+4|0;w=s+4|0;f[v>>2]=f[w>>2];c=m+8|0;f[c>>2]=f[s+8>>2];f[m+12>>2]=f[s+12>>2];A=m+16|0;f[A>>2]=f[s+16>>2];f[m+20>>2]=f[s+20>>2];f[m+24>>2]=f[s+24>>2];f[m+28>>2]=f[s+28>>2];f[m+32>>2]=f[s+32>>2];z=f[s+36>>2]|0;f[m+36>>2]=z;f[m+40>>2]=c;c=m+48|0;D=m+44|0;f[D>>2]=c;f[c>>2]=0;f[m+52>>2]=0;if(z|0){c=z+12|0;f[c>>2]=(f[c>>2]|0)+1}if((f[w>>2]|0)<3){w=f[s+44>>2]|0;c=f[D>>2]|0;f[c>>2]=f[w>>2];f[c+4>>2]=f[w+4>>2];E=A;break}else{f[v>>2]=0;BR(m,s);E=A;break}}else{OR(m,d,-1);E=m+16|0}while(0);d=l+16|0;if((f[E>>2]|0)==(f[d>>2]|0)){f[o>>2]=1124007936;A=o+4|0;s=o+8|0;v=o+40|0;B=A;C=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(C|0));f[v>>2]=s;B=o+48|0;C=o+44|0;f[C>>2]=B;f[B>>2]=0;f[o+52>>2]=0;w=i+8|0;f[w>>2]=0;f[w+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;eL(l,i);i=o+36|0;w=f[i>>2]|0;if(w|0){c=w+12|0;f[c>>2]=(f[c>>2]|0)+1}c=l+36|0;w=f[c>>2]|0;if(w|0?(D=w+12|0,w=f[D>>2]|0,f[D>>2]=w+-1,(w|0)==1):0)CR(l);f[c>>2]=0;w=l+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[w>>2]|0)>0){D=f[l+40>>2]|0;z=0;do{f[D+(z<<2)>>2]=0;z=z+1|0;F=f[w>>2]|0}while((z|0)<(F|0));f[x>>2]=f[o>>2];if((F|0)<3)G=38;else G=40}else{f[x>>2]=f[o>>2];G=38}if((G|0)==38){F=f[A>>2]|0;if((F|0)<3){f[w>>2]=F;f[l+8>>2]=f[s>>2];f[l+12>>2]=f[o+12>>2];s=f[C>>2]|0;F=f[l+44>>2]|0;f[F>>2]=f[s>>2];f[F+4>>2]=f[s+4>>2]}else G=40}if((G|0)==40)BR(l,o);s=o+16|0;f[d>>2]=f[s>>2];f[l+20>>2]=f[o+20>>2];f[l+24>>2]=f[o+24>>2];f[l+28>>2]=f[o+28>>2];f[l+32>>2]=f[o+32>>2];F=f[i>>2]|0;f[c>>2]=F;if(F|0?(c=F+12|0,F=f[c>>2]|0,f[c>>2]=F+-1,(F|0)==1):0)CR(o);f[i>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[A>>2]|0)>0){s=f[v>>2]|0;v=0;do{f[s+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[A>>2]|0))}A=f[C>>2]|0;if((A|0)!=(B|0))ZF(A)}A=(e&4|0)!=0;if(!(A|(t|0)==1))if(((y|0)==1?(f[k>>2]&16384|0)!=0:0)?(f[x>>2]&16384|0)!=0:0)H=(f[m>>2]&16384|0)!=0;else H=0;else H=1;x=A|H^1;A=y+(x?0:t+-1|0)|0;y=x?t:1;t=(q|0)==0;x=t&1;e=A&1;B=(e|0)==0;C=(Y(A,r)|0)-((e|q|0)==0&1)|0;q=k+16|0;e=f[q>>2]|0;a:do if((a|0)==5){r=f[d>>2]|0;v=f[E>>2]|0;s=f[k+48>>2]|0;i=f[l+48>>2]|0;o=f[m+48>>2]|0;F=(e|0)==(v|0);c=H|t^1;if(g)if(F){do if(!c){n[e>>2]=+n[e>>2]*+n[r>>2];w=y+-2|0;z=(w|0)==0;if(!z){D=1;do{I=e+(Y(D,o)|0)|0;J=+n[I>>2];K=D+1|0;L=e+(Y(K,o)|0)|0;M=+n[L>>2];N=r+(Y(D,i)|0)|0;O=+n[N>>2];N=r+(Y(K,i)|0)|0;P=-+n[N>>2];n[I>>2]=J*O-M*P;n[L>>2]=M*O+J*P;D=D+2|0}while(D>>>0<=w>>>0);if(!(y&1)){Q=y+-1|0;G=117}}else{Q=1;G=117}if((G|0)==117){D=e+(Y(Q,o)|0)|0;L=r+(Y(Q,i)|0)|0;n[D>>2]=+n[D>>2]*+n[L>>2]}if(B){L=r+(A<<2)+-4|0;D=e+(A<<2)+-4|0;n[D>>2]=+n[D>>2]*+n[L>>2];if(!z){I=1;do{N=D+(Y(I,o)|0)|0;P=+n[N>>2];K=I+1|0;R=D+(Y(K,o)|0)|0;J=+n[R>>2];S=L+(Y(I,i)|0)|0;O=+n[S>>2];S=L+(Y(K,i)|0)|0;M=-+n[S>>2];n[N>>2]=P*O-J*M;n[R>>2]=J*O+P*M;I=I+2|0}while(I>>>0<=w>>>0);if(!(y&1))T=y+-1|0;else break}else T=1;w=D+(Y(T,o)|0)|0;I=L+(Y(T,i)|0)|0;n[w>>2]=+n[w>>2]*+n[I>>2]}}while(0);I=t&H;w=y+-1|0;if(!y)break;z=x>>>0<C>>>0;R=I&B;if(!I){if(z){U=e;V=r;W=w}else break;while(1){I=x;do{N=U+(I<<2)|0;M=+n[N>>2];S=I+1|0;K=U+(S<<2)|0;P=+n[K>>2];O=+n[V+(I<<2)>>2];J=-+n[V+(S<<2)>>2];n[N>>2]=M*O-P*J;n[K>>2]=P*O+M*J;I=I+2|0}while(I>>>0<C>>>0);if(!W)break a;else{U=U+o|0;V=V+i|0;W=W+-1|0}}}if(!z)if(R){I=e;L=r;D=e;K=w;while(1){n[D>>2]=+n[I>>2]*+n[L>>2];n[D+(C<<2)>>2]=+n[I+(C<<2)>>2]*+n[L+(C<<2)>>2];if(!K)break a;else{I=I+s|0;L=L+i|0;D=D+o|0;K=K+-1|0}}}else{K=e;D=r;L=e;I=w;while(1){n[L>>2]=+n[K>>2]*+n[D>>2];if(!I)break a;else{K=K+s|0;D=D+i|0;L=L+o|0;I=I+-1|0}}}if(R){I=e;L=r;D=e;K=w;while(1){n[D>>2]=+n[I>>2]*+n[L>>2];z=x;do{N=D+(z<<2)|0;J=+n[N>>2];S=z+1|0;X=D+(S<<2)|0;M=+n[X>>2];O=+n[L+(z<<2)>>2];P=-+n[L+(S<<2)>>2];n[N>>2]=J*O-M*P;n[X>>2]=M*O+J*P;z=z+2|0}while(z>>>0<C>>>0);n[D+(C<<2)>>2]=+n[I+(C<<2)>>2]*+n[L+(C<<2)>>2];if(!K)break;else{I=I+s|0;L=L+i|0;D=D+o|0;K=K+-1|0}}}else{K=e;D=r;L=e;I=w;while(1){n[L>>2]=+n[K>>2]*+n[D>>2];R=x;do{z=L+(R<<2)|0;P=+n[z>>2];X=R+1|0;N=L+(X<<2)|0;J=+n[N>>2];O=+n[D+(R<<2)>>2];M=-+n[D+(X<<2)>>2];n[z>>2]=P*O-J*M;n[N>>2]=J*O+P*M;R=R+2|0}while(R>>>0<C>>>0);if(!I)break;else{K=K+s|0;D=D+i|0;L=L+o|0;I=I+-1|0}}}}else{do if(!c){n[v>>2]=+n[e>>2]*+n[r>>2];I=y+-2|0;L=(I|0)==0;if(!L){D=1;do{K=e+(Y(D,s)|0)|0;M=+n[K>>2];K=D+1|0;w=e+(Y(K,s)|0)|0;P=+n[w>>2];w=r+(Y(D,i)|0)|0;O=+n[w>>2];w=r+(Y(K,i)|0)|0;J=-+n[w>>2];w=v+(Y(D,o)|0)|0;n[w>>2]=M*O-P*J;w=v+(Y(K,o)|0)|0;n[w>>2]=P*O+M*J;D=D+2|0}while(D>>>0<=I>>>0);if(!(y&1)){Z=y+-1|0;G=144}}else{Z=1;G=144}if((G|0)==144){D=v+(Y(Z,o)|0)|0;w=r+(Y(Z,i)|0)|0;K=e+(Y(Z,s)|0)|0;n[D>>2]=+n[K>>2]*+n[w>>2]}if(B){w=e+(A<<2)+-4|0;K=r+(A<<2)+-4|0;D=v+(A<<2)+-4|0;n[D>>2]=+n[w>>2]*+n[K>>2];if(!L){R=1;do{N=w+(Y(R,s)|0)|0;J=+n[N>>2];N=R+1|0;z=w+(Y(N,s)|0)|0;M=+n[z>>2];z=K+(Y(R,i)|0)|0;O=+n[z>>2];z=K+(Y(N,i)|0)|0;P=-+n[z>>2];z=D+(Y(R,o)|0)|0;n[z>>2]=J*O-M*P;z=D+(Y(N,o)|0)|0;n[z>>2]=M*O+J*P;R=R+2|0}while(R>>>0<=I>>>0);if(!(y&1))_=y+-1|0;else break}else _=1;I=D+(Y(_,o)|0)|0;R=K+(Y(_,i)|0)|0;L=w+(Y(_,s)|0)|0;n[I>>2]=+n[L>>2]*+n[R>>2]}}while(0);R=t&H;L=y+-1|0;if(!y)break;I=x>>>0<C>>>0;z=R&B;if(!R){if(I){$=e;aa=r;ba=v;ca=L}else break;while(1){R=x;do{P=+n[$+(R<<2)>>2];N=R+1|0;J=+n[$+(N<<2)>>2];O=+n[aa+(R<<2)>>2];M=-+n[aa+(N<<2)>>2];n[ba+(R<<2)>>2]=P*O-J*M;n[ba+(N<<2)>>2]=J*O+P*M;R=R+2|0}while(R>>>0<C>>>0);if(!ca)break a;else{$=$+s|0;aa=aa+i|0;ba=ba+o|0;ca=ca+-1|0}}}if(!I)if(z){R=e;w=r;K=v;D=L;while(1){n[K>>2]=+n[R>>2]*+n[w>>2];n[K+(C<<2)>>2]=+n[R+(C<<2)>>2]*+n[w+(C<<2)>>2];if(!D)break a;else{R=R+s|0;w=w+i|0;K=K+o|0;D=D+-1|0}}}else{D=e;K=r;w=v;R=L;while(1){n[w>>2]=+n[D>>2]*+n[K>>2];if(!R)break a;else{D=D+s|0;K=K+i|0;w=w+o|0;R=R+-1|0}}}if(z){R=e;w=r;K=v;D=L;while(1){n[K>>2]=+n[R>>2]*+n[w>>2];I=x;do{M=+n[R+(I<<2)>>2];N=I+1|0;P=+n[R+(N<<2)>>2];O=+n[w+(I<<2)>>2];J=-+n[w+(N<<2)>>2];n[K+(I<<2)>>2]=M*O-P*J;n[K+(N<<2)>>2]=P*O+M*J;I=I+2|0}while(I>>>0<C>>>0);n[K+(C<<2)>>2]=+n[R+(C<<2)>>2]*+n[w+(C<<2)>>2];if(!D)break;else{R=R+s|0;w=w+i|0;K=K+o|0;D=D+-1|0}}}else{D=e;K=r;w=v;R=L;while(1){n[w>>2]=+n[D>>2]*+n[K>>2];z=x;do{J=+n[D+(z<<2)>>2];I=z+1|0;M=+n[D+(I<<2)>>2];O=+n[K+(z<<2)>>2];P=-+n[K+(I<<2)>>2];n[w+(z<<2)>>2]=J*O-M*P;n[w+(I<<2)>>2]=M*O+J*P;z=z+2|0}while(z>>>0<C>>>0);if(!R)break;else{D=D+s|0;K=K+i|0;w=w+o|0;R=R+-1|0}}}}else if(F){do if(!c){n[e>>2]=+n[e>>2]*+n[r>>2];R=y+-2|0;w=(R|0)==0;if(!w){K=1;do{D=e+(Y(K,o)|0)|0;P=+n[D>>2];L=K+1|0;z=e+(Y(L,o)|0)|0;J=+n[z>>2];I=r+(Y(K,i)|0)|0;O=+n[I>>2];I=r+(Y(L,i)|0)|0;M=+n[I>>2];n[D>>2]=P*O-J*M;n[z>>2]=J*O+P*M;K=K+2|0}while(K>>>0<=R>>>0);if(!(y&1)){da=y+-1|0;G=62}}else{da=1;G=62}if((G|0)==62){K=e+(Y(da,o)|0)|0;z=r+(Y(da,i)|0)|0;n[K>>2]=+n[K>>2]*+n[z>>2]}if(B){z=r+(A<<2)+-4|0;K=e+(A<<2)+-4|0;n[K>>2]=+n[K>>2]*+n[z>>2];if(!w){D=1;do{I=K+(Y(D,o)|0)|0;M=+n[I>>2];L=D+1|0;N=K+(Y(L,o)|0)|0;P=+n[N>>2];X=z+(Y(D,i)|0)|0;O=+n[X>>2];X=z+(Y(L,i)|0)|0;J=+n[X>>2];n[I>>2]=M*O-P*J;n[N>>2]=P*O+M*J;D=D+2|0}while(D>>>0<=R>>>0);if(!(y&1))ea=y+-1|0;else break}else ea=1;R=K+(Y(ea,o)|0)|0;D=z+(Y(ea,i)|0)|0;n[R>>2]=+n[R>>2]*+n[D>>2]}}while(0);F=t&H;D=y+-1|0;if(!y)break;R=x>>>0<C>>>0;w=F&B;if(!F){if(R){fa=e;ga=r;ha=D}else break;while(1){F=x;do{N=fa+(F<<2)|0;J=+n[N>>2];I=F+1|0;X=fa+(I<<2)|0;M=+n[X>>2];O=+n[ga+(F<<2)>>2];P=+n[ga+(I<<2)>>2];n[N>>2]=J*O-M*P;n[X>>2]=M*O+J*P;F=F+2|0}while(F>>>0<C>>>0);if(!ha)break a;else{fa=fa+o|0;ga=ga+i|0;ha=ha+-1|0}}}if(!R)if(w){F=e;z=r;K=e;X=D;while(1){n[K>>2]=+n[F>>2]*+n[z>>2];n[K+(C<<2)>>2]=+n[F+(C<<2)>>2]*+n[z+(C<<2)>>2];if(!X)break a;else{F=F+s|0;z=z+i|0;K=K+o|0;X=X+-1|0}}}else{X=e;K=r;z=e;F=D;while(1){n[z>>2]=+n[X>>2]*+n[K>>2];if(!F)break a;else{X=X+s|0;K=K+i|0;z=z+o|0;F=F+-1|0}}}if(w){F=e;z=r;K=e;X=D;while(1){n[K>>2]=+n[F>>2]*+n[z>>2];R=x;do{N=K+(R<<2)|0;P=+n[N>>2];I=R+1|0;L=K+(I<<2)|0;J=+n[L>>2];O=+n[z+(R<<2)>>2];M=+n[z+(I<<2)>>2];n[N>>2]=P*O-J*M;n[L>>2]=J*O+P*M;R=R+2|0}while(R>>>0<C>>>0);n[K+(C<<2)>>2]=+n[F+(C<<2)>>2]*+n[z+(C<<2)>>2];if(!X)break;else{F=F+s|0;z=z+i|0;K=K+o|0;X=X+-1|0}}}else{X=e;K=r;z=e;F=D;while(1){n[z>>2]=+n[X>>2]*+n[K>>2];w=x;do{R=z+(w<<2)|0;M=+n[R>>2];L=w+1|0;N=z+(L<<2)|0;P=+n[N>>2];O=+n[K+(w<<2)>>2];J=+n[K+(L<<2)>>2];n[R>>2]=M*O-P*J;n[N>>2]=P*O+M*J;w=w+2|0}while(w>>>0<C>>>0);if(!F)break;else{X=X+s|0;K=K+i|0;z=z+o|0;F=F+-1|0}}}}else{do if(!c){n[v>>2]=+n[e>>2]*+n[r>>2];F=y+-2|0;z=(F|0)==0;if(!z){K=1;do{X=e+(Y(K,s)|0)|0;J=+n[X>>2];X=K+1|0;D=e+(Y(X,s)|0)|0;M=+n[D>>2];D=r+(Y(K,i)|0)|0;O=+n[D>>2];D=r+(Y(X,i)|0)|0;P=+n[D>>2];D=v+(Y(K,o)|0)|0;n[D>>2]=J*O-M*P;D=v+(Y(X,o)|0)|0;n[D>>2]=M*O+J*P;K=K+2|0}while(K>>>0<=F>>>0);if(!(y&1)){ia=y+-1|0;G=89}}else{ia=1;G=89}if((G|0)==89){K=v+(Y(ia,o)|0)|0;D=r+(Y(ia,i)|0)|0;X=e+(Y(ia,s)|0)|0;n[K>>2]=+n[X>>2]*+n[D>>2]}if(B){D=e+(A<<2)+-4|0;X=r+(A<<2)+-4|0;K=v+(A<<2)+-4|0;n[K>>2]=+n[D>>2]*+n[X>>2];if(!z){w=1;do{N=D+(Y(w,s)|0)|0;P=+n[N>>2];N=w+1|0;R=D+(Y(N,s)|0)|0;J=+n[R>>2];R=X+(Y(w,i)|0)|0;O=+n[R>>2];R=X+(Y(N,i)|0)|0;M=+n[R>>2];R=K+(Y(w,o)|0)|0;n[R>>2]=P*O-J*M;R=K+(Y(N,o)|0)|0;n[R>>2]=J*O+P*M;w=w+2|0}while(w>>>0<=F>>>0);if(!(y&1))ja=y+-1|0;else break}else ja=1;F=K+(Y(ja,o)|0)|0;w=X+(Y(ja,i)|0)|0;z=D+(Y(ja,s)|0)|0;n[F>>2]=+n[z>>2]*+n[w>>2]}}while(0);c=t&H;w=y+-1|0;if(!y)break;z=x>>>0<C>>>0;F=c&B;if(!c){if(z){ka=e;la=r;ma=v;na=w}else break;while(1){c=x;do{M=+n[ka+(c<<2)>>2];R=c+1|0;P=+n[ka+(R<<2)>>2];O=+n[la+(c<<2)>>2];J=+n[la+(R<<2)>>2];n[ma+(c<<2)>>2]=M*O-P*J;n[ma+(R<<2)>>2]=P*O+M*J;c=c+2|0}while(c>>>0<C>>>0);if(!na)break a;else{ka=ka+s|0;la=la+i|0;ma=ma+o|0;na=na+-1|0}}}if(!z)if(F){c=e;D=r;X=v;K=w;while(1){n[X>>2]=+n[c>>2]*+n[D>>2];n[X+(C<<2)>>2]=+n[c+(C<<2)>>2]*+n[D+(C<<2)>>2];if(!K)break a;else{c=c+s|0;D=D+i|0;X=X+o|0;K=K+-1|0}}}else{K=e;X=r;D=v;c=w;while(1){n[D>>2]=+n[K>>2]*+n[X>>2];if(!c)break a;else{K=K+s|0;X=X+i|0;D=D+o|0;c=c+-1|0}}}if(F){c=e;D=r;X=v;K=w;while(1){n[X>>2]=+n[c>>2]*+n[D>>2];z=x;do{J=+n[c+(z<<2)>>2];R=z+1|0;M=+n[c+(R<<2)>>2];O=+n[D+(z<<2)>>2];P=+n[D+(R<<2)>>2];n[X+(z<<2)>>2]=J*O-M*P;n[X+(R<<2)>>2]=M*O+J*P;z=z+2|0}while(z>>>0<C>>>0);n[X+(C<<2)>>2]=+n[c+(C<<2)>>2]*+n[D+(C<<2)>>2];if(!K)break;else{c=c+s|0;D=D+i|0;X=X+o|0;K=K+-1|0}}}else{K=e;X=r;D=v;c=w;while(1){n[D>>2]=+n[K>>2]*+n[X>>2];F=x;do{P=+n[K+(F<<2)>>2];z=F+1|0;J=+n[K+(z<<2)>>2];O=+n[X+(F<<2)>>2];M=+n[X+(z<<2)>>2];n[D+(F<<2)>>2]=P*O-J*M;n[D+(z<<2)>>2]=J*O+P*M;F=F+2|0}while(F>>>0<C>>>0);if(!c)break;else{K=K+s|0;X=X+i|0;D=D+o|0;c=c+-1|0}}}}}else{c=f[d>>2]|0;o=f[E>>2]|0;D=f[k+48>>2]|0;i=f[l+48>>2]|0;X=f[m+48>>2]|0;s=(e|0)==(o|0);K=H|t^1;if(g)if(s){do if(!K){p[e>>3]=+p[e>>3]*+p[c>>3];w=y+-2|0;v=(w|0)==0;if(!v){r=1;do{F=e+(Y(r,X)|0)|0;M=+p[F>>3];z=r+1|0;R=e+(Y(z,X)|0)|0;P=+p[R>>3];N=c+(Y(r,i)|0)|0;O=+p[N>>3];N=c+(Y(z,i)|0)|0;J=-+p[N>>3];p[F>>3]=M*O-P*J;p[R>>3]=P*O+M*J;r=r+2|0}while(r>>>0<=w>>>0);if(!(y&1)){oa=y+-1|0;G=228}}else{oa=1;G=228}if((G|0)==228){r=e+(Y(oa,X)|0)|0;R=c+(Y(oa,i)|0)|0;p[r>>3]=+p[r>>3]*+p[R>>3]}if(B){R=c+(A<<3)+-8|0;r=e+(A<<3)+-8|0;p[r>>3]=+p[r>>3]*+p[R>>3];if(!v){F=1;do{N=r+(Y(F,X)|0)|0;J=+p[N>>3];z=F+1|0;L=r+(Y(z,X)|0)|0;M=+p[L>>3];I=R+(Y(F,i)|0)|0;O=+p[I>>3];I=R+(Y(z,i)|0)|0;P=-+p[I>>3];p[N>>3]=J*O-M*P;p[L>>3]=M*O+J*P;F=F+2|0}while(F>>>0<=w>>>0);if(!(y&1))pa=y+-1|0;else break}else pa=1;w=r+(Y(pa,X)|0)|0;F=R+(Y(pa,i)|0)|0;p[w>>3]=+p[w>>3]*+p[F>>3]}}while(0);F=t&H;w=y+-1|0;if(!y)break;v=x>>>0<C>>>0;L=F&B;if(!F){if(v){qa=e;ra=c;sa=w}else break;while(1){F=x;do{N=qa+(F<<3)|0;P=+p[N>>3];I=F+1|0;z=qa+(I<<3)|0;J=+p[z>>3];O=+p[ra+(F<<3)>>3];M=-+p[ra+(I<<3)>>3];p[N>>3]=P*O-J*M;p[z>>3]=J*O+P*M;F=F+2|0}while(F>>>0<C>>>0);if(!sa)break a;else{qa=qa+X|0;ra=ra+i|0;sa=sa+-1|0}}}if(!v)if(L){F=e;R=c;r=e;z=w;while(1){p[r>>3]=+p[F>>3]*+p[R>>3];p[r+(C<<3)>>3]=+p[F+(C<<3)>>3]*+p[R+(C<<3)>>3];if(!z)break a;else{F=F+D|0;R=R+i|0;r=r+X|0;z=z+-1|0}}}else{z=e;r=c;R=e;F=w;while(1){p[R>>3]=+p[z>>3]*+p[r>>3];if(!F)break a;else{z=z+D|0;r=r+i|0;R=R+X|0;F=F+-1|0}}}if(L){F=e;R=c;r=e;z=w;while(1){p[r>>3]=+p[F>>3]*+p[R>>3];v=x;do{N=r+(v<<3)|0;M=+p[N>>3];I=v+1|0;S=r+(I<<3)|0;P=+p[S>>3];O=+p[R+(v<<3)>>3];J=-+p[R+(I<<3)>>3];p[N>>3]=M*O-P*J;p[S>>3]=P*O+M*J;v=v+2|0}while(v>>>0<C>>>0);p[r+(C<<3)>>3]=+p[F+(C<<3)>>3]*+p[R+(C<<3)>>3];if(!z)break;else{F=F+D|0;R=R+i|0;r=r+X|0;z=z+-1|0}}}else{z=e;r=c;R=e;F=w;while(1){p[R>>3]=+p[z>>3]*+p[r>>3];L=x;do{v=R+(L<<3)|0;J=+p[v>>3];S=L+1|0;N=R+(S<<3)|0;M=+p[N>>3];O=+p[r+(L<<3)>>3];P=-+p[r+(S<<3)>>3];p[v>>3]=J*O-M*P;p[N>>3]=M*O+J*P;L=L+2|0}while(L>>>0<C>>>0);if(!F)break;else{z=z+D|0;r=r+i|0;R=R+X|0;F=F+-1|0}}}}else{do if(!K){p[o>>3]=+p[e>>3]*+p[c>>3];F=y+-2|0;R=(F|0)==0;if(!R){r=1;do{z=e+(Y(r,D)|0)|0;P=+p[z>>3];z=r+1|0;w=e+(Y(z,D)|0)|0;J=+p[w>>3];w=c+(Y(r,i)|0)|0;O=+p[w>>3];w=c+(Y(z,i)|0)|0;M=-+p[w>>3];w=o+(Y(r,X)|0)|0;p[w>>3]=P*O-J*M;w=o+(Y(z,X)|0)|0;p[w>>3]=J*O+P*M;r=r+2|0}while(r>>>0<=F>>>0);if(!(y&1)){ta=y+-1|0;G=255}}else{ta=1;G=255}if((G|0)==255){r=o+(Y(ta,X)|0)|0;w=c+(Y(ta,i)|0)|0;z=e+(Y(ta,D)|0)|0;p[r>>3]=+p[z>>3]*+p[w>>3]}if(B){w=e+(A<<3)+-8|0;z=c+(A<<3)+-8|0;r=o+(A<<3)+-8|0;p[r>>3]=+p[w>>3]*+p[z>>3];if(!R){L=1;do{N=w+(Y(L,D)|0)|0;M=+p[N>>3];N=L+1|0;v=w+(Y(N,D)|0)|0;P=+p[v>>3];v=z+(Y(L,i)|0)|0;O=+p[v>>3];v=z+(Y(N,i)|0)|0;J=-+p[v>>3];v=r+(Y(L,X)|0)|0;p[v>>3]=M*O-P*J;v=r+(Y(N,X)|0)|0;p[v>>3]=P*O+M*J;L=L+2|0}while(L>>>0<=F>>>0);if(!(y&1))ua=y+-1|0;else break}else ua=1;F=r+(Y(ua,X)|0)|0;L=z+(Y(ua,i)|0)|0;R=w+(Y(ua,D)|0)|0;p[F>>3]=+p[R>>3]*+p[L>>3]}}while(0);L=t&H;R=y+-1|0;if(!y)break;F=x>>>0<C>>>0;v=L&B;if(!L){if(F){va=e;wa=c;xa=o;ya=R}else break;while(1){L=x;do{J=+p[va+(L<<3)>>3];N=L+1|0;M=+p[va+(N<<3)>>3];O=+p[wa+(L<<3)>>3];P=-+p[wa+(N<<3)>>3];p[xa+(L<<3)>>3]=J*O-M*P;p[xa+(N<<3)>>3]=M*O+J*P;L=L+2|0}while(L>>>0<C>>>0);if(!ya)break a;else{va=va+D|0;wa=wa+i|0;xa=xa+X|0;ya=ya+-1|0}}}if(!F)if(v){L=e;w=c;z=o;r=R;while(1){p[z>>3]=+p[L>>3]*+p[w>>3];p[z+(C<<3)>>3]=+p[L+(C<<3)>>3]*+p[w+(C<<3)>>3];if(!r)break a;else{L=L+D|0;w=w+i|0;z=z+X|0;r=r+-1|0}}}else{r=e;z=c;w=o;L=R;while(1){p[w>>3]=+p[r>>3]*+p[z>>3];if(!L)break a;else{r=r+D|0;z=z+i|0;w=w+X|0;L=L+-1|0}}}if(v){L=e;w=c;z=o;r=R;while(1){p[z>>3]=+p[L>>3]*+p[w>>3];F=x;do{P=+p[L+(F<<3)>>3];N=F+1|0;J=+p[L+(N<<3)>>3];O=+p[w+(F<<3)>>3];M=-+p[w+(N<<3)>>3];p[z+(F<<3)>>3]=P*O-J*M;p[z+(N<<3)>>3]=J*O+P*M;F=F+2|0}while(F>>>0<C>>>0);p[z+(C<<3)>>3]=+p[L+(C<<3)>>3]*+p[w+(C<<3)>>3];if(!r)break;else{L=L+D|0;w=w+i|0;z=z+X|0;r=r+-1|0}}}else{r=e;z=c;w=o;L=R;while(1){p[w>>3]=+p[r>>3]*+p[z>>3];v=x;do{M=+p[r+(v<<3)>>3];F=v+1|0;P=+p[r+(F<<3)>>3];O=+p[z+(v<<3)>>3];J=-+p[z+(F<<3)>>3];p[w+(v<<3)>>3]=M*O-P*J;p[w+(F<<3)>>3]=P*O+M*J;v=v+2|0}while(v>>>0<C>>>0);if(!L)break;else{r=r+D|0;z=z+i|0;w=w+X|0;L=L+-1|0}}}}else if(s){do if(!K){p[e>>3]=+p[e>>3]*+p[c>>3];L=y+-2|0;w=(L|0)==0;if(!w){z=1;do{r=e+(Y(z,X)|0)|0;J=+p[r>>3];R=z+1|0;v=e+(Y(R,X)|0)|0;M=+p[v>>3];F=c+(Y(z,i)|0)|0;O=+p[F>>3];F=c+(Y(R,i)|0)|0;P=+p[F>>3];p[r>>3]=J*O-M*P;p[v>>3]=M*O+J*P;z=z+2|0}while(z>>>0<=L>>>0);if(!(y&1)){za=y+-1|0;G=173}}else{za=1;G=173}if((G|0)==173){z=e+(Y(za,X)|0)|0;v=c+(Y(za,i)|0)|0;p[z>>3]=+p[z>>3]*+p[v>>3]}if(B){v=c+(A<<3)+-8|0;z=e+(A<<3)+-8|0;p[z>>3]=+p[z>>3]*+p[v>>3];if(!w){r=1;do{F=z+(Y(r,X)|0)|0;P=+p[F>>3];R=r+1|0;N=z+(Y(R,X)|0)|0;J=+p[N>>3];S=v+(Y(r,i)|0)|0;O=+p[S>>3];S=v+(Y(R,i)|0)|0;M=+p[S>>3];p[F>>3]=P*O-J*M;p[N>>3]=J*O+P*M;r=r+2|0}while(r>>>0<=L>>>0);if(!(y&1))Aa=y+-1|0;else break}else Aa=1;L=z+(Y(Aa,X)|0)|0;r=v+(Y(Aa,i)|0)|0;p[L>>3]=+p[L>>3]*+p[r>>3]}}while(0);s=t&H;r=y+-1|0;if(!y)break;L=x>>>0<C>>>0;w=s&B;if(!s){if(L){Ba=e;Ca=c;Da=r}else break;while(1){s=x;do{N=Ba+(s<<3)|0;M=+p[N>>3];F=s+1|0;S=Ba+(F<<3)|0;P=+p[S>>3];O=+p[Ca+(s<<3)>>3];J=+p[Ca+(F<<3)>>3];p[N>>3]=M*O-P*J;p[S>>3]=P*O+M*J;s=s+2|0}while(s>>>0<C>>>0);if(!Da)break a;else{Ba=Ba+X|0;Ca=Ca+i|0;Da=Da+-1|0}}}if(!L)if(w){s=e;v=c;z=e;S=r;while(1){p[z>>3]=+p[s>>3]*+p[v>>3];p[z+(C<<3)>>3]=+p[s+(C<<3)>>3]*+p[v+(C<<3)>>3];if(!S)break a;else{s=s+D|0;v=v+i|0;z=z+X|0;S=S+-1|0}}}else{S=e;z=c;v=e;s=r;while(1){p[v>>3]=+p[S>>3]*+p[z>>3];if(!s)break a;else{S=S+D|0;z=z+i|0;v=v+X|0;s=s+-1|0}}}if(w){s=e;v=c;z=e;S=r;while(1){p[z>>3]=+p[s>>3]*+p[v>>3];L=x;do{N=z+(L<<3)|0;J=+p[N>>3];F=L+1|0;R=z+(F<<3)|0;M=+p[R>>3];O=+p[v+(L<<3)>>3];P=+p[v+(F<<3)>>3];p[N>>3]=J*O-M*P;p[R>>3]=M*O+J*P;L=L+2|0}while(L>>>0<C>>>0);p[z+(C<<3)>>3]=+p[s+(C<<3)>>3]*+p[v+(C<<3)>>3];if(!S)break;else{s=s+D|0;v=v+i|0;z=z+X|0;S=S+-1|0}}}else{S=e;z=c;v=e;s=r;while(1){p[v>>3]=+p[S>>3]*+p[z>>3];w=x;do{L=v+(w<<3)|0;P=+p[L>>3];R=w+1|0;N=v+(R<<3)|0;J=+p[N>>3];O=+p[z+(w<<3)>>3];M=+p[z+(R<<3)>>3];p[L>>3]=P*O-J*M;p[N>>3]=J*O+P*M;w=w+2|0}while(w>>>0<C>>>0);if(!s)break;else{S=S+D|0;z=z+i|0;v=v+X|0;s=s+-1|0}}}}else{do if(!K){p[o>>3]=+p[e>>3]*+p[c>>3];s=y+-2|0;v=(s|0)==0;if(!v){z=1;do{S=e+(Y(z,D)|0)|0;M=+p[S>>3];S=z+1|0;r=e+(Y(S,D)|0)|0;P=+p[r>>3];r=c+(Y(z,i)|0)|0;O=+p[r>>3];r=c+(Y(S,i)|0)|0;J=+p[r>>3];r=o+(Y(z,X)|0)|0;p[r>>3]=M*O-P*J;r=o+(Y(S,X)|0)|0;p[r>>3]=P*O+M*J;z=z+2|0}while(z>>>0<=s>>>0);if(!(y&1)){Ea=y+-1|0;G=200}}else{Ea=1;G=200}if((G|0)==200){z=o+(Y(Ea,X)|0)|0;r=c+(Y(Ea,i)|0)|0;S=e+(Y(Ea,D)|0)|0;p[z>>3]=+p[S>>3]*+p[r>>3]}if(B){r=e+(A<<3)+-8|0;S=c+(A<<3)+-8|0;z=o+(A<<3)+-8|0;p[z>>3]=+p[r>>3]*+p[S>>3];if(!v){w=1;do{N=r+(Y(w,D)|0)|0;J=+p[N>>3];N=w+1|0;L=r+(Y(N,D)|0)|0;M=+p[L>>3];L=S+(Y(w,i)|0)|0;O=+p[L>>3];L=S+(Y(N,i)|0)|0;P=+p[L>>3];L=z+(Y(w,X)|0)|0;p[L>>3]=J*O-M*P;L=z+(Y(N,X)|0)|0;p[L>>3]=M*O+J*P;w=w+2|0}while(w>>>0<=s>>>0);if(!(y&1))Fa=y+-1|0;else break}else Fa=1;s=z+(Y(Fa,X)|0)|0;w=S+(Y(Fa,i)|0)|0;v=r+(Y(Fa,D)|0)|0;p[s>>3]=+p[v>>3]*+p[w>>3]}}while(0);K=t&H;w=y+-1|0;if(!y)break;v=x>>>0<C>>>0;s=K&B;if(!K){if(v){Ga=e;Ha=c;Ia=o;Ja=w}else break;while(1){K=x;do{P=+p[Ga+(K<<3)>>3];L=K+1|0;J=+p[Ga+(L<<3)>>3];O=+p[Ha+(K<<3)>>3];M=+p[Ha+(L<<3)>>3];p[Ia+(K<<3)>>3]=P*O-J*M;p[Ia+(L<<3)>>3]=J*O+P*M;K=K+2|0}while(K>>>0<C>>>0);if(!Ja)break a;else{Ga=Ga+D|0;Ha=Ha+i|0;Ia=Ia+X|0;Ja=Ja+-1|0}}}if(!v)if(s){K=e;r=c;S=o;z=w;while(1){p[S>>3]=+p[K>>3]*+p[r>>3];p[S+(C<<3)>>3]=+p[K+(C<<3)>>3]*+p[r+(C<<3)>>3];if(!z)break a;else{K=K+D|0;r=r+i|0;S=S+X|0;z=z+-1|0}}}else{z=e;S=c;r=o;K=w;while(1){p[r>>3]=+p[z>>3]*+p[S>>3];if(!K)break a;else{z=z+D|0;S=S+i|0;r=r+X|0;K=K+-1|0}}}if(s){K=e;r=c;S=o;z=w;while(1){p[S>>3]=+p[K>>3]*+p[r>>3];v=x;do{M=+p[K+(v<<3)>>3];L=v+1|0;P=+p[K+(L<<3)>>3];O=+p[r+(v<<3)>>3];J=+p[r+(L<<3)>>3];p[S+(v<<3)>>3]=M*O-P*J;p[S+(L<<3)>>3]=P*O+M*J;v=v+2|0}while(v>>>0<C>>>0);p[S+(C<<3)>>3]=+p[K+(C<<3)>>3]*+p[r+(C<<3)>>3];if(!z)break;else{K=K+D|0;r=r+i|0;S=S+X|0;z=z+-1|0}}}else{z=e;S=c;r=o;K=w;while(1){p[r>>3]=+p[z>>3]*+p[S>>3];s=x;do{J=+p[z+(s<<3)>>3];v=s+1|0;M=+p[z+(v<<3)>>3];O=+p[S+(s<<3)>>3];P=+p[S+(v<<3)>>3];p[r+(s<<3)>>3]=J*O-M*P;p[r+(v<<3)>>3]=M*O+J*P;s=s+2|0}while(s>>>0<C>>>0);if(!K)break;else{z=z+D|0;S=S+i|0;r=r+X|0;K=K+-1|0}}}}}while(0);C=m+36|0;x=f[C>>2]|0;if(x|0?(e=x+12|0,x=f[e>>2]|0,f[e>>2]=x+-1,(x|0)==1):0)CR(m);f[C>>2]=0;C=m+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[C>>2]|0)>0){E=f[m+40>>2]|0;x=0;do{f[E+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[C>>2]|0))}C=f[m+44>>2]|0;if((C|0)!=(m+48|0))ZF(C);C=l+36|0;m=f[C>>2]|0;if(m|0?(x=m+12|0,m=f[x>>2]|0,f[x>>2]=m+-1,(m|0)==1):0)CR(l);f[C>>2]=0;C=l+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[C>>2]|0)>0){d=f[l+40>>2]|0;m=0;do{f[d+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[C>>2]|0))}C=f[l+44>>2]|0;if((C|0)!=(l+48|0))ZF(C);C=k+36|0;l=f[C>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)CR(k);f[C>>2]=0;C=k+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[C>>2]|0)>0){q=f[k+40>>2]|0;l=0;do{f[q+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[C>>2]|0))}C=f[k+44>>2]|0;if((C|0)!=(k+48|0))ZF(C);if(!(f[j+4>>2]|0)){u=h;return}u=h;return}function RM(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;if(a>>>0>2125763999){b=-1;return b|0}else{c=0;d=1650}do{e=d+c>>1;g=(f[32216+(e<<2)>>2]|0)<(a|0);c=g?e+1|0:c;d=g?d:e}while((c|0)<(d|0));b=f[32216+(d<<2)>>2]|0;return b|0}function SM(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0.0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0.0,Eb=0,Fb=0.0,Gb=0,Hb=0.0,Ib=0,Jb=0,Kb=0.0,Lb=0,Mb=0,Nb=0,Ob=0.0,Pb=0,Qb=0.0,Rb=0,Sb=0,Tb=0.0,Ub=0.0,Vb=0,Wb=0.0,Xb=0,Yb=0,Zb=0.0,_b=0,$b=0,ac=0,bc=0,cc=0.0,dc=0.0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0.0,oc=0,pc=0,qc=0,rc=0.0,sc=0,tc=0,uc=0.0,vc=0,wc=0.0,xc=0,yc=0,zc=0.0,Ac=0.0,Bc=0,Cc=0.0,Dc=0,Ec=0,Fc=0.0,Gc=0,Hc=0.0,Ic=0.0,Jc=0.0;j=u;u=u+624|0;k=j+32|0;l=j+600|0;m=j+584|0;o=j+576|0;q=j+544|0;r=j+536|0;t=j+480|0;v=j+424|0;w=j+368|0;x=j+312|0;y=j+256|0;z=j+200|0;A=j+144|0;B=j+132|0;C=j+120|0;D=j+64|0;E=j;_$(r,38820);do if((NS(a)|0)==65536){F=f[a+4>>2]|0;f[t>>2]=f[F>>2];G=t+4|0;H=F+4|0;f[G>>2]=f[H>>2];I=t+8|0;f[I>>2]=f[F+8>>2];K=t+12|0;f[K>>2]=f[F+12>>2];f[t+16>>2]=f[F+16>>2];f[t+20>>2]=f[F+20>>2];f[t+24>>2]=f[F+24>>2];f[t+28>>2]=f[F+28>>2];f[t+32>>2]=f[F+32>>2];L=f[F+36>>2]|0;f[t+36>>2]=L;f[t+40>>2]=I;M=t+48|0;N=t+44|0;f[N>>2]=M;f[M>>2]=0;f[t+52>>2]=0;if(L|0){M=L+12|0;f[M>>2]=(f[M>>2]|0)+1}if((f[H>>2]|0)<3){H=f[F+44>>2]|0;M=f[N>>2]|0;f[M>>2]=f[H>>2];f[M+4>>2]=f[H+4>>2];O=K;P=G;Q=t;R=I;break}else{f[G>>2]=0;BR(t,F);O=K;P=G;Q=t;R=I;break}}else{OR(t,a,-1);O=t+12|0;P=t+4|0;Q=t;R=t+8|0}while(0);a=f[R>>2]|0;R=(a|0)==1;I=f[O>>2]|0;O=R?I:a;a=f[Q>>2]|0;Q=Y((a>>>3&511)+1|0,R?1:I)|0;I=a&7;a=(g|0)>1?g:1;g=(c|0)>0;if(!(g&((f[P>>2]|0)<3&(I|0)==5))){f[k>>2]=0;f[k+4>>2]=0;S=c$(k,37)|0;T=163458;U=S+37|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));j$(-215,k,163496,163503,243);d$(k)}if((O|0)<(c|0)){f[k>>2]=0;f[k+4>>2]=0;G=c$(k,6)|0;b[G>>0]=b[163551]|0;b[G+1>>0]=b[163552]|0;b[G+2>>0]=b[163553]|0;b[G+3>>0]=b[163554]|0;b[G+4>>0]=b[163555]|0;b[G+5>>0]=b[163556]|0;j$(-215,k,163496,163503,244);d$(k)}G=t+16|0;K=t+44|0;F=t+48|0;$i(v,O,Q,5,f[G>>2]|0,R?Q<<2:f[F>>2]|0);pS(d,O,1,4,-1,1,0);f[w>>2]=1124007936;R=w+4|0;H=w+8|0;M=w+40|0;S=R;U=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(U|0));f[M>>2]=H;N=w+48|0;L=w+44|0;f[L>>2]=N;f[N>>2]=0;f[w+52>>2]=0;do if((NS(d)|0)==65536){V=f[d+4>>2]|0;f[x>>2]=f[V>>2];W=x+4|0;X=V+4|0;f[W>>2]=f[X>>2];Z=x+8|0;f[Z>>2]=f[V+8>>2];_=x+12|0;f[_>>2]=f[V+12>>2];f[x+16>>2]=f[V+16>>2];f[x+20>>2]=f[V+20>>2];f[x+24>>2]=f[V+24>>2];f[x+28>>2]=f[V+28>>2];f[x+32>>2]=f[V+32>>2];$=f[V+36>>2]|0;f[x+36>>2]=$;f[x+40>>2]=Z;aa=x+48|0;ba=x+44|0;f[ba>>2]=aa;f[aa>>2]=0;f[x+52>>2]=0;if($|0){aa=$+12|0;f[aa>>2]=(f[aa>>2]|0)+1}if((f[X>>2]|0)<3){X=f[V+44>>2]|0;aa=f[ba>>2]|0;f[aa>>2]=f[X>>2];f[aa+4>>2]=f[X+4>>2];ca=Z;da=_;break}else{f[W>>2]=0;BR(x,V);ca=Z;da=_;break}}else{OR(x,d,-1);ca=x+8|0;da=x+12|0}while(0);d=(h&1|0)!=0;_=f[da>>2]|0;da=(_|0)==1;Z=f[ca>>2]|0;ca=(da|(Z|0)==1)&(Y(Z,_)|0)==(O|0);do if(d){if(!(ca?(f[x>>2]&20479|0)==16388:0)){f[k>>2]=0;f[k+4>>2]=0;K1a(c$(k,147)|0,163558,147)|0;j$(-215,k,163496,163503,256);d$(k)}_=k+8|0;f[_>>2]=0;f[_+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=w;eL(x,k)}else{if(ca?(_=f[x>>2]|0,(_&20479|0)==16388):0)ea=_;else fa=26;do if((fa|0)==26){if((((Z|0)==(O|0)?(f[x+4>>2]|0)<3:0)&da?(_=f[x>>2]|0,(_&4095|0)==4):0)?f[x+16>>2]|0:0){ea=_;break}f[k>>2]=O;f[k+4>>2]=1;AR(x,2,k,4);ea=f[x>>2]|0}while(0);_=f[x+40>>2]|0;V=f[_+4>>2]|0;W=f[_>>2]|0;_=ea&4095;if(((((f[R>>2]|0)<3?(f[H>>2]|0)==(W|0):0)?(f[w+12>>2]|0)==(V|0):0)?(f[w>>2]&4095|0)==(_|0):0)?f[w+16>>2]|0:0)break;f[k>>2]=W;f[k+4>>2]=V;AR(w,2,k,_)}while(0);H=w+16|0;ea=f[H>>2]|0;f[y>>2]=1124007936;da=y+4|0;Z=y+8|0;ca=y+40|0;S=da;U=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(U|0));f[ca>>2]=Z;Z=y+48|0;_=y+44|0;f[_>>2]=Z;f[Z>>2]=0;f[y+52>>2]=0;f[k>>2]=c;V=k+4|0;f[V>>2]=Q;AR(y,2,k,I);f[z>>2]=1124007936;W=z+4|0;X=z+8|0;aa=z+40|0;S=W;U=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(U|0));f[aa>>2]=X;X=z+48|0;ba=z+44|0;f[ba>>2]=X;f[X>>2]=0;f[z+52>>2]=0;f[k>>2]=c;f[V>>2]=Q;AR(z,2,k,I);f[A>>2]=1124007936;$=A+4|0;ga=A+8|0;ha=A+40|0;S=$;U=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(U|0));f[ha>>2]=ga;ga=A+48|0;ia=A+44|0;f[ia>>2]=ga;f[ga>>2]=0;f[A+52>>2]=0;f[k>>2]=1;f[V>>2]=Q;AR(A,2,k,I);f[B>>2]=0;I=B+4|0;f[I>>2]=0;f[B+8>>2]=0;ja=(c|0)==0;do if(!ja)if(c>>>0>1073741823)gXa(B);else{ka=c<<2;la=NYa(ka)|0;f[B>>2]=la;ma=la+(c<<2)|0;f[B+8>>2]=ma;F1a(la|0,0,ka|0)|0;f[I>>2]=ma;break}while(0);f[C>>2]=0;ma=C+4|0;f[ma>>2]=0;f[C+8>>2]=0;if(Q|0){if(Q>>>0>536870911)gXa(C);ka=NYa(Q<<3)|0;f[ma>>2]=ka;f[C>>2]=ka;f[C+8>>2]=ka+(Q<<3);la=ka;na=Q;oa=ka;while(1){pa=la;f[pa>>2]=0;f[pa+4>>2]=0;pa=oa+8|0;qa=na+-1|0;if(!qa)break;else{la=pa;na=qa;oa=pa}}f[ma>>2]=ka+(Q<<3)}f[D>>2]=1124007936;ka=D+4|0;oa=D+8|0;na=D+40|0;S=ka;U=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(U|0));f[na>>2]=oa;oa=D+48|0;la=D+44|0;f[la>>2]=oa;f[oa>>2]=0;f[D+52>>2]=0;f[k>>2]=1;f[V>>2]=O;AR(D,2,k,6);V=f[C>>2]|0;pa=NY()|0;qa=f[e>>2]|0;ra=e+8|0;if(!(qa&2))sa=1.1920928955078125e-07;else{ta=+p[ra>>3];sa=ta<0.0?0.0:ta}ta=sa*sa;p[ra>>3]=ta;ra=e+4|0;if(!(qa&1))ua=100;else{qa=f[ra>>2]|0;e=(qa|0)>2?qa:2;ua=(e|0)<100?e:100}e=(c|0)==1;qa=e?2:ua;ua=e?1:a;f[ra>>2]=qa;ra=v+16|0;a=f[ra>>2]|0;e=v+44|0;va=(Q|0)>0;if(va){wa=0;do{xa=f[a+(wa<<2)>>2]|0;f[V+(wa<<3)>>2]=xa;f[V+(wa<<3)+4>>2]=xa;wa=wa+1|0}while((wa|0)!=(Q|0))}if((O|0)>1?(wa=f[ra>>2]|0,a=f[f[e>>2]>>2]|0,va):0){xa=1;do{ya=wa+(Y(a,xa)|0)|0;za=0;do{Aa=f[ya+(za<<2)>>2]|0;f[k>>2]=Aa;Ba=V+(za<<3)|0;sa=(f[s>>2]=Aa,+n[s>>2]);f[Ba>>2]=f[(sa<+n[Ba>>2]?k:Ba)>>2];Ba=V+(za<<3)+4|0;f[Ba>>2]=f[(+n[Ba>>2]<sa?k:Ba)>>2];za=za+1|0}while((za|0)!=(Q|0));xa=xa+1|0}while((xa|0)!=(O|0))}a:do if((ua|0)>0){xa=(h&2|0)==0;V=y+16|0;a=v+12|0;wa=v+8|0;za=v+48|0;ya=l+4|0;Ba=l+8|0;Aa=m+4|0;Ca=m+8|0;Da=(c|0)>1;Ea=o+4|0;Fa=q+4|0;Ga=q+8|0;Ha=q+12|0;Ia=q+16|0;Ja=q+20|0;Ka=q+24|0;La=k+4|0;La=m+8|0;Ma=c>>>0>1073741823;Na=c<<2;Oa=l+8|0;Pa=D+16|0;Qa=k+4|0;Ra=l+4|0;Sa=l+8|0;Ta=l+12|0;Ua=l+16|0;Va=l+20|0;Wa=k+8|0;Xa=k+12|0;Ya=k+4|0;Za=d^1;_a=(O|0)>0;$a=Q+-4|0;ab=(Q|0)<4;bb=A+16|0;cb=k+4|0;db=z+16|0;eb=k+4|0;fb=k+8|0;gb=k+4|0;hb=Q&-4;ib=(O|0)<1;jb=(hb|0)<(Q|0);kb=(qa|0)>2?qa:2;lb=0;sa=1797693134862315708145274.0e284;b:while(1){mb=d&(lb|0)<1;nb=0;ob=1797693134862315708145274.0e284;while(1){zR(y,z);c:do if((nb|0)!=0|mb){if(!((nb|lb|0)!=0|Za|ib)){pb=0;do{if((f[ea+(pb<<2)>>2]|0)>>>0>=c>>>0){f[k>>2]=0;f[eb>>2]=0;S=c$(k,33)|0;T=163706;U=S+33|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));j$(-215,k,163496,163503,333);d$(k)}pb=pb+1|0}while((pb|0)<(O|0))};f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;gL(y,k)|0;if(g)F1a(f[B>>2]|0,0,Na|0)|0;d:do if(_a){pb=f[ra>>2]|0;qb=f[e>>2]|0;rb=f[V>>2]|0;sb=f[_>>2]|0;tb=f[B>>2]|0;if(ab){ub=0;while(1){vb=pb+(Y(f[qb>>2]|0,ub)|0)|0;wb=f[ea+(ub<<2)>>2]|0;xb=rb+(Y(f[sb>>2]|0,wb)|0)|0;if(va){yb=0;do{zb=xb+(yb<<2)|0;n[zb>>2]=+n[vb+(yb<<2)>>2]+ +n[zb>>2];yb=yb+1|0}while((yb|0)!=(Q|0))}yb=tb+(wb<<2)|0;f[yb>>2]=(f[yb>>2]|0)+1;ub=ub+1|0;if((ub|0)==(O|0))break d}}else Ab=0;do{ub=pb+(Y(f[qb>>2]|0,Ab)|0)|0;yb=f[ea+(Ab<<2)>>2]|0;vb=rb+(Y(f[sb>>2]|0,yb)|0)|0;xb=0;do{zb=vb+(xb<<2)|0;Bb=xb|1;Cb=vb+(Bb<<2)|0;Db=+n[Cb>>2]+ +n[ub+(Bb<<2)>>2];n[zb>>2]=+n[zb>>2]+ +n[ub+(xb<<2)>>2];n[Cb>>2]=Db;Cb=xb|2;zb=vb+(Cb<<2)|0;Bb=xb|3;Eb=vb+(Bb<<2)|0;Db=+n[Eb>>2]+ +n[ub+(Bb<<2)>>2];n[zb>>2]=+n[zb>>2]+ +n[ub+(Cb<<2)>>2];n[Eb>>2]=Db;xb=xb+4|0}while((xb|0)<=($a|0));if(jb){xb=hb;do{wb=vb+(xb<<2)|0;n[wb>>2]=+n[ub+(xb<<2)>>2]+ +n[wb>>2];xb=xb+1|0}while((xb|0)!=(Q|0))}xb=tb+(yb<<2)|0;f[xb>>2]=(f[xb>>2]|0)+1;Ab=Ab+1|0}while((Ab|0)!=(O|0))}while(0);tb=(nb|0)>0;Db=tb?0.0:ob;if(!g){Fb=Db;break}sb=f[B>>2]|0;rb=f[V>>2]|0;qb=f[_>>2]|0;pb=f[bb>>2]|0;xb=f[ra>>2]|0;ub=f[e>>2]|0;vb=0;do{wb=sb+(vb<<2)|0;do if(!(f[wb>>2]|0)){if(Da){Eb=1;Cb=0;while(1){zb=(f[sb+(Cb<<2)>>2]|0)<(f[sb+(Eb<<2)>>2]|0)?Eb:Cb;Eb=Eb+1|0;if((Eb|0)==(c|0)){Gb=zb;break}else Cb=zb}}else Gb=0;Cb=f[qb>>2]|0;Eb=rb+(Y(Cb,vb)|0)|0;yb=rb+(Y(Cb,Gb)|0)|0;Cb=sb+(Gb<<2)|0;zb=f[Cb>>2]|0;Hb=1.0/+(zb|0);if(va){Bb=0;do{n[pb+(Bb<<2)>>2]=Hb*+n[yb+(Bb<<2)>>2];Bb=Bb+1|0}while((Bb|0)!=(Q|0))}e:do if(_a){if(va){Ib=-1;Jb=0;Kb=0.0}else{Bb=-1;Lb=0;while(1){Mb=(f[ea+(Lb<<2)>>2]|0)==(Gb|0)?Lb:Bb;Lb=Lb+1|0;if((Lb|0)==(O|0)){Nb=Mb;break e}else Bb=Mb}}while(1){if((f[ea+(Jb<<2)>>2]|0)==(Gb|0)){Bb=xb+(Y(f[ub>>2]|0,Jb)|0)|0;Lb=0;Hb=0.0;do{Ob=+n[Bb+(Lb<<2)>>2]-+n[pb+(Lb<<2)>>2];Hb=Hb+Ob*Ob;Lb=Lb+1|0}while((Lb|0)!=(Q|0));Ob=Hb;Lb=!(Kb<=Ob);Pb=Lb?Ib:Jb;Qb=Lb?Kb:Ob}else{Pb=Ib;Qb=Kb}Jb=Jb+1|0;if((Jb|0)==(O|0)){Nb=Pb;break}else{Ib=Pb;Kb=Qb}}}else Nb=-1;while(0);f[Cb>>2]=zb+-1;f[wb>>2]=(f[wb>>2]|0)+1;f[ea+(Nb<<2)>>2]=vb;Lb=xb+(Y(f[ub>>2]|0,Nb)|0)|0;if(va)Rb=0;else break;do{Bb=Lb+(Rb<<2)|0;Mb=yb+(Rb<<2)|0;n[Mb>>2]=+n[Mb>>2]-+n[Bb>>2];Mb=Eb+(Rb<<2)|0;n[Mb>>2]=+n[Bb>>2]+ +n[Mb>>2];Rb=Rb+1|0}while((Rb|0)!=(Q|0))}while(0);vb=vb+1|0}while((vb|0)!=(c|0));if(!g){Fb=Db;break}if(va){Sb=0;Tb=Db}else{vb=0;Ob=Db;while(1){if(!(f[(f[B>>2]|0)+(vb<<2)>>2]|0)){f[k>>2]=0;f[cb>>2]=0;S=c$(k,16)|0;T=163740;U=S+16|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));j$(-215,k,163496,163503,425);d$(k)}Ub=tb&Ob<0.0?0.0:Ob;vb=vb+1|0;if((vb|0)>=(c|0)){Fb=Ub;break c}else Ob=Ub}}while(1){vb=(f[V>>2]|0)+(Y(f[f[_>>2]>>2]|0,Sb)|0)|0;ub=f[(f[B>>2]|0)+(Sb<<2)>>2]|0;if(!ub){f[k>>2]=0;f[cb>>2]=0;S=c$(k,16)|0;T=163740;U=S+16|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));j$(-215,k,163496,163503,425);d$(k);Vb=f[(f[B>>2]|0)+(Sb<<2)>>2]|0}else Vb=ub;Ob=1.0/+(Vb|0);xb=0;do{pb=vb+(xb<<2)|0;n[pb>>2]=Ob*+n[pb>>2];xb=xb+1|0}while((xb|0)!=(Q|0));if(tb){xb=(f[db>>2]|0)+(Y(f[f[ba>>2]>>2]|0,Sb)|0)|0;Ob=0.0;ub=0;do{Db=+n[vb+(ub<<2)>>2]-+n[xb+(ub<<2)>>2];Ob=Ob+Db*Db;ub=ub+1|0}while((ub|0)!=(Q|0));Wb=Tb<Ob?Ob:Tb}else Wb=Tb;Sb=Sb+1|0;if((Sb|0)>=(c|0)){Fb=Wb;break}else Tb=Wb}}else{if(xa){if(!g){Fb=ob;break}tb=f[V>>2]|0;ub=f[f[_>>2]>>2]|0;xb=f[C>>2]|0;vb=(f[ma>>2]|0)-xb>>3;Db=1.0/+(vb>>>0);pb=xb;Ub=Db*2.0+1.0;if(!vb){Fb=ob;break}xb=pa;sb=f[xb>>2]|0;rb=f[xb+4>>2]|0;xb=0;while(1){qb=tb+(Y(ub,xb)|0)|0;Xb=sb;Yb=rb;wb=0;do{Eb=W1a(Xb|0,0,-130063606,0)|0;Xb=C1a(Eb|0,J|0,Yb|0,0)|0;Yb=J;Zb=+n[pb+(wb<<3)>>2];n[qb+(wb<<2)>>2]=Zb+(+n[pb+(wb<<3)+4>>2]-Zb)*(Ub*(+(Xb>>>0)*2.3283064365386963e-10)-Db);wb=wb+1|0}while((wb|0)!=(vb|0));xb=xb+1|0;if((xb|0)==(c|0))break;else{sb=Xb;rb=Yb}}rb=pa;f[rb>>2]=Xb;f[rb+4>>2]=Yb;Fb=ob;break}_$(k,38840);rb=f[a>>2]|0;sb=f[wa>>2]|0;xb=f[ra>>2]|0;vb=(f[za>>2]|0)>>>2;f[l>>2]=0;f[ya>>2]=0;f[Ba>>2]=0;if(ja)_b=0;else{if(Ma){fa=66;break b}pb=NYa(Na)|0;f[l>>2]=pb;ub=pb+(c<<2)|0;f[Oa>>2]=ub;F1a(pb|0,0,Na|0)|0;f[ya>>2]=ub;_b=pb}pb=sb*3|0;f[m>>2]=0;f[Aa>>2]=0;f[Ca>>2]=0;if(!sb){$b=0;ac=0}else{if(pb>>>0>1073741823){fa=70;break b}ub=sb*12|0;tb=NYa(ub)|0;f[m>>2]=tb;wb=tb+(pb<<2)|0;f[La>>2]=wb;F1a(tb|0,0,ub|0)|0;f[Aa>>2]=wb;$b=tb;ac=tb}tb=$b;wb=$b+(sb<<2)|0;ub=wb;pb=wb+(sb<<2)|0;wb=pa;qb=f[wb+4>>2]|0;Eb=W1a(f[wb>>2]|0,0,-130063606,0)|0;wb=C1a(Eb|0,J|0,qb|0,0)|0;qb=pa;f[qb>>2]=wb;f[qb+4>>2]=J;qb=(wb>>>0)%(sb>>>0)|0;f[_b>>2]=qb;wb=(sb|0)>0;do if(wb){Eb=xb+((Y(qb,vb)|0)<<2)|0;if((rb|0)>0){bc=0;cc=0.0}else{F1a(ac|0,0,sb<<2|0)|0;dc=0.0;break}while(1){yb=xb+((Y(bc,vb)|0)<<2)|0;Lb=0;Db=0.0;do{Ub=+n[yb+(Lb<<2)>>2]-+n[Eb+(Lb<<2)>>2];Db=Db+Ub*Ub;Lb=Lb+1|0}while((Lb|0)!=(rb|0));n[$b+(bc<<2)>>2]=Db;Ub=cc+Db;bc=bc+1|0;if((bc|0)==(sb|0)){dc=Ub;break}else cc=Ub}}else dc=0.0;while(0);if(Da){qb=sb+-1|0;Eb=(sb|0)>1;Lb=tb;yb=1;Ub=dc;zb=ub;Cb=pb;while(1){Mb=Lb;do if(Eb){Bb=-1;Ob=1797693134862315708145274.0e284;ec=0;fc=zb;gc=Cb;while(1){hc=pa;ic=f[hc+4>>2]|0;jc=W1a(f[hc>>2]|0,0,-130063606,0)|0;hc=C1a(jc|0,J|0,ic|0,0)|0;ic=J;jc=W1a(hc|0,0,-130063606,0)|0;kc=C1a(jc|0,J|0,ic|0,0)|0;ic=pa;f[ic>>2]=kc;f[ic+4>>2]=J;ic=0;Zb=Ub*((+(kc>>>0)+4294967296.0*+(hc>>>0))*5.421010862427522e-20);while(1){Zb=Zb-+n[Mb+(ic<<2)>>2];if(Zb<=0.0){lc=ic;break}hc=ic+1|0;if((hc|0)>=(qb|0)){lc=hc;break}else ic=hc}f[o>>2]=0;f[Ea>>2]=sb;ic=gc;hc=Y(lc,vb)|0;f[q>>2]=38868;f[Fa>>2]=ic;f[Ga>>2]=xb;f[Ha>>2]=Mb;f[Ia>>2]=rb;f[Ja>>2]=vb;f[Ka>>2]=hc;_U(o,q,-1.0);hc=0;Zb=0.0;do{Zb=Zb+ +n[ic+(hc<<2)>>2];hc=hc+1|0}while((hc|0)!=(sb|0));if(Zb<Ob){mc=lc;nc=Zb;oc=gc;pc=fc}else{mc=Bb;nc=Ob;oc=fc;pc=gc}ec=ec+1|0;if((ec|0)>=3){qc=mc;rc=nc;sc=oc;tc=pc;break}else{Bb=mc;Ob=nc;fc=oc;gc=pc}}}else{gc=pa;fc=f[gc+4>>2]|0;Bb=W1a(f[gc>>2]|0,0,-130063606,0)|0;gc=C1a(Bb|0,J|0,fc|0,0)|0;fc=J;Bb=W1a(gc|0,0,-130063606,0)|0;gc=C1a(Bb|0,J|0,fc|0,0)|0;fc=pa;f[fc>>2]=gc;f[fc+4>>2]=J;f[o>>2]=0;f[Ea>>2]=sb;fc=Cb;f[q>>2]=38868;f[Fa>>2]=fc;f[Ga>>2]=xb;f[Ha>>2]=Mb;f[Ia>>2]=rb;f[Ja>>2]=vb;f[Ka>>2]=0;_U(o,q,-1.0);if(wb){gc=0;Ob=0.0;do{Ob=Ob+ +n[fc+(gc<<2)>>2];gc=gc+1|0}while((gc|0)!=(sb|0));if(Ob<1797693134862315708145274.0e284){uc=Ob;fa=97}else{vc=-1;wc=1797693134862315708145274.0e284;xc=zb;yc=Cb}}else{uc=0.0;fa=97}if((fa|0)==97){fa=0;vc=0;wc=uc;xc=Cb;yc=zb}gc=pa;fc=f[gc+4>>2]|0;Bb=W1a(f[gc>>2]|0,0,-130063606,0)|0;gc=C1a(Bb|0,J|0,fc|0,0)|0;fc=J;Bb=W1a(gc|0,0,-130063606,0)|0;gc=C1a(Bb|0,J|0,fc|0,0)|0;fc=pa;f[fc>>2]=gc;f[fc+4>>2]=J;f[o>>2]=0;f[Ea>>2]=sb;fc=yc;f[q>>2]=38868;f[Fa>>2]=fc;f[Ga>>2]=xb;f[Ha>>2]=Mb;f[Ia>>2]=rb;f[Ja>>2]=vb;f[Ka>>2]=0;_U(o,q,-1.0);if(wb){gc=0;Db=0.0;while(1){zc=Db+ +n[fc+(gc<<2)>>2];gc=gc+1|0;if((gc|0)==(sb|0)){Ac=zc;break}else Db=zc}}else Ac=0.0;if(Ac<wc){Bc=0;Cc=Ac;Dc=yc;Ec=xc}else{Bc=vc;Cc=wc;Dc=xc;Ec=yc}gc=pa;fc=f[gc+4>>2]|0;Bb=W1a(f[gc>>2]|0,0,-130063606,0)|0;gc=C1a(Bb|0,J|0,fc|0,0)|0;fc=J;Bb=W1a(gc|0,0,-130063606,0)|0;gc=C1a(Bb|0,J|0,fc|0,0)|0;fc=pa;f[fc>>2]=gc;f[fc+4>>2]=J;f[o>>2]=0;f[Ea>>2]=sb;fc=Ec;f[q>>2]=38868;f[Fa>>2]=fc;f[Ga>>2]=xb;f[Ha>>2]=Mb;f[Ia>>2]=rb;f[Ja>>2]=vb;f[Ka>>2]=0;_U(o,q,-1.0);if(wb){gc=0;Db=0.0;while(1){Ob=Db+ +n[fc+(gc<<2)>>2];gc=gc+1|0;if((gc|0)==(sb|0)){Fc=Ob;break}else Db=Ob}}else Fc=0.0;if(!(Fc<Cc)){qc=Bc;rc=Cc;sc=Dc;tc=Ec;break}qc=0;rc=Fc;sc=Ec;tc=Dc}while(0);f[_b+(yb<<2)>>2]=qc;yb=yb+1|0;if((yb|0)>=(c|0))break;else{Mb=Lb;Lb=sc;Ub=rc;Cb=tc;zb=Mb}}}do if(g){zb=f[V>>2]|0;Cb=f[f[_>>2]>>2]|0;if((rb|0)>0)Gc=0;else break;do{Lb=xb+((Y(f[_b+(Gc<<2)>>2]|0,vb)|0)<<2)|0;yb=zb+(Y(Gc,Cb)|0)|0;sb=0;do{f[yb+(sb<<2)>>2]=f[Lb+(sb<<2)>>2];sb=sb+1|0}while((sb|0)!=(rb|0));Gc=Gc+1|0}while((Gc|0)!=(c|0))}while(0);rb=f[m>>2]|0;if(rb|0){vb=f[Aa>>2]|0;if((vb|0)!=(rb|0))f[Aa>>2]=vb+(~((vb+-4-rb|0)>>>2)<<2);PYa(rb)}rb=f[l>>2]|0;if(rb|0){vb=f[ya>>2]|0;if((vb|0)!=(rb|0))f[ya>>2]=vb+(~((vb+-4-rb|0)>>>2)<<2);PYa(rb)}Fb=ob}while(0);nb=nb+1|0;rb=(nb|0)==(kb|0)|Fb<=ta;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;gL(D,k)|0;vb=f[Pa>>2]|0;f[k>>2]=0;f[Qa>>2]=O;f[l>>2]=38888;f[Ra>>2]=vb;f[Sa>>2]=ea;f[Ta>>2]=v;f[Ua>>2]=y;b[Va>>0]=rb&1;_U(k,l,-1.0);f[Wa>>2]=0;f[Xa>>2]=0;f[k>>2]=16842752;f[Ya>>2]=D;VY(E,k);Hc=+p[E>>3];if(rb)break;else ob=Fb}if(Hc<sa){if(dT(i)|0)eL(y,i);nb=fb;f[nb>>2]=0;f[nb+4>>2]=0;f[k>>2]=33619968;f[gb>>2]=x;eL(w,k);Ic=Hc}else Ic=sa;lb=lb+1|0;if((lb|0)>=(ua|0)){Jc=Ic;break a}else sa=Ic}if((fa|0)==66)gXa(l);else if((fa|0)==70)gXa(m)}else Jc=1797693134862315708145274.0e284;while(0);m=D+36|0;fa=f[m>>2]|0;if(fa|0?(l=fa+12|0,fa=f[l>>2]|0,f[l>>2]=fa+-1,(fa|0)==1):0)CR(D);f[m>>2]=0;m=D+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[ka>>2]|0)>0){m=f[na>>2]|0;na=0;do{f[m+(na<<2)>>2]=0;na=na+1|0}while((na|0)<(f[ka>>2]|0))}ka=f[la>>2]|0;if((ka|0)!=(oa|0))ZF(ka);ka=f[C>>2]|0;if(ka|0){C=f[ma>>2]|0;if((C|0)!=(ka|0))f[ma>>2]=C+(~((C+-8-ka|0)>>>3)<<3);PYa(ka)}ka=f[B>>2]|0;if(ka|0){B=f[I>>2]|0;if((B|0)!=(ka|0))f[I>>2]=B+(~((B+-4-ka|0)>>>2)<<2);PYa(ka)}ka=A+36|0;B=f[ka>>2]|0;if(B|0?(I=B+12|0,B=f[I>>2]|0,f[I>>2]=B+-1,(B|0)==1):0)CR(A);f[ka>>2]=0;ka=A+16|0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;if((f[$>>2]|0)>0){ka=f[ha>>2]|0;ha=0;do{f[ka+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[$>>2]|0))}$=f[ia>>2]|0;if(($|0)!=(ga|0))ZF($);$=z+36|0;ga=f[$>>2]|0;do if(ga|0){ia=ga+12|0;ha=f[ia>>2]|0;f[ia>>2]=ha+-1;if((ha|0)!=1)break;CR(z)}while(0);f[$>>2]=0;$=z+16|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[W>>2]|0)>0){$=f[aa>>2]|0;aa=0;do{f[$+(aa<<2)>>2]=0;aa=aa+1|0}while((aa|0)<(f[W>>2]|0))}W=f[ba>>2]|0;if((W|0)!=(X|0))ZF(W);W=y+36|0;X=f[W>>2]|0;do if(X|0){ba=X+12|0;aa=f[ba>>2]|0;f[ba>>2]=aa+-1;if((aa|0)!=1)break;CR(y)}while(0);f[W>>2]=0;W=y+16|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[da>>2]|0)>0){W=f[ca>>2]|0;ca=0;do{f[W+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[da>>2]|0))}da=f[_>>2]|0;if((da|0)!=(Z|0))ZF(da);da=x+36|0;Z=f[da>>2]|0;do if(Z|0){_=Z+12|0;ca=f[_>>2]|0;f[_>>2]=ca+-1;if((ca|0)!=1)break;CR(x)}while(0);f[da>>2]=0;da=x+16|0;Z=x+4|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[Z>>2]|0)>0){da=f[x+40>>2]|0;ca=0;do{f[da+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[Z>>2]|0))}Z=f[x+44>>2]|0;if((Z|0)!=(x+48|0))ZF(Z);Z=w+36|0;x=f[Z>>2]|0;do if(x|0){ca=x+12|0;da=f[ca>>2]|0;f[ca>>2]=da+-1;if((da|0)!=1)break;CR(w)}while(0);f[Z>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[R>>2]|0)>0){H=f[M>>2]|0;M=0;do{f[H+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[R>>2]|0))}R=f[L>>2]|0;if((R|0)!=(N|0))ZF(R);R=v+36|0;N=f[R>>2]|0;do if(N|0){L=N+12|0;M=f[L>>2]|0;f[L>>2]=M+-1;if((M|0)!=1)break;CR(v)}while(0);f[R>>2]=0;R=v+4|0;f[ra>>2]=0;f[ra+4>>2]=0;f[ra+8>>2]=0;f[ra+12>>2]=0;if((f[R>>2]|0)>0){ra=f[v+40>>2]|0;N=0;do{f[ra+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[R>>2]|0))}R=f[e>>2]|0;if((R|0)!=(v+48|0))ZF(R);R=t+36|0;v=f[R>>2]|0;do if(v|0){e=v+12|0;N=f[e>>2]|0;f[e>>2]=N+-1;if((N|0)!=1)break;CR(t)}while(0);f[R>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[P>>2]|0)>0){G=f[t+40>>2]|0;t=0;do{f[G+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[P>>2]|0))}P=f[K>>2]|0;if((P|0)!=(F|0))ZF(P);if(!(f[r+4>>2]|0)){u=j;return +Jc}u=j;return +Jc}function TM(a){a=a|0;PYa(a);return}function UM(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0.0,C=0,D=0.0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;g=f[c>>2]|0;h=f[g+8>>2]|0;i=f[g+12>>2]|0;if((d|0)>=(e|0))return;j=a+12|0;k=(h|0)>0;l=(i|0)>0;m=a+4|0;o=a+8|0;if(b[a+20>>0]|0){a=f[o>>2]|0;q=f[m>>2]|0;r=d;s=g;while(1){g=f[j>>2]|0;t=(f[g+16>>2]|0)+(Y(f[f[g+44>>2]>>2]|0,r)|0)|0;g=(f[s+16>>2]|0)+(Y(f[f[s+44>>2]>>2]|0,f[a+(r<<2)>>2]|0)|0)|0;if(l){u=0;v=0.0;while(1){w=+n[t+(u<<2)>>2]-+n[g+(u<<2)>>2];x=v+w*w;u=u+1|0;if((u|0)==(i|0)){y=x;break}else v=x}}else y=0.0;p[q+(r<<3)>>3]=y;u=r+1|0;if((u|0)==(e|0))break;r=u;s=f[c>>2]|0}return}s=f[m>>2]|0;m=f[o>>2]|0;o=d;do{d=f[j>>2]|0;r=(f[d+16>>2]|0)+(Y(f[f[d+44>>2]>>2]|0,o)|0)|0;a:do if(k){d=f[c>>2]|0;q=f[d+16>>2]|0;a=f[f[d+44>>2]>>2]|0;if(l){z=0;A=0;B=1797693134862315708145274.0e284}else{d=0;u=0;y=1797693134862315708145274.0e284;while(1){g=y>0.0;t=g?d:u;v=g?0.0:y;d=d+1|0;if((d|0)==(h|0)){C=t;D=v;break a}else{u=t;y=v}}}while(1){u=q+(Y(a,z)|0)|0;d=0;y=0.0;do{v=+n[r+(d<<2)>>2]-+n[u+(d<<2)>>2];y=y+v*v;d=d+1|0}while((d|0)!=(i|0));v=y;d=B>v;u=d?z:A;x=d?v:B;z=z+1|0;if((z|0)==(h|0)){C=u;D=x;break}else{A=u;B=x}}}else{C=0;D=1797693134862315708145274.0e284}while(0);p[s+(o<<3)>>3]=D;f[m+(o<<2)>>2]=C;o=o+1|0}while((o|0)!=(e|0));return}function VM(a){a=a|0;PYa(a);return}function WM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0;c=u;u=u+16|0;d=c+8|0;e=c;_$(d,38900);g=f[b>>2]|0;h=f[b+4>>2]|0;a:do if((g|0)<(h|0)){b=f[a+8>>2]|0;i=f[a+20>>2]|0;j=b+(f[a+24>>2]<<2)|0;k=f[a+16>>2]|0;l=f[a+12>>2]|0;m=f[a+4>>2]|0;if((k|0)>0)o=g;else{p=g;while(1){n[e>>2]=0.0;q=l+(p<<2)|0;f[m+(p<<2)>>2]=f[(+n[q>>2]<0.0?q:e)>>2];p=p+1|0;if((p|0)==(h|0))break a}}do{p=b+((Y(i,o)|0)<<2)|0;q=0;r=0.0;do{s=+n[p+(q<<2)>>2]-+n[j+(q<<2)>>2];r=r+s*s;q=q+1|0}while((q|0)!=(k|0));n[e>>2]=r;q=l+(o<<2)|0;f[m+(o<<2)>>2]=f[(+n[q>>2]<r?q:e)>>2];o=o+1|0}while((o|0)!=(h|0))}while(0);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function XM(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=+j;k=+k;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0,I=0,K=0,N=0,O=0,P=0.0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0.0,sa=0,ta=0,ua=0.0,va=0,wa=0,xa=0.0,ya=0,za=0.0;l=u;u=u+1104|0;m=l;o=m+8|0;f[m>>2]=o;q=m+4|0;f[q>>2]=h;if(h>>>0>136){r=OYa(h>>>0>536870911?-1:h<<3)|0;f[m>>2]=r;s=r}else s=o;r=(g|0)>30?g:30;t=b>>>2;b=e>>>2;e=(h|0)>0;a:do if(e){v=(d|0)==0;w=h<<2;if((g|0)>0)x=0;else{y=0;while(1){z=Y(b,y)|0;p[s+(y<<3)>>3]=0.0;if(!v){F1a(d+(z<<2)|0,0,w|0)|0;n[d+(z+y<<2)>>2]=1.0}y=y+1|0;if((y|0)==(h|0))break a}}do{y=Y(b,x)|0;z=d+(y<<2)|0;A=Y(x,t)|0;B=0;C=0.0;do{D=+n[a+(B+A<<2)>>2];C=C+D*D;B=B+1|0}while((B|0)!=(g|0));p[s+(x<<3)>>3]=C;if(!v){F1a(z|0,0,w|0)|0;n[d+(y+x<<2)>>2]=1.0}x=x+1|0}while((x|0)!=(h|0))}while(0);b:do if((r|0)>0){x=h+-1|0;w=(h|0)>1;v=(g|0)>0;D=k;B=(d|0)==0;A=0;do{if(w){E=0;F=0}else break b;while(1){G=F;F=F+1|0;if((F|0)<(h|0)){H=a+((Y(G,t)|0)<<2)|0;I=s+(G<<3)|0;K=d+((Y(G,b)|0)<<2)|0;G=E;N=F;while(1){O=a+((Y(N,t)|0)<<2)|0;P=+p[I>>3];Q=s+(N<<3)|0;R=+p[Q>>3];if(v){S=0;T=0.0;while(1){U=T+ +n[H+(S<<2)>>2]*+n[O+(S<<2)>>2];S=S+1|0;if((S|0)==(g|0)){V=U;break}else T=U}}else V=0.0;if(!(+L(+V)<=D*+M(+(P*R)))){T=V*2.0;U=P-R;W=+L(+T);X=+L(+U);if(!(W>X))if(U!=U|0.0!=0.0|U==0.0)Z=0.0;else{_=W/X;$=X;aa=_*_;ba=32}else{_=X/W;$=W;aa=_*_;ba=32}if((ba|0)==32){ba=0;Z=$*+M(+(aa+1.0))}if(U<0.0){_=+M(+((Z-U)*.5/Z));ca=T/(Z*_*2.0);da=_}else{_=+M(+((U+Z)/(Z*2.0)));ca=_;da=T/(Z*_*2.0)}if(v){_=0.0;T=0.0;S=0;while(1){ea=H+(S<<2)|0;U=+n[ea>>2];fa=O+(S<<2)|0;W=+n[fa>>2];X=ca*U+da*W;ga=ca*W-da*U;n[ea>>2]=X;n[fa>>2]=ga;U=X;X=_+U*U;U=ga;ga=T+U*U;S=S+1|0;if((S|0)==(g|0)){ha=X;ia=ga;break}else{_=X;T=ga}}}else{ha=0.0;ia=0.0}p[I>>3]=ha;p[Q>>3]=ia;if(!B?(S=d+((Y(N,b)|0)<<2)|0,e):0){O=0;do{fa=K+(O<<2)|0;T=+n[fa>>2];ea=S+(O<<2)|0;_=+n[ea>>2];n[fa>>2]=ca*T+da*_;n[ea>>2]=ca*_-da*T;O=O+1|0}while((O|0)!=(h|0));ja=1}else ja=1}else ja=G;N=N+1|0;if((N|0)==(h|0)){ka=ja;break}else G=ja}}else ka=E;if((F|0)==(x|0))break;else E=ka}A=A+1|0}while(ka&(A|0)<(r|0))}while(0);if(e){if((g|0)>0){r=0;do{ka=Y(r,t)|0;E=0;da=0.0;do{ca=+n[a+(E+ka<<2)>>2];da=da+ca*ca;E=E+1|0}while((E|0)!=(g|0));ca=+M(+da);p[s+(r<<3)>>3]=ca;r=r+1|0}while((r|0)!=(h|0))}else F1a(s|0,0,h<<3|0)|0;r=h+-1|0;c:do if((h|0)>1){E=(g|0)>0;if(!d){ka=0;while(1){F=ka;ka=ka+1|0;if((ka|0)<(h|0)){ja=F;ba=ka;while(1){A=+p[s+(ja<<3)>>3]<+p[s+(ba<<3)>>3]?ba:ja;ba=ba+1|0;if((ba|0)==(h|0)){la=A;break}else ja=A}}else la=F;if((F|0)!=(la|0)){ja=s+(F<<3)|0;ba=s+(la<<3)|0;ca=+p[ja>>3];p[ja>>3]=+p[ba>>3];p[ba>>3]=ca}if((ka|0)==(r|0))break c}}else ma=0;do{ka=ma;ma=ma+1|0;if((ma|0)<(h|0)){ba=ka;ja=ma;while(1){A=+p[s+(ba<<3)>>3]<+p[s+(ja<<3)>>3]?ja:ba;ja=ja+1|0;if((ja|0)==(h|0)){na=A;break}else ba=A}}else na=ka;if((ka|0)!=(na|0)){ba=s+(ka<<3)|0;ja=s+(na<<3)|0;da=+p[ba>>3];p[ba>>3]=+p[ja>>3];p[ja>>3]=da;if(E){ja=Y(ka,t)|0;ba=Y(na,t)|0;F=0;do{A=a+(F+ja<<2)|0;x=a+(F+ba<<2)|0;B=f[A>>2]|0;f[A>>2]=f[x>>2];f[x>>2]=B;F=F+1|0}while((F|0)!=(g|0))}F=Y(ka,b)|0;ba=Y(na,b)|0;ja=0;do{B=d+(ja+F<<2)|0;x=d+(ja+ba<<2)|0;A=f[B>>2]|0;f[B>>2]=f[x>>2];f[x>>2]=A;ja=ja+1|0}while((ja|0)!=(h|0))}}while((ma|0)!=(r|0))}while(0);if(e){e=0;do{n[c+(e<<2)>>2]=+p[s+(e<<3)>>3];e=e+1|0}while((e|0)!=(h|0))}}if((d|0)!=0&(i|0)>0){d=(g|0)>0;da=1.0/+(g|0);ca=-da;ia=k*100.0;e=305419896;c=0;r=0;while(1){if((r|0)<(h|0))oa=+p[s+(r<<3)>>3];else oa=0.0;if(!(oa<=j)){pa=e;qa=c;ra=oa}else{ma=Y(r,t)|0;b=(r|0)>0;na=e;la=c;E=0;while(1){if(d){ja=na;ba=la;F=0;while(1){ka=W1a(ja|0,0,-130063606,0)|0;A=C1a(ka|0,J|0,ba|0,0)|0;ka=J;n[a+(F+ma<<2)>>2]=(A&256|0)!=0|0!=0?da:ca;F=F+1|0;if((F|0)==(g|0)){sa=A;ta=ka;break}else{ja=A;ba=ka}}}else{sa=na;ta=la}d:do if(b){if(d){ba=0;do{ja=Y(ba,t)|0;F=0;k=0.0;do{k=k+ +n[a+(F+ma<<2)>>2]*+n[a+(F+ja<<2)>>2];F=F+1|0}while((F|0)!=(g|0));ua=0.0;va=0;do{F=a+(va+ma<<2)|0;ha=+n[F>>2]-k*+n[a+(va+ja<<2)>>2];n[F>>2]=ha;ua=ua+ +L(+ha);va=va+1|0}while((va|0)!=(g|0));k=ua>ia?1.0/ua:0.0;ja=0;do{F=a+(ja+ma<<2)|0;n[F>>2]=k*+n[F>>2];ja=ja+1|0}while((ja|0)!=(g|0));ba=ba+1|0}while((ba|0)!=(r|0))}else{ba=0;do ba=ba+1|0;while((ba|0)!=(r|0))}if(b){if(d)wa=0;else{ba=0;while(1){ba=ba+1|0;if((ba|0)==(r|0))break d}}do{ba=Y(wa,t)|0;ja=0;k=0.0;do{k=k+ +n[a+(ja+ma<<2)>>2]*+n[a+(ja+ba<<2)>>2];ja=ja+1|0}while((ja|0)!=(g|0));xa=0.0;ya=0;do{ja=a+(ya+ma<<2)|0;ha=+n[ja>>2]-k*+n[a+(ya+ba<<2)>>2];n[ja>>2]=ha;xa=xa+ +L(+ha);ya=ya+1|0}while((ya|0)!=(g|0));k=xa>ia?1.0/xa:0.0;ba=0;do{ja=a+(ba+ma<<2)|0;n[ja>>2]=k*+n[ja>>2];ba=ba+1|0}while((ba|0)!=(g|0));wa=wa+1|0}while((wa|0)!=(r|0))}}while(0);if(d){ba=0;k=0.0;while(1){ha=+n[a+(ba+ma<<2)>>2];Z=k+ha*ha;ba=ba+1|0;if((ba|0)==(g|0)){za=Z;break}else k=Z}}else za=0.0;k=+M(+za);if(!(k<=j)|(E|0)>98){pa=sa;qa=ta;ra=k;break}else{na=sa;la=ta;E=E+1|0}}}k=ra>j?1.0/ra:0.0;if(d){E=Y(r,t)|0;la=0;do{na=a+(la+E<<2)|0;n[na>>2]=k*+n[na>>2];la=la+1|0}while((la|0)!=(g|0))}r=r+1|0;if((r|0)==(i|0))break;else{e=pa;c=qa}}}qa=f[m>>2]|0;if((qa|0)==(o|0)){u=l;return}if(qa|0)QYa(qa);f[m>>2]=o;f[q>>2]=136;u=l;return}function YM(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=+j;k=+k;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,N=0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0,aa=0.0,ba=0.0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0;l=u;u=u+1104|0;m=l;n=m+8|0;f[m>>2]=n;o=m+4|0;f[o>>2]=h;if(h>>>0>136){q=OYa(h>>>0>536870911?-1:h<<3)|0;f[m>>2]=q;r=q}else r=n;q=(g|0)>30?g:30;s=b>>>3;b=e>>>3;e=(h|0)>0;a:do if(e){t=(d|0)==0;v=h<<3;if((g|0)<=0)if(t){F1a(r|0,0,v|0)|0;break}else{w=0;while(1){x=Y(b,w)|0;p[r+(w<<3)>>3]=0.0;F1a(d+(x<<3)|0,0,v|0)|0;p[d+(x+w<<3)>>3]=1.0;w=w+1|0;if((w|0)==(h|0))break a}}else y=0;do{w=Y(b,y)|0;x=d+(w<<3)|0;z=Y(y,s)|0;A=0;B=0.0;do{C=+p[a+(A+z<<3)>>3];B=B+C*C;A=A+1|0}while((A|0)!=(g|0));p[r+(y<<3)>>3]=B;if(!t){F1a(x|0,0,v|0)|0;p[d+(w+y<<3)>>3]=1.0}y=y+1|0}while((y|0)!=(h|0))}while(0);b:do if((q|0)>0){y=h+-1|0;v=(h|0)>1;t=(g|0)>0;A=(d|0)==0;z=0;do{if(v){D=0;E=0}else break b;while(1){F=E;E=E+1|0;if((E|0)<(h|0)){G=a+((Y(F,s)|0)<<3)|0;H=r+(F<<3)|0;I=d+((Y(F,b)|0)<<3)|0;F=D;K=E;while(1){N=a+((Y(K,s)|0)<<3)|0;C=+p[H>>3];O=r+(K<<3)|0;P=+p[O>>3];if(t){Q=0;R=0.0;while(1){S=R+ +p[G+(Q<<3)>>3]*+p[N+(Q<<3)>>3];Q=Q+1|0;if((Q|0)==(g|0)){T=S;break}else R=S}}else T=0.0;if(!(+L(+T)<=+M(+(C*P))*k)){R=T*2.0;S=C-P;U=+L(+R);V=+L(+S);if(!(U>V))if(S!=S|0.0!=0.0|S==0.0)W=0.0;else{X=U/V;Z=V;_=X*X;$=32}else{X=V/U;Z=U;_=X*X;$=32}if(($|0)==32){$=0;W=Z*+M(+(_+1.0))}if(S<0.0){X=+M(+((W-S)*.5/W));aa=R/(W*X*2.0);ba=X}else{X=+M(+((S+W)/(W*2.0)));aa=X;ba=R/(W*X*2.0)}if(t){X=0.0;R=0.0;Q=0;while(1){ca=G+(Q<<3)|0;S=+p[ca>>3];da=N+(Q<<3)|0;U=+p[da>>3];V=aa*S+ba*U;ea=aa*U-ba*S;p[ca>>3]=V;p[da>>3]=ea;S=X+V*V;V=R+ea*ea;Q=Q+1|0;if((Q|0)==(g|0)){fa=S;ga=V;break}else{X=S;R=V}}}else{fa=0.0;ga=0.0}p[H>>3]=fa;p[O>>3]=ga;if(!A?(Q=d+((Y(K,b)|0)<<3)|0,e):0){N=0;do{da=I+(N<<3)|0;R=+p[da>>3];ca=Q+(N<<3)|0;X=+p[ca>>3];p[da>>3]=aa*R+ba*X;p[ca>>3]=aa*X-ba*R;N=N+1|0}while((N|0)!=(h|0));ha=1}else ha=1}else ha=F;K=K+1|0;if((K|0)==(h|0)){ia=ha;break}else F=ha}}else ia=D;if((E|0)==(y|0))break;else D=ia}z=z+1|0}while(ia&(z|0)<(q|0))}while(0);if(e){if((g|0)>0){q=0;do{ia=Y(q,s)|0;D=0;ba=0.0;do{aa=+p[a+(D+ia<<3)>>3];ba=ba+aa*aa;D=D+1|0}while((D|0)!=(g|0));aa=+M(+ba);p[r+(q<<3)>>3]=aa;q=q+1|0}while((q|0)!=(h|0))}else F1a(r|0,0,h<<3|0)|0;q=h+-1|0;c:do if((h|0)>1){D=(g|0)>0;if(!d){ia=0;while(1){E=ia;ia=ia+1|0;if((ia|0)<(h|0)){ha=E;$=ia;while(1){z=+p[r+(ha<<3)>>3]<+p[r+($<<3)>>3]?$:ha;$=$+1|0;if(($|0)==(h|0)){ja=z;break}else ha=z}}else ja=E;if((E|0)!=(ja|0)){ha=r+(E<<3)|0;$=r+(ja<<3)|0;aa=+p[ha>>3];p[ha>>3]=+p[$>>3];p[$>>3]=aa}if((ia|0)==(q|0))break c}}else ka=0;do{ia=ka;ka=ka+1|0;if((ka|0)<(h|0)){$=ia;ha=ka;while(1){z=+p[r+($<<3)>>3]<+p[r+(ha<<3)>>3]?ha:$;ha=ha+1|0;if((ha|0)==(h|0)){la=z;break}else $=z}}else la=ia;if((ia|0)!=(la|0)){$=r+(ia<<3)|0;ha=r+(la<<3)|0;ba=+p[$>>3];p[$>>3]=+p[ha>>3];p[ha>>3]=ba;if(D){ha=Y(ia,s)|0;$=Y(la,s)|0;E=0;do{z=a+(E+ha<<3)|0;y=a+(E+$<<3)|0;ba=+p[z>>3];p[z>>3]=+p[y>>3];p[y>>3]=ba;E=E+1|0}while((E|0)!=(g|0))}E=Y(ia,b)|0;$=Y(la,b)|0;ha=0;do{y=d+(ha+E<<3)|0;z=d+(ha+$<<3)|0;ba=+p[y>>3];p[y>>3]=+p[z>>3];p[z>>3]=ba;ha=ha+1|0}while((ha|0)!=(h|0))}}while((ka|0)!=(q|0))}while(0);if(e){e=0;do{p[c+(e<<3)>>3]=+p[r+(e<<3)>>3];e=e+1|0}while((e|0)!=(h|0))}}if((d|0)!=0&(i|0)>0){d=(g|0)>0;ba=1.0/+(g|0);aa=-ba;ga=k*100.0;e=305419896;c=0;q=0;while(1){if((q|0)<(h|0))ma=+p[r+(q<<3)>>3];else ma=0.0;if(!(ma<=j)){na=e;oa=c;pa=ma}else{ka=Y(q,s)|0;b=(q|0)>0;la=e;ja=c;D=0;while(1){if(d){ha=la;$=ja;E=0;while(1){ia=W1a(ha|0,0,-130063606,0)|0;z=C1a(ia|0,J|0,$|0,0)|0;ia=J;p[a+(E+ka<<3)>>3]=(z&256|0)!=0|0!=0?ba:aa;E=E+1|0;if((E|0)==(g|0)){qa=z;ra=ia;break}else{ha=z;$=ia}}}else{qa=la;ra=ja}d:do if(b){if(d){$=0;do{ha=Y($,s)|0;E=0;k=0.0;do{k=k+ +p[a+(E+ka<<3)>>3]*+p[a+(E+ha<<3)>>3];E=E+1|0}while((E|0)!=(g|0));sa=0.0;ta=0;do{E=a+(ta+ka<<3)|0;fa=+p[E>>3]-k*+p[a+(ta+ha<<3)>>3];p[E>>3]=fa;sa=sa+ +L(+fa);ta=ta+1|0}while((ta|0)!=(g|0));k=sa>ga?1.0/sa:0.0;ha=0;do{E=a+(ha+ka<<3)|0;p[E>>3]=k*+p[E>>3];ha=ha+1|0}while((ha|0)!=(g|0));$=$+1|0}while(($|0)!=(q|0))}else{$=0;do $=$+1|0;while(($|0)!=(q|0))}if(b){if(d)ua=0;else{$=0;while(1){$=$+1|0;if(($|0)==(q|0))break d}}do{$=Y(ua,s)|0;ha=0;k=0.0;do{k=k+ +p[a+(ha+ka<<3)>>3]*+p[a+(ha+$<<3)>>3];ha=ha+1|0}while((ha|0)!=(g|0));va=0.0;wa=0;do{ha=a+(wa+ka<<3)|0;fa=+p[ha>>3]-k*+p[a+(wa+$<<3)>>3];p[ha>>3]=fa;va=va+ +L(+fa);wa=wa+1|0}while((wa|0)!=(g|0));k=va>ga?1.0/va:0.0;$=0;do{ha=a+($+ka<<3)|0;p[ha>>3]=k*+p[ha>>3];$=$+1|0}while(($|0)!=(g|0));ua=ua+1|0}while((ua|0)!=(q|0))}}while(0);if(d){$=0;k=0.0;while(1){fa=+p[a+($+ka<<3)>>3];W=k+fa*fa;$=$+1|0;if(($|0)==(g|0)){xa=W;break}else k=W}}else xa=0.0;k=+M(+xa);if(!(k<=j)|(D|0)>98){na=qa;oa=ra;pa=k;break}else{la=qa;ja=ra;D=D+1|0}}}k=pa>j?1.0/pa:0.0;if(d){D=Y(q,s)|0;ja=0;do{la=a+(ja+D<<3)|0;p[la>>3]=k*+p[la>>3];ja=ja+1|0}while((ja|0)!=(g|0))}q=q+1|0;if((q|0)==(i|0))break;else{e=na;c=oa}}}oa=f[m>>2]|0;if((oa|0)==(n|0)){u=l;return}if(oa|0)QYa(oa);f[m>>2]=n;f[o>>2]=136;u=l;return}function ZM(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0.0,P=0,Q=0,R=0,S=0.0;c=u;u=u+1184|0;d=c+1168|0;e=c+1112|0;g=c+72|0;h=c+16|0;i=c;_$(d,38920);do if((NS(a)|0)==65536){j=f[a+4>>2]|0;f[e>>2]=f[j>>2];k=e+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=e+8|0;f[m>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];o=e+16|0;f[o>>2]=f[j+16>>2];f[e+20>>2]=f[j+20>>2];f[e+24>>2]=f[j+24>>2];f[e+28>>2]=f[j+28>>2];f[e+32>>2]=f[j+32>>2];q=f[j+36>>2]|0;f[e+36>>2]=q;f[e+40>>2]=m;r=e+48|0;s=e+44|0;f[s>>2]=r;f[r>>2]=0;f[e+52>>2]=0;if(q|0){t=q+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;t=f[s>>2]|0;f[t>>2]=f[l>>2];f[t+4>>2]=f[l+4>>2];v=r;w=o;x=e;y=s;z=m;break}else{f[k>>2]=0;BR(e,j);v=r;w=o;x=e;y=s;z=m;break}}else{OR(e,a,-1);v=e+48|0;w=e+16|0;x=e;y=e+44|0;z=e+8|0}while(0);a=f[x>>2]&4095;x=f[z>>2]|0;m=f[v>>2]|0;s=f[w>>2]|0;if(s){o=f[e+4>>2]|0;if((o|0)<3)A=Y(f[e+12>>2]|0,x)|0;else{r=f[e+40>>2]|0;j=0;k=1;while(1){l=Y(f[r+(j<<2)>>2]|0,k)|0;j=j+1|0;if((j|0)==(o|0)){A=l;break}else k=l}}if(!((o|0)==0|(A|0)==0))B=x;else C=14}else C=14;if((C|0)==14){f[g>>2]=0;f[g+4>>2]=0;D=c$(g,12)|0;E=164116;F=D+12|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));j$(-215,g,164129,164068,757);d$(g);B=f[z>>2]|0}if(!((a+-5|0)>>>0<2?(B|0)==(f[e+12>>2]|0):0)){f[g>>2]=0;f[g+4>>2]=0;D=c$(g,48)|0;E=164141;F=D+48|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));j$(-215,g,164129,164068,758);d$(g)}E=(x|0)==2;a:do if((a|0)==5){if(E){D=s+m|0;G=+n[s>>2]*+n[D+4>>2]-+n[s+4>>2]*+n[D>>2];break}switch(x|0){case 3:{D=s+m|0;H=+n[D+4>>2];F=s+(m<<1)|0;I=+n[F+8>>2];J=+n[D+8>>2];K=+n[F+4>>2];L=+n[D>>2];M=+n[F>>2];G=+n[s+8>>2]*(K*L-H*M)+(+n[s>>2]*(H*I-J*K)-+n[s+4>>2]*(I*L-J*M));break a;break}case 1:{G=+n[s>>2];break a;break}default:{F=(Y(x,x)|0)<<2;D=g+8|0;f[g>>2]=D;B=g+4|0;f[B>>2]=F;if(F>>>0>1032){z=OYa(F)|0;f[g>>2]=z;N=z}else N=D;z=h+4|0;f[z>>2]=2;F=h+8|0;f[F>>2]=x;f[h+12>>2]=x;C=h+16|0;f[C>>2]=N;f[h+20>>2]=N;A=h+24|0;o=h+40|0;k=A+8|0;f[k>>2]=0;f[k+4>>2]=0;f[o>>2]=F;k=h+48|0;j=h+44|0;f[j>>2]=k;r=x<<2;f[h>>2]=1124024325;f[k>>2]=r;f[h+52>>2]=4;l=N+(Y(f[F>>2]|0,r)|0)|0;f[h+28>>2]=l;f[A>>2]=l+(0-r)+r;r=i+8|0;f[r>>2]=0;f[r+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=h;eL(e,i);r=gU(f[C>>2]|0,f[k>>2]|0,x,0,0,0)|0;M=+(r|0);if((r|0)!=0&(x|0)>0){r=f[C>>2]|0;l=f[f[j>>2]>>2]|0;A=0;J=M;while(1){F=r+(Y(l,A)|0)+(A<<2)|0;L=J*+n[F>>2];A=A+1|0;if((A|0)==(x|0)){O=L;break}else J=L}}else O=M;A=h+36|0;l=f[A>>2]|0;if(l|0?(r=l+12|0,l=f[r>>2]|0,f[r>>2]=l+-1,(l|0)==1):0)CR(h);f[A>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[z>>2]|0)>0){A=f[o>>2]|0;l=0;do{f[A+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[z>>2]|0))}z=f[j>>2]|0;if((z|0)!=(k|0))ZF(z);z=f[g>>2]|0;if((z|0)!=(D|0)){if(z|0)QYa(z);f[g>>2]=D;f[B>>2]=1032}G=O;break a}}}else{if(E){z=s+m|0;G=+p[s>>3]*+p[z+8>>3]-+p[s+8>>3]*+p[z>>3];break}switch(x|0){case 3:{z=s+m|0;M=+p[z+8>>3];l=s+(m<<1)|0;J=+p[l+16>>3];L=+p[z+16>>3];I=+p[l+8>>3];K=+p[z>>3];H=+p[l>>3];G=+p[s+16>>3]*(I*K-M*H)+(+p[s>>3]*(M*J-L*I)-+p[s+8>>3]*(J*K-L*H));break a;break}case 1:{G=+p[s>>3];break a;break}default:{l=(Y(x,x)|0)<<3;z=g+8|0;f[g>>2]=z;A=g+4|0;f[A>>2]=l;if(l>>>0>1032){o=OYa(l)|0;f[g>>2]=o;P=o}else P=z;o=h+4|0;f[o>>2]=2;l=h+8|0;f[l>>2]=x;f[h+12>>2]=x;C=h+16|0;f[C>>2]=P;f[h+20>>2]=P;r=h+24|0;F=h+40|0;t=r+8|0;f[t>>2]=0;f[t+4>>2]=0;f[F>>2]=l;t=h+48|0;q=h+44|0;f[q>>2]=t;Q=x<<3;f[h>>2]=1124024326;f[t>>2]=Q;f[h+52>>2]=8;R=P+(Y(f[l>>2]|0,Q)|0)|0;f[h+28>>2]=R;f[r>>2]=R+(0-Q)+Q;Q=i+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=h;eL(e,i);Q=iU(f[C>>2]|0,f[t>>2]|0,x,0,0,0)|0;H=+(Q|0);if((Q|0)!=0&(x|0)>0){Q=f[C>>2]|0;R=f[f[q>>2]>>2]|0;r=0;L=H;while(1){l=Q+(Y(R,r)|0)+(r<<3)|0;K=L*+p[l>>3];r=r+1|0;if((r|0)==(x|0)){S=K;break}else L=K}}else S=H;r=h+36|0;R=f[r>>2]|0;if(R|0?(Q=R+12|0,R=f[Q>>2]|0,f[Q>>2]=R+-1,(R|0)==1):0)CR(h);f[r>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[o>>2]|0)>0){r=f[F>>2]|0;R=0;do{f[r+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[o>>2]|0))}o=f[q>>2]|0;if((o|0)!=(t|0))ZF(o);o=f[g>>2]|0;if((o|0)!=(z|0)){if(o|0)QYa(o);f[g>>2]=z;f[A>>2]=1032}G=S;break a}}}while(0);g=e+36|0;h=f[g>>2]|0;if(h|0?(x=h+12|0,h=f[x>>2]|0,f[x>>2]=h+-1,(h|0)==1):0)CR(e);f[g>>2]=0;g=e+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[g>>2]|0)>0){w=f[e+40>>2]|0;e=0;do{f[w+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[g>>2]|0))}g=f[y>>2]|0;if((g|0)!=(v|0))ZF(g);if(!(f[d+4>>2]|0)){u=c;return +G}u=c;return +G}function _M(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0.0,U=0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0;e=u;u=u+2416|0;g=e+1376|0;h=e+1368|0;i=e+1312|0;j=e+112|0;k=e+1256|0;l=e+56|0;m=e;o=e+1240|0;q=e+1224|0;r=e+1208|0;s=e+1152|0;_$(h,38940);do if((NS(a)|0)==65536){t=f[a+4>>2]|0;f[i>>2]=f[t>>2];v=i+4|0;w=t+4|0;f[v>>2]=f[w>>2];x=i+8|0;f[x>>2]=f[t+8>>2];f[i+12>>2]=f[t+12>>2];f[i+16>>2]=f[t+16>>2];f[i+20>>2]=f[t+20>>2];f[i+24>>2]=f[t+24>>2];f[i+28>>2]=f[t+28>>2];f[i+32>>2]=f[t+32>>2];y=f[t+36>>2]|0;f[i+36>>2]=y;f[i+40>>2]=x;x=i+48|0;z=i+44|0;f[z>>2]=x;f[x>>2]=0;f[i+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;x=f[z>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];A=i;break}else{f[v>>2]=0;BR(i,t);A=i;break}}else{OR(i,a,-1);A=i}while(0);a=f[A>>2]|0;A=a&4095;t=(A|0)==5;v=(A|0)==6;if((A+-5|0)>>>0>=2){f[g>>2]=0;f[g+4>>2]=0;B=c$(g,22)|0;C=164225;D=B+22|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));j$(-215,g,164248,164068,833);d$(g)}w=(a>>>3&511)+1<<(47696>>>(A<<1&14)&3);a=f[i+8>>2]|0;x=f[i+12>>2]|0;do if((d|0)==1){z=(x|0)<(a|0)?x:a;y=Y(z,a)|0;E=(Y(y+z+(Y(z,x)|0)|0,w)|0)+8|0;F=j+8|0;f[j>>2]=F;G=j+4|0;f[G>>2]=E;if(E>>>0>1032){H=OYa(E)|0;f[j>>2]=H;I=H}else I=F;$i(k,a,z,A,w+-1+I&0-w,0);H=k+16|0;E=k+44|0;$i(l,z,1,A,(f[H>>2]|0)+(Y(y,w)|0)|0,0);y=l+16|0;J=l+44|0;$i(m,z,x,A,(f[y>>2]|0)+(Y(z,w)|0)|0,0);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=i;z=q+8|0;f[z>>2]=0;f[z+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=l;z=r+8|0;f[z>>2]=0;f[z+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=k;z=s+8|0;f[z>>2]=0;f[z+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=m;_$(g,38960);$M(o,q,r,s,0);f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=l;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=m;f[s>>2]=1124007936;z=s+4|0;K=s+8|0;L=s+40|0;B=z;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[L>>2]=K;M=s+48|0;N=s+44|0;f[N>>2]=M;f[M>>2]=0;f[s+52>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=s;aN(g,o,q,r,c);O=s+36|0;P=f[O>>2]|0;if(P|0?(Q=P+12|0,P=f[Q>>2]|0,f[Q>>2]=P+-1,(P|0)==1):0)CR(s);f[O>>2]=0;O=s+16|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[z>>2]|0)>0){O=f[L>>2]|0;P=0;do{f[O+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[z>>2]|0))}z=f[N>>2]|0;if((z|0)!=(M|0))ZF(z);z=f[y>>2]|0;if(t){R=+n[z>>2];if(!(R>=1.1920928955078125e-07))S=0.0;else S=+n[z+(x+-1<<2)>>2]/R}else{R=+p[z>>3];if(!(R>=2.220446049250313e-16))S=0.0;else S=+p[z+(x+-1<<3)>>3]/R}z=m+36|0;P=f[z>>2]|0;if(P|0?(O=P+12|0,P=f[O>>2]|0,f[O>>2]=P+-1,(P|0)==1):0)CR(m);f[z>>2]=0;z=m+16|0;P=m+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[P>>2]|0)>0){z=f[m+40>>2]|0;O=0;do{f[z+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[P>>2]|0))}P=f[m+44>>2]|0;if((P|0)!=(m+48|0))ZF(P);P=l+36|0;O=f[P>>2]|0;if(O|0?(z=O+12|0,O=f[z>>2]|0,f[z>>2]=O+-1,(O|0)==1):0)CR(l);f[P>>2]=0;P=l+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[P>>2]|0)>0){O=f[l+40>>2]|0;z=0;do{f[O+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[P>>2]|0))}P=f[J>>2]|0;if((P|0)!=(l+48|0))ZF(P);P=k+36|0;z=f[P>>2]|0;if(z|0?(O=z+12|0,z=f[O>>2]|0,f[O>>2]=z+-1,(z|0)==1):0)CR(k);f[P>>2]=0;P=k+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[P>>2]|0)>0){z=f[k+40>>2]|0;O=0;do{f[z+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[P>>2]|0))}P=f[E>>2]|0;if((P|0)!=(k+48|0))ZF(P);P=f[j>>2]|0;if((P|0)!=(F|0)){if(P|0)QYa(P);f[j>>2]=F;f[G>>2]=1032}T=S}else{if((a|0)!=(x|0)){f[g>>2]=0;f[g+4>>2]=0;P=c$(g,6)|0;b[P>>0]=b[164255]|0;b[P+1>>0]=b[164256]|0;b[P+2>>0]=b[164257]|0;b[P+3>>0]=b[164258]|0;b[P+4>>0]=b[164259]|0;b[P+5>>0]=b[164260]|0;j$(-215,g,164248,164068,857);d$(g)}if((d|0)==2){P=Y(x,x)|0;O=(Y((P<<1)+x|0,w)|0)+8|0;z=g+8|0;f[g>>2]=z;H=g+4|0;f[H>>2]=O;if(O>>>0>1032){J=OYa(O)|0;f[g>>2]=J;U=J}else U=z;$i(j,x,x,A,w+-1+U&0-w,0);J=j+16|0;O=j+44|0;$i(k,x,1,A,(f[J>>2]|0)+(Y(P,w)|0)|0,0);P=k+16|0;y=k+44|0;$i(l,x,x,A,(f[P>>2]|0)+(Y(x,w)|0)|0,0);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=i;M=o+8|0;f[M>>2]=0;f[M+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=k;M=q+8|0;f[M>>2]=0;f[M+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=l;bN(m,o,q)|0;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=l;M=o+8|0;f[M>>2]=0;f[M+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=j;mS(m,o);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=k;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=j;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=l;f[s>>2]=1124007936;M=s+4|0;N=s+8|0;L=s+40|0;B=M;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[L>>2]=N;G=s+48|0;F=s+44|0;f[F>>2]=G;f[G>>2]=0;f[s+52>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=s;aN(m,o,q,r,c);E=s+36|0;K=f[E>>2]|0;if(K|0?(Q=K+12|0,K=f[Q>>2]|0,f[Q>>2]=K+-1,(K|0)==1):0)CR(s);f[E>>2]=0;E=s+16|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[M>>2]|0)>0){E=f[L>>2]|0;K=0;do{f[E+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[M>>2]|0))}M=f[F>>2]|0;if((M|0)!=(G|0))ZF(M);M=f[P>>2]|0;if(t){R=+n[M>>2];if(!(R>=1.1920928955078125e-07))V=0.0;else V=+n[M+(x+-1<<2)>>2]/R}else{R=+p[M>>3];if(!(R>=2.220446049250313e-16))V=0.0;else V=+p[M+(x+-1<<3)>>3]/R}M=l+36|0;K=f[M>>2]|0;if(K|0?(E=K+12|0,K=f[E>>2]|0,f[E>>2]=K+-1,(K|0)==1):0)CR(l);f[M>>2]=0;M=l+16|0;K=l+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[K>>2]|0)>0){M=f[l+40>>2]|0;E=0;do{f[M+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[K>>2]|0))}K=f[l+44>>2]|0;if((K|0)!=(l+48|0))ZF(K);K=k+36|0;E=f[K>>2]|0;if(E|0?(M=E+12|0,E=f[M>>2]|0,f[M>>2]=E+-1,(E|0)==1):0)CR(k);f[K>>2]=0;K=k+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[K>>2]|0)>0){E=f[k+40>>2]|0;M=0;do{f[E+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[K>>2]|0))}K=f[y>>2]|0;if((K|0)!=(k+48|0))ZF(K);K=j+36|0;M=f[K>>2]|0;do if(M|0){E=M+12|0;P=f[E>>2]|0;f[E>>2]=P+-1;if((P|0)!=1)break;CR(j)}while(0);f[K>>2]=0;M=j+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[M>>2]|0)>0){y=f[j+40>>2]|0;P=0;do{f[y+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[M>>2]|0))}M=f[O>>2]|0;if((M|0)!=(j+48|0))ZF(M);M=f[g>>2]|0;if((M|0)!=(z|0)){if(M|0)QYa(M);f[g>>2]=z;f[H>>2]=1032}T=V;break}M=(d|0)==0;P=(d|0)==3;switch(d|0){case 0:case 3:break;default:{f[g>>2]=0;f[g+4>>2]=0;B=c$(g,48)|0;C=164262;D=B+48|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));j$(-215,g,164248,164068,877);d$(g)}}pS(c,x,x,A,-1,0,0);do if((NS(c)|0)==65536){H=f[c+4>>2]|0;f[g>>2]=f[H>>2];z=g+4|0;O=H+4|0;f[z>>2]=f[O>>2];y=g+8|0;f[y>>2]=f[H+8>>2];f[g+12>>2]=f[H+12>>2];f[g+16>>2]=f[H+16>>2];f[g+20>>2]=f[H+20>>2];f[g+24>>2]=f[H+24>>2];f[g+28>>2]=f[H+28>>2];f[g+32>>2]=f[H+32>>2];J=f[H+36>>2]|0;f[g+36>>2]=J;f[g+40>>2]=y;y=g+48|0;K=g+44|0;f[K>>2]=y;f[y>>2]=0;f[g+52>>2]=0;if(J|0){y=J+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[O>>2]|0)<3){O=f[H+44>>2]|0;y=f[K>>2]|0;f[y>>2]=f[O>>2];f[y+4>>2]=f[O+4>>2];break}else{f[z>>2]=0;BR(g,H);break}}else OR(g,c,-1);while(0);a:do if((x|0)<4){H=f[i+16>>2]|0;z=f[g+16>>2]|0;O=f[i+48>>2]|0;y=f[g+48>>2]|0;b:do switch(x|0){case 2:{if(t){R=+n[H>>2];K=H+O|0;W=+n[K+4>>2];J=H+4|0;X=R*W-+n[J>>2]*+n[K>>2];if(!(X!=0.0))break b;Z=1.0/X;E=z+y|0;n[E+4>>2]=R*Z;n[z>>2]=W*Z;W=Z*-+n[K>>2];n[z+4>>2]=Z*-+n[J>>2];n[E>>2]=W;_=1;break a}else{W=+p[H>>3];E=H+O|0;Z=+p[E+8>>3];J=H+8|0;R=W*Z-+p[J>>3]*+p[E>>3];if(!(R!=0.0))break b;X=1.0/R;K=z+y|0;p[K+8>>3]=W*X;p[z>>3]=Z*X;Z=-(X*+p[E>>3]);p[z+8>>3]=-(X*+p[J>>3]);p[K>>3]=Z;_=1;break a}break}case 3:{K=O<<1;if(t){Z=+n[H>>2];J=H+O|0;X=+n[J+4>>2];E=H+K|0;W=+n[E+8>>2];R=+n[J+8>>2];$=+n[E+4>>2];aa=X*W-R*$;ba=+n[H+4>>2];ca=+n[J>>2];da=W*ca;ea=+n[E>>2];fa=R*ea;ga=+n[H+8>>2];ha=$*ca-X*ea;ia=ga*ha+(Z*aa-ba*(da-fa));if(!(ia!=0.0))break b;ja=1.0/ia;n[z>>2]=aa*ja;n[z+4>>2]=($*ga-W*ba)*ja;n[z+8>>2]=(R*ba-X*ga)*ja;E=z+y|0;n[E>>2]=(fa-da)*ja;n[E+4>>2]=(Z*W-ea*ga)*ja;n[E+8>>2]=(ca*ga-Z*R)*ja;E=z+(y<<1)|0;n[E>>2]=ha*ja;n[E+4>>2]=(ba*ea-Z*$)*ja;n[E+8>>2]=(Z*X-ba*ca)*ja;_=1;break a}else{ja=+p[H>>3];E=H+O|0;ca=+p[E+8>>3];J=H+K|0;ba=+p[J+16>>3];X=+p[E+16>>3];Z=+p[J+8>>3];$=ca*ba-X*Z;ea=+p[H+8>>3];ha=+p[E>>3];R=ba*ha;ga=+p[J>>3];W=X*ga;da=+p[H+16>>3];fa=Z*ha-ca*ga;aa=da*fa+(ja*$-ea*(R-W));if(!(aa!=0.0))break b;ia=1.0/aa;p[z>>3]=$*ia;p[z+8>>3]=(Z*da-ba*ea)*ia;p[z+16>>3]=(X*ea-ca*da)*ia;J=z+y|0;p[J>>3]=(W-R)*ia;p[J+8>>3]=(ja*ba-ga*da)*ia;p[J+16>>3]=(ha*da-ja*X)*ia;J=z+(y<<1)|0;p[J>>3]=fa*ia;p[J+8>>3]=(ea*ga-ja*Z)*ia;p[J+16>>3]=(ja*ca-ea*ha)*ia;_=1;break a}break}default:if(t){ia=+n[H>>2];if(!(ia!=0.0))break b;n[z>>2]=1.0/ia;_=1;break a}else{ia=+p[H>>3];if(!(ia!=0.0))break b;p[z>>3]=1.0/ia;_=1;break a}}while(0);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;gL(g,j)|0;_=0}else{z=Y(Y(x,w)|0,x)|0;H=j+8|0;f[j>>2]=H;y=j+4|0;f[y>>2]=z;if(z>>>0>1032){O=OYa(z)|0;f[j>>2]=O;ka=O}else ka=H;$i(k,x,x,A,ka,0);O=l+8|0;f[O>>2]=0;f[O+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=k;eL(i,l);O=l+8|0;f[O>>2]=0;f[O+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=g;p[m>>3]=1.0;O=m+8|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;f[O+16>>2]=0;f[O+20>>2]=0;kT(l,m);do if(M&t)if(!(gU(f[k+16>>2]|0,f[k+48>>2]|0,x,f[g+16>>2]|0,f[g+48>>2]|0,x)|0))la=141;else ma=1;else{if(M&v)if(!(iU(f[k+16>>2]|0,f[k+48>>2]|0,x,f[g+16>>2]|0,f[g+48>>2]|0,x)|0)){la=141;break}else{ma=1;break}O=f[k+16>>2]|0;if(P&t)na=kU(O,f[k+48>>2]|0,x,f[g+16>>2]|0,f[g+48>>2]|0,x)|0;else na=mU(O,f[k+48>>2]|0,x,f[g+16>>2]|0,f[g+48>>2]|0,x)|0;if(na)ma=1;else la=141}while(0);if((la|0)==141){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;gL(g,l)|0;ma=0}O=k+36|0;z=f[O>>2]|0;if(z|0?(J=z+12|0,z=f[J>>2]|0,f[J>>2]=z+-1,(z|0)==1):0)CR(k);f[O>>2]=0;O=k+16|0;z=k+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[z>>2]|0)>0){O=f[k+40>>2]|0;J=0;do{f[O+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[z>>2]|0))}z=f[k+44>>2]|0;if((z|0)!=(k+48|0))ZF(z);z=f[j>>2]|0;if((z|0)!=(H|0)){if(z|0)QYa(z);f[j>>2]=H;f[y>>2]=1032}_=ma}while(0);P=g+36|0;M=f[P>>2]|0;if(M|0?(z=M+12|0,M=f[z>>2]|0,f[z>>2]=M+-1,(M|0)==1):0)CR(g);f[P>>2]=0;P=g+16|0;M=g+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[M>>2]|0)>0){P=f[g+40>>2]|0;z=0;do{f[P+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[M>>2]|0))}M=f[g+44>>2]|0;if((M|0)!=(g+48|0))ZF(M);T=+(_&1)}while(0);_=i+36|0;g=f[_>>2]|0;if(g|0?(ma=g+12|0,g=f[ma>>2]|0,f[ma>>2]=g+-1,(g|0)==1):0)CR(i);f[_>>2]=0;_=i+16|0;g=i+4|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[g>>2]|0)>0){_=f[i+40>>2]|0;ma=0;do{f[_+(ma<<2)>>2]=0;ma=ma+1|0}while((ma|0)<(f[g>>2]|0))}g=f[i+44>>2]|0;if((g|0)!=(i+48|0))ZF(g);if(!(f[h+4>>2]|0)){u=e;return +T}u=e;return +T}function $M(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;h=u;u=u+1392|0;i=h+1336|0;j=h+296|0;k=h+240|0;l=h+184|0;m=h+128|0;n=h+72|0;o=h;p=h+56|0;do if((NS(a)|0)==65536){q=f[a+4>>2]|0;f[i>>2]=f[q>>2];r=i+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=i+8|0;f[t>>2]=f[q+8>>2];v=i+12|0;f[v>>2]=f[q+12>>2];f[i+16>>2]=f[q+16>>2];f[i+20>>2]=f[q+20>>2];f[i+24>>2]=f[q+24>>2];f[i+28>>2]=f[q+28>>2];f[i+32>>2]=f[q+32>>2];w=f[q+36>>2]|0;f[i+36>>2]=w;f[i+40>>2]=t;x=i+48|0;y=i+44|0;f[y>>2]=x;f[x>>2]=0;f[i+52>>2]=0;if(w|0){x=w+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;x=f[y>>2]|0;f[x>>2]=f[s>>2];f[x+4>>2]=f[s+4>>2];z=v;A=i;B=t;break}else{f[r>>2]=0;BR(i,q);z=v;A=i;B=t;break}}else{OR(i,a,-1);z=i+12|0;A=i;B=i+8|0}while(0);a=f[B>>2]|0;B=f[z>>2]|0;z=f[A>>2]&4095;if(dT(d)|0)C=1;else C=dT(e)|0;A=(z|0)==5;if((z+-5|0)>>>0>=2){f[j>>2]=0;f[j+4>>2]=0;D=c$(j,22)|0;t=164225;E=D+22|0;do{b[D>>0]=b[t>>0]|0;D=D+1|0;t=t+1|0}while((D|0)<(E|0));j$(-215,j,164656,164068,1425);d$(j)}if(!(g&2)){t=(a|0)<(B|0);v=t?B:a;q=t?a:B;F=q;G=v;H=g&4|0?v:q;I=t;J=C}else{oS(d);oS(e);C=(a|0)<(B|0);t=C?a:B;F=t;G=C?B:a;H=t;I=C;J=0}C=i+4|0;t=f[C>>2]|0;if((t|0)>0)K=f[(f[i+44>>2]|0)+(t+-1<<2)>>2]|0;else K=0;t=(Y(K,G)|0)+15&-16;a=Y(K,F)|0;K=a+15&-16;B=Y(t,H)|0;q=a+32+(Y(K,F)|0)+B|0;v=j+8|0;f[j>>2]=v;g=j+4|0;f[g>>2]=q;if(q>>>0>1032){r=OYa(q)|0;f[j>>2]=r;L=r}else L=v;r=L+15&-16;$i(k,F,G,z,r,t);L=r+B|0;$i(l,F,1,z,L,0);$i(m,H,G,z,r,t);f[n>>2]=1124007936;t=n+4|0;r=n+8|0;B=n+40|0;D=t;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[B>>2]=r;D=n+48|0;E=n+44|0;f[E>>2]=D;f[D>>2]=0;f[n+52>>2]=0;if(J){$i(o,F,F,z,L+a+15&-16,K);K=o+36|0;a=f[K>>2]|0;if(a|0){L=a+12|0;f[L>>2]=(f[L>>2]|0)+1}L=n+36|0;a=f[L>>2]|0;if(a|0?(z=a+12|0,a=f[z>>2]|0,f[z>>2]=a+-1,(a|0)==1):0)CR(n);f[L>>2]=0;a=n+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[t>>2]|0)>0){z=f[B>>2]|0;q=0;do{f[z+(q<<2)>>2]=0;q=q+1|0;M=f[t>>2]|0}while((q|0)<(M|0));f[n>>2]=f[o>>2];if((M|0)<3)N=30;else N=32}else{f[n>>2]=f[o>>2];N=30}if((N|0)==30){M=f[o+4>>2]|0;if((M|0)<3){f[t>>2]=M;f[r>>2]=f[o+8>>2];f[n+12>>2]=f[o+12>>2];r=f[o+44>>2]|0;M=f[E>>2]|0;f[M>>2]=f[r>>2];f[M+4>>2]=f[r+4>>2]}else N=32}if((N|0)==32)BR(n,o);N=o+16|0;f[a>>2]=f[N>>2];f[n+20>>2]=f[o+20>>2];f[n+24>>2]=f[o+24>>2];f[n+28>>2]=f[o+28>>2];f[n+32>>2]=f[o+32>>2];a=f[K>>2]|0;f[L>>2]=a;if(a|0?(L=a+12|0,a=f[L>>2]|0,f[L>>2]=a+-1,(a|0)==1):0)CR(o);f[K>>2]=0;K=o+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[K>>2]|0)>0){N=f[o+40>>2]|0;a=0;do{f[N+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[K>>2]|0))}K=f[o+44>>2]|0;if((K|0)!=(o+48|0))ZF(K)}if((H|0)>(F|0)){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;f[o+24>>2]=0;f[o+28>>2]=0;gL(m,o)|0}if(I){K=o+8|0;f[K>>2]=0;f[K+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=k;eL(i,o)}else{f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=i;K=p+8|0;f[K>>2]=0;f[K+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=k;mS(o,p)}p=k+16|0;K=f[p>>2]|0;if(A){A=f[n+16>>2]|0;a=J?H:0;XM(K,f[m+48>>2]|0,f[l+16>>2]|0,A,f[D>>2]|0,G,F,(A|0)==0?0:(a|0)<0?F:a,1.1754943508222875e-38,2.384185791015625e-07)}else{a=f[n+16>>2]|0;A=J?H:0;YM(K,f[m+48>>2]|0,f[l+16>>2]|0,a,f[D>>2]|0,G,F,(a|0)==0?0:(A|0)<0?F:A,2.2250738585072014e-308,2.220446049250313e-15)}eL(l,c);do if(J){c=dT(d)|0;if(I){if(c){f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=n;mS(o,d)}if(!(dT(e)|0))break;eL(m,e);break}else{if(c){f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=m;mS(o,d)}if(!(dT(e)|0))break;eL(n,e);break}}while(0);e=n+36|0;d=f[e>>2]|0;if(d|0?(o=d+12|0,d=f[o>>2]|0,f[o>>2]=d+-1,(d|0)==1):0)CR(n);f[e>>2]=0;e=n+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[t>>2]|0)>0){e=f[B>>2]|0;B=0;do{f[e+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[t>>2]|0))}t=f[E>>2]|0;if((t|0)!=(D|0))ZF(t);t=m+36|0;D=f[t>>2]|0;if(D|0?(E=D+12|0,D=f[E>>2]|0,f[E>>2]=D+-1,(D|0)==1):0)CR(m);f[t>>2]=0;t=m+16|0;D=m+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[D>>2]|0)>0){t=f[m+40>>2]|0;E=0;do{f[t+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[D>>2]|0))}D=f[m+44>>2]|0;if((D|0)!=(m+48|0))ZF(D);D=l+36|0;m=f[D>>2]|0;if(m|0?(E=m+12|0,m=f[E>>2]|0,f[E>>2]=m+-1,(m|0)==1):0)CR(l);f[D>>2]=0;D=l+16|0;m=l+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[m>>2]|0)>0){D=f[l+40>>2]|0;E=0;do{f[D+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))ZF(m);m=k+36|0;l=f[m>>2]|0;do if(l|0){E=l+12|0;D=f[E>>2]|0;f[E>>2]=D+-1;if((D|0)!=1)break;CR(k)}while(0);f[m>>2]=0;m=k+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[m>>2]|0)>0){p=f[k+40>>2]|0;l=0;do{f[p+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[m>>2]|0))}m=f[k+44>>2]|0;if((m|0)!=(k+48|0))ZF(m);m=f[j>>2]|0;if((m|0)!=(v|0)){if(m|0)QYa(m);f[j>>2]=v;f[g>>2]=1032}g=i+36|0;v=f[g>>2]|0;do if(v|0){j=v+12|0;m=f[j>>2]|0;f[j>>2]=m+-1;if((m|0)!=1)break;CR(i)}while(0);f[g>>2]=0;g=i+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[C>>2]|0)>0){g=f[i+40>>2]|0;v=0;do{f[g+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[C>>2]|0))}C=f[i+44>>2]|0;if((C|0)==(i+48|0)){u=h;return}ZF(C);u=h;return}function aN(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=u;u=u+1328|0;i=h+1272|0;j=h+1216|0;k=h+1160|0;l=h+1104|0;m=h+64|0;n=h+8|0;o=h;do if((NS(a)|0)==65536){p=f[a+4>>2]|0;f[i>>2]=f[p>>2];q=i+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=i+8|0;f[s>>2]=f[p+8>>2];f[i+12>>2]=f[p+12>>2];f[i+16>>2]=f[p+16>>2];f[i+20>>2]=f[p+20>>2];f[i+24>>2]=f[p+24>>2];f[i+28>>2]=f[p+28>>2];f[i+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[i+36>>2]=t;f[i+40>>2]=s;s=i+48|0;v=i+44|0;f[v>>2]=s;f[s>>2]=0;f[i+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;BR(i,p);break}}else OR(i,a,-1);while(0);do if((NS(c)|0)==65536){a=f[c+4>>2]|0;f[j>>2]=f[a>>2];p=j+4|0;q=a+4|0;f[p>>2]=f[q>>2];r=j+8|0;f[r>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];s=f[a+36>>2]|0;f[j+36>>2]=s;f[j+40>>2]=r;r=j+48|0;v=j+44|0;f[v>>2]=r;f[r>>2]=0;f[j+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[a+44>>2]|0;r=f[v>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[p>>2]=0;BR(j,a);break}}else OR(j,c,-1);while(0);do if((NS(d)|0)==65536){c=f[d+4>>2]|0;f[k>>2]=f[c>>2];a=k+4|0;p=c+4|0;f[a>>2]=f[p>>2];q=k+8|0;f[q>>2]=f[c+8>>2];f[k+12>>2]=f[c+12>>2];f[k+16>>2]=f[c+16>>2];f[k+20>>2]=f[c+20>>2];f[k+24>>2]=f[c+24>>2];f[k+28>>2]=f[c+28>>2];f[k+32>>2]=f[c+32>>2];r=f[c+36>>2]|0;f[k+36>>2]=r;f[k+40>>2]=q;q=k+48|0;v=k+44|0;f[v>>2]=q;f[q>>2]=0;f[k+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[c+44>>2]|0;q=f[v>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[a>>2]=0;BR(k,c);break}}else OR(k,d,-1);while(0);do if((NS(e)|0)==65536){d=f[e+4>>2]|0;f[l>>2]=f[d>>2];c=l+4|0;a=d+4|0;f[c>>2]=f[a>>2];p=l+8|0;f[p>>2]=f[d+8>>2];f[l+12>>2]=f[d+12>>2];f[l+16>>2]=f[d+16>>2];f[l+20>>2]=f[d+20>>2];f[l+24>>2]=f[d+24>>2];f[l+28>>2]=f[d+28>>2];f[l+32>>2]=f[d+32>>2];q=f[d+36>>2]|0;f[l+36>>2]=q;f[l+40>>2]=p;p=l+48|0;v=l+44|0;f[v>>2]=p;f[p>>2]=0;f[l+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[a>>2]|0)<3){a=f[d+44>>2]|0;p=f[v>>2]|0;f[p>>2]=f[a>>2];f[p+4>>2]=f[a+4>>2];break}else{f[c>>2]=0;BR(l,d);break}}else OR(l,e,-1);while(0);e=f[i>>2]|0;d=e&4095;c=i+4|0;a=f[c>>2]|0;if((a|0)>0)w=f[(f[i+44>>2]|0)+(a+-1<<2)>>2]|0;else w=0;a=f[j+8>>2]|0;p=f[k+12>>2]|0;v=l+16|0;q=f[v>>2]|0?f[l+12>>2]|0:a;r=(p|0)<(a|0)?p:a;if((f[i+8>>2]|0)==1)x=w;else x=((f[i+12>>2]|0)==1?0:w)+(f[i+48>>2]|0)|0;w=(q<<3)+16|0;s=m+8|0;f[m>>2]=s;t=m+4|0;f[t>>2]=w;if(w>>>0>1032){y=OYa(w)|0;f[m>>2]=y}if(!(((((d|0)==(f[j>>2]&4095|0)?(d|0)==(f[k>>2]&4095|0):0)?(f[j+16>>2]|0)!=0:0)?(f[k+16>>2]|0)!=0:0)?(f[i+16>>2]|0)!=0:0)){f[n>>2]=0;f[n+4>>2]=0;z=c$(n,76)|0;A=164391;B=z+76|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-215,n,164468,164068,1513);d$(n)}y=f[j+12>>2]|0;if((y|0)>=(r|0)?(w=f[k+8>>2]|0,(w|0)>=(r|0)):0){C=f[i+40>>2]|0;D=f[C+4>>2]|0;E=f[C>>2]|0;if((!((D|0)==(r|0)&(E|0)==1)?!((D|0)==1&(E|0)==(r|0)):0)?!((D|0)==(w|0)&(E|0)==(y|0)):0)F=46}else F=46;if((F|0)==46){f[n>>2]=0;f[n+4>>2]=0;z=c$(n,122)|0;A=164478;B=z+122|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-215,n,164468,164068,1515);d$(n)}do if(f[v>>2]|0){if((f[l>>2]&4095|0)==(d|0)?(f[l+8>>2]|0)==(a|0):0)break;f[n>>2]=0;f[n+4>>2]=0;z=c$(n,54)|0;A=164601;B=z+54|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-215,n,164468,164068,1516);d$(n)}while(0);pS(g,p,q,d,-1,0,0);do if((NS(g)|0)==65536){d=f[g+4>>2]|0;f[n>>2]=f[d>>2];A=n+4|0;z=d+4|0;f[A>>2]=f[z>>2];B=n+8|0;f[B>>2]=f[d+8>>2];f[n+12>>2]=f[d+12>>2];f[n+16>>2]=f[d+16>>2];f[n+20>>2]=f[d+20>>2];f[n+24>>2]=f[d+24>>2];f[n+28>>2]=f[d+28>>2];f[n+32>>2]=f[d+32>>2];F=f[d+36>>2]|0;f[n+36>>2]=F;f[n+40>>2]=B;B=n+48|0;y=n+44|0;f[y>>2]=B;f[B>>2]=0;f[n+52>>2]=0;if(F|0){B=F+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[z>>2]|0)<3){z=f[d+44>>2]|0;B=f[y>>2]|0;f[B>>2]=f[z>>2];f[B+4>>2]=f[z+4>>2];break}else{f[A>>2]=0;BR(n,d);break}}else OR(n,g,-1);while(0);switch(e&4095){case 5:{eN(a,p,f[i+16>>2]|0,x,f[j+16>>2]|0,f[j+48>>2]|0,0,f[k+16>>2]|0,f[k+48>>2]|0,f[v>>2]|0,f[l+48>>2]|0,q,f[n+16>>2]|0,f[n+48>>2]|0,f[m>>2]|0);break}case 6:{fN(a,p,f[i+16>>2]|0,x,f[j+16>>2]|0,f[j+48>>2]|0,0,f[k+16>>2]|0,f[k+48>>2]|0,f[v>>2]|0,f[l+48>>2]|0,q,f[n+16>>2]|0,f[n+48>>2]|0,f[m>>2]|0);break}default:{f[o>>2]=0;f[o+4>>2]=0;j$(-210,o,164468,164068,1529);d$(o)}}o=n+36|0;q=f[o>>2]|0;if(q|0?(x=q+12|0,q=f[x>>2]|0,f[x>>2]=q+-1,(q|0)==1):0)CR(n);f[o>>2]=0;o=n+16|0;q=n+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[q>>2]|0)>0){o=f[n+40>>2]|0;x=0;do{f[o+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[q>>2]|0))}q=f[n+44>>2]|0;if((q|0)!=(n+48|0))ZF(q);q=f[m>>2]|0;if((q|0)!=(s|0)){if(q|0)QYa(q);f[m>>2]=s;f[t>>2]=1032}t=l+36|0;s=f[t>>2]|0;if(s|0?(m=s+12|0,s=f[m>>2]|0,f[m>>2]=s+-1,(s|0)==1):0)CR(l);f[t>>2]=0;t=l+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[t>>2]|0)>0){v=f[l+40>>2]|0;s=0;do{f[v+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[t>>2]|0))}t=f[l+44>>2]|0;if((t|0)!=(l+48|0))ZF(t);t=k+36|0;l=f[t>>2]|0;do if(l|0){s=l+12|0;v=f[s>>2]|0;f[s>>2]=v+-1;if((v|0)!=1)break;CR(k)}while(0);f[t>>2]=0;t=k+16|0;l=k+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[l>>2]|0)>0){t=f[k+40>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))ZF(l);l=j+36|0;k=f[l>>2]|0;do if(k|0){v=k+12|0;t=f[v>>2]|0;f[v>>2]=t+-1;if((t|0)!=1)break;CR(j)}while(0);f[l>>2]=0;l=j+16|0;k=j+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[k>>2]|0)>0){l=f[j+40>>2]|0;t=0;do{f[l+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))ZF(k);k=i+36|0;j=f[k>>2]|0;do if(j|0){t=j+12|0;l=f[t>>2]|0;f[t>>2]=l+-1;if((l|0)!=1)break;CR(i)}while(0);f[k>>2]=0;k=i+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[c>>2]|0)>0){k=f[i+40>>2]|0;j=0;do{f[k+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[c>>2]|0))}c=f[i+44>>2]|0;if((c|0)==(i+48|0)){u=h;return}ZF(c);u=h;return}
function u3(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=f[a>>2]|0;h=f[a+4>>2]|0;i=f[a+8>>2]|0;k=f[a+12>>2]|0;l=f[a+16>>2]|0;m=f[a+20>>2]|0;n=f[a+24>>2]|0;o=f[a+28>>2]|0;p=f[a+32>>2]|0;q=f[a+36>>2]|0;a=e*3|0;if((e|0)>0){r=0;s=b}else return;while(1){b=j[s>>1]|0;e=Y(b,h)|0;t=j[s+2>>1]|0;u=Y(t,i)|0;v=j[s+4>>1]|0;w=e+2048+u+(Y(v,k)|0)>>12;u=(Y(b,l)|0)+2048+(Y(t,m)|0)+(Y(v,n)|0)>>12;e=(Y(b,o)|0)+2048+(Y(t,p)|0)+(Y(v,q)|0)>>12;d[c+(r<<1)>>1]=w>>>0<65536?w:(w|0)>0?65535:0;d[c+(r+1<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[c+(r+2<<1)>>1]=e>>>0<65536?e:(e|0)>0?65535:0;r=r+3|0;if((r|0)>=(a|0))break;else s=s+(g<<1)|0}return}function v3(a){a=a|0;PYa(a);return}function w3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,47004);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){x3(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function x3(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=f[a>>2]|0;i=f[a+4>>2]|0;j=f[a+8>>2]|0;k=f[a+12>>2]|0;l=f[a+16>>2]|0;m=f[a+20>>2]|0;n=f[a+24>>2]|0;o=f[a+28>>2]|0;p=f[a+32>>2]|0;q=f[a+36>>2]|0;a=e*3|0;if((e|0)>0){r=0;s=c}else return;while(1){c=h[s>>0]|0;e=Y(c,i)|0;t=h[s+1>>0]|0;u=Y(t,j)|0;v=h[s+2>>0]|0;w=e+2048+u+(Y(v,k)|0)>>12;u=(Y(c,l)|0)+2048+(Y(t,m)|0)+(Y(v,n)|0)>>12;e=(Y(c,o)|0)+2048+(Y(t,p)|0)+(Y(v,q)|0)>>12;b[d+r>>0]=w>>>0<256?w:(w|0)>0?255:0;b[d+(r+1)>>0]=u>>>0<256?u:(u|0)>0?255:0;b[d+(r+2)>>0]=e>>>0<256?e:(e|0)>0?255:0;r=r+3|0;if((r|0)>=(a|0))break;else s=s+g|0}return}function y3(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0;k=u;u=u+96|0;l=k+88|0;m=k+56|0;o=k+48|0;q=k;_$(o,47024);r=j?2:0;switch(h|0){case 0:{f[q>>2]=i;f[q+4>>2]=r;h=q+8|0;f[h>>2]=13273;s=q+12|0;f[s>>2]=-6296;t=q+16|0;f[t>>2]=-2042;f[q+20>>2]=-3970;f[q+24>>2]=7684;f[q+28>>2]=170;v=q+32|0;f[v>>2]=228;w=q+36|0;f[w>>2]=-836;x=q+40|0;f[x>>2]=4331;if(!j){f[h>>2]=228;f[v>>2]=13273;f[s>>2]=-836;f[w>>2]=-6296;f[t>>2]=4331;f[x>>2]=-2042}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=47052;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=q;_U(l,m,+(Y(g,e)|0)*.0000152587890625);break}case 2:{f[q>>2]=i;f[q+4>>2]=r;x=q+8|0;f[x>>2]=13273;t=q+12|0;f[t>>2]=-6296;w=q+16|0;f[w>>2]=-2042;f[q+20>>2]=-3970;f[q+24>>2]=7684;f[q+28>>2]=170;s=q+32|0;f[s>>2]=228;v=q+36|0;f[v>>2]=-836;h=q+40|0;f[h>>2]=4331;if(!j){f[x>>2]=228;f[s>>2]=13273;f[t>>2]=-836;f[v>>2]=-6296;f[w>>2]=4331;f[h>>2]=-2042}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=47072;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=q;_U(l,m,+(Y(g,e)|0)*.0000152587890625);break}default:{f[q>>2]=i;f[q+4>>2]=r;y=+p[46886];r=q+8|0;n[r>>2]=y;z=+p[46887];i=q+12|0;n[i>>2]=z;A=+p[46888];h=q+16|0;n[h>>2]=A;n[q+20>>2]=+p[46889];n[q+24>>2]=+p[46890];n[q+28>>2]=+p[46891];B=+p[46892];w=q+32|0;n[w>>2]=B;C=+p[46893];v=q+36|0;n[v>>2]=C;D=+p[46894];t=q+40|0;n[t>>2]=D;if(!j){n[r>>2]=B;n[w>>2]=y;n[i>>2]=C;n[v>>2]=z;n[h>>2]=D;n[t>>2]=A}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=47092;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=q;_U(l,m,+(Y(g,e)|0)*.0000152587890625)}}if(!(f[o+4>>2]|0)){u=k;return}u=k;return}function z3(a){a=a|0;PYa(a);return}function A3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,47104);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){B3(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function B3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0.0;e=f[a>>2]|0;g=+n[a+8>>2];h=+n[a+12>>2];i=+n[a+16>>2];j=+n[a+20>>2];k=+n[a+24>>2];l=+n[a+28>>2];m=+n[a+32>>2];o=+n[a+36>>2];p=+n[a+40>>2];a=d*3|0;if((d|0)<=0)return;if((e|0)==4){d=c;q=0;while(1){r=+n[b+(q<<2)>>2];s=+n[b+(q+1<<2)>>2];t=+n[b+(q+2<<2)>>2];n[d>>2]=g*r+h*s+i*t;n[d+4>>2]=j*r+k*s+l*t;n[d+8>>2]=m*r+o*s+p*t;n[d+12>>2]=1.0;q=q+3|0;if((q|0)>=(a|0))break;else d=d+16|0}return}else{d=c;c=0;while(1){t=+n[b+(c<<2)>>2];s=+n[b+(c+1<<2)>>2];r=+n[b+(c+2<<2)>>2];n[d>>2]=g*t+h*s+i*r;n[d+4>>2]=j*t+k*s+l*r;n[d+8>>2]=m*t+o*s+p*r;c=c+3|0;if((c|0)>=(a|0))break;else d=d+(e<<2)|0}return}}function C3(a){a=a|0;PYa(a);return}function D3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,47124);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){E3(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function E3(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=f[a>>2]|0;h=f[a+8>>2]|0;i=f[a+12>>2]|0;k=f[a+16>>2]|0;l=f[a+20>>2]|0;m=f[a+24>>2]|0;n=f[a+28>>2]|0;o=f[a+32>>2]|0;p=f[a+36>>2]|0;q=f[a+40>>2]|0;a=e*3|0;if((e|0)<=0)return;if((g|0)==4){e=c;r=0;while(1){s=j[b+(r<<1)>>1]|0;t=Y(s,h)|0;u=j[b+(r+1<<1)>>1]|0;v=Y(u,i)|0;w=j[b+(r+2<<1)>>1]|0;x=t+2048+v+(Y(w,k)|0)>>12;v=(Y(s,l)|0)+2048+(Y(u,m)|0)+(Y(w,n)|0)>>12;t=(Y(s,o)|0)+2048+(Y(u,p)|0)+(Y(w,q)|0)>>12;d[e>>1]=x>>>0<65536?x:(x|0)>0?65535:0;d[e+2>>1]=v>>>0<65536?v:(v|0)>0?65535:0;d[e+4>>1]=t>>>0<65536?t:(t|0)>0?65535:0;d[e+6>>1]=-1;r=r+3|0;if((r|0)>=(a|0))break;else e=e+8|0}return}else{e=c;c=0;while(1){r=j[b+(c<<1)>>1]|0;t=Y(r,h)|0;v=j[b+(c+1<<1)>>1]|0;x=Y(v,i)|0;w=j[b+(c+2<<1)>>1]|0;u=t+2048+x+(Y(w,k)|0)>>12;x=(Y(r,l)|0)+2048+(Y(v,m)|0)+(Y(w,n)|0)>>12;t=(Y(r,o)|0)+2048+(Y(v,p)|0)+(Y(w,q)|0)>>12;d[e>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[e+2>>1]=x>>>0<65536?x:(x|0)>0?65535:0;d[e+4>>1]=t>>>0<65536?t:(t|0)>0?65535:0;c=c+3|0;if((c|0)>=(a|0))break;else e=e+(g<<1)|0}return}}function F3(a){a=a|0;PYa(a);return}function G3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,47144);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){H3(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function H3(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=f[a>>2]|0;i=f[a+8>>2]|0;j=f[a+12>>2]|0;k=f[a+16>>2]|0;l=f[a+20>>2]|0;m=f[a+24>>2]|0;n=f[a+28>>2]|0;o=f[a+32>>2]|0;p=f[a+36>>2]|0;q=f[a+40>>2]|0;a=e*3|0;if((e|0)<=0)return;if((g|0)==4){e=d;r=0;while(1){s=h[c+r>>0]|0;t=Y(s,i)|0;u=h[c+(r+1)>>0]|0;v=Y(u,j)|0;w=h[c+(r+2)>>0]|0;x=t+2048+v+(Y(w,k)|0)>>12;v=(Y(s,l)|0)+2048+(Y(u,m)|0)+(Y(w,n)|0)>>12;t=(Y(s,o)|0)+2048+(Y(u,p)|0)+(Y(w,q)|0)>>12;b[e>>0]=x>>>0<256?x:(x|0)>0?255:0;b[e+1>>0]=v>>>0<256?v:(v|0)>0?255:0;b[e+2>>0]=t>>>0<256?t:(t|0)>0?255:0;b[e+3>>0]=-1;r=r+3|0;if((r|0)>=(a|0))break;else e=e+4|0}return}else{e=d;d=0;while(1){r=h[c+d>>0]|0;t=Y(r,i)|0;v=h[c+(d+1)>>0]|0;x=Y(v,j)|0;w=h[c+(d+2)>>0]|0;u=t+2048+x+(Y(w,k)|0)>>12;x=(Y(r,l)|0)+2048+(Y(v,m)|0)+(Y(w,n)|0)>>12;t=(Y(r,o)|0)+2048+(Y(v,p)|0)+(Y(w,q)|0)>>12;b[e>>0]=u>>>0<256?u:(u|0)>0?255:0;b[e+1>>0]=x>>>0<256?x:(x|0)>0?255:0;b[e+2>>0]=t>>>0<256?t:(t|0)>0?255:0;d=d+3|0;if((d|0)>=(a|0))break;else e=e+g|0}return}}function I3(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+64|0;p=o+56|0;q=o+24|0;r=o+16|0;s=o;_$(r,47164);t=(i|0)==5?360:l?256:180;l=k?2:0;k=(i|0)==0;do if(!m)if(k){f[s>>2]=j;f[s+4>>2]=3;f[s+8>>2]=l;n[s+12>>2]=+(t|0)/360.0;f[p>>2]=0;f[p+4>>2]=h;f[q>>2]=47232;f[q+4>>2]=a;f[q+8>>2]=c;f[q+12>>2]=d;f[q+16>>2]=e;f[q+20>>2]=g;f[q+24>>2]=s;_U(p,q,+(Y(h,g)|0)*.0000152587890625);break}else{f[s>>2]=j;f[s+4>>2]=l;n[s+8>>2]=+(t|0)/360.0;f[p>>2]=0;f[p+4>>2]=h;f[q>>2]=47252;f[q+4>>2]=a;f[q+8>>2]=c;f[q+12>>2]=d;f[q+16>>2]=e;f[q+20>>2]=g;f[q+24>>2]=s;_U(p,q,+(Y(h,g)|0)*.0000152587890625);break}else{if(!k){f[s>>2]=j;f[s+4>>2]=l;n[s+8>>2]=+(t|0);f[p>>2]=0;f[p+4>>2]=h;f[q>>2]=47212;f[q+4>>2]=a;f[q+8>>2]=c;f[q+12>>2]=d;f[q+16>>2]=e;f[q+20>>2]=g;f[q+24>>2]=s;_U(p,q,+(Y(h,g)|0)*.0000152587890625);break}f[s>>2]=j;f[s+4>>2]=l;f[s+8>>2]=t;switch(t&511){case 256:case 180:break;default:{f[p>>2]=0;f[p+4>>2]=0;i=c$(p,30)|0;v=211701;w=i+30|0;do{b[i>>0]=b[v>>0]|0;i=i+1|0;v=v+1|0}while((i|0)<(w|0));j$(-215,p,211732,206245,4511);d$(p)}}f[p>>2]=0;f[p+4>>2]=h;f[q>>2]=47192;f[q+4>>2]=a;f[q+8>>2]=c;f[q+12>>2]=d;f[q+16>>2]=e;f[q+20>>2]=g;f[q+24>>2]=s;_U(p,q,+(Y(h,g)|0)*.0000152587890625)}while(0);if(!(f[r+4>>2]|0)){u=o;return}u=o;return}function J3(a){a=a|0;PYa(a);return}function K3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0;c=u;u=u+16|0;d=c;_$(d,47264);e=f[b>>2]|0;g=f[b+4>>2]|0;a:do if((e|0)<(g|0)){b=f[a+8>>2]|0;h=f[a+16>>2]|0;i=a+24|0;j=f[a+20>>2]|0;k=j*3|0;if((j|0)<=0){j=e;while(1){j=j+1|0;if((j|0)>=(g|0))break a}}j=(f[a+12>>2]|0)+(Y(h,e)|0)|0;l=e;m=j;j=(f[a+4>>2]|0)+(Y(b,e)|0)|0;while(1){o=f[i>>2]|0;p=f[o+4>>2]|0;q=f[o>>2]|0;r=p^2;s=o+8|0;o=0;t=j;while(1){v=+n[t+(p<<2)>>2];w=+n[t+4>>2];x=+n[t+(r<<2)>>2];y=x<w?w:x;z=y<v?v:y;y=x>w?w:x;A=y>v?v:y;y=z-A;B=z+A;C=B*.5;if(y>1.1920928955078125e-07){D=y/(C<.5?B:2.0-z-A);A=60.0/y;do if(!(z==x))if(z==w){E=(v-x)*A+120.0;break}else{E=(x-w)*A+240.0;break}else E=(w-v)*A;while(0);if(E<0.0){F=E+360.0;G=D}else{F=E;G=D}}else{F=0.0;G=0.0}n[m+(o<<2)>>2]=F*+n[s>>2];n[m+(o+1<<2)>>2]=C;n[m+(o+2<<2)>>2]=G;o=o+3|0;if((o|0)>=(k|0))break;else t=t+(q<<2)|0}l=l+1|0;if((l|0)>=(g|0))break;else{m=m+h|0;j=j+b|0}}}while(0);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function L3(a){a=a|0;PYa(a);return}function M3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,47284);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){N3(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function N3(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0;g=u;u=u+3072|0;i=g;j=f[a>>2]|0;if((e|0)<=0){u=g;return}k=a+8|0;l=a+4|0;m=a+12|0;a=d;d=0;o=c;while(1){c=e-d|0;p=((c|0)<256?c:256)*3|0;q=(c|0)>0;if(q){c=0;r=o;do{n[i+(c<<2)>>2]=+(h[r>>0]|0)*.003921568859368563;n[i+(c+1<<2)>>2]=+(h[r+1>>0]|0)*.003921568859368563;n[i+(c+2<<2)>>2]=+(h[r+2>>0]|0)*.003921568859368563;c=c+3|0;r=r+j|0}while((c|0)<(p|0));c=f[k>>2]|0;s=f[l>>2]|0;if(q){t=c^2;v=0;w=i;while(1){x=+n[w+(c<<2)>>2];y=+n[w+4>>2];z=+n[w+(t<<2)>>2];A=z<y?y:z;B=A<x?x:A;A=z>y?y:z;C=A>x?x:A;A=B-C;D=B+C;E=D*.5;if(A>1.1920928955078125e-07){F=A/(E<.5?D:2.0-B-C);C=60.0/A;do if(!(B==z))if(B==y){G=(x-z)*C+120.0;break}else{G=(z-y)*C+240.0;break}else G=(y-x)*C;while(0);if(G<0.0){H=G+360.0;I=F}else{H=G;I=F}}else{H=0.0;I=0.0}n[i+(v<<2)>>2]=H*+n[m>>2];n[i+(v+1<<2)>>2]=E;n[i+(v+2<<2)>>2]=I;v=v+3|0;if((v|0)>=(p|0))break;else w=w+(s<<2)|0}if(q){s=0;do{w=wNa(+n[i+(s<<2)>>2])|0;b[a+s>>0]=w>>>0<256?w:(w|0)>0?255:0;w=s+1|0;v=wNa(+n[i+(w<<2)>>2]*255.0)|0;b[a+w>>0]=v>>>0<256?v:(v|0)>0?255:0;v=s+2|0;w=wNa(+n[i+(v<<2)>>2]*255.0)|0;b[a+v>>0]=w>>>0<256?w:(w|0)>0?255:0;s=s+3|0}while((s|0)<(p|0));J=r}else J=r}else J=r}else J=o;d=d+256|0;if((d|0)>=(e|0))break;else{a=a+768|0;o=J}}u=g;return}function O3(a){a=a|0;PYa(a);return}function P3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0;c=u;u=u+16|0;d=c;_$(d,47304);e=f[b>>2]|0;g=f[b+4>>2]|0;a:do if((e|0)<(g|0)){b=f[a+8>>2]|0;h=f[a+16>>2]|0;i=a+24|0;j=f[a+20>>2]|0;k=j*3|0;if((j|0)<=0){j=e;while(1){j=j+1|0;if((j|0)>=(g|0))break a}}j=(f[a+12>>2]|0)+(Y(h,e)|0)|0;l=e;m=j;j=(f[a+4>>2]|0)+(Y(b,e)|0)|0;while(1){o=f[i>>2]|0;p=f[o+4>>2]|0;q=f[o>>2]|0;r=+n[o+8>>2]*2.7777778450399637e-03;o=p^2;s=0;t=j;while(1){v=+n[t+(p<<2)>>2];w=+n[t+4>>2];x=+n[t+(o<<2)>>2];y=x<w?w:x;z=y<v?v:y;y=x>w?w:x;A=z-(y>v?v:y);y=A/(+L(+z)+1.1920928955078125e-07);B=60.0/(A+1.1920928955078125e-07);do if(!(z==x))if(z==w){C=(v-x)*B+120.0;break}else{C=(x-w)*B+240.0;break}else C=(w-v)*B;while(0);n[m+(s<<2)>>2]=r*(C<0.0?C+360.0:C);n[m+(s+1<<2)>>2]=y;n[m+(s+2<<2)>>2]=z;s=s+3|0;if((s|0)>=(k|0))break;else t=t+(q<<2)|0}l=l+1|0;if((l|0)>=(g|0))break;else{m=m+h|0;j=j+b|0}}}while(0);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function Q3(a){a=a|0;PYa(a);return}function R3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,47324);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){S3(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function S3(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0.0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=f[a+4>>2]|0;i=f[a>>2]|0;j=f[a+8>>2]|0;a=(j|0)==180?904652:905676;k=e*3|0;if(!(b[5689973]|0)){f[226419]=0;f[226163]=0;f[226675]=0;l=1;do{m=+(l|0);n=rNa(1044480.0/m)|0;f[906700+(l<<2)>>2]=n;o=m*6.0;n=rNa(737280.0/o)|0;f[904652+(l<<2)>>2]=n;n=rNa(1048576.0/o)|0;f[905676+(l<<2)>>2]=n;l=l+1|0}while((l|0)!=256);b[5689973]=1}if((e|0)<=0)return;e=g^2;l=0;n=c;while(1){c=h[n+g>>0]|0;p=h[n+1>>0]|0;q=h[n+e>>0]|0;r=p-c|0;s=r+256|0;if(s>>>0<769)t=h[331268+s>>0]|0;else t=0;s=t+c|0;u=q-s+256|0;if(u>>>0<769)v=h[331268+u>>0]|0;else v=0;u=v+s|0;s=c-p+256|0;if(s>>>0<769)w=h[331268+s>>0]|0;else w=0;s=c-w|0;x=s-q+256|0;if(x>>>0<769)y=h[331268+x>>0]|0;else y=0;x=y-s+u|0;s=(x>>>0<256?x:(x|0)>0?255:0)&255;x=((Y(s,f[906700+(u<<2)>>2]|0)|0)+2048|0)>>>12;z=(Y((u|0)==(q|0)?r:(u|0)==(p|0)?c-q+(s<<1)|0:q-p+(s<<2)|0,f[a+(s<<2)>>2]|0)|0)+2048>>12;s=((z|0)<0?j:0)+z|0;b[d+l>>0]=s>>>0<256?s:(s|0)>0?255:0;b[d+(l+1)>>0]=x;b[d+(l+2)>>0]=u;l=l+3|0;if((l|0)>=(k|0))break;else n=n+i|0}return}function T3(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,s=0;m=u;u=u+64|0;o=m+56|0;p=m+24|0;q=m+16|0;r=m;_$(q,47344);s=(h|0)==5?360:k?255:180;k=j?2:0;j=(h|0)==0;do if(l)if(j){f[r>>2]=i;f[r+4>>2]=3;f[r+8>>2]=k;n[r+12>>2]=6.0/+(s|0);f[o>>2]=0;f[o+4>>2]=g;f[p>>2]=47372;f[p+4>>2]=a;f[p+8>>2]=b;f[p+12>>2]=c;f[p+16>>2]=d;f[p+20>>2]=e;f[p+24>>2]=r;_U(o,p,+(Y(g,e)|0)*.0000152587890625);break}else{f[r>>2]=i;f[r+4>>2]=k;n[r+8>>2]=6.0/+(s|0);f[o>>2]=0;f[o+4>>2]=g;f[p>>2]=47392;f[p+4>>2]=a;f[p+8>>2]=b;f[p+12>>2]=c;f[p+16>>2]=d;f[p+20>>2]=e;f[p+24>>2]=r;_U(o,p,+(Y(g,e)|0)*.0000152587890625);break}else if(j){f[r>>2]=i;f[r+4>>2]=3;f[r+8>>2]=k;n[r+12>>2]=6.0/+(s|0);f[o>>2]=0;f[o+4>>2]=g;f[p>>2]=47412;f[p+4>>2]=a;f[p+8>>2]=b;f[p+12>>2]=c;f[p+16>>2]=d;f[p+20>>2]=e;f[p+24>>2]=r;_U(o,p,+(Y(g,e)|0)*.0000152587890625);break}else{f[r>>2]=i;f[r+4>>2]=k;n[r+8>>2]=6.0/+(s|0);f[o>>2]=0;f[o+4>>2]=g;f[p>>2]=47432;f[p+4>>2]=a;f[p+8>>2]=b;f[p+12>>2]=c;f[p+16>>2]=d;f[p+20>>2]=e;f[p+24>>2]=r;_U(o,p,+(Y(g,e)|0)*.0000152587890625);break}while(0);if(!(f[q+4>>2]|0)){u=m;return}u=m;return}function U3(a){a=a|0;PYa(a);return}function V3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,47444);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){W3(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function W3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0;e=u;u=u+16|0;g=e;h=f[a+4>>2]|0;i=f[a>>2]|0;j=+n[a+8>>2];a=d*3|0;if((d|0)<=0){u=e;return}d=h^2;k=g+4|0;l=g+8|0;m=g+12|0;if((i|0)==4){o=c;p=0;while(1){q=+n[b+(p<<2)>>2];r=+n[b+(p+1<<2)>>2];s=+n[b+(p+2<<2)>>2];if(s==0.0){t=r;v=r;w=r}else{if(!(r<=.5))x=r+s-r*s;else x=r*(s+1.0);s=r*2.0-x;r=j*q;if(!(r<0.0))if(!(r>=6.0))y=r;else{q=r;while(1){z=q+-6.0;if(!(z>=6.0)){y=z;break}else q=z}}else{q=r;while(1){z=q+6.0;if(z<0.0)q=z;else{y=z;break}}}A=~~y;B=A-(+(A|0)>y&1)|0;q=y-+(B|0);n[g>>2]=x;n[k>>2]=s;r=x-s;n[l>>2]=s+r*(1.0-q);n[m>>2]=s+r*q;t=+n[g+(f[47464+(B*12|0)>>2]<<2)>>2];v=+n[g+(f[47464+(B*12|0)+4>>2]<<2)>>2];w=+n[g+(f[47464+(B*12|0)+8>>2]<<2)>>2]}n[o+(h<<2)>>2]=t;n[o+4>>2]=v;n[o+(d<<2)>>2]=w;n[o+12>>2]=1.0;p=p+3|0;if((p|0)>=(a|0))break;else o=o+16|0}u=e;return}else{o=c;c=0;while(1){w=+n[b+(c<<2)>>2];v=+n[b+(c+1<<2)>>2];t=+n[b+(c+2<<2)>>2];if(t==0.0){C=v;D=v;E=v}else{if(!(v<=.5))F=v+t-v*t;else F=v*(t+1.0);t=v*2.0-F;v=j*w;if(!(v<0.0))if(!(v>=6.0))G=v;else{w=v;while(1){x=w+-6.0;if(!(x>=6.0)){G=x;break}else w=x}}else{w=v;while(1){s=w+6.0;if(s<0.0)w=s;else{G=s;break}}}p=~~G;B=p-(+(p|0)>G&1)|0;w=G-+(B|0);n[g>>2]=F;n[k>>2]=t;v=F-t;n[l>>2]=t+v*(1.0-w);n[m>>2]=t+v*w;C=+n[g+(f[47464+(B*12|0)>>2]<<2)>>2];D=+n[g+(f[47464+(B*12|0)+4>>2]<<2)>>2];E=+n[g+(f[47464+(B*12|0)+8>>2]<<2)>>2]}n[o+(h<<2)>>2]=C;n[o+4>>2]=D;n[o+(d<<2)>>2]=E;c=c+3|0;if((c|0)>=(a|0))break;else o=o+(i<<2)|0}u=e;return}}function X3(a){a=a|0;PYa(a);return}function Y3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,47536);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){Z3(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function Z3(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+3072|0;i=g;j=f[a>>2]|0;if((e|0)<=0){u=g;return}k=a+4|0;a=(j|0)==4;l=d;d=0;m=c;while(1){c=e-d|0;o=(c|0)<256?c:256;p=o*3|0;q=(c|0)>0;if(q){c=0;do{n[i+(c<<2)>>2]=+(h[m+c>>0]|0);r=c+1|0;n[i+(r<<2)>>2]=+(h[m+r>>0]|0)*.003921568859368563;r=c+2|0;n[i+(r<<2)>>2]=+(h[m+r>>0]|0)*.003921568859368563;c=c+3|0}while((c|0)<(p|0));W3(k,i,i,o);if(q)if(a){c=l;r=0;while(1){s=wNa(+n[i+(r<<2)>>2]*255.0)|0;b[c>>0]=s>>>0<256?s:(s|0)>0?255:0;s=wNa(+n[i+(r+1<<2)>>2]*255.0)|0;b[c+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=wNa(+n[i+(r+2<<2)>>2]*255.0)|0;b[c+2>>0]=s>>>0<256?s:(s|0)>0?255:0;b[c+3>>0]=-1;r=r+3|0;s=c+4|0;if((r|0)>=(p|0)){t=s;break}else c=s}}else{c=l;r=0;while(1){q=wNa(+n[i+(r<<2)>>2]*255.0)|0;b[c>>0]=q>>>0<256?q:(q|0)>0?255:0;q=wNa(+n[i+(r+1<<2)>>2]*255.0)|0;b[c+1>>0]=q>>>0<256?q:(q|0)>0?255:0;q=wNa(+n[i+(r+2<<2)>>2]*255.0)|0;b[c+2>>0]=q>>>0<256?q:(q|0)>0?255:0;r=r+3|0;q=c+j|0;if((r|0)>=(p|0)){t=q;break}else c=q}}else t=l}else{W3(k,i,i,o);t=l}d=d+256|0;if((d|0)>=(e|0))break;else{l=t;m=m+768|0}}u=g;return}function _3(a){a=a|0;PYa(a);return}function $3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,47556);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){a4(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function a4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0;e=u;u=u+16|0;g=e;h=f[a+4>>2]|0;i=f[a>>2]|0;j=+n[a+8>>2];a=d*3|0;if((d|0)<=0){u=e;return}d=h^2;k=g+4|0;l=g+8|0;m=g+12|0;if((i|0)==4){o=c;p=0;while(1){q=+n[b+(p+1<<2)>>2];r=+n[b+(p+2<<2)>>2];if(q==0.0){s=r;t=r;v=r}else{w=j*+n[b+(p<<2)>>2];if(!(w<0.0))if(!(w>=6.0))x=w;else{y=w;while(1){z=y+-6.0;if(!(z>=6.0)){x=z;break}else y=z}}else{y=w;while(1){z=y+6.0;if(z<0.0)y=z;else{x=z;break}}}A=~~x;B=A-(+(A|0)>x&1)|0;A=B>>>0>5;y=A?0.0:x-+(B|0);C=A?0:B;n[g>>2]=r;n[k>>2]=r*(1.0-q);n[l>>2]=r*(1.0-q*y);n[m>>2]=r*(1.0-q*(1.0-y));s=+n[g+(f[47576+(C*12|0)>>2]<<2)>>2];t=+n[g+(f[47576+(C*12|0)+4>>2]<<2)>>2];v=+n[g+(f[47576+(C*12|0)+8>>2]<<2)>>2]}n[o+(h<<2)>>2]=s;n[o+4>>2]=t;n[o+(d<<2)>>2]=v;n[o+12>>2]=1.0;p=p+3|0;if((p|0)>=(a|0))break;else o=o+16|0}u=e;return}else{o=c;c=0;while(1){v=+n[b+(c+1<<2)>>2];t=+n[b+(c+2<<2)>>2];if(v==0.0){D=t;E=t;F=t}else{s=j*+n[b+(c<<2)>>2];if(!(s<0.0))if(!(s>=6.0))G=s;else{x=s;while(1){y=x+-6.0;if(!(y>=6.0)){G=y;break}else x=y}}else{x=s;while(1){q=x+6.0;if(q<0.0)x=q;else{G=q;break}}}p=~~G;C=p-(+(p|0)>G&1)|0;p=C>>>0>5;x=p?0.0:G-+(C|0);B=p?0:C;n[g>>2]=t;n[k>>2]=t*(1.0-v);n[l>>2]=t*(1.0-v*x);n[m>>2]=t*(1.0-v*(1.0-x));D=+n[g+(f[47576+(B*12|0)>>2]<<2)>>2];E=+n[g+(f[47576+(B*12|0)+4>>2]<<2)>>2];F=+n[g+(f[47576+(B*12|0)+8>>2]<<2)>>2]}n[o+(h<<2)>>2]=D;n[o+4>>2]=E;n[o+(d<<2)>>2]=F;c=c+3|0;if((c|0)>=(a|0))break;else o=o+(i<<2)|0}u=e;return}}function b4(a){a=a|0;PYa(a);return}function c4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,47648);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){d4(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function d4(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+3072|0;i=g;j=f[a>>2]|0;if((e|0)<=0){u=g;return}k=a+4|0;a=(j|0)==4;l=d;d=0;m=c;while(1){c=e-d|0;o=(c|0)<256?c:256;p=o*3|0;q=(c|0)>0;if(q){c=0;do{n[i+(c<<2)>>2]=+(h[m+c>>0]|0);r=c+1|0;n[i+(r<<2)>>2]=+(h[m+r>>0]|0)*.003921568859368563;r=c+2|0;n[i+(r<<2)>>2]=+(h[m+r>>0]|0)*.003921568859368563;c=c+3|0}while((c|0)<(p|0));a4(k,i,i,o);if(q)if(a){c=l;r=0;while(1){s=wNa(+n[i+(r<<2)>>2]*255.0)|0;b[c>>0]=s>>>0<256?s:(s|0)>0?255:0;s=wNa(+n[i+(r+1<<2)>>2]*255.0)|0;b[c+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=wNa(+n[i+(r+2<<2)>>2]*255.0)|0;b[c+2>>0]=s>>>0<256?s:(s|0)>0?255:0;b[c+3>>0]=-1;r=r+3|0;s=c+4|0;if((r|0)>=(p|0)){t=s;break}else c=s}}else{c=l;r=0;while(1){q=wNa(+n[i+(r<<2)>>2]*255.0)|0;b[c>>0]=q>>>0<256?q:(q|0)>0?255:0;q=wNa(+n[i+(r+1<<2)>>2]*255.0)|0;b[c+1>>0]=q>>>0<256?q:(q|0)>0?255:0;q=wNa(+n[i+(r+2<<2)>>2]*255.0)|0;b[c+2>>0]=q>>>0<256?q:(q|0)>0?255:0;r=r+3|0;q=c+j|0;if((r|0)>=(p|0)){t=q;break}else c=q}}else t=l}else{a4(k,i,i,o);t=l}d=d+256|0;if((d|0)>=(e|0))break;else{l=t;m=m+768|0}}u=g;return}function e4(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0;n=u;u=u+128|0;o=n+112|0;p=n+80|0;q=n+72|0;r=n;_$(q,47668);s=k?2:0;k=(i|0)==0;do if(l)if(k){f4(r,j,s,0,0,m);f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=47696;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=r;_U(o,p,+(Y(h,g)|0)*.0000152587890625);break}else{g4(r,j,s,0,0,m);f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=47716;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=r;_U(o,p,+(Y(h,g)|0)*.0000152587890625);break}else{if(!k){h4(r,j,s,0,0,m);f[r+52>>2]=j;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=47756;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=r;_U(o,p,+(Y(h,g)|0)*.0000152587890625);break}f[r>>2]=j;h4(r+4|0,3,s,0,0,m);f[r+56>>2]=j;f[r+60>>2]=s;i4();b[r+64>>0]=m&1;if((b[375224]|0)==0?u1a(375224)|0:0)JCa(907752,255);f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=47736;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=r;_U(o,p,+(Y(h,g)|0)*.0000152587890625)}while(0);if(!(f[q+4>>2]|0)){u=n;return}u=n;return}function f4(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;i=u;u=u+80|0;j=i+56|0;k=i+32|0;l=i+24|0;m=i+16|0;o=i+8|0;q=i;f[a>>2]=c;b[a+40>>0]=h&1;i4();f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;if(!g){f[j>>2]=f[93790];f[j+4>>2]=f[93791];f[j+8>>2]=f[93792];f[j+12>>2]=f[93793];f[j+16>>2]=f[93794];f[j+20>>2]=f[93795]}else{p[j>>3]=+n[g>>2];p[j+8>>3]=+n[g+4>>2];p[j+16>>3]=+n[g+8>>2]}if((b[899752]|0)==0?u1a(899752)|0:0)UCa(899760,4096);if((f[11962]|0)<=0){u=i;return}g=(e|0)==0;h=d^2;c=k+8|0;r=k+16|0;s=l+4|0;t=k+8|0;v=k+16|0;w=0;do{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;x=w*3|0;if(g){y=375016+(x<<3)|0;if((y|0)!=(k|0)){z=y;y=f[z+4>>2]|0;A=k;f[A>>2]=f[z>>2];f[A+4>>2]=y}y=x+1|0;A=375016+(y<<3)|0;if((A|0)!=(c|0)){z=A;A=f[z+4>>2]|0;B=c;f[B>>2]=f[z>>2];f[B+4>>2]=A}A=375016+(x+2<<3)|0;if((A|0)==(r|0))C=y;else{B=A;A=f[B+4>>2]|0;z=r;f[z>>2]=f[B>>2];f[z+4>>2]=A;C=y}}else{p[k>>3]=+n[e+(x<<2)>>2];y=x+1|0;p[t>>3]=+n[e+(y<<2)>>2];p[v>>3]=+n[e+(x+2<<2)>>2];C=y}bDa(m,899760,k);y=j+(w<<3)|0;cDa(l,m,y);A=XCa(l)|0;f[a+4+(x+h<<2)>>2]=A;bDa(o,899760,c);cDa(l,o,y);A=XCa(l)|0;z=a+4+(C<<2)|0;f[z>>2]=A;bDa(q,899760,r);cDa(l,q,y);y=XCa(l)|0;f[a+4+(x+d<<2)>>2]=y;y=f[a+4+(x<<2)>>2]|0;if(!((((y|0)>-1?(A=f[z>>2]|0,(A|0)>-1):0)?(z=f[a+4+(x+2<<2)>>2]|0,(z|0)>-1):0)?(A+y+z|0)<8192:0)){f[l>>2]=0;f[s>>2]=0;z=c$(l,128)|0;y=214130;A=z+128|0;do{b[z>>0]=b[y>>0]|0;z=z+1|0;y=y+1|0}while((z|0)<(A|0));j$(-215,l,214259,206245,6359);d$(l)}w=w+1|0}while((w|0)<(f[11962]|0));u=i;return}function g4(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;i=u;u=u+128|0;j=i+116|0;k=i+64|0;l=i+40|0;m=i+32|0;o=i+24|0;q=i+104|0;r=i+96|0;t=i+16|0;v=i+8|0;w=i;x=i+92|0;y=i+88|0;f[a>>2]=c;c=a+40|0;b[c>>0]=h&1;h=a+44|0;f[h>>2]=d;f[j>>2]=3;i4();d=(e|0)!=0;z=(g|0)!=0;if(d|z)A=0;else A=b[c>>0]|0;b[a+41>>0]=A;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;if(z){p[k>>3]=+n[g>>2];p[k+8>>3]=+n[g+4>>2];p[k+16>>3]=+n[g+8>>2]}else{f[k>>2]=f[93790];f[k+4>>2]=f[93791];f[k+8>>2]=f[93792];f[k+12>>2]=f[93793];f[k+16>>2]=f[93794];f[k+20>>2]=f[93795]}g=m;f[g>>2]=0;f[g+4>>2]=1072693248;cDa(l,m,k);m=l+8|0;f[m>>2]=0;f[m+4>>2]=1072693248;m=o;f[m>>2]=0;f[m+4>>2]=1072693248;cDa(l+16|0,o,k+16|0);if((f[j>>2]|0)<=0){u=i;return}k=q+4|0;o=q+8|0;m=r+4|0;g=0;do{f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;z=l+(g<<3)|0;A=g*3|0;if(d){p[t>>3]=+n[e+(A<<2)>>2];bDa(v,z,t);YCa(r,v);f[q>>2]=f[r>>2];c=A+1|0;p[t>>3]=+n[e+(c<<2)>>2];bDa(v,z,t);YCa(r,v);f[k>>2]=f[r>>2];p[t>>3]=+n[e+(A+2<<2)>>2];bDa(v,z,t);YCa(r,v);f[o>>2]=f[r>>2];B=c}else{bDa(w,z,375016+(A<<3)|0);YCa(r,w);f[q>>2]=f[r>>2];c=A+1|0;bDa(w,z,375016+(c<<3)|0);YCa(r,w);f[k>>2]=f[r>>2];bDa(w,z,375016+(A+2<<3)|0);YCa(r,w);f[o>>2]=f[r>>2];B=c}c=f[q>>2]|0;f[a+4+((f[h>>2]^2)+A<<2)>>2]=c;z=f[k>>2]|0;f[a+4+(B<<2)>>2]=z;C=f[o>>2]|0;f[a+4+((f[h>>2]|0)+A<<2)>>2]=C;A=!((f[s>>2]=c,+n[s>>2])>=0.0);c=A|!((f[s>>2]=z,+n[s>>2])>=0.0);if(!(!(c|!((f[s>>2]=C,+n[s>>2])>=0.0))?(LCa(x,q,k),LCa(y,x,o),JCa(r,1024),SCa(y,r)|0):0)){f[r>>2]=0;f[m>>2]=0;C=c$(r,93)|0;c=213870;z=C+93|0;do{b[C>>0]=b[c>>0]|0;C=C+1|0;c=c+1|0}while((C|0)<(z|0));j$(-215,r,213964,206245,6435);d$(r)}g=g+1|0}while((g|0)<(f[j>>2]|0));u=i;return}function h4(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+128|0;j=i+112|0;k=i+48|0;l=i+100|0;m=i+104|0;o=i+96|0;q=i+40|0;r=i+92|0;s=i+32|0;t=i+24|0;v=i+16|0;w=i+8|0;x=i;y=i+88|0;z=i+84|0;A=i+80|0;B=i+76|0;C=i+72|0;f[a>>2]=c;b[a+48>>0]=h&1;i4();f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[j>>2]=0;a:do if((f[j>>2]|0)<3){if(g|0)while(1){p[k+(f[j>>2]<<3)>>3]=+n[g+(f[j>>2]<<2)>>2];f[j>>2]=(f[j>>2]|0)+1;if((f[j>>2]|0)>=3)break a}do{h=375160+(f[j>>2]<<3)|0;c=k+(f[j>>2]<<3)|0;if((h|0)!=(c|0)){D=h;h=f[D+4>>2]|0;E=c;f[E>>2]=f[D>>2];f[E+4>>2]=h}f[j>>2]=(f[j>>2]|0)+1}while((f[j>>2]|0)<3)}while(0);f[j>>2]=0;if((f[j>>2]|0)<3){g=(e|0)==0;h=(d|0)==0;d=m+4|0;do{E=(f[j>>2]|0)*3|0;if(g){n[a+4+((f[j>>2]|0)*3<<2)>>2]=+p[375016+(E<<3)>>3];n[a+4+(((f[j>>2]|0)*3|0)+1<<2)>>2]=+p[375016+(((f[j>>2]|0)*3|0)+1<<3)>>3];n[a+4+(((f[j>>2]|0)*3|0)+2<<2)>>2]=+p[375016+(((f[j>>2]|0)*3|0)+2<<3)>>3]}else{f[a+4+((f[j>>2]|0)*3<<2)>>2]=f[e+(E<<2)>>2];f[a+4+(((f[j>>2]|0)*3|0)+1<<2)>>2]=f[e+(((f[j>>2]|0)*3|0)+1<<2)>>2];f[a+4+(((f[j>>2]|0)*3|0)+2<<2)>>2]=f[e+(((f[j>>2]|0)*3|0)+2<<2)>>2]}if(h){E=a+4+((f[j>>2]|0)*3<<2)|0;D=a+4+(((f[j>>2]|0)*3|0)+2<<2)|0;c=f[E>>2]|0;f[E>>2]=f[D>>2];f[D>>2]=c}if(!(((+n[a+4+((f[j>>2]|0)*3<<2)>>2]>=0.0?+n[a+4+(((f[j>>2]|0)*3|0)+1<<2)>>2]>=0.0:0)?+n[a+4+(((f[j>>2]|0)*3|0)+2<<2)>>2]>=0.0:0)?(f[l>>2]=f[a+4+((f[j>>2]|0)*3<<2)>>2],f[m>>2]=f[a+4+(((f[j>>2]|0)*3|0)+1<<2)>>2],LCa(o,l,m),f[q>>2]=f[a+4+(((f[j>>2]|0)*3|0)+2<<2)>>2],LCa(r,o,q),n[s>>2]=1.5,SCa(r,s)|0):0)){f[m>>2]=0;f[d>>2]=0;K1a(c$(m,158)|0,213510,158)|0;j$(-215,m,213669,206245,7505);d$(m)}f[j>>2]=(f[j>>2]|0)+1}while((f[j>>2]|0)<3)}j=k+8|0;UCa(s,15);bDa(q,j,s);ZCa(t,k,q);UCa(w,3);bDa(v,k+16|0,w);ZCa(x,t,v);YCa(m,x);f[y>>2]=1065353216;f[v>>2]=872415232;x=RCa(m,v)|0;f[s>>2]=f[(x?m:v)>>2];QCa(q,y,s);f[m>>2]=f[q>>2];JCa(q,52);PCa(z,m,q);YCa(s,k);PCa(A,z,s);f[a+40>>2]=f[A>>2];JCa(q,117);PCa(B,m,q);YCa(s,j);PCa(C,B,s);f[a+44>>2]=f[C>>2];C=q;f[C>>2]=0;f[C+4>>2]=1072693248;if(dDa(j,q)|0){u=i;return}f[q>>2]=0;f[q+4>>2]=0;j=c$(q,31)|0;C=213682;a=j+31|0;do{b[j>>0]=b[C>>0]|0;j=j+1|0;C=C+1|0}while((j|0)<(a|0));j$(-215,q,213669,206245,7519);d$(q);u=i;return}function i4(){var a=0,c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0;a=u;u=u+14992|0;c=a+10876|0;e=a+10880|0;g=a+10872|0;h=a+10868|0;i=a+6768|0;j=a+2668|0;k=a+2664|0;l=a+2656|0;m=a+2660|0;o=a+136|0;p=a+2652|0;q=a+2648|0;r=a+2644|0;s=a+2640|0;t=a+128|0;v=a+2636|0;w=a+2632|0;x=a+2628|0;y=a+2624|0;z=a+2620|0;A=a+2616|0;B=a+2612|0;C=a+104|0;D=a+2608|0;E=a+64|0;F=a+2604|0;G=a+2600|0;H=a+2596|0;I=a+2592|0;K=a+2588|0;L=a+120|0;M=a+112|0;N=a+2584|0;O=a+2580|0;P=a+2576|0;Q=a+2572|0;R=a+2568|0;S=a+2504|0;T=a+2564|0;U=a+2560|0;V=a+2556|0;W=a;X=a+2552|0;Z=a+2500|0;_=a+2496|0;$=a+2548|0;aa=a+2544|0;ba=a+2540|0;ca=a+56|0;da=a+48|0;ea=a+40|0;fa=a+32|0;ga=a+24|0;ha=a+2456|0;ia=a+2448|0;ja=a+2444|0;ka=a+2436|0;la=a+2428|0;ma=a+2424|0;na=a+2416|0;oa=a+2408|0;pa=a+2404|0;qa=a+2400|0;ra=a+2396|0;sa=a+2388|0;ta=a+2384|0;ua=a+2380|0;va=a+2376|0;wa=a+2368|0;xa=a+2492|0;ya=a+1320|0;za=a+2488|0;Aa=a+256|0;Ba=a+248|0;Ca=a+2484|0;Da=a+240|0;Ea=a+2480|0;Fa=a+232|0;Ga=a+2476|0;Ha=a+224|0;Ia=a+2472|0;Ja=a+2468|0;Ka=a+2464|0;La=a+2460|0;Ma=a+204|0;Na=a+2452|0;Oa=a+196|0;Pa=a+2440|0;Qa=a+2432|0;Ra=a+180|0;Sa=a+2420|0;Ta=a+2412|0;Ua=a+168|0;Va=a+164|0;Wa=a+160|0;Xa=a+2392|0;Ya=a+156|0;Za=a+152|0;_a=a+148|0;$a=a+2372|0;ab=a+144|0;bb=a+1312|0;cb=a+1308|0;db=a+1304|0;eb=a+252|0;fb=a+244|0;gb=a+236|0;hb=a+228|0;ib=a+220|0;jb=a+216|0;kb=a+212|0;lb=a+208|0;mb=a+200|0;nb=a+192|0;ob=a+188|0;pb=a+184|0;qb=a+176|0;rb=a+172|0;if(b[5689974]|0){u=a;return}if((b[375288]|0)==0?u1a(375288)|0:0){JCa(c,216);JCa(e,24389);QCa(940560,c,e)}if((b[375296]|0)==0?u1a(375296)|0:0){JCa(g,841);JCa(e,108);QCa(940564,g,e)}if((b[375304]|0)==0?u1a(375304)|0:0){JCa(h,16);JCa(e,116);QCa(940568,h,e)}if((b[375312]|0)==0?u1a(375312)|0:0)JCa(940572,255);F1a(e|0,0,4100)|0;F1a(i|0,0,4100)|0;F1a(j|0,0,4100)|0;f[l>>2]=1065353216;f[m>>2]=f[226117];QCa(k,l,m);l=0;do{JCa(o,l);PCa(m,k,o);if(SCa(m,940560)|0)fDa(o,m,940564,940568);else jDa(o,m);h=e+(l<<2)|0;if((o|0)!=(h|0))f[h>>2]=f[o>>2];l=l+1|0}while((l|0)!=1025);s4(e,924140);f[p>>2]=1065353216;n[o>>2]=1024.0;QCa(m,p,o);f[k>>2]=f[m>>2];p=0;do{JCa(o,p);PCa(m,k,o);f[q>>2]=f[m>>2];t4(o,q);e=i+(p<<2)|0;if((o|0)!=(e|0))f[e>>2]=f[o>>2];f[r>>2]=f[m>>2];u4(o,r);e=j+(p<<2)|0;if((o|0)!=(e|0))f[e>>2]=f[o>>2];p=p+1|0}while((p|0)!=1025);s4(i,907756);s4(j,940576);if((b[375320]|0)==0?u1a(375320)|0:0)JCa(956960,2040);j=0;do{JCa(s,j);QCa(m,s,940572);f[v>>2]=f[m>>2];t4(t,v);PCa(o,956960,t);i=(WCa(o)|0)&65535;d[3767616+(j<<1)>>1]=i;d[3768128+(j<<1)>>1]=j<<3;j=j+1|0}while((j|0)!=256);if((b[375328]|0)==0?u1a(375328)|0:0){f[w>>2]=1065353216;JCa(m,4096);QCa(956964,w,m)}w=0;do{JCa(o,w);PCa(m,956964,o);f[x>>2]=f[m>>2];u4(t,x);PCa(o,940572,t);j=(WCa(o)|0)&65535;d[3768640+(w<<1)>>1]=j;PCa(o,940572,m);j=(VCa(o)|0)&65535;d[3776832+(w<<1)>>1]=j;w=w+1|0}while((w|0)!=4096);if((b[375336]|0)==0?u1a(375336)|0:0)n[239242]=1.0/(+n[235143]*8.0);if((b[375344]|0)==0?u1a(375344)|0:0)JCa(956972,32768);w=0;do{JCa(o,w);PCa(m,956968,o);if(SCa(m,940560)|0)fDa(t,m,940564,940568);else jDa(t,m);PCa(o,956972,t);x=(WCa(o)|0)&65535;d[3785024+(w<<1)>>1]=x;w=w+1|0}while((w|0)!=3072);w=0;do{if((w|0)<21){JCa(y,Y(w,2949120)|0);JCa(o,414613);QCa(m,y,o);x=WCa(m)|0;JCa(z,16384);JCa(A,16);JCa(t,116);QCa(B,A,t);JCa(D,w*5|0);JCa(E,1479);QCa(C,D,E);LCa(o,B,C);PCa(m,z,o);sb=WCa(m)|0;tb=x}else{JCa(F,Y(w,1638400)|0);JCa(o,29580);QCa(G,F,o);JCa(H,262144);JCa(C,116);QCa(t,H,C);LCa(m,G,t);x=WCa(m)|0;PCa(I,m,m);PCa(K,I,m);JCa(t,268435456);QCa(o,K,t);sb=x;tb=WCa(o)|0}x=w<<1;d[3791168+(x<<1)>>1]=tb;d[3791168+((x|1)<<1)>>1]=sb;w=w+1|0}while((w|0)!=256);ub=-8145;do{if((ub|0)<3391)vb=((ub*108|0)/841|0)+-290|0;else vb=(Y((Y(ub,ub)|0)>>>14,ub)|0)/16384|0;f[956976+(ub+8145<<2)>>2]=vb;ub=ub+1|0}while((ub|0)!=28719);UCa(t,15);bDa(o,375168,t);ZCa(L,375160,o);UCa(E,3);bDa(C,375176,E);ZCa(M,L,C);YCa(m,M);f[N>>2]=1065353216;f[C>>2]=872415232;M=RCa(m,C)|0;f[t>>2]=f[(M?m:C)>>2];QCa(o,N,t);f[m>>2]=f[o>>2];JCa(t,52);PCa(O,m,t);YCa(C,375160);PCa(o,O,C);JCa(C,117);PCa(P,m,C);YCa(E,375168);PCa(t,P,E);f[Q>>2]=1065353216;JCa(E,4);QCa(C,Q,E);Q=0;do{JCa(R,Q*100|0);QCa(E,R,940572);P=Q<<8;m=0;do{JCa(T,m);PCa(U,T,904480);QCa(V,U,940572);LCa(S,V,904472);JCa(X,9);PCa(_,E,o);LCa(Z,S,_);PCa(W,X,Z);JCa(_,16);PCa(Z,W,_);O=WCa(Z)|0;f[1104432+(m+P<<2)>>2]=O;m=m+1|0}while((m|0)!=256);wb=0;do{JCa($,wb);PCa(aa,$,904492);QCa(ba,aa,940572);LCa(S,ba,904484);PCa(_,E,t);LCa(Z,S,_);QCa(W,C,Z);m=RCa(W,C)|0;O=f[C>>2]|0;if(m)f[W>>2]=O;f[Z>>2]=O^-2147483648;if(SCa(W,Z)|0)f[W>>2]=f[C>>2]^-2147483648;JCa(_,16777216);PCa(Z,W,_);O=WCa(Z)|0;m=wb+P|0;f[1366576+(m<<2)>>2]=O;N=Y(O,Q)|0;O=W1a(N|0,((N|0)<0)<<31>>31|0,249600,0)|0;N=375352+(m<<3)|0;f[N>>2]=O;f[N+4>>2]=J;wb=wb+1|0}while((wb|0)!=256);Q=Q+1|0}while((Q|0)!=256);Q=E;wb=Q+36|0;do{f[Q>>2]=0;Q=Q+4|0}while((Q|0)<(wb|0));Q=S;wb=Q+36|0;do{f[Q>>2]=0;Q=Q+4|0}while((Q|0)<(wb|0));Q=ca;f[Q>>2]=0;f[Q+4>>2]=1072693248;cDa(W,ca,375160);ca=W+8|0;f[ca>>2]=0;f[ca+4>>2]=1072693248;ca=da;f[ca>>2]=0;f[ca+4>>2]=1072693248;cDa(W+16|0,da,375176);da=0;do{ca=da*3|0;Q=375016+(ca<<3)|0;YCa(Z,Q);wb=ca+2|0;C=S+(wb<<2)|0;if((Z|0)!=(C|0))f[C>>2]=f[Z>>2];C=ca+1|0;ba=375016+(C<<3)|0;YCa(Z,ba);aa=S+(C<<2)|0;if((Z|0)!=(aa|0))f[aa>>2]=f[Z>>2];aa=375016+(wb<<3)|0;YCa(Z,aa);$=S+(ca<<2)|0;if((Z|0)!=($|0))f[$>>2]=f[Z>>2];$=W+(da<<3)|0;bDa(ea,aa,$);YCa(Z,ea);aa=E+(ca<<2)|0;if((Z|0)!=(aa|0))f[aa>>2]=f[Z>>2];bDa(fa,ba,$);YCa(Z,fa);ba=E+(C<<2)|0;if((Z|0)!=(ba|0))f[ba>>2]=f[Z>>2];bDa(ga,Q,$);YCa(Z,ga);$=E+(wb<<2)|0;if((Z|0)!=($|0))f[$>>2]=f[Z>>2];da=da+1|0}while((da|0)!=3);f[Z>>2]=f[E>>2];f[_>>2]=f[E+4>>2];f[ha>>2]=f[E+8>>2];f[ia>>2]=f[E+12>>2];f[ja>>2]=f[E+16>>2];f[ka>>2]=f[E+20>>2];f[la>>2]=f[E+24>>2];f[ma>>2]=f[E+28>>2];f[na>>2]=f[E+32>>2];f[oa>>2]=f[S>>2];f[pa>>2]=f[S+4>>2];f[qa>>2]=f[S+8>>2];f[ra>>2]=f[S+12>>2];f[sa>>2]=f[S+16>>2];f[ta>>2]=f[S+20>>2];f[ua>>2]=f[S+24>>2];f[va>>2]=f[S+28>>2];f[wa>>2]=f[S+32>>2];if((b[899640]|0)==0?u1a(899640)|0:0)JCa(1628720,32);if((b[899648]|0)==0?u1a(899648)|0:0)JCa(1628724,116);if((b[899656]|0)==0?u1a(899656)|0:0)JCa(1628728,16);if((b[899664]|0)==0?u1a(899664)|0:0)JCa(1628732,500);if((b[899672]|0)==0?u1a(899672)|0:0)JCa(1628736,200);if((b[899680]|0)==0?u1a(899680)|0:0)JCa(1628740,100);if((b[899688]|0)==0?u1a(899688)|0:0)JCa(1628744,128);if((b[899696]|0)==0?u1a(899696)|0:0)JCa(1628748,256);if((b[899704]|0)==0?u1a(899704)|0:0)JCa(1628752,16384);do if(!(b[899712]|0)){if(!(u1a(899712)|0))break;JCa(xa,24389);JCa(ya,27);QCa(1628756,xa,ya)}while(0);do if(!(b[899720]|0)){if(!(u1a(899720)|0))break;JCa(za,9);JCa(ya,4);QCa(1628760,za,ya)}while(0);do if(!(b[899728]|0)){if(!(u1a(899728)|0))break;JCa(1628764,15)}while(0);do if(!(b[899736]|0)){if(!(u1a(899736)|0))break;JCa(1628768,3)}while(0);za=ya+8|0;xa=ya+4|0;f[xa>>2]=107811;S=OYa(215622)|0;f[ya>>2]=S;S=Aa+8|0;f[Aa>>2]=S;E=Aa+4|0;f[E>>2]=107811;da=OYa(215622)|0;f[Aa>>2]=da;da=0;do{ga=da*3|0;fa=0;do{ea=(fa*99|0)+ga|0;W=0;do{$=ea+(W*3267|0)|0;JCa(Ca,da);QCa(Ba,Ca,1628720);JCa(Ea,fa);QCa(Da,Ea,1628720);JCa(Ga,W);QCa(Fa,Ga,1628720);f[Ia>>2]=f[Ba>>2];t4(Ha,Ia);f[Ba>>2]=f[Ha>>2];f[Ja>>2]=f[Da>>2];t4(Ha,Ja);f[Da>>2]=f[Ha>>2];f[Ka>>2]=f[Fa>>2];t4(Ha,Ka);f[Fa>>2]=f[Ha>>2];PCa(La,Ba,Z);PCa(Ma,Da,_);LCa(Na,La,Ma);PCa(Oa,Fa,ha);LCa(Ha,Na,Oa);PCa(Pa,Ba,ia);PCa(Oa,Da,ja);LCa(Qa,Pa,Oa);PCa(Ra,Fa,ka);LCa(Ma,Qa,Ra);PCa(Sa,Ba,la);PCa(Ra,Da,ma);LCa(Ta,Sa,Ra);PCa(Ua,Fa,na);LCa(Oa,Ta,Ua);if(RCa(Ha,940560)|0)jDa(Ra,Ha);else fDa(Ra,Ha,940564,940568);if(RCa(Ma,940560)|0)jDa(Ua,Ma);else fDa(Ua,Ma,940564,940568);if(RCa(Oa,940560)|0)jDa(Va,Oa);else fDa(Va,Oa,940564,940568);if(RCa(Ma,940560)|0){PCa(Xa,1628724,Ua);OCa(Wa,Xa,1628728)}else PCa(Wa,1628756,Ma);OCa(Za,Ra,Ua);PCa(Ya,1628732,Za);OCa(_a,Ua,Va);PCa(Za,1628736,_a);PCa($a,1628752,Wa);QCa(_a,$a,1628740);wb=(WCa(_a)|0)&65535;d[(f[ya>>2]|0)+($<<1)>>1]=wb;LCa(ab,Ya,1628744);PCa(bb,1628752,ab);QCa(_a,bb,1628748);wb=(WCa(_a)|0)&65535;Q=$+1|0;d[(f[ya>>2]|0)+(Q<<1)>>1]=wb;LCa(ab,Za,1628744);PCa(cb,1628752,ab);QCa(_a,cb,1628748);wb=(WCa(_a)|0)&65535;ba=$+2|0;d[(f[ya>>2]|0)+(ba<<1)>>1]=wb;PCa(db,Ba,oa);PCa(Ma,Da,pa);LCa(eb,db,Ma);PCa(Oa,Fa,qa);LCa(Ha,eb,Oa);PCa(fb,Ba,ra);PCa(Oa,Da,sa);LCa(gb,fb,Oa);PCa(Ra,Fa,ta);LCa(Ma,gb,Ra);PCa(hb,Ba,ua);PCa(Ra,Da,va);LCa(ib,hb,Ra);PCa(Ua,Fa,wa);LCa(Oa,ib,Ua);if(SCa(Ma,940560)|0)fDa(Ra,Ma,940564,940568);else jDa(Ra,Ma);PCa(jb,Ra,1628724);OCa(Ua,jb,1628728);f[Ra>>2]=f[Ua>>2];JCa(kb,52);PCa(Ya,1628764,Ma);LCa(lb,Ha,Ya);PCa(Za,1628768,Oa);LCa(Wa,lb,Za);n[_a>>2]=1.1920928955078125e-07;wb=RCa(Wa,_a)|0;f[Va>>2]=f[(wb?Wa:_a)>>2];QCa(Ua,kb,Va);PCa(mb,Ha,Ua);OCa(Wa,mb,o);PCa(Va,Ra,Wa);PCa(nb,1628760,Ma);PCa(ob,nb,Ua);OCa(Ya,ob,t);PCa(Wa,Ra,Ya);PCa(pb,1628752,Ra);QCa(Ya,pb,1628740);wb=(WCa(Ya)|0)&65535;d[(f[Aa>>2]|0)+($<<1)>>1]=wb;OCa(Za,Va,904472);PCa(qb,1628752,Za);QCa(Ya,qb,904480);wb=(WCa(Ya)|0)&65535;d[(f[Aa>>2]|0)+(Q<<1)>>1]=wb;OCa(Za,Wa,904484);PCa(rb,1628752,Za);QCa(Ya,rb,904492);wb=(WCa(Ya)|0)&65535;xb=f[Aa>>2]|0;d[xb+(ba<<1)>>1]=wb;W=W+1|0}while((W|0)<33);fa=fa+1|0}while((fa|0)<33);da=da+1|0}while((da|0)<33);da=f[ya>>2]|0;Ya=0;do{rb=Ya*3|0;Za=Ya*24|0;Ya=Ya+1|0;Wa=((Ya|0)<32?Ya:32)*3|0;qb=0;do{Va=qb*99|0;pb=Va+rb|0;Ra=(qb*792|0)+Za|0;qb=qb+1|0;t=((qb|0)<32?qb:32)*99|0;ob=t+rb|0;Ua=Va+Wa|0;Va=t+Wa|0;t=0;do{nb=t*3267|0;Ma=nb+pb|0;o=Ra+(t*26136|0)|0;d[3792192+(o<<1)>>1]=d[da+(Ma<<1)>>1]|0;mb=Ma+1|0;Ha=o+8|0;d[3792192+(Ha<<1)>>1]=d[da+(mb<<1)>>1]|0;kb=Ma+2|0;_a=o+16|0;d[3792192+(_a<<1)>>1]=d[da+(kb<<1)>>1]|0;d[1977104+(o<<1)>>1]=d[xb+(Ma<<1)>>1]|0;d[1977104+(Ha<<1)>>1]=d[xb+(mb<<1)>>1]|0;d[1977104+(_a<<1)>>1]=d[xb+(kb<<1)>>1]|0;t=t+1|0;kb=((t|0)<32?t:32)*3267|0;_a=kb+pb|0;mb=o|1;d[3792192+(mb<<1)>>1]=d[da+(_a<<1)>>1]|0;Ha=_a+1|0;Ma=mb+8|0;d[3792192+(Ma<<1)>>1]=d[da+(Ha<<1)>>1]|0;lb=_a+2|0;Oa=mb+16|0;d[3792192+(Oa<<1)>>1]=d[da+(lb<<1)>>1]|0;d[1977104+(mb<<1)>>1]=d[xb+(_a<<1)>>1]|0;d[1977104+(Ma<<1)>>1]=d[xb+(Ha<<1)>>1]|0;d[1977104+(Oa<<1)>>1]=d[xb+(lb<<1)>>1]|0;lb=nb+ob|0;Oa=o|2;d[3792192+(Oa<<1)>>1]=d[da+(lb<<1)>>1]|0;Ha=lb+1|0;Ma=Oa+8|0;d[3792192+(Ma<<1)>>1]=d[da+(Ha<<1)>>1]|0;_a=lb+2|0;mb=Oa+16|0;d[3792192+(mb<<1)>>1]=d[da+(_a<<1)>>1]|0;d[1977104+(Oa<<1)>>1]=d[xb+(lb<<1)>>1]|0;d[1977104+(Ma<<1)>>1]=d[xb+(Ha<<1)>>1]|0;d[1977104+(mb<<1)>>1]=d[xb+(_a<<1)>>1]|0;_a=kb+ob|0;mb=o|3;d[3792192+(mb<<1)>>1]=d[da+(_a<<1)>>1]|0;Ha=_a+1|0;Ma=mb+8|0;d[3792192+(Ma<<1)>>1]=d[da+(Ha<<1)>>1]|0;lb=_a+2|0;Oa=mb+16|0;d[3792192+(Oa<<1)>>1]=d[da+(lb<<1)>>1]|0;d[1977104+(mb<<1)>>1]=d[xb+(_a<<1)>>1]|0;d[1977104+(Ma<<1)>>1]=d[xb+(Ha<<1)>>1]|0;d[1977104+(Oa<<1)>>1]=d[xb+(lb<<1)>>1]|0;lb=nb+Ua|0;Oa=o|4;d[3792192+(Oa<<1)>>1]=d[da+(lb<<1)>>1]|0;Ha=lb+1|0;Ma=Oa+8|0;d[3792192+(Ma<<1)>>1]=d[da+(Ha<<1)>>1]|0;_a=lb+2|0;mb=Oa+16|0;d[3792192+(mb<<1)>>1]=d[da+(_a<<1)>>1]|0;d[1977104+(Oa<<1)>>1]=d[xb+(lb<<1)>>1]|0;d[1977104+(Ma<<1)>>1]=d[xb+(Ha<<1)>>1]|0;d[1977104+(mb<<1)>>1]=d[xb+(_a<<1)>>1]|0;_a=kb+Ua|0;mb=o|5;d[3792192+(mb<<1)>>1]=d[da+(_a<<1)>>1]|0;Ha=_a+1|0;Ma=mb+8|0;d[3792192+(Ma<<1)>>1]=d[da+(Ha<<1)>>1]|0;lb=_a+2|0;Oa=mb+16|0;d[3792192+(Oa<<1)>>1]=d[da+(lb<<1)>>1]|0;d[1977104+(mb<<1)>>1]=d[xb+(_a<<1)>>1]|0;d[1977104+(Ma<<1)>>1]=d[xb+(Ha<<1)>>1]|0;d[1977104+(Oa<<1)>>1]=d[xb+(lb<<1)>>1]|0;lb=nb+Va|0;nb=o|6;d[3792192+(nb<<1)>>1]=d[da+(lb<<1)>>1]|0;Oa=lb+1|0;Ha=nb+8|0;d[3792192+(Ha<<1)>>1]=d[da+(Oa<<1)>>1]|0;Ma=lb+2|0;_a=nb+16|0;d[3792192+(_a<<1)>>1]=d[da+(Ma<<1)>>1]|0;d[1977104+(nb<<1)>>1]=d[xb+(lb<<1)>>1]|0;d[1977104+(Ha<<1)>>1]=d[xb+(Oa<<1)>>1]|0;d[1977104+(_a<<1)>>1]=d[xb+(Ma<<1)>>1]|0;Ma=kb+Va|0;kb=o|7;d[3792192+(kb<<1)>>1]=d[da+(Ma<<1)>>1]|0;o=Ma+1|0;_a=kb+8|0;d[3792192+(_a<<1)>>1]=d[da+(o<<1)>>1]|0;Oa=Ma+2|0;Ha=kb+16|0;d[3792192+(Ha<<1)>>1]=d[da+(Oa<<1)>>1]|0;d[1977104+(kb<<1)>>1]=d[xb+(Ma<<1)>>1]|0;d[1977104+(_a<<1)>>1]=d[xb+(o<<1)>>1]|0;d[1977104+(Ha<<1)>>1]=d[xb+(Oa<<1)>>1]|0}while((t|0)!=33)}while((qb|0)!=33)}while((Ya|0)!=33);yb=0;do{Ya=yb<<3;xb=16-yb<<16>>16;da=0;do{qb=(da<<7)+Ya|0;Wa=16-da<<16>>16;rb=Y(Wa,xb)|0;Za=Y(da,xb)|0;t=Y(Wa,yb)|0;Wa=Y(da,yb)|0;Va=0;do{Ua=3702080+(qb+(Va<<11)<<1)|0;ob=16-Va<<16>>16;pb=(Y(ob,rb)|0)&65535;d[Ua>>1]=pb;pb=(Y(Va,rb)|0)&65535;d[Ua+2>>1]=pb;pb=(Y(ob,Za)|0)&65535;d[Ua+4>>1]=pb;pb=(Y(Va,Za)|0)&65535;d[Ua+6>>1]=pb;pb=(Y(ob,t)|0)&65535;d[Ua+8>>1]=pb;pb=(Y(Va,t)|0)&65535;d[Ua+10>>1]=pb;pb=(Y(ob,Wa)|0)&65535;d[Ua+12>>1]=pb;pb=(Y(Va,Wa)|0)&65535;d[Ua+14>>1]=pb;Va=Va+1|0}while((Va|0)!=16);da=da+1|0}while((da|0)!=16);yb=yb+1|0}while((yb|0)!=16);yb=f[Aa>>2]|0;if((yb|0)!=(S|0)){if(yb|0)QYa(yb);f[Aa>>2]=S;f[E>>2]=520}E=f[ya>>2]|0;if((E|0)!=(za|0)){if(E|0)QYa(E);f[ya>>2]=za;f[xa>>2]=520}b[5689974]=1;u=a;return}function j4(a){a=a|0;PYa(a);return}function k4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,47768);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){l4(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function l4(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0;g=u;u=u+32|0;h=g+16|0;i=g+12|0;j=g+8|0;k=g+4|0;l=g;m=f[a>>2]|0;o=(b[a+48>>0]|0)!=0;p=o?907756:0;q=+n[a+4>>2];r=+n[a+8>>2];t=+n[a+12>>2];v=+n[a+16>>2];w=+n[a+20>>2];x=+n[a+24>>2];y=+n[a+28>>2];z=+n[a+32>>2];A=+n[a+36>>2];B=e*3|0;if((e|0)<=0){u=g;return}e=a+40|0;C=a+44|0;a=0;D=c;while(1){c=f[D>>2]|0;f[h>>2]=c;E=f[D+4>>2]|0;f[i>>2]=E;F=f[D+8>>2]|0;f[j>>2]=F;n[k>>2]=0.0;G=(f[s>>2]=c,+n[s>>2])<0.0?k:h;n[l>>2]=1.0;c=f[(+n[G>>2]>1.0?l:G)>>2]|0;f[h>>2]=c;n[k>>2]=0.0;G=(f[s>>2]=E,+n[s>>2])<0.0?k:i;n[l>>2]=1.0;E=f[(+n[G>>2]>1.0?l:G)>>2]|0;f[i>>2]=E;n[k>>2]=0.0;G=(f[s>>2]=F,+n[s>>2])<0.0?k:j;n[l>>2]=1.0;F=f[(+n[G>>2]>1.0?l:G)>>2]|0;f[j>>2]=F;H=(f[s>>2]=c,+n[s>>2]);I=(f[s>>2]=E,+n[s>>2]);J=(f[s>>2]=F,+n[s>>2]);if(o){K=H*1024.0;F=~~K;E=(F|0)>0?F:0;F=(E|0)<1023?E:1023;L=K-+(F|0);E=p+(F<<2<<2)|0;K=+n[E>>2]+L*(+n[E+4>>2]+L*(+n[E+8>>2]+ +n[E+12>>2]*L));n[h>>2]=K;L=I*1024.0;E=~~L;F=(E|0)>0?E:0;E=(F|0)<1023?F:1023;M=L-+(E|0);F=p+(E<<2<<2)|0;L=+n[F>>2]+M*(+n[F+4>>2]+M*(+n[F+8>>2]+ +n[F+12>>2]*M));n[i>>2]=L;M=J*1024.0;F=~~M;E=(F|0)>0?F:0;F=(E|0)<1023?E:1023;N=M-+(F|0);E=p+(F<<2<<2)|0;M=+n[E>>2]+N*(+n[E+4>>2]+N*(+n[E+8>>2]+ +n[E+12>>2]*N));n[j>>2]=M;O=M;P=L;Q=K}else{O=J;P=I;Q=H}H=q*Q+r*P+t*O;I=v*Q+w*P+x*O;J=+n[226117]*I;E=~~J;F=(E|0)>0?E:0;E=(F|0)<1023?F:1023;K=J-+(E|0);F=924140+(E<<2<<2)|0;J=(+n[F>>2]+K*(+n[F+4>>2]+K*(+n[F+8>>2]+ +n[F+12>>2]*K)))*116.0+-16.0;K=(y*Q+z*P+A*O)*3.0+(H+I*15.0);L=52.0/(K<1.1920928955078125e-07?1.1920928955078125e-07:K);K=(H*L-+n[e>>2])*J;H=(I*2.25*L-+n[C>>2])*J;n[d+(a<<2)>>2]=J;n[d+(a+1<<2)>>2]=K;n[d+(a+2<<2)>>2]=H;a=a+3|0;if((a|0)>=(B|0))break;else D=D+(m<<2)|0}u=g;return}function m4(a){a=a|0;PYa(a);return}function n4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,47788);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){o4(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function o4(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0;g=u;u=u+3104|0;i=g;j=g+3088|0;k=g+3092|0;l=g+3084|0;m=g+3080|0;o=g+3076|0;p=g+3072|0;if(b[a+64>>0]|0){p4(a+56|0,c,d,e);u=g;return}q=f[a>>2]|0;if((b[375232]|0)==0?u1a(375232)|0:0)JCa(940528,255);if((e|0)>0){r=a+4|0;a=d;d=0;s=c;while(1){c=e-d|0;t=(c|0)<256?c:256;if((b[375240]|0)==0?u1a(375240)|0:0){f[j>>2]=1065353216;QCa(940532,j,940528)}v=t*3|0;w=(c|0)>0;if(w){x=+n[235133];c=0;y=s;while(1){n[i+(c<<2)>>2]=+(h[y>>0]|0)*x;n[i+(c+1<<2)>>2]=+(h[y+1>>0]|0)*x;n[i+(c+2<<2)>>2]=+(h[y+2>>0]|0)*x;c=c+3|0;z=y+q|0;if((c|0)>=(v|0)){A=z;break}else y=z}}else A=s;l4(r,i,i,t);if((b[375248]|0)==0?u1a(375248)|0:0){JCa(k,100);QCa(940536,940528,k)}if((b[375256]|0)==0?u1a(375256)|0:0)QCa(940540,940528,904480);if((b[375264]|0)==0?u1a(375264)|0:0)QCa(940544,940528,904492);if((b[375272]|0)==0?u1a(375272)|0:0){f[l>>2]=f[226118]^-2147483648;PCa(m,l,940528);QCa(940548,m,904480)}if((b[375280]|0)==0?u1a(375280)|0:0){f[o>>2]=f[226121]^-2147483648;PCa(p,o,940528);QCa(940552,p,904492)}if(w){y=0;do{c=wNa(+n[i+(y<<2)>>2]*+n[235134])|0;b[a+y>>0]=c>>>0<256?c:(c|0)>0?255:0;c=y+1|0;z=wNa(+n[i+(c<<2)>>2]*+n[235135]+ +n[235137])|0;b[a+c>>0]=z>>>0<256?z:(z|0)>0?255:0;z=y+2|0;c=wNa(+n[i+(z<<2)>>2]*+n[235136]+ +n[235138])|0;b[a+z>>0]=c>>>0<256?c:(c|0)>0?255:0;y=y+3|0}while((y|0)<(v|0))}d=d+256|0;if((d|0)>=(e|0))break;else{a=a+768|0;s=A}}}u=g;return}function p4(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0;i=u;u=u+304|0;k=i+32|0;l=i+16|0;m=i;n=i+288|0;o=i+224|0;p=i+208|0;q=i+192|0;r=i+176|0;s=i+160|0;t=i+144|0;v=i+128|0;w=i+112|0;x=i+96|0;y=i+80|0;z=i+64|0;A=i+48|0;B=i+272|0;C=i+256|0;D=i+240|0;E=f[a>>2]|0;F=f[a+4>>2]|0;a=g*3|0;g=a+-48|0;if((a|0)>48){G=(E|0)==3;H=(F|0)==0;I=k+8|0;J=k+1|0;K=o+2|0;L=k+9|0;M=p+2|0;N=k+2|0;O=o+4|0;P=k+10|0;Q=p+4|0;R=k+3|0;S=o+6|0;T=k+11|0;U=p+6|0;V=k+4|0;W=o+8|0;X=k+12|0;Y=p+8|0;Z=k+5|0;_=o+10|0;$=k+13|0;aa=p+10|0;ba=k+6|0;ca=o+12|0;da=k+14|0;ea=p+12|0;fa=k+7|0;ga=o+14|0;ha=k+15|0;ia=p+14|0;ja=l+8|0;ka=l+1|0;la=q+2|0;ma=l+9|0;na=r+2|0;oa=l+2|0;pa=q+4|0;qa=l+10|0;ra=r+4|0;sa=l+3|0;ta=q+6|0;ua=l+11|0;va=r+6|0;wa=l+4|0;xa=q+8|0;ya=l+12|0;za=r+8|0;Aa=l+5|0;Ba=q+10|0;Ca=l+13|0;Da=r+10|0;Ea=l+6|0;Fa=q+12|0;Ga=l+14|0;Ha=r+12|0;Ia=l+7|0;Ja=q+14|0;Ka=l+15|0;La=r+14|0;Ma=m+8|0;Na=m+1|0;Oa=s+2|0;Pa=m+9|0;Qa=t+2|0;Ra=m+2|0;Sa=s+4|0;Ta=m+10|0;Ua=t+4|0;Va=m+3|0;Wa=s+6|0;Xa=m+11|0;Ya=t+6|0;Za=m+4|0;_a=s+8|0;$a=m+12|0;ab=t+8|0;bb=m+5|0;cb=s+10|0;db=m+13|0;eb=t+10|0;fb=m+6|0;gb=s+12|0;hb=m+14|0;ib=t+12|0;jb=m+7|0;kb=s+14|0;lb=m+15|0;mb=t+14|0;nb=v+2|0;ob=v+4|0;pb=v+6|0;qb=v+8|0;rb=v+10|0;sb=v+12|0;tb=v+14|0;ub=y+2|0;vb=y+4|0;wb=y+6|0;xb=y+8|0;yb=y+10|0;zb=y+12|0;Ab=y+14|0;Bb=w+2|0;Cb=w+4|0;Db=w+6|0;Eb=w+8|0;Fb=w+10|0;Gb=w+12|0;Hb=w+14|0;Ib=z+2|0;Jb=z+4|0;Kb=z+6|0;Lb=z+8|0;Mb=z+10|0;Nb=z+12|0;Ob=z+14|0;Pb=x+2|0;Qb=x+4|0;Rb=x+6|0;Sb=x+8|0;Tb=x+10|0;Ub=x+12|0;Vb=x+14|0;Wb=A+2|0;Xb=A+4|0;Yb=A+6|0;Zb=A+8|0;_b=A+10|0;$b=A+12|0;ac=A+14|0;bc=B+8|0;cc=B+1|0;dc=B+9|0;ec=B+2|0;fc=B+10|0;gc=B+3|0;hc=B+11|0;ic=B+4|0;jc=B+12|0;kc=B+5|0;lc=B+13|0;mc=B+6|0;nc=B+14|0;oc=B+7|0;pc=B+15|0;qc=C+8|0;rc=C+1|0;sc=C+9|0;tc=C+2|0;uc=C+10|0;vc=C+3|0;wc=C+11|0;xc=C+4|0;yc=C+12|0;zc=C+5|0;Ac=C+13|0;Bc=C+6|0;Cc=C+14|0;Dc=C+7|0;Ec=C+15|0;Fc=D+8|0;Gc=D+1|0;Hc=D+9|0;Ic=D+2|0;Jc=D+10|0;Kc=D+3|0;Lc=D+11|0;Mc=D+4|0;Nc=D+12|0;Oc=D+5|0;Pc=D+13|0;Qc=D+6|0;Rc=D+14|0;Sc=D+7|0;Tc=D+15|0;Uc=E<<4;Vc=0;Wc=c;while(1){if(G){Xc=0;Yc=0;while(1){b[k+Xc>>0]=b[Wc+Yc>>0]|0;b[l+Xc>>0]=b[Wc+(Yc+1)>>0]|0;b[m+Xc>>0]=b[Wc+(Yc+2)>>0]|0;Xc=Xc+1|0;if((Xc|0)==16)break;else Yc=Yc+3|0}}else{Yc=0;Xc=0;while(1){b[k+Yc>>0]=b[Wc+Xc>>0]|0;b[l+Yc>>0]=b[Wc+(Xc|1)>>0]|0;b[m+Yc>>0]=b[Wc+(Xc|2)>>0]|0;b[n+Yc>>0]=b[Wc+(Xc|3)>>0]|0;Yc=Yc+1|0;if((Yc|0)==16)break;else Xc=Xc+4|0}}if(!H){Xc=n;Yc=k;Zc=Xc+16|0;do{b[Xc>>0]=b[Yc>>0]|0;Xc=Xc+1|0;Yc=Yc+1|0}while((Xc|0)<(Zc|0));Xc=k;Yc=m;Zc=Xc+16|0;do{b[Xc>>0]=b[Yc>>0]|0;Xc=Xc+1|0;Yc=Yc+1|0}while((Xc|0)<(Zc|0));Xc=m;Yc=n;Zc=Xc+16|0;do{b[Xc>>0]=b[Yc>>0]|0;Xc=Xc+1|0;Yc=Yc+1|0}while((Xc|0)<(Zc|0))}d[o>>1]=h[k>>0]|0;d[p>>1]=h[I>>0]|0;d[K>>1]=h[J>>0]|0;d[M>>1]=h[L>>0]|0;d[O>>1]=h[N>>0]|0;d[Q>>1]=h[P>>0]|0;d[S>>1]=h[R>>0]|0;d[U>>1]=h[T>>0]|0;d[W>>1]=h[V>>0]|0;d[Y>>1]=h[X>>0]|0;d[_>>1]=h[Z>>0]|0;d[aa>>1]=h[$>>0]|0;d[ca>>1]=h[ba>>0]|0;d[ea>>1]=h[da>>0]|0;d[ga>>1]=h[fa>>0]|0;d[ia>>1]=h[ha>>0]|0;d[q>>1]=h[l>>0]|0;d[r>>1]=h[ja>>0]|0;d[la>>1]=h[ka>>0]|0;d[na>>1]=h[ma>>0]|0;d[pa>>1]=h[oa>>0]|0;d[ra>>1]=h[qa>>0]|0;d[ta>>1]=h[sa>>0]|0;d[va>>1]=h[ua>>0]|0;d[xa>>1]=h[wa>>0]|0;d[za>>1]=h[ya>>0]|0;d[Ba>>1]=h[Aa>>0]|0;d[Da>>1]=h[Ca>>0]|0;d[Fa>>1]=h[Ea>>0]|0;d[Ha>>1]=h[Ga>>0]|0;d[Ja>>1]=h[Ia>>0]|0;d[La>>1]=h[Ka>>0]|0;d[s>>1]=h[m>>0]|0;d[t>>1]=h[Ma>>0]|0;d[Oa>>1]=h[Na>>0]|0;d[Qa>>1]=h[Pa>>0]|0;d[Sa>>1]=h[Ra>>0]|0;d[Ua>>1]=h[Ta>>0]|0;d[Wa>>1]=h[Va>>0]|0;d[Ya>>1]=h[Xa>>0]|0;d[_a>>1]=h[Za>>0]|0;d[ab>>1]=h[$a>>0]|0;d[cb>>1]=h[bb>>0]|0;d[eb>>1]=h[db>>0]|0;d[gb>>1]=h[fb>>0]|0;d[ib>>1]=h[hb>>0]|0;d[kb>>1]=h[jb>>0]|0;d[mb>>1]=h[lb>>0]|0;Yc=(j[K>>1]|0)<<6&65535;Xc=(j[O>>1]|0)<<6&65535;Zc=(j[S>>1]|0)<<6&65535;_c=(j[W>>1]|0)<<6&65535;$c=(j[_>>1]|0)<<6&65535;ad=(j[ca>>1]|0)<<6&65535;bd=(j[ga>>1]|0)<<6&65535;d[o>>1]=(j[o>>1]|0)<<6;d[K>>1]=Yc;d[O>>1]=Xc;d[S>>1]=Zc;d[W>>1]=_c;d[_>>1]=$c;d[ca>>1]=ad;d[ga>>1]=bd;bd=(j[M>>1]|0)<<6&65535;ad=(j[Q>>1]|0)<<6&65535;$c=(j[U>>1]|0)<<6&65535;_c=(j[Y>>1]|0)<<6&65535;Zc=(j[aa>>1]|0)<<6&65535;Xc=(j[ea>>1]|0)<<6&65535;Yc=(j[ia>>1]|0)<<6&65535;d[p>>1]=(j[p>>1]|0)<<6;d[M>>1]=bd;d[Q>>1]=ad;d[U>>1]=$c;d[Y>>1]=_c;d[aa>>1]=Zc;d[ea>>1]=Xc;d[ia>>1]=Yc;Yc=(j[la>>1]|0)<<6&65535;Xc=(j[pa>>1]|0)<<6&65535;Zc=(j[ta>>1]|0)<<6&65535;_c=(j[xa>>1]|0)<<6&65535;$c=(j[Ba>>1]|0)<<6&65535;ad=(j[Fa>>1]|0)<<6&65535;bd=(j[Ja>>1]|0)<<6&65535;d[q>>1]=(j[q>>1]|0)<<6;d[la>>1]=Yc;d[pa>>1]=Xc;d[ta>>1]=Zc;d[xa>>1]=_c;d[Ba>>1]=$c;d[Fa>>1]=ad;d[Ja>>1]=bd;bd=(j[na>>1]|0)<<6&65535;ad=(j[ra>>1]|0)<<6&65535;$c=(j[va>>1]|0)<<6&65535;_c=(j[za>>1]|0)<<6&65535;Zc=(j[Da>>1]|0)<<6&65535;Xc=(j[Ha>>1]|0)<<6&65535;Yc=(j[La>>1]|0)<<6&65535;d[r>>1]=(j[r>>1]|0)<<6;d[na>>1]=bd;d[ra>>1]=ad;d[va>>1]=$c;d[za>>1]=_c;d[Da>>1]=Zc;d[Ha>>1]=Xc;d[La>>1]=Yc;Yc=(j[Oa>>1]|0)<<6&65535;Xc=(j[Sa>>1]|0)<<6&65535;Zc=(j[Wa>>1]|0)<<6&65535;_c=(j[_a>>1]|0)<<6&65535;$c=(j[cb>>1]|0)<<6&65535;ad=(j[gb>>1]|0)<<6&65535;bd=(j[kb>>1]|0)<<6&65535;d[s>>1]=(j[s>>1]|0)<<6;d[Oa>>1]=Yc;d[Sa>>1]=Xc;d[Wa>>1]=Zc;d[_a>>1]=_c;d[cb>>1]=$c;d[gb>>1]=ad;d[kb>>1]=bd;bd=(j[Qa>>1]|0)<<6&65535;ad=(j[Ua>>1]|0)<<6&65535;$c=(j[Ya>>1]|0)<<6&65535;_c=(j[ab>>1]|0)<<6&65535;Zc=(j[eb>>1]|0)<<6&65535;Xc=(j[ib>>1]|0)<<6&65535;Yc=(j[mb>>1]|0)<<6&65535;d[t>>1]=(j[t>>1]|0)<<6;d[Qa>>1]=bd;d[Ua>>1]=ad;d[Ya>>1]=$c;d[ab>>1]=_c;d[eb>>1]=Zc;d[ib>>1]=Xc;d[mb>>1]=Yc;q4(o,q,s,1977104,v,w,x);q4(p,r,t,1977104,y,z,A);Yc=(j[nb>>1]|0)>>>6;Xc=(j[ob>>1]|0)>>>6;Zc=(j[pb>>1]|0)>>>6;_c=(j[qb>>1]|0)>>>6;$c=(j[rb>>1]|0)>>>6;ad=(j[sb>>1]|0)>>>6;bd=(j[tb>>1]|0)>>>6;d[v>>1]=(j[v>>1]|0)>>>6;d[nb>>1]=Yc;d[ob>>1]=Xc;d[pb>>1]=Zc;d[qb>>1]=_c;d[rb>>1]=$c;d[sb>>1]=ad;d[tb>>1]=bd;bd=(j[ub>>1]|0)>>>6;ad=(j[vb>>1]|0)>>>6;$c=(j[wb>>1]|0)>>>6;_c=(j[xb>>1]|0)>>>6;Zc=(j[yb>>1]|0)>>>6;Xc=(j[zb>>1]|0)>>>6;Yc=(j[Ab>>1]|0)>>>6;d[y>>1]=(j[y>>1]|0)>>>6;d[ub>>1]=bd;d[vb>>1]=ad;d[wb>>1]=$c;d[xb>>1]=_c;d[yb>>1]=Zc;d[zb>>1]=Xc;d[Ab>>1]=Yc;Yc=(j[Bb>>1]|0)>>>6;Xc=(j[Cb>>1]|0)>>>6;Zc=(j[Db>>1]|0)>>>6;_c=(j[Eb>>1]|0)>>>6;$c=(j[Fb>>1]|0)>>>6;ad=(j[Gb>>1]|0)>>>6;bd=(j[Hb>>1]|0)>>>6;d[w>>1]=(j[w>>1]|0)>>>6;d[Bb>>1]=Yc;d[Cb>>1]=Xc;d[Db>>1]=Zc;d[Eb>>1]=_c;d[Fb>>1]=$c;d[Gb>>1]=ad;d[Hb>>1]=bd;bd=(j[Ib>>1]|0)>>>6;ad=(j[Jb>>1]|0)>>>6;$c=(j[Kb>>1]|0)>>>6;_c=(j[Lb>>1]|0)>>>6;Zc=(j[Mb>>1]|0)>>>6;Xc=(j[Nb>>1]|0)>>>6;Yc=(j[Ob>>1]|0)>>>6;d[z>>1]=(j[z>>1]|0)>>>6;d[Ib>>1]=bd;d[Jb>>1]=ad;d[Kb>>1]=$c;d[Lb>>1]=_c;d[Mb>>1]=Zc;d[Nb>>1]=Xc;d[Ob>>1]=Yc;Yc=(j[Pb>>1]|0)>>>6;Xc=(j[Qb>>1]|0)>>>6;Zc=(j[Rb>>1]|0)>>>6;_c=(j[Sb>>1]|0)>>>6;$c=(j[Tb>>1]|0)>>>6;ad=(j[Ub>>1]|0)>>>6;bd=(j[Vb>>1]|0)>>>6;d[x>>1]=(j[x>>1]|0)>>>6;d[Pb>>1]=Yc;d[Qb>>1]=Xc;d[Rb>>1]=Zc;d[Sb>>1]=_c;d[Tb>>1]=$c;d[Ub>>1]=ad;d[Vb>>1]=bd;bd=(j[Wb>>1]|0)>>>6;ad=(j[Xb>>1]|0)>>>6;$c=(j[Yb>>1]|0)>>>6;_c=(j[Zb>>1]|0)>>>6;Zc=(j[_b>>1]|0)>>>6;Xc=(j[$b>>1]|0)>>>6;Yc=(j[ac>>1]|0)>>>6;d[A>>1]=(j[A>>1]|0)>>>6;d[Wb>>1]=bd;d[Xb>>1]=ad;d[Yb>>1]=$c;d[Zb>>1]=_c;d[_b>>1]=Zc;d[$b>>1]=Xc;d[ac>>1]=Yc;Yc=j[v>>1]|0;b[B>>0]=Yc>>>0<255?Yc:255;Yc=j[y>>1]|0;b[bc>>0]=Yc>>>0<255?Yc:255;Yc=j[nb>>1]|0;b[cc>>0]=Yc>>>0<255?Yc:255;Yc=j[ub>>1]|0;b[dc>>0]=Yc>>>0<255?Yc:255;Yc=j[ob>>1]|0;b[ec>>0]=Yc>>>0<255?Yc:255;Yc=j[vb>>1]|0;b[fc>>0]=Yc>>>0<255?Yc:255;Yc=j[pb>>1]|0;b[gc>>0]=Yc>>>0<255?Yc:255;Yc=j[wb>>1]|0;b[hc>>0]=Yc>>>0<255?Yc:255;Yc=j[qb>>1]|0;b[ic>>0]=Yc>>>0<255?Yc:255;Yc=j[xb>>1]|0;b[jc>>0]=Yc>>>0<255?Yc:255;Yc=j[rb>>1]|0;b[kc>>0]=Yc>>>0<255?Yc:255;Yc=j[yb>>1]|0;b[lc>>0]=Yc>>>0<255?Yc:255;Yc=j[sb>>1]|0;b[mc>>0]=Yc>>>0<255?Yc:255;Yc=j[zb>>1]|0;b[nc>>0]=Yc>>>0<255?Yc:255;Yc=j[tb>>1]|0;b[oc>>0]=Yc>>>0<255?Yc:255;Yc=j[Ab>>1]|0;b[pc>>0]=Yc>>>0<255?Yc:255;Yc=j[w>>1]|0;b[C>>0]=Yc>>>0<255?Yc:255;Yc=j[z>>1]|0;b[qc>>0]=Yc>>>0<255?Yc:255;Yc=j[Bb>>1]|0;b[rc>>0]=Yc>>>0<255?Yc:255;Yc=j[Ib>>1]|0;b[sc>>0]=Yc>>>0<255?Yc:255;Yc=j[Cb>>1]|0;b[tc>>0]=Yc>>>0<255?Yc:255;Yc=j[Jb>>1]|0;b[uc>>0]=Yc>>>0<255?Yc:255;Yc=j[Db>>1]|0;b[vc>>0]=Yc>>>0<255?Yc:255;Yc=j[Kb>>1]|0;b[wc>>0]=Yc>>>0<255?Yc:255;Yc=j[Eb>>1]|0;b[xc>>0]=Yc>>>0<255?Yc:255;Yc=j[Lb>>1]|0;b[yc>>0]=Yc>>>0<255?Yc:255;Yc=j[Fb>>1]|0;b[zc>>0]=Yc>>>0<255?Yc:255;Yc=j[Mb>>1]|0;b[Ac>>0]=Yc>>>0<255?Yc:255;Yc=j[Gb>>1]|0;b[Bc>>0]=Yc>>>0<255?Yc:255;Yc=j[Nb>>1]|0;b[Cc>>0]=Yc>>>0<255?Yc:255;Yc=j[Hb>>1]|0;b[Dc>>0]=Yc>>>0<255?Yc:255;Yc=j[Ob>>1]|0;b[Ec>>0]=Yc>>>0<255?Yc:255;Yc=j[x>>1]|0;Xc=(Yc>>>0<255?Yc:255)&255;b[D>>0]=Xc;Yc=j[A>>1]|0;b[Fc>>0]=Yc>>>0<255?Yc:255;Yc=j[Pb>>1]|0;b[Gc>>0]=Yc>>>0<255?Yc:255;Yc=j[Wb>>1]|0;b[Hc>>0]=Yc>>>0<255?Yc:255;Yc=j[Qb>>1]|0;b[Ic>>0]=Yc>>>0<255?Yc:255;Yc=j[Xb>>1]|0;b[Jc>>0]=Yc>>>0<255?Yc:255;Yc=j[Rb>>1]|0;b[Kc>>0]=Yc>>>0<255?Yc:255;Yc=j[Yb>>1]|0;b[Lc>>0]=Yc>>>0<255?Yc:255;Yc=j[Sb>>1]|0;b[Mc>>0]=Yc>>>0<255?Yc:255;Yc=j[Zb>>1]|0;b[Nc>>0]=Yc>>>0<255?Yc:255;Yc=j[Tb>>1]|0;b[Oc>>0]=Yc>>>0<255?Yc:255;Yc=j[_b>>1]|0;b[Pc>>0]=Yc>>>0<255?Yc:255;Yc=j[Ub>>1]|0;b[Qc>>0]=Yc>>>0<255?Yc:255;Yc=j[$b>>1]|0;b[Rc>>0]=Yc>>>0<255?Yc:255;Yc=j[Vb>>1]|0;b[Sc>>0]=Yc>>>0<255?Yc:255;Yc=j[ac>>1]|0;b[Tc>>0]=Yc>>>0<255?Yc:255;Yc=e+Vc|0;b[Yc>>0]=b[B>>0]|0;b[Yc+1>>0]=b[C>>0]|0;b[Yc+2>>0]=Xc;Xc=0;Zc=1;do{_c=Xc;Xc=Xc+3|0;$c=b[D+Zc>>0]|0;b[Yc+Xc>>0]=b[B+Zc>>0]|0;b[Yc+(_c+4)>>0]=b[C+Zc>>0]|0;b[Yc+(_c+5)>>0]=$c;Zc=Zc+1|0}while((Zc|0)!=16);Zc=Vc+48|0;Yc=Wc+Uc|0;if((Zc|0)<(g|0)){Vc=Zc;Wc=Yc}else{cd=Zc;dd=Yc;break}}}else{cd=0;dd=c}if((cd|0)>=(a|0)){u=i;return}c=F^2;Wc=cd;cd=dd;while(1){r4((h[cd+F>>0]|0)<<6,(h[cd+1>>0]|0)<<6,(h[cd+c>>0]|0)<<6,1977104,k,l,m);dd=f[k>>2]|0;Vc=(dd|0)/64|0;b[e+Wc>>0]=Vc>>>0<256?Vc:(dd|0)>63?255:0;dd=f[l>>2]|0;Vc=(dd|0)/64|0;b[e+(Wc+1)>>0]=Vc>>>0<256?Vc:(dd|0)>63?255:0;dd=f[m>>2]|0;Vc=(dd|0)/64|0;b[e+(Wc+2)>>0]=Vc>>>0<256?Vc:(dd|0)>63?255:0;Wc=Wc+3|0;if((Wc|0)>=(a|0))break;else cd=cd+E|0}u=i;return}function q4(a,b,c,e,f,g,h){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0;i=d[a>>1]|0;j=d[a+2>>1]|0;k=d[a+4>>1]|0;l=d[a+6>>1]|0;m=d[a+8>>1]|0;n=d[a+10>>1]|0;o=d[a+12>>1]|0;p=d[a+14>>1]|0;a=d[b>>1]|0;q=d[b+2>>1]|0;r=d[b+4>>1]|0;s=d[b+6>>1]|0;t=d[b+8>>1]|0;u=d[b+10>>1]|0;v=d[b+12>>1]|0;w=d[b+14>>1]|0;b=d[c>>1]|0;x=d[c+2>>1]|0;y=d[c+4>>1]|0;z=d[c+6>>1]|0;A=d[c+8>>1]|0;B=d[c+10>>1]|0;C=d[c+12>>1]|0;D=d[c+14>>1]|0;c=e+((((a&65535)>>>9&65535)*792|0)+(((i&65535)>>>9)*24&65535)+(((b&65535)>>>9&65535)*26136|0)<<1)|0;E=c+16|0;F=d[E>>1]|0;G=d[E+2>>1]|0;H=d[E+4>>1]|0;I=d[E+6>>1]|0;J=d[E+8>>1]|0;K=d[E+10>>1]|0;L=d[E+12>>1]|0;M=d[E+14>>1]|0;E=c+32|0;N=d[E>>1]|0;O=d[E+2>>1]|0;P=d[E+4>>1]|0;Q=d[E+6>>1]|0;R=d[E+8>>1]|0;S=d[E+10>>1]|0;T=d[E+12>>1]|0;U=d[E+14>>1]|0;E=e+((((q&65535)>>>9&65535)*792|0)+(((j&65535)>>>9)*24&65535)+(((x&65535)>>>9&65535)*26136|0)<<1)|0;V=E+16|0;W=d[V>>1]|0;X=d[V+2>>1]|0;Z=d[V+4>>1]|0;_=d[V+6>>1]|0;$=d[V+8>>1]|0;aa=d[V+10>>1]|0;ba=d[V+12>>1]|0;ca=d[V+14>>1]|0;V=E+32|0;da=d[V>>1]|0;ea=d[V+2>>1]|0;fa=d[V+4>>1]|0;ga=d[V+6>>1]|0;ha=d[V+8>>1]|0;ia=d[V+10>>1]|0;ja=d[V+12>>1]|0;ka=d[V+14>>1]|0;V=e+((((r&65535)>>>9&65535)*792|0)+(((k&65535)>>>9)*24&65535)+(((y&65535)>>>9&65535)*26136|0)<<1)|0;la=V+16|0;ma=d[la>>1]|0;na=d[la+2>>1]|0;oa=d[la+4>>1]|0;pa=d[la+6>>1]|0;qa=d[la+8>>1]|0;ra=d[la+10>>1]|0;sa=d[la+12>>1]|0;ta=d[la+14>>1]|0;la=V+32|0;ua=d[la>>1]|0;va=d[la+2>>1]|0;wa=d[la+4>>1]|0;xa=d[la+6>>1]|0;ya=d[la+8>>1]|0;za=d[la+10>>1]|0;Aa=d[la+12>>1]|0;Ba=d[la+14>>1]|0;la=e+((((s&65535)>>>9&65535)*792|0)+(((l&65535)>>>9)*24&65535)+(((z&65535)>>>9&65535)*26136|0)<<1)|0;Ca=la+16|0;Da=d[Ca>>1]|0;Ea=d[Ca+2>>1]|0;Fa=d[Ca+4>>1]|0;Ga=d[Ca+6>>1]|0;Ha=d[Ca+8>>1]|0;Ia=d[Ca+10>>1]|0;Ja=d[Ca+12>>1]|0;Ka=d[Ca+14>>1]|0;Ca=la+32|0;La=d[Ca>>1]|0;Ma=d[Ca+2>>1]|0;Na=d[Ca+4>>1]|0;Oa=d[Ca+6>>1]|0;Pa=d[Ca+8>>1]|0;Qa=d[Ca+10>>1]|0;Ra=d[Ca+12>>1]|0;Sa=d[Ca+14>>1]|0;Ca=e+((((t&65535)>>>9&65535)*792|0)+(((m&65535)>>>9)*24&65535)+(((A&65535)>>>9&65535)*26136|0)<<1)|0;Ta=Ca+16|0;Ua=d[Ta>>1]|0;Va=d[Ta+2>>1]|0;Wa=d[Ta+4>>1]|0;Xa=d[Ta+6>>1]|0;Ya=d[Ta+8>>1]|0;Za=d[Ta+10>>1]|0;_a=d[Ta+12>>1]|0;$a=d[Ta+14>>1]|0;Ta=Ca+32|0;ab=d[Ta>>1]|0;bb=d[Ta+2>>1]|0;cb=d[Ta+4>>1]|0;db=d[Ta+6>>1]|0;eb=d[Ta+8>>1]|0;fb=d[Ta+10>>1]|0;gb=d[Ta+12>>1]|0;hb=d[Ta+14>>1]|0;Ta=e+((((u&65535)>>>9&65535)*792|0)+(((n&65535)>>>9)*24&65535)+(((B&65535)>>>9&65535)*26136|0)<<1)|0;ib=Ta+16|0;jb=d[ib>>1]|0;kb=d[ib+2>>1]|0;lb=d[ib+4>>1]|0;mb=d[ib+6>>1]|0;nb=d[ib+8>>1]|0;ob=d[ib+10>>1]|0;pb=d[ib+12>>1]|0;qb=d[ib+14>>1]|0;ib=Ta+32|0;rb=d[ib>>1]|0;sb=d[ib+2>>1]|0;tb=d[ib+4>>1]|0;ub=d[ib+6>>1]|0;vb=d[ib+8>>1]|0;wb=d[ib+10>>1]|0;xb=d[ib+12>>1]|0;yb=d[ib+14>>1]|0;ib=e+((((v&65535)>>>9&65535)*792|0)+(((o&65535)>>>9)*24&65535)+(((C&65535)>>>9&65535)*26136|0)<<1)|0;zb=ib+16|0;Ab=d[zb>>1]|0;Bb=d[zb+2>>1]|0;Cb=d[zb+4>>1]|0;Db=d[zb+6>>1]|0;Eb=d[zb+8>>1]|0;Fb=d[zb+10>>1]|0;Gb=d[zb+12>>1]|0;Hb=d[zb+14>>1]|0;zb=ib+32|0;Ib=d[zb>>1]|0;Jb=d[zb+2>>1]|0;Kb=d[zb+4>>1]|0;Lb=d[zb+6>>1]|0;Mb=d[zb+8>>1]|0;Nb=d[zb+10>>1]|0;Ob=d[zb+12>>1]|0;Pb=d[zb+14>>1]|0;zb=e+((((w&65535)>>>9&65535)*792|0)+(((p&65535)>>>9)*24&65535)+(((D&65535)>>>9&65535)*26136|0)<<1)|0;e=zb+16|0;Qb=d[e>>1]|0;Rb=d[e+2>>1]|0;Sb=d[e+4>>1]|0;Tb=d[e+6>>1]|0;Ub=d[e+8>>1]|0;Vb=d[e+10>>1]|0;Wb=d[e+12>>1]|0;Xb=d[e+14>>1]|0;e=zb+32|0;Yb=d[e>>1]|0;Zb=d[e+2>>1]|0;_b=d[e+4>>1]|0;$b=d[e+6>>1]|0;ac=d[e+8>>1]|0;bc=d[e+10>>1]|0;cc=d[e+12>>1]|0;dc=d[e+14>>1]|0;e=3702080+(((a<<2&1920|(i&65535)>>>2&120|b<<6&30720)&65535)<<1)|0;b=3702080+(((q<<2&1920|(j&65535)>>>2&120|x<<6&30720)&65535)<<1)|0;x=3702080+(((r<<2&1920|(k&65535)>>>2&120|y<<6&30720)&65535)<<1)|0;y=3702080+(((s<<2&1920|(l&65535)>>>2&120|z<<6&30720)&65535)<<1)|0;z=3702080+(((t<<2&1920|(m&65535)>>>2&120|A<<6&30720)&65535)<<1)|0;A=3702080+(((u<<2&1920|(n&65535)>>>2&120|B<<6&30720)&65535)<<1)|0;B=3702080+(((v<<2&1920|(o&65535)>>>2&120|C<<6&30720)&65535)<<1)|0;C=3702080+(((w<<2&1920|(p&65535)>>>2&120|D<<6&30720)&65535)<<1)|0;D=d[e>>1]|0;p=d[e+2>>1]|0;w=d[e+4>>1]|0;o=d[e+6>>1]|0;v=d[e+8>>1]|0;n=d[e+10>>1]|0;u=d[e+12>>1]|0;m=d[e+14>>1]|0;e=d[b>>1]|0;t=Y(e,d[E>>1]|0)|0;l=d[b+2>>1]|0;s=Y(l,d[E+2>>1]|0)|0;k=d[b+4>>1]|0;r=Y(k,d[E+4>>1]|0)|0;j=d[b+6>>1]|0;q=Y(j,d[E+6>>1]|0)|0;i=d[b+8>>1]|0;a=Y(i,d[E+8>>1]|0)|0;ec=d[b+10>>1]|0;fc=Y(ec,d[E+10>>1]|0)|0;gc=d[b+12>>1]|0;hc=Y(gc,d[E+12>>1]|0)|0;ic=d[b+14>>1]|0;b=Y(ic,d[E+14>>1]|0)|0;E=d[x>>1]|0;jc=Y(E,d[V>>1]|0)|0;kc=d[x+2>>1]|0;lc=Y(kc,d[V+2>>1]|0)|0;mc=d[x+4>>1]|0;nc=Y(mc,d[V+4>>1]|0)|0;oc=d[x+6>>1]|0;pc=Y(oc,d[V+6>>1]|0)|0;qc=d[x+8>>1]|0;rc=Y(qc,d[V+8>>1]|0)|0;sc=d[x+10>>1]|0;tc=Y(sc,d[V+10>>1]|0)|0;uc=d[x+12>>1]|0;vc=Y(uc,d[V+12>>1]|0)|0;wc=d[x+14>>1]|0;x=Y(wc,d[V+14>>1]|0)|0;V=d[y>>1]|0;xc=Y(V,d[la>>1]|0)|0;yc=d[y+2>>1]|0;zc=Y(yc,d[la+2>>1]|0)|0;Ac=d[y+4>>1]|0;Bc=Y(Ac,d[la+4>>1]|0)|0;Cc=d[y+6>>1]|0;Dc=Y(Cc,d[la+6>>1]|0)|0;Ec=d[y+8>>1]|0;Fc=Y(Ec,d[la+8>>1]|0)|0;Gc=d[y+10>>1]|0;Hc=Y(Gc,d[la+10>>1]|0)|0;Ic=d[y+12>>1]|0;Jc=Y(Ic,d[la+12>>1]|0)|0;Kc=d[y+14>>1]|0;y=Y(Kc,d[la+14>>1]|0)|0;la=d[z>>1]|0;Lc=Y(la,d[Ca>>1]|0)|0;Mc=d[z+2>>1]|0;Nc=Y(Mc,d[Ca+2>>1]|0)|0;Oc=d[z+4>>1]|0;Pc=Y(Oc,d[Ca+4>>1]|0)|0;Qc=d[z+6>>1]|0;Rc=Y(Qc,d[Ca+6>>1]|0)|0;Sc=d[z+8>>1]|0;Tc=Y(Sc,d[Ca+8>>1]|0)|0;Uc=d[z+10>>1]|0;Vc=Y(Uc,d[Ca+10>>1]|0)|0;Wc=d[z+12>>1]|0;Xc=Y(Wc,d[Ca+12>>1]|0)|0;Yc=d[z+14>>1]|0;z=Y(Yc,d[Ca+14>>1]|0)|0;Ca=d[A>>1]|0;Zc=Y(Ca,d[Ta>>1]|0)|0;_c=d[A+2>>1]|0;$c=Y(_c,d[Ta+2>>1]|0)|0;ad=d[A+4>>1]|0;bd=Y(ad,d[Ta+4>>1]|0)|0;cd=d[A+6>>1]|0;dd=Y(cd,d[Ta+6>>1]|0)|0;ed=d[A+8>>1]|0;fd=Y(ed,d[Ta+8>>1]|0)|0;gd=d[A+10>>1]|0;hd=Y(gd,d[Ta+10>>1]|0)|0;id=d[A+12>>1]|0;jd=Y(id,d[Ta+12>>1]|0)|0;kd=d[A+14>>1]|0;A=Y(kd,d[Ta+14>>1]|0)|0;Ta=d[B>>1]|0;ld=Y(Ta,d[ib>>1]|0)|0;md=d[B+2>>1]|0;nd=Y(md,d[ib+2>>1]|0)|0;od=d[B+4>>1]|0;pd=Y(od,d[ib+4>>1]|0)|0;qd=d[B+6>>1]|0;rd=Y(qd,d[ib+6>>1]|0)|0;sd=d[B+8>>1]|0;td=Y(sd,d[ib+8>>1]|0)|0;ud=d[B+10>>1]|0;vd=Y(ud,d[ib+10>>1]|0)|0;wd=d[B+12>>1]|0;xd=Y(wd,d[ib+12>>1]|0)|0;yd=d[B+14>>1]|0;B=Y(yd,d[ib+14>>1]|0)|0;ib=d[C>>1]|0;zd=Y(ib,d[zb>>1]|0)|0;Ad=d[C+2>>1]|0;Bd=Y(Ad,d[zb+2>>1]|0)|0;Cd=d[C+4>>1]|0;Dd=Y(Cd,d[zb+4>>1]|0)|0;Ed=d[C+6>>1]|0;Fd=Y(Ed,d[zb+6>>1]|0)|0;Gd=d[C+8>>1]|0;Hd=Y(Gd,d[zb+8>>1]|0)|0;Id=d[C+10>>1]|0;Jd=Y(Id,d[zb+10>>1]|0)|0;Kd=d[C+12>>1]|0;Ld=Y(Kd,d[zb+12>>1]|0)|0;Md=d[C+14>>1]|0;C=Y(Md,d[zb+14>>1]|0)|0;zb=((Y(D,d[c>>1]|0)|0)+2048+(Y(p,d[c+2>>1]|0)|0)+(Y(w,d[c+4>>1]|0)|0)+(Y(o,d[c+6>>1]|0)|0)+(Y(v,d[c+8>>1]|0)|0)+(Y(n,d[c+10>>1]|0)|0)+(Y(u,d[c+12>>1]|0)|0)+(Y(m,d[c+14>>1]|0)|0)|0)>>>12;c=(Lc+2048+Nc+Pc+Rc+Tc+Vc+Xc+z|0)>>>12;z=(t+2048+s+r+q+a+fc+hc+b|0)>>>12;b=(Zc+2048+$c+bd+dd+fd+hd+jd+A|0)>>>12;A=(jc+2048+lc+nc+pc+rc+tc+vc+x|0)>>>12;x=(ld+2048+nd+pd+rd+td+vd+xd+B|0)>>>12;B=(xc+2048+zc+Bc+Dc+Fc+Hc+Jc+y|0)>>>12;y=(zd+2048+Bd+Dd+Fd+Hd+Jd+Ld+C|0)>>>12;d[f>>1]=zb>>>0<65535?zb:65535;d[f+2>>1]=z>>>0<65535?z:65535;d[f+4>>1]=A>>>0<65535?A:65535;d[f+6>>1]=B>>>0<65535?B:65535;d[f+8>>1]=c>>>0<65535?c:65535;d[f+10>>1]=b>>>0<65535?b:65535;d[f+12>>1]=x>>>0<65535?x:65535;d[f+14>>1]=y>>>0<65535?y:65535;y=Y(e,W<<16>>16)|0;W=Y(l,X<<16>>16)|0;X=Y(k,Z<<16>>16)|0;Z=Y(j,_<<16>>16)|0;_=Y(i,$<<16>>16)|0;$=Y(ec,aa<<16>>16)|0;aa=Y(gc,ba<<16>>16)|0;ba=Y(ic,ca<<16>>16)|0;ca=Y(E,ma<<16>>16)|0;ma=Y(kc,na<<16>>16)|0;na=Y(mc,oa<<16>>16)|0;oa=Y(oc,pa<<16>>16)|0;pa=Y(qc,qa<<16>>16)|0;qa=Y(sc,ra<<16>>16)|0;ra=Y(uc,sa<<16>>16)|0;sa=Y(wc,ta<<16>>16)|0;ta=Y(V,Da<<16>>16)|0;Da=Y(yc,Ea<<16>>16)|0;Ea=Y(Ac,Fa<<16>>16)|0;Fa=Y(Cc,Ga<<16>>16)|0;Ga=Y(Ec,Ha<<16>>16)|0;Ha=Y(Gc,Ia<<16>>16)|0;Ia=Y(Ic,Ja<<16>>16)|0;Ja=Y(Kc,Ka<<16>>16)|0;Ka=Y(la,Ua<<16>>16)|0;Ua=Y(Mc,Va<<16>>16)|0;Va=Y(Oc,Wa<<16>>16)|0;Wa=Y(Qc,Xa<<16>>16)|0;Xa=Y(Sc,Ya<<16>>16)|0;Ya=Y(Uc,Za<<16>>16)|0;Za=Y(Wc,_a<<16>>16)|0;_a=Y(Yc,$a<<16>>16)|0;$a=Y(Ca,jb<<16>>16)|0;jb=Y(_c,kb<<16>>16)|0;kb=Y(ad,lb<<16>>16)|0;lb=Y(cd,mb<<16>>16)|0;mb=Y(ed,nb<<16>>16)|0;nb=Y(gd,ob<<16>>16)|0;ob=Y(id,pb<<16>>16)|0;pb=Y(kd,qb<<16>>16)|0;qb=Y(Ta,Ab<<16>>16)|0;Ab=Y(md,Bb<<16>>16)|0;Bb=Y(od,Cb<<16>>16)|0;Cb=Y(qd,Db<<16>>16)|0;Db=Y(sd,Eb<<16>>16)|0;Eb=Y(ud,Fb<<16>>16)|0;Fb=Y(wd,Gb<<16>>16)|0;Gb=Y(yd,Hb<<16>>16)|0;Hb=Y(ib,Qb<<16>>16)|0;Qb=Y(Ad,Rb<<16>>16)|0;Rb=Y(Cd,Sb<<16>>16)|0;Sb=Y(Ed,Tb<<16>>16)|0;Tb=Y(Gd,Ub<<16>>16)|0;Ub=Y(Id,Vb<<16>>16)|0;Vb=Y(Kd,Wb<<16>>16)|0;Wb=Y(Md,Xb<<16>>16)|0;Xb=((Y(D,F<<16>>16)|0)+2048+(Y(p,G<<16>>16)|0)+(Y(w,H<<16>>16)|0)+(Y(o,I<<16>>16)|0)+(Y(v,J<<16>>16)|0)+(Y(n,K<<16>>16)|0)+(Y(u,L<<16>>16)|0)+(Y(m,M<<16>>16)|0)|0)>>>12;M=(Ka+2048+Ua+Va+Wa+Xa+Ya+Za+_a|0)>>>12;_a=(y+2048+W+X+Z+_+$+aa+ba|0)>>>12;ba=($a+2048+jb+kb+lb+mb+nb+ob+pb|0)>>>12;pb=(ca+2048+ma+na+oa+pa+qa+ra+sa|0)>>>12;sa=(qb+2048+Ab+Bb+Cb+Db+Eb+Fb+Gb|0)>>>12;Gb=(ta+2048+Da+Ea+Fa+Ga+Ha+Ia+Ja|0)>>>12;Ja=(Hb+2048+Qb+Rb+Sb+Tb+Ub+Vb+Wb|0)>>>12;d[g>>1]=Xb>>>0<65535?Xb:65535;d[g+2>>1]=_a>>>0<65535?_a:65535;d[g+4>>1]=pb>>>0<65535?pb:65535;d[g+6>>1]=Gb>>>0<65535?Gb:65535;d[g+8>>1]=M>>>0<65535?M:65535;d[g+10>>1]=ba>>>0<65535?ba:65535;d[g+12>>1]=sa>>>0<65535?sa:65535;d[g+14>>1]=Ja>>>0<65535?Ja:65535;Ja=Y(e,da<<16>>16)|0;da=Y(l,ea<<16>>16)|0;ea=Y(k,fa<<16>>16)|0;fa=Y(j,ga<<16>>16)|0;ga=Y(i,ha<<16>>16)|0;ha=Y(ec,ia<<16>>16)|0;ia=Y(gc,ja<<16>>16)|0;ja=Y(ic,ka<<16>>16)|0;ka=Y(E,ua<<16>>16)|0;ua=Y(kc,va<<16>>16)|0;va=Y(mc,wa<<16>>16)|0;wa=Y(oc,xa<<16>>16)|0;xa=Y(qc,ya<<16>>16)|0;ya=Y(sc,za<<16>>16)|0;za=Y(uc,Aa<<16>>16)|0;Aa=Y(wc,Ba<<16>>16)|0;Ba=Y(V,La<<16>>16)|0;La=Y(yc,Ma<<16>>16)|0;Ma=Y(Ac,Na<<16>>16)|0;Na=Y(Cc,Oa<<16>>16)|0;Oa=Y(Ec,Pa<<16>>16)|0;Pa=Y(Gc,Qa<<16>>16)|0;Qa=Y(Ic,Ra<<16>>16)|0;Ra=Y(Kc,Sa<<16>>16)|0;Sa=Y(la,ab<<16>>16)|0;ab=Y(Mc,bb<<16>>16)|0;bb=Y(Oc,cb<<16>>16)|0;cb=Y(Qc,db<<16>>16)|0;db=Y(Sc,eb<<16>>16)|0;eb=Y(Uc,fb<<16>>16)|0;fb=Y(Wc,gb<<16>>16)|0;gb=Y(Yc,hb<<16>>16)|0;hb=Y(Ca,rb<<16>>16)|0;rb=Y(_c,sb<<16>>16)|0;sb=Y(ad,tb<<16>>16)|0;tb=Y(cd,ub<<16>>16)|0;ub=Y(ed,vb<<16>>16)|0;vb=Y(gd,wb<<16>>16)|0;wb=Y(id,xb<<16>>16)|0;xb=Y(kd,yb<<16>>16)|0;yb=Y(Ta,Ib<<16>>16)|0;Ib=Y(md,Jb<<16>>16)|0;Jb=Y(od,Kb<<16>>16)|0;Kb=Y(qd,Lb<<16>>16)|0;Lb=Y(sd,Mb<<16>>16)|0;Mb=Y(ud,Nb<<16>>16)|0;Nb=Y(wd,Ob<<16>>16)|0;Ob=Y(yd,Pb<<16>>16)|0;Pb=Y(ib,Yb<<16>>16)|0;Yb=Y(Ad,Zb<<16>>16)|0;Zb=Y(Cd,_b<<16>>16)|0;_b=Y(Ed,$b<<16>>16)|0;$b=Y(Gd,ac<<16>>16)|0;ac=Y(Id,bc<<16>>16)|0;bc=Y(Kd,cc<<16>>16)|0;cc=Y(Md,dc<<16>>16)|0;dc=((Y(D,N<<16>>16)|0)+2048+(Y(p,O<<16>>16)|0)+(Y(w,P<<16>>16)|0)+(Y(o,Q<<16>>16)|0)+(Y(v,R<<16>>16)|0)+(Y(n,S<<16>>16)|0)+(Y(u,T<<16>>16)|0)+(Y(m,U<<16>>16)|0)|0)>>>12;U=(Sa+2048+ab+bb+cb+db+eb+fb+gb|0)>>>12;gb=(Ja+2048+da+ea+fa+ga+ha+ia+ja|0)>>>12;ja=(hb+2048+rb+sb+tb+ub+vb+wb+xb|0)>>>12;xb=(ka+2048+ua+va+wa+xa+ya+za+Aa|0)>>>12;Aa=(yb+2048+Ib+Jb+Kb+Lb+Mb+Nb+Ob|0)>>>12;Ob=(Ba+2048+La+Ma+Na+Oa+Pa+Qa+Ra|0)>>>12;Ra=(Pb+2048+Yb+Zb+_b+$b+ac+bc+cc|0)>>>12;d[h>>1]=dc>>>0<65535?dc:65535;d[h+2>>1]=gb>>>0<65535?gb:65535;d[h+4>>1]=xb>>>0<65535?xb:65535;d[h+6>>1]=Ob>>>0<65535?Ob:65535;d[h+8>>1]=U>>>0<65535?U:65535;d[h+10>>1]=ja>>>0<65535?ja:65535;d[h+12>>1]=Aa>>>0<65535?Aa:65535;d[h+14>>1]=Ra>>>0<65535?Ra:65535;return}function r4(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;j=u;u=u+96|0;k=j+64|0;l=j+32|0;m=j;n=e+(((b>>9)*792|0)+((a>>9)*24|0)+((c>>9)*26136|0)<<1)|0;f[k>>2]=d[n>>1];f[l>>2]=d[n+16>>1];f[m>>2]=d[n+32>>1];e=k+4|0;f[e>>2]=d[n+2>>1];o=l+4|0;f[o>>2]=d[n+18>>1];p=m+4|0;f[p>>2]=d[n+34>>1];q=k+8|0;f[q>>2]=d[n+4>>1];r=l+8|0;f[r>>2]=d[n+20>>1];s=m+8|0;f[s>>2]=d[n+36>>1];t=k+12|0;f[t>>2]=d[n+6>>1];v=l+12|0;f[v>>2]=d[n+22>>1];w=m+12|0;f[w>>2]=d[n+38>>1];x=k+16|0;f[x>>2]=d[n+8>>1];y=l+16|0;f[y>>2]=d[n+24>>1];z=m+16|0;f[z>>2]=d[n+40>>1];A=k+20|0;f[A>>2]=d[n+10>>1];B=l+20|0;f[B>>2]=d[n+26>>1];C=m+20|0;f[C>>2]=d[n+42>>1];D=k+24|0;f[D>>2]=d[n+12>>1];E=l+24|0;f[E>>2]=d[n+28>>1];F=m+24|0;f[F>>2]=d[n+44>>1];G=d[n+14>>1]|0;f[k+28>>2]=G;H=l+28|0;f[H>>2]=d[n+30>>1];I=m+28|0;f[I>>2]=d[n+46>>1];n=b<<2&1920|a>>>2&120|c<<6&30720;c=d[3702080+(n<<1)>>1]|0;a=d[3702080+((n|1)<<1)>>1]|0;b=d[3702080+((n|2)<<1)>>1]|0;J=d[3702080+((n|3)<<1)>>1]|0;K=d[3702080+((n|4)<<1)>>1]|0;L=d[3702080+((n|5)<<1)>>1]|0;M=d[3702080+((n|6)<<1)>>1]|0;N=d[3702080+((n|7)<<1)>>1]|0;n=Y(c,f[k>>2]|0)|0;k=(Y(a,f[e>>2]|0)|0)+n|0;n=k+(Y(b,f[q>>2]|0)|0)|0;q=n+(Y(J,f[t>>2]|0)|0)|0;t=q+(Y(K,f[x>>2]|0)|0)|0;x=t+(Y(L,f[A>>2]|0)|0)|0;A=x+(Y(M,f[D>>2]|0)|0)+(Y(N,G)|0)|0;f[g>>2]=A;A=Y(f[l>>2]|0,c)|0;l=(Y(f[o>>2]|0,a)|0)+A|0;A=l+(Y(f[r>>2]|0,b)|0)|0;r=A+(Y(f[v>>2]|0,J)|0)|0;v=r+(Y(f[y>>2]|0,K)|0)|0;y=v+(Y(f[B>>2]|0,L)|0)|0;B=y+(Y(f[E>>2]|0,M)|0)|0;E=B+(Y(f[H>>2]|0,N)|0)|0;f[h>>2]=E;E=Y(f[m>>2]|0,c)|0;c=(Y(f[p>>2]|0,a)|0)+E|0;E=c+(Y(f[s>>2]|0,b)|0)|0;b=E+(Y(f[w>>2]|0,J)|0)|0;J=b+(Y(f[z>>2]|0,K)|0)|0;K=J+(Y(L,f[C>>2]|0)|0)|0;C=K+(Y(M,f[F>>2]|0)|0)|0;F=C+(Y(N,f[I>>2]|0)|0)|0;f[i>>2]=F;f[g>>2]=(f[g>>2]|0)+2048>>12;f[h>>2]=(f[h>>2]|0)+2048>>12;f[i>>2]=(f[i>>2]|0)+2048>>12;u=j;return}function s4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+64|0;d=c+56|0;e=c+52|0;g=c+48|0;h=c+44|0;i=c+40|0;j=c+36|0;k=c+32|0;l=c+24|0;m=c+20|0;o=c+28|0;p=c+16|0;q=c+12|0;r=c+4|0;s=c+8|0;t=c;JCa(d,2);JCa(e,3);JCa(g,4);JCa(h,0);n[b+4>>2]=0.0;n[b>>2]=0.0;v=1;do{w=v;v=v+1|0;PCa(j,a+(w<<2)|0,d);OCa(k,a+(v<<2)|0,j);x=w+-1|0;LCa(l,k,a+(x<<2)|0);PCa(i,l,e);f[m>>2]=1065353216;y=x<<2;OCa(o,g,b+(y<<2)|0);QCa(j,m,o);x=w<<2;w=b+(x<<2)|0;if((j|0)!=(w|0))f[w>>2]=f[j>>2];OCa(p,i,b+((y|1)<<2)|0);PCa(o,p,j);y=b+((x|1)<<2)|0;if((o|0)!=(y|0))f[y>>2]=f[o>>2]}while((v|0)!=1023);v=1023;while(1){p=v<<2;m=b+((p|1)<<2)|0;g=b+(p<<2)|0;PCa(j,g,h);OCa(i,m,j);l=a+(v<<2)|0;OCa(q,a+(v+1<<2)|0,l);PCa(r,i,d);LCa(s,h,r);QCa(o,s,e);OCa(j,q,o);OCa(t,h,i);QCa(o,t,e);if((l|0)!=(g|0))f[g>>2]=f[l>>2];if((j|0)!=(m|0))f[m>>2]=f[j>>2];m=b+((p|2)<<2)|0;if((i|0)!=(m|0))f[m>>2]=f[i>>2];m=b+((p|3)<<2)|0;if((o|0)!=(m|0))f[m>>2]=f[o>>2];f[h>>2]=f[i>>2];if((v|0)>0)v=v+-1|0;else break}u=c;return}function t4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+48|0;d=c+40|0;e=c+24|0;g=c+32|0;h=c+8|0;i=c+16|0;j=c;KCa(d,b);if(eDa(d,375184)|0){cDa(e,d,375200);YCa(a,e);u=c;return}else{ZCa(h,d,375216);d=j;f[d>>2]=0;f[d+4>>2]=1072693248;ZCa(i,j,375216);cDa(g,h,i);iDa(e,g,375208);YCa(a,e);u=c;return}}function u4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+64|0;d=c+56|0;e=c+40|0;g=c+48|0;h=c+24|0;i=c+16|0;j=c+32|0;k=c+8|0;l=c;KCa(d,b);if(eDa(d,375192)|0){bDa(e,d,375200);YCa(a,e);u=c;return}else{b=h;f[b>>2]=0;f[b+4>>2]=1072693248;cDa(g,h,375208);iDa(i,d,g);g=k;f[g>>2]=0;f[g+4>>2]=1072693248;ZCa(j,k,375216);bDa(l,i,j);aDa(e,l,375216);YCa(a,e);u=c;return}}function v4(a){a=a|0;PYa(a);return}function w4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,47808);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){x4(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function x4(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0.0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0.0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0.0,Zb=0.0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0.0,dc=0.0,ec=0.0,fc=0.0,gc=0.0,hc=0.0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0.0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0.0,Dc=0.0,Ec=0.0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0.0,Kc=0.0,Lc=0.0,Mc=0.0,Nc=0.0,Oc=0.0,Pc=0.0,Qc=0.0,Rc=0.0;h=u;u=u+240|0;i=h+132|0;j=h+128|0;k=h+124|0;l=h+120|0;m=h+116|0;o=h+112|0;p=h+108|0;q=h+104|0;r=h+100|0;t=h+96|0;v=h+92|0;w=h+88|0;x=h+84|0;y=h+80|0;z=h+76|0;A=h+72|0;B=h+68|0;C=h+64|0;D=h+60|0;E=h+56|0;F=h+52|0;G=h+48|0;H=h+44|0;I=h+40|0;J=h+36|0;K=h+32|0;L=h+28|0;M=h+24|0;N=h+20|0;O=h+16|0;P=h+12|0;Q=h+8|0;R=h+216|0;S=h+200|0;T=h+184|0;U=h+168|0;V=h+152|0;W=h+136|0;X=h+4|0;Y=h;Z=f[a>>2]|0;_=f[a+44>>2]|0;$=(b[a+40>>0]|0)!=0;aa=$?907756:0;ba=+n[a+4>>2];ca=+n[a+8>>2];da=+n[a+12>>2];ea=+n[a+16>>2];fa=+n[a+20>>2];ga=+n[a+24>>2];ha=+n[a+28>>2];ia=+n[a+32>>2];ja=+n[a+36>>2];ka=g*3|0;if(b[a+41>>0]|0){a=ka+-24|0;if((ka|0)>24){g=(Z|0)==3;la=Z<<2;ma=(_|0)==0;na=R+2|0;oa=R+4|0;pa=R+6|0;qa=R+8|0;ra=R+10|0;sa=R+12|0;ta=R+14|0;ua=S+2|0;va=S+4|0;wa=S+6|0;xa=S+8|0;ya=S+10|0;za=S+12|0;Aa=S+14|0;Ba=T+2|0;Ca=T+4|0;Da=T+6|0;Ea=T+8|0;Fa=T+10|0;Ga=T+12|0;Ha=T+14|0;Ia=U+2|0;Ja=U+4|0;Ka=U+6|0;La=U+8|0;Ma=U+10|0;Na=U+12|0;Oa=U+14|0;Pa=V+2|0;Qa=V+4|0;Ra=V+6|0;Sa=V+8|0;Ta=V+10|0;Ua=V+12|0;Va=V+14|0;Wa=W+2|0;Xa=W+4|0;Ya=W+6|0;Za=W+8|0;_a=W+10|0;$a=W+12|0;ab=W+14|0;bb=Z<<3;cb=0;db=c;while(1){eb=f[db>>2]|0;f[i>>2]=eb;fb=f[db+4>>2]|0;f[m>>2]=fb;gb=f[db+8>>2]|0;f[r>>2]=gb;hb=(f[s>>2]=fb,+n[s>>2]);if(g){fb=f[db+12>>2]|0;f[j>>2]=fb;ib=f[db+16>>2]|0;f[o>>2]=ib;jb=f[db+20>>2]|0;f[t>>2]=jb;kb=f[db+24>>2]|0;f[k>>2]=kb;f[p>>2]=f[db+28>>2];lb=f[db+32>>2]|0;f[v>>2]=lb;mb=f[db+36>>2]|0;f[l>>2]=mb;f[q>>2]=f[db+40>>2];nb=f[db+44>>2]|0;f[w>>2]=nb;ob=db+(la<<2)|0;pb=f[ob>>2]|0;f[x>>2]=pb;f[B>>2]=f[ob+4>>2];qb=f[ob+8>>2]|0;f[F>>2]=qb;rb=f[ob+12>>2]|0;f[y>>2]=rb;f[C>>2]=f[ob+16>>2];sb=f[ob+20>>2]|0;f[G>>2]=sb;tb=f[ob+24>>2]|0;f[z>>2]=tb;f[D>>2]=f[ob+28>>2];ub=f[ob+32>>2]|0;f[H>>2]=ub;vb=f[ob+36>>2]|0;f[A>>2]=vb;f[E>>2]=f[ob+40>>2];wb=jb;xb=lb;yb=nb;zb=qb;Ab=sb;Bb=ub;Cb=ib;Db=fb;Eb=kb;Fb=mb;Gb=pb;Hb=rb;Ib=tb;Jb=vb;Kb=ob+44|0}else{ob=f[db+16>>2]|0;f[j>>2]=ob;vb=f[db+20>>2]|0;f[o>>2]=vb;tb=f[db+24>>2]|0;f[t>>2]=tb;rb=f[db+32>>2]|0;f[k>>2]=rb;f[p>>2]=f[db+36>>2];pb=f[db+40>>2]|0;f[v>>2]=pb;mb=f[db+48>>2]|0;f[l>>2]=mb;f[q>>2]=f[db+52>>2];kb=f[db+56>>2]|0;f[w>>2]=kb;fb=db+(la<<2)|0;ib=f[fb>>2]|0;f[x>>2]=ib;f[B>>2]=f[fb+4>>2];ub=f[fb+8>>2]|0;f[F>>2]=ub;sb=f[fb+16>>2]|0;f[y>>2]=sb;f[C>>2]=f[fb+20>>2];qb=f[fb+24>>2]|0;f[G>>2]=qb;nb=f[fb+32>>2]|0;f[z>>2]=nb;f[D>>2]=f[fb+36>>2];lb=f[fb+40>>2]|0;f[H>>2]=lb;jb=f[fb+48>>2]|0;f[A>>2]=jb;f[E>>2]=f[fb+52>>2];wb=tb;xb=pb;yb=kb;zb=ub;Ab=qb;Bb=lb;Cb=vb;Db=ob;Eb=rb;Fb=mb;Gb=ib;Hb=sb;Ib=nb;Jb=jb;Kb=fb+56|0}Lb=(f[s>>2]=Cb,+n[s>>2]);fb=f[Kb>>2]|0;f[I>>2]=fb;if(ma){Mb=eb;Nb=Db;Ob=Eb;Pb=Fb;Qb=Gb;Rb=Hb;Sb=Ib;Tb=Jb}else{f[i>>2]=gb;f[j>>2]=wb;f[k>>2]=xb;f[l>>2]=yb;f[r>>2]=eb;f[t>>2]=Db;f[v>>2]=Eb;f[w>>2]=Fb;f[x>>2]=zb;f[y>>2]=Ab;f[z>>2]=Bb;f[A>>2]=fb;f[F>>2]=Gb;f[G>>2]=Hb;f[H>>2]=Ib;f[I>>2]=Jb;Mb=gb;Nb=wb;Ob=xb;Pb=yb;Qb=zb;Rb=Ab;Sb=Bb;Tb=fb}Ub=(f[s>>2]=Mb,+n[s>>2]);Vb=(f[s>>2]=Nb,+n[s>>2]);Wb=(f[s>>2]=Ob,+n[s>>2]);Xb=(f[s>>2]=Pb,+n[s>>2]);Yb=(f[s>>2]=Qb,+n[s>>2]);Zb=(f[s>>2]=Rb,+n[s>>2]);_b=(f[s>>2]=Sb,+n[s>>2]);$b=(f[s>>2]=Tb,+n[s>>2]);n[J>>2]=0.0;n[K>>2]=0.0;n[L>>2]=0.0;n[M>>2]=0.0;n[N>>2]=1.0;n[O>>2]=1.0;n[P>>2]=1.0;n[Q>>2]=1.0;ac=Ub<0.0?0.0:Ub;Ub=Vb<0.0?0.0:Vb;Vb=Wb<0.0?0.0:Wb;Wb=Xb<0.0?0.0:Xb;fb=Wb>1.0?1065353216:(n[s>>2]=Wb,f[s>>2]|0);n[i>>2]=ac>1.0?1.0:ac;n[j>>2]=Ub>1.0?1.0:Ub;n[k>>2]=Vb>1.0?1.0:Vb;f[l>>2]=fb;Vb=Yb<0.0?0.0:Yb;Yb=Zb<0.0?0.0:Zb;Zb=_b<0.0?0.0:_b;_b=$b<0.0?0.0:$b;fb=_b>1.0?1065353216:(n[s>>2]=_b,f[s>>2]|0);n[x>>2]=Vb>1.0?1.0:Vb;n[y>>2]=Yb>1.0?1.0:Yb;n[z>>2]=Zb>1.0?1.0:Zb;f[A>>2]=fb;Zb=hb<0.0?0.0:hb;hb=Lb<0.0?0.0:Lb;Lb=+n[p>>2];Yb=Lb<0.0?0.0:Lb;Lb=+n[q>>2];Vb=Lb<0.0?0.0:Lb;fb=Vb>1.0?1065353216:(n[s>>2]=Vb,f[s>>2]|0);n[m>>2]=Zb>1.0?1.0:Zb;n[o>>2]=hb>1.0?1.0:hb;n[p>>2]=Yb>1.0?1.0:Yb;f[q>>2]=fb;Yb=+n[B>>2];hb=+n[J>>2];Zb=Yb<hb?hb:Yb;Yb=+n[C>>2];Vb=+n[K>>2];Lb=Yb<Vb?Vb:Yb;Yb=+n[D>>2];_b=+n[L>>2];$b=Yb<_b?_b:Yb;Yb=+n[E>>2];Ub=+n[M>>2];ac=Yb<Ub?Ub:Yb;Yb=+n[N>>2];Wb=+n[O>>2];Xb=+n[P>>2];bc=+n[Q>>2];n[B>>2]=Yb<Zb?Yb:Zb;n[C>>2]=Wb<Lb?Wb:Lb;n[D>>2]=Xb<$b?Xb:$b;n[E>>2]=bc<ac?bc:ac;ac=+n[r>>2];$b=ac<hb?hb:ac;ac=+n[t>>2];Lb=ac<Vb?Vb:ac;ac=+n[v>>2];Zb=ac<_b?_b:ac;ac=+n[w>>2];cc=ac<Ub?Ub:ac;ac=+n[F>>2];dc=ac<hb?hb:ac;ac=+n[G>>2];hb=ac<Vb?Vb:ac;ac=+n[H>>2];Vb=ac<_b?_b:ac;ac=+n[I>>2];_b=ac<Ub?Ub:ac;ac=+n[i>>2]*16384.0;n[i>>2]=ac;Ub=+n[j>>2]*16384.0;n[j>>2]=Ub;ec=+n[k>>2]*16384.0;n[k>>2]=ec;fc=+n[l>>2]*16384.0;n[l>>2]=fc;gc=+n[m>>2]*16384.0;n[m>>2]=gc;hc=+n[o>>2]*16384.0;n[o>>2]=hc;ic=+n[p>>2]*16384.0;n[p>>2]=ic;jc=+n[q>>2]*16384.0;n[q>>2]=jc;kc=(Yb<$b?Yb:$b)*16384.0;n[r>>2]=kc;$b=(Wb<Lb?Wb:Lb)*16384.0;n[t>>2]=$b;Lb=(Xb<Zb?Xb:Zb)*16384.0;n[v>>2]=Lb;Zb=(bc<cc?bc:cc)*16384.0;n[w>>2]=Zb;cc=+n[x>>2]*16384.0;n[x>>2]=cc;lc=+n[y>>2]*16384.0;n[y>>2]=lc;mc=+n[z>>2]*16384.0;n[z>>2]=mc;nc=+n[A>>2]*16384.0;n[A>>2]=nc;oc=+n[B>>2]*16384.0;n[B>>2]=oc;pc=+n[C>>2]*16384.0;n[C>>2]=pc;qc=+n[D>>2]*16384.0;n[D>>2]=qc;rc=+n[E>>2]*16384.0;n[E>>2]=rc;sc=(Yb<dc?Yb:dc)*16384.0;n[F>>2]=sc;dc=(Wb<hb?Wb:hb)*16384.0;n[G>>2]=dc;hb=(Xb<Vb?Xb:Vb)*16384.0;n[H>>2]=hb;Vb=(bc<_b?bc:_b)*16384.0;n[I>>2]=Vb;fb=wNa(ac)|0;gb=wNa(Ub)|0;eb=wNa(ec)|0;jb=wNa(fc)|0;nb=wNa(cc)|0;sb=wNa(lc)|0;ib=wNa(mc)|0;mb=wNa(nc)|0;rb=wNa(gc)|0;ob=wNa(hc)|0;vb=wNa(ic)|0;lb=wNa(jc)|0;qb=wNa(oc)|0;ub=wNa(pc)|0;kb=wNa(qc)|0;pb=wNa(rc)|0;tb=wNa(kc)|0;tc=wNa($b)|0;uc=wNa(Lb)|0;vc=wNa(Zb)|0;wc=wNa(sc)|0;xc=wNa(dc)|0;yc=wNa(hb)|0;zc=wNa(Vb)|0;d[R>>1]=(fb+32768|0)>>>0<65536?fb:(fb|0)>0?32767:32768;d[na>>1]=(gb+32768|0)>>>0<65536?gb:(gb|0)>0?32767:32768;d[oa>>1]=(eb+32768|0)>>>0<65536?eb:(eb|0)>0?32767:32768;d[pa>>1]=(jb+32768|0)>>>0<65536?jb:(jb|0)>0?32767:32768;d[qa>>1]=(nb+32768|0)>>>0<65536?nb:(nb|0)>0?32767:32768;d[ra>>1]=(sb+32768|0)>>>0<65536?sb:(sb|0)>0?32767:32768;d[sa>>1]=(ib+32768|0)>>>0<65536?ib:(ib|0)>0?32767:32768;d[ta>>1]=(mb+32768|0)>>>0<65536?mb:(mb|0)>0?32767:32768;d[S>>1]=(rb+32768|0)>>>0<65536?rb:(rb|0)>0?32767:32768;d[ua>>1]=(ob+32768|0)>>>0<65536?ob:(ob|0)>0?32767:32768;d[va>>1]=(vb+32768|0)>>>0<65536?vb:(vb|0)>0?32767:32768;d[wa>>1]=(lb+32768|0)>>>0<65536?lb:(lb|0)>0?32767:32768;d[xa>>1]=(qb+32768|0)>>>0<65536?qb:(qb|0)>0?32767:32768;d[ya>>1]=(ub+32768|0)>>>0<65536?ub:(ub|0)>0?32767:32768;d[za>>1]=(kb+32768|0)>>>0<65536?kb:(kb|0)>0?32767:32768;d[Aa>>1]=(pb+32768|0)>>>0<65536?pb:(pb|0)>0?32767:32768;d[T>>1]=(tb+32768|0)>>>0<65536?tb:(tb|0)>0?32767:32768;d[Ba>>1]=(tc+32768|0)>>>0<65536?tc:(tc|0)>0?32767:32768;d[Ca>>1]=(uc+32768|0)>>>0<65536?uc:(uc|0)>0?32767:32768;d[Da>>1]=(vc+32768|0)>>>0<65536?vc:(vc|0)>0?32767:32768;d[Ea>>1]=(wc+32768|0)>>>0<65536?wc:(wc|0)>0?32767:32768;d[Fa>>1]=(xc+32768|0)>>>0<65536?xc:(xc|0)>0?32767:32768;d[Ga>>1]=(yc+32768|0)>>>0<65536?yc:(yc|0)>0?32767:32768;d[Ha>>1]=(zc+32768|0)>>>0<65536?zc:(zc|0)>0?32767:32768;q4(R,S,T,3792192,U,V,W);Vb=+(d[Ia>>1]|0)*.006103515625;hb=+(d[Ja>>1]|0)*.006103515625;dc=+(d[Ka>>1]|0)*.006103515625;sc=+(d[La>>1]|0)*.006103515625;Zb=+(d[Ma>>1]|0)*.006103515625;Lb=+(d[Na>>1]|0)*.006103515625;$b=+(d[Oa>>1]|0)*.006103515625;kc=+(d[V>>1]|0)*.015625+-128.0;rc=+(d[Pa>>1]|0)*.015625+-128.0;qc=+(d[Qa>>1]|0)*.015625+-128.0;pc=+(d[Ra>>1]|0)*.015625+-128.0;oc=+(d[Sa>>1]|0)*.015625+-128.0;jc=+(d[Ta>>1]|0)*.015625+-128.0;ic=+(d[Ua>>1]|0)*.015625+-128.0;hc=+(d[Va>>1]|0)*.015625+-128.0;gc=+(d[W>>1]|0)*.015625+-128.0;nc=+(d[Wa>>1]|0)*.015625+-128.0;mc=+(d[Xa>>1]|0)*.015625+-128.0;lc=+(d[Ya>>1]|0)*.015625+-128.0;cc=+(d[Za>>1]|0)*.015625+-128.0;fc=+(d[_a>>1]|0)*.015625+-128.0;ec=+(d[$a>>1]|0)*.015625+-128.0;Ub=+(d[ab>>1]|0)*.015625+-128.0;zc=e+(cb<<2)|0;n[zc>>2]=+(d[U>>1]|0)*.006103515625;n[zc+4>>2]=kc;n[zc+8>>2]=gc;n[zc+12>>2]=Vb;n[zc+16>>2]=rc;n[zc+20>>2]=nc;n[zc+24>>2]=hb;n[zc+28>>2]=qc;n[zc+32>>2]=mc;n[zc+36>>2]=dc;n[zc+40>>2]=pc;n[zc+44>>2]=lc;yc=zc+48|0;n[yc>>2]=sc;n[yc+4>>2]=oc;n[yc+8>>2]=cc;n[yc+12>>2]=Zb;n[yc+16>>2]=jc;n[yc+20>>2]=fc;n[yc+24>>2]=Lb;n[yc+28>>2]=ic;n[yc+32>>2]=ec;n[yc+36>>2]=$b;n[yc+40>>2]=hc;n[yc+44>>2]=Ub;yc=cb+24|0;zc=db+(bb<<2)|0;if((yc|0)<(a|0)){cb=yc;db=zc}else{Ac=yc;Bc=zc;break}}}else{Ac=0;Bc=c}if((Ac|0)<(ka|0)){db=_^2;cb=Ac;a=Bc;while(1){Ub=+n[a+(_<<2)>>2];if(!(Ub<0.0))if(Ub>1.0)Cc=1.0;else Cc=Ub;else Cc=0.0;Ub=+n[a+4>>2];if(!(Ub<0.0))if(Ub>1.0)Dc=1.0;else Dc=Ub;else Dc=0.0;Ub=+n[a+(db<<2)>>2];if(!(Ub<0.0))if(Ub>1.0)Ec=1.0;else Ec=Ub;else Ec=0.0;bb=wNa(Cc*16384.0)|0;U=wNa(Dc*16384.0)|0;r4(bb,U,wNa(Ec*16384.0)|0,3792192,i,j,k);Ub=+(f[j>>2]|0)*.00006103515625;hc=+(f[k>>2]|0)*.00006103515625;n[e+(cb<<2)>>2]=+(f[i>>2]|0)*.00006103515625*100.0;n[e+(cb+1<<2)>>2]=Ub*256.0+-128.0;n[e+(cb+2<<2)>>2]=hc*256.0+-128.0;U=cb+3|0;bb=a+(Z<<2)|0;if((U|0)<(ka|0)){cb=U;a=bb}else{Fc=U;Gc=bb;break}}}else{Fc=Ac;Gc=Bc}}else{Fc=0;Gc=c}if((b[899744]|0)==0?u1a(899744)|0:0){JCa(X,16);JCa(i,116);QCa(Y,X,i);f[407193]=f[Y>>2]}if((Fc|0)<(ka|0)){Hc=Fc;Ic=Gc}else{u=h;return}while(1){Ec=+n[Ic>>2];if(!(Ec<0.0))if(Ec>1.0)Jc=1.0;else Jc=Ec;else Jc=0.0;Ec=+n[Ic+4>>2];if(!(Ec<0.0))if(Ec>1.0)Kc=1.0;else Kc=Ec;else Kc=0.0;Ec=+n[Ic+8>>2];if(!(Ec<0.0))if(Ec>1.0)Lc=1.0;else Lc=Ec;else Lc=0.0;if($){Ec=Jc*1024.0;Gc=~~Ec;Fc=(Gc|0)>0?Gc:0;Gc=(Fc|0)<1023?Fc:1023;Dc=Ec-+(Gc|0);Fc=aa+(Gc<<2<<2)|0;Ec=Kc*1024.0;Gc=~~Ec;Y=(Gc|0)>0?Gc:0;Gc=(Y|0)<1023?Y:1023;Cc=Ec-+(Gc|0);Y=aa+(Gc<<2<<2)|0;Ec=Lc*1024.0;Gc=~~Ec;i=(Gc|0)>0?Gc:0;Gc=(i|0)<1023?i:1023;hc=Ec-+(Gc|0);i=aa+(Gc<<2<<2)|0;Mc=+n[i>>2]+hc*(+n[i+4>>2]+hc*(hc*+n[i+12>>2]+ +n[i+8>>2]));Nc=+n[Y>>2]+Cc*(+n[Y+4>>2]+Cc*(Cc*+n[Y+12>>2]+ +n[Y+8>>2]));Oc=+n[Fc>>2]+Dc*(+n[Fc+4>>2]+Dc*(Dc*+n[Fc+12>>2]+ +n[Fc+8>>2]))}else{Mc=Lc;Nc=Kc;Oc=Jc}Dc=da*Mc+(ca*Nc+ba*Oc);Cc=ga*Mc+(fa*Nc+ea*Oc);hc=ja*Mc+(ia*Nc+ha*Oc);if(Dc>.008856000378727913)Pc=+iN(Dc);else Pc=Dc*7.7870001792907715+ +n[407193];Fc=Cc>.008856000378727913;if(Fc)Qc=+iN(Cc);else Qc=Cc*7.7870001792907715+ +n[407193];if(hc>.008856000378727913)Rc=+iN(hc);else Rc=hc*7.7870001792907715+ +n[407193];n[e+(Hc<<2)>>2]=Fc?Qc*116.0+-16.0:Cc*903.2999877929688;n[e+(Hc+1<<2)>>2]=(Pc-Qc)*500.0;n[e+(Hc+2<<2)>>2]=(Qc-Rc)*200.0;Hc=Hc+3|0;if((Hc|0)>=(ka|0))break;else Ic=Ic+(Z<<2)|0}u=h;return}function y4(a){a=a|0;PYa(a);return}function z4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,47828);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){A4(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function A4(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=b[a+40>>0]|0?3767616:3768128;i=f[a>>2]|0;k=f[a+4>>2]|0;l=f[a+8>>2]|0;m=f[a+12>>2]|0;n=f[a+16>>2]|0;o=f[a+20>>2]|0;p=f[a+24>>2]|0;q=f[a+28>>2]|0;r=f[a+32>>2]|0;s=f[a+36>>2]|0;a=e*3|0;if((e|0)>0){t=0;u=c}else return;while(1){c=j[g+(h[u>>0]<<1)>>1]|0;e=j[g+(h[u+1>>0]<<1)>>1]|0;v=j[g+(h[u+2>>0]<<1)>>1]|0;w=3785024+((Y(c,k)|0)+2048+(Y(e,l)|0)+(Y(v,m)|0)>>12<<1)|0;x=3785024+((Y(c,n)|0)+2048+(Y(e,o)|0)+(Y(v,p)|0)>>12<<1)|0;y=j[x>>1]|0;x=3785024+((Y(c,q)|0)+2048+(Y(e,r)|0)+(Y(v,s)|0)>>12<<1)|0;v=(y*296|0)+-1320550>>15;e=(((j[w>>1]|0)-y|0)*500|0)+4210688>>15;w=((y-(j[x>>1]|0)|0)*200|0)+4210688>>15;b[d+t>>0]=v>>>0<256?v:(v|0)>0?255:0;b[d+(t+1)>>0]=e>>>0<256?e:(e|0)>0?255:0;b[d+(t+2)>>0]=w>>>0<256?w:(w|0)>0?255:0;t=t+3|0;if((t|0)>=(a|0))break;else u=u+i|0}return}function B4(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0;n=u;u=u+160|0;o=n+144|0;p=n+112|0;q=n+104|0;r=n;_$(q,47852);s=k?2:0;k=(i|0)==0;do if(l)if(k){C4(r,3,s,0,0,m);D4(r+56|0,j,s,0,0,m);f[r+100>>2]=j;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=47880;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=r;_U(o,p,+(Y(h,g)|0)*.0000152587890625);break}else{C4(r,j,s,0,0,m);f[r+56>>2]=j;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=47900;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=r;_U(o,p,+(Y(h,g)|0)*.0000152587890625);break}else if(k){f[r>>2]=j;E4(r+4|0,j,s,0,0,m);F4(r+56|0,j,s,0,0,m);b[r+100>>0]=1;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=47920;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=r;_U(o,p,+(Y(h,g)|0)*.0000152587890625);break}else{E4(r,j,s,0,0,m);f[r+52>>2]=j;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=47940;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=r;_U(o,p,+(Y(h,g)|0)*.0000152587890625);break}while(0);if(!(f[q+4>>2]|0)){u=n;return}u=n;return}function C4(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;i=u;u=u+96|0;j=i+48|0;k=i+24|0;l=i+16|0;m=i+8|0;o=i;q=i+80|0;r=i+76|0;s=i+72|0;f[a>>2]=c;b[a+40>>0]=h&1;h=a+52|0;f[h>>2]=d;i4();f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;if(!g){f[j>>2]=f[93790];f[j+4>>2]=f[93791];f[j+8>>2]=f[93792];f[j+12>>2]=f[93793];f[j+16>>2]=f[93794];f[j+20>>2]=f[93795]}else{p[j>>3]=+n[g>>2];p[j+8>>3]=+n[g+4>>2];p[j+16>>3]=+n[g+8>>2]}g=k+8|0;d=k+16|0;if(e|0){c=k+8|0;t=k+16|0;p[k>>3]=+n[e>>2];p[c>>3]=+n[e+12>>2];p[t>>3]=+n[e+24>>2];bDa(l,k,j);n[a+4+((f[h>>2]^2)*3<<2)>>2]=+p[l>>3];bDa(m,g,j);n[a+16>>2]=+p[m>>3];bDa(o,d,j);n[a+4+((f[h>>2]|0)*3<<2)>>2]=+p[o>>3];p[k>>3]=+n[e+4>>2];p[c>>3]=+n[e+16>>2];p[t>>3]=+n[e+28>>2];v=j+8|0;bDa(l,k,v);n[a+4+(((f[h>>2]^2)*3|0)+1<<2)>>2]=+p[l>>3];bDa(m,g,v);n[a+20>>2]=+p[m>>3];bDa(o,d,v);n[a+4+(((f[h>>2]|0)*3|0)+1<<2)>>2]=+p[o>>3];p[k>>3]=+n[e+8>>2];p[c>>3]=+n[e+20>>2];p[t>>3]=+n[e+32>>2];e=j+16|0;bDa(l,k,e);n[a+4+(((f[h>>2]^2)*3|0)+2<<2)>>2]=+p[l>>3];bDa(m,g,e);n[a+24>>2]=+p[m>>3];bDa(o,d,e);n[a+4+(((f[h>>2]|0)*3|0)+2<<2)>>2]=+p[o>>3];JCa(q,8);w=f[q>>2]|0;x=a+44|0;f[x>>2]=w;JCa(r,6);JCa(k,29);QCa(s,r,k);y=f[s>>2]|0;z=a+48|0;f[z>>2]=y;u=i;return}e=0;do{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;t=375088+(e<<3)|0;if((t|0)!=(k|0)){c=t;t=f[c+4>>2]|0;v=k;f[v>>2]=f[c>>2];f[v+4>>2]=t}t=e+3|0;v=375088+(t<<3)|0;if((v|0)!=(g|0)){c=v;v=f[c+4>>2]|0;A=g;f[A>>2]=f[c>>2];f[A+4>>2]=v}v=375088+(e+6<<3)|0;if((v|0)!=(d|0)){A=v;v=f[A+4>>2]|0;c=d;f[c>>2]=f[A>>2];f[c+4>>2]=v}v=j+(e<<3)|0;bDa(l,k,v);n[a+4+(((f[h>>2]^2)*3|0)+e<<2)>>2]=+p[l>>3];bDa(m,g,v);n[a+4+(t<<2)>>2]=+p[m>>3];bDa(o,d,v);n[a+4+(((f[h>>2]|0)*3|0)+e<<2)>>2]=+p[o>>3];e=e+1|0}while((e|0)!=3);JCa(q,8);w=f[q>>2]|0;x=a+44|0;f[x>>2]=w;JCa(r,6);JCa(k,29);QCa(s,r,k);y=f[s>>2]|0;z=a+48|0;f[z>>2]=y;u=i;return}function D4(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;i=u;u=u+80|0;j=i+56|0;k=i+32|0;l=i+24|0;m=i+16|0;o=i+8|0;q=i;f[a>>2]=c;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;if(!g){f[j>>2]=f[93790];f[j+4>>2]=f[93791];f[j+8>>2]=f[93792];f[j+12>>2]=f[93793];f[j+16>>2]=f[93794];f[j+20>>2]=f[93795]}else{p[j>>3]=+n[g>>2];p[j+8>>3]=+n[g+4>>2];p[j+16>>3]=+n[g+8>>2]}if((b[899816]|0)==0?u1a(899816)|0:0)UCa(899824,4096);g=d*3|0;c=k+8|0;r=k+16|0;s=(d^2)*3|0;if(e|0){d=k+8|0;t=k+16|0;v=0;do{p[k>>3]=+n[e+(v<<2)>>2];w=v+3|0;p[d>>3]=+n[e+(w<<2)>>2];p[t>>3]=+n[e+(v+6<<2)>>2];bDa(m,899824,k);x=j+(v<<3)|0;bDa(l,m,x);y=XCa(l)|0;f[a+4+(v+g<<2)>>2]=y;bDa(o,899824,c);bDa(l,o,x);y=XCa(l)|0;f[a+4+(w<<2)>>2]=y;bDa(q,899824,r);bDa(l,q,x);x=XCa(l)|0;f[a+4+(v+s<<2)>>2]=x;v=v+1|0}while((v|0)!=3);z=h?3768640:3776832;A=a+40|0;f[A>>2]=z;u=i;return}v=0;do{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;e=375088+(v<<3)|0;if((e|0)!=(k|0)){t=e;e=f[t+4>>2]|0;d=k;f[d>>2]=f[t>>2];f[d+4>>2]=e}e=v+3|0;d=375088+(e<<3)|0;if((d|0)!=(c|0)){t=d;d=f[t+4>>2]|0;x=c;f[x>>2]=f[t>>2];f[x+4>>2]=d}d=375088+(v+6<<3)|0;if((d|0)!=(r|0)){x=d;d=f[x+4>>2]|0;t=r;f[t>>2]=f[x>>2];f[t+4>>2]=d}bDa(m,899824,k);d=j+(v<<3)|0;bDa(l,m,d);t=XCa(l)|0;f[a+4+(v+g<<2)>>2]=t;bDa(o,899824,c);bDa(l,o,d);t=XCa(l)|0;f[a+4+(e<<2)>>2]=t;bDa(q,899824,r);bDa(l,q,d);d=XCa(l)|0;f[a+4+(v+s<<2)>>2]=d;v=v+1|0}while((v|0)!=3);z=h?3768640:3776832;A=a+40|0;f[A>>2]=z;u=i;return}function E4(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+112|0;j=i+48|0;k=i+100|0;l=i+40|0;m=i+24|0;o=i+32|0;q=i+16|0;r=i+8|0;s=i;t=i+96|0;v=i+92|0;w=i+88|0;x=i+84|0;y=i+80|0;z=i+76|0;A=i+72|0;f[a>>2]=c;b[a+48>>0]=h&1;i4();f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;if(!g){f[j>>2]=f[93790];f[j+4>>2]=f[93791];f[j+8>>2]=f[93792];f[j+12>>2]=f[93793];f[j+16>>2]=f[93794];f[j+20>>2]=f[93795]}else{p[j>>3]=+n[g>>2];p[j+8>>3]=+n[g+4>>2];p[j+16>>3]=+n[g+8>>2]}g=(d^2)*3|0;h=d*3|0;if(!e){YCa(k,375088);d=f[k>>2]|0;YCa(k,375112);c=f[k>>2]|0;YCa(k,375136);B=f[k>>2]|0;f[a+4+(g<<2)>>2]=d;f[a+16>>2]=c;f[a+4+(h<<2)>>2]=B;YCa(k,375096);B=f[k>>2]|0;YCa(k,375120);c=f[k>>2]|0;YCa(k,375144);d=f[k>>2]|0;f[a+4+(g+1<<2)>>2]=B;f[a+20>>2]=c;f[a+4+(h+1<<2)>>2]=d;YCa(k,375104);d=f[k>>2]|0;YCa(k,375128);c=f[k>>2]|0;YCa(k,375152);C=f[k>>2]|0;D=c;E=d}else{d=f[e+12>>2]|0;c=f[e+24>>2]|0;f[a+4+(g<<2)>>2]=f[e>>2];f[a+16>>2]=d;f[a+4+(h<<2)>>2]=c;c=f[e+16>>2]|0;d=f[e+28>>2]|0;f[a+4+(g+1<<2)>>2]=f[e+4>>2];f[a+20>>2]=c;f[a+4+(h+1<<2)>>2]=d;C=f[e+32>>2]|0;D=f[e+20>>2]|0;E=f[e+8>>2]|0}f[a+4+(g+2<<2)>>2]=E;f[a+24>>2]=D;f[a+4+(h+2<<2)>>2]=C;C=j+8|0;UCa(m,15);bDa(l,C,m);ZCa(o,j,l);UCa(r,3);bDa(q,j+16|0,r);ZCa(s,o,q);YCa(k,s);f[t>>2]=1065353216;f[q>>2]=872415232;s=RCa(k,q)|0;f[m>>2]=f[(s?k:q)>>2];QCa(l,t,m);f[k>>2]=f[l>>2];JCa(v,52);PCa(w,v,k);YCa(l,j);PCa(x,w,l);f[a+40>>2]=f[x>>2];JCa(y,117);PCa(z,y,k);YCa(l,C);PCa(A,z,l);f[a+44>>2]=f[A>>2];A=l;f[A>>2]=0;f[A+4>>2]=1072693248;if(dDa(C,l)|0){u=i;return}f[l>>2]=0;f[l+4>>2]=0;C=c$(l,31)|0;A=213682;a=C+31|0;do{b[C>>0]=b[A>>0]|0;C=C+1|0;A=A+1|0}while((C|0)<(a|0));j$(-215,l,214685,206245,7844);d$(l);u=i;return}function F4(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0;g=u;u=u+32|0;i=g+8|0;j=g;f[a>>2]=c;i4();if((b[899800]|0)==0?u1a(899800)|0:0)UCa(899808,4096);c=d*3|0;k=i+8|0;l=i+16|0;m=(d^2)*3|0;if(!e){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;d=375088;o=f[d+4>>2]|0;q=i;f[q>>2]=f[d>>2];f[q+4>>2]=o;o=375112;q=f[o+4>>2]|0;d=k;f[d>>2]=f[o>>2];f[d+4>>2]=q;q=375136;d=f[q+4>>2]|0;o=l;f[o>>2]=f[q>>2];f[o+4>>2]=d;bDa(j,899808,i);d=XCa(j)|0;f[a+4+(c<<2)>>2]=d;bDa(j,899808,k);d=XCa(j)|0;f[a+16>>2]=d;bDa(j,899808,l);d=XCa(j)|0;f[a+4+(m<<2)>>2]=d;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;d=375096;o=f[d+4>>2]|0;q=i;f[q>>2]=f[d>>2];f[q+4>>2]=o;o=375120;q=f[o+4>>2]|0;d=k;f[d>>2]=f[o>>2];f[d+4>>2]=q;q=375144;d=f[q+4>>2]|0;o=l;f[o>>2]=f[q>>2];f[o+4>>2]=d;bDa(j,899808,i);d=XCa(j)|0;f[a+4+(c+1<<2)>>2]=d;bDa(j,899808,k);d=XCa(j)|0;f[a+20>>2]=d;bDa(j,899808,l);d=XCa(j)|0;f[a+4+(m+1<<2)>>2]=d;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;d=375104;o=f[d+4>>2]|0;q=i;f[q>>2]=f[d>>2];f[q+4>>2]=o;o=375128;q=f[o+4>>2]|0;d=k;f[d>>2]=f[o>>2];f[d+4>>2]=q;q=375152;d=f[q+4>>2]|0;o=l;f[o>>2]=f[q>>2];f[o+4>>2]=d;bDa(j,899808,i);d=XCa(j)|0;f[a+4+(c+2<<2)>>2]=d;bDa(j,899808,k);d=XCa(j)|0;f[a+24>>2]=d;bDa(j,899808,l);d=XCa(j)|0;f[a+4+(m+2<<2)>>2]=d;r=h?3768640:3776832;s=a+40|0;f[s>>2]=r;u=g;return}else{p[i>>3]=+n[e>>2];d=i+8|0;p[d>>3]=+n[e+12>>2];o=i+16|0;p[o>>3]=+n[e+24>>2];bDa(j,899808,i);q=XCa(j)|0;f[a+4+(c<<2)>>2]=q;bDa(j,899808,k);q=XCa(j)|0;f[a+16>>2]=q;bDa(j,899808,l);q=XCa(j)|0;f[a+4+(m<<2)>>2]=q;p[i>>3]=+n[e+4>>2];p[d>>3]=+n[e+16>>2];p[o>>3]=+n[e+28>>2];bDa(j,899808,i);q=XCa(j)|0;f[a+4+(c+1<<2)>>2]=q;bDa(j,899808,k);q=XCa(j)|0;f[a+20>>2]=q;bDa(j,899808,l);q=XCa(j)|0;f[a+4+(m+1<<2)>>2]=q;p[i>>3]=+n[e+8>>2];p[d>>3]=+n[e+20>>2];p[o>>3]=+n[e+32>>2];bDa(j,899808,i);i=XCa(j)|0;f[a+4+(c+2<<2)>>2]=i;bDa(j,899808,k);k=XCa(j)|0;f[a+24>>2]=k;bDa(j,899808,l);l=XCa(j)|0;f[a+4+(m+2<<2)>>2]=l;r=h?3768640:3776832;s=a+40|0;f[s>>2]=r;u=g;return}}function G4(a){a=a|0;PYa(a);return}function H4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,47952);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){I4(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function I4(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0;g=u;u=u+32|0;h=g+16|0;i=g+12|0;j=g+8|0;k=g+4|0;l=g;m=f[a>>2]|0;o=(b[a+48>>0]|0)!=0;p=o?940576:0;q=+n[a+4>>2];r=+n[a+8>>2];t=+n[a+12>>2];v=+n[a+16>>2];w=+n[a+20>>2];x=+n[a+24>>2];y=+n[a+28>>2];z=+n[a+32>>2];A=+n[a+36>>2];B=+n[a+40>>2];C=+n[a+44>>2];a=e*3|0;if((e|0)<=0){u=g;return}e=(m|0)==4;D=d;d=0;while(1){E=+n[c+(d<<2)>>2];if(!(E>=8.0))F=E*.001107051968574524;else{G=(E+16.0)*.008620689623057842;F=G*(G*G)}G=(+n[c+(d+1<<2)>>2]+B*E)*3.0;H=.25/(C*E+ +n[c+(d+2<<2)>>2]);I=H>.25?.25:H;H=I<-.25?-.25:I;I=H*(G*(F*3.0));J=((E*156.0-G)*H+-5.0)*F;H=t*J+(r*F+q*I);n[h>>2]=H;G=x*J+(w*F+v*I);n[i>>2]=G;E=A*J+(z*F+y*I);n[j>>2]=E;n[k>>2]=0.0;K=H<0.0?k:h;n[l>>2]=1.0;L=f[(+n[K>>2]>1.0?l:K)>>2]|0;f[h>>2]=L;n[k>>2]=0.0;K=G<0.0?k:i;n[l>>2]=1.0;M=f[(+n[K>>2]>1.0?l:K)>>2]|0;f[i>>2]=M;n[k>>2]=0.0;K=E<0.0?k:j;n[l>>2]=1.0;N=f[(+n[K>>2]>1.0?l:K)>>2]|0;f[j>>2]=N;if(o){E=(f[s>>2]=N,+n[s>>2]);G=(f[s>>2]=M,+n[s>>2]);H=(f[s>>2]=L,+n[s>>2])*1024.0;M=~~H;N=(M|0)>0?M:0;M=(N|0)<1023?N:1023;I=H-+(M|0);N=p+(M<<2<<2)|0;H=+n[N>>2]+I*(+n[N+4>>2]+I*(+n[N+8>>2]+ +n[N+12>>2]*I));n[h>>2]=H;I=G*1024.0;N=~~I;M=(N|0)>0?N:0;N=(M|0)<1023?M:1023;G=I-+(N|0);M=p+(N<<2<<2)|0;n[i>>2]=+n[M>>2]+G*(+n[M+4>>2]+G*(+n[M+8>>2]+ +n[M+12>>2]*G));G=E*1024.0;M=~~G;N=(M|0)>0?M:0;M=(N|0)<1023?N:1023;E=G-+(M|0);N=p+(M<<2<<2)|0;n[j>>2]=+n[N>>2]+E*(+n[N+4>>2]+E*(+n[N+8>>2]+ +n[N+12>>2]*E));O=(n[s>>2]=H,f[s>>2]|0)}else O=L;f[D>>2]=O;f[D+4>>2]=f[i>>2];f[D+8>>2]=f[j>>2];if(e)n[D+12>>2]=1.0;d=d+3|0;if((d|0)>=(a|0))break;else D=D+(m<<2)|0}u=g;return}function J4(a){a=a|0;PYa(a);return}function K4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,47972);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){L4(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function L4(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;g=u;u=u+3088|0;i=g;j=g+3072|0;if(b[a+100>>0]|0){M4(a+56|0,c,d,e);u=g;return}k=f[a>>2]|0;if((b[899768]|0)==0?u1a(899768)|0:0)JCa(1628792,255);if((b[899776]|0)==0?u1a(899776)|0:0){JCa(j,100);QCa(1628796,j,1628792)}if((b[899784]|0)==0?u1a(899784)|0:0)QCa(1628800,904480,1628792);if((b[899792]|0)==0?u1a(899792)|0:0)QCa(1628804,904492,1628792);if((e|0)>0){j=a+4|0;a=(k|0)==4;l=d;d=0;m=~e;o=c;while(1){c=(Y((m|0)>-257?m:-257,-3)|0)+-19|0;p=((c|0)>16?c:16)+-1&-16;c=p+16|0;q=e-d|0;r=(q|0)<256?q:256;s=+n[407199];t=+n[407200];v=+n[407201];w=+n[226118];x=+n[226121];q=r*3|0;y=q+-48|0;if((y|0)>0){z=0;while(1){A=o+z|0;B=b[A+4>>0]|0;C=b[A+5>>0]|0;D=b[A+6>>0]|0;E=b[A+7>>0]|0;F=b[A+8>>0]|0;G=b[A+9>>0]|0;H=b[A+10>>0]|0;I=b[A+11>>0]|0;J=b[A+12>>0]|0;K=b[A+13>>0]|0;L=b[A+14>>0]|0;M=b[A+15>>0]|0;N=i+(z<<2)|0;O=w+t*+(h[A+1>>0]|0);P=x+v*+(h[A+2>>0]|0);Q=s*+(h[A+3>>0]|0)+0.0;n[N>>2]=s*+(h[A>>0]|0)+0.0;n[N+4>>2]=O;n[N+8>>2]=P;n[N+12>>2]=Q;n[N+16>>2]=w+t*+(B&255);n[N+20>>2]=x+v*+(C&255);n[N+24>>2]=s*+(D&255)+0.0;n[N+28>>2]=w+t*+(E&255);n[N+32>>2]=x+v*+(F&255);n[N+36>>2]=s*+(G&255)+0.0;n[N+40>>2]=w+t*+(H&255);n[N+44>>2]=x+v*+(I&255);n[N+48>>2]=s*+(J&255)+0.0;n[N+52>>2]=w+t*+(K&255);n[N+56>>2]=x+v*+(L&255);n[N+60>>2]=s*+(M&255)+0.0;M=A+16|0;L=b[M+4>>0]|0;K=b[M+5>>0]|0;J=b[M+6>>0]|0;I=b[M+7>>0]|0;H=b[M+8>>0]|0;G=b[M+9>>0]|0;F=b[M+10>>0]|0;E=b[M+11>>0]|0;D=b[M+12>>0]|0;C=b[M+13>>0]|0;B=b[M+14>>0]|0;R=b[M+15>>0]|0;Q=x+v*+(h[M+1>>0]|0);P=s*+(h[M+2>>0]|0)+0.0;O=w+t*+(h[M+3>>0]|0);n[N+64>>2]=w+t*+(h[M>>0]|0);n[N+68>>2]=Q;n[N+72>>2]=P;n[N+76>>2]=O;n[N+80>>2]=x+v*+(L&255);n[N+84>>2]=s*+(K&255)+0.0;n[N+88>>2]=w+t*+(J&255);n[N+92>>2]=x+v*+(I&255);n[N+96>>2]=s*+(H&255)+0.0;n[N+100>>2]=w+t*+(G&255);n[N+104>>2]=x+v*+(F&255);n[N+108>>2]=s*+(E&255)+0.0;n[N+112>>2]=w+t*+(D&255);n[N+116>>2]=x+v*+(C&255);n[N+120>>2]=s*+(B&255)+0.0;n[N+124>>2]=w+t*+(R&255);R=A+32|0;A=b[R+4>>0]|0;B=b[R+5>>0]|0;C=b[R+6>>0]|0;D=b[R+7>>0]|0;E=b[R+8>>0]|0;F=b[R+9>>0]|0;G=b[R+10>>0]|0;H=b[R+11>>0]|0;I=b[R+12>>0]|0;J=b[R+13>>0]|0;K=b[R+14>>0]|0;L=b[R+15>>0]|0;O=s*+(h[R+1>>0]|0)+0.0;P=w+t*+(h[R+2>>0]|0);Q=x+v*+(h[R+3>>0]|0);n[N+128>>2]=x+v*+(h[R>>0]|0);n[N+132>>2]=O;n[N+136>>2]=P;n[N+140>>2]=Q;n[N+144>>2]=s*+(A&255)+0.0;n[N+148>>2]=w+t*+(B&255);n[N+152>>2]=x+v*+(C&255);n[N+156>>2]=s*+(D&255)+0.0;n[N+160>>2]=w+t*+(E&255);n[N+164>>2]=x+v*+(F&255);n[N+168>>2]=s*+(G&255)+0.0;n[N+172>>2]=w+t*+(H&255);n[N+176>>2]=x+v*+(I&255);n[N+180>>2]=s*+(J&255)+0.0;n[N+184>>2]=w+t*+(K&255);n[N+188>>2]=x+v*+(L&255);L=z+48|0;if((L|0)<(y|0))z=L;else{S=L;break}}}else S=0;if((S|0)<(q|0)){v=+n[407199];x=+n[407200];t=+n[226118];w=+n[407201];s=+n[226121];z=S;do{n[i+(z<<2)>>2]=+(h[o+z>>0]|0)*v;y=z+1|0;n[i+(y<<2)>>2]=+(h[o+y>>0]|0)*x+t;y=z+2|0;n[i+(y<<2)>>2]=+(h[o+y>>0]|0)*w+s;z=z+3|0}while((z|0)<(q|0))}I4(j,i,i,r);z=q+-16|0;if((q|0)>16){y=l+16|0;L=l;N=0;while(1){K=i+(N<<2)|0;s=+n[K+16>>2];w=+n[K+20>>2];t=+n[K+24>>2];x=+n[K+28>>2];v=+n[K+32>>2];Q=+n[K+36>>2];P=+n[K+40>>2];O=+n[K+44>>2];T=+n[K+48>>2];U=+n[K+52>>2];V=+n[K+56>>2];W=+n[K+60>>2];X=+n[K+4>>2]*255.0;Z=+n[K+8>>2]*255.0;_=+n[K+12>>2]*255.0;J=wNa(+n[K>>2]*255.0)|0;K=wNa(X)|0;I=wNa(Z)|0;H=wNa(_)|0;G=wNa(s*255.0)|0;F=wNa(w*255.0)|0;E=wNa(t*255.0)|0;D=wNa(x*255.0)|0;C=wNa(v*255.0)|0;B=wNa(Q*255.0)|0;A=wNa(P*255.0)|0;R=wNa(O*255.0)|0;M=wNa(T*255.0)|0;$=wNa(U*255.0)|0;aa=wNa(V*255.0)|0;ba=wNa(W*255.0)|0;ca=((J+32768|0)>>>0<65536?J:(J|0)>0?32767:32768)&65535;J=((C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768)&65535;C=((K+32768|0)>>>0<65536?K:(K|0)>0?32767:32768)&65535;K=((B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768)&65535;B=((I+32768|0)>>>0<65536?I:(I|0)>0?32767:32768)&65535;I=((A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768)&65535;A=((H+32768|0)>>>0<65536?H:(H|0)>0?32767:32768)&65535;H=((R+32768|0)>>>0<65536?R:(R|0)>0?32767:32768)&65535;R=((G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768)&65535;G=((M+32768|0)>>>0<65536?M:(M|0)>0?32767:32768)&65535;M=((F+32768|0)>>>0<65536?F:(F|0)>0?32767:32768)&65535;F=(($+32768|0)>>>0<65536?$:($|0)>0?32767:32768)&65535;$=((E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768)&65535;E=((aa+32768|0)>>>0<65536?aa:(aa|0)>0?32767:32768)&65535;aa=((D+32768|0)>>>0<65536?D:(D|0)>0?32767:32768)&65535;D=((ba+32768|0)>>>0<65536?ba:(ba|0)>0?32767:32768)&65535;b[L>>0]=ca>>>0<255?ca:255;b[L+1>>0]=C>>>0<255?C:255;b[L+2>>0]=B>>>0<255?B:255;b[L+3>>0]=A>>>0<255?A:255;b[L+4>>0]=R>>>0<255?R:255;b[L+5>>0]=M>>>0<255?M:255;b[L+6>>0]=$>>>0<255?$:255;b[L+7>>0]=aa>>>0<255?aa:255;b[L+8>>0]=J>>>0<255?J:255;b[L+9>>0]=K>>>0<255?K:255;b[L+10>>0]=I>>>0<255?I:255;b[L+11>>0]=H>>>0<255?H:255;b[L+12>>0]=G>>>0<255?G:255;b[L+13>>0]=F>>>0<255?F:255;b[L+14>>0]=E>>>0<255?E:255;b[L+15>>0]=D>>>0<255?D:255;N=N+16|0;if((N|0)>=(z|0))break;else L=L+16|0}da=y+p|0;ea=c}else{da=l;ea=0}if((ea|0)<(q|0))if(a){L=da;z=ea;while(1){N=wNa(+n[i+(z<<2)>>2]*255.0)|0;b[L>>0]=N>>>0<256?N:(N|0)>0?255:0;N=wNa(+n[i+(z+1<<2)>>2]*255.0)|0;b[L+1>>0]=N>>>0<256?N:(N|0)>0?255:0;N=wNa(+n[i+(z+2<<2)>>2]*255.0)|0;b[L+2>>0]=N>>>0<256?N:(N|0)>0?255:0;b[L+3>>0]=-1;z=z+3|0;N=L+4|0;if((z|0)>=(q|0)){fa=N;break}else L=N}}else{L=da;z=ea;while(1){c=wNa(+n[i+(z<<2)>>2]*255.0)|0;b[L>>0]=c>>>0<256?c:(c|0)>0?255:0;c=wNa(+n[i+(z+1<<2)>>2]*255.0)|0;b[L+1>>0]=c>>>0<256?c:(c|0)>0?255:0;c=wNa(+n[i+(z+2<<2)>>2]*255.0)|0;b[L+2>>0]=c>>>0<256?c:(c|0)>0?255:0;z=z+3|0;c=L+k|0;if((z|0)>=(q|0)){fa=c;break}else L=c}}else fa=da;d=d+256|0;if((d|0)>=(e|0))break;else{l=fa;m=m+256|0;o=o+768|0}}}u=g;return}function M4(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0;i=u;u=u+688|0;k=i+672|0;l=i+656|0;m=i+640|0;n=i;o=i+512|0;p=i+448|0;q=i+384|0;r=i+320|0;s=i+256|0;t=i+192|0;v=i+624|0;w=i+608|0;x=i+592|0;y=i+576|0;z=f[a>>2]|0;A=g*3|0;g=A+-48|0;if((A|0)>48){B=a+4|0;C=a+8|0;D=a+12|0;E=a+16|0;F=a+20|0;G=a+24|0;H=a+28|0;I=a+32|0;K=a+36|0;L=a+40|0;M=r+16|0;N=r+4|0;O=r+20|0;P=r+8|0;Q=r+24|0;R=r+12|0;S=r+28|0;T=r+32|0;U=r+48|0;V=r+36|0;W=r+52|0;X=r+40|0;Z=r+56|0;_=r+44|0;$=r+60|0;aa=s+16|0;ba=s+4|0;ca=s+20|0;da=s+8|0;ea=s+24|0;fa=s+12|0;ga=s+28|0;ha=s+32|0;ia=s+48|0;ja=s+36|0;ka=s+52|0;la=s+40|0;ma=s+56|0;na=s+44|0;oa=s+60|0;pa=t+16|0;qa=t+4|0;ra=t+20|0;sa=t+8|0;ta=t+24|0;ua=t+12|0;va=t+28|0;wa=t+32|0;xa=t+48|0;ya=t+36|0;za=t+52|0;Aa=t+40|0;Ba=t+56|0;Ca=t+44|0;Da=t+60|0;Ea=v+1|0;Fa=v+2|0;Ga=v+3|0;Ha=v+4|0;Ia=v+5|0;Ja=v+6|0;Ka=v+7|0;La=v+8|0;Ma=v+9|0;Na=v+10|0;Oa=v+11|0;Pa=v+12|0;Qa=v+13|0;Ra=v+14|0;Sa=v+15|0;Ta=w+1|0;Ua=w+2|0;Va=w+3|0;Wa=w+4|0;Xa=w+5|0;Ya=w+6|0;Za=w+7|0;_a=w+8|0;$a=w+9|0;ab=w+10|0;bb=w+11|0;cb=w+12|0;db=w+13|0;eb=w+14|0;fb=w+15|0;gb=x+1|0;hb=x+2|0;ib=x+3|0;jb=x+4|0;kb=x+5|0;lb=x+6|0;mb=x+7|0;nb=x+8|0;ob=x+9|0;pb=x+10|0;qb=x+11|0;rb=x+12|0;sb=x+13|0;tb=x+14|0;ub=x+15|0;vb=(z|0)==4;wb=z<<4;xb=n+4|0;yb=n+8|0;zb=n+12|0;Ab=o+4|0;Bb=o+8|0;Cb=o+12|0;Db=n+64|0;Eb=n+68|0;Fb=n+72|0;Gb=n+76|0;Hb=p+4|0;Ib=p+8|0;Jb=p+12|0;Kb=n+128|0;Lb=n+132|0;Mb=n+136|0;Nb=n+140|0;Ob=q+4|0;Pb=q+8|0;Qb=q+12|0;Rb=n+16|0;Sb=n+20|0;Tb=n+24|0;Ub=n+28|0;Vb=o+16|0;Wb=o+20|0;Xb=o+24|0;Yb=o+28|0;Zb=n+80|0;_b=n+84|0;$b=n+88|0;ac=n+92|0;bc=p+16|0;cc=p+20|0;dc=p+24|0;ec=p+28|0;fc=n+144|0;gc=n+148|0;hc=n+152|0;ic=n+156|0;jc=q+16|0;kc=q+20|0;lc=q+24|0;mc=q+28|0;nc=n+32|0;oc=n+36|0;pc=n+40|0;qc=n+44|0;rc=o+32|0;sc=o+36|0;tc=o+40|0;uc=o+44|0;vc=n+96|0;wc=n+100|0;xc=n+104|0;yc=n+108|0;zc=p+32|0;Ac=p+36|0;Bc=p+40|0;Cc=p+44|0;Dc=n+160|0;Ec=n+164|0;Fc=n+168|0;Gc=n+172|0;Hc=q+32|0;Ic=q+36|0;Jc=q+40|0;Kc=q+44|0;Lc=n+48|0;Mc=n+52|0;Nc=n+56|0;Oc=n+60|0;Pc=o+48|0;Qc=o+52|0;Rc=o+56|0;Sc=o+60|0;Tc=n+112|0;Uc=n+116|0;Vc=n+120|0;Wc=n+124|0;Xc=p+48|0;Yc=p+52|0;Zc=p+56|0;_c=p+60|0;$c=n+176|0;ad=n+180|0;bd=n+184|0;cd=n+188|0;dd=q+48|0;ed=q+52|0;fd=q+56|0;gd=q+60|0;hd=e;id=0;while(1){jd=c+id|0;kd=0;ld=0;while(1){b[k+kd>>0]=b[jd+ld>>0]|0;b[l+kd>>0]=b[jd+(ld+1)>>0]|0;b[m+kd>>0]=b[jd+(ld+2)>>0]|0;kd=kd+1|0;if((kd|0)==16)break;else ld=ld+3|0}N4(a,k,l,m,n);ld=f[xb>>2]|0;kd=f[yb>>2]|0;jd=f[zb>>2]|0;f[o>>2]=f[n>>2];f[Ab>>2]=ld;f[Bb>>2]=kd;f[Cb>>2]=jd;jd=f[Eb>>2]|0;kd=f[Fb>>2]|0;ld=f[Gb>>2]|0;f[p>>2]=f[Db>>2];f[Hb>>2]=jd;f[Ib>>2]=kd;f[Jb>>2]=ld;ld=f[Lb>>2]|0;kd=f[Mb>>2]|0;jd=f[Nb>>2]|0;f[q>>2]=f[Kb>>2];f[Ob>>2]=ld;f[Pb>>2]=kd;f[Qb>>2]=jd;jd=f[Sb>>2]|0;kd=f[Tb>>2]|0;ld=f[Ub>>2]|0;f[Vb>>2]=f[Rb>>2];f[Wb>>2]=jd;f[Xb>>2]=kd;f[Yb>>2]=ld;ld=f[_b>>2]|0;kd=f[$b>>2]|0;jd=f[ac>>2]|0;f[bc>>2]=f[Zb>>2];f[cc>>2]=ld;f[dc>>2]=kd;f[ec>>2]=jd;jd=f[gc>>2]|0;kd=f[hc>>2]|0;ld=f[ic>>2]|0;f[jc>>2]=f[fc>>2];f[kc>>2]=jd;f[lc>>2]=kd;f[mc>>2]=ld;ld=f[oc>>2]|0;kd=f[pc>>2]|0;jd=f[qc>>2]|0;f[rc>>2]=f[nc>>2];f[sc>>2]=ld;f[tc>>2]=kd;f[uc>>2]=jd;jd=f[wc>>2]|0;kd=f[xc>>2]|0;ld=f[yc>>2]|0;f[zc>>2]=f[vc>>2];f[Ac>>2]=jd;f[Bc>>2]=kd;f[Cc>>2]=ld;ld=f[Ec>>2]|0;kd=f[Fc>>2]|0;jd=f[Gc>>2]|0;f[Hc>>2]=f[Dc>>2];f[Ic>>2]=ld;f[Jc>>2]=kd;f[Kc>>2]=jd;jd=f[Mc>>2]|0;kd=f[Nc>>2]|0;ld=f[Oc>>2]|0;f[Pc>>2]=f[Lc>>2];f[Qc>>2]=jd;f[Rc>>2]=kd;f[Sc>>2]=ld;ld=f[Uc>>2]|0;kd=f[Vc>>2]|0;jd=f[Wc>>2]|0;f[Xc>>2]=f[Tc>>2];f[Yc>>2]=ld;f[Zc>>2]=kd;f[_c>>2]=jd;jd=f[ad>>2]|0;kd=f[bd>>2]|0;ld=f[cd>>2]|0;f[dd>>2]=f[$c>>2];f[ed>>2]=jd;f[fd>>2]=kd;f[gd>>2]=ld;ld=f[B>>2]|0;kd=f[C>>2]|0;jd=f[D>>2]|0;md=f[E>>2]|0;nd=f[F>>2]|0;od=f[G>>2]|0;pd=f[H>>2]|0;qd=f[I>>2]|0;rd=f[K>>2]|0;sd=f[L>>2]|0;td=0;do{ud=f[o+(td<<4)>>2]|0;vd=Y(ud,ld)|0;wd=f[o+(td<<4)+4>>2]|0;xd=Y(wd,ld)|0;yd=f[o+(td<<4)+8>>2]|0;zd=Y(yd,ld)|0;Ad=f[o+(td<<4)+12>>2]|0;Bd=Y(Ad,ld)|0;Cd=f[p+(td<<4)>>2]|0;Dd=Y(Cd,kd)|0;Ed=f[p+(td<<4)+4>>2]|0;Fd=Y(Ed,kd)|0;Gd=f[p+(td<<4)+8>>2]|0;Hd=Y(Gd,kd)|0;Id=f[p+(td<<4)+12>>2]|0;Jd=Y(Id,kd)|0;Kd=f[q+(td<<4)>>2]|0;Ld=Y(Kd,jd)|0;Md=f[q+(td<<4)+4>>2]|0;Nd=Y(Md,jd)|0;Od=f[q+(td<<4)+8>>2]|0;Pd=Y(Od,jd)|0;Qd=f[q+(td<<4)+12>>2]|0;Rd=vd+8192+Dd+Ld>>14;Ld=xd+8192+Fd+Nd>>14;Nd=zd+8192+Hd+Pd>>14;Pd=Bd+8192+Jd+(Y(Qd,jd)|0)>>14;Jd=(Y(ud,md)|0)+8192+(Y(Cd,nd)|0)+(Y(Kd,od)|0)>>14;Bd=(Y(wd,md)|0)+8192+(Y(Ed,nd)|0)+(Y(Md,od)|0)>>14;Hd=(Y(yd,md)|0)+8192+(Y(Gd,nd)|0)+(Y(Od,od)|0)>>14;zd=(Y(Ad,md)|0)+8192+(Y(Id,nd)|0)+(Y(Qd,od)|0)>>14;Fd=(Y(ud,pd)|0)+8192+(Y(Cd,qd)|0)+(Y(Kd,rd)|0)>>14;Kd=(Y(wd,pd)|0)+8192+(Y(Ed,qd)|0)+(Y(Md,rd)|0)>>14;Md=(Y(yd,pd)|0)+8192+(Y(Gd,qd)|0)+(Y(Od,rd)|0)>>14;Od=(Y(Ad,pd)|0)+8192+(Y(Id,qd)|0)+(Y(Qd,rd)|0)>>14;Qd=j[sd+(((Ld|0)>0?((Ld|0)<4095?Ld:4095):0)<<1)>>1]|0;Ld=j[sd+(((Nd|0)>0?((Nd|0)<4095?Nd:4095):0)<<1)>>1]|0;Nd=j[sd+(((Pd|0)>0?((Pd|0)<4095?Pd:4095):0)<<1)>>1]|0;f[r+(td<<4)>>2]=j[sd+(((Rd|0)>0?((Rd|0)<4095?Rd:4095):0)<<1)>>1];f[r+(td<<4)+4>>2]=Qd;f[r+(td<<4)+8>>2]=Ld;f[r+(td<<4)+12>>2]=Nd;Nd=j[sd+(((Bd|0)>0?((Bd|0)<4095?Bd:4095):0)<<1)>>1]|0;Bd=j[sd+(((Hd|0)>0?((Hd|0)<4095?Hd:4095):0)<<1)>>1]|0;Hd=j[sd+(((zd|0)>0?((zd|0)<4095?zd:4095):0)<<1)>>1]|0;f[s+(td<<4)>>2]=j[sd+(((Jd|0)>0?((Jd|0)<4095?Jd:4095):0)<<1)>>1];f[s+(td<<4)+4>>2]=Nd;f[s+(td<<4)+8>>2]=Bd;f[s+(td<<4)+12>>2]=Hd;Hd=j[sd+(((Kd|0)>0?((Kd|0)<4095?Kd:4095):0)<<1)>>1]|0;Kd=j[sd+(((Md|0)>0?((Md|0)<4095?Md:4095):0)<<1)>>1]|0;Md=j[sd+(((Od|0)>0?((Od|0)<4095?Od:4095):0)<<1)>>1]|0;f[t+(td<<4)>>2]=j[sd+(((Fd|0)>0?((Fd|0)<4095?Fd:4095):0)<<1)>>1];f[t+(td<<4)+4>>2]=Hd;f[t+(td<<4)+8>>2]=Kd;f[t+(td<<4)+12>>2]=Md;td=td+1|0}while((td|0)!=4);td=f[r>>2]|0;sd=f[M>>2]|0;rd=f[N>>2]|0;qd=f[O>>2]|0;pd=f[P>>2]|0;od=f[Q>>2]|0;nd=f[R>>2]|0;md=f[S>>2]|0;jd=f[T>>2]|0;kd=f[U>>2]|0;ld=f[V>>2]|0;Md=f[W>>2]|0;Kd=f[X>>2]|0;Hd=f[Z>>2]|0;Fd=f[_>>2]|0;Od=f[$>>2]|0;Bd=f[s>>2]|0;Nd=f[aa>>2]|0;Jd=f[ba>>2]|0;zd=f[ca>>2]|0;Ld=f[da>>2]|0;Qd=f[ea>>2]|0;Rd=f[fa>>2]|0;Pd=f[ga>>2]|0;Id=f[ha>>2]|0;Ad=f[ia>>2]|0;Gd=f[ja>>2]|0;yd=f[ka>>2]|0;Ed=f[la>>2]|0;wd=f[ma>>2]|0;Cd=f[na>>2]|0;ud=f[oa>>2]|0;xd=f[t>>2]|0;Dd=f[pa>>2]|0;vd=f[qa>>2]|0;Sd=f[ra>>2]|0;Td=f[sa>>2]|0;Ud=f[ta>>2]|0;Vd=f[ua>>2]|0;Wd=f[va>>2]|0;Xd=f[wa>>2]|0;Yd=f[xa>>2]|0;Zd=f[ya>>2]|0;_d=f[za>>2]|0;$d=f[Aa>>2]|0;ae=f[Ba>>2]|0;be=f[Ca>>2]|0;ce=f[Da>>2]|0;b[v>>0]=xd>>>0<255?xd:255;b[Ea>>0]=vd>>>0<255?vd:255;b[Fa>>0]=Td>>>0<255?Td:255;b[Ga>>0]=Vd>>>0<255?Vd:255;b[Ha>>0]=Dd>>>0<255?Dd:255;b[Ia>>0]=Sd>>>0<255?Sd:255;b[Ja>>0]=Ud>>>0<255?Ud:255;b[Ka>>0]=Wd>>>0<255?Wd:255;b[La>>0]=Xd>>>0<255?Xd:255;b[Ma>>0]=Zd>>>0<255?Zd:255;b[Na>>0]=$d>>>0<255?$d:255;b[Oa>>0]=be>>>0<255?be:255;b[Pa>>0]=Yd>>>0<255?Yd:255;b[Qa>>0]=_d>>>0<255?_d:255;b[Ra>>0]=ae>>>0<255?ae:255;b[Sa>>0]=ce>>>0<255?ce:255;b[w>>0]=Bd>>>0<255?Bd:255;b[Ta>>0]=Jd>>>0<255?Jd:255;b[Ua>>0]=Ld>>>0<255?Ld:255;b[Va>>0]=Rd>>>0<255?Rd:255;b[Wa>>0]=Nd>>>0<255?Nd:255;b[Xa>>0]=zd>>>0<255?zd:255;b[Ya>>0]=Qd>>>0<255?Qd:255;b[Za>>0]=Pd>>>0<255?Pd:255;b[_a>>0]=Id>>>0<255?Id:255;b[$a>>0]=Gd>>>0<255?Gd:255;b[ab>>0]=Ed>>>0<255?Ed:255;b[bb>>0]=Cd>>>0<255?Cd:255;b[cb>>0]=Ad>>>0<255?Ad:255;b[db>>0]=yd>>>0<255?yd:255;b[eb>>0]=wd>>>0<255?wd:255;b[fb>>0]=ud>>>0<255?ud:255;b[x>>0]=td>>>0<255?td:255;b[gb>>0]=rd>>>0<255?rd:255;b[hb>>0]=pd>>>0<255?pd:255;b[ib>>0]=nd>>>0<255?nd:255;b[jb>>0]=sd>>>0<255?sd:255;b[kb>>0]=qd>>>0<255?qd:255;b[lb>>0]=od>>>0<255?od:255;b[mb>>0]=md>>>0<255?md:255;b[nb>>0]=jd>>>0<255?jd:255;b[ob>>0]=ld>>>0<255?ld:255;b[pb>>0]=Kd>>>0<255?Kd:255;b[qb>>0]=Fd>>>0<255?Fd:255;b[rb>>0]=kd>>>0<255?kd:255;b[sb>>0]=Md>>>0<255?Md:255;b[tb>>0]=Hd>>>0<255?Hd:255;b[ub>>0]=Od>>>0<255?Od:255;if(vb){Od=y;Hd=Od+16|0;do{b[Od>>0]=255;Od=Od+1|0}while((Od|0)<(Hd|0));Od=0;Hd=0;while(1){b[hd+Hd>>0]=b[v+Od>>0]|0;b[hd+(Hd|1)>>0]=b[w+Od>>0]|0;b[hd+(Hd|2)>>0]=b[x+Od>>0]|0;b[hd+(Hd|3)>>0]=b[y+Od>>0]|0;Od=Od+1|0;if((Od|0)==16)break;else Hd=Hd+4|0}}else{Hd=0;Od=0;while(1){b[hd+Od>>0]=b[v+Hd>>0]|0;b[hd+(Od+1)>>0]=b[w+Hd>>0]|0;b[hd+(Od+2)>>0]=b[x+Hd>>0]|0;Hd=Hd+1|0;if((Hd|0)==16)break;else Od=Od+3|0}}Od=id+48|0;Hd=hd+wb|0;if((Od|0)<(g|0)){hd=Hd;id=Od}else{de=Hd;ee=Od;break}}}else{de=e;ee=0}if((ee|0)>=(A|0)){u=i;return}e=a+4|0;id=a+8|0;hd=a+12|0;g=a+16|0;wb=a+20|0;x=a+24|0;w=a+28|0;v=a+32|0;y=a+36|0;vb=a+40|0;a=(z|0)==4;ub=de;de=ee;while(1){ee=h[c+de>>0]|0;tb=d[3791168+(ee<<1<<1)>>1]|0;sb=ee<<8;ee=f[1104432+((sb|(h[c+(de+1)>>0]|0))<<2)>>2]|0;rb=h[c+(de+2)>>0]|0|sb;sb=f[1366576+(rb<<2)>>2]|0;qb=W1a(sb|0,((sb|0)<0)<<31>>31|0,ee|0,((ee|0)<0)<<31>>31|0)|0;ee=J;sb=S1a(qb|0,ee|0,16384,0)|0;pb=tb&65535;ob=Y(sb,pb)|0;sb=(ob|0)/16384|0;nb=375352+(rb<<3)|0;rb=f[nb>>2]|0;mb=f[nb+4>>2]|0;nb=W1a(qb|0,ee|0,-85,-1)|0;ee=C1a(nb|0,J|0,rb|0,mb|0)|0;mb=S1a(ee|0,J|0,16384,0)|0;ee=C1a(mb|0,J|0,-20889600,-1)|0;mb=W1a(ee|0,J|0,tb&65535|0,0)|0;tb=S1a(mb|0,J|0,16384,0)|0;mb=((tb|0)/256|0)+((tb|0)/65536|0)|0;tb=(ob|0)>16383?((sb|0)<32768?sb:32768):0;sb=(mb|0)>0?((mb|0)<32768?mb:32768):0;mb=(Y(f[id>>2]|0,pb)|0)+8192+(Y(tb,f[e>>2]|0)|0)+(Y(sb,f[hd>>2]|0)|0)>>14;ob=(Y(f[wb>>2]|0,pb)|0)+8192+(Y(tb,f[g>>2]|0)|0)+(Y(sb,f[x>>2]|0)|0)>>14;ee=(Y(f[v>>2]|0,pb)|0)+8192+(Y(tb,f[w>>2]|0)|0)+(Y(sb,f[y>>2]|0)|0)>>14;sb=f[vb>>2]|0;tb=d[sb+(((mb|0)>0?((mb|0)<4095?mb:4095):0)<<1)>>1]|0;mb=d[sb+(((ob|0)>0?((ob|0)<4095?ob:4095):0)<<1)>>1]|0;ob=d[sb+(((ee|0)>0?((ee|0)<4095?ee:4095):0)<<1)>>1]|0;b[ub>>0]=(ob&65535)<256?ob&65535:ob<<16>>16?255:0;b[ub+1>>0]=(mb&65535)<256?mb&65535:mb<<16>>16?255:0;b[ub+2>>0]=(tb&65535)<256?tb&65535:tb<<16>>16?255:0;if(a)b[ub+3>>0]=-1;de=de+3|0;if((de|0)>=(A|0))break;else ub=ub+z|0}u=i;return}function N4(a,c,e,g,i){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;a=u;u=u+48|0;j=a+32|0;k=a+16|0;l=a;b[j>>0]=b[c>>0]|0;b[j+1>>0]=b[c+1>>0]|0;b[j+2>>0]=b[c+2>>0]|0;b[j+3>>0]=b[c+3>>0]|0;b[j+4>>0]=b[c+4>>0]|0;b[j+5>>0]=b[c+5>>0]|0;b[j+6>>0]=b[c+6>>0]|0;b[j+7>>0]=b[c+7>>0]|0;b[j+8>>0]=b[c+8>>0]|0;b[j+9>>0]=b[c+9>>0]|0;b[j+10>>0]=b[c+10>>0]|0;b[j+11>>0]=b[c+11>>0]|0;b[j+12>>0]=b[c+12>>0]|0;b[j+13>>0]=b[c+13>>0]|0;b[j+14>>0]=b[c+14>>0]|0;b[j+15>>0]=b[c+15>>0]|0;b[k>>0]=b[e>>0]|0;b[k+1>>0]=b[e+1>>0]|0;b[k+2>>0]=b[e+2>>0]|0;b[k+3>>0]=b[e+3>>0]|0;b[k+4>>0]=b[e+4>>0]|0;b[k+5>>0]=b[e+5>>0]|0;b[k+6>>0]=b[e+6>>0]|0;b[k+7>>0]=b[e+7>>0]|0;b[k+8>>0]=b[e+8>>0]|0;b[k+9>>0]=b[e+9>>0]|0;b[k+10>>0]=b[e+10>>0]|0;b[k+11>>0]=b[e+11>>0]|0;b[k+12>>0]=b[e+12>>0]|0;b[k+13>>0]=b[e+13>>0]|0;b[k+14>>0]=b[e+14>>0]|0;b[k+15>>0]=b[e+15>>0]|0;e=b[g>>0]|0;b[l>>0]=e;b[l+1>>0]=b[g+1>>0]|0;b[l+2>>0]=b[g+2>>0]|0;b[l+3>>0]=b[g+3>>0]|0;b[l+4>>0]=b[g+4>>0]|0;b[l+5>>0]=b[g+5>>0]|0;b[l+6>>0]=b[g+6>>0]|0;b[l+7>>0]=b[g+7>>0]|0;b[l+8>>0]=b[g+8>>0]|0;b[l+9>>0]=b[g+9>>0]|0;b[l+10>>0]=b[g+10>>0]|0;b[l+11>>0]=b[g+11>>0]|0;b[l+12>>0]=b[g+12>>0]|0;b[l+13>>0]=b[g+13>>0]|0;b[l+14>>0]=b[g+14>>0]|0;b[l+15>>0]=b[g+15>>0]|0;g=e;e=0;while(1){c=h[j+e>>0]|0;m=d[3791168+(c<<1<<1)>>1]|0;n=m&65535;o=c<<8;c=f[1104432+((o|(h[k+e>>0]|0))<<2)>>2]|0;p=g&255|o;o=f[1366576+(p<<2)>>2]|0;q=W1a(o|0,((o|0)<0)<<31>>31|0,c|0,((c|0)<0)<<31>>31|0)|0;c=J;o=375352+(p<<3)|0;p=f[o>>2]|0;r=f[o+4>>2]|0;o=W1a(q|0,c|0,-85,-1)|0;s=C1a(o|0,J|0,p|0,r|0)|0;r=H1a(s|0,J|0,14)|0;s=C1a(r|0,J|0,-20889600,-1)|0;r=W1a(s|0,J|0,m&65535|0,0)|0;m=I1a(r|0,J|0,14)|0;r=I1a(q|0,c|0,14)|0;c=(Y(r,n)|0)>>14;r=((m|0)/256|0)+((m|0)/65536|0)|0;f[i+(e<<2)>>2]=(c|0)>0?((c|0)<32768?c:32768):0;f[i+(e+16<<2)>>2]=n;f[i+(e+32<<2)>>2]=(r|0)>0?((r|0)<32768?r:32768):0;r=e+1|0;if((r|0)==16)break;g=b[l+r>>0]|0;e=r}u=a;return}function O4(a){a=a|0;PYa(a);return}function P4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,47992);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){Q4(f[j>>2]|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function Q4(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0,I=0.0,J=0,K=0.0,L=0.0,M=0.0,N=0.0;g=f[a>>2]|0;h=(b[a+40>>0]|0)!=0;i=h?940576:0;j=+n[a+4>>2];k=+n[a+8>>2];l=+n[a+12>>2];m=+n[a+16>>2];o=+n[a+20>>2];p=+n[a+24>>2];q=+n[a+28>>2];r=+n[a+32>>2];s=+n[a+36>>2];t=e*3|0;if((e|0)<=0)return;e=a+44|0;u=a+48|0;a=(g|0)==4;v=d;d=0;while(1){w=+n[c+(d<<2)>>2];if(!(w<=+n[e>>2])){x=(w+16.0)/116.0;y=x;z=x*(x*x)}else{x=w/903.2999877929688;y=x*7.7870001792907715+.13793103396892548;z=x}x=+n[c+(d+1<<2)>>2]/500.0+y;w=y-+n[c+(d+2<<2)>>2]/200.0;A=+n[u>>2];if(!(x<=A))B=x*(x*x);else B=(x+-.13793103396892548)/7.7870001792907715;if(!(w<=A))C=w*(w*w);else C=(w+-.13793103396892548)/7.7870001792907715;w=k*z+j*B+l*C;A=o*z+m*B+p*C;x=r*z+q*B+s*C;D=w<0.0?0.0:w>1.0?1.0:w;w=A<0.0?0.0:A>1.0?1.0:A;A=x<0.0?0.0:x>1.0?1.0:x;if(h){x=D*1024.0;E=~~x;F=(E|0)>0?E:0;E=(F|0)<1023?F:1023;G=x-+(E|0);F=i+(E<<2<<2)|0;x=w*1024.0;E=~~x;H=(E|0)>0?E:0;E=(H|0)<1023?H:1023;I=x-+(E|0);H=i+(E<<2<<2)|0;x=A*1024.0;E=~~x;J=(E|0)>0?E:0;E=(J|0)<1023?J:1023;K=x-+(E|0);J=i+(E<<2<<2)|0;L=+n[J>>2]+K*(+n[J+4>>2]+K*(K*+n[J+12>>2]+ +n[J+8>>2]));M=+n[H>>2]+I*(+n[H+4>>2]+I*(I*+n[H+12>>2]+ +n[H+8>>2]));N=+n[F>>2]+G*(+n[F+4>>2]+G*(G*+n[F+12>>2]+ +n[F+8>>2]))}else{L=A;M=w;N=D}n[v>>2]=N;n[v+4>>2]=M;n[v+8>>2]=L;if(a)n[v+12>>2]=1.0;d=d+3|0;if((d|0)>=(t|0))break;else v=v+(g<<2)|0}return}function R4(a){a=a|0;PYa(a);return}function S4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;_$(d,48012);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=e;m=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){T4((f[j>>2]|0)+56|0,b,m,f[k>>2]|0);l=l+1|0;if((l|0)>=(f[i>>2]|0))break;else{m=m+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function T4(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0;i=u;u=u+496|0;k=i+480|0;l=i+464|0;m=i+448|0;n=i+320|0;o=i+256|0;p=i+192|0;q=i+128|0;r=i+64|0;s=i;t=i+432|0;v=i+416|0;w=i+400|0;x=i+384|0;y=f[a>>2]|0;z=g*3|0;g=z+-48|0;if((z|0)<48){A=e;B=0}else{C=n+16|0;D=o+16|0;E=p+16|0;F=n+32|0;G=o+32|0;H=p+32|0;I=n+48|0;J=o+48|0;K=p+48|0;L=a+4|0;M=a+8|0;N=a+12|0;O=a+16|0;P=a+20|0;Q=a+24|0;R=a+28|0;S=a+32|0;T=a+36|0;U=a+40|0;V=q+16|0;W=q+4|0;X=q+20|0;Z=q+8|0;_=q+24|0;$=q+12|0;aa=q+28|0;ba=q+32|0;ca=q+48|0;da=q+36|0;ea=q+52|0;fa=q+40|0;ga=q+56|0;ha=q+44|0;ia=q+60|0;ja=r+16|0;ka=r+4|0;la=r+20|0;ma=r+8|0;na=r+24|0;oa=r+12|0;pa=r+28|0;qa=r+32|0;ra=r+48|0;sa=r+36|0;ta=r+52|0;ua=r+40|0;va=r+56|0;wa=r+44|0;xa=r+60|0;ya=s+16|0;za=s+4|0;Aa=s+20|0;Ba=s+8|0;Ca=s+24|0;Da=s+12|0;Ea=s+28|0;Fa=s+32|0;Ga=s+48|0;Ha=s+36|0;Ia=s+52|0;Ja=s+40|0;Ka=s+56|0;La=s+44|0;Ma=s+60|0;Na=t+1|0;Oa=t+2|0;Pa=t+3|0;Qa=t+4|0;Ra=t+5|0;Sa=t+6|0;Ta=t+7|0;Ua=t+8|0;Va=t+9|0;Wa=t+10|0;Xa=t+11|0;Ya=t+12|0;Za=t+13|0;_a=t+14|0;$a=t+15|0;ab=v+1|0;bb=v+2|0;cb=v+3|0;db=v+4|0;eb=v+5|0;fb=v+6|0;gb=v+7|0;hb=v+8|0;ib=v+9|0;jb=v+10|0;kb=v+11|0;lb=v+12|0;mb=v+13|0;nb=v+14|0;ob=v+15|0;pb=w+1|0;qb=w+2|0;rb=w+3|0;sb=w+4|0;tb=w+5|0;ub=w+6|0;vb=w+7|0;wb=w+8|0;xb=w+9|0;yb=w+10|0;zb=w+11|0;Ab=w+12|0;Bb=w+13|0;Cb=w+14|0;Db=w+15|0;Eb=(y|0)==4;Fb=y<<4;Gb=e;e=0;while(1){Hb=c+e|0;Ib=0;Jb=0;while(1){b[k+Ib>>0]=b[Hb+Jb>>0]|0;b[l+Ib>>0]=b[Hb+(Jb+1)>>0]|0;b[m+Ib>>0]=b[Hb+(Jb+2)>>0]|0;Ib=Ib+1|0;if((Ib|0)==16)break;else Jb=Jb+3|0}U4(a,k,l,m,n,o,p,C,D,E,F,G,H,I,J,K);Jb=f[L>>2]|0;Ib=f[M>>2]|0;Hb=f[N>>2]|0;Kb=f[O>>2]|0;Lb=f[P>>2]|0;Mb=f[Q>>2]|0;Nb=f[R>>2]|0;Ob=f[S>>2]|0;Pb=f[T>>2]|0;Qb=f[U>>2]|0;Rb=0;do{Sb=f[n+(Rb<<4)>>2]|0;Tb=Y(Sb,Jb)|0;Ub=f[n+(Rb<<4)+4>>2]|0;Vb=Y(Ub,Jb)|0;Wb=f[n+(Rb<<4)+8>>2]|0;Xb=Y(Wb,Jb)|0;Yb=f[n+(Rb<<4)+12>>2]|0;Zb=Y(Yb,Jb)|0;_b=f[o+(Rb<<4)>>2]|0;$b=Y(_b,Ib)|0;ac=f[o+(Rb<<4)+4>>2]|0;bc=Y(ac,Ib)|0;cc=f[o+(Rb<<4)+8>>2]|0;dc=Y(cc,Ib)|0;ec=f[o+(Rb<<4)+12>>2]|0;fc=Y(ec,Ib)|0;gc=f[p+(Rb<<4)>>2]|0;hc=Y(gc,Hb)|0;ic=f[p+(Rb<<4)+4>>2]|0;jc=Y(ic,Hb)|0;kc=f[p+(Rb<<4)+8>>2]|0;lc=Y(kc,Hb)|0;mc=f[p+(Rb<<4)+12>>2]|0;nc=Tb+8192+$b+hc>>14;hc=Vb+8192+bc+jc>>14;jc=Xb+8192+dc+lc>>14;lc=Zb+8192+fc+(Y(mc,Hb)|0)>>14;fc=(Y(Sb,Kb)|0)+8192+(Y(_b,Lb)|0)+(Y(gc,Mb)|0)>>14;Zb=(Y(Ub,Kb)|0)+8192+(Y(ac,Lb)|0)+(Y(ic,Mb)|0)>>14;dc=(Y(Wb,Kb)|0)+8192+(Y(cc,Lb)|0)+(Y(kc,Mb)|0)>>14;Xb=(Y(Yb,Kb)|0)+8192+(Y(ec,Lb)|0)+(Y(mc,Mb)|0)>>14;bc=(Y(Sb,Nb)|0)+8192+(Y(_b,Ob)|0)+(Y(gc,Pb)|0)>>14;gc=(Y(Ub,Nb)|0)+8192+(Y(ac,Ob)|0)+(Y(ic,Pb)|0)>>14;ic=(Y(Wb,Nb)|0)+8192+(Y(cc,Ob)|0)+(Y(kc,Pb)|0)>>14;kc=(Y(Yb,Nb)|0)+8192+(Y(ec,Ob)|0)+(Y(mc,Pb)|0)>>14;mc=j[Qb+(((hc|0)>0?((hc|0)<4095?hc:4095):0)<<1)>>1]|0;hc=j[Qb+(((jc|0)>0?((jc|0)<4095?jc:4095):0)<<1)>>1]|0;jc=j[Qb+(((lc|0)>0?((lc|0)<4095?lc:4095):0)<<1)>>1]|0;f[q+(Rb<<4)>>2]=j[Qb+(((nc|0)>0?((nc|0)<4095?nc:4095):0)<<1)>>1];f[q+(Rb<<4)+4>>2]=mc;f[q+(Rb<<4)+8>>2]=hc;f[q+(Rb<<4)+12>>2]=jc;jc=j[Qb+(((Zb|0)>0?((Zb|0)<4095?Zb:4095):0)<<1)>>1]|0;Zb=j[Qb+(((dc|0)>0?((dc|0)<4095?dc:4095):0)<<1)>>1]|0;dc=j[Qb+(((Xb|0)>0?((Xb|0)<4095?Xb:4095):0)<<1)>>1]|0;f[r+(Rb<<4)>>2]=j[Qb+(((fc|0)>0?((fc|0)<4095?fc:4095):0)<<1)>>1];f[r+(Rb<<4)+4>>2]=jc;f[r+(Rb<<4)+8>>2]=Zb;f[r+(Rb<<4)+12>>2]=dc;dc=j[Qb+(((gc|0)>0?((gc|0)<4095?gc:4095):0)<<1)>>1]|0;gc=j[Qb+(((ic|0)>0?((ic|0)<4095?ic:4095):0)<<1)>>1]|0;ic=j[Qb+(((kc|0)>0?((kc|0)<4095?kc:4095):0)<<1)>>1]|0;f[s+(Rb<<4)>>2]=j[Qb+(((bc|0)>0?((bc|0)<4095?bc:4095):0)<<1)>>1];f[s+(Rb<<4)+4>>2]=dc;f[s+(Rb<<4)+8>>2]=gc;f[s+(Rb<<4)+12>>2]=ic;Rb=Rb+1|0}while((Rb|0)!=4);Rb=f[q>>2]|0;Qb=f[V>>2]|0;Pb=f[W>>2]|0;Ob=f[X>>2]|0;Nb=f[Z>>2]|0;Mb=f[_>>2]|0;Lb=f[$>>2]|0;Kb=f[aa>>2]|0;Hb=f[ba>>2]|0;Ib=f[ca>>2]|0;Jb=f[da>>2]|0;ic=f[ea>>2]|0;gc=f[fa>>2]|0;dc=f[ga>>2]|0;bc=f[ha>>2]|0;kc=f[ia>>2]|0;Zb=f[r>>2]|0;jc=f[ja>>2]|0;fc=f[ka>>2]|0;Xb=f[la>>2]|0;hc=f[ma>>2]|0;mc=f[na>>2]|0;nc=f[oa>>2]|0;lc=f[pa>>2]|0;ec=f[qa>>2]|0;Yb=f[ra>>2]|0;cc=f[sa>>2]|0;Wb=f[ta>>2]|0;ac=f[ua>>2]|0;Ub=f[va>>2]|0;_b=f[wa>>2]|0;Sb=f[xa>>2]|0;Vb=f[s>>2]|0;$b=f[ya>>2]|0;Tb=f[za>>2]|0;oc=f[Aa>>2]|0;pc=f[Ba>>2]|0;qc=f[Ca>>2]|0;rc=f[Da>>2]|0;sc=f[Ea>>2]|0;tc=f[Fa>>2]|0;uc=f[Ga>>2]|0;vc=f[Ha>>2]|0;wc=f[Ia>>2]|0;xc=f[Ja>>2]|0;yc=f[Ka>>2]|0;zc=f[La>>2]|0;Ac=f[Ma>>2]|0;b[t>>0]=Vb>>>0<255?Vb:255;b[Na>>0]=Tb>>>0<255?Tb:255;b[Oa>>0]=pc>>>0<255?pc:255;b[Pa>>0]=rc>>>0<255?rc:255;b[Qa>>0]=$b>>>0<255?$b:255;b[Ra>>0]=oc>>>0<255?oc:255;b[Sa>>0]=qc>>>0<255?qc:255;b[Ta>>0]=sc>>>0<255?sc:255;b[Ua>>0]=tc>>>0<255?tc:255;b[Va>>0]=vc>>>0<255?vc:255;b[Wa>>0]=xc>>>0<255?xc:255;b[Xa>>0]=zc>>>0<255?zc:255;b[Ya>>0]=uc>>>0<255?uc:255;b[Za>>0]=wc>>>0<255?wc:255;b[_a>>0]=yc>>>0<255?yc:255;b[$a>>0]=Ac>>>0<255?Ac:255;b[v>>0]=Zb>>>0<255?Zb:255;b[ab>>0]=fc>>>0<255?fc:255;b[bb>>0]=hc>>>0<255?hc:255;b[cb>>0]=nc>>>0<255?nc:255;b[db>>0]=jc>>>0<255?jc:255;b[eb>>0]=Xb>>>0<255?Xb:255;b[fb>>0]=mc>>>0<255?mc:255;b[gb>>0]=lc>>>0<255?lc:255;b[hb>>0]=ec>>>0<255?ec:255;b[ib>>0]=cc>>>0<255?cc:255;b[jb>>0]=ac>>>0<255?ac:255;b[kb>>0]=_b>>>0<255?_b:255;b[lb>>0]=Yb>>>0<255?Yb:255;b[mb>>0]=Wb>>>0<255?Wb:255;b[nb>>0]=Ub>>>0<255?Ub:255;b[ob>>0]=Sb>>>0<255?Sb:255;b[w>>0]=Rb>>>0<255?Rb:255;b[pb>>0]=Pb>>>0<255?Pb:255;b[qb>>0]=Nb>>>0<255?Nb:255;b[rb>>0]=Lb>>>0<255?Lb:255;b[sb>>0]=Qb>>>0<255?Qb:255;b[tb>>0]=Ob>>>0<255?Ob:255;b[ub>>0]=Mb>>>0<255?Mb:255;b[vb>>0]=Kb>>>0<255?Kb:255;b[wb>>0]=Hb>>>0<255?Hb:255;b[xb>>0]=Jb>>>0<255?Jb:255;b[yb>>0]=gc>>>0<255?gc:255;b[zb>>0]=bc>>>0<255?bc:255;b[Ab>>0]=Ib>>>0<255?Ib:255;b[Bb>>0]=ic>>>0<255?ic:255;b[Cb>>0]=dc>>>0<255?dc:255;b[Db>>0]=kc>>>0<255?kc:255;if(Eb){kc=x;dc=kc+16|0;do{b[kc>>0]=255;kc=kc+1|0}while((kc|0)<(dc|0));kc=0;dc=0;while(1){b[Gb+dc>>0]=b[t+kc>>0]|0;b[Gb+(dc|1)>>0]=b[v+kc>>0]|0;b[Gb+(dc|2)>>0]=b[w+kc>>0]|0;b[Gb+(dc|3)>>0]=b[x+kc>>0]|0;kc=kc+1|0;if((kc|0)==16)break;else dc=dc+4|0}}else{dc=0;kc=0;while(1){b[Gb+kc>>0]=b[t+dc>>0]|0;b[Gb+(kc+1)>>0]=b[v+dc>>0]|0;b[Gb+(kc+2)>>0]=b[w+dc>>0]|0;dc=dc+1|0;if((dc|0)==16)break;else kc=kc+3|0}}kc=e+48|0;dc=Gb+Fb|0;if((kc|0)>(g|0)){A=dc;B=kc;break}else{Gb=dc;e=kc}}}if((B|0)>=(z|0)){u=i;return}e=a+4|0;Gb=a+8|0;g=a+12|0;Fb=a+16|0;w=a+20|0;v=a+24|0;t=a+28|0;x=a+32|0;Eb=a+36|0;Db=a+40|0;a=(y|0)==4;Cb=A;A=B;while(1){B=(h[c+A>>0]|0)<<1;Bb=j[3791168+((B|1)<<1)>>1]|0;Ab=f[956976+(((((h[c+(A+1)>>0]|0)*268435|0)+128|0)>>>13)+3951+Bb<<2)>>2]|0;zb=f[956976+(Bb+18629-((((h[c+(A+2)>>0]|0)*41943|0)+16|0)>>>9)<<2)>>2]|0;Bb=j[3791168+(B<<1)>>1]|0;B=(Y(f[e>>2]|0,Ab)|0)+8192+(Y(f[Gb>>2]|0,Bb)|0)+(Y(f[g>>2]|0,zb)|0)>>14;yb=(Y(f[Fb>>2]|0,Ab)|0)+8192+(Y(f[w>>2]|0,Bb)|0)+(Y(f[v>>2]|0,zb)|0)>>14;xb=(Y(f[t>>2]|0,Ab)|0)+8192+(Y(f[x>>2]|0,Bb)|0)+(Y(f[Eb>>2]|0,zb)|0)>>14;zb=f[Db>>2]|0;Bb=d[zb+(((B|0)>0?((B|0)<4095?B:4095):0)<<1)>>1]|0;B=d[zb+(((yb|0)>0?((yb|0)<4095?yb:4095):0)<<1)>>1]|0;yb=d[zb+(((xb|0)>0?((xb|0)<4095?xb:4095):0)<<1)>>1]|0;b[Cb>>0]=(yb&65535)<256?yb&65535:yb<<16>>16?255:0;b[Cb+1>>0]=(B&65535)<256?B&65535:B<<16>>16?255:0;b[Cb+2>>0]=(Bb&65535)<256?Bb&65535:Bb<<16>>16?255:0;if(a)b[Cb+3>>0]=-1;A=A+3|0;if((A|0)>=(z|0))break;else Cb=Cb+y|0}u=i;return}function U4(a,b,c,d,e,g,i,k,l,m,n,o,p,q,r,s){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;a=(h[b>>0]|0)<<1;t=(h[b+1>>0]|0)<<1;u=(h[b+2>>0]|0)<<1;v=(h[b+3>>0]|0)<<1;w=(h[b+4>>0]|0)<<1;x=(h[b+5>>0]|0)<<1;y=(h[b+6>>0]|0)<<1;z=(h[b+7>>0]|0)<<1;A=(h[b+8>>0]|0)<<1;B=(h[b+9>>0]|0)<<1;C=(h[b+10>>0]|0)<<1;D=(h[b+11>>0]|0)<<1;E=(h[b+12>>0]|0)<<1;F=(h[b+13>>0]|0)<<1;G=(h[b+14>>0]|0)<<1;H=(h[b+15>>0]|0)<<1;b=j[3791168+(t<<1)>>1]|0;I=j[3791168+(u<<1)>>1]|0;J=j[3791168+(v<<1)>>1]|0;f[g>>2]=j[3791168+(a<<1)>>1];f[g+4>>2]=b;f[g+8>>2]=I;f[g+12>>2]=J;J=j[3791168+(x<<1)>>1]|0;g=j[3791168+(y<<1)>>1]|0;I=j[3791168+(z<<1)>>1]|0;f[l>>2]=j[3791168+(w<<1)>>1];f[l+4>>2]=J;f[l+8>>2]=g;f[l+12>>2]=I;I=j[3791168+(B<<1)>>1]|0;l=j[3791168+(C<<1)>>1]|0;g=j[3791168+(D<<1)>>1]|0;f[o>>2]=j[3791168+(A<<1)>>1];f[o+4>>2]=I;f[o+8>>2]=l;f[o+12>>2]=g;g=j[3791168+(F<<1)>>1]|0;o=j[3791168+(G<<1)>>1]|0;l=j[3791168+(H<<1)>>1]|0;f[r>>2]=j[3791168+(E<<1)>>1];f[r+4>>2]=g;f[r+8>>2]=o;f[r+12>>2]=l;l=j[3791168+((a|1)<<1)>>1]|0;a=j[3791168+((t|1)<<1)>>1]|0;t=j[3791168+((u|1)<<1)>>1]|0;u=j[3791168+((v|1)<<1)>>1]|0;v=j[3791168+((w|1)<<1)>>1]|0;w=j[3791168+((x|1)<<1)>>1]|0;x=j[3791168+((y|1)<<1)>>1]|0;y=j[3791168+((z|1)<<1)>>1]|0;z=v+3951+((((h[c+4>>0]|0)*268435|0)+128|0)>>>13)|0;r=w+3951+((((h[c+5>>0]|0)*268435|0)+128|0)>>>13)|0;o=x+3951+((((h[c+6>>0]|0)*268435|0)+128|0)>>>13)|0;g=y+3951+((((h[c+7>>0]|0)*268435|0)+128|0)>>>13)|0;I=j[3791168+((A|1)<<1)>>1]|0;A=j[3791168+((B|1)<<1)>>1]|0;B=j[3791168+((C|1)<<1)>>1]|0;C=j[3791168+((D|1)<<1)>>1]|0;D=j[3791168+((E|1)<<1)>>1]|0;E=j[3791168+((F|1)<<1)>>1]|0;F=j[3791168+((G|1)<<1)>>1]|0;G=j[3791168+((H|1)<<1)>>1]|0;H=I+3951+((((h[c+8>>0]|0)*268435|0)+128|0)>>>13)|0;J=A+3951+((((h[c+9>>0]|0)*268435|0)+128|0)>>>13)|0;b=B+3951+((((h[c+10>>0]|0)*268435|0)+128|0)>>>13)|0;K=C+3951+((((h[c+11>>0]|0)*268435|0)+128|0)>>>13)|0;L=D+3951+((((h[c+12>>0]|0)*268435|0)+128|0)>>>13)|0;M=E+3951+((((h[c+13>>0]|0)*268435|0)+128|0)>>>13)|0;N=F+3951+((((h[c+14>>0]|0)*268435|0)+128|0)>>>13)|0;O=G+3951+((((h[c+15>>0]|0)*268435|0)+128|0)>>>13)|0;P=l+18629-((((h[d>>0]|0)*41943|0)+16|0)>>>9)|0;Q=a+18629-((((h[d+1>>0]|0)*41943|0)+16|0)>>>9)|0;R=t+18629-((((h[d+2>>0]|0)*41943|0)+16|0)>>>9)|0;S=u+18629-((((h[d+3>>0]|0)*41943|0)+16|0)>>>9)|0;T=v+18629-((((h[d+4>>0]|0)*41943|0)+16|0)>>>9)|0;v=w+18629-((((h[d+5>>0]|0)*41943|0)+16|0)>>>9)|0;w=x+18629-((((h[d+6>>0]|0)*41943|0)+16|0)>>>9)|0;x=y+18629-((((h[d+7>>0]|0)*41943|0)+16|0)>>>9)|0;y=I+18629-((((h[d+8>>0]|0)*41943|0)+16|0)>>>9)|0;I=A+18629-((((h[d+9>>0]|0)*41943|0)+16|0)>>>9)|0;A=B+18629-((((h[d+10>>0]|0)*41943|0)+16|0)>>>9)|0;B=C+18629-((((h[d+11>>0]|0)*41943|0)+16|0)>>>9)|0;C=D+18629-((((h[d+12>>0]|0)*41943|0)+16|0)>>>9)|0;D=E+18629-((((h[d+13>>0]|0)*41943|0)+16|0)>>>9)|0;E=F+18629-((((h[d+14>>0]|0)*41943|0)+16|0)>>>9)|0;F=G+18629-((((h[d+15>>0]|0)*41943|0)+16|0)>>>9)|0;d=f[956976+((a+3951+((((h[c+1>>0]|0)*268435|0)+128|0)>>>13)&65535)<<2)>>2]|0;a=f[956976+((t+3951+((((h[c+2>>0]|0)*268435|0)+128|0)>>>13)&65535)<<2)>>2]|0;t=f[956976+((u+3951+((((h[c+3>>0]|0)*268435|0)+128|0)>>>13)&65535)<<2)>>2]|0;f[e>>2]=f[956976+((l+3951+((((h[c>>0]|0)*268435|0)+128|0)>>>13)&65535)<<2)>>2];f[e+4>>2]=d;f[e+8>>2]=a;f[e+12>>2]=t;t=f[956976+((r&65535)<<2)>>2]|0;r=f[956976+((o&65535)<<2)>>2]|0;o=f[956976+((g&65535)<<2)>>2]|0;f[k>>2]=f[956976+((z&65535)<<2)>>2];f[k+4>>2]=t;f[k+8>>2]=r;f[k+12>>2]=o;o=f[956976+((J&65535)<<2)>>2]|0;J=f[956976+((b&65535)<<2)>>2]|0;b=f[956976+((K&65535)<<2)>>2]|0;f[n>>2]=f[956976+((H&65535)<<2)>>2];f[n+4>>2]=o;f[n+8>>2]=J;f[n+12>>2]=b;b=f[956976+((M&65535)<<2)>>2]|0;M=f[956976+((N&65535)<<2)>>2]|0;N=f[956976+((O&65535)<<2)>>2]|0;f[q>>2]=f[956976+((L&65535)<<2)>>2];f[q+4>>2]=b;f[q+8>>2]=M;f[q+12>>2]=N;N=f[956976+((Q&65535)<<2)>>2]|0;Q=f[956976+((R&65535)<<2)>>2]|0;R=f[956976+((S&65535)<<2)>>2]|0;f[i>>2]=f[956976+((P&65535)<<2)>>2];f[i+4>>2]=N;f[i+8>>2]=Q;f[i+12>>2]=R;R=f[956976+((v&65535)<<2)>>2]|0;v=f[956976+((w&65535)<<2)>>2]|0;w=f[956976+((x&65535)<<2)>>2]|0;f[m>>2]=f[956976+((T&65535)<<2)>>2];f[m+4>>2]=R;f[m+8>>2]=v;f[m+12>>2]=w;w=f[956976+((I&65535)<<2)>>2]|0;I=f[956976+((A&65535)<<2)>>2]|0;A=f[956976+((B&65535)<<2)>>2]|0;f[p>>2]=f[956976+((y&65535)<<2)>>2];f[p+4>>2]=w;f[p+8>>2]=I;f[p+12>>2]=A;A=f[956976+((D&65535)<<2)>>2]|0;D=f[956976+((E&65535)<<2)>>2]|0;E=f[956976+((F&65535)<<2)>>2]|0;f[s>>2]=f[956976+((C&65535)<<2)>>2];f[s+4>>2]=A;f[s+8>>2]=D;f[s+12>>2]=E;return}function V4(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=u;u=u+48|0;m=l+16|0;n=l+8|0;o=l;_$(o,48032);p=a+(Y(h,c)|0)|0;switch((j?20:0)+(i*100|0)+k|0){case 300:{f[m>>2]=48060;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=p;f[m+24>>2]=c;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;_U(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;W4(m,n)}break}case 301:{f[m>>2]=48080;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=p;f[m+24>>2]=c;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;_U(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;X4(m,n)}break}case 320:{f[m>>2]=48100;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=p;f[m+24>>2]=c;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;_U(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;Y4(m,n)}break}case 321:{f[m>>2]=48120;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=p;f[m+24>>2]=c;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;_U(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;Z4(m,n)}break}case 400:{f[m>>2]=48140;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=p;f[m+24>>2]=c;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;_U(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;_4(m,n)}break}case 401:{f[m>>2]=48160;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=p;f[m+24>>2]=c;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;_U(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;$4(m,n)}break}case 420:{f[m>>2]=48180;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=p;f[m+24>>2]=c;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;_U(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;a5(m,n)}break}case 421:{f[m>>2]=48200;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=p;f[m+24>>2]=c;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;_U(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;b5(m,n)}break}default:{f[m>>2]=0;f[m+4>>2]=0;n=c$(m,41)|0;h=215114;g=n+41|0;do{b[n>>0]=b[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(g|0));j$(-206,m,215156,206245,10799);d$(m)}}if(!(f[o+4>>2]|0)){u=l;return}u=l;return}function W4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=g;g=f[l>>2]|0;n=d;d=(f[a+20>>2]|0)+(i>>>1)|0;o=(f[a+16>>2]|0)+i|0;while(1){i=f[j>>2]|0;a=f[k>>2]|0;p=o+m|0;if((g|0)>0){q=0;r=i+(Y(a,n)|0)|0;s=i+(Y(a,n|1)|0)|0;while(1){a=(h[d+q>>0]|0)+-128|0;i=q|1;t=(h[d+i>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(a,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(a,2116026)|0)+524288|0;a=(h[o+q>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[r+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[r+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[r>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[o+i>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[r+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[r+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[r+3>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[p+q>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[s+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[s+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[s>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[p+i>>0]|0)+-16|0;i=Y((a|0)>0?a:0,1220542)|0;a=i+u>>20;b[s+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=i+v>>20;b[s+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=i+t>>20;b[s+3>>0]=a>>>0<256?a:(a|0)>0?255:0;q=q+2|0;x=f[l>>2]|0;if((q|0)>=(x|0))break;else{r=r+6|0;s=s+6|0}}y=x;z=f[c>>2]|0}else{y=g;z=m}n=n+2|0;if((n|0)>=(e|0))break;else{m=z;g=y;d=d+z|0;o=o+(z<<1)|0}}return}function X4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=g;g=f[l>>2]|0;n=d;d=(f[a+20>>2]|0)+(i>>>1)|0;o=(f[a+16>>2]|0)+i|0;while(1){i=f[j>>2]|0;a=f[k>>2]|0;p=o+m|0;if((g|0)>0){q=0;r=i+(Y(a,n)|0)|0;s=i+(Y(a,n|1)|0)|0;while(1){a=q|1;i=(h[d+a>>0]|0)+-128|0;t=(h[d+q>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(i,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(i,2116026)|0)+524288|0;i=(h[o+q>>0]|0)+-16|0;w=Y((i|0)>0?i:0,1220542)|0;i=w+u>>20;b[r+2>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+v>>20;b[r+1>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+t>>20;b[r>>0]=i>>>0<256?i:(i|0)>0?255:0;i=(h[o+a>>0]|0)+-16|0;w=Y((i|0)>0?i:0,1220542)|0;i=w+u>>20;b[r+5>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+v>>20;b[r+4>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+t>>20;b[r+3>>0]=i>>>0<256?i:(i|0)>0?255:0;i=(h[p+q>>0]|0)+-16|0;w=Y((i|0)>0?i:0,1220542)|0;i=w+u>>20;b[s+2>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+v>>20;b[s+1>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+t>>20;b[s>>0]=i>>>0<256?i:(i|0)>0?255:0;i=(h[p+a>>0]|0)+-16|0;a=Y((i|0)>0?i:0,1220542)|0;i=a+u>>20;b[s+5>>0]=i>>>0<256?i:(i|0)>0?255:0;i=a+v>>20;b[s+4>>0]=i>>>0<256?i:(i|0)>0?255:0;i=a+t>>20;b[s+3>>0]=i>>>0<256?i:(i|0)>0?255:0;q=q+2|0;x=f[l>>2]|0;if((q|0)>=(x|0))break;else{r=r+6|0;s=s+6|0}}y=x;z=f[c>>2]|0}else{y=g;z=m}n=n+2|0;if((n|0)>=(e|0))break;else{m=z;g=y;d=d+z|0;o=o+(z<<1)|0}}return}function Y4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=g;g=f[l>>2]|0;n=d;d=(f[a+20>>2]|0)+(i>>>1)|0;o=(f[a+16>>2]|0)+i|0;while(1){i=f[j>>2]|0;a=f[k>>2]|0;p=o+m|0;if((g|0)>0){q=0;r=i+(Y(a,n)|0)|0;s=i+(Y(a,n|1)|0)|0;while(1){a=(h[d+q>>0]|0)+-128|0;i=q|1;t=(h[d+i>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(a,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(a,2116026)|0)+524288|0;a=(h[o+q>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[r>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[r+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[r+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[o+i>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[r+3>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[r+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[r+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[p+q>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[s>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[s+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[s+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[p+i>>0]|0)+-16|0;i=Y((a|0)>0?a:0,1220542)|0;a=i+u>>20;b[s+3>>0]=a>>>0<256?a:(a|0)>0?255:0;a=i+v>>20;b[s+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=i+t>>20;b[s+5>>0]=a>>>0<256?a:(a|0)>0?255:0;q=q+2|0;x=f[l>>2]|0;if((q|0)>=(x|0))break;else{r=r+6|0;s=s+6|0}}y=x;z=f[c>>2]|0}else{y=g;z=m}n=n+2|0;if((n|0)>=(e|0))break;else{m=z;g=y;d=d+z|0;o=o+(z<<1)|0}}return}function Z4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=g;g=f[l>>2]|0;n=d;d=(f[a+20>>2]|0)+(i>>>1)|0;o=(f[a+16>>2]|0)+i|0;while(1){i=f[j>>2]|0;a=f[k>>2]|0;p=o+m|0;if((g|0)>0){q=0;r=i+(Y(a,n)|0)|0;s=i+(Y(a,n|1)|0)|0;while(1){a=q|1;i=(h[d+a>>0]|0)+-128|0;t=(h[d+q>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(i,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(i,2116026)|0)+524288|0;i=(h[o+q>>0]|0)+-16|0;w=Y((i|0)>0?i:0,1220542)|0;i=w+u>>20;b[r>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+v>>20;b[r+1>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+t>>20;b[r+2>>0]=i>>>0<256?i:(i|0)>0?255:0;i=(h[o+a>>0]|0)+-16|0;w=Y((i|0)>0?i:0,1220542)|0;i=w+u>>20;b[r+3>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+v>>20;b[r+4>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+t>>20;b[r+5>>0]=i>>>0<256?i:(i|0)>0?255:0;i=(h[p+q>>0]|0)+-16|0;w=Y((i|0)>0?i:0,1220542)|0;i=w+u>>20;b[s>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+v>>20;b[s+1>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+t>>20;b[s+2>>0]=i>>>0<256?i:(i|0)>0?255:0;i=(h[p+a>>0]|0)+-16|0;a=Y((i|0)>0?i:0,1220542)|0;i=a+u>>20;b[s+3>>0]=i>>>0<256?i:(i|0)>0?255:0;i=a+v>>20;b[s+4>>0]=i>>>0<256?i:(i|0)>0?255:0;i=a+t>>20;b[s+5>>0]=i>>>0<256?i:(i|0)>0?255:0;q=q+2|0;x=f[l>>2]|0;if((q|0)>=(x|0))break;else{r=r+6|0;s=s+6|0}}y=x;z=f[c>>2]|0}else{y=g;z=m}n=n+2|0;if((n|0)>=(e|0))break;else{m=z;g=y;d=d+z|0;o=o+(z<<1)|0}}return}function _4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=g;g=f[l>>2]|0;n=d;d=(f[a+20>>2]|0)+(i>>>1)|0;o=(f[a+16>>2]|0)+i|0;while(1){i=f[j>>2]|0;a=f[k>>2]|0;p=o+m|0;if((g|0)>0){q=0;r=i+(Y(a,n)|0)|0;s=i+(Y(a,n|1)|0)|0;while(1){a=(h[d+q>>0]|0)+-128|0;i=q|1;t=(h[d+i>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(a,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(a,2116026)|0)+524288|0;a=(h[o+q>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[r+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[r+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[r>>0]=a>>>0<256?a:(a|0)>0?255:0;b[r+3>>0]=-1;a=(h[o+i>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[r+6>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[r+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[r+4>>0]=a>>>0<256?a:(a|0)>0?255:0;b[r+7>>0]=-1;a=(h[p+q>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[s+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[s+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[s>>0]=a>>>0<256?a:(a|0)>0?255:0;b[s+3>>0]=-1;a=(h[p+i>>0]|0)+-16|0;i=Y((a|0)>0?a:0,1220542)|0;a=i+u>>20;b[s+6>>0]=a>>>0<256?a:(a|0)>0?255:0;a=i+v>>20;b[s+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=i+t>>20;b[s+4>>0]=a>>>0<256?a:(a|0)>0?255:0;b[s+7>>0]=-1;q=q+2|0;x=f[l>>2]|0;if((q|0)>=(x|0))break;else{r=r+8|0;s=s+8|0}}y=x;z=f[c>>2]|0}else{y=g;z=m}n=n+2|0;if((n|0)>=(e|0))break;else{m=z;g=y;d=d+z|0;o=o+(z<<1)|0}}return}function $4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=g;g=f[l>>2]|0;n=d;d=(f[a+20>>2]|0)+(i>>>1)|0;o=(f[a+16>>2]|0)+i|0;while(1){i=f[j>>2]|0;a=f[k>>2]|0;p=o+m|0;if((g|0)>0){q=0;r=i+(Y(a,n)|0)|0;s=i+(Y(a,n|1)|0)|0;while(1){a=q|1;i=(h[d+a>>0]|0)+-128|0;t=(h[d+q>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(i,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(i,2116026)|0)+524288|0;i=(h[o+q>>0]|0)+-16|0;w=Y((i|0)>0?i:0,1220542)|0;i=w+u>>20;b[r+2>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+v>>20;b[r+1>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+t>>20;b[r>>0]=i>>>0<256?i:(i|0)>0?255:0;b[r+3>>0]=-1;i=(h[o+a>>0]|0)+-16|0;w=Y((i|0)>0?i:0,1220542)|0;i=w+u>>20;b[r+6>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+v>>20;b[r+5>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+t>>20;b[r+4>>0]=i>>>0<256?i:(i|0)>0?255:0;b[r+7>>0]=-1;i=(h[p+q>>0]|0)+-16|0;w=Y((i|0)>0?i:0,1220542)|0;i=w+u>>20;b[s+2>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+v>>20;b[s+1>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+t>>20;b[s>>0]=i>>>0<256?i:(i|0)>0?255:0;b[s+3>>0]=-1;i=(h[p+a>>0]|0)+-16|0;a=Y((i|0)>0?i:0,1220542)|0;i=a+u>>20;b[s+6>>0]=i>>>0<256?i:(i|0)>0?255:0;i=a+v>>20;b[s+5>>0]=i>>>0<256?i:(i|0)>0?255:0;i=a+t>>20;b[s+4>>0]=i>>>0<256?i:(i|0)>0?255:0;b[s+7>>0]=-1;q=q+2|0;x=f[l>>2]|0;if((q|0)>=(x|0))break;else{r=r+8|0;s=s+8|0}}y=x;z=f[c>>2]|0}else{y=g;z=m}n=n+2|0;if((n|0)>=(e|0))break;else{m=z;g=y;d=d+z|0;o=o+(z<<1)|0}}return}function a5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=g;g=f[l>>2]|0;n=d;d=(f[a+20>>2]|0)+(i>>>1)|0;o=(f[a+16>>2]|0)+i|0;while(1){i=f[j>>2]|0;a=f[k>>2]|0;p=o+m|0;if((g|0)>0){q=0;r=i+(Y(a,n)|0)|0;s=i+(Y(a,n|1)|0)|0;while(1){a=(h[d+q>>0]|0)+-128|0;i=q|1;t=(h[d+i>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(a,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(a,2116026)|0)+524288|0;a=(h[o+q>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[r>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[r+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[r+2>>0]=a>>>0<256?a:(a|0)>0?255:0;b[r+3>>0]=-1;a=(h[o+i>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[r+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[r+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[r+6>>0]=a>>>0<256?a:(a|0)>0?255:0;b[r+7>>0]=-1;a=(h[p+q>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[s>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[s+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[s+2>>0]=a>>>0<256?a:(a|0)>0?255:0;b[s+3>>0]=-1;a=(h[p+i>>0]|0)+-16|0;i=Y((a|0)>0?a:0,1220542)|0;a=i+u>>20;b[s+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=i+v>>20;b[s+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=i+t>>20;b[s+6>>0]=a>>>0<256?a:(a|0)>0?255:0;b[s+7>>0]=-1;q=q+2|0;x=f[l>>2]|0;if((q|0)>=(x|0))break;else{r=r+8|0;s=s+8|0}}y=x;z=f[c>>2]|0}else{y=g;z=m}n=n+2|0;if((n|0)>=(e|0))break;else{m=z;g=y;d=d+z|0;o=o+(z<<1)|0}}return}function b5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=g;g=f[l>>2]|0;n=d;d=(f[a+20>>2]|0)+(i>>>1)|0;o=(f[a+16>>2]|0)+i|0;while(1){i=f[j>>2]|0;a=f[k>>2]|0;p=o+m|0;if((g|0)>0){q=0;r=i+(Y(a,n)|0)|0;s=i+(Y(a,n|1)|0)|0;while(1){a=q|1;i=(h[d+a>>0]|0)+-128|0;t=(h[d+q>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(i,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(i,2116026)|0)+524288|0;i=(h[o+q>>0]|0)+-16|0;w=Y((i|0)>0?i:0,1220542)|0;i=w+u>>20;b[r>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+v>>20;b[r+1>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+t>>20;b[r+2>>0]=i>>>0<256?i:(i|0)>0?255:0;b[r+3>>0]=-1;i=(h[o+a>>0]|0)+-16|0;w=Y((i|0)>0?i:0,1220542)|0;i=w+u>>20;b[r+4>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+v>>20;b[r+5>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+t>>20;b[r+6>>0]=i>>>0<256?i:(i|0)>0?255:0;b[r+7>>0]=-1;i=(h[p+q>>0]|0)+-16|0;w=Y((i|0)>0?i:0,1220542)|0;i=w+u>>20;b[s>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+v>>20;b[s+1>>0]=i>>>0<256?i:(i|0)>0?255:0;i=w+t>>20;b[s+2>>0]=i>>>0<256?i:(i|0)>0?255:0;b[s+3>>0]=-1;i=(h[p+a>>0]|0)+-16|0;a=Y((i|0)>0?i:0,1220542)|0;i=a+u>>20;b[s+4>>0]=i>>>0<256?i:(i|0)>0?255:0;i=a+v>>20;b[s+5>>0]=i>>>0<256?i:(i|0)>0?255:0;i=a+t>>20;b[s+6>>0]=i>>>0<256?i:(i|0)>0?255:0;b[s+7>>0]=-1;q=q+2|0;x=f[l>>2]|0;if((q|0)>=(x|0))break;else{r=r+8|0;s=s+8|0}}y=x;z=f[c>>2]|0}else{y=g;z=m}n=n+2|0;if((n|0)>=(e|0))break;else{m=z;g=y;d=d+z|0;o=o+(z<<1)|0}}return}function c5(a){a=a|0;PYa(a);return}function d5(a){a=a|0;PYa(a);return}function e5(a){a=a|0;PYa(a);return}function f5(a){a=a|0;PYa(a);return}function g5(a){a=a|0;PYa(a);return}function h5(a){a=a|0;PYa(a);return}function i5(a){a=a|0;PYa(a);return}function j5(a){a=a|0;PYa(a);return}function k5(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;l=u;u=u+64|0;m=l+16|0;n=l+8|0;o=l;_$(o,48212);p=a+(Y(h,c)|0)|0;q=(h|0)%4|0;r=a+(Y(((h|0)/4|0)+h|0,c)|0)+(Y((q|0)/2|0,(g|0)/2|0)|0)|0;s=(q|0)==2;q=(k|0)==1;k=q?r:p;t=q?p:r;r=s&q&1;p=s&(q^1)&1;switch(((i*10|0)+-30+(j?2:0)|0)>>>1&2147483647|0){case 0:{f[m>>2]=48240;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=k;f[m+24>>2]=t;f[m+28>>2]=c;f[m+32>>2]=r;f[m+36>>2]=p;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;_U(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;l5(m,n)}break}case 1:{f[m>>2]=48260;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=k;f[m+24>>2]=t;f[m+28>>2]=c;f[m+32>>2]=r;f[m+36>>2]=p;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;_U(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;m5(m,n)}break}case 5:{f[m>>2]=48280;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=k;f[m+24>>2]=t;f[m+28>>2]=c;f[m+32>>2]=r;f[m+36>>2]=p;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;_U(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;n5(m,n)}break}case 6:{f[m>>2]=48300;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=k;f[m+24>>2]=t;f[m+28>>2]=c;f[m+32>>2]=r;f[m+36>>2]=p;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;_U(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;o5(m,n)}break}default:{f[m>>2]=0;f[m+4>>2]=0;n=c$(m,41)|0;h=215114;g=n+41|0;do{b[n>>0]=b[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(g|0));j$(-206,m,215604,206245,10826);d$(m)}}if(!(f[o+4>>2]|0)){u=l;return}u=l;return}function l5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;i=g<<1;j=f[c+4>>2]<<1;c=a+12|0;k=f[c>>2]|0;l=(k|0)/2|0;f[e>>2]=l;m=a+28|0;n=f[m>>2]|0;f[e+4>>2]=n-l;l=f[a+32>>2]|0;o=f[a+36>>2]|0;p=(f[a+16>>2]|0)+(Y(n,i)|0)|0;q=Y((g|0)/2|0,n)|0;r=(f[a+20>>2]|0)+q|0;s=(f[a+24>>2]|0)+q|0;if(((g|0)%2|0|0)==1){t=o;v=l;w=k;x=n;y=r;z=s;A=i;B=p;C=2}else{D=n;E=k;F=i;G=r;H=l;I=s;J=o;K=p}while(1){if((C|0)==2){C=0;D=x;E=w;F=A;G=y+(f[e+((v&1)<<2)>>2]|0)|0;H=v+1|0;I=z+(f[e+((t&1)<<2)>>2]|0)|0;J=t+1|0;K=B}if((F|0)>=(j|0))break;p=f[a+4>>2]|0;o=f[a+8>>2]|0;s=K+D|0;if((E|0)>1){l=0;r=p+(Y(o,F)|0)|0;i=p+(Y(o,F|1)|0)|0;while(1){o=(h[G+l>>0]|0)+-128|0;p=(h[I+l>>0]|0)+-128|0;k=(Y(p,1673527)|0)+524288|0;n=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=l<<1;g=(h[K+o>>0]|0)+-16|0;q=Y((g|0)>0?g:0,1220542)|0;g=q+k>>20;b[r+2>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+n>>20;b[r+1>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+p>>20;b[r>>0]=g>>>0<256?g:(g|0)>0?255:0;g=o|1;q=(h[K+g>>0]|0)+-16|0;L=Y((q|0)>0?q:0,1220542)|0;q=L+k>>20;b[r+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+n>>20;b[r+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+p>>20;b[r+3>>0]=q>>>0<256?q:(q|0)>0?255:0;q=(h[s+o>>0]|0)+-16|0;o=Y((q|0)>0?q:0,1220542)|0;q=o+k>>20;b[i+2>>0]=q>>>0<256?q:(q|0)>0?255:0;q=o+n>>20;b[i+1>>0]=q>>>0<256?q:(q|0)>0?255:0;q=o+p>>20;b[i>>0]=q>>>0<256?q:(q|0)>0?255:0;q=(h[s+g>>0]|0)+-16|0;g=Y((q|0)>0?q:0,1220542)|0;q=g+k>>20;b[i+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+n>>20;b[i+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+p>>20;b[i+3>>0]=q>>>0<256?q:(q|0)>0?255:0;l=l+1|0;M=f[c>>2]|0;if((l|0)>=((M|0)/2|0|0))break;else{r=r+6|0;i=i+6|0}}N=f[m>>2]|0;O=M}else{N=D;O=E}t=J;v=H;w=O;x=N;y=G;z=I;A=F+2|0;B=K+(N<<1)|0;C=2}u=d;return}function m5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;i=g<<1;j=f[c+4>>2]<<1;c=a+12|0;k=f[c>>2]|0;l=(k|0)/2|0;f[e>>2]=l;m=a+28|0;n=f[m>>2]|0;f[e+4>>2]=n-l;l=f[a+32>>2]|0;o=f[a+36>>2]|0;p=(f[a+16>>2]|0)+(Y(n,i)|0)|0;q=Y((g|0)/2|0,n)|0;r=(f[a+20>>2]|0)+q|0;s=(f[a+24>>2]|0)+q|0;if(((g|0)%2|0|0)==1){t=o;v=l;w=k;x=n;y=r;z=s;A=i;B=p;C=2}else{D=n;E=k;F=i;G=r;H=l;I=s;J=o;K=p}while(1){if((C|0)==2){C=0;D=x;E=w;F=A;G=y+(f[e+((v&1)<<2)>>2]|0)|0;H=v+1|0;I=z+(f[e+((t&1)<<2)>>2]|0)|0;J=t+1|0;K=B}if((F|0)>=(j|0))break;p=f[a+4>>2]|0;o=f[a+8>>2]|0;s=K+D|0;if((E|0)>1){l=0;r=p+(Y(o,F)|0)|0;i=p+(Y(o,F|1)|0)|0;while(1){o=(h[G+l>>0]|0)+-128|0;p=(h[I+l>>0]|0)+-128|0;k=(Y(p,1673527)|0)+524288|0;n=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=l<<1;g=(h[K+o>>0]|0)+-16|0;q=Y((g|0)>0?g:0,1220542)|0;g=q+k>>20;b[r>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+n>>20;b[r+1>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+p>>20;b[r+2>>0]=g>>>0<256?g:(g|0)>0?255:0;g=o|1;q=(h[K+g>>0]|0)+-16|0;L=Y((q|0)>0?q:0,1220542)|0;q=L+k>>20;b[r+3>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+n>>20;b[r+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+p>>20;b[r+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=(h[s+o>>0]|0)+-16|0;o=Y((q|0)>0?q:0,1220542)|0;q=o+k>>20;b[i>>0]=q>>>0<256?q:(q|0)>0?255:0;q=o+n>>20;b[i+1>>0]=q>>>0<256?q:(q|0)>0?255:0;q=o+p>>20;b[i+2>>0]=q>>>0<256?q:(q|0)>0?255:0;q=(h[s+g>>0]|0)+-16|0;g=Y((q|0)>0?q:0,1220542)|0;q=g+k>>20;b[i+3>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+n>>20;b[i+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+p>>20;b[i+5>>0]=q>>>0<256?q:(q|0)>0?255:0;l=l+1|0;M=f[c>>2]|0;if((l|0)>=((M|0)/2|0|0))break;else{r=r+6|0;i=i+6|0}}N=f[m>>2]|0;O=M}else{N=D;O=E}t=J;v=H;w=O;x=N;y=G;z=I;A=F+2|0;B=K+(N<<1)|0;C=2}u=d;return}function n5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;i=g<<1;j=f[c+4>>2]<<1;c=a+12|0;k=f[c>>2]|0;l=(k|0)/2|0;f[e>>2]=l;m=a+28|0;n=f[m>>2]|0;f[e+4>>2]=n-l;l=f[a+32>>2]|0;o=f[a+36>>2]|0;p=(f[a+16>>2]|0)+(Y(n,i)|0)|0;q=Y((g|0)/2|0,n)|0;r=(f[a+20>>2]|0)+q|0;s=(f[a+24>>2]|0)+q|0;if(((g|0)%2|0|0)==1){t=o;v=l;w=k;x=n;y=r;z=s;A=i;B=p;C=2}else{D=n;E=k;F=i;G=r;H=l;I=s;J=o;K=p}while(1){if((C|0)==2){C=0;D=x;E=w;F=A;G=y+(f[e+((v&1)<<2)>>2]|0)|0;H=v+1|0;I=z+(f[e+((t&1)<<2)>>2]|0)|0;J=t+1|0;K=B}if((F|0)>=(j|0))break;p=f[a+4>>2]|0;o=f[a+8>>2]|0;s=K+D|0;if((E|0)>1){l=0;r=p+(Y(o,F)|0)|0;i=p+(Y(o,F|1)|0)|0;while(1){o=(h[G+l>>0]|0)+-128|0;p=(h[I+l>>0]|0)+-128|0;k=(Y(p,1673527)|0)+524288|0;n=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=l<<1;g=(h[K+o>>0]|0)+-16|0;q=Y((g|0)>0?g:0,1220542)|0;g=q+k>>20;b[r+2>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+n>>20;b[r+1>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+p>>20;b[r>>0]=g>>>0<256?g:(g|0)>0?255:0;b[r+3>>0]=-1;g=o|1;q=(h[K+g>>0]|0)+-16|0;L=Y((q|0)>0?q:0,1220542)|0;q=L+k>>20;b[r+6>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+n>>20;b[r+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+p>>20;b[r+4>>0]=q>>>0<256?q:(q|0)>0?255:0;b[r+7>>0]=-1;q=(h[s+o>>0]|0)+-16|0;o=Y((q|0)>0?q:0,1220542)|0;q=o+k>>20;b[i+2>>0]=q>>>0<256?q:(q|0)>0?255:0;q=o+n>>20;b[i+1>>0]=q>>>0<256?q:(q|0)>0?255:0;q=o+p>>20;b[i>>0]=q>>>0<256?q:(q|0)>0?255:0;b[i+3>>0]=-1;q=(h[s+g>>0]|0)+-16|0;g=Y((q|0)>0?q:0,1220542)|0;q=g+k>>20;b[i+6>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+n>>20;b[i+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+p>>20;b[i+4>>0]=q>>>0<256?q:(q|0)>0?255:0;b[i+7>>0]=-1;l=l+1|0;M=f[c>>2]|0;if((l|0)>=((M|0)/2|0|0))break;else{r=r+8|0;i=i+8|0}}N=f[m>>2]|0;O=M}else{N=D;O=E}t=J;v=H;w=O;x=N;y=G;z=I;A=F+2|0;B=K+(N<<1)|0;C=2}u=d;return}function o5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;i=g<<1;j=f[c+4>>2]<<1;c=a+12|0;k=f[c>>2]|0;l=(k|0)/2|0;f[e>>2]=l;m=a+28|0;n=f[m>>2]|0;f[e+4>>2]=n-l;l=f[a+32>>2]|0;o=f[a+36>>2]|0;p=(f[a+16>>2]|0)+(Y(n,i)|0)|0;q=Y((g|0)/2|0,n)|0;r=(f[a+20>>2]|0)+q|0;s=(f[a+24>>2]|0)+q|0;if(((g|0)%2|0|0)==1){t=o;v=l;w=k;x=n;y=r;z=s;A=i;B=p;C=2}else{D=n;E=k;F=i;G=r;H=l;I=s;J=o;K=p}while(1){if((C|0)==2){C=0;D=x;E=w;F=A;G=y+(f[e+((v&1)<<2)>>2]|0)|0;H=v+1|0;I=z+(f[e+((t&1)<<2)>>2]|0)|0;J=t+1|0;K=B}if((F|0)>=(j|0))break;p=f[a+4>>2]|0;o=f[a+8>>2]|0;s=K+D|0;if((E|0)>1){l=0;r=p+(Y(o,F)|0)|0;i=p+(Y(o,F|1)|0)|0;while(1){o=(h[G+l>>0]|0)+-128|0;p=(h[I+l>>0]|0)+-128|0;k=(Y(p,1673527)|0)+524288|0;n=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=l<<1;g=(h[K+o>>0]|0)+-16|0;q=Y((g|0)>0?g:0,1220542)|0;g=q+k>>20;b[r>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+n>>20;b[r+1>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+p>>20;b[r+2>>0]=g>>>0<256?g:(g|0)>0?255:0;b[r+3>>0]=-1;g=o|1;q=(h[K+g>>0]|0)+-16|0;L=Y((q|0)>0?q:0,1220542)|0;q=L+k>>20;b[r+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+n>>20;b[r+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+p>>20;b[r+6>>0]=q>>>0<256?q:(q|0)>0?255:0;b[r+7>>0]=-1;q=(h[s+o>>0]|0)+-16|0;o=Y((q|0)>0?q:0,1220542)|0;q=o+k>>20;b[i>>0]=q>>>0<256?q:(q|0)>0?255:0;q=o+n>>20;b[i+1>>0]=q>>>0<256?q:(q|0)>0?255:0;q=o+p>>20;b[i+2>>0]=q>>>0<256?q:(q|0)>0?255:0;b[i+3>>0]=-1;q=(h[s+g>>0]|0)+-16|0;g=Y((q|0)>0?q:0,1220542)|0;q=g+k>>20;b[i+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+n>>20;b[i+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+p>>20;b[i+6>>0]=q>>>0<256?q:(q|0)>0?255:0;b[i+7>>0]=-1;l=l+1|0;M=f[c>>2]|0;if((l|0)>=((M|0)/2|0|0))break;else{r=r+8|0;i=i+8|0}}N=f[m>>2]|0;O=M}else{N=D;O=E}t=J;v=H;w=O;x=N;y=G;z=I;A=F+2|0;B=K+(N<<1)|0;C=2}u=d;return}function p5(a){a=a|0;PYa(a);return}function q5(a){a=a|0;PYa(a);return}function r5(a){a=a|0;PYa(a);return}function s5(a){a=a|0;PYa(a);return}function t5(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0;l=u;u=u+48|0;m=l+16|0;n=l+8|0;o=l;_$(o,48312);switch(((j?-8:-10)+(k*10|0)|0)>>>1&2147483647|0){case 0:{f[m>>2]=48340;f[m+4>>2]=a;f[m+8>>2]=c;f[m+12>>2]=d;f[m+16>>2]=e;f[m+20>>2]=g;f[m+24>>2]=h;f[m+28>>2]=i;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;_U(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;u5(m,n)}break}case 1:{f[m>>2]=48360;f[m+4>>2]=a;f[m+8>>2]=c;f[m+12>>2]=d;f[m+16>>2]=e;f[m+20>>2]=g;f[m+24>>2]=h;f[m+28>>2]=i;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;_U(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;v5(m,n)}break}case 5:{f[m>>2]=48380;f[m+4>>2]=a;f[m+8>>2]=c;f[m+12>>2]=d;f[m+16>>2]=e;f[m+20>>2]=g;f[m+24>>2]=h;f[m+28>>2]=i;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;_U(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;w5(m,n)}break}case 6:{f[m>>2]=48400;f[m+4>>2]=a;f[m+8>>2]=c;f[m+12>>2]=d;f[m+16>>2]=e;f[m+20>>2]=g;f[m+24>>2]=h;f[m+28>>2]=i;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;_U(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;x5(m,n)}break}default:{f[m>>2]=0;f[m+4>>2]=0;n=c$(m,41)|0;h=215114;g=n+41|0;do{b[n>>0]=b[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(g|0));j$(-206,m,215872,206245,10845);d$(m)}}if(!(f[o+4>>2]|0)){u=l;return}u=l;return}function u5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=f[a+20>>2]|0;e=f[a+24>>2]|0;g=f[a+28>>2]|0;i=f[c>>2]|0;j=c+4|0;c=f[j>>2]|0;if((i|0)>=(c|0))return;k=a+4|0;l=a+8|0;m=a+12|0;n=a+16|0;a=(d|0)/2|0;o=(e|0)/2|0;p=Y(g,d)|0;d=(p|0)>0;q=g+2|0;r=g+1|0;s=g<<1;t=c;c=i;while(1){i=f[k>>2]|0;u=f[l>>2]|0;v=c<<1;w=i+(Y(u,v)|0)|0;x=i+(Y(u,v|1)|0)|0;u=f[m>>2]|0;i=f[n>>2]|0;y=u+(Y(i,v)|0)|0;v=u+(Y(i,((c|0)/2|0)+e|0)|0)+(Y((c|0)%2|0,a)|0)|0;z=c+o|0;A=u+(Y(i,((z|0)/2|0)+e|0)|0)+(Y((z|0)%2|0,a)|0)|0;if(d){z=0;i=0;while(1){u=z+2|0;B=h[w+u>>0]|0;C=z|1;D=h[w+C>>0]|0;E=h[w+z>>0]|0;F=q+z|0;G=r+z|0;H=z+g|0;I=(B*269484|0)+17301504+(D*528482|0)+(E*102760|0)|0;J=((h[w+F>>0]|0)*269484|0)+17301504+((h[w+G>>0]|0)*528482|0)+((h[w+H>>0]|0)*102760|0)|0;K=((h[x+u>>0]|0)*269484|0)+17301504+((h[x+C>>0]|0)*528482|0)+((h[x+z>>0]|0)*102760|0)|0;C=((h[x+F>>0]|0)*269484|0)+17301504+((h[x+G>>0]|0)*528482|0)+((h[x+H>>0]|0)*102760|0)|0;H=I>>>20;G=i<<1;b[y+G>>0]=I>>>0<268435456?H:H|0?255:0;H=J>>>20;I=G|1;b[y+I>>0]=J>>>0<268435456?H:H|0?255:0;H=K>>>20;b[y+((f[n>>2]|0)+G)>>0]=K>>>0<268435456?H:H|0?255:0;H=C>>>20;b[y+(I+(f[n>>2]|0))>>0]=C>>>0<268435456?H:H|0?255:0;H=(B*460324|0)+134742016+(Y(D,-385875)|0)+(Y(E,-74448)|0)|0;C=(Y(B,-155188)|0)+134742016+(Y(D,-305135)|0)+(E*460324|0)>>20;b[v+i>>0]=C>>>0<256?C:(C|0)>0?255:0;C=H>>20;b[A+i>>0]=C>>>0<256?C:(C|0)>0?255:0;z=z+s|0;if((z|0)>=(p|0))break;else i=i+1|0}L=f[j>>2]|0}else L=t;c=c+1|0;if((c|0)>=(L|0))break;else t=L}return}function v5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=f[a+20>>2]|0;e=f[a+24>>2]|0;g=f[a+28>>2]|0;i=f[c>>2]|0;j=c+4|0;c=f[j>>2]|0;if((i|0)>=(c|0))return;k=a+4|0;l=a+8|0;m=a+12|0;n=a+16|0;a=(d|0)/2|0;o=(e|0)/2|0;p=Y(g,d)|0;d=(p|0)>0;q=g+1|0;r=g+2|0;s=g<<1;t=c;c=i;while(1){i=f[k>>2]|0;u=f[l>>2]|0;v=c<<1;w=i+(Y(u,v)|0)|0;x=i+(Y(u,v|1)|0)|0;u=f[m>>2]|0;i=f[n>>2]|0;y=u+(Y(i,v)|0)|0;v=u+(Y(i,((c|0)/2|0)+e|0)|0)+(Y((c|0)%2|0,a)|0)|0;z=c+o|0;A=u+(Y(i,((z|0)/2|0)+e|0)|0)+(Y((z|0)%2|0,a)|0)|0;if(d){z=0;i=0;while(1){u=h[w+z>>0]|0;B=z|1;C=h[w+B>>0]|0;D=z+2|0;E=h[w+D>>0]|0;F=z+g|0;G=q+z|0;H=r+z|0;I=(u*269484|0)+17301504+(C*528482|0)+(E*102760|0)|0;J=((h[w+F>>0]|0)*269484|0)+17301504+((h[w+G>>0]|0)*528482|0)+((h[w+H>>0]|0)*102760|0)|0;K=((h[x+z>>0]|0)*269484|0)+17301504+((h[x+B>>0]|0)*528482|0)+((h[x+D>>0]|0)*102760|0)|0;D=((h[x+F>>0]|0)*269484|0)+17301504+((h[x+G>>0]|0)*528482|0)+((h[x+H>>0]|0)*102760|0)|0;H=I>>>20;G=i<<1;b[y+G>>0]=I>>>0<268435456?H:H|0?255:0;H=J>>>20;I=G|1;b[y+I>>0]=J>>>0<268435456?H:H|0?255:0;H=K>>>20;b[y+((f[n>>2]|0)+G)>>0]=K>>>0<268435456?H:H|0?255:0;H=D>>>20;b[y+(I+(f[n>>2]|0))>>0]=D>>>0<268435456?H:H|0?255:0;H=(u*460324|0)+134742016+(Y(C,-385875)|0)+(Y(E,-74448)|0)|0;D=(Y(u,-155188)|0)+134742016+(Y(C,-305135)|0)+(E*460324|0)>>20;b[v+i>>0]=D>>>0<256?D:(D|0)>0?255:0;D=H>>20;b[A+i>>0]=D>>>0<256?D:(D|0)>0?255:0;z=z+s|0;if((z|0)>=(p|0))break;else i=i+1|0}L=f[j>>2]|0}else L=t;c=c+1|0;if((c|0)>=(L|0))break;else t=L}return}function w5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=f[a+20>>2]|0;e=f[a+24>>2]|0;g=f[a+28>>2]|0;i=f[c>>2]|0;j=c+4|0;c=f[j>>2]|0;if((i|0)>=(c|0))return;k=a+4|0;l=a+8|0;m=a+12|0;n=a+16|0;a=(d|0)/2|0;o=(e|0)/2|0;p=Y(g,d)|0;d=(p|0)>0;q=g+2|0;r=g+1|0;s=g<<1;t=c;c=i;while(1){i=f[k>>2]|0;u=f[l>>2]|0;v=c<<1;w=i+(Y(u,v)|0)|0;x=i+(Y(u,v|1)|0)|0;u=f[m>>2]|0;i=f[n>>2]|0;y=u+(Y(i,v)|0)|0;v=u+(Y(i,((c|0)/2|0)+e|0)|0)+(Y((c|0)%2|0,a)|0)|0;z=c+o|0;A=u+(Y(i,((z|0)/2|0)+e|0)|0)+(Y((z|0)%2|0,a)|0)|0;if(d){z=0;i=0;while(1){u=z+2|0;B=h[w+u>>0]|0;C=z|1;D=h[w+C>>0]|0;E=h[w+z>>0]|0;F=q+z|0;G=r+z|0;H=z+g|0;I=(B*269484|0)+17301504+(D*528482|0)+(E*102760|0)|0;J=((h[w+F>>0]|0)*269484|0)+17301504+((h[w+G>>0]|0)*528482|0)+((h[w+H>>0]|0)*102760|0)|0;K=((h[x+u>>0]|0)*269484|0)+17301504+((h[x+C>>0]|0)*528482|0)+((h[x+z>>0]|0)*102760|0)|0;C=((h[x+F>>0]|0)*269484|0)+17301504+((h[x+G>>0]|0)*528482|0)+((h[x+H>>0]|0)*102760|0)|0;H=I>>>20;G=i<<1;b[y+G>>0]=I>>>0<268435456?H:H|0?255:0;H=J>>>20;I=G|1;b[y+I>>0]=J>>>0<268435456?H:H|0?255:0;H=K>>>20;b[y+((f[n>>2]|0)+G)>>0]=K>>>0<268435456?H:H|0?255:0;H=C>>>20;b[y+(I+(f[n>>2]|0))>>0]=C>>>0<268435456?H:H|0?255:0;H=(B*460324|0)+134742016+(Y(D,-385875)|0)+(Y(E,-74448)|0)|0;C=(Y(B,-155188)|0)+134742016+(Y(D,-305135)|0)+(E*460324|0)>>20;b[A+i>>0]=C>>>0<256?C:(C|0)>0?255:0;C=H>>20;b[v+i>>0]=C>>>0<256?C:(C|0)>0?255:0;z=z+s|0;if((z|0)>=(p|0))break;else i=i+1|0}L=f[j>>2]|0}else L=t;c=c+1|0;if((c|0)>=(L|0))break;else t=L}return}function x5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=f[a+20>>2]|0;e=f[a+24>>2]|0;g=f[a+28>>2]|0;i=f[c>>2]|0;j=c+4|0;c=f[j>>2]|0;if((i|0)>=(c|0))return;k=a+4|0;l=a+8|0;m=a+12|0;n=a+16|0;a=(d|0)/2|0;o=(e|0)/2|0;p=Y(g,d)|0;d=(p|0)>0;q=g+1|0;r=g+2|0;s=g<<1;t=c;c=i;while(1){i=f[k>>2]|0;u=f[l>>2]|0;v=c<<1;w=i+(Y(u,v)|0)|0;x=i+(Y(u,v|1)|0)|0;u=f[m>>2]|0;i=f[n>>2]|0;y=u+(Y(i,v)|0)|0;v=u+(Y(i,((c|0)/2|0)+e|0)|0)+(Y((c|0)%2|0,a)|0)|0;z=c+o|0;A=u+(Y(i,((z|0)/2|0)+e|0)|0)+(Y((z|0)%2|0,a)|0)|0;if(d){z=0;i=0;while(1){u=h[w+z>>0]|0;B=z|1;C=h[w+B>>0]|0;D=z+2|0;E=h[w+D>>0]|0;F=z+g|0;G=q+z|0;H=r+z|0;I=(u*269484|0)+17301504+(C*528482|0)+(E*102760|0)|0;J=((h[w+F>>0]|0)*269484|0)+17301504+((h[w+G>>0]|0)*528482|0)+((h[w+H>>0]|0)*102760|0)|0;K=((h[x+z>>0]|0)*269484|0)+17301504+((h[x+B>>0]|0)*528482|0)+((h[x+D>>0]|0)*102760|0)|0;D=((h[x+F>>0]|0)*269484|0)+17301504+((h[x+G>>0]|0)*528482|0)+((h[x+H>>0]|0)*102760|0)|0;H=I>>>20;G=i<<1;b[y+G>>0]=I>>>0<268435456?H:H|0?255:0;H=J>>>20;I=G|1;b[y+I>>0]=J>>>0<268435456?H:H|0?255:0;H=K>>>20;b[y+((f[n>>2]|0)+G)>>0]=K>>>0<268435456?H:H|0?255:0;H=D>>>20;b[y+(I+(f[n>>2]|0))>>0]=D>>>0<268435456?H:H|0?255:0;H=(u*460324|0)+134742016+(Y(C,-385875)|0)+(Y(E,-74448)|0)|0;D=(Y(u,-155188)|0)+134742016+(Y(C,-305135)|0)+(E*460324|0)>>20;b[A+i>>0]=D>>>0<256?D:(D|0)>0?255:0;D=H>>20;b[v+i>>0]=D>>>0<256?D:(D|0)>0?255:0;z=z+s|0;if((z|0)>=(p|0))break;else i=i+1|0}L=f[j>>2]|0}else L=t;c=c+1|0;if((c|0)>=(L|0))break;else t=L}return}function y5(a){a=a|0;PYa(a);return}function z5(a){a=a|0;PYa(a);return}function A5(a){a=a|0;PYa(a);return}function B5(a){a=a|0;PYa(a);return}function C5(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0;m=u;u=u+48|0;n=m+16|0;o=m+8|0;p=m;_$(p,48412);do switch((j?200:0)+(i*1e3|0)+(k*10|0)+l|0){case 3e3:{f[n>>2]=48440;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;_U(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;D5(n,o)}break}case 3001:{f[n>>2]=48460;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;_U(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;E5(n,o)}break}case 3010:{f[n>>2]=48480;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;_U(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;F5(n,o)}break}case 3200:{f[n>>2]=48500;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;_U(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;G5(n,o)}break}case 3201:{f[n>>2]=48520;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;_U(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;H5(n,o)}break}case 3210:{f[n>>2]=48540;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;_U(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;I5(n,o)}break}case 4e3:{f[n>>2]=48560;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;_U(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;J5(n,o)}break}case 4001:{f[n>>2]=48580;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;_U(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;K5(n,o)}break}case 4010:{f[n>>2]=48600;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;_U(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;L5(n,o)}break}case 4200:{f[n>>2]=48620;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;_U(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;M5(n,o)}break}case 4201:{f[n>>2]=48640;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;_U(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;N5(n,o)}break}case 4210:{f[n>>2]=48660;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;_U(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;O5(n,o)}break}default:{f[n>>2]=0;f[n+4>>2]=0;q=c$(n,41)|0;r=215114;s=q+41|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));j$(-206,n,216156,206245,10872);d$(n)}}while(0);if(!(f[p+4>>2]|0)){u=m;return}u=m;return}function D5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=g;g=f[l>>2]|0;m=d;d=i;while(1){if((g|0)>0){i=0;n=(f[j>>2]|0)+(Y(f[k>>2]|0,m)|0)|0;while(1){o=(h[d+(i|1)>>0]|0)+-128|0;p=(h[d+(i|3)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+i>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(i|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n+3>>0]=o>>>0<256?o:(o|0)>0?255:0;i=i+4|0;t=f[l>>2]|0;if((i|0)>=(t<<1|0))break;else n=n+6|0}u=t;v=f[c>>2]|0}else{u=g;v=a}m=m+1|0;if((m|0)==(e|0))break;else{a=v;g=u;d=d+v|0}}return}function E5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=g;g=f[l>>2]|0;m=d;d=i;while(1){if((g|0)>0){i=0;n=(f[j>>2]|0)+(Y(f[k>>2]|0,m)|0)|0;while(1){o=(h[d+i>>0]|0)+-128|0;p=(h[d+(i|2)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+(i|1)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(i|3)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n+3>>0]=o>>>0<256?o:(o|0)>0?255:0;i=i+4|0;t=f[l>>2]|0;if((i|0)>=(t<<1|0))break;else n=n+6|0}u=t;v=f[c>>2]|0}else{u=g;v=a}m=m+1|0;if((m|0)==(e|0))break;else{a=v;g=u;d=d+v|0}}return}function F5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=g;g=f[l>>2]|0;m=d;d=i;while(1){if((g|0)>0){i=0;n=(f[j>>2]|0)+(Y(f[k>>2]|0,m)|0)|0;while(1){o=(h[d+(i|3)>>0]|0)+-128|0;p=(h[d+(i|1)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+i>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(i|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n+3>>0]=o>>>0<256?o:(o|0)>0?255:0;i=i+4|0;t=f[l>>2]|0;if((i|0)>=(t<<1|0))break;else n=n+6|0}u=t;v=f[c>>2]|0}else{u=g;v=a}m=m+1|0;if((m|0)==(e|0))break;else{a=v;g=u;d=d+v|0}}return}function G5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=g;g=f[l>>2]|0;m=d;d=i;while(1){if((g|0)>0){i=0;n=(f[j>>2]|0)+(Y(f[k>>2]|0,m)|0)|0;while(1){o=(h[d+(i|1)>>0]|0)+-128|0;p=(h[d+(i|3)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+i>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(i|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n+3>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n+5>>0]=o>>>0<256?o:(o|0)>0?255:0;i=i+4|0;t=f[l>>2]|0;if((i|0)>=(t<<1|0))break;else n=n+6|0}u=t;v=f[c>>2]|0}else{u=g;v=a}m=m+1|0;if((m|0)==(e|0))break;else{a=v;g=u;d=d+v|0}}return}function H5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=g;g=f[l>>2]|0;m=d;d=i;while(1){if((g|0)>0){i=0;n=(f[j>>2]|0)+(Y(f[k>>2]|0,m)|0)|0;while(1){o=(h[d+i>>0]|0)+-128|0;p=(h[d+(i|2)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+(i|1)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(i|3)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n+3>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n+5>>0]=o>>>0<256?o:(o|0)>0?255:0;i=i+4|0;t=f[l>>2]|0;if((i|0)>=(t<<1|0))break;else n=n+6|0}u=t;v=f[c>>2]|0}else{u=g;v=a}m=m+1|0;if((m|0)==(e|0))break;else{a=v;g=u;d=d+v|0}}return}function I5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=g;g=f[l>>2]|0;m=d;d=i;while(1){if((g|0)>0){i=0;n=(f[j>>2]|0)+(Y(f[k>>2]|0,m)|0)|0;while(1){o=(h[d+(i|3)>>0]|0)+-128|0;p=(h[d+(i|1)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+i>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(i|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n+3>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n+5>>0]=o>>>0<256?o:(o|0)>0?255:0;i=i+4|0;t=f[l>>2]|0;if((i|0)>=(t<<1|0))break;else n=n+6|0}u=t;v=f[c>>2]|0}else{u=g;v=a}m=m+1|0;if((m|0)==(e|0))break;else{a=v;g=u;d=d+v|0}}return}function J5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=g;g=f[l>>2]|0;m=d;d=i;while(1){if((g|0)>0){i=0;n=(f[j>>2]|0)+(Y(f[k>>2]|0,m)|0)|0;while(1){o=(h[d+(i|1)>>0]|0)+-128|0;p=(h[d+(i|3)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+i>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n>>0]=o>>>0<256?o:(o|0)>0?255:0;b[n+3>>0]=-1;o=(h[d+(i|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n+6>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n+4>>0]=o>>>0<256?o:(o|0)>0?255:0;b[n+7>>0]=-1;i=i+4|0;t=f[l>>2]|0;if((i|0)>=(t<<1|0))break;else n=n+8|0}u=t;v=f[c>>2]|0}else{u=g;v=a}m=m+1|0;if((m|0)==(e|0))break;else{a=v;g=u;d=d+v|0}}return}function K5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=g;g=f[l>>2]|0;m=d;d=i;while(1){if((g|0)>0){i=0;n=(f[j>>2]|0)+(Y(f[k>>2]|0,m)|0)|0;while(1){o=(h[d+i>>0]|0)+-128|0;p=(h[d+(i|2)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+(i|1)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n>>0]=o>>>0<256?o:(o|0)>0?255:0;b[n+3>>0]=-1;o=(h[d+(i|3)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n+6>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n+4>>0]=o>>>0<256?o:(o|0)>0?255:0;b[n+7>>0]=-1;i=i+4|0;t=f[l>>2]|0;if((i|0)>=(t<<1|0))break;else n=n+8|0}u=t;v=f[c>>2]|0}else{u=g;v=a}m=m+1|0;if((m|0)==(e|0))break;else{a=v;g=u;d=d+v|0}}return}function L5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=g;g=f[l>>2]|0;m=d;d=i;while(1){if((g|0)>0){i=0;n=(f[j>>2]|0)+(Y(f[k>>2]|0,m)|0)|0;while(1){o=(h[d+(i|3)>>0]|0)+-128|0;p=(h[d+(i|1)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+i>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n>>0]=o>>>0<256?o:(o|0)>0?255:0;b[n+3>>0]=-1;o=(h[d+(i|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n+6>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n+4>>0]=o>>>0<256?o:(o|0)>0?255:0;b[n+7>>0]=-1;i=i+4|0;t=f[l>>2]|0;if((i|0)>=(t<<1|0))break;else n=n+8|0}u=t;v=f[c>>2]|0}else{u=g;v=a}m=m+1|0;if((m|0)==(e|0))break;else{a=v;g=u;d=d+v|0}}return}function M5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=g;g=f[l>>2]|0;m=d;d=i;while(1){if((g|0)>0){i=0;n=(f[j>>2]|0)+(Y(f[k>>2]|0,m)|0)|0;while(1){o=(h[d+(i|1)>>0]|0)+-128|0;p=(h[d+(i|3)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+i>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n+2>>0]=o>>>0<256?o:(o|0)>0?255:0;b[n+3>>0]=-1;o=(h[d+(i|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n+6>>0]=o>>>0<256?o:(o|0)>0?255:0;b[n+7>>0]=-1;i=i+4|0;t=f[l>>2]|0;if((i|0)>=(t<<1|0))break;else n=n+8|0}u=t;v=f[c>>2]|0}else{u=g;v=a}m=m+1|0;if((m|0)==(e|0))break;else{a=v;g=u;d=d+v|0}}return}function N5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=g;g=f[l>>2]|0;m=d;d=i;while(1){if((g|0)>0){i=0;n=(f[j>>2]|0)+(Y(f[k>>2]|0,m)|0)|0;while(1){o=(h[d+i>>0]|0)+-128|0;p=(h[d+(i|2)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+(i|1)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n+2>>0]=o>>>0<256?o:(o|0)>0?255:0;b[n+3>>0]=-1;o=(h[d+(i|3)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n+6>>0]=o>>>0<256?o:(o|0)>0?255:0;b[n+7>>0]=-1;i=i+4|0;t=f[l>>2]|0;if((i|0)>=(t<<1|0))break;else n=n+8|0}u=t;v=f[c>>2]|0}else{u=g;v=a}m=m+1|0;if((m|0)==(e|0))break;else{a=v;g=u;d=d+v|0}}return}function O5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=g;g=f[l>>2]|0;m=d;d=i;while(1){if((g|0)>0){i=0;n=(f[j>>2]|0)+(Y(f[k>>2]|0,m)|0)|0;while(1){o=(h[d+(i|3)>>0]|0)+-128|0;p=(h[d+(i|1)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+i>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n+2>>0]=o>>>0<256?o:(o|0)>0?255:0;b[n+3>>0]=-1;o=(h[d+(i|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[n+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[n+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[n+6>>0]=o>>>0<256?o:(o|0)>0?255:0;b[n+7>>0]=-1;i=i+4|0;t=f[l>>2]|0;if((i|0)>=(t<<1|0))break;else n=n+8|0}u=t;v=f[c>>2]|0}else{u=g;v=a}m=m+1|0;if((m|0)==(e|0))break;else{a=v;g=u;d=d+v|0}}return}function P5(a){a=a|0;PYa(a);return}function Q5(a){a=a|0;PYa(a);return}function R5(a){a=a|0;PYa(a);return}function S5(a){a=a|0;PYa(a);return}function T5(a){a=a|0;PYa(a);return}function U5(a){a=a|0;PYa(a);return}function V5(a){a=a|0;PYa(a);return}function W5(a){a=a|0;PYa(a);return}function X5(a){a=a|0;PYa(a);return}function Y5(a){a=a|0;PYa(a);return}function Z5(a){a=a|0;PYa(a);return}function _5(a){a=a|0;PYa(a);return}function $5(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+64|0;i=h+40|0;j=h+8|0;k=h;_$(k,48672);f[i>>2]=0;f[i+4>>2]=g;f[j>>2]=48700;f[j+4>>2]=a;f[j+8>>2]=b;f[j+12>>2]=c;f[j+16>>2]=d;f[j+20>>2]=e;f[j+24>>2]=h+48;_U(i,j,+(Y(g,e)|0)*.0000152587890625);if(!(f[k+4>>2]|0)){u=h;return}u=h;return}function a6(a){a=a|0;PYa(a);return}function b6(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;_$(e,48712);g=f[c>>2]|0;i=a+8|0;j=a+16|0;k=c+4|0;c=f[k>>2]|0;if((g|0)<(c|0)){l=f[j>>2]|0;m=(f[a+12>>2]|0)+(Y(l,g)|0)|0;n=f[i>>2]|0;o=a+20|0;p=c;c=l;l=n;q=g;r=m;m=(f[a+4>>2]|0)+(Y(n,g)|0)|0;while(1){g=f[o>>2]|0;if((g|0)>0){n=r;a=0;s=m;while(1){t=b[s+1>>0]|0;v=b[s+2>>0]|0;w=b[s+3>>0]|0;x=w&255;y=((((Y(x,h[s>>0]|0)|0)+128|0)>>>0)/255|0)&255;b[n>>0]=y;y=((((Y(x,t&255)|0)+128|0)>>>0)/255|0)&255;b[n+1>>0]=y;y=((((Y(x,v&255)|0)+128|0)>>>0)/255|0)&255;b[n+2>>0]=y;b[n+3>>0]=w;a=a+1|0;if((a|0)==(g|0))break;else{n=n+4|0;s=s+4|0}}z=f[i>>2]|0;A=f[j>>2]|0;B=f[k>>2]|0}else{z=l;A=c;B=p}q=q+1|0;if((q|0)>=(B|0))break;else{p=B;c=A;l=z;r=r+A|0;m=m+z|0}}}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function c6(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+64|0;i=h+40|0;j=h+8|0;k=h;_$(k,48732);f[i>>2]=0;f[i+4>>2]=g;f[j>>2]=48760;f[j+4>>2]=a;f[j+8>>2]=b;f[j+12>>2]=c;f[j+16>>2]=d;f[j+20>>2]=e;f[j+24>>2]=h+48;_U(i,j,+(Y(g,e)|0)*.0000152587890625);if(!(f[k+4>>2]|0)){u=h;return}u=h;return}function d6(a){a=a|0;PYa(a);return}function e6(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=u;u=u+16|0;e=d;_$(e,48772);g=f[c>>2]|0;i=a+8|0;j=a+16|0;k=c+4|0;c=f[k>>2]|0;if((g|0)<(c|0)){l=f[j>>2]|0;m=(f[a+12>>2]|0)+(Y(l,g)|0)|0;n=f[i>>2]|0;o=a+20|0;p=c;c=l;l=n;q=g;r=m;m=(f[a+4>>2]|0)+(Y(n,g)|0)|0;while(1){g=f[o>>2]|0;if((g|0)>0){n=r;a=0;s=m;while(1){t=b[s+3>>0]|0;v=t&255;if(!(t<<24>>24)){b[n>>0]=0;w=0;x=0}else{y=b[s+2>>0]|0;z=b[s+1>>0]|0;A=(t&255)>>>1&255;b[n>>0]=((((h[s>>0]|0)*255|0)+A|0)>>>0)/(v>>>0)|0;w=(((((z&255)*255|0)+A|0)>>>0)/(v>>>0)|0)&255;x=((((y&255)*255|0)+A|0)>>>0)/(v>>>0)|0}b[n+1>>0]=w;b[n+2>>0]=x;b[n+3>>0]=t;a=a+1|0;if((a|0)==(g|0))break;else{n=n+4|0;s=s+4|0}}B=f[i>>2]|0;C=f[j>>2]|0;D=f[k>>2]|0}else{B=l;C=c;D=p}q=q+1|0;if((q|0)>=(D|0))break;else{p=D;c=C;l=B;r=r+C|0;m=m+B|0}}}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function f6(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0;g=u;u=u+416|0;h=g+8|0;i=g;j=g+408|0;k=g+352|0;l=g+296|0;m=g+288|0;n=g+280|0;o=g+272|0;p=g+264|0;q=g+256|0;r=g+248|0;s=g+240|0;t=g+232|0;v=g+224|0;w=g+216|0;x=g+208|0;y=g+200|0;z=g+192|0;A=g+184|0;B=g+176|0;C=g+168|0;D=g+160|0;E=g+152|0;F=g+96|0;G=g+88|0;H=g+80|0;I=g+72|0;J=g+64|0;_$(j,48792);K=RR(a,-1)|0;L=K>>>3;M=L&511;N=M+1|0;O=K&7;f[k>>2]=1124007936;P=k+4|0;Q=k+8|0;R=k+40|0;S=P;T=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(T|0));f[R>>2]=Q;U=k+48|0;V=k+44|0;f[V>>2]=U;f[U>>2]=0;f[k+52>>2]=0;f[l>>2]=1124007936;W=l+4|0;X=l+8|0;Y=l+40|0;S=W;T=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(T|0));f[Y>>2]=X;Z=l+48|0;_=l+44|0;f[_>>2]=Z;f[Z>>2]=0;f[l+52>>2]=0;$=a+4|0;aa=c+4|0;if((f[$>>2]|0)!=(f[aa>>2]|0)){do if((NS(a)|0)==65536){ba=f[$>>2]|0;f[h>>2]=f[ba>>2];ca=h+4|0;da=ba+4|0;f[ca>>2]=f[da>>2];ea=h+8|0;f[ea>>2]=f[ba+8>>2];f[h+12>>2]=f[ba+12>>2];f[h+16>>2]=f[ba+16>>2];f[h+20>>2]=f[ba+20>>2];f[h+24>>2]=f[ba+24>>2];f[h+28>>2]=f[ba+28>>2];f[h+32>>2]=f[ba+32>>2];fa=h+36|0;ga=f[ba+36>>2]|0;f[fa>>2]=ga;f[h+40>>2]=ea;ea=h+48|0;ha=h+44|0;f[ha>>2]=ea;f[ea>>2]=0;f[h+52>>2]=0;if(ga|0){ea=ga+12|0;f[ea>>2]=(f[ea>>2]|0)+1}if((f[da>>2]|0)<3){da=f[ba+44>>2]|0;ea=f[ha>>2]|0;f[ea>>2]=f[da>>2];f[ea+4>>2]=f[da+4>>2];ia=fa;break}else{f[ca>>2]=0;BR(h,ba);ia=fa;break}}else{OR(h,a,-1);ia=h+36|0}while(0);$=f[ia>>2]|0;if($|0){fa=$+12|0;f[fa>>2]=(f[fa>>2]|0)+1}fa=k+36|0;$=f[fa>>2]|0;if($|0?(ba=$+12|0,$=f[ba>>2]|0,f[ba>>2]=$+-1,($|0)==1):0)CR(k);f[fa>>2]=0;$=k+16|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[P>>2]|0)>0){ba=f[R>>2]|0;ca=0;do{f[ba+(ca<<2)>>2]=0;ca=ca+1|0;ja=f[P>>2]|0}while((ca|0)<(ja|0));f[k>>2]=f[h>>2];if((ja|0)<3)ka=20;else ka=22}else{f[k>>2]=f[h>>2];ka=20}if((ka|0)==20){ja=f[h+4>>2]|0;if((ja|0)<3){f[P>>2]=ja;f[Q>>2]=f[h+8>>2];f[k+12>>2]=f[h+12>>2];ja=f[h+44>>2]|0;ca=f[V>>2]|0;f[ca>>2]=f[ja>>2];f[ca+4>>2]=f[ja+4>>2]}else ka=22}if((ka|0)==22)BR(k,h);ja=h+16|0;f[$>>2]=f[ja>>2];f[k+20>>2]=f[h+20>>2];f[k+24>>2]=f[h+24>>2];f[k+28>>2]=f[h+28>>2];f[k+32>>2]=f[h+32>>2];$=f[ia>>2]|0;f[fa>>2]=$;if($|0?(fa=$+12|0,$=f[fa>>2]|0,f[fa>>2]=$+-1,($|0)==1):0)CR(h);f[ia>>2]=0;ia=h+4|0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[ia>>2]|0)>0){ja=f[h+40>>2]|0;$=0;do{f[ja+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[ia>>2]|0))}ia=f[h+44>>2]|0;if((ia|0)!=(h+48|0))ZF(ia)}else{ia=h+8|0;f[ia>>2]=0;f[ia+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=k;ZS(a,h)}ia=f[R>>2]|0;$=f[ia+4>>2]|0;ja=f[ia>>2]|0;ia=(O|0)==0;fa=K&255;switch(fa&7){case 0:case 2:case 5:break;default:{f[h>>2]=0;f[h+4>>2]=0;S=c$(h,38)|0;la=217373;T=S+38|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11010);d$(h)}}do switch(d|0){case 5:case 4:case 3:case 1:case 2:case 0:{if((L&510|0)!=2){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,20)|0;la=217421;T=S+20|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11016);d$(h)}K=(d|0)==5|(d|2|0)==2?4:3;f[m>>2]=$;f[m+4>>2]=ja;KS(c,m,O|(K<<3)+-8,-1,0,0);do if((NS(c)|0)==65536){ca=f[aa>>2]|0;f[h>>2]=f[ca>>2];ba=h+4|0;da=ca+4|0;f[ba>>2]=f[da>>2];ea=h+8|0;f[ea>>2]=f[ca+8>>2];f[h+12>>2]=f[ca+12>>2];f[h+16>>2]=f[ca+16>>2];f[h+20>>2]=f[ca+20>>2];f[h+24>>2]=f[ca+24>>2];f[h+28>>2]=f[ca+28>>2];f[h+32>>2]=f[ca+32>>2];ha=h+36|0;ga=f[ca+36>>2]|0;f[ha>>2]=ga;f[h+40>>2]=ea;ea=h+48|0;ma=h+44|0;f[ma>>2]=ea;f[ea>>2]=0;f[h+52>>2]=0;if(ga|0){ea=ga+12|0;f[ea>>2]=(f[ea>>2]|0)+1}if((f[da>>2]|0)<3){da=f[ca+44>>2]|0;ea=f[ma>>2]|0;f[ea>>2]=f[da>>2];f[ea+4>>2]=f[da+4>>2];na=ha;break}else{f[ba>>2]=0;BR(h,ca);na=ha;break}}else{OR(h,c,-1);na=h+36|0}while(0);ha=f[na>>2]|0;if(ha|0){ca=ha+12|0;f[ca>>2]=(f[ca>>2]|0)+1}ca=l+36|0;ha=f[ca>>2]|0;if(ha|0?(ba=ha+12|0,ha=f[ba>>2]|0,f[ba>>2]=ha+-1,(ha|0)==1):0)CR(l);f[ca>>2]=0;ha=l+16|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[W>>2]|0)>0){ba=f[Y>>2]|0;da=0;do{f[ba+(da<<2)>>2]=0;da=da+1|0;oa=f[W>>2]|0}while((da|0)<(oa|0));f[l>>2]=f[h>>2];if((oa|0)<3)ka=54;else ka=56}else{f[l>>2]=f[h>>2];ka=54}if((ka|0)==54){da=f[h+4>>2]|0;if((da|0)<3){f[W>>2]=da;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];da=f[h+44>>2]|0;ba=f[_>>2]|0;f[ba>>2]=f[da>>2];f[ba+4>>2]=f[da+4>>2]}else ka=56}if((ka|0)==56)BR(l,h);da=h+16|0;f[ha>>2]=f[da>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ba=f[na>>2]|0;f[ca>>2]=ba;if(ba|0?(ea=ba+12|0,ba=f[ea>>2]|0,f[ea>>2]=ba+-1,(ba|0)==1):0)CR(h);f[na>>2]=0;ba=h+4|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[ba>>2]|0)>0){da=f[h+40>>2]|0;ea=0;do{f[da+(ea<<2)>>2]=0;ea=ea+1|0}while((ea|0)<(f[ba>>2]|0))}ba=f[h+44>>2]|0;if((ba|0)!=(h+48|0))ZF(ba);ba=f[k+16>>2]|0;ea=f[U>>2]|0;da=f[ha>>2]|0;ca=f[Z>>2]|0;ma=f[k+12>>2]|0;ga=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{pa=0;break}default:pa=1}m2(ba,ea,da,ca,ma,ga,O,N,K,pa);break}case 27:case 17:case 26:case 16:case 23:case 13:case 22:case 12:{if(!(ia&(L&510|0)==2)){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,36)|0;la=217442;T=S+36|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11026);d$(h)}switch(d|0){case 12:case 13:case 16:{qa=6;break}default:qa=(d|0)==17?6:5}f[n>>2]=$;f[n+4>>2]=ja;KS(c,n,8,-1,0,0);do if((NS(c)|0)==65536){K=f[aa>>2]|0;f[h>>2]=f[K>>2];ha=h+4|0;ga=K+4|0;f[ha>>2]=f[ga>>2];ma=h+8|0;f[ma>>2]=f[K+8>>2];f[h+12>>2]=f[K+12>>2];f[h+16>>2]=f[K+16>>2];f[h+20>>2]=f[K+20>>2];f[h+24>>2]=f[K+24>>2];f[h+28>>2]=f[K+28>>2];f[h+32>>2]=f[K+32>>2];ca=h+36|0;da=f[K+36>>2]|0;f[ca>>2]=da;f[h+40>>2]=ma;ma=h+48|0;ea=h+44|0;f[ea>>2]=ma;f[ma>>2]=0;f[h+52>>2]=0;if(da|0){ma=da+12|0;f[ma>>2]=(f[ma>>2]|0)+1}if((f[ga>>2]|0)<3){ga=f[K+44>>2]|0;ma=f[ea>>2]|0;f[ma>>2]=f[ga>>2];f[ma+4>>2]=f[ga+4>>2];ra=ca;break}else{f[ha>>2]=0;BR(h,K);ra=ca;break}}else{OR(h,c,-1);ra=h+36|0}while(0);ca=f[ra>>2]|0;if(ca|0){K=ca+12|0;f[K>>2]=(f[K>>2]|0)+1}K=l+36|0;ca=f[K>>2]|0;if(ca|0?(ha=ca+12|0,ca=f[ha>>2]|0,f[ha>>2]=ca+-1,(ca|0)==1):0)CR(l);f[K>>2]=0;ca=l+16|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[W>>2]|0)>0){ha=f[Y>>2]|0;ga=0;do{f[ha+(ga<<2)>>2]=0;ga=ga+1|0;sa=f[W>>2]|0}while((ga|0)<(sa|0));f[l>>2]=f[h>>2];if((sa|0)<3)ka=89;else ka=91}else{f[l>>2]=f[h>>2];ka=89}if((ka|0)==89){ga=f[h+4>>2]|0;if((ga|0)<3){f[W>>2]=ga;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ga=f[h+44>>2]|0;ha=f[_>>2]|0;f[ha>>2]=f[ga>>2];f[ha+4>>2]=f[ga+4>>2]}else ka=91}if((ka|0)==91)BR(l,h);ga=h+16|0;f[ca>>2]=f[ga>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ha=f[ra>>2]|0;f[K>>2]=ha;if(ha|0?(ma=ha+12|0,ha=f[ma>>2]|0,f[ma>>2]=ha+-1,(ha|0)==1):0)CR(h);f[ra>>2]=0;ha=h+4|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[ha>>2]|0)>0){ga=f[h+40>>2]|0;ma=0;do{f[ga+(ma<<2)>>2]=0;ma=ma+1|0}while((ma|0)<(f[ha>>2]|0))}ha=f[h+44>>2]|0;if((ha|0)!=(h+48|0))ZF(ha);ha=f[k+16>>2]|0;ma=f[U>>2]|0;ga=f[ca>>2]|0;K=f[Z>>2]|0;ea=f[k+12>>2]|0;da=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{ta=0;break}default:ta=1}w2(ha,ma,ga,K,ea,da,N,ta,qa);break}case 29:case 19:case 28:case 18:case 25:case 15:case 24:case 14:{if((e|0)<1){da=d+-18|0;if(da>>>0<12)ua=(3075>>>(da&4095)&1)+3&4095;else ua=3}else ua=e;if(!(ia&((N|0)==2&(ua+-3|0)>>>0<2))){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,48)|0;la=217479;T=S+48|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11038);d$(h)}switch(d|0){case 14:case 15:case 18:{va=6;break}default:va=(d|0)==19?6:5}f[o>>2]=$;f[o+4>>2]=ja;KS(c,o,(ua<<3)+-8|O,-1,0,0);do if((NS(c)|0)==65536){ca=f[aa>>2]|0;f[h>>2]=f[ca>>2];da=h+4|0;ea=ca+4|0;f[da>>2]=f[ea>>2];K=h+8|0;f[K>>2]=f[ca+8>>2];f[h+12>>2]=f[ca+12>>2];f[h+16>>2]=f[ca+16>>2];f[h+20>>2]=f[ca+20>>2];f[h+24>>2]=f[ca+24>>2];f[h+28>>2]=f[ca+28>>2];f[h+32>>2]=f[ca+32>>2];ga=h+36|0;ma=f[ca+36>>2]|0;f[ga>>2]=ma;f[h+40>>2]=K;K=h+48|0;ha=h+44|0;f[ha>>2]=K;f[K>>2]=0;f[h+52>>2]=0;if(ma|0){K=ma+12|0;f[K>>2]=(f[K>>2]|0)+1}if((f[ea>>2]|0)<3){ea=f[ca+44>>2]|0;K=f[ha>>2]|0;f[K>>2]=f[ea>>2];f[K+4>>2]=f[ea+4>>2];wa=ga;break}else{f[da>>2]=0;BR(h,ca);wa=ga;break}}else{OR(h,c,-1);wa=h+36|0}while(0);ga=f[wa>>2]|0;if(ga|0){ca=ga+12|0;f[ca>>2]=(f[ca>>2]|0)+1}ca=l+36|0;ga=f[ca>>2]|0;if(ga|0?(da=ga+12|0,ga=f[da>>2]|0,f[da>>2]=ga+-1,(ga|0)==1):0)CR(l);f[ca>>2]=0;ga=l+16|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[W>>2]|0)>0){da=f[Y>>2]|0;ea=0;do{f[da+(ea<<2)>>2]=0;ea=ea+1|0;xa=f[W>>2]|0}while((ea|0)<(xa|0));f[l>>2]=f[h>>2];if((xa|0)<3)ka=127;else ka=129}else{f[l>>2]=f[h>>2];ka=127}if((ka|0)==127){ea=f[h+4>>2]|0;if((ea|0)<3){f[W>>2]=ea;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ea=f[h+44>>2]|0;da=f[_>>2]|0;f[da>>2]=f[ea>>2];f[da+4>>2]=f[ea+4>>2]}else ka=129}if((ka|0)==129)BR(l,h);ea=h+16|0;f[ga>>2]=f[ea>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];da=f[wa>>2]|0;f[ca>>2]=da;if(da|0?(K=da+12|0,da=f[K>>2]|0,f[K>>2]=da+-1,(da|0)==1):0)CR(h);f[wa>>2]=0;da=h+4|0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[da>>2]|0)>0){ea=f[h+40>>2]|0;K=0;do{f[ea+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[da>>2]|0))}da=f[h+44>>2]|0;if((da|0)!=(h+48|0))ZF(da);da=f[k+16>>2]|0;K=f[U>>2]|0;ea=f[ga>>2]|0;ca=f[Z>>2]|0;ha=f[k+12>>2]|0;ma=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{ya=0;break}default:ya=1}A2(da,K,ea,ca,ha,ma,ua,ya,va);break}case 11:case 7:case 10:case 6:{if((L&510|0)!=2){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,20)|0;la=217421;T=S+20|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11048);d$(h)}f[p>>2]=$;f[p+4>>2]=ja;KS(c,p,O,-1,0,0);do if((NS(c)|0)==65536){ga=f[aa>>2]|0;f[h>>2]=f[ga>>2];ma=h+4|0;ha=ga+4|0;f[ma>>2]=f[ha>>2];ca=h+8|0;f[ca>>2]=f[ga+8>>2];f[h+12>>2]=f[ga+12>>2];f[h+16>>2]=f[ga+16>>2];f[h+20>>2]=f[ga+20>>2];f[h+24>>2]=f[ga+24>>2];f[h+28>>2]=f[ga+28>>2];f[h+32>>2]=f[ga+32>>2];ea=h+36|0;K=f[ga+36>>2]|0;f[ea>>2]=K;f[h+40>>2]=ca;ca=h+48|0;da=h+44|0;f[da>>2]=ca;f[ca>>2]=0;f[h+52>>2]=0;if(K|0){ca=K+12|0;f[ca>>2]=(f[ca>>2]|0)+1}if((f[ha>>2]|0)<3){ha=f[ga+44>>2]|0;ca=f[da>>2]|0;f[ca>>2]=f[ha>>2];f[ca+4>>2]=f[ha+4>>2];za=ea;break}else{f[ma>>2]=0;BR(h,ga);za=ea;break}}else{OR(h,c,-1);za=h+36|0}while(0);ea=f[za>>2]|0;if(ea|0){ga=ea+12|0;f[ga>>2]=(f[ga>>2]|0)+1}ga=l+36|0;ea=f[ga>>2]|0;if(ea|0?(ma=ea+12|0,ea=f[ma>>2]|0,f[ma>>2]=ea+-1,(ea|0)==1):0)CR(l);f[ga>>2]=0;ea=l+16|0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[W>>2]|0)>0){ma=f[Y>>2]|0;ha=0;do{f[ma+(ha<<2)>>2]=0;ha=ha+1|0;Aa=f[W>>2]|0}while((ha|0)<(Aa|0));f[l>>2]=f[h>>2];if((Aa|0)<3)ka=160;else ka=162}else{f[l>>2]=f[h>>2];ka=160}if((ka|0)==160){ha=f[h+4>>2]|0;if((ha|0)<3){f[W>>2]=ha;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ha=f[h+44>>2]|0;ma=f[_>>2]|0;f[ma>>2]=f[ha>>2];f[ma+4>>2]=f[ha+4>>2]}else ka=162}if((ka|0)==162)BR(l,h);ha=h+16|0;f[ea>>2]=f[ha>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ma=f[za>>2]|0;f[ga>>2]=ma;if(ma|0?(ca=ma+12|0,ma=f[ca>>2]|0,f[ca>>2]=ma+-1,(ma|0)==1):0)CR(h);f[za>>2]=0;ma=h+4|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[ma>>2]|0)>0){ha=f[h+40>>2]|0;ca=0;do{f[ha+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[ma>>2]|0))}ma=f[h+44>>2]|0;if((ma|0)!=(h+48|0))ZF(ma);ma=f[k+16>>2]|0;ca=f[U>>2]|0;ha=f[ea>>2]|0;ga=f[Z>>2]|0;da=f[k+12>>2]|0;K=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{Ba=0;break}default:Ba=1}E2(ma,ca,ha,ga,da,K,O,N,Ba);break}case 31:case 21:{if(!(ia&(N|0)==2)){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,22)|0;la=217528;T=S+22|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11056);d$(h)}ea=(d|0)==21?6:5;f[q>>2]=$;f[q+4>>2]=ja;KS(c,q,0,-1,0,0);do if((NS(c)|0)==65536){K=f[aa>>2]|0;f[h>>2]=f[K>>2];da=h+4|0;ga=K+4|0;f[da>>2]=f[ga>>2];ha=h+8|0;f[ha>>2]=f[K+8>>2];f[h+12>>2]=f[K+12>>2];f[h+16>>2]=f[K+16>>2];f[h+20>>2]=f[K+20>>2];f[h+24>>2]=f[K+24>>2];f[h+28>>2]=f[K+28>>2];f[h+32>>2]=f[K+32>>2];ca=h+36|0;ma=f[K+36>>2]|0;f[ca>>2]=ma;f[h+40>>2]=ha;ha=h+48|0;ba=h+44|0;f[ba>>2]=ha;f[ha>>2]=0;f[h+52>>2]=0;if(ma|0){ha=ma+12|0;f[ha>>2]=(f[ha>>2]|0)+1}if((f[ga>>2]|0)<3){ga=f[K+44>>2]|0;ha=f[ba>>2]|0;f[ha>>2]=f[ga>>2];f[ha+4>>2]=f[ga+4>>2];Ca=ca;break}else{f[da>>2]=0;BR(h,K);Ca=ca;break}}else{OR(h,c,-1);Ca=h+36|0}while(0);ca=f[Ca>>2]|0;if(ca|0){K=ca+12|0;f[K>>2]=(f[K>>2]|0)+1}K=l+36|0;ca=f[K>>2]|0;if(ca|0?(da=ca+12|0,ca=f[da>>2]|0,f[da>>2]=ca+-1,(ca|0)==1):0)CR(l);f[K>>2]=0;ca=l+16|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[W>>2]|0)>0){da=f[Y>>2]|0;ga=0;do{f[da+(ga<<2)>>2]=0;ga=ga+1|0;Da=f[W>>2]|0}while((ga|0)<(Da|0));f[l>>2]=f[h>>2];if((Da|0)<3)ka=193;else ka=195}else{f[l>>2]=f[h>>2];ka=193}if((ka|0)==193){ga=f[h+4>>2]|0;if((ga|0)<3){f[W>>2]=ga;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ga=f[h+44>>2]|0;da=f[_>>2]|0;f[da>>2]=f[ga>>2];f[da+4>>2]=f[ga+4>>2]}else ka=195}if((ka|0)==195)BR(l,h);ga=h+16|0;f[ca>>2]=f[ga>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];da=f[Ca>>2]|0;f[K>>2]=da;if(da|0?(ha=da+12|0,da=f[ha>>2]|0,f[ha>>2]=da+-1,(da|0)==1):0)CR(h);f[Ca>>2]=0;da=h+4|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[da>>2]|0)>0){ga=f[h+40>>2]|0;ha=0;do{f[ga+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[da>>2]|0))}da=f[h+44>>2]|0;if((da|0)!=(h+48|0))ZF(da);S2(f[k+16>>2]|0,f[U>>2]|0,f[ca>>2]|0,f[Z>>2]|0,f[k+12>>2]|0,f[Q>>2]|0,ea);break}case 9:case 8:{da=(e|0)<1?((d|0)==9?4:3):e;if(!((da+-3|0)>>>0<2&(M|0)==0)){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,34)|0;la=221307;T=S+34|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11065);d$(h)}f[r>>2]=$;f[r+4>>2]=ja;KS(c,r,O|(da<<3)+-8,-1,0,0);do if((NS(c)|0)==65536){ea=f[aa>>2]|0;f[h>>2]=f[ea>>2];ca=h+4|0;ha=ea+4|0;f[ca>>2]=f[ha>>2];ga=h+8|0;f[ga>>2]=f[ea+8>>2];f[h+12>>2]=f[ea+12>>2];f[h+16>>2]=f[ea+16>>2];f[h+20>>2]=f[ea+20>>2];f[h+24>>2]=f[ea+24>>2];f[h+28>>2]=f[ea+28>>2];f[h+32>>2]=f[ea+32>>2];K=h+36|0;ba=f[ea+36>>2]|0;f[K>>2]=ba;f[h+40>>2]=ga;ga=h+48|0;ma=h+44|0;f[ma>>2]=ga;f[ga>>2]=0;f[h+52>>2]=0;if(ba|0){ga=ba+12|0;f[ga>>2]=(f[ga>>2]|0)+1}if((f[ha>>2]|0)<3){ha=f[ea+44>>2]|0;ga=f[ma>>2]|0;f[ga>>2]=f[ha>>2];f[ga+4>>2]=f[ha+4>>2];Ea=K;break}else{f[ca>>2]=0;BR(h,ea);Ea=K;break}}else{OR(h,c,-1);Ea=h+36|0}while(0);K=f[Ea>>2]|0;if(K|0){ea=K+12|0;f[ea>>2]=(f[ea>>2]|0)+1}ea=l+36|0;K=f[ea>>2]|0;if(K|0?(ca=K+12|0,K=f[ca>>2]|0,f[ca>>2]=K+-1,(K|0)==1):0)CR(l);f[ea>>2]=0;K=l+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[W>>2]|0)>0){ca=f[Y>>2]|0;ha=0;do{f[ca+(ha<<2)>>2]=0;ha=ha+1|0;Fa=f[W>>2]|0}while((ha|0)<(Fa|0));f[l>>2]=f[h>>2];if((Fa|0)<3)ka=224;else ka=226}else{f[l>>2]=f[h>>2];ka=224}if((ka|0)==224){ha=f[h+4>>2]|0;if((ha|0)<3){f[W>>2]=ha;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ha=f[h+44>>2]|0;ca=f[_>>2]|0;f[ca>>2]=f[ha>>2];f[ca+4>>2]=f[ha+4>>2]}else ka=226}if((ka|0)==226)BR(l,h);ha=h+16|0;f[K>>2]=f[ha>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ca=f[Ea>>2]|0;f[ea>>2]=ca;if(ca|0?(ga=ca+12|0,ca=f[ga>>2]|0,f[ga>>2]=ca+-1,(ca|0)==1):0)CR(h);f[Ea>>2]=0;ca=h+4|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[ca>>2]|0)>0){ha=f[h+40>>2]|0;ga=0;do{f[ha+(ga<<2)>>2]=0;ga=ga+1|0}while((ga|0)<(f[ca>>2]|0))}ca=f[h+44>>2]|0;if((ca|0)!=(h+48|0))ZF(ca);L2(f[k+16>>2]|0,f[U>>2]|0,f[K>>2]|0,f[Z>>2]|0,f[k+12>>2]|0,f[Q>>2]|0,O,da);break}case 30:case 20:{if(M|O|0){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,22)|0;la=217551;T=S+22|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11072);d$(h)}da=(d|0)==20?6:5;f[s>>2]=$;f[s+4>>2]=ja;KS(c,s,8,-1,0,0);do if((NS(c)|0)==65536){K=f[aa>>2]|0;f[h>>2]=f[K>>2];ca=h+4|0;ga=K+4|0;f[ca>>2]=f[ga>>2];ha=h+8|0;f[ha>>2]=f[K+8>>2];f[h+12>>2]=f[K+12>>2];f[h+16>>2]=f[K+16>>2];f[h+20>>2]=f[K+20>>2];f[h+24>>2]=f[K+24>>2];f[h+28>>2]=f[K+28>>2];f[h+32>>2]=f[K+32>>2];ea=h+36|0;ma=f[K+36>>2]|0;f[ea>>2]=ma;f[h+40>>2]=ha;ha=h+48|0;ba=h+44|0;f[ba>>2]=ha;f[ha>>2]=0;f[h+52>>2]=0;if(ma|0){ha=ma+12|0;f[ha>>2]=(f[ha>>2]|0)+1}if((f[ga>>2]|0)<3){ga=f[K+44>>2]|0;ha=f[ba>>2]|0;f[ha>>2]=f[ga>>2];f[ha+4>>2]=f[ga+4>>2];Ga=ea;break}else{f[ca>>2]=0;BR(h,K);Ga=ea;break}}else{OR(h,c,-1);Ga=h+36|0}while(0);ea=f[Ga>>2]|0;if(ea|0){K=ea+12|0;f[K>>2]=(f[K>>2]|0)+1}K=l+36|0;ea=f[K>>2]|0;if(ea|0?(ca=ea+12|0,ea=f[ca>>2]|0,f[ca>>2]=ea+-1,(ea|0)==1):0)CR(l);f[K>>2]=0;ea=l+16|0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[W>>2]|0)>0){ca=f[Y>>2]|0;ga=0;do{f[ca+(ga<<2)>>2]=0;ga=ga+1|0;Ha=f[W>>2]|0}while((ga|0)<(Ha|0));f[l>>2]=f[h>>2];if((Ha|0)<3)ka=255;else ka=257}else{f[l>>2]=f[h>>2];ka=255}if((ka|0)==255){ga=f[h+4>>2]|0;if((ga|0)<3){f[W>>2]=ga;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ga=f[h+44>>2]|0;ca=f[_>>2]|0;f[ca>>2]=f[ga>>2];f[ca+4>>2]=f[ga+4>>2]}else ka=257}if((ka|0)==257)BR(l,h);ga=h+16|0;f[ea>>2]=f[ga>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ca=f[Ga>>2]|0;f[K>>2]=ca;if(ca|0?(ha=ca+12|0,ca=f[ha>>2]|0,f[ha>>2]=ca+-1,(ca|0)==1):0)CR(h);f[Ga>>2]=0;ca=h+4|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[ca>>2]|0)>0){ga=f[h+40>>2]|0;ha=0;do{f[ga+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[ca>>2]|0))}ca=f[h+44>>2]|0;if((ca|0)!=(h+48|0))ZF(ca);V2(f[k+16>>2]|0,f[U>>2]|0,f[ea>>2]|0,f[Z>>2]|0,f[k+12>>2]|0,f[Q>>2]|0,da);break}case 83:case 82:case 37:case 36:{if((L&510|0)!=2){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,20)|0;la=217421;T=S+20|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11081);d$(h)}f[t>>2]=$;f[t+4>>2]=ja;KS(c,t,O|16,-1,0,0);do if((NS(c)|0)==65536){da=f[aa>>2]|0;f[h>>2]=f[da>>2];ea=h+4|0;ca=da+4|0;f[ea>>2]=f[ca>>2];ha=h+8|0;f[ha>>2]=f[da+8>>2];f[h+12>>2]=f[da+12>>2];f[h+16>>2]=f[da+16>>2];f[h+20>>2]=f[da+20>>2];f[h+24>>2]=f[da+24>>2];f[h+28>>2]=f[da+28>>2];f[h+32>>2]=f[da+32>>2];ga=h+36|0;K=f[da+36>>2]|0;f[ga>>2]=K;f[h+40>>2]=ha;ha=h+48|0;ba=h+44|0;f[ba>>2]=ha;f[ha>>2]=0;f[h+52>>2]=0;if(K|0){ha=K+12|0;f[ha>>2]=(f[ha>>2]|0)+1}if((f[ca>>2]|0)<3){ca=f[da+44>>2]|0;ha=f[ba>>2]|0;f[ha>>2]=f[ca>>2];f[ha+4>>2]=f[ca+4>>2];Ia=ga;break}else{f[ea>>2]=0;BR(h,da);Ia=ga;break}}else{OR(h,c,-1);Ia=h+36|0}while(0);ga=f[Ia>>2]|0;if(ga|0){da=ga+12|0;f[da>>2]=(f[da>>2]|0)+1}da=l+36|0;ga=f[da>>2]|0;if(ga|0?(ea=ga+12|0,ga=f[ea>>2]|0,f[ea>>2]=ga+-1,(ga|0)==1):0)CR(l);f[da>>2]=0;ga=l+16|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[W>>2]|0)>0){ea=f[Y>>2]|0;ca=0;do{f[ea+(ca<<2)>>2]=0;ca=ca+1|0;Ja=f[W>>2]|0}while((ca|0)<(Ja|0));f[l>>2]=f[h>>2];if((Ja|0)<3)ka=286;else ka=288}else{f[l>>2]=f[h>>2];ka=286}if((ka|0)==286){ca=f[h+4>>2]|0;if((ca|0)<3){f[W>>2]=ca;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ca=f[h+44>>2]|0;ea=f[_>>2]|0;f[ea>>2]=f[ca>>2];f[ea+4>>2]=f[ca+4>>2]}else ka=288}if((ka|0)==288)BR(l,h);ca=h+16|0;f[ga>>2]=f[ca>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ea=f[Ia>>2]|0;f[da>>2]=ea;if(ea|0?(ha=ea+12|0,ea=f[ha>>2]|0,f[ha>>2]=ea+-1,(ea|0)==1):0)CR(h);f[Ia>>2]=0;ea=h+4|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[ea>>2]|0)>0){ca=f[h+40>>2]|0;ha=0;do{f[ca+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[ea>>2]|0))}ea=f[h+44>>2]|0;if((ea|0)!=(h+48|0))ZF(ea);ea=f[k+16>>2]|0;ha=f[U>>2]|0;ca=f[ga>>2]|0;da=f[Z>>2]|0;ba=f[k+12>>2]|0;K=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{Ka=0;break}default:Ka=1}Y2(ea,ha,ca,da,ba,K,O,N,Ka,(d|1|0)==37);break}case 85:case 84:case 39:case 38:{K=(e|0)<1?3:e;if(!((K+-3|0)>>>0<2&(N|0)==3)){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,34)|0;la=217574;T=S+34|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11091);d$(h)}f[v>>2]=$;f[v+4>>2]=ja;KS(c,v,O|(K<<3)+-8,-1,0,0);do if((NS(c)|0)==65536){ga=f[aa>>2]|0;f[h>>2]=f[ga>>2];ba=h+4|0;da=ga+4|0;f[ba>>2]=f[da>>2];ca=h+8|0;f[ca>>2]=f[ga+8>>2];f[h+12>>2]=f[ga+12>>2];f[h+16>>2]=f[ga+16>>2];f[h+20>>2]=f[ga+20>>2];f[h+24>>2]=f[ga+24>>2];f[h+28>>2]=f[ga+28>>2];f[h+32>>2]=f[ga+32>>2];ha=h+36|0;ea=f[ga+36>>2]|0;f[ha>>2]=ea;f[h+40>>2]=ca;ca=h+48|0;ma=h+44|0;f[ma>>2]=ca;f[ca>>2]=0;f[h+52>>2]=0;if(ea|0){ca=ea+12|0;f[ca>>2]=(f[ca>>2]|0)+1}if((f[da>>2]|0)<3){da=f[ga+44>>2]|0;ca=f[ma>>2]|0;f[ca>>2]=f[da>>2];f[ca+4>>2]=f[da+4>>2];La=ha;break}else{f[ba>>2]=0;BR(h,ga);La=ha;break}}else{OR(h,c,-1);La=h+36|0}while(0);ha=f[La>>2]|0;if(ha|0){ga=ha+12|0;f[ga>>2]=(f[ga>>2]|0)+1}ga=l+36|0;ha=f[ga>>2]|0;if(ha|0?(ba=ha+12|0,ha=f[ba>>2]|0,f[ba>>2]=ha+-1,(ha|0)==1):0)CR(l);f[ga>>2]=0;ha=l+16|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[W>>2]|0)>0){ba=f[Y>>2]|0;da=0;do{f[ba+(da<<2)>>2]=0;da=da+1|0;Ma=f[W>>2]|0}while((da|0)<(Ma|0));f[l>>2]=f[h>>2];if((Ma|0)<3)ka=319;else ka=321}else{f[l>>2]=f[h>>2];ka=319}if((ka|0)==319){da=f[h+4>>2]|0;if((da|0)<3){f[W>>2]=da;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];da=f[h+44>>2]|0;ba=f[_>>2]|0;f[ba>>2]=f[da>>2];f[ba+4>>2]=f[da+4>>2]}else ka=321}if((ka|0)==321)BR(l,h);da=h+16|0;f[ha>>2]=f[da>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ba=f[La>>2]|0;f[ga>>2]=ba;if(ba|0?(ca=ba+12|0,ba=f[ca>>2]|0,f[ca>>2]=ba+-1,(ba|0)==1):0)CR(h);f[La>>2]=0;ba=h+4|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[ba>>2]|0)>0){da=f[h+40>>2]|0;ca=0;do{f[da+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[ba>>2]|0))}ba=f[h+44>>2]|0;if((ba|0)!=(h+48|0))ZF(ba);ba=f[k+16>>2]|0;ca=f[U>>2]|0;da=f[ha>>2]|0;ga=f[Z>>2]|0;ma=f[k+12>>2]|0;ea=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{Na=0;break}default:Na=1}f3(ba,ca,da,ga,ma,ea,O,K,Na,(d|1|0)==39);break}case 33:case 32:{if((L&510|0)!=2){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,20)|0;la=217421;T=S+20|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11099);d$(h)}f[w>>2]=$;f[w+4>>2]=ja;KS(c,w,O|16,-1,0,0);do if((NS(c)|0)==65536){K=f[aa>>2]|0;f[h>>2]=f[K>>2];ha=h+4|0;ea=K+4|0;f[ha>>2]=f[ea>>2];ma=h+8|0;f[ma>>2]=f[K+8>>2];f[h+12>>2]=f[K+12>>2];f[h+16>>2]=f[K+16>>2];f[h+20>>2]=f[K+20>>2];f[h+24>>2]=f[K+24>>2];f[h+28>>2]=f[K+28>>2];f[h+32>>2]=f[K+32>>2];ga=h+36|0;da=f[K+36>>2]|0;f[ga>>2]=da;f[h+40>>2]=ma;ma=h+48|0;ca=h+44|0;f[ca>>2]=ma;f[ma>>2]=0;f[h+52>>2]=0;if(da|0){ma=da+12|0;f[ma>>2]=(f[ma>>2]|0)+1}if((f[ea>>2]|0)<3){ea=f[K+44>>2]|0;ma=f[ca>>2]|0;f[ma>>2]=f[ea>>2];f[ma+4>>2]=f[ea+4>>2];Oa=ga;break}else{f[ha>>2]=0;BR(h,K);Oa=ga;break}}else{OR(h,c,-1);Oa=h+36|0}while(0);ga=f[Oa>>2]|0;if(ga|0){K=ga+12|0;f[K>>2]=(f[K>>2]|0)+1}K=l+36|0;ga=f[K>>2]|0;if(ga|0?(ha=ga+12|0,ga=f[ha>>2]|0,f[ha>>2]=ga+-1,(ga|0)==1):0)CR(l);f[K>>2]=0;ga=l+16|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[W>>2]|0)>0){ha=f[Y>>2]|0;ea=0;do{f[ha+(ea<<2)>>2]=0;ea=ea+1|0;Pa=f[W>>2]|0}while((ea|0)<(Pa|0));f[l>>2]=f[h>>2];if((Pa|0)<3)ka=352;else ka=354}else{f[l>>2]=f[h>>2];ka=352}if((ka|0)==352){ea=f[h+4>>2]|0;if((ea|0)<3){f[W>>2]=ea;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ea=f[h+44>>2]|0;ha=f[_>>2]|0;f[ha>>2]=f[ea>>2];f[ha+4>>2]=f[ea+4>>2]}else ka=354}if((ka|0)==354)BR(l,h);ea=h+16|0;f[ga>>2]=f[ea>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ha=f[Oa>>2]|0;f[K>>2]=ha;if(ha|0?(ma=ha+12|0,ha=f[ma>>2]|0,f[ma>>2]=ha+-1,(ha|0)==1):0)CR(h);f[Oa>>2]=0;ha=h+4|0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[ha>>2]|0)>0){ea=f[h+40>>2]|0;ma=0;do{f[ea+(ma<<2)>>2]=0;ma=ma+1|0}while((ma|0)<(f[ha>>2]|0))}ha=f[h+44>>2]|0;if((ha|0)!=(h+48|0))ZF(ha);ha=f[k+16>>2]|0;ma=f[U>>2]|0;ea=f[ga>>2]|0;K=f[Z>>2]|0;ca=f[k+12>>2]|0;da=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{Qa=0;break}default:Qa=1}p3(ha,ma,ea,K,ca,da,O,N,Qa);break}case 35:case 34:{da=(e|0)<1?3:e;if(!((da+-3|0)>>>0<2&(N|0)==3)){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,34)|0;la=217574;T=S+34|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11107);d$(h)}f[x>>2]=$;f[x+4>>2]=ja;KS(c,x,O|(da<<3)+-8,-1,0,0);do if((NS(c)|0)==65536){ga=f[aa>>2]|0;f[h>>2]=f[ga>>2];ca=h+4|0;K=ga+4|0;f[ca>>2]=f[K>>2];ea=h+8|0;f[ea>>2]=f[ga+8>>2];f[h+12>>2]=f[ga+12>>2];f[h+16>>2]=f[ga+16>>2];f[h+20>>2]=f[ga+20>>2];f[h+24>>2]=f[ga+24>>2];f[h+28>>2]=f[ga+28>>2];f[h+32>>2]=f[ga+32>>2];ma=h+36|0;ha=f[ga+36>>2]|0;f[ma>>2]=ha;f[h+40>>2]=ea;ea=h+48|0;ba=h+44|0;f[ba>>2]=ea;f[ea>>2]=0;f[h+52>>2]=0;if(ha|0){ea=ha+12|0;f[ea>>2]=(f[ea>>2]|0)+1}if((f[K>>2]|0)<3){K=f[ga+44>>2]|0;ea=f[ba>>2]|0;f[ea>>2]=f[K>>2];f[ea+4>>2]=f[K+4>>2];Ra=ma;break}else{f[ca>>2]=0;BR(h,ga);Ra=ma;break}}else{OR(h,c,-1);Ra=h+36|0}while(0);ma=f[Ra>>2]|0;if(ma|0){ga=ma+12|0;f[ga>>2]=(f[ga>>2]|0)+1}ga=l+36|0;ma=f[ga>>2]|0;if(ma|0?(ca=ma+12|0,ma=f[ca>>2]|0,f[ca>>2]=ma+-1,(ma|0)==1):0)CR(l);f[ga>>2]=0;ma=l+16|0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[W>>2]|0)>0){ca=f[Y>>2]|0;K=0;do{f[ca+(K<<2)>>2]=0;K=K+1|0;Sa=f[W>>2]|0}while((K|0)<(Sa|0));f[l>>2]=f[h>>2];if((Sa|0)<3)ka=385;else ka=387}else{f[l>>2]=f[h>>2];ka=385}if((ka|0)==385){K=f[h+4>>2]|0;if((K|0)<3){f[W>>2]=K;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];K=f[h+44>>2]|0;ca=f[_>>2]|0;f[ca>>2]=f[K>>2];f[ca+4>>2]=f[K+4>>2]}else ka=387}if((ka|0)==387)BR(l,h);K=h+16|0;f[ma>>2]=f[K>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ca=f[Ra>>2]|0;f[ga>>2]=ca;if(ca|0?(ea=ca+12|0,ca=f[ea>>2]|0,f[ea>>2]=ca+-1,(ca|0)==1):0)CR(h);f[Ra>>2]=0;ca=h+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[ca>>2]|0)>0){K=f[h+40>>2]|0;ea=0;do{f[K+(ea<<2)>>2]=0;ea=ea+1|0}while((ea|0)<(f[ca>>2]|0))}ca=f[h+44>>2]|0;if((ca|0)!=(h+48|0))ZF(ca);ca=f[k+16>>2]|0;ea=f[U>>2]|0;K=f[ma>>2]|0;ga=f[Z>>2]|0;ba=f[k+12>>2]|0;ha=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{Ta=0;break}default:Ta=1}y3(ca,ea,K,ga,ba,ha,O,da,Ta);break}case 69:case 68:case 53:case 52:case 67:case 66:case 41:case 40:{if((L&510|0)==2)switch(fa&7){case 0:case 5:break;default:ka=401}else ka=401;if((ka|0)==401){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,52)|0;la=217609;T=S+52|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11115);d$(h)}f[y>>2]=$;f[y+4>>2]=ja;KS(c,y,O|16,-1,0,0);do if((NS(c)|0)==65536){da=f[aa>>2]|0;f[h>>2]=f[da>>2];ma=h+4|0;ha=da+4|0;f[ma>>2]=f[ha>>2];ba=h+8|0;f[ba>>2]=f[da+8>>2];f[h+12>>2]=f[da+12>>2];f[h+16>>2]=f[da+16>>2];f[h+20>>2]=f[da+20>>2];f[h+24>>2]=f[da+24>>2];f[h+28>>2]=f[da+28>>2];f[h+32>>2]=f[da+32>>2];ga=h+36|0;K=f[da+36>>2]|0;f[ga>>2]=K;f[h+40>>2]=ba;ba=h+48|0;ea=h+44|0;f[ea>>2]=ba;f[ba>>2]=0;f[h+52>>2]=0;if(K|0){ba=K+12|0;f[ba>>2]=(f[ba>>2]|0)+1}if((f[ha>>2]|0)<3){ha=f[da+44>>2]|0;ba=f[ea>>2]|0;f[ba>>2]=f[ha>>2];f[ba+4>>2]=f[ha+4>>2];Ua=ga;break}else{f[ma>>2]=0;BR(h,da);Ua=ga;break}}else{OR(h,c,-1);Ua=h+36|0}while(0);ga=f[Ua>>2]|0;if(ga|0){da=ga+12|0;f[da>>2]=(f[da>>2]|0)+1}da=l+36|0;ga=f[da>>2]|0;if(ga|0?(ma=ga+12|0,ga=f[ma>>2]|0,f[ma>>2]=ga+-1,(ga|0)==1):0)CR(l);f[da>>2]=0;ga=l+16|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[W>>2]|0)>0){ma=f[Y>>2]|0;ha=0;do{f[ma+(ha<<2)>>2]=0;ha=ha+1|0;Va=f[W>>2]|0}while((ha|0)<(Va|0));f[l>>2]=f[h>>2];if((Va|0)<3)ka=419;else ka=421}else{f[l>>2]=f[h>>2];ka=419}if((ka|0)==419){ha=f[h+4>>2]|0;if((ha|0)<3){f[W>>2]=ha;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ha=f[h+44>>2]|0;ma=f[_>>2]|0;f[ma>>2]=f[ha>>2];f[ma+4>>2]=f[ha+4>>2]}else ka=421}if((ka|0)==421)BR(l,h);ha=h+16|0;f[ga>>2]=f[ha>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ma=f[Ua>>2]|0;f[da>>2]=ma;if(ma|0?(ba=ma+12|0,ma=f[ba>>2]|0,f[ba>>2]=ma+-1,(ma|0)==1):0)CR(h);f[Ua>>2]=0;ma=h+4|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[ma>>2]|0)>0){ha=f[h+40>>2]|0;ba=0;do{f[ha+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[ma>>2]|0))}ma=f[h+44>>2]|0;if((ma|0)!=(h+48|0))ZF(ma);ma=f[k+16>>2]|0;ba=f[U>>2]|0;ha=f[ga>>2]|0;da=f[Z>>2]|0;ea=f[k+12>>2]|0;K=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{Wa=0;break}default:Wa=1}ca=d+-40|0;I3(ma,ba,ha,da,ea,K,O,N,Wa,(d+-66|0)>>>0<8,ca>>>0<32&(-872366077>>>ca&1|0)!=0);break}case 73:case 72:case 61:case 60:case 71:case 70:case 55:case 54:{ca=(e|0)<1?3:e;if((ca+-3|0)>>>0<2&(N|0)==3)switch(fa&7){case 0:case 5:break;default:ka=435}else ka=435;if((ka|0)==435){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,64)|0;la=217662;T=S+64|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11125);d$(h)}f[z>>2]=$;f[z+4>>2]=ja;KS(c,z,O|(ca<<3)+-8,-1,0,0);do if((NS(c)|0)==65536){ga=f[aa>>2]|0;f[h>>2]=f[ga>>2];K=h+4|0;ea=ga+4|0;f[K>>2]=f[ea>>2];da=h+8|0;f[da>>2]=f[ga+8>>2];f[h+12>>2]=f[ga+12>>2];f[h+16>>2]=f[ga+16>>2];f[h+20>>2]=f[ga+20>>2];f[h+24>>2]=f[ga+24>>2];f[h+28>>2]=f[ga+28>>2];f[h+32>>2]=f[ga+32>>2];ha=h+36|0;ba=f[ga+36>>2]|0;f[ha>>2]=ba;f[h+40>>2]=da;da=h+48|0;ma=h+44|0;f[ma>>2]=da;f[da>>2]=0;f[h+52>>2]=0;if(ba|0){da=ba+12|0;f[da>>2]=(f[da>>2]|0)+1}if((f[ea>>2]|0)<3){ea=f[ga+44>>2]|0;da=f[ma>>2]|0;f[da>>2]=f[ea>>2];f[da+4>>2]=f[ea+4>>2];Xa=ha;break}else{f[K>>2]=0;BR(h,ga);Xa=ha;break}}else{OR(h,c,-1);Xa=h+36|0}while(0);ha=f[Xa>>2]|0;if(ha|0){ga=ha+12|0;f[ga>>2]=(f[ga>>2]|0)+1}ga=l+36|0;ha=f[ga>>2]|0;if(ha|0?(K=ha+12|0,ha=f[K>>2]|0,f[K>>2]=ha+-1,(ha|0)==1):0)CR(l);f[ga>>2]=0;ha=l+16|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[W>>2]|0)>0){K=f[Y>>2]|0;ea=0;do{f[K+(ea<<2)>>2]=0;ea=ea+1|0;Ya=f[W>>2]|0}while((ea|0)<(Ya|0));f[l>>2]=f[h>>2];if((Ya|0)<3)ka=453;else ka=455}else{f[l>>2]=f[h>>2];ka=453}if((ka|0)==453){ea=f[h+4>>2]|0;if((ea|0)<3){f[W>>2]=ea;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ea=f[h+44>>2]|0;K=f[_>>2]|0;f[K>>2]=f[ea>>2];f[K+4>>2]=f[ea+4>>2]}else ka=455}if((ka|0)==455)BR(l,h);ea=h+16|0;f[ha>>2]=f[ea>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];K=f[Xa>>2]|0;f[ga>>2]=K;if(K|0?(da=K+12|0,K=f[da>>2]|0,f[da>>2]=K+-1,(K|0)==1):0)CR(h);f[Xa>>2]=0;K=h+4|0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[K>>2]|0)>0){ea=f[h+40>>2]|0;da=0;do{f[ea+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[K>>2]|0))}K=f[h+44>>2]|0;if((K|0)!=(h+48|0))ZF(K);K=f[k+16>>2]|0;da=f[U>>2]|0;ea=f[ha>>2]|0;ga=f[Z>>2]|0;ma=f[k+12>>2]|0;ba=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{Za=0;break}default:Za=1}_a=d+-40|0;T3(K,da,ea,ga,ma,ba,O,ca,Za,(d+-66|0)>>>0<8,_a>>>0<32&(-872366077>>>_a&1|0)!=0);break}case 77:case 76:case 51:case 50:case 75:case 74:case 45:case 44:{if((L&510|0)==2)switch(fa&7){case 0:case 5:break;default:ka=469}else ka=469;if((ka|0)==469){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,52)|0;la=217609;T=S+52|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11134);d$(h)}f[A>>2]=$;f[A+4>>2]=ja;KS(c,A,O|16,-1,0,0);do if((NS(c)|0)==65536){ca=f[aa>>2]|0;f[h>>2]=f[ca>>2];ha=h+4|0;_a=ca+4|0;f[ha>>2]=f[_a>>2];ba=h+8|0;f[ba>>2]=f[ca+8>>2];f[h+12>>2]=f[ca+12>>2];f[h+16>>2]=f[ca+16>>2];f[h+20>>2]=f[ca+20>>2];f[h+24>>2]=f[ca+24>>2];f[h+28>>2]=f[ca+28>>2];f[h+32>>2]=f[ca+32>>2];ma=h+36|0;ga=f[ca+36>>2]|0;f[ma>>2]=ga;f[h+40>>2]=ba;ba=h+48|0;ea=h+44|0;f[ea>>2]=ba;f[ba>>2]=0;f[h+52>>2]=0;if(ga|0){ba=ga+12|0;f[ba>>2]=(f[ba>>2]|0)+1}if((f[_a>>2]|0)<3){_a=f[ca+44>>2]|0;ba=f[ea>>2]|0;f[ba>>2]=f[_a>>2];f[ba+4>>2]=f[_a+4>>2];$a=ma;break}else{f[ha>>2]=0;BR(h,ca);$a=ma;break}}else{OR(h,c,-1);$a=h+36|0}while(0);ma=f[$a>>2]|0;if(ma|0){ca=ma+12|0;f[ca>>2]=(f[ca>>2]|0)+1}ca=l+36|0;ma=f[ca>>2]|0;if(ma|0?(ha=ma+12|0,ma=f[ha>>2]|0,f[ha>>2]=ma+-1,(ma|0)==1):0)CR(l);f[ca>>2]=0;ma=l+16|0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[W>>2]|0)>0){ha=f[Y>>2]|0;_a=0;do{f[ha+(_a<<2)>>2]=0;_a=_a+1|0;ab=f[W>>2]|0}while((_a|0)<(ab|0));f[l>>2]=f[h>>2];if((ab|0)<3)ka=487;else ka=489}else{f[l>>2]=f[h>>2];ka=487}if((ka|0)==487){_a=f[h+4>>2]|0;if((_a|0)<3){f[W>>2]=_a;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];_a=f[h+44>>2]|0;ha=f[_>>2]|0;f[ha>>2]=f[_a>>2];f[ha+4>>2]=f[_a+4>>2]}else ka=489}if((ka|0)==489)BR(l,h);_a=h+16|0;f[ma>>2]=f[_a>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ha=f[$a>>2]|0;f[ca>>2]=ha;if(ha|0?(ba=ha+12|0,ha=f[ba>>2]|0,f[ba>>2]=ha+-1,(ha|0)==1):0)CR(h);f[$a>>2]=0;ha=h+4|0;f[_a>>2]=0;f[_a+4>>2]=0;f[_a+8>>2]=0;f[_a+12>>2]=0;if((f[ha>>2]|0)>0){_a=f[h+40>>2]|0;ba=0;do{f[_a+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[ha>>2]|0))}ha=f[h+44>>2]|0;if((ha|0)!=(h+48|0))ZF(ha);ha=f[k+16>>2]|0;ba=f[U>>2]|0;_a=f[ma>>2]|0;ca=f[Z>>2]|0;ea=f[k+12>>2]|0;ga=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{bb=0;break}default:bb=1}switch(d|0){case 75:case 74:case 45:case 44:case 79:case 78:case 57:case 56:{cb=1;break}default:cb=0}da=d+-44|0;if(da>>>0<16)db=((-3901&65535)>>>(da&65535)&1)!=0;else db=0;e4(ha,ba,_a,ca,ea,ga,O,N,bb,cb,db);break}case 81:case 80:case 59:case 58:case 79:case 78:case 57:case 56:{ga=(e|0)<1?3:e;if((ga+-3|0)>>>0<2&(N|0)==3)switch(fa&7){case 0:case 5:break;default:ka=507}else ka=507;if((ka|0)==507){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,64)|0;la=217662;T=S+64|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11144);d$(h)}f[B>>2]=$;f[B+4>>2]=ja;KS(c,B,O|(ga<<3)+-8,-1,0,0);do if((NS(c)|0)==65536){ma=f[aa>>2]|0;f[h>>2]=f[ma>>2];ea=h+4|0;ca=ma+4|0;f[ea>>2]=f[ca>>2];_a=h+8|0;f[_a>>2]=f[ma+8>>2];f[h+12>>2]=f[ma+12>>2];f[h+16>>2]=f[ma+16>>2];f[h+20>>2]=f[ma+20>>2];f[h+24>>2]=f[ma+24>>2];f[h+28>>2]=f[ma+28>>2];f[h+32>>2]=f[ma+32>>2];ba=h+36|0;ha=f[ma+36>>2]|0;f[ba>>2]=ha;f[h+40>>2]=_a;_a=h+48|0;da=h+44|0;f[da>>2]=_a;f[_a>>2]=0;f[h+52>>2]=0;if(ha|0){_a=ha+12|0;f[_a>>2]=(f[_a>>2]|0)+1}if((f[ca>>2]|0)<3){ca=f[ma+44>>2]|0;_a=f[da>>2]|0;f[_a>>2]=f[ca>>2];f[_a+4>>2]=f[ca+4>>2];eb=ba;break}else{f[ea>>2]=0;BR(h,ma);eb=ba;break}}else{OR(h,c,-1);eb=h+36|0}while(0);ba=f[eb>>2]|0;if(ba|0){ma=ba+12|0;f[ma>>2]=(f[ma>>2]|0)+1}ma=l+36|0;ba=f[ma>>2]|0;if(ba|0?(ea=ba+12|0,ba=f[ea>>2]|0,f[ea>>2]=ba+-1,(ba|0)==1):0)CR(l);f[ma>>2]=0;ba=l+16|0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[W>>2]|0)>0){ea=f[Y>>2]|0;ca=0;do{f[ea+(ca<<2)>>2]=0;ca=ca+1|0;fb=f[W>>2]|0}while((ca|0)<(fb|0));f[l>>2]=f[h>>2];if((fb|0)<3)ka=525;else ka=527}else{f[l>>2]=f[h>>2];ka=525}if((ka|0)==525){ca=f[h+4>>2]|0;if((ca|0)<3){f[W>>2]=ca;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ca=f[h+44>>2]|0;ea=f[_>>2]|0;f[ea>>2]=f[ca>>2];f[ea+4>>2]=f[ca+4>>2]}else ka=527}if((ka|0)==527)BR(l,h);ca=h+16|0;f[ba>>2]=f[ca>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ea=f[eb>>2]|0;f[ma>>2]=ea;if(ea|0?(_a=ea+12|0,ea=f[_a>>2]|0,f[_a>>2]=ea+-1,(ea|0)==1):0)CR(h);f[eb>>2]=0;ea=h+4|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[ea>>2]|0)>0){ca=f[h+40>>2]|0;_a=0;do{f[ca+(_a<<2)>>2]=0;_a=_a+1|0}while((_a|0)<(f[ea>>2]|0))}ea=f[h+44>>2]|0;if((ea|0)!=(h+48|0))ZF(ea);ea=f[k+16>>2]|0;_a=f[U>>2]|0;ca=f[ba>>2]|0;ma=f[Z>>2]|0;da=f[k+12>>2]|0;ha=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{gb=0;break}default:gb=1}switch(d|0){case 75:case 74:case 45:case 44:case 79:case 78:case 57:case 56:{hb=1;break}default:hb=0}K=d+-44|0;if(K>>>0<16)ib=((-3901&65535)>>>(K&65535)&1)!=0;else ib=0;B4(ea,_a,ca,ma,da,ha,O,ga,gb,hb,ib);break}case 142:case 141:case 140:case 139:case 138:case 137:case 136:case 135:case 65:case 64:case 63:case 62:case 49:case 48:case 47:case 46:case 89:case 88:case 87:case 86:{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=k;B7(h,c,d,e);break}case 94:case 95:case 96:case 97:case 90:case 91:case 92:case 93:{ha=(e|0)<1?((d+-94|0)>>>0<4?4:3):e;da=d+-92|0;if(da>>>0<6)jb=51>>>(da&63)&63;else jb=0;da=jb&1;if((ha+-3|0)>>>0>=2){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,20)|0;la=217727;T=S+20|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11165);d$(h)}if(!(($&1|0)==0?!((ja|0)%3|0|O|0):0)){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,53)|0;la=217748;T=S+53|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11166);d$(h)}f[C>>2]=$;f[C+4>>2]=(ja<<1|0)/3|0;KS(c,C,O|(ha<<3)+-8,-1,0,0);do if((NS(c)|0)==65536){ga=f[aa>>2]|0;f[h>>2]=f[ga>>2];ba=h+4|0;ma=ga+4|0;f[ba>>2]=f[ma>>2];ca=h+8|0;f[ca>>2]=f[ga+8>>2];f[h+12>>2]=f[ga+12>>2];f[h+16>>2]=f[ga+16>>2];f[h+20>>2]=f[ga+20>>2];f[h+24>>2]=f[ga+24>>2];f[h+28>>2]=f[ga+28>>2];f[h+32>>2]=f[ga+32>>2];_a=h+36|0;ea=f[ga+36>>2]|0;f[_a>>2]=ea;f[h+40>>2]=ca;ca=h+48|0;K=h+44|0;f[K>>2]=ca;f[ca>>2]=0;f[h+52>>2]=0;if(ea|0){ca=ea+12|0;f[ca>>2]=(f[ca>>2]|0)+1}if((f[ma>>2]|0)<3){ma=f[ga+44>>2]|0;ca=f[K>>2]|0;f[ca>>2]=f[ma>>2];f[ca+4>>2]=f[ma+4>>2];kb=_a;break}else{f[ba>>2]=0;BR(h,ga);kb=_a;break}}else{OR(h,c,-1);kb=h+36|0}while(0);_a=f[kb>>2]|0;if(_a|0){ga=_a+12|0;f[ga>>2]=(f[ga>>2]|0)+1}ga=l+36|0;_a=f[ga>>2]|0;if(_a|0?(ba=_a+12|0,_a=f[ba>>2]|0,f[ba>>2]=_a+-1,(_a|0)==1):0)CR(l);f[ga>>2]=0;_a=l+16|0;f[_a>>2]=0;f[_a+4>>2]=0;f[_a+8>>2]=0;f[_a+12>>2]=0;if((f[W>>2]|0)>0){ba=f[Y>>2]|0;ma=0;do{f[ba+(ma<<2)>>2]=0;ma=ma+1|0;lb=f[W>>2]|0}while((ma|0)<(lb|0));f[l>>2]=f[h>>2];if((lb|0)<3)ka=568;else ka=570}else{f[l>>2]=f[h>>2];ka=568}if((ka|0)==568){ma=f[h+4>>2]|0;if((ma|0)<3){f[W>>2]=ma;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ma=f[h+44>>2]|0;ba=f[_>>2]|0;f[ba>>2]=f[ma>>2];f[ba+4>>2]=f[ma+4>>2]}else ka=570}if((ka|0)==570)BR(l,h);ma=h+16|0;f[_a>>2]=f[ma>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ba=f[kb>>2]|0;f[ga>>2]=ba;if(ba|0?(ca=ba+12|0,ba=f[ca>>2]|0,f[ca>>2]=ba+-1,(ba|0)==1):0)CR(h);f[kb>>2]=0;ba=h+4|0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[ba>>2]|0)>0){ma=f[h+40>>2]|0;ca=0;do{f[ma+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[ba>>2]|0))}ba=f[h+44>>2]|0;if((ba|0)!=(h+48|0))ZF(ba);ba=f[k+16>>2]|0;ca=f[U>>2]|0;ma=f[_a>>2]|0;ga=f[Z>>2]|0;K=f[l+12>>2]|0;ea=f[X>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{mb=0;break}default:mb=1}V4(ba,ca,ma,ga,K,ea,ha,mb,da);break}case 104:case 105:case 100:case 101:case 102:case 103:case 98:case 99:{ea=(e|0)<1?((d+-102|0)>>>0<4?4:3):e;K=d+-98|0;if(K>>>0<6)nb=51>>>(K&63)&63;else nb=0;K=nb&1;if((ea+-3|0)>>>0>=2){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,20)|0;la=217727;T=S+20|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11178);d$(h)}if(!(($&1|0)==0?!((ja|0)%3|0|O|0):0)){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,53)|0;la=217748;T=S+53|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11179);d$(h)}f[D>>2]=$;f[D+4>>2]=(ja<<1|0)/3|0;KS(c,D,O|(ea<<3)+-8,-1,0,0);do if((NS(c)|0)==65536){da=f[aa>>2]|0;f[h>>2]=f[da>>2];ha=h+4|0;_a=da+4|0;f[ha>>2]=f[_a>>2];ga=h+8|0;f[ga>>2]=f[da+8>>2];f[h+12>>2]=f[da+12>>2];f[h+16>>2]=f[da+16>>2];f[h+20>>2]=f[da+20>>2];f[h+24>>2]=f[da+24>>2];f[h+28>>2]=f[da+28>>2];f[h+32>>2]=f[da+32>>2];ma=h+36|0;ca=f[da+36>>2]|0;f[ma>>2]=ca;f[h+40>>2]=ga;ga=h+48|0;ba=h+44|0;f[ba>>2]=ga;f[ga>>2]=0;f[h+52>>2]=0;if(ca|0){ga=ca+12|0;f[ga>>2]=(f[ga>>2]|0)+1}if((f[_a>>2]|0)<3){_a=f[da+44>>2]|0;ga=f[ba>>2]|0;f[ga>>2]=f[_a>>2];f[ga+4>>2]=f[_a+4>>2];ob=ma;break}else{f[ha>>2]=0;BR(h,da);ob=ma;break}}else{OR(h,c,-1);ob=h+36|0}while(0);ma=f[ob>>2]|0;if(ma|0){da=ma+12|0;f[da>>2]=(f[da>>2]|0)+1}da=l+36|0;ma=f[da>>2]|0;if(ma|0?(ha=ma+12|0,ma=f[ha>>2]|0,f[ha>>2]=ma+-1,(ma|0)==1):0)CR(l);f[da>>2]=0;ma=l+16|0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[W>>2]|0)>0){ha=f[Y>>2]|0;_a=0;do{f[ha+(_a<<2)>>2]=0;_a=_a+1|0;pb=f[W>>2]|0}while((_a|0)<(pb|0));f[l>>2]=f[h>>2];if((pb|0)<3)ka=606;else ka=608}else{f[l>>2]=f[h>>2];ka=606}if((ka|0)==606){_a=f[h+4>>2]|0;if((_a|0)<3){f[W>>2]=_a;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];_a=f[h+44>>2]|0;ha=f[_>>2]|0;f[ha>>2]=f[_a>>2];f[ha+4>>2]=f[_a+4>>2]}else ka=608}if((ka|0)==608)BR(l,h);_a=h+16|0;f[ma>>2]=f[_a>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ha=f[ob>>2]|0;f[da>>2]=ha;if(ha|0?(ga=ha+12|0,ha=f[ga>>2]|0,f[ga>>2]=ha+-1,(ha|0)==1):0)CR(h);f[ob>>2]=0;ha=h+4|0;f[_a>>2]=0;f[_a+4>>2]=0;f[_a+8>>2]=0;f[_a+12>>2]=0;if((f[ha>>2]|0)>0){_a=f[h+40>>2]|0;ga=0;do{f[_a+(ga<<2)>>2]=0;ga=ga+1|0}while((ga|0)<(f[ha>>2]|0))}ha=f[h+44>>2]|0;if((ha|0)!=(h+48|0))ZF(ha);ha=f[k+16>>2]|0;ga=f[U>>2]|0;_a=f[ma>>2]|0;da=f[Z>>2]|0;ba=f[l+12>>2]|0;ca=f[X>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{qb=0;break}default:qb=1}k5(ha,ga,_a,da,ba,ca,ea,qb,K);break}case 106:{ca=(e|0)>1?e:1;if((e|0)>=2){f[h>>2]=0;f[h+4>>2]=0;ba=c$(h,8)|0;da=ba;b[da>>0]=100;b[da+1>>0]=99;b[da+2>>0]=110;b[da+3>>0]=32;da=ba+4|0;b[da>>0]=61;b[da+1>>0]=61;b[da+2>>0]=32;b[da+3>>0]=49;j$(-215,h,217412,206245,11190);d$(h)}if(!(($&1|0)==0?!((ja|0)%3|0|O|0):0)){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,53)|0;la=217748;T=S+53|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11191);d$(h)}K=(ja<<1|0)/3|0;f[E>>2]=$;f[E+4>>2]=K;KS(c,E,O|(ca<<3)+-8,-1,0,0);do if((NS(c)|0)==65536){ea=f[aa>>2]|0;f[h>>2]=f[ea>>2];ma=h+4|0;da=ea+4|0;f[ma>>2]=f[da>>2];ba=h+8|0;f[ba>>2]=f[ea+8>>2];f[h+12>>2]=f[ea+12>>2];f[h+16>>2]=f[ea+16>>2];f[h+20>>2]=f[ea+20>>2];f[h+24>>2]=f[ea+24>>2];f[h+28>>2]=f[ea+28>>2];f[h+32>>2]=f[ea+32>>2];_a=h+36|0;ga=f[ea+36>>2]|0;f[_a>>2]=ga;f[h+40>>2]=ba;ba=h+48|0;ha=h+44|0;f[ha>>2]=ba;f[ba>>2]=0;f[h+52>>2]=0;if(ga|0){ba=ga+12|0;f[ba>>2]=(f[ba>>2]|0)+1}if((f[da>>2]|0)<3){da=f[ea+44>>2]|0;ba=f[ha>>2]|0;f[ba>>2]=f[da>>2];f[ba+4>>2]=f[da+4>>2];rb=_a;break}else{f[ma>>2]=0;BR(h,ea);rb=_a;break}}else{OR(h,c,-1);rb=h+36|0}while(0);ca=f[rb>>2]|0;if(ca|0){_a=ca+12|0;f[_a>>2]=(f[_a>>2]|0)+1}_a=l+36|0;ca=f[_a>>2]|0;if(ca|0?(ea=ca+12|0,ca=f[ea>>2]|0,f[ea>>2]=ca+-1,(ca|0)==1):0)CR(l);f[_a>>2]=0;ca=l+16|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[W>>2]|0)>0){ea=f[Y>>2]|0;ma=0;do{f[ea+(ma<<2)>>2]=0;ma=ma+1|0;sb=f[W>>2]|0}while((ma|0)<(sb|0));f[l>>2]=f[h>>2];if((sb|0)<3)ka=642;else ka=644}else{f[l>>2]=f[h>>2];ka=642}if((ka|0)==642){ma=f[h+4>>2]|0;if((ma|0)<3){f[W>>2]=ma;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ma=f[h+44>>2]|0;ea=f[_>>2]|0;f[ea>>2]=f[ma>>2];f[ea+4>>2]=f[ma+4>>2]}else ka=644}if((ka|0)==644)BR(l,h);ma=h+16|0;f[ca>>2]=f[ma>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ea=f[rb>>2]|0;f[_a>>2]=ea;if(ea|0?(da=ea+12|0,ea=f[da>>2]|0,f[da>>2]=ea+-1,(ea|0)==1):0)CR(h);f[rb>>2]=0;ea=h+4|0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[ea>>2]|0)>0){ma=f[h+40>>2]|0;da=0;do{f[ma+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[ea>>2]|0))}ea=f[h+44>>2]|0;if((ea|0)!=(h+48|0))ZF(ea);f[h>>2]=-2147483648;f[h+4>>2]=2147483647;f[i>>2]=0;f[i+4>>2]=K;DR(F,k,i,h);ea=h+8|0;f[ea>>2]=0;f[ea+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=l;eL(F,h);ea=F+36|0;da=f[ea>>2]|0;if(da|0?(ma=da+12|0,da=f[ma>>2]|0,f[ma>>2]=da+-1,(da|0)==1):0)CR(F);f[ea>>2]=0;ea=F+16|0;da=F+4|0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[da>>2]|0)>0){ea=f[F+40>>2]|0;ma=0;do{f[ea+(ma<<2)>>2]=0;ma=ma+1|0}while((ma|0)<(f[da>>2]|0))}da=f[F+44>>2]|0;if((da|0)!=(F+48|0))ZF(da);break}case 130:case 129:case 128:case 127:case 134:case 133:case 132:case 131:{da=(e|0)>1?e:1;ma=(d+-127|0)>>>0<4?1:2;if(!(ia&(L&510|0)==2)){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,36)|0;la=217442;T=S+36|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11210);d$(h)}if((e|0)>=2){f[h>>2]=0;f[h+4>>2]=0;ea=c$(h,8)|0;K=ea;b[K>>0]=100;b[K+1>>0]=99;b[K+2>>0]=110;b[K+3>>0]=32;K=ea+4|0;b[K>>0]=61;b[K+1>>0]=61;b[K+2>>0]=32;b[K+3>>0]=49;j$(-215,h,217412,206245,11211);d$(h)}if((ja|$)&1|0){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,39)|0;la=217802;T=S+39|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11212);d$(h)}f[G>>2]=$;f[G+4>>2]=((ja|0)/2|0)*3;KS(c,G,O|(da<<3)+-8,-1,0,0);do if((NS(c)|0)==65536){K=f[aa>>2]|0;f[h>>2]=f[K>>2];ea=h+4|0;_a=K+4|0;f[ea>>2]=f[_a>>2];ca=h+8|0;f[ca>>2]=f[K+8>>2];f[h+12>>2]=f[K+12>>2];f[h+16>>2]=f[K+16>>2];f[h+20>>2]=f[K+20>>2];f[h+24>>2]=f[K+24>>2];f[h+28>>2]=f[K+28>>2];f[h+32>>2]=f[K+32>>2];ba=h+36|0;ha=f[K+36>>2]|0;f[ba>>2]=ha;f[h+40>>2]=ca;ca=h+48|0;ga=h+44|0;f[ga>>2]=ca;f[ca>>2]=0;f[h+52>>2]=0;if(ha|0){ca=ha+12|0;f[ca>>2]=(f[ca>>2]|0)+1}if((f[_a>>2]|0)<3){_a=f[K+44>>2]|0;ca=f[ga>>2]|0;f[ca>>2]=f[_a>>2];f[ca+4>>2]=f[_a+4>>2];tb=ba;break}else{f[ea>>2]=0;BR(h,K);tb=ba;break}}else{OR(h,c,-1);tb=h+36|0}while(0);da=f[tb>>2]|0;if(da|0){ba=da+12|0;f[ba>>2]=(f[ba>>2]|0)+1}ba=l+36|0;da=f[ba>>2]|0;if(da|0?(K=da+12|0,da=f[K>>2]|0,f[K>>2]=da+-1,(da|0)==1):0)CR(l);f[ba>>2]=0;da=l+16|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[W>>2]|0)>0){K=f[Y>>2]|0;ea=0;do{f[K+(ea<<2)>>2]=0;ea=ea+1|0;ub=f[W>>2]|0}while((ea|0)<(ub|0));f[l>>2]=f[h>>2];if((ub|0)<3)ka=684;else ka=686}else{f[l>>2]=f[h>>2];ka=684}if((ka|0)==684){ea=f[h+4>>2]|0;if((ea|0)<3){f[W>>2]=ea;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ea=f[h+44>>2]|0;K=f[_>>2]|0;f[K>>2]=f[ea>>2];f[K+4>>2]=f[ea+4>>2]}else ka=686}if((ka|0)==686)BR(l,h);ea=h+16|0;f[da>>2]=f[ea>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];K=f[tb>>2]|0;f[ba>>2]=K;if(K|0?(_a=K+12|0,K=f[_a>>2]|0,f[_a>>2]=K+-1,(K|0)==1):0)CR(h);f[tb>>2]=0;K=h+4|0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[K>>2]|0)>0){ea=f[h+40>>2]|0;_a=0;do{f[ea+(_a<<2)>>2]=0;_a=_a+1|0}while((_a|0)<(f[K>>2]|0))}K=f[h+44>>2]|0;if((K|0)!=(h+48|0))ZF(K);K=f[k+16>>2]|0;_a=f[U>>2]|0;ea=f[da>>2]|0;ba=f[Z>>2]|0;ca=f[k+12>>2]|0;ga=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{vb=0;break}default:vb=1}t5(K,_a,ea,ba,ca,ga,N,vb,ma);break}case 122:case 121:case 120:case 119:case 118:case 117:case 116:case 115:case 112:case 111:case 108:case 107:{if((e|0)<1){ga=d+-111|0;if(ga>>>0<12)wb=(3843>>>(ga&4095)&1)+3&4095;else wb=3}else wb=e;ga=d+-107|0;if(ga>>>0<6)xb=51>>>(ga&63)&63;else xb=0;ga=xb&1;ca=d+-117|0;if(ca>>>0<6)yb=51>>>(ca&63)&63;else yb=0;ca=yb&1;if((wb+-3|0)>>>0>=2){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,20)|0;la=217727;T=S+20|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11227);d$(h)}if(!(ia&(N|0)==2)){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,22)|0;la=217528;T=S+22|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11228);d$(h)}f[H>>2]=$;f[H+4>>2]=ja;KS(c,H,(wb<<3)+-8|0,-1,0,0);do if((NS(c)|0)==65536){ma=f[aa>>2]|0;f[h>>2]=f[ma>>2];da=h+4|0;ba=ma+4|0;f[da>>2]=f[ba>>2];ea=h+8|0;f[ea>>2]=f[ma+8>>2];f[h+12>>2]=f[ma+12>>2];f[h+16>>2]=f[ma+16>>2];f[h+20>>2]=f[ma+20>>2];f[h+24>>2]=f[ma+24>>2];f[h+28>>2]=f[ma+28>>2];f[h+32>>2]=f[ma+32>>2];_a=h+36|0;K=f[ma+36>>2]|0;f[_a>>2]=K;f[h+40>>2]=ea;ea=h+48|0;ha=h+44|0;f[ha>>2]=ea;f[ea>>2]=0;f[h+52>>2]=0;if(K|0){ea=K+12|0;f[ea>>2]=(f[ea>>2]|0)+1}if((f[ba>>2]|0)<3){ba=f[ma+44>>2]|0;ea=f[ha>>2]|0;f[ea>>2]=f[ba>>2];f[ea+4>>2]=f[ba+4>>2];zb=_a;break}else{f[da>>2]=0;BR(h,ma);zb=_a;break}}else{OR(h,c,-1);zb=h+36|0}while(0);_a=f[zb>>2]|0;if(_a|0){ma=_a+12|0;f[ma>>2]=(f[ma>>2]|0)+1}ma=l+36|0;_a=f[ma>>2]|0;if(_a|0?(da=_a+12|0,_a=f[da>>2]|0,f[da>>2]=_a+-1,(_a|0)==1):0)CR(l);f[ma>>2]=0;_a=l+16|0;f[_a>>2]=0;f[_a+4>>2]=0;f[_a+8>>2]=0;f[_a+12>>2]=0;if((f[W>>2]|0)>0){da=f[Y>>2]|0;ba=0;do{f[da+(ba<<2)>>2]=0;ba=ba+1|0;Ab=f[W>>2]|0}while((ba|0)<(Ab|0));f[l>>2]=f[h>>2];if((Ab|0)<3)ka=726;else ka=728}else{f[l>>2]=f[h>>2];ka=726}if((ka|0)==726){ba=f[h+4>>2]|0;if((ba|0)<3){f[W>>2]=ba;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ba=f[h+44>>2]|0;da=f[_>>2]|0;f[da>>2]=f[ba>>2];f[da+4>>2]=f[ba+4>>2]}else ka=728}if((ka|0)==728)BR(l,h);ba=h+16|0;f[_a>>2]=f[ba>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];da=f[zb>>2]|0;f[ma>>2]=da;if(da|0?(ea=da+12|0,da=f[ea>>2]|0,f[ea>>2]=da+-1,(da|0)==1):0)CR(h);f[zb>>2]=0;da=h+4|0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[da>>2]|0)>0){ba=f[h+40>>2]|0;ea=0;do{f[ba+(ea<<2)>>2]=0;ea=ea+1|0}while((ea|0)<(f[da>>2]|0))}da=f[h+44>>2]|0;if((da|0)!=(h+48|0))ZF(da);da=f[k+16>>2]|0;ea=f[U>>2]|0;ba=f[_a>>2]|0;ma=f[Z>>2]|0;ha=f[k+12>>2]|0;K=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{Bb=0;break}default:Bb=1}C5(da,ea,ba,ma,ha,K,wb,Bb,ca,ga);break}case 124:case 123:{if((e|0)>=2){f[h>>2]=0;f[h+4>>2]=0;K=c$(h,8)|0;ha=K;b[ha>>0]=100;b[ha+1>>0]=99;b[ha+2>>0]=110;b[ha+3>>0]=32;ha=K+4|0;b[ha>>0]=61;b[ha+1>>0]=61;b[ha+2>>0]=32;b[ha+3>>0]=49;j$(-215,h,217412,206245,11238);d$(h)}if(!(ia&(N|0)==2)){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,22)|0;la=217528;T=S+22|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11239);d$(h)}ga=k+36|0;ca=f[ga>>2]|0;if(ca|0?(_a=ca+12|0,ca=f[_a>>2]|0,f[_a>>2]=ca+-1,(ca|0)==1):0)CR(k);f[ga>>2]=0;ga=k+16|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[P>>2]|0)>0){ga=f[R>>2]|0;ca=0;do{f[ga+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[P>>2]|0))}TI(a,c,(d|0)==123&1);break}case 125:{ca=(e|0)<1?4:e;if(!(ia&((ca|0)==4&(N|0)==4))){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,34)|0;la=217842;T=S+34|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11247);d$(h)}f[I>>2]=$;f[I+4>>2]=ja;KS(c,I,O|(ca<<3)+-8,-1,0,0);do if((NS(c)|0)==65536){ga=f[aa>>2]|0;f[h>>2]=f[ga>>2];_a=h+4|0;ha=ga+4|0;f[_a>>2]=f[ha>>2];K=h+8|0;f[K>>2]=f[ga+8>>2];f[h+12>>2]=f[ga+12>>2];f[h+16>>2]=f[ga+16>>2];f[h+20>>2]=f[ga+20>>2];f[h+24>>2]=f[ga+24>>2];f[h+28>>2]=f[ga+28>>2];f[h+32>>2]=f[ga+32>>2];ma=h+36|0;ba=f[ga+36>>2]|0;f[ma>>2]=ba;f[h+40>>2]=K;K=h+48|0;ea=h+44|0;f[ea>>2]=K;f[K>>2]=0;f[h+52>>2]=0;if(ba|0){K=ba+12|0;f[K>>2]=(f[K>>2]|0)+1}if((f[ha>>2]|0)<3){ha=f[ga+44>>2]|0;K=f[ea>>2]|0;f[K>>2]=f[ha>>2];f[K+4>>2]=f[ha+4>>2];Cb=ma;break}else{f[_a>>2]=0;BR(h,ga);Cb=ma;break}}else{OR(h,c,-1);Cb=h+36|0}while(0);ca=f[Cb>>2]|0;if(ca|0){ma=ca+12|0;f[ma>>2]=(f[ma>>2]|0)+1}ma=l+36|0;ca=f[ma>>2]|0;if(ca|0?(ga=ca+12|0,ca=f[ga>>2]|0,f[ga>>2]=ca+-1,(ca|0)==1):0)CR(l);f[ma>>2]=0;ca=l+16|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[W>>2]|0)>0){ga=f[Y>>2]|0;_a=0;do{f[ga+(_a<<2)>>2]=0;_a=_a+1|0;Db=f[W>>2]|0}while((_a|0)<(Db|0));f[l>>2]=f[h>>2];if((Db|0)<3)ka=770;else ka=772}else{f[l>>2]=f[h>>2];ka=770}if((ka|0)==770){_a=f[h+4>>2]|0;if((_a|0)<3){f[W>>2]=_a;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];_a=f[h+44>>2]|0;ga=f[_>>2]|0;f[ga>>2]=f[_a>>2];f[ga+4>>2]=f[_a+4>>2]}else ka=772}if((ka|0)==772)BR(l,h);_a=h+16|0;f[ca>>2]=f[_a>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ga=f[Cb>>2]|0;f[ma>>2]=ga;if(ga|0?(ha=ga+12|0,ga=f[ha>>2]|0,f[ha>>2]=ga+-1,(ga|0)==1):0)CR(h);f[Cb>>2]=0;ga=h+4|0;f[_a>>2]=0;f[_a+4>>2]=0;f[_a+8>>2]=0;f[_a+12>>2]=0;if((f[ga>>2]|0)>0){_a=f[h+40>>2]|0;ha=0;do{f[_a+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[ga>>2]|0))}ga=f[h+44>>2]|0;if((ga|0)!=(h+48|0))ZF(ga);$5(f[k+16>>2]|0,f[U>>2]|0,f[ca>>2]|0,f[Z>>2]|0,f[k+12>>2]|0,f[Q>>2]|0);break}case 126:{ga=(e|0)<1?4:e;if(!(ia&((ga|0)==4&(N|0)==4))){f[h>>2]=0;f[h+4>>2]=0;S=c$(h,34)|0;la=217842;T=S+34|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-215,h,217412,206245,11254);d$(h)}f[J>>2]=$;f[J+4>>2]=ja;KS(c,J,O|(ga<<3)+-8,-1,0,0);do if((NS(c)|0)==65536){ca=f[aa>>2]|0;f[h>>2]=f[ca>>2];ha=h+4|0;_a=ca+4|0;f[ha>>2]=f[_a>>2];ma=h+8|0;f[ma>>2]=f[ca+8>>2];f[h+12>>2]=f[ca+12>>2];f[h+16>>2]=f[ca+16>>2];f[h+20>>2]=f[ca+20>>2];f[h+24>>2]=f[ca+24>>2];f[h+28>>2]=f[ca+28>>2];f[h+32>>2]=f[ca+32>>2];K=h+36|0;ea=f[ca+36>>2]|0;f[K>>2]=ea;f[h+40>>2]=ma;ma=h+48|0;ba=h+44|0;f[ba>>2]=ma;f[ma>>2]=0;f[h+52>>2]=0;if(ea|0){ma=ea+12|0;f[ma>>2]=(f[ma>>2]|0)+1}if((f[_a>>2]|0)<3){_a=f[ca+44>>2]|0;ma=f[ba>>2]|0;f[ma>>2]=f[_a>>2];f[ma+4>>2]=f[_a+4>>2];Eb=K;break}else{f[ha>>2]=0;BR(h,ca);Eb=K;break}}else{OR(h,c,-1);Eb=h+36|0}while(0);ga=f[Eb>>2]|0;if(ga|0){K=ga+12|0;f[K>>2]=(f[K>>2]|0)+1}K=l+36|0;ga=f[K>>2]|0;if(ga|0?(ca=ga+12|0,ga=f[ca>>2]|0,f[ca>>2]=ga+-1,(ga|0)==1):0)CR(l);f[K>>2]=0;ga=l+16|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[W>>2]|0)>0){ca=f[Y>>2]|0;ha=0;do{f[ca+(ha<<2)>>2]=0;ha=ha+1|0;Fb=f[W>>2]|0}while((ha|0)<(Fb|0));f[l>>2]=f[h>>2];if((Fb|0)<3)ka=801;else ka=803}else{f[l>>2]=f[h>>2];ka=801}if((ka|0)==801){ha=f[h+4>>2]|0;if((ha|0)<3){f[W>>2]=ha;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ha=f[h+44>>2]|0;ca=f[_>>2]|0;f[ca>>2]=f[ha>>2];f[ca+4>>2]=f[ha+4>>2]}else ka=803}if((ka|0)==803)BR(l,h);ha=h+16|0;f[ga>>2]=f[ha>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ca=f[Eb>>2]|0;f[K>>2]=ca;if(ca|0?(_a=ca+12|0,ca=f[_a>>2]|0,f[_a>>2]=ca+-1,(ca|0)==1):0)CR(h);f[Eb>>2]=0;ca=h+4|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[ca>>2]|0)>0){ha=f[h+40>>2]|0;_a=0;do{f[ha+(_a<<2)>>2]=0;_a=_a+1|0}while((_a|0)<(f[ca>>2]|0))}ca=f[h+44>>2]|0;if((ca|0)!=(h+48|0))ZF(ca);c6(f[k+16>>2]|0,f[U>>2]|0,f[ga>>2]|0,f[Z>>2]|0,f[k+12>>2]|0,f[Q>>2]|0);break}default:{f[h>>2]=0;f[h+4>>2]=0;S=c$(h,41)|0;la=215114;T=S+41|0;do{b[S>>0]=b[la>>0]|0;S=S+1|0;la=la+1|0}while((S|0)<(T|0));j$(-206,h,217412,206245,11260);d$(h)}}while(0);h=l+36|0;la=f[h>>2]|0;if(la|0?(S=la+12|0,la=f[S>>2]|0,f[S>>2]=la+-1,(la|0)==1):0)CR(l);f[h>>2]=0;h=l+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[W>>2]|0)>0){h=f[Y>>2]|0;Y=0;do{f[h+(Y<<2)>>2]=0;Y=Y+1|0}while((Y|0)<(f[W>>2]|0))}W=f[_>>2]|0;if((W|0)!=(Z|0))ZF(W);W=k+36|0;Z=f[W>>2]|0;if(Z|0?(_=Z+12|0,Z=f[_>>2]|0,f[_>>2]=Z+-1,(Z|0)==1):0)CR(k);f[W>>2]=0;W=k+16|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[P>>2]|0)>0){W=f[R>>2]|0;R=0;do{f[W+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[P>>2]|0))}P=f[V>>2]|0;if((P|0)!=(U|0))ZF(P);if(!(f[j+4>>2]|0)){u=g;return}u=g;return}function g6(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+208|0;g=e+144|0;h=e+88|0;i=e+32|0;j=e+16|0;k=e;JR(g,a,0,1,0,0);JR(h,c,0,1,0,0);f[i>>2]=f[h>>2];c=i+4|0;a=h+4|0;l=f[a>>2]|0;f[c>>2]=l;m=i+8|0;f[m>>2]=f[h+8>>2];f[i+12>>2]=f[h+12>>2];n=i+16|0;o=h+16|0;f[n>>2]=f[o>>2];f[i+20>>2]=f[h+20>>2];f[i+24>>2]=f[h+24>>2];f[i+28>>2]=f[h+28>>2];f[i+32>>2]=f[h+32>>2];p=i+36|0;q=h+36|0;r=f[q>>2]|0;f[p>>2]=r;s=i+40|0;f[s>>2]=m;m=i+48|0;t=i+44|0;f[t>>2]=m;f[m>>2]=0;f[i+52>>2]=0;if(!r)v=l;else{l=r+12|0;f[l>>2]=(f[l>>2]|0)+1;v=f[a>>2]|0}if((v|0)<3){v=f[h+44>>2]|0;l=f[t>>2]|0;f[l>>2]=f[v>>2];f[l+4>>2]=f[v+4>>2]}else{f[c>>2]=0;BR(i,h)}v=f[i>>2]|0;if(!((v^f[g>>2])&7))w=v;else{f[j>>2]=0;f[j+4>>2]=0;x=c$(j,26)|0;y=217930;z=x+26|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));j$(-215,j,217957,206245,11268);d$(j);w=f[i>>2]|0}f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=g;v=k+8|0;f[v>>2]=0;f[v+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=i;f6(j,k,d,(w>>>3&511)+1|0);if((f[n>>2]|0)!=(f[o>>2]|0)){f[j>>2]=0;f[j+4>>2]=0;x=c$(j,21)|0;y=217968;z=x+21|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));j$(-215,j,217957,206245,11271);d$(j)}j=f[p>>2]|0;if(j|0?(y=j+12|0,j=f[y>>2]|0,f[y>>2]=j+-1,(j|0)==1):0)CR(i);f[p>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[c>>2]|0)>0){n=f[s>>2]|0;s=0;do{f[n+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[c>>2]|0))}c=f[t>>2]|0;if((c|0)!=(m|0))ZF(c);c=f[q>>2]|0;if(c|0?(m=c+12|0,c=f[m>>2]|0,f[m>>2]=c+-1,(c|0)==1):0)CR(h);f[q>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[a>>2]|0)>0){o=f[h+40>>2]|0;q=0;do{f[o+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[a>>2]|0))}a=f[h+44>>2]|0;if((a|0)!=(h+48|0))ZF(a);a=g+36|0;h=f[a>>2]|0;if(h|0?(q=h+12|0,h=f[q>>2]|0,f[q>>2]=h+-1,(h|0)==1):0)CR(g);f[a>>2]=0;a=g+16|0;h=g+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[h>>2]|0)>0){a=f[g+40>>2]|0;q=0;do{f[a+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)==(g+48|0)){u=e;return}ZF(h);u=e;return}function h6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return i6(a,b,c,d,-1)|0}function i6(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+144|0;i=h+72|0;j=h+8|0;k=h+16|0;l=h+128|0;m=h;do if((NS(a)|0)==65536){n=f[a+4>>2]|0;f[i>>2]=f[n>>2];o=i+4|0;p=n+4|0;f[o>>2]=f[p>>2];q=i+8|0;f[q>>2]=f[n+8>>2];f[i+12>>2]=f[n+12>>2];f[i+16>>2]=f[n+16>>2];f[i+20>>2]=f[n+20>>2];f[i+24>>2]=f[n+24>>2];f[i+28>>2]=f[n+28>>2];f[i+32>>2]=f[n+32>>2];r=f[n+36>>2]|0;f[i+36>>2]=r;s=i+40|0;f[s>>2]=q;q=i+48|0;t=i+44|0;f[t>>2]=q;f[q>>2]=0;f[i+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[n+44>>2]|0;q=f[t>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];v=s;break}else{f[o>>2]=0;BR(i,n);v=s;break}}else{OR(i,a,-1);v=i+40|0}while(0);a=f[v>>2]|0;s=f[a>>2]|0;f[j>>2]=f[a+4>>2];f[j+4>>2]=s;KS(c,j,e&7,-1,0,0);do if((NS(c)|0)==65536){j=f[c+4>>2]|0;f[k>>2]=f[j>>2];s=k+4|0;a=j+4|0;f[s>>2]=f[a>>2];n=k+8|0;f[n>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];f[k+16>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];o=f[j+36>>2]|0;f[k+36>>2]=o;f[k+40>>2]=n;n=k+48|0;p=k+44|0;f[p>>2]=n;f[n>>2]=0;f[k+52>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[a>>2]|0)<3){a=f[j+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[a>>2];f[n+4>>2]=f[a+4>>2];break}else{f[s>>2]=0;BR(k,j);break}}else OR(k,c,-1);while(0);switch(e|0){case 2:{w=j6(i,k,d,g,l)|0;break}case 4:{w=j6(i,k,d,g,l)|0;break}default:{f[m>>2]=0;f[m+4>>2]=0;l=c$(m,37)|0;g=217990;d=l+37|0;do{b[l>>0]=b[g>>0]|0;l=l+1|0;g=g+1|0}while((l|0)<(d|0));j$(-210,m,218028,218048,4010);d$(m);w=0}}m=k+36|0;g=f[m>>2]|0;if(g|0?(l=g+12|0,g=f[l>>2]|0,f[l>>2]=g+-1,(g|0)==1):0)CR(k);f[m>>2]=0;m=k+16|0;g=k+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[g>>2]|0)>0){m=f[k+40>>2]|0;l=0;do{f[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[g>>2]|0))}g=f[k+44>>2]|0;if((g|0)!=(k+48|0))ZF(g);g=i+36|0;k=f[g>>2]|0;if(k|0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)CR(i);f[g>>2]=0;g=i+16|0;k=i+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[k>>2]|0)>0){g=f[v>>2]|0;v=0;do{f[g+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[k>>2]|0))}k=f[i+44>>2]|0;if((k|0)==(i+48|0)){u=h;return w|0}ZF(k);u=h;return w|0}function j6(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=u;u=u+16|0;i=h;j=h+13|0;k=h+12|0;l=h+11|0;m=h+10|0;n=h+9|0;o=h+8|0;if(!((f[c>>2]&4088|0)==0?!(f[a>>2]&4088|0):0)){f[i>>2]=0;f[i+4>>2]=0;p=c$(i,38)|0;q=218112;r=p+38|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,i,218151,218048,3932);d$(i)}s=(d|0)==8;t=(d|0)==4;switch(d|0){case 4:case 8:break;default:{f[i>>2]=0;f[i+4>>2]=0;p=c$(i,38)|0;q=223444;r=p+38|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,i,218151,218048,3933);d$(i)}}v=(e|0)==1;w=(e|0)==0;x=(e|0)==-1;switch(e|0){case 0:case 1:case -1:break;default:{f[i>>2]=0;f[i+4>>2]=0;p=c$(i,67)|0;q=218176;r=p+67|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,i,218151,218048,3934);d$(i)}}e=f[c>>2]|0;y=e&7;z=f[a>>2]&6;A=cV()|0;B=bV()|0;if((z|1|0)!=1){f[i>>2]=0;f[i+4>>2]=0;p=c$(i,26)|0;q=218244;r=p+26|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,i,218151,218048,3941);d$(i)}if((A|0)!=0&(B|0)>1)C=((f[c+8>>2]|0)/(B|0)|0|0)>1;else C=0;B=(y|0)==0;a:do if(t|w){if(!B){switch(e&7){case 2:{D=(k6(j,a,c,d,g)|0)&65535;u=h;return D|0}case 4:break;default:break a}if(C){D=m6(l,a,c,d,g)|0;u=h;return D|0}else{D=l6(k,a,c,d,g)|0;u=h;return D|0}}}else if(!(B|s&(v|x)^1)){switch(e&7){case 2:{D=(n6(m,a,c,d,g)|0)&65535;u=h;return D|0}case 4:break;default:break a}if(C){D=p6(o,a,c,d,g)|0;u=h;return D|0}else{D=o6(n,a,c,d,g)|0;u=h;return D|0}}while(0);f[i>>2]=0;f[i+4>>2]=0;p=c$(i,28)|0;q=218271;r=p+28|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-210,i,218151,218048,3987);d$(i);D=-1;u=h;return D|0}function k6(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;h=u;u=u+16|0;a=h;i=c+8|0;if((f[e+8>>2]|0)!=(f[i>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;k=c$(a,26)|0;l=218765;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,a,373355,218048,659);d$(a)}n=c+12|0;if((f[e+12>>2]|0)!=(f[n>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;k=c$(a,26)|0;l=218792;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,a,373355,218048,660);d$(a)}o=(g|0)==8;switch(g|0){case 4:case 8:break;default:{f[a>>2]=0;f[a+4>>2]=0;k=c$(a,38)|0;l=223444;m=k+38|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,a,373355,218048,661);d$(a)}}a=f[i>>2]|0;i=f[n>>2]|0;n=YF((Y(i,a)|0)+3&-2)|0;d[n>>1]=0;l=(a|0)>0;if(o){if(!l){p=1;ZF(n);u=h;return p|0}o=(i|0)>0;k=i+-1|0;m=f[c+16>>2]|0;g=f[f[c+44>>2]>>2]|0;q=f[e+16>>2]|0;r=f[f[e+44>>2]>>2]|0;s=0-g|0;t=0-r|0;v=1;w=0;while(1){x=m+(Y(g,w)|0)|0;y=x+s|0;z=q+(Y(r,w)|0)|0;A=z+t|0;if(o){B=(w|0)>0;C=0;D=v;while(1){a:do if(!(b[x+C>>0]|0)){d[z+(C<<1)>>1]=0;E=D}else{if(B){if(b[y+C>>0]|0){d[z+(C<<1)>>1]=d[A+(C<<1)>>1]|0;E=D;break}F=(C|0)>0;if((C|0)<(k|0)?(G=C+1|0,b[y+G>>0]|0):0){H=d[A+(G<<1)>>1]|0;do if(F){G=C+-1|0;if(!(b[y+G>>0]|0)){I=C+-1|0;if(!(b[x+I>>0]|0)){J=H;break}K=d[z+(I<<1)>>1]|0;I=K;while(1){L=d[n+((I&65535)<<1)>>1]|0;if((L&65535)<(I&65535))I=L;else break}if(K<<16>>16==H<<16>>16)M=I;else{L=H;while(1){N=d[n+((L&65535)<<1)>>1]|0;if((N&65535)<(L&65535))L=N;else break}N=(I&65535)>(L&65535)?L:I;O=H;do{P=n+((O&65535)<<1)|0;Q=O;O=d[P>>1]|0;d[P>>1]=N}while((O&65535)<(Q&65535));M=N}N=K;do{O=n+((N&65535)<<1)|0;I=N;N=d[O>>1]|0;d[O>>1]=M}while((N&65535)<(I&65535));J=M}else{N=d[A+(G<<1)>>1]|0;K=N;while(1){I=d[n+((K&65535)<<1)>>1]|0;if((I&65535)<(K&65535))K=I;else break}if(N<<16>>16==H<<16>>16)R=K;else{G=H;while(1){I=d[n+((G&65535)<<1)>>1]|0;if((I&65535)<(G&65535))G=I;else break}I=(K&65535)>(G&65535)?G:K;O=H;do{L=n+((O&65535)<<1)|0;Q=O;O=d[L>>1]|0;d[L>>1]=I}while((O&65535)<(Q&65535));R=I}I=N;do{O=n+((I&65535)<<1)|0;K=I;I=d[O>>1]|0;d[O>>1]=R}while((I&65535)<(K&65535));d[z+(C<<1)>>1]=R;E=D;break a}}else J=H;while(0);d[z+(C<<1)>>1]=J;E=D;break}if(F){H=C+-1|0;if(!(b[y+H>>0]|0))S=46;else{d[z+(C<<1)>>1]=d[A+(H<<1)>>1]|0;E=D;break}}}else if((C|0)>0)S=46;if((S|0)==46?(S=0,H=C+-1|0,b[x+H>>0]|0):0){d[z+(C<<1)>>1]=d[z+(H<<1)>>1]|0;E=D;break}d[z+(C<<1)>>1]=D;H=D&65535;d[n+(H<<1)>>1]=D;E=H+1&65535}while(0);C=C+1|0;if((C|0)==(i|0)){T=E;break}else D=E}}else T=v;w=w+1|0;if((w|0)==(a|0)){U=T;break}else v=T}}else{if(!l){p=1;ZF(n);u=h;return p|0}T=(i|0)>0;v=f[c+16>>2]|0;w=f[f[c+44>>2]>>2]|0;c=f[e+16>>2]|0;E=f[f[e+44>>2]>>2]|0;S=0-w|0;J=0-E|0;R=1;M=0;while(1){k=v+(Y(w,M)|0)|0;o=k+S|0;t=c+(Y(E,M)|0)|0;r=t+J|0;b:do if(T){if((M|0)>0){V=0;W=R}else{q=0;s=R;while(1){do if(!(b[k+q>>0]|0)){d[t+(q<<1)>>1]=0;X=s}else{if((q|0)>0?(g=q+-1|0,b[k+g>>0]|0):0){d[t+(q<<1)>>1]=d[t+(g<<1)>>1]|0;X=s;break}d[t+(q<<1)>>1]=s;g=s&65535;d[n+(g<<1)>>1]=s;X=g+1&65535}while(0);q=q+1|0;if((q|0)==(i|0)){Z=X;break b}else s=X}}while(1){do if(!(b[k+V>>0]|0)){d[t+(V<<1)>>1]=0;_=W}else{s=(V|0)>0;if(!(b[o+V>>0]|0)){if(s?(q=V+-1|0,b[k+q>>0]|0):0){d[t+(V<<1)>>1]=d[t+(q<<1)>>1]|0;_=W;break}d[t+(V<<1)>>1]=W;q=W&65535;d[n+(q<<1)>>1]=W;_=q+1&65535;break}q=d[r+(V<<1)>>1]|0;if(s?(s=V+-1|0,(b[k+s>>0]|0)!=0):0){F=d[t+(s<<1)>>1]|0;s=F;while(1){g=d[n+((s&65535)<<1)>>1]|0;if((g&65535)<(s&65535))s=g;else break}if(F<<16>>16==q<<16>>16)$=s;else{g=q;while(1){m=d[n+((g&65535)<<1)>>1]|0;if((m&65535)<(g&65535))g=m;else break}m=(s&65535)>(g&65535)?g:s;D=q;do{C=n+((D&65535)<<1)|0;z=D;D=d[C>>1]|0;d[C>>1]=m}while((D&65535)<(z&65535));$=m}m=F;do{D=n+((m&65535)<<1)|0;s=m;m=d[D>>1]|0;d[D>>1]=$}while((m&65535)<(s&65535));aa=$}else aa=q;d[t+(V<<1)>>1]=aa;_=W}while(0);V=V+1|0;if((V|0)==(i|0)){Z=_;break}else W=_}}else Z=R;while(0);M=M+1|0;if((M|0)==(a|0)){U=Z;break}else R=Z}}if((U&65535)>1){Z=U&65535;U=1;R=1;while(1){M=n+(U<<1)|0;_=j[M>>1]|0;if(_>>>0<U>>>0){d[M>>1]=d[n+(_<<1)>>1]|0;ba=R}else{d[M>>1]=R;ba=(R&65535)+1&65535}U=U+1|0;if((U|0)==(Z|0)){ca=ba;break}else R=ba}}else ca=1;if(!l){p=ca;ZF(n);u=h;return p|0}l=f[e+16>>2]|0;ba=f[f[e+44>>2]>>2]|0;e=0;do{R=l+(Y(ba,e)|0)|0;Z=R+(i<<1)|0;if((R|0)!=(Z|0)){U=R;do{d[U>>1]=d[n+(j[U>>1]<<1)>>1]|0;U=U+2|0}while((U|0)!=(Z|0))}e=e+1|0}while((e|0)!=(a|0));p=ca;ZF(n);u=h;return p|0}function l6(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;g=u;u=u+16|0;a=g;h=c+8|0;if((f[d+8>>2]|0)!=(f[h>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;i=c$(a,26)|0;j=218765;k=i+26|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-215,a,373355,218048,659);d$(a)}l=c+12|0;if((f[d+12>>2]|0)!=(f[l>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;i=c$(a,26)|0;j=218792;k=i+26|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-215,a,373355,218048,660);d$(a)}m=(e|0)==8;switch(e|0){case 4:case 8:break;default:{f[a>>2]=0;f[a+4>>2]=0;i=c$(a,38)|0;j=223444;k=i+38|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-215,a,373355,218048,661);d$(a)}}a=f[h>>2]|0;h=f[l>>2]|0;l=YF((((Y(h,a)|0)+1|0)>>>1<<2)+4|0)|0;f[l>>2]=0;j=(a|0)>0;if(m){if(!j){n=1;ZF(l);u=g;return n|0}m=(h|0)>0;i=h+-1|0;k=f[c+16>>2]|0;e=f[c+44>>2]|0;o=f[d+16>>2]|0;p=f[d+44>>2]|0;q=1;r=0;while(1){s=f[e>>2]|0;t=k+(Y(s,r)|0)|0;v=t+(0-s)|0;s=f[p>>2]|0;w=o+(Y(s,r)|0)|0;x=w+(0-s)|0;if(m){s=(r|0)>0;y=0;z=q;while(1){a:do if(!(b[t+y>>0]|0)){f[w+(y<<2)>>2]=0;A=z}else{if(s){if(b[v+y>>0]|0){f[w+(y<<2)>>2]=f[x+(y<<2)>>2];A=z;break}B=(y|0)>0;if((y|0)<(i|0)?(C=y+1|0,b[v+C>>0]|0):0){D=f[x+(C<<2)>>2]|0;do if(B){C=y+-1|0;if(!(b[v+C>>0]|0)){E=y+-1|0;if(!(b[t+E>>0]|0)){F=D;break}G=f[w+(E<<2)>>2]|0;E=G;while(1){H=f[l+(E<<2)>>2]|0;if((H|0)<(E|0))E=H;else break}if((G|0)==(D|0))I=E;else{H=D;while(1){J=f[l+(H<<2)>>2]|0;if((J|0)<(H|0))H=J;else break}J=(E|0)>(H|0)?H:E;K=D;do{L=l+(K<<2)|0;M=K;K=f[L>>2]|0;f[L>>2]=J}while((K|0)<(M|0));I=J}J=G;do{K=l+(J<<2)|0;E=J;J=f[K>>2]|0;f[K>>2]=I}while((J|0)<(E|0));F=I}else{J=f[x+(C<<2)>>2]|0;G=J;while(1){E=f[l+(G<<2)>>2]|0;if((E|0)<(G|0))G=E;else break}if((J|0)==(D|0))N=G;else{C=D;while(1){E=f[l+(C<<2)>>2]|0;if((E|0)<(C|0))C=E;else break}E=(G|0)>(C|0)?C:G;K=D;do{H=l+(K<<2)|0;M=K;K=f[H>>2]|0;f[H>>2]=E}while((K|0)<(M|0));N=E}E=J;do{K=l+(E<<2)|0;G=E;E=f[K>>2]|0;f[K>>2]=N}while((E|0)<(G|0));f[w+(y<<2)>>2]=N;A=z;break a}}else F=D;while(0);f[w+(y<<2)>>2]=F;A=z;break}if(B){D=y+-1|0;if(!(b[v+D>>0]|0))O=46;else{f[w+(y<<2)>>2]=f[x+(D<<2)>>2];A=z;break}}}else if((y|0)>0)O=46;if((O|0)==46?(O=0,D=y+-1|0,b[t+D>>0]|0):0){f[w+(y<<2)>>2]=f[w+(D<<2)>>2];A=z;break}f[w+(y<<2)>>2]=z;f[l+(z<<2)>>2]=z;A=z+1|0}while(0);y=y+1|0;if((y|0)==(h|0)){P=A;break}else z=A}}else P=q;r=r+1|0;if((r|0)==(a|0)){Q=P;break}else q=P}}else{if(!j){n=1;ZF(l);u=g;return n|0}P=(h|0)>0;q=f[c+16>>2]|0;r=f[c+44>>2]|0;c=f[d+16>>2]|0;A=f[d+44>>2]|0;O=1;F=0;while(1){N=f[r>>2]|0;I=q+(Y(N,F)|0)|0;i=I+(0-N)|0;N=f[A>>2]|0;m=c+(Y(N,F)|0)|0;o=m+(0-N)|0;b:do if(P){if((F|0)>0){R=0;S=O}else{N=0;p=O;while(1){do if(!(b[I+N>>0]|0)){f[m+(N<<2)>>2]=0;T=p}else{if((N|0)>0?(k=N+-1|0,b[I+k>>0]|0):0){f[m+(N<<2)>>2]=f[m+(k<<2)>>2];T=p;break}f[m+(N<<2)>>2]=p;f[l+(p<<2)>>2]=p;T=p+1|0}while(0);N=N+1|0;if((N|0)==(h|0)){U=T;break b}else p=T}}while(1){do if(!(b[I+R>>0]|0)){f[m+(R<<2)>>2]=0;V=S}else{p=(R|0)>0;if(!(b[i+R>>0]|0)){if(p?(N=R+-1|0,b[I+N>>0]|0):0){f[m+(R<<2)>>2]=f[m+(N<<2)>>2];V=S;break}f[m+(R<<2)>>2]=S;f[l+(S<<2)>>2]=S;V=S+1|0;break}N=f[o+(R<<2)>>2]|0;if(p?(p=R+-1|0,(b[I+p>>0]|0)!=0):0){B=f[m+(p<<2)>>2]|0;p=B;while(1){k=f[l+(p<<2)>>2]|0;if((k|0)<(p|0))p=k;else break}if((B|0)==(N|0))W=p;else{k=N;while(1){e=f[l+(k<<2)>>2]|0;if((e|0)<(k|0))k=e;else break}e=(p|0)>(k|0)?k:p;z=N;do{y=l+(z<<2)|0;w=z;z=f[y>>2]|0;f[y>>2]=e}while((z|0)<(w|0));W=e}e=B;do{z=l+(e<<2)|0;p=e;e=f[z>>2]|0;f[z>>2]=W}while((e|0)<(p|0));X=W}else X=N;f[m+(R<<2)>>2]=X;V=S}while(0);R=R+1|0;if((R|0)==(h|0)){U=V;break}else S=V}}else U=O;while(0);F=F+1|0;if((F|0)==(a|0)){Q=U;break}else O=U}}if((Q|0)>1){U=1;O=1;while(1){F=l+(U<<2)|0;V=f[F>>2]|0;if((V|0)<(U|0)){f[F>>2]=f[l+(V<<2)>>2];Z=O}else{f[F>>2]=O;Z=O+1|0}U=U+1|0;if((U|0)==(Q|0)){_=Z;break}else O=Z}}else _=1;if(!j){n=_;ZF(l);u=g;return n|0}j=f[d+16>>2]|0;Z=f[d+44>>2]|0;d=0;do{O=j+(Y(f[Z>>2]|0,d)|0)|0;Q=O+(h<<2)|0;if((O|0)!=(Q|0)){U=O;do{f[U>>2]=f[l+(f[U>>2]<<2)>>2];U=U+4|0}while((U|0)!=(Q|0))}d=d+1|0}while((d|0)!=(a|0));n=_;ZF(l);u=g;return n|0}function m6(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;a=u;u=u+48|0;h=a+32|0;i=a+24|0;j=a;k=c+8|0;l=d+8|0;if((f[k>>2]|0)!=(f[l>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=c$(h,26)|0;n=218300;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,h,373355,218048,578);d$(h)}p=c+12|0;q=d+12|0;if((f[p>>2]|0)!=(f[q>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=c$(h,26)|0;n=218327;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,h,373355,218048,579);d$(h)}r=(e|0)==8;switch(e|0){case 4:case 8:break;default:{f[h>>2]=0;f[h+4>>2]=0;m=c$(h,38)|0;n=223444;o=m+38|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,h,373355,218048,580);d$(h)}}n=bV()|0;m=f[k>>2]|0;k=f[p>>2]|0;p=((Y(k,m)|0)+1|0)>>>1;o=YF(m<<2)|0;e=YF((p<<2)+4|0)|0;f[e>>2]=0;f[h>>2]=0;f[h+4>>2]=m;f[i>>2]=1;if(r){f[j>>2]=48860;f[j+4>>2]=c;f[j+8>>2]=d;f[j+12>>2]=e;f[j+16>>2]=o;_U(h,j,+(n|0));v6(d,e,o);if((m|0)>0){r=(k+1|0)/2|0;p=0;do{s=p+1|0;t=(Y((s|0)/2|0,r)|0)+1|0;v=f[o+(s<<2)>>2]|0;s=v+t|0;if((v|0)>0){v=t;do{t=e+(v<<2)|0;w=f[t>>2]|0;if((w|0)<(v|0))f[t>>2]=f[e+(w<<2)>>2];else{f[t>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}v=v+1|0}while((v|0)<(s|0))}p=f[o+(p<<2)>>2]|0}while((p|0)<(m|0))}}else{f[j>>2]=48880;f[j+4>>2]=c;f[j+8>>2]=d;f[j+12>>2]=e;f[j+16>>2]=o;_U(h,j,+(n|0));c=f[q>>2]|0;q=f[l>>2]|0;l=f[o>>2]|0;a:do if((l|0)<(q|0)){p=f[d+16>>2]|0;r=f[d+44>>2]|0;if((c|0)>0)x=l;else{s=l;while(1){s=f[o+(s<<2)>>2]|0;if((s|0)>=(q|0))break a}}do{s=f[r>>2]|0;v=p+(Y(s,x)|0)|0;t=v+(0-s)|0;s=0;do{w=v+(s<<2)|0;y=f[w>>2]|0;if((y|0)>0?(z=f[t+(s<<2)>>2]|0,(z|0)>0):0){A=z;while(1){B=f[e+(A<<2)>>2]|0;if((B|0)<(A|0))A=B;else break}if((z|0)==(y|0))C=A;else{B=y;while(1){D=f[e+(B<<2)>>2]|0;if((D|0)<(B|0))B=D;else break}D=(A|0)>(B|0)?B:A;E=y;do{F=e+(E<<2)|0;G=E;E=f[F>>2]|0;f[F>>2]=D}while((E|0)<(G|0));C=D}D=z;do{E=e+(D<<2)|0;y=D;D=f[E>>2]|0;f[E>>2]=C}while((D|0)<(y|0));f[w>>2]=C}s=s+1|0}while((s|0)!=(c|0));x=f[o+(x<<2)>>2]|0}while((x|0)<(q|0))}while(0);if((m|0)>0){q=0;do{x=(((Y(q,k)|0)+1|0)/2|0)+1|0;c=f[o+(q+1<<2)>>2]|0;C=c+x|0;if((c|0)>0){c=x;do{x=e+(c<<2)|0;l=f[x>>2]|0;if((l|0)<(c|0))f[x>>2]=f[e+(l<<2)>>2];else{f[x>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}c=c+1|0}while((c|0)<(C|0))}q=f[o+(q<<2)>>2]|0}while((q|0)<(m|0))}}q=OYa((m|0)>-1?m:-1)|0;f[j>>2]=48900;f[j+4>>2]=d;f[j+8>>2]=e;f[j+12>>2]=g;f[j+16>>2]=q;f[j+20>>2]=i;_U(h,j,+(n|0));QYa(q);ZF(o);ZF(e);u=a;return f[i>>2]|0}
function lga(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0,N=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0;e=u;u=u+1072|0;g=e+1064|0;h=e;switch(a|0){case 1:{i=5681008;k=2;l=1956692;break}case 2:{i=5517168;k=4;l=1629012;break}case 4:{i=5549936;k=8;l=1694548;break}default:{f[g>>2]=0;f[g+4>>2]=0;m=c$(g,38)|0;o=314840;p=m+38|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));j$(-5,g,314879,314894,224);d$(g);i=0;k=0;l=0}}q=5689976+a|0;if(b[q>>0]|0){r=i;s=l;t=c?r:s;u=e;return t|0}v=h+8|0;f[h>>2]=v;w=h+4|0;f[w>>2]=256;switch(a|0){case 1:{a=0;x=v;while(1){y=+(a|0)*.03125;n[x>>2]=1.0-y;n[x+4>>2]=y;a=a+1|0;if((a|0)==32)break;else x=x+8|0}break}case 2:{x=0;a=v;while(1){y=+(x|0)*.03125;z=y+1.0;A=z*(z*(3.75-z*.75)+-6.0)+3.0;n[a>>2]=A;z=y*(y*(y*1.25+-2.25))+1.0;n[a+4>>2]=z;B=1.0-y;y=B*(B*(B*1.25+-2.25))+1.0;n[a+8>>2]=y;n[a+12>>2]=1.0-A-z-y;x=x+1|0;if((x|0)==32)break;else a=a+16|0}break}case 4:{a=0;x=v;while(1){y=+(a|0)*.03125;if(y<1.1920928955078125e-07){f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[x+16>>2]=0;f[x+20>>2]=0;f[x+24>>2]=0;f[x+28>>2]=0;C=1.0}else{z=y+3.0;y=-z*3.141592653589793*.25;A=+P(+y);B=+O(+y);D=B*0.0;E=(A+D)/(y*y);y=-(z+-1.0)*3.141592653589793*.25;F=A*-.7071067811865476;G=B*-.7071067811865476;H=(F+G)/(y*y);y=-(z+-2.0)*3.141592653589793*.25;I=A*0.0;J=(I+B)/(y*y);y=-(z+-3.0)*3.141592653589793*.25;K=A*.7071067811865476;L=(K+G)/(y*y);y=-(z+-4.0)*3.141592653589793*.25;G=(D-A)/(y*y);y=-(z+-5.0)*3.141592653589793*.25;A=B*.7071067811865476;D=(K+A)/(y*y);y=-(z+-6.0)*3.141592653589793*.25;K=(I-B)/(y*y);y=-(z+-7.0)*3.141592653589793*.25;z=(F+A)/(y*y);y=1.0/(z+(K+(D+(G+(L+(J+(H+(E+0.0))))))));n[x>>2]=E*y;n[x+4>>2]=H*y;n[x+8>>2]=J*y;n[x+16>>2]=G*y;n[x+20>>2]=D*y;n[x+24>>2]=K*y;n[x+28>>2]=z*y;C=L*y}n[x+12>>2]=C;a=a+1|0;if((a|0)==32)break;else x=x+32|0}break}default:{f[g>>2]=0;f[g+4>>2]=0;m=c$(g,28)|0;o=323569;p=m+28|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));j$(-5,g,314946,314894,207);d$(g)}}g=(k|0)==0;o=f[h>>2]|0;m=Y(k,k)|0;p=k>>>1;x=m<<5;a=m<<10;M=l+(a<<2)|0;N=Y(p,k)|0;Q=p+N|0;R=p+1|0;S=R+N|0;T=Y(R,k)|0;U=p+T|0;V=R+T|0;T=0;W=i;X=l;while(1){l=T<<5;Z=(T|0)<16&1;_=Y(T,k)|0;$=W;aa=0;ba=X;X=X+(x<<2)|0;while(1){ca=aa+l|0;b[5689984+(ca<<1)>>0]=(aa|0)<16&1;b[5689984+(ca<<1)+1>>0]=Z;if(!g){ca=Y(aa,k)|0;da=0;ea=0;while(1){C=+n[o+(ea+_<<2)>>2];fa=Y(ea,k)|0;ga=da;ha=0;do{y=C*+n[o+(ha+ca<<2)>>2];ia=ha+fa|0;n[ba+(ia<<2)>>2]=y;ja=wNa(y*32768.0)|0;ka=(ja+32768|0)>>>0<65536?ja:(ja|0)>0?32767:32768;d[$+(ia<<1)>>1]=ka;ga=(ka<<16>>16)+ga|0;ha=ha+1|0}while((ha|0)<(k|0));ea=ea+1|0;if((ea|0)>=(k|0))break;else da=ga}if((ga|0)!=32768){la=ga;ma=34}}else{la=0;ma=34}if((ma|0)==34){ma=0;da=d[$+(Q<<1)>>1]|0;ea=d[$+(S<<1)>>1]|0;ca=ea<<16>>16<da<<16>>16;ha=ca?p:ea<<16>>16>da<<16>>16?R:p;da=ca?R:p;ca=d[$+(U<<1)>>1]|0;if(ca<<16>>16<(d[$+(N+da<<1)>>1]|0)){na=p;oa=ha;pa=R;qa=p}else{ea=ca<<16>>16>(d[$+(N+ha<<1)>>1]|0);na=ea?R:p;oa=ea?p:ha;pa=p;qa=da}da=d[$+(V<<1)>>1]|0;ha=$+((Y(pa,k)|0)+qa<<1)|0;if(da<<16>>16<(d[ha>>1]|0)){ra=na;sa=oa;ta=R;ua=R}else{ha=$+((Y(na,k)|0)+oa<<1)|0;ea=da<<16>>16>(d[ha>>1]|0);ra=ea?R:na;sa=ea?R:oa;ta=pa;ua=qa}if((la|0)<32768){ea=(Y(ra,k)|0)+sa|0;va=ea;wa=d[$+(ea<<1)>>1]|0}else{ea=(Y(ta,k)|0)+ua|0;va=ea;wa=j[$+(ea<<1)>>1]|0}d[$+(va<<1)>>1]=-32768-la+wa}aa=aa+1|0;if((aa|0)==32)break;else{$=$+(m<<1)|0;ba=ba+(m<<2)|0}}T=T+1|0;if((T|0)==32)break;else W=W+(x<<1)|0}x=Y(Y(k,-1024)|0,k)|0;k=M+(x<<2)|0;M=i+(a<<1)+(x<<1)|0;b[q>>0]=1;q=f[h>>2]|0;if((q|0)!=(v|0)){if(q|0)QYa(q);f[h>>2]=v;f[w>>2]=264}r=M;s=k;t=c?r:s;u=e;return t|0}function mga(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;j=u;u=u+384|0;k=j;l=j+368|0;m=j+360|0;n=j+304|0;o=j+240|0;q=j+184|0;r=j+296|0;s=j+128|0;t=j+72|0;_$(l,72656);QR(m,d,-1);if((Y(f[m+4>>2]|0,f[m>>2]|0)|0)<=0){f[k>>2]=0;f[k+4>>2]=0;v=c$(k,23)|0;w=314961;x=v+23|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-215,k,314985,314894,1728);d$(k)}if(!(XS(e)|0)?(QR(k,e,-1),QR(n,d,-1),!((f[k>>2]|0)==(f[n>>2]|0)?(f[k+4>>2]|0)==(f[n+4>>2]|0):0)):0){f[k>>2]=0;f[k+4>>2]=0;v=c$(k,47)|0;w=314991;x=v+47|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-215,k,314985,314894,1729);d$(k)}do if((NS(a)|0)==65536){m=f[a+4>>2]|0;f[n>>2]=f[m>>2];y=n+4|0;z=m+4|0;f[y>>2]=f[z>>2];A=n+8|0;f[A>>2]=f[m+8>>2];f[n+12>>2]=f[m+12>>2];f[n+16>>2]=f[m+16>>2];f[n+20>>2]=f[m+20>>2];f[n+24>>2]=f[m+24>>2];f[n+28>>2]=f[m+28>>2];f[n+32>>2]=f[m+32>>2];B=f[m+36>>2]|0;f[n+36>>2]=B;f[n+40>>2]=A;A=n+48|0;C=n+44|0;f[C>>2]=A;f[A>>2]=0;f[n+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[m+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;BR(n,m);break}}else OR(n,a,-1);while(0);do if((NS(d)|0)==65536){m=f[d+4>>2]|0;f[o>>2]=f[m>>2];y=o+4|0;z=m+4|0;f[y>>2]=f[z>>2];A=o+8|0;f[A>>2]=f[m+8>>2];f[o+12>>2]=f[m+12>>2];f[o+16>>2]=f[m+16>>2];f[o+20>>2]=f[m+20>>2];f[o+24>>2]=f[m+24>>2];f[o+28>>2]=f[m+28>>2];f[o+32>>2]=f[m+32>>2];C=f[m+36>>2]|0;f[o+36>>2]=C;f[o+40>>2]=A;A=o+48|0;B=o+44|0;f[B>>2]=A;f[A>>2]=0;f[o+52>>2]=0;if(C|0){A=C+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[m+44>>2]|0;A=f[B>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;BR(o,m);break}}else OR(o,d,-1);while(0);do if((NS(e)|0)==65536){d=f[e+4>>2]|0;f[q>>2]=f[d>>2];m=q+4|0;y=d+4|0;f[m>>2]=f[y>>2];z=q+8|0;f[z>>2]=f[d+8>>2];f[q+12>>2]=f[d+12>>2];f[q+16>>2]=f[d+16>>2];f[q+20>>2]=f[d+20>>2];f[q+24>>2]=f[d+24>>2];f[q+28>>2]=f[d+28>>2];f[q+32>>2]=f[d+32>>2];A=f[d+36>>2]|0;f[q+36>>2]=A;f[q+40>>2]=z;z=q+48|0;B=q+44|0;f[B>>2]=z;f[z>>2]=0;f[q+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[d+44>>2]|0;z=f[B>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[m>>2]=0;BR(q,d);break}}else OR(q,e,-1);while(0);e=o+40|0;d=f[e>>2]|0;m=f[d>>2]|0;f[r>>2]=f[d+4>>2];f[r+4>>2]=m;KS(c,r,f[n>>2]&4095,-1,0,0);do if((NS(c)|0)==65536){r=f[c+4>>2]|0;f[s>>2]=f[r>>2];m=s+4|0;d=r+4|0;f[m>>2]=f[d>>2];y=s+8|0;f[y>>2]=f[r+8>>2];z=s+12|0;f[z>>2]=f[r+12>>2];f[s+16>>2]=f[r+16>>2];f[s+20>>2]=f[r+20>>2];f[s+24>>2]=f[r+24>>2];f[s+28>>2]=f[r+28>>2];f[s+32>>2]=f[r+32>>2];B=f[r+36>>2]|0;f[s+36>>2]=B;f[s+40>>2]=y;y=s+48|0;A=s+44|0;f[A>>2]=y;f[y>>2]=0;f[s+52>>2]=0;if(B|0){y=B+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[d>>2]|0)<3){d=f[r+44>>2]|0;y=f[A>>2]|0;f[y>>2]=f[d>>2];f[y+4>>2]=f[d+4>>2];D=z;break}else{f[m>>2]=0;BR(s,r);D=z;break}}else{OR(s,c,-1);D=s+12|0}while(0);if(!((((f[D>>2]|0)<32767?(f[s+8>>2]|0)<32767:0)?(f[n+12>>2]|0)<32767:0)?(f[n+8>>2]|0)<32767:0)){f[k>>2]=0;f[k+4>>2]=0;v=c$(k,80)|0;w=315039;x=v+80|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-215,k,314985,314894,1749);d$(k)}c=s+16|0;z=n+16|0;if((f[c>>2]|0)==(f[z>>2]|0)){f[t>>2]=1124007936;r=t+4|0;m=t+8|0;d=t+40|0;v=r;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[d>>2]=m;y=t+48|0;A=t+44|0;f[A>>2]=y;f[y>>2]=0;f[t+52>>2]=0;B=k+8|0;f[B>>2]=0;f[B+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=t;eL(n,k);B=t+36|0;C=f[B>>2]|0;if(C|0){E=C+12|0;f[E>>2]=(f[E>>2]|0)+1}E=n+36|0;C=f[E>>2]|0;if(C|0?(F=C+12|0,C=f[F>>2]|0,f[F>>2]=C+-1,(C|0)==1):0)CR(n);f[E>>2]=0;C=n+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[C>>2]|0)>0){F=f[n+40>>2]|0;G=0;do{f[F+(G<<2)>>2]=0;G=G+1|0;H=f[C>>2]|0}while((G|0)<(H|0));f[n>>2]=f[t>>2];if((H|0)<3)I=50;else I=52}else{f[n>>2]=f[t>>2];I=50}if((I|0)==50){H=f[r>>2]|0;if((H|0)<3){f[C>>2]=H;f[n+8>>2]=f[m>>2];f[n+12>>2]=f[t+12>>2];m=f[A>>2]|0;H=f[n+44>>2]|0;f[H>>2]=f[m>>2];f[H+4>>2]=f[m+4>>2]}else I=52}if((I|0)==52)BR(n,t);m=t+16|0;f[z>>2]=f[m>>2];f[n+20>>2]=f[t+20>>2];f[n+24>>2]=f[t+24>>2];f[n+28>>2]=f[t+28>>2];f[n+32>>2]=f[t+32>>2];H=f[B>>2]|0;f[E>>2]=H;if(H|0?(E=H+12|0,H=f[E>>2]|0,f[E>>2]=H+-1,(H|0)==1):0)CR(t);f[B>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[r>>2]|0)>0){m=f[d>>2]|0;d=0;do{f[m+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[r>>2]|0))}r=f[A>>2]|0;if((r|0)!=(y|0))ZF(r)}r=(g|0)==3?1:g;g=f[n>>2]&7;y=(g|0)==0;switch(r|0){case 0:{A=f[72676+(g<<2)>>2]|0;if((g|0)==7){f[k>>2]=0;f[k+4>>2]=0;v=c$(k,11)|0;w=315120;x=v+11|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-215,k,314985,314894,1809);d$(k);J=0;K=0;L=A}else{J=0;K=0;L=A}break}case 1:{M=f[72708+(g<<2)>>2]|0;I=71;break}case 2:{A=f[72740+(g<<2)>>2]|0;if((WS(a,-1)|0)<5){M=A;I=71}else{f[k>>2]=0;f[k+4>>2]=0;v=c$(k,20)|0;w=315132;x=v+20|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-215,k,314985,314894,1817);d$(k);M=A;I=71}break}case 4:{A=f[72772+(g<<2)>>2]|0;if((WS(a,-1)|0)<5){M=A;I=71}else{f[k>>2]=0;f[k+4>>2]=0;v=c$(k,20)|0;w=315132;x=v+20|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-215,k,314985,314894,1821);d$(k);M=A;I=71}break}default:{f[k>>2]=0;f[k+4>>2]=0;v=c$(k,28)|0;w=323569;x=v+28|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-5,k,314985,314894,1824);d$(k);I=72}}if((I|0)==71)if(!M)I=72;else{N=M;I=73}if((I|0)==72){f[k>>2]=0;f[k+4>>2]=0;v=c$(k,10)|0;w=315153;x=v+10|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-215,k,314985,314894,1825);d$(k);N=0;I=73}if((I|0)==73){J=lga(r,y)|0;K=N;L=0}N=o;y=q;r=f[o>>2]|0;w=r&4095;v=(w|0)==11;x=f[q>>2]|0;if(v)if((x&4094|0)!=2?(f[q+16>>2]|0)!=0:0){M=f[q+4>>2]|0;if((M|0)<3)O=Y(f[q+12>>2]|0,f[q+8>>2]|0)|0;else{A=f[q+40>>2]|0;a=0;g=1;while(1){d=Y(f[A+(a<<2)>>2]|0,g)|0;a=a+1|0;if((a|0)==(M|0)){O=d;break}else g=d}}if(!((M|0)==0|(O|0)==0))I=82;else I=90}else I=90;else I=82;do if((I|0)==82){O=x&4095;if((O|0)==11){if((r&4094|0)==2){I=90;break}if(!(f[o+16>>2]|0)){I=90;break}M=f[o+4>>2]|0;if((M|0)<3)P=Y(f[o+12>>2]|0,f[o+8>>2]|0)|0;else{g=f[e>>2]|0;a=0;A=1;while(1){d=Y(f[g+(a<<2)>>2]|0,A)|0;a=a+1|0;if((a|0)==(M|0)){P=d;break}else A=d}}if((M|0)==0|(P|0)==0){I=90;break}}switch(r&4095){case 11:case 13:{if(f[q+16>>2]|0){A=f[q+4>>2]|0;if((A|0)<3)Q=Y(f[q+12>>2]|0,f[q+8>>2]|0)|0;else{a=f[q+40>>2]|0;g=0;d=1;while(1){m=Y(f[a+(g<<2)>>2]|0,d)|0;g=g+1|0;if((g|0)==(A|0)){Q=m;break}else d=m}}if(!((A|0)==0|(Q|0)==0))I=98;else R=r}else R=r;break}default:I=98}if((I|0)==98)if((w|0)==5&(O|0)==5)R=r;else{f[k>>2]=0;f[k+4>>2]=0;K1a(c$(k,258)|0,315164,258)|0;j$(-215,k,314985,314894,1840);d$(k);R=f[o>>2]|0}S=N;T=y;U=(R&4088|0)==0}while(0);if((I|0)==90){S=v?N:y;T=v?y:N;U=0}f[k>>2]=72812;f[k+4>>2]=n;f[k+8>>2]=s;f[k+12>>2]=S;f[k+16>>2]=T;f[k+20>>2]=h;p[k+24>>3]=+p[i>>3];p[k+32>>3]=+p[i+8>>3];p[k+40>>3]=+p[i+16>>3];p[k+48>>3]=+p[i+24>>3];f[k+56>>2]=U&1;f[k+60>>2]=L;f[k+64>>2]=K;f[k+68>>2]=J;J=f[s+8>>2]|0;f[t>>2]=0;f[t+4>>2]=J;K=s+4|0;L=f[K>>2]|0;if((L|0)<3)V=Y(f[D>>2]|0,J)|0;else{J=f[s+40>>2]|0;D=0;U=1;while(1){i=Y(f[J+(D<<2)>>2]|0,U)|0;D=D+1|0;if((D|0)==(L|0)){V=i;break}else U=i}}_U(t,k,+(V>>>0)*.0000152587890625);V=s+36|0;k=f[V>>2]|0;if(k|0?(t=k+12|0,k=f[t>>2]|0,f[t>>2]=k+-1,(k|0)==1):0)CR(s);f[V>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[K>>2]|0)>0){c=f[s+40>>2]|0;V=0;do{f[c+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[K>>2]|0))}K=f[s+44>>2]|0;if((K|0)!=(s+48|0))ZF(K);K=q+36|0;s=f[K>>2]|0;if(s|0?(V=s+12|0,s=f[V>>2]|0,f[V>>2]=s+-1,(s|0)==1):0)CR(q);f[K>>2]=0;K=q+16|0;s=q+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[s>>2]|0)>0){K=f[q+40>>2]|0;V=0;do{f[K+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[s>>2]|0))}s=f[q+44>>2]|0;if((s|0)!=(q+48|0))ZF(s);s=o+36|0;q=f[s>>2]|0;if(q|0?(V=q+12|0,q=f[V>>2]|0,f[V>>2]=q+-1,(q|0)==1):0)CR(o);f[s>>2]=0;s=o+16|0;q=o+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[q>>2]|0)>0){s=f[e>>2]|0;e=0;do{f[s+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[q>>2]|0))}q=f[o+44>>2]|0;if((q|0)!=(o+48|0))ZF(q);q=n+36|0;o=f[q>>2]|0;do if(o|0){e=o+12|0;s=f[e>>2]|0;f[e>>2]=s+-1;if((s|0)!=1)break;CR(n)}while(0);f[q>>2]=0;q=n+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[q>>2]|0)>0){z=f[n+40>>2]|0;o=0;do{f[z+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[q>>2]|0))}q=f[n+44>>2]|0;if((q|0)!=(n+48|0))ZF(q);if(!(f[l+4>>2]|0)){u=j;return}u=j;return}function nga(a){a=a|0;PYa(a);return}function oga(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0;c=u;u=u+416|0;e=c+352|0;g=c+296|0;i=c+240|0;k=c+184|0;l=c+72|0;m=c+16|0;o=c+128|0;p=c;q=a+8|0;r=f[q>>2]|0;s=f[r+8>>2]|0;t=a+12|0;v=f[f[t>>2]>>2]&7;w=16384/(((s|0)<128?s:128)|0)|0;x=f[r+12>>2]|0;r=(x|0)<(w|0)?x:w;w=16384/(r|0)|0;x=(s|0)<(w|0)?s:w;f[g>>2]=1124007936;w=g+4|0;s=g+8|0;y=g+40|0;z=w;A=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(A|0));f[y>>2]=s;s=g+48|0;B=g+44|0;f[B>>2]=s;f[s>>2]=0;f[g+52>>2]=0;f[e>>2]=x;C=e+4|0;f[C>>2]=r;AR(g,2,e,11);f[i>>2]=1124007936;D=i+4|0;E=i+8|0;F=i+40|0;z=D;A=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(A|0));f[F>>2]=E;E=i+48|0;z=i+44|0;f[z>>2]=E;f[E>>2]=0;f[i+52>>2]=0;A=a+60|0;if(!(f[A>>2]|0)){f[e>>2]=x;f[C>>2]=r;AR(i,2,e,2)}C=f[b>>2]|0;G=b+4|0;if((C|0)<(f[G>>2]|0)){b=k+4|0;H=k+8|0;I=k+12|0;J=l+4|0;K=l+8|0;L=l+12|0;M=m+4|0;N=m+8|0;O=m+12|0;P=a+64|0;Q=a+4|0;R=a+68|0;S=a+20|0;T=a+24|0;U=l+36|0;V=l+16|0;W=l+4|0;X=l+40|0;Z=l+44|0;_=l+48|0;$=k+16|0;aa=k+44|0;ba=a+16|0;ca=p+4|0;da=p+8|0;ea=p+12|0;fa=m+36|0;ga=k+36|0;ha=k+4|0;ia=k+40|0;ja=m+4|0;ka=m+8|0;la=k+8|0;ma=m+12|0;na=k+12|0;oa=m+44|0;pa=m+16|0;qa=m+20|0;ra=k+20|0;sa=m+24|0;ta=k+24|0;ua=m+28|0;va=k+28|0;wa=m+32|0;xa=k+32|0;ya=m+40|0;za=m+48|0;Aa=a+56|0;a=k+48|0;Ba=e+36|0;Ca=e+16|0;Da=e+4|0;Ea=e+40|0;Fa=e+44|0;Ga=e+48|0;Ha=m+4|0;Ia=m+8|0;Ja=m+12|0;Ka=l+36|0;La=l+4|0;Ma=l+8|0;Na=l+12|0;Oa=l+44|0;Pa=l+16|0;Qa=l+20|0;Ra=l+24|0;Sa=l+28|0;Ta=l+32|0;Ua=l+40|0;Va=l+48|0;Wa=(v|0)==5;v=l+4|0;Xa=l+8|0;Ya=l+12|0;Za=m+8|0;_a=m+4|0;$a=o+36|0;ab=o+16|0;bb=o+4|0;cb=o+40|0;db=o+44|0;eb=o+48|0;fb=f[q>>2]|0;gb=C;while(1){C=f[fb+12>>2]|0;if((C|0)>0){hb=C;C=fb;ib=0;while(1){jb=(f[G>>2]|0)-gb|0;kb=(jb|0)<(x|0)?jb:x;jb=hb-ib|0;lb=(jb|0)<(r|0)?jb:r;f[k>>2]=ib;f[b>>2]=gb;f[H>>2]=lb;f[I>>2]=kb;FR(e,C,k);f[l>>2]=0;f[J>>2]=0;f[K>>2]=lb;f[L>>2]=kb;FR(k,g,l);if(!(f[A>>2]|0)){f[m>>2]=0;f[M>>2]=0;f[N>>2]=lb;f[O>>2]=kb;FR(l,i,m);if((kb|0)>0){jb=(lb|0)>0;mb=ib<<1;nb=0;do{ob=(f[$>>2]|0)+(Y(f[f[aa>>2]>>2]|0,nb)|0)|0;pb=(f[V>>2]|0)+(Y(f[f[Z>>2]>>2]|0,nb)|0)|0;qb=f[t>>2]|0;do if((f[qb>>2]&4095|0)==11?(f[f[ba>>2]>>2]&4094|0)==2:0){f[p>>2]=ib;f[ca>>2]=gb;f[da>>2]=lb;f[ea>>2]=kb;FR(m,qb,p);rb=f[fa>>2]|0;if(rb|0){sb=rb+12|0;f[sb>>2]=(f[sb>>2]|0)+1}sb=f[ga>>2]|0;if(sb|0?(rb=sb+12|0,sb=f[rb>>2]|0,f[rb>>2]=sb+-1,(sb|0)==1):0)CR(k);f[ga>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[ha>>2]|0)>0){sb=f[ia>>2]|0;rb=0;do{f[sb+(rb<<2)>>2]=0;rb=rb+1|0;tb=f[ha>>2]|0}while((rb|0)<(tb|0));f[k>>2]=f[m>>2];if((tb|0)<3)ub=73;else ub=75}else{f[k>>2]=f[m>>2];ub=73}if((ub|0)==73){ub=0;rb=f[ja>>2]|0;if((rb|0)<3){f[ha>>2]=rb;f[la>>2]=f[ka>>2];f[na>>2]=f[ma>>2];rb=f[oa>>2]|0;sb=f[aa>>2]|0;f[sb>>2]=f[rb>>2];f[sb+4>>2]=f[rb+4>>2]}else ub=75}if((ub|0)==75){ub=0;BR(k,m)}f[$>>2]=f[pa>>2];f[ra>>2]=f[qa>>2];f[ta>>2]=f[sa>>2];f[va>>2]=f[ua>>2];f[xa>>2]=f[wa>>2];rb=f[fa>>2]|0;f[ga>>2]=rb;do if(rb|0){sb=rb+12|0;vb=f[sb>>2]|0;f[sb>>2]=vb+-1;if((vb|0)!=1)break;CR(m)}while(0);f[fa>>2]=0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[ja>>2]|0)>0){rb=f[ya>>2]|0;vb=0;do{f[rb+(vb<<2)>>2]=0;vb=vb+1|0}while((vb|0)<(f[ja>>2]|0))}vb=f[oa>>2]|0;if((vb|0)!=(za|0))ZF(vb);vb=f[ba>>2]|0;rb=(f[vb+16>>2]|0)+(Y(f[f[vb+44>>2]>>2]|0,nb+gb|0)|0)+(ib<<1)|0;if(jb)wb=0;else break;do{d[pb+(wb<<1)>>1]=d[rb+(wb<<1)>>1]&1023;wb=wb+1|0}while((wb|0)<(lb|0))}else ub=86;while(0);do if((ub|0)==86){ub=0;rb=nb+gb|0;vb=(f[qb+16>>2]|0)+(Y(f[f[qb+44>>2]>>2]|0,rb)|0)|0;if(!(f[Aa>>2]|0)){sb=vb+(mb<<2)|0;if(jb)xb=0;else break;do{yb=xb<<1;zb=wNa(+n[sb+(yb<<2)>>2]*32.0)|0;Ab=yb|1;Bb=wNa(+n[sb+(Ab<<2)>>2]*32.0)|0;Cb=zb>>5;d[ob+(yb<<1)>>1]=(Cb+32768|0)>>>0<65536?Cb:(Cb|0)>0?32767:32768;Cb=Bb>>5;d[ob+(Ab<<1)>>1]=(Cb+32768|0)>>>0<65536?Cb:(Cb|0)>0?32767:32768;d[pb+(xb<<1)>>1]=Bb<<5&992|zb&31;xb=xb+1|0}while((xb|0)<(lb|0))}else{sb=vb+(ib<<2)|0;zb=f[ba>>2]|0;Bb=(f[zb+16>>2]|0)+(Y(f[f[zb+44>>2]>>2]|0,rb)|0)+(ib<<2)|0;if(jb)Db=0;else break;do{zb=wNa(+n[sb+(Db<<2)>>2]*32.0)|0;Cb=wNa(+n[Bb+(Db<<2)>>2]*32.0)|0;Ab=zb>>5;yb=Db<<1;d[ob+(yb<<1)>>1]=(Ab+32768|0)>>>0<65536?Ab:(Ab|0)>0?32767:32768;Ab=Cb>>5;d[ob+((yb|1)<<1)>>1]=(Ab+32768|0)>>>0<65536?Ab:(Ab|0)>0?32767:32768;d[pb+(Db<<1)>>1]=Cb<<5&992|zb&31;Db=Db+1|0}while((Db|0)<(lb|0))}}while(0);nb=nb+1|0}while((nb|0)<(kb|0))}Xh[f[P>>2]&127](f[Q>>2]|0,e,k,l,f[R>>2]|0,f[S>>2]|0,T);nb=f[U>>2]|0;if(nb|0?(jb=nb+12|0,nb=f[jb>>2]|0,f[jb>>2]=nb+-1,(nb|0)==1):0)CR(l);f[U>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[W>>2]|0)>0){nb=f[X>>2]|0;jb=0;do{f[nb+(jb<<2)>>2]=0;jb=jb+1|0}while((jb|0)<(f[W>>2]|0))}jb=f[Z>>2]|0;if((jb|0)!=(_|0))ZF(jb)}else{jb=f[t>>2]|0;do if((f[jb>>2]&4095|0)==11){nb=f[ba>>2]|0;if(f[nb+16>>2]|0){mb=f[nb+4>>2]|0;if((mb|0)<3)Eb=Y(f[nb+12>>2]|0,f[nb+8>>2]|0)|0;else{pb=f[nb+40>>2]|0;nb=0;ob=1;while(1){qb=Y(f[pb+(nb<<2)>>2]|0,ob)|0;nb=nb+1|0;if((nb|0)==(mb|0)){Eb=qb;break}else ob=qb}}if(!((mb|0)==0|(Eb|0)==0)){ub=36;break}}f[m>>2]=ib;f[Ha>>2]=gb;f[Ia>>2]=lb;f[Ja>>2]=kb;FR(l,jb,m);ob=f[Ka>>2]|0;if(ob|0){nb=ob+12|0;f[nb>>2]=(f[nb>>2]|0)+1}nb=f[ga>>2]|0;if(nb|0?(ob=nb+12|0,nb=f[ob>>2]|0,f[ob>>2]=nb+-1,(nb|0)==1):0)CR(k);f[ga>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[ha>>2]|0)>0){nb=f[ia>>2]|0;ob=0;do{f[nb+(ob<<2)>>2]=0;ob=ob+1|0;Fb=f[ha>>2]|0}while((ob|0)<(Fb|0));f[k>>2]=f[l>>2];if((Fb|0)<3)ub=24;else ub=26}else{f[k>>2]=f[l>>2];ub=24}if((ub|0)==24){ub=0;ob=f[La>>2]|0;if((ob|0)<3){f[ha>>2]=ob;f[la>>2]=f[Ma>>2];f[na>>2]=f[Na>>2];ob=f[Oa>>2]|0;nb=f[aa>>2]|0;f[nb>>2]=f[ob>>2];f[nb+4>>2]=f[ob+4>>2]}else ub=26}if((ub|0)==26){ub=0;BR(k,l)}f[$>>2]=f[Pa>>2];f[ra>>2]=f[Qa>>2];f[ta>>2]=f[Ra>>2];f[va>>2]=f[Sa>>2];f[xa>>2]=f[Ta>>2];ob=f[Ka>>2]|0;f[ga>>2]=ob;if(ob|0?(nb=ob+12|0,ob=f[nb>>2]|0,f[nb>>2]=ob+-1,(ob|0)==1):0)CR(l);f[Ka>>2]=0;f[Pa>>2]=0;f[Pa+4>>2]=0;f[Pa+8>>2]=0;f[Pa+12>>2]=0;if((f[La>>2]|0)>0){ob=f[Ua>>2]|0;nb=0;do{f[ob+(nb<<2)>>2]=0;nb=nb+1|0}while((nb|0)<(f[La>>2]|0))}nb=f[Oa>>2]|0;if((nb|0)!=(Va|0))ZF(nb)}else ub=36;while(0);a:do if((ub|0)==36){ub=0;if(!Wa){if((kb|0)<=0)break;nb=f[$>>2]|0;ob=f[jb+16>>2]|0;mb=ib<<1;pb=f[ba>>2]|0;qb=f[pb+16>>2]|0;if((lb|0)<=0)break;Bb=f[f[aa>>2]>>2]|0;sb=f[f[jb+44>>2]>>2]|0;rb=f[f[pb+44>>2]>>2]|0;pb=0;while(1){vb=nb+(Y(Bb,pb)|0)|0;zb=pb+gb|0;Cb=ob+(Y(sb,zb)|0)+(mb<<1)|0;Ab=qb+(Y(rb,zb)|0)+(ib<<1)|0;zb=0;do{yb=d[Ab+(zb<<1)>>1]&1023;Gb=zb<<1;d[vb+(Gb<<1)>>1]=(h[5689984+(yb<<1)>>0]|0)+(j[Cb+(Gb<<1)>>1]|0);Hb=Gb|1;d[vb+(Hb<<1)>>1]=(h[5689984+(yb<<1)+1>>0]|0)+(j[Cb+(Hb<<1)>>1]|0);zb=zb+1|0}while((zb|0)<(lb|0));pb=pb+1|0;if((pb|0)>=(kb|0))break a}}if(f[Aa>>2]|0){if((kb|0)<=0)break;pb=f[$>>2]|0;rb=f[f[aa>>2]>>2]|0;qb=f[jb+16>>2]|0;mb=f[f[jb+44>>2]>>2]|0;sb=f[ba>>2]|0;ob=f[sb+16>>2]|0;Bb=f[f[sb+44>>2]>>2]|0;if((lb|0)>0)Ib=0;else break;while(1){sb=pb+(Y(rb,Ib)|0)|0;nb=Ib+gb|0;zb=qb+(Y(mb,nb)|0)+(ib<<2)|0;Cb=ob+(Y(Bb,nb)|0)+(ib<<2)|0;nb=0;do{vb=wNa(+n[zb+(nb<<2)>>2])|0;Ab=nb<<1;d[sb+(Ab<<1)>>1]=(vb+32768|0)>>>0<65536?vb:(vb|0)>0?32767:32768;vb=wNa(+n[Cb+(nb<<2)>>2])|0;d[sb+((Ab|1)<<1)>>1]=(vb+32768|0)>>>0<65536?vb:(vb|0)>0?32767:32768;nb=nb+1|0}while((nb|0)<(lb|0));Ib=Ib+1|0;if((Ib|0)>=(kb|0))break a}}f[l>>2]=ib;f[v>>2]=gb;f[Xa>>2]=lb;f[Ya>>2]=kb;FR(o,jb,l);Bb=Za;f[Bb>>2]=0;f[Bb+4>>2]=0;f[m>>2]=33619968;f[_a>>2]=k;WJ(o,m,f[k>>2]&7,1.0,0.0);Bb=f[$a>>2]|0;if(Bb|0?(ob=Bb+12|0,Bb=f[ob>>2]|0,f[ob>>2]=Bb+-1,(Bb|0)==1):0)CR(o);f[$a>>2]=0;f[ab>>2]=0;f[ab+4>>2]=0;f[ab+8>>2]=0;f[ab+12>>2]=0;if((f[bb>>2]|0)>0){Bb=f[cb>>2]|0;ob=0;do{f[Bb+(ob<<2)>>2]=0;ob=ob+1|0}while((ob|0)<(f[bb>>2]|0))}ob=f[db>>2]|0;if((ob|0)!=(eb|0))ZF(ob)}while(0);Bh[f[A>>2]&255](f[Q>>2]|0,e,k,f[S>>2]|0,T)}jb=f[ga>>2]|0;if(jb|0?(kb=jb+12|0,jb=f[kb>>2]|0,f[kb>>2]=jb+-1,(jb|0)==1):0)CR(k);f[ga>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[ha>>2]|0)>0){jb=f[ia>>2]|0;kb=0;do{f[jb+(kb<<2)>>2]=0;kb=kb+1|0}while((kb|0)<(f[ha>>2]|0))}kb=f[aa>>2]|0;if((kb|0)!=(a|0))ZF(kb);kb=f[Ba>>2]|0;if(kb|0?(jb=kb+12|0,kb=f[jb>>2]|0,f[jb>>2]=kb+-1,(kb|0)==1):0)CR(e);f[Ba>>2]=0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[Ca+8>>2]=0;f[Ca+12>>2]=0;if((f[Da>>2]|0)>0){kb=f[Ea>>2]|0;jb=0;do{f[kb+(jb<<2)>>2]=0;jb=jb+1|0}while((jb|0)<(f[Da>>2]|0))}jb=f[Fa>>2]|0;if((jb|0)!=(Ga|0))ZF(jb);ib=ib+r|0;jb=f[q>>2]|0;hb=f[jb+12>>2]|0;if((hb|0)<=(ib|0)){Jb=jb;break}else C=jb}}else Jb=fb;gb=gb+x|0;if((gb|0)>=(f[G>>2]|0))break;else fb=Jb}}Jb=i+36|0;fb=f[Jb>>2]|0;if(fb|0?(G=fb+12|0,fb=f[G>>2]|0,f[G>>2]=fb+-1,(fb|0)==1):0)CR(i);f[Jb>>2]=0;Jb=i+16|0;f[Jb>>2]=0;f[Jb+4>>2]=0;f[Jb+8>>2]=0;f[Jb+12>>2]=0;if((f[D>>2]|0)>0){Jb=f[F>>2]|0;F=0;do{f[Jb+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[D>>2]|0))}D=f[z>>2]|0;if((D|0)!=(E|0))ZF(D);D=g+36|0;E=f[D>>2]|0;if(E|0?(z=E+12|0,E=f[z>>2]|0,f[z>>2]=E+-1,(E|0)==1):0)CR(g);f[D>>2]=0;D=g+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[w>>2]|0)>0){D=f[y>>2]|0;y=0;do{f[D+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[w>>2]|0))}w=f[B>>2]|0;if((w|0)==(s|0)){u=c;return}ZF(w);u=c;return}function pga(a,c,e,g,i,k,l){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0;m=u;u=u+576|0;n=m+64|0;o=m+32|0;q=m;r=f[a+40>>2]|0;s=f[r+4>>2]|0;t=f[r>>2]|0;r=f[c+40>>2]|0;v=f[r+4>>2]|0;w=f[r>>2]|0;r=(f[a>>2]|0)>>>3;x=(r&511)+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{A=rNa(+p[l+((a&3)<<3)>>3])|0;b[n+a>>0]=A>>>0<256?A:(A|0)>0?255:0;a=a+1|0}while((a|0)!=(x|0));a=(k|0)!=5?k:4;l=s+-7|0;A=(l|0)>0?l:0;l=t+-7|0;B=(l|0)>0?l:0;if((f[c>>2]&16384|0)!=0?(f[e>>2]&16384|0)!=0:0){l=(f[g>>2]&16384|0)!=0;C=Y(l?w:1,v)|0;if(l){D=C;E=1}else{F=C;G=6}}else{F=v;G=6}if((G|0)==6)if((w|0)>0){D=F;E=w}else{u=m;return}w=c+16|0;F=c+44|0;c=e+16|0;v=e+44|0;e=g+16|0;C=g+44|0;g=(D|0)>0;l=x<<1;H=x*3|0;I=x<<2;J=x*5|0;K=x*6|0;L=x*7|0;M=z<<3;N=1-M|0;O=(k|0)==5;k=(a|0)==0;P=o+4|0;Q=o+8|0;R=o+12|0;S=o+16|0;T=o+20|0;U=o+24|0;V=o+28|0;W=(r|-512)^511;r=q+4|0;X=q+8|0;Z=q+12|0;_=q+16|0;$=q+20|0;aa=q+24|0;ba=q+28|0;ca=y;y=0;while(1){da=f[w>>2]|0;ea=Y(f[f[F>>2]>>2]|0,y)|0;fa=(f[c>>2]|0)+(Y(f[f[v>>2]>>2]|0,y)|0)|0;ga=(f[e>>2]|0)+(Y(f[f[C>>2]>>2]|0,y)|0)|0;if(g){ha=da+ea|0;ia=ca;ja=0;while(1){ka=da+(ea+(Y(x,ja)|0))|0;la=ja<<1;ma=d[fa+(la<<1)>>1]|0;na=ma<<16>>16;oa=na+-3|0;pa=d[fa+((la|1)<<1)>>1]|0;la=pa+-3|0;qa=i+(j[ga+(ja<<1)>>1]<<6<<1)|0;if(oa>>>0<A>>>0&la>>>0<B>>>0){ra=ia+(Y(la,z)|0)+(Y(oa,x)|0)|0;sa=0;while(1){ta=ra;ua=0;va=0;wa=qa;while(1){xa=Y(d[wa>>1]|0,h[ta>>0]|0)|0;ya=Y(d[wa+2>>1]|0,h[ta+x>>0]|0)|0;za=Y(d[wa+4>>1]|0,h[ta+l>>0]|0)|0;Aa=Y(d[wa+6>>1]|0,h[ta+H>>0]|0)|0;Ba=Y(d[wa+8>>1]|0,h[ta+I>>0]|0)|0;Ca=Y(d[wa+10>>1]|0,h[ta+J>>0]|0)|0;Da=Y(d[wa+12>>1]|0,h[ta+K>>0]|0)|0;va=xa+va+ya+za+Aa+Ba+Ca+Da+(Y(d[wa+14>>1]|0,h[ta+L>>0]|0)|0)|0;ua=ua+1|0;if((ua|0)==8)break;else{ta=ta+z|0;wa=wa+16|0}}wa=va+16384>>15;b[ha+sa>>0]=wa>>>0<256?wa:(wa|0)>0?255:0;sa=sa+1|0;if((sa|0)==(x|0)){Ea=ia;break}else ra=ra+M+N|0}}else{if(O?!(na>>>0<s>>>0&pa>>>0<t>>>0):0)Fa=ia;else G=19;do if((G|0)==19){G=0;if(k?(pa+5|0)<1|ma<<16>>16>-5&(oa|0)<(s|0)&(la|0)<(t|0)^1:0){K1a(ka|0,n|0,x|0)|0;Fa=ia;break}ra=Y(lL(oa,s,a)|0,x)|0;f[o>>2]=ra;sa=lL(la,t,a)|0;f[q>>2]=sa;sa=Y(lL(na+-2|0,s,a)|0,x)|0;f[P>>2]=sa;wa=lL(pa+-2|0,t,a)|0;f[r>>2]=wa;wa=Y(lL(na+-1|0,s,a)|0,x)|0;f[Q>>2]=wa;ta=lL(pa+-1|0,t,a)|0;f[X>>2]=ta;ta=Y(lL(na,s,a)|0,x)|0;f[R>>2]=ta;ua=lL(pa,t,a)|0;f[Z>>2]=ua;ua=Y(lL(na+1|0,s,a)|0,x)|0;f[S>>2]=ua;Da=lL(pa+1|0,t,a)|0;f[_>>2]=Da;Da=Y(lL(na+2|0,s,a)|0,x)|0;f[T>>2]=Da;Ca=lL(pa+2|0,t,a)|0;f[$>>2]=Ca;Ca=Y(lL(na+3|0,s,a)|0,x)|0;f[U>>2]=Ca;Ba=lL(pa+3|0,t,a)|0;f[aa>>2]=Ba;Ba=Y(lL(na+4|0,s,a)|0,x)|0;f[V>>2]=Ba;Aa=lL(pa+4|0,t,a)|0;f[ba>>2]=Aa;Aa=ra;ra=sa;sa=wa;wa=ta;ta=ua;ua=Da;Da=Ca;Ca=Ba;Ba=ia;za=0;while(1){ya=h[n+za>>0]|0;xa=ya<<15;Ga=(ra|0)>-1;Ha=(sa|0)>-1;Ia=(wa|0)>-1;Ja=(ta|0)>-1;Ka=(ua|0)>-1;La=(Da|0)>-1;Ma=(Ca|0)>-1;if((Aa|0)>-1){Na=0;Oa=xa;Pa=qa;while(1){Qa=f[q+(Na<<2)>>2]|0;Ra=Ba+(Y(Qa,z)|0)|0;do if((Qa|0)<0)Sa=Oa;else{Ta=(Y((h[Ra+Aa>>0]|0)-ya|0,d[Pa>>1]|0)|0)+Oa|0;if(Ga)Ua=(Y((h[Ra+ra>>0]|0)-ya|0,d[Pa+2>>1]|0)|0)+Ta|0;else Ua=Ta;if(Ha)Va=(Y((h[Ra+sa>>0]|0)-ya|0,d[Pa+4>>1]|0)|0)+Ua|0;else Va=Ua;if(Ia)Wa=(Y((h[Ra+wa>>0]|0)-ya|0,d[Pa+6>>1]|0)|0)+Va|0;else Wa=Va;if(Ja)Xa=(Y((h[Ra+ta>>0]|0)-ya|0,d[Pa+8>>1]|0)|0)+Wa|0;else Xa=Wa;if(Ka)Ya=(Y((h[Ra+ua>>0]|0)-ya|0,d[Pa+10>>1]|0)|0)+Xa|0;else Ya=Xa;if(La)Za=(Y((h[Ra+Da>>0]|0)-ya|0,d[Pa+12>>1]|0)|0)+Ya|0;else Za=Ya;if(!Ma){Sa=Za;break}Sa=(Y((h[Ra+Ca>>0]|0)-ya|0,d[Pa+14>>1]|0)|0)+Za|0}while(0);Na=Na+1|0;if((Na|0)==8){_a=Sa;break}else{Oa=Sa;Pa=Pa+16|0}}}else{Pa=0;Oa=xa;Na=qa;while(1){Ra=f[q+(Pa<<2)>>2]|0;Qa=Ba+(Y(Ra,z)|0)|0;do if((Ra|0)<0)$a=Oa;else{if(Ga)ab=(Y((h[Qa+ra>>0]|0)-ya|0,d[Na+2>>1]|0)|0)+Oa|0;else ab=Oa;if(Ha)bb=(Y((h[Qa+sa>>0]|0)-ya|0,d[Na+4>>1]|0)|0)+ab|0;else bb=ab;if(Ia)cb=(Y((h[Qa+wa>>0]|0)-ya|0,d[Na+6>>1]|0)|0)+bb|0;else cb=bb;if(Ja)db=(Y((h[Qa+ta>>0]|0)-ya|0,d[Na+8>>1]|0)|0)+cb|0;else db=cb;if(Ka)eb=(Y((h[Qa+ua>>0]|0)-ya|0,d[Na+10>>1]|0)|0)+db|0;else eb=db;if(La)fb=(Y((h[Qa+Da>>0]|0)-ya|0,d[Na+12>>1]|0)|0)+eb|0;else fb=eb;if(!Ma){$a=fb;break}$a=(Y((h[Qa+Ca>>0]|0)-ya|0,d[Na+14>>1]|0)|0)+fb|0}while(0);Pa=Pa+1|0;if((Pa|0)==8){_a=$a;break}else{Oa=$a;Na=Na+16|0}}}Na=_a+16384>>15;b[ha+za>>0]=Na>>>0<256?Na:(Na|0)>0?255:0;Na=za+1|0;if((Na|0)==(x|0))break;Aa=f[o>>2]|0;ra=f[P>>2]|0;sa=f[Q>>2]|0;wa=f[R>>2]|0;ta=f[S>>2]|0;ua=f[T>>2]|0;Da=f[U>>2]|0;Ca=f[V>>2]|0;Ba=Ba+1|0;za=Na}Fa=ia+x+W|0}while(0);Ea=Fa}ja=ja+1|0;if((ja|0)==(D|0)){gb=Ea;break}else{ha=ha+x|0;ia=Ea}}}else gb=ca;y=y+1|0;if((y|0)==(E|0))break;else ca=gb}u=m;return}function qga(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0.0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0;k=u;u=u+1088|0;l=k+64|0;m=k+32|0;o=k;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>1;a=0;do{A=rNa(+p[i+((a&3)<<3)>>3])|0;d[l+(a<<1)>>1]=A>>>0<65536?A:(A|0)>0?65535:0;a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-7|0;A=(i|0)>0?i:0;i=s+-7|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=x<<2;J=x*5|0;K=x*6|0;L=x*7|0;M=z<<3;N=1-M|0;O=(h|0)==5;h=(a|0)==0;P=m+4|0;Q=m+8|0;R=m+12|0;S=m+16|0;T=m+20|0;U=m+24|0;V=m+28|0;W=(q|-512)^511;q=(w<<1)+2|0;w=o+4|0;X=o+8|0;Z=o+12|0;_=o+16|0;$=o+20|0;aa=o+24|0;ba=o+28|0;ca=y;y=0;while(1){da=f[v>>2]|0;ea=Y(f[f[F>>2]>>2]|0,y)|0;fa=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,y)|0)|0;ga=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,y)|0)|0;if(e){ha=da+ea|0;ia=ca;ja=0;while(1){ka=da+(ea+(Y(q,ja)|0))|0;la=ja<<1;ma=d[fa+(la<<1)>>1]|0;na=ma<<16>>16;oa=na+-3|0;pa=d[fa+((la|1)<<1)>>1]|0;la=pa+-3|0;qa=g+(j[ga+(ja<<1)>>1]<<6<<2)|0;if(oa>>>0<A>>>0&la>>>0<B>>>0){ra=ia+((Y(la,z)|0)<<1)+((Y(oa,x)|0)<<1)|0;sa=0;while(1){ta=ra;ua=0;va=0.0;wa=qa;while(1){va=va+(+(j[ta>>1]|0)*+n[wa>>2]+ +(j[ta+(x<<1)>>1]|0)*+n[wa+4>>2]+ +(j[ta+(i<<1)>>1]|0)*+n[wa+8>>2]+ +(j[ta+(H<<1)>>1]|0)*+n[wa+12>>2]+ +(j[ta+(I<<1)>>1]|0)*+n[wa+16>>2]+ +(j[ta+(J<<1)>>1]|0)*+n[wa+20>>2]+ +(j[ta+(K<<1)>>1]|0)*+n[wa+24>>2]+ +(j[ta+(L<<1)>>1]|0)*+n[wa+28>>2]);ua=ua+1|0;if((ua|0)==8)break;else{ta=ta+(z<<1)|0;wa=wa+32|0}}wa=wNa(va)|0;d[ha+(sa<<1)>>1]=wa>>>0<65536?wa:(wa|0)>0?65535:0;sa=sa+1|0;if((sa|0)==(x|0)){xa=ia;break}else ra=ra+(M<<1)+(N<<1)|0}}else{if(O?!(na>>>0<r>>>0&pa>>>0<s>>>0):0)ya=ia;else G=19;do if((G|0)==19){G=0;if(h?(pa+5|0)<1|ma<<16>>16>-5&(oa|0)<(r|0)&(la|0)<(s|0)^1:0){K1a(ka|0,l|0,q|0)|0;ya=ia;break}ra=Y(lL(oa,r,a)|0,x)|0;f[m>>2]=ra;sa=lL(la,s,a)|0;f[o>>2]=sa;sa=Y(lL(na+-2|0,r,a)|0,x)|0;f[P>>2]=sa;wa=lL(pa+-2|0,s,a)|0;f[w>>2]=wa;wa=Y(lL(na+-1|0,r,a)|0,x)|0;f[Q>>2]=wa;ta=lL(pa+-1|0,s,a)|0;f[X>>2]=ta;ta=Y(lL(na,r,a)|0,x)|0;f[R>>2]=ta;ua=lL(pa,s,a)|0;f[Z>>2]=ua;ua=Y(lL(na+1|0,r,a)|0,x)|0;f[S>>2]=ua;za=lL(pa+1|0,s,a)|0;f[_>>2]=za;za=Y(lL(na+2|0,r,a)|0,x)|0;f[T>>2]=za;Aa=lL(pa+2|0,s,a)|0;f[$>>2]=Aa;Aa=Y(lL(na+3|0,r,a)|0,x)|0;f[U>>2]=Aa;Ba=lL(pa+3|0,s,a)|0;f[aa>>2]=Ba;Ba=Y(lL(na+4|0,r,a)|0,x)|0;f[V>>2]=Ba;Ca=lL(pa+4|0,s,a)|0;f[ba>>2]=Ca;Ca=ra;ra=sa;sa=wa;wa=ta;ta=ua;ua=za;za=Aa;Aa=Ba;Ba=ia;Da=0;while(1){Ea=+(j[l+(Da<<1)>>1]|0);Fa=(ra|0)>-1;Ga=(sa|0)>-1;Ha=(wa|0)>-1;Ia=(ta|0)>-1;Ja=(ua|0)>-1;Ka=(za|0)>-1;La=(Aa|0)>-1;if((Ca|0)>-1){Ma=0;Na=Ea;Oa=qa;while(1){Pa=f[o+(Ma<<2)>>2]|0;Qa=Ba+((Y(Pa,z)|0)<<1)|0;do if((Pa|0)<0)Ra=Na;else{Sa=Na+ +n[Oa>>2]*(+(j[Qa+(Ca<<1)>>1]|0)-Ea);if(Fa)Ta=Sa+ +n[Oa+4>>2]*(+(j[Qa+(ra<<1)>>1]|0)-Ea);else Ta=Sa;if(Ga)Ua=Ta+ +n[Oa+8>>2]*(+(j[Qa+(sa<<1)>>1]|0)-Ea);else Ua=Ta;if(Ha)Va=Ua+ +n[Oa+12>>2]*(+(j[Qa+(wa<<1)>>1]|0)-Ea);else Va=Ua;if(Ia)Wa=Va+ +n[Oa+16>>2]*(+(j[Qa+(ta<<1)>>1]|0)-Ea);else Wa=Va;if(Ja)Xa=Wa+ +n[Oa+20>>2]*(+(j[Qa+(ua<<1)>>1]|0)-Ea);else Xa=Wa;if(Ka)Ya=Xa+ +n[Oa+24>>2]*(+(j[Qa+(za<<1)>>1]|0)-Ea);else Ya=Xa;if(!La){Ra=Ya;break}Ra=Ya+ +n[Oa+28>>2]*(+(j[Qa+(Aa<<1)>>1]|0)-Ea)}while(0);Ma=Ma+1|0;if((Ma|0)==8){Za=Ra;break}else{Na=Ra;Oa=Oa+32|0}}}else{Oa=0;Na=Ea;Ma=qa;while(1){Qa=f[o+(Oa<<2)>>2]|0;Pa=Ba+((Y(Qa,z)|0)<<1)|0;do if((Qa|0)<0)_a=Na;else{if(Fa)$a=Na+ +n[Ma+4>>2]*(+(j[Pa+(ra<<1)>>1]|0)-Ea);else $a=Na;if(Ga)ab=$a+ +n[Ma+8>>2]*(+(j[Pa+(sa<<1)>>1]|0)-Ea);else ab=$a;if(Ha)bb=ab+ +n[Ma+12>>2]*(+(j[Pa+(wa<<1)>>1]|0)-Ea);else bb=ab;if(Ia)cb=bb+ +n[Ma+16>>2]*(+(j[Pa+(ta<<1)>>1]|0)-Ea);else cb=bb;if(Ja)db=cb+ +n[Ma+20>>2]*(+(j[Pa+(ua<<1)>>1]|0)-Ea);else db=cb;if(Ka)eb=db+ +n[Ma+24>>2]*(+(j[Pa+(za<<1)>>1]|0)-Ea);else eb=db;if(!La){_a=eb;break}_a=eb+ +n[Ma+28>>2]*(+(j[Pa+(Aa<<1)>>1]|0)-Ea)}while(0);Oa=Oa+1|0;if((Oa|0)==8){Za=_a;break}else{Na=_a;Ma=Ma+32|0}}}Ma=wNa(Za)|0;d[ha+(Da<<1)>>1]=Ma>>>0<65536?Ma:(Ma|0)>0?65535:0;Ma=Da+1|0;if((Ma|0)==(x|0))break;Ca=f[m>>2]|0;ra=f[P>>2]|0;sa=f[Q>>2]|0;wa=f[R>>2]|0;ta=f[S>>2]|0;ua=f[T>>2]|0;za=f[U>>2]|0;Aa=f[V>>2]|0;Ba=Ba+2|0;Da=Ma}ya=ia+(x<<1)+(W<<1)|0}while(0);xa=ya}ja=ja+1|0;if((ja|0)==(D|0)){fb=xa;break}else{ha=ha+(x<<1)|0;ia=xa}}}else fb=ca;y=y+1|0;if((y|0)==(E|0))break;else ca=fb}u=k;return}function rga(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0.0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0;k=u;u=u+1088|0;l=k+64|0;m=k+32|0;o=k;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>1;a=0;do{A=rNa(+p[i+((a&3)<<3)>>3])|0;d[l+(a<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-7|0;A=(i|0)>0?i:0;i=s+-7|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=x<<2;J=x*5|0;K=x*6|0;L=x*7|0;M=z<<3;N=1-M|0;O=(h|0)==5;h=(a|0)==0;P=m+4|0;Q=m+8|0;R=m+12|0;S=m+16|0;T=m+20|0;U=m+24|0;V=m+28|0;W=(q|-512)^511;q=(w<<1)+2|0;w=o+4|0;X=o+8|0;Z=o+12|0;_=o+16|0;$=o+20|0;aa=o+24|0;ba=o+28|0;ca=y;y=0;while(1){da=f[v>>2]|0;ea=Y(f[f[F>>2]>>2]|0,y)|0;fa=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,y)|0)|0;ga=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,y)|0)|0;if(e){ha=da+ea|0;ia=ca;ja=0;while(1){ka=da+(ea+(Y(q,ja)|0))|0;la=ja<<1;ma=d[fa+(la<<1)>>1]|0;na=ma<<16>>16;oa=na+-3|0;pa=d[fa+((la|1)<<1)>>1]|0;la=pa+-3|0;qa=g+(j[ga+(ja<<1)>>1]<<6<<2)|0;if(oa>>>0<A>>>0&la>>>0<B>>>0){ra=ia+((Y(la,z)|0)<<1)+((Y(oa,x)|0)<<1)|0;sa=0;while(1){ta=ra;ua=0;va=0.0;wa=qa;while(1){va=va+(+(d[ta>>1]|0)*+n[wa>>2]+ +(d[ta+(x<<1)>>1]|0)*+n[wa+4>>2]+ +(d[ta+(i<<1)>>1]|0)*+n[wa+8>>2]+ +(d[ta+(H<<1)>>1]|0)*+n[wa+12>>2]+ +(d[ta+(I<<1)>>1]|0)*+n[wa+16>>2]+ +(d[ta+(J<<1)>>1]|0)*+n[wa+20>>2]+ +(d[ta+(K<<1)>>1]|0)*+n[wa+24>>2]+ +(d[ta+(L<<1)>>1]|0)*+n[wa+28>>2]);ua=ua+1|0;if((ua|0)==8)break;else{ta=ta+(z<<1)|0;wa=wa+32|0}}wa=wNa(va)|0;d[ha+(sa<<1)>>1]=(wa+32768|0)>>>0<65536?wa:(wa|0)>0?32767:32768;sa=sa+1|0;if((sa|0)==(x|0)){xa=ia;break}else ra=ra+(M<<1)+(N<<1)|0}}else{if(O?!(na>>>0<r>>>0&pa>>>0<s>>>0):0)ya=ia;else G=19;do if((G|0)==19){G=0;if(h?(pa+5|0)<1|ma<<16>>16>-5&(oa|0)<(r|0)&(la|0)<(s|0)^1:0){K1a(ka|0,l|0,q|0)|0;ya=ia;break}ra=Y(lL(oa,r,a)|0,x)|0;f[m>>2]=ra;sa=lL(la,s,a)|0;f[o>>2]=sa;sa=Y(lL(na+-2|0,r,a)|0,x)|0;f[P>>2]=sa;wa=lL(pa+-2|0,s,a)|0;f[w>>2]=wa;wa=Y(lL(na+-1|0,r,a)|0,x)|0;f[Q>>2]=wa;ta=lL(pa+-1|0,s,a)|0;f[X>>2]=ta;ta=Y(lL(na,r,a)|0,x)|0;f[R>>2]=ta;ua=lL(pa,s,a)|0;f[Z>>2]=ua;ua=Y(lL(na+1|0,r,a)|0,x)|0;f[S>>2]=ua;za=lL(pa+1|0,s,a)|0;f[_>>2]=za;za=Y(lL(na+2|0,r,a)|0,x)|0;f[T>>2]=za;Aa=lL(pa+2|0,s,a)|0;f[$>>2]=Aa;Aa=Y(lL(na+3|0,r,a)|0,x)|0;f[U>>2]=Aa;Ba=lL(pa+3|0,s,a)|0;f[aa>>2]=Ba;Ba=Y(lL(na+4|0,r,a)|0,x)|0;f[V>>2]=Ba;Ca=lL(pa+4|0,s,a)|0;f[ba>>2]=Ca;Ca=ra;ra=sa;sa=wa;wa=ta;ta=ua;ua=za;za=Aa;Aa=Ba;Ba=ia;Da=0;while(1){Ea=+(d[l+(Da<<1)>>1]|0);Fa=(ra|0)>-1;Ga=(sa|0)>-1;Ha=(wa|0)>-1;Ia=(ta|0)>-1;Ja=(ua|0)>-1;Ka=(za|0)>-1;La=(Aa|0)>-1;if((Ca|0)>-1){Ma=0;Na=Ea;Oa=qa;while(1){Pa=f[o+(Ma<<2)>>2]|0;Qa=Ba+((Y(Pa,z)|0)<<1)|0;do if((Pa|0)<0)Ra=Na;else{Sa=Na+ +n[Oa>>2]*(+(d[Qa+(Ca<<1)>>1]|0)-Ea);if(Fa)Ta=Sa+ +n[Oa+4>>2]*(+(d[Qa+(ra<<1)>>1]|0)-Ea);else Ta=Sa;if(Ga)Ua=Ta+ +n[Oa+8>>2]*(+(d[Qa+(sa<<1)>>1]|0)-Ea);else Ua=Ta;if(Ha)Va=Ua+ +n[Oa+12>>2]*(+(d[Qa+(wa<<1)>>1]|0)-Ea);else Va=Ua;if(Ia)Wa=Va+ +n[Oa+16>>2]*(+(d[Qa+(ta<<1)>>1]|0)-Ea);else Wa=Va;if(Ja)Xa=Wa+ +n[Oa+20>>2]*(+(d[Qa+(ua<<1)>>1]|0)-Ea);else Xa=Wa;if(Ka)Ya=Xa+ +n[Oa+24>>2]*(+(d[Qa+(za<<1)>>1]|0)-Ea);else Ya=Xa;if(!La){Ra=Ya;break}Ra=Ya+ +n[Oa+28>>2]*(+(d[Qa+(Aa<<1)>>1]|0)-Ea)}while(0);Ma=Ma+1|0;if((Ma|0)==8){Za=Ra;break}else{Na=Ra;Oa=Oa+32|0}}}else{Oa=0;Na=Ea;Ma=qa;while(1){Qa=f[o+(Oa<<2)>>2]|0;Pa=Ba+((Y(Qa,z)|0)<<1)|0;do if((Qa|0)<0)_a=Na;else{if(Fa)$a=Na+ +n[Ma+4>>2]*(+(d[Pa+(ra<<1)>>1]|0)-Ea);else $a=Na;if(Ga)ab=$a+ +n[Ma+8>>2]*(+(d[Pa+(sa<<1)>>1]|0)-Ea);else ab=$a;if(Ha)bb=ab+ +n[Ma+12>>2]*(+(d[Pa+(wa<<1)>>1]|0)-Ea);else bb=ab;if(Ia)cb=bb+ +n[Ma+16>>2]*(+(d[Pa+(ta<<1)>>1]|0)-Ea);else cb=bb;if(Ja)db=cb+ +n[Ma+20>>2]*(+(d[Pa+(ua<<1)>>1]|0)-Ea);else db=cb;if(Ka)eb=db+ +n[Ma+24>>2]*(+(d[Pa+(za<<1)>>1]|0)-Ea);else eb=db;if(!La){_a=eb;break}_a=eb+ +n[Ma+28>>2]*(+(d[Pa+(Aa<<1)>>1]|0)-Ea)}while(0);Oa=Oa+1|0;if((Oa|0)==8){Za=_a;break}else{Na=_a;Ma=Ma+32|0}}}Ma=wNa(Za)|0;d[ha+(Da<<1)>>1]=(Ma+32768|0)>>>0<65536?Ma:(Ma|0)>0?32767:32768;Ma=Da+1|0;if((Ma|0)==(x|0))break;Ca=f[m>>2]|0;ra=f[P>>2]|0;sa=f[Q>>2]|0;wa=f[R>>2]|0;ta=f[S>>2]|0;ua=f[T>>2]|0;za=f[U>>2]|0;Aa=f[V>>2]|0;Ba=Ba+2|0;Da=Ma}ya=ia+(x<<1)+(W<<1)|0}while(0);xa=ya}ja=ja+1|0;if((ja|0)==(D|0)){fb=xa;break}else{ha=ha+(x<<1)|0;ia=xa}}}else fb=ca;y=y+1|0;if((y|0)==(E|0))break;else ca=fb}u=k;return}function sga(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0.0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0;k=u;u=u+2112|0;l=k+64|0;m=k+32|0;o=k;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>2;a=0;do{n[l+(a<<2)>>2]=+p[i+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-7|0;A=(i|0)>0?i:0;i=s+-7|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=x<<2;J=x*5|0;K=x*6|0;L=x*7|0;M=z<<3;N=1-M|0;O=(h|0)==5;h=(a|0)==0;P=m+4|0;Q=m+8|0;R=m+12|0;S=m+16|0;T=m+20|0;U=m+24|0;V=m+28|0;W=(q|-512)^511;q=(w<<2)+4|0;w=o+4|0;X=o+8|0;Z=o+12|0;_=o+16|0;$=o+20|0;aa=o+24|0;ba=o+28|0;ca=y;y=0;while(1){da=f[v>>2]|0;ea=Y(f[f[F>>2]>>2]|0,y)|0;fa=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,y)|0)|0;ga=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,y)|0)|0;if(e){ha=da+ea|0;ia=ca;ja=0;while(1){ka=da+(ea+(Y(q,ja)|0))|0;la=ja<<1;ma=d[fa+(la<<1)>>1]|0;na=ma<<16>>16;oa=na+-3|0;pa=d[fa+((la|1)<<1)>>1]|0;la=pa+-3|0;qa=g+(j[ga+(ja<<1)>>1]<<6<<2)|0;if(oa>>>0<A>>>0&la>>>0<B>>>0){ra=ia+((Y(la,z)|0)<<2)+((Y(oa,x)|0)<<2)|0;sa=0;while(1){ta=ra;ua=0;va=0.0;wa=qa;while(1){va=va+(+n[ta>>2]*+n[wa>>2]+ +n[ta+(x<<2)>>2]*+n[wa+4>>2]+ +n[ta+(i<<2)>>2]*+n[wa+8>>2]+ +n[ta+(H<<2)>>2]*+n[wa+12>>2]+ +n[ta+(I<<2)>>2]*+n[wa+16>>2]+ +n[ta+(J<<2)>>2]*+n[wa+20>>2]+ +n[ta+(K<<2)>>2]*+n[wa+24>>2]+ +n[ta+(L<<2)>>2]*+n[wa+28>>2]);ua=ua+1|0;if((ua|0)==8)break;else{ta=ta+(z<<2)|0;wa=wa+32|0}}n[ha+(sa<<2)>>2]=va;sa=sa+1|0;if((sa|0)==(x|0)){xa=ia;break}else ra=ra+(M<<2)+(N<<2)|0}}else{if(O?!(na>>>0<r>>>0&pa>>>0<s>>>0):0)ya=ia;else G=19;do if((G|0)==19){G=0;if(h?(pa+5|0)<1|ma<<16>>16>-5&(oa|0)<(r|0)&(la|0)<(s|0)^1:0){K1a(ka|0,l|0,q|0)|0;ya=ia;break}ra=Y(lL(oa,r,a)|0,x)|0;f[m>>2]=ra;sa=lL(la,s,a)|0;f[o>>2]=sa;sa=Y(lL(na+-2|0,r,a)|0,x)|0;f[P>>2]=sa;wa=lL(pa+-2|0,s,a)|0;f[w>>2]=wa;wa=Y(lL(na+-1|0,r,a)|0,x)|0;f[Q>>2]=wa;ta=lL(pa+-1|0,s,a)|0;f[X>>2]=ta;ta=Y(lL(na,r,a)|0,x)|0;f[R>>2]=ta;ua=lL(pa,s,a)|0;f[Z>>2]=ua;ua=Y(lL(na+1|0,r,a)|0,x)|0;f[S>>2]=ua;za=lL(pa+1|0,s,a)|0;f[_>>2]=za;za=Y(lL(na+2|0,r,a)|0,x)|0;f[T>>2]=za;Aa=lL(pa+2|0,s,a)|0;f[$>>2]=Aa;Aa=Y(lL(na+3|0,r,a)|0,x)|0;f[U>>2]=Aa;Ba=lL(pa+3|0,s,a)|0;f[aa>>2]=Ba;Ba=Y(lL(na+4|0,r,a)|0,x)|0;f[V>>2]=Ba;Ca=lL(pa+4|0,s,a)|0;f[ba>>2]=Ca;Ca=ra;ra=sa;sa=wa;wa=ta;ta=ua;ua=za;za=Aa;Aa=Ba;Ba=ia;Da=0;while(1){Ea=+n[l+(Da<<2)>>2];Fa=(ra|0)>-1;Ga=(sa|0)>-1;Ha=(wa|0)>-1;Ia=(ta|0)>-1;Ja=(ua|0)>-1;Ka=(za|0)>-1;La=(Aa|0)>-1;if((Ca|0)>-1){Ma=0;Na=Ea;Oa=qa;while(1){Pa=f[o+(Ma<<2)>>2]|0;Qa=Ba+((Y(Pa,z)|0)<<2)|0;do if((Pa|0)<0)Ra=Na;else{Sa=Na+(+n[Qa+(Ca<<2)>>2]-Ea)*+n[Oa>>2];if(Fa)Ta=Sa+(+n[Qa+(ra<<2)>>2]-Ea)*+n[Oa+4>>2];else Ta=Sa;if(Ga)Ua=Ta+(+n[Qa+(sa<<2)>>2]-Ea)*+n[Oa+8>>2];else Ua=Ta;if(Ha)Va=Ua+(+n[Qa+(wa<<2)>>2]-Ea)*+n[Oa+12>>2];else Va=Ua;if(Ia)Wa=Va+(+n[Qa+(ta<<2)>>2]-Ea)*+n[Oa+16>>2];else Wa=Va;if(Ja)Xa=Wa+(+n[Qa+(ua<<2)>>2]-Ea)*+n[Oa+20>>2];else Xa=Wa;if(Ka)Ya=Xa+(+n[Qa+(za<<2)>>2]-Ea)*+n[Oa+24>>2];else Ya=Xa;if(!La){Ra=Ya;break}Ra=Ya+(+n[Qa+(Aa<<2)>>2]-Ea)*+n[Oa+28>>2]}while(0);Ma=Ma+1|0;if((Ma|0)==8){Za=Ra;break}else{Na=Ra;Oa=Oa+32|0}}}else{Oa=0;Na=Ea;Ma=qa;while(1){Qa=f[o+(Oa<<2)>>2]|0;Pa=Ba+((Y(Qa,z)|0)<<2)|0;do if((Qa|0)<0)_a=Na;else{if(Fa)$a=Na+(+n[Pa+(ra<<2)>>2]-Ea)*+n[Ma+4>>2];else $a=Na;if(Ga)ab=$a+(+n[Pa+(sa<<2)>>2]-Ea)*+n[Ma+8>>2];else ab=$a;if(Ha)bb=ab+(+n[Pa+(wa<<2)>>2]-Ea)*+n[Ma+12>>2];else bb=ab;if(Ia)cb=bb+(+n[Pa+(ta<<2)>>2]-Ea)*+n[Ma+16>>2];else cb=bb;if(Ja)db=cb+(+n[Pa+(ua<<2)>>2]-Ea)*+n[Ma+20>>2];else db=cb;if(Ka)eb=db+(+n[Pa+(za<<2)>>2]-Ea)*+n[Ma+24>>2];else eb=db;if(!La){_a=eb;break}_a=eb+(+n[Pa+(Aa<<2)>>2]-Ea)*+n[Ma+28>>2]}while(0);Oa=Oa+1|0;if((Oa|0)==8){Za=_a;break}else{Na=_a;Ma=Ma+32|0}}}n[ha+(Da<<2)>>2]=Za;Ma=Da+1|0;if((Ma|0)==(x|0))break;Ca=f[m>>2]|0;ra=f[P>>2]|0;sa=f[Q>>2]|0;wa=f[R>>2]|0;ta=f[S>>2]|0;ua=f[T>>2]|0;za=f[U>>2]|0;Aa=f[V>>2]|0;Ba=Ba+4|0;Da=Ma}ya=ia+(x<<2)+(W<<2)|0}while(0);xa=ya}ja=ja+1|0;if((ja|0)==(D|0)){fb=xa;break}else{ha=ha+(x<<2)|0;ia=xa}}}else fb=ca;y=y+1|0;if((y|0)==(E|0))break;else ca=fb}u=k;return}function tga(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0.0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0;k=u;u=u+4160|0;l=k;m=k+4128|0;o=k+4096|0;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>3;a=0;do{p[l+(a<<3)>>3]=+p[i+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-7|0;A=(i|0)>0?i:0;i=s+-7|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=x<<2;J=x*5|0;K=x*6|0;L=x*7|0;M=z<<3;N=1-M|0;O=(h|0)==5;h=(a|0)==0;P=m+4|0;Q=m+8|0;R=m+12|0;S=m+16|0;T=m+20|0;U=m+24|0;V=m+28|0;W=(q|-512)^511;q=(w<<3)+8|0;w=o+4|0;X=o+8|0;Z=o+12|0;_=o+16|0;$=o+20|0;aa=o+24|0;ba=o+28|0;ca=y;y=0;while(1){da=f[v>>2]|0;ea=Y(f[f[F>>2]>>2]|0,y)|0;fa=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,y)|0)|0;ga=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,y)|0)|0;if(e){ha=da+ea|0;ia=ca;ja=0;while(1){ka=da+(ea+(Y(q,ja)|0))|0;la=ja<<1;ma=d[fa+(la<<1)>>1]|0;na=ma<<16>>16;oa=na+-3|0;pa=d[fa+((la|1)<<1)>>1]|0;la=pa+-3|0;qa=g+(j[ga+(ja<<1)>>1]<<6<<2)|0;if(oa>>>0<A>>>0&la>>>0<B>>>0){ra=ia+((Y(la,z)|0)<<3)+((Y(oa,x)|0)<<3)|0;sa=0;while(1){ta=ra;ua=0;va=0.0;wa=qa;while(1){va=va+(+p[ta>>3]*+n[wa>>2]+ +p[ta+(x<<3)>>3]*+n[wa+4>>2]+ +p[ta+(i<<3)>>3]*+n[wa+8>>2]+ +p[ta+(H<<3)>>3]*+n[wa+12>>2]+ +p[ta+(I<<3)>>3]*+n[wa+16>>2]+ +p[ta+(J<<3)>>3]*+n[wa+20>>2]+ +p[ta+(K<<3)>>3]*+n[wa+24>>2]+ +p[ta+(L<<3)>>3]*+n[wa+28>>2]);ua=ua+1|0;if((ua|0)==8)break;else{ta=ta+(z<<3)|0;wa=wa+32|0}}p[ha+(sa<<3)>>3]=va;sa=sa+1|0;if((sa|0)==(x|0)){xa=ia;break}else ra=ra+(M<<3)+(N<<3)|0}}else{if(O?!(na>>>0<r>>>0&pa>>>0<s>>>0):0)ya=ia;else G=19;do if((G|0)==19){G=0;if(h?(pa+5|0)<1|ma<<16>>16>-5&(oa|0)<(r|0)&(la|0)<(s|0)^1:0){K1a(ka|0,l|0,q|0)|0;ya=ia;break}ra=Y(lL(oa,r,a)|0,x)|0;f[m>>2]=ra;sa=lL(la,s,a)|0;f[o>>2]=sa;sa=Y(lL(na+-2|0,r,a)|0,x)|0;f[P>>2]=sa;wa=lL(pa+-2|0,s,a)|0;f[w>>2]=wa;wa=Y(lL(na+-1|0,r,a)|0,x)|0;f[Q>>2]=wa;ta=lL(pa+-1|0,s,a)|0;f[X>>2]=ta;ta=Y(lL(na,r,a)|0,x)|0;f[R>>2]=ta;ua=lL(pa,s,a)|0;f[Z>>2]=ua;ua=Y(lL(na+1|0,r,a)|0,x)|0;f[S>>2]=ua;za=lL(pa+1|0,s,a)|0;f[_>>2]=za;za=Y(lL(na+2|0,r,a)|0,x)|0;f[T>>2]=za;Aa=lL(pa+2|0,s,a)|0;f[$>>2]=Aa;Aa=Y(lL(na+3|0,r,a)|0,x)|0;f[U>>2]=Aa;Ba=lL(pa+3|0,s,a)|0;f[aa>>2]=Ba;Ba=Y(lL(na+4|0,r,a)|0,x)|0;f[V>>2]=Ba;Ca=lL(pa+4|0,s,a)|0;f[ba>>2]=Ca;Ca=ra;ra=sa;sa=wa;wa=ta;ta=ua;ua=za;za=Aa;Aa=Ba;Ba=ia;Da=0;while(1){Ea=+p[l+(Da<<3)>>3];Fa=(ra|0)>-1;Ga=(sa|0)>-1;Ha=(wa|0)>-1;Ia=(ta|0)>-1;Ja=(ua|0)>-1;Ka=(za|0)>-1;La=(Aa|0)>-1;if((Ca|0)>-1){Ma=0;Na=Ea;Oa=qa;while(1){Pa=f[o+(Ma<<2)>>2]|0;Qa=Ba+((Y(Pa,z)|0)<<3)|0;do if((Pa|0)<0)Ra=Na;else{Sa=Na+(+p[Qa+(Ca<<3)>>3]-Ea)*+n[Oa>>2];if(Fa)Ta=Sa+(+p[Qa+(ra<<3)>>3]-Ea)*+n[Oa+4>>2];else Ta=Sa;if(Ga)Ua=Ta+(+p[Qa+(sa<<3)>>3]-Ea)*+n[Oa+8>>2];else Ua=Ta;if(Ha)Va=Ua+(+p[Qa+(wa<<3)>>3]-Ea)*+n[Oa+12>>2];else Va=Ua;if(Ia)Wa=Va+(+p[Qa+(ta<<3)>>3]-Ea)*+n[Oa+16>>2];else Wa=Va;if(Ja)Xa=Wa+(+p[Qa+(ua<<3)>>3]-Ea)*+n[Oa+20>>2];else Xa=Wa;if(Ka)Ya=Xa+(+p[Qa+(za<<3)>>3]-Ea)*+n[Oa+24>>2];else Ya=Xa;if(!La){Ra=Ya;break}Ra=Ya+(+p[Qa+(Aa<<3)>>3]-Ea)*+n[Oa+28>>2]}while(0);Ma=Ma+1|0;if((Ma|0)==8){Za=Ra;break}else{Na=Ra;Oa=Oa+32|0}}}else{Oa=0;Na=Ea;Ma=qa;while(1){Qa=f[o+(Oa<<2)>>2]|0;Pa=Ba+((Y(Qa,z)|0)<<3)|0;do if((Qa|0)<0)_a=Na;else{if(Fa)$a=Na+(+p[Pa+(ra<<3)>>3]-Ea)*+n[Ma+4>>2];else $a=Na;if(Ga)ab=$a+(+p[Pa+(sa<<3)>>3]-Ea)*+n[Ma+8>>2];else ab=$a;if(Ha)bb=ab+(+p[Pa+(wa<<3)>>3]-Ea)*+n[Ma+12>>2];else bb=ab;if(Ia)cb=bb+(+p[Pa+(ta<<3)>>3]-Ea)*+n[Ma+16>>2];else cb=bb;if(Ja)db=cb+(+p[Pa+(ua<<3)>>3]-Ea)*+n[Ma+20>>2];else db=cb;if(Ka)eb=db+(+p[Pa+(za<<3)>>3]-Ea)*+n[Ma+24>>2];else eb=db;if(!La){_a=eb;break}_a=eb+(+p[Pa+(Aa<<3)>>3]-Ea)*+n[Ma+28>>2]}while(0);Oa=Oa+1|0;if((Oa|0)==8){Za=_a;break}else{Na=_a;Ma=Ma+32|0}}}p[ha+(Da<<3)>>3]=Za;Ma=Da+1|0;if((Ma|0)==(x|0))break;Ca=f[m>>2]|0;ra=f[P>>2]|0;sa=f[Q>>2]|0;wa=f[R>>2]|0;ta=f[S>>2]|0;ua=f[T>>2]|0;za=f[U>>2]|0;Aa=f[V>>2]|0;Ba=Ba+8|0;Da=Ma}ya=ia+(x<<3)+(W<<3)|0}while(0);xa=ya}ja=ja+1|0;if((ja|0)==(D|0)){fb=xa;break}else{ha=ha+(x<<3)|0;ia=xa}}}else fb=ca;y=y+1|0;if((y|0)==(E|0))break;else ca=fb}u=k;return}function uga(a,c,e,g,i,k,l){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0;m=u;u=u+544|0;n=m+32|0;o=m+16|0;q=m;r=f[a+40>>2]|0;s=f[r+4>>2]|0;t=f[r>>2]|0;r=f[c+40>>2]|0;v=f[r+4>>2]|0;w=f[r>>2]|0;r=(f[a>>2]|0)>>>3;x=(r&511)+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{A=rNa(+p[l+((a&3)<<3)>>3])|0;b[n+a>>0]=A>>>0<256?A:(A|0)>0?255:0;a=a+1|0}while((a|0)!=(x|0));a=(k|0)!=5?k:4;l=s+-3|0;A=(l|0)>0?l:0;l=t+-3|0;B=(l|0)>0?l:0;if((f[c>>2]&16384|0)!=0?(f[e>>2]&16384|0)!=0:0){l=(f[g>>2]&16384|0)!=0;C=Y(l?w:1,v)|0;if(l){D=C;E=1}else{F=C;G=6}}else{F=v;G=6}if((G|0)==6)if((w|0)>0){D=F;E=w}else{u=m;return}w=c+16|0;F=c+44|0;c=e+16|0;v=e+44|0;e=g+16|0;C=g+44|0;g=(D|0)>0;l=x<<1;H=x*3|0;I=(Y(z,-3)|0)+1|0;J=(k|0)==5;k=(a|0)==0;K=o+4|0;L=o+8|0;M=o+12|0;N=(r|-512)^511;r=q+4|0;O=q+8|0;P=q+12|0;Q=y;y=0;while(1){R=f[w>>2]|0;S=Y(f[f[F>>2]>>2]|0,y)|0;T=(f[c>>2]|0)+(Y(f[f[v>>2]>>2]|0,y)|0)|0;U=(f[e>>2]|0)+(Y(f[f[C>>2]>>2]|0,y)|0)|0;if(g){V=R+S|0;W=Q;X=0;while(1){Z=R+(S+(Y(x,X)|0))|0;_=X<<1;$=d[T+(_<<1)>>1]|0;aa=$+-1|0;ba=d[T+((_|1)<<1)>>1]|0;_=ba+-1|0;ca=i+(j[U+(X<<1)>>1]<<4<<1)|0;if(aa>>>0<A>>>0&_>>>0<B>>>0){da=ca+2|0;ea=ca+4|0;fa=ca+6|0;ga=ca+8|0;ha=ca+10|0;ia=ca+12|0;ja=ca+14|0;ka=ca+16|0;la=ca+18|0;ma=ca+20|0;na=ca+22|0;oa=ca+24|0;pa=ca+26|0;qa=ca+28|0;ra=ca+30|0;sa=W+(Y(_,z)|0)+(Y(aa,x)|0)|0;ta=0;while(1){ua=Y(d[ca>>1]|0,h[sa>>0]|0)|0;va=Y(d[da>>1]|0,h[sa+x>>0]|0)|0;wa=Y(d[ea>>1]|0,h[sa+l>>0]|0)|0;xa=Y(d[fa>>1]|0,h[sa+H>>0]|0)|0;ya=sa+z|0;za=Y(d[ga>>1]|0,h[ya>>0]|0)|0;Aa=Y(d[ha>>1]|0,h[ya+x>>0]|0)|0;Ba=Y(d[ia>>1]|0,h[ya+l>>0]|0)|0;Ca=Y(d[ja>>1]|0,h[ya+H>>0]|0)|0;Da=ya+z|0;ya=Y(d[ka>>1]|0,h[Da>>0]|0)|0;Ea=Y(d[la>>1]|0,h[Da+x>>0]|0)|0;Fa=Y(d[ma>>1]|0,h[Da+l>>0]|0)|0;Ga=Y(d[na>>1]|0,h[Da+H>>0]|0)|0;Ha=Da+z|0;Da=Y(d[oa>>1]|0,h[Ha>>0]|0)|0;Ia=Y(d[pa>>1]|0,h[Ha+x>>0]|0)|0;Ja=Y(d[qa>>1]|0,h[Ha+l>>0]|0)|0;Ka=ua+16384+va+wa+xa+za+Aa+Ba+Ca+ya+Ea+Fa+Ga+Da+Ia+Ja+(Y(d[ra>>1]|0,h[Ha+H>>0]|0)|0)>>15;b[V+ta>>0]=Ka>>>0<256?Ka:(Ka|0)>0?255:0;ta=ta+1|0;if((ta|0)==(x|0)){La=W;break}else sa=Ha+I|0}}else{if(J?!($>>>0<s>>>0&ba>>>0<t>>>0):0)Ma=W;else G=17;do if((G|0)==17){G=0;if(k?(ba+3|0)<1|((ba|0)>(t|0)|(($|0)>(s|0)|($+3|0)<1)):0){K1a(Z|0,n|0,x|0)|0;Ma=W;break}sa=Y(lL(aa,s,a)|0,x)|0;f[o>>2]=sa;ta=lL(_,t,a)|0;f[q>>2]=ta;ta=Y(lL($,s,a)|0,x)|0;f[K>>2]=ta;ra=lL(ba,t,a)|0;f[r>>2]=ra;ra=Y(lL($+1|0,s,a)|0,x)|0;f[L>>2]=ra;qa=lL(ba+1|0,t,a)|0;f[O>>2]=qa;qa=Y(lL($+2|0,s,a)|0,x)|0;f[M>>2]=qa;pa=lL(ba+2|0,t,a)|0;f[P>>2]=pa;pa=ca+8|0;oa=pa+8|0;na=oa+8|0;ma=na+2|0;la=na+4|0;ka=na+6|0;ja=oa+2|0;ia=oa+4|0;ha=oa+6|0;ga=pa+2|0;fa=pa+4|0;ea=pa+6|0;da=ca+2|0;Ha=ca+4|0;Ka=ca+6|0;Ja=ca+8|0;Ia=Ja+8|0;Da=Ia+8|0;Ga=Da+2|0;Fa=Da+4|0;Ea=Da+6|0;Da=Ia+2|0;ya=Ia+4|0;Ca=Ia+6|0;Ia=Ja+2|0;Ba=Ja+4|0;Aa=Ja+6|0;Ja=ca+2|0;za=ca+4|0;xa=ca+6|0;wa=ca+8|0;va=ca+16|0;ua=ca+24|0;Na=ua+4|0;Oa=ua+6|0;ua=va+4|0;Pa=va+6|0;va=wa+4|0;Qa=wa+6|0;wa=ca+4|0;Ra=ca+6|0;Sa=sa;sa=ta;ta=ra;ra=qa;qa=W;Ta=0;while(1){Ua=h[n+Ta>>0]|0;Va=Ua<<15;Wa=(sa|0)>-1;Xa=(ta|0)>-1;Ya=(ra|0)>-1;Za=f[q>>2]|0;_a=qa+(Y(Za,z)|0)|0;$a=(Za|0)<0;do if((Sa|0)>-1){if(!$a){Za=(Y((h[_a+Sa>>0]|0)-Ua|0,d[ca>>1]|0)|0)+Va|0;if(Wa)ab=(Y((h[_a+sa>>0]|0)-Ua|0,d[da>>1]|0)|0)+Za|0;else ab=Za;if(Xa)bb=(Y((h[_a+ta>>0]|0)-Ua|0,d[Ha>>1]|0)|0)+ab|0;else bb=ab;if(Ya)cb=(Y((h[_a+ra>>0]|0)-Ua|0,d[Ka>>1]|0)|0)+bb|0;else cb=bb}else cb=Va;Za=f[r>>2]|0;db=qa+(Y(Za,z)|0)|0;if((Za|0)>=0){Za=(Y((h[db+Sa>>0]|0)-Ua|0,d[pa>>1]|0)|0)+cb|0;if(Wa)eb=(Y((h[db+sa>>0]|0)-Ua|0,d[ga>>1]|0)|0)+Za|0;else eb=Za;if(Xa)fb=(Y((h[db+ta>>0]|0)-Ua|0,d[fa>>1]|0)|0)+eb|0;else fb=eb;if(Ya)gb=(Y((h[db+ra>>0]|0)-Ua|0,d[ea>>1]|0)|0)+fb|0;else gb=fb}else gb=cb;db=f[O>>2]|0;Za=qa+(Y(db,z)|0)|0;if((db|0)>=0){db=(Y((h[Za+Sa>>0]|0)-Ua|0,d[oa>>1]|0)|0)+gb|0;if(Wa)hb=(Y((h[Za+sa>>0]|0)-Ua|0,d[ja>>1]|0)|0)+db|0;else hb=db;if(Xa)ib=(Y((h[Za+ta>>0]|0)-Ua|0,d[ia>>1]|0)|0)+hb|0;else ib=hb;if(Ya)jb=(Y((h[Za+ra>>0]|0)-Ua|0,d[ha>>1]|0)|0)+ib|0;else jb=ib}else jb=gb;Za=f[P>>2]|0;db=qa+(Y(Za,z)|0)|0;if((Za|0)>=0){Za=(Y((h[db+Sa>>0]|0)-Ua|0,d[na>>1]|0)|0)+jb|0;if(Wa)kb=(Y((h[db+sa>>0]|0)-Ua|0,d[ma>>1]|0)|0)+Za|0;else kb=Za;if(Xa)lb=(Y((h[db+ta>>0]|0)-Ua|0,d[la>>1]|0)|0)+kb|0;else lb=kb;if(Ya)mb=(Y((h[db+ra>>0]|0)-Ua|0,d[ka>>1]|0)|0)+lb|0;else mb=lb}else mb=jb}else if(Wa){if(!$a){db=(Y((h[_a+sa>>0]|0)-Ua|0,d[Ja>>1]|0)|0)+Va|0;if(Xa)nb=(Y((h[_a+ta>>0]|0)-Ua|0,d[za>>1]|0)|0)+db|0;else nb=db;if(Ya)ob=(Y((h[_a+ra>>0]|0)-Ua|0,d[xa>>1]|0)|0)+nb|0;else ob=nb}else ob=Va;db=f[r>>2]|0;Za=qa+(Y(db,z)|0)|0;if((db|0)>=0){db=(Y((h[Za+sa>>0]|0)-Ua|0,d[Ia>>1]|0)|0)+ob|0;if(Xa)pb=(Y((h[Za+ta>>0]|0)-Ua|0,d[Ba>>1]|0)|0)+db|0;else pb=db;if(Ya)qb=(Y((h[Za+ra>>0]|0)-Ua|0,d[Aa>>1]|0)|0)+pb|0;else qb=pb}else qb=ob;Za=f[O>>2]|0;db=qa+(Y(Za,z)|0)|0;do if((Za|0)<0)rb=qb;else{sb=(Y((h[db+sa>>0]|0)-Ua|0,d[Da>>1]|0)|0)+qb|0;if(Xa)tb=(Y((h[db+ta>>0]|0)-Ua|0,d[ya>>1]|0)|0)+sb|0;else tb=sb;if(!Ya){rb=tb;break}rb=(Y((h[db+ra>>0]|0)-Ua|0,d[Ca>>1]|0)|0)+tb|0}while(0);db=f[P>>2]|0;Za=qa+(Y(db,z)|0)|0;if((db|0)<0){mb=rb;break}db=(Y((h[Za+sa>>0]|0)-Ua|0,d[Ga>>1]|0)|0)+rb|0;if(Xa)ub=(Y((h[Za+ta>>0]|0)-Ua|0,d[Fa>>1]|0)|0)+db|0;else ub=db;if(!Ya){mb=ub;break}mb=(Y((h[Za+ra>>0]|0)-Ua|0,d[Ea>>1]|0)|0)+ub|0;break}else{if(!$a){if(Xa)vb=(Y((h[_a+ta>>0]|0)-Ua|0,d[wa>>1]|0)|0)+Va|0;else vb=Va;if(Ya)wb=(Y((h[_a+ra>>0]|0)-Ua|0,d[Ra>>1]|0)|0)+vb|0;else wb=vb}else wb=Va;Za=f[r>>2]|0;db=qa+(Y(Za,z)|0)|0;if((Za|0)>=0){if(Xa)xb=(Y((h[db+ta>>0]|0)-Ua|0,d[va>>1]|0)|0)+wb|0;else xb=wb;if(Ya)yb=(Y((h[db+ra>>0]|0)-Ua|0,d[Qa>>1]|0)|0)+xb|0;else yb=xb}else yb=wb;db=f[O>>2]|0;Za=qa+(Y(db,z)|0)|0;do if((db|0)<0)zb=yb;else{if(Xa)Ab=(Y((h[Za+ta>>0]|0)-Ua|0,d[ua>>1]|0)|0)+yb|0;else Ab=yb;if(!Ya){zb=Ab;break}zb=(Y((h[Za+ra>>0]|0)-Ua|0,d[Pa>>1]|0)|0)+Ab|0}while(0);Za=f[P>>2]|0;db=qa+(Y(Za,z)|0)|0;if((Za|0)<0){mb=zb;break}if(Xa)Bb=(Y((h[db+ta>>0]|0)-Ua|0,d[Na>>1]|0)|0)+zb|0;else Bb=zb;if(!Ya){mb=Bb;break}mb=(Y((h[db+ra>>0]|0)-Ua|0,d[Oa>>1]|0)|0)+Bb|0;break}while(0);Ua=mb+16384>>15;b[V+Ta>>0]=Ua>>>0<256?Ua:(Ua|0)>0?255:0;Ua=Ta+1|0;if((Ua|0)==(x|0))break;Sa=f[o>>2]|0;sa=f[K>>2]|0;ta=f[L>>2]|0;ra=f[M>>2]|0;qa=qa+1|0;Ta=Ua}Ma=W+x+N|0}while(0);La=Ma}X=X+1|0;if((X|0)==(D|0)){Cb=La;break}else{V=V+x|0;W=La}}}else Cb=Q;y=y+1|0;if((y|0)==(E|0))break;else Q=Cb}u=m;return}function vga(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0,Db=0,Eb=0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0;k=u;u=u+1056|0;l=k+32|0;m=k+16|0;o=k;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>1;a=0;do{A=rNa(+p[i+((a&3)<<3)>>3])|0;d[l+(a<<1)>>1]=A>>>0<65536?A:(A|0)>0?65535:0;a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-3|0;A=(i|0)>0?i:0;i=s+-3|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=(Y(z,-3)|0)+1|0;J=(h|0)==5;h=(a|0)==0;K=m+4|0;L=m+8|0;M=m+12|0;N=(q|-512)^511;q=(w<<1)+2|0;w=o+4|0;O=o+8|0;P=o+12|0;Q=y;y=0;while(1){R=f[v>>2]|0;S=Y(f[f[F>>2]>>2]|0,y)|0;T=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,y)|0)|0;U=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,y)|0)|0;if(e){V=R+S|0;W=Q;X=0;while(1){Z=R+(S+(Y(q,X)|0))|0;_=X<<1;$=d[T+(_<<1)>>1]|0;aa=$+-1|0;ba=d[T+((_|1)<<1)>>1]|0;_=ba+-1|0;ca=g+(j[U+(X<<1)>>1]<<4<<2)|0;if(aa>>>0<A>>>0&_>>>0<B>>>0){da=W+((Y(_,z)|0)<<1)+((Y(aa,x)|0)<<1)|0;ea=+n[ca>>2];fa=+n[ca+4>>2];ga=+n[ca+8>>2];ha=+n[ca+12>>2];ia=+n[ca+16>>2];ja=+n[ca+20>>2];ka=+n[ca+24>>2];la=+n[ca+28>>2];ma=+n[ca+32>>2];na=+n[ca+36>>2];oa=+n[ca+40>>2];pa=+n[ca+44>>2];qa=+n[ca+48>>2];ra=+n[ca+52>>2];sa=+n[ca+56>>2];ta=+n[ca+60>>2];ua=da;da=0;while(1){va=ua+(z<<1)|0;wa=va+(z<<1)|0;xa=wa+(z<<1)|0;ya=wNa(+(j[ua>>1]|0)*ea+ +(j[ua+(x<<1)>>1]|0)*fa+ +(j[ua+(i<<1)>>1]|0)*ga+ +(j[ua+(H<<1)>>1]|0)*ha+(+(j[va>>1]|0)*ia+ +(j[va+(x<<1)>>1]|0)*ja+ +(j[va+(i<<1)>>1]|0)*ka+ +(j[va+(H<<1)>>1]|0)*la)+(+(j[wa>>1]|0)*ma+ +(j[wa+(x<<1)>>1]|0)*na+ +(j[wa+(i<<1)>>1]|0)*oa+ +(j[wa+(H<<1)>>1]|0)*pa)+(+(j[xa>>1]|0)*qa+ +(j[xa+(x<<1)>>1]|0)*ra+ +(j[xa+(i<<1)>>1]|0)*sa+ +(j[xa+(H<<1)>>1]|0)*ta))|0;d[V+(da<<1)>>1]=ya>>>0<65536?ya:(ya|0)>0?65535:0;da=da+1|0;if((da|0)==(x|0)){za=W;break}else ua=xa+(I<<1)|0}}else{if(J?!($>>>0<r>>>0&ba>>>0<s>>>0):0)Aa=W;else G=17;do if((G|0)==17){G=0;if(h?(ba+3|0)<1|((ba|0)>(s|0)|(($|0)>(r|0)|($+3|0)<1)):0){K1a(Z|0,l|0,q|0)|0;Aa=W;break}ua=Y(lL(aa,r,a)|0,x)|0;f[m>>2]=ua;da=lL(_,s,a)|0;f[o>>2]=da;xa=Y(lL($,r,a)|0,x)|0;f[K>>2]=xa;ya=lL(ba,s,a)|0;f[w>>2]=ya;wa=Y(lL($+1|0,r,a)|0,x)|0;f[L>>2]=wa;va=lL(ba+1|0,s,a)|0;f[O>>2]=va;Ba=Y(lL($+2|0,r,a)|0,x)|0;f[M>>2]=Ba;Ca=lL(ba+2|0,s,a)|0;f[P>>2]=Ca;Da=Y(da,z)|0;Ea=(da|0)<0;Fa=ca+16|0;Ga=Y(ya,z)|0;Ha=(ya|0)<0;Ia=Fa+16|0;Ja=Y(va,z)|0;Ka=(va|0)<0;La=Ia+16|0;Ma=Y(Ca,z)|0;Na=(Ca|0)<0;Oa=La+4|0;Pa=La+8|0;Qa=La+12|0;La=Ia+4|0;Ra=Ia+8|0;Sa=Ia+12|0;Ia=Fa+4|0;Ta=Fa+8|0;Ua=Fa+12|0;Fa=ca+4|0;Va=ca+8|0;Wa=ca+12|0;Xa=Y(da,z)|0;Ya=(da|0)<0;da=ca+16|0;Za=Y(ya,z)|0;_a=(ya|0)<0;ya=ca+32|0;$a=Y(va,z)|0;ab=(va|0)<0;va=ca+48|0;bb=Y(Ca,z)|0;cb=(Ca|0)<0;Ca=va+8|0;db=va+12|0;va=ya+8|0;eb=ya+12|0;ya=da+8|0;fb=da+12|0;da=ca+8|0;gb=ca+12|0;hb=ua;ua=xa;xa=wa;wa=Ba;Ba=W;ib=0;while(1){ta=+(j[l+(ib<<1)>>1]|0);jb=(ua|0)>-1;kb=(xa|0)>-1;lb=(wa|0)>-1;do if((hb|0)<=-1)if(jb){mb=Ba+(Da<<1)|0;if(!Ea){sa=ta+ +n[Fa>>2]*(+(j[mb+(ua<<1)>>1]|0)-ta);if(kb)nb=sa+ +n[Va>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else nb=sa;if(lb)ob=nb+ +n[Wa>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);else ob=nb}else ob=ta;mb=Ba+(Ga<<1)|0;if(!Ha){sa=ob+ +n[Ia>>2]*(+(j[mb+(ua<<1)>>1]|0)-ta);if(kb)pb=sa+ +n[Ta>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else pb=sa;if(lb)qb=pb+ +n[Ua>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);else qb=pb}else qb=ob;mb=Ba+(Ja<<1)|0;do if(Ka)rb=qb;else{sa=qb+ +n[La>>2]*(+(j[mb+(ua<<1)>>1]|0)-ta);if(kb)sb=sa+ +n[Ra>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else sb=sa;if(!lb){rb=sb;break}rb=sb+ +n[Sa>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta)}while(0);mb=Ba+(Ma<<1)|0;if(Na){tb=rb;break}sa=rb+ +n[Oa>>2]*(+(j[mb+(ua<<1)>>1]|0)-ta);if(kb)ub=sa+ +n[Pa>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else ub=sa;if(!lb){tb=ub;break}tb=ub+ +n[Qa>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);break}else{mb=Ba+(Xa<<1)|0;if(!Ya){if(kb)vb=ta+ +n[da>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else vb=ta;if(lb)wb=vb+ +n[gb>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);else wb=vb}else wb=ta;mb=Ba+(Za<<1)|0;if(!_a){if(kb)xb=wb+ +n[ya>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else xb=wb;if(lb)yb=xb+ +n[fb>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);else yb=xb}else yb=wb;mb=Ba+($a<<1)|0;do if(ab)zb=yb;else{if(kb)Ab=yb+ +n[va>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else Ab=yb;if(!lb){zb=Ab;break}zb=Ab+ +n[eb>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta)}while(0);mb=Ba+(bb<<1)|0;if(cb){tb=zb;break}if(kb)Bb=zb+ +n[Ca>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else Bb=zb;if(!lb){tb=Bb;break}tb=Bb+ +n[db>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);break}else{mb=0;sa=ta;Cb=ca;while(1){Db=f[o+(mb<<2)>>2]|0;Eb=Ba+((Y(Db,z)|0)<<1)|0;if((Db|0)>=0){ra=sa+ +n[Cb>>2]*(+(j[Eb+(hb<<1)>>1]|0)-ta);if(jb)Fb=ra+ +n[Cb+4>>2]*(+(j[Eb+(ua<<1)>>1]|0)-ta);else Fb=ra;if(kb)Gb=Fb+ +n[Cb+8>>2]*(+(j[Eb+(xa<<1)>>1]|0)-ta);else Gb=Fb;if(lb)Hb=Gb+ +n[Cb+12>>2]*(+(j[Eb+(wa<<1)>>1]|0)-ta);else Hb=Gb}else Hb=sa;mb=mb+1|0;if((mb|0)==4){tb=Hb;break}else{sa=Hb;Cb=Cb+16|0}}}while(0);lb=wNa(tb)|0;d[V+(ib<<1)>>1]=lb>>>0<65536?lb:(lb|0)>0?65535:0;lb=ib+1|0;if((lb|0)==(x|0))break;hb=f[m>>2]|0;ua=f[K>>2]|0;xa=f[L>>2]|0;wa=f[M>>2]|0;Ba=Ba+2|0;ib=lb}Aa=W+(x<<1)+(N<<1)|0}while(0);za=Aa}X=X+1|0;if((X|0)==(D|0)){Ib=za;break}else{V=V+(x<<1)|0;W=za}}}else Ib=Q;y=y+1|0;if((y|0)==(E|0))break;else Q=Ib}u=k;return}function wga(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0,Db=0,Eb=0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0;k=u;u=u+1056|0;l=k+32|0;m=k+16|0;o=k;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>1;a=0;do{A=rNa(+p[i+((a&3)<<3)>>3])|0;d[l+(a<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-3|0;A=(i|0)>0?i:0;i=s+-3|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=(Y(z,-3)|0)+1|0;J=(h|0)==5;h=(a|0)==0;K=m+4|0;L=m+8|0;M=m+12|0;N=(q|-512)^511;q=(w<<1)+2|0;w=o+4|0;O=o+8|0;P=o+12|0;Q=y;y=0;while(1){R=f[v>>2]|0;S=Y(f[f[F>>2]>>2]|0,y)|0;T=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,y)|0)|0;U=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,y)|0)|0;if(e){V=R+S|0;W=Q;X=0;while(1){Z=R+(S+(Y(q,X)|0))|0;_=X<<1;$=d[T+(_<<1)>>1]|0;aa=$+-1|0;ba=d[T+((_|1)<<1)>>1]|0;_=ba+-1|0;ca=g+(j[U+(X<<1)>>1]<<4<<2)|0;if(aa>>>0<A>>>0&_>>>0<B>>>0){da=W+((Y(_,z)|0)<<1)+((Y(aa,x)|0)<<1)|0;ea=+n[ca>>2];fa=+n[ca+4>>2];ga=+n[ca+8>>2];ha=+n[ca+12>>2];ia=+n[ca+16>>2];ja=+n[ca+20>>2];ka=+n[ca+24>>2];la=+n[ca+28>>2];ma=+n[ca+32>>2];na=+n[ca+36>>2];oa=+n[ca+40>>2];pa=+n[ca+44>>2];qa=+n[ca+48>>2];ra=+n[ca+52>>2];sa=+n[ca+56>>2];ta=+n[ca+60>>2];ua=da;da=0;while(1){va=ua+(z<<1)|0;wa=va+(z<<1)|0;xa=wa+(z<<1)|0;ya=wNa(+(d[ua>>1]|0)*ea+ +(d[ua+(x<<1)>>1]|0)*fa+ +(d[ua+(i<<1)>>1]|0)*ga+ +(d[ua+(H<<1)>>1]|0)*ha+(+(d[va>>1]|0)*ia+ +(d[va+(x<<1)>>1]|0)*ja+ +(d[va+(i<<1)>>1]|0)*ka+ +(d[va+(H<<1)>>1]|0)*la)+(+(d[wa>>1]|0)*ma+ +(d[wa+(x<<1)>>1]|0)*na+ +(d[wa+(i<<1)>>1]|0)*oa+ +(d[wa+(H<<1)>>1]|0)*pa)+(+(d[xa>>1]|0)*qa+ +(d[xa+(x<<1)>>1]|0)*ra+ +(d[xa+(i<<1)>>1]|0)*sa+ +(d[xa+(H<<1)>>1]|0)*ta))|0;d[V+(da<<1)>>1]=(ya+32768|0)>>>0<65536?ya:(ya|0)>0?32767:32768;da=da+1|0;if((da|0)==(x|0)){za=W;break}else ua=xa+(I<<1)|0}}else{if(J?!($>>>0<r>>>0&ba>>>0<s>>>0):0)Aa=W;else G=17;do if((G|0)==17){G=0;if(h?(ba+3|0)<1|((ba|0)>(s|0)|(($|0)>(r|0)|($+3|0)<1)):0){K1a(Z|0,l|0,q|0)|0;Aa=W;break}ua=Y(lL(aa,r,a)|0,x)|0;f[m>>2]=ua;da=lL(_,s,a)|0;f[o>>2]=da;xa=Y(lL($,r,a)|0,x)|0;f[K>>2]=xa;ya=lL(ba,s,a)|0;f[w>>2]=ya;wa=Y(lL($+1|0,r,a)|0,x)|0;f[L>>2]=wa;va=lL(ba+1|0,s,a)|0;f[O>>2]=va;Ba=Y(lL($+2|0,r,a)|0,x)|0;f[M>>2]=Ba;Ca=lL(ba+2|0,s,a)|0;f[P>>2]=Ca;Da=Y(da,z)|0;Ea=(da|0)<0;Fa=ca+16|0;Ga=Y(ya,z)|0;Ha=(ya|0)<0;Ia=Fa+16|0;Ja=Y(va,z)|0;Ka=(va|0)<0;La=Ia+16|0;Ma=Y(Ca,z)|0;Na=(Ca|0)<0;Oa=La+4|0;Pa=La+8|0;Qa=La+12|0;La=Ia+4|0;Ra=Ia+8|0;Sa=Ia+12|0;Ia=Fa+4|0;Ta=Fa+8|0;Ua=Fa+12|0;Fa=ca+4|0;Va=ca+8|0;Wa=ca+12|0;Xa=Y(da,z)|0;Ya=(da|0)<0;da=ca+16|0;Za=Y(ya,z)|0;_a=(ya|0)<0;ya=ca+32|0;$a=Y(va,z)|0;ab=(va|0)<0;va=ca+48|0;bb=Y(Ca,z)|0;cb=(Ca|0)<0;Ca=va+8|0;db=va+12|0;va=ya+8|0;eb=ya+12|0;ya=da+8|0;fb=da+12|0;da=ca+8|0;gb=ca+12|0;hb=ua;ua=xa;xa=wa;wa=Ba;Ba=W;ib=0;while(1){ta=+(d[l+(ib<<1)>>1]|0);jb=(ua|0)>-1;kb=(xa|0)>-1;lb=(wa|0)>-1;do if((hb|0)<=-1)if(jb){mb=Ba+(Da<<1)|0;if(!Ea){sa=ta+ +n[Fa>>2]*(+(d[mb+(ua<<1)>>1]|0)-ta);if(kb)nb=sa+ +n[Va>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else nb=sa;if(lb)ob=nb+ +n[Wa>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);else ob=nb}else ob=ta;mb=Ba+(Ga<<1)|0;if(!Ha){sa=ob+ +n[Ia>>2]*(+(d[mb+(ua<<1)>>1]|0)-ta);if(kb)pb=sa+ +n[Ta>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else pb=sa;if(lb)qb=pb+ +n[Ua>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);else qb=pb}else qb=ob;mb=Ba+(Ja<<1)|0;do if(Ka)rb=qb;else{sa=qb+ +n[La>>2]*(+(d[mb+(ua<<1)>>1]|0)-ta);if(kb)sb=sa+ +n[Ra>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else sb=sa;if(!lb){rb=sb;break}rb=sb+ +n[Sa>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta)}while(0);mb=Ba+(Ma<<1)|0;if(Na){tb=rb;break}sa=rb+ +n[Oa>>2]*(+(d[mb+(ua<<1)>>1]|0)-ta);if(kb)ub=sa+ +n[Pa>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else ub=sa;if(!lb){tb=ub;break}tb=ub+ +n[Qa>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);break}else{mb=Ba+(Xa<<1)|0;if(!Ya){if(kb)vb=ta+ +n[da>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else vb=ta;if(lb)wb=vb+ +n[gb>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);else wb=vb}else wb=ta;mb=Ba+(Za<<1)|0;if(!_a){if(kb)xb=wb+ +n[ya>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else xb=wb;if(lb)yb=xb+ +n[fb>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);else yb=xb}else yb=wb;mb=Ba+($a<<1)|0;do if(ab)zb=yb;else{if(kb)Ab=yb+ +n[va>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else Ab=yb;if(!lb){zb=Ab;break}zb=Ab+ +n[eb>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta)}while(0);mb=Ba+(bb<<1)|0;if(cb){tb=zb;break}if(kb)Bb=zb+ +n[Ca>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else Bb=zb;if(!lb){tb=Bb;break}tb=Bb+ +n[db>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);break}else{mb=0;sa=ta;Cb=ca;while(1){Db=f[o+(mb<<2)>>2]|0;Eb=Ba+((Y(Db,z)|0)<<1)|0;if((Db|0)>=0){ra=sa+ +n[Cb>>2]*(+(d[Eb+(hb<<1)>>1]|0)-ta);if(jb)Fb=ra+ +n[Cb+4>>2]*(+(d[Eb+(ua<<1)>>1]|0)-ta);else Fb=ra;if(kb)Gb=Fb+ +n[Cb+8>>2]*(+(d[Eb+(xa<<1)>>1]|0)-ta);else Gb=Fb;if(lb)Hb=Gb+ +n[Cb+12>>2]*(+(d[Eb+(wa<<1)>>1]|0)-ta);else Hb=Gb}else Hb=sa;mb=mb+1|0;if((mb|0)==4){tb=Hb;break}else{sa=Hb;Cb=Cb+16|0}}}while(0);lb=wNa(tb)|0;d[V+(ib<<1)>>1]=(lb+32768|0)>>>0<65536?lb:(lb|0)>0?32767:32768;lb=ib+1|0;if((lb|0)==(x|0))break;hb=f[m>>2]|0;ua=f[K>>2]|0;xa=f[L>>2]|0;wa=f[M>>2]|0;Ba=Ba+2|0;ib=lb}Aa=W+(x<<1)+(N<<1)|0}while(0);za=Aa}X=X+1|0;if((X|0)==(D|0)){Ib=za;break}else{V=V+(x<<1)|0;W=za}}}else Ib=Q;y=y+1|0;if((y|0)==(E|0))break;else Q=Ib}u=k;return}function xga(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0.0,Rb=0.0,Sb=0;k=u;u=u+2064|0;l=k+16|0;m=k;o=f[a+40>>2]|0;q=f[o+4>>2]|0;r=f[o>>2]|0;o=f[b+40>>2]|0;s=f[o+4>>2]|0;t=f[o>>2]|0;o=(f[a>>2]|0)>>>3;v=o&511;w=v+1|0;x=f[a+16>>2]|0;y=(f[a+48>>2]|0)>>>2;a=0;do{n[l+(a<<2)>>2]=+p[i+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(w|0));a=(h|0)!=5?h:4;i=q+-3|0;z=(i|0)>0?i:0;i=r+-3|0;A=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;B=Y(i?t:1,s)|0;if(i){C=B;D=1}else{E=B;F=6}}else{E=s;F=6}if((F|0)==6)if((t|0)>0){C=E;D=t}else{u=k;return}t=b+16|0;E=b+44|0;b=c+16|0;s=c+44|0;c=e+16|0;B=e+44|0;e=(C|0)>0;i=w<<1;G=w*3|0;H=(Y(y,-3)|0)+1|0;I=(h|0)==5;h=(a|0)==0;J=m+4|0;K=m+8|0;L=m+12|0;M=(o|-512)^511;o=(v<<2)+4|0;v=x;x=0;while(1){N=f[t>>2]|0;O=Y(f[f[E>>2]>>2]|0,x)|0;P=(f[b>>2]|0)+(Y(f[f[s>>2]>>2]|0,x)|0)|0;Q=(f[c>>2]|0)+(Y(f[f[B>>2]>>2]|0,x)|0)|0;if(e){R=N+O|0;S=v;T=0;while(1){U=N+(O+(Y(o,T)|0))|0;V=T<<1;W=d[P+(V<<1)>>1]|0;X=W+-1|0;Z=d[P+((V|1)<<1)>>1]|0;V=Z+-1|0;_=g+(j[Q+(T<<1)>>1]<<4<<2)|0;if(X>>>0<z>>>0&V>>>0<A>>>0){$=_+4|0;aa=_+8|0;ba=_+12|0;ca=_+16|0;da=_+20|0;ea=_+24|0;fa=_+28|0;ga=_+32|0;ha=_+36|0;ia=_+40|0;ja=_+44|0;ka=_+48|0;la=_+52|0;ma=_+56|0;na=_+60|0;oa=S+((Y(V,y)|0)<<2)+((Y(X,w)|0)<<2)|0;pa=0;while(1){qa=oa+(y<<2)|0;ra=qa+(y<<2)|0;sa=ra+(y<<2)|0;n[R+(pa<<2)>>2]=+n[oa>>2]*+n[_>>2]+ +n[oa+(w<<2)>>2]*+n[$>>2]+ +n[oa+(i<<2)>>2]*+n[aa>>2]+ +n[oa+(G<<2)>>2]*+n[ba>>2]+(+n[qa>>2]*+n[ca>>2]+ +n[qa+(w<<2)>>2]*+n[da>>2]+ +n[qa+(i<<2)>>2]*+n[ea>>2]+ +n[qa+(G<<2)>>2]*+n[fa>>2])+(+n[ra>>2]*+n[ga>>2]+ +n[ra+(w<<2)>>2]*+n[ha>>2]+ +n[ra+(i<<2)>>2]*+n[ia>>2]+ +n[ra+(G<<2)>>2]*+n[ja>>2])+(+n[sa>>2]*+n[ka>>2]+ +n[sa+(w<<2)>>2]*+n[la>>2]+ +n[sa+(i<<2)>>2]*+n[ma>>2]+ +n[sa+(G<<2)>>2]*+n[na>>2]);pa=pa+1|0;if((pa|0)==(w|0)){ta=S;break}else oa=sa+(H<<2)|0}}else{if(I?!(W>>>0<q>>>0&Z>>>0<r>>>0):0)ua=S;else F=17;do if((F|0)==17){F=0;if(h?(Z+3|0)<1|((Z|0)>(r|0)|((W|0)>(q|0)|(W+3|0)<1)):0){K1a(U|0,l|0,o|0)|0;ua=S;break}oa=Y(lL(X,q,a)|0,w)|0;f[m>>2]=oa;pa=lL(V,r,a)|0;na=Y(lL(W,q,a)|0,w)|0;f[J>>2]=na;ma=lL(Z,r,a)|0;la=Y(lL(W+1|0,q,a)|0,w)|0;f[K>>2]=la;ka=lL(Z+1|0,r,a)|0;ja=Y(lL(W+2|0,q,a)|0,w)|0;f[L>>2]=ja;ia=lL(Z+2|0,r,a)|0;ha=Y(pa,y)|0;ga=(pa|0)<0;fa=_+16|0;ea=Y(ma,y)|0;da=(ma|0)<0;ca=fa+16|0;ba=Y(ka,y)|0;aa=(ka|0)<0;$=ca+16|0;sa=Y(ia,y)|0;ra=(ia|0)<0;qa=$+4|0;va=$+8|0;wa=$+12|0;xa=ca+4|0;ya=ca+8|0;za=ca+12|0;Aa=fa+4|0;Ba=fa+8|0;Ca=fa+12|0;Da=_+4|0;Ea=_+8|0;Fa=_+12|0;Ga=Y(pa,y)|0;Ha=(pa|0)<0;Ia=_+16|0;Ja=Y(ma,y)|0;Ka=(ma|0)<0;La=Ia+16|0;Ma=Y(ka,y)|0;Na=(ka|0)<0;Oa=La+16|0;Pa=Y(ia,y)|0;Qa=(ia|0)<0;Ra=Oa+4|0;Sa=Oa+8|0;Ta=Oa+12|0;Oa=La+4|0;Ua=La+8|0;Va=La+12|0;La=Ia+4|0;Wa=Ia+8|0;Xa=Ia+12|0;Ia=_+4|0;Ya=_+8|0;Za=_+12|0;_a=Y(pa,y)|0;$a=(pa|0)<0;pa=_+16|0;ab=Y(ma,y)|0;bb=(ma|0)<0;ma=_+32|0;cb=Y(ka,y)|0;db=(ka|0)<0;ka=_+48|0;eb=Y(ia,y)|0;fb=(ia|0)<0;ia=ka+8|0;gb=ka+12|0;ka=ma+8|0;hb=ma+12|0;ma=pa+8|0;ib=pa+12|0;pa=_+8|0;jb=_+12|0;kb=oa;oa=na;na=la;la=ja;ja=S;lb=0;while(1){mb=+n[l+(lb<<2)>>2];nb=(oa|0)>-1;ob=(na|0)>-1;pb=(la|0)>-1;do if((kb|0)>-1){qb=ja+(ha<<2)|0;if(!ga){rb=mb+(+n[qb+(kb<<2)>>2]-mb)*+n[_>>2];if(nb)sb=rb+(+n[qb+(oa<<2)>>2]-mb)*+n[Da>>2];else sb=rb;if(ob)tb=sb+(+n[qb+(na<<2)>>2]-mb)*+n[Ea>>2];else tb=sb;if(pb)ub=tb+(+n[qb+(la<<2)>>2]-mb)*+n[Fa>>2];else ub=tb}else ub=mb;qb=ja+(ea<<2)|0;if(!da){rb=ub+(+n[qb+(kb<<2)>>2]-mb)*+n[fa>>2];if(nb)vb=rb+(+n[qb+(oa<<2)>>2]-mb)*+n[Aa>>2];else vb=rb;if(ob)wb=vb+(+n[qb+(na<<2)>>2]-mb)*+n[Ba>>2];else wb=vb;if(pb)xb=wb+(+n[qb+(la<<2)>>2]-mb)*+n[Ca>>2];else xb=wb}else xb=ub;qb=ja+(ba<<2)|0;if(!aa){rb=xb+(+n[qb+(kb<<2)>>2]-mb)*+n[ca>>2];if(nb)yb=rb+(+n[qb+(oa<<2)>>2]-mb)*+n[xa>>2];else yb=rb;if(ob)zb=yb+(+n[qb+(na<<2)>>2]-mb)*+n[ya>>2];else zb=yb;if(pb)Ab=zb+(+n[qb+(la<<2)>>2]-mb)*+n[za>>2];else Ab=zb}else Ab=xb;qb=ja+(sa<<2)|0;if(!ra){rb=Ab+(+n[qb+(kb<<2)>>2]-mb)*+n[$>>2];if(nb)Bb=rb+(+n[qb+(oa<<2)>>2]-mb)*+n[qa>>2];else Bb=rb;if(ob)Cb=Bb+(+n[qb+(na<<2)>>2]-mb)*+n[va>>2];else Cb=Bb;if(pb)Db=Cb+(+n[qb+(la<<2)>>2]-mb)*+n[wa>>2];else Db=Cb}else Db=Ab}else if(nb){qb=ja+(Ga<<2)|0;if(!Ha){rb=mb+(+n[qb+(oa<<2)>>2]-mb)*+n[Ia>>2];if(ob)Eb=rb+(+n[qb+(na<<2)>>2]-mb)*+n[Ya>>2];else Eb=rb;if(pb)Fb=Eb+(+n[qb+(la<<2)>>2]-mb)*+n[Za>>2];else Fb=Eb}else Fb=mb;qb=ja+(Ja<<2)|0;if(!Ka){rb=Fb+(+n[qb+(oa<<2)>>2]-mb)*+n[La>>2];if(ob)Gb=rb+(+n[qb+(na<<2)>>2]-mb)*+n[Wa>>2];else Gb=rb;if(pb)Hb=Gb+(+n[qb+(la<<2)>>2]-mb)*+n[Xa>>2];else Hb=Gb}else Hb=Fb;qb=ja+(Ma<<2)|0;do if(Na)Ib=Hb;else{rb=Hb+(+n[qb+(oa<<2)>>2]-mb)*+n[Oa>>2];if(ob)Jb=rb+(+n[qb+(na<<2)>>2]-mb)*+n[Ua>>2];else Jb=rb;if(!pb){Ib=Jb;break}Ib=Jb+(+n[qb+(la<<2)>>2]-mb)*+n[Va>>2]}while(0);qb=ja+(Pa<<2)|0;if(Qa){Db=Ib;break}rb=Ib+(+n[qb+(oa<<2)>>2]-mb)*+n[Ra>>2];if(ob)Kb=rb+(+n[qb+(na<<2)>>2]-mb)*+n[Sa>>2];else Kb=rb;if(!pb){Db=Kb;break}Db=Kb+(+n[qb+(la<<2)>>2]-mb)*+n[Ta>>2];break}else{qb=ja+(_a<<2)|0;if(!$a){if(ob)Lb=mb+(+n[qb+(na<<2)>>2]-mb)*+n[pa>>2];else Lb=mb;if(pb)Mb=Lb+(+n[qb+(la<<2)>>2]-mb)*+n[jb>>2];else Mb=Lb}else Mb=mb;qb=ja+(ab<<2)|0;if(!bb){if(ob)Nb=Mb+(+n[qb+(na<<2)>>2]-mb)*+n[ma>>2];else Nb=Mb;if(pb)Ob=Nb+(+n[qb+(la<<2)>>2]-mb)*+n[ib>>2];else Ob=Nb}else Ob=Mb;qb=ja+(cb<<2)|0;do if(db)Pb=Ob;else{if(ob)Qb=Ob+(+n[qb+(na<<2)>>2]-mb)*+n[ka>>2];else Qb=Ob;if(!pb){Pb=Qb;break}Pb=Qb+(+n[qb+(la<<2)>>2]-mb)*+n[hb>>2]}while(0);qb=ja+(eb<<2)|0;if(fb){Db=Pb;break}if(ob)Rb=Pb+(+n[qb+(na<<2)>>2]-mb)*+n[ia>>2];else Rb=Pb;if(!pb){Db=Rb;break}Db=Rb+(+n[qb+(la<<2)>>2]-mb)*+n[gb>>2];break}while(0);n[R+(lb<<2)>>2]=Db;pb=lb+1|0;if((pb|0)==(w|0))break;kb=f[m>>2]|0;oa=f[J>>2]|0;na=f[K>>2]|0;la=f[L>>2]|0;ja=ja+4|0;lb=pb}ua=S+(w<<2)+(M<<2)|0}while(0);ta=ua}T=T+1|0;if((T|0)==(C|0)){Sb=ta;break}else{R=R+(w<<2)|0;S=ta}}}else Sb=v;x=x+1|0;if((x|0)==(D|0))break;else v=Sb}u=k;return}function yga(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0,Db=0,Eb=0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0;k=u;u=u+4128|0;l=k;m=k+4112|0;o=k+4096|0;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>3;a=0;do{p[l+(a<<3)>>3]=+p[i+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-3|0;A=(i|0)>0?i:0;i=s+-3|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=(Y(z,-3)|0)+1|0;J=(h|0)==5;h=(a|0)==0;K=m+4|0;L=m+8|0;M=m+12|0;N=(q|-512)^511;q=(w<<3)+8|0;w=o+4|0;O=o+8|0;P=o+12|0;Q=y;y=0;while(1){R=f[v>>2]|0;S=Y(f[f[F>>2]>>2]|0,y)|0;T=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,y)|0)|0;U=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,y)|0)|0;if(e){V=R+S|0;W=Q;X=0;while(1){Z=R+(S+(Y(q,X)|0))|0;_=X<<1;$=d[T+(_<<1)>>1]|0;aa=$+-1|0;ba=d[T+((_|1)<<1)>>1]|0;_=ba+-1|0;ca=g+(j[U+(X<<1)>>1]<<4<<2)|0;if(aa>>>0<A>>>0&_>>>0<B>>>0){da=W+((Y(_,z)|0)<<3)+((Y(aa,x)|0)<<3)|0;ea=+n[ca>>2];fa=+n[ca+4>>2];ga=+n[ca+8>>2];ha=+n[ca+12>>2];ia=+n[ca+16>>2];ja=+n[ca+20>>2];ka=+n[ca+24>>2];la=+n[ca+28>>2];ma=+n[ca+32>>2];na=+n[ca+36>>2];oa=+n[ca+40>>2];pa=+n[ca+44>>2];qa=+n[ca+48>>2];ra=+n[ca+52>>2];sa=+n[ca+56>>2];ta=+n[ca+60>>2];ua=da;da=0;while(1){va=ua+(z<<3)|0;wa=va+(z<<3)|0;xa=wa+(z<<3)|0;p[V+(da<<3)>>3]=+p[ua>>3]*ea+ +p[ua+(x<<3)>>3]*fa+ +p[ua+(i<<3)>>3]*ga+ +p[ua+(H<<3)>>3]*ha+(+p[va>>3]*ia+ +p[va+(x<<3)>>3]*ja+ +p[va+(i<<3)>>3]*ka+ +p[va+(H<<3)>>3]*la)+(+p[wa>>3]*ma+ +p[wa+(x<<3)>>3]*na+ +p[wa+(i<<3)>>3]*oa+ +p[wa+(H<<3)>>3]*pa)+(+p[xa>>3]*qa+ +p[xa+(x<<3)>>3]*ra+ +p[xa+(i<<3)>>3]*sa+ +p[xa+(H<<3)>>3]*ta);da=da+1|0;if((da|0)==(x|0)){ya=W;break}else ua=xa+(I<<3)|0}}else{if(J?!($>>>0<r>>>0&ba>>>0<s>>>0):0)za=W;else G=17;do if((G|0)==17){G=0;if(h?(ba+3|0)<1|((ba|0)>(s|0)|(($|0)>(r|0)|($+3|0)<1)):0){K1a(Z|0,l|0,q|0)|0;za=W;break}ua=Y(lL(aa,r,a)|0,x)|0;f[m>>2]=ua;da=lL(_,s,a)|0;f[o>>2]=da;xa=Y(lL($,r,a)|0,x)|0;f[K>>2]=xa;wa=lL(ba,s,a)|0;f[w>>2]=wa;va=Y(lL($+1|0,r,a)|0,x)|0;f[L>>2]=va;Aa=lL(ba+1|0,s,a)|0;f[O>>2]=Aa;Ba=Y(lL($+2|0,r,a)|0,x)|0;f[M>>2]=Ba;Ca=lL(ba+2|0,s,a)|0;f[P>>2]=Ca;Da=Y(da,z)|0;Ea=(da|0)<0;Fa=ca+16|0;Ga=Y(wa,z)|0;Ha=(wa|0)<0;Ia=Fa+16|0;Ja=Y(Aa,z)|0;Ka=(Aa|0)<0;La=Ia+16|0;Ma=Y(Ca,z)|0;Na=(Ca|0)<0;Oa=La+4|0;Pa=La+8|0;Qa=La+12|0;La=Ia+4|0;Ra=Ia+8|0;Sa=Ia+12|0;Ia=Fa+4|0;Ta=Fa+8|0;Ua=Fa+12|0;Fa=ca+4|0;Va=ca+8|0;Wa=ca+12|0;Xa=Y(da,z)|0;Ya=(da|0)<0;da=ca+16|0;Za=Y(wa,z)|0;_a=(wa|0)<0;wa=ca+32|0;$a=Y(Aa,z)|0;ab=(Aa|0)<0;Aa=ca+48|0;bb=Y(Ca,z)|0;cb=(Ca|0)<0;Ca=Aa+8|0;db=Aa+12|0;Aa=wa+8|0;eb=wa+12|0;wa=da+8|0;fb=da+12|0;da=ca+8|0;gb=ca+12|0;hb=ua;ua=xa;xa=va;va=Ba;Ba=W;ib=0;while(1){ta=+p[l+(ib<<3)>>3];jb=(ua|0)>-1;kb=(xa|0)>-1;lb=(va|0)>-1;do if((hb|0)<=-1)if(jb){mb=Ba+(Da<<3)|0;if(!Ea){sa=ta+(+p[mb+(ua<<3)>>3]-ta)*+n[Fa>>2];if(kb)nb=sa+(+p[mb+(xa<<3)>>3]-ta)*+n[Va>>2];else nb=sa;if(lb)ob=nb+(+p[mb+(va<<3)>>3]-ta)*+n[Wa>>2];else ob=nb}else ob=ta;mb=Ba+(Ga<<3)|0;if(!Ha){sa=ob+(+p[mb+(ua<<3)>>3]-ta)*+n[Ia>>2];if(kb)pb=sa+(+p[mb+(xa<<3)>>3]-ta)*+n[Ta>>2];else pb=sa;if(lb)qb=pb+(+p[mb+(va<<3)>>3]-ta)*+n[Ua>>2];else qb=pb}else qb=ob;mb=Ba+(Ja<<3)|0;do if(Ka)rb=qb;else{sa=qb+(+p[mb+(ua<<3)>>3]-ta)*+n[La>>2];if(kb)sb=sa+(+p[mb+(xa<<3)>>3]-ta)*+n[Ra>>2];else sb=sa;if(!lb){rb=sb;break}rb=sb+(+p[mb+(va<<3)>>3]-ta)*+n[Sa>>2]}while(0);mb=Ba+(Ma<<3)|0;if(Na){tb=rb;break}sa=rb+(+p[mb+(ua<<3)>>3]-ta)*+n[Oa>>2];if(kb)ub=sa+(+p[mb+(xa<<3)>>3]-ta)*+n[Pa>>2];else ub=sa;if(!lb){tb=ub;break}tb=ub+(+p[mb+(va<<3)>>3]-ta)*+n[Qa>>2];break}else{mb=Ba+(Xa<<3)|0;if(!Ya){if(kb)vb=ta+(+p[mb+(xa<<3)>>3]-ta)*+n[da>>2];else vb=ta;if(lb)wb=vb+(+p[mb+(va<<3)>>3]-ta)*+n[gb>>2];else wb=vb}else wb=ta;mb=Ba+(Za<<3)|0;if(!_a){if(kb)xb=wb+(+p[mb+(xa<<3)>>3]-ta)*+n[wa>>2];else xb=wb;if(lb)yb=xb+(+p[mb+(va<<3)>>3]-ta)*+n[fb>>2];else yb=xb}else yb=wb;mb=Ba+($a<<3)|0;do if(ab)zb=yb;else{if(kb)Ab=yb+(+p[mb+(xa<<3)>>3]-ta)*+n[Aa>>2];else Ab=yb;if(!lb){zb=Ab;break}zb=Ab+(+p[mb+(va<<3)>>3]-ta)*+n[eb>>2]}while(0);mb=Ba+(bb<<3)|0;if(cb){tb=zb;break}if(kb)Bb=zb+(+p[mb+(xa<<3)>>3]-ta)*+n[Ca>>2];else Bb=zb;if(!lb){tb=Bb;break}tb=Bb+(+p[mb+(va<<3)>>3]-ta)*+n[db>>2];break}else{mb=0;sa=ta;Cb=ca;while(1){Db=f[o+(mb<<2)>>2]|0;Eb=Ba+((Y(Db,z)|0)<<3)|0;if((Db|0)>=0){ra=sa+(+p[Eb+(hb<<3)>>3]-ta)*+n[Cb>>2];if(jb)Fb=ra+(+p[Eb+(ua<<3)>>3]-ta)*+n[Cb+4>>2];else Fb=ra;if(kb)Gb=Fb+(+p[Eb+(xa<<3)>>3]-ta)*+n[Cb+8>>2];else Gb=Fb;if(lb)Hb=Gb+(+p[Eb+(va<<3)>>3]-ta)*+n[Cb+12>>2];else Hb=Gb}else Hb=sa;mb=mb+1|0;if((mb|0)==4){tb=Hb;break}else{sa=Hb;Cb=Cb+16|0}}}while(0);p[V+(ib<<3)>>3]=tb;lb=ib+1|0;if((lb|0)==(x|0))break;hb=f[m>>2]|0;ua=f[K>>2]|0;xa=f[L>>2]|0;va=f[M>>2]|0;Ba=Ba+8|0;ib=lb}za=W+(x<<3)+(N<<3)|0}while(0);ya=za}X=X+1|0;if((X|0)==(D|0)){Ib=ya;break}else{V=V+(x<<3)|0;W=ya}}}else Ib=Q;y=y+1|0;if((y|0)==(E|0))break;else Q=Ib}u=k;return}function zga(a,c,e,g,i,k,l){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0;m=u;u=u+528|0;n=m+8|0;o=m;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[c+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{A=rNa(+p[l+((a&3)<<3)>>3])|0;b[n+a>>0]=A>>>0<256?A:(A|0)>0?255:0;a=a+1|0}while((a|0)!=(x|0));a=r+-1|0;l=(a|0)>0?a:0;A=s+-1|0;B=(A|0)>0?A:0;if((Y(s,r)|0)<=0){f[o>>2]=0;f[o+4>>2]=0;C=c$(o,16)|0;D=315443;E=C+16|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));j$(-215,o,315460,314894,662);d$(o)}if((v|0)<=0){u=m;return}o=c+16|0;D=c+44|0;c=e+16|0;C=e+44|0;e=g+16|0;E=g+44|0;g=(t|0)<0;F=(k|0)==5;G=F&(x|0)!=3;H=(w|0)==0;w=(k|0)==0;I=(k|0)==1;J=q&65535;q=z+1|0;K=z+2|0;L=z+3|0;M=z+4|0;N=z+5|0;O=z+6|0;P=z+7|0;Q=0;do{R=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,Q)|0)|0;S=(f[e>>2]|0)+(Y(f[f[E>>2]>>2]|0,Q)|0)|0;if(!g){T=(f[o>>2]|0)+(Y(f[f[D>>2]>>2]|0,Q)|0)|0;U=0;V=0;W=0;while(1){do if((V|0)<(t|0)){X=V<<1;if((d[R+(X<<1)>>1]|0)>>>0>=l>>>0)if(W){Z=18;break}else{_=T;$=U;aa=V;ba=0;break}else{ca=(d[R+((X|1)<<1)>>1]|0)>>>0<B>>>0;Z=16;break}}else{ca=W^1;Z=16}while(0);do if((Z|0)==16){Z=0;if(W^ca)if(ca){if(G){_=T+(Y(V-U|0,x)|0)|0;$=V;aa=V;ba=1;break}X=(V|0)>(U|0);if(H){if(!X){_=T;$=V;aa=U;ba=1;break}da=V-U|0;ea=T;fa=U;while(1){ga=fa<<1;ha=d[R+(ga<<1)>>1]|0;ia=ha<<16>>16;ja=d[R+((ga|1)<<1)>>1]|0;ga=ja<<16>>16;do if(w)if(ja<<16>>16<-1|ha<<16>>16>-2&(ia|0)<(r|0)&(ga|0)<(s|0)^1){ka=b[n>>0]|0;break}else{la=i+(j[S+(fa<<1)>>1]<<2<<1)|0;Z=49;break}else{ma=i+(j[S+(fa<<1)>>1]<<2<<1)|0;if(I){na=ha<<16>>16>-1?((ia|0)<(r|0)?ia:a):0;oa=ia+1|0;pa=ha<<16>>16>-2?((oa|0)<(r|0)?oa:a):0;oa=ga+1|0;qa=Y(ja<<16>>16>-1?((ga|0)<(s|0)?ga:A):0,z)|0;ra=Y(ja<<16>>16>-2?((oa|0)<(s|0)?oa:A):0,z)|0;sa=ma;ta=y+(qa+na)|0;ua=y+(qa+pa)|0;va=y+(ra+na)|0;wa=y+(ra+pa)|0;Z=50}else{la=ma;Z=49}}while(0);if((Z|0)==49){Z=0;ja=lL(ia,r,k)|0;ha=lL(ia+1|0,r,k)|0;ma=lL(ga,s,k)|0;pa=lL(ga+1|0,s,k)|0;ra=Y(ma,z)|0;na=Y(pa,z)|0;sa=la;ta=(ma|ja|0)>-1?y+(ra+ja)|0:n;ua=(ma|ha|0)>-1?y+(ra+ha)|0:n;va=(pa|ja|0)>-1?y+(na+ja)|0:n;wa=(pa|ha|0)>-1?y+(na+ha)|0:n;Z=50}if((Z|0)==50){Z=0;ha=Y(d[sa>>1]|0,h[ta>>0]|0)|0;na=Y(d[sa+2>>1]|0,h[ua>>0]|0)|0;pa=Y(d[sa+4>>1]|0,h[va>>0]|0)|0;ja=ha+16384+na+pa+(Y(d[sa+6>>1]|0,h[wa>>0]|0)|0)>>15;ka=(ja>>>0<256?ja:(ja|0)>0?255:0)&255}b[ea>>0]=ka;fa=fa+1|0;if((fa|0)==(V|0))break;else ea=ea+1|0}_=T+da|0;$=V;aa=V;ba=1;break}if(X){ea=Y(x,V+-1-U|0)|0;fa=T;ja=U;while(1){pa=ja<<1;na=d[R+(pa<<1)>>1]|0;ha=na<<16>>16;ra=d[R+((pa|1)<<1)>>1]|0;pa=ra<<16>>16;do if(w)if(ra<<16>>16<-1|na<<16>>16>-2&(ha|0)<(r|0)&(pa|0)<(s|0)^1){ma=0;do{b[fa+ma>>0]=b[n+ma>>0]|0;ma=ma+1|0}while((ma|0)!=(x|0))}else{xa=i+(j[S+(ja<<1)>>1]<<2<<1)|0;Z=58;break}else{ma=i+(j[S+(ja<<1)>>1]<<2<<1)|0;if(I){qa=ha+1|0;oa=pa+1|0;ya=y+(Y(ra<<16>>16>-1?((pa|0)<(s|0)?pa:A):0,z)|0)|0;za=Y(na<<16>>16>-1?((ha|0)<(r|0)?ha:a):0,x)|0;Aa=Y(na<<16>>16>-2?((qa|0)<(r|0)?qa:a):0,x)|0;qa=y+(Y(ra<<16>>16>-2?((oa|0)<(s|0)?oa:A):0,z)|0)|0;Ba=ma;Ca=ya+za|0;Da=ya+Aa|0;Ea=qa+za|0;Fa=qa+Aa|0;Z=61}else{xa=ma;Z=58}}while(0);do if((Z|0)==58){Z=0;if(F?!(ha>>>0<a>>>0&pa>>>0<A>>>0):0)break;ra=lL(ha,r,k)|0;na=lL(ha+1|0,r,k)|0;ga=lL(pa,s,k)|0;ia=lL(pa+1|0,s,k)|0;ma=y+(Y(ga,z)|0)|0;Aa=Y(ra,x)|0;qa=Y(na,x)|0;za=y+(Y(ia,z)|0)|0;Ba=xa;Ca=(ga|ra|0)>-1?ma+Aa|0:n;Da=(ga|na|0)>-1?ma+qa|0:n;Ea=(ia|ra|0)>-1?za+Aa|0:n;Fa=(ia|na|0)>-1?za+qa|0:n;Z=61}while(0);if((Z|0)==61){Z=0;pa=Ba+2|0;ha=Ba+4|0;qa=Ba+6|0;za=0;do{na=Y(d[Ba>>1]|0,h[Ca+za>>0]|0)|0;ia=Y(d[pa>>1]|0,h[Da+za>>0]|0)|0;Aa=Y(d[ha>>1]|0,h[Ea+za>>0]|0)|0;ra=na+16384+ia+Aa+(Y(d[qa>>1]|0,h[Fa+za>>0]|0)|0)>>15;b[fa+za>>0]=ra>>>0<256?ra:(ra|0)>0?255:0;za=za+1|0}while((za|0)!=(x|0))}ja=ja+1|0;if((ja|0)==(V|0))break;else fa=fa+x|0}_=T+x+ea|0;$=V;aa=V;ba=1}else{_=T;$=V;aa=U;ba=1}}else Z=18;else{_=T;$=U;aa=V;ba=W}}while(0);a:do if((Z|0)==18){Z=0;switch(J&511){case 0:{if((V|0)<=(U|0)){_=T;$=V;aa=U;ba=0;break a}fa=V-U|0;ja=T;X=U;while(1){da=X<<1;za=i+(j[S+(X<<1)>>1]<<2<<1)|0;qa=y+(Y(d[R+((da|1)<<1)>>1]|0,z)|0)+(d[R+(da<<1)>>1]|0)|0;da=Y(d[za>>1]|0,h[qa>>0]|0)|0;ha=Y(d[za+2>>1]|0,h[qa+1>>0]|0)|0;pa=Y(d[za+4>>1]|0,h[qa+z>>0]|0)|0;ra=da+16384+ha+pa+(Y(d[za+6>>1]|0,h[qa+q>>0]|0)|0)>>15;b[ja>>0]=ra>>>0<256?ra:(ra|0)>0?255:0;X=X+1|0;if((X|0)==(V|0))break;else ja=ja+1|0}_=T+fa|0;$=V;aa=V;ba=0;break a;break}case 1:{if((V|0)<=(U|0)){_=T;$=V;aa=U;ba=0;break a}ja=V-U<<1;X=T;ea=U;while(1){ra=ea<<1;qa=i+(j[S+(ea<<1)>>1]<<2<<1)|0;za=y+(Y(d[R+((ra|1)<<1)>>1]|0,z)|0)+(d[R+(ra<<1)>>1]<<1)|0;ra=d[qa>>1]|0;pa=Y(ra,h[za>>0]|0)|0;ha=d[qa+2>>1]|0;da=Y(ha,h[za+2>>0]|0)|0;Aa=d[qa+4>>1]|0;ia=Y(Aa,h[za+z>>0]|0)|0;na=d[qa+6>>1]|0;qa=Y(na,h[za+K>>0]|0)|0;ma=Y(h[za+1>>0]|0,ra)|0;ra=Y(h[za+3>>0]|0,ha)|0;ha=Y(h[za+q>>0]|0,Aa)|0;Aa=Y(h[za+L>>0]|0,na)|0;na=pa+16384+da+ia+qa>>15;b[X>>0]=na>>>0<256?na:(na|0)>0?255:0;na=ma+16384+ra+ha+Aa>>15;b[X+1>>0]=na>>>0<256?na:(na|0)>0?255:0;ea=ea+1|0;if((ea|0)==(V|0))break;else X=X+2|0}_=T+ja|0;$=V;aa=V;ba=0;break a;break}case 2:{if((V|0)<=(U|0)){_=T;$=V;aa=U;ba=0;break a}X=(V-U|0)*3|0;ea=T;fa=U;while(1){na=fa<<1;Aa=i+(j[S+(fa<<1)>>1]<<2<<1)|0;ha=y+(Y(d[R+((na|1)<<1)>>1]|0,z)|0)+((d[R+(na<<1)>>1]|0)*3|0)|0;na=d[Aa>>1]|0;ra=Y(na,h[ha>>0]|0)|0;ma=d[Aa+2>>1]|0;qa=Y(ma,h[ha+3>>0]|0)|0;ia=d[Aa+4>>1]|0;da=Y(ia,h[ha+z>>0]|0)|0;pa=d[Aa+6>>1]|0;Aa=Y(pa,h[ha+L>>0]|0)|0;za=Y(h[ha+1>>0]|0,na)|0;ga=Y(h[ha+4>>0]|0,ma)|0;ya=Y(h[ha+q>>0]|0,ia)|0;oa=Y(h[ha+M>>0]|0,pa)|0;Ga=Y(h[ha+2>>0]|0,na)|0;na=Y(h[ha+5>>0]|0,ma)|0;ma=Y(h[ha+K>>0]|0,ia)|0;ia=Y(h[ha+N>>0]|0,pa)|0;pa=ra+16384+qa+da+Aa>>15;b[ea>>0]=pa>>>0<256?pa:(pa|0)>0?255:0;pa=za+16384+ga+ya+oa>>15;b[ea+1>>0]=pa>>>0<256?pa:(pa|0)>0?255:0;pa=Ga+16384+na+ma+ia>>15;b[ea+2>>0]=pa>>>0<256?pa:(pa|0)>0?255:0;fa=fa+1|0;if((fa|0)==(V|0))break;else ea=ea+3|0}_=T+X|0;$=V;aa=V;ba=0;break a;break}case 3:{if((V|0)<=(U|0)){_=T;$=V;aa=U;ba=0;break a}ea=V-U<<2;fa=T;ja=U;while(1){pa=ja<<1;ia=i+(j[S+(ja<<1)>>1]<<2<<1)|0;ma=y+(Y(d[R+((pa|1)<<1)>>1]|0,z)|0)+(d[R+(pa<<1)>>1]<<2)|0;pa=d[ia>>1]|0;na=Y(pa,h[ma>>0]|0)|0;Ga=ia+2|0;oa=d[Ga>>1]|0;ya=Y(oa,h[ma+4>>0]|0)|0;ga=ia+4|0;za=d[ga>>1]|0;Aa=Y(za,h[ma+z>>0]|0)|0;da=ia+6|0;qa=d[da>>1]|0;ra=Y(qa,h[ma+M>>0]|0)|0;ha=Y(h[ma+1>>0]|0,pa)|0;pa=Y(h[ma+5>>0]|0,oa)|0;oa=Y(h[ma+q>>0]|0,za)|0;za=Y(h[ma+N>>0]|0,qa)|0;qa=na+16384+ya+Aa+ra>>15;b[fa>>0]=qa>>>0<256?qa:(qa|0)>0?255:0;qa=ha+16384+pa+oa+za>>15;b[fa+1>>0]=qa>>>0<256?qa:(qa|0)>0?255:0;qa=d[ia>>1]|0;ia=Y(qa,h[ma+2>>0]|0)|0;za=d[Ga>>1]|0;Ga=Y(za,h[ma+6>>0]|0)|0;oa=d[ga>>1]|0;ga=Y(oa,h[ma+K>>0]|0)|0;pa=d[da>>1]|0;da=Y(pa,h[ma+O>>0]|0)|0;ha=Y(h[ma+3>>0]|0,qa)|0;qa=Y(h[ma+7>>0]|0,za)|0;za=Y(h[ma+L>>0]|0,oa)|0;oa=Y(h[ma+P>>0]|0,pa)|0;pa=ia+16384+Ga+ga+da>>15;b[fa+2>>0]=pa>>>0<256?pa:(pa|0)>0?255:0;pa=ha+16384+qa+za+oa>>15;b[fa+3>>0]=pa>>>0<256?pa:(pa|0)>0?255:0;ja=ja+1|0;if((ja|0)==(V|0))break;else fa=fa+4|0}_=T+ea|0;$=V;aa=V;ba=0;break a;break}default:{if((V|0)<=(U|0)){_=T;$=V;aa=U;ba=0;break a}fa=Y(x,V+-1-U|0)|0;ja=T;X=U;while(1){pa=X<<1;oa=i+(j[S+(X<<1)>>1]<<2<<1)|0;za=y+(Y(d[R+((pa|1)<<1)>>1]|0,z)|0)+(Y(d[R+(pa<<1)>>1]|0,x)|0)|0;pa=oa+2|0;qa=oa+4|0;ha=oa+6|0;da=0;do{ga=Y(d[oa>>1]|0,h[za+da>>0]|0)|0;Ga=Y(d[pa>>1]|0,h[za+(da+x)>>0]|0)|0;ia=da+z|0;ma=Y(d[qa>>1]|0,h[za+ia>>0]|0)|0;ra=ga+16384+Ga+ma+(Y(d[ha>>1]|0,h[za+(ia+x)>>0]|0)|0)>>15;b[ja+da>>0]=ra>>>0<256?ra:(ra|0)>0?255:0;da=da+1|0}while((da|0)!=(x|0));X=X+1|0;if((X|0)==(V|0))break;else ja=ja+x|0}_=T+x+fa|0;$=V;aa=V;ba=0;break a}}}while(0);if((aa|0)<(t|0)){T=_;U=$;V=aa+1|0;W=ba}else break}}Q=Q+1|0}while((Q|0)!=(v|0));u=m;return}function Aga(a,c,e,g,h,i,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0;l=u;u=u+1040|0;m=l+8|0;o=l;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[c+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{A=rNa(+p[k+((a&3)<<3)>>3])|0;d[m+(a<<1)>>1]=A>>>0<65536?A:(A|0)>0?65535:0;a=a+1|0}while((a|0)!=(x|0));a=z>>>1;z=r+-1|0;k=(z|0)>0?z:0;A=s+-1|0;B=(A|0)>0?A:0;if((Y(s,r)|0)<=0){f[o>>2]=0;f[o+4>>2]=0;C=c$(o,16)|0;D=315443;E=C+16|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));j$(-215,o,315460,314894,662);d$(o)}if((v|0)<=0){u=l;return}o=c+16|0;D=c+44|0;c=e+16|0;C=e+44|0;e=g+16|0;E=g+44|0;g=(t|0)<0;F=(i|0)==5;G=F&(x|0)!=3;H=(w|0)==0;I=(i|0)==0;J=(i|0)==1;K=q&65535;q=a+1|0;L=a+2|0;M=a+3|0;N=a+4|0;O=a+5|0;P=a+6|0;Q=a+7|0;R=(w<<1)+2|0;w=0;do{S=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,w)|0)|0;T=(f[e>>2]|0)+(Y(f[f[E>>2]>>2]|0,w)|0)|0;if(!g){U=(f[o>>2]|0)+(Y(f[f[D>>2]>>2]|0,w)|0)|0;V=0;W=0;X=0;while(1){do if((W|0)<(t|0)){Z=W<<1;if((d[S+(Z<<1)>>1]|0)>>>0>=k>>>0)if(X){_=18;break}else{$=U;aa=V;ba=W;ca=0;break}else{da=(d[S+((Z|1)<<1)>>1]|0)>>>0<B>>>0;_=16;break}}else{da=X^1;_=16}while(0);do if((_|0)==16){_=0;if(X^da)if(da){if(G){$=U+((Y(W-V|0,x)|0)<<1)|0;aa=W;ba=W;ca=1;break}Z=(W|0)>(V|0);if(H){if(!Z){$=U;aa=W;ba=V;ca=1;break}ea=W-V|0;fa=U;ga=V;while(1){ha=ga<<1;ia=d[S+(ha<<1)>>1]|0;ja=ia<<16>>16;ka=d[S+((ha|1)<<1)>>1]|0;ha=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(ja|0)<(r|0)&(ha|0)<(s|0)^1){la=d[m>>1]|0;break}else{ma=h+(j[T+(ga<<1)>>1]<<2<<2)|0;_=49;break}else{na=h+(j[T+(ga<<1)>>1]<<2<<2)|0;if(J){oa=ia<<16>>16>-1?((ja|0)<(r|0)?ja:z):0;pa=ja+1|0;qa=ia<<16>>16>-2?((pa|0)<(r|0)?pa:z):0;pa=ha+1|0;ra=Y(ka<<16>>16>-1?((ha|0)<(s|0)?ha:A):0,a)|0;sa=Y(ka<<16>>16>-2?((pa|0)<(s|0)?pa:A):0,a)|0;ta=na;ua=d[y+(ra+oa<<1)>>1]|0;va=d[y+(ra+qa<<1)>>1]|0;wa=d[y+(sa+oa<<1)>>1]|0;xa=y+(sa+qa<<1)|0;_=57}else{ma=na;_=49}}while(0);do if((_|0)==49){_=0;ka=lL(ja,r,i)|0;ia=lL(ja+1|0,r,i)|0;na=lL(ha,s,i)|0;qa=lL(ha+1|0,s,i)|0;if((na|ka|0)>-1)ya=y+((Y(na,a)|0)+ka<<1)|0;else ya=m;sa=d[ya>>1]|0;if((na|ia|0)>-1)za=y+((Y(na,a)|0)+ia<<1)|0;else za=m;na=d[za>>1]|0;if((qa|ka|0)>-1)Aa=y+((Y(qa,a)|0)+ka<<1)|0;else Aa=m;ka=d[Aa>>1]|0;if((qa|ia|0)<=-1){ta=ma;ua=sa;va=na;wa=ka;xa=m;_=57;break}ta=ma;ua=sa;va=na;wa=ka;xa=y+((Y(qa,a)|0)+ia<<1)|0;_=57}while(0);if((_|0)==57){_=0;ha=wNa(+(ua&65535)*+n[ta>>2]+ +(va&65535)*+n[ta+4>>2]+ +(wa&65535)*+n[ta+8>>2]+ +(j[xa>>1]|0)*+n[ta+12>>2])|0;la=(ha>>>0<65536?ha:(ha|0)>0?65535:0)&65535}d[fa>>1]=la;ga=ga+1|0;if((ga|0)==(W|0))break;else fa=fa+2|0}$=U+(ea<<1)|0;aa=W;ba=W;ca=1;break}if(Z){fa=U+(x<<1)+(Y(R,W+-1-V|0)|0)|0;ga=U;ha=V;while(1){ja=ha<<1;ia=d[S+(ja<<1)>>1]|0;qa=ia<<16>>16;ka=d[S+((ja|1)<<1)>>1]|0;ja=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(qa|0)<(r|0)&(ja|0)<(s|0)^1){na=0;do{d[ga+(na<<1)>>1]=d[m+(na<<1)>>1]|0;na=na+1|0}while((na|0)!=(x|0))}else{Ba=h+(j[T+(ha<<1)>>1]<<2<<2)|0;_=65;break}else{na=h+(j[T+(ha<<1)>>1]<<2<<2)|0;if(J){sa=qa+1|0;oa=ja+1|0;ra=y+((Y(ka<<16>>16>-1?((ja|0)<(s|0)?ja:A):0,a)|0)<<1)|0;pa=Y(ia<<16>>16>-1?((qa|0)<(r|0)?qa:z):0,x)|0;Ca=Y(ia<<16>>16>-2?((sa|0)<(r|0)?sa:z):0,x)|0;sa=y+((Y(ka<<16>>16>-2?((oa|0)<(s|0)?oa:A):0,a)|0)<<1)|0;Da=na;Ea=ra+(pa<<1)|0;Fa=ra+(Ca<<1)|0;Ga=sa+(pa<<1)|0;Ha=sa+(Ca<<1)|0;_=75}else{Ba=na;_=65}}while(0);do if((_|0)==65){_=0;if(F?!(qa>>>0<z>>>0&ja>>>0<A>>>0):0)break;ka=lL(qa,r,i)|0;ia=lL(qa+1|0,r,i)|0;na=lL(ja,s,i)|0;Ca=lL(ja+1|0,s,i)|0;if((na|ka|0)>-1)Ia=y+((Y(na,a)|0)<<1)+((Y(ka,x)|0)<<1)|0;else Ia=m;if((na|ia|0)>-1)Ja=y+((Y(na,a)|0)<<1)+((Y(ia,x)|0)<<1)|0;else Ja=m;if((Ca|ka|0)>-1)Ka=y+((Y(Ca,a)|0)<<1)+((Y(ka,x)|0)<<1)|0;else Ka=m;if((Ca|ia|0)<=-1){Da=Ba;Ea=Ia;Fa=Ja;Ga=Ka;Ha=m;_=75;break}Da=Ba;Ea=Ia;Fa=Ja;Ga=Ka;Ha=y+((Y(Ca,a)|0)<<1)+((Y(ia,x)|0)<<1)|0;_=75}while(0);if((_|0)==75){_=0;La=+n[Da>>2];Ma=+n[Da+4>>2];Na=+n[Da+8>>2];Oa=+n[Da+12>>2];ja=0;do{qa=wNa(+(j[Ea+(ja<<1)>>1]|0)*La+ +(j[Fa+(ja<<1)>>1]|0)*Ma+ +(j[Ga+(ja<<1)>>1]|0)*Na+ +(j[Ha+(ja<<1)>>1]|0)*Oa)|0;d[ga+(ja<<1)>>1]=qa>>>0<65536?qa:(qa|0)>0?65535:0;ja=ja+1|0}while((ja|0)!=(x|0))}ha=ha+1|0;if((ha|0)==(W|0))break;else ga=ga+(x<<1)|0}$=fa;aa=W;ba=W;ca=1}else{$=U;aa=W;ba=V;ca=1}}else _=18;else{$=U;aa=V;ba=W;ca=X}}while(0);a:do if((_|0)==18){_=0;switch(K&511){case 0:{if((W|0)<=(V|0)){$=U;aa=W;ba=V;ca=0;break a}ga=W-V|0;ha=U;Z=V;while(1){ea=Z<<1;ja=h+(j[T+(Z<<1)>>1]<<2<<2)|0;qa=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(ea<<1)>>1]<<1)|0;ea=wNa(+(j[qa>>1]|0)*+n[ja>>2]+ +(j[qa+2>>1]|0)*+n[ja+4>>2]+ +(j[qa+(a<<1)>>1]|0)*+n[ja+8>>2]+ +(j[qa+(q<<1)>>1]|0)*+n[ja+12>>2])|0;d[ha>>1]=ea>>>0<65536?ea:(ea|0)>0?65535:0;Z=Z+1|0;if((Z|0)==(W|0))break;else ha=ha+2|0}$=U+(ga<<1)|0;aa=W;ba=W;ca=0;break a;break}case 1:{if((W|0)<=(V|0)){$=U;aa=W;ba=V;ca=0;break a}ha=W-V<<1;Z=U;fa=V;while(1){ea=fa<<1;ja=h+(j[T+(fa<<1)>>1]<<2<<2)|0;qa=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(ea<<1)>>1]<<1<<1)|0;Oa=+n[ja>>2];Na=+n[ja+4>>2];Ma=+n[ja+8>>2];La=+n[ja+12>>2];Pa=Oa*+(j[qa+2>>1]|0)+Na*+(j[qa+6>>1]|0)+Ma*+(j[qa+(q<<1)>>1]|0)+La*+(j[qa+(M<<1)>>1]|0);ja=wNa(+(j[qa>>1]|0)*Oa+ +(j[qa+4>>1]|0)*Na+ +(j[qa+(a<<1)>>1]|0)*Ma+ +(j[qa+(L<<1)>>1]|0)*La)|0;d[Z>>1]=ja>>>0<65536?ja:(ja|0)>0?65535:0;ja=wNa(Pa)|0;d[Z+2>>1]=ja>>>0<65536?ja:(ja|0)>0?65535:0;fa=fa+1|0;if((fa|0)==(W|0))break;else Z=Z+4|0}$=U+(ha<<1)|0;aa=W;ba=W;ca=0;break a;break}case 2:{if((W|0)<=(V|0)){$=U;aa=W;ba=V;ca=0;break a}Z=(W-V|0)*3|0;fa=U;ga=V;while(1){ja=ga<<1;qa=h+(j[T+(ga<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((ja|1)<<1)>>1]|0,a)|0)<<1)+((d[S+(ja<<1)>>1]|0)*3<<1)|0;Pa=+n[qa>>2];La=+n[qa+4>>2];Ma=+n[qa+8>>2];Na=+n[qa+12>>2];Oa=Pa*+(j[ea+2>>1]|0)+La*+(j[ea+8>>1]|0)+Ma*+(j[ea+(q<<1)>>1]|0)+Na*+(j[ea+(N<<1)>>1]|0);Qa=Pa*+(j[ea+4>>1]|0)+La*+(j[ea+10>>1]|0)+Ma*+(j[ea+(L<<1)>>1]|0)+Na*+(j[ea+(O<<1)>>1]|0);qa=wNa(+(j[ea>>1]|0)*Pa+ +(j[ea+6>>1]|0)*La+ +(j[ea+(a<<1)>>1]|0)*Ma+ +(j[ea+(M<<1)>>1]|0)*Na)|0;d[fa>>1]=qa>>>0<65536?qa:(qa|0)>0?65535:0;qa=wNa(Oa)|0;d[fa+2>>1]=qa>>>0<65536?qa:(qa|0)>0?65535:0;qa=wNa(Qa)|0;d[fa+4>>1]=qa>>>0<65536?qa:(qa|0)>0?65535:0;ga=ga+1|0;if((ga|0)==(W|0))break;else fa=fa+6|0}$=U+(Z<<1)|0;aa=W;ba=W;ca=0;break a;break}case 3:{if((W|0)<=(V|0)){$=U;aa=W;ba=V;ca=0;break a}fa=W-V<<2;ga=U;ha=V;while(1){qa=ha<<1;ea=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ja=y+((Y(d[S+((qa|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(qa<<1)>>1]<<2<<1)|0;Qa=+n[ea>>2];Oa=+n[ea+4>>2];Na=+n[ea+8>>2];Ma=+n[ea+12>>2];La=Qa*+(j[ja+2>>1]|0)+Oa*+(j[ja+10>>1]|0)+Na*+(j[ja+(q<<1)>>1]|0)+Ma*+(j[ja+(O<<1)>>1]|0);ea=wNa(+(j[ja>>1]|0)*Qa+ +(j[ja+8>>1]|0)*Oa+ +(j[ja+(a<<1)>>1]|0)*Na+ +(j[ja+(N<<1)>>1]|0)*Ma)|0;d[ga>>1]=ea>>>0<65536?ea:(ea|0)>0?65535:0;ea=wNa(La)|0;d[ga+2>>1]=ea>>>0<65536?ea:(ea|0)>0?65535:0;La=Qa*+(j[ja+6>>1]|0)+Oa*+(j[ja+14>>1]|0)+Na*+(j[ja+(M<<1)>>1]|0)+Ma*+(j[ja+(Q<<1)>>1]|0);ea=wNa(+(j[ja+4>>1]|0)*Qa+ +(j[ja+12>>1]|0)*Oa+ +(j[ja+(L<<1)>>1]|0)*Na+ +(j[ja+(P<<1)>>1]|0)*Ma)|0;d[ga+4>>1]=ea>>>0<65536?ea:(ea|0)>0?65535:0;ea=wNa(La)|0;d[ga+6>>1]=ea>>>0<65536?ea:(ea|0)>0?65535:0;ha=ha+1|0;if((ha|0)==(W|0))break;else ga=ga+8|0}$=U+(fa<<1)|0;aa=W;ba=W;ca=0;break a;break}default:{if((W|0)<=(V|0)){$=U;aa=W;ba=V;ca=0;break a}ga=U+(x<<1)+(Y(R,W+-1-V|0)|0)|0;ha=U;Z=V;while(1){ea=Z<<1;ja=h+(j[T+(Z<<1)>>1]<<2<<2)|0;qa=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+((Y(d[S+(ea<<1)>>1]|0,x)|0)<<1)|0;La=+n[ja>>2];Ma=+n[ja+4>>2];Na=+n[ja+8>>2];Oa=+n[ja+12>>2];ja=0;do{ea=ja+a|0;ia=wNa(+(j[qa+(ja<<1)>>1]|0)*La+ +(j[qa+(ja+x<<1)>>1]|0)*Ma+ +(j[qa+(ea<<1)>>1]|0)*Na+ +(j[qa+(ea+x<<1)>>1]|0)*Oa)|0;d[ha+(ja<<1)>>1]=ia>>>0<65536?ia:(ia|0)>0?65535:0;ja=ja+1|0}while((ja|0)!=(x|0));Z=Z+1|0;if((Z|0)==(W|0))break;else ha=ha+(x<<1)|0}$=ga;aa=W;ba=W;ca=0;break a}}}while(0);if((ba|0)<(t|0)){U=$;V=aa;W=ba+1|0;X=ca}else break}}w=w+1|0}while((w|0)!=(v|0));u=l;return}function Bga(a,c,e,g,h,i,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0;l=u;u=u+1040|0;m=l+8|0;o=l;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[c+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{A=rNa(+p[k+((a&3)<<3)>>3])|0;d[m+(a<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;a=a+1|0}while((a|0)!=(x|0));a=z>>>1;z=r+-1|0;k=(z|0)>0?z:0;A=s+-1|0;B=(A|0)>0?A:0;if((Y(s,r)|0)<=0){f[o>>2]=0;f[o+4>>2]=0;C=c$(o,16)|0;D=315443;E=C+16|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));j$(-215,o,315460,314894,662);d$(o)}if((v|0)<=0){u=l;return}o=c+16|0;D=c+44|0;c=e+16|0;C=e+44|0;e=g+16|0;E=g+44|0;g=(t|0)<0;F=(i|0)==5;G=F&(x|0)!=3;H=(w|0)==0;I=(i|0)==0;J=(i|0)==1;K=q&65535;q=a+1|0;L=a+2|0;M=a+3|0;N=a+4|0;O=a+5|0;P=a+6|0;Q=a+7|0;R=(w<<1)+2|0;w=0;do{S=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,w)|0)|0;T=(f[e>>2]|0)+(Y(f[f[E>>2]>>2]|0,w)|0)|0;if(!g){U=(f[o>>2]|0)+(Y(f[f[D>>2]>>2]|0,w)|0)|0;V=0;W=0;X=0;while(1){do if((W|0)<(t|0)){Z=W<<1;if((d[S+(Z<<1)>>1]|0)>>>0>=k>>>0)if(X){_=18;break}else{$=U;aa=V;ba=W;ca=0;break}else{da=(d[S+((Z|1)<<1)>>1]|0)>>>0<B>>>0;_=16;break}}else{da=X^1;_=16}while(0);do if((_|0)==16){_=0;if(X^da)if(da){if(G){$=U+((Y(W-V|0,x)|0)<<1)|0;aa=W;ba=W;ca=1;break}Z=(W|0)>(V|0);if(H){if(!Z){$=U;aa=W;ba=V;ca=1;break}ea=W-V|0;fa=U;ga=V;while(1){ha=ga<<1;ia=d[S+(ha<<1)>>1]|0;ja=ia<<16>>16;ka=d[S+((ha|1)<<1)>>1]|0;ha=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(ja|0)<(r|0)&(ha|0)<(s|0)^1){la=d[m>>1]|0;break}else{ma=h+(j[T+(ga<<1)>>1]<<2<<2)|0;_=49;break}else{na=h+(j[T+(ga<<1)>>1]<<2<<2)|0;if(J){oa=ia<<16>>16>-1?((ja|0)<(r|0)?ja:z):0;pa=ja+1|0;qa=ia<<16>>16>-2?((pa|0)<(r|0)?pa:z):0;pa=ha+1|0;ra=Y(ka<<16>>16>-1?((ha|0)<(s|0)?ha:A):0,a)|0;sa=Y(ka<<16>>16>-2?((pa|0)<(s|0)?pa:A):0,a)|0;ta=na;ua=d[y+(ra+oa<<1)>>1]|0;va=d[y+(ra+qa<<1)>>1]|0;wa=d[y+(sa+oa<<1)>>1]|0;xa=y+(sa+qa<<1)|0;_=57}else{ma=na;_=49}}while(0);do if((_|0)==49){_=0;ka=lL(ja,r,i)|0;ia=lL(ja+1|0,r,i)|0;na=lL(ha,s,i)|0;qa=lL(ha+1|0,s,i)|0;if((na|ka|0)>-1)ya=y+((Y(na,a)|0)+ka<<1)|0;else ya=m;sa=d[ya>>1]|0;if((na|ia|0)>-1)za=y+((Y(na,a)|0)+ia<<1)|0;else za=m;na=d[za>>1]|0;if((qa|ka|0)>-1)Aa=y+((Y(qa,a)|0)+ka<<1)|0;else Aa=m;ka=d[Aa>>1]|0;if((qa|ia|0)<=-1){ta=ma;ua=sa;va=na;wa=ka;xa=m;_=57;break}ta=ma;ua=sa;va=na;wa=ka;xa=y+((Y(qa,a)|0)+ia<<1)|0;_=57}while(0);if((_|0)==57){_=0;ha=wNa(+(ua<<16>>16)*+n[ta>>2]+ +(va<<16>>16)*+n[ta+4>>2]+ +(wa<<16>>16)*+n[ta+8>>2]+ +(d[xa>>1]|0)*+n[ta+12>>2])|0;la=((ha+32768|0)>>>0<65536?ha:(ha|0)>0?32767:32768)&65535}d[fa>>1]=la;ga=ga+1|0;if((ga|0)==(W|0))break;else fa=fa+2|0}$=U+(ea<<1)|0;aa=W;ba=W;ca=1;break}if(Z){fa=U+(x<<1)+(Y(R,W+-1-V|0)|0)|0;ga=U;ha=V;while(1){ja=ha<<1;ia=d[S+(ja<<1)>>1]|0;qa=ia<<16>>16;ka=d[S+((ja|1)<<1)>>1]|0;ja=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(qa|0)<(r|0)&(ja|0)<(s|0)^1){na=0;do{d[ga+(na<<1)>>1]=d[m+(na<<1)>>1]|0;na=na+1|0}while((na|0)!=(x|0))}else{Ba=h+(j[T+(ha<<1)>>1]<<2<<2)|0;_=65;break}else{na=h+(j[T+(ha<<1)>>1]<<2<<2)|0;if(J){sa=qa+1|0;oa=ja+1|0;ra=y+((Y(ka<<16>>16>-1?((ja|0)<(s|0)?ja:A):0,a)|0)<<1)|0;pa=Y(ia<<16>>16>-1?((qa|0)<(r|0)?qa:z):0,x)|0;Ca=Y(ia<<16>>16>-2?((sa|0)<(r|0)?sa:z):0,x)|0;sa=y+((Y(ka<<16>>16>-2?((oa|0)<(s|0)?oa:A):0,a)|0)<<1)|0;Da=na;Ea=ra+(pa<<1)|0;Fa=ra+(Ca<<1)|0;Ga=sa+(pa<<1)|0;Ha=sa+(Ca<<1)|0;_=75}else{Ba=na;_=65}}while(0);do if((_|0)==65){_=0;if(F?!(qa>>>0<z>>>0&ja>>>0<A>>>0):0)break;ka=lL(qa,r,i)|0;ia=lL(qa+1|0,r,i)|0;na=lL(ja,s,i)|0;Ca=lL(ja+1|0,s,i)|0;if((na|ka|0)>-1)Ia=y+((Y(na,a)|0)<<1)+((Y(ka,x)|0)<<1)|0;else Ia=m;if((na|ia|0)>-1)Ja=y+((Y(na,a)|0)<<1)+((Y(ia,x)|0)<<1)|0;else Ja=m;if((Ca|ka|0)>-1)Ka=y+((Y(Ca,a)|0)<<1)+((Y(ka,x)|0)<<1)|0;else Ka=m;if((Ca|ia|0)<=-1){Da=Ba;Ea=Ia;Fa=Ja;Ga=Ka;Ha=m;_=75;break}Da=Ba;Ea=Ia;Fa=Ja;Ga=Ka;Ha=y+((Y(Ca,a)|0)<<1)+((Y(ia,x)|0)<<1)|0;_=75}while(0);if((_|0)==75){_=0;La=+n[Da>>2];Ma=+n[Da+4>>2];Na=+n[Da+8>>2];Oa=+n[Da+12>>2];ja=0;do{qa=wNa(+(d[Ea+(ja<<1)>>1]|0)*La+ +(d[Fa+(ja<<1)>>1]|0)*Ma+ +(d[Ga+(ja<<1)>>1]|0)*Na+ +(d[Ha+(ja<<1)>>1]|0)*Oa)|0;d[ga+(ja<<1)>>1]=(qa+32768|0)>>>0<65536?qa:(qa|0)>0?32767:32768;ja=ja+1|0}while((ja|0)!=(x|0))}ha=ha+1|0;if((ha|0)==(W|0))break;else ga=ga+(x<<1)|0}$=fa;aa=W;ba=W;ca=1}else{$=U;aa=W;ba=V;ca=1}}else _=18;else{$=U;aa=V;ba=W;ca=X}}while(0);a:do if((_|0)==18){_=0;switch(K&511){case 0:{if((W|0)<=(V|0)){$=U;aa=W;ba=V;ca=0;break a}ga=W-V|0;ha=U;Z=V;while(1){ea=Z<<1;ja=h+(j[T+(Z<<1)>>1]<<2<<2)|0;qa=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(ea<<1)>>1]<<1)|0;ea=wNa(+(d[qa>>1]|0)*+n[ja>>2]+ +(d[qa+2>>1]|0)*+n[ja+4>>2]+ +(d[qa+(a<<1)>>1]|0)*+n[ja+8>>2]+ +(d[qa+(q<<1)>>1]|0)*+n[ja+12>>2])|0;d[ha>>1]=(ea+32768|0)>>>0<65536?ea:(ea|0)>0?32767:32768;Z=Z+1|0;if((Z|0)==(W|0))break;else ha=ha+2|0}$=U+(ga<<1)|0;aa=W;ba=W;ca=0;break a;break}case 1:{if((W|0)<=(V|0)){$=U;aa=W;ba=V;ca=0;break a}ha=W-V<<1;Z=U;fa=V;while(1){ea=fa<<1;ja=h+(j[T+(fa<<1)>>1]<<2<<2)|0;qa=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(ea<<1)>>1]<<1<<1)|0;Oa=+n[ja>>2];Na=+n[ja+4>>2];Ma=+n[ja+8>>2];La=+n[ja+12>>2];Pa=Oa*+(d[qa+2>>1]|0)+Na*+(d[qa+6>>1]|0)+Ma*+(d[qa+(q<<1)>>1]|0)+La*+(d[qa+(M<<1)>>1]|0);ja=wNa(+(d[qa>>1]|0)*Oa+ +(d[qa+4>>1]|0)*Na+ +(d[qa+(a<<1)>>1]|0)*Ma+ +(d[qa+(L<<1)>>1]|0)*La)|0;d[Z>>1]=(ja+32768|0)>>>0<65536?ja:(ja|0)>0?32767:32768;ja=wNa(Pa)|0;d[Z+2>>1]=(ja+32768|0)>>>0<65536?ja:(ja|0)>0?32767:32768;fa=fa+1|0;if((fa|0)==(W|0))break;else Z=Z+4|0}$=U+(ha<<1)|0;aa=W;ba=W;ca=0;break a;break}case 2:{if((W|0)<=(V|0)){$=U;aa=W;ba=V;ca=0;break a}Z=(W-V|0)*3|0;fa=U;ga=V;while(1){ja=ga<<1;qa=h+(j[T+(ga<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((ja|1)<<1)>>1]|0,a)|0)<<1)+((d[S+(ja<<1)>>1]|0)*3<<1)|0;Pa=+n[qa>>2];La=+n[qa+4>>2];Ma=+n[qa+8>>2];Na=+n[qa+12>>2];Oa=Pa*+(d[ea+2>>1]|0)+La*+(d[ea+8>>1]|0)+Ma*+(d[ea+(q<<1)>>1]|0)+Na*+(d[ea+(N<<1)>>1]|0);Qa=Pa*+(d[ea+4>>1]|0)+La*+(d[ea+10>>1]|0)+Ma*+(d[ea+(L<<1)>>1]|0)+Na*+(d[ea+(O<<1)>>1]|0);qa=wNa(+(d[ea>>1]|0)*Pa+ +(d[ea+6>>1]|0)*La+ +(d[ea+(a<<1)>>1]|0)*Ma+ +(d[ea+(M<<1)>>1]|0)*Na)|0;d[fa>>1]=(qa+32768|0)>>>0<65536?qa:(qa|0)>0?32767:32768;qa=wNa(Oa)|0;d[fa+2>>1]=(qa+32768|0)>>>0<65536?qa:(qa|0)>0?32767:32768;qa=wNa(Qa)|0;d[fa+4>>1]=(qa+32768|0)>>>0<65536?qa:(qa|0)>0?32767:32768;ga=ga+1|0;if((ga|0)==(W|0))break;else fa=fa+6|0}$=U+(Z<<1)|0;aa=W;ba=W;ca=0;break a;break}case 3:{if((W|0)<=(V|0)){$=U;aa=W;ba=V;ca=0;break a}fa=W-V<<2;ga=U;ha=V;while(1){qa=ha<<1;ea=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ja=y+((Y(d[S+((qa|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(qa<<1)>>1]<<2<<1)|0;Qa=+n[ea>>2];Oa=+n[ea+4>>2];Na=+n[ea+8>>2];Ma=+n[ea+12>>2];La=Qa*+(d[ja+2>>1]|0)+Oa*+(d[ja+10>>1]|0)+Na*+(d[ja+(q<<1)>>1]|0)+Ma*+(d[ja+(O<<1)>>1]|0);ea=wNa(+(d[ja>>1]|0)*Qa+ +(d[ja+8>>1]|0)*Oa+ +(d[ja+(a<<1)>>1]|0)*Na+ +(d[ja+(N<<1)>>1]|0)*Ma)|0;d[ga>>1]=(ea+32768|0)>>>0<65536?ea:(ea|0)>0?32767:32768;ea=wNa(La)|0;d[ga+2>>1]=(ea+32768|0)>>>0<65536?ea:(ea|0)>0?32767:32768;La=Qa*+(d[ja+6>>1]|0)+Oa*+(d[ja+14>>1]|0)+Na*+(d[ja+(M<<1)>>1]|0)+Ma*+(d[ja+(Q<<1)>>1]|0);ea=wNa(+(d[ja+4>>1]|0)*Qa+ +(d[ja+12>>1]|0)*Oa+ +(d[ja+(L<<1)>>1]|0)*Na+ +(d[ja+(P<<1)>>1]|0)*Ma)|0;d[ga+4>>1]=(ea+32768|0)>>>0<65536?ea:(ea|0)>0?32767:32768;ea=wNa(La)|0;d[ga+6>>1]=(ea+32768|0)>>>0<65536?ea:(ea|0)>0?32767:32768;ha=ha+1|0;if((ha|0)==(W|0))break;else ga=ga+8|0}$=U+(fa<<1)|0;aa=W;ba=W;ca=0;break a;break}default:{if((W|0)<=(V|0)){$=U;aa=W;ba=V;ca=0;break a}ga=U+(x<<1)+(Y(R,W+-1-V|0)|0)|0;ha=U;Z=V;while(1){ea=Z<<1;ja=h+(j[T+(Z<<1)>>1]<<2<<2)|0;qa=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+((Y(d[S+(ea<<1)>>1]|0,x)|0)<<1)|0;La=+n[ja>>2];Ma=+n[ja+4>>2];Na=+n[ja+8>>2];Oa=+n[ja+12>>2];ja=0;do{ea=ja+a|0;ia=wNa(+(d[qa+(ja<<1)>>1]|0)*La+ +(d[qa+(ja+x<<1)>>1]|0)*Ma+ +(d[qa+(ea<<1)>>1]|0)*Na+ +(d[qa+(ea+x<<1)>>1]|0)*Oa)|0;d[ha+(ja<<1)>>1]=(ia+32768|0)>>>0<65536?ia:(ia|0)>0?32767:32768;ja=ja+1|0}while((ja|0)!=(x|0));Z=Z+1|0;if((Z|0)==(W|0))break;else ha=ha+(x<<1)|0}$=ga;aa=W;ba=W;ca=0;break a}}}while(0);if((ba|0)<(t|0)){U=$;V=aa;W=ba+1|0;X=ca}else break}}w=w+1|0}while((w|0)!=(v|0));u=l;return}function Cga(a,c,e,g,h,i,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0;l=u;u=u+2064|0;m=l+8|0;o=l;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[c+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{n[m+(a<<2)>>2]=+p[k+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(x|0));a=z>>>2;z=r+-1|0;k=(z|0)>0?z:0;A=s+-1|0;B=(A|0)>0?A:0;if((Y(s,r)|0)<=0){f[o>>2]=0;f[o+4>>2]=0;C=c$(o,16)|0;D=315443;E=C+16|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));j$(-215,o,315460,314894,662);d$(o)}if((v|0)<=0){u=l;return}o=c+16|0;D=c+44|0;c=e+16|0;C=e+44|0;e=g+16|0;E=g+44|0;g=(t|0)<0;F=(i|0)==5;G=F&(x|0)!=3;H=(w|0)==0;I=(i|0)==0;J=(i|0)==1;K=q&65535;q=a+1|0;L=a+2|0;M=a+3|0;N=a+4|0;O=a+5|0;P=a+6|0;Q=a+7|0;R=(w<<2)+4|0;w=0;do{S=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,w)|0)|0;T=(f[e>>2]|0)+(Y(f[f[E>>2]>>2]|0,w)|0)|0;if(!g){U=(f[o>>2]|0)+(Y(f[f[D>>2]>>2]|0,w)|0)|0;V=0;W=0;X=0;while(1){do if((W|0)<(t|0)){Z=W<<1;if((d[S+(Z<<1)>>1]|0)>>>0>=k>>>0)if(X){_=18;break}else{$=U;aa=V;ba=W;ca=0;break}else{da=(d[S+((Z|1)<<1)>>1]|0)>>>0<B>>>0;_=16;break}}else{da=X^1;_=16}while(0);do if((_|0)==16){_=0;if(X^da)if(da){if(G){$=U+((Y(W-V|0,x)|0)<<2)|0;aa=W;ba=W;ca=1;break}Z=(W|0)>(V|0);if(H){if(!Z){$=U;aa=W;ba=V;ca=1;break}ea=W-V|0;fa=U;ga=V;while(1){ha=ga<<1;ia=d[S+(ha<<1)>>1]|0;ja=ia<<16>>16;ka=d[S+((ha|1)<<1)>>1]|0;ha=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(ja|0)<(r|0)&(ha|0)<(s|0)^1){la=+n[m>>2];break}else{ma=h+(j[T+(ga<<1)>>1]<<2<<2)|0;_=49;break}else{na=h+(j[T+(ga<<1)>>1]<<2<<2)|0;if(J){oa=ia<<16>>16>-1?((ja|0)<(r|0)?ja:z):0;pa=ja+1|0;qa=ia<<16>>16>-2?((pa|0)<(r|0)?pa:z):0;pa=ha+1|0;ra=Y(ka<<16>>16>-1?((ha|0)<(s|0)?ha:A):0,a)|0;sa=Y(ka<<16>>16>-2?((pa|0)<(s|0)?pa:A):0,a)|0;ta=na;ua=+n[y+(ra+oa<<2)>>2];va=+n[y+(ra+qa<<2)>>2];wa=+n[y+(sa+oa<<2)>>2];xa=y+(sa+qa<<2)|0;_=57}else{ma=na;_=49}}while(0);do if((_|0)==49){_=0;ka=lL(ja,r,i)|0;ia=lL(ja+1|0,r,i)|0;na=lL(ha,s,i)|0;qa=lL(ha+1|0,s,i)|0;if((na|ka|0)>-1)ya=y+((Y(na,a)|0)+ka<<2)|0;else ya=m;za=+n[ya>>2];if((na|ia|0)>-1)Aa=y+((Y(na,a)|0)+ia<<2)|0;else Aa=m;Ba=+n[Aa>>2];if((qa|ka|0)>-1)Ca=y+((Y(qa,a)|0)+ka<<2)|0;else Ca=m;Da=+n[Ca>>2];if((qa|ia|0)<=-1){ta=ma;ua=za;va=Ba;wa=Da;xa=m;_=57;break}ta=ma;ua=za;va=Ba;wa=Da;xa=y+((Y(qa,a)|0)+ia<<2)|0;_=57}while(0);if((_|0)==57){_=0;la=ua*+n[ta>>2]+va*+n[ta+4>>2]+wa*+n[ta+8>>2]+ +n[xa>>2]*+n[ta+12>>2]}n[fa>>2]=la;ga=ga+1|0;if((ga|0)==(W|0))break;else fa=fa+4|0}$=U+(ea<<2)|0;aa=W;ba=W;ca=1;break}if(Z){fa=U+(x<<2)+(Y(R,W+-1-V|0)|0)|0;ga=U;ha=V;while(1){ja=ha<<1;ia=d[S+(ja<<1)>>1]|0;qa=ia<<16>>16;ka=d[S+((ja|1)<<1)>>1]|0;ja=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(qa|0)<(r|0)&(ja|0)<(s|0)^1){na=0;do{f[ga+(na<<2)>>2]=f[m+(na<<2)>>2];na=na+1|0}while((na|0)!=(x|0))}else{Ea=h+(j[T+(ha<<1)>>1]<<2<<2)|0;_=65;break}else{na=h+(j[T+(ha<<1)>>1]<<2<<2)|0;if(J){sa=qa+1|0;oa=ja+1|0;ra=y+((Y(ka<<16>>16>-1?((ja|0)<(s|0)?ja:A):0,a)|0)<<2)|0;pa=Y(ia<<16>>16>-1?((qa|0)<(r|0)?qa:z):0,x)|0;Fa=Y(ia<<16>>16>-2?((sa|0)<(r|0)?sa:z):0,x)|0;sa=y+((Y(ka<<16>>16>-2?((oa|0)<(s|0)?oa:A):0,a)|0)<<2)|0;Ga=na;Ha=ra+(pa<<2)|0;Ia=ra+(Fa<<2)|0;Ja=sa+(pa<<2)|0;Ka=sa+(Fa<<2)|0;_=75}else{Ea=na;_=65}}while(0);do if((_|0)==65){_=0;if(F?!(qa>>>0<z>>>0&ja>>>0<A>>>0):0)break;ka=lL(qa,r,i)|0;ia=lL(qa+1|0,r,i)|0;na=lL(ja,s,i)|0;Fa=lL(ja+1|0,s,i)|0;if((na|ka|0)>-1)La=y+((Y(na,a)|0)<<2)+((Y(ka,x)|0)<<2)|0;else La=m;if((na|ia|0)>-1)Ma=y+((Y(na,a)|0)<<2)+((Y(ia,x)|0)<<2)|0;else Ma=m;if((Fa|ka|0)>-1)Na=y+((Y(Fa,a)|0)<<2)+((Y(ka,x)|0)<<2)|0;else Na=m;if((Fa|ia|0)<=-1){Ga=Ea;Ha=La;Ia=Ma;Ja=Na;Ka=m;_=75;break}Ga=Ea;Ha=La;Ia=Ma;Ja=Na;Ka=y+((Y(Fa,a)|0)<<2)+((Y(ia,x)|0)<<2)|0;_=75}while(0);if((_|0)==75){_=0;ja=Ga+4|0;qa=Ga+8|0;ia=Ga+12|0;Fa=0;do{n[ga+(Fa<<2)>>2]=+n[Ha+(Fa<<2)>>2]*+n[Ga>>2]+ +n[Ia+(Fa<<2)>>2]*+n[ja>>2]+ +n[Ja+(Fa<<2)>>2]*+n[qa>>2]+ +n[Ka+(Fa<<2)>>2]*+n[ia>>2];Fa=Fa+1|0}while((Fa|0)!=(x|0))}ha=ha+1|0;if((ha|0)==(W|0))break;else ga=ga+(x<<2)|0}$=fa;aa=W;ba=W;ca=1}else{$=U;aa=W;ba=V;ca=1}}else _=18;else{$=U;aa=V;ba=W;ca=X}}while(0);a:do if((_|0)==18){_=0;switch(K&511){case 0:{if((W|0)<=(V|0)){$=U;aa=W;ba=V;ca=0;break a}ga=W-V|0;ha=U;Z=V;while(1){ea=Z<<1;Fa=h+(j[T+(Z<<1)>>1]<<2<<2)|0;ia=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<2)+(d[S+(ea<<1)>>1]<<2)|0;n[ha>>2]=+n[ia>>2]*+n[Fa>>2]+ +n[ia+4>>2]*+n[Fa+4>>2]+ +n[ia+(a<<2)>>2]*+n[Fa+8>>2]+ +n[ia+(q<<2)>>2]*+n[Fa+12>>2];Z=Z+1|0;if((Z|0)==(W|0))break;else ha=ha+4|0}$=U+(ga<<2)|0;aa=W;ba=W;ca=0;break a;break}case 1:{if((W|0)<=(V|0)){$=U;aa=W;ba=V;ca=0;break a}ha=W-V<<1;Z=U;fa=V;while(1){Fa=fa<<1;ia=h+(j[T+(fa<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((Fa|1)<<1)>>1]|0,a)|0)<<2)+(d[S+(Fa<<1)>>1]<<1<<2)|0;Da=+n[ia>>2];Ba=+n[ia+4>>2];za=+n[ia+8>>2];Oa=+n[ia+12>>2];Pa=Da*+n[ea+4>>2]+Ba*+n[ea+12>>2]+za*+n[ea+(q<<2)>>2]+Oa*+n[ea+(M<<2)>>2];n[Z>>2]=+n[ea>>2]*Da+ +n[ea+8>>2]*Ba+ +n[ea+(a<<2)>>2]*za+ +n[ea+(L<<2)>>2]*Oa;n[Z+4>>2]=Pa;fa=fa+1|0;if((fa|0)==(W|0))break;else Z=Z+8|0}$=U+(ha<<2)|0;aa=W;ba=W;ca=0;break a;break}case 2:{if((W|0)<=(V|0)){$=U;aa=W;ba=V;ca=0;break a}Z=(W-V|0)*3|0;fa=U;ga=V;while(1){ea=ga<<1;ia=h+(j[T+(ga<<1)>>1]<<2<<2)|0;Fa=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<2)+((d[S+(ea<<1)>>1]|0)*3<<2)|0;Pa=+n[ia>>2];Oa=+n[ia+4>>2];za=+n[ia+8>>2];Ba=+n[ia+12>>2];Da=Pa*+n[Fa+4>>2]+Oa*+n[Fa+16>>2]+za*+n[Fa+(q<<2)>>2]+Ba*+n[Fa+(N<<2)>>2];Qa=Pa*+n[Fa+8>>2]+Oa*+n[Fa+20>>2]+za*+n[Fa+(L<<2)>>2]+Ba*+n[Fa+(O<<2)>>2];n[fa>>2]=+n[Fa>>2]*Pa+ +n[Fa+12>>2]*Oa+ +n[Fa+(a<<2)>>2]*za+ +n[Fa+(M<<2)>>2]*Ba;n[fa+4>>2]=Da;n[fa+8>>2]=Qa;ga=ga+1|0;if((ga|0)==(W|0))break;else fa=fa+12|0}$=U+(Z<<2)|0;aa=W;ba=W;ca=0;break a;break}case 3:{if((W|0)<=(V|0)){$=U;aa=W;ba=V;ca=0;break a}fa=W-V<<2;ga=U;ha=V;while(1){Fa=ha<<1;ia=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((Fa|1)<<1)>>1]|0,a)|0)<<2)+(d[S+(Fa<<1)>>1]<<2<<2)|0;Qa=+n[ia>>2];Fa=ia+4|0;Da=+n[Fa>>2];qa=ia+8|0;Ba=+n[qa>>2];ja=ia+12|0;za=+n[ja>>2];Oa=Qa*+n[ea+4>>2]+Da*+n[ea+20>>2]+Ba*+n[ea+(q<<2)>>2]+za*+n[ea+(O<<2)>>2];n[ga>>2]=+n[ea>>2]*Qa+ +n[ea+16>>2]*Da+ +n[ea+(a<<2)>>2]*Ba+ +n[ea+(N<<2)>>2]*za;n[ga+4>>2]=Oa;Oa=+n[ia>>2];za=+n[Fa>>2];Ba=+n[qa>>2];Da=+n[ja>>2];Qa=Oa*+n[ea+12>>2]+za*+n[ea+28>>2]+Ba*+n[ea+(M<<2)>>2]+Da*+n[ea+(Q<<2)>>2];n[ga+8>>2]=+n[ea+8>>2]*Oa+ +n[ea+24>>2]*za+ +n[ea+(L<<2)>>2]*Ba+ +n[ea+(P<<2)>>2]*Da;n[ga+12>>2]=Qa;ha=ha+1|0;if((ha|0)==(W|0))break;else ga=ga+16|0}$=U+(fa<<2)|0;aa=W;ba=W;ca=0;break a;break}default:{if((W|0)<=(V|0)){$=U;aa=W;ba=V;ca=0;break a}ga=U+(x<<2)+(Y(R,W+-1-V|0)|0)|0;ha=U;Z=V;while(1){ea=Z<<1;ja=h+(j[T+(Z<<1)>>1]<<2<<2)|0;qa=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<2)+((Y(d[S+(ea<<1)>>1]|0,x)|0)<<2)|0;ea=ja+4|0;Fa=ja+8|0;ia=ja+12|0;ka=0;do{na=ka+a|0;n[ha+(ka<<2)>>2]=+n[qa+(ka<<2)>>2]*+n[ja>>2]+ +n[qa+(ka+x<<2)>>2]*+n[ea>>2]+ +n[qa+(na<<2)>>2]*+n[Fa>>2]+ +n[qa+(na+x<<2)>>2]*+n[ia>>2];ka=ka+1|0}while((ka|0)!=(x|0));Z=Z+1|0;if((Z|0)==(W|0))break;else ha=ha+(x<<2)|0}$=ga;aa=W;ba=W;ca=0;break a}}}while(0);if((ba|0)<(t|0)){U=$;V=aa;W=ba+1|0;X=ca}else break}}w=w+1|0}while((w|0)!=(v|0));u=l;return}function Dga(a,c,e,g,h,i,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0;l=u;u=u+4112|0;m=l;o=l+4096|0;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[c+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{p[m+(a<<3)>>3]=+p[k+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(x|0));a=z>>>3;z=r+-1|0;k=(z|0)>0?z:0;A=s+-1|0;B=(A|0)>0?A:0;if((Y(s,r)|0)<=0){f[o>>2]=0;f[o+4>>2]=0;C=c$(o,16)|0;D=315443;E=C+16|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));j$(-215,o,315460,314894,662);d$(o)}if((v|0)<=0){u=l;return}o=c+16|0;D=c+44|0;c=e+16|0;C=e+44|0;e=g+16|0;E=g+44|0;g=(t|0)<0;F=(i|0)==5;G=F&(x|0)!=3;H=(w|0)==0;I=(i|0)==0;J=(i|0)==1;K=q&65535;q=a+1|0;L=a+2|0;M=a+3|0;N=a+4|0;O=a+5|0;P=a+6|0;Q=a+7|0;R=(w<<3)+8|0;w=0;do{S=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,w)|0)|0;T=(f[e>>2]|0)+(Y(f[f[E>>2]>>2]|0,w)|0)|0;if(!g){U=(f[o>>2]|0)+(Y(f[f[D>>2]>>2]|0,w)|0)|0;V=0;W=0;X=0;while(1){do if((W|0)<(t|0)){Z=W<<1;if((d[S+(Z<<1)>>1]|0)>>>0>=k>>>0)if(X){_=18;break}else{$=U;aa=V;ba=W;ca=0;break}else{da=(d[S+((Z|1)<<1)>>1]|0)>>>0<B>>>0;_=16;break}}else{da=X^1;_=16}while(0);do if((_|0)==16){_=0;if(X^da)if(da){if(G){$=U+((Y(W-V|0,x)|0)<<3)|0;aa=W;ba=W;ca=1;break}Z=(W|0)>(V|0);if(H){if(!Z){$=U;aa=W;ba=V;ca=1;break}ea=W-V|0;fa=U;ga=V;while(1){ha=ga<<1;ia=d[S+(ha<<1)>>1]|0;ja=ia<<16>>16;ka=d[S+((ha|1)<<1)>>1]|0;ha=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(ja|0)<(r|0)&(ha|0)<(s|0)^1){la=+p[m>>3];break}else{ma=h+(j[T+(ga<<1)>>1]<<2<<2)|0;_=49;break}else{na=h+(j[T+(ga<<1)>>1]<<2<<2)|0;if(J){oa=ia<<16>>16>-1?((ja|0)<(r|0)?ja:z):0;pa=ja+1|0;qa=ia<<16>>16>-2?((pa|0)<(r|0)?pa:z):0;pa=ha+1|0;ra=Y(ka<<16>>16>-1?((ha|0)<(s|0)?ha:A):0,a)|0;sa=Y(ka<<16>>16>-2?((pa|0)<(s|0)?pa:A):0,a)|0;ta=na;ua=+p[y+(ra+oa<<3)>>3];va=+p[y+(ra+qa<<3)>>3];wa=+p[y+(sa+oa<<3)>>3];xa=y+(sa+qa<<3)|0;_=57}else{ma=na;_=49}}while(0);do if((_|0)==49){_=0;ka=lL(ja,r,i)|0;ia=lL(ja+1|0,r,i)|0;na=lL(ha,s,i)|0;qa=lL(ha+1|0,s,i)|0;if((na|ka|0)>-1)ya=y+((Y(na,a)|0)+ka<<3)|0;else ya=m;za=+p[ya>>3];if((na|ia|0)>-1)Aa=y+((Y(na,a)|0)+ia<<3)|0;else Aa=m;Ba=+p[Aa>>3];if((qa|ka|0)>-1)Ca=y+((Y(qa,a)|0)+ka<<3)|0;else Ca=m;Da=+p[Ca>>3];if((qa|ia|0)<=-1){ta=ma;ua=za;va=Ba;wa=Da;xa=m;_=57;break}ta=ma;ua=za;va=Ba;wa=Da;xa=y+((Y(qa,a)|0)+ia<<3)|0;_=57}while(0);if((_|0)==57){_=0;la=ua*+n[ta>>2]+va*+n[ta+4>>2]+wa*+n[ta+8>>2]+ +p[xa>>3]*+n[ta+12>>2]}p[fa>>3]=la;ga=ga+1|0;if((ga|0)==(W|0))break;else fa=fa+8|0}$=U+(ea<<3)|0;aa=W;ba=W;ca=1;break}if(Z){fa=U+(x<<3)+(Y(R,W+-1-V|0)|0)|0;ga=U;ha=V;while(1){ja=ha<<1;ia=d[S+(ja<<1)>>1]|0;qa=ia<<16>>16;ka=d[S+((ja|1)<<1)>>1]|0;ja=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(qa|0)<(r|0)&(ja|0)<(s|0)^1){na=0;do{p[ga+(na<<3)>>3]=+p[m+(na<<3)>>3];na=na+1|0}while((na|0)!=(x|0))}else{Ea=h+(j[T+(ha<<1)>>1]<<2<<2)|0;_=65;break}else{na=h+(j[T+(ha<<1)>>1]<<2<<2)|0;if(J){sa=qa+1|0;oa=ja+1|0;ra=y+((Y(ka<<16>>16>-1?((ja|0)<(s|0)?ja:A):0,a)|0)<<3)|0;pa=Y(ia<<16>>16>-1?((qa|0)<(r|0)?qa:z):0,x)|0;Fa=Y(ia<<16>>16>-2?((sa|0)<(r|0)?sa:z):0,x)|0;sa=y+((Y(ka<<16>>16>-2?((oa|0)<(s|0)?oa:A):0,a)|0)<<3)|0;Ga=na;Ha=ra+(pa<<3)|0;Ia=ra+(Fa<<3)|0;Ja=sa+(pa<<3)|0;Ka=sa+(Fa<<3)|0;_=75}else{Ea=na;_=65}}while(0);do if((_|0)==65){_=0;if(F?!(qa>>>0<z>>>0&ja>>>0<A>>>0):0)break;ka=lL(qa,r,i)|0;ia=lL(qa+1|0,r,i)|0;na=lL(ja,s,i)|0;Fa=lL(ja+1|0,s,i)|0;if((na|ka|0)>-1)La=y+((Y(na,a)|0)<<3)+((Y(ka,x)|0)<<3)|0;else La=m;if((na|ia|0)>-1)Ma=y+((Y(na,a)|0)<<3)+((Y(ia,x)|0)<<3)|0;else Ma=m;if((Fa|ka|0)>-1)Na=y+((Y(Fa,a)|0)<<3)+((Y(ka,x)|0)<<3)|0;else Na=m;if((Fa|ia|0)<=-1){Ga=Ea;Ha=La;Ia=Ma;Ja=Na;Ka=m;_=75;break}Ga=Ea;Ha=La;Ia=Ma;Ja=Na;Ka=y+((Y(Fa,a)|0)<<3)+((Y(ia,x)|0)<<3)|0;_=75}while(0);if((_|0)==75){_=0;Da=+n[Ga>>2];Ba=+n[Ga+4>>2];za=+n[Ga+8>>2];Oa=+n[Ga+12>>2];ja=0;do{p[ga+(ja<<3)>>3]=+p[Ha+(ja<<3)>>3]*Da+ +p[Ia+(ja<<3)>>3]*Ba+ +p[Ja+(ja<<3)>>3]*za+ +p[Ka+(ja<<3)>>3]*Oa;ja=ja+1|0}while((ja|0)!=(x|0))}ha=ha+1|0;if((ha|0)==(W|0))break;else ga=ga+(x<<3)|0}$=fa;aa=W;ba=W;ca=1}else{$=U;aa=W;ba=V;ca=1}}else _=18;else{$=U;aa=V;ba=W;ca=X}}while(0);a:do if((_|0)==18){_=0;switch(K&511){case 0:{if((W|0)<=(V|0)){$=U;aa=W;ba=V;ca=0;break a}ga=W-V|0;ha=U;Z=V;while(1){ea=Z<<1;ja=h+(j[T+(Z<<1)>>1]<<2<<2)|0;qa=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<3)+(d[S+(ea<<1)>>1]<<3)|0;p[ha>>3]=+p[qa>>3]*+n[ja>>2]+ +p[qa+8>>3]*+n[ja+4>>2]+ +p[qa+(a<<3)>>3]*+n[ja+8>>2]+ +p[qa+(q<<3)>>3]*+n[ja+12>>2];Z=Z+1|0;if((Z|0)==(W|0))break;else ha=ha+8|0}$=U+(ga<<3)|0;aa=W;ba=W;ca=0;break a;break}case 1:{if((W|0)<=(V|0)){$=U;aa=W;ba=V;ca=0;break a}ha=W-V<<1;Z=U;fa=V;while(1){ja=fa<<1;qa=h+(j[T+(fa<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((ja|1)<<1)>>1]|0,a)|0)<<3)+(d[S+(ja<<1)>>1]<<1<<3)|0;Oa=+n[qa>>2];za=+n[qa+4>>2];Ba=+n[qa+8>>2];Da=+n[qa+12>>2];Pa=Oa*+p[ea+8>>3]+za*+p[ea+24>>3]+Ba*+p[ea+(q<<3)>>3]+Da*+p[ea+(M<<3)>>3];p[Z>>3]=+p[ea>>3]*Oa+ +p[ea+16>>3]*za+ +p[ea+(a<<3)>>3]*Ba+ +p[ea+(L<<3)>>3]*Da;p[Z+8>>3]=Pa;fa=fa+1|0;if((fa|0)==(W|0))break;else Z=Z+16|0}$=U+(ha<<3)|0;aa=W;ba=W;ca=0;break a;break}case 2:{if((W|0)<=(V|0)){$=U;aa=W;ba=V;ca=0;break a}Z=(W-V|0)*3|0;fa=U;ga=V;while(1){ea=ga<<1;qa=h+(j[T+(ga<<1)>>1]<<2<<2)|0;ja=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<3)+((d[S+(ea<<1)>>1]|0)*3<<3)|0;Pa=+n[qa>>2];Da=+n[qa+4>>2];Ba=+n[qa+8>>2];za=+n[qa+12>>2];Oa=Pa*+p[ja+8>>3]+Da*+p[ja+32>>3]+Ba*+p[ja+(q<<3)>>3]+za*+p[ja+(N<<3)>>3];Qa=Pa*+p[ja+16>>3]+Da*+p[ja+40>>3]+Ba*+p[ja+(L<<3)>>3]+za*+p[ja+(O<<3)>>3];p[fa>>3]=+p[ja>>3]*Pa+ +p[ja+24>>3]*Da+ +p[ja+(a<<3)>>3]*Ba+ +p[ja+(M<<3)>>3]*za;p[fa+8>>3]=Oa;p[fa+16>>3]=Qa;ga=ga+1|0;if((ga|0)==(W|0))break;else fa=fa+24|0}$=U+(Z<<3)|0;aa=W;ba=W;ca=0;break a;break}case 3:{if((W|0)<=(V|0)){$=U;aa=W;ba=V;ca=0;break a}fa=W-V<<2;ga=U;ha=V;while(1){ja=ha<<1;qa=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((ja|1)<<1)>>1]|0,a)|0)<<3)+(d[S+(ja<<1)>>1]<<2<<3)|0;Qa=+n[qa>>2];Oa=+n[qa+4>>2];za=+n[qa+8>>2];Ba=+n[qa+12>>2];Da=Qa*+p[ea+8>>3]+Oa*+p[ea+40>>3]+za*+p[ea+(q<<3)>>3]+Ba*+p[ea+(O<<3)>>3];p[ga>>3]=+p[ea>>3]*Qa+ +p[ea+32>>3]*Oa+ +p[ea+(a<<3)>>3]*za+ +p[ea+(N<<3)>>3]*Ba;p[ga+8>>3]=Da;Da=Qa*+p[ea+24>>3]+Oa*+p[ea+56>>3]+za*+p[ea+(M<<3)>>3]+Ba*+p[ea+(Q<<3)>>3];p[ga+16>>3]=+p[ea+16>>3]*Qa+ +p[ea+48>>3]*Oa+ +p[ea+(L<<3)>>3]*za+ +p[ea+(P<<3)>>3]*Ba;p[ga+24>>3]=Da;ha=ha+1|0;if((ha|0)==(W|0))break;else ga=ga+32|0}$=U+(fa<<3)|0;aa=W;ba=W;ca=0;break a;break}default:{if((W|0)<=(V|0)){$=U;aa=W;ba=V;ca=0;break a}ga=U+(x<<3)+(Y(R,W+-1-V|0)|0)|0;ha=U;Z=V;while(1){ea=Z<<1;qa=h+(j[T+(Z<<1)>>1]<<2<<2)|0;ja=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<3)+((Y(d[S+(ea<<1)>>1]|0,x)|0)<<3)|0;Da=+n[qa>>2];Ba=+n[qa+4>>2];za=+n[qa+8>>2];Oa=+n[qa+12>>2];qa=0;do{ea=qa+a|0;p[ha+(qa<<3)>>3]=+p[ja+(qa<<3)>>3]*Da+ +p[ja+(qa+x<<3)>>3]*Ba+ +p[ja+(ea<<3)>>3]*za+ +p[ja+(ea+x<<3)>>3]*Oa;qa=qa+1|0}while((qa|0)!=(x|0));Z=Z+1|0;if((Z|0)==(W|0))break;else ha=ha+(x<<3)|0}$=ga;aa=W;ba=W;ca=0;break a}}}while(0);if((ba|0)<(t|0)){U=$;V=aa;W=ba+1|0;X=ca}else break}}w=w+1|0}while((w|0)!=(v|0));u=l;return}function Ega(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;i=u;u=u+512|0;j=i;k=f[a+40>>2]|0;l=f[k+4>>2]|0;m=f[k>>2]|0;k=f[c+40>>2]|0;n=f[k+4>>2]|0;o=f[k>>2]|0;k=(f[a>>2]|0)>>>3&511;q=k+1|0;r=f[a+16>>2]|0;s=f[a+48>>2]|0;a=0;do{t=rNa(+p[h+((a&3)<<3)>>3])|0;b[j+a>>0]=t>>>0<256?t:(t|0)>0?255:0;a=a+1|0}while((a|0)!=(q|0));if(f[c>>2]&16384){a=(f[e>>2]&16384|0)!=0;h=Y(a?o:1,n)|0;if(a){v=h;w=1}else{x=h;y=5}}else{x=n;y=5}if((y|0)==5)if((o|0)>0){v=x;w=o}else{u=i;return}o=c+16|0;x=c+44|0;c=e+16|0;n=e+44|0;e=(k|0)==0;k=(v|0)>0;h=l+-1|0;a=m+-1|0;t=(q|0)==3;z=(q|0)==4;A=(g|0)==5;B=0;do{C=(f[o>>2]|0)+(Y(f[f[x>>2]>>2]|0,B)|0)|0;D=(f[c>>2]|0)+(Y(f[f[n>>2]>>2]|0,B)|0)|0;a:do if(e){if(k)switch(g|0){case 1:{E=0;do{F=E<<1;G=d[D+(F<<1)>>1]|0;H=G<<16>>16;I=d[D+((F|1)<<1)>>1]|0;F=I<<16>>16;if(H>>>0<l>>>0&F>>>0<m>>>0){J=H;K=F}else{J=G<<16>>16>-1?((H|0)<(l|0)?H:h):0;K=I<<16>>16>-1?((F|0)<(m|0)?F:a):0}F=r+((Y(K,s)|0)+J)|0;b[C+E>>0]=b[F>>0]|0;E=E+1|0}while((E|0)!=(v|0));break}case 0:{E=0;do{F=E<<1;I=d[D+(F<<1)>>1]|0;H=d[D+((F|1)<<1)>>1]|0;F=r+((Y(H,s)|0)+I)|0;b[C+E>>0]=b[(I>>>0<l>>>0&H>>>0<m>>>0?F:j)>>0]|0;E=E+1|0}while((E|0)!=(v|0));break}default:{E=0;do{F=E<<1;H=d[D+(F<<1)>>1]|0;I=d[D+((F|1)<<1)>>1]|0;if(!(H>>>0<l>>>0&I>>>0<m>>>0)){if(!A){F=lL(H,l,g)|0;L=F;M=lL(I,m,g)|0;y=28}}else{L=H;M=I;y=28}if((y|0)==28){y=0;I=r+((Y(M,s)|0)+L)|0;b[C+E>>0]=b[I>>0]|0}E=E+1|0}while((E|0)!=(v|0))}}}else if(k){if(A){E=C;I=0;while(1){H=I<<1;F=d[D+(H<<1)>>1]|0;G=d[D+((H|1)<<1)>>1]|0;do if(F>>>0<l>>>0&G>>>0<m>>>0){H=r+(Y(G,s)|0)|0;if(t){N=H+(F*3|0)|0;b[E>>0]=b[N>>0]|0;b[E+1>>0]=b[N+1>>0]|0;b[E+2>>0]=b[N+2>>0]|0;break}if(z){N=H+(F<<2)|0;b[E>>0]=b[N>>0]|0;b[E+1>>0]=b[N+1>>0]|0;b[E+2>>0]=b[N+2>>0]|0;b[E+3>>0]=b[N+3>>0]|0;break}N=H+(Y(F,q)|0)|0;H=0;do{b[E+H>>0]=b[N+H>>0]|0;H=H+1|0}while((H|0)!=(q|0))}while(0);I=I+1|0;if((I|0)==(v|0))break a;else E=E+q|0}}else{O=C;P=0}while(1){E=P<<1;I=d[D+(E<<1)>>1]|0;F=I<<16>>16;G=d[D+((E|1)<<1)>>1]|0;E=G<<16>>16;b:do if(F>>>0<l>>>0&E>>>0<m>>>0){H=r+(Y(E,s)|0)|0;if(t){N=H+(F*3|0)|0;b[O>>0]=b[N>>0]|0;b[O+1>>0]=b[N+1>>0]|0;b[O+2>>0]=b[N+2>>0]|0;break}if(z){N=H+(F<<2)|0;b[O>>0]=b[N>>0]|0;b[O+1>>0]=b[N+1>>0]|0;b[O+2>>0]=b[N+2>>0]|0;b[O+3>>0]=b[N+3>>0]|0;break}N=H+(Y(F,q)|0)|0;H=0;do{b[O+H>>0]=b[N+H>>0]|0;H=H+1|0}while((H|0)!=(q|0))}else{switch(g|0){case 5:{break b;break}case 1:{Q=r+(Y(G<<16>>16>-1?((E|0)<(m|0)?E:a):0,s)|0)+(Y(I<<16>>16>-1?((F|0)<(l|0)?F:h):0,q)|0)|0;break}case 0:{Q=j;break}default:{H=lL(F,l,g)|0;Q=r+(Y(lL(E,m,g)|0,s)|0)+(Y(H,q)|0)|0}}H=0;do{b[O+H>>0]=b[Q+H>>0]|0;H=H+1|0}while((H|0)!=(q|0))}while(0);P=P+1|0;if((P|0)==(v|0))break;else O=O+q|0}}while(0);B=B+1|0}while((B|0)!=(w|0));u=i;return}function Fga(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;i=u;u=u+512|0;j=i;k=f[a+40>>2]|0;l=f[k+4>>2]|0;m=f[k>>2]|0;k=f[c+40>>2]|0;n=f[k+4>>2]|0;o=f[k>>2]|0;k=(f[a>>2]|0)>>>3&511;q=k+1|0;r=f[a+16>>2]|0;s=f[a+48>>2]|0;a=0;do{t=rNa(+p[h+((a&3)<<3)>>3])|0;b[j+a>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;a=a+1|0}while((a|0)!=(q|0));if(f[c>>2]&16384){a=(f[e>>2]&16384|0)!=0;h=Y(a?o:1,n)|0;if(a){v=h;w=1}else{x=h;y=5}}else{x=n;y=5}if((y|0)==5)if((o|0)>0){v=x;w=o}else{u=i;return}o=c+16|0;x=c+44|0;c=e+16|0;n=e+44|0;e=(k|0)==0;k=(v|0)>0;h=l+-1|0;a=m+-1|0;t=(q|0)==3;z=(q|0)==4;A=(g|0)==5;B=0;do{C=(f[o>>2]|0)+(Y(f[f[x>>2]>>2]|0,B)|0)|0;D=(f[c>>2]|0)+(Y(f[f[n>>2]>>2]|0,B)|0)|0;a:do if(e){if(k)switch(g|0){case 1:{E=0;do{F=E<<1;G=d[D+(F<<1)>>1]|0;H=G<<16>>16;I=d[D+((F|1)<<1)>>1]|0;F=I<<16>>16;if(H>>>0<l>>>0&F>>>0<m>>>0){J=H;K=F}else{J=G<<16>>16>-1?((H|0)<(l|0)?H:h):0;K=I<<16>>16>-1?((F|0)<(m|0)?F:a):0}F=r+((Y(K,s)|0)+J)|0;b[C+E>>0]=b[F>>0]|0;E=E+1|0}while((E|0)!=(v|0));break}case 0:{E=0;do{F=E<<1;I=d[D+(F<<1)>>1]|0;H=d[D+((F|1)<<1)>>1]|0;F=r+((Y(H,s)|0)+I)|0;b[C+E>>0]=b[(I>>>0<l>>>0&H>>>0<m>>>0?F:j)>>0]|0;E=E+1|0}while((E|0)!=(v|0));break}default:{E=0;do{F=E<<1;H=d[D+(F<<1)>>1]|0;I=d[D+((F|1)<<1)>>1]|0;if(!(H>>>0<l>>>0&I>>>0<m>>>0)){if(!A){F=lL(H,l,g)|0;L=F;M=lL(I,m,g)|0;y=28}}else{L=H;M=I;y=28}if((y|0)==28){y=0;I=r+((Y(M,s)|0)+L)|0;b[C+E>>0]=b[I>>0]|0}E=E+1|0}while((E|0)!=(v|0))}}}else if(k){if(A){E=C;I=0;while(1){H=I<<1;F=d[D+(H<<1)>>1]|0;G=d[D+((H|1)<<1)>>1]|0;do if(F>>>0<l>>>0&G>>>0<m>>>0){H=r+(Y(G,s)|0)|0;if(t){N=H+(F*3|0)|0;b[E>>0]=b[N>>0]|0;b[E+1>>0]=b[N+1>>0]|0;b[E+2>>0]=b[N+2>>0]|0;break}if(z){N=H+(F<<2)|0;b[E>>0]=b[N>>0]|0;b[E+1>>0]=b[N+1>>0]|0;b[E+2>>0]=b[N+2>>0]|0;b[E+3>>0]=b[N+3>>0]|0;break}N=H+(Y(F,q)|0)|0;H=0;do{b[E+H>>0]=b[N+H>>0]|0;H=H+1|0}while((H|0)!=(q|0))}while(0);I=I+1|0;if((I|0)==(v|0))break a;else E=E+q|0}}else{O=C;P=0}while(1){E=P<<1;I=d[D+(E<<1)>>1]|0;F=I<<16>>16;G=d[D+((E|1)<<1)>>1]|0;E=G<<16>>16;b:do if(F>>>0<l>>>0&E>>>0<m>>>0){H=r+(Y(E,s)|0)|0;if(t){N=H+(F*3|0)|0;b[O>>0]=b[N>>0]|0;b[O+1>>0]=b[N+1>>0]|0;b[O+2>>0]=b[N+2>>0]|0;break}if(z){N=H+(F<<2)|0;b[O>>0]=b[N>>0]|0;b[O+1>>0]=b[N+1>>0]|0;b[O+2>>0]=b[N+2>>0]|0;b[O+3>>0]=b[N+3>>0]|0;break}N=H+(Y(F,q)|0)|0;H=0;do{b[O+H>>0]=b[N+H>>0]|0;H=H+1|0}while((H|0)!=(q|0))}else{switch(g|0){case 5:{break b;break}case 1:{Q=r+(Y(G<<16>>16>-1?((E|0)<(m|0)?E:a):0,s)|0)+(Y(I<<16>>16>-1?((F|0)<(l|0)?F:h):0,q)|0)|0;break}case 0:{Q=j;break}default:{H=lL(F,l,g)|0;Q=r+(Y(lL(E,m,g)|0,s)|0)+(Y(H,q)|0)|0}}H=0;do{b[O+H>>0]=b[Q+H>>0]|0;H=H+1|0}while((H|0)!=(q|0))}while(0);P=P+1|0;if((P|0)==(v|0))break;else O=O+q|0}}while(0);B=B+1|0}while((B|0)!=(w|0));u=i;return}function Gga(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;h=u;u=u+1024|0;i=h;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[b+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=(f[a>>2]|0)>>>3&511;o=j+1|0;q=f[a+16>>2]|0;r=f[a+48>>2]|0;a=0;do{s=rNa(+p[g+((a&3)<<3)>>3])|0;d[i+(a<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;a=a+1|0}while((a|0)!=(o|0));a=r>>>1;if(f[b>>2]&16384){r=(f[c>>2]&16384|0)!=0;g=Y(r?n:1,m)|0;if(r){t=g;v=1}else{w=g;x=5}}else{w=m;x=5}if((x|0)==5)if((n|0)>0){t=w;v=n}else{u=h;return}n=b+16|0;w=b+44|0;b=c+16|0;m=c+44|0;c=(j|0)==0;j=(t|0)>0;g=k+-1|0;r=l+-1|0;s=(o|0)==3;y=(o|0)==4;z=(e|0)==5;A=0;do{B=(f[n>>2]|0)+(Y(f[f[w>>2]>>2]|0,A)|0)|0;C=(f[b>>2]|0)+(Y(f[f[m>>2]>>2]|0,A)|0)|0;a:do if(c){if(j)switch(e|0){case 1:{D=0;do{E=D<<1;F=d[C+(E<<1)>>1]|0;G=F<<16>>16;H=d[C+((E|1)<<1)>>1]|0;E=H<<16>>16;if(G>>>0<k>>>0&E>>>0<l>>>0){I=G;J=E}else{I=F<<16>>16>-1?((G|0)<(k|0)?G:g):0;J=H<<16>>16>-1?((E|0)<(l|0)?E:r):0}E=q+((Y(J,a)|0)+I<<1)|0;d[B+(D<<1)>>1]=d[E>>1]|0;D=D+1|0}while((D|0)!=(t|0));break}case 0:{D=0;do{E=D<<1;H=d[C+(E<<1)>>1]|0;G=d[C+((E|1)<<1)>>1]|0;if(H>>>0<k>>>0&G>>>0<l>>>0)K=q+((Y(G,a)|0)+H<<1)|0;else K=i;d[B+(D<<1)>>1]=d[K>>1]|0;D=D+1|0}while((D|0)!=(t|0));break}default:{D=0;do{H=D<<1;G=d[C+(H<<1)>>1]|0;E=d[C+((H|1)<<1)>>1]|0;if(!(G>>>0<k>>>0&E>>>0<l>>>0)){if(!z){H=lL(G,k,e)|0;L=H;M=lL(E,l,e)|0;x=30}}else{L=G;M=E;x=30}if((x|0)==30){x=0;E=q+((Y(M,a)|0)+L<<1)|0;d[B+(D<<1)>>1]=d[E>>1]|0}D=D+1|0}while((D|0)!=(t|0))}}}else if(j){if(z){D=B;E=0;while(1){G=E<<1;H=d[C+(G<<1)>>1]|0;F=d[C+((G|1)<<1)>>1]|0;do if(H>>>0<k>>>0&F>>>0<l>>>0){G=q+((Y(F,a)|0)<<1)|0;if(s){N=G+(H*3<<1)|0;d[D>>1]=d[N>>1]|0;d[D+2>>1]=d[N+2>>1]|0;d[D+4>>1]=d[N+4>>1]|0;break}if(y){N=G+(H<<2<<1)|0;d[D>>1]=d[N>>1]|0;d[D+2>>1]=d[N+2>>1]|0;d[D+4>>1]=d[N+4>>1]|0;d[D+6>>1]=d[N+6>>1]|0;break}N=G+((Y(H,o)|0)<<1)|0;G=0;do{d[D+(G<<1)>>1]=d[N+(G<<1)>>1]|0;G=G+1|0}while((G|0)!=(o|0))}while(0);E=E+1|0;if((E|0)==(t|0))break a;else D=D+(o<<1)|0}}else{O=B;P=0}while(1){D=P<<1;E=d[C+(D<<1)>>1]|0;H=E<<16>>16;F=d[C+((D|1)<<1)>>1]|0;D=F<<16>>16;b:do if(H>>>0<k>>>0&D>>>0<l>>>0){G=q+((Y(D,a)|0)<<1)|0;if(s){N=G+(H*3<<1)|0;d[O>>1]=d[N>>1]|0;d[O+2>>1]=d[N+2>>1]|0;d[O+4>>1]=d[N+4>>1]|0;break}if(y){N=G+(H<<2<<1)|0;d[O>>1]=d[N>>1]|0;d[O+2>>1]=d[N+2>>1]|0;d[O+4>>1]=d[N+4>>1]|0;d[O+6>>1]=d[N+6>>1]|0;break}N=G+((Y(H,o)|0)<<1)|0;G=0;do{d[O+(G<<1)>>1]=d[N+(G<<1)>>1]|0;G=G+1|0}while((G|0)!=(o|0))}else{switch(e|0){case 5:{break b;break}case 1:{Q=q+((Y(F<<16>>16>-1?((D|0)<(l|0)?D:r):0,a)|0)<<1)+((Y(E<<16>>16>-1?((H|0)<(k|0)?H:g):0,o)|0)<<1)|0;break}case 0:{Q=i;break}default:{G=lL(H,k,e)|0;Q=q+((Y(lL(D,l,e)|0,a)|0)<<1)+((Y(G,o)|0)<<1)|0}}G=0;do{d[O+(G<<1)>>1]=d[Q+(G<<1)>>1]|0;G=G+1|0}while((G|0)!=(o|0))}while(0);P=P+1|0;if((P|0)==(t|0))break;else O=O+(o<<1)|0}}while(0);A=A+1|0}while((A|0)!=(v|0));u=h;return}function Hga(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;h=u;u=u+1024|0;i=h;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[b+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=(f[a>>2]|0)>>>3&511;o=j+1|0;q=f[a+16>>2]|0;r=f[a+48>>2]|0;a=0;do{s=rNa(+p[g+((a&3)<<3)>>3])|0;d[i+(a<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;a=a+1|0}while((a|0)!=(o|0));a=r>>>1;if(f[b>>2]&16384){r=(f[c>>2]&16384|0)!=0;g=Y(r?n:1,m)|0;if(r){t=g;v=1}else{w=g;x=5}}else{w=m;x=5}if((x|0)==5)if((n|0)>0){t=w;v=n}else{u=h;return}n=b+16|0;w=b+44|0;b=c+16|0;m=c+44|0;c=(j|0)==0;j=(t|0)>0;g=k+-1|0;r=l+-1|0;s=(o|0)==3;y=(o|0)==4;z=(e|0)==5;A=0;do{B=(f[n>>2]|0)+(Y(f[f[w>>2]>>2]|0,A)|0)|0;C=(f[b>>2]|0)+(Y(f[f[m>>2]>>2]|0,A)|0)|0;a:do if(c){if(j)switch(e|0){case 1:{D=0;do{E=D<<1;F=d[C+(E<<1)>>1]|0;G=F<<16>>16;H=d[C+((E|1)<<1)>>1]|0;E=H<<16>>16;if(G>>>0<k>>>0&E>>>0<l>>>0){I=G;J=E}else{I=F<<16>>16>-1?((G|0)<(k|0)?G:g):0;J=H<<16>>16>-1?((E|0)<(l|0)?E:r):0}E=q+((Y(J,a)|0)+I<<1)|0;d[B+(D<<1)>>1]=d[E>>1]|0;D=D+1|0}while((D|0)!=(t|0));break}case 0:{D=0;do{E=D<<1;H=d[C+(E<<1)>>1]|0;G=d[C+((E|1)<<1)>>1]|0;if(H>>>0<k>>>0&G>>>0<l>>>0)K=q+((Y(G,a)|0)+H<<1)|0;else K=i;d[B+(D<<1)>>1]=d[K>>1]|0;D=D+1|0}while((D|0)!=(t|0));break}default:{D=0;do{H=D<<1;G=d[C+(H<<1)>>1]|0;E=d[C+((H|1)<<1)>>1]|0;if(!(G>>>0<k>>>0&E>>>0<l>>>0)){if(!z){H=lL(G,k,e)|0;L=H;M=lL(E,l,e)|0;x=30}}else{L=G;M=E;x=30}if((x|0)==30){x=0;E=q+((Y(M,a)|0)+L<<1)|0;d[B+(D<<1)>>1]=d[E>>1]|0}D=D+1|0}while((D|0)!=(t|0))}}}else if(j){if(z){D=B;E=0;while(1){G=E<<1;H=d[C+(G<<1)>>1]|0;F=d[C+((G|1)<<1)>>1]|0;do if(H>>>0<k>>>0&F>>>0<l>>>0){G=q+((Y(F,a)|0)<<1)|0;if(s){N=G+(H*3<<1)|0;d[D>>1]=d[N>>1]|0;d[D+2>>1]=d[N+2>>1]|0;d[D+4>>1]=d[N+4>>1]|0;break}if(y){N=G+(H<<2<<1)|0;d[D>>1]=d[N>>1]|0;d[D+2>>1]=d[N+2>>1]|0;d[D+4>>1]=d[N+4>>1]|0;d[D+6>>1]=d[N+6>>1]|0;break}N=G+((Y(H,o)|0)<<1)|0;G=0;do{d[D+(G<<1)>>1]=d[N+(G<<1)>>1]|0;G=G+1|0}while((G|0)!=(o|0))}while(0);E=E+1|0;if((E|0)==(t|0))break a;else D=D+(o<<1)|0}}else{O=B;P=0}while(1){D=P<<1;E=d[C+(D<<1)>>1]|0;H=E<<16>>16;F=d[C+((D|1)<<1)>>1]|0;D=F<<16>>16;b:do if(H>>>0<k>>>0&D>>>0<l>>>0){G=q+((Y(D,a)|0)<<1)|0;if(s){N=G+(H*3<<1)|0;d[O>>1]=d[N>>1]|0;d[O+2>>1]=d[N+2>>1]|0;d[O+4>>1]=d[N+4>>1]|0;break}if(y){N=G+(H<<2<<1)|0;d[O>>1]=d[N>>1]|0;d[O+2>>1]=d[N+2>>1]|0;d[O+4>>1]=d[N+4>>1]|0;d[O+6>>1]=d[N+6>>1]|0;break}N=G+((Y(H,o)|0)<<1)|0;G=0;do{d[O+(G<<1)>>1]=d[N+(G<<1)>>1]|0;G=G+1|0}while((G|0)!=(o|0))}else{switch(e|0){case 5:{break b;break}case 1:{Q=q+((Y(F<<16>>16>-1?((D|0)<(l|0)?D:r):0,a)|0)<<1)+((Y(E<<16>>16>-1?((H|0)<(k|0)?H:g):0,o)|0)<<1)|0;break}case 0:{Q=i;break}default:{G=lL(H,k,e)|0;Q=q+((Y(lL(D,l,e)|0,a)|0)<<1)+((Y(G,o)|0)<<1)|0}}G=0;do{d[O+(G<<1)>>1]=d[Q+(G<<1)>>1]|0;G=G+1|0}while((G|0)!=(o|0))}while(0);P=P+1|0;if((P|0)==(t|0))break;else O=O+(o<<1)|0}}while(0);A=A+1|0}while((A|0)!=(v|0));u=h;return}function Iga(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;h=u;u=u+2048|0;i=h;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[b+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=(f[a>>2]|0)>>>3&511;o=j+1|0;q=f[a+16>>2]|0;r=f[a+48>>2]|0;a=0;do{s=rNa(+p[g+((a&3)<<3)>>3])|0;f[i+(a<<2)>>2]=s;a=a+1|0}while((a|0)!=(o|0));a=r>>>2;if(f[b>>2]&16384){r=(f[c>>2]&16384|0)!=0;g=Y(r?n:1,m)|0;if(r){t=g;v=1}else{w=g;x=5}}else{w=m;x=5}if((x|0)==5)if((n|0)>0){t=w;v=n}else{u=h;return}n=b+16|0;w=b+44|0;b=c+16|0;m=c+44|0;c=(j|0)==0;j=(t|0)>0;g=k+-1|0;r=l+-1|0;s=(o|0)==3;y=(o|0)==4;z=(e|0)==5;A=0;do{B=(f[n>>2]|0)+(Y(f[f[w>>2]>>2]|0,A)|0)|0;C=(f[b>>2]|0)+(Y(f[f[m>>2]>>2]|0,A)|0)|0;a:do if(c){if(j)switch(e|0){case 1:{D=0;do{E=D<<1;F=d[C+(E<<1)>>1]|0;G=F<<16>>16;H=d[C+((E|1)<<1)>>1]|0;E=H<<16>>16;if(G>>>0<k>>>0&E>>>0<l>>>0){I=G;J=E}else{I=F<<16>>16>-1?((G|0)<(k|0)?G:g):0;J=H<<16>>16>-1?((E|0)<(l|0)?E:r):0}E=q+((Y(J,a)|0)+I<<2)|0;f[B+(D<<2)>>2]=f[E>>2];D=D+1|0}while((D|0)!=(t|0));break}case 0:{D=0;do{E=D<<1;H=d[C+(E<<1)>>1]|0;G=d[C+((E|1)<<1)>>1]|0;if(H>>>0<k>>>0&G>>>0<l>>>0)K=q+((Y(G,a)|0)+H<<2)|0;else K=i;f[B+(D<<2)>>2]=f[K>>2];D=D+1|0}while((D|0)!=(t|0));break}default:{D=0;do{H=D<<1;G=d[C+(H<<1)>>1]|0;E=d[C+((H|1)<<1)>>1]|0;if(!(G>>>0<k>>>0&E>>>0<l>>>0)){if(!z){H=lL(G,k,e)|0;L=H;M=lL(E,l,e)|0;x=30}}else{L=G;M=E;x=30}if((x|0)==30){x=0;E=q+((Y(M,a)|0)+L<<2)|0;f[B+(D<<2)>>2]=f[E>>2]}D=D+1|0}while((D|0)!=(t|0))}}}else if(j){if(z){D=B;E=0;while(1){G=E<<1;H=d[C+(G<<1)>>1]|0;F=d[C+((G|1)<<1)>>1]|0;do if(H>>>0<k>>>0&F>>>0<l>>>0){G=q+((Y(F,a)|0)<<2)|0;if(s){N=G+(H*3<<2)|0;f[D>>2]=f[N>>2];f[D+4>>2]=f[N+4>>2];f[D+8>>2]=f[N+8>>2];break}if(y){N=G+(H<<2<<2)|0;f[D>>2]=f[N>>2];f[D+4>>2]=f[N+4>>2];f[D+8>>2]=f[N+8>>2];f[D+12>>2]=f[N+12>>2];break}N=G+((Y(H,o)|0)<<2)|0;G=0;do{f[D+(G<<2)>>2]=f[N+(G<<2)>>2];G=G+1|0}while((G|0)!=(o|0))}while(0);E=E+1|0;if((E|0)==(t|0))break a;else D=D+(o<<2)|0}}else{O=B;P=0}while(1){D=P<<1;E=d[C+(D<<1)>>1]|0;H=E<<16>>16;F=d[C+((D|1)<<1)>>1]|0;D=F<<16>>16;b:do if(H>>>0<k>>>0&D>>>0<l>>>0){G=q+((Y(D,a)|0)<<2)|0;if(s){N=G+(H*3<<2)|0;f[O>>2]=f[N>>2];f[O+4>>2]=f[N+4>>2];f[O+8>>2]=f[N+8>>2];break}if(y){N=G+(H<<2<<2)|0;f[O>>2]=f[N>>2];f[O+4>>2]=f[N+4>>2];f[O+8>>2]=f[N+8>>2];f[O+12>>2]=f[N+12>>2];break}N=G+((Y(H,o)|0)<<2)|0;G=0;do{f[O+(G<<2)>>2]=f[N+(G<<2)>>2];G=G+1|0}while((G|0)!=(o|0))}else{switch(e|0){case 5:{break b;break}case 1:{Q=q+((Y(F<<16>>16>-1?((D|0)<(l|0)?D:r):0,a)|0)<<2)+((Y(E<<16>>16>-1?((H|0)<(k|0)?H:g):0,o)|0)<<2)|0;break}case 0:{Q=i;break}default:{G=lL(H,k,e)|0;Q=q+((Y(lL(D,l,e)|0,a)|0)<<2)+((Y(G,o)|0)<<2)|0}}G=0;do{f[O+(G<<2)>>2]=f[Q+(G<<2)>>2];G=G+1|0}while((G|0)!=(o|0))}while(0);P=P+1|0;if((P|0)==(t|0))break;else O=O+(o<<2)|0}}while(0);A=A+1|0}while((A|0)!=(v|0));u=h;return}function Jga(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;h=u;u=u+2048|0;i=h;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[b+40>>2]|0;m=f[j+4>>2]|0;o=f[j>>2]|0;j=(f[a>>2]|0)>>>3&511;q=j+1|0;r=f[a+16>>2]|0;s=f[a+48>>2]|0;a=0;do{n[i+(a<<2)>>2]=+p[g+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(q|0));a=s>>>2;if(f[b>>2]&16384){s=(f[c>>2]&16384|0)!=0;g=Y(s?o:1,m)|0;if(s){t=g;v=1}else{w=g;x=5}}else{w=m;x=5}if((x|0)==5)if((o|0)>0){t=w;v=o}else{u=h;return}o=b+16|0;w=b+44|0;b=c+16|0;m=c+44|0;c=(j|0)==0;j=(t|0)>0;g=k+-1|0;s=l+-1|0;y=(q|0)==3;z=(q|0)==4;A=(e|0)==5;B=0;do{C=(f[o>>2]|0)+(Y(f[f[w>>2]>>2]|0,B)|0)|0;D=(f[b>>2]|0)+(Y(f[f[m>>2]>>2]|0,B)|0)|0;a:do if(c){if(j)switch(e|0){case 1:{E=0;do{F=E<<1;G=d[D+(F<<1)>>1]|0;H=G<<16>>16;I=d[D+((F|1)<<1)>>1]|0;F=I<<16>>16;if(H>>>0<k>>>0&F>>>0<l>>>0){J=H;K=F}else{J=G<<16>>16>-1?((H|0)<(k|0)?H:g):0;K=I<<16>>16>-1?((F|0)<(l|0)?F:s):0}F=r+((Y(K,a)|0)+J<<2)|0;f[C+(E<<2)>>2]=f[F>>2];E=E+1|0}while((E|0)!=(t|0));break}case 0:{E=0;do{F=E<<1;I=d[D+(F<<1)>>1]|0;H=d[D+((F|1)<<1)>>1]|0;if(I>>>0<k>>>0&H>>>0<l>>>0)L=r+((Y(H,a)|0)+I<<2)|0;else L=i;f[C+(E<<2)>>2]=f[L>>2];E=E+1|0}while((E|0)!=(t|0));break}default:{E=0;do{I=E<<1;H=d[D+(I<<1)>>1]|0;F=d[D+((I|1)<<1)>>1]|0;if(!(H>>>0<k>>>0&F>>>0<l>>>0)){if(!A){I=lL(H,k,e)|0;M=I;N=lL(F,l,e)|0;x=30}}else{M=H;N=F;x=30}if((x|0)==30){x=0;F=r+((Y(N,a)|0)+M<<2)|0;f[C+(E<<2)>>2]=f[F>>2]}E=E+1|0}while((E|0)!=(t|0))}}}else if(j){if(A){E=C;F=0;while(1){H=F<<1;I=d[D+(H<<1)>>1]|0;G=d[D+((H|1)<<1)>>1]|0;do if(I>>>0<k>>>0&G>>>0<l>>>0){H=r+((Y(G,a)|0)<<2)|0;if(y){O=H+(I*3<<2)|0;f[E>>2]=f[O>>2];f[E+4>>2]=f[O+4>>2];f[E+8>>2]=f[O+8>>2];break}if(z){O=H+(I<<2<<2)|0;f[E>>2]=f[O>>2];f[E+4>>2]=f[O+4>>2];f[E+8>>2]=f[O+8>>2];f[E+12>>2]=f[O+12>>2];break}O=H+((Y(I,q)|0)<<2)|0;H=0;do{f[E+(H<<2)>>2]=f[O+(H<<2)>>2];H=H+1|0}while((H|0)!=(q|0))}while(0);F=F+1|0;if((F|0)==(t|0))break a;else E=E+(q<<2)|0}}else{P=C;Q=0}while(1){E=Q<<1;F=d[D+(E<<1)>>1]|0;I=F<<16>>16;G=d[D+((E|1)<<1)>>1]|0;E=G<<16>>16;b:do if(I>>>0<k>>>0&E>>>0<l>>>0){H=r+((Y(E,a)|0)<<2)|0;if(y){O=H+(I*3<<2)|0;f[P>>2]=f[O>>2];f[P+4>>2]=f[O+4>>2];f[P+8>>2]=f[O+8>>2];break}if(z){O=H+(I<<2<<2)|0;f[P>>2]=f[O>>2];f[P+4>>2]=f[O+4>>2];f[P+8>>2]=f[O+8>>2];f[P+12>>2]=f[O+12>>2];break}O=H+((Y(I,q)|0)<<2)|0;H=0;do{f[P+(H<<2)>>2]=f[O+(H<<2)>>2];H=H+1|0}while((H|0)!=(q|0))}else{switch(e|0){case 5:{break b;break}case 1:{R=r+((Y(G<<16>>16>-1?((E|0)<(l|0)?E:s):0,a)|0)<<2)+((Y(F<<16>>16>-1?((I|0)<(k|0)?I:g):0,q)|0)<<2)|0;break}case 0:{R=i;break}default:{H=lL(I,k,e)|0;R=r+((Y(lL(E,l,e)|0,a)|0)<<2)+((Y(H,q)|0)<<2)|0}}H=0;do{f[P+(H<<2)>>2]=f[R+(H<<2)>>2];H=H+1|0}while((H|0)!=(q|0))}while(0);Q=Q+1|0;if((Q|0)==(t|0))break;else P=P+(q<<2)|0}}while(0);B=B+1|0}while((B|0)!=(v|0));u=h;return}function Kga(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;h=u;u=u+4096|0;i=h;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[b+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=(f[a>>2]|0)>>>3&511;o=j+1|0;q=f[a+16>>2]|0;r=f[a+48>>2]|0;a=0;do{p[i+(a<<3)>>3]=+p[g+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(o|0));a=r>>>3;if(f[b>>2]&16384){r=(f[c>>2]&16384|0)!=0;g=Y(r?n:1,m)|0;if(r){s=g;t=1}else{v=g;w=5}}else{v=m;w=5}if((w|0)==5)if((n|0)>0){s=v;t=n}else{u=h;return}n=b+16|0;v=b+44|0;b=c+16|0;m=c+44|0;c=(j|0)==0;j=(s|0)>0;g=k+-1|0;r=l+-1|0;x=(o|0)==3;y=(o|0)==4;z=(e|0)==5;A=0;do{B=(f[n>>2]|0)+(Y(f[f[v>>2]>>2]|0,A)|0)|0;C=(f[b>>2]|0)+(Y(f[f[m>>2]>>2]|0,A)|0)|0;a:do if(c){if(j)switch(e|0){case 1:{D=0;do{E=D<<1;F=d[C+(E<<1)>>1]|0;G=F<<16>>16;H=d[C+((E|1)<<1)>>1]|0;E=H<<16>>16;if(G>>>0<k>>>0&E>>>0<l>>>0){I=G;J=E}else{I=F<<16>>16>-1?((G|0)<(k|0)?G:g):0;J=H<<16>>16>-1?((E|0)<(l|0)?E:r):0}E=q+((Y(J,a)|0)+I<<3)|0;p[B+(D<<3)>>3]=+p[E>>3];D=D+1|0}while((D|0)!=(s|0));break}case 0:{D=0;do{E=D<<1;H=d[C+(E<<1)>>1]|0;G=d[C+((E|1)<<1)>>1]|0;if(H>>>0<k>>>0&G>>>0<l>>>0)K=q+((Y(G,a)|0)+H<<3)|0;else K=i;p[B+(D<<3)>>3]=+p[K>>3];D=D+1|0}while((D|0)!=(s|0));break}default:{D=0;do{H=D<<1;G=d[C+(H<<1)>>1]|0;E=d[C+((H|1)<<1)>>1]|0;if(!(G>>>0<k>>>0&E>>>0<l>>>0)){if(!z){H=lL(G,k,e)|0;L=H;M=lL(E,l,e)|0;w=30}}else{L=G;M=E;w=30}if((w|0)==30){w=0;E=q+((Y(M,a)|0)+L<<3)|0;p[B+(D<<3)>>3]=+p[E>>3]}D=D+1|0}while((D|0)!=(s|0))}}}else if(j){if(z){D=B;E=0;while(1){G=E<<1;H=d[C+(G<<1)>>1]|0;F=d[C+((G|1)<<1)>>1]|0;do if(H>>>0<k>>>0&F>>>0<l>>>0){G=q+((Y(F,a)|0)<<3)|0;if(x){N=G+(H*3<<3)|0;p[D>>3]=+p[N>>3];p[D+8>>3]=+p[N+8>>3];p[D+16>>3]=+p[N+16>>3];break}if(y){N=G+(H<<2<<3)|0;p[D>>3]=+p[N>>3];p[D+8>>3]=+p[N+8>>3];p[D+16>>3]=+p[N+16>>3];p[D+24>>3]=+p[N+24>>3];break}N=G+((Y(H,o)|0)<<3)|0;G=0;do{p[D+(G<<3)>>3]=+p[N+(G<<3)>>3];G=G+1|0}while((G|0)!=(o|0))}while(0);E=E+1|0;if((E|0)==(s|0))break a;else D=D+(o<<3)|0}}else{O=B;P=0}while(1){D=P<<1;E=d[C+(D<<1)>>1]|0;H=E<<16>>16;F=d[C+((D|1)<<1)>>1]|0;D=F<<16>>16;b:do if(H>>>0<k>>>0&D>>>0<l>>>0){G=q+((Y(D,a)|0)<<3)|0;if(x){N=G+(H*3<<3)|0;p[O>>3]=+p[N>>3];p[O+8>>3]=+p[N+8>>3];p[O+16>>3]=+p[N+16>>3];break}if(y){N=G+(H<<2<<3)|0;p[O>>3]=+p[N>>3];p[O+8>>3]=+p[N+8>>3];p[O+16>>3]=+p[N+16>>3];p[O+24>>3]=+p[N+24>>3];break}N=G+((Y(H,o)|0)<<3)|0;G=0;do{p[O+(G<<3)>>3]=+p[N+(G<<3)>>3];G=G+1|0}while((G|0)!=(o|0))}else{switch(e|0){case 5:{break b;break}case 1:{Q=q+((Y(F<<16>>16>-1?((D|0)<(l|0)?D:r):0,a)|0)<<3)+((Y(E<<16>>16>-1?((H|0)<(k|0)?H:g):0,o)|0)<<3)|0;break}case 0:{Q=i;break}default:{G=lL(H,k,e)|0;Q=q+((Y(lL(D,l,e)|0,a)|0)<<3)+((Y(G,o)|0)<<3)|0}}G=0;do{p[O+(G<<3)>>3]=+p[Q+(G<<3)>>3];G=G+1|0}while((G|0)!=(o|0))}while(0);P=P+1|0;if((P|0)==(s|0))break;else O=O+(o<<3)|0}}while(0);A=A+1|0}while((A|0)!=(t|0));u=h;return}function Lga(a,b,c,d,e,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0;o=u;u=u+1408|0;q=o+1352|0;r=o+1288|0;s=o+1296|0;t=o+208|0;v=o+224|0;w=o+216|0;x=o+32|0;y=o;f[r>>2]=d;f[r+4>>2]=e;CN(q,r,a,b,c);f[t>>2]=i;f[t+4>>2]=j;CN(s,t,a,g,h);h=s+12|0;g=f[h>>2]|0;a=g<<1;t=v+8|0;f[v>>2]=t;j=v+4|0;f[j>>2]=a;if(a>>>0>264){i=OYa(a>>>0>1073741823?-1:a<<2)|0;f[v>>2]=i;z=i}else z=t;i=z+(g<<2)|0;if((g|0)>0){A=+p[k>>3];B=+p[k+24>>3];g=f[h>>2]|0;a=0;do{C=+(a|0);c=rNa(C*A*1024.0)|0;f[z+(a<<2)>>2]=c;c=rNa(C*B*1024.0)|0;f[i+(a<<2)>>2]=c;a=a+1|0}while((a|0)<(g|0))}g=s+8|0;a=f[g>>2]|0;f[w>>2]=0;f[w+4>>2]=a;B=+p[n+8>>3];A=+p[n+16>>3];C=+p[n+24>>3];p[y>>3]=+p[n>>3];p[y+8>>3]=B;p[y+16>>3]=A;p[y+24>>3]=C;Mga(x,q,s,l,m,y,z,i,k);k=s+4|0;i=f[k>>2]|0;if((i|0)<3)D=Y(f[h>>2]|0,f[g>>2]|0)|0;else{g=f[s+40>>2]|0;h=0;z=1;while(1){y=Y(f[g+(h<<2)>>2]|0,z)|0;h=h+1|0;if((h|0)==(i|0)){D=y;break}else z=y}}_U(w,x,+(D>>>0)*.0000152587890625);Nga(x);x=f[v>>2]|0;if((x|0)!=(t|0)){if(x|0)QYa(x);f[v>>2]=t;f[j>>2]=264}j=s+36|0;t=f[j>>2]|0;if(t|0?(v=t+12|0,t=f[v>>2]|0,f[v>>2]=t+-1,(t|0)==1):0)CR(s);f[j>>2]=0;j=s+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[k>>2]|0)>0){j=f[s+40>>2]|0;t=0;do{f[j+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[k>>2]|0))}k=f[s+44>>2]|0;if((k|0)!=(s+48|0))ZF(k);k=q+36|0;s=f[k>>2]|0;if(s|0?(t=s+12|0,s=f[t>>2]|0,f[t>>2]=s+-1,(s|0)==1):0)CR(q);f[k>>2]=0;k=q+16|0;s=q+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[s>>2]|0)>0){k=f[q+40>>2]|0;t=0;do{f[k+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[s>>2]|0))}s=f[q+44>>2]|0;if((s|0)==(q+48|0)){u=o;return}ZF(s);u=o;return}function Mga(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0;f[a>>2]=72832;k=a+4|0;f[k>>2]=f[b>>2];l=a+8|0;m=b+4|0;f[l>>2]=f[m>>2];n=a+12|0;f[n>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];o=f[b+36>>2]|0;f[a+40>>2]=o;f[a+44>>2]=n;n=a+52|0;q=a+48|0;f[q>>2]=n;f[n>>2]=0;f[a+56>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[b+44>>2]|0;n=f[q>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2]}else{f[l>>2]=0;BR(k,b)}b=a+60|0;f[b>>2]=f[c>>2];k=a+64|0;l=c+4|0;f[k>>2]=f[l>>2];m=a+68|0;f[m>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];n=f[c+36>>2]|0;f[a+96>>2]=n;f[a+100>>2]=m;m=a+108|0;q=a+104|0;f[q>>2]=m;f[m>>2]=0;f[a+112>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[c+44>>2]|0;m=f[q>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];r=a+116|0;f[r>>2]=d;s=a+120|0;f[s>>2]=e;t=+p[g>>3];u=a+128|0;p[u>>3]=t;v=g+8|0;w=+p[v>>3];x=a+136|0;p[x>>3]=w;y=g+16|0;z=+p[y>>3];A=a+144|0;p[A>>3]=z;B=g+24|0;C=+p[B>>3];D=a+152|0;p[D>>3]=C;E=a+160|0;f[E>>2]=h;F=a+164|0;f[F>>2]=i;G=a+168|0;f[G>>2]=j;return}else{f[k>>2]=0;BR(b,c);r=a+116|0;f[r>>2]=d;s=a+120|0;f[s>>2]=e;t=+p[g>>3];u=a+128|0;p[u>>3]=t;v=g+8|0;w=+p[v>>3];x=a+136|0;p[x>>3]=w;y=g+16|0;z=+p[y>>3];A=a+144|0;p[A>>3]=z;B=g+24|0;C=+p[B>>3];D=a+152|0;p[D>>3]=C;E=a+160|0;f[E>>2]=h;F=a+164|0;f[F>>2]=i;G=a+168|0;f[G>>2]=j;return}}function Nga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=72832;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function Oga(a){a=a|0;Nga(a);PYa(a);return}function Pga(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0;c=u;u=u+24912|0;e=c+8520|0;g=c+328|0;h=c+272|0;i=c+216|0;j=c+160|0;k=c+104|0;l=c+88|0;m=c+72|0;n=c+56|0;o=c;q=a+116|0;r=(f[q>>2]|0)==0?512:16;s=a+60|0;t=f[a+68>>2]|0;v=4096/(((t|0)<32?t:32)|0)|0;w=a+72|0;x=f[w>>2]|0;y=(x|0)<(v|0)?x:v;v=4096/(y|0)|0;x=(t|0)<(v|0)?t:v;v=f[b>>2]|0;t=b+4|0;if((v|0)>=(f[t>>2]|0)){u=c;return}b=h+4|0;z=h+8|0;A=h+12|0;B=h+16|0;C=h+20|0;D=h+24|0;E=h+28|0;F=h+40|0;G=h+48|0;H=h+44|0;I=i+4|0;J=i+8|0;K=i+40|0;L=i+48|0;M=i+44|0;N=i+52|0;O=k+4|0;P=k+8|0;Q=k+12|0;R=a+4|0;S=k+8|0;T=k+12|0;U=k+4|0;V=l+8|0;W=l+4|0;X=m+8|0;Z=m+12|0;_=m+4|0;$=o+4|0;aa=o+8|0;ba=o+40|0;ca=o+48|0;da=o+44|0;ea=o+52|0;fa=n+8|0;ga=n+12|0;ha=n+4|0;ia=a+120|0;ja=a+128|0;ka=o+36|0;la=o+16|0;ma=j+36|0;na=j+16|0;oa=j+4|0;pa=j+40|0;qa=j+44|0;ra=j+48|0;sa=i+36|0;ta=i+16|0;ua=h+36|0;va=k+4|0;wa=k+8|0;xa=k+12|0;ya=k+16|0;za=k+20|0;Aa=k+24|0;Ba=k+28|0;Ca=k+40|0;Da=k+48|0;Ea=k+44|0;Fa=l+8|0;Ga=l+12|0;Ha=l+4|0;Ia=m+8|0;Ja=m+4|0;Ka=n+8|0;La=n+12|0;Ma=n+4|0;Na=o+8|0;Oa=o+12|0;Pa=o+4|0;Qa=k+36|0;Ra=a+168|0;Sa=a+160|0;Ta=a+164|0;a=D+8|0;Ua=h+52|0;Va=Aa+8|0;Wa=k+52|0;Xa=f[w>>2]|0;Ya=v;while(1){if((Xa|0)>0){v=Xa;Za=0;while(1){_a=v-Za|0;$a=(_a|0)<(y|0)?_a:y;_a=(f[t>>2]|0)-Ya|0;ab=(_a|0)<(x|0)?_a:x;f[b>>2]=2;f[z>>2]=ab;f[A>>2]=$a;f[B>>2]=e;f[C>>2]=e;_a=a;f[_a>>2]=0;f[_a+4>>2]=0;f[F>>2]=z;f[H>>2]=G;_a=$a<<2;f[h>>2]=1124024331;f[G>>2]=_a;f[Ua>>2]=4;bb=e+(Y(ab,_a)|0)|0;f[E>>2]=bb;f[D>>2]=bb+(0-_a)+_a;f[i>>2]=1124007936;_a=I;bb=_a+36|0;do{f[_a>>2]=0;_a=_a+4|0}while((_a|0)<(bb|0));f[K>>2]=J;f[M>>2]=L;f[L>>2]=0;f[N>>2]=0;f[k>>2]=Za;f[O>>2]=Ya;f[P>>2]=$a;f[Q>>2]=ab;FR(j,s,k);if((ab|0)>0){cb=f[Ra>>2]|0;db=+p[cb+8>>3];eb=+p[cb+16>>3];fb=+p[cb+32>>3];gb=+p[cb+40>>3];cb=f[q>>2]|0;hb=(cb|0)==0;ib=($a|0)>0;jb=0;do{kb=Y(jb,$a)|0;lb=e+(kb<<1<<1)|0;mb=+(jb+Ya|0);nb=(rNa((mb*db+eb)*1024.0)|0)+r|0;ob=(rNa((mb*fb+gb)*1024.0)|0)+r|0;if(hb){if(ib){pb=f[Sa>>2]|0;qb=f[Ta>>2]|0;rb=0;do{sb=rb+Za|0;tb=(f[pb+(sb<<2)>>2]|0)+nb>>10;ub=(f[qb+(sb<<2)>>2]|0)+ob>>10;sb=rb<<1;d[lb+(sb<<1)>>1]=(tb+32768|0)>>>0<65536?tb:(tb|0)>0?32767:32768;d[lb+((sb|1)<<1)>>1]=(ub+32768|0)>>>0<65536?ub:(ub|0)>0?32767:32768;rb=rb+1|0}while((rb|0)<($a|0))}}else{rb=g+(kb<<1)|0;if(ib){qb=f[Sa>>2]|0;pb=f[Ta>>2]|0;ub=0;do{sb=ub+Za|0;tb=(f[qb+(sb<<2)>>2]|0)+nb|0;vb=(f[pb+(sb<<2)>>2]|0)+ob|0;sb=tb>>10;wb=ub<<1;d[lb+(wb<<1)>>1]=(sb+32768|0)>>>0<65536?sb:(sb|0)>0?32767:32768;sb=vb>>10;d[lb+((wb|1)<<1)>>1]=(sb+32768|0)>>>0<65536?sb:(sb|0)>0?32767:32768;d[rb+(ub<<1)>>1]=vb&992|tb>>>5&31;ub=ub+1|0}while((ub|0)<($a|0))}}jb=jb+1|0}while((jb|0)<(ab|0));xb=cb}else xb=f[q>>2]|0;if(!xb){f[S>>2]=0;f[T>>2]=0;f[k>>2]=16842752;f[U>>2]=R;cb=V;f[cb>>2]=0;f[cb+4>>2]=0;f[l>>2]=33619968;f[W>>2]=j;f[X>>2]=0;f[Z>>2]=0;f[m>>2]=16842752;f[_>>2]=h;f[o>>2]=1124007936;_a=$;bb=_a+36|0;do{f[_a>>2]=0;_a=_a+4|0}while((_a|0)<(bb|0));f[ba>>2]=aa;f[da>>2]=ca;f[ca>>2]=0;f[ea>>2]=0;f[fa>>2]=0;f[ga>>2]=0;f[n>>2]=16842752;f[ha>>2]=o;mga(k,l,m,n,0,f[ia>>2]|0,ja);_a=f[ka>>2]|0;if(_a|0?(bb=_a+12|0,_a=f[bb>>2]|0,f[bb>>2]=_a+-1,(_a|0)==1):0)CR(o);f[ka>>2]=0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[$>>2]|0)>0){_a=f[ba>>2]|0;bb=0;do{f[_a+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[$>>2]|0))}bb=f[da>>2]|0;if((bb|0)!=(ca|0))ZF(bb)}else{f[va>>2]=2;f[wa>>2]=ab;f[xa>>2]=$a;f[ya>>2]=g;f[za>>2]=g;bb=Va;f[bb>>2]=0;f[bb+4>>2]=0;f[Ca>>2]=wa;f[Ea>>2]=Da;bb=$a<<1;f[k>>2]=1124024322;f[Da>>2]=bb;f[Wa>>2]=2;_a=g+(Y(ab,bb)|0)|0;f[Ba>>2]=_a;f[Aa>>2]=_a+(0-bb)+bb;f[Fa>>2]=0;f[Ga>>2]=0;f[l>>2]=16842752;f[Ha>>2]=R;bb=Ia;f[bb>>2]=0;f[bb+4>>2]=0;f[m>>2]=33619968;f[Ja>>2]=j;f[Ka>>2]=0;f[La>>2]=0;f[n>>2]=16842752;f[Ma>>2]=h;f[Na>>2]=0;f[Oa>>2]=0;f[o>>2]=16842752;f[Pa>>2]=k;mga(l,m,n,o,xb,f[ia>>2]|0,ja);bb=f[Qa>>2]|0;if(bb|0?(_a=bb+12|0,bb=f[_a>>2]|0,f[_a>>2]=bb+-1,(bb|0)==1):0)CR(k);f[Qa>>2]=0;f[ya>>2]=0;f[ya+4>>2]=0;f[ya+8>>2]=0;f[ya+12>>2]=0;if((f[va>>2]|0)>0){bb=f[Ca>>2]|0;_a=0;do{f[bb+(_a<<2)>>2]=0;_a=_a+1|0}while((_a|0)<(f[va>>2]|0))}_a=f[Ea>>2]|0;if((_a|0)!=(Da|0))ZF(_a)}_a=f[ma>>2]|0;if(_a|0?(bb=_a+12|0,_a=f[bb>>2]|0,f[bb>>2]=_a+-1,(_a|0)==1):0)CR(j);f[ma>>2]=0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;if((f[oa>>2]|0)>0){_a=f[pa>>2]|0;bb=0;do{f[_a+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[oa>>2]|0))}bb=f[qa>>2]|0;if((bb|0)!=(ra|0))ZF(bb);bb=f[sa>>2]|0;if(bb|0?(_a=bb+12|0,bb=f[_a>>2]|0,f[_a>>2]=bb+-1,(bb|0)==1):0)CR(i);f[sa>>2]=0;f[ta>>2]=0;f[ta+4>>2]=0;f[ta+8>>2]=0;f[ta+12>>2]=0;if((f[I>>2]|0)>0){bb=f[K>>2]|0;_a=0;do{f[bb+(_a<<2)>>2]=0;_a=_a+1|0}while((_a|0)<(f[I>>2]|0))}_a=f[M>>2]|0;if((_a|0)!=(L|0))ZF(_a);_a=f[ua>>2]|0;if(_a|0?(bb=_a+12|0,_a=f[bb>>2]|0,f[bb>>2]=_a+-1,(_a|0)==1):0)CR(h);f[ua>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[b>>2]|0)>0){_a=f[F>>2]|0;bb=0;do{f[_a+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[b>>2]|0))}bb=f[H>>2]|0;if((bb|0)!=(G|0))ZF(bb);Za=Za+y|0;bb=f[w>>2]|0;if((bb|0)<=(Za|0)){yb=bb;break}else v=bb}}else yb=Xa;Ya=Ya+x|0;if((Ya|0)>=(f[t>>2]|0))break;else Xa=yb}u=c;return}function Qga(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0;j=u;u=u+304|0;k=j;l=j+296|0;m=j+240|0;n=j+176|0;o=j+232|0;q=j+120|0;r=j+64|0;s=j+48|0;_$(l,72844);t=g&7;a:do if((WS(a,-1)|0)>=5){switch(g&7){case 2:case 4:break;default:break a}f[k>>2]=0;f[k+4>>2]=0;v=c$(k,89)|0;w=315589;x=v+89|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-215,k,315679,314894,2677);d$(k)}while(0);do if((NS(a)|0)==65536){y=f[a+4>>2]|0;f[m>>2]=f[y>>2];z=m+4|0;A=y+4|0;f[z>>2]=f[A>>2];B=m+8|0;f[B>>2]=f[y+8>>2];f[m+12>>2]=f[y+12>>2];f[m+16>>2]=f[y+16>>2];f[m+20>>2]=f[y+20>>2];f[m+24>>2]=f[y+24>>2];f[m+28>>2]=f[y+28>>2];f[m+32>>2]=f[y+32>>2];C=f[y+36>>2]|0;f[m+36>>2]=C;f[m+40>>2]=B;B=m+48|0;D=m+44|0;f[D>>2]=B;f[B>>2]=0;f[m+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[y+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];break}else{f[z>>2]=0;BR(m,y);break}}else OR(m,a,-1);while(0);do if((NS(d)|0)==65536){a=f[d+4>>2]|0;f[n>>2]=f[a>>2];y=n+4|0;z=a+4|0;f[y>>2]=f[z>>2];A=n+8|0;f[A>>2]=f[a+8>>2];f[n+12>>2]=f[a+12>>2];f[n+16>>2]=f[a+16>>2];f[n+20>>2]=f[a+20>>2];f[n+24>>2]=f[a+24>>2];f[n+28>>2]=f[a+28>>2];f[n+32>>2]=f[a+32>>2];B=f[a+36>>2]|0;f[n+36>>2]=B;f[n+40>>2]=A;A=n+48|0;D=n+44|0;f[D>>2]=A;f[A>>2]=0;f[n+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[a+44>>2]|0;A=f[D>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;BR(n,a);break}}else OR(n,d,-1);while(0);d=f[e>>2]|0;a=f[e+4>>2]|0;if(!(Y(a,d)|0)){e=f[m+40>>2]|0;E=f[e>>2]|0;F=f[e+4>>2]|0}else{E=a;F=d}f[o>>2]=F;f[o+4>>2]=E;KS(c,o,f[m>>2]&4095,-1,0,0);do if((NS(c)|0)==65536){o=f[c+4>>2]|0;f[q>>2]=f[o>>2];E=q+4|0;F=o+4|0;f[E>>2]=f[F>>2];d=q+8|0;f[d>>2]=f[o+8>>2];f[q+12>>2]=f[o+12>>2];f[q+16>>2]=f[o+16>>2];f[q+20>>2]=f[o+20>>2];f[q+24>>2]=f[o+24>>2];f[q+28>>2]=f[o+28>>2];f[q+32>>2]=f[o+32>>2];a=f[o+36>>2]|0;f[q+36>>2]=a;f[q+40>>2]=d;d=q+48|0;e=q+44|0;f[e>>2]=d;f[d>>2]=0;f[q+52>>2]=0;if(a|0){d=a+12|0;f[d>>2]=(f[d>>2]|0)+1}if((f[F>>2]|0)<3){F=f[o+44>>2]|0;d=f[e>>2]|0;f[d>>2]=f[F>>2];f[d+4>>2]=f[F+4>>2];break}else{f[E>>2]=0;BR(q,o);break}}else OR(q,c,-1);while(0);c=m+12|0;if(!((f[c>>2]|0)>0?(f[m+8>>2]|0)>0:0)){f[k>>2]=0;f[k+4>>2]=0;v=c$(k,28)|0;w=315690;x=v+28|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-215,k,315679,314894,2691);d$(k)}o=q+16|0;E=m+16|0;if((f[o>>2]|0)==(f[E>>2]|0)){f[r>>2]=1124007936;F=r+4|0;d=r+8|0;e=r+40|0;v=F;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[e>>2]=d;a=r+48|0;y=r+44|0;f[y>>2]=a;f[a>>2]=0;f[r+52>>2]=0;z=k+8|0;f[z>>2]=0;f[z+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=r;eL(m,k);z=r+36|0;A=f[z>>2]|0;if(A|0){D=A+12|0;f[D>>2]=(f[D>>2]|0)+1}D=m+36|0;A=f[D>>2]|0;if(A|0?(B=A+12|0,A=f[B>>2]|0,f[B>>2]=A+-1,(A|0)==1):0)CR(m);f[D>>2]=0;A=m+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[A>>2]|0)>0){B=f[m+40>>2]|0;C=0;do{f[B+(C<<2)>>2]=0;C=C+1|0;G=f[A>>2]|0}while((C|0)<(G|0));f[m>>2]=f[r>>2];if((G|0)<3)H=41;else H=43}else{f[m>>2]=f[r>>2];H=41}if((H|0)==41){G=f[F>>2]|0;if((G|0)<3){f[A>>2]=G;f[m+8>>2]=f[d>>2];f[c>>2]=f[r+12>>2];d=f[y>>2]|0;G=f[m+44>>2]|0;f[G>>2]=f[d>>2];f[G+4>>2]=f[d+4>>2]}else H=43}if((H|0)==43)BR(m,r);H=r+16|0;f[E>>2]=f[H>>2];f[m+20>>2]=f[r+20>>2];f[m+24>>2]=f[r+24>>2];f[m+28>>2]=f[r+28>>2];f[m+32>>2]=f[r+32>>2];d=f[z>>2]|0;f[D>>2]=d;if(d|0?(D=d+12|0,d=f[D>>2]|0,f[D>>2]=d+-1,(d|0)==1):0)CR(r);f[z>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[F>>2]|0)>0){H=f[e>>2]|0;e=0;do{f[H+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[F>>2]|0))}F=f[y>>2]|0;if((F|0)!=(a|0))ZF(F)}v=k;x=v+48|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));F=r+4|0;f[F>>2]=2;a=r+8|0;f[a>>2]=2;f[r+12>>2]=3;y=r+16|0;f[y>>2]=k;f[r+20>>2]=k;e=r+24|0;H=r+40|0;z=e+8|0;f[z>>2]=0;f[z+4>>2]=0;f[H>>2]=a;a=r+48|0;z=r+44|0;f[z>>2]=a;f[r>>2]=1124024326;f[a>>2]=24;f[r+52>>2]=8;f[r+28>>2]=k+48;f[e>>2]=k+48;e=(t|0)==3?1:t;if((((f[n>>2]&4095)+-5|0)>>>0<2?(f[n+8>>2]|0)==2:0)?(f[n+12>>2]|0)==3:0)I=1124024326;else{f[s>>2]=0;f[s+4>>2]=0;v=c$(s,66)|0;w=315719;x=v+66|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-215,s,315679,314894,2700);d$(s);I=f[r>>2]|0}w=s+8|0;f[w>>2]=0;f[w+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=r;WJ(n,s,I&4095,1.0,0.0);if(!(g&16)){J=+p[k>>3];g=k+32|0;K=+p[g>>3];I=k+8|0;L=+p[I>>3];s=k+24|0;M=+p[s>>3];N=J*K-L*M;O=N!=0.0?1.0/N:0.0;N=K*O;K=J*O;p[k>>3]=N;J=-O;O=L*J;p[I>>3]=O;L=M*J;p[s>>3]=L;p[g>>3]=K;g=k+16|0;J=+p[g>>3];s=k+40|0;M=+p[s>>3];p[g>>3]=-(N*J)-O*M;p[s>>3]=-(J*L)-K*M}s=m+48|0;g=q+48|0;Lga(f[m>>2]&4095,f[E>>2]|0,f[s>>2]|0,f[c>>2]|0,f[m+8>>2]|0,f[o>>2]|0,f[g>>2]|0,f[q+12>>2]|0,f[q+8>>2]|0,k,e,h,i);i=r+36|0;h=f[i>>2]|0;if(h|0?(e=h+12|0,h=f[e>>2]|0,f[e>>2]=h+-1,(h|0)==1):0)CR(r);f[i>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[F>>2]|0)>0){y=f[H>>2]|0;H=0;do{f[y+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[F>>2]|0))}F=f[z>>2]|0;if((F|0)!=(a|0))ZF(F);F=q+36|0;a=f[F>>2]|0;if(a|0?(z=a+12|0,a=f[z>>2]|0,f[z>>2]=a+-1,(a|0)==1):0)CR(q);f[F>>2]=0;F=q+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[F>>2]|0)>0){o=f[q+40>>2]|0;a=0;do{f[o+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[F>>2]|0))}F=f[q+44>>2]|0;if((F|0)!=(g|0))ZF(F);F=n+36|0;g=f[F>>2]|0;if(g|0?(q=g+12|0,g=f[q>>2]|0,f[q>>2]=g+-1,(g|0)==1):0)CR(n);f[F>>2]=0;F=n+16|0;g=n+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[g>>2]|0)>0){F=f[n+40>>2]|0;q=0;do{f[F+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[g>>2]|0))}g=f[n+44>>2]|0;if((g|0)!=(n+48|0))ZF(g);g=m+36|0;n=f[g>>2]|0;do if(n|0){q=n+12|0;F=f[q>>2]|0;f[q>>2]=F+-1;if((F|0)!=1)break;CR(m)}while(0);f[g>>2]=0;g=m+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[g>>2]|0)>0){E=f[m+40>>2]|0;n=0;do{f[E+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[g>>2]|0))}g=f[m+44>>2]|0;if((g|0)!=(s|0))ZF(g);if(!(f[l+4>>2]|0)){u=j;return}u=j;return}function Rga(a,b,c,d,e,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0;o=u;u=u+336|0;q=o+272|0;r=o+208|0;s=o+216|0;t=o+192|0;v=o+200|0;w=o+32|0;x=o;f[r>>2]=d;f[r+4>>2]=e;CN(q,r,a,b,c);f[t>>2]=i;f[t+4>>2]=j;CN(s,t,a,g,h);h=s+8|0;g=f[h>>2]|0;f[v>>2]=0;f[v+4>>2]=g;y=+p[n+8>>3];z=+p[n+16>>3];A=+p[n+24>>3];p[x>>3]=+p[n>>3];p[x+8>>3]=y;p[x+16>>3]=z;p[x+24>>3]=A;Sga(w,q,s,k,l,m,x);x=s+4|0;m=f[x>>2]|0;if((m|0)<3)B=Y(f[s+12>>2]|0,f[h>>2]|0)|0;else{h=f[s+40>>2]|0;l=0;k=1;while(1){n=Y(f[h+(l<<2)>>2]|0,k)|0;l=l+1|0;if((l|0)==(m|0)){B=n;break}else k=n}}_U(v,w,+(B>>>0)*.0000152587890625);Tga(w);w=s+36|0;B=f[w>>2]|0;if(B|0?(v=B+12|0,B=f[v>>2]|0,f[v>>2]=B+-1,(B|0)==1):0)CR(s);f[w>>2]=0;w=s+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[x>>2]|0)>0){w=f[s+40>>2]|0;B=0;do{f[w+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[x>>2]|0))}x=f[s+44>>2]|0;if((x|0)!=(s+48|0))ZF(x);x=q+36|0;s=f[x>>2]|0;if(s|0?(B=s+12|0,s=f[B>>2]|0,f[B>>2]=s+-1,(s|0)==1):0)CR(q);f[x>>2]=0;x=q+16|0;s=q+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[s>>2]|0)>0){x=f[q+40>>2]|0;B=0;do{f[x+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[s>>2]|0))}s=f[q+44>>2]|0;if((s|0)==(q+48|0)){u=o;return}ZF(s);u=o;return}function Sga(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0,u=0,v=0.0,w=0,x=0,y=0.0,z=0,A=0,B=0.0,C=0;f[a>>2]=72872;i=a+4|0;f[i>>2]=f[b>>2];j=a+8|0;k=b+4|0;f[j>>2]=f[k>>2];l=a+12|0;f[l>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];m=f[b+36>>2]|0;f[a+40>>2]=m;f[a+44>>2]=l;l=a+52|0;n=a+48|0;f[n>>2]=l;f[l>>2]=0;f[a+56>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[b+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;BR(i,b)}b=a+60|0;f[b>>2]=f[c>>2];i=a+64|0;j=c+4|0;f[i>>2]=f[j>>2];k=a+68|0;f[k>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];l=f[c+36>>2]|0;f[a+96>>2]=l;f[a+100>>2]=k;k=a+108|0;n=a+104|0;f[n>>2]=k;f[k>>2]=0;f[a+112>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[c+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=a+116|0;f[o>>2]=d;q=a+120|0;f[q>>2]=e;r=a+124|0;f[r>>2]=g;s=+p[h>>3];t=a+128|0;p[t>>3]=s;u=h+8|0;v=+p[u>>3];w=a+136|0;p[w>>3]=v;x=h+16|0;y=+p[x>>3];z=a+144|0;p[z>>3]=y;A=h+24|0;B=+p[A>>3];C=a+152|0;p[C>>3]=B;return}else{f[i>>2]=0;BR(b,c);o=a+116|0;f[o>>2]=d;q=a+120|0;f[q>>2]=e;r=a+124|0;f[r>>2]=g;s=+p[h>>3];t=a+128|0;p[t>>3]=s;u=h+8|0;v=+p[u>>3];w=a+136|0;p[w>>3]=v;x=h+16|0;y=+p[x>>3];z=a+144|0;p[z>>3]=y;A=h+24|0;B=+p[A>>3];C=a+152|0;p[C>>3]=B;return}}function Tga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=72872;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function Uga(a){a=a|0;Tga(a);PYa(a);return}function Vga(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0,pb=0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0,vb=0.0,wb=0.0,xb=0.0,yb=0,zb=0,Ab=0,Bb=0,Cb=0;c=u;u=u+6480|0;e=c+2376|0;g=c+328|0;h=c+272|0;i=c+216|0;j=c+160|0;k=c+104|0;l=c+88|0;m=c+72|0;n=c+56|0;o=c;q=a+60|0;r=f[a+72>>2]|0;s=f[a+68>>2]|0;t=1024/(((s|0)<16?s:16)|0)|0;v=(r|0)<(t|0)?r:t;t=1024/(v|0)|0;w=(s|0)<(t|0)?s:t;t=f[b>>2]|0;s=b+4|0;if((t|0)>=(f[s>>2]|0)){u=c;return}b=(r|0)>0;x=h+4|0;y=h+8|0;z=h+12|0;A=h+16|0;B=h+20|0;C=h+24|0;D=h+28|0;E=h+40|0;F=h+48|0;G=h+44|0;H=i+4|0;I=i+8|0;J=i+40|0;K=i+48|0;L=i+44|0;M=i+52|0;N=k+4|0;O=k+8|0;P=k+12|0;Q=a+120|0;R=a+4|0;S=k+8|0;T=k+12|0;U=k+4|0;V=l+8|0;W=l+4|0;X=m+8|0;Z=m+12|0;_=m+4|0;$=o+4|0;aa=o+8|0;ba=o+40|0;ca=o+48|0;da=o+44|0;ea=o+52|0;fa=n+8|0;ga=n+12|0;ha=n+4|0;ia=a+124|0;ja=a+128|0;ka=o+36|0;la=o+16|0;ma=j+36|0;na=j+16|0;oa=j+4|0;pa=j+40|0;qa=j+44|0;ra=j+48|0;sa=i+36|0;ta=i+16|0;ua=h+36|0;va=k+4|0;wa=k+8|0;xa=k+12|0;ya=k+16|0;za=k+20|0;Aa=k+24|0;Ba=k+28|0;Ca=k+40|0;Da=k+48|0;Ea=k+44|0;Fa=l+8|0;Ga=l+12|0;Ha=l+4|0;Ia=m+8|0;Ja=m+4|0;Ka=n+8|0;La=n+12|0;Ma=n+4|0;Na=o+8|0;Oa=o+12|0;Pa=o+4|0;Qa=k+36|0;Ra=a+116|0;a=C+8|0;Sa=h+52|0;Ta=Aa+8|0;Ua=k+52|0;Va=t;do{if(b){t=0;do{Wa=r-t|0;Xa=(Wa|0)<(v|0)?Wa:v;Wa=(f[s>>2]|0)-Va|0;Ya=(Wa|0)<(w|0)?Wa:w;f[x>>2]=2;f[y>>2]=Ya;f[z>>2]=Xa;f[A>>2]=e;f[B>>2]=e;Wa=a;f[Wa>>2]=0;f[Wa+4>>2]=0;f[E>>2]=y;f[G>>2]=F;Wa=Xa<<2;f[h>>2]=1124024331;f[F>>2]=Wa;f[Sa>>2]=4;Za=e+(Y(Ya,Wa)|0)|0;f[D>>2]=Za;f[C>>2]=Za+(0-Wa)+Wa;f[i>>2]=1124007936;Wa=H;Za=Wa+36|0;do{f[Wa>>2]=0;Wa=Wa+4|0}while((Wa|0)<(Za|0));f[J>>2]=I;f[L>>2]=K;f[K>>2]=0;f[M>>2]=0;f[k>>2]=t;f[N>>2]=Va;f[O>>2]=Xa;f[P>>2]=Ya;FR(j,q,k);_a=f[Q>>2]|0;$a=(_a|0)==0;if((Ya|0)>0){ab=f[Ra>>2]|0;bb=+p[ab>>3];cb=+(t|0);db=cb*bb;eb=+p[ab+8>>3];fb=+p[ab+16>>3];gb=+p[ab+24>>3];hb=cb*gb;ib=+p[ab+32>>3];jb=+p[ab+40>>3];kb=+p[ab+48>>3];lb=cb*kb;cb=+p[ab+56>>3];mb=+p[ab+64>>3];ab=(Xa|0)>0;nb=0;do{ob=Y(nb,Xa)|0;pb=e+(ob<<1<<1)|0;qb=+(nb+Va|0);rb=fb+(db+qb*eb);sb=jb+(hb+qb*ib);tb=mb+(lb+qb*cb);if($a){if(ab){ub=0;do{qb=+(ub|0);vb=tb+qb*kb;wb=vb!=0.0?1.0/vb:0.0;vb=wb*(rb+qb*bb);xb=vb<2147483647.0?vb:2147483647.0;vb=wb*(sb+qb*gb);qb=vb<2147483647.0?vb:2147483647.0;yb=rNa(xb>-2147483648.0?xb:-2147483648.0)|0;zb=rNa(qb>-2147483648.0?qb:-2147483648.0)|0;Ab=ub<<1;d[pb+(Ab<<1)>>1]=(yb+32768|0)>>>0<65536?yb:(yb|0)>0?32767:32768;d[pb+((Ab|1)<<1)>>1]=(zb+32768|0)>>>0<65536?zb:(zb|0)>0?32767:32768;ub=ub+1|0}while((ub|0)<(Xa|0))}}else{ub=g+(ob<<1)|0;if(ab){zb=0;do{qb=+(zb|0);xb=tb+qb*kb;vb=xb!=0.0?32.0/xb:0.0;xb=vb*(rb+qb*bb);wb=xb<2147483647.0?xb:2147483647.0;xb=vb*(sb+qb*gb);qb=xb<2147483647.0?xb:2147483647.0;Ab=rNa(wb>-2147483648.0?wb:-2147483648.0)|0;yb=rNa(qb>-2147483648.0?qb:-2147483648.0)|0;Bb=Ab>>5;Cb=zb<<1;d[pb+(Cb<<1)>>1]=(Bb+32768|0)>>>0<65536?Bb:(Bb|0)>0?32767:32768;Bb=yb>>5;d[pb+((Cb|1)<<1)>>1]=(Bb+32768|0)>>>0<65536?Bb:(Bb|0)>0?32767:32768;d[ub+(zb<<1)>>1]=yb<<5&992|Ab&31;zb=zb+1|0}while((zb|0)<(Xa|0))}}nb=nb+1|0}while((nb|0)<(Ya|0))}if($a){f[S>>2]=0;f[T>>2]=0;f[k>>2]=16842752;f[U>>2]=R;nb=V;f[nb>>2]=0;f[nb+4>>2]=0;f[l>>2]=33619968;f[W>>2]=j;f[X>>2]=0;f[Z>>2]=0;f[m>>2]=16842752;f[_>>2]=h;f[o>>2]=1124007936;Wa=$;Za=Wa+36|0;do{f[Wa>>2]=0;Wa=Wa+4|0}while((Wa|0)<(Za|0));f[ba>>2]=aa;f[da>>2]=ca;f[ca>>2]=0;f[ea>>2]=0;f[fa>>2]=0;f[ga>>2]=0;f[n>>2]=16842752;f[ha>>2]=o;mga(k,l,m,n,0,f[ia>>2]|0,ja);Wa=f[ka>>2]|0;if(Wa|0?(Za=Wa+12|0,Wa=f[Za>>2]|0,f[Za>>2]=Wa+-1,(Wa|0)==1):0)CR(o);f[ka>>2]=0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[$>>2]|0)>0){Wa=f[ba>>2]|0;Za=0;do{f[Wa+(Za<<2)>>2]=0;Za=Za+1|0}while((Za|0)<(f[$>>2]|0))}Za=f[da>>2]|0;if((Za|0)!=(ca|0))ZF(Za)}else{f[va>>2]=2;f[wa>>2]=Ya;f[xa>>2]=Xa;f[ya>>2]=g;f[za>>2]=g;Za=Ta;f[Za>>2]=0;f[Za+4>>2]=0;f[Ca>>2]=wa;f[Ea>>2]=Da;Za=Xa<<1;f[k>>2]=1124024322;f[Da>>2]=Za;f[Ua>>2]=2;Wa=g+(Y(Ya,Za)|0)|0;f[Ba>>2]=Wa;f[Aa>>2]=Wa+(0-Za)+Za;f[Fa>>2]=0;f[Ga>>2]=0;f[l>>2]=16842752;f[Ha>>2]=R;Za=Ia;f[Za>>2]=0;f[Za+4>>2]=0;f[m>>2]=33619968;f[Ja>>2]=j;f[Ka>>2]=0;f[La>>2]=0;f[n>>2]=16842752;f[Ma>>2]=h;f[Na>>2]=0;f[Oa>>2]=0;f[o>>2]=16842752;f[Pa>>2]=k;mga(l,m,n,o,_a,f[ia>>2]|0,ja);Za=f[Qa>>2]|0;if(Za|0?(Wa=Za+12|0,Za=f[Wa>>2]|0,f[Wa>>2]=Za+-1,(Za|0)==1):0)CR(k);f[Qa>>2]=0;f[ya>>2]=0;f[ya+4>>2]=0;f[ya+8>>2]=0;f[ya+12>>2]=0;if((f[va>>2]|0)>0){Za=f[Ca>>2]|0;Wa=0;do{f[Za+(Wa<<2)>>2]=0;Wa=Wa+1|0}while((Wa|0)<(f[va>>2]|0))}Wa=f[Ea>>2]|0;if((Wa|0)!=(Da|0))ZF(Wa)}Wa=f[ma>>2]|0;if(Wa|0?(Za=Wa+12|0,Wa=f[Za>>2]|0,f[Za>>2]=Wa+-1,(Wa|0)==1):0)CR(j);f[ma>>2]=0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;if((f[oa>>2]|0)>0){Wa=f[pa>>2]|0;Za=0;do{f[Wa+(Za<<2)>>2]=0;Za=Za+1|0}while((Za|0)<(f[oa>>2]|0))}Za=f[qa>>2]|0;if((Za|0)!=(ra|0))ZF(Za);Za=f[sa>>2]|0;if(Za|0?(Wa=Za+12|0,Za=f[Wa>>2]|0,f[Wa>>2]=Za+-1,(Za|0)==1):0)CR(i);f[sa>>2]=0;f[ta>>2]=0;f[ta+4>>2]=0;f[ta+8>>2]=0;f[ta+12>>2]=0;if((f[H>>2]|0)>0){Za=f[J>>2]|0;Wa=0;do{f[Za+(Wa<<2)>>2]=0;Wa=Wa+1|0}while((Wa|0)<(f[H>>2]|0))}Wa=f[L>>2]|0;if((Wa|0)!=(K|0))ZF(Wa);Wa=f[ua>>2]|0;if(Wa|0?(Za=Wa+12|0,Wa=f[Za>>2]|0,f[Za>>2]=Wa+-1,(Wa|0)==1):0)CR(h);f[ua>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[x>>2]|0)>0){Wa=f[E>>2]|0;Za=0;do{f[Wa+(Za<<2)>>2]=0;Za=Za+1|0}while((Za|0)<(f[x>>2]|0))}Za=f[G>>2]|0;if((Za|0)!=(F|0))ZF(Za);t=t+v|0}while((r|0)>(t|0))}Va=Va+w|0}while((Va|0)<(f[s>>2]|0));u=c;return}function Wga(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;j=u;u=u+352|0;k=j;l=j+336|0;m=j+280|0;n=j+216|0;o=j+272|0;p=j+160|0;q=j+104|0;r=j+88|0;s=j+72|0;_$(l,72884);if(!(US(a,-1)|0)){f[k>>2]=0;f[k+4>>2]=0;t=c$(k,16)|0;v=315905;w=t+16|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));j$(-215,k,315922,314894,2978);d$(k)}do if((NS(a)|0)==65536){x=f[a+4>>2]|0;f[m>>2]=f[x>>2];y=m+4|0;z=x+4|0;f[y>>2]=f[z>>2];A=m+8|0;f[A>>2]=f[x+8>>2];f[m+12>>2]=f[x+12>>2];f[m+16>>2]=f[x+16>>2];f[m+20>>2]=f[x+20>>2];f[m+24>>2]=f[x+24>>2];f[m+28>>2]=f[x+28>>2];f[m+32>>2]=f[x+32>>2];B=f[x+36>>2]|0;f[m+36>>2]=B;f[m+40>>2]=A;A=m+48|0;C=m+44|0;f[C>>2]=A;f[A>>2]=0;f[m+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[x+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;BR(m,x);break}}else OR(m,a,-1);while(0);do if((NS(d)|0)==65536){a=f[d+4>>2]|0;f[n>>2]=f[a>>2];x=n+4|0;y=a+4|0;f[x>>2]=f[y>>2];z=n+8|0;f[z>>2]=f[a+8>>2];f[n+12>>2]=f[a+12>>2];f[n+16>>2]=f[a+16>>2];f[n+20>>2]=f[a+20>>2];f[n+24>>2]=f[a+24>>2];f[n+28>>2]=f[a+28>>2];f[n+32>>2]=f[a+32>>2];A=f[a+36>>2]|0;f[n+36>>2]=A;f[n+40>>2]=z;z=n+48|0;C=n+44|0;f[C>>2]=z;f[z>>2]=0;f[n+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[a+44>>2]|0;z=f[C>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;BR(n,a);break}}else OR(n,d,-1);while(0);d=f[e>>2]|0;a=f[e+4>>2]|0;if(!(Y(a,d)|0)){e=f[m+40>>2]|0;D=f[e>>2]|0;E=f[e+4>>2]|0}else{D=a;E=d}f[o>>2]=E;f[o+4>>2]=D;KS(c,o,f[m>>2]&4095,-1,0,0);do if((NS(c)|0)==65536){o=f[c+4>>2]|0;f[p>>2]=f[o>>2];D=p+4|0;E=o+4|0;f[D>>2]=f[E>>2];d=p+8|0;f[d>>2]=f[o+8>>2];f[p+12>>2]=f[o+12>>2];a=p+16|0;f[a>>2]=f[o+16>>2];f[p+20>>2]=f[o+20>>2];f[p+24>>2]=f[o+24>>2];f[p+28>>2]=f[o+28>>2];f[p+32>>2]=f[o+32>>2];e=f[o+36>>2]|0;f[p+36>>2]=e;f[p+40>>2]=d;d=p+48|0;x=p+44|0;f[x>>2]=d;f[d>>2]=0;f[p+52>>2]=0;if(e|0){d=e+12|0;f[d>>2]=(f[d>>2]|0)+1}if((f[E>>2]|0)<3){E=f[o+44>>2]|0;d=f[x>>2]|0;f[d>>2]=f[E>>2];f[d+4>>2]=f[E+4>>2];F=a;break}else{f[D>>2]=0;BR(p,o);F=a;break}}else{OR(p,c,-1);F=p+16|0}while(0);c=m+16|0;if((f[F>>2]|0)==(f[c>>2]|0)){f[q>>2]=1124007936;a=q+4|0;o=q+8|0;D=q+40|0;t=a;w=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));f[D>>2]=o;E=q+48|0;d=q+44|0;f[d>>2]=E;f[E>>2]=0;f[q+52>>2]=0;x=k+8|0;f[x>>2]=0;f[x+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=q;eL(m,k);x=q+36|0;e=f[x>>2]|0;if(e|0){y=e+12|0;f[y>>2]=(f[y>>2]|0)+1}y=m+36|0;e=f[y>>2]|0;if(e|0?(z=e+12|0,e=f[z>>2]|0,f[z>>2]=e+-1,(e|0)==1):0)CR(m);f[y>>2]=0;e=m+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[e>>2]|0)>0){z=f[m+40>>2]|0;C=0;do{f[z+(C<<2)>>2]=0;C=C+1|0;G=f[e>>2]|0}while((C|0)<(G|0));f[m>>2]=f[q>>2];if((G|0)<3)H=37;else H=39}else{f[m>>2]=f[q>>2];H=37}if((H|0)==37){G=f[a>>2]|0;if((G|0)<3){f[e>>2]=G;f[m+8>>2]=f[o>>2];f[m+12>>2]=f[q+12>>2];o=f[d>>2]|0;G=f[m+44>>2]|0;f[G>>2]=f[o>>2];f[G+4>>2]=f[o+4>>2]}else H=39}if((H|0)==39)BR(m,q);H=q+16|0;f[c>>2]=f[H>>2];f[m+20>>2]=f[q+20>>2];f[m+24>>2]=f[q+24>>2];f[m+28>>2]=f[q+28>>2];f[m+32>>2]=f[q+32>>2];o=f[x>>2]|0;f[y>>2]=o;if(o|0?(y=o+12|0,o=f[y>>2]|0,f[y>>2]=o+-1,(o|0)==1):0)CR(q);f[x>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[a>>2]|0)>0){H=f[D>>2]|0;D=0;do{f[H+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[a>>2]|0))}a=f[d>>2]|0;if((a|0)!=(E|0))ZF(a)}a=q+4|0;f[a>>2]=2;E=q+8|0;f[E>>2]=3;f[q+12>>2]=3;d=q+16|0;f[d>>2]=k;f[q+20>>2]=k;D=q+24|0;H=q+40|0;x=D+8|0;f[x>>2]=0;f[x+4>>2]=0;f[H>>2]=E;E=q+48|0;x=q+44|0;f[x>>2]=E;f[q>>2]=1124024326;f[E>>2]=24;f[q+52>>2]=8;f[q+28>>2]=k+72;f[D>>2]=k+72;k=g&7;D=(k|0)==3?1:k;if((((f[n>>2]&4095)+-5|0)>>>0<2?(f[n+8>>2]|0)==3:0)?(f[n+12>>2]|0)==3:0)I=1124024326;else{f[r>>2]=0;f[r+4>>2]=0;t=c$(r,66)|0;v=315938;w=t+66|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));j$(-215,r,315922,314894,3002);d$(r);I=f[q>>2]|0}v=r+8|0;f[v>>2]=0;f[v+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=q;WJ(n,r,I&4095,1.0,0.0);if(!(g&16)){f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=q;g=s+8|0;f[g>>2]=0;f[g+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=q;+_M(r,s,0)}s=m+48|0;r=p+48|0;Rga(f[m>>2]&4095,f[c>>2]|0,f[s>>2]|0,f[m+12>>2]|0,f[m+8>>2]|0,f[F>>2]|0,f[r>>2]|0,f[p+12>>2]|0,f[p+8>>2]|0,f[d>>2]|0,D,h,i);i=q+36|0;h=f[i>>2]|0;if(h|0?(D=h+12|0,h=f[D>>2]|0,f[D>>2]=h+-1,(h|0)==1):0)CR(q);f[i>>2]=0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[a>>2]|0)>0){d=f[H>>2]|0;H=0;do{f[d+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[a>>2]|0))}a=f[x>>2]|0;if((a|0)!=(E|0))ZF(a);a=p+36|0;E=f[a>>2]|0;if(E|0?(x=E+12|0,E=f[x>>2]|0,f[x>>2]=E+-1,(E|0)==1):0)CR(p);f[a>>2]=0;a=p+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[a>>2]|0)>0){F=f[p+40>>2]|0;E=0;do{f[F+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[a>>2]|0))}a=f[p+44>>2]|0;if((a|0)!=(r|0))ZF(a);a=n+36|0;r=f[a>>2]|0;if(r|0?(p=r+12|0,r=f[p>>2]|0,f[p>>2]=r+-1,(r|0)==1):0)CR(n);f[a>>2]=0;a=n+16|0;r=n+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[r>>2]|0)>0){a=f[n+40>>2]|0;p=0;do{f[a+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[r>>2]|0))}r=f[n+44>>2]|0;if((r|0)!=(n+48|0))ZF(r);r=m+36|0;n=f[r>>2]|0;if(n|0?(p=n+12|0,n=f[p>>2]|0,f[p>>2]=n+-1,(n|0)==1):0)CR(m);f[r>>2]=0;r=m+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[r>>2]|0)>0){c=f[m+40>>2]|0;n=0;do{f[c+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[r>>2]|0))}r=f[m+44>>2]|0;if((r|0)!=(s|0))ZF(r);if(!(f[l+4>>2]|0)){u=j;return}u=j;return}function Xga(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0,h=0,i=0.0,j=0.0,k=0,l=0,m=0,o=0,q=0.0;e=u;u=u+16|0;g=e+8|0;h=e;_$(h,72904);i=c*.017453292519943295;c=+O(+i)*d;j=+P(+i)*d;f[a>>2]=1124007936;k=a+8|0;l=a+40|0;m=a+4|0;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[l>>2]=k;k=a+48|0;f[a+44>>2]=k;f[k>>2]=0;f[a+52>>2]=0;f[g>>2]=2;f[g+4>>2]=3;AR(a,2,g,6);g=f[a+16>>2]|0;p[g>>3]=c;p[g+8>>3]=j;d=1.0-c;i=+n[b>>2];q=+n[b+4>>2];p[g+16>>3]=d*i-j*q;p[g+24>>3]=-j;p[g+32>>3]=c;p[g+40>>3]=j*i+d*q;if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function Yga(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0;e=u;u=u+800|0;g=e+64|0;h=e+792|0;i=e+736|0;j=e;k=e+680|0;l=e+624|0;m=e+608|0;o=e+592|0;q=e+576|0;_$(h,72924);f[a>>2]=1124007936;r=a+8|0;s=a+40|0;t=a+4|0;v=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));f[s>>2]=r;r=a+48|0;f[a+44>>2]=r;f[r>>2]=0;f[a+52>>2]=0;f[g>>2]=3;f[g+4>>2]=3;AR(a,2,g,6);r=a+16|0;a=f[r>>2]|0;f[i>>2]=1124007942;s=i+4|0;f[s>>2]=2;w=i+8|0;f[w>>2]=8;x=i+12|0;f[x>>2]=1;y=i+16|0;f[y>>2]=a;z=i+20|0;f[z>>2]=a;A=i+24|0;B=i+28|0;C=i+40|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;f[C>>2]=w;D=i+48|0;E=i+44|0;f[E>>2]=D;f[i+52>>2]=0;f[D>>2]=0;if(!a){f[g>>2]=0;f[g+4>>2]=0;t=c$(g,26)|0;F=358223;v=t+26|0;do{b[t>>0]=b[F>>0]|0;t=t+1|0;F=F+1|0}while((t|0)<(v|0));j$(-215,g,358250,358254,500);d$(g);G=f[x>>2]|0;H=f[i>>2]|0;I=f[E>>2]|0;J=f[z>>2]|0}else{G=1;H=1124007942;I=D;J=a}a=G<<3;f[i>>2]=H|16384;f[I>>2]=a;f[I+4>>2]=8;I=J+(Y(f[w>>2]|0,a)|0)|0;f[B>>2]=I;f[A>>2]=I+(0-a)+a;a=k+4|0;f[a>>2]=2;I=k+8|0;f[I>>2]=8;f[k+12>>2]=8;A=k+16|0;f[A>>2]=g;f[k+20>>2]=g;B=k+24|0;w=k+40|0;J=B+8|0;f[J>>2]=0;f[J+4>>2]=0;f[w>>2]=I;I=k+48|0;J=k+44|0;f[J>>2]=I;f[k>>2]=1124024326;f[I>>2]=64;f[k+52>>2]=8;f[k+28>>2]=g+512;f[B>>2]=g+512;B=l+4|0;f[B>>2]=2;H=l+8|0;f[H>>2]=8;f[l+12>>2]=1;G=l+16|0;f[G>>2]=j;f[l+20>>2]=j;z=l+24|0;x=l+40|0;F=z+8|0;f[F>>2]=0;f[F+4>>2]=0;f[x>>2]=H;H=l+48|0;F=l+44|0;f[F>>2]=H;f[l>>2]=1124024326;f[H>>2]=8;f[l+52>>2]=8;f[l+28>>2]=j+64;f[z>>2]=j+64;z=0;do{K=+n[c+(z<<3)>>2];L=K;t=z+4|0;p[g+(t<<6)+24>>3]=L;p[g+(z<<6)>>3]=L;L=+n[c+(z<<3)+4>>2];M=L;p[g+(t<<6)+32>>3]=M;p[g+(z<<6)+8>>3]=M;p[g+(t<<6)+40>>3]=1.0;p[g+(z<<6)+16>>3]=1.0;v=g+(t<<6)|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;f[v+16>>2]=0;f[v+20>>2]=0;v=g+(z<<6)+24|0;M=-K;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;f[v+16>>2]=0;f[v+20>>2]=0;K=+n[d+(z<<3)>>2];p[g+(z<<6)+48>>3]=K*M;N=-L;p[g+(z<<6)+56>>3]=K*N;L=+n[d+(z<<3)+4>>2];p[g+(t<<6)+48>>3]=L*M;p[g+(t<<6)+56>>3]=L*N;p[j+(z<<3)>>3]=K;p[j+(t<<3)>>3]=L;z=z+1|0}while((z|0)!=4);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=k;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=l;z=q+8|0;f[z>>2]=0;f[z+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=i;hN(m,o,q,1)|0;p[(f[r>>2]|0)+64>>3]=1.0;r=l+36|0;q=f[r>>2]|0;if(q|0?(o=q+12|0,q=f[o>>2]|0,f[o>>2]=q+-1,(q|0)==1):0)CR(l);f[r>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[B>>2]|0)>0){G=f[x>>2]|0;x=0;do{f[G+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[B>>2]|0))}B=f[F>>2]|0;if((B|0)!=(H|0))ZF(B);B=k+36|0;H=f[B>>2]|0;if(H|0?(F=H+12|0,H=f[F>>2]|0,f[F>>2]=H+-1,(H|0)==1):0)CR(k);f[B>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[a>>2]|0)>0){A=f[w>>2]|0;w=0;do{f[A+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[a>>2]|0))}a=f[J>>2]|0;if((a|0)!=(I|0))ZF(a);a=i+36|0;I=f[a>>2]|0;if(I|0?(J=I+12|0,I=f[J>>2]|0,f[J>>2]=I+-1,(I|0)==1):0)CR(i);f[a>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[s>>2]|0)>0){y=f[C>>2]|0;C=0;do{f[y+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[s>>2]|0))}s=f[E>>2]|0;if((s|0)!=(D|0))ZF(s);if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function Zga(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0;e=u;u=u+560|0;g=e+48|0;h=e+496|0;i=e;j=e+440|0;k=e+384|0;l=e+368|0;m=e+352|0;o=e+336|0;f[a>>2]=1124007936;q=a+8|0;r=a+40|0;s=a+4|0;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[r>>2]=q;q=a+48|0;f[a+44>>2]=q;f[q>>2]=0;f[a+52>>2]=0;f[g>>2]=2;f[g+4>>2]=3;AR(a,2,g,6);q=f[a+16>>2]|0;f[h>>2]=1124007942;a=h+4|0;f[a>>2]=2;r=h+8|0;f[r>>2]=6;v=h+12|0;f[v>>2]=1;w=h+16|0;f[w>>2]=q;x=h+20|0;f[x>>2]=q;y=h+24|0;z=h+28|0;A=h+40|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[A>>2]=r;B=h+48|0;C=h+44|0;f[C>>2]=B;f[h+52>>2]=0;f[B>>2]=0;if(!q){f[g>>2]=0;f[g+4>>2]=0;s=c$(g,26)|0;D=358223;t=s+26|0;do{b[s>>0]=b[D>>0]|0;s=s+1|0;D=D+1|0}while((s|0)<(t|0));j$(-215,g,358250,358254,500);d$(g);E=f[v>>2]|0;F=f[h>>2]|0;G=f[C>>2]|0;H=f[x>>2]|0}else{E=1;F=1124007942;G=B;H=q}q=E<<3;f[h>>2]=F|16384;f[G>>2]=q;f[G+4>>2]=8;G=H+(Y(f[r>>2]|0,q)|0)|0;f[z>>2]=G;f[y>>2]=G+(0-q)+q;q=j+4|0;f[q>>2]=2;G=j+8|0;f[G>>2]=6;f[j+12>>2]=6;y=j+16|0;f[y>>2]=g;f[j+20>>2]=g;z=j+24|0;r=j+40|0;H=z+8|0;f[H>>2]=0;f[H+4>>2]=0;f[r>>2]=G;G=j+48|0;H=j+44|0;f[H>>2]=G;f[j>>2]=1124024326;f[G>>2]=48;f[j+52>>2]=8;f[j+28>>2]=g+288;f[z>>2]=g+288;z=k+4|0;f[z>>2]=2;F=k+8|0;f[F>>2]=6;f[k+12>>2]=1;E=k+16|0;f[E>>2]=i;f[k+20>>2]=i;x=k+24|0;v=k+40|0;D=x+8|0;f[D>>2]=0;f[D+4>>2]=0;f[v>>2]=F;F=k+48|0;D=k+44|0;f[D>>2]=F;f[k>>2]=1124024326;f[F>>2]=8;f[k+52>>2]=8;f[k+28>>2]=i+48;f[x>>2]=i+48;I=+n[c>>2];p[g+72>>3]=I;p[g>>3]=I;I=+n[c+4>>2];p[g+80>>3]=I;p[g+8>>3]=I;p[g+88>>3]=1.0;p[g+16>>3]=1.0;s=g+24|0;t=s+48|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));p[i>>3]=+n[d>>2];p[i+8>>3]=+n[d+4>>2];I=+n[c+8>>2];p[g+168>>3]=I;p[g+96>>3]=I;I=+n[c+12>>2];p[g+176>>3]=I;p[g+104>>3]=I;p[g+184>>3]=1.0;p[g+112>>3]=1.0;x=d+8|0;s=g+120|0;t=s+48|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));p[i+16>>3]=+n[x>>2];p[i+24>>3]=+n[d+12>>2];I=+n[c+16>>2];p[g+264>>3]=I;p[g+192>>3]=I;I=+n[c+20>>2];p[g+272>>3]=I;p[g+200>>3]=I;p[g+280>>3]=1.0;p[g+208>>3]=1.0;c=d+16|0;s=g+216|0;t=s+48|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));p[i+32>>3]=+n[c>>2];p[i+40>>3]=+n[d+20>>2];f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=j;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=k;d=o+8|0;f[d>>2]=0;f[d+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=h;hN(l,m,o,0)|0;o=k+36|0;m=f[o>>2]|0;if(m|0?(l=m+12|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0)CR(k);f[o>>2]=0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[z>>2]|0)>0){E=f[v>>2]|0;v=0;do{f[E+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[z>>2]|0))}z=f[D>>2]|0;if((z|0)!=(F|0))ZF(z);z=j+36|0;F=f[z>>2]|0;if(F|0?(D=F+12|0,F=f[D>>2]|0,f[D>>2]=F+-1,(F|0)==1):0)CR(j);f[z>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[q>>2]|0)>0){y=f[r>>2]|0;r=0;do{f[y+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[q>>2]|0))}q=f[H>>2]|0;if((q|0)!=(G|0))ZF(q);q=h+36|0;G=f[q>>2]|0;if(G|0?(H=G+12|0,G=f[H>>2]|0,f[H>>2]=G+-1,(G|0)==1):0)CR(h);f[q>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[a>>2]|0)>0){w=f[A>>2]|0;A=0;do{f[w+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[a>>2]|0))}a=f[C>>2]|0;if((a|0)==(B|0)){u=e;return}ZF(a);u=e;return}function _ga(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+128|0;g=e+64|0;h=e+8|0;i=e;do if((NS(c)|0)==65536){j=f[c+4>>2]|0;f[g>>2]=f[j>>2];k=g+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=g+8|0;f[m>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];f[g+32>>2]=f[j+32>>2];n=f[j+36>>2]|0;f[g+36>>2]=n;f[g+40>>2]=m;m=g+48|0;o=g+44|0;f[o>>2]=m;f[m>>2]=0;f[g+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;BR(g,j);break}}else OR(g,c,-1);while(0);do if((NS(d)|0)==65536){c=f[d+4>>2]|0;f[h>>2]=f[c>>2];j=h+4|0;k=c+4|0;f[j>>2]=f[k>>2];l=h+8|0;f[l>>2]=f[c+8>>2];f[h+12>>2]=f[c+12>>2];f[h+16>>2]=f[c+16>>2];f[h+20>>2]=f[c+20>>2];f[h+24>>2]=f[c+24>>2];f[h+28>>2]=f[c+28>>2];f[h+32>>2]=f[c+32>>2];m=f[c+36>>2]|0;f[h+36>>2]=m;f[h+40>>2]=l;l=h+48|0;o=h+44|0;f[o>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[c+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];break}else{f[j>>2]=0;BR(h,c);break}}else OR(h,d,-1);while(0);if(!((LS(g,2,5,1)|0)==4?(LS(h,2,5,1)|0)==4:0)){f[i>>2]=0;f[i+4>>2]=0;d=c$(i,56)|0;c=316226;j=d+56|0;do{b[d>>0]=b[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(j|0));j$(-215,i,316283,314894,3232);d$(i)}i=g+16|0;c=h+16|0;Yga(a,f[i>>2]|0,f[c>>2]|0);a=h+36|0;d=f[a>>2]|0;if(d|0?(j=d+12|0,d=f[j>>2]|0,f[j>>2]=d+-1,(d|0)==1):0)CR(h);f[a>>2]=0;a=h+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[h+40>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[a>>2]|0))}a=f[h+44>>2]|0;if((a|0)!=(h+48|0))ZF(a);a=g+36|0;h=f[a>>2]|0;if(h|0?(d=h+12|0,h=f[d>>2]|0,f[d>>2]=h+-1,(h|0)==1):0)CR(g);f[a>>2]=0;a=g+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[a>>2]|0)>0){i=f[g+40>>2]|0;h=0;do{f[i+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[a>>2]|0))}a=f[g+44>>2]|0;if((a|0)==(g+48|0)){u=e;return}ZF(a);u=e;return}function $ga(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+128|0;g=e+64|0;h=e+8|0;i=e;do if((NS(c)|0)==65536){j=f[c+4>>2]|0;f[g>>2]=f[j>>2];k=g+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=g+8|0;f[m>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];f[g+32>>2]=f[j+32>>2];n=f[j+36>>2]|0;f[g+36>>2]=n;f[g+40>>2]=m;m=g+48|0;o=g+44|0;f[o>>2]=m;f[m>>2]=0;f[g+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;BR(g,j);break}}else OR(g,c,-1);while(0);do if((NS(d)|0)==65536){c=f[d+4>>2]|0;f[h>>2]=f[c>>2];j=h+4|0;k=c+4|0;f[j>>2]=f[k>>2];l=h+8|0;f[l>>2]=f[c+8>>2];f[h+12>>2]=f[c+12>>2];f[h+16>>2]=f[c+16>>2];f[h+20>>2]=f[c+20>>2];f[h+24>>2]=f[c+24>>2];f[h+28>>2]=f[c+28>>2];f[h+32>>2]=f[c+32>>2];m=f[c+36>>2]|0;f[h+36>>2]=m;f[h+40>>2]=l;l=h+48|0;o=h+44|0;f[o>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[c+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];break}else{f[j>>2]=0;BR(h,c);break}}else OR(h,d,-1);while(0);if(!((LS(g,2,5,1)|0)==3?(LS(h,2,5,1)|0)==3:0)){f[i>>2]=0;f[i+4>>2]=0;d=c$(i,56)|0;c=316307;j=d+56|0;do{b[d>>0]=b[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(j|0));j$(-215,i,316364,314894,3239);d$(i)}i=g+16|0;c=h+16|0;Zga(a,f[i>>2]|0,f[c>>2]|0);a=h+36|0;d=f[a>>2]|0;if(d|0?(j=d+12|0,d=f[j>>2]|0,f[j>>2]=d+-1,(d|0)==1):0)CR(h);f[a>>2]=0;a=h+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[h+40>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[a>>2]|0))}a=f[h+44>>2]|0;if((a|0)!=(h+48|0))ZF(a);a=g+36|0;h=f[a>>2]|0;if(h|0?(d=h+12|0,h=f[d>>2]|0,f[d>>2]=h+-1,(h|0)==1):0)CR(g);f[a>>2]=0;a=g+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[a>>2]|0)>0){i=f[g+40>>2]|0;h=0;do{f[i+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[a>>2]|0))}a=f[g+44>>2]|0;if((a|0)==(g+48|0)){u=e;return}ZF(a);u=e;return}function aha(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,N=0.0,Q=0.0,S=0.0,T=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0;i=u;u=u+1232|0;j=i+168|0;k=i+144|0;l=i+80|0;m=i+24|0;o=i;p=i+88|0;_$(l,72944);do if((NS(a)|0)==65536){q=f[a+4>>2]|0;f[m>>2]=f[q>>2];r=m+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=m+8|0;f[t>>2]=f[q+8>>2];f[m+12>>2]=f[q+12>>2];f[m+16>>2]=f[q+16>>2];f[m+20>>2]=f[q+20>>2];f[m+24>>2]=f[q+24>>2];f[m+28>>2]=f[q+28>>2];f[m+32>>2]=f[q+32>>2];v=f[q+36>>2]|0;f[m+36>>2]=v;f[m+40>>2]=t;t=m+48|0;w=m+44|0;f[w>>2]=t;f[t>>2]=0;f[m+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[r>>2]=0;BR(m,q);break}}else OR(m,a,-1);while(0);f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;a=LS(m,2,-1,0)|0;q=LS(m,3,-1,0)|0;r=(a|0)>-1;if((q&a|0)<=-1){f[j>>2]=0;f[j+4>>2]=0;x=c$(j,30)|0;y=316383;z=x+30|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));j$(-215,j,316414,316422,605);d$(j)}if((f[m>>2]&16391|0)==16389)A=m+16|0;else{f[j>>2]=1124007936;s=j+4|0;t=j+8|0;w=j+40|0;x=s;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[w>>2]=t;v=j+48|0;B=j+44|0;f[B>>2]=v;f[v>>2]=0;f[j+52>>2]=0;C=k+8|0;f[C>>2]=0;f[C+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=j;WJ(m,k,5,1.0,0.0);C=j+36|0;D=f[C>>2]|0;if(D|0){E=D+12|0;f[E>>2]=(f[E>>2]|0)+1}E=m+36|0;D=f[E>>2]|0;if(D|0?(F=D+12|0,D=f[F>>2]|0,f[F>>2]=D+-1,(D|0)==1):0)CR(m);f[E>>2]=0;D=m+16|0;F=m+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[F>>2]|0)>0){G=f[m+40>>2]|0;H=0;do{f[G+(H<<2)>>2]=0;H=H+1|0;I=f[F>>2]|0}while((H|0)<(I|0));f[m>>2]=f[j>>2];if((I|0)<3)K=22;else K=24}else{f[m>>2]=f[j>>2];K=22}if((K|0)==22){I=f[s>>2]|0;if((I|0)<3){f[F>>2]=I;f[m+8>>2]=f[t>>2];f[m+12>>2]=f[j+12>>2];t=f[B>>2]|0;I=f[m+44>>2]|0;f[I>>2]=f[t>>2];f[I+4>>2]=f[t+4>>2]}else K=24}if((K|0)==24)BR(m,j);t=j+16|0;f[D>>2]=f[t>>2];f[m+20>>2]=f[j+20>>2];f[m+24>>2]=f[j+24>>2];f[m+28>>2]=f[j+28>>2];f[m+32>>2]=f[j+32>>2];I=f[C>>2]|0;f[E>>2]=I;if(I|0?(E=I+12|0,I=f[E>>2]|0,f[E>>2]=I+-1,(I|0)==1):0)CR(j);f[C>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[s>>2]|0)>0){t=f[w>>2]|0;w=0;do{f[t+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[s>>2]|0))}s=f[B>>2]|0;if((s|0)!=(v|0))ZF(s);A=D}D=f[A>>2]|0;if(r){N=e;Q=g;S=h;T=+(a|0);V=T*1.1920928955078125e-07;W=Q!=0.0?Q:1.0;r=S!=0.0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;switch(d|0){case 2:{if((a|0)>0){s=0;Q=0.0;X=0.0;Y=0.0;Z=0.0;_=0.0;while(1){$=+n[D+(s<<3)>>2];aa=Q+$;ba=+n[D+(s<<3)+4>>2];ca=Z+ba;da=X+$*$;ea=_+ba*ba;fa=Y+$*ba;s=s+1|0;if((s|0)==(a|0)){ga=aa;ha=da;ia=fa;ja=ca;ka=ea;break}else{Q=aa;X=da;Y=fa;Z=ca;_=ea}}}else{ga=0.0;ha=0.0;ia=0.0;ja=0.0;ka=0.0}_=T;T=ga/_;ga=ja/_;ja=+U(+((ia/_-ga*T)*2.0),+(ha/_-T*T-(ka/_-ga*ga)))*.5;_=+O(+ja);n[o>>2]=_;_=+P(+ja);n[o+4>>2]=_;n[o+8>>2]=T;n[o+12>>2]=ga;break}case 1:{la=185;ma=0;K=44;break}case 4:{la=186;ma=0;K=44;break}case 5:{la=0;ma=33;K=44;break}case 6:{la=0;ma=34;K=44;break}case 7:{la=0;ma=35;K=44;break}default:{f[j>>2]=0;f[j+4>>2]=0;x=c$(j,21)|0;y=316474;z=x+21|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));j$(-5,j,316496,316422,359);d$(j);la=0;ma=0;K=44}}if((K|0)==44){s=a<<1;v=j+8|0;f[j>>2]=v;B=j+4|0;f[B>>2]=s;if(s>>>0>264){w=OYa(s>>>0>1073741823?-1:s<<2)|0;f[j>>2]=w;na=w}else na=v;w=na+(a<<2)|0;s=(a|0)>0;t=(a|0)<10?a:10;C=k+4|0;ga=r?S:.009999999776482582;r=k+8|0;I=k+12|0;E=(la|0)==0;F=a<<2;H=(a|0)==0|s^1;G=-1;oa=-1;S=0.0;T=0.0;_=0.0;ja=0.0;ka=0.0;pa=0;ha=1797693134862315708145274.0e284;while(1){if(s)F1a(na|0,0,F|0)|0;if(H){qa=G;ra=oa}else{sa=G;ta=oa;ua=0;while(1){va=sa;wa=ta;do{xa=W1a(va|0,0,-130063606,0)|0;va=C1a(xa|0,J|0,wa|0,0)|0;wa=J;ya=na+(((va>>>0)%(a>>>0)|0)<<2)|0}while(!(+n[ya>>2]<1.1920928955078125e-07));ua=ua+1|0;n[ya>>2]=1.0;if((ua|0)>=(t|0)){qa=va;ra=wa;break}else{sa=va;ta=wa}}}gha(D,a,na,k);ia=S;Z=T;Y=_;X=ja;Q=ka;ta=0;sa=0;while(1){if(ta){ea=+n[k>>2];ca=+n[C>>2];fa=ia*ea+Z*ca;da=fa<-1.0?-1.0:fa;if(+L(+(+R(+(da>1.0?1.0:da))))<ga?(da=+L(+(+n[r>>2]-Y)),fa=+L(+(+n[I>>2]-X)),(da>fa?da:fa)<W):0){za=ia;Aa=Z;Ba=Y;Ca=X;Da=Q;break}else{Ea=ea;Fa=ca}}else{Ea=+n[k>>2];Fa=+n[C>>2]}ca=+n[r>>2];ea=+n[I>>2];if(s){ua=0;fa=0.0;while(1){da=+L(+(Fa*(+n[D+(ua<<3)>>2]-ca)-Ea*(+n[D+(ua<<3)+4>>2]-ea)));n[w+(ua<<2)>>2]=da;aa=fa+da;ua=ua+1|0;if((ua|0)==(a|0)){Ga=aa;break}else fa=aa}}else Ga=0.0;if(Ga<V){za=ia;Aa=Z;Ba=Y;Ca=X;Da=Ga;break}if(E)vh[ma&63](w,a,na,N);else fi[la&255](w,a,na);if(s){ua=0;fa=0.0;while(1){aa=fa+ +n[na+(ua<<2)>>2];ua=ua+1|0;if((ua|0)==(a|0)){Ha=aa;break}else fa=aa}}else Ha=0.0;if(+L(+Ha)>1.1920928955078125e-07){fa=1.0/Ha;if(s){ua=0;do{wa=na+(ua<<2)|0;n[wa>>2]=fa*+n[wa>>2];ua=ua+1|0}while((ua|0)!=(a|0))}}else if(s){ua=0;do{n[na+(ua<<2)>>2]=1.0;ua=ua+1|0}while((ua|0)!=(a|0))}gha(D,a,na,k);sa=sa+1|0;if((sa|0)>=30){za=Ea;Aa=Fa;Ba=ca;Ca=ea;Da=Ga;break}else{ia=Ea;Z=Fa;Y=ca;X=ea;Q=Ga;ta=1}}if(Da<ha){f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];f[o+8>>2]=f[k+8>>2];f[o+12>>2]=f[k+12>>2];if(Da<V)break;else Ia=Da}else Ia=ha;pa=pa+1|0;if((pa|0)>=20)break;else{G=qa;oa=ra;S=za;T=Aa;_=Ba;ja=Ca;ka=Da;ha=Ia}}ra=f[j>>2]|0;if((ra|0)!=(v|0)){if(ra|0)QYa(ra);f[j>>2]=v;f[B>>2]=264}}}else{Ia=e;e=g;g=h;h=+(q|0)*1.1920928955078125e-07;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;ha=e!=0.0?e:1.0;B=g!=0.0;switch(d|0){case 2:{hha(D,q,0,o);break}case 1:{Ja=185;Ka=0;K=88;break}case 4:{Ja=186;Ka=0;K=88;break}case 5:{Ja=0;Ka=33;K=88;break}case 6:{Ja=0;Ka=34;K=88;break}case 7:{Ja=0;Ka=35;K=88;break}default:{f[j>>2]=0;f[j+4>>2]=0;x=c$(j,16)|0;y=316506;z=x+16|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));j$(-5,j,316523,316422,494);d$(j);Ja=0;Ka=0;K=88}}if((K|0)==88){K=q<<1;y=j+8|0;f[j>>2]=y;x=j+4|0;f[x>>2]=K;if(K>>>0>264){z=OYa(K>>>0>1073741823?-1:K<<2)|0;f[j>>2]=z;La=z}else La=y;z=La+(q<<2)|0;K=(q|0)>0;d=(q|0)<10?q:10;v=k+4|0;ra=k+8|0;e=B?g:.009999999776482582;B=k+12|0;oa=k+16|0;qa=k+20|0;G=(Ja|0)==0;pa=q<<2;na=(q|0)==0|K^1;s=-1;w=-1;g=0.0;Da=0.0;ka=0.0;Ca=0.0;ja=0.0;Ba=0.0;_=0.0;la=0;Aa=1797693134862315708145274.0e284;while(1){if(K)F1a(La|0,0,pa|0)|0;if(na){Ma=s;Na=w}else{ma=s;E=w;I=0;while(1){r=ma;C=E;do{t=W1a(r|0,0,-130063606,0)|0;r=C1a(t|0,J|0,C|0,0)|0;C=J;Oa=La+(((r>>>0)%(q>>>0)|0)<<2)|0}while(!(+n[Oa>>2]<1.1920928955078125e-07));I=I+1|0;n[Oa>>2]=1.0;if((I|0)>=(d|0)){Ma=r;Na=C;break}else{ma=r;E=C}}}hha(D,q,La,k);ea=g;ca=Da;T=ka;za=Ca;S=ja;V=Ba;Ga=_;E=0;ma=0;while(1){Fa=+n[k>>2];if(E){Ea=+n[v>>2];Ha=+n[ra>>2];N=ea*Fa+S*Ea+V*Ha;W=N<-1.0?-1.0:N;if(+L(+(+R(+(W>1.0?1.0:W))))<e?(W=+n[B>>2]-ca,N=+n[oa>>2]-T,ga=+n[qa>>2]-za,Q=Fa-ea,X=Ea-S,Y=Ha-V,Z=+L(+(Y*N-X*ga)),ia=+L(+(Q*ga-Y*W)),Y=+L(+(X*W-Q*N)),N=Z>ia?Z:ia,(N>Y?N:Y)<ha):0){Pa=ea;Qa=ca;Ra=T;Sa=za;Ta=S;Ua=V;Va=Ga;break}else{Wa=Ea;Xa=Ha}}else{Wa=+n[v>>2];Xa=+n[ra>>2]}Ha=+n[B>>2];Ea=+n[oa>>2];Y=+n[qa>>2];if(K){I=0;N=0.0;while(1){ia=+n[D+(I*12|0)>>2]-Ha;Z=+n[D+(I*12|0)+4>>2]-Ea;Q=+n[D+(I*12|0)+8>>2]-Y;W=Wa*Q-Xa*Z;X=Xa*ia-Fa*Q;Q=Fa*Z-Wa*ia;ia=+M(+(Q*Q+(W*W+X*X)));n[z+(I<<2)>>2]=ia;X=N+ia;I=I+1|0;if((I|0)==(q|0)){Ya=X;break}else N=X}}else Ya=0.0;if(G)vh[Ka&63](z,q,La,Ia);else fi[Ja&255](z,q,La);if(K){I=0;N=0.0;while(1){X=N+ +n[La+(I<<2)>>2];I=I+1|0;if((I|0)==(q|0)){Za=X;break}else N=X}}else Za=0.0;if(+L(+Za)>1.1920928955078125e-07){N=1.0/Za;if(K){I=0;do{C=La+(I<<2)|0;n[C>>2]=N*+n[C>>2];I=I+1|0}while((I|0)!=(q|0))}}else if(K){I=0;do{n[La+(I<<2)>>2]=1.0;I=I+1|0}while((I|0)!=(q|0))}hha(D,q,La,k);ma=ma+1|0;if((ma|0)>=30){Pa=Fa;Qa=Ha;Ra=Ea;Sa=Y;Ta=Wa;Ua=Xa;Va=Ya;break}else{ea=Fa;ca=Ha;T=Ea;za=Y;S=Wa;V=Xa;Ga=Ya;E=1}}if(Va<Aa){f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];f[o+8>>2]=f[k+8>>2];f[o+12>>2]=f[k+12>>2];f[o+16>>2]=f[k+16>>2];f[o+20>>2]=f[k+20>>2];if(Va<h)break;else _a=Va}else _a=Aa;la=la+1|0;if((la|0)>=20)break;else{s=Ma;w=Na;g=Pa;Da=Qa;ka=Ra;Ca=Sa;ja=Ta;Ba=Ua;_=Va;Aa=_a}}Na=f[j>>2]|0;if((Na|0)!=(y|0)){if(Na|0)QYa(Na);f[j>>2]=y;f[x>>2]=264}}}x=a>>31&2|4;a=p+4|0;f[a>>2]=2;y=p+8|0;f[y>>2]=x;f[p+12>>2]=1;j=p+16|0;f[j>>2]=o;f[p+20>>2]=o;Na=p+24|0;w=p+40|0;Ma=Na+8|0;f[Ma>>2]=0;f[Ma+4>>2]=0;f[w>>2]=y;y=p+48|0;Ma=p+44|0;f[Ma>>2]=y;f[p>>2]=1124024325;f[y>>2]=4;f[p+52>>2]=4;s=o+(x<<2)|0;f[p+28>>2]=s;f[Na>>2]=s;eL(p,c);c=p+36|0;s=f[c>>2]|0;if(s|0?(Na=s+12|0,s=f[Na>>2]|0,f[Na>>2]=s+-1,(s|0)==1):0)CR(p);f[c>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[a>>2]|0)>0){j=f[w>>2]|0;w=0;do{f[j+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[a>>2]|0))}a=f[Ma>>2]|0;if((a|0)!=(y|0))ZF(a);a=m+36|0;y=f[a>>2]|0;if(y|0?(Ma=y+12|0,y=f[Ma>>2]|0,f[Ma>>2]=y+-1,(y|0)==1):0)CR(m);f[a>>2]=0;a=m+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[a>>2]|0)>0){A=f[m+40>>2]|0;y=0;do{f[A+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[a>>2]|0))}a=f[m+44>>2]|0;if((a|0)!=(m+48|0))ZF(a);if(!(f[l+4>>2]|0)){u=i;return}u=i;return}function bha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0;e=d<=0.0?1.3450000286102295:d;if((b|0)>0)f=0;else return;do{d=+n[a+(f<<2)>>2];n[c+(f<<2)>>2]=d<e?1.0:e/d;f=f+1|0}while((f|0)!=(b|0));return}function cha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0.0;e=d==0.0?.3350532650947571:1.0/d;if((b|0)>0)f=0;else return;do{d=+n[a+(f<<2)>>2];g=+V(+-(e*(e*(d*d))));n[c+(f<<2)>>2]=g;f=f+1|0}while((f|0)!=(b|0));return}function dha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0;e=d==0.0?.7143877744674683:1.0/d;if((b|0)>0)f=0;else return;do{n[c+(f<<2)>>2]=1.0/(e*+n[a+(f<<2)>>2]+1.0);f=f+1|0}while((f|0)!=(b|0));return}function eha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0.0;if((b|0)>0)d=0;else return;do{e=+n[a+(d<<2)>>2];f=1.0/+M(+(e*e*.5+1.0));n[c+(d<<2)>>2]=f;d=d+1|0}while((d|0)!=(b|0));return}function fha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((b|0)>0)d=0;else return;do{e=+L(+(+n[a+(d<<2)>>2]));n[c+(d<<2)>>2]=1.0/(e<1.0e-06?1.0e-06:e);d=d+1|0}while((d|0)!=(b|0));return}function gha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0;e=(b|0)>0;if(c)if(e){f=0;g=0.0;h=0.0;i=0.0;j=0.0;k=0.0;l=0.0;while(1){m=+n[c+(f<<2)>>2];o=+n[a+(f<<3)>>2];p=m*o;q=h+p;r=+n[a+(f<<3)+4>>2];s=m*r;t=k+s;u=i+o*p;o=l+r*s;s=j+p*r;r=g+m;f=f+1|0;if((f|0)==(b|0)){v=r;w=q;x=u;y=s;z=t;A=o;break}else{g=r;h=q;i=u;j=s;k=t;l=o}}}else{v=0.0;w=0.0;x=0.0;y=0.0;z=0.0;A=0.0}else{if(e){e=0;l=0.0;k=0.0;j=0.0;i=0.0;h=0.0;while(1){g=+n[a+(e<<3)>>2];o=l+g;t=+n[a+(e<<3)+4>>2];s=i+t;u=k+g*g;q=h+t*t;r=j+g*t;e=e+1|0;if((e|0)==(b|0)){B=o;C=u;D=r;E=s;F=q;break}else{l=o;k=u;j=r;i=s;h=q}}}else{B=0.0;C=0.0;D=0.0;E=0.0;F=0.0}v=+(b|0);w=B;x=C;y=D;z=E;A=F}F=w/v;w=z/v;z=+U(+((y/v-w*F)*2.0),+(x/v-F*F-(A/v-w*w)))*.5;v=+O(+z);n[d>>2]=v;v=+P(+z);n[d+4>>2]=v;n[d+8>>2]=F;n[d+12>>2]=w;return}function hha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;e=u;u=u+304|0;g=e+264|0;h=e+228|0;i=e+216|0;j=e+160|0;k=e+104|0;l=e+48|0;m=e+32|0;o=e+16|0;p=e;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;q=h;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));q=(b|0)>0;if(c)if(q){r=0;s=0.0;t=0.0;v=0.0;w=0.0;x=0.0;y=0.0;z=0.0;A=0.0;B=0.0;C=0.0;while(1){D=+n[a+(r*12|0)>>2];E=+n[a+(r*12|0)+4>>2];F=+n[a+(r*12|0)+8>>2];G=+n[c+(r<<2)>>2];H=v+D*D*G;I=w+D*E*G;J=x+D*F*G;K=z+E*E*G;L=A+E*F*G;N=C+F*F*G;O=t+D*G;D=y+E*G;E=B+F*G;F=s+G;r=r+1|0;if((r|0)==(b|0)){P=F;Q=O;R=H;S=I;T=J;U=D;V=K;W=L;X=E;Y=N;break}else{s=F;t=O;v=H;w=I;x=J;y=D;z=K;A=L;B=E;C=N}}}else{P=0.0;Q=0.0;R=0.0;S=0.0;T=0.0;U=0.0;V=0.0;W=0.0;X=0.0;Y=0.0}else{if(q){q=0;C=0.0;B=0.0;A=0.0;z=0.0;y=0.0;x=0.0;w=0.0;v=0.0;t=0.0;while(1){s=+n[a+(q*12|0)>>2];N=+n[a+(q*12|0)+4>>2];E=+n[a+(q*12|0)+8>>2];L=B+s*s;K=A+s*N;D=z+s*E;J=x+N*N;I=w+N*E;H=t+E*E;O=C+s;s=y+N;N=v+E;q=q+1|0;if((q|0)==(b|0)){Z=O;_=L;$=K;aa=D;ba=s;ca=J;da=I;ea=N;fa=H;break}else{C=O;B=L;A=K;z=D;y=s;x=J;w=I;v=N;t=H}}}else{Z=0.0;_=0.0;$=0.0;aa=0.0;ba=0.0;ca=0.0;da=0.0;ea=0.0;fa=0.0}P=+(b|0);Q=Z;R=_;S=$;T=aa;U=ba;V=ca;W=da;X=ea;Y=fa}fa=Q/P;Q=U/P;U=X/P;X=R/P-fa*fa;R=V/P-Q*Q;V=Y/P-U*U;n[g>>2]=V+R;Y=-(S/P-fa*Q);n[g+4>>2]=Y;S=-(T/P-fa*U);n[g+8>>2]=S;n[g+12>>2]=Y;n[g+16>>2]=X+V;V=-(W/P-Q*U);n[g+20>>2]=V;n[g+24>>2]=S;n[g+28>>2]=V;n[g+32>>2]=R+X;b=j+4|0;f[b>>2]=2;q=j+8|0;f[q>>2]=3;f[j+12>>2]=3;a=j+16|0;f[a>>2]=g;f[j+20>>2]=g;r=j+24|0;c=j+40|0;ga=r+8|0;f[ga>>2]=0;f[ga+4>>2]=0;f[c>>2]=q;q=j+48|0;ga=j+44|0;f[ga>>2]=q;f[j>>2]=1124024325;f[q>>2]=12;f[j+52>>2]=4;f[j+28>>2]=g+36;f[r>>2]=g+36;g=k+4|0;f[g>>2]=2;r=k+8|0;f[r>>2]=3;f[k+12>>2]=3;ha=k+16|0;f[ha>>2]=h;f[k+20>>2]=h;ia=k+24|0;ja=k+40|0;ka=ia+8|0;f[ka>>2]=0;f[ka+4>>2]=0;f[ja>>2]=r;r=k+48|0;ka=k+44|0;f[ka>>2]=r;f[k>>2]=1124024325;f[r>>2]=12;f[k+52>>2]=4;f[k+28>>2]=h+36;f[ia>>2]=h+36;ia=l+4|0;f[ia>>2]=2;la=l+8|0;f[la>>2]=3;f[l+12>>2]=1;ma=l+16|0;f[ma>>2]=i;f[l+20>>2]=i;na=l+24|0;oa=l+40|0;pa=na+8|0;f[pa>>2]=0;f[pa+4>>2]=0;f[oa>>2]=la;la=l+48|0;pa=l+44|0;f[pa>>2]=la;f[l>>2]=1124024325;f[la>>2]=4;f[l+52>>2]=4;f[l+28>>2]=i+12;f[na>>2]=i+12;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=j;na=o+8|0;f[na>>2]=0;f[na+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=l;na=p+8|0;f[na>>2]=0;f[na+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=k;bN(m,o,p)|0;p=!(+n[i>>2]<+n[i+4>>2]);o=h+((+n[i+((p&1)<<2)>>2]<+n[i+8>>2]?(p?3:0):6)<<2)|0;X=+n[o>>2];R=X;V=+n[o+4>>2];S=V;P=+n[o+8>>2];W=P;Y=+M(+(R*R+S*S+W*W));W=Y<1.0e-06?1.0e-06:Y;n[d>>2]=X/W;n[d+4>>2]=V/W;n[d+8>>2]=P/W;n[d+12>>2]=fa;n[d+16>>2]=Q;n[d+20>>2]=U;d=l+36|0;o=f[d>>2]|0;if(o|0?(p=o+12|0,o=f[p>>2]|0,f[p>>2]=o+-1,(o|0)==1):0)CR(l);f[d>>2]=0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[ia>>2]|0)>0){ma=f[oa>>2]|0;oa=0;do{f[ma+(oa<<2)>>2]=0;oa=oa+1|0}while((oa|0)<(f[ia>>2]|0))}ia=f[pa>>2]|0;if((ia|0)!=(la|0))ZF(ia);ia=k+36|0;la=f[ia>>2]|0;if(la|0?(pa=la+12|0,la=f[pa>>2]|0,f[pa>>2]=la+-1,(la|0)==1):0)CR(k);f[ia>>2]=0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[g>>2]|0)>0){ha=f[ja>>2]|0;ja=0;do{f[ha+(ja<<2)>>2]=0;ja=ja+1|0}while((ja|0)<(f[g>>2]|0))}g=f[ka>>2]|0;if((g|0)!=(r|0))ZF(g);g=j+36|0;r=f[g>>2]|0;if(r|0?(ka=r+12|0,r=f[ka>>2]|0,f[ka>>2]=r+-1,(r|0)==1):0)CR(j);f[g>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[b>>2]|0)>0){a=f[c>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[ga>>2]|0;if((b|0)==(q|0)){u=e;return}ZF(b);u=e;return}function iha(a,c,d,e){a=a|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,q=0.0,r=0.0,s=0,t=0,v=0.0,w=0.0,x=0,y=0,z=0.0;g=u;u=u+320|0;h=g+304|0;i=g+248|0;j=g+192|0;k=g;_$(h,72964);kha(k,a,0);qha(k,i);kha(k,c,0);qha(k,j);switch(d|0){case 1:{d=0;c=0;a=0;e=0.0;while(1){l=+p[i+(a<<3)>>3];m=+L(+l);n=+p[j+(a<<3)>>3];o=+L(+n);d=l!=l|0.0!=0.0|l==0.0?d:1;c=n!=n|0.0!=0.0|n==0.0?c:1;if(m>1.0e-05&o>1.0e-05){q=1.0/((l>0.0?1.0:l<0.0?-1.0:0.0)*+uNa(m));r=e+ +L(+(1.0/((n>0.0?1.0:n<0.0?-1.0:0.0)*+uNa(o))-q))}else r=e;a=a+1|0;if((a|0)==7)break;else e=r}s=(d&1)!=0;t=(c&1)!=0;v=r;break}case 2:{c=0;d=0;a=0;r=0.0;while(1){e=+p[i+(a<<3)>>3];q=+L(+e);o=+p[j+(a<<3)>>3];n=+L(+o);c=e!=e|0.0!=0.0|e==0.0?c:1;d=o!=o|0.0!=0.0|o==0.0?d:1;if(q>1.0e-05&n>1.0e-05){m=(e>0.0?1.0:e<0.0?-1.0:0.0)*+uNa(q);w=r+ +L(+((o>0.0?1.0:o<0.0?-1.0:0.0)*+uNa(n)-m))}else w=r;a=a+1|0;if((a|0)==7)break;else r=w}s=(c&1)!=0;t=(d&1)!=0;v=w;break}case 3:{d=0;c=0;a=0;w=0.0;while(1){r=+p[i+(a<<3)>>3];m=+L(+r);n=+p[j+(a<<3)>>3];o=+L(+n);x=d|r==r&0.0==0.0&r!=0.0;y=c|n==n&0.0==0.0&n!=0.0;if(m>1.0e-05&o>1.0e-05?(q=(r>0.0?1.0:r<0.0?-1.0:0.0)*+uNa(m),m=+L(+((q-(n>0.0?1.0:n<0.0?-1.0:0.0)*+uNa(o))/q)),w<m):0)z=m;else z=w;a=a+1|0;if((a|0)==7){s=x;t=y;v=z;break}else{d=x;c=y;w=z}}break}default:{f[k>>2]=0;f[k+4>>2]=0;c=c$(k,25)|0;d=316604;a=c+25|0;do{b[c>>0]=b[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(a|0));j$(-5,k,316630,316642,161);d$(k);s=0;t=0;v=0.0}}z=s^t?1797693134862315708145274.0e284:v;if(!(f[h+4>>2]|0)){u=g;return +z}u=g;return +z}function jha(a){a=a|0;F1a(a|0,0,192)|0;return}function kha(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0,Ib=0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0.0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0.0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0.0,Zb=0.0,_b=0.0,$b=0.0,ac=0.0;e=u;u=u+1344|0;g=e+264|0;h=e+256|0;i=e+320|0;j=e+248|0;k=e+192|0;l=e+136|0;m=e+8|0;o=e+120|0;q=e+104|0;r=e;s=e+88|0;_$(h,72984);t=RR(c,-1)|0;v=t&7;w=t&4088;QR(j,c,-1);if((f[j>>2]|0)>=1?(x=j+4|0,(f[x>>2]|0)>=1):0){do if((NS(c)|0)==65536){y=f[c+4>>2]|0;f[k>>2]=f[y>>2];z=k+4|0;A=y+4|0;f[z>>2]=f[A>>2];B=k+8|0;f[B>>2]=f[y+8>>2];f[k+12>>2]=f[y+12>>2];f[k+16>>2]=f[y+16>>2];f[k+20>>2]=f[y+20>>2];f[k+24>>2]=f[y+24>>2];f[k+28>>2]=f[y+28>>2];f[k+32>>2]=f[y+32>>2];C=f[y+36>>2]|0;f[k+36>>2]=C;f[k+40>>2]=B;B=k+48|0;D=k+44|0;f[D>>2]=B;f[B>>2]=0;f[k+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[y+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];break}else{f[z>>2]=0;BR(k,y);break}}else OR(k,c,-1);while(0);if((v|1|0)==5&(LS(k,2,-1,1)|0)>-1){F1a(a|0,0,192)|0;c=LS(k,2,-1,1)|0;y=f[k>>2]|0;z=(y&7|0)==5;A=f[k+16>>2]|0;if((y&6|0)!=4){f[g>>2]=0;f[g+4>>2]=0;E=c$(g,44)|0;F=316760;G=E+44|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));j$(-215,g,316805,316820,101);d$(g)}if(c|0){y=c+-1|0;if(z){H=+n[A+(y<<3)>>2];I=+n[A+(y<<3)+4>>2]}else{H=+(f[A+(y<<3)>>2]|0);I=+(f[A+(y<<3)+4>>2]|0)}J=H*H;K=I*I;if((c|0)>0)if(z){N=0.0;O=0.0;P=0.0;Q=0.0;R=0.0;S=0.0;T=0.0;U=0.0;V=0.0;W=0.0;z=0;X=H;Z=J;_=I;$=K;while(1){aa=X;X=+n[A+(z<<3)>>2];ba=_;_=+n[A+(z<<3)+4>>2];ca=Z;Z=X*X;da=$;$=_*_;ea=aa*_-ba*X;fa=aa+X;ga=ba+_;ha=N+ea;ia=fa*ea;ja=R+ia;ka=ga*ea;la=O+ka;ma=U+ea*(Z+aa*fa);na=S+ea*(aa*(ba+ga)+X*(_+ga));oa=P+ea*($+ba*ga);pa=W+(ca+Z)*ia;ia=Q+(da+$)*ka;ka=V+ea*(ca*(ba*3.0+_)+aa*(X*2.0)*ga+Z*(ba+_*3.0));ga=T+ea*($*(aa+X*3.0)+(da*(aa*3.0+X)+fa*(ba*(_*2.0))));z=z+1|0;if((z|0)==(c|0)){qa=ha;ra=la;sa=oa;ta=ia;ua=ja;va=na;wa=ga;xa=ma;ya=ka;za=pa;break}else{N=ha;O=la;P=oa;Q=ia;R=ja;S=na;T=ga;U=ma;V=ka;W=pa}}}else{W=0.0;V=0.0;U=0.0;T=0.0;S=0.0;R=0.0;Q=0.0;P=0.0;O=0.0;N=0.0;z=0;_=H;H=J;J=I;I=K;while(1){K=_;_=+(f[A+(z<<3)>>2]|0);X=J;J=+(f[A+(z<<3)+4>>2]|0);$=H;H=_*_;Z=I;I=J*J;pa=K*J-X*_;ka=K+_;ma=X+J;ga=W+pa;na=ka*pa;ja=S+na;ia=ma*pa;oa=V+ia;la=P+pa*(H+K*ka);ha=R+pa*(K*(X+ma)+_*(J+ma));ba=U+pa*(I+X*ma);fa=N+($+H)*na;na=T+(Z+I)*ia;ia=O+pa*($*(X*3.0+J)+K*(_*2.0)*ma+H*(X+J*3.0));ma=Q+pa*(I*(K+_*3.0)+(Z*(K*3.0+_)+ka*(X*(J*2.0))));z=z+1|0;if((z|0)==(c|0)){qa=ga;ra=oa;sa=ba;ta=na;ua=ja;va=ha;wa=ma;xa=la;ya=ia;za=fa;break}else{W=ga;V=oa;U=ba;T=na;S=ja;R=ha;Q=ma;P=la;O=ia;N=fa}}}else{qa=0.0;ra=0.0;sa=0.0;ta=0.0;ua=0.0;va=0.0;wa=0.0;xa=0.0;ya=0.0;za=0.0}if(+L(+qa)>1.1920928955078125e-07){c=qa>0.0;N=c?.16666666666666666:-.16666666666666666;O=c?.08333333333333333:-.08333333333333333;P=c?.05:-.05;Q=c?.016666666666666666:-.016666666666666666;R=qa*(c?.5:-.5);p[a>>3]=R;qa=ua*N;p[a+8>>3]=qa;ua=ra*N;p[a+16>>3]=ua;N=xa*O;p[a+24>>3]=N;xa=va*(c?.041666666666666664:-.041666666666666664);p[a+32>>3]=xa;va=sa*O;p[a+40>>3]=va;O=za*P;p[a+48>>3]=O;za=ya*Q;p[a+56>>3]=za;ya=wa*Q;p[a+64>>3]=ya;Q=ta*P;p[a+72>>3]=Q;c=+L(+R)>2.220446049250313e-16;P=1.0/R;R=c?P:0.0;ta=c?ua*P:0.0;wa=c?qa*P:0.0;P=qa*wa;sa=N-P;N=qa*ta;qa=xa-N;xa=ua*ta;ra=va-xa;p[a+80>>3]=sa;p[a+88>>3]=qa;p[a+96>>3]=ra;va=O-wa*(P+sa*3.0);p[a+104>>3]=va;P=qa+qa;O=za-wa*(ua*wa+P)-ta*sa;p[a+112>>3]=O;ua=ya-ta*(N+P)-wa*ra;p[a+120>>3]=ua;wa=Q-ta*(xa+ra*3.0);p[a+128>>3]=wa;xa=R*R;ta=xa*+M(+(+L(+R)));p[a+136>>3]=xa*sa;p[a+144>>3]=xa*qa;p[a+152>>3]=xa*ra;p[a+160>>3]=va*ta;p[a+168>>3]=O*ta;p[a+176>>3]=ua*ta;p[a+184>>3]=wa*ta}}}else{if(w|0){f[g>>2]=0;f[g+4>>2]=0;E=c$(g,43)|0;F=316872;G=E+43|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));j$(-5,g,316916,316820,677);d$(g)}a:do if((v|0)==0|d)Aa=377;else switch(t&7){case 2:{Aa=378;break a;break}case 3:{Aa=379;break a;break}case 5:{Aa=380;break a;break}case 6:{Aa=381;break a;break}default:{f[g>>2]=0;f[g+4>>2]=0;j$(-210,g,316916,316820,692);d$(g);Aa=0;break a}}while(0);f[g>>2]=f[k>>2];t=g+4|0;v=k+4|0;F=f[v>>2]|0;f[t>>2]=F;E=g+8|0;f[E>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];G=g+16|0;f[G>>2]=f[k+16>>2];f[g+20>>2]=f[k+20>>2];f[g+24>>2]=f[k+24>>2];f[g+28>>2]=f[k+28>>2];f[g+32>>2]=f[k+32>>2];w=g+36|0;c=f[k+36>>2]|0;f[w>>2]=c;z=g+40|0;f[z>>2]=E;E=g+48|0;A=g+44|0;f[A>>2]=E;f[E>>2]=0;f[g+52>>2]=0;if(!c)Ba=F;else{F=c+12|0;f[F>>2]=(f[F>>2]|0)+1;Ba=f[v>>2]|0}if((Ba|0)<3){Ba=f[k+44>>2]|0;v=f[A>>2]|0;f[v>>2]=f[Ba>>2];f[v+4>>2]=f[Ba+4>>2]}else{f[t>>2]=0;BR(g,k)}Ba=f[x>>2]|0;if((Ba|0)>0){v=m+4|0;F=m+8|0;c=m+12|0;y=m+4|0;B=m+8|0;D=m+12|0;C=m+16|0;Ca=m+20|0;Da=m+24|0;Ea=m+28|0;Fa=m+40|0;Ga=m+48|0;Ha=m+44|0;Ia=m+52|0;Ja=o+8|0;Ka=o+12|0;La=o+4|0;Ma=q+8|0;Na=q+12|0;Oa=q+4|0;Pa=s+8|0;Qa=s+4|0;Ra=m+36|0;Sa=l+36|0;Ta=l+16|0;Ua=l+4|0;Va=l+40|0;Wa=l+8|0;Xa=l+12|0;Ya=l+44|0;Za=l+20|0;_a=l+24|0;$a=l+28|0;ab=m+32|0;bb=l+32|0;cb=m+8|0;db=m+16|0;eb=m+24|0;fb=m+32|0;gb=m+40|0;hb=m+48|0;ib=m+56|0;jb=m+64|0;kb=m+72|0;lb=l+48|0;mb=Da+8|0;nb=Ba;Ba=f[j>>2]|0;ta=0.0;wa=0.0;ua=0.0;O=0.0;va=0.0;ra=0.0;xa=0.0;qa=0.0;sa=0.0;R=0.0;ob=0;while(1){pb=nb-ob|0;qb=(pb|0)<32?pb:32;if((Ba|0)>0){Q=+(ob|0);pb=Ba;P=ta;N=wa;ya=ua;za=O;S=va;T=ra;U=xa;V=qa;W=sa;J=R;rb=0;do{sb=pb-rb|0;tb=(sb|0)<32?sb:32;f[m>>2]=rb;f[v>>2]=ob;f[F>>2]=tb;f[c>>2]=qb;FR(l,g,m);if(d){f[y>>2]=2;f[B>>2]=qb;f[D>>2]=tb;f[C>>2]=i;f[Ca>>2]=i;sb=mb;f[sb>>2]=0;f[sb+4>>2]=0;f[Fa>>2]=B;f[Ha>>2]=Ga;f[m>>2]=1124024320;f[Ga>>2]=tb;f[Ia>>2]=1;sb=i+(Y(qb,tb)|0)|0;f[Ea>>2]=sb;f[Da>>2]=sb+(0-tb)+tb;f[Ja>>2]=0;f[Ka>>2]=0;f[o>>2]=16842752;f[La>>2]=l;p[r>>3]=0.0;f[q>>2]=-1056833530;f[Oa>>2]=r;f[Ma>>2]=1;f[Na>>2]=1;tb=Pa;f[tb>>2]=0;f[tb+4>>2]=0;f[s>>2]=33619968;f[Qa>>2]=m;pI(o,q,s,5);tb=f[Ra>>2]|0;if(tb|0){sb=tb+12|0;f[sb>>2]=(f[sb>>2]|0)+1}sb=f[Sa>>2]|0;do if(sb|0){tb=sb+12|0;ub=f[tb>>2]|0;f[tb>>2]=ub+-1;if((ub|0)!=1)break;CR(l)}while(0);f[Sa>>2]=0;f[Ta>>2]=0;f[Ta+4>>2]=0;f[Ta+8>>2]=0;f[Ta+12>>2]=0;if((f[Ua>>2]|0)>0){sb=f[Va>>2]|0;ub=0;do{f[sb+(ub<<2)>>2]=0;ub=ub+1|0;vb=f[Ua>>2]|0}while((ub|0)<(vb|0));f[l>>2]=f[m>>2];if((vb|0)<3)wb=62;else wb=64}else{f[l>>2]=f[m>>2];wb=62}do if((wb|0)==62){wb=0;ub=f[y>>2]|0;if((ub|0)>=3){wb=64;break}f[Ua>>2]=ub;f[Wa>>2]=f[B>>2];f[Xa>>2]=f[D>>2];ub=f[Ha>>2]|0;sb=f[Ya>>2]|0;f[sb>>2]=f[ub>>2];f[sb+4>>2]=f[ub+4>>2]}while(0);if((wb|0)==64){wb=0;BR(l,m)}f[Ta>>2]=f[C>>2];f[Za>>2]=f[Ca>>2];f[_a>>2]=f[Da>>2];f[$a>>2]=f[Ea>>2];f[bb>>2]=f[ab>>2];ub=f[Ra>>2]|0;f[Sa>>2]=ub;do if(ub|0){sb=ub+12|0;tb=f[sb>>2]|0;f[sb>>2]=tb+-1;if((tb|0)!=1)break;CR(m)}while(0);f[Ra>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[y>>2]|0)>0){ub=f[Fa>>2]|0;tb=0;do{f[ub+(tb<<2)>>2]=0;tb=tb+1|0}while((tb|0)<(f[y>>2]|0))}tb=f[Ha>>2]|0;if((tb|0)!=(Ga|0))ZF(tb)}Gh[Aa&511](l,m);_=+p[m>>3];if(d){I=_*.00392156862745098;p[m>>3]=I;H=+p[cb>>3]*.00392156862745098;p[cb>>3]=H;fa=+p[db>>3]*.00392156862745098;p[db>>3]=fa;ia=+p[eb>>3]*.00392156862745098;p[eb>>3]=ia;la=+p[fb>>3]*.00392156862745098;p[fb>>3]=la;ma=+p[gb>>3]*.00392156862745098;p[gb>>3]=ma;ha=+p[hb>>3]*.00392156862745098;p[hb>>3]=ha;ja=+p[ib>>3]*.00392156862745098;p[ib>>3]=ja;na=+p[jb>>3]*.00392156862745098;p[jb>>3]=na;ba=+p[kb>>3]*.00392156862745098;p[kb>>3]=ba;xb=I;yb=H;zb=fa;Ab=ia;Bb=la;Cb=ma;Db=ha;Eb=ja;Fb=na;Gb=ba}else{xb=_;yb=+p[cb>>3];zb=+p[db>>3];Ab=+p[eb>>3];Bb=+p[fb>>3];Cb=+p[gb>>3];Db=+p[hb>>3];Eb=+p[ib>>3];Fb=+p[jb>>3];Gb=+p[kb>>3]}_=+(rb|0);ba=_*xb;na=Q*xb;P=P+xb;ja=yb+ba;J=J+ja;ha=na+zb;N=N+ha;ya=ya+(Ab+_*(ba+yb*2.0));ma=_*ha;ha=Q*yb;za=za+(ha+(Bb+ma));S=S+(Cb+Q*(na+zb*2.0));T=T+(Db+_*(Ab*3.0+_*(ba+yb*3.0)));U=U+(Q*Ab+(Eb+_*(ma+(ha+Bb)*2.0)));V=V+(_*Cb+(Fb+Q*(Q*ja+(_*zb+Bb)*2.0)));W=W+(Q*(Q*(na+zb*3.0)+Cb*3.0)+Gb);tb=f[Sa>>2]|0;do if(tb|0){ub=tb+12|0;sb=f[ub>>2]|0;f[ub>>2]=sb+-1;if((sb|0)!=1)break;CR(l)}while(0);f[Sa>>2]=0;f[Ta>>2]=0;f[Ta+4>>2]=0;f[Ta+8>>2]=0;f[Ta+12>>2]=0;if((f[Ua>>2]|0)>0){tb=f[Va>>2]|0;sb=0;do{f[tb+(sb<<2)>>2]=0;sb=sb+1|0}while((sb|0)<(f[Ua>>2]|0))}sb=f[Ya>>2]|0;if((sb|0)!=(lb|0))ZF(sb);rb=rb+32|0;pb=f[j>>2]|0}while((pb|0)>(rb|0));Hb=pb;Ib=f[x>>2]|0;Jb=P;Kb=N;Lb=ya;Mb=za;Nb=S;Ob=T;Pb=U;Qb=V;Rb=W;Sb=J}else{Hb=Ba;Ib=nb;Jb=ta;Kb=wa;Lb=ua;Mb=O;Nb=va;Ob=ra;Pb=xa;Qb=qa;Rb=sa;Sb=R}ob=ob+32|0;if((Ib|0)<=(ob|0)){Tb=Jb;Ub=Kb;Vb=Lb;Wb=Mb;Xb=Nb;Yb=Ob;Zb=Pb;_b=Qb;$b=Rb;ac=Sb;break}else{nb=Ib;Ba=Hb;ta=Jb;wa=Kb;ua=Lb;O=Mb;va=Nb;ra=Ob;xa=Pb;qa=Qb;sa=Rb;R=Sb}}}else{Tb=0.0;Ub=0.0;Vb=0.0;Wb=0.0;Xb=0.0;Yb=0.0;Zb=0.0;_b=0.0;$b=0.0;ac=0.0}Hb=+L(+Tb)>2.220446049250313e-16;Sb=1.0/Tb;R=Hb?Sb:0.0;Rb=Hb?Ub*Sb:0.0;sa=Hb?ac*Sb:0.0;Sb=ac*sa;Qb=Vb-Sb;qa=ac*Rb;Pb=Wb-qa;xa=Ub*Rb;Ob=Xb-xa;ra=Yb-sa*(Sb+Qb*3.0);Sb=Pb+Pb;Nb=Zb-sa*(Ub*sa+Sb)-Rb*Qb;va=_b-Rb*(qa+Sb)-sa*Ob;sa=$b-Rb*(xa+Ob*3.0);xa=R*R;Rb=+M(+(+L(+R)))*xa;p[a>>3]=Tb;p[a+8>>3]=ac;p[a+16>>3]=Ub;p[a+24>>3]=Vb;p[a+32>>3]=Wb;p[a+40>>3]=Xb;p[a+48>>3]=Yb;p[a+56>>3]=Zb;p[a+64>>3]=_b;p[a+72>>3]=$b;p[a+80>>3]=Qb;p[a+88>>3]=Pb;p[a+96>>3]=Ob;p[a+104>>3]=ra;p[a+112>>3]=Nb;p[a+120>>3]=va;p[a+128>>3]=sa;p[a+136>>3]=xa*Qb;p[a+144>>3]=xa*Pb;p[a+152>>3]=xa*Ob;p[a+160>>3]=Rb*ra;p[a+168>>3]=Rb*Nb;p[a+176>>3]=Rb*va;p[a+184>>3]=Rb*sa;Hb=f[w>>2]|0;if(Hb|0?(Ba=Hb+12|0,Hb=f[Ba>>2]|0,f[Ba>>2]=Hb+-1,(Hb|0)==1):0)CR(g);f[w>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[t>>2]|0)>0){G=f[z>>2]|0;z=0;do{f[G+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[t>>2]|0))}t=f[A>>2]|0;if((t|0)!=(E|0))ZF(t)}t=k+36|0;E=f[t>>2]|0;if(E|0?(A=E+12|0,E=f[A>>2]|0,f[A>>2]=E+-1,(E|0)==1):0)CR(k);f[t>>2]=0;t=k+16|0;E=k+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[E>>2]|0)>0){t=f[k+40>>2]|0;A=0;do{f[t+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[E>>2]|0))}E=f[k+44>>2]|0;if((E|0)!=(k+48|0))ZF(E)}else F1a(a|0,0,192)|0;if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function lha(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0;c=f[a+40>>2]|0;e=f[c+4>>2]|0;g=f[c>>2]|0;if((g|0)>0?(c=f[a+16>>2]|0,h=f[f[a+44>>2]>>2]|0,(e|0)>0):0){a=0;i=0;j=0;k=0;l=0;m=0;n=0;o=0;q=0;r=0;s=0;t=0;u=0;v=0;w=0;x=0;y=0;z=0;A=0;B=0;C=0;do{D=c+(Y(h,C)|0)|0;E=0;F=0;G=0;H=0;I=0;K=0;do{L=d[D+(G<<1)>>1]|0;M=Y(L,G)|0;H=L+H|0;I=M+I|0;L=Y(M,G)|0;K=L+K|0;M=Y(L,G)|0;E=C1a(M|0,((M|0)<0)<<31>>31|0,E|0,F|0)|0;F=J;G=G+1|0}while((G|0)!=(e|0));G=Y(H,C)|0;D=Y(C,C)|0;M=((G|0)<0)<<31>>31;L=W1a(G|0,M|0,D|0,0)|0;a=C1a(a|0,i|0,L|0,J|0)|0;i=J;L=((I|0)<0)<<31>>31;N=W1a(I|0,L|0,D|0,0)|0;j=C1a(j|0,k|0,N|0,J|0)|0;k=J;N=((K|0)<0)<<31>>31;O=W1a(K|0,N|0,C|0,((C|0)<0)<<31>>31|0)|0;l=C1a(l|0,m|0,O|0,J|0)|0;m=J;n=C1a(n|0,o|0,E|0,F|0)|0;o=J;O=Y(H,D)|0;q=C1a(q|0,r|0,O|0,((O|0)<0)<<31>>31|0)|0;r=J;O=Y(I,C)|0;s=C1a(s|0,t|0,O|0,((O|0)<0)<<31>>31|0)|0;t=J;u=C1a(u|0,v|0,K|0,N|0)|0;v=J;w=C1a(w|0,x|0,G|0,M|0)|0;x=J;y=C1a(y|0,z|0,I|0,L|0)|0;z=J;A=C1a(A|0,B|0,H|0,((H|0)<0)<<31>>31|0)|0;B=J;C=C+1|0}while((C|0)!=(g|0));P=+(A>>>0)+4294967296.0*+(B|0);Q=+(y>>>0)+4294967296.0*+(z|0);R=+(w>>>0)+4294967296.0*+(x|0);S=+(u>>>0)+4294967296.0*+(v|0);T=+(s>>>0)+4294967296.0*+(t|0);U=+(q>>>0)+4294967296.0*+(r|0);V=+(n>>>0)+4294967296.0*+(o|0);W=+(l>>>0)+4294967296.0*+(m|0);X=+(j>>>0)+4294967296.0*+(k|0);Z=+(a>>>0)+4294967296.0*+(i|0)}else{P=0.0;Q=0.0;R=0.0;S=0.0;T=0.0;U=0.0;V=0.0;W=0.0;X=0.0;Z=0.0}p[b>>3]=P;p[b+8>>3]=Q;p[b+16>>3]=R;p[b+24>>3]=S;p[b+32>>3]=T;p[b+40>>3]=U;p[b+48>>3]=V;p[b+56>>3]=W;p[b+64>>3]=X;p[b+72>>3]=Z;return}function mha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0;c=u;u=u+80|0;d=c;e=f[a+40>>2]|0;g=f[e+4>>2]|0;h=f[e>>2]|0;e=d;i=e+80|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(i|0));if((h|0)<=0){e=b;j=d;i=e+80|0;do{f[e>>2]=f[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(i|0));u=c;return}k=f[a+16>>2]|0;l=f[f[a+44>>2]>>2]|0;a=d+72|0;m=d+64|0;o=d+56|0;q=d+48|0;r=d+40|0;s=d+32|0;t=d+24|0;v=d+16|0;w=d+8|0;if((g|0)>0){x=0.0;y=0.0;z=0.0;A=0.0;B=0.0;C=0.0;D=0.0;E=0.0;F=0.0;G=0.0;H=0;while(1){I=k+(Y(l,H)|0)|0;J=0;K=0.0;L=0.0;M=0.0;N=0.0;do{O=+n[I+(J<<2)>>2];P=+(J|0);Q=P*O;K=K+O;L=L+Q;O=P*Q;M=M+O;N=N+P*O;J=J+1|0}while((J|0)!=(g|0));O=+(H|0);P=O*K;Q=+(Y(H,H)|0);R=Q*P+x;S=Q*L+y;T=O*M+z;U=N+A;V=Q*K+B;Q=O*L+C;O=M+D;W=P+E;P=L+F;X=K+G;H=H+1|0;if((H|0)==(h|0)){Z=R;_=S;$=T;aa=U;ba=V;ca=Q;da=O;ea=W;fa=P;ga=X;break}else{x=R;y=S;z=T;A=U;B=V;C=Q;D=O;E=W;F=P;G=X}}}else{G=0.0;F=0.0;E=0.0;D=0.0;C=0.0;B=0.0;H=0;while(1){A=+(H|0)*0.0;z=+(Y(H,H)|0);y=z*A+G;x=z*0.0;z=x+F;X=A+E;P=x+D;x=A+C;W=A+B;H=H+1|0;if((H|0)==(h|0)){Z=y;_=z;$=X;aa=0.0;ba=P;ca=x;da=0.0;ea=W;fa=0.0;ga=0.0;break}else{G=y;F=z;E=X;D=P;C=x;B=W}}}p[a>>3]=Z;p[m>>3]=_;p[o>>3]=$;p[q>>3]=aa;p[r>>3]=ba;p[s>>3]=ca;p[t>>3]=da;p[v>>3]=ea;p[w>>3]=fa;p[d>>3]=ga;e=b;j=d;i=e+80|0;do{f[e>>2]=f[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(i|0));u=c;return}function nha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0;c=u;u=u+80|0;d=c;e=f[a+40>>2]|0;g=f[e+4>>2]|0;h=f[e>>2]|0;e=d;i=e+80|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(i|0));if((h|0)<=0){e=b;j=d;i=e+80|0;do{f[e>>2]=f[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(i|0));u=c;return}k=f[a+16>>2]|0;l=f[f[a+44>>2]>>2]|0;a=d+72|0;m=d+64|0;n=d+56|0;o=d+48|0;q=d+40|0;r=d+32|0;s=d+24|0;t=d+16|0;v=d+8|0;if((g|0)>0){w=0.0;x=0.0;y=0.0;z=0.0;A=0.0;B=0.0;C=0.0;D=0.0;E=0.0;F=0.0;G=0;while(1){H=k+(Y(l,G)|0)|0;I=0;J=0.0;K=0.0;L=0.0;M=0.0;do{N=+p[H+(I<<3)>>3];O=+(I|0);P=O*N;J=J+N;K=K+P;N=O*P;L=L+N;M=M+O*N;I=I+1|0}while((I|0)!=(g|0));N=+(G|0);O=N*J;P=+(Y(G,G)|0);Q=P*O+w;R=P*K+x;S=N*L+y;T=M+z;U=P*J+A;P=N*K+B;N=L+C;V=O+D;O=K+E;W=J+F;G=G+1|0;if((G|0)==(h|0)){X=Q;Z=R;_=S;$=T;aa=U;ba=P;ca=N;da=V;ea=O;fa=W;break}else{w=Q;x=R;y=S;z=T;A=U;B=P;C=N;D=V;E=O;F=W}}}else{F=0.0;E=0.0;D=0.0;C=0.0;B=0.0;A=0.0;G=0;while(1){z=+(G|0)*0.0;y=+(Y(G,G)|0);x=y*z+F;w=y*0.0;y=w+E;W=z+D;O=w+C;w=z+B;V=z+A;G=G+1|0;if((G|0)==(h|0)){X=x;Z=y;_=W;$=0.0;aa=O;ba=w;ca=0.0;da=V;ea=0.0;fa=0.0;break}else{F=x;E=y;D=W;C=O;B=w;A=V}}}p[a>>3]=X;p[m>>3]=Z;p[n>>3]=_;p[o>>3]=$;p[q>>3]=aa;p[r>>3]=ba;p[s>>3]=ca;p[t>>3]=da;p[v>>3]=ea;p[d>>3]=fa;e=b;j=d;i=e+80|0;do{f[e>>2]=f[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(i|0));u=c;return}function oha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;c=f[a+40>>2]|0;d=f[c+4>>2]|0;e=f[c>>2]|0;if((e|0)>0?(c=f[a+16>>2]|0,g=f[f[a+44>>2]>>2]|0,(d|0)>0):0){a=0;i=0;j=0;k=0;l=0;m=0;n=0;o=0;q=0;r=0;s=0;do{t=c+(Y(g,s)|0)|0;u=0;v=0;w=0;x=0;y=0;do{z=h[t+u>>0]|0;A=Y(z,u)|0;v=z+v|0;w=A+w|0;z=Y(A,u)|0;x=z+x|0;y=(Y(z,u)|0)+y|0;u=u+1|0}while((u|0)!=(d|0));u=Y(v,s)|0;t=Y(s,s)|0;a=a+(Y(u,t)|0)|0;i=i+(Y(w,t)|0)|0;j=j+(Y(x,s)|0)|0;k=k+y|0;l=l+(Y(v,t)|0)|0;m=m+(Y(w,s)|0)|0;n=n+x|0;o=o+u|0;q=q+w|0;r=r+v|0;s=s+1|0}while((s|0)!=(e|0));B=+(j|0);C=+(i|0);D=+(a|0);E=+(r|0);F=+(q|0);G=+(o|0);H=+(n|0);I=+(m|0);J=+(l|0);K=+(k|0)}else{B=0.0;C=0.0;D=0.0;E=0.0;F=0.0;G=0.0;H=0.0;I=0.0;J=0.0;K=0.0}p[b>>3]=E;p[b+8>>3]=F;p[b+16>>3]=G;p[b+24>>3]=H;p[b+32>>3]=I;p[b+40>>3]=J;p[b+48>>3]=K;p[b+56>>3]=B;p[b+64>>3]=C;p[b+72>>3]=D;return}function pha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0;c=f[a+40>>2]|0;d=f[c+4>>2]|0;e=f[c>>2]|0;if((e|0)>0?(c=f[a+16>>2]|0,g=f[f[a+44>>2]>>2]|0,(d|0)>0):0){a=0;h=0;i=0;k=0;l=0;m=0;n=0;o=0;q=0;r=0;s=0;t=0;u=0;v=0;w=0;x=0;y=0;z=0;A=0;B=0;C=0;do{D=c+(Y(g,C)|0)|0;E=0;F=0;G=0;H=0;I=0;K=0;do{L=j[D+(G<<1)>>1]|0;M=Y(L,G)|0;H=L+H|0;I=M+I|0;L=Y(M,G)|0;K=L+K|0;M=Y(L,G)|0;E=C1a(M|0,((M|0)<0)<<31>>31|0,E|0,F|0)|0;F=J;G=G+1|0}while((G|0)!=(d|0));G=Y(H,C)|0;D=Y(C,C)|0;M=((G|0)<0)<<31>>31;L=W1a(G|0,M|0,D|0,0)|0;a=C1a(a|0,h|0,L|0,J|0)|0;h=J;L=((I|0)<0)<<31>>31;N=W1a(I|0,L|0,D|0,0)|0;i=C1a(i|0,k|0,N|0,J|0)|0;k=J;N=((K|0)<0)<<31>>31;O=W1a(K|0,N|0,C|0,((C|0)<0)<<31>>31|0)|0;l=C1a(l|0,m|0,O|0,J|0)|0;m=J;n=C1a(n|0,o|0,E|0,F|0)|0;o=J;O=Y(H,D)|0;q=C1a(q|0,r|0,O|0,((O|0)<0)<<31>>31|0)|0;r=J;O=Y(I,C)|0;s=C1a(s|0,t|0,O|0,((O|0)<0)<<31>>31|0)|0;t=J;u=C1a(u|0,v|0,K|0,N|0)|0;v=J;w=C1a(w|0,x|0,G|0,M|0)|0;x=J;y=C1a(y|0,z|0,I|0,L|0)|0;z=J;A=C1a(A|0,B|0,H|0,((H|0)<0)<<31>>31|0)|0;B=J;C=C+1|0}while((C|0)!=(e|0));P=+(A>>>0)+4294967296.0*+(B|0);Q=+(y>>>0)+4294967296.0*+(z|0);R=+(w>>>0)+4294967296.0*+(x|0);S=+(u>>>0)+4294967296.0*+(v|0);T=+(s>>>0)+4294967296.0*+(t|0);U=+(q>>>0)+4294967296.0*+(r|0);V=+(n>>>0)+4294967296.0*+(o|0);W=+(l>>>0)+4294967296.0*+(m|0);X=+(i>>>0)+4294967296.0*+(k|0);Z=+(a>>>0)+4294967296.0*+(h|0)}else{P=0.0;Q=0.0;R=0.0;S=0.0;T=0.0;U=0.0;V=0.0;W=0.0;X=0.0;Z=0.0}p[b>>3]=P;p[b+8>>3]=Q;p[b+16>>3]=R;p[b+24>>3]=S;p[b+32>>3]=T;p[b+40>>3]=U;p[b+48>>3]=V;p[b+56>>3]=W;p[b+64>>3]=X;p[b+72>>3]=Z;return}function qha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0.0,i=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,q=0.0,r=0.0,s=0.0;c=u;u=u+16|0;d=c;_$(d,73004);e=a+160|0;g=a+176|0;h=+p[e>>3]+ +p[g>>3];i=a+168|0;j=a+184|0;k=+p[i>>3]+ +p[j>>3];l=h*h;m=k*k;n=a+144|0;o=+p[n>>3]*4.0;q=+p[a+136>>3];r=+p[a+152>>3];s=q-r;p[b>>3]=q+r;p[b+8>>3]=s*s+o*+p[n>>3];p[b+24>>3]=l+m;p[b+40>>3]=k*(h*o)+(l-m)*s;s=h*(l-m*3.0);h=k*(l*3.0-m);m=+p[e>>3]-+p[g>>3]*3.0;l=+p[i>>3]*3.0-+p[j>>3];p[b+16>>3]=m*m+l*l;p[b+32>>3]=s*m+h*l;p[b+48>>3]=s*l-h*m;if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function rha(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=u;u=u+16|0;i=h;j=h+8|0;k=d&7;l=(g|0)<0?(e|0)/2|0:g;g=(c|0)==0;if((c|1|0)!=1){f[j>>2]=0;f[j+4>>2]=0;c=c$(j,39)|0;m=317016;n=c+39|0;do{b[c>>0]=b[m>>0]|0;c=c+1|0;m=m+1|0}while((c|0)<(n|0));j$(-215,j,317056,317079,852);d$(j)}m=(k|0)==0;a:do if(g){if(m){k=NYa(16)|0;v9(k);f[k>>2]=73032;f[k+4>>2]=e;f[k+8>>2]=l;c=NYa(16)|0;n=c+4|0;f[n>>2]=1;f[c>>2]=73052;f[c+8>>2]=k;f[a>>2]=c;f[a+4>>2]=k;f[n>>2]=(f[n>>2]|0)+1;k=f[n>>2]|0;f[n>>2]=k+-1;if((k|0)!=1){u=h;return}ki[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}switch(d&7){case 2:{c=NYa(16)|0;v9(c);f[c>>2]=73072;f[c+4>>2]=e;f[c+8>>2]=l;k=NYa(16)|0;n=k+4|0;f[n>>2]=1;f[k>>2]=73092;f[k+8>>2]=c;f[a>>2]=k;f[a+4>>2]=c;f[n>>2]=(f[n>>2]|0)+1;c=f[n>>2]|0;f[n>>2]=c+-1;if((c|0)!=1){u=h;return}ki[f[(f[k>>2]|0)+8>>2]&2047](k);u=h;return}case 3:{k=NYa(16)|0;v9(k);f[k>>2]=73112;f[k+4>>2]=e;f[k+8>>2]=l;c=NYa(16)|0;n=c+4|0;f[n>>2]=1;f[c>>2]=73132;f[c+8>>2]=k;f[a>>2]=c;f[a+4>>2]=k;f[n>>2]=(f[n>>2]|0)+1;k=f[n>>2]|0;f[n>>2]=k+-1;if((k|0)!=1){u=h;return}ki[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}case 5:{c=NYa(16)|0;v9(c);f[c>>2]=73152;f[c+4>>2]=e;f[c+8>>2]=l;k=NYa(16)|0;n=k+4|0;f[n>>2]=1;f[k>>2]=73172;f[k+8>>2]=c;f[a>>2]=k;f[a+4>>2]=c;f[n>>2]=(f[n>>2]|0)+1;c=f[n>>2]|0;f[n>>2]=c+-1;if((c|0)!=1){u=h;return}ki[f[(f[k>>2]|0)+8>>2]&2047](k);u=h;return}case 6:{k=NYa(16)|0;v9(k);f[k>>2]=73192;f[k+4>>2]=e;f[k+8>>2]=l;c=NYa(16)|0;n=c+4|0;f[n>>2]=1;f[c>>2]=73212;f[c+8>>2]=k;f[a>>2]=c;f[a+4>>2]=k;f[n>>2]=(f[n>>2]|0)+1;k=f[n>>2]|0;f[n>>2]=k+-1;if((k|0)!=1){u=h;return}ki[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}default:break a}}else{if(m){c=NYa(16)|0;v9(c);f[c>>2]=73232;f[c+4>>2]=e;f[c+8>>2]=l;k=NYa(16)|0;n=k+4|0;f[n>>2]=1;f[k>>2]=73252;f[k+8>>2]=c;f[a>>2]=k;f[a+4>>2]=c;f[n>>2]=(f[n>>2]|0)+1;c=f[n>>2]|0;f[n>>2]=c+-1;if((c|0)!=1){u=h;return}ki[f[(f[k>>2]|0)+8>>2]&2047](k);u=h;return}switch(d&7){case 2:{k=NYa(16)|0;v9(k);f[k>>2]=73272;f[k+4>>2]=e;f[k+8>>2]=l;c=NYa(16)|0;n=c+4|0;f[n>>2]=1;f[c>>2]=73292;f[c+8>>2]=k;f[a>>2]=c;f[a+4>>2]=k;f[n>>2]=(f[n>>2]|0)+1;k=f[n>>2]|0;f[n>>2]=k+-1;if((k|0)!=1){u=h;return}ki[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}case 3:{c=NYa(16)|0;v9(c);f[c>>2]=73312;f[c+4>>2]=e;f[c+8>>2]=l;k=NYa(16)|0;n=k+4|0;f[n>>2]=1;f[k>>2]=73332;f[k+8>>2]=c;f[a>>2]=k;f[a+4>>2]=c;f[n>>2]=(f[n>>2]|0)+1;c=f[n>>2]|0;f[n>>2]=c+-1;if((c|0)!=1){u=h;return}ki[f[(f[k>>2]|0)+8>>2]&2047](k);u=h;return}case 5:{k=NYa(16)|0;v9(k);f[k>>2]=73352;f[k+4>>2]=e;f[k+8>>2]=l;c=NYa(16)|0;n=c+4|0;f[n>>2]=1;f[c>>2]=73372;f[c+8>>2]=k;f[a>>2]=c;f[a+4>>2]=k;f[n>>2]=(f[n>>2]|0)+1;k=f[n>>2]|0;f[n>>2]=k+-1;if((k|0)!=1){u=h;return}ki[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}case 6:{c=NYa(16)|0;v9(c);f[c>>2]=73392;f[c+4>>2]=e;f[c+8>>2]=l;k=NYa(16)|0;n=k+4|0;f[n>>2]=1;f[k>>2]=73412;f[k+8>>2]=c;f[a>>2]=k;f[a+4>>2]=c;f[n>>2]=(f[n>>2]|0)+1;c=f[n>>2]|0;f[n>>2]=c+-1;if((c|0)!=1){u=h;return}ki[f[(f[k>>2]|0)+8>>2]&2047](k);u=h;return}default:break a}}while(0);f[i>>2]=d;p$(j,317129,i);j$(-213,j,317056,317079,890);d$(j);f[a>>2]=0;f[a+4>>2]=0;u=h;return}function sha(a){a=a|0;PYa(a);return}function tha(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function uha(a){a=a|0;PYa(a);return}function vha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0.0;g=Y(f[a+4>>2]|0,e)|0;a=Y(e,d)|0;if((g|0)==(e|0)){if((a|0)>0)h=0;else return;do{p[c+(h<<3)>>3]=+p[b+(h<<3)>>3];h=h+1|0}while((h|0)!=(a|0));return}if((e|0)<=0)return;h=e<<1;d=a-h|0;i=(d|0)<0;j=(g|0)>(e|0);k=(h|0)<(g|0);l=c;c=b;b=0;while(1){a:do if(i)m=0;else{if(k)n=0;else{o=0;while(1){q=c+(o<<3)|0;r=+p[q+(e<<3)>>3];s=+p[q>>3];p[l+(o<<3)>>3]=r<s?s:r;s=+p[q+(h<<3)>>3];p[l+(o+e<<3)>>3]=r<s?s:r;q=o+h|0;if((q|0)>(d|0)){m=q;break a}else o=q}}while(1){o=c+(n<<3)|0;q=h;r=+p[o+(e<<3)>>3];do{s=+p[o+(q<<3)>>3];r=r<s?s:r;q=q+e|0}while((q|0)<(g|0));s=+p[o>>3];p[l+(n<<3)>>3]=r<s?s:r;s=+p[o+(q<<3)>>3];p[l+(n+e<<3)>>3]=r<s?s:r;t=n+h|0;if((t|0)>(d|0)){m=t;break}else n=t}}while(0);b:do if((m|0)<(a|0)){if(j)u=m;else{t=m;while(1){p[l+(t<<3)>>3]=+p[c+(t<<3)>>3];t=t+e|0;if((t|0)>=(a|0))break b}}do{t=c+(u<<3)|0;v=e;s=+p[t>>3];do{w=+p[t+(v<<3)>>3];s=s<w?w:s;v=v+e|0}while((v|0)<(g|0));p[l+(u<<3)>>3]=s;u=u+e|0}while((u|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(e|0))break;else{l=l+8|0;c=c+8|0}}return}function wha(a){a=a|0;PYa(a);return}function xha(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function yha(a){a=a|0;PYa(a);return}function zha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0.0;g=Y(f[a+4>>2]|0,e)|0;a=Y(e,d)|0;if((g|0)==(e|0)){if((a|0)>0)h=0;else return;do{f[c+(h<<2)>>2]=f[b+(h<<2)>>2];h=h+1|0}while((h|0)!=(a|0));return}if((e|0)<=0)return;h=e<<1;d=a-h|0;i=(d|0)<0;j=(g|0)>(e|0);k=(h|0)<(g|0);l=c;c=b;b=0;while(1){a:do if(i)m=0;else{if(k)o=0;else{p=0;while(1){q=c+(p<<2)|0;r=+n[q+(e<<2)>>2];s=+n[q>>2];n[l+(p<<2)>>2]=r<s?s:r;s=+n[q+(h<<2)>>2];n[l+(p+e<<2)>>2]=r<s?s:r;q=p+h|0;if((q|0)>(d|0)){m=q;break a}else p=q}}while(1){p=c+(o<<2)|0;q=h;r=+n[p+(e<<2)>>2];do{s=+n[p+(q<<2)>>2];r=r<s?s:r;q=q+e|0}while((q|0)<(g|0));s=+n[p>>2];n[l+(o<<2)>>2]=r<s?s:r;s=+n[p+(q<<2)>>2];n[l+(o+e<<2)>>2]=r<s?s:r;t=o+h|0;if((t|0)>(d|0)){m=t;break}else o=t}}while(0);b:do if((m|0)<(a|0)){if(j)u=m;else{t=m;while(1){f[l+(t<<2)>>2]=f[c+(t<<2)>>2];t=t+e|0;if((t|0)>=(a|0))break b}}do{t=c+(u<<2)|0;v=e;s=+n[t>>2];do{w=+n[t+(v<<2)>>2];s=s<w?w:s;v=v+e|0}while((v|0)<(g|0));n[l+(u<<2)>>2]=s;u=u+e|0}while((u|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(e|0))break;else{l=l+4|0;c=c+4|0}}return}function Aha(a){a=a|0;PYa(a);return}function Bha(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Cha(a){a=a|0;PYa(a);return}function Dha(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((h|0)==(g|0)){if((a|0)>0)i=0;else return;do{d[c+(i<<1)>>1]=d[b+(i<<1)>>1]|0;i=i+1|0}while((i|0)!=(a|0));return}if((g|0)<=0)return;i=g<<1;e=a-i|0;j=(e|0)<0;k=(h|0)>(g|0);l=(i|0)<(h|0);m=c;c=b;b=0;while(1){a:do if(j)n=0;else{if(l)o=0;else{p=0;while(1){q=c+(p<<1)|0;r=d[q+(g<<1)>>1]|0;s=d[q>>1]|0;d[m+(p<<1)>>1]=r<<16>>16<s<<16>>16?s:r;s=d[q+(i<<1)>>1]|0;d[m+(p+g<<1)>>1]=r<<16>>16<s<<16>>16?s:r;r=p+i|0;if((r|0)>(e|0)){n=r;break a}else p=r}}while(1){p=c+(o<<1)|0;r=i;s=d[p+(g<<1)>>1]|0;do{q=d[p+(r<<1)>>1]|0;s=s<<16>>16<q<<16>>16?q:s;r=r+g|0}while((r|0)<(h|0));q=d[p>>1]|0;d[m+(o<<1)>>1]=s<<16>>16<q<<16>>16?q:s;q=d[p+(r<<1)>>1]|0;d[m+(o+g<<1)>>1]=s<<16>>16<q<<16>>16?q:s;q=o+i|0;if((q|0)>(e|0)){n=q;break}else o=q}}while(0);b:do if((n|0)<(a|0)){if(k)t=n;else{q=n;while(1){d[m+(q<<1)>>1]=d[c+(q<<1)>>1]|0;q=q+g|0;if((q|0)>=(a|0))break b}}do{q=c+(t<<1)|0;u=g;v=d[q>>1]|0;do{w=d[q+(u<<1)>>1]|0;v=v<<16>>16<w<<16>>16?w:v;u=u+g|0}while((u|0)<(h|0));d[m+(t<<1)>>1]=v;t=t+g|0}while((t|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(g|0))break;else{m=m+2|0;c=c+2|0}}return}function Eha(a){a=a|0;PYa(a);return}function Fha(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Gha(a){a=a|0;PYa(a);return}function Hha(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((h|0)==(g|0)){if((a|0)>0)i=0;else return;do{d[c+(i<<1)>>1]=d[b+(i<<1)>>1]|0;i=i+1|0}while((i|0)!=(a|0));return}if((g|0)<=0)return;i=g<<1;e=a-i|0;j=(e|0)<0;k=(h|0)>(g|0);l=(i|0)<(h|0);m=c;c=b;b=0;while(1){a:do if(j)n=0;else{if(l)o=0;else{p=0;while(1){q=c+(p<<1)|0;r=d[q+(g<<1)>>1]|0;s=d[q>>1]|0;d[m+(p<<1)>>1]=(r&65535)<(s&65535)?s:r;s=d[q+(i<<1)>>1]|0;d[m+(p+g<<1)>>1]=(r&65535)<(s&65535)?s:r;r=p+i|0;if((r|0)>(e|0)){n=r;break a}else p=r}}while(1){p=c+(o<<1)|0;r=i;s=d[p+(g<<1)>>1]|0;do{q=d[p+(r<<1)>>1]|0;s=(s&65535)<(q&65535)?q:s;r=r+g|0}while((r|0)<(h|0));q=d[p>>1]|0;d[m+(o<<1)>>1]=(s&65535)<(q&65535)?q:s;q=d[p+(r<<1)>>1]|0;d[m+(o+g<<1)>>1]=(s&65535)<(q&65535)?q:s;q=o+i|0;if((q|0)>(e|0)){n=q;break}else o=q}}while(0);b:do if((n|0)<(a|0)){if(k)t=n;else{q=n;while(1){d[m+(q<<1)>>1]=d[c+(q<<1)>>1]|0;q=q+g|0;if((q|0)>=(a|0))break b}}do{q=c+(t<<1)|0;u=g;v=d[q>>1]|0;do{w=d[q+(u<<1)>>1]|0;v=(v&65535)<(w&65535)?w:v;u=u+g|0}while((u|0)<(h|0));d[m+(t<<1)>>1]=v;t=t+g|0}while((t|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(g|0))break;else{m=m+2|0;c=c+2|0}}return}function Iha(a){a=a|0;PYa(a);return}function Jha(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Kha(a){a=a|0;PYa(a);return}function Lha(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((i|0)==(g|0)){if((a|0)>0)j=0;else return;do{b[d+j>>0]=b[c+j>>0]|0;j=j+1|0}while((j|0)!=(a|0));return}if((g|0)<=0)return;j=g<<1;e=a-j|0;k=(e|0)<0;l=(i|0)>(g|0);m=(j|0)<(i|0);n=d;d=c;c=0;while(1){a:do if(k)o=0;else{if(m)p=0;else{q=0;while(1){r=d+q|0;s=h[r+g>>0]|0;t=(h[r>>0]|0)-s+256|0;if(t>>>0<769)u=h[331268+t>>0]|0;else u=0;b[n+q>>0]=u+s;t=(h[r+j>>0]|0)-s+256|0;if(t>>>0<769)v=h[331268+t>>0]|0;else v=0;b[n+(q+g)>>0]=v+s;s=q+j|0;if((s|0)>(e|0)){o=s;break a}else q=s}}while(1){q=d+p|0;s=j;t=b[q+g>>0]|0;while(1){r=t&255;w=(h[q+s>>0]|0)-r+256|0;if(w>>>0<769)x=h[331268+w>>0]|0;else x=0;y=x+r|0;s=s+g|0;if((s|0)>=(i|0))break;else t=y&255}t=y&255;r=(h[q>>0]|0)-t+256|0;if(r>>>0<769)z=h[331268+r>>0]|0;else z=0;b[n+p>>0]=z+y;r=(h[q+s>>0]|0)-t+256|0;if(r>>>0<769)A=h[331268+r>>0]|0;else A=0;b[n+(p+g)>>0]=A+y;r=p+j|0;if((r|0)>(e|0)){o=r;break}else p=r}}while(0);b:do if((o|0)<(a|0)){if(l)B=o;else{r=o;while(1){b[n+r>>0]=b[d+r>>0]|0;r=r+g|0;if((r|0)>=(a|0))break b}}do{r=d+B|0;t=g;w=b[r>>0]|0;do{C=w&255;D=(h[r+t>>0]|0)-C+256|0;if(D>>>0<769)E=h[331268+D>>0]|0;else E=0;w=E+C&255;t=t+g|0}while((t|0)<(i|0));b[n+B>>0]=w;B=B+g|0}while((B|0)<(a|0))}while(0);c=c+1|0;if((c|0)==(g|0))break;else{n=n+1|0;d=d+1|0}}return}function Mha(a){a=a|0;PYa(a);return}function Nha(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Oha(a){a=a|0;PYa(a);return}function Pha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0.0;g=Y(f[a+4>>2]|0,e)|0;a=Y(e,d)|0;if((g|0)==(e|0)){if((a|0)>0)h=0;else return;do{p[c+(h<<3)>>3]=+p[b+(h<<3)>>3];h=h+1|0}while((h|0)!=(a|0));return}if((e|0)<=0)return;h=e<<1;d=a-h|0;i=(d|0)<0;j=(g|0)>(e|0);k=(h|0)<(g|0);l=c;c=b;b=0;while(1){a:do if(i)m=0;else{if(k)n=0;else{o=0;while(1){q=c+(o<<3)|0;r=+p[q+(e<<3)>>3];s=+p[q>>3];p[l+(o<<3)>>3]=s<r?s:r;s=+p[q+(h<<3)>>3];p[l+(o+e<<3)>>3]=s<r?s:r;q=o+h|0;if((q|0)>(d|0)){m=q;break a}else o=q}}while(1){o=c+(n<<3)|0;q=h;r=+p[o+(e<<3)>>3];do{s=+p[o+(q<<3)>>3];r=s<r?s:r;q=q+e|0}while((q|0)<(g|0));s=+p[o>>3];p[l+(n<<3)>>3]=s<r?s:r;s=+p[o+(q<<3)>>3];p[l+(n+e<<3)>>3]=s<r?s:r;t=n+h|0;if((t|0)>(d|0)){m=t;break}else n=t}}while(0);b:do if((m|0)<(a|0)){if(j)u=m;else{t=m;while(1){p[l+(t<<3)>>3]=+p[c+(t<<3)>>3];t=t+e|0;if((t|0)>=(a|0))break b}}do{t=c+(u<<3)|0;v=e;s=+p[t>>3];do{w=+p[t+(v<<3)>>3];s=w<s?w:s;v=v+e|0}while((v|0)<(g|0));p[l+(u<<3)>>3]=s;u=u+e|0}while((u|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(e|0))break;else{l=l+8|0;c=c+8|0}}return}function Qha(a){a=a|0;PYa(a);return}function Rha(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Sha(a){a=a|0;PYa(a);return}function Tha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0.0;g=Y(f[a+4>>2]|0,e)|0;a=Y(e,d)|0;if((g|0)==(e|0)){if((a|0)>0)h=0;else return;do{f[c+(h<<2)>>2]=f[b+(h<<2)>>2];h=h+1|0}while((h|0)!=(a|0));return}if((e|0)<=0)return;h=e<<1;d=a-h|0;i=(d|0)<0;j=(g|0)>(e|0);k=(h|0)<(g|0);l=c;c=b;b=0;while(1){a:do if(i)m=0;else{if(k)o=0;else{p=0;while(1){q=c+(p<<2)|0;r=+n[q+(e<<2)>>2];s=+n[q>>2];n[l+(p<<2)>>2]=s<r?s:r;s=+n[q+(h<<2)>>2];n[l+(p+e<<2)>>2]=s<r?s:r;q=p+h|0;if((q|0)>(d|0)){m=q;break a}else p=q}}while(1){p=c+(o<<2)|0;q=h;r=+n[p+(e<<2)>>2];do{s=+n[p+(q<<2)>>2];r=s<r?s:r;q=q+e|0}while((q|0)<(g|0));s=+n[p>>2];n[l+(o<<2)>>2]=s<r?s:r;s=+n[p+(q<<2)>>2];n[l+(o+e<<2)>>2]=s<r?s:r;t=o+h|0;if((t|0)>(d|0)){m=t;break}else o=t}}while(0);b:do if((m|0)<(a|0)){if(j)u=m;else{t=m;while(1){f[l+(t<<2)>>2]=f[c+(t<<2)>>2];t=t+e|0;if((t|0)>=(a|0))break b}}do{t=c+(u<<2)|0;v=e;s=+n[t>>2];do{w=+n[t+(v<<2)>>2];s=w<s?w:s;v=v+e|0}while((v|0)<(g|0));n[l+(u<<2)>>2]=s;u=u+e|0}while((u|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(e|0))break;else{l=l+4|0;c=c+4|0}}return}function Uha(a){a=a|0;PYa(a);return}function Vha(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Wha(a){a=a|0;PYa(a);return}function Xha(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((h|0)==(g|0)){if((a|0)>0)i=0;else return;do{d[c+(i<<1)>>1]=d[b+(i<<1)>>1]|0;i=i+1|0}while((i|0)!=(a|0));return}if((g|0)<=0)return;i=g<<1;e=a-i|0;j=(e|0)<0;k=(h|0)>(g|0);l=(i|0)<(h|0);m=c;c=b;b=0;while(1){a:do if(j)n=0;else{if(l)o=0;else{p=0;while(1){q=c+(p<<1)|0;r=d[q+(g<<1)>>1]|0;s=d[q>>1]|0;d[m+(p<<1)>>1]=s<<16>>16<r<<16>>16?s:r;s=d[q+(i<<1)>>1]|0;d[m+(p+g<<1)>>1]=s<<16>>16<r<<16>>16?s:r;r=p+i|0;if((r|0)>(e|0)){n=r;break a}else p=r}}while(1){p=c+(o<<1)|0;r=i;s=d[p+(g<<1)>>1]|0;do{q=d[p+(r<<1)>>1]|0;s=q<<16>>16<s<<16>>16?q:s;r=r+g|0}while((r|0)<(h|0));q=d[p>>1]|0;d[m+(o<<1)>>1]=q<<16>>16<s<<16>>16?q:s;q=d[p+(r<<1)>>1]|0;d[m+(o+g<<1)>>1]=q<<16>>16<s<<16>>16?q:s;q=o+i|0;if((q|0)>(e|0)){n=q;break}else o=q}}while(0);b:do if((n|0)<(a|0)){if(k)t=n;else{q=n;while(1){d[m+(q<<1)>>1]=d[c+(q<<1)>>1]|0;q=q+g|0;if((q|0)>=(a|0))break b}}do{q=c+(t<<1)|0;u=g;v=d[q>>1]|0;do{w=d[q+(u<<1)>>1]|0;v=w<<16>>16<v<<16>>16?w:v;u=u+g|0}while((u|0)<(h|0));d[m+(t<<1)>>1]=v;t=t+g|0}while((t|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(g|0))break;else{m=m+2|0;c=c+2|0}}return}function Yha(a){a=a|0;PYa(a);return}function Zha(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function _ha(a){a=a|0;PYa(a);return}function $ha(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((h|0)==(g|0)){if((a|0)>0)i=0;else return;do{d[c+(i<<1)>>1]=d[b+(i<<1)>>1]|0;i=i+1|0}while((i|0)!=(a|0));return}if((g|0)<=0)return;i=g<<1;e=a-i|0;j=(e|0)<0;k=(h|0)>(g|0);l=(i|0)<(h|0);m=c;c=b;b=0;while(1){a:do if(j)n=0;else{if(l)o=0;else{p=0;while(1){q=c+(p<<1)|0;r=d[q+(g<<1)>>1]|0;s=d[q>>1]|0;d[m+(p<<1)>>1]=(s&65535)<(r&65535)?s:r;s=d[q+(i<<1)>>1]|0;d[m+(p+g<<1)>>1]=(s&65535)<(r&65535)?s:r;r=p+i|0;if((r|0)>(e|0)){n=r;break a}else p=r}}while(1){p=c+(o<<1)|0;r=i;s=d[p+(g<<1)>>1]|0;do{q=d[p+(r<<1)>>1]|0;s=(q&65535)<(s&65535)?q:s;r=r+g|0}while((r|0)<(h|0));q=d[p>>1]|0;d[m+(o<<1)>>1]=(q&65535)<(s&65535)?q:s;q=d[p+(r<<1)>>1]|0;d[m+(o+g<<1)>>1]=(q&65535)<(s&65535)?q:s;q=o+i|0;if((q|0)>(e|0)){n=q;break}else o=q}}while(0);b:do if((n|0)<(a|0)){if(k)t=n;else{q=n;while(1){d[m+(q<<1)>>1]=d[c+(q<<1)>>1]|0;q=q+g|0;if((q|0)>=(a|0))break b}}do{q=c+(t<<1)|0;u=g;v=d[q>>1]|0;do{w=d[q+(u<<1)>>1]|0;v=(w&65535)<(v&65535)?w:v;u=u+g|0}while((u|0)<(h|0));d[m+(t<<1)>>1]=v;t=t+g|0}while((t|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(g|0))break;else{m=m+2|0;c=c+2|0}}return}function aia(a){a=a|0;PYa(a);return}function bia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function cia(a){a=a|0;PYa(a);return}function dia(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((i|0)==(g|0)){if((a|0)>0)j=0;else return;do{b[d+j>>0]=b[c+j>>0]|0;j=j+1|0}while((j|0)!=(a|0));return}if((g|0)<=0)return;j=g<<1;e=a-j|0;k=(e|0)<0;l=(i|0)>(g|0);m=(j|0)<(i|0);n=d;d=c;c=0;while(1){a:do if(k)o=0;else{if(m)p=0;else{q=0;while(1){r=d+q|0;s=h[r+g>>0]|0;t=s-(h[r>>0]|0)+256|0;if(t>>>0<769)u=h[331268+t>>0]|0;else u=0;b[n+q>>0]=s-u;t=s-(h[r+j>>0]|0)+256|0;if(t>>>0<769)v=h[331268+t>>0]|0;else v=0;b[n+(q+g)>>0]=s-v;s=q+j|0;if((s|0)>(e|0)){o=s;break a}else q=s}}while(1){q=d+p|0;s=j;t=b[q+g>>0]|0;while(1){r=t&255;w=r-(h[q+s>>0]|0)+256|0;if(w>>>0<769)x=h[331268+w>>0]|0;else x=0;y=r-x|0;s=s+g|0;if((s|0)>=(i|0))break;else t=y&255}t=y&255;r=t-(h[q>>0]|0)+256|0;if(r>>>0<769)z=h[331268+r>>0]|0;else z=0;b[n+p>>0]=y-z;r=t-(h[q+s>>0]|0)+256|0;if(r>>>0<769)A=h[331268+r>>0]|0;else A=0;b[n+(p+g)>>0]=y-A;r=p+j|0;if((r|0)>(e|0)){o=r;break}else p=r}}while(0);b:do if((o|0)<(a|0)){if(l)B=o;else{r=o;while(1){b[n+r>>0]=b[d+r>>0]|0;r=r+g|0;if((r|0)>=(a|0))break b}}do{r=d+B|0;t=g;w=b[r>>0]|0;do{C=w&255;D=C-(h[r+t>>0]|0)+256|0;if(D>>>0<769)E=h[331268+D>>0]|0;else E=0;w=C-E&255;t=t+g|0}while((t|0)<(i|0));b[n+B>>0]=w;B=B+g|0}while((B|0)<(a|0))}while(0);c=c+1|0;if((c|0)==(g|0))break;else{n=n+1|0;d=d+1|0}}return}function eia(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=u;u=u+16|0;i=h;j=h+8|0;k=d&7;l=(g|0)<0?(e|0)/2|0:g;g=(c|0)==0;if((c|1|0)!=1){f[j>>2]=0;f[j+4>>2]=0;c=c$(j,39)|0;m=317016;n=c+39|0;do{b[c>>0]=b[m>>0]|0;c=c+1|0;m=m+1|0}while((c|0)<(n|0));j$(-215,j,318797,317079,899);d$(j)}m=(k|0)==0;a:do if(g){if(m){k=NYa(16)|0;w9(k);f[k>>2]=73432;f[k+4>>2]=e;f[k+8>>2]=l;c=NYa(16)|0;n=c+4|0;f[n>>2]=1;f[c>>2]=73456;f[c+8>>2]=k;f[a>>2]=c;f[a+4>>2]=k;f[n>>2]=(f[n>>2]|0)+1;k=f[n>>2]|0;f[n>>2]=k+-1;if((k|0)!=1){u=h;return}ki[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}switch(d&7){case 2:{c=NYa(16)|0;w9(c);f[c>>2]=73476;f[c+4>>2]=e;f[c+8>>2]=l;k=NYa(16)|0;n=k+4|0;f[n>>2]=1;f[k>>2]=73500;f[k+8>>2]=c;f[a>>2]=k;f[a+4>>2]=c;f[n>>2]=(f[n>>2]|0)+1;c=f[n>>2]|0;f[n>>2]=c+-1;if((c|0)!=1){u=h;return}ki[f[(f[k>>2]|0)+8>>2]&2047](k);u=h;return}case 3:{k=NYa(16)|0;w9(k);f[k>>2]=73520;f[k+4>>2]=e;f[k+8>>2]=l;c=NYa(16)|0;n=c+4|0;f[n>>2]=1;f[c>>2]=73544;f[c+8>>2]=k;f[a>>2]=c;f[a+4>>2]=k;f[n>>2]=(f[n>>2]|0)+1;k=f[n>>2]|0;f[n>>2]=k+-1;if((k|0)!=1){u=h;return}ki[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}case 5:{c=NYa(16)|0;w9(c);f[c>>2]=73564;f[c+4>>2]=e;f[c+8>>2]=l;k=NYa(16)|0;n=k+4|0;f[n>>2]=1;f[k>>2]=73588;f[k+8>>2]=c;f[a>>2]=k;f[a+4>>2]=c;f[n>>2]=(f[n>>2]|0)+1;c=f[n>>2]|0;f[n>>2]=c+-1;if((c|0)!=1){u=h;return}ki[f[(f[k>>2]|0)+8>>2]&2047](k);u=h;return}case 6:{k=NYa(16)|0;w9(k);f[k>>2]=73608;f[k+4>>2]=e;f[k+8>>2]=l;c=NYa(16)|0;n=c+4|0;f[n>>2]=1;f[c>>2]=73632;f[c+8>>2]=k;f[a>>2]=c;f[a+4>>2]=k;f[n>>2]=(f[n>>2]|0)+1;k=f[n>>2]|0;f[n>>2]=k+-1;if((k|0)!=1){u=h;return}ki[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}default:break a}}else{if(m){c=NYa(16)|0;w9(c);f[c>>2]=73652;f[c+4>>2]=e;f[c+8>>2]=l;k=NYa(16)|0;n=k+4|0;f[n>>2]=1;f[k>>2]=73676;f[k+8>>2]=c;f[a>>2]=k;f[a+4>>2]=c;f[n>>2]=(f[n>>2]|0)+1;c=f[n>>2]|0;f[n>>2]=c+-1;if((c|0)!=1){u=h;return}ki[f[(f[k>>2]|0)+8>>2]&2047](k);u=h;return}switch(d&7){case 2:{k=NYa(16)|0;w9(k);f[k>>2]=73696;f[k+4>>2]=e;f[k+8>>2]=l;c=NYa(16)|0;n=c+4|0;f[n>>2]=1;f[c>>2]=73720;f[c+8>>2]=k;f[a>>2]=c;f[a+4>>2]=k;f[n>>2]=(f[n>>2]|0)+1;k=f[n>>2]|0;f[n>>2]=k+-1;if((k|0)!=1){u=h;return}ki[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}case 3:{c=NYa(16)|0;w9(c);f[c>>2]=73740;f[c+4>>2]=e;f[c+8>>2]=l;k=NYa(16)|0;n=k+4|0;f[n>>2]=1;f[k>>2]=73764;f[k+8>>2]=c;f[a>>2]=k;f[a+4>>2]=c;f[n>>2]=(f[n>>2]|0)+1;c=f[n>>2]|0;f[n>>2]=c+-1;if((c|0)!=1){u=h;return}ki[f[(f[k>>2]|0)+8>>2]&2047](k);u=h;return}case 5:{k=NYa(16)|0;w9(k);f[k>>2]=73784;f[k+4>>2]=e;f[k+8>>2]=l;c=NYa(16)|0;n=c+4|0;f[n>>2]=1;f[c>>2]=73808;f[c+8>>2]=k;f[a>>2]=c;f[a+4>>2]=k;f[n>>2]=(f[n>>2]|0)+1;k=f[n>>2]|0;f[n>>2]=k+-1;if((k|0)!=1){u=h;return}ki[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}case 6:{c=NYa(16)|0;w9(c);f[c>>2]=73828;f[c+4>>2]=e;f[c+8>>2]=l;k=NYa(16)|0;n=k+4|0;f[n>>2]=1;f[k>>2]=73852;f[k+8>>2]=c;f[a>>2]=k;f[a+4>>2]=c;f[n>>2]=(f[n>>2]|0)+1;c=f[n>>2]|0;f[n>>2]=c+-1;if((c|0)!=1){u=h;return}ki[f[(f[k>>2]|0)+8>>2]&2047](k);u=h;return}default:break a}}while(0);f[i>>2]=d;p$(j,317129,i);j$(-213,j,318797,317079,937);d$(j);f[a>>2]=0;f[a+4>>2]=0;u=h;return}function fia(a){a=a|0;PYa(a);return}function gia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function hia(a){a=a|0;PYa(a);return}function iia(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;h=f[a+4>>2]|0;a=d>>>3;d=(h|0)>1;if(d&(e|0)>1){i=g+-4|0;j=(g|0)<4;k=(h|0)>2;l=a<<1;m=g&-4;n=c;o=e;q=b;while(1){a:do if(j)r=0;else{s=f[q+4>>2]|0;t=f[q>>2]|0;if(!k){u=f[q+8>>2]|0;v=0;while(1){w=s+(v<<3)|0;x=+p[w>>3];y=+p[w+8>>3];z=+p[w+16>>3];A=+p[w+24>>3];w=t+(v<<3)|0;B=+p[w>>3];p[n+(v<<3)>>3]=x<B?B:x;B=+p[w+8>>3];p[n+((v|1)<<3)>>3]=y<B?B:y;B=+p[w+16>>3];p[n+((v|2)<<3)>>3]=z<B?B:z;B=+p[w+24>>3];p[n+((v|3)<<3)>>3]=A<B?B:A;w=u+(v<<3)|0;B=+p[w>>3];C=v+a|0;p[n+(C<<3)>>3]=x<B?B:x;x=+p[w+8>>3];p[n+(C+1<<3)>>3]=y<x?x:y;y=+p[w+16>>3];p[n+(C+2<<3)>>3]=z<y?y:z;z=+p[w+24>>3];p[n+(C+3<<3)>>3]=A<z?z:A;v=v+4|0;if((v|0)>(i|0)){r=m;break a}}}v=f[q+(h<<2)>>2]|0;u=0;do{C=s+(u<<3)|0;w=2;A=+p[C>>3];z=+p[C+8>>3];y=+p[C+16>>3];x=+p[C+24>>3];do{C=(f[q+(w<<2)>>2]|0)+(u<<3)|0;B=+p[C>>3];A=A<B?B:A;B=+p[C+8>>3];z=z<B?B:z;B=+p[C+16>>3];y=y<B?B:y;B=+p[C+24>>3];x=x<B?B:x;w=w+1|0}while((w|0)!=(h|0));w=t+(u<<3)|0;B=+p[w>>3];p[n+(u<<3)>>3]=A<B?B:A;B=+p[w+8>>3];p[n+((u|1)<<3)>>3]=z<B?B:z;B=+p[w+16>>3];p[n+((u|2)<<3)>>3]=y<B?B:y;B=+p[w+24>>3];p[n+((u|3)<<3)>>3]=x<B?B:x;w=v+(u<<3)|0;B=+p[w>>3];C=u+a|0;p[n+(C<<3)>>3]=A<B?B:A;B=+p[w+8>>3];p[n+(C+1<<3)>>3]=z<B?B:z;B=+p[w+16>>3];p[n+(C+2<<3)>>3]=y<B?B:y;B=+p[w+24>>3];p[n+(C+3<<3)>>3]=x<B?B:x;u=u+4|0}while((u|0)<=(i|0));r=m}while(0);b:do if((r|0)<(g|0)){u=f[q+4>>2]|0;v=f[q>>2]|0;if(!k){t=f[q+8>>2]|0;s=r;while(1){B=+p[u+(s<<3)>>3];D=+p[v+(s<<3)>>3];p[n+(s<<3)>>3]=B<D?D:B;D=+p[t+(s<<3)>>3];p[n+(s+a<<3)>>3]=B<D?D:B;s=s+1|0;if((s|0)==(g|0))break b}}s=f[q+(h<<2)>>2]|0;t=r;do{C=2;B=+p[u+(t<<3)>>3];do{D=+p[(f[q+(C<<2)>>2]|0)+(t<<3)>>3];B=B<D?D:B;C=C+1|0}while((C|0)!=(h|0));x=+p[v+(t<<3)>>3];p[n+(t<<3)>>3]=B<x?x:B;x=+p[s+(t<<3)>>3];p[n+(t+a<<3)>>3]=B<x?x:B;t=t+1|0}while((t|0)!=(g|0))}while(0);t=o+-2|0;s=n+(l<<3)|0;v=q+8|0;if((t|0)>1){n=s;o=t;q=v}else{E=s;F=t;G=v;break}}}else{E=c;F=e;G=b}if((F|0)<=0)return;b=g+-4|0;e=(g|0)<4;c=g&-4;q=E;E=F;F=G;while(1){c:do if(e)H=0;else{G=f[F>>2]|0;if(d)I=0;else{o=0;while(1){n=G+(o<<3)|0;x=+p[n+8>>3];y=+p[n+16>>3];z=+p[n+24>>3];p[q+(o<<3)>>3]=+p[n>>3];p[q+((o|1)<<3)>>3]=x;p[q+((o|2)<<3)>>3]=y;p[q+((o|3)<<3)>>3]=z;o=o+4|0;if((o|0)>(b|0)){H=c;break c}}}do{o=G+(I<<3)|0;n=1;z=+p[o>>3];y=+p[o+8>>3];x=+p[o+16>>3];A=+p[o+24>>3];do{o=(f[F+(n<<2)>>2]|0)+(I<<3)|0;D=+p[o>>3];z=z<D?D:z;D=+p[o+8>>3];y=y<D?D:y;D=+p[o+16>>3];x=x<D?D:x;D=+p[o+24>>3];A=A<D?D:A;n=n+1|0}while((n|0)!=(h|0));p[q+(I<<3)>>3]=z;p[q+((I|1)<<3)>>3]=y;p[q+((I|2)<<3)>>3]=x;p[q+((I|3)<<3)>>3]=A;I=I+4|0}while((I|0)<=(b|0));H=c}while(0);d:do if((H|0)<(g|0)){G=f[F>>2]|0;if(d)J=H;else{n=H;while(1){p[q+(n<<3)>>3]=+p[G+(n<<3)>>3];n=n+1|0;if((n|0)==(g|0))break d}}do{n=1;B=+p[G+(J<<3)>>3];do{D=+p[(f[F+(n<<2)>>2]|0)+(J<<3)>>3];B=B<D?D:B;n=n+1|0}while((n|0)!=(h|0));p[q+(J<<3)>>3]=B;J=J+1|0}while((J|0)!=(g|0))}while(0);if((E|0)>1){q=q+(a<<3)|0;E=E+-1|0;F=F+4|0}else break}return}function jia(a){a=a|0;PYa(a);return}function kia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function lia(a){a=a|0;PYa(a);return}function mia(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;h=f[a+4>>2]|0;a=d>>>2;d=(h|0)>1;if(d&(e|0)>1){i=g+-4|0;j=(g|0)<4;k=(h|0)>2;l=a<<1;m=g&-4;o=c;p=e;q=b;while(1){a:do if(j)r=0;else{s=f[q+4>>2]|0;t=f[q>>2]|0;if(!k){u=f[q+8>>2]|0;v=0;while(1){w=s+(v<<2)|0;x=+n[w>>2];y=+n[w+4>>2];z=+n[w+8>>2];A=+n[w+12>>2];w=t+(v<<2)|0;B=+n[w>>2];n[o+(v<<2)>>2]=x<B?B:x;B=+n[w+4>>2];n[o+((v|1)<<2)>>2]=y<B?B:y;B=+n[w+8>>2];n[o+((v|2)<<2)>>2]=z<B?B:z;B=+n[w+12>>2];n[o+((v|3)<<2)>>2]=A<B?B:A;w=u+(v<<2)|0;B=+n[w>>2];C=v+a|0;n[o+(C<<2)>>2]=x<B?B:x;x=+n[w+4>>2];n[o+(C+1<<2)>>2]=y<x?x:y;y=+n[w+8>>2];n[o+(C+2<<2)>>2]=z<y?y:z;z=+n[w+12>>2];n[o+(C+3<<2)>>2]=A<z?z:A;v=v+4|0;if((v|0)>(i|0)){r=m;break a}}}v=f[q+(h<<2)>>2]|0;u=0;do{C=s+(u<<2)|0;w=2;A=+n[C>>2];z=+n[C+4>>2];y=+n[C+8>>2];x=+n[C+12>>2];do{C=(f[q+(w<<2)>>2]|0)+(u<<2)|0;B=+n[C>>2];A=A<B?B:A;B=+n[C+4>>2];z=z<B?B:z;B=+n[C+8>>2];y=y<B?B:y;B=+n[C+12>>2];x=x<B?B:x;w=w+1|0}while((w|0)!=(h|0));w=t+(u<<2)|0;B=+n[w>>2];n[o+(u<<2)>>2]=A<B?B:A;B=+n[w+4>>2];n[o+((u|1)<<2)>>2]=z<B?B:z;B=+n[w+8>>2];n[o+((u|2)<<2)>>2]=y<B?B:y;B=+n[w+12>>2];n[o+((u|3)<<2)>>2]=x<B?B:x;w=v+(u<<2)|0;B=+n[w>>2];C=u+a|0;n[o+(C<<2)>>2]=A<B?B:A;B=+n[w+4>>2];n[o+(C+1<<2)>>2]=z<B?B:z;B=+n[w+8>>2];n[o+(C+2<<2)>>2]=y<B?B:y;B=+n[w+12>>2];n[o+(C+3<<2)>>2]=x<B?B:x;u=u+4|0}while((u|0)<=(i|0));r=m}while(0);b:do if((r|0)<(g|0)){u=f[q+4>>2]|0;v=f[q>>2]|0;if(!k){t=f[q+8>>2]|0;s=r;while(1){B=+n[u+(s<<2)>>2];D=+n[v+(s<<2)>>2];n[o+(s<<2)>>2]=B<D?D:B;D=+n[t+(s<<2)>>2];n[o+(s+a<<2)>>2]=B<D?D:B;s=s+1|0;if((s|0)==(g|0))break b}}s=f[q+(h<<2)>>2]|0;t=r;do{C=2;B=+n[u+(t<<2)>>2];do{D=+n[(f[q+(C<<2)>>2]|0)+(t<<2)>>2];B=B<D?D:B;C=C+1|0}while((C|0)!=(h|0));x=+n[v+(t<<2)>>2];n[o+(t<<2)>>2]=B<x?x:B;x=+n[s+(t<<2)>>2];n[o+(t+a<<2)>>2]=B<x?x:B;t=t+1|0}while((t|0)!=(g|0))}while(0);t=p+-2|0;s=o+(l<<2)|0;v=q+8|0;if((t|0)>1){o=s;p=t;q=v}else{E=s;F=t;G=v;break}}}else{E=c;F=e;G=b}if((F|0)<=0)return;b=g+-4|0;e=(g|0)<4;c=g&-4;q=E;E=F;F=G;while(1){c:do if(e)H=0;else{G=f[F>>2]|0;if(d)I=0;else{p=0;while(1){o=G+(p<<2)|0;l=f[o+4>>2]|0;r=f[o+8>>2]|0;k=f[o+12>>2]|0;f[q+(p<<2)>>2]=f[o>>2];f[q+((p|1)<<2)>>2]=l;f[q+((p|2)<<2)>>2]=r;f[q+((p|3)<<2)>>2]=k;p=p+4|0;if((p|0)>(b|0)){H=c;break c}}}do{p=G+(I<<2)|0;k=1;x=+n[p>>2];y=+n[p+4>>2];z=+n[p+8>>2];A=+n[p+12>>2];do{p=(f[F+(k<<2)>>2]|0)+(I<<2)|0;D=+n[p>>2];x=x<D?D:x;D=+n[p+4>>2];y=y<D?D:y;D=+n[p+8>>2];z=z<D?D:z;D=+n[p+12>>2];A=A<D?D:A;k=k+1|0}while((k|0)!=(h|0));n[q+(I<<2)>>2]=x;n[q+((I|1)<<2)>>2]=y;n[q+((I|2)<<2)>>2]=z;n[q+((I|3)<<2)>>2]=A;I=I+4|0}while((I|0)<=(b|0));H=c}while(0);d:do if((H|0)<(g|0)){G=f[F>>2]|0;if(d)J=H;else{k=H;while(1){f[q+(k<<2)>>2]=f[G+(k<<2)>>2];k=k+1|0;if((k|0)==(g|0))break d}}do{k=1;B=+n[G+(J<<2)>>2];do{D=+n[(f[F+(k<<2)>>2]|0)+(J<<2)>>2];B=B<D?D:B;k=k+1|0}while((k|0)!=(h|0));n[q+(J<<2)>>2]=B;J=J+1|0}while((J|0)!=(g|0))}while(0);if((E|0)>1){q=q+(a<<2)|0;E=E+-1|0;F=F+4|0}else break}return}function nia(a){a=a|0;PYa(a);return}function oia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function pia(a){a=a|0;PYa(a);return}function qia(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;a=e>>>1;e=(i|0)>1;if(e&(g|0)>1){j=h+-4|0;k=(h|0)<4;l=(i|0)>2;m=a<<1;n=h&-4;o=c;p=g;q=b;while(1){a:do if(k)r=0;else{s=f[q+4>>2]|0;t=f[q>>2]|0;if(!l){u=f[q+8>>2]|0;v=0;while(1){w=s+(v<<1)|0;x=d[w>>1]|0;y=d[w+2>>1]|0;z=d[w+4>>1]|0;A=d[w+6>>1]|0;w=t+(v<<1)|0;B=d[w>>1]|0;d[o+(v<<1)>>1]=x<<16>>16<B<<16>>16?B:x;B=d[w+2>>1]|0;d[o+((v|1)<<1)>>1]=y<<16>>16<B<<16>>16?B:y;B=d[w+4>>1]|0;d[o+((v|2)<<1)>>1]=z<<16>>16<B<<16>>16?B:z;B=d[w+6>>1]|0;d[o+((v|3)<<1)>>1]=A<<16>>16<B<<16>>16?B:A;B=u+(v<<1)|0;w=d[B>>1]|0;C=v+a|0;d[o+(C<<1)>>1]=x<<16>>16<w<<16>>16?w:x;x=d[B+2>>1]|0;d[o+(C+1<<1)>>1]=y<<16>>16<x<<16>>16?x:y;y=d[B+4>>1]|0;d[o+(C+2<<1)>>1]=z<<16>>16<y<<16>>16?y:z;z=d[B+6>>1]|0;d[o+(C+3<<1)>>1]=A<<16>>16<z<<16>>16?z:A;v=v+4|0;if((v|0)>(j|0)){r=n;break a}}}v=f[q+(i<<2)>>2]|0;u=0;do{A=s+(u<<1)|0;z=2;C=d[A>>1]|0;B=d[A+2>>1]|0;y=d[A+4>>1]|0;x=d[A+6>>1]|0;do{A=(f[q+(z<<2)>>2]|0)+(u<<1)|0;w=d[A>>1]|0;C=C<<16>>16<w<<16>>16?w:C;w=d[A+2>>1]|0;B=B<<16>>16<w<<16>>16?w:B;w=d[A+4>>1]|0;y=y<<16>>16<w<<16>>16?w:y;w=d[A+6>>1]|0;x=x<<16>>16<w<<16>>16?w:x;z=z+1|0}while((z|0)!=(i|0));z=t+(u<<1)|0;w=d[z>>1]|0;d[o+(u<<1)>>1]=C<<16>>16<w<<16>>16?w:C;w=d[z+2>>1]|0;d[o+((u|1)<<1)>>1]=B<<16>>16<w<<16>>16?w:B;w=d[z+4>>1]|0;d[o+((u|2)<<1)>>1]=y<<16>>16<w<<16>>16?w:y;w=d[z+6>>1]|0;d[o+((u|3)<<1)>>1]=x<<16>>16<w<<16>>16?w:x;w=v+(u<<1)|0;z=d[w>>1]|0;A=u+a|0;d[o+(A<<1)>>1]=C<<16>>16<z<<16>>16?z:C;z=d[w+2>>1]|0;d[o+(A+1<<1)>>1]=B<<16>>16<z<<16>>16?z:B;z=d[w+4>>1]|0;d[o+(A+2<<1)>>1]=y<<16>>16<z<<16>>16?z:y;z=d[w+6>>1]|0;d[o+(A+3<<1)>>1]=x<<16>>16<z<<16>>16?z:x;u=u+4|0}while((u|0)<=(j|0));r=n}while(0);b:do if((r|0)<(h|0)){u=f[q+4>>2]|0;v=f[q>>2]|0;if(!l){t=f[q+8>>2]|0;s=r;while(1){z=d[u+(s<<1)>>1]|0;A=d[v+(s<<1)>>1]|0;d[o+(s<<1)>>1]=z<<16>>16<A<<16>>16?A:z;A=d[t+(s<<1)>>1]|0;d[o+(s+a<<1)>>1]=z<<16>>16<A<<16>>16?A:z;s=s+1|0;if((s|0)==(h|0))break b}}s=f[q+(i<<2)>>2]|0;t=r;do{z=2;A=d[u+(t<<1)>>1]|0;do{w=d[(f[q+(z<<2)>>2]|0)+(t<<1)>>1]|0;A=A<<16>>16<w<<16>>16?w:A;z=z+1|0}while((z|0)!=(i|0));z=d[v+(t<<1)>>1]|0;d[o+(t<<1)>>1]=A<<16>>16<z<<16>>16?z:A;z=d[s+(t<<1)>>1]|0;d[o+(t+a<<1)>>1]=A<<16>>16<z<<16>>16?z:A;t=t+1|0}while((t|0)!=(h|0))}while(0);t=p+-2|0;s=o+(m<<1)|0;v=q+8|0;if((t|0)>1){o=s;p=t;q=v}else{D=s;E=t;F=v;break}}}else{D=c;E=g;F=b}if((E|0)<=0)return;b=h+-4|0;g=(h|0)<4;c=h&-4;q=D;D=E;E=F;while(1){c:do if(g)G=0;else{F=f[E>>2]|0;if(e)H=0;else{p=0;while(1){o=F+(p<<1)|0;m=d[o+2>>1]|0;r=d[o+4>>1]|0;l=d[o+6>>1]|0;d[q+(p<<1)>>1]=d[o>>1]|0;d[q+((p|1)<<1)>>1]=m;d[q+((p|2)<<1)>>1]=r;d[q+((p|3)<<1)>>1]=l;p=p+4|0;if((p|0)>(b|0)){G=c;break c}}}do{p=F+(H<<1)|0;l=1;r=d[p>>1]|0;m=d[p+2>>1]|0;o=d[p+4>>1]|0;n=d[p+6>>1]|0;do{p=(f[E+(l<<2)>>2]|0)+(H<<1)|0;j=d[p>>1]|0;r=r<<16>>16<j<<16>>16?j:r;j=d[p+2>>1]|0;m=m<<16>>16<j<<16>>16?j:m;j=d[p+4>>1]|0;o=o<<16>>16<j<<16>>16?j:o;j=d[p+6>>1]|0;n=n<<16>>16<j<<16>>16?j:n;l=l+1|0}while((l|0)!=(i|0));d[q+(H<<1)>>1]=r;d[q+((H|1)<<1)>>1]=m;d[q+((H|2)<<1)>>1]=o;d[q+((H|3)<<1)>>1]=n;H=H+4|0}while((H|0)<=(b|0));G=c}while(0);d:do if((G|0)<(h|0)){F=f[E>>2]|0;if(e)I=G;else{l=G;while(1){d[q+(l<<1)>>1]=d[F+(l<<1)>>1]|0;l=l+1|0;if((l|0)==(h|0))break d}}do{l=1;A=d[F+(I<<1)>>1]|0;do{j=d[(f[E+(l<<2)>>2]|0)+(I<<1)>>1]|0;A=A<<16>>16<j<<16>>16?j:A;l=l+1|0}while((l|0)!=(i|0));d[q+(I<<1)>>1]=A;I=I+1|0}while((I|0)!=(h|0))}while(0);if((D|0)>1){q=q+(a<<1)|0;D=D+-1|0;E=E+4|0}else break}return}function ria(a){a=a|0;PYa(a);return}function sia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function tia(a){a=a|0;PYa(a);return}function uia(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;a=e>>>1;e=(i|0)>1;if(e&(g|0)>1){j=h+-4|0;k=(h|0)<4;l=(i|0)>2;m=a<<1;n=h&-4;o=c;p=g;q=b;while(1){a:do if(k)r=0;else{s=f[q+4>>2]|0;t=f[q>>2]|0;if(!l){u=f[q+8>>2]|0;v=0;while(1){w=s+(v<<1)|0;x=d[w>>1]|0;y=d[w+2>>1]|0;z=d[w+4>>1]|0;A=d[w+6>>1]|0;w=t+(v<<1)|0;B=d[w>>1]|0;d[o+(v<<1)>>1]=(x&65535)<(B&65535)?B:x;B=d[w+2>>1]|0;d[o+((v|1)<<1)>>1]=(y&65535)<(B&65535)?B:y;B=d[w+4>>1]|0;d[o+((v|2)<<1)>>1]=(z&65535)<(B&65535)?B:z;B=d[w+6>>1]|0;d[o+((v|3)<<1)>>1]=(A&65535)<(B&65535)?B:A;B=u+(v<<1)|0;w=d[B>>1]|0;C=v+a|0;d[o+(C<<1)>>1]=(x&65535)<(w&65535)?w:x;x=d[B+2>>1]|0;d[o+(C+1<<1)>>1]=(y&65535)<(x&65535)?x:y;y=d[B+4>>1]|0;d[o+(C+2<<1)>>1]=(z&65535)<(y&65535)?y:z;z=d[B+6>>1]|0;d[o+(C+3<<1)>>1]=(A&65535)<(z&65535)?z:A;v=v+4|0;if((v|0)>(j|0)){r=n;break a}}}v=f[q+(i<<2)>>2]|0;u=0;do{A=s+(u<<1)|0;z=2;C=d[A>>1]|0;B=d[A+2>>1]|0;y=d[A+4>>1]|0;x=d[A+6>>1]|0;do{A=(f[q+(z<<2)>>2]|0)+(u<<1)|0;w=d[A>>1]|0;C=(C&65535)<(w&65535)?w:C;w=d[A+2>>1]|0;B=(B&65535)<(w&65535)?w:B;w=d[A+4>>1]|0;y=(y&65535)<(w&65535)?w:y;w=d[A+6>>1]|0;x=(x&65535)<(w&65535)?w:x;z=z+1|0}while((z|0)!=(i|0));z=t+(u<<1)|0;w=d[z>>1]|0;d[o+(u<<1)>>1]=(C&65535)<(w&65535)?w:C;w=d[z+2>>1]|0;d[o+((u|1)<<1)>>1]=(B&65535)<(w&65535)?w:B;w=d[z+4>>1]|0;d[o+((u|2)<<1)>>1]=(y&65535)<(w&65535)?w:y;w=d[z+6>>1]|0;d[o+((u|3)<<1)>>1]=(x&65535)<(w&65535)?w:x;w=v+(u<<1)|0;z=d[w>>1]|0;A=u+a|0;d[o+(A<<1)>>1]=(C&65535)<(z&65535)?z:C;z=d[w+2>>1]|0;d[o+(A+1<<1)>>1]=(B&65535)<(z&65535)?z:B;z=d[w+4>>1]|0;d[o+(A+2<<1)>>1]=(y&65535)<(z&65535)?z:y;z=d[w+6>>1]|0;d[o+(A+3<<1)>>1]=(x&65535)<(z&65535)?z:x;u=u+4|0}while((u|0)<=(j|0));r=n}while(0);b:do if((r|0)<(h|0)){u=f[q+4>>2]|0;v=f[q>>2]|0;if(!l){t=f[q+8>>2]|0;s=r;while(1){z=d[u+(s<<1)>>1]|0;A=d[v+(s<<1)>>1]|0;d[o+(s<<1)>>1]=(z&65535)<(A&65535)?A:z;A=d[t+(s<<1)>>1]|0;d[o+(s+a<<1)>>1]=(z&65535)<(A&65535)?A:z;s=s+1|0;if((s|0)==(h|0))break b}}s=f[q+(i<<2)>>2]|0;t=r;do{z=2;A=d[u+(t<<1)>>1]|0;do{w=d[(f[q+(z<<2)>>2]|0)+(t<<1)>>1]|0;A=(A&65535)<(w&65535)?w:A;z=z+1|0}while((z|0)!=(i|0));z=d[v+(t<<1)>>1]|0;d[o+(t<<1)>>1]=(A&65535)<(z&65535)?z:A;z=d[s+(t<<1)>>1]|0;d[o+(t+a<<1)>>1]=(A&65535)<(z&65535)?z:A;t=t+1|0}while((t|0)!=(h|0))}while(0);t=p+-2|0;s=o+(m<<1)|0;v=q+8|0;if((t|0)>1){o=s;p=t;q=v}else{D=s;E=t;F=v;break}}}else{D=c;E=g;F=b}if((E|0)<=0)return;b=h+-4|0;g=(h|0)<4;c=h&-4;q=D;D=E;E=F;while(1){c:do if(g)G=0;else{F=f[E>>2]|0;if(e)H=0;else{p=0;while(1){o=F+(p<<1)|0;m=d[o+2>>1]|0;r=d[o+4>>1]|0;l=d[o+6>>1]|0;d[q+(p<<1)>>1]=d[o>>1]|0;d[q+((p|1)<<1)>>1]=m;d[q+((p|2)<<1)>>1]=r;d[q+((p|3)<<1)>>1]=l;p=p+4|0;if((p|0)>(b|0)){G=c;break c}}}do{p=F+(H<<1)|0;l=1;r=d[p>>1]|0;m=d[p+2>>1]|0;o=d[p+4>>1]|0;n=d[p+6>>1]|0;do{p=(f[E+(l<<2)>>2]|0)+(H<<1)|0;j=d[p>>1]|0;r=(r&65535)<(j&65535)?j:r;j=d[p+2>>1]|0;m=(m&65535)<(j&65535)?j:m;j=d[p+4>>1]|0;o=(o&65535)<(j&65535)?j:o;j=d[p+6>>1]|0;n=(n&65535)<(j&65535)?j:n;l=l+1|0}while((l|0)!=(i|0));d[q+(H<<1)>>1]=r;d[q+((H|1)<<1)>>1]=m;d[q+((H|2)<<1)>>1]=o;d[q+((H|3)<<1)>>1]=n;H=H+4|0}while((H|0)<=(b|0));G=c}while(0);d:do if((G|0)<(h|0)){F=f[E>>2]|0;if(e)I=G;else{l=G;while(1){d[q+(l<<1)>>1]=d[F+(l<<1)>>1]|0;l=l+1|0;if((l|0)==(h|0))break d}}do{l=1;A=d[F+(I<<1)>>1]|0;do{j=d[(f[E+(l<<2)>>2]|0)+(I<<1)>>1]|0;A=(A&65535)<(j&65535)?j:A;l=l+1|0}while((l|0)!=(i|0));d[q+(I<<1)>>1]=A;I=I+1|0}while((I|0)!=(h|0))}while(0);if((D|0)>1){q=q+(a<<1)|0;D=D+-1|0;E=E+4|0}else break}return}function via(a){a=a|0;PYa(a);return}function wia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function xia(a){a=a|0;PYa(a);return}function yia(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;j=f[a+4>>2]|0;a=(j|0)>1;if(a&(g|0)>1){k=i+-4|0;l=(i|0)<4;m=(j|0)>2;n=e<<1;o=i&-4;p=d;q=g;r=c;while(1){if(l)s=0;else{t=r+4|0;u=0;do{v=(f[t>>2]|0)+u|0;w=b[v>>0]|0;x=b[v+1>>0]|0;y=b[v+2>>0]|0;z=b[v+3>>0]|0;if(m){v=2;A=w;B=x;C=y;D=z;while(1){E=(f[r+(v<<2)>>2]|0)+u|0;F=A&255;G=(h[E>>0]|0)-F+256|0;if(G>>>0<769)H=h[331268+G>>0]|0;else H=0;G=H+F&255;F=B&255;I=(h[E+1>>0]|0)-F+256|0;if(I>>>0<769)J=h[331268+I>>0]|0;else J=0;I=J+F&255;F=C&255;K=(h[E+2>>0]|0)-F+256|0;if(K>>>0<769)L=h[331268+K>>0]|0;else L=0;K=L+F&255;F=D&255;M=(h[E+3>>0]|0)-F+256|0;if(M>>>0<769)N=h[331268+M>>0]|0;else N=0;M=N+F&255;v=v+1|0;if((v|0)==(j|0)){O=j;P=G;Q=I;R=K;S=M;break}else{A=G;B=I;C=K;D=M}}}else{O=2;P=w;Q=x;R=y;S=z}D=(f[r>>2]|0)+u|0;C=P&255;B=(h[D>>0]|0)-C+256|0;if(B>>>0<769)T=h[331268+B>>0]|0;else T=0;b[p+u>>0]=T+C;B=Q&255;A=(h[D+1>>0]|0)-B+256|0;if(A>>>0<769)U=h[331268+A>>0]|0;else U=0;b[p+(u|1)>>0]=U+B;A=R&255;v=(h[D+2>>0]|0)-A+256|0;if(v>>>0<769)V=h[331268+v>>0]|0;else V=0;b[p+(u|2)>>0]=V+A;v=S&255;M=(h[D+3>>0]|0)-v+256|0;if(M>>>0<769)W=h[331268+M>>0]|0;else W=0;b[p+(u|3)>>0]=W+v;M=(f[r+(O<<2)>>2]|0)+u|0;D=(h[M>>0]|0)-C+256|0;if(D>>>0<769)X=h[331268+D>>0]|0;else X=0;D=u+e|0;b[p+D>>0]=X+C;C=(h[M+1>>0]|0)-B+256|0;if(C>>>0<769)Y=h[331268+C>>0]|0;else Y=0;b[p+(D+1)>>0]=Y+B;B=(h[M+2>>0]|0)-A+256|0;if(B>>>0<769)Z=h[331268+B>>0]|0;else Z=0;b[p+(D+2)>>0]=Z+A;A=(h[M+3>>0]|0)-v+256|0;if(A>>>0<769)_=h[331268+A>>0]|0;else _=0;b[p+(D+3)>>0]=_+v;u=u+4|0}while((u|0)<=(k|0));s=o}a:do if((s|0)<(i|0)){u=r+4|0;if(!m){t=r+8|0;v=s;while(1){D=h[(f[u>>2]|0)+v>>0]|0;A=(h[(f[r>>2]|0)+v>>0]|0)-D+256|0;if(A>>>0<769)$=h[331268+A>>0]|0;else $=0;b[p+v>>0]=$+D;A=(h[(f[t>>2]|0)+v>>0]|0)-D+256|0;if(A>>>0<769)aa=h[331268+A>>0]|0;else aa=0;b[p+(v+e)>>0]=aa+D;v=v+1|0;if((v|0)==(i|0))break a}}v=r+(j<<2)|0;t=s;do{z=2;y=b[(f[u>>2]|0)+t>>0]|0;while(1){x=y&255;w=(h[(f[r+(z<<2)>>2]|0)+t>>0]|0)-x+256|0;if(w>>>0<769)ba=h[331268+w>>0]|0;else ba=0;ca=ba+x|0;z=z+1|0;if((z|0)==(j|0))break;else y=ca&255}y=ca&255;z=(h[(f[r>>2]|0)+t>>0]|0)-y+256|0;if(z>>>0<769)da=h[331268+z>>0]|0;else da=0;b[p+t>>0]=da+ca;z=(h[(f[v>>2]|0)+t>>0]|0)-y+256|0;if(z>>>0<769)ea=h[331268+z>>0]|0;else ea=0;b[p+(t+e)>>0]=ea+ca;t=t+1|0}while((t|0)!=(i|0))}while(0);t=q+-2|0;v=p+n|0;u=r+8|0;if((t|0)>1){p=v;q=t;r=u}else{fa=v;ga=t;ha=u;break}}}else{fa=d;ga=g;ha=c}if((ga|0)<=0)return;c=i+-4|0;g=(i|0)<4;d=i&-4;r=fa;fa=ga;ga=ha;while(1){b:do if(g)ia=0;else{if(a)ja=0;else{ha=0;while(1){q=(f[ga>>2]|0)+ha|0;p=b[q+1>>0]|0;n=b[q+2>>0]|0;ca=b[q+3>>0]|0;b[r+ha>>0]=b[q>>0]|0;b[r+(ha|1)>>0]=p;b[r+(ha|2)>>0]=n;b[r+(ha|3)>>0]=ca;ha=ha+4|0;if((ha|0)>(c|0)){ia=d;break b}}}do{ha=(f[ga>>2]|0)+ja|0;ca=1;n=b[ha>>0]|0;p=b[ha+1>>0]|0;q=b[ha+2>>0]|0;ea=b[ha+3>>0]|0;do{ha=(f[ga+(ca<<2)>>2]|0)+ja|0;da=n&255;ba=(h[ha>>0]|0)-da+256|0;if(ba>>>0<769)ka=h[331268+ba>>0]|0;else ka=0;n=ka+da&255;da=p&255;ba=(h[ha+1>>0]|0)-da+256|0;if(ba>>>0<769)la=h[331268+ba>>0]|0;else la=0;p=la+da&255;da=q&255;ba=(h[ha+2>>0]|0)-da+256|0;if(ba>>>0<769)ma=h[331268+ba>>0]|0;else ma=0;q=ma+da&255;da=ea&255;ba=(h[ha+3>>0]|0)-da+256|0;if(ba>>>0<769)na=h[331268+ba>>0]|0;else na=0;ea=na+da&255;ca=ca+1|0}while((ca|0)!=(j|0));b[r+ja>>0]=n;b[r+(ja|1)>>0]=p;b[r+(ja|2)>>0]=q;b[r+(ja|3)>>0]=ea;ja=ja+4|0}while((ja|0)<=(c|0));ia=d}while(0);c:do if((ia|0)<(i|0)){if(a)oa=ia;else{ca=ia;while(1){b[r+ca>>0]=b[(f[ga>>2]|0)+ca>>0]|0;ca=ca+1|0;if((ca|0)==(i|0))break c}}do{ca=1;da=b[(f[ga>>2]|0)+oa>>0]|0;do{ba=da&255;ha=(h[(f[ga+(ca<<2)>>2]|0)+oa>>0]|0)-ba+256|0;if(ha>>>0<769)pa=h[331268+ha>>0]|0;else pa=0;da=pa+ba&255;ca=ca+1|0}while((ca|0)!=(j|0));b[r+oa>>0]=da;oa=oa+1|0}while((oa|0)!=(i|0))}while(0);if((fa|0)>1){r=r+e|0;fa=fa+-1|0;ga=ga+4|0}else break}return}function zia(a){a=a|0;PYa(a);return}function Aia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Bia(a){a=a|0;PYa(a);return}function Cia(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;h=f[a+4>>2]|0;a=d>>>3;d=(h|0)>1;if(d&(e|0)>1){i=g+-4|0;j=(g|0)<4;k=(h|0)>2;l=a<<1;m=g&-4;n=c;o=e;q=b;while(1){a:do if(j)r=0;else{s=f[q+4>>2]|0;t=f[q>>2]|0;if(!k){u=f[q+8>>2]|0;v=0;while(1){w=s+(v<<3)|0;x=+p[w>>3];y=+p[w+8>>3];z=+p[w+16>>3];A=+p[w+24>>3];w=t+(v<<3)|0;B=+p[w>>3];p[n+(v<<3)>>3]=B<x?B:x;B=+p[w+8>>3];p[n+((v|1)<<3)>>3]=B<y?B:y;B=+p[w+16>>3];p[n+((v|2)<<3)>>3]=B<z?B:z;B=+p[w+24>>3];p[n+((v|3)<<3)>>3]=B<A?B:A;w=u+(v<<3)|0;B=+p[w>>3];C=v+a|0;p[n+(C<<3)>>3]=B<x?B:x;x=+p[w+8>>3];p[n+(C+1<<3)>>3]=x<y?x:y;y=+p[w+16>>3];p[n+(C+2<<3)>>3]=y<z?y:z;z=+p[w+24>>3];p[n+(C+3<<3)>>3]=z<A?z:A;v=v+4|0;if((v|0)>(i|0)){r=m;break a}}}v=f[q+(h<<2)>>2]|0;u=0;do{C=s+(u<<3)|0;w=2;A=+p[C>>3];z=+p[C+8>>3];y=+p[C+16>>3];x=+p[C+24>>3];do{C=(f[q+(w<<2)>>2]|0)+(u<<3)|0;B=+p[C>>3];A=B<A?B:A;B=+p[C+8>>3];z=B<z?B:z;B=+p[C+16>>3];y=B<y?B:y;B=+p[C+24>>3];x=B<x?B:x;w=w+1|0}while((w|0)!=(h|0));w=t+(u<<3)|0;B=+p[w>>3];p[n+(u<<3)>>3]=B<A?B:A;B=+p[w+8>>3];p[n+((u|1)<<3)>>3]=B<z?B:z;B=+p[w+16>>3];p[n+((u|2)<<3)>>3]=B<y?B:y;B=+p[w+24>>3];p[n+((u|3)<<3)>>3]=B<x?B:x;w=v+(u<<3)|0;B=+p[w>>3];C=u+a|0;p[n+(C<<3)>>3]=B<A?B:A;B=+p[w+8>>3];p[n+(C+1<<3)>>3]=B<z?B:z;B=+p[w+16>>3];p[n+(C+2<<3)>>3]=B<y?B:y;B=+p[w+24>>3];p[n+(C+3<<3)>>3]=B<x?B:x;u=u+4|0}while((u|0)<=(i|0));r=m}while(0);b:do if((r|0)<(g|0)){u=f[q+4>>2]|0;v=f[q>>2]|0;if(!k){t=f[q+8>>2]|0;s=r;while(1){B=+p[u+(s<<3)>>3];D=+p[v+(s<<3)>>3];p[n+(s<<3)>>3]=D<B?D:B;D=+p[t+(s<<3)>>3];p[n+(s+a<<3)>>3]=D<B?D:B;s=s+1|0;if((s|0)==(g|0))break b}}s=f[q+(h<<2)>>2]|0;t=r;do{C=2;B=+p[u+(t<<3)>>3];do{D=+p[(f[q+(C<<2)>>2]|0)+(t<<3)>>3];B=D<B?D:B;C=C+1|0}while((C|0)!=(h|0));x=+p[v+(t<<3)>>3];p[n+(t<<3)>>3]=x<B?x:B;x=+p[s+(t<<3)>>3];p[n+(t+a<<3)>>3]=x<B?x:B;t=t+1|0}while((t|0)!=(g|0))}while(0);t=o+-2|0;s=n+(l<<3)|0;v=q+8|0;if((t|0)>1){n=s;o=t;q=v}else{E=s;F=t;G=v;break}}}else{E=c;F=e;G=b}if((F|0)<=0)return;b=g+-4|0;e=(g|0)<4;c=g&-4;q=E;E=F;F=G;while(1){c:do if(e)H=0;else{G=f[F>>2]|0;if(d)I=0;else{o=0;while(1){n=G+(o<<3)|0;x=+p[n+8>>3];y=+p[n+16>>3];z=+p[n+24>>3];p[q+(o<<3)>>3]=+p[n>>3];p[q+((o|1)<<3)>>3]=x;p[q+((o|2)<<3)>>3]=y;p[q+((o|3)<<3)>>3]=z;o=o+4|0;if((o|0)>(b|0)){H=c;break c}}}do{o=G+(I<<3)|0;n=1;z=+p[o>>3];y=+p[o+8>>3];x=+p[o+16>>3];A=+p[o+24>>3];do{o=(f[F+(n<<2)>>2]|0)+(I<<3)|0;D=+p[o>>3];z=D<z?D:z;D=+p[o+8>>3];y=D<y?D:y;D=+p[o+16>>3];x=D<x?D:x;D=+p[o+24>>3];A=D<A?D:A;n=n+1|0}while((n|0)!=(h|0));p[q+(I<<3)>>3]=z;p[q+((I|1)<<3)>>3]=y;p[q+((I|2)<<3)>>3]=x;p[q+((I|3)<<3)>>3]=A;I=I+4|0}while((I|0)<=(b|0));H=c}while(0);d:do if((H|0)<(g|0)){G=f[F>>2]|0;if(d)J=H;else{n=H;while(1){p[q+(n<<3)>>3]=+p[G+(n<<3)>>3];n=n+1|0;if((n|0)==(g|0))break d}}do{n=1;B=+p[G+(J<<3)>>3];do{D=+p[(f[F+(n<<2)>>2]|0)+(J<<3)>>3];B=D<B?D:B;n=n+1|0}while((n|0)!=(h|0));p[q+(J<<3)>>3]=B;J=J+1|0}while((J|0)!=(g|0))}while(0);if((E|0)>1){q=q+(a<<3)|0;E=E+-1|0;F=F+4|0}else break}return}function Dia(a){a=a|0;PYa(a);return}function Eia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Fia(a){a=a|0;PYa(a);return}
function T6(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0;d=f[c>>2]|0;e=((d|0)%2|0)+d|0;d=c+4|0;c=f[d>>2]|0;g=a+16|0;h=f[g>>2]|0;f[h+(e<<2)>>2]=((c|0)%2|0)+c;c=e+1|0;i=a+8|0;j=(Y(((f[(f[i>>2]|0)+12>>2]|0)+1|0)/2|0,(c|0)/2|0)|0)+1|0;k=a+4|0;l=f[k>>2]|0;m=f[l+8>>2]|0;n=f[l+12>>2]|0;if((e|0)>=(f[d>>2]|0)){o=h;p=j;q=p-j|0;r=o+(c<<2)|0;f[r>>2]=q;return}h=(n|0)>0;l=a+12|0;a=j;s=e;while(1){t=f[k>>2]|0;u=f[f[t+44>>2]>>2]|0;v=(f[t+16>>2]|0)+(Y(u,s)|0)|0;t=0-u|0;w=v+t|0;x=w+t|0;t=v+u|0;u=f[i>>2]|0;y=f[f[u+44>>2]>>2]|0;z=(f[u+16>>2]|0)+(Y(y,s)|0)|0;u=0-y|0;y=z+u+u|0;if(h){u=(s+1|0)<(m|0);A=(s|0)>(e|0);B=A^1;C=(s|0)>(c|0);D=0;E=a;while(1){a:do if(!(b[v+D>>0]|0)){F=D|1;G=(F|0)<(n|0);if(u?b[t+D>>0]|0:0){H=D+-1|0;I=(D|0)>0;if(G?b[v+F>>0]|0:0){if(I){if(b[v+H>>0]|0){do if(A){if(b[w+F>>0]|0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}do if(C){if(!(b[x+D>>0]|0))break;K=D+-2|0;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(K<<2)>>2];J=E;break a}do if((K|0)>-1){if(!(b[w+K>>0]|0))break;if(b[x+H>>0]|0){f[z+(D<<2)>>2]=f[z+(K<<2)>>2];J=E;break a}L=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;N=f[z+(K<<2)>>2]|0;O=M;while(1){P=f[L+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}if((M|0)==(N|0))Q=O;else{P=N;while(1){R=f[L+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}R=(O|0)>(P|0)?P:O;S=N;do{T=L+(S<<2)|0;U=S;S=f[T>>2]|0;f[T>>2]=R}while((S|0)<(U|0));Q=R}R=M;do{S=L+(R<<2)|0;N=R;R=f[S>>2]|0;f[S>>2]=Q}while((R|0)<(N|0));f[z+(D<<2)>>2]=Q;J=E;break a}while(0);R=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;M=f[z+(K<<2)>>2]|0;N=L;while(1){S=f[R+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}if((L|0)==(M|0))V=N;else{K=M;while(1){S=f[R+(K<<2)>>2]|0;if((S|0)<(K|0))K=S;else break}S=(N|0)>(K|0)?K:N;O=M;do{P=R+(O<<2)|0;U=O;O=f[P>>2]|0;f[P>>2]=S}while((O|0)<(U|0));V=S}S=L;do{O=R+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=V}while((S|0)<(M|0));f[z+(D<<2)>>2]=V;J=E;break a}while(0);S=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;L=f[z+(D+-2<<2)>>2]|0;M=R;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}if((R|0)==(L|0))W=M;else{O=L;while(1){N=f[S+(O<<2)>>2]|0;if((N|0)<(O|0))O=N;else break}N=(M|0)>(O|0)?O:M;K=L;do{U=S+(K<<2)|0;P=K;K=f[U>>2]|0;f[U>>2]=N}while((K|0)<(P|0));W=N}N=R;do{K=S+(N<<2)|0;L=N;N=f[K>>2]|0;f[K>>2]=W}while((N|0)<(L|0));f[z+(D<<2)>>2]=W;J=E;break a}N=D+2|0;if((N|0)>=(n|0))break;if(!(b[w+N>>0]|0))break;do if(C){if(!(b[x+F>>0]|0))break;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}if(!(b[x+D>>0]|0)){S=f[l>>2]|0;R=f[y+(N<<2)>>2]|0;L=f[z+(D+-2<<2)>>2]|0;K=R;while(1){M=f[S+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}if((R|0)==(L|0))X=K;else{M=L;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(K|0)>(M|0)?M:K;P=L;do{U=S+(P<<2)|0;T=P;P=f[U>>2]|0;f[U>>2]=O}while((P|0)<(T|0));X=O}O=R;do{P=S+(O<<2)|0;L=O;O=f[P>>2]|0;f[P>>2]=X}while((O|0)<(L|0));f[z+(D<<2)>>2]=X;J=E;break a}O=D+-2|0;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(O<<2)>>2];J=E;break a}do if((O|0)>-1){if(!(b[w+O>>0]|0))break;if(b[x+H>>0]|0){f[z+(D<<2)>>2]=f[z+(O<<2)>>2];J=E;break a}S=f[l>>2]|0;R=f[y+(N<<2)>>2]|0;L=f[z+(O<<2)>>2]|0;P=R;while(1){K=f[S+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}if((R|0)==(L|0))Z=P;else{K=L;while(1){M=f[S+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}M=(P|0)>(K|0)?K:P;T=L;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=M}while((T|0)<(_|0));Z=M}M=R;do{T=S+(M<<2)|0;L=M;M=f[T>>2]|0;f[T>>2]=Z}while((M|0)<(L|0));f[z+(D<<2)>>2]=Z;J=E;break a}while(0);M=f[l>>2]|0;S=f[y+(N<<2)>>2]|0;R=f[z+(O<<2)>>2]|0;L=S;while(1){T=f[M+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}if((S|0)==(R|0))$=L;else{O=R;while(1){T=f[M+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}T=(L|0)>(O|0)?O:L;P=R;do{K=M+(P<<2)|0;_=P;P=f[K>>2]|0;f[K>>2]=T}while((P|0)<(_|0));$=T}T=S;do{P=M+(T<<2)|0;R=T;T=f[P>>2]|0;f[P>>2]=$}while((T|0)<(R|0));f[z+(D<<2)>>2]=$;J=E;break a}while(0);T=f[l>>2]|0;M=f[y+(N<<2)>>2]|0;S=f[z+(D+-2<<2)>>2]|0;R=M;while(1){P=f[T+(R<<2)>>2]|0;if((P|0)<(R|0))R=P;else break}if((M|0)==(S|0))aa=R;else{N=S;while(1){P=f[T+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(R|0)>(N|0)?N:R;L=S;do{O=T+(L<<2)|0;_=L;L=f[O>>2]|0;f[O>>2]=P}while((L|0)<(_|0));aa=P}P=M;do{L=T+(P<<2)|0;S=P;P=f[L>>2]|0;f[L>>2]=aa}while((P|0)<(S|0));f[z+(D<<2)>>2]=aa;J=E;break a}while(0);f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(b[t+H>>0]|0){do if(A){if(b[w+F>>0]|0){P=D+-2|0;do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[w+H>>0]|0){T=f[z+(P<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}do if(C){if(!(b[x+D>>0]|0))break;f[z+(D<<2)>>2]=T;J=E;break a}while(0);M=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;L=S;while(1){R=f[M+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((S|0)==(T|0))ba=L;else{R=T;while(1){N=f[M+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}N=(L|0)>(R|0)?R:L;_=T;do{O=M+(_<<2)|0;K=_;_=f[O>>2]|0;f[O>>2]=N}while((_|0)<(K|0));ba=N}N=S;do{_=M+(N<<2)|0;T=N;N=f[_>>2]|0;f[_>>2]=ba}while((N|0)<(T|0));f[z+(D<<2)>>2]=ba;J=E;break a}if(!(b[w+P>>0]|0)){N=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=f[z+(P<<2)>>2]|0;T=M;while(1){_=f[N+(T<<2)>>2]|0;if((_|0)<(T|0))T=_;else break}if((M|0)==(S|0))ca=T;else{_=S;while(1){L=f[N+(_<<2)>>2]|0;if((L|0)<(_|0))_=L;else break}L=(T|0)>(_|0)?_:T;R=S;do{K=N+(R<<2)|0;O=R;R=f[K>>2]|0;f[K>>2]=L}while((R|0)<(O|0));ca=L}L=M;do{R=N+(L<<2)|0;S=L;L=f[R>>2]|0;f[R>>2]=ca}while((L|0)<(S|0));f[z+(D<<2)>>2]=ca;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;L=f[z+(P<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}N=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=M;while(1){R=f[N+(S<<2)>>2]|0;if((R|0)<(S|0))S=R;else break}if((M|0)==(L|0))da=S;else{R=L;while(1){T=f[N+(R<<2)>>2]|0;if((T|0)<(R|0))R=T;else break}T=(S|0)>(R|0)?R:S;_=L;do{O=N+(_<<2)|0;K=_;_=f[O>>2]|0;f[O>>2]=T}while((_|0)<(K|0));da=T}T=M;do{_=N+(T<<2)|0;L=T;T=f[_>>2]|0;f[_>>2]=da}while((T|0)<(L|0));f[z+(D<<2)>>2]=da;J=E;break a}while(0);T=f[l>>2]|0;N=f[y+(D<<2)>>2]|0;M=f[z+(P<<2)>>2]|0;L=N;while(1){_=f[T+(L<<2)>>2]|0;if((_|0)<(L|0))L=_;else break}if((N|0)==(M|0))ea=L;else{_=M;while(1){S=f[T+(_<<2)>>2]|0;if((S|0)<(_|0))_=S;else break}S=(L|0)>(_|0)?_:L;R=M;do{K=T+(R<<2)|0;O=R;R=f[K>>2]|0;f[K>>2]=S}while((R|0)<(O|0));ea=S}S=N;do{R=T+(S<<2)|0;M=S;S=f[R>>2]|0;f[R>>2]=ea}while((S|0)<(M|0));f[z+(D<<2)>>2]=ea;J=E;break a}while(0);S=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;N=f[z+(P<<2)>>2]|0;M=T;while(1){R=f[S+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}if((T|0)==(N|0))fa=M;else{P=N;while(1){R=f[S+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}R=(M|0)>(P|0)?P:M;L=N;do{_=S+(L<<2)|0;O=L;L=f[_>>2]|0;f[_>>2]=R}while((L|0)<(O|0));fa=R}R=T;do{L=S+(R<<2)|0;N=R;R=f[L>>2]|0;f[L>>2]=fa}while((R|0)<(N|0));f[z+(D<<2)>>2]=fa;J=E;break a}R=D+2|0;do if(!((R|0)>=(n|0)|B)){if(!(b[w+R>>0]|0))break;do if(C){if(!(b[x+F>>0]|0))break;S=D+-2|0;do if((S|0)>-1){if(!(b[v+S>>0]|0))break;if(b[w+H>>0]|0){T=f[z+(S<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}N=f[l>>2]|0;L=f[y+(R<<2)>>2]|0;M=L;while(1){P=f[N+(M<<2)>>2]|0;if((P|0)<(M|0))M=P;else break}if((L|0)==(T|0))ga=M;else{P=T;while(1){O=f[N+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}O=(M|0)>(P|0)?P:M;_=T;do{K=N+(_<<2)|0;U=_;_=f[K>>2]|0;f[K>>2]=O}while((_|0)<(U|0));ga=O}O=L;do{_=N+(O<<2)|0;T=O;O=f[_>>2]|0;f[_>>2]=ga}while((O|0)<(T|0));f[z+(D<<2)>>2]=ga;J=E;break a}if(!(b[w+S>>0]|0)){O=f[l>>2]|0;N=f[y+(R<<2)>>2]|0;L=f[z+(S<<2)>>2]|0;T=N;while(1){_=f[O+(T<<2)>>2]|0;if((_|0)<(T|0))T=_;else break}if((N|0)==(L|0))ha=T;else{_=L;while(1){M=f[O+(_<<2)>>2]|0;if((M|0)<(_|0))_=M;else break}M=(T|0)>(_|0)?_:T;P=L;do{U=O+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=M}while((P|0)<(K|0));ha=M}M=N;do{P=O+(M<<2)|0;L=M;M=f[P>>2]|0;f[P>>2]=ha}while((M|0)<(L|0));f[z+(D<<2)>>2]=ha;J=E;break a}if(!(b[x+H>>0]|0)){M=f[l>>2]|0;O=f[y+(R<<2)>>2]|0;N=f[z+(S<<2)>>2]|0;L=O;while(1){P=f[M+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}if((O|0)==(N|0))ia=L;else{P=N;while(1){T=f[M+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}T=(L|0)>(P|0)?P:L;_=N;do{K=M+(_<<2)|0;U=_;_=f[K>>2]|0;f[K>>2]=T}while((_|0)<(U|0));ia=T}T=O;do{_=M+(T<<2)|0;N=T;T=f[_>>2]|0;f[_>>2]=ia}while((T|0)<(N|0));f[z+(D<<2)>>2]=ia;J=E;break a}T=f[z+(S<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}M=f[l>>2]|0;O=f[y+(R<<2)>>2]|0;N=O;while(1){_=f[M+(N<<2)>>2]|0;if((_|0)<(N|0))N=_;else break}if((O|0)==(T|0))ja=N;else{_=T;while(1){L=f[M+(_<<2)>>2]|0;if((L|0)<(_|0))_=L;else break}L=(N|0)>(_|0)?_:N;P=T;do{U=M+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=L}while((P|0)<(K|0));ja=L}L=O;do{P=M+(L<<2)|0;T=L;L=f[P>>2]|0;f[P>>2]=ja}while((L|0)<(T|0));f[z+(D<<2)>>2]=ja;J=E;break a}while(0);L=f[l>>2]|0;M=f[y+(R<<2)>>2]|0;O=f[z+(S<<2)>>2]|0;T=M;while(1){P=f[L+(T<<2)>>2]|0;if((P|0)<(T|0))T=P;else break}if((M|0)==(O|0))ka=T;else{S=O;while(1){P=f[L+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}P=(T|0)>(S|0)?S:T;N=O;do{_=L+(N<<2)|0;K=N;N=f[_>>2]|0;f[_>>2]=P}while((N|0)<(K|0));ka=P}P=M;do{N=L+(P<<2)|0;O=P;P=f[N>>2]|0;f[N>>2]=ka}while((P|0)<(O|0));f[z+(D<<2)>>2]=ka;J=E;break a}while(0);P=D+-2|0;if(!(b[w+D>>0]|0)){L=f[l>>2]|0;M=f[y+(R<<2)>>2]|0;O=f[z+(P<<2)>>2]|0;N=M;while(1){T=f[L+(N<<2)>>2]|0;if((T|0)<(N|0))N=T;else break}if((M|0)==(O|0))la=N;else{T=O;while(1){S=f[L+(T<<2)>>2]|0;if((S|0)<(T|0))T=S;else break}S=(N|0)>(T|0)?T:N;K=O;do{_=L+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=S}while((K|0)<(U|0));la=S}S=M;do{K=L+(S<<2)|0;O=S;S=f[K>>2]|0;f[K>>2]=la}while((S|0)<(O|0));f[z+(D<<2)>>2]=la;J=E;break a}do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[w+H>>0]|0){S=f[l>>2]|0;L=f[y+(R<<2)>>2]|0;M=f[z+(P<<2)>>2]|0;O=L;while(1){K=f[S+(O<<2)>>2]|0;if((K|0)<(O|0))O=K;else break}if((L|0)==(M|0))ma=O;else{K=M;while(1){N=f[S+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(O|0)>(K|0)?K:O;T=M;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=N}while((T|0)<(_|0));ma=N}N=L;do{T=S+(N<<2)|0;M=N;N=f[T>>2]|0;f[T>>2]=ma}while((N|0)<(M|0));f[z+(D<<2)>>2]=ma;J=E;break a}if(!(b[w+P>>0]|0)){N=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;L=f[y+(R<<2)>>2]|0;M=S;while(1){T=f[N+(M<<2)>>2]|0;if((T|0)<(M|0))M=T;else break}if((S|0)==(L|0))na=M;else{T=L;while(1){O=f[N+(T<<2)>>2]|0;if((O|0)<(T|0))T=O;else break}O=(M|0)>(T|0)?T:M;K=L;do{_=N+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=O}while((K|0)<(U|0));na=O}O=S;do{K=N+(O<<2)|0;L=O;O=f[K>>2]|0;f[K>>2]=na}while((O|0)<(L|0));O=f[z+(P<<2)>>2]|0;S=na;while(1){L=f[N+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((na|0)==(O|0))oa=S;else{L=O;while(1){K=f[N+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(S|0)>(L|0)?L:S;M=O;do{T=N+(M<<2)|0;U=M;M=f[T>>2]|0;f[T>>2]=K}while((M|0)<(U|0));oa=K}K=na;do{M=N+(K<<2)|0;O=K;K=f[M>>2]|0;f[M>>2]=oa}while((K|0)<(O|0));f[z+(D<<2)>>2]=oa;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;K=f[l>>2]|0;N=f[y+(R<<2)>>2]|0;O=f[z+(P<<2)>>2]|0;M=N;while(1){S=f[K+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}if((N|0)==(O|0))pa=M;else{S=O;while(1){L=f[K+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}L=(M|0)>(S|0)?S:M;U=O;do{T=K+(U<<2)|0;_=U;U=f[T>>2]|0;f[T>>2]=L}while((U|0)<(_|0));pa=L}L=N;do{U=K+(L<<2)|0;O=L;L=f[U>>2]|0;f[U>>2]=pa}while((L|0)<(O|0));f[z+(D<<2)>>2]=pa;J=E;break a}while(0);L=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;N=f[y+(R<<2)>>2]|0;O=K;while(1){U=f[L+(O<<2)>>2]|0;if((U|0)<(O|0))O=U;else break}if((K|0)==(N|0))qa=O;else{U=N;while(1){M=f[L+(U<<2)>>2]|0;if((M|0)<(U|0))U=M;else break}M=(O|0)>(U|0)?U:O;S=N;do{_=L+(S<<2)|0;T=S;S=f[_>>2]|0;f[_>>2]=M}while((S|0)<(T|0));qa=M}M=K;do{S=L+(M<<2)|0;N=M;M=f[S>>2]|0;f[S>>2]=qa}while((M|0)<(N|0));M=f[z+(P<<2)>>2]|0;K=qa;while(1){N=f[L+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}if((qa|0)==(M|0))ra=K;else{N=M;while(1){S=f[L+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}S=(K|0)>(N|0)?N:K;O=M;do{U=L+(O<<2)|0;T=O;O=f[U>>2]|0;f[U>>2]=S}while((O|0)<(T|0));ra=S}S=qa;do{O=L+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=ra}while((S|0)<(M|0));f[z+(D<<2)>>2]=ra;J=E;break a}while(0);S=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;M=f[y+(R<<2)>>2]|0;O=L;while(1){K=f[S+(O<<2)>>2]|0;if((K|0)<(O|0))O=K;else break}if((L|0)==(M|0))sa=O;else{K=M;while(1){N=f[S+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(O|0)>(K|0)?K:O;T=M;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=N}while((T|0)<(_|0));sa=N}N=L;do{T=S+(N<<2)|0;M=N;N=f[T>>2]|0;f[T>>2]=sa}while((N|0)<(M|0));N=f[z+(P<<2)>>2]|0;L=sa;while(1){M=f[S+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((sa|0)==(N|0))ta=L;else{P=N;while(1){M=f[S+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}M=(L|0)>(P|0)?P:L;T=N;do{O=S+(T<<2)|0;K=T;T=f[O>>2]|0;f[O>>2]=M}while((T|0)<(K|0));ta=M}M=sa;do{T=S+(M<<2)|0;N=M;M=f[T>>2]|0;f[T>>2]=ta}while((M|0)<(N|0));f[z+(D<<2)>>2]=ta;J=E;break a}while(0);R=D+-2|0;if(!(b[w+D>>0]|0)){ua=R;break}do if((R|0)>-1){if(!(b[v+R>>0]|0))break;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}if(!(b[w+R>>0]|0)){M=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;N=f[z+(R<<2)>>2]|0;T=S;while(1){L=f[M+(T<<2)>>2]|0;if((L|0)<(T|0))T=L;else break}if((S|0)==(N|0))va=T;else{L=N;while(1){P=f[M+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(T|0)>(L|0)?L:T;K=N;do{O=M+(K<<2)|0;_=K;K=f[O>>2]|0;f[O>>2]=P}while((K|0)<(_|0));va=P}P=S;do{K=M+(P<<2)|0;N=P;P=f[K>>2]|0;f[K>>2]=va}while((P|0)<(N|0));f[z+(D<<2)>>2]=va;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}while(0);P=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=f[z+(R<<2)>>2]|0;N=M;while(1){K=f[P+(N<<2)>>2]|0;if((K|0)<(N|0))N=K;else break}if((M|0)==(S|0))wa=N;else{K=S;while(1){T=f[P+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}T=(N|0)>(K|0)?K:N;L=S;do{_=P+(L<<2)|0;O=L;L=f[_>>2]|0;f[_>>2]=T}while((L|0)<(O|0));wa=T}T=M;do{L=P+(T<<2)|0;S=T;T=f[L>>2]|0;f[L>>2]=wa}while((T|0)<(S|0));f[z+(D<<2)>>2]=wa;J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[z+(R<<2)>>2]|0;S=P;while(1){L=f[T+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((P|0)==(M|0))xa=S;else{R=M;while(1){L=f[T+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}L=(S|0)>(R|0)?R:S;N=M;do{K=T+(N<<2)|0;O=N;N=f[K>>2]|0;f[K>>2]=L}while((N|0)<(O|0));xa=L}L=P;do{N=T+(L<<2)|0;M=L;L=f[N>>2]|0;f[N>>2]=xa}while((L|0)<(M|0));f[z+(D<<2)>>2]=xa;J=E;break a}else ua=D+-2|0;while(0);f[z+(D<<2)>>2]=f[z+(ua<<2)>>2];J=E;break}}if(A){if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}L=D+2|0;if(!((L|0)>=(n|0)|B)?b[w+L>>0]|0:0){if(!(b[w+D>>0]|0)){f[z+(D<<2)>>2]=f[y+(L<<2)>>2];J=E;break}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[y+(L<<2)>>2];J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[y+(L<<2)>>2]|0;N=P;while(1){S=f[T+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}if((P|0)==(M|0))ya=N;else{L=M;while(1){S=f[T+(L<<2)>>2]|0;if((S|0)<(L|0))L=S;else break}S=(N|0)>(L|0)?L:N;R=M;do{O=T+(R<<2)|0;K=R;R=f[O>>2]|0;f[O>>2]=S}while((R|0)<(K|0));ya=S}S=P;do{R=T+(S<<2)|0;M=S;S=f[R>>2]|0;f[R>>2]=ya}while((S|0)<(M|0));f[z+(D<<2)>>2]=ya;J=E;break}if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}if(I){if(b[t+H>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(b[v+H>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}do if(G){if(!(b[v+F>>0]|0)){if(!u)break;if(!(b[t+F>>0]|0))break;f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break a}if(A){if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break a}S=D+2|0;if(!((S|0)>=(n|0)|B)?b[w+S>>0]|0:0){if(!(b[w+D>>0]|0)){f[z+(D<<2)>>2]=f[y+(S<<2)>>2];J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[y+(S<<2)>>2];J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[y+(S<<2)>>2]|0;R=P;while(1){N=f[T+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}if((P|0)==(M|0))za=R;else{S=M;while(1){N=f[T+(S<<2)>>2]|0;if((N|0)<(S|0))S=N;else break}N=(R|0)>(S|0)?S:R;L=M;do{K=T+(L<<2)|0;O=L;L=f[K>>2]|0;f[K>>2]=N}while((L|0)<(O|0));za=N}N=P;do{L=T+(N<<2)|0;M=N;N=f[L>>2]|0;f[L>>2]=za}while((N|0)<(M|0));f[z+(D<<2)>>2]=za;J=E;break a}if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break a}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break a}while(0);f[z+(D<<2)>>2]=0;J=E}else{F=D+-1|0;G=(D|0)>0;if(G){if(b[v+F>>0]|0){H=D|1;I=(H|0)<(n|0);if(A&I?b[w+H>>0]|0:0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(C?b[x+D>>0]|0:0){N=D+-2|0;if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[z+(N<<2)>>2];J=E;break}do if((N|0)>-1){if(!(b[w+N>>0]|0))break;if(b[x+F>>0]|0){f[z+(D<<2)>>2]=f[z+(N<<2)>>2];J=E;break a}T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[z+(N<<2)>>2]|0;L=P;while(1){R=f[T+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((P|0)==(M|0))Aa=L;else{R=M;while(1){S=f[T+(R<<2)>>2]|0;if((S|0)<(R|0))R=S;else break}S=(L|0)>(R|0)?R:L;O=M;do{K=T+(O<<2)|0;_=O;O=f[K>>2]|0;f[K>>2]=S}while((O|0)<(_|0));Aa=S}S=P;do{O=T+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=Aa}while((S|0)<(M|0));f[z+(D<<2)>>2]=Aa;J=E;break a}while(0);S=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;P=f[z+(N<<2)>>2]|0;M=T;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}if((T|0)==(P|0))Ba=M;else{N=P;while(1){O=f[S+(N<<2)>>2]|0;if((O|0)<(N|0))N=O;else break}O=(M|0)>(N|0)?N:M;L=P;do{R=S+(L<<2)|0;_=L;L=f[R>>2]|0;f[R>>2]=O}while((L|0)<(_|0));Ba=O}O=T;do{L=S+(O<<2)|0;P=O;O=f[L>>2]|0;f[L>>2]=Ba}while((O|0)<(P|0));f[z+(D<<2)>>2]=Ba;J=E;break}O=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;T=f[z+(D+-2<<2)>>2]|0;P=S;while(1){L=f[O+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((S|0)==(T|0))Ca=P;else{L=T;while(1){M=f[O+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(P|0)>(L|0)?L:P;N=T;do{_=O+(N<<2)|0;R=N;N=f[_>>2]|0;f[_>>2]=M}while((N|0)<(R|0));Ca=M}M=S;do{N=O+(M<<2)|0;T=M;M=f[N>>2]|0;f[N>>2]=Ca}while((M|0)<(T|0));f[z+(D<<2)>>2]=Ca;J=E;break}if(I?b[v+H>>0]|0:0){M=D+2|0;if(A&(M|0)<(n|0)?b[w+M>>0]|0:0){do if(C){if(!(b[x+H>>0]|0))break;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}if(!(b[x+D>>0]|0)){O=f[l>>2]|0;S=f[y+(M<<2)>>2]|0;T=f[z+(D+-2<<2)>>2]|0;N=S;while(1){P=f[O+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((S|0)==(T|0))Da=N;else{P=T;while(1){L=f[O+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}L=(N|0)>(P|0)?P:N;R=T;do{_=O+(R<<2)|0;K=R;R=f[_>>2]|0;f[_>>2]=L}while((R|0)<(K|0));Da=L}L=S;do{R=O+(L<<2)|0;T=L;L=f[R>>2]|0;f[R>>2]=Da}while((L|0)<(T|0));f[z+(D<<2)>>2]=Da;J=E;break a}L=D+-2|0;if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[z+(L<<2)>>2];J=E;break a}do if((L|0)>-1){if(!(b[w+L>>0]|0))break;if(b[x+F>>0]|0){f[z+(D<<2)>>2]=f[z+(L<<2)>>2];J=E;break a}O=f[l>>2]|0;S=f[y+(M<<2)>>2]|0;T=f[z+(L<<2)>>2]|0;R=S;while(1){N=f[O+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}if((S|0)==(T|0))Ea=R;else{N=T;while(1){P=f[O+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(R|0)>(N|0)?N:R;K=T;do{_=O+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=P}while((K|0)<(U|0));Ea=P}P=S;do{K=O+(P<<2)|0;T=P;P=f[K>>2]|0;f[K>>2]=Ea}while((P|0)<(T|0));f[z+(D<<2)>>2]=Ea;J=E;break a}while(0);P=f[l>>2]|0;O=f[y+(M<<2)>>2]|0;S=f[z+(L<<2)>>2]|0;T=O;while(1){K=f[P+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}if((O|0)==(S|0))Fa=T;else{L=S;while(1){K=f[P+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(T|0)>(L|0)?L:T;R=S;do{N=P+(R<<2)|0;U=R;R=f[N>>2]|0;f[N>>2]=K}while((R|0)<(U|0));Fa=K}K=O;do{R=P+(K<<2)|0;S=K;K=f[R>>2]|0;f[R>>2]=Fa}while((K|0)<(S|0));f[z+(D<<2)>>2]=Fa;J=E;break a}while(0);H=f[l>>2]|0;I=f[y+(M<<2)>>2]|0;K=f[z+(D+-2<<2)>>2]|0;P=I;while(1){O=f[H+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}if((I|0)==(K|0))Ga=P;else{M=K;while(1){O=f[H+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(P|0)>(M|0)?M:P;S=K;do{R=H+(S<<2)|0;T=S;S=f[R>>2]|0;f[R>>2]=O}while((S|0)<(T|0));Ga=O}O=I;do{S=H+(O<<2)|0;K=O;O=f[S>>2]|0;f[S>>2]=Ga}while((O|0)<(K|0));f[z+(D<<2)>>2]=Ga;J=E;break}f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(u?b[t+F>>0]|0:0){O=D|1;H=(O|0)<(n|0);if(!(B|H^1)?b[w+O>>0]|0:0){I=D+-2|0;if((I|0)>-1?b[v+I>>0]|0:0){if(b[w+F>>0]|0){K=f[z+(I<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break}do if(C){if(!(b[x+D>>0]|0))break;f[z+(D<<2)>>2]=K;J=E;break a}while(0);S=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=P;while(1){T=f[S+(M<<2)>>2]|0;if((T|0)<(M|0))M=T;else break}if((P|0)==(K|0))Ha=M;else{T=K;while(1){R=f[S+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(M|0)>(T|0)?T:M;L=K;do{U=S+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=R}while((L|0)<(N|0));Ha=R}R=P;do{L=S+(R<<2)|0;K=R;R=f[L>>2]|0;f[L>>2]=Ha}while((R|0)<(K|0));f[z+(D<<2)>>2]=Ha;J=E;break}if(!(b[w+I>>0]|0)){R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;P=f[z+(I<<2)>>2]|0;K=S;while(1){L=f[R+(K<<2)>>2]|0;if((L|0)<(K|0))K=L;else break}if((S|0)==(P|0))Ia=K;else{L=P;while(1){M=f[R+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(K|0)>(L|0)?L:K;T=P;do{N=R+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=M}while((T|0)<(U|0));Ia=M}M=S;do{T=R+(M<<2)|0;P=M;M=f[T>>2]|0;f[T>>2]=Ia}while((M|0)<(P|0));f[z+(D<<2)>>2]=Ia;J=E;break}do if(C){if(!(b[x+F>>0]|0))break;M=f[z+(I<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=M;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=M;J=E;break a}R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;P=S;while(1){T=f[R+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}if((S|0)==(M|0))Ja=P;else{T=M;while(1){K=f[R+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(P|0)>(T|0)?T:P;L=M;do{U=R+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=K}while((L|0)<(N|0));Ja=K}K=S;do{L=R+(K<<2)|0;M=K;K=f[L>>2]|0;f[L>>2]=Ja}while((K|0)<(M|0));f[z+(D<<2)>>2]=Ja;J=E;break a}while(0);K=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;S=f[z+(I<<2)>>2]|0;M=R;while(1){L=f[K+(M<<2)>>2]|0;if((L|0)<(M|0))M=L;else break}if((R|0)==(S|0))Ka=M;else{L=S;while(1){P=f[K+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(M|0)>(L|0)?L:M;T=S;do{N=K+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=P}while((T|0)<(U|0));Ka=P}P=R;do{T=K+(P<<2)|0;S=P;P=f[T>>2]|0;f[T>>2]=Ka}while((P|0)<(S|0));f[z+(D<<2)>>2]=Ka;J=E;break}if(b[w+D>>0]|0){P=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;R=f[z+(I<<2)>>2]|0;S=K;while(1){T=f[P+(S<<2)>>2]|0;if((T|0)<(S|0))S=T;else break}if((K|0)==(R|0))La=S;else{T=R;while(1){M=f[P+(T<<2)>>2]|0;if((M|0)<(T|0))T=M;else break}M=(S|0)>(T|0)?T:S;L=R;do{U=P+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=M}while((L|0)<(N|0));La=M}M=K;do{L=P+(M<<2)|0;R=M;M=f[L>>2]|0;f[L>>2]=La}while((M|0)<(R|0));f[z+(D<<2)>>2]=La;J=E;break}if(!(b[w+F>>0]|0)){M=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;K=f[z+(I<<2)>>2]|0;R=P;while(1){L=f[M+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}if((P|0)==(K|0))Ma=R;else{L=K;while(1){S=f[M+(L<<2)>>2]|0;if((S|0)<(L|0))L=S;else break}S=(R|0)>(L|0)?L:R;T=K;do{N=M+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=S}while((T|0)<(U|0));Ma=S}S=P;do{T=M+(S<<2)|0;K=S;S=f[T>>2]|0;f[T>>2]=Ma}while((S|0)<(K|0));f[z+(D<<2)>>2]=Ma;J=E;break}S=f[y+(D<<2)>>2]|0;M=f[l>>2]|0;do if(C){if(!(b[x+D>>0]|0))break;P=f[z+(I<<2)>>2]|0;K=S;while(1){T=f[M+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}if((S|0)==(P|0))Na=K;else{T=P;while(1){R=f[M+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(K|0)>(T|0)?T:K;L=P;do{U=M+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=R}while((L|0)<(N|0));Na=R}R=S;do{L=M+(R<<2)|0;P=R;R=f[L>>2]|0;f[L>>2]=Na}while((R|0)<(P|0));f[z+(D<<2)>>2]=Na;J=E;break a}while(0);R=f[y+(I<<2)>>2]|0;P=R;while(1){L=f[M+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((R|0)==(S|0))Oa=P;else{L=S;while(1){K=f[M+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(P|0)>(L|0)?L:P;T=S;do{N=M+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=K}while((T|0)<(U|0));Oa=K}K=R;do{T=M+(K<<2)|0;S=K;K=f[T>>2]|0;f[T>>2]=Oa}while((K|0)<(S|0));K=f[z+(I<<2)>>2]|0;R=Oa;while(1){S=f[M+(R<<2)>>2]|0;if((S|0)<(R|0))R=S;else break}if((Oa|0)==(K|0))Pa=R;else{I=K;while(1){S=f[M+(I<<2)>>2]|0;if((S|0)<(I|0))I=S;else break}S=(R|0)>(I|0)?I:R;T=K;do{P=M+(T<<2)|0;L=T;T=f[P>>2]|0;f[P>>2]=S}while((T|0)<(L|0));Pa=S}S=Oa;do{T=M+(S<<2)|0;K=S;S=f[T>>2]|0;f[T>>2]=Pa}while((S|0)<(K|0));f[z+(D<<2)>>2]=Pa;J=E;break}if(H?b[v+O>>0]|0:0){S=D+2|0;if(!((S|0)>=(n|0)|B)?b[w+S>>0]|0:0){M=D+-2|0;do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[w+F>>0]|0){do if(C){if(!(b[x+O>>0]|0))break;K=f[z+(M<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break a}T=f[l>>2]|0;R=f[y+(S<<2)>>2]|0;I=R;while(1){L=f[T+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((R|0)==(K|0))Qa=I;else{L=K;while(1){P=f[T+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(I|0)>(L|0)?L:I;U=K;do{N=T+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=P}while((U|0)<(_|0));Qa=P}P=R;do{U=T+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=Qa}while((P|0)<(K|0));f[z+(D<<2)>>2]=Qa;J=E;break a}while(0);P=f[l>>2]|0;T=f[y+(S<<2)>>2]|0;R=f[z+(M<<2)>>2]|0;K=T;while(1){U=f[P+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}if((T|0)==(R|0))Ra=K;else{U=R;while(1){I=f[P+(U<<2)>>2]|0;if((I|0)<(U|0))U=I;else break}I=(K|0)>(U|0)?U:K;L=R;do{_=P+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=I}while((L|0)<(N|0));Ra=I}I=T;do{L=P+(I<<2)|0;R=I;I=f[L>>2]|0;f[L>>2]=Ra}while((I|0)<(R|0));f[z+(D<<2)>>2]=Ra;J=E;break a}do if(C){if(!(b[x+O>>0]|0))break;if(!(b[w+M>>0]|0)){I=f[l>>2]|0;P=f[y+(S<<2)>>2]|0;T=f[z+(M<<2)>>2]|0;R=P;while(1){L=f[I+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}if((P|0)==(T|0))Sa=R;else{L=T;while(1){K=f[I+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(R|0)>(L|0)?L:R;U=T;do{N=I+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=K}while((U|0)<(_|0));Sa=K}K=P;do{U=I+(K<<2)|0;T=K;K=f[U>>2]|0;f[U>>2]=Sa}while((K|0)<(T|0));f[z+(D<<2)>>2]=Sa;J=E;break a}if(!(b[x+F>>0]|0)){K=f[l>>2]|0;I=f[y+(S<<2)>>2]|0;P=f[z+(M<<2)>>2]|0;T=I;while(1){U=f[K+(T<<2)>>2]|0;if((U|0)<(T|0))T=U;else break}if((I|0)==(P|0))Ta=T;else{U=P;while(1){R=f[K+(U<<2)>>2]|0;if((R|0)<(U|0))U=R;else break}R=(T|0)>(U|0)?U:T;L=P;do{_=K+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=R}while((L|0)<(N|0));Ta=R}R=I;do{L=K+(R<<2)|0;P=R;R=f[L>>2]|0;f[L>>2]=Ta}while((R|0)<(P|0));f[z+(D<<2)>>2]=Ta;J=E;break a}R=f[z+(M<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=R;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=R;J=E;break a}K=f[l>>2]|0;I=f[y+(S<<2)>>2]|0;P=I;while(1){L=f[K+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((I|0)==(R|0))Ua=P;else{L=R;while(1){T=f[K+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}T=(P|0)>(L|0)?L:P;U=R;do{N=K+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=T}while((U|0)<(_|0));Ua=T}T=I;do{U=K+(T<<2)|0;R=T;T=f[U>>2]|0;f[U>>2]=Ua}while((T|0)<(R|0));f[z+(D<<2)>>2]=Ua;J=E;break a}while(0);if(!(b[w+D>>0]|0)){T=f[l>>2]|0;K=f[y+(S<<2)>>2]|0;I=f[z+(M<<2)>>2]|0;R=K;while(1){U=f[T+(R<<2)>>2]|0;if((U|0)<(R|0))R=U;else break}if((K|0)==(I|0))Va=R;else{U=I;while(1){P=f[T+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}P=(R|0)>(U|0)?U:R;L=I;do{_=T+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=P}while((L|0)<(N|0));Va=P}P=K;do{L=T+(P<<2)|0;I=P;P=f[L>>2]|0;f[L>>2]=Va}while((P|0)<(I|0));f[z+(D<<2)>>2]=Va;J=E;break a}if(!(b[w+M>>0]|0)){P=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;K=f[y+(S<<2)>>2]|0;I=T;while(1){L=f[P+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((T|0)==(K|0))Wa=I;else{L=K;while(1){R=f[P+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}R=(I|0)>(L|0)?L:I;U=K;do{N=P+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=R}while((U|0)<(_|0));Wa=R}R=T;do{U=P+(R<<2)|0;K=R;R=f[U>>2]|0;f[U>>2]=Wa}while((R|0)<(K|0));R=f[z+(M<<2)>>2]|0;T=Wa;while(1){K=f[P+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}if((Wa|0)==(R|0))Xa=T;else{K=R;while(1){U=f[P+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}U=(T|0)>(K|0)?K:T;I=R;do{L=P+(I<<2)|0;_=I;I=f[L>>2]|0;f[L>>2]=U}while((I|0)<(_|0));Xa=U}U=Wa;do{I=P+(U<<2)|0;R=U;U=f[I>>2]|0;f[I>>2]=Xa}while((U|0)<(R|0));f[z+(D<<2)>>2]=Xa;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;U=f[l>>2]|0;P=f[y+(S<<2)>>2]|0;R=f[z+(M<<2)>>2]|0;I=P;while(1){T=f[U+(I<<2)>>2]|0;if((T|0)<(I|0))I=T;else break}if((P|0)==(R|0))Ya=I;else{T=R;while(1){K=f[U+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(I|0)>(T|0)?T:I;_=R;do{L=U+(_<<2)|0;N=_;_=f[L>>2]|0;f[L>>2]=K}while((_|0)<(N|0));Ya=K}K=P;do{_=U+(K<<2)|0;R=K;K=f[_>>2]|0;f[_>>2]=Ya}while((K|0)<(R|0));f[z+(D<<2)>>2]=Ya;J=E;break a}while(0);K=f[l>>2]|0;U=f[y+(D<<2)>>2]|0;P=f[y+(S<<2)>>2]|0;R=U;while(1){_=f[K+(R<<2)>>2]|0;if((_|0)<(R|0))R=_;else break}if((U|0)==(P|0))Za=R;else{_=P;while(1){I=f[K+(_<<2)>>2]|0;if((I|0)<(_|0))_=I;else break}I=(R|0)>(_|0)?_:R;T=P;do{N=K+(T<<2)|0;L=T;T=f[N>>2]|0;f[N>>2]=I}while((T|0)<(L|0));Za=I}I=U;do{T=K+(I<<2)|0;P=I;I=f[T>>2]|0;f[T>>2]=Za}while((I|0)<(P|0));I=f[z+(M<<2)>>2]|0;U=Za;while(1){P=f[K+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}if((Za|0)==(I|0))_a=U;else{P=I;while(1){T=f[K+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}T=(U|0)>(P|0)?P:U;R=I;do{_=K+(R<<2)|0;L=R;R=f[_>>2]|0;f[_>>2]=T}while((R|0)<(L|0));_a=T}T=Za;do{R=K+(T<<2)|0;I=T;T=f[R>>2]|0;f[R>>2]=_a}while((T|0)<(I|0));f[z+(D<<2)>>2]=_a;J=E;break a}while(0);if(b[w+D>>0]|0){do if(C){if(!(b[x+O>>0]|0))break;H=f[l>>2]|0;T=f[y+(S<<2)>>2]|0;K=f[z+(M<<2)>>2]|0;I=T;while(1){R=f[H+(I<<2)>>2]|0;if((R|0)<(I|0))I=R;else break}if((T|0)==(K|0))$a=I;else{R=K;while(1){U=f[H+(R<<2)>>2]|0;if((U|0)<(R|0))R=U;else break}U=(I|0)>(R|0)?R:I;P=K;do{L=H+(P<<2)|0;_=P;P=f[L>>2]|0;f[L>>2]=U}while((P|0)<(_|0));$a=U}U=T;do{P=H+(U<<2)|0;K=U;U=f[P>>2]|0;f[P>>2]=$a}while((U|0)<(K|0));f[z+(D<<2)>>2]=$a;J=E;break a}while(0);U=f[l>>2]|0;H=f[y+(D<<2)>>2]|0;T=f[y+(S<<2)>>2]|0;K=H;while(1){P=f[U+(K<<2)>>2]|0;if((P|0)<(K|0))K=P;else break}if((H|0)==(T|0))ab=K;else{P=T;while(1){I=f[U+(P<<2)>>2]|0;if((I|0)<(P|0))P=I;else break}I=(K|0)>(P|0)?P:K;R=T;do{_=U+(R<<2)|0;L=R;R=f[_>>2]|0;f[_>>2]=I}while((R|0)<(L|0));ab=I}I=H;do{R=U+(I<<2)|0;T=I;I=f[R>>2]|0;f[R>>2]=ab}while((I|0)<(T|0));I=f[z+(M<<2)>>2]|0;H=ab;while(1){T=f[U+(H<<2)>>2]|0;if((T|0)<(H|0))H=T;else break}if((ab|0)==(I|0))bb=H;else{T=I;while(1){R=f[U+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(H|0)>(T|0)?T:H;K=I;do{P=U+(K<<2)|0;L=K;K=f[P>>2]|0;f[P>>2]=R}while((K|0)<(L|0));bb=R}R=ab;do{K=U+(R<<2)|0;I=R;R=f[K>>2]|0;f[K>>2]=bb}while((R|0)<(I|0));f[z+(D<<2)>>2]=bb;J=E;break}if(!(b[w+F>>0]|0)){R=f[l>>2]|0;U=f[y+(S<<2)>>2]|0;I=f[z+(M<<2)>>2]|0;K=U;while(1){H=f[R+(K<<2)>>2]|0;if((H|0)<(K|0))K=H;else break}if((U|0)==(I|0))cb=K;else{H=I;while(1){T=f[R+(H<<2)>>2]|0;if((T|0)<(H|0))H=T;else break}T=(K|0)>(H|0)?H:K;L=I;do{P=R+(L<<2)|0;_=L;L=f[P>>2]|0;f[P>>2]=T}while((L|0)<(_|0));cb=T}T=U;do{L=R+(T<<2)|0;I=T;T=f[L>>2]|0;f[L>>2]=cb}while((T|0)<(I|0));f[z+(D<<2)>>2]=cb;J=E;break}do if(C){if(!(b[x+O>>0]|0))break;T=f[y+(S<<2)>>2]|0;R=f[l>>2]|0;if(b[x+D>>0]|0){U=f[z+(M<<2)>>2]|0;I=T;while(1){L=f[R+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((T|0)==(U|0))db=I;else{L=U;while(1){K=f[R+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(I|0)>(L|0)?L:I;H=U;do{_=R+(H<<2)|0;P=H;H=f[_>>2]|0;f[_>>2]=K}while((H|0)<(P|0));db=K}K=T;do{H=R+(K<<2)|0;U=K;K=f[H>>2]|0;f[H>>2]=db}while((K|0)<(U|0));f[z+(D<<2)>>2]=db;J=E;break a}K=f[y+(M<<2)>>2]|0;U=K;while(1){H=f[R+(U<<2)>>2]|0;if((H|0)<(U|0))U=H;else break}if((K|0)==(T|0))eb=U;else{H=T;while(1){I=f[R+(H<<2)>>2]|0;if((I|0)<(H|0))H=I;else break}I=(U|0)>(H|0)?H:U;L=T;do{P=R+(L<<2)|0;_=L;L=f[P>>2]|0;f[P>>2]=I}while((L|0)<(_|0));eb=I}I=K;do{L=R+(I<<2)|0;T=I;I=f[L>>2]|0;f[L>>2]=eb}while((I|0)<(T|0));I=f[z+(M<<2)>>2]|0;K=eb;while(1){T=f[R+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}if((eb|0)==(I|0))fb=K;else{T=I;while(1){L=f[R+(T<<2)>>2]|0;if((L|0)<(T|0))T=L;else break}L=(K|0)>(T|0)?T:K;U=I;do{H=R+(U<<2)|0;_=U;U=f[H>>2]|0;f[H>>2]=L}while((U|0)<(_|0));fb=L}L=eb;do{U=R+(L<<2)|0;I=L;L=f[U>>2]|0;f[U>>2]=fb}while((L|0)<(I|0));f[z+(D<<2)>>2]=fb;J=E;break a}while(0);O=f[l>>2]|0;L=f[y+(M<<2)>>2]|0;R=f[y+(S<<2)>>2]|0;I=L;while(1){U=f[O+(I<<2)>>2]|0;if((U|0)<(I|0))I=U;else break}if((L|0)==(R|0))gb=I;else{S=R;while(1){U=f[O+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}U=(I|0)>(S|0)?S:I;K=R;do{T=O+(K<<2)|0;_=K;K=f[T>>2]|0;f[T>>2]=U}while((K|0)<(_|0));gb=U}U=L;do{K=O+(U<<2)|0;R=U;U=f[K>>2]|0;f[K>>2]=gb}while((U|0)<(R|0));U=f[z+(M<<2)>>2]|0;L=gb;while(1){R=f[O+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((gb|0)==(U|0))hb=L;else{M=U;while(1){R=f[O+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}R=(L|0)>(M|0)?M:L;K=U;do{I=O+(K<<2)|0;S=K;K=f[I>>2]|0;f[I>>2]=R}while((K|0)<(S|0));hb=R}R=gb;do{K=O+(R<<2)|0;U=R;R=f[K>>2]|0;f[K>>2]=hb}while((R|0)<(U|0));f[z+(D<<2)>>2]=hb;J=E;break}do if(A){R=D+-2|0;if(b[w+F>>0]|0){O=f[z+(R<<2)>>2]|0;do if((R|0)>-1){if(!(b[v+R>>0]|0))break;f[z+(D<<2)>>2]=O;J=E;break a}while(0);U=f[l>>2]|0;K=f[y+(R<<2)>>2]|0;L=K;while(1){M=f[U+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((K|0)==(O|0))ib=L;else{M=O;while(1){S=f[U+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}S=(L|0)>(M|0)?M:L;I=O;do{_=U+(I<<2)|0;T=I;I=f[_>>2]|0;f[_>>2]=S}while((I|0)<(T|0));ib=S}S=K;do{I=U+(S<<2)|0;O=S;S=f[I>>2]|0;f[I>>2]=ib}while((S|0)<(O|0));f[z+(D<<2)>>2]=ib;J=E;break a}if(!(b[w+D>>0]|0)){jb=R;break}do if((R|0)>-1){if(!(b[v+R>>0]|0))break;if(!(b[w+R>>0]|0)){S=f[l>>2]|0;U=f[y+(D<<2)>>2]|0;K=f[z+(R<<2)>>2]|0;O=U;while(1){I=f[S+(O<<2)>>2]|0;if((I|0)<(O|0))O=I;else break}if((U|0)==(K|0))kb=O;else{I=K;while(1){L=f[S+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}L=(O|0)>(I|0)?I:O;M=K;do{T=S+(M<<2)|0;_=M;M=f[T>>2]|0;f[T>>2]=L}while((M|0)<(_|0));kb=L}L=U;do{M=S+(L<<2)|0;K=L;L=f[M>>2]|0;f[M>>2]=kb}while((L|0)<(K|0));f[z+(D<<2)>>2]=kb;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}while(0);L=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;U=f[z+(R<<2)>>2]|0;K=S;while(1){M=f[L+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}if((S|0)==(U|0))lb=K;else{M=U;while(1){O=f[L+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(K|0)>(M|0)?M:K;I=U;do{_=L+(I<<2)|0;T=I;I=f[_>>2]|0;f[_>>2]=O}while((I|0)<(T|0));lb=O}O=S;do{I=L+(O<<2)|0;U=O;O=f[I>>2]|0;f[I>>2]=lb}while((O|0)<(U|0));f[z+(D<<2)>>2]=lb;J=E;break a}while(0);O=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;S=f[z+(R<<2)>>2]|0;U=L;while(1){I=f[O+(U<<2)>>2]|0;if((I|0)<(U|0))U=I;else break}if((L|0)==(S|0))mb=U;else{R=S;while(1){I=f[O+(R<<2)>>2]|0;if((I|0)<(R|0))R=I;else break}I=(U|0)>(R|0)?R:U;K=S;do{M=O+(K<<2)|0;T=K;K=f[M>>2]|0;f[M>>2]=I}while((K|0)<(T|0));mb=I}I=L;do{K=O+(I<<2)|0;S=I;I=f[K>>2]|0;f[K>>2]=mb}while((I|0)<(S|0));f[z+(D<<2)>>2]=mb;J=E;break a}else jb=D+-2|0;while(0);f[z+(D<<2)>>2]=f[z+(jb<<2)>>2];J=E;break}if(A){I=D+-2|0;if(b[w+F>>0]|0){O=f[z+(I<<2)>>2]|0;do if((I|0)>-1){if(!(b[v+I>>0]|0))break;f[z+(D<<2)>>2]=O;J=E;break a}while(0);L=f[l>>2]|0;S=f[y+(I<<2)>>2]|0;K=S;while(1){U=f[L+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}if((S|0)==(O|0))nb=K;else{U=O;while(1){R=f[L+(U<<2)>>2]|0;if((R|0)<(U|0))U=R;else break}R=(K|0)>(U|0)?U:K;T=O;do{M=L+(T<<2)|0;_=T;T=f[M>>2]|0;f[M>>2]=R}while((T|0)<(_|0));nb=R}R=S;do{T=L+(R<<2)|0;O=R;R=f[T>>2]|0;f[T>>2]=nb}while((R|0)<(O|0));f[z+(D<<2)>>2]=nb;J=E;break}if(!(b[w+D>>0]|0))ob=I;else{do if((I|0)>-1){if(!(b[v+I>>0]|0))break;if(!(b[w+I>>0]|0)){R=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;S=f[z+(I<<2)>>2]|0;O=L;while(1){T=f[R+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}if((L|0)==(S|0))pb=O;else{T=S;while(1){K=f[R+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(O|0)>(T|0)?T:O;U=S;do{_=R+(U<<2)|0;M=U;U=f[_>>2]|0;f[_>>2]=K}while((U|0)<(M|0));pb=K}K=L;do{U=R+(K<<2)|0;S=K;K=f[U>>2]|0;f[U>>2]=pb}while((K|0)<(S|0));f[z+(D<<2)>>2]=pb;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[z+(I<<2)>>2];J=E;break a}while(0);K=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;L=f[z+(I<<2)>>2]|0;S=R;while(1){U=f[K+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}if((R|0)==(L|0))qb=S;else{U=L;while(1){O=f[K+(U<<2)>>2]|0;if((O|0)<(U|0))U=O;else break}O=(S|0)>(U|0)?U:S;T=L;do{M=K+(T<<2)|0;_=T;T=f[M>>2]|0;f[M>>2]=O}while((T|0)<(_|0));qb=O}O=R;do{T=K+(O<<2)|0;L=O;O=f[T>>2]|0;f[T>>2]=qb}while((O|0)<(L|0));f[z+(D<<2)>>2]=qb;J=E;break a}while(0);O=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;R=f[z+(I<<2)>>2]|0;L=K;while(1){T=f[O+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}if((K|0)==(R|0))rb=L;else{I=R;while(1){T=f[O+(I<<2)>>2]|0;if((T|0)<(I|0))I=T;else break}T=(L|0)>(I|0)?I:L;S=R;do{U=O+(S<<2)|0;_=S;S=f[U>>2]|0;f[U>>2]=T}while((S|0)<(_|0));rb=T}T=K;do{S=O+(T<<2)|0;R=T;T=f[S>>2]|0;f[S>>2]=rb}while((T|0)<(R|0));f[z+(D<<2)>>2]=rb;J=E;break}}else ob=D+-2|0;f[z+(D<<2)>>2]=f[z+(ob<<2)>>2];J=E;break}}T=D|1;O=(T|0)<(n|0);if(!(B|O^1)?b[w+T>>0]|0:0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(G?b[w+F>>0]|0:0){K=f[y+(D<<2)>>2]|0;if(C?b[x+D>>0]|0:0){f[z+(D<<2)>>2]=K;J=E;break}R=f[l>>2]|0;S=f[y+(D+-2<<2)>>2]|0;L=S;while(1){I=f[R+(L<<2)>>2]|0;if((I|0)<(L|0))L=I;else break}if((S|0)==(K|0))sb=L;else{I=K;while(1){_=f[R+(I<<2)>>2]|0;if((_|0)<(I|0))I=_;else break}_=(L|0)>(I|0)?I:L;U=K;do{M=R+(U<<2)|0;H=U;U=f[M>>2]|0;f[M>>2]=_}while((U|0)<(H|0));sb=_}_=S;do{U=R+(_<<2)|0;K=_;_=f[U>>2]|0;f[U>>2]=sb}while((_|0)<(K|0));f[z+(D<<2)>>2]=sb;J=E;break}f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(O?b[v+T>>0]|0:0){_=D+2|0;if(!((_|0)>=(n|0)|B)?b[w+_>>0]|0:0){if(b[w+D>>0]|0){if(C?b[x+T>>0]|0:0){f[z+(D<<2)>>2]=f[y+(_<<2)>>2];J=E;break}R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;K=f[y+(_<<2)>>2]|0;U=S;while(1){L=f[R+(U<<2)>>2]|0;if((L|0)<(U|0))U=L;else break}if((S|0)==(K|0))tb=U;else{O=K;while(1){L=f[R+(O<<2)>>2]|0;if((L|0)<(O|0))O=L;else break}L=(U|0)>(O|0)?O:U;I=K;do{H=R+(I<<2)|0;M=I;I=f[H>>2]|0;f[H>>2]=L}while((I|0)<(M|0));tb=L}L=S;do{I=R+(L<<2)|0;K=L;L=f[I>>2]|0;f[I>>2]=tb}while((L|0)<(K|0));f[z+(D<<2)>>2]=tb;J=E;break}if(G?b[w+F>>0]|0:0){do if(C){if(!(b[x+T>>0]|0))break;L=f[y+(_<<2)>>2]|0;if(b[x+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}R=f[l>>2]|0;S=f[y+(D+-2<<2)>>2]|0;K=S;while(1){I=f[R+(K<<2)>>2]|0;if((I|0)<(K|0))K=I;else break}if((S|0)==(L|0))ub=K;else{I=L;while(1){U=f[R+(I<<2)>>2]|0;if((U|0)<(I|0))I=U;else break}U=(K|0)>(I|0)?I:K;O=L;do{M=R+(O<<2)|0;H=O;O=f[M>>2]|0;f[M>>2]=U}while((O|0)<(H|0));ub=U}U=S;do{O=R+(U<<2)|0;L=U;U=f[O>>2]|0;f[O>>2]=ub}while((U|0)<(L|0));f[z+(D<<2)>>2]=ub;J=E;break a}while(0);T=f[l>>2]|0;U=f[y+(D+-2<<2)>>2]|0;R=f[y+(_<<2)>>2]|0;S=U;while(1){L=f[T+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((U|0)==(R|0))vb=S;else{L=R;while(1){O=f[T+(L<<2)>>2]|0;if((O|0)<(L|0))L=O;else break}O=(S|0)>(L|0)?L:S;K=R;do{I=T+(K<<2)|0;H=K;K=f[I>>2]|0;f[I>>2]=O}while((K|0)<(H|0));vb=O}O=U;do{K=T+(O<<2)|0;R=O;O=f[K>>2]|0;f[K>>2]=vb}while((O|0)<(R|0));f[z+(D<<2)>>2]=vb;J=E;break}f[z+(D<<2)>>2]=f[y+(_<<2)>>2];J=E;break}if(A?b[w+D>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(!(B|G^1)?b[w+F>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}if(A?b[w+D>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(!(B|G^1)?b[w+F>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0}while(0);D=D+2|0;if((D|0)>=(n|0)){wb=J;break}else E=J}}else wb=a;s=s+2|0;if((s|0)>=(f[d>>2]|0))break;else a=wb}o=f[g>>2]|0;p=wb;q=p-j|0;r=o+(c<<2)|0;f[r>>2]=q;return}function U6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=f[a+12>>2]|0;e=f[a+8>>2]|0;g=f[c>>2]|0;if((g|0)>=(e|0))return;h=f[a+16>>2]|0;i=f[a+44>>2]|0;a=(d|0)>0;j=d+-1|0;k=g;do{g=f[i>>2]|0;l=h+(Y(g,k)|0)|0;m=l+(0-g)|0;if(a){g=0;do{n=l+(g<<2)|0;o=f[n>>2]|0;if((o|0)>0){if((g|0)>0?(p=f[m+(g+-1<<2)>>2]|0,(p|0)>0):0){q=p;while(1){r=f[b+(q<<2)>>2]|0;if((r|0)<(q|0))q=r;else break}if((p|0)==(o|0))s=q;else{r=o;while(1){t=f[b+(r<<2)>>2]|0;if((t|0)<(r|0))r=t;else break}t=(q|0)>(r|0)?r:q;u=o;do{v=b+(u<<2)|0;w=u;u=f[v>>2]|0;f[v>>2]=t}while((u|0)<(w|0));s=t}t=p;do{u=b+(t<<2)|0;q=t;t=f[u>>2]|0;f[u>>2]=s}while((t|0)<(q|0));f[n>>2]=s;x=s}else x=o;if((g|0)<(j|0)?(t=f[m+(g+1<<2)>>2]|0,(t|0)>0):0){p=t;while(1){q=f[b+(p<<2)>>2]|0;if((q|0)<(p|0))p=q;else break}if((t|0)==(x|0))y=p;else{o=x;while(1){q=f[b+(o<<2)>>2]|0;if((q|0)<(o|0))o=q;else break}q=(p|0)>(o|0)?o:p;u=x;do{r=b+(u<<2)|0;w=u;u=f[r>>2]|0;f[r>>2]=q}while((u|0)<(w|0));y=q}q=t;do{u=b+(q<<2)|0;p=q;q=f[u>>2]|0;f[u>>2]=y}while((q|0)<(p|0));f[n>>2]=y;z=y}else z=x;q=f[m+(g<<2)>>2]|0;if((q|0)>0){t=q;while(1){p=f[b+(t<<2)>>2]|0;if((p|0)<(t|0))t=p;else break}if((q|0)==(z|0))A=t;else{p=z;while(1){u=f[b+(p<<2)>>2]|0;if((u|0)<(p|0))p=u;else break}u=(t|0)>(p|0)?p:t;o=z;do{w=b+(o<<2)|0;r=o;o=f[w>>2]|0;f[w>>2]=u}while((o|0)<(r|0));A=u}u=q;do{o=b+(u<<2)|0;t=u;u=f[o>>2]|0;f[o>>2]=A}while((u|0)<(t|0));f[n>>2]=A}}g=g+1|0}while((g|0)!=(d|0))}k=f[c+(k<<2)>>2]|0}while((k|0)<(e|0));return}function V6(a){a=a|0;PYa(a);return}function W6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=f[b>>2]|0;d=f[b+4>>2]|0;if((c|0)>0){b=a+16|0;Q6((f[b>>2]|0)+(c*136|0)|0,f[f[a+20>>2]>>2]|0);e=f[b>>2]|0;f[e+(c*136|0)+132>>2]=d;if((c|0)>=(d|0))return;b=a+4|0;g=a+8|0;h=e+(c*136|0)+20|0;i=e+(c*136|0)+48|0;j=e+(c*136|0)+120|0;e=c;do{k=f[b>>2]|0;l=(f[k+16>>2]|0)+(Y(f[f[k+44>>2]>>2]|0,e)|0)|0;m=l+(f[k+12>>2]<<2)|0;if((l|0)!=(m|0)){k=f[g>>2]|0;n=f[h>>2]|0;o=f[i>>2]|0;p=f[j>>2]|0;q=((e|0)<0)<<31>>31;r=0;s=l;while(1){l=f[k+(f[s>>2]<<2)>>2]|0;f[s>>2]=l;t=n+(Y(f[o>>2]|0,l)|0)|0;u=f[t>>2]|0;f[t>>2]=(u|0)>(r|0)?r:u;u=t+8|0;v=f[u>>2]|0;f[u>>2]=(v|0)<(r|0)?r:v;v=t+4|0;u=f[v>>2]|0;f[v>>2]=(u|0)>(e|0)?e:u;u=t+12|0;v=f[u>>2]|0;f[u>>2]=(v|0)<(e|0)?e:v;v=t+16|0;f[v>>2]=(f[v>>2]|0)+1;v=p+(l<<4)|0;t=v;u=C1a(f[t>>2]|0,f[t+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;t=v;f[t>>2]=u;f[t+4>>2]=J;t=p+(l<<4)+8|0;l=t;u=C1a(f[l>>2]|0,f[l+4>>2]|0,e|0,q|0)|0;l=t;f[l>>2]=u;f[l+4>>2]=J;s=s+4|0;if((s|0)==(m|0))break;else r=r+1|0}}e=e+1|0}while((e|0)!=(d|0));return}else{e=a+12|0;f[(f[e>>2]|0)+132>>2]=d;if((c|0)>=(d|0))return;j=a+4|0;i=a+8|0;a=c;do{c=f[j>>2]|0;h=(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,a)|0)|0;g=h+(f[c+12>>2]<<2)|0;if((h|0)!=(g|0)){c=f[i>>2]|0;b=((a|0)<0)<<31>>31;r=0;m=h;while(1){h=f[c+(f[m>>2]<<2)>>2]|0;f[m>>2]=h;s=f[e>>2]|0;q=(f[s+20>>2]|0)+(Y(f[f[s+48>>2]>>2]|0,h)|0)|0;p=f[q>>2]|0;f[q>>2]=(p|0)>(r|0)?r:p;p=q+8|0;o=f[p>>2]|0;f[p>>2]=(o|0)<(r|0)?r:o;o=q+4|0;p=f[o>>2]|0;f[o>>2]=(p|0)>(a|0)?a:p;p=q+12|0;o=f[p>>2]|0;f[p>>2]=(o|0)<(a|0)?a:o;o=q+16|0;f[o>>2]=(f[o>>2]|0)+1;o=f[s+120>>2]|0;s=o+(h<<4)|0;q=s;p=C1a(f[q>>2]|0,f[q+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;q=s;f[q>>2]=p;f[q+4>>2]=J;q=o+(h<<4)+8|0;h=q;o=C1a(f[h>>2]|0,f[h+4>>2]|0,a|0,b|0)|0;h=q;f[h>>2]=o;f[h+4>>2]=J;m=m+4|0;if((m|0)==(g|0))break;else r=r+1|0}}a=a+1|0}while((a|0)!=(d|0));return}}function X6(a){a=a|0;PYa(a);return}function Y6(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=f[c>>2]|0;e=c+4|0;c=f[a+16>>2]|0;f[c+(d<<2)>>2]=f[e>>2];g=a+8|0;h=f[g>>2]|0;i=(((Y(f[h+12>>2]|0,d)|0)+1|0)/2|0)+1|0;j=a+4|0;k=f[j>>2]|0;l=f[k+12>>2]|0;if((d|0)==(f[e>>2]|0)){m=i;n=m-i|0;o=d+1|0;p=c+(o<<2)|0;f[p>>2]=n;return}q=(l|0)>0;r=a+12|0;a=i;s=d;t=h;h=k;while(1){k=f[f[h+44>>2]>>2]|0;u=(f[h+16>>2]|0)+(Y(k,s)|0)|0;v=u+(0-k)|0;k=f[f[t+44>>2]>>2]|0;w=(f[t+16>>2]|0)+(Y(k,s)|0)|0;x=w+(0-k)|0;a:do if(q){if((s|0)>(d|0)){y=0;z=a}else{k=0;A=a;while(1){do if(!(b[u+k>>0]|0)){f[w+(k<<2)>>2]=0;B=A}else{if((k|0)>0?(C=k+-1|0,b[u+C>>0]|0):0){f[w+(k<<2)>>2]=f[w+(C<<2)>>2];B=A;break}f[w+(k<<2)>>2]=A;f[(f[r>>2]|0)+(A<<2)>>2]=A;B=A+1|0}while(0);k=k+1|0;if((k|0)==(l|0)){D=B;break a}else A=B}}while(1){do if(!(b[u+y>>0]|0)){f[w+(y<<2)>>2]=0;E=z}else{A=(y|0)>0;if(!(b[v+y>>0]|0)){if(A?(k=y+-1|0,b[u+k>>0]|0):0){f[w+(y<<2)>>2]=f[w+(k<<2)>>2];E=z;break}f[w+(y<<2)>>2]=z;f[(f[r>>2]|0)+(z<<2)>>2]=z;E=z+1|0;break}k=f[x+(y<<2)>>2]|0;if(A?(A=y+-1|0,(b[u+A>>0]|0)!=0):0){C=f[r>>2]|0;F=f[w+(A<<2)>>2]|0;A=F;while(1){G=f[C+(A<<2)>>2]|0;if((G|0)<(A|0))A=G;else break}if((F|0)==(k|0))H=A;else{G=k;while(1){I=f[C+(G<<2)>>2]|0;if((I|0)<(G|0))G=I;else break}I=(A|0)>(G|0)?G:A;J=k;do{K=C+(J<<2)|0;L=J;J=f[K>>2]|0;f[K>>2]=I}while((J|0)<(L|0));H=I}I=F;do{J=C+(I<<2)|0;A=I;I=f[J>>2]|0;f[J>>2]=H}while((I|0)<(A|0));M=H}else M=k;f[w+(y<<2)>>2]=M;E=z}while(0);y=y+1|0;if((y|0)==(l|0)){D=E;break}else z=E}}else D=a;while(0);w=s+1|0;if((w|0)==(f[e>>2]|0)){m=D;break}a=D;s=w;t=f[g>>2]|0;h=f[j>>2]|0}n=m-i|0;o=d+1|0;p=c+(o<<2)|0;f[p>>2]=n;return}function Z6(a){a=a|0;PYa(a);return}function _6(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=f[c>>2]|0;e=c+4|0;c=f[a+16>>2]|0;f[c+(d<<2)>>2]=f[e>>2];g=d+1|0;h=a+8|0;i=f[h>>2]|0;j=(Y(((f[i+12>>2]|0)+1|0)/2|0,(g|0)/2|0)|0)+1|0;k=a+4|0;l=f[k>>2]|0;m=f[l+12>>2]|0;n=f[e>>2]|0;if((d|0)==(n|0)){o=j;p=o-j|0;q=c+(g<<2)|0;f[q>>2]=p;return}r=(m|0)>0;s=m+-1|0;t=a+12|0;a=n;n=j;u=d;v=i;i=l;while(1){l=f[f[i+44>>2]>>2]|0;w=(f[i+16>>2]|0)+(Y(l,u)|0)|0;x=w+(0-l)|0;l=f[f[v+44>>2]>>2]|0;y=(f[v+16>>2]|0)+(Y(l,u)|0)|0;z=y+(0-l)|0;if(r){l=(u|0)>(d|0);A=l^1;B=0;C=n;while(1){a:do if(!(b[w+B>>0]|0)){f[y+(B<<2)>>2]=0;D=C}else{if(l){if(b[x+B>>0]|0){f[y+(B<<2)>>2]=f[z+(B<<2)>>2];D=C;break}if(!((B|0)>=(s|0)|A)){E=B+1|0;if(!(b[x+E>>0]|0))F=0;else{do if((B|0)>0){G=B+-1|0;if(!(b[x+G>>0]|0)){H=f[z+(E<<2)>>2]|0;if(!(b[w+G>>0]|0)){I=H;break}J=f[t>>2]|0;K=f[y+(G<<2)>>2]|0;L=K;while(1){M=f[J+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((K|0)==(H|0))N=L;else{M=H;while(1){O=f[J+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(L|0)>(M|0)?M:L;P=H;do{Q=J+(P<<2)|0;R=P;P=f[Q>>2]|0;f[Q>>2]=O}while((P|0)<(R|0));N=O}O=K;do{P=J+(O<<2)|0;H=O;O=f[P>>2]|0;f[P>>2]=N}while((O|0)<(H|0));I=N}else{O=f[t>>2]|0;J=f[z+(G<<2)>>2]|0;K=f[z+(E<<2)>>2]|0;H=J;while(1){P=f[O+(H<<2)>>2]|0;if((P|0)<(H|0))H=P;else break}if((J|0)==(K|0))S=H;else{G=K;while(1){P=f[O+(G<<2)>>2]|0;if((P|0)<(G|0))G=P;else break}P=(H|0)>(G|0)?G:H;L=K;do{M=O+(L<<2)|0;R=L;L=f[M>>2]|0;f[M>>2]=P}while((L|0)<(R|0));S=P}P=J;do{L=O+(P<<2)|0;K=P;P=f[L>>2]|0;f[L>>2]=S}while((P|0)<(K|0));f[y+(B<<2)>>2]=S;D=C;break a}}else I=f[z+(E<<2)>>2]|0;while(0);f[y+(B<<2)>>2]=I;D=C;break}}else F=A}else F=A;E=(B|0)>0;if(!(F|E^1)?(P=B+-1|0,b[x+P>>0]|0):0){f[y+(B<<2)>>2]=f[z+(P<<2)>>2];D=C;break}if(E?(E=B+-1|0,b[w+E>>0]|0):0){f[y+(B<<2)>>2]=f[y+(E<<2)>>2];D=C;break}f[y+(B<<2)>>2]=C;f[(f[t>>2]|0)+(C<<2)>>2]=C;D=C+1|0}while(0);B=B+1|0;if((B|0)==(m|0))break;else C=D}T=f[e>>2]|0;U=D}else{T=a;U=n}C=u+1|0;if((C|0)==(T|0)){o=U;break}a=T;n=U;u=C;v=f[h>>2]|0;i=f[k>>2]|0}p=o-j|0;q=c+(g<<2)|0;f[q>>2]=p;return}function $6(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;if(!((a|0)!=0&(c|0)!=0)){f[e>>2]=0;f[e+4>>2]=0;j$(-27,e,219266,219289,60);d$(e)}if(!((f[a+28>>2]|0)==1?(f[a+4>>2]|0)>=64:0)){f[e>>2]=0;f[e+4>>2]=0;j$(-201,e,219266,219289,63);d$(e)}CL(a,c,0);e=a+56|0;a=f[e+4>>2]|0;g=c+36|0;f[g>>2]=f[e>>2];f[g+4>>2]=a;b[c+44>>0]=1;b[c+45>>0]=0;b[c+46>>0]=1;b[c+47>>0]=-1;b[c+48>>0]=0;a=c+49|0;b[a>>0]=-1;b[a+1>>0]=-1>>8;b[a+2>>0]=-1>>16;b[a+3>>0]=-1>>24;b[c+53>>0]=0;b[c+54>>0]=-1;b[c+55>>0]=1;b[c+56>>0]=0;b[c+57>>0]=1;b[c+58>>0]=1;b[c+59>>0]=1;u=d;return}function a7(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=u;u=u+48|0;l=k+8|0;m=k;if(!c){f[l>>2]=0;f[l+4>>2]=0;j$(-27,l,219342,219289,188);d$(l)}n=F0(a,l,0,0)|0;l=f[n>>2]|0;a=(l&4095|0)==4;o=(e|0)==2&a?4:e;if(!((l&4094|0)==0&(o|0)<4|a&(o|0)==4)){f[m>>2]=0;f[m+4>>2]=0;p=c$(m,119)|0;q=219367;r=p+119|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-210,m,219342,219289,199);d$(m)}a=f[n+24>>2]|0;l=f[n+20>>2]|0;e=f[n+4>>2]|0;s=f[n+16>>2]|0;if(g>>>0>4){f[m>>2]=0;f[m+4>>2]=0;j$(-211,m,219342,219289,206);d$(m)}t=(g|0)==0;if(((t?64:88)|0)>(d|0)){f[m>>2]=0;f[m+4>>2]=0;j$(-201,m,219342,219289,209);d$(m)}v=_F(788)|0;F1a(v+8|0,0,780)|0;w=v+4|0;f[w>>2]=c;f[v>>2]=c;f[v+40>>2]=s;x=s+e|0;f[v+44>>2]=x;f[v+48>>2]=e;y=a+-1|0;f[v+52>>2]=y;z=l+-1|0;f[v+56>>2]=z;f[v+244>>2]=o;A=v+60|0;f[A>>2]=h;f[A+4>>2]=i;f[v+72>>2]=1;f[v+68>>2]=1;f[v+76>>2]=0;f[v+80>>2]=1;f[v+84>>2]=2;i=v+180|0;f[v+148>>2]=i;f[v+176>>2]=1;f[v+140>>2]=0;f[v+144>>2]=0;A=v+152|0;f[A>>2]=0;f[A+4>>2]=0;f[v+160>>2]=a;f[v+164>>2]=l;f[v+88>>2]=0;f[v+248>>2]=0;f[i>>2]=32768;i=v+236|0;f[i>>2]=g;f[v+240>>2]=g;do if((g+-3|0)>>>0>=2){A=v+252|0;if(t){f[A>>2]=20480;B=d;C=1;D=0;E=20480;F=A;break}else{f[A>>2]=20492;B=d;C=8;D=g;E=20492;F=A;break}}else{f[i>>2]=0;A=v+252|0;f[A>>2]=20480;B=64;C=1;D=g;E=20480;F=A}while(0);f[v+256>>2]=B;f[v+260>>2]=C;f[v+268>>2]=d;d=(D|0)==0;D=v+264|0;f[D>>2]=d?E:20492;f[v+272>>2]=d?C:8;f[F>>2]=E;f[D>>2]=t?20480:20492;tL(c,v+16|0);if((g|0)>2){g=qL(f[w>>2]|0)|0;f[v>>2]=g}if((o|0)>1){o=qL(f[w>>2]|0)|0;f[v+8>>2]=o;w=UL(0,64,44,o)|0;f[v+12>>2]=w}if((e|0)<=-1){f[m>>2]=0;f[m+4>>2]=0;p=c$(m,9)|0;q=219487;r=p+9|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,m,219342,219289,289);d$(m)}if((l|0)<=0){f[m>>2]=0;f[m+4>>2]=0;p=c$(m,16)|0;q=219497;r=p+16|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,m,219342,219289,290);d$(m)}if((j|0?(j=f[n>>2]|0,m=(j>>>3&511)+1<<(47696>>>(j<<1&14)&3),j=Y(m,a)|0,F1a(s|0,0,j|0)|0,F1a(s+(Y(e,z)|0)|0,0,j|0)|0,(z|0)>1):0)?(j=Y(m,y)|0,(m|0)>0):0){y=x;x=1;while(1){s=0;do{b[y+(s+j)>>0]=0;b[y+s>>0]=0;s=s+1|0}while((s|0)!=(m|0));x=x+1|0;if((x|0)==(z|0))break;else y=y+e|0}}if((f[n>>2]&4095|0)==4){u=k;return v|0}+mqa(n,n,0.0,1.0,0);u=k;return v|0}function b7(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0;c=u;u=u+128|0;d=c+104|0;e=c+88|0;g=c+80|0;h=c+72|0;i=c+8|0;j=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;j$(-27,d,219514,219289,1012);d$(d)}k=a+48|0;if((f[k>>2]|0)<=-1){f[d>>2]=0;f[d+4>>2]=0;l=c$(d,22)|0;m=219532;n=l+22|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-215,d,219514,219289,1018);d$(d)}o=a+88|0;p=f[o>>2]|0;if(p|0){q=a+248|0;if(f[q>>2]|0){r=a+4|0;tL(f[r>>2]|0,d);if((f[d>>2]|0)==(f[a+32>>2]|0)?(f[d+4>>2]|0)==(f[a+36>>2]|0):0)uL(f[r>>2]|0,a+24|0);f[q>>2]=0}q=f[p+12>>2]|0;if(q|0)dM(q,f[(f[p+8>>2]|0)+12>>2]|0,a+180|0);f[o>>2]=0}p=f[a+40>>2]|0;q=a+44|0;r=f[q>>2]|0;s=f[k>>2]|0;k=s>>>2;t=a+68|0;v=f[t>>2]|0;w=a+72|0;x=f[w>>2]|0;y=f[a+52>>2]|0;z=f[a+56>>2]|0;A=f[a+244>>2]|0;B=a+76|0;C=a+80|0;D=a+84|0;E=v+-1|0;F=(A|0)==4;if(F){G=-1073741824;H=f[r+(E<<2)>>2]|0}else{G=-2;H=b[r+E>>0]|0}if((x|0)>=(z|0)){I=0;u=c;return I|0}E=~G;J=(A|0)==0;K=a+136|0;L=a+4|0;M=a+24|0;N=a+252|0;O=a+256|0;P=a+260|0;Q=a+92|0;R=a+60|0;S=a+64|0;T=a+236|0;U=0-s|0;V=1-s|0;W=i+4|0;X=i+8|0;Z=~s;_=i+12|0;$=i+16|0;aa=s+-1|0;ba=i+20|0;ca=i+24|0;da=s+1|0;ea=i+28|0;fa=i+32|0;ga=d+12|0;ha=d+20|0;ia=e+4|0;ja=a+240|0;ka=a+268|0;la=a+12|0;ma=d+4|0;na=0-k|0;oa=1-k|0;pa=~k;qa=k+-1|0;ra=k+1|0;sa=d+12|0;ta=d+20|0;ua=h+4|0;va=d+12|0;wa=d+20|0;xa=h+4|0;ya=(A|0)<2;za=d+4|0;Aa=d+4|0;Ba=d+4|0;Ca=d+4|0;Da=F?p:0;Ea=(Da|0)!=0;Fa=r;r=f[B>>2]|0;Ga=f[C>>2]|0;Ha=f[D>>2]|0;Ia=H;H=v;v=x;a:while(1){x=F?Fa:0;b:do if((H|0)<(y|0)){Ja=(x|0)!=0;Ka=Y(Ga,s)|0;La=Y(Ga,k)|0;Ma=r;Na=Ha;Oa=0;Pa=Ia;Qa=H;while(1){Ra=(Qa|0)<(y|0);c:do if(Ja)if(Ra){Sa=Pa;Ta=Qa;while(1){Ua=f[x+(Ta<<2)>>2]|0;if((Ua|0)!=(Sa|0)?(Ua^Sa)&E|0:0){Va=Ua;Wa=Sa;Xa=Ta;break c}Ya=Ta+1|0;if((Ya|0)<(y|0)){Sa=Ua;Ta=Ya}else{Va=Ua;Wa=Ua;Xa=Ya;break}}}else{Va=Oa;Wa=Pa;Xa=Qa}else if(Ra){Ta=Qa;while(1){Sa=b[Fa+Ta>>0]|0;if((Sa|0)!=(Pa|0)){Va=Sa;Wa=Pa;Xa=Ta;break c}Sa=Ta+1|0;if((Sa|0)<(y|0))Ta=Sa;else{Va=Pa;Wa=Pa;Xa=Sa;break}}}else{Va=Oa;Wa=Pa;Xa=Qa}while(0);if((Xa|0)>=(y|0)){Za=Na;break b}if(Ja){Ra=(Wa&G|0)!=0;Ta=(Va&G|0)==0;if(!(((Wa|0)==0|Ra)&Ta))if(Ta&(Ra^1)){_a=Ra;$a=35}else{ab=Ma;bb=Na;cb=Va}else{db=0;eb=Ma;$a=36}}else if(!((Wa|0)==0&(Va|0)==1))if((Wa|0)<1|(Va|0)!=0){ab=Ma;bb=Na;cb=Va}else{_a=(Wa&G|0)!=0;$a=35}else{db=0;eb=Ma;$a=36}if(($a|0)==35){$a=0;db=1;eb=_a?Xa+-1|0:Ma;$a=36}d:do if(($a|0)==36){$a=0;e:do if(J){if(db|0){ab=eb;bb=Na;cb=Va;break d}if((b[p+(eb+Ka)>>0]|0)>0){ab=eb;bb=Na;cb=Va;break d}else{fb=1;gb=K;hb=Xa}}else{Ra=Xa-db|0;if(!ya){if(!db)switch(A|0){case 2:case 4:{fb=0;gb=K;hb=Ra;break e;break}default:{}}if((eb|0)>=1){if(Ea)ib=f[Da+(eb+La<<2)>>2]|0;else ib=b[p+(eb+Ka)>>0]|0;Ta=f[a+276+((ib&127)<<2)>>2]|0;if(!Ta){$a=80;break a}Sa=x+(eb<<2)|0;Ya=Fa+eb|0;Ua=Ta;Ta=0;f:while(1){do if((eb-(f[Ua+16>>2]|0)|0)>>>0<(f[Ua+24>>2]|0)>>>0){if((Ga-(f[Ua+20>>2]|0)|0)>>>0>=(f[Ua+28>>2]|0)>>>0){jb=Ta;break}if(!Ta){jb=Ua;break}kb=f[Ta+36>>2]|0;if(!Ea){lb=p+(Y(kb,s)|0)|0;mb=lb+(f[Ta+32>>2]|0)|0;lb=f[Ta+40>>2]|0;f[i>>2]=1;f[W>>2]=V;f[X>>2]=U;f[_>>2]=Z;f[$>>2]=-1;f[ba>>2]=aa;f[ca>>2]=s;f[ea>>2]=da;f[fa>>2]=f[i>>2];f[fa+4>>2]=f[i+4>>2];f[fa+8>>2]=f[i+8>>2];f[fa+12>>2]=f[i+12>>2];f[fa+16>>2]=f[i+16>>2];f[fa+20>>2]=f[i+20>>2];f[fa+24>>2]=f[i+24>>2];f[fa+28>>2]=f[i+28>>2];nb=lb|0?0:4;lb=nb;do{lb=lb+7&7;ob=mb+(f[i+(lb<<2)>>2]|0)|0;pb=(lb|0)==(nb|0)}while(!((b[ob>>0]|0)!=0|pb));g:do if(pb)qb=mb;else{nb=mb;rb=lb;while(1){sb=rb;while(1){tb=sb+1|0;ub=nb+(f[i+(tb<<2)>>2]|0)|0;if(!ub){f[d>>2]=0;f[Ca>>2]=0;vb=c$(d,8)|0;wb=vb;b[wb>>0]=105;b[wb+1>>0]=52;b[wb+2>>0]=32;b[wb+3>>0]=33;wb=vb+4|0;b[wb>>0]=61;b[wb+1>>0]=32;b[wb+2>>0]=48;b[wb+3>>0]=76;j$(-215,d,219585,219289,668);d$(d)}if((tb|0)<15&(b[ub>>0]|0)==0)sb=tb;else break}if((nb|0)==(Ya|0)){$a=74;break f}if((nb|0)==(ob|0)&(ub|0)==(mb|0)){qb=ob;break g}nb=ub;rb=sb+5&7}}while(0);if((qb|0)==(Ya|0)){xb=Ta;break f}else{jb=Ua;break}}mb=Da+((Y(kb,k)|0)<<2)|0;lb=mb+(f[Ta+32>>2]<<2)|0;mb=f[Ta+40>>2]|0;if(!lb){f[d>>2]=0;f[Aa>>2]=0;l=c$(d,9)|0;m=219555;n=l+9|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-215,d,219565,219289,820);d$(d)}kb=f[lb>>2]&1073741823;f[i>>2]=1;f[W>>2]=oa;f[X>>2]=na;f[_>>2]=pa;f[$>>2]=-1;f[ba>>2]=qa;f[ca>>2]=k;f[ea>>2]=ra;f[fa>>2]=f[i>>2];f[fa+4>>2]=f[i+4>>2];f[fa+8>>2]=f[i+8>>2];f[fa+12>>2]=f[i+12>>2];f[fa+16>>2]=f[i+16>>2];f[fa+20>>2]=f[i+20>>2];f[fa+24>>2]=f[i+24>>2];f[fa+28>>2]=f[i+28>>2];rb=mb|0?0:4;nb=rb;do{nb=nb+7&7;yb=lb+(f[i+(nb<<2)>>2]<<2)|0;zb=(nb|0)==(rb|0)}while(!(zb|(f[yb>>2]&1073741823|0)==(kb|0)));h:do if(zb)Ab=lb;else{rb=lb;mb=nb;while(1){tb=mb;while(1){wb=tb+1|0;Bb=rb+(f[i+(wb<<2)>>2]<<2)|0;if(!Bb){f[d>>2]=0;f[Ba>>2]=0;vb=c$(d,8)|0;Cb=vb;b[Cb>>0]=105;b[Cb+1>>0]=52;b[Cb+2>>0]=32;b[Cb+3>>0]=33;Cb=vb+4|0;b[Cb>>0]=61;b[Cb+1>>0]=32;b[Cb+2>>0]=48;b[Cb+3>>0]=76;j$(-215,d,219565,219289,857);d$(d)}if((wb|0)<15?(f[Bb>>2]&1073741823|0)!=(kb|0):0)tb=wb;else break}if((rb|0)==(Sa|0)){$a=62;break f}if((rb|0)==(yb|0)&(Bb|0)==(lb|0)){Ab=yb;break h}rb=Bb;mb=tb+5&7}}while(0);if((Ab|0)==(Sa|0)){xb=Ta;break f}else jb=Ua}else jb=Ta;while(0);Ua=f[Ua+4>>2]|0;if(!Ua){xb=jb;break}else Ta=jb}if(($a|0)==62){$a=0;xb=Ta}else if(($a|0)==74){$a=0;xb=Ta}if(!xb){$a=80;break a}if((f[xb+40>>2]|0)==(db|0)){Ua=f[xb+8>>2]|0;Db=(Ua|0)==0?K:Ua}else Db=xb;if(!(f[Db+12>>2]|0)){ab=eb;bb=Na;cb=Va;break d}else{fb=0;gb=Db;hb=Ra}}else{fb=0;gb=K;hb=Ra}}else{fb=1;gb=K;hb=Ra}}while(0);tL(f[L>>2]|0,M);Ua=yL(f[N>>2]|0,f[O>>2]|0,f[P>>2]|0,f[a>>2]|0)|0;f[Ua>>2]=f[Ua>>2]|(db|0?32768:0);if(fb){Sa=Fa+Xa+(0-db)|0;Ya=(f[R>>2]|0)+hb|0;lb=(f[S>>2]|0)+v|0;kb=f[T>>2]|0;f[i>>2]=1;f[W>>2]=V;f[X>>2]=U;f[_>>2]=Z;f[$>>2]=-1;f[ba>>2]=aa;f[ca>>2]=s;f[ea>>2]=da;f[fa>>2]=f[i>>2];f[fa+4>>2]=f[i+4>>2];f[fa+8>>2]=f[i+8>>2];f[fa+12>>2]=f[i+12>>2];f[fa+16>>2]=f[i+16>>2];f[fa+20>>2]=f[i+20>>2];f[fa+24>>2]=f[i+24>>2];f[fa+28>>2]=f[i+28>>2];FL(Ua,d);nb=(kb|0)<1;if(nb){mb=Ua+56|0;f[mb>>2]=Ya;f[mb+4>>2]=lb}mb=(f[Ua>>2]|0)>>>13&4^4;rb=mb;do{rb=rb+7&7;Eb=Sa+(f[i+(rb<<2)>>2]|0)|0;Fb=(rb|0)==(mb|0)}while(!((b[Eb>>0]|0)!=0|Fb));i:do if(Fb){b[Sa>>0]=-126;if((kb|0)>0){mb=f[ga>>2]|0;if(mb>>>0<(f[ha>>2]|0)>>>0)Gb=mb;else{JL(d);Gb=f[ga>>2]|0}mb=Gb;sb=mb;b[sb>>0]=Ya;b[sb+1>>0]=Ya>>8;b[sb+2>>0]=Ya>>16;b[sb+3>>0]=Ya>>24;sb=mb+4|0;b[sb>>0]=lb;b[sb+1>>0]=lb>>8;b[sb+2>>0]=lb>>16;b[sb+3>>0]=lb>>24;f[ga>>2]=(f[ga>>2]|0)+8;IL(d)|0;$a=134}else $a=133}else{if(nb){sb=Sa;mb=rb;while(1){wb=mb;while(1){Hb=wb+1|0;Ib=sb+(f[i+(Hb<<2)>>2]|0)|0;if(!Ib){f[e>>2]=0;f[ia>>2]=0;Cb=c$(e,8)|0;vb=Cb;b[vb>>0]=105;b[vb+1>>0]=52;b[vb+2>>0]=32;b[vb+3>>0]=33;vb=Cb+4|0;b[vb>>0]=61;b[vb+1>>0]=32;b[vb+2>>0]=48;b[vb+3>>0]=76;j$(-215,e,219615,219289,572);d$(e)}if((Hb|0)<15&(b[Ib>>0]|0)==0)wb=Hb;else break}vb=Hb&7;if((vb+-1|0)>>>0>=mb>>>0){if((b[sb>>0]|0)==1){Jb=2;$a=115}}else{Jb=-126;$a=115}if(($a|0)==115){$a=0;b[sb>>0]=Jb}Cb=f[ga>>2]|0;if(Cb>>>0<(f[ha>>2]|0)>>>0)Kb=Cb;else{JL(d);Kb=f[ga>>2]|0}b[Kb>>0]=vb;f[ga>>2]=(f[ga>>2]|0)+1;if((sb|0)==(Eb|0)&(Ib|0)==(Sa|0)){$a=133;break i}sb=Ib;mb=wb+5&7}}if((kb|0)==1){mb=Sa;sb=Ya;Ra=lb;Ta=rb;while(1){vb=Ta;while(1){Lb=vb+1|0;Mb=mb+(f[i+(Lb<<2)>>2]|0)|0;if(!Mb){f[e>>2]=0;f[ia>>2]=0;Cb=c$(e,8)|0;Nb=Cb;b[Nb>>0]=105;b[Nb+1>>0]=52;b[Nb+2>>0]=32;b[Nb+3>>0]=33;Nb=Cb+4|0;b[Nb>>0]=61;b[Nb+1>>0]=32;b[Nb+2>>0]=48;b[Nb+3>>0]=76;j$(-215,e,219615,219289,572);d$(e)}if((Lb|0)<15&(b[Mb>>0]|0)==0)vb=Lb;else break}wb=Lb&7;if((wb+-1|0)>>>0>=Ta>>>0){if((b[mb>>0]|0)==1){Ob=2;$a=104}}else{Ob=-126;$a=104}if(($a|0)==104){$a=0;b[mb>>0]=Ob}Nb=f[ga>>2]|0;if(Nb>>>0<(f[ha>>2]|0)>>>0)Pb=Nb;else{JL(d);Pb=f[ga>>2]|0}Nb=Pb;Cb=Nb;b[Cb>>0]=sb;b[Cb+1>>0]=sb>>8;b[Cb+2>>0]=sb>>16;b[Cb+3>>0]=sb>>24;Cb=Nb+4|0;b[Cb>>0]=Ra;b[Cb+1>>0]=Ra>>8;b[Cb+2>>0]=Ra>>16;b[Cb+3>>0]=Ra>>24;f[ga>>2]=(f[ga>>2]|0)+8;if((mb|0)==(Eb|0)&(Mb|0)==(Sa|0)){$a=133;break i}mb=Mb;sb=(f[49012+(wb<<3)>>2]|0)+sb|0;Ra=(f[49012+(wb<<3)+4>>2]|0)+Ra|0;Ta=vb+5&7}}Ta=Sa;Ra=rb^4;sb=Ya;mb=lb;wb=rb;while(1){Cb=wb;while(1){Qb=Cb+1|0;Rb=Ta+(f[i+(Qb<<2)>>2]|0)|0;if(!Rb){f[e>>2]=0;f[ia>>2]=0;Nb=c$(e,8)|0;Sb=Nb;b[Sb>>0]=105;b[Sb+1>>0]=52;b[Sb+2>>0]=32;b[Sb+3>>0]=33;Sb=Nb+4|0;b[Sb>>0]=61;b[Sb+1>>0]=32;b[Sb+2>>0]=48;b[Sb+3>>0]=76;j$(-215,e,219615,219289,572);d$(e)}if((Qb|0)<15&(b[Rb>>0]|0)==0)Cb=Qb;else break}vb=Qb&7;if((vb+-1|0)>>>0>=wb>>>0){if((b[Ta>>0]|0)==1){Tb=2;$a=126}}else{Tb=-126;$a=126}if(($a|0)==126){$a=0;b[Ta>>0]=Tb}if((vb|0)==(Ra|0))Ub=Ra;else{Sb=f[ga>>2]|0;if(Sb>>>0<(f[ha>>2]|0)>>>0)Vb=Sb;else{JL(d);Vb=f[ga>>2]|0}Sb=Vb;Nb=Sb;b[Nb>>0]=sb;b[Nb+1>>0]=sb>>8;b[Nb+2>>0]=sb>>16;b[Nb+3>>0]=sb>>24;Nb=Sb+4|0;b[Nb>>0]=mb;b[Nb+1>>0]=mb>>8;b[Nb+2>>0]=mb>>16;b[Nb+3>>0]=mb>>24;f[ga>>2]=(f[ga>>2]|0)+8;Ub=vb}if((Ta|0)==(Eb|0)&(Rb|0)==(Sa|0)){$a=133;break i}Ta=Rb;Ra=Ub;sb=(f[49012+(vb<<3)>>2]|0)+sb|0;mb=(f[49012+(vb<<3)+4>>2]|0)+mb|0;wb=Cb+5&7}}while(0);if(($a|0)==133?($a=0,IL(d)|0,kb|0):0)$a=134;if(($a|0)==134){$a=0;una(e,Ua,1)}Wb=Q;Xb=Na}else{f[j>>2]=0;VL(f[la>>2]|0,0,j)|0;Sa=f[j>>2]|0;rb=0-db|0;if(Ja){lb=f[x+(hb<<2)>>2]&127;Ya=x+(Xa<<2)+(rb<<2)|0;nb=(f[R>>2]|0)+hb|0;wb=(f[S>>2]|0)+v|0;mb=f[T>>2]|0;if(!Ya){f[d>>2]=0;f[ma>>2]=0;l=c$(d,9)|0;m=219555;n=l+9|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-215,d,219631,219289,881);d$(d)}f[e>>2]=0;f[g>>2]=0;kb=f[Ya>>2]|0;sb=kb&1073741823;Ra=sb|1073741824;Ta=kb|-1073741824;f[i>>2]=1;f[W>>2]=oa;f[X>>2]=na;f[_>>2]=pa;f[$>>2]=-1;f[ba>>2]=qa;f[ca>>2]=k;f[ea>>2]=ra;f[fa>>2]=f[i>>2];f[fa+4>>2]=f[i+4>>2];f[fa+8>>2]=f[i+8>>2];f[fa+12>>2]=f[i+12>>2];f[fa+16>>2]=f[i+16>>2];f[fa+20>>2]=f[i+20>>2];f[fa+24>>2]=f[i+24>>2];f[fa+28>>2]=f[i+28>>2];FL(Ua,d);kb=(mb|0)<1;if(kb){vb=Ua+56|0;f[vb>>2]=nb;f[vb+4>>2]=wb}f[g>>2]=nb;f[e>>2]=nb;vb=(f[Ua>>2]|0)>>>13&4^4;Nb=vb;do{Nb=Nb+7&7;Yb=Ya+(f[i+(Nb<<2)>>2]<<2)|0;Zb=(Nb|0)==(vb|0)}while(!(Zb|(f[Yb>>2]&1073741823|0)==(sb|0)));do if(Zb){f[Ya>>2]=Ta;if((mb|0)<=0){_b=nb;$b=wb;ac=nb;bc=wb;break}vb=f[sa>>2]|0;if(vb>>>0<(f[ta>>2]|0)>>>0)cc=vb;else{JL(d);cc=f[sa>>2]|0}vb=cc;Sb=vb;b[Sb>>0]=nb;b[Sb+1>>0]=nb>>8;b[Sb+2>>0]=nb>>16;b[Sb+3>>0]=nb>>24;Sb=vb+4|0;b[Sb>>0]=wb;b[Sb+1>>0]=wb>>8;b[Sb+2>>0]=wb>>16;b[Sb+3>>0]=wb>>24;f[sa>>2]=(f[sa>>2]|0)+8;_b=nb;$b=wb;ac=nb;bc=wb}else{Sb=Nb^4;vb=(mb|0)==1;j:do if(kb){dc=Ya;ec=Sb;fc=nb;gc=wb;hc=wb;ic=wb;jc=Nb;while(1){kc=jc;while(1){lc=kc+1|0;mc=dc+(f[i+(lc<<2)>>2]<<2)|0;if(!mc){f[h>>2]=0;f[ua>>2]=0;nc=c$(h,8)|0;oc=nc;b[oc>>0]=105;b[oc+1>>0]=52;b[oc+2>>0]=32;b[oc+3>>0]=33;oc=nc+4|0;b[oc>>0]=61;b[oc+1>>0]=32;b[oc+2>>0]=48;b[oc+3>>0]=76;j$(-215,h,219631,219289,941);d$(h)}if((lc|0)<15?(f[mc>>2]&1073741823|0)!=(sb|0):0)kc=lc;else break}oc=lc&7;if((oc+-1|0)>>>0>=jc>>>0){if((f[dc>>2]|0)==(sb|0)){pc=Ra;$a=156}}else{pc=Ta;$a=156}if(($a|0)==156){$a=0;f[dc>>2]=pc}nc=f[sa>>2]|0;if(nc>>>0<(f[ta>>2]|0)>>>0)qc=nc;else{JL(d);qc=f[sa>>2]|0}b[qc>>0]=oc;f[sa>>2]=(f[sa>>2]|0)+1;if((oc|0)==(ec|0)){rc=hc;sc=ic}else{if((fc|0)>=(f[e>>2]|0)){if((fc|0)>(f[g>>2]|0)){tc=g;$a=162}}else{tc=e;$a=162}if(($a|0)==162){$a=0;f[tc>>2]=fc}nc=(gc|0)<(hc|0);rc=nc?gc:hc;sc=nc?ic:(gc|0)>(ic|0)?gc:ic}if((dc|0)==(Yb|0)&(mc|0)==(Ya|0)){uc=rc;vc=sc;break j}dc=mc;ec=oc;fc=(f[49012+(oc<<3)>>2]|0)+fc|0;gc=(f[49012+(oc<<3)+4>>2]|0)+gc|0;hc=rc;ic=sc;jc=kc+5&7}}else{jc=Ya;ic=Sb;hc=nb;gc=wb;fc=wb;ec=wb;dc=Nb;while(1){Cb=dc;while(1){wc=Cb+1|0;xc=jc+(f[i+(wc<<2)>>2]<<2)|0;if(!xc){f[h>>2]=0;f[ua>>2]=0;oc=c$(h,8)|0;nc=oc;b[nc>>0]=105;b[nc+1>>0]=52;b[nc+2>>0]=32;b[nc+3>>0]=33;nc=oc+4|0;b[nc>>0]=61;b[nc+1>>0]=32;b[nc+2>>0]=48;b[nc+3>>0]=76;j$(-215,h,219631,219289,941);d$(h)}if((wc|0)<15?(f[xc>>2]&1073741823|0)!=(sb|0):0)Cb=wc;else break}kc=wc&7;if((kc+-1|0)>>>0>=dc>>>0){if((f[jc>>2]|0)==(sb|0)){yc=Ra;$a=172}}else{yc=Ta;$a=172}if(($a|0)==172){$a=0;f[jc>>2]=yc}if(vb|(kc|0)!=(ic|0)){nc=f[sa>>2]|0;if(nc>>>0<(f[ta>>2]|0)>>>0)zc=nc;else{JL(d);zc=f[sa>>2]|0}nc=zc;oc=nc;b[oc>>0]=hc;b[oc+1>>0]=hc>>8;b[oc+2>>0]=hc>>16;b[oc+3>>0]=hc>>24;oc=nc+4|0;b[oc>>0]=gc;b[oc+1>>0]=gc>>8;b[oc+2>>0]=gc>>16;b[oc+3>>0]=gc>>24;f[sa>>2]=(f[sa>>2]|0)+8}if((kc|0)==(ic|0)){Ac=fc;Bc=ec}else{if((hc|0)>=(f[e>>2]|0)){if((hc|0)>(f[g>>2]|0)){Cc=g;$a=180}}else{Cc=e;$a=180}if(($a|0)==180){$a=0;f[Cc>>2]=hc}oc=(gc|0)<(fc|0);Ac=oc?gc:fc;Bc=oc?ec:(gc|0)>(ec|0)?gc:ec}if((jc|0)==(Yb|0)&(xc|0)==(Ya|0)){uc=Ac;vc=Bc;break j}jc=xc;ic=kc;hc=(f[49012+(kc<<3)>>2]|0)+hc|0;gc=(f[49012+(kc<<3)+4>>2]|0)+gc|0;fc=Ac;ec=Bc;dc=Cb+5&7}}while(0);_b=f[e>>2]|0;$b=uc;ac=f[g>>2]|0;bc=vc}while(0);Ya=1-_b+ac|0;f[g>>2]=Ya;Ta=bc+1-$b|0;IL(d)|0;if(mb|0){f[Ua+56>>2]=_b;f[Ua+60>>2]=$b;f[Ua+64>>2]=Ya;f[Ua+68>>2]=Ta}Ra=Sa+16|0;f[Ra>>2]=_b;sb=Sa+20|0;f[sb>>2]=$b;f[Sa+24>>2]=Ya;f[Sa+28>>2]=Ta;Dc=lb;Ec=Na;Fc=Ra;Gc=sb}else{sb=Na+1&127;Ra=((sb|0)==0?3:0)+sb|0;sb=Fa+Xa+rb|0;Ta=(f[R>>2]|0)+hb|0;Ya=(f[S>>2]|0)+v|0;Nb=f[T>>2]|0;f[e>>2]=0;f[g>>2]=0;f[i>>2]=1;f[W>>2]=V;f[X>>2]=U;f[_>>2]=Z;f[$>>2]=-1;f[ba>>2]=aa;f[ca>>2]=s;f[ea>>2]=da;f[fa>>2]=f[i>>2];f[fa+4>>2]=f[i+4>>2];f[fa+8>>2]=f[i+8>>2];f[fa+12>>2]=f[i+12>>2];f[fa+16>>2]=f[i+16>>2];f[fa+20>>2]=f[i+20>>2];f[fa+24>>2]=f[i+24>>2];f[fa+28>>2]=f[i+28>>2];FL(Ua,d);wb=(Nb|0)<1;if(wb){nb=Ua+56|0;f[nb>>2]=Ta;f[nb+4>>2]=Ya}f[g>>2]=Ta;f[e>>2]=Ta;nb=(f[Ua>>2]|0)>>>13&4^4;kb=nb;do{kb=kb+7&7;Hc=sb+(f[i+(kb<<2)>>2]|0)|0;Ic=(kb|0)==(nb|0)}while(!((b[Hc>>0]|0)!=0|Ic));do if(Ic){b[sb>>0]=Na|128;if((Nb|0)<=0){Jc=Ta;Kc=Ya;Lc=Ta;Mc=Ya;break}nb=f[va>>2]|0;if(nb>>>0<(f[wa>>2]|0)>>>0)Nc=nb;else{JL(d);Nc=f[va>>2]|0}nb=Nc;rb=nb;b[rb>>0]=Ta;b[rb+1>>0]=Ta>>8;b[rb+2>>0]=Ta>>16;b[rb+3>>0]=Ta>>24;rb=nb+4|0;b[rb>>0]=Ya;b[rb+1>>0]=Ya>>8;b[rb+2>>0]=Ya>>16;b[rb+3>>0]=Ya>>24;f[va>>2]=(f[va>>2]|0)+8;Jc=Ta;Kc=Ya;Lc=Ta;Mc=Ya}else{rb=kb^4;nb=Na|128;lb=(Nb|0)==1;k:do if(wb){mb=sb;vb=rb;Sb=Ta;dc=Ya;ec=Ya;fc=Ya;gc=kb;while(1){hc=gc;while(1){Oc=hc+1|0;Pc=mb+(f[i+(Oc<<2)>>2]|0)|0;if(!Pc){f[h>>2]=0;f[xa>>2]=0;ic=c$(h,8)|0;jc=ic;b[jc>>0]=105;b[jc+1>>0]=52;b[jc+2>>0]=32;b[jc+3>>0]=33;jc=ic+4|0;b[jc>>0]=61;b[jc+1>>0]=32;b[jc+2>>0]=48;b[jc+3>>0]=76;j$(-215,h,219653,219289,749);d$(h)}if((Oc|0)<15&(b[Pc>>0]|0)==0)hc=Oc;else break}Cb=Oc&7;if((Cb+-1|0)>>>0>=gc>>>0){if((b[mb>>0]|0)==1){Qc=Na;$a=205}}else{Qc=nb;$a=205}if(($a|0)==205){$a=0;b[mb>>0]=Qc}jc=f[va>>2]|0;if(jc>>>0<(f[wa>>2]|0)>>>0)Rc=jc;else{JL(d);Rc=f[va>>2]|0}b[Rc>>0]=Cb;f[va>>2]=(f[va>>2]|0)+1;if((Cb|0)==(vb|0)){Sc=ec;Tc=fc}else{if((Sb|0)>=(f[e>>2]|0)){if((Sb|0)>(f[g>>2]|0)){Uc=g;$a=211}}else{Uc=e;$a=211}if(($a|0)==211){$a=0;f[Uc>>2]=Sb}jc=(dc|0)<(ec|0);Sc=jc?dc:ec;Tc=jc?fc:(dc|0)>(fc|0)?dc:fc}if((mb|0)==(Hc|0)&(Pc|0)==(sb|0)){Vc=Sc;Wc=Tc;break k}mb=Pc;vb=Cb;Sb=(f[49012+(Cb<<3)>>2]|0)+Sb|0;dc=(f[49012+(Cb<<3)+4>>2]|0)+dc|0;ec=Sc;fc=Tc;gc=hc+5&7}}else{gc=sb;fc=rb;ec=Ta;dc=Ya;Sb=Ya;vb=Ya;mb=kb;while(1){Cb=mb;while(1){Xc=Cb+1|0;Yc=gc+(f[i+(Xc<<2)>>2]|0)|0;if(!Yc){f[h>>2]=0;f[xa>>2]=0;jc=c$(h,8)|0;ic=jc;b[ic>>0]=105;b[ic+1>>0]=52;b[ic+2>>0]=32;b[ic+3>>0]=33;ic=jc+4|0;b[ic>>0]=61;b[ic+1>>0]=32;b[ic+2>>0]=48;b[ic+3>>0]=76;j$(-215,h,219653,219289,749);d$(h)}if((Xc|0)<15&(b[Yc>>0]|0)==0)Cb=Xc;else break}hc=Xc&7;if((hc+-1|0)>>>0>=mb>>>0){if((b[gc>>0]|0)==1){Zc=Na;$a=221}}else{Zc=nb;$a=221}if(($a|0)==221){$a=0;b[gc>>0]=Zc}if(lb|(hc|0)!=(fc|0)){ic=f[va>>2]|0;if(ic>>>0<(f[wa>>2]|0)>>>0)_c=ic;else{JL(d);_c=f[va>>2]|0}ic=_c;jc=ic;b[jc>>0]=ec;b[jc+1>>0]=ec>>8;b[jc+2>>0]=ec>>16;b[jc+3>>0]=ec>>24;jc=ic+4|0;b[jc>>0]=dc;b[jc+1>>0]=dc>>8;b[jc+2>>0]=dc>>16;b[jc+3>>0]=dc>>24;f[va>>2]=(f[va>>2]|0)+8}if((hc|0)==(fc|0)){$c=Sb;ad=vb}else{if((ec|0)>=(f[e>>2]|0)){if((ec|0)>(f[g>>2]|0)){bd=g;$a=229}}else{bd=e;$a=229}if(($a|0)==229){$a=0;f[bd>>2]=ec}jc=(dc|0)<(Sb|0);$c=jc?dc:Sb;ad=jc?vb:(dc|0)>(vb|0)?dc:vb}if((gc|0)==(Hc|0)&(Yc|0)==(sb|0)){Vc=$c;Wc=ad;break k}gc=Yc;fc=hc;ec=(f[49012+(hc<<3)>>2]|0)+ec|0;dc=(f[49012+(hc<<3)+4>>2]|0)+dc|0;Sb=$c;vb=ad;mb=Cb+5&7}}while(0);Jc=f[e>>2]|0;Kc=Vc;Lc=f[g>>2]|0;Mc=Wc}while(0);sb=1-Jc+Lc|0;f[g>>2]=sb;kb=Mc+1-Kc|0;IL(d)|0;if(Nb|0){f[Ua+56>>2]=Jc;f[Ua+60>>2]=Kc;f[Ua+64>>2]=sb;f[Ua+68>>2]=kb}Ya=Sa+16|0;f[Ya>>2]=Jc;Ta=Sa+20|0;f[Ta>>2]=Kc;f[Sa+24>>2]=sb;f[Sa+28>>2]=kb;Dc=Na;Ec=Ra;Fc=Ya;Gc=Ta}f[Fc>>2]=(f[Fc>>2]|0)-(f[R>>2]|0);f[Gc>>2]=(f[Gc>>2]|0)-(f[S>>2]|0);Ta=a+276+(Dc<<2)|0;f[Sa+4>>2]=f[Ta>>2];f[Ta>>2]=Sa;Wb=Sa;Xb=Ec}f[Wb+40>>2]=db;cd=Wb+12|0;f[cd>>2]=Ua;Ta=Wb+32|0;f[Ta>>2]=hb;f[Ta+4>>2]=v;Ta=Wb+8|0;f[Ta>>2]=gb;Ya=f[ja>>2]|0;if((f[T>>2]|0)==(Ya|0)){dd=gb;ed=Ua}else{kb=j1(Ua,f[ka>>2]|0,f[L>>2]|0,Ya)|0;f[cd>>2]=kb;sL(f[a>>2]|0);dd=f[Ta>>2]|0;ed=f[cd>>2]|0}f[ed+16>>2]=f[dd+12>>2];fd=f[L>>2]|0;if(f[gb+12>>2]|0){$a=245;break a}f[cd>>2]=0;Ta=f[a>>2]|0;if((Ta|0)==(fd|0))uL(fd,M);else sL(Ta);ab=hb;bb=Xb;cb=b[Fa+Xa>>0]|0}while(0);Qa=Xa+1|0;if((Qa|0)>=(y|0)){Za=bb;break}else{Ma=cb>>>0>1?Xa:ab;Na=bb;Oa=cb;Pa=cb}}}else Za=Ha;while(0);x=v+1|0;if((x|0)<(z|0)){Fa=Fa+s|0;r=0;Ga=x;Ha=Za;Ia=0;H=1;v=x}else{I=0;$a=248;break}}if(($a|0)==80){f[d>>2]=0;f[za>>2]=0;l=c$(d,13)|0;m=219601;n=l+13|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-215,d,219514,219289,1182);d$(d)}else if(($a|0)==245){tL(fd,a+32|0);f[o>>2]=Wb;f[t>>2]=Xa+1+(Ja?0-db|0:0);f[w>>2]=v;f[B>>2]=hb;f[C>>2]=Ga;f[q>>2]=Fa;f[D>>2]=Xb;I=f[cd>>2]|0;u=c;return I|0}else if(($a|0)==248){u=c;return I|0}return 0}function c7(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;j$(-27,c,219671,219289,1328);d$(c)}d=f[a>>2]|0;if(!d){e=0;u=b;return e|0}g=d+88|0;h=f[g>>2]|0;if(h|0){i=d+248|0;if(f[i>>2]|0){j=d+4|0;tL(f[j>>2]|0,c);if((f[c>>2]|0)==(f[d+32>>2]|0)?(f[c+4>>2]|0)==(f[d+36>>2]|0):0)uL(f[j>>2]|0,d+24|0);f[i>>2]=0}i=f[h+12>>2]|0;if(i|0)dM(i,f[(f[h+8>>2]|0)+12>>2]|0,d+180|0);f[g>>2]=0}if((f[d>>2]|0)!=(f[d+4>>2]|0))rL(d);g=d+8|0;if(f[g>>2]|0)rL(g);g=f[d+200>>2]|0;$F(f[a>>2]|0);f[a>>2]=0;e=g;u=b;return e|0}function d7(a,c,d,e,g,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;m=u;u=u+160|0;n=m+136|0;o=m+112|0;p=m+88|0;q=m+56|0;r=m+24|0;s=m+8|0;t=m;f[t>>2]=0;if(!d){f[n>>2]=0;f[n+4>>2]=0;v=c$(n,25)|0;w=219689;x=v+25|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-27,n,219715,219289,1817);d$(n)}f[d>>2]=0;if((i|0)!=5){y=a7(a,c,e,g,i,j,k,l)|0;f[t>>2]=y;l=y;y=-1;while(1){z=y+1|0;if(!(b7(l)|0))break;l=f[t>>2]|0;y=z}y=c7(t)|0;f[d>>2]=y;A=z;u=m;return A|0}if(k|j|0){f[n>>2]=0;f[n+4>>2]=0;v=c$(n,51)|0;w=219735;x=v+51|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-211,n,219715,219289,1825);d$(n)}if(!c){f[r>>2]=0;f[r+4>>2]=0;v=c$(r,20)|0;w=219787;x=v+20|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-27,r,219808,219289,1508);d$(r)}j=(d|0)!=0;if(!j){f[r>>2]=0;f[r+4>>2]=0;v=c$(r,25)|0;w=219689;x=v+25|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-27,r,219808,219289,1511);d$(r)}if((e|0)<88){f[r>>2]=0;f[r+4>>2]=0;v=c$(r,48)|0;w=219834;x=v+48|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-201,r,219808,219289,1514);d$(r)}k=qL(c)|0;if(!k)B=0;else{z=NYa(16)|0;f[z+4>>2]=1;f[z>>2]=49084;f[z+8>>2]=k;B=z}z=qL(c)|0;if(!z)C=0;else{y=NYa(16)|0;f[y+4>>2]=1;f[y>>2]=49084;f[y+8>>2]=z;C=y}y=F0(a,r,0,0)|0;if(f[y>>2]&4094|0){f[s>>2]=0;f[s+4>>2]=0;v=c$(s,32)|0;w=219883;x=v+32|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-5,s,219808,219289,1525);d$(s)}w=f[y+16>>2]|0;r=f[y+4>>2]|0;a=f[y+20>>2]|0;t=f[y+24>>2]|0;y=yL(0,56,16,k)|0;FL(y,p);GL(0,56,4,z,n);GL(0,56,4,z,o);z=p+12|0;k=f[z>>2]|0;l=p+20|0;if(k>>>0<(f[l>>2]|0)>>>0)D=k;else{JL(p);D=f[z>>2]|0}v=D;x=v+16|0;do{b[v>>0]=0;v=v+1|0}while((v|0)<(x|0));v=(f[z>>2]|0)+16|0;f[z>>2]=v;x=p+4|0;D=v+(0-(f[(f[x>>2]|0)+28>>2]|0))|0;v=(t|0)>0;a:do if(v){k=n+12|0;i=n+20|0;g=0;E=D;while(1){F=g;while(1){if(b[w+F>>0]|0){G=F;break}H=F+1|0;if((H|0)<(t|0))F=H;else{G=H;break}}if((G|0)==(t|0)){I=E;break a}F=f[z>>2]|0;if(F>>>0<(f[l>>2]|0)>>>0)J=F;else{JL(p);J=f[z>>2]|0}b[J>>0]=0;b[J+1>>0]=0;b[J+2>>0]=0;b[J+3>>0]=0;F=J+4|0;b[F>>0]=0;b[F+1>>0]=0;b[F+2>>0]=0;b[F+3>>0]=0;F=J+8|0;b[F>>0]=G;b[F+1>>0]=G>>8;b[F+2>>0]=G>>16;b[F+3>>0]=G>>24;F=J+12|0;b[F>>0]=0;b[F+1>>0]=0;b[F+2>>0]=0;b[F+3>>0]=0;F=(f[z>>2]|0)+16|0;f[z>>2]=F;H=F+(0-(f[(f[x>>2]|0)+28>>2]|0))|0;f[E+4>>2]=H;K=G+1|0;b:do if((t|0)>(K|0)){L=K;while(1){if(!(b[w+L>>0]|0)){M=L;break b}N=L+1|0;if((N|0)<(t|0))L=N;else{M=N;break}}}else M=K;while(0);K=M+-1|0;if(F>>>0<(f[l>>2]|0)>>>0)O=F;else{JL(p);O=f[z>>2]|0}b[O>>0]=0;b[O+1>>0]=0;b[O+2>>0]=0;b[O+3>>0]=0;L=O+4|0;b[L>>0]=0;b[L+1>>0]=0;b[L+2>>0]=0;b[L+3>>0]=0;L=O+8|0;b[L>>0]=K;b[L+1>>0]=K>>8;b[L+2>>0]=K>>16;b[L+3>>0]=K>>24;K=O+12|0;b[K>>0]=0;b[K+1>>0]=0;b[K+2>>0]=0;b[K+3>>0]=0;K=(f[z>>2]|0)+16|0;f[z>>2]=K;L=K+(0-(f[(f[x>>2]|0)+28>>2]|0))|0;K=H+4|0;f[K>>2]=L;f[H>>2]=L;L=f[k>>2]|0;if(L>>>0<(f[i>>2]|0)>>>0)P=L;else{JL(n);P=f[k>>2]|0}b[P>>0]=H;b[P+1>>0]=H>>8;b[P+2>>0]=H>>16;b[P+3>>0]=H>>24;f[k>>2]=(f[k>>2]|0)+4;L=f[K>>2]|0;if((M|0)<(t|0)){g=M;E=L}else{I=L;break}}}else I=D;while(0);HL(p);M=f[D+4>>2]|0;D=y+24|0;y=f[D>>2]|0;P=y+-1|0;f[I+4>>2]=0;c:do if((a|0)>1){O=n+12|0;G=n+20|0;J=o+12|0;E=o+20|0;g=y;k=1;i=0;L=w;K=I;N=M;Q=P;while(1){R=L+r|0;d:do if(v){S=0;T=K;while(1){U=S;while(1){if(b[R+U>>0]|0){V=U;break}W=U+1|0;if((W|0)<(t|0))U=W;else{V=W;break}}if((V|0)==(t|0)){X=T;break d}U=f[z>>2]|0;if(U>>>0<(f[l>>2]|0)>>>0)Y=U;else{JL(p);Y=f[z>>2]|0}b[Y>>0]=0;b[Y+1>>0]=0;b[Y+2>>0]=0;b[Y+3>>0]=0;U=Y+4|0;b[U>>0]=0;b[U+1>>0]=0;b[U+2>>0]=0;b[U+3>>0]=0;U=Y+8|0;b[U>>0]=V;b[U+1>>0]=V>>8;b[U+2>>0]=V>>16;b[U+3>>0]=V>>24;U=Y+12|0;b[U>>0]=k;b[U+1>>0]=k>>8;b[U+2>>0]=k>>16;b[U+3>>0]=k>>24;U=(f[z>>2]|0)+16|0;f[z>>2]=U;W=U+(0-(f[(f[x>>2]|0)+28>>2]|0))|0;f[T+4>>2]=W;Z=V+1|0;e:do if((t|0)>(Z|0)){_=Z;while(1){if(!(b[R+_>>0]|0)){$=_;break e}aa=_+1|0;if((aa|0)<(t|0))_=aa;else{$=aa;break}}}else $=Z;while(0);Z=$+-1|0;if(U>>>0<(f[l>>2]|0)>>>0)ba=U;else{JL(p);ba=f[z>>2]|0}b[ba>>0]=0;b[ba+1>>0]=0;b[ba+2>>0]=0;b[ba+3>>0]=0;_=ba+4|0;b[_>>0]=0;b[_+1>>0]=0;b[_+2>>0]=0;b[_+3>>0]=0;_=ba+8|0;b[_>>0]=Z;b[_+1>>0]=Z>>8;b[_+2>>0]=Z>>16;b[_+3>>0]=Z>>24;Z=ba+12|0;b[Z>>0]=k;b[Z+1>>0]=k>>8;b[Z+2>>0]=k>>16;b[Z+3>>0]=k>>24;Z=(f[z>>2]|0)+16|0;f[z>>2]=Z;_=Z+(0-(f[(f[x>>2]|0)+28>>2]|0))|0;f[W+4>>2]=_;if(($|0)<(t|0)){S=$;T=_}else{X=_;break}}}else X=K;while(0);HL(p);H=f[K+4>>2]|0;F=(f[D>>2]|0)-g|0;f[X+4>>2]=0;T=(Q|0)/2|0;S=(F|0)/2|0;f:do if((Q|0)>1&(F|0)>1){_=0;Z=0;aa=H;ca=0;da=i;ea=N;while(1){g:do switch(_|0){case 0:{fa=f[ea+4>>2]|0;ga=f[fa+8>>2]|0;ha=aa+4|0;ia=f[ha>>2]|0;ja=f[ia+8>>2]|0;if((ga|0)<(ja|0)){ka=(ga|0)<((f[aa+8>>2]|0)+-1|0);f[(ka?fa:aa)>>2]=ea;la=(ka^1)&1;ma=Z+1|0;na=aa;oa=ca;pa=ka?da:fa;qa=f[fa+4>>2]|0;break g}if((f[ea+8>>2]|0)>(ja+1|0)){f[aa>>2]=ia;ja=f[O>>2]|0;if(ja>>>0<(f[G>>2]|0)>>>0)ra=ja;else{JL(n);ra=f[O>>2]|0}b[ra>>0]=aa;b[ra+1>>0]=aa>>8;b[ra+2>>0]=aa>>16;b[ra+3>>0]=aa>>24;f[O>>2]=(f[O>>2]|0)+4;sa=f[ha>>2]|0;ta=0;ua=da}else{f[aa>>2]=ea;sa=ia;ta=-1;ua=ia}la=ta;ma=Z;na=f[sa+4>>2]|0;oa=ca+1|0;pa=ua;qa=ea;break}case 1:{ia=f[aa+4>>2]|0;ha=f[ia+8>>2]|0;if((f[ea+8>>2]|0)>(ha+1|0)){f[da>>2]=ia;la=0;ma=Z;na=f[ia+4>>2]|0;oa=ca+1|0;pa=da;qa=ea;break g}f[da>>2]=ea;ja=f[ea+4>>2]|0;if((f[ja+8>>2]|0)<(ha|0)){la=1;ma=Z+1|0;na=aa;oa=ca;pa=ja;qa=f[ja+4>>2]|0;break g}else{la=-1;ma=Z;na=f[ia+4>>2]|0;oa=ca+1|0;pa=ia;qa=ea;break g}break}case -1:{ia=ea+4|0;ja=f[ia>>2]|0;if((f[aa+8>>2]|0)>((f[ja+8>>2]|0)+1|0)){f[ja>>2]=da;la=0;ma=Z+1|0;na=aa;oa=ca;pa=da;qa=f[ja+4>>2]|0;break g}ja=f[J>>2]|0;if(ja>>>0<(f[E>>2]|0)>>>0)va=ja;else{JL(o);va=f[J>>2]|0}b[va>>0]=aa;b[va+1>>0]=aa>>8;b[va+2>>0]=aa>>16;b[va+3>>0]=aa>>24;f[J>>2]=(f[J>>2]|0)+4;f[aa>>2]=da;ja=f[aa+4>>2]|0;ha=f[ia>>2]|0;if((f[ja+8>>2]|0)<(f[ha+8>>2]|0)){la=-1;ma=Z;na=f[ja+4>>2]|0;oa=ca+1|0;pa=ja;qa=ea;break g}else{la=1;ma=Z+1|0;na=aa;oa=ca;pa=ha;qa=f[ha+4>>2]|0;break g}break}default:{la=_;ma=Z;na=aa;oa=ca;pa=da;qa=ea}}while(0);if((oa|0)<(S|0)&(ma|0)<(T|0)){_=la;Z=ma;aa=na;ca=oa;da=pa;ea=qa}else{wa=la;xa=ma;ya=na;za=oa;Aa=pa;Ba=qa;break f}}}else{wa=0;xa=0;ya=H;za=0;Aa=i;Ba=N}while(0);if((za|0)<(S|0)){ea=wa;da=ya;ca=za;while(1){aa=da+4|0;Z=f[aa>>2]|0;if(!ea){f[da>>2]=Z;_=f[O>>2]|0;if(_>>>0<(f[G>>2]|0)>>>0)Ca=_;else{JL(n);Ca=f[O>>2]|0}b[Ca>>0]=da;b[Ca+1>>0]=da>>8;b[Ca+2>>0]=da>>16;b[Ca+3>>0]=da>>24;f[O>>2]=(f[O>>2]|0)+4;Da=f[aa>>2]|0}else{f[Aa>>2]=Z;Da=Z}ca=ca+1|0;if((ca|0)>=(S|0)){Ea=0;break}else{ea=0;da=f[Da+4>>2]|0}}}else Ea=wa;if((xa|0)<(T|0)){da=Ea;ea=xa;S=Ba;while(1){ca=f[S+4>>2]|0;Z=S;S=f[ca+4>>2]|0;f[ca>>2]=(da|0)==0?Z:Aa;ea=ea+1|0;if((ea|0)==(T|0))break;else da=0}}da=k+1|0;if((da|0)>=(a|0)){Fa=H;Ga=F;break c}g=f[D>>2]|0;k=da;i=Aa;L=R;K=X;N=H;Q=F}}else{Fa=M;Ga=P}while(0);P=(Ga|0)/2|0;if((Ga|0)>1){Ga=0;M=Fa;while(1){Fa=f[M+4>>2]|0;f[Fa>>2]=M;Ga=Ga+1|0;if((Ga|0)>=(P|0))break;else M=f[Fa+4>>2]|0}}M=IL(n)|0;n=IL(o)|0;o=q+12|0;P=q+20|0;Ga=0;Fa=0;X=0;Aa=0;while(1){D=(X|0)==0;a=D?M:n;CL(a,q,0);Ba=a+24|0;if((f[Ba>>2]|0)>0)if(D){D=Ga;a=Fa;xa=0;Ea=Aa;while(1){wa=f[o>>2]|0;Da=h[wa>>0]|h[wa+1>>0]<<8|h[wa+2>>0]<<16|h[wa+3>>0]<<24;Ca=wa+4|0;f[o>>2]=Ca;if(Ca>>>0>=(f[P>>2]|0)>>>0)LL(q,1);do if(!(f[Da>>2]|0)){Ha=a;Ia=Ea}else{GL(20492,e,8,c,p);Ca=f[z>>2]|0;wa=Da;do{if(Ca>>>0<(f[l>>2]|0)>>>0)Ja=Ca;else{JL(p);Ja=f[z>>2]|0}za=wa+8|0;ya=za;qa=h[ya>>0]|h[ya+1>>0]<<8|h[ya+2>>0]<<16|h[ya+3>>0]<<24;ya=za+4|0;za=h[ya>>0]|h[ya+1>>0]<<8|h[ya+2>>0]<<16|h[ya+3>>0]<<24;ya=Ja;pa=ya;b[pa>>0]=qa;b[pa+1>>0]=qa>>8;b[pa+2>>0]=qa>>16;b[pa+3>>0]=qa>>24;qa=ya+4|0;b[qa>>0]=za;b[qa+1>>0]=za>>8;b[qa+2>>0]=za>>16;b[qa+3>>0]=za>>24;Ca=(f[z>>2]|0)+8|0;f[z>>2]=Ca;za=wa;wa=f[wa>>2]|0;f[za>>2]=0}while((wa|0)!=(Da|0));wa=IL(p)|0;una(s,wa,1);if(!a){Ha=wa;Ia=wa;break}f[wa+8>>2]=Ea;f[Ea+12>>2]=wa;Ha=a;Ia=wa}while(0);xa=xa+1|0;Da=D+1|0;if((xa|0)>=(f[Ba>>2]|0)){Ka=Da;La=Ha;Ma=Ia;break}else{D=Da;a=Ha;Ea=Ia}}}else{Ea=Ga;a=Fa;D=0;xa=Aa;while(1){Da=f[o>>2]|0;F=h[Da>>0]|h[Da+1>>0]<<8|h[Da+2>>0]<<16|h[Da+3>>0]<<24;H=Da+4|0;f[o>>2]=H;if(H>>>0>=(f[P>>2]|0)>>>0)LL(q,1);do if(!(f[F>>2]|0)){Na=a;Oa=xa}else{GL(20492,e,8,c,p);H=f[z>>2]|0;Da=F;do{if(H>>>0<(f[l>>2]|0)>>>0)Pa=H;else{JL(p);Pa=f[z>>2]|0}R=Da+8|0;wa=R;Ca=h[wa>>0]|h[wa+1>>0]<<8|h[wa+2>>0]<<16|h[wa+3>>0]<<24;wa=R+4|0;R=h[wa>>0]|h[wa+1>>0]<<8|h[wa+2>>0]<<16|h[wa+3>>0]<<24;wa=Pa;za=wa;b[za>>0]=Ca;b[za+1>>0]=Ca>>8;b[za+2>>0]=Ca>>16;b[za+3>>0]=Ca>>24;Ca=wa+4|0;b[Ca>>0]=R;b[Ca+1>>0]=R>>8;b[Ca+2>>0]=R>>16;b[Ca+3>>0]=R>>24;H=(f[z>>2]|0)+8|0;f[z>>2]=H;R=Da;Da=f[Da>>2]|0;f[R>>2]=0}while((Da|0)!=(F|0));Da=IL(p)|0;una(s,Da,1);f[Da>>2]=f[Da>>2]|32768;if(!a){Na=Da;Oa=Da;break}f[Da+8>>2]=xa;f[xa+12>>2]=Da;Na=a;Oa=Da}while(0);D=D+1|0;F=Ea+1|0;if((D|0)>=(f[Ba>>2]|0)){Ka=F;La=Na;Ma=Oa;break}else{Ea=F;a=Na;xa=Oa}}}else{Ka=Ga;La=Fa;Ma=Aa}X=X+1|0;if((X|0)>=2)break;else{Ga=Ka;Fa=La;Aa=Ma}}Ma=(La|0)==0?-1:Ka;if(j)f[d>>2]=La;La=C;if(C|0?(d=La+4|0,j=f[d>>2]|0,f[d>>2]=j+-1,(j|0)==1):0)ki[f[(f[C>>2]|0)+8>>2]&2047](La);La=B;if(!B){A=Ma;u=m;return A|0}C=La+4|0;j=f[C>>2]|0;f[C>>2]=j+-1;if((j|0)!=1){A=Ma;u=m;return A|0}ki[f[(f[B>>2]|0)+8>>2]&2047](La);A=Ma;u=m;return A|0}function e7(a){a=a|0;PYa(a);return}function f7(a){a=a|0;$0(a+12|0,f[a+8>>2]|0);if(!a)return;ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function g7(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;i=u;u=u+304|0;j=i+256|0;k=i+248|0;l=i+192|0;m=i;n=i+132|0;o=i+96|0;p=i+40|0;q=i+32|0;r=i+136|0;_$(k,49096);if(((NS(c)|0)!=262144?(NS(c)|0)!=327680:0)?(NS(c)|0)!=720896:0){f[j>>2]=0;f[j+4>>2]=0;K1a(c$(j,155)|0,219984,155)|0;j$(-215,j,220140,219289,1892);d$(j)}do if(!(XS(c)|0)){if((WS(c,-1)|0)==2?(VS(c,-1)|0)==4:0)break;f[j>>2]=0;f[j+4>>2]=0;s=c$(j,74)|0;t=220153;v=s+74|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,j,220140,219289,1894);d$(j)}while(0);f[l>>2]=1124007936;w=l+4|0;x=l+8|0;y=l+40|0;s=w;v=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(v|0));f[y>>2]=x;z=l+48|0;A=l+44|0;f[A>>2]=z;f[z>>2]=0;f[l+52>>2]=0;B=j+8|0;f[B>>2]=0;f[B+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=l;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;mL(a,j,1,1,1,1,16,m);a=pL(0)|0;if(!a)C=0;else{B=NYa(16)|0;f[B+4>>2]=1;f[B>>2]=49084;f[B+8>>2]=a;C=B}B=f[x>>2]|0;x=(f[w>>2]|0)==1?1:f[l+12>>2]|0;D=f[l>>2]|0;E=D&4095;F=l+16|0;G=f[F>>2]|0;H=Y((D>>>3&511)+1<<(47696>>>(E<<1&14)&3),x)|0;f[m>>2]=E|1111638016;E=m+4|0;f[E>>2]=H;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=G;f[m+20>>2]=B;f[m+24>>2]=x;f[E>>2]=f[f[A>>2]>>2];f[m>>2]=D&20479|1111621632;f[n>>2]=0;if(dT(d)|0)cT(d);d7(m,a,n,88,e,g,(f[h>>2]|0)+-1|0,(f[h+4>>2]|0)+-1|0,0)|0;h=f[n>>2]|0;if(h){n=aM(h,56,a)|0;if(!n)I=0;else{if((f[n+28>>2]|0)!=4){f[j>>2]=0;f[j+4>>2]=0;s=c$(j,39)|0;t=337105;v=s+39|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,j,337145,337149,2974);d$(j)}I=f[n+24>>2]|0}pS(c,I,1,0,-1,1,0);CL(n,o,0);a=o+32|0;f[a>>2]=0;h=(I|0)>0;if(h){g=o+12|0;e=p+4|0;m=p+16|0;D=p+36|0;E=p+40|0;x=p+48|0;B=p+44|0;G=j+4|0;H=q+4|0;J=o+20|0;K=o+4|0;L=0;do{M=f[f[g>>2]>>2]|0;f[M+72>>2]=L;pS(c,f[M+24>>2]|0,1,12,L,1,0);OR(p,c,L);if(!(f[p>>2]&16384)){f[j>>2]=0;f[G>>2]=0;s=c$(j,17)|0;t=220228;v=s+17|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,j,220140,219289,1919);d$(j)}N=f[m>>2]|0;O=q;f[O>>2]=0;f[O+4>>2]=0;f[H>>2]=1073741823;f[j>>2]=f[q>>2];f[j+4>>2]=f[q+4>>2];BL(M,N,j)|0;N=f[D>>2]|0;if(N|0?(O=N+12|0,N=f[O>>2]|0,f[O>>2]=N+-1,(N|0)==1):0)CR(p);f[D>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[e>>2]|0)>0){N=f[E>>2]|0;O=0;do{f[N+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[e>>2]|0))}O=f[B>>2]|0;if((O|0)!=(x|0))ZF(O);L=L+1|0;O=(f[g>>2]|0)+4|0;f[g>>2]=O;if(O>>>0>=(f[J>>2]|0)>>>0)LL(o,1);O=(f[a>>2]|0)+1|0;f[a>>2]=O;f[a>>2]=(O|0)<(f[(f[K>>2]|0)+24>>2]<<1|0)?O:0}while((L|0)<(I|0))}if(dT(d)|0){pS(d,1,I,28,-1,1,0);do if((NS(d)|0)==65536){L=f[d+4>>2]|0;f[r>>2]=f[L>>2];K=r+4|0;J=L+4|0;f[K>>2]=f[J>>2];g=r+8|0;f[g>>2]=f[L+8>>2];f[r+12>>2]=f[L+12>>2];x=r+16|0;f[x>>2]=f[L+16>>2];f[r+20>>2]=f[L+20>>2];f[r+24>>2]=f[L+24>>2];f[r+28>>2]=f[L+28>>2];f[r+32>>2]=f[L+32>>2];B=r+36|0;e=f[L+36>>2]|0;f[B>>2]=e;f[r+40>>2]=g;g=r+48|0;E=r+44|0;f[E>>2]=g;f[g>>2]=0;f[r+52>>2]=0;if(e|0){g=e+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[J>>2]|0)<3){J=f[L+44>>2]|0;g=f[E>>2]|0;f[g>>2]=f[J>>2];f[g+4>>2]=f[J+4>>2];P=x;Q=E;R=B;break}else{f[K>>2]=0;BR(r,L);P=x;Q=E;R=B;break}}else{OR(r,d,-1);P=r+16|0;Q=r+44|0;R=r+36|0}while(0);d=f[P>>2]|0;B=f[R>>2]|0;if(B|0?(E=B+12|0,B=f[E>>2]|0,f[E>>2]=B+-1,(B|0)==1):0)CR(r);f[R>>2]=0;R=r+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[R>>2]|0)>0){P=f[r+40>>2]|0;B=0;do{f[P+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[R>>2]|0))}R=f[Q>>2]|0;if((R|0)!=(r+48|0))ZF(R);CL(n,j,0);f[j+32>>2]=0;s=o;t=j;v=s+36|0;do{f[s>>2]=f[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(v|0));if(h){h=o+12|0;t=o+20|0;s=o+4|0;v=0;do{j=f[f[h>>2]>>2]|0;n=f[j+12>>2]|0;if(!n)S=-1;else S=f[n+72>>2]|0;n=f[j+8>>2]|0;if(!n)T=-1;else T=f[n+72>>2]|0;n=f[j+20>>2]|0;if(!n)U=-1;else U=f[n+72>>2]|0;n=f[j+16>>2]|0;if(!n)V=-1;else V=f[n+72>>2]|0;f[d+(v<<4)>>2]=S;f[d+(v<<4)+4>>2]=T;f[d+(v<<4)+8>>2]=U;f[d+(v<<4)+12>>2]=V;v=v+1|0;n=(f[h>>2]|0)+4|0;f[h>>2]=n;if(n>>>0>=(f[t>>2]|0)>>>0)LL(o,1);n=(f[a>>2]|0)+1|0;f[a>>2]=n;f[a>>2]=(n|0)<(f[(f[s>>2]|0)+24>>2]<<1|0)?n:0}while((v|0)<(I|0))}}}else cT(c);if(C|0?(c=C+4|0,I=f[c>>2]|0,f[c>>2]=I+-1,(I|0)==1):0)ki[f[(f[C>>2]|0)+8>>2]&2047](C);C=l+36|0;I=f[C>>2]|0;if(I|0?(c=I+12|0,I=f[c>>2]|0,f[c>>2]=I+-1,(I|0)==1):0)CR(l);f[C>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[w>>2]|0)>0){F=f[y>>2]|0;y=0;do{f[F+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[w>>2]|0))}w=f[A>>2]|0;if((w|0)!=(z|0))ZF(w);if(!(f[k+4>>2]|0)){u=i;return}u=i;return}function h7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g+8|0;i=g;_$(h,49116);j=fT()|0;f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];g7(a,b,j,c,d,i);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function i7(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;g=u;u=u+3376|0;h=g;i=g+3360|0;j=g+3304|0;k=g+2184|0;l=g+1120|0;m=g+56|0;o=g+3248|0;_$(i,49136);p=a+4|0;q=c+4|0;if((f[p>>2]|0)==(f[q>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;r=c$(h,34)|0;s=220415;t=r+34|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-215,h,220450,220461,133);d$(h)}do if((NS(a)|0)==65536){v=f[p>>2]|0;f[j>>2]=f[v>>2];w=j+4|0;x=v+4|0;f[w>>2]=f[x>>2];y=j+8|0;f[y>>2]=f[v+8>>2];f[j+12>>2]=f[v+12>>2];f[j+16>>2]=f[v+16>>2];f[j+20>>2]=f[v+20>>2];f[j+24>>2]=f[v+24>>2];f[j+28>>2]=f[v+28>>2];f[j+32>>2]=f[v+32>>2];z=f[v+36>>2]|0;f[j+36>>2]=z;f[j+40>>2]=y;y=j+48|0;A=j+44|0;f[A>>2]=y;f[y>>2]=0;f[j+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[v+44>>2]|0;y=f[A>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[w>>2]=0;BR(j,v);break}}else OR(j,a,-1);while(0);a=LS(j,2,-1,1)|0;p=f[j>>2]&7;if(!((a|0)>-1&(p|1|0)==5)){f[h>>2]=0;f[h+4>>2]=0;r=c$(h,40)|0;s=220514;t=r+40|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-215,h,220450,220461,137);d$(h)}if(a){if(aT(c)|0)B=(RR(c,-1)|0)!=4;else B=e;e=(p|0)==5;v=k+8|0;f[k>>2]=v;w=k+4|0;x=a>>>0>264;f[w>>2]=a;if(x){y=OYa(a>>>0>1073741823?-1:a<<2)|0;f[k>>2]=y;C=y}else C=v;y=a+2|0;A=l+8|0;f[l>>2]=A;z=l+4|0;f[z>>2]=y;if(y>>>0>264){D=OYa(y>>>0>1073741823?-1:y<<2)|0;f[l>>2]=D;E=D}else E=A;D=m+8|0;f[m>>2]=D;y=m+4|0;f[y>>2]=a;if(x){x=OYa(a>>>0>1073741823?-1:a<<2)|0;f[m>>2]=x;F=x}else F=D;x=f[j+16>>2]|0;if(!(f[j>>2]&16384)){f[h>>2]=0;f[h+4>>2]=0;r=c$(h,21)|0;s=220555;t=r+21|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-215,h,220450,220461,156);d$(h)}if((a|0)>0){s=0;do{f[C+(s<<2)>>2]=x+(s<<3);s=s+1|0}while((s|0)!=(a|0))}s=C+(a<<2)|0;if(e){k7(C,s,h);if((a|0)>1){r=1;t=0;G=0;while(1){H=+n[(f[C+(r<<2)>>2]|0)+4>>2];I=+n[(f[C+(G<<2)>>2]|0)+4>>2]>H?r:G;J=+n[(f[C+(t<<2)>>2]|0)+4>>2]<H?r:t;r=r+1|0;if((r|0)==(a|0)){K=J;L=I;break}else{t=J;G=I}}}else{K=0;L=0}}else{j7(C,s,h);if((a|0)>1){s=1;G=0;t=0;while(1){r=f[(f[C+(s<<2)>>2]|0)+4>>2]|0;I=(f[(f[C+(t<<2)>>2]|0)+4>>2]|0)>(r|0)?s:t;J=(f[(f[C+(G<<2)>>2]|0)+4>>2]|0)<(r|0)?s:G;s=s+1|0;if((s|0)==(a|0)){K=J;L=I;break}else{G=J;t=I}}}else{K=0;L=0}}t=f[C>>2]|0;G=a+-1|0;a=f[C+(G<<2)>>2]|0;if((f[t>>2]|0)==(f[a>>2]|0)?(f[t+4>>2]|0)==(f[a+4>>2]|0):0){f[F>>2]=0;M=1}else{a=E;if(e){t=m7(C,0,K,E,-1,1)|0;s=E+(t<<2)|0;N=s;O=t;P=m7(C,G,K,s,-1,-1)|0}else{s=l7(C,0,K,E,-1,1)|0;t=E+(s<<2)|0;N=t;O=s;P=l7(C,G,K,t,-1,-1)|0}t=N;N=d?a:t;K=d?O:P;s=d?t:a;t=d?P:O;O=K+-1|0;if((K|0)>1){P=N;I=x;J=0;do{f[F+(J<<2)>>2]=(f[C+(f[P+(J<<2)>>2]<<2)>>2]|0)-I>>3;J=J+1|0}while((J|0)!=(O|0));Q=O}else Q=0;if((t|0)>1){O=s;J=x;I=t+Q+-1|0;P=t;r=Q;do{P=P+-1|0;R=r;r=r+1|0;f[F+(R<<2)>>2]=(f[C+(f[O+(P<<2)>>2]<<2)>>2]|0)-J>>3}while((r|0)!=(I|0));if((t|0)>2){S=s+4|0;T=I;U=47}else{V=I;U=45}}else{V=Q;U=45}if((U|0)==45)if((K|0)>2){S=N+(K+-2<<2)|0;T=V;U=47}else{W=-1;X=V}if((U|0)==47){W=f[S>>2]|0;X=T}if(e){e=m7(C,0,L,E,1,-1)|0;T=E+(e<<2)|0;Z=T;_=e;$=m7(C,G,L,T,1,1)|0}else{T=l7(C,0,L,E,1,-1)|0;e=E+(T<<2)|0;Z=e;_=T;$=l7(C,G,L,e,1,1)|0}e=Z;Z=d?e:a;L=d?$:_;G=d?a:e;e=d?_:$;do if((W|0)>-1){do if((L|0)>2){aa=Z+4|0;U=56}else{if((L+e|0)<=2){ba=-1;break}aa=G+(2-L<<2)|0;U=56}while(0);if((U|0)==56)ba=f[aa>>2]|0;if((ba|0)!=(W|0)){if((ba|0)<=-1){U=62;break}$=f[C+(ba<<2)>>2]|0;_=f[C+(W<<2)>>2]|0;if((f[$>>2]|0)!=(f[_>>2]|0)){U=62;break}if((f[$+4>>2]|0)!=(f[_+4>>2]|0)){U=62;break}}_=(e|0)<2?e:2;if((L|0)<2){ca=_;da=X}else{ea=2;fa=_;ga=1;U=63}}else U=62;while(0);if((U|0)==62)if((L|0)>1){ea=L;fa=e;ga=L+-1|0;U=63}else{ca=e;da=X}if((U|0)==63){U=Z;Z=x;e=ea+X|0;ea=0;L=X;while(1){f[F+(L<<2)>>2]=(f[C+(f[U+(ea<<2)>>2]<<2)>>2]|0)-Z>>3;ea=ea+1|0;if((ea|0)==(ga|0))break;else L=L+1|0}ca=fa;da=e+-1|0}if((ca|0)>1){e=G;G=x;fa=ca+da|0;L=ca;ca=da;while(1){L=L+-1|0;f[F+(ca<<2)>>2]=(f[C+(f[e+(L<<2)>>2]<<2)>>2]|0)-G>>3;if((L|0)<=1)break;else ca=ca+1|0}M=fa+-1|0}else M=da}if(B){pS(c,M,1,p|8,-1,0,0);do if((NS(c)|0)==65536){p=f[q>>2]|0;f[h>>2]=f[p>>2];B=h+4|0;da=p+4|0;f[B>>2]=f[da>>2];fa=h+8|0;f[fa>>2]=f[p+8>>2];f[h+12>>2]=f[p+12>>2];f[h+16>>2]=f[p+16>>2];f[h+20>>2]=f[p+20>>2];f[h+24>>2]=f[p+24>>2];f[h+28>>2]=f[p+28>>2];f[h+32>>2]=f[p+32>>2];ca=f[p+36>>2]|0;f[h+36>>2]=ca;f[h+40>>2]=fa;fa=h+48|0;L=h+44|0;f[L>>2]=fa;f[fa>>2]=0;f[h+52>>2]=0;if(ca|0){fa=ca+12|0;f[fa>>2]=(f[fa>>2]|0)+1}if((f[da>>2]|0)<3){da=f[p+44>>2]|0;fa=f[L>>2]|0;f[fa>>2]=f[da>>2];f[fa+4>>2]=f[da+4>>2];ha=h;break}else{f[B>>2]=0;BR(h,p);ha=h;break}}else{OR(h,c,-1);ha=h}while(0);if(!(f[ha>>2]&16384))ia=f[f[h+44>>2]>>2]|0;else ia=8;if((M|0)>0){ha=f[h+16>>2]|0;q=0;do{p=f[F+(q<<2)>>2]|0;B=ha+(Y(q,ia)|0)|0;f[B>>2]=f[x+(p<<3)>>2];f[B+4>>2]=f[x+(p<<3)+4>>2];q=q+1|0}while((q|0)!=(M|0))}q=h+36|0;x=f[q>>2]|0;do if(x|0){ia=x+12|0;ha=f[ia>>2]|0;f[ia>>2]=ha+-1;if((ha|0)!=1)break;CR(h)}while(0);f[q>>2]=0;q=h+16|0;x=h+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[x>>2]|0)>0){q=f[h+40>>2]|0;ha=0;do{f[q+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[x>>2]|0))}x=f[h+44>>2]|0;if((x|0)!=(h+48|0))ZF(x)}else{x=o+4|0;f[x>>2]=2;h=o+8|0;f[h>>2]=M;f[o+12>>2]=1;M=o+16|0;f[M>>2]=F;f[o+20>>2]=F;ha=o+24|0;q=o+40|0;ia=ha+8|0;f[ia>>2]=0;f[ia+4>>2]=0;f[q>>2]=h;ia=o+48|0;p=o+44|0;f[p>>2]=ia;f[o>>2]=1124024324;f[ia>>2]=4;f[o+52>>2]=4;B=F+(f[h>>2]<<2)|0;f[o+28>>2]=B;f[ha>>2]=B+-4+4;eL(o,c);B=o+36|0;ha=f[B>>2]|0;if(ha|0?(h=ha+12|0,ha=f[h>>2]|0,f[h>>2]=ha+-1,(ha|0)==1):0)CR(o);f[B>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[x>>2]|0)>0){M=f[q>>2]|0;q=0;do{f[M+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[x>>2]|0))}x=f[p>>2]|0;if((x|0)!=(ia|0))ZF(x)}x=f[m>>2]|0;if((x|0)!=(D|0)){if(x|0)QYa(x);f[m>>2]=D;f[y>>2]=264}y=f[l>>2]|0;if((y|0)!=(A|0)){if(y|0)QYa(y);f[l>>2]=A;f[z>>2]=264}z=f[k>>2]|0;if((z|0)!=(v|0)){if(z|0)QYa(z);f[k>>2]=v;f[w>>2]=264}}else oS(c);c=j+36|0;w=f[c>>2]|0;if(w|0?(v=w+12|0,w=f[v>>2]|0,f[v>>2]=w+-1,(w|0)==1):0)CR(j);f[c>>2]=0;c=j+16|0;w=j+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[w>>2]|0)>0){c=f[j+40>>2]|0;v=0;do{f[c+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[w>>2]|0))}w=f[j+44>>2]|0;if((w|0)!=(j+48|0))ZF(w);if(!(f[i+4>>2]|0)){u=g;return}u=g;return}function j7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=a;a=b;a:while(1){b=a;e=a+-4|0;g=a+-8|0;h=d;while(1){i=h;b:while(1){j=i;k=b-j|0;l=k>>2;switch(l|0){case 2:{m=5;break a;break}case 3:{m=9;break a;break}case 4:{m=27;break a;break}case 5:{m=28;break a;break}case 1:case 0:{m=107;break a;break}default:{}}if((k|0)<124){m=30;break a}n=i+(((l|0)/2|0)<<2)|0;do if((k|0)>3996){o=(l|0)/4|0;p=s7(i,i+(o<<2)|0,n,n+(o<<2)|0,e,c)|0}else{o=f[n>>2]|0;q=f[i>>2]|0;r=f[o>>2]|0;s=f[q>>2]|0;t=o;u=q;if((r|0)>=(s|0))if((r|0)==(s|0))v=(f[o+4>>2]|0)<(f[q+4>>2]|0);else v=0;else v=1;w=f[e>>2]|0;x=f[w>>2]|0;y=w;if((x|0)>=(r|0))if((x|0)==(r|0))z=(f[w+4>>2]|0)<(f[o+4>>2]|0);else z=0;else z=1;if(!v){if(!z){p=0;break}f[n>>2]=y;f[e>>2]=t;o=f[n>>2]|0;w=f[i>>2]|0;r=f[o>>2]|0;x=f[w>>2]|0;A=w;B=o;if((r|0)>=(x|0)){if((r|0)!=(x|0)){p=1;break}if((f[o+4>>2]|0)>=(f[w+4>>2]|0)){p=1;break}}f[i>>2]=B;f[n>>2]=A;p=2;break}if(z){f[i>>2]=y;f[e>>2]=u;p=1;break}f[i>>2]=t;f[n>>2]=u;t=f[e>>2]|0;y=f[t>>2]|0;A=t;if((y|0)>=(s|0)){if((y|0)!=(s|0)){p=1;break}if((f[t+4>>2]|0)>=(f[q+4>>2]|0)){p=1;break}}f[n>>2]=A;f[e>>2]=u;p=2}while(0);C=f[i>>2]|0;l=f[n>>2]|0;k=f[C>>2]|0;u=f[l>>2]|0;if((k|0)<(u|0)){D=e;E=p;break}if((k|0)==(u|0)?(f[C+4>>2]|0)<(f[l+4>>2]|0):0){D=e;E=p;break}if((i|0)!=(g|0)){A=l+4|0;F=g;while(1){G=f[F>>2]|0;l=f[G>>2]|0;if((l|0)<(u|0)){m=82;break b}if((l|0)==(u|0)?(f[G+4>>2]|0)<(f[A>>2]|0):0){m=82;break b}l=F+-4|0;if((i|0)==(l|0))break;else F=l}}A=i+4|0;u=f[e>>2]|0;l=f[u>>2]|0;q=u;do if((k|0)<(l|0))H=A;else{if((k|0)==(l|0)?(f[C+4>>2]|0)<(f[u+4>>2]|0):0){H=A;break}if((A|0)==(e|0)){m=107;break a}t=C+4|0;s=A;while(1){I=f[s>>2]|0;y=f[I>>2]|0;if((k|0)<(y|0))break;if((k|0)==(y|0)?(f[t>>2]|0)<(f[I+4>>2]|0):0)break;y=s+4|0;if((y|0)==(e|0)){m=107;break a}else s=y}f[s>>2]=q;f[e>>2]=I;H=s+4|0}while(0);if((H|0)==(e|0)){m=107;break a}else{J=H;K=e}while(1){q=f[i>>2]|0;k=f[J>>2]|0;A=f[q>>2]|0;u=f[k>>2]|0;c:do if((A|0)<(u|0))L=J;else{l=q+4|0;t=u;y=k;B=J;while(1){if((A|0)==(t|0)?(f[l>>2]|0)<(f[y+4>>2]|0):0){L=B;break c}w=B+4|0;y=f[w>>2]|0;t=f[y>>2]|0;if((A|0)<(t|0)){L=w;break}else B=w}}while(0);k=q+4|0;u=K;while(1){s=u;u=u+-4|0;M=f[u>>2]|0;s=f[M>>2]|0;if((A|0)<(s|0)){u=u;continue}if((A|0)!=(s|0))break;if((f[k>>2]|0)>=(f[M+4>>2]|0))break}if(L>>>0>=u>>>0){i=L;continue b}k=f[L>>2]|0;f[L>>2]=M;f[u>>2]=k;J=L+4|0;K=u}}if((m|0)==82){m=0;f[i>>2]=G;f[F>>2]=C;D=F;E=p+1|0}k=i+4|0;d:do if(k>>>0<D>>>0){A=k;q=D;s=n;B=E;while(1){t=f[s>>2]|0;y=f[t>>2]|0;l=t+4|0;t=A;while(1){N=f[t>>2]|0;w=f[N>>2]|0;if((w|0)>=(y|0)){if((w|0)!=(y|0))break;if((f[N+4>>2]|0)>=(f[l>>2]|0))break}t=t+4|0}u=N;w=q+-4|0;o=f[w>>2]|0;x=f[o>>2]|0;e:do if((x|0)<(y|0))O=w;else{r=x;P=o;Q=w;while(1){if((r|0)==(y|0)?(f[P+4>>2]|0)<(f[l>>2]|0):0){O=Q;break e}R=Q+-4|0;P=f[R>>2]|0;r=f[P>>2]|0;if((r|0)<(y|0)){O=R;break}else Q=R}}while(0);if(t>>>0>O>>>0){S=t;T=s;U=B;break d}f[t>>2]=f[O>>2];f[O>>2]=u;A=t+4|0;q=O;s=(s|0)==(t|0)?O:s;B=B+1|0}}else{S=k;T=n;U=E}while(0);do if((S|0)==(T|0))V=U;else{k=f[T>>2]|0;B=f[S>>2]|0;s=f[k>>2]|0;q=f[B>>2]|0;A=B;y=k;if((s|0)>=(q|0)){if((s|0)!=(q|0)){V=U;break}if((f[k+4>>2]|0)>=(f[B+4>>2]|0)){V=U;break}}f[S>>2]=y;f[T>>2]=A;V=U+1|0}while(0);if(!V){W=u7(i,S,c)|0;A=S+4|0;if(u7(A,a,c)|0){m=106;break}if(W){h=A;continue}}A=S;if((A-j|0)>=(b-A|0)){m=105;break}j7(i,S,c);h=S+4|0}if((m|0)==105){m=0;j7(S+4|0,a,c);d=i;a=S;continue}else if((m|0)==106){m=0;if(W){m=107;break}else{d=i;a=S;continue}}}if((m|0)==5){S=f[e>>2]|0;d=f[i>>2]|0;W=f[S>>2]|0;j=f[d>>2]|0;V=d;U=S;if((W|0)>=(j|0)){if((W|0)!=(j|0))return;if((f[S+4>>2]|0)>=(f[d+4>>2]|0))return}f[i>>2]=U;f[e>>2]=V;return}else if((m|0)==9){V=i+4|0;U=f[V>>2]|0;d=f[i>>2]|0;S=f[U>>2]|0;j=f[d>>2]|0;W=U;T=d;if((S|0)>=(j|0))if((S|0)==(j|0))X=(f[U+4>>2]|0)<(f[d+4>>2]|0);else X=0;else X=1;E=f[e>>2]|0;n=f[E>>2]|0;O=E;if((n|0)>=(S|0))if((n|0)==(S|0))Y=(f[E+4>>2]|0)<(f[U+4>>2]|0);else Y=0;else Y=1;if(!X){if(!Y)return;f[V>>2]=O;f[e>>2]=W;X=f[V>>2]|0;U=f[i>>2]|0;E=f[X>>2]|0;S=f[U>>2]|0;n=U;N=X;if((E|0)>=(S|0)){if((E|0)!=(S|0))return;if((f[X+4>>2]|0)>=(f[U+4>>2]|0))return}f[i>>2]=N;f[V>>2]=n;return}if(Y){f[i>>2]=O;f[e>>2]=T;return}f[i>>2]=W;f[V>>2]=T;W=f[e>>2]|0;O=f[W>>2]|0;Y=W;if((O|0)>=(j|0)){if((O|0)!=(j|0))return;if((f[W+4>>2]|0)>=(f[d+4>>2]|0))return}f[V>>2]=Y;f[e>>2]=T;return}else if((m|0)==27){r7(i,i+4|0,i+8|0,e,c)|0;return}else if((m|0)==28){s7(i,i+4|0,i+8|0,i+12|0,e,c)|0;return}else if((m|0)==30){t7(i,a,c);return}else if((m|0)==107)return}function k7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;d=a;a=b;a:while(1){b=a;e=a+-4|0;g=a+-8|0;h=d;while(1){i=h;b:while(1){j=i;k=b-j|0;l=k>>2;switch(l|0){case 2:{m=5;break a;break}case 3:{m=9;break a;break}case 4:{m=27;break a;break}case 5:{m=28;break a;break}case 1:case 0:{m=107;break a;break}default:{}}if((k|0)<124){m=30;break a}o=i+(((l|0)/2|0)<<2)|0;do if((k|0)>3996){p=(l|0)/4|0;q=o7(i,i+(p<<2)|0,o,o+(p<<2)|0,e,c)|0}else{p=f[o>>2]|0;r=f[i>>2]|0;s=+n[p>>2];t=+n[r>>2];u=p;v=r;if(!(s<t))if(s==t)w=+n[p+4>>2]<+n[r+4>>2];else w=0;else w=1;x=f[e>>2]|0;y=+n[x>>2];z=x;if(!(y<s))if(y==s)A=+n[x+4>>2]<+n[p+4>>2];else A=0;else A=1;if(!w){if(!A){q=0;break}f[o>>2]=z;f[e>>2]=u;p=f[o>>2]|0;x=f[i>>2]|0;s=+n[p>>2];y=+n[x>>2];B=x;C=p;if(!(s<y)){if(!(s==y)){q=1;break}if(!(+n[p+4>>2]<+n[x+4>>2])){q=1;break}}f[i>>2]=C;f[o>>2]=B;q=2;break}if(A){f[i>>2]=z;f[e>>2]=v;q=1;break}f[i>>2]=u;f[o>>2]=v;u=f[e>>2]|0;y=+n[u>>2];z=u;if(!(y<t)){if(!(y==t)){q=1;break}if(!(+n[u+4>>2]<+n[r+4>>2])){q=1;break}}f[o>>2]=z;f[e>>2]=v;q=2}while(0);D=f[i>>2]|0;l=f[o>>2]|0;t=+n[D>>2];y=+n[l>>2];if(t<y){E=e;F=q;break}if(t==y?+n[D+4>>2]<+n[l+4>>2]:0){E=e;F=q;break}if((i|0)!=(g|0)){k=l+4|0;G=g;while(1){H=f[G>>2]|0;s=+n[H>>2];if(s<y){m=82;break b}if(s==y?+n[H+4>>2]<+n[k>>2]:0){m=82;break b}l=G+-4|0;if((i|0)==(l|0))break;else G=l}}k=i+4|0;l=f[e>>2]|0;y=+n[l>>2];v=l;do if(t<y)I=k;else{if(t==y?+n[D+4>>2]<+n[l+4>>2]:0){I=k;break}if((k|0)==(e|0)){m=107;break a}z=D+4|0;r=k;while(1){J=f[r>>2]|0;s=+n[J>>2];if(t<s)break;if(t==s?+n[z>>2]<+n[J+4>>2]:0)break;u=r+4|0;if((u|0)==(e|0)){m=107;break a}else r=u}f[r>>2]=v;f[e>>2]=J;I=r+4|0}while(0);if((I|0)==(e|0)){m=107;break a}else{K=I;L=e}while(1){v=f[i>>2]|0;k=f[K>>2]|0;t=+n[v>>2];y=+n[k>>2];c:do if(t<y)M=K;else{l=v+4|0;s=y;z=k;u=K;while(1){if(t==s?+n[l>>2]<+n[z+4>>2]:0){M=u;break c}B=u+4|0;z=f[B>>2]|0;s=+n[z>>2];if(t<s){M=B;break}else u=B}}while(0);k=v+4|0;r=L;while(1){u=r;r=r+-4|0;N=f[r>>2]|0;y=+n[N>>2];if(t<y){r=r;continue}if(!(t==y))break;if(!(+n[k>>2]<+n[N+4>>2]))break}if(M>>>0>=r>>>0){i=M;continue b}k=f[M>>2]|0;f[M>>2]=N;f[r>>2]=k;K=M+4|0;L=r}}if((m|0)==82){m=0;f[i>>2]=H;f[G>>2]=D;E=G;F=q+1|0}k=i+4|0;d:do if(k>>>0<E>>>0){v=k;u=E;z=o;l=F;while(1){B=f[z>>2]|0;t=+n[B>>2];C=B+4|0;B=v;while(1){O=f[B>>2]|0;y=+n[O>>2];if(!(y<t)){if(!(y==t))break;if(!(+n[O+4>>2]<+n[C>>2]))break}B=B+4|0}r=O;x=u+-4|0;p=f[x>>2]|0;y=+n[p>>2];e:do if(y<t)P=x;else{s=y;Q=p;R=x;while(1){if(s==t?+n[Q+4>>2]<+n[C>>2]:0){P=R;break e}S=R+-4|0;Q=f[S>>2]|0;s=+n[Q>>2];if(s<t){P=S;break}else R=S}}while(0);if(B>>>0>P>>>0){T=B;U=z;V=l;break d}f[B>>2]=f[P>>2];f[P>>2]=r;v=B+4|0;u=P;z=(z|0)==(B|0)?P:z;l=l+1|0}}else{T=k;U=o;V=F}while(0);do if((T|0)==(U|0))W=V;else{k=f[U>>2]|0;l=f[T>>2]|0;t=+n[k>>2];y=+n[l>>2];z=l;u=k;if(!(t<y)){if(!(t==y)){W=V;break}if(!(+n[k+4>>2]<+n[l+4>>2])){W=V;break}}f[T>>2]=u;f[U>>2]=z;W=V+1|0}while(0);if(!W){X=q7(i,T,c)|0;z=T+4|0;if(q7(z,a,c)|0){m=106;break}if(X){h=z;continue}}z=T;if((z-j|0)>=(b-z|0)){m=105;break}k7(i,T,c);h=T+4|0}if((m|0)==105){m=0;k7(T+4|0,a,c);d=i;a=T;continue}else if((m|0)==106){m=0;if(X){m=107;break}else{d=i;a=T;continue}}}if((m|0)==5){T=f[e>>2]|0;d=f[i>>2]|0;y=+n[T>>2];t=+n[d>>2];X=d;j=T;if(!(y<t)){if(!(y==t))return;if(!(+n[T+4>>2]<+n[d+4>>2]))return}f[i>>2]=j;f[e>>2]=X;return}else if((m|0)==9){X=i+4|0;j=f[X>>2]|0;d=f[i>>2]|0;t=+n[j>>2];y=+n[d>>2];T=j;W=d;if(!(t<y))if(t==y)Y=+n[j+4>>2]<+n[d+4>>2];else Y=0;else Y=1;V=f[e>>2]|0;s=+n[V>>2];U=V;if(!(s<t))if(s==t)Z=+n[V+4>>2]<+n[j+4>>2];else Z=0;else Z=1;if(!Y){if(!Z)return;f[X>>2]=U;f[e>>2]=T;Y=f[X>>2]|0;j=f[i>>2]|0;t=+n[Y>>2];s=+n[j>>2];V=j;F=Y;if(!(t<s)){if(!(t==s))return;if(!(+n[Y+4>>2]<+n[j+4>>2]))return}f[i>>2]=F;f[X>>2]=V;return}if(Z){f[i>>2]=U;f[e>>2]=W;return}f[i>>2]=T;f[X>>2]=W;T=f[e>>2]|0;s=+n[T>>2];U=T;if(!(s<y)){if(!(s==y))return;if(!(+n[T+4>>2]<+n[d+4>>2]))return}f[X>>2]=U;f[e>>2]=W;return}else if((m|0)==27){n7(i,i+4|0,i+8|0,e,c)|0;return}else if((m|0)==28){o7(i,i+4|0,i+8|0,i+12|0,e,c)|0;return}else if((m|0)==30){p7(i,a,c);return}else if((m|0)==107)return}function l7(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;h=(c|0)>(b|0)?1:-1;i=h+b|0;j=i+h|0;do if((b|0)!=(c|0)){k=f[a+(b<<2)>>2]|0;l=f[a+(c<<2)>>2]|0;if((f[k>>2]|0)==(f[l>>2]|0)?(f[k+4>>2]|0)==(f[l+4>>2]|0):0)break;f[d>>2]=b;l=d+4|0;f[l>>2]=i;k=d+8|0;f[k>>2]=j;m=h+c|0;a:do if((j|0)==(m|0))n=3;else{o=i;p=j;q=b;r=3;while(1){s=d+(r+-1<<2)|0;t=a+(q<<2)|0;u=f[a+(o<<2)>>2]|0;b:do if((q|0)!=(b|0)){v=u+4|0;w=p;while(1){x=f[v>>2]|0;y=f[a+(w<<2)>>2]|0;z=(f[y+4>>2]|0)-x|0;if((((z|0)>0&1)-(z>>>31)|0)!=(e|0))break;A=w+h|0;f[s>>2]=A;if((A|0)==(m|0)){n=r;break a}else w=A}v=f[u>>2]|0;A=f[t>>2]|0;B=v-(f[A>>2]|0)|0;C=x-(f[A+4>>2]|0)|0;A=(Y(C,(f[y>>2]|0)-v|0)|0)-(Y(B,z)|0)|0;if((C|B|0)==0?1:(((A|0)>0&1)-(A>>>31)|0)!=(g|0)){f[d+(r+-2<<2)>>2]=w;D=-1;E=q;F=w;G=f[d+(r+-4<<2)>>2]|0}else{H=o;I=w;J=15}}else{A=u;B=o;C=p;while(1){v=A+4|0;K=C;while(1){L=f[v>>2]|0;M=f[a+(K<<2)>>2]|0;N=(f[M+4>>2]|0)-L|0;if((((N|0)>0&1)-(N>>>31)|0)!=(e|0))break;O=K+h|0;f[s>>2]=O;if((O|0)==(m|0)){n=r;break a}else K=O}v=f[A>>2]|0;O=f[t>>2]|0;P=v-(f[O>>2]|0)|0;Q=L-(f[O+4>>2]|0)|0;O=(Y(Q,(f[M>>2]|0)-v|0)|0)-(Y(P,N)|0)|0;if(!((Q|P|0)==0?1:(((O|0)>0&1)-(O>>>31)|0)!=(g|0))){H=B;I=K;J=15;break b}f[l>>2]=K;O=K+h|0;f[k>>2]=O;if((O|0)==(m|0)){n=r;break a}else{A=M;B=K;C=O}}}while(0);if((J|0)==15){J=0;t=I+h|0;f[d+(r<<2)>>2]=t;D=1;E=I;F=t;G=H}t=r+D|0;if((F|0)==(m|0)){n=t;break}else{o=E;p=F;q=G;r=t}}}while(0);R=n+-1|0;return R|0}while(0);f[d>>2]=b;R=1;return R|0}function m7(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0,S=0,T=0;h=(c|0)>(b|0)?1:-1;i=h+b|0;j=i+h|0;do if((b|0)!=(c|0)){k=f[a+(b<<2)>>2]|0;l=f[a+(c<<2)>>2]|0;if(+n[k>>2]==+n[l>>2]?+n[k+4>>2]==+n[l+4>>2]:0)break;f[d>>2]=b;l=d+4|0;f[l>>2]=i;k=d+8|0;f[k>>2]=j;m=h+c|0;a:do if((j|0)==(m|0))o=3;else{p=i;q=j;r=b;s=3;while(1){t=d+(s+-1<<2)|0;u=a+(r<<2)|0;v=f[a+(p<<2)>>2]|0;w=+n[v+4>>2];b:do if((r|0)==(b|0)){x=v;y=w;z=p;A=q;while(1){B=A;while(1){C=f[a+(B<<2)>>2]|0;D=+n[C+4>>2];E=D-y;if(((E>0.0&1)-(E<0.0&1)|0)!=(e|0))break;F=B+h|0;f[t>>2]=F;if((F|0)==(m|0)){o=s;break a}else B=F}G=+n[x>>2];F=f[u>>2]|0;H=G-+n[F>>2];I=y-+n[F+4>>2];J=(+n[C>>2]-G)*I-E*H;if(((J>0.0&1)-(J<0.0&1)|0)==(g|0)?H!=0.0|I!=0.0:0){K=z;L=B;M=16;break b}f[l>>2]=B;F=B+h|0;f[k>>2]=F;if((F|0)==(m|0)){o=s;break a}else{x=C;y=D;z=B;A=F}}}else{A=q;while(1){N=f[a+(A<<2)>>2]|0;O=+n[N+4>>2]-w;if(((O>0.0&1)-(O<0.0&1)|0)!=(e|0))break;z=A+h|0;f[t>>2]=z;if((z|0)==(m|0)){o=s;break a}else A=z}y=+n[v>>2];z=f[u>>2]|0;I=y-+n[z>>2];H=w-+n[z+4>>2];J=(+n[N>>2]-y)*H-O*I;if(((J>0.0&1)-(J<0.0&1)|0)==(g|0)?I!=0.0|H!=0.0:0){K=p;L=A;M=16;break}f[d+(s+-2<<2)>>2]=A;P=-1;Q=r;R=A;S=f[d+(s+-4<<2)>>2]|0}while(0);if((M|0)==16){M=0;u=L+h|0;f[d+(s<<2)>>2]=u;P=1;Q=L;R=u;S=K}u=s+P|0;if((R|0)==(m|0)){o=u;break}else{p=Q;q=R;r=S;s=u}}}while(0);T=o+-1|0;return T|0}while(0);f[d>>2]=b;T=1;return T|0}function n7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=f[b>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=e;k=g;if(!(h<i))if(h==i)l=+n[e+4>>2]<+n[g+4>>2];else l=0;else l=1;m=f[c>>2]|0;o=+n[m>>2];p=m;if(!(o<h))if(o==h)q=+n[m+4>>2]<+n[e+4>>2];else q=0;else q=1;do if(!l)if(q){f[b>>2]=p;f[c>>2]=j;r=f[b>>2]|0;s=f[a>>2]|0;h=+n[r>>2];o=+n[s>>2];t=s;u=r;if(!(h<o)){if(!(h==o)){v=e;w=j;x=1;break}if(!(+n[r+4>>2]<+n[s+4>>2])){v=e;w=j;x=1;break}}f[a>>2]=u;f[b>>2]=t;t=f[c>>2]|0;v=t;w=t;x=2}else{v=m;w=p;x=0}else{if(q){f[a>>2]=p;f[c>>2]=k;v=g;w=k;x=1;break}f[a>>2]=j;f[b>>2]=k;t=f[c>>2]|0;o=+n[t>>2];u=t;if(!(o<i)){if(!(o==i)){v=t;w=u;x=1;break}if(!(+n[t+4>>2]<+n[g+4>>2])){v=t;w=u;x=1;break}}f[b>>2]=u;f[c>>2]=k;v=g;w=k;x=2}while(0);k=f[d>>2]|0;i=+n[k>>2];o=+n[v>>2];g=k;if(!(i<o)){if(!(i==o)){y=x;return y|0}if(!(+n[k+4>>2]<+n[v+4>>2])){y=x;return y|0}}f[c>>2]=g;f[d>>2]=w;w=x+1|0;d=f[c>>2]|0;g=f[b>>2]|0;o=+n[d>>2];i=+n[g>>2];v=g;k=d;if(!(o<i)){if(!(o==i)){y=w;return y|0}if(!(+n[d+4>>2]<+n[g+4>>2])){y=w;return y|0}}f[b>>2]=k;f[c>>2]=v;v=x+2|0;c=f[b>>2]|0;k=f[a>>2]|0;i=+n[c>>2];o=+n[k>>2];w=k;g=c;if(!(i<o)){if(!(i==o)){y=v;return y|0}if(!(+n[c+4>>2]<+n[k+4>>2])){y=v;return y|0}}f[a>>2]=g;f[b>>2]=w;y=x+3|0;return y|0}function o7(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0.0,k=0.0,l=0,m=0,o=0;h=n7(a,b,c,d,g)|0;g=f[e>>2]|0;i=f[d>>2]|0;j=+n[g>>2];k=+n[i>>2];l=i;m=g;if(!(j<k)){if(!(j==k)){o=h;return o|0}if(!(+n[g+4>>2]<+n[i+4>>2])){o=h;return o|0}}f[d>>2]=m;f[e>>2]=l;l=h+1|0;e=f[d>>2]|0;m=f[c>>2]|0;k=+n[e>>2];j=+n[m>>2];i=m;g=e;if(!(k<j)){if(!(k==j)){o=l;return o|0}if(!(+n[e+4>>2]<+n[m+4>>2])){o=l;return o|0}}f[c>>2]=g;f[d>>2]=i;i=h+2|0;d=f[c>>2]|0;g=f[b>>2]|0;j=+n[d>>2];k=+n[g>>2];l=g;m=d;if(!(j<k)){if(!(j==k)){o=i;return o|0}if(!(+n[d+4>>2]<+n[g+4>>2])){o=i;return o|0}}f[b>>2]=m;f[c>>2]=l;l=h+3|0;c=f[b>>2]|0;m=f[a>>2]|0;k=+n[c>>2];j=+n[m>>2];i=m;g=c;if(!(k<j)){if(!(k==j)){o=l;return o|0}if(!(+n[c+4>>2]<+n[m+4>>2])){o=l;return o|0}}f[a>>2]=g;f[b>>2]=i;o=h+4|0;return o|0}function p7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=a+8|0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=e;k=g;if(!(h<i))if(h==i)l=+n[e+4>>2]<+n[g+4>>2];else l=0;else l=1;m=f[c>>2]|0;o=+n[m>>2];p=m;if(!(o<h))if(o==h)q=+n[m+4>>2]<+n[e+4>>2];else q=0;else q=1;do if(!l)if(q){f[d>>2]=p;f[c>>2]=j;if(!(o<i)){if(!(o==i)){r=j;s=e;break}if(!(+n[m+4>>2]<+n[g+4>>2])){r=j;s=e;break}}f[a>>2]=p;f[d>>2]=k;r=j;s=e}else{r=p;s=m}else{if(q){f[a>>2]=p;f[c>>2]=k;r=k;s=g;break}f[a>>2]=j;f[d>>2]=k;if(!(o<i)){if(!(o==i)){r=p;s=m;break}if(!(+n[m+4>>2]<+n[g+4>>2])){r=p;s=m;break}}f[d>>2]=p;f[c>>2]=k;r=k;s=g}while(0);g=a+12|0;if((g|0)==(b|0))return;else{t=s;u=r;v=g;w=c}while(1){c=f[v>>2]|0;i=+n[c>>2];o=+n[t>>2];g=c;if(!(i<o)){if(i==o?(r=c+4|0,+n[r>>2]<+n[t+4>>2]):0){x=r;y=25}}else{x=c+4|0;y=25}if((y|0)==25){y=0;f[v>>2]=u;a:do if((w|0)==(a|0))z=w;else{c=w;r=w;while(1){s=r;r=c+-4|0;k=f[r>>2]|0;o=+n[k>>2];p=k;if(!(i<o)){if(!(i==o)){z=s;break a}if(!(+n[x>>2]<+n[k+4>>2])){z=s;break a}}f[s>>2]=p;if((r|0)==(a|0)){z=r;break}else c=r}}while(0);f[z>>2]=g}r=v+4|0;if((r|0)==(b|0))break;c=f[v>>2]|0;p=v;t=c;u=c;v=r;w=p}return}function q7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=g;k=e;if(!(h<i)){if(!(h==i)){l=1;return l|0}if(!(+n[e+4>>2]<+n[g+4>>2])){l=1;return l|0}}f[a>>2]=k;f[d>>2]=j;l=1;return l|0}case 3:{j=a+4|0;d=b+-4|0;k=f[j>>2]|0;g=f[a>>2]|0;i=+n[k>>2];h=+n[g>>2];e=k;m=g;if(!(i<h))if(i==h)o=+n[k+4>>2]<+n[g+4>>2];else o=0;else o=1;p=f[d>>2]|0;q=+n[p>>2];r=p;if(!(q<i))if(q==i)s=+n[p+4>>2]<+n[k+4>>2];else s=0;else s=1;if(!o){if(!s){l=1;return l|0}f[j>>2]=r;f[d>>2]=e;o=f[j>>2]|0;k=f[a>>2]|0;i=+n[o>>2];q=+n[k>>2];p=k;t=o;if(!(i<q)){if(!(i==q)){l=1;return l|0}if(!(+n[o+4>>2]<+n[k+4>>2])){l=1;return l|0}}f[a>>2]=t;f[j>>2]=p;l=1;return l|0}if(s){f[a>>2]=r;f[d>>2]=m;l=1;return l|0}f[a>>2]=e;f[j>>2]=m;e=f[d>>2]|0;q=+n[e>>2];r=e;if(!(q<h)){if(!(q==h)){l=1;return l|0}if(!(+n[e+4>>2]<+n[g+4>>2])){l=1;return l|0}}f[j>>2]=r;f[d>>2]=m;l=1;return l|0}case 4:{n7(a,a+4|0,a+8|0,b+-4|0,c)|0;l=1;return l|0}case 5:{o7(a,a+4|0,a+8|0,a+12|0,b+-4|0,c)|0;l=1;return l|0}case 1:case 0:{l=1;return l|0}default:{c=a+8|0;m=a+4|0;d=f[m>>2]|0;r=f[a>>2]|0;h=+n[d>>2];q=+n[r>>2];j=d;g=r;if(!(h<q))if(h==q)u=+n[d+4>>2]<+n[r+4>>2];else u=0;else u=1;e=f[c>>2]|0;i=+n[e>>2];s=e;if(!(i<h))if(i==h)v=+n[e+4>>2]<+n[d+4>>2];else v=0;else v=1;do if(!u)if(v){f[m>>2]=s;f[c>>2]=j;if(!(i<q)){if(!(i==q)){w=d;break}if(!(+n[e+4>>2]<+n[r+4>>2])){w=d;break}}f[a>>2]=s;f[m>>2]=g;w=d}else w=e;else{if(v){f[a>>2]=s;f[c>>2]=g;w=r;break}f[a>>2]=j;f[m>>2]=g;if(!(i<q)){if(!(i==q)){w=e;break}if(!(+n[e+4>>2]<+n[r+4>>2])){w=e;break}}f[m>>2]=s;f[c>>2]=g;w=r}while(0);r=a+12|0;a:do if((r|0)==(b|0)){x=1;y=0}else{g=w;s=0;m=r;e=c;while(1){j=f[m>>2]|0;q=+n[j>>2];i=+n[g>>2];v=j;if(!(q<i))if(q==i?(d=j+4|0,+n[d>>2]<+n[g+4>>2]):0){z=d;A=49}else B=s;else{z=j+4|0;A=49}if((A|0)==49){A=0;f[m>>2]=f[e>>2];b:do if((e|0)==(a|0))C=e;else{j=e;d=e;while(1){u=d;d=j+-4|0;p=f[d>>2]|0;i=+n[p>>2];t=p;if(!(q<i)){if(!(q==i)){C=u;break b}if(!(+n[z>>2]<+n[p+4>>2])){C=u;break b}}f[u>>2]=t;if((d|0)==(a|0)){C=d;break}else j=d}}while(0);f[C>>2]=v;d=s+1|0;if((d|0)==8){x=0;y=(m+4|0)==(b|0);break a}else B=d}d=m+4|0;if((d|0)==(b|0)){x=1;y=0;break a}j=m;g=f[m>>2]|0;s=B;m=d;e=j}}while(0);l=y|x;return l|0}}return 0}function r7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=f[b>>2]|0;g=f[a>>2]|0;h=f[e>>2]|0;i=f[g>>2]|0;j=e;k=g;if((h|0)>=(i|0))if((h|0)==(i|0))l=(f[e+4>>2]|0)<(f[g+4>>2]|0);else l=0;else l=1;m=f[c>>2]|0;n=f[m>>2]|0;o=m;if((n|0)>=(h|0))if((n|0)==(h|0))p=(f[m+4>>2]|0)<(f[e+4>>2]|0);else p=0;else p=1;do if(!l)if(p){f[b>>2]=o;f[c>>2]=j;h=f[b>>2]|0;n=f[a>>2]|0;q=f[h>>2]|0;r=f[n>>2]|0;s=n;t=h;if((q|0)>=(r|0)){if((q|0)!=(r|0)){u=e;v=j;w=1;break}if((f[h+4>>2]|0)>=(f[n+4>>2]|0)){u=e;v=j;w=1;break}}f[a>>2]=t;f[b>>2]=s;s=f[c>>2]|0;u=s;v=s;w=2}else{u=m;v=o;w=0}else{if(p){f[a>>2]=o;f[c>>2]=k;u=g;v=k;w=1;break}f[a>>2]=j;f[b>>2]=k;s=f[c>>2]|0;t=f[s>>2]|0;n=s;if((t|0)>=(i|0)){if((t|0)!=(i|0)){u=s;v=n;w=1;break}if((f[s+4>>2]|0)>=(f[g+4>>2]|0)){u=s;v=n;w=1;break}}f[b>>2]=n;f[c>>2]=k;u=g;v=k;w=2}while(0);k=f[d>>2]|0;g=f[k>>2]|0;i=f[u>>2]|0;j=k;if((g|0)>=(i|0)){if((g|0)!=(i|0)){x=w;return x|0}if((f[k+4>>2]|0)>=(f[u+4>>2]|0)){x=w;return x|0}}f[c>>2]=j;f[d>>2]=v;v=w+1|0;d=f[c>>2]|0;j=f[b>>2]|0;u=f[d>>2]|0;k=f[j>>2]|0;i=j;g=d;if((u|0)>=(k|0)){if((u|0)!=(k|0)){x=v;return x|0}if((f[d+4>>2]|0)>=(f[j+4>>2]|0)){x=v;return x|0}}f[b>>2]=g;f[c>>2]=i;i=w+2|0;c=f[b>>2]|0;g=f[a>>2]|0;v=f[c>>2]|0;j=f[g>>2]|0;d=g;k=c;if((v|0)>=(j|0)){if((v|0)!=(j|0)){x=i;return x|0}if((f[c+4>>2]|0)>=(f[g+4>>2]|0)){x=i;return x|0}}f[a>>2]=k;f[b>>2]=d;x=w+3|0;return x|0}function s7(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=r7(a,b,c,d,g)|0;g=f[e>>2]|0;i=f[d>>2]|0;j=f[g>>2]|0;k=f[i>>2]|0;l=i;m=g;if((j|0)>=(k|0)){if((j|0)!=(k|0)){n=h;return n|0}if((f[g+4>>2]|0)>=(f[i+4>>2]|0)){n=h;return n|0}}f[d>>2]=m;f[e>>2]=l;l=h+1|0;e=f[d>>2]|0;m=f[c>>2]|0;i=f[e>>2]|0;g=f[m>>2]|0;k=m;j=e;if((i|0)>=(g|0)){if((i|0)!=(g|0)){n=l;return n|0}if((f[e+4>>2]|0)>=(f[m+4>>2]|0)){n=l;return n|0}}f[c>>2]=j;f[d>>2]=k;k=h+2|0;d=f[c>>2]|0;j=f[b>>2]|0;l=f[d>>2]|0;m=f[j>>2]|0;e=j;g=d;if((l|0)>=(m|0)){if((l|0)!=(m|0)){n=k;return n|0}if((f[d+4>>2]|0)>=(f[j+4>>2]|0)){n=k;return n|0}}f[b>>2]=g;f[c>>2]=e;e=h+3|0;c=f[b>>2]|0;g=f[a>>2]|0;k=f[c>>2]|0;j=f[g>>2]|0;d=g;m=c;if((k|0)>=(j|0)){if((k|0)!=(j|0)){n=e;return n|0}if((f[c+4>>2]|0)>=(f[g+4>>2]|0)){n=e;return n|0}}f[a>>2]=m;f[b>>2]=d;n=h+4|0;return n|0}function t7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;c=a+8|0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=f[e>>2]|0;i=f[g>>2]|0;j=e;k=g;if((h|0)>=(i|0))if((h|0)==(i|0))l=(f[e+4>>2]|0)<(f[g+4>>2]|0);else l=0;else l=1;m=f[c>>2]|0;n=f[m>>2]|0;o=m;if((n|0)>=(h|0))if((n|0)==(h|0))p=(f[m+4>>2]|0)<(f[e+4>>2]|0);else p=0;else p=1;do if(!l)if(p){f[d>>2]=o;f[c>>2]=j;if((n|0)>=(i|0)){if((n|0)!=(i|0)){q=j;r=e;break}if((f[m+4>>2]|0)>=(f[g+4>>2]|0)){q=j;r=e;break}}f[a>>2]=o;f[d>>2]=k;q=j;r=e}else{q=o;r=m}else{if(p){f[a>>2]=o;f[c>>2]=k;q=k;r=g;break}f[a>>2]=j;f[d>>2]=k;if((n|0)>=(i|0)){if((n|0)!=(i|0)){q=o;r=m;break}if((f[m+4>>2]|0)>=(f[g+4>>2]|0)){q=o;r=m;break}}f[d>>2]=o;f[c>>2]=k;q=k;r=g}while(0);g=a+12|0;if((g|0)==(b|0))return;else{s=r;t=q;u=g;v=c}while(1){c=f[u>>2]|0;g=f[c>>2]|0;q=f[s>>2]|0;r=c;if((g|0)>=(q|0)){if((g|0)==(q|0)?(q=c+4|0,(f[q>>2]|0)<(f[s+4>>2]|0)):0){w=q;x=25}}else{w=c+4|0;x=25}if((x|0)==25){x=0;f[u>>2]=t;a:do if((v|0)==(a|0))y=v;else{c=v;q=v;while(1){k=q;q=c+-4|0;o=f[q>>2]|0;d=f[o>>2]|0;m=o;if((g|0)>=(d|0)){if((g|0)!=(d|0)){y=k;break a}if((f[w>>2]|0)>=(f[o+4>>2]|0)){y=k;break a}}f[k>>2]=m;if((q|0)==(a|0)){y=q;break}else c=q}}while(0);f[y>>2]=r}g=u+4|0;if((g|0)==(b|0))break;q=f[u>>2]|0;c=u;s=q;t=q;u=g;v=c}return}function u7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=f[e>>2]|0;i=f[g>>2]|0;j=g;k=e;if((h|0)>=(i|0)){if((h|0)!=(i|0)){l=1;return l|0}if((f[e+4>>2]|0)>=(f[g+4>>2]|0)){l=1;return l|0}}f[a>>2]=k;f[d>>2]=j;l=1;return l|0}case 3:{j=a+4|0;d=b+-4|0;k=f[j>>2]|0;g=f[a>>2]|0;e=f[k>>2]|0;i=f[g>>2]|0;h=k;m=g;if((e|0)>=(i|0))if((e|0)==(i|0))n=(f[k+4>>2]|0)<(f[g+4>>2]|0);else n=0;else n=1;o=f[d>>2]|0;p=f[o>>2]|0;q=o;if((p|0)>=(e|0))if((p|0)==(e|0))r=(f[o+4>>2]|0)<(f[k+4>>2]|0);else r=0;else r=1;if(!n){if(!r){l=1;return l|0}f[j>>2]=q;f[d>>2]=h;n=f[j>>2]|0;k=f[a>>2]|0;o=f[n>>2]|0;e=f[k>>2]|0;p=k;s=n;if((o|0)>=(e|0)){if((o|0)!=(e|0)){l=1;return l|0}if((f[n+4>>2]|0)>=(f[k+4>>2]|0)){l=1;return l|0}}f[a>>2]=s;f[j>>2]=p;l=1;return l|0}if(r){f[a>>2]=q;f[d>>2]=m;l=1;return l|0}f[a>>2]=h;f[j>>2]=m;h=f[d>>2]|0;q=f[h>>2]|0;r=h;if((q|0)>=(i|0)){if((q|0)!=(i|0)){l=1;return l|0}if((f[h+4>>2]|0)>=(f[g+4>>2]|0)){l=1;return l|0}}f[j>>2]=r;f[d>>2]=m;l=1;return l|0}case 4:{r7(a,a+4|0,a+8|0,b+-4|0,c)|0;l=1;return l|0}case 5:{s7(a,a+4|0,a+8|0,a+12|0,b+-4|0,c)|0;l=1;return l|0}case 1:case 0:{l=1;return l|0}default:{c=a+8|0;m=a+4|0;d=f[m>>2]|0;r=f[a>>2]|0;j=f[d>>2]|0;g=f[r>>2]|0;h=d;i=r;if((j|0)>=(g|0))if((j|0)==(g|0))t=(f[d+4>>2]|0)<(f[r+4>>2]|0);else t=0;else t=1;q=f[c>>2]|0;p=f[q>>2]|0;s=q;if((p|0)>=(j|0))if((p|0)==(j|0))u=(f[q+4>>2]|0)<(f[d+4>>2]|0);else u=0;else u=1;do if(!t)if(u){f[m>>2]=s;f[c>>2]=h;if((p|0)>=(g|0)){if((p|0)!=(g|0)){v=d;break}if((f[q+4>>2]|0)>=(f[r+4>>2]|0)){v=d;break}}f[a>>2]=s;f[m>>2]=i;v=d}else v=q;else{if(u){f[a>>2]=s;f[c>>2]=i;v=r;break}f[a>>2]=h;f[m>>2]=i;if((p|0)>=(g|0)){if((p|0)!=(g|0)){v=q;break}if((f[q+4>>2]|0)>=(f[r+4>>2]|0)){v=q;break}}f[m>>2]=s;f[c>>2]=i;v=r}while(0);r=a+12|0;a:do if((r|0)==(b|0)){w=1;x=0}else{i=v;s=0;m=r;q=c;while(1){g=f[m>>2]|0;p=f[g>>2]|0;h=f[i>>2]|0;u=g;if((p|0)>=(h|0))if((p|0)==(h|0)?(h=g+4|0,(f[h>>2]|0)<(f[i+4>>2]|0)):0){y=h;z=49}else A=s;else{y=g+4|0;z=49}if((z|0)==49){z=0;f[m>>2]=f[q>>2];b:do if((q|0)==(a|0))B=q;else{g=q;h=q;while(1){d=h;h=g+-4|0;t=f[h>>2]|0;j=f[t>>2]|0;k=t;if((p|0)>=(j|0)){if((p|0)!=(j|0)){B=d;break b}if((f[y>>2]|0)>=(f[t+4>>2]|0)){B=d;break b}}f[d>>2]=k;if((h|0)==(a|0)){B=h;break}else g=h}}while(0);f[B>>2]=u;p=s+1|0;if((p|0)==8){w=0;x=(m+4|0)==(b|0);break a}else A=p}p=m+4|0;if((p|0)==(b|0)){w=1;x=0;break a}h=m;i=f[m>>2]|0;s=A;m=p;q=h}}while(0);l=x|w;return l|0}}return 0}function v7(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0,S=0;e=u;u=u+208|0;g=e+200|0;h=e+144|0;i=e+88|0;j=e+72|0;k=e;l=e+16|0;_$(g,49156);do if((NS(a)|0)==65536){m=f[a+4>>2]|0;f[h>>2]=f[m>>2];n=h+4|0;o=m+4|0;f[n>>2]=f[o>>2];p=h+8|0;f[p>>2]=f[m+8>>2];f[h+12>>2]=f[m+12>>2];f[h+16>>2]=f[m+16>>2];f[h+20>>2]=f[m+20>>2];f[h+24>>2]=f[m+24>>2];f[h+28>>2]=f[m+28>>2];f[h+32>>2]=f[m+32>>2];q=f[m+36>>2]|0;f[h+36>>2]=q;f[h+40>>2]=p;p=h+48|0;r=h+44|0;f[r>>2]=p;f[p>>2]=0;f[h+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[m+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[n>>2]=0;BR(h,m);break}}else OR(h,a,-1);while(0);a=LS(h,2,4,1)|0;if((a|0)>-1)if((a|0)>=4){do if((NS(c)|0)==65536){m=f[c+4>>2]|0;f[i>>2]=f[m>>2];n=i+4|0;o=m+4|0;f[n>>2]=f[o>>2];p=i+8|0;f[p>>2]=f[m+8>>2];f[i+12>>2]=f[m+12>>2];f[i+16>>2]=f[m+16>>2];f[i+20>>2]=f[m+20>>2];f[i+24>>2]=f[m+24>>2];f[i+28>>2]=f[m+28>>2];f[i+32>>2]=f[m+32>>2];r=f[m+36>>2]|0;f[i+36>>2]=r;f[i+40>>2]=p;p=i+48|0;q=i+44|0;f[q>>2]=p;f[p>>2]=0;f[i+52>>2]=0;if(r|0){p=r+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[m+44>>2]|0;p=f[q>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[n>>2]=0;BR(i,m);break}}else OR(i,c,-1);while(0);c=LS(i,1,4,1)|0;if((c|0)<=0){f[j>>2]=0;f[j+4>>2]=0;s=c$(j,11)|0;t=220664;v=s+11|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,j,220647,220461,284);d$(j)}m=f[h+16>>2]|0;n=i+16|0;o=f[n>>2]|0;p=i+44|0;f[j>>2]=0;q=j+4|0;f[q>>2]=0;f[j+8>>2]=0;if((c|0)>=3){r=f[o+4>>2]|0;w=f[o>>2]|0;x=f[o+8>>2]|0;y=(((x|0)>(r|0)&1)+((r|0)>(w|0)&1)+((w|0)>(x|0)&1)|0)!=2;x=c+-1|0;w=f[o+((y?0:x)<<2)>>2]|0;if(!((w|0)>-1&(w|0)<(a|0))){f[k>>2]=0;f[k+4>>2]=0;s=c$(k,29)|0;t=220676;v=s+29|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,k,220647,220461,300);d$(k)}r=k+4|0;z=k+8|0;A=k+12|0;B=j+8|0;C=k+4|0;D=w;w=0;do{E=D;D=f[o+((y?x-w|0:w)<<2)>>2]|0;if(!((D|0)>-1&(D|0)<(a|0))){f[k>>2]=0;f[C>>2]=0;s=c$(k,29)|0;t=220706;v=s+29|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,k,220647,220461,305);d$(k)}F=f[m+(E<<3)>>2]|0;G=f[m+(E<<3)+4>>2]|0;H=(f[m+(D<<3)>>2]|0)-F|0;I=+(H|0);J=(f[m+(D<<3)+4>>2]|0)-G|0;K=+(J|0);if(!(J|H))N=0.0;else N=1.0/+M(+(I*I+K*K));H=E+1|0;J=(H|0)<(a|0)?H:0;if((J|0)!=(D|0)){H=J;J=-1;O=0.0;P=0;do{Q=N*+L(+(I*+((f[m+(H<<3)+4>>2]|0)-G|0)-K*+((f[m+(H<<3)>>2]|0)-F|0)));R=Q>O;J=R?H:J;O=R?Q:O;P=P|R;R=H+1|0;H=(R|0)<(a|0)?R:0}while((H|0)!=(D|0));if(P){H=rNa(O*256.0)|0;f[k>>2]=E;f[r>>2]=D;f[z>>2]=J;f[A>>2]=H;H=f[q>>2]|0;if((H|0)==(f[B>>2]|0))w7(j,k);else{f[H>>2]=E;f[H+4>>2]=f[r>>2];f[H+8>>2]=f[z>>2];f[H+12>>2]=f[A>>2];f[q>>2]=H+16}}}w=w+1|0}while((c|0)>(w|0));f[l>>2]=1124024348;w=l+4|0;f[w>>2]=2;c=l+8|0;A=f[q>>2]|0;z=f[j>>2]|0;r=A-z|0;f[c>>2]=r>>4;f[l+12>>2]=1;k=l+16|0;B=l+40|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[B>>2]=c;c=l+48|0;D=l+44|0;f[D>>2]=c;f[c>>2]=0;a=l+52|0;f[a>>2]=0;m=z;if((m|0)!=(A|0)){f[a>>2]=16;f[c>>2]=16;f[k>>2]=m;f[l+20>>2]=m;m=z+r|0;f[l+24>>2]=m;f[l+28>>2]=m}eL(l,d);m=l+36|0;r=f[m>>2]|0;if(r|0?(z=r+12|0,r=f[z>>2]|0,f[z>>2]=r+-1,(r|0)==1):0)CR(l);f[m>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[w>>2]|0)>0){k=f[B>>2]|0;B=0;do{f[k+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[w>>2]|0))}w=f[D>>2]|0;if((w|0)!=(c|0))ZF(w)}else oS(d);w=f[j>>2]|0;if(w|0){j=f[q>>2]|0;if((j|0)!=(w|0))f[q>>2]=j+(~((j+-16-w|0)>>>4)<<4);PYa(w)}w=i+36|0;j=f[w>>2]|0;if(j|0?(q=j+12|0,j=f[q>>2]|0,f[q>>2]=j+-1,(j|0)==1):0)CR(i);f[w>>2]=0;w=i+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[w>>2]|0)>0){n=f[i+40>>2]|0;j=0;do{f[n+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[w>>2]|0))}w=f[p>>2]|0;if((w|0)!=(i+48|0))ZF(w)}else S=11;else{f[i>>2]=0;f[i+4>>2]=0;s=c$(i,12)|0;t=220634;v=s+12|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,i,220647,220461,274);d$(i);S=11}if((S|0)==11)oS(d);d=h+36|0;S=f[d>>2]|0;if(S|0?(i=S+12|0,S=f[i>>2]|0,f[i>>2]=S+-1,(S|0)==1):0)CR(h);f[d>>2]=0;d=h+16|0;S=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[S>>2]|0)>0){d=f[h+40>>2]|0;i=0;do{f[d+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[S>>2]|0))}S=f[h+44>>2]|0;if((S|0)!=(h+48|0))ZF(S);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function w7(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)gXa(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=De(8)|0;UYa(l,358155);f[l>>2]=130560;Of(l|0,21520,875)}else{n=NYa(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;f[l>>2]=f[b>>2];f[n+(g<<4)+4>>2]=f[b+4>>2];f[n+(g<<4)+8>>2]=f[b+8>>2];f[n+(g<<4)+12>>2]=f[b+12>>2];b=l+16|0;if((j|0)==(i|0))o=l;else{g=j+-16-e|0;n=l;m=j;while(1){j=m;m=m+-16|0;f[n+-16>>2]=f[m>>2];f[n+-12>>2]=f[j+-12>>2];f[n+-8>>2]=f[j+-8>>2];f[n+-4>>2]=f[j+-4>>2];if((m|0)==(i|0))break;else n=n+-16|0}o=l+(~(g>>>4)<<4)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;PYa(e);return}function x7(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0;c=u;u=u+64|0;d=c+8|0;e=c;do if((NS(a)|0)==65536){g=f[a+4>>2]|0;f[d>>2]=f[g>>2];h=d+4|0;i=g+4|0;f[h>>2]=f[i>>2];j=d+8|0;f[j>>2]=f[g+8>>2];f[d+12>>2]=f[g+12>>2];f[d+16>>2]=f[g+16>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];k=f[g+36>>2]|0;f[d+36>>2]=k;f[d+40>>2]=j;j=d+48|0;l=d+44|0;f[l>>2]=j;f[j>>2]=0;f[d+52>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[g+44>>2]|0;j=f[l>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];break}else{f[h>>2]=0;BR(d,g);break}}else OR(d,a,-1);while(0);a=LS(d,2,-1,1)|0;g=f[d>>2]&7;if(!((a|0)>-1&(g|1|0)==5)){f[e>>2]=0;f[e+4>>2]=0;h=c$(e,40)|0;i=220514;j=h+40|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));j$(-215,e,220799,220461,392);d$(e)}a:do if(a){e=f[d+16>>2]|0;if((g|0)==4){i=((a<<1)+-2|0)%(a|0)|0;h=a+-1|0;j=f[e+(h<<3)>>2]|0;l=f[e+(h<<3)+4>>2]|0;if((a|0)<=0){m=1;break}h=j;k=l;o=j-(f[e+(i<<3)>>2]|0)|0;j=l-(f[e+(i<<3)+4>>2]|0)|0;i=0;l=0;while(1){p=h;h=f[e+(i<<3)>>2]|0;q=k;k=f[e+(i<<3)+4>>2]|0;r=o;o=h-p|0;p=j;j=k-q|0;q=Y(o,p)|0;p=Y(j,r)|0;l=((p|0)>(q|0)?1:(p|0)<(q|0)?2:3)|l;i=i+1|0;if((l|0)==3){m=0;break a}if((i|0)>=(a|0)){m=1;break}}}else{i=((a<<1)+-2|0)%(a|0)|0;l=a+-1|0;j=f[e+(l<<3)>>2]|0;o=f[e+(l<<3)+4>>2]|0;if((a|0)<=0){m=1;break}t=(f[s>>2]=o,+n[s>>2])-+n[e+(i<<3)+4>>2];l=j;k=o;v=(f[s>>2]=j,+n[s>>2])-+n[e+(i<<3)>>2];w=t;i=0;j=0;while(1){o=l;l=f[e+(i<<3)>>2]|0;h=k;k=f[e+(i<<3)+4>>2]|0;t=(f[s>>2]=l,+n[s>>2]);x=v;v=t-(f[s>>2]=o,+n[s>>2]);t=(f[s>>2]=k,+n[s>>2]);y=w;w=t-(f[s>>2]=h,+n[s>>2]);t=y*v;y=x*w;j=(y>t?1:y<t?2:3)|j;i=i+1|0;if((j|0)==3){m=0;break a}if((i|0)>=(a|0)){m=1;break}}}}else m=0;while(0);a=d+36|0;g=f[a>>2]|0;if(g|0?(i=g+12|0,g=f[i>>2]|0,f[i>>2]=g+-1,(g|0)==1):0)CR(d);f[a>>2]=0;a=d+16|0;g=d+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[g>>2]|0)>0){a=f[d+40>>2]|0;i=0;do{f[a+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[g>>2]|0))}g=f[d+44>>2]|0;if((g|0)==(d+48|0)){u=c;return m|0}ZF(g);u=c;return m|0}function y7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+128|0;h=g+120|0;i=g+64|0;j=g;k=g+8|0;_$(h,49176);do if((NS(a)|0)==65536){l=f[a+4>>2]|0;f[i>>2]=f[l>>2];m=i+4|0;n=l+4|0;f[m>>2]=f[n>>2];o=i+8|0;f[o>>2]=f[l+8>>2];f[i+12>>2]=f[l+12>>2];f[i+16>>2]=f[l+16>>2];f[i+20>>2]=f[l+20>>2];f[i+24>>2]=f[l+24>>2];f[i+28>>2]=f[l+28>>2];f[i+32>>2]=f[l+32>>2];p=f[l+36>>2]|0;f[i+36>>2]=p;q=i+40|0;f[q>>2]=o;o=i+48|0;r=i+44|0;f[r>>2]=o;f[o>>2]=0;f[i+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[l+44>>2]|0;o=f[r>>2]|0;f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2];s=q;break}else{f[m>>2]=0;BR(i,l);s=q;break}}else{OR(i,a,-1);s=i+40|0}while(0);a=f[s>>2]|0;q=f[a>>2]|0;f[j>>2]=f[a+4>>2];f[j+4>>2]=q;KS(b,j,5,-1,0,0);do if((NS(b)|0)==65536){j=f[b+4>>2]|0;f[k>>2]=f[j>>2];q=k+4|0;a=j+4|0;f[q>>2]=f[a>>2];l=k+8|0;f[l>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];f[k+16>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];m=f[j+36>>2]|0;f[k+36>>2]=m;f[k+40>>2]=l;l=k+48|0;n=k+44|0;f[n>>2]=l;f[l>>2]=0;f[k+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[a>>2]|0)<3){a=f[j+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[a>>2];f[l+4>>2]=f[a+4>>2];break}else{f[q>>2]=0;BR(k,j);break}}else OR(k,b,-1);while(0);z7(i,k,c,d,0,0.0,e);e=k+36|0;d=f[e>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)CR(k);f[e>>2]=0;e=k+16|0;d=k+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[d>>2]|0)>0){e=f[k+40>>2]|0;c=0;do{f[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[k+44>>2]|0;if((d|0)!=(k+48|0))ZF(d);d=i+36|0;k=f[d>>2]|0;if(k|0?(c=k+12|0,k=f[c>>2]|0,f[c>>2]=k+-1,(k|0)==1):0)CR(i);f[d>>2]=0;d=i+16|0;k=i+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[k>>2]|0)>0){d=f[s>>2]|0;s=0;do{f[d+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[k>>2]|0))}k=f[i+44>>2]|0;if((k|0)!=(i+48|0))ZF(k);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function z7(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0;j=u;u=u+224|0;k=j+200|0;l=j+144|0;m=j+88|0;o=j+24|0;p=j;q=j+80|0;r=j+16|0;s=f[a>>2]|0;t=(e|0)>0;v=+(d|0)*(t?+(1<<e+-1|0):4.0);w=(e|0)<0?v*2.0:v;v=1.0/((s&7|0)==0?w*255.0:w);switch(s&4095){case 5:case 0:break;default:{f[k>>2]=0;f[k+4>>2]=0;x=c$(k,114)|0;s=220815;y=x+114|0;do{b[x>>0]=b[s>>0]|0;x=x+1|0;s=s+1|0}while((x|0)<(y|0));j$(-215,k,220930,220950,269);d$(k)}}f[l>>2]=1124007936;s=l+4|0;z=l+8|0;A=l+40|0;x=s;y=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));f[A>>2]=z;z=l+48|0;B=l+44|0;f[B>>2]=z;f[z>>2]=0;f[l+52>>2]=0;f[m>>2]=1124007936;C=m+4|0;D=m+8|0;E=m+40|0;x=C;y=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));f[E>>2]=D;D=m+48|0;F=m+44|0;f[F>>2]=D;f[D>>2]=0;f[m+52>>2]=0;if(t){f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;t=o+8|0;f[t>>2]=0;f[t+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=l;b8(k,o,5,1,0,e,v,0.0,i);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;t=o+8|0;f[t>>2]=0;f[t+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=m;b8(k,o,5,0,1,e,v,0.0,i)}else{f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;e=o+8|0;f[e>>2]=0;f[e+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=l;c8(k,o,5,1,0,v,0.0,i);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;e=o+8|0;f[e>>2]=0;f[e+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=m;c8(k,o,5,0,1,v,0.0,i)}e=f[a+40>>2]|0;a=f[e+4>>2]|0;t=f[e>>2]|0;f[o>>2]=1124007936;e=o+4|0;G=o+8|0;H=o+40|0;x=e;y=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));f[H>>2]=G;G=o+48|0;x=o+44|0;f[x>>2]=G;f[G>>2]=0;f[o+52>>2]=0;f[k>>2]=t;f[k+4>>2]=a;AR(o,2,k,21);if((t|0)>0?(y=f[o+16>>2]|0,I=f[f[x>>2]>>2]|0,J=f[l+16>>2]|0,K=f[f[B>>2]>>2]|0,N=f[m+16>>2]|0,O=f[f[F>>2]>>2]|0,(a|0)>0):0){P=0;do{Q=y+(Y(I,P)|0)|0;R=J+(Y(K,P)|0)|0;S=N+(Y(O,P)|0)|0;T=0;do{v=+n[R+(T<<2)>>2];w=+n[S+(T<<2)>>2];U=T*3|0;n[Q+(U<<2)>>2]=v*v;n[Q+(U+1<<2)>>2]=v*w;n[Q+(U+2<<2)>>2]=w*w;T=T+1|0}while((T|0)!=(a|0));P=P+1|0}while((P|0)!=(t|0))}f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=o;t=p+8|0;f[t>>2]=0;f[t+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=o;t=f[o>>2]&7;f[q>>2]=d;f[q+4>>2]=d;f[r>>2]=-1;f[r+4>>2]=-1;Dpa(k,p,t,q,r,0,i);a:do switch(g|0){case 0:{i=f[c+16>>2]|0;r=f[c+44>>2]|0;q=f[H>>2]|0;t=f[q+4>>2]|0;p=f[q>>2]|0;if(f[o>>2]&16384){q=(f[c>>2]&16384|0)!=0;k=Y(q?p:1,t)|0;if(q){V=k;W=1}else{X=k;Z=14}}else{X=t;Z=14}if((Z|0)==14)if((p|0)>0){V=X;W=p}else break a;p=f[o+16>>2]|0;t=f[f[x>>2]>>2]|0;k=f[r>>2]|0;if((V|0)>0){r=0;do{q=p+(Y(r,t)|0)|0;d=i+(Y(r,k)|0)|0;P=0;do{a=P*3|0;w=+n[q+(a<<2)>>2]*.5;v=+n[q+(a+1<<2)>>2];_=+n[q+(a+2<<2)>>2]*.5;$=w-_;aa=w+_-+M(+(v*v+$*$));n[d+(P<<2)>>2]=aa;P=P+1|0}while((P|0)!=(V|0));r=r+1|0}while((r|0)!=(W|0))}break}case 1:{r=f[c+16>>2]|0;k=f[c+44>>2]|0;i=f[H>>2]|0;t=f[i+4>>2]|0;p=f[i>>2]|0;if(f[o>>2]&16384){i=(f[c>>2]&16384|0)!=0;P=Y(i?p:1,t)|0;if(i){ba=P;ca=1}else{da=P;Z=21}}else{da=t;Z=21}if((Z|0)==21)if((p|0)>0){ba=da;ca=p}else break a;p=f[o+16>>2]|0;t=f[f[x>>2]>>2]|0;P=f[k>>2]|0;if((ba|0)>0){k=0;do{i=p+(Y(k,t)|0)|0;d=r+(Y(k,P)|0)|0;q=0;do{a=q*3|0;aa=+n[i+(a<<2)>>2];$=+n[i+(a+1<<2)>>2];v=+n[i+(a+2<<2)>>2];_=aa+v;n[d+(q<<2)>>2]=aa*v-$*$-_*(_*h);q=q+1|0}while((q|0)!=(ba|0));k=k+1|0}while((k|0)!=(ca|0))}break}case 2:{k=f[c+16>>2]|0;P=f[c+44>>2]|0;r=f[H>>2]|0;t=f[r+4>>2]|0;p=f[r>>2]|0;if(f[o>>2]&16384){r=(f[c>>2]&16384|0)!=0;q=Y(r?p:1,t)|0;if(r){ea=q;fa=1}else{ga=q;Z=28}}else{ga=t;Z=28}if((Z|0)==28)if((p|0)>0){ea=ga;fa=p}else break a;p=f[o+16>>2]|0;t=f[f[x>>2]>>2]|0;q=f[P>>2]|0;P=(ea|0)>0;r=0;do{d=p+(Y(r,t)|0)|0;i=k+(Y(r,q)|0)|0;if(P){a=0;do{O=a*3|0;_=+n[d+(O<<2)>>2];$=+n[d+(O+1<<2)>>2];v=$;aa=+n[d+(O+2<<2)>>2];w=(_+aa)*.5;ha=_-aa;ia=+M(+(v*v+ha*ha*.25));ha=ia+w;ja=w-ia;ia=ha-_;w=+L(+$);if(w+ +L(+ia)<.0001){$=ha-aa;ka=w+ +L(+$);la=1.0/(ka+1.1920928955078125e-07);if(ka<.0001){ma=$*la;na=v*la}else{ma=$;na=v}}else{ma=v;na=ia}ia=1.0/+M(+(ma*ma+na*na+2.220446049250313e-16));O=a*6|0;n[i+(O<<2)>>2]=ha;n[i+(O+2<<2)>>2]=ma*ia;n[i+(O+3<<2)>>2]=na*ia;ia=ja-_;if(w+ +L(+ia)<.0001){_=ja-aa;aa=w+ +L(+_);w=1.0/(aa+1.1920928955078125e-07);if(aa<.0001){oa=_*w;pa=v*w}else{oa=_;pa=v}}else{oa=v;pa=ia}ia=1.0/+M(+(oa*oa+pa*pa+2.220446049250313e-16));n[i+((O|1)<<2)>>2]=ja;n[i+(O+4<<2)>>2]=oa*ia;n[i+(O+5<<2)>>2]=pa*ia;a=a+1|0}while((a|0)!=(ea|0))}r=r+1|0}while((r|0)!=(fa|0));break}default:{}}while(0);fa=o+36|0;ea=f[fa>>2]|0;if(ea|0?(ga=ea+12|0,ea=f[ga>>2]|0,f[ga>>2]=ea+-1,(ea|0)==1):0)CR(o);f[fa>>2]=0;fa=o+16|0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[e>>2]|0)>0){fa=f[H>>2]|0;H=0;do{f[fa+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[e>>2]|0))}e=f[x>>2]|0;if((e|0)!=(G|0))ZF(e);e=m+36|0;G=f[e>>2]|0;if(G|0?(x=G+12|0,G=f[x>>2]|0,f[x>>2]=G+-1,(G|0)==1):0)CR(m);f[e>>2]=0;e=m+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[C>>2]|0)>0){e=f[E>>2]|0;E=0;do{f[e+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[C>>2]|0))}C=f[F>>2]|0;if((C|0)!=(D|0))ZF(C);C=l+36|0;D=f[C>>2]|0;if(D|0?(F=D+12|0,D=f[F>>2]|0,f[F>>2]=D+-1,(D|0)==1):0)CR(l);f[C>>2]=0;C=l+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[s>>2]|0)>0){C=f[A>>2]|0;A=0;do{f[C+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[s>>2]|0))}s=f[B>>2]|0;if((s|0)==(z|0)){u=j;return}ZF(s);u=j;return}function A7(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=u;u=u+128|0;i=h+120|0;j=h+64|0;k=h;l=h+8|0;_$(i,49196);do if((NS(a)|0)==65536){m=f[a+4>>2]|0;f[j>>2]=f[m>>2];n=j+4|0;o=m+4|0;f[n>>2]=f[o>>2];p=j+8|0;f[p>>2]=f[m+8>>2];f[j+12>>2]=f[m+12>>2];f[j+16>>2]=f[m+16>>2];f[j+20>>2]=f[m+20>>2];f[j+24>>2]=f[m+24>>2];f[j+28>>2]=f[m+28>>2];f[j+32>>2]=f[m+32>>2];q=f[m+36>>2]|0;f[j+36>>2]=q;r=j+40|0;f[r>>2]=p;p=j+48|0;s=j+44|0;f[s>>2]=p;f[p>>2]=0;f[j+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[m+44>>2]|0;p=f[s>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];t=r;break}else{f[n>>2]=0;BR(j,m);t=r;break}}else{OR(j,a,-1);t=j+40|0}while(0);a=f[t>>2]|0;r=f[a>>2]|0;f[k>>2]=f[a+4>>2];f[k+4>>2]=r;KS(b,k,5,-1,0,0);do if((NS(b)|0)==65536){k=f[b+4>>2]|0;f[l>>2]=f[k>>2];r=l+4|0;a=k+4|0;f[r>>2]=f[a>>2];m=l+8|0;f[m>>2]=f[k+8>>2];f[l+12>>2]=f[k+12>>2];f[l+16>>2]=f[k+16>>2];f[l+20>>2]=f[k+20>>2];f[l+24>>2]=f[k+24>>2];f[l+28>>2]=f[k+28>>2];f[l+32>>2]=f[k+32>>2];n=f[k+36>>2]|0;f[l+36>>2]=n;f[l+40>>2]=m;m=l+48|0;o=l+44|0;f[o>>2]=m;f[m>>2]=0;f[l+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[a>>2]|0)<3){a=f[k+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[a>>2];f[m+4>>2]=f[a+4>>2];break}else{f[r>>2]=0;BR(l,k);break}}else OR(l,b,-1);while(0);z7(j,l,c,d,1,e,g);g=l+36|0;d=f[g>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)CR(l);f[g>>2]=0;g=l+16|0;d=l+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[d>>2]|0)>0){g=f[l+40>>2]|0;c=0;do{f[g+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[l+44>>2]|0;if((d|0)!=(l+48|0))ZF(d);d=j+36|0;l=f[d>>2]|0;if(l|0?(c=l+12|0,l=f[c>>2]|0,f[c>>2]=l+-1,(l|0)==1):0)CR(j);f[d>>2]=0;d=j+16|0;l=j+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[l>>2]|0)>0){d=f[t>>2]|0;t=0;do{f[d+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[l>>2]|0))}l=f[j+44>>2]|0;if((l|0)!=(j+48|0))ZF(l);if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function B7(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0;i=u;u=u+1536|0;k=i+480|0;l=i;m=i+336|0;o=i+304|0;p=i+248|0;q=i+192|0;r=i+328|0;s=i+320|0;t=i+136|0;v=i+312|0;_$(o,49216);do if((NS(a)|0)==65536){w=f[a+4>>2]|0;f[p>>2]=f[w>>2];x=p+4|0;y=w+4|0;f[x>>2]=f[y>>2];z=p+8|0;f[z>>2]=f[w+8>>2];f[p+12>>2]=f[w+12>>2];f[p+16>>2]=f[w+16>>2];f[p+20>>2]=f[w+20>>2];f[p+24>>2]=f[w+24>>2];f[p+28>>2]=f[w+28>>2];f[p+32>>2]=f[w+32>>2];A=f[w+36>>2]|0;f[p+36>>2]=A;B=p+40|0;f[B>>2]=z;z=p+48|0;C=p+44|0;f[C>>2]=z;f[z>>2]=0;f[p+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[w+44>>2]|0;z=f[C>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];D=p;E=B;break}else{f[x>>2]=0;BR(p,w);D=p;E=B;break}}else{OR(p,a,-1);D=p;E=p+40|0}while(0);f[q>>2]=1124007936;a=q+4|0;B=q+8|0;w=q+40|0;x=a;y=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));f[w>>2]=B;z=q+48|0;C=q+44|0;f[C>>2]=z;f[z>>2]=0;f[q+52>>2]=0;A=f[E>>2]|0;F=f[A+4>>2]|0;G=f[A>>2]|0;A=f[D>>2]|0;D=A>>>3&511;H=A&7;A=(H|0)==0;I=(H|0)==2;if((H|2|0)!=2){f[k>>2]=0;f[k+4>>2]=0;x=c$(k,24)|0;J=221138;y=x+24|0;do{b[x>>0]=b[J>>0]|0;x=x+1|0;J=J+1|0}while((x|0)<(y|0));j$(-215,k,221163,221175,1624);d$(k)}K=p+16|0;if(f[K>>2]|0){L=f[p+4>>2]|0;if((L|0)<3)M=Y(f[p+12>>2]|0,f[p+8>>2]|0)|0;else{N=f[E>>2]|0;O=0;P=1;while(1){Q=Y(f[N+(O<<2)>>2]|0,P)|0;O=O+1|0;if((O|0)==(L|0)){M=Q;break}else P=Q}}if((L|0)==0|(M|0)==0)R=16}else R=16;if((R|0)==16){f[k>>2]=0;f[k+4>>2]=0;x=c$(k,12)|0;J=345902;y=x+12|0;do{b[x>>0]=b[J>>0]|0;x=x+1|0;J=J+1|0}while((x|0)<(y|0));j$(-215,k,221163,221175,1625);d$(k)}a:do switch(e|0){case 89:case 88:case 87:case 86:{M=(g|0)>1?g:1;if(!((g|0)<2&(D|0)==0)){f[k>>2]=0;f[k+4>>2]=0;x=c$(k,20)|0;J=221231;y=x+20|0;do{b[x>>0]=b[J>>0]|0;x=x+1|0;J=J+1|0}while((x|0)<(y|0));j$(-215,k,221163,221175,1632);d$(k)}f[r>>2]=F;f[r+4>>2]=G;KS(c,r,H|(M<<3)+-8,-1,0,0);do if((NS(c)|0)==65536){L=f[c+4>>2]|0;f[k>>2]=f[L>>2];P=k+4|0;O=L+4|0;f[P>>2]=f[O>>2];N=k+8|0;f[N>>2]=f[L+8>>2];f[k+12>>2]=f[L+12>>2];f[k+16>>2]=f[L+16>>2];f[k+20>>2]=f[L+20>>2];f[k+24>>2]=f[L+24>>2];f[k+28>>2]=f[L+28>>2];f[k+32>>2]=f[L+32>>2];Q=k+36|0;S=f[L+36>>2]|0;f[Q>>2]=S;f[k+40>>2]=N;N=k+48|0;T=k+44|0;f[T>>2]=N;f[N>>2]=0;f[k+52>>2]=0;if(S|0){N=S+12|0;f[N>>2]=(f[N>>2]|0)+1}if((f[O>>2]|0)<3){O=f[L+44>>2]|0;N=f[T>>2]|0;f[N>>2]=f[O>>2];f[N+4>>2]=f[O+4>>2];U=Q;break}else{f[P>>2]=0;BR(k,L);U=Q;break}}else{OR(k,c,-1);U=k+36|0}while(0);M=f[U>>2]|0;if(M|0){Q=M+12|0;f[Q>>2]=(f[Q>>2]|0)+1}Q=q+36|0;M=f[Q>>2]|0;if(M|0?(L=M+12|0,M=f[L>>2]|0,f[L>>2]=M+-1,(M|0)==1):0)CR(q);f[Q>>2]=0;M=q+16|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[a>>2]|0)>0){L=f[w>>2]|0;P=0;do{f[L+(P<<2)>>2]=0;P=P+1|0;V=f[a>>2]|0}while((P|0)<(V|0));f[q>>2]=f[k>>2];if((V|0)<3)R=37;else R=39}else{f[q>>2]=f[k>>2];R=37}if((R|0)==37){P=f[k+4>>2]|0;if((P|0)<3){f[a>>2]=P;f[B>>2]=f[k+8>>2];f[q+12>>2]=f[k+12>>2];P=f[k+44>>2]|0;L=f[C>>2]|0;f[L>>2]=f[P>>2];f[L+4>>2]=f[P+4>>2]}else R=39}if((R|0)==39)BR(q,k);P=k+16|0;f[M>>2]=f[P>>2];f[q+20>>2]=f[k+20>>2];f[q+24>>2]=f[k+24>>2];f[q+28>>2]=f[k+28>>2];f[q+32>>2]=f[k+32>>2];L=f[U>>2]|0;f[Q>>2]=L;if(L|0?(O=L+12|0,L=f[O>>2]|0,f[O>>2]=L+-1,(L|0)==1):0)CR(k);f[U>>2]=0;L=k+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[L>>2]|0)>0){P=f[k+40>>2]|0;O=0;do{f[P+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[L>>2]|0))}L=f[k+44>>2]|0;if((L|0)!=(k+48|0))ZF(L);if(A){L=f[E>>2]|0;O=f[L+4>>2]|0;P=f[L>>2]|0;L=k+4|0;Q=(e&-2|0)==86;N=P+-2|0;f[L>>2]=N;f[k>>2]=O+-2;if((P|0)>2){f[l>>2]=0;f[l+4>>2]=N;C7(m,p,q,((e|0)==87|(e|0)==89)&1,Q,k,Q?1868:4899,Q?4899:1868);Q=f[a>>2]|0;if((Q|0)<3)W=Y(f[q+12>>2]|0,f[B>>2]|0)|0;else{N=f[w>>2]|0;P=0;O=1;while(1){T=Y(f[N+(P<<2)>>2]|0,O)|0;P=P+1|0;if((P|0)==(Q|0)){W=T;break}else O=T}}_U(l,m,+(W>>>0)*.0000152587890625);D7(m)}O=f[w>>2]|0;Q=f[O+4>>2]|0;P=f[O>>2]|0;f[k>>2]=Q;f[L>>2]=P;O=f[M>>2]|0;N=f[z>>2]|0;T=(Q|0)>0;if((P|0)>2){if(T){Q=0;do{b[O+Q>>0]=b[O+(Q+N)>>0]|0;S=f[L>>2]|0;X=O+((Y(S+-2|0,N)|0)+Q)|0;Z=O+((Y(S+-1|0,N)|0)+Q)|0;b[Z>>0]=b[X>>0]|0;Q=Q+1|0}while((Q|0)<(f[k>>2]|0))}}else if(T?(Q=O+(Y(P+-1|0,N)|0)|0,b[Q>>0]=0,b[O>>0]=0,(f[k>>2]|0)>1):0){Q=1;do{X=O+((Y((f[L>>2]|0)+-1|0,N)|0)+Q)|0;b[X>>0]=0;b[O+Q>>0]=0;Q=Q+1|0}while((Q|0)<(f[k>>2]|0))}break a}if(!I){f[k>>2]=0;f[k+4>>2]=0;x=c$(k,54)|0;J=221252;y=x+54|0;do{b[x>>0]=b[J>>0]|0;x=x+1|0;J=J+1|0}while((x|0)<(y|0));j$(-210,k,221163,221175,1642);d$(k);break a}Q=f[E>>2]|0;O=f[Q+4>>2]|0;N=f[Q>>2]|0;Q=k+4|0;L=(e&-2|0)==86;P=N+-2|0;f[Q>>2]=P;f[k>>2]=O+-2;if((N|0)>2){f[l>>2]=0;f[l+4>>2]=P;E7(m,p,q,((e|0)==87|(e|0)==89)&1,L,k,L?1868:4899,L?4899:1868);L=f[a>>2]|0;if((L|0)<3)_=Y(f[q+12>>2]|0,f[B>>2]|0)|0;else{P=f[w>>2]|0;N=0;O=1;while(1){T=Y(f[P+(N<<2)>>2]|0,O)|0;N=N+1|0;if((N|0)==(L|0)){_=T;break}else O=T}}_U(l,m,+(_>>>0)*.0000152587890625);F7(m)}O=f[w>>2]|0;L=f[O+4>>2]|0;N=f[O>>2]|0;f[k>>2]=L;f[Q>>2]=N;O=f[M>>2]|0;P=(f[z>>2]|0)>>>1;T=(L|0)>0;if((N|0)>2){if(T){X=Y(P,N+-2|0)|0;Z=Y(P,N+-1|0)|0;S=0;do{d[O+(S<<1)>>1]=d[O+(S+P<<1)>>1]|0;d[O+(S+Z<<1)>>1]=d[O+(S+X<<1)>>1]|0;S=S+1|0}while((S|0)!=(L|0))}}else if(T){S=Y(P,N+-1|0)|0;X=0;do{d[O+(X+S<<1)>>1]=0;d[O+(X<<1)>>1]=0;X=X+1|0}while((X|0)!=(L|0))}break}case 65:case 64:case 63:case 62:case 142:case 141:case 140:case 139:case 49:case 48:case 47:case 46:{L=(g|0)<1?3:g;if(!((L+-3|0)>>>0<2&(D|0)==0)){f[k>>2]=0;f[k+4>>2]=0;x=c$(k,34)|0;J=221307;y=x+34|0;do{b[x>>0]=b[J>>0]|0;x=x+1|0;J=J+1|0}while((x|0)<(y|0));j$(-215,k,221163,221175,1651);d$(k)}f[s>>2]=F;f[s+4>>2]=G;KS(c,s,H|(L<<3)+-8,-1,0,0);do if((NS(c)|0)==65536){X=f[c+4>>2]|0;f[t>>2]=f[X>>2];O=t+4|0;S=X+4|0;f[O>>2]=f[S>>2];N=t+8|0;f[N>>2]=f[X+8>>2];f[t+12>>2]=f[X+12>>2];f[t+16>>2]=f[X+16>>2];f[t+20>>2]=f[X+20>>2];f[t+24>>2]=f[X+24>>2];f[t+28>>2]=f[X+28>>2];f[t+32>>2]=f[X+32>>2];P=f[X+36>>2]|0;f[t+36>>2]=P;f[t+40>>2]=N;N=t+48|0;T=t+44|0;f[T>>2]=N;f[N>>2]=0;f[t+52>>2]=0;if(P|0){N=P+12|0;f[N>>2]=(f[N>>2]|0)+1}if((f[S>>2]|0)<3){S=f[X+44>>2]|0;N=f[T>>2]|0;f[N>>2]=f[S>>2];f[N+4>>2]=f[S+4>>2];break}else{f[O>>2]=0;BR(t,X);break}}else OR(t,c,-1);while(0);b:do switch(e|0){case 46:case 47:case 48:case 49:case 139:case 140:case 141:case 142:{if(A){G7(p,t,e);break b}if(!I){f[k>>2]=0;f[k+4>>2]=0;x=c$(k,53)|0;J=221342;y=x+53|0;do{b[x>>0]=b[J>>0]|0;x=x+1|0;J=J+1|0}while((x|0)<(y|0));j$(-210,k,221163,221175,1666);d$(k);break b}L=(f[t+48>>2]|0)>>>1;X=f[E>>2]|0;O=f[X+4>>2]|0;S=f[X>>2]|0;X=k+4|0;N=((f[t>>2]|0)>>>3&511)+1|0;T=S+-2|0;f[X>>2]=T;f[k>>2]=O+-2;if((S|0)>2){f[l>>2]=0;f[l+4>>2]=T;H7(m,p,t,((e|0)==47|(e|0)==49)&1,(e|1|0)==47?-1:1,k);T=f[t+4>>2]|0;if((T|0)<3)$=Y(f[t+12>>2]|0,f[t+8>>2]|0)|0;else{S=f[t+40>>2]|0;O=0;P=1;while(1){Z=Y(f[S+(O<<2)>>2]|0,P)|0;O=O+1|0;if((O|0)==(T|0)){$=Z;break}else P=Z}}_U(l,m,+($>>>0)*.0000152587890625);I7(m)}P=f[t+40>>2]|0;T=f[P+4>>2]|0;O=f[P>>2]|0;f[k>>2]=T;f[X>>2]=O;P=f[t+16>>2]|0;S=Y(T,N)|0;T=(S|0)>0;if((O|0)>2){if(T){Z=Y(O+-2|0,L)|0;M=Y(O+-1|0,L)|0;Q=0;do{d[P+(Q<<1)>>1]=d[P+(Q+L<<1)>>1]|0;d[P+(Q+M<<1)>>1]=d[P+(Q+Z<<1)>>1]|0;Q=Q+1|0}while((Q|0)!=(S|0))}}else if(T){Q=Y(O+-1|0,L)|0;Z=0;do{d[P+(Z+Q<<1)>>1]=0;d[P+(Z<<1)>>1]=0;Z=Z+1|0}while((Z|0)!=(S|0))}break}default:{if(!A){f[k>>2]=0;f[k+4>>2]=0;x=c$(k,10)|0;J=347832;y=x+10|0;do{b[x>>0]=b[J>>0]|0;x=x+1|0;J=J+1|0}while((x|0)<(y|0));j$(-215,k,221163,221175,1670);d$(k)}S=f[K>>2]|0;Z=f[p+48>>2]|0;P=f[t+16>>2]|0;Q=f[t+48>>2]|0;L=f[E>>2]|0;O=f[L+4>>2]|0;T=f[L>>2]|0;if((((O|0)>(T|0)?T:O)|0)<8){G7(p,t,e);break b}L=O<<1;M=O*3|0;N=O<<2;X=O*5|0;aa=O*6|0;ba=O*49|0;ca=O*147|0;da=k+8|0;f[k>>2]=da;ea=k+4|0;f[ea>>2]=ca;if(ca>>>0>520){fa=OYa(ca>>>0>2147483647?-1:ca<<1)|0;f[k>>2]=fa;ga=fa}else ga=da;fa=Z<<1;ca=S+fa|0;S=T+-4|0;if((S|0)>2){ha=O+-2|0;ia=O+-1|0;ja=(ia|0)>1;ka=~Z;la=Z+-1|0;ma=0-Z|0;na=1-Z|0;oa=Z+1|0;pa=(ha|0)>2;qa=M+-9|0;ra=ha*3|0;sa=O+1|0;ta=L|1;ua=L+-1|0;va=M+-1|0;wa=M+1|0;xa=ma<<1;ya=xa+-1|0;za=xa|1;Aa=fa+-1|0;Ba=fa|1;Ca=-2-Z|0;Da=Z+-2|0;Ea=2-Z|0;Fa=Z+2|0;Ga=N|1;Ha=N+-1|0;Ia=X+-1|0;Ja=X+1|0;Ka=Y(Z,-2)|0;La=Ka+2|0;Ma=aa|1;Na=fa+-2|0;Oa=aa+-1|0;Pa=Ka+-2|0;Ka=fa+2|0;Qa=ha+O|0;Ra=ha+L|0;Sa=ha+M|0;Ta=ha+N|0;Ua=ha+X|0;Va=ha+aa|0;Wa=(e|1|0)==63?0:2;Xa=(e|0)!=62&(e|0)!=64;Ya=2;while(1){Za=Y(Ya,Q)|0;_a=(Ya|0)==2?-1:1;do{$a=_a+Ya|0;ab=ga+((Y(($a+-1|0)%3|0,ba)|0)<<1)+2|0;d[ab+(ha<<1)>>1]=0;d[ab+-2>>1]=0;d[ab+(Qa<<1)>>1]=0;d[ab+(ia<<1)>>1]=0;d[ab+(Ra<<1)>>1]=0;d[ab+(ua<<1)>>1]=0;d[ab+(Sa<<1)>>1]=0;d[ab+(va<<1)>>1]=0;d[ab+(Ta<<1)>>1]=0;d[ab+(Ha<<1)>>1]=0;d[ab+(Ua<<1)>>1]=0;d[ab+(Ia<<1)>>1]=0;d[ab+(Va<<1)>>1]=0;d[ab+(Oa<<1)>>1]=0;if(ja){bb=ab;ab=1;cb=ca+(Y($a,Z)|0)+1|0;while(1){$a=cb+ka|0;db=cb+la|0;eb=(h[$a>>0]|0)-(h[db>>0]|0)|0;fb=cb+ma|0;gb=cb+Z|0;hb=(h[fb>>0]|0)-(h[gb>>0]|0)|0;ib=cb+na|0;jb=cb+oa|0;kb=(h[ib>>0]|0)-(h[jb>>0]|0)|0;d[bb>>1]=(((hb|0)>-1?hb:0-hb|0)<<1)+((eb|0)>-1?eb:0-eb|0)+((kb|0)>-1?kb:0-kb|0);kb=(h[$a>>0]|0)-(h[ib>>0]|0)|0;eb=cb+-1|0;cb=cb+1|0;hb=(h[eb>>0]|0)-(h[cb>>0]|0)|0;lb=(h[db>>0]|0)-(h[jb>>0]|0)|0;d[bb+(O<<1)>>1]=(((hb|0)>-1?hb:0-hb|0)<<1)+((kb|0)>-1?kb:0-kb|0)+((lb|0)>-1?lb:0-lb|0);lb=(h[ib>>0]|0)-(h[db>>0]|0)|0;db=bb+(L<<1)|0;d[db>>1]=((lb|0)>-1?lb:0-lb|0)<<1;lb=(h[$a>>0]|0)-(h[jb>>0]|0)|0;jb=bb+(M<<1)|0;d[jb>>1]=((lb|0)>-1?lb:0-lb|0)<<1;lb=(h[fb>>0]|0)-(h[eb>>0]|0)|0;$a=(h[gb>>0]|0)-(h[cb>>0]|0)|0;d[bb+(N<<1)>>1]=((lb|0)>-1?lb:0-lb|0)+(j[db>>1]|0)+(($a|0)>-1?$a:0-$a|0);$a=(h[fb>>0]|0)-(h[cb>>0]|0)|0;db=(h[gb>>0]|0)-(h[eb>>0]|0)|0;d[bb+(X<<1)>>1]=(($a|0)>-1?$a:0-$a|0)+(j[jb>>1]|0)+((db|0)>-1?db:0-db|0);d[bb+(aa<<1)>>1]=((h[eb>>0]|0)+(h[fb>>0]|0)+(h[cb>>0]|0)+(h[gb>>0]|0)|0)>>>1;ab=ab+1|0;if((ab|0)==(ia|0))break;else bb=bb+2|0}}_a=_a+1|0}while((_a|0)!=2);_a=P+Za|0;if(pa){bb=Wa^2;ab=ga+((Y((Ya+-2|0)%3|0,ba)|0)<<1)+4|0;cb=ga+((Y((Ya+-1|0)%3|0,ba)|0)<<1)+4|0;gb=ga+((Y((Ya|0)%3|0,ba)|0)<<1)+4|0;fb=_a+6|0;eb=Xa;db=2;jb=ca+(Y(Ya,Z)|0)+2|0;while(1){$a=j[cb>>1]|0;lb=$a+(j[ab>>1]|0)|0;ib=(j[gb>>1]|0)+$a|0;$a=j[cb+(O<<1)>>1]|0;kb=$a+(j[cb+(ia<<1)>>1]|0)|0;hb=(j[cb+(sa<<1)>>1]|0)+$a|0;$a=ib>>>0<lb>>>0?ib:lb;mb=(kb|0)<($a|0)?kb:$a;$a=(hb|0)<(mb|0)?hb:mb;mb=lb>>>0<ib>>>0?ib:lb;nb=(mb|0)<(kb|0)?kb:mb;mb=(nb|0)<(hb|0)?hb:nb;if(eb){nb=j[cb+(L<<1)>>1]|0;ob=(j[ab+(ta<<1)>>1]|0)+(j[ab+(L<<1)>>1]|0)+nb+(j[cb+(ta<<1)>>1]|0)|0;pb=(j[cb+(ua<<1)>>1]|0)+nb+(j[gb+(L<<1)>>1]|0)+(j[gb+(ua<<1)>>1]|0)|0;nb=j[cb+(M<<1)>>1]|0;qb=(j[ab+(va<<1)>>1]|0)+(j[ab+(M<<1)>>1]|0)+nb+(j[cb+(va<<1)>>1]|0)|0;rb=(j[cb+(wa<<1)>>1]|0)+nb+(j[gb+(M<<1)>>1]|0)+(j[gb+(wa<<1)>>1]|0)|0;nb=(ob|0)<($a|0)?ob:$a;sb=(pb|0)<(nb|0)?pb:nb;nb=(qb|0)<(sb|0)?qb:sb;sb=(mb|0)<(ob|0)?ob:mb;tb=(sb|0)<(pb|0)?pb:sb;sb=(tb|0)<(qb|0)?qb:tb;tb=(sb|0)<(rb|0)?rb:sb;sb=((tb|0)<2?1:tb>>>1)+((rb|0)<(nb|0)?rb:nb)|0;if((lb|0)<(sb|0)){ub=(h[jb+ma>>0]|0)<<1;vb=(h[jb>>0]|0)+(h[jb+xa>>0]|0)|0;wb=(h[jb+za>>0]|0)+(h[jb+ya>>0]|0)|0;xb=1}else{ub=0;vb=0;wb=0;xb=0}if((ib|0)<(sb|0)){yb=((h[jb+Z>>0]|0)<<1)+ub|0;zb=(h[jb+fa>>0]|0)+vb+(h[jb>>0]|0)|0;Ab=(h[jb+Aa>>0]|0)+wb+(h[jb+Ba>>0]|0)|0;Bb=xb+1|0}else{yb=ub;zb=vb;Ab=wb;Bb=xb}if((kb|0)<(sb|0)){Cb=(h[jb+Ca>>0]|0)+yb+(h[jb+Da>>0]|0)|0;Db=(h[jb+-2>>0]|0)+zb+(h[jb>>0]|0)|0;Eb=((h[jb+-1>>0]|0)<<1)+Ab|0;Fb=Bb+1|0}else{Cb=yb;Db=zb;Eb=Ab;Fb=Bb}if((hb|0)<(sb|0)){Gb=(h[jb+Ea>>0]|0)+Cb+(h[jb+Fa>>0]|0)|0;Hb=(h[jb+2>>0]|0)+Db+(h[jb>>0]|0)|0;Ib=((h[jb+1>>0]|0)<<1)+Eb|0;Jb=Fb+1|0}else{Gb=Cb;Hb=Db;Ib=Eb;Jb=Fb}if((ob|0)<(sb|0)){Kb=(h[jb+ma>>0]|0)+Gb+(h[jb+Ea>>0]|0)|0;Lb=((h[jb+na>>0]|0)<<1)+Hb|0;Mb=(h[jb+za>>0]|0)+Ib+(h[jb+1>>0]|0)|0;Nb=Jb+1|0}else{Kb=Gb;Lb=Hb;Mb=Ib;Nb=Jb}if((pb|0)<(sb|0)){Ob=(h[jb+Z>>0]|0)+Kb+(h[jb+Da>>0]|0)|0;Pb=((h[jb+la>>0]|0)<<1)+Lb|0;Qb=(h[jb+Aa>>0]|0)+Mb+(h[jb+-1>>0]|0)|0;Rb=Nb+1|0}else{Ob=Kb;Pb=Lb;Qb=Mb;Rb=Nb}if((qb|0)<(sb|0)){Sb=(h[jb+Ca>>0]|0)+Ob+(h[jb+ma>>0]|0)|0;Tb=((h[jb+ka>>0]|0)<<1)+Pb|0;Ub=(h[jb+ya>>0]|0)+Qb+(h[jb+-1>>0]|0)|0;Vb=Rb+1|0}else{Sb=Ob;Tb=Pb;Ub=Qb;Vb=Rb}if((rb|0)<(sb|0)){Wb=(h[jb+Fa>>0]|0)+Sb+(h[jb+Z>>0]|0)|0;Xb=((h[jb+oa>>0]|0)<<1)+Tb|0;Yb=(h[jb+Ba>>0]|0)+Ub+(h[jb+1>>0]|0)|0;Zb=Vb+1|0}else{Wb=Sb;Xb=Tb;Yb=Ub;Zb=Vb}sb=h[jb>>0]|0;_b=+n[49236+(Zb<<2)>>2];$b=_b;ac=sb;bc=(wNa(+(Yb-Xb|0)*_b)|0)+sb|0;cc=sb;dc=Wb-Xb|0}else{sb=j[cb+(N<<1)>>1]|0;rb=sb+(j[ab+(Ga<<1)>>1]|0)|0;qb=(j[gb+(Ha<<1)>>1]|0)+sb|0;sb=j[cb+(X<<1)>>1]|0;pb=sb+(j[ab+(Ia<<1)>>1]|0)|0;ob=(j[gb+(Ja<<1)>>1]|0)+sb|0;sb=(rb|0)<($a|0)?rb:$a;$a=(qb|0)<(sb|0)?qb:sb;sb=(pb|0)<($a|0)?pb:$a;$a=(mb|0)<(rb|0)?rb:mb;mb=($a|0)<(qb|0)?qb:$a;$a=(mb|0)<(pb|0)?pb:mb;mb=($a|0)<(ob|0)?ob:$a;$a=((mb|0)<2?1:mb>>>1)+((ob|0)<(sb|0)?ob:sb)|0;sb=h[jb>>0]|0;if((lb|0)<($a|0)){ec=(h[jb+na>>0]|0)+(h[jb+ka>>0]|0)|0;fc=(h[jb+ma>>0]|0)<<1;gc=(h[jb+xa>>0]|0)+sb|0;hc=1}else{ec=0;fc=0;gc=0;hc=0}if((ib|0)<($a|0)){ic=(h[jb+la>>0]|0)+ec+(h[jb+oa>>0]|0)|0;jc=((h[jb+Z>>0]|0)<<1)+fc|0;kc=gc+sb+(h[jb+fa>>0]|0)|0;lc=hc+1|0}else{ic=ec;jc=fc;kc=gc;lc=hc}if((kb|0)<($a|0)){mc=(h[jb+ka>>0]|0)+ic+(h[jb+la>>0]|0)|0;nc=((h[jb+-1>>0]|0)<<1)+jc|0;oc=kc+sb+(h[jb+-2>>0]|0)|0;pc=lc+1|0}else{mc=ic;nc=jc;oc=kc;pc=lc}if((hb|0)<($a|0)){qc=(h[jb+na>>0]|0)+mc+(h[jb+oa>>0]|0)|0;rc=((h[jb+1>>0]|0)<<1)+nc|0;sc=oc+sb+(h[jb+2>>0]|0)|0;tc=pc+1|0}else{qc=mc;rc=nc;sc=oc;tc=pc}if((rb|0)<($a|0)){uc=((h[jb+na>>0]|0)<<1)+qc|0;vc=(j[ab+(Ma<<1)>>1]|0)+rc|0;wc=sc+sb+(h[jb+La>>0]|0)|0;xc=tc+1|0}else{uc=qc;vc=rc;wc=sc;xc=tc}if((qb|0)<($a|0)){yc=((h[jb+la>>0]|0)<<1)+uc|0;zc=(j[gb+(Oa<<1)>>1]|0)+vc|0;Ac=wc+sb+(h[jb+Na>>0]|0)|0;Bc=xc+1|0}else{yc=uc;zc=vc;Ac=wc;Bc=xc}if((pb|0)<($a|0)){Cc=((h[jb+na>>0]|0)<<1)+yc|0;Dc=(j[ab+(Oa<<1)>>1]|0)+zc|0;Ec=Ac+sb+(h[jb+Pa>>0]|0)|0;Fc=Bc+1|0}else{Cc=yc;Dc=zc;Ec=Ac;Fc=Bc}if((ob|0)<($a|0)){Gc=((h[jb+na>>0]|0)<<1)+Cc|0;Hc=(j[gb+(Ma<<1)>>1]|0)+Dc|0;Ic=Ec+sb+(h[jb+Ka>>0]|0)|0;Jc=Fc+1|0}else{Gc=Cc;Hc=Dc;Ic=Ec;Jc=Fc}_b=+n[49236+(Jc<<2)>>2];$b=_b;ac=(wNa(+(Hc-Ic|0)*_b)|0)+sb|0;bc=sb;cc=sb;dc=Gc-Ic|0}sb=(wNa(+(dc|0)*$b)|0)+cc|0;b[fb+Wa>>0]=sb>>>0<256?sb:(sb|0)>0?255:0;b[fb+1>>0]=ac>>>0<256?ac:(ac|0)>0?255:0;b[fb+bb>>0]=bc>>>0<256?bc:(bc|0)>0?255:0;db=db+1|0;if((db|0)==(ha|0)){Kc=bb;break}else{ab=ab+2|0;cb=cb+2|0;gb=gb+2|0;fb=fb+3|0;eb=eb^1;jb=jb+1|0}}}else Kc=Wa^2;jb=qa+Za|0;eb=Za+ra|0;fb=P+(Za+5)|0;b[fb>>0]=b[P+(Za+8)>>0]|0;b[P+eb>>0]=b[P+jb>>0]|0;gb=P+(Za+4)|0;b[gb>>0]=b[P+(Za+7)>>0]|0;b[P+(eb+1)>>0]=b[P+(jb+1)>>0]|0;cb=P+(Za+3)|0;b[cb>>0]=b[P+(Za+6)>>0]|0;b[P+(eb+2)>>0]=b[P+(jb+2)>>0]|0;b[P+(Za+2)>>0]=b[fb>>0]|0;b[P+(eb+3)>>0]=b[P+(jb+3)>>0]|0;b[P+(Za+1)>>0]=b[gb>>0]|0;b[P+(eb+4)>>0]=b[P+(jb+4)>>0]|0;b[_a>>0]=b[cb>>0]|0;b[P+(eb+5)>>0]=b[P+(jb+5)>>0]|0;Ya=Ya+1|0;if((Ya|0)==(S|0))break;else{Wa=Kc;Xa=Xa^1}}}if((M|0)>0){Xa=Q<<1;Wa=Y(T+-5|0,Q)|0;Ya=Y(T+-1|0,Q)|0;ra=Y(T+-2|0,Q)|0;qa=Y(T+-3|0,Q)|0;ha=Y(S,Q)|0;Ka=0;do{Ma=b[P+(Ka+Xa)>>0]|0;b[P+(Ka+Q)>>0]=Ma;b[P+Ka>>0]=Ma;Ma=b[P+(Ka+Wa)>>0]|0;b[P+(Ka+Ya)>>0]=Ma;b[P+(Ka+ra)>>0]=Ma;b[P+(Ka+qa)>>0]=Ma;b[P+(Ka+ha)>>0]=Ma;Ka=Ka+1|0}while((Ka|0)!=(M|0))}M=f[k>>2]|0;if((M|0)!=(da|0)){if(M|0)QYa(M);f[k>>2]=da;f[ea>>2]=520}}}while(0);M=t+36|0;Ka=f[M>>2]|0;if(Ka|0?(ha=Ka+12|0,Ka=f[ha>>2]|0,f[ha>>2]=Ka+-1,(Ka|0)==1):0)CR(t);f[M>>2]=0;M=t+16|0;Ka=t+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[Ka>>2]|0)>0){M=f[t+40>>2]|0;ha=0;do{f[M+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[Ka>>2]|0))}Ka=f[t+44>>2]|0;if((Ka|0)!=(t+48|0))ZF(Ka);break}case 138:case 137:case 136:case 135:{Ka=(g|0)<1?3:g;if(!((Ka|0)==3&(D|0)==0)){f[k>>2]=0;f[k+4>>2]=0;x=c$(k,20)|0;J=221396;y=x+20|0;do{b[x>>0]=b[J>>0]|0;x=x+1|0;J=J+1|0}while((x|0)<(y|0));j$(-215,k,221163,221175,1680);d$(k)}f[v>>2]=F;f[v+4>>2]=G;KS(c,v,H|(Ka<<3)+-8,-1,0,0);do if((NS(c)|0)==65536){ha=f[c+4>>2]|0;f[k>>2]=f[ha>>2];M=k+4|0;P=ha+4|0;f[M>>2]=f[P>>2];qa=k+8|0;f[qa>>2]=f[ha+8>>2];f[k+12>>2]=f[ha+12>>2];f[k+16>>2]=f[ha+16>>2];f[k+20>>2]=f[ha+20>>2];f[k+24>>2]=f[ha+24>>2];f[k+28>>2]=f[ha+28>>2];f[k+32>>2]=f[ha+32>>2];ra=k+36|0;Ya=f[ha+36>>2]|0;f[ra>>2]=Ya;f[k+40>>2]=qa;qa=k+48|0;Wa=k+44|0;f[Wa>>2]=qa;f[qa>>2]=0;f[k+52>>2]=0;if(Ya|0){qa=Ya+12|0;f[qa>>2]=(f[qa>>2]|0)+1}if((f[P>>2]|0)<3){P=f[ha+44>>2]|0;qa=f[Wa>>2]|0;f[qa>>2]=f[P>>2];f[qa+4>>2]=f[P+4>>2];Lc=ra;break}else{f[M>>2]=0;BR(k,ha);Lc=ra;break}}else{OR(k,c,-1);Lc=k+36|0}while(0);Ka=f[Lc>>2]|0;if(Ka|0){ra=Ka+12|0;f[ra>>2]=(f[ra>>2]|0)+1}ra=q+36|0;Ka=f[ra>>2]|0;if(Ka|0?(ha=Ka+12|0,Ka=f[ha>>2]|0,f[ha>>2]=Ka+-1,(Ka|0)==1):0)CR(q);f[ra>>2]=0;Ka=q+16|0;f[Ka>>2]=0;f[Ka+4>>2]=0;f[Ka+8>>2]=0;f[Ka+12>>2]=0;if((f[a>>2]|0)>0){ha=f[w>>2]|0;M=0;do{f[ha+(M<<2)>>2]=0;M=M+1|0;Mc=f[a>>2]|0}while((M|0)<(Mc|0));f[q>>2]=f[k>>2];if((Mc|0)<3)R=195;else R=197}else{f[q>>2]=f[k>>2];R=195}if((R|0)==195){M=f[k+4>>2]|0;if((M|0)<3){f[a>>2]=M;f[B>>2]=f[k+8>>2];f[q+12>>2]=f[k+12>>2];M=f[k+44>>2]|0;ha=f[C>>2]|0;f[ha>>2]=f[M>>2];f[ha+4>>2]=f[M+4>>2]}else R=197}if((R|0)==197)BR(q,k);M=k+16|0;f[Ka>>2]=f[M>>2];f[q+20>>2]=f[k+20>>2];f[q+24>>2]=f[k+24>>2];f[q+28>>2]=f[k+28>>2];f[q+32>>2]=f[k+32>>2];ha=f[Lc>>2]|0;f[ra>>2]=ha;if(ha|0?(P=ha+12|0,ha=f[P>>2]|0,f[P>>2]=ha+-1,(ha|0)==1):0)CR(k);f[Lc>>2]=0;ha=k+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[ha>>2]|0)>0){M=f[k+40>>2]|0;P=0;do{f[M+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[ha>>2]|0))}ha=f[k+44>>2]|0;if((ha|0)!=(k+48|0))ZF(ha);if(A){ha=f[E>>2]|0;P=f[ha+4>>2]|0;M=f[ha>>2]|0;f[k>>2]=P;ha=k+4|0;f[ha>>2]=M;c:do if(!((P|0)<3|(M|0)<3)){f[k>>2]=P+-2;f[ha>>2]=M+-2;J7(l,p,q,k,(e+-135|0)>>>0<2&1,(e|2|0)==138&1);ra=f[ha>>2]|0;f[m>>2]=0;f[m+4>>2]=ra;ra=f[a>>2]|0;if((ra|0)<3)Nc=Y(f[q+12>>2]|0,f[B>>2]|0)|0;else{qa=f[w>>2]|0;Wa=0;Ya=1;while(1){Q=Y(f[qa+(Wa<<2)>>2]|0,Ya)|0;Wa=Wa+1|0;if((Wa|0)==(ra|0)){Nc=Q;break}else Ya=Q}}_U(m,l,+(Nc>>>0)*.0000152587890625);K7(l);Ya=f[w>>2]|0;ra=f[Ya+4>>2]|0;Wa=f[Ya>>2]|0;f[ha>>2]=Wa;Ya=f[q>>2]|0;qa=Y((Ya>>>3&511)+1|0,ra)|0;f[k>>2]=qa;ra=((f[z>>2]|0)>>>0)/((1212424721>>>(Ya<<2&28)&15)>>>0)|0;Ya=f[Ka>>2]|0;ea=Ya+(Y(ra,Wa+-1|0)|0)|0;da=(qa|0)>0;if((Wa|0)<=2){if(da)Oc=0;else break;while(1){b[ea+Oc>>0]=0;b[Ya+Oc>>0]=0;Oc=Oc+1|0;if((Oc|0)>=(f[k>>2]|0))break c}}if(da){Wa=Ya+ra|0;qa=ea+(0-ra)|0;Q=0;do{b[Ya+Q>>0]=b[Wa+Q>>0]|0;b[ea+Q>>0]=b[qa+Q>>0]|0;Q=Q+1|0}while((Q|0)<(f[k>>2]|0))}}else{f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;gL(q,l)|0}while(0);break a}if(!I){f[k>>2]=0;f[k+4>>2]=0;x=c$(k,74)|0;J=221417;y=x+74|0;do{b[x>>0]=b[J>>0]|0;x=x+1|0;J=J+1|0}while((x|0)<(y|0));j$(-210,k,221163,221175,1689);d$(k);break a}ha=f[E>>2]|0;M=f[ha+4>>2]|0;P=f[ha>>2]|0;f[k>>2]=M;ha=k+4|0;f[ha>>2]=P;d:do if(!((M|0)<3|(P|0)<3)){f[k>>2]=M+-2;f[ha>>2]=P+-2;L7(l,p,q,k,(e+-135|0)>>>0<2&1,(e|2|0)==138&1);Q=f[ha>>2]|0;f[m>>2]=0;f[m+4>>2]=Q;Q=f[a>>2]|0;if((Q|0)<3)Pc=Y(f[q+12>>2]|0,f[B>>2]|0)|0;else{qa=f[w>>2]|0;ea=0;Wa=1;while(1){Ya=Y(f[qa+(ea<<2)>>2]|0,Wa)|0;ea=ea+1|0;if((ea|0)==(Q|0)){Pc=Ya;break}else Wa=Ya}}_U(m,l,+(Pc>>>0)*.0000152587890625);M7(l);Wa=f[w>>2]|0;Q=f[Wa+4>>2]|0;ea=f[Wa>>2]|0;f[ha>>2]=ea;Wa=f[q>>2]|0;qa=Y((Wa>>>3&511)+1|0,Q)|0;f[k>>2]=qa;Q=((f[z>>2]|0)>>>0)/((1212424721>>>(Wa<<2&28)&15)>>>0)|0;Wa=f[Ka>>2]|0;Ya=Wa+((Y(Q,ea+-1|0)|0)<<1)|0;ra=(qa|0)>0;if((ea|0)<=2){if(ra)Qc=0;else break;while(1){d[Ya+(Qc<<1)>>1]=0;d[Wa+(Qc<<1)>>1]=0;Qc=Qc+1|0;if((Qc|0)==(qa|0))break d}}if(ra){ea=Wa+(Q<<1)|0;da=Ya+(0-Q<<1)|0;Xa=0;do{d[Wa+(Xa<<1)>>1]=d[ea+(Xa<<1)>>1]|0;d[Ya+(Xa<<1)>>1]=d[da+(Xa<<1)>>1]|0;Xa=Xa+1|0}while((Xa|0)!=(qa|0))}}else{f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;gL(q,l)|0}while(0);break}default:{f[k>>2]=0;f[k+4>>2]=0;x=c$(k,43)|0;J=221492;y=x+43|0;do{b[x>>0]=b[J>>0]|0;x=x+1|0;J=J+1|0}while((x|0)<(y|0));j$(-206,k,221163,221175,1694);d$(k)}}while(0);k=q+36|0;J=f[k>>2]|0;if(J|0?(x=J+12|0,J=f[x>>2]|0,f[x>>2]=J+-1,(J|0)==1):0)CR(q);f[k>>2]=0;k=q+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[a>>2]|0)>0){k=f[w>>2]|0;w=0;do{f[k+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[a>>2]|0))}a=f[C>>2]|0;if((a|0)!=(z|0))ZF(a);a=p+36|0;z=f[a>>2]|0;if(z|0?(C=z+12|0,z=f[C>>2]|0,f[C>>2]=z+-1,(z|0)==1):0)CR(p);f[a>>2]=0;a=p+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[a>>2]|0)>0){K=f[E>>2]|0;E=0;do{f[K+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[a>>2]|0))}a=f[p+44>>2]|0;if((a|0)!=(p+48|0))ZF(a);if(!(f[o+4>>2]|0)){u=i;return}u=i;return}function C7(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;k=g&1;f[a>>2]=49380;g=a+4|0;f[g>>2]=f[c>>2];l=a+8|0;m=c+4|0;f[l>>2]=f[m>>2];n=a+12|0;f[n>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];o=f[c+36>>2]|0;f[a+40>>2]=o;f[a+44>>2]=n;n=a+52|0;p=a+48|0;f[p>>2]=n;f[n>>2]=0;f[a+56>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[c+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2]}else{f[l>>2]=0;BR(g,c)}c=a+60|0;f[c>>2]=f[d>>2];g=a+64|0;l=d+4|0;f[g>>2]=f[l>>2];m=a+68|0;f[m>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];n=f[d+36>>2]|0;f[a+96>>2]=n;f[a+100>>2]=m;m=a+108|0;p=a+104|0;f[p>>2]=m;f[m>>2]=0;f[a+112>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[d+44>>2]|0;m=f[p>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];q=a+116|0;f[q>>2]=e;r=a+120|0;b[r>>0]=k;s=a+124|0;t=f[h>>2]|0;f[s>>2]=t;u=a+128|0;v=h+4|0;w=f[v>>2]|0;f[u>>2]=w;x=a+132|0;f[x>>2]=i;y=a+136|0;f[y>>2]=j;return}else{f[g>>2]=0;BR(c,d);q=a+116|0;f[q>>2]=e;r=a+120|0;b[r>>0]=k;s=a+124|0;t=f[h>>2]|0;f[s>>2]=t;u=a+128|0;v=h+4|0;w=f[v>>2]|0;f[u>>2]=w;x=a+132|0;f[x>>2]=i;y=a+136|0;f[y>>2]=j;return}}function D7(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49380;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function E7(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;k=g&1;f[a>>2]=49360;g=a+4|0;f[g>>2]=f[c>>2];l=a+8|0;m=c+4|0;f[l>>2]=f[m>>2];n=a+12|0;f[n>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];o=f[c+36>>2]|0;f[a+40>>2]=o;f[a+44>>2]=n;n=a+52|0;p=a+48|0;f[p>>2]=n;f[n>>2]=0;f[a+56>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[c+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2]}else{f[l>>2]=0;BR(g,c)}c=a+60|0;f[c>>2]=f[d>>2];g=a+64|0;l=d+4|0;f[g>>2]=f[l>>2];m=a+68|0;f[m>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];n=f[d+36>>2]|0;f[a+96>>2]=n;f[a+100>>2]=m;m=a+108|0;p=a+104|0;f[p>>2]=m;f[m>>2]=0;f[a+112>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[d+44>>2]|0;m=f[p>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];q=a+116|0;f[q>>2]=e;r=a+120|0;b[r>>0]=k;s=a+124|0;t=f[h>>2]|0;f[s>>2]=t;u=a+128|0;v=h+4|0;w=f[v>>2]|0;f[u>>2]=w;x=a+132|0;f[x>>2]=i;y=a+136|0;f[y>>2]=j;return}else{f[g>>2]=0;BR(c,d);q=a+116|0;f[q>>2]=e;r=a+120|0;b[r>>0]=k;s=a+124|0;t=f[h>>2]|0;f[s>>2]=t;u=a+128|0;v=h+4|0;w=f[v>>2]|0;f[u>>2]=w;x=a+132|0;f[x>>2]=i;y=a+136|0;f[y>>2]=j;return}}function F7(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49360;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function G7(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+160|0;g=e+144|0;h=e+136|0;i=e;j=f[c+48>>2]|0;k=f[a+40>>2]|0;l=f[k+4>>2]|0;m=f[k>>2]|0;k=g+4|0;n=((f[c>>2]|0)>>>3&511)+1|0;o=m+-2|0;f[k>>2]=o;f[g>>2]=l+-2;if((m|0)>2){f[h>>2]=0;f[h+4>>2]=o;T7(i,a,c,((d|0)==47|(d|0)==49)&1,(d|1|0)==47?-1:1,g);d=f[c+4>>2]|0;if((d|0)<3)p=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{a=f[c+40>>2]|0;o=0;m=1;while(1){l=Y(f[a+(o<<2)>>2]|0,m)|0;o=o+1|0;if((o|0)==(d|0)){p=l;break}else m=l}}_U(h,i,+(p>>>0)*.0000152587890625);U7(i)}i=f[c+40>>2]|0;p=f[i+4>>2]|0;h=f[i>>2]|0;f[g>>2]=p;f[k>>2]=h;i=f[c+16>>2]|0;c=(Y(p,n)|0)>0;if((h|0)>2){if(c)q=0;else{u=e;return}do{b[i+q>>0]=b[i+(q+j)>>0]|0;p=f[k>>2]|0;m=i+((Y(p+-2|0,j)|0)+q)|0;d=i+((Y(p+-1|0,j)|0)+q)|0;b[d>>0]=b[m>>0]|0;q=q+1|0}while((q|0)<(Y(f[g>>2]|0,n)|0));u=e;return}if(!c){u=e;return}c=i+(Y(h+-1|0,j)|0)|0;b[c>>0]=0;b[i>>0]=0;if((Y(f[g>>2]|0,n)|0)>1)r=1;else{u=e;return}do{c=i+((Y((f[k>>2]|0)+-1|0,j)|0)+r)|0;b[c>>0]=0;b[i+r>>0]=0;r=r+1|0}while((r|0)<(Y(f[g>>2]|0,n)|0));u=e;return}function H7(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f[a>>2]=49320;h=a+4|0;f[h>>2]=f[b>>2];i=a+8|0;j=b+4|0;f[i>>2]=f[j>>2];k=a+12|0;f[k>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];l=f[b+36>>2]|0;f[a+40>>2]=l;f[a+44>>2]=k;k=a+52|0;m=a+48|0;f[m>>2]=k;f[k>>2]=0;f[a+56>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[b+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[i>>2]=0;BR(h,b)}b=a+60|0;f[b>>2]=f[c>>2];h=a+64|0;i=c+4|0;f[h>>2]=f[i>>2];j=a+68|0;f[j>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];k=f[c+36>>2]|0;f[a+96>>2]=k;f[a+100>>2]=j;j=a+108|0;m=a+104|0;f[m>>2]=j;f[j>>2]=0;f[a+112>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[c+44>>2]|0;j=f[m>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];n=a+116|0;f[n>>2]=d;o=a+120|0;f[o>>2]=e;p=a+124|0;q=f[g>>2]|0;f[p>>2]=q;r=a+128|0;s=g+4|0;t=f[s>>2]|0;f[r>>2]=t;return}else{f[h>>2]=0;BR(b,c);n=a+116|0;f[n>>2]=d;o=a+120|0;f[o>>2]=e;p=a+124|0;q=f[g>>2]|0;f[p>>2]=q;r=a+128|0;s=g+4|0;t=f[s>>2]|0;f[r>>2]=t;return}}function I7(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49320;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function J7(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f[a>>2]=49300;h=a+4|0;f[h>>2]=f[b>>2];i=a+8|0;j=b+4|0;f[i>>2]=f[j>>2];k=a+12|0;f[k>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];l=f[b+36>>2]|0;f[a+40>>2]=l;f[a+44>>2]=k;k=a+52|0;m=a+48|0;f[m>>2]=k;f[k>>2]=0;f[a+56>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[b+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[i>>2]=0;BR(h,b)}b=a+60|0;f[b>>2]=f[c>>2];h=a+64|0;i=c+4|0;f[h>>2]=f[i>>2];j=a+68|0;f[j>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];k=f[c+36>>2]|0;f[a+96>>2]=k;f[a+100>>2]=j;j=a+108|0;m=a+104|0;f[m>>2]=j;f[j>>2]=0;f[a+112>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[c+44>>2]|0;j=f[m>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];n=a+116|0;o=f[d>>2]|0;f[n>>2]=o;p=a+120|0;q=d+4|0;r=f[q>>2]|0;f[p>>2]=r;s=a+124|0;f[s>>2]=e;t=a+128|0;f[t>>2]=g;return}else{f[h>>2]=0;BR(b,c);n=a+116|0;o=f[d>>2]|0;f[n>>2]=o;p=a+120|0;q=d+4|0;r=f[q>>2]|0;f[p>>2]=r;s=a+124|0;f[s>>2]=e;t=a+128|0;f[t>>2]=g;return}}function K7(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49300;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function L7(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f[a>>2]=49280;h=a+4|0;f[h>>2]=f[b>>2];i=a+8|0;j=b+4|0;f[i>>2]=f[j>>2];k=a+12|0;f[k>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];l=f[b+36>>2]|0;f[a+40>>2]=l;f[a+44>>2]=k;k=a+52|0;m=a+48|0;f[m>>2]=k;f[k>>2]=0;f[a+56>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[b+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[i>>2]=0;BR(h,b)}b=a+60|0;f[b>>2]=f[c>>2];h=a+64|0;i=c+4|0;f[h>>2]=f[i>>2];j=a+68|0;f[j>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];k=f[c+36>>2]|0;f[a+96>>2]=k;f[a+100>>2]=j;j=a+108|0;m=a+104|0;f[m>>2]=j;f[j>>2]=0;f[a+112>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[c+44>>2]|0;j=f[m>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];n=a+116|0;o=f[d>>2]|0;f[n>>2]=o;p=a+120|0;q=d+4|0;r=f[q>>2]|0;f[p>>2]=r;s=a+124|0;f[s>>2]=e;t=a+128|0;f[t>>2]=g;return}else{f[h>>2]=0;BR(b,c);n=a+116|0;o=f[d>>2]|0;f[n>>2]=o;p=a+120|0;q=d+4|0;r=f[q>>2]|0;f[p>>2]=r;s=a+124|0;f[s>>2]=e;t=a+128|0;f[t>>2]=g;return}}function M7(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49280;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function N7(a){a=a|0;M7(a);PYa(a);return}function O7(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=f[a+60>>2]|0;e=(c>>>3&511)+1|0;g=e<<1;h=((f[a+52>>2]|0)>>>0)/((1212424721>>>(f[a+4>>2]<<2&28)&15)>>>0)|0;i=f[a+108>>2]|0;k=(i>>>0)/((1212424721>>>(c<<2&28)&15)>>>0)|0;c=f[b>>2]|0;l=c+1|0;m=f[b+4>>2]|0;if((c|0)>=(m|0))return;b=c&1;n=(f[a+76>>2]|0)+(Y(l,i)|0)+(e<<1)|0;i=0-h|0;o=a+116|0;p=g-k|0;q=e-k|0;k=~h;r=1-h|0;s=h+-1|0;t=h+1|0;u=n;n=(f[a+20>>2]|0)+(Y(f[f[a+48>>2]>>2]|0,l)|0)+2|0;l=b^f[a+124>>2];v=b^f[a+128>>2];a=c;while(1){if(!v){w=u;x=n;y=1}else{c=l<<1;d[u+(c<<1)>>1]=((j[n+(h<<1)>>1]|0)+(j[n+(i<<1)>>1]|0)|0)>>>1;d[u+2>>1]=d[n>>1]|0;b=n+2|0;d[u+(2-c<<1)>>1]=((j[b>>1]|0)+(j[n+-2>>1]|0)|0)>>>1;w=u+(e<<1)|0;x=b;y=2}b=f[o>>2]|0;c=(y|0)<(b|0);if(!l)if(c){z=w;A=x;B=y;while(1){C=A+(r<<1)|0;D=A+(t<<1)|0;d[z>>1]=((j[A+(k<<1)>>1]|0)+2+(j[C>>1]|0)+(j[A+(s<<1)>>1]|0)+(j[D>>1]|0)|0)>>>2;E=j[A+-2>>1]|0;F=A+2|0;G=d[F>>1]|0;H=E-(G&65535)|0;I=j[A+(h<<1)>>1]|0;J=d[A+(i<<1)>>1]|0;K=I-(J&65535)|0;L=(((H|0)>-1?H:0-H|0)|0)>(((K|0)>-1?K:0-K|0)|0);d[z+2>>1]=((L?I:E)+1+((L?J:G)&65535)|0)>>>1;d[z+4>>1]=d[A>>1]|0;d[z+6>>1]=((j[C>>1]|0)+1+(j[D>>1]|0)|0)>>>1;d[z+8>>1]=d[F>>1]|0;F=A+4|0;d[z+10>>1]=((j[A>>1]|0)+1+(j[F>>1]|0)|0)>>>1;D=B+2|0;C=z+(g<<1)|0;if((D|0)<(b|0)){z=C;A=F;B=D}else{M=C;N=F;O=D;break}}}else{M=w;N=x;O=y}else if(c){B=w;A=x;z=y;while(1){d[B>>1]=d[A>>1]|0;D=j[A+-2>>1]|0;F=A+2|0;C=d[F>>1]|0;G=D-(C&65535)|0;J=j[A+(h<<1)>>1]|0;L=d[A+(i<<1)>>1]|0;E=J-(L&65535)|0;I=(((G|0)>-1?G:0-G|0)|0)>(((E|0)>-1?E:0-E|0)|0);d[B+2>>1]=((I?J:D)+1+((I?L:C)&65535)|0)>>>1;C=A+(r<<1)|0;L=A+(t<<1)|0;d[B+4>>1]=((j[C>>1]|0)+(j[A+(k<<1)>>1]|0)+(j[A+(s<<1)>>1]|0)+(j[L>>1]|0)|0)>>>2;I=A+4|0;d[B+6>>1]=((j[A>>1]|0)+1+(j[I>>1]|0)|0)>>>1;d[B+8>>1]=d[F>>1]|0;d[B+10>>1]=((j[C>>1]|0)+1+(j[L>>1]|0)|0)>>>1;L=z+2|0;C=B+(g<<1)|0;if((L|0)<(b|0)){B=C;A=I;z=L}else{M=C;N=I;O=L;break}}}else{M=w;N=x;O=y}if((O|0)>(b|0)){P=M;Q=N}else{z=l<<1;d[M+(z<<1)>>1]=((j[N+(k<<1)>>1]|0)+2+(j[N+(r<<1)>>1]|0)+(j[N+(s<<1)>>1]|0)+(j[N+(t<<1)>>1]|0)|0)>>>2;A=j[N+-2>>1]|0;B=N+2|0;c=d[B>>1]|0;L=A-(c&65535)|0;I=j[N+(h<<1)>>1]|0;C=d[N+(i<<1)>>1]|0;F=I-(C&65535)|0;D=(((L|0)>-1?L:0-L|0)|0)>(((F|0)>-1?F:0-F|0)|0);d[M+2>>1]=((D?I:A)+1+((D?C:c)&65535)|0)>>>1;d[M+(2-z<<1)>>1]=d[N>>1]|0;P=M+(e<<1)|0;Q=B}B=0;do{d[P+(B<<1)>>1]=d[P+(B-e<<1)>>1]|0;d[P+(q+B<<1)>>1]=d[P+(p+B<<1)>>1]|0;B=B+1|0}while((B|0)!=(e|0));a=a+1|0;if((a|0)>=(m|0))break;else{u=P+(g<<1)|0;n=Q+4|0;l=l^1;v=v^1}}return}function P7(a){a=a|0;K7(a);PYa(a);return}function Q7(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=f[a+60>>2]|0;e=(d>>>3&511)+1|0;g=e<<1;i=((f[a+52>>2]|0)>>>0)/((1212424721>>>(f[a+4>>2]<<2&28)&15)>>>0)|0;j=f[a+108>>2]|0;k=(j>>>0)/((1212424721>>>(d<<2&28)&15)>>>0)|0;d=f[c>>2]|0;l=d+1|0;m=c+4|0;if((d|0)>=(f[m>>2]|0))return;c=d&1;n=(f[a+76>>2]|0)+(Y(l,j)|0)+e|0;j=0-i|0;o=a+116|0;p=g-k|0;q=e-k|0;k=~i;r=1-i|0;s=i+-1|0;t=i+1|0;u=n;n=(f[a+20>>2]|0)+(Y(f[f[a+48>>2]>>2]|0,l)|0)+1|0;l=c^f[a+124>>2];v=c^f[a+128>>2];a=d;while(1){if(!v){w=u;x=n;y=1}else{d=l<<1;b[u+d>>0]=((h[n+i>>0]|0)+(h[n+j>>0]|0)|0)>>>1;b[u+1>>0]=b[n>>0]|0;c=n+1|0;b[u+(2-d)>>0]=((h[c>>0]|0)+(h[n+-1>>0]|0)|0)>>>1;w=u+e|0;x=c;y=2}c=f[o>>2]|0;d=(y|0)<(c|0);if(!l)if(d){z=w;A=x;B=y;while(1){C=A+r|0;D=A+t|0;b[z>>0]=((h[A+k>>0]|0)+2+(h[C>>0]|0)+(h[A+s>>0]|0)+(h[D>>0]|0)|0)>>>2;E=h[A+-1>>0]|0;F=A+1|0;G=b[F>>0]|0;H=E-(G&255)|0;I=h[A+i>>0]|0;J=b[A+j>>0]|0;K=I-(J&255)|0;L=(((H|0)>-1?H:0-H|0)|0)>(((K|0)>-1?K:0-K|0)|0);b[z+1>>0]=((L?I:E)+1+((L?J:G)&255)|0)>>>1;b[z+2>>0]=b[A>>0]|0;b[z+3>>0]=((h[C>>0]|0)+1+(h[D>>0]|0)|0)>>>1;b[z+4>>0]=b[F>>0]|0;F=A+2|0;b[z+5>>0]=((h[A>>0]|0)+1+(h[F>>0]|0)|0)>>>1;D=B+2|0;C=z+g|0;G=f[o>>2]|0;if((D|0)<(G|0)){z=C;A=F;B=D}else{M=G;N=C;O=F;P=D;break}}}else{M=c;N=w;O=x;P=y}else if(d){B=w;A=x;z=y;while(1){b[B>>0]=b[A>>0]|0;D=h[A+-1>>0]|0;F=A+1|0;C=b[F>>0]|0;G=D-(C&255)|0;J=h[A+i>>0]|0;L=b[A+j>>0]|0;E=J-(L&255)|0;I=(((G|0)>-1?G:0-G|0)|0)>(((E|0)>-1?E:0-E|0)|0);b[B+1>>0]=((I?J:D)+1+((I?L:C)&255)|0)>>>1;C=A+r|0;L=A+t|0;b[B+2>>0]=((h[C>>0]|0)+(h[A+k>>0]|0)+(h[A+s>>0]|0)+(h[L>>0]|0)|0)>>>2;I=A+2|0;b[B+3>>0]=((h[A>>0]|0)+1+(h[I>>0]|0)|0)>>>1;b[B+4>>0]=b[F>>0]|0;b[B+5>>0]=((h[C>>0]|0)+1+(h[L>>0]|0)|0)>>>1;L=z+2|0;C=B+g|0;F=f[o>>2]|0;if((L|0)<(F|0)){B=C;A=I;z=L}else{M=F;N=C;O=I;P=L;break}}}else{M=c;N=w;O=x;P=y}if((P|0)>(M|0)){Q=N;R=O}else{z=l<<1;b[N+z>>0]=((h[O+k>>0]|0)+2+(h[O+r>>0]|0)+(h[O+s>>0]|0)+(h[O+t>>0]|0)|0)>>>2;A=h[O+-1>>0]|0;B=O+1|0;d=b[B>>0]|0;L=A-(d&255)|0;I=h[O+i>>0]|0;C=b[O+j>>0]|0;F=I-(C&255)|0;D=(((L|0)>-1?L:0-L|0)|0)>(((F|0)>-1?F:0-F|0)|0);b[N+1>>0]=((D?I:A)+1+((D?C:d)&255)|0)>>>1;b[N+(2-z)>>0]=b[O>>0]|0;Q=N+e|0;R=B}B=0;do{b[Q+B>>0]=b[Q+(B-e)>>0]|0;b[Q+(q+B)>>0]=b[Q+(p+B)>>0]|0;B=B+1|0}while((B|0)!=(e|0));a=a+1|0;if((a|0)>=(f[m>>2]|0))break;else{u=Q+g|0;n=R+2|0;l=l^1;v=v^1}}return}function R7(a){a=a|0;I7(a);PYa(a);return}function S7(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;c=((f[a+60>>2]|0)>>>3&511)+1|0;e=c<<1;g=f[a+52>>2]|0;h=g>>>1;i=f[b>>2]|0;k=(f[a+108>>2]|0)>>>1;l=f[a+120>>2]|0;m=f[a+116>>2]|0;n=(i&1|0)==0;o=f[b+4>>2]|0;if((i|0)>=(o|0))return;b=(f[a+76>>2]|0)+((Y(k,i+1|0)|0)<<1)+(c<<1)+2|0;p=(f[a+20>>2]|0)+((Y(i,h)|0)<<1)|0;q=a+124|0;a=f[q>>2]|0;r=(a|0)<1;s=(c|0)==3;t=Y(a,c)|0;u=t+1|0;v=t+-1|0;w=t+2|0;x=g|1;g=h+2|0;y=h+1|0;z=(c|0)==4;A=h<<1;B=A+2|0;C=A|1;D=h+3|0;E=p;p=n?l:0-l|0;l=b;b=i;i=n?m:(m|0)==0&1;while(1){m=E+(a<<1)|0;if(r){d[l+(u<<1)>>1]=0;d[l+(t<<1)>>1]=0;d[l+(v<<1)>>1]=0;if(s){F=-4;G=-2;H=-3;I=0}else{d[l+-6>>1]=0;d[l+-8>>1]=0;F=-2;G=-5;H=w;I=-1}d[l+(G<<1)>>1]=0;d[l+(H<<1)>>1]=I;d[l+(F<<1)>>1]=I;J=p;K=i}else{n=(i|0)!=0;if(n){L=E+2|0;M=((j[E+(h<<1)>>1]|0)+1+(j[E+(g<<1)>>1]|0)|0)>>>1;d[l+(0-p<<1)>>1]=((j[L>>1]|0)+1+(j[E+(x<<1)>>1]|0)|0)>>>1;d[l>>1]=d[E+(y<<1)>>1]|0;d[l+(p<<1)>>1]=M;if(z)d[l+4>>1]=-1;N=L;O=l+(c<<1)|0}else{N=E;O=l}L=(p|0)>0;M=m+-4|0;P=N>>>0>M>>>0;do if(s)if(L){if(P){Q=N;R=O;break}else{S=N;T=O}while(1){U=S+4|0;V=S+(B<<1)|0;W=S+(g<<1)|0;X=((j[S+2>>1]|0)+2+(j[S+(h<<1)>>1]|0)+(j[W>>1]|0)+(j[S+(C<<1)>>1]|0)|0)>>>2;d[T+-2>>1]=((j[S>>1]|0)+2+(j[U>>1]|0)+(j[S+(A<<1)>>1]|0)+(j[V>>1]|0)|0)>>>2;d[T>>1]=X;X=S+(y<<1)|0;d[T+2>>1]=d[X>>1]|0;Z=((j[X>>1]|0)+1+(j[S+(D<<1)>>1]|0)|0)>>>1;d[T+4>>1]=((j[U>>1]|0)+1+(j[V>>1]|0)|0)>>>1;d[T+6>>1]=d[W>>1]|0;d[T+8>>1]=Z;Z=T+(e<<1)|0;if(U>>>0>M>>>0){Q=U;R=Z;break}else{S=U;T=Z}}}else{if(P){Q=N;R=O;break}else{_=N;$=O}while(1){Z=_+4|0;U=_+(B<<1)|0;W=_+(g<<1)|0;V=((j[_+2>>1]|0)+2+(j[_+(h<<1)>>1]|0)+(j[W>>1]|0)+(j[_+(C<<1)>>1]|0)|0)>>>2;d[$+2>>1]=((j[_>>1]|0)+2+(j[Z>>1]|0)+(j[_+(A<<1)>>1]|0)+(j[U>>1]|0)|0)>>>2;d[$>>1]=V;V=_+(y<<1)|0;d[$+-2>>1]=d[V>>1]|0;X=((j[V>>1]|0)+1+(j[_+(D<<1)>>1]|0)|0)>>>1;d[$+8>>1]=((j[Z>>1]|0)+1+(j[U>>1]|0)|0)>>>1;d[$+6>>1]=d[W>>1]|0;d[$+4>>1]=X;X=$+(e<<1)|0;if(Z>>>0>M>>>0){Q=Z;R=X;break}else{_=Z;$=X}}}else if(L){if(P){Q=N;R=O;break}else{aa=N;ba=O}while(1){X=aa+4|0;Z=aa+(B<<1)|0;W=aa+(g<<1)|0;U=((j[aa+2>>1]|0)+2+(j[aa+(h<<1)>>1]|0)+(j[W>>1]|0)+(j[aa+(C<<1)>>1]|0)|0)>>>2;d[ba+-2>>1]=((j[aa>>1]|0)+2+(j[X>>1]|0)+(j[aa+(A<<1)>>1]|0)+(j[Z>>1]|0)|0)>>>2;d[ba>>1]=U;U=aa+(y<<1)|0;d[ba+2>>1]=d[U>>1]|0;d[ba+4>>1]=-1;V=((j[U>>1]|0)+1+(j[aa+(D<<1)>>1]|0)|0)>>>1;d[ba+6>>1]=((j[X>>1]|0)+1+(j[Z>>1]|0)|0)>>>1;d[ba+8>>1]=d[W>>1]|0;d[ba+10>>1]=V;d[ba+12>>1]=-1;V=ba+(e<<1)|0;if(X>>>0>M>>>0){Q=X;R=V;break}else{aa=X;ba=V}}}else{if(P){Q=N;R=O;break}else{ca=N;da=O}while(1){V=ca+4|0;X=ca+(B<<1)|0;W=((j[ca>>1]|0)+2+(j[V>>1]|0)+(j[ca+(A<<1)>>1]|0)+(j[X>>1]|0)|0)>>>2;Z=ca+(g<<1)|0;U=((j[ca+2>>1]|0)+2+(j[ca+(h<<1)>>1]|0)+(j[Z>>1]|0)+(j[ca+(C<<1)>>1]|0)|0)>>>2;ea=ca+(y<<1)|0;d[da+-2>>1]=d[ea>>1]|0;d[da>>1]=U;d[da+2>>1]=W;d[da+4>>1]=-1;W=((j[V>>1]|0)+1+(j[X>>1]|0)|0)>>>1;d[da+6>>1]=((j[ea>>1]|0)+1+(j[ca+(D<<1)>>1]|0)|0)>>>1;d[da+8>>1]=d[Z>>1]|0;d[da+10>>1]=W;d[da+12>>1]=-1;W=da+(e<<1)|0;if(V>>>0>M>>>0){Q=V;R=W;break}else{ca=V;da=W}}}while(0);if(Q>>>0<m>>>0?(M=((j[Q+2>>1]|0)+2+(j[Q+(h<<1)>>1]|0)+(j[Q+(g<<1)>>1]|0)+(j[Q+(C<<1)>>1]|0)|0)>>>2,d[R+(0-p<<1)>>1]=((j[Q>>1]|0)+2+(j[Q+4>>1]|0)+(j[Q+(A<<1)>>1]|0)+(j[Q+(B<<1)>>1]|0)|0)>>>2,d[R>>1]=M,d[R+(p<<1)>>1]=d[Q+(y<<1)>>1]|0,z):0)d[R+4>>1]=-1;M=d[l+-2>>1]|0;P=d[l+2>>1]|0;L=d[l>>1]|0;W=Y(f[q>>2]|0,c)|0;V=W+-4|0;if(s){d[l+-8>>1]=M;d[l+-6>>1]=L;d[l+-4>>1]=P;fa=1;ga=d[l+(V<<1)>>1]|0;ha=W}else{d[l+-10>>1]=M;d[l+-8>>1]=L;d[l+-6>>1]=P;d[l+-4>>1]=d[l+4>>1]|0;P=d[l+(W+-5<<1)>>1]|0;d[l+(W<<1)>>1]=d[l+(V<<1)>>1]|0;fa=2;ga=P;ha=W+1|0}d[l+(W+-1<<1)>>1]=ga;d[l+(ha<<1)>>1]=d[l+(W+-3<<1)>>1]|0;d[l+(fa+W<<1)>>1]=d[l+(W+-2<<1)>>1]|0;J=0-p|0;K=(n^1)&1}b=b+1|0;if((b|0)>=(o|0))break;else{E=E+(h<<1)|0;p=J;l=l+(k<<1)|0;i=K}}return}function T7(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f[a>>2]=49340;h=a+4|0;f[h>>2]=f[b>>2];i=a+8|0;j=b+4|0;f[i>>2]=f[j>>2];k=a+12|0;f[k>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];l=f[b+36>>2]|0;f[a+40>>2]=l;f[a+44>>2]=k;k=a+52|0;m=a+48|0;f[m>>2]=k;f[k>>2]=0;f[a+56>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[b+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[i>>2]=0;BR(h,b)}b=a+60|0;f[b>>2]=f[c>>2];h=a+64|0;i=c+4|0;f[h>>2]=f[i>>2];j=a+68|0;f[j>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];k=f[c+36>>2]|0;f[a+96>>2]=k;f[a+100>>2]=j;j=a+108|0;m=a+104|0;f[m>>2]=j;f[j>>2]=0;f[a+112>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[c+44>>2]|0;j=f[m>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];n=a+116|0;f[n>>2]=d;o=a+120|0;f[o>>2]=e;p=a+124|0;q=f[g>>2]|0;f[p>>2]=q;r=a+128|0;s=g+4|0;t=f[s>>2]|0;f[r>>2]=t;return}else{f[h>>2]=0;BR(b,c);n=a+116|0;f[n>>2]=d;o=a+120|0;f[o>>2]=e;p=a+124|0;q=f[g>>2]|0;f[p>>2]=q;r=a+128|0;s=g+4|0;t=f[s>>2]|0;f[r>>2]=t;return}}function U7(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49340;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function V7(a){a=a|0;U7(a);PYa(a);return}function W7(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0;d=((f[a+60>>2]|0)>>>3&511)+1|0;e=d<<1;g=f[a+52>>2]|0;i=f[c>>2]|0;j=f[a+108>>2]|0;k=f[a+120>>2]|0;l=f[a+116>>2]|0;m=(i&1|0)==0;n=c+4|0;if((i|0)>=(f[n>>2]|0))return;c=(f[a+76>>2]|0)+(Y(i+1|0,j)|0)+d+1|0;o=a+124|0;p=(d|0)==3;q=g<<1;r=q|1;s=g+2|0;t=g+1|0;u=(d|0)==4;v=q+2|0;w=g+3|0;x=(f[a+20>>2]|0)+(Y(i,g)|0)|0;a=m?k:0-k|0;k=c;c=i;i=m?l:(l|0)==0&1;while(1){l=f[o>>2]|0;m=x+l|0;if((l|0)<1){y=k+((Y(l,d)|0)+1)|0;b[y>>0]=0;y=k+(Y(f[o>>2]|0,d)|0)|0;b[y>>0]=0;y=k+((Y(f[o>>2]|0,d)|0)+-1)|0;b[y>>0]=0;if(p){b[k+-2>>0]=0;z=-4;A=-3;B=0}else{b[k+-3>>0]=0;b[k+-4>>0]=0;b[k+-5>>0]=0;z=-2;A=(Y(f[o>>2]|0,d)|0)+2|0;B=-1}b[k+A>>0]=B;b[k+z>>0]=B;C=a;D=i}else{y=(i|0)!=0;if(y){l=x+1|0;E=((h[x+g>>0]|0)+1+(h[x+s>>0]|0)|0)>>>1;b[k+(0-a)>>0]=((h[l>>0]|0)+1+(h[x+r>>0]|0)|0)>>>1;b[k>>0]=b[x+t>>0]|0;b[k+a>>0]=E;if(u)b[k+2>>0]=-1;F=l;G=k+d|0}else{F=x;G=k}l=(a|0)>0;E=m+-2|0;H=F>>>0>E>>>0;do if(p)if(l){if(H){I=F;J=G;break}else{K=F;L=G}while(1){M=K+2|0;N=K+v|0;O=K+s|0;P=((h[K+1>>0]|0)+2+(h[K+g>>0]|0)+(h[O>>0]|0)+(h[K+r>>0]|0)|0)>>>2;b[L+-1>>0]=((h[K>>0]|0)+2+(h[M>>0]|0)+(h[K+q>>0]|0)+(h[N>>0]|0)|0)>>>2;b[L>>0]=P;P=K+t|0;b[L+1>>0]=b[P>>0]|0;Q=((h[P>>0]|0)+1+(h[K+w>>0]|0)|0)>>>1;b[L+2>>0]=((h[M>>0]|0)+1+(h[N>>0]|0)|0)>>>1;b[L+3>>0]=b[O>>0]|0;b[L+4>>0]=Q;Q=L+e|0;if(M>>>0>E>>>0){I=M;J=Q;break}else{K=M;L=Q}}}else{if(H){I=F;J=G;break}else{R=F;S=G}while(1){Q=R+2|0;M=R+v|0;O=R+s|0;N=((h[R+1>>0]|0)+2+(h[R+g>>0]|0)+(h[O>>0]|0)+(h[R+r>>0]|0)|0)>>>2;b[S+1>>0]=((h[R>>0]|0)+2+(h[Q>>0]|0)+(h[R+q>>0]|0)+(h[M>>0]|0)|0)>>>2;b[S>>0]=N;N=R+t|0;b[S+-1>>0]=b[N>>0]|0;P=((h[N>>0]|0)+1+(h[R+w>>0]|0)|0)>>>1;b[S+4>>0]=((h[Q>>0]|0)+1+(h[M>>0]|0)|0)>>>1;b[S+3>>0]=b[O>>0]|0;b[S+2>>0]=P;P=S+e|0;if(Q>>>0>E>>>0){I=Q;J=P;break}else{R=Q;S=P}}}else if(l){if(H){I=F;J=G;break}else{T=F;U=G}while(1){P=T+2|0;Q=T+v|0;O=T+s|0;M=((h[T+1>>0]|0)+2+(h[T+g>>0]|0)+(h[O>>0]|0)+(h[T+r>>0]|0)|0)>>>2;b[U+-1>>0]=((h[T>>0]|0)+2+(h[P>>0]|0)+(h[T+q>>0]|0)+(h[Q>>0]|0)|0)>>>2;b[U>>0]=M;M=T+t|0;b[U+1>>0]=b[M>>0]|0;b[U+2>>0]=-1;N=((h[M>>0]|0)+1+(h[T+w>>0]|0)|0)>>>1;b[U+3>>0]=((h[P>>0]|0)+1+(h[Q>>0]|0)|0)>>>1;b[U+4>>0]=b[O>>0]|0;b[U+5>>0]=N;b[U+6>>0]=-1;N=U+e|0;if(P>>>0>E>>>0){I=P;J=N;break}else{T=P;U=N}}}else{if(H){I=F;J=G;break}else{V=F;W=G}while(1){N=V+2|0;P=V+v|0;O=((h[V>>0]|0)+2+(h[N>>0]|0)+(h[V+q>>0]|0)+(h[P>>0]|0)|0)>>>2;Q=V+s|0;M=((h[V+1>>0]|0)+2+(h[V+g>>0]|0)+(h[Q>>0]|0)+(h[V+r>>0]|0)|0)>>>2;X=V+t|0;b[W+-1>>0]=b[X>>0]|0;b[W>>0]=M;b[W+1>>0]=O;b[W+2>>0]=-1;O=((h[N>>0]|0)+1+(h[P>>0]|0)|0)>>>1;b[W+3>>0]=((h[X>>0]|0)+1+(h[V+w>>0]|0)|0)>>>1;b[W+4>>0]=b[Q>>0]|0;b[W+5>>0]=O;b[W+6>>0]=-1;O=W+e|0;if(N>>>0>E>>>0){I=N;J=O;break}else{V=N;W=O}}}while(0);if(I>>>0<m>>>0?(E=((h[I+1>>0]|0)+2+(h[I+g>>0]|0)+(h[I+s>>0]|0)+(h[I+r>>0]|0)|0)>>>2,b[J+(0-a)>>0]=((h[I>>0]|0)+2+(h[I+2>>0]|0)+(h[I+q>>0]|0)+(h[I+v>>0]|0)|0)>>>2,b[J>>0]=E,b[J+a>>0]=b[I+t>>0]|0,u):0)b[J+2>>0]=-1;E=b[k+-1>>0]|0;H=b[k+1>>0]|0;l=b[k>>0]|0;if(p){b[k+-4>>0]=E;b[k+-3>>0]=l;b[k+-2>>0]=H;O=(f[o>>2]|0)*3|0;b[k+(O+-1)>>0]=b[k+(O+-4)>>0]|0;O=(f[o>>2]|0)*3|0;Z=1;_=O;$=O}else{b[k+-5>>0]=E;b[k+-4>>0]=l;b[k+-3>>0]=H;b[k+-2>>0]=b[k+2>>0]|0;H=Y(f[o>>2]|0,d)|0;b[k+(H+-1)>>0]=b[k+(H+-5)>>0]|0;H=Y(f[o>>2]|0,d)|0;b[k+H>>0]=b[k+(H+-4)>>0]|0;H=Y(f[o>>2]|0,d)|0;Z=2;_=H+1|0;$=H}b[k+_>>0]=b[k+($+-3)>>0]|0;H=Y(f[o>>2]|0,d)|0;b[k+(H+Z)>>0]=b[k+(H+-2)>>0]|0;C=0-a|0;D=(y^1)&1}c=c+1|0;if((c|0)>=(f[n>>2]|0))break;else{x=x+g|0;a=C;k=k+j|0;i=D}}return}function X7(a){a=a|0;F7(a);PYa(a);return}function Y7(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;c=f[a+52>>2]|0;e=c>>>1;g=(f[a+108>>2]|0)>>>1;h=f[a+132>>2]|0;i=f[a+136>>2]|0;k=f[a+116>>2]|0;l=f[b>>2]|0;m=(l&1|0)==0;n=f[b+4>>2]|0;if((l|0)>=(n|0))return;b=(f[a+76>>2]|0)+(g+1<<1)+((Y(l,g)|0)<<1)|0;o=(f[a+20>>2]|0)+((Y(l,e)|0)<<1)|0;p=f[a+124>>2]|0;a=(p|0)<1;q=c|1;c=e+2|0;r=e+1|0;s=e<<1;t=s+2|0;u=s|1;v=e+3|0;w=p+-1|0;x=o;o=m?h:i;y=b;b=l;l=m?i:h;h=m?k:(k|0)==0&1;while(1){k=x+(p<<1)|0;if(a){d[y+(p<<1)>>1]=0;d[y+-2>>1]=0;z=o;A=l;B=h}else{m=(h|0)!=0;if(m){i=x+2|0;C=Y((j[x+(q<<1)>>1]|0)+(j[i>>1]|0)|0,l)|0;D=Y((j[x+(c<<1)>>1]|0)+(j[x+(e<<1)>>1]|0)|0,o)|0;d[y>>1]=(C+16384+D+((j[x+(r<<1)>>1]|0)*19234|0)|0)>>>15;E=i;F=y+2|0}else{E=x;F=y}i=k+-4|0;if(E>>>0>i>>>0){G=E;H=F}else{D=o<<2;C=E;I=F;while(1){J=C+4|0;K=C+(t<<1)|0;L=Y((j[J>>1]|0)+(j[C>>1]|0)+(j[C+(s<<1)>>1]|0)+(j[K>>1]|0)|0,l)|0;M=C+(c<<1)|0;N=C+(r<<1)|0;O=(L+32768+(((j[C+(e<<1)>>1]|0)+(j[C+2>>1]|0)+(j[M>>1]|0)+(j[C+(u<<1)>>1]|0)|0)*9617|0)+(Y(D,j[N>>1]|0)|0)|0)>>>16&65535;d[I>>1]=O;O=Y((j[K>>1]|0)+(j[J>>1]|0)|0,l)|0;K=Y((j[C+(v<<1)>>1]|0)+(j[N>>1]|0)|0,o)|0;d[I+2>>1]=(O+16384+K+((j[M>>1]|0)*19234|0)|0)>>>15;M=I+4|0;if(J>>>0>i>>>0){G=J;H=M;break}else{C=J;I=M}}}if(G>>>0<k>>>0){I=Y((j[G+4>>1]|0)+(j[G>>1]|0)+(j[G+(s<<1)>>1]|0)+(j[G+(t<<1)>>1]|0)|0,l)|0;C=(I+32768+(((j[G+(e<<1)>>1]|0)+(j[G+2>>1]|0)+(j[G+(c<<1)>>1]|0)+(j[G+(u<<1)>>1]|0)|0)*9617|0)+(Y(o<<2,j[G+(r<<1)>>1]|0)|0)|0)>>>16&65535;d[H>>1]=C}d[y+-2>>1]=d[y>>1]|0;d[y+(p<<1)>>1]=d[y+(w<<1)>>1]|0;z=l;A=o;B=(m^1)&1}b=b+1|0;if((b|0)>=(n|0))break;else{x=x+(e<<1)|0;o=z;y=y+(g<<1)|0;l=A;h=B}}return}function Z7(a){a=a|0;D7(a);PYa(a);return}function _7(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=f[a+52>>2]|0;e=f[a+108>>2]|0;g=f[a+132>>2]|0;i=f[a+136>>2]|0;j=f[a+116>>2]|0;k=f[c>>2]|0;l=(k&1|0)==0;m=c+4|0;if((k|0)>=(f[m>>2]|0))return;c=(f[a+76>>2]|0)+(e+1)+(Y(k,e)|0)|0;n=(f[a+20>>2]|0)+(Y(k,d)|0)|0;o=a+124|0;a=d<<1;p=a|1;q=d+2|0;r=d+1|0;s=a+2|0;t=d+3|0;u=n;n=l?g:i;v=c;c=k;k=l?i:g;g=l?j:(j|0)==0&1;while(1){j=f[o>>2]|0;l=u+j|0;if((j|0)<1){b[v+j>>0]=0;b[v+-1>>0]=0;w=n;x=k;y=g}else{j=(g|0)!=0;if(j){i=u+1|0;z=Y((h[u+p>>0]|0)+(h[i>>0]|0)|0,k)|0;A=Y((h[u+q>>0]|0)+(h[u+d>>0]|0)|0,n)|0;b[v>>0]=(z+16384+A+((h[u+r>>0]|0)*19234|0)|0)>>>15;B=i;C=v+1|0}else{B=u;C=v}i=l+-2|0;if(B>>>0>i>>>0){D=B;E=C}else{A=n<<2;z=B;F=C;while(1){G=z+2|0;H=z+s|0;I=Y((h[G>>0]|0)+(h[z>>0]|0)+(h[z+a>>0]|0)+(h[H>>0]|0)|0,k)|0;J=z+q|0;K=z+r|0;L=(I+32768+(((h[z+d>>0]|0)+(h[z+1>>0]|0)+(h[J>>0]|0)+(h[z+p>>0]|0)|0)*9617|0)+(Y(A,h[K>>0]|0)|0)|0)>>>16&255;b[F>>0]=L;L=Y((h[H>>0]|0)+(h[G>>0]|0)|0,k)|0;H=Y((h[z+t>>0]|0)+(h[K>>0]|0)|0,n)|0;b[F+1>>0]=(L+16384+H+((h[J>>0]|0)*19234|0)|0)>>>15;J=F+2|0;if(G>>>0>i>>>0){D=G;E=J;break}else{z=G;F=J}}}if(D>>>0<l>>>0){F=Y((h[D+2>>0]|0)+(h[D>>0]|0)+(h[D+a>>0]|0)+(h[D+s>>0]|0)|0,k)|0;z=(F+32768+(((h[D+d>>0]|0)+(h[D+1>>0]|0)+(h[D+q>>0]|0)+(h[D+p>>0]|0)|0)*9617|0)+(Y(n<<2,h[D+r>>0]|0)|0)|0)>>>16&255;b[E>>0]=z}b[v+-1>>0]=b[v>>0]|0;z=f[o>>2]|0;b[v+z>>0]=b[v+(z+-1)>>0]|0;w=k;x=n;y=(j^1)&1}c=c+1|0;if((c|0)>=(f[m>>2]|0))break;else{u=u+d|0;n=w;v=v+e|0;k=x;g=y}}return}function $7(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;i=u;u=u+208|0;j=i+144|0;k=i+88|0;l=i+72|0;m=i+16|0;n=i;if((h+-5|0)>>>0>=2){f[j>>2]=0;f[j+4>>2]=0;o=c$(j,24)|0;p=329923;q=o+24|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-215,j,222159,222012,60);d$(j)}pS(a,3,1,h,-1,1,0);pS(c,3,1,h,-1,1,0);do if((NS(a)|0)==65536){r=f[a+4>>2]|0;f[j>>2]=f[r>>2];s=j+4|0;t=r+4|0;f[s>>2]=f[t>>2];v=j+8|0;f[v>>2]=f[r+8>>2];f[j+12>>2]=f[r+12>>2];f[j+16>>2]=f[r+16>>2];f[j+20>>2]=f[r+20>>2];f[j+24>>2]=f[r+24>>2];f[j+28>>2]=f[r+28>>2];f[j+32>>2]=f[r+32>>2];w=f[r+36>>2]|0;f[j+36>>2]=w;f[j+40>>2]=v;v=j+48|0;x=j+44|0;f[x>>2]=v;f[v>>2]=0;f[j+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[r+44>>2]|0;v=f[x>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];break}else{f[s>>2]=0;BR(j,r);break}}else OR(j,a,-1);while(0);do if((NS(c)|0)==65536){a=f[c+4>>2]|0;f[k>>2]=f[a>>2];r=k+4|0;s=a+4|0;f[r>>2]=f[s>>2];t=k+8|0;f[t>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];v=f[a+36>>2]|0;f[k+36>>2]=v;f[k+40>>2]=t;t=k+48|0;x=k+44|0;f[x>>2]=t;f[t>>2]=0;f[k+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[a+44>>2]|0;t=f[x>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[r>>2]=0;BR(k,a);break}}else OR(k,c,-1);while(0);if(!((e|d|0)>-1&(e+d|0)==1)){f[l>>2]=0;f[l+4>>2]=0;o=c$(l,32)|0;p=222176;q=o+32|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));j$(-215,l,222159,222012,66);d$(l)}p=m+4|0;o=m+8|0;q=m+12|0;c=m+16|0;a=m+20|0;r=m+24|0;s=m+28|0;t=m+40|0;x=m+48|0;v=m+44|0;w=n+8|0;y=n+4|0;z=m+36|0;A=l+4|0;B=l+8|0;if(g){g=r+8|0;C=m+52|0;switch(d|0){case 0:{D=3;E=10;F=3;G=42;break}case 1:{D=1;E=0;F=-1;G=42;break}default:{}}if((G|0)==42){f[l>>2]=F;f[A>>2]=E;f[B>>2]=D}D=f[j+8>>2]|0;E=f[j+12>>2]|0;f[p>>2]=2;f[o>>2]=D;f[q>>2]=E;f[c>>2]=l;f[a>>2]=l;F=g;f[F>>2]=0;f[F+4>>2]=0;f[t>>2]=o;f[v>>2]=x;F=E<<2;f[m>>2]=1124024324;f[x>>2]=F;f[C>>2]=4;E=l+(Y(D,F)|0)|0;f[s>>2]=E;f[r>>2]=E+(0-F)+F;F=w;f[F>>2]=0;f[F+4>>2]=0;f[n>>2]=33619968;f[y>>2]=j;WJ(m,n,h,(d|0)==1?1.0:.03125,0.0);F=f[z>>2]|0;if(F|0?(E=F+12|0,F=f[E>>2]|0,f[E>>2]=F+-1,(F|0)==1):0)CR(m);f[z>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){F=f[t>>2]|0;E=0;do{f[F+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[p>>2]|0))}E=f[v>>2]|0;if((E|0)!=(x|0))ZF(E);switch(e|0){case 0:{H=3;I=10;J=3;G=73;break}case 1:{H=1;I=0;J=-1;G=73;break}default:{}}if((G|0)==73){f[l>>2]=J;f[A>>2]=I;f[B>>2]=H}H=f[k+8>>2]|0;I=f[k+12>>2]|0;f[p>>2]=2;f[o>>2]=H;f[q>>2]=I;f[c>>2]=l;f[a>>2]=l;J=g;f[J>>2]=0;f[J+4>>2]=0;f[t>>2]=o;f[v>>2]=x;J=I<<2;f[m>>2]=1124024324;f[x>>2]=J;f[C>>2]=4;C=l+(Y(H,J)|0)|0;f[s>>2]=C;f[r>>2]=C+(0-J)+J;J=w;f[J>>2]=0;f[J+4>>2]=0;f[n>>2]=33619968;f[y>>2]=k;WJ(m,n,h,(e|0)==1?1.0:.03125,0.0);J=f[z>>2]|0;if(J|0?(C=J+12|0,J=f[C>>2]|0,f[C>>2]=J+-1,(J|0)==1):0)CR(m);f[z>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){J=f[t>>2]|0;C=0;do{f[J+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[p>>2]|0))}C=f[v>>2]|0;if((C|0)!=(x|0))ZF(C)}else{switch(d|0){case 0:{K=3;L=10;M=3;G=23;break}case 1:{K=1;L=0;M=-1;G=23;break}default:{}}if((G|0)==23){f[l>>2]=M;f[A>>2]=L;f[B>>2]=K}K=f[j+8>>2]|0;L=f[j+12>>2]|0;f[p>>2]=2;f[o>>2]=K;f[q>>2]=L;f[c>>2]=l;f[a>>2]=l;M=r+8|0;f[M>>2]=0;f[M+4>>2]=0;f[t>>2]=o;f[v>>2]=x;M=L<<2;f[m>>2]=1124024324;f[x>>2]=M;L=m+52|0;f[L>>2]=4;d=l+(Y(K,M)|0)|0;f[s>>2]=d;f[r>>2]=d+(0-M)+M;M=w;f[M>>2]=0;f[M+4>>2]=0;f[n>>2]=33619968;f[y>>2]=j;WJ(m,n,h,1.0,0.0);M=f[z>>2]|0;if(M|0?(d=M+12|0,M=f[d>>2]|0,f[d>>2]=M+-1,(M|0)==1):0)CR(m);f[z>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){M=f[t>>2]|0;d=0;do{f[M+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[p>>2]|0))}d=f[v>>2]|0;if((d|0)!=(x|0))ZF(d);switch(e|0){case 0:{N=3;O=10;P=3;G=62;break}case 1:{N=1;O=0;P=-1;G=62;break}default:{}}if((G|0)==62){f[l>>2]=P;f[A>>2]=O;f[B>>2]=N}N=f[k+8>>2]|0;B=f[k+12>>2]|0;f[p>>2]=2;f[o>>2]=N;f[q>>2]=B;f[c>>2]=l;f[a>>2]=l;a=r+8|0;f[a>>2]=0;f[a+4>>2]=0;f[t>>2]=o;f[v>>2]=x;o=B<<2;f[m>>2]=1124024324;f[x>>2]=o;f[L>>2]=4;L=l+(Y(N,o)|0)|0;f[s>>2]=L;f[r>>2]=L+(0-o)+o;o=w;f[o>>2]=0;f[o+4>>2]=0;f[n>>2]=33619968;f[y>>2]=k;WJ(m,n,h,1.0,0.0);h=f[z>>2]|0;if(h|0?(n=h+12|0,h=f[n>>2]|0,f[n>>2]=h+-1,(h|0)==1):0)CR(m);f[z>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){c=f[t>>2]|0;t=0;do{f[c+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[p>>2]|0))}p=f[v>>2]|0;if((p|0)!=(x|0))ZF(p)}p=k+36|0;x=f[p>>2]|0;if(x|0?(v=x+12|0,x=f[v>>2]|0,f[v>>2]=x+-1,(x|0)==1):0)CR(k);f[p>>2]=0;p=k+16|0;x=k+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[x>>2]|0)>0){p=f[k+40>>2]|0;v=0;do{f[p+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[x>>2]|0))}x=f[k+44>>2]|0;if((x|0)!=(k+48|0))ZF(x);x=j+36|0;k=f[x>>2]|0;if(k|0?(v=k+12|0,k=f[v>>2]|0,f[v>>2]=k+-1,(k|0)==1):0)CR(j);f[x>>2]=0;x=j+16|0;k=j+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[k>>2]|0)>0){x=f[j+40>>2]|0;v=0;do{f[x+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)==(j+48|0)){u=i;return}ZF(k);u=i;return}function a8(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0;j=u;u=u+208|0;k=j+184|0;l=j+128|0;m=j+72|0;n=j+56|0;o=j;p=(g|0)==1;q=(d|0)>0&p?3:g;r=(e|0)>0&p?3:g;if((i+-5|0)>>>0>=2){f[k>>2]=0;f[k+4>>2]=0;s=c$(k,24)|0;t=329923;v=s+24|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,k,221996,222012,95);d$(k)}pS(a,q,1,i,-1,1,0);pS(c,r,1,i,-1,1,0);do if((NS(a)|0)==65536){p=f[a+4>>2]|0;f[l>>2]=f[p>>2];w=l+4|0;x=p+4|0;f[w>>2]=f[x>>2];y=l+8|0;f[y>>2]=f[p+8>>2];f[l+12>>2]=f[p+12>>2];f[l+16>>2]=f[p+16>>2];f[l+20>>2]=f[p+20>>2];f[l+24>>2]=f[p+24>>2];f[l+28>>2]=f[p+28>>2];f[l+32>>2]=f[p+32>>2];z=f[p+36>>2]|0;f[l+36>>2]=z;f[l+40>>2]=y;y=l+48|0;A=l+44|0;f[A>>2]=y;f[y>>2]=0;f[l+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[p+44>>2]|0;y=f[A>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[w>>2]=0;BR(l,p);break}}else OR(l,a,-1);while(0);do if((NS(c)|0)==65536){a=f[c+4>>2]|0;f[m>>2]=f[a>>2];p=m+4|0;w=a+4|0;f[p>>2]=f[w>>2];x=m+8|0;f[x>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];y=f[a+36>>2]|0;f[m+36>>2]=y;f[m+40>>2]=x;x=m+48|0;A=m+44|0;f[A>>2]=x;f[x>>2]=0;f[m+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[a+44>>2]|0;x=f[A>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[p>>2]=0;BR(m,a);break}}else OR(m,c,-1);while(0);if((g|0)>31|(g&1|0)==0){f[k>>2]=0;f[k+4>>2]=0;s=c$(k,50)|0;t=222062;v=s+50|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-211,k,221996,222012,103);d$(k)}g=((q|0)<(r|0)?r:q)+1|0;f[n>>2]=0;c=n+4|0;f[c>>2]=0;f[n+8>>2]=0;do if(g|0)if(g>>>0>1073741823)gXa(n);else{a=g<<2;p=NYa(a)|0;f[n>>2]=p;w=p+(g<<2)|0;f[n+8>>2]=w;F1a(p|0,0,a|0)|0;f[c>>2]=w;break}while(0);if(!((e|d|0)>-1&(e+d|0)>0)){f[k>>2]=0;f[k+4>>2]=0;s=c$(k,31)|0;t=222113;v=s+31|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,k,221996,222012,106);d$(k)}g=o+4|0;w=o+8|0;a=o+12|0;p=o+16|0;x=o+20|0;A=o+24|0;y=o+28|0;z=o+40|0;B=o+48|0;C=o+44|0;D=o+52|0;E=k+4|0;F=k+8|0;G=k+4|0;H=o+36|0;I=k+4|0;J=0;do{K=(J|0)==0;L=K?l:m;M=K?d:e;N=K?q:r;if((N|0)<=(M|0)){f[k>>2]=0;f[I>>2]=0;s=c$(k,13)|0;t=222145;v=s+13|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,k,221996,222012,114);d$(k)}switch(N|0){case 1:{K=f[n>>2]|0;O=0;P=K;Q=K;R=52;break}case 3:{do if(M){K=f[n>>2]|0;if((M|0)==1){f[K>>2]=-1;S=0;T=K;U=K;break}else{f[K>>2]=1;S=-2;T=K;U=K;break}}else{K=f[n>>2]|0;f[K>>2]=1;S=2;T=K;U=K}while(0);f[T+4>>2]=S;O=2;P=T;Q=U;R=52;break}default:{K=f[n>>2]|0;V=1;W=0;while(1){f[K+(W<<2)>>2]=V;if((W|0)<(N|0)){V=0;W=W+1|0}else break}W=N+~M|0;if((W|0)>0){V=f[n>>2]|0;if((N|0)<1)X=V;else{Z=0;do{_=f[V>>2]|0;$=_;aa=1;ba=_;while(1){_=$;$=f[V+(aa<<2)>>2]|0;f[V+(aa+-1<<2)>>2]=ba;ba=_+$|0;if((aa|0)==(N|0))break;else aa=aa+1|0}Z=Z+1|0}while((Z|0)!=(W|0));X=V}}else X=K;if((M|0)>0){V=f[n>>2]|0;if((N|0)<1)ca=V;else{W=0;do{Z=f[V>>2]|0;aa=Z;$=1;ba=0-Z|0;while(1){Z=aa;aa=f[V+($<<2)>>2]|0;f[V+($+-1<<2)>>2]=ba;ba=Z-aa|0;if(($|0)==(N|0))break;else $=$+1|0}W=W+1|0}while((W|0)!=(M|0));ca=V}}else ca=X}}if((R|0)==52){R=0;f[P+(O<<2)>>2]=1;ca=Q}V=f[L+8>>2]|0;W=f[L+12>>2]|0;f[o>>2]=1124007940;f[g>>2]=2;f[w>>2]=V;f[a>>2]=W;f[p>>2]=ca;f[x>>2]=ca;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;f[z>>2]=w;f[C>>2]=B;f[D>>2]=0;f[B>>2]=0;if((Y(W,V)|0)!=0&(ca|0)==0){f[k>>2]=0;f[E>>2]=0;s=c$(k,26)|0;t=358223;v=s+26|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));j$(-215,k,358250,358254,500);d$(k);da=f[a>>2]|0;ea=f[o>>2]|0;fa=f[C>>2]|0;ga=f[x>>2]|0}else{da=W;ea=1124007940;fa=B;ga=ca}V=da<<2;f[o>>2]=ea|16384;f[fa>>2]=V;f[fa+4>>2]=4;K=ga+(Y(f[w>>2]|0,V)|0)|0;f[y>>2]=K;f[A>>2]=K+(0-V)+V;if(h)ha=1.0/+(1<<N+~M|0);else ha=1.0;V=F;f[V>>2]=0;f[V+4>>2]=0;f[k>>2]=33619968;f[G>>2]=L;WJ(o,k,i,ha,0.0);V=f[H>>2]|0;if(V|0?(K=V+12|0,V=f[K>>2]|0,f[K>>2]=V+-1,(V|0)==1):0)CR(o);f[H>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[g>>2]|0)>0){V=f[z>>2]|0;K=0;do{f[V+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[g>>2]|0))}K=f[C>>2]|0;if((K|0)!=(B|0))ZF(K);J=J+1|0}while((J|0)<2);J=f[n>>2]|0;if(J|0){n=f[c>>2]|0;if((n|0)!=(J|0))f[c>>2]=n+(~((n+-4-J|0)>>>2)<<2);PYa(J)}J=m+36|0;n=f[J>>2]|0;if(n|0?(c=n+12|0,n=f[c>>2]|0,f[c>>2]=n+-1,(n|0)==1):0)CR(m);f[J>>2]=0;J=m+16|0;n=m+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[n>>2]|0)>0){J=f[m+40>>2]|0;c=0;do{f[J+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[n>>2]|0))}n=f[m+44>>2]|0;if((n|0)!=(m+48|0))ZF(n);n=l+36|0;m=f[n>>2]|0;if(m|0?(c=m+12|0,m=f[c>>2]|0,f[c>>2]=m+-1,(m|0)==1):0)CR(l);f[n>>2]=0;n=l+16|0;m=l+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[m>>2]|0)>0){n=f[l+40>>2]|0;c=0;do{f[n+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)==(l+48|0)){u=j;return}ZF(m);u=j;return}function b8(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;k=u;u=u+176|0;l=k+152|0;m=k+136|0;n=k+144|0;o=k+80|0;p=k+24|0;q=k;r=k+16|0;_$(m,49392);s=RR(a,-1)|0;t=s&7;v=(c|0)<0?t:c;QR(n,a,-1);KS(b,n,v&7|s&4088,-1,0,0);s=(v|0)<(t|0)?t:v;t=(s|0)>5?s:5;f[o>>2]=1124007936;s=o+4|0;n=o+8|0;c=o+40|0;w=s;x=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(x|0));f[c>>2]=n;n=o+48|0;y=o+44|0;f[y>>2]=n;f[n>>2]=0;f[o+52>>2]=0;f[p>>2]=1124007936;z=p+4|0;A=p+8|0;B=p+40|0;w=z;x=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(x|0));f[B>>2]=A;A=p+48|0;w=p+44|0;f[w>>2]=A;f[A>>2]=0;f[p+52>>2]=0;x=l+8|0;f[x>>2]=0;f[x+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=o;x=q+8|0;f[x>>2]=0;f[x+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=p;if((g|0)<1)$7(l,q,d,e,0,t);else a8(l,q,d,e,g,0,t);do if(h!=1.0)if(!d){t=l+8|0;f[t>>2]=0;f[t+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=o;WJ(o,l,-1,h,0.0);break}else{t=l+8|0;f[t>>2]=0;f[t+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=p;WJ(p,l,-1,h,0.0);break}while(0);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=o;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=p;f[r>>2]=-1;f[r+4>>2]=-1;ifa(a,b,v,l,q,r,i,j);j=p+36|0;r=f[j>>2]|0;if(r|0?(q=r+12|0,r=f[q>>2]|0,f[q>>2]=r+-1,(r|0)==1):0)CR(p);f[j>>2]=0;j=p+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[z>>2]|0)>0){j=f[B>>2]|0;B=0;do{f[j+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[z>>2]|0))}z=f[w>>2]|0;if((z|0)!=(A|0))ZF(z);z=o+36|0;A=f[z>>2]|0;if(A|0?(w=A+12|0,A=f[w>>2]|0,f[w>>2]=A+-1,(A|0)==1):0)CR(o);f[z>>2]=0;z=o+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[s>>2]|0)>0){z=f[c>>2]|0;c=0;do{f[z+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[s>>2]|0))}s=f[y>>2]|0;if((s|0)!=(n|0))ZF(s);if(!(f[m+4>>2]|0)){u=k;return}u=k;return}function c8(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;j=u;u=u+176|0;k=j+152|0;l=j+136|0;m=j+144|0;n=j+80|0;o=j+24|0;p=j;q=j+16|0;_$(l,49412);r=RR(a,-1)|0;s=r&7;t=(c|0)<0?s:c;QR(m,a,-1);KS(b,m,t&7|r&4088,-1,0,0);r=(t|0)<(s|0)?s:t;s=(r|0)>5?r:5;f[n>>2]=1124007936;r=n+4|0;m=n+8|0;c=n+40|0;v=r;w=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(w|0));f[c>>2]=m;m=n+48|0;x=n+44|0;f[x>>2]=m;f[m>>2]=0;f[n+52>>2]=0;f[o>>2]=1124007936;y=o+4|0;z=o+8|0;A=o+40|0;v=y;w=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(w|0));f[A>>2]=z;z=o+48|0;v=o+44|0;f[v>>2]=z;f[z>>2]=0;f[o+52>>2]=0;w=k+8|0;f[w>>2]=0;f[w+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=n;w=p+8|0;f[w>>2]=0;f[w+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=o;$7(k,p,d,e,0,s);do if(g!=1.0)if(!d){s=k+8|0;f[s>>2]=0;f[s+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=n;WJ(n,k,-1,g,0.0);break}else{s=k+8|0;f[s>>2]=0;f[s+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=o;WJ(o,k,-1,g,0.0);break}while(0);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=n;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=o;f[q>>2]=-1;f[q+4>>2]=-1;ifa(a,b,t,k,p,q,h,i);i=o+36|0;q=f[i>>2]|0;if(q|0?(p=q+12|0,q=f[p>>2]|0,f[p>>2]=q+-1,(q|0)==1):0)CR(o);f[i>>2]=0;i=o+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[y>>2]|0)>0){i=f[A>>2]|0;A=0;do{f[i+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[y>>2]|0))}y=f[v>>2]|0;if((y|0)!=(z|0))ZF(y);y=n+36|0;z=f[y>>2]|0;if(z|0?(v=z+12|0,z=f[v>>2]|0,f[v>>2]=z+-1,(z|0)==1):0)CR(n);f[y>>2]=0;y=n+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[r>>2]|0)>0){y=f[c>>2]|0;c=0;do{f[y+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[r>>2]|0))}r=f[x>>2]|0;if((r|0)!=(m|0))ZF(r);if(!(f[l+4>>2]|0)){u=j;return}u=j;return}function d8(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;i=u;u=u+624|0;j=i+600|0;k=i+528|0;l=i;m=i+520|0;n=i+496|0;o=i+512|0;p=i+504|0;q=i+432|0;r=i+376|0;s=i+312|0;t=i+256|0;v=i+248|0;w=i+240|0;x=i+232|0;y=i+488|0;z=i+224|0;A=i+368|0;B=i+168|0;C=i+112|0;D=i+56|0;f[m>>2]=c;_$(n,49432);E=RR(a,-1)|0;F=E&7;G=E>>>3&511;H=G+1|0;if((c|0)<0){f[m>>2]=F;I=F}else I=c;QR(o,a,-1);c=G<<3;KS(b,o,I&7|c,-1,0,0);if((d|2|0)==3){o=(d|0)==3;J=k;G=49452;K=J+72|0;do{f[J>>2]=f[G>>2];J=J+4|0;G=G+4|0}while((J|0)<(K|0));L=o&1;o=k+(L*36|0)|0;M=l+4|0;f[M>>2]=2;N=l+8|0;f[N>>2]=3;f[l+12>>2]=3;O=l+16|0;f[O>>2]=o;f[l+20>>2]=o;o=l+24|0;P=l+40|0;Q=o+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[P>>2]=N;N=l+48|0;Q=l+44|0;f[Q>>2]=N;f[l>>2]=1124024325;f[N>>2]=12;f[l+52>>2]=4;f[l+28>>2]=k+(L*36|0)+36;f[o>>2]=k+(L*36|0)+36;o=e!=1.0;if(o){R=j+8|0;f[R>>2]=0;f[R+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=l;WJ(l,j,-1,e,0.0);R=l+36|0;S=f[R>>2]|0;if((S|0)!=0?(T=S+12|0,S=f[T>>2]|0,f[T>>2]=S+-1,(S|0)==1):0){CR(l);U=R}else U=R}else U=l+36|0;f[U>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[M>>2]|0)>0){O=f[P>>2]|0;P=0;do{f[O+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[M>>2]|0))}M=f[Q>>2]|0;if((M|0)!=(N|0))ZF(M);J=k;G=49452;K=J+72|0;do{f[J>>2]=f[G>>2];J=J+4|0;G=G+4|0}while((J|0)<(K|0));G=k+(L*36|0)|0;M=l+4|0;f[M>>2]=2;N=l+8|0;f[N>>2]=3;f[l+12>>2]=3;Q=l+16|0;f[Q>>2]=G;f[l+20>>2]=G;G=l+24|0;P=l+40|0;O=G+8|0;f[O>>2]=0;f[O+4>>2]=0;f[P>>2]=N;N=l+48|0;O=l+44|0;f[O>>2]=N;f[l>>2]=1124024325;f[N>>2]=12;f[l+52>>2]=4;f[l+28>>2]=k+(L*36|0)+36;f[G>>2]=k+(L*36|0)+36;if(o){o=j+8|0;f[o>>2]=0;f[o+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=l;WJ(l,j,-1,e,0.0)}o=f[m>>2]|0;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=l;f[p>>2]=-1;f[p+4>>2]=-1;hfa(a,b,o,j,p,g,h);p=l+36|0;o=f[p>>2]|0;if(o|0?(L=o+12|0,o=f[L>>2]|0,f[L>>2]=o+-1,(o|0)==1):0)CR(l);f[p>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[M>>2]|0)>0){Q=f[P>>2]|0;P=0;do{f[Q+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[M>>2]|0))}M=f[O>>2]|0;if((M|0)!=(N|0))ZF(M)}else{M=(I|0)<(F|0)?F:I;I=(M|0)>5?M:5;M=((d|0)<6&(F|0)==0?3:F>>>0<6?5:6)|c;f[q>>2]=1124007936;c=q+4|0;N=q+8|0;O=q+40|0;J=c;K=J+36|0;do{f[J>>2]=0;J=J+4|0}while((J|0)<(K|0));f[O>>2]=N;P=q+48|0;Q=q+44|0;f[Q>>2]=P;f[P>>2]=0;f[q+52>>2]=0;f[r>>2]=1124007936;p=r+4|0;o=r+8|0;L=r+40|0;J=p;K=J+36|0;do{f[J>>2]=0;J=J+4|0}while((J|0)<(K|0));f[L>>2]=o;o=r+48|0;G=r+44|0;f[G>>2]=o;f[o>>2]=0;f[r+52>>2]=0;U=j+8|0;f[U>>2]=0;f[U+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=q;U=k+8|0;f[U>>2]=0;f[U+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=r;a8(j,k,2,0,d,0,I);do if((NS(a)|0)==65536){I=f[a+4>>2]|0;f[s>>2]=f[I>>2];d=s+4|0;U=I+4|0;f[d>>2]=f[U>>2];R=s+8|0;f[R>>2]=f[I+8>>2];f[s+12>>2]=f[I+12>>2];f[s+16>>2]=f[I+16>>2];f[s+20>>2]=f[I+20>>2];f[s+24>>2]=f[I+24>>2];f[s+28>>2]=f[I+28>>2];f[s+32>>2]=f[I+32>>2];S=f[I+36>>2]|0;f[s+36>>2]=S;f[s+40>>2]=R;R=s+48|0;T=s+44|0;f[T>>2]=R;f[R>>2]=0;f[s+52>>2]=0;if(S|0){R=S+12|0;f[R>>2]=(f[R>>2]|0)+1}if((f[U>>2]|0)<3){U=f[I+44>>2]|0;R=f[T>>2]|0;f[R>>2]=f[U>>2];f[R+4>>2]=f[U+4>>2];break}else{f[d>>2]=0;BR(s,I);break}}else OR(s,a,-1);while(0);do if((NS(b)|0)==65536){a=f[b+4>>2]|0;f[t>>2]=f[a>>2];I=t+4|0;d=a+4|0;f[I>>2]=f[d>>2];U=t+8|0;f[U>>2]=f[a+8>>2];f[t+12>>2]=f[a+12>>2];f[t+16>>2]=f[a+16>>2];f[t+20>>2]=f[a+20>>2];f[t+24>>2]=f[a+24>>2];f[t+28>>2]=f[a+28>>2];f[t+32>>2]=f[a+32>>2];R=f[a+36>>2]|0;f[t+36>>2]=R;f[t+40>>2]=U;U=t+48|0;T=t+44|0;f[T>>2]=U;f[U>>2]=0;f[t+52>>2]=0;if(R|0){U=R+12|0;f[U>>2]=(f[U>>2]|0)+1}if((f[d>>2]|0)<3){d=f[a+44>>2]|0;U=f[T>>2]|0;f[U>>2]=f[d>>2];f[U+4>>2]=f[d+4>>2];break}else{f[I>>2]=0;BR(t,a);break}}else OR(t,b,-1);while(0);f[v>>2]=0;f[v+4>>2]=0;b=s+12|0;a=s+8|0;I=f[a>>2]|0;f[w>>2]=f[b>>2];f[w+4>>2]=I;if(!(h&16))KR(s,w,v);I=h&-17;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=q;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=r;f[y>>2]=-1;f[y+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;Cda(x,E,M,j,k,y,0.0,I,I,l);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=r;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=q;f[A>>2]=-1;f[A+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;Cda(z,E,M,j,k,A,0.0,I,I,l);I=x+4|0;A=f[I>>2]|0;E=Jg[f[(f[A>>2]|0)+12>>2]&63](A,s,w,v)|0;A=z+4|0;y=f[A>>2]|0;Jg[f[(f[y>>2]|0)+12>>2]&63](y,s,w,v)|0;v=s+16|0;w=s+44|0;y=(f[v>>2]|0)+(Y(f[f[w>>2]>>2]|0,E)|0)|0;E=f[b>>2]|0;h=Y(E,H<<(47696>>>(F<<1)&3))|0;F=f[a>>2]|0;H=h>>>0>16384?1:16384/(h>>>0)|0;h=(F|0)<(H|0)?F:H;H=(f[N>>2]|0)+-1+h|0;f[B>>2]=1124007936;F=B+4|0;d=B+8|0;U=B+40|0;J=F;K=J+36|0;do{f[J>>2]=0;J=J+4|0}while((J|0)<(K|0));f[U>>2]=d;T=B+48|0;R=B+44|0;f[R>>2]=T;f[T>>2]=0;f[B+52>>2]=0;f[j>>2]=H;H=j+4|0;f[H>>2]=E;AR(B,2,j,M);E=h+-1+(f[N>>2]|0)|0;N=f[b>>2]|0;f[C>>2]=1124007936;b=C+4|0;S=C+8|0;V=C+40|0;J=b;K=J+36|0;do{f[J>>2]=0;J=J+4|0}while((J|0)<(K|0));f[V>>2]=S;J=C+48|0;K=C+44|0;f[K>>2]=J;f[J>>2]=0;f[C+52>>2]=0;f[j>>2]=E;f[H>>2]=N;AR(C,2,j,M);if((f[a>>2]|0)>0){M=s+48|0;N=B+16|0;H=C+16|0;E=j+4|0;W=k+4|0;X=j+8|0;Z=j+12|0;_=j+4|0;$=k+8|0;aa=k+12|0;ba=k+4|0;ca=l+8|0;da=l+4|0;ea=j+8|0;fa=j+4|0;ga=D+36|0;ha=D+16|0;ia=D+4|0;ja=D+40|0;ka=D+44|0;la=D+48|0;ma=f[M>>2]|0;na=0;oa=y;while(1){y=f[I>>2]|0;bg[f[(f[y>>2]|0)+16>>2]&127](y,oa,ma,h,f[N>>2]|0,f[T>>2]|0)|0;y=f[A>>2]|0;pa=bg[f[(f[y>>2]|0)+16>>2]&127](y,oa,f[M>>2]|0,h,f[H>>2]|0,f[J>>2]|0)|0;if((pa|0)>0){y=pa+na|0;f[j>>2]=na;f[E>>2]=y;f[k>>2]=-2147483648;f[W>>2]=2147483647;DR(D,t,j,k);f[S>>2]=pa;f[d>>2]=pa;f[X>>2]=0;f[Z>>2]=0;f[j>>2]=16842752;f[_>>2]=B;f[$>>2]=0;f[aa>>2]=0;f[k>>2]=16842752;f[ba>>2]=C;qa=ca;f[qa>>2]=0;f[qa+4>>2]=0;f[l>>2]=33619968;f[da>>2]=B;TG(j,k,l,fT()|0,-1);qa=ea;f[qa>>2]=0;f[qa+4>>2]=0;f[j>>2]=33619968;f[fa>>2]=D;WJ(B,j,f[m>>2]|0,e,g);qa=f[ga>>2]|0;if(qa|0?(ra=qa+12|0,qa=f[ra>>2]|0,f[ra>>2]=qa+-1,(qa|0)==1):0)CR(D);f[ga>>2]=0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[ia>>2]|0)>0){qa=f[ja>>2]|0;ra=0;do{f[qa+(ra<<2)>>2]=0;ra=ra+1|0}while((ra|0)<(f[ia>>2]|0))}ra=f[ka>>2]|0;if((ra|0)!=(la|0))ZF(ra);sa=y}else sa=pa+na|0;ma=f[M>>2]|0;oa=oa+(Y(ma,h)|0)|0;if((sa|0)>=(f[a>>2]|0))break;else na=sa}}sa=C+36|0;na=f[sa>>2]|0;if(na|0?(a=na+12|0,na=f[a>>2]|0,f[a>>2]=na+-1,(na|0)==1):0)CR(C);f[sa>>2]=0;sa=C+16|0;f[sa>>2]=0;f[sa+4>>2]=0;f[sa+8>>2]=0;f[sa+12>>2]=0;if((f[b>>2]|0)>0){sa=f[V>>2]|0;V=0;do{f[sa+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[b>>2]|0))}b=f[K>>2]|0;if((b|0)!=(J|0))ZF(b);b=B+36|0;J=f[b>>2]|0;if(J|0?(K=J+12|0,J=f[K>>2]|0,f[K>>2]=J+-1,(J|0)==1):0)CR(B);f[b>>2]=0;b=B+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[F>>2]|0)>0){b=f[U>>2]|0;U=0;do{f[b+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[F>>2]|0))}F=f[R>>2]|0;if((F|0)!=(T|0))ZF(F);F=f[z>>2]|0;if(F|0?(z=F+4|0,T=f[z>>2]|0,f[z>>2]=T+-1,(T|0)==1):0)ki[f[(f[F>>2]|0)+8>>2]&2047](F);F=f[x>>2]|0;if(F|0?(x=F+4|0,T=f[x>>2]|0,f[x>>2]=T+-1,(T|0)==1):0)ki[f[(f[F>>2]|0)+8>>2]&2047](F);F=t+36|0;T=f[F>>2]|0;if(T|0?(x=T+12|0,T=f[x>>2]|0,f[x>>2]=T+-1,(T|0)==1):0)CR(t);f[F>>2]=0;F=t+16|0;T=t+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[T>>2]|0)>0){F=f[t+40>>2]|0;x=0;do{f[F+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[T>>2]|0))}T=f[t+44>>2]|0;if((T|0)!=(t+48|0))ZF(T);T=s+36|0;t=f[T>>2]|0;do if(t|0){x=t+12|0;F=f[x>>2]|0;f[x>>2]=F+-1;if((F|0)!=1)break;CR(s)}while(0);f[T>>2]=0;T=s+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[T>>2]|0)>0){v=f[s+40>>2]|0;t=0;do{f[v+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[T>>2]|0))}T=f[w>>2]|0;if((T|0)!=(s+48|0))ZF(T);T=r+36|0;s=f[T>>2]|0;do if(s|0){w=s+12|0;t=f[w>>2]|0;f[w>>2]=t+-1;if((t|0)!=1)break;CR(r)}while(0);f[T>>2]=0;T=r+16|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[p>>2]|0)>0){T=f[L>>2]|0;L=0;do{f[T+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[p>>2]|0))}p=f[G>>2]|0;if((p|0)!=(o|0))ZF(p);p=q+36|0;o=f[p>>2]|0;do if(o|0){G=o+12|0;L=f[G>>2]|0;f[G>>2]=L+-1;if((L|0)!=1)break;CR(q)}while(0);f[p>>2]=0;p=q+16|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[c>>2]|0)>0){p=f[O>>2]|0;O=0;do{f[p+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[c>>2]|0))}c=f[Q>>2]|0;if((c|0)!=(P|0))ZF(c)}if(!(f[n+4>>2]|0)){u=i;return}u=i;return}function e8(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+144|0;i=h+128|0;j=h+72|0;k=h+16|0;l=h;JR(j,a,0,1,0,0);JR(k,c,0,1,0,0);c=j+40|0;m=f[c>>2]|0;n=k+40|0;o=f[n>>2]|0;if(((f[m>>2]|0)==(f[o>>2]|0)?(f[m+4>>2]|0)==(f[o+4>>2]|0):0)?(o=f[k>>2]|0,((o^f[j>>2])&4088|0)==0):0)p=o;else{f[i>>2]=0;f[i+4>>2]=0;o=c$(i,60)|0;m=222442;q=o+60|0;do{b[o>>0]=b[m>>0]|0;o=o+1|0;m=m+1|0}while((o|0)<(q|0));j$(-215,i,222503,222012,882);d$(i);p=f[k>>2]|0}f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=j;m=l+8|0;f[m>>2]=0;f[m+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=k;b8(i,l,p&7,d,e,g,1.0,0.0,1);if(((a|0?(f[a>>2]|0)==112:0)?f[a+68>>2]|0:0)?!((e&1|0)==0|(f[a+32>>2]|0)==0):0){a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=k;WJ(k,i,-1,-1.0,0.0)}i=k+36|0;a=f[i>>2]|0;if(a|0?(e=a+12|0,a=f[e>>2]|0,f[e>>2]=a+-1,(a|0)==1):0)CR(k);f[i>>2]=0;i=k+16|0;a=k+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[a>>2]|0)>0){i=f[n>>2]|0;n=0;do{f[i+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[a>>2]|0))}a=f[k+44>>2]|0;if((a|0)!=(k+48|0))ZF(a);a=j+36|0;k=f[a>>2]|0;if(k|0?(n=k+12|0,k=f[n>>2]|0,f[n>>2]=k+-1,(k|0)==1):0)CR(j);f[a>>2]=0;a=j+16|0;k=j+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[k>>2]|0)>0){a=f[c>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)==(j+48|0)){u=h;return}ZF(k);u=h;return}function f8(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0.0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0;i=u;u=u+1568|0;j=i+528|0;k=i+472|0;l=i+232|0;m=i+448|0;o=i+392|0;p=i+336|0;q=i+464|0;r=i+280|0;s=i+456|0;t=i;v=i+8|0;w=i+264|0;_$(m,49524);do if((NS(a)|0)==65536){x=f[a+4>>2]|0;f[o>>2]=f[x>>2];y=o+4|0;z=x+4|0;f[y>>2]=f[z>>2];A=o+8|0;f[A>>2]=f[x+8>>2];f[o+12>>2]=f[x+12>>2];f[o+16>>2]=f[x+16>>2];f[o+20>>2]=f[x+20>>2];f[o+24>>2]=f[x+24>>2];f[o+28>>2]=f[x+28>>2];f[o+32>>2]=f[x+32>>2];B=f[x+36>>2]|0;f[o+36>>2]=B;f[o+40>>2]=A;A=o+48|0;C=o+44|0;f[C>>2]=A;f[A>>2]=0;f[o+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[x+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;BR(o,x);break}}else OR(o,a,-1);while(0);f[p>>2]=1124007936;a=p+4|0;x=p+8|0;y=p+40|0;z=a;A=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(A|0));f[y>>2]=x;C=p+48|0;B=p+44|0;f[B>>2]=C;f[C>>2]=0;f[p+52>>2]=0;D=dT(d)|0;if(f[o>>2]&4095|0){f[j>>2]=0;f[j+4>>2]=0;z=c$(j,55)|0;E=332814;A=z+55|0;do{b[z>>0]=b[E>>0]|0;z=z+1|0;E=E+1|0}while((z|0)<(A|0));j$(-215,j,222511,222529,720);d$(j)}F=o+40|0;G=f[F>>2]|0;H=f[G>>2]|0;f[q>>2]=f[G+4>>2];f[q+4>>2]=H;KS(c,q,5,-1,0,0);do if((NS(c)|0)==65536){q=f[c+4>>2]|0;f[r>>2]=f[q>>2];H=r+4|0;G=q+4|0;f[H>>2]=f[G>>2];I=r+8|0;f[I>>2]=f[q+8>>2];f[r+12>>2]=f[q+12>>2];f[r+16>>2]=f[q+16>>2];f[r+20>>2]=f[q+20>>2];f[r+24>>2]=f[q+24>>2];f[r+28>>2]=f[q+28>>2];f[r+32>>2]=f[q+32>>2];J=f[q+36>>2]|0;f[r+36>>2]=J;f[r+40>>2]=I;I=r+48|0;K=r+44|0;f[K>>2]=I;f[I>>2]=0;f[r+52>>2]=0;if(J|0){I=J+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[G>>2]|0)<3){G=f[q+44>>2]|0;I=f[K>>2]|0;f[I>>2]=f[G>>2];f[I+4>>2]=f[G+4>>2];break}else{f[H>>2]=0;BR(r,q);break}}else OR(r,c,-1);while(0);a:do if(D){if((h|1|0)!=1){f[j>>2]=0;f[j+4>>2]=0;z=c$(j,62)|0;E=222586;A=z+62|0;do{b[z>>0]=b[E>>0]|0;z=z+1|0;E=E+1|0}while((z|0)<(A|0));j$(-215,j,222511,222529,727);d$(j)}c=f[F>>2]|0;q=f[c>>2]|0;f[s>>2]=f[c+4>>2];f[s+4>>2]=q;KS(d,s,4,-1,0,0);do if((NS(d)|0)==65536){q=f[d+4>>2]|0;f[j>>2]=f[q>>2];c=j+4|0;H=q+4|0;f[c>>2]=f[H>>2];G=j+8|0;f[G>>2]=f[q+8>>2];f[j+12>>2]=f[q+12>>2];f[j+16>>2]=f[q+16>>2];f[j+20>>2]=f[q+20>>2];f[j+24>>2]=f[q+24>>2];f[j+28>>2]=f[q+28>>2];f[j+32>>2]=f[q+32>>2];I=j+36|0;K=f[q+36>>2]|0;f[I>>2]=K;f[j+40>>2]=G;G=j+48|0;J=j+44|0;f[J>>2]=G;f[G>>2]=0;f[j+52>>2]=0;if(K|0){G=K+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[H>>2]|0)<3){H=f[q+44>>2]|0;G=f[J>>2]|0;f[G>>2]=f[H>>2];f[G+4>>2]=f[H+4>>2];L=I;break}else{f[c>>2]=0;BR(j,q);L=I;break}}else{OR(j,d,-1);L=j+36|0}while(0);I=f[L>>2]|0;if(I|0){q=I+12|0;f[q>>2]=(f[q>>2]|0)+1}q=p+36|0;I=f[q>>2]|0;if(I|0?(c=I+12|0,I=f[c>>2]|0,f[c>>2]=I+-1,(I|0)==1):0)CR(p);f[q>>2]=0;I=p+16|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[a>>2]|0)>0){c=f[y>>2]|0;H=0;do{f[c+(H<<2)>>2]=0;H=H+1|0;M=f[a>>2]|0}while((H|0)<(M|0));f[p>>2]=f[j>>2];if((M|0)<3)N=37;else N=39}else{f[p>>2]=f[j>>2];N=37}if((N|0)==37){H=f[j+4>>2]|0;if((H|0)<3){f[a>>2]=H;f[x>>2]=f[j+8>>2];f[p+12>>2]=f[j+12>>2];H=f[j+44>>2]|0;c=f[B>>2]|0;f[c>>2]=f[H>>2];f[c+4>>2]=f[H+4>>2]}else N=39}if((N|0)==39)BR(p,j);H=j+16|0;f[I>>2]=f[H>>2];f[p+20>>2]=f[j+20>>2];f[p+24>>2]=f[j+24>>2];f[p+28>>2]=f[j+28>>2];f[p+32>>2]=f[j+32>>2];c=f[L>>2]|0;f[q>>2]=c;if(c|0?(G=c+12|0,c=f[G>>2]|0,f[G>>2]=c+-1,(c|0)==1):0)CR(j);f[L>>2]=0;c=j+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[c>>2]|0)>0){H=f[j+40>>2]|0;G=0;do{f[H+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[c>>2]|0))}c=f[j+44>>2]|0;if((c|0)!=(j+48|0))ZF(c);c=t;f[c>>2]=0;f[c+4>>2]=0;O=t;P=5}else{c=t;f[c>>2]=0;f[c+4>>2]=0;switch(g|0){case 0:case 3:case 5:{O=t;P=g;break a;break}default:{}}f[j>>2]=0;f[j+4>>2]=0;z=c$(j,41)|0;E=222649;A=z+41|0;do{b[z>>0]=b[E>>0]|0;z=z+1|0;E=E+1|0}while((z|0)<(A|0));j$(-201,j,222511,222529,737);d$(j);O=t;P=g}while(0);g=(e|0)==1;if((e|2|0)!=3){t=(e|0)==2&D?5:P;if(!t){P=f[F>>2]|0;O=f[r+40>>2]|0;if(!((f[P>>2]|0)==(f[O>>2]|0)?(f[P+4>>2]|0)==(f[O+4>>2]|0):0)){f[j>>2]=0;f[j+4>>2]=0;z=c$(j,24)|0;E=326643;A=z+24|0;do{b[z>>0]=b[E>>0]|0;z=z+1|0;E=E+1|0}while((z|0)<(A|0));j$(-215,j,222691,222529,560);d$(j)}if(!((f[o>>2]&4095|0)==0?(f[r>>2]&4095|0)==5:0)){f[j>>2]=0;f[j+4>>2]=0;z=c$(j,114)|0;E=222705;A=z+114|0;do{b[z>>0]=b[E>>0]|0;z=z+1|0;E=E+1|0}while((z|0)<(A|0));j$(-215,j,222691,222529,562);d$(j)}O=o+8|0;P=f[O>>2]|0;L=o+12|0;x=f[L>>2]|0;M=P<<1;d=P*3|0;s=(P*12|0)+4+(P<<3)|0;c=x<<3;G=s>>>0<c>>>0?c:s;s=j+8|0;f[j>>2]=s;c=j+4|0;f[c>>2]=G;if(G>>>0>1032){H=OYa(G)|0;f[j>>2]=H;Q=H}else Q=s;H=Q+(M<<2)+3&-4;G=H;q=H;H=(P|0)>0;if(H){I=0;do{R=+(Y(I,I)|0);n[Q+(I<<2)>>2]=R;I=I+1|0}while((I|0)!=(P|0))}if((P|0)<(M|0)){I=P;do{n[Q+(I<<2)>>2]=999999986991104.0;I=I+1|0}while((I|0)!=(M|0))}if(H){H=(M|0)>1?M:1;F1a(q|0,0,H<<2|0)|0;S=H}else S=0;if((S|0)<=(d|0)){H=S;while(1){f[G+(H<<2)>>2]=H-M;if((H|0)<(d|0))H=H+1|0;else break}}f[k>>2]=0;f[k+4>>2]=x;f[l>>2]=49552;f[l+4>>2]=o;f[l+8>>2]=r;H=f[O>>2]|0;f[l+12>>2]=G+(H<<1<<2)+4;f[l+16>>2]=Q;G=f[o+4>>2]|0;if((G|0)<3)T=Y(f[L>>2]|0,H)|0;else{H=f[F>>2]|0;L=0;O=1;while(1){d=Y(f[H+(L<<2)>>2]|0,O)|0;L=L+1|0;if((L|0)==(G|0)){T=d;break}else O=d}}_U(k,l,+(T>>>0)*.0000152587890625);T=Q+(x<<2)|0;n[Q>>2]=0.0;n[T>>2]=0.0;if((x|0)>1){O=1;do{n[T+(O<<2)>>2]=.5/+(O|0);R=+(Y(O,O)|0);n[Q+(O<<2)>>2]=R;O=O+1|0}while((O|0)!=(x|0))}f[k>>2]=0;f[k+4>>2]=P;f[l>>2]=49572;f[l+4>>2]=r;f[l+8>>2]=Q;f[l+12>>2]=T;_U(k,l,-1.0);T=f[j>>2]|0;if((T|0)!=(s|0)){if(T|0)QYa(T);f[j>>2]=s;f[c>>2]=1032}}else{U=t;N=80}}else{U=D?5:3;N=80}if((N|0)==80){switch(e|0){case 3:{V=0;break}case 2:case 1:{N=82;break}default:{f[j>>2]=0;f[j+4>>2]=0;z=c$(j,73)|0;E=222820;A=z+73|0;do{b[z>>0]=b[E>>0]|0;z=z+1|0;E=E+1|0}while((z|0)<(A|0));j$(-215,j,222511,222529,780);d$(j);N=82}}if((N|0)==82)V=g?1:2;switch(V+(U*10|0)|0){case 30:{W=65536.0;X=65536.0;Z=0.0;break}case 31:{W=65536.0;X=131072.0;Z=0.0;break}case 32:{W=62586.87890625;X=89738.4453125;Z=0.0;break}case 50:{W=65536.0;X=65536.0;Z=131072.0;break}case 51:{W=65536.0;X=131072.0;Z=196608.0;break}case 52:{W=65536.0;X=91750.3984375;Z=143976.03125;break}default:{f[j>>2]=0;f[j+4>>2]=0;z=c$(j,19)|0;E=222894;A=z+19|0;do{b[z>>0]=b[E>>0]|0;z=z+1|0;E=E+1|0}while((z|0)<(A|0));j$(-5,j,222914,222529,441);d$(j);W=0.0;X=0.0;Z=0.0}}E=f[F>>2]|0;V=(U|0)==3;U=V?2:4;g=(f[E>>2]|0)+U|0;N=(f[E+4>>2]|0)+U|0;f[k>>2]=1124007936;U=k+4|0;E=k+8|0;e=k+40|0;z=U;A=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(A|0));f[e>>2]=E;E=k+48|0;t=k+44|0;f[t>>2]=E;f[E>>2]=0;f[k+52>>2]=0;f[j>>2]=g;f[j+4>>2]=N;AR(k,2,j,4);b:do if(D){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;f[j>>2]=-1056833530;f[j+4>>2]=l;f[j+8>>2]=1;f[j+12>>2]=4;hL(p,j,fT()|0)|0;if(!h){QQ(v,o,0.0);f[j>>2]=1124007936;N=j+4|0;g=j+8|0;c=j+40|0;z=N;A=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(A|0));f[c>>2]=g;s=j+48|0;T=j+44|0;f[T>>2]=s;f[s>>2]=0;f[j+52>>2]=0;Q=f[v>>2]|0;Ah[f[(f[Q>>2]|0)+12>>2]&255](Q,v,j,-1);fj(v);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=j;Q=w+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[w>>2]=33619968;f[w+4>>2]=p;i6(l,w,8,4,0)|0;Q=j+36|0;P=f[Q>>2]|0;if(P|0?(x=P+12|0,P=f[x>>2]|0,f[x>>2]=P+-1,(P|0)==1):0)CR(j);f[Q>>2]=0;Q=j+16|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[N>>2]|0)>0){Q=f[c>>2]|0;P=0;do{f[Q+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[N>>2]|0))}N=f[T>>2]|0;if((N|0)!=(s|0))ZF(N)}else{N=o+8|0;if((f[N>>2]|0)>0){P=o+12|0;Q=f[o+16>>2]|0;c=f[o+44>>2]|0;g=f[p+16>>2]|0;x=f[P>>2]|0;O=0;G=1;while(1){L=Q+(Y(f[c>>2]|0,O)|0)|0;H=g+(Y(f[f[B>>2]>>2]|0,O)|0)|0;if((x|0)>0){d=x;M=0;S=G;while(1){if(!(b[L+M>>0]|0)){f[H+(M<<2)>>2]=S;_=f[P>>2]|0;$=S+1|0}else{_=d;$=S}M=M+1|0;if((M|0)>=(_|0)){aa=_;ba=$;break}else{d=_;S=$}}}else{aa=x;ba=G}O=O+1|0;if((O|0)>=(f[N>>2]|0))break;else{x=aa;G=ba}}}}G=wNa(W)|0;x=wNa(X)|0;N=wNa(Z)|0;O=f[o+16>>2]|0;P=f[k+16>>2]|0;g=f[t>>2]|0;c=f[r+16>>2]|0;Q=f[p+16>>2]|0;s=f[o+48>>2]|0;T=(f[E>>2]|0)>>>2;S=(f[r+48>>2]|0)>>>2;d=(f[C>>2]|0)>>>2;M=f[F>>2]|0;H=f[M+4>>2]|0;L=f[M>>2]|0;M=f[e>>2]|0;q=f[M+4>>2]|0;I=f[M>>2]|0;if((q|0)>0){M=P+(Y(f[g>>2]|0,I+-1|0)|0)|0;J=0;do{f[P+(J<<2)>>2]=536870911;f[M+(J<<2)>>2]=536870911;J=J+1|0}while((J|0)!=(q|0));J=f[g>>2]|0;M=P+J|0;K=P+(Y(J,I+-2|0)|0)|0;J=0;do{f[M+(J<<2)>>2]=536870911;f[K+(J<<2)>>2]=536870911;J=J+1|0}while((J|0)!=(q|0))}if((L|0)>0){q=(H|0)>0;J=T<<1;K=d<<1;M=~K;I=1-K|0;g=-2-d|0;ca=~d;da=1-d|0;ea=2-d|0;fa=H+1|0;ga=0;do{ha=Y(ga,s)|0;ia=P+((Y(ga+2|0,T)|0)<<2)+8|0;ja=Y(ga,d)|0;f[ia+(H<<2)>>2]=536870911;f[ia+-4>>2]=536870911;f[ia+(fa<<2)>>2]=536870911;f[ia+-8>>2]=536870911;ka=O+ha|0;ha=Q+(ja<<2)|0;if(q){ja=0;do{if(!(b[ka+ja>>0]|0)){la=0;ma=ia}else{na=ja-J|0;oa=(f[ia+(na+-1<<2)>>2]|0)+N|0;if((oa|0)<536870911){pa=f[ha+(ja+M<<2)>>2]|0;qa=oa}else{pa=0;qa=536870911}oa=(f[ia+(na+1<<2)>>2]|0)+N|0;if((qa|0)>(oa|0)){ra=f[ha+(I+ja<<2)>>2]|0;sa=oa}else{ra=pa;sa=qa}oa=ja-T|0;na=(f[ia+(oa+-2<<2)>>2]|0)+N|0;if((sa|0)>(na|0)){ta=f[ha+(g+ja<<2)>>2]|0;ua=na}else{ta=ra;ua=sa}na=(f[ia+(oa+-1<<2)>>2]|0)+x|0;if((ua|0)>(na|0)){va=f[ha+(ja+ca<<2)>>2]|0;wa=na}else{va=ta;wa=ua}na=(f[ia+(oa<<2)>>2]|0)+G|0;if((wa|0)>(na|0)){xa=f[ha+(ja-d<<2)>>2]|0;ya=na}else{xa=va;ya=wa}na=(f[ia+(oa+1<<2)>>2]|0)+x|0;if((ya|0)>(na|0)){za=f[ha+(da+ja<<2)>>2]|0;Aa=na}else{za=xa;Aa=ya}na=(f[ia+(oa+2<<2)>>2]|0)+N|0;if((Aa|0)>(na|0)){Ba=f[ha+(ea+ja<<2)>>2]|0;Ca=na}else{Ba=za;Ca=Aa}na=ja+-1|0;oa=(f[ia+(na<<2)>>2]|0)+G|0;if((Ca|0)>(oa|0)){Da=f[ha+(na<<2)>>2]|0;Ea=oa}else{Da=Ba;Ea=Ca}f[ia+(ja<<2)>>2]=Ea;la=Da;ma=ha}f[ma+(ja<<2)>>2]=la;ja=ja+1|0}while((ja|0)!=(H|0))}ga=ga+1|0}while((ga|0)!=(L|0));ga=J+-1|0;ea=K+-1|0;da=d+2|0;if(q){ca=L;do{g=ca;ca=ca+-1|0;I=c+((Y(ca,S)|0)<<2)|0;M=P+((Y(g+1|0,T)|0)<<2)+8|0;O=Q+((Y(ca,d)|0)<<2)|0;fa=H;do{s=fa;fa=fa+-1|0;ja=M+(fa<<2)|0;ha=f[ja>>2]|0;ia=O+(fa<<2)|0;if((ha|0)>(G|0)){ka=(f[M+(s+J<<2)>>2]|0)+N|0;oa=(ha|0)>(ka|0);na=oa?ka:ha;ka=(f[M+(ga+fa<<2)>>2]|0)+N|0;Fa=(na|0)>(ka|0);Ga=Fa?ka:na;na=fa+T|0;ka=(f[M+(na+2<<2)>>2]|0)+N|0;Ha=(Ga|0)>(ka|0);Ia=Ha?ka:Ga;Ga=(f[M+(s+T<<2)>>2]|0)+x|0;ka=(Ia|0)>(Ga|0);Ja=ka?Ga:Ia;Ia=(f[M+(na<<2)>>2]|0)+G|0;Ga=(Ja|0)>(Ia|0);Ka=fa+d|0;La=Ga?Ia:Ja;Ja=(f[M+(na+-1<<2)>>2]|0)+x|0;Ia=(La|0)>(Ja|0);Ma=Ia?Ja:La;La=(f[M+(na+-2<<2)>>2]|0)+N|0;na=(Ma|0)>(La|0);Ja=na?La:Ma;Ma=(f[M+(s<<2)>>2]|0)+G|0;La=(Ja|0)>(Ma|0);Na=La?Ma:Ja;Ja=f[(La?O+(s<<2)|0:na?O+(Ka+-2<<2)|0:Ia?O+(Ka+-1<<2)|0:Ga?O+(Ka<<2)|0:ka?O+(s+d<<2)|0:Ha?O+(da+fa<<2)|0:Fa?O+(ea+fa<<2)|0:oa?O+(s+K<<2)|0:ia)>>2]|0;f[ja>>2]=Na;f[ia>>2]=Ja;Oa=Na}else Oa=ha;n[I+(fa<<2)>>2]=+(Oa|0)*.0000152587890625}while((s|0)>1)}while((g|0)>1)}}}else{K=wNa(W)|0;ea=wNa(X)|0;if(V){da=f[o+16>>2]|0;d=f[k+16>>2]|0;G=f[r+16>>2]|0;N=f[o+48>>2]|0;x=(f[E>>2]|0)>>>2;T=(f[r+48>>2]|0)>>>2;ga=f[F>>2]|0;J=f[ga+4>>2]|0;H=f[ga>>2]|0;ga=f[e>>2]|0;ca=f[ga+4>>2]|0;if((ca|0)>0){Q=d+(Y(f[f[t>>2]>>2]|0,(f[ga>>2]|0)+-1|0)|0)|0;ga=0;do{f[d+(ga<<2)>>2]=536870911;f[Q+(ga<<2)>>2]=536870911;ga=ga+1|0}while((ga|0)!=(ca|0))}if((H|0)<=0)break;ca=(J|0)>0;if(ca){ga=0;do{Q=Y(ga,N)|0;ga=ga+1|0;P=d+((Y(ga,x)|0)<<2)+4|0;f[P+(J<<2)>>2]=536870911;f[P+-4>>2]=536870911;S=da+Q|0;Q=536870911;c=0;while(1){if(!(b[S+c>>0]|0))Pa=0;else{L=c-x|0;q=(f[P+(L+-1<<2)>>2]|0)+ea|0;fa=(f[P+(L<<2)>>2]|0)+K|0;I=(q|0)>(fa|0)?fa:q;q=(f[P+(L+1<<2)>>2]|0)+ea|0;L=(I|0)>(q|0)?q:I;I=Q+K|0;Pa=(L|0)>(I|0)?I:L}f[P+(c<<2)>>2]=Pa;c=c+1|0;if((c|0)==(J|0))break;else Q=Pa}}while((ga|0)!=(H|0))}else{ga=0;do{ga=ga+1|0;da=d+((Y(ga,x)|0)<<2)+4|0;f[da+(J<<2)>>2]=536870911;f[da+-4>>2]=536870911}while((ga|0)!=(H|0))}if(ca)Qa=H;else break;while(1){ga=Qa;Qa=Qa+-1|0;da=G+((Y(Qa,T)|0)<<2)|0;N=d+((Y(ga,x)|0)<<2)+4|0;Q=J;do{c=Q;Q=Q+-1|0;P=N+(Q<<2)|0;S=f[P>>2]|0;if((S|0)>(K|0)){g=Q+x|0;L=(f[N+(c+x<<2)>>2]|0)+ea|0;I=(S|0)>(L|0)?L:S;L=(f[N+(g<<2)>>2]|0)+K|0;q=(I|0)>(L|0)?L:I;I=(f[N+(g+-1<<2)>>2]|0)+ea|0;g=(q|0)>(I|0)?I:q;q=(f[N+(c<<2)>>2]|0)+K|0;I=(g|0)>(q|0)?q:g;f[P>>2]=I;Ra=I}else Ra=S;n[da+(Q<<2)>>2]=+(Ra|0)*.0000152587890625}while((c|0)>1);if((ga|0)<=1)break b}}x=wNa(Z)|0;J=f[o+16>>2]|0;d=f[k+16>>2]|0;T=f[t>>2]|0;G=f[r+16>>2]|0;H=f[o+48>>2]|0;ca=(f[E>>2]|0)>>>2;Q=(f[r+48>>2]|0)>>>2;da=f[F>>2]|0;N=f[da+4>>2]|0;c=f[da>>2]|0;da=f[e>>2]|0;S=f[da+4>>2]|0;I=f[da>>2]|0;if((S|0)>0){da=d+(Y(f[T>>2]|0,I+-1|0)|0)|0;P=0;do{f[d+(P<<2)>>2]=536870911;f[da+(P<<2)>>2]=536870911;P=P+1|0}while((P|0)!=(S|0));P=f[T>>2]|0;da=d+P|0;g=d+(Y(P,I+-2|0)|0)|0;P=0;do{f[da+(P<<2)>>2]=536870911;f[g+(P<<2)>>2]=536870911;P=P+1|0}while((P|0)!=(S|0))}if((c|0)>0){S=(N|0)>0;P=ca<<1;g=N+1|0;if(S){da=0;do{I=Y(da,H)|0;T=d+((Y(da+2|0,ca)|0)<<2)+8|0;f[T+(N<<2)>>2]=536870911;f[T+-4>>2]=536870911;f[T+(g<<2)>>2]=536870911;f[T+-8>>2]=536870911;q=J+I|0;I=0;do{if(!(b[q+I>>0]|0))Sa=0;else{L=I-P|0;fa=(f[T+(L+-1<<2)>>2]|0)+x|0;O=(f[T+(L+1<<2)>>2]|0)+x|0;L=(fa|0)>(O|0)?O:fa;fa=I-ca|0;O=(f[T+(fa+-2<<2)>>2]|0)+x|0;M=(L|0)>(O|0)?O:L;L=(f[T+(fa+-1<<2)>>2]|0)+ea|0;O=(M|0)>(L|0)?L:M;M=(f[T+(fa<<2)>>2]|0)+K|0;L=(O|0)>(M|0)?M:O;O=(f[T+(fa+1<<2)>>2]|0)+ea|0;M=(L|0)>(O|0)?O:L;L=(f[T+(fa+2<<2)>>2]|0)+x|0;fa=(M|0)>(L|0)?L:M;M=(f[T+(I+-1<<2)>>2]|0)+K|0;Sa=(fa|0)>(M|0)?M:fa}f[T+(I<<2)>>2]=Sa;I=I+1|0}while((I|0)!=(N|0));da=da+1|0}while((da|0)!=(c|0))}else{da=0;do{J=d+((Y(da+2|0,ca)|0)<<2)+8|0;f[J+(N<<2)>>2]=536870911;f[J+-4>>2]=536870911;f[J+(g<<2)>>2]=536870911;f[J+-8>>2]=536870911;da=da+1|0}while((da|0)!=(c|0))}da=P+-1|0;if(S){g=c;do{J=g;g=g+-1|0;H=G+((Y(g,Q)|0)<<2)|0;I=d+((Y(J+1|0,ca)|0)<<2)+8|0;T=N;do{q=T;T=T+-1|0;ga=I+(T<<2)|0;fa=f[ga>>2]|0;if((fa|0)>(K|0)){M=(f[I+(q+P<<2)>>2]|0)+x|0;L=(fa|0)>(M|0)?M:fa;M=(f[I+(da+T<<2)>>2]|0)+x|0;O=(L|0)>(M|0)?M:L;L=T+ca|0;M=(f[I+(L+2<<2)>>2]|0)+x|0;s=(O|0)>(M|0)?M:O;O=(f[I+(q+ca<<2)>>2]|0)+ea|0;M=(s|0)>(O|0)?O:s;s=(f[I+(L<<2)>>2]|0)+K|0;O=(M|0)>(s|0)?s:M;M=(f[I+(L+-1<<2)>>2]|0)+ea|0;s=(O|0)>(M|0)?M:O;O=(f[I+(L+-2<<2)>>2]|0)+x|0;L=(s|0)>(O|0)?O:s;s=(f[I+(q<<2)>>2]|0)+K|0;O=(L|0)>(s|0)?s:L;f[ga>>2]=O;Ta=O}else Ta=fa;n[H+(T<<2)>>2]=+(Ta|0)*.0000152587890625}while((q|0)>1)}while((J|0)>1)}}}while(0);Ta=k+36|0;Sa=f[Ta>>2]|0;if(Sa|0?(Ra=Sa+12|0,Sa=f[Ra>>2]|0,f[Ra>>2]=Sa+-1,(Sa|0)==1):0)CR(k);f[Ta>>2]=0;Ta=k+16|0;f[Ta>>2]=0;f[Ta+4>>2]=0;f[Ta+8>>2]=0;f[Ta+12>>2]=0;if((f[U>>2]|0)>0){Ta=f[e>>2]|0;e=0;do{f[Ta+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[U>>2]|0))}U=f[t>>2]|0;if((U|0)!=(E|0))ZF(U)}U=r+36|0;E=f[U>>2]|0;if(E|0?(t=E+12|0,E=f[t>>2]|0,f[t>>2]=E+-1,(E|0)==1):0)CR(r);f[U>>2]=0;U=r+16|0;E=r+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[E>>2]|0)>0){U=f[r+40>>2]|0;t=0;do{f[U+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[E>>2]|0))}E=f[r+44>>2]|0;if((E|0)!=(r+48|0))ZF(E);E=p+36|0;r=f[E>>2]|0;if(r|0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0)CR(p);f[E>>2]=0;E=p+16|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[a>>2]|0)>0){E=f[y>>2]|0;y=0;do{f[E+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[a>>2]|0))}a=f[B>>2]|0;if((a|0)!=(C|0))ZF(a);a=o+36|0;C=f[a>>2]|0;if(C|0?(B=C+12|0,C=f[B>>2]|0,f[B>>2]=C+-1,(C|0)==1):0)CR(o);f[a>>2]=0;a=o+16|0;C=o+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[C>>2]|0)>0){a=f[F>>2]|0;F=0;do{f[a+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[C>>2]|0))}C=f[o+44>>2]|0;if((C|0)!=(o+48|0))ZF(C);if(!(f[m+4>>2]|0)){u=i;return}u=i;return}function g8(a){a=a|0;PYa(a);return}function h8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0.0,E=0,F=0.0;c=u;u=u+1040|0;d=c;e=f[b>>2]|0;g=f[b+4>>2]|0;b=f[a+4>>2]|0;h=f[b+12>>2]|0;i=(h*12|0)+24|0;j=d+8|0;f[d>>2]=j;k=d+4|0;f[k>>2]=i;if(i>>>0>1032){l=OYa(i)|0;f[d>>2]=l;m=l}else m=j;l=m+(h<<2)|0;i=l+(h<<2)+4+3&-4;a:do if((e|0)<(g|0)){o=f[b+16>>2]|0;p=f[b+44>>2]|0;q=l+4|0;r=(h|0)>0;s=a+8|0;if((h|0)<=1){t=e;while(1){v=o+(Y(f[p>>2]|0,t)|0)|0;f[i>>2]=0;n[l>>2]=-999999986991104.0;n[q>>2]=999999986991104.0;f[m>>2]=f[v>>2];if(r){w=f[s>>2]|0;x=0;y=0;while(1){z=+(y|0);A=x;while(1){B=A+1|0;if(+n[l+(B<<2)>>2]<z)A=B;else break}B=f[i+(A<<2)>>2]|0;C=y-B|0;z=+M(+(+n[w+(((C|0)>-1?C:0-C|0)<<2)>>2]+ +n[m+(B<<2)>>2]));n[v+(y<<2)>>2]=z;y=y+1|0;if((y|0)==(h|0))break;else x=A}}t=t+1|0;if((t|0)==(g|0))break a}}t=f[s>>2]|0;x=f[a+12>>2]|0;y=e;do{v=o+(Y(f[p>>2]|0,y)|0)|0;f[i>>2]=0;n[l>>2]=-999999986991104.0;n[q>>2]=999999986991104.0;f[m>>2]=f[v>>2];w=0;B=1;do{z=+n[v+(B<<2)>>2];n[m+(B<<2)>>2]=z;D=z+ +n[t+(B<<2)>>2];C=w;while(1){E=f[i+(C<<2)>>2]|0;F=(D-+n[v+(E<<2)>>2]-+n[t+(E<<2)>>2])*+n[x+(B-E<<2)>>2];if(F>+n[l+(C<<2)>>2])break;else C=C+-1|0}w=C+1|0;f[i+(w<<2)>>2]=B;n[l+(w<<2)>>2]=F;n[l+(C+2<<2)>>2]=999999986991104.0;B=B+1|0}while((B|0)!=(h|0));if(r){B=0;w=0;while(1){D=+(w|0);A=B;while(1){E=A+1|0;if(+n[l+(E<<2)>>2]<D)A=E;else break}C=f[i+(A<<2)>>2]|0;E=w-C|0;D=+M(+(+n[t+(((E|0)>-1?E:0-E|0)<<2)>>2]+ +n[m+(C<<2)>>2]));n[v+(w<<2)>>2]=D;w=w+1|0;if((w|0)==(h|0))break;else B=A}}y=y+1|0}while((y|0)!=(g|0))}while(0);if((m|0)==(j|0)){u=c;return}QYa(m);f[d>>2]=j;f[k>>2]=1032;u=c;return}function i8(a){a=a|0;PYa(a);return}function j8(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+1072|0;e=d;g=f[c>>2]|0;h=f[c+4>>2]|0;c=f[a+4>>2]|0;i=f[c+8>>2]|0;j=f[c+48>>2]|0;k=f[a+8>>2]|0;l=(f[k+48>>2]|0)>>>2;m=e+8|0;f[e>>2]=m;n=e+4|0;f[n>>2]=i;if(i>>>0>264){o=OYa(i>>>0>1073741823?-1:i<<2)|0;f[e>>2]=o;p=o}else p=m;if((g|0)<(h|0)?(o=i+-1|0,q=a+12|0,r=a+16|0,a=0-j|0,(i|0)>0):0){j=f[c+16>>2]|0;s=f[c+44>>2]|0;c=f[k+16>>2]|0;k=g;do{g=o;t=o;v=j+(Y(f[s>>2]|0,o)|0)+k|0;while(1){g=b[v>>0]|0?g+1|0:0;f[p+(t<<2)>>2]=g;if((t|0)<=0)break;else{t=t+-1|0;v=v+a|0}}v=f[q>>2]|0;t=f[r>>2]|0;g=o;w=c+(k<<2)|0;x=0;while(1){y=p+(x<<2)|0;g=g+1-(f[v+(g-(f[y>>2]|0)<<2)>>2]|0)|0;f[y>>2]=g;f[w>>2]=f[t+(g<<2)>>2];x=x+1|0;if((x|0)==(i|0))break;else w=w+(l<<2)|0}k=k+1|0}while((k|0)!=(h|0))}if((p|0)==(m|0)){u=d;return}QYa(p);f[e>>2]=m;f[n>>2]=264;u=d;return}function k8(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;i=u;u=u+400|0;j=i+144|0;k=i+136|0;l=i+128|0;m=i+72|0;n=i+64|0;o=i+8|0;p=i;_$(p,49584);if((d|0)==1&(g|0)==0){_$(l,49604);do if((NS(a)|0)==65536){l=f[a+4>>2]|0;f[m>>2]=f[l>>2];g=m+4|0;q=l+4|0;f[g>>2]=f[q>>2];r=m+8|0;f[r>>2]=f[l+8>>2];f[m+12>>2]=f[l+12>>2];f[m+16>>2]=f[l+16>>2];f[m+20>>2]=f[l+20>>2];f[m+24>>2]=f[l+24>>2];f[m+28>>2]=f[l+28>>2];f[m+32>>2]=f[l+32>>2];s=f[l+36>>2]|0;f[m+36>>2]=s;f[m+40>>2]=r;r=m+48|0;t=m+44|0;f[t>>2]=r;f[r>>2]=0;f[m+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[l+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];v=m;break}else{f[g>>2]=0;BR(m,l);v=m;break}}else{OR(m,a,-1);v=m}while(0);if(f[v>>2]&4095|0){f[j>>2]=0;f[j+4>>2]=0;w=c$(j,55)|0;x=332814;y=w+55|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));j$(-215,j,223062,222529,688);d$(j)}l=m+40|0;g=f[l>>2]|0;q=f[g>>2]|0;f[n>>2]=f[g+4>>2];f[n+4>>2]=q;KS(c,n,0,-1,0,0);do if((NS(c)|0)==65536){n=f[c+4>>2]|0;f[o>>2]=f[n>>2];q=o+4|0;g=n+4|0;f[q>>2]=f[g>>2];r=o+8|0;f[r>>2]=f[n+8>>2];f[o+12>>2]=f[n+12>>2];t=o+16|0;f[t>>2]=f[n+16>>2];f[o+20>>2]=f[n+20>>2];f[o+24>>2]=f[n+24>>2];f[o+28>>2]=f[n+28>>2];f[o+32>>2]=f[n+32>>2];s=f[n+36>>2]|0;f[o+36>>2]=s;f[o+40>>2]=r;r=o+48|0;z=o+44|0;f[z>>2]=r;f[r>>2]=0;f[o+52>>2]=0;if(s|0){A=s+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[g>>2]|0)<3){g=f[n+44>>2]|0;A=f[z>>2]|0;f[A>>2]=f[g>>2];f[A+4>>2]=f[g+4>>2];B=r;C=t;break}else{f[q>>2]=0;BR(o,n);B=r;C=t;break}}else{OR(o,c,-1);B=o+48|0;C=o+16|0}while(0);t=f[m+12>>2]|0;r=f[m+8>>2]|0;n=m+16|0;q=f[n>>2]|0;g=f[C>>2]|0;A=m+48|0;z=f[A>>2]|0;s=f[B>>2]|0;if(!((f[v>>2]&4095|0)==0?!(f[o>>2]&4095|0):0)){f[k>>2]=0;f[k+4>>2]=0;w=c$(k,114)|0;x=223086;y=w+114|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));j$(-215,k,223201,222529,617);d$(k)}v=f[l>>2]|0;D=o+40|0;E=f[D>>2]|0;if((f[v>>2]|0)==(f[E>>2]|0)?(f[v+4>>2]|0)==(f[E+4>>2]|0):0)F=0;else{f[k>>2]=0;f[k+4>>2]=0;w=c$(k,24)|0;x=326643;y=w+24|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));j$(-215,k,223201,222529,618);d$(k);F=0}do{k=F;F=F+1|0;b[j+k>>0]=F>>>0<256?F:(k>>>31)+255|0}while((F|0)!=256);F=((b[q>>0]|0)!=0)<<31>>31;b[g>>0]=F;k=(t|0)>1;if(k){x=F;F=1;do{if(!(b[q+F>>0]|0))G=0;else G=h[j+(x&255)>>0]|0;x=G&255;b[g+F>>0]=x;F=F+1|0}while((F|0)!=(t|0))}do if((r|0)>1){F=0-s|0;x=Y(s,r+-1|0)|0;if(k){H=g;I=q;J=1}else{G=g;w=q;y=1;do{w=w+z|0;G=G+s|0;if(!(b[w>>0]|0))K=0;else K=h[j+(h[G+F>>0]|0)>>0]|0;b[G>>0]=K;y=y+1|0}while((y|0)!=(r|0));L=g+x|0;break}do{I=I+z|0;H=H+s|0;if(!(b[I>>0]|0))M=0;else M=h[j+(h[H+F>>0]|0)>>0]|0;b[H>>0]=M;y=M;G=1;while(1){if(!(b[I+G>>0]|0))N=0;else{w=h[H+(G-s)>>0]|0;N=h[j+((y|0)>(w|0)?w:y)>>0]|0}b[H+G>>0]=N;G=G+1|0;if((G|0)==(t|0))break;else y=N}J=J+1|0}while((J|0)!=(r|0));L=g+x|0}else L=g;while(0);g=t+-1|0;J=t+-2|0;t=(J|0)>-1;if(t){N=h[L+g>>0]|0;H=J;while(1){I=h[j+N>>0]|0;M=L+H|0;z=I-(h[M>>0]|0)+256|0;if(z>>>0<769)O=h[331268+z>>0]|0;else O=0;N=I-O|0;b[M>>0]=N;if((H|0)<=0)break;else H=H+-1|0}}H=r+-2|0;a:do if((H|0)>-1){r=0-s|0;N=s+g|0;if(t){P=L;Q=H}else{O=L;M=H;while(1){O=O+r|0;I=b[j+(h[O+N>>0]|0)>>0]|0;z=O+g|0;K=b[z>>0]|0;b[z>>0]=(I&255)>(K&255)?K:I;if((M|0)<=0)break a;else M=M+-1|0}}while(1){P=P+r|0;M=b[j+(h[P+N>>0]|0)>>0]|0;O=P+g|0;x=b[O>>0]|0;I=(M&255)>(x&255)?x:M;b[O>>0]=I;O=I&255;I=J;while(1){M=h[P+(I+s)>>0]|0;x=b[j+(O>>>0>M>>>0?M:O)>>0]|0;M=P+I|0;K=b[M>>0]|0;z=(x&255)>(K&255)?K:x;b[M>>0]=z;if((I|0)>0){O=z&255;I=I+-1|0}else break}if((Q|0)<=0)break;else Q=Q+-1|0}}while(0);Q=o+36|0;P=f[Q>>2]|0;if(P|0?(j=P+12|0,P=f[j>>2]|0,f[j>>2]=P+-1,(P|0)==1):0)CR(o);f[Q>>2]=0;Q=o+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[Q>>2]|0)>0){C=f[D>>2]|0;D=0;do{f[C+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[Q>>2]|0))}Q=f[o+44>>2]|0;if((Q|0)!=(B|0))ZF(Q);Q=m+36|0;B=f[Q>>2]|0;if(B|0?(o=B+12|0,B=f[o>>2]|0,f[o>>2]=B+-1,(B|0)==1):0)CR(m);f[Q>>2]=0;Q=m+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[Q>>2]|0)>0){n=f[l>>2]|0;l=0;do{f[n+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[Q>>2]|0))}Q=f[m+44>>2]|0;if((Q|0)!=(A|0))ZF(Q)}else f8(a,c,fT()|0,d,e,1);if(!(f[p+4>>2]|0)){u=i;return}u=i;return}function l8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,M=0.0,N=0,O=0,P=0;d=u;u=u+16|0;e=d;_$(e,49624);g=a;h=f[g>>2]|0;i=f[g+4>>2]|0;g=C1a(h|0,i|0,-1,-1)|0;j=J;k=a+8|0;a=f[k>>2]|0;l=f[k+4>>2]|0;k=C1a(a|0,l|0,-1,-1)|0;m=J;if((i|0)<0|(i|0)==0&h>>>0<1|((l|0)<0|(l|0)==0&a>>>0<1))n=0;else{o=b+8|0;p=c+8|0;q=b;r=f[q>>2]|0;s=f[q+4>>2]|0;q=I1a(r|0,s|0,63)|0;t=o;v=f[t>>2]|0;w=f[t+4>>2]|0;t=I1a(v|0,w|0,61)|0;x=(((s|0)>(i|0)|(s|0)==(i|0)&r>>>0>=h>>>0)&1)<<1|q|t&4|(((w|0)>(l|0)|(w|0)==(l|0)&v>>>0>=a>>>0)&1)<<3;t=c;q=f[t>>2]|0;y=f[t+4>>2]|0;t=I1a(q|0,y|0,63)|0;z=p;A=f[z>>2]|0;B=f[z+4>>2]|0;z=I1a(A|0,B|0,61)|0;C=(((y|0)>(i|0)|(y|0)==(i|0)&q>>>0>=h>>>0)&1)<<1|t|z&4|(((B|0)>(l|0)|(B|0)==(l|0)&A>>>0>=a>>>0)&1)<<3;if(!((C&x|0)!=0|(C|x|0)==0)){if(!(x&12)){D=r;E=s;F=v;G=w;H=x}else{a=x>>>0<8;l=a?0:k;z=a?0:m;a=B1a(l|0,z|0,v|0,w|0)|0;I=+(a>>>0)+4294967296.0*+(J|0);a=B1a(q|0,y|0,r|0,s|0)|0;M=(+(a>>>0)+4294967296.0*+(J|0))*I;a=B1a(A|0,B|0,v|0,w|0)|0;I=M/(+(a>>>0)+4294967296.0*+(J|0));a=C1a(~~I>>>0|0,(+L(I)>=1.0?(I>0.0?~~+Z(+K(I/4294967296.0),4294967295.0)>>>0:~~+X((I-+(~~I>>>0))/4294967296.0)>>>0):0)|0,r|0,s|0)|0;s=J;r=b;f[r>>2]=a;f[r+4>>2]=s;r=o;f[r>>2]=l;f[r+4>>2]=z;r=I1a(a|0,s|0,63)|0;D=a;E=s;F=l;G=z;H=(((s|0)>(i|0)|(s|0)==(i|0)&a>>>0>=h>>>0)&1)<<1|r}if(!(C&12))N=C;else{r=C>>>0<8;a=r?0:k;k=r?0:m;m=p;r=f[m>>2]|0;s=f[m+4>>2]|0;m=B1a(a|0,k|0,r|0,s|0)|0;I=+(m>>>0)+4294967296.0*+(J|0);m=c;z=f[m>>2]|0;l=f[m+4>>2]|0;m=B1a(z|0,l|0,D|0,E|0)|0;M=I*(+(m>>>0)+4294967296.0*+(J|0));m=B1a(r|0,s|0,F|0,G|0)|0;I=M/(+(m>>>0)+4294967296.0*+(J|0));m=C1a(~~I>>>0|0,(+L(I)>=1.0?(I>0.0?~~+Z(+K(I/4294967296.0),4294967295.0)>>>0:~~+X((I-+(~~I>>>0))/4294967296.0)>>>0):0)|0,z|0,l|0)|0;l=J;z=c;f[z>>2]=m;f[z+4>>2]=l;z=p;f[z>>2]=a;f[z+4>>2]=k;k=I1a(m|0,l|0,63)|0;N=(((l|0)>(i|0)|(l|0)==(i|0)&m>>>0>=h>>>0)&1)<<1|k}if(!((N&H|0)!=0|(N|H|0)==0)){if(H|0){k=(H|0)==1;h=k?0:g;m=k?0:j;k=b;i=f[k>>2]|0;l=f[k+4>>2]|0;k=B1a(h|0,m|0,i|0,l|0)|0;I=+(k>>>0)+4294967296.0*+(J|0);k=p;z=o;a=f[z>>2]|0;G=f[z+4>>2]|0;z=B1a(f[k>>2]|0,f[k+4>>2]|0,a|0,G|0)|0;M=I*(+(z>>>0)+4294967296.0*+(J|0));z=c;k=B1a(f[z>>2]|0,f[z+4>>2]|0,i|0,l|0)|0;I=M/(+(k>>>0)+4294967296.0*+(J|0));k=C1a(~~I>>>0|0,(+L(I)>=1.0?(I>0.0?~~+Z(+K(I/4294967296.0),4294967295.0)>>>0:~~+X((I-+(~~I>>>0))/4294967296.0)>>>0):0)|0,a|0,G|0)|0;G=o;f[G>>2]=k;f[G+4>>2]=J;G=b;f[G>>2]=h;f[G+4>>2]=m}if(!N){O=0;P=0}else{m=(N|0)==1;G=m?0:g;g=m?0:j;j=c;m=f[j>>2]|0;h=f[j+4>>2]|0;j=B1a(G|0,g|0,m|0,h|0)|0;I=+(j>>>0)+4294967296.0*+(J|0);j=p;k=f[j>>2]|0;a=f[j+4>>2]|0;j=o;o=B1a(k|0,a|0,f[j>>2]|0,f[j+4>>2]|0)|0;M=I*(+(o>>>0)+4294967296.0*+(J|0));o=b;b=B1a(m|0,h|0,f[o>>2]|0,f[o+4>>2]|0)|0;I=M/(+(b>>>0)+4294967296.0*+(J|0));b=C1a(~~I>>>0|0,(+L(I)>=1.0?(I>0.0?~~+Z(+K(I/4294967296.0),4294967295.0)>>>0:~~+X((I-+(~~I>>>0))/4294967296.0)>>>0):0)|0,k|0,a|0)|0;a=p;f[a>>2]=b;f[a+4>>2]=J;a=c;f[a>>2]=G;f[a+4>>2]=g;O=0;P=0}}else{O=H;P=N}}else{O=x;P=C}n=(O|P|0)==0}if(!(f[e+4>>2]|0)){u=d;return n|0}u=d;return n|0}function m8(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;m=a+20|0;f[m>>2]=-1;n=(g|0)==8;switch(g|0){case 4:case 8:break;default:{f[j>>2]=0;f[j+4>>2]=0;g=c$(j,38)|0;o=223444;p=g+38|0;do{b[g>>0]=b[o>>0]|0;g=g+1|0;o=o+1|0}while((g|0)<(p|0));j$(-215,j,223483,223392,170);d$(j)}}o=f[d>>2]|0;g=f[c+12>>2]|0;p=f[e>>2]|0;if((o>>>0<g>>>0&p>>>0<g>>>0?(g=f[c+8>>2]|0,(f[d+4>>2]|0)>>>0<g>>>0):0)?(q=f[e+4>>2]|0,q>>>0<g>>>0):0){r=p;s=q}else{q=f[c+40>>2]|0;g=f[q+4>>2]|0;t=f[q>>2]|0;q=d+4|0;v=f[q>>2]|0;w=j;f[w>>2]=o;f[w+4>>2]=((o|0)<0)<<31>>31;o=j+8|0;w=o;f[w>>2]=v;f[w+4>>2]=((v|0)<0)<<31>>31;v=e+4|0;w=f[v>>2]|0;x=k;f[x>>2]=p;f[x+4>>2]=((p|0)<0)<<31>>31;p=k+8|0;x=p;f[x>>2]=w;f[x+4>>2]=((w|0)<0)<<31>>31;w=l;f[w>>2]=g;f[w+4>>2]=((g|0)<0)<<31>>31;g=l+8|0;f[g>>2]=t;f[g+4>>2]=((t|0)<0)<<31>>31;t=l8(l,j,k)|0;f[d>>2]=f[j>>2];f[q>>2]=f[o>>2];o=f[k>>2]|0;f[e>>2]=o;e=f[p>>2]|0;f[v>>2]=e;if(t){r=o;s=e}else{f[a>>2]=f[c+16>>2];e=a+16|0;f[a+4>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;y=0;z=0;A=a+8|0;f[A>>2]=y;B=a+12|0;f[B>>2]=z;u=i;return}}e=f[c+4>>2]|0;if((e|0)>0)C=f[(f[c+44>>2]|0)+(e+-1<<2)>>2]|0;else C=0;e=c+48|0;o=f[e>>2]|0;t=f[d>>2]|0;v=r-t|0;p=d+4|0;k=f[p>>2]|0;q=s-k|0;j=v>>31;l=(j^v)-j|0;if(h){h=j&(t^r)^t;f[d>>2]=h;d=(s^k)&j^k;f[p>>2]=d;D=d;E=h;F=C;G=(q^j)-j|0}else{D=k;E=t;F=(j^C)-j|0;G=q}q=c+16|0;c=(f[q>>2]|0)+(Y(D,o)|0)+(Y(E,C)|0)|0;f[a>>2]=c;c=G>>31;E=(c^G)-c|0;G=(c^o)-c|0;c=(E|0)>(l|0);o=(c?E:0)^l;l=(c?o:0)^E;E=(c?l:0)^o;o=(c?G:0)^F;F=(c?o:0)^G;G=(c?F:0)^o;o=E<<1;c=l<<1;if(n){H=E;I=o;J=E-c|0;K=F}else{H=E+l|0;I=o+c|0;J=0;K=F-G|0}f[a+16>>2]=J;f[a+28>>2]=I;f[a+24>>2]=0-c;f[a+36>>2]=K;f[a+32>>2]=G;f[m>>2]=H+1;f[a+4>>2]=f[q>>2];y=f[e>>2]|0;z=C;A=a+8|0;f[A>>2]=y;B=a+12|0;f[B>>2]=z;u=i;return}function n8(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;i=u;u=u+64|0;j=i+40|0;k=i+16|0;l=i;m=i+32|0;f[j>>2]=0;n=j+4|0;f[n>>2]=0;f[j+8>>2]=0;o=+(f[a+4>>2]|0);p[k>>3]=+(f[a>>2]|0);p[k+8>>3]=o;o=+(f[b+4>>2]|0);p[l>>3]=+(f[b>>2]|0);p[l+8>>3]=o;o8(k,l,c,d,e,g,j);g=h+4|0;e=f[g>>2]|0;d=f[h>>2]|0;c=e;if((e|0)==(d|0)|(c|0)==(d|0))q=e;else{e=c+(~((c+-8-d|0)>>>3)<<3)|0;f[g>>2]=e;q=e}e=f[n>>2]|0;c=f[j>>2]|0;l=c;if((e|0)==(c|0)){r=d;s=q;t=l}else{q=m+4|0;d=h+8|0;k=l;b=l;l=c;c=e;e=0;v=-2147483648;w=-2147483648;while(1){x=rNa(+p[k+(e<<4)>>3])|0;f[m>>2]=x;y=rNa(+p[k+(e<<4)+8>>3])|0;f[q>>2]=y;if((x|0)!=(v|0)|(y|0)!=(w|0)){z=f[g>>2]|0;if((z|0)==(f[d>>2]|0)){p8(h,m);A=f[n>>2]|0;B=f[j>>2]|0}else{f[z>>2]=x;f[z+4>>2]=y;f[g>>2]=z+8;A=c;B=l}C=B;D=A;E=B;F=f[m>>2]|0;G=f[q>>2]|0}else{C=l;D=c;E=b;F=v;G=w}e=e+1|0;if(e>>>0>=D-C>>4>>>0)break;else{k=C;b=E;l=C;c=D;v=F;w=G}}r=f[h>>2]|0;s=f[g>>2]|0;t=E}if((s-r|0)==8){q8(h,2,a);H=f[j>>2]|0}else H=t;if(!H){u=i;return}t=f[n>>2]|0;if((t|0)!=(H|0))f[n>>2]=t+(~((t+-16-H|0)>>>4)<<4);PYa(H);u=i;return}function o8(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0;i=u;u=u+32|0;j=i+16|0;k=i;_$(j,49644);l=((c|0)>0?c:0)+359-c|0;m=l-((l>>>0)%360|0)+c|0;c=~m;l=m+((c|0)>-361?c:-361)+360|0;c=m+(((l>>>0)%360|0)-l)|0;l=(d|0)>(e|0);m=l?d:e;o=l?e:d;if((o|0)<0){l=~((e|0)<(d|0)?e:d);d=((o|0)>-360?o:-360)+l+360|0;e=d-((d>>>0)%360|0)|0;q=m+e+360|0;r=e+359-l|0}else{q=m;r=o}if((q|0)>360){o=q+-361|0;m=o-((o>>>0)%360|0)|0;s=q+-360-m|0;t=r+-360-m|0}else{s=q;t=r}r=(s-t|0)>360;q=r?360:s;s=r?0:t;t=(c>>31&360)+c|0;v=+n[49664+(t<<2)>>2];w=+n[49664+(450-t<<2)>>2];t=h+4|0;c=f[t>>2]|0;r=f[h>>2]|0;m=c;if((c|0)==(r|0)|(m|0)==(r|0)){x=c;y=m}else{c=m+(~((m+-16-r|0)>>>4)<<4)|0;f[t>>2]=c;x=c;y=c}c=q+g|0;if((s|0)<(c|0)){m=b+8|0;z=w;w=v;o=a+8|0;l=k+8|0;e=h+8|0;d=y;y=s;while(1){s=(y|0)>(q|0)?q:y;A=(s|0)<0?s+360|0:s;v=+p[b>>3]*+n[49664+(450-A<<2)>>2];B=+p[m>>3]*+n[49664+(A<<2)>>2];C=z*v+ +p[a>>3]-w*B;p[k>>3]=C;D=z*B+(w*v+ +p[o>>3]);p[l>>3]=D;if((d|0)==(f[e>>2]|0))r8(h,k);else{p[d>>3]=C;p[d+8>>3]=D;f[t>>2]=d+16}A=y+g|0;if((A|0)>=(c|0))break;d=f[t>>2]|0;y=A}E=f[h>>2]|0;F=f[t>>2]|0}else{E=r;F=x}if((F-E|0)==16)s8(h,2,a);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function p8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)gXa(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>2;m=k>>3>>>0<268435455?(l>>>0<h>>>0?h:l):536870911;do if(m)if(m>>>0>536870911){l=De(8)|0;UYa(l,358155);f[l>>2]=130560;Of(l|0,21520,875)}else{n=NYa(m<<3)|0;break}else n=0;while(0);l=n+(g<<3)|0;h=n+(m<<3)|0;f[l>>2]=f[b>>2];f[n+(g<<3)+4>>2]=f[b+4>>2];b=l+8|0;if((j|0)==(i|0))o=l;else{g=j+-8-e|0;n=l;m=j;while(1){j=m;m=m+-8|0;f[n+-8>>2]=f[m>>2];f[n+-4>>2]=f[j+-4>>2];if((m|0)==(i|0))break;else n=n+-8|0}o=l+(~(g>>>3)<<3)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;PYa(e);return}function q8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;do if(e-g>>3>>>0>=b>>>0){i=a+4|0;j=f[i>>2]|0;k=j-g>>3;l=k>>>0<b>>>0;m=l?k:b;n=j;if(m|0){j=c+4|0;o=h;p=m;while(1){f[o>>2]=f[c>>2];f[o+4>>2]=f[j>>2];p=p+-1|0;if(!p)break;else o=o+8|0}}if(!l){o=h+(b<<3)|0;if((n|0)==(o|0))return;else{q=i;r=n+(~((n+-8-o|0)>>>3)<<3)|0;break}}else{o=b-k|0;p=c+4|0;j=n;m=o;while(1){f[j>>2]=f[c>>2];f[j+4>>2]=f[p>>2];m=m+-1|0;if(!m)break;else j=j+8|0}q=i;r=n+(o<<3)|0;break}}else{j=g;if(!g)s=e;else{m=a+4|0;p=f[m>>2]|0;if((p|0)!=(h|0))f[m>>2]=p+(~((p+-8-g|0)>>>3)<<3);PYa(j);f[d>>2]=0;f[m>>2]=0;f[a>>2]=0;s=0}if(b>>>0>536870911)gXa(a);m=s>>2;j=s>>3>>>0<268435455?(m>>>0<b>>>0?b:m):536870911;if(j>>>0>536870911)gXa(a);m=NYa(j<<3)|0;p=a+4|0;f[p>>2]=m;f[a>>2]=m;f[d>>2]=m+(j<<3);j=c+4|0;k=m;l=b;while(1){f[k>>2]=f[c>>2];f[k+4>>2]=f[j>>2];l=l+-1|0;if(!l)break;else k=k+8|0}q=p;r=m+(b<<3)|0}while(0);f[q>>2]=r;return}function r8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)gXa(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=De(8)|0;UYa(l,358155);f[l>>2]=130560;Of(l|0,21520,875)}else{n=NYa(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;p[l>>3]=+p[b>>3];p[n+(g<<4)+8>>3]=+p[b+8>>3];b=l+16|0;if((j|0)==(i|0))o=l;else{g=j+-16-e|0;n=l;m=j;while(1){j=m;m=m+-16|0;p[n+-16>>3]=+p[m>>3];p[n+-8>>3]=+p[j+-8>>3];if((m|0)==(i|0))break;else n=n+-16|0}o=l+(~(g>>>4)<<4)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;PYa(e);return}function s8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;do if(e-g>>4>>>0>=b>>>0){i=a+4|0;j=f[i>>2]|0;k=j-g>>4;l=k>>>0<b>>>0;m=l?k:b;n=j;if(m|0){j=c+8|0;o=h;q=m;while(1){p[o>>3]=+p[c>>3];p[o+8>>3]=+p[j>>3];q=q+-1|0;if(!q)break;else o=o+16|0}}if(!l){o=h+(b<<4)|0;if((n|0)==(o|0))return;else{r=i;s=n+(~((n+-16-o|0)>>>4)<<4)|0;break}}else{o=b-k|0;q=c+8|0;j=n;m=o;while(1){p[j>>3]=+p[c>>3];p[j+8>>3]=+p[q>>3];m=m+-1|0;if(!m)break;else j=j+16|0}r=i;s=n+(o<<4)|0;break}}else{j=g;if(!g)t=e;else{m=a+4|0;q=f[m>>2]|0;if((q|0)!=(h|0))f[m>>2]=q+(~((q+-16-g|0)>>>4)<<4);PYa(j);f[d>>2]=0;f[m>>2]=0;f[a>>2]=0;t=0}if(b>>>0>268435455)gXa(a);m=t>>3;j=t>>4>>>0<134217727?(m>>>0<b>>>0?b:m):268435455;if(j>>>0>268435455)gXa(a);m=NYa(j<<4)|0;q=a+4|0;f[q>>2]=m;f[a>>2]=m;f[d>>2]=m+(j<<4);j=c+8|0;k=m;l=b;while(1){p[k>>3]=+p[c>>3];p[k+8>>3]=+p[j>>3];l=l+-1|0;if(!l)break;else k=k+16|0}r=q;s=m+(b<<4)|0}while(0);f[r>>2]=s;return}function t8(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;j=u;u=u+128|0;k=j+120|0;l=j+64|0;m=j+32|0;n=j+16|0;o=j;_$(k,51468);do if((NS(a)|0)==65536){p=f[a+4>>2]|0;f[l>>2]=f[p>>2];q=l+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=l+8|0;f[s>>2]=f[p+8>>2];f[l+12>>2]=f[p+12>>2];f[l+16>>2]=f[p+16>>2];f[l+20>>2]=f[p+20>>2];f[l+24>>2]=f[p+24>>2];f[l+28>>2]=f[p+28>>2];f[l+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[l+36>>2]=t;f[l+40>>2]=s;s=l+48|0;v=l+44|0;f[v>>2]=s;f[s>>2]=0;f[l+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;BR(l,p);break}}else OR(l,a,-1);while(0);if((h|0)==16)w=(f[l>>2]&7|0)==0?16:8;else w=h;if(g>>>0>=32768){f[m>>2]=0;f[m+4>>2]=0;x=c$(m,44)|0;y=223579;z=x+44|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));j$(-215,m,223624,223392,1817);d$(m)}if(i>>>0>=17){f[m>>2]=0;f[m+4>>2]=0;x=c$(m,31)|0;y=223629;z=x+31|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));j$(-215,m,223624,223392,1818);d$(m)}MS(e,m,f[l>>2]&4095,0);e=f[c>>2]|0;y=f[c+4>>2]|0;c=n;f[c>>2]=e;f[c+4>>2]=((e|0)<0)<<31>>31;e=n+8|0;f[e>>2]=y;f[e+4>>2]=((y|0)<0)<<31>>31;y=f[d>>2]|0;e=f[d+4>>2]|0;d=o;f[d>>2]=y;f[d+4>>2]=((y|0)<0)<<31>>31;y=o+8|0;f[y>>2]=e;f[y+4>>2]=((e|0)<0)<<31>>31;u8(l,n,o,m,g,w,3,i);i=l+36|0;w=f[i>>2]|0;if(w|0?(g=w+12|0,w=f[g>>2]|0,f[g>>2]=w+-1,(w|0)==1):0)CR(l);f[i>>2]=0;i=l+16|0;w=l+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[w>>2]|0)>0){i=f[l+40>>2]|0;g=0;do{f[i+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[w>>2]|0))}w=f[l+44>>2]|0;if((w|0)!=(l+48|0))ZF(w);if(!(f[k+4>>2]|0)){u=j;return}u=j;return}function u8(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0;j=u;u=u+176|0;k=j+80|0;l=j+64|0;m=j+48|0;n=j+32|0;o=j+96|0;p=j+160|0;q=j+16|0;r=j;s=16-i|0;t=b;v=R1a(f[t>>2]|0,f[t+4>>2]|0,s|0)|0;t=b;f[t>>2]=v;f[t+4>>2]=J;t=b+8|0;v=t;w=R1a(f[v>>2]|0,f[v+4>>2]|0,s|0)|0;v=t;f[v>>2]=w;f[v+4>>2]=J;v=c;w=R1a(f[v>>2]|0,f[v+4>>2]|0,s|0)|0;v=J;x=c;f[x>>2]=w;f[x+4>>2]=v;x=c+8|0;y=x;z=R1a(f[y>>2]|0,f[y+4>>2]|0,s|0)|0;s=J;y=x;f[y>>2]=z;f[y+4>>2]=s;if((e|0)<2){if((g|0)>=16){y=b;A=f[y+4>>2]|0;B=m;f[B>>2]=f[y>>2];f[B+4>>2]=A;A=t;B=f[A+4>>2]|0;y=m+8|0;f[y>>2]=f[A>>2];f[y+4>>2]=B;B=n;f[B>>2]=w;f[B+4>>2]=v;B=n+8|0;f[B>>2]=z;f[B+4>>2]=s;x8(a,m,n,d);u=j;return}a:do if(i|0){switch(g|0){case 1:case 4:{break a;break}default:{}}n=b;m=f[n+4>>2]|0;B=k;f[B>>2]=f[n>>2];f[B+4>>2]=m;m=t;B=f[m+4>>2]|0;n=k+8|0;f[n>>2]=f[m>>2];f[n+4>>2]=B;B=l;f[B>>2]=w;f[B+4>>2]=v;B=l+8|0;f[B>>2]=z;f[B+4>>2]=s;w8(a,k,l,d);u=j;return}while(0);l=b;k=C1a(f[l>>2]|0,f[l+4>>2]|0,32768,0)|0;l=H1a(k|0,J|0,16)|0;k=b;f[k>>2]=l;f[k+4>>2]=J;k=t;l=C1a(f[k>>2]|0,f[k+4>>2]|0,32768,0)|0;k=H1a(l|0,J|0,16)|0;l=t;f[l>>2]=k;f[l+4>>2]=J;l=c;k=C1a(f[l>>2]|0,f[l+4>>2]|0,32768,0)|0;l=H1a(k|0,J|0,16)|0;k=c;f[k>>2]=l;f[k+4>>2]=J;k=x;i=C1a(f[k>>2]|0,f[k+4>>2]|0,32768,0)|0;k=H1a(i|0,J|0,16)|0;i=x;f[i>>2]=k;f[i+4>>2]=J;v8(a,f[b>>2]|0,f[t>>2]|0,l,k,d,g);u=j;return}k=o;l=k+64|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));k=b;l=f[k>>2]|0;i=f[k+4>>2]|0;k=B1a(l|0,i|0,w|0,v|0)|0;C=(+(k>>>0)+4294967296.0*+(J|0))*.0000152587890625;k=t;B=f[k>>2]|0;n=f[k+4>>2]|0;k=B1a(z|0,s|0,B|0,n|0)|0;D=(+(k>>>0)+4294967296.0*+(J|0))*.0000152587890625;E=C*C+D*D;k=e<<15;if(+L(+E)>2.220446049250313e-16){F=(+(k|0)+ +(e<<16&65536|0)*.5)/+M(+E);e=rNa(D*F)|0;m=((e|0)<0)<<31>>31;y=rNa(C*F)|0;A=((y|0)<0)<<31>>31;G=C1a(e|0,m|0,l|0,i|0)|0;H=o;f[H>>2]=G;f[H+4>>2]=J;H=C1a(B|0,n|0,y|0,A|0)|0;G=o+8|0;f[G>>2]=H;f[G+4>>2]=J;G=B1a(l|0,i|0,e|0,m|0)|0;i=o+16|0;f[i>>2]=G;f[i+4>>2]=J;i=B1a(B|0,n|0,y|0,A|0)|0;n=o+24|0;f[n>>2]=i;f[n+4>>2]=J;n=B1a(w|0,v|0,e|0,m|0)|0;i=o+32|0;f[i>>2]=n;f[i+4>>2]=J;i=B1a(z|0,s|0,y|0,A|0)|0;n=o+40|0;f[n>>2]=i;f[n+4>>2]=J;n=C1a(w|0,v|0,e|0,m|0)|0;m=o+48|0;f[m>>2]=n;f[m+4>>2]=J;m=C1a(z|0,s|0,y|0,A|0)|0;A=o+56|0;f[A>>2]=m;f[A+4>>2]=J;y8(a,o,4,d,g,16)}o=p+4|0;A=k+32768>>16;m=q+8|0;y=((k|0)<0)<<31>>31;s=r+8|0;z=(h&1|0)==0;if((g|0)<16){if(!z){n=b;e=C1a(f[n>>2]|0,f[n+4>>2]|0,32768,0)|0;n=I1a(e|0,J|0,16)|0;e=t;v=C1a(f[e>>2]|0,f[e+4>>2]|0,32768,0)|0;e=I1a(v|0,J|0,16)|0;f[p>>2]=n;f[o>>2]=e;z8(a,p,A,d,1)}e=c;n=f[e>>2]|0;v=f[e+4>>2]|0;e=b;f[e>>2]=n;f[e+4>>2]=v;e=x;w=f[e>>2]|0;i=f[e+4>>2]|0;e=t;f[e>>2]=w;f[e+4>>2]=i;if(h&2|0){e=C1a(n|0,v|0,32768,0)|0;v=I1a(e|0,J|0,16)|0;e=C1a(w|0,i|0,32768,0)|0;i=I1a(e|0,J|0,16)|0;f[p>>2]=v;f[o>>2]=i;z8(a,p,A,d,1)}}else{if(!z){z=b;A=f[z+4>>2]|0;p=q;f[p>>2]=f[z>>2];f[p+4>>2]=A;A=t;p=f[A+4>>2]|0;z=m;f[z>>2]=f[A>>2];f[z+4>>2]=p;p=r;f[p>>2]=k;f[p+4>>2]=y;p=s;f[p>>2]=k;f[p+4>>2]=y;A8(a,q,r,0,0,360,d,-1,g)}p=c;z=f[p>>2]|0;A=f[p+4>>2]|0;p=b;f[p>>2]=z;f[p+4>>2]=A;p=x;i=f[p>>2]|0;o=f[p+4>>2]|0;p=t;f[p>>2]=i;f[p+4>>2]=o;if(h&2|0){h=q;f[h>>2]=z;f[h+4>>2]=A;A=m;f[A>>2]=i;f[A+4>>2]=o;o=r;f[o>>2]=k;f[o+4>>2]=y;o=s;f[o>>2]=k;f[o+4>>2]=y;A8(a,q,r,0,0,360,d,-1,g)}}g=c;c=f[g+4>>2]|0;d=b;f[d>>2]=f[g>>2];f[d+4>>2]=c;c=x;x=f[c+4>>2]|0;d=t;f[d>>2]=f[c>>2];f[d+4>>2]=x;u=j;return}function v8(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=u;u=u+64|0;k=j+16|0;l=j+8|0;m=j;switch(i|0){case 0:{n=8;break}case 1:{n=4;break}default:n=i}f[l>>2]=c;f[l+4>>2]=d;f[m>>2]=e;f[m+4>>2]=g;m8(k,a,l,m,n,1);n=f[k+20>>2]|0;m=f[a+4>>2]|0;if((m|0)>0)o=f[(f[a+44>>2]|0)+(m+-1<<2)>>2]|0;else o=0;if((n|0)<=0){u=j;return}m=k+16|0;a=k+24|0;l=k+28|0;g=k+32|0;e=k+36|0;d=h+1|0;c=h+2|0;switch(o|0){case 1:{i=f[k>>2]|0;p=0;do{b[i>>0]=b[h>>0]|0;p=p+1|0;q=f[m>>2]|0;r=q>>31;f[m>>2]=(f[a>>2]|0)+q+(f[l>>2]&r);i=(f[k>>2]|0)+((f[e>>2]&r)+(f[g>>2]|0))|0;f[k>>2]=i}while((p|0)!=(n|0));u=j;return}case 3:{p=f[k>>2]|0;i=0;do{b[p>>0]=b[h>>0]|0;b[p+1>>0]=b[d>>0]|0;b[p+2>>0]=b[c>>0]|0;i=i+1|0;r=f[m>>2]|0;q=r>>31;f[m>>2]=(f[a>>2]|0)+r+(f[l>>2]&q);p=(f[k>>2]|0)+((f[e>>2]&q)+(f[g>>2]|0))|0;f[k>>2]=p}while((i|0)!=(n|0));u=j;return}default:{i=f[k>>2]|0;p=0;do{K1a(i|0,h|0,o|0)|0;p=p+1|0;c=f[m>>2]|0;d=c>>31;f[m>>2]=(f[a>>2]|0)+c+(f[l>>2]&d);i=(f[k>>2]|0)+((f[e>>2]&d)+(f[g>>2]|0))|0;f[k>>2]=i}while((p|0)!=(n|0));u=j;return}}}function w8(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;g=u;u=u+16|0;h=g;i=b[e>>0]|0;j=b[e+1>>0]|0;k=b[e+2>>0]|0;l=f[a+4>>2]|0;if((l|0)>0)m=f[(f[a+44>>2]|0)+(l+-1<<2)>>2]|0;else m=0;l=f[a+16>>2]|0;n=f[a+48>>2]|0;o=f[a+40>>2]|0;a=f[o+4>>2]|0;p=f[o>>2]|0;o=R1a(a|0,((a|0)<0)<<31>>31|0,16)|0;q=J;r=R1a(p|0,((p|0)<0)<<31>>31|0,16)|0;s=h;f[s>>2]=o;f[s+4>>2]=q;q=h+8|0;f[q>>2]=r;f[q+4>>2]=J;if(!(l8(h,c,d)|0)){u=g;return}h=d;q=f[h>>2]|0;r=f[h+4>>2]|0;h=c;s=f[h>>2]|0;o=f[h+4>>2]|0;h=B1a(q|0,r|0,s|0,o|0)|0;t=J;v=d+8|0;w=v;x=f[w>>2]|0;y=f[w+4>>2]|0;w=c+8|0;z=w;A=f[z>>2]|0;B=f[z+4>>2]|0;z=B1a(x|0,y|0,A|0,B|0)|0;C=J;D=H1a(h|0,t|0,63)|0;E=J;F=B1a(D^h|0,E^t|0,D|0,E|0)|0;G=J;H=H1a(z|0,C|0,63)|0;I=J;K=B1a(H^z|0,I^C|0,H|0,I|0)|0;L=J;M=(G|0)>(L|0)|(G|0)==(L|0)&F>>>0>K>>>0;if(M){N=B1a(z^D|0,C^E|0,D|0,E|0)|0;C=D&q^s;z=E&r^o;O=c;f[O>>2]=C;f[O+4>>2]=z;O=d;P=f[O>>2]^C&D;C=f[O+4>>2]^z&E;z=d;f[z>>2]=P;f[z+4>>2]=C;z=c;O=f[z>>2]^P&D;P=f[z+4>>2]^C&E;C=c;f[C>>2]=O;f[C+4>>2]=P;C=D&x^A;z=E&y^B;Q=w;f[Q>>2]=C;f[Q+4>>2]=z;Q=v;R=f[Q>>2]^C&D;C=f[Q+4>>2]^z&E;z=v;f[z>>2]=R;f[z+4>>2]=C;z=w;Q=f[z>>2]^R&D;D=f[z+4>>2]^C&E;E=w;f[E>>2]=Q;f[E+4>>2]=D;E=R1a(N|0,J|0,16)|0;N=S1a(E|0,J|0,F|1|0,G|0)|0;S=d;T=O;U=P;V=O;W=P;X=Q;Z=D;_=N;$=J;aa=65536;ba=0}else{N=B1a(H^h|0,I^t|0,H|0,I|0)|0;t=H&q^s;s=I&r^o;o=c;f[o>>2]=t;f[o+4>>2]=s;o=d;r=f[o>>2]^t&H;t=f[o+4>>2]^s&I;s=d;f[s>>2]=r;f[s+4>>2]=t;s=c;o=f[s>>2]^r&H;r=f[s+4>>2]^t&I;t=c;f[t>>2]=o;f[t+4>>2]=r;t=A^x&H;x=B^y&I;y=w;f[y>>2]=t;f[y+4>>2]=x;y=v;B=f[y>>2]^t&H;t=f[y+4>>2]^x&I;x=v;f[x>>2]=B;f[x+4>>2]=t;x=w;y=f[x>>2]^B&H;H=f[x+4>>2]^t&I;I=w;f[I>>2]=y;f[I+4>>2]=H;I=R1a(N|0,J|0,16)|0;N=S1a(I|0,J|0,K|1|0,L|0)|0;S=v;T=y;U=H;V=o;W=r;X=y;Z=H;_=65536;$=0;aa=N;ba=J}N=S;S=B1a(f[N>>2]|0,f[N+4>>2]|0,T|0,U|0)|0;U=I1a(S|0,J|0,16)|0;S=C1a(V|0,W|0,32768,0)|0;W=c;f[W>>2]=S;f[W+4>>2]=J;W=C1a(X|0,Z|0,32768,0)|0;Z=w;f[Z>>2]=W;f[Z+4>>2]=J;Z=d;d=v;v=f[d>>2]|0;W=f[d+4>>2]|0;d=C1a(f[Z>>2]|0,f[Z+4>>2]|0,32768,0)|0;Z=J;X=C1a(v|0,W|0,32768,0)|0;W=I1a(X|0,J|0,16)|0;X=I1a(d|0,Z|0,16)|0;Z=(X|0)>-1;switch(m|0){case 3:{if(Z?(d=l+(Y(W,n)|0)+(X*3|0)|0,(W|0)<(p|0)&((X|0)<(a|0)&(W|0)>-1)):0){b[d>>0]=i;b[d+1>>0]=j;b[d+2>>0]=k}if(M){d=c;v=H1a(f[d>>2]|0,f[d+4>>2]|0,16)|0;d=J;S=c;f[S>>2]=v;f[S+4>>2]=d;if((U|0)<=-1){u=g;return}S=w;V=f[S>>2]|0;T=f[S+4>>2]|0;S=v;v=d;d=U;while(1){N=I1a(V|0,T|0,16)|0;if((S|0)>-1?(H=l+(Y(N,n)|0)+(S*3|0)|0,(N|0)<(p|0)&((S|0)<(a|0)&(N|0)>-1)):0){b[H>>0]=i;b[H+1>>0]=j;b[H+2>>0]=k;H=c;N=w;ca=f[H>>2]|0;da=f[H+4>>2]|0;ea=f[N>>2]|0;fa=f[N+4>>2]|0}else{ca=S;da=v;ea=V;fa=T}S=C1a(ca|0,da|0,1,0)|0;v=J;N=c;f[N>>2]=S;f[N+4>>2]=v;V=C1a(ea|0,fa|0,_|0,$|0)|0;T=J;N=w;f[N>>2]=V;f[N+4>>2]=T;if((d|0)<=0)break;else d=d+-1|0}u=g;return}else{d=w;T=H1a(f[d>>2]|0,f[d+4>>2]|0,16)|0;d=J;V=w;f[V>>2]=T;f[V+4>>2]=d;if((U|0)<=-1){u=g;return}V=c;fa=f[V>>2]|0;ea=f[V+4>>2]|0;V=T;T=d;d=U;while(1){v=I1a(fa|0,ea|0,16)|0;if((v|0)>-1?(S=l+(Y(V,n)|0)+(v*3|0)|0,(V|0)<(p|0)&((v|0)<(a|0)&(V|0)>-1)):0){b[S>>0]=i;b[S+1>>0]=j;b[S+2>>0]=k;S=c;v=w;ga=f[S>>2]|0;ha=f[S+4>>2]|0;ia=f[v>>2]|0;ja=f[v+4>>2]|0}else{ga=fa;ha=ea;ia=V;ja=T}fa=C1a(ga|0,ha|0,aa|0,ba|0)|0;ea=J;v=c;f[v>>2]=fa;f[v+4>>2]=ea;V=C1a(ia|0,ja|0,1,0)|0;T=J;v=w;f[v>>2]=V;f[v+4>>2]=T;if((d|0)<=0)break;else d=d+-1|0}u=g;return}break}case 1:{if(Z?(W|0)<(p|0)&((X|0)<(a|0)&(W|0)>-1):0){d=l+(Y(W,n)|0)+X|0;b[d>>0]=i}if(M){d=c;T=H1a(f[d>>2]|0,f[d+4>>2]|0,16)|0;d=J;V=c;f[V>>2]=T;f[V+4>>2]=d;if((U|0)<=-1){u=g;return}V=w;ja=f[V>>2]|0;ia=f[V+4>>2]|0;V=T;T=d;d=U;while(1){ea=I1a(ja|0,ia|0,16)|0;if((V|0)>-1?(ea|0)<(p|0)&((V|0)<(a|0)&(ea|0)>-1):0){fa=l+(Y(ea,n)|0)+V|0;b[fa>>0]=i;fa=c;ea=w;ka=f[fa>>2]|0;la=f[fa+4>>2]|0;ma=f[ea>>2]|0;na=f[ea+4>>2]|0}else{ka=V;la=T;ma=ja;na=ia}V=C1a(ka|0,la|0,1,0)|0;T=J;ea=c;f[ea>>2]=V;f[ea+4>>2]=T;ja=C1a(ma|0,na|0,_|0,$|0)|0;ia=J;ea=w;f[ea>>2]=ja;f[ea+4>>2]=ia;if((d|0)<=0)break;else d=d+-1|0}u=g;return}else{d=w;ia=H1a(f[d>>2]|0,f[d+4>>2]|0,16)|0;d=J;ja=w;f[ja>>2]=ia;f[ja+4>>2]=d;if((U|0)<=-1){u=g;return}ja=c;na=f[ja>>2]|0;ma=f[ja+4>>2]|0;ja=ia;ia=d;d=U;while(1){T=I1a(na|0,ma|0,16)|0;if((T|0)>-1?(ja|0)<(p|0)&((T|0)<(a|0)&(ja|0)>-1):0){V=l+(Y(ja,n)|0)+T|0;b[V>>0]=i;V=c;T=w;oa=f[V>>2]|0;pa=f[V+4>>2]|0;qa=f[T>>2]|0;ra=f[T+4>>2]|0}else{oa=na;pa=ma;qa=ja;ra=ia}na=C1a(oa|0,pa|0,aa|0,ba|0)|0;ma=J;T=c;f[T>>2]=na;f[T+4>>2]=ma;ja=C1a(qa|0,ra|0,1,0)|0;ia=J;T=w;f[T>>2]=ja;f[T+4>>2]=ia;if((d|0)<=0)break;else d=d+-1|0}u=g;return}break}default:{if((Z?(W|0)<(p|0)&((X|0)<(a|0)&(W|0)>-1):0)?(Z=l+(Y(W,n)|0)+(Y(X,m)|0)|0,X=((m|0)<0)<<31>>31,(m|0)>0):0){W=0;d=0;do{b[Z+W>>0]=b[e+W>>0]|0;W=C1a(W|0,d|0,1,0)|0;d=J}while((d|0)<(X|0)|(d|0)==(X|0)&W>>>0<m>>>0)}if(M){M=c;W=H1a(f[M>>2]|0,f[M+4>>2]|0,16)|0;M=J;X=c;f[X>>2]=W;f[X+4>>2]=M;if((U|0)<=-1){u=g;return}X=((m|0)<0)<<31>>31;d=w;Z=f[d>>2]|0;ia=f[d+4>>2]|0;if((m|0)>0){sa=Z;ta=ia;ua=W;va=M;wa=U}else{d=W;W=M;M=Z;Z=ia;ia=U;while(1){d=C1a(d|0,W|0,1,0)|0;W=J;M=C1a(M|0,Z|0,_|0,$|0)|0;Z=J;if((ia|0)<=0)break;else ia=ia+-1|0}ia=c;f[ia>>2]=d;f[ia+4>>2]=W;W=w;f[W>>2]=M;f[W+4>>2]=Z;u=g;return}while(1){Z=I1a(sa|0,ta|0,16)|0;if((ua|0)>-1?(Z|0)<(p|0)&((ua|0)<(a|0)&(Z|0)>-1):0){W=l+(Y(Z,n)|0)+(Y(ua,m)|0)|0;Z=0;M=0;do{b[W+Z>>0]=b[e+Z>>0]|0;Z=C1a(Z|0,M|0,1,0)|0;M=J}while((M|0)<(X|0)|(M|0)==(X|0)&Z>>>0<m>>>0);Z=c;M=w;xa=f[Z>>2]|0;ya=f[Z+4>>2]|0;za=f[M>>2]|0;Aa=f[M+4>>2]|0}else{xa=ua;ya=va;za=sa;Aa=ta}ua=C1a(xa|0,ya|0,1,0)|0;va=J;M=c;f[M>>2]=ua;f[M+4>>2]=va;sa=C1a(za|0,Aa|0,_|0,$|0)|0;ta=J;M=w;f[M>>2]=sa;f[M+4>>2]=ta;if((wa|0)<=0)break;else wa=wa+-1|0}u=g;return}else{wa=w;ta=H1a(f[wa>>2]|0,f[wa+4>>2]|0,16)|0;wa=J;sa=w;f[sa>>2]=ta;f[sa+4>>2]=wa;if((U|0)<=-1){u=g;return}sa=((m|0)<0)<<31>>31;$=c;_=f[$>>2]|0;Aa=f[$+4>>2]|0;if((m|0)>0){Ba=_;Ca=Aa;Da=ta;Ea=wa;Fa=U}else{$=_;_=Aa;Aa=ta;ta=wa;wa=U;while(1){$=C1a($|0,_|0,aa|0,ba|0)|0;_=J;Aa=C1a(Aa|0,ta|0,1,0)|0;ta=J;if((wa|0)<=0)break;else wa=wa+-1|0}wa=c;f[wa>>2]=$;f[wa+4>>2]=_;_=w;f[_>>2]=Aa;f[_+4>>2]=ta;u=g;return}while(1){ta=I1a(Ba|0,Ca|0,16)|0;if((ta|0)>-1?(Da|0)<(p|0)&((ta|0)<(a|0)&(Da|0)>-1):0){_=l+(Y(Da,n)|0)+(Y(ta,m)|0)|0;ta=0;Aa=0;do{b[_+ta>>0]=b[e+ta>>0]|0;ta=C1a(ta|0,Aa|0,1,0)|0;Aa=J}while((Aa|0)<(sa|0)|(Aa|0)==(sa|0)&ta>>>0<m>>>0);ta=c;Aa=w;Ga=f[ta>>2]|0;Ha=f[ta+4>>2]|0;Ia=f[Aa>>2]|0;Ja=f[Aa+4>>2]|0}else{Ga=Ba;Ha=Ca;Ia=Da;Ja=Ea}Ba=C1a(Ga|0,Ha|0,aa|0,ba|0)|0;Ca=J;Aa=c;f[Aa>>2]=Ba;f[Aa+4>>2]=Ca;Da=C1a(Ia|0,Ja|0,1,0)|0;Ea=J;Aa=w;f[Aa>>2]=Da;f[Aa+4>>2]=Ea;if((Fa|0)<=0)break;else Fa=Fa+-1|0}u=g;return}}}}
function bN(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=u;u=u+1296|0;g=e+1280|0;h=e+1224|0;i=e+1168|0;j=e+128|0;k=e+72|0;l=e+16|0;m=e;_$(g,38980);do if((NS(a)|0)==65536){n=f[a+4>>2]|0;f[h>>2]=f[n>>2];o=h+4|0;p=n+4|0;f[o>>2]=f[p>>2];q=h+8|0;f[q>>2]=f[n+8>>2];r=h+12|0;f[r>>2]=f[n+12>>2];f[h+16>>2]=f[n+16>>2];f[h+20>>2]=f[n+20>>2];f[h+24>>2]=f[n+24>>2];f[h+28>>2]=f[n+28>>2];f[h+32>>2]=f[n+32>>2];s=f[n+36>>2]|0;f[h+36>>2]=s;f[h+40>>2]=q;t=h+48|0;v=h+44|0;f[v>>2]=t;f[t>>2]=0;f[h+52>>2]=0;if(s|0){t=s+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[p>>2]|0)<3){p=f[n+44>>2]|0;t=f[v>>2]|0;f[t>>2]=f[p>>2];f[t+4>>2]=f[p+4>>2];w=r;x=h;y=q;break}else{f[o>>2]=0;BR(h,n);w=r;x=h;y=q;break}}else{OR(h,a,-1);w=h+12|0;x=h;y=h+8|0}while(0);a=f[x>>2]&4095;x=f[y>>2]|0;if((x|0)!=(f[w>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;z=c$(i,20)|0;A=164311;B=z+20|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-215,i,164332,164068,1389);d$(i)}w=(a|0)==5;if((a+-5|0)>>>0>=2){f[i>>2]=0;f[i+4>>2]=0;z=c$(i,22)|0;A=164225;B=z+22|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-215,i,164332,164068,1390);d$(i)}f[i>>2]=1124007936;A=i+4|0;y=i+8|0;q=i+40|0;z=A;B=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(B|0));f[q>>2]=y;z=i+48|0;B=i+44|0;f[B>>2]=z;f[z>>2]=0;f[i+52>>2]=0;if(dT(d)|0){pS(d,x,x,a,-1,0,0);do if((NS(d)|0)==65536){r=f[d+4>>2]|0;f[j>>2]=f[r>>2];n=j+4|0;o=r+4|0;f[n>>2]=f[o>>2];p=j+8|0;f[p>>2]=f[r+8>>2];f[j+12>>2]=f[r+12>>2];f[j+16>>2]=f[r+16>>2];f[j+20>>2]=f[r+20>>2];f[j+24>>2]=f[r+24>>2];f[j+28>>2]=f[r+28>>2];f[j+32>>2]=f[r+32>>2];t=j+36|0;v=f[r+36>>2]|0;f[t>>2]=v;f[j+40>>2]=p;p=j+48|0;s=j+44|0;f[s>>2]=p;f[p>>2]=0;f[j+52>>2]=0;if(v|0){p=v+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[r+44>>2]|0;p=f[s>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];C=t;break}else{f[n>>2]=0;BR(j,r);C=t;break}}else{OR(j,d,-1);C=j+36|0}while(0);d=f[C>>2]|0;if(d|0){t=d+12|0;f[t>>2]=(f[t>>2]|0)+1}t=i+36|0;d=f[t>>2]|0;if(d|0?(r=d+12|0,d=f[r>>2]|0,f[r>>2]=d+-1,(d|0)==1):0)CR(i);f[t>>2]=0;d=i+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[A>>2]|0)>0){r=f[q>>2]|0;n=0;do{f[r+(n<<2)>>2]=0;n=n+1|0;D=f[A>>2]|0}while((n|0)<(D|0));f[i>>2]=f[j>>2];if((D|0)<3)E=30;else E=32}else{f[i>>2]=f[j>>2];E=30}if((E|0)==30){D=f[j+4>>2]|0;if((D|0)<3){f[A>>2]=D;f[y>>2]=f[j+8>>2];f[i+12>>2]=f[j+12>>2];y=f[j+44>>2]|0;D=f[B>>2]|0;f[D>>2]=f[y>>2];f[D+4>>2]=f[y+4>>2]}else E=32}if((E|0)==32)BR(i,j);E=j+16|0;f[d>>2]=f[E>>2];f[i+20>>2]=f[j+20>>2];f[i+24>>2]=f[j+24>>2];f[i+28>>2]=f[j+28>>2];f[i+32>>2]=f[j+32>>2];d=f[C>>2]|0;f[t>>2]=d;if(d|0?(t=d+12|0,d=f[t>>2]|0,f[t>>2]=d+-1,(d|0)==1):0)CR(j);f[C>>2]=0;C=j+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[C>>2]|0)>0){E=f[j+40>>2]|0;d=0;do{f[E+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[C>>2]|0))}C=f[j+44>>2]|0;if((C|0)!=(j+48|0))ZF(C)}C=h+4|0;d=f[C>>2]|0;if((d|0)>0)F=f[(f[h+44>>2]|0)+(d+-1<<2)>>2]|0;else F=0;d=Y(F,x)|0;E=d+15&-16;t=Y(E,x)|0;y=(Y(x*5|0,F)|0)+32+t|0;F=j+8|0;f[j>>2]=F;D=j+4|0;f[D>>2]=y;if(y>>>0>1032){n=OYa(y)|0;f[j>>2]=n;G=n}else G=F;n=G+15&-16;$i(k,x,x,a,n,E);$i(l,x,1,a,n+t|0,0);a=n+(t+d)|0;d=m+8|0;f[d>>2]=0;f[d+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=k;eL(h,m);m=k+16|0;d=f[m>>2]|0;if(w)H=cN(d,f[k+48>>2]|0,f[l+16>>2]|0,f[i+16>>2]|0,f[z>>2]|0,x,a)|0;else H=dN(d,f[k+48>>2]|0,f[l+16>>2]|0,f[i+16>>2]|0,f[z>>2]|0,x,a)|0;eL(l,c);c=l+36|0;a=f[c>>2]|0;if(a|0?(x=a+12|0,a=f[x>>2]|0,f[x>>2]=a+-1,(a|0)==1):0)CR(l);f[c>>2]=0;c=l+16|0;a=l+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[l+40>>2]|0;x=0;do{f[c+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[a>>2]|0))}a=f[l+44>>2]|0;if((a|0)!=(l+48|0))ZF(a);a=k+36|0;l=f[a>>2]|0;if(l|0?(x=l+12|0,l=f[x>>2]|0,f[x>>2]=l+-1,(l|0)==1):0)CR(k);f[a>>2]=0;a=k+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[a>>2]|0)>0){m=f[k+40>>2]|0;l=0;do{f[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[a>>2]|0))}a=f[k+44>>2]|0;if((a|0)!=(k+48|0))ZF(a);a=f[j>>2]|0;if((a|0)!=(F|0)){if(a|0)QYa(a);f[j>>2]=F;f[D>>2]=1032}D=i+36|0;F=f[D>>2]|0;if(F|0?(j=F+12|0,F=f[j>>2]|0,f[j>>2]=F+-1,(F|0)==1):0)CR(i);f[D>>2]=0;D=i+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[A>>2]|0)>0){D=f[q>>2]|0;q=0;do{f[D+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[A>>2]|0))}A=f[B>>2]|0;if((A|0)!=(z|0))ZF(A);A=h+36|0;z=f[A>>2]|0;if(z|0?(B=z+12|0,z=f[B>>2]|0,f[B>>2]=z+-1,(z|0)==1):0)CR(h);f[A>>2]=0;A=h+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[C>>2]|0)>0){A=f[h+40>>2]|0;z=0;do{f[A+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[C>>2]|0))}C=f[h+44>>2]|0;if((C|0)!=(h+48|0))ZF(C);if(!(f[g+4>>2]|0)){u=e;return H|0}u=e;return H|0}function cN(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;i=b>>>2;b=(d|0)!=0;if(b){j=e>>>2;if((g|0)>0){k=g<<2;l=0;do{m=Y(j,l)|0;F1a(d+(m<<2)|0,0,k|0)|0;n[d+(m+l<<2)>>2]=1.0;l=l+1|0}while((l|0)!=(g|0));o=j}else o=j}else o=e;e=Y(g*30|0,g)|0;j=h+3&-4;h=j+(g<<2)|0;if((g|0)<=0)return 1;l=i+1|0;k=g+-1|0;m=0;do{p=a+((Y(m,l)|0)<<2)|0;f[c+(m<<2)>>2]=f[p>>2];if((m|0)<(k|0)){p=m+1|0;q=Y(m,i)|0;r=m+2|0;if((r|0)<(g|0)){s=r;r=p;t=+L(+(+n[a+(q+p<<2)>>2]));while(1){u=+L(+(+n[a+(s+q<<2)>>2]));v=t<u;w=v?s:r;s=s+1|0;if((s|0)==(g|0)){x=w;break}else{r=w;t=v?u:t}}}else x=p;f[j+(m<<2)>>2]=x}if((m|0)>0){if((m|0)==1)y=0;else{r=1;s=0;t=+L(+(+n[a+(m<<2)>>2]));while(1){q=a+((Y(r,i)|0)+m<<2)|0;u=+L(+(+n[q>>2]));q=t<u;v=q?r:s;r=r+1|0;if((r|0)>=(m|0)){y=v;break}else{s=v;t=q?u:t}}}f[h+(m<<2)>>2]=y}m=m+1|0}while((m|0)!=(g|0));m=(g|0)>1;y=g+-1|0;if(m&(e|0)>0){x=(y|0)>1;k=(g|0)<1|b^1;l=0;do{s=f[j>>2]|0;t=+L(+(+n[a+(s<<2)>>2]));if(x){r=1;p=0;u=t;do{q=Y(r,i)|0;z=+L(+(+n[a+((f[j+(r<<2)>>2]|0)+q<<2)>>2]));q=u<z;u=q?z:u;p=q?r:p;r=r+1|0}while((r|0)!=(y|0));A=1;B=p;C=f[j+(p<<2)>>2]|0;D=u}else{A=1;B=0;C=s;D=t}while(1){r=f[h+(A<<2)>>2]|0;q=a+((Y(r,i)|0)+A<<2)|0;z=+L(+(+n[q>>2]));q=D<z;C=q?A:C;B=q?r:B;A=A+1|0;if((A|0)==(g|0))break;else D=q?z:D}s=Y(B,i)|0;p=a+(s+C<<2)|0;t=+n[p>>2];u=+L(+t);if(u<=1.1920928955078125e-07)break;q=c+(C<<2)|0;r=c+(B<<2)|0;z=(+n[q>>2]-+n[r>>2])*.5;E=+L(+z);if(!(u>E))if(z!=z|0.0!=0.0|z==0.0)F=0.0;else{G=u/E;H=E;I=G*G;J=38}else{G=E/u;H=u;I=G*G;J=38}if((J|0)==38){J=0;F=H*+M(+(I+1.0))}G=E+F;E=+L(+G);if(!(u>E))if(G!=G|0.0!=0.0|G==0.0)K=0.0;else{N=u/E;O=E;P=N*N;J=43}else{N=E/u;O=u;P=N*N;J=43}if((J|0)==43){J=0;K=O*+M(+(P+1.0))}N=G/K;u=t/K;E=t*(t/G);v=z<0.0;z=v?-E:E;E=v?-u:u;n[p>>2]=0.0;n[r>>2]=+n[r>>2]-z;n[q>>2]=z+ +n[q>>2];q=(B|0)>0;if(q){r=0;do{p=Y(r,i)|0;v=a+(p+B<<2)|0;z=+n[v>>2];w=a+(p+C<<2)|0;u=+n[w>>2];n[v>>2]=N*z-E*u;n[w>>2]=E*z+N*u;r=r+1|0}while((r|0)!=(B|0))}r=B+1|0;if((r|0)<(C|0)){w=r;do{v=a+(w+s<<2)|0;u=+n[v>>2];p=a+((Y(w,i)|0)+C<<2)|0;z=+n[p>>2];n[v>>2]=N*u-E*z;n[p>>2]=E*u+N*z;w=w+1|0}while((w|0)!=(C|0))}w=C+1|0;if((w|0)<(g|0)){p=Y(C,i)|0;v=w;do{Q=a+(v+s<<2)|0;z=+n[Q>>2];R=a+(v+p<<2)|0;u=+n[R>>2];n[Q>>2]=N*z-E*u;n[R>>2]=E*z+N*u;v=v+1|0}while((v|0)!=(g|0))}if(!k){v=Y(B,o)|0;p=Y(C,o)|0;R=0;do{Q=d+(R+v<<2)|0;u=+n[Q>>2];S=d+(R+p<<2)|0;z=+n[S>>2];n[Q>>2]=N*u-E*z;n[S>>2]=E*u+N*z;R=R+1|0}while((R|0)!=(g|0))}if((B|0)<(y|0)){R=B+2|0;if((R|0)<(g|0)){p=R;R=r;N=+L(+(+n[a+(s+r<<2)>>2]));while(1){E=+L(+(+n[a+(p+s<<2)>>2]));v=N<E;S=v?p:R;p=p+1|0;if((p|0)==(g|0)){T=S;break}else{R=S;N=v?E:N}}}else T=r;f[j+(B<<2)>>2]=T}if(q){if((B|0)==1)U=0;else{R=1;p=0;N=+L(+(+n[a+(B<<2)>>2]));while(1){s=a+((Y(R,i)|0)+B<<2)|0;E=+L(+(+n[s>>2]));s=N<E;v=s?R:p;R=R+1|0;if((R|0)>=(B|0)){U=v;break}else{p=v;N=s?E:N}}}f[h+(B<<2)>>2]=U}if((C|0)<(y|0)){p=Y(C,i)|0;R=C+2|0;if((R|0)<(g|0)){q=R;R=w;N=+L(+(+n[a+(p+w<<2)>>2]));while(1){E=+L(+(+n[a+(q+p<<2)>>2]));r=N<E;s=r?q:R;q=q+1|0;if((q|0)==(g|0)){V=s;break}else{R=s;N=r?E:N}}}else V=w;f[j+(C<<2)>>2]=V}if((C|0)>0){if((C|0)==1)W=0;else{R=1;q=0;N=+L(+(+n[a+(C<<2)>>2]));while(1){p=a+((Y(R,i)|0)+C<<2)|0;E=+L(+(+n[p>>2]));p=N<E;r=p?R:q;R=R+1|0;if((R|0)>=(C|0)){W=r;break}else{q=r;N=p?E:N}}}f[h+(C<<2)>>2]=W}l=l+1|0}while((l|0)<(e|0));if(!m)return 1}else if(!m)return 1;if(b)X=0;else{b=0;do{m=b;b=b+1|0;if((b|0)<(g|0)){e=b;l=m;while(1){W=+n[c+(l<<2)>>2]<+n[c+(e<<2)>>2]?e:l;e=e+1|0;if((e|0)==(g|0)){Z=W;break}else l=W}}else Z=m;if((m|0)!=(Z|0)){l=c+(Z<<2)|0;e=c+(m<<2)|0;W=f[l>>2]|0;f[l>>2]=f[e>>2];f[e>>2]=W}}while((b|0)!=(y|0));return 1}do{b=X;X=X+1|0;if((X|0)<(g|0)){Z=X;W=b;while(1){e=+n[c+(W<<2)>>2]<+n[c+(Z<<2)>>2]?Z:W;Z=Z+1|0;if((Z|0)==(g|0)){_=e;break}else W=e}}else _=b;if((b|0)!=(_|0)){W=c+(_<<2)|0;Z=c+(b<<2)|0;m=f[W>>2]|0;f[W>>2]=f[Z>>2];f[Z>>2]=m;m=Y(_,o)|0;Z=Y(b,o)|0;W=0;do{e=d+(W+m<<2)|0;l=d+(W+Z<<2)|0;C=f[e>>2]|0;f[e>>2]=f[l>>2];f[l>>2]=C;W=W+1|0}while((W|0)!=(g|0))}}while((X|0)!=(y|0));return 1}function dN(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;i=b>>>3;b=(d|0)!=0;if(b){j=e>>>3;if((g|0)>0){k=g<<3;l=0;do{m=Y(j,l)|0;F1a(d+(m<<3)|0,0,k|0)|0;p[d+(m+l<<3)>>3]=1.0;l=l+1|0}while((l|0)!=(g|0));n=j}else n=j}else n=e;e=Y(g*30|0,g)|0;j=h+3&-4;h=j+(g<<2)|0;if((g|0)<=0)return 1;l=i+1|0;k=g+-1|0;m=0;do{o=a+((Y(m,l)|0)<<3)|0;p[c+(m<<3)>>3]=+p[o>>3];if((m|0)<(k|0)){o=m+1|0;q=Y(m,i)|0;r=m+2|0;if((r|0)<(g|0)){s=r;r=o;t=+L(+(+p[a+(q+o<<3)>>3]));while(1){u=+L(+(+p[a+(s+q<<3)>>3]));v=t<u;w=v?s:r;s=s+1|0;if((s|0)==(g|0)){x=w;break}else{r=w;t=v?u:t}}}else x=o;f[j+(m<<2)>>2]=x}if((m|0)>0){if((m|0)==1)y=0;else{r=1;s=0;t=+L(+(+p[a+(m<<3)>>3]));while(1){q=a+((Y(r,i)|0)+m<<3)|0;u=+L(+(+p[q>>3]));q=t<u;v=q?r:s;r=r+1|0;if((r|0)>=(m|0)){y=v;break}else{s=v;t=q?u:t}}}f[h+(m<<2)>>2]=y}m=m+1|0}while((m|0)!=(g|0));m=(g|0)>1;y=g+-1|0;if(m&(e|0)>0){x=(y|0)>1;k=(g|0)<1|b^1;l=0;do{s=f[j>>2]|0;t=+L(+(+p[a+(s<<3)>>3]));if(x){r=1;o=0;u=t;do{q=Y(r,i)|0;z=+L(+(+p[a+((f[j+(r<<2)>>2]|0)+q<<3)>>3]));q=u<z;u=q?z:u;o=q?r:o;r=r+1|0}while((r|0)!=(y|0));A=1;B=o;C=f[j+(o<<2)>>2]|0;D=u}else{A=1;B=0;C=s;D=t}while(1){r=f[h+(A<<2)>>2]|0;q=a+((Y(r,i)|0)+A<<3)|0;z=+L(+(+p[q>>3]));q=D<z;C=q?A:C;B=q?r:B;A=A+1|0;if((A|0)==(g|0))break;else D=q?z:D}s=Y(B,i)|0;o=a+(s+C<<3)|0;t=+p[o>>3];u=+L(+t);if(u<=2.220446049250313e-16)break;q=c+(C<<3)|0;r=c+(B<<3)|0;z=(+p[q>>3]-+p[r>>3])*.5;E=+L(+z);if(!(u>E))if(z!=z|0.0!=0.0|z==0.0)F=0.0;else{G=u/E;H=E;I=G*G;J=38}else{G=E/u;H=u;I=G*G;J=38}if((J|0)==38){J=0;F=H*+M(+(I+1.0))}G=E+F;E=+L(+G);if(!(u>E))if(G!=G|0.0!=0.0|G==0.0)K=0.0;else{N=u/E;O=E;P=N*N;J=43}else{N=E/u;O=u;P=N*N;J=43}if((J|0)==43){J=0;K=O*+M(+(P+1.0))}N=G/K;u=t/K;E=t*(t/G);v=z<0.0;z=v?-E:E;E=v?-u:u;p[o>>3]=0.0;p[r>>3]=+p[r>>3]-z;p[q>>3]=z+ +p[q>>3];q=(B|0)>0;if(q){r=0;do{o=Y(r,i)|0;v=a+(o+B<<3)|0;z=+p[v>>3];w=a+(o+C<<3)|0;u=+p[w>>3];p[v>>3]=N*z-E*u;p[w>>3]=E*z+N*u;r=r+1|0}while((r|0)!=(B|0))}r=B+1|0;if((r|0)<(C|0)){w=r;do{v=a+(w+s<<3)|0;u=+p[v>>3];o=a+((Y(w,i)|0)+C<<3)|0;z=+p[o>>3];p[v>>3]=N*u-E*z;p[o>>3]=E*u+N*z;w=w+1|0}while((w|0)!=(C|0))}w=C+1|0;if((w|0)<(g|0)){o=Y(C,i)|0;v=w;do{Q=a+(v+s<<3)|0;z=+p[Q>>3];R=a+(v+o<<3)|0;u=+p[R>>3];p[Q>>3]=N*z-E*u;p[R>>3]=E*z+N*u;v=v+1|0}while((v|0)!=(g|0))}if(!k){v=Y(B,n)|0;o=Y(C,n)|0;R=0;do{Q=d+(R+v<<3)|0;u=+p[Q>>3];S=d+(R+o<<3)|0;z=+p[S>>3];p[Q>>3]=N*u-E*z;p[S>>3]=E*u+N*z;R=R+1|0}while((R|0)!=(g|0))}if((B|0)<(y|0)){R=B+2|0;if((R|0)<(g|0)){o=R;R=r;N=+L(+(+p[a+(s+r<<3)>>3]));while(1){E=+L(+(+p[a+(o+s<<3)>>3]));v=N<E;S=v?o:R;o=o+1|0;if((o|0)==(g|0)){T=S;break}else{R=S;N=v?E:N}}}else T=r;f[j+(B<<2)>>2]=T}if(q){if((B|0)==1)U=0;else{R=1;o=0;N=+L(+(+p[a+(B<<3)>>3]));while(1){s=a+((Y(R,i)|0)+B<<3)|0;E=+L(+(+p[s>>3]));s=N<E;v=s?R:o;R=R+1|0;if((R|0)>=(B|0)){U=v;break}else{o=v;N=s?E:N}}}f[h+(B<<2)>>2]=U}if((C|0)<(y|0)){o=Y(C,i)|0;R=C+2|0;if((R|0)<(g|0)){q=R;R=w;N=+L(+(+p[a+(o+w<<3)>>3]));while(1){E=+L(+(+p[a+(q+o<<3)>>3]));r=N<E;s=r?q:R;q=q+1|0;if((q|0)==(g|0)){V=s;break}else{R=s;N=r?E:N}}}else V=w;f[j+(C<<2)>>2]=V}if((C|0)>0){if((C|0)==1)W=0;else{R=1;q=0;N=+L(+(+p[a+(C<<3)>>3]));while(1){o=a+((Y(R,i)|0)+C<<3)|0;E=+L(+(+p[o>>3]));o=N<E;r=o?R:q;R=R+1|0;if((R|0)>=(C|0)){W=r;break}else{q=r;N=o?E:N}}}f[h+(C<<2)>>2]=W}l=l+1|0}while((l|0)<(e|0));if(!m)return 1}else if(!m)return 1;if(b)X=0;else{b=0;do{m=b;b=b+1|0;if((b|0)<(g|0)){e=b;l=m;while(1){W=+p[c+(l<<3)>>3]<+p[c+(e<<3)>>3]?e:l;e=e+1|0;if((e|0)==(g|0)){Z=W;break}else l=W}}else Z=m;if((m|0)!=(Z|0)){l=c+(Z<<3)|0;e=c+(m<<3)|0;K=+p[l>>3];p[l>>3]=+p[e>>3];p[e>>3]=K}}while((b|0)!=(y|0));return 1}do{b=X;X=X+1|0;if((X|0)<(g|0)){Z=X;e=b;while(1){l=+p[c+(e<<3)>>3]<+p[c+(Z<<3)>>3]?Z:e;Z=Z+1|0;if((Z|0)==(g|0)){_=l;break}else e=l}}else _=b;if((b|0)!=(_|0)){e=c+(_<<3)|0;Z=c+(b<<3)|0;K=+p[e>>3];p[e>>3]=+p[Z>>3];p[Z>>3]=K;Z=Y(_,n)|0;e=Y(b,n)|0;m=0;do{l=d+(m+Z<<3)|0;W=d+(m+e<<3)|0;K=+p[l>>3];p[l>>3]=+p[W>>3];p[W>>3]=K;m=m+1|0}while((m|0)!=(g|0))}}while((X|0)!=(y|0));return 1}function eN(a,b,c,d,e,f,g,h,i,j,k,l,m,o,q){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;o=o|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0,K=0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0;r=(d|0)==0?1:d>>>2;d=f>>>2;f=i>>>2;i=k>>>2;k=o>>>2;o=q+7&-8;q=o;s=o;o=g?d:1;t=g?1:d;d=(b|0)<(a|0)?b:a;g=(j|0)!=0;u=g?l:a;l=(b|0)>0;v=(u|0)>0;if(l&v){w=u<<2;x=0;do{F1a(m+((Y(x,k)|0)<<2)|0,0,w|0)|0;x=x+1|0}while((x|0)!=(b|0))}if((d|0)>0){y=0;z=0.0}else return;do{x=c+((Y(y,r)|0)<<2)|0;z=z+ +n[x>>2];y=y+1|0}while((y|0)<(d|0));A=z*4.440892098500626e-16;y=(u|0)==1;x=(a|0)>0;w=u+-4|0;B=(u|0)<4;C=u&-4;D=(C|0)<(u|0);E=u<<3;F=0;G=e;e=h;while(1){h=c+((Y(F,r)|0)<<2)|0;z=+n[h>>2];a:do if(!(+L(+z)<=A)){H=1.0/z;if(y){if(g)if(x){h=0;I=0.0;while(1){J=G+((Y(h,t)|0)<<2)|0;K=j+((Y(h,i)|0)<<2)|0;M=I+ +n[J>>2]*+n[K>>2];h=h+1|0;if((h|0)==(a|0)){N=M;break}else I=M}}else N=0.0;else N=+n[G>>2];I=H*N;if(l)O=0;else break;while(1){h=m+((Y(O,k)|0)<<2)|0;n[h>>2]=+n[h>>2]+I*+n[e+(O<<2)>>2];O=O+1|0;if((O|0)==(b|0))break a}}b:do if(g){if(v)F1a(q|0,0,E|0)|0;c:do if(x){if(B){if(v){P=0;Q=j}else break b;while(1){h=G+((Y(P,t)|0)<<2)|0;I=+n[h>>2];h=0;do{K=s+(h<<3)|0;p[K>>3]=+p[K>>3]+I*+n[Q+(h<<2)>>2];h=h+1|0}while((h|0)!=(u|0));P=P+1|0;if((P|0)==(a|0))break c;else Q=Q+(i<<2)|0}}if(D){R=0;S=j}else{h=0;K=j;while(1){J=G+((Y(h,t)|0)<<2)|0;I=+n[J>>2];J=0;do{T=s+(J<<3)|0;U=J|1;V=s+(U<<3)|0;M=+p[V>>3]+I*+n[K+(U<<2)>>2];p[T>>3]=+p[T>>3]+I*+n[K+(J<<2)>>2];p[V>>3]=M;V=J|2;T=s+(V<<3)|0;U=J|3;W=s+(U<<3)|0;M=+p[W>>3]+I*+n[K+(U<<2)>>2];p[T>>3]=+p[T>>3]+I*+n[K+(V<<2)>>2];p[W>>3]=M;J=J+4|0}while((J|0)<=(w|0));h=h+1|0;if((h|0)==(a|0))break c;else K=K+(i<<2)|0}}while(1){K=G+((Y(R,t)|0)<<2)|0;I=+n[K>>2];K=0;do{h=s+(K<<3)|0;J=K|1;W=s+(J<<3)|0;M=+p[W>>3]+I*+n[S+(J<<2)>>2];p[h>>3]=+p[h>>3]+I*+n[S+(K<<2)>>2];p[W>>3]=M;W=K|2;h=s+(W<<3)|0;J=K|3;V=s+(J<<3)|0;M=+p[V>>3]+I*+n[S+(J<<2)>>2];p[h>>3]=+p[h>>3]+I*+n[S+(W<<2)>>2];p[V>>3]=M;K=K+4|0}while((K|0)<=(w|0));X=C;do{K=s+(X<<3)|0;p[K>>3]=+p[K>>3]+I*+n[S+(X<<2)>>2];X=X+1|0}while((X|0)!=(u|0));R=R+1|0;if((R|0)==(a|0))break;else S=S+(i<<2)|0}}while(0);if(v){K=0;do{V=s+(K<<3)|0;p[V>>3]=H*+p[V>>3];K=K+1|0}while((K|0)!=(u|0))}}else if(v){K=0;do{V=G+((Y(K,t)|0)<<2)|0;p[s+(K<<3)>>3]=H*+n[V>>2];K=K+1|0}while((K|0)!=(u|0))}while(0);if(l){if(B){if(v){Z=0;_=m}else break;while(1){H=+n[e+(Z<<2)>>2];K=0;do{V=_+(K<<2)|0;n[V>>2]=+n[V>>2]+H*+p[s+(K<<3)>>3];K=K+1|0}while((K|0)!=(u|0));Z=Z+1|0;if((Z|0)==(b|0))break a;else _=_+(k<<2)|0}}if(D){$=0;aa=m}else{K=0;V=m;while(1){H=+n[e+(K<<2)>>2];W=0;do{h=V+(W<<2)|0;J=W|1;T=V+(J<<2)|0;I=+n[T>>2]+H*+p[s+(J<<3)>>3];n[h>>2]=+n[h>>2]+H*+p[s+(W<<3)>>3];n[T>>2]=I;T=W|2;h=V+(T<<2)|0;J=W|3;U=V+(J<<2)|0;I=+n[U>>2]+H*+p[s+(J<<3)>>3];n[h>>2]=+n[h>>2]+H*+p[s+(T<<3)>>3];n[U>>2]=I;W=W+4|0}while((W|0)<=(w|0));K=K+1|0;if((K|0)==(b|0))break a;else V=V+(k<<2)|0}}while(1){H=+n[e+($<<2)>>2];V=0;do{K=aa+(V<<2)|0;W=V|1;U=aa+(W<<2)|0;I=+n[U>>2]+H*+p[s+(W<<3)>>3];n[K>>2]=+n[K>>2]+H*+p[s+(V<<3)>>3];n[U>>2]=I;U=V|2;K=aa+(U<<2)|0;W=V|3;T=aa+(W<<2)|0;I=+n[T>>2]+H*+p[s+(W<<3)>>3];n[K>>2]=+n[K>>2]+H*+p[s+(U<<3)>>3];n[T>>2]=I;V=V+4|0}while((V|0)<=(w|0));ba=C;do{V=aa+(ba<<2)|0;n[V>>2]=+n[V>>2]+H*+p[s+(ba<<3)>>3];ba=ba+1|0}while((ba|0)!=(u|0));$=$+1|0;if(($|0)==(b|0))break;else aa=aa+(k<<2)|0}}}while(0);F=F+1|0;if((F|0)>=(d|0))break;else{G=G+(o<<2)|0;e=e+(f<<2)|0}}return}function fN(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0;q=(d|0)==0?1:d>>>3;d=f>>>3;f=i>>>3;i=k>>>3;k=n>>>3;n=o+7&-8;o=n;r=n;n=g?d:1;s=g?1:d;d=(b|0)<(a|0)?b:a;g=(j|0)!=0;t=g?l:a;l=(b|0)>0;u=(t|0)>0;if(l&u){v=t<<3;w=0;do{F1a(m+((Y(w,k)|0)<<3)|0,0,v|0)|0;w=w+1|0}while((w|0)!=(b|0))}if((d|0)>0){x=0;y=0.0}else return;do{w=c+((Y(x,q)|0)<<3)|0;y=y+ +p[w>>3];x=x+1|0}while((x|0)<(d|0));z=y*4.440892098500626e-16;x=(t|0)==1;w=(a|0)>0;v=t<<3;A=0;B=e;e=h;while(1){h=c+((Y(A,q)|0)<<3)|0;y=+p[h>>3];a:do if(!(+L(+y)<=z)){C=1.0/y;if(x){if(g)if(w){h=0;D=0.0;while(1){E=B+((Y(h,s)|0)<<3)|0;F=j+((Y(h,i)|0)<<3)|0;G=D+ +p[E>>3]*+p[F>>3];h=h+1|0;if((h|0)==(a|0)){H=G;break}else D=G}}else H=0.0;else H=+p[B>>3];D=C*H;if(l)I=0;else break;while(1){h=m+((Y(I,k)|0)<<3)|0;p[h>>3]=+p[h>>3]+D*+p[e+(I<<3)>>3];I=I+1|0;if((I|0)==(b|0))break a}}do if(!g){if(u){h=0;do{F=B+((Y(h,s)|0)<<3)|0;p[r+(h<<3)>>3]=C*+p[F>>3];h=h+1|0}while((h|0)!=(t|0))}}else{if(!u){gN(a,t,j,i,B,s,r,0);break}F1a(o|0,0,v|0)|0;gN(a,t,j,i,B,s,r,0);h=0;do{F=r+(h<<3)|0;p[F>>3]=C*+p[F>>3];h=h+1|0}while((h|0)!=(t|0))}while(0);gN(b,t,r,0,e,1,m,k)}while(0);A=A+1|0;if((A|0)>=(d|0))break;else{B=B+(n<<3)|0;e=e+(f<<3)|0}}return}function gN(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0,r=0,s=0.0,t=0;if((a|0)<=0)return;i=b+-4|0;if((b|0)<4){j=(b|0)>0;k=0;l=c;m=g;while(1){n=e+((Y(k,f)|0)<<3)|0;o=+p[n>>3];if(j){n=0;do{q=m+(n<<3)|0;p[q>>3]=+p[q>>3]+o*+p[l+(n<<3)>>3];n=n+1|0}while((n|0)!=(b|0))}k=k+1|0;if((k|0)==(a|0))break;else{l=l+(d<<3)|0;m=m+(h<<3)|0}}return}m=b&-4;l=(m|0)<(b|0);k=0;j=c;c=g;while(1){g=e+((Y(k,f)|0)<<3)|0;o=+p[g>>3];g=0;do{n=c+(g<<3)|0;q=g|1;r=c+(q<<3)|0;s=+p[r>>3]+o*+p[j+(q<<3)>>3];p[n>>3]=+p[n>>3]+o*+p[j+(g<<3)>>3];p[r>>3]=s;r=g|2;n=c+(r<<3)|0;q=g|3;t=c+(q<<3)|0;s=+p[t>>3]+o*+p[j+(q<<3)>>3];p[n>>3]=+p[n>>3]+o*+p[j+(r<<3)>>3];p[t>>3]=s;g=g+4|0}while((g|0)<=(i|0));if(l){g=m;do{t=c+(g<<3)|0;p[t>>3]=+p[t>>3]+o*+p[j+(g<<3)>>3];g=g+1|0}while((g|0)!=(b|0))}k=k+1|0;if((k|0)==(a|0))break;else{j=j+(d<<3)|0;c=c+(h<<3)|0}}return}function hN(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0,X=0.0,Z=0.0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0;g=u;u=u+1680|0;h=g;i=g+1624|0;j=g+1616|0;k=g+1560|0;l=g+1504|0;m=g+464|0;o=g+408|0;q=g+352|0;r=g+240|0;s=g+184|0;t=g+128|0;v=g+72|0;w=g+56|0;x=g+296|0;_$(j,39e3);do if((NS(a)|0)==65536){y=f[a+4>>2]|0;f[k>>2]=f[y>>2];z=k+4|0;A=y+4|0;f[z>>2]=f[A>>2];B=k+8|0;f[B>>2]=f[y+8>>2];f[k+12>>2]=f[y+12>>2];f[k+16>>2]=f[y+16>>2];f[k+20>>2]=f[y+20>>2];f[k+24>>2]=f[y+24>>2];f[k+28>>2]=f[y+28>>2];f[k+32>>2]=f[y+32>>2];C=f[y+36>>2]|0;f[k+36>>2]=C;f[k+40>>2]=B;B=k+48|0;D=k+44|0;f[D>>2]=B;f[B>>2]=0;f[k+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[y+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];break}else{f[z>>2]=0;BR(k,y);break}}else OR(k,a,-1);while(0);do if((NS(c)|0)==65536){a=f[c+4>>2]|0;f[l>>2]=f[a>>2];y=l+4|0;z=a+4|0;f[y>>2]=f[z>>2];A=l+8|0;f[A>>2]=f[a+8>>2];f[l+12>>2]=f[a+12>>2];f[l+16>>2]=f[a+16>>2];f[l+20>>2]=f[a+20>>2];f[l+24>>2]=f[a+24>>2];f[l+28>>2]=f[a+28>>2];f[l+32>>2]=f[a+32>>2];B=f[a+36>>2]|0;f[l+36>>2]=B;f[l+40>>2]=A;A=l+48|0;D=l+44|0;f[D>>2]=A;f[A>>2]=0;f[l+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[a+44>>2]|0;A=f[D>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];E=l;break}else{f[y>>2]=0;BR(l,a);E=l;break}}else{OR(l,c,-1);E=l}while(0);c=f[k>>2]|0;a=c&4095;y=(e&16|0)!=0;if(!((a+-5|0)>>>0<2?(a|0)==(f[E>>2]&4095|0):0)){f[h>>2]=0;f[h+4>>2]=0;F=c$(h,48)|0;G=164801;H=F+48|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));j$(-215,h,164850,164068,1094);d$(h)}z=e&-17;a:do switch(e|0){case 0:case 3:case 16:case 19:{if(!y?(f[k+8>>2]|0)!=(f[k+12>>2]|0):0){f[h>>2]=0;f[h+4>>2]=0;F=c$(h,87)|0;G=164856;H=F+87|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));j$(-215,h,164850,164068,1098);d$(h)}switch(e|0){case 0:case 3:case 16:case 19:break;default:{I=58;break a}}if(((!y?(A=k+8|0,D=f[A>>2]|0,(D|0)<4):0)?(D|0)==(f[k+12>>2]|0):0)?(f[l+12>>2]|0)==1:0){pS(d,D,1,f[k>>2]&4095,-1,0,0);do if((NS(d)|0)==65536){D=f[d+4>>2]|0;f[h>>2]=f[D>>2];B=h+4|0;C=D+4|0;f[B>>2]=f[C>>2];J=h+8|0;f[J>>2]=f[D+8>>2];f[h+12>>2]=f[D+12>>2];K=h+16|0;f[K>>2]=f[D+16>>2];f[h+20>>2]=f[D+20>>2];f[h+24>>2]=f[D+24>>2];f[h+28>>2]=f[D+28>>2];f[h+32>>2]=f[D+32>>2];L=f[D+36>>2]|0;f[h+36>>2]=L;f[h+40>>2]=J;J=h+48|0;M=h+44|0;f[M>>2]=J;f[J>>2]=0;f[h+52>>2]=0;if(L|0){N=L+12|0;f[N>>2]=(f[N>>2]|0)+1}if((f[C>>2]|0)<3){C=f[D+44>>2]|0;N=f[M>>2]|0;f[N>>2]=f[C>>2];f[N+4>>2]=f[C+4>>2];O=J;P=K;Q=M;break}else{f[B>>2]=0;BR(h,D);O=J;P=K;Q=M;break}}else{OR(h,d,-1);O=h+48|0;P=h+16|0;Q=h+44|0}while(0);M=f[k+16>>2]|0;K=f[l+16>>2]|0;J=f[P>>2]|0;D=f[k+48>>2]|0;B=f[l+48>>2]|0;C=f[O>>2]|0;N=(a|0)==5;b:do switch(f[A>>2]|0){case 2:{if(N){R=+n[M>>2];L=M+D|0;S=+n[L+4>>2];T=+n[M+4>>2];U=+n[L>>2];V=R*S-T*U;if(!(V!=0.0)){W=0;break b}X=1.0/V;V=+n[K>>2];Z=+n[K+B>>2];n[J+C>>2]=X*(R*Z-U*V);n[J>>2]=X*(S*V-T*Z);W=1;break b}else{Z=+p[M>>3];L=M+D|0;T=+p[L+8>>3];V=+p[M+8>>3];S=+p[L>>3];X=Z*T-V*S;if(!(X!=0.0)){W=0;break b}U=1.0/X;X=+p[K>>3];R=+p[K+B>>3];p[J+C>>3]=U*(Z*R-S*X);p[J>>3]=U*(T*X-V*R);W=1;break b}break}case 3:{L=D<<1;if(N){R=+n[M>>2];_=M+D|0;V=+n[_+4>>2];$=M+L|0;X=+n[$+8>>2];T=X;U=+n[_+8>>2];S=+n[$+4>>2];Z=V*T-U*S;aa=+n[M+4>>2];ba=+n[_>>2];ca=+n[$>>2];da=T*ba-U*ca;ea=+n[M+8>>2];fa=S*ba-V*ca;ga=ea*fa+(R*Z-aa*da);if(!(ga!=0.0)){W=0;break b}ha=1.0/ga;ga=+n[K>>2];ia=+n[K+B>>2];ja=ia;ka=+n[K+(B<<1)>>2];la=U*ka;U=S*ja;S=V*ka;V=ba*ka-ca*ja;n[J>>2]=ha*(ea*(U-S)+(Z*ga-aa*(T*ja-la)));n[J+C>>2]=ha*(ea*V+(R*(X*ia-la)-da*ga));n[J+(C<<1)>>2]=ha*(fa*ga+(R*(S-U)-aa*V));W=1;break b}else{V=+p[M>>3];$=M+D|0;aa=+p[$+8>>3];_=M+L|0;U=+p[_+16>>3];S=+p[$+16>>3];R=+p[_+8>>3];ga=aa*U-S*R;fa=+p[M+8>>3];ha=+p[$>>3];da=U*ha;la=+p[_>>3];ia=S*la;X=+p[M+16>>3];ea=R*ha-aa*la;ja=X*ea+(V*ga-fa*(da-ia));if(!(ja!=0.0)){W=0;break b}T=1.0/ja;ja=+p[K>>3];Z=+p[K+B>>3];ca=+p[K+(B<<1)>>3];p[J>>3]=T*(ga*ja+(R*X-U*fa)*Z+(S*fa-aa*X)*ca);p[J+C>>3]=T*((ia-da)*ja+(V*U-la*X)*Z+(ha*X-V*S)*ca);p[J+(C<<1)>>3]=T*(ea*ja+(fa*la-V*R)*Z+(V*aa-fa*ha)*ca);W=1;break b}break}default:if(N){ca=+n[M>>2];if(!(ca!=0.0)){W=0;break b}n[J>>2]=+n[K>>2]/ca;W=1;break b}else{ca=+p[M>>3];if(!(ca!=0.0)){W=0;break b}p[J>>3]=+p[K>>3]/ca;W=1;break b}}while(0);K=h+36|0;J=f[K>>2]|0;if(J|0?(M=J+12|0,J=f[M>>2]|0,f[M>>2]=J+-1,(J|0)==1):0)CR(h);f[K>>2]=0;K=h+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[K>>2]|0)>0){J=f[h+40>>2]|0;M=0;do{f[J+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[K>>2]|0))}K=f[Q>>2]|0;if((K|0)!=(O|0))ZF(K);ma=W;na=l+36|0}else I=58;break}default:I=58}while(0);if((I|0)==58){W=f[k+8>>2]|0;O=k+12|0;Q=f[O>>2]|0;P=f[l+12>>2]|0;K=(c>>>3&511)+1<<(47696>>>(a<<1&14)&3);c=Y(Q,K)|0;M=c+15&-16;J=(Y(W,K)|0)+15&-16;N=(e|0)!=1?M:J;J=m+8|0;f[m>>2]=J;C=m+4|0;f[C>>2]=1032;f[o>>2]=f[E>>2];E=o+4|0;B=l+4|0;D=f[B>>2]|0;f[E>>2]=D;A=o+8|0;f[A>>2]=f[l+8>>2];_=o+12|0;f[_>>2]=P;$=o+16|0;f[$>>2]=f[l+16>>2];L=o+20|0;f[L>>2]=f[l+20>>2];oa=o+24|0;f[oa>>2]=f[l+24>>2];pa=o+28|0;f[pa>>2]=f[l+28>>2];qa=o+32|0;f[qa>>2]=f[l+32>>2];ra=o+36|0;sa=l+36|0;ta=f[sa>>2]|0;f[ra>>2]=ta;ua=o+40|0;f[ua>>2]=A;va=o+48|0;wa=o+44|0;f[wa>>2]=va;f[va>>2]=0;f[o+52>>2]=0;if(!ta)xa=D;else{D=ta+12|0;f[D>>2]=(f[D>>2]|0)+1;xa=f[B>>2]|0}if((xa|0)<3){xa=f[l+44>>2]|0;B=f[wa>>2]|0;f[B>>2]=f[xa>>2];f[B+4>>2]=f[xa+4>>2]}else{f[E>>2]=0;BR(o,l)}pS(d,f[O>>2]|0,f[_>>2]|0,f[k>>2]&4095,-1,0,0);do if((NS(d)|0)==65536){O=f[d+4>>2]|0;f[q>>2]=f[O>>2];xa=q+4|0;B=O+4|0;f[xa>>2]=f[B>>2];D=q+8|0;f[D>>2]=f[O+8>>2];f[q+12>>2]=f[O+12>>2];f[q+16>>2]=f[O+16>>2];f[q+20>>2]=f[O+20>>2];f[q+24>>2]=f[O+24>>2];f[q+28>>2]=f[O+28>>2];f[q+32>>2]=f[O+32>>2];ta=f[O+36>>2]|0;f[q+36>>2]=ta;f[q+40>>2]=D;D=q+48|0;ya=q+44|0;f[ya>>2]=D;f[D>>2]=0;f[q+52>>2]=0;if(ta|0){D=ta+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[B>>2]|0)<3){B=f[O+44>>2]|0;D=f[ya>>2]|0;f[D>>2]=f[B>>2];f[D+4>>2]=f[B+4>>2];break}else{f[xa>>2]=0;BR(q,O);break}}else OR(q,d,-1);while(0);if((W|0)<(Q|0)){f[h>>2]=0;f[h+4>>2]=0;F=c$(h,58)|0;G=164944;H=F+58|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));j$(-5,h,164850,164068,1244);d$(h)}G=(W|0)==(Q|0);if(G){za=0;Aa=W;Ba=z}else{za=y;Aa=y?Q:W;Ba=(e|0)==17?2:z}z=(Ba|0)==1;e=Y(za|z?Q:W,N)|0;y=Y(c,P)|0;c=(za?y+32|0:32)+e|0;d=(Ba|0)==2;if((Ba+-1|0)>>>0<2)Ca=(P<<3)+32+(Y(M+(K*5|0)|0,Q)|0)+c|0;else Ca=c;if((f[C>>2]|0)>>>0<Ca>>>0){c=f[m>>2]|0;if((c|0)==(J|0))Da=c;else{if(c|0)QYa(c);f[m>>2]=J;f[C>>2]=1032;Da=J}f[C>>2]=Ca;if(Ca>>>0>1032){c=OYa(Ca)|0;f[m>>2]=c;Ea=c}else Ea=Da}else{f[C>>2]=Ca;Ea=f[m>>2]|0}Ca=Ea+15&-16;$i(r,Aa,Q,a,Ca,N);c:do if(za){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=k;Ea=i+8|0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=r;FO(h,i,1,fT()|0,1.0,-1);Ea=Ca+e|0;switch(Ba|0){case 0:case 3:{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=k;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=o;f[t>>2]=1124007936;Da=t+4|0;c=t+8|0;O=t+40|0;F=Da;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[O>>2]=c;xa=t+48|0;B=t+44|0;f[B>>2]=xa;f[xa>>2]=0;f[t+52>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[s>>2]=16842752;f[s+4>>2]=t;D=v+8|0;f[D>>2]=0;f[D+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=q;jO(h,i,1.0,s,0.0,v,1);D=t+36|0;ya=f[D>>2]|0;if(ya|0?(ta=ya+12|0,ya=f[ta>>2]|0,f[ta>>2]=ya+-1,(ya|0)==1):0)CR(t);f[D>>2]=0;D=t+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[Da>>2]|0)>0){D=f[O>>2]|0;ya=0;do{f[D+(ya<<2)>>2]=0;ya=ya+1|0}while((ya|0)<(f[Da>>2]|0))}Da=f[B>>2]|0;if((Da|0)!=(xa|0))ZF(Da);Fa=Ea;break c;break}default:{}}$i(h,Q,P,a,Ea,0);Da=Ca+e+y|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=k;f[s+8>>2]=0;f[s+12>>2]=0;f[s>>2]=16842752;f[s+4>>2]=o;f[v>>2]=1124007936;ya=v+4|0;D=v+8|0;O=v+40|0;F=ya;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[O>>2]=D;Ea=v+48|0;xa=v+44|0;f[xa>>2]=Ea;f[Ea>>2]=0;f[v+52>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t>>2]=16842752;f[t+4>>2]=v;B=w+8|0;f[B>>2]=0;f[B+4>>2]=0;f[w>>2]=33619968;f[w+4>>2]=h;jO(i,s,1.0,t,0.0,w,1);B=v+36|0;c=f[B>>2]|0;if(c|0?(ta=c+12|0,c=f[ta>>2]|0,f[ta>>2]=c+-1,(c|0)==1):0)CR(v);f[B>>2]=0;B=v+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[ya>>2]|0)>0){B=f[O>>2]|0;c=0;do{f[B+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[ya>>2]|0))}ya=f[xa>>2]|0;if((ya|0)!=(Ea|0))ZF(ya);ya=h+36|0;c=f[ya>>2]|0;if(c|0){B=c+12|0;f[B>>2]=(f[B>>2]|0)+1}B=f[ra>>2]|0;if(B|0?(c=B+12|0,B=f[c>>2]|0,f[c>>2]=B+-1,(B|0)==1):0)CR(o);f[ra>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[E>>2]|0)>0){B=f[ua>>2]|0;c=0;do{f[B+(c<<2)>>2]=0;c=c+1|0;Ga=f[E>>2]|0}while((c|0)<(Ga|0));f[o>>2]=f[h>>2];if((Ga|0)<3)I=139;else I=141}else{f[o>>2]=f[h>>2];I=139}do if((I|0)==139){c=f[h+4>>2]|0;if((c|0)>=3){I=141;break}f[E>>2]=c;f[A>>2]=f[h+8>>2];f[_>>2]=f[h+12>>2];c=f[h+44>>2]|0;B=f[wa>>2]|0;f[B>>2]=f[c>>2];f[B+4>>2]=f[c+4>>2]}while(0);if((I|0)==141)BR(o,h);c=h+16|0;f[$>>2]=f[c>>2];f[L>>2]=f[h+20>>2];f[oa>>2]=f[h+24>>2];f[pa>>2]=f[h+28>>2];f[qa>>2]=f[h+32>>2];B=f[ya>>2]|0;f[ra>>2]=B;do if(B|0){Ea=B+12|0;xa=f[Ea>>2]|0;f[Ea>>2]=xa+-1;if((xa|0)!=1)break;CR(h)}while(0);f[ya>>2]=0;B=h+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[B>>2]|0)>0){xa=f[h+40>>2]|0;Ea=0;do{f[xa+(Ea<<2)>>2]=0;Ea=Ea+1|0}while((Ea|0)<(f[B>>2]|0))}B=f[h+44>>2]|0;if((B|0)!=(h+48|0))ZF(B);Fa=Da}else{if(z){$i(h,Q,Aa,a,Ca,N);B=h+36|0;Ea=f[B>>2]|0;if(Ea|0){xa=Ea+12|0;f[xa>>2]=(f[xa>>2]|0)+1}xa=r+36|0;Ea=f[xa>>2]|0;if(Ea|0?(c=Ea+12|0,Ea=f[c>>2]|0,f[c>>2]=Ea+-1,(Ea|0)==1):0)CR(r);f[xa>>2]=0;Ea=r+16|0;c=r+4|0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[Ea+8>>2]=0;f[Ea+12>>2]=0;if((f[c>>2]|0)>0){ya=f[r+40>>2]|0;O=0;do{f[ya+(O<<2)>>2]=0;O=O+1|0;Ha=f[c>>2]|0}while((O|0)<(Ha|0));f[r>>2]=f[h>>2];if((Ha|0)<3)I=98;else I=100}else{f[r>>2]=f[h>>2];I=98}if((I|0)==98){O=f[h+4>>2]|0;if((O|0)<3){f[c>>2]=O;f[r+8>>2]=f[h+8>>2];f[r+12>>2]=f[h+12>>2];O=f[h+44>>2]|0;ya=f[r+44>>2]|0;f[ya>>2]=f[O>>2];f[ya+4>>2]=f[O+4>>2]}else I=100}if((I|0)==100)BR(r,h);O=h+16|0;f[Ea>>2]=f[O>>2];f[r+20>>2]=f[h+20>>2];f[r+24>>2]=f[h+24>>2];f[r+28>>2]=f[h+28>>2];f[r+32>>2]=f[h+32>>2];ya=f[B>>2]|0;f[xa>>2]=ya;do if(ya|0){Da=ya+12|0;D=f[Da>>2]|0;f[Da>>2]=D+-1;if((D|0)!=1)break;CR(h)}while(0);f[B>>2]=0;ya=h+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[ya>>2]|0)>0){xa=f[h+40>>2]|0;Ea=0;do{f[xa+(Ea<<2)>>2]=0;Ea=Ea+1|0}while((Ea|0)<(f[ya>>2]|0))}ya=f[h+44>>2]|0;if((ya|0)!=(h+48|0))ZF(ya);f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=k;ya=i+8|0;f[ya>>2]=0;f[ya+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=r;mS(h,i)}else{ya=h+8|0;f[ya>>2]=0;f[ya+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=r;eL(k,h)}ya=Ca+e|0;switch(Ba|0){case 0:case 3:break;default:{Fa=ya;break c}}Ea=h+8|0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=q;eL(o,h);Fa=ya}while(0);d:do switch(Ba|0){case 0:{e=f[r+16>>2]|0;if((a|0)==5)if(!(gU(e,f[r+48>>2]|0,Q,f[q+16>>2]|0,f[q+48>>2]|0,P)|0)){I=278;break d}else{Ia=1;break d}else if(!(iU(e,f[r+48>>2]|0,Q,f[q+16>>2]|0,f[q+48>>2]|0,P)|0)){I=278;break d}else{Ia=1;break d}break}case 3:{e=f[r+16>>2]|0;if((a|0)==5)Ja=kU(e,f[r+48>>2]|0,Q,f[q+16>>2]|0,f[q+48>>2]|0,P)|0;else Ja=mU(e,f[r+48>>2]|0,Q,f[q+16>>2]|0,f[q+48>>2]|0,P)|0;if(Ja)Ia=1;else I=278;break}case 4:{f[s>>2]=1124007936;e=s+4|0;Ca=s+8|0;Ha=s+40|0;F=e;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[Ha>>2]=Ca;N=s+48|0;z=s+44|0;f[z>>2]=N;f[N>>2]=0;f[s+52>>2]=0;if(G|za){qa=h+8|0;f[qa>>2]=0;f[qa+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=q;eL(o,h);qa=q+36|0;pa=f[qa>>2]|0;if(pa|0){oa=pa+12|0;f[oa>>2]=(f[oa>>2]|0)+1}oa=s+36|0;pa=f[oa>>2]|0;if(pa|0?(L=pa+12|0,pa=f[L>>2]|0,f[L>>2]=pa+-1,(pa|0)==1):0)CR(s);f[oa>>2]=0;pa=s+16|0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[e>>2]|0)>0){L=f[Ha>>2]|0;_=0;do{f[L+(_<<2)>>2]=0;_=_+1|0;Ka=f[e>>2]|0}while((_|0)<(Ka|0));f[s>>2]=f[q>>2];if((Ka|0)<3)I=169;else I=171}else{f[s>>2]=f[q>>2];I=169}if((I|0)==169){_=f[q+4>>2]|0;if((_|0)<3){f[e>>2]=_;f[Ca>>2]=f[q+8>>2];f[s+12>>2]=f[q+12>>2];_=f[q+44>>2]|0;L=f[z>>2]|0;f[L>>2]=f[_>>2];f[L+4>>2]=f[_+4>>2]}else I=171}if((I|0)==171)BR(s,q);f[pa>>2]=f[q+16>>2];f[s+20>>2]=f[q+20>>2];f[s+24>>2]=f[q+24>>2];f[s+28>>2]=f[q+28>>2];f[s+32>>2]=f[q+32>>2];f[oa>>2]=f[qa>>2]}else{f[i>>2]=1124007936;_=i+4|0;L=i+8|0;A=i+40|0;F=_;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[A>>2]=L;qa=i+48|0;oa=i+44|0;f[oa>>2]=qa;f[qa>>2]=0;f[i+52>>2]=0;f[h>>2]=W;f[h+4>>2]=P;AR(i,2,h,a);pa=i+36|0;Ga=f[pa>>2]|0;if(Ga|0){v=Ga+12|0;f[v>>2]=(f[v>>2]|0)+1}v=s+36|0;Ga=f[v>>2]|0;if(Ga|0?(w=Ga+12|0,Ga=f[w>>2]|0,f[w>>2]=Ga+-1,(Ga|0)==1):0)CR(s);f[v>>2]=0;Ga=s+16|0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[Ga+8>>2]=0;f[Ga+12>>2]=0;if((f[e>>2]|0)>0){w=f[Ha>>2]|0;t=0;do{f[w+(t<<2)>>2]=0;t=t+1|0;La=f[e>>2]|0}while((t|0)<(La|0));f[s>>2]=f[i>>2];if((La|0)<3)I=183;else I=185}else{f[s>>2]=f[i>>2];I=183}if((I|0)==183){t=f[_>>2]|0;if((t|0)<3){f[e>>2]=t;f[Ca>>2]=f[L>>2];f[s+12>>2]=f[i+12>>2];t=f[oa>>2]|0;w=f[z>>2]|0;f[w>>2]=f[t>>2];f[w+4>>2]=f[t+4>>2]}else I=185}if((I|0)==185)BR(s,i);t=i+16|0;f[Ga>>2]=f[t>>2];f[s+20>>2]=f[i+20>>2];f[s+24>>2]=f[i+24>>2];f[s+28>>2]=f[i+28>>2];f[s+32>>2]=f[i+32>>2];w=f[pa>>2]|0;f[v>>2]=w;do if(w|0){y=w+12|0;ya=f[y>>2]|0;f[y>>2]=ya+-1;if((ya|0)!=1)break;CR(i)}while(0);f[pa>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[_>>2]|0)>0){w=f[A>>2]|0;v=0;do{f[w+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[_>>2]|0))}_=f[oa>>2]|0;if((_|0)!=(qa|0))ZF(_);_=h+8|0;f[_>>2]=0;f[_+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=s;eL(o,h)}_=f[r+16>>2]|0;if((a|0)==5)Ma=oU(_,f[r+48>>2]|0,f[r+8>>2]|0,f[r+12>>2]|0,f[s+12>>2]|0,f[s+16>>2]|0,f[N>>2]|0,0)|0;else Ma=pU(_,f[r+48>>2]|0,f[r+8>>2]|0,f[r+12>>2]|0,f[s+12>>2]|0,f[s+16>>2]|0,f[N>>2]|0,0)|0;_=(Ma|0)==0;v=f[q+8>>2]|0;if((f[Ca>>2]|0)!=(v|0)){f[h>>2]=0;f[h+4>>2]=v;f[i>>2]=-2147483648;f[i+4>>2]=2147483647;DR(x,s,h,i);v=h+8|0;f[v>>2]=0;f[v+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=q;eL(x,h);v=x+36|0;w=f[v>>2]|0;if(w|0?(A=w+12|0,w=f[A>>2]|0,f[A>>2]=w+-1,(w|0)==1):0)CR(x);f[v>>2]=0;v=x+16|0;w=x+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[w>>2]|0)>0){v=f[x+40>>2]|0;A=0;do{f[v+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[w>>2]|0))}w=f[x+44>>2]|0;if((w|0)!=(x+48|0))ZF(w)}w=s+36|0;A=f[w>>2]|0;if(A|0?(v=A+12|0,A=f[v>>2]|0,f[v>>2]=A+-1,(A|0)==1):0)CR(s);f[w>>2]=0;w=s+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[e>>2]|0)>0){w=f[Ha>>2]|0;A=0;do{f[w+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[e>>2]|0))}e=f[z>>2]|0;if((e|0)!=(N|0))ZF(e);if(_)I=278;else Ia=1;break}default:{e=Fa+15&-16;$i(h,Q,Q,a,e,M);$i(i,Q,1,a,e+(Y(M,Q)|0)|0,0);f[s>>2]=1124007936;A=s+4|0;w=s+8|0;Ha=s+40|0;F=A;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[Ha>>2]=w;_=s+48|0;N=s+44|0;f[N>>2]=_;f[_>>2]=0;f[s+52>>2]=0;z=e+(Y(M+K|0,Q)|0)|0;v=(a|0)==5;Ca=f[r+16>>2]|0;e:do if(d){if(v)cN(Ca,f[r+48>>2]|0,f[i+16>>2]|0,f[h+16>>2]|0,f[h+48>>2]|0,Q,z)|0;else dN(Ca,f[r+48>>2]|0,f[i+16>>2]|0,f[h+16>>2]|0,f[h+48>>2]|0,Q,z)|0;qa=h+36|0;oa=f[qa>>2]|0;if(oa|0){t=oa+12|0;f[t>>2]=(f[t>>2]|0)+1}t=s+36|0;oa=f[t>>2]|0;if(oa|0?(pa=oa+12|0,oa=f[pa>>2]|0,f[pa>>2]=oa+-1,(oa|0)==1):0)CR(s);f[t>>2]=0;oa=s+16|0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((f[A>>2]|0)>0){pa=f[Ha>>2]|0;Ga=0;do{f[pa+(Ga<<2)>>2]=0;Ga=Ga+1|0;Na=f[A>>2]|0}while((Ga|0)<(Na|0));f[s>>2]=f[h>>2];if((Na|0)<3)I=230}else{f[s>>2]=f[h>>2];I=230}do if((I|0)==230){Ga=f[h+4>>2]|0;if((Ga|0)>=3)break;f[A>>2]=Ga;f[w>>2]=f[h+8>>2];f[s+12>>2]=f[h+12>>2];Ga=f[h+44>>2]|0;pa=f[N>>2]|0;f[pa>>2]=f[Ga>>2];f[pa+4>>2]=f[Ga+4>>2];Oa=oa;Pa=t;Qa=qa;Ra=h;break e}while(0);BR(s,h);Oa=oa;Pa=t;Qa=qa;Ra=h}else{if(v){Ga=f[h+16>>2]|0;XM(Ca,f[r+48>>2]|0,f[i+16>>2]|0,Ga,f[h+48>>2]|0,Aa,Q,(Ga|0)==0?0:Q,1.1754943508222875e-38,2.384185791015625e-07)}else{Ga=f[h+16>>2]|0;YM(Ca,f[r+48>>2]|0,f[i+16>>2]|0,Ga,f[h+48>>2]|0,Aa,Q,(Ga|0)==0?0:Q,2.2250738585072014e-308,2.220446049250313e-15)}Ga=r+36|0;pa=f[Ga>>2]|0;if(pa|0){L=pa+12|0;f[L>>2]=(f[L>>2]|0)+1}L=s+36|0;pa=f[L>>2]|0;if(pa|0?(ya=pa+12|0,pa=f[ya>>2]|0,f[ya>>2]=pa+-1,(pa|0)==1):0)CR(s);f[L>>2]=0;pa=s+16|0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[A>>2]|0)>0){ya=f[Ha>>2]|0;y=0;do{f[ya+(y<<2)>>2]=0;y=y+1|0;Sa=f[A>>2]|0}while((y|0)<(Sa|0));f[s>>2]=f[r>>2];if((Sa|0)<3)I=246}else{f[s>>2]=f[r>>2];I=246}do if((I|0)==246){y=f[r+4>>2]|0;if((y|0)>=3)break;f[A>>2]=y;f[w>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];y=f[r+44>>2]|0;ya=f[N>>2]|0;f[ya>>2]=f[y>>2];f[ya+4>>2]=f[y+4>>2];Oa=pa;Pa=L;Qa=Ga;Ra=r;break e}while(0);BR(s,r);Oa=pa;Pa=L;Qa=Ga;Ra=r}while(0);f[Oa>>2]=f[Ra+16>>2];f[s+20>>2]=f[Ra+20>>2];f[s+24>>2]=f[Ra+24>>2];f[s+28>>2]=f[Ra+28>>2];f[s+32>>2]=f[Ra+32>>2];f[Pa>>2]=f[Qa>>2];w=i+16|0;Ca=f[w>>2]|0;if(v)eN(Aa,Q,Ca,0,f[s+16>>2]|0,f[_>>2]|0,1,f[h+16>>2]|0,f[h+48>>2]|0,f[$>>2]|0,f[va>>2]|0,P,f[q+16>>2]|0,f[q+48>>2]|0,z);else fN(Aa,Q,Ca,0,f[s+16>>2]|0,f[_>>2]|0,1,f[h+16>>2]|0,f[h+48>>2]|0,f[$>>2]|0,f[va>>2]|0,P,f[q+16>>2]|0,f[q+48>>2]|0,z);Ca=s+36|0;e=f[Ca>>2]|0;if(e|0?(y=e+12|0,e=f[y>>2]|0,f[y>>2]=e+-1,(e|0)==1):0)CR(s);f[Ca>>2]=0;Ca=s+16|0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[Ca+8>>2]=0;f[Ca+12>>2]=0;if((f[A>>2]|0)>0){Ca=f[Ha>>2]|0;e=0;do{f[Ca+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[A>>2]|0))}A=f[N>>2]|0;if((A|0)!=(_|0))ZF(A);A=i+36|0;e=f[A>>2]|0;do if(e|0){Ca=e+12|0;Ha=f[Ca>>2]|0;f[Ca>>2]=Ha+-1;if((Ha|0)!=1)break;CR(i)}while(0);f[A>>2]=0;e=i+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[e>>2]|0)>0){_=f[i+40>>2]|0;N=0;do{f[_+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[e>>2]|0))}e=f[i+44>>2]|0;if((e|0)!=(i+48|0))ZF(e);e=h+36|0;N=f[e>>2]|0;do if(N|0){_=N+12|0;w=f[_>>2]|0;f[_>>2]=w+-1;if((w|0)!=1)break;CR(h)}while(0);f[e>>2]=0;N=h+16|0;w=h+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[w>>2]|0)>0){N=f[h+40>>2]|0;_=0;do{f[N+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[w>>2]|0))}w=f[h+44>>2]|0;if((w|0)!=(h+48|0))ZF(w);Ia=1}}while(0);if((I|0)==278){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;gL(q,h)|0;Ia=0}h=r+36|0;I=f[h>>2]|0;if(I|0?(i=I+12|0,I=f[i>>2]|0,f[i>>2]=I+-1,(I|0)==1):0)CR(r);f[h>>2]=0;h=r+16|0;I=r+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[I>>2]|0)>0){h=f[r+40>>2]|0;i=0;do{f[h+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[I>>2]|0))}I=f[r+44>>2]|0;if((I|0)!=(r+48|0))ZF(I);I=q+36|0;r=f[I>>2]|0;if(r|0?(i=r+12|0,r=f[i>>2]|0,f[i>>2]=r+-1,(r|0)==1):0)CR(q);f[I>>2]=0;I=q+16|0;r=q+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[r>>2]|0)>0){I=f[q+40>>2]|0;i=0;do{f[I+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[r>>2]|0))}r=f[q+44>>2]|0;if((r|0)!=(q+48|0))ZF(r);r=f[ra>>2]|0;do if(r|0){q=r+12|0;i=f[q>>2]|0;f[q>>2]=i+-1;if((i|0)!=1)break;CR(o)}while(0);f[ra>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[E>>2]|0)>0){$=f[ua>>2]|0;ua=0;do{f[$+(ua<<2)>>2]=0;ua=ua+1|0}while((ua|0)<(f[E>>2]|0))}E=f[wa>>2]|0;if((E|0)!=(va|0))ZF(E);E=f[m>>2]|0;if((E|0)!=(J|0)){if(E|0)QYa(E);f[m>>2]=J;f[C>>2]=1032}ma=Ia;na=sa}sa=f[na>>2]|0;if(sa|0?(Ia=sa+12|0,sa=f[Ia>>2]|0,f[Ia>>2]=sa+-1,(sa|0)==1):0)CR(l);f[na>>2]=0;na=l+16|0;sa=l+4|0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;if((f[sa>>2]|0)>0){na=f[l+40>>2]|0;Ia=0;do{f[na+(Ia<<2)>>2]=0;Ia=Ia+1|0}while((Ia|0)<(f[sa>>2]|0))}sa=f[l+44>>2]|0;if((sa|0)!=(l+48|0))ZF(sa);sa=k+36|0;l=f[sa>>2]|0;if(l|0?(Ia=l+12|0,l=f[Ia>>2]|0,f[Ia>>2]=l+-1,(l|0)==1):0)CR(k);f[sa>>2]=0;sa=k+16|0;l=k+4|0;f[sa>>2]=0;f[sa+4>>2]=0;f[sa+8>>2]=0;f[sa+12>>2]=0;if((f[l>>2]|0)>0){sa=f[k+40>>2]|0;Ia=0;do{f[sa+(Ia<<2)>>2]=0;Ia=Ia+1|0}while((Ia|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))ZF(l);if(!(f[j+4>>2]|0)){u=g;return ma|0}u=g;return ma|0}function iN(a){a=+a;var b=0,c=0,d=0,e=0,g=0,h=0,i=0.0;b=u;u=u+16|0;c=b;_$(c,39020);d=(n[s>>2]=a,f[s>>2]|0);e=(d>>>23&255)+-127|0;g=(e|0)%3|0;h=g+-3-(g>>31&-3)|0;a=(f[s>>2]=(h<<23)+1065353216|d&8388607,+n[s>>2]);i=d|0?(f[s>>2]=(((e-h|0)/3|0)<<23)+(d&-2147483648)+(n[s>>2]=(a*(a*(a*(a*45.2548339756803+192.2798368355061)+119.16548242855816)+13.432501390862399)+.16361612265857542)/(a*(a*(a*(a*14.808840932191346+151.97140510444356)+168.52544141015682)+33.99059413502156)+1.0),f[s>>2]|0),+n[s>>2]):0.0;if(!(f[c+4>>2]|0)){u=b;return +i}u=b;return +i}function jN(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+240|0;g=e+232|0;h=e+176|0;i=e+120|0;j=e+64|0;k=e+48|0;l=e+32|0;m=e;_$(g,39040);n=RR(a,-1)|0;o=VS(a,-1)|0;p=WS(a,-1)|0;QR(h,a,-1);QR(i,c,-1);do if((f[h>>2]|0)==(f[i>>2]|0)?(f[h+4>>2]|0)==(f[i+4>>2]|0):0)if((n|0)==(RR(c,-1)|0)?(o+-5|0)>>>0<2:0)break;else{q=6;break}else q=6;while(0);if((q|0)==6){f[h>>2]=0;f[h+4>>2]=0;q=c$(h,79)|0;n=165137;r=q+79|0;do{b[q>>0]=b[n>>0]|0;q=q+1|0;n=n+1|0}while((q|0)<(r|0));j$(-215,h,204633,165086,150);d$(h)}do if((NS(a)|0)==65536){n=f[a+4>>2]|0;f[h>>2]=f[n>>2];q=h+4|0;r=n+4|0;f[q>>2]=f[r>>2];s=h+8|0;f[s>>2]=f[n+8>>2];f[h+12>>2]=f[n+12>>2];f[h+16>>2]=f[n+16>>2];f[h+20>>2]=f[n+20>>2];f[h+24>>2]=f[n+24>>2];f[h+28>>2]=f[n+28>>2];f[h+32>>2]=f[n+32>>2];t=f[n+36>>2]|0;f[h+36>>2]=t;f[h+40>>2]=s;s=h+48|0;v=h+44|0;f[v>>2]=s;f[s>>2]=0;f[h+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[n+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;BR(h,n);break}}else OR(h,a,-1);while(0);do if((NS(c)|0)==65536){a=f[c+4>>2]|0;f[i>>2]=f[a>>2];n=i+4|0;q=a+4|0;f[n>>2]=f[q>>2];r=i+8|0;f[r>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];s=f[a+36>>2]|0;f[i+36>>2]=s;f[i+40>>2]=r;r=i+48|0;v=i+44|0;f[v>>2]=r;f[r>>2]=0;f[i+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[a+44>>2]|0;r=f[v>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[n>>2]=0;BR(i,a);break}}else OR(i,c,-1);while(0);c=h+4|0;a=h+40|0;MR(d,f[c>>2]|0,f[a>>2]|0,f[h>>2]&4095,-1,0,0);do if((NS(d)|0)==65536){n=f[d+4>>2]|0;f[j>>2]=f[n>>2];q=j+4|0;r=n+4|0;f[q>>2]=f[r>>2];v=j+8|0;f[v>>2]=f[n+8>>2];f[j+12>>2]=f[n+12>>2];f[j+16>>2]=f[n+16>>2];f[j+20>>2]=f[n+20>>2];f[j+24>>2]=f[n+24>>2];f[j+28>>2]=f[n+28>>2];f[j+32>>2]=f[n+32>>2];s=f[n+36>>2]|0;f[j+36>>2]=s;f[j+40>>2]=v;v=j+48|0;t=j+44|0;f[t>>2]=v;f[v>>2]=0;f[j+52>>2]=0;if(s|0){v=s+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[r>>2]|0)<3){r=f[n+44>>2]|0;v=f[t>>2]|0;f[v>>2]=f[r>>2];f[v+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;BR(j,n);break}}else OR(j,d,-1);while(0);f[k>>2]=h;f[k+4>>2]=i;f[k+8>>2]=j;f[k+12>>2]=0;bU(m,k,l,-1);k=Y(f[m+20>>2]|0,p)|0;p=m+16|0;d=l+8|0;n=l+4|0;a:do if((o|0)==5){q=0;while(1){if(q>>>0>=(f[p>>2]|0)>>>0)break a;LN(f[l>>2]|0,f[n>>2]|0,f[d>>2]|0,k);tR(m)|0;q=q+1|0}}else{q=0;while(1){if(q>>>0>=(f[p>>2]|0)>>>0)break a;MN(f[l>>2]|0,f[n>>2]|0,f[d>>2]|0,k);tR(m)|0;q=q+1|0}}while(0);m=j+36|0;k=f[m>>2]|0;if(k|0?(d=k+12|0,k=f[d>>2]|0,f[d>>2]=k+-1,(k|0)==1):0)CR(j);f[m>>2]=0;m=j+16|0;k=j+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[k>>2]|0)>0){m=f[j+40>>2]|0;d=0;do{f[m+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))ZF(k);k=i+36|0;j=f[k>>2]|0;if(j|0?(d=j+12|0,j=f[d>>2]|0,f[d>>2]=j+-1,(j|0)==1):0)CR(i);f[k>>2]=0;k=i+16|0;j=i+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[i+40>>2]|0;d=0;do{f[k+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))ZF(j);j=h+36|0;i=f[j>>2]|0;if(i|0?(d=i+12|0,i=f[d>>2]|0,f[d>>2]=i+-1,(i|0)==1):0)CR(h);f[j>>2]=0;j=h+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[c>>2]|0)>0){j=f[a>>2]|0;a=0;do{f[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[c>>2]|0))}c=f[h+44>>2]|0;if((c|0)!=(h+48|0))ZF(c);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function kN(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=u;u=u+304|0;i=h+296|0;j=h+240|0;k=h+184|0;l=h+128|0;m=h+72|0;n=h+48|0;o=h+32|0;p=h;_$(i,39060);do if((NS(a)|0)==65536){q=f[a+4>>2]|0;f[j>>2]=f[q>>2];r=j+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=j+8|0;f[t>>2]=f[q+8>>2];f[j+12>>2]=f[q+12>>2];f[j+16>>2]=f[q+16>>2];f[j+20>>2]=f[q+20>>2];f[j+24>>2]=f[q+24>>2];f[j+28>>2]=f[q+28>>2];f[j+32>>2]=f[q+32>>2];v=f[q+36>>2]|0;f[j+36>>2]=v;f[j+40>>2]=t;t=j+48|0;w=j+44|0;f[w>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[r>>2]=0;BR(j,q);break}}else OR(j,a,-1);while(0);do if((NS(c)|0)==65536){a=f[c+4>>2]|0;f[k>>2]=f[a>>2];q=k+4|0;r=a+4|0;f[q>>2]=f[r>>2];s=k+8|0;f[s>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];t=f[a+36>>2]|0;f[k+36>>2]=t;w=k+40|0;f[w>>2]=s;s=k+48|0;v=k+44|0;f[v>>2]=s;f[s>>2]=0;f[k+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[a+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];x=w;break}else{f[q>>2]=0;BR(k,a);x=w;break}}else{OR(k,c,-1);x=k+40|0}while(0);c=f[j>>2]|0;w=c&4095;a=c&7;q=c>>>3&511;c=q+1|0;r=j+40|0;s=f[r>>2]|0;v=f[s+-4>>2]|0;t=f[x>>2]|0;a:do if((v|0)==(f[t+-4>>2]|0)){if((v|0)==2){if((f[s>>2]|0)!=(f[t>>2]|0)){y=23;break}if((f[s+4>>2]|0)!=(f[t+4>>2]|0)){y=23;break}}else if((v|0)>0){z=0;do{if((f[s+(z<<2)>>2]|0)!=(f[t+(z<<2)>>2]|0)){y=23;break a}z=z+1|0}while((z|0)<(v|0))}if((a+-5|0)>>>0<2?(w|0)==(f[k>>2]&4095|0):0)A=s;else y=23}else y=23;while(0);if((y|0)==23){f[l>>2]=0;f[l+4>>2]=0;y=c$(l,66)|0;s=165273;v=y+66|0;do{b[y>>0]=b[s>>0]|0;y=y+1|0;s=s+1|0}while((y|0)<(v|0));j$(-215,l,165340,165086,276);d$(l);A=f[r>>2]|0}s=j+4|0;MR(d,f[s>>2]|0,A,w,-1,0,0);MR(e,f[s>>2]|0,f[r>>2]|0,w,-1,0,0);do if((NS(d)|0)==65536){w=f[d+4>>2]|0;f[l>>2]=f[w>>2];A=l+4|0;y=w+4|0;f[A>>2]=f[y>>2];v=l+8|0;f[v>>2]=f[w+8>>2];f[l+12>>2]=f[w+12>>2];f[l+16>>2]=f[w+16>>2];f[l+20>>2]=f[w+20>>2];f[l+24>>2]=f[w+24>>2];f[l+28>>2]=f[w+28>>2];f[l+32>>2]=f[w+32>>2];t=f[w+36>>2]|0;f[l+36>>2]=t;f[l+40>>2]=v;v=l+48|0;z=l+44|0;f[z>>2]=v;f[v>>2]=0;f[l+52>>2]=0;if(t|0){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[y>>2]|0)<3){y=f[w+44>>2]|0;v=f[z>>2]|0;f[v>>2]=f[y>>2];f[v+4>>2]=f[y+4>>2];break}else{f[A>>2]=0;BR(l,w);break}}else OR(l,d,-1);while(0);do if((NS(e)|0)==65536){d=f[e+4>>2]|0;f[m>>2]=f[d>>2];w=m+4|0;A=d+4|0;f[w>>2]=f[A>>2];y=m+8|0;f[y>>2]=f[d+8>>2];f[m+12>>2]=f[d+12>>2];f[m+16>>2]=f[d+16>>2];f[m+20>>2]=f[d+20>>2];f[m+24>>2]=f[d+24>>2];f[m+28>>2]=f[d+28>>2];f[m+32>>2]=f[d+32>>2];v=f[d+36>>2]|0;f[m+36>>2]=v;f[m+40>>2]=y;y=m+48|0;z=m+44|0;f[z>>2]=y;f[y>>2]=0;f[m+52>>2]=0;if(v|0){y=v+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[A>>2]|0)<3){A=f[d+44>>2]|0;y=f[z>>2]|0;f[y>>2]=f[A>>2];f[y+4>>2]=f[A+4>>2];break}else{f[w>>2]=0;BR(m,d);break}}else OR(m,e,-1);while(0);f[n>>2]=j;f[n+4>>2]=k;f[n+8>>2]=l;f[n+12>>2]=m;f[n+16>>2]=0;bU(p,n,o,-1);n=Y(f[p+20>>2]|0,c)|0;e=q|1024;q=e-((e>>>0)%(c>>>0)|0)|0;c=(q|0)<(n|0)?q:n;q=1212424721>>>(f[j>>2]<<2&28)&15;e=p+16|0;d=(n|0)>0;w=(a|0)==5;a=o+4|0;A=o+8|0;y=o+12|0;z=0;while(1){if(z>>>0>=(f[e>>2]|0)>>>0)break;if(d)if(w){v=f[o>>2]|0;t=f[a>>2]|0;B=f[A>>2]|0;C=f[y>>2]|0;D=0;do{E=n-D|0;F=(c|0)<(E|0)?c:E;LN(v,t,B,F);JN(t,v,C,F,g);E=Y(F,q)|0;v=(f[o>>2]|0)+E|0;f[o>>2]=v;t=(f[a>>2]|0)+E|0;f[a>>2]=t;B=(f[A>>2]|0)+E|0;f[A>>2]=B;C=(f[y>>2]|0)+E|0;f[y>>2]=C;D=D+c|0}while((n|0)>(D|0))}else{D=f[o>>2]|0;C=f[a>>2]|0;B=f[A>>2]|0;t=f[y>>2]|0;v=0;do{E=n-v|0;F=(c|0)<(E|0)?c:E;MN(D,C,B,F);KN(C,D,t,F,g);E=Y(F,q)|0;D=(f[o>>2]|0)+E|0;f[o>>2]=D;C=(f[a>>2]|0)+E|0;f[a>>2]=C;B=(f[A>>2]|0)+E|0;f[A>>2]=B;t=(f[y>>2]|0)+E|0;f[y>>2]=t;v=v+c|0}while((n|0)>(v|0))}tR(p)|0;z=z+1|0}z=m+36|0;p=f[z>>2]|0;if(p|0?(n=p+12|0,p=f[n>>2]|0,f[n>>2]=p+-1,(p|0)==1):0)CR(m);f[z>>2]=0;z=m+16|0;p=m+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[p>>2]|0)>0){z=f[m+40>>2]|0;n=0;do{f[z+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[p>>2]|0))}p=f[m+44>>2]|0;if((p|0)!=(m+48|0))ZF(p);p=l+36|0;m=f[p>>2]|0;if(m|0?(n=m+12|0,m=f[n>>2]|0,f[n>>2]=m+-1,(m|0)==1):0)CR(l);f[p>>2]=0;p=l+16|0;m=l+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[m>>2]|0)>0){p=f[l+40>>2]|0;n=0;do{f[p+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))ZF(m);m=k+36|0;l=f[m>>2]|0;if(l|0?(n=l+12|0,l=f[n>>2]|0,f[n>>2]=l+-1,(l|0)==1):0)CR(k);f[m>>2]=0;m=k+16|0;l=k+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[l>>2]|0)>0){m=f[x>>2]|0;x=0;do{f[m+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))ZF(l);l=j+36|0;k=f[l>>2]|0;if(k|0?(x=k+12|0,k=f[x>>2]|0,f[x>>2]=k+-1,(k|0)==1):0)CR(j);f[l>>2]=0;l=j+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[s>>2]|0)>0){l=f[r>>2]|0;r=0;do{f[l+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[s>>2]|0))}s=f[j+44>>2]|0;if((s|0)!=(j+48|0))ZF(s);if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function lN(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0,R=0.0,S=0.0,T=0.0,U=0,V=0,W=0,X=0,Z=0;h=u;u=u+1376|0;i=h+1360|0;j=h+1304|0;k=h+1248|0;l=h+1192|0;m=h+1136|0;o=h+1112|0;q=h+1096|0;r=h+1064|0;s=h;_$(i,39080);t=RR(c,-1)|0;v=t&7;w=t>>>3&511;x=w+1|0;y=(v|0)==5;z=(v|0)==6;if((v+-5|0)>>>0<2){if(!(XS(a)|0)?(RR(a,-1)|0)!=(t|0):0)A=4}else A=4;if((A|0)==4){f[j>>2]=0;f[j+4>>2]=0;B=c$(j,67)|0;C=165429;D=B+67|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));j$(-215,j,165497,165086,565);d$(j)}do if((NS(a)|0)==65536){v=f[a+4>>2]|0;f[j>>2]=f[v>>2];E=j+4|0;F=v+4|0;f[E>>2]=f[F>>2];G=j+8|0;f[G>>2]=f[v+8>>2];f[j+12>>2]=f[v+12>>2];f[j+16>>2]=f[v+16>>2];f[j+20>>2]=f[v+20>>2];f[j+24>>2]=f[v+24>>2];f[j+28>>2]=f[v+28>>2];f[j+32>>2]=f[v+32>>2];H=f[v+36>>2]|0;f[j+36>>2]=H;f[j+40>>2]=G;G=j+48|0;I=j+44|0;f[I>>2]=G;f[G>>2]=0;f[j+52>>2]=0;if(H|0){G=H+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[F>>2]|0)<3){F=f[v+44>>2]|0;G=f[I>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=f[F+4>>2];break}else{f[E>>2]=0;BR(j,v);break}}else OR(j,a,-1);while(0);do if((NS(c)|0)==65536){a=f[c+4>>2]|0;f[k>>2]=f[a>>2];v=k+4|0;E=a+4|0;f[v>>2]=f[E>>2];F=k+8|0;f[F>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];G=f[a+36>>2]|0;f[k+36>>2]=G;f[k+40>>2]=F;F=k+48|0;I=k+44|0;f[I>>2]=F;f[F>>2]=0;f[k+52>>2]=0;if(G|0){F=G+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[E>>2]|0)<3){E=f[a+44>>2]|0;F=f[I>>2]|0;f[F>>2]=f[E>>2];f[F+4>>2]=f[E+4>>2];break}else{f[v>>2]=0;BR(k,a);break}}else OR(k,c,-1);while(0);c=j+16|0;a:do if(f[c>>2]|0){a=f[j+4>>2]|0;if((a|0)<3)J=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{v=f[j+40>>2]|0;E=0;F=1;while(1){I=Y(f[v+(E<<2)>>2]|0,F)|0;E=E+1|0;if((E|0)==(a|0)){J=I;break}else F=I}}if(!((a|0)==0|(J|0)==0)){F=f[k+40>>2]|0;E=f[F+-4>>2]|0;v=f[j+40>>2]|0;b:do if((E|0)==(f[v+-4>>2]|0)){if((E|0)==2){if((f[F>>2]|0)!=(f[v>>2]|0))break;if((f[F+4>>2]|0)==(f[v+4>>2]|0))break a;else break}if((E|0)>0)K=0;else break a;while(1){if((f[F+(K<<2)>>2]|0)!=(f[v+(K<<2)>>2]|0))break b;K=K+1|0;if((K|0)>=(E|0))break a}}while(0);f[l>>2]=0;f[l+4>>2]=0;B=c$(l,37)|0;C=165509;D=B+37|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));j$(-215,l,165497,165086,571);d$(l)}}while(0);C=k+4|0;B=k+40|0;MR(d,f[C>>2]|0,f[B>>2]|0,t,-1,0,0);MR(e,f[C>>2]|0,f[B>>2]|0,t,-1,0,0);do if((NS(d)|0)==65536){t=f[d+4>>2]|0;f[l>>2]=f[t>>2];D=l+4|0;K=t+4|0;f[D>>2]=f[K>>2];J=l+8|0;f[J>>2]=f[t+8>>2];f[l+12>>2]=f[t+12>>2];f[l+16>>2]=f[t+16>>2];f[l+20>>2]=f[t+20>>2];f[l+24>>2]=f[t+24>>2];f[l+28>>2]=f[t+28>>2];f[l+32>>2]=f[t+32>>2];E=f[t+36>>2]|0;f[l+36>>2]=E;f[l+40>>2]=J;J=l+48|0;v=l+44|0;f[v>>2]=J;f[J>>2]=0;f[l+52>>2]=0;if(E|0){J=E+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[K>>2]|0)<3){K=f[t+44>>2]|0;J=f[v>>2]|0;f[J>>2]=f[K>>2];f[J+4>>2]=f[K+4>>2];break}else{f[D>>2]=0;BR(l,t);break}}else OR(l,d,-1);while(0);do if((NS(e)|0)==65536){d=f[e+4>>2]|0;f[m>>2]=f[d>>2];t=m+4|0;D=d+4|0;f[t>>2]=f[D>>2];K=m+8|0;f[K>>2]=f[d+8>>2];f[m+12>>2]=f[d+12>>2];f[m+16>>2]=f[d+16>>2];f[m+20>>2]=f[d+20>>2];f[m+24>>2]=f[d+24>>2];f[m+28>>2]=f[d+28>>2];f[m+32>>2]=f[d+32>>2];J=f[d+36>>2]|0;f[m+36>>2]=J;f[m+40>>2]=K;K=m+48|0;v=m+44|0;f[v>>2]=K;f[K>>2]=0;f[m+52>>2]=0;if(J|0){K=J+12|0;f[K>>2]=(f[K>>2]|0)+1}if((f[D>>2]|0)<3){D=f[d+44>>2]|0;K=f[v>>2]|0;f[K>>2]=f[D>>2];f[K+4>>2]=f[D+4>>2];break}else{f[t>>2]=0;BR(m,d);break}}else OR(m,e,-1);while(0);f[o>>2]=j;f[o+4>>2]=k;f[o+8>>2]=l;f[o+12>>2]=m;f[o+16>>2]=0;bU(r,o,q,-1);o=s+8|0;f[s>>2]=o;e=s+4|0;f[e>>2]=264;d=Y(f[r+20>>2]|0,x)|0;t=w|1024;w=t-((t>>>0)%(x>>>0)|0)|0;x=(w|0)<(d|0)?w:d;w=1212424721>>>(f[k>>2]<<2&28)&15;if(z){z=x<<1;f[e>>2]=z;if(z>>>0>264){t=OYa(z>>>0>1073741823?-1:z<<2)|0;f[s>>2]=t;L=t}else L=o;M=L;N=L+(x<<2)|0}else{M=0;N=0}L=r+16|0;t=(d|0)>0;z=q+4|0;D=q+8|0;K=q+12|0;O=g?.17777777777777778:10.185916357881302;g=0;while(1){if(g>>>0>=(f[L>>2]|0)>>>0)break;if(t){v=0;do{J=d-v|0;E=(x|0)<(J|0)?x:J;do if(y){J=f[q>>2]|0;F=f[z>>2]|0;a=f[D>>2]|0;I=f[K>>2]|0;G=(E|0)>0;if(G){H=0;do{P=O*+n[F+(H<<2)>>2];Q=rNa(P)|0;R=P-+(Q|0);P=R*(R*(R*-1.5767166072981726e-04)+.09817477042468103);S=R*(R*-.004817389940423465)+1.0;R=+p[11056+((Q&63)<<3)>>3];T=+p[11056+((16-Q&63)<<3)>>3];n[I+(H<<2)>>2]=R*S+T*P;n[a+(H<<2)>>2]=T*S-R*P;H=H+1|0}while((H|0)!=(E|0));if((J|0)!=0&G){H=0;do{P=+n[J+(H<<2)>>2];F=a+(H<<2)|0;n[F>>2]=P*+n[F>>2];F=I+(H<<2)|0;n[F>>2]=P*+n[F>>2];H=H+1|0}while((H|0)<(E|0));U=J;A=71}else{V=J;A=72}}else{V=J;A=72}}else{H=f[q>>2]|0;I=f[z>>2]|0;a=f[D>>2]|0;G=f[K>>2]|0;F=(E|0)>0;if(F){Q=0;do{n[M+(Q<<2)>>2]=+p[I+(Q<<3)>>3];Q=Q+1|0}while((Q|0)<(E|0));if(F){Q=0;do{I=M+(Q<<2)|0;P=O*+n[I>>2];J=rNa(P)|0;R=P-+(J|0);P=R*(R*(R*-1.5767166072981726e-04)+.09817477042468103);S=R*(R*-.004817389940423465)+1.0;R=+p[11056+((J&63)<<3)>>3];T=+p[11056+((16-J&63)<<3)>>3];n[N+(Q<<2)>>2]=R*S+T*P;n[I>>2]=T*S-R*P;Q=Q+1|0}while((Q|0)!=(E|0))}}if(!H){Q=E<<2;K1a(a|0,M|0,Q|0)|0;K1a(G|0,N|0,Q|0)|0;V=f[q>>2]|0;A=72;break}if(F){Q=0;do{P=+p[H+(Q<<3)>>3];p[a+(Q<<3)>>3]=P*+n[M+(Q<<2)>>2];p[G+(Q<<3)>>3]=P*+n[N+(Q<<2)>>2];Q=Q+1|0}while((Q|0)<(E|0));U=H;A=71}else{V=H;A=72}}while(0);if((A|0)==71){A=0;W=U;X=Y(E,w)|0;A=73}else if((A|0)==72){A=0;Q=Y(E,w)|0;if(!V)Z=Q;else{W=V;X=Q;A=73}}if((A|0)==73){A=0;f[q>>2]=W+X;Z=X}f[z>>2]=(f[z>>2]|0)+Z;f[D>>2]=(f[D>>2]|0)+Z;f[K>>2]=(f[K>>2]|0)+Z;v=v+x|0}while((d|0)>(v|0))}tR(r)|0;g=g+1|0}g=f[s>>2]|0;if((g|0)!=(o|0)){if(g|0)QYa(g);f[s>>2]=o;f[e>>2]=264}e=m+36|0;o=f[e>>2]|0;if(o|0?(s=o+12|0,o=f[s>>2]|0,f[s>>2]=o+-1,(o|0)==1):0)CR(m);f[e>>2]=0;e=m+16|0;o=m+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[o>>2]|0)>0){e=f[m+40>>2]|0;s=0;do{f[e+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[o>>2]|0))}o=f[m+44>>2]|0;if((o|0)!=(m+48|0))ZF(o);o=l+36|0;m=f[o>>2]|0;if(m|0?(s=m+12|0,m=f[s>>2]|0,f[s>>2]=m+-1,(m|0)==1):0)CR(l);f[o>>2]=0;o=l+16|0;m=l+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[m>>2]|0)>0){o=f[l+40>>2]|0;s=0;do{f[o+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))ZF(m);m=k+36|0;l=f[m>>2]|0;if(l|0?(s=l+12|0,l=f[s>>2]|0,f[s>>2]=l+-1,(l|0)==1):0)CR(k);f[m>>2]=0;m=k+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[C>>2]|0)>0){m=f[B>>2]|0;B=0;do{f[m+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[C>>2]|0))}C=f[k+44>>2]|0;if((C|0)!=(k+48|0))ZF(C);C=j+36|0;k=f[C>>2]|0;if(k|0?(B=k+12|0,k=f[B>>2]|0,f[B>>2]=k+-1,(k|0)==1):0)CR(j);f[C>>2]=0;C=j+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[C>>2]|0)>0){c=f[j+40>>2]|0;k=0;do{f[c+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[C>>2]|0))}C=f[j+44>>2]|0;if((C|0)!=(j+48|0))ZF(C);if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function mN(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+176|0;e=d+168|0;g=d+112|0;h=d+56|0;i=d+40|0;j=d+32|0;k=d;_$(e,39100);l=RR(a,-1)|0;m=VS(a,-1)|0;n=WS(a,-1)|0;o=(m|0)==5;if((m+-5|0)>>>0>=2){f[g>>2]=0;f[g+4>>2]=0;m=c$(g,24)|0;p=168818;q=m+24|0;do{b[m>>0]=b[p>>0]|0;m=m+1|0;p=p+1|0}while((m|0)<(q|0));j$(-215,g,165624,165086,668);d$(g)}do if((NS(a)|0)==65536){p=f[a+4>>2]|0;f[g>>2]=f[p>>2];m=g+4|0;q=p+4|0;f[m>>2]=f[q>>2];r=g+8|0;f[r>>2]=f[p+8>>2];f[g+12>>2]=f[p+12>>2];f[g+16>>2]=f[p+16>>2];f[g+20>>2]=f[p+20>>2];f[g+24>>2]=f[p+24>>2];f[g+28>>2]=f[p+28>>2];f[g+32>>2]=f[p+32>>2];s=f[p+36>>2]|0;f[g+36>>2]=s;t=g+40|0;f[t>>2]=r;r=g+48|0;v=g+44|0;f[v>>2]=r;f[r>>2]=0;f[g+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[p+44>>2]|0;r=f[v>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];w=m;x=t;break}else{f[m>>2]=0;BR(g,p);w=m;x=t;break}}else{OR(g,a,-1);w=g+4|0;x=g+40|0}while(0);MR(c,f[w>>2]|0,f[x>>2]|0,l,-1,0,0);do if((NS(c)|0)==65536){l=f[c+4>>2]|0;f[h>>2]=f[l>>2];a=h+4|0;t=l+4|0;f[a>>2]=f[t>>2];m=h+8|0;f[m>>2]=f[l+8>>2];f[h+12>>2]=f[l+12>>2];f[h+16>>2]=f[l+16>>2];f[h+20>>2]=f[l+20>>2];f[h+24>>2]=f[l+24>>2];f[h+28>>2]=f[l+28>>2];f[h+32>>2]=f[l+32>>2];p=f[l+36>>2]|0;f[h+36>>2]=p;f[h+40>>2]=m;m=h+48|0;q=h+44|0;f[q>>2]=m;f[m>>2]=0;f[h+52>>2]=0;if(p|0){m=p+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[t>>2]|0)<3){t=f[l+44>>2]|0;m=f[q>>2]|0;f[m>>2]=f[t>>2];f[m+4>>2]=f[t+4>>2];break}else{f[a>>2]=0;BR(h,l);break}}else OR(h,c,-1);while(0);f[i>>2]=g;f[i+4>>2]=h;f[i+8>>2]=0;bU(k,i,j,-1);i=Y(f[k+20>>2]|0,n)|0;n=k+16|0;c=j+4|0;a:do if(o){l=0;while(1){if(l>>>0>=(f[n>>2]|0)>>>0)break a;RN(f[j>>2]|0,f[c>>2]|0,i);tR(k)|0;l=l+1|0}}else{l=0;while(1){if(l>>>0>=(f[n>>2]|0)>>>0)break a;SN(f[j>>2]|0,f[c>>2]|0,i);tR(k)|0;l=l+1|0}}while(0);k=h+36|0;i=f[k>>2]|0;if(i|0?(c=i+12|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)CR(h);f[k>>2]=0;k=h+16|0;i=h+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[i>>2]|0)>0){k=f[h+40>>2]|0;c=0;do{f[k+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)!=(h+48|0))ZF(i);i=g+36|0;h=f[i>>2]|0;if(h|0?(c=h+12|0,h=f[c>>2]|0,f[c>>2]=h+-1,(h|0)==1):0)CR(g);f[i>>2]=0;i=g+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[w>>2]|0)>0){i=f[x>>2]|0;x=0;do{f[i+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[w>>2]|0))}w=f[g+44>>2]|0;if((w|0)!=(g+48|0))ZF(w);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function nN(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+176|0;e=d+168|0;g=d+112|0;h=d+56|0;i=d+40|0;j=d+32|0;k=d;_$(e,39120);l=RR(a,-1)|0;m=VS(a,-1)|0;n=WS(a,-1)|0;o=(m|0)==5;if((m+-5|0)>>>0>=2){f[g>>2]=0;f[g+4>>2]=0;m=c$(g,24)|0;p=168818;q=m+24|0;do{b[m>>0]=b[p>>0]|0;m=m+1|0;p=p+1|0}while((m|0)<(q|0));j$(-215,g,165666,165086,701);d$(g)}do if((NS(a)|0)==65536){p=f[a+4>>2]|0;f[g>>2]=f[p>>2];m=g+4|0;q=p+4|0;f[m>>2]=f[q>>2];r=g+8|0;f[r>>2]=f[p+8>>2];f[g+12>>2]=f[p+12>>2];f[g+16>>2]=f[p+16>>2];f[g+20>>2]=f[p+20>>2];f[g+24>>2]=f[p+24>>2];f[g+28>>2]=f[p+28>>2];f[g+32>>2]=f[p+32>>2];s=f[p+36>>2]|0;f[g+36>>2]=s;t=g+40|0;f[t>>2]=r;r=g+48|0;v=g+44|0;f[v>>2]=r;f[r>>2]=0;f[g+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[p+44>>2]|0;r=f[v>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];w=m;x=t;break}else{f[m>>2]=0;BR(g,p);w=m;x=t;break}}else{OR(g,a,-1);w=g+4|0;x=g+40|0}while(0);MR(c,f[w>>2]|0,f[x>>2]|0,l,-1,0,0);do if((NS(c)|0)==65536){l=f[c+4>>2]|0;f[h>>2]=f[l>>2];a=h+4|0;t=l+4|0;f[a>>2]=f[t>>2];m=h+8|0;f[m>>2]=f[l+8>>2];f[h+12>>2]=f[l+12>>2];f[h+16>>2]=f[l+16>>2];f[h+20>>2]=f[l+20>>2];f[h+24>>2]=f[l+24>>2];f[h+28>>2]=f[l+28>>2];f[h+32>>2]=f[l+32>>2];p=f[l+36>>2]|0;f[h+36>>2]=p;f[h+40>>2]=m;m=h+48|0;q=h+44|0;f[q>>2]=m;f[m>>2]=0;f[h+52>>2]=0;if(p|0){m=p+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[t>>2]|0)<3){t=f[l+44>>2]|0;m=f[q>>2]|0;f[m>>2]=f[t>>2];f[m+4>>2]=f[t+4>>2];break}else{f[a>>2]=0;BR(h,l);break}}else OR(h,c,-1);while(0);f[i>>2]=g;f[i+4>>2]=h;f[i+8>>2]=0;bU(k,i,j,-1);i=Y(f[k+20>>2]|0,n)|0;n=k+16|0;c=j+4|0;a:do if(o){l=0;while(1){if(l>>>0>=(f[n>>2]|0)>>>0)break a;TN(f[j>>2]|0,f[c>>2]|0,i);tR(k)|0;l=l+1|0}}else{l=0;while(1){if(l>>>0>=(f[n>>2]|0)>>>0)break a;UN(f[j>>2]|0,f[c>>2]|0,i);tR(k)|0;l=l+1|0}}while(0);k=h+36|0;i=f[k>>2]|0;if(i|0?(c=i+12|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)CR(h);f[k>>2]=0;k=h+16|0;i=h+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[i>>2]|0)>0){k=f[h+40>>2]|0;c=0;do{f[k+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)!=(h+48|0))ZF(i);i=g+36|0;h=f[i>>2]|0;if(h|0?(c=h+12|0,h=f[c>>2]|0,f[c>>2]=h+-1,(h|0)==1):0)CR(g);f[i>>2]=0;i=g+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[w>>2]|0)>0){i=f[x>>2]|0;x=0;do{f[i+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[w>>2]|0))}w=f[g+44>>2]|0;if((w|0)!=(g+48|0))ZF(w);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function oN(a,c,d){a=a|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0;e=u;u=u+1216|0;g=e+1208|0;h=e+1152|0;i=e;j=e+1136|0;k=e+1128|0;l=e+1096|0;m=e+56|0;_$(g,39140);o=RR(a,-1)|0;q=o&7;r=o>>>3&511;s=r+1|0;t=rNa(c)|0;v=+L(+(+(t|0)-c))<2.220446049250313e-16;a:do if(!v)if((q+-5|0)>>>0<2)w=8;else{f[h>>2]=0;f[h+4>>2]=0;x=c$(h,24)|0;y=168818;z=x+24|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));j$(-215,h,165708,165086,1234);d$(h);w=8}else switch(t|0){case 0:{bT(d,a,o);p[i>>3]=1.0;p[i+8>>3]=1.0;p[i+16>>3]=1.0;p[i+24>>3]=1.0;f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=4;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;eT(d,h,j);break a;break}case 1:{ZS(a,d);break a;break}case 2:{LH(a,a,d,1.0,-1);break a;break}default:{w=8;break a}}while(0);if((w|0)==8){do if((NS(a)|0)==65536){w=f[a+4>>2]|0;f[h>>2]=f[w>>2];A=h+4|0;B=w+4|0;f[A>>2]=f[B>>2];E=h+8|0;f[E>>2]=f[w+8>>2];f[h+12>>2]=f[w+12>>2];f[h+16>>2]=f[w+16>>2];f[h+20>>2]=f[w+20>>2];f[h+24>>2]=f[w+24>>2];f[h+28>>2]=f[w+28>>2];f[h+32>>2]=f[w+32>>2];F=f[w+36>>2]|0;f[h+36>>2]=F;G=h+40|0;f[G>>2]=E;E=h+48|0;H=h+44|0;f[H>>2]=E;f[E>>2]=0;f[h+52>>2]=0;if(F|0){E=F+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[B>>2]|0)<3){B=f[w+44>>2]|0;E=f[H>>2]|0;f[E>>2]=f[B>>2];f[E+4>>2]=f[B+4>>2];I=A;J=G;break}else{f[A>>2]=0;BR(h,w);I=A;J=G;break}}else{OR(h,a,-1);I=h+4|0;J=h+40|0}while(0);MR(d,f[I>>2]|0,f[J>>2]|0,o,-1,0,0);do if((NS(d)|0)==65536){o=f[d+4>>2]|0;f[i>>2]=f[o>>2];a=i+4|0;G=o+4|0;f[a>>2]=f[G>>2];A=i+8|0;f[A>>2]=f[o+8>>2];f[i+12>>2]=f[o+12>>2];f[i+16>>2]=f[o+16>>2];f[i+20>>2]=f[o+20>>2];f[i+24>>2]=f[o+24>>2];f[i+28>>2]=f[o+28>>2];f[i+32>>2]=f[o+32>>2];w=f[o+36>>2]|0;f[i+36>>2]=w;f[i+40>>2]=A;A=i+48|0;B=i+44|0;f[B>>2]=A;f[A>>2]=0;f[i+52>>2]=0;if(w|0){A=w+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[G>>2]|0)<3){G=f[o+44>>2]|0;A=f[B>>2]|0;f[A>>2]=f[G>>2];f[A+4>>2]=f[G+4>>2];break}else{f[a>>2]=0;BR(i,o);break}}else OR(i,d,-1);while(0);f[j>>2]=h;f[j+4>>2]=i;f[j+8>>2]=0;bU(l,j,k,-1);j=Y(f[l+20>>2]|0,s)|0;b:do if(!v){if(+L(+(+L(+c)+-.5))<2.220446049250313e-16){d=(q|0)==5;o=c<0.0?(d?176:175):d?178:177;d=l+16|0;a=k+4|0;G=0;while(1){if(G>>>0>=(f[d>>2]|0)>>>0)break b;fi[o&255](f[k>>2]|0,f[a>>2]|0,j);tR(l)|0;G=G+1|0}}G=r|1024;a=G-((G>>>0)%(s>>>0)|0)|0;G=(a|0)<(j|0)?a:j;a=1212424721>>>(f[h>>2]<<2&28)&15;o=m+8|0;f[m>>2]=o;d=m+4|0;f[d>>2]=1032;if((f[h+16>>2]|0)==(f[i+16>>2]|0)){A=Y(a,G)|0;f[d>>2]=A;if(A>>>0>1032){B=OYa(A)|0;f[m>>2]=B;K=B}else K=o;M=K;N=K}else{M=0;N=0}B=l+16|0;A=(j|0)>0;w=(q|0)==5;E=(N|0)!=0;H=k+4|0;F=c<0.0;O=(M|0)!=0;P=0;while(1){if(P>>>0>=(f[B>>2]|0)>>>0)break;if(A){Q=f[k>>2]|0;R=0;do{S=j-R|0;T=(G|0)<(S|0)?G:S;do if(w){S=E?N:Q;U=f[H>>2]|0;if((S|0)!=(Q|0))K1a(S|0,Q|0,Y(T,a)|0)|0;TN(S,U,T);S=(T|0)>0;if(S)V=0;else{RN(U,U,T);break}do{W=U+(V<<2)|0;n[W>>2]=+n[W>>2]*c;V=V+1|0}while((V|0)<(T|0));RN(U,U,T);if(S)if(F){W=0;do{X=+n[Q+(W<<2)>>2];if(X<=0.0)n[U+(W<<2)>>2]=X==0.0?D:C;W=W+1|0}while((W|0)<(T|0))}else{W=0;do{if(+n[Q+(W<<2)>>2]<0.0)n[U+(W<<2)>>2]=C;W=W+1|0}while((W|0)<(T|0))}}else{W=O?M:Q;U=f[H>>2]|0;if((W|0)!=(Q|0))K1a(W|0,Q|0,Y(T,a)|0)|0;UN(W,U,T);W=(T|0)>0;if(W)Z=0;else{SN(U,U,T);break}do{S=U+(Z<<3)|0;p[S>>3]=+p[S>>3]*c;Z=Z+1|0}while((Z|0)<(T|0));SN(U,U,T);if(W)if(F){S=0;do{X=+p[Q+(S<<3)>>3];if(X<=0.0)p[U+(S<<3)>>3]=X==0.0?D:C;S=S+1|0}while((S|0)<(T|0))}else{S=0;do{if(+p[Q+(S<<3)>>3]<0.0)p[U+(S<<3)>>3]=C;S=S+1|0}while((S|0)<(T|0))}}while(0);S=Y(T,a)|0;Q=(f[k>>2]|0)+S|0;f[k>>2]=Q;f[H>>2]=(f[H>>2]|0)+S;R=R+G|0}while((j|0)>(R|0))}tR(l)|0;P=P+1|0}P=f[m>>2]|0;if((P|0)!=(o|0)){if(P|0)QYa(P);f[m>>2]=o;f[d>>2]=1032}}else{P=f[39160+(q<<2)>>2]|0;if((q|0)==7){f[m>>2]=0;f[m+4>>2]=0;x=c$(m,9)|0;y=323538;z=x+9|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));j$(-215,m,165708,165086,1250);d$(m)}d=l+16|0;o=k+4|0;G=0;while(1){if(G>>>0>=(f[d>>2]|0)>>>0)break b;Ah[P&255](f[k>>2]|0,f[o>>2]|0,j,t);tR(l)|0;G=G+1|0}}while(0);l=i+36|0;t=f[l>>2]|0;if(t|0?(j=t+12|0,t=f[j>>2]|0,f[j>>2]=t+-1,(t|0)==1):0)CR(i);f[l>>2]=0;l=i+16|0;t=i+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[t>>2]|0)>0){l=f[i+40>>2]|0;j=0;do{f[l+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[t>>2]|0))}t=f[i+44>>2]|0;if((t|0)!=(i+48|0))ZF(t);t=h+36|0;i=f[t>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)CR(h);f[t>>2]=0;t=h+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[I>>2]|0)>0){t=f[J>>2]|0;J=0;do{f[t+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[I>>2]|0))}I=f[h+44>>2]|0;if((I|0)!=(h+48|0))ZF(I)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function pN(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,j=0,k=0,l=0;f=u;u=u+16|0;g=f;if((e|0)<0){b[g>>0]=0;i=e<<1&2;j=(i^2)+-1|0;b[g+1>>0]=j>>>0<256?j:(i|0)==0?255:0;b[g+2>>0]=-1;b[g+3>>0]=1;b[g+4>>0]=(e|0)==-1&1;if((d|0)>0){i=0;do{j=b[a+i>>0]|0;if((j&255)<3)k=b[g+((j&255)+2)>>0]|0;else k=0;b[c+i>>0]=k;i=i+1|0}while((i|0)!=(d|0))}u=f;return}if((d|0)<=0){u=f;return}if((e|0)>1)l=0;else{i=0;do{b[c+i>>0]=b[a+i>>0]|0;i=i+1|0}while((i|0)!=(d|0));u=f;return}do{i=1;k=h[a+l>>0]|0;g=e;while(1){i=Y((g&1|0)==0?1:k,i)|0;k=Y(k,k)|0;if(g>>>0<=3)break;else g=g>>>1}g=Y(i,k)|0;b[c+l>>0]=g>>>0<255?g:255;l=l+1|0}while((l|0)!=(d|0));u=f;return}function qN(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=u;u=u+16|0;g=f;if((e|0)<0){h=(e|0)==-1;b[g>>0]=((h<<31>>31)+128|0)>>>0<256?h<<31>>31:-128;b[g+1>>0]=(e<<1&2^2)+255;b[g+2>>0]=127;b[g+3>>0]=1;b[g+4>>0]=h&1;if((d|0)>0){h=0;do{i=b[a+h>>0]|0;j=i<<24>>24;if(((i<<24>>24>-1?j:0-j|0)|0)<3)k=b[g+(j+2)>>0]|0;else k=0;b[c+h>>0]=k;h=h+1|0}while((h|0)!=(d|0))}u=f;return}if((d|0)<=0){u=f;return}if((e|0)>1)l=0;else{h=0;do{k=b[a+h>>0]|0;g=k<<24>>24;b[c+h>>0]=(g+128|0)>>>0<256?g:k<<24>>24>0?127:128;h=h+1|0}while((h|0)!=(d|0));u=f;return}do{h=1;k=b[a+l>>0]|0;g=e;while(1){h=Y((g&1|0)==0?1:k,h)|0;k=Y(k,k)|0;if(g>>>0<=3)break;else g=g>>>1}g=Y(h,k)|0;b[c+l>>0]=(g+128|0)>>>0<256?g:(g|0)>0?127:128;l=l+1|0}while((l|0)!=(d|0));u=f;return}function rN(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,i=0,k=0,l=0;f=u;u=u+16|0;g=f;if((e|0)<0){d[g>>1]=0;h=e<<1&2;i=(h^2)+-1|0;d[g+2>>1]=i>>>0<65536?i:(h|0)==0?65535:0;d[g+4>>1]=-1;d[g+6>>1]=1;d[g+8>>1]=(e|0)==-1&1;if((c|0)>0){h=0;do{i=d[a+(h<<1)>>1]|0;if((i&65535)<3)k=d[g+((i&65535)+2<<1)>>1]|0;else k=0;d[b+(h<<1)>>1]=k;h=h+1|0}while((h|0)!=(c|0))}u=f;return}if((c|0)<=0){u=f;return}if((e|0)>1)l=0;else{h=0;do{d[b+(h<<1)>>1]=d[a+(h<<1)>>1]|0;h=h+1|0}while((h|0)!=(c|0));u=f;return}do{h=1;k=j[a+(l<<1)>>1]|0;g=e;while(1){h=Y((g&1|0)==0?1:k,h)|0;k=Y(k,k)|0;if(g>>>0<=3)break;else g=g>>>1}g=Y(h,k)|0;d[b+(l<<1)>>1]=g>>>0<65535?g:65535;l=l+1|0}while((l|0)!=(c|0));u=f;return}function sN(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=u;u=u+16|0;g=f;if((e|0)<0){h=(e|0)==-1;d[g>>1]=((h<<31>>31)+32768|0)>>>0<65536?h<<31>>31:-32768;d[g+2>>1]=(e<<1&2^2)+65535;d[g+4>>1]=32767;d[g+6>>1]=1;d[g+8>>1]=h&1;if((c|0)>0){h=0;do{i=d[a+(h<<1)>>1]|0;j=i<<16>>16;if(((i<<16>>16>-1?j:0-j|0)|0)<3)k=d[g+(j+2<<1)>>1]|0;else k=0;d[b+(h<<1)>>1]=k;h=h+1|0}while((h|0)!=(c|0))}u=f;return}if((c|0)<=0){u=f;return}if((e|0)>1)l=0;else{h=0;do{k=d[a+(h<<1)>>1]|0;g=k<<16>>16;d[b+(h<<1)>>1]=(g+32768|0)>>>0<65536?g:k<<16>>16>0?32767:32768;h=h+1|0}while((h|0)!=(c|0));u=f;return}do{h=1;k=d[a+(l<<1)>>1]|0;g=e;while(1){h=Y((g&1|0)==0?1:k,h)|0;k=Y(k,k)|0;if(g>>>0<=3)break;else g=g>>>1}g=Y(h,k)|0;d[b+(l<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;l=l+1|0}while((l|0)!=(c|0));u=f;return}function tN(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+32|0;g=e;if((d|0)<0){h=(d|0)==-1;f[g>>2]=h<<31>>31;f[g+4>>2]=(d<<1&2^2)+-1;f[g+8>>2]=2147483647;f[g+12>>2]=1;f[g+16>>2]=h&1;if((c|0)>0){h=0;do{i=f[a+(h<<2)>>2]|0;if((((i|0)>-1?i:0-i|0)|0)<3)j=f[g+(i+2<<2)>>2]|0;else j=0;f[b+(h<<2)>>2]=j;h=h+1|0}while((h|0)!=(c|0))}u=e;return}if((c|0)<=0){u=e;return}if((d|0)>1)k=0;else{h=0;do{f[b+(h<<2)>>2]=f[a+(h<<2)>>2];h=h+1|0}while((h|0)!=(c|0));u=e;return}do{h=1;j=f[a+(k<<2)>>2]|0;g=d;while(1){h=Y((g&1|0)==0?1:j,h)|0;j=Y(j,j)|0;if(g>>>0<=3)break;else g=g>>>1}g=Y(h,j)|0;f[b+(k<<2)>>2]=g;k=k+1|0}while((k|0)!=(c|0));u=e;return}function uN(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0.0,i=0.0,j=0.0,k=0.0;e=(d|0)>-1?d:0-d|0;if((c|0)<=0)return;g=(d|0)<0;if((e|0)<=1)if(g){d=0;do{n[b+(d<<2)>>2]=1.0/+n[a+(d<<2)>>2];d=d+1|0}while((d|0)!=(c|0));return}else{d=0;do{f[b+(d<<2)>>2]=f[a+(d<<2)>>2];d=d+1|0}while((d|0)!=(c|0));return}if(g){g=0;do{h=1.0;i=1.0/+n[a+(g<<2)>>2];d=e;while(1){h=(d&1|0)==0?h:i*h;i=i*i;if(d>>>0<=3)break;else d=d>>>1}n[b+(g<<2)>>2]=i*h;g=g+1|0}while((g|0)!=(c|0));return}else{g=0;do{j=1.0;k=+n[a+(g<<2)>>2];d=e;while(1){j=(d&1|0)==0?j:k*j;k=k*k;if(d>>>0<=3)break;else d=d>>>1}n[b+(g<<2)>>2]=k*j;g=g+1|0}while((g|0)!=(c|0));return}}function vN(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0.0,h=0.0,i=0.0,j=0.0;e=(d|0)>-1?d:0-d|0;if((c|0)<=0)return;f=(d|0)<0;if((e|0)<=1)if(f){d=0;do{p[b+(d<<3)>>3]=1.0/+p[a+(d<<3)>>3];d=d+1|0}while((d|0)!=(c|0));return}else{d=0;do{p[b+(d<<3)>>3]=+p[a+(d<<3)>>3];d=d+1|0}while((d|0)!=(c|0));return}if(f){f=0;do{g=1.0;h=1.0/+p[a+(f<<3)>>3];d=e;while(1){g=(d&1|0)==0?g:h*g;h=h*h;if(d>>>0<=3)break;else d=d>>>1}p[b+(f<<3)>>3]=h*g;f=f+1|0}while((f|0)!=(c|0));return}else{f=0;do{i=1.0;j=+p[a+(f<<3)>>3];d=e;while(1){i=(d&1|0)==0?i:j*i;j=j*j;if(d>>>0<=3)break;else d=d>>>1}p[b+(f<<3)>>3]=j*i;f=f+1|0}while((f|0)!=(c|0));return}}function wN(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;_$(d,39192);oN(a,.5,b);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function xN(a,c){a=a|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0;d=u;u=u+112|0;e=d+104|0;g=d+48|0;h=d+40|0;i=d+32|0;j=d;_$(e,39212);if((VS(a,-1)|0)!=5){f[g>>2]=0;f[g+4>>2]=0;k=c$(g,15)|0;l=165797;m=k+15|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,g,165813,165086,1583);d$(g)}do if((NS(a)|0)==65536){l=f[a+4>>2]|0;f[g>>2]=f[l>>2];k=g+4|0;m=l+4|0;f[k>>2]=f[m>>2];o=g+8|0;f[o>>2]=f[l+8>>2];f[g+12>>2]=f[l+12>>2];f[g+16>>2]=f[l+16>>2];f[g+20>>2]=f[l+20>>2];f[g+24>>2]=f[l+24>>2];f[g+28>>2]=f[l+28>>2];f[g+32>>2]=f[l+32>>2];p=f[l+36>>2]|0;f[g+36>>2]=p;f[g+40>>2]=o;o=g+48|0;q=g+44|0;f[q>>2]=o;f[o>>2]=0;f[g+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[m>>2]|0)<3){m=f[l+44>>2]|0;o=f[q>>2]|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];break}else{f[k>>2]=0;BR(g,l);break}}else OR(g,a,-1);while(0);f[h>>2]=g;f[h+4>>2]=0;bU(j,h,i,-1);h=Y(((f[g>>2]|0)>>>3&511)+1|0,f[j+20>>2]|0)|0;r=c;a=j+16|0;a:do if(!h){l=0;while(1){if(l>>>0>=(f[a>>2]|0)>>>0)break a;tR(j)|0;l=l+1|0}}else{l=0;while(1){if(l>>>0>=(f[a>>2]|0)>>>0)break a;k=f[i>>2]|0;m=0;do{o=k+(m<<2)|0;if((f[o>>2]&2147483647)>>>0>2139095040)n[o>>2]=r;m=m+1|0}while((m|0)!=(h|0));tR(j)|0;l=l+1|0}}while(0);j=g+36|0;h=f[j>>2]|0;if(h|0?(i=h+12|0,h=f[i>>2]|0,f[i>>2]=h+-1,(h|0)==1):0)CR(g);f[j>>2]=0;j=g+16|0;h=g+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[h>>2]|0)>0){j=f[g+40>>2]|0;i=0;do{f[j+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)!=(g+48|0))ZF(h);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function yN(a,b){a=+a;b=+b;return +(+VN(a,b))}function zN(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+144|0;g=e+88|0;h=e+32|0;i=e+16|0;j=e;JR(g,a,0,1,0,0);JR(h,c,0,1,0,0);a:do if(((f[h>>2]^f[g>>2])&4095|0)==0?(c=f[g+40>>2]|0,a=f[c+-4>>2]|0,k=f[h+40>>2]|0,(a|0)==(f[k+-4>>2]|0)):0){if((a|0)==2){if((f[c>>2]|0)!=(f[k>>2]|0)){l=9;break}if((f[c+4>>2]|0)==(f[k+4>>2]|0))break;else{l=9;break}}if((a|0)>0){m=0;do{if((f[c+(m<<2)>>2]|0)!=(f[k+(m<<2)>>2]|0)){l=9;break a}m=m+1|0}while((m|0)<(a|0))}}else l=9;while(0);if((l|0)==9){f[i>>2]=0;f[i+4>>2]=0;l=c$(i,48)|0;a=165868;m=l+48|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(m|0));j$(-215,i,165917,165086,1699);d$(i)}f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=g;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=h;oN(i,d,j);j=h+36|0;i=f[j>>2]|0;if(i|0?(a=i+12|0,i=f[a>>2]|0,f[a>>2]=i+-1,(i|0)==1):0)CR(h);f[j>>2]=0;j=h+16|0;i=h+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[i>>2]|0)>0){j=f[h+40>>2]|0;a=0;do{f[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)!=(h+48|0))ZF(i);i=g+36|0;h=f[i>>2]|0;if(h|0?(a=h+12|0,h=f[a>>2]|0,f[a>>2]=h+-1,(h|0)==1):0)CR(g);f[i>>2]=0;i=g+16|0;h=g+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[h>>2]|0)>0){i=f[g+40>>2]|0;a=0;do{f[i+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)==(g+48|0)){u=e;return}ZF(h);u=e;return}function AN(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0.0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0.0,H=0,I=0.0,J=0.0,K=0.0,P=0.0,Q=0,S=0,T=0.0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0;d=u;u=u+128|0;e=d+112|0;g=d+56|0;h=d;_$(e,39232);do if((NS(a)|0)==65536){i=f[a+4>>2]|0;f[g>>2]=f[i>>2];j=g+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=g+8|0;f[l>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];f[g+16>>2]=f[i+16>>2];f[g+20>>2]=f[i+20>>2];f[g+24>>2]=f[i+24>>2];f[g+28>>2]=f[i+28>>2];f[g+32>>2]=f[i+32>>2];m=f[i+36>>2]|0;f[g+36>>2]=m;f[g+40>>2]=l;l=g+48|0;o=g+44|0;f[o>>2]=l;f[l>>2]=0;f[g+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];q=g;break}else{f[j>>2]=0;BR(g,i);q=g;break}}else{OR(g,a,-1);q=g}while(0);a=f[q>>2]&4095;i=(a|0)==5;if((a+-5|0)>>>0>=2){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,24)|0;k=165923;l=j+24|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,h,165948,165086,1744);d$(h)}k=g+40|0;j=f[k>>2]|0;l=f[j+4>>2]|0;o=f[j>>2]|0;if(!((l+-3|0)>>>0<2&(o|0)==1)?!((l|0)==1&(o+-3|0)>>>0<2):0){f[h>>2]=0;f[h+4>>2]=0;K1a(c$(h,130)|0,165959,130)|0;j$(-215,h,165948,165086,1748);d$(h)}pS(c,3,1,a,-1,1,96);do if((NS(c)|0)==65536){a=f[c+4>>2]|0;f[h>>2]=f[a>>2];o=h+4|0;l=a+4|0;f[o>>2]=f[l>>2];j=h+8|0;f[j>>2]=f[a+8>>2];f[h+12>>2]=f[a+12>>2];f[h+16>>2]=f[a+16>>2];f[h+20>>2]=f[a+20>>2];f[h+24>>2]=f[a+24>>2];f[h+28>>2]=f[a+28>>2];f[h+32>>2]=f[a+32>>2];m=f[a+36>>2]|0;f[h+36>>2]=m;f[h+40>>2]=j;j=h+48|0;r=h+44|0;f[r>>2]=j;f[j>>2]=0;f[h+52>>2]=0;if(m|0){j=m+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[l>>2]|0)<3){l=f[a+44>>2]|0;j=f[r>>2]|0;f[j>>2]=f[l>>2];f[j+4>>2]=f[l+4>>2];break}else{f[o>>2]=0;BR(h,a);break}}else OR(h,c,-1);while(0);c=f[g+12>>2]|0;a=(c+(f[g+8>>2]|0)|0)==5;o=g+16|0;if(i){if(a){i=f[o>>2]|0;s=i;t=i;v=+n[i>>2];w=0}else{i=f[o>>2]|0;s=i;t=i;v=1.0;w=-1}i=w+1|0;do if(!(f[q>>2]&16384)){l=f[k>>2]|0;do if((f[l>>2]|0)!=1){j=f[f[g+44>>2]>>2]|0;if((f[l+4>>2]|0)==1){x=s+(Y(j,i)|0)|0;break}else{r=(i|0)/(c|0)|0;x=s+(Y(r,j)|0)+(i-(Y(r,c)|0)<<2)|0;break}}else x=s+(i<<2)|0;while(0);y=+n[x>>2];l=w+2|0;r=f[k>>2]|0;do if((f[r>>2]|0)!=1){j=f[f[g+44>>2]>>2]|0;if((f[r+4>>2]|0)==1){z=s+(Y(j,l)|0)|0;break}else{m=(l|0)/(c|0)|0;z=s+(Y(m,j)|0)+(l-(Y(m,c)|0)<<2)|0;break}}else z=s+(l<<2)|0;while(0);A=+n[z>>2];l=w+3|0;r=f[k>>2]|0;if((f[r>>2]|0)!=1){m=f[f[g+44>>2]>>2]|0;if((f[r+4>>2]|0)==1){B=A;C=y;D=s+(Y(m,l)|0)|0;break}else{r=(l|0)/(c|0)|0;B=A;C=y;D=s+(Y(r,m)|0)+(l-(Y(r,c)|0)<<2)|0;break}}else{E=A;F=l;G=y;H=37}}else{E=+n[s+(w+2<<2)>>2];F=w+3|0;G=+n[t+(i<<2)>>2];H=37}while(0);if((H|0)==37){B=E;C=G;D=s+(F<<2)|0}I=v;J=C;K=B;P=+n[D>>2]}else{if(a){a=f[o>>2]|0;Q=a;S=a;T=+p[a>>3];U=0}else{a=f[o>>2]|0;Q=a;S=a;T=1.0;U=-1}a=U+1|0;do if(!(f[q>>2]&16384)){o=f[k>>2]|0;do if((f[o>>2]|0)!=1){D=f[f[g+44>>2]>>2]|0;if((f[o+4>>2]|0)==1){V=Q+(Y(D,a)|0)|0;break}else{F=(a|0)/(c|0)|0;V=Q+(Y(F,D)|0)+(a-(Y(F,c)|0)<<3)|0;break}}else V=Q+(a<<3)|0;while(0);y=+p[V>>3];o=U+2|0;F=f[k>>2]|0;do if((f[F>>2]|0)!=1){D=f[f[g+44>>2]>>2]|0;if((f[F+4>>2]|0)==1){W=Q+(Y(D,o)|0)|0;break}else{s=(o|0)/(c|0)|0;W=Q+(Y(s,D)|0)+(o-(Y(s,c)|0)<<3)|0;break}}else W=Q+(o<<3)|0;while(0);B=+p[W>>3];o=U+3|0;F=f[k>>2]|0;if((f[F>>2]|0)!=1){s=f[f[g+44>>2]>>2]|0;if((f[F+4>>2]|0)==1){X=B;Z=y;_=Q+(Y(s,o)|0)|0;break}else{F=(o|0)/(c|0)|0;X=B;Z=y;_=Q+(Y(F,s)|0)+(o-(Y(F,c)|0)<<3)|0;break}}else{$=B;aa=y;ba=o;H=58}}else{$=+p[Q+(U+2<<3)>>3];aa=+p[S+(a<<3)>>3];ba=U+3|0;H=58}while(0);if((H|0)==58){X=$;Z=aa;_=Q+(ba<<3)|0}I=T;J=Z;K=X;P=+p[_>>3]}do if(I==0.0){if(!(J==0.0)){X=K*K-J*4.0*P;if(!(X>=0.0)){ca=0;da=0.0;ea=0.0;fa=0.0;break}Z=+M(+X);X=(Z-K)*.5;T=(K+Z)*-.5;_=+L(+X)>+L(+T);aa=_?X:T;ca=Z>0.0?2:1;da=aa/J;ea=P/aa;fa=0.0;break}if(K==0.0){ca=(P==0.0)<<31>>31;da=0.0;ea=0.0;fa=0.0;break}else{ca=1;da=-P/K;ea=0.0;fa=0.0;break}}else{aa=1.0/I;Z=J*aa;T=K*aa;X=(Z*Z-T*3.0)*.1111111111111111;$=(P*aa*27.0+(Z*(Z*(Z*2.0))-T*(Z*9.0)))*.018518518518518517;T=X*(X*X);aa=T-$*$;if(aa>0.0){B=+M(+X)*-2.0;C=+R(+($/+M(+T)))*.3333333333333333;T=Z*.3333333333333333;ca=3;da=B*+O(+C)-T;ea=B*+O(+(C+2.0943951023931953))-T;fa=B*+O(+(C+4.1887902047863905))-T;break}if(!(aa==0.0)){T=+N(+(+M(+-aa)+ +L(+$)),.3333333333333333);aa=$>0.0?-T:T;ca=1;da=aa+X/aa-Z*.3333333333333333;ea=0.0;fa=0.0;break}aa=Z/3.0;if(!($>=0.0)){Z=+N(+-$,.3333333333333333);ga=-Z;ha=Z*2.0}else{Z=+N(+$,.3333333333333333);ga=Z;ha=Z*-2.0}Z=ga-aa;$=ha-aa;_=$==Z;ca=_?1:2;da=$;ea=_?0.0:Z;fa=0.0}while(0);_=f[h>>2]|0;ba=h+16|0;Q=f[ba>>2]|0;if((_&4095|0)==5){n[Q>>2]=da;do if(!(_&16384)){U=f[h+40>>2]|0;do if((f[U>>2]|0)!=1){a=f[f[h+44>>2]>>2]|0;if((f[U+4>>2]|0)==1){ia=Q+a|0;break}else{S=f[h+12>>2]|0;c=(S+1|0)>>>0<3?S:0;ia=Q+(Y(c,a)|0)+(1-(Y(c,S)|0)<<2)|0;break}}else ia=Q+4|0;while(0);n[ia>>2]=ea;U=f[h+40>>2]|0;if((f[U>>2]|0)!=1){S=f[f[h+44>>2]>>2]|0;if((f[U+4>>2]|0)==1){ja=Q+(S<<1)|0;break}else{U=f[h+12>>2]|0;c=2/(U|0)|0;ja=Q+(Y(c,S)|0)+(2-(Y(c,U)|0)<<2)|0;break}}else H=87}else{n[Q+4>>2]=ea;H=87}while(0);if((H|0)==87)ja=Q+8|0;n[ja>>2]=fa}else{p[Q>>3]=da;do if(!(_&16384)){ja=f[h+40>>2]|0;do if((f[ja>>2]|0)!=1){ia=f[f[h+44>>2]>>2]|0;if((f[ja+4>>2]|0)==1){ka=Q+ia|0;break}else{U=f[h+12>>2]|0;c=(U+1|0)>>>0<3?U:0;ka=Q+(Y(c,ia)|0)+(1-(Y(c,U)|0)<<3)|0;break}}else ka=Q+8|0;while(0);p[ka>>3]=ea;ja=f[h+40>>2]|0;if((f[ja>>2]|0)!=1){U=f[f[h+44>>2]>>2]|0;if((f[ja+4>>2]|0)==1){la=Q+(U<<1)|0;break}else{ja=f[h+12>>2]|0;c=2/(ja|0)|0;la=Q+(Y(c,U)|0)+(2-(Y(c,ja)|0)<<3)|0;break}}else H=100}else{p[Q+8>>3]=ea;H=100}while(0);if((H|0)==100)la=Q+16|0;p[la>>3]=fa}la=h+36|0;Q=f[la>>2]|0;if(Q|0?(H=Q+12|0,Q=f[H>>2]|0,f[H>>2]=Q+-1,(Q|0)==1):0)CR(h);f[la>>2]=0;la=h+4|0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[la>>2]|0)>0){ba=f[h+40>>2]|0;Q=0;do{f[ba+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[la>>2]|0))}la=f[h+44>>2]|0;if((la|0)!=(h+48|0))ZF(la);la=g+36|0;h=f[la>>2]|0;if(h|0?(Q=h+12|0,h=f[Q>>2]|0,f[Q>>2]=h+-1,(h|0)==1):0)CR(g);f[la>>2]=0;la=g+16|0;h=g+4|0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[h>>2]|0)>0){la=f[k>>2]|0;k=0;do{f[la+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)!=(g+48|0))ZF(h);if(!(f[e+4>>2]|0)){u=d;return ca|0}u=d;return ca|0}function BN(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0,ka=0,la=0.0,ma=0.0,na=0.0,oa=0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0;e=u;u=u+1552|0;g=e+1528|0;h=e+1520|0;i=e+1464|0;j=e+1408|0;k=e;l=e+1344|0;m=e+1400|0;n=e+1288|0;o=e+1176|0;q=e+1160|0;r=e+1232|0;_$(h,39252);do if((NS(a)|0)==65536){s=f[a+4>>2]|0;f[i>>2]=f[s>>2];t=i+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=i+8|0;f[w>>2]=f[s+8>>2];f[i+12>>2]=f[s+12>>2];f[i+16>>2]=f[s+16>>2];f[i+20>>2]=f[s+20>>2];f[i+24>>2]=f[s+24>>2];f[i+28>>2]=f[s+28>>2];f[i+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[i+36>>2]=x;f[i+40>>2]=w;w=i+48|0;y=i+44|0;f[y>>2]=w;f[w>>2]=0;f[i+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[t>>2]=0;BR(i,s);break}}else OR(i,a,-1);while(0);s=RR(a,-1)|0;a=s&7;if(!(a>>>0>4?((s>>>3&511)+1|0)>>>0<3:0)){f[g>>2]=0;f[g+4>>2]=0;z=c$(g,81)|0;A=166134;B=z+81|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-215,g,166216,165086,1895);d$(g)}s=i+8|0;t=f[s>>2]|0;v=i+12|0;if((t|0)!=1)if((f[v>>2]|0)==1)C=t;else{f[g>>2]=0;f[g+4>>2]=0;z=c$(g,38)|0;A=166226;B=z+38|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));j$(-215,g,166216,165086,1896);d$(g);C=f[s>>2]|0}else C=1;s=f[v>>2]|0;v=s+-2+C|0;pS(c,v,1,a|8,-1,1,96);do if((NS(c)|0)==65536){a=f[c+4>>2]|0;f[j>>2]=f[a>>2];A=j+4|0;t=a+4|0;f[A>>2]=f[t>>2];w=j+8|0;f[w>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];y=f[a+36>>2]|0;f[j+36>>2]=y;f[j+40>>2]=w;w=j+48|0;x=j+44|0;f[x>>2]=w;f[w>>2]=0;f[j+52>>2]=0;if(y|0){w=y+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[t>>2]|0)<3){t=f[a+44>>2]|0;w=f[x>>2]|0;f[w>>2]=f[t>>2];f[w+4>>2]=f[t+4>>2];break}else{f[A>>2]=0;BR(j,a);break}}else OR(j,c,-1);while(0);c=(v<<1)+2|0;a=k+8|0;F1a(a|0,0,1152)|0;f[k>>2]=a;A=k+4|0;f[A>>2]=c;if(c>>>0>72){t=OYa(c>>>0>268435455?-1:c<<4)|0;F1a(t|0,0,c<<4|0)|0;f[k>>2]=t;D=t}else D=a;t=D+(v<<4)+16|0;c=i+40|0;w=f[c>>2]|0;x=f[w>>2]|0;f[m>>2]=f[w+4>>2];f[m+4>>2]=x;x=((f[i>>2]|0)>>>3&511)+1|0;CN(l,m,(x<<3)+-2|0,(x|0)==2?D:t,0);x=g+8|0;f[x>>2]=0;f[x+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=l;WJ(i,g,f[l>>2]&4095,1.0,0.0);if(!(f[i>>2]&4088))if((v|0)<0){E=0;F=v}else{x=s+C+-1|0;C=0;do{p[D+(C<<4)>>3]=+p[t+(C<<3)>>3];p[D+(C<<4)+8>>3]=0.0;C=C+1|0}while((C|0)!=(x|0));G=26}else G=26;do if((G|0)==26){if((v|0)<=1)if((v|0)==1){H=1;I=1}else{E=0;F=v;break}else{x=v;while(1){J=+L(+(+p[D+(x<<4)>>3]));if(J+ +L(+(+p[D+(x<<4)+8>>3]))>2.220446049250313e-16){K=x;break}x=x+-1|0;if((x|0)<=1){K=1;break}}H=(K|0)>0;I=K}x=0;J=1.0;O=0.0;while(1){C=t+(x<<4)|0;p[C>>3]=J;p[C+8>>3]=O;P=J+O;x=x+1|0;if((x|0)==(I|0)){E=H;F=I;break}else{J=J-O;O=P}}}while(0);I=(d|0)<1?1e3:d;a:do if((I|0)>0){d=D+(F<<4)|0;H=D+(F<<4)+8|0;K=n+4|0;x=n+8|0;C=n+40|0;s=n+48|0;m=n+44|0;w=n+52|0;y=g+4|0;Q=o+4|0;R=o+8|0;S=o+40|0;T=o+48|0;U=o+44|0;V=o+52|0;W=n+16|0;X=n+12|0;Z=g+8|0;_=g+12|0;$=g+4|0;aa=q+8|0;ba=q+4|0;ca=o+16|0;da=o+36|0;ea=n+36|0;fa=0;while(1){if(E){ga=0;ha=0.0}else{ia=0.0;break a}do{ja=t+(ga<<4)|0;O=+p[ja>>3];ka=ja+8|0;J=+p[ka>>3];P=+p[d>>3];la=+p[H>>3];ma=P;na=la;oa=0;pa=P;P=la;qa=1;while(1){ra=F-oa+-1|0;la=pa;pa=O*pa-J*P+ +p[D+(ra<<4)>>3];P=J*la+O*P+ +p[D+(ra<<4)+8>>3];do if((oa|0)!=(ga|0)){ra=t+(oa<<4)|0;la=O-+p[ra>>3];sa=J-+p[ra+8>>3];if(la!=0.0|sa!=0.0){ta=ma*la-na*sa;ua=na*la+ma*sa;va=qa;break}else{ta=ma;ua=na;va=qa+1|0;break}}else{ta=ma;ua=na;va=qa}while(0);oa=oa+1|0;if((oa|0)==(F|0))break;else{ma=ta;na=ua;qa=va}}na=1.0/(ta*ta+ua*ua);ma=na*(ta*pa+ua*P);sa=na*(ta*P-ua*pa);if((va|0)>1){if(((va<<31>>31)+(va>>>1)|0)>0){na=ma+ +M(+(ma*ma+sa*sa));la=+M(+(na*.5));wa=+M(+((na-ma)*.5));xa=la;ya=ma<0.0?-wa:wa}else{xa=ma;ya=sa}if(!(va&1)){za=xa;Aa=ya}else{f[n>>2]=1124007936;z=K;B=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(B|0));f[C>>2]=x;f[m>>2]=s;f[s>>2]=0;f[w>>2]=0;f[g>>2]=4;f[y>>2]=1;AR(n,2,g,6);f[o>>2]=1124007936;z=Q;B=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(B|0));f[S>>2]=R;f[U>>2]=T;f[T>>2]=0;f[V>>2]=0;f[g>>2]=3;f[y>>2]=1;AR(o,2,g,14);pa=-+N(+ma,3.0);qa=(f[n>>2]&16384|0)==0;oa=f[W>>2]|0;do if(qa?(ra=f[C>>2]|0,(f[ra>>2]|0)!=1):0){Ba=f[f[m>>2]>>2]|0;if((f[ra+4>>2]|0)==1){Ca=oa+(Ba*3|0)|0;break}else{ra=f[X>>2]|0;Da=3/(ra|0)|0;Ca=oa+(Y(Da,Ba)|0)+(3-(Y(Da,ra)|0)<<3)|0;break}}else G=49;while(0);if((G|0)==49){G=0;Ca=oa+24|0}p[Ca>>3]=pa;P=-(ma*ma*15.0+sa*sa*27.0);do if(qa){ra=f[C>>2]|0;do if((f[ra>>2]|0)!=1){Da=f[f[m>>2]>>2]|0;if((f[ra+4>>2]|0)==1){Ea=oa+(Da<<1)|0;break}else{Ba=f[X>>2]|0;Fa=2/(Ba|0)|0;Ea=oa+(Y(Fa,Da)|0)+(2-(Y(Fa,Ba)|0)<<3)|0;break}}else Ea=oa+16|0;while(0);p[Ea>>3]=P;wa=ma*-48.0;ra=f[C>>2]|0;if((f[ra>>2]|0)!=1){Ba=f[f[m>>2]>>2]|0;if((f[ra+4>>2]|0)==1){Ga=wa;Ha=oa+Ba|0;break}else{ra=f[X>>2]|0;Fa=(ra+1|0)>>>0<3?ra:0;Ga=wa;Ha=oa+(Y(Fa,Ba)|0)+(1-(Y(Fa,ra)|0)<<3)|0;break}}else{Ia=wa;G=61}}else{p[oa+16>>3]=P;Ia=ma*-48.0;G=61}while(0);if((G|0)==61){G=0;Ga=Ia;Ha=oa+8|0}p[Ha>>3]=Ga;p[oa>>3]=64.0;f[Z>>2]=0;f[_>>2]=0;f[g>>2]=16842752;f[$>>2]=n;qa=aa;f[qa>>2]=0;f[qa+4>>2]=0;f[q>>2]=33619968;f[ba>>2]=o;AN(g,q)|0;P=+p[f[ca>>2]>>3];if(!(P>=0.0))Ja=-+N(+-P,.3333333333333333);else Ja=+N(+P,.3333333333333333);P=+M(+(Ja*Ja/3.0-ma/(Ja*3.0)));qa=f[da>>2]|0;do if(qa|0){ra=qa+12|0;Fa=f[ra>>2]|0;f[ra>>2]=Fa+-1;if((Fa|0)!=1)break;CR(o)}while(0);f[da>>2]=0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[Q>>2]|0)>0){qa=f[S>>2]|0;oa=0;do{f[qa+(oa<<2)>>2]=0;oa=oa+1|0}while((oa|0)<(f[Q>>2]|0))}oa=f[U>>2]|0;if((oa|0)!=(T|0))ZF(oa);oa=f[ea>>2]|0;do if(oa|0){qa=oa+12|0;Fa=f[qa>>2]|0;f[qa>>2]=Fa+-1;if((Fa|0)!=1)break;CR(n)}while(0);f[ea>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[K>>2]|0)>0){oa=f[C>>2]|0;Fa=0;do{f[oa+(Fa<<2)>>2]=0;Fa=Fa+1|0}while((Fa|0)<(f[K>>2]|0))}Fa=f[m>>2]|0;if((Fa|0)!=(s|0))ZF(Fa);za=Ja;Aa=P}}else{za=ma;Aa=sa}p[ja>>3]=O-za;p[ka>>3]=J-Aa;pa=+M(+(za*za+Aa*Aa));ha=ha<pa?pa:ha;ga=ga+1|0}while((ga|0)<(F|0));fa=fa+1|0;if(!(!(ha<=0.0)&(fa|0)<(I|0))){Ka=ha;G=87;break}}}else{Ka=0.0;G=87}while(0);if((G|0)==87)if((f[i>>2]&4088|0)==0&E){E=0;do{G=t+(E<<4)+8|0;if(+L(+(+p[G>>3]))<1.0e-100)p[G>>3]=0.0;E=E+1|0}while((E|0)!=(F|0));ia=Ka}else ia=Ka;if((F|0)<(v|0)){E=F;do{F=t+(E<<4)|0;E=E+1|0;G=t+(E<<4)|0;f[G>>2]=f[F>>2];f[G+4>>2]=f[F+4>>2];f[G+8>>2]=f[F+8>>2];f[G+12>>2]=f[F+12>>2]}while((E|0)!=(v|0))}v=j+40|0;E=f[v>>2]|0;F=f[E+4>>2]|0;G=f[E>>2]|0;E=r+4|0;f[E>>2]=2;I=r+8|0;f[I>>2]=G;f[r+12>>2]=F;ga=r+16|0;f[ga>>2]=t;f[r+20>>2]=t;n=r+24|0;o=r+40|0;q=n+8|0;f[q>>2]=0;f[q+4>>2]=0;f[o>>2]=I;I=r+48|0;q=r+44|0;f[q>>2]=I;Ha=F<<4;f[r>>2]=1124024334;f[I>>2]=Ha;f[r+52>>2]=16;F=t+(Y(G,Ha)|0)|0;f[r+28>>2]=F;f[n>>2]=F+(0-Ha)+Ha;Ha=g+8|0;f[Ha>>2]=0;f[Ha+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;WJ(r,g,f[j>>2]&4095,1.0,0.0);g=r+36|0;Ha=f[g>>2]|0;if(Ha|0?(F=Ha+12|0,Ha=f[F>>2]|0,f[F>>2]=Ha+-1,(Ha|0)==1):0)CR(r);f[g>>2]=0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[E>>2]|0)>0){ga=f[o>>2]|0;o=0;do{f[ga+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[E>>2]|0))}E=f[q>>2]|0;if((E|0)!=(I|0))ZF(E);E=l+36|0;I=f[E>>2]|0;if(I|0?(q=I+12|0,I=f[q>>2]|0,f[q>>2]=I+-1,(I|0)==1):0)CR(l);f[E>>2]=0;E=l+16|0;I=l+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[I>>2]|0)>0){E=f[l+40>>2]|0;q=0;do{f[E+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[I>>2]|0))}I=f[l+44>>2]|0;if((I|0)!=(l+48|0))ZF(I);I=f[k>>2]|0;if((I|0)!=(a|0)){if(I|0)QYa(I);f[k>>2]=a;f[A>>2]=72}A=j+36|0;a=f[A>>2]|0;if(a|0?(k=a+12|0,a=f[k>>2]|0,f[k>>2]=a+-1,(a|0)==1):0)CR(j);f[A>>2]=0;A=j+16|0;a=j+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[a>>2]|0)>0){A=f[v>>2]|0;v=0;do{f[A+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[a>>2]|0))}a=f[j+44>>2]|0;if((a|0)!=(j+48|0))ZF(a);a=i+36|0;j=f[a>>2]|0;do if(j|0){v=j+12|0;A=f[v>>2]|0;f[v>>2]=A+-1;if((A|0)!=1)break;CR(i)}while(0);f[a>>2]=0;a=i+16|0;j=i+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[j>>2]|0)>0){a=f[c>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))ZF(j);if(!(f[h+4>>2]|0)){u=e;return +ia}u=e;return +ia}function CN(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=u;u=u+16|0;i=h;f[a>>2]=d&4095|1124007936;f[a+4>>2]=2;j=a+8|0;k=f[c+4>>2]|0;f[j>>2]=k;l=a+12|0;m=f[c>>2]|0;f[l>>2]=m;f[a+16>>2]=e;c=a+20|0;f[c>>2]=e;n=a+24|0;o=a+28|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[a+40>>2]=j;p=a+48|0;q=a+44|0;f[q>>2]=p;f[a+52>>2]=0;f[p>>2]=0;if((Y(m,k)|0)!=0&(e|0)==0){f[i>>2]=0;f[i+4>>2]=0;r=c$(i,26)|0;s=358223;t=r+26|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-215,i,358250,358254,533);d$(i);v=f[l>>2]|0}else v=m;m=d&7;l=(d>>>3&511)+1<<(47696>>>(m<<1)&3);d=Y(v,l)|0;if(!g){w=d;x=16384;y=f[a>>2]|0;z=y|x;f[a>>2]=z;A=f[q>>2]|0;f[A>>2]=w;B=A+4|0;f[B>>2]=l;C=f[c>>2]|0;D=f[j>>2]|0;E=Y(D,w)|0;F=C+E|0;f[o>>2]=F;G=0-w|0;H=F+G|0;I=H+d|0;f[n>>2]=I;u=h;return}v=(f[j>>2]|0)==1?d:g;if((v>>>0)%((1212424721>>>(m<<2)&15)>>>0)|0|0){f[i>>2]=0;f[i+4>>2]=0;r=c$(i,31)|0;s=172705;t=r+31|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));j$(-13,i,358250,358254,549);d$(i)}w=v;x=(v|0)==(d|0)?16384:0;y=f[a>>2]|0;z=y|x;f[a>>2]=z;A=f[q>>2]|0;f[A>>2]=w;B=A+4|0;f[B>>2]=l;C=f[c>>2]|0;D=f[j>>2]|0;E=Y(D,w)|0;F=C+E|0;f[o>>2]=F;G=0-w|0;H=F+G|0;I=H+d|0;f[n>>2]=I;u=h;return}function DN(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0;g=u;u=u+16|0;h=g;_$(h,39272);i=e?1.0:.01745329238474369;if((d|0)>0){e=0;do{j=+n[a+(e<<2)>>2];k=+n[b+(e<<2)>>2];l=+L(+k);m=+L(+j);if(!(l>=m)){o=l/(m+2.220446049250313e-16);p=o*o;q=90.0-o*(p*(p*(8.914000511169434-p*2.539724588394165)+-18.66744613647461)+57.283626556396484)}else{p=m/(l+2.220446049250313e-16);l=p*p;q=p*(l*(l*(8.914000511169434-l*2.539724588394165)+-18.66744613647461)+57.283626556396484)}l=k<0.0?180.0-q:q;n[c+(e<<2)>>2]=i*(j<0.0?360.0-l:l);e=e+1|0}while((e|0)!=(d|0))}if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function EN(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,q=0.0;g=u;u=u+16|0;h=g;_$(h,39292);i=e?1.0:.017453292519943295;if((d|0)>0){e=0;do{j=+p[a+(e<<3)>>3];k=+p[b+(e<<3)>>3];l=+L(+k);m=+L(+j);if(!(l>=m)){n=l/(m+2.220446049250313e-16);o=n*n;q=90.0-n*(o*(o*(8.914000511169434-o*2.539724588394165)+-18.66744613647461)+57.283626556396484)}else{o=m/(l+2.220446049250313e-16);l=o*o;q=o*(l*(l*(8.914000511169434-l*2.539724588394165)+-18.66744613647461)+57.283626556396484)}l=k<0.0?180.0-q:q;p[c+(e<<3)>>3]=i*(j<0.0?360.0-l:l);e=e+1|0}while((e|0)!=(d|0))}if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function FN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0.0,m=0,o=0.0,q=0,r=0.0,t=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=u;u=u+16|0;e=d;_$(e,39432);g=c+-4|0;if((c|0)<4)h=0;else{i=0;do{j=+n[a+(i<<2)>>2];k=i|1;l=+n[a+(k<<2)>>2];m=i|2;o=+n[a+(m<<2)>>2];q=i|3;r=+n[a+(q<<2)>>2];t=(n[s>>2]=j,f[s>>2]|0);v=(t&2130706432)>>>0>1149239296?((t|0)<0?-192.0e3:192.0e3):j*92.33248261689366;t=(n[s>>2]=l,f[s>>2]|0);j=(t&2130706432)>>>0>1149239296?((t|0)<0?-192.0e3:192.0e3):l*92.33248261689366;t=(n[s>>2]=o,f[s>>2]|0);l=(t&2130706432)>>>0>1149239296?((t|0)<0?-192.0e3:192.0e3):o*92.33248261689366;t=(n[s>>2]=r,f[s>>2]|0);o=(t&2130706432)>>>0>1149239296?((t|0)<0?-192.0e3:192.0e3):r*92.33248261689366;t=rNa(v)|0;w=rNa(j)|0;x=rNa(l)|0;y=rNa(o)|0;r=(v-+(t|0))*.015625;v=(j-+(w|0))*.015625;j=(l-+(x|0))*.015625;l=(o-+(y|0))*.015625;z=t>>6;A=z+127|0;B=w>>6;C=B+127|0;D=x>>6;E=D+127|0;F=y>>6;G=F+127|0;o=+p[11568+((t&63)<<3)>>3]*(f[s>>2]=(A>>>0>255?((z|0)<-127?0:255):A)<<23,+n[s>>2])*(r*(r*(r*(r+5.73953104019165)+24.84149932861328)+71.67741394042969)+103.40864562988281);r=+p[11568+((w&63)<<3)>>3]*(f[s>>2]=(C>>>0>255?((B|0)<-127?0:255):C)<<23,+n[s>>2])*(v*(v*(v*(v+5.73953104019165)+24.84149932861328)+71.67741394042969)+103.40864562988281);n[b+(i<<2)>>2]=o;n[b+(k<<2)>>2]=r;r=+p[11568+((x&63)<<3)>>3]*(f[s>>2]=(E>>>0>255?((D|0)<-127?0:255):E)<<23,+n[s>>2])*(j*(j*(j*(j+5.73953104019165)+24.84149932861328)+71.67741394042969)+103.40864562988281);j=+p[11568+((y&63)<<3)>>3]*(f[s>>2]=(G>>>0>255?((F|0)<-127?0:255):G)<<23,+n[s>>2])*(l*(l*(l*(l+5.73953104019165)+24.84149932861328)+71.67741394042969)+103.40864562988281);n[b+(m<<2)>>2]=r;n[b+(q<<2)>>2]=j;i=i+4|0}while((i|0)<=(g|0));h=c&-4}if((h|0)<(c|0)){g=h;do{j=+n[a+(g<<2)>>2];h=(n[s>>2]=j,f[s>>2]|0);r=(h&2130706432)>>>0>1149239296?((h|0)<0?-192.0e3:192.0e3):j*92.33248261689366;h=rNa(r)|0;i=h>>6;q=i+127|0;j=(r-+(h|0))*.015625;n[b+(g<<2)>>2]=+p[11568+((h&63)<<3)>>3]*(f[s>>2]=(q>>>0>255?((i|0)<-127?0:255):q)<<23,+n[s>>2])*(j*(j*(j*(j+5.73953104019165)+24.84149932861328)+71.67741394042969)+103.40864562988281);g=g+1|0}while((g|0)!=(c|0))}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function GN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0.0,m=0,n=0.0,o=0,q=0.0,r=0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=u;u=u+16|0;e=d;_$(e,39452);g=c+-4|0;if((c|0)<4)h=0;else{i=0;do{j=+p[a+(i<<3)>>3];k=i|1;l=+p[a+(k<<3)>>3];m=i|2;n=+p[a+(m<<3)>>3];o=i|3;q=+p[a+(o<<3)>>3];p[s>>3]=j;r=H1a(f[s>>2]|0,f[s+4>>2]|0,52)|0;t=(r&2046)>>>0>1033?((r|0)<0?-192.0e3:192.0e3):j*92.33248261689366;p[s>>3]=l;r=H1a(f[s>>2]|0,f[s+4>>2]|0,52)|0;j=(r&2046)>>>0>1033?((r|0)<0?-192.0e3:192.0e3):l*92.33248261689366;p[s>>3]=n;r=H1a(f[s>>2]|0,f[s+4>>2]|0,52)|0;l=(r&2046)>>>0>1033?((r|0)<0?-192.0e3:192.0e3):n*92.33248261689366;p[s>>3]=q;r=H1a(f[s>>2]|0,f[s+4>>2]|0,52)|0;n=(r&2046)>>>0>1033?((r|0)<0?-192.0e3:192.0e3):q*92.33248261689366;r=rNa(t)|0;v=rNa(j)|0;w=rNa(l)|0;x=rNa(n)|0;q=(t-+(r|0))*.015625;t=(j-+(v|0))*.015625;j=(l-+(w|0))*.015625;l=(n-+(x|0))*.015625;y=r>>6;z=y+1023|0;A=R1a((z>>>0>2047?((y|0)<-1023?0:2047):z)|0,0,52)|0;z=J;y=v>>6;B=y+1023|0;C=R1a((B>>>0>2047?((y|0)<-1023?0:2047):B)|0,0,52)|0;B=J;y=w>>6;D=y+1023|0;E=R1a((D>>>0>2047?((y|0)<-1023?0:2047):D)|0,0,52)|0;D=J;y=x>>6;F=y+1023|0;G=R1a((F>>>0>2047?((y|0)<-1023?0:2047):F)|0,0,52)|0;F=J;f[s>>2]=A;f[s+4>>2]=z;n=+p[11568+((r&63)<<3)>>3]*+p[s>>3]*(q*(q*(q*(q*(q*.13825440165858396+.9945944344074722)+5.7396048189422615)+24.841498169168357)+71.67741243389332)+103.4086474621308);f[s>>2]=C;f[s+4>>2]=B;q=+p[11568+((v&63)<<3)>>3]*+p[s>>3]*(t*(t*(t*(t*(t*.13825440165858396+.9945944344074722)+5.7396048189422615)+24.841498169168357)+71.67741243389332)+103.4086474621308);p[b+(i<<3)>>3]=n;p[b+(k<<3)>>3]=q;f[s>>2]=E;f[s+4>>2]=D;q=+p[11568+((w&63)<<3)>>3]*+p[s>>3]*(j*(j*(j*(j*(j*.13825440165858396+.9945944344074722)+5.7396048189422615)+24.841498169168357)+71.67741243389332)+103.4086474621308);f[s>>2]=G;f[s+4>>2]=F;j=+p[11568+((x&63)<<3)>>3]*+p[s>>3]*(l*(l*(l*(l*(l*.13825440165858396+.9945944344074722)+5.7396048189422615)+24.841498169168357)+71.67741243389332)+103.4086474621308);p[b+(m<<3)>>3]=q;p[b+(o<<3)>>3]=j;i=i+4|0}while((i|0)<=(g|0));h=c&-4}if((h|0)<(c|0)){g=h;do{j=+p[a+(g<<3)>>3];p[s>>3]=j;h=H1a(f[s>>2]|0,f[s+4>>2]|0,52)|0;q=(h&2046)>>>0>1033?((h|0)<0?-192.0e3:192.0e3):j*92.33248261689366;h=rNa(q)|0;i=h>>6;o=i+1023|0;m=R1a((o>>>0>2047?((i|0)<-1023?0:2047):o)|0,0,52)|0;o=J;j=(q-+(h|0))*.015625;f[s>>2]=m;f[s+4>>2]=o;p[b+(g<<3)>>3]=+p[11568+((h&63)<<3)>>3]*+p[s>>3]*(j*(j*(j*(j*(j*.13825440165858396+.9945944344074722)+5.7396048189422615)+24.841498169168357)+71.67741243389332)+103.4086474621308);g=g+1|0}while((g|0)!=(c|0))}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function HN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0;d=u;u=u+16|0;e=d;_$(e,39472);g=c+-4|0;if((c|0)<4)h=0;else{i=0;do{j=f[a+(i<<2)>>2]|0;k=i|1;l=f[a+(k<<2)>>2]|0;m=j>>>14&510;o=l>>>14&510;q=i|2;r=f[a+(q<<2)>>2]|0;t=i|3;v=f[a+(t<<2)>>2]|0;w=((f[s>>2]=j&32767|1065353216,+n[s>>2])+-1.0)*+p[16+((m|1)<<3)>>3];x=((f[s>>2]=l&32767|1065353216,+n[s>>2])+-1.0)*+p[16+((o|1)<<3)>>3];y=r>>>14&510;z=v>>>14&510;A=+p[16+(y<<3)>>3]+ +((r>>>23&255)+-127|0)*.6931471805599453;B=+p[16+(z<<3)>>3]+ +((v>>>23&255)+-127|0)*.6931471805599453;C=((f[s>>2]=r&32767|1065353216,+n[s>>2])+-1.0)*+p[16+((y|1)<<3)>>3];D=((f[s>>2]=v&32767|1065353216,+n[s>>2])+-1.0)*+p[16+((z|1)<<3)>>3];E=w+ +n[39492+(((m|0)==510&1)<<2)>>2];w=x+ +n[39492+(((o|0)==510&1)<<2)>>2];x=+p[16+(o<<3)>>3]+ +((l>>>23&255)+-127|0)*.6931471805599453+w*(w*(w*.3333333432674408+-.5)+1.0);n[b+(i<<2)>>2]=+p[16+(m<<3)>>3]+ +((j>>>23&255)+-127|0)*.6931471805599453+E*(E*(E*.3333333432674408+-.5)+1.0);n[b+(k<<2)>>2]=x;x=C+ +n[39492+(((y|0)==510&1)<<2)>>2];C=D+ +n[39492+(((z|0)==510&1)<<2)>>2];n[b+(q<<2)>>2]=A+x*(x*(x*.3333333432674408+-.5)+1.0);n[b+(t<<2)>>2]=B+C*(C*(C*.3333333432674408+-.5)+1.0);i=i+4|0}while((i|0)<=(g|0));h=c&-4}if((h|0)<(c|0)){g=h;do{h=f[a+(g<<2)>>2]|0;i=h>>>14&510;C=+n[39492+(((i|0)==510&1)<<2)>>2]+ +p[16+((i|1)<<3)>>3]*((f[s>>2]=h&32767|1065353216,+n[s>>2])+-1.0);n[b+(g<<2)>>2]=+p[16+(i<<3)>>3]+ +((h>>>23&255)+-127|0)*.6931471805599453+C*(C*(C*.3333333432674408+-.5)+1.0);g=g+1|0}while((g|0)!=(c|0))}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function IN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0.0,r=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0;d=u;u=u+16|0;e=d;_$(e,39500);g=c+-4|0;if((c|0)<4)h=0;else{i=0;do{j=a+(i<<3)|0;k=i|1;l=a+(k<<3)|0;m=f[l>>2]|0;n=f[j+4>>2]|0;o=f[l+4>>2]|0;f[s>>2]=f[j>>2];f[s+4>>2]=n&4095|1072693248;q=+p[s>>3];f[s>>2]=m;f[s+4>>2]=o&4095|1072693248;m=i|2;j=a+(m<<3)|0;l=i|3;r=a+(l<<3)|0;t=f[r>>2]|0;v=n>>>11&510;w=o>>>11&510;x=+p[16+(v<<3)>>3]+ +((n>>>20&2047)+-1023|0)*.6931471805599453;y=+p[16+(w<<3)>>3]+ +((o>>>20&2047)+-1023|0)*.6931471805599453;o=f[j+4>>2]|0;n=f[r+4>>2]|0;z=(q+-1.0)*+p[16+((v|1)<<3)>>3];q=(+p[s>>3]+-1.0)*+p[16+((w|1)<<3)>>3];f[s>>2]=f[j>>2];f[s+4>>2]=o&4095|1072693248;A=+p[s>>3];f[s>>2]=t;f[s+4>>2]=n&4095|1072693248;t=o>>>11&510;j=n>>>11&510;B=+p[16+(t<<3)>>3]+ +((o>>>20&2047)+-1023|0)*.6931471805599453;C=+p[16+(j<<3)>>3]+ +((n>>>20&2047)+-1023|0)*.6931471805599453;D=+p[16+((t|1)<<3)>>3]*(A+-1.0);A=+p[16+((j|1)<<3)>>3]*(+p[s>>3]+-1.0);E=z+ +p[12080+(((v|0)==510&1)<<3)>>3];z=E*E;F=q+ +p[12080+(((w|0)==510&1)<<3)>>3];q=F*F;p[b+(i<<3)>>3]=x+(z*(z*(z*(-.16666666666666666-z*.125)+-.25)+-.5)+E*(z*(z*(z*.14285714285714288+.2)+.3333333333333333)+1.0));p[b+(k<<3)>>3]=y+(q*(q*(q*(-.16666666666666666-q*.125)+-.25)+-.5)+F*(q*(q*(q*.14285714285714288+.2)+.3333333333333333)+1.0));q=D+ +p[12080+(((t|0)==510&1)<<3)>>3];D=q*q;F=A+ +p[12080+(((j|0)==510&1)<<3)>>3];A=F*F;p[b+(m<<3)>>3]=B+(D*(D*(D*(-.16666666666666666-D*.125)+-.25)+-.5)+q*(D*(D*(D*.14285714285714288+.2)+.3333333333333333)+1.0));p[b+(l<<3)>>3]=C+(A*(A*(A*(-.16666666666666666-A*.125)+-.25)+-.5)+F*(A*(A*(A*.14285714285714288+.2)+.3333333333333333)+1.0));i=i+4|0}while((i|0)<=(g|0));h=c&-4}if((h|0)<(c|0)){g=h;do{h=a+(g<<3)|0;i=f[h+4>>2]|0;f[s>>2]=f[h>>2];f[s+4>>2]=i&4095|1072693248;h=i>>>11&510;A=+p[12080+(((h|0)==510&1)<<3)>>3]+ +p[16+((h|1)<<3)>>3]*(+p[s>>3]+-1.0);F=A*A;p[b+(g<<3)>>3]=+p[16+(h<<3)>>3]+ +((i>>>20&2047)+-1023|0)*.6931471805599453+(F*(F*(F*(-.16666666666666666-F*.125)+-.25)+-.5)+A*(F*(F*(F*.14285714285714288+.2)+.3333333333333333)+1.0));g=g+1|0}while((g|0)!=(c|0))}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function JN(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;_$(h,39520);DN(a,b,c,d,e);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function KN(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;_$(h,39540);EN(a,b,c,d,e);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function LN(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0.0,j=0.0,k=0.0;e=u;u=u+16|0;g=e+8|0;h=e;_$(h,39560);_$(g,39312);if((d|0)>0){g=0;do{i=+n[a+(g<<2)>>2];j=+n[b+(g<<2)>>2];k=+M(+(i*i+j*j));n[c+(g<<2)>>2]=k;g=g+1|0}while((g|0)!=(d|0))}if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function MN(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0.0,j=0.0,k=0.0;e=u;u=u+16|0;g=e+8|0;h=e;_$(h,39580);_$(g,39332);if((d|0)>0){g=0;do{i=+p[a+(g<<3)>>3];j=+p[b+(g<<3)>>3];k=+M(+(i*i+j*j));p[c+(g<<3)>>3]=k;g=g+1|0}while((g|0)!=(d|0))}if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function NN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+16|0;e=d+8|0;g=d;_$(g,39600);_$(e,39352);if((c|0)>0){e=0;do{h=1.0/+M(+(+n[a+(e<<2)>>2]));n[b+(e<<2)>>2]=h;e=e+1|0}while((e|0)!=(c|0))}if(!(f[g+4>>2]|0)){u=d;return}u=d;return}function ON(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+16|0;e=d+8|0;g=d;_$(g,39620);_$(e,39372);if((c|0)>0){e=0;do{h=1.0/+M(+(+p[a+(e<<3)>>3]));p[b+(e<<3)>>3]=h;e=e+1|0}while((e|0)!=(c|0))}if(!(f[g+4>>2]|0)){u=d;return}u=d;return}function PN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+16|0;e=d+8|0;g=d;_$(g,39640);_$(e,39392);if((c|0)>0){e=0;do{h=+M(+(+n[a+(e<<2)>>2]));n[b+(e<<2)>>2]=h;e=e+1|0}while((e|0)!=(c|0))}if(!(f[g+4>>2]|0)){u=d;return}u=d;return}function QN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+16|0;e=d+8|0;g=d;_$(g,39660);_$(e,39412);if((c|0)>0){e=0;do{h=+M(+(+p[a+(e<<3)>>3]));p[b+(e<<3)>>3]=h;e=e+1|0}while((e|0)!=(c|0))}if(!(f[g+4>>2]|0)){u=d;return}u=d;return}function RN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_$(e,39680);FN(a,b,c);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function SN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_$(e,39700);GN(a,b,c);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function TN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_$(e,39720);HN(a,b,c);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function UN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_$(e,39740);IN(a,b,c);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function VN(a,b){a=+a;b=+b;var c=0.0,d=0.0,e=0.0,f=0.0,g=0.0,h=0,i=0.0,j=0.0,k=0,l=0.0,m=0.0;c=+L(+b);d=+L(+a);if(!(c>=d)){e=c/(d+2.220446049250313e-16);f=e*e;g=90.0-e*(f*(f*(8.914000511169434-f*2.539724588394165)+-18.66744613647461)+57.283626556396484);h=b<0.0;i=180.0-g;j=h?i:g;k=a<0.0;l=360.0-j;m=k?l:j;return +m}else{f=d/(c+2.220446049250313e-16);c=f*f;g=f*(c*(c*(8.914000511169434-c*2.539724588394165)+-18.66744613647461)+57.283626556396484);h=b<0.0;i=180.0-g;j=h?i:g;k=a<0.0;l=360.0-j;m=k?l:j;return +m}return +(0.0)}function WN(a,b,c,d,e,g,h,i,j,k,l,m,n,o,p){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;q=u;u=u+448|0;r=q+392|0;s=q+336|0;t=q+280|0;v=q+224|0;w=q+168|0;x=q+112|0;y=q+56|0;z=q;A=(o&2|0)==0;B=(o&1|0)!=0;C=B?l:m;D=B?m:l;B=A?C:n;E=A?n:C;C=(o&4|0)==0;A=C?D:n;F=C?n:D;f[r>>2]=1124007936;C=r+4|0;G=r+8|0;H=r+40|0;I=C;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[H>>2]=G;K=r+48|0;L=r+44|0;f[L>>2]=K;f[K>>2]=0;f[r+52>>2]=0;f[s>>2]=1124007936;M=s+4|0;N=s+8|0;O=s+40|0;I=M;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[O>>2]=N;P=s+48|0;Q=s+44|0;f[Q>>2]=P;f[P>>2]=0;f[s+52>>2]=0;f[t>>2]=1124007936;R=t+4|0;S=t+8|0;T=t+40|0;I=R;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[T>>2]=S;I=t+48|0;J=t+44|0;f[J>>2]=I;f[I>>2]=0;f[t+52>>2]=0;if(a|0){$i(v,l,m,p,a,b);b=v+36|0;a=f[b>>2]|0;if(a|0){m=a+12|0;f[m>>2]=(f[m>>2]|0)+1}m=r+36|0;a=f[m>>2]|0;if(a|0?(l=a+12|0,a=f[l>>2]|0,f[l>>2]=a+-1,(a|0)==1):0)CR(r);f[m>>2]=0;a=r+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[C>>2]|0)>0){l=f[H>>2]|0;U=0;do{f[l+(U<<2)>>2]=0;U=U+1|0;V=f[C>>2]|0}while((U|0)<(V|0));f[r>>2]=f[v>>2];if((V|0)<3)W=12;else W=14}else{f[r>>2]=f[v>>2];W=12}if((W|0)==12){V=f[v+4>>2]|0;if((V|0)<3){f[C>>2]=V;f[G>>2]=f[v+8>>2];f[r+12>>2]=f[v+12>>2];V=f[v+44>>2]|0;U=f[L>>2]|0;f[U>>2]=f[V>>2];f[U+4>>2]=f[V+4>>2]}else W=14}if((W|0)==14)BR(r,v);V=v+16|0;f[a>>2]=f[V>>2];f[r+20>>2]=f[v+20>>2];f[r+24>>2]=f[v+24>>2];f[r+28>>2]=f[v+28>>2];f[r+32>>2]=f[v+32>>2];a=f[b>>2]|0;f[m>>2]=a;if(a|0?(m=a+12|0,a=f[m>>2]|0,f[m>>2]=a+-1,(a|0)==1):0)CR(v);f[b>>2]=0;b=v+4|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[b>>2]|0)>0){V=f[v+40>>2]|0;a=0;do{f[V+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[b>>2]|0))}b=f[v+44>>2]|0;if((b|0)!=(v+48|0))ZF(b)}if(c|0){$i(v,B,E,p,c,d);d=v+36|0;c=f[d>>2]|0;if(c|0){E=c+12|0;f[E>>2]=(f[E>>2]|0)+1}E=s+36|0;c=f[E>>2]|0;if(c|0?(B=c+12|0,c=f[B>>2]|0,f[B>>2]=c+-1,(c|0)==1):0)CR(s);f[E>>2]=0;c=s+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[M>>2]|0)>0){B=f[O>>2]|0;b=0;do{f[B+(b<<2)>>2]=0;b=b+1|0;X=f[M>>2]|0}while((b|0)<(X|0));f[s>>2]=f[v>>2];if((X|0)<3)W=35;else W=37}else{f[s>>2]=f[v>>2];W=35}if((W|0)==35){X=f[v+4>>2]|0;if((X|0)<3){f[M>>2]=X;f[N>>2]=f[v+8>>2];f[s+12>>2]=f[v+12>>2];X=f[v+44>>2]|0;b=f[Q>>2]|0;f[b>>2]=f[X>>2];f[b+4>>2]=f[X+4>>2]}else W=37}if((W|0)==37)BR(s,v);X=v+16|0;f[c>>2]=f[X>>2];f[s+20>>2]=f[v+20>>2];f[s+24>>2]=f[v+24>>2];f[s+28>>2]=f[v+28>>2];f[s+32>>2]=f[v+32>>2];c=f[d>>2]|0;f[E>>2]=c;if(c|0?(E=c+12|0,c=f[E>>2]|0,f[E>>2]=c+-1,(c|0)==1):0)CR(v);f[d>>2]=0;d=v+4|0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[d>>2]|0)>0){X=f[v+40>>2]|0;c=0;do{f[X+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[v+44>>2]|0;if((d|0)!=(v+48|0))ZF(d)}if((g|0)!=0&i!=0.0){$i(v,A,F,p,g,h);h=v+36|0;g=f[h>>2]|0;if(g|0){F=g+12|0;f[F>>2]=(f[F>>2]|0)+1}F=t+36|0;g=f[F>>2]|0;if(g|0?(A=g+12|0,g=f[A>>2]|0,f[A>>2]=g+-1,(g|0)==1):0)CR(t);f[F>>2]=0;g=t+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[R>>2]|0)>0){A=f[T>>2]|0;d=0;do{f[A+(d<<2)>>2]=0;d=d+1|0;Y=f[R>>2]|0}while((d|0)<(Y|0));f[t>>2]=f[v>>2];if((Y|0)<3)W=58;else W=60}else{f[t>>2]=f[v>>2];W=58}if((W|0)==58){Y=f[v+4>>2]|0;if((Y|0)<3){f[R>>2]=Y;f[S>>2]=f[v+8>>2];f[t+12>>2]=f[v+12>>2];Y=f[v+44>>2]|0;d=f[J>>2]|0;f[d>>2]=f[Y>>2];f[d+4>>2]=f[Y+4>>2]}else W=60}if((W|0)==60)BR(t,v);W=v+16|0;f[g>>2]=f[W>>2];f[t+20>>2]=f[v+20>>2];f[t+24>>2]=f[v+24>>2];f[t+28>>2]=f[v+28>>2];f[t+32>>2]=f[v+32>>2];g=f[h>>2]|0;f[F>>2]=g;if(g|0?(F=g+12|0,g=f[F>>2]|0,f[F>>2]=g+-1,(g|0)==1):0)CR(v);f[h>>2]=0;h=v+4|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[h>>2]|0)>0){W=f[v+40>>2]|0;g=0;do{f[W+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[h>>2]|0))}h=f[v+44>>2]|0;if((h|0)!=(v+48|0))ZF(h)}$i(v,D,n,p,j,k);f[w>>2]=f[r>>2];k=w+4|0;j=f[C>>2]|0;f[k>>2]=j;p=w+8|0;f[p>>2]=f[G>>2];f[w+12>>2]=f[r+12>>2];G=w+16|0;n=r+16|0;f[G>>2]=f[n>>2];f[w+20>>2]=f[r+20>>2];f[w+24>>2]=f[r+24>>2];f[w+28>>2]=f[r+28>>2];f[w+32>>2]=f[r+32>>2];D=w+36|0;h=r+36|0;g=f[h>>2]|0;f[D>>2]=g;W=w+40|0;f[W>>2]=p;p=w+48|0;F=w+44|0;f[F>>2]=p;f[p>>2]=0;f[w+52>>2]=0;if(!g)Z=j;else{j=g+12|0;f[j>>2]=(f[j>>2]|0)+1;Z=f[C>>2]|0}if((Z|0)<3){Z=f[L>>2]|0;j=f[F>>2]|0;f[j>>2]=f[Z>>2];f[j+4>>2]=f[Z+4>>2]}else{f[k>>2]=0;BR(w,r)}f[x>>2]=f[s>>2];Z=x+4|0;j=f[M>>2]|0;f[Z>>2]=j;g=x+8|0;f[g>>2]=f[N>>2];f[x+12>>2]=f[s+12>>2];N=x+16|0;Y=s+16|0;f[N>>2]=f[Y>>2];f[x+20>>2]=f[s+20>>2];f[x+24>>2]=f[s+24>>2];f[x+28>>2]=f[s+28>>2];f[x+32>>2]=f[s+32>>2];d=x+36|0;A=s+36|0;c=f[A>>2]|0;f[d>>2]=c;X=x+40|0;f[X>>2]=g;g=x+48|0;E=x+44|0;f[E>>2]=g;f[g>>2]=0;f[x+52>>2]=0;if(!c)_=j;else{j=c+12|0;f[j>>2]=(f[j>>2]|0)+1;_=f[M>>2]|0}if((_|0)<3){_=f[Q>>2]|0;j=f[E>>2]|0;f[j>>2]=f[_>>2];f[j+4>>2]=f[_+4>>2]}else{f[Z>>2]=0;BR(x,s)}f[y>>2]=f[t>>2];_=y+4|0;j=f[R>>2]|0;f[_>>2]=j;c=y+8|0;f[c>>2]=f[S>>2];f[y+12>>2]=f[t+12>>2];S=y+16|0;b=t+16|0;f[S>>2]=f[b>>2];f[y+20>>2]=f[t+20>>2];f[y+24>>2]=f[t+24>>2];f[y+28>>2]=f[t+28>>2];f[y+32>>2]=f[t+32>>2];B=y+36|0;a=t+36|0;V=f[a>>2]|0;f[B>>2]=V;m=y+40|0;f[m>>2]=c;c=y+48|0;U=y+44|0;f[U>>2]=c;f[c>>2]=0;f[y+52>>2]=0;if(!V)$=j;else{j=V+12|0;f[j>>2]=(f[j>>2]|0)+1;$=f[R>>2]|0}if(($|0)<3){$=f[J>>2]|0;j=f[U>>2]|0;f[j>>2]=f[$>>2];f[j+4>>2]=f[$+4>>2]}else{f[_>>2]=0;BR(y,t)}f[z>>2]=f[v>>2];$=z+4|0;j=v+4|0;V=f[j>>2]|0;f[$>>2]=V;l=z+8|0;f[l>>2]=f[v+8>>2];f[z+12>>2]=f[v+12>>2];aa=z+16|0;ba=v+16|0;f[aa>>2]=f[ba>>2];f[z+20>>2]=f[v+20>>2];f[z+24>>2]=f[v+24>>2];f[z+28>>2]=f[v+28>>2];f[z+32>>2]=f[v+32>>2];ca=z+36|0;da=v+36|0;ea=f[da>>2]|0;f[ca>>2]=ea;fa=z+40|0;f[fa>>2]=l;l=z+48|0;ga=z+44|0;f[ga>>2]=l;f[l>>2]=0;f[z+52>>2]=0;if(!ea)ha=V;else{V=ea+12|0;f[V>>2]=(f[V>>2]|0)+1;ha=f[j>>2]|0}if((ha|0)<3){ha=f[v+44>>2]|0;V=f[ga>>2]|0;f[V>>2]=f[ha>>2];f[V+4>>2]=f[ha+4>>2]}else{f[$>>2]=0;BR(z,v)}XN(w,x,e,y,i,z,o);o=f[ca>>2]|0;if(o|0?(ha=o+12|0,o=f[ha>>2]|0,f[ha>>2]=o+-1,(o|0)==1):0)CR(z);f[ca>>2]=0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[$>>2]|0)>0){aa=f[fa>>2]|0;fa=0;do{f[aa+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[$>>2]|0))}$=f[ga>>2]|0;if(($|0)!=(l|0))ZF($);$=f[B>>2]|0;if($|0?(l=$+12|0,$=f[l>>2]|0,f[l>>2]=$+-1,($|0)==1):0)CR(y);f[B>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[_>>2]|0)>0){S=f[m>>2]|0;m=0;do{f[S+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[_>>2]|0))}_=f[U>>2]|0;if((_|0)!=(c|0))ZF(_);_=f[d>>2]|0;if(_|0?(c=_+12|0,_=f[c>>2]|0,f[c>>2]=_+-1,(_|0)==1):0)CR(x);f[d>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[Z>>2]|0)>0){N=f[X>>2]|0;X=0;do{f[N+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[Z>>2]|0))}Z=f[E>>2]|0;if((Z|0)!=(g|0))ZF(Z);Z=f[D>>2]|0;do if(Z|0){g=Z+12|0;E=f[g>>2]|0;f[g>>2]=E+-1;if((E|0)!=1)break;CR(w)}while(0);f[D>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[k>>2]|0)>0){G=f[W>>2]|0;W=0;do{f[G+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[k>>2]|0))}k=f[F>>2]|0;if((k|0)!=(p|0))ZF(k);k=f[da>>2]|0;do if(k|0){p=k+12|0;F=f[p>>2]|0;f[p>>2]=F+-1;if((F|0)!=1)break;CR(v)}while(0);f[da>>2]=0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[j>>2]|0)>0){ba=f[v+40>>2]|0;da=0;do{f[ba+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[j>>2]|0))}j=f[v+44>>2]|0;if((j|0)!=(v+48|0))ZF(j);j=f[a>>2]|0;do if(j|0){v=j+12|0;da=f[v>>2]|0;f[v>>2]=da+-1;if((da|0)!=1)break;CR(t)}while(0);f[a>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[R>>2]|0)>0){b=f[T>>2]|0;T=0;do{f[b+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[R>>2]|0))}R=f[J>>2]|0;if((R|0)!=(I|0))ZF(R);R=f[A>>2]|0;do if(R|0){I=R+12|0;J=f[I>>2]|0;f[I>>2]=J+-1;if((J|0)!=1)break;CR(s)}while(0);f[A>>2]=0;f[Y>>2]=0;f[Y+4>>2]=0;f[Y+8>>2]=0;f[Y+12>>2]=0;if((f[M>>2]|0)>0){Y=f[O>>2]|0;O=0;do{f[Y+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[M>>2]|0))}M=f[Q>>2]|0;if((M|0)!=(P|0))ZF(M);M=f[h>>2]|0;do if(M|0){P=M+12|0;Q=f[P>>2]|0;f[P>>2]=Q+-1;if((Q|0)!=1)break;CR(r)}while(0);f[h>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[C>>2]|0)>0){n=f[H>>2]|0;H=0;do{f[n+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[C>>2]|0))}C=f[L>>2]|0;if((C|0)==(K|0)){u=q;return}ZF(C);u=q;return}function XN(a,c,d,e,g,h,i){a=a|0;c=c|0;d=+d;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0;j=u;u=u+1120|0;k=j+1104|0;l=j+64|0;m=j+56|0;o=j+48|0;q=j+40|0;r=j+32|0;s=j+24|0;t=j+16|0;v=j+8|0;w=j;_$(k,39760);x=f[a+40>>2]|0;y=f[x+4>>2]|0;z=f[x>>2]|0;x=f[a>>2]|0;A=x&4095;switch(i&3){case 0:{B=c+8|0;C=c+12|0;D=z;break}case 1:{B=c+8|0;C=c+12|0;D=y;break}case 2:{B=c+12|0;C=c+8|0;D=z;break}case 3:{B=c+12|0;C=c+8|0;D=y;break}default:{}}E=f[C>>2]|0;C=f[B>>2]|0;a:do if((i|0)==0&(C+-2|0)>>>0<3?(C|0)==(E|0)|(C|0)==(D|0):0){switch(x&4095){case 5:{B=f[h+16>>2]|0;F=f[a+16>>2]|0;G=f[c+16>>2]|0;H=f[e+16>>2]|0;I=f[h+48>>2]|0;J=I>>>2;K=f[a+48>>2]|0;L=K>>>2;M=f[c+48>>2]|0;N=M>>>2;if(!H)O=0;else O=(f[e+48>>2]|0)>>>2;P=(H|0)==0?901300:H;switch(C|0){case 2:{if(!((E|0)!=2|(G|0)==(B|0))){if((D|0)<=0)break a;Q=G+(N<<2)|0;R=G+4|0;S=G+(N+1<<2)|0;T=F;U=P;V=B;W=0;while(1){X=+n[T>>2];Z=+n[T+4>>2];_=X*+n[R>>2]+Z*+n[S>>2];n[V>>2]=(X*+n[G>>2]+Z*+n[Q>>2])*d+ +n[U>>2]*g;n[V+4>>2]=_*d+ +n[U+4>>2]*g;W=W+1|0;if((W|0)==(D|0))break a;else{T=T+(L<<2)|0;U=U+(O<<2)|0;V=V+(J<<2)|0}}}if((F|0)!=(B|0)){V=(P|0)==901300;U=(V^1)&1;T=V?1:O;if((E|0)<=0)break a;V=F+4|0;W=F+(L<<2)|0;Q=F+(L+1<<2)|0;S=G;R=P;$=B;aa=0;while(1){_=+n[S>>2];Z=+n[S+(N<<2)>>2];X=_*+n[W>>2]+Z*+n[Q>>2];n[$>>2]=(+n[F>>2]*_+ +n[V>>2]*Z)*d+ +n[R>>2]*g;n[$+(J<<2)>>2]=X*d+ +n[R+(T<<2)>>2]*g;aa=aa+1|0;if((aa|0)==(E|0))break a;else{S=S+4|0;R=R+(U<<2)|0;$=$+4|0}}}break}case 3:{if(!((E|0)!=3|(G|0)==(B|0))){if((D|0)<=0)break a;$=G+(N<<2)|0;U=N<<1;R=G+(U<<2)|0;S=G+4|0;aa=G+(N+1<<2)|0;T=G+((U|1)<<2)|0;V=G+8|0;Q=G+(N+2<<2)|0;W=G+(U+2<<2)|0;U=F;ba=P;ca=B;da=0;while(1){X=+n[U>>2];Z=+n[U+4>>2];_=+n[U+8>>2];ea=X*+n[S>>2]+Z*+n[aa>>2]+_*+n[T>>2];fa=X*+n[V>>2]+Z*+n[Q>>2]+_*+n[W>>2];n[ca>>2]=(X*+n[G>>2]+Z*+n[$>>2]+_*+n[R>>2])*d+ +n[ba>>2]*g;n[ca+4>>2]=ea*d+ +n[ba+4>>2]*g;n[ca+8>>2]=fa*d+ +n[ba+8>>2]*g;da=da+1|0;if((da|0)==(D|0))break a;else{U=U+(L<<2)|0;ba=ba+(O<<2)|0;ca=ca+(J<<2)|0}}}if((F|0)!=(B|0)){ca=(P|0)==901300;ba=(ca^1)&1;U=ca?1:O;if((E|0)<=0)break a;ca=F+4|0;da=F+8|0;R=N<<1;$=F+(L<<2)|0;W=F+(L+1<<2)|0;Q=F+(L+2<<2)|0;V=L<<1;T=F+(V<<2)|0;aa=F+((V|1)<<2)|0;S=F+(V+2<<2)|0;V=U<<1;ga=J<<1;ha=G;ia=P;ja=B;ka=0;while(1){fa=+n[ha>>2];ea=+n[ha+(N<<2)>>2];_=+n[ha+(R<<2)>>2];Z=fa*+n[$>>2]+ea*+n[W>>2]+_*+n[Q>>2];X=fa*+n[T>>2]+ea*+n[aa>>2]+_*+n[S>>2];n[ja>>2]=(+n[F>>2]*fa+ +n[ca>>2]*ea+ +n[da>>2]*_)*d+ +n[ia>>2]*g;n[ja+(J<<2)>>2]=Z*d+ +n[ia+(U<<2)>>2]*g;n[ja+(ga<<2)>>2]=X*d+ +n[ia+(V<<2)>>2]*g;ka=ka+1|0;if((ka|0)==(E|0))break a;else{ha=ha+4|0;ia=ia+(ba<<2)|0;ja=ja+4|0}}}break}case 4:{if(!((E|0)!=4|(G|0)==(B|0))){if((D|0)<=0)break a;ja=G+(N<<2)|0;ba=N<<1;ia=G+(ba<<2)|0;ha=N*3|0;ka=G+(ha<<2)|0;V=G+4|0;ga=G+(N+1<<2)|0;U=G+((ba|1)<<2)|0;da=G+(ha+1<<2)|0;ca=G+8|0;S=G+(N+2<<2)|0;aa=G+(ba+2<<2)|0;T=G+(ha+2<<2)|0;Q=G+12|0;W=G+(N+3<<2)|0;$=G+(ba+3<<2)|0;ba=G+(ha+3<<2)|0;ha=F;R=P;la=B;ma=0;while(1){X=+n[ha>>2];Z=+n[ha+4>>2];_=+n[ha+8>>2];ea=+n[ha+12>>2];fa=X*+n[V>>2]+Z*+n[ga>>2]+_*+n[U>>2]+ea*+n[da>>2];na=X*+n[ca>>2]+Z*+n[S>>2]+_*+n[aa>>2]+ea*+n[T>>2];oa=X*+n[Q>>2]+Z*+n[W>>2]+_*+n[$>>2]+ea*+n[ba>>2];n[la>>2]=(X*+n[G>>2]+Z*+n[ja>>2]+_*+n[ia>>2]+ea*+n[ka>>2])*d+ +n[R>>2]*g;n[la+4>>2]=fa*d+ +n[R+4>>2]*g;n[la+8>>2]=na*d+ +n[R+8>>2]*g;n[la+12>>2]=oa*d+ +n[R+12>>2]*g;ma=ma+1|0;if((ma|0)==(D|0))break a;else{ha=ha+(L<<2)|0;R=R+(O<<2)|0;la=la+(J<<2)|0}}}if((F|0)!=(B|0)){la=(P|0)==901300;R=(la^1)&1;ha=la?1:O;if((E|0)<=0)break a;la=F+4|0;ma=F+8|0;ka=N<<1;ia=F+12|0;ja=N*3|0;ba=F+(L<<2)|0;$=F+(L+1<<2)|0;W=F+(L+2<<2)|0;Q=F+(L+3<<2)|0;T=L<<1;aa=F+(T<<2)|0;S=F+((T|1)<<2)|0;ca=F+(T+2<<2)|0;da=F+(T+3<<2)|0;T=L*3|0;U=F+(T<<2)|0;ga=F+(T+1<<2)|0;V=F+(T+2<<2)|0;pa=F+(T+3<<2)|0;T=ha<<1;qa=J<<1;ra=ha*3|0;sa=J*3|0;ta=G;ua=P;va=B;wa=0;while(1){oa=+n[ta>>2];na=+n[ta+(N<<2)>>2];fa=+n[ta+(ka<<2)>>2];ea=+n[ta+(ja<<2)>>2];_=oa*+n[ba>>2]+na*+n[$>>2]+fa*+n[W>>2]+ea*+n[Q>>2];Z=oa*+n[aa>>2]+na*+n[S>>2]+fa*+n[ca>>2]+ea*+n[da>>2];X=oa*+n[U>>2]+na*+n[ga>>2]+fa*+n[V>>2]+ea*+n[pa>>2];n[va>>2]=(+n[F>>2]*oa+ +n[la>>2]*na+ +n[ma>>2]*fa+ +n[ia>>2]*ea)*d+ +n[ua>>2]*g;n[va+(J<<2)>>2]=_*d+ +n[ua+(ha<<2)>>2]*g;n[va+(qa<<2)>>2]=Z*d+ +n[ua+(T<<2)>>2]*g;n[va+(sa<<2)>>2]=X*d+ +n[ua+(ra<<2)>>2]*g;wa=wa+1|0;if((wa|0)==(E|0))break a;else{ta=ta+4|0;ua=ua+(R<<2)|0;va=va+4|0}}}break}default:{}}if((A|0)==6){xa=I;ya=K;za=M;Aa=H;Ba=H;Ca=G;Da=B;Ea=F}else{Fa=66;break a}break}case 6:{va=f[e+16>>2]|0;xa=f[h+48>>2]|0;ya=f[a+48>>2]|0;za=f[c+48>>2]|0;Aa=va;Ba=va;Ca=f[c+16>>2]|0;Da=f[h+16>>2]|0;Ea=f[a+16>>2]|0;break}default:{Fa=66;break a}}va=xa>>>3;R=ya>>>3;ua=za>>>3;if(!Aa)Ga=0;else Ga=(f[e+48>>2]|0)>>>3;ta=(Ba|0)==0?374944:Ba;switch(C|0){case 2:{if(!((E|0)!=2|(Ca|0)==(Da|0))){if((D|0)<=0)break a;wa=Ca+(ua<<3)|0;ra=Ca+8|0;sa=Ca+(ua+1<<3)|0;T=Ea;qa=ta;ha=Da;J=0;while(1){X=+p[T>>3];Z=+p[T+8>>3];_=X*+p[ra>>3]+Z*+p[sa>>3];p[ha>>3]=(X*+p[Ca>>3]+Z*+p[wa>>3])*d+ +p[qa>>3]*g;p[ha+8>>3]=_*d+ +p[qa+8>>3]*g;J=J+1|0;if((J|0)==(D|0))break a;else{T=T+(R<<3)|0;qa=qa+(Ga<<3)|0;ha=ha+(va<<3)|0}}}if((Ea|0)==(Da|0)){Fa=66;break a}ha=(ta|0)==374944;qa=(ha^1)&1;T=ha?1:Ga;if((E|0)<=0)break a;ha=Ea+8|0;J=Ea+(R<<3)|0;wa=Ea+(R+1<<3)|0;sa=Ca;ra=ta;F=Da;B=0;while(1){_=+p[sa>>3];Z=+p[sa+(ua<<3)>>3];X=_*+p[J>>3]+Z*+p[wa>>3];p[F>>3]=(+p[Ea>>3]*_+ +p[ha>>3]*Z)*d+ +p[ra>>3]*g;p[F+(va<<3)>>3]=X*d+ +p[ra+(T<<3)>>3]*g;B=B+1|0;if((B|0)==(E|0))break;else{sa=sa+8|0;ra=ra+(qa<<3)|0;F=F+8|0}}break}case 3:{if(!((E|0)!=3|(Ca|0)==(Da|0))){if((D|0)<=0)break a;F=Ca+(ua<<3)|0;qa=ua<<1;ra=Ca+(qa<<3)|0;sa=Ca+8|0;B=Ca+(ua+1<<3)|0;T=Ca+((qa|1)<<3)|0;ha=Ca+16|0;wa=Ca+(ua+2<<3)|0;J=Ca+(qa+2<<3)|0;qa=Ea;G=ta;H=Da;M=0;while(1){X=+p[qa>>3];Z=+p[qa+8>>3];_=+p[qa+16>>3];ea=X*+p[sa>>3]+Z*+p[B>>3]+_*+p[T>>3];fa=X*+p[ha>>3]+Z*+p[wa>>3]+_*+p[J>>3];p[H>>3]=(X*+p[Ca>>3]+Z*+p[F>>3]+_*+p[ra>>3])*d+ +p[G>>3]*g;p[H+8>>3]=ea*d+ +p[G+8>>3]*g;p[H+16>>3]=fa*d+ +p[G+16>>3]*g;M=M+1|0;if((M|0)==(D|0))break a;else{qa=qa+(R<<3)|0;G=G+(Ga<<3)|0;H=H+(va<<3)|0}}}if((Ea|0)==(Da|0)){Fa=66;break a}H=(ta|0)==374944;G=(H^1)&1;qa=H?1:Ga;if((E|0)<=0)break a;H=Ea+8|0;M=Ea+16|0;ra=ua<<1;F=Ea+(R<<3)|0;J=Ea+(R+1<<3)|0;wa=Ea+(R+2<<3)|0;ha=R<<1;T=Ea+(ha<<3)|0;B=Ea+((ha|1)<<3)|0;sa=Ea+(ha+2<<3)|0;ha=qa<<1;K=va<<1;I=Ca;ia=ta;ma=Da;la=0;while(1){fa=+p[I>>3];ea=+p[I+(ua<<3)>>3];_=+p[I+(ra<<3)>>3];Z=fa*+p[F>>3]+ea*+p[J>>3]+_*+p[wa>>3];X=fa*+p[T>>3]+ea*+p[B>>3]+_*+p[sa>>3];p[ma>>3]=(+p[Ea>>3]*fa+ +p[H>>3]*ea+ +p[M>>3]*_)*d+ +p[ia>>3]*g;p[ma+(va<<3)>>3]=Z*d+ +p[ia+(qa<<3)>>3]*g;p[ma+(K<<3)>>3]=X*d+ +p[ia+(ha<<3)>>3]*g;la=la+1|0;if((la|0)==(E|0))break;else{I=I+8|0;ia=ia+(G<<3)|0;ma=ma+8|0}}break}case 4:{if(!((E|0)!=4|(Ca|0)==(Da|0))){if((D|0)<=0)break a;ma=Ca+(ua<<3)|0;G=ua<<1;ia=Ca+(G<<3)|0;I=ua*3|0;la=Ca+(I<<3)|0;ha=Ca+8|0;K=Ca+(ua+1<<3)|0;qa=Ca+((G|1)<<3)|0;M=Ca+(I+1<<3)|0;H=Ca+16|0;sa=Ca+(ua+2<<3)|0;B=Ca+(G+2<<3)|0;T=Ca+(I+2<<3)|0;wa=Ca+24|0;J=Ca+(ua+3<<3)|0;F=Ca+(G+3<<3)|0;G=Ca+(I+3<<3)|0;I=Ea;ra=ta;pa=Da;V=0;while(1){X=+p[I>>3];Z=+p[I+8>>3];_=+p[I+16>>3];ea=+p[I+24>>3];fa=X*+p[ha>>3]+Z*+p[K>>3]+_*+p[qa>>3]+ea*+p[M>>3];na=X*+p[H>>3]+Z*+p[sa>>3]+_*+p[B>>3]+ea*+p[T>>3];oa=X*+p[wa>>3]+Z*+p[J>>3]+_*+p[F>>3]+ea*+p[G>>3];p[pa>>3]=(X*+p[Ca>>3]+Z*+p[ma>>3]+_*+p[ia>>3]+ea*+p[la>>3])*d+ +p[ra>>3]*g;p[pa+8>>3]=fa*d+ +p[ra+8>>3]*g;p[pa+16>>3]=na*d+ +p[ra+16>>3]*g;p[pa+24>>3]=oa*d+ +p[ra+24>>3]*g;V=V+1|0;if((V|0)==(D|0))break a;else{I=I+(R<<3)|0;ra=ra+(Ga<<3)|0;pa=pa+(va<<3)|0}}}if((E|0)>16|(Ea|0)==(Da|0)){Fa=66;break a}pa=(ta|0)==374944;ra=pa?1:Ga;I=(pa^1)&1;if((E|0)<=0)break a;pa=Ea+8|0;V=Ea+16|0;la=ua<<1;ia=Ea+24|0;ma=ua*3|0;G=Ea+(R<<3)|0;F=Ea+(R+1<<3)|0;J=Ea+(R+2<<3)|0;wa=Ea+(R+3<<3)|0;T=R<<1;B=Ea+(T<<3)|0;sa=Ea+((T|1)<<3)|0;H=Ea+(T+2<<3)|0;M=Ea+(T+3<<3)|0;T=R*3|0;qa=Ea+(T<<3)|0;K=Ea+(T+1<<3)|0;ha=Ea+(T+2<<3)|0;ga=Ea+(T+3<<3)|0;T=ra<<1;U=va<<1;da=ra*3|0;ca=va*3|0;S=Ca;aa=ta;Q=Da;W=0;while(1){oa=+p[S>>3];na=+p[S+(ua<<3)>>3];fa=+p[S+(la<<3)>>3];ea=+p[S+(ma<<3)>>3];_=oa*+p[G>>3]+na*+p[F>>3]+fa*+p[J>>3]+ea*+p[wa>>3];Z=oa*+p[B>>3]+na*+p[sa>>3]+fa*+p[H>>3]+ea*+p[M>>3];X=oa*+p[qa>>3]+na*+p[K>>3]+fa*+p[ha>>3]+ea*+p[ga>>3];p[Q>>3]=(+p[Ea>>3]*oa+ +p[pa>>3]*na+ +p[V>>3]*fa+ +p[ia>>3]*ea)*d+ +p[aa>>3]*g;p[Q+(va<<3)>>3]=_*d+ +p[aa+(ra<<3)>>3]*g;p[Q+(U<<3)>>3]=Z*d+ +p[aa+(T<<3)>>3]*g;p[Q+(ca<<3)>>3]=X*d+ +p[aa+(da<<3)>>3]*g;W=W+1|0;if((W|0)==(E|0))break;else{S=S+8|0;aa=aa+(I<<3)|0;Q=Q+8|0}}break}default:{Fa=66;break a}}}else Fa=66;while(0);if((Fa|0)==66){Ea=f[c+48>>2]|0;Da=e+16|0;Ca=f[Da>>2]|0;if(!Ca)Ha=0;else Ha=f[e+48>>2]|0;Ga=l+8|0;f[l>>2]=Ga;Ba=l+4|0;f[Ba>>2]=1032;switch(x&4095){case 5:{Ia=106;Ja=1;Ka=2;break}case 6:{Ia=107;Ja=2;Ka=3;break}case 13:{Ia=108;Ja=3;Ka=4;break}case 14:{Fa=72;break}default:{f[m>>2]=0;f[m+4>>2]=0;Aa=c$(m,49)|0;za=168046;ya=Aa+49|0;do{b[Aa>>0]=b[za>>0]|0;Aa=Aa+1|0;za=za+1|0}while((Aa|0)<(ya|0));j$(-215,m,168096,168105,1218);d$(m);Fa=72}}if((Fa|0)==72){Ia=109;Ja=4;Ka=5}m=(E|0)==1;if((i&2|0)==0&(m|(C|0)==1)?(f[c>>2]&16384|0)!=0:0){if(m)La=0;else La=(x>>>3&511)+1<<(47696>>>(A<<1&14)&3);Ma=La;Na=i|2}else{Ma=Ea;Na=i}if((D|0)<65)if((C|0)<10001)Fa=83;else Fa=81;else if((C|0)<11|(E|0)<65&(C|0)<10001)Fa=83;else Fa=81;do if((Fa|0)==81){if((E|0)<129?(D|0)<129&(C|0)<129:0){Fa=83;break}i=x&7;Ea=(x>>>3&511)+1<<(47696>>>(i<<1)&3);La=Ea<<((i|0)==5&1);i=(Na&1|0)!=0;A=a+48|0;m=f[A>>2]|0;za=i?Ea:m;Aa=i?m:Ea;m=(Na&2|0)!=0;ya=m?Ea:Ma;xa=m?Ma:Ea;if(f[Da>>2]|0){O=f[e+4>>2]|0;if((O|0)<3)Oa=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{Q=f[e+40>>2]|0;I=0;aa=1;while(1){S=Y(f[Q+(I<<2)>>2]|0,aa)|0;I=I+1|0;if((I|0)==(O|0)){Oa=S;break}else aa=S}}if(!((O|0)==0|(Oa|0)==0)){aa=(Na&4|0)==0;I=f[e+48>>2]|0;Pa=aa?I:Ea;Qa=aa?Ea:I;Ra=Na}else Fa=90}else Fa=90;if((Fa|0)==90){Pa=0;Qa=0;Ra=Na&-5}I=(D|0)<128?D:128;aa=(E|0)<128?E:128;Q=16384/(I|0)|0;S=16384/(aa|0)|0;W=(S|0)<(Q|0)?S:Q;Q=(C|0)<(W|0)?C:W;if((Y(Q,I)|0)>16384)Sa=16384/(Q|0)|0;else Sa=I;if((Y(Q,aa)|0)>16384)Ta=16384/(Q|0)|0;else Ta=aa;aa=((Q|0)/8|0)+Q|0;I=Y(Ta+2+((Ta|0)/8|0)&-2,aa+1|0)|0;S=Y(I,Ea)|0;da=Y(I,La)|0;if(i){Ua=Y(Y(aa+2&-2,Ea)|0,Sa+1+((Sa|0)/8|0)|0)|0;Va=Ra&-2}else{Ua=0;Va=Ra}aa=da+S+Ua|0;if((f[Ba>>2]|0)>>>0<aa>>>0){I=f[l>>2]|0;if((I|0)!=(Ga|0)){if(I|0)QYa(I);f[l>>2]=Ga;f[Ba>>2]=1032}f[Ba>>2]=aa;if(aa>>>0>1032){I=OYa(aa)|0;f[l>>2]=I;Wa=I}else Wa=Ga}else{f[Ba>>2]=aa;Wa=f[l>>2]|0}aa=Wa+da|0;da=aa+S|0;S=i?da:0;if((D|0)>0){I=D<<3;ca=(E|0)>0;T=h+16|0;U=h+44|0;ra=h+48|0;va=E<<3;ia=(C|0)>(W|0);W=(C|0)>0;V=w+4|0;pa=a+16|0;ga=c+16|0;ha=C<<3;K=i&(S|0)!=0;qa=(Ea|0)==4;M=Ea&65535;H=Ea>>>2;sa=r+4|0;B=s+4|0;wa=t+4|0;J=v+4|0;F=Va;G=0;while(1){ma=G+Sa|0;if((ma|0)<(D|0)?((ma<<3)+Sa|0)<=(I|0):0)Xa=Sa;else Xa=D-G|0;if(ca){ma=Ca+(Y(G,Pa)|0)|0;la=Y(G,za)|0;ua=F;ta=0;while(1){R=f[ra>>2]|0;$=Y(ta,Ea)|0;ba=(f[T>>2]|0)+(Y(R,G)|0)+$|0;ja=ma+(Y(ta,Qa)|0)|0;ka=ta+Ta|0;if((ka|0)<(E|0)?((ka<<3)+Ta|0)<=(va|0):0)Ya=Ta;else Ya=E-ta|0;ka=ua&15;N=Y(Ya,La)|0;P=ia?Wa:ba;ba=ia?N:R;if(W){R=Y(ta,xa)|0;N=(Ya|0)<(E|0);L=ka;Za=0;while(1){_a=(f[pa>>2]|0)+la+(Y(Za,Aa)|0)|0;$a=f[A>>2]|0;ab=(f[ga>>2]|0)+(Y(Za,ya)|0)+R|0;bb=Za+Q|0;if((bb|0)<(C|0)?((bb<<3)+Q|0)<=(ha|0):0)cb=Q;else cb=C-Za|0;bb=i?Xa:cb;db=i?cb:Xa;b:do if(K){eb=Y(cb,Ea)|0;if((bb|0)<=0){fb=da;gb=eb;hb=db;ib=bb;break}jb=(db|0)>0;if(qa){if(jb){kb=da;lb=0;mb=_a}else{fb=S;gb=eb;hb=db;ib=bb;break}while(1){nb=mb;ob=0;while(1){f[kb+(ob<<2)>>2]=f[nb>>2];ob=ob+1|0;if((ob|0)==(db|0))break;else nb=nb+$a|0}lb=lb+1|0;if((lb|0)==(bb|0)){fb=S;gb=eb;hb=db;ib=bb;break b}else{kb=kb+eb|0;mb=mb+4|0}}}nb=db<<2;ob=db<<1;switch(M&8191){case 16:{pb=da;qb=0;rb=_a;while(1){if(jb){sb=rb;tb=0;while(1){ub=f[sb+4>>2]|0;f[pb+(tb<<2)>>2]=f[sb>>2];f[pb+((tb|1)<<2)>>2]=ub;ub=f[sb+12>>2]|0;f[pb+((tb|2)<<2)>>2]=f[sb+8>>2];f[pb+((tb|3)<<2)>>2]=ub;tb=tb+4|0;if((tb|0)>=(nb|0))break;else sb=sb+$a|0}}qb=qb+1|0;if((qb|0)==(bb|0)){fb=S;gb=eb;hb=db;ib=bb;break}else{pb=pb+eb|0;rb=rb+Ea|0}}break}case 8:{rb=da;pb=0;qb=_a;while(1){if(jb){nb=qb;sb=0;while(1){tb=f[nb+4>>2]|0;f[rb+(sb<<2)>>2]=f[nb>>2];f[rb+((sb|1)<<2)>>2]=tb;sb=sb+2|0;if((sb|0)>=(ob|0))break;else nb=nb+$a|0}}pb=pb+1|0;if((pb|0)==(bb|0)){fb=S;gb=eb;hb=db;ib=bb;break}else{rb=rb+eb|0;qb=qb+Ea|0}}break}default:{fb=da;gb=eb;hb=db;ib=bb;break b}}}else{fb=_a;gb=$a;hb=bb;ib=db}while(0);c:do if(N){db=m?cb:Ya;bb=m?Ya:cb;$a=Y(db,Ea)|0;_a=Y(db,H)|0;if(!bb){vb=aa;wb=$a;break}db=_a+-4|0;if((_a|0)<4){qb=(_a|0)>0;rb=bb;pb=aa;ob=ab;while(1){rb=rb+-1|0;if(qb){jb=0;do{f[pb+(jb<<2)>>2]=f[ob+(jb<<2)>>2];jb=jb+1|0}while((jb|0)!=(_a|0))}if(!rb){vb=aa;wb=$a;break c}else{pb=pb+$a|0;ob=ob+Ma|0}}}ob=_a&-4;pb=(ob|0)<(_a|0);rb=bb;qb=aa;eb=ab;while(1){jb=0;do{nb=jb|1;sb=f[eb+(nb<<2)>>2]|0;f[qb+(jb<<2)>>2]=f[eb+(jb<<2)>>2];f[qb+(nb<<2)>>2]=sb;sb=jb|2;nb=jb|3;tb=f[eb+(nb<<2)>>2]|0;f[qb+(sb<<2)>>2]=f[eb+(sb<<2)>>2];f[qb+(nb<<2)>>2]=tb;jb=jb+4|0}while((jb|0)<=(db|0));rb=rb+-1|0;if(pb){jb=ob;do{f[qb+(jb<<2)>>2]=f[eb+(jb<<2)>>2];jb=jb+1|0}while((jb|0)!=(_a|0))}if(!rb){vb=aa;wb=$a;break}else{qb=qb+$a|0;eb=eb+Ma|0}}}else{vb=ab;wb=Ma}while(0);if(ia){f[r>>2]=hb;f[sa>>2]=ib;f[s>>2]=Ya;f[B>>2]=Xa;_h[Ia&127](fb,gb,vb,wb,P,ba,r,s,L)}else{f[t>>2]=hb;f[wa>>2]=ib;f[v>>2]=Ya;f[J>>2]=Xa;Ig[Ja&7](fb,gb,vb,wb,ja,Ha,P,ba,t,v,d,g,L)}ab=L|16;Za=cb+Za|0;if((C|0)<=(Za|0)){xb=ab;break}else L=ab}}else xb=ka;if(ia){L=(f[T>>2]|0)+(Y(f[f[U>>2]>>2]|0,G)|0)+$|0;Za=f[ra>>2]|0;f[w>>2]=Ya;f[V>>2]=Xa;ni[Ka&7](ja,Ha,P,ba,L,Za,w,d,g,xb)}ta=Ya+ta|0;if((E|0)<=(ta|0)){yb=xb;break}else ua=xb}}else yb=F;G=Xa+G|0;if((D|0)<=(G|0))break;else F=yb}}}while(0);if((Fa|0)==83){Fa=f[a+16>>2]|0;yb=f[a+48>>2]|0;a=f[c+16>>2]|0;c=f[h+16>>2]|0;Xa=f[h+48>>2]|0;f[o>>2]=y;f[o+4>>2]=z;f[q>>2]=E;f[q+4>>2]=D;Ig[Ja&7](Fa,yb,a,Ma,Ca,Ha,c,Xa,o,q,d,g,Na)}Na=f[l>>2]|0;if((Na|0)!=(Ga|0)){if(Na|0)QYa(Na);f[l>>2]=Ga;f[Ba>>2]=1032}}if(!(f[k+4>>2]|0)){u=j;return}u=j;return}function YN(a,b,c,d,e,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;n=n|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Z=0.0,_=0.0,$=0,aa=0.0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0,qa=0.0,ra=0.0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0.0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0;o=u;u=u+2192|0;q=o+1096|0;r=o;s=f[j>>2]|0;t=f[j+4>>2]|0;j=f[k>>2]|0;v=f[k+4>>2]|0;k=q+8|0;f[q>>2]=k;w=q+4|0;f[w>>2]=136;x=b>>>3;y=d>>>3;z=g>>>3;g=i>>>3;i=(e|0)==0;A=(n&4|0)==0;B=i?0:A?z:1;C=i?0:A?1:z;if(n&1)if(b>>>0>15&(t|0)>1){f[w>>2]=t;if(t>>>0>136){z=OYa(t>>>0>536870911?-1:t<<3)|0;f[q>>2]=z;D=z;E=1;F=x;G=t;H=43}else{D=k;E=1;F=x;G=t;H=43}}else{I=1;J=x;K=t;H=5}else{I=x;J=1;K=s;H=5}if((H|0)==5)if((K|0)==1){s=r+8|0;f[r>>2]=s;z=r+4|0;f[z>>2]=136;if(b>>>0>15&(t|0)>1){f[w>>2]=v;if(v>>>0>136){t=OYa(v>>>0>536870911?-1:v<<3)|0;f[q>>2]=t;L=t}else L=k;if((v|0)>0){t=0;do{b=a+((Y(t,x)|0)<<3)|0;p[L+(t<<3)>>3]=+p[b>>3];t=t+1|0}while((t|0)!=(v|0));M=L}else M=L}else M=a;if(d>>>0>15){f[z>>2]=j;if(j>>>0>136){d=OYa(j>>>0>536870911?-1:j<<3)|0;f[r>>2]=d;N=d}else N=s;if((j|0)>0){d=0;do{L=c+((Y(d,y)|0)<<3)|0;p[N+(d<<3)>>3]=+p[L>>3];d=d+1|0}while((d|0)!=(j|0));O=N;P=N}else{O=N;P=N}}else{O=s;P=c}a:do if((v|0)>0){N=C<<1;if((j|0)<2){if((j|0)==1){Q=e;R=h;S=0}else break;while(1){T=+p[M+(S<<3)>>3]*l*+p[P>>3];if(!Q)U=T;else U=T+ +p[Q>>3]*m;p[R>>3]=U;S=S+1|0;if((S|0)==(v|0))break a;else{Q=Q+(B<<3)|0;R=R+(g<<3)|0}}}d=j+-2|0;L=((d|0)>1?d:1)>>>1;t=Y(L,N)|0;x=(L<<1)+2|0;if((x|0)>=(j|0)){L=e;b=h;A=0;while(1){T=+p[M+(A<<3)>>3]*l;i=L;V=0;while(1){W=T*+p[P+(V<<3)>>3];X=V|1;Z=T*+p[P+(X<<3)>>3];if(!i){p[b+(V<<3)>>3]=W;_=Z}else{p[b+(V<<3)>>3]=W+ +p[i>>3]*m;_=Z+ +p[i+(C<<3)>>3]*m}p[b+(X<<3)>>3]=_;V=V+2|0;if((V|0)>(d|0))break;else i=i+(N<<3)|0}A=A+1|0;if((A|0)==(v|0))break a;else{L=L+(B<<3)|0;b=b+(g<<3)|0}}}b=e;L=h;A=0;i=e+(N<<3)|0;while(1){T=+p[M+(A<<3)>>3]*l;V=b;X=0;while(1){Z=T*+p[P+(X<<3)>>3];$=X|1;W=T*+p[P+($<<3)>>3];if(!V){p[L+(X<<3)>>3]=Z;aa=W}else{p[L+(X<<3)>>3]=Z+ +p[V>>3]*m;aa=W+ +p[V+(C<<3)>>3]*m}p[L+($<<3)>>3]=aa;X=X+2|0;if((X|0)>(d|0))break;else V=V+(N<<3)|0}V=i+(t<<3)|0;X=x;while(1){W=T*+p[P+(X<<3)>>3];if(!V)ba=W;else ba=W+ +p[V>>3]*m;p[L+(X<<3)>>3]=ba;X=X+1|0;if((X|0)==(j|0))break;else V=V+(C<<3)|0}A=A+1|0;if((A|0)==(v|0))break;else{b=b+(B<<3)|0;L=L+(g<<3)|0;i=i+(B<<3)|0}}}while(0);if((O|0)!=(s|0)){QYa(O);f[r>>2]=s;f[z>>2]=136}}else{D=0;E=I;F=J;G=K;H=43}b:do if((H|0)==43){if(n&2|0){if((v|0)<=0)break;K=(D|0)==0;J=(j|0)>0;I=G+-4|0;z=(G|0)<4;s=G&-4;O=K|(G|0)<1;P=(G|0)>0;M=(s|0)<(G|0);ba=l*0.0;R=a;Q=e;S=h;i=0;while(1){if(O)ca=K?R:D;else{L=0;do{b=R+((Y(L,F)|0)<<3)|0;p[D+(L<<3)>>3]=+p[b>>3];L=L+1|0}while((L|0)!=(G|0));ca=D}c:do if(J){if(z){if(P){da=c;ea=Q;fa=0}else{L=Q;b=0;while(1){if(!L)ga=ba;else ga=ba+ +p[L>>3]*m;p[S+(b<<3)>>3]=ga;b=b+1|0;if((b|0)==(j|0))break c;else L=L+(C<<3)|0}}while(1){L=0;aa=0.0;do{aa=aa+ +p[ca+(L<<3)>>3]*+p[da+(L<<3)>>3];L=L+1|0}while((L|0)!=(G|0));_=(aa+0.0)*l;if(!ea)ha=_;else ha=_+ +p[ea>>3]*m;p[S+(fa<<3)>>3]=ha;fa=fa+1|0;if((fa|0)==(j|0))break c;else{da=da+(y<<3)|0;ea=ea+(C<<3)|0}}}if(M){ia=c;ja=Q;ka=0}else{L=c;b=Q;A=0;while(1){x=0;_=0.0;U=0.0;T=0.0;W=0.0;do{_=_+ +p[ca+(x<<3)>>3]*+p[L+(x<<3)>>3];t=x|1;U=U+ +p[ca+(t<<3)>>3]*+p[L+(t<<3)>>3];t=x|2;T=T+ +p[ca+(t<<3)>>3]*+p[L+(t<<3)>>3];t=x|3;W=W+ +p[ca+(t<<3)>>3]*+p[L+(t<<3)>>3];x=x+4|0}while((x|0)<=(I|0));aa=(W+(T+(U+_)))*l;if(!b)la=aa;else la=aa+ +p[b>>3]*m;p[S+(A<<3)>>3]=la;A=A+1|0;if((A|0)==(j|0))break c;else{L=L+(y<<3)|0;b=b+(C<<3)|0}}}while(1){b=0;aa=0.0;Z=0.0;ma=0.0;na=0.0;while(1){oa=aa+ +p[ca+(b<<3)>>3]*+p[ia+(b<<3)>>3];L=b|1;Z=Z+ +p[ca+(L<<3)>>3]*+p[ia+(L<<3)>>3];L=b|2;ma=ma+ +p[ca+(L<<3)>>3]*+p[ia+(L<<3)>>3];L=b|3;na=na+ +p[ca+(L<<3)>>3]*+p[ia+(L<<3)>>3];b=b+4|0;if((b|0)>(I|0)){pa=s;qa=oa;break}else aa=oa}do{qa=qa+ +p[ca+(pa<<3)>>3]*+p[ia+(pa<<3)>>3];pa=pa+1|0}while((pa|0)!=(G|0));aa=(na+(ma+(Z+qa)))*l;if(!ja)ra=aa;else ra=aa+ +p[ja>>3]*m;p[S+(ka<<3)>>3]=ra;ka=ka+1|0;if((ka|0)==(j|0))break;else{ia=ia+(y<<3)|0;ja=ja+(C<<3)|0}}}while(0);i=i+1|0;if((i|0)==(v|0))break b;else{R=R+(E<<3)|0;Q=Q+(B<<3)|0;S=S+(g<<3)|0}}}S=j<<3;if(S>>>0<1601){if((v|0)<=0)break;Q=(D|0)==0;R=j+-4|0;i=(j|0)<4;s=(G|0)>0;I=C<<2;M=C<<1;P=C*3|0;z=R>>>2;J=(z<<2)+4|0;K=Q|(G|0)<1;ba=l*0.0;O=a;b=e;L=h;A=0;x=e+(Y((z<<5)+32|0,C)|0)|0;while(1){if(K)sa=Q?O:D;else{z=0;do{t=O+((Y(z,F)|0)<<3)|0;p[D+(z<<3)>>3]=+p[t>>3];z=z+1|0}while((z|0)!=(G|0));sa=D}d:do if(i){ta=b;ua=0}else{if(s){va=b;wa=0}else{z=b;t=0;while(1){N=t|1;d=t|2;if(!z){p[L+(t<<3)>>3]=ba;p[L+(N<<3)>>3]=ba;p[L+(d<<3)>>3]=ba;xa=ba}else{p[L+(t<<3)>>3]=ba+ +p[z>>3]*m;p[L+(N<<3)>>3]=ba+ +p[z+(C<<3)>>3]*m;p[L+(d<<3)>>3]=ba+ +p[z+(M<<3)>>3]*m;xa=ba+ +p[z+(P<<3)>>3]*m}p[L+((t|3)<<3)>>3]=xa;t=t+4|0;if((t|0)>(R|0)){ta=x;ua=J;break d}else z=z+(I<<3)|0}}while(1){z=c+(wa<<3)|0;t=0;aa=0.0;_=0.0;U=0.0;T=0.0;while(1){W=+p[sa+(t<<3)>>3];aa=aa+W*+p[z>>3];_=_+W*+p[z+8>>3];U=U+W*+p[z+16>>3];T=T+W*+p[z+24>>3];t=t+1|0;if((t|0)==(G|0))break;else z=z+(y<<3)|0}Z=aa*l;ma=T*l;z=wa|1;t=wa|2;na=U*l;W=_*l;if(!va){p[L+(wa<<3)>>3]=Z;p[L+(z<<3)>>3]=W;p[L+(t<<3)>>3]=na;ya=ma}else{p[L+(wa<<3)>>3]=Z+ +p[va>>3]*m;p[L+(z<<3)>>3]=W+ +p[va+(C<<3)>>3]*m;p[L+(t<<3)>>3]=na+ +p[va+(M<<3)>>3]*m;ya=ma+ +p[va+(P<<3)>>3]*m}p[L+((wa|3)<<3)>>3]=ya;wa=wa+4|0;if((wa|0)>(R|0)){ta=x;ua=J;break}else va=va+(I<<3)|0}}while(0);e:do if((ua|0)<(j|0)){if(s){za=ta;Aa=ua}else{t=ta;z=ua;while(1){if(!t)Ba=ba;else Ba=ba+ +p[t>>3]*m;p[L+(z<<3)>>3]=Ba;z=z+1|0;if((z|0)==(j|0))break e;else t=t+(C<<3)|0}}while(1){t=c+(Aa<<3)|0;z=0;ma=0.0;while(1){ma=ma+ +p[sa+(z<<3)>>3]*+p[t>>3];z=z+1|0;if((z|0)==(G|0))break;else t=t+(y<<3)|0}_=ma*l;if(!za)Ca=_;else Ca=_+ +p[za>>3]*m;p[L+(Aa<<3)>>3]=Ca;Aa=Aa+1|0;if((Aa|0)==(j|0))break;else za=za+(C<<3)|0}}while(0);A=A+1|0;if((A|0)==(v|0))break b;else{O=O+(E<<3)|0;b=b+(B<<3)|0;L=L+(g<<3)|0;x=x+(B<<3)|0}}}x=r+8|0;f[r>>2]=x;L=r+4|0;f[L>>2]=j;if(j>>>0>136){b=OYa(j>>>0>536870911?-1:j<<3)|0;f[r>>2]=b;Da=b;Ea=b}else{Da=x;Ea=x}if((v|0)>0){b=(D|0)==0;O=(j|0)>0;A=(G|0)>0;s=j+-4|0;I=(j|0)<4;J=j&-4;R=b|(G|0)<1;P=(J|0)<(j|0);M=a;i=e;Q=h;K=0;while(1){if(R)Fa=b?M:D;else{t=0;do{z=M+((Y(t,F)|0)<<3)|0;p[D+(t<<3)>>3]=+p[z>>3];t=t+1|0}while((t|0)!=(G|0));Fa=D}if(O)F1a(Ea|0,0,S|0)|0;f:do if(A){if(I){if(O){Ga=c;Ha=0}else break;while(1){ba=+p[Fa+(Ha<<3)>>3];t=0;do{z=Ea+(t<<3)|0;p[z>>3]=+p[z>>3]+ba*+p[Ga+(t<<3)>>3];t=t+1|0}while((t|0)!=(j|0));Ha=Ha+1|0;if((Ha|0)==(G|0))break f;else Ga=Ga+(y<<3)|0}}if(P){Ia=c;Ja=0}else{t=c;z=0;while(1){ba=+p[Fa+(z<<3)>>3];d=0;do{N=Ea+(d<<3)|0;V=d|1;X=Ea+(V<<3)|0;ma=+p[X>>3]+ba*+p[t+(V<<3)>>3];p[N>>3]=+p[N>>3]+ba*+p[t+(d<<3)>>3];p[X>>3]=ma;X=d|2;N=Ea+(X<<3)|0;V=d|3;$=Ea+(V<<3)|0;ma=+p[$>>3]+ba*+p[t+(V<<3)>>3];p[N>>3]=+p[N>>3]+ba*+p[t+(X<<3)>>3];p[$>>3]=ma;d=d+4|0}while((d|0)<=(s|0));z=z+1|0;if((z|0)==(G|0))break f;else t=t+(y<<3)|0}}while(1){ba=+p[Fa+(Ja<<3)>>3];t=0;do{z=Ea+(t<<3)|0;d=t|1;$=Ea+(d<<3)|0;ma=+p[$>>3]+ba*+p[Ia+(d<<3)>>3];p[z>>3]=+p[z>>3]+ba*+p[Ia+(t<<3)>>3];p[$>>3]=ma;$=t|2;z=Ea+($<<3)|0;d=t|3;X=Ea+(d<<3)|0;ma=+p[X>>3]+ba*+p[Ia+(d<<3)>>3];p[z>>3]=+p[z>>3]+ba*+p[Ia+($<<3)>>3];p[X>>3]=ma;t=t+4|0}while((t|0)<=(s|0));Ka=J;do{t=Ea+(Ka<<3)|0;p[t>>3]=+p[t>>3]+ba*+p[Ia+(Ka<<3)>>3];Ka=Ka+1|0}while((Ka|0)!=(j|0));Ja=Ja+1|0;if((Ja|0)==(G|0))break;else Ia=Ia+(y<<3)|0}}while(0);if(!i){if(O){t=0;do{p[Q+(t<<3)>>3]=+p[Ea+(t<<3)>>3]*l;t=t+1|0}while((t|0)!=(j|0))}}else if(O){t=i;X=0;while(1){p[Q+(X<<3)>>3]=+p[Ea+(X<<3)>>3]*l+ +p[t>>3]*m;X=X+1|0;if((X|0)==(j|0))break;else t=t+(C<<3)|0}}K=K+1|0;if((K|0)==(v|0)){La=Da;break}else{M=M+(E<<3)|0;i=i+(B<<3)|0;Q=Q+(g<<3)|0}}}else La=Ea;if((La|0)!=(x|0)){QYa(La);f[r>>2]=x;f[L>>2]=136}}while(0);r=f[q>>2]|0;if((r|0)==(k|0)){u=o;return}if(r|0)QYa(r);f[q>>2]=k;f[w>>2]=136;u=o;return}function ZN(a,b,c,d,e,g,h,i,j,k,l,m,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0,Ra=0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0;q=u;u=u+2256|0;r=q+1160|0;s=q;t=f[j>>2]|0;v=f[j+4>>2]|0;j=f[k>>2]|0;w=f[k+4>>2]|0;k=r+8|0;F1a(k|0,0,1088)|0;f[r>>2]=k;x=r+4|0;f[x>>2]=136;y=b>>>3;z=d>>>3;A=g>>>3;g=i>>>3;i=(e|0)==0;B=(o&4|0)==0;C=i?0:B?A:1;D=i?0:B?1:A;if(o&1)if(b>>>0>15&(v|0)>1){f[x>>2]=v;if(v>>>0>136){A=OYa(v>>>0>536870911?-1:v<<3)|0;F1a(A|0,0,v<<3|0)|0;f[r>>2]=A;E=A;F=1;G=y;H=v;I=33}else{E=k;F=1;G=y;H=v;I=33}}else{J=1;K=y;L=v;I=5}else{J=y;K=1;L=t;I=5}if((I|0)==5)if((L|0)==1){t=s+8|0;F1a(t|0,0,1088)|0;f[s>>2]=t;A=s+4|0;f[A>>2]=136;if(b>>>0>15&(v|0)>1){f[x>>2]=w;if(w>>>0>136){v=OYa(w>>>0>536870911?-1:w<<3)|0;F1a(v|0,0,w<<3|0)|0;f[r>>2]=v;M=v}else M=k;if((w|0)>0){v=0;do{b=a+((Y(v,y)|0)<<3)|0;B=f[b+4>>2]|0;i=M+(v<<3)|0;f[i>>2]=f[b>>2];f[i+4>>2]=B;v=v+1|0}while((v|0)!=(w|0));N=M}else N=M}else N=a;if(d>>>0>15){f[A>>2]=j;if(j>>>0>136){d=OYa(j>>>0>536870911?-1:j<<3)|0;F1a(d|0,0,j<<3|0)|0;f[s>>2]=d;O=d}else O=t;if((j|0)>0){d=0;do{M=c+((Y(d,z)|0)<<3)|0;v=f[M+4>>2]|0;y=O+(d<<3)|0;f[y>>2]=f[M>>2];f[y+4>>2]=v;d=d+1|0}while((d|0)<(j|0));P=O}else P=O}else P=c;if((w|0)>0){O=D<<1;d=(j|0)<2;v=j+-2|0;y=v>>>1;M=(y<<1)+2|0;B=e;i=h;b=0;Q=e+(Y(D,(y<<4)+16|0)|0)|0;while(1){R=+n[N+(b<<3)>>2]*l;S=+n[N+(b<<3)+4>>2]*l;if(d){T=B;U=0}else{y=B;V=0;while(1){W=+n[P+(V<<3)>>2];X=+n[P+(V<<3)+4>>2];Z=R*W-S*X;_=S*W+R*X;$=V|1;X=+n[P+($<<3)>>2];W=+n[P+($<<3)+4>>2];aa=R*X-S*W;ba=S*X+R*W;if(!y){n[i+(V<<3)>>2]=Z;n[i+(V<<3)+4>>2]=_;ca=aa;da=ba}else{W=_+ +n[y+4>>2]*m;n[i+(V<<3)>>2]=Z+ +n[y>>2]*m;n[i+(V<<3)+4>>2]=W;ca=aa+ +n[y+(D<<3)>>2]*m;da=ba+ +n[y+(D<<3)+4>>2]*m}n[i+($<<3)>>2]=ca;n[i+($<<3)+4>>2]=da;V=V+2|0;if((V|0)>(v|0)){T=Q;U=M;break}else y=y+(O<<3)|0}}if((U|0)<(j|0)){y=T;V=U;while(1){ba=+n[P+(V<<3)>>2];aa=+n[P+(V<<3)+4>>2];W=R*ba-S*aa;Z=S*ba+R*aa;if(!y){ea=W;fa=Z}else{ea=W+ +n[y>>2]*m;fa=Z+ +n[y+4>>2]*m}n[i+(V<<3)>>2]=ea;n[i+(V<<3)+4>>2]=fa;V=V+1|0;if((V|0)==(j|0))break;else y=y+(D<<3)|0}}b=b+1|0;if((b|0)==(w|0))break;else{B=B+(C<<3)|0;i=i+(g<<3)|0;Q=Q+(C<<3)|0}}}Q=f[s>>2]|0;if((Q|0)!=(t|0)){if(Q|0)QYa(Q);f[s>>2]=t;f[A>>2]=136}}else{E=0;F=J;G=K;H=L;I=33}a:do if((I|0)==33){if(o&2|0){if((w|0)<=0)break;L=(E|0)==0;K=H+-4|0;J=(H|0)<4;A=H&-4;t=L|(H|0)<1;Q=(j|0)>0;i=a;B=e;b=h;P=0;while(1){if(t)ga=L?i:E;else{U=0;do{T=i+((Y(U,G)|0)<<3)|0;O=f[T+4>>2]|0;M=E+(U<<3)|0;f[M>>2]=f[T>>2];f[M+4>>2]=O;U=U+1|0}while((U|0)!=(H|0));ga=E}if(Q){U=c;O=B;M=0;while(1){if(J){ha=0;ia=0.0;ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0;oa=0.0;pa=0.0}else{T=0;fa=0.0;ea=0.0;da=0.0;ca=0.0;R=0.0;S=0.0;Z=0.0;W=0.0;while(1){aa=+n[ga+(T<<3)>>2];ba=+n[ga+(T<<3)+4>>2];_=+n[U+(T<<3)>>2];X=+n[U+(T<<3)+4>>2];qa=fa+(aa*_-ba*X);ra=ea+(ba*_+aa*X);v=T|1;X=+n[ga+(v<<3)>>2];aa=+n[ga+(v<<3)+4>>2];_=+n[U+(v<<3)>>2];ba=+n[U+(v<<3)+4>>2];sa=da+(X*_-aa*ba);ta=ca+(aa*_+X*ba);v=T|2;ba=+n[ga+(v<<3)>>2];X=+n[ga+(v<<3)+4>>2];_=+n[U+(v<<3)>>2];aa=+n[U+(v<<3)+4>>2];ua=R+(ba*_-X*aa);va=S+(X*_+ba*aa);v=T|3;aa=+n[ga+(v<<3)>>2];ba=+n[ga+(v<<3)+4>>2];_=+n[U+(v<<3)>>2];X=+n[U+(v<<3)+4>>2];wa=Z+(aa*_-ba*X);xa=W+(ba*_+aa*X);T=T+4|0;if((T|0)>(K|0)){ha=A;ia=qa;ja=ra;ka=sa;la=ta;ma=ua;na=va;oa=wa;pa=xa;break}else{fa=qa;ea=ra;da=sa;ca=ta;R=ua;S=va;Z=wa;W=xa}}}if((ha|0)<(H|0)){T=ha;W=ia;Z=ja;while(1){S=+n[ga+(T<<3)>>2];R=+n[ga+(T<<3)+4>>2];ca=+n[U+(T<<3)>>2];da=+n[U+(T<<3)+4>>2];ea=W+(S*ca-R*da);fa=Z+(R*ca+S*da);T=T+1|0;if((T|0)==(H|0)){ya=ea;za=fa;break}else{W=ea;Z=fa}}}else{ya=ia;za=ja}Z=(oa+(ma+(ka+ya)))*l;W=(pa+(na+(la+za)))*l;if(!O){Aa=Z;Ba=W}else{Aa=Z+ +n[O>>2]*m;Ba=W+ +n[O+4>>2]*m}n[b+(M<<3)>>2]=Aa;n[b+(M<<3)+4>>2]=Ba;M=M+1|0;if((M|0)==(j|0))break;else{U=U+(z<<3)|0;O=O+(D<<3)|0}}}P=P+1|0;if((P|0)==(w|0))break a;else{i=i+(F<<3)|0;B=B+(C<<3)|0;b=b+(g<<3)|0}}}if(j<<3>>>0<1601){if((w|0)<=0)break;b=(E|0)==0;B=j+-4|0;i=(j|0)<4;P=(H|0)>0;A=D<<2;K=D<<1;J=D*3|0;Q=B>>>2;L=(Q<<2)+4|0;t=b|(H|0)<1;W=l*0.0;O=a;U=e;M=h;T=0;v=e+(Y((Q<<5)+32|0,D)|0)|0;while(1){if(t)Ca=b?O:E;else{Q=0;do{d=O+((Y(Q,G)|0)<<3)|0;N=f[d+4>>2]|0;y=E+(Q<<3)|0;f[y>>2]=f[d>>2];f[y+4>>2]=N;Q=Q+1|0}while((Q|0)!=(H|0));Ca=E}if(i){Da=U;Ea=0}else{Q=U;N=0;while(1){if(P){y=c+(N<<3)|0;d=0;Z=0.0;fa=0.0;ea=0.0;da=0.0;S=0.0;ca=0.0;R=0.0;xa=0.0;while(1){wa=+n[Ca+(d<<3)>>2];va=+n[Ca+(d<<3)+4>>2];ua=+n[y>>2];ta=+n[y+4>>2];sa=Z+(wa*ua-va*ta);ra=fa+(va*ua+wa*ta);ta=+n[y+8>>2];ua=+n[y+12>>2];qa=ea+(wa*ta-va*ua);X=da+(va*ta+wa*ua);ua=+n[y+16>>2];ta=+n[y+20>>2];aa=S+(wa*ua-va*ta);_=ca+(va*ua+wa*ta);ta=+n[y+24>>2];ua=+n[y+28>>2];ba=R+(wa*ta-va*ua);Fa=xa+(va*ta+wa*ua);d=d+1|0;if((d|0)==(H|0)){Ga=sa;Ha=ra;Ia=qa;Ja=X;Ka=aa;La=_;Ma=ba;Na=Fa;break}else{y=y+(z<<3)|0;Z=sa;fa=ra;ea=qa;da=X;S=aa;ca=_;R=ba;xa=Fa}}}else{Ga=0.0;Ha=0.0;Ia=0.0;Ja=0.0;Ka=0.0;La=0.0;Ma=0.0;Na=0.0}xa=Ga*l;R=Ha*l;if(!Q){n[M+(N<<3)>>2]=xa;n[M+(N<<3)+4>>2]=R;y=N|1;n[M+(y<<3)>>2]=Ia*l;n[M+(y<<3)+4>>2]=Ja*l;y=N|2;n[M+(y<<3)>>2]=Ka*l;n[M+(y<<3)+4>>2]=La*l;Oa=Ma*l;Pa=Na*l}else{ca=R+ +n[Q+4>>2]*m;n[M+(N<<3)>>2]=xa+ +n[Q>>2]*m;n[M+(N<<3)+4>>2]=ca;ca=Ja*l+ +n[Q+(D<<3)+4>>2]*m;y=N|1;n[M+(y<<3)>>2]=Ia*l+ +n[Q+(D<<3)>>2]*m;n[M+(y<<3)+4>>2]=ca;ca=La*l+ +n[Q+(K<<3)+4>>2]*m;y=N|2;n[M+(y<<3)>>2]=Ka*l+ +n[Q+(K<<3)>>2]*m;n[M+(y<<3)+4>>2]=ca;Oa=Ma*l+ +n[Q+(J<<3)>>2]*m;Pa=Na*l+ +n[Q+(J<<3)+4>>2]*m}y=N|3;n[M+(y<<3)>>2]=Oa;n[M+(y<<3)+4>>2]=Pa;N=N+4|0;if((N|0)>(B|0)){Da=v;Ea=L;break}else Q=Q+(A<<3)|0}}b:do if((Ea|0)<(j|0)){if(P){Qa=Da;Ra=Ea}else{Q=Da;N=Ea;while(1){if(!Q){Sa=W;Ta=W}else{Sa=W+ +n[Q>>2]*m;Ta=W+ +n[Q+4>>2]*m}n[M+(N<<3)>>2]=Sa;n[M+(N<<3)+4>>2]=Ta;N=N+1|0;if((N|0)==(j|0))break b;else Q=Q+(D<<3)|0}}while(1){Q=c+(Ra<<3)|0;N=0;ca=0.0;xa=0.0;while(1){R=+n[Ca+(N<<3)>>2];S=+n[Ca+(N<<3)+4>>2];da=+n[Q>>2];ea=+n[Q+4>>2];ca=ca+(R*da-S*ea);xa=xa+(S*da+R*ea);N=N+1|0;if((N|0)==(H|0))break;else Q=Q+(z<<3)|0}ea=ca*l;R=xa*l;if(!Qa){Ua=ea;Va=R}else{Ua=ea+ +n[Qa>>2]*m;Va=R+ +n[Qa+4>>2]*m}n[M+(Ra<<3)>>2]=Ua;n[M+(Ra<<3)+4>>2]=Va;Ra=Ra+1|0;if((Ra|0)==(j|0))break;else Qa=Qa+(D<<3)|0}}while(0);T=T+1|0;if((T|0)==(w|0))break a;else{O=O+(F<<3)|0;U=U+(C<<3)|0;M=M+(g<<3)|0;v=v+(C<<3)|0}}}v=s+8|0;F1a(v|0,0,1152)|0;f[s>>2]=v;M=s+4|0;f[M>>2]=j;if(j>>>0>72){U=OYa(j>>>0>268435455?-1:j<<4)|0;F1a(U|0,0,j<<4|0)|0;f[s>>2]=U;Wa=U}else Wa=v;if((w|0)>0){U=(E|0)==0;O=(j|0)>0;T=(H|0)>0;P=j+-4|0;A=(j|0)<4;L=j<<4;B=j&-4;J=U|(H|0)<1;K=a;i=e;b=h;t=0;while(1){if(J)Xa=U?K:E;else{Q=0;do{N=K+((Y(Q,G)|0)<<3)|0;y=f[N+4>>2]|0;d=E+(Q<<3)|0;f[d>>2]=f[N>>2];f[d+4>>2]=y;Q=Q+1|0}while((Q|0)!=(H|0));Xa=E}if(O)F1a(Wa|0,0,L|0)|0;if(T){Q=c;y=0;while(1){W=+n[Xa+(y<<3)>>2];R=+n[Xa+(y<<3)+4>>2];if(A)Ya=0;else{d=0;do{ea=+n[Q+(d<<3)>>2];da=+n[Q+(d<<3)+4>>2];N=Wa+(d<<4)|0;V=Wa+(d<<4)+8|0;S=+p[V>>3]+(R*ea+W*da);$=d|1;fa=+n[Q+($<<3)>>2];Z=+n[Q+($<<3)+4>>2];Za=Wa+($<<4)|0;_a=Wa+($<<4)+8|0;Fa=+p[Za>>3]+(W*fa-R*Z);ba=+p[_a>>3]+(R*fa+W*Z);p[N>>3]=+p[N>>3]+(W*ea-R*da);p[V>>3]=S;p[Za>>3]=Fa;p[_a>>3]=ba;_a=d|2;ba=+n[Q+(_a<<3)>>2];Fa=+n[Q+(_a<<3)+4>>2];Za=Wa+(_a<<4)|0;V=Wa+(_a<<4)+8|0;S=+p[V>>3]+(R*ba+W*Fa);_a=d|3;da=+n[Q+(_a<<3)>>2];ea=+n[Q+(_a<<3)+4>>2];N=Wa+(_a<<4)|0;$=Wa+(_a<<4)+8|0;Z=+p[N>>3]+(W*da-R*ea);fa=+p[$>>3]+(R*da+W*ea);p[Za>>3]=+p[Za>>3]+(W*ba-R*Fa);p[V>>3]=S;p[N>>3]=Z;p[$>>3]=fa;d=d+4|0}while((d|0)<=(P|0));Ya=B}if((Ya|0)<(j|0)){d=Ya;do{fa=+n[Q+(d<<3)>>2];Z=+n[Q+(d<<3)+4>>2];$=Wa+(d<<4)|0;p[$>>3]=+p[$>>3]+(W*fa-R*Z);$=Wa+(d<<4)+8|0;p[$>>3]=+p[$>>3]+(R*fa+W*Z);d=d+1|0}while((d|0)!=(j|0))}y=y+1|0;if((y|0)==(H|0))break;else Q=Q+(z<<3)|0}}if(!i){if(O){Q=0;do{W=+p[Wa+(Q<<4)+8>>3]*l;n[b+(Q<<3)>>2]=+p[Wa+(Q<<4)>>3]*l;n[b+(Q<<3)+4>>2]=W;Q=Q+1|0}while((Q|0)!=(j|0))}}else if(O){Q=i;y=0;while(1){W=+p[Wa+(y<<4)+8>>3]*l+ +n[Q+4>>2]*m;n[b+(y<<3)>>2]=+p[Wa+(y<<4)>>3]*l+ +n[Q>>2]*m;n[b+(y<<3)+4>>2]=W;y=y+1|0;if((y|0)==(j|0))break;else Q=Q+(D<<3)|0}}t=t+1|0;if((t|0)==(w|0))break;else{K=K+(F<<3)|0;i=i+(C<<3)|0;b=b+(g<<3)|0}}$a=f[s>>2]|0}else $a=Wa;if(($a|0)!=(v|0)){if($a|0)QYa($a);f[s>>2]=v;f[M>>2]=72}}while(0);s=f[r>>2]|0;if((s|0)==(k|0)){u=q;return}if(s|0)QYa(s);f[r>>2]=k;f[x>>2]=136;u=q;return}function _N(a,b,c,d,e,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;n=n|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Z=0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0,Pa=0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0;o=u;u=u+2320|0;q=o+1160|0;r=o;s=f[j>>2]|0;t=f[j+4>>2]|0;j=f[k>>2]|0;v=f[k+4>>2]|0;k=q+8|0;F1a(k|0,0,1152)|0;f[q>>2]=k;w=q+4|0;f[w>>2]=72;x=b>>>4;y=d>>>4;z=g>>>4;g=i>>>4;i=(e|0)==0;A=(n&4|0)==0;B=i?0:A?z:1;C=i?0:A?1:z;if(n&1)if(b>>>0>31&(t|0)>1){f[w>>2]=t;if(t>>>0>72){z=OYa(t>>>0>268435455?-1:t<<4)|0;F1a(z|0,0,t<<4|0)|0;f[q>>2]=z;D=z;E=1;F=x;G=t;H=40}else{D=k;E=1;F=x;G=t;H=40}}else{I=1;J=x;K=t;H=5}else{I=x;J=1;K=s;H=5}if((H|0)==5)if((K|0)==1){s=r+8|0;F1a(s|0,0,1152)|0;f[r>>2]=s;z=r+4|0;f[z>>2]=72;if(b>>>0>31&(t|0)>1){f[w>>2]=v;if(v>>>0>72){t=OYa(v>>>0>268435455?-1:v<<4)|0;F1a(t|0,0,v<<4|0)|0;f[q>>2]=t;L=t}else L=k;if((v|0)>0){t=0;do{b=a+((Y(t,x)|0)<<4)|0;A=L+(t<<4)|0;f[A>>2]=f[b>>2];f[A+4>>2]=f[b+4>>2];f[A+8>>2]=f[b+8>>2];f[A+12>>2]=f[b+12>>2];t=t+1|0}while((t|0)!=(v|0));M=L}else M=L}else M=a;if(d>>>0>31){f[z>>2]=j;if(j>>>0>72){d=OYa(j>>>0>268435455?-1:j<<4)|0;F1a(d|0,0,j<<4|0)|0;f[r>>2]=d;N=d}else N=s;if((j|0)>0){d=0;do{L=c+((Y(d,y)|0)<<4)|0;t=N+(d<<4)|0;f[t>>2]=f[L>>2];f[t+4>>2]=f[L+4>>2];f[t+8>>2]=f[L+8>>2];f[t+12>>2]=f[L+12>>2];d=d+1|0}while((d|0)<(j|0));O=N}else O=N}else O=c;a:do if((v|0)>0){N=C<<1;d=j+-2|0;if((j|0)<2){L=(j|0)==1;t=e;x=h;b=0;while(1){P=+p[M+(b<<4)>>3]*l;Q=+p[M+(b<<4)+8>>3]*l;if(L){A=t;i=0;while(1){R=+p[O+(i<<4)>>3];S=+p[O+(i<<4)+8>>3];T=P*R-Q*S;U=Q*R+P*S;if(!A){V=T;W=U}else{V=T+ +p[A>>3]*m;W=U+ +p[A+8>>3]*m}p[x+(i<<4)>>3]=V;p[x+(i<<4)+8>>3]=W;i=i+1|0;if((i|0)==(j|0))break;else A=A+(C<<4)|0}}b=b+1|0;if((b|0)==(v|0))break a;else{t=t+(B<<4)|0;x=x+(g<<4)|0}}}x=d>>>1;t=(x<<1)+2|0;b=(t|0)<(j|0);L=e;A=h;i=0;X=e+(Y(C,(x<<5)+32|0)|0)|0;while(1){P=+p[M+(i<<4)>>3]*l;Q=+p[M+(i<<4)+8>>3]*l;x=L;Z=0;while(1){U=+p[O+(Z<<4)>>3];T=+p[O+(Z<<4)+8>>3];S=P*U-Q*T;R=Q*U+P*T;_=Z|1;T=+p[O+(_<<4)>>3];U=+p[O+(_<<4)+8>>3];$=P*T-Q*U;aa=Q*T+P*U;if(!x){p[A+(Z<<4)>>3]=S;p[A+(Z<<4)+8>>3]=R;ba=$;ca=aa}else{U=R+ +p[x+8>>3]*m;p[A+(Z<<4)>>3]=S+ +p[x>>3]*m;p[A+(Z<<4)+8>>3]=U;ba=$+ +p[x+(C<<4)>>3]*m;ca=aa+ +p[x+(C<<4)+8>>3]*m}p[A+(_<<4)>>3]=ba;p[A+(_<<4)+8>>3]=ca;Z=Z+2|0;if((Z|0)>(d|0))break;else x=x+(N<<4)|0}if(b){x=X;Z=t;while(1){aa=+p[O+(Z<<4)>>3];$=+p[O+(Z<<4)+8>>3];U=P*aa-Q*$;S=Q*aa+P*$;if(!x){da=U;ea=S}else{da=U+ +p[x>>3]*m;ea=S+ +p[x+8>>3]*m}p[A+(Z<<4)>>3]=da;p[A+(Z<<4)+8>>3]=ea;Z=Z+1|0;if((Z|0)==(j|0))break;else x=x+(C<<4)|0}}i=i+1|0;if((i|0)==(v|0))break;else{L=L+(B<<4)|0;A=A+(g<<4)|0;X=X+(B<<4)|0}}}while(0);O=f[r>>2]|0;if((O|0)!=(s|0)){if(O|0)QYa(O);f[r>>2]=s;f[z>>2]=72}}else{D=0;E=I;F=J;G=K;H=40}b:do if((H|0)==40){if(n&2|0){if((v|0)<=0)break;K=(D|0)==0;J=G+-4|0;I=(G|0)<4;z=G&-4;s=K|(G|0)<1;O=(j|0)>0;M=a;X=e;A=h;L=0;while(1){if(s)fa=K?M:D;else{i=0;do{t=M+((Y(i,F)|0)<<4)|0;b=D+(i<<4)|0;f[b>>2]=f[t>>2];f[b+4>>2]=f[t+4>>2];f[b+8>>2]=f[t+8>>2];f[b+12>>2]=f[t+12>>2];i=i+1|0}while((i|0)!=(G|0));fa=D}if(O){i=c;t=X;b=0;while(1){if(I){ga=0;ha=0.0;ia=0.0;ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0;oa=0.0}else{N=0;ea=0.0;da=0.0;ca=0.0;ba=0.0;W=0.0;V=0.0;P=0.0;Q=0.0;while(1){S=+p[fa+(N<<4)>>3];U=+p[fa+(N<<4)+8>>3];$=+p[i+(N<<4)>>3];aa=+p[i+(N<<4)+8>>3];R=ea+(S*$-U*aa);T=da+(U*$+S*aa);d=N|1;aa=+p[fa+(d<<4)>>3];S=+p[fa+(d<<4)+8>>3];$=+p[i+(d<<4)>>3];U=+p[i+(d<<4)+8>>3];pa=ca+(aa*$-S*U);qa=ba+(S*$+aa*U);d=N|2;U=+p[fa+(d<<4)>>3];aa=+p[fa+(d<<4)+8>>3];$=+p[i+(d<<4)>>3];S=+p[i+(d<<4)+8>>3];ra=W+(U*$-aa*S);sa=V+(aa*$+U*S);d=N|3;S=+p[fa+(d<<4)>>3];U=+p[fa+(d<<4)+8>>3];$=+p[i+(d<<4)>>3];aa=+p[i+(d<<4)+8>>3];ta=P+(S*$-U*aa);ua=Q+(U*$+S*aa);N=N+4|0;if((N|0)>(J|0)){ga=z;ha=R;ia=T;ja=pa;ka=qa;la=ra;ma=sa;na=ta;oa=ua;break}else{ea=R;da=T;ca=pa;ba=qa;W=ra;V=sa;P=ta;Q=ua}}}if((ga|0)<(G|0)){N=ga;Q=ha;P=ia;while(1){V=+p[fa+(N<<4)>>3];W=+p[fa+(N<<4)+8>>3];ba=+p[i+(N<<4)>>3];ca=+p[i+(N<<4)+8>>3];da=Q+(V*ba-W*ca);ea=P+(W*ba+V*ca);N=N+1|0;if((N|0)==(G|0)){va=da;wa=ea;break}else{Q=da;P=ea}}}else{va=ha;wa=ia}P=(na+(la+(ja+va)))*l;Q=(oa+(ma+(ka+wa)))*l;if(!t){xa=P;ya=Q}else{xa=P+ +p[t>>3]*m;ya=Q+ +p[t+8>>3]*m}p[A+(b<<4)>>3]=xa;p[A+(b<<4)+8>>3]=ya;b=b+1|0;if((b|0)==(j|0))break;else{i=i+(y<<4)|0;t=t+(C<<4)|0}}}L=L+1|0;if((L|0)==(v|0))break b;else{M=M+(E<<4)|0;X=X+(B<<4)|0;A=A+(g<<4)|0}}}A=j<<4;if(A>>>0<1601){if((v|0)<=0)break;X=(D|0)==0;M=j+-4|0;L=(j|0)<4;z=(G|0)>0;J=C<<2;I=C<<1;O=C*3|0;K=M>>>2;s=(K<<2)+4|0;t=X|(G|0)<1;Q=l*0.0;i=a;b=e;N=h;d=0;x=e+(Y((K<<6)+64|0,C)|0)|0;while(1){if(t)za=X?i:D;else{K=0;do{Z=i+((Y(K,F)|0)<<4)|0;_=D+(K<<4)|0;f[_>>2]=f[Z>>2];f[_+4>>2]=f[Z+4>>2];f[_+8>>2]=f[Z+8>>2];f[_+12>>2]=f[Z+12>>2];K=K+1|0}while((K|0)!=(G|0));za=D}if(L){Aa=b;Ba=0}else{K=b;Z=0;while(1){if(z){_=c+(Z<<4)|0;Ca=0;P=0.0;ea=0.0;da=0.0;ca=0.0;V=0.0;ba=0.0;W=0.0;ua=0.0;while(1){ta=+p[za+(Ca<<4)>>3];sa=+p[za+(Ca<<4)+8>>3];ra=+p[_>>3];qa=+p[_+8>>3];pa=P+(ta*ra-sa*qa);T=ea+(sa*ra+ta*qa);qa=+p[_+16>>3];ra=+p[_+24>>3];R=da+(ta*qa-sa*ra);aa=ca+(sa*qa+ta*ra);ra=+p[_+32>>3];qa=+p[_+40>>3];S=V+(ta*ra-sa*qa);$=ba+(sa*ra+ta*qa);qa=+p[_+48>>3];ra=+p[_+56>>3];U=W+(ta*qa-sa*ra);Da=ua+(sa*qa+ta*ra);Ca=Ca+1|0;if((Ca|0)==(G|0)){Ea=pa;Fa=T;Ga=R;Ha=aa;Ia=S;Ja=$;Ka=U;La=Da;break}else{_=_+(y<<4)|0;P=pa;ea=T;da=R;ca=aa;V=S;ba=$;W=U;ua=Da}}}else{Ea=0.0;Fa=0.0;Ga=0.0;Ha=0.0;Ia=0.0;Ja=0.0;Ka=0.0;La=0.0}ua=Ea*l;W=Fa*l;if(!K){p[N+(Z<<4)>>3]=ua;p[N+(Z<<4)+8>>3]=W;_=Z|1;p[N+(_<<4)>>3]=Ga*l;p[N+(_<<4)+8>>3]=Ha*l;_=Z|2;p[N+(_<<4)>>3]=Ia*l;p[N+(_<<4)+8>>3]=Ja*l;Ma=Ka*l;Na=La*l}else{ba=W+ +p[K+8>>3]*m;p[N+(Z<<4)>>3]=ua+ +p[K>>3]*m;p[N+(Z<<4)+8>>3]=ba;ba=Ha*l+ +p[K+(C<<4)+8>>3]*m;_=Z|1;p[N+(_<<4)>>3]=Ga*l+ +p[K+(C<<4)>>3]*m;p[N+(_<<4)+8>>3]=ba;ba=Ja*l+ +p[K+(I<<4)+8>>3]*m;_=Z|2;p[N+(_<<4)>>3]=Ia*l+ +p[K+(I<<4)>>3]*m;p[N+(_<<4)+8>>3]=ba;Ma=Ka*l+ +p[K+(O<<4)>>3]*m;Na=La*l+ +p[K+(O<<4)+8>>3]*m}_=Z|3;p[N+(_<<4)>>3]=Ma;p[N+(_<<4)+8>>3]=Na;Z=Z+4|0;if((Z|0)>(M|0)){Aa=x;Ba=s;break}else K=K+(J<<4)|0}}c:do if((Ba|0)<(j|0)){if(z){Oa=Aa;Pa=Ba}else{K=Aa;Z=Ba;while(1){if(!K){Qa=Q;Ra=Q}else{Qa=Q+ +p[K>>3]*m;Ra=Q+ +p[K+8>>3]*m}p[N+(Z<<4)>>3]=Qa;p[N+(Z<<4)+8>>3]=Ra;Z=Z+1|0;if((Z|0)==(j|0))break c;else K=K+(C<<4)|0}}while(1){K=c+(Pa<<4)|0;Z=0;ba=0.0;ua=0.0;while(1){W=+p[za+(Z<<4)>>3];V=+p[za+(Z<<4)+8>>3];ca=+p[K>>3];da=+p[K+8>>3];ba=ba+(W*ca-V*da);ua=ua+(V*ca+W*da);Z=Z+1|0;if((Z|0)==(G|0))break;else K=K+(y<<4)|0}da=ba*l;W=ua*l;if(!Oa){Sa=da;Ta=W}else{Sa=da+ +p[Oa>>3]*m;Ta=W+ +p[Oa+8>>3]*m}p[N+(Pa<<4)>>3]=Sa;p[N+(Pa<<4)+8>>3]=Ta;Pa=Pa+1|0;if((Pa|0)==(j|0))break;else Oa=Oa+(C<<4)|0}}while(0);d=d+1|0;if((d|0)==(v|0))break b;else{i=i+(E<<4)|0;b=b+(B<<4)|0;N=N+(g<<4)|0;x=x+(B<<4)|0}}}x=r+8|0;F1a(x|0,0,1152)|0;f[r>>2]=x;N=r+4|0;f[N>>2]=j;if(j>>>0>72){b=OYa(j>>>0>268435455?-1:j<<4)|0;F1a(b|0,0,A|0)|0;f[r>>2]=b;Ua=b}else Ua=x;if((v|0)>0){b=(D|0)==0;i=(j|0)>0;d=(G|0)>0;z=j+-4|0;J=(j|0)<4;s=j&-4;M=b|(G|0)<1;O=a;I=e;L=h;X=0;while(1){if(M)Va=b?O:D;else{t=0;do{K=O+((Y(t,F)|0)<<4)|0;Z=D+(t<<4)|0;f[Z>>2]=f[K>>2];f[Z+4>>2]=f[K+4>>2];f[Z+8>>2]=f[K+8>>2];f[Z+12>>2]=f[K+12>>2];t=t+1|0}while((t|0)!=(G|0));Va=D}if(i)F1a(Ua|0,0,A|0)|0;if(d){t=c;K=0;while(1){Q=+p[Va+(K<<4)>>3];W=+p[Va+(K<<4)+8>>3];if(J)Wa=0;else{Z=0;do{da=+p[t+(Z<<4)>>3];ca=+p[t+(Z<<4)+8>>3];_=Ua+(Z<<4)|0;Ca=Ua+(Z<<4)+8|0;V=+p[Ca>>3]+(W*da+Q*ca);Xa=Z|1;ea=+p[t+(Xa<<4)>>3];P=+p[t+(Xa<<4)+8>>3];Ya=Ua+(Xa<<4)|0;Za=Ua+(Xa<<4)+8|0;Da=+p[Ya>>3]+(Q*ea-W*P);U=+p[Za>>3]+(W*ea+Q*P);p[_>>3]=+p[_>>3]+(Q*da-W*ca);p[Ca>>3]=V;p[Ya>>3]=Da;p[Za>>3]=U;Za=Z|2;U=+p[t+(Za<<4)>>3];Da=+p[t+(Za<<4)+8>>3];Ya=Ua+(Za<<4)|0;Ca=Ua+(Za<<4)+8|0;V=+p[Ca>>3]+(W*U+Q*Da);Za=Z|3;ca=+p[t+(Za<<4)>>3];da=+p[t+(Za<<4)+8>>3];_=Ua+(Za<<4)|0;Xa=Ua+(Za<<4)+8|0;P=+p[_>>3]+(Q*ca-W*da);ea=+p[Xa>>3]+(W*ca+Q*da);p[Ya>>3]=+p[Ya>>3]+(Q*U-W*Da);p[Ca>>3]=V;p[_>>3]=P;p[Xa>>3]=ea;Z=Z+4|0}while((Z|0)<=(z|0));Wa=s}if((Wa|0)<(j|0)){Z=Wa;do{ea=+p[t+(Z<<4)>>3];P=+p[t+(Z<<4)+8>>3];Xa=Ua+(Z<<4)|0;p[Xa>>3]=+p[Xa>>3]+(Q*ea-W*P);Xa=Ua+(Z<<4)+8|0;p[Xa>>3]=W*ea+Q*P+ +p[Xa>>3];Z=Z+1|0}while((Z|0)!=(j|0))}K=K+1|0;if((K|0)==(G|0))break;else t=t+(y<<4)|0}}if(!I){if(i){t=0;do{Q=+p[Ua+(t<<4)+8>>3]*l;p[L+(t<<4)>>3]=+p[Ua+(t<<4)>>3]*l;p[L+(t<<4)+8>>3]=Q;t=t+1|0}while((t|0)!=(j|0))}}else if(i){t=I;K=0;while(1){Q=+p[Ua+(K<<4)+8>>3]*l+ +p[t+8>>3]*m;p[L+(K<<4)>>3]=+p[Ua+(K<<4)>>3]*l+ +p[t>>3]*m;p[L+(K<<4)+8>>3]=Q;K=K+1|0;if((K|0)==(j|0))break;else t=t+(C<<4)|0}}X=X+1|0;if((X|0)==(v|0))break;else{O=O+(E<<4)|0;I=I+(B<<4)|0;L=L+(g<<4)|0}}_a=f[r>>2]|0}else _a=Ua;if((_a|0)!=(x|0)){if(_a|0)QYa(_a);f[r>>2]=x;f[N>>2]=72}}while(0);r=f[q>>2]|0;if((r|0)==(k|0)){u=o;return}if(r|0)QYa(r);f[q>>2]=k;f[w>>2]=72;u=o;return}function $N(a,b,c,d,e,g,h,i,j,k,l,m,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0,X=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0.0,ca=0.0,da=0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0,xa=0.0,ya=0.0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0;q=u;u=u+2160|0;r=q+1096|0;s=q;t=f[j>>2]|0;v=f[j+4>>2]|0;j=f[k>>2]|0;w=f[k+4>>2]|0;k=r+8|0;f[r>>2]=k;x=r+4|0;f[x>>2]=264;y=b>>>2;z=d>>>2;A=g>>>2;g=i>>>2;i=(e|0)==0;B=(o&4|0)==0;C=i?0:B?A:1;D=i?0:B?1:A;if(o&1)if(b>>>0>7&(v|0)>1){f[x>>2]=v;if(v>>>0>264){A=OYa(v>>>0>1073741823?-1:v<<2)|0;f[r>>2]=A;E=A;F=1;G=y;H=v;I=43}else{E=k;F=1;G=y;H=v;I=43}}else{J=1;K=y;L=v;I=5}else{J=y;K=1;L=t;I=5}if((I|0)==5)if((L|0)==1){t=s+8|0;f[s>>2]=t;A=s+4|0;f[A>>2]=264;if(b>>>0>7&(v|0)>1){f[x>>2]=w;if(w>>>0>264){v=OYa(w>>>0>1073741823?-1:w<<2)|0;f[r>>2]=v;M=v}else M=k;if((w|0)>0){v=0;do{b=a+((Y(v,y)|0)<<2)|0;f[M+(v<<2)>>2]=f[b>>2];v=v+1|0}while((v|0)!=(w|0));N=M}else N=M}else N=a;if(d>>>0>7){f[A>>2]=j;if(j>>>0>264){d=OYa(j>>>0>1073741823?-1:j<<2)|0;f[s>>2]=d;O=d}else O=t;if((j|0)>0){d=0;do{M=c+((Y(d,z)|0)<<2)|0;f[O+(d<<2)>>2]=f[M>>2];d=d+1|0}while((d|0)!=(j|0));P=O;Q=O}else{P=O;Q=O}}else{P=t;Q=c}a:do if((w|0)>0){O=D<<1;if((j|0)<2){if((j|0)==1){R=e;S=h;T=0}else break;while(1){U=+n[N+(T<<2)>>2]*l*+n[Q>>2];if(!R)V=U;else V=U+ +n[R>>2]*m;n[S>>2]=V;T=T+1|0;if((T|0)==(w|0))break a;else{R=R+(C<<2)|0;S=S+(g<<2)|0}}}d=j+-2|0;M=((d|0)>1?d:1)>>>1;v=Y(M,O)|0;y=(M<<1)+2|0;if((y|0)>=(j|0)){M=e;b=h;B=0;while(1){U=+n[N+(B<<2)>>2]*l;i=M;W=0;while(1){X=U*+n[Q+(W<<2)>>2];Z=W|1;_=U*+n[Q+(Z<<2)>>2];if(!i){n[b+(W<<2)>>2]=X;$=_}else{n[b+(W<<2)>>2]=X+ +n[i>>2]*m;$=_+ +n[i+(D<<2)>>2]*m}n[b+(Z<<2)>>2]=$;W=W+2|0;if((W|0)>(d|0))break;else i=i+(O<<2)|0}B=B+1|0;if((B|0)==(w|0))break a;else{M=M+(C<<2)|0;b=b+(g<<2)|0}}}b=e;M=h;B=0;i=e+(O<<2)|0;while(1){U=+n[N+(B<<2)>>2]*l;W=b;Z=0;while(1){_=U*+n[Q+(Z<<2)>>2];aa=Z|1;X=U*+n[Q+(aa<<2)>>2];if(!W){n[M+(Z<<2)>>2]=_;ba=X}else{n[M+(Z<<2)>>2]=_+ +n[W>>2]*m;ba=X+ +n[W+(D<<2)>>2]*m}n[M+(aa<<2)>>2]=ba;Z=Z+2|0;if((Z|0)>(d|0))break;else W=W+(O<<2)|0}W=i+(v<<2)|0;Z=y;while(1){X=U*+n[Q+(Z<<2)>>2];if(!W)ca=X;else ca=X+ +n[W>>2]*m;n[M+(Z<<2)>>2]=ca;Z=Z+1|0;if((Z|0)==(j|0))break;else W=W+(D<<2)|0}B=B+1|0;if((B|0)==(w|0))break;else{b=b+(C<<2)|0;M=M+(g<<2)|0;i=i+(C<<2)|0}}}while(0);if((P|0)!=(t|0)){QYa(P);f[s>>2]=t;f[A>>2]=264}}else{E=0;F=J;G=K;H=L;I=43}b:do if((I|0)==43){if(o&2|0){if((w|0)<=0)break;L=(E|0)==0;K=(j|0)>0;J=H+-4|0;A=(H|0)<4;t=H&-4;P=L|(H|0)<1;Q=(H|0)>0;N=(t|0)<(H|0);ca=l*0.0;S=a;R=e;T=h;i=0;while(1){if(P)da=L?S:E;else{M=0;do{b=S+((Y(M,G)|0)<<2)|0;f[E+(M<<2)>>2]=f[b>>2];M=M+1|0}while((M|0)!=(H|0));da=E}c:do if(K){if(!A){M=c;b=R;B=0;while(1){y=0;ba=0.0;$=0.0;V=0.0;U=0.0;do{ba=ba+ +n[da+(y<<2)>>2]*+n[M+(y<<2)>>2];v=y|1;$=$+ +n[da+(v<<2)>>2]*+n[M+(v<<2)>>2];v=y|2;V=V+ +n[da+(v<<2)>>2]*+n[M+(v<<2)>>2];v=y|3;U=U+ +n[da+(v<<2)>>2]*+n[M+(v<<2)>>2];y=y+4|0}while((y|0)<=(J|0));if(N){y=t;X=ba;while(1){_=X+ +n[da+(y<<2)>>2]*+n[M+(y<<2)>>2];y=y+1|0;if((y|0)==(H|0)){ea=_;break}else X=_}}else ea=ba;X=(U+(V+($+ea)))*l;if(!b)fa=X;else fa=X+ +n[b>>2]*m;n[T+(B<<2)>>2]=fa;B=B+1|0;if((B|0)==(j|0))break c;else{M=M+(z<<2)|0;b=b+(D<<2)|0}}}if(Q){ga=c;ha=R;ia=0}else{b=R;M=0;while(1){if(!b)ja=ca;else ja=ca+ +n[b>>2]*m;n[T+(M<<2)>>2]=ja;M=M+1|0;if((M|0)==(j|0))break c;else b=b+(D<<2)|0}}while(1){b=0;X=0.0;do{X=X+ +n[da+(b<<2)>>2]*+n[ga+(b<<2)>>2];b=b+1|0}while((b|0)!=(H|0));$=(X+0.0)*l;if(!ha)ka=$;else ka=$+ +n[ha>>2]*m;n[T+(ia<<2)>>2]=ka;ia=ia+1|0;if((ia|0)==(j|0))break;else{ga=ga+(z<<2)|0;ha=ha+(D<<2)|0}}}while(0);i=i+1|0;if((i|0)==(w|0))break b;else{S=S+(F<<2)|0;R=R+(C<<2)|0;T=T+(g<<2)|0}}}if(j<<2>>>0<1601){if((w|0)<=0)break;T=(E|0)==0;R=j+-4|0;S=(j|0)<4;i=(H|0)>0;Q=D<<2;t=D<<1;N=D*3|0;J=R>>>2;A=(J<<2)+4|0;K=T|(H|0)<1;ca=l*0.0;$=ca;L=a;P=e;b=h;M=0;B=e+(Y((J<<4)+16|0,D)|0)|0;while(1){if(K)la=T?L:E;else{J=0;do{y=L+((Y(J,G)|0)<<2)|0;f[E+(J<<2)>>2]=f[y>>2];J=J+1|0}while((J|0)!=(H|0));la=E}d:do if(S){ma=P;na=0}else{if(i){oa=P;pa=0}else{J=P;y=0;while(1){v=y|2;O=y|1;if(!J){n[b+(y<<2)>>2]=$;n[b+(O<<2)>>2]=$;n[b+(v<<2)>>2]=$;qa=ca}else{n[b+(y<<2)>>2]=ca+ +n[J>>2]*m;n[b+(O<<2)>>2]=ca+ +n[J+(D<<2)>>2]*m;n[b+(v<<2)>>2]=ca+ +n[J+(t<<2)>>2]*m;qa=ca+ +n[J+(N<<2)>>2]*m}n[b+((y|3)<<2)>>2]=qa;y=y+4|0;if((y|0)>(R|0)){ma=B;na=A;break d}else J=J+(Q<<2)|0}}while(1){J=c+(pa<<2)|0;y=0;V=0.0;U=0.0;ba=0.0;_=0.0;while(1){ra=+n[la+(y<<2)>>2];V=V+ra*+n[J>>2];U=U+ra*+n[J+4>>2];ba=ba+ra*+n[J+8>>2];_=_+ra*+n[J+12>>2];y=y+1|0;if((y|0)==(H|0))break;else J=J+(z<<2)|0}X=V*l;J=pa|2;ra=U*l;y=pa|1;sa=ba*l;ta=_*l;if(!oa){n[b+(pa<<2)>>2]=X;n[b+(y<<2)>>2]=ra;n[b+(J<<2)>>2]=sa;ua=ta}else{n[b+(pa<<2)>>2]=X+ +n[oa>>2]*m;n[b+(y<<2)>>2]=ra+ +n[oa+(D<<2)>>2]*m;n[b+(J<<2)>>2]=sa+ +n[oa+(t<<2)>>2]*m;ua=ta+ +n[oa+(N<<2)>>2]*m}n[b+((pa|3)<<2)>>2]=ua;pa=pa+4|0;if((pa|0)>(R|0)){ma=B;na=A;break}else oa=oa+(Q<<2)|0}}while(0);e:do if((na|0)<(j|0)){if(i){va=ma;wa=na}else{J=ma;y=na;while(1){if(!J)xa=ca;else xa=ca+ +n[J>>2]*m;n[b+(y<<2)>>2]=xa;y=y+1|0;if((y|0)==(j|0))break e;else J=J+(D<<2)|0}}while(1){J=c+(wa<<2)|0;y=0;ta=0.0;while(1){ta=ta+ +n[la+(y<<2)>>2]*+n[J>>2];y=y+1|0;if((y|0)==(H|0))break;else J=J+(z<<2)|0}_=ta*l;if(!va)ya=_;else ya=_+ +n[va>>2]*m;n[b+(wa<<2)>>2]=ya;wa=wa+1|0;if((wa|0)==(j|0))break;else va=va+(D<<2)|0}}while(0);M=M+1|0;if((M|0)==(w|0))break b;else{L=L+(F<<2)|0;P=P+(C<<2)|0;b=b+(g<<2)|0;B=B+(C<<2)|0}}}B=s+8|0;f[s>>2]=B;b=s+4|0;f[b>>2]=j;if(j>>>0>136){P=OYa(j>>>0>536870911?-1:j<<3)|0;f[s>>2]=P;za=P;Aa=P}else{za=B;Aa=B}if((w|0)>0){P=(E|0)==0;L=(j|0)>0;M=(H|0)>0;i=j+-4|0;Q=(j|0)<4;A=j<<3;R=j&-4;N=P|(H|0)<1;t=(R|0)<(j|0);S=a;T=e;K=h;J=0;while(1){if(N)Ba=P?S:E;else{y=0;do{v=S+((Y(y,G)|0)<<2)|0;f[E+(y<<2)>>2]=f[v>>2];y=y+1|0}while((y|0)!=(H|0));Ba=E}if(L)F1a(Aa|0,0,A|0)|0;f:do if(M){if(Q){if(L){Ca=c;Da=0}else break;while(1){ca=+n[Ba+(Da<<2)>>2];y=0;do{v=Aa+(y<<3)|0;p[v>>3]=+p[v>>3]+ca*+n[Ca+(y<<2)>>2];y=y+1|0}while((y|0)!=(j|0));Da=Da+1|0;if((Da|0)==(H|0))break f;else Ca=Ca+(z<<2)|0}}if(t){Ea=c;Fa=0}else{y=c;v=0;while(1){ca=+n[Ba+(v<<2)>>2];O=0;do{d=Aa+(O<<3)|0;W=O|1;Z=Aa+(W<<3)|0;ta=+p[Z>>3]+ca*+n[y+(W<<2)>>2];p[d>>3]=+p[d>>3]+ca*+n[y+(O<<2)>>2];p[Z>>3]=ta;Z=O|2;d=Aa+(Z<<3)|0;W=O|3;aa=Aa+(W<<3)|0;ta=+p[aa>>3]+ca*+n[y+(W<<2)>>2];p[d>>3]=+p[d>>3]+ca*+n[y+(Z<<2)>>2];p[aa>>3]=ta;O=O+4|0}while((O|0)<=(i|0));v=v+1|0;if((v|0)==(H|0))break f;else y=y+(z<<2)|0}}while(1){ca=+n[Ba+(Fa<<2)>>2];y=0;do{v=Aa+(y<<3)|0;O=y|1;aa=Aa+(O<<3)|0;ta=+p[aa>>3]+ca*+n[Ea+(O<<2)>>2];p[v>>3]=+p[v>>3]+ca*+n[Ea+(y<<2)>>2];p[aa>>3]=ta;aa=y|2;v=Aa+(aa<<3)|0;O=y|3;Z=Aa+(O<<3)|0;ta=+p[Z>>3]+ca*+n[Ea+(O<<2)>>2];p[v>>3]=+p[v>>3]+ca*+n[Ea+(aa<<2)>>2];p[Z>>3]=ta;y=y+4|0}while((y|0)<=(i|0));Ga=R;do{y=Aa+(Ga<<3)|0;p[y>>3]=+p[y>>3]+ca*+n[Ea+(Ga<<2)>>2];Ga=Ga+1|0}while((Ga|0)!=(j|0));Fa=Fa+1|0;if((Fa|0)==(H|0))break;else Ea=Ea+(z<<2)|0}}while(0);if(!T){if(L){y=0;do{n[K+(y<<2)>>2]=+p[Aa+(y<<3)>>3]*l;y=y+1|0}while((y|0)!=(j|0))}}else if(L){y=T;Z=0;while(1){n[K+(Z<<2)>>2]=+p[Aa+(Z<<3)>>3]*l+ +n[y>>2]*m;Z=Z+1|0;if((Z|0)==(j|0))break;else y=y+(D<<2)|0}}J=J+1|0;if((J|0)==(w|0)){Ha=za;break}else{S=S+(F<<2)|0;T=T+(C<<2)|0;K=K+(g<<2)|0}}}else Ha=Aa;if((Ha|0)!=(B|0)){QYa(Ha);f[s>>2]=B;f[b>>2]=136}}while(0);s=f[r>>2]|0;if((s|0)==(k|0)){u=q;return}if(s|0)QYa(s);f[r>>2]=k;f[x>>2]=264;u=q;return}function aO(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0.0;k=u;u=u+1104|0;l=k;m=f[h>>2]|0;n=f[h+4>>2]|0;h=f[i>>2]|0;o=f[i+4>>2]|0;i=l+8|0;f[l>>2]=i;q=l+4|0;f[q>>2]=136;r=j&16;s=b>>>3;b=d>>>3;d=g>>>3;if(j&1){f[q>>2]=n;if(n>>>0>136){g=OYa(n>>>0>536870911?-1:n<<3)|0;f[l>>2]=g;t=g;v=g;w=1;x=s;y=n}else{t=i;v=i;w=1;x=s;y=n}}else{t=i;v=0;w=s;x=1;y=m}m=(o|0)>0;if(!(j&2)){if(m){j=(v|0)==0;s=h+-4|0;n=(h|0)<4;g=(r|0)==0;z=(y|0)>0;A=h&-4;B=(y|0)<1|j;C=(s>>>2<<5)+32|0;D=a;E=e;F=0;while(1){G=e+((Y(d,F)|0)<<3)|0;if(B)H=j?D:v;else{I=0;do{J=D+((Y(I,x)|0)<<3)|0;p[v+(I<<3)>>3]=+p[J>>3];I=I+1|0}while((I|0)!=(y|0));H=v}a:do if(!n)if(g){if(z)K=0;else{F1a(G|0,0,C|0)|0;L=A;break}do{I=c+(K<<3)|0;J=0;M=0.0;N=0.0;O=0.0;P=0.0;while(1){Q=+p[H+(J<<3)>>3];M=M+Q*+p[I>>3];N=N+Q*+p[I+8>>3];O=O+Q*+p[I+16>>3];P=P+Q*+p[I+24>>3];J=J+1|0;if((J|0)==(y|0))break;else I=I+(b<<3)|0}p[E+(K<<3)>>3]=M;p[E+((K|1)<<3)>>3]=N;p[E+((K|2)<<3)>>3]=O;p[E+((K|3)<<3)>>3]=P;K=K+4|0}while((K|0)<=(s|0));L=A}else{if(z)R=0;else{I=0;while(1){I=I+4|0;if((I|0)>(s|0)){L=A;break a}}}do{I=E+((R|3)<<3)|0;J=E+((R|2)<<3)|0;S=E+((R|1)<<3)|0;T=E+(R<<3)|0;U=c+(R<<3)|0;V=0;Q=+p[T>>3];W=+p[S>>3];X=+p[J>>3];Z=+p[I>>3];while(1){_=+p[H+(V<<3)>>3];Q=Q+_*+p[U>>3];W=W+_*+p[U+8>>3];X=X+_*+p[U+16>>3];Z=Z+_*+p[U+24>>3];V=V+1|0;if((V|0)==(y|0))break;else U=U+(b<<3)|0}p[T>>3]=Q;p[S>>3]=W;p[J>>3]=X;p[I>>3]=Z;R=R+4|0}while((R|0)<=(s|0));L=A}else L=0;while(0);b:do if((h|0)>(L|0)){if(!g){if(z)$=L;else break;while(1){U=E+($<<3)|0;V=c+($<<3)|0;aa=0;P=+p[U>>3];while(1){P=P+ +p[H+(aa<<3)>>3]*+p[V>>3];aa=aa+1|0;if((aa|0)==(y|0))break;else V=V+(b<<3)|0}p[U>>3]=P;$=$+1|0;if(($|0)==(h|0))break b}}if(z)ba=L;else{F1a(G+(L<<3)|0,0,h-L<<3|0)|0;break}do{V=c+(ba<<3)|0;aa=0;Z=0.0;while(1){Z=Z+ +p[H+(aa<<3)>>3]*+p[V>>3];aa=aa+1|0;if((aa|0)==(y|0))break;else V=V+(b<<3)|0}p[E+(ba<<3)>>3]=Z;ba=ba+1|0}while((ba|0)!=(h|0))}while(0);F=F+1|0;if((F|0)==(o|0))break;else{D=D+(w<<3)|0;E=E+(d<<3)|0}}}}else if(m){m=(v|0)==0;E=(h|0)>0;D=(r|0)==0;r=y+-2|0;F=(y|0)<2;ba=y&-2;H=(y|0)<1|m;L=(y|0)>0;z=(ba|0)<(y|0);$=(y|0)>0;g=(ba|0)<(y|0);A=a;a=e;e=0;while(1){if(H)ca=m?A:v;else{s=0;do{R=A+((Y(s,x)|0)<<3)|0;p[v+(s<<3)>>3]=+p[R>>3];s=s+1|0}while((s|0)!=(y|0));ca=v}c:do if(E)if(D){if(F){s=c;R=0;while(1){if(L){K=0;P=0.0;while(1){X=P+ +p[ca+(K<<3)>>3]*+p[s+(K<<3)>>3];K=K+1|0;if((K|0)==(y|0)){da=X;break}else P=X}}else da=0.0;p[a+(R<<3)>>3]=da+0.0;R=R+1|0;if((R|0)==(h|0))break c;else s=s+(b<<3)|0}}else{ea=c;fa=0}while(1){s=0;P=0.0;Z=0.0;do{P=P+ +p[ca+(s<<3)>>3]*+p[ea+(s<<3)>>3];R=s|1;Z=Z+ +p[ca+(R<<3)>>3]*+p[ea+(R<<3)>>3];s=s+2|0}while((s|0)<=(r|0));if(z){s=ba;X=P;while(1){W=X+ +p[ca+(s<<3)>>3]*+p[ea+(s<<3)>>3];s=s+1|0;if((s|0)==(y|0)){ga=W;break}else X=W}}else ga=P;p[a+(fa<<3)>>3]=Z+ga;fa=fa+1|0;if((fa|0)==(h|0))break;else ea=ea+(b<<3)|0}}else{if(F){s=c;R=0;while(1){K=a+(R<<3)|0;X=+p[K>>3];if($){C=0;W=X;while(1){Q=W+ +p[ca+(C<<3)>>3]*+p[s+(C<<3)>>3];C=C+1|0;if((C|0)==(y|0)){ha=Q;break}else W=Q}}else ha=X;p[K>>3]=ha+0.0;R=R+1|0;if((R|0)==(h|0))break c;else s=s+(b<<3)|0}}else{ia=c;ja=0}while(1){s=a+(ja<<3)|0;R=0;W=+p[s>>3];Z=0.0;do{W=W+ +p[ca+(R<<3)>>3]*+p[ia+(R<<3)>>3];C=R|1;Z=Z+ +p[ca+(C<<3)>>3]*+p[ia+(C<<3)>>3];R=R+2|0}while((R|0)<=(r|0));if(g){R=ba;X=W;while(1){P=X+ +p[ca+(R<<3)>>3]*+p[ia+(R<<3)>>3];R=R+1|0;if((R|0)==(y|0)){ka=P;break}else X=P}}else ka=W;p[s>>3]=Z+ka;ja=ja+1|0;if((ja|0)==(h|0))break;else ia=ia+(b<<3)|0}}while(0);e=e+1|0;if((e|0)==(o|0))break;else{A=A+(w<<3)|0;a=a+(d<<3)|0}}}if((t|0)==(i|0)){u=k;return}QYa(t);f[l>>2]=i;f[q>>2]=136;u=k;return}function bO(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0,xa=0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0,Ha=0,Ia=0.0,Ja=0.0;k=u;u=u+1104|0;l=k;m=f[h>>2]|0;o=f[h+4>>2]|0;h=f[i>>2]|0;q=f[i+4>>2]|0;i=l+8|0;F1a(i|0,0,1088)|0;f[l>>2]=i;r=l+4|0;f[r>>2]=136;s=j&16;t=b>>>3;b=d>>>3;d=g>>>4;if(j&1){f[r>>2]=o;if(o>>>0>136){g=OYa(o>>>0>536870911?-1:o<<3)|0;F1a(g|0,0,o<<3|0)|0;f[l>>2]=g;v=g;w=1;x=t;y=o}else{v=i;w=1;x=t;y=o}}else{v=0;w=t;x=1;y=m}m=(q|0)>0;if(!(j&2)){if(m){j=(v|0)==0;t=h+-4|0;o=(h|0)<4;g=(s|0)==0;z=(y|0)>0;A=h&-4;B=(y|0)<1|j;C=a;D=e;E=0;while(1){F=e+((Y(d,E)|0)<<4)|0;if(B)G=j?C:v;else{H=0;do{I=C+((Y(H,x)|0)<<3)|0;J=f[I+4>>2]|0;K=v+(H<<3)|0;f[K>>2]=f[I>>2];f[K+4>>2]=J;H=H+1|0}while((H|0)!=(y|0));G=v}if(o)L=0;else{H=0;do{if(g){M=0.0;N=0.0;O=0.0;P=0.0;Q=0.0;R=0.0;S=0.0;T=0.0}else{J=H|1;K=H|2;I=H|3;M=+p[D+(H<<4)>>3];N=+p[D+(H<<4)+8>>3];O=+p[D+(J<<4)>>3];P=+p[D+(J<<4)+8>>3];Q=+p[D+(K<<4)>>3];R=+p[D+(K<<4)+8>>3];S=+p[D+(I<<4)>>3];T=+p[D+(I<<4)+8>>3]}if(z){I=c+(H<<3)|0;K=0;U=M;V=N;W=O;X=P;Z=Q;_=R;$=S;aa=T;while(1){ba=+n[G+(K<<3)>>2];ca=+n[G+(K<<3)+4>>2];da=+n[I>>2];ea=+n[I+4>>2];fa=U+(ba*da-ca*ea);ga=V+(ca*da+ba*ea);ea=+n[I+8>>2];da=+n[I+12>>2];ha=W+(ba*ea-ca*da);ia=X+(ca*ea+ba*da);da=+n[I+16>>2];ea=+n[I+20>>2];ja=Z+(ba*da-ca*ea);ka=_+(ca*da+ba*ea);ea=+n[I+24>>2];da=+n[I+28>>2];la=$+(ba*ea-ca*da);ma=aa+(ca*ea+ba*da);K=K+1|0;if((K|0)==(y|0)){na=fa;oa=ga;pa=ha;qa=ia;ra=ja;sa=ka;ta=la;ua=ma;break}else{I=I+(b<<3)|0;U=fa;V=ga;W=ha;X=ia;Z=ja;_=ka;$=la;aa=ma}}}else{na=M;oa=N;pa=O;qa=P;ra=Q;sa=R;ta=S;ua=T}p[D+(H<<4)>>3]=na;p[D+(H<<4)+8>>3]=oa;I=H|1;p[D+(I<<4)>>3]=pa;p[D+(I<<4)+8>>3]=qa;I=H|2;p[D+(I<<4)>>3]=ra;p[D+(I<<4)+8>>3]=sa;I=H|3;p[D+(I<<4)>>3]=ta;p[D+(I<<4)+8>>3]=ua;H=H+4|0}while((H|0)<=(t|0));L=A}a:do if((h|0)>(L|0))if(g){if(z)va=L;else{F1a(F+(L<<4)|0,0,h-L<<4|0)|0;break}do{H=c+(va<<3)|0;I=0;aa=0.0;$=0.0;while(1){_=+n[G+(I<<3)>>2];Z=+n[G+(I<<3)+4>>2];X=+n[H>>2];W=+n[H+4>>2];aa=aa+(_*X-Z*W);$=$+(Z*X+_*W);I=I+1|0;if((I|0)==(y|0))break;else H=H+(b<<3)|0}p[D+(va<<4)>>3]=aa;p[D+(va<<4)+8>>3]=$;va=va+1|0}while((va|0)!=(h|0))}else{if(z)wa=L;else{H=L;while(1){H=H+1|0;if((H|0)==(h|0))break a}}do{H=D+(wa<<4)+8|0;I=D+(wa<<4)|0;K=c+(wa<<3)|0;J=0;W=+p[I>>3];_=+p[H>>3];while(1){X=+n[G+(J<<3)>>2];Z=+n[G+(J<<3)+4>>2];V=+n[K>>2];U=+n[K+4>>2];W=W+(X*V-Z*U);_=_+(Z*V+X*U);J=J+1|0;if((J|0)==(y|0))break;else K=K+(b<<3)|0}p[I>>3]=W;p[H>>3]=_;wa=wa+1|0}while((wa|0)!=(h|0))}while(0);E=E+1|0;if((E|0)==(q|0))break;else{C=C+(w<<3)|0;D=D+(d<<4)|0}}}}else if(m){m=(v|0)==0;D=(s|0)==0;s=y+-2|0;C=(y|0)<2;E=y&-2;wa=(y|0)<1|m;G=(h|0)>0;L=(y|0)>0;z=(E|0)<(y|0);va=(y|0)>0;g=(E|0)<(y|0);A=a;a=e;e=0;while(1){if(wa)xa=m?A:v;else{t=0;do{o=A+((Y(t,x)|0)<<3)|0;j=f[o+4>>2]|0;B=v+(t<<3)|0;f[B>>2]=f[o>>2];f[B+4>>2]=j;t=t+1|0}while((t|0)!=(y|0));xa=v}b:do if(G)if(D){if(C){t=c;j=0;while(1){if(L){B=0;ua=0.0;ta=0.0;while(1){sa=+n[xa+(B<<3)>>2];ra=+n[xa+(B<<3)+4>>2];qa=+n[t+(B<<3)>>2];pa=+n[t+(B<<3)+4>>2];oa=ua+(sa*qa-ra*pa);na=ta+(ra*qa+sa*pa);B=B+1|0;if((B|0)==(y|0)){ya=oa;za=na;break}else{ua=oa;ta=na}}}else{ya=0.0;za=0.0}p[a+(j<<4)>>3]=ya+0.0;p[a+(j<<4)+8>>3]=za+0.0;j=j+1|0;if((j|0)==(h|0))break b;else t=t+(b<<3)|0}}else{Aa=c;Ba=0}while(1){t=0;ta=0.0;ua=0.0;_=0.0;W=0.0;do{na=+n[xa+(t<<3)>>2];oa=+n[xa+(t<<3)+4>>2];pa=+n[Aa+(t<<3)>>2];sa=+n[Aa+(t<<3)+4>>2];ta=ta+(na*pa-oa*sa);ua=ua+(oa*pa+na*sa);j=t|1;sa=+n[xa+(j<<3)>>2];na=+n[xa+(j<<3)+4>>2];pa=+n[Aa+(j<<3)>>2];oa=+n[Aa+(j<<3)+4>>2];_=_+(sa*pa-na*oa);W=W+(na*pa+sa*oa);t=t+2|0}while((t|0)<=(s|0));if(z){t=E;oa=ta;sa=ua;while(1){pa=+n[xa+(t<<3)>>2];na=+n[xa+(t<<3)+4>>2];qa=+n[Aa+(t<<3)>>2];ra=+n[Aa+(t<<3)+4>>2];T=oa+(pa*qa-na*ra);S=sa+(na*qa+pa*ra);t=t+1|0;if((t|0)==(y|0)){Ca=T;Da=S;break}else{oa=T;sa=S}}}else{Ca=ta;Da=ua}p[a+(Ba<<4)>>3]=_+Ca;p[a+(Ba<<4)+8>>3]=W+Da;Ba=Ba+1|0;if((Ba|0)==(h|0))break;else Aa=Aa+(b<<3)|0}}else{if(C){t=c;j=0;while(1){B=a+(j<<4)+8|0;H=a+(j<<4)|0;sa=+p[H>>3];oa=+p[B>>3];if(va){I=0;S=sa;T=oa;while(1){ra=+n[xa+(I<<3)>>2];pa=+n[xa+(I<<3)+4>>2];qa=+n[t+(I<<3)>>2];na=+n[t+(I<<3)+4>>2];R=S+(ra*qa-pa*na);Q=T+(pa*qa+ra*na);I=I+1|0;if((I|0)==(y|0)){Ea=R;Fa=Q;break}else{S=R;T=Q}}}else{Ea=sa;Fa=oa}p[H>>3]=Ea+0.0;p[B>>3]=Fa+0.0;j=j+1|0;if((j|0)==(h|0))break b;else t=t+(b<<3)|0}}else{Ga=c;Ha=0}while(1){t=a+(Ha<<4)+8|0;j=a+(Ha<<4)|0;I=0;T=+p[j>>3];S=+p[t>>3];W=0.0;_=0.0;do{ua=+n[xa+(I<<3)>>2];ta=+n[xa+(I<<3)+4>>2];Q=+n[Ga+(I<<3)>>2];R=+n[Ga+(I<<3)+4>>2];T=T+(ua*Q-ta*R);S=S+(ta*Q+ua*R);o=I|1;R=+n[xa+(o<<3)>>2];ua=+n[xa+(o<<3)+4>>2];Q=+n[Ga+(o<<3)>>2];ta=+n[Ga+(o<<3)+4>>2];W=W+(R*Q-ua*ta);_=_+(ua*Q+R*ta);I=I+2|0}while((I|0)<=(s|0));if(g){I=E;oa=T;sa=S;while(1){ta=+n[xa+(I<<3)>>2];R=+n[xa+(I<<3)+4>>2];Q=+n[Ga+(I<<3)>>2];ua=+n[Ga+(I<<3)+4>>2];na=oa+(ta*Q-R*ua);ra=sa+(R*Q+ta*ua);I=I+1|0;if((I|0)==(y|0)){Ia=na;Ja=ra;break}else{oa=na;sa=ra}}}else{Ia=T;Ja=S}p[j>>3]=W+Ia;p[t>>3]=_+Ja;Ha=Ha+1|0;if((Ha|0)==(h|0))break;else Ga=Ga+(b<<3)|0}}while(0);e=e+1|0;if((e|0)==(q|0))break;else{A=A+(w<<3)|0;a=a+(d<<4)|0}}}d=f[l>>2]|0;if((d|0)==(i|0)){u=k;return}if(d|0)QYa(d);f[l>>2]=i;f[r>>2]=136;u=k;return}function cO(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0.0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0,za=0,Aa=0.0,Ba=0.0;k=u;u=u+1168|0;l=k;m=f[h>>2]|0;n=f[h+4>>2]|0;h=f[i>>2]|0;o=f[i+4>>2]|0;i=l+8|0;F1a(i|0,0,1152)|0;f[l>>2]=i;q=l+4|0;f[q>>2]=72;r=j&16;s=b>>>4;b=d>>>4;d=g>>>4;if(j&1){f[q>>2]=n;if(n>>>0>72){g=OYa(n>>>0>268435455?-1:n<<4)|0;F1a(g|0,0,n<<4|0)|0;f[l>>2]=g;t=g;v=1;w=s;x=n}else{t=i;v=1;w=s;x=n}}else{t=0;v=s;w=1;x=m}m=(o|0)>0;if(!(j&2)){if(m){j=(t|0)==0;s=h+-4|0;n=(h|0)<4;g=(r|0)==0;y=(x|0)>0;z=h&-4;A=(x|0)<1|j;B=(s>>>2<<6)+64|0;C=a;D=e;E=0;while(1){F=e+((Y(d,E)|0)<<4)|0;if(A)G=j?C:t;else{H=0;do{I=C+((Y(H,w)|0)<<4)|0;J=t+(H<<4)|0;f[J>>2]=f[I>>2];f[J+4>>2]=f[I+4>>2];f[J+8>>2]=f[I+8>>2];f[J+12>>2]=f[I+12>>2];H=H+1|0}while((H|0)!=(x|0));G=t}a:do if(!n)if(g){if(y)K=0;else{F1a(F|0,0,B|0)|0;L=z;break}do{H=c+(K<<4)|0;I=0;M=0.0;N=0.0;O=0.0;P=0.0;Q=0.0;R=0.0;S=0.0;T=0.0;while(1){U=+p[G+(I<<4)>>3];V=+p[G+(I<<4)+8>>3];W=+p[H>>3];X=+p[H+8>>3];M=M+(U*W-V*X);N=N+(V*W+U*X);X=+p[H+16>>3];W=+p[H+24>>3];O=O+(U*X-V*W);P=P+(V*X+U*W);W=+p[H+32>>3];X=+p[H+40>>3];Q=Q+(U*W-V*X);R=R+(V*W+U*X);X=+p[H+48>>3];W=+p[H+56>>3];S=S+(U*X-V*W);T=T+(V*X+U*W);I=I+1|0;if((I|0)==(x|0))break;else H=H+(b<<4)|0}p[D+(K<<4)>>3]=M;p[D+(K<<4)+8>>3]=N;H=K|1;p[D+(H<<4)>>3]=O;p[D+(H<<4)+8>>3]=P;H=K|2;p[D+(H<<4)>>3]=Q;p[D+(H<<4)+8>>3]=R;H=K|3;p[D+(H<<4)>>3]=S;p[D+(H<<4)+8>>3]=T;K=K+4|0}while((K|0)<=(s|0));L=z}else{if(y)Z=0;else{H=0;while(1){H=H+4|0;if((H|0)>(s|0)){L=z;break a}}}do{H=D+(Z<<4)|0;I=D+(Z<<4)+8|0;J=Z|1;_=D+(J<<4)|0;$=D+(J<<4)+8|0;J=Z|2;aa=D+(J<<4)|0;ba=D+(J<<4)+8|0;J=Z|3;ca=D+(J<<4)|0;da=D+(J<<4)+8|0;J=c+(Z<<4)|0;ea=0;W=+p[H>>3];U=+p[I>>3];X=+p[_>>3];V=+p[$>>3];fa=+p[aa>>3];ga=+p[ba>>3];ha=+p[ca>>3];ia=+p[da>>3];while(1){ja=+p[G+(ea<<4)>>3];ka=+p[G+(ea<<4)+8>>3];la=+p[J>>3];ma=+p[J+8>>3];W=W+(ja*la-ka*ma);U=U+(ka*la+ja*ma);ma=+p[J+16>>3];la=+p[J+24>>3];X=X+(ja*ma-ka*la);V=V+(ka*ma+ja*la);la=+p[J+32>>3];ma=+p[J+40>>3];fa=fa+(ja*la-ka*ma);ga=ga+(ka*la+ja*ma);ma=+p[J+48>>3];la=+p[J+56>>3];ha=ha+(ja*ma-ka*la);ia=ia+(ka*ma+ja*la);ea=ea+1|0;if((ea|0)==(x|0))break;else J=J+(b<<4)|0}p[H>>3]=W;p[I>>3]=U;p[_>>3]=X;p[$>>3]=V;p[aa>>3]=fa;p[ba>>3]=ga;p[ca>>3]=ha;p[da>>3]=ia;Z=Z+4|0}while((Z|0)<=(s|0));L=z}else L=0;while(0);b:do if((h|0)>(L|0))if(g){if(y)na=L;else{F1a(F+(L<<4)|0,0,h-L<<4|0)|0;break}do{J=c+(na<<4)|0;ea=0;T=0.0;S=0.0;while(1){R=+p[G+(ea<<4)>>3];Q=+p[G+(ea<<4)+8>>3];P=+p[J>>3];O=+p[J+8>>3];T=T+(R*P-Q*O);S=S+(Q*P+R*O);ea=ea+1|0;if((ea|0)==(x|0))break;else J=J+(b<<4)|0}p[D+(na<<4)>>3]=T;p[D+(na<<4)+8>>3]=S;na=na+1|0}while((na|0)!=(h|0))}else{if(y)oa=L;else{J=L;while(1){J=J+1|0;if((J|0)==(h|0))break b}}do{J=D+(oa<<4)+8|0;ea=D+(oa<<4)|0;da=c+(oa<<4)|0;ca=0;ia=+p[ea>>3];ha=+p[J>>3];while(1){ga=+p[G+(ca<<4)>>3];fa=+p[G+(ca<<4)+8>>3];V=+p[da>>3];X=+p[da+8>>3];ia=ia+(ga*V-fa*X);ha=ha+(fa*V+ga*X);ca=ca+1|0;if((ca|0)==(x|0))break;else da=da+(b<<4)|0}p[ea>>3]=ia;p[J>>3]=ha;oa=oa+1|0}while((oa|0)!=(h|0))}while(0);E=E+1|0;if((E|0)==(o|0))break;else{C=C+(v<<4)|0;D=D+(d<<4)|0}}}}else if(m){m=(t|0)==0;D=(r|0)==0;r=x+-2|0;C=(x|0)<2;E=x&-2;oa=(x|0)<1|m;G=(h|0)>0;L=(x|0)>0;y=(E|0)<(x|0);na=(x|0)>0;g=(E|0)<(x|0);z=a;a=e;e=0;while(1){if(oa)pa=m?z:t;else{s=0;do{Z=z+((Y(s,w)|0)<<4)|0;K=t+(s<<4)|0;f[K>>2]=f[Z>>2];f[K+4>>2]=f[Z+4>>2];f[K+8>>2]=f[Z+8>>2];f[K+12>>2]=f[Z+12>>2];s=s+1|0}while((s|0)!=(x|0));pa=t}c:do if(G)if(D){if(C){s=c;Z=0;while(1){if(L){K=0;S=0.0;T=0.0;while(1){X=+p[pa+(K<<4)>>3];ga=+p[pa+(K<<4)+8>>3];V=+p[s+(K<<4)>>3];fa=+p[s+(K<<4)+8>>3];U=S+(X*V-ga*fa);W=T+(ga*V+X*fa);K=K+1|0;if((K|0)==(x|0)){qa=U;ra=W;break}else{S=U;T=W}}}else{qa=0.0;ra=0.0}p[a+(Z<<4)>>3]=qa+0.0;p[a+(Z<<4)+8>>3]=ra+0.0;Z=Z+1|0;if((Z|0)==(h|0))break c;else s=s+(b<<4)|0}}else{sa=c;ta=0}while(1){s=0;T=0.0;S=0.0;ha=0.0;ia=0.0;do{W=+p[pa+(s<<4)>>3];U=+p[pa+(s<<4)+8>>3];fa=+p[sa+(s<<4)>>3];X=+p[sa+(s<<4)+8>>3];T=T+(W*fa-U*X);S=S+(U*fa+W*X);Z=s|1;X=+p[pa+(Z<<4)>>3];W=+p[pa+(Z<<4)+8>>3];fa=+p[sa+(Z<<4)>>3];U=+p[sa+(Z<<4)+8>>3];ha=ha+(X*fa-W*U);ia=ia+(W*fa+X*U);s=s+2|0}while((s|0)<=(r|0));if(y){s=E;U=T;X=S;while(1){fa=+p[pa+(s<<4)>>3];W=+p[pa+(s<<4)+8>>3];V=+p[sa+(s<<4)>>3];ga=+p[sa+(s<<4)+8>>3];O=U+(fa*V-W*ga);R=X+(W*V+fa*ga);s=s+1|0;if((s|0)==(x|0)){ua=O;va=R;break}else{U=O;X=R}}}else{ua=T;va=S}p[a+(ta<<4)>>3]=ha+ua;p[a+(ta<<4)+8>>3]=ia+va;ta=ta+1|0;if((ta|0)==(h|0))break;else sa=sa+(b<<4)|0}}else{if(C){s=c;Z=0;while(1){K=a+(Z<<4)+8|0;J=a+(Z<<4)|0;X=+p[J>>3];U=+p[K>>3];if(na){ea=0;R=X;O=U;while(1){ga=+p[pa+(ea<<4)>>3];fa=+p[pa+(ea<<4)+8>>3];V=+p[s+(ea<<4)>>3];W=+p[s+(ea<<4)+8>>3];P=R+(ga*V-fa*W);Q=O+(fa*V+ga*W);ea=ea+1|0;if((ea|0)==(x|0)){wa=P;xa=Q;break}else{R=P;O=Q}}}else{wa=X;xa=U}p[J>>3]=wa+0.0;p[K>>3]=xa+0.0;Z=Z+1|0;if((Z|0)==(h|0))break c;else s=s+(b<<4)|0}}else{ya=c;za=0}while(1){s=a+(za<<4)+8|0;Z=a+(za<<4)|0;ea=0;O=+p[Z>>3];R=+p[s>>3];ia=0.0;ha=0.0;do{S=+p[pa+(ea<<4)>>3];T=+p[pa+(ea<<4)+8>>3];Q=+p[ya+(ea<<4)>>3];P=+p[ya+(ea<<4)+8>>3];O=O+(S*Q-T*P);R=R+(T*Q+S*P);B=ea|1;P=+p[pa+(B<<4)>>3];S=+p[pa+(B<<4)+8>>3];Q=+p[ya+(B<<4)>>3];T=+p[ya+(B<<4)+8>>3];ia=ia+(P*Q-S*T);ha=ha+(S*Q+P*T);ea=ea+2|0}while((ea|0)<=(r|0));if(g){ea=E;U=O;X=R;while(1){T=+p[pa+(ea<<4)>>3];P=+p[pa+(ea<<4)+8>>3];Q=+p[ya+(ea<<4)>>3];S=+p[ya+(ea<<4)+8>>3];W=U+(T*Q-P*S);ga=X+(P*Q+T*S);ea=ea+1|0;if((ea|0)==(x|0)){Aa=W;Ba=ga;break}else{U=W;X=ga}}}else{Aa=O;Ba=R}p[Z>>3]=ia+Aa;p[s>>3]=ha+Ba;za=za+1|0;if((za|0)==(h|0))break;else ya=ya+(b<<4)|0}}while(0);e=e+1|0;if((e|0)==(o|0))break;else{z=z+(v<<4)|0;a=a+(d<<4)|0}}}d=f[l>>2]|0;if((d|0)==(i|0)){u=k;return}if(d|0)QYa(d);f[l>>2]=i;f[q>>2]=72;u=k;return}function dO(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0,ka=0,la=0.0;k=u;u=u+1072|0;l=k;m=f[h>>2]|0;o=f[h+4>>2]|0;h=f[i>>2]|0;q=f[i+4>>2]|0;i=l+8|0;f[l>>2]=i;r=l+4|0;f[r>>2]=264;s=j&16;t=b>>>2;b=d>>>2;d=g>>>3;if(j&1){f[r>>2]=o;if(o>>>0>264){g=OYa(o>>>0>1073741823?-1:o<<2)|0;f[l>>2]=g;v=g;w=g;x=1;y=t;z=o}else{v=i;w=i;x=1;y=t;z=o}}else{v=i;w=0;x=t;y=1;z=m}m=(q|0)>0;if(!(j&2)){if(m){j=(w|0)==0;t=h+-4|0;o=(h|0)<4;g=(s|0)==0;A=(z|0)>0;B=h&-4;C=(z|0)<1|j;D=(t>>>2<<5)+32|0;E=a;F=e;G=0;while(1){H=e+((Y(d,G)|0)<<3)|0;if(C)I=j?E:w;else{J=0;do{K=E+((Y(J,y)|0)<<2)|0;f[w+(J<<2)>>2]=f[K>>2];J=J+1|0}while((J|0)!=(z|0));I=w}a:do if(!o)if(g){if(A)L=0;else{F1a(H|0,0,D|0)|0;M=B;break}do{J=c+(L<<2)|0;K=0;N=0.0;O=0.0;P=0.0;Q=0.0;while(1){R=+n[I+(K<<2)>>2];N=N+R*+n[J>>2];O=O+R*+n[J+4>>2];P=P+R*+n[J+8>>2];Q=Q+R*+n[J+12>>2];K=K+1|0;if((K|0)==(z|0))break;else J=J+(b<<2)|0}p[F+(L<<3)>>3]=N;p[F+((L|1)<<3)>>3]=O;p[F+((L|2)<<3)>>3]=P;p[F+((L|3)<<3)>>3]=Q;L=L+4|0}while((L|0)<=(t|0));M=B}else{if(A)S=0;else{J=0;while(1){J=J+4|0;if((J|0)>(t|0)){M=B;break a}}}do{J=F+((S|3)<<3)|0;K=F+((S|2)<<3)|0;T=F+((S|1)<<3)|0;U=F+(S<<3)|0;V=c+(S<<2)|0;W=0;R=+p[U>>3];X=+p[T>>3];Z=+p[K>>3];_=+p[J>>3];while(1){$=+n[I+(W<<2)>>2];R=R+$*+n[V>>2];X=X+$*+n[V+4>>2];Z=Z+$*+n[V+8>>2];_=_+$*+n[V+12>>2];W=W+1|0;if((W|0)==(z|0))break;else V=V+(b<<2)|0}p[U>>3]=R;p[T>>3]=X;p[K>>3]=Z;p[J>>3]=_;S=S+4|0}while((S|0)<=(t|0));M=B}else M=0;while(0);b:do if((h|0)>(M|0)){if(!g){if(A)aa=M;else break;while(1){V=F+(aa<<3)|0;W=c+(aa<<2)|0;ba=0;Q=+p[V>>3];while(1){Q=Q+ +n[I+(ba<<2)>>2]*+n[W>>2];ba=ba+1|0;if((ba|0)==(z|0))break;else W=W+(b<<2)|0}p[V>>3]=Q;aa=aa+1|0;if((aa|0)==(h|0))break b}}if(A)ca=M;else{F1a(H+(M<<3)|0,0,h-M<<3|0)|0;break}do{W=c+(ca<<2)|0;ba=0;_=0.0;while(1){_=_+ +n[I+(ba<<2)>>2]*+n[W>>2];ba=ba+1|0;if((ba|0)==(z|0))break;else W=W+(b<<2)|0}p[F+(ca<<3)>>3]=_;ca=ca+1|0}while((ca|0)!=(h|0))}while(0);G=G+1|0;if((G|0)==(q|0))break;else{E=E+(x<<2)|0;F=F+(d<<3)|0}}}}else if(m){m=(w|0)==0;F=(h|0)>0;E=(s|0)==0;s=z+-2|0;G=(z|0)<2;ca=z&-2;I=(z|0)<1|m;M=(z|0)>0;A=(ca|0)<(z|0);aa=(z|0)>0;g=(ca|0)<(z|0);B=a;a=e;e=0;while(1){if(I)da=m?B:w;else{t=0;do{S=B+((Y(t,y)|0)<<2)|0;f[w+(t<<2)>>2]=f[S>>2];t=t+1|0}while((t|0)!=(z|0));da=w}c:do if(F)if(E){if(G){t=c;S=0;while(1){if(M){L=0;Q=0.0;while(1){Z=Q+ +n[da+(L<<2)>>2]*+n[t+(L<<2)>>2];L=L+1|0;if((L|0)==(z|0)){ea=Z;break}else Q=Z}}else ea=0.0;p[a+(S<<3)>>3]=ea+0.0;S=S+1|0;if((S|0)==(h|0))break c;else t=t+(b<<2)|0}}else{fa=c;ga=0}while(1){t=0;Q=0.0;_=0.0;do{Q=Q+ +n[da+(t<<2)>>2]*+n[fa+(t<<2)>>2];S=t|1;_=_+ +n[da+(S<<2)>>2]*+n[fa+(S<<2)>>2];t=t+2|0}while((t|0)<=(s|0));if(A){t=ca;Z=Q;while(1){X=Z+ +n[da+(t<<2)>>2]*+n[fa+(t<<2)>>2];t=t+1|0;if((t|0)==(z|0)){ha=X;break}else Z=X}}else ha=Q;p[a+(ga<<3)>>3]=_+ha;ga=ga+1|0;if((ga|0)==(h|0))break;else fa=fa+(b<<2)|0}}else{if(G){t=c;S=0;while(1){L=a+(S<<3)|0;Z=+p[L>>3];if(aa){D=0;X=Z;while(1){R=X+ +n[da+(D<<2)>>2]*+n[t+(D<<2)>>2];D=D+1|0;if((D|0)==(z|0)){ia=R;break}else X=R}}else ia=Z;p[L>>3]=ia+0.0;S=S+1|0;if((S|0)==(h|0))break c;else t=t+(b<<2)|0}}else{ja=c;ka=0}while(1){t=a+(ka<<3)|0;S=0;X=+p[t>>3];_=0.0;do{X=X+ +n[da+(S<<2)>>2]*+n[ja+(S<<2)>>2];D=S|1;_=_+ +n[da+(D<<2)>>2]*+n[ja+(D<<2)>>2];S=S+2|0}while((S|0)<=(s|0));if(g){S=ca;Z=X;while(1){Q=Z+ +n[da+(S<<2)>>2]*+n[ja+(S<<2)>>2];S=S+1|0;if((S|0)==(z|0)){la=Q;break}else Z=Q}}else la=X;p[t>>3]=_+la;ka=ka+1|0;if((ka|0)==(h|0))break;else ja=ja+(b<<2)|0}}while(0);e=e+1|0;if((e|0)==(q|0))break;else{B=B+(x<<2)|0;a=a+(d<<3)|0}}}if((v|0)==(i|0)){u=k;return}QYa(v);f[l>>2]=i;f[r>>2]=264;u=k;return}function eO(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0;l=f[h>>2]|0;m=f[h+4>>2]|0;h=b>>>3;b=d>>>3;d=g>>>3;g=(a|0)==0;n=(k&4|0)==0;k=g?0:n?h:1;o=g?0:n?1:h;if(!m)return;h=o<<1;n=o*3|0;g=o<<2;q=(l|0)<4;r=l+-4|0;s=(r|0)>3?r:3;t=(s&2147483644)+4|0;u=s>>>2;s=Y(u,g)|0;v=(u<<2)+4|0;u=a;w=c;c=e;e=m;m=a+(g<<3)|0;while(1){e=e+-1|0;if(!u){if(q)x=0;else{a=0;do{y=a|1;z=+p[w+(y<<3)>>3]*i;p[c+(a<<3)>>3]=+p[w+(a<<3)>>3]*i;p[c+(y<<3)>>3]=z;y=a|2;A=a|3;z=+p[w+(A<<3)>>3]*i;p[c+(y<<3)>>3]=+p[w+(y<<3)>>3]*i;p[c+(A<<3)>>3]=z;a=a+4|0}while((a|0)<=(r|0));x=t}if((x|0)<(l|0)){a=x;do{p[c+(a<<3)>>3]=+p[w+(a<<3)>>3]*i;a=a+1|0}while((a|0)!=(l|0))}}else{if(q){B=u;C=0}else{a=u;A=0;while(1){y=A|1;z=+p[w+(y<<3)>>3]*i+ +p[a+(o<<3)>>3]*j;p[c+(A<<3)>>3]=+p[w+(A<<3)>>3]*i+ +p[a>>3]*j;p[c+(y<<3)>>3]=z;y=A|2;D=A|3;z=+p[w+(D<<3)>>3]*i+ +p[a+(n<<3)>>3]*j;p[c+(y<<3)>>3]=+p[w+(y<<3)>>3]*i+ +p[a+(h<<3)>>3]*j;p[c+(D<<3)>>3]=z;A=A+4|0;if((A|0)>(r|0))break;else a=a+(g<<3)|0}B=m+(s<<3)|0;C=v}if((C|0)<(l|0)){a=B;A=C;while(1){p[c+(A<<3)>>3]=+p[w+(A<<3)>>3]*i+ +p[a>>3]*j;A=A+1|0;if((A|0)==(l|0))break;else a=a+(o<<3)|0}}}if(!e)break;else{u=u+(k<<3)|0;w=w+(b<<3)|0;c=c+(d<<3)|0;m=m+(k<<3)|0}}return}function fO(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0;l=f[h>>2]|0;m=f[h+4>>2]|0;h=b>>>3;b=d>>>4;d=g>>>3;g=(a|0)==0;o=(k&4|0)==0;k=g?0:o?h:1;q=g?0:o?1:h;if(!m)return;h=q<<1;o=q*3|0;g=q<<2;r=(l|0)<4;s=l+-4|0;t=s>>>2;u=(t<<2)+4|0;v=a;w=m;m=c;c=e;e=a+(Y(q,(t<<5)+32|0)|0)|0;while(1){w=w+-1|0;if(!v){if(r)x=0;else{t=0;do{a=t|1;y=+p[m+(a<<4)>>3]*i;z=+p[m+(a<<4)+8>>3]*i;A=+p[m+(t<<4)+8>>3]*i;n[c+(t<<3)>>2]=+p[m+(t<<4)>>3]*i;n[c+(t<<3)+4>>2]=A;n[c+(a<<3)>>2]=y;n[c+(a<<3)+4>>2]=z;a=t|2;B=t|3;z=+p[m+(B<<4)>>3]*i;y=+p[m+(B<<4)+8>>3]*i;A=+p[m+(a<<4)+8>>3]*i;n[c+(a<<3)>>2]=+p[m+(a<<4)>>3]*i;n[c+(a<<3)+4>>2]=A;n[c+(B<<3)>>2]=z;n[c+(B<<3)+4>>2]=y;t=t+4|0}while((t|0)<=(s|0));x=u}if((x|0)<(l|0)){t=x;do{y=+p[m+(t<<4)+8>>3]*i;n[c+(t<<3)>>2]=+p[m+(t<<4)>>3]*i;n[c+(t<<3)+4>>2]=y;t=t+1|0}while((t|0)!=(l|0))}}else{if(r){C=v;D=0}else{t=v;B=0;while(1){a=B|1;y=+p[m+(a<<4)>>3]*i+ +n[t+(q<<3)>>2]*j;z=+p[m+(a<<4)+8>>3]*i+ +n[t+(q<<3)+4>>2]*j;A=+p[m+(B<<4)+8>>3]*i+ +n[t+4>>2]*j;n[c+(B<<3)>>2]=+p[m+(B<<4)>>3]*i+ +n[t>>2]*j;n[c+(B<<3)+4>>2]=A;n[c+(a<<3)>>2]=y;n[c+(a<<3)+4>>2]=z;a=B|2;E=B|3;z=+p[m+(E<<4)>>3]*i+ +n[t+(o<<3)>>2]*j;y=+p[m+(E<<4)+8>>3]*i+ +n[t+(o<<3)+4>>2]*j;A=+p[m+(a<<4)+8>>3]*i+ +n[t+(h<<3)+4>>2]*j;n[c+(a<<3)>>2]=+p[m+(a<<4)>>3]*i+ +n[t+(h<<3)>>2]*j;n[c+(a<<3)+4>>2]=A;n[c+(E<<3)>>2]=z;n[c+(E<<3)+4>>2]=y;B=B+4|0;if((B|0)>(s|0)){C=e;D=u;break}else t=t+(g<<3)|0}}if((D|0)<(l|0)){t=C;B=D;while(1){y=+p[m+(B<<4)+8>>3]*i+ +n[t+4>>2]*j;n[c+(B<<3)>>2]=+p[m+(B<<4)>>3]*i+ +n[t>>2]*j;n[c+(B<<3)+4>>2]=y;B=B+1|0;if((B|0)==(l|0))break;else t=t+(q<<3)|0}}}if(!w)break;else{v=v+(k<<3)|0;m=m+(b<<4)|0;c=c+(d<<3)|0;e=e+(k<<3)|0}}return}function gO(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0;l=f[h>>2]|0;m=f[h+4>>2]|0;h=b>>>4;b=d>>>4;d=g>>>4;g=(a|0)==0;n=(k&4|0)==0;k=g?0:n?h:1;o=g?0:n?1:h;if(!m)return;h=o<<1;n=o*3|0;g=o<<2;q=(l|0)<4;r=l+-4|0;s=r>>>2;t=(s<<2)+4|0;u=a;v=m;m=c;c=e;e=a+(Y(o,(s<<6)+64|0)|0)|0;while(1){v=v+-1|0;if(!u){if(q)w=0;else{s=0;do{x=+p[m+(s<<4)+8>>3]*i;a=s|1;y=+p[m+(a<<4)>>3]*i;z=+p[m+(a<<4)+8>>3]*i;p[c+(s<<4)>>3]=+p[m+(s<<4)>>3]*i;p[c+(s<<4)+8>>3]=x;p[c+(a<<4)>>3]=y;p[c+(a<<4)+8>>3]=z;a=s|2;z=+p[m+(a<<4)+8>>3]*i;A=s|3;y=+p[m+(A<<4)>>3]*i;x=+p[m+(A<<4)+8>>3]*i;p[c+(a<<4)>>3]=+p[m+(a<<4)>>3]*i;p[c+(a<<4)+8>>3]=z;p[c+(A<<4)>>3]=y;p[c+(A<<4)+8>>3]=x;s=s+4|0}while((s|0)<=(r|0));w=t}if((w|0)<(l|0)){s=w;do{x=+p[m+(s<<4)+8>>3]*i;p[c+(s<<4)>>3]=+p[m+(s<<4)>>3]*i;p[c+(s<<4)+8>>3]=x;s=s+1|0}while((s|0)!=(l|0))}}else{if(q){B=u;C=0}else{s=u;A=0;while(1){a=A|1;x=+p[m+(A<<4)+8>>3]*i+ +p[s+8>>3]*j;y=+p[m+(a<<4)>>3]*i+ +p[s+(o<<4)>>3]*j;z=+p[m+(a<<4)+8>>3]*i+ +p[s+(o<<4)+8>>3]*j;p[c+(A<<4)>>3]=+p[m+(A<<4)>>3]*i+ +p[s>>3]*j;p[c+(A<<4)+8>>3]=x;p[c+(a<<4)>>3]=y;p[c+(a<<4)+8>>3]=z;a=A|2;D=A|3;z=+p[m+(a<<4)+8>>3]*i+ +p[s+(h<<4)+8>>3]*j;y=+p[m+(D<<4)>>3]*i+ +p[s+(n<<4)>>3]*j;x=+p[m+(D<<4)+8>>3]*i+ +p[s+(n<<4)+8>>3]*j;p[c+(a<<4)>>3]=+p[m+(a<<4)>>3]*i+ +p[s+(h<<4)>>3]*j;p[c+(a<<4)+8>>3]=z;p[c+(D<<4)>>3]=y;p[c+(D<<4)+8>>3]=x;A=A+4|0;if((A|0)>(r|0)){B=e;C=t;break}else s=s+(g<<4)|0}}if((C|0)<(l|0)){s=B;A=C;while(1){x=+p[m+(A<<4)+8>>3]*i+ +p[s+8>>3]*j;p[c+(A<<4)>>3]=+p[m+(A<<4)>>3]*i+ +p[s>>3]*j;p[c+(A<<4)+8>>3]=x;A=A+1|0;if((A|0)==(l|0))break;else s=s+(o<<4)|0}}}if(!v)break;else{u=u+(k<<4)|0;m=m+(b<<4)|0;c=c+(d<<4)|0;e=e+(k<<4)|0}}return}function hO(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0;l=f[h>>2]|0;m=f[h+4>>2]|0;h=b>>>2;b=d>>>3;d=g>>>2;g=(a|0)==0;o=(k&4|0)==0;k=g?0:o?h:1;q=g?0:o?1:h;if(!m)return;h=q<<1;o=q*3|0;g=q<<2;r=(l|0)<4;s=l+-4|0;t=(s|0)>3?s:3;u=(t&2147483644)+4|0;v=t>>>2;t=Y(v,g)|0;w=(v<<2)+4|0;v=a;x=c;c=e;e=m;m=a+(g<<2)|0;while(1){e=e+-1|0;if(!v){if(r)y=0;else{a=0;do{z=a|1;A=+p[x+(z<<3)>>3]*i;n[c+(a<<2)>>2]=+p[x+(a<<3)>>3]*i;n[c+(z<<2)>>2]=A;z=a|2;B=a|3;A=+p[x+(B<<3)>>3]*i;n[c+(z<<2)>>2]=+p[x+(z<<3)>>3]*i;n[c+(B<<2)>>2]=A;a=a+4|0}while((a|0)<=(s|0));y=u}if((y|0)<(l|0)){a=y;do{n[c+(a<<2)>>2]=+p[x+(a<<3)>>3]*i;a=a+1|0}while((a|0)!=(l|0))}}else{if(r){C=v;D=0}else{a=v;B=0;while(1){z=B|1;A=+p[x+(z<<3)>>3]*i+ +n[a+(q<<2)>>2]*j;n[c+(B<<2)>>2]=+p[x+(B<<3)>>3]*i+ +n[a>>2]*j;n[c+(z<<2)>>2]=A;z=B|2;E=B|3;A=+p[x+(E<<3)>>3]*i+ +n[a+(o<<2)>>2]*j;n[c+(z<<2)>>2]=+p[x+(z<<3)>>3]*i+ +n[a+(h<<2)>>2]*j;n[c+(E<<2)>>2]=A;B=B+4|0;if((B|0)>(s|0))break;else a=a+(g<<2)|0}C=m+(t<<2)|0;D=w}if((D|0)<(l|0)){a=C;B=D;while(1){n[c+(B<<2)>>2]=+p[x+(B<<3)>>3]*i+ +n[a>>2]*j;B=B+1|0;if((B|0)==(l|0))break;else a=a+(q<<2)|0}}}if(!e)break;else{v=v+(k<<2)|0;x=x+(b<<3)|0;c=c+(d<<2)|0;m=m+(k<<2)|0}}return}function iO(a,b,c,d,e,g,h,i,j,k,l,m,n,o,p){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;q=u;u=u+448|0;r=q+392|0;s=q+336|0;t=q+280|0;v=q+224|0;w=q+168|0;x=q+112|0;y=q+56|0;z=q;A=(o&2|0)==0;B=(o&1|0)!=0;C=B?l:m;D=B?m:l;B=A?C:n;E=A?n:C;C=(o&4|0)==0;A=C?D:n;F=C?n:D;f[r>>2]=1124007936;C=r+4|0;G=r+8|0;H=r+40|0;I=C;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[H>>2]=G;K=r+48|0;L=r+44|0;f[L>>2]=K;f[K>>2]=0;f[r+52>>2]=0;f[s>>2]=1124007936;M=s+4|0;N=s+8|0;O=s+40|0;I=M;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[O>>2]=N;P=s+48|0;Q=s+44|0;f[Q>>2]=P;f[P>>2]=0;f[s+52>>2]=0;f[t>>2]=1124007936;R=t+4|0;S=t+8|0;T=t+40|0;I=R;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[T>>2]=S;I=t+48|0;J=t+44|0;f[J>>2]=I;f[I>>2]=0;f[t+52>>2]=0;if(a|0){$i(v,l,m,p,a,b);b=v+36|0;a=f[b>>2]|0;if(a|0){m=a+12|0;f[m>>2]=(f[m>>2]|0)+1}m=r+36|0;a=f[m>>2]|0;if(a|0?(l=a+12|0,a=f[l>>2]|0,f[l>>2]=a+-1,(a|0)==1):0)CR(r);f[m>>2]=0;a=r+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[C>>2]|0)>0){l=f[H>>2]|0;U=0;do{f[l+(U<<2)>>2]=0;U=U+1|0;V=f[C>>2]|0}while((U|0)<(V|0));f[r>>2]=f[v>>2];if((V|0)<3)W=12;else W=14}else{f[r>>2]=f[v>>2];W=12}if((W|0)==12){V=f[v+4>>2]|0;if((V|0)<3){f[C>>2]=V;f[G>>2]=f[v+8>>2];f[r+12>>2]=f[v+12>>2];V=f[v+44>>2]|0;U=f[L>>2]|0;f[U>>2]=f[V>>2];f[U+4>>2]=f[V+4>>2]}else W=14}if((W|0)==14)BR(r,v);V=v+16|0;f[a>>2]=f[V>>2];f[r+20>>2]=f[v+20>>2];f[r+24>>2]=f[v+24>>2];f[r+28>>2]=f[v+28>>2];f[r+32>>2]=f[v+32>>2];a=f[b>>2]|0;f[m>>2]=a;if(a|0?(m=a+12|0,a=f[m>>2]|0,f[m>>2]=a+-1,(a|0)==1):0)CR(v);f[b>>2]=0;b=v+4|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[b>>2]|0)>0){V=f[v+40>>2]|0;a=0;do{f[V+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[b>>2]|0))}b=f[v+44>>2]|0;if((b|0)!=(v+48|0))ZF(b)}if(c|0){$i(v,B,E,p,c,d);d=v+36|0;c=f[d>>2]|0;if(c|0){E=c+12|0;f[E>>2]=(f[E>>2]|0)+1}E=s+36|0;c=f[E>>2]|0;if(c|0?(B=c+12|0,c=f[B>>2]|0,f[B>>2]=c+-1,(c|0)==1):0)CR(s);f[E>>2]=0;c=s+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[M>>2]|0)>0){B=f[O>>2]|0;b=0;do{f[B+(b<<2)>>2]=0;b=b+1|0;X=f[M>>2]|0}while((b|0)<(X|0));f[s>>2]=f[v>>2];if((X|0)<3)W=35;else W=37}else{f[s>>2]=f[v>>2];W=35}if((W|0)==35){X=f[v+4>>2]|0;if((X|0)<3){f[M>>2]=X;f[N>>2]=f[v+8>>2];f[s+12>>2]=f[v+12>>2];X=f[v+44>>2]|0;b=f[Q>>2]|0;f[b>>2]=f[X>>2];f[b+4>>2]=f[X+4>>2]}else W=37}if((W|0)==37)BR(s,v);X=v+16|0;f[c>>2]=f[X>>2];f[s+20>>2]=f[v+20>>2];f[s+24>>2]=f[v+24>>2];f[s+28>>2]=f[v+28>>2];f[s+32>>2]=f[v+32>>2];c=f[d>>2]|0;f[E>>2]=c;if(c|0?(E=c+12|0,c=f[E>>2]|0,f[E>>2]=c+-1,(c|0)==1):0)CR(v);f[d>>2]=0;d=v+4|0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[d>>2]|0)>0){X=f[v+40>>2]|0;c=0;do{f[X+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[v+44>>2]|0;if((d|0)!=(v+48|0))ZF(d)}if((g|0)!=0&i!=0.0){$i(v,A,F,p,g,h);h=v+36|0;g=f[h>>2]|0;if(g|0){F=g+12|0;f[F>>2]=(f[F>>2]|0)+1}F=t+36|0;g=f[F>>2]|0;if(g|0?(A=g+12|0,g=f[A>>2]|0,f[A>>2]=g+-1,(g|0)==1):0)CR(t);f[F>>2]=0;g=t+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[R>>2]|0)>0){A=f[T>>2]|0;d=0;do{f[A+(d<<2)>>2]=0;d=d+1|0;Y=f[R>>2]|0}while((d|0)<(Y|0));f[t>>2]=f[v>>2];if((Y|0)<3)W=58;else W=60}else{f[t>>2]=f[v>>2];W=58}if((W|0)==58){Y=f[v+4>>2]|0;if((Y|0)<3){f[R>>2]=Y;f[S>>2]=f[v+8>>2];f[t+12>>2]=f[v+12>>2];Y=f[v+44>>2]|0;d=f[J>>2]|0;f[d>>2]=f[Y>>2];f[d+4>>2]=f[Y+4>>2]}else W=60}if((W|0)==60)BR(t,v);W=v+16|0;f[g>>2]=f[W>>2];f[t+20>>2]=f[v+20>>2];f[t+24>>2]=f[v+24>>2];f[t+28>>2]=f[v+28>>2];f[t+32>>2]=f[v+32>>2];g=f[h>>2]|0;f[F>>2]=g;if(g|0?(F=g+12|0,g=f[F>>2]|0,f[F>>2]=g+-1,(g|0)==1):0)CR(v);f[h>>2]=0;h=v+4|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[h>>2]|0)>0){W=f[v+40>>2]|0;g=0;do{f[W+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[h>>2]|0))}h=f[v+44>>2]|0;if((h|0)!=(v+48|0))ZF(h)}$i(v,D,n,p,j,k);f[w>>2]=f[r>>2];k=w+4|0;j=f[C>>2]|0;f[k>>2]=j;p=w+8|0;f[p>>2]=f[G>>2];f[w+12>>2]=f[r+12>>2];G=w+16|0;n=r+16|0;f[G>>2]=f[n>>2];f[w+20>>2]=f[r+20>>2];f[w+24>>2]=f[r+24>>2];f[w+28>>2]=f[r+28>>2];f[w+32>>2]=f[r+32>>2];D=w+36|0;h=r+36|0;g=f[h>>2]|0;f[D>>2]=g;W=w+40|0;f[W>>2]=p;p=w+48|0;F=w+44|0;f[F>>2]=p;f[p>>2]=0;f[w+52>>2]=0;if(!g)Z=j;else{j=g+12|0;f[j>>2]=(f[j>>2]|0)+1;Z=f[C>>2]|0}if((Z|0)<3){Z=f[L>>2]|0;j=f[F>>2]|0;f[j>>2]=f[Z>>2];f[j+4>>2]=f[Z+4>>2]}else{f[k>>2]=0;BR(w,r)}f[x>>2]=f[s>>2];Z=x+4|0;j=f[M>>2]|0;f[Z>>2]=j;g=x+8|0;f[g>>2]=f[N>>2];f[x+12>>2]=f[s+12>>2];N=x+16|0;Y=s+16|0;f[N>>2]=f[Y>>2];f[x+20>>2]=f[s+20>>2];f[x+24>>2]=f[s+24>>2];f[x+28>>2]=f[s+28>>2];f[x+32>>2]=f[s+32>>2];d=x+36|0;A=s+36|0;c=f[A>>2]|0;f[d>>2]=c;X=x+40|0;f[X>>2]=g;g=x+48|0;E=x+44|0;f[E>>2]=g;f[g>>2]=0;f[x+52>>2]=0;if(!c)_=j;else{j=c+12|0;f[j>>2]=(f[j>>2]|0)+1;_=f[M>>2]|0}if((_|0)<3){_=f[Q>>2]|0;j=f[E>>2]|0;f[j>>2]=f[_>>2];f[j+4>>2]=f[_+4>>2]}else{f[Z>>2]=0;BR(x,s)}f[y>>2]=f[t>>2];_=y+4|0;j=f[R>>2]|0;f[_>>2]=j;c=y+8|0;f[c>>2]=f[S>>2];f[y+12>>2]=f[t+12>>2];S=y+16|0;b=t+16|0;f[S>>2]=f[b>>2];f[y+20>>2]=f[t+20>>2];f[y+24>>2]=f[t+24>>2];f[y+28>>2]=f[t+28>>2];f[y+32>>2]=f[t+32>>2];B=y+36|0;a=t+36|0;V=f[a>>2]|0;f[B>>2]=V;m=y+40|0;f[m>>2]=c;c=y+48|0;U=y+44|0;f[U>>2]=c;f[c>>2]=0;f[y+52>>2]=0;if(!V)$=j;else{j=V+12|0;f[j>>2]=(f[j>>2]|0)+1;$=f[R>>2]|0}if(($|0)<3){$=f[J>>2]|0;j=f[U>>2]|0;f[j>>2]=f[$>>2];f[j+4>>2]=f[$+4>>2]}else{f[_>>2]=0;BR(y,t)}f[z>>2]=f[v>>2];$=z+4|0;j=v+4|0;V=f[j>>2]|0;f[$>>2]=V;l=z+8|0;f[l>>2]=f[v+8>>2];f[z+12>>2]=f[v+12>>2];aa=z+16|0;ba=v+16|0;f[aa>>2]=f[ba>>2];f[z+20>>2]=f[v+20>>2];f[z+24>>2]=f[v+24>>2];f[z+28>>2]=f[v+28>>2];f[z+32>>2]=f[v+32>>2];ca=z+36|0;da=v+36|0;ea=f[da>>2]|0;f[ca>>2]=ea;fa=z+40|0;f[fa>>2]=l;l=z+48|0;ga=z+44|0;f[ga>>2]=l;f[l>>2]=0;f[z+52>>2]=0;if(!ea)ha=V;else{V=ea+12|0;f[V>>2]=(f[V>>2]|0)+1;ha=f[j>>2]|0}if((ha|0)<3){ha=f[v+44>>2]|0;V=f[ga>>2]|0;f[V>>2]=f[ha>>2];f[V+4>>2]=f[ha+4>>2]}else{f[$>>2]=0;BR(z,v)}XN(w,x,e,y,i,z,o);o=f[ca>>2]|0;if(o|0?(ha=o+12|0,o=f[ha>>2]|0,f[ha>>2]=o+-1,(o|0)==1):0)CR(z);f[ca>>2]=0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[$>>2]|0)>0){aa=f[fa>>2]|0;fa=0;do{f[aa+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[$>>2]|0))}$=f[ga>>2]|0;if(($|0)!=(l|0))ZF($);$=f[B>>2]|0;if($|0?(l=$+12|0,$=f[l>>2]|0,f[l>>2]=$+-1,($|0)==1):0)CR(y);f[B>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[_>>2]|0)>0){S=f[m>>2]|0;m=0;do{f[S+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[_>>2]|0))}_=f[U>>2]|0;if((_|0)!=(c|0))ZF(_);_=f[d>>2]|0;if(_|0?(c=_+12|0,_=f[c>>2]|0,f[c>>2]=_+-1,(_|0)==1):0)CR(x);f[d>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[Z>>2]|0)>0){N=f[X>>2]|0;X=0;do{f[N+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[Z>>2]|0))}Z=f[E>>2]|0;if((Z|0)!=(g|0))ZF(Z);Z=f[D>>2]|0;do if(Z|0){g=Z+12|0;E=f[g>>2]|0;f[g>>2]=E+-1;if((E|0)!=1)break;CR(w)}while(0);f[D>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[k>>2]|0)>0){G=f[W>>2]|0;W=0;do{f[G+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[k>>2]|0))}k=f[F>>2]|0;if((k|0)!=(p|0))ZF(k);k=f[da>>2]|0;do if(k|0){p=k+12|0;F=f[p>>2]|0;f[p>>2]=F+-1;if((F|0)!=1)break;CR(v)}while(0);f[da>>2]=0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[j>>2]|0)>0){ba=f[v+40>>2]|0;da=0;do{f[ba+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[j>>2]|0))}j=f[v+44>>2]|0;if((j|0)!=(v+48|0))ZF(j);j=f[a>>2]|0;do if(j|0){v=j+12|0;da=f[v>>2]|0;f[v>>2]=da+-1;if((da|0)!=1)break;CR(t)}while(0);f[a>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[R>>2]|0)>0){b=f[T>>2]|0;T=0;do{f[b+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[R>>2]|0))}R=f[J>>2]|0;if((R|0)!=(I|0))ZF(R);R=f[A>>2]|0;do if(R|0){I=R+12|0;J=f[I>>2]|0;f[I>>2]=J+-1;if((J|0)!=1)break;CR(s)}while(0);f[A>>2]=0;f[Y>>2]=0;f[Y+4>>2]=0;f[Y+8>>2]=0;f[Y+12>>2]=0;if((f[M>>2]|0)>0){Y=f[O>>2]|0;O=0;do{f[Y+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[M>>2]|0))}M=f[Q>>2]|0;if((M|0)!=(P|0))ZF(M);M=f[h>>2]|0;do if(M|0){P=M+12|0;Q=f[P>>2]|0;f[P>>2]=Q+-1;if((Q|0)!=1)break;CR(r)}while(0);f[h>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[C>>2]|0)>0){n=f[H>>2]|0;H=0;do{f[n+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[C>>2]|0))}C=f[L>>2]|0;if((C|0)==(K|0)){u=q;return}ZF(C);u=q;return}function jO(a,c,d,e,g,h,i){a=a|0;c=c|0;d=+d;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;j=u;u=u+352|0;k=j+336|0;l=j+280|0;m=j+224|0;n=j+168|0;o=j+112|0;p=j+56|0;q=j;do if((NS(a)|0)==65536){r=f[a+4>>2]|0;f[l>>2]=f[r>>2];s=l+4|0;t=r+4|0;f[s>>2]=f[t>>2];v=l+8|0;f[v>>2]=f[r+8>>2];f[l+12>>2]=f[r+12>>2];f[l+16>>2]=f[r+16>>2];f[l+20>>2]=f[r+20>>2];f[l+24>>2]=f[r+24>>2];f[l+28>>2]=f[r+28>>2];f[l+32>>2]=f[r+32>>2];w=f[r+36>>2]|0;f[l+36>>2]=w;f[l+40>>2]=v;v=l+48|0;x=l+44|0;f[x>>2]=v;f[v>>2]=0;f[l+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[r+44>>2]|0;v=f[x>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];break}else{f[s>>2]=0;BR(l,r);break}}else OR(l,a,-1);while(0);do if((NS(c)|0)==65536){a=f[c+4>>2]|0;f[m>>2]=f[a>>2];r=m+4|0;s=a+4|0;f[r>>2]=f[s>>2];t=m+8|0;f[t>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];v=f[a+36>>2]|0;f[m+36>>2]=v;f[m+40>>2]=t;t=m+48|0;x=m+44|0;f[x>>2]=t;f[t>>2]=0;f[m+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[a+44>>2]|0;t=f[x>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[r>>2]=0;BR(m,a);break}}else OR(m,c,-1);while(0);do if(g!=0.0){if((NS(e)|0)!=65536){OR(n,e,-1);break}c=f[e+4>>2]|0;f[n>>2]=f[c>>2];a=n+4|0;r=c+4|0;f[a>>2]=f[r>>2];s=n+8|0;f[s>>2]=f[c+8>>2];f[n+12>>2]=f[c+12>>2];f[n+16>>2]=f[c+16>>2];f[n+20>>2]=f[c+20>>2];f[n+24>>2]=f[c+24>>2];f[n+28>>2]=f[c+28>>2];f[n+32>>2]=f[c+32>>2];t=f[c+36>>2]|0;f[n+36>>2]=t;f[n+40>>2]=s;s=n+48|0;x=n+44|0;f[x>>2]=s;f[s>>2]=0;f[n+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[c+44>>2]|0;s=f[x>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[a>>2]=0;BR(n,c);break}}else{f[n>>2]=1124007936;c=n+8|0;a=n+40|0;y=n+4|0;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[a>>2]=c;r=n+48|0;f[n+44>>2]=r;f[r>>2]=0;f[n+52>>2]=0}while(0);e=l+40|0;r=f[e>>2]|0;s=f[r+4>>2]|0;x=f[r>>2]|0;r=f[l>>2]|0;t=r&4095;if((t|0)!=(f[m>>2]&4095|0)){f[k>>2]=0;f[k+4>>2]=0;y=c$(k,16)|0;A=168228;z=y+16|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));j$(-215,k,168245,168105,1558);d$(k)}if(((r&4087)+-5|0)>>>0>=2){f[k>>2]=0;f[k+4>>2]=0;K1a(c$(k,210)|0,168250,210)|0;j$(-215,k,168245,168105,1558);d$(k)}switch(i&3){case 0:{v=f[m+12>>2]|0;if((s|0)==(f[m+8>>2]|0)){B=v;C=x}else{f[k>>2]=0;f[k+4>>2]=0;y=c$(k,19)|0;A=168461;z=y+19|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));j$(-215,k,168245,168105,1565);d$(k);B=v;C=x}break}case 1:{v=f[m+12>>2]|0;if((x|0)==(f[m+8>>2]|0)){B=v;C=s}else{f[k>>2]=0;f[k+4>>2]=0;y=c$(k,20)|0;A=168481;z=y+20|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));j$(-215,k,168245,168105,1570);d$(k);B=v;C=s}break}case 2:{v=f[m+8>>2]|0;if((s|0)==(f[m+12>>2]|0)){B=v;C=x}else{f[k>>2]=0;f[k+4>>2]=0;y=c$(k,19)|0;A=168461;z=y+19|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));j$(-215,k,168245,168105,1575);d$(k);B=v;C=x}break}case 3:{v=f[m+8>>2]|0;if((x|0)==(f[m+12>>2]|0)){B=v;C=s}else{f[k>>2]=0;f[k+4>>2]=0;y=c$(k,20)|0;A=168481;z=y+20|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));j$(-215,k,168245,168105,1580);d$(k);B=v;C=s}break}default:{}}v=n+16|0;do if(f[v>>2]|0){w=f[n+4>>2]|0;if((w|0)<3)D=Y(f[n+12>>2]|0,f[n+8>>2]|0)|0;else{E=f[n+40>>2]|0;F=0;G=1;while(1){H=Y(f[E+(F<<2)>>2]|0,G)|0;F=F+1|0;if((F|0)==(w|0)){D=H;break}else G=H}}if(!((w|0)==0|(D|0)==0)){if((f[n>>2]&4095|0)!=(t|0)){f[k>>2]=0;f[k+4>>2]=0;y=c$(k,16)|0;A=168502;z=y+16|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));j$(-215,k,168245,168105,1588);d$(k)}w=f[n+8>>2]|0;if(!(i&4)){if((w|0)==(C|0)?(f[n+12>>2]|0)==(B|0):0)break}else if((w|0)==(B|0)?(f[n+12>>2]|0)==(C|0):0)break;f[k>>2]=0;f[k+4>>2]=0;K1a(c$(k,158)|0,168519,158)|0;j$(-215,k,168245,168105,1588);d$(k)}}while(0);pS(h,C,B,t,-1,0,0);do if((NS(h)|0)==65536){t=f[h+4>>2]|0;f[o>>2]=f[t>>2];D=o+4|0;w=t+4|0;f[D>>2]=f[w>>2];G=o+8|0;f[G>>2]=f[t+8>>2];f[o+12>>2]=f[t+12>>2];f[o+16>>2]=f[t+16>>2];f[o+20>>2]=f[t+20>>2];f[o+24>>2]=f[t+24>>2];f[o+28>>2]=f[t+28>>2];f[o+32>>2]=f[t+32>>2];F=f[t+36>>2]|0;f[o+36>>2]=F;f[o+40>>2]=G;G=o+48|0;E=o+44|0;f[E>>2]=G;f[G>>2]=0;f[o+52>>2]=0;if(F|0){G=F+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;G=f[E>>2]|0;f[G>>2]=f[w>>2];f[G+4>>2]=f[w+4>>2];break}else{f[D>>2]=0;BR(o,t);break}}else OR(o,h,-1);while(0);if(i&4){h=o+16|0;if((f[v>>2]|0)==(f[h>>2]|0)){f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=n;t=p+8|0;f[t>>2]=0;f[t+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=n;mS(k,p);I=h;J=i&-5}else{I=h;J=i}}else{I=o+16|0;J=i}f[p>>2]=1124007936;i=p+4|0;h=p+8|0;t=p+40|0;y=i;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[t>>2]=h;D=p+48|0;w=p+44|0;f[w>>2]=D;f[D>>2]=0;f[p+52>>2]=0;G=f[I>>2]|0;E=l+16|0;if((G|0)!=(f[E>>2]|0)?(G|0)!=(f[m+16>>2]|0):0)K=o;else{G=f[o>>2]&4095;f[q>>2]=1124007936;F=q+4|0;c=q+8|0;a=q+40|0;y=F;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[a>>2]=c;H=q+48|0;L=q+44|0;f[L>>2]=H;f[H>>2]=0;f[q+52>>2]=0;f[k>>2]=C;f[k+4>>2]=B;AR(q,2,k,G);G=q+36|0;B=f[G>>2]|0;if(B|0){C=B+12|0;f[C>>2]=(f[C>>2]|0)+1}C=p+36|0;B=f[C>>2]|0;if(B|0?(M=B+12|0,B=f[M>>2]|0,f[M>>2]=B+-1,(B|0)==1):0)CR(p);f[C>>2]=0;B=p+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[i>>2]|0)>0){M=f[t>>2]|0;N=0;do{f[M+(N<<2)>>2]=0;N=N+1|0;O=f[i>>2]|0}while((N|0)<(O|0));f[p>>2]=f[q>>2];if((O|0)<3)P=75;else P=77}else{f[p>>2]=f[q>>2];P=75}if((P|0)==75){O=f[F>>2]|0;if((O|0)<3){f[i>>2]=O;f[h>>2]=f[c>>2];f[p+12>>2]=f[q+12>>2];c=f[L>>2]|0;h=f[w>>2]|0;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2]}else P=77}if((P|0)==77)BR(p,q);c=q+16|0;f[B>>2]=f[c>>2];f[p+20>>2]=f[q+20>>2];f[p+24>>2]=f[q+24>>2];f[p+28>>2]=f[q+28>>2];f[p+32>>2]=f[q+32>>2];B=f[G>>2]|0;f[C>>2]=B;if(B|0?(C=B+12|0,B=f[C>>2]|0,f[C>>2]=B+-1,(B|0)==1):0)CR(q);f[G>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[F>>2]|0)>0){c=f[a>>2]|0;a=0;do{f[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[F>>2]|0))}F=f[L>>2]|0;if((F|0)!=(H|0))ZF(F);K=p}switch(r&4095){case 5:{WN(f[E>>2]|0,f[l+48>>2]|0,f[m+16>>2]|0,f[m+48>>2]|0,d,f[v>>2]|0,f[n+48>>2]|0,g,f[K+16>>2]|0,f[K+48>>2]|0,x,s,f[K+12>>2]|0,J,5);break}case 6:{iO(f[E>>2]|0,f[l+48>>2]|0,f[m+16>>2]|0,f[m+48>>2]|0,d,f[v>>2]|0,f[n+48>>2]|0,g,f[K+16>>2]|0,f[K+48>>2]|0,x,s,f[K+12>>2]|0,J,6);break}case 13:{WN(f[E>>2]|0,f[l+48>>2]|0,f[m+16>>2]|0,f[m+48>>2]|0,d,f[v>>2]|0,f[n+48>>2]|0,g,f[K+16>>2]|0,f[K+48>>2]|0,x,s,f[K+12>>2]|0,J,13);break}case 14:{P=92;break}default:{f[k>>2]=0;f[k+4>>2]=0;y=c$(k,49)|0;A=168046;z=y+49|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));j$(-215,k,168245,168105,1623);d$(k);P=92}}if((P|0)==92)iO(f[E>>2]|0,f[l+48>>2]|0,f[m+16>>2]|0,f[m+48>>2]|0,d,f[v>>2]|0,f[n+48>>2]|0,g,f[I>>2]|0,f[o+48>>2]|0,x,s,f[K+12>>2]|0,J,14);if((K|0)!=(o|0)){J=k+8|0;f[J>>2]=0;f[J+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=o;eL(K,k)}k=p+36|0;K=f[k>>2]|0;if(K|0?(J=K+12|0,K=f[J>>2]|0,f[J>>2]=K+-1,(K|0)==1):0)CR(p);f[k>>2]=0;k=p+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[i>>2]|0)>0){k=f[t>>2]|0;t=0;do{f[k+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[i>>2]|0))}i=f[w>>2]|0;if((i|0)!=(D|0))ZF(i);i=o+36|0;D=f[i>>2]|0;if(D|0?(w=D+12|0,D=f[w>>2]|0,f[w>>2]=D+-1,(D|0)==1):0)CR(o);f[i>>2]=0;i=o+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[i>>2]|0)>0){I=f[o+40>>2]|0;D=0;do{f[I+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[i>>2]|0))}i=f[o+44>>2]|0;if((i|0)!=(o+48|0))ZF(i);i=n+36|0;o=f[i>>2]|0;if(o|0?(D=o+12|0,o=f[D>>2]|0,f[D>>2]=o+-1,(o|0)==1):0)CR(n);f[i>>2]=0;i=n+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[i>>2]|0)>0){v=f[n+40>>2]|0;o=0;do{f[v+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[i>>2]|0))}i=f[n+44>>2]|0;if((i|0)!=(n+48|0))ZF(i);i=m+36|0;n=f[i>>2]|0;do if(n|0){o=n+12|0;v=f[o>>2]|0;f[o>>2]=v+-1;if((v|0)!=1)break;CR(m)}while(0);f[i>>2]=0;i=m+16|0;n=m+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[n>>2]|0)>0){i=f[m+40>>2]|0;v=0;do{f[i+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[n>>2]|0))}n=f[m+44>>2]|0;if((n|0)!=(m+48|0))ZF(n);n=l+36|0;m=f[n>>2]|0;do if(m|0){v=m+12|0;i=f[v>>2]|0;f[v>>2]=i+-1;if((i|0)!=1)break;CR(l)}while(0);f[n>>2]=0;n=l+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[n>>2]|0)>0){E=f[e>>2]|0;e=0;do{f[E+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[n>>2]|0))}n=f[l+44>>2]|0;if((n|0)==(l+48|0)){u=j;return}ZF(n);u=j;return}function kO(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0.0,Z=0.0,_=0.0,$=0;e=u;u=u+1424|0;g=e+1400|0;h=e+1392|0;i=e+1384|0;j=e+1328|0;k=e+1272|0;l=e+1264|0;m=e+1208|0;o=e;q=e+1152|0;r=e+1096|0;_$(i,39780);do if((NS(a)|0)==65536){s=f[a+4>>2]|0;f[j>>2]=f[s>>2];t=j+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=j+8|0;f[w>>2]=f[s+8>>2];f[j+12>>2]=f[s+12>>2];f[j+16>>2]=f[s+16>>2];f[j+20>>2]=f[s+20>>2];f[j+24>>2]=f[s+24>>2];f[j+28>>2]=f[s+28>>2];f[j+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[j+36>>2]=x;f[j+40>>2]=w;w=j+48|0;y=j+44|0;f[y>>2]=w;f[w>>2]=0;f[j+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[t>>2]=0;BR(j,s);break}}else OR(j,a,-1);while(0);do if((NS(d)|0)==65536){a=f[d+4>>2]|0;f[k>>2]=f[a>>2];s=k+4|0;t=a+4|0;f[s>>2]=f[t>>2];v=k+8|0;f[v>>2]=f[a+8>>2];w=k+12|0;f[w>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];y=f[a+36>>2]|0;f[k+36>>2]=y;f[k+40>>2]=v;x=k+48|0;z=k+44|0;f[z>>2]=x;f[x>>2]=0;f[k+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[t>>2]|0)<3){t=f[a+44>>2]|0;x=f[z>>2]|0;f[x>>2]=f[t>>2];f[x+4>>2]=f[t+4>>2];A=w;B=v;break}else{f[s>>2]=0;BR(k,a);A=w;B=v;break}}else{OR(k,d,-1);A=k+12|0;B=k+8|0}while(0);d=f[j>>2]|0;v=d&7;w=d>>>3&511;d=w+1|0;a=f[B>>2]|0;s=f[A>>2]|0;t=w+2|0;if(!((d|0)==(s|0)|(t|0)==(s|0))){f[g>>2]=0;f[g+4>>2]=0;C=c$(g,34)|0;D=168678;E=C+34|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));j$(-215,g,168713,168105,2119);d$(g)}s=j+40|0;x=f[s>>2]|0;z=f[x>>2]|0;f[l>>2]=f[x+4>>2];f[l+4>>2]=z;KS(c,l,(a<<3)+-8|v,-1,0,0);do if((NS(c)|0)==65536){l=f[c+4>>2]|0;f[m>>2]=f[l>>2];z=m+4|0;x=l+4|0;f[z>>2]=f[x>>2];y=m+8|0;f[y>>2]=f[l+8>>2];f[m+12>>2]=f[l+12>>2];f[m+16>>2]=f[l+16>>2];f[m+20>>2]=f[l+20>>2];f[m+24>>2]=f[l+24>>2];f[m+28>>2]=f[l+28>>2];f[m+32>>2]=f[l+32>>2];F=f[l+36>>2]|0;f[m+36>>2]=F;f[m+40>>2]=y;y=m+48|0;G=m+44|0;f[G>>2]=y;f[y>>2]=0;f[m+52>>2]=0;if(F|0){y=F+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[l+44>>2]|0;y=f[G>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[z>>2]=0;BR(m,l);break}}else OR(m,c,-1);while(0);c=(v|2|0)==6;l=c?6:5;z=o+8|0;f[o>>2]=z;x=o+4|0;f[x>>2]=136;y=f[k>>2]|0;if((f[A>>2]|0)==(t|0)&((y&16384|0)!=0&(y&4095|0)==(l|0)))H=f[k+16>>2]|0;else{y=Y(t,a)|0;f[x>>2]=y;if(y>>>0>136){G=OYa(y>>>0>536870911?-1:y<<3)|0;f[o>>2]=G;I=G}else I=z;$i(q,a,t,l,I,0);G=q+16|0;y=f[G>>2]|0;F=q+44|0;J=q+4|0;K=f[J>>2]|0;if((K|0)<3)M=Y(f[q+12>>2]|0,f[q+8>>2]|0)|0;else{N=f[q+40>>2]|0;O=0;P=1;while(1){Q=Y(f[N+(O<<2)>>2]|0,P)|0;O=O+1|0;if((O|0)==(K|0)){M=Q;break}else P=Q}}if((K|0)>0)R=f[(f[F>>2]|0)+(K+-1<<2)>>2]|0;else R=0;F1a(y|0,0,Y(R,M)|0)|0;M=f[A>>2]|0;if((M|0)!=(t|0)){f[g>>2]=-2147483648;f[g+4>>2]=2147483647;f[h>>2]=0;f[h+4>>2]=M;DR(r,q,g,h);M=g+8|0;f[M>>2]=0;f[M+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=r;WJ(k,g,l,1.0,0.0);M=r+36|0;t=f[M>>2]|0;if(t|0?(R=t+12|0,t=f[R>>2]|0,f[R>>2]=t+-1,(t|0)==1):0)CR(r);f[M>>2]=0;M=r+16|0;t=r+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[t>>2]|0)>0){M=f[r+40>>2]|0;R=0;do{f[M+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[t>>2]|0))}t=f[r+44>>2]|0;if((t|0)!=(r+48|0))ZF(t)}else{t=g+8|0;f[t>>2]=0;f[t+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=q;WJ(k,g,l,1.0,0.0)}l=q+36|0;t=f[l>>2]|0;if(t|0){r=t+12|0;f[r>>2]=(f[r>>2]|0)+1}r=k+36|0;t=f[r>>2]|0;if(t|0?(R=t+12|0,t=f[R>>2]|0,f[R>>2]=t+-1,(t|0)==1):0)CR(k);f[r>>2]=0;t=k+16|0;R=k+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[R>>2]|0)>0){M=f[k+40>>2]|0;y=0;do{f[M+(y<<2)>>2]=0;y=y+1|0;S=f[R>>2]|0}while((y|0)<(S|0));f[k>>2]=f[q>>2];if((S|0)<3)T=54;else T=56}else{f[k>>2]=f[q>>2];T=54}if((T|0)==54){S=f[J>>2]|0;if((S|0)<3){f[R>>2]=S;f[B>>2]=f[q+8>>2];f[A>>2]=f[q+12>>2];B=f[F>>2]|0;S=f[k+44>>2]|0;f[S>>2]=f[B>>2];f[S+4>>2]=f[B+4>>2]}else T=56}if((T|0)==56)BR(k,q);f[t>>2]=f[G>>2];f[k+20>>2]=f[q+20>>2];f[k+24>>2]=f[q+24>>2];f[k+28>>2]=f[q+28>>2];f[k+32>>2]=f[q+32>>2];t=f[l>>2]|0;f[r>>2]=t;if(t|0?(r=t+12|0,t=f[r>>2]|0,f[r>>2]=t+-1,(t|0)==1):0)CR(q);f[l>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[J>>2]|0)>0){G=f[q+40>>2]|0;l=0;do{f[G+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[J>>2]|0))}J=f[F>>2]|0;if((J|0)!=(q+48|0))ZF(J);H=I}a:do if((d|0)==(a|0)){U=c?2.220446049250313e-16:1.1920928955078125e-07;I=f[k+16>>2]|0;if(w|0){J=f[f[k+44>>2]>>2]|0;if(c){F=0;while(1){l=I+(Y(J,F)|0)|0;G=0;while(1){if((F|0)!=(G|0)?+L(+(+p[l+(G<<3)>>3]))>U:0){V=39800;T=96;break a}if((G|0)<(w|0))G=G+1|0;else break}if((F|0)<(w|0))F=F+1|0;else{V=39832;T=96;break a}}}else{F=0;while(1){G=I+(Y(J,F)|0)|0;l=0;while(1){if((F|0)!=(l|0)?+L(+(+n[G+(l<<2)>>2]))>U:0){V=39800;T=96;break a}if((l|0)<(w|0))l=l+1|0;else break}if((F|0)<(w|0))F=F+1|0;else{V=39832;T=96;break a}}}}if(c){U=+p[I>>3];do if((f[k>>2]&16384|0)==0?(F=f[k+40>>2]|0,(f[F>>2]|0)!=1):0){J=f[f[k+44>>2]>>2]|0;if((f[F+4>>2]|0)==1){W=I+J|0;break}else{F=f[A>>2]|0;l=(F+1|0)>>>0<3?F:0;W=I+(Y(l,J)|0)+(1-(Y(l,F)|0)<<3)|0;break}}else T=85;while(0);if((T|0)==85)W=I+8|0;X=U;Z=+p[W>>3]}else{_=+n[I>>2];do if((f[k>>2]&16384|0)==0?(F=f[k+40>>2]|0,(f[F>>2]|0)!=1):0){l=f[f[k+44>>2]>>2]|0;if((f[F+4>>2]|0)==1){$=I+l|0;break}else{F=f[A>>2]|0;J=(F+1|0)>>>0<3?F:0;$=I+(Y(J,l)|0)+(1-(Y(J,F)|0)<<2)|0;break}}else T=78;while(0);if((T|0)==78)$=I+4|0;X=_;Z=+n[$>>2]}F=g+8|0;f[F>>2]=0;f[F+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=m;WJ(j,g,f[m>>2]&4095,X,Z)}else{V=39800;T=96}while(0);if((T|0)==96){T=f[V+(v<<2)>>2]|0;if(!T){f[g>>2]=0;f[g+4>>2]=0;C=c$(g,9)|0;D=323538;E=C+9|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));j$(-215,g,168713,168105,2175);d$(g)}f[g>>2]=j;f[g+4>>2]=m;f[g+8>>2]=0;bU(q,g,h,-1);g=f[q+20>>2]|0;D=q+16|0;C=h+4|0;E=0;while(1){if(E>>>0>=(f[D>>2]|0)>>>0)break;bh[T&255](f[h>>2]|0,f[C>>2]|0,H,g,d,a);tR(q)|0;E=E+1|0}}E=f[o>>2]|0;if((E|0)!=(z|0)){if(E|0)QYa(E);f[o>>2]=z;f[x>>2]=136}x=m+36|0;z=f[x>>2]|0;if(z|0?(o=z+12|0,z=f[o>>2]|0,f[o>>2]=z+-1,(z|0)==1):0)CR(m);f[x>>2]=0;x=m+16|0;z=m+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[z>>2]|0)>0){x=f[m+40>>2]|0;o=0;do{f[x+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[z>>2]|0))}z=f[m+44>>2]|0;if((z|0)!=(m+48|0))ZF(z);z=k+36|0;m=f[z>>2]|0;if(m|0?(o=m+12|0,m=f[o>>2]|0,f[o>>2]=m+-1,(m|0)==1):0)CR(k);f[z>>2]=0;z=k+16|0;m=k+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[m>>2]|0)>0){z=f[k+40>>2]|0;o=0;do{f[z+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[m>>2]|0))}m=f[k+44>>2]|0;if((m|0)!=(k+48|0))ZF(m);m=j+36|0;k=f[m>>2]|0;if(k|0?(o=k+12|0,k=f[o>>2]|0,f[o>>2]=k+-1,(k|0)==1):0)CR(j);f[m>>2]=0;m=j+16|0;k=j+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[k>>2]|0)>0){m=f[s>>2]|0;s=0;do{f[m+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))ZF(k);if(!(f[i+4>>2]|0)){u=e;return}u=e;return}function lO(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;switch(f|0){case 2:{g=e<<1;if((e|0)<=0)return;i=d+8|0;j=d+16|0;k=d+20|0;l=0;do{m=wNa(+n[i>>2]+ +n[d>>2]*+(h[a+l>>0]|0))|0;o=l|1;p=wNa(+n[k>>2]+ +n[j>>2]*+(h[a+o>>0]|0))|0;b[c+l>>0]=m>>>0<256?m:(m|0)>0?255:0;b[c+o>>0]=p>>>0<256?p:(p|0)>0?255:0;l=l+2|0}while((l|0)<(g|0));return}case 3:{g=e*3|0;if((e|0)<=0)return;l=d+12|0;j=d+20|0;k=d+28|0;i=d+40|0;p=d+44|0;o=0;do{m=wNa(+n[l>>2]+ +n[d>>2]*+(h[a+o>>0]|0))|0;q=o+1|0;r=wNa(+n[k>>2]+ +n[j>>2]*+(h[a+q>>0]|0))|0;s=o+2|0;t=wNa(+n[p>>2]+ +n[i>>2]*+(h[a+s>>0]|0))|0;b[c+o>>0]=m>>>0<256?m:(m|0)>0?255:0;b[c+q>>0]=r>>>0<256?r:(r|0)>0?255:0;b[c+s>>0]=t>>>0<256?t:(t|0)>0?255:0;o=o+3|0}while((o|0)<(g|0));return}case 4:{g=e<<2;if((e|0)<=0)return;o=d+16|0;i=d+24|0;p=d+36|0;j=d+48|0;k=d+56|0;l=d+72|0;t=d+76|0;s=0;do{r=wNa(+n[o>>2]+ +n[d>>2]*+(h[a+s>>0]|0))|0;q=s|1;m=wNa(+n[p>>2]+ +n[i>>2]*+(h[a+q>>0]|0))|0;b[c+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[c+q>>0]=m>>>0<256?m:(m|0)>0?255:0;m=s|2;q=wNa(+n[k>>2]+ +n[j>>2]*+(h[a+m>>0]|0))|0;r=s|3;u=wNa(+n[t>>2]+ +n[l>>2]*+(h[a+r>>0]|0))|0;b[c+m>>0]=q>>>0<256?q:(q|0)>0?255:0;b[c+r>>0]=u>>>0<256?u:(u|0)>0?255:0;s=s+4|0}while((s|0)<(g|0));return}default:{if((e|0)<=0)return;g=f+1|0;if((f|0)>0){v=c;w=a;x=0}else return;while(1){a=d;c=0;while(1){s=wNa(+(h[w+c>>0]|0)*+n[a+(c<<2)>>2]+ +n[a+(f<<2)>>2])|0;b[v+c>>0]=s>>>0<256?s:(s|0)>0?255:0;c=c+1|0;if((c|0)==(f|0))break;else a=a+(g<<2)|0}x=x+1|0;if((x|0)==(e|0))break;else{v=v+f|0;w=w+f|0}}return}}}function mO(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;switch(f|0){case 2:{g=e<<1;if((e|0)<=0)return;h=d+8|0;i=d+16|0;j=d+20|0;k=0;do{l=wNa(+n[h>>2]+ +n[d>>2]*+(b[a+k>>0]|0))|0;m=k|1;o=wNa(+n[j>>2]+ +n[i>>2]*+(b[a+m>>0]|0))|0;b[c+k>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;b[c+m>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;k=k+2|0}while((k|0)<(g|0));return}case 3:{g=e*3|0;if((e|0)<=0)return;k=d+12|0;i=d+20|0;j=d+28|0;h=d+40|0;o=d+44|0;m=0;do{l=wNa(+n[k>>2]+ +n[d>>2]*+(b[a+m>>0]|0))|0;p=m+1|0;q=wNa(+n[j>>2]+ +n[i>>2]*+(b[a+p>>0]|0))|0;r=m+2|0;s=wNa(+n[o>>2]+ +n[h>>2]*+(b[a+r>>0]|0))|0;b[c+m>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;b[c+p>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;b[c+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;m=m+3|0}while((m|0)<(g|0));return}case 4:{g=e<<2;if((e|0)<=0)return;m=d+16|0;h=d+24|0;o=d+36|0;i=d+48|0;j=d+56|0;k=d+72|0;s=d+76|0;r=0;do{q=wNa(+n[m>>2]+ +n[d>>2]*+(b[a+r>>0]|0))|0;p=r|1;l=wNa(+n[o>>2]+ +n[h>>2]*+(b[a+p>>0]|0))|0;b[c+r>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;b[c+p>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;l=r|2;p=wNa(+n[j>>2]+ +n[i>>2]*+(b[a+l>>0]|0))|0;q=r|3;t=wNa(+n[s>>2]+ +n[k>>2]*+(b[a+q>>0]|0))|0;b[c+l>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;b[c+q>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;r=r+4|0}while((r|0)<(g|0));return}default:{if((e|0)<=0)return;g=f+1|0;if((f|0)>0){u=c;v=a;w=0}else return;while(1){a=d;c=0;while(1){r=wNa(+(b[v+c>>0]|0)*+n[a+(c<<2)>>2]+ +n[a+(f<<2)>>2])|0;b[u+c>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;c=c+1|0;if((c|0)==(f|0))break;else a=a+(g<<2)|0}w=w+1|0;if((w|0)==(e|0))break;else{u=u+f|0;v=v+f|0}}return}}}function nO(a,b,c,e,f,g){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,k=0.0,l=0.0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0,y=0,z=0;switch(f|0){case 2:{g=e<<1;if((e|0)<=0)return;h=+n[c>>2];i=+n[c+8>>2];k=+n[c+16>>2];l=+n[c+20>>2];m=0;do{o=wNa(i+h*+(j[a+(m<<1)>>1]|0))|0;p=m|1;q=wNa(l+k*+(j[a+(p<<1)>>1]|0))|0;d[b+(m<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;d[b+(p<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;m=m+2|0}while((m|0)<(g|0));return}case 3:{g=e*3|0;if((e|0)<=0)return;k=+n[c>>2];l=+n[c+12>>2];h=+n[c+20>>2];i=+n[c+28>>2];r=+n[c+40>>2];s=+n[c+44>>2];m=0;do{q=wNa(l+k*+(j[a+(m<<1)>>1]|0))|0;p=m+1|0;o=wNa(i+h*+(j[a+(p<<1)>>1]|0))|0;t=m+2|0;u=wNa(s+r*+(j[a+(t<<1)>>1]|0))|0;d[b+(m<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;d[b+(p<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;d[b+(t<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;m=m+3|0}while((m|0)<(g|0));return}case 4:{g=e<<2;if((e|0)<=0)return;r=+n[c>>2];s=+n[c+16>>2];h=+n[c+24>>2];i=+n[c+36>>2];k=+n[c+48>>2];l=+n[c+56>>2];v=+n[c+72>>2];w=+n[c+76>>2];m=0;do{u=wNa(s+r*+(j[a+(m<<1)>>1]|0))|0;t=m|1;o=wNa(i+h*+(j[a+(t<<1)>>1]|0))|0;d[b+(m<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[b+(t<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;o=m|2;t=wNa(l+k*+(j[a+(o<<1)>>1]|0))|0;u=m|3;p=wNa(w+v*+(j[a+(u<<1)>>1]|0))|0;d[b+(o<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;d[b+(u<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;m=m+4|0}while((m|0)<(g|0));return}default:{if((e|0)<=0)return;g=f+1|0;if((f|0)>0){x=b;y=a;z=0}else return;while(1){a=c;b=0;while(1){m=wNa(+(j[y+(b<<1)>>1]|0)*+n[a+(b<<2)>>2]+ +n[a+(f<<2)>>2])|0;d[x+(b<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;b=b+1|0;if((b|0)==(f|0))break;else a=a+(g<<2)|0}z=z+1|0;if((z|0)==(e|0))break;else{x=x+(f<<1)|0;y=y+(f<<1)|0}}return}}}function oO(a,b,c,e,f,g){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,j=0.0,k=0.0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0;switch(f|0){case 2:{g=e<<1;if((e|0)<=0)return;h=+n[c>>2];i=+n[c+8>>2];j=+n[c+16>>2];k=+n[c+20>>2];l=0;do{m=wNa(i+h*+(d[a+(l<<1)>>1]|0))|0;o=l|1;p=wNa(k+j*+(d[a+(o<<1)>>1]|0))|0;d[b+(l<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;d[b+(o<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;l=l+2|0}while((l|0)<(g|0));return}case 3:{g=e*3|0;if((e|0)<=0)return;j=+n[c>>2];k=+n[c+12>>2];h=+n[c+20>>2];i=+n[c+28>>2];q=+n[c+40>>2];r=+n[c+44>>2];l=0;do{p=wNa(k+j*+(d[a+(l<<1)>>1]|0))|0;o=l+1|0;m=wNa(i+h*+(d[a+(o<<1)>>1]|0))|0;s=l+2|0;t=wNa(r+q*+(d[a+(s<<1)>>1]|0))|0;d[b+(l<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[b+(o<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;d[b+(s<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;l=l+3|0}while((l|0)<(g|0));return}case 4:{g=e<<2;if((e|0)<=0)return;q=+n[c>>2];r=+n[c+16>>2];h=+n[c+24>>2];i=+n[c+36>>2];j=+n[c+48>>2];k=+n[c+56>>2];u=+n[c+72>>2];v=+n[c+76>>2];l=0;do{t=wNa(r+q*+(d[a+(l<<1)>>1]|0))|0;s=l|1;m=wNa(i+h*+(d[a+(s<<1)>>1]|0))|0;d[b+(l<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;d[b+(s<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;m=l|2;s=wNa(k+j*+(d[a+(m<<1)>>1]|0))|0;t=l|3;o=wNa(v+u*+(d[a+(t<<1)>>1]|0))|0;d[b+(m<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;d[b+(t<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;l=l+4|0}while((l|0)<(g|0));return}default:{if((e|0)<=0)return;g=f+1|0;if((f|0)>0){w=b;x=a;y=0}else return;while(1){a=c;b=0;while(1){l=wNa(+(d[x+(b<<1)>>1]|0)*+n[a+(b<<2)>>2]+ +n[a+(f<<2)>>2])|0;d[w+(b<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;b=b+1|0;if((b|0)==(f|0))break;else a=a+(g<<2)|0}y=y+1|0;if((y|0)==(e|0))break;else{w=w+(f<<1)|0;x=x+(f<<1)|0}}return}}}function pO(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0.0,i=0.0,j=0.0,k=0.0,l=0,m=0,n=0,o=0,q=0.0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0;switch(e|0){case 2:{g=d<<1;if((d|0)<=0)return;h=+p[c>>3];i=+p[c+16>>3];j=+p[c+32>>3];k=+p[c+40>>3];l=0;do{m=rNa(i+h*+(f[a+(l<<2)>>2]|0))|0;n=l|1;o=rNa(k+j*+(f[a+(n<<2)>>2]|0))|0;f[b+(l<<2)>>2]=m;f[b+(n<<2)>>2]=o;l=l+2|0}while((l|0)<(g|0));return}case 3:{g=d*3|0;if((d|0)<=0)return;j=+p[c>>3];k=+p[c+24>>3];h=+p[c+40>>3];i=+p[c+56>>3];q=+p[c+80>>3];r=+p[c+88>>3];l=0;do{o=rNa(k+j*+(f[a+(l<<2)>>2]|0))|0;n=l+1|0;m=rNa(i+h*+(f[a+(n<<2)>>2]|0))|0;s=l+2|0;t=rNa(r+q*+(f[a+(s<<2)>>2]|0))|0;f[b+(l<<2)>>2]=o;f[b+(n<<2)>>2]=m;f[b+(s<<2)>>2]=t;l=l+3|0}while((l|0)<(g|0));return}case 4:{g=d<<2;if((d|0)<=0)return;q=+p[c>>3];r=+p[c+32>>3];h=+p[c+48>>3];i=+p[c+72>>3];j=+p[c+96>>3];k=+p[c+112>>3];u=+p[c+144>>3];v=+p[c+152>>3];l=0;do{t=rNa(r+q*+(f[a+(l<<2)>>2]|0))|0;s=l|1;m=rNa(i+h*+(f[a+(s<<2)>>2]|0))|0;f[b+(l<<2)>>2]=t;f[b+(s<<2)>>2]=m;m=l|2;s=rNa(k+j*+(f[a+(m<<2)>>2]|0))|0;t=l|3;n=rNa(v+u*+(f[a+(t<<2)>>2]|0))|0;f[b+(m<<2)>>2]=s;f[b+(t<<2)>>2]=n;l=l+4|0}while((l|0)<(g|0));return}default:{if((d|0)<=0)return;g=e+1|0;if((e|0)>0){w=b;x=a;y=0}else return;while(1){a=c;b=0;while(1){l=rNa(+(f[x+(b<<2)>>2]|0)*+p[a+(b<<3)>>3]+ +p[a+(e<<3)>>3])|0;f[w+(b<<2)>>2]=l;b=b+1|0;if((b|0)==(e|0))break;else a=a+(g<<3)|0}y=y+1|0;if((y|0)==(d|0))break;else{w=w+(e<<2)|0;x=x+(e<<2)|0}}return}}}function qO(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0;switch(e|0){case 2:{f=d<<1;if((d|0)<=0)return;g=c+8|0;h=c+16|0;i=c+20|0;j=0;do{k=j|1;l=+n[h>>2]*+n[a+(k<<2)>>2]+ +n[i>>2];n[b+(j<<2)>>2]=+n[c>>2]*+n[a+(j<<2)>>2]+ +n[g>>2];n[b+(k<<2)>>2]=l;j=j+2|0}while((j|0)<(f|0));return}case 3:{f=d*3|0;if((d|0)<=0)return;j=c+12|0;g=c+20|0;i=c+28|0;h=c+40|0;k=c+44|0;m=0;do{o=m+1|0;l=+n[g>>2]*+n[a+(o<<2)>>2]+ +n[i>>2];p=m+2|0;q=+n[h>>2]*+n[a+(p<<2)>>2]+ +n[k>>2];n[b+(m<<2)>>2]=+n[c>>2]*+n[a+(m<<2)>>2]+ +n[j>>2];n[b+(o<<2)>>2]=l;n[b+(p<<2)>>2]=q;m=m+3|0}while((m|0)<(f|0));return}case 4:{f=d<<2;if((d|0)<=0)return;m=c+16|0;j=c+24|0;k=c+36|0;h=c+48|0;i=c+56|0;g=c+72|0;p=c+76|0;o=0;do{r=o|1;q=+n[j>>2]*+n[a+(r<<2)>>2]+ +n[k>>2];n[b+(o<<2)>>2]=+n[c>>2]*+n[a+(o<<2)>>2]+ +n[m>>2];n[b+(r<<2)>>2]=q;r=o|2;s=o|3;q=+n[g>>2]*+n[a+(s<<2)>>2]+ +n[p>>2];n[b+(r<<2)>>2]=+n[h>>2]*+n[a+(r<<2)>>2]+ +n[i>>2];n[b+(s<<2)>>2]=q;o=o+4|0}while((o|0)<(f|0));return}default:{if((d|0)<=0)return;f=e+1|0;if((e|0)>0){t=b;u=a;v=0}else return;while(1){a=c;b=0;while(1){n[t+(b<<2)>>2]=+n[u+(b<<2)>>2]*+n[a+(b<<2)>>2]+ +n[a+(e<<2)>>2];b=b+1|0;if((b|0)==(e|0))break;else a=a+(f<<2)|0}v=v+1|0;if((v|0)==(d|0))break;else{t=t+(e<<2)|0;u=u+(e<<2)|0}}return}}}function rO(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,q=0.0,r=0,s=0,t=0,u=0,v=0;switch(e|0){case 2:{f=d<<1;if((d|0)<=0)return;g=c+16|0;h=c+32|0;i=c+40|0;j=0;do{k=j|1;l=+p[h>>3]*+p[a+(k<<3)>>3]+ +p[i>>3];p[b+(j<<3)>>3]=+p[c>>3]*+p[a+(j<<3)>>3]+ +p[g>>3];p[b+(k<<3)>>3]=l;j=j+2|0}while((j|0)<(f|0));return}case 3:{f=d*3|0;if((d|0)<=0)return;j=c+24|0;g=c+40|0;i=c+56|0;h=c+80|0;k=c+88|0;m=0;do{n=m+1|0;l=+p[g>>3]*+p[a+(n<<3)>>3]+ +p[i>>3];o=m+2|0;q=+p[h>>3]*+p[a+(o<<3)>>3]+ +p[k>>3];p[b+(m<<3)>>3]=+p[c>>3]*+p[a+(m<<3)>>3]+ +p[j>>3];p[b+(n<<3)>>3]=l;p[b+(o<<3)>>3]=q;m=m+3|0}while((m|0)<(f|0));return}case 4:{f=d<<2;if((d|0)<=0)return;m=c+32|0;j=c+48|0;k=c+72|0;h=c+96|0;i=c+112|0;g=c+144|0;o=c+152|0;n=0;do{r=n|1;q=+p[j>>3]*+p[a+(r<<3)>>3]+ +p[k>>3];p[b+(n<<3)>>3]=+p[c>>3]*+p[a+(n<<3)>>3]+ +p[m>>3];p[b+(r<<3)>>3]=q;r=n|2;s=n|3;q=+p[g>>3]*+p[a+(s<<3)>>3]+ +p[o>>3];p[b+(r<<3)>>3]=+p[h>>3]*+p[a+(r<<3)>>3]+ +p[i>>3];p[b+(s<<3)>>3]=q;n=n+4|0}while((n|0)<(f|0));return}default:{if((d|0)<=0)return;f=e+1|0;if((e|0)>0){t=b;u=a;v=0}else return;while(1){a=c;b=0;while(1){p[t+(b<<3)>>3]=+p[u+(b<<3)>>3]*+p[a+(b<<3)>>3]+ +p[a+(e<<3)>>3];b=b+1|0;if((b|0)==(e|0))break;else a=a+(f<<3)|0}v=v+1|0;if((v|0)==(d|0))break;else{t=t+(e<<3)|0;u=u+(e<<3)|0}}return}}}function sO(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0;if((f|0)==2&(g|0)==2){i=e<<1;if((e|0)<=0)return;j=d+4|0;k=d+8|0;l=d+12|0;m=d+16|0;o=d+20|0;p=0;do{q=+(h[a+p>>0]|0);r=p|1;s=+(h[a+r>>0]|0);t=wNa(+n[k>>2]+(q*+n[d>>2]+s*+n[j>>2]))|0;u=wNa(+n[o>>2]+(q*+n[l>>2]+s*+n[m>>2]))|0;b[c+p>>0]=t>>>0<256?t:(t|0)>0?255:0;b[c+r>>0]=u>>>0<256?u:(u|0)>0?255:0;p=p+2|0}while((p|0)<(i|0));return}i=(f|0)==3;if(i&(g|0)==3){p=e*3|0;if((e|0)<=0)return;m=d+4|0;l=d+8|0;o=d+12|0;j=d+16|0;k=d+20|0;u=d+24|0;r=d+28|0;t=d+32|0;v=d+36|0;w=d+40|0;x=d+44|0;y=0;do{s=+(h[a+y>>0]|0);z=y+1|0;q=+(h[a+z>>0]|0);A=y+2|0;B=+(h[a+A>>0]|0);C=wNa(+n[o>>2]+(s*+n[d>>2]+q*+n[m>>2]+B*+n[l>>2]))|0;D=wNa(+n[r>>2]+(s*+n[j>>2]+q*+n[k>>2]+B*+n[u>>2]))|0;E=wNa(+n[x>>2]+(s*+n[t>>2]+q*+n[v>>2]+B*+n[w>>2]))|0;b[c+y>>0]=C>>>0<256?C:(C|0)>0?255:0;b[c+z>>0]=D>>>0<256?D:(D|0)>0?255:0;b[c+A>>0]=E>>>0<256?E:(E|0)>0?255:0;y=y+3|0}while((y|0)<(p|0));return}if(i&(g|0)==1){if((e|0)<=0)return;i=d+4|0;p=d+8|0;y=d+12|0;w=a;v=0;while(1){t=wNa(+n[y>>2]+(+n[d>>2]*+(h[w>>0]|0)+ +n[i>>2]*+(h[w+1>>0]|0)+ +n[p>>2]*+(h[w+2>>0]|0)))|0;b[c+v>>0]=t>>>0<256?t:(t|0)>0?255:0;v=v+1|0;if((v|0)==(e|0))break;else w=w+3|0}return}if((f|0)==4&(g|0)==4){w=e<<2;if((e|0)<=0)return;v=d+4|0;p=d+8|0;i=d+12|0;y=d+16|0;t=d+20|0;x=d+24|0;u=d+28|0;k=d+32|0;j=d+36|0;r=d+40|0;l=d+44|0;m=d+48|0;o=d+52|0;E=d+56|0;A=d+60|0;D=d+64|0;z=d+68|0;C=d+72|0;F=d+76|0;G=0;do{B=+(h[a+G>>0]|0);H=G|1;q=+(h[a+H>>0]|0);I=G|2;s=+(h[a+I>>0]|0);J=G|3;K=+(h[a+J>>0]|0);L=wNa(+n[y>>2]+(B*+n[d>>2]+q*+n[v>>2]+s*+n[p>>2]+K*+n[i>>2]))|0;M=wNa(+n[j>>2]+(B*+n[t>>2]+q*+n[x>>2]+s*+n[u>>2]+K*+n[k>>2]))|0;b[c+G>>0]=L>>>0<256?L:(L|0)>0?255:0;b[c+H>>0]=M>>>0<256?M:(M|0)>0?255:0;M=wNa(+n[E>>2]+(B*+n[r>>2]+q*+n[l>>2]+s*+n[m>>2]+K*+n[o>>2]))|0;H=wNa(+n[F>>2]+(B*+n[A>>2]+q*+n[D>>2]+s*+n[z>>2]+K*+n[C>>2]))|0;b[c+I>>0]=M>>>0<256?M:(M|0)>0?255:0;b[c+J>>0]=H>>>0<256?H:(H|0)>0?255:0;G=G+4|0}while((G|0)<(w|0));return}if((e|0)<=0)return;w=f+1|0;if((g|0)<=0)return;if((f|0)>0){N=c;O=a;P=0}else{a=c;c=0;while(1){G=d;C=0;while(1){z=wNa(+n[G+(f<<2)>>2])|0;b[a+C>>0]=z>>>0<256?z:(z|0)>0?255:0;C=C+1|0;if((C|0)==(g|0))break;else G=G+(w<<2)|0}c=c+1|0;if((c|0)==(e|0))break;else a=a+g|0}return}while(1){a=d;c=0;while(1){G=0;K=+n[a+(f<<2)>>2];do{K=K+ +n[a+(G<<2)>>2]*+(h[O+G>>0]|0);G=G+1|0}while((G|0)!=(f|0));G=wNa(K)|0;b[N+c>>0]=G>>>0<256?G:(G|0)>0?255:0;c=c+1|0;if((c|0)==(g|0))break;else a=a+(w<<2)|0}P=P+1|0;if((P|0)==(e|0))break;else{N=N+g|0;O=O+f|0}}return}function tO(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0;if((f|0)==2&(g|0)==2){h=e<<1;if((e|0)<=0)return;i=d+4|0;j=d+8|0;k=d+12|0;l=d+16|0;m=d+20|0;o=0;do{p=+(b[a+o>>0]|0);q=o|1;r=+(b[a+q>>0]|0);s=wNa(+n[j>>2]+(p*+n[d>>2]+r*+n[i>>2]))|0;t=wNa(+n[m>>2]+(p*+n[k>>2]+r*+n[l>>2]))|0;b[c+o>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;b[c+q>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;o=o+2|0}while((o|0)<(h|0));return}h=(f|0)==3;if(h&(g|0)==3){o=e*3|0;if((e|0)<=0)return;l=d+4|0;k=d+8|0;m=d+12|0;i=d+16|0;j=d+20|0;t=d+24|0;q=d+28|0;s=d+32|0;u=d+36|0;v=d+40|0;w=d+44|0;x=0;do{r=+(b[a+x>>0]|0);y=x+1|0;p=+(b[a+y>>0]|0);z=x+2|0;A=+(b[a+z>>0]|0);B=wNa(+n[m>>2]+(r*+n[d>>2]+p*+n[l>>2]+A*+n[k>>2]))|0;C=wNa(+n[q>>2]+(r*+n[i>>2]+p*+n[j>>2]+A*+n[t>>2]))|0;D=wNa(+n[w>>2]+(r*+n[s>>2]+p*+n[u>>2]+A*+n[v>>2]))|0;b[c+x>>0]=(B+128|0)>>>0<256?B:(B|0)>0?127:128;b[c+y>>0]=(C+128|0)>>>0<256?C:(C|0)>0?127:128;b[c+z>>0]=(D+128|0)>>>0<256?D:(D|0)>0?127:128;x=x+3|0}while((x|0)<(o|0));return}if(h&(g|0)==1){if((e|0)<=0)return;h=d+4|0;o=d+8|0;x=d+12|0;v=a;u=0;while(1){s=wNa(+n[x>>2]+(+n[d>>2]*+(b[v>>0]|0)+ +n[h>>2]*+(b[v+1>>0]|0)+ +n[o>>2]*+(b[v+2>>0]|0)))|0;b[c+u>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;u=u+1|0;if((u|0)==(e|0))break;else v=v+3|0}return}if((f|0)==4&(g|0)==4){v=e<<2;if((e|0)<=0)return;u=d+4|0;o=d+8|0;h=d+12|0;x=d+16|0;s=d+20|0;w=d+24|0;t=d+28|0;j=d+32|0;i=d+36|0;q=d+40|0;k=d+44|0;l=d+48|0;m=d+52|0;D=d+56|0;z=d+60|0;C=d+64|0;y=d+68|0;B=d+72|0;E=d+76|0;F=0;do{A=+(b[a+F>>0]|0);G=F|1;p=+(b[a+G>>0]|0);H=F|2;r=+(b[a+H>>0]|0);I=F|3;J=+(b[a+I>>0]|0);K=wNa(+n[x>>2]+(A*+n[d>>2]+p*+n[u>>2]+r*+n[o>>2]+J*+n[h>>2]))|0;L=wNa(+n[i>>2]+(A*+n[s>>2]+p*+n[w>>2]+r*+n[t>>2]+J*+n[j>>2]))|0;b[c+F>>0]=(K+128|0)>>>0<256?K:(K|0)>0?127:128;b[c+G>>0]=(L+128|0)>>>0<256?L:(L|0)>0?127:128;L=wNa(+n[D>>2]+(A*+n[q>>2]+p*+n[k>>2]+r*+n[l>>2]+J*+n[m>>2]))|0;G=wNa(+n[E>>2]+(A*+n[z>>2]+p*+n[C>>2]+r*+n[y>>2]+J*+n[B>>2]))|0;b[c+H>>0]=(L+128|0)>>>0<256?L:(L|0)>0?127:128;b[c+I>>0]=(G+128|0)>>>0<256?G:(G|0)>0?127:128;F=F+4|0}while((F|0)<(v|0));return}if((e|0)<=0)return;v=f+1|0;if((g|0)<=0)return;if((f|0)>0){M=c;N=a;O=0}else{a=c;c=0;while(1){F=d;B=0;while(1){y=wNa(+n[F+(f<<2)>>2])|0;b[a+B>>0]=(y+128|0)>>>0<256?y:(y|0)>0?127:128;B=B+1|0;if((B|0)==(g|0))break;else F=F+(v<<2)|0}c=c+1|0;if((c|0)==(e|0))break;else a=a+g|0}return}while(1){a=d;c=0;while(1){F=0;J=+n[a+(f<<2)>>2];do{J=J+ +n[a+(F<<2)>>2]*+(b[N+F>>0]|0);F=F+1|0}while((F|0)!=(f|0));F=wNa(J)|0;b[M+c>>0]=(F+128|0)>>>0<256?F:(F|0)>0?127:128;c=c+1|0;if((c|0)==(g|0))break;else a=a+(v<<2)|0}O=O+1|0;if((O|0)==(e|0))break;else{M=M+g|0;N=N+f|0}}return}function uO(a,b,c,e,f,g){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0;if((f|0)==2&(g|0)==2){h=e<<1;if((e|0)<=0)return;i=+n[c>>2];k=+n[c+4>>2];l=+n[c+8>>2];m=+n[c+12>>2];o=+n[c+16>>2];p=+n[c+20>>2];q=0;do{r=+(j[a+(q<<1)>>1]|0);s=q|1;t=+(j[a+(s<<1)>>1]|0);u=wNa(l+(i*r+k*t))|0;v=wNa(p+(m*r+o*t))|0;d[b+(q<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[b+(s<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;q=q+2|0}while((q|0)<(h|0));return}h=(f|0)==3;if(h&(g|0)==3){q=e*3|0;if((e|0)<=0)return;o=+n[c>>2];m=+n[c+4>>2];p=+n[c+8>>2];k=+n[c+12>>2];i=+n[c+16>>2];l=+n[c+20>>2];t=+n[c+24>>2];r=+n[c+28>>2];w=+n[c+32>>2];x=+n[c+36>>2];y=+n[c+40>>2];z=+n[c+44>>2];v=0;do{A=+(j[a+(v<<1)>>1]|0);s=v+1|0;B=+(j[a+(s<<1)>>1]|0);u=v+2|0;C=+(j[a+(u<<1)>>1]|0);D=wNa(k+(o*A+m*B+p*C))|0;E=wNa(r+(i*A+l*B+t*C))|0;F=wNa(z+(w*A+x*B+y*C))|0;d[b+(v<<1)>>1]=D>>>0<65536?D:(D|0)>0?65535:0;d[b+(s<<1)>>1]=E>>>0<65536?E:(E|0)>0?65535:0;d[b+(u<<1)>>1]=F>>>0<65536?F:(F|0)>0?65535:0;v=v+3|0}while((v|0)<(q|0));return}if(h&(g|0)==1){if((e|0)<=0)return;y=+n[c>>2];x=+n[c+4>>2];w=+n[c+8>>2];z=+n[c+12>>2];h=a;q=0;while(1){v=wNa(z+(y*+(j[h>>1]|0)+x*+(j[h+2>>1]|0)+w*+(j[h+4>>1]|0)))|0;d[b+(q<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;q=q+1|0;if((q|0)==(e|0))break;else h=h+6|0}return}if((f|0)==4&(g|0)==4){h=e<<2;if((e|0)<=0)return;w=+n[c>>2];x=+n[c+4>>2];y=+n[c+8>>2];z=+n[c+12>>2];t=+n[c+16>>2];l=+n[c+20>>2];i=+n[c+24>>2];r=+n[c+28>>2];p=+n[c+32>>2];m=+n[c+36>>2];o=+n[c+40>>2];k=+n[c+44>>2];C=+n[c+48>>2];B=+n[c+52>>2];A=+n[c+56>>2];G=+n[c+60>>2];H=+n[c+64>>2];I=+n[c+68>>2];J=+n[c+72>>2];K=+n[c+76>>2];q=0;do{L=+(j[a+(q<<1)>>1]|0);v=q|1;M=+(j[a+(v<<1)>>1]|0);F=q|2;N=+(j[a+(F<<1)>>1]|0);u=q|3;O=+(j[a+(u<<1)>>1]|0);E=wNa(t+(w*L+x*M+y*N+z*O))|0;s=wNa(m+(l*L+i*M+r*N+p*O))|0;d[b+(q<<1)>>1]=E>>>0<65536?E:(E|0)>0?65535:0;d[b+(v<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;s=wNa(A+(o*L+k*M+C*N+B*O))|0;v=wNa(K+(G*L+H*M+I*N+J*O))|0;d[b+(F<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;d[b+(u<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;q=q+4|0}while((q|0)<(h|0));return}if((e|0)<=0)return;h=f+1|0;if((g|0)<=0)return;if((f|0)>0){P=b;Q=a;R=0}else{a=b;b=0;while(1){q=c;v=0;while(1){u=wNa(+n[q+(f<<2)>>2])|0;d[a+(v<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;v=v+1|0;if((v|0)==(g|0))break;else q=q+(h<<2)|0}b=b+1|0;if((b|0)==(e|0))break;else a=a+(g<<1)|0}return}while(1){a=c;b=0;while(1){q=0;J=+n[a+(f<<2)>>2];do{J=J+ +n[a+(q<<2)>>2]*+(j[Q+(q<<1)>>1]|0);q=q+1|0}while((q|0)!=(f|0));q=wNa(J)|0;d[P+(b<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;b=b+1|0;if((b|0)==(g|0))break;else a=a+(h<<2)|0}R=R+1|0;if((R|0)==(e|0))break;else{P=P+(g<<1)|0;Q=Q+(f<<1)|0}}return}function vO(a,b,c,e,f,g){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0;if((f|0)==2&(g|0)==2){h=e<<1;if((e|0)<=0)return;i=+n[c>>2];j=+n[c+4>>2];k=+n[c+8>>2];l=+n[c+12>>2];m=+n[c+16>>2];o=+n[c+20>>2];p=0;do{q=+(d[a+(p<<1)>>1]|0);r=p|1;s=+(d[a+(r<<1)>>1]|0);t=wNa(k+(i*q+j*s))|0;u=wNa(o+(l*q+m*s))|0;d[b+(p<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;d[b+(r<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;p=p+2|0}while((p|0)<(h|0));return}h=(f|0)==3;if(h&(g|0)==3){p=e*3|0;if((e|0)<=0)return;m=+n[c>>2];l=+n[c+4>>2];o=+n[c+8>>2];j=+n[c+12>>2];i=+n[c+16>>2];k=+n[c+20>>2];s=+n[c+24>>2];q=+n[c+28>>2];v=+n[c+32>>2];w=+n[c+36>>2];x=+n[c+40>>2];y=+n[c+44>>2];u=0;do{z=+(d[a+(u<<1)>>1]|0);r=u+1|0;A=+(d[a+(r<<1)>>1]|0);t=u+2|0;B=+(d[a+(t<<1)>>1]|0);C=wNa(j+(m*z+l*A+o*B))|0;D=wNa(q+(i*z+k*A+s*B))|0;E=wNa(y+(v*z+w*A+x*B))|0;d[b+(u<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;d[b+(r<<1)>>1]=(D+32768|0)>>>0<65536?D:(D|0)>0?32767:32768;d[b+(t<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;u=u+3|0}while((u|0)<(p|0));return}if(h&(g|0)==1){if((e|0)<=0)return;x=+n[c>>2];w=+n[c+4>>2];v=+n[c+8>>2];y=+n[c+12>>2];h=a;p=0;while(1){u=wNa(y+(x*+(d[h>>1]|0)+w*+(d[h+2>>1]|0)+v*+(d[h+4>>1]|0)))|0;d[b+(p<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;p=p+1|0;if((p|0)==(e|0))break;else h=h+6|0}return}if((f|0)==4&(g|0)==4){h=e<<2;if((e|0)<=0)return;v=+n[c>>2];w=+n[c+4>>2];x=+n[c+8>>2];y=+n[c+12>>2];s=+n[c+16>>2];k=+n[c+20>>2];i=+n[c+24>>2];q=+n[c+28>>2];o=+n[c+32>>2];l=+n[c+36>>2];m=+n[c+40>>2];j=+n[c+44>>2];B=+n[c+48>>2];A=+n[c+52>>2];z=+n[c+56>>2];F=+n[c+60>>2];G=+n[c+64>>2];H=+n[c+68>>2];I=+n[c+72>>2];J=+n[c+76>>2];p=0;do{K=+(d[a+(p<<1)>>1]|0);u=p|1;L=+(d[a+(u<<1)>>1]|0);E=p|2;M=+(d[a+(E<<1)>>1]|0);t=p|3;N=+(d[a+(t<<1)>>1]|0);D=wNa(s+(v*K+w*L+x*M+y*N))|0;r=wNa(l+(k*K+i*L+q*M+o*N))|0;d[b+(p<<1)>>1]=(D+32768|0)>>>0<65536?D:(D|0)>0?32767:32768;d[b+(u<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;r=wNa(z+(m*K+j*L+B*M+A*N))|0;u=wNa(J+(F*K+G*L+H*M+I*N))|0;d[b+(E<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;d[b+(t<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;p=p+4|0}while((p|0)<(h|0));return}if((e|0)<=0)return;h=f+1|0;if((g|0)<=0)return;if((f|0)>0){O=b;P=a;Q=0}else{a=b;b=0;while(1){p=c;u=0;while(1){t=wNa(+n[p+(f<<2)>>2])|0;d[a+(u<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;u=u+1|0;if((u|0)==(g|0))break;else p=p+(h<<2)|0}b=b+1|0;if((b|0)==(e|0))break;else a=a+(g<<1)|0}return}while(1){a=c;b=0;while(1){p=0;I=+n[a+(f<<2)>>2];do{I=I+ +n[a+(p<<2)>>2]*+(d[P+(p<<1)>>1]|0);p=p+1|0}while((p|0)!=(f|0));p=wNa(I)|0;d[O+(b<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;b=b+1|0;if((b|0)==(g|0))break;else a=a+(h<<2)|0}Q=Q+1|0;if((Q|0)==(e|0))break;else{O=O+(g<<1)|0;P=P+(f<<1)|0}}return}function wO(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0;if((e|0)==2&(g|0)==2){h=d<<1;if((d|0)<=0)return;i=+p[c>>3];j=+p[c+8>>3];k=+p[c+16>>3];l=+p[c+24>>3];m=+p[c+32>>3];n=+p[c+40>>3];o=0;do{q=+(f[a+(o<<2)>>2]|0);r=o|1;s=+(f[a+(r<<2)>>2]|0);t=rNa(k+(i*q+j*s))|0;u=rNa(n+(l*q+m*s))|0;f[b+(o<<2)>>2]=t;f[b+(r<<2)>>2]=u;o=o+2|0}while((o|0)<(h|0));return}h=(e|0)==3;if(h&(g|0)==3){o=d*3|0;if((d|0)<=0)return;m=+p[c>>3];l=+p[c+8>>3];n=+p[c+16>>3];j=+p[c+24>>3];i=+p[c+32>>3];k=+p[c+40>>3];s=+p[c+48>>3];q=+p[c+56>>3];v=+p[c+64>>3];w=+p[c+72>>3];x=+p[c+80>>3];y=+p[c+88>>3];u=0;do{z=+(f[a+(u<<2)>>2]|0);r=u+1|0;A=+(f[a+(r<<2)>>2]|0);t=u+2|0;B=+(f[a+(t<<2)>>2]|0);C=rNa(j+(m*z+l*A+n*B))|0;D=rNa(q+(i*z+k*A+s*B))|0;E=rNa(y+(v*z+w*A+x*B))|0;f[b+(u<<2)>>2]=C;f[b+(r<<2)>>2]=D;f[b+(t<<2)>>2]=E;u=u+3|0}while((u|0)<(o|0));return}if(h&(g|0)==1){if((d|0)<=0)return;x=+p[c>>3];w=+p[c+8>>3];v=+p[c+16>>3];y=+p[c+24>>3];h=a;o=0;while(1){u=rNa(y+(x*+(f[h>>2]|0)+w*+(f[h+4>>2]|0)+v*+(f[h+8>>2]|0)))|0;f[b+(o<<2)>>2]=u;o=o+1|0;if((o|0)==(d|0))break;else h=h+12|0}return}if((e|0)==4&(g|0)==4){h=d<<2;if((d|0)<=0)return;v=+p[c>>3];w=+p[c+8>>3];x=+p[c+16>>3];y=+p[c+24>>3];s=+p[c+32>>3];k=+p[c+40>>3];i=+p[c+48>>3];q=+p[c+56>>3];n=+p[c+64>>3];l=+p[c+72>>3];m=+p[c+80>>3];j=+p[c+88>>3];B=+p[c+96>>3];A=+p[c+104>>3];z=+p[c+112>>3];F=+p[c+120>>3];G=+p[c+128>>3];H=+p[c+136>>3];I=+p[c+144>>3];J=+p[c+152>>3];o=0;do{K=+(f[a+(o<<2)>>2]|0);u=o|1;L=+(f[a+(u<<2)>>2]|0);E=o|2;M=+(f[a+(E<<2)>>2]|0);t=o|3;N=+(f[a+(t<<2)>>2]|0);D=rNa(s+(v*K+w*L+x*M+y*N))|0;r=rNa(l+(k*K+i*L+q*M+n*N))|0;f[b+(o<<2)>>2]=D;f[b+(u<<2)>>2]=r;r=rNa(z+(m*K+j*L+B*M+A*N))|0;u=rNa(J+(F*K+G*L+H*M+I*N))|0;f[b+(E<<2)>>2]=r;f[b+(t<<2)>>2]=u;o=o+4|0}while((o|0)<(h|0));return}if((d|0)<=0)return;h=e+1|0;if((g|0)<=0)return;if((e|0)>0){O=b;P=a;Q=0}else{a=b;b=0;while(1){o=c;u=0;while(1){t=rNa(+p[o+(e<<3)>>3])|0;f[a+(u<<2)>>2]=t;u=u+1|0;if((u|0)==(g|0))break;else o=o+(h<<3)|0}b=b+1|0;if((b|0)==(d|0))break;else a=a+(g<<2)|0}return}while(1){a=c;b=0;while(1){o=0;I=+p[a+(e<<3)>>3];do{I=I+ +p[a+(o<<3)>>3]*+(f[P+(o<<2)>>2]|0);o=o+1|0}while((o|0)!=(e|0));o=rNa(I)|0;f[O+(b<<2)>>2]=o;b=b+1|0;if((b|0)==(g|0))break;else a=a+(h<<3)|0}Q=Q+1|0;if((Q|0)==(d|0))break;else{O=O+(g<<2)|0;P=P+(e<<2)|0}}return}function xO(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;if((e|0)==2&(g|0)==2){h=d<<1;if((d|0)<=0)return;i=c+4|0;j=c+8|0;k=c+12|0;l=c+16|0;m=c+20|0;o=0;do{p=+n[a+(o<<2)>>2];q=o|1;r=+n[a+(q<<2)>>2];s=+n[m>>2]+(p*+n[k>>2]+r*+n[l>>2]);n[b+(o<<2)>>2]=+n[j>>2]+(p*+n[c>>2]+r*+n[i>>2]);n[b+(q<<2)>>2]=s;o=o+2|0}while((o|0)<(h|0));return}h=(e|0)==3;if(h&(g|0)==3){o=d*3|0;if((d|0)<=0)return;i=c+4|0;j=c+8|0;l=c+12|0;k=c+16|0;m=c+20|0;q=c+24|0;t=c+28|0;u=c+32|0;v=c+36|0;w=c+40|0;x=c+44|0;y=0;do{s=+n[a+(y<<2)>>2];z=y+1|0;r=+n[a+(z<<2)>>2];A=y+2|0;p=+n[a+(A<<2)>>2];B=+n[t>>2]+(s*+n[k>>2]+r*+n[m>>2]+p*+n[q>>2]);C=+n[x>>2]+(s*+n[u>>2]+r*+n[v>>2]+p*+n[w>>2]);n[b+(y<<2)>>2]=+n[l>>2]+(s*+n[c>>2]+r*+n[i>>2]+p*+n[j>>2]);n[b+(z<<2)>>2]=B;n[b+(A<<2)>>2]=C;y=y+3|0}while((y|0)<(o|0));return}if(h&(g|0)==1){if((d|0)<=0)return;h=c+4|0;o=c+8|0;y=c+12|0;j=a;i=0;while(1){n[b+(i<<2)>>2]=+n[y>>2]+(+n[c>>2]*+n[j>>2]+ +n[h>>2]*+n[j+4>>2]+ +n[o>>2]*+n[j+8>>2]);i=i+1|0;if((i|0)==(d|0))break;else j=j+12|0}return}if((e|0)==4&(g|0)==4){j=d<<2;if((d|0)<=0)return;i=c+4|0;o=c+8|0;h=c+12|0;y=c+16|0;l=c+20|0;w=c+24|0;v=c+28|0;u=c+32|0;x=c+36|0;q=c+40|0;m=c+44|0;k=c+48|0;t=c+52|0;A=c+56|0;z=c+60|0;D=c+64|0;E=c+68|0;F=c+72|0;G=c+76|0;H=0;do{C=+n[a+(H<<2)>>2];I=H|1;B=+n[a+(I<<2)>>2];J=H|2;p=+n[a+(J<<2)>>2];K=H|3;r=+n[a+(K<<2)>>2];s=+n[x>>2]+(C*+n[l>>2]+B*+n[w>>2]+p*+n[v>>2]+r*+n[u>>2]);n[b+(H<<2)>>2]=+n[y>>2]+(C*+n[c>>2]+B*+n[i>>2]+p*+n[o>>2]+r*+n[h>>2]);n[b+(I<<2)>>2]=s;s=+n[G>>2]+(C*+n[z>>2]+B*+n[D>>2]+p*+n[E>>2]+r*+n[F>>2]);n[b+(J<<2)>>2]=+n[A>>2]+(C*+n[q>>2]+B*+n[m>>2]+p*+n[k>>2]+r*+n[t>>2]);n[b+(K<<2)>>2]=s;H=H+4|0}while((H|0)<(j|0));return}if((d|0)<=0)return;j=e+1|0;if((g|0)<=0)return;if((e|0)>0){L=b;M=a;N=0}else{a=b;b=0;while(1){H=c;t=0;while(1){f[a+(t<<2)>>2]=f[H+(e<<2)>>2];t=t+1|0;if((t|0)==(g|0))break;else H=H+(j<<2)|0}b=b+1|0;if((b|0)==(d|0))break;else a=a+(g<<2)|0}return}while(1){a=c;b=0;while(1){H=0;s=+n[a+(e<<2)>>2];do{s=s+ +n[a+(H<<2)>>2]*+n[M+(H<<2)>>2];H=H+1|0}while((H|0)!=(e|0));n[L+(b<<2)>>2]=s;b=b+1|0;if((b|0)==(g|0))break;else a=a+(j<<2)|0}N=N+1|0;if((N|0)==(d|0))break;else{L=L+(g<<2)|0;M=M+(e<<2)|0}}return}function yO(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0.0,o=0,q=0.0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;if((e|0)==2&(f|0)==2){g=d<<1;if((d|0)<=0)return;h=c+8|0;i=c+16|0;j=c+24|0;k=c+32|0;l=c+40|0;m=0;do{n=+p[a+(m<<3)>>3];o=m|1;q=+p[a+(o<<3)>>3];r=+p[l>>3]+(n*+p[j>>3]+q*+p[k>>3]);p[b+(m<<3)>>3]=+p[i>>3]+(n*+p[c>>3]+q*+p[h>>3]);p[b+(o<<3)>>3]=r;m=m+2|0}while((m|0)<(g|0));return}g=(e|0)==3;if(g&(f|0)==3){m=d*3|0;if((d|0)<=0)return;h=c+8|0;i=c+16|0;k=c+24|0;j=c+32|0;l=c+40|0;o=c+48|0;s=c+56|0;t=c+64|0;u=c+72|0;v=c+80|0;w=c+88|0;x=0;do{r=+p[a+(x<<3)>>3];y=x+1|0;q=+p[a+(y<<3)>>3];z=x+2|0;n=+p[a+(z<<3)>>3];A=+p[s>>3]+(r*+p[j>>3]+q*+p[l>>3]+n*+p[o>>3]);B=+p[w>>3]+(r*+p[t>>3]+q*+p[u>>3]+n*+p[v>>3]);p[b+(x<<3)>>3]=+p[k>>3]+(r*+p[c>>3]+q*+p[h>>3]+n*+p[i>>3]);p[b+(y<<3)>>3]=A;p[b+(z<<3)>>3]=B;x=x+3|0}while((x|0)<(m|0));return}if(g&(f|0)==1){if((d|0)<=0)return;g=c+8|0;m=c+16|0;x=c+24|0;i=a;h=0;while(1){p[b+(h<<3)>>3]=+p[x>>3]+(+p[c>>3]*+p[i>>3]+ +p[g>>3]*+p[i+8>>3]+ +p[m>>3]*+p[i+16>>3]);h=h+1|0;if((h|0)==(d|0))break;else i=i+24|0}return}if((e|0)==4&(f|0)==4){i=d<<2;if((d|0)<=0)return;h=c+8|0;m=c+16|0;g=c+24|0;x=c+32|0;k=c+40|0;v=c+48|0;u=c+56|0;t=c+64|0;w=c+72|0;o=c+80|0;l=c+88|0;j=c+96|0;s=c+104|0;z=c+112|0;y=c+120|0;C=c+128|0;D=c+136|0;E=c+144|0;F=c+152|0;G=0;do{B=+p[a+(G<<3)>>3];H=G|1;A=+p[a+(H<<3)>>3];I=G|2;n=+p[a+(I<<3)>>3];J=G|3;q=+p[a+(J<<3)>>3];r=+p[w>>3]+(B*+p[k>>3]+A*+p[v>>3]+n*+p[u>>3]+q*+p[t>>3]);p[b+(G<<3)>>3]=+p[x>>3]+(B*+p[c>>3]+A*+p[h>>3]+n*+p[m>>3]+q*+p[g>>3]);p[b+(H<<3)>>3]=r;r=+p[F>>3]+(B*+p[y>>3]+A*+p[C>>3]+n*+p[D>>3]+q*+p[E>>3]);p[b+(I<<3)>>3]=+p[z>>3]+(B*+p[o>>3]+A*+p[l>>3]+n*+p[j>>3]+q*+p[s>>3]);p[b+(J<<3)>>3]=r;G=G+4|0}while((G|0)<(i|0));return}if((d|0)<=0)return;i=e+1|0;if((f|0)<=0)return;if((e|0)>0){K=b;L=a;M=0}else{a=b;b=0;while(1){G=c;s=0;while(1){p[a+(s<<3)>>3]=+p[G+(e<<3)>>3];s=s+1|0;if((s|0)==(f|0))break;else G=G+(i<<3)|0}b=b+1|0;if((b|0)==(d|0))break;else a=a+(f<<3)|0}return}while(1){a=c;b=0;while(1){G=0;r=+p[a+(e<<3)>>3];do{r=r+ +p[a+(G<<3)>>3]*+p[L+(G<<3)>>3];G=G+1|0}while((G|0)!=(e|0));p[K+(b<<3)>>3]=r;b=b+1|0;if((b|0)==(f|0))break;else a=a+(i<<3)|0}M=M+1|0;if((M|0)==(d|0))break;else{K=K+(f<<3)|0;L=L+(e<<3)|0}}return}
function oG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;BG(a,b,c,d,e,f,g,h);return}function pG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;AG(a,b,c,d,e,f,g,h);return}function qG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;zG(a,b,c,d,e,f,g,h);return}function rG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;yG(a,b,c,d,e,f,g,h);return}function sG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;xG(a,b,c,d,e,f,g,h);return}function tG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;wG(a,b,c,d,e,f,g,h);return}function uG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;vG(a,b,c,d,e,f,g,h);return}function vG(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0.0,r=0.0,s=0.0,t=0.0;i=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){j=(g|0)>0;k=i;l=e;m=a;n=c;while(1){if(j){o=0;do{q=+p[m+(o<<3)>>3];r=+p[n+(o<<3)>>3];p[l+(o<<3)>>3]=q<r?r:q;o=o+1|0}while((o|0)!=(g|0))}if(!k)break;else{k=k+-1|0;l=l+f|0;m=m+b|0;n=n+d|0}}return}n=g&-4;m=(n|0)<(g|0);l=i;i=e;e=a;a=c;while(1){c=0;do{q=+p[e+(c<<3)>>3];r=+p[a+(c<<3)>>3];k=c|1;s=+p[e+(k<<3)>>3];t=+p[a+(k<<3)>>3];p[i+(c<<3)>>3]=q<r?r:q;p[i+(k<<3)>>3]=s<t?t:s;k=c|2;s=+p[e+(k<<3)>>3];t=+p[a+(k<<3)>>3];j=c|3;q=+p[e+(j<<3)>>3];r=+p[a+(j<<3)>>3];p[i+(k<<3)>>3]=s<t?t:s;p[i+(j<<3)>>3]=q<r?r:q;c=c+4|0}while((c|0)<=(h|0));if(m){c=n;do{q=+p[e+(c<<3)>>3];r=+p[a+(c<<3)>>3];p[i+(c<<3)>>3]=q<r?r:q;c=c+1|0}while((c|0)!=(g|0))}if(!l)break;else{l=l+-1|0;i=i+f|0;e=e+b|0;a=a+d|0}}return}function wG(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0;i=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){j=(g|0)>0;k=i;l=e;m=a;o=c;while(1){if(j){p=0;do{q=+n[m+(p<<2)>>2];r=+n[o+(p<<2)>>2];n[l+(p<<2)>>2]=q<r?r:q;p=p+1|0}while((p|0)!=(g|0))}if(!k)break;else{k=k+-1|0;l=l+f|0;m=m+b|0;o=o+d|0}}return}o=g&-4;m=(o|0)<(g|0);l=i;i=e;e=a;a=c;while(1){c=0;do{q=+n[e+(c<<2)>>2];r=+n[a+(c<<2)>>2];k=c|1;s=+n[e+(k<<2)>>2];t=+n[a+(k<<2)>>2];n[i+(c<<2)>>2]=q<r?r:q;n[i+(k<<2)>>2]=s<t?t:s;k=c|2;s=+n[e+(k<<2)>>2];t=+n[a+(k<<2)>>2];j=c|3;q=+n[e+(j<<2)>>2];r=+n[a+(j<<2)>>2];n[i+(k<<2)>>2]=s<t?t:s;n[i+(j<<2)>>2]=q<r?r:q;c=c+4|0}while((c|0)<=(h|0));if(m){c=o;do{q=+n[e+(c<<2)>>2];r=+n[a+(c<<2)>>2];n[i+(c<<2)>>2]=q<r?r:q;c=c+1|0}while((c|0)!=(g|0))}if(!l)break;else{l=l+-1|0;i=i+f|0;e=e+b|0;a=a+d|0}}return}function xG(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=j;m=e;n=a;o=c;while(1){if(k){p=0;do{q=f[n+(p<<2)>>2]|0;r=f[o+(p<<2)>>2]|0;f[m+(p<<2)>>2]=(q|0)<(r|0)?r:q;p=p+1|0}while((p|0)!=(h|0))}if(!l)break;else{l=l+-1|0;m=m+g|0;n=n+b|0;o=o+d|0}}return}o=h&-4;n=(o|0)<(h|0);m=j;j=e;e=a;a=c;while(1){c=0;do{l=f[e+(c<<2)>>2]|0;k=f[a+(c<<2)>>2]|0;p=c|1;q=f[e+(p<<2)>>2]|0;r=f[a+(p<<2)>>2]|0;f[j+(c<<2)>>2]=(l|0)<(k|0)?k:l;f[j+(p<<2)>>2]=(q|0)<(r|0)?r:q;q=c|2;r=f[e+(q<<2)>>2]|0;p=f[a+(q<<2)>>2]|0;l=c|3;k=f[e+(l<<2)>>2]|0;s=f[a+(l<<2)>>2]|0;f[j+(q<<2)>>2]=(r|0)<(p|0)?p:r;f[j+(l<<2)>>2]=(k|0)<(s|0)?s:k;c=c+4|0}while((c|0)<=(i|0));if(n){c=o;do{k=f[e+(c<<2)>>2]|0;s=f[a+(c<<2)>>2]|0;f[j+(c<<2)>>2]=(k|0)<(s|0)?s:k;c=c+1|0}while((c|0)!=(h|0))}if(!m)break;else{m=m+-1|0;j=j+g|0;e=e+b|0;a=a+d|0}}return}function yG(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=j;m=f;n=a;o=c;while(1){if(k){p=0;do{q=d[n+(p<<1)>>1]|0;r=d[o+(p<<1)>>1]|0;d[m+(p<<1)>>1]=q<<16>>16<r<<16>>16?r:q;p=p+1|0}while((p|0)!=(h|0))}if(!l)break;else{l=l+-1|0;m=m+g|0;n=n+b|0;o=o+e|0}}return}o=h&-4;n=(o|0)<(h|0);m=j;j=f;f=a;a=c;while(1){c=0;do{l=d[f+(c<<1)>>1]|0;k=d[a+(c<<1)>>1]|0;p=c|1;q=d[f+(p<<1)>>1]|0;r=d[a+(p<<1)>>1]|0;d[j+(c<<1)>>1]=l<<16>>16<k<<16>>16?k:l;d[j+(p<<1)>>1]=q<<16>>16<r<<16>>16?r:q;q=c|2;r=d[f+(q<<1)>>1]|0;p=d[a+(q<<1)>>1]|0;l=c|3;k=d[f+(l<<1)>>1]|0;s=d[a+(l<<1)>>1]|0;d[j+(q<<1)>>1]=r<<16>>16<p<<16>>16?p:r;d[j+(l<<1)>>1]=k<<16>>16<s<<16>>16?s:k;c=c+4|0}while((c|0)<=(i|0));if(n){c=o;do{k=d[f+(c<<1)>>1]|0;s=d[a+(c<<1)>>1]|0;d[j+(c<<1)>>1]=k<<16>>16<s<<16>>16?s:k;c=c+1|0}while((c|0)!=(h|0))}if(!m)break;else{m=m+-1|0;j=j+g|0;f=f+b|0;a=a+e|0}}return}function zG(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=j;m=f;n=a;o=c;while(1){if(k){p=0;do{q=d[n+(p<<1)>>1]|0;r=d[o+(p<<1)>>1]|0;d[m+(p<<1)>>1]=(q&65535)<(r&65535)?r:q;p=p+1|0}while((p|0)!=(h|0))}if(!l)break;else{l=l+-1|0;m=m+g|0;n=n+b|0;o=o+e|0}}return}o=h&-4;n=(o|0)<(h|0);m=j;j=f;f=a;a=c;while(1){c=0;do{l=d[f+(c<<1)>>1]|0;k=d[a+(c<<1)>>1]|0;p=c|1;q=d[f+(p<<1)>>1]|0;r=d[a+(p<<1)>>1]|0;d[j+(c<<1)>>1]=(l&65535)<(k&65535)?k:l;d[j+(p<<1)>>1]=(q&65535)<(r&65535)?r:q;q=c|2;r=d[f+(q<<1)>>1]|0;p=d[a+(q<<1)>>1]|0;l=c|3;k=d[f+(l<<1)>>1]|0;s=d[a+(l<<1)>>1]|0;d[j+(q<<1)>>1]=(r&65535)<(p&65535)?p:r;d[j+(l<<1)>>1]=(k&65535)<(s&65535)?s:k;c=c+4|0}while((c|0)<=(i|0));if(n){c=o;do{k=d[f+(c<<1)>>1]|0;s=d[a+(c<<1)>>1]|0;d[j+(c<<1)>>1]=(k&65535)<(s&65535)?s:k;c=c+1|0}while((c|0)!=(h|0))}if(!m)break;else{m=m+-1|0;j=j+g|0;f=f+b|0;a=a+e|0}}return}function AG(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=j;m=f;n=a;o=d;while(1){if(k){p=0;do{q=b[n+p>>0]|0;r=b[o+p>>0]|0;b[m+p>>0]=q<<24>>24<r<<24>>24?r:q;p=p+1|0}while((p|0)!=(h|0))}if(!l)break;else{l=l+-1|0;m=m+g|0;n=n+c|0;o=o+e|0}}return}o=h&-4;n=(o|0)<(h|0);m=j;j=f;f=a;a=d;while(1){d=0;do{l=b[f+d>>0]|0;k=b[a+d>>0]|0;p=d|1;q=b[f+p>>0]|0;r=b[a+p>>0]|0;b[j+d>>0]=l<<24>>24<k<<24>>24?k:l;b[j+p>>0]=q<<24>>24<r<<24>>24?r:q;q=d|2;r=b[f+q>>0]|0;p=b[a+q>>0]|0;l=d|3;k=b[f+l>>0]|0;s=b[a+l>>0]|0;b[j+q>>0]=r<<24>>24<p<<24>>24?p:r;b[j+l>>0]=k<<24>>24<s<<24>>24?s:k;d=d+4|0}while((d|0)<=(i|0));if(n){d=o;do{k=b[f+d>>0]|0;s=b[a+d>>0]|0;b[j+d>>0]=k<<24>>24<s<<24>>24?s:k;d=d+1|0}while((d|0)!=(h|0))}if(!m)break;else{m=m+-1|0;j=j+g|0;f=f+c|0;a=a+e|0}}return}function BG(a,c,d,e,f,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){l=(i|0)>0;m=k;n=f;o=a;p=d;while(1){if(l){q=0;do{r=h[o+q>>0]|0;b[n+q>>0]=(h[199495+(256-r+(h[p+q>>0]|0))>>0]|0)+r;q=q+1|0}while((q|0)!=(i|0))}if(!m)break;else{m=m+-1|0;n=n+g|0;o=o+c|0;p=p+e|0}}return}p=i&-4;o=(p|0)<(i|0);n=k;k=f;f=a;a=d;while(1){d=0;do{m=h[f+d>>0]|0;l=d|1;q=h[f+l>>0]|0;r=(h[199495+(256-q+(h[a+l>>0]|0))>>0]|0)+q&255;b[k+d>>0]=(h[199495+(256-m+(h[a+d>>0]|0))>>0]|0)+m;b[k+l>>0]=r;r=d|2;l=h[f+r>>0]|0;m=d|3;q=h[f+m>>0]|0;s=(h[199495+(256-q+(h[a+m>>0]|0))>>0]|0)+q&255;b[k+r>>0]=(h[199495+(256-l+(h[a+r>>0]|0))>>0]|0)+l;b[k+m>>0]=s;d=d+4|0}while((d|0)<=(j|0));if(o){d=p;do{s=h[f+d>>0]|0;b[k+d>>0]=(h[199495+(256-s+(h[a+d>>0]|0))>>0]|0)+s;d=d+1|0}while((d|0)!=(i|0))}if(!n)break;else{n=n+-1|0;k=k+g|0;f=f+c|0;a=a+e|0}}return}function CG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_$(e,30340);dG(a,b,c,fT()|0,30360,0,13);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function DG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;QG(a,b,c,d,e,f,g,h);return}function EG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;PG(a,b,c,d,e,f,g,h);return}function FG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;OG(a,b,c,d,e,f,g,h);return}function GG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;NG(a,b,c,d,e,f,g,h);return}function HG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;MG(a,b,c,d,e,f,g,h);return}function IG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;LG(a,b,c,d,e,f,g,h);return}function JG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;KG(a,b,c,d,e,f,g,h);return}function KG(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0.0,r=0.0,s=0.0,t=0.0;i=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){j=(g|0)>0;k=i;l=e;m=a;n=c;while(1){if(j){o=0;do{q=+p[m+(o<<3)>>3];r=+p[n+(o<<3)>>3];p[l+(o<<3)>>3]=r<q?r:q;o=o+1|0}while((o|0)!=(g|0))}if(!k)break;else{k=k+-1|0;l=l+f|0;m=m+b|0;n=n+d|0}}return}n=g&-4;m=(n|0)<(g|0);l=i;i=e;e=a;a=c;while(1){c=0;do{q=+p[e+(c<<3)>>3];r=+p[a+(c<<3)>>3];k=c|1;s=+p[e+(k<<3)>>3];t=+p[a+(k<<3)>>3];p[i+(c<<3)>>3]=r<q?r:q;p[i+(k<<3)>>3]=t<s?t:s;k=c|2;s=+p[e+(k<<3)>>3];t=+p[a+(k<<3)>>3];j=c|3;q=+p[e+(j<<3)>>3];r=+p[a+(j<<3)>>3];p[i+(k<<3)>>3]=t<s?t:s;p[i+(j<<3)>>3]=r<q?r:q;c=c+4|0}while((c|0)<=(h|0));if(m){c=n;do{q=+p[e+(c<<3)>>3];r=+p[a+(c<<3)>>3];p[i+(c<<3)>>3]=r<q?r:q;c=c+1|0}while((c|0)!=(g|0))}if(!l)break;else{l=l+-1|0;i=i+f|0;e=e+b|0;a=a+d|0}}return}function LG(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0;i=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){j=(g|0)>0;k=i;l=e;m=a;o=c;while(1){if(j){p=0;do{q=+n[m+(p<<2)>>2];r=+n[o+(p<<2)>>2];n[l+(p<<2)>>2]=r<q?r:q;p=p+1|0}while((p|0)!=(g|0))}if(!k)break;else{k=k+-1|0;l=l+f|0;m=m+b|0;o=o+d|0}}return}o=g&-4;m=(o|0)<(g|0);l=i;i=e;e=a;a=c;while(1){c=0;do{q=+n[e+(c<<2)>>2];r=+n[a+(c<<2)>>2];k=c|1;s=+n[e+(k<<2)>>2];t=+n[a+(k<<2)>>2];n[i+(c<<2)>>2]=r<q?r:q;n[i+(k<<2)>>2]=t<s?t:s;k=c|2;s=+n[e+(k<<2)>>2];t=+n[a+(k<<2)>>2];j=c|3;q=+n[e+(j<<2)>>2];r=+n[a+(j<<2)>>2];n[i+(k<<2)>>2]=t<s?t:s;n[i+(j<<2)>>2]=r<q?r:q;c=c+4|0}while((c|0)<=(h|0));if(m){c=o;do{q=+n[e+(c<<2)>>2];r=+n[a+(c<<2)>>2];n[i+(c<<2)>>2]=r<q?r:q;c=c+1|0}while((c|0)!=(g|0))}if(!l)break;else{l=l+-1|0;i=i+f|0;e=e+b|0;a=a+d|0}}return}function MG(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=j;m=e;n=a;o=c;while(1){if(k){p=0;do{q=f[n+(p<<2)>>2]|0;r=f[o+(p<<2)>>2]|0;f[m+(p<<2)>>2]=(r|0)<(q|0)?r:q;p=p+1|0}while((p|0)!=(h|0))}if(!l)break;else{l=l+-1|0;m=m+g|0;n=n+b|0;o=o+d|0}}return}o=h&-4;n=(o|0)<(h|0);m=j;j=e;e=a;a=c;while(1){c=0;do{l=f[e+(c<<2)>>2]|0;k=f[a+(c<<2)>>2]|0;p=c|1;q=f[e+(p<<2)>>2]|0;r=f[a+(p<<2)>>2]|0;f[j+(c<<2)>>2]=(k|0)<(l|0)?k:l;f[j+(p<<2)>>2]=(r|0)<(q|0)?r:q;q=c|2;r=f[e+(q<<2)>>2]|0;p=f[a+(q<<2)>>2]|0;l=c|3;k=f[e+(l<<2)>>2]|0;s=f[a+(l<<2)>>2]|0;f[j+(q<<2)>>2]=(p|0)<(r|0)?p:r;f[j+(l<<2)>>2]=(s|0)<(k|0)?s:k;c=c+4|0}while((c|0)<=(i|0));if(n){c=o;do{k=f[e+(c<<2)>>2]|0;s=f[a+(c<<2)>>2]|0;f[j+(c<<2)>>2]=(s|0)<(k|0)?s:k;c=c+1|0}while((c|0)!=(h|0))}if(!m)break;else{m=m+-1|0;j=j+g|0;e=e+b|0;a=a+d|0}}return}function NG(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=j;m=f;n=a;o=c;while(1){if(k){p=0;do{q=d[n+(p<<1)>>1]|0;r=d[o+(p<<1)>>1]|0;d[m+(p<<1)>>1]=r<<16>>16<q<<16>>16?r:q;p=p+1|0}while((p|0)!=(h|0))}if(!l)break;else{l=l+-1|0;m=m+g|0;n=n+b|0;o=o+e|0}}return}o=h&-4;n=(o|0)<(h|0);m=j;j=f;f=a;a=c;while(1){c=0;do{l=d[f+(c<<1)>>1]|0;k=d[a+(c<<1)>>1]|0;p=c|1;q=d[f+(p<<1)>>1]|0;r=d[a+(p<<1)>>1]|0;d[j+(c<<1)>>1]=k<<16>>16<l<<16>>16?k:l;d[j+(p<<1)>>1]=r<<16>>16<q<<16>>16?r:q;q=c|2;r=d[f+(q<<1)>>1]|0;p=d[a+(q<<1)>>1]|0;l=c|3;k=d[f+(l<<1)>>1]|0;s=d[a+(l<<1)>>1]|0;d[j+(q<<1)>>1]=p<<16>>16<r<<16>>16?p:r;d[j+(l<<1)>>1]=s<<16>>16<k<<16>>16?s:k;c=c+4|0}while((c|0)<=(i|0));if(n){c=o;do{k=d[f+(c<<1)>>1]|0;s=d[a+(c<<1)>>1]|0;d[j+(c<<1)>>1]=s<<16>>16<k<<16>>16?s:k;c=c+1|0}while((c|0)!=(h|0))}if(!m)break;else{m=m+-1|0;j=j+g|0;f=f+b|0;a=a+e|0}}return}function OG(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=j;m=f;n=a;o=c;while(1){if(k){p=0;do{q=d[n+(p<<1)>>1]|0;r=d[o+(p<<1)>>1]|0;d[m+(p<<1)>>1]=(r&65535)<(q&65535)?r:q;p=p+1|0}while((p|0)!=(h|0))}if(!l)break;else{l=l+-1|0;m=m+g|0;n=n+b|0;o=o+e|0}}return}o=h&-4;n=(o|0)<(h|0);m=j;j=f;f=a;a=c;while(1){c=0;do{l=d[f+(c<<1)>>1]|0;k=d[a+(c<<1)>>1]|0;p=c|1;q=d[f+(p<<1)>>1]|0;r=d[a+(p<<1)>>1]|0;d[j+(c<<1)>>1]=(k&65535)<(l&65535)?k:l;d[j+(p<<1)>>1]=(r&65535)<(q&65535)?r:q;q=c|2;r=d[f+(q<<1)>>1]|0;p=d[a+(q<<1)>>1]|0;l=c|3;k=d[f+(l<<1)>>1]|0;s=d[a+(l<<1)>>1]|0;d[j+(q<<1)>>1]=(p&65535)<(r&65535)?p:r;d[j+(l<<1)>>1]=(s&65535)<(k&65535)?s:k;c=c+4|0}while((c|0)<=(i|0));if(n){c=o;do{k=d[f+(c<<1)>>1]|0;s=d[a+(c<<1)>>1]|0;d[j+(c<<1)>>1]=(s&65535)<(k&65535)?s:k;c=c+1|0}while((c|0)!=(h|0))}if(!m)break;else{m=m+-1|0;j=j+g|0;f=f+b|0;a=a+e|0}}return}function PG(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=j;m=f;n=a;o=d;while(1){if(k){p=0;do{q=b[n+p>>0]|0;r=b[o+p>>0]|0;b[m+p>>0]=r<<24>>24<q<<24>>24?r:q;p=p+1|0}while((p|0)!=(h|0))}if(!l)break;else{l=l+-1|0;m=m+g|0;n=n+c|0;o=o+e|0}}return}o=h&-4;n=(o|0)<(h|0);m=j;j=f;f=a;a=d;while(1){d=0;do{l=b[f+d>>0]|0;k=b[a+d>>0]|0;p=d|1;q=b[f+p>>0]|0;r=b[a+p>>0]|0;b[j+d>>0]=k<<24>>24<l<<24>>24?k:l;b[j+p>>0]=r<<24>>24<q<<24>>24?r:q;q=d|2;r=b[f+q>>0]|0;p=b[a+q>>0]|0;l=d|3;k=b[f+l>>0]|0;s=b[a+l>>0]|0;b[j+q>>0]=p<<24>>24<r<<24>>24?p:r;b[j+l>>0]=s<<24>>24<k<<24>>24?s:k;d=d+4|0}while((d|0)<=(i|0));if(n){d=o;do{k=b[f+d>>0]|0;s=b[a+d>>0]|0;b[j+d>>0]=s<<24>>24<k<<24>>24?s:k;d=d+1|0}while((d|0)!=(h|0))}if(!m)break;else{m=m+-1|0;j=j+g|0;f=f+c|0;a=a+e|0}}return}function QG(a,c,d,e,f,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){l=(i|0)>0;m=k;n=f;o=a;p=d;while(1){if(l){q=0;do{r=h[o+q>>0]|0;b[n+q>>0]=r-(h[199495+((r|256)-(h[p+q>>0]|0))>>0]|0);q=q+1|0}while((q|0)!=(i|0))}if(!m)break;else{m=m+-1|0;n=n+g|0;o=o+c|0;p=p+e|0}}return}p=i&-4;o=(p|0)<(i|0);n=k;k=f;f=a;a=d;while(1){d=0;do{m=h[f+d>>0]|0;l=d|1;q=h[f+l>>0]|0;r=q-(h[199495+((q|256)-(h[a+l>>0]|0))>>0]|0)&255;b[k+d>>0]=m-(h[199495+((m|256)-(h[a+d>>0]|0))>>0]|0);b[k+l>>0]=r;r=d|2;l=h[f+r>>0]|0;m=d|3;q=h[f+m>>0]|0;s=q-(h[199495+((q|256)-(h[a+m>>0]|0))>>0]|0)&255;b[k+r>>0]=l-(h[199495+((l|256)-(h[a+r>>0]|0))>>0]|0);b[k+m>>0]=s;d=d+4|0}while((d|0)<=(j|0));if(o){d=p;do{s=h[f+d>>0]|0;b[k+d>>0]=s-(h[199495+((s|256)-(h[a+d>>0]|0))>>0]|0);d=d+1|0}while((d|0)!=(i|0))}if(!n)break;else{n=n+-1|0;k=k+g|0;f=f+c|0;a=a+e|0}}return}function RG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+64|0;e=d+48|0;g=d+32|0;h=d+16|0;i=d;_$(e,30392);j=g+8|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;dG(h,i,g,fT()|0,30308,0,14);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function SG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+64|0;e=d+48|0;g=d+32|0;h=d+16|0;i=d;_$(e,30412);j=g+8|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;dG(h,i,g,fT()|0,30360,0,13);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function TG(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;_$(h,30432);UG(a,b,c,d,e,30452,0,0,0);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function UG(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0.0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0;k=u;u=u+1504|0;l=k+1448|0;m=k+1440|0;n=k+1432|0;o=k+1424|0;q=k;r=k+1368|0;s=k+1232|0;t=k+1168|0;v=k+128|0;w=k+104|0;x=k+88|0;y=k+56|0;z=k+1360|0;A=k+1352|0;B=k+1344|0;C=k+1336|0;D=k+1328|0;E=k+1320|0;F=k+1312|0;G=k+1304|0;H=k+1296|0;I=k+1288|0;K=k+1224|0;L=a;M=c;N=NS(a)|0;O=NS(c)|0;P=XS(e)|0;Q=P^1;R=RR(a,-1)|0;S=R&7;T=R>>>3&511;U=T+1|0;V=RR(c,-1)|0;W=V&7;f[m>>2]=W;X=(V>>>3&511)+1|0;Z=nS(a,-1)|0;_=nS(c,-1)|0;$=(Z|0)<3;if($)QR(n,a,-1);else{f[n>>2]=0;f[n+4>>2]=0}aa=(_|0)<3;if(aa)QR(o,c,-1);else{f[o>>2]=0;f[o+4>>2]=0}if((nS(a,-1)|0)<=2?YS(a,-1)|0:0){QR(l,a,-1);ba=f[l>>2]|0;ca=(ba|0)==1;if(!ca?(f[l+4>>2]|0)!=1:0)da=0;else if(!((N|0)!=131072&(O|0)==131072)){ea=f[l+4>>2]|0;fa=(ea|0)==1;if(!((ba|0)==(X|0)&fa|ca&(fa|(ea|0)==(X|0))))if(ca&(ea|0)==4)da=X>>>0<5&(RR(a,-1)|0)==6;else da=0;else da=1}else da=0;ga=da}else ga=0;if((nS(c,-1)|0)<=2?YS(c,-1)|0:0){QR(l,c,-1);da=f[l>>2]|0;ea=(da|0)==1;if(!ea?(f[l+4>>2]|0)!=1:0)ha=0;else if(!((N|0)==131072&(O|0)!=131072)){ca=f[l+4>>2]|0;fa=(ca|0)==1;if(!((da|0)==(U|0)&fa|ea&(fa|(ca|0)==(U|0))))if(ea&(ca|0)==4)ha=U>>>0<5&(RR(c,-1)|0)==6;else ha=0;else ha=1}else ha=0;ia=ha}else ia=0;do if((N|0)==(O|0)|(T|0)==0?!((R|0)!=(V|0)|Q|aa&($&((f[n>>2]|0)==(f[o>>2]|0)?(f[n+4>>2]|0)==(f[o+4>>2]|0):0))^1):0){if(!(aT(d)|0)?(g|0)<0|(g&7|0)==(S|0):0){if(ga^ia)break}else{if(!(aT(d)|0))break;if(ga^ia|(RR(d,-1)|0)!=(R|0))break}bT(d,a,R);do if((NS(a)|0)==65536){ha=f[a+4>>2]|0;f[l>>2]=f[ha>>2];ca=l+4|0;ea=ha+4|0;f[ca>>2]=f[ea>>2];fa=l+8|0;f[fa>>2]=f[ha+8>>2];f[l+12>>2]=f[ha+12>>2];f[l+16>>2]=f[ha+16>>2];f[l+20>>2]=f[ha+20>>2];f[l+24>>2]=f[ha+24>>2];f[l+28>>2]=f[ha+28>>2];f[l+32>>2]=f[ha+32>>2];da=f[ha+36>>2]|0;f[l+36>>2]=da;f[l+40>>2]=fa;fa=l+48|0;ba=l+44|0;f[ba>>2]=fa;f[fa>>2]=0;f[l+52>>2]=0;if(da|0){fa=da+12|0;f[fa>>2]=(f[fa>>2]|0)+1}if((f[ea>>2]|0)<3){ea=f[ha+44>>2]|0;fa=f[ba>>2]|0;f[fa>>2]=f[ea>>2];f[fa+4>>2]=f[ea+4>>2];break}else{f[ca>>2]=0;BR(l,ha);break}}else OR(l,a,-1);while(0);do if((NS(c)|0)==65536){ha=f[c+4>>2]|0;f[q>>2]=f[ha>>2];ca=q+4|0;ea=ha+4|0;f[ca>>2]=f[ea>>2];fa=q+8|0;f[fa>>2]=f[ha+8>>2];f[q+12>>2]=f[ha+12>>2];f[q+16>>2]=f[ha+16>>2];f[q+20>>2]=f[ha+20>>2];f[q+24>>2]=f[ha+24>>2];f[q+28>>2]=f[ha+28>>2];f[q+32>>2]=f[ha+32>>2];ba=f[ha+36>>2]|0;f[q+36>>2]=ba;f[q+40>>2]=fa;fa=q+48|0;da=q+44|0;f[da>>2]=fa;f[fa>>2]=0;f[q+52>>2]=0;if(ba|0){fa=ba+12|0;f[fa>>2]=(f[fa>>2]|0)+1}if((f[ea>>2]|0)<3){ea=f[ha+44>>2]|0;fa=f[da>>2]|0;f[fa>>2]=f[ea>>2];f[fa+4>>2]=f[ea+4>>2];break}else{f[ca>>2]=0;BR(q,ha);break}}else OR(q,c,-1);while(0);do if((NS(d)|0)==65536){ha=f[d+4>>2]|0;f[r>>2]=f[ha>>2];ca=r+4|0;ea=ha+4|0;f[ca>>2]=f[ea>>2];fa=r+8|0;f[fa>>2]=f[ha+8>>2];f[r+12>>2]=f[ha+12>>2];f[r+16>>2]=f[ha+16>>2];f[r+20>>2]=f[ha+20>>2];f[r+24>>2]=f[ha+24>>2];f[r+28>>2]=f[ha+28>>2];f[r+32>>2]=f[ha+32>>2];da=f[ha+36>>2]|0;f[r+36>>2]=da;f[r+40>>2]=fa;fa=r+48|0;ba=r+44|0;f[ba>>2]=fa;f[fa>>2]=0;f[r+52>>2]=0;if(da|0){fa=da+12|0;f[fa>>2]=(f[fa>>2]|0)+1}if((f[ea>>2]|0)<3){ea=f[ha+44>>2]|0;fa=f[ba>>2]|0;f[fa>>2]=f[ea>>2];f[fa+4>>2]=f[ea+4>>2];ja=r;break}else{f[ca>>2]=0;BR(r,ha);ja=r;break}}else{OR(r,d,-1);ja=r}while(0);ha=f[l>>2]|0;ca=(ha>>>3&511)+1|0;ea=f[q>>2]|0;fa=f[ja>>2]|0;ba=f[l+12>>2]|0;da=f[l+8>>2]|0;ka=W1a(ba|0,((ba|0)<0)<<31>>31|0,ca|0,0)|0;la=W1a(ka|0,J|0,da|0,((da|0)<0)<<31>>31|0)|0;if((ha&16384&ea&fa|0)!=0?(la|0)==(la|0)&(((la|0)<0)<<31>>31|0)==(J|0):0){ma=la;na=1}else{ma=Y(ba,ca)|0;na=da}da=l+16|0;ca=l+44|0;ba=l+48|0;la=q+16|0;fa=q+44|0;ea=q+48|0;ha=r+16|0;ka=r+44|0;oa=r+48|0;_h[f[h+(S<<2)>>2]&127](f[da>>2]|0,f[ba>>2]|0,f[la>>2]|0,f[ea>>2]|0,f[ha>>2]|0,f[oa>>2]|0,ma,na,j);pa=r+36|0;qa=f[pa>>2]|0;if(qa|0?(ra=qa+12|0,qa=f[ra>>2]|0,f[ra>>2]=qa+-1,(qa|0)==1):0)CR(r);f[pa>>2]=0;pa=r+4|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[pa>>2]|0)>0){ha=f[r+40>>2]|0;qa=0;do{f[ha+(qa<<2)>>2]=0;qa=qa+1|0}while((qa|0)<(f[pa>>2]|0))}pa=f[ka>>2]|0;if((pa|0)!=(oa|0))ZF(pa);pa=q+36|0;qa=f[pa>>2]|0;if(qa|0?(ha=qa+12|0,qa=f[ha>>2]|0,f[ha>>2]=qa+-1,(qa|0)==1):0)CR(q);f[pa>>2]=0;pa=q+4|0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[pa>>2]|0)>0){qa=f[q+40>>2]|0;ha=0;do{f[qa+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[pa>>2]|0))}pa=f[fa>>2]|0;if((pa|0)!=(ea|0))ZF(pa);pa=l+36|0;ha=f[pa>>2]|0;do if(ha|0){qa=ha+12|0;la=f[qa>>2]|0;f[qa>>2]=la+-1;if((la|0)!=1)break;CR(l)}while(0);f[pa>>2]=0;ha=l+4|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[ha>>2]|0)>0){ea=f[l+40>>2]|0;fa=0;do{f[ea+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[ha>>2]|0))}ha=f[ca>>2]|0;if((ha|0)!=(ba|0))ZF(ha);u=k;return}while(0);do if((Z|0)==(_|0)?(na=f[n>>2]|0,ma=f[n+4>>2]|0,(U|0)==(X|0)&((na|0)==(f[o>>2]|0)?(ma|0)==(f[o+4>>2]|0):0)):0){if((N|0)==131072?(na|0)==1&((ma|0)==4|(ma|0)==1):0){sa=87;break}if((O|0)==131072?(na|0)==1&((ma|0)==4|(ma|0)==1):0)sa=87;else{ta=U;ua=S;va=0;wa=L;xa=M;ya=0;za=R;Aa=V}}else sa=87;while(0);do if((sa|0)==87){a:do if((nS(a,-1)|0)<=2?YS(a,-1)|0:0){QR(l,a,-1);_=f[l>>2]|0;Z=(_|0)==1;if(!(!Z?(f[l+4>>2]|0)!=1:0))sa=91;do if((sa|0)==91?!((N|0)!=131072&(O|0)==131072):0){ma=f[l+4>>2]|0;na=(ma|0)==1;if(!((_|0)==(X|0)&na|Z&(na|(ma|0)==(X|0)))){if(!(Z&(ma|0)==4))break;if(!(X>>>0<5&(RR(a,-1)|0)==6)){sa=98;break a}}ma=f[n>>2]|0;na=n+4|0;ja=f[na>>2]|0;f[n>>2]=f[o>>2];ia=o+4|0;f[na>>2]=f[ia>>2];f[o>>2]=ma;f[ia>>2]=ja;f[m>>2]=S;Ba=X;Ca=U;Da=W;Ea=M;Fa=L;Ga=1;Ha=V;Ia=R;break a}while(0);sa=98}else sa=98;while(0);b:do if((sa|0)==98){do if((nS(c,-1)|0)<=2?YS(c,-1)|0:0){QR(l,c,-1);ba=f[l>>2]|0;ca=(ba|0)==1;if(!(!ca?(f[l+4>>2]|0)!=1:0))sa=102;if((sa|0)==102?!((N|0)==131072&(O|0)!=131072):0){Z=f[l+4>>2]|0;_=(Z|0)==1;if((ba|0)==(U|0)&_|ca&(_|(Z|0)==(U|0))){Ba=U;Ca=X;Da=S;Ea=L;Fa=M;Ga=0;Ha=R;Ia=V;break b}if(ca&(Z|0)==4)if(U>>>0<5&(RR(c,-1)|0)==6){Ba=U;Ca=X;Da=S;Ea=L;Fa=M;Ga=0;Ha=R;Ia=V;break b}else break}}while(0);f[l>>2]=0;f[l+4>>2]=0;K1a(c$(l,153)|0,156919,153)|0;j$(-209,l,157073,156152,659);d$(l);Ba=U;Ca=X;Da=S;Ea=L;Fa=M;Ga=0;Ha=R;Ia=V}while(0);if((Ia|0)==6)switch(f[o+4>>2]|0){case 4:case 1:break;default:sa=111}else sa=111;if((sa|0)==111){f[l>>2]=0;f[l+4>>2]=0;Z=c$(l,50)|0;ca=157083;_=Z+50|0;do{b[Z>>0]=b[ca>>0]|0;Z=Z+1|0;ca=ca+1|0}while((Z|0)<(_|0));j$(-215,l,157073,156152,661);d$(l)}if(i){f[m>>2]=6;ta=Ba;ua=Da;va=1;wa=Ea;xa=Fa;ya=Ga<<24>>24!=0;za=Ha;Aa=Ia;break}ca=Fa;do if((NS(ca)|0)==65536){Z=f[ca+4>>2]|0;f[l>>2]=f[Z>>2];_=l+4|0;ba=Z+4|0;f[_>>2]=f[ba>>2];ja=l+8|0;f[ja>>2]=f[Z+8>>2];f[l+12>>2]=f[Z+12>>2];ia=l+16|0;f[ia>>2]=f[Z+16>>2];f[l+20>>2]=f[Z+20>>2];f[l+24>>2]=f[Z+24>>2];f[l+28>>2]=f[Z+28>>2];f[l+32>>2]=f[Z+32>>2];ma=f[Z+36>>2]|0;f[l+36>>2]=ma;f[l+40>>2]=ja;ja=l+48|0;na=l+44|0;f[na>>2]=ja;f[ja>>2]=0;f[l+52>>2]=0;if(ma|0){ja=ma+12|0;f[ja>>2]=(f[ja>>2]|0)+1}if((f[ba>>2]|0)<3){ba=f[Z+44>>2]|0;ja=f[na>>2]|0;f[ja>>2]=f[ba>>2];f[ja+4>>2]=f[ba+4>>2];Ja=ia;Ka=na;break}else{f[_>>2]=0;BR(l,Z);Ja=ia;Ka=na;break}}else{OR(l,ca,-1);Ja=l+16|0;Ka=l+44|0}while(0);ca=f[Ja>>2]|0;na=((f[o>>2]|0)==1?(f[o+4>>2]|0)==1:0)?Ca:Ba;ia=0;Z=-2147483648;_=2147483647;while(1){La=+p[ca+(ia<<3)>>3];ba=rNa(La)|0;if(+(ba|0)!=La){sa=126;break}Z=(Z|0)<(ba|0)?ba:Z;_=(_|0)>(ba|0)?ba:_;ia=ia+1|0;if((ia|0)>=(na|0)){sa=123;break}}if((sa|0)==123){na=(_|0)>-1;if(!(na&(Z|0)<256))if((_|0)>-129&(Z|0)<128)Ma=1;else Ma=na&(Z|0)<65536?2:(_|0)>-32769&(Z|0)<32768?3:4;else Ma=0}else if((sa|0)==126){f[m>>2]=6;Ma=Da>>>0<4|(Da|0)==5?5:6}f[m>>2]=Ma;na=l+36|0;ia=f[na>>2]|0;if(ia|0?(ca=ia+12|0,ia=f[ca>>2]|0,f[ca>>2]=ia+-1,(ia|0)==1):0)CR(l);f[na>>2]=0;na=l+4|0;f[Ja>>2]=0;f[Ja+4>>2]=0;f[Ja+8>>2]=0;f[Ja+12>>2]=0;if((f[na>>2]|0)>0){ia=f[l+40>>2]|0;ca=0;do{f[ia+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[na>>2]|0))}na=f[Ka>>2]|0;if((na|0)!=(l+48|0))ZF(na);ta=Ba;ua=Da;va=1;wa=Ea;xa=Fa;ya=Ga<<24>>24!=0;za=Ha;Aa=Ia}while(0);do if((g|0)<0){if(aT(d)|0){Na=RR(d,-1)|0;break}if((za|0)==(Aa|0)|va)Na=za;else{f[l>>2]=0;f[l+4>>2]=0;K1a(c$(l,136)|0,157134,136)|0;j$(-5,l,157073,156152,683);d$(l);Na=za}}else Na=g;while(0);g=Na&7;Ia=f[m>>2]|0;do if(!((ua|0)==(Ia|0)&(g|0)==(ua|0))){if(i){m=(Ia|0)>5?Ia:5;Ha=(ua|0)<(m|0)?m:ua;Oa=(Ha|0)<(g|0)?g:Ha;break}if((ua|0)<2&(Ia|0)<2)Pa=3;else Pa=(ua|0)<5&(Ia|0)<5?4:(ua|0)<(Ia|0)?Ia:ua;Ha=(Pa|0)<(g|0)?g:Pa;if(g>>>0<5)Oa=(ua|0)<5|(Ia|0)<5?4:Ha;else Oa=Ha}else Oa=ua;while(0);ua=(ta<<3)+-8|0;Ia=g|ua;g=Oa&7;Pa=g|ua;do if(P)bT(d,wa,Ia);else{if((RR(e,-1)|0|1|0)==1?(i=wa,TS(e,i)|0):0)Qa=i;else{f[l>>2]=0;f[l+4>>2]=0;K1a(c$(l,132)|0,157271,132)|0;j$(-215,l,157073,156152,715);d$(l);Qa=wa}if(TS(d,Qa)|0){i=(RR(d,-1)|0)==(Ia|0);bT(d,Qa,Ia);if(i)break}else bT(d,Qa,Ia);p[q>>3]=0.0;f[l>>2]=-1056833530;f[l+4>>2]=q;f[l+8>>2]=1;f[l+12>>2]=1;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;eT(d,l,r)}while(0);if((za|0)==(Pa|0))Ra=0;else Ra=VI(za,Pa)|0;if((Aa|0)!=(za|0))if((Aa|0)==(Pa|0))Sa=0;else Sa=VI(Aa,Pa)|0;else Sa=Ra;if((Ia|0)==(Pa|0))Ta=0;else Ta=VI(Pa,Ia)|0;Ia=(za>>>3&511)+1<<(47696>>>(za<<1&14)&3);za=(Aa>>>3&511)+1<<(47696>>>(Aa<<1&14)&3);Aa=(ua>>>3&511)+1|0;ua=Aa<<(47696>>>(Na<<1&14)&3);f[l>>2]=ua;Na=Aa<<(47696>>>(Oa<<1&14)&3);Oa=((Na+1023|0)>>>0)/(Na>>>0)|0;Aa=cL(ua)|0;ua=wa;do if((NS(ua)|0)==65536){wa=f[ua+4>>2]|0;f[q>>2]=f[wa>>2];Qa=q+4|0;i=wa+4|0;f[Qa>>2]=f[i>>2];Ha=q+8|0;f[Ha>>2]=f[wa+8>>2];f[q+12>>2]=f[wa+12>>2];f[q+16>>2]=f[wa+16>>2];f[q+20>>2]=f[wa+20>>2];f[q+24>>2]=f[wa+24>>2];f[q+28>>2]=f[wa+28>>2];f[q+32>>2]=f[wa+32>>2];m=f[wa+36>>2]|0;f[q+36>>2]=m;f[q+40>>2]=Ha;Ha=q+48|0;Ga=q+44|0;f[Ga>>2]=Ha;f[Ha>>2]=0;f[q+52>>2]=0;if(m|0){Ha=m+12|0;f[Ha>>2]=(f[Ha>>2]|0)+1}if((f[i>>2]|0)<3){i=f[wa+44>>2]|0;Ha=f[Ga>>2]|0;f[Ha>>2]=f[i>>2];f[Ha+4>>2]=f[i+4>>2];break}else{f[Qa>>2]=0;BR(q,wa);break}}else OR(q,ua,-1);while(0);ua=xa;do if((NS(ua)|0)==65536){xa=f[ua+4>>2]|0;f[r>>2]=f[xa>>2];wa=r+4|0;Qa=xa+4|0;f[wa>>2]=f[Qa>>2];i=r+8|0;f[i>>2]=f[xa+8>>2];f[r+12>>2]=f[xa+12>>2];f[r+16>>2]=f[xa+16>>2];f[r+20>>2]=f[xa+20>>2];f[r+24>>2]=f[xa+24>>2];f[r+28>>2]=f[xa+28>>2];f[r+32>>2]=f[xa+32>>2];Ha=f[xa+36>>2]|0;f[r+36>>2]=Ha;f[r+40>>2]=i;i=r+48|0;Ga=r+44|0;f[Ga>>2]=i;f[i>>2]=0;f[r+52>>2]=0;if(Ha|0){i=Ha+12|0;f[i>>2]=(f[i>>2]|0)+1}if((f[Qa>>2]|0)<3){Qa=f[xa+44>>2]|0;i=f[Ga>>2]|0;f[i>>2]=f[Qa>>2];f[i+4>>2]=f[Qa+4>>2];break}else{f[wa>>2]=0;BR(r,xa);break}}else OR(r,ua,-1);while(0);do if((NS(d)|0)==65536){ua=f[d+4>>2]|0;f[s>>2]=f[ua>>2];xa=s+4|0;wa=ua+4|0;f[xa>>2]=f[wa>>2];Qa=s+8|0;f[Qa>>2]=f[ua+8>>2];f[s+12>>2]=f[ua+12>>2];f[s+16>>2]=f[ua+16>>2];f[s+20>>2]=f[ua+20>>2];f[s+24>>2]=f[ua+24>>2];f[s+28>>2]=f[ua+28>>2];f[s+32>>2]=f[ua+32>>2];i=f[ua+36>>2]|0;f[s+36>>2]=i;f[s+40>>2]=Qa;Qa=s+48|0;Ga=s+44|0;f[Ga>>2]=Qa;f[Qa>>2]=0;f[s+52>>2]=0;if(i|0){Qa=i+12|0;f[Qa>>2]=(f[Qa>>2]|0)+1}if((f[wa>>2]|0)<3){wa=f[ua+44>>2]|0;Qa=f[Ga>>2]|0;f[Qa>>2]=f[wa>>2];f[Qa+4>>2]=f[wa+4>>2];break}else{f[xa>>2]=0;BR(s,ua);break}}else OR(s,d,-1);while(0);do if((NS(e)|0)==65536){d=f[e+4>>2]|0;f[t>>2]=f[d>>2];ua=t+4|0;xa=d+4|0;f[ua>>2]=f[xa>>2];wa=t+8|0;f[wa>>2]=f[d+8>>2];f[t+12>>2]=f[d+12>>2];f[t+16>>2]=f[d+16>>2];f[t+20>>2]=f[d+20>>2];f[t+24>>2]=f[d+24>>2];f[t+28>>2]=f[d+28>>2];f[t+32>>2]=f[d+32>>2];Qa=f[d+36>>2]|0;f[t+36>>2]=Qa;f[t+40>>2]=wa;wa=t+48|0;Ga=t+44|0;f[Ga>>2]=wa;f[wa>>2]=0;f[t+52>>2]=0;if(Qa|0){wa=Qa+12|0;f[wa>>2]=(f[wa>>2]|0)+1}if((f[xa>>2]|0)<3){xa=f[d+44>>2]|0;wa=f[Ga>>2]|0;f[wa>>2]=f[xa>>2];f[wa+4>>2]=f[xa+4>>2];break}else{f[ua>>2]=0;BR(t,d);break}}else OR(t,e,-1);while(0);e=v+8|0;f[v>>2]=e;d=v+4|0;f[d>>2]=1032;ua=(Ra|0)!=0;xa=(Sa|0)!=0;wa=(Ta|0)!=0;Ga=(va|xa?Na:0)+(ua?Na:0)+(wa?Na:0)+(P?0:f[l>>2]|0)|0;Qa=f[h+(g<<2)>>2]|0;if(va){f[w>>2]=q;f[w+4>>2]=s;f[w+8>>2]=t;f[w+12>>2]=0;bU(y,w,x,-1);va=f[y+20>>2]|0;g=Oa>>>0<va>>>0?Oa:va;h=(Y(g,Ga)|0)+64|0;do if((f[d>>2]|0)>>>0<h>>>0){i=f[v>>2]|0;if((i|0)!=(e|0)){if(i|0)QYa(i);f[v>>2]=e;f[d>>2]=1032}f[d>>2]=h;if(h>>>0<=1032){Ua=e;break}i=OYa(h)|0;f[v>>2]=i;Ua=i}else{f[d>>2]=h;Ua=f[v>>2]|0}while(0);h=Y(g,Na)|0;i=ua?Ua+h+15&-16:Ua;Ha=ua?Ua:0;Ua=i+h+15&-16;m=P?Ua:wa?Ua+h+15&-16:Ua;aG(r,Pa,i,g);Pa=y+16|0;h=(va|0)==0;Fa=i;i=x+4|0;Ea=F+4|0;Da=Ha;Ba=wa|Q;Ka=G+4|0;Ja=I+4|0;Ma=x+8|0;sa=K+4|0;Ca=H+4|0;o=0;while(1){if(o>>>0>=(f[Pa>>2]|0)>>>0)break;if(!h){V=f[x>>2]|0;R=f[i>>2]|0;M=0;do{L=va-M|0;S=L>>>0>g>>>0?g:L;L=Y(S,ta)|0;if(ua){f[F>>2]=L;f[Ea>>2]=1;Oh[Ra&255](V,1,0,1,Ha,1,F,0);Va=Da}else Va=V;X=ya?Fa:Va;U=ya?Va:Fa;do if(Ba){_h[Qa&127](X,1,U,1,Ua,1,L,1,j);if(P){f[G>>2]=L;f[Ka>>2]=1;Oh[Ta&255](Ua,1,0,1,R,1,G,0);break}if(wa){f[I>>2]=L;f[Ja>>2]=1;Oh[Ta&255](Ua,1,0,1,m,1,I,0);c=f[Ma>>2]|0;f[K>>2]=S;f[sa>>2]=1;Oh[Aa&255](m,1,c,1,R,1,K,l)}else{c=f[Ma>>2]|0;f[H>>2]=S;f[Ca>>2]=1;Oh[Aa&255](Ua,1,c,1,R,1,H,l)}f[Ma>>2]=(f[Ma>>2]|0)+S}else _h[Qa&127](X,1,U,1,R,1,L,1,j);while(0);L=Y(S,Ia)|0;V=(f[x>>2]|0)+L|0;f[x>>2]=V;L=Y(f[l>>2]|0,S)|0;R=(f[i>>2]|0)+L|0;f[i>>2]=R;M=M+g|0}while(va>>>0>M>>>0)}tR(y)|0;o=o+1|0}}else{f[w>>2]=q;f[w+4>>2]=r;f[w+8>>2]=s;f[w+12>>2]=t;f[w+16>>2]=0;bU(y,w,x,-1);w=f[y+20>>2]|0;o=(ua|Q|xa|wa)&Oa>>>0<w>>>0?Oa:w;Oa=(Y(o,Ga)|0)+64|0;do if((f[d>>2]|0)>>>0<Oa>>>0){Ga=f[v>>2]|0;if((Ga|0)!=(e|0)){if(Ga|0)QYa(Ga);f[v>>2]=e;f[d>>2]=1032}f[d>>2]=Oa;if(Oa>>>0<=1032){Wa=e;break}Ga=OYa(Oa)|0;f[v>>2]=Ga;Wa=Ga}else{f[d>>2]=Oa;Wa=f[v>>2]|0}while(0);Oa=Y(o,Na)|0;Na=ua?Wa+Oa+15&-16:Wa;Ga=ua?Wa:0;va=xa?Na+Oa+15&-16:Na;g=xa?Na:0;Na=P?va:wa?va+Oa+15&-16:va;Oa=y+16|0;i=(w|0)==0;Ma=x+4|0;H=x+8|0;Ua=z+4|0;Ca=xa^1;xa=wa|Q;Q=B+4|0;K=D+4|0;m=x+12|0;sa=E+4|0;I=C+4|0;Ja=A+4|0;G=0;while(1){if(G>>>0>=(f[Oa>>2]|0)>>>0)break;if(!i){Ka=f[x>>2]|0;Ba=f[Ma>>2]|0;Fa=f[H>>2]|0;Va=0;do{ya=w-Va|0;Da=ya>>>0>o>>>0?o:ya;ya=Y(Da,ta)|0;if(ua){f[z>>2]=ya;f[Ua>>2]=1;Oh[Ra&255](Ka,1,0,1,Ga,1,z,0);Xa=f[x>>2]|0;Ya=f[Ma>>2]|0;Za=Wa}else{Xa=Ka;Ya=Ba;Za=Ka}F=(Xa|0)==(Ya|0);if(F|Ca)_a=F?Za:Ba;else{f[A>>2]=ya;f[Ja>>2]=1;Oh[Sa&255](Ba,1,0,1,g,1,A,0);_a=g}do if(xa){_h[Qa&127](Za,1,_a,1,va,0,ya,1,j);if(P){f[B>>2]=ya;f[Q>>2]=1;Oh[Ta&255](va,1,0,1,Fa,1,B,0);break}if(wa){f[D>>2]=ya;f[K>>2]=1;Oh[Ta&255](va,1,0,1,Na,1,D,0);F=f[m>>2]|0;f[E>>2]=Da;f[sa>>2]=1;Oh[Aa&255](Na,1,F,1,Fa,1,E,l)}else{F=f[m>>2]|0;f[C>>2]=Da;f[I>>2]=1;Oh[Aa&255](va,1,F,1,Fa,1,C,l)}f[m>>2]=(f[m>>2]|0)+Da}else _h[Qa&127](Za,1,_a,1,Fa,1,ya,1,j);while(0);ya=Y(Da,Ia)|0;Ka=(f[x>>2]|0)+ya|0;f[x>>2]=Ka;ya=Y(Da,za)|0;Ba=(f[Ma>>2]|0)+ya|0;f[Ma>>2]=Ba;ya=Y(f[l>>2]|0,Da)|0;Fa=(f[H>>2]|0)+ya|0;f[H>>2]=Fa;Va=Va+o|0}while(w>>>0>Va>>>0)}tR(y)|0;G=G+1|0}}G=f[v>>2]|0;if((G|0)!=(e|0)){if(G|0)QYa(G);f[v>>2]=e;f[d>>2]=1032}d=t+36|0;e=f[d>>2]|0;do if(e|0){v=e+12|0;G=f[v>>2]|0;f[v>>2]=G+-1;if((G|0)!=1)break;CR(t)}while(0);f[d>>2]=0;d=t+16|0;e=t+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[e>>2]|0)>0){d=f[t+40>>2]|0;G=0;do{f[d+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[e>>2]|0))}e=f[t+44>>2]|0;if((e|0)!=(t+48|0))ZF(e);e=s+36|0;t=f[e>>2]|0;do if(t|0){G=t+12|0;d=f[G>>2]|0;f[G>>2]=d+-1;if((d|0)!=1)break;CR(s)}while(0);f[e>>2]=0;e=s+16|0;t=s+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[t>>2]|0)>0){e=f[s+40>>2]|0;d=0;do{f[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[t>>2]|0))}t=f[s+44>>2]|0;if((t|0)!=(s+48|0))ZF(t);t=r+36|0;s=f[t>>2]|0;do if(s|0){d=s+12|0;e=f[d>>2]|0;f[d>>2]=e+-1;if((e|0)!=1)break;CR(r)}while(0);f[t>>2]=0;t=r+16|0;s=r+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[s>>2]|0)>0){t=f[r+40>>2]|0;e=0;do{f[t+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[s>>2]|0))}s=f[r+44>>2]|0;if((s|0)!=(r+48|0))ZF(s);s=q+36|0;r=f[s>>2]|0;do if(r|0){e=r+12|0;t=f[e>>2]|0;f[e>>2]=t+-1;if((t|0)!=1)break;CR(q)}while(0);f[s>>2]=0;s=q+16|0;r=q+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[r>>2]|0)>0){s=f[q+40>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[q+44>>2]|0;if((r|0)!=(q+48|0))ZF(r);u=k;return}function VG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;gH(a,b,c,d,e,f,g,h);return}function WG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;fH(a,b,c,d,e,f,g,h);return}function XG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;eH(a,b,c,d,e,f,g,h);return}function YG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;dH(a,b,c,d,e,f,g,h);return}function ZG(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;cH(a,b,c,d,e,f,g,h);return}function _G(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;bH(a,b,c,d,e,f,g,h);return}function $G(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;aH(a,b,c,d,e,f,g,h);return}function aH(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0.0;i=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){j=(g|0)>0;k=i;l=e;m=a;n=c;while(1){if(j){o=0;do{p[l+(o<<3)>>3]=+p[m+(o<<3)>>3]+ +p[n+(o<<3)>>3];o=o+1|0}while((o|0)!=(g|0))}if(!k)break;else{k=k+-1|0;l=l+f|0;m=m+b|0;n=n+d|0}}return}n=g&-4;m=(n|0)<(g|0);l=i;i=e;e=a;a=c;while(1){c=0;do{k=c|1;q=+p[e+(k<<3)>>3]+ +p[a+(k<<3)>>3];p[i+(c<<3)>>3]=+p[e+(c<<3)>>3]+ +p[a+(c<<3)>>3];p[i+(k<<3)>>3]=q;k=c|2;j=c|3;q=+p[e+(j<<3)>>3]+ +p[a+(j<<3)>>3];p[i+(k<<3)>>3]=+p[e+(k<<3)>>3]+ +p[a+(k<<3)>>3];p[i+(j<<3)>>3]=q;c=c+4|0}while((c|0)<=(h|0));if(m){c=n;do{p[i+(c<<3)>>3]=+p[e+(c<<3)>>3]+ +p[a+(c<<3)>>3];c=c+1|0}while((c|0)!=(g|0))}if(!l)break;else{l=l+-1|0;i=i+f|0;e=e+b|0;a=a+d|0}}return}function bH(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0;i=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){j=(g|0)>0;k=i;l=e;m=a;o=c;while(1){if(j){p=0;do{n[l+(p<<2)>>2]=+n[m+(p<<2)>>2]+ +n[o+(p<<2)>>2];p=p+1|0}while((p|0)!=(g|0))}if(!k)break;else{k=k+-1|0;l=l+f|0;m=m+b|0;o=o+d|0}}return}o=g&-4;m=(o|0)<(g|0);l=i;i=e;e=a;a=c;while(1){c=0;do{k=c|1;q=+n[e+(k<<2)>>2]+ +n[a+(k<<2)>>2];n[i+(c<<2)>>2]=+n[e+(c<<2)>>2]+ +n[a+(c<<2)>>2];n[i+(k<<2)>>2]=q;k=c|2;j=c|3;q=+n[e+(j<<2)>>2]+ +n[a+(j<<2)>>2];n[i+(k<<2)>>2]=+n[e+(k<<2)>>2]+ +n[a+(k<<2)>>2];n[i+(j<<2)>>2]=q;c=c+4|0}while((c|0)<=(h|0));if(m){c=o;do{n[i+(c<<2)>>2]=+n[e+(c<<2)>>2]+ +n[a+(c<<2)>>2];c=c+1|0}while((c|0)!=(g|0))}if(!l)break;else{l=l+-1|0;i=i+f|0;e=e+b|0;a=a+d|0}}return}function cH(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=j;m=e;n=a;o=c;while(1){if(k){p=0;do{f[m+(p<<2)>>2]=(f[o+(p<<2)>>2]|0)+(f[n+(p<<2)>>2]|0);p=p+1|0}while((p|0)!=(h|0))}if(!l)break;else{l=l+-1|0;m=m+g|0;n=n+b|0;o=o+d|0}}return}o=h&-4;n=(o|0)<(h|0);m=j;j=e;e=a;a=c;while(1){c=0;do{l=c|1;k=(f[a+(l<<2)>>2]|0)+(f[e+(l<<2)>>2]|0)|0;f[j+(c<<2)>>2]=(f[a+(c<<2)>>2]|0)+(f[e+(c<<2)>>2]|0);f[j+(l<<2)>>2]=k;k=c|2;l=c|3;p=(f[a+(l<<2)>>2]|0)+(f[e+(l<<2)>>2]|0)|0;f[j+(k<<2)>>2]=(f[a+(k<<2)>>2]|0)+(f[e+(k<<2)>>2]|0);f[j+(l<<2)>>2]=p;c=c+4|0}while((c|0)<=(i|0));if(n){c=o;do{f[j+(c<<2)>>2]=(f[a+(c<<2)>>2]|0)+(f[e+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(h|0))}if(!m)break;else{m=m+-1|0;j=j+g|0;e=e+b|0;a=a+d|0}}return}function dH(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=j;m=f;n=a;o=c;while(1){if(k){p=0;do{q=(d[o+(p<<1)>>1]|0)+(d[n+(p<<1)>>1]|0)|0;d[m+(p<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;p=p+1|0}while((p|0)!=(h|0))}if(!l)break;else{l=l+-1|0;m=m+g|0;n=n+b|0;o=o+e|0}}return}o=h&-4;n=(o|0)<(h|0);m=j;j=f;f=a;a=c;while(1){c=0;do{l=(d[a+(c<<1)>>1]|0)+(d[f+(c<<1)>>1]|0)|0;k=c|1;p=(d[a+(k<<1)>>1]|0)+(d[f+(k<<1)>>1]|0)|0;d[j+(c<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;d[j+(k<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;p=c|2;k=(d[a+(p<<1)>>1]|0)+(d[f+(p<<1)>>1]|0)|0;l=c|3;q=(d[a+(l<<1)>>1]|0)+(d[f+(l<<1)>>1]|0)|0;d[j+(p<<1)>>1]=(k+32768|0)>>>0<65536?k:(k|0)>0?32767:32768;d[j+(l<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;c=c+4|0}while((c|0)<=(i|0));if(n){c=o;do{q=(d[a+(c<<1)>>1]|0)+(d[f+(c<<1)>>1]|0)|0;d[j+(c<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;c=c+1|0}while((c|0)!=(h|0))}if(!m)break;else{m=m+-1|0;j=j+g|0;f=f+b|0;a=a+e|0}}return}function eH(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){l=(h|0)>0;m=k;n=f;o=a;p=c;while(1){if(l){q=0;do{r=(j[p+(q<<1)>>1]|0)+(j[o+(q<<1)>>1]|0)|0;d[n+(q<<1)>>1]=r>>>0<65536?r:r|0?65535:0;q=q+1|0}while((q|0)!=(h|0))}if(!m)break;else{m=m+-1|0;n=n+g|0;o=o+b|0;p=p+e|0}}return}p=h&-4;o=(p|0)<(h|0);n=k;k=f;f=a;a=c;while(1){c=0;do{m=(j[a+(c<<1)>>1]|0)+(j[f+(c<<1)>>1]|0)|0;l=c|1;q=(j[a+(l<<1)>>1]|0)+(j[f+(l<<1)>>1]|0)|0;d[k+(c<<1)>>1]=m>>>0<65536?m:m|0?65535:0;d[k+(l<<1)>>1]=q>>>0<65536?q:q|0?65535:0;q=c|2;l=(j[a+(q<<1)>>1]|0)+(j[f+(q<<1)>>1]|0)|0;m=c|3;r=(j[a+(m<<1)>>1]|0)+(j[f+(m<<1)>>1]|0)|0;d[k+(q<<1)>>1]=l>>>0<65536?l:l|0?65535:0;d[k+(m<<1)>>1]=r>>>0<65536?r:r|0?65535:0;c=c+4|0}while((c|0)<=(i|0));if(o){c=p;do{r=(j[a+(c<<1)>>1]|0)+(j[f+(c<<1)>>1]|0)|0;d[k+(c<<1)>>1]=r>>>0<65536?r:r|0?65535:0;c=c+1|0}while((c|0)!=(h|0))}if(!n)break;else{n=n+-1|0;k=k+g|0;f=f+b|0;a=a+e|0}}return}function fH(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=j;m=f;n=a;o=d;while(1){if(k){p=0;do{q=(b[o+p>>0]|0)+(b[n+p>>0]|0)|0;b[m+p>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;p=p+1|0}while((p|0)!=(h|0))}if(!l)break;else{l=l+-1|0;m=m+g|0;n=n+c|0;o=o+e|0}}return}o=h&-4;n=(o|0)<(h|0);m=j;j=f;f=a;a=d;while(1){d=0;do{l=(b[a+d>>0]|0)+(b[f+d>>0]|0)|0;k=d|1;p=(b[a+k>>0]|0)+(b[f+k>>0]|0)|0;b[j+d>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;b[j+k>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;p=d|2;k=(b[a+p>>0]|0)+(b[f+p>>0]|0)|0;l=d|3;q=(b[a+l>>0]|0)+(b[f+l>>0]|0)|0;b[j+p>>0]=(k+128|0)>>>0<256?k:(k|0)>0?127:128;b[j+l>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;d=d+4|0}while((d|0)<=(i|0));if(n){d=o;do{q=(b[a+d>>0]|0)+(b[f+d>>0]|0)|0;b[j+d>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;d=d+1|0}while((d|0)!=(h|0))}if(!m)break;else{m=m+-1|0;j=j+g|0;f=f+c|0;a=a+e|0}}return}function gH(a,c,d,e,f,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){l=(i|0)>0;m=k;n=f;o=a;p=d;while(1){if(l){q=0;do{b[n+q>>0]=b[199495+((h[o+q>>0]|0|256)+(h[p+q>>0]|0))>>0]|0;q=q+1|0}while((q|0)!=(i|0))}if(!m)break;else{m=m+-1|0;n=n+g|0;o=o+c|0;p=p+e|0}}return}p=i&-4;o=(p|0)<(i|0);n=k;k=f;f=a;a=d;while(1){d=0;do{m=d|1;l=b[199495+((h[f+m>>0]|0|256)+(h[a+m>>0]|0))>>0]|0;b[k+d>>0]=b[199495+((h[f+d>>0]|0|256)+(h[a+d>>0]|0))>>0]|0;b[k+m>>0]=l;l=d|2;m=d|3;q=b[199495+((h[f+m>>0]|0|256)+(h[a+m>>0]|0))>>0]|0;b[k+l>>0]=b[199495+((h[f+l>>0]|0|256)+(h[a+l>>0]|0))>>0]|0;b[k+m>>0]=q;d=d+4|0}while((d|0)<=(j|0));if(o){d=p;do{b[k+d>>0]=b[199495+((h[f+d>>0]|0|256)+(h[a+d>>0]|0))>>0]|0;d=d+1|0}while((d|0)!=(i|0))}if(!n)break;else{n=n+-1|0;k=k+g|0;f=f+c|0;a=a+e|0}}return}function hH(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;_$(h,30484);UG(a,b,c,d,e,30504,0,0,1);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function iH(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;vH(a,b,c,d,e,f,g,h);return}function jH(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;uH(a,b,c,d,e,f,g,h);return}function kH(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;tH(a,b,c,d,e,f,g,h);return}function lH(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;sH(a,b,c,d,e,f,g,h);return}function mH(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;rH(a,b,c,d,e,f,g,h);return}function nH(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;qH(a,b,c,d,e,f,g,h);return}function oH(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;pH(a,b,c,d,e,f,g,h);return}function pH(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0.0;i=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){j=(g|0)>0;k=i;l=e;m=a;n=c;while(1){if(j){o=0;do{p[l+(o<<3)>>3]=+p[m+(o<<3)>>3]-+p[n+(o<<3)>>3];o=o+1|0}while((o|0)!=(g|0))}if(!k)break;else{k=k+-1|0;l=l+f|0;m=m+b|0;n=n+d|0}}return}n=g&-4;m=(n|0)<(g|0);l=i;i=e;e=a;a=c;while(1){c=0;do{k=c|1;q=+p[e+(k<<3)>>3]-+p[a+(k<<3)>>3];p[i+(c<<3)>>3]=+p[e+(c<<3)>>3]-+p[a+(c<<3)>>3];p[i+(k<<3)>>3]=q;k=c|2;j=c|3;q=+p[e+(j<<3)>>3]-+p[a+(j<<3)>>3];p[i+(k<<3)>>3]=+p[e+(k<<3)>>3]-+p[a+(k<<3)>>3];p[i+(j<<3)>>3]=q;c=c+4|0}while((c|0)<=(h|0));if(m){c=n;do{p[i+(c<<3)>>3]=+p[e+(c<<3)>>3]-+p[a+(c<<3)>>3];c=c+1|0}while((c|0)!=(g|0))}if(!l)break;else{l=l+-1|0;i=i+f|0;e=e+b|0;a=a+d|0}}return}function qH(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0;i=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){j=(g|0)>0;k=i;l=e;m=a;o=c;while(1){if(j){p=0;do{n[l+(p<<2)>>2]=+n[m+(p<<2)>>2]-+n[o+(p<<2)>>2];p=p+1|0}while((p|0)!=(g|0))}if(!k)break;else{k=k+-1|0;l=l+f|0;m=m+b|0;o=o+d|0}}return}o=g&-4;m=(o|0)<(g|0);l=i;i=e;e=a;a=c;while(1){c=0;do{k=c|1;q=+n[e+(k<<2)>>2]-+n[a+(k<<2)>>2];n[i+(c<<2)>>2]=+n[e+(c<<2)>>2]-+n[a+(c<<2)>>2];n[i+(k<<2)>>2]=q;k=c|2;j=c|3;q=+n[e+(j<<2)>>2]-+n[a+(j<<2)>>2];n[i+(k<<2)>>2]=+n[e+(k<<2)>>2]-+n[a+(k<<2)>>2];n[i+(j<<2)>>2]=q;c=c+4|0}while((c|0)<=(h|0));if(m){c=o;do{n[i+(c<<2)>>2]=+n[e+(c<<2)>>2]-+n[a+(c<<2)>>2];c=c+1|0}while((c|0)!=(g|0))}if(!l)break;else{l=l+-1|0;i=i+f|0;e=e+b|0;a=a+d|0}}return}function rH(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=j;m=e;n=a;o=c;while(1){if(k){p=0;do{f[m+(p<<2)>>2]=(f[n+(p<<2)>>2]|0)-(f[o+(p<<2)>>2]|0);p=p+1|0}while((p|0)!=(h|0))}if(!l)break;else{l=l+-1|0;m=m+g|0;n=n+b|0;o=o+d|0}}return}o=h&-4;n=(o|0)<(h|0);m=j;j=e;e=a;a=c;while(1){c=0;do{l=c|1;k=(f[e+(l<<2)>>2]|0)-(f[a+(l<<2)>>2]|0)|0;f[j+(c<<2)>>2]=(f[e+(c<<2)>>2]|0)-(f[a+(c<<2)>>2]|0);f[j+(l<<2)>>2]=k;k=c|2;l=c|3;p=(f[e+(l<<2)>>2]|0)-(f[a+(l<<2)>>2]|0)|0;f[j+(k<<2)>>2]=(f[e+(k<<2)>>2]|0)-(f[a+(k<<2)>>2]|0);f[j+(l<<2)>>2]=p;c=c+4|0}while((c|0)<=(i|0));if(n){c=o;do{f[j+(c<<2)>>2]=(f[e+(c<<2)>>2]|0)-(f[a+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(h|0))}if(!m)break;else{m=m+-1|0;j=j+g|0;e=e+b|0;a=a+d|0}}return}function sH(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=j;m=f;n=a;o=c;while(1){if(k){p=0;do{q=(d[n+(p<<1)>>1]|0)-(d[o+(p<<1)>>1]|0)|0;d[m+(p<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;p=p+1|0}while((p|0)!=(h|0))}if(!l)break;else{l=l+-1|0;m=m+g|0;n=n+b|0;o=o+e|0}}return}o=h&-4;n=(o|0)<(h|0);m=j;j=f;f=a;a=c;while(1){c=0;do{l=(d[f+(c<<1)>>1]|0)-(d[a+(c<<1)>>1]|0)|0;k=c|1;p=(d[f+(k<<1)>>1]|0)-(d[a+(k<<1)>>1]|0)|0;d[j+(c<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;d[j+(k<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;p=c|2;k=(d[f+(p<<1)>>1]|0)-(d[a+(p<<1)>>1]|0)|0;l=c|3;q=(d[f+(l<<1)>>1]|0)-(d[a+(l<<1)>>1]|0)|0;d[j+(p<<1)>>1]=(k+32768|0)>>>0<65536?k:(k|0)>0?32767:32768;d[j+(l<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;c=c+4|0}while((c|0)<=(i|0));if(n){c=o;do{q=(d[f+(c<<1)>>1]|0)-(d[a+(c<<1)>>1]|0)|0;d[j+(c<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;c=c+1|0}while((c|0)!=(h|0))}if(!m)break;else{m=m+-1|0;j=j+g|0;f=f+b|0;a=a+e|0}}return}function tH(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){l=(h|0)>0;m=k;n=f;o=a;p=c;while(1){if(l){q=0;do{r=(j[o+(q<<1)>>1]|0)-(j[p+(q<<1)>>1]|0)|0;d[n+(q<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;q=q+1|0}while((q|0)!=(h|0))}if(!m)break;else{m=m+-1|0;n=n+g|0;o=o+b|0;p=p+e|0}}return}p=h&-4;o=(p|0)<(h|0);n=k;k=f;f=a;a=c;while(1){c=0;do{m=(j[f+(c<<1)>>1]|0)-(j[a+(c<<1)>>1]|0)|0;l=c|1;q=(j[f+(l<<1)>>1]|0)-(j[a+(l<<1)>>1]|0)|0;d[k+(c<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;d[k+(l<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;q=c|2;l=(j[f+(q<<1)>>1]|0)-(j[a+(q<<1)>>1]|0)|0;m=c|3;r=(j[f+(m<<1)>>1]|0)-(j[a+(m<<1)>>1]|0)|0;d[k+(q<<1)>>1]=l>>>0<65536?l:(l|0)>0?65535:0;d[k+(m<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;c=c+4|0}while((c|0)<=(i|0));if(o){c=p;do{r=(j[f+(c<<1)>>1]|0)-(j[a+(c<<1)>>1]|0)|0;d[k+(c<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;c=c+1|0}while((c|0)!=(h|0))}if(!n)break;else{n=n+-1|0;k=k+g|0;f=f+b|0;a=a+e|0}}return}function uH(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=j;m=f;n=a;o=d;while(1){if(k){p=0;do{q=(b[n+p>>0]|0)-(b[o+p>>0]|0)|0;b[m+p>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;p=p+1|0}while((p|0)!=(h|0))}if(!l)break;else{l=l+-1|0;m=m+g|0;n=n+c|0;o=o+e|0}}return}o=h&-4;n=(o|0)<(h|0);m=j;j=f;f=a;a=d;while(1){d=0;do{l=(b[f+d>>0]|0)-(b[a+d>>0]|0)|0;k=d|1;p=(b[f+k>>0]|0)-(b[a+k>>0]|0)|0;b[j+d>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;b[j+k>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;p=d|2;k=(b[f+p>>0]|0)-(b[a+p>>0]|0)|0;l=d|3;q=(b[f+l>>0]|0)-(b[a+l>>0]|0)|0;b[j+p>>0]=(k+128|0)>>>0<256?k:(k|0)>0?127:128;b[j+l>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;d=d+4|0}while((d|0)<=(i|0));if(n){d=o;do{q=(b[f+d>>0]|0)-(b[a+d>>0]|0)|0;b[j+d>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;d=d+1|0}while((d|0)!=(h|0))}if(!m)break;else{m=m+-1|0;j=j+g|0;f=f+c|0;a=a+e|0}}return}function vH(a,c,d,e,f,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){l=(i|0)>0;m=k;n=f;o=a;p=d;while(1){if(l){q=0;do{b[n+q>>0]=b[199495+((h[o+q>>0]|0|256)-(h[p+q>>0]|0))>>0]|0;q=q+1|0}while((q|0)!=(i|0))}if(!m)break;else{m=m+-1|0;n=n+g|0;o=o+c|0;p=p+e|0}}return}p=i&-4;o=(p|0)<(i|0);n=k;k=f;f=a;a=d;while(1){d=0;do{m=d|1;l=b[199495+((h[f+m>>0]|0|256)-(h[a+m>>0]|0))>>0]|0;b[k+d>>0]=b[199495+((h[f+d>>0]|0|256)-(h[a+d>>0]|0))>>0]|0;b[k+m>>0]=l;l=d|2;m=d|3;q=b[199495+((h[f+m>>0]|0|256)-(h[a+m>>0]|0))>>0]|0;b[k+l>>0]=b[199495+((h[f+l>>0]|0|256)-(h[a+l>>0]|0))>>0]|0;b[k+m>>0]=q;d=d+4|0}while((d|0)<=(j|0));if(o){d=p;do{b[k+d>>0]=b[199495+((h[f+d>>0]|0|256)-(h[a+d>>0]|0))>>0]|0;d=d+1|0}while((d|0)!=(i|0))}if(!n)break;else{n=n+-1|0;k=k+g|0;f=f+c|0;a=a+e|0}}return}function wH(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_$(e,30536);UG(a,b,c,fT()|0,-1,30556,0,0,3);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function xH(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;KH(a,b,c,d,e,f,g,h);return}function yH(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;JH(a,b,c,d,e,f,g,h);return}function zH(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;IH(a,b,c,d,e,f,g,h);return}function AH(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;HH(a,b,c,d,e,f,g,h);return}function BH(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;GH(a,b,c,d,e,f,g,h);return}function CH(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;FH(a,b,c,d,e,f,g,h);return}function DH(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;EH(a,b,c,d,e,f,g,h);return}function EH(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0.0,r=0.0;i=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){j=(g|0)>0;k=i;l=e;m=a;n=c;while(1){if(j){o=0;do{q=+L(+(+p[m+(o<<3)>>3]-+p[n+(o<<3)>>3]));p[l+(o<<3)>>3]=q;o=o+1|0}while((o|0)!=(g|0))}if(!k)break;else{k=k+-1|0;l=l+f|0;m=m+b|0;n=n+d|0}}return}n=g&-4;m=(n|0)<(g|0);l=i;i=e;e=a;a=c;while(1){c=0;do{q=+L(+(+p[e+(c<<3)>>3]-+p[a+(c<<3)>>3]));k=c|1;r=+L(+(+p[e+(k<<3)>>3]-+p[a+(k<<3)>>3]));p[i+(c<<3)>>3]=q;p[i+(k<<3)>>3]=r;k=c|2;r=+L(+(+p[e+(k<<3)>>3]-+p[a+(k<<3)>>3]));j=c|3;q=+L(+(+p[e+(j<<3)>>3]-+p[a+(j<<3)>>3]));p[i+(k<<3)>>3]=r;p[i+(j<<3)>>3]=q;c=c+4|0}while((c|0)<=(h|0));if(m){c=n;do{q=+L(+(+p[e+(c<<3)>>3]-+p[a+(c<<3)>>3]));p[i+(c<<3)>>3]=q;c=c+1|0}while((c|0)!=(g|0))}if(!l)break;else{l=l+-1|0;i=i+f|0;e=e+b|0;a=a+d|0}}return}function FH(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0;i=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){j=(g|0)>0;k=i;l=e;m=a;o=c;while(1){if(j){p=0;do{q=+L(+(+n[m+(p<<2)>>2]-+n[o+(p<<2)>>2]));n[l+(p<<2)>>2]=q;p=p+1|0}while((p|0)!=(g|0))}if(!k)break;else{k=k+-1|0;l=l+f|0;m=m+b|0;o=o+d|0}}return}o=g&-4;m=(o|0)<(g|0);l=i;i=e;e=a;a=c;while(1){c=0;do{q=+L(+(+n[e+(c<<2)>>2]-+n[a+(c<<2)>>2]));k=c|1;r=+L(+(+n[e+(k<<2)>>2]-+n[a+(k<<2)>>2]));n[i+(c<<2)>>2]=q;n[i+(k<<2)>>2]=r;k=c|2;r=+L(+(+n[e+(k<<2)>>2]-+n[a+(k<<2)>>2]));j=c|3;q=+L(+(+n[e+(j<<2)>>2]-+n[a+(j<<2)>>2]));n[i+(k<<2)>>2]=r;n[i+(j<<2)>>2]=q;c=c+4|0}while((c|0)<=(h|0));if(m){c=o;do{q=+L(+(+n[e+(c<<2)>>2]-+n[a+(c<<2)>>2]));n[i+(c<<2)>>2]=q;c=c+1|0}while((c|0)!=(g|0))}if(!l)break;else{l=l+-1|0;i=i+f|0;e=e+b|0;a=a+d|0}}return}function GH(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=j;m=e;n=a;o=c;while(1){if(k){p=0;do{q=f[n+(p<<2)>>2]|0;r=f[o+(p<<2)>>2]|0;f[m+(p<<2)>>2]=(q|0)>(r|0)?q-r|0:r-q|0;p=p+1|0}while((p|0)!=(h|0))}if(!l)break;else{l=l+-1|0;m=m+g|0;n=n+b|0;o=o+d|0}}return}o=h&-4;n=(o|0)<(h|0);m=j;j=e;e=a;a=c;while(1){c=0;do{l=f[e+(c<<2)>>2]|0;k=f[a+(c<<2)>>2]|0;p=c|1;q=f[e+(p<<2)>>2]|0;r=f[a+(p<<2)>>2]|0;f[j+(c<<2)>>2]=(l|0)>(k|0)?l-k|0:k-l|0;f[j+(p<<2)>>2]=(q|0)>(r|0)?q-r|0:r-q|0;q=c|2;r=f[e+(q<<2)>>2]|0;p=f[a+(q<<2)>>2]|0;l=c|3;k=f[e+(l<<2)>>2]|0;s=f[a+(l<<2)>>2]|0;f[j+(q<<2)>>2]=(r|0)>(p|0)?r-p|0:p-r|0;f[j+(l<<2)>>2]=(k|0)>(s|0)?k-s|0:s-k|0;c=c+4|0}while((c|0)<=(i|0));if(n){c=o;do{k=f[e+(c<<2)>>2]|0;s=f[a+(c<<2)>>2]|0;f[j+(c<<2)>>2]=(k|0)>(s|0)?k-s|0:s-k|0;c=c+1|0}while((c|0)!=(h|0))}if(!m)break;else{m=m+-1|0;j=j+g|0;e=e+b|0;a=a+d|0}}return}function HH(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if(!i)return;j=h+-4|0;k=(h|0)<4;l=h&-4;m=i;i=f;f=a;a=c;while(1){m=m+-1|0;if(k)n=0;else{c=0;do{o=(d[f+(c<<1)>>1]|0)-(d[a+(c<<1)>>1]|0)|0;p=(o|0)>-1?o:0-o|0;o=c|1;q=(d[f+(o<<1)>>1]|0)-(d[a+(o<<1)>>1]|0)|0;r=(q|0)>-1?q:0-q|0;d[i+(c<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[i+(o<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;r=c|2;o=(d[f+(r<<1)>>1]|0)-(d[a+(r<<1)>>1]|0)|0;p=(o|0)>-1?o:0-o|0;o=c|3;q=(d[f+(o<<1)>>1]|0)-(d[a+(o<<1)>>1]|0)|0;s=(q|0)>-1?q:0-q|0;d[i+(r<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[i+(o<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;c=c+4|0}while((c|0)<=(j|0));n=l}if((n|0)<(h|0)){c=n;do{s=(d[f+(c<<1)>>1]|0)-(d[a+(c<<1)>>1]|0)|0;o=(s|0)>-1?s:0-s|0;d[i+(c<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;c=c+1|0}while((c|0)!=(h|0))}if(!m)break;else{i=i+g|0;f=f+b|0;a=a+e|0}}return}function IH(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=j;m=f;n=a;o=c;while(1){if(k){p=0;do{q=d[n+(p<<1)>>1]|0;r=d[o+(p<<1)>>1]|0;s=(q&65535)>(r&65535);d[m+(p<<1)>>1]=((s?q:r)&65535)-((s?r:q)&65535);p=p+1|0}while((p|0)!=(h|0))}if(!l)break;else{l=l+-1|0;m=m+g|0;n=n+b|0;o=o+e|0}}return}o=h&-4;n=(o|0)<(h|0);m=j;j=f;f=a;a=c;while(1){c=0;do{l=d[f+(c<<1)>>1]|0;k=d[a+(c<<1)>>1]|0;p=(l&65535)>(k&65535);q=c|1;r=d[f+(q<<1)>>1]|0;s=d[a+(q<<1)>>1]|0;t=(r&65535)>(s&65535);d[j+(c<<1)>>1]=((p?l:k)&65535)-((p?k:l)&65535);d[j+(q<<1)>>1]=((t?r:s)&65535)-((t?s:r)&65535);r=c|2;s=d[f+(r<<1)>>1]|0;t=d[a+(r<<1)>>1]|0;q=(s&65535)>(t&65535);l=c|3;k=d[f+(l<<1)>>1]|0;p=d[a+(l<<1)>>1]|0;u=(k&65535)>(p&65535);d[j+(r<<1)>>1]=((q?s:t)&65535)-((q?t:s)&65535);d[j+(l<<1)>>1]=((u?k:p)&65535)-((u?p:k)&65535);c=c+4|0}while((c|0)<=(i|0));if(n){c=o;do{k=d[f+(c<<1)>>1]|0;p=d[a+(c<<1)>>1]|0;u=(k&65535)>(p&65535);d[j+(c<<1)>>1]=((u?k:p)&65535)-((u?p:k)&65535);c=c+1|0}while((c|0)!=(h|0))}if(!m)break;else{m=m+-1|0;j=j+g|0;f=f+b|0;a=a+e|0}}return}function JH(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=j;m=f;n=a;o=d;while(1){if(k){p=0;do{q=(b[n+p>>0]|0)-(b[o+p>>0]|0)|0;r=(q|0)>-1?q:0-q|0;b[m+p>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;p=p+1|0}while((p|0)!=(h|0))}if(!l)break;else{l=l+-1|0;m=m+g|0;n=n+c|0;o=o+e|0}}return}o=h&-4;n=(o|0)<(h|0);m=j;j=f;f=a;a=d;while(1){d=0;do{l=(b[f+d>>0]|0)-(b[a+d>>0]|0)|0;k=(l|0)>-1?l:0-l|0;l=d|1;p=(b[f+l>>0]|0)-(b[a+l>>0]|0)|0;r=(p|0)>-1?p:0-p|0;b[j+d>>0]=(k+128|0)>>>0<256?k:(k|0)>0?127:128;b[j+l>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;r=d|2;l=(b[f+r>>0]|0)-(b[a+r>>0]|0)|0;k=(l|0)>-1?l:0-l|0;l=d|3;p=(b[f+l>>0]|0)-(b[a+l>>0]|0)|0;q=(p|0)>-1?p:0-p|0;b[j+r>>0]=(k+128|0)>>>0<256?k:(k|0)>0?127:128;b[j+l>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;d=d+4|0}while((d|0)<=(i|0));if(n){d=o;do{q=(b[f+d>>0]|0)-(b[a+d>>0]|0)|0;l=(q|0)>-1?q:0-q|0;b[j+d>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;d=d+1|0}while((d|0)!=(h|0))}if(!m)break;else{m=m+-1|0;j=j+g|0;f=f+c|0;a=a+e|0}}return}function KH(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=j;m=f;n=a;o=d;while(1){if(k){p=0;do{q=b[n+p>>0]|0;r=b[o+p>>0]|0;s=(q&255)>(r&255);b[m+p>>0]=((s?q:r)&255)-((s?r:q)&255);p=p+1|0}while((p|0)!=(h|0))}if(!l)break;else{l=l+-1|0;m=m+g|0;n=n+c|0;o=o+e|0}}return}o=h&-4;n=(o|0)<(h|0);m=j;j=f;f=a;a=d;while(1){d=0;do{l=b[f+d>>0]|0;k=b[a+d>>0]|0;p=(l&255)>(k&255);q=d|1;r=b[f+q>>0]|0;s=b[a+q>>0]|0;t=(r&255)>(s&255);b[j+d>>0]=((p?l:k)&255)-((p?k:l)&255);b[j+q>>0]=((t?r:s)&255)-((t?s:r)&255);r=d|2;s=b[f+r>>0]|0;t=b[a+r>>0]|0;q=(s&255)>(t&255);l=d|3;k=b[f+l>>0]|0;p=b[a+l>>0]|0;u=(k&255)>(p&255);b[j+r>>0]=((q?s:t)&255)-((q?t:s)&255);b[j+l>>0]=((u?k:p)&255)-((u?p:k)&255);d=d+4|0}while((d|0)<=(i|0));if(n){d=o;do{k=b[f+d>>0]|0;p=b[a+d>>0]|0;u=(k&255)>(p&255);b[j+d>>0]=((u?k:p)&255)-((u?p:k)&255);d=d+1|0}while((d|0)!=(h|0))}if(!m)break;else{m=m+-1|0;j=j+g|0;f=f+c|0;a=a+e|0}}return}function LH(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+16|0;h=g;i=g+8|0;p[h>>3]=d;_$(i,30588);j=fT()|0;k=+L(+(d+-1.0))<2.220446049250313e-16;UG(a,b,c,j,e,30608,1,h,k?4:5);if(!(f[i+4>>2]|0)){u=g;return}u=g;return}function MH(a,c,d,e,f,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;l=+p[k>>3];k=j+-1|0;m=(j|0)==0;if(l==1.0){if(m)return;j=i+-4|0;if((i|0)<4){if((i|0)>0){n=k;o=f;q=a;r=d}else return;while(1){s=0;do{t=Y(h[r+s>>0]|0,h[q+s>>0]|0)|0;b[o+s>>0]=t>>>0<256?t:t|0?255:0;s=s+1|0}while((s|0)!=(i|0));if(!n)break;else{n=n+-1|0;o=o+g|0;q=q+c|0;r=r+e|0}}return}r=i&-4;q=(r|0)<(i|0);o=k;n=f;s=a;t=d;while(1){u=0;do{v=Y(h[t+u>>0]|0,h[s+u>>0]|0)|0;w=u|1;x=Y(h[t+w>>0]|0,h[s+w>>0]|0)|0;b[n+u>>0]=v>>>0<256?v:v|0?255:0;b[n+w>>0]=x>>>0<256?x:x|0?255:0;x=u|2;w=Y(h[t+x>>0]|0,h[s+x>>0]|0)|0;v=u|3;y=Y(h[t+v>>0]|0,h[s+v>>0]|0)|0;b[n+x>>0]=w>>>0<256?w:w|0?255:0;b[n+v>>0]=y>>>0<256?y:y|0?255:0;u=u+4|0}while((u|0)<=(j|0));if(q){u=r;do{y=Y(h[t+u>>0]|0,h[s+u>>0]|0)|0;b[n+u>>0]=y>>>0<256?y:y|0?255:0;u=u+1|0}while((u|0)!=(i|0))}if(!o)break;else{o=o+-1|0;n=n+g|0;s=s+c|0;t=t+e|0}}return}else{if(m)return;m=i+-4|0;if((i|0)<4){if((i|0)>0){z=k;A=f;B=a;C=d}else return;while(1){t=0;do{s=wNa(l*+(h[B+t>>0]|0)*+(h[C+t>>0]|0))|0;b[A+t>>0]=s>>>0<256?s:(s|0)>0?255:0;t=t+1|0}while((t|0)!=(i|0));if(!z)break;else{z=z+-1|0;A=A+g|0;B=B+c|0;C=C+e|0}}return}C=i&-4;B=(C|0)<(i|0);A=k;k=f;f=a;a=d;while(1){d=0;do{z=wNa(l*+(h[f+d>>0]|0)*+(h[a+d>>0]|0))|0;t=d|1;s=wNa(l*+(h[f+t>>0]|0)*+(h[a+t>>0]|0))|0;b[k+d>>0]=z>>>0<256?z:(z|0)>0?255:0;b[k+t>>0]=s>>>0<256?s:(s|0)>0?255:0;s=d|2;t=wNa(l*+(h[f+s>>0]|0)*+(h[a+s>>0]|0))|0;z=d|3;n=wNa(l*+(h[f+z>>0]|0)*+(h[a+z>>0]|0))|0;b[k+s>>0]=t>>>0<256?t:(t|0)>0?255:0;b[k+z>>0]=n>>>0<256?n:(n|0)>0?255:0;d=d+4|0}while((d|0)<=(m|0));if(B){d=C;do{n=wNa(l*+(h[f+d>>0]|0)*+(h[a+d>>0]|0))|0;b[k+d>>0]=n>>>0<256?n:(n|0)>0?255:0;d=d+1|0}while((d|0)!=(i|0))}if(!A)break;else{A=A+-1|0;k=k+g|0;f=f+c|0;a=a+e|0}}return}}function NH(a,c,d,e,f,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;k=+p[j>>3];j=i+-1|0;l=(i|0)==0;if(!(k==1.0)){if(l)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){m=j;n=f;o=a;q=d}else return;while(1){r=0;do{s=wNa(k*+(b[o+r>>0]|0)*+(b[q+r>>0]|0))|0;b[n+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;r=r+1|0}while((r|0)!=(h|0));if(!m)break;else{m=m+-1|0;n=n+g|0;o=o+c|0;q=q+e|0}}return}q=h&-4;o=(q|0)<(h|0);n=j;m=f;r=a;s=d;while(1){t=0;do{u=wNa(k*+(b[r+t>>0]|0)*+(b[s+t>>0]|0))|0;v=t|1;w=wNa(k*+(b[r+v>>0]|0)*+(b[s+v>>0]|0))|0;b[m+t>>0]=(u+128|0)>>>0<256?u:(u|0)>0?127:128;b[m+v>>0]=(w+128|0)>>>0<256?w:(w|0)>0?127:128;w=t|2;v=wNa(k*+(b[r+w>>0]|0)*+(b[s+w>>0]|0))|0;u=t|3;x=wNa(k*+(b[r+u>>0]|0)*+(b[s+u>>0]|0))|0;b[m+w>>0]=(v+128|0)>>>0<256?v:(v|0)>0?127:128;b[m+u>>0]=(x+128|0)>>>0<256?x:(x|0)>0?127:128;t=t+4|0}while((t|0)<=(i|0));if(o){t=q;do{x=wNa(k*+(b[r+t>>0]|0)*+(b[s+t>>0]|0))|0;b[m+t>>0]=(x+128|0)>>>0<256?x:(x|0)>0?127:128;t=t+1|0}while((t|0)!=(h|0))}if(!n)break;else{n=n+-1|0;m=m+g|0;r=r+c|0;s=s+e|0}}return}if(l)return;l=h+-4|0;if((h|0)<4){if((h|0)>0){y=j;z=f;A=a;B=d}else return;while(1){s=0;do{r=Y(b[B+s>>0]|0,b[A+s>>0]|0)|0;b[z+s>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;s=s+1|0}while((s|0)!=(h|0));if(!y)break;else{y=y+-1|0;z=z+g|0;A=A+c|0;B=B+e|0}}return}B=h&-4;if((B|0)<(h|0)){C=j;D=f;E=a;F=d}else{A=j;j=f;f=a;a=d;while(1){d=0;do{z=Y(b[a+d>>0]|0,b[f+d>>0]|0)|0;y=d|1;s=Y(b[a+y>>0]|0,b[f+y>>0]|0)|0;b[j+d>>0]=(z+128|0)>>>0<256?z:(z|0)>0?127:128;b[j+y>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;s=d|2;y=Y(b[a+s>>0]|0,b[f+s>>0]|0)|0;z=d|3;r=Y(b[a+z>>0]|0,b[f+z>>0]|0)|0;b[j+s>>0]=(y+128|0)>>>0<256?y:(y|0)>0?127:128;b[j+z>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;d=d+4|0}while((d|0)<=(l|0));if(!A)break;else{A=A+-1|0;j=j+g|0;f=f+c|0;a=a+e|0}}return}while(1){a=0;do{f=Y(b[F+a>>0]|0,b[E+a>>0]|0)|0;j=a|1;A=Y(b[F+j>>0]|0,b[E+j>>0]|0)|0;b[D+a>>0]=(f+128|0)>>>0<256?f:(f|0)>0?127:128;b[D+j>>0]=(A+128|0)>>>0<256?A:(A|0)>0?127:128;A=a|2;j=Y(b[F+A>>0]|0,b[E+A>>0]|0)|0;f=a|3;d=Y(b[F+f>>0]|0,b[E+f>>0]|0)|0;b[D+A>>0]=(j+128|0)>>>0<256?j:(j|0)>0?127:128;b[D+f>>0]=(d+128|0)>>>0<256?d:(d|0)>0?127:128;a=a+4|0}while((a|0)<=(l|0));G=B;do{a=Y(b[F+G>>0]|0,b[E+G>>0]|0)|0;b[D+G>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;G=G+1|0}while((G|0)!=(h|0));if(!C)break;else{C=C+-1|0;D=D+g|0;E=E+c|0;F=F+e|0}}return}function OH(a,b,c,e,f,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;l=+p[k>>3];k=b>>>1;b=e>>>1;e=g>>>1;g=i+-1|0;m=(i|0)==0;if(!(l==1.0)){if(m)return;i=h+-4|0;n=(h|0)<4;o=h&-4;q=g;r=f;s=a;t=c;while(1){if(n)u=0;else{v=0;do{w=wNa(l*+(j[s+(v<<1)>>1]|0)*+(j[t+(v<<1)>>1]|0))|0;x=v|1;y=wNa(l*+(j[s+(x<<1)>>1]|0)*+(j[t+(x<<1)>>1]|0))|0;d[r+(v<<1)>>1]=w>>>0<65536?w:(w|0)>0?65535:0;d[r+(x<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=v|2;x=wNa(l*+(j[s+(y<<1)>>1]|0)*+(j[t+(y<<1)>>1]|0))|0;w=v|3;z=wNa(l*+(j[s+(w<<1)>>1]|0)*+(j[t+(w<<1)>>1]|0))|0;d[r+(y<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;d[r+(w<<1)>>1]=z>>>0<65536?z:(z|0)>0?65535:0;v=v+4|0}while((v|0)<=(i|0));u=o}if((u|0)<(h|0)){v=u;do{z=wNa(l*+(j[s+(v<<1)>>1]|0)*+(j[t+(v<<1)>>1]|0))|0;d[r+(v<<1)>>1]=z>>>0<65536?z:(z|0)>0?65535:0;v=v+1|0}while((v|0)!=(h|0))}if(!q)break;else{q=q+-1|0;r=r+(e<<1)|0;s=s+(k<<1)|0;t=t+(b<<1)|0}}return}if(m)return;m=h+-4|0;if((h|0)<4){if((h|0)>0){A=g;B=f;C=a;D=c}else return;while(1){t=0;do{s=Y(j[D+(t<<1)>>1]|0,j[C+(t<<1)>>1]|0)|0;d[B+(t<<1)>>1]=s>>>0<65536?s:s|0?65535:0;t=t+1|0}while((t|0)!=(h|0));if(!A)break;else{A=A+-1|0;B=B+(e<<1)|0;C=C+(k<<1)|0;D=D+(b<<1)|0}}return}D=h&-4;C=(D|0)<(h|0);B=g;g=f;f=a;a=c;while(1){c=0;do{A=Y(j[a+(c<<1)>>1]|0,j[f+(c<<1)>>1]|0)|0;t=c|1;s=Y(j[a+(t<<1)>>1]|0,j[f+(t<<1)>>1]|0)|0;d[g+(c<<1)>>1]=A>>>0<65536?A:A|0?65535:0;d[g+(t<<1)>>1]=s>>>0<65536?s:s|0?65535:0;s=c|2;t=Y(j[a+(s<<1)>>1]|0,j[f+(s<<1)>>1]|0)|0;A=c|3;r=Y(j[a+(A<<1)>>1]|0,j[f+(A<<1)>>1]|0)|0;d[g+(s<<1)>>1]=t>>>0<65536?t:t|0?65535:0;d[g+(A<<1)>>1]=r>>>0<65536?r:r|0?65535:0;c=c+4|0}while((c|0)<=(m|0));if(C){c=D;do{r=Y(j[a+(c<<1)>>1]|0,j[f+(c<<1)>>1]|0)|0;d[g+(c<<1)>>1]=r>>>0<65536?r:r|0?65535:0;c=c+1|0}while((c|0)!=(h|0))}if(!B)break;else{B=B+-1|0;g=g+(e<<1)|0;f=f+(k<<1)|0;a=a+(b<<1)|0}}return}function PH(a,b,c,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;k=+p[j>>3];j=b>>>1;b=e>>>1;e=g>>>1;g=i+-1|0;l=(i|0)==0;if(!(k==1.0)){if(l)return;i=h+-4|0;m=(h|0)<4;n=h&-4;o=g;q=f;r=a;s=c;while(1){if(m)t=0;else{u=0;do{v=wNa(k*+(d[r+(u<<1)>>1]|0)*+(d[s+(u<<1)>>1]|0))|0;w=u|1;x=wNa(k*+(d[r+(w<<1)>>1]|0)*+(d[s+(w<<1)>>1]|0))|0;d[q+(u<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[q+(w<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;x=u|2;w=wNa(k*+(d[r+(x<<1)>>1]|0)*+(d[s+(x<<1)>>1]|0))|0;v=u|3;y=wNa(k*+(d[r+(v<<1)>>1]|0)*+(d[s+(v<<1)>>1]|0))|0;d[q+(x<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;d[q+(v<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;u=u+4|0}while((u|0)<=(i|0));t=n}if((t|0)<(h|0)){u=t;do{y=wNa(k*+(d[r+(u<<1)>>1]|0)*+(d[s+(u<<1)>>1]|0))|0;d[q+(u<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;u=u+1|0}while((u|0)!=(h|0))}if(!o)break;else{o=o+-1|0;q=q+(e<<1)|0;r=r+(j<<1)|0;s=s+(b<<1)|0}}return}if(l)return;l=h+-4|0;if((h|0)<4){if((h|0)>0){z=g;A=f;B=a;C=c}else return;while(1){s=0;do{r=Y(d[C+(s<<1)>>1]|0,d[B+(s<<1)>>1]|0)|0;d[A+(s<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;s=s+1|0}while((s|0)!=(h|0));if(!z)break;else{z=z+-1|0;A=A+(e<<1)|0;B=B+(j<<1)|0;C=C+(b<<1)|0}}return}C=h&-4;B=(C|0)<(h|0);A=g;g=f;f=a;a=c;while(1){c=0;do{z=Y(d[a+(c<<1)>>1]|0,d[f+(c<<1)>>1]|0)|0;s=c|1;r=Y(d[a+(s<<1)>>1]|0,d[f+(s<<1)>>1]|0)|0;d[g+(c<<1)>>1]=(z+32768|0)>>>0<65536?z:(z|0)>0?32767:32768;d[g+(s<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;r=c|2;s=Y(d[a+(r<<1)>>1]|0,d[f+(r<<1)>>1]|0)|0;z=c|3;q=Y(d[a+(z<<1)>>1]|0,d[f+(z<<1)>>1]|0)|0;d[g+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;d[g+(z<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;c=c+4|0}while((c|0)<=(l|0));if(B){c=C;do{q=Y(d[a+(c<<1)>>1]|0,d[f+(c<<1)>>1]|0)|0;d[g+(c<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;c=c+1|0}while((c|0)!=(h|0))}if(!A)break;else{A=A+-1|0;g=g+(e<<1)|0;f=f+(j<<1)|0;a=a+(b<<1)|0}}return}function QH(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;k=+p[j>>3];j=b>>>2;b=d>>>2;d=g>>>2;g=i+-1|0;l=(i|0)==0;if(!(k==1.0)){if(l)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){m=g;n=e;o=a;q=c}else return;while(1){r=0;do{s=rNa(k*+(f[o+(r<<2)>>2]|0)*+(f[q+(r<<2)>>2]|0))|0;f[n+(r<<2)>>2]=s;r=r+1|0}while((r|0)!=(h|0));if(!m)break;else{m=m+-1|0;n=n+(d<<2)|0;o=o+(j<<2)|0;q=q+(b<<2)|0}}return}q=h&-4;o=(q|0)<(h|0);n=g;m=e;r=a;s=c;while(1){t=0;do{u=rNa(k*+(f[r+(t<<2)>>2]|0)*+(f[s+(t<<2)>>2]|0))|0;v=t|1;w=rNa(k*+(f[r+(v<<2)>>2]|0)*+(f[s+(v<<2)>>2]|0))|0;f[m+(t<<2)>>2]=u;f[m+(v<<2)>>2]=w;w=t|2;v=rNa(k*+(f[r+(w<<2)>>2]|0)*+(f[s+(w<<2)>>2]|0))|0;u=t|3;x=rNa(k*+(f[r+(u<<2)>>2]|0)*+(f[s+(u<<2)>>2]|0))|0;f[m+(w<<2)>>2]=v;f[m+(u<<2)>>2]=x;t=t+4|0}while((t|0)<=(i|0));if(o){t=q;do{x=rNa(k*+(f[r+(t<<2)>>2]|0)*+(f[s+(t<<2)>>2]|0))|0;f[m+(t<<2)>>2]=x;t=t+1|0}while((t|0)!=(h|0))}if(!n)break;else{n=n+-1|0;m=m+(d<<2)|0;r=r+(j<<2)|0;s=s+(b<<2)|0}}return}if(l)return;l=h+-4|0;if((h|0)<4){if((h|0)>0){y=g;z=e;A=a;B=c}else return;while(1){s=0;do{r=Y(f[B+(s<<2)>>2]|0,f[A+(s<<2)>>2]|0)|0;f[z+(s<<2)>>2]=r;s=s+1|0}while((s|0)!=(h|0));if(!y)break;else{y=y+-1|0;z=z+(d<<2)|0;A=A+(j<<2)|0;B=B+(b<<2)|0}}return}B=h&-4;if((B|0)<(h|0)){C=g;D=e;E=a;F=c}else{A=g;g=e;e=a;a=c;while(1){c=0;do{z=Y(f[a+(c<<2)>>2]|0,f[e+(c<<2)>>2]|0)|0;y=c|1;s=Y(f[a+(y<<2)>>2]|0,f[e+(y<<2)>>2]|0)|0;f[g+(c<<2)>>2]=z;f[g+(y<<2)>>2]=s;s=c|2;y=Y(f[a+(s<<2)>>2]|0,f[e+(s<<2)>>2]|0)|0;z=c|3;r=Y(f[a+(z<<2)>>2]|0,f[e+(z<<2)>>2]|0)|0;f[g+(s<<2)>>2]=y;f[g+(z<<2)>>2]=r;c=c+4|0}while((c|0)<=(l|0));if(!A)break;else{A=A+-1|0;g=g+(d<<2)|0;e=e+(j<<2)|0;a=a+(b<<2)|0}}return}while(1){a=0;do{e=Y(f[F+(a<<2)>>2]|0,f[E+(a<<2)>>2]|0)|0;g=a|1;A=Y(f[F+(g<<2)>>2]|0,f[E+(g<<2)>>2]|0)|0;f[D+(a<<2)>>2]=e;f[D+(g<<2)>>2]=A;A=a|2;g=Y(f[F+(A<<2)>>2]|0,f[E+(A<<2)>>2]|0)|0;e=a|3;c=Y(f[F+(e<<2)>>2]|0,f[E+(e<<2)>>2]|0)|0;f[D+(A<<2)>>2]=g;f[D+(e<<2)>>2]=c;a=a+4|0}while((a|0)<=(l|0));G=B;do{a=Y(f[F+(G<<2)>>2]|0,f[E+(G<<2)>>2]|0)|0;f[D+(G<<2)>>2]=a;G=G+1|0}while((G|0)!=(h|0));if(!C)break;else{C=C+-1|0;D=D+(d<<2)|0;E=E+(j<<2)|0;F=F+(b<<2)|0}}return}function RH(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=+p[i>>3];i=b>>>2;b=d>>>2;d=f>>>2;f=h+-1|0;k=(h|0)==0;if(!(j==1.0)){if(k)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){l=f;m=e;o=a;q=c}else return;while(1){r=0;do{n[m+(r<<2)>>2]=j*+n[o+(r<<2)>>2]*+n[q+(r<<2)>>2];r=r+1|0}while((r|0)!=(g|0));if(!l)break;else{l=l+-1|0;m=m+(d<<2)|0;o=o+(i<<2)|0;q=q+(b<<2)|0}}return}q=g&-4;o=(q|0)<(g|0);m=f;l=e;r=a;s=c;while(1){t=0;do{u=t|1;v=j*+n[r+(u<<2)>>2]*+n[s+(u<<2)>>2];n[l+(t<<2)>>2]=j*+n[r+(t<<2)>>2]*+n[s+(t<<2)>>2];n[l+(u<<2)>>2]=v;u=t|2;w=t|3;v=j*+n[r+(w<<2)>>2]*+n[s+(w<<2)>>2];n[l+(u<<2)>>2]=j*+n[r+(u<<2)>>2]*+n[s+(u<<2)>>2];n[l+(w<<2)>>2]=v;t=t+4|0}while((t|0)<=(h|0));if(o){t=q;do{n[l+(t<<2)>>2]=j*+n[r+(t<<2)>>2]*+n[s+(t<<2)>>2];t=t+1|0}while((t|0)!=(g|0))}if(!m)break;else{m=m+-1|0;l=l+(d<<2)|0;r=r+(i<<2)|0;s=s+(b<<2)|0}}return}if(k)return;k=g+-4|0;if((g|0)<4){if((g|0)>0){x=f;y=e;z=a;A=c}else return;while(1){s=0;do{n[y+(s<<2)>>2]=+n[z+(s<<2)>>2]*+n[A+(s<<2)>>2];s=s+1|0}while((s|0)!=(g|0));if(!x)break;else{x=x+-1|0;y=y+(d<<2)|0;z=z+(i<<2)|0;A=A+(b<<2)|0}}return}A=g&-4;if((A|0)<(g|0)){B=f;C=e;D=a;E=c}else{z=f;f=e;e=a;a=c;while(1){c=0;do{y=c|1;j=+n[e+(y<<2)>>2]*+n[a+(y<<2)>>2];n[f+(c<<2)>>2]=+n[e+(c<<2)>>2]*+n[a+(c<<2)>>2];n[f+(y<<2)>>2]=j;y=c|2;x=c|3;j=+n[e+(x<<2)>>2]*+n[a+(x<<2)>>2];n[f+(y<<2)>>2]=+n[e+(y<<2)>>2]*+n[a+(y<<2)>>2];n[f+(x<<2)>>2]=j;c=c+4|0}while((c|0)<=(k|0));if(!z)break;else{z=z+-1|0;f=f+(d<<2)|0;e=e+(i<<2)|0;a=a+(b<<2)|0}}return}while(1){a=0;do{e=a|1;j=+n[D+(e<<2)>>2]*+n[E+(e<<2)>>2];n[C+(a<<2)>>2]=+n[D+(a<<2)>>2]*+n[E+(a<<2)>>2];n[C+(e<<2)>>2]=j;e=a|2;f=a|3;j=+n[D+(f<<2)>>2]*+n[E+(f<<2)>>2];n[C+(e<<2)>>2]=+n[D+(e<<2)>>2]*+n[E+(e<<2)>>2];n[C+(f<<2)>>2]=j;a=a+4|0}while((a|0)<=(k|0));F=A;do{n[C+(F<<2)>>2]=+n[D+(F<<2)>>2]*+n[E+(F<<2)>>2];F=F+1|0}while((F|0)!=(g|0));if(!B)break;else{B=B+-1|0;C=C+(d<<2)|0;D=D+(i<<2)|0;E=E+(b<<2)|0}}return}function SH(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;j=+p[i>>3];i=b>>>3;b=d>>>3;d=f>>>3;f=h+-1|0;k=(h|0)==0;if(!(j==1.0)){if(k)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){l=f;m=e;n=a;o=c}else return;while(1){q=0;do{p[m+(q<<3)>>3]=j*+p[n+(q<<3)>>3]*+p[o+(q<<3)>>3];q=q+1|0}while((q|0)!=(g|0));if(!l)break;else{l=l+-1|0;m=m+(d<<3)|0;n=n+(i<<3)|0;o=o+(b<<3)|0}}return}o=g&-4;n=(o|0)<(g|0);m=f;l=e;q=a;r=c;while(1){s=0;do{t=s|1;u=j*+p[q+(t<<3)>>3]*+p[r+(t<<3)>>3];p[l+(s<<3)>>3]=j*+p[q+(s<<3)>>3]*+p[r+(s<<3)>>3];p[l+(t<<3)>>3]=u;t=s|2;v=s|3;u=j*+p[q+(v<<3)>>3]*+p[r+(v<<3)>>3];p[l+(t<<3)>>3]=j*+p[q+(t<<3)>>3]*+p[r+(t<<3)>>3];p[l+(v<<3)>>3]=u;s=s+4|0}while((s|0)<=(h|0));if(n){s=o;do{p[l+(s<<3)>>3]=j*+p[q+(s<<3)>>3]*+p[r+(s<<3)>>3];s=s+1|0}while((s|0)!=(g|0))}if(!m)break;else{m=m+-1|0;l=l+(d<<3)|0;q=q+(i<<3)|0;r=r+(b<<3)|0}}return}if(k)return;k=g+-4|0;if((g|0)<4){if((g|0)>0){w=f;x=e;y=a;z=c}else return;while(1){r=0;do{p[x+(r<<3)>>3]=+p[y+(r<<3)>>3]*+p[z+(r<<3)>>3];r=r+1|0}while((r|0)!=(g|0));if(!w)break;else{w=w+-1|0;x=x+(d<<3)|0;y=y+(i<<3)|0;z=z+(b<<3)|0}}return}z=g&-4;if((z|0)<(g|0)){A=f;B=e;C=a;D=c}else{y=f;f=e;e=a;a=c;while(1){c=0;do{x=c|1;j=+p[e+(x<<3)>>3]*+p[a+(x<<3)>>3];p[f+(c<<3)>>3]=+p[e+(c<<3)>>3]*+p[a+(c<<3)>>3];p[f+(x<<3)>>3]=j;x=c|2;w=c|3;j=+p[e+(w<<3)>>3]*+p[a+(w<<3)>>3];p[f+(x<<3)>>3]=+p[e+(x<<3)>>3]*+p[a+(x<<3)>>3];p[f+(w<<3)>>3]=j;c=c+4|0}while((c|0)<=(k|0));if(!y)break;else{y=y+-1|0;f=f+(d<<3)|0;e=e+(i<<3)|0;a=a+(b<<3)|0}}return}while(1){a=0;do{e=a|1;j=+p[C+(e<<3)>>3]*+p[D+(e<<3)>>3];p[B+(a<<3)>>3]=+p[C+(a<<3)>>3]*+p[D+(a<<3)>>3];p[B+(e<<3)>>3]=j;e=a|2;f=a|3;j=+p[C+(f<<3)>>3]*+p[D+(f<<3)>>3];p[B+(e<<3)>>3]=+p[C+(e<<3)>>3]*+p[D+(e<<3)>>3];p[B+(f<<3)>>3]=j;a=a+4|0}while((a|0)<=(k|0));E=z;do{p[B+(E<<3)>>3]=+p[C+(E<<3)>>3]*+p[D+(E<<3)>>3];E=E+1|0}while((E|0)!=(g|0));if(!A)break;else{A=A+-1|0;B=B+(d<<3)|0;C=C+(i<<3)|0;D=D+(b<<3)|0}}return}function TH(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0;g=u;u=u+16|0;h=g;i=g+8|0;p[h>>3]=d;_$(i,30640);UG(a,b,c,fT()|0,e,30660,1,h,6);if(!(f[i+4>>2]|0)){u=g;return}u=g;return}function UH(a,c,d,e,f,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;l=+p[k>>3];k=(i|0)>0&(j|0)!=0;if(!a){if(k){m=j;n=f;o=d}else return;while(1){q=0;do{r=b[o+q>>0]|0;if(!(r<<24>>24))s=0;else{t=wNa(l/+(r&255))|0;s=(t>>>0<256?t:(t|0)>0?255:0)&255}b[n+q>>0]=s;q=q+1|0}while((q|0)!=(i|0));m=m+-1|0;if(!m)break;else{n=n+g|0;o=o+e|0}}return}else{if(k){u=j;v=f;w=a;x=d}else return;while(1){d=0;do{a=b[x+d>>0]|0;if(!(a<<24>>24))y=0;else{f=wNa(l*+(h[w+d>>0]|0)/+(a&255))|0;y=(f>>>0<256?f:(f|0)>0?255:0)&255}b[v+d>>0]=y;d=d+1|0}while((d|0)!=(i|0));u=u+-1|0;if(!u)break;else{v=v+g|0;w=w+c|0;x=x+e|0}}return}}function VH(a,c,d,e,f,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0,q=0;k=+p[j>>3];if((h|0)>0&(i|0)!=0){l=i;m=f;n=a;o=d}else return;while(1){d=0;do{a=b[o+d>>0]|0;if(!(a<<24>>24))q=0;else{f=wNa(k*+(b[n+d>>0]|0)/+(a<<24>>24))|0;q=((f+128|0)>>>0<256?f:(f|0)>0?127:128)&255}b[m+d>>0]=q;d=d+1|0}while((d|0)!=(h|0));l=l+-1|0;if(!l)break;else{m=m+g|0;n=n+c|0;o=o+e|0}}return}function WH(a,b,c,e,f,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0.0,n=0,o=0,q=0,r=0,s=0;l=b>>>1;b=e>>>1;e=g>>>1;m=+p[k>>3];if((h|0)>0&(i|0)!=0){n=i;o=f;q=a;r=c}else return;while(1){c=0;do{a=d[r+(c<<1)>>1]|0;if(!(a<<16>>16))s=0;else{f=wNa(m*+(j[q+(c<<1)>>1]|0)/+(a&65535))|0;s=(f>>>0<65536?f:(f|0)>0?65535:0)&65535}d[o+(c<<1)>>1]=s;c=c+1|0}while((c|0)!=(h|0));n=n+-1|0;if(!n)break;else{o=o+(e<<1)|0;q=q+(l<<1)|0;r=r+(b<<1)|0}}return}function XH(a,b,c,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0.0,m=0,n=0,o=0,q=0,r=0;k=b>>>1;b=e>>>1;e=g>>>1;l=+p[j>>3];if((h|0)>0&(i|0)!=0){m=i;n=f;o=a;q=c}else return;while(1){c=0;do{a=d[q+(c<<1)>>1]|0;if(!(a<<16>>16))r=0;else{f=wNa(l*+(d[o+(c<<1)>>1]|0)/+(a<<16>>16))|0;r=((f+32768|0)>>>0<65536?f:(f|0)>0?32767:32768)&65535}d[n+(c<<1)>>1]=r;c=c+1|0}while((c|0)!=(h|0));m=m+-1|0;if(!m)break;else{n=n+(e<<1)|0;o=o+(k<<1)|0;q=q+(b<<1)|0}}return}function YH(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0.0,m=0,n=0,o=0,q=0,r=0;k=b>>>2;b=d>>>2;d=g>>>2;l=+p[j>>3];if((h|0)>0&(i|0)!=0){m=i;n=e;o=a;q=c}else return;while(1){c=0;do{a=f[q+(c<<2)>>2]|0;if(!a)r=0;else r=wNa(l*+(f[o+(c<<2)>>2]|0)/+(a|0))|0;f[n+(c<<2)>>2]=r;c=c+1|0}while((c|0)!=(h|0));m=m+-1|0;if(!m)break;else{n=n+(d<<2)|0;o=o+(k<<2)|0;q=q+(b<<2)|0}}return}function ZH(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0,q=0.0,r=0.0;j=+p[i>>3];i=b>>>2;b=d>>>2;d=f>>>2;if((g|0)>0&(h|0)!=0){k=h;l=e;m=a;o=c}else return;while(1){c=0;do{q=+n[o+(c<<2)>>2];if(q!=0.0)r=j*+n[m+(c<<2)>>2]/q;else r=0.0;n[l+(c<<2)>>2]=r;c=c+1|0}while((c|0)!=(g|0));k=k+-1|0;if(!k)break;else{l=l+(d<<2)|0;m=m+(i<<2)|0;o=o+(b<<2)|0}}return}function _H(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,n=0,o=0.0,q=0.0;j=+p[i>>3];i=b>>>3;b=d>>>3;d=f>>>3;if((g|0)>0&(h|0)!=0){k=h;l=e;m=a;n=c}else return;while(1){c=0;do{o=+p[n+(c<<3)>>3];if(o!=0.0)q=j*+p[m+(c<<3)>>3]/o;else q=0.0;p[l+(c<<3)>>3]=q;c=c+1|0}while((c|0)!=(g|0));k=k+-1|0;if(!k)break;else{l=l+(d<<3)|0;m=m+(i<<3)|0;n=n+(b<<3)|0}}return}function $H(a,b,c,d){a=+a;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=e+8|0;p[g>>3]=a;_$(h,30692);UG(b,b,c,fT()|0,d,30712,1,g,7);if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function aI(a,c,d,e,f,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0;k=+p[j>>3];if((h|0)>0&(i|0)!=0){l=i;m=f;n=d}else return;while(1){d=0;do{f=b[n+d>>0]|0;if(!(f<<24>>24))o=0;else{i=wNa(k/+(f&255))|0;o=(i>>>0<256?i:(i|0)>0?255:0)&255}b[m+d>>0]=o;d=d+1|0}while((d|0)!=(h|0));l=l+-1|0;if(!l)break;else{m=m+g|0;n=n+e|0}}return}function bI(a,c,d,e,f,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0;k=+p[j>>3];if((h|0)>0&(i|0)!=0){l=i;m=f;n=d}else return;while(1){d=0;do{f=b[n+d>>0]|0;if(!(f<<24>>24))o=0;else{i=wNa(k/+(f<<24>>24))|0;o=((i+128|0)>>>0<256?i:(i|0)>0?127:128)&255}b[m+d>>0]=o;d=d+1|0}while((d|0)!=(h|0));l=l+-1|0;if(!l)break;else{m=m+g|0;n=n+e|0}}return}function cI(a,b,c,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0;b=e>>>1;e=g>>>1;k=+p[j>>3];if((h|0)>0&(i|0)!=0){l=i;m=f;n=c}else return;while(1){c=0;do{f=d[n+(c<<1)>>1]|0;if(!(f<<16>>16))o=0;else{i=wNa(k/+(f&65535))|0;o=(i>>>0<65536?i:(i|0)>0?65535:0)&65535}d[m+(c<<1)>>1]=o;c=c+1|0}while((c|0)!=(h|0));l=l+-1|0;if(!l)break;else{m=m+(e<<1)|0;n=n+(b<<1)|0}}return}function dI(a,b,c,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0;b=e>>>1;e=g>>>1;k=+p[j>>3];if((h|0)>0&(i|0)!=0){l=i;m=f;n=c}else return;while(1){c=0;do{f=d[n+(c<<1)>>1]|0;if(!(f<<16>>16))o=0;else{i=wNa(k/+(f<<16>>16))|0;o=((i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768)&65535}d[m+(c<<1)>>1]=o;c=c+1|0}while((c|0)!=(h|0));l=l+-1|0;if(!l)break;else{m=m+(e<<1)|0;n=n+(b<<1)|0}}return}function eI(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0;b=d>>>2;d=g>>>2;k=+p[j>>3];if((h|0)>0&(i|0)!=0){l=i;m=e;n=c}else return;while(1){c=0;do{e=f[n+(c<<2)>>2]|0;if(!e)o=0;else o=wNa(k/+(e|0))|0;f[m+(c<<2)>>2]=o;c=c+1|0}while((c|0)!=(h|0));l=l+-1|0;if(!l)break;else{m=m+(d<<2)|0;n=n+(b<<2)|0}}return}function fI(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0.0;j=+p[i>>3];i=d>>>2;d=f>>>2;if((g|0)>0&(h|0)!=0){k=h;l=e;m=c}else return;while(1){c=0;do{o=+n[m+(c<<2)>>2];n[l+(c<<2)>>2]=o!=0.0?j/o:0.0;c=c+1|0}while((c|0)!=(g|0));k=k+-1|0;if(!k)break;else{l=l+(d<<2)|0;m=m+(i<<2)|0}}return}function gI(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,n=0.0;j=+p[i>>3];i=d>>>3;d=f>>>3;if((g|0)>0&(h|0)!=0){k=h;l=e;m=c}else return;while(1){c=0;do{n=+p[m+(c<<3)>>3];p[l+(c<<3)>>3]=n!=0.0?j/n:0.0;c=c+1|0}while((c|0)!=(g|0));k=k+-1|0;if(!k)break;else{l=l+(d<<3)|0;m=m+(i<<3)|0}}return}function hI(a,b,c,d,e,g,h){a=a|0;b=+b;c=c|0;d=+d;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+24|0;k=i;_$(j,30744);p[k>>3]=b;p[k+8>>3]=d;p[k+16>>3]=e;UG(a,c,g,fT()|0,h,30764,1,k,8);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function iI(a,c,d,e,f,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,o=0.0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0;l=+p[k>>3];m=+p[k+8>>3];o=+p[k+16>>3];if(!j)return;k=i+-4|0;q=(i|0)<4;r=i&-4;s=j;j=f;f=a;a=d;while(1){s=s+-1|0;if(q)t=0;else{d=0;do{u=d|1;v=o+(l*+n[43492+((h[f+u>>0]|0)+128<<2)>>2]+m*+n[43492+((h[a+u>>0]|0)+128<<2)>>2]);w=wNa(o+(l*+n[43492+((h[f+d>>0]|0)+128<<2)>>2]+m*+n[43492+((h[a+d>>0]|0)+128<<2)>>2]))|0;b[j+d>>0]=w>>>0<256?w:(w|0)>0?255:0;w=wNa(v)|0;b[j+u>>0]=w>>>0<256?w:(w|0)>0?255:0;w=d|2;u=d|3;v=o+(l*+n[43492+((h[f+u>>0]|0)+128<<2)>>2]+m*+n[43492+((h[a+u>>0]|0)+128<<2)>>2]);x=wNa(o+(l*+n[43492+((h[f+w>>0]|0)+128<<2)>>2]+m*+n[43492+((h[a+w>>0]|0)+128<<2)>>2]))|0;b[j+w>>0]=x>>>0<256?x:(x|0)>0?255:0;x=wNa(v)|0;b[j+u>>0]=x>>>0<256?x:(x|0)>0?255:0;d=d+4|0}while((d|0)<=(k|0));t=r}if((t|0)<(i|0)){d=t;do{x=wNa(o+(l*+n[43492+((h[f+d>>0]|0)+128<<2)>>2]+m*+n[43492+((h[a+d>>0]|0)+128<<2)>>2]))|0;b[j+d>>0]=x>>>0<256?x:(x|0)>0?255:0;d=d+1|0}while((d|0)!=(i|0))}if(!s)break;else{j=j+g|0;f=f+c|0;a=a+e|0}}return}function jI(a,c,d,e,f,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0;k=+p[j>>3];l=+p[j+8>>3];m=+p[j+16>>3];if(!i)return;j=h+-4|0;n=(h|0)<4;o=h&-4;q=i;i=f;f=a;a=d;while(1){q=q+-1|0;if(n)r=0;else{d=0;do{s=wNa(m+(k*+(b[f+d>>0]|0)+l*+(b[a+d>>0]|0)))|0;t=d|1;u=wNa(m+(k*+(b[f+t>>0]|0)+l*+(b[a+t>>0]|0)))|0;b[i+d>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;b[i+t>>0]=(u+128|0)>>>0<256?u:(u|0)>0?127:128;u=d|2;t=wNa(m+(k*+(b[f+u>>0]|0)+l*+(b[a+u>>0]|0)))|0;s=d|3;v=wNa(m+(k*+(b[f+s>>0]|0)+l*+(b[a+s>>0]|0)))|0;b[i+u>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;b[i+s>>0]=(v+128|0)>>>0<256?v:(v|0)>0?127:128;d=d+4|0}while((d|0)<=(j|0));r=o}if((r|0)<(h|0)){d=r;do{v=wNa(m+(k*+(b[f+d>>0]|0)+l*+(b[a+d>>0]|0)))|0;b[i+d>>0]=(v+128|0)>>>0<256?v:(v|0)>0?127:128;d=d+1|0}while((d|0)!=(h|0))}if(!q)break;else{i=i+g|0;f=f+c|0;a=a+e|0}}return}function kI(a,b,c,e,f,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0.0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=+p[k>>3];m=+p[k+8>>3];n=+p[k+16>>3];k=b>>>1;b=e>>>1;e=g>>>1;if(!i)return;g=h+-4|0;o=(h|0)<4;q=h&-4;r=i;i=f;f=a;a=c;while(1){r=r+-1|0;if(o)s=0;else{c=0;do{t=wNa(n+(l*+(j[f+(c<<1)>>1]|0)+m*+(j[a+(c<<1)>>1]|0)))|0;u=c|1;v=wNa(n+(l*+(j[f+(u<<1)>>1]|0)+m*+(j[a+(u<<1)>>1]|0)))|0;d[i+(c<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;d[i+(u<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;v=c|2;u=wNa(n+(l*+(j[f+(v<<1)>>1]|0)+m*+(j[a+(v<<1)>>1]|0)))|0;t=c|3;w=wNa(n+(l*+(j[f+(t<<1)>>1]|0)+m*+(j[a+(t<<1)>>1]|0)))|0;d[i+(v<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[i+(t<<1)>>1]=w>>>0<65536?w:(w|0)>0?65535:0;c=c+4|0}while((c|0)<=(g|0));s=q}if((s|0)<(h|0)){c=s;do{w=wNa(n+(l*+(j[f+(c<<1)>>1]|0)+m*+(j[a+(c<<1)>>1]|0)))|0;d[i+(c<<1)>>1]=w>>>0<65536?w:(w|0)>0?65535:0;c=c+1|0}while((c|0)!=(h|0))}if(!r)break;else{i=i+(e<<1)|0;f=f+(k<<1)|0;a=a+(b<<1)|0}}return}function lI(a,b,c,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0;k=+p[j>>3];l=+p[j+8>>3];m=+p[j+16>>3];j=b>>>1;b=e>>>1;e=g>>>1;if(!i)return;g=h+-4|0;n=(h|0)<4;o=h&-4;q=i;i=f;f=a;a=c;while(1){q=q+-1|0;if(n)r=0;else{c=0;do{s=wNa(m+(k*+(d[f+(c<<1)>>1]|0)+l*+(d[a+(c<<1)>>1]|0)))|0;t=c|1;u=wNa(m+(k*+(d[f+(t<<1)>>1]|0)+l*+(d[a+(t<<1)>>1]|0)))|0;d[i+(c<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;d[i+(t<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;u=c|2;t=wNa(m+(k*+(d[f+(u<<1)>>1]|0)+l*+(d[a+(u<<1)>>1]|0)))|0;s=c|3;v=wNa(m+(k*+(d[f+(s<<1)>>1]|0)+l*+(d[a+(s<<1)>>1]|0)))|0;d[i+(u<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;d[i+(s<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;c=c+4|0}while((c|0)<=(g|0));r=o}if((r|0)<(h|0)){c=r;do{v=wNa(m+(k*+(d[f+(c<<1)>>1]|0)+l*+(d[a+(c<<1)>>1]|0)))|0;d[i+(c<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;c=c+1|0}while((c|0)!=(h|0))}if(!q)break;else{i=i+(e<<1)|0;f=f+(j<<1)|0;a=a+(b<<1)|0}}return}function mI(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0,u=0;k=+p[j>>3];l=+p[j+8>>3];m=+p[j+16>>3];j=b>>>2;b=d>>>2;d=g>>>2;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){n=g;o=e;q=a;r=c}else return;while(1){s=0;do{t=rNa(m+(k*+(f[q+(s<<2)>>2]|0)+l*+(f[r+(s<<2)>>2]|0)))|0;f[o+(s<<2)>>2]=t;s=s+1|0}while((s|0)!=(h|0));if(!n)break;else{n=n+-1|0;o=o+(d<<2)|0;q=q+(j<<2)|0;r=r+(b<<2)|0}}return}r=h&-4;q=(r|0)<(h|0);o=g;g=e;e=a;a=c;while(1){c=0;do{n=rNa(m+(k*+(f[e+(c<<2)>>2]|0)+l*+(f[a+(c<<2)>>2]|0)))|0;s=c|1;t=rNa(m+(k*+(f[e+(s<<2)>>2]|0)+l*+(f[a+(s<<2)>>2]|0)))|0;f[g+(c<<2)>>2]=n;f[g+(s<<2)>>2]=t;t=c|2;s=rNa(m+(k*+(f[e+(t<<2)>>2]|0)+l*+(f[a+(t<<2)>>2]|0)))|0;n=c|3;u=rNa(m+(k*+(f[e+(n<<2)>>2]|0)+l*+(f[a+(n<<2)>>2]|0)))|0;f[g+(t<<2)>>2]=s;f[g+(n<<2)>>2]=u;c=c+4|0}while((c|0)<=(i|0));if(q){c=r;do{u=rNa(m+(k*+(f[e+(c<<2)>>2]|0)+l*+(f[a+(c<<2)>>2]|0)))|0;f[g+(c<<2)>>2]=u;c=c+1|0}while((c|0)!=(h|0))}if(!o)break;else{o=o+-1|0;g=g+(d<<2)|0;e=e+(j<<2)|0;a=a+(b<<2)|0}}return}function nI(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0.0,m=0,o=0,q=0,r=0,s=0,t=0.0;j=+p[i>>3];k=+p[i+8>>3];l=+p[i+16>>3];i=b>>>2;b=d>>>2;d=f>>>2;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){m=f;o=e;q=a;r=c}else return;while(1){s=0;do{n[o+(s<<2)>>2]=l+(j*+n[q+(s<<2)>>2]+k*+n[r+(s<<2)>>2]);s=s+1|0}while((s|0)!=(g|0));if(!m)break;else{m=m+-1|0;o=o+(d<<2)|0;q=q+(i<<2)|0;r=r+(b<<2)|0}}return}r=g&-4;q=(r|0)<(g|0);o=f;f=e;e=a;a=c;while(1){c=0;do{m=c|1;t=l+(j*+n[e+(m<<2)>>2]+k*+n[a+(m<<2)>>2]);n[f+(c<<2)>>2]=l+(j*+n[e+(c<<2)>>2]+k*+n[a+(c<<2)>>2]);n[f+(m<<2)>>2]=t;m=c|2;s=c|3;t=l+(j*+n[e+(s<<2)>>2]+k*+n[a+(s<<2)>>2]);n[f+(m<<2)>>2]=l+(j*+n[e+(m<<2)>>2]+k*+n[a+(m<<2)>>2]);n[f+(s<<2)>>2]=t;c=c+4|0}while((c|0)<=(h|0));if(q){c=r;do{n[f+(c<<2)>>2]=l+(j*+n[e+(c<<2)>>2]+k*+n[a+(c<<2)>>2]);c=c+1|0}while((c|0)!=(g|0))}if(!o)break;else{o=o+-1|0;f=f+(d<<2)|0;e=e+(i<<2)|0;a=a+(b<<2)|0}}return}function oI(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;j=+p[i>>3];k=+p[i+8>>3];l=+p[i+16>>3];i=b>>>3;b=d>>>3;d=f>>>3;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){m=f;n=e;o=a;q=c}else return;while(1){r=0;do{p[n+(r<<3)>>3]=l+(j*+p[o+(r<<3)>>3]+k*+p[q+(r<<3)>>3]);r=r+1|0}while((r|0)!=(g|0));if(!m)break;else{m=m+-1|0;n=n+(d<<3)|0;o=o+(i<<3)|0;q=q+(b<<3)|0}}return}q=g&-4;if((q|0)<(g|0)){s=f;t=e;u=a;v=c}else{o=f;f=e;e=a;a=c;while(1){c=0;do{n=c|1;w=l+(j*+p[e+(n<<3)>>3]+k*+p[a+(n<<3)>>3]);p[f+(c<<3)>>3]=l+(j*+p[e+(c<<3)>>3]+k*+p[a+(c<<3)>>3]);p[f+(n<<3)>>3]=w;n=c|2;m=c|3;w=l+(j*+p[e+(m<<3)>>3]+k*+p[a+(m<<3)>>3]);p[f+(n<<3)>>3]=l+(j*+p[e+(n<<3)>>3]+k*+p[a+(n<<3)>>3]);p[f+(m<<3)>>3]=w;c=c+4|0}while((c|0)<=(h|0));if(!o)break;else{o=o+-1|0;f=f+(d<<3)|0;e=e+(i<<3)|0;a=a+(b<<3)|0}}return}while(1){a=0;do{e=a|1;w=l+(j*+p[u+(e<<3)>>3]+k*+p[v+(e<<3)>>3]);p[t+(a<<3)>>3]=l+(j*+p[u+(a<<3)>>3]+k*+p[v+(a<<3)>>3]);p[t+(e<<3)>>3]=w;e=a|2;f=a|3;w=l+(j*+p[u+(f<<3)>>3]+k*+p[v+(f<<3)>>3]);p[t+(e<<3)>>3]=l+(j*+p[u+(e<<3)>>3]+k*+p[v+(e<<3)>>3]);p[t+(f<<3)>>3]=w;a=a+4|0}while((a|0)<=(h|0));x=q;do{p[t+(x<<3)>>3]=l+(j*+p[u+(x<<3)>>3]+k*+p[v+(x<<3)>>3]);x=x+1|0}while((x|0)!=(g|0));if(!s)break;else{s=s+-1|0;t=t+(d<<3)|0;u=u+(i<<3)|0;v=v+(b<<3)|0}}return}function pI(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0.0,aa=0.0,ba=0;g=u;u=u+1456|0;h=g+1400|0;i=g+1392|0;j=g+1384|0;k=g+1264|0;l=g+1376|0;m=g+1208|0;n=g+1320|0;o=g+1192|0;q=g+1168|0;r=g+1136|0;s=g+96|0;t=g+88|0;v=g+1184|0;w=g+56|0;x=g;f[i>>2]=e;_$(j,30796);if(e>>>0>=6){f[h>>2]=0;f[h+4>>2]=0;e=c$(h,92)|0;y=157872;z=e+92|0;do{b[e>>0]=b[y>>0]|0;e=e+1|0;y=y+1|0}while((e|0)<(z|0));j$(-215,h,157965,156152,1234);d$(h)}y=NS(a)|0;if(((((NS(c)|0)==131072&1)+((y|0)==131072&1)|0)!=1?TS(a,c)|0:0)?(y=RR(a,-1)|0,(y|0)==(RR(c,-1)|0)):0){A=0;B=32}else B=6;do if((B|0)==6){y=RR(c,-1)|0;e=NS(a)|0;z=NS(c)|0;if((nS(a,-1)|0)<=2?YS(a,-1)|0:0){QR(h,a,-1);C=f[h>>2]|0;D=(C|0)==1;if(!D?(f[h+4>>2]|0)!=1:0)E=0;else{F=(y>>>3&511)+1|0;if(!((e|0)!=131072&(z|0)==131072)){z=f[h+4>>2]|0;e=(z|0)==1;if(!((C|0)==(F|0)&e|D&(e|(z|0)==(F|0))))if(D&(z|0)==4)E=F>>>0<5&(RR(a,-1)|0)==6;else E=0;else E=1}else E=0}G=E}else G=0;F=RR(a,-1)|0;z=NS(c)|0;D=NS(a)|0;if((nS(c,-1)|0)<=2?YS(c,-1)|0:0){QR(h,c,-1);e=f[h>>2]|0;C=(e|0)==1;if(!C?(f[h+4>>2]|0)!=1:0)H=0;else{y=(F>>>3&511)+1|0;if(!((z|0)!=131072&(D|0)==131072)){D=f[h+4>>2]|0;z=(D|0)==1;if(!((e|0)==(y|0)&z|C&(z|(D|0)==(y|0))))if(C&(D|0)==4)H=y>>>0<5&(RR(c,-1)|0)==6;else H=0;else H=1}else H=0}I=H}else I=0;y=G^1;if(I|y){if((y|I^1)&(G|I)){A=1;B=32;break}f[h>>2]=0;f[h+4>>2]=0;K1a(c$(h,139)|0,157973,139)|0;j$(-209,h,157965,156152,1256);d$(h);A=1;B=32;break}y=f[i>>2]|0;switch(y|0){case 3:{K=1;break}case 4:{K=2;break}case 2:{K=4;break}default:K=(y|0)==1?3:y}f[i>>2]=K;pI(c,a,d,K)}while(0);if((B|0)==32){K=NS(a)|0;I=NS(c)|0;do if((NS(a)|0)==65536){G=f[a+4>>2]|0;f[h>>2]=f[G>>2];H=h+4|0;E=G+4|0;f[H>>2]=f[E>>2];y=h+8|0;f[y>>2]=f[G+8>>2];f[h+12>>2]=f[G+12>>2];f[h+16>>2]=f[G+16>>2];f[h+20>>2]=f[G+20>>2];f[h+24>>2]=f[G+24>>2];f[h+28>>2]=f[G+28>>2];f[h+32>>2]=f[G+32>>2];D=f[G+36>>2]|0;f[h+36>>2]=D;f[h+40>>2]=y;y=h+48|0;C=h+44|0;f[C>>2]=y;f[y>>2]=0;f[h+52>>2]=0;if(D|0){y=D+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[E>>2]|0)<3){E=f[G+44>>2]|0;y=f[C>>2]|0;f[y>>2]=f[E>>2];f[y+4>>2]=f[E+4>>2];break}else{f[H>>2]=0;BR(h,G);break}}else OR(h,a,-1);while(0);do if((NS(c)|0)==65536){a=f[c+4>>2]|0;f[k>>2]=f[a>>2];G=k+4|0;H=a+4|0;f[G>>2]=f[H>>2];E=k+8|0;f[E>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];y=f[a+36>>2]|0;f[k+36>>2]=y;f[k+40>>2]=E;E=k+48|0;C=k+44|0;f[C>>2]=E;f[E>>2]=0;f[k+52>>2]=0;if(y|0){E=y+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[H>>2]|0)<3){H=f[a+44>>2]|0;E=f[C>>2]|0;f[E>>2]=f[H>>2];f[E+4>>2]=f[H+4>>2];break}else{f[G>>2]=0;BR(k,a);break}}else OR(k,c,-1);while(0);c=h+4|0;a=f[c>>2]|0;if(((K|0)==(I|0)&(a|0)<3?(f[k+4>>2]|0)<3:0)?(I=h+40|0,K=f[I>>2]|0,G=f[K+4>>2]|0,H=f[K>>2]|0,E=f[k+40>>2]|0,(H|0)==(f[E>>2]|0)?(G|0)==(f[E+4>>2]|0):0):0){E=f[h>>2]|0;C=f[k>>2]|0;y=(E>>>3&511)+1|0;if(!((C^E)&4095)){f[l>>2]=G;f[l+4>>2]=H;KS(d,l,(y<<3)+-8|0,-1,0,0);do if((NS(d)|0)==65536){l=f[d+4>>2]|0;f[m>>2]=f[l>>2];H=m+4|0;G=l+4|0;f[H>>2]=f[G>>2];D=m+8|0;f[D>>2]=f[l+8>>2];f[m+12>>2]=f[l+12>>2];f[m+16>>2]=f[l+16>>2];f[m+20>>2]=f[l+20>>2];f[m+24>>2]=f[l+24>>2];f[m+28>>2]=f[l+28>>2];f[m+32>>2]=f[l+32>>2];z=f[l+36>>2]|0;f[m+36>>2]=z;f[m+40>>2]=D;D=m+48|0;e=m+44|0;f[e>>2]=D;f[D>>2]=0;f[m+52>>2]=0;if(z|0){D=z+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[G>>2]|0)<3){G=f[l+44>>2]|0;D=f[e>>2]|0;f[D>>2]=f[G>>2];f[D+4>>2]=f[G+4>>2];L=m;break}else{f[H>>2]=0;BR(m,l);L=m;break}}else{OR(m,d,-1);L=m}while(0);l=f[h>>2]|0;H=(l>>>3&511)+1|0;G=f[k>>2]|0;D=f[L>>2]|0;L=f[h+12>>2]|0;e=f[h+8>>2]|0;z=W1a(L|0,((L|0)<0)<<31>>31|0,H|0,0)|0;F=W1a(z|0,J|0,e|0,((e|0)<0)<<31>>31|0)|0;if((l&16384&G&D|0)!=0?(F|0)==(F|0)&(((F|0)<0)<<31>>31|0)==(J|0):0){M=F;N=1}else{M=Y(L,H)|0;N=e}e=m+16|0;H=m+44|0;L=m+48|0;_h[f[30816+((l&7)<<2)>>2]&127](f[h+16>>2]|0,f[h+48>>2]|0,f[k+16>>2]|0,f[k+48>>2]|0,f[e>>2]|0,f[L>>2]|0,M,N,i);N=m+36|0;M=f[N>>2]|0;if(M|0?(l=M+12|0,M=f[l>>2]|0,f[l>>2]=M+-1,(M|0)==1):0)CR(m);f[N>>2]=0;N=m+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[N>>2]|0)>0){e=f[m+40>>2]|0;M=0;do{f[e+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[N>>2]|0))}N=f[H>>2]|0;if((N|0)!=(L|0))ZF(N);O=k+36|0}else{P=E;Q=C;R=K;S=y;T=h;U=k;V=I;B=70}}else{I=f[h>>2]|0;y=h+40|0;P=I;Q=f[k>>2]|0;R=f[y>>2]|0;S=(I>>>3&511)+1|0;T=h;U=k;V=y;B=70}if((B|0)==70){y=P&7;P=Q&7;MR(d,a,R,(S<<3)+-8|0,-1,0,0);kS(m,h,1,0);S=m+36|0;R=f[S>>2]|0;if(R|0){a=R+12|0;f[a>>2]=(f[a>>2]|0)+1}a=h+36|0;R=f[a>>2]|0;if(R|0?(Q=R+12|0,R=f[Q>>2]|0,f[Q>>2]=R+-1,(R|0)==1):0)CR(h);f[a>>2]=0;R=h+16|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[c>>2]|0)>0){Q=f[V>>2]|0;V=0;do{f[Q+(V<<2)>>2]=0;V=V+1|0;W=f[c>>2]|0}while((V|0)<(W|0));f[T>>2]=f[m>>2];if((W|0)<3)B=80;else B=82}else{f[T>>2]=f[m>>2];B=80}if((B|0)==80){T=f[m+4>>2]|0;if((T|0)<3){f[c>>2]=T;f[h+8>>2]=f[m+8>>2];f[h+12>>2]=f[m+12>>2];T=f[m+44>>2]|0;W=f[h+44>>2]|0;f[W>>2]=f[T>>2];f[W+4>>2]=f[T+4>>2]}else B=82}if((B|0)==82)BR(h,m);T=m+16|0;f[R>>2]=f[T>>2];f[h+20>>2]=f[m+20>>2];f[h+24>>2]=f[m+24>>2];f[h+28>>2]=f[m+28>>2];f[h+32>>2]=f[m+32>>2];R=f[S>>2]|0;f[a>>2]=R;if(R|0?(a=R+12|0,R=f[a>>2]|0,f[a>>2]=R+-1,(R|0)==1):0)CR(m);f[S>>2]=0;S=m+4|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[S>>2]|0)>0){T=f[m+40>>2]|0;R=0;do{f[T+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[S>>2]|0))}S=f[m+44>>2]|0;if((S|0)!=(m+48|0))ZF(S);kS(m,k,1,0);S=m+36|0;R=f[S>>2]|0;if(R|0){T=R+12|0;f[T>>2]=(f[T>>2]|0)+1}T=k+36|0;R=f[T>>2]|0;if(R|0?(a=R+12|0,R=f[a>>2]|0,f[a>>2]=R+-1,(R|0)==1):0)CR(k);f[T>>2]=0;R=k+16|0;a=k+4|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[a>>2]|0)>0){W=f[k+40>>2]|0;V=0;do{f[W+(V<<2)>>2]=0;V=V+1|0;X=f[a>>2]|0}while((V|0)<(X|0));f[U>>2]=f[m>>2];if((X|0)<3)B=101;else B=103}else{f[U>>2]=f[m>>2];B=101}if((B|0)==101){U=f[m+4>>2]|0;if((U|0)<3){f[a>>2]=U;f[k+8>>2]=f[m+8>>2];f[k+12>>2]=f[m+12>>2];U=f[m+44>>2]|0;a=f[k+44>>2]|0;f[a>>2]=f[U>>2];f[a+4>>2]=f[U+4>>2]}else B=103}if((B|0)==103)BR(k,m);U=m+16|0;f[R>>2]=f[U>>2];f[k+20>>2]=f[m+20>>2];f[k+24>>2]=f[m+24>>2];f[k+28>>2]=f[m+28>>2];f[k+32>>2]=f[m+32>>2];a=f[S>>2]|0;f[T>>2]=a;if(a|0?(X=a+12|0,a=f[X>>2]|0,f[X>>2]=a+-1,(a|0)==1):0)CR(m);f[S>>2]=0;S=m+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[S>>2]|0)>0){U=f[m+40>>2]|0;a=0;do{f[U+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[S>>2]|0))}S=f[m+44>>2]|0;if((S|0)!=(m+48|0))ZF(S);do if((NS(d)|0)==65536){S=f[d+4>>2]|0;f[n>>2]=f[S>>2];a=n+4|0;U=S+4|0;f[a>>2]=f[U>>2];X=n+8|0;f[X>>2]=f[S+8>>2];f[n+12>>2]=f[S+12>>2];f[n+16>>2]=f[S+16>>2];f[n+20>>2]=f[S+20>>2];f[n+24>>2]=f[S+24>>2];f[n+28>>2]=f[S+28>>2];f[n+32>>2]=f[S+32>>2];V=f[S+36>>2]|0;f[n+36>>2]=V;f[n+40>>2]=X;X=n+48|0;W=n+44|0;f[W>>2]=X;f[X>>2]=0;f[n+52>>2]=0;if(V|0){X=V+12|0;f[X>>2]=(f[X>>2]|0)+1}if((f[U>>2]|0)<3){U=f[S+44>>2]|0;X=f[W>>2]|0;f[X>>2]=f[U>>2];f[X+4>>2]=f[U+4>>2];break}else{f[a>>2]=0;BR(n,S);break}}else OR(n,d,-1);while(0);kS(m,n,1,0);d=n+36|0;S=f[d>>2]|0;do if(S|0){a=S+12|0;U=f[a>>2]|0;f[a>>2]=U+-1;if((U|0)!=1)break;CR(n)}while(0);f[d>>2]=0;d=n+16|0;S=n+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[S>>2]|0)>0){d=f[n+40>>2]|0;U=0;do{f[d+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[S>>2]|0))}S=f[n+44>>2]|0;if((S|0)!=(n+48|0))ZF(S);S=f[c>>2]|0;if((S|0)>0)Z=f[(f[h+44>>2]|0)+(S+-1<<2)>>2]|0;else Z=0;S=(Z|0)==0?1:Z;Z=((S+1023|0)>>>0)/(S>>>0)|0;c=f[30816+(y<<2)>>2]|0;if(A){f[o>>2]=h;f[o+4>>2]=m;f[o+8>>2]=0;bU(r,o,q,-1);A=f[r+20>>2]|0;n=Z>>>0<A>>>0?Z:A;Z=Y(n,S)|0;U=s+8|0;f[s>>2]=U;d=s+4|0;f[d>>2]=Z;if(Z>>>0>1032){a=OYa(Z)|0;f[s>>2]=a;_=a}else _=U;a:do if(y>>>0>4){aG(k,y,_,n);B=157}else{p[t>>3]=0.0;a=VI(P,6)|0;Z=f[R>>2]|0;f[v>>2]=1;f[v+4>>2]=1;Oh[a&255](Z,1,0,1,t,1,v,0);$=+p[t>>3];do if($<+p[10264+(y<<3)>>3]){Z=f[i>>2]|0;aa=(Z|0)==5|(Z+-1|0)>>>0<2?255.0:0.0;p[w>>3]=aa;p[w+8>>3]=aa;p[w+16>>3]=aa;p[w+24>>3]=aa;gL(m,w)|0}else{if($>+p[10328+(y<<3)>>3]){aa=((f[i>>2]|0)+-3|0)>>>0<3?255.0:0.0;p[w>>3]=aa;p[w+8>>3]=aa;p[w+16>>3]=aa;p[w+24>>3]=aa;gL(m,w)|0;break}Z=rNa($)|0;f[w>>2]=Z;b:do if($!=+(Z|0)){a=f[i>>2]|0;if((a|1|0)==3){X=~~$;f[w>>2]=(+(X|0)<$&1)+X;break}switch(a|0){case 1:case 4:{X=~~$;f[w>>2]=X-(+(X|0)>$&1);break b;break}default:{aa=(a|0)==5?255.0:0.0;p[x>>3]=aa;p[x+8>>3]=aa;p[x+16>>3]=aa;p[x+24>>3]=aa;gL(m,x)|0;break a}}}while(0);Z=x+4|0;f[Z>>2]=2;a=x+8|0;f[a>>2]=1;f[x+12>>2]=1;X=x+16|0;f[X>>2]=w;f[x+20>>2]=w;W=x+24|0;V=x+40|0;Q=W+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[V>>2]=a;a=x+48|0;Q=x+44|0;f[Q>>2]=a;f[x>>2]=1124024324;f[a>>2]=4;f[x+52>>2]=4;f[x+28>>2]=w+4;f[W>>2]=w+4;aG(x,y,_,n);W=x+36|0;I=f[W>>2]|0;do if(I|0){K=I+12|0;C=f[K>>2]|0;f[K>>2]=C+-1;if((C|0)!=1)break;CR(x)}while(0);f[W>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[Z>>2]|0)>0){I=f[V>>2]|0;C=0;do{f[I+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[Z>>2]|0))}Z=f[Q>>2]|0;if((Z|0)!=(a|0))ZF(Z);B=157;break a}while(0)}while(0);c:do if((B|0)==157){x=r+16|0;y=q+4|0;if(!A){w=0;while(1){if(w>>>0>=(f[x>>2]|0)>>>0)break c;tR(r)|0;w=w+1|0}}else ba=0;while(1){if(ba>>>0>=(f[x>>2]|0)>>>0)break c;w=f[q>>2]|0;t=f[y>>2]|0;v=0;do{R=A-v|0;P=R>>>0>n>>>0?n:R;_h[c&127](w,0,_,0,t,0,P,1,i);R=Y(P,S)|0;w=(f[q>>2]|0)+R|0;f[q>>2]=w;t=(f[y>>2]|0)+P|0;f[y>>2]=t;v=v+n|0}while(A>>>0>v>>>0);tR(r)|0;ba=ba+1|0}}while(0);ba=f[s>>2]|0;if((ba|0)!=(U|0)){if(ba|0)QYa(ba);f[s>>2]=U;f[d>>2]=1032}}else{f[o>>2]=h;f[o+4>>2]=k;f[o+8>>2]=m;f[o+12>>2]=0;bU(r,o,q,-1);o=f[r+20>>2]|0;d=r+16|0;U=q+4|0;s=q+8|0;ba=0;while(1){if(ba>>>0>=(f[d>>2]|0)>>>0)break;_h[c&127](f[q>>2]|0,0,f[U>>2]|0,0,f[s>>2]|0,0,o,1,i);tR(r)|0;ba=ba+1|0}}ba=m+36|0;r=f[ba>>2]|0;do if(r|0){i=r+12|0;o=f[i>>2]|0;f[i>>2]=o+-1;if((o|0)!=1)break;CR(m)}while(0);f[ba>>2]=0;ba=m+16|0;r=m+4|0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[r>>2]|0)>0){ba=f[m+40>>2]|0;o=0;do{f[ba+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[r>>2]|0))}r=f[m+44>>2]|0;if((r|0)!=(m+48|0))ZF(r);O=T}T=f[O>>2]|0;if(T|0?(r=T+12|0,T=f[r>>2]|0,f[r>>2]=T+-1,(T|0)==1):0)CR(k);f[O>>2]=0;O=k+16|0;T=k+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[T>>2]|0)>0){O=f[k+40>>2]|0;r=0;do{f[O+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[T>>2]|0))}T=f[k+44>>2]|0;if((T|0)!=(k+48|0))ZF(T);T=h+36|0;k=f[T>>2]|0;if(k|0?(r=k+12|0,k=f[r>>2]|0,f[r>>2]=k+-1,(k|0)==1):0)CR(h);f[T>>2]=0;T=h+16|0;k=h+4|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[k>>2]|0)>0){T=f[h+40>>2]|0;r=0;do{f[T+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[k>>2]|0))}k=f[h+44>>2]|0;if((k|0)!=(h+48|0))ZF(k)}if(!(f[j+4>>2]|0)){u=g;return}u=g;return}function qI(a,c,d,e,g,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;m=a;a=d;d=f[l>>2]|0;l=(d|1|0)==3;n=l?a:m;o=l?e:c;p=l?m:a;a=l?c:e;e=l?((d|0)==2?4:1):d;switch(e|0){case 1:case 4:{d=(e|0)==1?0:255;if((k|0)!=0&(j|0)>0){q=k;r=g;s=n;t=p}else return;while(1){q=q+-1|0;l=s;c=t;m=0;do{b[r+m>>0]=((h[l+m>>0]|0)>(h[c+m>>0]|0))<<31>>31^d;m=m+1|0}while((m|0)!=(j|0));if(!q)break;else{r=r+i|0;s=l+o|0;t=c+a|0}}return}case 0:case 5:{t=(e|0)==0?0:255;if((k|0)!=0&(j|0)>0){u=k;v=g;w=n;x=p}else return;while(1){u=u+-1|0;p=w;n=x;g=0;do{b[v+g>>0]=((b[p+g>>0]|0)==(b[n+g>>0]|0))<<31>>31^t;g=g+1|0}while((g|0)!=(j|0));if(!u)break;else{v=v+i|0;w=p+o|0;x=n+a|0}}return}default:return}}function rI(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;l=f[k>>2]|0;k=a;a=d;d=(l|1|0)==3;m=d?e:c;n=d?k:a;o=d?c:e;e=d?a:k;k=d?((l|0)==2?4:1):l;switch(k|0){case 1:case 4:{l=(k|0)==1?0:255;d=j+-1|0;if(!j)return;a=i+-4|0;if((i|0)<4){if((i|0)>0){p=d;q=g;r=e;s=n}else return;while(1){c=r;t=s;u=0;do{b[q+u>>0]=((b[c+u>>0]|0)>(b[t+u>>0]|0))<<31>>31^l;u=u+1|0}while((u|0)!=(i|0));if(!p)break;else{p=p+-1|0;q=q+h|0;r=c+m|0;s=t+o|0}}return}s=i&-4;if((s|0)<(i|0)){v=d;w=g;x=e;y=n}else{r=d;d=g;q=e;p=n;while(1){u=q;z=p;A=0;do{B=A|1;C=((b[u+B>>0]|0)>(b[z+B>>0]|0))<<31>>31^l;b[d+A>>0]=((b[u+A>>0]|0)>(b[z+A>>0]|0))<<31>>31^l;b[d+B>>0]=C;C=A|2;B=A|3;D=((b[u+B>>0]|0)>(b[z+B>>0]|0))<<31>>31^l;b[d+C>>0]=((b[u+C>>0]|0)>(b[z+C>>0]|0))<<31>>31^l;b[d+B>>0]=D;A=A+4|0}while((A|0)<=(a|0));if(!r)break;else{r=r+-1|0;d=d+h|0;q=u+m|0;p=z+o|0}}return}while(1){p=x;q=y;d=0;do{r=d|1;A=((b[p+r>>0]|0)>(b[q+r>>0]|0))<<31>>31^l;b[w+d>>0]=((b[p+d>>0]|0)>(b[q+d>>0]|0))<<31>>31^l;b[w+r>>0]=A;A=d|2;r=d|3;t=((b[p+r>>0]|0)>(b[q+r>>0]|0))<<31>>31^l;b[w+A>>0]=((b[p+A>>0]|0)>(b[q+A>>0]|0))<<31>>31^l;b[w+r>>0]=t;d=d+4|0}while((d|0)<=(a|0));E=s;do{b[w+E>>0]=((b[p+E>>0]|0)>(b[q+E>>0]|0))<<31>>31^l;E=E+1|0}while((E|0)!=(i|0));if(!v)break;else{v=v+-1|0;w=w+h|0;x=p+m|0;y=q+o|0}}return}case 0:case 5:{y=(k|0)==0?0:255;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){if((i|0)>0){F=k;G=g;H=e;I=n}else return;while(1){x=H;w=I;v=0;do{b[G+v>>0]=((b[x+v>>0]|0)==(b[w+v>>0]|0))<<31>>31^y;v=v+1|0}while((v|0)!=(i|0));if(!F)break;else{F=F+-1|0;G=G+h|0;H=x+m|0;I=w+o|0}}return}I=i&-4;if((I|0)<(i|0)){J=k;K=g;L=e;M=n}else{H=k;k=g;g=e;e=n;while(1){n=g;G=e;F=0;do{v=F|1;q=((b[n+v>>0]|0)==(b[G+v>>0]|0))<<31>>31^y;b[k+F>>0]=((b[n+F>>0]|0)==(b[G+F>>0]|0))<<31>>31^y;b[k+v>>0]=q;q=F|2;v=F|3;p=((b[n+v>>0]|0)==(b[G+v>>0]|0))<<31>>31^y;b[k+q>>0]=((b[n+q>>0]|0)==(b[G+q>>0]|0))<<31>>31^y;b[k+v>>0]=p;F=F+4|0}while((F|0)<=(j|0));if(!H)break;else{H=H+-1|0;k=k+h|0;g=n+m|0;e=G+o|0}}return}while(1){e=L;g=M;k=0;do{H=k|1;F=((b[e+H>>0]|0)==(b[g+H>>0]|0))<<31>>31^y;b[K+k>>0]=((b[e+k>>0]|0)==(b[g+k>>0]|0))<<31>>31^y;b[K+H>>0]=F;F=k|2;H=k|3;w=((b[e+H>>0]|0)==(b[g+H>>0]|0))<<31>>31^y;b[K+F>>0]=((b[e+F>>0]|0)==(b[g+F>>0]|0))<<31>>31^y;b[K+H>>0]=w;k=k+4|0}while((k|0)<=(j|0));N=I;do{b[K+N>>0]=((b[e+N>>0]|0)==(b[g+N>>0]|0))<<31>>31^y;N=N+1|0}while((N|0)!=(i|0));if(!J)break;else{J=J+-1|0;K=K+h|0;L=e+m|0;M=g+o|0}}return}default:return}}function sI(a,c,e,g,h,i,k,l,m){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;n=f[m>>2]|0;m=a;a=e;e=c>>>1;c=g>>>1;g=(n|1|0)==3;o=g?c:e;p=g?m:a;q=g?e:c;c=g?a:m;m=g?((n|0)==2?4:1):n;switch(m|0){case 1:case 4:{n=(m|0)==1?0:255;g=l+-1|0;if(!l)return;a=k+-4|0;if((k|0)<4){if((k|0)>0){r=g;s=h;t=c;u=p}else return;while(1){e=t;v=u;w=0;do{b[s+w>>0]=((j[e+(w<<1)>>1]|0)>(j[v+(w<<1)>>1]|0))<<31>>31^n;w=w+1|0}while((w|0)!=(k|0));if(!r)break;else{r=r+-1|0;s=s+i|0;t=e+(o<<1)|0;u=v+(q<<1)|0}}return}u=k&-4;if((u|0)<(k|0)){x=g;y=h;z=c;A=p}else{t=g;g=h;s=c;r=p;while(1){w=s;B=r;C=0;do{D=C|1;E=((j[w+(D<<1)>>1]|0)>(j[B+(D<<1)>>1]|0))<<31>>31^n;b[g+C>>0]=((j[w+(C<<1)>>1]|0)>(j[B+(C<<1)>>1]|0))<<31>>31^n;b[g+D>>0]=E;E=C|2;D=C|3;F=((j[w+(D<<1)>>1]|0)>(j[B+(D<<1)>>1]|0))<<31>>31^n;b[g+E>>0]=((j[w+(E<<1)>>1]|0)>(j[B+(E<<1)>>1]|0))<<31>>31^n;b[g+D>>0]=F;C=C+4|0}while((C|0)<=(a|0));if(!t)break;else{t=t+-1|0;g=g+i|0;s=w+(o<<1)|0;r=B+(q<<1)|0}}return}while(1){r=z;s=A;g=0;do{t=g|1;C=((j[r+(t<<1)>>1]|0)>(j[s+(t<<1)>>1]|0))<<31>>31^n;b[y+g>>0]=((j[r+(g<<1)>>1]|0)>(j[s+(g<<1)>>1]|0))<<31>>31^n;b[y+t>>0]=C;C=g|2;t=g|3;v=((j[r+(t<<1)>>1]|0)>(j[s+(t<<1)>>1]|0))<<31>>31^n;b[y+C>>0]=((j[r+(C<<1)>>1]|0)>(j[s+(C<<1)>>1]|0))<<31>>31^n;b[y+t>>0]=v;g=g+4|0}while((g|0)<=(a|0));G=u;do{b[y+G>>0]=((j[r+(G<<1)>>1]|0)>(j[s+(G<<1)>>1]|0))<<31>>31^n;G=G+1|0}while((G|0)!=(k|0));if(!x)break;else{x=x+-1|0;y=y+i|0;z=r+(o<<1)|0;A=s+(q<<1)|0}}return}case 0:case 5:{A=(m|0)==0?0:255;m=l+-1|0;if(!l)return;l=k+-4|0;if((k|0)<4){if((k|0)>0){H=m;I=h;J=c;K=p}else return;while(1){z=J;y=K;x=0;do{b[I+x>>0]=((d[z+(x<<1)>>1]|0)==(d[y+(x<<1)>>1]|0))<<31>>31^A;x=x+1|0}while((x|0)!=(k|0));if(!H)break;else{H=H+-1|0;I=I+i|0;J=z+(o<<1)|0;K=y+(q<<1)|0}}return}K=k&-4;J=(K|0)<(k|0);I=m;m=h;h=c;c=p;while(1){p=h;H=c;x=0;do{s=x|1;r=((d[p+(s<<1)>>1]|0)==(d[H+(s<<1)>>1]|0))<<31>>31^A;b[m+x>>0]=((d[p+(x<<1)>>1]|0)==(d[H+(x<<1)>>1]|0))<<31>>31^A;b[m+s>>0]=r;r=x|2;s=x|3;G=((d[p+(s<<1)>>1]|0)==(d[H+(s<<1)>>1]|0))<<31>>31^A;b[m+r>>0]=((d[p+(r<<1)>>1]|0)==(d[H+(r<<1)>>1]|0))<<31>>31^A;b[m+s>>0]=G;x=x+4|0}while((x|0)<=(l|0));if(J){x=K;do{b[m+x>>0]=((d[p+(x<<1)>>1]|0)==(d[H+(x<<1)>>1]|0))<<31>>31^A;x=x+1|0}while((x|0)!=(k|0))}if(!I)break;else{I=I+-1|0;m=m+i|0;h=p+(o<<1)|0;c=H+(q<<1)|0}}return}default:return}}function tI(a,c,e,g,h,i,j,k,l){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;m=a;a=e;e=f[l>>2]|0;l=c>>>1;c=g>>>1;g=(e|1|0)==3;n=g?a:m;o=g?c:l;p=g?m:a;a=g?l:c;c=g?((e|0)==2?4:1):e;switch(c|0){case 1:case 4:{e=(c|0)==1?0:255;if((k|0)!=0&(j|0)>0){q=k;r=h;s=n;t=p}else return;while(1){q=q+-1|0;g=s;l=t;m=0;do{b[r+m>>0]=((d[g+(m<<1)>>1]|0)>(d[l+(m<<1)>>1]|0))<<31>>31^e;m=m+1|0}while((m|0)!=(j|0));if(!q)break;else{r=r+i|0;s=g+(o<<1)|0;t=l+(a<<1)|0}}return}case 0:case 5:{t=(c|0)==0?0:255;if((k|0)!=0&(j|0)>0){u=k;v=h;w=n;x=p}else return;while(1){u=u+-1|0;p=w;n=x;h=0;do{b[v+h>>0]=((d[p+(h<<1)>>1]|0)==(d[n+(h<<1)>>1]|0))<<31>>31^t;h=h+1|0}while((h|0)!=(j|0));if(!u)break;else{v=v+i|0;w=p+(o<<1)|0;x=n+(a<<1)|0}}return}default:return}}function uI(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=f[k>>2]|0;k=a;a=d;d=c>>>2;c=e>>>2;e=(l|1|0)==3;m=e?c:d;n=e?k:a;o=e?d:c;c=e?a:k;k=e?((l|0)==2?4:1):l;switch(k|0){case 1:case 4:{l=(k|0)==1?0:255;e=j+-1|0;if(!j)return;a=i+-4|0;if((i|0)<4){if((i|0)>0){p=e;q=g;r=c;s=n}else return;while(1){d=r;t=s;u=0;do{b[q+u>>0]=((f[d+(u<<2)>>2]|0)>(f[t+(u<<2)>>2]|0))<<31>>31^l;u=u+1|0}while((u|0)!=(i|0));if(!p)break;else{p=p+-1|0;q=q+h|0;r=d+(m<<2)|0;s=t+(o<<2)|0}}return}s=i&-4;if((s|0)<(i|0)){v=e;w=g;x=c;y=n}else{r=e;e=g;q=c;p=n;while(1){u=q;z=p;A=0;do{B=A|1;C=((f[u+(B<<2)>>2]|0)>(f[z+(B<<2)>>2]|0))<<31>>31^l;b[e+A>>0]=((f[u+(A<<2)>>2]|0)>(f[z+(A<<2)>>2]|0))<<31>>31^l;b[e+B>>0]=C;C=A|2;B=A|3;D=((f[u+(B<<2)>>2]|0)>(f[z+(B<<2)>>2]|0))<<31>>31^l;b[e+C>>0]=((f[u+(C<<2)>>2]|0)>(f[z+(C<<2)>>2]|0))<<31>>31^l;b[e+B>>0]=D;A=A+4|0}while((A|0)<=(a|0));if(!r)break;else{r=r+-1|0;e=e+h|0;q=u+(m<<2)|0;p=z+(o<<2)|0}}return}while(1){p=x;q=y;e=0;do{r=e|1;A=((f[p+(r<<2)>>2]|0)>(f[q+(r<<2)>>2]|0))<<31>>31^l;b[w+e>>0]=((f[p+(e<<2)>>2]|0)>(f[q+(e<<2)>>2]|0))<<31>>31^l;b[w+r>>0]=A;A=e|2;r=e|3;t=((f[p+(r<<2)>>2]|0)>(f[q+(r<<2)>>2]|0))<<31>>31^l;b[w+A>>0]=((f[p+(A<<2)>>2]|0)>(f[q+(A<<2)>>2]|0))<<31>>31^l;b[w+r>>0]=t;e=e+4|0}while((e|0)<=(a|0));E=s;do{b[w+E>>0]=((f[p+(E<<2)>>2]|0)>(f[q+(E<<2)>>2]|0))<<31>>31^l;E=E+1|0}while((E|0)!=(i|0));if(!v)break;else{v=v+-1|0;w=w+h|0;x=p+(m<<2)|0;y=q+(o<<2)|0}}return}case 0:case 5:{y=(k|0)==0?0:255;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){if((i|0)>0){F=k;G=g;H=c;I=n}else return;while(1){x=H;w=I;v=0;do{b[G+v>>0]=((f[x+(v<<2)>>2]|0)==(f[w+(v<<2)>>2]|0))<<31>>31^y;v=v+1|0}while((v|0)!=(i|0));if(!F)break;else{F=F+-1|0;G=G+h|0;H=x+(m<<2)|0;I=w+(o<<2)|0}}return}I=i&-4;H=(I|0)<(i|0);G=k;k=g;g=c;c=n;while(1){n=g;F=c;v=0;do{q=v|1;p=((f[n+(q<<2)>>2]|0)==(f[F+(q<<2)>>2]|0))<<31>>31^y;b[k+v>>0]=((f[n+(v<<2)>>2]|0)==(f[F+(v<<2)>>2]|0))<<31>>31^y;b[k+q>>0]=p;p=v|2;q=v|3;E=((f[n+(q<<2)>>2]|0)==(f[F+(q<<2)>>2]|0))<<31>>31^y;b[k+p>>0]=((f[n+(p<<2)>>2]|0)==(f[F+(p<<2)>>2]|0))<<31>>31^y;b[k+q>>0]=E;v=v+4|0}while((v|0)<=(j|0));if(H){v=I;do{b[k+v>>0]=((f[n+(v<<2)>>2]|0)==(f[F+(v<<2)>>2]|0))<<31>>31^y;v=v+1|0}while((v|0)!=(i|0))}if(!G)break;else{G=G+-1|0;k=k+h|0;g=n+(m<<2)|0;c=F+(o<<2)|0}}return}default:return}}function vI(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;l=f[k>>2]|0;k=a;a=d;d=c>>>2;c=e>>>2;e=(l|1|0)==3;m=e?c:d;o=e?k:a;p=e?d:c;c=e?a:k;k=e?((l|0)==2?4:1):l;switch(k|0){case 1:case 4:{l=(k|0)==1?0:255;e=j+-1|0;if(!j)return;a=i+-4|0;if((i|0)<4){if((i|0)>0){q=e;r=g;s=c;t=o}else return;while(1){d=s;u=t;v=0;do{b[r+v>>0]=(+n[d+(v<<2)>>2]>+n[u+(v<<2)>>2])<<31>>31^l;v=v+1|0}while((v|0)!=(i|0));if(!q)break;else{q=q+-1|0;r=r+h|0;s=d+(m<<2)|0;t=u+(p<<2)|0}}return}t=i&-4;if((t|0)<(i|0)){w=e;x=g;y=c;z=o}else{s=e;e=g;r=c;q=o;while(1){v=r;A=q;B=0;do{C=B|1;D=(+n[v+(C<<2)>>2]>+n[A+(C<<2)>>2])<<31>>31^l;b[e+B>>0]=(+n[v+(B<<2)>>2]>+n[A+(B<<2)>>2])<<31>>31^l;b[e+C>>0]=D;D=B|2;C=B|3;E=(+n[v+(C<<2)>>2]>+n[A+(C<<2)>>2])<<31>>31^l;b[e+D>>0]=(+n[v+(D<<2)>>2]>+n[A+(D<<2)>>2])<<31>>31^l;b[e+C>>0]=E;B=B+4|0}while((B|0)<=(a|0));if(!s)break;else{s=s+-1|0;e=e+h|0;r=v+(m<<2)|0;q=A+(p<<2)|0}}return}while(1){q=y;r=z;e=0;do{s=e|1;B=(+n[q+(s<<2)>>2]>+n[r+(s<<2)>>2])<<31>>31^l;b[x+e>>0]=(+n[q+(e<<2)>>2]>+n[r+(e<<2)>>2])<<31>>31^l;b[x+s>>0]=B;B=e|2;s=e|3;u=(+n[q+(s<<2)>>2]>+n[r+(s<<2)>>2])<<31>>31^l;b[x+B>>0]=(+n[q+(B<<2)>>2]>+n[r+(B<<2)>>2])<<31>>31^l;b[x+s>>0]=u;e=e+4|0}while((e|0)<=(a|0));F=t;do{b[x+F>>0]=(+n[q+(F<<2)>>2]>+n[r+(F<<2)>>2])<<31>>31^l;F=F+1|0}while((F|0)!=(i|0));if(!w)break;else{w=w+-1|0;x=x+h|0;y=q+(m<<2)|0;z=r+(p<<2)|0}}return}case 0:case 5:{z=(k|0)==0?0:255;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){if((i|0)>0){G=k;H=g;I=c;J=o}else return;while(1){y=I;x=J;w=0;do{b[H+w>>0]=(+n[y+(w<<2)>>2]==+n[x+(w<<2)>>2])<<31>>31^z;w=w+1|0}while((w|0)!=(i|0));if(!G)break;else{G=G+-1|0;H=H+h|0;I=y+(m<<2)|0;J=x+(p<<2)|0}}return}J=i&-4;I=(J|0)<(i|0);H=k;k=g;g=c;c=o;while(1){o=g;G=c;w=0;do{r=w|1;q=(+n[o+(r<<2)>>2]==+n[G+(r<<2)>>2])<<31>>31^z;b[k+w>>0]=(+n[o+(w<<2)>>2]==+n[G+(w<<2)>>2])<<31>>31^z;b[k+r>>0]=q;q=w|2;r=w|3;F=(+n[o+(r<<2)>>2]==+n[G+(r<<2)>>2])<<31>>31^z;b[k+q>>0]=(+n[o+(q<<2)>>2]==+n[G+(q<<2)>>2])<<31>>31^z;b[k+r>>0]=F;w=w+4|0}while((w|0)<=(j|0));if(I){w=J;do{b[k+w>>0]=(+n[o+(w<<2)>>2]==+n[G+(w<<2)>>2])<<31>>31^z;w=w+1|0}while((w|0)!=(i|0))}if(!H)break;else{H=H+-1|0;k=k+h|0;g=o+(m<<2)|0;c=G+(p<<2)|0}}return}default:return}}function wI(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;l=f[k>>2]|0;k=a;a=d;d=c>>>3;c=e>>>3;e=(l|1|0)==3;m=e?c:d;n=e?k:a;o=e?d:c;c=e?a:k;k=e?((l|0)==2?4:1):l;switch(k|0){case 1:case 4:{l=(k|0)==1?0:255;e=j+-1|0;if(!j)return;a=i+-4|0;if((i|0)<4){if((i|0)>0){q=e;r=g;s=c;t=n}else return;while(1){d=s;u=t;v=0;do{b[r+v>>0]=(+p[d+(v<<3)>>3]>+p[u+(v<<3)>>3])<<31>>31^l;v=v+1|0}while((v|0)!=(i|0));if(!q)break;else{q=q+-1|0;r=r+h|0;s=d+(m<<3)|0;t=u+(o<<3)|0}}return}t=i&-4;if((t|0)<(i|0)){w=e;x=g;y=c;z=n}else{s=e;e=g;r=c;q=n;while(1){v=r;A=q;B=0;do{C=B|1;D=(+p[v+(C<<3)>>3]>+p[A+(C<<3)>>3])<<31>>31^l;b[e+B>>0]=(+p[v+(B<<3)>>3]>+p[A+(B<<3)>>3])<<31>>31^l;b[e+C>>0]=D;D=B|2;C=B|3;E=(+p[v+(C<<3)>>3]>+p[A+(C<<3)>>3])<<31>>31^l;b[e+D>>0]=(+p[v+(D<<3)>>3]>+p[A+(D<<3)>>3])<<31>>31^l;b[e+C>>0]=E;B=B+4|0}while((B|0)<=(a|0));if(!s)break;else{s=s+-1|0;e=e+h|0;r=v+(m<<3)|0;q=A+(o<<3)|0}}return}while(1){q=y;r=z;e=0;do{s=e|1;B=(+p[q+(s<<3)>>3]>+p[r+(s<<3)>>3])<<31>>31^l;b[x+e>>0]=(+p[q+(e<<3)>>3]>+p[r+(e<<3)>>3])<<31>>31^l;b[x+s>>0]=B;B=e|2;s=e|3;u=(+p[q+(s<<3)>>3]>+p[r+(s<<3)>>3])<<31>>31^l;b[x+B>>0]=(+p[q+(B<<3)>>3]>+p[r+(B<<3)>>3])<<31>>31^l;b[x+s>>0]=u;e=e+4|0}while((e|0)<=(a|0));F=t;do{b[x+F>>0]=(+p[q+(F<<3)>>3]>+p[r+(F<<3)>>3])<<31>>31^l;F=F+1|0}while((F|0)!=(i|0));if(!w)break;else{w=w+-1|0;x=x+h|0;y=q+(m<<3)|0;z=r+(o<<3)|0}}return}case 0:case 5:{z=(k|0)==0?0:255;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){if((i|0)>0){G=k;H=g;I=c;J=n}else return;while(1){y=I;x=J;w=0;do{b[H+w>>0]=(+p[y+(w<<3)>>3]==+p[x+(w<<3)>>3])<<31>>31^z;w=w+1|0}while((w|0)!=(i|0));if(!G)break;else{G=G+-1|0;H=H+h|0;I=y+(m<<3)|0;J=x+(o<<3)|0}}return}J=i&-4;I=(J|0)<(i|0);H=k;k=g;g=c;c=n;while(1){n=g;G=c;w=0;do{r=w|1;q=(+p[n+(r<<3)>>3]==+p[G+(r<<3)>>3])<<31>>31^z;b[k+w>>0]=(+p[n+(w<<3)>>3]==+p[G+(w<<3)>>3])<<31>>31^z;b[k+r>>0]=q;q=w|2;r=w|3;F=(+p[n+(r<<3)>>3]==+p[G+(r<<3)>>3])<<31>>31^z;b[k+q>>0]=(+p[n+(q<<3)>>3]==+p[G+(q<<3)>>3])<<31>>31^z;b[k+r>>0]=F;w=w+4|0}while((w|0)<=(j|0));if(I){w=J;do{b[k+w>>0]=(+p[n+(w<<3)>>3]==+p[G+(w<<3)>>3])<<31>>31^z;w=w+1|0}while((w|0)!=(i|0))}if(!H)break;else{H=H+-1|0;k=k+h|0;g=n+(m<<3)|0;c=G+(o<<3)|0}}return}default:return}}function xI(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;g=u;u=u+1488|0;h=g+1432|0;i=g+1424|0;j=g+1368|0;k=g+1312|0;l=g+1256|0;m=g+1200|0;n=g+1188|0;o=g+1168|0;q=g+1144|0;r=g+1104|0;s=g+64|0;t=g+1160|0;v=g+1136|0;w=g;x=g+56|0;_$(i,30848);y=NS(a)|0;z=NS(c)|0;A=NS(d)|0;do if((NS(a)|0)==65536){B=f[a+4>>2]|0;f[j>>2]=f[B>>2];C=j+4|0;D=B+4|0;f[C>>2]=f[D>>2];E=j+8|0;f[E>>2]=f[B+8>>2];f[j+12>>2]=f[B+12>>2];f[j+16>>2]=f[B+16>>2];f[j+20>>2]=f[B+20>>2];f[j+24>>2]=f[B+24>>2];f[j+28>>2]=f[B+28>>2];f[j+32>>2]=f[B+32>>2];F=f[B+36>>2]|0;f[j+36>>2]=F;f[j+40>>2]=E;E=j+48|0;G=j+44|0;f[G>>2]=E;f[E>>2]=0;f[j+52>>2]=0;if(F|0){E=F+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[D>>2]|0)<3){D=f[B+44>>2]|0;E=f[G>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2];break}else{f[C>>2]=0;BR(j,B);break}}else OR(j,a,-1);while(0);do if((NS(c)|0)==65536){a=f[c+4>>2]|0;f[k>>2]=f[a>>2];B=k+4|0;C=a+4|0;f[B>>2]=f[C>>2];D=k+8|0;f[D>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];E=f[a+36>>2]|0;f[k+36>>2]=E;f[k+40>>2]=D;D=k+48|0;G=k+44|0;f[G>>2]=D;f[D>>2]=0;f[k+52>>2]=0;if(E|0){D=E+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[C>>2]|0)<3){C=f[a+44>>2]|0;D=f[G>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2];break}else{f[B>>2]=0;BR(k,a);break}}else OR(k,c,-1);while(0);do if((NS(d)|0)==65536){c=f[d+4>>2]|0;f[l>>2]=f[c>>2];a=l+4|0;B=c+4|0;f[a>>2]=f[B>>2];C=l+8|0;f[C>>2]=f[c+8>>2];f[l+12>>2]=f[c+12>>2];f[l+16>>2]=f[c+16>>2];f[l+20>>2]=f[c+20>>2];f[l+24>>2]=f[c+24>>2];f[l+28>>2]=f[c+28>>2];f[l+32>>2]=f[c+32>>2];D=f[c+36>>2]|0;f[l+36>>2]=D;f[l+40>>2]=C;C=l+48|0;G=l+44|0;f[G>>2]=C;f[C>>2]=0;f[l+52>>2]=0;if(D|0){C=D+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[B>>2]|0)<3){B=f[c+44>>2]|0;C=f[G>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2];break}else{f[a>>2]=0;BR(l,c);break}}else OR(l,d,-1);while(0);d=(y|0)!=131072;a:do if(!(d&(z|0)==131072)?(c=f[j+40>>2]|0,a=f[c+-4>>2]|0,B=f[k+40>>2]|0,(a|0)==(f[B+-4>>2]|0)):0){if((a|0)==2){if((f[c>>2]|0)!=(f[B>>2]|0)){H=31;break}if((f[c+4>>2]|0)!=(f[B+4>>2]|0)){H=31;break}}else if((a|0)>0){C=0;do{if((f[c+(C<<2)>>2]|0)!=(f[B+(C<<2)>>2]|0)){H=31;break a}C=C+1|0}while((C|0)<(a|0))}if(!((f[k>>2]^f[j>>2])&4095))I=0;else H=31}else H=31;while(0);do if((H|0)==31){a=f[j>>2]|0;if((((f[k+4>>2]|0)<=2?(C=f[k>>2]|0,C&16384|0):0)?(B=f[k+40>>2]|0,c=f[B+4>>2]|0,G=f[B>>2]|0,B=(c|0)==1,D=(G|0)==1,B|D):0)?(E=(a>>>3&511)+1|0,!((y|0)==131072&(z|0)!=131072)):0){if((c|0)==(E|0)&D|B&(D|(G|0)==(E|0))){I=1;break}if(!(E>>>0>4|(C&4095|0)!=6|B&(G|0)==4^1)){I=1;break}}f[h>>2]=0;f[h+4>>2]=0;J=c$(h,90)|0;K=158172;L=J+90|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));j$(-209,h,158263,156152,1769);d$(h);I=1}while(0);b:do if(!(d&(A|0)==131072)?(z=f[j+40>>2]|0,G=f[z+-4>>2]|0,B=f[l+40>>2]|0,(G|0)==(f[B+-4>>2]|0)):0){if((G|0)==2){if((f[z>>2]|0)!=(f[B>>2]|0)){H=47;break}if((f[z+4>>2]|0)!=(f[B+4>>2]|0)){H=47;break}}else if((G|0)>0){C=0;do{if((f[z+(C<<2)>>2]|0)!=(f[B+(C<<2)>>2]|0)){H=47;break b}C=C+1|0}while((C|0)<(G|0))}if(!((f[l>>2]^f[j>>2])&4095)){G=I&1;if(I){M=0;N=G;O=0;H=56}else{P=0;Q=G;R=j;S=0}}else H=47}else H=47;while(0);if((H|0)==47){d=f[j>>2]|0;if((((f[l+4>>2]|0)<=2?(G=f[l>>2]|0,(G&16384|0)!=0):0)?(C=f[l+40>>2]|0,B=f[C+4>>2]|0,z=f[C>>2]|0,C=(B|0)==1,E=(z|0)==1,C|E):0)?(D=(d>>>3&511)+1|0,!((y|0)==131072&(A|0)!=131072)):0){if(!((B|0)==(D|0)&E|C&(E|(z|0)==(D|0)))?D>>>0>4|(G&4095|0)!=6|C&(z|0)==4^1:0)H=53}else H=53;if((H|0)==53){f[h>>2]=0;f[h+4>>2]=0;J=c$(h,90)|0;K=158271;L=J+90|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));j$(-209,h,158263,156152,1778);d$(h)}z=I&1;if(I){P=1;Q=z;R=j;S=1}else{M=1;N=z;O=1;H=56}}if((H|0)==56){f[h>>2]=0;f[h+4>>2]=0;J=c$(h,20)|0;K=158362;L=J+20|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));j$(-215,h,158263,156152,1782);d$(h);P=M;Q=N;R=j;S=O}O=f[R>>2]|0;N=O>>>3;M=N&511;z=M+1|0;C=O&7;O=j+4|0;G=f[O>>2]|0;if((G|0)>0)T=f[(f[j+44>>2]|0)+(G+-1<<2)>>2]|0;else T=0;D=((T+1023|0)>>>0)/(T>>>0)|0;E=j+40|0;MR(e,G,f[E>>2]|0,0,-1,0,0);do if((NS(e)|0)==65536){G=f[e+4>>2]|0;f[m>>2]=f[G>>2];B=m+4|0;A=G+4|0;f[B>>2]=f[A>>2];y=m+8|0;f[y>>2]=f[G+8>>2];f[m+12>>2]=f[G+12>>2];f[m+16>>2]=f[G+16>>2];f[m+20>>2]=f[G+20>>2];f[m+24>>2]=f[G+24>>2];f[m+28>>2]=f[G+28>>2];f[m+32>>2]=f[G+32>>2];d=f[G+36>>2]|0;f[m+36>>2]=d;f[m+40>>2]=y;y=m+48|0;c=m+44|0;f[c>>2]=y;f[y>>2]=0;f[m+52>>2]=0;if(d|0){y=d+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[A>>2]|0)<3){A=f[G+44>>2]|0;y=f[c>>2]|0;f[y>>2]=f[A>>2];f[y+4>>2]=f[A+4>>2];break}else{f[B>>2]=0;BR(m,G);break}}else OR(m,e,-1);while(0);e=f[30868+(C<<2)>>2]|0;f[n>>2]=j;f[n+4>>2]=m;f[n+8>>2]=0;f[o>>2]=j;f[o+4>>2]=m;f[o+8>>2]=k;f[o+12>>2]=l;f[o+16>>2]=0;G=I&S;bU(r,G?n:o,q,-1);o=f[r+20>>2]|0;n=D>>>0<o>>>0?D:o;D=(z<<3)+128+(Y(n,(Y(T,Q+P|0)|0)+z|0)|0)|0;P=s+8|0;f[s>>2]=P;Q=s+4|0;f[Q>>2]=D;if(D>>>0>1032){B=OYa(D)|0;f[s>>2]=B;U=B}else U=P;B=U+(Y(n,z)|0)+15&-16;if(G){G=Y(n,T)|0;D=B+G+15&-16;A=f[k>>2]|0;if(!((f[l>>2]^A)&4095))V=A;else{f[h>>2]=0;f[h+4>>2]=0;J=c$(h,22)|0;K=158383;L=J+22|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));j$(-215,h,158263,156152,1809);d$(h);V=f[k>>2]|0}A=V&7;if(C>>>0<4&(A|0)!=(C|0)){V=D+G+15&-16;G=V;y=V;c=y+(z<<2)|0;d=VI(A,4)|0;A=k+16|0;a=f[A>>2]|0;F=k+44|0;f[t>>2]=z;f[t+4>>2]=1;Oh[d&255](a,1,0,1,G,1,t,0);t=l+16|0;a=f[t>>2]|0;W=l+44|0;f[v>>2]=z;f[v+4>>2]=1;Oh[d&255](a,1,0,1,c,1,v,0);v=rNa(+p[10264+(C<<3)>>3])|0;a=rNa(+p[10328+(C<<3)>>3])|0;C=v+1|0;d=0;do{X=y+(d<<2)|0;Z=f[X>>2]|0;_=c+(d<<2)|0;$=f[_>>2]|0;if(($|0)<(v|0)|((Z|0)>(a|0)|(Z|0)>($|0))){f[X>>2]=C;f[_>>2]=v}d=d+1|0}while((d|0)!=(z|0));f[w>>2]=1124007940;d=w+4|0;f[d>>2]=2;v=w+8|0;f[v>>2]=z;C=w+12|0;f[C>>2]=1;a=w+16|0;f[a>>2]=G;y=w+20|0;f[y>>2]=G;_=w+24|0;X=w+28|0;$=w+40|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;f[$>>2]=v;Z=w+48|0;aa=w+44|0;f[aa>>2]=Z;f[w+52>>2]=0;f[Z>>2]=0;if(!V){f[h>>2]=0;f[h+4>>2]=0;J=c$(h,26)|0;K=358223;L=J+26|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));j$(-215,h,358250,358254,500);d$(h);K=w+36|0;ba=f[C>>2]|0;ca=f[w>>2]|0;da=f[aa>>2]|0;ea=f[y>>2]|0;fa=f[K>>2]|0;ga=K}else{ba=1;ca=1124007940;da=Z;ea=G;fa=0;ga=w+36|0}G=ba<<2;f[w>>2]=ca|16384;f[da>>2]=G;f[da+4>>2]=4;da=ea+(Y(f[v>>2]|0,G)|0)|0;f[X>>2]=da;f[_>>2]=da+(0-G)+G;if(fa|0){G=fa+12|0;f[G>>2]=(f[G>>2]|0)+1}G=k+36|0;fa=f[G>>2]|0;if(fa|0?(da=fa+12|0,fa=f[da>>2]|0,f[da>>2]=fa+-1,(fa|0)==1):0)CR(k);f[G>>2]=0;fa=k+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[fa>>2]|0)>0){da=f[k+40>>2]|0;ea=0;do{f[da+(ea<<2)>>2]=0;ea=ea+1|0;ha=f[fa>>2]|0}while((ea|0)<(ha|0));f[k>>2]=f[w>>2];if((ha|0)<3)H=89;else H=91}else{f[k>>2]=f[w>>2];H=89}if((H|0)==89){ha=f[d>>2]|0;if((ha|0)<3){f[fa>>2]=ha;f[k+8>>2]=f[v>>2];f[k+12>>2]=f[C>>2];C=f[aa>>2]|0;v=f[F>>2]|0;f[v>>2]=f[C>>2];f[v+4>>2]=f[C+4>>2]}else H=91}if((H|0)==91)BR(k,w);f[A>>2]=f[a>>2];f[k+20>>2]=f[y>>2];f[k+24>>2]=f[_>>2];f[k+28>>2]=f[X>>2];f[k+32>>2]=f[w+32>>2];X=f[ga>>2]|0;f[G>>2]=X;if(X|0?(G=X+12|0,X=f[G>>2]|0,f[G>>2]=X+-1,(X|0)==1):0)CR(w);f[ga>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[d>>2]|0)>0){a=f[$>>2]|0;$=0;do{f[a+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[d>>2]|0))}d=f[aa>>2]|0;if((d|0)!=(Z|0))ZF(d);d=h+4|0;f[d>>2]=2;Z=h+8|0;f[Z>>2]=z;aa=h+12|0;f[aa>>2]=1;$=h+16|0;f[$>>2]=c;a=h+20|0;f[a>>2]=c;ga=h+24|0;w=h+28|0;X=h+40|0;G=ga+8|0;f[G>>2]=0;f[G+4>>2]=0;f[X>>2]=Z;G=h+48|0;_=h+44|0;f[_>>2]=G;f[h>>2]=1124024324;f[G>>2]=4;f[h+52>>2]=4;y=c+(z<<2)|0;f[w>>2]=y;f[ga>>2]=y+-4+4;y=h+36|0;c=l+36|0;A=f[c>>2]|0;do if(A|0){C=A+12|0;v=f[C>>2]|0;f[C>>2]=v+-1;if((v|0)!=1)break;CR(l)}while(0);f[c>>2]=0;A=l+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[A>>2]|0)>0){v=f[l+40>>2]|0;C=0;do{f[v+(C<<2)>>2]=0;C=C+1|0;ia=f[A>>2]|0}while((C|0)<(ia|0));f[l>>2]=f[h>>2];if((ia|0)<3)H=108;else H=110}else{f[l>>2]=f[h>>2];H=108}do if((H|0)==108){ia=f[d>>2]|0;if((ia|0)>=3){H=110;break}f[A>>2]=ia;f[l+8>>2]=f[Z>>2];f[l+12>>2]=f[aa>>2];ia=f[_>>2]|0;C=f[W>>2]|0;f[C>>2]=f[ia>>2];f[C+4>>2]=f[ia+4>>2]}while(0);if((H|0)==110)BR(l,h);f[t>>2]=f[$>>2];f[l+20>>2]=f[a>>2];f[l+24>>2]=f[ga>>2];f[l+28>>2]=f[w>>2];f[l+32>>2]=f[h+32>>2];w=f[y>>2]|0;f[c>>2]=w;do if(w|0){c=w+12|0;ga=f[c>>2]|0;f[c>>2]=ga+-1;if((ga|0)!=1)break;CR(h)}while(0);f[y>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[d>>2]|0)>0){$=f[X>>2]|0;X=0;do{f[$+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[d>>2]|0))}d=f[_>>2]|0;if((d|0)!=(G|0))ZF(d)}aG(k,f[R>>2]&4095,B,n);aG(l,f[R>>2]&4095,D,n);ja=B;ka=D}else{ja=0;ka=0}D=r+16|0;B=(o|0)==0;R=q+((I?2:3)<<2)|0;d=(M|0)==0;G=q+4|0;_=x+4|0;X=N+1&3;N=(X|0)==0?4:X;X=N&255;$=N>>>0>=z>>>0;y=q+8|0;h=0;while(1){if(h>>>0>=(f[D>>2]|0)>>>0)break;if(!B){w=0;do{ga=o-w|0;c=ga>>>0>n>>>0?n:ga;ga=Y(c,T)|0;if(I)la=ja;else{a=f[y>>2]|0;f[y>>2]=a+ga;la=a}if(S)ma=ka;else{a=f[R>>2]|0;f[R>>2]=a+ga;ma=a}a=f[q>>2]|0;t=d?f[G>>2]|0:U;H=Y(c,z)|0;f[x>>2]=H;f[_>>2]=1;_h[e&127](a,0,la,0,ma,0,t,0,x);c:do if(!d){t=f[G>>2]|0;switch(X&7){case 1:{if(!c)break c;else{na=0;oa=0}while(1){b[t+na>>0]=b[U+oa>>0]|0;na=na+1|0;if((na|0)==(c|0))break;else oa=oa+z|0}break}case 2:{if(!c)break c;else{pa=0;qa=0}while(1){b[t+pa>>0]=b[U+(qa+1)>>0]&b[U+qa>>0];pa=pa+1|0;if((pa|0)==(c|0))break;else qa=qa+z|0}break}case 3:{if(!c)break c;else{ra=0;sa=0}while(1){b[t+ra>>0]=b[U+(sa+1)>>0]&b[U+sa>>0]&b[U+(sa+2)>>0];ra=ra+1|0;if((ra|0)==(c|0))break;else sa=sa+z|0}break}default:{if(!c)break c;else{ta=0;ua=0}while(1){b[t+ta>>0]=b[U+(ua+1)>>0]&b[U+ua>>0]&b[U+(ua+2)>>0]&b[U+(ua+3)>>0];ta=ta+1|0;if((ta|0)==(c|0))break;else ua=ua+z|0}}}if(!($|(c|0)==0)){a=N;do{H=0;W=a;while(1){aa=t+H|0;b[aa>>0]=b[U+(W+1)>>0]&b[U+W>>0]&b[U+(W+2)>>0]&b[U+(W+3)>>0]&b[aa>>0];H=H+1|0;if((H|0)==(c|0))break;else W=W+z|0}a=a+4|0}while((a|0)<=(M|0))}}while(0);f[q>>2]=(f[q>>2]|0)+ga;f[G>>2]=(f[G>>2]|0)+c;w=w+n|0}while(o>>>0>w>>>0)}tR(r)|0;h=h+1|0}h=f[s>>2]|0;if((h|0)!=(P|0)){if(h|0)QYa(h);f[s>>2]=P;f[Q>>2]=1032}Q=m+36|0;P=f[Q>>2]|0;if(P|0?(s=P+12|0,P=f[s>>2]|0,f[s>>2]=P+-1,(P|0)==1):0)CR(m);f[Q>>2]=0;Q=m+16|0;P=m+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[P>>2]|0)>0){Q=f[m+40>>2]|0;s=0;do{f[Q+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[P>>2]|0))}P=f[m+44>>2]|0;if((P|0)!=(m+48|0))ZF(P);P=l+36|0;m=f[P>>2]|0;if(m|0?(s=m+12|0,m=f[s>>2]|0,f[s>>2]=m+-1,(m|0)==1):0)CR(l);f[P>>2]=0;P=l+16|0;m=l+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[m>>2]|0)>0){P=f[l+40>>2]|0;s=0;do{f[P+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))ZF(m);m=k+36|0;l=f[m>>2]|0;if(l|0?(s=l+12|0,l=f[s>>2]|0,f[s>>2]=l+-1,(l|0)==1):0)CR(k);f[m>>2]=0;m=k+16|0;l=k+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[l>>2]|0)>0){m=f[k+40>>2]|0;s=0;do{f[m+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))ZF(l);l=j+36|0;k=f[l>>2]|0;do if(k|0){s=k+12|0;m=f[s>>2]|0;f[s>>2]=m+-1;if((m|0)!=1)break;CR(j)}while(0);f[l>>2]=0;l=j+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[O>>2]|0)>0){l=f[E>>2]|0;E=0;do{f[l+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[O>>2]|0))}O=f[j+44>>2]|0;if((O|0)!=(j+48|0))ZF(O);if(!(f[i+4>>2]|0)){u=g;return}u=g;return}function yI(a,c,d,e,g,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;m=f[l>>2]|0;n=f[l+4>>2]|0;if(!n)return;l=m+-4|0;if((m|0)<4){o=(m|0)>0;p=n;q=j;r=a;s=d;t=g;while(1){p=p+-1|0;if(o){u=0;do{v=b[r+u>>0]|0;if((h[s+u>>0]|0)>(v&255))w=0;else w=(v&255)<=(h[t+u>>0]|0);b[q+u>>0]=w<<31>>31;u=u+1|0}while((u|0)!=(m|0))}if(!p)break;else{q=q+k|0;r=r+c|0;s=s+e|0;t=t+i|0}}return}t=m&-4;s=(t|0)<(m|0);r=n;n=j;j=a;a=d;d=g;while(1){g=0;do{q=b[j+g>>0]|0;if((h[a+g>>0]|0)>(q&255))x=0;else x=(q&255)<=(h[d+g>>0]|0);q=g|1;p=b[j+q>>0]|0;if((h[a+q>>0]|0)>(p&255))y=0;else y=(p&255)<=(h[d+q>>0]|0);b[n+g>>0]=x<<31>>31;b[n+q>>0]=y<<31>>31;q=g|2;p=b[j+q>>0]|0;if((h[a+q>>0]|0)>(p&255))z=0;else z=(p&255)<=(h[d+q>>0]|0);p=g|3;w=b[j+p>>0]|0;if((h[a+p>>0]|0)>(w&255))A=0;else A=(w&255)<=(h[d+p>>0]|0);b[n+q>>0]=z<<31>>31;b[n+p>>0]=A<<31>>31;g=g+4|0}while((g|0)<=(l|0));r=r+-1|0;if(s){g=t;do{p=b[j+g>>0]|0;if((h[a+g>>0]|0)>(p&255))B=0;else B=(p&255)<=(h[d+g>>0]|0);b[n+g>>0]=B<<31>>31;g=g+1|0}while((g|0)!=(m|0))}if(!r)break;else{n=n+k|0;j=j+c|0;a=a+e|0;d=d+i|0}}return}function zI(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;l=f[k>>2]|0;m=f[k+4>>2]|0;if(!m)return;k=l+-4|0;if((l|0)<4){n=(l|0)>0;o=m;p=i;q=a;r=d;s=g;while(1){o=o+-1|0;if(n){t=0;do{u=b[q+t>>0]|0;if((b[r+t>>0]|0)>u<<24>>24)v=0;else v=u<<24>>24<=(b[s+t>>0]|0);b[p+t>>0]=v<<31>>31;t=t+1|0}while((t|0)!=(l|0))}if(!o)break;else{p=p+j|0;q=q+c|0;r=r+e|0;s=s+h|0}}return}s=l&-4;r=(s|0)<(l|0);q=m;m=i;i=a;a=d;d=g;while(1){g=0;do{p=b[i+g>>0]|0;if((b[a+g>>0]|0)>p<<24>>24)w=0;else w=p<<24>>24<=(b[d+g>>0]|0);p=g|1;o=b[i+p>>0]|0;if((b[a+p>>0]|0)>o<<24>>24)x=0;else x=o<<24>>24<=(b[d+p>>0]|0);b[m+g>>0]=w<<31>>31;b[m+p>>0]=x<<31>>31;p=g|2;o=b[i+p>>0]|0;if((b[a+p>>0]|0)>o<<24>>24)y=0;else y=o<<24>>24<=(b[d+p>>0]|0);o=g|3;v=b[i+o>>0]|0;if((b[a+o>>0]|0)>v<<24>>24)z=0;else z=v<<24>>24<=(b[d+o>>0]|0);b[m+p>>0]=y<<31>>31;b[m+o>>0]=z<<31>>31;g=g+4|0}while((g|0)<=(k|0));q=q+-1|0;if(r){g=s;do{o=b[i+g>>0]|0;if((b[a+g>>0]|0)>o<<24>>24)A=0;else A=o<<24>>24<=(b[d+g>>0]|0);b[m+g>>0]=A<<31>>31;g=g+1|0}while((g|0)!=(l|0))}if(!q)break;else{m=m+j|0;i=i+c|0;a=a+e|0;d=d+h|0}}return}function AI(a,c,e,g,h,i,k,l,m){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;n=f[m>>2]|0;o=f[m+4>>2]|0;m=c>>>1;c=g>>>1;g=i>>>1;if(!o)return;i=n+-4|0;if((n|0)<4){p=(n|0)>0;q=o;r=k;s=a;t=e;u=h;while(1){q=q+-1|0;if(p){v=0;do{w=d[s+(v<<1)>>1]|0;if((j[t+(v<<1)>>1]|0)>(w&65535))x=0;else x=(w&65535)<=(j[u+(v<<1)>>1]|0);b[r+v>>0]=x<<31>>31;v=v+1|0}while((v|0)!=(n|0))}if(!q)break;else{r=r+l|0;s=s+(m<<1)|0;t=t+(c<<1)|0;u=u+(g<<1)|0}}return}u=n&-4;t=(u|0)<(n|0);s=o;o=k;k=a;a=e;e=h;while(1){h=0;do{r=d[k+(h<<1)>>1]|0;if((j[a+(h<<1)>>1]|0)>(r&65535))y=0;else y=(r&65535)<=(j[e+(h<<1)>>1]|0);r=h|1;q=d[k+(r<<1)>>1]|0;if((j[a+(r<<1)>>1]|0)>(q&65535))z=0;else z=(q&65535)<=(j[e+(r<<1)>>1]|0);b[o+h>>0]=y<<31>>31;b[o+r>>0]=z<<31>>31;r=h|2;q=d[k+(r<<1)>>1]|0;if((j[a+(r<<1)>>1]|0)>(q&65535))A=0;else A=(q&65535)<=(j[e+(r<<1)>>1]|0);q=h|3;x=d[k+(q<<1)>>1]|0;if((j[a+(q<<1)>>1]|0)>(x&65535))B=0;else B=(x&65535)<=(j[e+(q<<1)>>1]|0);b[o+r>>0]=A<<31>>31;b[o+q>>0]=B<<31>>31;h=h+4|0}while((h|0)<=(i|0));s=s+-1|0;if(t){h=u;do{q=d[k+(h<<1)>>1]|0;if((j[a+(h<<1)>>1]|0)>(q&65535))C=0;else C=(q&65535)<=(j[e+(h<<1)>>1]|0);b[o+h>>0]=C<<31>>31;h=h+1|0}while((h|0)!=(n|0))}if(!s)break;else{o=o+l|0;k=k+(m<<1)|0;a=a+(c<<1)|0;e=e+(g<<1)|0}}return}function BI(a,c,e,g,h,i,j,k,l){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;m=f[l>>2]|0;n=f[l+4>>2]|0;l=c>>>1;c=g>>>1;g=i>>>1;if(!n)return;i=m+-4|0;if((m|0)<4){o=(m|0)>0;p=n;q=j;r=a;s=e;t=h;while(1){p=p+-1|0;if(o){u=0;do{v=d[r+(u<<1)>>1]|0;if((d[s+(u<<1)>>1]|0)>v<<16>>16)w=0;else w=v<<16>>16<=(d[t+(u<<1)>>1]|0);b[q+u>>0]=w<<31>>31;u=u+1|0}while((u|0)!=(m|0))}if(!p)break;else{q=q+k|0;r=r+(l<<1)|0;s=s+(c<<1)|0;t=t+(g<<1)|0}}return}t=m&-4;s=(t|0)<(m|0);r=n;n=j;j=a;a=e;e=h;while(1){h=0;do{q=d[j+(h<<1)>>1]|0;if((d[a+(h<<1)>>1]|0)>q<<16>>16)x=0;else x=q<<16>>16<=(d[e+(h<<1)>>1]|0);q=h|1;p=d[j+(q<<1)>>1]|0;if((d[a+(q<<1)>>1]|0)>p<<16>>16)y=0;else y=p<<16>>16<=(d[e+(q<<1)>>1]|0);b[n+h>>0]=x<<31>>31;b[n+q>>0]=y<<31>>31;q=h|2;p=d[j+(q<<1)>>1]|0;if((d[a+(q<<1)>>1]|0)>p<<16>>16)z=0;else z=p<<16>>16<=(d[e+(q<<1)>>1]|0);p=h|3;w=d[j+(p<<1)>>1]|0;if((d[a+(p<<1)>>1]|0)>w<<16>>16)A=0;else A=w<<16>>16<=(d[e+(p<<1)>>1]|0);b[n+q>>0]=z<<31>>31;b[n+p>>0]=A<<31>>31;h=h+4|0}while((h|0)<=(i|0));r=r+-1|0;if(s){h=t;do{p=d[j+(h<<1)>>1]|0;if((d[a+(h<<1)>>1]|0)>p<<16>>16)B=0;else B=p<<16>>16<=(d[e+(h<<1)>>1]|0);b[n+h>>0]=B<<31>>31;h=h+1|0}while((h|0)!=(m|0))}if(!r)break;else{n=n+k|0;j=j+(l<<1)|0;a=a+(c<<1)|0;e=e+(g<<1)|0}}return}function CI(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;l=f[k>>2]|0;m=f[k+4>>2]|0;k=c>>>2;c=e>>>2;e=h>>>2;if(!m)return;h=l+-4|0;if((l|0)<4){n=(l|0)>0;o=m;p=i;q=a;r=d;s=g;while(1){o=o+-1|0;if(n){t=0;do{u=f[q+(t<<2)>>2]|0;if((f[r+(t<<2)>>2]|0)>(u|0))v=0;else v=(u|0)<=(f[s+(t<<2)>>2]|0);b[p+t>>0]=v<<31>>31;t=t+1|0}while((t|0)!=(l|0))}if(!o)break;else{p=p+j|0;q=q+(k<<2)|0;r=r+(c<<2)|0;s=s+(e<<2)|0}}return}s=l&-4;r=(s|0)<(l|0);q=m;m=i;i=a;a=d;d=g;while(1){g=0;do{p=f[i+(g<<2)>>2]|0;if((f[a+(g<<2)>>2]|0)>(p|0))w=0;else w=(p|0)<=(f[d+(g<<2)>>2]|0);p=g|1;o=f[i+(p<<2)>>2]|0;if((f[a+(p<<2)>>2]|0)>(o|0))x=0;else x=(o|0)<=(f[d+(p<<2)>>2]|0);b[m+g>>0]=w<<31>>31;b[m+p>>0]=x<<31>>31;p=g|2;o=f[i+(p<<2)>>2]|0;if((f[a+(p<<2)>>2]|0)>(o|0))y=0;else y=(o|0)<=(f[d+(p<<2)>>2]|0);o=g|3;v=f[i+(o<<2)>>2]|0;if((f[a+(o<<2)>>2]|0)>(v|0))z=0;else z=(v|0)<=(f[d+(o<<2)>>2]|0);b[m+p>>0]=y<<31>>31;b[m+o>>0]=z<<31>>31;g=g+4|0}while((g|0)<=(h|0));q=q+-1|0;if(r){g=s;do{o=f[i+(g<<2)>>2]|0;if((f[a+(g<<2)>>2]|0)>(o|0))A=0;else A=(o|0)<=(f[d+(g<<2)>>2]|0);b[m+g>>0]=A<<31>>31;g=g+1|0}while((g|0)!=(l|0))}if(!q)break;else{m=m+j|0;i=i+(k<<2)|0;a=a+(c<<2)|0;d=d+(e<<2)|0}}return}function DI(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0;l=f[k>>2]|0;m=f[k+4>>2]|0;k=c>>>2;c=e>>>2;e=h>>>2;if(!m)return;h=l+-4|0;if((l|0)<4){o=(l|0)>0;p=m;q=i;r=a;s=d;t=g;while(1){p=p+-1|0;if(o){u=0;do{v=+n[r+(u<<2)>>2];if(!(+n[s+(u<<2)>>2]<=v))w=0;else w=v<=+n[t+(u<<2)>>2];b[q+u>>0]=w<<31>>31;u=u+1|0}while((u|0)!=(l|0))}if(!p)break;else{q=q+j|0;r=r+(k<<2)|0;s=s+(c<<2)|0;t=t+(e<<2)|0}}return}t=l&-4;s=(t|0)<(l|0);r=m;m=i;i=a;a=d;d=g;while(1){g=0;do{v=+n[i+(g<<2)>>2];if(!(+n[a+(g<<2)>>2]<=v))x=0;else x=v<=+n[d+(g<<2)>>2];q=g|1;v=+n[i+(q<<2)>>2];if(!(+n[a+(q<<2)>>2]<=v))y=0;else y=v<=+n[d+(q<<2)>>2];b[m+g>>0]=x<<31>>31;b[m+q>>0]=y<<31>>31;q=g|2;v=+n[i+(q<<2)>>2];if(!(+n[a+(q<<2)>>2]<=v))z=0;else z=v<=+n[d+(q<<2)>>2];p=g|3;v=+n[i+(p<<2)>>2];if(!(+n[a+(p<<2)>>2]<=v))A=0;else A=v<=+n[d+(p<<2)>>2];b[m+q>>0]=z<<31>>31;b[m+p>>0]=A<<31>>31;g=g+4|0}while((g|0)<=(h|0));r=r+-1|0;if(s){g=t;do{v=+n[i+(g<<2)>>2];if(!(+n[a+(g<<2)>>2]<=v))B=0;else B=v<=+n[d+(g<<2)>>2];b[m+g>>0]=B<<31>>31;g=g+1|0}while((g|0)!=(l|0))}if(!r)break;else{m=m+j|0;i=i+(k<<2)|0;a=a+(c<<2)|0;d=d+(e<<2)|0}}return}function EI(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0;l=f[k>>2]|0;m=f[k+4>>2]|0;k=c>>>3;c=e>>>3;e=h>>>3;if(!m)return;h=l+-4|0;if((l|0)<4){n=(l|0)>0;o=m;q=i;r=a;s=d;t=g;while(1){o=o+-1|0;if(n){u=0;do{v=+p[r+(u<<3)>>3];if(!(+p[s+(u<<3)>>3]<=v))w=0;else w=v<=+p[t+(u<<3)>>3];b[q+u>>0]=w<<31>>31;u=u+1|0}while((u|0)!=(l|0))}if(!o)break;else{q=q+j|0;r=r+(k<<3)|0;s=s+(c<<3)|0;t=t+(e<<3)|0}}return}t=l&-4;s=(t|0)<(l|0);r=m;m=i;i=a;a=d;d=g;while(1){g=0;do{v=+p[i+(g<<3)>>3];if(!(+p[a+(g<<3)>>3]<=v))x=0;else x=v<=+p[d+(g<<3)>>3];q=g|1;v=+p[i+(q<<3)>>3];if(!(+p[a+(q<<3)>>3]<=v))y=0;else y=v<=+p[d+(q<<3)>>3];b[m+g>>0]=x<<31>>31;b[m+q>>0]=y<<31>>31;q=g|2;v=+p[i+(q<<3)>>3];if(!(+p[a+(q<<3)>>3]<=v))z=0;else z=v<=+p[d+(q<<3)>>3];o=g|3;v=+p[i+(o<<3)>>3];if(!(+p[a+(o<<3)>>3]<=v))A=0;else A=v<=+p[d+(o<<3)>>3];b[m+q>>0]=z<<31>>31;b[m+o>>0]=A<<31>>31;g=g+4|0}while((g|0)<=(h|0));r=r+-1|0;if(s){g=t;do{v=+p[i+(g<<3)>>3];if(!(+p[a+(g<<3)>>3]<=v))B=0;else B=v<=+p[d+(g<<3)>>3];b[m+g>>0]=B<<31>>31;g=g+1|0}while((g|0)!=(l|0))}if(!r)break;else{m=m+j|0;i=i+(k<<3)|0;a=a+(c<<3)|0;d=d+(e<<3)|0}}return}function FI(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=u;u=u+1104|0;e=d+1096|0;g=d+1080|0;h=d+40|0;i=d+8|0;j=d;_$(e,30900);k=f[a>>2]|0;l=k&7;m=k>>>3&511;k=m+1|0;if(m){n=a+4|0;o=a+40|0;p=0;while(1){AR(c+(p*56|0)|0,f[n>>2]|0,f[o>>2]|0,l);if((p|0)<(m|0))p=p+1|0;else break}p=f[30920+(l<<2)>>2]|0;if((l|0)==7){f[g>>2]=0;f[g+4>>2]=0;l=c$(g,9)|0;o=323538;q=l+9|0;do{b[l>>0]=b[o>>0]|0;l=l+1|0;o=o+1|0}while((l|0)<(q|0));j$(-215,g,158472,158478,161);d$(g)}o=f[n>>2]|0;if((o|0)>0)r=f[(f[a+44>>2]|0)+(o+-1<<2)>>2]|0;else r=0;o=1212424721>>>(f[a>>2]<<2&28)&15;f[g>>2]=((r+1023|0)>>>0)/(r>>>0)|0;n=m+2|0;m=(n<<3)+16|0;l=h+8|0;f[h>>2]=l;q=h+4|0;f[q>>2]=m;if(m>>>0>1032){s=OYa(m)|0;f[h>>2]=s;t=s}else t=l;s=t+(k<<2)+4+15&-16;m=s;f[t>>2]=a;v=0;do{w=v;v=v+1|0;f[t+(v<<2)>>2]=c+(w*56|0)}while((v|0)!=(k|0));v=s;bU(i,t,v,n);n=f[i+20>>2]|0;f[j>>2]=n;t=536870911/(k>>>0)|0;if(k>>>0<5)x=n;else{s=f[g>>2]|0;x=s>>>0<n>>>0?s:f[j>>2]|0}s=x>>>0<t>>>0?x:t;t=i+16|0;x=m+4|0;w=0;y=n;z=n;while(1){if(w>>>0>=(f[t>>2]|0)>>>0)break;if(!z){A=y;B=0}else{n=0;C=y;D=z;while(1){E=D-n|0;F=s>>>0<E>>>0?s:E;Ah[p&255](f[v>>2]|0,x,F,k);n=n+s|0;if(n>>>0<C>>>0){E=Y(r,F)|0;f[v>>2]=(f[v>>2]|0)+E;E=Y(o,F)|0;F=0;do{F=F+1|0;G=m+(F<<2)|0;f[G>>2]=(f[G>>2]|0)+E}while((F|0)!=(k|0));H=f[j>>2]|0}else H=C;if(H>>>0<=n>>>0){A=H;B=H;break}else{C=H;D=H}}}tR(i)|0;w=w+1|0;y=A;z=B}B=f[h>>2]|0;if((B|0)!=(l|0)){if(B|0)QYa(B);f[h>>2]=l;f[q>>2]=1032}}else{q=g+8|0;f[q>>2]=0;f[q+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;eL(a,g)}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function GI(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+80|0;e=d+72|0;g=d+16|0;h=d;_$(e,30952);do if((NS(a)|0)==65536){i=f[a+4>>2]|0;f[g>>2]=f[i>>2];j=g+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=g+8|0;f[l>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];m=g+16|0;f[m>>2]=f[i+16>>2];f[g+20>>2]=f[i+20>>2];f[g+24>>2]=f[i+24>>2];f[g+28>>2]=f[i+28>>2];f[g+32>>2]=f[i+32>>2];n=f[i+36>>2]|0;f[g+36>>2]=n;f[g+40>>2]=l;l=g+48|0;o=g+44|0;f[o>>2]=l;f[l>>2]=0;f[g+52>>2]=0;if(n|0){l=n+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];p=m;break}else{f[j>>2]=0;BR(g,i);p=m;break}}else{OR(g,a,-1);p=g+16|0}while(0);if(f[p>>2]|0){a=g+4|0;m=f[a>>2]|0;if((m|0)<3)q=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{i=f[g+40>>2]|0;j=0;k=1;while(1){l=Y(f[i+(j<<2)>>2]|0,k)|0;j=j+1|0;if((j|0)==(m|0)){q=l;break}else k=l}}if(!((m|0)==0|(q|0)==0)){if((aT(c)|0?!(XS(c)|0):0)?(q=RR(c,-1)|0,(q|0)!=(f[g>>2]&7|0)):0){f[h>>2]=0;f[h+4>>2]=0;q=c$(h,58)|0;m=158570;k=q+58|0;do{b[q>>0]=b[m>>0]|0;q=q+1|0;m=m+1|0}while((q|0)<(k|0));j$(-215,h,158472,158478,256);d$(h)}m=f[g>>2]|0;q=m&7;k=m>>>3&511;pS(c,k+1|0,1,q,-1,0,0);m=g+40|0;j=0;while(1){MR(c,f[a>>2]|0,f[m>>2]|0,q,j,0,0);if((j|0)<(k|0))j=j+1|0;else break}f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;PS(c,h);FI(g,f[h>>2]|0);Vt(h)}else r=14}else r=14;if((r|0)==14)oS(c);c=g+36|0;r=f[c>>2]|0;if(r|0?(h=r+12|0,r=f[h>>2]|0,f[h>>2]=r+-1,(r|0)==1):0)CR(g);f[c>>2]=0;c=g+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[c>>2]|0)>0){p=f[g+40>>2]|0;r=0;do{f[p+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[c>>2]|0))}c=f[g+44>>2]|0;if((c|0)!=(g+48|0))ZF(c);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function HI(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0;e=u;u=u+2208|0;g=e+2200|0;h=e+2144|0;i=e+1080|0;j=e+40|0;k=e+8|0;l=e;_$(g,30972);if(!((a|0)!=0&(c|0)!=0)){f[h>>2]=0;f[h+4>>2]=0;m=c$(h,11)|0;n=158677;o=m+11|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,h,158689,158478,327);d$(h);p=f[a>>2]&7;if(!c){q=1;r=p;s=1;t=0;v=16}else{w=p;v=4}}else{w=f[a>>2]&7;v=4}if((v|0)==4){p=a+40|0;x=h+4|0;y=1;z=0;A=0;while(1){B=a+(A*56|0)|0;C=f[a+(A*56|0)+40>>2]|0;D=f[C+-4>>2]|0;E=f[p>>2]|0;a:do if((D|0)==(f[E+-4>>2]|0)){if((D|0)==2){if((f[C>>2]|0)!=(f[E>>2]|0)){v=13;break}if((f[C+4>>2]|0)!=(f[E+4>>2]|0)){v=13;break}}else if((D|0)>0){F=0;do{if((f[C+(F<<2)>>2]|0)!=(f[E+(F<<2)>>2]|0)){v=13;break a}F=F+1|0}while((F|0)<(D|0))}if((f[B>>2]&7|0)!=(w|0))v=13}else v=13;while(0);if((v|0)==13){v=0;f[h>>2]=0;f[x>>2]=0;m=c$(h,50)|0;n=158695;o=m+50|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,h,158689,158478,336);d$(h)}D=f[B>>2]|0;y=y&(D&4088|0)==0;G=D>>>3&511;H=z+1+G|0;A=A+1|0;if(A>>>0>=c>>>0)break;else z=H}if((z+G|0)>>>0<512){I=y;J=w;K=0;L=H}else{q=y;r=w;s=0;t=H;v=16}}if((v|0)==16){f[h>>2]=0;f[h+4>>2]=0;m=c$(h,19)|0;n=158746;o=m+19|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,h,158689,158478,341);d$(h);I=q;J=r;K=s;L=t}MR(d,f[a+4>>2]|0,f[a+40>>2]|0,(L<<3)+-8|J,-1,0,0);do if((NS(d)|0)==65536){t=f[d+4>>2]|0;f[h>>2]=f[t>>2];s=h+4|0;r=t+4|0;f[s>>2]=f[r>>2];q=h+8|0;f[q>>2]=f[t+8>>2];f[h+12>>2]=f[t+12>>2];f[h+16>>2]=f[t+16>>2];f[h+20>>2]=f[t+20>>2];f[h+24>>2]=f[t+24>>2];f[h+28>>2]=f[t+28>>2];f[h+32>>2]=f[t+32>>2];v=f[t+36>>2]|0;f[h+36>>2]=v;f[h+40>>2]=q;q=h+48|0;H=h+44|0;f[H>>2]=q;f[q>>2]=0;f[h+52>>2]=0;if(v|0){q=v+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[r>>2]|0)<3){r=f[t+44>>2]|0;q=f[H>>2]|0;f[q>>2]=f[r>>2];f[q+4>>2]=f[r+4>>2];break}else{f[s>>2]=0;BR(h,t);break}}else OR(h,d,-1);while(0);do if((c|0)!=1){if(!I){d=L<<1;t=i+8|0;f[i>>2]=t;s=i+4|0;f[s>>2]=d;if(d>>>0>264){r=OYa(d>>>0>1073741823?-1:d<<2)|0;f[i>>2]=r;M=r}else M=t;if(!K){r=0;d=0;while(1){q=(f[a+(r*56|0)>>2]|0)>>>3&511;H=0;while(1){v=H+d|0;w=v<<1;f[M+(w<<2)>>2]=v;f[M+((w|1)<<2)>>2]=v;if((H|0)==(q|0))break;else H=H+1|0}r=r+1|0;if((r|0)==(c|0))break;else d=d+1+q|0}}II(a,c,h,1,M,L);d=f[i>>2]|0;if((d|0)!=(t|0)){if(d|0)QYa(d);f[i>>2]=t;f[s>>2]=264}break}d=f[30992+(J<<2)>>2]|0;if((J|0)==7){f[i>>2]=0;f[i+4>>2]=0;m=c$(i,9)|0;n=323538;o=m+9|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,i,158689,158478,372);d$(i)}s=f[h+4>>2]|0;if((s|0)>0)N=f[(f[h+44>>2]|0)+(s+-1<<2)>>2]|0;else N=0;s=1212424721>>>(f[h>>2]<<2&28)&15;f[i>>2]=((N+1023|0)>>>0)/(N>>>0)|0;t=L+1|0;r=(t<<3)+16|0;B=j+8|0;f[j>>2]=B;H=j+4|0;f[H>>2]=r;if(r>>>0>1032){v=OYa(r)|0;f[j>>2]=v;O=v}else O=B;v=O+(L<<2)+4+15&-16;r=v;w=v;f[O>>2]=h;v=(L|0)>0;if(v){y=0;do{G=y;y=y+1|0;f[O+(y<<2)>>2]=a+(G*56|0)}while((y|0)!=(L|0))}bU(k,O,w,t);y=f[k+20>>2]|0;f[l>>2]=y;G=536870911/(L|0)|0;if((L|0)<5)P=y;else{z=f[i>>2]|0;P=z>>>0<y>>>0?z:f[l>>2]|0}z=P>>>0<G>>>0?P:G;G=k+16|0;A=r+4|0;b:do if(v){x=0;p=y;D=y;while(1){if(x>>>0>=(f[G>>2]|0)>>>0)break b;if(!D){Q=p;R=0}else{E=0;C=p;F=D;while(1){S=F-E|0;T=z>>>0<S>>>0?z:S;Ah[d&255](A,f[w>>2]|0,T,L);E=E+z|0;if(E>>>0<C>>>0){S=Y(N,T)|0;f[w>>2]=(f[w>>2]|0)+S;S=Y(s,T)|0;T=0;do{T=T+1|0;U=r+(T<<2)|0;f[U>>2]=(f[U>>2]|0)+S}while((T|0)!=(L|0));V=f[l>>2]|0}else V=C;if(V>>>0<=E>>>0){Q=V;R=V;break}else{C=V;F=V}}}tR(k)|0;x=x+1|0;p=Q;D=R}}else{D=0;p=y;x=y;while(1){if(D>>>0>=(f[G>>2]|0)>>>0)break b;if(!x){W=p;X=0}else{q=0;F=p;C=x;while(1){E=C-q|0;T=z>>>0<E>>>0?z:E;Ah[d&255](A,f[w>>2]|0,T,L);q=q+z|0;if(q>>>0<F>>>0){E=Y(N,T)|0;f[w>>2]=(f[w>>2]|0)+E;Z=f[l>>2]|0}else Z=F;if(Z>>>0<=q>>>0){W=Z;X=Z;break}else{F=Z;C=Z}}}tR(k)|0;D=D+1|0;p=W;x=X}}while(0);w=f[j>>2]|0;if((w|0)!=(B|0)){if(w|0)QYa(w);f[j>>2]=B;f[H>>2]=1032}}else{w=i+8|0;f[w>>2]=0;f[w+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=h;eL(a,i)}while(0);i=h+36|0;a=f[i>>2]|0;if(a|0?(j=a+12|0,a=f[j>>2]|0,f[j>>2]=a+-1,(a|0)==1):0)CR(h);f[i>>2]=0;i=h+16|0;a=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[a>>2]|0)>0){i=f[h+40>>2]|0;j=0;do{f[i+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[a>>2]|0))}a=f[h+44>>2]|0;if((a|0)!=(h+48|0))ZF(a);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function II(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0;i=u;u=u+1088|0;j=i+1072|0;k=i+32|0;l=i;_$(j,31024);if(h|0){m=(e|0)!=0;if(!((a|0)!=0&(c|0)!=0&(d|0)!=0&m&(g|0)!=0)){f[k>>2]=0;f[k+4>>2]=0;n=c$(k,60)|0;o=158766;p=n+60|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-215,k,158827,158478,573);d$(k)}q=f[d>>2]|0;r=1212424721>>>(q<<2&28)&15;s=q&7;q=e+c|0;t=(q<<3)+8+(h<<5)|0;v=k+8|0;f[k>>2]=v;w=k+4|0;f[w>>2]=t;if(t>>>0>1032){x=OYa(t)|0;f[k>>2]=x;y=x}else y=v;x=y+(c<<2)+(e<<2)|0;t=x+(c<<2)+(e<<2)+4|0;z=t+(h<<2)|0;A=z+(h<<2)|0;B=A+(h<<2<<2)|0;C=B+(h<<2)|0;D=(c|0)==0;if(!D){E=0;do{f[y+(E<<2)>>2]=a+(E*56|0);E=E+1|0}while((E|0)!=(c|0))}if(e|0){E=0;do{f[y+(E+c<<2)>>2]=d+(E*56|0);E=E+1|0}while((E|0)!=(e|0))}f[x+(q<<2)>>2]=0;E=l+4|0;F=l+4|0;G=0;do{H=G<<1;I=f[g+(H<<2)>>2]|0;J=f[g+((H|1)<<2)>>2]|0;if((I|0)>-1){a:do if(!D){H=I;K=0;while(1){L=f[a+(K*56|0)>>2]|0;M=L>>>3&511;if((H|0)<=(M|0))break;N=H+-1-M|0;M=K+1|0;if(M>>>0<c>>>0){H=N;K=M}else{O=N;P=M;Q=16;break a}}if((L&7|0)==(s|0)){R=H;S=K}else{O=H;P=K;Q=16}}else{O=I;P=0;Q=16}while(0);if((Q|0)==16){Q=0;f[l>>2]=0;f[E>>2]=0;n=c$(l,36)|0;o=158839;p=n+36|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-215,l,158827,158478,600);d$(l);R=O;S=P}I=G<<2;f[A+(I<<2)>>2]=S;M=Y(R,r)|0;f[A+((I|1)<<2)>>2]=M;T=((f[a+(S*56|0)>>2]|0)>>>3&511)+1|0}else{M=G<<2;f[A+(M<<2)>>2]=q;f[A+((M|1)<<2)>>2]=0;T=0}f[B+(G<<2)>>2]=T;b:do if(m){M=J;I=0;while(1){U=f[d+(I*56|0)>>2]|0;N=U>>>3&511;if((M|0)<=(N|0))break;V=M+-1-N|0;N=I+1|0;if(N>>>0<e>>>0){M=V;I=N}else{W=V;X=N;Q=23;break b}}if((M|0)>-1&(U&7|0)==(s|0)){Z=M;_=I}else{W=M;X=I;Q=23}}else{W=J;X=0;Q=23}while(0);if((Q|0)==23){Q=0;f[l>>2]=0;f[F>>2]=0;n=c$(l,47)|0;o=158876;p=n+47|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-215,l,158827,158478,613);d$(l);Z=W;_=X}J=G<<2;f[A+((J|2)<<2)>>2]=_+c;K=Y(Z,r)|0;f[A+((J|3)<<2)>>2]=K;f[C+(G<<2)>>2]=((f[d+(_*56|0)>>2]|0)>>>3&511)+1;G=G+1|0}while(G>>>0<h>>>0);bU(l,y,x,q);q=f[l+20>>2]|0;y=((r+1023|0)>>>0)/(r>>>0)|0;G=(y|0)<(q|0)?y:q;y=f[31044+(s<<2)>>2]|0;s=l+16|0;_=(q|0)>0;d=Y(G,r)|0;r=0;while(1){if(r>>>0<(f[s>>2]|0)>>>0)$=0;else break;do{Z=$<<2;f[t+($<<2)>>2]=(f[x+(f[A+(Z<<2)>>2]<<2)>>2]|0)+(f[A+((Z|1)<<2)>>2]|0);f[z+($<<2)>>2]=(f[x+(f[A+((Z|2)<<2)>>2]<<2)>>2]|0)+(f[A+((Z|3)<<2)>>2]|0);$=$+1|0}while(($|0)!=(h|0));c:do if(_){Z=0;do{c=q-Z|0;bh[y&255](t,B,z,C,(G|0)<(c|0)?G:c,h);Z=Z+G|0;c=(Z|0)<(q|0);if(c)aa=0;else break c;do{X=Y(d,f[B+(aa<<2)>>2]|0)|0;W=t+(aa<<2)|0;f[W>>2]=(f[W>>2]|0)+X;X=Y(d,f[C+(aa<<2)>>2]|0)|0;W=z+(aa<<2)|0;f[W>>2]=(f[W>>2]|0)+X;aa=aa+1|0}while((aa|0)!=(h|0))}while(c)}while(0);tR(l)|0;r=r+1|0}r=f[k>>2]|0;if((r|0)!=(v|0)){if(r|0)QYa(r);f[k>>2]=v;f[w>>2]=1032}}if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function JI(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if((h|0)<=0)return;i=g+-2|0;if((g|0)<2){if((g|0)==1)j=0;else return;do{k=f[a+(j<<2)>>2]|0;if(!k)l=0;else l=b[k>>0]|0;b[f[d+(j<<2)>>2]>>0]=l;j=j+1|0}while((j|0)!=(h|0));return}j=g&-2;if((j|0)<(g|0))m=0;else{g=0;do{l=f[a+(g<<2)>>2]|0;k=f[d+(g<<2)>>2]|0;n=f[c+(g<<2)>>2]|0;o=f[e+(g<<2)>>2]|0;if(!l){p=o<<1;q=k;r=0;while(1){b[q+o>>0]=0;b[q>>0]=0;r=r+2|0;if((r|0)>(i|0))break;else q=q+p|0}}else{p=n<<1;q=o<<1;r=k;s=0;t=l;while(1){u=b[t+n>>0]|0;b[r>>0]=b[t>>0]|0;b[r+o>>0]=u;s=s+2|0;if((s|0)>(i|0))break;else{r=r+q|0;t=t+p|0}}}g=g+1|0}while((g|0)!=(h|0));return}do{g=f[a+(m<<2)>>2]|0;p=f[d+(m<<2)>>2]|0;t=f[c+(m<<2)>>2]|0;q=f[e+(m<<2)>>2]|0;if(!g){r=q<<1;s=p;o=0;while(1){b[s+q>>0]=0;b[s>>0]=0;o=o+2|0;if((o|0)>(i|0))break;else s=s+r|0}r=p+(Y(q,j)|0)|0;b[r>>0]=0}else{r=t<<1;s=q<<1;o=Y(t,j)|0;n=p;l=0;k=g;while(1){u=b[k+t>>0]|0;b[n>>0]=b[k>>0]|0;b[n+q>>0]=u;l=l+2|0;if((l|0)>(i|0))break;else{n=n+s|0;k=k+r|0}}r=p+(Y(q,j)|0)|0;b[r>>0]=b[g+o>>0]|0}m=m+1|0}while((m|0)!=(h|0));return}function KI(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;if((h|0)<=0)return;i=g+-2|0;if((g|0)<2){if((g|0)==1)j=0;else return;do{k=f[a+(j<<2)>>2]|0;if(!k)l=0;else l=d[k>>1]|0;d[f[c+(j<<2)>>2]>>1]=l;j=j+1|0}while((j|0)!=(h|0));return}j=i>>>1;l=(j<<2)+4|0;if(((j<<1)+2|0)<(g|0))m=0;else{g=0;do{j=f[a+(g<<2)>>2]|0;k=f[c+(g<<2)>>2]|0;n=f[b+(g<<2)>>2]|0;o=f[e+(g<<2)>>2]|0;if(!j){p=o<<1;q=k;r=0;while(1){d[q+(o<<1)>>1]=0;d[q>>1]=0;r=r+2|0;if((r|0)>(i|0))break;else q=q+(p<<1)|0}}else{p=n<<1;q=o<<1;r=k;s=0;t=j;while(1){u=d[t+(n<<1)>>1]|0;d[r>>1]=d[t>>1]|0;d[r+(o<<1)>>1]=u;s=s+2|0;if((s|0)>(i|0))break;else{r=r+(q<<1)|0;t=t+(p<<1)|0}}}g=g+1|0}while((g|0)!=(h|0));return}do{g=f[a+(m<<2)>>2]|0;p=f[c+(m<<2)>>2]|0;t=f[b+(m<<2)>>2]|0;q=f[e+(m<<2)>>2]|0;if(!g){r=q<<1;s=Y(q,l)|0;o=p;n=0;while(1){d[o+(q<<1)>>1]=0;d[o>>1]=0;n=n+2|0;if((n|0)>(i|0))break;else o=o+(r<<1)|0}d[p+s>>1]=0}else{r=t<<1;o=q<<1;n=Y(t,l)|0;j=Y(q,l)|0;k=p;u=0;v=g;while(1){w=d[v+(t<<1)>>1]|0;d[k>>1]=d[v>>1]|0;d[k+(q<<1)>>1]=w;u=u+2|0;if((u|0)>(i|0))break;else{k=k+(o<<1)|0;v=v+(r<<1)|0}}d[p+j>>1]=d[g+n>>1]|0}m=m+1|0}while((m|0)!=(h|0));return}function LI(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;if((g|0)<=0)return;h=e+-2|0;if((e|0)<2){if((e|0)==1)i=0;else return;do{j=f[a+(i<<2)>>2]|0;if(!j)k=0;else k=f[j>>2]|0;f[f[c+(i<<2)>>2]>>2]=k;i=i+1|0}while((i|0)!=(g|0));return}i=h>>>1;k=(i<<3)+8|0;if(((i<<1)+2|0)<(e|0))l=0;else{e=0;do{i=f[a+(e<<2)>>2]|0;j=f[c+(e<<2)>>2]|0;m=f[b+(e<<2)>>2]|0;n=f[d+(e<<2)>>2]|0;if(!i){o=n<<1;p=j;q=0;while(1){f[p+(n<<2)>>2]=0;f[p>>2]=0;q=q+2|0;if((q|0)>(h|0))break;else p=p+(o<<2)|0}}else{o=m<<1;p=n<<1;q=j;r=0;s=i;while(1){t=f[s+(m<<2)>>2]|0;f[q>>2]=f[s>>2];f[q+(n<<2)>>2]=t;r=r+2|0;if((r|0)>(h|0))break;else{q=q+(p<<2)|0;s=s+(o<<2)|0}}}e=e+1|0}while((e|0)!=(g|0));return}do{e=f[a+(l<<2)>>2]|0;o=f[c+(l<<2)>>2]|0;s=f[b+(l<<2)>>2]|0;p=f[d+(l<<2)>>2]|0;if(!e){q=p<<1;r=Y(p,k)|0;n=o;m=0;while(1){f[n+(p<<2)>>2]=0;f[n>>2]=0;m=m+2|0;if((m|0)>(h|0))break;else n=n+(q<<2)|0}f[o+r>>2]=0}else{q=s<<1;n=p<<1;m=Y(s,k)|0;i=Y(p,k)|0;j=o;t=0;u=e;while(1){v=f[u+(s<<2)>>2]|0;f[j>>2]=f[u>>2];f[j+(p<<2)>>2]=v;t=t+2|0;if((t|0)>(h|0))break;else{j=j+(n<<2)|0;u=u+(q<<2)|0}}f[o+i>>2]=f[e+m>>2]}l=l+1|0}while((l|0)!=(g|0));return}function MI(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;if((g|0)<=0)return;h=e+-2|0;if((e|0)<2){if((e|0)==1)i=0;else return;do{j=f[a+(i<<2)>>2]|0;if(!j){k=0;l=0}else{m=j;k=f[m>>2]|0;l=f[m+4>>2]|0}m=f[c+(i<<2)>>2]|0;f[m>>2]=k;f[m+4>>2]=l;i=i+1|0}while((i|0)!=(g|0));return}i=h>>>1;l=(i<<4)+16|0;if(((i<<1)+2|0)<(e|0))n=0;else{e=0;do{i=f[a+(e<<2)>>2]|0;k=f[c+(e<<2)>>2]|0;m=f[b+(e<<2)>>2]|0;j=f[d+(e<<2)>>2]|0;if(!i){o=j<<1;p=k;q=0;while(1){r=p+(j<<3)|0;f[r>>2]=0;f[r+4>>2]=0;r=p;f[r>>2]=0;f[r+4>>2]=0;q=q+2|0;if((q|0)>(h|0))break;else p=p+(o<<3)|0}}else{o=m<<1;p=j<<1;q=k;r=0;s=i;while(1){t=s;u=f[t+4>>2]|0;v=s+(m<<3)|0;w=f[v>>2]|0;x=f[v+4>>2]|0;v=q;f[v>>2]=f[t>>2];f[v+4>>2]=u;u=q+(j<<3)|0;f[u>>2]=w;f[u+4>>2]=x;r=r+2|0;if((r|0)>(h|0))break;else{q=q+(p<<3)|0;s=s+(o<<3)|0}}}e=e+1|0}while((e|0)!=(g|0));return}do{e=f[a+(n<<2)>>2]|0;o=f[c+(n<<2)>>2]|0;s=f[b+(n<<2)>>2]|0;p=f[d+(n<<2)>>2]|0;if(!e){q=p<<1;r=Y(p,l)|0;j=o;m=0;while(1){i=j+(p<<3)|0;f[i>>2]=0;f[i+4>>2]=0;i=j;f[i>>2]=0;f[i+4>>2]=0;m=m+2|0;if((m|0)>(h|0))break;else j=j+(q<<3)|0}q=o+r|0;f[q>>2]=0;f[q+4>>2]=0}else{q=s<<1;j=p<<1;m=Y(s,l)|0;i=Y(p,l)|0;k=o;x=0;u=e;while(1){w=u;v=f[w+4>>2]|0;t=u+(s<<3)|0;y=f[t>>2]|0;z=f[t+4>>2]|0;t=k;f[t>>2]=f[w>>2];f[t+4>>2]=v;v=k+(p<<3)|0;f[v>>2]=y;f[v+4>>2]=z;x=x+2|0;if((x|0)>(h|0))break;else{k=k+(j<<3)|0;u=u+(q<<3)|0}}q=e+m|0;u=f[q+4>>2]|0;j=o+i|0;f[j>>2]=f[q>>2];f[j+4>>2]=u}n=n+1|0}while((n|0)!=(g|0));return}function NI(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+32|0;d=c+16|0;e=c;_$(d,31076);f[e>>2]=0;g=e+4|0;f[g>>2]=0;f[e+8>>2]=0;PS(a,e);a=f[e>>2]|0;h=f[g>>2]|0;HI((a|0)==(h|0)?0:a,(h-a|0)/56|0,b);Vt(e);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function OI(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;g=u;u=u+1536|0;h=g+1520|0;i=g+56|0;j=g;_$(h,31096);if(!((d|0)==0|(e|0)==0)){if(((NS(a)|0)!=327680?(NS(a)|0)!=983040:0)?(NS(a)|0)!=262144:0)k=(NS(a)|0)!=720896;else k=0;if(((NS(c)|0)!=327680?(NS(c)|0)!=983040:0)?(NS(c)|0)!=262144:0)l=(NS(c)|0)!=720896;else l=0;if(k)m=1;else m=US(a,-1)|0;if(l)n=1;else n=US(c,-1)|0;o=(m|0)>0;p=(n|0)>0;if(!(o&p)){f[i>>2]=0;f[i+4>>2]=0;q=c$(i,20)|0;r=159111;s=q+20|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));j$(-215,i,158827,158478,767);d$(i)}PI(i,n+m|0);r=f[i>>2]|0;if(o){o=a+4|0;q=j+4|0;s=j+8|0;t=j+12|0;v=j+16|0;w=j+20|0;x=j+24|0;y=j+28|0;z=j+32|0;A=j+36|0;B=j+40|0;C=j+48|0;D=j+44|0;E=j+52|0;F=0;do{G=k?-1:F;do if((G|0)<0&(NS(a)|0)==65536){H=f[o>>2]|0;f[j>>2]=f[H>>2];I=H+4|0;f[q>>2]=f[I>>2];f[s>>2]=f[H+8>>2];f[t>>2]=f[H+12>>2];f[v>>2]=f[H+16>>2];f[w>>2]=f[H+20>>2];f[x>>2]=f[H+24>>2];f[y>>2]=f[H+28>>2];f[z>>2]=f[H+32>>2];J=f[H+36>>2]|0;f[A>>2]=J;f[B>>2]=s;f[D>>2]=C;f[C>>2]=0;f[E>>2]=0;if(J|0){K=J+12|0;f[K>>2]=(f[K>>2]|0)+1}if((f[I>>2]|0)<3){I=f[H+44>>2]|0;K=f[D>>2]|0;f[K>>2]=f[I>>2];f[K+4>>2]=f[I+4>>2];break}else{f[q>>2]=0;BR(j,H);break}}else OR(j,a,G);while(0);G=r+(F*56|0)|0;if((G|0)!=(j|0)){H=f[A>>2]|0;if(H|0){I=H+12|0;f[I>>2]=(f[I>>2]|0)+1}I=r+(F*56|0)+36|0;H=f[I>>2]|0;if(H|0?(K=H+12|0,H=f[K>>2]|0,f[K>>2]=H+-1,(H|0)==1):0)CR(G);f[I>>2]=0;H=r+(F*56|0)+16|0;K=r+(F*56|0)+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[K>>2]|0)>0){J=f[r+(F*56|0)+40>>2]|0;L=0;do{f[J+(L<<2)>>2]=0;L=L+1|0;M=f[K>>2]|0}while((L|0)<(M|0));f[G>>2]=f[j>>2];if((M|0)<3)N=38;else N=40}else{f[G>>2]=f[j>>2];N=38}if((N|0)==38){N=0;L=f[q>>2]|0;if((L|0)<3){f[K>>2]=L;f[r+(F*56|0)+8>>2]=f[s>>2];f[r+(F*56|0)+12>>2]=f[t>>2];L=f[D>>2]|0;J=f[r+(F*56|0)+44>>2]|0;f[J>>2]=f[L>>2];f[J+4>>2]=f[L+4>>2]}else N=40}if((N|0)==40){N=0;BR(G,j)}f[H>>2]=f[v>>2];f[r+(F*56|0)+20>>2]=f[w>>2];f[r+(F*56|0)+24>>2]=f[x>>2];f[r+(F*56|0)+28>>2]=f[y>>2];f[r+(F*56|0)+32>>2]=f[z>>2];f[I>>2]=f[A>>2]}L=f[A>>2]|0;if(L|0?(J=L+12|0,L=f[J>>2]|0,f[J>>2]=L+-1,(L|0)==1):0)CR(j);f[A>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[q>>2]|0)>0){L=f[B>>2]|0;J=0;do{f[L+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[q>>2]|0))}J=f[D>>2]|0;if((J|0)!=(C|0))ZF(J);F=F+1|0}while((F|0)<(m|0))}if(p){p=c+4|0;F=j+4|0;C=j+8|0;D=j+12|0;q=j+16|0;B=j+20|0;v=j+24|0;A=j+28|0;z=j+32|0;y=j+36|0;x=j+40|0;w=j+48|0;t=j+44|0;s=j+52|0;M=0;do{a=l?-1:M;do if((a|0)<0&(NS(c)|0)==65536){E=f[p>>2]|0;f[j>>2]=f[E>>2];o=E+4|0;f[F>>2]=f[o>>2];f[C>>2]=f[E+8>>2];f[D>>2]=f[E+12>>2];f[q>>2]=f[E+16>>2];f[B>>2]=f[E+20>>2];f[v>>2]=f[E+24>>2];f[A>>2]=f[E+28>>2];f[z>>2]=f[E+32>>2];k=f[E+36>>2]|0;f[y>>2]=k;f[x>>2]=C;f[t>>2]=w;f[w>>2]=0;f[s>>2]=0;if(k|0){J=k+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[o>>2]|0)<3){o=f[E+44>>2]|0;J=f[t>>2]|0;f[J>>2]=f[o>>2];f[J+4>>2]=f[o+4>>2];break}else{f[F>>2]=0;BR(j,E);break}}else OR(j,c,a);while(0);a=M+m|0;E=r+(a*56|0)|0;if((E|0)!=(j|0)){o=f[y>>2]|0;if(o|0){J=o+12|0;f[J>>2]=(f[J>>2]|0)+1}J=r+(a*56|0)+36|0;o=f[J>>2]|0;if(o|0?(k=o+12|0,o=f[k>>2]|0,f[k>>2]=o+-1,(o|0)==1):0)CR(E);f[J>>2]=0;o=r+(a*56|0)+16|0;k=r+(a*56|0)+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[k>>2]|0)>0){L=f[r+(a*56|0)+40>>2]|0;I=0;do{f[L+(I<<2)>>2]=0;I=I+1|0;O=f[k>>2]|0}while((I|0)<(O|0));f[E>>2]=f[j>>2];if((O|0)<3)N=69;else N=71}else{f[E>>2]=f[j>>2];N=69}if((N|0)==69){N=0;I=f[F>>2]|0;if((I|0)<3){f[k>>2]=I;f[r+(a*56|0)+8>>2]=f[C>>2];f[r+(a*56|0)+12>>2]=f[D>>2];I=f[t>>2]|0;L=f[r+(a*56|0)+44>>2]|0;f[L>>2]=f[I>>2];f[L+4>>2]=f[I+4>>2]}else N=71}if((N|0)==71){N=0;BR(E,j)}f[o>>2]=f[q>>2];f[r+(a*56|0)+20>>2]=f[B>>2];f[r+(a*56|0)+24>>2]=f[v>>2];f[r+(a*56|0)+28>>2]=f[A>>2];f[r+(a*56|0)+32>>2]=f[z>>2];f[J>>2]=f[y>>2]}I=f[y>>2]|0;if(I|0?(L=I+12|0,I=f[L>>2]|0,f[L>>2]=I+-1,(I|0)==1):0)CR(j);f[y>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[F>>2]|0)>0){I=f[x>>2]|0;L=0;do{f[I+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[F>>2]|0))}L=f[t>>2]|0;if((L|0)!=(w|0))ZF(L);M=M+1|0}while((M|0)<(n|0))}II(r,m,r+(m*56|0)|0,n,d,e);QI(i)}if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function PI(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=0;do{f[a+8+(d*56|0)>>2]=1124007936;e=a+8+(d*56|0)+8|0;g=a+8+(d*56|0)+40|0;h=a+8+(d*56|0)+4|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;j=a+8+(d*56|0)+48|0;f[a+8+(d*56|0)+44>>2]=j;f[j>>2]=0;f[a+8+(d*56|0)+52>>2]=0;d=d+1|0}while((d|0)!=26);f[a>>2]=c;c=a+4|0;f[c>>2]=26;if(b>>>0<=26){f[c>>2]=b;return}RI(a);f[c>>2]=b;c=b*56|0;d=OYa(b>>>0>76695844|c>>>0>4294967291?-1:c+4|0)|0;f[d>>2]=b;c=d+4|0;d=c+(b*56|0)|0;b=c;do{f[b>>2]=1124007936;j=b+8|0;k=b+40|0;h=b+4|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[k>>2]=j;e=b+48|0;f[b+44>>2]=e;f[e>>2]=0;f[b+52>>2]=0;b=b+56|0}while((b|0)!=(d|0));f[a>>2]=c;return}function QI(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;RI(a);b=a+8|0;c=a+1464|0;do{a=c;c=c+-56|0;d=a+-20|0;e=f[d>>2]|0;if(e|0?(g=e+12|0,e=f[g>>2]|0,f[g>>2]=e+-1,(e|0)==1):0)CR(c);f[d>>2]=0;d=a+-40|0;e=a+-52|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[e>>2]|0)>0){d=f[a+-16>>2]|0;g=0;do{f[d+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[e>>2]|0))}e=f[a+-12>>2]|0;if((e|0)!=(a+-8|0))ZF(e)}while((c|0)!=(b|0));return}function RI(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a>>2]|0;c=a+8|0;if((b|0)==(c|0))return;if(b|0){d=b+-4|0;e=f[d>>2]|0;if(e|0){g=b+(e*56|0)|0;do{e=g;g=g+-56|0;h=e+-20|0;i=f[h>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)CR(g);f[h>>2]=0;h=e+-40|0;i=e+-52|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[i>>2]|0)>0){h=f[e+-16>>2]|0;j=0;do{f[h+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[i>>2]|0))}i=f[e+-12>>2]|0;if((i|0)!=(e+-8|0))ZF(i)}while((g|0)!=(b|0))}QYa(d)}f[a>>2]=c;f[a+4>>2]=26;return}function SI(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=u;u=u+1536|0;g=e+1520|0;h=e+56|0;i=e;_$(g,31116);j=d+4|0;if((f[d>>2]|0)!=(f[j>>2]|0)){if(((NS(a)|0)!=327680?(NS(a)|0)!=983040:0)?(NS(a)|0)!=262144:0)k=(NS(a)|0)!=720896;else k=0;if(((NS(c)|0)!=327680?(NS(c)|0)!=983040:0)?(NS(c)|0)!=262144:0)l=(NS(c)|0)!=720896;else l=0;if(k)m=1;else m=US(a,-1)|0;if(l)n=1;else n=US(c,-1)|0;o=(m|0)>0;p=(n|0)>0;if(!(p&(o&((f[j>>2]|0)-(f[d>>2]|0)&4|0)==0))){f[h>>2]=0;f[h+4>>2]=0;q=c$(h,44)|0;r=159220;s=q+44|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));j$(-215,h,158827,158478,800);d$(h)}PI(h,n+m|0);r=f[h>>2]|0;if(o){o=a+4|0;q=i+4|0;s=i+8|0;t=i+12|0;v=i+16|0;w=i+20|0;x=i+24|0;y=i+28|0;z=i+32|0;A=i+36|0;B=i+40|0;C=i+48|0;D=i+44|0;E=i+52|0;F=0;do{G=k?-1:F;do if((G|0)<0&(NS(a)|0)==65536){H=f[o>>2]|0;f[i>>2]=f[H>>2];I=H+4|0;f[q>>2]=f[I>>2];f[s>>2]=f[H+8>>2];f[t>>2]=f[H+12>>2];f[v>>2]=f[H+16>>2];f[w>>2]=f[H+20>>2];f[x>>2]=f[H+24>>2];f[y>>2]=f[H+28>>2];f[z>>2]=f[H+32>>2];J=f[H+36>>2]|0;f[A>>2]=J;f[B>>2]=s;f[D>>2]=C;f[C>>2]=0;f[E>>2]=0;if(J|0){K=J+12|0;f[K>>2]=(f[K>>2]|0)+1}if((f[I>>2]|0)<3){I=f[H+44>>2]|0;K=f[D>>2]|0;f[K>>2]=f[I>>2];f[K+4>>2]=f[I+4>>2];break}else{f[q>>2]=0;BR(i,H);break}}else OR(i,a,G);while(0);G=r+(F*56|0)|0;if((G|0)!=(i|0)){H=f[A>>2]|0;if(H|0){I=H+12|0;f[I>>2]=(f[I>>2]|0)+1}I=r+(F*56|0)+36|0;H=f[I>>2]|0;if(H|0?(K=H+12|0,H=f[K>>2]|0,f[K>>2]=H+-1,(H|0)==1):0)CR(G);f[I>>2]=0;H=r+(F*56|0)+16|0;K=r+(F*56|0)+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[K>>2]|0)>0){J=f[r+(F*56|0)+40>>2]|0;L=0;do{f[J+(L<<2)>>2]=0;L=L+1|0;M=f[K>>2]|0}while((L|0)<(M|0));f[G>>2]=f[i>>2];if((M|0)<3)N=38;else N=40}else{f[G>>2]=f[i>>2];N=38}if((N|0)==38){N=0;L=f[q>>2]|0;if((L|0)<3){f[K>>2]=L;f[r+(F*56|0)+8>>2]=f[s>>2];f[r+(F*56|0)+12>>2]=f[t>>2];L=f[D>>2]|0;J=f[r+(F*56|0)+44>>2]|0;f[J>>2]=f[L>>2];f[J+4>>2]=f[L+4>>2]}else N=40}if((N|0)==40){N=0;BR(G,i)}f[H>>2]=f[v>>2];f[r+(F*56|0)+20>>2]=f[w>>2];f[r+(F*56|0)+24>>2]=f[x>>2];f[r+(F*56|0)+28>>2]=f[y>>2];f[r+(F*56|0)+32>>2]=f[z>>2];f[I>>2]=f[A>>2]}L=f[A>>2]|0;if(L|0?(J=L+12|0,L=f[J>>2]|0,f[J>>2]=L+-1,(L|0)==1):0)CR(i);f[A>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[q>>2]|0)>0){L=f[B>>2]|0;J=0;do{f[L+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[q>>2]|0))}J=f[D>>2]|0;if((J|0)!=(C|0))ZF(J);F=F+1|0}while((F|0)<(m|0))}if(p){p=c+4|0;F=i+4|0;C=i+8|0;D=i+12|0;q=i+16|0;B=i+20|0;v=i+24|0;A=i+28|0;z=i+32|0;y=i+36|0;x=i+40|0;w=i+48|0;t=i+44|0;s=i+52|0;M=0;do{a=l?-1:M;do if((a|0)<0&(NS(c)|0)==65536){E=f[p>>2]|0;f[i>>2]=f[E>>2];o=E+4|0;f[F>>2]=f[o>>2];f[C>>2]=f[E+8>>2];f[D>>2]=f[E+12>>2];f[q>>2]=f[E+16>>2];f[B>>2]=f[E+20>>2];f[v>>2]=f[E+24>>2];f[A>>2]=f[E+28>>2];f[z>>2]=f[E+32>>2];k=f[E+36>>2]|0;f[y>>2]=k;f[x>>2]=C;f[t>>2]=w;f[w>>2]=0;f[s>>2]=0;if(k|0){J=k+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[o>>2]|0)<3){o=f[E+44>>2]|0;J=f[t>>2]|0;f[J>>2]=f[o>>2];f[J+4>>2]=f[o+4>>2];break}else{f[F>>2]=0;BR(i,E);break}}else OR(i,c,a);while(0);a=M+m|0;E=r+(a*56|0)|0;if((E|0)!=(i|0)){o=f[y>>2]|0;if(o|0){J=o+12|0;f[J>>2]=(f[J>>2]|0)+1}J=r+(a*56|0)+36|0;o=f[J>>2]|0;if(o|0?(k=o+12|0,o=f[k>>2]|0,f[k>>2]=o+-1,(o|0)==1):0)CR(E);f[J>>2]=0;o=r+(a*56|0)+16|0;k=r+(a*56|0)+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[k>>2]|0)>0){L=f[r+(a*56|0)+40>>2]|0;I=0;do{f[L+(I<<2)>>2]=0;I=I+1|0;O=f[k>>2]|0}while((I|0)<(O|0));f[E>>2]=f[i>>2];if((O|0)<3)N=69;else N=71}else{f[E>>2]=f[i>>2];N=69}if((N|0)==69){N=0;I=f[F>>2]|0;if((I|0)<3){f[k>>2]=I;f[r+(a*56|0)+8>>2]=f[C>>2];f[r+(a*56|0)+12>>2]=f[D>>2];I=f[t>>2]|0;L=f[r+(a*56|0)+44>>2]|0;f[L>>2]=f[I>>2];f[L+4>>2]=f[I+4>>2]}else N=71}if((N|0)==71){N=0;BR(E,i)}f[o>>2]=f[q>>2];f[r+(a*56|0)+20>>2]=f[B>>2];f[r+(a*56|0)+24>>2]=f[v>>2];f[r+(a*56|0)+28>>2]=f[A>>2];f[r+(a*56|0)+32>>2]=f[z>>2];f[J>>2]=f[y>>2]}I=f[y>>2]|0;if(I|0?(L=I+12|0,I=f[L>>2]|0,f[L>>2]=I+-1,(I|0)==1):0)CR(i);f[y>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[F>>2]|0)>0){I=f[x>>2]|0;L=0;do{f[I+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[F>>2]|0))}L=f[t>>2]|0;if((L|0)!=(w|0))ZF(L);M=M+1|0}while((M|0)<(n|0))}M=f[d>>2]|0;II(r,m,r+(m*56|0)|0,n,M,(f[j>>2]|0)-M>>2>>>1);QI(h)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function TI(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+192|0;g=e+184|0;h=e+176|0;i=e+120|0;j=e+64|0;k=e+48|0;l=e+32|0;m=e+16|0;n=e;_$(g,31136);o=RR(a,-1)|0;p=o&7;if(!((d|0)>-1?(o>>>3&511|0)>=(d|0):0)){f[h>>2]=0;f[h+4>>2]=0;o=c$(h,20)|0;q=159358;r=o+20|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));j$(-215,h,159379,158478,897);d$(h)}f[h>>2]=d;f[h+4>>2]=0;if((vU()|0?(nS(a,-1)|0)<3:0)?(NS(c)|0)==655360:0){OS(i,a,-1);MR(c,f[i+4>>2]|0,f[i+32>>2]|0,p,-1,0,0);OS(j,c,-1);UI(l,1,i);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=17498112;f[k+4>>2]=l;UI(n,1,j);d=m+8|0;f[d>>2]=0;f[d+4>>2]=0;f[m>>2]=1124794368;f[m+4>>2]=n;OI(k,m,h,1);m=f[n>>2]|0;if(m|0){k=n+4|0;while(1){d=f[k>>2]|0;if((d|0)==(m|0))break;q=d+-48|0;f[k>>2]=q;j0(q)}PYa(f[n>>2]|0)}n=f[l>>2]|0;if(n|0){k=l+4|0;while(1){m=f[k>>2]|0;if((m|0)==(n|0))break;q=m+-48|0;f[k>>2]=q;j0(q)}PYa(f[l>>2]|0)}j0(j);j0(i)}else{do if((NS(a)|0)==65536){l=f[a+4>>2]|0;f[i>>2]=f[l>>2];k=i+4|0;n=l+4|0;f[k>>2]=f[n>>2];q=i+8|0;f[q>>2]=f[l+8>>2];f[i+12>>2]=f[l+12>>2];f[i+16>>2]=f[l+16>>2];f[i+20>>2]=f[l+20>>2];f[i+24>>2]=f[l+24>>2];f[i+28>>2]=f[l+28>>2];f[i+32>>2]=f[l+32>>2];m=f[l+36>>2]|0;f[i+36>>2]=m;d=i+40|0;f[d>>2]=q;q=i+48|0;o=i+44|0;f[o>>2]=q;f[q>>2]=0;f[i+52>>2]=0;if(m|0){q=m+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[n>>2]|0)<3){n=f[l+44>>2]|0;q=f[o>>2]|0;f[q>>2]=f[n>>2];f[q+4>>2]=f[n+4>>2];s=k;t=d;break}else{f[k>>2]=0;BR(i,l);s=k;t=d;break}}else{OR(i,a,-1);s=i+4|0;t=i+40|0}while(0);MR(c,f[s>>2]|0,f[t>>2]|0,p,-1,0,0);do if((NS(c)|0)==65536){p=f[c+4>>2]|0;f[j>>2]=f[p>>2];a=j+4|0;d=p+4|0;f[a>>2]=f[d>>2];k=j+8|0;f[k>>2]=f[p+8>>2];f[j+12>>2]=f[p+12>>2];f[j+16>>2]=f[p+16>>2];f[j+20>>2]=f[p+20>>2];f[j+24>>2]=f[p+24>>2];f[j+28>>2]=f[p+28>>2];f[j+32>>2]=f[p+32>>2];l=f[p+36>>2]|0;f[j+36>>2]=l;f[j+40>>2]=k;k=j+48|0;n=j+44|0;f[n>>2]=k;f[k>>2]=0;f[j+52>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[d>>2]|0)<3){d=f[p+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];break}else{f[a>>2]=0;BR(j,p);break}}else OR(j,c,-1);while(0);II(i,1,j,1,h,1);h=j+36|0;c=f[h>>2]|0;if(c|0?(p=c+12|0,c=f[p>>2]|0,f[p>>2]=c+-1,(c|0)==1):0)CR(j);f[h>>2]=0;h=j+16|0;c=j+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[c>>2]|0)>0){h=f[j+40>>2]|0;p=0;do{f[h+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[c>>2]|0))}c=f[j+44>>2]|0;if((c|0)!=(j+48|0))ZF(c);c=i+36|0;j=f[c>>2]|0;if(j|0?(p=j+12|0,j=f[p>>2]|0,f[p>>2]=j+-1,(j|0)==1):0)CR(i);f[c>>2]=0;c=i+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[s>>2]|0)>0){c=f[t>>2]|0;t=0;do{f[c+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[s>>2]|0))}s=f[i+44>>2]|0;if((s|0)!=(i+48|0))ZF(s)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function UI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f[a>>2]=0;d=a+4|0;f[d>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>89478485)gXa(a);e=NYa(b*48|0)|0;f[d>>2]=e;f[a>>2]=e;f[a+8>>2]=e+(b*48|0);a=c+4|0;g=c+8|0;h=c+12|0;i=c+16|0;j=c+20|0;k=c+24|0;l=c+28|0;m=c+36|0;n=e;e=b;do{f[n>>2]=f[c>>2];b=n+4|0;f[b>>2]=f[a>>2];o=n+8|0;f[o>>2]=f[g>>2];f[n+12>>2]=f[h>>2];f[n+16>>2]=f[i>>2];f[n+20>>2]=f[j>>2];p=f[k>>2]|0;f[n+24>>2]=p;f[n+28>>2]=f[l>>2];f[n+32>>2]=o;o=n+40|0;q=n+36|0;f[q>>2]=o;f[n+44>>2]=0;f[o>>2]=0;if(p|0){o=p+8|0;f[o>>2]=(f[o>>2]|0)+1}if((f[a>>2]|0)<3){o=f[m>>2]|0;p=f[q>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2]}else{f[b>>2]=0;i0(n,c)}n=(f[d>>2]|0)+48|0;f[d>>2]=n;e=e+-1|0}while((e|0)!=0);return}function VI(a,b){a=a|0;b=b|0;return f[31156+((b&7)<<5)+((a&7)<<2)>>2]|0}function WI(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;i=f[h>>2]|0;d=f[h+4>>2]|0;if(!d)return;else{j=d;k=e;l=a}while(1){j=j+-1|0;K1a(k|0,l|0,i|0)|0;if(!j)break;else{k=k+g|0;l=l+b|0}}return}function XI(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=f[i>>2]|0;e=f[i+4>>2]|0;if(!e)return;i=j+-4|0;if((j|0)<4){d=(j|0)>0;k=e;l=g;m=a;while(1){k=k+-1|0;if(d){n=0;do{o=b[m+n>>0]|0;b[l+n>>0]=(o|0)>0?o:0;n=n+1|0}while((n|0)!=(j|0))}if(!k)break;else{l=l+h|0;m=m+c|0}}return}m=j&-4;l=(m|0)<(j|0);k=e;e=g;g=a;while(1){a=0;do{d=b[g+a>>0]|0;n=a|1;o=b[g+n>>0]|0;b[e+a>>0]=(d|0)>0?d:0;b[e+n>>0]=(o|0)>0?o:0;o=a|2;n=b[g+o>>0]|0;d=a|3;p=b[g+d>>0]|0;b[e+o>>0]=(n|0)>0?n:0;b[e+d>>0]=(p|0)>0?p:0;a=a+4|0}while((a|0)<=(i|0));k=k+-1|0;if(l){a=m;do{p=b[g+a>>0]|0;b[e+a>>0]=(p|0)>0?p:0;a=a+1|0}while((a|0)!=(j|0))}if(!k)break;else{e=e+h|0;g=g+c|0}}return}function YI(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;k=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>1;if(!e)return;c=k+-4|0;if((k|0)<4){d=(k|0)>0;l=e;m=g;n=a;while(1){l=l+-1|0;if(d){o=0;do{p=j[n+(o<<1)>>1]|0;b[m+o>>0]=p>>>0<255?p:255;o=o+1|0}while((o|0)!=(k|0))}if(!l)break;else{m=m+h|0;n=n+(i<<1)|0}}return}n=k&-4;m=(n|0)<(k|0);l=e;e=g;g=a;while(1){a=0;do{d=j[g+(a<<1)>>1]|0;o=a|1;p=j[g+(o<<1)>>1]|0;b[e+a>>0]=d>>>0<255?d:255;b[e+o>>0]=p>>>0<255?p:255;p=a|2;o=j[g+(p<<1)>>1]|0;d=a|3;q=j[g+(d<<1)>>1]|0;b[e+p>>0]=o>>>0<255?o:255;b[e+d>>0]=q>>>0<255?q:255;a=a+4|0}while((a|0)<=(c|0));l=l+-1|0;if(m){a=n;do{q=j[g+(a<<1)>>1]|0;b[e+a>>0]=q>>>0<255?q:255;a=a+1|0}while((a|0)!=(k|0))}if(!l)break;else{e=e+h|0;g=g+(i<<1)|0}}return}function ZI(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;k=f[j>>2]|0;g=f[j+4>>2]|0;j=c>>>1;if(!g)return;c=k+-4|0;if((k|0)<4){e=(k|0)>0;l=g;m=h;n=a;while(1){l=l+-1|0;if(e){o=0;do{p=d[n+(o<<1)>>1]|0;b[m+o>>0]=(p&65535)<256?p&65535:p<<16>>16>0?255:0;o=o+1|0}while((o|0)!=(k|0))}if(!l)break;else{m=m+i|0;n=n+(j<<1)|0}}return}n=k&-4;m=(n|0)<(k|0);l=g;g=h;h=a;while(1){a=0;do{e=d[h+(a<<1)>>1]|0;o=a|1;p=d[h+(o<<1)>>1]|0;b[g+a>>0]=(e&65535)<256?e&65535:e<<16>>16>0?255:0;b[g+o>>0]=(p&65535)<256?p&65535:p<<16>>16>0?255:0;p=a|2;o=d[h+(p<<1)>>1]|0;e=a|3;q=d[h+(e<<1)>>1]|0;b[g+p>>0]=(o&65535)<256?o&65535:o<<16>>16>0?255:0;b[g+e>>0]=(q&65535)<256?q&65535:q<<16>>16>0?255:0;a=a+4|0}while((a|0)<=(c|0));l=l+-1|0;if(m){a=n;do{q=d[h+(a<<1)>>1]|0;b[g+a>>0]=(q&65535)<256?q&65535:q<<16>>16>0?255:0;a=a+1|0}while((a|0)!=(k|0))}if(!l)break;else{g=g+i|0;h=h+(j<<1)|0}}return}function _I(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>2;if(!e)return;c=j+-4|0;if((j|0)<4){d=(j|0)>0;k=e;l=g;m=a;while(1){k=k+-1|0;if(d){n=0;do{o=f[m+(n<<2)>>2]|0;b[l+n>>0]=o>>>0<256?o:(o|0)>0?255:0;n=n+1|0}while((n|0)!=(j|0))}if(!k)break;else{l=l+h|0;m=m+(i<<2)|0}}return}m=j&-4;l=(m|0)<(j|0);k=e;e=g;g=a;while(1){a=0;do{d=f[g+(a<<2)>>2]|0;n=a|1;o=f[g+(n<<2)>>2]|0;b[e+a>>0]=d>>>0<256?d:(d|0)>0?255:0;b[e+n>>0]=o>>>0<256?o:(o|0)>0?255:0;o=a|2;n=f[g+(o<<2)>>2]|0;d=a|3;p=f[g+(d<<2)>>2]|0;b[e+o>>0]=n>>>0<256?n:(n|0)>0?255:0;b[e+d>>0]=p>>>0<256?p:(p|0)>0?255:0;a=a+4|0}while((a|0)<=(c|0));k=k+-1|0;if(l){a=m;do{p=f[g+(a<<2)>>2]|0;b[e+a>>0]=p>>>0<256?p:(p|0)>0?255:0;a=a+1|0}while((a|0)!=(j|0))}if(!k)break;else{e=e+h|0;g=g+(i<<2)|0}}return}function $I(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>2;if(!e)return;c=j+-4|0;if((j|0)<4){d=(j|0)>0;k=e;l=g;m=a;while(1){k=k+-1|0;if(d){o=0;do{p=wNa(+n[m+(o<<2)>>2])|0;b[l+o>>0]=p>>>0<256?p:(p|0)>0?255:0;o=o+1|0}while((o|0)!=(j|0))}if(!k)break;else{l=l+h|0;m=m+(i<<2)|0}}return}m=j&-4;l=(m|0)<(j|0);k=e;e=g;g=a;while(1){a=0;do{d=wNa(+n[g+(a<<2)>>2])|0;o=a|1;p=wNa(+n[g+(o<<2)>>2])|0;b[e+a>>0]=d>>>0<256?d:(d|0)>0?255:0;b[e+o>>0]=p>>>0<256?p:(p|0)>0?255:0;p=a|2;o=wNa(+n[g+(p<<2)>>2])|0;d=a|3;q=wNa(+n[g+(d<<2)>>2])|0;b[e+p>>0]=o>>>0<256?o:(o|0)>0?255:0;b[e+d>>0]=q>>>0<256?q:(q|0)>0?255:0;a=a+4|0}while((a|0)<=(c|0));k=k+-1|0;if(l){a=m;do{q=wNa(+n[g+(a<<2)>>2])|0;b[e+a>>0]=q>>>0<256?q:(q|0)>0?255:0;a=a+1|0}while((a|0)!=(j|0))}if(!k)break;else{e=e+h|0;g=g+(i<<2)|0}}return}function aJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>3;if(!e)return;c=j+-4|0;if((j|0)<4){d=(j|0)>0;k=e;l=g;m=a;while(1){k=k+-1|0;if(d){n=0;do{o=rNa(+p[m+(n<<3)>>3])|0;b[l+n>>0]=o>>>0<256?o:(o|0)>0?255:0;n=n+1|0}while((n|0)!=(j|0))}if(!k)break;else{l=l+h|0;m=m+(i<<3)|0}}return}m=j&-4;l=(m|0)<(j|0);k=e;e=g;g=a;while(1){a=0;do{d=rNa(+p[g+(a<<3)>>3])|0;n=a|1;o=rNa(+p[g+(n<<3)>>3])|0;b[e+a>>0]=d>>>0<256?d:(d|0)>0?255:0;b[e+n>>0]=o>>>0<256?o:(o|0)>0?255:0;o=a|2;n=rNa(+p[g+(o<<3)>>3])|0;d=a|3;q=rNa(+p[g+(d<<3)>>3])|0;b[e+o>>0]=n>>>0<256?n:(n|0)>0?255:0;b[e+d>>0]=q>>>0<256?q:(q|0)>0?255:0;a=a+4|0}while((a|0)<=(c|0));k=k+-1|0;if(l){a=m;do{q=rNa(+p[g+(a<<3)>>3])|0;b[e+a>>0]=q>>>0<256?q:(q|0)>0?255:0;a=a+1|0}while((a|0)!=(j|0))}if(!k)break;else{e=e+h|0;g=g+(i<<3)|0}}return}function bJ(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;k=f[j>>2]|0;e=f[j+4>>2]|0;if(!e)return;j=k+-4|0;if((k|0)<4){d=(k|0)>0;l=e;m=g;n=a;while(1){l=l+-1|0;if(d){o=0;do{p=h[n+o>>0]|0;b[m+o>>0]=p>>>0<127?p:127;o=o+1|0}while((o|0)!=(k|0))}if(!l)break;else{m=m+i|0;n=n+c|0}}return}n=k&-4;m=(n|0)<(k|0);l=e;e=g;g=a;while(1){a=0;do{d=h[g+a>>0]|0;o=a|1;p=h[g+o>>0]|0;b[e+a>>0]=d>>>0<127?d:127;b[e+o>>0]=p>>>0<127?p:127;p=a|2;o=h[g+p>>0]|0;d=a|3;q=h[g+d>>0]|0;b[e+p>>0]=o>>>0<127?o:127;b[e+d>>0]=q>>>0<127?q:127;a=a+4|0}while((a|0)<=(j|0));l=l+-1|0;if(m){a=n;do{q=h[g+a>>0]|0;b[e+a>>0]=q>>>0<127?q:127;a=a+1|0}while((a|0)!=(k|0))}if(!l)break;else{e=e+i|0;g=g+c|0}}return}function cJ(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;k=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>1;if(!e)return;c=k+-4|0;if((k|0)<4){d=(k|0)>0;l=e;m=g;n=a;while(1){l=l+-1|0;if(d){o=0;do{p=j[n+(o<<1)>>1]|0;b[m+o>>0]=p>>>0<127?p:127;o=o+1|0}while((o|0)!=(k|0))}if(!l)break;else{m=m+h|0;n=n+(i<<1)|0}}return}n=k&-4;m=(n|0)<(k|0);l=e;e=g;g=a;while(1){a=0;do{d=j[g+(a<<1)>>1]|0;o=a|1;p=j[g+(o<<1)>>1]|0;b[e+a>>0]=d>>>0<127?d:127;b[e+o>>0]=p>>>0<127?p:127;p=a|2;o=j[g+(p<<1)>>1]|0;d=a|3;q=j[g+(d<<1)>>1]|0;b[e+p>>0]=o>>>0<127?o:127;b[e+d>>0]=q>>>0<127?q:127;a=a+4|0}while((a|0)<=(c|0));l=l+-1|0;if(m){a=n;do{q=j[g+(a<<1)>>1]|0;b[e+a>>0]=q>>>0<127?q:127;a=a+1|0}while((a|0)!=(k|0))}if(!l)break;else{e=e+h|0;g=g+(i<<1)|0}}return}function dJ(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=f[j>>2]|0;g=f[j+4>>2]|0;j=c>>>1;if(!g)return;c=k+-4|0;if((k|0)<4){e=(k|0)>0;l=g;m=h;n=a;while(1){l=l+-1|0;if(e){o=0;do{p=d[n+(o<<1)>>1]|0;q=p<<16>>16;b[m+o>>0]=(q+128|0)>>>0<256?q:p<<16>>16>0?127:128;o=o+1|0}while((o|0)!=(k|0))}if(!l)break;else{m=m+i|0;n=n+(j<<1)|0}}return}n=k&-4;m=(n|0)<(k|0);l=g;g=h;h=a;while(1){a=0;do{e=d[h+(a<<1)>>1]|0;o=e<<16>>16;p=a|1;q=d[h+(p<<1)>>1]|0;r=q<<16>>16;b[g+a>>0]=(o+128|0)>>>0<256?o:e<<16>>16>0?127:128;b[g+p>>0]=(r+128|0)>>>0<256?r:q<<16>>16>0?127:128;q=a|2;r=d[h+(q<<1)>>1]|0;p=r<<16>>16;e=a|3;o=d[h+(e<<1)>>1]|0;s=o<<16>>16;b[g+q>>0]=(p+128|0)>>>0<256?p:r<<16>>16>0?127:128;b[g+e>>0]=(s+128|0)>>>0<256?s:o<<16>>16>0?127:128;a=a+4|0}while((a|0)<=(c|0));l=l+-1|0;if(m){a=n;do{o=d[h+(a<<1)>>1]|0;s=o<<16>>16;b[g+a>>0]=(s+128|0)>>>0<256?s:o<<16>>16>0?127:128;a=a+1|0}while((a|0)!=(k|0))}if(!l)break;else{g=g+i|0;h=h+(j<<1)|0}}return}function eJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>2;if(!e)return;c=j+-4|0;if((j|0)<4){d=(j|0)>0;k=e;l=g;m=a;while(1){k=k+-1|0;if(d){n=0;do{o=f[m+(n<<2)>>2]|0;b[l+n>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;n=n+1|0}while((n|0)!=(j|0))}if(!k)break;else{l=l+h|0;m=m+(i<<2)|0}}return}m=j&-4;l=(m|0)<(j|0);k=e;e=g;g=a;while(1){a=0;do{d=f[g+(a<<2)>>2]|0;n=a|1;o=f[g+(n<<2)>>2]|0;b[e+a>>0]=(d+128|0)>>>0<256?d:(d|0)>0?127:128;b[e+n>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;o=a|2;n=f[g+(o<<2)>>2]|0;d=a|3;p=f[g+(d<<2)>>2]|0;b[e+o>>0]=(n+128|0)>>>0<256?n:(n|0)>0?127:128;b[e+d>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;a=a+4|0}while((a|0)<=(c|0));k=k+-1|0;if(l){a=m;do{p=f[g+(a<<2)>>2]|0;b[e+a>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;a=a+1|0}while((a|0)!=(j|0))}if(!k)break;else{e=e+h|0;g=g+(i<<2)|0}}return}function fJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>2;if(!e)return;c=j+-4|0;if((j|0)<4){d=(j|0)>0;k=e;l=g;m=a;while(1){k=k+-1|0;if(d){o=0;do{p=wNa(+n[m+(o<<2)>>2])|0;b[l+o>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;o=o+1|0}while((o|0)!=(j|0))}if(!k)break;else{l=l+h|0;m=m+(i<<2)|0}}return}m=j&-4;l=(m|0)<(j|0);k=e;e=g;g=a;while(1){a=0;do{d=wNa(+n[g+(a<<2)>>2])|0;o=a|1;p=wNa(+n[g+(o<<2)>>2])|0;b[e+a>>0]=(d+128|0)>>>0<256?d:(d|0)>0?127:128;b[e+o>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;p=a|2;o=wNa(+n[g+(p<<2)>>2])|0;d=a|3;q=wNa(+n[g+(d<<2)>>2])|0;b[e+p>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;b[e+d>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;a=a+4|0}while((a|0)<=(c|0));k=k+-1|0;if(l){a=m;do{q=wNa(+n[g+(a<<2)>>2])|0;b[e+a>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;a=a+1|0}while((a|0)!=(j|0))}if(!k)break;else{e=e+h|0;g=g+(i<<2)|0}}return}function gJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>3;if(!e)return;c=j+-4|0;if((j|0)<4){d=(j|0)>0;k=e;l=g;m=a;while(1){k=k+-1|0;if(d){n=0;do{o=rNa(+p[m+(n<<3)>>3])|0;b[l+n>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;n=n+1|0}while((n|0)!=(j|0))}if(!k)break;else{l=l+h|0;m=m+(i<<3)|0}}return}m=j&-4;l=(m|0)<(j|0);k=e;e=g;g=a;while(1){a=0;do{d=rNa(+p[g+(a<<3)>>3])|0;n=a|1;o=rNa(+p[g+(n<<3)>>3])|0;b[e+a>>0]=(d+128|0)>>>0<256?d:(d|0)>0?127:128;b[e+n>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;o=a|2;n=rNa(+p[g+(o<<3)>>3])|0;d=a|3;q=rNa(+p[g+(d<<3)>>3])|0;b[e+o>>0]=(n+128|0)>>>0<256?n:(n|0)>0?127:128;b[e+d>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;a=a+4|0}while((a|0)<=(c|0));k=k+-1|0;if(l){a=m;do{q=rNa(+p[g+(a<<3)>>3])|0;b[e+a>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;a=a+1|0}while((a|0)!=(j|0))}if(!k)break;else{e=e+h|0;g=g+(i<<3)|0}}return}function hJ(a,b,c,e,g,i,j,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;k=f[j>>2]|0;e=f[j+4>>2]|0;j=i>>>1;if(!e)return;i=k+-4|0;if((k|0)<4){c=(k|0)>0;l=e;m=g;n=a;while(1){l=l+-1|0;if(c){o=0;do{d[m+(o<<1)>>1]=h[n+o>>0]|0;o=o+1|0}while((o|0)!=(k|0))}if(!l)break;else{m=m+(j<<1)|0;n=n+b|0}}return}n=k&-4;m=(n|0)<(k|0);l=e;e=g;g=a;while(1){a=0;do{c=a|1;o=h[g+c>>0]|0;d[e+(a<<1)>>1]=h[g+a>>0]|0;d[e+(c<<1)>>1]=o;o=a|2;c=a|3;p=h[g+c>>0]|0;d[e+(o<<1)>>1]=h[g+o>>0]|0;d[e+(c<<1)>>1]=p;a=a+4|0}while((a|0)<=(i|0));l=l+-1|0;if(m){a=n;do{d[e+(a<<1)>>1]=h[g+a>>0]|0;a=a+1|0}while((a|0)!=(k|0))}if(!l)break;else{e=e+(j<<1)|0;g=g+b|0}}return}function iJ(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;k=f[j>>2]|0;g=f[j+4>>2]|0;j=i>>>1;if(!g)return;i=k+-4|0;if((k|0)<4){e=(k|0)>0;l=g;m=h;n=a;while(1){l=l+-1|0;if(e){o=0;do{p=b[n+o>>0]|0;d[m+(o<<1)>>1]=(p|0)>0?p:0;o=o+1|0}while((o|0)!=(k|0))}if(!l)break;else{m=m+(j<<1)|0;n=n+c|0}}return}n=k&-4;m=(n|0)<(k|0);l=g;g=h;h=a;while(1){a=0;do{e=b[h+a>>0]|0;o=a|1;p=b[h+o>>0]|0;d[g+(a<<1)>>1]=(e|0)>0?e:0;d[g+(o<<1)>>1]=(p|0)>0?p:0;p=a|2;o=b[h+p>>0]|0;e=a|3;q=b[h+e>>0]|0;d[g+(p<<1)>>1]=(o|0)>0?o:0;d[g+(e<<1)>>1]=(q|0)>0?q:0;a=a+4|0}while((a|0)<=(i|0));l=l+-1|0;if(m){a=n;do{q=b[h+a>>0]|0;d[g+(a<<1)>>1]=(q|0)>0?q:0;a=a+1|0}while((a|0)!=(k|0))}if(!l)break;else{g=g+(j<<1)|0;h=h+c|0}}return}function jJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;i=f[h+4>>2]|0;d=b>>>1;b=g>>>1;if(!i)return;g=f[h>>2]<<1;h=i;i=e;e=a;while(1){h=h+-1|0;K1a(i|0,e|0,g|0)|0;if(!h)break;else{i=i+(b<<1)|0;e=e+(d<<1)|0}}return}function kJ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>1;h=e+-1|0;if(!e)return;if((j|0)<4){if((j|0)>0){k=h;l=g;m=a}else return;while(1){e=0;do{c=d[m+(e<<1)>>1]|0;d[l+(e<<1)>>1]=(c|0)>0?c:0;e=e+1|0}while((e|0)!=(j|0));if(!k)break;else{k=k+-1|0;l=l+(b<<1)|0;m=m+(i<<1)|0}}return}m=j+-4|0;l=(((m|0)>3?m:3)&2147483644)+4|0;if((l|0)<(j|0)){n=h;o=g;p=a}else{k=h;h=g;g=a;while(1){a=0;do{e=d[g+(a<<1)>>1]|0;c=a|1;q=d[g+(c<<1)>>1]|0;d[h+(a<<1)>>1]=(e|0)>0?e:0;d[h+(c<<1)>>1]=(q|0)>0?q:0;q=a|2;c=d[g+(q<<1)>>1]|0;e=a|3;r=d[g+(e<<1)>>1]|0;d[h+(q<<1)>>1]=(c|0)>0?c:0;d[h+(e<<1)>>1]=(r|0)>0?r:0;a=a+4|0}while((a|0)<=(m|0));if(!k)break;else{k=k+-1|0;h=h+(b<<1)|0;g=g+(i<<1)|0}}return}while(1){g=0;do{h=d[p+(g<<1)>>1]|0;k=g|1;a=d[p+(k<<1)>>1]|0;d[o+(g<<1)>>1]=(h|0)>0?h:0;d[o+(k<<1)>>1]=(a|0)>0?a:0;a=g|2;k=d[p+(a<<1)>>1]|0;h=g|3;r=d[p+(h<<1)>>1]|0;d[o+(a<<1)>>1]=(k|0)>0?k:0;d[o+(h<<1)>>1]=(r|0)>0?r:0;g=g+4|0}while((g|0)<=(m|0));s=l;do{g=d[p+(s<<1)>>1]|0;d[o+(s<<1)>>1]=(g|0)>0?g:0;s=s+1|0}while((s|0)!=(j|0));if(!n)break;else{n=n+-1|0;o=o+(b<<1)|0;p=p+(i<<1)|0}}return}function lJ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>2;b=h>>>1;if(!e)return;h=j+-4|0;c=(((h|0)>3?h:3)&2147483644)+4|0;if((j|0)<4){k=(j|0)>0;l=e;m=g;n=a;while(1){l=l+-1|0;if(k){o=0;do{p=f[n+(o<<2)>>2]|0;d[m+(o<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;o=o+1|0}while((o|0)!=(j|0))}if(!l)break;else{m=m+(b<<1)|0;n=n+(i<<2)|0}}return}n=(c|0)<(j|0);m=e;e=g;g=a;while(1){a=0;do{l=f[g+(a<<2)>>2]|0;k=a|1;o=f[g+(k<<2)>>2]|0;d[e+(a<<1)>>1]=l>>>0<65536?l:(l|0)>0?65535:0;d[e+(k<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;o=a|2;k=f[g+(o<<2)>>2]|0;l=a|3;p=f[g+(l<<2)>>2]|0;d[e+(o<<1)>>1]=k>>>0<65536?k:(k|0)>0?65535:0;d[e+(l<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;a=a+4|0}while((a|0)<=(h|0));m=m+-1|0;if(n){a=c;do{p=f[g+(a<<2)>>2]|0;d[e+(a<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;a=a+1|0}while((a|0)!=(j|0))}if(!m)break;else{e=e+(b<<1)|0;g=g+(i<<2)|0}}return}function mJ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>2;b=h>>>1;h=e+-1|0;if(!e)return;if((j|0)<4){if((j|0)>0){k=h;l=g;m=a}else return;while(1){e=0;do{c=wNa(+n[m+(e<<2)>>2])|0;d[l+(e<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;e=e+1|0}while((e|0)!=(j|0));if(!k)break;else{k=k+-1|0;l=l+(b<<1)|0;m=m+(i<<2)|0}}return}m=j+-4|0;l=(((m|0)>3?m:3)&2147483644)+4|0;if((l|0)<(j|0)){o=h;p=g;q=a}else{k=h;h=g;g=a;while(1){a=0;do{e=wNa(+n[g+(a<<2)>>2])|0;c=a|1;r=wNa(+n[g+(c<<2)>>2])|0;d[h+(a<<1)>>1]=e>>>0<65536?e:(e|0)>0?65535:0;d[h+(c<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;r=a|2;c=wNa(+n[g+(r<<2)>>2])|0;e=a|3;s=wNa(+n[g+(e<<2)>>2])|0;d[h+(r<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;d[h+(e<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;a=a+4|0}while((a|0)<=(m|0));if(!k)break;else{k=k+-1|0;h=h+(b<<1)|0;g=g+(i<<2)|0}}return}while(1){g=0;do{h=wNa(+n[q+(g<<2)>>2])|0;k=g|1;a=wNa(+n[q+(k<<2)>>2])|0;d[p+(g<<1)>>1]=h>>>0<65536?h:(h|0)>0?65535:0;d[p+(k<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=g|2;k=wNa(+n[q+(a<<2)>>2])|0;h=g|3;s=wNa(+n[q+(h<<2)>>2])|0;d[p+(a<<1)>>1]=k>>>0<65536?k:(k|0)>0?65535:0;d[p+(h<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;g=g+4|0}while((g|0)<=(m|0));t=l;do{g=wNa(+n[q+(t<<2)>>2])|0;d[p+(t<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;t=t+1|0}while((t|0)!=(j|0));if(!o)break;else{o=o+-1|0;p=p+(b<<1)|0;q=q+(i<<2)|0}}return}function nJ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>3;b=h>>>1;h=e+-1|0;if(!e)return;if((j|0)<4){if((j|0)>0){k=h;l=g;m=a}else return;while(1){e=0;do{c=rNa(+p[m+(e<<3)>>3])|0;d[l+(e<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;e=e+1|0}while((e|0)!=(j|0));if(!k)break;else{k=k+-1|0;l=l+(b<<1)|0;m=m+(i<<3)|0}}return}m=j+-4|0;l=(((m|0)>3?m:3)&2147483644)+4|0;if((l|0)<(j|0)){n=h;o=g;q=a}else{k=h;h=g;g=a;while(1){a=0;do{e=rNa(+p[g+(a<<3)>>3])|0;c=a|1;r=rNa(+p[g+(c<<3)>>3])|0;d[h+(a<<1)>>1]=e>>>0<65536?e:(e|0)>0?65535:0;d[h+(c<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;r=a|2;c=rNa(+p[g+(r<<3)>>3])|0;e=a|3;s=rNa(+p[g+(e<<3)>>3])|0;d[h+(r<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;d[h+(e<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;a=a+4|0}while((a|0)<=(m|0));if(!k)break;else{k=k+-1|0;h=h+(b<<1)|0;g=g+(i<<3)|0}}return}while(1){g=0;do{h=rNa(+p[q+(g<<3)>>3])|0;k=g|1;a=rNa(+p[q+(k<<3)>>3])|0;d[o+(g<<1)>>1]=h>>>0<65536?h:(h|0)>0?65535:0;d[o+(k<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=g|2;k=rNa(+p[q+(a<<3)>>3])|0;h=g|3;s=rNa(+p[q+(h<<3)>>3])|0;d[o+(a<<1)>>1]=k>>>0<65536?k:(k|0)>0?65535:0;d[o+(h<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;g=g+4|0}while((g|0)<=(m|0));t=l;do{g=rNa(+p[q+(t<<3)>>3])|0;d[o+(t<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;t=t+1|0}while((t|0)!=(j|0));if(!n)break;else{n=n+-1|0;o=o+(b<<1)|0;q=q+(i<<3)|0}}return}function oJ(a,b,c,e,g,i,j,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;k=f[j>>2]|0;e=f[j+4>>2]|0;j=i>>>1;if(!e)return;i=k+-4|0;if((k|0)<4){c=(k|0)>0;l=e;m=g;n=a;while(1){l=l+-1|0;if(c){o=0;do{d[m+(o<<1)>>1]=h[n+o>>0]|0;o=o+1|0}while((o|0)!=(k|0))}if(!l)break;else{m=m+(j<<1)|0;n=n+b|0}}return}n=k&-4;m=(n|0)<(k|0);l=e;e=g;g=a;while(1){a=0;do{c=a|1;o=h[g+c>>0]|0;d[e+(a<<1)>>1]=h[g+a>>0]|0;d[e+(c<<1)>>1]=o;o=a|2;c=a|3;p=h[g+c>>0]|0;d[e+(o<<1)>>1]=h[g+o>>0]|0;d[e+(c<<1)>>1]=p;a=a+4|0}while((a|0)<=(i|0));l=l+-1|0;if(m){a=n;do{d[e+(a<<1)>>1]=h[g+a>>0]|0;a=a+1|0}while((a|0)!=(k|0))}if(!l)break;else{e=e+(j<<1)|0;g=g+b|0}}return}function pJ(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;k=f[j>>2]|0;g=f[j+4>>2]|0;j=i>>>1;if(!g)return;i=k+-4|0;if((k|0)<4){e=(k|0)>0;l=g;m=h;n=a;while(1){l=l+-1|0;if(e){o=0;do{d[m+(o<<1)>>1]=b[n+o>>0]|0;o=o+1|0}while((o|0)!=(k|0))}if(!l)break;else{m=m+(j<<1)|0;n=n+c|0}}return}n=k&-4;m=(n|0)<(k|0);l=g;g=h;h=a;while(1){a=0;do{e=a|1;o=b[h+e>>0]|0;d[g+(a<<1)>>1]=b[h+a>>0]|0;d[g+(e<<1)>>1]=o;o=a|2;e=a|3;p=b[h+e>>0]|0;d[g+(o<<1)>>1]=b[h+o>>0]|0;d[g+(e<<1)>>1]=p;a=a+4|0}while((a|0)<=(i|0));l=l+-1|0;if(m){a=n;do{d[g+(a<<1)>>1]=b[h+a>>0]|0;a=a+1|0}while((a|0)!=(k|0))}if(!l)break;else{g=g+(j<<1)|0;h=h+c|0}}return}function qJ(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>1;h=e+-1|0;if(!e)return;if((k|0)<4){if((k|0)>0){l=h;m=g;n=a}else return;while(1){e=0;do{c=j[n+(e<<1)>>1]|0;d[m+(e<<1)>>1]=c>>>0<32767?c:32767;e=e+1|0}while((e|0)!=(k|0));if(!l)break;else{l=l+-1|0;m=m+(b<<1)|0;n=n+(i<<1)|0}}return}n=k+-4|0;m=(((n|0)>3?n:3)&2147483644)+4|0;if((m|0)<(k|0)){o=h;p=g;q=a}else{l=h;h=g;g=a;while(1){a=0;do{e=j[g+(a<<1)>>1]|0;c=a|1;r=j[g+(c<<1)>>1]|0;d[h+(a<<1)>>1]=e>>>0<32767?e:32767;d[h+(c<<1)>>1]=r>>>0<32767?r:32767;r=a|2;c=j[g+(r<<1)>>1]|0;e=a|3;s=j[g+(e<<1)>>1]|0;d[h+(r<<1)>>1]=c>>>0<32767?c:32767;d[h+(e<<1)>>1]=s>>>0<32767?s:32767;a=a+4|0}while((a|0)<=(n|0));if(!l)break;else{l=l+-1|0;h=h+(b<<1)|0;g=g+(i<<1)|0}}return}while(1){g=0;do{h=j[q+(g<<1)>>1]|0;l=g|1;a=j[q+(l<<1)>>1]|0;d[p+(g<<1)>>1]=h>>>0<32767?h:32767;d[p+(l<<1)>>1]=a>>>0<32767?a:32767;a=g|2;l=j[q+(a<<1)>>1]|0;h=g|3;s=j[q+(h<<1)>>1]|0;d[p+(a<<1)>>1]=l>>>0<32767?l:32767;d[p+(h<<1)>>1]=s>>>0<32767?s:32767;g=g+4|0}while((g|0)<=(n|0));t=m;do{g=j[q+(t<<1)>>1]|0;d[p+(t<<1)>>1]=g>>>0<32767?g:32767;t=t+1|0}while((t|0)!=(k|0));if(!o)break;else{o=o+-1|0;p=p+(b<<1)|0;q=q+(i<<1)|0}}return}function rJ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>2;b=h>>>1;if(!e)return;h=j+-4|0;c=(((h|0)>3?h:3)&2147483644)+4|0;if((j|0)<4){k=(j|0)>0;l=e;m=g;n=a;while(1){l=l+-1|0;if(k){o=0;do{p=f[n+(o<<2)>>2]|0;d[m+(o<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;o=o+1|0}while((o|0)!=(j|0))}if(!l)break;else{m=m+(b<<1)|0;n=n+(i<<2)|0}}return}n=(c|0)<(j|0);m=e;e=g;g=a;while(1){a=0;do{l=f[g+(a<<2)>>2]|0;k=a|1;o=f[g+(k<<2)>>2]|0;d[e+(a<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;d[e+(k<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;o=a|2;k=f[g+(o<<2)>>2]|0;l=a|3;p=f[g+(l<<2)>>2]|0;d[e+(o<<1)>>1]=(k+32768|0)>>>0<65536?k:(k|0)>0?32767:32768;d[e+(l<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;a=a+4|0}while((a|0)<=(h|0));m=m+-1|0;if(n){a=c;do{p=f[g+(a<<2)>>2]|0;d[e+(a<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;a=a+1|0}while((a|0)!=(j|0))}if(!m)break;else{e=e+(b<<1)|0;g=g+(i<<2)|0}}return}function sJ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>2;b=h>>>1;if((j|0)>0&(e|0)!=0){k=e;l=g;m=a}else return;while(1){a=0;do{g=wNa(+n[m+(a<<2)>>2])|0;d[l+(a<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;a=a+1|0}while((a|0)!=(j|0));k=k+-1|0;if(!k)break;else{l=l+(b<<1)|0;m=m+(i<<2)|0}}return}function tJ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>3;b=h>>>1;h=e+-1|0;if(!e)return;if((j|0)<4){if((j|0)>0){k=h;l=g;m=a}else return;while(1){e=0;do{c=rNa(+p[m+(e<<3)>>3])|0;d[l+(e<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;e=e+1|0}while((e|0)!=(j|0));if(!k)break;else{k=k+-1|0;l=l+(b<<1)|0;m=m+(i<<3)|0}}return}m=j+-4|0;l=(((m|0)>3?m:3)&2147483644)+4|0;k=(l|0)<(j|0);e=h;h=g;g=a;while(1){a=0;do{c=rNa(+p[g+(a<<3)>>3])|0;n=a|1;o=rNa(+p[g+(n<<3)>>3])|0;d[h+(a<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;d[h+(n<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;o=a|2;n=rNa(+p[g+(o<<3)>>3])|0;c=a|3;q=rNa(+p[g+(c<<3)>>3])|0;d[h+(o<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;d[h+(c<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;a=a+4|0}while((a|0)<=(m|0));if(k){a=l;do{q=rNa(+p[g+(a<<3)>>3])|0;d[h+(a<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;a=a+1|0}while((a|0)!=(j|0))}if(!e)break;else{e=e+-1|0;h=h+(b<<1)|0;g=g+(i<<3)|0}}return}function uJ(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;j=f[i>>2]|0;d=f[i+4>>2]|0;i=g>>>2;if(!d)return;g=j+-4|0;if((j|0)<4){c=(j|0)>0;k=d;l=e;m=a;while(1){k=k+-1|0;if(c){n=0;do{f[l+(n<<2)>>2]=h[m+n>>0];n=n+1|0}while((n|0)!=(j|0))}if(!k)break;else{l=l+(i<<2)|0;m=m+b|0}}return}m=j&-4;l=(m|0)<(j|0);k=d;d=e;e=a;while(1){a=0;do{c=a|1;n=h[e+c>>0]|0;f[d+(a<<2)>>2]=h[e+a>>0];f[d+(c<<2)>>2]=n;n=a|2;c=a|3;o=h[e+c>>0]|0;f[d+(n<<2)>>2]=h[e+n>>0];f[d+(c<<2)>>2]=o;a=a+4|0}while((a|0)<=(g|0));k=k+-1|0;if(l){a=m;do{f[d+(a<<2)>>2]=h[e+a>>0];a=a+1|0}while((a|0)!=(j|0))}if(!k)break;else{d=d+(i<<2)|0;e=e+b|0}}return}function vJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=h>>>2;if(!e)return;h=j+-4|0;if((j|0)<4){d=(j|0)>0;k=e;l=g;m=a;while(1){k=k+-1|0;if(d){n=0;do{f[l+(n<<2)>>2]=b[m+n>>0];n=n+1|0}while((n|0)!=(j|0))}if(!k)break;else{l=l+(i<<2)|0;m=m+c|0}}return}m=j&-4;l=(m|0)<(j|0);k=e;e=g;g=a;while(1){a=0;do{d=a|1;n=b[g+d>>0]|0;f[e+(a<<2)>>2]=b[g+a>>0];f[e+(d<<2)>>2]=n;n=a|2;d=a|3;o=b[g+d>>0]|0;f[e+(n<<2)>>2]=b[g+n>>0];f[e+(d<<2)>>2]=o;a=a+4|0}while((a|0)<=(h|0));k=k+-1|0;if(l){a=m;do{f[e+(a<<2)>>2]=b[g+a>>0];a=a+1|0}while((a|0)!=(j|0))}if(!k)break;else{e=e+(i<<2)|0;g=g+c|0}}return}function wJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>1;b=g>>>2;if(!d)return;g=i+-4|0;if((i|0)<4){c=(i|0)>0;k=d;l=e;m=a;while(1){k=k+-1|0;if(c){n=0;do{f[l+(n<<2)>>2]=j[m+(n<<1)>>1];n=n+1|0}while((n|0)!=(i|0))}if(!k)break;else{l=l+(b<<2)|0;m=m+(h<<1)|0}}return}m=i&-4;l=(m|0)<(i|0);k=d;d=e;e=a;while(1){a=0;do{c=a|1;n=j[e+(c<<1)>>1]|0;f[d+(a<<2)>>2]=j[e+(a<<1)>>1];f[d+(c<<2)>>2]=n;n=a|2;c=a|3;o=j[e+(c<<1)>>1]|0;f[d+(n<<2)>>2]=j[e+(n<<1)>>1];f[d+(c<<2)>>2]=o;a=a+4|0}while((a|0)<=(g|0));k=k+-1|0;if(l){a=m;do{f[d+(a<<2)>>2]=j[e+(a<<1)>>1];a=a+1|0}while((a|0)!=(i|0))}if(!k)break;else{d=d+(b<<2)|0;e=e+(h<<1)|0}}return}function xJ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>2;if(!e)return;h=j+-4|0;if((j|0)<4){c=(j|0)>0;k=e;l=g;m=a;while(1){k=k+-1|0;if(c){n=0;do{f[l+(n<<2)>>2]=d[m+(n<<1)>>1];n=n+1|0}while((n|0)!=(j|0))}if(!k)break;else{l=l+(b<<2)|0;m=m+(i<<1)|0}}return}m=j&-4;l=(m|0)<(j|0);k=e;e=g;g=a;while(1){a=0;do{c=a|1;n=d[g+(c<<1)>>1]|0;f[e+(a<<2)>>2]=d[g+(a<<1)>>1];f[e+(c<<2)>>2]=n;n=a|2;c=a|3;o=d[g+(c<<1)>>1]|0;f[e+(n<<2)>>2]=d[g+(n<<1)>>1];f[e+(c<<2)>>2]=o;a=a+4|0}while((a|0)<=(h|0));k=k+-1|0;if(l){a=m;do{f[e+(a<<2)>>2]=d[g+(a<<1)>>1];a=a+1|0}while((a|0)!=(j|0))}if(!k)break;else{e=e+(b<<2)|0;g=g+(i<<1)|0}}return}function yJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;i=f[h+4>>2]|0;d=b>>>2;b=g>>>2;if(!i)return;g=f[h>>2]<<2;h=i;i=e;e=a;while(1){h=h+-1|0;K1a(i|0,e|0,g|0)|0;if(!h)break;else{i=i+(b<<2)|0;e=e+(d<<2)|0}}return}function zJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>2;b=g>>>2;if(!d)return;g=i+-4|0;if((i|0)<4){c=(i|0)>0;j=d;k=e;l=a;while(1){j=j+-1|0;if(c){m=0;do{o=wNa(+n[l+(m<<2)>>2])|0;f[k+(m<<2)>>2]=o;m=m+1|0}while((m|0)!=(i|0))}if(!j)break;else{k=k+(b<<2)|0;l=l+(h<<2)|0}}return}l=i&-4;k=(l|0)<(i|0);j=d;d=e;e=a;while(1){a=0;do{c=wNa(+n[e+(a<<2)>>2])|0;m=a|1;o=wNa(+n[e+(m<<2)>>2])|0;f[d+(a<<2)>>2]=c;f[d+(m<<2)>>2]=o;o=a|2;m=wNa(+n[e+(o<<2)>>2])|0;c=a|3;p=wNa(+n[e+(c<<2)>>2])|0;f[d+(o<<2)>>2]=m;f[d+(c<<2)>>2]=p;a=a+4|0}while((a|0)<=(g|0));j=j+-1|0;if(k){a=l;do{p=wNa(+n[e+(a<<2)>>2])|0;f[d+(a<<2)>>2]=p;a=a+1|0}while((a|0)!=(i|0))}if(!j)break;else{d=d+(b<<2)|0;e=e+(h<<2)|0}}return}function AJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>3;b=g>>>2;if(!d)return;g=i+-4|0;if((i|0)<4){c=(i|0)>0;j=d;k=e;l=a;while(1){j=j+-1|0;if(c){m=0;do{n=rNa(+p[l+(m<<3)>>3])|0;f[k+(m<<2)>>2]=n;m=m+1|0}while((m|0)!=(i|0))}if(!j)break;else{k=k+(b<<2)|0;l=l+(h<<3)|0}}return}l=i&-4;k=(l|0)<(i|0);j=d;d=e;e=a;while(1){a=0;do{c=rNa(+p[e+(a<<3)>>3])|0;m=a|1;n=rNa(+p[e+(m<<3)>>3])|0;f[d+(a<<2)>>2]=c;f[d+(m<<2)>>2]=n;n=a|2;m=rNa(+p[e+(n<<3)>>3])|0;c=a|3;o=rNa(+p[e+(c<<3)>>3])|0;f[d+(n<<2)>>2]=m;f[d+(c<<2)>>2]=o;a=a+4|0}while((a|0)<=(g|0));j=j+-1|0;if(k){a=l;do{o=rNa(+p[e+(a<<3)>>3])|0;f[d+(a<<2)>>2]=o;a=a+1|0}while((a|0)!=(i|0))}if(!j)break;else{d=d+(b<<2)|0;e=e+(h<<3)|0}}return}function BJ(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0.0;j=f[i>>2]|0;d=f[i+4>>2]|0;i=g>>>2;if(!d)return;g=j+-4|0;if((j|0)<4){c=(j|0)>0;k=d;l=e;m=a;while(1){k=k+-1|0;if(c){o=0;do{n[l+(o<<2)>>2]=+(h[m+o>>0]|0);o=o+1|0}while((o|0)!=(j|0))}if(!k)break;else{l=l+(i<<2)|0;m=m+b|0}}return}m=j&-4;l=(m|0)<(j|0);k=d;d=e;e=a;while(1){a=0;do{c=a|1;p=+(h[e+c>>0]|0);n[d+(a<<2)>>2]=+(h[e+a>>0]|0);n[d+(c<<2)>>2]=p;c=a|2;o=a|3;p=+(h[e+o>>0]|0);n[d+(c<<2)>>2]=+(h[e+c>>0]|0);n[d+(o<<2)>>2]=p;a=a+4|0}while((a|0)<=(g|0));k=k+-1|0;if(l){a=m;do{n[d+(a<<2)>>2]=+(h[e+a>>0]|0);a=a+1|0}while((a|0)!=(j|0))}if(!k)break;else{d=d+(i<<2)|0;e=e+b|0}}return}function CJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0.0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=h>>>2;if(!e)return;h=j+-4|0;if((j|0)<4){d=(j|0)>0;k=e;l=g;m=a;while(1){k=k+-1|0;if(d){o=0;do{n[l+(o<<2)>>2]=+(b[m+o>>0]|0);o=o+1|0}while((o|0)!=(j|0))}if(!k)break;else{l=l+(i<<2)|0;m=m+c|0}}return}m=j&-4;l=(m|0)<(j|0);k=e;e=g;g=a;while(1){a=0;do{d=a|1;p=+(b[g+d>>0]|0);n[e+(a<<2)>>2]=+(b[g+a>>0]|0);n[e+(d<<2)>>2]=p;d=a|2;o=a|3;p=+(b[g+o>>0]|0);n[e+(d<<2)>>2]=+(b[g+d>>0]|0);n[e+(o<<2)>>2]=p;a=a+4|0}while((a|0)<=(h|0));k=k+-1|0;if(l){a=m;do{n[e+(a<<2)>>2]=+(b[g+a>>0]|0);a=a+1|0}while((a|0)!=(j|0))}if(!k)break;else{e=e+(i<<2)|0;g=g+c|0}}return}function DJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>1;b=g>>>2;g=d+-1|0;if(!d)return;if((i|0)<4){if((i|0)>0){k=g;l=e;m=a}else return;while(1){d=0;do{n[l+(d<<2)>>2]=+(j[m+(d<<1)>>1]|0);d=d+1|0}while((d|0)!=(i|0));if(!k)break;else{k=k+-1|0;l=l+(b<<2)|0;m=m+(h<<1)|0}}return}m=i+-4|0;l=(((m|0)>3?m:3)&2147483644)+4|0;if((l|0)<(i|0)){o=g;p=e;q=a}else{k=g;g=e;e=a;while(1){a=0;do{d=a|1;r=+(j[e+(d<<1)>>1]|0);n[g+(a<<2)>>2]=+(j[e+(a<<1)>>1]|0);n[g+(d<<2)>>2]=r;d=a|2;c=a|3;r=+(j[e+(c<<1)>>1]|0);n[g+(d<<2)>>2]=+(j[e+(d<<1)>>1]|0);n[g+(c<<2)>>2]=r;a=a+4|0}while((a|0)<=(m|0));if(!k)break;else{k=k+-1|0;g=g+(b<<2)|0;e=e+(h<<1)|0}}return}while(1){e=0;do{g=e|1;r=+(j[q+(g<<1)>>1]|0);n[p+(e<<2)>>2]=+(j[q+(e<<1)>>1]|0);n[p+(g<<2)>>2]=r;g=e|2;k=e|3;r=+(j[q+(k<<1)>>1]|0);n[p+(g<<2)>>2]=+(j[q+(g<<1)>>1]|0);n[p+(k<<2)>>2]=r;e=e+4|0}while((e|0)<=(m|0));s=l;do{n[p+(s<<2)>>2]=+(j[q+(s<<1)>>1]|0);s=s+1|0}while((s|0)!=(i|0));if(!o)break;else{o=o+-1|0;p=p+(b<<2)|0;q=q+(h<<1)|0}}return}function EJ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>2;h=e+-1|0;if(!e)return;if((j|0)<4){if((j|0)>0){k=h;l=g;m=a}else return;while(1){e=0;do{n[l+(e<<2)>>2]=+(d[m+(e<<1)>>1]|0);e=e+1|0}while((e|0)!=(j|0));if(!k)break;else{k=k+-1|0;l=l+(b<<2)|0;m=m+(i<<1)|0}}return}m=j+-4|0;l=(((m|0)>3?m:3)&2147483644)+4|0;if((l|0)<(j|0)){o=h;p=g;q=a}else{k=h;h=g;g=a;while(1){a=0;do{e=a|1;r=+(d[g+(e<<1)>>1]|0);n[h+(a<<2)>>2]=+(d[g+(a<<1)>>1]|0);n[h+(e<<2)>>2]=r;e=a|2;c=a|3;r=+(d[g+(c<<1)>>1]|0);n[h+(e<<2)>>2]=+(d[g+(e<<1)>>1]|0);n[h+(c<<2)>>2]=r;a=a+4|0}while((a|0)<=(m|0));if(!k)break;else{k=k+-1|0;h=h+(b<<2)|0;g=g+(i<<1)|0}}return}while(1){g=0;do{h=g|1;r=+(d[q+(h<<1)>>1]|0);n[p+(g<<2)>>2]=+(d[q+(g<<1)>>1]|0);n[p+(h<<2)>>2]=r;h=g|2;k=g|3;r=+(d[q+(k<<1)>>1]|0);n[p+(h<<2)>>2]=+(d[q+(h<<1)>>1]|0);n[p+(k<<2)>>2]=r;g=g+4|0}while((g|0)<=(m|0));s=l;do{n[p+(s<<2)>>2]=+(d[q+(s<<1)>>1]|0);s=s+1|0}while((s|0)!=(j|0));if(!o)break;else{o=o+-1|0;p=p+(b<<2)|0;q=q+(i<<1)|0}}return}function FJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0.0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>2;b=g>>>2;if(!d)return;g=i+-4|0;c=(((g|0)>3?g:3)&2147483644)+4|0;if((i|0)<4){j=(i|0)>0;k=d;l=e;m=a;while(1){k=k+-1|0;if(j){o=0;do{n[l+(o<<2)>>2]=+(f[m+(o<<2)>>2]|0);o=o+1|0}while((o|0)!=(i|0))}if(!k)break;else{l=l+(b<<2)|0;m=m+(h<<2)|0}}return}m=(c|0)<(i|0);l=d;d=e;e=a;while(1){a=0;do{k=a|1;p=+(f[e+(k<<2)>>2]|0);n[d+(a<<2)>>2]=+(f[e+(a<<2)>>2]|0);n[d+(k<<2)>>2]=p;k=a|2;j=a|3;p=+(f[e+(j<<2)>>2]|0);n[d+(k<<2)>>2]=+(f[e+(k<<2)>>2]|0);n[d+(j<<2)>>2]=p;a=a+4|0}while((a|0)<=(g|0));l=l+-1|0;if(m){a=c;do{n[d+(a<<2)>>2]=+(f[e+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=(i|0))}if(!l)break;else{d=d+(b<<2)|0;e=e+(h<<2)|0}}return}function GJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0.0,s=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>3;b=g>>>2;g=d+-1|0;if(!d)return;if((i|0)<4){if((i|0)>0){j=g;k=e;l=a}else return;while(1){d=0;do{n[k+(d<<2)>>2]=+p[l+(d<<3)>>3];d=d+1|0}while((d|0)!=(i|0));if(!j)break;else{j=j+-1|0;k=k+(b<<2)|0;l=l+(h<<3)|0}}return}l=i+-4|0;k=(((l|0)>3?l:3)&2147483644)+4|0;if((k|0)<(i|0)){m=g;o=e;q=a}else{j=g;g=e;e=a;while(1){a=0;do{d=a|1;r=+p[e+(d<<3)>>3];n[g+(a<<2)>>2]=+p[e+(a<<3)>>3];n[g+(d<<2)>>2]=r;d=a|2;c=a|3;r=+p[e+(c<<3)>>3];n[g+(d<<2)>>2]=+p[e+(d<<3)>>3];n[g+(c<<2)>>2]=r;a=a+4|0}while((a|0)<=(l|0));if(!j)break;else{j=j+-1|0;g=g+(b<<2)|0;e=e+(h<<3)|0}}return}while(1){e=0;do{g=e|1;r=+p[q+(g<<3)>>3];n[o+(e<<2)>>2]=+p[q+(e<<3)>>3];n[o+(g<<2)>>2]=r;g=e|2;j=e|3;r=+p[q+(j<<3)>>3];n[o+(g<<2)>>2]=+p[q+(g<<3)>>3];n[o+(j<<2)>>2]=r;e=e+4|0}while((e|0)<=(l|0));s=k;do{n[o+(s<<2)>>2]=+p[q+(s<<3)>>3];s=s+1|0}while((s|0)!=(i|0));if(!m)break;else{m=m+-1|0;o=o+(b<<2)|0;q=q+(h<<3)|0}}return}function HJ(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0.0;j=f[i>>2]|0;d=f[i+4>>2]|0;i=g>>>3;if(!d)return;g=j+-4|0;if((j|0)<4){c=(j|0)>0;k=d;l=e;m=a;while(1){k=k+-1|0;if(c){n=0;do{p[l+(n<<3)>>3]=+(h[m+n>>0]|0);n=n+1|0}while((n|0)!=(j|0))}if(!k)break;else{l=l+(i<<3)|0;m=m+b|0}}return}m=j&-4;l=(m|0)<(j|0);k=d;d=e;e=a;while(1){a=0;do{c=a|1;o=+(h[e+c>>0]|0);p[d+(a<<3)>>3]=+(h[e+a>>0]|0);p[d+(c<<3)>>3]=o;c=a|2;n=a|3;o=+(h[e+n>>0]|0);p[d+(c<<3)>>3]=+(h[e+c>>0]|0);p[d+(n<<3)>>3]=o;a=a+4|0}while((a|0)<=(g|0));k=k+-1|0;if(l){a=m;do{p[d+(a<<3)>>3]=+(h[e+a>>0]|0);a=a+1|0}while((a|0)!=(j|0))}if(!k)break;else{d=d+(i<<3)|0;e=e+b|0}}return}function IJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0.0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=h>>>3;if(!e)return;h=j+-4|0;if((j|0)<4){d=(j|0)>0;k=e;l=g;m=a;while(1){k=k+-1|0;if(d){n=0;do{p[l+(n<<3)>>3]=+(b[m+n>>0]|0);n=n+1|0}while((n|0)!=(j|0))}if(!k)break;else{l=l+(i<<3)|0;m=m+c|0}}return}m=j&-4;l=(m|0)<(j|0);k=e;e=g;g=a;while(1){a=0;do{d=a|1;o=+(b[g+d>>0]|0);p[e+(a<<3)>>3]=+(b[g+a>>0]|0);p[e+(d<<3)>>3]=o;d=a|2;n=a|3;o=+(b[g+n>>0]|0);p[e+(d<<3)>>3]=+(b[g+d>>0]|0);p[e+(n<<3)>>3]=o;a=a+4|0}while((a|0)<=(h|0));k=k+-1|0;if(l){a=m;do{p[e+(a<<3)>>3]=+(b[g+a>>0]|0);a=a+1|0}while((a|0)!=(j|0))}if(!k)break;else{e=e+(i<<3)|0;g=g+c|0}}return}function JJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>1;b=g>>>3;g=d+-1|0;if(!d)return;if((i|0)<4){if((i|0)>0){k=g;l=e;m=a}else return;while(1){d=0;do{p[l+(d<<3)>>3]=+(j[m+(d<<1)>>1]|0);d=d+1|0}while((d|0)!=(i|0));if(!k)break;else{k=k+-1|0;l=l+(b<<3)|0;m=m+(h<<1)|0}}return}m=i+-4|0;l=(((m|0)>3?m:3)&2147483644)+4|0;if((l|0)<(i|0)){n=g;o=e;q=a}else{k=g;g=e;e=a;while(1){a=0;do{d=a|1;r=+(j[e+(d<<1)>>1]|0);p[g+(a<<3)>>3]=+(j[e+(a<<1)>>1]|0);p[g+(d<<3)>>3]=r;d=a|2;c=a|3;r=+(j[e+(c<<1)>>1]|0);p[g+(d<<3)>>3]=+(j[e+(d<<1)>>1]|0);p[g+(c<<3)>>3]=r;a=a+4|0}while((a|0)<=(m|0));if(!k)break;else{k=k+-1|0;g=g+(b<<3)|0;e=e+(h<<1)|0}}return}while(1){e=0;do{g=e|1;r=+(j[q+(g<<1)>>1]|0);p[o+(e<<3)>>3]=+(j[q+(e<<1)>>1]|0);p[o+(g<<3)>>3]=r;g=e|2;k=e|3;r=+(j[q+(k<<1)>>1]|0);p[o+(g<<3)>>3]=+(j[q+(g<<1)>>1]|0);p[o+(k<<3)>>3]=r;e=e+4|0}while((e|0)<=(m|0));s=l;do{p[o+(s<<3)>>3]=+(j[q+(s<<1)>>1]|0);s=s+1|0}while((s|0)!=(i|0));if(!n)break;else{n=n+-1|0;o=o+(b<<3)|0;q=q+(h<<1)|0}}return}function KJ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>3;h=e+-1|0;if(!e)return;if((j|0)<4){if((j|0)>0){k=h;l=g;m=a}else return;while(1){e=0;do{p[l+(e<<3)>>3]=+(d[m+(e<<1)>>1]|0);e=e+1|0}while((e|0)!=(j|0));if(!k)break;else{k=k+-1|0;l=l+(b<<3)|0;m=m+(i<<1)|0}}return}m=j+-4|0;l=(((m|0)>3?m:3)&2147483644)+4|0;if((l|0)<(j|0)){n=h;o=g;q=a}else{k=h;h=g;g=a;while(1){a=0;do{e=a|1;r=+(d[g+(e<<1)>>1]|0);p[h+(a<<3)>>3]=+(d[g+(a<<1)>>1]|0);p[h+(e<<3)>>3]=r;e=a|2;c=a|3;r=+(d[g+(c<<1)>>1]|0);p[h+(e<<3)>>3]=+(d[g+(e<<1)>>1]|0);p[h+(c<<3)>>3]=r;a=a+4|0}while((a|0)<=(m|0));if(!k)break;else{k=k+-1|0;h=h+(b<<3)|0;g=g+(i<<1)|0}}return}while(1){g=0;do{h=g|1;r=+(d[q+(h<<1)>>1]|0);p[o+(g<<3)>>3]=+(d[q+(g<<1)>>1]|0);p[o+(h<<3)>>3]=r;h=g|2;k=g|3;r=+(d[q+(k<<1)>>1]|0);p[o+(h<<3)>>3]=+(d[q+(h<<1)>>1]|0);p[o+(k<<3)>>3]=r;g=g+4|0}while((g|0)<=(m|0));s=l;do{p[o+(s<<3)>>3]=+(d[q+(s<<1)>>1]|0);s=s+1|0}while((s|0)!=(j|0));if(!n)break;else{n=n+-1|0;o=o+(b<<3)|0;q=q+(i<<1)|0}}return}function LJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0.0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>2;b=g>>>3;if(!d)return;g=i+-4|0;c=(((g|0)>3?g:3)&2147483644)+4|0;if((i|0)<4){j=(i|0)>0;k=d;l=e;m=a;while(1){k=k+-1|0;if(j){n=0;do{p[l+(n<<3)>>3]=+(f[m+(n<<2)>>2]|0);n=n+1|0}while((n|0)!=(i|0))}if(!k)break;else{l=l+(b<<3)|0;m=m+(h<<2)|0}}return}m=(c|0)<(i|0);l=d;d=e;e=a;while(1){a=0;do{k=a|1;o=+(f[e+(k<<2)>>2]|0);p[d+(a<<3)>>3]=+(f[e+(a<<2)>>2]|0);p[d+(k<<3)>>3]=o;k=a|2;j=a|3;o=+(f[e+(j<<2)>>2]|0);p[d+(k<<3)>>3]=+(f[e+(k<<2)>>2]|0);p[d+(j<<3)>>3]=o;a=a+4|0}while((a|0)<=(g|0));l=l+-1|0;if(m){a=c;do{p[d+(a<<3)>>3]=+(f[e+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=(i|0))}if(!l)break;else{d=d+(b<<3)|0;e=e+(h<<2)|0}}return}function MJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0.0,s=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>2;b=g>>>3;g=d+-1|0;if(!d)return;if((i|0)<4){if((i|0)>0){j=g;k=e;l=a}else return;while(1){d=0;do{p[k+(d<<3)>>3]=+n[l+(d<<2)>>2];d=d+1|0}while((d|0)!=(i|0));if(!j)break;else{j=j+-1|0;k=k+(b<<3)|0;l=l+(h<<2)|0}}return}l=i+-4|0;k=(((l|0)>3?l:3)&2147483644)+4|0;if((k|0)<(i|0)){m=g;o=e;q=a}else{j=g;g=e;e=a;while(1){a=0;do{d=a|1;r=+n[e+(d<<2)>>2];p[g+(a<<3)>>3]=+n[e+(a<<2)>>2];p[g+(d<<3)>>3]=r;d=a|2;c=a|3;r=+n[e+(c<<2)>>2];p[g+(d<<3)>>3]=+n[e+(d<<2)>>2];p[g+(c<<3)>>3]=r;a=a+4|0}while((a|0)<=(l|0));if(!j)break;else{j=j+-1|0;g=g+(b<<3)|0;e=e+(h<<2)|0}}return}while(1){e=0;do{g=e|1;r=+n[q+(g<<2)>>2];p[o+(e<<3)>>3]=+n[q+(e<<2)>>2];p[o+(g<<3)>>3]=r;g=e|2;j=e|3;r=+n[q+(j<<2)>>2];p[o+(g<<3)>>3]=+n[q+(g<<2)>>2];p[o+(j<<3)>>3]=r;e=e+4|0}while((e|0)<=(l|0));s=k;do{p[o+(s<<3)>>3]=+n[q+(s<<2)>>2];s=s+1|0}while((s|0)!=(i|0));if(!m)break;else{m=m+-1|0;o=o+(b<<3)|0;q=q+(h<<2)|0}}return}function NJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;i=f[h+4>>2]|0;d=b>>>3;b=g>>>3;if(!i)return;g=f[h>>2]<<3;h=i;i=e;e=a;while(1){h=h+-1|0;K1a(i|0,e|0,g|0)|0;if(!h)break;else{i=i+(b<<3)|0;e=e+(d<<3)|0}}return}function OJ(a,c,d,e){a=a|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+208|0;h=g+200|0;i=g+144|0;j=g;k=g+88|0;l=g+72|0;m=g+64|0;n=g+56|0;o=g+24|0;q=g+16|0;_$(h,31412);do if((NS(a)|0)==65536){r=f[a+4>>2]|0;f[i>>2]=f[r>>2];s=i+4|0;t=r+4|0;f[s>>2]=f[t>>2];v=i+8|0;f[v>>2]=f[r+8>>2];f[i+12>>2]=f[r+12>>2];f[i+16>>2]=f[r+16>>2];f[i+20>>2]=f[r+20>>2];f[i+24>>2]=f[r+24>>2];f[i+28>>2]=f[r+28>>2];f[i+32>>2]=f[r+32>>2];w=f[r+36>>2]|0;f[i+36>>2]=w;x=i+40|0;f[x>>2]=v;v=i+48|0;y=i+44|0;f[y>>2]=v;f[v>>2]=0;f[i+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[r+44>>2]|0;v=f[y>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];z=s;A=i;B=x;break}else{f[s>>2]=0;BR(i,r);z=s;A=i;B=x;break}}else{OR(i,a,-1);z=i+4|0;A=i;B=i+40|0}while(0);a=((f[A>>2]|0)>>>3&511)+1|0;p[j>>3]=d;p[j+8>>3]=e;MR(c,f[z>>2]|0,f[B>>2]|0,(a<<3)+-8|0,-1,0,0);do if((NS(c)|0)==65536){x=f[c+4>>2]|0;f[k>>2]=f[x>>2];s=k+4|0;r=x+4|0;f[s>>2]=f[r>>2];t=k+8|0;f[t>>2]=f[x+8>>2];f[k+12>>2]=f[x+12>>2];f[k+16>>2]=f[x+16>>2];f[k+20>>2]=f[x+20>>2];f[k+24>>2]=f[x+24>>2];f[k+28>>2]=f[x+28>>2];f[k+32>>2]=f[x+32>>2];v=f[x+36>>2]|0;f[k+36>>2]=v;f[k+40>>2]=t;t=k+48|0;y=k+44|0;f[y>>2]=t;f[t>>2]=0;f[k+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[r>>2]|0)<3){r=f[x+44>>2]|0;t=f[y>>2]|0;f[t>>2]=f[r>>2];f[t+4>>2]=f[r+4>>2];break}else{f[s>>2]=0;BR(k,x);break}}else OR(k,c,-1);while(0);c=f[A>>2]&7;x=f[31432+(c<<2)>>2]|0;if((c|0)==7){f[l>>2]=0;f[l+4>>2]=0;c=c$(l,9)|0;s=323538;r=c+9|0;do{b[c>>0]=b[s>>0]|0;c=c+1|0;s=s+1|0}while((c|0)<(r|0));j$(-215,l,159448,158478,5073);d$(l)}if((f[z>>2]|0)<3){s=f[A>>2]|0;A=f[k>>2]|0;c=f[i+12>>2]|0;r=f[i+8>>2]|0;t=W1a(c|0,((c|0)<0)<<31>>31|0,a|0,0)|0;y=W1a(t|0,J|0,r|0,((r|0)<0)<<31>>31|0)|0;if((s&16384&A|0)!=0?(y|0)==(y|0)&(((y|0)<0)<<31>>31|0)==(J|0):0){C=y;D=1}else{C=Y(c,a)|0;D=r}r=f[i+16>>2]|0;c=f[i+48>>2]|0;y=f[k+16>>2]|0;A=f[k+48>>2]|0;f[m>>2]=C;f[m+4>>2]=D;Oh[x&255](r,c,0,0,y,A,m,j)}else{f[l>>2]=i;f[l+4>>2]=k;f[l+8>>2]=0;bU(o,l,n,-1);l=Y(f[o+20>>2]|0,a)|0;a=o+16|0;m=n+4|0;A=q+4|0;y=0;while(1){if(y>>>0>=(f[a>>2]|0)>>>0)break;c=f[n>>2]|0;r=f[m>>2]|0;f[q>>2]=l;f[A>>2]=1;Oh[x&255](c,0,0,0,r,0,q,j);tR(o)|0;y=y+1|0}}y=k+36|0;o=f[y>>2]|0;if(o|0?(j=o+12|0,o=f[j>>2]|0,f[j>>2]=o+-1,(o|0)==1):0)CR(k);f[y>>2]=0;y=k+16|0;o=k+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[o>>2]|0)>0){y=f[k+40>>2]|0;j=0;do{f[y+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[o>>2]|0))}o=f[k+44>>2]|0;if((o|0)!=(k+48|0))ZF(o);o=i+36|0;k=f[o>>2]|0;if(k|0?(j=k+12|0,k=f[j>>2]|0,f[j>>2]=k+-1,(k|0)==1):0)CR(i);f[o>>2]=0;o=i+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[z>>2]|0)>0){o=f[B>>2]|0;B=0;do{f[o+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[z>>2]|0))}z=f[i+44>>2]|0;if((z|0)!=(i+48|0))ZF(z);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function PJ(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;e=f[j>>2]|0;d=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];if(!d)return;k=e+-4|0;if((e|0)<4){j=(e|0)>0;n=d;o=g;q=a;while(1){n=n+-1|0;if(j){r=0;do{s=wNa(+L(+(m+l*+(h[q+r>>0]|0))))|0;b[o+r>>0]=s>>>0<256?s:(s|0)>0?255:0;r=r+1|0}while((r|0)!=(e|0))}if(!n)break;else{o=o+i|0;q=q+c|0}}return}q=e&-4;o=(q|0)<(e|0);n=d;d=g;g=a;while(1){a=0;do{j=wNa(+L(+(m+l*+(h[g+a>>0]|0))))|0;r=a|1;s=wNa(+L(+(m+l*+(h[g+r>>0]|0))))|0;b[d+a>>0]=j>>>0<256?j:(j|0)>0?255:0;b[d+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a|2;r=wNa(+L(+(m+l*+(h[g+s>>0]|0))))|0;j=a|3;t=wNa(+L(+(m+l*+(h[g+j>>0]|0))))|0;b[d+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[d+j>>0]=t>>>0<256?t:(t|0)>0?255:0;a=a+4|0}while((a|0)<=(k|0));n=n+-1|0;if(o){a=q;do{t=wNa(+L(+(m+l*+(h[g+a>>0]|0))))|0;b[d+a>>0]=t>>>0<256?t:(t|0)>0?255:0;a=a+1|0}while((a|0)!=(e|0))}if(!n)break;else{d=d+i|0;g=g+c|0}}return}function QJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];if(!d)return;j=e+-4|0;if((e|0)<4){i=(e|0)>0;m=d;n=g;o=a;while(1){m=m+-1|0;if(i){q=0;do{r=wNa(+L(+(l+k*+(b[o+q>>0]|0))))|0;b[n+q>>0]=r>>>0<256?r:(r|0)>0?255:0;q=q+1|0}while((q|0)!=(e|0))}if(!m)break;else{n=n+h|0;o=o+c|0}}return}o=e&-4;n=(o|0)<(e|0);m=d;d=g;g=a;while(1){a=0;do{i=wNa(+L(+(l+k*+(b[g+a>>0]|0))))|0;q=a|1;r=wNa(+L(+(l+k*+(b[g+q>>0]|0))))|0;b[d+a>>0]=i>>>0<256?i:(i|0)>0?255:0;b[d+q>>0]=r>>>0<256?r:(r|0)>0?255:0;r=a|2;q=wNa(+L(+(l+k*+(b[g+r>>0]|0))))|0;i=a|3;s=wNa(+L(+(l+k*+(b[g+i>>0]|0))))|0;b[d+r>>0]=q>>>0<256?q:(q|0)>0?255:0;b[d+i>>0]=s>>>0<256?s:(s|0)>0?255:0;a=a+4|0}while((a|0)<=(j|0));m=m+-1|0;if(n){a=o;do{s=wNa(+L(+(l+k*+(b[g+a>>0]|0))))|0;b[d+a>>0]=s>>>0<256?s:(s|0)>0?255:0;a=a+1|0}while((a|0)!=(e|0))}if(!m)break;else{d=d+h|0;g=g+c|0}}return}function RJ(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;e=f[i>>2]|0;d=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if(!d)return;c=e+-4|0;if((e|0)<4){i=(e|0)>0;n=d;o=g;q=a;while(1){n=n+-1|0;if(i){r=0;do{s=wNa(+L(+(m+l*+(j[q+(r<<1)>>1]|0))))|0;b[o+r>>0]=s>>>0<256?s:(s|0)>0?255:0;r=r+1|0}while((r|0)!=(e|0))}if(!n)break;else{o=o+h|0;q=q+(k<<1)|0}}return}q=e&-4;o=(q|0)<(e|0);n=d;d=g;g=a;while(1){a=0;do{i=wNa(+L(+(m+l*+(j[g+(a<<1)>>1]|0))))|0;r=a|1;s=wNa(+L(+(m+l*+(j[g+(r<<1)>>1]|0))))|0;b[d+a>>0]=i>>>0<256?i:(i|0)>0?255:0;b[d+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a|2;r=wNa(+L(+(m+l*+(j[g+(s<<1)>>1]|0))))|0;i=a|3;t=wNa(+L(+(m+l*+(j[g+(i<<1)>>1]|0))))|0;b[d+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[d+i>>0]=t>>>0<256?t:(t|0)>0?255:0;a=a+4|0}while((a|0)<=(c|0));n=n+-1|0;if(o){a=q;do{t=wNa(+L(+(m+l*+(j[g+(a<<1)>>1]|0))))|0;b[d+a>>0]=t>>>0<256?t:(t|0)>0?255:0;a=a+1|0}while((a|0)!=(e|0))}if(!n)break;else{d=d+h|0;g=g+(k<<1)|0}}return}function SJ(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;g=f[j>>2]|0;e=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if(!e)return;c=g+-4|0;if((g|0)<4){j=(g|0)>0;n=e;o=h;q=a;while(1){n=n+-1|0;if(j){r=0;do{s=wNa(+L(+(m+l*+(d[q+(r<<1)>>1]|0))))|0;b[o+r>>0]=s>>>0<256?s:(s|0)>0?255:0;r=r+1|0}while((r|0)!=(g|0))}if(!n)break;else{o=o+i|0;q=q+(k<<1)|0}}return}q=g&-4;o=(q|0)<(g|0);n=e;e=h;h=a;while(1){a=0;do{j=wNa(+L(+(m+l*+(d[h+(a<<1)>>1]|0))))|0;r=a|1;s=wNa(+L(+(m+l*+(d[h+(r<<1)>>1]|0))))|0;b[e+a>>0]=j>>>0<256?j:(j|0)>0?255:0;b[e+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a|2;r=wNa(+L(+(m+l*+(d[h+(s<<1)>>1]|0))))|0;j=a|3;t=wNa(+L(+(m+l*+(d[h+(j<<1)>>1]|0))))|0;b[e+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[e+j>>0]=t>>>0<256?t:(t|0)>0?255:0;a=a+4|0}while((a|0)<=(c|0));n=n+-1|0;if(o){a=q;do{t=wNa(+L(+(m+l*+(d[h+(a<<1)>>1]|0))))|0;b[e+a>>0]=t>>>0<256?t:(t|0)>0?255:0;a=a+1|0}while((a|0)!=(g|0))}if(!n)break;else{e=e+i|0;h=h+(k<<1)|0}}return}function TJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if(!d)return;c=e+-4|0;if((e|0)<4){i=(e|0)>0;m=d;n=g;o=a;while(1){m=m+-1|0;if(i){q=0;do{r=wNa(+L(+(l+k*+(f[o+(q<<2)>>2]|0))))|0;b[n+q>>0]=r>>>0<256?r:(r|0)>0?255:0;q=q+1|0}while((q|0)!=(e|0))}if(!m)break;else{n=n+h|0;o=o+(j<<2)|0}}return}o=e&-4;n=(o|0)<(e|0);m=d;d=g;g=a;while(1){a=0;do{i=wNa(+L(+(l+k*+(f[g+(a<<2)>>2]|0))))|0;q=a|1;r=wNa(+L(+(l+k*+(f[g+(q<<2)>>2]|0))))|0;b[d+a>>0]=i>>>0<256?i:(i|0)>0?255:0;b[d+q>>0]=r>>>0<256?r:(r|0)>0?255:0;r=a|2;q=wNa(+L(+(l+k*+(f[g+(r<<2)>>2]|0))))|0;i=a|3;s=wNa(+L(+(l+k*+(f[g+(i<<2)>>2]|0))))|0;b[d+r>>0]=q>>>0<256?q:(q|0)>0?255:0;b[d+i>>0]=s>>>0<256?s:(s|0)>0?255:0;a=a+4|0}while((a|0)<=(c|0));m=m+-1|0;if(n){a=o;do{s=wNa(+L(+(l+k*+(f[g+(a<<2)>>2]|0))))|0;b[d+a>>0]=s>>>0<256?s:(s|0)>0?255:0;a=a+1|0}while((a|0)!=(e|0))}if(!m)break;else{d=d+h|0;g=g+(j<<2)|0}}return}function UJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0,s=0,t=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if(!d)return;c=e+-4|0;if((e|0)<4){i=(e|0)>0;m=d;o=g;q=a;while(1){m=m+-1|0;if(i){r=0;do{s=wNa(+L(+(l+k*+n[q+(r<<2)>>2])))|0;b[o+r>>0]=s>>>0<256?s:(s|0)>0?255:0;r=r+1|0}while((r|0)!=(e|0))}if(!m)break;else{o=o+h|0;q=q+(j<<2)|0}}return}q=e&-4;o=(q|0)<(e|0);m=d;d=g;g=a;while(1){a=0;do{i=wNa(+L(+(l+k*+n[g+(a<<2)>>2])))|0;r=a|1;s=wNa(+L(+(l+k*+n[g+(r<<2)>>2])))|0;b[d+a>>0]=i>>>0<256?i:(i|0)>0?255:0;b[d+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a|2;r=wNa(+L(+(l+k*+n[g+(s<<2)>>2])))|0;i=a|3;t=wNa(+L(+(l+k*+n[g+(i<<2)>>2])))|0;b[d+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[d+i>>0]=t>>>0<256?t:(t|0)>0?255:0;a=a+4|0}while((a|0)<=(c|0));m=m+-1|0;if(o){a=q;do{t=wNa(+L(+(l+k*+n[g+(a<<2)>>2])))|0;b[d+a>>0]=t>>>0<256?t:(t|0)>0?255:0;a=a+1|0}while((a|0)!=(e|0))}if(!m)break;else{d=d+h|0;g=g+(j<<2)|0}}return}function VJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;d=f[i+4>>2]|0;i=c>>>3;if(!d)return;k=+p[j>>3];l=+p[j+8>>3];j=e+-4|0;if((e|0)<4){c=(e|0)>0;m=d;n=g;o=a;while(1){m=m+-1|0;if(c){q=0;do{r=rNa(+L(+(l+k*+p[o+(q<<3)>>3])))|0;b[n+q>>0]=r>>>0<256?r:(r|0)>0?255:0;q=q+1|0}while((q|0)!=(e|0))}if(!m)break;else{n=n+h|0;o=o+(i<<3)|0}}return}o=e&-4;n=(o|0)<(e|0);m=d;d=g;g=a;while(1){a=0;do{c=rNa(+L(+(l+k*+p[g+(a<<3)>>3])))|0;q=a|1;r=rNa(+L(+(l+k*+p[g+(q<<3)>>3])))|0;b[d+a>>0]=c>>>0<256?c:(c|0)>0?255:0;b[d+q>>0]=r>>>0<256?r:(r|0)>0?255:0;r=a|2;q=rNa(+L(+(l+k*+p[g+(r<<3)>>3])))|0;c=a|3;s=rNa(+L(+(l+k*+p[g+(c<<3)>>3])))|0;b[d+r>>0]=q>>>0<256?q:(q|0)>0?255:0;b[d+c>>0]=s>>>0<256?s:(s|0)>0?255:0;a=a+4|0}while((a|0)<=(j|0));m=m+-1|0;if(n){a=o;do{s=rNa(+L(+(l+k*+p[g+(a<<3)>>3])))|0;b[d+a>>0]=s>>>0<256?s:(s|0)>0?255:0;a=a+1|0}while((a|0)!=(e|0))}if(!m)break;else{d=d+h|0;g=g+(i<<3)|0}}return}function WJ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=+e;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,M=0,N=0,O=0;h=u;u=u+224|0;i=h+208|0;j=h+152|0;k=h+88|0;l=h+96|0;m=h;n=h+72|0;o=h+56|0;q=h+64|0;r=h+24|0;s=h+16|0;_$(i,31464);if(+L(+(e+-1.0))<2.220446049250313e-16)t=+L(+g)<2.220446049250313e-16;else t=0;do if((d|0)<0)if(aT(c)|0){v=RR(c,-1)|0;w=f[a>>2]|0;x=v;y=a;break}else{v=f[a>>2]|0;w=v;x=v&4095;y=a;break}else{v=f[a>>2]|0;w=v;x=v&4088|d&7;y=a}while(0);d=w&7;v=x&7;if((d|0)!=(v|0)|t^1){f[j>>2]=w;w=j+4|0;z=a+4|0;A=f[z>>2]|0;f[w>>2]=A;B=j+8|0;f[B>>2]=f[a+8>>2];C=j+12|0;f[C>>2]=f[a+12>>2];D=j+16|0;f[D>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];E=j+36|0;F=f[a+36>>2]|0;f[E>>2]=F;G=j+40|0;f[G>>2]=B;H=j+48|0;I=j+44|0;f[I>>2]=H;f[H>>2]=0;f[j+52>>2]=0;if(!F)K=A;else{A=F+12|0;f[A>>2]=(f[A>>2]|0)+1;K=f[z>>2]|0}if((K|0)<3){K=f[a+44>>2]|0;A=f[I>>2]|0;f[A>>2]=f[K>>2];f[A+4>>2]=f[K+4>>2]}else{f[w>>2]=0;BR(j,a)}K=f[z>>2]|0;A=f[a+40>>2]|0;if((K|0)<3){F=f[A>>2]|0;f[k>>2]=f[A+4>>2];f[k+4>>2]=F;KS(c,k,x,-1,0,0)}else MR(c,K,A,x,-1,0,0);do if((NS(c)|0)==65536){x=f[c+4>>2]|0;f[l>>2]=f[x>>2];A=l+4|0;K=x+4|0;f[A>>2]=f[K>>2];k=l+8|0;f[k>>2]=f[x+8>>2];f[l+12>>2]=f[x+12>>2];f[l+16>>2]=f[x+16>>2];f[l+20>>2]=f[x+20>>2];f[l+24>>2]=f[x+24>>2];f[l+28>>2]=f[x+28>>2];f[l+32>>2]=f[x+32>>2];F=f[x+36>>2]|0;f[l+36>>2]=F;f[l+40>>2]=k;k=l+48|0;M=l+44|0;f[M>>2]=k;f[k>>2]=0;f[l+52>>2]=0;if(F|0){k=F+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[K>>2]|0)<3){K=f[x+44>>2]|0;k=f[M>>2]|0;f[k>>2]=f[K>>2];f[k+4>>2]=f[K+4>>2];break}else{f[A>>2]=0;BR(l,x);break}}else OR(l,c,-1);while(0);x=f[(t?31156:31484)+(v<<5)+(d<<2)>>2]|0;p[m>>3]=e;p[m+8>>3]=g;d=((f[y>>2]|0)>>>3&511)+1|0;if(!x){f[n>>2]=0;f[n+4>>2]=0;y=c$(n,9)|0;v=323538;t=y+9|0;do{b[y>>0]=b[v>>0]|0;y=y+1|0;v=v+1|0}while((y|0)<(t|0));j$(-215,n,159530,158478,5235);d$(n)}if((f[z>>2]|0)<3){z=f[j>>2]|0;v=f[l>>2]|0;y=f[C>>2]|0;C=f[B>>2]|0;B=W1a(y|0,((y|0)<0)<<31>>31|0,d|0,0)|0;t=W1a(B|0,J|0,C|0,((C|0)<0)<<31>>31|0)|0;if((z&16384&v|0)!=0?(t|0)==(t|0)&(((t|0)<0)<<31>>31|0)==(J|0):0){N=t;O=1}else{N=Y(y,d)|0;O=C}C=f[D>>2]|0;y=f[H>>2]|0;t=f[l+16>>2]|0;v=f[l+48>>2]|0;f[o>>2]=N;f[o+4>>2]=O;Oh[x&255](C,y,0,0,t,v,o,m)}else{f[n>>2]=j;f[n+4>>2]=l;f[n+8>>2]=0;bU(r,n,q,-1);n=Y(f[r+20>>2]|0,d)|0;d=r+16|0;o=q+4|0;v=s+4|0;t=0;while(1){if(t>>>0>=(f[d>>2]|0)>>>0)break;y=f[q>>2]|0;C=f[o>>2]|0;f[s>>2]=n;f[v>>2]=1;Oh[x&255](y,1,0,0,C,1,s,m);tR(r)|0;t=t+1|0}}t=l+36|0;r=f[t>>2]|0;if(r|0?(m=r+12|0,r=f[m>>2]|0,f[m>>2]=r+-1,(r|0)==1):0)CR(l);f[t>>2]=0;t=l+16|0;r=l+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[r>>2]|0)>0){t=f[l+40>>2]|0;m=0;do{f[t+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[r>>2]|0))}r=f[l+44>>2]|0;if((r|0)!=(l+48|0))ZF(r);r=f[E>>2]|0;if(r|0?(l=r+12|0,r=f[l>>2]|0,f[l>>2]=r+-1,(r|0)==1):0)CR(j);f[E>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[w>>2]|0)>0){D=f[G>>2]|0;G=0;do{f[D+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[w>>2]|0))}w=f[I>>2]|0;if((w|0)!=(H|0))ZF(w)}else eL(a,c);if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function XJ(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;e=f[j>>2]|0;d=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];if(!d)return;k=e+-4|0;if((e|0)<4){j=(e|0)>0;n=d;o=g;q=a;while(1){n=n+-1|0;if(j){r=0;do{s=wNa(m+l*+(h[q+r>>0]|0))|0;b[o+r>>0]=s>>>0<256?s:(s|0)>0?255:0;r=r+1|0}while((r|0)!=(e|0))}if(!n)break;else{o=o+i|0;q=q+c|0}}return}q=e&-4;o=(q|0)<(e|0);n=d;d=g;g=a;while(1){a=0;do{j=wNa(m+l*+(h[g+a>>0]|0))|0;r=a|1;s=wNa(m+l*+(h[g+r>>0]|0))|0;b[d+a>>0]=j>>>0<256?j:(j|0)>0?255:0;b[d+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a|2;r=wNa(m+l*+(h[g+s>>0]|0))|0;j=a|3;t=wNa(m+l*+(h[g+j>>0]|0))|0;b[d+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[d+j>>0]=t>>>0<256?t:(t|0)>0?255:0;a=a+4|0}while((a|0)<=(k|0));n=n+-1|0;if(o){a=q;do{t=wNa(m+l*+(h[g+a>>0]|0))|0;b[d+a>>0]=t>>>0<256?t:(t|0)>0?255:0;a=a+1|0}while((a|0)!=(e|0))}if(!n)break;else{d=d+i|0;g=g+c|0}}return}function YJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];if(!d)return;j=e+-4|0;if((e|0)<4){i=(e|0)>0;m=d;n=g;o=a;while(1){m=m+-1|0;if(i){q=0;do{r=wNa(l+k*+(b[o+q>>0]|0))|0;b[n+q>>0]=r>>>0<256?r:(r|0)>0?255:0;q=q+1|0}while((q|0)!=(e|0))}if(!m)break;else{n=n+h|0;o=o+c|0}}return}o=e&-4;n=(o|0)<(e|0);m=d;d=g;g=a;while(1){a=0;do{i=wNa(l+k*+(b[g+a>>0]|0))|0;q=a|1;r=wNa(l+k*+(b[g+q>>0]|0))|0;b[d+a>>0]=i>>>0<256?i:(i|0)>0?255:0;b[d+q>>0]=r>>>0<256?r:(r|0)>0?255:0;r=a|2;q=wNa(l+k*+(b[g+r>>0]|0))|0;i=a|3;s=wNa(l+k*+(b[g+i>>0]|0))|0;b[d+r>>0]=q>>>0<256?q:(q|0)>0?255:0;b[d+i>>0]=s>>>0<256?s:(s|0)>0?255:0;a=a+4|0}while((a|0)<=(j|0));m=m+-1|0;if(n){a=o;do{s=wNa(l+k*+(b[g+a>>0]|0))|0;b[d+a>>0]=s>>>0<256?s:(s|0)>0?255:0;a=a+1|0}while((a|0)!=(e|0))}if(!m)break;else{d=d+h|0;g=g+c|0}}return}function ZJ(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;e=f[i>>2]|0;d=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if(!d)return;c=e+-4|0;if((e|0)<4){i=(e|0)>0;n=d;o=g;q=a;while(1){n=n+-1|0;if(i){r=0;do{s=wNa(m+l*+(j[q+(r<<1)>>1]|0))|0;b[o+r>>0]=s>>>0<256?s:(s|0)>0?255:0;r=r+1|0}while((r|0)!=(e|0))}if(!n)break;else{o=o+h|0;q=q+(k<<1)|0}}return}q=e&-4;o=(q|0)<(e|0);n=d;d=g;g=a;while(1){a=0;do{i=wNa(m+l*+(j[g+(a<<1)>>1]|0))|0;r=a|1;s=wNa(m+l*+(j[g+(r<<1)>>1]|0))|0;b[d+a>>0]=i>>>0<256?i:(i|0)>0?255:0;b[d+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a|2;r=wNa(m+l*+(j[g+(s<<1)>>1]|0))|0;i=a|3;t=wNa(m+l*+(j[g+(i<<1)>>1]|0))|0;b[d+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[d+i>>0]=t>>>0<256?t:(t|0)>0?255:0;a=a+4|0}while((a|0)<=(c|0));n=n+-1|0;if(o){a=q;do{t=wNa(m+l*+(j[g+(a<<1)>>1]|0))|0;b[d+a>>0]=t>>>0<256?t:(t|0)>0?255:0;a=a+1|0}while((a|0)!=(e|0))}if(!n)break;else{d=d+h|0;g=g+(k<<1)|0}}return}function _J(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;g=f[j>>2]|0;e=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if(!e)return;c=g+-4|0;if((g|0)<4){j=(g|0)>0;n=e;o=h;q=a;while(1){n=n+-1|0;if(j){r=0;do{s=wNa(m+l*+(d[q+(r<<1)>>1]|0))|0;b[o+r>>0]=s>>>0<256?s:(s|0)>0?255:0;r=r+1|0}while((r|0)!=(g|0))}if(!n)break;else{o=o+i|0;q=q+(k<<1)|0}}return}q=g&-4;o=(q|0)<(g|0);n=e;e=h;h=a;while(1){a=0;do{j=wNa(m+l*+(d[h+(a<<1)>>1]|0))|0;r=a|1;s=wNa(m+l*+(d[h+(r<<1)>>1]|0))|0;b[e+a>>0]=j>>>0<256?j:(j|0)>0?255:0;b[e+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a|2;r=wNa(m+l*+(d[h+(s<<1)>>1]|0))|0;j=a|3;t=wNa(m+l*+(d[h+(j<<1)>>1]|0))|0;b[e+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[e+j>>0]=t>>>0<256?t:(t|0)>0?255:0;a=a+4|0}while((a|0)<=(c|0));n=n+-1|0;if(o){a=q;do{t=wNa(m+l*+(d[h+(a<<1)>>1]|0))|0;b[e+a>>0]=t>>>0<256?t:(t|0)>0?255:0;a=a+1|0}while((a|0)!=(g|0))}if(!n)break;else{e=e+i|0;h=h+(k<<1)|0}}return}function $J(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if(!d)return;c=e+-4|0;if((e|0)<4){i=(e|0)>0;m=d;n=g;o=a;while(1){m=m+-1|0;if(i){q=0;do{r=wNa(l+k*+(f[o+(q<<2)>>2]|0))|0;b[n+q>>0]=r>>>0<256?r:(r|0)>0?255:0;q=q+1|0}while((q|0)!=(e|0))}if(!m)break;else{n=n+h|0;o=o+(j<<2)|0}}return}o=e&-4;n=(o|0)<(e|0);m=d;d=g;g=a;while(1){a=0;do{i=wNa(l+k*+(f[g+(a<<2)>>2]|0))|0;q=a|1;r=wNa(l+k*+(f[g+(q<<2)>>2]|0))|0;b[d+a>>0]=i>>>0<256?i:(i|0)>0?255:0;b[d+q>>0]=r>>>0<256?r:(r|0)>0?255:0;r=a|2;q=wNa(l+k*+(f[g+(r<<2)>>2]|0))|0;i=a|3;s=wNa(l+k*+(f[g+(i<<2)>>2]|0))|0;b[d+r>>0]=q>>>0<256?q:(q|0)>0?255:0;b[d+i>>0]=s>>>0<256?s:(s|0)>0?255:0;a=a+4|0}while((a|0)<=(c|0));m=m+-1|0;if(n){a=o;do{s=wNa(l+k*+(f[g+(a<<2)>>2]|0))|0;b[d+a>>0]=s>>>0<256?s:(s|0)>0?255:0;a=a+1|0}while((a|0)!=(e|0))}if(!m)break;else{d=d+h|0;g=g+(j<<2)|0}}return}function aK(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0,s=0,t=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if(!d)return;c=e+-4|0;if((e|0)<4){i=(e|0)>0;m=d;o=g;q=a;while(1){m=m+-1|0;if(i){r=0;do{s=wNa(l+k*+n[q+(r<<2)>>2])|0;b[o+r>>0]=s>>>0<256?s:(s|0)>0?255:0;r=r+1|0}while((r|0)!=(e|0))}if(!m)break;else{o=o+h|0;q=q+(j<<2)|0}}return}q=e&-4;o=(q|0)<(e|0);m=d;d=g;g=a;while(1){a=0;do{i=wNa(l+k*+n[g+(a<<2)>>2])|0;r=a|1;s=wNa(l+k*+n[g+(r<<2)>>2])|0;b[d+a>>0]=i>>>0<256?i:(i|0)>0?255:0;b[d+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a|2;r=wNa(l+k*+n[g+(s<<2)>>2])|0;i=a|3;t=wNa(l+k*+n[g+(i<<2)>>2])|0;b[d+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[d+i>>0]=t>>>0<256?t:(t|0)>0?255:0;a=a+4|0}while((a|0)<=(c|0));m=m+-1|0;if(o){a=q;do{t=wNa(l+k*+n[g+(a<<2)>>2])|0;b[d+a>>0]=t>>>0<256?t:(t|0)>0?255:0;a=a+1|0}while((a|0)!=(e|0))}if(!m)break;else{d=d+h|0;g=g+(j<<2)|0}}return}function bK(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;d=f[i+4>>2]|0;i=c>>>3;if(!d)return;k=+p[j>>3];l=+p[j+8>>3];j=e+-4|0;if((e|0)<4){c=(e|0)>0;m=d;n=g;o=a;while(1){m=m+-1|0;if(c){q=0;do{r=rNa(l+k*+p[o+(q<<3)>>3])|0;b[n+q>>0]=r>>>0<256?r:(r|0)>0?255:0;q=q+1|0}while((q|0)!=(e|0))}if(!m)break;else{n=n+h|0;o=o+(i<<3)|0}}return}o=e&-4;n=(o|0)<(e|0);m=d;d=g;g=a;while(1){a=0;do{c=rNa(l+k*+p[g+(a<<3)>>3])|0;q=a|1;r=rNa(l+k*+p[g+(q<<3)>>3])|0;b[d+a>>0]=c>>>0<256?c:(c|0)>0?255:0;b[d+q>>0]=r>>>0<256?r:(r|0)>0?255:0;r=a|2;q=rNa(l+k*+p[g+(r<<3)>>3])|0;c=a|3;s=rNa(l+k*+p[g+(c<<3)>>3])|0;b[d+r>>0]=q>>>0<256?q:(q|0)>0?255:0;b[d+c>>0]=s>>>0<256?s:(s|0)>0?255:0;a=a+4|0}while((a|0)<=(j|0));m=m+-1|0;if(n){a=o;do{s=rNa(l+k*+p[g+(a<<3)>>3])|0;b[d+a>>0]=s>>>0<256?s:(s|0)>0?255:0;a=a+1|0}while((a|0)!=(e|0))}if(!m)break;else{d=d+h|0;g=g+(i<<3)|0}}return}function cK(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;e=f[j>>2]|0;d=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];if(!d)return;k=e+-4|0;if((e|0)<4){j=(e|0)>0;n=d;o=g;q=a;while(1){n=n+-1|0;if(j){r=0;do{s=wNa(m+l*+(h[q+r>>0]|0))|0;b[o+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;r=r+1|0}while((r|0)!=(e|0))}if(!n)break;else{o=o+i|0;q=q+c|0}}return}q=e&-4;o=(q|0)<(e|0);n=d;d=g;g=a;while(1){a=0;do{j=wNa(m+l*+(h[g+a>>0]|0))|0;r=a|1;s=wNa(m+l*+(h[g+r>>0]|0))|0;b[d+a>>0]=(j+128|0)>>>0<256?j:(j|0)>0?127:128;b[d+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;s=a|2;r=wNa(m+l*+(h[g+s>>0]|0))|0;j=a|3;t=wNa(m+l*+(h[g+j>>0]|0))|0;b[d+s>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;b[d+j>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;a=a+4|0}while((a|0)<=(k|0));n=n+-1|0;if(o){a=q;do{t=wNa(m+l*+(h[g+a>>0]|0))|0;b[d+a>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;a=a+1|0}while((a|0)!=(e|0))}if(!n)break;else{d=d+i|0;g=g+c|0}}return}function dK(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];if(!d)return;j=e+-4|0;if((e|0)<4){i=(e|0)>0;m=d;n=g;o=a;while(1){m=m+-1|0;if(i){q=0;do{r=wNa(l+k*+(b[o+q>>0]|0))|0;b[n+q>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;q=q+1|0}while((q|0)!=(e|0))}if(!m)break;else{n=n+h|0;o=o+c|0}}return}o=e&-4;n=(o|0)<(e|0);m=d;d=g;g=a;while(1){a=0;do{i=wNa(l+k*+(b[g+a>>0]|0))|0;q=a|1;r=wNa(l+k*+(b[g+q>>0]|0))|0;b[d+a>>0]=(i+128|0)>>>0<256?i:(i|0)>0?127:128;b[d+q>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;r=a|2;q=wNa(l+k*+(b[g+r>>0]|0))|0;i=a|3;s=wNa(l+k*+(b[g+i>>0]|0))|0;b[d+r>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;b[d+i>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;a=a+4|0}while((a|0)<=(j|0));m=m+-1|0;if(n){a=o;do{s=wNa(l+k*+(b[g+a>>0]|0))|0;b[d+a>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;a=a+1|0}while((a|0)!=(e|0))}if(!m)break;else{d=d+h|0;g=g+c|0}}return}function eK(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;e=f[i>>2]|0;d=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if(!d)return;c=e+-4|0;if((e|0)<4){i=(e|0)>0;n=d;o=g;q=a;while(1){n=n+-1|0;if(i){r=0;do{s=wNa(m+l*+(j[q+(r<<1)>>1]|0))|0;b[o+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;r=r+1|0}while((r|0)!=(e|0))}if(!n)break;else{o=o+h|0;q=q+(k<<1)|0}}return}q=e&-4;o=(q|0)<(e|0);n=d;d=g;g=a;while(1){a=0;do{i=wNa(m+l*+(j[g+(a<<1)>>1]|0))|0;r=a|1;s=wNa(m+l*+(j[g+(r<<1)>>1]|0))|0;b[d+a>>0]=(i+128|0)>>>0<256?i:(i|0)>0?127:128;b[d+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;s=a|2;r=wNa(m+l*+(j[g+(s<<1)>>1]|0))|0;i=a|3;t=wNa(m+l*+(j[g+(i<<1)>>1]|0))|0;b[d+s>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;b[d+i>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;a=a+4|0}while((a|0)<=(c|0));n=n+-1|0;if(o){a=q;do{t=wNa(m+l*+(j[g+(a<<1)>>1]|0))|0;b[d+a>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;a=a+1|0}while((a|0)!=(e|0))}if(!n)break;else{d=d+h|0;g=g+(k<<1)|0}}return}function fK(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;g=f[j>>2]|0;e=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if(!e)return;c=g+-4|0;if((g|0)<4){j=(g|0)>0;n=e;o=h;q=a;while(1){n=n+-1|0;if(j){r=0;do{s=wNa(m+l*+(d[q+(r<<1)>>1]|0))|0;b[o+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;r=r+1|0}while((r|0)!=(g|0))}if(!n)break;else{o=o+i|0;q=q+(k<<1)|0}}return}q=g&-4;o=(q|0)<(g|0);n=e;e=h;h=a;while(1){a=0;do{j=wNa(m+l*+(d[h+(a<<1)>>1]|0))|0;r=a|1;s=wNa(m+l*+(d[h+(r<<1)>>1]|0))|0;b[e+a>>0]=(j+128|0)>>>0<256?j:(j|0)>0?127:128;b[e+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;s=a|2;r=wNa(m+l*+(d[h+(s<<1)>>1]|0))|0;j=a|3;t=wNa(m+l*+(d[h+(j<<1)>>1]|0))|0;b[e+s>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;b[e+j>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;a=a+4|0}while((a|0)<=(c|0));n=n+-1|0;if(o){a=q;do{t=wNa(m+l*+(d[h+(a<<1)>>1]|0))|0;b[e+a>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;a=a+1|0}while((a|0)!=(g|0))}if(!n)break;else{e=e+i|0;h=h+(k<<1)|0}}return}function gK(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if(!d)return;c=e+-4|0;if((e|0)<4){i=(e|0)>0;m=d;n=g;o=a;while(1){m=m+-1|0;if(i){q=0;do{r=wNa(l+k*+(f[o+(q<<2)>>2]|0))|0;b[n+q>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;q=q+1|0}while((q|0)!=(e|0))}if(!m)break;else{n=n+h|0;o=o+(j<<2)|0}}return}o=e&-4;n=(o|0)<(e|0);m=d;d=g;g=a;while(1){a=0;do{i=wNa(l+k*+(f[g+(a<<2)>>2]|0))|0;q=a|1;r=wNa(l+k*+(f[g+(q<<2)>>2]|0))|0;b[d+a>>0]=(i+128|0)>>>0<256?i:(i|0)>0?127:128;b[d+q>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;r=a|2;q=wNa(l+k*+(f[g+(r<<2)>>2]|0))|0;i=a|3;s=wNa(l+k*+(f[g+(i<<2)>>2]|0))|0;b[d+r>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;b[d+i>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;a=a+4|0}while((a|0)<=(c|0));m=m+-1|0;if(n){a=o;do{s=wNa(l+k*+(f[g+(a<<2)>>2]|0))|0;b[d+a>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;a=a+1|0}while((a|0)!=(e|0))}if(!m)break;else{d=d+h|0;g=g+(j<<2)|0}}return}function hK(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0,s=0,t=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if(!d)return;c=e+-4|0;if((e|0)<4){i=(e|0)>0;m=d;o=g;q=a;while(1){m=m+-1|0;if(i){r=0;do{s=wNa(l+k*+n[q+(r<<2)>>2])|0;b[o+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;r=r+1|0}while((r|0)!=(e|0))}if(!m)break;else{o=o+h|0;q=q+(j<<2)|0}}return}q=e&-4;o=(q|0)<(e|0);m=d;d=g;g=a;while(1){a=0;do{i=wNa(l+k*+n[g+(a<<2)>>2])|0;r=a|1;s=wNa(l+k*+n[g+(r<<2)>>2])|0;b[d+a>>0]=(i+128|0)>>>0<256?i:(i|0)>0?127:128;b[d+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;s=a|2;r=wNa(l+k*+n[g+(s<<2)>>2])|0;i=a|3;t=wNa(l+k*+n[g+(i<<2)>>2])|0;b[d+s>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;b[d+i>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;a=a+4|0}while((a|0)<=(c|0));m=m+-1|0;if(o){a=q;do{t=wNa(l+k*+n[g+(a<<2)>>2])|0;b[d+a>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;a=a+1|0}while((a|0)!=(e|0))}if(!m)break;else{d=d+h|0;g=g+(j<<2)|0}}return}function iK(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;d=f[i+4>>2]|0;i=c>>>3;if(!d)return;k=+p[j>>3];l=+p[j+8>>3];j=e+-4|0;if((e|0)<4){c=(e|0)>0;m=d;n=g;o=a;while(1){m=m+-1|0;if(c){q=0;do{r=rNa(l+k*+p[o+(q<<3)>>3])|0;b[n+q>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;q=q+1|0}while((q|0)!=(e|0))}if(!m)break;else{n=n+h|0;o=o+(i<<3)|0}}return}o=e&-4;n=(o|0)<(e|0);m=d;d=g;g=a;while(1){a=0;do{c=rNa(l+k*+p[g+(a<<3)>>3])|0;q=a|1;r=rNa(l+k*+p[g+(q<<3)>>3])|0;b[d+a>>0]=(c+128|0)>>>0<256?c:(c|0)>0?127:128;b[d+q>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;r=a|2;q=rNa(l+k*+p[g+(r<<3)>>3])|0;c=a|3;s=rNa(l+k*+p[g+(c<<3)>>3])|0;b[d+r>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;b[d+c>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;a=a+4|0}while((a|0)<=(j|0));m=m+-1|0;if(n){a=o;do{s=rNa(l+k*+p[g+(a<<3)>>3])|0;b[d+a>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;a=a+1|0}while((a|0)!=(e|0))}if(!m)break;else{d=d+h|0;g=g+(i<<3)|0}}return}function jK(a,b,c,e,g,i,j,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;e=f[j>>2]|0;c=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=i>>>1;if(!c)return;i=e+-4|0;if((e|0)<4){j=(e|0)>0;n=c;o=g;q=a;while(1){n=n+-1|0;if(j){r=0;do{s=wNa(m+l*+(h[q+r>>0]|0))|0;d[o+(r<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;r=r+1|0}while((r|0)!=(e|0))}if(!n)break;else{o=o+(k<<1)|0;q=q+b|0}}return}q=e&-4;o=(q|0)<(e|0);n=c;c=g;g=a;while(1){a=0;do{j=wNa(m+l*+(h[g+a>>0]|0))|0;r=a|1;s=wNa(m+l*+(h[g+r>>0]|0))|0;d[c+(a<<1)>>1]=j>>>0<65536?j:(j|0)>0?65535:0;d[c+(r<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;s=a|2;r=wNa(m+l*+(h[g+s>>0]|0))|0;j=a|3;t=wNa(m+l*+(h[g+j>>0]|0))|0;d[c+(s<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;d[c+(j<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;a=a+4|0}while((a|0)<=(i|0));n=n+-1|0;if(o){a=q;do{t=wNa(m+l*+(h[g+a>>0]|0))|0;d[c+(a<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;a=a+1|0}while((a|0)!=(e|0))}if(!n)break;else{c=c+(k<<1)|0;g=g+b|0}}return}function kK(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;g=f[j>>2]|0;e=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=i>>>1;if(!e)return;i=g+-4|0;if((g|0)<4){j=(g|0)>0;n=e;o=h;q=a;while(1){n=n+-1|0;if(j){r=0;do{s=wNa(m+l*+(b[q+r>>0]|0))|0;d[o+(r<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;r=r+1|0}while((r|0)!=(g|0))}if(!n)break;else{o=o+(k<<1)|0;q=q+c|0}}return}q=g&-4;o=(q|0)<(g|0);n=e;e=h;h=a;while(1){a=0;do{j=wNa(m+l*+(b[h+a>>0]|0))|0;r=a|1;s=wNa(m+l*+(b[h+r>>0]|0))|0;d[e+(a<<1)>>1]=j>>>0<65536?j:(j|0)>0?65535:0;d[e+(r<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;s=a|2;r=wNa(m+l*+(b[h+s>>0]|0))|0;j=a|3;t=wNa(m+l*+(b[h+j>>0]|0))|0;d[e+(s<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;d[e+(j<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;a=a+4|0}while((a|0)<=(i|0));n=n+-1|0;if(o){a=q;do{t=wNa(m+l*+(b[h+a>>0]|0))|0;d[e+(a<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;a=a+1|0}while((a|0)!=(g|0))}if(!n)break;else{e=e+(k<<1)|0;h=h+c|0}}return}function lK(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;e=f[i>>2]|0;c=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=b>>>1;b=h>>>1;h=c+-1|0;if(!c)return;if((e|0)<4){if((e|0)>0){n=h;o=g;q=a}else return;while(1){c=0;do{i=wNa(m+l*+(j[q+(c<<1)>>1]|0))|0;d[o+(c<<1)>>1]=i>>>0<65536?i:(i|0)>0?65535:0;c=c+1|0}while((c|0)!=(e|0));if(!n)break;else{n=n+-1|0;o=o+(b<<1)|0;q=q+(k<<1)|0}}return}q=e+-4|0;o=(((q|0)>3?q:3)&2147483644)+4|0;n=(o|0)<(e|0);c=h;h=g;g=a;while(1){a=0;do{i=wNa(m+l*+(j[g+(a<<1)>>1]|0))|0;r=a|1;s=wNa(m+l*+(j[g+(r<<1)>>1]|0))|0;d[h+(a<<1)>>1]=i>>>0<65536?i:(i|0)>0?65535:0;d[h+(r<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;s=a|2;r=wNa(m+l*+(j[g+(s<<1)>>1]|0))|0;i=a|3;t=wNa(m+l*+(j[g+(i<<1)>>1]|0))|0;d[h+(s<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;d[h+(i<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;a=a+4|0}while((a|0)<=(q|0));if(n){a=o;do{t=wNa(m+l*+(j[g+(a<<1)>>1]|0))|0;d[h+(a<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;a=a+1|0}while((a|0)!=(e|0))}if(!c)break;else{c=c+-1|0;h=h+(b<<1)|0;g=g+(k<<1)|0}}return}function mK(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>1;b=h>>>1;h=c+-1|0;if(!c)return;if((e|0)<4){if((e|0)>0){m=h;n=g;o=a}else return;while(1){c=0;do{i=wNa(l+k*+(d[o+(c<<1)>>1]|0))|0;d[n+(c<<1)>>1]=i>>>0<65536?i:(i|0)>0?65535:0;c=c+1|0}while((c|0)!=(e|0));if(!m)break;else{m=m+-1|0;n=n+(b<<1)|0;o=o+(j<<1)|0}}return}o=e+-4|0;n=(((o|0)>3?o:3)&2147483644)+4|0;m=(n|0)<(e|0);c=h;h=g;g=a;while(1){a=0;do{i=wNa(l+k*+(d[g+(a<<1)>>1]|0))|0;q=a|1;r=wNa(l+k*+(d[g+(q<<1)>>1]|0))|0;d[h+(a<<1)>>1]=i>>>0<65536?i:(i|0)>0?65535:0;d[h+(q<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;r=a|2;q=wNa(l+k*+(d[g+(r<<1)>>1]|0))|0;i=a|3;s=wNa(l+k*+(d[g+(i<<1)>>1]|0))|0;d[h+(r<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;d[h+(i<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;a=a+4|0}while((a|0)<=(o|0));if(m){a=n;do{s=wNa(l+k*+(d[g+(a<<1)>>1]|0))|0;d[h+(a<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;a=a+1|0}while((a|0)!=(e|0))}if(!c)break;else{c=c+-1|0;h=h+(b<<1)|0;g=g+(j<<1)|0}}return}function nK(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>2;b=h>>>1;if(!c)return;h=e+-4|0;i=(((h|0)>3?h:3)&2147483644)+4|0;if((e|0)<4){m=(e|0)>0;n=c;o=g;q=a;while(1){n=n+-1|0;if(m){r=0;do{s=wNa(l+k*+(f[q+(r<<2)>>2]|0))|0;d[o+(r<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;r=r+1|0}while((r|0)!=(e|0))}if(!n)break;else{o=o+(b<<1)|0;q=q+(j<<2)|0}}return}q=(i|0)<(e|0);o=c;c=g;g=a;while(1){a=0;do{n=wNa(l+k*+(f[g+(a<<2)>>2]|0))|0;m=a|1;r=wNa(l+k*+(f[g+(m<<2)>>2]|0))|0;d[c+(a<<1)>>1]=n>>>0<65536?n:(n|0)>0?65535:0;d[c+(m<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;r=a|2;m=wNa(l+k*+(f[g+(r<<2)>>2]|0))|0;n=a|3;s=wNa(l+k*+(f[g+(n<<2)>>2]|0))|0;d[c+(r<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;d[c+(n<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;a=a+4|0}while((a|0)<=(h|0));o=o+-1|0;if(q){a=i;do{s=wNa(l+k*+(f[g+(a<<2)>>2]|0))|0;d[c+(a<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;a=a+1|0}while((a|0)!=(e|0))}if(!o)break;else{c=c+(b<<1)|0;g=g+(j<<2)|0}}return}function oK(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0,s=0,t=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>2;b=h>>>1;h=c+-1|0;if(!c)return;if((e|0)<4){if((e|0)>0){m=h;o=g;q=a}else return;while(1){c=0;do{i=wNa(l+k*+n[q+(c<<2)>>2])|0;d[o+(c<<1)>>1]=i>>>0<65536?i:(i|0)>0?65535:0;c=c+1|0}while((c|0)!=(e|0));if(!m)break;else{m=m+-1|0;o=o+(b<<1)|0;q=q+(j<<2)|0}}return}q=e+-4|0;o=(((q|0)>3?q:3)&2147483644)+4|0;m=(o|0)<(e|0);c=h;h=g;g=a;while(1){a=0;do{i=wNa(l+k*+n[g+(a<<2)>>2])|0;r=a|1;s=wNa(l+k*+n[g+(r<<2)>>2])|0;d[h+(a<<1)>>1]=i>>>0<65536?i:(i|0)>0?65535:0;d[h+(r<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;s=a|2;r=wNa(l+k*+n[g+(s<<2)>>2])|0;i=a|3;t=wNa(l+k*+n[g+(i<<2)>>2])|0;d[h+(s<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;d[h+(i<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;a=a+4|0}while((a|0)<=(q|0));if(m){a=o;do{t=wNa(l+k*+n[g+(a<<2)>>2])|0;d[h+(a<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;a=a+1|0}while((a|0)!=(e|0))}if(!c)break;else{c=c+-1|0;h=h+(b<<1)|0;g=g+(j<<2)|0}}return}function pK(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;c=f[i+4>>2]|0;i=b>>>3;b=h>>>1;h=c+-1|0;if(!c)return;k=+p[j>>3];l=+p[j+8>>3];if((e|0)<4){if((e|0)>0){m=h;n=g;o=a}else return;while(1){j=0;do{c=rNa(l+k*+p[o+(j<<3)>>3])|0;d[n+(j<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;j=j+1|0}while((j|0)!=(e|0));if(!m)break;else{m=m+-1|0;n=n+(b<<1)|0;o=o+(i<<3)|0}}return}o=e+-4|0;n=(((o|0)>3?o:3)&2147483644)+4|0;m=(n|0)<(e|0);j=h;h=g;g=a;while(1){a=0;do{c=rNa(l+k*+p[g+(a<<3)>>3])|0;q=a|1;r=rNa(l+k*+p[g+(q<<3)>>3])|0;d[h+(a<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;d[h+(q<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;r=a|2;q=rNa(l+k*+p[g+(r<<3)>>3])|0;c=a|3;s=rNa(l+k*+p[g+(c<<3)>>3])|0;d[h+(r<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;d[h+(c<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;a=a+4|0}while((a|0)<=(o|0));if(m){a=n;do{s=rNa(l+k*+p[g+(a<<3)>>3])|0;d[h+(a<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;a=a+1|0}while((a|0)!=(e|0))}if(!j)break;else{j=j+-1|0;h=h+(b<<1)|0;g=g+(i<<3)|0}}return}function qK(a,b,c,e,g,i,j,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;e=f[j>>2]|0;c=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=i>>>1;if(!c)return;i=e+-4|0;if((e|0)<4){j=(e|0)>0;n=c;o=g;q=a;while(1){n=n+-1|0;if(j){r=0;do{s=wNa(m+l*+(h[q+r>>0]|0))|0;d[o+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;r=r+1|0}while((r|0)!=(e|0))}if(!n)break;else{o=o+(k<<1)|0;q=q+b|0}}return}q=e&-4;o=(q|0)<(e|0);n=c;c=g;g=a;while(1){a=0;do{j=wNa(m+l*+(h[g+a>>0]|0))|0;r=a|1;s=wNa(m+l*+(h[g+r>>0]|0))|0;d[c+(a<<1)>>1]=(j+32768|0)>>>0<65536?j:(j|0)>0?32767:32768;d[c+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;s=a|2;r=wNa(m+l*+(h[g+s>>0]|0))|0;j=a|3;t=wNa(m+l*+(h[g+j>>0]|0))|0;d[c+(s<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;d[c+(j<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;a=a+4|0}while((a|0)<=(i|0));n=n+-1|0;if(o){a=q;do{t=wNa(m+l*+(h[g+a>>0]|0))|0;d[c+(a<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;a=a+1|0}while((a|0)!=(e|0))}if(!n)break;else{c=c+(k<<1)|0;g=g+b|0}}return}function rK(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;g=f[j>>2]|0;e=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=i>>>1;if(!e)return;i=g+-4|0;if((g|0)<4){j=(g|0)>0;n=e;o=h;q=a;while(1){n=n+-1|0;if(j){r=0;do{s=wNa(m+l*+(b[q+r>>0]|0))|0;d[o+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;r=r+1|0}while((r|0)!=(g|0))}if(!n)break;else{o=o+(k<<1)|0;q=q+c|0}}return}q=g&-4;o=(q|0)<(g|0);n=e;e=h;h=a;while(1){a=0;do{j=wNa(m+l*+(b[h+a>>0]|0))|0;r=a|1;s=wNa(m+l*+(b[h+r>>0]|0))|0;d[e+(a<<1)>>1]=(j+32768|0)>>>0<65536?j:(j|0)>0?32767:32768;d[e+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;s=a|2;r=wNa(m+l*+(b[h+s>>0]|0))|0;j=a|3;t=wNa(m+l*+(b[h+j>>0]|0))|0;d[e+(s<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;d[e+(j<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;a=a+4|0}while((a|0)<=(i|0));n=n+-1|0;if(o){a=q;do{t=wNa(m+l*+(b[h+a>>0]|0))|0;d[e+(a<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;a=a+1|0}while((a|0)!=(g|0))}if(!n)break;else{e=e+(k<<1)|0;h=h+c|0}}return}function sK(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;e=f[i>>2]|0;c=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=b>>>1;b=h>>>1;h=c+-1|0;if(!c)return;if((e|0)<4){if((e|0)>0){n=h;o=g;q=a}else return;while(1){c=0;do{i=wNa(m+l*+(j[q+(c<<1)>>1]|0))|0;d[o+(c<<1)>>1]=(i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768;c=c+1|0}while((c|0)!=(e|0));if(!n)break;else{n=n+-1|0;o=o+(b<<1)|0;q=q+(k<<1)|0}}return}q=e+-4|0;o=(((q|0)>3?q:3)&2147483644)+4|0;n=(o|0)<(e|0);c=h;h=g;g=a;while(1){a=0;do{i=wNa(m+l*+(j[g+(a<<1)>>1]|0))|0;r=a|1;s=wNa(m+l*+(j[g+(r<<1)>>1]|0))|0;d[h+(a<<1)>>1]=(i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768;d[h+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;s=a|2;r=wNa(m+l*+(j[g+(s<<1)>>1]|0))|0;i=a|3;t=wNa(m+l*+(j[g+(i<<1)>>1]|0))|0;d[h+(s<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;d[h+(i<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;a=a+4|0}while((a|0)<=(q|0));if(n){a=o;do{t=wNa(m+l*+(j[g+(a<<1)>>1]|0))|0;d[h+(a<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;a=a+1|0}while((a|0)!=(e|0))}if(!c)break;else{c=c+-1|0;h=h+(b<<1)|0;g=g+(k<<1)|0}}return}function tK(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>1;b=h>>>1;if((e|0)>0&(c|0)!=0){m=c;n=g;o=a}else return;while(1){a=0;do{g=wNa(l+k*+(d[o+(a<<1)>>1]|0))|0;d[n+(a<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;a=a+1|0}while((a|0)!=(e|0));m=m+-1|0;if(!m)break;else{n=n+(b<<1)|0;o=o+(j<<1)|0}}return}function uK(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>2;b=h>>>1;if(!c)return;h=e+-4|0;i=(((h|0)>3?h:3)&2147483644)+4|0;if((e|0)<4){m=(e|0)>0;n=c;o=g;q=a;while(1){n=n+-1|0;if(m){r=0;do{s=wNa(l+k*+(f[q+(r<<2)>>2]|0))|0;d[o+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;r=r+1|0}while((r|0)!=(e|0))}if(!n)break;else{o=o+(b<<1)|0;q=q+(j<<2)|0}}return}q=(i|0)<(e|0);o=c;c=g;g=a;while(1){a=0;do{n=wNa(l+k*+(f[g+(a<<2)>>2]|0))|0;m=a|1;r=wNa(l+k*+(f[g+(m<<2)>>2]|0))|0;d[c+(a<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;d[c+(m<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;r=a|2;m=wNa(l+k*+(f[g+(r<<2)>>2]|0))|0;n=a|3;s=wNa(l+k*+(f[g+(n<<2)>>2]|0))|0;d[c+(r<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;d[c+(n<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;a=a+4|0}while((a|0)<=(h|0));o=o+-1|0;if(q){a=i;do{s=wNa(l+k*+(f[g+(a<<2)>>2]|0))|0;d[c+(a<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;a=a+1|0}while((a|0)!=(e|0))}if(!o)break;else{c=c+(b<<1)|0;g=g+(j<<2)|0}}return}
function FWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=YOa(374219)|0;if(e>>>0>4294967279)WYa(a);if(e>>>0<11){b[a+11>>0]=e;g=a}else{h=e+16&-16;i=NYa(h)|0;f[a>>2]=i;f[a+8>>2]=h|-2147483648;f[a+4>>2]=e;g=i}kOa(g,374219,e)|0;b[d>>0]=0;ZOa(g+e|0,d);u=c;return}function GWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=YOa(374213)|0;if(e>>>0>4294967279)WYa(a);if(e>>>0<11){b[a+11>>0]=e;g=a}else{h=e+16&-16;i=NYa(h)|0;f[a>>2]=i;f[a+8>>2]=h|-2147483648;f[a+4>>2]=e;g=i}kOa(g,374213,e)|0;b[d>>0]=0;ZOa(g+e|0,d);u=c;return}function HWa(a){a=a|0;f[a>>2]=130064;_Ya(a+16|0);hQa(a);return}function IWa(a){a=a|0;HWa(a);PYa(a);return}function JWa(a){a=a|0;return f[a+8>>2]|0}function KWa(a){a=a|0;return f[a+12>>2]|0}function LWa(a,b){a=a|0;b=b|0;YYa(a,b+16|0);return}function MWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=nTa(130120)|0;if(e>>>0>1073741807)WYa(a);do if(e>>>0>=2){g=e+4&-4;if(g>>>0>1073741823)We();else{h=NYa(g<<2)|0;f[a>>2]=h;f[a+8>>2]=g|-2147483648;f[a+4>>2]=e;i=h;break}}else{b[a+8+3>>0]=e;i=a}while(0);COa(i,130120,e)|0;f[d>>2]=0;nQa(i+(e<<2)|0,d);u=c;return}function NWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=nTa(130096)|0;if(e>>>0>1073741807)WYa(a);do if(e>>>0>=2){g=e+4&-4;if(g>>>0>1073741823)We();else{h=NYa(g<<2)|0;f[a>>2]=h;f[a+8>>2]=g|-2147483648;f[a+4>>2]=e;i=h;break}}else{b[a+8+3>>0]=e;i=a}while(0);COa(i,130096,e)|0;f[d>>2]=0;nQa(i+(e<<2)|0,d);u=c;return}function OWa(a){a=a|0;hQa(a);PYa(a);return}function PWa(a){a=a|0;hQa(a);PYa(a);return}function QWa(a,b,c){a=a|0;b=b|0;c=c|0;var e=0;if(c>>>0<128){a=(zWa()|0)+(c<<1)|0;e=(d[a>>1]&b)<<16>>16!=0}else e=0;return e|0}function RWa(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0;a=b;b=e;while(1){if((a|0)==(c|0))break;if((f[a>>2]|0)>>>0<128){e=zWa()|0;g=j[e+(f[a>>2]<<1)>>1]|0}else g=0;d[b>>1]=g;a=a+4|0;b=b+2|0}return c|0}function SWa(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0;a=c;while(1){if((a|0)==(e|0)){g=e;break}if((f[a>>2]|0)>>>0<128?(c=zWa()|0,(d[c+(f[a>>2]<<1)>>1]&b)<<16>>16):0){g=a;break}a=a+4|0}return g|0}function TWa(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0;a=c;while(1){if((a|0)==(e|0)){g=e;break}if((f[a>>2]|0)>>>0>=128){g=a;break}c=zWa()|0;if(!((d[c+(f[a>>2]<<1)>>1]&b)<<16>>16)){g=a;break}a=a+4|0}return g|0}function UWa(a,b){a=a|0;b=b|0;var c=0;if(b>>>0<128){a=(yWa()|0)+(b<<2)|0;c=f[a>>2]|0}else c=b;return c|0}function VWa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=b;while(1){if((a|0)==(c|0))break;b=f[a>>2]|0;if(b>>>0<128){d=yWa()|0;e=f[d+(f[a>>2]<<2)>>2]|0}else e=b;f[a>>2]=e;a=a+4|0}return c|0}function WWa(a,b){a=a|0;b=b|0;var c=0;if(b>>>0<128){a=(xWa()|0)+(b<<2)|0;c=f[a>>2]|0}else c=b;return c|0}function XWa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=b;while(1){if((a|0)==(c|0))break;b=f[a>>2]|0;if(b>>>0<128){d=xWa()|0;e=f[d+(f[a>>2]<<2)>>2]|0}else e=b;f[a>>2]=e;a=a+4|0}return c|0}function YWa(a,b){a=a|0;b=b|0;return b<<24>>24|0}function ZWa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;a=e;e=c;while(1){if((e|0)==(d|0))break;f[a>>2]=b[e>>0];a=a+4|0;e=e+1|0}return d|0}function _Wa(a,b,c){a=a|0;b=b|0;c=c|0;return (b>>>0<128?b&255:c)|0}function $Wa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=(d-c|0)>>>2;h=g;g=c;while(1){if((g|0)==(d|0))break;i=f[g>>2]|0;b[h>>0]=i>>>0<128?i&255:e;h=h+1|0;g=g+4|0}return c+(a<<2)|0}function aXa(a){a=a|0;hQa(a);PYa(a);return}function bXa(a){a=a|0;hQa(a);PYa(a);return}function cXa(a){a=a|0;hQa(a);PYa(a);return}function dXa(a){a=a|0;f[a>>2]=130380;return}function eXa(a){a=a|0;f[a>>2]=130416;return}function fXa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;f[a+4>>2]=e+-1;f[a>>2]=129972;e=a+8|0;f[e>>2]=c;b[a+12>>0]=d&1;if(!c){c=zWa()|0;f[e>>2]=c}return}function gXa(a){a=a|0;We()}function hXa(a){a=a|0;We()}function iXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;f[a+4>>2]=c+-1;f[a>>2]=129952;c=a+8|0;jXa(c,28);g=a+144|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=YOa(370137)|0;if(h>>>0>4294967279)WYa(g);if(h>>>0<11){b[g+11>>0]=h;i=g}else{j=h+16&-16;k=NYa(j)|0;f[g>>2]=k;f[a+152>>2]=j|-2147483648;f[a+148>>2]=h;i=k}kOa(i,370137,h)|0;b[e>>0]=0;ZOa(i+h|0,e);e=f[c>>2]|0;c=a+12|0;h=f[c>>2]|0;while(1){if((h|0)==(e|0))break;i=h+-4|0;f[c>>2]=i;h=i}kXa();lXa(a,900448);mXa();nXa(a,900456);oXa();pXa(a,900464);qXa();rXa(a,900480);sXa();tXa(a,900488);uXa();vXa(a,900496);wXa();xXa(a,900512);yXa();zXa(a,900520);AXa();BXa(a,900528);CXa();DXa(a,900552);EXa();FXa(a,900584);GXa();HXa(a,900592);IXa();JXa(a,900600);KXa();LXa(a,900608);MXa();NXa(a,900616);OXa();PXa(a,900624);QXa();RXa(a,900632);SXa();TXa(a,900640);UXa();VXa(a,900648);WXa();XXa(a,900656);YXa();ZXa(a,900664);_Xa();$Xa(a,900672);aYa();bYa(a,900680);cYa();dYa(a,900696);eYa();fYa(a,900712);gYa();hYa(a,900728);iYa();jYa(a,900744);kYa();lYa(a,900752);u=d;return}function jXa(a,c){a=a|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+128>>0]=0;if(c|0){yYa(a,c);pYa(a,c)}return}function kXa(){f[225113]=0;f[225112]=127616;return}function lXa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1975160)|0);return}function mXa(){f[225115]=0;f[225114]=127648;return}function nXa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1975168)|0);return}function oXa(){fXa(900464,0,0,1);return}function pXa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1975176)|0);return}function qXa(){f[225121]=0;f[225120]=130168;return}function rXa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1975208)|0);return}function sXa(){f[225123]=0;f[225122]=130236;return}function tXa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1976968)|0);return}function uXa(){xYa(900496,1);return}function vXa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1976976)|0);return}function wXa(){f[225129]=0;f[225128]=130284;return}function xXa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1976984)|0);return}function yXa(){f[225131]=0;f[225130]=130332;return}function zXa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1976992)|0);return}function AXa(){wYa(900528,1);return}function BXa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1975192)|0);return}function CXa(){vYa(900552,1);return}function DXa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1975216)|0);return}function EXa(){f[225147]=0;f[225146]=127680;return}function FXa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1975200)|0);return}function GXa(){f[225149]=0;f[225148]=127744;return}function HXa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1975224)|0);return}function IXa(){f[225151]=0;f[225150]=127808;return}function JXa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1975232)|0);return}function KXa(){f[225153]=0;f[225152]=127860;return}function LXa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1975240)|0);return}function MXa(){f[225155]=0;f[225154]=129408;return}function NXa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1976888)|0);return}function OXa(){f[225157]=0;f[225156]=129464;return}function PXa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1976896)|0);return}function QXa(){f[225159]=0;f[225158]=129520;return}function RXa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1976904)|0);return}function SXa(){f[225161]=0;f[225160]=129576;return}function TXa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1976912)|0);return}function UXa(){f[225163]=0;f[225162]=129632;return}function VXa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1976920)|0);return}function WXa(){f[225165]=0;f[225164]=129660;return}function XXa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1976928)|0);return}function YXa(){f[225167]=0;f[225166]=129688;return}function ZXa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1976936)|0);return}function _Xa(){f[225169]=0;f[225168]=129716;return}function $Xa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1976944)|0);return}function aYa(){f[225171]=0;f[225170]=130148;dXa(900688);f[225170]=127912;f[225172]=127960;return}function bYa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1976052)|0);return}function cYa(){f[225175]=0;f[225174]=130148;eXa(900704);f[225174]=127996;f[225176]=128044;return}function dYa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1976864)|0);return}function eYa(){var a=0;f[225179]=0;f[225178]=130148;a=EQa()|0;f[225180]=a;f[225178]=129360;return}function fYa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1976872)|0);return}function gYa(){var a=0;f[225183]=0;f[225182]=130148;a=EQa()|0;f[225184]=a;f[225182]=129384;return}function hYa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1976880)|0);return}function iYa(){f[225187]=0;f[225186]=129744;return}function jYa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1976952)|0);return}function kYa(){f[225189]=0;f[225188]=129776;return}function lYa(a,b){a=a|0;b=b|0;mYa(a,b,GQa(1976960)|0);return}function mYa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;IYa(b);d=a+8|0;e=f[d>>2]|0;if((f[a+12>>2]|0)-e>>2>>>0>c>>>0){g=e;h=d}else{nYa(d,c+1|0);g=f[d>>2]|0;h=d}d=f[g+(c<<2)>>2]|0;if(d|0)KYa(d)|0;f[(f[h>>2]|0)+(c<<2)>>2]=b;return}function nYa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>2;h=e;e=d;a:do if(g>>>0>=b>>>0){if(g>>>0>b>>>0){d=h+(b<<2)|0;i=e;while(1){if((i|0)==(d|0))break a;j=i+-4|0;f[c>>2]=j;i=j}}}else oYa(a,b-g|0);while(0);return}function oYa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+32|0;d=c;e=a+8|0;g=a+4|0;h=f[g>>2]|0;do if((f[e>>2]|0)-h>>2>>>0<b>>>0){i=(h-(f[a>>2]|0)>>2)+b|0;j=qYa(a)|0;if(j>>>0<i>>>0)gXa(a);else{k=f[a>>2]|0;l=(f[e>>2]|0)-k|0;m=l>>1;rYa(d,l>>2>>>0<j>>>1>>>0?(m>>>0<i>>>0?i:m):j,(f[g>>2]|0)-k>>2,a+16|0);sYa(d,b);tYa(a,d);uYa(d);break}}else pYa(a,b);while(0);u=c;return}function pYa(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;a=f[c>>2]|0;d=b;do{f[a>>2]=0;a=(f[c>>2]|0)+4|0;f[c>>2]=a;d=d+-1|0}while((d|0)!=0);return}function qYa(a){a=a|0;return 1073741823}function rYa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;f[a+12>>2]=0;f[a+16>>2]=e;do if(c){g=e+112|0;if(c>>>0<29&(b[g>>0]|0)==0){b[g>>0]=1;h=e;break}else{h=NYa(c<<2)|0;break}}else h=0;while(0);f[a>>2]=h;e=h+(d<<2)|0;f[a+8>>2]=e;f[a+4>>2]=e;f[a+12>>2]=h+(c<<2);return}function sYa(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+8|0;a=f[c>>2]|0;d=b;do{f[a>>2]=0;a=(f[c>>2]|0)+4|0;f[c>>2]=a;d=d+-1|0}while((d|0)!=0);return}function tYa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[a>>2]|0;d=a+4|0;e=b+4|0;g=(f[d>>2]|0)-c|0;h=(f[e>>2]|0)+(0-(g>>2)<<2)|0;f[e>>2]=h;if((g|0)>0){K1a(h|0,c|0,g|0)|0;i=e;j=f[e>>2]|0}else{i=e;j=h}h=f[a>>2]|0;f[a>>2]=j;f[i>>2]=h;h=b+8|0;j=f[d>>2]|0;f[d>>2]=f[h>>2];f[h>>2]=j;j=a+8|0;a=b+12|0;h=f[j>>2]|0;f[j>>2]=f[a>>2];f[a>>2]=h;f[b>>2]=f[i>>2];return}function uYa(a){a=a|0;var c=0,d=0,e=0,g=0;c=f[a+4>>2]|0;d=a+8|0;e=f[d>>2]|0;while(1){if((e|0)==(c|0))break;g=e+-4|0;f[d>>2]=g;e=g}e=f[a>>2]|0;do if(e|0){d=f[a+16>>2]|0;if((d|0)==(e|0)){b[d+112>>0]=0;break}else{PYa(e);break}}while(0);return}function vYa(a,b){a=a|0;b=b|0;f[a+4>>2]=b+-1;f[a>>2]=130064;f[a+8>>2]=46;f[a+12>>2]=44;b=a+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[b+(a<<2)>>2]=0;a=a+1|0}return}function wYa(a,c){a=a|0;c=c|0;f[a+4>>2]=c+-1;f[a>>2]=130024;b[a+8>>0]=46;b[a+9>>0]=44;c=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[c+(a<<2)>>2]=0;a=a+1|0}return}function xYa(a,b){a=a|0;b=b|0;f[a+4>>2]=b+-1;f[a>>2]=129904;b=EQa()|0;f[a+8>>2]=b;return}function yYa(a,c){a=a|0;c=c|0;var d=0,e=0;if((qYa(a)|0)>>>0<c>>>0)gXa(a);d=a+128|0;if(c>>>0<29&(b[d>>0]|0)==0){b[d>>0]=1;e=a+16|0}else e=NYa(c<<2)|0;f[a+4>>2]=e;f[a>>2]=e;f[a+8>>2]=e+(c<<2);return}function zYa(){if((b[900760]|0)==0?u1a(900760)|0:0){AYa()|0;f[494251]=1977e3}return f[494251]|0}function AYa(){BYa();f[494250]=900768;return 1977e3}function BYa(){iXa(900768,1);return}function CYa(){DYa(1977008,zYa()|0);return 1977008}function DYa(a,b){a=a|0;b=b|0;var c=0;c=f[b>>2]|0;f[a>>2]=c;IYa(c);return}function EYa(){if((b[900928]|0)==0?u1a(900928)|0:0){CYa()|0;f[494253]=1977008}return f[494253]|0}function FYa(a){a=a|0;var b=0,c=0;b=EYa()|0;c=f[b>>2]|0;f[a>>2]=c;IYa(c);return}function GYa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(!c)d=0;else d=yKa(a,b,c)|0;return d|0}function HYa(a){a=a|0;return}function IYa(a){a=a|0;JYa(a+4|0);return}function JYa(a){a=a|0;f[a>>2]=(f[a>>2]|0)+1;return}function KYa(a){a=a|0;var b=0;if((LYa(a+4|0)|0)==-1){ki[f[(f[a>>2]|0)+8>>2]&2047](a);b=1}else b=0;return b|0}function LYa(a){a=a|0;var b=0;b=f[a>>2]|0;f[a>>2]=b+-1;return b+-1|0}function MYa(a,b,c){a=a|0;b=b|0;c=c|0;E1a(1977016)|0;while(1){if((f[a>>2]|0)!=1)break;df(1977044,1977016)|0}if(!(f[a>>2]|0)){f[a>>2]=1;D1a(1977016)|0;ki[c&2047](b);E1a(1977016)|0;f[a>>2]=-1;D1a(1977016)|0;J1a(1977044)|0}else D1a(1977016)|0;return}function NYa(a){a=a|0;var b=0,c=0;b=(a|0)==0?1:a;while(1){a=dKa(b)|0;if(a|0){c=a;break}a=x1a()|0;if(!a){c=0;break}gi[a&3]()}return c|0}function OYa(a){a=a|0;return NYa(a)|0}function PYa(a){a=a|0;eKa(a);return}function QYa(a){a=a|0;PYa(a);return}function RYa(){We()}function SYa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=xKa(b)|0;d=NYa(c+13|0)|0;f[d>>2]=c;f[d+4>>2]=c;f[d+8>>2]=0;e=TYa(d)|0;K1a(e|0,b|0,c+1|0)|0;f[a>>2]=e;return}function TYa(a){a=a|0;return a+12|0}function UYa(a,b){a=a|0;b=b|0;f[a>>2]=130540;SYa(a+4|0,b);return}function VYa(a){a=a|0;return 1}function WYa(a){a=a|0;We()}function XYa(a){a=a|0;We()}function YYa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if((b[c+11>>0]|0)<0){g=f[c>>2]|0;h=f[c+4>>2]|0;if(h>>>0>4294967279)WYa(a);if(h>>>0<11){b[a+11>>0]=h;i=a}else{j=h+16&-16;k=NYa(j)|0;f[a>>2]=k;f[a+8>>2]=j|-2147483648;f[a+4>>2]=h;i=k}kOa(i,g,h)|0;b[e>>0]=0;ZOa(i+h|0,e)}else{f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2]}u=d;return}function ZYa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;g=u;u=u+16|0;h=g;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;i=b[c+11>>0]|0;j=i<<24>>24<0;k=j?f[c+4>>2]|0:i&255;if(k>>>0<d>>>0)XYa(a);i=(j?f[c>>2]|0:c)+d|0;c=k-d|0;d=c>>>0<e>>>0?c:e;if(d>>>0>4294967279)WYa(a);if(d>>>0<11){b[a+11>>0]=d;l=a}else{e=d+16&-16;c=NYa(e)|0;f[a>>2]=c;f[a+8>>2]=e|-2147483648;f[a+4>>2]=d;l=c}kOa(l,i,d)|0;b[h>>0]=0;ZOa(l+d|0,h);u=g;return}function _Ya(a){a=a|0;if((b[a+11>>0]|0)<0)PYa(f[a>>2]|0);return}function $Ya(a,c){a=a|0;c=c|0;var d=0,e=0;if((a|0)!=(c|0)){d=b[c+11>>0]|0;e=d<<24>>24<0;aZa(a,e?f[c>>2]|0:c,e?f[c+4>>2]|0:d&255)|0}return a|0}function aZa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j)k=(f[a+8>>2]&2147483647)+-1|0;else k=10;do if(k>>>0>=d>>>0){if(j)l=f[a>>2]|0;else l=a;bZa(l,c,d)|0;b[g>>0]=0;ZOa(l+d|0,g);if((b[h>>0]|0)<0){f[a+4>>2]=d;break}else{b[h>>0]=d;break}}else{if(j)m=f[a+4>>2]|0;else m=i&255;cZa(a,k,d-k|0,m,0,m,d,c)}while(0);u=e;return a|0}function bZa(a,b,c){a=a|0;b=b|0;c=c|0;if(c|0)M1a(a|0,b|0,c|0)|0;return a|0}function cZa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=u;u=u+16|0;l=k;if((-18-c|0)>>>0<d>>>0)WYa(a);if((b[a+11>>0]|0)<0)m=f[a>>2]|0;else m=a;if(c>>>0<2147483623){n=d+c|0;d=c<<1;o=n>>>0<d>>>0?d:n;p=o>>>0<11?11:o+16&-16}else p=-17;o=NYa(p)|0;if(g|0)kOa(o,m,g)|0;if(i|0)kOa(o+g|0,j,i)|0;j=e-h|0;e=j-g|0;if(e|0)kOa(o+g+i|0,m+g+h|0,e)|0;if((c|0)!=10)PYa(m);f[a>>2]=o;f[a+8>>2]=p|-2147483648;p=j+i|0;f[a+4>>2]=p;b[l>>0]=0;ZOa(o+p|0,l);u=k;return}function dZa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(c>>>0>4294967279)WYa(a);d=a+11|0;e=b[d>>0]|0;g=e<<24>>24<0;if(g){h=f[a+4>>2]|0;i=(f[a+8>>2]&2147483647)+-1|0}else{h=e&255;i=10}j=h>>>0>c>>>0?h:c;c=j>>>0<11;k=c?10:(j+16&-16)+-1|0;do if((k|0)!=(i|0)){do if(c){j=f[a>>2]|0;if(g){l=a;m=0;n=j;o=13}else{kOa(a,j,(e&255)+1|0)|0;PYa(j);o=15}}else{j=NYa(k+1|0)|0;if(g){l=j;m=1;n=f[a>>2]|0;o=13;break}else{kOa(j,a,(e&255)+1|0)|0;p=j;o=14;break}}while(0);if((o|0)==13){kOa(l,n,(f[a+4>>2]|0)+1|0)|0;PYa(n);if(m){p=l;o=14}else o=15}if((o|0)==14){f[a+8>>2]=k+1|-2147483648;f[a+4>>2]=h;f[a>>2]=p;break}else if((o|0)==15){b[d>>0]=h;break}}while(0);return}function eZa(a,b){a=a|0;b=b|0;return aZa(a,b,YOa(b)|0)|0}function fZa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j)k=f[a+4>>2]|0;else k=i&255;do if(k>>>0>=c>>>0)if(j){i=(f[a>>2]|0)+c|0;b[g>>0]=0;ZOa(i,g);f[a+4>>2]=c;break}else{b[g>>0]=0;ZOa(a+c|0,g);b[h>>0]=c;break}else gZa(a,c-k|0,d)|0;while(0);u=e;return}function gZa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;if(c|0){h=a+11|0;i=b[h>>0]|0;if(i<<24>>24<0){j=f[a+4>>2]|0;k=(f[a+8>>2]&2147483647)+-1|0}else{j=i&255;k=10}l=j+c|0;if((k-j|0)>>>0<c>>>0){hZa(a,k,l-k|0,j,j,0,0);m=b[h>>0]|0}else m=i;if(m<<24>>24<0)n=f[a>>2]|0;else n=a;gUa(n+j|0,c,d)|0;if((b[h>>0]|0)<0)f[a+4>>2]=l;else b[h>>0]=l;b[g>>0]=0;ZOa(n+l|0,g)}u=e;return a|0}function hZa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;if((-17-c|0)>>>0<d>>>0)WYa(a);if((b[a+11>>0]|0)<0)j=f[a>>2]|0;else j=a;if(c>>>0<2147483623){k=d+c|0;d=c<<1;l=k>>>0<d>>>0?d:k;m=l>>>0<11?11:l+16&-16}else m=-17;l=NYa(m)|0;if(g|0)kOa(l,j,g)|0;k=e-h-g|0;if(k|0)kOa(l+g+i|0,j+g+h|0,k)|0;if((c|0)!=10)PYa(j);f[a>>2]=l;f[a+8>>2]=m|-2147483648;return}function iZa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=b[a+11>>0]|0;e=d<<24>>24<0;if(e)g=f[a+4>>2]|0;else g=d&255;if(g>>>0<=c>>>0)XYa(a);if(e)h=f[a>>2]|0;else h=a;return h+c|0}function jZa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j){k=f[a+4>>2]|0;l=(f[a+8>>2]&2147483647)+-1|0}else{k=i&255;l=10}i=k+d|0;if((l-k|0)>>>0>=d>>>0){if(d|0){if(j)m=f[a>>2]|0;else m=a;kOa(m+k|0,c,d)|0;if((b[h>>0]|0)<0)f[a+4>>2]=i;else b[h>>0]=i;b[g>>0]=0;ZOa(m+i|0,g)}}else cZa(a,l,i-l|0,k,k,0,d,c);u=e;return a|0}function kZa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;g=d+1|0;b[e>>0]=c;c=a+11|0;h=b[c>>0]|0;i=h<<24>>24<0;if(i){j=(f[a+8>>2]&2147483647)+-1|0;k=f[a+4>>2]|0}else{j=10;k=h&255}if((k|0)==(j|0)){hZa(a,j,1,j,j,0,0);h=j+1|0;if((b[c>>0]|0)<0){l=h;m=8}else{n=h;m=7}}else{h=k+1|0;if(i){l=h;m=8}else{n=h;m=7}}if((m|0)==7){b[c>>0]=n;o=a}else if((m|0)==8){m=f[a>>2]|0;f[a+4>>2]=l;o=m}m=o+k|0;ZOa(m,e);b[g>>0]=0;ZOa(m+1|0,g);u=d;return}function lZa(a,b,c){a=a|0;b=b|0;c=c|0;return b>>>0<=a>>>0&a>>>0<c>>>0|0}function mZa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;if(!c)e=0;else e=BKa(a,jOa(b[d>>0]|0)|0,c)|0;return e|0}function nZa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;h=b[a+11>>0]|0;if(h<<24>>24<0){i=f[a+4>>2]|0;j=f[a>>2]|0}else{i=h&255;j=a}b[g>>0]=c;if(i>>>0>d>>>0){c=mZa(j+d|0,i-d|0,g)|0;k=(c|0)==0?-1:c-j|0}else k=-1;u=e;return k|0}function oZa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=b[a+11>>0]|0;if(e<<24>>24<0){g=f[a+4>>2]|0;h=f[a>>2]|0}else{g=e&255;h=a}a:do if(!g)i=-1;else{a=h+(g>>>0>d>>>0?d+1|0:g)|0;do{if((a|0)==(h|0)){i=-1;break a}a=a+-1|0}while(!(dPa(b[a>>0]|0,c)|0));i=a-h|0}while(0);return i|0}function pZa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=b[a+11>>0]|0;i=h<<24>>24<0;if(i)j=f[a+4>>2]|0;else j=h&255;if((g|0)==-1|j>>>0<c>>>0)XYa(a);h=j-c|0;j=h>>>0<d>>>0?h:d;if(i)k=f[a>>2]|0;else k=a;a=j>>>0>g>>>0;i=GYa(k+c|0,e,a?g:j)|0;if(!i)return (j>>>0<g>>>0?-1:a&1)|0;else return i|0;return 0}function qZa(a){a=a|0;if((b[a+8+3>>0]|0)<0)PYa(f[a>>2]|0);return}function rZa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=a+8|0;i=h+3|0;j=b[i>>0]|0;k=j<<24>>24<0;if(k)l=(f[h>>2]&2147483647)+-1|0;else l=1;do if(l>>>0>=d>>>0){if(k)m=f[a>>2]|0;else m=a;sZa(m,c,d)|0;f[g>>2]=0;nQa(m+(d<<2)|0,g);if((b[i>>0]|0)<0){f[a+4>>2]=d;break}else{b[i>>0]=d;break}}else{if(k)n=f[a+4>>2]|0;else n=j&255;tZa(a,l,d-l|0,n,0,n,d,c)}while(0);u=e;return a|0}function sZa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(!c)d=a;else{$Ka(a,b,c)|0;d=a}return d|0}function tZa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=u;u=u+16|0;l=k;if((1073741806-c|0)>>>0<d>>>0)WYa(a);m=a+8|0;if((b[m+3>>0]|0)<0)n=f[a>>2]|0;else n=a;if(c>>>0<536870887){o=d+c|0;d=c<<1;p=o>>>0<d>>>0?d:o;o=p>>>0<2?2:p+4&-4;if(o>>>0>1073741823)We();else q=o}else q=1073741807;o=NYa(q<<2)|0;if(g|0)COa(o,n,g)|0;if(i|0)COa(o+(g<<2)|0,j,i)|0;j=e-h|0;e=j-g|0;if(e|0)COa(o+(g<<2)+(i<<2)|0,n+(g<<2)+(h<<2)|0,e)|0;if((c|0)!=1)PYa(n);f[a>>2]=o;f[m>>2]=q|-2147483648;q=j+i|0;f[a+4>>2]=q;f[l>>2]=0;nQa(o+(q<<2)|0,l);u=k;return}function uZa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if(c>>>0>1073741807)WYa(a);d=a+8|0;e=d+3|0;g=b[e>>0]|0;h=g<<24>>24<0;if(h){i=f[a+4>>2]|0;j=(f[d>>2]&2147483647)+-1|0}else{i=g&255;j=1}k=i>>>0>c>>>0?i:c;c=k>>>0<2;l=c?1:(k+4&-4)+-1|0;do if((l|0)!=(j|0)){do if(c){k=f[a>>2]|0;if(h){m=a;n=0;o=k;p=15}else{COa(a,k,(g&255)+1|0)|0;PYa(k);p=17}}else{k=l+1|0;if(k>>>0>1073741823)We();q=NYa(k<<2)|0;if(h){m=q;n=1;o=f[a>>2]|0;p=15;break}else{COa(q,a,(g&255)+1|0)|0;r=q;p=16;break}}while(0);if((p|0)==15){COa(m,o,(f[a+4>>2]|0)+1|0)|0;PYa(o);if(n){r=m;p=16}else p=17}if((p|0)==16){f[d>>2]=l+1|-2147483648;f[a+4>>2]=i;f[a>>2]=r;break}else if((p|0)==17){b[e>>0]=i;break}}while(0);return}function vZa(a,b){a=a|0;b=b|0;return rZa(a,b,nTa(b)|0)|0}function wZa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;if((1073741807-c|0)>>>0<d>>>0)WYa(a);j=a+8|0;if((b[j+3>>0]|0)<0)k=f[a>>2]|0;else k=a;if(c>>>0<536870887){l=d+c|0;d=c<<1;m=l>>>0<d>>>0?d:l;l=m>>>0<2?2:m+4&-4;if(l>>>0>1073741823)We();else n=l}else n=1073741807;l=NYa(n<<2)|0;if(g|0)COa(l,k,g)|0;m=e-h-g|0;if(m|0)COa(l+(g<<2)+(i<<2)|0,k+(g<<2)+(h<<2)|0,m)|0;if((c|0)!=1)PYa(k);f[a>>2]=l;f[j>>2]=n|-2147483648;return}function xZa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=a+8|0;i=h+3|0;j=b[i>>0]|0;k=j<<24>>24<0;if(k){l=f[a+4>>2]|0;m=(f[h>>2]&2147483647)+-1|0}else{l=j&255;m=1}j=l+d|0;if((m-l|0)>>>0>=d>>>0){if(d|0){if(k)n=f[a>>2]|0;else n=a;COa(n+(l<<2)|0,c,d)|0;if((b[i>>0]|0)<0)f[a+4>>2]=j;else b[i>>0]=j;f[g>>2]=0;nQa(n+(j<<2)|0,g)}}else tZa(a,m,j-m|0,l,l,0,d,c);u=e;return a|0}function yZa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+16|0;e=d;g=d+4|0;f[e>>2]=c;c=a+8|0;h=c+3|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j){k=(f[c>>2]&2147483647)+-1|0;l=f[a+4>>2]|0}else{k=1;l=i&255}if((l|0)==(k|0)){wZa(a,k,1,k,k,0,0);i=k+1|0;if((b[h>>0]|0)<0){m=i;n=8}else{o=i;n=7}}else{i=l+1|0;if(j){m=i;n=8}else{o=i;n=7}}if((n|0)==7){b[h>>0]=o;p=a}else if((n|0)==8){n=f[a>>2]|0;f[a+4>>2]=m;p=n}n=p+(l<<2)|0;nQa(n,e);f[g>>2]=0;nQa(n+4|0,g);u=d;return}function zZa(){var a=0,b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;a=u;u=u+48|0;b=a+32|0;c=a+24|0;d=a+16|0;e=a;g=a+36|0;a=AZa()|0;if(a|0?(h=f[a>>2]|0,h|0):0){a=h+48|0;i=f[a>>2]|0;j=f[a+4>>2]|0;if(!((i&-256|0)==1126902528&(j|0)==1129074247)){f[c>>2]=f[32612];BZa(372340,c)}if((i|0)==1126902529&(j|0)==1129074247)k=f[h+44>>2]|0;else k=h+80|0;f[g>>2]=k;k=f[h>>2]|0;h=f[k+4>>2]|0;j=ui[f[(f[5360]|0)+16>>2]&127](21440,k,g)|0;k=f[32612]|0;if(j){j=f[g>>2]|0;g=mi[f[(f[j>>2]|0)+8>>2]&255](j)|0;f[e>>2]=k;f[e+4>>2]=h;f[e+8>>2]=g;BZa(372254,e)}else{f[d>>2]=k;f[d+4>>2]=h;BZa(372299,d)}}BZa(372378,b)}function AZa(){var a=0,b=0;a=u;u=u+16|0;if(!(de(1977092,3)|0)){b=cf(f[494274]|0)|0;u=a;return b|0}else BZa(372529,a);return 0}function BZa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d>>2]=b;b=f[30809]|0;rLa(b,a,d)|0;EMa(10,b)|0;We()}function CZa(a){a=a|0;return}function DZa(a){a=a|0;CZa(a);PYa(a);return}function EZa(a){a=a|0;return}function FZa(a){a=a|0;return}function GZa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+64|0;e=d;if(!(KZa(a,b,0)|0))if((b|0)!=0?(g=OZa(b,21464,21448,0)|0,(g|0)!=0):0){b=e+4|0;h=b+52|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[e>>2]=g;f[e+8>>2]=a;f[e+12>>2]=-1;f[e+48>>2]=1;Ah[f[(f[g>>2]|0)+28>>2]&255](g,e,f[c>>2]|0,1);if((f[e+24>>2]|0)==1){f[c>>2]=f[e+16>>2];i=1}else i=0;j=i}else j=0;else j=1;u=d;return j|0}function HZa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;if(KZa(a,f[b+8>>2]|0,g)|0)NZa(0,b,c,d,e);return}function IZa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;do if(!(KZa(a,f[c+8>>2]|0,g)|0)){if(KZa(a,f[c>>2]|0,g)|0){h=c+32|0;if((f[c+16>>2]|0)!=(d|0)?(i=c+20|0,(f[i>>2]|0)!=(d|0)):0){f[h>>2]=e;f[i>>2]=d;i=c+40|0;f[i>>2]=(f[i>>2]|0)+1;if((f[c+36>>2]|0)==1?(f[c+24>>2]|0)==2:0)b[c+54>>0]=1;f[c+44>>2]=4;break}if((e|0)==1)f[h>>2]=1}}else MZa(0,c,d,e);while(0);return}function JZa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if(KZa(a,f[b+8>>2]|0,0)|0)LZa(0,b,c,d);return}function KZa(a,b,c){a=a|0;b=b|0;c=c|0;return (a|0)==(b|0)|0}function LZa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;a=c+16|0;g=f[a>>2]|0;h=c+36|0;i=c+24|0;do if(g){if((g|0)!=(d|0)){f[h>>2]=(f[h>>2]|0)+1;f[i>>2]=2;b[c+54>>0]=1;break}if((f[i>>2]|0)==2)f[i>>2]=e}else{f[a>>2]=d;f[i>>2]=e;f[h>>2]=1}while(0);return}function MZa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if((f[b+4>>2]|0)==(c|0)?(c=b+28|0,(f[c>>2]|0)!=1):0)f[c>>2]=d;return}function NZa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;b[c+53>>0]=1;do if((f[c+4>>2]|0)==(e|0)){b[c+52>>0]=1;a=c+16|0;h=f[a>>2]|0;i=c+54|0;j=c+48|0;k=c+24|0;l=c+36|0;if(!h){f[a>>2]=d;f[k>>2]=g;f[l>>2]=1;if(!((f[j>>2]|0)==1&(g|0)==1))break;b[i>>0]=1;break}if((h|0)!=(d|0)){f[l>>2]=(f[l>>2]|0)+1;b[i>>0]=1;break}l=f[k>>2]|0;if((l|0)==2){f[k>>2]=g;m=g}else m=l;if((f[j>>2]|0)==1&(m|0)==1)b[i>>0]=1}while(0);return}function OZa(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+64|0;i=h;j=f[a>>2]|0;k=a+(f[j+-8>>2]|0)|0;l=f[j+-4>>2]|0;f[i>>2]=e;f[i+4>>2]=a;f[i+8>>2]=c;f[i+12>>2]=g;g=i+16|0;c=i+20|0;a=i+24|0;j=i+28|0;m=i+32|0;n=i+40|0;o=g;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));d[g+36>>1]=0;b[g+38>>0]=0;a:do if(KZa(l,e,0)|0){f[i+48>>2]=1;bh[f[(f[l>>2]|0)+20>>2]&255](l,i,k,k,1,0);q=(f[a>>2]|0)==1?k:0}else{Bh[f[(f[l>>2]|0)+24>>2]&255](l,i,k,1,0);switch(f[i+36>>2]|0){case 0:{q=(f[n>>2]|0)==1&(f[j>>2]|0)==1&(f[m>>2]|0)==1?f[c>>2]|0:0;break a;break}case 1:break;default:{q=0;break a}}if((f[a>>2]|0)!=1?!((f[n>>2]|0)==0&(f[j>>2]|0)==1&(f[m>>2]|0)==1):0){q=0;break}q=f[g>>2]|0}while(0);u=h;return q|0}function PZa(a){a=a|0;CZa(a);PYa(a);return}function QZa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0;if(KZa(a,f[b+8>>2]|0,g)|0)NZa(0,b,c,d,e);else{h=f[a+8>>2]|0;bh[f[(f[h>>2]|0)+20>>2]&255](h,b,c,d,e,g)}return}function RZa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;do if(!(KZa(a,f[c+8>>2]|0,g)|0)){h=a+8|0;if(!(KZa(a,f[c>>2]|0,g)|0)){i=f[h>>2]|0;Bh[f[(f[i>>2]|0)+24>>2]&255](i,c,d,e,g);break}i=c+32|0;if((f[c+16>>2]|0)!=(d|0)?(j=c+20|0,(f[j>>2]|0)!=(d|0)):0){f[i>>2]=e;k=c+44|0;if((f[k>>2]|0)==4)break;l=c+52|0;b[l>>0]=0;m=c+53|0;b[m>>0]=0;n=f[h>>2]|0;bh[f[(f[n>>2]|0)+20>>2]&255](n,c,d,d,1,g);if(b[m>>0]|0)if(!(b[l>>0]|0)){o=3;p=11}else q=3;else{o=4;p=11}if((p|0)==11){f[j>>2]=d;j=c+40|0;f[j>>2]=(f[j>>2]|0)+1;if((f[c+36>>2]|0)==1?(f[c+24>>2]|0)==2:0){b[c+54>>0]=1;q=o}else q=o}f[k>>2]=q;break}if((e|0)==1)f[i>>2]=1}else MZa(0,c,d,e);while(0);return}function SZa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;if(KZa(a,f[b+8>>2]|0,0)|0)LZa(0,b,c,d);else{e=f[a+8>>2]|0;Ah[f[(f[e>>2]|0)+28>>2]&255](e,b,c,d)}return}function TZa(a){a=a|0;return}function UZa(){var a=0;a=u;u=u+16|0;if(!(Qe(1977096,1028)|0)){u=a;return}else BZa(372578,a)}function VZa(a){a=a|0;var b=0;b=u;u=u+16|0;eKa(a);if(!(Lf(f[494274]|0,0)|0)){u=b;return}else BZa(372628,b)}function WZa(){var a=0,b=0;a=AZa()|0;if((a|0?(b=f[a>>2]|0,b|0):0)?(a=b+48|0,(f[a>>2]&-256|0)==1126902528?(f[a+4>>2]|0)==1129074247:0):0)XZa(f[b+12>>2]|0);XZa(YZa()|0)}function XZa(a){a=a|0;var b=0;b=u;u=u+16|0;gi[a&3]();BZa(372681,b)}function YZa(){var a=0;a=f[32611]|0;f[32611]=a+0;return a|0}function ZZa(a){a=a|0;return}function _Za(a){a=a|0;f[a>>2]=130540;c_a(a+4|0);return}function $Za(a){a=a|0;_Za(a);PYa(a);return}function a_a(a){a=a|0;return b_a(a+4|0)|0}function b_a(a){a=a|0;return f[a>>2]|0}function c_a(a){a=a|0;var b=0,c=0;if(VYa(a)|0?(b=d_a(f[a>>2]|0)|0,a=b+8|0,c=f[a>>2]|0,f[a>>2]=c+-1,(c+-1|0)<0):0)PYa(b);return}function d_a(a){a=a|0;return a+-12|0}function e_a(a){a=a|0;_Za(a);PYa(a);return}function f_a(a){a=a|0;CZa(a);PYa(a);return}function g_a(a,b,c){a=a|0;b=b|0;c=c|0;return KZa(a,b,0)|0}function h_a(a){a=a|0;CZa(a);PYa(a);return}function i_a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+64|0;e=d;f[c>>2]=f[f[c>>2]>>2];if(!(j_a(a,b,0)|0))if(((b|0)!=0?(g=OZa(b,21464,21552,0)|0,(g|0)!=0):0)?(f[g+8>>2]&~f[a+8>>2]|0)==0:0){b=a+12|0;a=g+12|0;if(!(KZa(f[b>>2]|0,f[a>>2]|0,0)|0)?!(KZa(f[b>>2]|0,21584,0)|0):0){g=f[b>>2]|0;if((((g|0)!=0?(b=OZa(g,21464,21448,0)|0,(b|0)!=0):0)?(g=f[a>>2]|0,(g|0)!=0):0)?(a=OZa(g,21464,21448,0)|0,(a|0)!=0):0){g=e+4|0;h=g+52|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=a;f[e+8>>2]=b;f[e+12>>2]=-1;f[e+48>>2]=1;Ah[f[(f[a>>2]|0)+28>>2]&255](a,e,f[c>>2]|0,1);if((f[e+24>>2]|0)==1){f[c>>2]=f[e+16>>2];i=1}else i=0;j=i}else j=0}else j=1}else j=0;else j=1;u=d;return j|0}function j_a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(KZa(a,b,0)|0)d=1;else d=KZa(b,21592,0)|0;return d|0}function k_a(a){a=a|0;CZa(a);PYa(a);return}function l_a(a,b,c){a=a|0;b=b|0;c=c|0;return KZa(a,b,0)|0}function m_a(a){a=a|0;CZa(a);PYa(a);return}function n_a(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if(KZa(a,f[c+8>>2]|0,h)|0)NZa(0,c,d,e,g);else{i=c+52|0;j=b[i>>0]|0;k=c+53|0;l=b[k>>0]|0;m=f[a+12>>2]|0;n=a+16+(m<<3)|0;b[i>>0]=0;b[k>>0]=0;r_a(a+16|0,c,d,e,g,h);a:do if((m|0)>1){o=c+24|0;p=c+54|0;q=a+8|0;r=a+24|0;do{if(b[p>>0]|0)break a;if(!(b[i>>0]|0)){if(b[k>>0]|0?(f[q>>2]&1|0)==0:0)break a}else{if((f[o>>2]|0)==1)break a;if(!(f[q>>2]&2))break a}b[i>>0]=0;b[k>>0]=0;r_a(r,c,d,e,g,h);r=r+8|0}while(r>>>0<n>>>0)}while(0);b[i>>0]=j;b[k>>0]=l}return}function o_a(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;a:do if(!(KZa(a,f[c+8>>2]|0,g)|0)){h=a+12|0;i=c+24|0;j=c+36|0;k=c+54|0;l=a+8|0;m=a+16|0;if(!(KZa(a,f[c>>2]|0,g)|0)){n=f[h>>2]|0;o=a+16+(n<<3)|0;s_a(m,c,d,e,g);p=a+24|0;if((n|0)<=1)break;n=f[l>>2]|0;if((n&2|0)==0?(f[j>>2]|0)!=1:0){if(!(n&1)){n=p;while(1){if(b[k>>0]|0)break a;if((f[j>>2]|0)==1)break a;s_a(n,c,d,e,g);n=n+8|0;if(n>>>0>=o>>>0)break a}}else q=p;while(1){if(b[k>>0]|0)break a;if((f[j>>2]|0)==1?(f[i>>2]|0)==1:0)break a;s_a(q,c,d,e,g);q=q+8|0;if(q>>>0>=o>>>0)break a}}else r=p;while(1){if(b[k>>0]|0)break a;s_a(r,c,d,e,g);r=r+8|0;if(r>>>0>=o>>>0)break a}}o=c+32|0;if((f[c+16>>2]|0)!=(d|0)?(p=c+20|0,(f[p>>2]|0)!=(d|0)):0){f[o>>2]=e;n=c+44|0;if((f[n>>2]|0)==4)break;s=a+16+(f[h>>2]<<3)|0;t=c+52|0;u=c+53|0;v=0;w=0;x=m;b:while(1){if(x>>>0>=s>>>0){y=w;z=18;break}b[t>>0]=0;b[u>>0]=0;r_a(x,c,d,d,1,g);if(b[k>>0]|0){y=w;z=18;break}do if(b[u>>0]|0){if(!(b[t>>0]|0))if(!(f[l>>2]&1)){y=1;z=18;break b}else{A=v;B=1;break}if((f[i>>2]|0)==1){z=23;break b}if(!(f[l>>2]&2)){z=23;break b}else{A=1;B=1}}else{A=v;B=w}while(0);v=A;w=B;x=x+8|0}do if((z|0)==18){if((!v?(f[p>>2]=d,x=c+40|0,f[x>>2]=(f[x>>2]|0)+1,(f[j>>2]|0)==1):0)?(f[i>>2]|0)==2:0){b[k>>0]=1;if(y){z=23;break}else{C=4;break}}if(y)z=23;else C=4}while(0);if((z|0)==23)C=3;f[n>>2]=C;break}if((e|0)==1)f[o>>2]=1}else MZa(0,c,d,e);while(0);return}function p_a(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;a:do if(!(KZa(a,f[c+8>>2]|0,0)|0)){g=f[a+12>>2]|0;h=a+16+(g<<3)|0;q_a(a+16|0,c,d,e);if((g|0)>1){g=c+54|0;i=a+24|0;do{q_a(i,c,d,e);if(b[g>>0]|0)break a;i=i+8|0}while(i>>>0<h>>>0)}}else LZa(0,c,d,e);while(0);return}function q_a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a+4>>2]|0;g=e>>8;if(!(e&1))h=g;else h=f[(f[c>>2]|0)+g>>2]|0;g=f[a>>2]|0;Ah[f[(f[g>>2]|0)+28>>2]&255](g,b,c+h|0,e&2|0?d:2);return}function r_a(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=f[a+4>>2]|0;i=h>>8;if(!(h&1))j=i;else j=f[(f[d>>2]|0)+i>>2]|0;i=f[a>>2]|0;bh[f[(f[i>>2]|0)+20>>2]&255](i,b,c,d+j|0,h&2|0?e:2,g);return}function s_a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a+4>>2]|0;h=g>>8;if(!(g&1))i=h;else i=f[(f[c>>2]|0)+h>>2]|0;h=f[a>>2]|0;Bh[f[(f[h>>2]|0)+24>>2]&255](h,b,c+i|0,g&2|0?d:2,e);return}function t_a(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=u;u=u+4192|0;h=g+4176|0;i=g;j=g+4112|0;k=(e|0)!=0;if((a|0)!=0?(l=(c|0)!=0,m=(d|0)==0,!(l&m)):0){if(l)n=f[d>>2]|0;else n=0;u_a(i);v_a(j,i);l=j+48|0;o=j+61|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;b[l+12>>0]=0;b[o>>0]=1;l=j+32|0;p=j+36|0;q=f[p>>2]|0;if(q>>>0<(f[j+40>>2]|0)>>>0){w_a(h,i);f[q>>2]=0;f[q+4>>2]=0;r=f[h>>2]|0;f[q+8>>2]=0;f[q+12>>2]=r;f[p>>2]=(f[p>>2]|0)+16}else x_a(l,i);r=j+62|0;b[r>>0]=0;b[j+63>>0]=1;f[h>>2]=0;q=a+(xKa(a)|0)|0;y_a(a,q,j,h);s=f[h>>2]|0;do if(!((s|0)!=0|(b[r>>0]|0)==0)){t=f[l>>2]|0;if((t|0)!=(f[p>>2]|0)?(f[t>>2]|0)!=(f[t+4>>2]|0):0){b[r>>0]=0;b[o>>0]=0;t=f[j>>2]|0;v=j+4|0;while(1){w=f[v>>2]|0;if((w|0)==(t|0))break;x=w+-24|0;f[v>>2]=x;z_a(x)}v=f[j+16>>2]|0;t=j+20|0;while(1){x=f[t>>2]|0;if((x|0)==(v|0))break;w=x+-16|0;f[t>>2]=w;A_a(w)}y_a(a,q,j,h);if(!(b[r>>0]|0)){y=f[h>>2]|0;z=22;break}else{f[h>>2]=-2;A=-2;B=0;break}}else z=23}else{y=s;z=22}while(0);if((z|0)==22)if(!y)z=23;else{A=y;B=0}do if((z|0)==23){y=j+4|0;s=B_a((f[y>>2]|0)+-24|0)|0;r=s+1|0;if(r>>>0>n>>>0){q=fKa(c,r)|0;if(!q){f[h>>2]=-1;A=-1;B=0;break}if(m)C=q;else{f[d>>2]=r;C=q}}else if(!c){A=0;B=0;break}else C=c;q=f[y>>2]|0;r=q+-12|0;a=b[r+11>>0]|0;o=a<<24>>24<0;C_a(q+-24|0,o?f[r>>2]|0:r,o?f[q+-8>>2]|0:a&255)|0;a=(f[y>>2]|0)+-24|0;if((b[a+11>>0]|0)<0)D=f[a>>2]|0;else D=a;K1a(C|0,D|0,s|0)|0;b[C+s>>0]=0;A=0;B=C}while(0);if(k)f[e>>2]=A;D_a(j);E_a(i);E=B}else if(k){f[e>>2]=-3;E=0}else E=0;u=g;return E|0}function u_a(a){a=a|0;f[a+4096>>2]=a;return}function v_a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;q1a(d,b);f[a>>2]=0;f[a+4>>2]=0;e=f[d>>2]|0;f[a+8>>2]=0;f[a+12>>2]=e;w_a(d,b);r1a(a+16|0,d);s1a(d,b);t1a(a+32|0,d);u=c;return}function w_a(a,b){a=a|0;b=b|0;f[a>>2]=b;return}function x_a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+32|0;d=c+20|0;e=c;g=a+4|0;h=((f[g>>2]|0)-(f[a>>2]|0)>>4)+1|0;i=S0a(a)|0;if(i>>>0<h>>>0)gXa(a);else{j=f[a>>2]|0;k=(f[a+8>>2]|0)-j|0;l=k>>3;T0a(e,k>>4>>>0<i>>>1>>>0?(l>>>0<h>>>0?h:l):i,(f[g>>2]|0)-j>>4,a+12|0);j=e+8|0;g=f[j>>2]|0;w_a(d,b);f[g>>2]=0;f[g+4>>2]=0;b=f[d>>2]|0;f[g+8>>2]=0;f[g+12>>2]=b;f[j>>2]=g+16;U0a(a,e);V0a(e);u=c;return}}function y_a(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;a:do if(a>>>0<c>>>0){b:do if((b[a>>0]|0)!=95){if((U_a(a,c,d)|0)!=(c|0)){f[e>>2]=-2;break a}}else{if((c-a|0)<=3){f[e>>2]=-2;break a}g=a+2|0;switch(b[a+1>>0]|0){case 90:{h=R_a(g,c,d)|0;if(!((h|0)==(g|0)|(h|0)==(c|0))?(b[h>>0]|0)==46:0)i=S_a(h,c,d)|0;else i=h;if((i|0)==(c|0))break b;f[e>>2]=-2;break a;break}case 95:{if((b[g>>0]|0)==95?(b[a+3>>0]|0)==90:0){g=a+4|0;h=R_a(g,c,d)|0;if(!((h|0)==(g|0)|(h|0)==(c|0))?(T_a(h,c,d)|0)==(c|0):0)break b;f[e>>2]=-2;break a}break}default:{}}f[e>>2]=-2;break a}while(0);if((f[e>>2]|0)==0?(f[d>>2]|0)==(f[d+4>>2]|0):0)f[e>>2]=-2}else f[e>>2]=-2;while(0);return}function z_a(a){a=a|0;Q_a(a+12|0);Q_a(a);return}function A_a(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a>>2]|0;if(b|0){c=a+4|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-24|0;f[c>>2]=e;z_a(e)}c=f[a>>2]|0;P_a(a+12|0,c,((f[a+8>>2]|0)-c|0)/24|0)}return}function B_a(a){a=a|0;var c=0,d=0,e=0;c=b[a+11>>0]|0;if(c<<24>>24<0)d=f[a+4>>2]|0;else d=c&255;c=b[a+12+11>>0]|0;if(c<<24>>24<0)e=f[a+16>>2]|0;else e=c&255;return e+d|0}function C_a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j){k=f[a+4>>2]|0;l=(f[a+8>>2]&2147483647)+-1|0}else{k=i&255;l=10}i=k+d|0;if((l-k|0)>>>0>=d>>>0){if(d|0){if(j)m=f[a>>2]|0;else m=a;kOa(m+k|0,c,d)|0;if((b[h>>0]|0)<0)f[a+4>>2]=i;else b[h>>0]=i;b[g>>0]=0;ZOa(m+i|0,g)}}else M_a(a,l,i-l|0,k,k,0,d,c);u=e;return a|0}function D_a(a){a=a|0;F_a(a+32|0);G_a(a+16|0);A_a(a);return}function E_a(a){a=a|0;f[a+4096>>2]=0;return}function F_a(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a>>2]|0;if(b|0){c=a+4|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-16|0;f[c>>2]=e;G_a(e)}c=f[a>>2]|0;L_a(a+12|0,c,(f[a+8>>2]|0)-c>>4)}return}function G_a(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a>>2]|0;if(b|0){c=a+4|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-16|0;f[c>>2]=e;A_a(e)}c=f[a>>2]|0;H_a(a+12|0,c,(f[a+8>>2]|0)-c>>4)}return}function H_a(a,b,c){a=a|0;b=b|0;c=c|0;I_a(f[a>>2]|0,b,c<<4);return}function I_a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(J_a(a,b)|0){d=b+(K_a(c)|0)|0;c=a+4096|0;if((d|0)==(f[c>>2]|0))f[c>>2]=b}else eKa(b);return}function J_a(a,b){a=a|0;b=b|0;return a>>>0<=b>>>0&(a+4096|0)>>>0>=b>>>0|0}function K_a(a){a=a|0;return a+15&-16|0}function L_a(a,b,c){a=a|0;b=b|0;c=c|0;I_a(f[a>>2]|0,b,c<<4);return}function M_a(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=u;u=u+16|0;l=k;if((-18-c|0)>>>0<d>>>0)WYa(a);if((b[a+11>>0]|0)<0)m=f[a>>2]|0;else m=a;if(c>>>0<2147483623){n=d+c|0;d=c<<1;o=n>>>0<d>>>0?d:n;p=o>>>0<11?11:o+16&-16}else p=-17;o=N_a(p)|0;if(g|0)kOa(o,m,g)|0;if(i|0)kOa(o+g|0,j,i)|0;j=e-h|0;e=j-g|0;if(e|0)kOa(o+g+i|0,m+g+h|0,e)|0;if((c|0)!=10)O_a(m);f[a>>2]=o;f[a+8>>2]=p|-2147483648;p=j+i|0;f[a+4>>2]=p;b[l>>0]=0;ZOa(o+p|0,l);u=k;return}function N_a(a){a=a|0;return dKa(a)|0}function O_a(a){a=a|0;eKa(a);return}function P_a(a,b,c){a=a|0;b=b|0;c=c|0;I_a(f[a>>2]|0,b,c*24|0);return}function Q_a(a){a=a|0;if((b[a+11>>0]|0)<0)O_a(f[a>>2]|0);return}function R_a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;e=u;u=u+64|0;g=e+48|0;h=e+40|0;i=e+32|0;j=e+24|0;k=e+12|0;l=e;if((a|0)!=(c|0)){m=d+56|0;k1a(h,m);f[m>>2]=(f[m>>2]|0)+1;n=d+61|0;l1a(i,n);if((f[m>>2]|0)>>>0>1)b[n>>0]=1;a:do switch(b[a>>0]|0){case 84:case 71:{o=1;p=m1a(a,c,d)|0;break}default:{m=r$a(a,c,d)|0;q=f[d+48>>2]|0;r=f[d+52>>2]|0;b:do if((m|0)!=(a|0))if((m|0)!=(c|0)){switch(b[m>>0]|0){case 46:case 69:{s=m;break b;break}default:{}}l1a(j,n);b[n>>0]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;t=0;while(1){if((t|0)==3)break;f[k+(t<<2)>>2]=0;t=t+1|0}t=d+4|0;v=f[t>>2]|0;c:do if((f[d>>2]|0)!=(v|0)){w=v+-24|0;x=b[w+11>>0]|0;y=x<<24>>24<0;if(y)z=f[v+-20>>2]|0;else z=x&255;if(z){if(!(b[d+60>>0]|0)){if(y){A=f[w>>2]|0;B=f[v+-20>>2]|0}else{A=w;B=x&255}if((b[A+B+-1>>0]|0)==62){if(y){C=f[w>>2]|0;D=f[v+-20>>2]|0}else{C=w;D=x&255}if((b[C+(D+-2)>>0]|0)!=45){if(y){E=f[w>>2]|0;F=f[v+-20>>2]|0}else{E=w;F=x&255}if((b[E+(F+-2)>>0]|0)!=62){x=U_a(m,c,d)|0;if((x|0)==(m|0)){G=0;H=a;break}w=f[t>>2]|0;y=w;if(((w-(f[d>>2]|0)|0)/24|0)>>>0<2){G=0;H=a;break}w=y+-24|0;f[l>>2]=f[w>>2];f[l+4>>2]=f[w+4>>2];f[l+8>>2]=f[w+8>>2];I=0;while(1){if((I|0)==3)break;f[w+(I<<2)>>2]=0;I=I+1|0}I=y+-12|0;w=k+11|0;if((b[w>>0]|0)<0){J=f[k>>2]|0;b[g>>0]=0;ZOa(J,g);f[k+4>>2]=0}else{b[g>>0]=0;ZOa(k,g);b[w>>0]=0}x$a(k);f[k>>2]=f[I>>2];f[k+4>>2]=f[I+4>>2];f[k+8>>2]=f[I+8>>2];J=0;while(1){if((J|0)==3)break;f[I+(J<<2)>>2]=0;J=J+1|0}J=b[w>>0]|0;if(!((J<<24>>24<0?f[k+4>>2]|0:J&255)|0))p0a(l,32);J=f[t>>2]|0;I=J+-24|0;y=J;while(1){if((y|0)==(I|0))break;K=y+-24|0;f[t>>2]=K;z_a(K);y=f[t>>2]|0}y=b[l+11>>0]|0;I=y<<24>>24<0;Z0a(J+-48|0,0,I?f[l>>2]|0:l,I?f[l+4>>2]|0:y&255)|0;Q_a(l);L=f[t>>2]|0;M=x}else{L=v;M=m}}else{L=v;M=m}}else{L=v;M=m}}else{L=v;M=m}p0a(L+-24|0,40);if((M|0)!=(c|0)?(b[M>>0]|0)==118:0){N=f[d>>2]|0;O=f[t>>2]|0;P=M+1|0}else Q=49;do if((Q|0)==49){y=g+11|0;I=g+4|0;w=l+11|0;K=l+4|0;R=1;S=M;d:while(1){T=f[d>>2]|0;U=f[t>>2]|0;V=S;while(1){W=(U-T|0)/24|0;X=U_a(V,c,d)|0;U=f[t>>2]|0;T=f[d>>2]|0;Y=(U-T|0)/24|0;if((X|0)==(V|0)){Q=72;break d}if(Y>>>0>W>>>0)break;else V=X}f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Z=0;while(1){if((Z|0)==3){_=W;break}f[g+(Z<<2)>>2]=0;Z=Z+1|0}while(1){if(_>>>0>=Y>>>0){$=W;break}Z=b[y>>0]|0;if((Z<<24>>24<0?f[I>>2]|0:Z&255)|0)Y_a(g,373235)|0;k$a(l,(f[d>>2]|0)+(_*24|0)|0);Z=b[w>>0]|0;aa=Z<<24>>24<0;C_a(g,aa?f[l>>2]|0:l,aa?f[K>>2]|0:Z&255)|0;Q_a(l);_=_+1|0}while(1){if($>>>0>=Y>>>0)break;Z=f[t>>2]|0;aa=Z+-24|0;ba=Z;while(1){if((ba|0)==(aa|0))break;Z=ba+-24|0;f[t>>2]=Z;z_a(Z);ba=f[t>>2]|0}$=$+1|0}ba=b[y>>0]|0;aa=f[I>>2]|0;if(!((ba<<24>>24<0?aa:ba&255)|0))ca=R;else{Z=f[t>>2]|0;if((f[d>>2]|0)==(Z|0)){Q=84;break}if(R){da=Z;ea=ba;fa=aa}else{Y_a(Z+-24|0,373235)|0;da=f[t>>2]|0;ea=b[y>>0]|0;fa=f[I>>2]|0}Z=ea<<24>>24<0;C_a(da+-24|0,Z?f[g>>2]|0:g,Z?fa:ea&255)|0;ca=0}Q_a(g);R=ca;S=X}if((Q|0)==72){N=T;O=U;P=V;break}else if((Q|0)==84){Q_a(g);G=0;H=a;break c}}while(0);if((N|0)!=(O|0)){p0a(O+-24|0,41);if(q&1|0)Y_a((f[t>>2]|0)+-24|0,372958)|0;if(q&2|0)Y_a((f[t>>2]|0)+-24|0,372965)|0;if(q&4|0)Y_a((f[t>>2]|0)+-24|0,372975)|0;switch(r|0){case 1:{Y_a((f[t>>2]|0)+-24|0,374439)|0;break}case 2:{Y_a((f[t>>2]|0)+-24|0,374442)|0;break}default:{}}x=b[k+11>>0]|0;J=x<<24>>24<0;C_a((f[t>>2]|0)+-24|0,J?f[k>>2]|0:k,J?f[k+4>>2]|0:x&255)|0;G=1;H=P}else{G=0;H=a}}else{G=0;H=a}}else{G=0;H=a}while(0);Q_a(k);n1a(j);if(G)s=H;else{o=0;p=H;break a}}else s=c;else s=a;while(0);o=1;p=s}}while(0);n1a(i);o1a(h);if(o){ga=p;Q=88}else ha=a}else{ga=a;Q=88}if((Q|0)==88)ha=ga;u=e;return ha|0}function S_a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;if(((a|0)!=(c|0)?(b[a>>0]|0)==46:0)?(k=d+4|0,(f[d>>2]|0)!=(f[k>>2]|0)):0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;d=c-a|0;if(d>>>0>4294967279)WYa(j);if(d>>>0<11){b[j+11>>0]=d;l=j}else{m=d+16&-16;n=N_a(m)|0;f[j>>2]=n;f[j+8>>2]=m|-2147483648;f[j+4>>2]=d;l=n}n=a;m=l;while(1){if((n|0)==(c|0))break;ZOa(m,n);n=n+1|0;m=m+1|0}b[g>>0]=0;ZOa(l+d|0,g);X_a(j,0,373008)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];g=0;while(1){if((g|0)==3)break;f[j+(g<<2)>>2]=0;g=g+1|0}Y_a(i,373011)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];g=0;while(1){if((g|0)==3)break;f[i+(g<<2)>>2]=0;g=g+1|0}g=b[h+11>>0]|0;d=g<<24>>24<0;C_a((f[k>>2]|0)+-24|0,d?f[h>>2]|0:h,d?f[h+4>>2]|0:g&255)|0;Q_a(h);Q_a(i);Q_a(j);o=c}else o=a;u=e;return o|0}function T_a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;a:do if((c-a|0)>12){e=0;g=a;while(1){h=g+1|0;if((e|0)>=13)break;if((b[g>>0]|0)==(b[374644+e>>0]|0)){e=e+1|0;g=h}else{i=a;break a}}b:do if((g|0)==(c|0))j=c;else{if((b[g>>0]|0)==95){if((h|0)==(c|0)){i=a;break a}if(((b[h>>0]|0)+-48|0)>>>0>=10){i=a;break a}k=g+2|0}else k=g;while(1){if((k|0)==(c|0)){j=c;break b}if(((b[k>>0]|0)+-48|0)>>>0>=10){j=k;break b}k=k+1|0}}while(0);g=f[d+4>>2]|0;if((f[d>>2]|0)!=(g|0)){X_a(g+-24|0,0,374658)|0;i=j}else i=a}else i=a;while(0);return i|0}function U_a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=u;u=u+144|0;g=e+128|0;h=e+104|0;i=e+40|0;j=e+88|0;k=e+24|0;l=e+76|0;m=e+12|0;n=e;o=e+64|0;a:do if((a|0)!=(c|0)){p=d+16|0;switch(b[a>>0]|0){case 75:case 86:case 114:{f[g>>2]=0;q=V_a(a,c,g)|0;b:do if((q|0)!=(a|0)?(r=(b[q>>0]|0)==70,s=d+4|0,t=((f[s>>2]|0)-(f[d>>2]|0)|0)/24|0,v=U_a(q,c,d)|0,w=((f[s>>2]|0)-(f[d>>2]|0)|0)/24|0,(v|0)!=(q|0)):0){s=d+20|0;x=f[s>>2]|0;c:do if(r){y=x+-16|0;z=x;while(1){if((z|0)==(y|0)){A=y;break c}B=z+-16|0;f[s>>2]=B;A_a(B);z=f[s>>2]|0}}else A=x;while(0);f[h>>2]=f[d+12>>2];if(A>>>0<(f[d+24>>2]|0)>>>0){f[A>>2]=0;f[A+4>>2]=0;x=f[h>>2]|0;f[A+8>>2]=0;f[A+12>>2]=x;f[s>>2]=(f[s>>2]|0)+16}else W_a(p,h);x=f[g>>2]|0;z=(x&1|0)==0;y=(x&2|0)==0;B=(x&4|0)==0;x=t;while(1){if(x>>>0>=w>>>0){C=v;break b}if(r){D=f[d>>2]|0;E=D+(x*24|0)+12|0;F=b[E+11>>0]|0;G=F<<24>>24<0;if(G){H=f[E>>2]|0;I=f[D+(x*24|0)+16>>2]|0}else{H=E;I=F&255}J=I+-2|0;if((b[H+J>>0]|0)==38)K=I+-3|0;else{if(G){L=f[D+(x*24|0)+16>>2]|0;M=f[E>>2]|0}else{L=F&255;M=E}K=(b[M+L+-1>>0]|0)==38?J:I}if(z)N=K;else{X_a(E,K,372958)|0;N=K+6|0}if(y)O=N;else{X_a((f[d>>2]|0)+(x*24|0)+12|0,N,372965)|0;O=N+9|0}if(!B)X_a((f[d>>2]|0)+(x*24|0)+12|0,O,372975)|0}else{if(!z)Y_a((f[d>>2]|0)+(x*24|0)|0,372958)|0;if(!y)Y_a((f[d>>2]|0)+(x*24|0)|0,372965)|0;if(!B)Y_a((f[d>>2]|0)+(x*24|0)|0,372975)|0}E=f[s>>2]|0;J=(f[d>>2]|0)+(x*24|0)|0;F=E+-12|0;D=f[F>>2]|0;if((D|0)==(f[E+-8>>2]|0))__a(E+-16|0,J);else{Z_a(D,J);f[F>>2]=(f[F>>2]|0)+24}x=x+1|0}}else C=a;while(0);P=C;break a;break}default:{}}q=$_a(a,c,d)|0;if((q|0)==(a|0)){x=a+1|0;s=(x|0)!=(c|0);d:do switch(b[a>>0]|0){case 65:{B=a$a(a,c,d)|0;if((B|0)==(a|0)){P=a;break a}y=f[d+4>>2]|0;if((f[d>>2]|0)==(y|0)){P=a;break a}f[h>>2]=f[d+12>>2];b$a(g,y+-24|0,h);y=d+20|0;z=f[y>>2]|0;if(z>>>0<(f[d+24>>2]|0)>>>0){f[z>>2]=0;r=z+4|0;f[r>>2]=0;v=f[g+12>>2]|0;f[z+8>>2]=0;f[z+12>>2]=v;f[z>>2]=f[g>>2];v=g+4|0;f[r>>2]=f[v>>2];r=g+8|0;f[z+8>>2]=f[r>>2];f[r>>2]=0;f[v>>2]=0;f[g>>2]=0;f[y>>2]=(f[y>>2]|0)+16}else c$a(p,g);A_a(g);P=B;break a;break}case 67:{B=U_a(x,c,d)|0;if((B|0)==(x|0)){P=a;break a}y=d+4|0;v=f[y>>2]|0;if((f[d>>2]|0)==(v|0)){P=a;break a}Y_a(v+-24|0,372985)|0;v=(f[y>>2]|0)+-24|0;f[h>>2]=f[d+12>>2];b$a(g,v,h);v=d+20|0;y=f[v>>2]|0;if(y>>>0<(f[d+24>>2]|0)>>>0){f[y>>2]=0;r=y+4|0;f[r>>2]=0;z=f[g+12>>2]|0;f[y+8>>2]=0;f[y+12>>2]=z;f[y>>2]=f[g>>2];z=g+4|0;f[r>>2]=f[z>>2];r=g+8|0;f[y+8>>2]=f[r>>2];f[r>>2]=0;f[z>>2]=0;f[g>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else c$a(p,g);A_a(g);P=B;break a;break}case 70:{B=d$a(a,c,d)|0;if((B|0)==(a|0)){P=a;break a}v=f[d+4>>2]|0;if((f[d>>2]|0)==(v|0)){P=a;break a}f[h>>2]=f[d+12>>2];b$a(g,v+-24|0,h);v=d+20|0;z=f[v>>2]|0;if(z>>>0<(f[d+24>>2]|0)>>>0){f[z>>2]=0;r=z+4|0;f[r>>2]=0;y=f[g+12>>2]|0;f[z+8>>2]=0;f[z+12>>2]=y;f[z>>2]=f[g>>2];y=g+4|0;f[r>>2]=f[y>>2];r=g+8|0;f[z+8>>2]=f[r>>2];f[r>>2]=0;f[y>>2]=0;f[g>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else c$a(p,g);A_a(g);P=B;break a;break}case 71:{B=U_a(x,c,d)|0;if((B|0)==(x|0)){P=a;break a}v=d+4|0;y=f[v>>2]|0;if((f[d>>2]|0)==(y|0)){P=a;break a}Y_a(y+-24|0,372994)|0;y=(f[v>>2]|0)+-24|0;f[h>>2]=f[d+12>>2];b$a(g,y,h);y=d+20|0;v=f[y>>2]|0;if(v>>>0<(f[d+24>>2]|0)>>>0){f[v>>2]=0;r=v+4|0;f[r>>2]=0;z=f[g+12>>2]|0;f[v+8>>2]=0;f[v+12>>2]=z;f[v>>2]=f[g>>2];z=g+4|0;f[r>>2]=f[z>>2];r=g+8|0;f[v+8>>2]=f[r>>2];f[r>>2]=0;f[z>>2]=0;f[g>>2]=0;f[y>>2]=(f[y>>2]|0)+16}else c$a(p,g);A_a(g);P=B;break a;break}case 77:{B=e$a(a,c,d)|0;if((B|0)==(a|0)){P=a;break a}y=f[d+4>>2]|0;if((f[d>>2]|0)==(y|0)){P=a;break a}f[h>>2]=f[d+12>>2];b$a(g,y+-24|0,h);y=d+20|0;z=f[y>>2]|0;if(z>>>0<(f[d+24>>2]|0)>>>0){f[z>>2]=0;r=z+4|0;f[r>>2]=0;v=f[g+12>>2]|0;f[z+8>>2]=0;f[z+12>>2]=v;f[z>>2]=f[g>>2];v=g+4|0;f[r>>2]=f[v>>2];r=g+8|0;f[z+8>>2]=f[r>>2];f[r>>2]=0;f[v>>2]=0;f[g>>2]=0;f[y>>2]=(f[y>>2]|0)+16}else c$a(p,g);A_a(g);P=B;break a;break}case 79:{B=d+4|0;y=((f[B>>2]|0)-(f[d>>2]|0)|0)/24|0;v=U_a(x,c,d)|0;r=((f[B>>2]|0)-(f[d>>2]|0)|0)/24|0;if((v|0)==(x|0)){P=a;break a}B=f[d+12>>2]|0;f[g>>2]=B;z=d+20|0;w=f[z>>2]|0;if(w>>>0<(f[d+24>>2]|0)>>>0){f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=B;f[z>>2]=(f[z>>2]|0)+16}else W_a(p,g);B=g+11|0;w=g+4|0;t=y;while(1){if(t>>>0>=r>>>0){P=v;break a}f$a(g,(f[d>>2]|0)+(t*24|0)+12|0,2);y=YOa(373005)|0;F=b[B>>0]|0;if((y|0)==((F<<24>>24<0?f[w>>2]|0:F&255)|0))Q=(g$a(g,373005,y)|0)==0;else Q=0;Q_a(g);y=f[d>>2]|0;if(!Q){F=y+(t*24|0)+12|0;if((b[F+11>>0]|0)<0)R=f[F>>2]|0;else R=F;if((b[R>>0]|0)==40){Y_a(y+(t*24|0)|0,373013)|0;X_a((f[d>>2]|0)+(t*24|0)+12|0,0,373011)|0}}else{Y_a(y+(t*24|0)|0,373008)|0;X_a((f[d>>2]|0)+(t*24|0)+12|0,0,373011)|0}Y_a((f[d>>2]|0)+(t*24|0)|0,373015)|0;y=f[z>>2]|0;F=(f[d>>2]|0)+(t*24|0)|0;J=y+-12|0;D=f[J>>2]|0;if((D|0)==(f[y+-8>>2]|0))__a(y+-16|0,F);else{Z_a(D,F);f[J>>2]=(f[J>>2]|0)+24}t=t+1|0}break}case 80:{t=d+4|0;z=((f[t>>2]|0)-(f[d>>2]|0)|0)/24|0;w=U_a(x,c,d)|0;B=((f[t>>2]|0)-(f[d>>2]|0)|0)/24|0;if((w|0)==(x|0)){P=a;break a}t=f[d+12>>2]|0;f[g>>2]=t;v=d+20|0;r=f[v>>2]|0;if(r>>>0<(f[d+24>>2]|0)>>>0){f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=t;f[v>>2]=(f[v>>2]|0)+16}else W_a(p,g);t=g+11|0;r=g+4|0;J=g+11|0;F=g+4|0;D=z;while(1){if(D>>>0>=B>>>0){P=w;break a}f$a(g,(f[d>>2]|0)+(D*24|0)+12|0,2);z=YOa(373005)|0;y=b[t>>0]|0;if((z|0)==((y<<24>>24<0?f[r>>2]|0:y&255)|0))S=(g$a(g,373005,z)|0)==0;else S=0;Q_a(g);z=f[d>>2]|0;if(!S){y=z+(D*24|0)+12|0;if((b[y+11>>0]|0)<0)T=f[y>>2]|0;else T=y;if((b[T>>0]|0)==40){Y_a(z+(D*24|0)|0,373013)|0;X_a((f[d>>2]|0)+(D*24|0)+12|0,0,373011)|0}}else{Y_a(z+(D*24|0)|0,373008)|0;X_a((f[d>>2]|0)+(D*24|0)+12|0,0,373011)|0}if((b[x>>0]|0)==85){f$a(g,(f[d>>2]|0)+(D*24|0)|0,12);z=YOa(373018)|0;y=b[J>>0]|0;if((z|0)==((y<<24>>24<0?f[F>>2]|0:y&255)|0))U=(g$a(g,373018,z)|0)!=0;else U=1;Q_a(g);z=(f[d>>2]|0)+(D*24|0)|0;if(U){V=z;W=112}else h$a(z)}else{V=(f[d>>2]|0)+(D*24|0)|0;W=112}if((W|0)==112){W=0;Y_a(V,373031)|0}z=f[v>>2]|0;y=(f[d>>2]|0)+(D*24|0)|0;E=z+-12|0;G=f[E>>2]|0;if((G|0)==(f[z+-8>>2]|0))__a(z+-16|0,y);else{Z_a(G,y);f[E>>2]=(f[E>>2]|0)+24}D=D+1|0}break}case 82:{D=d+4|0;v=((f[D>>2]|0)-(f[d>>2]|0)|0)/24|0;F=U_a(x,c,d)|0;J=((f[D>>2]|0)-(f[d>>2]|0)|0)/24|0;if((F|0)==(x|0)){P=a;break a}D=f[d+12>>2]|0;f[g>>2]=D;r=d+20|0;t=f[r>>2]|0;if(t>>>0<(f[d+24>>2]|0)>>>0){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=D;f[r>>2]=(f[r>>2]|0)+16}else W_a(p,g);D=g+11|0;t=g+4|0;w=v;while(1){if(w>>>0>=J>>>0){P=F;break a}f$a(g,(f[d>>2]|0)+(w*24|0)+12|0,2);v=YOa(373005)|0;B=b[D>>0]|0;if((v|0)==((B<<24>>24<0?f[t>>2]|0:B&255)|0))X=(g$a(g,373005,v)|0)==0;else X=0;Q_a(g);v=f[d>>2]|0;if(!X){B=v+(w*24|0)+12|0;if((b[B+11>>0]|0)<0)Y=f[B>>2]|0;else Y=B;if((b[Y>>0]|0)==40){Y_a(v+(w*24|0)|0,373013)|0;X_a((f[d>>2]|0)+(w*24|0)+12|0,0,373011)|0}}else{Y_a(v+(w*24|0)|0,373008)|0;X_a((f[d>>2]|0)+(w*24|0)+12|0,0,373011)|0}Y_a((f[d>>2]|0)+(w*24|0)|0,373033)|0;v=f[r>>2]|0;B=(f[d>>2]|0)+(w*24|0)|0;E=v+-12|0;y=f[E>>2]|0;if((y|0)==(f[v+-8>>2]|0))__a(v+-16|0,B);else{Z_a(y,B);f[E>>2]=(f[E>>2]|0)+24}w=w+1|0}break}case 84:{w=d+4|0;r=((f[w>>2]|0)-(f[d>>2]|0)|0)/24|0;t=i$a(a,c,d)|0;D=((f[w>>2]|0)-(f[d>>2]|0)|0)/24|0;if((t|0)==(a|0)){P=a;break a}F=d+12|0;J=f[F>>2]|0;f[g>>2]=J;E=d+20|0;B=f[E>>2]|0;y=d+24|0;if(B>>>0<(f[y>>2]|0)>>>0){f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=J;f[E>>2]=(f[E>>2]|0)+16}else W_a(p,g);J=r;while(1){if(J>>>0>=D>>>0)break;B=f[E>>2]|0;v=(f[d>>2]|0)+(J*24|0)|0;G=B+-12|0;z=f[G>>2]|0;if((z|0)==(f[B+-8>>2]|0))__a(B+-16|0,v);else{Z_a(z,v);f[G>>2]=(f[G>>2]|0)+24}J=J+1|0}if(!((D|0)==(r+1|0)&(b[d+63>>0]|0)!=0)){P=t;break a}J=j$a(t,c,d)|0;if((J|0)==(t|0)){P=t;break a}k$a(g,(f[w>>2]|0)+-24|0);G=f[w>>2]|0;v=G+-24|0;z=G;while(1){if((z|0)==(v|0))break;B=z+-24|0;f[w>>2]=B;z_a(B);z=f[w>>2]|0}z=b[g+11>>0]|0;v=z<<24>>24<0;C_a(G+-48|0,v?f[g>>2]|0:g,v?f[g+4>>2]|0:z&255)|0;z=(f[w>>2]|0)+-24|0;f[i>>2]=f[F>>2];b$a(h,z,i);z=f[E>>2]|0;if(z>>>0<(f[y>>2]|0)>>>0){f[z>>2]=0;v=z+4|0;f[v>>2]=0;t=f[h+12>>2]|0;f[z+8>>2]=0;f[z+12>>2]=t;f[z>>2]=f[h>>2];t=h+4|0;f[v>>2]=f[t>>2];v=h+8|0;f[z+8>>2]=f[v>>2];f[v>>2]=0;f[t>>2]=0;f[h>>2]=0;f[E>>2]=(f[E>>2]|0)+16}else c$a(p,h);A_a(h);Q_a(g);P=J;break a;break}case 85:{if(!s){P=a;break a}t=l$a(x,c,d)|0;if((t|0)==(x|0)){P=a;break a}v=U_a(t,c,d)|0;if((v|0)==(t|0)){P=a;break a}t=d+4|0;z=f[t>>2]|0;if(((z-(f[d>>2]|0)|0)/24|0)>>>0<2){P=a;break a}k$a(g,z+-24|0);z=f[t>>2]|0;r=z+-24|0;D=z;while(1){if((D|0)==(r|0))break;B=D+-24|0;f[t>>2]=B;z_a(B);D=f[t>>2]|0}f$a(h,z+-48|0,9);D=YOa(373035)|0;r=b[h+11>>0]|0;if((D|0)==((r<<24>>24<0?f[h+4>>2]|0:r&255)|0)){r=(g$a(h,373035,D)|0)==0;Q_a(h);if(r){k$a(h,(f[t>>2]|0)+-24|0);r=f[t>>2]|0;D=r+-24|0;J=r;while(1){if((J|0)==(D|0))break;r=J+-24|0;f[t>>2]=r;z_a(r);J=f[t>>2]|0}J=h+11|0;D=b[J>>0]|0;z=D<<24>>24<0;r=f[h>>2]|0;E=l$a(z?r+9|0:h+9|0,(z?r:h)+(z?f[h+4>>2]|0:D&255)|0,d)|0;if((E|0)==(((b[J>>0]|0)<0?f[h>>2]|0:h)+9|0)){m$a(k,g,373045);E=b[J>>0]|0;J=E<<24>>24<0;C_a(k,J?f[h>>2]|0:h,J?f[h+4>>2]|0:E&255)|0;f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];f[o+8>>2]=f[k+8>>2];E=0;while(1){if((E|0)==3)break;f[k+(E<<2)>>2]=0;E=E+1|0}n$a(i,o);E=f[t>>2]|0;if(E>>>0<(f[d+8>>2]|0)>>>0){p$a(E,i);f[t>>2]=(f[t>>2]|0)+24}else q$a(d,i);z_a(i);Q_a(o);Q_a(k)}else{m$a(m,g,373047);k$a(n,(f[t>>2]|0)+-24|0);E=b[n+11>>0]|0;J=E<<24>>24<0;C_a(m,J?f[n>>2]|0:n,J?f[n+4>>2]|0:E&255)|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2];f[k+8>>2]=f[m+8>>2];E=0;while(1){if((E|0)==3)break;f[m+(E<<2)>>2]=0;E=E+1|0}Y_a(k,373049)|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];f[l+8>>2]=f[k+8>>2];E=0;while(1){if((E|0)==3)break;f[k+(E<<2)>>2]=0;E=E+1|0}n$a(i,l);o$a((f[t>>2]|0)+-24|0,i);z_a(i);Q_a(l);Q_a(k);Q_a(n);Q_a(m)}Q_a(h)}else W=166}else{Q_a(h);W=166}if((W|0)==166){m$a(i,g,373045);k$a(k,(f[t>>2]|0)+-24|0);E=b[k+11>>0]|0;J=E<<24>>24<0;C_a(i,J?f[k>>2]|0:k,J?f[k+4>>2]|0:E&255)|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];E=0;while(1){if((E|0)==3)break;f[i+(E<<2)>>2]=0;E=E+1|0}n$a(h,j);o$a((f[t>>2]|0)+-24|0,h);z_a(h);Q_a(j);Q_a(k);Q_a(i)}E=(f[t>>2]|0)+-24|0;f[i>>2]=f[d+12>>2];b$a(h,E,i);E=d+20|0;J=f[E>>2]|0;if(J>>>0<(f[d+24>>2]|0)>>>0){f[J>>2]=0;D=J+4|0;f[D>>2]=0;z=f[h+12>>2]|0;f[J+8>>2]=0;f[J+12>>2]=z;f[J>>2]=f[h>>2];z=h+4|0;f[D>>2]=f[z>>2];D=h+8|0;f[J+8>>2]=f[D>>2];f[D>>2]=0;f[z>>2]=0;f[h>>2]=0;f[E>>2]=(f[E>>2]|0)+16}else c$a(p,h);A_a(h);Q_a(g);P=v;break a;break}case 83:{if(s?(b[x>>0]|0)==116:0){E=r$a(a,c,d)|0;if((E|0)==(a|0)){P=a;break a}z=f[d+4>>2]|0;if((f[d>>2]|0)==(z|0)){P=a;break a}f[h>>2]=f[d+12>>2];b$a(g,z+-24|0,h);z=d+20|0;D=f[z>>2]|0;if(D>>>0<(f[d+24>>2]|0)>>>0){f[D>>2]=0;J=D+4|0;f[J>>2]=0;r=f[g+12>>2]|0;f[D+8>>2]=0;f[D+12>>2]=r;f[D>>2]=f[g>>2];r=g+4|0;f[J>>2]=f[r>>2];J=g+8|0;f[D+8>>2]=f[J>>2];f[J>>2]=0;f[r>>2]=0;f[g>>2]=0;f[z>>2]=(f[z>>2]|0)+16}else c$a(p,g);A_a(g);P=E;break a}E=s$a(a,c,d)|0;if((E|0)==(a|0)){P=a;break a}z=j$a(E,c,d)|0;if((z|0)==(E|0)){P=E;break a}r=d+4|0;J=f[r>>2]|0;if(((J-(f[d>>2]|0)|0)/24|0)>>>0<2){P=E;break a}k$a(g,J+-24|0);J=f[r>>2]|0;E=J+-24|0;D=J;while(1){if((D|0)==(E|0))break;y=D+-24|0;f[r>>2]=y;z_a(y);D=f[r>>2]|0}D=b[g+11>>0]|0;E=D<<24>>24<0;C_a(J+-48|0,E?f[g>>2]|0:g,E?f[g+4>>2]|0:D&255)|0;D=(f[r>>2]|0)+-24|0;f[i>>2]=f[d+12>>2];b$a(h,D,i);D=d+20|0;E=f[D>>2]|0;if(E>>>0<(f[d+24>>2]|0)>>>0){f[E>>2]=0;v=E+4|0;f[v>>2]=0;t=f[h+12>>2]|0;f[E+8>>2]=0;f[E+12>>2]=t;f[E>>2]=f[h>>2];t=h+4|0;f[v>>2]=f[t>>2];v=h+8|0;f[E+8>>2]=f[v>>2];f[v>>2]=0;f[t>>2]=0;f[h>>2]=0;f[D>>2]=(f[D>>2]|0)+16}else c$a(p,h);A_a(h);Q_a(g);P=z;break a;break}case 68:{if(s)switch(b[x>>0]|0){case 112:{D=d+4|0;t=((f[D>>2]|0)-(f[d>>2]|0)|0)/24|0;v=a+2|0;E=U_a(v,c,d)|0;y=((f[D>>2]|0)-(f[d>>2]|0)|0)/24|0;if((E|0)==(v|0))break d;v=f[d+12>>2]|0;f[g>>2]=v;D=d+20|0;F=f[D>>2]|0;if(F>>>0<(f[d+24>>2]|0)>>>0){f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=v;f[D>>2]=(f[D>>2]|0)+16}else W_a(p,g);v=t;while(1){if(v>>>0>=y>>>0){P=E;break a}t=f[D>>2]|0;F=(f[d>>2]|0)+(v*24|0)|0;w=t+-12|0;G=f[w>>2]|0;if((G|0)==(f[t+-8>>2]|0))__a(t+-16|0,F);else{Z_a(G,F);f[w>>2]=(f[w>>2]|0)+24}v=v+1|0}break}case 84:case 116:{v=t$a(a,c,d)|0;if((v|0)==(a|0))break d;D=f[d+4>>2]|0;if((f[d>>2]|0)==(D|0)){P=a;break a}f[h>>2]=f[d+12>>2];b$a(g,D+-24|0,h);D=d+20|0;E=f[D>>2]|0;if(E>>>0<(f[d+24>>2]|0)>>>0){f[E>>2]=0;y=E+4|0;f[y>>2]=0;z=f[g+12>>2]|0;f[E+8>>2]=0;f[E+12>>2]=z;f[E>>2]=f[g>>2];z=g+4|0;f[y>>2]=f[z>>2];y=g+8|0;f[E+8>>2]=f[y>>2];f[y>>2]=0;f[z>>2]=0;f[g>>2]=0;f[D>>2]=(f[D>>2]|0)+16}else c$a(p,g);A_a(g);P=v;break a;break}case 118:{v=u$a(a,c,d)|0;if((v|0)==(a|0))break d;D=f[d+4>>2]|0;if((f[d>>2]|0)==(D|0)){P=a;break a}f[h>>2]=f[d+12>>2];b$a(g,D+-24|0,h);D=d+20|0;z=f[D>>2]|0;if(z>>>0<(f[d+24>>2]|0)>>>0){f[z>>2]=0;y=z+4|0;f[y>>2]=0;E=f[g+12>>2]|0;f[z+8>>2]=0;f[z+12>>2]=E;f[z>>2]=f[g>>2];E=g+4|0;f[y>>2]=f[E>>2];y=g+8|0;f[z+8>>2]=f[y>>2];f[y>>2]=0;f[E>>2]=0;f[g>>2]=0;f[D>>2]=(f[D>>2]|0)+16}else c$a(p,g);A_a(g);P=v;break a;break}default:break d}break}default:{}}while(0);x=$_a(a,c,d)|0;if((x|0)==(a|0)){s=r$a(a,c,d)|0;if((s|0)!=(a|0)?(v=f[d+4>>2]|0,(f[d>>2]|0)!=(v|0)):0){f[h>>2]=f[d+12>>2];b$a(g,v+-24|0,h);v=d+20|0;D=f[v>>2]|0;if(D>>>0<(f[d+24>>2]|0)>>>0){f[D>>2]=0;E=D+4|0;f[E>>2]=0;y=f[g+12>>2]|0;f[D+8>>2]=0;f[D+12>>2]=y;f[D>>2]=f[g>>2];y=g+4|0;f[E>>2]=f[y>>2];E=g+8|0;f[D+8>>2]=f[E>>2];f[E>>2]=0;f[y>>2]=0;f[g>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else c$a(p,g);A_a(g);P=s}else P=a}else P=x}else P=q}else P=a;while(0);u=e;return P|0}function V_a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f[d>>2]=0;if((a|0)!=(c|0)){c=b[a>>0]|0;if(c<<24>>24==114){f[d>>2]=4;e=a+1|0;g=b[e>>0]|0;h=4;i=e}else{g=c;h=0;i=a}if(g<<24>>24==86){c=h|2;f[d>>2]=c;e=i+1|0;j=b[e>>0]|0;k=c;l=e}else{j=g;k=h;l=i}if(j<<24>>24==75){f[d>>2]=k|1;m=l+1|0}else m=l}else m=a;return m|0}function W_a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+32|0;d=c;e=a+4|0;g=((f[e>>2]|0)-(f[a>>2]|0)>>4)+1|0;h=_0a(a)|0;if(h>>>0<g>>>0)gXa(a);else{i=f[a>>2]|0;j=(f[a+8>>2]|0)-i|0;k=j>>3;$0a(d,j>>4>>>0<h>>>1>>>0?(k>>>0<g>>>0?g:k):h,(f[e>>2]|0)-i>>4,a+12|0);i=d+8|0;e=f[i>>2]|0;f[e>>2]=0;f[e+4>>2]=0;h=f[b>>2]|0;f[e+8>>2]=0;f[e+12>>2]=h;f[i>>2]=e+16;a1a(a,d);b1a(d);u=c;return}}function X_a(a,b,c){a=a|0;b=b|0;c=c|0;return Z0a(a,b,c,YOa(c)|0)|0}function Y_a(a,b){a=a|0;b=b|0;return C_a(a,b,YOa(b)|0)|0}function Z_a(a,b){a=a|0;b=b|0;t0a(a,b);t0a(a+12|0,b+12|0);return}function __a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+32|0;d=c;e=a+4|0;g=(((f[e>>2]|0)-(f[a>>2]|0)|0)/24|0)+1|0;h=x0a(a)|0;if(h>>>0<g>>>0)gXa(a);else{i=f[a>>2]|0;j=((f[a+8>>2]|0)-i|0)/24|0;k=j<<1;y0a(d,j>>>0<h>>>1>>>0?(k>>>0<g>>>0?g:k):h,((f[e>>2]|0)-i|0)/24|0,a+12|0);i=d+8|0;e=f[i>>2]|0;Z_a(e,b);f[i>>2]=e+24;z0a(a,d);A0a(d);u=c;return}}function $_a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+32|0;g=e;a:do if((a|0)==(c|0))h=a;else{i=a+1|0;do switch(b[a>>0]|0){case 118:{E0a(g,374450);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);h=i;break a;break}case 119:{f1a(g);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);h=i;break a;break}case 98:{E0a(g,374455);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);h=i;break a;break}case 99:{E0a(g,374224);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);h=i;break a;break}case 97:{l0a(g,374229);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);h=i;break a;break}case 104:{I0a(g,374241);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);h=i;break a;break}case 115:{X$a(g,374255);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);h=i;break a;break}case 116:{m0a(g,374261);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);h=i;break a;break}case 105:{g1a(g,374460);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);h=i;break a;break}case 106:{n0a(g,374464);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);h=i;break a;break}case 108:{E0a(g,374477);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);h=i;break a;break}case 109:{I0a(g,374482);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);h=i;break a;break}case 120:{i0a(g,374496);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);h=i;break a;break}case 121:{h1a(g);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);h=i;break a;break}case 110:{i1a(g,374290);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);h=i;break a;break}case 111:{j0a(g,374299);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);h=i;break a;break}case 102:{X$a(g,374506);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);h=i;break a;break}case 100:{j1a(g);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);h=i;break a;break}case 101:{l0a(g,374512);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);h=i;break a;break}case 103:{h0a(g,374524);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);h=i;break a;break}case 122:{g1a(g,374535);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);h=i;break a;break}case 117:{j=l$a(i,c,d)|0;h=(j|0)==(i|0)?a:j;break a;break}case 68:{if((i|0)==(c|0)){h=a;break a}j=a+2|0;switch(b[i>>0]|0){case 100:{i0a(g,374539);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){p$a(l,g);f[k>>2]=(f[k>>2]|0)+24}else q$a(d,g);z_a(g);h=j;break a;break}case 101:{h0a(g,374549);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){p$a(l,g);f[k>>2]=(f[k>>2]|0)+24}else q$a(d,g);z_a(g);h=j;break a;break}case 102:{i0a(g,374560);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){p$a(l,g);f[k>>2]=(f[k>>2]|0)+24}else q$a(d,g);z_a(g);h=j;break a;break}case 104:{i0a(g,374570);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){p$a(l,g);f[k>>2]=(f[k>>2]|0)+24}else q$a(d,g);z_a(g);h=j;break a;break}case 105:{i1a(g,374580);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){p$a(l,g);f[k>>2]=(f[k>>2]|0)+24}else q$a(d,g);z_a(g);h=j;break a;break}case 115:{i1a(g,374589);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){p$a(l,g);f[k>>2]=(f[k>>2]|0)+24}else q$a(d,g);z_a(g);h=j;break a;break}case 97:{E0a(g,374598);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){p$a(l,g);f[k>>2]=(f[k>>2]|0)+24}else q$a(d,g);z_a(g);h=j;break a;break}case 110:{m0a(g,374603);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){p$a(l,g);f[k>>2]=(f[k>>2]|0)+24}else q$a(d,g);z_a(g);h=j;break a;break}default:{h=a;break a}}break}default:{h=a;break a}}while(0)}while(0);u=e;return h|0}function a$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+112|0;g=e+96|0;h=e+72|0;i=e+48|0;j=e+36|0;k=e+24|0;l=e+12|0;m=e;do if(((a|0)!=(c|0)?(b[a>>0]|0)==65:0)?(n=a+1|0,(n|0)!=(c|0)):0){o=b[n>>0]|0;if(o<<24>>24==95){p=a+2|0;q=U_a(p,c,d)|0;if((q|0)==(p|0)){r=a;break}p=d+4|0;s=f[p>>2]|0;if((f[d>>2]|0)==(s|0)){r=a;break}f$a(g,s+-12|0,2);s=YOa(373005)|0;t=b[g+11>>0]|0;if((s|0)==((t<<24>>24<0?f[g+4>>2]|0:t&255)|0)){t=(g$a(g,373005,s)|0)==0;Q_a(g);if(t)e1a((f[p>>2]|0)+-12|0)}else Q_a(g);X_a((f[p>>2]|0)+-12|0,0,374446)|0;r=q;break}if((o+-49&255)<9){o=v$a(n,c)|0;if((o|0)==(c|0)){r=a;break}if((b[o>>0]|0)!=95){r=a;break}q=o+1|0;p=U_a(q,c,d)|0;if((p|0)==(q|0)){r=a;break}q=d+4|0;t=f[q>>2]|0;if((f[d>>2]|0)==(t|0)){r=a;break}f$a(g,t+-12|0,2);t=YOa(373005)|0;s=b[g+11>>0]|0;if((t|0)==((s<<24>>24<0?f[g+4>>2]|0:s&255)|0)){s=(g$a(g,373005,t)|0)==0;Q_a(g);if(s)e1a((f[q>>2]|0)+-12|0)}else Q_a(g);s=(f[q>>2]|0)+-12|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;q=o-n|0;if(q>>>0>4294967279)WYa(j);if(q>>>0<11){b[j+11>>0]=q;v=j}else{t=q+16&-16;w=N_a(t)|0;f[j>>2]=w;f[j+8>>2]=t|-2147483648;f[j+4>>2]=q;v=w}w=n;t=v;while(1){if((w|0)==(o|0))break;ZOa(t,w);w=w+1|0;t=t+1|0}b[g>>0]=0;ZOa(v+q|0,g);X_a(j,0,373005)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];t=0;while(1){if((t|0)==3)break;f[j+(t<<2)>>2]=0;t=t+1|0}Y_a(i,373060)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];t=0;while(1){if((t|0)==3)break;f[i+(t<<2)>>2]=0;t=t+1|0}t=b[h+11>>0]|0;q=t<<24>>24<0;Z0a(s,0,q?f[h>>2]|0:h,q?f[h+4>>2]|0:t&255)|0;Q_a(h);Q_a(i);Q_a(j);r=p;break}t=w$a(n,c,d)|0;if(((!((t|0)==(n|0)|(t|0)==(c|0))?(b[t>>0]|0)==95:0)?(q=t+1|0,t=U_a(q,c,d)|0,(t|0)!=(q|0)):0)?(q=d+4|0,w=f[q>>2]|0,((w-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){p$a(h,w+-24|0);w=f[q>>2]|0;o=w+-24|0;x=w;while(1){if((x|0)==(o|0))break;y=x+-24|0;f[q>>2]=y;z_a(y);x=f[q>>2]|0}p$a(i,w+-48|0);x=f[q>>2]|0;o=x+-24|0;n=o+11|0;if((b[n>>0]|0)<0){p=f[o>>2]|0;b[g>>0]=0;ZOa(p,g);f[x+-20>>2]=0}else{b[g>>0]=0;ZOa(o,g);b[n>>0]=0}x$a(o);f[o>>2]=f[h>>2];f[o+4>>2]=f[h+4>>2];f[o+8>>2]=f[h+8>>2];o=0;while(1){if((o|0)==3)break;f[h+(o<<2)>>2]=0;o=o+1|0}o=h+12|0;f$a(g,o,2);w=YOa(373005)|0;n=b[g+11>>0]|0;if((w|0)==((n<<24>>24<0?f[g+4>>2]|0:n&255)|0)){n=(g$a(g,373005,w)|0)==0;Q_a(g);if(n)e1a(o)}else Q_a(g);k$a(m,i);X_a(m,0,373005)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];n=0;while(1){if((n|0)==3)break;f[m+(n<<2)>>2]=0;n=n+1|0}Y_a(l,373060)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];n=0;while(1){if((n|0)==3)break;f[l+(n<<2)>>2]=0;n=n+1|0}n=b[o+11>>0]|0;w=n<<24>>24<0;C_a(k,w?f[o>>2]|0:o,w?f[h+16>>2]|0:n&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];n=0;while(1){if((n|0)==3)break;f[k+(n<<2)>>2]=0;n=n+1|0}n=f[q>>2]|0;o=n+-12|0;w=o+11|0;if((b[w>>0]|0)<0){x=f[o>>2]|0;b[g>>0]=0;ZOa(x,g);f[n+-8>>2]=0}else{b[g>>0]=0;ZOa(o,g);b[w>>0]=0}x$a(o);f[o>>2]=f[j>>2];f[o+4>>2]=f[j+4>>2];f[o+8>>2]=f[j+8>>2];o=0;while(1){if((o|0)==3)break;f[j+(o<<2)>>2]=0;o=o+1|0}Q_a(j);Q_a(k);Q_a(l);Q_a(m);z_a(i);z_a(h);r=t}else r=a}else r=a;while(0);u=e;return r|0}function b$a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;f[a>>2]=0;d=a+4|0;f[d>>2]=0;e=f[c>>2]|0;f[a+8>>2]=0;f[a+12>>2]=e;d1a(a);Z_a(f[d>>2]|0,b);f[d>>2]=(f[d>>2]|0)+24;return}function c$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+32|0;d=c;e=a+4|0;g=((f[e>>2]|0)-(f[a>>2]|0)>>4)+1|0;h=_0a(a)|0;if(h>>>0<g>>>0)gXa(a);else{i=f[a>>2]|0;j=(f[a+8>>2]|0)-i|0;k=j>>3;$0a(d,j>>4>>>0<h>>>1>>>0?(k>>>0<g>>>0?g:k):h,(f[e>>2]|0)-i>>4,a+12|0);i=d+8|0;e=f[i>>2]|0;f[e>>2]=0;h=e+4|0;f[h>>2]=0;k=f[b+12>>2]|0;f[e+8>>2]=0;f[e+12>>2]=k;f[e>>2]=f[b>>2];k=b+4|0;f[h>>2]=f[k>>2];h=b+8|0;f[e+8>>2]=f[h>>2];f[h>>2]=0;f[k>>2]=0;f[b>>2]=0;f[i>>2]=e+16;a1a(a,d);b1a(d);u=c;return}}function d$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+32|0;g=e+12|0;h=e;a:do if(((a|0)!=(c|0)?(b[a>>0]|0)==70:0)?(i=a+1|0,(i|0)!=(c|0)):0){if((b[i>>0]|0)==89){j=a+2|0;if((j|0)==(c|0)){k=a;break}else l=j}else l=i;i=U_a(l,c,d)|0;if((i|0)!=(l|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;j=YOa(373013)|0;if(j>>>0>4294967279)WYa(h);if(j>>>0<11){m=h+11|0;b[m>>0]=j;n=h;o=m;p=h+4|0}else{m=j+16&-16;q=N_a(m)|0;f[h>>2]=q;f[h+8>>2]=m|-2147483648;m=h+4|0;f[m>>2]=j;n=q;o=h+11|0;p=m}kOa(n,373013,j)|0;b[g>>0]=0;ZOa(n+j|0,g);j=d+4|0;m=g+11|0;q=g+4|0;r=0;s=i;b:while(1){i=s;c:while(1){if((i|0)==(c|0)){t=15;break b}v=b[i>>0]|0;w=i+1|0;switch(v<<24>>24){case 69:{t=19;break b;break}case 118:{i=w;continue c;break}default:{}}x=(w|0)==(c|0);if(!(x|v<<24>>24!=82)?(b[w>>0]|0)==69:0){r=1;s=w;continue b}if(!(x|v<<24>>24!=79)?(b[w>>0]|0)==69:0){r=2;s=w;continue b}v=((f[j>>2]|0)-(f[d>>2]|0)|0)/24|0;x=U_a(i,c,d)|0;y=((f[j>>2]|0)-(f[d>>2]|0)|0)/24|0;if((x|0)==(i|0)|(x|0)==(c|0))break b;else z=v;while(1){if(z>>>0>=y>>>0){A=v;break}B=b[o>>0]|0;if((B<<24>>24<0?f[p>>2]|0:B&255)>>>0>1)Y_a(h,373235)|0;k$a(g,(f[d>>2]|0)+(z*24|0)|0);B=b[m>>0]|0;C=B<<24>>24<0;C_a(h,C?f[g>>2]|0:g,C?f[q>>2]|0:B&255)|0;Q_a(g);z=z+1|0}while(1){if(A>>>0>=y>>>0){i=x;continue c}v=f[j>>2]|0;B=v+-24|0;C=v;while(1){if((C|0)==(B|0))break;v=C+-24|0;f[j>>2]=v;z_a(v);C=f[j>>2]|0}A=A+1|0}}}d:do if((t|0)==15){q=f[j>>2]|0;m=q+-24|0;s=q;while(1){if((s|0)==(m|0))break d;q=s+-24|0;f[j>>2]=q;z_a(q);s=f[j>>2]|0}}else if((t|0)==19){Y_a(h,373011)|0;switch(r&3){case 1:{Y_a(h,374439)|0;break}case 2:{Y_a(h,374442)|0;break}default:{}}s=f[j>>2]|0;if((f[d>>2]|0)!=(s|0)){Y_a(s+-24|0,373045)|0;s=b[o>>0]|0;m=s<<24>>24<0;Z0a((f[j>>2]|0)+-12|0,0,m?f[h>>2]|0:h,m?f[p>>2]|0:s&255)|0;Q_a(h);k=w;break a}}while(0);Q_a(h);k=a}else k=a}else k=a;while(0);u=e;return k|0}function e$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+112|0;g=e+96|0;h=e+72|0;i=e+48|0;j=e+36|0;k=e+24|0;l=e+12|0;m=e;if(((((a|0)!=(c|0)?(b[a>>0]|0)==77:0)?(n=a+1|0,o=U_a(n,c,d)|0,(o|0)!=(n|0)):0)?(n=U_a(o,c,d)|0,(n|0)!=(o|0)):0)?(o=d+4|0,c=f[o>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){p$a(h,c+-24|0);c=f[o>>2]|0;d=c+-24|0;p=c;while(1){if((p|0)==(d|0))break;q=p+-24|0;f[o>>2]=q;z_a(q);p=f[o>>2]|0}p$a(i,c+-48|0);c=h+12|0;a:do if((b[((b[c+11>>0]|0)<0?f[c>>2]|0:c)>>0]|0)==40){Y_a(h,373013)|0;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[l+8>>2]=f[h+8>>2];p=0;while(1){if((p|0)==3)break;f[h+(p<<2)>>2]=0;p=p+1|0}k$a(m,i);p=b[m+11>>0]|0;d=p<<24>>24<0;C_a(l,d?f[m>>2]|0:m,d?f[m+4>>2]|0:p&255)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];p=0;while(1){if((p|0)==3)break;f[l+(p<<2)>>2]=0;p=p+1|0}Y_a(k,374435)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];p=0;while(1){if((p|0)==3)break;f[k+(p<<2)>>2]=0;p=p+1|0}p=f[o>>2]|0;d=p+-24|0;q=d+11|0;if((b[q>>0]|0)<0){r=f[d>>2]|0;b[g>>0]=0;ZOa(r,g);f[p+-20>>2]=0}else{b[g>>0]=0;ZOa(d,g);b[q>>0]=0}x$a(d);f[d>>2]=f[j>>2];f[d+4>>2]=f[j+4>>2];f[d+8>>2]=f[j+8>>2];d=0;while(1){if((d|0)==3)break;f[j+(d<<2)>>2]=0;d=d+1|0}Q_a(j);Q_a(k);Q_a(m);Q_a(l);X_a(c,0,373011)|0;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];f[j+8>>2]=f[c+8>>2];d=0;while(1){if((d|0)==3)break;f[c+(d<<2)>>2]=0;d=d+1|0}d=f[o>>2]|0;q=d+-12|0;p=q+11|0;if((b[p>>0]|0)<0){r=f[q>>2]|0;b[g>>0]=0;ZOa(r,g);f[d+-8>>2]=0}else{b[g>>0]=0;ZOa(q,g);b[p>>0]=0}x$a(q);f[q>>2]=f[j>>2];f[q+4>>2]=f[j+4>>2];f[q+8>>2]=f[j+8>>2];q=0;while(1){if((q|0)==3)break;f[j+(q<<2)>>2]=0;q=q+1|0}Q_a(j)}else{Y_a(h,373045)|0;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[l+8>>2]=f[h+8>>2];q=0;while(1){if((q|0)==3)break;f[h+(q<<2)>>2]=0;q=q+1|0}k$a(m,i);q=b[m+11>>0]|0;p=q<<24>>24<0;C_a(l,p?f[m>>2]|0:m,p?f[m+4>>2]|0:q&255)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];q=0;while(1){if((q|0)==3)break;f[l+(q<<2)>>2]=0;q=q+1|0}Y_a(k,374435)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];q=0;while(1){if((q|0)==3)break;f[k+(q<<2)>>2]=0;q=q+1|0}q=f[o>>2]|0;p=q+-24|0;d=p+11|0;if((b[d>>0]|0)<0){r=f[p>>2]|0;b[g>>0]=0;ZOa(r,g);f[q+-20>>2]=0}else{b[g>>0]=0;ZOa(p,g);b[d>>0]=0}x$a(p);f[p>>2]=f[j>>2];f[p+4>>2]=f[j+4>>2];f[p+8>>2]=f[j+8>>2];p=0;while(1){if((p|0)==3)break;f[j+(p<<2)>>2]=0;p=p+1|0}Q_a(j);Q_a(k);Q_a(m);Q_a(l);p=f[o>>2]|0;d=p+-12|0;q=d+11|0;if((b[q>>0]|0)<0){r=f[d>>2]|0;b[g>>0]=0;ZOa(r,g);f[p+-8>>2]=0}else{b[g>>0]=0;ZOa(d,g);b[q>>0]=0}x$a(d);f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];f[d+8>>2]=f[c+8>>2];d=0;while(1){if((d|0)==3)break a;f[c+(d<<2)>>2]=0;d=d+1|0}}while(0);z_a(i);z_a(h);s=n}else s=a;u=e;return s|0}function f$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=b[c+11>>0]|0;i=h<<24>>24<0;j=i?f[c+4>>2]|0:h&255;h=i?f[c>>2]|0:c;c=j>>>0<d>>>0?j:d;if(c>>>0>4294967279)WYa(a);if(c>>>0<11){b[a+11>>0]=c;k=a}else{d=c+16&-16;j=N_a(d)|0;f[a>>2]=j;f[a+8>>2]=d|-2147483648;f[a+4>>2]=c;k=j}kOa(k,h,c)|0;b[g>>0]=0;ZOa(k+c|0,g);u=e;return}function g$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=b[a+11>>0]|0;g=e<<24>>24<0;if(g)h=f[a+4>>2]|0;else h=e&255;if((d|0)==-1)XYa(a);if(g)i=f[a>>2]|0;else i=a;a=h>>>0>d>>>0;g=GYa(i,c,a?d:h)|0;if(!g)return (h>>>0<d>>>0?-1:a&1)|0;else return g|0;return 0}function h$a(a){a=a|0;Y0a(a,YOa(374432)|0);return}function i$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+64|0;g=e+40|0;h=e;i=e+24|0;j=a;a:do if((c-j|0)>1?(b[a>>0]|0)==84:0){k=b[a+1>>0]|0;l=d+62|0;m=d+32|0;if(k<<24>>24==95){n=f[d+36>>2]|0;if((f[m>>2]|0)==(n|0)){o=a;break}p=f[n+-16>>2]|0;q=a+2|0;if((p|0)==(f[n+-12>>2]|0)){X0a(g);n=d+4|0;r=f[n>>2]|0;if(r>>>0<(f[d+8>>2]|0)>>>0){p$a(r,g);f[n>>2]=(f[n>>2]|0)+24}else q$a(d,g);z_a(g);b[l>>0]=1;o=q;break}n=f[p+4>>2]|0;r=d+4|0;s=d+8|0;t=f[p>>2]|0;while(1){if((t|0)==(n|0)){o=q;break a}p=f[r>>2]|0;if((p|0)==(f[s>>2]|0))__a(d,t);else{Z_a(p,t);f[r>>2]=(f[r>>2]|0)+24}t=t+24|0}}t=(k<<24>>24)+-48|0;if(t>>>0<10){r=t;t=a+2|0;while(1){v=t+1|0;if((t|0)==(c|0)){o=a;break a}w=b[t>>0]|0;s=(w<<24>>24)+-48|0;if(s>>>0>=10)break;r=s+(r*10|0)|0;t=v}if(w<<24>>24==95?(t=f[d+36>>2]|0,(f[m>>2]|0)!=(t|0)):0){k=r+1|0;s=f[t+-16>>2]|0;q=s;if(k>>>0<(f[t+-12>>2]|0)-s>>4>>>0){s=f[q+(k<<4)+4>>2]|0;t=d+4|0;n=d+8|0;p=f[q+(k<<4)>>2]|0;while(1){if((p|0)==(s|0)){o=v;break a}k=f[t>>2]|0;if((k|0)==(f[n>>2]|0))__a(d,p);else{Z_a(k,p);f[t>>2]=(f[t>>2]|0)+24}p=p+24|0}};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;p=v-j|0;if(p>>>0>4294967279)WYa(i);if(p>>>0<11){b[i+11>>0]=p;x=i}else{t=p+16&-16;n=N_a(t)|0;f[i>>2]=n;f[i+8>>2]=t|-2147483648;f[i+4>>2]=p;x=n}n=a;t=x;while(1){if((n|0)==(v|0))break;ZOa(t,n);n=n+1|0;t=t+1|0}b[g>>0]=0;ZOa(x+p|0,g);n$a(h,i);t=d+4|0;n=f[t>>2]|0;if(n>>>0<(f[d+8>>2]|0)>>>0){p$a(n,h);f[t>>2]=(f[t>>2]|0)+24}else q$a(d,h);z_a(h);Q_a(i);b[l>>0]=1;o=v}else o=a}else o=a}else o=a;while(0);u=e;return o|0}function j$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=u;u=u+64|0;g=e+32|0;h=e+16|0;i=e;j=e+4|0;do if((c-a|0)>1?(b[a>>0]|0)==73:0){k=d+61|0;l=d+32|0;a:do if(b[k>>0]|0){m=f[d+36>>2]|0;n=f[m+-16>>2]|0;o=m+-12|0;while(1){m=f[o>>2]|0;if((m|0)==(n|0))break a;p=m+-16|0;f[o>>2]=p;A_a(p)}}while(0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;o=YOa(373047)|0;if(o>>>0>4294967279)WYa(h);if(o>>>0<11){n=h+11|0;b[n>>0]=o;q=h;r=n;s=h+4|0}else{n=o+16&-16;p=N_a(n)|0;f[h>>2]=p;f[h+8>>2]=n|-2147483648;n=h+4|0;f[n>>2]=o;q=p;r=h+11|0;s=n}kOa(q,373047,o)|0;b[g>>0]=0;ZOa(q+o|0,g);o=d+4|0;n=d+36|0;p=d+12|0;m=g+11|0;t=g+4|0;v=d+40|0;w=a+1|0;b:while(1){if((b[w>>0]|0)==69)break;if(b[k>>0]|0){f[i>>2]=f[p>>2];x=f[n>>2]|0;if(x>>>0<(f[v>>2]|0)>>>0){P0a(g,i);f[x>>2]=0;f[x+4>>2]=0;y=f[g>>2]|0;f[x+8>>2]=0;f[x+12>>2]=y;f[n>>2]=(f[n>>2]|0)+16}else Q0a(l,i)}y=((f[o>>2]|0)-(f[d>>2]|0)|0)/24|0;x=R0a(w,c,d)|0;z=((f[o>>2]|0)-(f[d>>2]|0)|0)/24|0;c:do if(b[k>>0]|0){A=f[n>>2]|0;B=A+-16|0;C=A;while(1){if((C|0)==(B|0))break c;A=C+-16|0;f[n>>2]=A;G_a(A);C=f[n>>2]|0}}while(0);if((x|0)==(w|0)|(x|0)==(c|0)){D=53;break}d:do if(!(b[k>>0]|0))E=y;else{C=f[n>>2]|0;B=f[p>>2]|0;f[g>>2]=B;A=C+-12|0;F=f[A>>2]|0;if(F>>>0<(f[C+-8>>2]|0)>>>0){f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=B;f[A>>2]=(f[A>>2]|0)+16}else W_a(C+-16|0,g);C=y;while(1){if(C>>>0>=z>>>0){E=y;break d}A=f[(f[n>>2]|0)+-12>>2]|0;B=(f[d>>2]|0)+(C*24|0)|0;F=A+-12|0;G=f[F>>2]|0;if((G|0)==(f[A+-8>>2]|0))__a(A+-16|0,B);else{Z_a(G,B);f[F>>2]=(f[F>>2]|0)+24}C=C+1|0}}while(0);while(1){if(E>>>0>=z>>>0){H=z;break}C=b[r>>0]|0;if((C<<24>>24<0?f[s>>2]|0:C&255)>>>0>1)Y_a(h,373235)|0;k$a(g,(f[d>>2]|0)+(E*24|0)|0);C=b[m>>0]|0;F=C<<24>>24<0;C_a(h,F?f[g>>2]|0:g,F?f[t>>2]|0:C&255)|0;Q_a(g);E=E+1|0}while(1){if((H|0)==(y|0)){w=x;continue b}z=f[o>>2]|0;C=z+-24|0;F=z;while(1){if((F|0)==(C|0))break;z=F+-24|0;f[o>>2]=z;z_a(z);F=f[o>>2]|0}H=H+-1|0}}if((D|0)==53){Q_a(h);I=a;break}t=w+1|0;m=b[r>>0]|0;n=m<<24>>24<0;if((b[(n?f[h>>2]|0:h)+(n?f[s>>2]|0:m&255)+-1>>0]|0)==62)Y_a(h,374426)|0;else Y_a(h,373049)|0;f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];f[j+8>>2]=f[h+8>>2];m=0;while(1){if((m|0)==3)break;f[h+(m<<2)>>2]=0;m=m+1|0}n$a(g,j);m=f[o>>2]|0;if(m>>>0<(f[d+8>>2]|0)>>>0){p$a(m,g);f[o>>2]=(f[o>>2]|0)+24}else q$a(d,g);z_a(g);Q_a(j);Q_a(h);I=t}else I=a;while(0);u=e;return I|0}function k$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=c+12|0;e=b[d+11>>0]|0;g=e<<24>>24<0;C_a(c,g?f[d>>2]|0:d,g?f[c+16>>2]|0:e&255)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];a=0;while(1){if((a|0)==3)break;f[c+(a<<2)>>2]=0;a=a+1|0}return}function l$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+48|0;g=e+24|0;h=e+12|0;i=e;a:do if(((a|0)!=(c|0)?(j=(b[a>>0]|0)+-48|0,j>>>0<10):0)?(k=a+1|0,(k|0)!=(c|0)):0){l=k;k=j;while(1){j=(b[l>>0]|0)+-48|0;if(j>>>0>=10)break;m=l+1|0;if((m|0)==(c|0)){n=a;break a}l=m;k=j+(k*10|0)|0}if((c-l|0)>>>0>=k>>>0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(k>>>0>4294967279)WYa(h);if(k>>>0<11){b[h+11>>0]=k;o=h}else{j=k+16&-16;m=N_a(j)|0;f[h>>2]=m;f[h+8>>2]=j|-2147483648;f[h+4>>2]=k;o=m}kOa(o,l,k)|0;b[g>>0]=0;ZOa(o+k|0,g);f$a(g,h,10);m=YOa(374393)|0;j=b[g+11>>0]|0;if((m|0)==((j<<24>>24<0?f[g+4>>2]|0:j&255)|0))p=(g$a(g,374393,m)|0)==0;else p=0;Q_a(g);if(p){O0a(g);m=d+4|0;j=f[m>>2]|0;if(j>>>0<(f[d+8>>2]|0)>>>0){p$a(j,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g)}else{f[i>>2]=f[h>>2];f[i+4>>2]=f[h+4>>2];f[i+8>>2]=f[h+8>>2];m=0;while(1){if((m|0)==3)break;f[h+(m<<2)>>2]=0;m=m+1|0}n$a(g,i);m=d+4|0;j=f[m>>2]|0;if(j>>>0<(f[d+8>>2]|0)>>>0){p$a(j,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);Q_a(i)}Q_a(h);n=l+k|0}else n=a}else n=a;while(0);u=e;return n|0}function m$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=0;while(1){if((h|0)==3)break;f[a+(h<<2)>>2]=0;h=h+1|0}h=c+11|0;i=b[h>>0]|0;j=i<<24>>24<0?f[c+4>>2]|0:i&255;i=YOa(d)|0;k=(b[h>>0]|0)<0?f[c>>2]|0:c;c=j+i|0;if(c>>>0>4294967279)WYa(a);if(c>>>0<11){b[a+11>>0]=j;l=a}else{h=c+16&-16;c=N_a(h)|0;f[a>>2]=c;f[a+8>>2]=h|-2147483648;f[a+4>>2]=j;l=c}kOa(l,k,j)|0;b[g>>0]=0;ZOa(l+j|0,g);C_a(a,d,i)|0;u=e;return}function n$a(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];c=0;while(1){if((c|0)==3)break;f[b+(c<<2)>>2]=0;c=c+1|0}c=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[c+(a<<2)>>2]=0;a=a+1|0}return}function o$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=a+11|0;if((b[g>>0]|0)<0){h=f[a>>2]|0;b[e>>0]=0;ZOa(h,e);f[a+4>>2]=0}else{b[e>>0]=0;ZOa(a,e);b[g>>0]=0}x$a(a);f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];g=0;while(1){if((g|0)==3)break;f[c+(g<<2)>>2]=0;g=g+1|0}g=a+12|0;h=c+12|0;c=g+11|0;if((b[c>>0]|0)<0){i=f[g>>2]|0;b[e>>0]=0;ZOa(i,e);f[a+16>>2]=0}else{b[e>>0]=0;ZOa(g,e);b[c>>0]=0}x$a(g);f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];f[g+8>>2]=f[h+8>>2];g=0;while(1){if((g|0)==3)break;f[h+(g<<2)>>2]=0;g=g+1|0}u=d;return}function p$a(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];c=0;while(1){if((c|0)==3)break;f[b+(c<<2)>>2]=0;c=c+1|0}c=a+12|0;a=b+12|0;f[c>>2]=f[a>>2];f[c+4>>2]=f[a+4>>2];f[c+8>>2]=f[a+8>>2];c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}return}function q$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+32|0;d=c;e=a+4|0;g=(((f[e>>2]|0)-(f[a>>2]|0)|0)/24|0)+1|0;h=x0a(a)|0;if(h>>>0<g>>>0)gXa(a);else{i=f[a>>2]|0;j=((f[a+8>>2]|0)-i|0)/24|0;k=j<<1;y0a(d,j>>>0<h>>>1>>>0?(k>>>0<g>>>0?g:k):h,((f[e>>2]|0)-i|0)/24|0,a+12|0);i=d+8|0;e=f[i>>2]|0;p$a(e,b);f[i>>2]=e+24;z0a(a,d);A0a(d);u=c;return}}function r$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+32|0;g=e+8|0;h=e;a:do if((c-a|0)>1){i=(b[a>>0]|0)==76?a+1|0:a;switch(b[i>>0]|0){case 78:{j=J0a(i,c,d)|0;k=(j|0)==(i|0)?a:j;break a;break}case 90:{j=K0a(i,c,d)|0;k=(j|0)==(i|0)?a:j;break a;break}default:{j=L0a(i,c,d)|0;if((j|0)==(i|0)){l=s$a(i,c,d)|0;if((l|0)==(i|0)|(l|0)==(c|0)){k=a;break a}if((b[l>>0]|0)!=73){k=a;break a}i=j$a(l,c,d)|0;if((i|0)==(l|0)){k=a;break a}l=d+4|0;m=f[l>>2]|0;if(((m-(f[d>>2]|0)|0)/24|0)>>>0<2){k=a;break a}k$a(g,m+-24|0);m=f[l>>2]|0;n=m+-24|0;o=m;while(1){if((o|0)==(n|0))break;p=o+-24|0;f[l>>2]=p;z_a(p);o=f[l>>2]|0}l=b[g+11>>0]|0;o=l<<24>>24<0;C_a(m+-48|0,o?f[g>>2]|0:g,o?f[g+4>>2]|0:l&255)|0;Q_a(g);k=i;break a}if((j|0)==(c|0)){k=c;break a}if((b[j>>0]|0)!=73){k=j;break a}l=d+4|0;o=f[l>>2]|0;if((f[d>>2]|0)==(o|0)){k=a;break a}f[h>>2]=f[d+12>>2];b$a(g,o+-24|0,h);o=d+20|0;n=f[o>>2]|0;if(n>>>0<(f[d+24>>2]|0)>>>0){f[n>>2]=0;p=n+4|0;f[p>>2]=0;q=f[g+12>>2]|0;f[n+8>>2]=0;f[n+12>>2]=q;f[n>>2]=f[g>>2];q=g+4|0;f[p>>2]=f[q>>2];p=g+8|0;f[n+8>>2]=f[p>>2];f[p>>2]=0;f[q>>2]=0;f[g>>2]=0;f[o>>2]=(f[o>>2]|0)+16}else c$a(d+16|0,g);A_a(g);o=j$a(j,c,d)|0;if((o|0)==(j|0)){k=a;break a}q=f[l>>2]|0;if(((q-(f[d>>2]|0)|0)/24|0)>>>0<2){k=a;break a}k$a(g,q+-24|0);q=f[l>>2]|0;p=q+-24|0;n=q;while(1){if((n|0)==(p|0))break;r=n+-24|0;f[l>>2]=r;z_a(r);n=f[l>>2]|0}l=b[g+11>>0]|0;n=l<<24>>24<0;C_a(q+-48|0,n?f[g>>2]|0:g,n?f[g+4>>2]|0:l&255)|0;Q_a(g);k=o;break a}}}else k=a;while(0);u=e;return k|0}function s$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+32|0;g=e;a:do if((c-a|0)>1?(b[a>>0]|0)==83:0){h=b[a+1>>0]|0;i=a+2|0;j=d+16|0;switch(h|0){case 97:{m0a(g,374339);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){p$a(l,g);f[k>>2]=(f[k>>2]|0)+24}else q$a(d,g);z_a(g);m=i;break a;break}case 98:{j0a(g,374354);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){p$a(l,g);f[k>>2]=(f[k>>2]|0)+24}else q$a(d,g);z_a(g);m=i;break a;break}case 115:{l0a(g,373833);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){p$a(l,g);f[k>>2]=(f[k>>2]|0)+24}else q$a(d,g);z_a(g);m=i;break a;break}case 105:{n0a(g,373929);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){p$a(l,g);f[k>>2]=(f[k>>2]|0)+24}else q$a(d,g);z_a(g);m=i;break a;break}case 111:{n0a(g,374006);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){p$a(l,g);f[k>>2]=(f[k>>2]|0)+24}else q$a(d,g);z_a(g);m=i;break a;break}case 100:{I0a(g,374083);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){p$a(l,g);f[k>>2]=(f[k>>2]|0)+24}else q$a(d,g);z_a(g);m=i;break a;break}case 95:{k=f[j>>2]|0;if((k|0)==(f[d+20>>2]|0)){m=a;break a}l=f[k+4>>2]|0;n=d+4|0;o=d+8|0;p=f[k>>2]|0;while(1){if((p|0)==(l|0)){m=i;break a}k=f[n>>2]|0;if((k|0)==(f[o>>2]|0))__a(d,p);else{Z_a(k,p);f[n>>2]=(f[n>>2]|0)+24}p=p+24|0}break}default:{p=(h+-48|0)>>>0<10;if(!p?(PKa(h)|0)==0:0){m=a;break a}n=(p?-48:-55)+h|0;p=i;while(1){q=p+1|0;if((p|0)==(c|0)){m=a;break a}r=b[p>>0]|0;o=r<<24>>24;l=(o+-48|0)>>>0<10;if(!l?(PKa(o)|0)==0:0)break;n=o+(n*36|0)+(l?-48:-55)|0;p=q}if(r<<24>>24!=95){m=a;break a}p=n+1|0;i=f[j>>2]|0;h=i;if(p>>>0>=(f[d+20>>2]|0)-i>>4>>>0){m=a;break a}i=f[h+(p<<4)+4>>2]|0;l=d+4|0;o=d+8|0;k=f[h+(p<<4)>>2]|0;while(1){if((k|0)==(i|0)){m=q;break a}p=f[l>>2]|0;if((p|0)==(f[o>>2]|0))__a(d,k);else{Z_a(p,k);f[l>>2]=(f[l>>2]|0)+24}k=k+24|0}}}}else m=a;while(0);u=e;return m|0}function t$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+64|0;g=e+40|0;h=e+12|0;i=e+24|0;j=e;a:do if((c-a|0)>3?(b[a>>0]|0)==68:0){switch(b[a+1>>0]|0){case 84:case 116:break;default:{k=a;break a}}l=a+2|0;m=w$a(l,c,d)|0;if((!((m|0)==(l|0)|(m|0)==(c|0))?(b[m>>0]|0)==69:0)?(l=d+4|0,n=f[l>>2]|0,(f[d>>2]|0)!=(n|0)):0){k$a(j,n+-24|0);X_a(j,0,374329)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];n=0;while(1){if((n|0)==3)break;f[j+(n<<2)>>2]=0;n=n+1|0}Y_a(i,373011)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];n=0;while(1){if((n|0)==3)break;f[i+(n<<2)>>2]=0;n=n+1|0}n$a(g,h);o$a((f[l>>2]|0)+-24|0,g);z_a(g);Q_a(h);Q_a(i);Q_a(j);k=m+1|0}else k=a}else k=a;while(0);u=e;return k|0}function u$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+80|0;g=e+60|0;h=e+24|0;i=e+12|0;j=e;k=e+48|0;a:do if(((c-a|0)>3?(b[a>>0]|0)==68:0)?(b[a+1>>0]|0)==118:0){l=a+2|0;m=b[l>>0]|0;if((m+-49&255)>=9){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;n=0;while(1){if((n|0)==3)break;f[h+(n<<2)>>2]=0;n=n+1|0}b:do if(m<<24>>24!=95?(n=w$a(l,c,d)|0,(n|0)!=(l|0)):0){o=d+4|0;p=f[o>>2]|0;if((f[d>>2]|0)!=(p|0)){k$a(i,p+-24|0);p=h+11|0;if((b[p>>0]|0)<0){q=f[h>>2]|0;b[g>>0]=0;ZOa(q,g);f[h+4>>2]=0}else{b[g>>0]=0;ZOa(h,g);b[p>>0]=0}x$a(h);f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];p=0;while(1){if((p|0)==3)break;f[i+(p<<2)>>2]=0;p=p+1|0}Q_a(i);p=f[o>>2]|0;q=p+-24|0;r=p;while(1){if((r|0)==(q|0)){s=n;t=53;break b}p=r+-24|0;f[o>>2]=p;z_a(p);r=f[o>>2]|0}}}else{s=l;t=53}while(0);do if((t|0)==53){if((((s|0)!=(c|0)?(b[s>>0]|0)==95:0)?(m=s+1|0,(m|0)!=(c|0)):0)?(o=U_a(m,c,d)|0,(o|0)!=(m|0)):0){m=d+4|0;if((f[d>>2]|0)==(f[m>>2]|0))break;y$a(i,373051,h);Y_a(i,373060)|0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];f[g+8>>2]=f[i+8>>2];r=0;while(1){if((r|0)==3)break;f[i+(r<<2)>>2]=0;r=r+1|0}r=b[g+11>>0]|0;n=r<<24>>24<0;C_a((f[m>>2]|0)+-24|0,n?f[g>>2]|0:g,n?f[g+4>>2]|0:r&255)|0;Q_a(g);Q_a(i);v=o}else v=a;Q_a(h);w=v;break a}while(0);Q_a(h);w=a;break}r=v$a(l,c)|0;if(((r|0)!=(c|0)?(b[r>>0]|0)==95:0)?(n=r-l|0,q=r+1|0,(q|0)!=(c|0)):0){if((b[q>>0]|0)!=112){p=U_a(q,c,d)|0;if((p|0)==(q|0)){w=a;break}q=d+4|0;if((f[d>>2]|0)==(f[q>>2]|0)){w=a;break};f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(n>>>0>4294967279)WYa(j);if(n>>>0<11){b[j+11>>0]=n;x=j}else{y=n+16&-16;z=N_a(y)|0;f[j>>2]=z;f[j+8>>2]=y|-2147483648;f[j+4>>2]=n;x=z}kOa(x,l,n)|0;b[g>>0]=0;ZOa(x+n|0,g);X_a(j,0,373051)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];z=0;while(1){if((z|0)==3)break;f[j+(z<<2)>>2]=0;z=z+1|0}Y_a(i,373060)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];z=0;while(1){if((z|0)==3)break;f[i+(z<<2)>>2]=0;z=z+1|0}z=b[h+11>>0]|0;y=z<<24>>24<0;C_a((f[q>>2]|0)+-24|0,y?f[h>>2]|0:h,y?f[h+4>>2]|0:z&255)|0;Q_a(h);Q_a(i);Q_a(j);w=p;break}z=r+2|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(n>>>0>4294967279)WYa(j);if(n>>>0<11){b[j+11>>0]=n;A=j}else{y=n+16&-16;B=N_a(y)|0;f[j>>2]=B;f[j+8>>2]=y|-2147483648;f[j+4>>2]=n;A=B}kOa(A,l,n)|0;b[g>>0]=0;ZOa(A+n|0,g);X_a(j,0,373062)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];B=0;while(1){if((B|0)==3)break;f[j+(B<<2)>>2]=0;B=B+1|0}Y_a(i,373060)|0;f[k>>2]=f[i>>2];f[k+4>>2]=f[i+4>>2];f[k+8>>2]=f[i+8>>2];B=0;while(1){if((B|0)==3)break;f[i+(B<<2)>>2]=0;B=B+1|0}n$a(h,k);B=d+4|0;n=f[B>>2]|0;if(n>>>0<(f[d+8>>2]|0)>>>0){p$a(n,h);f[B>>2]=(f[B>>2]|0)+24}else q$a(d,h);z_a(h);Q_a(k);Q_a(i);Q_a(j);w=z}else w=a}else w=a;while(0);u=e;return w|0}function v$a(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0;a:do if((a|0)!=(c|0)?(d=(b[a>>0]|0)==110?a+1|0:a,(d|0)!=(c|0)):0){e=b[d>>0]|0;f=d+1|0;if(e<<24>>24!=48)if((e+-49&255)<9){e=f;while(1){if((e|0)==(c|0)){g=c;break a}if(((b[e>>0]|0)+-48|0)>>>0>=10){g=e;break a}e=e+1|0}}else g=a;else g=f}else g=a;while(0);return g|0}function w$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;e=u;u=u+208|0;g=e+176|0;h=e+112|0;i=e+88|0;j=e+64|0;k=e+48|0;l=e+160|0;m=e+36|0;n=e+148|0;o=e+136|0;p=e+124|0;q=e+24|0;r=e+12|0;s=e;t=c;v=t-a|0;a:do if((v|0)>1){w=a+2|0;if((v|0)>3?(b[a>>0]|0)==103:0){x=(b[a+1>>0]|0)==115;y=x;z=x?w:a}else{y=0;z=a}x=z+1|0;A=a+3|0;B=(w|0)!=(c|0);C=z+2|0;do switch(b[z>>0]|0){case 76:{D=z$a(a,c,d)|0;break a;break}case 84:{D=i$a(a,c,d)|0;break a;break}case 102:{D=A$a(a,c,d)|0;break a;break}case 97:{switch(b[x>>0]|0){case 97:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=YOa(373015)|0;if(E>>>0>4294967279)WYa(h);if(E>>>0<11){b[h+11>>0]=E;F=h}else{G=E+16&-16;H=N_a(G)|0;f[h>>2]=H;f[h+8>>2]=G|-2147483648;f[h+4>>2]=E;F=H}kOa(F,373015,E)|0;b[g>>0]=0;ZOa(F+E|0,g);E=B$a(w,c,h,d)|0;Q_a(h);D=(E|0)==(w|0)?a:E;break a;break}case 100:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=YOa(373033)|0;if(E>>>0>4294967279)WYa(h);if(E>>>0<11){b[h+11>>0]=E;I=h}else{H=E+16&-16;G=N_a(H)|0;f[h>>2]=G;f[h+8>>2]=H|-2147483648;f[h+4>>2]=E;I=G}kOa(I,373033,E)|0;b[g>>0]=0;ZOa(I+E|0,g);E=C$a(w,c,h,d)|0;Q_a(h);D=(E|0)==(w|0)?a:E;break a;break}case 110:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=YOa(373033)|0;if(E>>>0>4294967279)WYa(h);if(E>>>0<11){b[h+11>>0]=E;J=h}else{G=E+16&-16;H=N_a(G)|0;f[h>>2]=H;f[h+8>>2]=G|-2147483648;f[h+4>>2]=E;J=H}kOa(J,373033,E)|0;b[g>>0]=0;ZOa(J+E|0,g);E=B$a(w,c,h,d)|0;Q_a(h);D=(E|0)==(w|0)?a:E;break a;break}case 78:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=YOa(373076)|0;if(E>>>0>4294967279)WYa(h);if(E>>>0<11){b[h+11>>0]=E;K=h}else{H=E+16&-16;G=N_a(H)|0;f[h>>2]=G;f[h+8>>2]=H|-2147483648;f[h+4>>2]=E;K=G}kOa(K,373076,E)|0;b[g>>0]=0;ZOa(K+E|0,g);E=B$a(w,c,h,d)|0;Q_a(h);D=(E|0)==(w|0)?a:E;break a;break}case 83:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=YOa(373079)|0;if(E>>>0>4294967279)WYa(h);if(E>>>0<11){b[h+11>>0]=E;L=h}else{G=E+16&-16;H=N_a(G)|0;f[h>>2]=H;f[h+8>>2]=G|-2147483648;f[h+4>>2]=E;L=H}kOa(L,373079,E)|0;b[g>>0]=0;ZOa(L+E|0,g);E=B$a(w,c,h,d)|0;Q_a(h);D=(E|0)==(w|0)?a:E;break a;break}case 116:{D=D$a(a,c,d)|0;break a;break}case 122:{D=E$a(a,c,d)|0;break a;break}default:{D=a;break a}}break}case 99:{switch(b[x>>0]|0){case 99:{D=F$a(a,c,d)|0;break a;break}case 108:{D=G$a(a,c,d)|0;break a;break}case 109:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=YOa(373081)|0;if(E>>>0>4294967279)WYa(h);if(E>>>0<11){b[h+11>>0]=E;M=h}else{H=E+16&-16;G=N_a(H)|0;f[h>>2]=G;f[h+8>>2]=H|-2147483648;f[h+4>>2]=E;M=G}kOa(M,373081,E)|0;b[g>>0]=0;ZOa(M+E|0,g);E=B$a(w,c,h,d)|0;Q_a(h);D=(E|0)==(w|0)?a:E;break a;break}case 111:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=YOa(373083)|0;if(E>>>0>4294967279)WYa(h);if(E>>>0<11){b[h+11>>0]=E;N=h}else{G=E+16&-16;H=N_a(G)|0;f[h>>2]=H;f[h+8>>2]=G|-2147483648;f[h+4>>2]=E;N=H}kOa(N,373083,E)|0;b[g>>0]=0;ZOa(N+E|0,g);E=C$a(w,c,h,d)|0;Q_a(h);D=(E|0)==(w|0)?a:E;break a;break}case 118:{D=H$a(a,c,d)|0;break a;break}default:{D=a;break a}}break}case 100:{switch(b[x>>0]|0){case 97:{E=w$a(C,c,d)|0;if((E|0)==(C|0)){D=a;break a}H=d+4|0;if((f[d>>2]|0)==(f[H>>2]|0)){D=a;break a};f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;b:do if(y){G=YOa(373085)|0;if(G>>>0>4294967279)WYa(j);if(G>>>0<11){b[j+11>>0]=G;O=j}else{P=G+16&-16;Q=N_a(P)|0;f[j>>2]=Q;f[j+8>>2]=P|-2147483648;f[j+4>>2]=G;O=Q}kOa(O,373085,G)|0;b[g>>0]=0;ZOa(O+G|0,g)}else{G=0;while(1){if((G|0)==3)break b;f[j+(G<<2)>>2]=0;G=G+1|0}}while(0);Y_a(j,373088)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];G=0;while(1){if((G|0)==3)break;f[j+(G<<2)>>2]=0;G=G+1|0}k$a(k,(f[H>>2]|0)+-24|0);G=b[k+11>>0]|0;Q=G<<24>>24<0;C_a(i,Q?f[k>>2]|0:k,Q?f[k+4>>2]|0:G&255)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];G=0;while(1){if((G|0)==3)break;f[i+(G<<2)>>2]=0;G=G+1|0}G=f[H>>2]|0;Q=G+-24|0;P=Q+11|0;if((b[P>>0]|0)<0){R=f[Q>>2]|0;b[g>>0]=0;ZOa(R,g);f[G+-20>>2]=0}else{b[g>>0]=0;ZOa(Q,g);b[P>>0]=0}x$a(Q);f[Q>>2]=f[h>>2];f[Q+4>>2]=f[h+4>>2];f[Q+8>>2]=f[h+8>>2];Q=0;while(1){if((Q|0)==3)break;f[h+(Q<<2)>>2]=0;Q=Q+1|0}Q_a(h);Q_a(k);Q_a(i);Q_a(j);D=E;break a;break}case 99:{D=I$a(a,c,d)|0;break a;break}case 101:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=YOa(373031)|0;if(Q>>>0>4294967279)WYa(h);if(Q>>>0<11){b[h+11>>0]=Q;S=h}else{H=Q+16&-16;P=N_a(H)|0;f[h>>2]=P;f[h+8>>2]=H|-2147483648;f[h+4>>2]=Q;S=P}kOa(S,373031,Q)|0;b[g>>0]=0;ZOa(S+Q|0,g);Q=C$a(w,c,h,d)|0;Q_a(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 108:{Q=w$a(C,c,d)|0;if((Q|0)==(C|0)){D=a;break a}P=d+4|0;if((f[d>>2]|0)==(f[P>>2]|0)){D=a;break a};f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;c:do if(y){H=YOa(373085)|0;if(H>>>0>4294967279)WYa(j);if(H>>>0<11){b[j+11>>0]=H;T=j}else{G=H+16&-16;R=N_a(G)|0;f[j>>2]=R;f[j+8>>2]=G|-2147483648;f[j+4>>2]=H;T=R}kOa(T,373085,H)|0;b[g>>0]=0;ZOa(T+H|0,g)}else{H=0;while(1){if((H|0)==3)break c;f[j+(H<<2)>>2]=0;H=H+1|0}}while(0);Y_a(j,373098)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];E=0;while(1){if((E|0)==3)break;f[j+(E<<2)>>2]=0;E=E+1|0}k$a(k,(f[P>>2]|0)+-24|0);E=b[k+11>>0]|0;H=E<<24>>24<0;C_a(i,H?f[k>>2]|0:k,H?f[k+4>>2]|0:E&255)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];E=0;while(1){if((E|0)==3)break;f[i+(E<<2)>>2]=0;E=E+1|0}E=f[P>>2]|0;H=E+-24|0;R=H+11|0;if((b[R>>0]|0)<0){G=f[H>>2]|0;b[g>>0]=0;ZOa(G,g);f[E+-20>>2]=0}else{b[g>>0]=0;ZOa(H,g);b[R>>0]=0}x$a(H);f[H>>2]=f[h>>2];f[H+4>>2]=f[h+4>>2];f[H+8>>2]=f[h+8>>2];H=0;while(1){if((H|0)==3)break;f[h+(H<<2)>>2]=0;H=H+1|0}Q_a(h);Q_a(k);Q_a(i);Q_a(j);D=Q;break a;break}case 110:{D=J$a(a,c,d)|0;break a;break}case 115:{D=K$a(a,c,d)|0;break a;break}case 116:{D=L$a(a,c,d)|0;break a;break}case 118:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=YOa(373106)|0;if(H>>>0>4294967279)WYa(h);if(H>>>0<11){b[h+11>>0]=H;U=h}else{P=H+16&-16;R=N_a(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=H;U=R}kOa(U,373106,H)|0;b[g>>0]=0;ZOa(U+H|0,g);H=B$a(w,c,h,d)|0;Q_a(h);D=(H|0)==(w|0)?a:H;break a;break}case 86:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=YOa(373108)|0;if(H>>>0>4294967279)WYa(h);if(H>>>0<11){b[h+11>>0]=H;V=h}else{R=H+16&-16;P=N_a(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=H;V=P}kOa(V,373108,H)|0;b[g>>0]=0;ZOa(V+H|0,g);H=B$a(w,c,h,d)|0;Q_a(h);D=(H|0)==(w|0)?a:H;break a;break}default:{D=a;break a}}break}case 101:{switch(b[x>>0]|0){case 111:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=YOa(373111)|0;if(H>>>0>4294967279)WYa(h);if(H>>>0<11){b[h+11>>0]=H;W=h}else{P=H+16&-16;R=N_a(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=H;W=R}kOa(W,373111,H)|0;b[g>>0]=0;ZOa(W+H|0,g);H=B$a(w,c,h,d)|0;Q_a(h);D=(H|0)==(w|0)?a:H;break a;break}case 79:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=YOa(373113)|0;if(H>>>0>4294967279)WYa(h);if(H>>>0<11){b[h+11>>0]=H;X=h}else{R=H+16&-16;P=N_a(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=H;X=P}kOa(X,373113,H)|0;b[g>>0]=0;ZOa(X+H|0,g);H=B$a(w,c,h,d)|0;Q_a(h);D=(H|0)==(w|0)?a:H;break a;break}case 113:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=YOa(373116)|0;if(H>>>0>4294967279)WYa(h);if(H>>>0<11){b[h+11>>0]=H;Y=h}else{P=H+16&-16;R=N_a(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=H;Y=R}kOa(Y,373116,H)|0;b[g>>0]=0;ZOa(Y+H|0,g);H=B$a(w,c,h,d)|0;Q_a(h);D=(H|0)==(w|0)?a:H;break a;break}default:{D=a;break a}}break}case 103:{switch(b[x>>0]|0){case 101:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=YOa(373119)|0;if(H>>>0>4294967279)WYa(h);if(H>>>0<11){b[h+11>>0]=H;Z=h}else{R=H+16&-16;P=N_a(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=H;Z=P}kOa(Z,373119,H)|0;b[g>>0]=0;ZOa(Z+H|0,g);H=B$a(w,c,h,d)|0;Q_a(h);D=(H|0)==(w|0)?a:H;break a;break}case 116:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=YOa(373049)|0;if(H>>>0>4294967279)WYa(h);if(H>>>0<11){b[h+11>>0]=H;_=h}else{P=H+16&-16;R=N_a(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=H;_=R}kOa(_,373049,H)|0;b[g>>0]=0;ZOa(_+H|0,g);H=B$a(w,c,h,d)|0;Q_a(h);D=(H|0)==(w|0)?a:H;break a;break}default:{D=a;break a}}break}case 105:{if((b[x>>0]|0)!=120){D=a;break a}H=w$a(w,c,d)|0;if((H|0)==(w|0)){D=a;break a}R=w$a(H,c,d)|0;P=d+4|0;if((R|0)==(H|0)){H=f[P>>2]|0;E=H+-24|0;G=H;while(1){if((G|0)==(E|0)){D=a;break a}H=G+-24|0;f[P>>2]=H;z_a(H);G=f[P>>2]|0}}G=f[P>>2]|0;if(((G-(f[d>>2]|0)|0)/24|0)>>>0<2){D=a;break a}k$a(g,G+-24|0);G=f[P>>2]|0;E=G+-24|0;Q=G;while(1){if((Q|0)==(E|0))break;H=Q+-24|0;f[P>>2]=H;z_a(H);Q=f[P>>2]|0}k$a(h,G+-48|0);y$a(m,373013,h);Y_a(m,373122)|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2];f[k+8>>2]=f[m+8>>2];Q=0;while(1){if((Q|0)==3)break;f[m+(Q<<2)>>2]=0;Q=Q+1|0}Q=b[g+11>>0]|0;G=Q<<24>>24<0;C_a(k,G?f[g>>2]|0:g,G?f[g+4>>2]|0:Q&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];Q=0;while(1){if((Q|0)==3)break;f[k+(Q<<2)>>2]=0;Q=Q+1|0}Y_a(j,373060)|0;f[l>>2]=f[j>>2];f[l+4>>2]=f[j+4>>2];f[l+8>>2]=f[j+8>>2];Q=0;while(1){if((Q|0)==3)break;f[j+(Q<<2)>>2]=0;Q=Q+1|0}n$a(i,l);o$a((f[P>>2]|0)+-24|0,i);z_a(i);Q_a(l);Q_a(j);Q_a(k);Q_a(m);Q_a(h);Q_a(g);D=R;break a;break}case 108:{switch(b[x>>0]|0){case 101:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=YOa(373125)|0;if(Q>>>0>4294967279)WYa(h);if(Q>>>0<11){b[h+11>>0]=Q;$=h}else{G=Q+16&-16;E=N_a(G)|0;f[h>>2]=E;f[h+8>>2]=G|-2147483648;f[h+4>>2]=Q;$=E}kOa($,373125,Q)|0;b[g>>0]=0;ZOa($+Q|0,g);Q=B$a(w,c,h,d)|0;Q_a(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 115:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=YOa(373128)|0;if(Q>>>0>4294967279)WYa(h);if(Q>>>0<11){b[h+11>>0]=Q;aa=h}else{E=Q+16&-16;G=N_a(E)|0;f[h>>2]=G;f[h+8>>2]=E|-2147483648;f[h+4>>2]=Q;aa=G}kOa(aa,373128,Q)|0;b[g>>0]=0;ZOa(aa+Q|0,g);Q=B$a(w,c,h,d)|0;Q_a(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 83:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=YOa(373131)|0;if(Q>>>0>4294967279)WYa(h);if(Q>>>0<11){b[h+11>>0]=Q;ba=h}else{G=Q+16&-16;E=N_a(G)|0;f[h>>2]=E;f[h+8>>2]=G|-2147483648;f[h+4>>2]=Q;ba=E}kOa(ba,373131,Q)|0;b[g>>0]=0;ZOa(ba+Q|0,g);Q=B$a(w,c,h,d)|0;Q_a(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 116:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=YOa(373047)|0;if(Q>>>0>4294967279)WYa(h);if(Q>>>0<11){b[h+11>>0]=Q;ca=h}else{E=Q+16&-16;G=N_a(E)|0;f[h>>2]=G;f[h+8>>2]=E|-2147483648;f[h+4>>2]=Q;ca=G}kOa(ca,373047,Q)|0;b[g>>0]=0;ZOa(ca+Q|0,g);Q=B$a(w,c,h,d)|0;Q_a(h);D=(Q|0)==(w|0)?a:Q;break a;break}default:{D=a;break a}}break}case 109:{switch(b[x>>0]|0){case 105:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=YOa(373135)|0;if(Q>>>0>4294967279)WYa(h);if(Q>>>0<11){b[h+11>>0]=Q;da=h}else{G=Q+16&-16;E=N_a(G)|0;f[h>>2]=E;f[h+8>>2]=G|-2147483648;f[h+4>>2]=Q;da=E}kOa(da,373135,Q)|0;b[g>>0]=0;ZOa(da+Q|0,g);Q=B$a(w,c,h,d)|0;Q_a(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 73:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=YOa(373137)|0;if(Q>>>0>4294967279)WYa(h);if(Q>>>0<11){b[h+11>>0]=Q;ea=h}else{E=Q+16&-16;G=N_a(E)|0;f[h>>2]=G;f[h+8>>2]=E|-2147483648;f[h+4>>2]=Q;ea=G}kOa(ea,373137,Q)|0;b[g>>0]=0;ZOa(ea+Q|0,g);Q=B$a(w,c,h,d)|0;Q_a(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 108:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=YOa(373031)|0;if(Q>>>0>4294967279)WYa(h);if(Q>>>0<11){b[h+11>>0]=Q;fa=h}else{G=Q+16&-16;E=N_a(G)|0;f[h>>2]=E;f[h+8>>2]=G|-2147483648;f[h+4>>2]=Q;fa=E}kOa(fa,373031,Q)|0;b[g>>0]=0;ZOa(fa+Q|0,g);Q=B$a(w,c,h,d)|0;Q_a(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 76:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=YOa(373140)|0;if(Q>>>0>4294967279)WYa(h);if(Q>>>0<11){b[h+11>>0]=Q;ga=h}else{E=Q+16&-16;G=N_a(E)|0;f[h>>2]=G;f[h+8>>2]=E|-2147483648;f[h+4>>2]=Q;ga=G}kOa(ga,373140,Q)|0;b[g>>0]=0;ZOa(ga+Q|0,g);Q=B$a(w,c,h,d)|0;Q_a(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 109:{if(B?(b[w>>0]|0)==95:0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=YOa(373143)|0;if(Q>>>0>4294967279)WYa(h);if(Q>>>0<11){b[h+11>>0]=Q;ha=h}else{G=Q+16&-16;E=N_a(G)|0;f[h>>2]=E;f[h+8>>2]=G|-2147483648;f[h+4>>2]=Q;ha=E}kOa(ha,373143,Q)|0;b[g>>0]=0;ZOa(ha+Q|0,g);Q=C$a(A,c,h,d)|0;Q_a(h);D=(Q|0)==(A|0)?a:Q;break a}Q=w$a(w,c,d)|0;if((Q|0)==(w|0)){D=a;break a}E=d+4|0;G=f[E>>2]|0;if((f[d>>2]|0)==(G|0)){D=a;break a}k$a(i,G+-24|0);X_a(i,0,373013)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];G=0;while(1){if((G|0)==3)break;f[i+(G<<2)>>2]=0;G=G+1|0}Y_a(h,373146)|0;f[n>>2]=f[h>>2];f[n+4>>2]=f[h+4>>2];f[n+8>>2]=f[h+8>>2];G=0;while(1){if((G|0)==3)break;f[h+(G<<2)>>2]=0;G=G+1|0}n$a(g,n);o$a((f[E>>2]|0)+-24|0,g);z_a(g);Q_a(n);Q_a(h);Q_a(i);D=Q;break a;break}default:{D=a;break a}}break}case 110:{switch(b[x>>0]|0){case 119:case 97:{D=M$a(a,c,d)|0;break a;break}case 101:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=YOa(373150)|0;if(G>>>0>4294967279)WYa(h);if(G>>>0<11){b[h+11>>0]=G;ia=h}else{R=G+16&-16;P=N_a(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=G;ia=P}kOa(ia,373150,G)|0;b[g>>0]=0;ZOa(ia+G|0,g);G=B$a(w,c,h,d)|0;Q_a(h);D=(G|0)==(w|0)?a:G;break a;break}case 103:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=YOa(373135)|0;if(G>>>0>4294967279)WYa(h);if(G>>>0<11){b[h+11>>0]=G;ja=h}else{P=G+16&-16;R=N_a(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=G;ja=R}kOa(ja,373135,G)|0;b[g>>0]=0;ZOa(ja+G|0,g);G=C$a(w,c,h,d)|0;Q_a(h);D=(G|0)==(w|0)?a:G;break a;break}case 116:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=YOa(373153)|0;if(G>>>0>4294967279)WYa(h);if(G>>>0<11){b[h+11>>0]=G;ka=h}else{R=G+16&-16;P=N_a(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=G;ka=P}kOa(ka,373153,G)|0;b[g>>0]=0;ZOa(ka+G|0,g);G=C$a(w,c,h,d)|0;Q_a(h);D=(G|0)==(w|0)?a:G;break a;break}case 120:{G=N$a(w,c,d)|0;D=(G|0)==(w|0)?a:G;break a;break}default:{D=a;break a}}break}case 111:{switch(b[x>>0]|0){case 110:{D=J$a(a,c,d)|0;break a;break}case 111:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=YOa(373155)|0;if(G>>>0>4294967279)WYa(h);if(G>>>0<11){b[h+11>>0]=G;la=h}else{P=G+16&-16;R=N_a(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=G;la=R}kOa(la,373155,G)|0;b[g>>0]=0;ZOa(la+G|0,g);G=B$a(w,c,h,d)|0;Q_a(h);D=(G|0)==(w|0)?a:G;break a;break}case 114:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=YOa(373158)|0;if(G>>>0>4294967279)WYa(h);if(G>>>0<11){b[h+11>>0]=G;ma=h}else{R=G+16&-16;P=N_a(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=G;ma=P}kOa(ma,373158,G)|0;b[g>>0]=0;ZOa(ma+G|0,g);G=B$a(w,c,h,d)|0;Q_a(h);D=(G|0)==(w|0)?a:G;break a;break}case 82:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=YOa(373160)|0;if(G>>>0>4294967279)WYa(h);if(G>>>0<11){b[h+11>>0]=G;na=h}else{P=G+16&-16;R=N_a(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=G;na=R}kOa(na,373160,G)|0;b[g>>0]=0;ZOa(na+G|0,g);G=B$a(w,c,h,d)|0;Q_a(h);D=(G|0)==(w|0)?a:G;break a;break}default:{D=a;break a}}break}case 112:{switch(b[x>>0]|0){case 109:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=YOa(373163)|0;if(G>>>0>4294967279)WYa(h);if(G>>>0<11){b[h+11>>0]=G;oa=h}else{R=G+16&-16;P=N_a(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=G;oa=P}kOa(oa,373163,G)|0;b[g>>0]=0;ZOa(oa+G|0,g);G=B$a(w,c,h,d)|0;Q_a(h);D=(G|0)==(w|0)?a:G;break a;break}case 108:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=YOa(373167)|0;if(G>>>0>4294967279)WYa(h);if(G>>>0<11){b[h+11>>0]=G;pa=h}else{P=G+16&-16;R=N_a(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=G;pa=R}kOa(pa,373167,G)|0;b[g>>0]=0;ZOa(pa+G|0,g);G=B$a(w,c,h,d)|0;Q_a(h);D=(G|0)==(w|0)?a:G;break a;break}case 76:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=YOa(373169)|0;if(G>>>0>4294967279)WYa(h);if(G>>>0<11){b[h+11>>0]=G;qa=h}else{R=G+16&-16;P=N_a(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=G;qa=P}kOa(qa,373169,G)|0;b[g>>0]=0;ZOa(qa+G|0,g);G=B$a(w,c,h,d)|0;Q_a(h);D=(G|0)==(w|0)?a:G;break a;break}case 112:{if(B?(b[w>>0]|0)==95:0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=YOa(373172)|0;if(G>>>0>4294967279)WYa(h);if(G>>>0<11){b[h+11>>0]=G;ra=h}else{P=G+16&-16;R=N_a(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=G;ra=R}kOa(ra,373172,G)|0;b[g>>0]=0;ZOa(ra+G|0,g);G=C$a(A,c,h,d)|0;Q_a(h);D=(G|0)==(A|0)?a:G;break a}G=w$a(w,c,d)|0;if((G|0)==(w|0)){D=a;break a}R=d+4|0;P=f[R>>2]|0;if((f[d>>2]|0)==(P|0)){D=a;break a}k$a(i,P+-24|0);X_a(i,0,373013)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];P=0;while(1){if((P|0)==3)break;f[i+(P<<2)>>2]=0;P=P+1|0}Y_a(h,373175)|0;f[o>>2]=f[h>>2];f[o+4>>2]=f[h+4>>2];f[o+8>>2]=f[h+8>>2];P=0;while(1){if((P|0)==3)break;f[h+(P<<2)>>2]=0;P=P+1|0}n$a(g,o);o$a((f[R>>2]|0)+-24|0,g);z_a(g);Q_a(o);Q_a(h);Q_a(i);D=G;break a;break}case 115:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;P=YOa(373167)|0;if(P>>>0>4294967279)WYa(h);if(P>>>0<11){b[h+11>>0]=P;sa=h}else{Q=P+16&-16;E=N_a(Q)|0;f[h>>2]=E;f[h+8>>2]=Q|-2147483648;f[h+4>>2]=P;sa=E}kOa(sa,373167,P)|0;b[g>>0]=0;ZOa(sa+P|0,g);P=C$a(w,c,h,d)|0;Q_a(h);D=(P|0)==(w|0)?a:P;break a;break}case 116:{D=O$a(a,c,d)|0;break a;break}default:{D=a;break a}}break}case 113:{if((b[x>>0]|0)!=117){D=a;break a}P=w$a(w,c,d)|0;if((P|0)==(w|0)){D=a;break a}E=w$a(P,c,d)|0;if((E|0)==(P|0)){P=d+4|0;Q=f[P>>2]|0;H=Q+-24|0;ta=Q;while(1){if((ta|0)==(H|0)){D=a;break a}Q=ta+-24|0;f[P>>2]=Q;z_a(Q);ta=f[P>>2]|0}}P=w$a(E,c,d)|0;ta=d+4|0;if((P|0)==(E|0)){H=f[ta>>2]|0;G=H+-24|0;R=H;while(1){if((R|0)==(G|0))break;Q=R+-24|0;f[ta>>2]=Q;z_a(Q);R=f[ta>>2]|0}R=H+-48|0;E=G;while(1){if((E|0)==(R|0)){D=a;break a}Q=E+-24|0;f[ta>>2]=Q;z_a(Q);E=f[ta>>2]|0}}E=f[ta>>2]|0;if(((E-(f[d>>2]|0)|0)/24|0)>>>0<3){D=a;break a}k$a(g,E+-24|0);E=f[ta>>2]|0;R=E+-24|0;G=E;while(1){if((G|0)==(R|0))break;H=G+-24|0;f[ta>>2]=H;z_a(H);G=f[ta>>2]|0}k$a(h,E+-48|0);G=f[ta>>2]|0;R=G+-24|0;H=G;while(1){if((H|0)==(R|0))break;Q=H+-24|0;f[ta>>2]=Q;z_a(Q);H=f[ta>>2]|0}k$a(i,G+-48|0);y$a(s,373013,i);Y_a(s,373179)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];H=0;while(1){if((H|0)==3)break;f[s+(H<<2)>>2]=0;H=H+1|0}H=b[h+11>>0]|0;G=H<<24>>24<0;C_a(r,G?f[h>>2]|0:h,G?f[h+4>>2]|0:H&255)|0;f[q>>2]=f[r>>2];f[q+4>>2]=f[r+4>>2];f[q+8>>2]=f[r+8>>2];H=0;while(1){if((H|0)==3)break;f[r+(H<<2)>>2]=0;H=H+1|0}Y_a(q,373185)|0;f[m>>2]=f[q>>2];f[m+4>>2]=f[q+4>>2];f[m+8>>2]=f[q+8>>2];H=0;while(1){if((H|0)==3)break;f[q+(H<<2)>>2]=0;H=H+1|0}H=b[g+11>>0]|0;G=H<<24>>24<0;C_a(m,G?f[g>>2]|0:g,G?f[g+4>>2]|0:H&255)|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2];f[k+8>>2]=f[m+8>>2];H=0;while(1){if((H|0)==3)break;f[m+(H<<2)>>2]=0;H=H+1|0}Y_a(k,373011)|0;f[p>>2]=f[k>>2];f[p+4>>2]=f[k+4>>2];f[p+8>>2]=f[k+8>>2];H=0;while(1){if((H|0)==3)break;f[k+(H<<2)>>2]=0;H=H+1|0}n$a(j,p);o$a((f[ta>>2]|0)+-24|0,j);z_a(j);Q_a(p);Q_a(k);Q_a(m);Q_a(q);Q_a(r);Q_a(s);Q_a(i);Q_a(h);Q_a(g);D=P;break a;break}case 114:{switch(b[x>>0]|0){case 99:{D=P$a(a,c,d)|0;break a;break}case 109:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=YOa(373191)|0;if(H>>>0>4294967279)WYa(h);if(H>>>0<11){b[h+11>>0]=H;ua=h}else{G=H+16&-16;R=N_a(G)|0;f[h>>2]=R;f[h+8>>2]=G|-2147483648;f[h+4>>2]=H;ua=R}kOa(ua,373191,H)|0;b[g>>0]=0;ZOa(ua+H|0,g);H=B$a(w,c,h,d)|0;Q_a(h);D=(H|0)==(w|0)?a:H;break a;break}case 77:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=YOa(373193)|0;if(H>>>0>4294967279)WYa(h);if(H>>>0<11){b[h+11>>0]=H;va=h}else{R=H+16&-16;G=N_a(R)|0;f[h>>2]=G;f[h+8>>2]=R|-2147483648;f[h+4>>2]=H;va=G}kOa(va,373193,H)|0;b[g>>0]=0;ZOa(va+H|0,g);H=B$a(w,c,h,d)|0;Q_a(h);D=(H|0)==(w|0)?a:H;break a;break}case 115:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=YOa(373196)|0;if(H>>>0>4294967279)WYa(h);if(H>>>0<11){b[h+11>>0]=H;wa=h}else{G=H+16&-16;R=N_a(G)|0;f[h>>2]=R;f[h+8>>2]=G|-2147483648;f[h+4>>2]=H;wa=R}kOa(wa,373196,H)|0;b[g>>0]=0;ZOa(wa+H|0,g);H=B$a(w,c,h,d)|0;Q_a(h);D=(H|0)==(w|0)?a:H;break a;break}case 83:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=YOa(373199)|0;if(H>>>0>4294967279)WYa(h);if(H>>>0<11){b[h+11>>0]=H;xa=h}else{R=H+16&-16;G=N_a(R)|0;f[h>>2]=G;f[h+8>>2]=R|-2147483648;f[h+4>>2]=H;xa=G}kOa(xa,373199,H)|0;b[g>>0]=0;ZOa(xa+H|0,g);H=B$a(w,c,h,d)|0;Q_a(h);D=(H|0)==(w|0)?a:H;break a;break}default:{D=a;break a}}break}case 115:{switch(b[x>>0]|0){case 99:{D=Q$a(a,c,d)|0;break a;break}case 112:{D=R$a(a,c,d)|0;break a;break}case 114:{D=J$a(a,c,d)|0;break a;break}case 116:{D=S$a(a,c,d)|0;break a;break}case 122:{D=T$a(a,c,d)|0;break a;break}case 90:{if((t-z|0)<=2){D=a;break a}switch(b[C>>0]|0){case 84:{D=U$a(a,c,d)|0;break a;break}case 102:{D=V$a(a,c,d)|0;break a;break}default:{D=a;break a}}break}default:{D=a;break a}}break}case 116:{switch(b[x>>0]|0){case 105:case 101:{D=W$a(a,c,d)|0;break a;break}case 114:{X$a(g,373203);H=d+4|0;G=f[H>>2]|0;if(G>>>0<(f[d+8>>2]|0)>>>0){p$a(G,g);f[H>>2]=(f[H>>2]|0)+24}else q$a(d,g);z_a(g);D=w;break a;break}case 119:{D=Y$a(a,c,d)|0;break a;break}default:{D=a;break a}}break}case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:{D=J$a(a,c,d)|0;break a;break}default:{D=a;break a}}while(0)}else D=a;while(0);u=e;return D|0}function x$a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+11|0;d=b[c>>0]|0;if(d<<24>>24<0){e=(f[a+8>>2]&2147483647)+-1|0;g=f[a+4>>2]|0}else{e=10;g=d&255}h=g>>>0<11;i=h?10:(g+16&-16)+-1|0;a:do if((i|0)!=(e|0)){do if(h){j=f[a>>2]|0;if(d<<24>>24<0){k=a;l=0;m=j;n=12}else{kOa(a,j,(d&255)+1|0)|0;O_a(j);n=14}}else{j=N_a(i+1|0)|0;if(i>>>0<=e>>>0&(j|0)==0)break a;o=b[c>>0]|0;if(o<<24>>24<0){k=j;l=1;m=f[a>>2]|0;n=12;break}else{kOa(j,a,(o&255)+1|0)|0;p=j;n=13;break}}while(0);if((n|0)==12){kOa(k,m,(f[a+4>>2]|0)+1|0)|0;O_a(m);if(l){p=k;n=13}else n=14}if((n|0)==13){f[a+8>>2]=i+1|-2147483648;f[a+4>>2]=g;f[a>>2]=p;break}else if((n|0)==14){b[c>>0]=g;break}}while(0);return}function y$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=0;while(1){if((h|0)==3)break;f[a+(h<<2)>>2]=0;h=h+1|0}h=YOa(c)|0;i=d+11|0;j=b[i>>0]|0;k=j<<24>>24<0?f[d+4>>2]|0:j&255;j=k+h|0;if(j>>>0>4294967279)WYa(a);if(j>>>0<11){b[a+11>>0]=h;l=a}else{m=j+16&-16;j=N_a(m)|0;f[a>>2]=j;f[a+8>>2]=m|-2147483648;f[a+4>>2]=h;l=j}kOa(l,c,h)|0;b[g>>0]=0;ZOa(l+h|0,g);C_a(a,(b[i>>0]|0)<0?f[d>>2]|0:d,k)|0;u=e;return}function z$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=u;u=u+112|0;g=e+88|0;h=e+48|0;i=e+72|0;j=e+36|0;k=e+24|0;l=e+12|0;m=e;a:do if((c-a|0)>3?(b[a>>0]|0)==76:0){n=a+1|0;o=a+3|0;p=a+2|0;do switch(b[n>>0]|0){case 84:{q=a;break a;break}case 119:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=YOa(374205)|0;if(r>>>0>4294967279)WYa(h);if(r>>>0<11){b[h+11>>0]=r;s=h}else{t=r+16&-16;v=N_a(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;s=v}kOa(s,374205,r)|0;b[g>>0]=0;ZOa(s+r|0,g);r=D0a(p,c,h,d)|0;Q_a(h);q=(r|0)==(p|0)?a:r;break a;break}case 98:{if((b[o>>0]|0)!=69){q=a;break a}r=a+4|0;switch(b[p>>0]|0){case 48:{X$a(g,374213);v=d+4|0;t=f[v>>2]|0;if(t>>>0<(f[d+8>>2]|0)>>>0){p$a(t,g);f[v>>2]=(f[v>>2]|0)+24}else q$a(d,g);z_a(g);q=r;break a;break}case 49:{E0a(g,374219);v=d+4|0;t=f[v>>2]|0;if(t>>>0<(f[d+8>>2]|0)>>>0){p$a(t,g);f[v>>2]=(f[v>>2]|0)+24}else q$a(d,g);z_a(g);q=r;break a;break}default:{q=a;break a}}break}case 99:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=YOa(374224)|0;if(r>>>0>4294967279)WYa(h);if(r>>>0<11){b[h+11>>0]=r;w=h}else{v=r+16&-16;t=N_a(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;w=t}kOa(w,374224,r)|0;b[g>>0]=0;ZOa(w+r|0,g);r=D0a(p,c,h,d)|0;Q_a(h);q=(r|0)==(p|0)?a:r;break a;break}case 97:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=YOa(374229)|0;if(r>>>0>4294967279)WYa(h);if(r>>>0<11){b[h+11>>0]=r;x=h}else{t=r+16&-16;v=N_a(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;x=v}kOa(x,374229,r)|0;b[g>>0]=0;ZOa(x+r|0,g);r=D0a(p,c,h,d)|0;Q_a(h);q=(r|0)==(p|0)?a:r;break a;break}case 104:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=YOa(374241)|0;if(r>>>0>4294967279)WYa(h);if(r>>>0<11){b[h+11>>0]=r;y=h}else{v=r+16&-16;t=N_a(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;y=t}kOa(y,374241,r)|0;b[g>>0]=0;ZOa(y+r|0,g);r=D0a(p,c,h,d)|0;Q_a(h);q=(r|0)==(p|0)?a:r;break a;break}case 115:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=YOa(374255)|0;if(r>>>0>4294967279)WYa(h);if(r>>>0<11){b[h+11>>0]=r;z=h}else{t=r+16&-16;v=N_a(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;z=v}kOa(z,374255,r)|0;b[g>>0]=0;ZOa(z+r|0,g);r=D0a(p,c,h,d)|0;Q_a(h);q=(r|0)==(p|0)?a:r;break a;break}case 116:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=YOa(374261)|0;if(r>>>0>4294967279)WYa(h);if(r>>>0<11){b[h+11>>0]=r;A=h}else{v=r+16&-16;t=N_a(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;A=t}kOa(A,374261,r)|0;b[g>>0]=0;ZOa(A+r|0,g);r=D0a(p,c,h,d)|0;Q_a(h);q=(r|0)==(p|0)?a:r;break a;break}case 105:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=YOa(5694105)|0;if(r>>>0>4294967279)WYa(h);if(r>>>0<11){b[h+11>>0]=r;B=h}else{t=r+16&-16;v=N_a(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;B=v}kOa(B,5694105,r)|0;b[g>>0]=0;ZOa(B+r|0,g);r=D0a(p,c,h,d)|0;Q_a(h);q=(r|0)==(p|0)?a:r;break a;break}case 106:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=YOa(374276)|0;if(r>>>0>4294967279)WYa(h);if(r>>>0<11){b[h+11>>0]=r;C=h}else{v=r+16&-16;t=N_a(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;C=t}kOa(C,374276,r)|0;b[g>>0]=0;ZOa(C+r|0,g);r=D0a(p,c,h,d)|0;Q_a(h);q=(r|0)==(p|0)?a:r;break a;break}case 108:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=YOa(374278)|0;if(r>>>0>4294967279)WYa(h);if(r>>>0<11){b[h+11>>0]=r;D=h}else{t=r+16&-16;v=N_a(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;D=v}kOa(D,374278,r)|0;b[g>>0]=0;ZOa(D+r|0,g);r=D0a(p,c,h,d)|0;Q_a(h);q=(r|0)==(p|0)?a:r;break a;break}case 109:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=YOa(374280)|0;if(r>>>0>4294967279)WYa(h);if(r>>>0<11){b[h+11>>0]=r;E=h}else{v=r+16&-16;t=N_a(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;E=t}kOa(E,374280,r)|0;b[g>>0]=0;ZOa(E+r|0,g);r=D0a(p,c,h,d)|0;Q_a(h);q=(r|0)==(p|0)?a:r;break a;break}case 120:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=YOa(374283)|0;if(r>>>0>4294967279)WYa(h);if(r>>>0<11){b[h+11>>0]=r;F=h}else{t=r+16&-16;v=N_a(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;F=v}kOa(F,374283,r)|0;b[g>>0]=0;ZOa(F+r|0,g);r=D0a(p,c,h,d)|0;Q_a(h);q=(r|0)==(p|0)?a:r;break a;break}case 121:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=YOa(374286)|0;if(r>>>0>4294967279)WYa(h);if(r>>>0<11){b[h+11>>0]=r;G=h}else{v=r+16&-16;t=N_a(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;G=t}kOa(G,374286,r)|0;b[g>>0]=0;ZOa(G+r|0,g);r=D0a(p,c,h,d)|0;Q_a(h);q=(r|0)==(p|0)?a:r;break a;break}case 110:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=YOa(374290)|0;if(r>>>0>4294967279)WYa(h);if(r>>>0<11){b[h+11>>0]=r;H=h}else{t=r+16&-16;v=N_a(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;H=v}kOa(H,374290,r)|0;b[g>>0]=0;ZOa(H+r|0,g);r=D0a(p,c,h,d)|0;Q_a(h);q=(r|0)==(p|0)?a:r;break a;break}case 111:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=YOa(374299)|0;if(r>>>0>4294967279)WYa(h);if(r>>>0<11){b[h+11>>0]=r;I=h}else{v=r+16&-16;t=N_a(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;I=t}kOa(I,374299,r)|0;b[g>>0]=0;ZOa(I+r|0,g);r=D0a(p,c,h,d)|0;Q_a(h);q=(r|0)==(p|0)?a:r;break a;break}case 102:{r=F0a(p,c,d)|0;q=(r|0)==(p|0)?a:r;break a;break}case 100:{r=G0a(p,c,d)|0;q=(r|0)==(p|0)?a:r;break a;break}case 101:{r=H0a(p,c,d)|0;q=(r|0)==(p|0)?a:r;break a;break}case 95:{if((b[p>>0]|0)!=90){q=a;break a}r=R_a(o,c,d)|0;if((r|0)==(o|0)|(r|0)==(c|0)){q=a;break a}q=(b[r>>0]|0)==69?r+1|0:a;break a;break}default:{r=U_a(n,c,d)|0;if((r|0)==(n|0)|(r|0)==(c|0)){q=a;break a}if((b[r>>0]|0)==69){q=r+1|0;break a}else J=r;while(1){K=J+1|0;if((J|0)==(c|0)){q=a;break a}L=b[J>>0]|0;if(((L<<24>>24)+-48|0)>>>0<10)J=K;else break}if(!((J|0)!=(r|0)&L<<24>>24==69)){q=a;break a}t=d+4|0;v=f[t>>2]|0;if((f[d>>2]|0)==(v|0)){q=a;break a}k$a(l,v+-24|0);X_a(l,0,373013)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];v=0;while(1){if((v|0)==3)break;f[l+(v<<2)>>2]=0;v=v+1|0}Y_a(k,373011)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];v=0;while(1){if((v|0)==3)break;f[k+(v<<2)>>2]=0;v=v+1|0}f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;v=J-r|0;if(v>>>0>4294967279)WYa(m);if(v>>>0<11){b[m+11>>0]=v;M=m}else{N=v+16&-16;O=N_a(N)|0;f[m>>2]=O;f[m+8>>2]=N|-2147483648;f[m+4>>2]=v;M=O}O=r;N=M;while(1){if((O|0)==(J|0))break;ZOa(N,O);O=O+1|0;N=N+1|0}b[g>>0]=0;ZOa(M+v|0,g);N=b[m+11>>0]|0;O=N<<24>>24<0;C_a(j,O?f[m>>2]|0:m,O?f[m+4>>2]|0:N&255)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];N=0;while(1){if((N|0)==3)break;f[j+(N<<2)>>2]=0;N=N+1|0}n$a(h,i);o$a((f[t>>2]|0)+-24|0,h);z_a(h);Q_a(i);Q_a(m);Q_a(j);Q_a(k);Q_a(l);q=K;break a}}while(0)}else q=a;while(0);u=e;return q|0}function A$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+80|0;g=e+64|0;h=e+60|0;i=e+24|0;j=e+48|0;k=e+12|0;l=e;a:do if((c-a|0)>2?(b[a>>0]|0)==102:0){m=a+2|0;switch(b[a+1>>0]|0){case 112:{n=V_a(m,c,h)|0;o=v$a(n,c)|0;if((o|0)!=(c|0)?(b[o>>0]|0)==95:0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;p=o-n|0;if(p>>>0>4294967279)WYa(k);if(p>>>0<11){b[k+11>>0]=p;q=k}else{r=p+16&-16;s=N_a(r)|0;f[k>>2]=s;f[k+8>>2]=r|-2147483648;f[k+4>>2]=p;q=s}s=n;n=q;while(1){if((s|0)==(o|0))break;ZOa(n,s);s=s+1|0;n=n+1|0}b[g>>0]=0;ZOa(q+p|0,g);X_a(k,0,374202)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];n=0;while(1){if((n|0)==3)break;f[k+(n<<2)>>2]=0;n=n+1|0}n$a(i,j);n=d+4|0;p=f[n>>2]|0;if(p>>>0<(f[d+8>>2]|0)>>>0){p$a(p,i);f[n>>2]=(f[n>>2]|0)+24}else q$a(d,i);z_a(i);Q_a(j);Q_a(k);t=o+1|0}else t=a;v=t;break a;break}case 76:break;default:{v=a;break a}}n=v$a(m,c)|0;if((((n|0)!=(c|0)?(b[n>>0]|0)==112:0)?(p=V_a(n+1|0,c,h)|0,n=v$a(p,c)|0,(n|0)!=(c|0)):0)?(b[n>>0]|0)==95:0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;s=n-p|0;if(s>>>0>4294967279)WYa(k);if(s>>>0<11){b[k+11>>0]=s;w=k}else{r=s+16&-16;x=N_a(r)|0;f[k>>2]=x;f[k+8>>2]=r|-2147483648;f[k+4>>2]=s;w=x}x=p;p=w;while(1){if((x|0)==(n|0))break;ZOa(p,x);x=x+1|0;p=p+1|0}b[g>>0]=0;ZOa(w+s|0,g);X_a(k,0,374202)|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];f[l+8>>2]=f[k+8>>2];p=0;while(1){if((p|0)==3)break;f[k+(p<<2)>>2]=0;p=p+1|0}n$a(i,l);p=d+4|0;s=f[p>>2]|0;if(s>>>0<(f[d+8>>2]|0)>>>0){p$a(s,i);f[p>>2]=(f[p>>2]|0)+24}else q$a(d,i);z_a(i);Q_a(l);Q_a(k);y=n+1|0}else y=a;v=y}else v=a;while(0);u=e;return v|0}function B$a(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;g=u;u=u+96|0;h=g+84|0;i=g+72|0;j=g+60|0;k=g+48|0;l=g+36|0;m=g+24|0;n=g+12|0;o=g;p=w$a(a,c,e)|0;a:do if((p|0)!=(a|0)){q=w$a(p,c,e)|0;r=e+4|0;if((q|0)==(p|0)){s=f[r>>2]|0;t=s+-24|0;v=s;while(1){if((v|0)==(t|0)){w=a;break a}s=v+-24|0;f[r>>2]=s;z_a(s);v=f[r>>2]|0}}v=f[r>>2]|0;if(((v-(f[e>>2]|0)|0)/24|0)>>>0>=2){k$a(i,v+-24|0);v=f[r>>2]|0;t=v+-24|0;s=v;while(1){if((s|0)==(t|0))break;x=s+-24|0;f[r>>2]=x;z_a(x);s=f[r>>2]|0}k$a(j,v+-48|0);s=f[r>>2]|0;t=s+-24|0;x=t+11|0;if((b[x>>0]|0)<0){y=f[t>>2]|0;b[h>>0]=0;ZOa(y,h);f[s+-20>>2]=0}else{b[h>>0]=0;ZOa(t,h);b[x>>0]=0}x=YOa(373049)|0;s=d+11|0;y=b[s>>0]|0;z=d+4|0;if((x|0)==((y<<24>>24<0?f[z>>2]|0:y&255)|0)?(g$a(d,373049,x)|0)==0:0)p0a(t,40);y$a(o,373013,j);Y_a(o,373299)|0;f[n>>2]=f[o>>2];f[n+4>>2]=f[o+4>>2];f[n+8>>2]=f[o+8>>2];x=0;while(1){if((x|0)==3)break;f[o+(x<<2)>>2]=0;x=x+1|0}x=b[s>>0]|0;r=x<<24>>24<0;C_a(n,r?f[d>>2]|0:d,r?f[z>>2]|0:x&255)|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];x=0;while(1){if((x|0)==3)break;f[n+(x<<2)>>2]=0;x=x+1|0}Y_a(m,373008)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];x=0;while(1){if((x|0)==3)break;f[m+(x<<2)>>2]=0;x=x+1|0}x=b[i+11>>0]|0;r=x<<24>>24<0;C_a(l,r?f[i>>2]|0:i,r?f[i+4>>2]|0:x&255)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];x=0;while(1){if((x|0)==3)break;f[l+(x<<2)>>2]=0;x=x+1|0}Y_a(k,373011)|0;f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];f[h+8>>2]=f[k+8>>2];x=0;while(1){if((x|0)==3)break;f[k+(x<<2)>>2]=0;x=x+1|0}x=b[h+11>>0]|0;r=x<<24>>24<0;C_a(t,r?f[h>>2]|0:h,r?f[h+4>>2]|0:x&255)|0;Q_a(h);Q_a(k);Q_a(l);Q_a(m);Q_a(n);Q_a(o);x=YOa(373049)|0;r=b[s>>0]|0;if((x|0)==((r<<24>>24<0?f[z>>2]|0:r&255)|0)?(g$a(d,373049,x)|0)==0:0)p0a(t,41);Q_a(j);Q_a(i);w=q}else w=a}else w=a;while(0);u=g;return w|0}function C$a(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+64|0;h=g+48|0;i=g+36|0;j=g+24|0;k=g+12|0;l=g;m=w$a(a,c,e)|0;if((m|0)!=(a|0)?(c=e+4|0,(f[e>>2]|0)!=(f[c>>2]|0)):0){m$a(k,d,373013);k$a(l,(f[c>>2]|0)+-24|0);d=b[l+11>>0]|0;e=d<<24>>24<0;C_a(k,e?f[l>>2]|0:l,e?f[l+4>>2]|0:d&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];d=0;while(1){if((d|0)==3)break;f[k+(d<<2)>>2]=0;d=d+1|0}Y_a(j,373011)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];d=0;while(1){if((d|0)==3)break;f[j+(d<<2)>>2]=0;d=d+1|0}d=f[c>>2]|0;c=d+-24|0;e=c+11|0;if((b[e>>0]|0)<0){n=f[c>>2]|0;b[h>>0]=0;ZOa(n,h);f[d+-20>>2]=0}else{b[h>>0]=0;ZOa(c,h);b[e>>0]=0}x$a(c);f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}Q_a(i);Q_a(j);Q_a(l);Q_a(k);o=m}else o=a;u=g;return o|0}function D$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;if(((((c-a|0)>2?(b[a>>0]|0)==97:0)?(b[a+1>>0]|0)==116:0)?(k=a+2|0,l=U_a(k,c,d)|0,(l|0)!=(k|0)):0)?(k=d+4|0,c=f[k>>2]|0,(f[d>>2]|0)!=(c|0)):0){k$a(j,c+-24|0);X_a(j,0,374192)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}Y_a(i,373011)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}c=f[k>>2]|0;k=c+-24|0;d=k+11|0;if((b[d>>0]|0)<0){m=f[k>>2]|0;b[g>>0]=0;ZOa(m,g);f[c+-20>>2]=0}else{b[g>>0]=0;ZOa(k,g);b[d>>0]=0}x$a(k);f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];k=0;while(1){if((k|0)==3)break;f[h+(k<<2)>>2]=0;k=k+1|0}Q_a(h);Q_a(i);Q_a(j);n=l}else n=a;u=e;return n|0}function E$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;if(((((c-a|0)>2?(b[a>>0]|0)==97:0)?(b[a+1>>0]|0)==122:0)?(k=a+2|0,l=w$a(k,c,d)|0,(l|0)!=(k|0)):0)?(k=d+4|0,c=f[k>>2]|0,(f[d>>2]|0)!=(c|0)):0){k$a(j,c+-24|0);X_a(j,0,374192)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}Y_a(i,373011)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}c=f[k>>2]|0;k=c+-24|0;d=k+11|0;if((b[d>>0]|0)<0){m=f[k>>2]|0;b[g>>0]=0;ZOa(m,g);f[c+-20>>2]=0}else{b[g>>0]=0;ZOa(k,g);b[d>>0]=0}x$a(k);f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];k=0;while(1){if((k|0)==3)break;f[h+(k<<2)>>2]=0;k=k+1|0}Q_a(h);Q_a(i);Q_a(j);n=l}else n=a;u=e;return n|0}function F$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+112|0;g=e+88|0;h=e+64|0;i=e+36|0;j=e+48|0;k=e+24|0;l=e+12|0;m=e;if((((((c-a|0)>2?(b[a>>0]|0)==99:0)?(b[a+1>>0]|0)==99:0)?(n=a+2|0,o=U_a(n,c,d)|0,(o|0)!=(n|0)):0)?(n=w$a(o,c,d)|0,(n|0)!=(o|0)):0)?(o=d+4|0,c=f[o>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){k$a(g,c+-24|0);c=f[o>>2]|0;d=c+-24|0;p=c;while(1){if((p|0)==(d|0))break;q=p+-24|0;f[o>>2]=q;z_a(q);p=f[o>>2]|0}k$a(m,c+-48|0);X_a(m,0,374180)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];c=0;while(1){if((c|0)==3)break;f[m+(c<<2)>>2]=0;c=c+1|0}Y_a(l,373260)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];c=0;while(1){if((c|0)==3)break;f[l+(c<<2)>>2]=0;c=c+1|0}c=b[g+11>>0]|0;p=c<<24>>24<0;C_a(k,p?f[g>>2]|0:g,p?f[g+4>>2]|0:c&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];c=0;while(1){if((c|0)==3)break;f[k+(c<<2)>>2]=0;c=c+1|0}Y_a(j,373011)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}n$a(h,i);o$a((f[o>>2]|0)+-24|0,h);z_a(h);Q_a(i);Q_a(j);Q_a(k);Q_a(l);Q_a(m);Q_a(g);r=n}else r=a;u=e;return r|0}function G$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+32|0;g=e+12|0;h=e;a:do if(((((c-a|0)>3?(b[a>>0]|0)==99:0)?(b[a+1>>0]|0)==108:0)?(i=a+2|0,j=w$a(i,c,d)|0,!((j|0)==(i|0)|(j|0)==(c|0))):0)?(i=d+4|0,k=f[i>>2]|0,(f[d>>2]|0)!=(k|0)):0){l=k+-12|0;m=b[l+11>>0]|0;n=m<<24>>24<0;C_a(k+-24|0,n?f[l>>2]|0:l,n?f[k+-8>>2]|0:m&255)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;m=0;while(1){if((m|0)==3)break;f[h+(m<<2)>>2]=0;m=m+1|0}m=f[i>>2]|0;k=m+-12|0;n=k+11|0;if((b[n>>0]|0)<0){l=f[k>>2]|0;b[g>>0]=0;ZOa(l,g);f[m+-8>>2]=0}else{b[g>>0]=0;ZOa(k,g);b[n>>0]=0}x$a(k);f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];k=0;while(1){if((k|0)==3)break;f[h+(k<<2)>>2]=0;k=k+1|0}Q_a(h);Y_a((f[i>>2]|0)+-24|0,373013)|0;k=g+11|0;n=g+4|0;m=j;while(1){if((b[m>>0]|0)==69)break;l=w$a(m,c,d)|0;if((l|0)==(m|0)|(l|0)==(c|0)){o=a;break a}p=f[i>>2]|0;if((f[d>>2]|0)==(p|0)){o=a;break a}k$a(g,p+-24|0);p=f[i>>2]|0;q=p+-24|0;r=p;while(1){if((r|0)==(q|0))break;s=r+-24|0;f[i>>2]=s;z_a(s);r=f[i>>2]|0}r=b[k>>0]|0;s=r<<24>>24<0;t=s?f[n>>2]|0:r&255;if(t|0){if((f[d>>2]|0)==(q|0)){v=26;break}C_a(p+-48|0,s?f[g>>2]|0:g,t)|0}Q_a(g);m=l}if((v|0)==26){Q_a(g);o=a;break}n=f[i>>2]|0;if((f[d>>2]|0)!=(n|0)){Y_a(n+-24|0,373011)|0;o=m+1|0}else o=a}else o=a;while(0);u=e;return o|0}function H$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+112|0;g=e+88|0;h=e+64|0;i=e+36|0;j=e+48|0;k=e+24|0;l=e+12|0;m=e;a:do if((((c-a|0)>2?(b[a>>0]|0)==99:0)?(b[a+1>>0]|0)==118:0)?(n=d+63|0,o=b[n>>0]|0,b[n>>0]=0,p=a+2|0,q=U_a(p,c,d)|0,b[n>>0]=o,!((q|0)==(p|0)|(q|0)==(c|0))):0){if((b[q>>0]|0)!=95){p=w$a(q,c,d)|0;if((p|0)==(q|0)){r=a;break}else s=p}else{p=q+1|0;if((p|0)==(c|0)){r=a;break}q=b[p>>0]|0;b:do if(q<<24>>24==69){o=d+4|0;n=f[o>>2]|0;if(n>>>0<(f[d+8>>2]|0)>>>0){f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[n+16>>2]=0;f[n+20>>2]=0;v0a(n);f[o>>2]=(f[o>>2]|0)+24;t=p;break}else{w0a(d);t=p;break}}else{o=q;n=p;while(1){if(o<<24>>24==69){t=n;break b}v=w$a(n,c,d)|0;w=(v|0)==(n|0)|(v|0)==(c|0);if(w){r=a;break a}o=b[(w?n:v)>>0]|0;n=v}}while(0);s=t+1|0}p=d+4|0;q=f[p>>2]|0;if(((q-(f[d>>2]|0)|0)/24|0)>>>0>=2){k$a(g,q+-24|0);q=f[p>>2]|0;n=q+-24|0;o=q;while(1){if((o|0)==(n|0))break;v=o+-24|0;f[p>>2]=v;z_a(v);o=f[p>>2]|0}k$a(m,q+-48|0);X_a(m,0,373013)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];o=0;while(1){if((o|0)==3)break;f[m+(o<<2)>>2]=0;o=o+1|0}Y_a(l,374177)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];o=0;while(1){if((o|0)==3)break;f[l+(o<<2)>>2]=0;o=o+1|0}o=b[g+11>>0]|0;q=o<<24>>24<0;C_a(k,q?f[g>>2]|0:g,q?f[g+4>>2]|0:o&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];o=0;while(1){if((o|0)==3)break;f[k+(o<<2)>>2]=0;o=o+1|0}Y_a(j,373011)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];o=0;while(1){if((o|0)==3)break;f[j+(o<<2)>>2]=0;o=o+1|0}n$a(h,i);o$a((f[p>>2]|0)+-24|0,h);z_a(h);Q_a(i);Q_a(j);Q_a(k);Q_a(l);Q_a(m);Q_a(g);r=s}else r=a}else r=a;while(0);u=e;return r|0}function I$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+112|0;g=e+88|0;h=e+64|0;i=e+36|0;j=e+48|0;k=e+24|0;l=e+12|0;m=e;if((((((c-a|0)>2?(b[a>>0]|0)==100:0)?(b[a+1>>0]|0)==99:0)?(n=a+2|0,o=U_a(n,c,d)|0,(o|0)!=(n|0)):0)?(n=w$a(o,c,d)|0,(n|0)!=(o|0)):0)?(o=d+4|0,c=f[o>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){k$a(g,c+-24|0);c=f[o>>2]|0;d=c+-24|0;p=c;while(1){if((p|0)==(d|0))break;q=p+-24|0;f[o>>2]=q;z_a(q);p=f[o>>2]|0}k$a(m,c+-48|0);X_a(m,0,374163)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];c=0;while(1){if((c|0)==3)break;f[m+(c<<2)>>2]=0;c=c+1|0}Y_a(l,373260)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];c=0;while(1){if((c|0)==3)break;f[l+(c<<2)>>2]=0;c=c+1|0}c=b[g+11>>0]|0;p=c<<24>>24<0;C_a(k,p?f[g>>2]|0:g,p?f[g+4>>2]|0:c&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];c=0;while(1){if((c|0)==3)break;f[k+(c<<2)>>2]=0;c=c+1|0}Y_a(j,373011)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}n$a(h,i);o$a((f[o>>2]|0)+-24|0,h);z_a(h);Q_a(i);Q_a(j);Q_a(k);Q_a(l);Q_a(m);Q_a(g);r=n}else r=a;u=e;return r|0}function J$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+32|0;g=e+12|0;h=e;i=c;a:do if((i-a|0)>2){if((b[a>>0]|0)==103){j=(b[a+1>>0]|0)==115;k=j;l=j?a+2|0:a}else{k=0;l=a}j=$$a(l,c,d)|0;if((j|0)!=(l|0)){if(!k){m=j;break}n=f[d+4>>2]|0;if((f[d>>2]|0)==(n|0)){m=a;break}X_a(n+-24|0,0,373085)|0;m=j;break}if(((i-l|0)>2?(b[l>>0]|0)==115:0)?(b[l+1>>0]|0)==114:0){j=l+2|0;if((b[j>>0]|0)==78){n=l+3|0;o=a0a(n,c,d)|0;if((o|0)==(n|0)|(o|0)==(c|0)){m=a;break}n=j$a(o,c,d)|0;p=d+4|0;do if((n|0)==(o|0)){q=d;r=o}else{s=f[p>>2]|0;if(((s-(f[d>>2]|0)|0)/24|0)>>>0<2){m=a;break a}k$a(g,s+-24|0);s=f[p>>2]|0;t=s+-24|0;v=s;while(1){if((v|0)==(t|0))break;w=v+-24|0;f[p>>2]=w;z_a(w);v=f[p>>2]|0}v=b[g+11>>0]|0;t=v<<24>>24<0;C_a(s+-48|0,t?f[g>>2]|0:g,t?f[g+4>>2]|0:v&255)|0;if((n|0)!=(c|0)){Q_a(g);q=d;r=n;break}v=f[p>>2]|0;t=v+-24|0;w=v;while(1){if((w|0)==(t|0))break;v=w+-24|0;f[p>>2]=v;z_a(v);w=f[p>>2]|0}Q_a(g);m=a;break a}while(0);n=h+11|0;o=h+4|0;w=r;while(1){if((b[w>>0]|0)==69)break;t=b0a(w,c,d)|0;if((t|0)==(w|0)|(t|0)==(c|0)){m=a;break a}s=f[p>>2]|0;if(((s-(f[q>>2]|0)|0)/24|0)>>>0<2){m=a;break a}k$a(g,s+-24|0);s=f[p>>2]|0;v=s+-24|0;x=s;while(1){if((x|0)==(v|0))break;s=x+-24|0;f[p>>2]=s;z_a(s);x=f[p>>2]|0}X_a(g,0,373085)|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];x=0;while(1){if((x|0)==3)break;f[g+(x<<2)>>2]=0;x=x+1|0}x=b[n>>0]|0;v=x<<24>>24<0;C_a((f[p>>2]|0)+-24|0,v?f[h>>2]|0:h,v?f[o>>2]|0:x&255)|0;Q_a(h);Q_a(g);w=t}o=w+1|0;n=$$a(o,c,d)|0;if((n|0)==(o|0)){o=f[p>>2]|0;if((f[d>>2]|0)==(o|0)){m=a;break}x=o+-24|0;v=o;while(1){if((v|0)==(x|0)){m=a;break a}o=v+-24|0;f[p>>2]=o;z_a(o);v=f[p>>2]|0}}v=f[p>>2]|0;if(((v-(f[q>>2]|0)|0)/24|0)>>>0<2){m=a;break}k$a(g,v+-24|0);v=f[p>>2]|0;x=v+-24|0;w=v;while(1){if((w|0)==(x|0))break;v=w+-24|0;f[p>>2]=v;z_a(v);w=f[p>>2]|0}X_a(g,0,373085)|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];w=0;while(1){if((w|0)==3)break;f[g+(w<<2)>>2]=0;w=w+1|0}w=b[h+11>>0]|0;x=w<<24>>24<0;C_a((f[p>>2]|0)+-24|0,x?f[h>>2]|0:h,x?f[h+4>>2]|0:w&255)|0;Q_a(h);Q_a(g);m=n;break}w=a0a(j,c,d)|0;if((w|0)!=(j|0)){x=j$a(w,c,d)|0;if((x|0)==(w|0))y=w;else{w=d+4|0;v=f[w>>2]|0;if(((v-(f[d>>2]|0)|0)/24|0)>>>0<2){m=a;break}k$a(g,v+-24|0);v=f[w>>2]|0;o=v+-24|0;s=v;while(1){if((s|0)==(o|0))break;z=s+-24|0;f[w>>2]=z;z_a(z);s=f[w>>2]|0}w=b[g+11>>0]|0;s=w<<24>>24<0;C_a(v+-48|0,s?f[g>>2]|0:g,s?f[g+4>>2]|0:w&255)|0;Q_a(g);y=x}w=$$a(y,c,d)|0;if((w|0)==(y|0)){s=d+4|0;o=f[s>>2]|0;if((f[d>>2]|0)==(o|0)){m=a;break}n=o+-24|0;p=o;while(1){if((p|0)==(n|0)){m=a;break a}o=p+-24|0;f[s>>2]=o;z_a(o);p=f[s>>2]|0}}s=d+4|0;p=f[s>>2]|0;if(((p-(f[d>>2]|0)|0)/24|0)>>>0<2){m=a;break}k$a(g,p+-24|0);p=f[s>>2]|0;n=p+-24|0;x=p;while(1){if((x|0)==(n|0))break;p=x+-24|0;f[s>>2]=p;z_a(p);x=f[s>>2]|0}X_a(g,0,373085)|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];x=0;while(1){if((x|0)==3)break;f[g+(x<<2)>>2]=0;x=x+1|0}x=b[h+11>>0]|0;n=x<<24>>24<0;C_a((f[s>>2]|0)+-24|0,n?f[h>>2]|0:h,n?f[h+4>>2]|0:x&255)|0;Q_a(h);Q_a(g);m=w;break}x=b0a(j,c,d)|0;if(!((x|0)==(j|0)|(x|0)==(c|0))){if(k){n=d+4|0;p=f[n>>2]|0;if((f[d>>2]|0)==(p|0)){m=a;break}X_a(p+-24|0,0,373085)|0;A=n}else A=d+4|0;n=h+11|0;p=h+4|0;v=x;while(1){if((b[v>>0]|0)==69)break;x=b0a(v,c,d)|0;if((x|0)==(v|0)|(x|0)==(c|0)){m=a;break a}o=f[A>>2]|0;if(((o-(f[d>>2]|0)|0)/24|0)>>>0<2){m=a;break a}k$a(g,o+-24|0);o=f[A>>2]|0;z=o+-24|0;B=o;while(1){if((B|0)==(z|0))break;o=B+-24|0;f[A>>2]=o;z_a(o);B=f[A>>2]|0}X_a(g,0,373085)|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];B=0;while(1){if((B|0)==3)break;f[g+(B<<2)>>2]=0;B=B+1|0}B=b[n>>0]|0;z=B<<24>>24<0;C_a((f[A>>2]|0)+-24|0,z?f[h>>2]|0:h,z?f[p>>2]|0:B&255)|0;Q_a(h);Q_a(g);v=x}p=v+1|0;n=$$a(p,c,d)|0;if((n|0)==(p|0)){p=f[A>>2]|0;if((f[d>>2]|0)==(p|0)){m=a;break}j=p+-24|0;w=p;while(1){if((w|0)==(j|0)){m=a;break a}p=w+-24|0;f[A>>2]=p;z_a(p);w=f[A>>2]|0}}w=f[A>>2]|0;if(((w-(f[d>>2]|0)|0)/24|0)>>>0>=2){k$a(g,w+-24|0);w=f[A>>2]|0;j=w+-24|0;v=w;while(1){if((v|0)==(j|0))break;w=v+-24|0;f[A>>2]=w;z_a(w);v=f[A>>2]|0}X_a(g,0,373085)|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];v=0;while(1){if((v|0)==3)break;f[g+(v<<2)>>2]=0;v=v+1|0}v=b[h+11>>0]|0;j=v<<24>>24<0;C_a((f[A>>2]|0)+-24|0,j?f[h>>2]|0:h,j?f[h+4>>2]|0:v&255)|0;Q_a(h);Q_a(g);m=n}else m=a}else m=a}else m=a}else m=a;while(0);u=e;return m|0}function K$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+32|0;g=e+12|0;h=e;if((((((c-a|0)>2?(b[a>>0]|0)==100:0)?(b[a+1>>0]|0)==115:0)?(i=a+2|0,j=w$a(i,c,d)|0,(j|0)!=(i|0)):0)?(i=w$a(j,c,d)|0,(i|0)!=(j|0)):0)?(j=d+4|0,c=f[j>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){k$a(g,c+-24|0);c=f[j>>2]|0;d=c+-24|0;k=c;while(1){if((k|0)==(d|0))break;c=k+-24|0;f[j>>2]=c;z_a(c);k=f[j>>2]|0}y$a(h,373304,g);k=b[h+11>>0]|0;d=k<<24>>24<0;C_a((f[j>>2]|0)+-24|0,d?f[h>>2]|0:h,d?f[h+4>>2]|0:k&255)|0;Q_a(h);Q_a(g);l=i}else l=a;u=e;return l|0}function L$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+32|0;g=e+12|0;h=e;if((((((c-a|0)>2?(b[a>>0]|0)==100:0)?(b[a+1>>0]|0)==116:0)?(i=a+2|0,j=w$a(i,c,d)|0,(j|0)!=(i|0)):0)?(i=J$a(j,c,d)|0,(i|0)!=(j|0)):0)?(j=d+4|0,c=f[j>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){k$a(g,c+-24|0);c=f[j>>2]|0;d=c+-24|0;k=c;while(1){if((k|0)==(d|0))break;c=k+-24|0;f[j>>2]=c;z_a(c);k=f[j>>2]|0}y$a(h,373302,g);k=b[h+11>>0]|0;d=k<<24>>24<0;C_a((f[j>>2]|0)+-24|0,d?f[h>>2]|0:h,d?f[h+4>>2]|0:k&255)|0;Q_a(h);Q_a(g);l=i}else l=a;u=e;return l|0}function M$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;e=u;u=u+112|0;g=e+88|0;h=e+76|0;i=e+64|0;j=e+40|0;k=e+16|0;l=e;m=e+52|0;n=c;a:do if((n-a|0)>3){o=b[a>>0]|0;if(o<<24>>24==103){p=(b[a+1>>0]|0)==115;q=p?a+2|0:a;r=b[q>>0]|0;s=p;t=q}else{r=o;s=0;t=a}if(r<<24>>24==110){o=b[t+1>>0]|0;q=o<<24>>24==97;switch(o<<24>>24){case 97:case 119:break;default:{v=a;break a}}o=t+2|0;b:do if((o|0)!=(c|0)){p=0;w=o;while(1){if((b[w>>0]|0)==95)break;x=w$a(w,c,d)|0;y=(x|0)==(w|0);z=(x|0)==(c|0);if(y|z)break b;else{p=p|(y|z)^1;w=x}}x=w+1|0;z=U_a(x,c,d)|0;if(!((z|0)==(x|0)|(z|0)==(c|0))){x=b[z>>0]|0;c:do if(!((n-z|0)>2&x<<24>>24==112))if(x<<24>>24==69){A=0;B=z}else break b;else{if((b[z+1>>0]|0)!=105)break b;y=z+2|0;while(1){if((b[y>>0]|0)==69){A=1;B=y;break c}C=y;y=w$a(y,c,d)|0;if((y|0)==(C|0)|(y|0)==(c|0))break b}}while(0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;z=0;while(1){if((z|0)==3)break;f[h+(z<<2)>>2]=0;z=z+1|0}d:do if(A){z=d+4|0;x=f[z>>2]|0;if((f[d>>2]|0)==(x|0)){D=1;E=a}else{k$a(i,x+-24|0);x=h+11|0;if((b[x>>0]|0)<0){w=f[h>>2]|0;b[g>>0]=0;ZOa(w,g);f[h+4>>2]=0}else{b[g>>0]=0;ZOa(h,g);b[x>>0]=0}x$a(h);f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];x=0;while(1){if((x|0)==3)break;f[i+(x<<2)>>2]=0;x=x+1|0}Q_a(i);x=f[z>>2]|0;w=x+-24|0;y=x;while(1){if((y|0)==(w|0)){F=w;G=d;H=z;I=31;break d}x=y+-24|0;f[z>>2]=x;z_a(x);y=f[z>>2]|0}}}else{z=d+4|0;F=f[z>>2]|0;G=d;H=z;I=31}while(0);if((I|0)==31)if((f[G>>2]|0)==(F|0)){D=1;E=a}else{k$a(i,F+-24|0);z=f[H>>2]|0;y=z+-24|0;w=z;while(1){if((w|0)==(y|0))break;x=w+-24|0;f[H>>2]=x;z_a(x);w=f[H>>2]|0}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;w=0;while(1){if((w|0)==3)break;f[j+(w<<2)>>2]=0;w=w+1|0}e:do if(p)if((f[G>>2]|0)==(y|0)){J=1;K=a}else{k$a(k,z+-48|0);w=j+11|0;if((b[w>>0]|0)<0){x=f[j>>2]|0;b[g>>0]=0;ZOa(x,g);f[j+4>>2]=0}else{b[g>>0]=0;ZOa(j,g);b[w>>0]=0}x$a(j);f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];w=0;while(1){if((w|0)==3)break;f[k+(w<<2)>>2]=0;w=w+1|0}Q_a(k);w=f[H>>2]|0;x=w+-24|0;C=w;while(1){if((C|0)==(x|0)){I=49;break e}w=C+-24|0;f[H>>2]=w;z_a(w);C=f[H>>2]|0}}else I=49;while(0);if((I|0)==49){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;z=0;while(1){if((z|0)==3)break;f[g+(z<<2)>>2]=0;z=z+1|0}if(s)Z$a(g,373085);if(q)Y_a(g,373295)|0;else Y_a(g,373045)|0;if(p){y$a(l,373013,j);Y_a(l,373299)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];z=0;while(1){if((z|0)==3)break;f[l+(z<<2)>>2]=0;z=z+1|0}z=b[k+11>>0]|0;p=z<<24>>24<0;C_a(g,p?f[k>>2]|0:k,p?f[k+4>>2]|0:z&255)|0;Q_a(k);Q_a(l)}z=b[i+11>>0]|0;p=z<<24>>24<0;C_a(g,p?f[i>>2]|0:i,p?f[i+4>>2]|0:z&255)|0;if(A){y$a(l,373008,h);Y_a(l,373011)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];z=0;while(1){if((z|0)==3)break;f[l+(z<<2)>>2]=0;z=z+1|0}z=b[k+11>>0]|0;p=z<<24>>24<0;C_a(g,p?f[k>>2]|0:k,p?f[k+4>>2]|0:z&255)|0;Q_a(k);Q_a(l)};f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[m+8>>2]=f[g+8>>2];z=0;while(1){if((z|0)==3)break;f[g+(z<<2)>>2]=0;z=z+1|0}n$a(k,m);z=f[H>>2]|0;if(z>>>0<(f[d+8>>2]|0)>>>0){p$a(z,k);f[H>>2]=(f[H>>2]|0)+24}else q$a(d,k);z_a(k);Q_a(m);Q_a(g);J=0;K=B+1|0}Q_a(j);Q_a(i);D=J;E=K}Q_a(h);if(!D){v=E;break a}}}while(0);v=a}else v=a}else v=a;while(0);u=e;return v|0}function N$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;k=w$a(a,c,d)|0;if((k|0)!=(a|0)?(c=d+4|0,l=f[c>>2]|0,(f[d>>2]|0)!=(l|0)):0){k$a(j,l+-24|0);X_a(j,0,373284)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];l=0;while(1){if((l|0)==3)break;f[j+(l<<2)>>2]=0;l=l+1|0}Y_a(i,373011)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];l=0;while(1){if((l|0)==3)break;f[i+(l<<2)>>2]=0;l=l+1|0}l=f[c>>2]|0;c=l+-24|0;d=c+11|0;if((b[d>>0]|0)<0){m=f[c>>2]|0;b[g>>0]=0;ZOa(m,g);f[l+-20>>2]=0}else{b[g>>0]=0;ZOa(c,g);b[d>>0]=0}x$a(c);f[c>>2]=f[h>>2];f[c+4>>2]=f[h+4>>2];f[c+8>>2]=f[h+8>>2];c=0;while(1){if((c|0)==3)break;f[h+(c<<2)>>2]=0;c=c+1|0}Q_a(h);Q_a(i);Q_a(j);n=k}else n=a;u=e;return n|0}function O$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;if((((((c-a|0)>2?(b[a>>0]|0)==112:0)?(b[a+1>>0]|0)==116:0)?(h=a+2|0,i=w$a(h,c,d)|0,(i|0)!=(h|0)):0)?(h=w$a(i,c,d)|0,(h|0)!=(i|0)):0)?(i=d+4|0,c=f[i>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){k$a(g,c+-24|0);c=f[i>>2]|0;d=c+-24|0;j=c;while(1){if((j|0)==(d|0))break;k=j+-24|0;f[i>>2]=k;z_a(k);j=f[i>>2]|0}Y_a(c+-48|0,373281)|0;c=b[g+11>>0]|0;j=c<<24>>24<0;C_a((f[i>>2]|0)+-24|0,j?f[g>>2]|0:g,j?f[g+4>>2]|0:c&255)|0;Q_a(g);l=h}else l=a;u=e;return l|0}function P$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+112|0;g=e+88|0;h=e+64|0;i=e+36|0;j=e+48|0;k=e+24|0;l=e+12|0;m=e;if((((((c-a|0)>2?(b[a>>0]|0)==114:0)?(b[a+1>>0]|0)==99:0)?(n=a+2|0,o=U_a(n,c,d)|0,(o|0)!=(n|0)):0)?(n=w$a(o,c,d)|0,(n|0)!=(o|0)):0)?(o=d+4|0,c=f[o>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){k$a(g,c+-24|0);c=f[o>>2]|0;d=c+-24|0;p=c;while(1){if((p|0)==(d|0))break;q=p+-24|0;f[o>>2]=q;z_a(q);p=f[o>>2]|0}k$a(m,c+-48|0);X_a(m,0,373263)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];c=0;while(1){if((c|0)==3)break;f[m+(c<<2)>>2]=0;c=c+1|0}Y_a(l,373260)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];c=0;while(1){if((c|0)==3)break;f[l+(c<<2)>>2]=0;c=c+1|0}c=b[g+11>>0]|0;p=c<<24>>24<0;C_a(k,p?f[g>>2]|0:g,p?f[g+4>>2]|0:c&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];c=0;while(1){if((c|0)==3)break;f[k+(c<<2)>>2]=0;c=c+1|0}Y_a(j,373011)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}n$a(h,i);o$a((f[o>>2]|0)+-24|0,h);z_a(h);Q_a(i);Q_a(j);Q_a(k);Q_a(l);Q_a(m);Q_a(g);r=n}else r=a;u=e;return r|0}function Q$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+112|0;g=e+88|0;h=e+64|0;i=e+36|0;j=e+48|0;k=e+24|0;l=e+12|0;m=e;if((((((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==99:0)?(n=a+2|0,o=U_a(n,c,d)|0,(o|0)!=(n|0)):0)?(n=w$a(o,c,d)|0,(n|0)!=(o|0)):0)?(o=d+4|0,c=f[o>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){k$a(g,c+-24|0);c=f[o>>2]|0;d=c+-24|0;p=c;while(1){if((p|0)==(d|0))break;q=p+-24|0;f[o>>2]=q;z_a(q);p=f[o>>2]|0}k$a(m,c+-48|0);X_a(m,0,373247)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];c=0;while(1){if((c|0)==3)break;f[m+(c<<2)>>2]=0;c=c+1|0}Y_a(l,373260)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];c=0;while(1){if((c|0)==3)break;f[l+(c<<2)>>2]=0;c=c+1|0}c=b[g+11>>0]|0;p=c<<24>>24<0;C_a(k,p?f[g>>2]|0:g,p?f[g+4>>2]|0:c&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];c=0;while(1){if((c|0)==3)break;f[k+(c<<2)>>2]=0;c=c+1|0}Y_a(j,373011)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}n$a(h,i);o$a((f[o>>2]|0)+-24|0,h);z_a(h);Q_a(i);Q_a(j);Q_a(k);Q_a(l);Q_a(m);Q_a(g);r=n}else r=a;u=e;return r|0}function R$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0;if(((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==112:0){e=a+2|0;f=w$a(e,c,d)|0;g=(f|0)==(e|0)?a:f}else g=a;return g|0}function S$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+64|0;g=e+40|0;h=e+12|0;i=e+24|0;j=e;if(((((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==116:0)?(k=a+2|0,l=U_a(k,c,d)|0,(l|0)!=(k|0)):0)?(k=d+4|0,c=f[k>>2]|0,(f[d>>2]|0)!=(c|0)):0){k$a(j,c+-24|0);X_a(j,0,373238)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}Y_a(i,373011)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}n$a(g,h);o$a((f[k>>2]|0)+-24|0,g);z_a(g);Q_a(h);Q_a(i);Q_a(j);m=l}else m=a;u=e;return m|0}function T$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+64|0;g=e+40|0;h=e+12|0;i=e+24|0;j=e;if(((((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==122:0)?(k=a+2|0,l=w$a(k,c,d)|0,(l|0)!=(k|0)):0)?(k=d+4|0,c=f[k>>2]|0,(f[d>>2]|0)!=(c|0)):0){k$a(j,c+-24|0);X_a(j,0,373238)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}Y_a(i,373011)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}n$a(g,h);o$a((f[k>>2]|0)+-24|0,g);z_a(g);Q_a(h);Q_a(i);Q_a(j);m=l}else m=a;u=e;return m|0}function U$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+64|0;g=e+40|0;h=e+24|0;i=e;j=e+12|0;if(((((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==90:0)?(k=a+2|0,(b[k>>0]|0)==84):0)?(l=d+4|0,m=((f[l>>2]|0)-(f[d>>2]|0)|0)/24|0,n=i$a(k,c,d)|0,c=((f[l>>2]|0)-(f[d>>2]|0)|0)/24|0,(n|0)!=(k|0)):0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;k=YOa(373224)|0;if(k>>>0>4294967279)WYa(h);if(k>>>0<11){b[h+11>>0]=k;o=h}else{p=k+16&-16;q=N_a(p)|0;f[h>>2]=q;f[h+8>>2]=p|-2147483648;f[h+4>>2]=k;o=q}kOa(o,373224,k)|0;b[g>>0]=0;ZOa(o+k|0,g);a:do if((m|0)!=(c|0)){k$a(g,(f[d>>2]|0)+(m*24|0)|0);k=b[g+11>>0]|0;o=k<<24>>24<0;C_a(h,o?f[g>>2]|0:g,o?f[g+4>>2]|0:k&255)|0;Q_a(g);k=g+11|0;o=g+4|0;q=m;while(1){p=q+1|0;if((p|0)==(c|0))break a;k$a(i,(f[d>>2]|0)+(p*24|0)|0);X_a(i,0,373235)|0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];f[g+8>>2]=f[i+8>>2];r=0;while(1){if((r|0)==3)break;f[i+(r<<2)>>2]=0;r=r+1|0}r=b[k>>0]|0;s=r<<24>>24<0;C_a(h,s?f[g>>2]|0:g,s?f[o>>2]|0:r&255)|0;Q_a(g);Q_a(i);q=p}}while(0);Y_a(h,373011)|0;i=c;while(1){if((i|0)==(m|0))break;c=f[l>>2]|0;q=c+-24|0;o=c;while(1){if((o|0)==(q|0))break;c=o+-24|0;f[l>>2]=c;z_a(c);o=f[l>>2]|0}i=i+-1|0}f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];f[j+8>>2]=f[h+8>>2];i=0;while(1){if((i|0)==3)break;f[h+(i<<2)>>2]=0;i=i+1|0}n$a(g,j);i=f[l>>2]|0;if(i>>>0<(f[d+8>>2]|0)>>>0){p$a(i,g);f[l>>2]=(f[l>>2]|0)+24}else q$a(d,g);z_a(g);Q_a(j);Q_a(h);t=n}else t=a;u=e;return t|0}function V$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+64|0;g=e+40|0;h=e+12|0;i=e+24|0;j=e;if((((((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==90:0)?(k=a+2|0,(b[k>>0]|0)==102):0)?(l=A$a(k,c,d)|0,(l|0)!=(k|0)):0)?(k=d+4|0,c=f[k>>2]|0,(f[d>>2]|0)!=(c|0)):0){k$a(j,c+-24|0);X_a(j,0,373224)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}Y_a(i,373011)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}n$a(g,h);o$a((f[k>>2]|0)+-24|0,g);z_a(g);Q_a(h);Q_a(i);Q_a(j);m=l}else m=a;u=e;return m|0}function W$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+64|0;g=e+40|0;h=e+12|0;i=e+24|0;j=e;a:do if((c-a|0)>2?(b[a>>0]|0)==116:0){k=b[a+1>>0]|0;switch(k<<24>>24){case 101:case 105:break;default:{l=a;break a}}m=a+2|0;if(k<<24>>24==101)n=w$a(m,c,d)|0;else n=U_a(m,c,d)|0;if((n|0)!=(m|0)?(m=d+4|0,k=f[m>>2]|0,(f[d>>2]|0)!=(k|0)):0){k$a(j,k+-24|0);X_a(j,0,373216)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];k=0;while(1){if((k|0)==3)break;f[j+(k<<2)>>2]=0;k=k+1|0}Y_a(i,373011)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];k=0;while(1){if((k|0)==3)break;f[i+(k<<2)>>2]=0;k=k+1|0}n$a(g,h);o$a((f[m>>2]|0)+-24|0,g);z_a(g);Q_a(h);Q_a(i);Q_a(j);l=n}else l=a}else l=a;while(0);u=e;return l|0}function X$a(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=5;kOa(a,c,5)|0;b[e>>0]=0;ZOa(a+5|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function Y$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+48|0;g=e+24|0;h=e;i=e+12|0;if(((((c-a|0)>2?(b[a>>0]|0)==116:0)?(b[a+1>>0]|0)==119:0)?(j=a+2|0,k=w$a(j,c,d)|0,(k|0)!=(j|0)):0)?(j=d+4|0,c=f[j>>2]|0,(f[d>>2]|0)!=(c|0)):0){k$a(i,c+-24|0);X_a(i,0,373209)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}n$a(g,h);o$a((f[j>>2]|0)+-24|0,g);z_a(g);Q_a(h);Q_a(i);l=k}else l=a;u=e;return l|0}function Z$a(a,b){a=a|0;b=b|0;_$a(a,b,YOa(b)|0);return}function _$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j)k=(f[a+8>>2]&2147483647)+-1|0;else k=10;do if(k>>>0>=d>>>0){if(j)l=f[a>>2]|0;else l=a;bZa(l,c,d)|0;b[g>>0]=0;ZOa(l+d|0,g);if((b[h>>0]|0)<0){f[a+4>>2]=d;break}else{b[h>>0]=d;break}}else{if(j)m=f[a+4>>2]|0;else m=i&255;M_a(a,k,d-k|0,m,0,m,d,c)}while(0);u=e;return}function $$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+16|0;g=e;a:do if((c-a|0)>1){h=b[a>>0]|0;i=h<<24>>24==111;switch(h<<24>>24){case 100:case 111:{if((b[a+1>>0]|0)==110){h=a+2|0;if(!i){i=u0a(h,c,d)|0;j=(i|0)==(h|0)?a:i;break a}i=g0a(h,c,d)|0;if((i|0)==(h|0)){j=a;break a}h=j$a(i,c,d)|0;if((h|0)==(i|0)){j=i;break a}i=d+4|0;k=f[i>>2]|0;if(((k-(f[d>>2]|0)|0)/24|0)>>>0<2){j=h;break a}k$a(g,k+-24|0);k=f[i>>2]|0;l=k+-24|0;m=k;while(1){if((m|0)==(l|0))break;n=m+-24|0;f[i>>2]=n;z_a(n);m=f[i>>2]|0}i=b[g+11>>0]|0;m=i<<24>>24<0;C_a(k+-48|0,m?f[g>>2]|0:g,m?f[g+4>>2]|0:i&255)|0;Q_a(g);j=h;break a}break}default:{}}i=c0a(a,c,d)|0;if((i|0)==(a|0)){m=g0a(a,c,d)|0;if((m|0)!=(a|0)){l=j$a(m,c,d)|0;if((l|0)!=(m|0)){n=d+4|0;o=f[n>>2]|0;if(((o-(f[d>>2]|0)|0)/24|0)>>>0<2)j=l;else{k$a(g,o+-24|0);o=f[n>>2]|0;p=o+-24|0;q=o;while(1){if((q|0)==(p|0))break;r=q+-24|0;f[n>>2]=r;z_a(r);q=f[n>>2]|0}n=b[g+11>>0]|0;q=n<<24>>24<0;C_a(o+-48|0,q?f[g>>2]|0:g,q?f[g+4>>2]|0:n&255)|0;Q_a(g);j=l}}else j=m}else j=a}else j=i}else j=a;while(0);u=e;return j|0}function a0a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+32|0;g=e+8|0;h=e;a:do if((a|0)==(c|0))i=a;else{j=d+16|0;switch(b[a>>0]|0){case 84:{k=d+4|0;l=((f[k>>2]|0)-(f[d>>2]|0)|0)/24|0;m=i$a(a,c,d)|0;n=f[k>>2]|0;o=(n-(f[d>>2]|0)|0)/24|0;p=n;if((m|0)!=(a|0)&(o|0)==(l+1|0)){f[h>>2]=f[d+12>>2];b$a(g,p+-24|0,h);n=d+20|0;q=f[n>>2]|0;if(q>>>0<(f[d+24>>2]|0)>>>0){f[q>>2]=0;r=q+4|0;f[r>>2]=0;s=f[g+12>>2]|0;f[q+8>>2]=0;f[q+12>>2]=s;f[q>>2]=f[g>>2];s=g+4|0;f[r>>2]=f[s>>2];r=g+8|0;f[q+8>>2]=f[r>>2];f[r>>2]=0;f[s>>2]=0;f[g>>2]=0;f[n>>2]=(f[n>>2]|0)+16}else c$a(j,g);A_a(g);i=m;break a}else{t=p;v=o}while(1){if((v|0)==(l|0)){i=a;break a}o=t+-24|0;p=t;while(1){if((p|0)==(o|0))break;m=p+-24|0;f[k>>2]=m;z_a(m);p=f[k>>2]|0}t=o;v=v+-1|0}break}case 68:{k=t$a(a,c,d)|0;if((k|0)==(a|0)){i=a;break a}l=f[d+4>>2]|0;if((f[d>>2]|0)==(l|0)){i=a;break a}f[h>>2]=f[d+12>>2];b$a(g,l+-24|0,h);l=d+20|0;p=f[l>>2]|0;if(p>>>0<(f[d+24>>2]|0)>>>0){f[p>>2]=0;m=p+4|0;f[m>>2]=0;n=f[g+12>>2]|0;f[p+8>>2]=0;f[p+12>>2]=n;f[p>>2]=f[g>>2];n=g+4|0;f[m>>2]=f[n>>2];m=g+8|0;f[p+8>>2]=f[m>>2];f[m>>2]=0;f[n>>2]=0;f[g>>2]=0;f[l>>2]=(f[l>>2]|0)+16}else c$a(j,g);A_a(g);i=k;break a;break}case 83:{k=s$a(a,c,d)|0;if((k|0)!=(a|0)){i=k;break a}if((c-a|0)<=2){i=a;break a}if((b[a+1>>0]|0)!=116){i=a;break a}k=a+2|0;l=d0a(k,c,d)|0;if((l|0)==(k|0)){i=a;break a}k=d+4|0;n=f[k>>2]|0;if((f[d>>2]|0)==(n|0)){i=a;break a}X_a(n+-24|0,0,373307)|0;n=(f[k>>2]|0)+-24|0;f[h>>2]=f[d+12>>2];b$a(g,n,h);n=d+20|0;k=f[n>>2]|0;if(k>>>0<(f[d+24>>2]|0)>>>0){f[k>>2]=0;m=k+4|0;f[m>>2]=0;p=f[g+12>>2]|0;f[k+8>>2]=0;f[k+12>>2]=p;f[k>>2]=f[g>>2];p=g+4|0;f[m>>2]=f[p>>2];m=g+8|0;f[k+8>>2]=f[m>>2];f[m>>2]=0;f[p>>2]=0;f[g>>2]=0;f[n>>2]=(f[n>>2]|0)+16}else c$a(j,g);A_a(g);i=l;break a;break}default:{i=a;break a}}}while(0);u=e;return i|0}function b0a(a,b,c){a=a|0;b=b|0;c=c|0;return c0a(a,b,c)|0}function c0a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;if((a|0)!=(c|0)?(h=l$a(a,c,d)|0,(h|0)!=(a|0)):0){i=j$a(h,c,d)|0;if((i|0)!=(h|0)){c=d+4|0;j=f[c>>2]|0;if(((j-(f[d>>2]|0)|0)/24|0)>>>0<2)k=a;else{k$a(g,j+-24|0);j=f[c>>2]|0;d=j+-24|0;l=j;while(1){if((l|0)==(d|0))break;m=l+-24|0;f[c>>2]=m;z_a(m);l=f[c>>2]|0}c=b[g+11>>0]|0;l=c<<24>>24<0;C_a(j+-48|0,l?f[g>>2]|0:g,l?f[g+4>>2]|0:c&255)|0;Q_a(g);k=i}}else k=h}else k=a;u=e;return k|0}function d0a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;a:do if((a|0)==(c|0))e=a;else switch(b[a>>0]|0){case 68:case 67:{e=e0a(a,c,d)|0;break a;break}case 85:{e=f0a(a,c,d)|0;break a;break}case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:{e=l$a(a,c,d)|0;break a;break}default:return g0a(a,c,d)|0}while(0);return e|0}function e0a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+64|0;g=e+40|0;h=e+24|0;i=e;j=e+12|0;a:do if((c-a|0)>1?(k=d+4|0,l=f[k>>2]|0,(f[d>>2]|0)!=(l|0)):0){m=a+2|0;n=d+60|0;o=a+1|0;switch(b[a>>0]|0){case 67:{switch(b[o>>0]|0){case 53:case 51:case 50:case 49:break;default:{p=a;break a}}s0a(h,l+-24|0);n$a(g,h);q=f[k>>2]|0;if(q>>>0<(f[d+8>>2]|0)>>>0){p$a(q,g);f[k>>2]=(f[k>>2]|0)+24}else q$a(d,g);z_a(g);Q_a(h);b[n>>0]=1;p=m;break a;break}case 68:break;default:{p=a;break a}}switch(b[o>>0]|0){case 53:case 50:case 49:case 48:break;default:{p=a;break a}}s0a(j,l+-24|0);X_a(j,0,373083)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];l=0;while(1){if((l|0)==3)break;f[j+(l<<2)>>2]=0;l=l+1|0}n$a(g,i);l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){p$a(l,g);f[k>>2]=(f[k>>2]|0)+24}else q$a(d,g);z_a(g);Q_a(i);Q_a(j);b[n>>0]=1;p=m}else p=a;while(0);u=e;return p|0}function f0a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=u;u=u+80|0;g=e+68|0;h=e+16|0;i=e+56|0;j=e+44|0;k=e;l=e+40|0;a:do if((c-a|0)>2?(b[a>>0]|0)==85:0){m=a+2|0;switch(b[a+1>>0]|0){case 116:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;n=YOa(373814)|0;if(n>>>0>4294967279)WYa(i);if(n>>>0<11){b[i+11>>0]=n;o=i}else{p=n+16&-16;q=N_a(p)|0;f[i>>2]=q;f[i+8>>2]=p|-2147483648;f[i+4>>2]=n;o=q}kOa(o,373814,n)|0;b[g>>0]=0;ZOa(o+n|0,g);n$a(h,i);n=d+4|0;q=f[n>>2]|0;if(q>>>0<(f[d+8>>2]|0)>>>0){p$a(q,h);f[n>>2]=(f[n>>2]|0)+24}else q$a(d,h);z_a(h);Q_a(i);if((m|0)==(c|0)){q=f[n>>2]|0;p=q+-24|0;r=q;while(1){if((r|0)==(p|0)){s=a;break a}q=r+-24|0;f[n>>2]=q;z_a(q);r=f[n>>2]|0}}if(((b[m>>0]|0)+-48|0)>>>0<10){r=a+3|0;while(1){if((r|0)==(c|0)){t=c;break}if(((b[r>>0]|0)+-48|0)>>>0>=10){t=r;break}r=r+1|0}o0a((f[n>>2]|0)+-24|0,m,t);v=t}else v=m;p0a((f[n>>2]|0)+-24|0,39);if((v|0)!=(c|0)?(b[v>>0]|0)==95:0){s=v+1|0;break a}r=f[n>>2]|0;p=r+-24|0;q=r;while(1){if((q|0)==(p|0)){s=a;break a}r=q+-24|0;f[n>>2]=r;z_a(r);q=f[n>>2]|0}break}case 108:break;default:{s=a;break a}}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;n=YOa(373823)|0;if(n>>>0>4294967279)WYa(j);if(n>>>0<11){b[j+11>>0]=n;w=j}else{q=n+16&-16;p=N_a(q)|0;f[j>>2]=p;f[j+8>>2]=q|-2147483648;f[j+4>>2]=n;w=p}kOa(w,373823,n)|0;b[g>>0]=0;ZOa(w+n|0,g);n$a(h,j);n=d+4|0;p=f[n>>2]|0;if(p>>>0<(f[d+8>>2]|0)>>>0){p$a(p,h);f[n>>2]=(f[n>>2]|0)+24}else q$a(d,h);z_a(h);Q_a(j);do if((b[m>>0]|0)!=118){p=U_a(m,c,d)|0;if((p|0)==(m|0)){q=f[n>>2]|0;r=q+-24|0;x=q;while(1){if((x|0)==(r|0)){s=a;break a}q=x+-24|0;f[n>>2]=q;z_a(q);x=f[n>>2]|0}}x=f[n>>2]|0;if(((x-(f[d>>2]|0)|0)/24|0)>>>0<2){s=a;break a}k$a(h,x+-24|0);x=f[n>>2]|0;r=x+-24|0;q=x;while(1){if((q|0)==(r|0))break;y=q+-24|0;f[n>>2]=y;z_a(y);q=f[n>>2]|0}q=h+11|0;r=b[q>>0]|0;y=r<<24>>24<0;z=h+4|0;C_a(x+-48|0,y?f[h>>2]|0:h,y?f[z>>2]|0:r&255)|0;r=p;while(1){y=U_a(r,c,d)|0;if((y|0)==(r|0)){A=60;break}B=f[n>>2]|0;if(((B-(f[d>>2]|0)|0)/24|0)>>>0<2){A=85;break}k$a(k,B+-24|0);if((b[q>>0]|0)<0){B=f[h>>2]|0;b[g>>0]=0;ZOa(B,g);f[z>>2]=0}else{b[g>>0]=0;ZOa(h,g);b[q>>0]=0}x$a(h);f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];f[h+8>>2]=f[k+8>>2];B=0;while(1){if((B|0)==3)break;f[k+(B<<2)>>2]=0;B=B+1|0}Q_a(k);B=f[n>>2]|0;C=B+-24|0;D=B;while(1){if((D|0)==(C|0))break;E=D+-24|0;f[n>>2]=E;z_a(E);D=f[n>>2]|0}D=b[q>>0]|0;if(!((D<<24>>24<0?f[z>>2]|0:D&255)|0)){r=y;continue}Y_a(B+-48|0,373235)|0;D=b[q>>0]|0;C=D<<24>>24<0;C_a((f[n>>2]|0)+-24|0,C?f[h>>2]|0:h,C?f[z>>2]|0:D&255)|0;r=y}if((A|0)==60){Y_a((f[n>>2]|0)+-24|0,373011)|0;Q_a(h);F=r;break}else if((A|0)==85){Q_a(h);s=a;break a}}else{p0a((f[n>>2]|0)+-24|0,41);F=a+3|0}while(0);if((F|0)!=(c|0)?(b[F>>0]|0)==69:0){m=F+1|0;if((m|0)==(c|0)){z=f[n>>2]|0;q=z+-24|0;p=z;while(1){if((p|0)==(q|0)){s=a;break a}z=p+-24|0;f[n>>2]=z;z_a(z);p=f[n>>2]|0}}if(((b[m>>0]|0)+-48|0)>>>0<10){p=F+2|0;while(1){if((p|0)==(c|0)){G=c;break}if(((b[p>>0]|0)+-48|0)>>>0>=10){G=p;break}p=p+1|0}p=(f[n>>2]|0)+-24|0;if((b[p+11>>0]|0)<0)H=f[p>>2]|0;else H=p;f[l>>2]=H+7;f[g>>2]=f[l>>2];q0a(p,g,m,G)|0;I=G}else I=m;if((I|0)!=(c|0)?(b[I>>0]|0)==95:0){s=I+1|0;break}p=f[n>>2]|0;q=p+-24|0;z=p;while(1){if((z|0)==(q|0)){s=a;break a}p=z+-24|0;f[n>>2]=p;z_a(p);z=f[n>>2]|0}}z=f[n>>2]|0;q=z+-24|0;m=z;while(1){if((m|0)==(q|0)){s=a;break a}z=m+-24|0;f[n>>2]=z;z_a(z);m=f[n>>2]|0}}else s=a;while(0);u=e;return s|0}function g0a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+32|0;g=e;a:do if((c-a|0)>1){h=a+2|0;i=a+1|0;do switch(b[a>>0]|0){case 97:{switch(b[i>>0]|0){case 97:{h0a(g,373313);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 110:case 100:{i0a(g,373324);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 78:{h0a(g,373334);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 83:{i0a(g,373345);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}default:{l=a;break a}}break}case 99:{switch(b[i>>0]|0){case 108:{h0a(g,373355);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 109:{i0a(g,373366);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 111:{i0a(g,373376);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[j>>2]=(f[j>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 118:{j=d+63|0;k=b[j>>0]|0;b[j>>0]=0;m=U_a(h,c,d)|0;b[j>>0]=k;if((m|0)==(h|0)){l=a;break a}k=f[d+4>>2]|0;if((f[d>>2]|0)==(k|0)){l=a;break a}X_a(k+-24|0,0,373386)|0;b[d+60>>0]=1;l=m;break a;break}default:{l=a;break a}}break}case 100:{switch(b[i>>0]|0){case 97:{j0a(g,373396);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 101:{i0a(g,373414);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 108:{k0a(g);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 118:{i0a(g,373424);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 86:{h0a(g,373434);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}default:{l=a;break a}}break}case 101:{switch(b[i>>0]|0){case 111:{i0a(g,373445);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 79:{h0a(g,373455);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 113:{h0a(g,373466);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}default:{l=a;break a}}break}case 103:{switch(b[i>>0]|0){case 101:{h0a(g,373477);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 116:{i0a(g,373488);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}default:{l=a;break a}}break}case 105:{if((b[i>>0]|0)!=120){l=a;break a}h0a(g,373498);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 108:{switch(b[i>>0]|0){case 101:{h0a(g,373509);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 105:{m=l$a(h,c,d)|0;if((m|0)==(h|0)){l=a;break a}k=f[d+4>>2]|0;if((f[d>>2]|0)==(k|0)){l=a;break a}X_a(k+-24|0,0,373520)|0;l=m;break a;break}case 115:{h0a(g,373532);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 83:{l0a(g,373543);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 116:{i0a(g,373555);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}default:{l=a;break a}}break}case 109:{switch(b[i>>0]|0){case 105:{i0a(g,373565);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 73:{h0a(g,373575);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 108:{i0a(g,373414);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 76:{h0a(g,373586);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 109:{h0a(g,373597);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}default:{l=a;break a}}break}case 110:{switch(b[i>>0]|0){case 97:{m0a(g,373608);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 101:{h0a(g,373623);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 103:{i0a(g,373565);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 116:{i0a(g,373634);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 119:{n0a(g,373644);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}default:{l=a;break a}}break}case 111:{switch(b[i>>0]|0){case 111:{h0a(g,373657);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 114:{i0a(g,373668);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 82:{h0a(g,373678);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}default:{l=a;break a}}break}case 112:{switch(b[i>>0]|0){case 109:{l0a(g,373689);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 108:{i0a(g,373701);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 76:{h0a(g,373711);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 112:{h0a(g,373722);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 115:{i0a(g,373701);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 116:{h0a(g,373733);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}default:{l=a;break a}}break}case 113:{if((b[i>>0]|0)!=117){l=a;break a}i0a(g,373744);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 114:{switch(b[i>>0]|0){case 109:{i0a(g,373754);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 77:{h0a(g,373764);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 115:{h0a(g,373775);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}case 83:{l0a(g,373786);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){p$a(k,g);f[m>>2]=(f[m>>2]|0)+24}else q$a(d,g);z_a(g);l=h;break a;break}default:{l=a;break a}}break}case 118:{if(((b[i>>0]|0)+-48|0)>>>0>=10){l=a;break a}m=l$a(h,c,d)|0;if((m|0)==(h|0)){l=a;break a}k=f[d+4>>2]|0;if((f[d>>2]|0)==(k|0)){l=a;break a}X_a(k+-24|0,0,373386)|0;l=m;break a;break}default:{l=a;break a}}while(0)}else l=a;while(0);u=e;return l|0}function h0a(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=10;kOa(a,c,10)|0;b[e>>0]=0;ZOa(a+10|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function i0a(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=9;kOa(a,c,9)|0;b[e>>0]=0;ZOa(a+9|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function j0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=N_a(32)|0;f[a>>2]=g;f[a+8>>2]=-2147483616;f[a+4>>2]=17;kOa(g,c,17)|0;b[e>>0]=0;ZOa(g+17|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function k0a(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=N_a(16)|0;f[a>>2]=e;f[a+8>>2]=-2147483632;f[a+4>>2]=15;kOa(e,373798,15)|0;b[d>>0]=0;ZOa(e+15|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function l0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=N_a(16)|0;f[a>>2]=g;f[a+8>>2]=-2147483632;f[a+4>>2]=11;kOa(g,c,11)|0;b[e>>0]=0;ZOa(g+11|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function m0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=N_a(16)|0;f[a>>2]=g;f[a+8>>2]=-2147483632;f[a+4>>2]=14;kOa(g,c,14)|0;b[e>>0]=0;ZOa(g+14|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function n0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=N_a(16)|0;f[a>>2]=g;f[a+8>>2]=-2147483632;f[a+4>>2]=12;kOa(g,c,12)|0;b[e>>0]=0;ZOa(g+12|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function o0a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+16|0;g=c;h=e+12|0;i=e;j=a+11|0;k=b[j>>0]|0;l=k<<24>>24<0;if(l){m=f[a+4>>2]|0;n=(f[a+8>>2]&2147483647)+-1|0}else{m=k&255;n=10}o=d-g|0;do if(o|0){if(l){p=f[a>>2]|0;q=p;r=p;s=f[a+4>>2]|0}else{q=a;r=a;s=k&255}if(lZa(c,r,q+s|0)|0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(o>>>0>4294967279)WYa(i);if(o>>>0<11){b[i+11>>0]=o;t=i}else{p=o+16&-16;v=N_a(p)|0;f[i>>2]=v;f[i+8>>2]=p|-2147483648;f[i+4>>2]=o;t=v}v=c;p=t;while(1){if((v|0)==(d|0))break;ZOa(p,v);v=v+1|0;p=p+1|0}b[h>>0]=0;ZOa(t+o|0,h);p=b[i+11>>0]|0;v=p<<24>>24<0;C_a(a,v?f[i>>2]|0:i,v?f[i+4>>2]|0:p&255)|0;Q_a(i);break}p=m+o|0;if((n-m|0)>>>0<o>>>0)r0a(a,n,p-n|0,m,m,0);if((b[j>>0]|0)<0)w=f[a>>2]|0;else w=a;v=d+(m-g)|0;x=c;y=w+m|0;while(1){if((x|0)==(d|0))break;ZOa(y,x);x=x+1|0;y=y+1|0}b[h>>0]=0;ZOa(w+v|0,h);if((b[j>>0]|0)<0){f[a+4>>2]=p;break}else{b[j>>0]=p;break}}while(0);u=e;return}function p0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;g=d+1|0;b[e>>0]=c;c=a+11|0;h=b[c>>0]|0;i=h<<24>>24<0;if(i){j=(f[a+8>>2]&2147483647)+-1|0;k=f[a+4>>2]|0}else{j=10;k=h&255}if((k|0)==(j|0)){r0a(a,j,1,j,j,0);h=j+1|0;if((b[c>>0]|0)<0){l=h;m=8}else{n=h;m=7}}else{h=k+1|0;if(i){l=h;m=8}else{n=h;m=7}}if((m|0)==7){b[c>>0]=n;o=a}else if((m|0)==8){m=f[a>>2]|0;f[a+4>>2]=l;o=m}m=o+k|0;ZOa(m,e);b[g>>0]=0;ZOa(m+1|0,g);u=d;return}function q0a(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=u;u=u+32|0;h=g+16|0;i=g;j=g+12|0;k=a+11|0;l=b[k>>0]|0;m=l<<24>>24<0;if(m)n=f[a>>2]|0;else n=a;o=f[c>>2]|0;c=o-n|0;n=e-d|0;do if(!n){p=l;q=35}else{if(m){r=f[a>>2]|0;s=r;t=r;v=f[a+4>>2]|0}else{s=a;t=a;v=l&255}if(lZa(d,s,t+v|0)|0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(n>>>0>4294967279)WYa(i);if(n>>>0<11){b[i+11>>0]=n;w=i}else{r=n+16&-16;x=N_a(r)|0;f[i>>2]=x;f[i+8>>2]=r|-2147483648;f[i+4>>2]=n;w=x}x=d;r=w;while(1){if((x|0)==(e|0))break;ZOa(r,x);x=x+1|0;r=r+1|0}b[h>>0]=0;ZOa(w+n|0,h);f[j>>2]=o;r=b[i+11>>0]|0;x=r<<24>>24<0;y=x?f[i>>2]|0:i;z=y+(x?f[i+4>>2]|0:r&255)|0;f[h>>2]=f[j>>2];r=q0a(a,h,y,z)|0;Q_a(i);A=r;break}r=b[k>>0]|0;z=r<<24>>24<0;if(z){B=(f[a+8>>2]&2147483647)+-1|0;C=f[a+4>>2]|0}else{B=10;C=r&255}r=C+n|0;if((B-C|0)>>>0>=n>>>0){if(z)D=f[a>>2]|0;else D=a;z=C-c|0;if(!z)E=D;else{y=D+c|0;bZa(y+n|0,y,z)|0;E=D}}else{r0a(a,B,r-B|0,C,c,n);E=f[a>>2]|0}if((b[k>>0]|0)<0)f[a+4>>2]=r;else b[k>>0]=r;b[h>>0]=0;ZOa(E+r|0,h);r=d;z=E+c|0;while(1){if((r|0)==(e|0))break;ZOa(z,r);r=r+1|0;z=z+1|0}p=b[k>>0]|0;q=35}while(0);if((q|0)==35){if(p<<24>>24<0)F=f[a>>2]|0;else F=a;A=F+c|0}u=g;return A|0}function r0a(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;if((-17-c|0)>>>0<d>>>0)WYa(a);if((b[a+11>>0]|0)<0)i=f[a>>2]|0;else i=a;if(c>>>0<2147483623){j=d+c|0;d=c<<1;k=j>>>0<d>>>0?d:j;l=k>>>0<11?11:k+16&-16}else l=-17;k=N_a(l)|0;if(g|0)kOa(k,i,g)|0;j=e-g|0;if(j|0)kOa(k+g+h|0,i+g|0,j)|0;if((c|0)!=10)O_a(i);f[a>>2]=k;f[a+8>>2]=l|-2147483648;return}function s0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+11|0;h=b[g>>0]|0;i=c+4|0;a:do if(!((h<<24>>24<0?f[i>>2]|0:h&255)|0))t0a(a,c);else{j=YOa(373833)|0;k=b[g>>0]|0;if((j|0)==((k<<24>>24<0?f[i>>2]|0:k&255)|0)?(g$a(c,373833,j)|0)==0:0){Z$a(c,373845);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;j=YOa(373916)|0;if(j>>>0>4294967279)WYa(a);if(j>>>0<11){b[a+11>>0]=j;l=a}else{k=j+16&-16;m=N_a(k)|0;f[a>>2]=m;f[a+8>>2]=k|-2147483648;f[a+4>>2]=j;l=m}kOa(l,373916,j)|0;b[e>>0]=0;ZOa(l+j|0,e);break}j=YOa(373929)|0;m=b[g>>0]|0;if((j|0)==((m<<24>>24<0?f[i>>2]|0:m&255)|0)?(g$a(c,373929,j)|0)==0:0){Z$a(c,373942);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;j=YOa(373992)|0;if(j>>>0>4294967279)WYa(a);if(j>>>0<11){b[a+11>>0]=j;n=a}else{m=j+16&-16;k=N_a(m)|0;f[a>>2]=k;f[a+8>>2]=m|-2147483648;f[a+4>>2]=j;n=k}kOa(n,373992,j)|0;b[e>>0]=0;ZOa(n+j|0,e);break}j=YOa(374006)|0;k=b[g>>0]|0;if((j|0)==((k<<24>>24<0?f[i>>2]|0:k&255)|0)?(g$a(c,374006,j)|0)==0:0){Z$a(c,374019);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;j=YOa(374069)|0;if(j>>>0>4294967279)WYa(a);if(j>>>0<11){b[a+11>>0]=j;o=a}else{k=j+16&-16;m=N_a(k)|0;f[a>>2]=m;f[a+8>>2]=k|-2147483648;f[a+4>>2]=j;o=m}kOa(o,374069,j)|0;b[e>>0]=0;ZOa(o+j|0,e);break}j=YOa(374083)|0;m=b[g>>0]|0;k=f[i>>2]|0;do if((j|0)==((m<<24>>24<0?k:m&255)|0)){if(g$a(c,374083,j)|0){p=b[g>>0]|0;q=f[i>>2]|0;break}Z$a(c,374097);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;r=YOa(374148)|0;if(r>>>0>4294967279)WYa(a);if(r>>>0<11){b[a+11>>0]=r;s=a}else{t=r+16&-16;v=N_a(t)|0;f[a>>2]=v;f[a+8>>2]=t|-2147483648;f[a+4>>2]=r;s=v}kOa(s,374148,r)|0;b[e>>0]=0;ZOa(s+r|0,e);break a}else{p=m;q=k}while(0);k=p<<24>>24<0;m=k?f[c>>2]|0:c;j=m+(k?q:p&255)|0;b:do if((b[j+-1>>0]|0)==62){k=1;r=j;c:while(1){v=r;d:while(1){w=v+-1|0;if((w|0)==(m|0))break c;x=v+-2|0;switch(b[x>>0]|0){case 60:{y=43;break d;break}case 62:{y=44;break d;break}default:v=w}}if((y|0)==43){y=0;v=k+-1|0;if(!v){z=x;break b}else{k=v;r=w;continue}}else if((y|0)==44){y=0;k=k+1|0;r=w;continue}}f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;r=0;while(1){if((r|0)==3)break a;f[a+(r<<2)>>2]=0;r=r+1|0}}else z=j;while(0);j=z;while(1){r=j+-1|0;if((r|0)==(m|0)){A=m;break}if((b[r>>0]|0)==58){A=j;break}else j=r}f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;j=z-A|0;if(j>>>0>4294967279)WYa(a);if(j>>>0<11){b[a+11>>0]=j;B=a}else{m=j+16&-16;r=N_a(m)|0;f[a>>2]=r;f[a+8>>2]=m|-2147483648;f[a+4>>2]=j;B=r}r=A;m=B;while(1){if((r|0)==(z|0))break;ZOa(m,r);r=r+1|0;m=m+1|0}b[e>>0]=0;ZOa(B+j|0,e)}while(0);u=d;return}function t0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if((b[c+11>>0]|0)<0){g=f[c>>2]|0;h=f[c+4>>2]|0;if(h>>>0>4294967279)WYa(a);if(h>>>0<11){b[a+11>>0]=h;i=a}else{j=h+16&-16;k=N_a(j)|0;f[a>>2]=k;f[a+8>>2]=j|-2147483648;f[a+4>>2]=h;i=k}kOa(i,g,h)|0;b[e>>0]=0;ZOa(i+h|0,e)}else{f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2]}u=d;return}function u0a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;if((a|0)!=(b|0)){d=a0a(a,b,c)|0;if((d|0)==(a|0))e=c0a(a,b,c)|0;else e=d;if((e|0)!=(a|0)?(d=f[c+4>>2]|0,(f[c>>2]|0)!=(d|0)):0){X_a(d+-24|0,0,373083)|0;g=e}else g=a}else g=a;return g|0}function v0a(a){a=a|0;var b=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}b=a+12|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[b+(a<<2)>>2]=0;a=a+1|0}return}function w0a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=u;u=u+32|0;c=b;d=a+4|0;e=(((f[d>>2]|0)-(f[a>>2]|0)|0)/24|0)+1|0;g=x0a(a)|0;if(g>>>0<e>>>0)gXa(a);else{h=f[a>>2]|0;i=((f[a+8>>2]|0)-h|0)/24|0;j=i<<1;y0a(c,i>>>0<g>>>1>>>0?(j>>>0<e>>>0?e:j):g,((f[d>>2]|0)-h|0)/24|0,a+12|0);h=c+8|0;d=f[h>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;v0a(d);f[h>>2]=d+24;z0a(a,c);A0a(c);u=b;return}}function x0a(a){a=a|0;return 178956970}function y0a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;f[a+12>>2]=0;f[a+16>>2]=d;if(!b)e=0;else e=B0a(d,b)|0;f[a>>2]=e;d=e+(c*24|0)|0;f[a+8>>2]=d;f[a+4>>2]=d;f[a+12>>2]=e+(b*24|0);return}function z0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[a>>2]|0;d=a+4|0;e=b+4|0;g=f[d>>2]|0;while(1){if((g|0)==(c|0))break;h=g+-24|0;p$a((f[e>>2]|0)+-24|0,h);f[e>>2]=(f[e>>2]|0)+-24;g=h}g=f[a>>2]|0;f[a>>2]=f[e>>2];f[e>>2]=g;g=b+8|0;c=f[d>>2]|0;f[d>>2]=f[g>>2];f[g>>2]=c;c=a+8|0;a=b+12|0;g=f[c>>2]|0;f[c>>2]=f[a>>2];f[a>>2]=g;f[b>>2]=f[e>>2];return}function A0a(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+4>>2]|0;c=a+8|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-24|0;f[c>>2]=e;z_a(e)}c=f[a>>2]|0;if(c|0)P_a(f[a+16>>2]|0,c,((f[a+12>>2]|0)-c|0)/24|0);return}function B0a(a,b){a=a|0;b=b|0;return C0a(f[a>>2]|0,b*24|0)|0}function C0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=K_a(b)|0;b=a+4096|0;d=f[b>>2]|0;if((a+4096-d|0)>>>0<c>>>0)e=dKa(c)|0;else{f[b>>2]=d+c;e=d}return e|0}function D0a(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+48|0;h=g+24|0;i=g;j=g+12|0;k=v$a(a,c)|0;if(!((k|0)==(a|0)|(k|0)==(c|0))?(b[k>>0]|0)==69:0){c=d+11|0;l=b[c>>0]|0;m=d+4|0;do if((l<<24>>24<0?f[m>>2]|0:l&255)>>>0<=3){n=e+4|0;o=f[n>>2]|0;if(o>>>0<(f[e+8>>2]|0)>>>0){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;v0a(o);f[n>>2]=(f[n>>2]|0)+24;break}else{w0a(e);break}}else{y$a(j,373013,d);Y_a(j,373011)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];n=0;while(1){if((n|0)==3)break;f[j+(n<<2)>>2]=0;n=n+1|0}n$a(h,i);n=e+4|0;o=f[n>>2]|0;if(o>>>0<(f[e+8>>2]|0)>>>0){p$a(o,h);f[n>>2]=(f[n>>2]|0)+24}else q$a(e,h);z_a(h);Q_a(i);Q_a(j)}while(0);j=e+4|0;if((b[a>>0]|0)==110){p0a((f[j>>2]|0)+-24|0,45);p=a+1|0}else p=a;o0a((f[j>>2]|0)+-24|0,p,k);p=b[c>>0]|0;c=p<<24>>24<0;e=c?f[m>>2]|0:p&255;if(e>>>0<4)C_a((f[j>>2]|0)+-24|0,c?f[d>>2]|0:d,e)|0;q=k+1|0}else q=a;u=g;return q|0}function E0a(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=4;kOa(a,c,4)|0;b[e>>0]=0;ZOa(a+4|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function F0a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+80|0;g=e;h=e+44|0;i=e+48|0;j=e+8|0;k=e+32|0;a:do if((c-a|0)>>>0>8){l=h;m=0;while(1){o=b[a+m>>0]|0;q=o<<24>>24;r=a+(m|1)|0;if((m|0)==8){s=6;break}if(!(fNa(q)|0))break;t=b[r>>0]|0;b[l>>0]=t+(((q+-48|0)>>>0<10?0:9)+q<<4)+((t+-48|0)>>>0<10?208:169);l=l+1|0;m=m+2|0}do if((s|0)==6){if(o<<24>>24==69){b:do if((h|0)!=(l|0)){m=h;t=l;while(1){q=t+-1|0;if(m>>>0>=q>>>0)break b;v=b[m>>0]|0;b[m>>0]=b[q>>0]|0;b[q>>0]=v;m=m+1|0;t=q}}while(0);t=i;m=t+24|0;do{b[t>>0]=0;t=t+1|0}while((t|0)<(m|0));p[g>>3]=+n[h>>2];t=pLa(i,24,374325,g)|0;if(t>>>0>23)break;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(t>>>0<11){b[k+11>>0]=t;w=k}else{m=t+16&-16;q=N_a(m)|0;f[k>>2]=q;f[k+8>>2]=m|-2147483648;f[k+4>>2]=t;w=q}kOa(w,i,t)|0;b[g>>0]=0;ZOa(w+t|0,g);n$a(j,k);t=d+4|0;q=f[t>>2]|0;if(q>>>0<(f[d+8>>2]|0)>>>0){p$a(q,j);f[t>>2]=(f[t>>2]|0)+24}else q$a(d,j);z_a(j);Q_a(k);x=r}else x=a;y=x;break a}while(0);y=a}else y=a;while(0);u=e;return y|0}function G0a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+96|0;g=e+8|0;h=e;i=e+56|0;j=e+16|0;k=e+40|0;a:do if((c-a|0)>>>0>16){l=h;m=0;while(1){n=b[a+m>>0]|0;o=n<<24>>24;q=a+(m|1)|0;if((m|0)==16){r=6;break}if(!(fNa(o)|0))break;s=b[q>>0]|0;b[l>>0]=s+(((o+-48|0)>>>0<10?0:9)+o<<4)+((s+-48|0)>>>0<10?208:169);l=l+1|0;m=m+2|0}do if((r|0)==6){if(n<<24>>24==69){b:do if((h|0)!=(l|0)){m=h;s=l;while(1){o=s+-1|0;if(m>>>0>=o>>>0)break b;t=b[m>>0]|0;b[m>>0]=b[o>>0]|0;b[o>>0]=t;m=m+1|0;s=o}}while(0);s=i;m=s+32|0;do{b[s>>0]=0;s=s+1|0}while((s|0)<(m|0));p[g>>3]=+p[h>>3];s=pLa(i,32,374322,g)|0;if(s>>>0>31)break;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(s>>>0<11){b[k+11>>0]=s;v=k}else{m=s+16&-16;o=N_a(m)|0;f[k>>2]=o;f[k+8>>2]=m|-2147483648;f[k+4>>2]=s;v=o}kOa(v,i,s)|0;b[g>>0]=0;ZOa(v+s|0,g);n$a(j,k);s=d+4|0;o=f[s>>2]|0;if(o>>>0<(f[d+8>>2]|0)>>>0){p$a(o,j);f[s>>2]=(f[s>>2]|0)+24}else q$a(d,j);z_a(j);Q_a(k);w=q}else w=a;x=w;break a}while(0);x=a}else x=a;while(0);u=e;return x|0}function H0a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+96|0;g=e+8|0;h=e;i=e+56|0;j=e+16|0;k=e+40|0;a:do if((c-a|0)>>>0>20){l=h;m=0;while(1){n=b[a+m>>0]|0;o=n<<24>>24;q=a+(m|1)|0;if((m|0)==20){r=6;break}if(!(fNa(o)|0))break;s=b[q>>0]|0;b[l>>0]=s+(((o+-48|0)>>>0<10?0:9)+o<<4)+((s+-48|0)>>>0<10?208:169);l=l+1|0;m=m+2|0}do if((r|0)==6){if(n<<24>>24==69){b:do if((h|0)!=(l|0)){m=h;s=l;while(1){o=s+-1|0;if(m>>>0>=o>>>0)break b;t=b[m>>0]|0;b[m>>0]=b[o>>0]|0;b[o>>0]=t;m=m+1|0;s=o}}while(0);s=i;m=s+40|0;do{b[s>>0]=0;s=s+1|0}while((s|0)<(m|0));p[g>>3]=+p[h>>3];s=pLa(i,40,374317,g)|0;if(s>>>0>39)break;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(s>>>0<11){b[k+11>>0]=s;v=k}else{m=s+16&-16;o=N_a(m)|0;f[k>>2]=o;f[k+8>>2]=m|-2147483648;f[k+4>>2]=s;v=o}kOa(v,i,s)|0;b[g>>0]=0;ZOa(v+s|0,g);n$a(j,k);s=d+4|0;o=f[s>>2]|0;if(o>>>0<(f[d+8>>2]|0)>>>0){p$a(o,j);f[s>>2]=(f[s>>2]|0)+24}else q$a(d,j);z_a(j);Q_a(k);w=q}else w=a;x=w;break a}while(0);x=a}else x=a;while(0);u=e;return x|0}function I0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=N_a(16)|0;f[a>>2]=g;f[a+8>>2]=-2147483632;f[a+4>>2]=13;kOa(g,c,13)|0;b[e>>0]=0;ZOa(g+13|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function J0a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+8|0;j=e;a:do if((a|0)!=(c|0)?(b[a>>0]|0)==78:0){k=V_a(a+1|0,c,g)|0;b:do if((k|0)!=(c|0)){l=d+52|0;f[l>>2]=0;m=k+1|0;switch(b[k>>0]|0){case 82:{n=1;o=6;break}case 79:{n=2;o=6;break}default:p=k}if((o|0)==6){f[l>>2]=n;p=m}m=d+4|0;l=f[m>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;v0a(l);f[m>>2]=(f[m>>2]|0)+24}else w0a(d);if(((c-p|0)>1?(b[p>>0]|0)==83:0)?(b[p+1>>0]|0)==116:0){Z$a((f[m>>2]|0)+-24|0,374389);q=p+2|0}else q=p;if((q|0)==(c|0)){l=f[m>>2]|0;r=l+-24|0;s=l;while(1){if((s|0)==(r|0))break b;l=s+-24|0;f[m>>2]=l;z_a(l);s=f[m>>2]|0}}s=d+16|0;r=h+11|0;l=h+4|0;t=d+12|0;v=d+20|0;w=d+24|0;x=i+12|0;y=i+4|0;z=i+8|0;A=i+12|0;B=i+4|0;C=i+8|0;D=i+11|0;E=i+4|0;F=i+11|0;G=i+4|0;H=i+12|0;I=i+4|0;J=i+8|0;K=i+12|0;L=i+4|0;M=i+8|0;N=i+11|0;O=i+4|0;P=i+12|0;Q=i+4|0;R=i+8|0;S=i+11|0;T=i+4|0;U=0;V=q;c:while(1){W=V;d:while(1){X=b[W>>0]|0;Y=W+1|0;if(X<<24>>24==69)break c;switch(X<<24>>24|0){case 83:{o=21;break d;break}case 84:{o=37;break d;break}case 68:{o=51;break d;break}case 73:break;case 76:{if((Y|0)==(c|0))break b;else{W=Y;continue d}break}default:break d}X=j$a(W,c,d)|0;if((X|0)==(W|0)|(X|0)==(c|0))break b;k$a(h,(f[m>>2]|0)+-24|0);Z=f[m>>2]|0;_=Z+-24|0;$=Z;while(1){if(($|0)==(_|0))break;aa=$+-24|0;f[m>>2]=aa;z_a(aa);$=f[m>>2]|0}$=b[r>>0]|0;_=$<<24>>24<0;C_a(Z+-48|0,_?f[h>>2]|0:h,_?f[l>>2]|0:$&255)|0;$=(f[m>>2]|0)+-24|0;f[j>>2]=f[t>>2];b$a(i,$,j);$=f[v>>2]|0;if($>>>0<(f[w>>2]|0)>>>0){f[$>>2]=0;_=$+4|0;f[_>>2]=0;aa=f[x>>2]|0;f[$+8>>2]=0;f[$+12>>2]=aa;f[$>>2]=f[i>>2];f[_>>2]=f[y>>2];f[$+8>>2]=f[z>>2];f[z>>2]=0;f[y>>2]=0;f[i>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else c$a(s,i);A_a(i);Q_a(h);W=X}e:do if((o|0)==21){o=0;if((Y|0)!=(c|0)?(b[Y>>0]|0)==116:0)break;$=s$a(W,c,d)|0;if(($|0)==(W|0)|($|0)==(c|0))break b;k$a(h,(f[m>>2]|0)+-24|0);_=f[m>>2]|0;aa=_+-24|0;ba=_;while(1){if((ba|0)==(aa|0))break;ca=ba+-24|0;f[m>>2]=ca;z_a(ca);ba=f[m>>2]|0}ba=_+-48|0;aa=b[ba+11>>0]|0;if(aa<<24>>24<0)da=f[_+-44>>2]|0;else da=aa&255;if(!da)N0a(ba,h);else{y$a(i,373085,h);ba=b[F>>0]|0;aa=ba<<24>>24<0;C_a((f[m>>2]|0)+-24|0,aa?f[i>>2]|0:i,aa?f[G>>2]|0:ba&255)|0;Q_a(i);ba=(f[m>>2]|0)+-24|0;f[j>>2]=f[t>>2];b$a(i,ba,j);ba=f[v>>2]|0;if(ba>>>0<(f[w>>2]|0)>>>0){f[ba>>2]=0;aa=ba+4|0;f[aa>>2]=0;X=f[H>>2]|0;f[ba+8>>2]=0;f[ba+12>>2]=X;f[ba>>2]=f[i>>2];f[aa>>2]=f[I>>2];f[ba+8>>2]=f[J>>2];f[J>>2]=0;f[I>>2]=0;f[i>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else c$a(s,i);A_a(i)}Q_a(h);U=1;V=$;continue c}else if((o|0)==37){o=0;ba=i$a(W,c,d)|0;if((ba|0)==(W|0)|(ba|0)==(c|0))break b;k$a(h,(f[m>>2]|0)+-24|0);aa=f[m>>2]|0;X=aa+-24|0;Z=aa;while(1){if((Z|0)==(X|0))break;ca=Z+-24|0;f[m>>2]=ca;z_a(ca);Z=f[m>>2]|0}Z=aa+-48|0;X=b[Z+11>>0]|0;if(X<<24>>24<0)ea=f[aa+-44>>2]|0;else ea=X&255;if(!ea)N0a(Z,h);else{y$a(i,373085,h);Z=b[N>>0]|0;X=Z<<24>>24<0;C_a((f[m>>2]|0)+-24|0,X?f[i>>2]|0:i,X?f[O>>2]|0:Z&255)|0;Q_a(i)}Z=(f[m>>2]|0)+-24|0;f[j>>2]=f[t>>2];b$a(i,Z,j);Z=f[v>>2]|0;if(Z>>>0<(f[w>>2]|0)>>>0){f[Z>>2]=0;X=Z+4|0;f[X>>2]=0;$=f[K>>2]|0;f[Z+8>>2]=0;f[Z+12>>2]=$;f[Z>>2]=f[i>>2];f[X>>2]=f[L>>2];f[Z+8>>2]=f[M>>2];f[M>>2]=0;f[L>>2]=0;f[i>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else c$a(s,i);A_a(i);Q_a(h);U=1;V=ba;continue c}else if((o|0)==51){o=0;if((Y|0)!=(c|0))switch(b[Y>>0]|0){case 84:case 116:break;default:break e}Z=t$a(W,c,d)|0;if((Z|0)==(W|0)|(Z|0)==(c|0))break b;k$a(h,(f[m>>2]|0)+-24|0);X=f[m>>2]|0;$=X+-24|0;_=X;while(1){if((_|0)==($|0))break;ca=_+-24|0;f[m>>2]=ca;z_a(ca);_=f[m>>2]|0}_=X+-48|0;$=b[_+11>>0]|0;if($<<24>>24<0)fa=f[X+-44>>2]|0;else fa=$&255;if(!fa)N0a(_,h);else{y$a(i,373085,h);_=b[S>>0]|0;$=_<<24>>24<0;C_a((f[m>>2]|0)+-24|0,$?f[i>>2]|0:i,$?f[T>>2]|0:_&255)|0;Q_a(i)}_=(f[m>>2]|0)+-24|0;f[j>>2]=f[t>>2];b$a(i,_,j);_=f[v>>2]|0;if(_>>>0<(f[w>>2]|0)>>>0){f[_>>2]=0;$=_+4|0;f[$>>2]=0;ba=f[P>>2]|0;f[_+8>>2]=0;f[_+12>>2]=ba;f[_>>2]=f[i>>2];f[$>>2]=f[Q>>2];f[_+8>>2]=f[R>>2];f[R>>2]=0;f[Q>>2]=0;f[i>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else c$a(s,i);A_a(i);Q_a(h);U=1;V=Z;continue c}while(0);_=d0a(W,c,d)|0;if((_|0)==(W|0)|(_|0)==(c|0))break b;k$a(h,(f[m>>2]|0)+-24|0);$=f[m>>2]|0;ba=$+-24|0;aa=$;while(1){if((aa|0)==(ba|0))break;ca=aa+-24|0;f[m>>2]=ca;z_a(ca);aa=f[m>>2]|0}aa=$+-48|0;ba=b[aa+11>>0]|0;if(ba<<24>>24<0)ga=f[$+-44>>2]|0;else ga=ba&255;if(!ga)N0a(aa,h);else{y$a(i,373085,h);aa=b[D>>0]|0;ba=aa<<24>>24<0;C_a((f[m>>2]|0)+-24|0,ba?f[i>>2]|0:i,ba?f[E>>2]|0:aa&255)|0;Q_a(i)}aa=(f[m>>2]|0)+-24|0;f[j>>2]=f[t>>2];b$a(i,aa,j);aa=f[v>>2]|0;if(aa>>>0<(f[w>>2]|0)>>>0){f[aa>>2]=0;ba=aa+4|0;f[ba>>2]=0;W=f[A>>2]|0;f[aa+8>>2]=0;f[aa+12>>2]=W;f[aa>>2]=f[i>>2];f[ba>>2]=f[B>>2];f[aa+8>>2]=f[C>>2];f[C>>2]=0;f[B>>2]=0;f[i>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else c$a(s,i);A_a(i);Q_a(h);U=1;V=_}f[d+48>>2]=f[g>>2];f:do if(U?(V=f[v>>2]|0,(f[s>>2]|0)!=(V|0)):0){B=V+-16|0;C=V;while(1){if((C|0)==(B|0))break f;V=C+-16|0;f[v>>2]=V;A_a(V);C=f[v>>2]|0}}while(0);ha=Y;break a}while(0);ha=a}else ha=a;while(0);u=e;return ha|0}function K0a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+16|0;g=e;a:do if(((((a|0)!=(c|0)?(b[a>>0]|0)==90:0)?(h=a+1|0,i=R_a(h,c,d)|0,!((i|0)==(h|0)|(i|0)==(c|0))):0)?(b[i>>0]|0)==69:0)?(h=i+1|0,(h|0)!=(c|0)):0){j=i+2|0;switch(b[h>>0]|0){case 115:{i=M0a(j,c)|0;k=f[d+4>>2]|0;if((f[d>>2]|0)==(k|0)){l=i;break a}Y_a(k+-24|0,374372)|0;l=i;break a;break}case 100:{if((j|0)==(c|0)){l=a;break a}i=v$a(j,c)|0;if((i|0)==(c|0)){l=a;break a}if((b[i>>0]|0)!=95){l=a;break a}j=i+1|0;i=r$a(j,c,d)|0;k=d+4|0;if((i|0)==(j|0)){j=f[k>>2]|0;m=j+-24|0;n=j;while(1){if((n|0)==(m|0)){l=a;break a}j=n+-24|0;f[k>>2]=j;z_a(j);n=f[k>>2]|0}}n=f[k>>2]|0;if(((n-(f[d>>2]|0)|0)/24|0)>>>0<2){l=a;break a}k$a(g,n+-24|0);n=f[k>>2]|0;m=n+-24|0;j=n;while(1){if((j|0)==(m|0))break;o=j+-24|0;f[k>>2]=o;z_a(o);j=f[k>>2]|0}Y_a(n+-48|0,373085)|0;j=b[g+11>>0]|0;m=j<<24>>24<0;C_a((f[k>>2]|0)+-24|0,m?f[g>>2]|0:g,m?f[g+4>>2]|0:j&255)|0;Q_a(g);l=i;break a;break}default:{j=r$a(h,c,d)|0;if((j|0)==(h|0)){m=d+4|0;o=f[m>>2]|0;p=o+-24|0;q=o;while(1){if((q|0)==(p|0)){l=a;break a}o=q+-24|0;f[m>>2]=o;z_a(o);q=f[m>>2]|0}}m=M0a(j,c)|0;q=d+4|0;p=f[q>>2]|0;if(((p-(f[d>>2]|0)|0)/24|0)>>>0<2){l=m;break a}k$a(g,p+-24|0);p=f[q>>2]|0;h=p+-24|0;i=p;while(1){if((i|0)==(h|0))break;k=i+-24|0;f[q>>2]=k;z_a(k);i=f[q>>2]|0}Y_a(p+-48|0,373085)|0;i=b[g+11>>0]|0;h=i<<24>>24<0;C_a((f[q>>2]|0)+-24|0,h?f[g>>2]|0:g,h?f[g+4>>2]|0:i&255)|0;Q_a(g);l=m;break a}}}else l=a;while(0);u=e;return l|0}function L0a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;if((c-a|0)>1){if((b[a>>0]|0)==83?(b[a+1>>0]|0)==116:0){e=a+2|0;if((e|0)==(c|0)){g=0;h=c}else{g=0;h=(b[e>>0]|0)==76?a+3|0:e}}else{g=1;h=a}e=d0a(h,c,d)|0;c=(e|0)==(h|0);if(!(g|c)){g=f[d+4>>2]|0;if((f[d>>2]|0)==(g|0))i=a;else{X_a(g+-24|0,0,373307)|0;i=e}}else i=c?a:e}else i=a;return i|0}function M0a(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;a:do if((a|0)!=(c|0)){d=b[a>>0]|0;e=a+1|0;if(d<<24>>24!=95){if(((d<<24>>24)+-48|0)>>>0<10)f=e;else{g=a;break}while(1){if((f|0)==(c|0)){g=c;break a}if(((b[f>>0]|0)+-48|0)>>>0>=10){g=f;break a}f=f+1|0}}if((e|0)!=(c|0)){d=b[e>>0]|0;h=a+2|0;if(((d<<24>>24)+-48|0)>>>0>=10)if(d<<24>>24==95){d=h;do{i=d;d=d+1|0;if((i|0)==(c|0)){g=a;break a}j=b[i>>0]|0}while(((j<<24>>24)+-48|0)>>>0<10);return (j<<24>>24==95?d:a)|0}else g=a;else g=h}else g=a}else g=a;while(0);return g|0}function N0a(a,c){a=a|0;c=c|0;var d=0,e=0;if((a|0)!=(c|0)){d=b[c+11>>0]|0;e=d<<24>>24<0;_$a(a,e?f[c>>2]|0:c,e?f[c+4>>2]|0:d&255)}return}function O0a(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=N_a(32)|0;f[a>>2]=e;f[a+8>>2]=-2147483616;f[a+4>>2]=21;kOa(e,374404,21)|0;b[d>>0]=0;ZOa(e+21|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function P0a(a,b){a=a|0;b=b|0;f[a>>2]=f[b>>2];return}function Q0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+32|0;d=c+20|0;e=c;g=a+4|0;h=((f[g>>2]|0)-(f[a>>2]|0)>>4)+1|0;i=S0a(a)|0;if(i>>>0<h>>>0)gXa(a);else{j=f[a>>2]|0;k=(f[a+8>>2]|0)-j|0;l=k>>3;T0a(e,k>>4>>>0<i>>>1>>>0?(l>>>0<h>>>0?h:l):i,(f[g>>2]|0)-j>>4,a+12|0);j=e+8|0;g=f[j>>2]|0;P0a(d,b);f[g>>2]=0;f[g+4>>2]=0;b=f[d>>2]|0;f[g+8>>2]=0;f[g+12>>2]=b;f[j>>2]=g+16;U0a(a,e);V0a(e);u=c;return}}function R0a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;a:do if((a|0)==(c|0))e=a;else{f=a+1|0;switch(b[a>>0]|0){case 88:{g=w$a(f,c,d)|0;if((g|0)==(f|0)|(g|0)==(c|0)){e=a;break a}e=(b[g>>0]|0)==69?g+1|0:a;break a;break}case 74:{if((f|0)==(c|0)){e=a;break a}else h=f;while(1){if((b[h>>0]|0)==69)break;g=R0a(h,c,d)|0;if((g|0)==(h|0)){e=a;break a}else h=g}e=h+1|0;break a;break}case 76:{if((f|0)!=(c|0)?(b[f>>0]|0)==90:0){g=a+2|0;i=R_a(g,c,d)|0;if((i|0)==(g|0)|(i|0)==(c|0)){e=a;break a}e=(b[i>>0]|0)==69?i+1|0:a;break a}e=z$a(a,c,d)|0;break a;break}default:{e=U_a(a,c,d)|0;break a}}}while(0);return e|0}function S0a(a){a=a|0;return 268435455}function T0a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;f[a+12>>2]=0;f[a+16>>2]=d;if(!b)e=0;else e=W0a(d,b)|0;f[a>>2]=e;d=e+(c<<4)|0;f[a+8>>2]=d;f[a+4>>2]=d;f[a+12>>2]=e+(b<<4);return}function U0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a>>2]|0;d=a+4|0;e=b+4|0;g=f[d>>2]|0;while(1){if((g|0)==(c|0))break;h=f[e>>2]|0;i=h+-16|0;j=g+-16|0;f[i>>2]=0;k=h+-12|0;f[k>>2]=0;l=f[g+-4>>2]|0;f[h+-8>>2]=0;f[h+-4>>2]=l;f[i>>2]=f[j>>2];i=g+-12|0;f[k>>2]=f[i>>2];k=g+-8|0;f[h+-8>>2]=f[k>>2];f[k>>2]=0;f[i>>2]=0;f[j>>2]=0;f[e>>2]=(f[e>>2]|0)+-16;g=j}g=f[a>>2]|0;f[a>>2]=f[e>>2];f[e>>2]=g;g=b+8|0;c=f[d>>2]|0;f[d>>2]=f[g>>2];f[g>>2]=c;c=a+8|0;a=b+12|0;g=f[c>>2]|0;f[c>>2]=f[a>>2];f[a>>2]=g;f[b>>2]=f[e>>2];return}function V0a(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+4>>2]|0;c=a+8|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-16|0;f[c>>2]=e;G_a(e)}c=f[a>>2]|0;if(c|0)L_a(f[a+16>>2]|0,c,(f[a+12>>2]|0)-c>>4);return}function W0a(a,b){a=a|0;b=b|0;return C0a(f[a>>2]|0,b<<4)|0}function X0a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=2;kOa(a,374429,2)|0;b[d>>0]=0;ZOa(a+2|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function Y0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=a+11|0;h=b[g>>0]|0;i=h<<24>>24<0;if(i){j=f[a+4>>2]|0;k=j>>>0<11?j:11;l=j;m=(f[a+8>>2]&2147483647)+-1|0}else{j=h&255;k=j>>>0<11?j:11;l=j;m=10}if((k-l+m|0)>>>0<c>>>0)M_a(a,m,l+c-k-m|0,l,0,k,c,374432);else{if(i)n=f[a>>2]|0;else n=a;do if((k|0)!=(c|0)){i=l-k|0;if(!i){o=k;p=c;q=0;r=374432;s=17}else{if(k>>>0>c>>>0){bZa(n,374432,c)|0;bZa(n+c|0,n+k|0,i)|0;t=k;v=c;break}do if(n>>>0<374432>>>0&(n+l|0)>>>0>374432>>>0)if((n+k|0)>>>0>374432>>>0){bZa(n,374432,k)|0;w=0;x=c-k|0;y=k;z=374432+c|0;break}else{w=k;x=c;y=0;z=374432+(c-k)|0;break}else{w=k;x=c;y=0;z=374432}while(0);m=n+y|0;bZa(m+x|0,m+w|0,i)|0;o=w;p=x;q=y;r=z;s=17}}else{o=c;p=c;q=0;r=374432;s=17}while(0);if((s|0)==17){bZa(n+q|0,r,p)|0;t=o;v=p}p=v-t+l|0;if((b[g>>0]|0)<0)f[a+4>>2]=p;else b[g>>0]=p;b[e>>0]=0;ZOa(n+p|0,e)}u=d;return}function Z0a(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16|0;h=g;i=a+11|0;j=b[i>>0]|0;k=j<<24>>24<0;if(k)l=f[a+4>>2]|0;else l=j&255;if(l>>>0<c>>>0)XYa(a);if(k)m=(f[a+8>>2]&2147483647)+-1|0;else m=10;j=l+e|0;if((m-l|0)>>>0>=e>>>0){if(e|0){if(k)n=f[a>>2]|0;else n=a;k=l-c|0;o=n+c|0;if(!k)p=d;else{bZa(o+e|0,o,k)|0;p=o>>>0<=d>>>0&(n+l|0)>>>0>d>>>0?d+e|0:d}bZa(o,p,e)|0;if((b[i>>0]|0)<0)f[a+4>>2]=j;else b[i>>0]=j;b[h>>0]=0;ZOa(n+j|0,h)}}else M_a(a,m,j-m|0,l,c,0,e,d);u=g;return a|0}function _0a(a){a=a|0;return 268435455}function $0a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;f[a+12>>2]=0;f[a+16>>2]=d;if(!b)e=0;else e=c1a(d,b)|0;f[a>>2]=e;d=e+(c<<4)|0;f[a+8>>2]=d;f[a+4>>2]=d;f[a+12>>2]=e+(b<<4);return}function a1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a>>2]|0;d=a+4|0;e=b+4|0;g=f[d>>2]|0;while(1){if((g|0)==(c|0))break;h=f[e>>2]|0;i=h+-16|0;j=g+-16|0;f[i>>2]=0;k=h+-12|0;f[k>>2]=0;l=f[g+-4>>2]|0;f[h+-8>>2]=0;f[h+-4>>2]=l;f[i>>2]=f[j>>2];i=g+-12|0;f[k>>2]=f[i>>2];k=g+-8|0;f[h+-8>>2]=f[k>>2];f[k>>2]=0;f[i>>2]=0;f[j>>2]=0;f[e>>2]=(f[e>>2]|0)+-16;g=j}g=f[a>>2]|0;f[a>>2]=f[e>>2];f[e>>2]=g;g=b+8|0;c=f[d>>2]|0;f[d>>2]=f[g>>2];f[g>>2]=c;c=a+8|0;a=b+12|0;g=f[c>>2]|0;f[c>>2]=f[a>>2];f[a>>2]=g;f[b>>2]=f[e>>2];return}function b1a(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+4>>2]|0;c=a+8|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-16|0;f[c>>2]=e;A_a(e)}c=f[a>>2]|0;if(c|0)H_a(f[a+16>>2]|0,c,(f[a+12>>2]|0)-c>>4);return}function c1a(a,b){a=a|0;b=b|0;return C0a(f[a>>2]|0,b<<4)|0}function d1a(a){a=a|0;var b=0;if(!(x0a(a)|0))gXa(a);else{b=B0a(a+12|0,1)|0;f[a+4>>2]=b;f[a>>2]=b;f[a+8>>2]=b+24;return}}function e1a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=a+11|0;g=b[e>>0]|0;if(g<<24>>24<0){h=f[a+4>>2]|0;i=f[a>>2]|0}else{h=g&255;i=a}j=(h|0)!=0&1;k=h-j|0;if(!k)l=g;else{bZa(i,i+j|0,k)|0;l=b[e>>0]|0}if(l<<24>>24<0)f[a+4>>2]=k;else b[e>>0]=k;b[d>>0]=0;ZOa(i+k|0,d);u=c;return}function f1a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=7;kOa(a,374205,7)|0;b[d>>0]=0;ZOa(a+7|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function g1a(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=3;kOa(a,c,3)|0;b[e>>0]=0;ZOa(a+3|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function h1a(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=N_a(32)|0;f[a>>2]=e;f[a+8>>2]=-2147483616;f[a+4>>2]=18;kOa(e,374625,18)|0;b[d>>0]=0;ZOa(e+18|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function i1a(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=8;kOa(a,c,8)|0;b[e>>0]=0;ZOa(a+8|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function j1a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=6;kOa(a,374618,6)|0;b[d>>0]=0;ZOa(a+6|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function k1a(a,b){a=a|0;b=b|0;f[a>>2]=b;f[a+4>>2]=f[b>>2];return}function l1a(a,c){a=a|0;c=c|0;f[a>>2]=c;b[a+4>>0]=b[c>>0]|0;return}function m1a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+64|0;g=e+60|0;h=e+48|0;i=e+36|0;j=e+24|0;k=e+12|0;l=e;a:do if((c-a|0)>2){m=a+2|0;n=a+1|0;switch(b[a>>0]|0){case 84:break;case 71:{switch(b[n>>0]|0){case 86:{o=r$a(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}X_a(r+-24|0,0,374843)|0;p=o;q=60;break a;break}case 82:{o=r$a(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}X_a(r+-24|0,0,374863)|0;p=o;q=60;break a;break}default:{p=a;q=60;break a}}break}default:{p=a;q=60;break a}}switch(b[n>>0]|0){case 86:{o=U_a(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}X_a(r+-24|0,0,374692)|0;p=o;q=60;break a;break}case 84:{o=U_a(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}X_a(r+-24|0,0,374704)|0;p=o;q=60;break a;break}case 73:{o=U_a(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}X_a(r+-24|0,0,374713)|0;p=o;q=60;break a;break}case 83:{o=U_a(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}X_a(r+-24|0,0,374727)|0;p=o;q=60;break a;break}case 99:{o=p1a(m,c)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=p1a(o,c)|0;if((r|0)==(o|0)){p=a;q=60;break a}o=R_a(r,c,d)|0;if((o|0)==(r|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}X_a(r+-24|0,0,374746)|0;p=o;q=60;break a;break}case 67:{o=U_a(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=v$a(o,c)|0;if((r|0)==(o|0)|(r|0)==(c|0)){p=a;q=60;break a}if((b[r>>0]|0)!=95){p=a;q=60;break a}o=r+1|0;r=U_a(o,c,d)|0;if((r|0)==(o|0)){p=a;q=60;break a}o=d+4|0;t=f[o>>2]|0;if(((t-(f[d>>2]|0)|0)/24|0)>>>0<2){s=a;break a}k$a(h,t+-24|0);t=f[o>>2]|0;v=t+-24|0;w=t;while(1){if((w|0)==(v|0))break;t=w+-24|0;f[o>>2]=t;z_a(t);w=f[o>>2]|0}X_a(h,0,374773)|0;f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];w=0;while(1){if((w|0)==3)break;f[h+(w<<2)>>2]=0;w=w+1|0}Y_a(k,374798)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];w=0;while(1){if((w|0)==3)break;f[k+(w<<2)>>2]=0;w=w+1|0}k$a(l,(f[o>>2]|0)+-24|0);w=b[l+11>>0]|0;v=w<<24>>24<0;C_a(j,v?f[l>>2]|0:l,v?f[l+4>>2]|0:w&255)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];w=0;while(1){if((w|0)==3)break;f[j+(w<<2)>>2]=0;w=w+1|0}w=f[o>>2]|0;v=w+-24|0;t=v+11|0;if((b[t>>0]|0)<0){x=f[v>>2]|0;b[g>>0]=0;ZOa(x,g);f[w+-20>>2]=0}else{b[g>>0]=0;ZOa(v,g);b[t>>0]=0}x$a(v);f[v>>2]=f[i>>2];f[v+4>>2]=f[i+4>>2];f[v+8>>2]=f[i+8>>2];v=0;while(1){if((v|0)==3)break;f[i+(v<<2)>>2]=0;v=v+1|0}Q_a(i);Q_a(l);Q_a(j);Q_a(k);Q_a(h);p=r;q=60;break a;break}default:{v=p1a(n,c)|0;do if((v|0)!=(n|0)){o=R_a(v,c,d)|0;if((o|0)!=(v|0)){t=f[d+4>>2]|0;if((f[d>>2]|0)!=(t|0)){w=t+-24|0;if((b[m>>0]|0)==118){X_a(w,0,374803)|0;y=0;z=o;break}else{X_a(w,0,374821)|0;y=0;z=o;break}}else{y=1;z=a}}else{y=0;z=a}}else{y=3;z=a}while(0);switch(y&3){case 3:case 0:{p=z;q=60;break a;break}default:{}}if(!y){p=z;q=60;break a}else{s=a;break a}}}}else{p=a;q=60}while(0);if((q|0)==60)s=p;u=e;return s|0}function n1a(a){a=a|0;b[f[a>>2]>>0]=b[a+4>>0]|0;return}function o1a(a){a=a|0;f[f[a>>2]>>2]=f[a+4>>2];return}function p1a(a,c){a=a|0;c=c|0;var d=0,e=0,f=0;a:do if((a|0)!=(c|0)){d=a+1|0;switch(b[a>>0]|0){case 104:{e=v$a(d,c)|0;if((e|0)==(d|0)|(e|0)==(c|0)){f=a;break a}return ((b[e>>0]|0)==95?e+1|0:a)|0}case 118:break;default:{f=a;break a}}e=v$a(d,c)|0;if((!((e|0)==(d|0)|(e|0)==(c|0))?(b[e>>0]|0)==95:0)?(d=e+1|0,e=v$a(d,c)|0,!((e|0)==(d|0)|(e|0)==(c|0))):0)f=(b[e>>0]|0)==95?e+1|0:a;else f=a}else f=a;while(0);return f|0}function q1a(a,b){a=a|0;b=b|0;f[a>>2]=b;return}function r1a(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=0;f[a+4>>2]=0;c=f[b>>2]|0;f[a+8>>2]=0;f[a+12>>2]=c;return}function s1a(a,b){a=a|0;b=b|0;f[a>>2]=b;return}function t1a(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=0;f[a+4>>2]=0;c=f[b>>2]|0;f[a+8>>2]=0;f[a+12>>2]=c;return}function u1a(a){a=a|0;var c=0;if((b[a>>0]|0)==1)c=0;else{b[a>>0]=1;c=1}return c|0}function v1a(a){a=a|0;return}function w1a(a){a=a|0;return}function x1a(){var a=0;a=f[494275]|0;f[494275]=a+0;return a|0}function y1a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[e>>2]=f[c>>2];g=ui[f[(f[a>>2]|0)+16>>2]&127](a,b,e)|0;if(g)f[c>>2]=f[e>>2];u=d;return g&1|0}function z1a(a){a=a|0;var b=0;if(!a)b=0;else b=(OZa(a,21464,21552,0)|0)!=0;return b&1|0}function A1a(){}function B1a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return (J=e,a-c>>>0|0)|0}function C1a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return (J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function D1a(a){a=a|0;return 0}function E1a(a){a=a|0;return 0}function F1a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=a+d|0;c=c&255;if((d|0)>=67){while(a&3){b[a>>0]=c;a=a+1|0}g=e&-4|0;h=g-64|0;i=c|c<<8|c<<16|c<<24;while((a|0)<=(h|0)){f[a>>2]=i;f[a+4>>2]=i;f[a+8>>2]=i;f[a+12>>2]=i;f[a+16>>2]=i;f[a+20>>2]=i;f[a+24>>2]=i;f[a+28>>2]=i;f[a+32>>2]=i;f[a+36>>2]=i;f[a+40>>2]=i;f[a+44>>2]=i;f[a+48>>2]=i;f[a+52>>2]=i;f[a+56>>2]=i;f[a+60>>2]=i;a=a+64|0}while((a|0)<(g|0)){f[a>>2]=i;a=a+4|0}}while((a|0)<(e|0)){b[a>>0]=c;a=a+1|0}return e-d|0}function G1a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;A=A+1|0;f[a>>2]=A;while((e|0)<(d|0)){if(!(f[c+(e<<3)>>2]|0)){f[c+(e<<3)>>2]=A;f[c+((e<<3)+4)>>2]=b;f[c+((e<<3)+8)>>2]=0;J=d;return c|0}e=e+1|0}d=d*2|0;c=fKa(c|0,8*(d+1|0)|0)|0;c=G1a(a|0,b|0,c|0,d|0)|0;J=d;return c|0}function H1a(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function I1a(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function J1a(a){a=a|0;return 0}function K1a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;if((d|0)>=8192)return td(a|0,c|0,d|0)|0;e=a|0;g=a+d|0;if((a&3)==(c&3)){while(a&3){if(!d)return e|0;b[a>>0]=b[c>>0]|0;a=a+1|0;c=c+1|0;d=d-1|0}h=g&-4|0;d=h-64|0;while((a|0)<=(d|0)){f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];f[a+36>>2]=f[c+36>>2];f[a+40>>2]=f[c+40>>2];f[a+44>>2]=f[c+44>>2];f[a+48>>2]=f[c+48>>2];f[a+52>>2]=f[c+52>>2];f[a+56>>2]=f[c+56>>2];f[a+60>>2]=f[c+60>>2];a=a+64|0;c=c+64|0}while((a|0)<(h|0)){f[a>>2]=f[c>>2];a=a+4|0;c=c+4|0}}else{h=g-4|0;while((a|0)<(h|0)){b[a>>0]=b[c>>0]|0;b[a+1>>0]=b[c+1>>0]|0;b[a+2>>0]=b[c+2>>0]|0;b[a+3>>0]=b[c+3>>0]|0;a=a+4|0;c=c+4|0}}while((a|0)<(g|0)){b[a>>0]=b[c>>0]|0;a=a+1|0;c=c+1|0}return e|0}function L1a(a){a=a|0;var b=0,c=0;a=a+15&-16|0;b=f[r>>2]|0;c=b+a|0;if((a|0)>0&(c|0)<(b|0)|(c|0)<0){ea()|0;Vd(12);return -1}f[r>>2]=c;if((c|0)>(da()|0)?(ca()|0)==0:0){f[r>>2]=b;Vd(12);return -1}return b|0}function M1a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;if((c|0)<(a|0)&(a|0)<(c+d|0)){e=a;c=c+d|0;a=a+d|0;while((d|0)>0){a=a-1|0;c=c-1|0;d=d-1|0;b[a>>0]=b[c>>0]|0}a=e}else K1a(a,c,d)|0;return a|0}function N1a(a){a=a|0;var c=0;c=b[w+(a&255)>>0]|0;if((c|0)<8)return c|0;c=b[w+(a>>8&255)>>0]|0;if((c|0)<8)return c+8|0;c=b[w+(a>>16&255)>>0]|0;if((c|0)<8)return c+16|0;return (b[w+(a>>>24)>>0]|0)+24|0}function O1a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;g=a;h=b;i=h;j=c;k=d;l=k;if(!i){m=(e|0)!=0;if(!l){if(m){f[e>>2]=(g>>>0)%(j>>>0);f[e+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return (J=n,o)|0}else{if(!m){n=0;o=0;return (J=n,o)|0}f[e>>2]=a|0;f[e+4>>2]=b&0;n=0;o=0;return (J=n,o)|0}}m=(l|0)==0;do if(j){if(!m){p=($(l|0)|0)-($(i|0)|0)|0;if(p>>>0<=31){q=p+1|0;r=31-p|0;s=p-31>>31;t=q;u=g>>>(q>>>0)&s|i<<r;v=i>>>(q>>>0)&s;w=0;x=g<<r;break}if(!e){n=0;o=0;return (J=n,o)|0}f[e>>2]=a|0;f[e+4>>2]=h|b&0;n=0;o=0;return (J=n,o)|0}r=j-1|0;if(r&j|0){s=($(j|0)|0)+33-($(i|0)|0)|0;q=64-s|0;p=32-s|0;y=p>>31;z=s-32|0;A=z>>31;t=s;u=p-1>>31&i>>>(z>>>0)|(i<<p|g>>>(s>>>0))&A;v=A&i>>>(s>>>0);w=g<<q&y;x=(i<<q|g>>>(z>>>0))&y|g<<p&s-33>>31;break}if(e|0){f[e>>2]=r&g;f[e+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return (J=n,o)|0}else{r=N1a(j|0)|0;n=i>>>(r>>>0)|0;o=i<<32-r|g>>>(r>>>0)|0;return (J=n,o)|0}}else{if(m){if(e|0){f[e>>2]=(i>>>0)%(j>>>0);f[e+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return (J=n,o)|0}if(!g){if(e|0){f[e>>2]=0;f[e+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return (J=n,o)|0}r=l-1|0;if(!(r&l)){if(e|0){f[e>>2]=a|0;f[e+4>>2]=r&i|b&0}n=0;o=i>>>((N1a(l|0)|0)>>>0);return (J=n,o)|0}r=($(l|0)|0)-($(i|0)|0)|0;if(r>>>0<=30){s=r+1|0;p=31-r|0;t=s;u=i<<p|g>>>(s>>>0);v=i>>>(s>>>0);w=0;x=g<<p;break}if(!e){n=0;o=0;return (J=n,o)|0}f[e>>2]=a|0;f[e+4>>2]=h|b&0;n=0;o=0;return (J=n,o)|0}while(0);if(!t){B=x;C=w;D=v;E=u;F=0;G=0}else{b=c|0|0;c=k|d&0;d=C1a(b|0,c|0,-1,-1)|0;k=J;h=x;x=w;w=v;v=u;u=t;t=0;do{a=h;h=x>>>31|h<<1;x=t|x<<1;g=v<<1|a>>>31|0;a=v>>>31|w<<1|0;B1a(d|0,k|0,g|0,a|0)|0;i=J;l=i>>31|((i|0)<0?-1:0)<<1;t=l&1;v=B1a(g|0,a|0,l&b|0,(((i|0)<0?-1:0)>>31|((i|0)<0?-1:0)<<1)&c|0)|0;w=J;u=u-1|0}while((u|0)!=0);B=h;C=x;D=w;E=v;F=0;G=t}t=C;C=0;if(e|0){f[e>>2]=E;f[e+4>>2]=D}n=(t|0)>>>31|(B|C)<<1|(C<<1|t>>>31)&0|F;o=(t<<1|0>>>31)&-2|G;return (J=n,o)|0}function P1a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e|0;O1a(a,b,c,d,g)|0;u=e;return (J=f[g+4>>2]|0,f[g>>2]|0)|0}function Q1a(a){a=a|0;return (a&255)<<24|(a>>8&255)<<16|(a>>16&255)<<8|a>>>24|0}function R1a(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function S1a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=B1a(e^a|0,f^b|0,e|0,f|0)|0;b=J;a=g^e;e=h^f;return B1a((O1a(i,b,B1a(g^c|0,h^d|0,g|0,h|0)|0,J,0)|0)^a|0,J^e|0,a|0,e|0)|0}function T1a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;while((d|0)<(c|0)){e=f[b+(d<<3)>>2]|0;if(!e)break;if((e|0)==(a|0))return f[b+((d<<3)+4)>>2]|0;d=d+1|0}return 0}function U1a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return O1a(a,b,c,d,0)|0}function V1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=Y(d,c)|0;f=a>>>16;a=(e>>>16)+(Y(d,f)|0)|0;d=b>>>16;b=Y(d,c)|0;return (J=(a>>>16)+(Y(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function W1a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=V1a(e,a)|0;f=J;return (J=(Y(b,a)|0)+(Y(d,e)|0)+f|f&0,c|0|0)|0}function X1a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;return Xf[a&3](b|0,c|0,d|0,e|0,f|0,+g)|0}function Y1a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;Yf[a&1](b|0,c|0,d|0,e|0,+f,+g,+h)}function Z1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;Zf[a&7](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)}function _1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;_f[a&3](b|0,c|0,d|0,e|0,f|0,+g,+h,i|0)}function $1a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;$f[a&3](b|0,c|0,d|0,+e,f|0,g|0,h|0)}function a2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;ag[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,+i)}function b2a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return bg[a&127](b|0,c|0,d|0,e|0,f|0,g|0)|0}function c2a(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;cg[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,i|0,j|0,k|0,l|0)}function d2a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;dg[a&7](b|0,c|0,d|0,e|0,+f,+g,h|0)}function e2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;eg[a&1](b|0,c|0,d|0,+e,+f,+g,+h,i|0)}function f2a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;fg[a&1](b|0,c|0,+d,e|0,f|0,g|0)}function g2a(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;gg[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0)}function h2a(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;hg[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,+l)}function i2a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;ig[a&1](b|0,c|0,d|0,+e,+f,+g,+h)}function j2a(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;return jg[a&1](b|0,+c,d|0)|0}function k2a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;kg[a&3](b|0,c|0,+d,+e,f|0,+g,+h)}function l2a(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;lg[a&3](b|0,+c,d|0)}function m2a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;mg[a&3](b|0,c|0,+d,+e,f|0,g|0)}function n2a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;ng[a&3](b|0,c|0,+d,+e,f|0,+g)}function o2a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;og[a&7](b|0,c|0,d|0,e|0,f|0,+g,h|0)}function p2a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;j=+j;pg[a&1](b|0,c|0,+d,+e,f|0,+g,+h,+i,+j)}function q2a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;qg[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,i|0,j|0,k|0)}function r2a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=+j;rg[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i,+j)}function s2a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=+k;sg[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,i|0,j|0,+k)}function t2a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=j|0;tg[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i,j|0)}function u2a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;ug[a&3](b|0,c|0,d|0,+e,+f,g|0,h|0)}function v2a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;vg[a&3](b|0,c|0,d|0,+e,f|0,g|0)}function w2a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;wg[a&3](b|0,c|0,d|0,e|0,f|0,+g,+h)}function x2a(a,b){a=a|0;b=b|0;return +xg[a&31](b|0)}function y2a(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;yg[a&1](b|0,c|0,d|0,e|0,f|0,g|0,+h,i|0,j|0,k|0,l|0)}function z2a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;j=+j;k=k|0;zg[a&3](b|0,c|0,d|0,e|0,+f,g|0,h|0,+i,+j,k|0)}function A2a(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;Ag[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,i|0,j|0,k|0,+l)}function B2a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;j=j|0;Bg[a&3](b|0,c|0,d|0,e|0,+f,+g,h|0,i|0,j|0)}function C2a(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;Cg[a&1](+b,c|0,d|0)}function D2a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return +Dg[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function E2a(a,b,c){a=a|0;b=b|0;c=c|0;return +Eg[a&31](b|0,c|0)}function F2a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;Fg[a&1](b|0,c|0,d|0,+e,+f,g|0,h|0,i|0,j|0)}function G2a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=+j;Gg[a&1](b|0,c|0,d|0,+e,+f,g|0,h|0,i|0,+j)}function H2a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;j=+j;Hg[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,+i,+j)}function I2a(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;n=n|0;Ig[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,+l,+m,n|0)}function J2a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Jg[a&63](b|0,c|0,d|0,e|0)|0}function K2a(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;Kg[a&3](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,j|0,k|0,l|0)}function L2a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;Lg[a&1](b|0,c|0,d|0,+e,+f,+g,h|0)}function M2a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=+j;k=+k;Mg[a&1](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,+j,+k)}function N2a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return Ng[a&3](b|0,c|0,d|0,+e)|0}function O2a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Og[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function P2a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;Pg[a&1](b|0,c|0,+d,+e,f|0,g|0,h|0)}function Q2a(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=j|0;k=+k;l=l|0;m=m|0;n=n|0;return Qg[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i,j|0,+k,l|0,m|0,n|0)|0}function R2a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;j=j|0;Rg[a&1](b|0,c|0,d|0,+e,+f,+g,h|0,i|0,j|0)}function S2a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=+h;Sg[a&1](b|0,c|0,+d,e|0,f|0,g|0,+h)}function T2a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;Tg[a&7](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0,j|0)}function U2a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;Ug[a&1](b|0,c|0,+d,e|0,f|0,g|0,h|0)}function V2a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;return +Vg[a&1](b|0,c|0,d|0,+e,+f,g|0)}function W2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=+g;h=h|0;i=i|0;Wg[a&1](b|0,c|0,d|0,+e,f|0,+g,h|0,i|0)}function X2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return +Xg[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function Y2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=+i;Yg[a&1](b|0,c|0,d|0,+e,f|0,g|0,h|0,+i)}function Z2a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;j=j|0;Zg[a&1](b|0,c|0,d|0,+e,+f,+g,+h,i|0,j|0)}function _2a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return _g[a&1](b|0,c|0,+d,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function $2a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;$g[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function a3a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=+i;j=j|0;k=k|0;ah[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,+i,j|0,k|0)}function b3a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;bh[a&255](b|0,c|0,d|0,e|0,f|0,g|0)}function c3a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;ch[a&3](b|0,c|0,d|0,+e,f|0,g|0,h|0,i|0)}function d3a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;dh[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h,i|0)}function e3a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;eh[a&1](b|0,c|0,d|0,e|0,f|0,g|0,+h,i|0,j|0,k|0)}function f3a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=i|0;j=j|0;fh[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,i|0,j|0)}function g3a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;gh[a&15](b|0,c|0,d|0,+e,+f)}function h3a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;hh[a&7](b|0,c|0,d|0,+e,f|0)}function i3a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;return ih[a&1](b|0,c|0,+d,e|0,f|0,g|0,h|0)|0}function j3a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;jh[a&1](b|0,c|0,+d,+e,f|0,+g,+h,+i)}function k3a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;kh[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)}function l3a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;return +lh[a&1](b|0,c|0,+d,+e,f|0)}function m3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +mh[a&31](b|0,c|0,d|0)}function n3a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;nh[a&3](b|0,c|0,d|0,+e,+f,+g)}function o3a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;j=+j;k=+k;oh[a&1](b|0,c|0,d|0,+e,+f,g|0,+h,+i,+j,+k)}function p3a(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=+m;ph[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,+m)}function q3a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;qh[a&1](b|0,c|0,d|0,+e,+f,g|0,+h,+i)}function r3a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;rh[a&1](b|0,c|0,d|0,+e,f|0,g|0,h|0,i|0,+j,k|0)}function s3a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;sh[a&1](b|0,c|0,d|0,+e,+f,g|0,h|0,i|0,j|0,+k)}function t3a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;th[a&7](b|0,c|0,d|0,+e,+f,g|0)}function u3a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return uh[a&63](b|0,c|0,d|0,e|0,f|0)|0}function v3a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;vh[a&63](b|0,c|0,d|0,+e)}function w3a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=+i;wh[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,+i)}function x3a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;xh[a&1](b|0,c|0,+d,e|0,f|0)}function y3a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return yh[a&7](b|0,c|0,d|0,e|0,+f)|0}function z3a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=i|0;zh[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,i|0)}function A3a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ah[a&255](b|0,c|0,d|0,e|0)}function B3a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Bh[a&255](b|0,c|0,d|0,e|0,f|0)}function C3a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;Ch[a&1](b|0,c|0,+d,e|0,f|0,g|0,h|0,i|0,j|0,k|0)}function D3a(a,b,c){a=a|0;b=b|0;c=+c;Dh[a&31](b|0,+c)}function E3a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;return Eh[a&3](b|0,c|0,+d,e|0)|0}function F3a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;return Fh[a&1](b|0,c|0,+d,+e)|0}function G3a(a,b,c){a=a|0;b=b|0;c=c|0;Gh[a&511](b|0,c|0)}function H3a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;Hh[a&15](b|0,c|0,d|0,e|0,+f)}function I3a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=+i;j=j|0;Ih[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,+i,j|0)}function J3a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;Jh[a&7](b|0,c|0,+d,+e)}function K3a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;Kh[a&15](b|0,c|0,+d,e|0)}function L3a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=+h;i=+i;j=j|0;Lh[a&1](b|0,c|0,d|0,+e,f|0,g|0,+h,+i,j|0)}function M3a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return +Mh[a&1](b|0,c|0,d|0,+e)}function N3a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;Nh[a&1](b|0,c|0,d|0,+e,+f,+g,h|0,i|0)}function O3a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Oh[a&255](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function P3a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;Ph[a&1](b|0,c|0,d|0,+e,+f,+g,h|0,i|0,j|0,k|0)}function Q3a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;Qh[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i)}function R3a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return +Rh[a&15](b|0,c|0,d|0,e|0)}function S3a(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=+j;k=+k;l=l|0;Sh[a&1](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,+j,+k,l|0)}function T3a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;Th[a&7](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0)}function U3a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;j=+j;Uh[a&1](b|0,c|0,d|0,+e,+f,g|0,+h,+i,+j)}function V3a(a,b,c){a=a|0;b=b|0;c=+c;return Vh[a&1](b|0,+c)|0}function W3a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;Wh[a&1](b|0,c|0,d|0,+e,+f,g|0,+h)}function X3a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Xh[a&127](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function Y3a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=+g;h=h|0;Yh[a&1](b|0,c|0,+d,e|0,+f,+g,h|0)}function Z3a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;Zh[a&7](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function _3a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;_h[a&127](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function $3a(a,b,c){a=a|0;b=b|0;c=c|0;return $h[a&255](b|0,c|0)|0}function a4a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;ai[a&7](b|0,c|0,+d,+e,f|0)}function b4a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=+g;h=h|0;bi[a&1](b|0,c|0,d|0,+e,f|0,+g,h|0)}function c4a(a,b,c,d,e){a=a|0;b=+b;c=c|0;d=d|0;e=e|0;ci[a&1](+b,c|0,d|0,e|0)}function d4a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;j=j|0;di[a&1](b|0,c|0,d|0,e|0,f|0,g|0,+h,i|0,j|0)}function e4a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=i|0;j=j|0;k=k|0;ei[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,i|0,j|0,k|0)}function f4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fi[a&255](b|0,c|0,d|0)}function g4a(a){a=a|0;gi[a&3]()}function h4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;hi[a&31](b|0,c|0,+d)}function i4a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ii[a&1](b|0,c|0,+d,e|0,f|0,g|0,h|0,i|0)}function j4a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;ji[a&3](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,j|0,k|0)}function k4a(a,b){a=a|0;b=b|0;ki[a&2047](b|0)}function l4a(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=l|0;li[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0,j|0,+k,l|0)}function m4a(a,b){a=a|0;b=b|0;return mi[a&255](b|0)|0}function n4a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=+j;k=k|0;ni[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i,+j,k|0)}function o4a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;oi[a&1](b|0,+c,d|0,+e,+f,g|0)}function p4a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;pi[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h,+i)}function q4a(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;qi[a&7](b|0,+c,d|0,e|0)}function r4a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;ri[a&7](b|0,c|0,d|0,e|0,+f,g|0)}function s4a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;si[a&3](b|0,c|0,d|0,+e,+f,g|0,h|0,i|0)}function t4a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ti[a&1](b|0,c|0,+d,e|0,f|0,g|0,h|0,i|0,j|0)}function u4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ui[a&127](b|0,c|0,d|0)|0}function v4a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;h=h|0;vi[a&1](b|0,c|0,+d,e|0,+f,g|0,h|0)}function w4a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;wi[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,i|0)}function x4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;return xi[a&3](b|0,c|0,+d)|0}function y4a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;yi[a&7](b|0,c|0,d|0,e|0,+f,g|0,h|0)}function z4a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return +zi[a&7](b|0,c|0,d|0,e|0,f|0)}function A4a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return +Ai[a&1](b|0,c|0,d|0,e|0,+f)}function B4a(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;return Bi[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0)|0}function C4a(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;return Ci[a&0](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0)|0}function D4a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;j=j|0;Di[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h,+i,j|0)}function E4a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;return Ei[a&1](b|0,c|0,+d,e|0,f|0,g|0)|0}function F4a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return Fi[a&1](b|0,c|0,+d,e|0,f|0,g|0,h|0,i|0,j|0)|0}function G4a(a){a=a|0;return Gi[a&63]()|0}function H4a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;return Hi[a&1](b|0,c|0,+d,e|0,f|0)|0}function I4a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return +Ii[a&3](b|0,c|0,d|0,e|0,f|0,g|0)}function J4a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Ji[a&1](b|0,c|0,+d,e|0,f|0,g|0,h|0,i|0)|0}function K4a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;h=h|0;Ki[a&1](b|0,+c,d|0,+e,+f,g|0,h|0)}function L4a(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;Li[a&1](b|0,c|0,d|0,e|0,f|0,g|0,+h,i|0,j|0,k|0,l|0,m|0)}function M4a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;Mi[a&3](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,j|0)}function N4a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;Ni[a&1](b|0,c|0,+d,e|0,+f,g|0)}function O4a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Oi[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function P4a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=+g;h=h|0;i=i|0;Pi[a&1](b|0,c|0,+d,e|0,+f,+g,h|0,i|0)}function Q4a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=+j;Qi[a&1](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,+j)}function R4a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;Ri[a&7](b|0,c|0,d|0,e|0,+f,+g)}function S4a(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;Si[a&1](b|0,+c,d|0,e|0,f|0)}function T4a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;aa(0);return 0}function U4a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;aa(1)}function V4a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;aa(2)}function W4a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;aa(3)}function X4a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;aa(4)}function Y4a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=+h;aa(5)}function Z4a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;aa(6);return 0}function _4a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;aa(7)}function $4a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;aa(8)}function a5a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;h=h|0;aa(9)}function b5a(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;aa(10)}function c5a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;aa(11)}function d5a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;aa(12)}function e5a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;aa(13)}function f5a(a,b,c){a=a|0;b=+b;c=c|0;aa(14);return 0}function g5a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;aa(15)}function h5a(a,b,c){a=a|0;b=+b;c=c|0;aa(16)}function i5a(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;aa(17)}function j5a(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;aa(18)}function k5a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;aa(19)}function l5a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;h=+h;i=+i;aa(20)}function m5a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;aa(21)}function n5a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;aa(22)}function o5a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=+j;aa(23)}function p5a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;aa(24)}function q5a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;aa(25)}function r5a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;aa(26)}function s5a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;aa(27)}function t5a(a){a=a|0;aa(28);return 0.0}function u5a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;aa(29)}function v5a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=+h;i=+i;j=j|0;aa(30)}function w5a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;aa(31)}function x5a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;aa(32)}function y5a(a,b,c){a=+a;b=b|0;c=c|0;aa(33)}function z5a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;aa(34);return 0.0}function A5a(a,b){a=a|0;b=b|0;aa(35);return 0.0}function B5a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;aa(36)}function C5a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;i=+i;aa(37)}function D5a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=+h;i=+i;aa(38)}function E5a(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;m=m|0;aa(39)}function F5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;aa(40);return 0}function G5a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;aa(41)}function H5a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=g|0;aa(42)}function I5a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;j=+j;aa(43)}function J5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;aa(44);return 0}function K5a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;aa(45);return 0}function L5a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=g|0;aa(46)}function M5a(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;j=+j;k=k|0;l=l|0;m=m|0;aa(47);return 0}function N5a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=g|0;h=h|0;i=i|0;aa(48)}function O5a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=+g;aa(49)}function P5a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;aa(50)}function Q5a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;aa(51)}function R5a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;aa(52);return 0.0}function S5a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;h=h|0;aa(53)}function T5a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;aa(54);return 0.0}function U5a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=+h;aa(55)}function V5a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;h=h|0;i=i|0;aa(56)}function W5a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;aa(57);return 0}function X5a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;aa(58)}function Y5a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;j=j|0;aa(59)}function Z5a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;aa(60)}function _5a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;aa(61)}function $5a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;aa(62)}function a6a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;aa(63)}function b6a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;aa(64)}function c6a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;aa(65)}function d6a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;aa(66)}function e6a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;aa(67);return 0}function f6a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;h=+h;aa(68)}function g6a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;aa(69)}function h6a(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;aa(70);return 0.0}function i6a(a,b,c){a=a|0;b=b|0;c=c|0;aa(71);return 0.0}function j6a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;aa(72)}function k6a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;j=+j;aa(73)}function l6a(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;aa(74)}function m6a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;aa(75)}function n6a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=j|0;aa(76)}function o6a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;aa(77)}function p6a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;aa(78)}function q6a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;aa(79);return 0}function r6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;aa(80)}function s6a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;aa(81)}function t6a(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;aa(82)}function u6a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;aa(83);return 0}function v6a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;aa(84)}function w6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;aa(85)}function x6a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;aa(86)}function y6a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;aa(87)}function z6a(a,b){a=a|0;b=+b;aa(88)}function A6a(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;aa(89);return 0}function B6a(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;aa(90);return 0}function C6a(a,b){a=a|0;b=b|0;aa(91)}function D6a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;aa(92)}function E6a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;aa(93)}function F6a(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;aa(94)}function G6a(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;aa(95)}function H6a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=+g;h=+h;i=i|0;aa(96)}function I6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;aa(97);return 0.0}function J6a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=g|0;h=h|0;aa(98)}function K6a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;aa(99)}function L6a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;aa(100)}function M6a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;aa(101)}function N6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;aa(102);return 0.0}function O6a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;j=+j;k=k|0;aa(103)}function P6a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;aa(104)}function Q6a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;aa(105)}function R6a(a,b){a=a|0;b=+b;aa(106);return 0}function S6a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;aa(107)}function T6a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;aa(108)}function U6a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;aa(109)}function V6a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;aa(110)}function W6a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;aa(111)}function X6a(a,b){a=a|0;b=b|0;aa(112);return 0}function Y6a(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;aa(113)}function Z6a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;aa(114)}function _6a(a,b,c,d){a=+a;b=b|0;c=c|0;d=d|0;aa(115)}function $6a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;aa(116)}function a7a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;j=j|0;aa(117)}function b7a(a,b,c){a=a|0;b=b|0;c=c|0;aa(118)}function c7a(){aa(119)}function d7a(){af()}function e7a(a,b,c){a=a|0;b=b|0;c=+c;aa(120)}function f7a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;aa(121)}function g7a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;aa(122)}function h7a(a){a=a|0;aa(123)}function i7a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;aa(124)}function j7a(a){a=a|0;aa(125);return 0}function k7a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;j=j|0;aa(126)}function l7a(a,b,c,d,e,f){a=a|0;b=+b;c=c|0;d=+d;e=+e;f=f|0;aa(127)}function m7a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;aa(128)}function n7a(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;aa(129)}function o7a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;aa(130)}function p7a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;aa(131)}function q7a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;aa(132)}function r7a(a,b,c){a=a|0;b=b|0;c=c|0;aa(133);return 0}function s7a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=f|0;g=g|0;aa(134)}function t7a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;aa(135)}function u7a(a,b,c){a=a|0;b=b|0;c=+c;aa(136);return 0}function v7a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;aa(137)}function w7a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;aa(138);return 0.0}function x7a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;aa(139);return 0.0}function y7a(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;aa(140);return 0}function z7a(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;aa(141);return 0}function A7a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;aa(142)}function B7a(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;aa(143);return 0}function C7a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;aa(144);return 0}function D7a(){aa(145);return 0}function E7a(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;aa(146);return 0}function F7a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;aa(147);return 0.0}function G7a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;aa(148);return 0}function H7a(a,b,c,d,e,f,g){a=a|0;b=+b;c=c|0;d=+d;e=+e;f=f|0;g=g|0;aa(149)}function I7a(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;aa(150)}function J7a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;aa(151)}function K7a(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=f|0;aa(152)}function L7a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;aa(153);return 0}function M7a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;h=h|0;aa(154)}function N7a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;aa(155)}function O7a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;aa(156)}function P7a(a,b,c,d,e){a=a|0;b=+b;c=c|0;d=d|0;e=e|0;aa(157)}
function Vma(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f[a>>2]=75072;i=a+4|0;f[i>>2]=f[b>>2];j=a+8|0;k=b+4|0;f[j>>2]=f[k>>2];l=a+12|0;f[l>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];m=f[b+36>>2]|0;f[a+40>>2]=m;f[a+44>>2]=l;l=a+52|0;n=a+48|0;f[n>>2]=l;f[l>>2]=0;f[a+56>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[b+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;BR(i,b)}b=a+60|0;f[b>>2]=f[c>>2];i=a+64|0;j=c+4|0;f[i>>2]=f[j>>2];k=a+68|0;f[k>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];l=f[c+36>>2]|0;f[a+96>>2]=l;f[a+100>>2]=k;k=a+108|0;n=a+104|0;f[n>>2]=k;f[k>>2]=0;f[a+112>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[c+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}else{f[i>>2]=0;BR(b,c);o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}}function Wma(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=75072;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function Xma(a){a=a|0;Wma(a);PYa(a);return}function Yma(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0.0,U=0,V=0.0,W=0.0,X=0,Z=0,_=0.0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0;e=u;u=u+32|0;g=e;h=f[a+44>>2]|0;i=f[h+4>>2]|0;k=f[h>>2]|0;h=(f[a+4>>2]|0)>>>3;l=(h&511)+1|0;m=a+116|0;n=f[m>>2]|0;o=a+120|0;p=f[o>>2]|0;q=Y(p,n)|0;r=1.0/+(q|0);s=Y((i|0)/(n|0)|0,l)|0;t=Y(l,f[(f[a+100>>2]|0)+4>>2]|0)|0;v=Y(l,i)|0;i=f[a+52>>2]|0;f[g>>2]=n;f[g+4>>2]=p;f[g+8>>2]=l;f[g+16>>2]=i;a:do if((n|0)==2&(p|0)==2){switch(h&511){case 2:case 0:{w=1;break a;break}default:{}}w=(l|0)==4&1}else w=0;while(0);b[g+12>>0]=w;w=f[c>>2]|0;h=c+4|0;if((w|0)>=(f[h>>2]|0)){u=e;return}c=a+76|0;n=a+108|0;i=a+20|0;x=a+48|0;y=a+128|0;z=q+-4|0;A=(q|0)<4;B=a+124|0;a=(t|0)>0;D=t<<1;E=q&-4;F=(E|0)<(q|0);G=(q|0)>0;H=p;p=w;while(1){w=(f[c>>2]|0)+(Y(f[n>>2]|0,p)|0)|0;I=Y(H,p)|0;J=(I+H|0)<=(k|0)?s:0;b:do if((I|0)<(k|0)){K=Zma(g,(f[i>>2]|0)+(Y(f[f[x>>2]>>2]|0,I)|0)|0,w,J)|0;c:do if((K|0)<(J|0)){L=(f[i>>2]|0)+(Y(f[f[x>>2]>>2]|0,I)|0)|0;M=f[y>>2]|0;if(A){N=K;while(1){O=L+(f[M+(N<<2)>>2]<<1)|0;if(G){P=f[B>>2]|0;Q=0;R=0.0;while(1){S=R+ +(j[O+(f[P+(Q<<2)>>2]<<1)>>1]|0);Q=Q+1|0;if((Q|0)==(q|0)){T=S;break}else R=S}}else T=0.0;Q=wNa(r*T)|0;d[w+(N<<1)>>1]=Q>>>0<65536?Q:(Q|0)>0?65535:0;N=N+1|0;if((N|0)==(J|0)){U=J;break c}}}N=f[B>>2]|0;Q=K;do{P=L+(f[M+(Q<<2)>>2]<<1)|0;O=0;R=0.0;do{R=R+ +((j[P+(f[N+((O|1)<<2)>>2]<<1)>>1]|0)+(j[P+(f[N+(O<<2)>>2]<<1)>>1]|0)+(j[P+(f[N+((O|2)<<2)>>2]<<1)>>1]|0)+(j[P+(f[N+((O|3)<<2)>>2]<<1)>>1]|0)|0);O=O+4|0}while((O|0)<=(z|0));if(F){O=E;S=R;while(1){V=S+ +(j[P+(f[N+(O<<2)>>2]<<1)>>1]|0);O=O+1|0;if((O|0)==(q|0)){W=V;break}else S=V}}else W=R;O=wNa(r*W)|0;d[w+(Q<<1)>>1]=O>>>0<65536?O:(O|0)>0?65535:0;Q=Q+1|0}while((Q|0)!=(J|0));U=J}else U=K;while(0);if((U|0)<(t|0)){K=f[y>>2]|0;Q=f[o>>2]|0;if((Q|0)>0)X=U;else{N=wNa(C)|0;M=(N>>>0<65536?N:(N|0)>0?65535:0)&65535;N=U;while(1){L=w+(N<<1)|0;if((f[K+(N<<2)>>2]|0)>=(v|0))d[L>>1]=0;d[L>>1]=M;N=N+1|0;if((N|0)==(t|0))break b}}do{N=f[K+(X<<2)>>2]|0;d:do if((N|0)<(v|0)){M=0;S=0.0;L=0;while(1){O=L+I|0;if((O|0)>=(k|0)){Z=M;_=S;break d}P=(f[i>>2]|0)+(Y(f[f[x>>2]>>2]|0,O)|0)+(N<<1)|0;O=Y(f[m>>2]|0,l)|0;if((O|0)>0){$=M;V=S;aa=0;while(1){ba=V+ +(j[P+(aa<<1)>>1]|0);ca=$+1|0;aa=aa+l|0;if(!((aa+N|0)<(v|0)&(aa|0)<(O|0))){da=ca;ea=ba;break}else{$=ca;V=ba}}}else{da=M;ea=S}L=L+1|0;if((L|0)>=(Q|0)){Z=da;_=ea;break}else{M=da;S=ea}}}else{d[w+(X<<1)>>1]=0;Z=0;_=0.0}while(0);N=wNa(_/+(Z|0))|0;d[w+(X<<1)>>1]=N>>>0<65536?N:(N|0)>0?65535:0;X=X+1|0}while((X|0)!=(t|0))}}else if(a)F1a(w|0,0,D|0)|0;while(0);w=p+1|0;if((w|0)>=(f[h>>2]|0))break;H=f[o>>2]|0;p=w}u=e;return}function Zma(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0;h=u;u=u+16|0;i=h;if(!(b[a+12>>0]|0)){k=0;u=h;return k|0}l=c+(f[a+16>>2]|0)|0;switch(f[a+8>>2]|0){case 1:{if((g|0)>0)m=0;else{k=0;u=h;return k|0}do{a=m<<1;n=a|1;d[e+(m<<1)>>1]=((j[c+(a<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[l+(a<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)|0)>>>2;m=m+1|0}while((m|0)!=(g|0));k=g;u=h;return k|0}case 3:{if((g|0)>0)o=0;else{k=0;u=h;return k|0}while(1){m=o<<1;n=m+3|0;d[e+(o<<1)>>1]=((j[c+(m<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[l+(m<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)|0)>>>2;n=m|1;a=m+4|0;d[e+(o+1<<1)>>1]=((j[c+(n<<1)>>1]|0)+2+(j[c+(a<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)+(j[l+(a<<1)>>1]|0)|0)>>>2;a=m+2|0;n=m+5|0;d[e+(o+2<<1)>>1]=((j[c+(a<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[l+(a<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)|0)>>>2;n=o+3|0;if((n|0)<(g|0))o=n;else{k=n;break}}u=h;return k|0}case 4:break;default:{f[i>>2]=0;f[i+4>>2]=0;o=c$(i,7)|0;b[o>>0]=b[325727]|0;b[o+1>>0]=b[325728]|0;b[o+2>>0]=b[325729]|0;b[o+3>>0]=b[325730]|0;b[o+4>>0]=b[325731]|0;b[o+5>>0]=b[325732]|0;b[o+6>>0]=b[325733]|0;j$(-215,i,373355,323470,2164);d$(i)}}if((g|0)>0)p=0;else{k=0;u=h;return k|0}do{i=p<<1;o=i|4;d[e+(p<<1)>>1]=((j[c+(i<<1)>>1]|0)+2+(j[c+(o<<1)>>1]|0)+(j[l+(i<<1)>>1]|0)+(j[l+(o<<1)>>1]|0)|0)>>>2;o=i|1;n=i|5;d[e+((p|1)<<1)>>1]=((j[c+(o<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[l+(o<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)|0)>>>2;n=i|2;o=i|6;d[e+((p|2)<<1)>>1]=((j[c+(n<<1)>>1]|0)+2+(j[c+(o<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)+(j[l+(o<<1)>>1]|0)|0)>>>2;o=i|3;n=i|7;d[e+((p|3)<<1)>>1]=((j[c+(o<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[l+(o<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)|0)>>>2;p=p+4|0}while((p|0)<(g|0));k=g+3&-4;u=h;return k|0}function _ma(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f[a>>2]=75092;i=a+4|0;f[i>>2]=f[b>>2];j=a+8|0;k=b+4|0;f[j>>2]=f[k>>2];l=a+12|0;f[l>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];m=f[b+36>>2]|0;f[a+40>>2]=m;f[a+44>>2]=l;l=a+52|0;n=a+48|0;f[n>>2]=l;f[l>>2]=0;f[a+56>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[b+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;BR(i,b)}b=a+60|0;f[b>>2]=f[c>>2];i=a+64|0;j=c+4|0;f[i>>2]=f[j>>2];k=a+68|0;f[k>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];l=f[c+36>>2]|0;f[a+96>>2]=l;f[a+100>>2]=k;k=a+108|0;n=a+104|0;f[n>>2]=k;f[k>>2]=0;f[a+112>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[c+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}else{f[i>>2]=0;BR(b,c);o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}}function $ma(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=75092;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))ZF(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function ana(a){a=a|0;$ma(a);PYa(a);return}function bna(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0;d=u;u=u+32|0;e=d;g=f[a+44>>2]|0;i=f[g+4>>2]|0;j=f[g>>2]|0;g=(f[a+4>>2]|0)>>>3;k=(g&511)+1|0;l=a+116|0;m=f[l>>2]|0;n=a+120|0;o=f[n>>2]|0;p=Y(o,m)|0;q=1.0/+(p|0);r=Y((i|0)/(m|0)|0,k)|0;s=Y(k,f[(f[a+100>>2]|0)+4>>2]|0)|0;t=Y(k,i)|0;i=f[a+52>>2]|0;f[e>>2]=m;f[e+4>>2]=o;f[e+8>>2]=k;f[e+16>>2]=i;a:do if((m|0)==2&(o|0)==2){switch(g&511){case 2:case 0:{v=1;break a;break}default:{}}v=(k|0)==4&1}else v=0;while(0);b[e+12>>0]=v;v=f[c>>2]|0;g=c+4|0;if((v|0)>=(f[g>>2]|0)){u=d;return}c=a+76|0;m=a+108|0;i=a+20|0;w=a+48|0;x=a+128|0;y=p+-4|0;z=(p|0)<4;A=a+124|0;a=(s|0)>0;B=p&-4;C=(p|0)>0;D=(B|0)<(p|0);E=o;o=v;while(1){v=(f[c>>2]|0)+(Y(f[m>>2]|0,o)|0)|0;F=Y(E,o)|0;G=(F+E|0)<=(j|0)?r:0;if((F|0)<(j|0)){H=cna(e,(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,F)|0)|0,v,G)|0;b:do if((H|0)<(G|0)){if(z){I=H;while(1){J=(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,F)|0)|0;K=J+(f[(f[x>>2]|0)+(I<<2)>>2]|0)|0;if(C){J=f[A>>2]|0;L=0;M=0;while(1){N=(h[K+(f[J+(L<<2)>>2]|0)>>0]|0)+M|0;L=L+1|0;if((L|0)==(p|0)){O=N;break}else M=N}}else O=0;M=wNa(q*+(O|0))|0;b[v+I>>0]=M>>>0<256?M:(M|0)>0?255:0;I=I+1|0;if((I|0)==(G|0)){P=G;break b}}}else Q=H;do{I=(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,F)|0)|0;M=I+(f[(f[x>>2]|0)+(Q<<2)>>2]|0)|0;I=f[A>>2]|0;L=0;J=0;do{J=(h[M+(f[I+(L<<2)>>2]|0)>>0]|0)+J+(h[M+(f[I+((L|1)<<2)>>2]|0)>>0]|0)+(h[M+(f[I+((L|2)<<2)>>2]|0)>>0]|0)+(h[M+(f[I+((L|3)<<2)>>2]|0)>>0]|0)|0;L=L+4|0}while((L|0)<=(y|0));if(D){L=B;K=J;while(1){N=(h[M+(f[I+(L<<2)>>2]|0)>>0]|0)+K|0;L=L+1|0;if((L|0)==(p|0)){R=N;break}else K=N}}else R=J;K=wNa(q*+(R|0))|0;b[v+Q>>0]=K>>>0<256?K:(K|0)>0?255:0;Q=Q+1|0}while((Q|0)!=(G|0));P=G}else P=H;while(0);if((P|0)<(s|0)){H=P;do{G=f[(f[x>>2]|0)+(H<<2)>>2]|0;K=(G|0)<(t|0);if(!K)b[v+H>>0]=0;L=f[n>>2]|0;c:do if((L|0)<1|K^1){S=0;T=0}else{I=0;M=0;N=0;while(1){U=N+F|0;if((U|0)>=(j|0)){S=I;T=M;break c}V=(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,U)|0)+G|0;U=Y(f[l>>2]|0,k)|0;if((U|0)>0){W=I;X=M;Z=0;while(1){_=(h[V+Z>>0]|0)+X|0;$=W+1|0;Z=Z+k|0;if(!((Z+G|0)<(t|0)&(Z|0)<(U|0))){aa=$;ba=_;break}else{W=$;X=_}}}else{aa=I;ba=M}N=N+1|0;if((N|0)>=(L|0)){S=aa;T=ba;break}else{I=aa;M=ba}}}while(0);L=wNa(+(T|0)/+(S|0))|0;b[v+H>>0]=L>>>0<256?L:(L|0)>0?255:0;H=H+1|0}while((H|0)!=(s|0))}}else if(a)F1a(v|0,0,s|0)|0;H=o+1|0;if((H|0)>=(f[g>>2]|0))break;E=f[n>>2]|0;o=H}u=d;return}function cna(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;i=g;if(!(b[a+12>>0]|0)){j=0;u=g;return j|0}k=c+(f[a+16>>2]|0)|0;switch(f[a+8>>2]|0){case 1:{if((e|0)>0)l=0;else{j=0;u=g;return j|0}do{a=l<<1;m=a|1;b[d+l>>0]=((h[c+a>>0]|0)+2+(h[c+m>>0]|0)+(h[k+a>>0]|0)+(h[k+m>>0]|0)|0)>>>2;l=l+1|0}while((l|0)!=(e|0));j=e;u=g;return j|0}case 3:{if((e|0)>0)n=0;else{j=0;u=g;return j|0}while(1){l=n<<1;m=l+3|0;b[d+n>>0]=((h[c+l>>0]|0)+2+(h[c+m>>0]|0)+(h[k+l>>0]|0)+(h[k+m>>0]|0)|0)>>>2;m=l|1;a=l+4|0;b[d+(n+1)>>0]=((h[c+m>>0]|0)+2+(h[c+a>>0]|0)+(h[k+m>>0]|0)+(h[k+a>>0]|0)|0)>>>2;a=l+2|0;m=l+5|0;b[d+(n+2)>>0]=((h[c+a>>0]|0)+2+(h[c+m>>0]|0)+(h[k+a>>0]|0)+(h[k+m>>0]|0)|0)>>>2;m=n+3|0;if((m|0)<(e|0))n=m;else{j=m;break}}u=g;return j|0}case 4:break;default:{f[i>>2]=0;f[i+4>>2]=0;n=c$(i,7)|0;b[n>>0]=b[325727]|0;b[n+1>>0]=b[325728]|0;b[n+2>>0]=b[325729]|0;b[n+3>>0]=b[325730]|0;b[n+4>>0]=b[325731]|0;b[n+5>>0]=b[325732]|0;b[n+6>>0]=b[325733]|0;j$(-215,i,373355,323470,2164);d$(i)}}if((e|0)>0)o=0;else{j=0;u=g;return j|0}do{i=o<<1;n=i|4;b[d+o>>0]=((h[c+i>>0]|0)+2+(h[c+n>>0]|0)+(h[k+i>>0]|0)+(h[k+n>>0]|0)|0)>>>2;n=i|1;m=i|5;b[d+(o|1)>>0]=((h[c+n>>0]|0)+2+(h[c+m>>0]|0)+(h[k+n>>0]|0)+(h[k+m>>0]|0)|0)>>>2;m=i|2;n=i|6;b[d+(o|2)>>0]=((h[c+m>>0]|0)+2+(h[c+n>>0]|0)+(h[k+m>>0]|0)+(h[k+n>>0]|0)|0)>>>2;n=i|3;m=i|7;b[d+(o|3)>>0]=((h[c+n>>0]|0)+2+(h[c+m>>0]|0)+(h[k+n>>0]|0)+(h[k+m>>0]|0)|0)>>>2;o=o+4|0}while((o|0)<(e|0));j=e+3&-4;u=g;return j|0}function dna(a){a=a|0;tka(a);PYa(a);return}function ena(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=f[(f[a+100>>2]|0)+4>>2]|0;g=f[a+8>>2]|0;if((g|0)>0)h=f[(f[a+48>>2]|0)+(g+-1<<2)>>2]|0;else h=0;g=f[c>>2]|0;i=c+4|0;if((g|0)>=(f[i>>2]|0))return;c=a+76|0;j=a+108|0;k=a+128|0;l=(f[f[a+44>>2]>>2]|0)+-1|0;m=a+20|0;n=a+48|0;o=(e|0)>0;q=a+116|0;r=a+120|0;a=e+-2|0;s=(e|0)<2;t=e&-2;u=g;do{g=(f[c>>2]|0)+(Y(f[j>>2]|0,u)|0)|0;v=+(u|0)*+p[k>>3];w=~~v;x=w-(+(w|0)>v&1)|0;w=(f[m>>2]|0)+(Y((l|0)<(x|0)?l:x,f[f[n>>2]>>2]|0)|0)|0;switch(h|0){case 1:{if(s)y=0;else{x=0;do{z=f[q>>2]|0;A=x|1;B=b[w+(f[z+(A<<2)>>2]|0)>>0]|0;b[g+x>>0]=b[w+(f[z+(x<<2)>>2]|0)>>0]|0;b[g+A>>0]=B;x=x+2|0}while((x|0)<=(a|0));y=t}if((y|0)<(e|0)){x=y;do{b[g+x>>0]=b[w+(f[(f[q>>2]|0)+(x<<2)>>2]|0)>>0]|0;x=x+1|0}while((x|0)!=(e|0))}break}case 2:{if(o){x=f[q>>2]|0;B=0;do{d[g+(B<<1)>>1]=d[w+(f[x+(B<<2)>>2]|0)>>1]|0;B=B+1|0}while((B|0)!=(e|0))}break}case 3:{if(o){B=g;x=0;while(1){A=w+(f[(f[q>>2]|0)+(x<<2)>>2]|0)|0;b[B>>0]=b[A>>0]|0;b[B+1>>0]=b[A+1>>0]|0;b[B+2>>0]=b[A+2>>0]|0;x=x+1|0;if((x|0)==(e|0))break;else B=B+3|0}}break}case 4:{if(o){B=f[q>>2]|0;x=0;do{f[g+(x<<2)>>2]=f[w+(f[B+(x<<2)>>2]|0)>>2];x=x+1|0}while((x|0)!=(e|0))}break}case 6:{if(o){x=f[q>>2]|0;B=g;A=0;while(1){z=w+(f[x+(A<<2)>>2]|0)|0;d[B>>1]=d[z>>1]|0;d[B+2>>1]=d[z+2>>1]|0;d[B+4>>1]=d[z+4>>1]|0;A=A+1|0;if((A|0)==(e|0))break;else B=B+6|0}}break}case 8:{if(o){B=f[q>>2]|0;A=g;x=0;while(1){z=w+(f[B+(x<<2)>>2]|0)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];x=x+1|0;if((x|0)==(e|0))break;else A=A+8|0}}break}case 12:{if(o){A=f[q>>2]|0;x=g;B=0;while(1){z=w+(f[A+(B<<2)>>2]|0)|0;f[x>>2]=f[z>>2];f[x+4>>2]=f[z+4>>2];f[x+8>>2]=f[z+8>>2];B=B+1|0;if((B|0)==(e|0))break;else x=x+12|0}}break}default:if(o){x=f[q>>2]|0;B=f[r>>2]|0;A=g;z=0;while(1){C=w+(f[x+(z<<2)>>2]|0)|0;if((B|0)>0){D=0;do{f[A+(D<<2)>>2]=f[C+(D<<2)>>2];D=D+1|0;E=f[r>>2]|0}while((D|0)<(E|0));F=E}else F=B;z=z+1|0;if((z|0)==(e|0))break;else{B=F;A=A+h|0}}}}u=u+1|0}while((u|0)<(f[i>>2]|0));return}function fna(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0;i=u;u=u+160|0;j=i+144|0;k=i+136|0;l=i+80|0;m=i+72|0;n=i+16|0;o=i;_$(j,75124);QR(k,a,-1);if(!((f[k>>2]|0)>0?(f[k+4>>2]|0)>0:0)){f[l>>2]=0;f[l+4>>2]=0;p=c$(l,35)|0;q=326132;r=p+35|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,l,323463,323470,3289);d$(l)}s=f[d>>2]|0;t=d+4|0;v=f[t>>2]|0;if((Y(v,s)|0)<=0?!(e>0.0&g>0.0):0){f[l>>2]=0;f[l+4>>2]=0;p=c$(l,56)|0;q=326168;r=p+56|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,l,323463,323470,3290);d$(l);w=f[d>>2]|0;x=f[t>>2]|0}else{w=s;x=v}if(!(Y(x,w)|0)){v=rNa(+(f[k>>2]|0)*e)|0;s=rNa(+(f[k+4>>2]|0)*g)|0;f[d>>2]=v;f[t>>2]=s;if((Y(s,v)|0)>0){y=e;z=g}else{f[l>>2]=0;f[l+4>>2]=0;p=c$(l,16)|0;q=323521;r=p+16|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,l,323463,323470,3295);d$(l);y=e;z=g}}else{y=+(w|0)/+(f[k>>2]|0);z=+(x|0)/+(f[k+4>>2]|0)}do if((NS(a)|0)==65536){x=f[a+4>>2]|0;f[l>>2]=f[x>>2];w=l+4|0;q=x+4|0;f[w>>2]=f[q>>2];p=l+8|0;f[p>>2]=f[x+8>>2];f[l+12>>2]=f[x+12>>2];f[l+16>>2]=f[x+16>>2];f[l+20>>2]=f[x+20>>2];f[l+24>>2]=f[x+24>>2];f[l+28>>2]=f[x+28>>2];f[l+32>>2]=f[x+32>>2];r=f[x+36>>2]|0;f[l+36>>2]=r;f[l+40>>2]=p;p=l+48|0;v=l+44|0;f[v>>2]=p;f[p>>2]=0;f[l+52>>2]=0;if(r|0){p=r+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[q>>2]|0)<3){q=f[x+44>>2]|0;p=f[v>>2]|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];A=l;break}else{f[w>>2]=0;BR(l,x);A=l;break}}else{OR(l,a,-1);A=l}while(0);f[m>>2]=f[d>>2];f[m+4>>2]=f[t>>2];KS(c,m,f[A>>2]&4095,-1,0,0);do if((NS(c)|0)==65536){m=f[c+4>>2]|0;f[n>>2]=f[m>>2];a=n+4|0;x=m+4|0;f[a>>2]=f[x>>2];w=n+8|0;f[w>>2]=f[m+8>>2];f[n+12>>2]=f[m+12>>2];f[n+16>>2]=f[m+16>>2];f[n+20>>2]=f[m+20>>2];f[n+24>>2]=f[m+24>>2];f[n+28>>2]=f[m+28>>2];f[n+32>>2]=f[m+32>>2];q=f[m+36>>2]|0;f[n+36>>2]=q;f[n+40>>2]=w;w=n+48|0;p=n+44|0;f[p>>2]=w;f[w>>2]=0;f[n+52>>2]=0;if(q|0){w=q+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[x>>2]|0)<3){x=f[m+44>>2]|0;w=f[p>>2]|0;f[w>>2]=f[x>>2];f[w+4>>2]=f[x+4>>2];break}else{f[a>>2]=0;BR(n,m);break}}else OR(n,c,-1);while(0);if((f[d>>2]|0)==(f[k>>2]|0)?(f[t>>2]|0)==(f[k+4>>2]|0):0){k=o+8|0;f[k>>2]=0;f[k+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=n;eL(l,o)}else rka(f[A>>2]&4095,f[l+16>>2]|0,f[l+48>>2]|0,f[l+12>>2]|0,f[l+8>>2]|0,f[n+16>>2]|0,f[n+48>>2]|0,f[n+12>>2]|0,f[n+8>>2]|0,y,z,h);h=n+36|0;A=f[h>>2]|0;if(A|0?(o=A+12|0,A=f[o>>2]|0,f[o>>2]=A+-1,(A|0)==1):0)CR(n);f[h>>2]=0;h=n+16|0;A=n+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[A>>2]|0)>0){h=f[n+40>>2]|0;o=0;do{f[h+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[A>>2]|0))}A=f[n+44>>2]|0;if((A|0)!=(n+48|0))ZF(A);A=l+36|0;n=f[A>>2]|0;if(n|0?(o=n+12|0,n=f[o>>2]|0,f[o>>2]=n+-1,(n|0)==1):0)CR(l);f[A>>2]=0;A=l+16|0;n=l+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[n>>2]|0)>0){A=f[l+40>>2]|0;o=0;do{f[A+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[n>>2]|0))}n=f[l+44>>2]|0;if((n|0)!=(l+48|0))ZF(n);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function gna(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+160|0;g=e+96|0;h=e+40|0;i=e+24|0;j=e;k=e+16|0;JR(g,a,0,1,0,0);JR(h,c,0,1,0,0);if((f[h>>2]^f[g>>2])&4095|0){f[i>>2]=0;f[i+4>>2]=0;c=c$(i,24)|0;a=326293;l=c+24|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(l|0));j$(-215,i,326318,323470,3325);d$(i)}f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=g;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=h;a=h+40|0;c=f[a>>2]|0;l=f[c>>2]|0;f[k>>2]=f[c+4>>2];f[k+4>>2]=l;fna(i,j,k,+(f[h+12>>2]|0)/+(f[g+12>>2]|0),+(f[h+8>>2]|0)/+(f[g+8>>2]|0),d);d=h+36|0;k=f[d>>2]|0;if(k|0?(j=k+12|0,k=f[j>>2]|0,f[j>>2]=k+-1,(k|0)==1):0)CR(h);f[d>>2]=0;d=h+16|0;k=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[k>>2]|0)>0){d=f[a>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[k>>2]|0))}k=f[h+44>>2]|0;if((k|0)!=(h+48|0))ZF(k);k=g+36|0;h=f[k>>2]|0;if(h|0?(a=h+12|0,h=f[a>>2]|0,f[a>>2]=h+-1,(h|0)==1):0)CR(g);f[k>>2]=0;k=g+16|0;h=g+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[h>>2]|0)>0){k=f[g+40>>2]|0;a=0;do{f[k+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)==(g+48|0)){u=e;return}ZF(h);u=e;return}function hna(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0,ga=0.0,ha=0.0,ia=0.0,ja=0,ka=0.0,la=0.0;d=u;u=u+1152|0;e=d+88|0;g=d+72|0;h=d+64|0;i=d+56|0;j=d;_$(i,75144);f[j>>2]=1124007936;k=j+4|0;l=j+8|0;m=j+40|0;o=k;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[m>>2]=l;q=j+48|0;r=j+44|0;f[r>>2]=q;f[q>>2]=0;f[j+52>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;t=e+8|0;f[t>>2]=0;f[t+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=j;i7(c,e,1,1);if((f[j>>2]&7|0)!=5){f[e>>2]=1124007936;c=e+4|0;t=e+8|0;v=e+40|0;o=c;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[v>>2]=t;w=e+48|0;x=e+44|0;f[x>>2]=w;f[w>>2]=0;f[e+52>>2]=0;y=g+8|0;f[y>>2]=0;f[y+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=e;WJ(j,g,5,1.0,0.0);y=e+36|0;z=f[y>>2]|0;if(z|0){A=z+12|0;f[A>>2]=(f[A>>2]|0)+1}A=j+36|0;z=f[A>>2]|0;if(z|0?(B=z+12|0,z=f[B>>2]|0,f[B>>2]=z+-1,(z|0)==1):0)CR(j);f[A>>2]=0;z=j+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[k>>2]|0)>0){B=f[m>>2]|0;C=0;do{f[B+(C<<2)>>2]=0;C=C+1|0;D=f[k>>2]|0}while((C|0)<(D|0));f[j>>2]=f[e>>2];if((D|0)<3)E=12;else E=14}else{f[j>>2]=f[e>>2];E=12}if((E|0)==12){D=f[c>>2]|0;if((D|0)<3){f[k>>2]=D;f[l>>2]=f[t>>2];f[j+12>>2]=f[e+12>>2];t=f[x>>2]|0;l=f[r>>2]|0;f[l>>2]=f[t>>2];f[l+4>>2]=f[t+4>>2]}else E=14}if((E|0)==14)BR(j,e);t=e+16|0;f[z>>2]=f[t>>2];f[j+20>>2]=f[e+20>>2];f[j+24>>2]=f[e+24>>2];f[j+28>>2]=f[e+28>>2];f[j+32>>2]=f[e+32>>2];z=f[y>>2]|0;f[A>>2]=z;if(z|0?(A=z+12|0,z=f[A>>2]|0,f[A>>2]=z+-1,(z|0)==1):0)CR(e);f[y>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[c>>2]|0)>0){t=f[v>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[c>>2]|0))}c=f[x>>2]|0;if((c|0)!=(w|0))ZF(c)}c=LS(j,2,-1,1)|0;w=j+16|0;x=f[w>>2]|0;a:do if((c|0)>2){v=c*3|0;t=e+8|0;f[e>>2]=t;y=e+4|0;f[y>>2]=v;if(v>>>0>264){z=OYa(v>>>0>1073741823?-1:v<<2)|0;f[e>>2]=z;F=z}else F=t;z=F+(c<<2)|0;f[g>>2]=-1;f[g+4>>2]=-1;f[g+8>>2]=-1;f[g+12>>2]=-1;v=f[x>>2]|0;A=f[x+4>>2]|0;G=(f[s>>2]=v,+n[s>>2]);H=(f[s>>2]=A,+n[s>>2]);l=0;I=H;D=0;C=0;J=G;B=v;v=A;A=0;K=G;L=0;G=H;while(1){H=(f[s>>2]=B,+n[s>>2]);N=H<J;C=N?D:C;O=H>K;A=O?D:A;P=(f[s>>2]=v,+n[s>>2]);Q=P>G;L=Q?D:L;R=P<I;l=R?D:l;S=D;D=D+1|0;T=(D|0)<(c|0)?D:0;B=f[x+(T<<3)>>2]|0;v=f[x+(T<<3)+4>>2]|0;V=(f[s>>2]=B,+n[s>>2])-H;W=V;X=(f[s>>2]=v,+n[s>>2])-P;Y=X;n[z+(S<<3)>>2]=V;n[z+(S<<3)+4>>2]=X;X=1.0/+M(+(W*W+Y*Y));n[F+(S<<2)>>2]=X;if((D|0)==(c|0))break;else{I=R?P:I;J=N?H:J;K=O?H:K;G=Q?P:G}}D=c+-1|0;G=+n[z+(D<<3)>>2];K=+n[z+(D<<3)+4>>2];D=0;while(1){J=G;G=+n[z+(D<<3)>>2];I=K;K=+n[z+(D<<3)+4>>2];Z=J*K-I*G;D=D+1|0;if(Z!=0.0){E=33;break}if((D|0)>=(c|0)){E=32;break}}if((E|0)==32){f[h>>2]=0;f[h+4>>2]=0;o=c$(h,16)|0;D=326327;p=o+16|0;do{b[o>>0]=b[D>>0]|0;o=o+1|0;D=D+1|0}while((o|0)<(p|0));j$(-215,h,326344,326361,166);d$(h);_=0.0}else if((E|0)==33)_=Z>0.0?1.0:-1.0;f[g>>2]=l;D=g+4|0;f[D>>2]=A;v=g+8|0;f[v>>2]=L;B=g+12|0;f[B>>2]=C;Q=l;O=A;N=L;R=C;G=_;K=0.0;S=0;I=0.0;J=0.0;P=0.0;T=0;H=0.0;$=0;X=3402823466385288598117041.0e14;b:while(1){Y=(G*+n[z+(Q<<3)>>2]+K*+n[z+(Q<<3)+4>>2])*+n[F+(Q<<2)>>2];W=(G*+n[z+(O<<3)+4>>2]-K*+n[z+(O<<3)>>2])*+n[F+(O<<2)>>2];aa=W>Y;V=aa?W:Y;Y=(-(G*+n[z+(N<<3)>>2])-K*+n[z+(N<<3)+4>>2])*+n[F+(N<<2)>>2];ba=Y>V;ca=(K*+n[z+(R<<3)>>2]-G*+n[z+(R<<3)+4>>2])*+n[F+(R<<2)>>2]>(ba?Y:V)?3:ba?2:aa&1;aa=g+(ca<<2)|0;ba=f[aa>>2]|0;V=+n[F+(ba<<2)>>2];Y=+n[z+(ba<<3)>>2]*V;W=V*+n[z+(ba<<3)+4>>2];switch(ca&3){case 0:{da=Y;ea=W;break}case 1:{da=W;ea=-Y;break}case 2:{da=-Y;ea=-W;break}case 3:{da=-W;ea=Y;break}default:{E=39;break b}}ca=ba+1|0;f[aa>>2]=(ca|0)==(c|0)?0:ca;O=f[D>>2]|0;R=f[B>>2]|0;Y=da*(+n[x+(O<<3)>>2]-+n[x+(R<<3)>>2])+ea*(+n[x+(O<<3)+4>>2]-+n[x+(R<<3)+4>>2]);N=f[v>>2]|0;Q=f[g>>2]|0;W=da*(+n[x+(N<<3)+4>>2]-+n[x+(Q<<3)+4>>2])-ea*(+n[x+(N<<3)>>2]-+n[x+(Q<<3)>>2]);V=Y*W;if(!(V<=X)){fa=S;ga=I;ha=J;ia=P;ja=T;ka=H;la=X}else{fa=R;ga=Y;ha=ea;ia=W;ja=Q;ka=da;la=V}$=$+1|0;if(($|0)>=(c|0))break;else{G=da;K=ea;S=fa;I=ga;J=ha;P=ia;T=ja;H=ka;X=la}}X=-ha;H=ka*+n[x+(fa<<3)>>2]+ha*+n[x+(fa<<3)+4>>2];P=+n[x+(ja<<3)>>2]*X+ka*+n[x+(ja<<3)+4>>2];J=1.0/(ka*ka-ha*X);I=J*(ka*H-ha*P);K=J*(ka*P-H*X);H=ga*ka;P=ha*ga;J=ia*X;X=ia*ka;T=f[e>>2]|0;if((T|0)!=(t|0)){if(T|0)QYa(T);f[e>>2]=t;f[y>>2]=264}n[a>>2]=I+(H+J)*.5;n[a+4>>2]=K+(P+X)*.5;K=H;H=P;P=+M(+(K*K+H*H));n[a+8>>2]=P;P=J;J=X;X=+M(+(P*P+J*J));n[a+12>>2]=X;X=+U(+H,+K);n[a+16>>2]=X}else switch(c|0){case 2:{X=+n[x>>2];K=+n[x+8>>2];n[a>>2]=(X+K)*.5;H=+n[x+4>>2];J=+n[x+12>>2];n[a+4>>2]=(H+J)*.5;P=K-X;X=J-H;H=+M(+(P*P+X*X));n[a+8>>2]=H;n[a+12>>2]=0.0;H=+U(+X,+P);n[a+16>>2]=H;break a;break}case 1:{f[a>>2]=f[x>>2];f[a+4>>2]=f[x+4>>2];break a;break}default:break a}while(0);x=a+16|0;n[x>>2]=+n[x>>2]*180.0/3.141592653589793;x=j+36|0;a=f[x>>2]|0;if(a|0?(c=a+12|0,a=f[c>>2]|0,f[c>>2]=a+-1,(a|0)==1):0)CR(j);f[x>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[k>>2]|0)>0){w=f[m>>2]|0;m=0;do{f[w+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[r>>2]|0;if((k|0)!=(q|0))ZF(k);if(!(f[i+4>>2]|0)){u=d;return}u=d;return}function ina(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;d=u;u=u+4256|0;e=d+4240|0;g=d+4184|0;i=d+4128|0;j=d+4112|0;k=d+2064|0;l=d+8|0;m=d;_$(e,75164);do if((NS(a)|0)==65536){n=f[a+4>>2]|0;f[g>>2]=f[n>>2];o=g+4|0;p=n+4|0;f[o>>2]=f[p>>2];q=g+8|0;f[q>>2]=f[n+8>>2];f[g+12>>2]=f[n+12>>2];f[g+16>>2]=f[n+16>>2];f[g+20>>2]=f[n+20>>2];f[g+24>>2]=f[n+24>>2];f[g+28>>2]=f[n+28>>2];f[g+32>>2]=f[n+32>>2];r=f[n+36>>2]|0;f[g+36>>2]=r;f[g+40>>2]=q;q=g+48|0;s=g+44|0;f[s>>2]=q;f[q>>2]=0;f[g+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[n+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[o>>2]=0;BR(g,n);break}}else OR(g,a,-1);while(0);do if((NS(c)|0)==65536){a=f[c+4>>2]|0;f[i>>2]=f[a>>2];n=i+4|0;o=a+4|0;f[n>>2]=f[o>>2];p=i+8|0;f[p>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];q=f[a+36>>2]|0;f[i+36>>2]=q;f[i+40>>2]=p;p=i+48|0;s=i+44|0;f[s>>2]=p;f[p>>2]=0;f[i+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[a+44>>2]|0;p=f[s>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[n>>2]=0;BR(i,a);break}}else OR(i,c,-1);while(0);c=g+40|0;a=f[c>>2]|0;n=f[a+4>>2]|0;o=f[a>>2]|0;f[j>>2]=0;p=j+4|0;f[p>>2]=0;f[j+8>>2]=0;F1a(k|0,0,2048)|0;if((f[g>>2]&4095|0)==16?(f[i>>2]&4095|0)==4:0)t=a;else{f[m>>2]=0;f[m+4>>2]=0;v=c$(m,114)|0;w=326461;x=v+114|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-215,m,326576,326586,161);d$(m);t=f[c>>2]|0}a=i+40|0;s=f[a>>2]|0;if(!((f[t>>2]|0)==(f[s>>2]|0)?(f[t+4>>2]|0)==(f[s+4>>2]|0):0)){f[m>>2]=0;f[m+4>>2]=0;v=c$(m,24)|0;w=326643;x=v+24|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));j$(-215,m,326576,326586,162);d$(m)}m=g+16|0;w=f[m>>2]|0;v=g+48|0;x=f[v>>2]|0;s=i+16|0;t=f[s>>2]|0;q=i+48|0;r=f[q>>2]|0;F1a(l|0,0,1024)|0;y=g+44|0;z=i+44|0;A=r>>>2;r=256;do{f[l+(r<<2)>>2]=r+-256;r=r+1|0}while((r|0)!=513);r=o+-1|0;if((n|0)>0){o=Y(A,r)|0;B=0;do{f[t+(B+o<<2)>>2]=-1;f[t+(B<<2)>>2]=-1;B=B+1|0}while((B|0)!=(n|0))}if((r|0)>1){B=n+-1|0;n=(B|0)>1;o=0-A|0;C=0-x|0;D=0;E=1;F=w;w=t;while(1){F=F+x|0;w=w+(A<<2)|0;f[w+(B<<2)>>2]=-1;f[w>>2]=-1;if(n){t=Y(E,A)|0;G=Y(E,x)|0;H=D;I=1;while(1){J=w+(I<<2)|0;K=f[J>>2]|0;if((K|0)>=0)if(!K)L=33;else M=H;else{f[J>>2]=0;L=33}do if((L|0)==33){L=0;if((f[J+-4>>2]|0)>0){K=I*3|0;N=F+K|0;O=N+-3|0;P=(h[N>>0]|0)-(h[O>>0]|0)|0;Q=(h[N+1>>0]|0)-(h[O+1>>0]|0)|0;R=(Q|0)>-1?Q:0-Q|0;Q=(h[N+2>>0]|0)-(h[O+2>>0]|0)|0;O=(Q|0)>-1?Q:0-Q|0;S=f[J+4>>2]|0;T=N;U=O+(f[l+((f[l+(((P|0)>-1?P:0-P|0)+256-R<<2)>>2]|0)+256+R-O<<2)>>2]|0)|0;V=K}else{K=f[J+4>>2]|0;if(((K|0)<=0?(f[J+(o<<2)>>2]|0)<=0:0)?(f[J+(A<<2)>>2]|0)<=0:0){M=H;break}O=I*3|0;S=K;T=F+O|0;U=256;V=O}if((S|0)>0){O=(h[T>>0]|0)-(h[T+3>>0]|0)|0;K=(h[T+1>>0]|0)-(h[T+4>>0]|0)|0;R=(K|0)>-1?K:0-K|0;K=(h[T+2>>0]|0)-(h[T+5>>0]|0)|0;P=(K|0)>-1?K:0-K|0;W=U-(f[l+(U+256-(f[l+((f[l+(((O|0)>-1?O:0-O|0)+256-R<<2)>>2]|0)+256+R-P<<2)>>2]|0)-P<<2)>>2]|0)|0}else W=U;if((f[J+(o<<2)>>2]|0)>0){P=T+C|0;R=(h[T>>0]|0)-(h[P>>0]|0)|0;O=(h[T+1>>0]|0)-(h[P+1>>0]|0)|0;K=(O|0)>-1?O:0-O|0;O=(h[T+2>>0]|0)-(h[P+2>>0]|0)|0;P=(O|0)>-1?O:0-O|0;X=W-(f[l+(W+256-(f[l+((f[l+(((R|0)>-1?R:0-R|0)+256-K<<2)>>2]|0)+256+K-P<<2)>>2]|0)-P<<2)>>2]|0)|0}else X=W;if((f[J+(A<<2)>>2]|0)>0){P=T+x|0;K=(h[T>>0]|0)-(h[P>>0]|0)|0;R=(h[T+1>>0]|0)-(h[P+1>>0]|0)|0;O=(R|0)>-1?R:0-R|0;R=(h[T+2>>0]|0)-(h[P+2>>0]|0)|0;P=(R|0)>-1?R:0-R|0;Z=X-(f[l+(X+256-(f[l+((f[l+(((K|0)>-1?K:0-K|0)+256-O<<2)>>2]|0)+256+O-P<<2)>>2]|0)-P<<2)>>2]|0)|0}else Z=X;if(!H){P=f[p>>2]|0;O=f[j>>2]|0;K=P-O|0;R=(K|0)/12|0;N=R*3|0;Q=(N|0)>257?(N|0)/2|0:128;N=O;O=P;do if(Q>>>0>R>>>0){jna(j,Q-R|0);L=52}else{if(Q>>>0>=R>>>0){L=52;break}P=N+(Q*12|0)|0;if((O|0)==(P|0)){_=N;$=R;break}f[p>>2]=O+(~(((O+-12-P|0)>>>0)/12|0)*12|0);_=N;$=R}while(0);do if((L|0)==52){L=0;N=f[j>>2]|0;if(K|0){_=N;$=R;break}f[N>>2]=0;_=N;$=1}while(0);R=Q+-1|0;if(($|0)<(R|0)){K=$;do{N=K;K=K+1|0;f[_+(N*12|0)>>2]=K}while((K|0)!=(R|0))}f[_+(R*12|0)>>2]=0;aa=_;ba=$}else{aa=f[j>>2]|0;ba=H}K=aa+(ba*12|0)|0;Q=f[K>>2]|0;f[K>>2]=0;f[aa+(ba*12|0)+4>>2]=I+t;f[aa+(ba*12|0)+8>>2]=V+G;K=k+(Z<<3)+4|0;N=f[K>>2]|0;f[((N|0)==0?k+(Z<<3)|0:(f[j>>2]|0)+(N*12|0)|0)>>2]=ba;f[K>>2]=ba;f[J>>2]=-2;M=Q}while(0);I=I+1|0;if((I|0)>=(B|0)){ca=M;break}else H=M}}else ca=D;E=E+1|0;if((E|0)>=(r|0)){da=ca;break}else D=ca}}else da=0;ca=0;while(1){if(f[k+(ca<<3)>>2]|0){ea=ca;L=63;break}ca=ca+1|0;if((ca|0)>=256){L=62;break}}if((L|0)==62?(ca|0)!=256:0){ea=ca;L=63}a:do if((L|0)==63){ca=f[m>>2]|0;D=f[s>>2]|0;r=0-A|0;E=0-x|0;M=ea;B=da;while(1){ba=f[k+(M<<3)>>2]|0;b:do if(!ba){Z=M;while(1){fa=Z+1|0;if((fa|0)>=256)break;V=f[k+(fa<<3)>>2]|0;if(!V)Z=fa;else{ga=V;ha=fa;break b}}if((fa|0)==256)break a;ga=f[k+(fa<<3)>>2]|0;ha=fa}else{ga=ba;ha=M}while(0);ba=f[j>>2]|0;Z=ba+(ga*12|0)|0;R=f[Z>>2]|0;f[k+(ha<<3)>>2]=R;V=ba;if(!R)f[k+(ha<<3)+4>>2]=0;f[Z>>2]=B;Z=f[ba+(ga*12|0)+4>>2]|0;R=f[ba+(ga*12|0)+8>>2]|0;aa=D+(Z<<2)|0;$=ca+R|0;_=aa+-4|0;X=f[_>>2]|0;T=(X|0)>0?X:0;W=aa+4|0;C=f[W>>2]|0;if((C|0)>0)ia=(X|0)<1?C:(C|0)==(T|0)?T:-1;else ia=T;T=aa+(r<<2)|0;o=f[T>>2]|0;if((o|0)>0)ja=(ia|0)==0?o:(o|0)==(ia|0)?ia:-1;else ja=ia;o=aa+(A<<2)|0;U=f[o>>2]|0;if((U|0)>0)if(!ja)f[aa>>2]=U;else{ka=(U|0)==(ja|0)?ja:-1;L=78}else{ka=ja;L=78}if((L|0)==78?(L=0,f[aa>>2]=ka,(ka|0)==-1):0){M=ha;B=ga;continue}if(!X){X=$+-3|0;aa=(h[$>>0]|0)-(h[X>>0]|0)|0;U=(h[$+1>>0]|0)-(h[X+1>>0]|0)|0;S=(U|0)>-1?U:0-U|0;U=(h[$+2>>0]|0)-(h[X+2>>0]|0)|0;X=(U|0)>-1?U:0-U|0;U=X+(f[l+((f[l+(((aa|0)>-1?aa:0-aa|0)+256-S<<2)>>2]|0)+256+S-X<<2)>>2]|0)|0;if(!ga){X=f[p>>2]|0;S=X-V|0;aa=(S|0)/12|0;F=aa*3|0;w=(F|0)>257?(F|0)/2|0:128;F=X;do if(w>>>0<=aa>>>0)if(w>>>0<aa>>>0){X=ba+(w*12|0)|0;if((F|0)==(X|0)){la=ba;ma=aa;break}f[p>>2]=F+(~(((F+-12-X|0)>>>0)/12|0)*12|0);la=ba;ma=aa}else L=86;else{jna(j,w-aa|0);L=86}while(0);if((L|0)==86){L=0;F=f[j>>2]|0;if(!S){f[F>>2]=0;la=F;ma=1}else{la=F;ma=aa}}F=w+-1|0;if((ma|0)<(F|0)){X=ma;do{n=X;X=X+1|0;f[la+(n*12|0)>>2]=X}while((X|0)!=(F|0))}f[la+(F*12|0)>>2]=0;na=la;oa=ma}else{na=ba;oa=ga}X=na+(oa*12|0)|0;w=f[X>>2]|0;f[X>>2]=0;f[na+(oa*12|0)+4>>2]=Z+-1;f[na+(oa*12|0)+8>>2]=R+-3;X=k+(U<<3)+4|0;aa=f[X>>2]|0;S=f[j>>2]|0;f[((aa|0)==0?k+(U<<3)|0:S+(aa*12|0)|0)>>2]=oa;f[X>>2]=oa;X=ha-(f[l+(ha+256-U<<2)>>2]|0)|0;f[_>>2]=-2;pa=f[W>>2]|0;qa=S;ra=S;sa=X;ta=w}else{pa=C;qa=V;ra=ba;sa=ha;ta=ga}if(!pa){w=$+3|0;X=(h[$>>0]|0)-(h[w>>0]|0)|0;S=(h[$+1>>0]|0)-(h[w+1>>0]|0)|0;aa=(S|0)>-1?S:0-S|0;S=(h[$+2>>0]|0)-(h[w+2>>0]|0)|0;w=(S|0)>-1?S:0-S|0;S=w+(f[l+((f[l+(((X|0)>-1?X:0-X|0)+256-aa<<2)>>2]|0)+256+aa-w<<2)>>2]|0)|0;if(!ta){w=f[p>>2]|0;aa=w-qa|0;X=(aa|0)/12|0;n=X*3|0;H=(n|0)>257?(n|0)/2|0:128;n=qa;I=w;do if(H>>>0>X>>>0){jna(j,H-X|0);L=99}else{if(H>>>0>=X>>>0){L=99;break}w=n+(H*12|0)|0;if((I|0)==(w|0)){ua=ra;va=X;break}f[p>>2]=I+(~(((I+-12-w|0)>>>0)/12|0)*12|0);ua=ra;va=X}while(0);do if((L|0)==99){L=0;I=f[j>>2]|0;if(aa|0){ua=I;va=X;break}f[I>>2]=0;ua=I;va=1}while(0);X=H+-1|0;if((va|0)<(X|0)){aa=va;do{I=aa;aa=aa+1|0;f[ua+(I*12|0)>>2]=aa}while((aa|0)!=(X|0))}f[ua+(X*12|0)>>2]=0;wa=ua;xa=va}else{wa=ra;xa=ta}aa=wa+(xa*12|0)|0;H=f[aa>>2]|0;f[aa>>2]=0;f[wa+(xa*12|0)+4>>2]=Z+1;f[wa+(xa*12|0)+8>>2]=R+3;aa=k+(S<<3)+4|0;I=f[aa>>2]|0;n=f[j>>2]|0;f[((I|0)==0?k+(S<<3)|0:n+(I*12|0)|0)>>2]=xa;f[aa>>2]=xa;aa=sa-(f[l+(sa+256-S<<2)>>2]|0)|0;f[W>>2]=-2;ya=n;za=n;Aa=aa;Ba=H}else{ya=qa;za=ra;Aa=sa;Ba=ta}if(!(f[T>>2]|0)){H=$+E|0;aa=(h[$>>0]|0)-(h[H>>0]|0)|0;n=(h[$+1>>0]|0)-(h[H+1>>0]|0)|0;I=(n|0)>-1?n:0-n|0;n=(h[$+2>>0]|0)-(h[H+2>>0]|0)|0;H=(n|0)>-1?n:0-n|0;n=H+(f[l+((f[l+(((aa|0)>-1?aa:0-aa|0)+256-I<<2)>>2]|0)+256+I-H<<2)>>2]|0)|0;if(!Ba){H=f[p>>2]|0;I=H-ya|0;aa=(I|0)/12|0;ba=aa*3|0;V=(ba|0)>257?(ba|0)/2|0:128;ba=ya;C=H;do if(V>>>0>aa>>>0){jna(j,V-aa|0);L=112}else{if(V>>>0>=aa>>>0){L=112;break}H=ba+(V*12|0)|0;if((C|0)==(H|0)){Ca=za;Da=aa;break}f[p>>2]=C+(~(((C+-12-H|0)>>>0)/12|0)*12|0);Ca=za;Da=aa}while(0);do if((L|0)==112){L=0;C=f[j>>2]|0;if(I|0){Ca=C;Da=aa;break}f[C>>2]=0;Ca=C;Da=1}while(0);aa=V+-1|0;if((Da|0)<(aa|0)){I=Da;do{C=I;I=I+1|0;f[Ca+(C*12|0)>>2]=I}while((I|0)!=(aa|0))}f[Ca+(aa*12|0)>>2]=0;Ea=Ca;Fa=Da}else{Ea=za;Fa=Ba}I=Ea+(Fa*12|0)|0;V=f[I>>2]|0;f[I>>2]=0;f[Ea+(Fa*12|0)+4>>2]=Z-A;f[Ea+(Fa*12|0)+8>>2]=R-x;I=k+(n<<3)+4|0;C=f[I>>2]|0;ba=f[j>>2]|0;f[((C|0)==0?k+(n<<3)|0:ba+(C*12|0)|0)>>2]=Fa;f[I>>2]=Fa;I=Aa-(f[l+(Aa+256-n<<2)>>2]|0)|0;f[T>>2]=-2;Ga=ba;Ha=ba;Ia=I;Ja=V}else{Ga=ya;Ha=za;Ia=Aa;Ja=Ba}if(f[o>>2]|0){M=Ia;B=Ja;continue}V=$+x|0;I=(h[$>>0]|0)-(h[V>>0]|0)|0;ba=(h[$+1>>0]|0)-(h[V+1>>0]|0)|0;C=(ba|0)>-1?ba:0-ba|0;ba=(h[$+2>>0]|0)-(h[V+2>>0]|0)|0;V=(ba|0)>-1?ba:0-ba|0;ba=V+(f[l+((f[l+(((I|0)>-1?I:0-I|0)+256-C<<2)>>2]|0)+256+C-V<<2)>>2]|0)|0;if(!Ja){V=f[p>>2]|0;C=V-Ga|0;I=(C|0)/12|0;W=I*3|0;S=(W|0)>257?(W|0)/2|0:128;W=Ga;X=V;do if(S>>>0>I>>>0){jna(j,S-I|0);L=125}else{if(S>>>0>=I>>>0){L=125;break}V=W+(S*12|0)|0;if((X|0)==(V|0)){Ka=Ha;La=I;break}f[p>>2]=X+(~(((X+-12-V|0)>>>0)/12|0)*12|0);Ka=Ha;La=I}while(0);do if((L|0)==125){L=0;X=f[j>>2]|0;if(C|0){Ka=X;La=I;break}f[X>>2]=0;Ka=X;La=1}while(0);I=S+-1|0;if((La|0)<(I|0)){C=La;do{X=C;C=C+1|0;f[Ka+(X*12|0)>>2]=C}while((C|0)!=(I|0))}f[Ka+(I*12|0)>>2]=0;Ma=Ka;Na=La}else{Ma=Ha;Na=Ja}C=Ma+(Na*12|0)|0;S=f[C>>2]|0;f[C>>2]=0;f[Ma+(Na*12|0)+4>>2]=Z+A;f[Ma+(Na*12|0)+8>>2]=R+x;C=k+(ba<<3)+4|0;X=f[C>>2]|0;f[((X|0)==0?k+(ba<<3)|0:(f[j>>2]|0)+(X*12|0)|0)>>2]=Na;f[C>>2]=Na;C=Ia-(f[l+(Ia+256-ba<<2)>>2]|0)|0;f[o>>2]=-2;M=C;B=S}}while(0);Ia=f[j>>2]|0;if(Ia|0){j=f[p>>2]|0;if((j|0)!=(Ia|0))f[p>>2]=j+(~(((j+-12-Ia|0)>>>0)/12|0)*12|0);PYa(Ia)}Ia=i+36|0;j=f[Ia>>2]|0;if(j|0?(p=j+12|0,j=f[p>>2]|0,f[p>>2]=j+-1,(j|0)==1):0)CR(i);f[Ia>>2]=0;Ia=i+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[Ia>>2]|0)>0){s=f[a>>2]|0;a=0;do{f[s+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[Ia>>2]|0))}Ia=f[z>>2]|0;if((Ia|0)!=(q|0))ZF(Ia);Ia=g+36|0;q=f[Ia>>2]|0;if(q|0?(z=q+12|0,q=f[z>>2]|0,f[z>>2]=q+-1,(q|0)==1):0)CR(g);f[Ia>>2]=0;Ia=g+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[Ia>>2]|0)>0){m=f[c>>2]|0;c=0;do{f[m+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[Ia>>2]|0))}Ia=f[y>>2]|0;if((Ia|0)!=(v|0))ZF(Ia);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function jna(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/12|0)>>>0>=b>>>0){h=g;i=b;do{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;h=(f[e>>2]|0)+12|0;f[e>>2]=h;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;h=(g-i|0)/12|0;g=h+b|0;if(g>>>0>357913941)gXa(a);j=(d-i|0)/12|0;i=j<<1;d=j>>>0<178956970?(i>>>0<g>>>0?g:i):357913941;do if(d)if(d>>>0>357913941){i=De(8)|0;UYa(i,358155);f[i>>2]=130560;Of(i|0,21520,875)}else{k=NYa(d*12|0)|0;break}else k=0;while(0);i=k+(h*12|0)|0;h=k+(d*12|0)|0;d=i;k=b;b=i;do{f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;d=b+12|0;b=d;k=k+-1|0}while((k|0)!=0);k=f[a>>2]|0;d=(f[e>>2]|0)-k|0;g=i+(((d|0)/-12|0)*12|0)|0;if((d|0)>0)K1a(g|0,k|0,d|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=h;if(!k)return;PYa(k);return}function kna(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;e=u;u=u+112|0;g=e+96|0;h=e+40|0;i=e+32|0;j=e+24|0;k=e;_$(g,75184);do if((NS(a)|0)==65536){l=f[a+4>>2]|0;f[h>>2]=f[l>>2];m=h+4|0;o=l+4|0;f[m>>2]=f[o>>2];p=h+8|0;f[p>>2]=f[l+8>>2];f[h+12>>2]=f[l+12>>2];f[h+16>>2]=f[l+16>>2];f[h+20>>2]=f[l+20>>2];f[h+24>>2]=f[l+24>>2];f[h+28>>2]=f[l+28>>2];f[h+32>>2]=f[l+32>>2];q=f[l+36>>2]|0;f[h+36>>2]=q;f[h+40>>2]=p;p=h+48|0;r=h+44|0;f[r>>2]=p;f[p>>2]=0;f[h+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[l+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[m>>2]=0;BR(h,l);break}}else OR(h,a,-1);while(0);a=LS(h,2,-1,1)|0;l=f[h>>2]&7;n[i>>2]=0.0;m=i+4|0;n[m>>2]=0.0;n[j>>2]=0.0;if(!((a|0)>-1&(l|1|0)==5)){f[k>>2]=0;f[k+4>>2]=0;o=c$(k,40)|0;p=326717;r=o+40|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(r|0));j$(-215,k,326758,326777,215);d$(k)}p=c+4|0;n[p>>2]=0.0;n[c>>2]=0.0;n[d>>2]=0.0;do if(a|0){o=(l|0)==5;r=f[h+16>>2]|0;if((a|0)<4){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;if((a|0)>0)if(o){q=0;do{s=f[r+(q<<3)+4>>2]|0;f[k+(q<<3)>>2]=f[r+(q<<3)>>2];f[k+(q<<3)+4>>2]=s;q=q+1|0}while((q|0)!=(a|0))}else{q=0;do{t=+(f[r+(q<<3)+4>>2]|0);n[k+(q<<3)>>2]=+(f[r+(q<<3)>>2]|0);n[k+(q<<3)+4>>2]=t;q=q+1|0}while((q|0)!=(a|0))}lna(k,a,i,j);f[c>>2]=f[i>>2];f[p>>2]=f[m>>2];f[d>>2]=f[j>>2];break}a:do if(o){t=+n[r+8>>2];v=(+n[r>>2]+t)*.5;n[i>>2]=v;q=r+4|0;w=+n[r+12>>2];x=(+n[q>>2]+w)*.5;n[m>>2]=x;y=+n[r>>2]-t;t=+n[q>>2]-w;w=+M(+(y*y+t*t))*.5+9.999999747378752e-05;n[j>>2]=w;t=v;v=x;x=w;q=2;while(1){w=+n[r+(q<<3)>>2]-t;y=+n[r+(q<<3)+4>>2]-v;if(!(+M(+(w*w+y*y))<x))mna(r,q,i,j);s=q+1|0;if((s|0)==(a|0))break a;t=+n[i>>2];v=+n[m>>2];x=+n[j>>2];q=s}}else{q=f[r>>2]|0;s=f[r+8>>2]|0;x=+(s+q|0)*.5;n[i>>2]=x;z=f[r+4>>2]|0;A=f[r+12>>2]|0;v=+(A+z|0)*.5;n[m>>2]=v;t=+(q-s|0);y=+(z-A|0);w=+M(+(t*t+y*y))*.5+9.999999747378752e-05;n[j>>2]=w;y=x;x=v;v=w;A=2;while(1){w=+(f[r+(A<<3)>>2]|0)-y;t=+(f[r+(A<<3)+4>>2]|0)-x;if(!(+M(+(w*w+t*t))<v))nna(r,A,i,j);z=A+1|0;if((z|0)==(a|0))break a;y=+n[i>>2];x=+n[m>>2];v=+n[j>>2];A=z}}while(0);f[c>>2]=f[i>>2];f[p>>2]=f[m>>2];f[d>>2]=f[j>>2]}while(0);j=h+36|0;d=f[j>>2]|0;if(d|0?(m=d+12|0,d=f[m>>2]|0,f[m>>2]=d+-1,(d|0)==1):0)CR(h);f[j>>2]=0;j=h+16|0;d=h+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[d>>2]|0)>0){j=f[h+40>>2]|0;m=0;do{f[j+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[d>>2]|0))}d=f[h+44>>2]|0;if((d|0)!=(h+48|0))ZF(d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function lna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,g=0.0,h=0,i=0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0;switch(b|0){case 1:{f[c>>2]=f[a>>2];f[c+4>>2]=f[a+4>>2];n[d>>2]=0.0;e=+n[d>>2];g=e+9.999999747378752e-05;n[d>>2]=g;return}case 2:{b=a+8|0;n[c>>2]=(+n[a>>2]+ +n[b>>2])*.5;h=a+4|0;i=a+12|0;n[c+4>>2]=(+n[h>>2]+ +n[i>>2])*.5;j=+n[a>>2]-+n[b>>2];k=+n[h>>2]-+n[i>>2];l=+M(+(j*j+k*k))*.5;n[d>>2]=l;e=+n[d>>2];g=e+9.999999747378752e-05;n[d>>2]=g;return}case 3:{l=+n[a+8>>2];k=+n[a+12>>2];j=+n[a>>2];i=a+4|0;m=+n[i>>2];o=l-j;p=k-m;q=+n[a+16>>2];r=+n[a+20>>2];s=q-j;t=r-m;u=o*t-p*s;if(u==0.0){v=j-l;w=m-k;x=+M(+(v*v+w*w));w=j-q;v=m-r;y=+M(+(w*w+v*v));v=l-q;w=k-r;z=+M(+(v*v+w*w));do if(!(x>=y)|!(x>=z)){if(!(!(y>=x)|!(y>=z))){A=j+q;B=m+r;C=y;break}if(!(z>=x)|!(z>=y)){e=+n[d>>2];g=e+9.999999747378752e-05;n[d>>2]=g;return}else{A=l+q;B=k+r;C=z;break}}else{A=l+j;B=k+m;C=x}while(0);n[c>>2]=A*.5;n[c+4>>2]=B*.5;D=C*.5}else{C=o*((l+j)*.5)+p*((k+m)*.5);k=s*((j+q)*.5)+t*((m+r)*.5);r=(t*C-p*k)/u;p=(o*k-s*C)/u;n[c>>2]=r;n[c+4>>2]=p;u=r-+n[a>>2];r=p-+n[i>>2];D=+M(+(u*u+r*r))}n[d>>2]=D;e=+n[d>>2];g=e+9.999999747378752e-05;n[d>>2]=g;return}default:{e=+n[d>>2];g=e+9.999999747378752e-05;n[d>>2]=g;return}}}function mna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0;e=u;u=u+32|0;g=e;h=a+(b<<3)|0;n[c>>2]=(+n[a>>2]+ +n[h>>2])*.5;i=a+4|0;j=a+(b<<3)+4|0;k=c+4|0;n[k>>2]=(+n[i>>2]+ +n[j>>2])*.5;l=+n[a>>2]-+n[h>>2];m=+n[i>>2]-+n[j>>2];o=+M(+(l*l+m*m))*.5+9.999999747378752e-05;n[d>>2]=o;if((b|0)<=1){u=e;return}i=a+(b<<3)|0;h=g+4|0;p=g+8|0;q=g+12|0;r=g+20|0;s=g+16|0;m=o;t=1;while(1){o=+n[a+(t<<3)>>2];v=a+(t<<3)+4|0;l=+n[v>>2];w=+n[c>>2]-o;x=+n[k>>2]-l;a:do if(!(+M(+(w*w+x*x))<m)){y=a+(t<<3)|0;n[c>>2]=(o+ +n[i>>2])*.5;n[k>>2]=(l+ +n[j>>2])*.5;z=+n[y>>2]-+n[i>>2];A=+n[v>>2]-+n[j>>2];B=+M(+(z*z+A*A))*.5+9.999999747378752e-05;n[d>>2]=B;A=B;C=0;while(1){B=+n[a+(C<<3)>>2];z=+n[a+(C<<3)+4>>2];D=+n[c>>2]-B;E=+n[k>>2]-z;if(!(+M(+(D*D+E*E))<A)){F=f[j>>2]|0;f[g>>2]=f[i>>2];f[h>>2]=F;F=f[v>>2]|0;f[p>>2]=f[y>>2];f[q>>2]=F;n[s>>2]=B;n[r>>2]=z;lna(g,3,c,d)}F=C+1|0;if((F|0)==(t|0))break a;A=+n[d>>2];C=F}}while(0);v=t+1|0;if((v|0)==(b|0))break;m=+n[d>>2];t=v}u=e;return}function nna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0;e=u;u=u+32|0;g=e;h=f[a>>2]|0;i=a+(b<<3)|0;j=f[i>>2]|0;n[c>>2]=+(j+h|0)*.5;k=f[a+4>>2]|0;l=a+(b<<3)+4|0;m=f[l>>2]|0;o=c+4|0;n[o>>2]=+(m+k|0)*.5;p=+(h-j|0);q=+(k-m|0);r=+M(+(p*p+q*q))*.5+9.999999747378752e-05;n[d>>2]=r;if((b|0)<=1){u=e;return}m=g+4|0;k=g+8|0;j=g+12|0;h=g+16|0;s=g+20|0;q=r;t=1;while(1){v=a+(t<<3)|0;w=f[v>>2]|0;x=a+(t<<3)+4|0;y=f[x>>2]|0;r=+n[c>>2]-+(w|0);p=+n[o>>2]-+(y|0);a:do if(!(+M(+(r*r+p*p))<q)){z=f[i>>2]|0;n[c>>2]=+(z+w|0)*.5;A=f[l>>2]|0;n[o>>2]=+(A+y|0)*.5;B=+(w-z|0);C=+(y-A|0);D=+M(+(B*B+C*C))*.5+9.999999747378752e-05;n[d>>2]=D;C=D;A=0;while(1){D=+(f[a+(A<<3)>>2]|0);B=+(f[a+(A<<3)+4>>2]|0);E=+n[c>>2]-D;F=+n[o>>2]-B;if(!(+M(+(E*E+F*F))<C)){F=+(f[l>>2]|0);n[g>>2]=+(f[i>>2]|0);n[m>>2]=F;F=+(f[x>>2]|0);n[k>>2]=+(f[v>>2]|0);n[j>>2]=F;n[h>>2]=D;n[s>>2]=B;lna(g,3,c,d)}z=A+1|0;if((z|0)==(t|0))break a;C=+n[d>>2];A=z}}while(0);v=t+1|0;if((v|0)==(b|0))break;q=+n[d>>2];t=v}u=e;return}function ona(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0.0,t=0.0,v=0.0,w=0.0,x=0.0;d=u;u=u+80|0;e=d+64|0;g=d+8|0;h=d;_$(e,75204);do if((NS(a)|0)==65536){i=f[a+4>>2]|0;f[g>>2]=f[i>>2];j=g+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=g+8|0;f[l>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];f[g+16>>2]=f[i+16>>2];f[g+20>>2]=f[i+20>>2];f[g+24>>2]=f[i+24>>2];f[g+28>>2]=f[i+28>>2];f[g+32>>2]=f[i+32>>2];m=f[i+36>>2]|0;f[g+36>>2]=m;f[g+40>>2]=l;l=g+48|0;o=g+44|0;f[o>>2]=l;f[l>>2]=0;f[g+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];break}else{f[j>>2]=0;BR(g,i);break}}else OR(g,a,-1);while(0);a=LS(g,2,-1,1)|0;i=f[g>>2]&7;if(!((a|0)>-1&(i|1|0)==5)){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,40)|0;k=326717;l=j+40|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,h,326892,326777,284);d$(h)}if((a|0)>=2){h=c?a+-1|0:0;c=f[g+16>>2]|0;if((i|0)==5){i=0;p=0.0;k=f[c+(h<<3)>>2]|0;j=f[c+(h<<3)+4>>2]|0;while(1){l=k;k=f[c+(i<<3)>>2]|0;q=(f[s>>2]=k,+n[s>>2]);o=j;j=f[c+(i<<3)+4>>2]|0;r=(f[s>>2]=j,+n[s>>2]);t=q-(f[s>>2]=l,+n[s>>2]);q=r-(f[s>>2]=o,+n[s>>2]);r=p+ +M(+(q*q+t*t));i=i+1|0;if((i|0)==(a|0)){v=r;break}else p=r}}else{p=+(f[c+(h<<3)>>2]|0);r=+(f[c+(h<<3)+4>>2]|0);h=0;t=0.0;while(1){q=p;p=+(f[c+(h<<3)>>2]|0);w=r;r=+(f[c+(h<<3)+4>>2]|0);x=p-q;q=r-w;w=t+ +M(+(q*q+x*x));h=h+1|0;if((h|0)==(a|0)){v=w;break}else t=w}}}else v=0.0;a=g+36|0;h=f[a>>2]|0;if(h|0?(c=h+12|0,h=f[c>>2]|0,f[c>>2]=h+-1,(h|0)==1):0)CR(g);f[a>>2]=0;a=g+16|0;h=g+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[h>>2]|0)>0){a=f[g+40>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)!=(g+48|0))ZF(h);if(!(f[e+4>>2]|0)){u=d;return +v}u=d;return +v}function pna(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0;d=u;u=u+80|0;e=d+64|0;g=d+8|0;h=d;_$(e,75224);do if((NS(a)|0)==65536){i=f[a+4>>2]|0;f[g>>2]=f[i>>2];j=g+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=g+8|0;f[l>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];f[g+16>>2]=f[i+16>>2];f[g+20>>2]=f[i+20>>2];f[g+24>>2]=f[i+24>>2];f[g+28>>2]=f[i+28>>2];f[g+32>>2]=f[i+32>>2];m=f[i+36>>2]|0;f[g+36>>2]=m;f[g+40>>2]=l;l=g+48|0;o=g+44|0;f[o>>2]=l;f[l>>2]=0;f[g+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];break}else{f[j>>2]=0;BR(g,i);break}}else OR(g,a,-1);while(0);a=LS(g,2,-1,1)|0;i=f[g>>2]&7;if(!((a|0)>-1&(i|1|0)==5)){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,42)|0;k=326941;l=j+42|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,h,326984,326777,319);d$(h)}if(a){h=(i|0)==5;i=f[g+16>>2]|0;k=a+-1|0;if(h){j=f[i+(k<<3)+4>>2]|0;p=+n[i+(k<<3)>>2];q=(f[s>>2]=j,+n[s>>2]);r=j}else{t=+(f[i+(k<<3)+4>>2]|0);p=+(f[i+(k<<3)>>2]|0);q=t;r=(n[s>>2]=t,f[s>>2]|0)}if((a|0)>0)if(h){t=p;v=0.0;h=0;k=r;while(1){w=t;t=+n[i+(h<<3)>>2];r=k;k=f[i+(h<<3)+4>>2]|0;x=w*(f[s>>2]=k,+n[s>>2]);w=v+(x-(f[s>>2]=r,+n[s>>2])*t);h=h+1|0;if((h|0)==(a|0)){y=w;break}else v=w}}else{v=p;p=q;q=0.0;h=0;while(1){t=v;v=+(f[i+(h<<3)>>2]|0);w=p;p=+(f[i+(h<<3)+4>>2]|0);x=q+(t*p-w*v);h=h+1|0;if((h|0)==(a|0)){y=x;break}else q=x}}else y=0.0;q=y*.5;if(c)z=q;else z=+L(+q)}else z=0.0;c=g+36|0;a=f[c>>2]|0;if(a|0?(h=a+12|0,a=f[h>>2]|0,f[h>>2]=a+-1,(a|0)==1):0)CR(g);f[c>>2]=0;c=g+16|0;a=g+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[g+40>>2]|0;h=0;do{f[c+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[a>>2]|0))}a=f[g+44>>2]|0;if((a|0)!=(g+48|0))ZF(a);if(!(f[e+4>>2]|0)){u=d;return +z}u=d;return +z}function qna(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,O=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0.0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0,ta=0.0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0;d=u;u=u+2592|0;e=d+2584|0;g=d+2528|0;h=d+2232|0;i=d+2192|0;j=d+1096|0;k=d;l=d+2472|0;m=d+2416|0;o=d+2360|0;q=d+2304|0;r=d+2288|0;s=d+2272|0;_$(e,75244);do if((NS(c)|0)==65536){t=f[c+4>>2]|0;f[g>>2]=f[t>>2];v=g+4|0;w=t+4|0;f[v>>2]=f[w>>2];x=g+8|0;f[x>>2]=f[t+8>>2];f[g+12>>2]=f[t+12>>2];f[g+16>>2]=f[t+16>>2];f[g+20>>2]=f[t+20>>2];f[g+24>>2]=f[t+24>>2];f[g+28>>2]=f[t+28>>2];f[g+32>>2]=f[t+32>>2];y=f[t+36>>2]|0;f[g+36>>2]=y;f[g+40>>2]=x;x=g+48|0;z=g+44|0;f[z>>2]=x;f[x>>2]=0;f[g+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;x=f[z>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[v>>2]=0;BR(g,t);break}}else OR(g,c,-1);while(0);c=LS(g,2,-1,1)|0;t=f[g>>2]&7;if(!((c|0)>-1&(t|1|0)==5)){f[h>>2]=0;f[h+4>>2]=0;A=c$(h,36)|0;B=327037;C=A+36|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));j$(-215,h,327074,326777,352);d$(h)};f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;if((c|0)<5){f[h>>2]=0;f[h+4>>2]=0;A=c$(h,52)|0;B=327085;C=A+52|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));j$(-201,h,327074,326777,357);d$(h)}A=h;C=A+40|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));A=i;C=A+40|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));A=(t|0)==5;t=g+16|0;C=f[t>>2]|0;B=g+44|0;v=c*5|0;w=j+8|0;f[j>>2]=w;x=j+4|0;f[x>>2]=v;if(v>>>0>136){z=OYa(v>>>0>536870911?-1:v<<3)|0;f[j>>2]=z;D=z}else D=w;z=k+8|0;f[k>>2]=z;v=k+4|0;f[v>>2]=c;if(c>>>0>136){y=OYa(c>>>0>536870911?-1:c<<3)|0;f[k>>2]=y;E=y}else E=z;y=l+4|0;f[y>>2]=2;F=l+8|0;f[F>>2]=c;G=l+12|0;f[G>>2]=5;H=l+16|0;f[H>>2]=D;I=l+20|0;f[I>>2]=D;J=l+24|0;K=l+28|0;N=l+40|0;O=J+8|0;f[O>>2]=0;f[O+4>>2]=0;f[N>>2]=F;O=l+48|0;Q=l+44|0;f[Q>>2]=O;f[l>>2]=1124024326;f[O>>2]=40;f[l+52>>2]=8;R=D+((f[F>>2]|0)*5<<3)|0;f[K>>2]=R;f[J>>2]=R+-40+40;R=m+4|0;f[R>>2]=2;S=m+8|0;f[S>>2]=c;T=m+12|0;f[T>>2]=1;V=m+16|0;f[V>>2]=E;W=m+20|0;f[W>>2]=E;X=m+24|0;Y=m+28|0;Z=m+40|0;_=X+8|0;f[_>>2]=0;f[_+4>>2]=0;f[Z>>2]=S;_=m+48|0;$=m+44|0;f[$>>2]=_;f[m>>2]=1124024326;f[_>>2]=8;f[m+52>>2]=8;aa=E+(f[S>>2]<<3)|0;f[Y>>2]=aa;f[X>>2]=aa+-8+8;aa=o+4|0;f[aa>>2]=2;ba=o+8|0;f[ba>>2]=5;ca=o+12|0;f[ca>>2]=1;da=o+16|0;f[da>>2]=h;ea=o+20|0;f[ea>>2]=h;fa=o+24|0;ga=o+28|0;ha=o+40|0;ia=fa+8|0;f[ia>>2]=0;f[ia+4>>2]=0;f[ha>>2]=ba;ia=o+48|0;ja=o+44|0;f[ja>>2]=ia;f[o>>2]=1124024326;f[ia>>2]=8;f[o+52>>2]=8;f[ga>>2]=h+40;f[fa>>2]=h+40;ka=(c|0)>0;if(ka){if(A){la=0.0;ma=0.0;na=0;while(1){oa=la+ +n[C+(na<<3)>>2];pa=ma+ +n[C+(na<<3)+4>>2];na=na+1|0;if((na|0)==(c|0)){qa=oa;ra=pa;break}else{la=oa;ma=pa}}}else{ma=0.0;la=0.0;na=0;while(1){pa=ma+ +(f[C+(na<<3)>>2]|0);oa=la+ +(f[C+(na<<3)+4>>2]|0);na=na+1|0;if((na|0)==(c|0)){qa=pa;ra=oa;break}else{ma=pa;la=oa}}}la=+(c|0);ma=qa/la;qa=ra/la;if(ka)if(A){na=0;do{la=+n[C+(na<<3)>>2]-ma;ra=+n[C+(na<<3)+4>>2]-qa;p[E+(na<<3)>>3]=1.0e4;oa=la;sa=na*5|0;p[D+(sa<<3)>>3]=-(oa*oa);la=ra;p[D+(sa+1<<3)>>3]=-(la*la);p[D+(sa+2<<3)>>3]=-(la*oa);p[D+(sa+3<<3)>>3]=oa;p[D+(sa+4<<3)>>3]=la;na=na+1|0}while((na|0)!=(c|0));ta=ma;ua=qa}else{na=0;do{la=+(f[C+(na<<3)>>2]|0)-ma;oa=+(f[C+(na<<3)+4>>2]|0)-qa;p[E+(na<<3)>>3]=1.0e4;ra=la;sa=na*5|0;p[D+(sa<<3)>>3]=-(ra*ra);la=oa;p[D+(sa+1<<3)>>3]=-(la*la);p[D+(sa+2<<3)>>3]=-(la*ra);p[D+(sa+3<<3)>>3]=ra;p[D+(sa+4<<3)>>3]=la;na=na+1|0}while((na|0)!=(c|0));ta=ma;ua=qa}else{ta=ma;ua=qa}}else{qa=+(c|0);ta=0.0/qa;ua=0.0/qa}f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=l;f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=m;na=s+8|0;f[na>>2]=0;f[na+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=o;hN(q,r,s,1)|0;na=q+4|0;f[na>>2]=2;sa=q+8|0;f[sa>>2]=2;va=q+12|0;f[va>>2]=2;wa=q+16|0;f[wa>>2]=D;xa=q+20|0;f[xa>>2]=D;ya=q+24|0;za=q+28|0;Aa=q+40|0;Ba=ya+8|0;f[Ba>>2]=0;f[Ba+4>>2]=0;f[Aa>>2]=sa;Ba=q+48|0;Ca=q+44|0;f[Ca>>2]=Ba;Da=q+36|0;f[q>>2]=1124024326;f[Ba>>2]=16;f[q+52>>2]=8;Ea=D+(f[sa>>2]<<1<<3)|0;f[za>>2]=Ea;f[ya>>2]=Ea+-16+16;Ea=l+36|0;Fa=f[Ea>>2]|0;if(Fa|0?(Ga=Fa+12|0,Fa=f[Ga>>2]|0,f[Ga>>2]=Fa+-1,(Fa|0)==1):0)CR(l);f[Ea>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[y>>2]|0)>0){Fa=f[N>>2]|0;Ga=0;do{f[Fa+(Ga<<2)>>2]=0;Ga=Ga+1|0;Ha=f[y>>2]|0}while((Ga|0)<(Ha|0));f[l>>2]=f[q>>2];if((Ha|0)<3)Ia=33;else Ia=35}else{f[l>>2]=f[q>>2];Ia=33}if((Ia|0)==33){Ha=f[na>>2]|0;if((Ha|0)<3){f[y>>2]=Ha;f[F>>2]=f[sa>>2];f[G>>2]=f[va>>2];va=f[Ca>>2]|0;sa=f[Q>>2]|0;f[sa>>2]=f[va>>2];f[sa+4>>2]=f[va+4>>2]}else Ia=35}if((Ia|0)==35)BR(l,q);f[H>>2]=f[wa>>2];f[I>>2]=f[xa>>2];f[J>>2]=f[ya>>2];f[K>>2]=f[za>>2];za=l+32|0;f[za>>2]=f[q+32>>2];ya=f[Da>>2]|0;f[Ea>>2]=ya;if(ya|0?(xa=ya+12|0,ya=f[xa>>2]|0,f[xa>>2]=ya+-1,(ya|0)==1):0)CR(q);f[Da>>2]=0;f[wa>>2]=0;f[wa+4>>2]=0;f[wa+8>>2]=0;f[wa+12>>2]=0;if((f[na>>2]|0)>0){wa=f[Aa>>2]|0;Aa=0;do{f[wa+(Aa<<2)>>2]=0;Aa=Aa+1|0}while((Aa|0)<(f[na>>2]|0))}na=f[Ca>>2]|0;if((na|0)!=(Ba|0))ZF(na);na=q+4|0;f[na>>2]=2;Ba=q+8|0;f[Ba>>2]=2;Ca=q+12|0;f[Ca>>2]=1;Aa=q+16|0;f[Aa>>2]=E;wa=q+20|0;f[wa>>2]=E;Da=q+24|0;ya=q+28|0;xa=q+40|0;va=Da+8|0;f[va>>2]=0;f[va+4>>2]=0;f[xa>>2]=Ba;va=q+48|0;sa=q+44|0;f[sa>>2]=va;Ha=q+36|0;f[q>>2]=1124024326;f[va>>2]=8;f[q+52>>2]=8;Ga=E+(f[Ba>>2]<<3)|0;f[ya>>2]=Ga;f[Da>>2]=Ga+-8+8;Ga=m+36|0;Fa=f[Ga>>2]|0;if(Fa|0?(Ja=Fa+12|0,Fa=f[Ja>>2]|0,f[Ja>>2]=Fa+-1,(Fa|0)==1):0)CR(m);f[Ga>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[R>>2]|0)>0){Fa=f[Z>>2]|0;Ja=0;do{f[Fa+(Ja<<2)>>2]=0;Ja=Ja+1|0;Ka=f[R>>2]|0}while((Ja|0)<(Ka|0));f[m>>2]=f[q>>2];if((Ka|0)<3)Ia=52;else Ia=54}else{f[m>>2]=f[q>>2];Ia=52}if((Ia|0)==52){Ka=f[na>>2]|0;if((Ka|0)<3){f[R>>2]=Ka;f[S>>2]=f[Ba>>2];f[T>>2]=f[Ca>>2];Ca=f[sa>>2]|0;Ba=f[$>>2]|0;f[Ba>>2]=f[Ca>>2];f[Ba+4>>2]=f[Ca+4>>2]}else Ia=54}if((Ia|0)==54)BR(m,q);f[V>>2]=f[Aa>>2];f[W>>2]=f[wa>>2];f[X>>2]=f[Da>>2];f[Y>>2]=f[ya>>2];ya=m+32|0;f[ya>>2]=f[q+32>>2];Da=f[Ha>>2]|0;f[Ga>>2]=Da;if(Da|0?(wa=Da+12|0,Da=f[wa>>2]|0,f[wa>>2]=Da+-1,(Da|0)==1):0)CR(q);f[Ha>>2]=0;f[Aa>>2]=0;f[Aa+4>>2]=0;f[Aa+8>>2]=0;f[Aa+12>>2]=0;if((f[na>>2]|0)>0){Aa=f[xa>>2]|0;xa=0;do{f[Aa+(xa<<2)>>2]=0;xa=xa+1|0}while((xa|0)<(f[na>>2]|0))}na=f[sa>>2]|0;if((na|0)!=(va|0))ZF(na);na=q+4|0;f[na>>2]=2;va=q+8|0;f[va>>2]=2;sa=q+12|0;f[sa>>2]=1;xa=q+16|0;f[xa>>2]=i;Aa=q+20|0;f[Aa>>2]=i;Ha=q+24|0;Da=q+28|0;wa=q+40|0;Ca=Ha+8|0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[wa>>2]=va;Ca=q+48|0;Ba=q+44|0;f[Ba>>2]=Ca;f[q>>2]=1124024326;f[Ca>>2]=8;f[q+52>>2]=8;f[Da>>2]=i+16;f[Ha>>2]=i+16;Ka=q+36|0;Ja=o+36|0;Fa=f[Ja>>2]|0;if(Fa|0?(La=Fa+12|0,Fa=f[La>>2]|0,f[La>>2]=Fa+-1,(Fa|0)==1):0)CR(o);f[Ja>>2]=0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[aa>>2]|0)>0){Fa=f[ha>>2]|0;La=0;do{f[Fa+(La<<2)>>2]=0;La=La+1|0;Ma=f[aa>>2]|0}while((La|0)<(Ma|0));f[o>>2]=f[q>>2];if((Ma|0)<3)Ia=71;else Ia=73}else{f[o>>2]=f[q>>2];Ia=71}if((Ia|0)==71){Ma=f[na>>2]|0;if((Ma|0)<3){f[aa>>2]=Ma;f[ba>>2]=f[va>>2];f[ca>>2]=f[sa>>2];sa=f[Ba>>2]|0;va=f[ja>>2]|0;f[va>>2]=f[sa>>2];f[va+4>>2]=f[sa+4>>2]}else Ia=73}if((Ia|0)==73)BR(o,q);f[da>>2]=f[xa>>2];f[ea>>2]=f[Aa>>2];f[fa>>2]=f[Ha>>2];f[ga>>2]=f[Da>>2];Da=o+32|0;f[Da>>2]=f[q+32>>2];Ha=f[Ka>>2]|0;f[Ja>>2]=Ha;do if(Ha|0){Aa=Ha+12|0;sa=f[Aa>>2]|0;f[Aa>>2]=sa+-1;if((sa|0)!=1)break;CR(q)}while(0);f[Ka>>2]=0;f[xa>>2]=0;f[xa+4>>2]=0;f[xa+8>>2]=0;f[xa+12>>2]=0;if((f[na>>2]|0)>0){xa=f[wa>>2]|0;wa=0;do{f[xa+(wa<<2)>>2]=0;wa=wa+1|0}while((wa|0)<(f[na>>2]|0))}na=f[Ba>>2]|0;if((na|0)!=(Ca|0))ZF(na);p[D>>3]=+p[h>>3]*2.0;na=h+16|0;qa=+p[na>>3];p[D+16>>3]=qa;p[D+8>>3]=qa;Ca=h+8|0;p[D+24>>3]=+p[Ca>>3]*2.0;p[E>>3]=+p[h+24>>3];p[E+8>>3]=+p[h+32>>3];f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=l;f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=m;Ba=s+8|0;f[Ba>>2]=0;f[Ba+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=o;hN(q,r,s,1)|0;Ba=q+4|0;f[Ba>>2]=2;wa=q+8|0;f[wa>>2]=c;xa=q+12|0;f[xa>>2]=3;Ka=q+16|0;f[Ka>>2]=D;Ha=q+20|0;f[Ha>>2]=D;sa=q+24|0;Aa=q+28|0;va=q+40|0;Ma=sa+8|0;f[Ma>>2]=0;f[Ma+4>>2]=0;f[va>>2]=wa;Ma=q+48|0;La=q+44|0;f[La>>2]=Ma;Fa=q+36|0;f[q>>2]=1124024326;f[Ma>>2]=24;f[q+52>>2]=8;Na=D+((f[wa>>2]|0)*3<<3)|0;f[Aa>>2]=Na;f[sa>>2]=Na+-24+24;Na=f[Ea>>2]|0;do if(Na|0){Oa=Na+12|0;Pa=f[Oa>>2]|0;f[Oa>>2]=Pa+-1;if((Pa|0)!=1)break;CR(l)}while(0);f[Ea>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[y>>2]|0)>0){Na=f[N>>2]|0;Pa=0;do{f[Na+(Pa<<2)>>2]=0;Pa=Pa+1|0;Qa=f[y>>2]|0}while((Pa|0)<(Qa|0));f[l>>2]=f[q>>2];if((Qa|0)<3)Ia=90;else Ia=92}else{f[l>>2]=f[q>>2];Ia=90}do if((Ia|0)==90){Qa=f[Ba>>2]|0;if((Qa|0)>=3){Ia=92;break}f[y>>2]=Qa;f[F>>2]=f[wa>>2];f[G>>2]=f[xa>>2];Qa=f[La>>2]|0;Pa=f[Q>>2]|0;f[Pa>>2]=f[Qa>>2];f[Pa+4>>2]=f[Qa+4>>2]}while(0);if((Ia|0)==92)BR(l,q);f[H>>2]=f[Ka>>2];f[I>>2]=f[Ha>>2];f[J>>2]=f[sa>>2];f[K>>2]=f[Aa>>2];f[za>>2]=f[q+32>>2];za=f[Fa>>2]|0;f[Ea>>2]=za;do if(za|0){Aa=za+12|0;K=f[Aa>>2]|0;f[Aa>>2]=K+-1;if((K|0)!=1)break;CR(q)}while(0);f[Fa>>2]=0;f[Ka>>2]=0;f[Ka+4>>2]=0;f[Ka+8>>2]=0;f[Ka+12>>2]=0;if((f[Ba>>2]|0)>0){Ka=f[va>>2]|0;va=0;do{f[Ka+(va<<2)>>2]=0;va=va+1|0}while((va|0)<(f[Ba>>2]|0))}Ba=f[La>>2]|0;if((Ba|0)!=(Ma|0))ZF(Ba);Ba=q+4|0;f[Ba>>2]=2;Ma=q+8|0;f[Ma>>2]=c;La=q+12|0;f[La>>2]=1;va=q+16|0;f[va>>2]=E;Ka=q+20|0;f[Ka>>2]=E;Fa=q+24|0;za=q+28|0;K=q+40|0;Aa=Fa+8|0;f[Aa>>2]=0;f[Aa+4>>2]=0;f[K>>2]=Ma;Aa=q+48|0;sa=q+44|0;f[sa>>2]=Aa;J=q+36|0;f[q>>2]=1124024326;f[Aa>>2]=8;f[q+52>>2]=8;Ha=E+(f[Ma>>2]<<3)|0;f[za>>2]=Ha;f[Fa>>2]=Ha+-8+8;Ha=f[Ga>>2]|0;do if(Ha|0){I=Ha+12|0;xa=f[I>>2]|0;f[I>>2]=xa+-1;if((xa|0)!=1)break;CR(m)}while(0);f[Ga>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[R>>2]|0)>0){Ha=f[Z>>2]|0;xa=0;do{f[Ha+(xa<<2)>>2]=0;xa=xa+1|0;Ra=f[R>>2]|0}while((xa|0)<(Ra|0));f[m>>2]=f[q>>2];if((Ra|0)<3)Ia=109;else Ia=111}else{f[m>>2]=f[q>>2];Ia=109}do if((Ia|0)==109){Ra=f[Ba>>2]|0;if((Ra|0)>=3){Ia=111;break}f[R>>2]=Ra;f[S>>2]=f[Ma>>2];f[T>>2]=f[La>>2];Ra=f[sa>>2]|0;xa=f[$>>2]|0;f[xa>>2]=f[Ra>>2];f[xa+4>>2]=f[Ra+4>>2]}while(0);if((Ia|0)==111)BR(m,q);f[V>>2]=f[va>>2];f[W>>2]=f[Ka>>2];f[X>>2]=f[Fa>>2];f[Y>>2]=f[za>>2];f[ya>>2]=f[q+32>>2];ya=f[J>>2]|0;f[Ga>>2]=ya;do if(ya|0){za=ya+12|0;Y=f[za>>2]|0;f[za>>2]=Y+-1;if((Y|0)!=1)break;CR(q)}while(0);f[J>>2]=0;f[va>>2]=0;f[va+4>>2]=0;f[va+8>>2]=0;f[va+12>>2]=0;if((f[Ba>>2]|0)>0){va=f[K>>2]|0;K=0;do{f[va+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[Ba>>2]|0))}Ba=f[sa>>2]|0;if((Ba|0)!=(Aa|0))ZF(Ba);Ba=q+4|0;f[Ba>>2]=2;Aa=q+8|0;f[Aa>>2]=3;sa=q+12|0;f[sa>>2]=1;K=q+16|0;f[K>>2]=h;va=q+20|0;f[va>>2]=h;J=q+24|0;ya=q+28|0;Y=q+40|0;za=J+8|0;f[za>>2]=0;f[za+4>>2]=0;f[Y>>2]=Aa;za=q+48|0;Fa=q+44|0;f[Fa>>2]=za;f[q>>2]=1124024326;f[za>>2]=8;f[q+52>>2]=8;f[ya>>2]=h+24;f[J>>2]=h+24;X=q+36|0;Ka=f[Ja>>2]|0;do if(Ka|0){W=Ka+12|0;La=f[W>>2]|0;f[W>>2]=La+-1;if((La|0)!=1)break;CR(o)}while(0);f[Ja>>2]=0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[aa>>2]|0)>0){Ka=f[ha>>2]|0;La=0;do{f[Ka+(La<<2)>>2]=0;La=La+1|0;Sa=f[aa>>2]|0}while((La|0)<(Sa|0));f[o>>2]=f[q>>2];if((Sa|0)<3)Ia=128;else Ia=130}else{f[o>>2]=f[q>>2];Ia=128}do if((Ia|0)==128){Sa=f[Ba>>2]|0;if((Sa|0)>=3){Ia=130;break}f[aa>>2]=Sa;f[ba>>2]=f[Aa>>2];f[ca>>2]=f[sa>>2];Sa=f[Fa>>2]|0;La=f[ja>>2]|0;f[La>>2]=f[Sa>>2];f[La+4>>2]=f[Sa+4>>2]}while(0);if((Ia|0)==130)BR(o,q);f[da>>2]=f[K>>2];f[ea>>2]=f[va>>2];f[fa>>2]=f[J>>2];f[ga>>2]=f[ya>>2];f[Da>>2]=f[q+32>>2];Da=f[X>>2]|0;f[Ja>>2]=Da;do if(Da|0){ya=Da+12|0;ga=f[ya>>2]|0;f[ya>>2]=ga+-1;if((ga|0)!=1)break;CR(q)}while(0);f[X>>2]=0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[Ba>>2]|0)>0){K=f[Y>>2]|0;Y=0;do{f[K+(Y<<2)>>2]=0;Y=Y+1|0}while((Y|0)<(f[Ba>>2]|0))}Ba=f[Fa>>2]|0;if((Ba|0)!=(za|0))ZF(Ba);if(ka){qa=+p[i>>3];ma=+p[i+8>>3];if(A){A=0;do{la=+n[C+(A<<3)>>2]-ta;ra=+n[C+(A<<3)+4>>2]-ua;p[E+(A<<3)>>3]=1.0;oa=la;la=oa-qa;ka=A*3|0;p[D+(ka<<3)>>3]=la*la;la=ra;ra=la-ma;p[D+(ka+1<<3)>>3]=ra*ra;p[D+(ka+2<<3)>>3]=(oa-qa)*(la-ma);A=A+1|0}while((A|0)!=(c|0))}else{A=0;do{la=+(f[C+(A<<3)>>2]|0)-ta;oa=+(f[C+(A<<3)+4>>2]|0)-ua;p[E+(A<<3)>>3]=1.0;ra=la;la=ra-qa;ka=A*3|0;p[D+(ka<<3)>>3]=la*la;la=oa;oa=la-ma;p[D+(ka+1<<3)>>3]=oa*oa;p[D+(ka+2<<3)>>3]=(ra-qa)*(la-ma);A=A+1|0}while((A|0)!=(c|0))}}f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=l;f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=m;c=s+8|0;f[c>>2]=0;f[c+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=o;hN(q,r,s,1)|0;ma=+p[na>>3];qa=+p[Ca>>3];la=+p[h>>3];ra=qa-la;oa=+U(+ma,+ra)*-.5;p[i+32>>3]=oa;if(+L(+ma)>1.0e-08)Ta=ma/+P(+(oa*-2.0));else Ta=ra;ra=la+qa;qa=+L(+(ra-Ta));if(qa>1.0e-08)Ua=+M(+(2.0/qa));else Ua=qa;p[i+16>>3]=Ua;qa=+L(+(ra+Ta));if(qa>1.0e-08)Va=+M(+(2.0/qa));else Va=qa;p[i+24>>3]=Va;n[a>>2]=ta+ +p[i>>3];n[a+4>>2]=ua+ +p[i+8>>3];ua=Ua*2.0;i=a+8|0;n[i>>2]=ua;Ua=Va*2.0;h=a+12|0;n[h>>2]=Ua;if(ua>Ua){n[i>>2]=Ua;n[h>>2]=ua;ua=oa*180.0/3.141592653589793+90.0;h=a+16|0;n[h>>2]=ua;Wa=ua;Xa=h}else{h=a+16|0;Wa=+n[h>>2];Xa=h}ua=Wa+360.0;if(Wa<-180.0){n[Xa>>2]=ua;Ya=ua}else Ya=Wa;if(Ya>360.0)n[Xa>>2]=Ya+-360.0;Xa=f[Ja>>2]|0;do if(Xa|0){h=Xa+12|0;a=f[h>>2]|0;f[h>>2]=a+-1;if((a|0)!=1)break;CR(o)}while(0);f[Ja>>2]=0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[aa>>2]|0)>0){da=f[ha>>2]|0;ha=0;do{f[da+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[aa>>2]|0))}aa=f[ja>>2]|0;if((aa|0)!=(ia|0))ZF(aa);aa=f[Ga>>2]|0;do if(aa|0){ia=aa+12|0;ja=f[ia>>2]|0;f[ia>>2]=ja+-1;if((ja|0)!=1)break;CR(m)}while(0);f[Ga>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[R>>2]|0)>0){V=f[Z>>2]|0;Z=0;do{f[V+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[R>>2]|0))}R=f[$>>2]|0;if((R|0)!=(_|0))ZF(R);R=f[Ea>>2]|0;do if(R|0){_=R+12|0;$=f[_>>2]|0;f[_>>2]=$+-1;if(($|0)!=1)break;CR(l)}while(0);f[Ea>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[y>>2]|0)>0){H=f[N>>2]|0;N=0;do{f[H+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[y>>2]|0))}y=f[Q>>2]|0;if((y|0)!=(O|0))ZF(y);y=f[k>>2]|0;if((y|0)!=(z|0)){if(y|0)QYa(y);f[k>>2]=z;f[v>>2]=136}v=f[j>>2]|0;if((v|0)!=(w|0)){if(v|0)QYa(v);f[j>>2]=w;f[x>>2]=136}x=g+36|0;w=f[x>>2]|0;do if(w|0){j=w+12|0;v=f[j>>2]|0;f[j>>2]=v+-1;if((v|0)!=1)break;CR(g)}while(0);f[x>>2]=0;x=g+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[x>>2]|0)>0){t=f[g+40>>2]|0;w=0;do{f[t+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[x>>2]|0))}x=f[B>>2]|0;if((x|0)!=(g+48|0))ZF(x);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function rna(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+64|0;d=c+56|0;e=c;_$(d,75264);do if((NS(b)|0)==65536){g=f[b+4>>2]|0;f[e>>2]=f[g>>2];h=e+4|0;i=g+4|0;f[h>>2]=f[i>>2];j=e+8|0;f[j>>2]=f[g+8>>2];f[e+12>>2]=f[g+12>>2];f[e+16>>2]=f[g+16>>2];f[e+20>>2]=f[g+20>>2];f[e+24>>2]=f[g+24>>2];f[e+28>>2]=f[g+28>>2];f[e+32>>2]=f[g+32>>2];k=f[g+36>>2]|0;f[e+36>>2]=k;f[e+40>>2]=j;j=e+48|0;l=e+44|0;f[l>>2]=j;f[j>>2]=0;f[e+52>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[g+44>>2]|0;j=f[l>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];m=e;break}else{f[h>>2]=0;BR(e,g);m=e;break}}else{OR(e,b,-1);m=e}while(0);if(!(f[m>>2]&7))sna(a,e);else tna(a,e);a=e+36|0;m=f[a>>2]|0;if(m|0?(b=m+12|0,m=f[b>>2]|0,f[b>>2]=m+-1,(m|0)==1):0)CR(e);f[a>>2]=0;a=e+16|0;m=e+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[m>>2]|0)>0){a=f[e+40>>2]|0;b=0;do{f[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[m>>2]|0))}m=f[e+44>>2]|0;if((m|0)!=(e+48|0))ZF(m);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function sna(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;if(!((g&6)>>>0<2&(g&4088|0)==0)){f[e>>2]=0;f[e+4>>2]=0;g=c$(e,39)|0;h=327202;i=g+39|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j$(-215,e,327242,326777,906);d$(e)}e=f[c+40>>2]|0;h=f[e+4>>2]|0;g=f[e>>2]|0;if((g|0)<=0){j=-1;k=h;l=0;m=-1;n=(k|0)<(h|0);o=n?m:0;p=n?k:0;q=j+1|0;r=q-p|0;s=l-o|0;f[a>>2]=p;t=a+4|0;f[t>>2]=o;v=a+8|0;f[v>>2]=r;w=a+12|0;f[w>>2]=s;u=d;return}e=f[c+16>>2]|0;i=f[f[c+44>>2]>>2]|0;c=0;x=-1;y=h;z=-1;A=-1;while(1){B=e+(Y(i,c)|0)|0;C=B;D=C+3&-4;E=D;F=D-C|0;C=(F|0)>(h|0)?h:F;a:do if((C|0)>0){D=0;while(1){if(b[B+D>>0]|0)break;G=D+1|0;if((G|0)<(C|0))D=G;else{H=0;I=x;J=y;break a}}H=1;I=(D|0)>(x|0)?D:x;J=(D|0)<(y|0)?D:y}else{H=0;I=x;J=y}while(0);if((h|0)>(F|0)){B=J-C|0;G=I-C|0;K=h-C|0;L=B+-4|0;b:do if((B|0)<4)M=0;else{N=0;while(1){if(f[E+N>>2]|0){M=N;break b}O=N+4|0;if((O|0)>(L|0)){M=O;break}else N=O}}while(0);c:do if((M|0)<(B|0)){L=M;while(1){if(b[E+L>>0]|0)break;F=L+1|0;if((F|0)<(B|0))L=F;else{P=H;Q=F;R=G;S=B;break c}}P=1;Q=L;R=(L|0)>(G|0)?L:G;S=L}else{P=H;Q=M;R=G;S=B}while(0);B=Q+-1|0;G=(B|0)<(R|0)?R:B;B=K;while(1){T=B+-1|0;U=(T|0)>(G|0);V=(T&3|0)==3;if(V|U^1){W=20;break}if(!(b[E+T>>0]|0))B=T;else{X=T;break}}d:do if((W|0)==20){W=0;if(U&V?(B=G+3|0,(T|0)>(B|0)):0){K=T;while(1){if(f[E+K+-3>>2]|0){X=K;break d}F=K+-4|0;if((F|0)>(B|0))K=F;else{X=F;break}}}else X=T}while(0);e:do if((X|0)>(G|0)){K=X;while(1){if(b[E+K>>0]|0){Z=1;_=K;break e}B=K+-1|0;if((B|0)>(G|0))K=B;else{$=B;W=27;break}}}else{$=X;W=27}while(0);f:do if((W|0)==27){W=0;if(!P){G=Q&-4;K=$+-3|0;g:do if((G|0)>(K|0))aa=G;else{B=G;while(1){if(f[E+B>>2]|0){aa=B;break g}L=B+4|0;if((L|0)>(K|0)){aa=L;break}else B=L}}while(0);if((aa|0)>($|0)){Z=0;_=R}else{K=aa;while(1){if(b[E+K>>0]|0){Z=1;_=R;break f}if((K|0)<($|0))K=K+1|0;else{Z=0;_=R;break}}}}else{Z=P;_=R}}while(0);ba=Z;ca=_+C|0;da=S+C|0}else{ba=H;ca=I;da=J}E=(ba|0)==0;z=E?z:c;A=E?A:(A|0)<0?c:A;c=c+1|0;if((c|0)==(g|0))break;else{x=ca;y=da}}j=ca;k=da;l=z+1|0;m=A;n=(k|0)<(h|0);o=n?m:0;p=n?k:0;q=j+1|0;r=q-p|0;s=l-o|0;f[a>>2]=p;t=a+4|0;f[t>>2]=o;v=a+8|0;f[v>>2]=r;w=a+12|0;f[w>>2]=s;u=d;return}function tna(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0;d=u;u=u+16|0;e=d;g=LS(c,2,-1,1)|0;h=f[c>>2]&7;if(!((g|0)>-1&(h|1|0)==5)){f[e>>2]=0;f[e+4>>2]=0;i=c$(e,42)|0;j=326941;k=i+42|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));j$(-215,e,327181,326777,788);d$(e)}if(!g){f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;u=d;return}e=f[c+16>>2]|0;c=f[e>>2]|0;j=f[e+4>>2]|0;if((h|0)!=5)if((g|0)>1){h=1;i=c;k=c;l=j;m=j;while(1){o=f[e+(h<<3)>>2]|0;p=f[e+(h<<3)+4>>2]|0;q=(k|0)>(o|0)?o:k;r=(i|0)<(o|0)?o:i;o=(m|0)>(p|0)?p:m;t=(l|0)<(p|0)?p:l;h=h+1|0;if((h|0)==(g|0)){v=r;w=q;x=t;y=o;break}else{i=r;k=q;l=t;m=o}}}else{v=c;w=c;x=j;y=j}else{m=c>>31&2147483647^c;c=j>>31&2147483647^j;if((g|0)>1){j=1;l=m;k=m;i=c;h=c;while(1){o=f[e+(j<<3)>>2]|0;t=f[e+(j<<3)+4>>2]|0;q=o>>31&2147483647^o;o=t>>31&2147483647^t;t=(k|0)>(q|0)?q:k;r=(l|0)<(q|0)?q:l;q=(h|0)>(o|0)?o:h;p=(i|0)<(o|0)?o:i;j=j+1|0;if((j|0)==(g|0)){z=r;A=t;B=p;C=q;break}else{l=r;k=t;i=p;h=q}}}else{z=m;A=m;B=c;C=c}D=(f[s>>2]=A>>31&2147483647^A,+n[s>>2]);A=~~D;E=(f[s>>2]=C>>31&2147483647^C,+n[s>>2]);C=~~E;F=(f[s>>2]=z>>31&2147483647^z,+n[s>>2]);z=~~F;G=(f[s>>2]=B>>31&2147483647^B,+n[s>>2]);B=~~G;v=z-(+(z|0)>F&1)|0;w=A-(+(A|0)>D&1)|0;x=B-(+(B|0)>G&1)|0;y=C-(+(C|0)>E&1)|0}f[a>>2]=w;f[a+4>>2]=y;f[a+8>>2]=v+1-w;f[a+12>>2]=x+1-y;u=d;return}function una(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=u;u=u+1344|0;g=e+1256|0;h=e+1236|0;i=e+1208|0;j=e;k=e+1152|0;l=e+1096|0;m=g+56|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((c|0)!=0?(m=f[c>>2]|0,(m&-65536|0)==1117323264):0){if((m&4094|0)!=12){f[j>>2]=0;f[j+4>>2]=0;n=c$(j,25)|0;o=327297;p=n+25|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-5,j,327323,326777,1363);d$(j)}if((f[c+4>>2]|0)>=88)if(!d){m=c+56|0;f[a>>2]=f[m>>2];f[a+4>>2]=f[m+4>>2];f[a+8>>2]=f[m+8>>2];f[a+12>>2]=f[m+12>>2];u=e;return}else{q=c;r=d;s=21}else{q=c;r=0;s=21}}else s=6;a:do if((s|0)==6){d=F0(c,i,0,0)|0;switch(f[d>>2]&4095){case 13:case 12:{q=uqa(0,d,g,h)|0;r=0;s=21;break a;break}case 1:case 0:break;default:{f[j>>2]=0;f[j+4>>2]=0;n=c$(j,56)|0;o=327338;p=n+56|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));j$(-210,j,327323,326777,1383);d$(j)}}if(!d){q=0;r=0;s=21}else{JR(k,d,0,1,0,0);sna(j,k);m=f[j>>2]|0;t=f[j+4>>2]|0;v=f[j+8>>2]|0;w=f[j+12>>2]|0;x=k+36|0;y=f[x>>2]|0;if(y|0?(z=y+12|0,y=f[z>>2]|0,f[z>>2]=y+-1,(y|0)==1):0)CR(k);f[x>>2]=0;x=k+16|0;y=k+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[y>>2]|0)>0){x=f[k+40>>2]|0;z=0;do{f[x+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[y>>2]|0))}y=f[k+44>>2]|0;if((y|0)!=(k+48|0))ZF(y);A=m;B=v;C=w;D=t}}while(0);if((s|0)==21){if(!(f[q+24>>2]|0)){E=0;F=0;G=0;H=0}else{s=j+8|0;f[j>>2]=s;o=j+4|0;f[o>>2]=136;JR(l,q,0,0,0,j);tna(k,l);n=f[k>>2]|0;p=f[k+4>>2]|0;h=f[k+8>>2]|0;g=f[k+12>>2]|0;k=l+36|0;i=f[k>>2]|0;if(i|0?(c=i+12|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)CR(l);f[k>>2]=0;k=l+16|0;i=l+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[i>>2]|0)>0){k=f[l+40>>2]|0;c=0;do{f[k+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[l+44>>2]|0;if((i|0)!=(l+48|0))ZF(i);i=f[j>>2]|0;if((i|0)!=(s|0)){if(i|0)QYa(i);f[j>>2]=s;f[o>>2]=136}E=n;F=h;G=g;H=p}if(!r){A=E;B=F;C=G;D=H}else{f[q+56>>2]=E;f[q+60>>2]=H;f[q+64>>2]=F;f[q+68>>2]=G;A=E;B=F;C=G;D=H}}f[a>>2]=A;f[a+4>>2]=D;f[a+8>>2]=B;f[a+12>>2]=C;u=e;return}function vna(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+16|0;i=h;j=h+8|0;k=c&7;l=d&7;if((d^c)&4088|0){f[j>>2]=0;f[j+4>>2]=0;m=c$(j,90)|0;n=327395;o=m+90|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,j,327486,327502,1300);d$(j)}n=(g|0)<0?(e|0)/2|0:g;g=(k|0)==0;m=(l|0)==4;if(g&m){o=NYa(12)|0;v9(o);f[o>>2]=75292;f[o+4>>2]=e;f[o+8>>2]=n;p=NYa(16)|0;q=p+4|0;f[q>>2]=1;f[p>>2]=75312;f[p+8>>2]=o;f[a>>2]=p;f[a+4>>2]=o;f[q>>2]=(f[q>>2]|0)+1;o=f[q>>2]|0;f[q>>2]=o+-1;if((o|0)!=1){u=h;return}ki[f[(f[p>>2]|0)+8>>2]&2047](p);u=h;return}if(g&(l|0)==2){p=NYa(12)|0;v9(p);f[p>>2]=75332;f[p+4>>2]=e;f[p+8>>2]=n;o=NYa(16)|0;q=o+4|0;f[q>>2]=1;f[o>>2]=75352;f[o+8>>2]=p;f[a>>2]=o;f[a+4>>2]=p;f[q>>2]=(f[q>>2]|0)+1;p=f[q>>2]|0;f[q>>2]=p+-1;if((p|0)!=1){u=h;return}ki[f[(f[o>>2]|0)+8>>2]&2047](o);u=h;return}o=(l|0)==6;if(g&o){g=NYa(12)|0;v9(g);f[g>>2]=75372;f[g+4>>2]=e;f[g+8>>2]=n;l=NYa(16)|0;p=l+4|0;f[p>>2]=1;f[l>>2]=75392;f[l+8>>2]=g;f[a>>2]=l;f[a+4>>2]=g;f[p>>2]=(f[p>>2]|0)+1;g=f[p>>2]|0;f[p>>2]=g+-1;if((g|0)!=1){u=h;return}ki[f[(f[l>>2]|0)+8>>2]&2047](l);u=h;return}l=(k|0)==2;if(l&m){g=NYa(12)|0;v9(g);f[g>>2]=75412;f[g+4>>2]=e;f[g+8>>2]=n;p=NYa(16)|0;q=p+4|0;f[q>>2]=1;f[p>>2]=75432;f[p+8>>2]=g;f[a>>2]=p;f[a+4>>2]=g;f[q>>2]=(f[q>>2]|0)+1;g=f[q>>2]|0;f[q>>2]=g+-1;if((g|0)!=1){u=h;return}ki[f[(f[p>>2]|0)+8>>2]&2047](p);u=h;return}if(l&o){l=NYa(12)|0;v9(l);f[l>>2]=75452;f[l+4>>2]=e;f[l+8>>2]=n;p=NYa(16)|0;g=p+4|0;f[g>>2]=1;f[p>>2]=75472;f[p+8>>2]=l;f[a>>2]=p;f[a+4>>2]=l;f[g>>2]=(f[g>>2]|0)+1;l=f[g>>2]|0;f[g>>2]=l+-1;if((l|0)!=1){u=h;return}ki[f[(f[p>>2]|0)+8>>2]&2047](p);u=h;return}p=(k|0)==3;if(p&m){l=NYa(12)|0;v9(l);f[l>>2]=75492;f[l+4>>2]=e;f[l+8>>2]=n;g=NYa(16)|0;q=g+4|0;f[q>>2]=1;f[g>>2]=75512;f[g+8>>2]=l;f[a>>2]=g;f[a+4>>2]=l;f[q>>2]=(f[q>>2]|0)+1;l=f[q>>2]|0;f[q>>2]=l+-1;if((l|0)!=1){u=h;return}ki[f[(f[g>>2]|0)+8>>2]&2047](g);u=h;return}if((k|0)==4&m){m=NYa(12)|0;v9(m);f[m>>2]=75532;f[m+4>>2]=e;f[m+8>>2]=n;g=NYa(16)|0;l=g+4|0;f[l>>2]=1;f[g>>2]=75552;f[g+8>>2]=m;f[a>>2]=g;f[a+4>>2]=m;f[l>>2]=(f[l>>2]|0)+1;m=f[l>>2]|0;f[l>>2]=m+-1;if((m|0)!=1){u=h;return}ki[f[(f[g>>2]|0)+8>>2]&2047](g);u=h;return}if(p&o){p=NYa(12)|0;v9(p);f[p>>2]=75572;f[p+4>>2]=e;f[p+8>>2]=n;g=NYa(16)|0;m=g+4|0;f[m>>2]=1;f[g>>2]=75592;f[g+8>>2]=p;f[a>>2]=g;f[a+4>>2]=p;f[m>>2]=(f[m>>2]|0)+1;p=f[m>>2]|0;f[m>>2]=p+-1;if((p|0)!=1){u=h;return}ki[f[(f[g>>2]|0)+8>>2]&2047](g);u=h;return}if((k|0)==5&o){g=NYa(12)|0;v9(g);f[g>>2]=75612;f[g+4>>2]=e;f[g+8>>2]=n;p=NYa(16)|0;m=p+4|0;f[m>>2]=1;f[p>>2]=75632;f[p+8>>2]=g;f[a>>2]=p;f[a+4>>2]=g;f[m>>2]=(f[m>>2]|0)+1;g=f[m>>2]|0;f[m>>2]=g+-1;if((g|0)!=1){u=h;return}ki[f[(f[p>>2]|0)+8>>2]&2047](p);u=h;return}if(!((k|0)==6&o)){f[i>>2]=c;f[i+4>>2]=d;p$(j,327553,i);j$(-213,j,327486,327502,1328);d$(j);f[a>>2]=0;f[a+4>>2]=0;u=h;return}j=NYa(12)|0;v9(j);f[j>>2]=75652;f[j+4>>2]=e;f[j+8>>2]=n;n=NYa(16)|0;e=n+4|0;f[e>>2]=1;f[n>>2]=75672;f[n+8>>2]=j;f[a>>2]=n;f[a+4>>2]=j;f[e>>2]=(f[e>>2]|0)+1;j=f[e>>2]|0;f[e>>2]=j+-1;if((j|0)!=1){u=h;return}ki[f[(f[n>>2]|0)+8>>2]&2047](n);u=h;return}function wna(a){a=a|0;PYa(a);return}function xna(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function yna(a){a=a|0;PYa(a);return}function zna(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0;g=f[a+4>>2]|0;a=Y(g,e)|0;h=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;i=e<<1;j=0;do{p[c+(j<<3)>>3]=+p[b+(j<<3)>>3]+ +p[b+(j+e<<3)>>3]+ +p[b+(j+i<<3)>>3];j=j+1|0}while((j|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;j=e*3|0;i=e<<2;k=0;do{p[c+(k<<3)>>3]=+p[b+(k<<3)>>3]+ +p[b+(k+e<<3)>>3]+ +p[b+(k+d<<3)>>3]+ +p[b+(k+j<<3)>>3]+ +p[b+(k+i<<3)>>3];k=k+1|0}while((k|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){g=0;l=0.0;while(1){m=l+ +p[b+(g<<3)>>3];g=g+1|0;if((g|0)==(a|0)){n=m;break}else l=m}}else n=0.0;p[c>>3]=n;if((h|0)>0){o=0;q=n}else return;do{q=q+(+p[b+(o+a<<3)>>3]-+p[b+(o<<3)>>3]);o=o+1|0;p[c+(o<<3)>>3]=q}while((o|0)!=(h|0));return}case 3:{if((a|0)>0){o=0;q=0.0;n=0.0;l=0.0;while(1){m=q+ +p[b+(o<<3)>>3];r=n+ +p[b+(o+1<<3)>>3];s=l+ +p[b+(o+2<<3)>>3];o=o+3|0;if((o|0)>=(a|0)){t=m;u=r;v=s;break}else{q=m;n=r;l=s}}}else{t=0.0;u=0.0;v=0.0}p[c>>3]=t;p[c+8>>3]=u;p[c+16>>3]=v;if((h|0)>0){w=0;x=t;y=u;z=v}else return;do{o=w+a|0;x=x+(+p[b+(o<<3)>>3]-+p[b+(w<<3)>>3]);y=y+(+p[b+(o+1<<3)>>3]-+p[b+(w+1<<3)>>3]);z=z+(+p[b+(o+2<<3)>>3]-+p[b+(w+2<<3)>>3]);o=w;w=w+3|0;p[c+(w<<3)>>3]=x;p[c+(o+4<<3)>>3]=y;p[c+(o+5<<3)>>3]=z}while((w|0)<(h|0));return}case 4:{if((a|0)>0){w=0;z=0.0;y=0.0;x=0.0;v=0.0;while(1){u=z+ +p[b+(w<<3)>>3];t=y+ +p[b+((w|1)<<3)>>3];l=x+ +p[b+((w|2)<<3)>>3];n=v+ +p[b+((w|3)<<3)>>3];w=w+4|0;if((w|0)>=(a|0)){A=u;B=t;C=l;D=n;break}else{z=u;y=t;x=l;v=n}}}else{A=0.0;B=0.0;C=0.0;D=0.0}p[c>>3]=A;p[c+8>>3]=B;p[c+16>>3]=C;p[c+24>>3]=D;if((h|0)>0){E=0;F=A;G=B;H=C;I=D}else return;do{w=E+a|0;F=F+(+p[b+(w<<3)>>3]-+p[b+(E<<3)>>3]);G=G+(+p[b+(w+1<<3)>>3]-+p[b+((E|1)<<3)>>3]);H=H+(+p[b+(w+2<<3)>>3]-+p[b+((E|2)<<3)>>3]);I=I+(+p[b+(w+3<<3)>>3]-+p[b+((E|3)<<3)>>3]);w=E;E=E+4|0;p[c+(E<<3)>>3]=F;p[c+(w+5<<3)>>3]=G;p[c+(w+6<<3)>>3]=H;p[c+(w+7<<3)>>3]=I}while((E|0)<(h|0));return}default:{if((e|0)<=0)return;E=(h|0)>0;if((a|0)>0){w=c;o=b;g=0;while(1){k=0;I=0.0;do{I=I+ +p[o+(k<<3)>>3];k=k+e|0}while((k|0)<(a|0));p[w>>3]=I;if(E){k=0;H=I;do{H=H+(+p[o+(k+a<<3)>>3]-+p[o+(k<<3)>>3]);k=k+e|0;p[w+(k<<3)>>3]=H}while((k|0)<(h|0))}g=g+1|0;if((g|0)==(e|0))break;else{w=w+8|0;o=o+8|0}}return}if(E){J=c;K=b;L=0}else{F1a(c|0,0,e<<3|0)|0;return}while(1){p[J>>3]=0.0;c=0;H=0.0;do{H=H+(+p[K+(c+a<<3)>>3]-+p[K+(c<<3)>>3]);c=c+e|0;p[J+(c<<3)>>3]=H}while((c|0)<(h|0));L=L+1|0;if((L|0)==(e|0))break;else{J=J+8|0;K=K+8|0}}return}}}}function Ana(a){a=a|0;PYa(a);return}function Bna(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Cna(a){a=a|0;PYa(a);return}function Dna(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0;g=f[a+4>>2]|0;a=Y(g,e)|0;h=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;i=e<<1;j=0;do{p[c+(j<<3)>>3]=+n[b+(j<<2)>>2]+ +n[b+(j+e<<2)>>2]+ +n[b+(j+i<<2)>>2];j=j+1|0}while((j|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;j=e*3|0;i=e<<2;k=0;do{p[c+(k<<3)>>3]=+n[b+(k<<2)>>2]+ +n[b+(k+e<<2)>>2]+ +n[b+(k+d<<2)>>2]+ +n[b+(k+j<<2)>>2]+ +n[b+(k+i<<2)>>2];k=k+1|0}while((k|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){g=0;l=0.0;while(1){m=l+ +n[b+(g<<2)>>2];g=g+1|0;if((g|0)==(a|0)){o=m;break}else l=m}}else o=0.0;p[c>>3]=o;if((h|0)>0){q=0;r=o}else return;do{r=r+(+n[b+(q+a<<2)>>2]-+n[b+(q<<2)>>2]);q=q+1|0;p[c+(q<<3)>>3]=r}while((q|0)!=(h|0));return}case 3:{if((a|0)>0){q=0;r=0.0;o=0.0;l=0.0;while(1){m=r+ +n[b+(q<<2)>>2];s=o+ +n[b+(q+1<<2)>>2];t=l+ +n[b+(q+2<<2)>>2];q=q+3|0;if((q|0)>=(a|0)){u=m;v=s;w=t;break}else{r=m;o=s;l=t}}}else{u=0.0;v=0.0;w=0.0}p[c>>3]=u;p[c+8>>3]=v;p[c+16>>3]=w;if((h|0)>0){x=0;y=u;z=v;A=w}else return;do{q=x+a|0;y=y+(+n[b+(q<<2)>>2]-+n[b+(x<<2)>>2]);z=z+(+n[b+(q+1<<2)>>2]-+n[b+(x+1<<2)>>2]);A=A+(+n[b+(q+2<<2)>>2]-+n[b+(x+2<<2)>>2]);q=x;x=x+3|0;p[c+(x<<3)>>3]=y;p[c+(q+4<<3)>>3]=z;p[c+(q+5<<3)>>3]=A}while((x|0)<(h|0));return}case 4:{if((a|0)>0){x=0;A=0.0;z=0.0;y=0.0;w=0.0;while(1){v=A+ +n[b+(x<<2)>>2];u=z+ +n[b+((x|1)<<2)>>2];l=y+ +n[b+((x|2)<<2)>>2];o=w+ +n[b+((x|3)<<2)>>2];x=x+4|0;if((x|0)>=(a|0)){B=v;C=u;D=l;E=o;break}else{A=v;z=u;y=l;w=o}}}else{B=0.0;C=0.0;D=0.0;E=0.0}p[c>>3]=B;p[c+8>>3]=C;p[c+16>>3]=D;p[c+24>>3]=E;if((h|0)>0){F=0;G=B;H=C;I=D;J=E}else return;do{x=F+a|0;G=G+(+n[b+(x<<2)>>2]-+n[b+(F<<2)>>2]);H=H+(+n[b+(x+1<<2)>>2]-+n[b+((F|1)<<2)>>2]);I=I+(+n[b+(x+2<<2)>>2]-+n[b+((F|2)<<2)>>2]);J=J+(+n[b+(x+3<<2)>>2]-+n[b+((F|3)<<2)>>2]);x=F;F=F+4|0;p[c+(F<<3)>>3]=G;p[c+(x+5<<3)>>3]=H;p[c+(x+6<<3)>>3]=I;p[c+(x+7<<3)>>3]=J}while((F|0)<(h|0));return}default:{if((e|0)<=0)return;F=(h|0)>0;if((a|0)>0){x=c;q=b;g=0;while(1){k=0;J=0.0;do{J=J+ +n[q+(k<<2)>>2];k=k+e|0}while((k|0)<(a|0));p[x>>3]=J;if(F){k=0;I=J;do{I=I+(+n[q+(k+a<<2)>>2]-+n[q+(k<<2)>>2]);k=k+e|0;p[x+(k<<3)>>3]=I}while((k|0)<(h|0))}g=g+1|0;if((g|0)==(e|0))break;else{x=x+8|0;q=q+4|0}}return}if(F){K=c;L=b;M=0}else{F1a(c|0,0,e<<3|0)|0;return}while(1){p[K>>3]=0.0;c=0;I=0.0;do{I=I+(+n[L+(c+a<<2)>>2]-+n[L+(c<<2)>>2]);c=c+e|0;p[K+(c<<3)>>3]=I}while((c|0)<(h|0));M=M+1|0;if((M|0)==(e|0))break;else{K=K+8|0;L=L+4|0}}return}}}}function Ena(a){a=a|0;PYa(a);return}function Fna(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Gna(a){a=a|0;PYa(a);return}function Hna(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0;h=f[a+4>>2]|0;a=Y(h,g)|0;i=Y(e+-1|0,g)|0;switch(h|0){case 3:{h=Y(g,e)|0;if((h|0)<=0)return;j=g<<1;k=0;do{p[c+(k<<3)>>3]=+(d[b+(k<<1)>>1]|0)+ +(d[b+(k+g<<1)>>1]|0)+ +(d[b+(k+j<<1)>>1]|0);k=k+1|0}while((k|0)!=(h|0));return}case 5:{h=Y(g,e)|0;if((h|0)<=0)return;e=g<<1;k=g*3|0;j=g<<2;l=0;do{p[c+(l<<3)>>3]=+(d[b+(l<<1)>>1]|0)+ +(d[b+(l+g<<1)>>1]|0)+ +(d[b+(l+e<<1)>>1]|0)+ +(d[b+(l+k<<1)>>1]|0)+ +(d[b+(l+j<<1)>>1]|0);l=l+1|0}while((l|0)!=(h|0));return}default:switch(g|0){case 1:{if((a|0)>0){h=0;m=0.0;while(1){n=m+ +(d[b+(h<<1)>>1]|0);h=h+1|0;if((h|0)==(a|0)){o=n;break}else m=n}}else o=0.0;p[c>>3]=o;if((i|0)>0){q=0;r=o}else return;do{r=r+(+(d[b+(q+a<<1)>>1]|0)-+(d[b+(q<<1)>>1]|0));q=q+1|0;p[c+(q<<3)>>3]=r}while((q|0)!=(i|0));return}case 3:{if((a|0)>0){q=0;r=0.0;o=0.0;m=0.0;while(1){n=r+ +(d[b+(q<<1)>>1]|0);s=o+ +(d[b+(q+1<<1)>>1]|0);t=m+ +(d[b+(q+2<<1)>>1]|0);q=q+3|0;if((q|0)>=(a|0)){u=n;v=s;w=t;break}else{r=n;o=s;m=t}}}else{u=0.0;v=0.0;w=0.0}p[c>>3]=u;p[c+8>>3]=v;p[c+16>>3]=w;if((i|0)>0){x=0;y=u;z=v;A=w}else return;do{q=x+a|0;y=y+(+(d[b+(q<<1)>>1]|0)-+(d[b+(x<<1)>>1]|0));z=z+(+(d[b+(q+1<<1)>>1]|0)-+(d[b+(x+1<<1)>>1]|0));A=A+(+(d[b+(q+2<<1)>>1]|0)-+(d[b+(x+2<<1)>>1]|0));q=x;x=x+3|0;p[c+(x<<3)>>3]=y;p[c+(q+4<<3)>>3]=z;p[c+(q+5<<3)>>3]=A}while((x|0)<(i|0));return}case 4:{if((a|0)>0){x=0;A=0.0;z=0.0;y=0.0;w=0.0;while(1){v=A+ +(d[b+(x<<1)>>1]|0);u=z+ +(d[b+((x|1)<<1)>>1]|0);m=y+ +(d[b+((x|2)<<1)>>1]|0);o=w+ +(d[b+((x|3)<<1)>>1]|0);x=x+4|0;if((x|0)>=(a|0)){B=v;C=u;D=m;E=o;break}else{A=v;z=u;y=m;w=o}}}else{B=0.0;C=0.0;D=0.0;E=0.0}p[c>>3]=B;p[c+8>>3]=C;p[c+16>>3]=D;p[c+24>>3]=E;if((i|0)>0){F=0;G=B;H=C;I=D;J=E}else return;do{x=F+a|0;G=G+(+(d[b+(x<<1)>>1]|0)-+(d[b+(F<<1)>>1]|0));H=H+(+(d[b+(x+1<<1)>>1]|0)-+(d[b+((F|1)<<1)>>1]|0));I=I+(+(d[b+(x+2<<1)>>1]|0)-+(d[b+((F|2)<<1)>>1]|0));J=J+(+(d[b+(x+3<<1)>>1]|0)-+(d[b+((F|3)<<1)>>1]|0));x=F;F=F+4|0;p[c+(F<<3)>>3]=G;p[c+(x+5<<3)>>3]=H;p[c+(x+6<<3)>>3]=I;p[c+(x+7<<3)>>3]=J}while((F|0)<(i|0));return}default:{if((g|0)<=0)return;F=(i|0)>0;if((a|0)>0){x=c;q=b;h=0;while(1){l=0;J=0.0;do{J=J+ +(d[q+(l<<1)>>1]|0);l=l+g|0}while((l|0)<(a|0));p[x>>3]=J;if(F){l=0;I=J;do{I=I+(+(d[q+(l+a<<1)>>1]|0)-+(d[q+(l<<1)>>1]|0));l=l+g|0;p[x+(l<<3)>>3]=I}while((l|0)<(i|0))}h=h+1|0;if((h|0)==(g|0))break;else{x=x+8|0;q=q+2|0}}return}if(F){K=c;L=b;M=0}else{F1a(c|0,0,g<<3|0)|0;return}while(1){p[K>>3]=0.0;c=0;I=0.0;do{I=I+(+(d[L+(c+a<<1)>>1]|0)-+(d[L+(c<<1)>>1]|0));c=c+g|0;p[K+(c<<3)>>3]=I}while((c|0)<(i|0));M=M+1|0;if((M|0)==(g|0))break;else{K=K+8|0;L=L+2|0}}return}}}}function Ina(a){a=a|0;PYa(a);return}function Jna(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Kna(a){a=a|0;PYa(a);return}function Lna(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;g=f[a+4>>2]|0;a=Y(g,e)|0;h=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;i=e<<1;j=0;do{f[c+(j<<2)>>2]=(f[b+(j+e<<2)>>2]|0)+(f[b+(j<<2)>>2]|0)+(f[b+(j+i<<2)>>2]|0);j=j+1|0}while((j|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;j=e*3|0;i=e<<2;k=0;do{f[c+(k<<2)>>2]=(f[b+(k+e<<2)>>2]|0)+(f[b+(k<<2)>>2]|0)+(f[b+(k+d<<2)>>2]|0)+(f[b+(k+j<<2)>>2]|0)+(f[b+(k+i<<2)>>2]|0);k=k+1|0}while((k|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){g=0;k=0;while(1){i=(f[b+(g<<2)>>2]|0)+k|0;g=g+1|0;if((g|0)==(a|0)){l=i;break}else k=i}}else l=0;f[c>>2]=l;if((h|0)>0){m=0;n=l}else return;do{n=(f[b+(m+a<<2)>>2]|0)-(f[b+(m<<2)>>2]|0)+n|0;m=m+1|0;f[c+(m<<2)>>2]=n}while((m|0)!=(h|0));return}case 3:{if((a|0)>0){m=0;n=0;l=0;k=0;while(1){g=(f[b+(m<<2)>>2]|0)+n|0;i=(f[b+(m+1<<2)>>2]|0)+l|0;j=(f[b+(m+2<<2)>>2]|0)+k|0;m=m+3|0;if((m|0)>=(a|0)){o=g;p=i;q=j;break}else{n=g;l=i;k=j}}}else{o=0;p=0;q=0}f[c>>2]=o;f[c+4>>2]=p;f[c+8>>2]=q;if((h|0)>0){r=0;s=o;t=p;u=q}else return;do{q=r+a|0;s=(f[b+(q<<2)>>2]|0)-(f[b+(r<<2)>>2]|0)+s|0;t=(f[b+(q+1<<2)>>2]|0)-(f[b+(r+1<<2)>>2]|0)+t|0;u=(f[b+(q+2<<2)>>2]|0)-(f[b+(r+2<<2)>>2]|0)+u|0;q=r;r=r+3|0;f[c+(r<<2)>>2]=s;f[c+(q+4<<2)>>2]=t;f[c+(q+5<<2)>>2]=u}while((r|0)<(h|0));return}case 4:{if((a|0)>0){r=0;u=0;t=0;s=0;q=0;while(1){p=(f[b+(r<<2)>>2]|0)+u|0;o=(f[b+((r|1)<<2)>>2]|0)+t|0;k=(f[b+((r|2)<<2)>>2]|0)+s|0;l=(f[b+((r|3)<<2)>>2]|0)+q|0;r=r+4|0;if((r|0)>=(a|0)){v=p;w=o;x=k;y=l;break}else{u=p;t=o;s=k;q=l}}}else{v=0;w=0;x=0;y=0}f[c>>2]=v;f[c+4>>2]=w;f[c+8>>2]=x;f[c+12>>2]=y;if((h|0)>0){z=0;A=v;B=w;C=x;D=y}else return;do{y=z+a|0;A=(f[b+(y<<2)>>2]|0)-(f[b+(z<<2)>>2]|0)+A|0;B=(f[b+(y+1<<2)>>2]|0)-(f[b+((z|1)<<2)>>2]|0)+B|0;C=(f[b+(y+2<<2)>>2]|0)-(f[b+((z|2)<<2)>>2]|0)+C|0;D=(f[b+(y+3<<2)>>2]|0)-(f[b+((z|3)<<2)>>2]|0)+D|0;y=z;z=z+4|0;f[c+(z<<2)>>2]=A;f[c+(y+5<<2)>>2]=B;f[c+(y+6<<2)>>2]=C;f[c+(y+7<<2)>>2]=D}while((z|0)<(h|0));return}default:{if((e|0)<=0)return;z=(h|0)>0;if((a|0)>0){D=c;C=b;B=0;while(1){A=0;y=0;do{y=(f[C+(A<<2)>>2]|0)+y|0;A=A+e|0}while((A|0)<(a|0));f[D>>2]=y;if(z){A=0;x=y;do{x=(f[C+(A+a<<2)>>2]|0)-(f[C+(A<<2)>>2]|0)+x|0;A=A+e|0;f[D+(A<<2)>>2]=x}while((A|0)<(h|0))}B=B+1|0;if((B|0)==(e|0))break;else{D=D+4|0;C=C+4|0}}return}if(z){E=c;F=b;G=0}else{F1a(c|0,0,e<<2|0)|0;return}while(1){f[E>>2]=0;c=0;b=0;do{b=(f[F+(c+a<<2)>>2]|0)-(f[F+(c<<2)>>2]|0)+b|0;c=c+e|0;f[E+(c<<2)>>2]=b}while((c|0)<(h|0));G=G+1|0;if((G|0)==(e|0))break;else{E=E+4|0;F=F+4|0}}return}}}}function Mna(a){a=a|0;PYa(a);return}function Nna(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Ona(a){a=a|0;PYa(a);return}function Pna(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=f[a+4>>2]|0;a=Y(h,g)|0;i=Y(e+-1|0,g)|0;switch(h|0){case 3:{h=Y(g,e)|0;if((h|0)<=0)return;j=g<<1;k=0;do{f[c+(k<<2)>>2]=(d[b+(k+g<<1)>>1]|0)+(d[b+(k<<1)>>1]|0)+(d[b+(k+j<<1)>>1]|0);k=k+1|0}while((k|0)!=(h|0));return}case 5:{h=Y(g,e)|0;if((h|0)<=0)return;e=g<<1;k=g*3|0;j=g<<2;l=0;do{f[c+(l<<2)>>2]=(d[b+(l+g<<1)>>1]|0)+(d[b+(l<<1)>>1]|0)+(d[b+(l+e<<1)>>1]|0)+(d[b+(l+k<<1)>>1]|0)+(d[b+(l+j<<1)>>1]|0);l=l+1|0}while((l|0)!=(h|0));return}default:switch(g|0){case 1:{if((a|0)>0){h=0;l=0;while(1){j=(d[b+(h<<1)>>1]|0)+l|0;h=h+1|0;if((h|0)==(a|0)){m=j;break}else l=j}}else m=0;f[c>>2]=m;if((i|0)>0){n=0;o=m}else return;do{o=(d[b+(n+a<<1)>>1]|0)-(d[b+(n<<1)>>1]|0)+o|0;n=n+1|0;f[c+(n<<2)>>2]=o}while((n|0)!=(i|0));return}case 3:{if((a|0)>0){n=0;o=0;m=0;l=0;while(1){h=(d[b+(n<<1)>>1]|0)+o|0;j=(d[b+(n+1<<1)>>1]|0)+m|0;k=(d[b+(n+2<<1)>>1]|0)+l|0;n=n+3|0;if((n|0)>=(a|0)){p=h;q=j;r=k;break}else{o=h;m=j;l=k}}}else{p=0;q=0;r=0}f[c>>2]=p;f[c+4>>2]=q;f[c+8>>2]=r;if((i|0)>0){s=0;t=p;u=q;v=r}else return;do{r=s+a|0;t=(d[b+(r<<1)>>1]|0)-(d[b+(s<<1)>>1]|0)+t|0;u=(d[b+(r+1<<1)>>1]|0)-(d[b+(s+1<<1)>>1]|0)+u|0;v=(d[b+(r+2<<1)>>1]|0)-(d[b+(s+2<<1)>>1]|0)+v|0;r=s;s=s+3|0;f[c+(s<<2)>>2]=t;f[c+(r+4<<2)>>2]=u;f[c+(r+5<<2)>>2]=v}while((s|0)<(i|0));return}case 4:{if((a|0)>0){s=0;v=0;u=0;t=0;r=0;while(1){q=(d[b+(s<<1)>>1]|0)+v|0;p=(d[b+((s|1)<<1)>>1]|0)+u|0;l=(d[b+((s|2)<<1)>>1]|0)+t|0;m=(d[b+((s|3)<<1)>>1]|0)+r|0;s=s+4|0;if((s|0)>=(a|0)){w=q;x=p;y=l;z=m;break}else{v=q;u=p;t=l;r=m}}}else{w=0;x=0;y=0;z=0}f[c>>2]=w;f[c+4>>2]=x;f[c+8>>2]=y;f[c+12>>2]=z;if((i|0)>0){A=0;B=w;C=x;D=y;E=z}else return;do{z=A+a|0;B=(d[b+(z<<1)>>1]|0)-(d[b+(A<<1)>>1]|0)+B|0;C=(d[b+(z+1<<1)>>1]|0)-(d[b+((A|1)<<1)>>1]|0)+C|0;D=(d[b+(z+2<<1)>>1]|0)-(d[b+((A|2)<<1)>>1]|0)+D|0;E=(d[b+(z+3<<1)>>1]|0)-(d[b+((A|3)<<1)>>1]|0)+E|0;z=A;A=A+4|0;f[c+(A<<2)>>2]=B;f[c+(z+5<<2)>>2]=C;f[c+(z+6<<2)>>2]=D;f[c+(z+7<<2)>>2]=E}while((A|0)<(i|0));return}default:{if((g|0)<=0)return;A=(i|0)>0;if((a|0)>0){E=c;D=b;C=0;while(1){B=0;z=0;do{z=(d[D+(B<<1)>>1]|0)+z|0;B=B+g|0}while((B|0)<(a|0));f[E>>2]=z;if(A){B=0;y=z;do{y=(d[D+(B+a<<1)>>1]|0)-(d[D+(B<<1)>>1]|0)+y|0;B=B+g|0;f[E+(B<<2)>>2]=y}while((B|0)<(i|0))}C=C+1|0;if((C|0)==(g|0))break;else{E=E+4|0;D=D+2|0}}return}if(A){F=c;G=b;H=0}else{F1a(c|0,0,g<<2|0)|0;return}while(1){f[F>>2]=0;c=0;b=0;do{b=(d[G+(c+a<<1)>>1]|0)-(d[G+(c<<1)>>1]|0)+b|0;c=c+g|0;f[F+(c<<2)>>2]=b}while((c|0)<(i|0));H=H+1|0;if((H|0)==(g|0))break;else{F=F+4|0;G=G+2|0}}return}}}}function Qna(a){a=a|0;PYa(a);return}function Rna(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Sna(a){a=a|0;PYa(a);return}function Tna(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0;g=f[a+4>>2]|0;a=Y(g,e)|0;h=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;i=e<<1;k=0;do{p[c+(k<<3)>>3]=+(j[b+(k<<1)>>1]|0)+ +(j[b+(k+e<<1)>>1]|0)+ +(j[b+(k+i<<1)>>1]|0);k=k+1|0}while((k|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;k=e*3|0;i=e<<2;l=0;do{p[c+(l<<3)>>3]=+(j[b+(l<<1)>>1]|0)+ +(j[b+(l+e<<1)>>1]|0)+ +(j[b+(l+d<<1)>>1]|0)+ +(j[b+(l+k<<1)>>1]|0)+ +(j[b+(l+i<<1)>>1]|0);l=l+1|0}while((l|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){g=0;m=0.0;while(1){n=m+ +(j[b+(g<<1)>>1]|0);g=g+1|0;if((g|0)==(a|0)){o=n;break}else m=n}}else o=0.0;p[c>>3]=o;if((h|0)>0){q=0;r=o}else return;do{r=r+(+(j[b+(q+a<<1)>>1]|0)-+(j[b+(q<<1)>>1]|0));q=q+1|0;p[c+(q<<3)>>3]=r}while((q|0)!=(h|0));return}case 3:{if((a|0)>0){q=0;r=0.0;o=0.0;m=0.0;while(1){n=r+ +(j[b+(q<<1)>>1]|0);s=o+ +(j[b+(q+1<<1)>>1]|0);t=m+ +(j[b+(q+2<<1)>>1]|0);q=q+3|0;if((q|0)>=(a|0)){u=n;v=s;w=t;break}else{r=n;o=s;m=t}}}else{u=0.0;v=0.0;w=0.0}p[c>>3]=u;p[c+8>>3]=v;p[c+16>>3]=w;if((h|0)>0){x=0;y=u;z=v;A=w}else return;do{q=x+a|0;y=y+(+(j[b+(q<<1)>>1]|0)-+(j[b+(x<<1)>>1]|0));z=z+(+(j[b+(q+1<<1)>>1]|0)-+(j[b+(x+1<<1)>>1]|0));A=A+(+(j[b+(q+2<<1)>>1]|0)-+(j[b+(x+2<<1)>>1]|0));q=x;x=x+3|0;p[c+(x<<3)>>3]=y;p[c+(q+4<<3)>>3]=z;p[c+(q+5<<3)>>3]=A}while((x|0)<(h|0));return}case 4:{if((a|0)>0){x=0;A=0.0;z=0.0;y=0.0;w=0.0;while(1){v=A+ +(j[b+(x<<1)>>1]|0);u=z+ +(j[b+((x|1)<<1)>>1]|0);m=y+ +(j[b+((x|2)<<1)>>1]|0);o=w+ +(j[b+((x|3)<<1)>>1]|0);x=x+4|0;if((x|0)>=(a|0)){B=v;C=u;D=m;E=o;break}else{A=v;z=u;y=m;w=o}}}else{B=0.0;C=0.0;D=0.0;E=0.0}p[c>>3]=B;p[c+8>>3]=C;p[c+16>>3]=D;p[c+24>>3]=E;if((h|0)>0){F=0;G=B;H=C;I=D;J=E}else return;do{x=F+a|0;G=G+(+(j[b+(x<<1)>>1]|0)-+(j[b+(F<<1)>>1]|0));H=H+(+(j[b+(x+1<<1)>>1]|0)-+(j[b+((F|1)<<1)>>1]|0));I=I+(+(j[b+(x+2<<1)>>1]|0)-+(j[b+((F|2)<<1)>>1]|0));J=J+(+(j[b+(x+3<<1)>>1]|0)-+(j[b+((F|3)<<1)>>1]|0));x=F;F=F+4|0;p[c+(F<<3)>>3]=G;p[c+(x+5<<3)>>3]=H;p[c+(x+6<<3)>>3]=I;p[c+(x+7<<3)>>3]=J}while((F|0)<(h|0));return}default:{if((e|0)<=0)return;F=(h|0)>0;if((a|0)>0){x=c;q=b;g=0;while(1){l=0;J=0.0;do{J=J+ +(j[q+(l<<1)>>1]|0);l=l+e|0}while((l|0)<(a|0));p[x>>3]=J;if(F){l=0;I=J;do{I=I+(+(j[q+(l+a<<1)>>1]|0)-+(j[q+(l<<1)>>1]|0));l=l+e|0;p[x+(l<<3)>>3]=I}while((l|0)<(h|0))}g=g+1|0;if((g|0)==(e|0))break;else{x=x+8|0;q=q+2|0}}return}if(F){K=c;L=b;M=0}else{F1a(c|0,0,e<<3|0)|0;return}while(1){p[K>>3]=0.0;c=0;I=0.0;do{I=I+(+(j[L+(c+a<<1)>>1]|0)-+(j[L+(c<<1)>>1]|0));c=c+e|0;p[K+(c<<3)>>3]=I}while((c|0)<(h|0));M=M+1|0;if((M|0)==(e|0))break;else{K=K+8|0;L=L+2|0}}return}}}}function Una(a){a=a|0;PYa(a);return}function Vna(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Wna(a){a=a|0;PYa(a);return}function Xna(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=f[a+4>>2]|0;a=Y(g,e)|0;h=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;i=e<<1;k=0;do{f[c+(k<<2)>>2]=(j[b+(k+e<<1)>>1]|0)+(j[b+(k<<1)>>1]|0)+(j[b+(k+i<<1)>>1]|0);k=k+1|0}while((k|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;k=e*3|0;i=e<<2;l=0;do{f[c+(l<<2)>>2]=(j[b+(l+e<<1)>>1]|0)+(j[b+(l<<1)>>1]|0)+(j[b+(l+d<<1)>>1]|0)+(j[b+(l+k<<1)>>1]|0)+(j[b+(l+i<<1)>>1]|0);l=l+1|0}while((l|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){g=0;l=0;while(1){i=(j[b+(g<<1)>>1]|0)+l|0;g=g+1|0;if((g|0)==(a|0)){m=i;break}else l=i}}else m=0;f[c>>2]=m;if((h|0)>0){n=0;o=m}else return;do{o=(j[b+(n+a<<1)>>1]|0)-(j[b+(n<<1)>>1]|0)+o|0;n=n+1|0;f[c+(n<<2)>>2]=o}while((n|0)!=(h|0));return}case 3:{if((a|0)>0){n=0;o=0;m=0;l=0;while(1){g=(j[b+(n<<1)>>1]|0)+o|0;i=(j[b+(n+1<<1)>>1]|0)+m|0;k=(j[b+(n+2<<1)>>1]|0)+l|0;n=n+3|0;if((n|0)>=(a|0)){p=g;q=i;r=k;break}else{o=g;m=i;l=k}}}else{p=0;q=0;r=0}f[c>>2]=p;f[c+4>>2]=q;f[c+8>>2]=r;if((h|0)>0){s=0;t=p;u=q;v=r}else return;do{r=s+a|0;t=(j[b+(r<<1)>>1]|0)-(j[b+(s<<1)>>1]|0)+t|0;u=(j[b+(r+1<<1)>>1]|0)-(j[b+(s+1<<1)>>1]|0)+u|0;v=(j[b+(r+2<<1)>>1]|0)-(j[b+(s+2<<1)>>1]|0)+v|0;r=s;s=s+3|0;f[c+(s<<2)>>2]=t;f[c+(r+4<<2)>>2]=u;f[c+(r+5<<2)>>2]=v}while((s|0)<(h|0));return}case 4:{if((a|0)>0){s=0;v=0;u=0;t=0;r=0;while(1){q=(j[b+(s<<1)>>1]|0)+v|0;p=(j[b+((s|1)<<1)>>1]|0)+u|0;l=(j[b+((s|2)<<1)>>1]|0)+t|0;m=(j[b+((s|3)<<1)>>1]|0)+r|0;s=s+4|0;if((s|0)>=(a|0)){w=q;x=p;y=l;z=m;break}else{v=q;u=p;t=l;r=m}}}else{w=0;x=0;y=0;z=0}f[c>>2]=w;f[c+4>>2]=x;f[c+8>>2]=y;f[c+12>>2]=z;if((h|0)>0){A=0;B=w;C=x;D=y;E=z}else return;do{z=A+a|0;B=(j[b+(z<<1)>>1]|0)-(j[b+(A<<1)>>1]|0)+B|0;C=(j[b+(z+1<<1)>>1]|0)-(j[b+((A|1)<<1)>>1]|0)+C|0;D=(j[b+(z+2<<1)>>1]|0)-(j[b+((A|2)<<1)>>1]|0)+D|0;E=(j[b+(z+3<<1)>>1]|0)-(j[b+((A|3)<<1)>>1]|0)+E|0;z=A;A=A+4|0;f[c+(A<<2)>>2]=B;f[c+(z+5<<2)>>2]=C;f[c+(z+6<<2)>>2]=D;f[c+(z+7<<2)>>2]=E}while((A|0)<(h|0));return}default:{if((e|0)<=0)return;A=(h|0)>0;if((a|0)>0){E=c;D=b;C=0;while(1){B=0;z=0;do{z=(j[D+(B<<1)>>1]|0)+z|0;B=B+e|0}while((B|0)<(a|0));f[E>>2]=z;if(A){B=0;y=z;do{y=(j[D+(B+a<<1)>>1]|0)-(j[D+(B<<1)>>1]|0)+y|0;B=B+e|0;f[E+(B<<2)>>2]=y}while((B|0)<(h|0))}C=C+1|0;if((C|0)==(e|0))break;else{E=E+4|0;D=D+2|0}}return}if(A){F=c;G=b;H=0}else{F1a(c|0,0,e<<2|0)|0;return}while(1){f[F>>2]=0;c=0;b=0;do{b=(j[G+(c+a<<1)>>1]|0)-(j[G+(c<<1)>>1]|0)+b|0;c=c+e|0;f[F+(c<<2)>>2]=b}while((c|0)<(h|0));H=H+1|0;if((H|0)==(e|0))break;else{F=F+4|0;G=G+2|0}}return}}}}function Yna(a){a=a|0;PYa(a);return}function Zna(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function _na(a){a=a|0;PYa(a);return}function $na(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0;g=f[a+4>>2]|0;a=Y(g,e)|0;i=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;j=e<<1;k=0;do{p[c+(k<<3)>>3]=+(h[b+k>>0]|0)+ +(h[b+(k+e)>>0]|0)+ +(h[b+(k+j)>>0]|0);k=k+1|0}while((k|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;k=e*3|0;j=e<<2;l=0;do{p[c+(l<<3)>>3]=+(h[b+l>>0]|0)+ +(h[b+(l+e)>>0]|0)+ +(h[b+(l+d)>>0]|0)+ +(h[b+(l+k)>>0]|0)+ +(h[b+(l+j)>>0]|0);l=l+1|0}while((l|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){g=0;m=0.0;while(1){n=m+ +(h[b+g>>0]|0);g=g+1|0;if((g|0)==(a|0)){o=n;break}else m=n}}else o=0.0;p[c>>3]=o;if((i|0)>0){q=0;r=o}else return;do{r=r+(+(h[b+(q+a)>>0]|0)-+(h[b+q>>0]|0));q=q+1|0;p[c+(q<<3)>>3]=r}while((q|0)!=(i|0));return}case 3:{if((a|0)>0){q=0;r=0.0;o=0.0;m=0.0;while(1){n=r+ +(h[b+q>>0]|0);s=o+ +(h[b+(q+1)>>0]|0);t=m+ +(h[b+(q+2)>>0]|0);q=q+3|0;if((q|0)>=(a|0)){u=n;v=s;w=t;break}else{r=n;o=s;m=t}}}else{u=0.0;v=0.0;w=0.0}p[c>>3]=u;p[c+8>>3]=v;p[c+16>>3]=w;if((i|0)>0){x=0;y=u;z=v;A=w}else return;do{q=x+a|0;y=y+(+(h[b+q>>0]|0)-+(h[b+x>>0]|0));z=z+(+(h[b+(q+1)>>0]|0)-+(h[b+(x+1)>>0]|0));A=A+(+(h[b+(q+2)>>0]|0)-+(h[b+(x+2)>>0]|0));q=x;x=x+3|0;p[c+(x<<3)>>3]=y;p[c+(q+4<<3)>>3]=z;p[c+(q+5<<3)>>3]=A}while((x|0)<(i|0));return}case 4:{if((a|0)>0){x=0;A=0.0;z=0.0;y=0.0;w=0.0;while(1){v=A+ +(h[b+x>>0]|0);u=z+ +(h[b+(x|1)>>0]|0);m=y+ +(h[b+(x|2)>>0]|0);o=w+ +(h[b+(x|3)>>0]|0);x=x+4|0;if((x|0)>=(a|0)){B=v;C=u;D=m;E=o;break}else{A=v;z=u;y=m;w=o}}}else{B=0.0;C=0.0;D=0.0;E=0.0}p[c>>3]=B;p[c+8>>3]=C;p[c+16>>3]=D;p[c+24>>3]=E;if((i|0)>0){F=0;G=B;H=C;I=D;J=E}else return;do{x=F+a|0;G=G+(+(h[b+x>>0]|0)-+(h[b+F>>0]|0));H=H+(+(h[b+(x+1)>>0]|0)-+(h[b+(F|1)>>0]|0));I=I+(+(h[b+(x+2)>>0]|0)-+(h[b+(F|2)>>0]|0));J=J+(+(h[b+(x+3)>>0]|0)-+(h[b+(F|3)>>0]|0));x=F;F=F+4|0;p[c+(F<<3)>>3]=G;p[c+(x+5<<3)>>3]=H;p[c+(x+6<<3)>>3]=I;p[c+(x+7<<3)>>3]=J}while((F|0)<(i|0));return}default:{if((e|0)<=0)return;F=(i|0)>0;if((a|0)>0){x=c;q=b;g=0;while(1){l=0;J=0.0;do{J=J+ +(h[q+l>>0]|0);l=l+e|0}while((l|0)<(a|0));p[x>>3]=J;if(F){l=0;I=J;do{I=I+(+(h[q+(l+a)>>0]|0)-+(h[q+l>>0]|0));l=l+e|0;p[x+(l<<3)>>3]=I}while((l|0)<(i|0))}g=g+1|0;if((g|0)==(e|0))break;else{x=x+8|0;q=q+1|0}}return}if(F){K=c;L=b;M=0}else{F1a(c|0,0,e<<3|0)|0;return}while(1){p[K>>3]=0.0;c=0;I=0.0;do{I=I+(+(h[L+(c+a)>>0]|0)-+(h[L+c>>0]|0));c=c+e|0;p[K+(c<<3)>>3]=I}while((c|0)<(i|0));M=M+1|0;if((M|0)==(e|0))break;else{K=K+8|0;L=L+1|0}}return}}}}function aoa(a){a=a|0;PYa(a);return}function boa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function coa(a){a=a|0;PYa(a);return}function doa(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;a=Y(i,g)|0;j=Y(e+-1|0,g)|0;switch(i|0){case 3:{i=Y(g,e)|0;if((i|0)<=0)return;k=g<<1;l=0;do{d[c+(l<<1)>>1]=(h[b+(l+g)>>0]|0)+(h[b+l>>0]|0)+(h[b+(l+k)>>0]|0);l=l+1|0}while((l|0)!=(i|0));return}case 5:{i=Y(g,e)|0;if((i|0)<=0)return;e=g<<1;l=g*3|0;k=g<<2;m=0;do{d[c+(m<<1)>>1]=(h[b+(m+g)>>0]|0)+(h[b+m>>0]|0)+(h[b+(m+e)>>0]|0)+(h[b+(m+l)>>0]|0)+(h[b+(m+k)>>0]|0);m=m+1|0}while((m|0)!=(i|0));return}default:switch(g|0){case 1:{if((a|0)>0){i=0;m=0;do{m=(h[b+i>>0]|0)+(m&65535)|0;i=i+1|0}while((i|0)!=(a|0));n=m&65535}else n=0;d[c>>1]=n;if((j|0)>0){o=0;p=n}else return;do{p=(h[b+(o+a)>>0]|0)+(p&65535)-(h[b+o>>0]|0)&65535;o=o+1|0;d[c+(o<<1)>>1]=p}while((o|0)!=(j|0));return}case 3:{if((a|0)>0){o=0;p=0;n=0;m=0;do{p=(h[b+o>>0]|0)+(p&65535)|0;n=(h[b+(o+1)>>0]|0)+(n&65535)|0;m=(h[b+(o+2)>>0]|0)+(m&65535)|0;o=o+3|0}while((o|0)<(a|0));q=p&65535;r=n&65535;s=m&65535}else{q=0;r=0;s=0}d[c>>1]=q;d[c+2>>1]=r;d[c+4>>1]=s;if((j|0)>0){t=0;u=q;v=r;w=s}else return;do{s=t+a|0;u=(h[b+s>>0]|0)+(u&65535)-(h[b+t>>0]|0)&65535;v=(h[b+(s+1)>>0]|0)+(v&65535)-(h[b+(t+1)>>0]|0)&65535;w=(h[b+(s+2)>>0]|0)+(w&65535)-(h[b+(t+2)>>0]|0)&65535;s=t;t=t+3|0;d[c+(t<<1)>>1]=u;d[c+(s+4<<1)>>1]=v;d[c+(s+5<<1)>>1]=w}while((t|0)<(j|0));return}case 4:{if((a|0)>0){t=0;w=0;v=0;u=0;s=0;do{w=(h[b+t>>0]|0)+(w&65535)|0;v=(h[b+(t|1)>>0]|0)+(v&65535)|0;u=(h[b+(t|2)>>0]|0)+(u&65535)|0;s=(h[b+(t|3)>>0]|0)+(s&65535)|0;t=t+4|0}while((t|0)<(a|0));x=w&65535;y=v&65535;z=u&65535;A=s&65535}else{x=0;y=0;z=0;A=0}d[c>>1]=x;d[c+2>>1]=y;d[c+4>>1]=z;d[c+6>>1]=A;if((j|0)>0){B=0;C=x;D=y;E=z;F=A}else return;do{A=B+a|0;C=(h[b+A>>0]|0)+(C&65535)-(h[b+B>>0]|0)&65535;D=(h[b+(A+1)>>0]|0)+(D&65535)-(h[b+(B|1)>>0]|0)&65535;E=(h[b+(A+2)>>0]|0)+(E&65535)-(h[b+(B|2)>>0]|0)&65535;F=(h[b+(A+3)>>0]|0)+(F&65535)-(h[b+(B|3)>>0]|0)&65535;A=B;B=B+4|0;d[c+(B<<1)>>1]=C;d[c+(A+5<<1)>>1]=D;d[c+(A+6<<1)>>1]=E;d[c+(A+7<<1)>>1]=F}while((B|0)<(j|0));return}default:{if((g|0)<=0)return;B=(j|0)>0;if((a|0)>0){F=c;E=b;D=0;while(1){C=0;A=0;do{A=(h[E+C>>0]|0)+(A&65535)|0;C=C+g|0}while((C|0)<(a|0));d[F>>1]=A;if(B){C=0;z=A;do{z=(h[E+(C+a)>>0]|0)+(z&65535)-(h[E+C>>0]|0)|0;C=C+g|0;d[F+(C<<1)>>1]=z}while((C|0)<(j|0))}D=D+1|0;if((D|0)==(g|0))break;else{F=F+2|0;E=E+1|0}}return}if(B){G=c;H=b;I=0}else{F1a(c|0,0,g<<1|0)|0;return}while(1){d[G>>1]=0;c=0;b=0;do{b=(h[H+(c+a)>>0]|0)+(b&65535)-(h[H+c>>0]|0)|0;c=c+g|0;d[G+(c<<1)>>1]=b}while((c|0)<(j|0));I=I+1|0;if((I|0)==(g|0))break;else{G=G+2|0;H=H+1|0}}return}}}}function eoa(a){a=a|0;PYa(a);return}function foa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function goa(a){a=a|0;PYa(a);return}function hoa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=f[a+4>>2]|0;a=Y(g,e)|0;i=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;j=e<<1;k=0;do{f[c+(k<<2)>>2]=(h[b+(k+e)>>0]|0)+(h[b+k>>0]|0)+(h[b+(k+j)>>0]|0);k=k+1|0}while((k|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;k=e*3|0;j=e<<2;l=0;do{f[c+(l<<2)>>2]=(h[b+(l+e)>>0]|0)+(h[b+l>>0]|0)+(h[b+(l+d)>>0]|0)+(h[b+(l+k)>>0]|0)+(h[b+(l+j)>>0]|0);l=l+1|0}while((l|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){g=0;l=0;while(1){j=(h[b+g>>0]|0)+l|0;g=g+1|0;if((g|0)==(a|0)){m=j;break}else l=j}}else m=0;f[c>>2]=m;if((i|0)>0){n=0;o=m}else return;do{o=(h[b+(n+a)>>0]|0)-(h[b+n>>0]|0)+o|0;n=n+1|0;f[c+(n<<2)>>2]=o}while((n|0)!=(i|0));return}case 3:{if((a|0)>0){n=0;o=0;m=0;l=0;while(1){g=(h[b+n>>0]|0)+o|0;j=(h[b+(n+1)>>0]|0)+m|0;k=(h[b+(n+2)>>0]|0)+l|0;n=n+3|0;if((n|0)>=(a|0)){p=g;q=j;r=k;break}else{o=g;m=j;l=k}}}else{p=0;q=0;r=0}f[c>>2]=p;f[c+4>>2]=q;f[c+8>>2]=r;if((i|0)>0){s=0;t=p;u=q;v=r}else return;do{r=s+a|0;t=(h[b+r>>0]|0)-(h[b+s>>0]|0)+t|0;u=(h[b+(r+1)>>0]|0)-(h[b+(s+1)>>0]|0)+u|0;v=(h[b+(r+2)>>0]|0)-(h[b+(s+2)>>0]|0)+v|0;r=s;s=s+3|0;f[c+(s<<2)>>2]=t;f[c+(r+4<<2)>>2]=u;f[c+(r+5<<2)>>2]=v}while((s|0)<(i|0));return}case 4:{if((a|0)>0){s=0;v=0;u=0;t=0;r=0;while(1){q=(h[b+s>>0]|0)+v|0;p=(h[b+(s|1)>>0]|0)+u|0;l=(h[b+(s|2)>>0]|0)+t|0;m=(h[b+(s|3)>>0]|0)+r|0;s=s+4|0;if((s|0)>=(a|0)){w=q;x=p;y=l;z=m;break}else{v=q;u=p;t=l;r=m}}}else{w=0;x=0;y=0;z=0}f[c>>2]=w;f[c+4>>2]=x;f[c+8>>2]=y;f[c+12>>2]=z;if((i|0)>0){A=0;B=w;C=x;D=y;E=z}else return;do{z=A+a|0;B=(h[b+z>>0]|0)-(h[b+A>>0]|0)+B|0;C=(h[b+(z+1)>>0]|0)-(h[b+(A|1)>>0]|0)+C|0;D=(h[b+(z+2)>>0]|0)-(h[b+(A|2)>>0]|0)+D|0;E=(h[b+(z+3)>>0]|0)-(h[b+(A|3)>>0]|0)+E|0;z=A;A=A+4|0;f[c+(A<<2)>>2]=B;f[c+(z+5<<2)>>2]=C;f[c+(z+6<<2)>>2]=D;f[c+(z+7<<2)>>2]=E}while((A|0)<(i|0));return}default:{if((e|0)<=0)return;A=(i|0)>0;if((a|0)>0){E=c;D=b;C=0;while(1){B=0;z=0;do{z=(h[D+B>>0]|0)+z|0;B=B+e|0}while((B|0)<(a|0));f[E>>2]=z;if(A){B=0;y=z;do{y=(h[D+(B+a)>>0]|0)-(h[D+B>>0]|0)+y|0;B=B+e|0;f[E+(B<<2)>>2]=y}while((B|0)<(i|0))}C=C+1|0;if((C|0)==(e|0))break;else{E=E+4|0;D=D+1|0}}return}if(A){F=c;G=b;H=0}else{F1a(c|0,0,e<<2|0)|0;return}while(1){f[F>>2]=0;c=0;b=0;do{b=(h[G+(c+a)>>0]|0)-(h[G+c>>0]|0)+b|0;c=c+e|0;f[F+(c<<2)>>2]=b}while((c|0)<(i|0));H=H+1|0;if((H|0)==(e|0))break;else{F=F+4|0;G=G+1|0}}return}}}}function ioa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0.0,w=0,x=0;i=u;u=u+16|0;j=i;k=i+8|0;l=c&7;m=d&7;if((d^c)&4088|0){f[k>>2]=0;f[k+4>>2]=0;n=c$(k,90)|0;o=328485;q=n+90|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));j$(-215,k,328576,327502,1338);d$(k)}o=(g|0)<0?(e|0)/2|0:g;g=(m|0)==0;n=(l|0)==4;if(n&g){q=NYa(40)|0;w9(q);f[q>>2]=75692;f[q+28>>2]=0;f[q+32>>2]=0;f[q+36>>2]=0;f[q+4>>2]=e;f[q+8>>2]=o;p[q+16>>3]=h;f[q+24>>2]=0;r=NYa(16)|0;s=r+4|0;f[s>>2]=1;f[r>>2]=75716;f[r+8>>2]=q;f[a>>2]=r;f[a+4>>2]=q;f[s>>2]=(f[s>>2]|0)+1;q=f[s>>2]|0;f[s>>2]=q+-1;if((q|0)!=1){u=i;return}ki[f[(f[r>>2]|0)+8>>2]&2047](r);u=i;return}if((l|0)==2&g){r=NYa(48)|0;w9(r);f[r>>2]=75736;f[r+36>>2]=0;f[r+40>>2]=0;f[r+44>>2]=0;f[r+4>>2]=e;f[r+8>>2]=o;p[r+16>>3]=h;f[r+24>>2]=0;q=r+28|0;f[q>>2]=0;s=r+32|0;f[s>>2]=1;do if(h!=1.0){t=rNa(1.0/h)|0;v=8388608.0/+(t|0);w=~~v;x=w-(+(w|0)>v&1)|0;f[s>>2]=x;w=(t|0)/2|0;f[q>>2]=w;if(v-+(x|0)<.5){f[q>>2]=w+1;break}else{f[s>>2]=x+1;break}}while(0);s=NYa(16)|0;q=s+4|0;f[q>>2]=1;f[s>>2]=75760;f[s+8>>2]=r;f[a>>2]=s;f[a+4>>2]=r;f[q>>2]=(f[q>>2]|0)+1;r=f[q>>2]|0;f[q>>2]=r+-1;if((r|0)!=1){u=i;return}ki[f[(f[s>>2]|0)+8>>2]&2047](s);u=i;return}s=(l|0)==6;if(s&g){g=NYa(40)|0;w9(g);f[g>>2]=75780;f[g+28>>2]=0;f[g+32>>2]=0;f[g+36>>2]=0;f[g+4>>2]=e;f[g+8>>2]=o;p[g+16>>3]=h;f[g+24>>2]=0;l=NYa(16)|0;r=l+4|0;f[r>>2]=1;f[l>>2]=75804;f[l+8>>2]=g;f[a>>2]=l;f[a+4>>2]=g;f[r>>2]=(f[r>>2]|0)+1;g=f[r>>2]|0;f[r>>2]=g+-1;if((g|0)!=1){u=i;return}ki[f[(f[l>>2]|0)+8>>2]&2047](l);u=i;return}l=(m|0)==2;if(n&l){g=NYa(40)|0;w9(g);f[g>>2]=75824;f[g+28>>2]=0;f[g+32>>2]=0;f[g+36>>2]=0;f[g+4>>2]=e;f[g+8>>2]=o;p[g+16>>3]=h;f[g+24>>2]=0;r=NYa(16)|0;q=r+4|0;f[q>>2]=1;f[r>>2]=75848;f[r+8>>2]=g;f[a>>2]=r;f[a+4>>2]=g;f[q>>2]=(f[q>>2]|0)+1;g=f[q>>2]|0;f[q>>2]=g+-1;if((g|0)!=1){u=i;return}ki[f[(f[r>>2]|0)+8>>2]&2047](r);u=i;return}if(s&l){l=NYa(40)|0;w9(l);f[l>>2]=75868;f[l+28>>2]=0;f[l+32>>2]=0;f[l+36>>2]=0;f[l+4>>2]=e;f[l+8>>2]=o;p[l+16>>3]=h;f[l+24>>2]=0;r=NYa(16)|0;g=r+4|0;f[g>>2]=1;f[r>>2]=75892;f[r+8>>2]=l;f[a>>2]=r;f[a+4>>2]=l;f[g>>2]=(f[g>>2]|0)+1;l=f[g>>2]|0;f[g>>2]=l+-1;if((l|0)!=1){u=i;return}ki[f[(f[r>>2]|0)+8>>2]&2047](r);u=i;return}r=(m|0)==3;if(n&r){l=NYa(40)|0;w9(l);f[l>>2]=75912;f[l+28>>2]=0;f[l+32>>2]=0;f[l+36>>2]=0;f[l+4>>2]=e;f[l+8>>2]=o;p[l+16>>3]=h;f[l+24>>2]=0;g=NYa(16)|0;q=g+4|0;f[q>>2]=1;f[g>>2]=75936;f[g+8>>2]=l;f[a>>2]=g;f[a+4>>2]=l;f[q>>2]=(f[q>>2]|0)+1;l=f[q>>2]|0;f[q>>2]=l+-1;if((l|0)!=1){u=i;return}ki[f[(f[g>>2]|0)+8>>2]&2047](g);u=i;return}if(s&r){r=NYa(40)|0;w9(r);f[r>>2]=75956;f[r+28>>2]=0;f[r+32>>2]=0;f[r+36>>2]=0;f[r+4>>2]=e;f[r+8>>2]=o;p[r+16>>3]=h;f[r+24>>2]=0;g=NYa(16)|0;l=g+4|0;f[l>>2]=1;f[g>>2]=75980;f[g+8>>2]=r;f[a>>2]=g;f[a+4>>2]=r;f[l>>2]=(f[l>>2]|0)+1;r=f[l>>2]|0;f[l>>2]=r+-1;if((r|0)!=1){u=i;return}ki[f[(f[g>>2]|0)+8>>2]&2047](g);u=i;return}if(n&(m|0)==4){g=NYa(40)|0;w9(g);f[g>>2]=76e3;f[g+28>>2]=0;f[g+32>>2]=0;f[g+36>>2]=0;f[g+4>>2]=e;f[g+8>>2]=o;p[g+16>>3]=h;f[g+24>>2]=0;r=NYa(16)|0;l=r+4|0;f[l>>2]=1;f[r>>2]=76024;f[r+8>>2]=g;f[a>>2]=r;f[a+4>>2]=g;f[l>>2]=(f[l>>2]|0)+1;g=f[l>>2]|0;f[l>>2]=g+-1;if((g|0)!=1){u=i;return}ki[f[(f[r>>2]|0)+8>>2]&2047](r);u=i;return}r=(m|0)==5;if(n&r){g=NYa(40)|0;w9(g);f[g>>2]=76044;f[g+28>>2]=0;f[g+32>>2]=0;f[g+36>>2]=0;f[g+4>>2]=e;f[g+8>>2]=o;p[g+16>>3]=h;f[g+24>>2]=0;l=NYa(16)|0;q=l+4|0;f[q>>2]=1;f[l>>2]=76068;f[l+8>>2]=g;f[a>>2]=l;f[a+4>>2]=g;f[q>>2]=(f[q>>2]|0)+1;g=f[q>>2]|0;f[q>>2]=g+-1;if((g|0)!=1){u=i;return}ki[f[(f[l>>2]|0)+8>>2]&2047](l);u=i;return}if(s&r){r=NYa(40)|0;w9(r);f[r>>2]=76088;f[r+28>>2]=0;f[r+32>>2]=0;f[r+36>>2]=0;f[r+4>>2]=e;f[r+8>>2]=o;p[r+16>>3]=h;f[r+24>>2]=0;l=NYa(16)|0;g=l+4|0;f[g>>2]=1;f[l>>2]=76112;f[l+8>>2]=r;f[a>>2]=l;f[a+4>>2]=r;f[g>>2]=(f[g>>2]|0)+1;r=f[g>>2]|0;f[g>>2]=r+-1;if((r|0)!=1){u=i;return}ki[f[(f[l>>2]|0)+8>>2]&2047](l);u=i;return}l=(m|0)==6;if(n&l){n=NYa(40)|0;w9(n);f[n>>2]=76132;f[n+28>>2]=0;f[n+32>>2]=0;f[n+36>>2]=0;f[n+4>>2]=e;f[n+8>>2]=o;p[n+16>>3]=h;f[n+24>>2]=0;m=NYa(16)|0;r=m+4|0;f[r>>2]=1;f[m>>2]=76156;f[m+8>>2]=n;f[a>>2]=m;f[a+4>>2]=n;f[r>>2]=(f[r>>2]|0)+1;n=f[r>>2]|0;f[r>>2]=n+-1;if((n|0)!=1){u=i;return}ki[f[(f[m>>2]|0)+8>>2]&2047](m);u=i;return}if(!(s&l)){f[j>>2]=c;f[j+4>>2]=d;p$(k,328595,j);j$(-213,k,328576,327502,1370);d$(k);f[a>>2]=0;f[a+4>>2]=0;u=i;return}k=NYa(40)|0;w9(k);f[k>>2]=76176;f[k+28>>2]=0;f[k+32>>2]=0;f[k+36>>2]=0;f[k+4>>2]=e;f[k+8>>2]=o;p[k+16>>3]=h;f[k+24>>2]=0;o=NYa(16)|0;e=o+4|0;f[e>>2]=1;f[o>>2]=76200;f[o+8>>2]=k;f[a>>2]=o;f[a+4>>2]=k;f[e>>2]=(f[e>>2]|0)+1;k=f[e>>2]|0;f[e>>2]=k+-1;if((k|0)!=1){u=i;return}ki[f[(f[o>>2]|0)+8>>2]&2047](o);u=i;return}function joa(a){a=a|0;PYa(a);return}function koa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function loa(a){a=a|0;var b=0,c=0;f[a>>2]=76176;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function moa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=76176;b=f[a+28>>2]|0;if(!b){PYa(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function noa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;n=a+32|0;o=f[n>>2]|0;q=f[m>>2]|0;r=o-q>>3;s=q;if((r|0)==(h|0)){q=a+24|0;t=f[q>>2]|0;if(!t){v=s;w=q;x=9}else{q=a+4|0;y=f[q>>2]|0;if((t|0)==(y+-1|0))z=y;else{f[j>>2]=0;f[j+4>>2]=0;y=c$(j,19)|0;t=328741;A=y+19|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(A|0));j$(-215,j,373355,327502,226);d$(j);z=f[q>>2]|0}B=z;C=s;D=c+(z+-1<<2)|0}}else{z=o;if(r>>>0>=h>>>0)if(r>>>0>h>>>0?(o=s+(h<<3)|0,(z|0)!=(o|0)):0){f[n>>2]=z+(~((z+-8-o|0)>>>3)<<3);E=s}else E=s;else{Mfa(m,h-r|0);E=f[m>>2]|0}m=a+24|0;f[m>>2]=0;v=E;w=m;x=9}if((x|0)==9){F1a(v|0,0,h<<3|0)|0;x=f[w>>2]|0;m=f[a+4>>2]|0;a=m+-1|0;if((x|0)<(a|0)){if((h|0)>0){E=x;r=c;while(1){s=f[r>>2]|0;o=0;do{z=v+(o<<3)|0;p[z>>3]=+p[s+(o<<3)>>3]+ +p[z>>3];o=o+1|0}while((o|0)!=(h|0));o=E+1|0;s=r+4|0;if((o|0)<(a|0)){E=o;r=s}else{F=o;G=s;break}}}else{r=x+1|0;E=(a|0)>(r|0)?a:r;F=E;G=c+(E-x<<2)|0}f[w>>2]=F;B=m;C=v;D=G}else{B=m;C=v;D=c}}if(!g){u=i;return}c=1-B|0;B=h+-2|0;v=(h|0)<2;m=h&-2;G=g;g=d;d=D;while(1){G=G+-1|0;D=f[d>>2]|0;F=f[d+(c<<2)>>2]|0;if(l){if(v)H=0;else{w=0;do{x=C+(w<<3)|0;I=+p[x>>3]+ +p[D+(w<<3)>>3];E=w|1;r=C+(E<<3)|0;J=+p[r>>3]+ +p[D+(E<<3)>>3];p[g+(w<<3)>>3]=k*I;p[g+(E<<3)>>3]=k*J;K=J-+p[F+(E<<3)>>3];p[x>>3]=I-+p[F+(w<<3)>>3];p[r>>3]=K;w=w+2|0}while((w|0)<=(B|0));H=m}if((H|0)<(h|0)){w=H;do{r=C+(w<<3)|0;K=+p[r>>3]+ +p[D+(w<<3)>>3];p[g+(w<<3)>>3]=k*K;p[r>>3]=K-+p[F+(w<<3)>>3];w=w+1|0}while((w|0)!=(h|0))}}else{if(v)L=0;else{w=0;do{r=C+(w<<3)|0;K=+p[r>>3]+ +p[D+(w<<3)>>3];x=w|1;E=C+(x<<3)|0;I=+p[E>>3]+ +p[D+(x<<3)>>3];p[g+(w<<3)>>3]=K;p[g+(x<<3)>>3]=I;J=I-+p[F+(x<<3)>>3];p[r>>3]=K-+p[F+(w<<3)>>3];p[E>>3]=J;w=w+2|0}while((w|0)<=(B|0));L=m}if((L|0)<(h|0)){w=L;do{E=C+(w<<3)|0;J=+p[E>>3]+ +p[D+(w<<3)>>3];p[g+(w<<3)>>3]=J;p[E>>3]=J-+p[F+(w<<3)>>3];w=w+1|0}while((w|0)!=(h|0))}}if(!G)break;else{g=g+e|0;d=d+4|0}}u=i;return}function ooa(a){a=a|0;f[a+24>>2]=0;return}function poa(a){a=a|0;PYa(a);return}function qoa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function roa(a){a=a|0;var b=0,c=0;f[a>>2]=76132;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);PYa(b);return}function soa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=76132;b=f[a+28>>2]|0;if(!b){PYa(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b);PYa(a);return}function toa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;n=a+32|0;o=f[n>>2]|0;q=f[m>>2]|0;r=o-q>>2;s=q;if((r|0)==(h|0)){q=a+24|0;t=f[q>>2]|0;if(!t){v=s;w=q;x=9}else{q=a+4|0;y=f[q>>2]|0;if((t|0)==(y+-1|0))z=y;else{f[j>>2]=0;f[j+4>>2]=0;y=c$(j,19)|0;t=328741;A=y+19|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(A|0));j$(-215,j,373355,327502,226);d$(j);z=f[q>>2]|0}B=s;C=z;D=c+(z+-1<<2)|0}}else{z=o;if(r>>>0>=h>>>0)if(r>>>0>h>>>0?(o=s+(h<<2)|0,(z|0)!=(o|0)):0){f[n>>2]=z+(~((z+-4-o|0)>>>2)<<2);E=s}else E=s;else{GM(m,h-r|0);E=f[m>>2]|0}m=a+24|0;f[m>>2]=0;v=E;w=m;x=9}do if((x|0)==9){F1a(v|0,0,h<<2|0)|0;m=f[w>>2]|0;E=a+4|0;r=f[E>>2]|0;s=r+-1|0;if((m|0)<(s|0)){if((h|0)>0)F=c;else{o=m;m=c;do{o=o+1|0;m=m+4|0}while((o|0)<(s|0));f[w>>2]=o;B=v;C=r;D=m;break}while(1){s=f[F>>2]|0;z=0;do{n=v+(z<<2)|0;f[n>>2]=(f[n>>2]|0)+(f[s+(z<<2)>>2]|0);z=z+1|0}while((z|0)!=(h|0));z=(f[w>>2]|0)+1|0;f[w>>2]=z;s=F+4|0;n=f[E>>2]|0;if((z|0)<(n+-1|0))F=s;else{B=v;C=n;D=s;break}}}else{B=v;C=r;D=c}}while(0);if(!g){u=i;return}c=a+4|0;a=h+-2|0;v=(h|0)<2;F=h&-2;w=C;C=g;g=d;d=D;while(1){D=C+-1|0;x=f[d>>2]|0;E=f[d+(1-w<<2)>>2]|0;if(l){if(v)G=0;else{m=0;do{o=B+(m<<2)|0;s=(f[x+(m<<2)>>2]|0)+(f[o>>2]|0)|0;n=m|1;z=B+(n<<2)|0;q=(f[x+(n<<2)>>2]|0)+(f[z>>2]|0)|0;p[g+(m<<3)>>3]=k*+(s|0);p[g+(n<<3)>>3]=k*+(q|0);j=q-(f[E+(n<<2)>>2]|0)|0;f[o>>2]=s-(f[E+(m<<2)>>2]|0);f[z>>2]=j;m=m+2|0}while((m|0)<=(a|0));G=F}if((G|0)<(h|0)){m=G;do{r=B+(m<<2)|0;j=(f[x+(m<<2)>>2]|0)+(f[r>>2]|0)|0;p[g+(m<<3)>>3]=k*+(j|0);f[r>>2]=j-(f[E+(m<<2)>>2]|0);m=m+1|0}while((m|0)!=(h|0))}}else{if(v)H=0;else{m=0;do{j=B+(m<<2)|0;r=(f[x+(m<<2)>>2]|0)+(f[j>>2]|0)|0;z=m|1;s=B+(z<<2)|0;o=(f[x+(z<<2)>>2]|0)+(f[s>>2]|0)|0;p[g+(m<<3)>>3]=+(r|0);p[g+(z<<3)>>3]=+(o|0);n=o-(f[E+(z<<2)>>2]|0)|0;f[j>>2]=r-(f[E+(m<<2)>>2]|0);f[s>>2]=n;m=m+2|0}while((m|0)<=(a|0));H=F}if((H|0)<(h|0)){m=H;do{n=B+(m<<2)|0;s=(f[x+(m<<2)>>2]|0)+(f[n>>2]|0)|0;p[g+(m<<3)>>3]=+(s|0);f[n>>2]=s-(f[E+(m<<2)>>2]|0);m=m+1|0}while((m|0)!=(h|0))}}if(!D)break;w=f[c>>2]|0;C=D;g=g+e|0;d=d+4|0}u=i;return}function uoa(a){a=a|0;f[a+24>>2]=0;return}function voa(a){a=a|0;PYa(a);return}function woa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function xoa(a){a=a|0;var b=0,c=0;f[a>>2]=76088;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function yoa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=76088;b=f[a+28>>2]|0;if(!b){PYa(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function zoa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[m>>2]|0;s=q-r>>3;t=r;if((s|0)==(h|0)){r=a+24|0;v=f[r>>2]|0;if(!v){w=t;x=r;y=9}else{r=a+4|0;z=f[r>>2]|0;if((v|0)==(z+-1|0))A=z;else{f[j>>2]=0;f[j+4>>2]=0;z=c$(j,19)|0;v=328741;B=z+19|0;do{b[z>>0]=b[v>>0]|0;z=z+1|0;v=v+1|0}while((z|0)<(B|0));j$(-215,j,373355,327502,226);d$(j);A=f[r>>2]|0}C=A;D=t;E=c+(A+-1<<2)|0}}else{A=q;if(s>>>0>=h>>>0)if(s>>>0>h>>>0?(q=t+(h<<3)|0,(A|0)!=(q|0)):0){f[o>>2]=A+(~((A+-8-q|0)>>>3)<<3);F=t}else F=t;else{Mfa(m,h-s|0);F=f[m>>2]|0}m=a+24|0;f[m>>2]=0;w=F;x=m;y=9}if((y|0)==9){F1a(w|0,0,h<<3|0)|0;y=f[x>>2]|0;m=f[a+4>>2]|0;a=m+-1|0;if((y|0)<(a|0)){if((h|0)>0){F=y;s=c;while(1){t=f[s>>2]|0;q=0;do{A=w+(q<<3)|0;p[A>>3]=+p[t+(q<<3)>>3]+ +p[A>>3];q=q+1|0}while((q|0)!=(h|0));q=F+1|0;t=s+4|0;if((q|0)<(a|0)){F=q;s=t}else{G=q;H=t;break}}}else{s=y+1|0;F=(a|0)>(s|0)?a:s;G=F;H=c+(F-y<<2)|0}f[x>>2]=G;C=m;D=w;E=H}else{C=m;D=w;E=c}}if(!g){u=i;return}c=1-C|0;C=h+-2|0;w=(h|0)<2;m=h&-2;H=g;g=d;d=E;while(1){H=H+-1|0;E=f[d>>2]|0;G=f[d+(c<<2)>>2]|0;if(l){if(w)I=0;else{x=0;do{y=D+(x<<3)|0;J=+p[y>>3]+ +p[E+(x<<3)>>3];F=x|1;s=D+(F<<3)|0;K=+p[s>>3]+ +p[E+(F<<3)>>3];n[g+(x<<2)>>2]=k*J;n[g+(F<<2)>>2]=k*K;L=K-+p[G+(F<<3)>>3];p[y>>3]=J-+p[G+(x<<3)>>3];p[s>>3]=L;x=x+2|0}while((x|0)<=(C|0));I=m}if((I|0)<(h|0)){x=I;do{s=D+(x<<3)|0;L=+p[s>>3]+ +p[E+(x<<3)>>3];n[g+(x<<2)>>2]=k*L;p[s>>3]=L-+p[G+(x<<3)>>3];x=x+1|0}while((x|0)!=(h|0))}}else{if(w)M=0;else{x=0;do{s=D+(x<<3)|0;L=+p[s>>3]+ +p[E+(x<<3)>>3];y=x|1;F=D+(y<<3)|0;J=+p[F>>3]+ +p[E+(y<<3)>>3];n[g+(x<<2)>>2]=L;n[g+(y<<2)>>2]=J;K=J-+p[G+(y<<3)>>3];p[s>>3]=L-+p[G+(x<<3)>>3];p[F>>3]=K;x=x+2|0}while((x|0)<=(C|0));M=m}if((M|0)<(h|0)){x=M;do{F=D+(x<<3)|0;K=+p[F>>3]+ +p[E+(x<<3)>>3];n[g+(x<<2)>>2]=K;p[F>>3]=K-+p[G+(x<<3)>>3];x=x+1|0}while((x|0)!=(h|0))}}if(!H)break;else{g=g+e|0;d=d+4|0}}u=i;return}function Aoa(a){a=a|0;f[a+24>>2]=0;return}function Boa(a){a=a|0;PYa(a);return}function Coa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Doa(a){a=a|0;var b=0,c=0;f[a>>2]=76044;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);PYa(b);return}function Eoa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=76044;b=f[a+28>>2]|0;if(!b){PYa(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b);PYa(a);return}function Foa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[m>>2]|0;s=q-r>>2;t=r;if((s|0)==(h|0)){r=a+24|0;v=f[r>>2]|0;if(!v){w=t;x=r;y=9}else{r=a+4|0;z=f[r>>2]|0;if((v|0)==(z+-1|0))A=z;else{f[j>>2]=0;f[j+4>>2]=0;z=c$(j,19)|0;v=328741;B=z+19|0;do{b[z>>0]=b[v>>0]|0;z=z+1|0;v=v+1|0}while((z|0)<(B|0));j$(-215,j,373355,327502,984);d$(j);A=f[r>>2]|0}C=t;D=A;E=c+(A+-1<<2)|0}}else{A=q;if(s>>>0>=h>>>0)if(s>>>0>h>>>0?(q=t+(h<<2)|0,(A|0)!=(q|0)):0){f[o>>2]=A+(~((A+-4-q|0)>>>2)<<2);F=t}else F=t;else{GM(m,h-s|0);F=f[m>>2]|0}m=a+24|0;f[m>>2]=0;w=F;x=m;y=9}do if((y|0)==9){F1a(w|0,0,h<<2|0)|0;m=f[x>>2]|0;F=a+4|0;s=f[F>>2]|0;t=s+-1|0;if((m|0)<(t|0)){if((h|0)>0)G=c;else{q=m;m=c;do{q=q+1|0;m=m+4|0}while((q|0)<(t|0));f[x>>2]=q;C=w;D=s;E=m;break}while(1){t=f[G>>2]|0;A=0;do{o=w+(A<<2)|0;f[o>>2]=(f[o>>2]|0)+(f[t+(A<<2)>>2]|0);A=A+1|0}while((A|0)!=(h|0));A=(f[x>>2]|0)+1|0;f[x>>2]=A;t=G+4|0;o=f[F>>2]|0;if((A|0)<(o+-1|0))G=t;else{C=w;D=o;E=t;break}}}else{C=w;D=s;E=c}}while(0);c=g+-1|0;if(!g){u=i;return}g=a+4|0;a=(h|0)>0;if(l){l=D;w=c;G=d;x=E;while(1){y=f[x>>2]|0;F=f[x+(1-l<<2)>>2]|0;if(a){m=0;do{q=C+(m<<2)|0;t=(f[y+(m<<2)>>2]|0)+(f[q>>2]|0)|0;n[G+(m<<2)>>2]=k*+(t|0);f[q>>2]=t-(f[F+(m<<2)>>2]|0);m=m+1|0}while((m|0)!=(h|0))}if(!w)break;l=f[g>>2]|0;w=w+-1|0;G=G+e|0;x=x+4|0}u=i;return}if(a){H=D;I=c;J=d;K=E}else{u=i;return}while(1){E=f[K>>2]|0;d=f[K+(1-H<<2)>>2]|0;c=0;do{D=C+(c<<2)|0;a=(f[E+(c<<2)>>2]|0)+(f[D>>2]|0)|0;n[J+(c<<2)>>2]=+(a|0);f[D>>2]=a-(f[d+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(h|0));if(!I)break;H=f[g>>2]|0;I=I+-1|0;J=J+e|0;K=K+4|0}u=i;return}function Goa(a){a=a|0;f[a+24>>2]=0;return}function Hoa(a){a=a|0;PYa(a);return}function Ioa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Joa(a){a=a|0;var b=0,c=0;f[a>>2]=76e3;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);PYa(b);return}function Koa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=76e3;b=f[a+28>>2]|0;if(!b){PYa(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b);PYa(a);return}function Loa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;n=a+32|0;o=f[n>>2]|0;q=f[m>>2]|0;r=o-q>>2;s=q;if((r|0)==(h|0)){q=a+24|0;t=f[q>>2]|0;if(!t){v=s;w=q;x=9}else{q=a+4|0;y=f[q>>2]|0;if((t|0)==(y+-1|0))z=y;else{f[j>>2]=0;f[j+4>>2]=0;y=c$(j,19)|0;t=328741;A=y+19|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(A|0));j$(-215,j,373355,327502,864);d$(j);z=f[q>>2]|0}B=s;C=z;D=c+(z+-1<<2)|0}}else{z=o;if(r>>>0>=h>>>0)if(r>>>0>h>>>0?(o=s+(h<<2)|0,(z|0)!=(o|0)):0){f[n>>2]=z+(~((z+-4-o|0)>>>2)<<2);E=s}else E=s;else{GM(m,h-r|0);E=f[m>>2]|0}m=a+24|0;f[m>>2]=0;v=E;w=m;x=9}do if((x|0)==9){F1a(v|0,0,h<<2|0)|0;m=f[w>>2]|0;E=a+4|0;r=f[E>>2]|0;s=r+-1|0;if((m|0)<(s|0)){if((h|0)>0)F=c;else{o=m;m=c;do{o=o+1|0;m=m+4|0}while((o|0)<(s|0));f[w>>2]=o;B=v;C=r;D=m;break}while(1){s=f[F>>2]|0;z=0;do{n=v+(z<<2)|0;f[n>>2]=(f[n>>2]|0)+(f[s+(z<<2)>>2]|0);z=z+1|0}while((z|0)!=(h|0));z=(f[w>>2]|0)+1|0;f[w>>2]=z;s=F+4|0;n=f[E>>2]|0;if((z|0)<(n+-1|0))F=s;else{B=v;C=n;D=s;break}}}else{B=v;C=r;D=c}}while(0);c=g+-1|0;if(!g){u=i;return}g=a+4|0;a=(h|0)>0;if(l){l=C;v=c;F=d;w=D;while(1){x=f[w>>2]|0;E=f[w+(1-l<<2)>>2]|0;if(a){m=0;do{o=B+(m<<2)|0;s=(f[x+(m<<2)>>2]|0)+(f[o>>2]|0)|0;n=rNa(k*+(s|0))|0;f[F+(m<<2)>>2]=n;f[o>>2]=s-(f[E+(m<<2)>>2]|0);m=m+1|0}while((m|0)!=(h|0))}if(!v)break;l=f[g>>2]|0;v=v+-1|0;F=F+e|0;w=w+4|0}u=i;return}if(a){G=C;H=c;I=d;J=D}else{u=i;return}while(1){D=f[J>>2]|0;d=f[J+(1-G<<2)>>2]|0;c=0;do{C=B+(c<<2)|0;a=(f[D+(c<<2)>>2]|0)+(f[C>>2]|0)|0;f[I+(c<<2)>>2]=a;f[C>>2]=a-(f[d+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(h|0));if(!H)break;G=f[g>>2]|0;H=H+-1|0;I=I+e|0;J=J+4|0}u=i;return}function Moa(a){a=a|0;f[a+24>>2]=0;return}function Noa(a){a=a|0;PYa(a);return}function Ooa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Poa(a){a=a|0;var b=0,c=0;f[a>>2]=75956;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function Qoa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=75956;b=f[a+28>>2]|0;if(!b){PYa(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function Roa(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0;j=u;u=u+16|0;k=j;l=+p[a+16>>3];m=l!=1.0;n=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[n>>2]|0;s=q-r>>3;t=r;if((s|0)==(i|0)){r=a+24|0;v=f[r>>2]|0;if(!v){w=t;x=r;y=9}else{r=a+4|0;z=f[r>>2]|0;if((v|0)==(z+-1|0))A=z;else{f[k>>2]=0;f[k+4>>2]=0;z=c$(k,19)|0;v=328741;B=z+19|0;do{b[z>>0]=b[v>>0]|0;z=z+1|0;v=v+1|0}while((z|0)<(B|0));j$(-215,k,373355,327502,226);d$(k);A=f[r>>2]|0}C=A;D=t;E=c+(A+-1<<2)|0}}else{A=q;if(s>>>0>=i>>>0)if(s>>>0>i>>>0?(q=t+(i<<3)|0,(A|0)!=(q|0)):0){f[o>>2]=A+(~((A+-8-q|0)>>>3)<<3);F=t}else F=t;else{Mfa(n,i-s|0);F=f[n>>2]|0}n=a+24|0;f[n>>2]=0;w=F;x=n;y=9}if((y|0)==9){F1a(w|0,0,i<<3|0)|0;y=f[x>>2]|0;n=f[a+4>>2]|0;a=n+-1|0;if((y|0)<(a|0)){if((i|0)>0){F=y;s=c;while(1){t=f[s>>2]|0;q=0;do{A=w+(q<<3)|0;p[A>>3]=+p[t+(q<<3)>>3]+ +p[A>>3];q=q+1|0}while((q|0)!=(i|0));q=F+1|0;t=s+4|0;if((q|0)<(a|0)){F=q;s=t}else{G=q;H=t;break}}}else{s=y+1|0;F=(a|0)>(s|0)?a:s;G=F;H=c+(F-y<<2)|0}f[x>>2]=G;C=n;D=w;E=H}else{C=n;D=w;E=c}}if(!h){u=j;return}c=1-C|0;C=i+-2|0;w=(i|0)<2;n=i&-2;H=h;h=e;e=E;while(1){H=H+-1|0;E=f[e>>2]|0;G=f[e+(c<<2)>>2]|0;if(m){if(w)I=0;else{x=0;do{y=D+(x<<3)|0;J=+p[y>>3]+ +p[E+(x<<3)>>3];F=x|1;s=D+(F<<3)|0;K=+p[s>>3]+ +p[E+(F<<3)>>3];a=rNa(l*J)|0;d[h+(x<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=rNa(l*K)|0;d[h+(F<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;L=K-+p[G+(F<<3)>>3];p[y>>3]=J-+p[G+(x<<3)>>3];p[s>>3]=L;x=x+2|0}while((x|0)<=(C|0));I=n}if((I|0)<(i|0)){x=I;do{s=D+(x<<3)|0;L=+p[s>>3]+ +p[E+(x<<3)>>3];y=rNa(l*L)|0;d[h+(x<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;p[s>>3]=L-+p[G+(x<<3)>>3];x=x+1|0}while((x|0)!=(i|0))}}else{if(w)M=0;else{x=0;do{s=D+(x<<3)|0;L=+p[s>>3]+ +p[E+(x<<3)>>3];y=x|1;F=D+(y<<3)|0;J=+p[F>>3]+ +p[E+(y<<3)>>3];a=rNa(L)|0;d[h+(x<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=rNa(J)|0;d[h+(y<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;K=J-+p[G+(y<<3)>>3];p[s>>3]=L-+p[G+(x<<3)>>3];p[F>>3]=K;x=x+2|0}while((x|0)<=(C|0));M=n}if((M|0)<(i|0)){x=M;do{F=D+(x<<3)|0;K=+p[F>>3]+ +p[E+(x<<3)>>3];s=rNa(K)|0;d[h+(x<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;p[F>>3]=K-+p[G+(x<<3)>>3];x=x+1|0}while((x|0)!=(i|0))}}if(!H)break;else{h=h+g|0;e=e+4|0}}u=j;return}function Soa(a){a=a|0;f[a+24>>2]=0;return}function Toa(a){a=a|0;PYa(a);return}function Uoa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Voa(a){a=a|0;var b=0,c=0;f[a>>2]=75912;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);PYa(b);return}function Woa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=75912;b=f[a+28>>2]|0;if(!b){PYa(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b);PYa(a);return}function Xoa(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=u;u=u+16|0;k=j;l=+p[a+16>>3];m=l!=1.0;n=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[n>>2]|0;s=q-r>>2;t=r;if((s|0)==(i|0)){r=a+24|0;v=f[r>>2]|0;if(!v){w=t;x=r;y=9}else{r=a+4|0;z=f[r>>2]|0;if((v|0)==(z+-1|0))A=z;else{f[k>>2]=0;f[k+4>>2]=0;z=c$(k,19)|0;v=328741;B=z+19|0;do{b[z>>0]=b[v>>0]|0;z=z+1|0;v=v+1|0}while((z|0)<(B|0));j$(-215,k,373355,327502,612);d$(k);A=f[r>>2]|0}C=t;D=A;E=c+(A+-1<<2)|0}}else{A=q;if(s>>>0>=i>>>0)if(s>>>0>i>>>0?(q=t+(i<<2)|0,(A|0)!=(q|0)):0){f[o>>2]=A+(~((A+-4-q|0)>>>2)<<2);F=t}else F=t;else{GM(n,i-s|0);F=f[n>>2]|0}n=a+24|0;f[n>>2]=0;w=F;x=n;y=9}do if((y|0)==9){F1a(w|0,0,i<<2|0)|0;n=f[x>>2]|0;F=a+4|0;s=f[F>>2]|0;t=s+-1|0;if((n|0)<(t|0)){if((i|0)>0)G=c;else{q=n;n=c;do{q=q+1|0;n=n+4|0}while((q|0)<(t|0));f[x>>2]=q;C=w;D=s;E=n;break}while(1){t=f[G>>2]|0;A=0;do{o=w+(A<<2)|0;f[o>>2]=(f[o>>2]|0)+(f[t+(A<<2)>>2]|0);A=A+1|0}while((A|0)!=(i|0));A=(f[x>>2]|0)+1|0;f[x>>2]=A;t=G+4|0;o=f[F>>2]|0;if((A|0)<(o+-1|0))G=t;else{C=w;D=o;E=t;break}}}else{C=w;D=s;E=c}}while(0);c=h+-1|0;if(!h){u=j;return}h=a+4|0;a=(i|0)>0;if(m){m=D;w=c;G=e;x=E;while(1){y=f[x>>2]|0;F=f[x+(1-m<<2)>>2]|0;if(a){n=0;do{q=C+(n<<2)|0;t=(f[y+(n<<2)>>2]|0)+(f[q>>2]|0)|0;o=rNa(l*+(t|0))|0;d[G+(n<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;f[q>>2]=t-(f[F+(n<<2)>>2]|0);n=n+1|0}while((n|0)!=(i|0))}if(!w)break;m=f[h>>2]|0;w=w+-1|0;G=G+g|0;x=x+4|0}u=j;return}else{x=D;D=c;c=e;e=E;while(1){E=f[e>>2]|0;G=f[e+(1-x<<2)>>2]|0;if(a){w=0;do{m=C+(w<<2)|0;n=(f[E+(w<<2)>>2]|0)+(f[m>>2]|0)|0;d[c+(w<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;f[m>>2]=n-(f[G+(w<<2)>>2]|0);w=w+1|0}while((w|0)!=(i|0))}if(!D)break;x=f[h>>2]|0;D=D+-1|0;c=c+g|0;e=e+4|0}u=j;return}}function Yoa(a){a=a|0;f[a+24>>2]=0;return}function Zoa(a){a=a|0;PYa(a);return}function _oa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function $oa(a){a=a|0;var b=0,c=0;f[a>>2]=75868;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function apa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=75868;b=f[a+28>>2]|0;if(!b){PYa(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function bpa(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0;j=u;u=u+16|0;k=j;l=+p[a+16>>3];m=l!=1.0;n=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[n>>2]|0;s=q-r>>3;t=r;if((s|0)==(i|0)){r=a+24|0;v=f[r>>2]|0;if(!v){w=t;x=r;y=9}else{r=a+4|0;z=f[r>>2]|0;if((v|0)==(z+-1|0))A=z;else{f[k>>2]=0;f[k+4>>2]=0;z=c$(k,19)|0;v=328741;B=z+19|0;do{b[z>>0]=b[v>>0]|0;z=z+1|0;v=v+1|0}while((z|0)<(B|0));j$(-215,k,373355,327502,226);d$(k);A=f[r>>2]|0}C=A;D=t;E=c+(A+-1<<2)|0}}else{A=q;if(s>>>0>=i>>>0)if(s>>>0>i>>>0?(q=t+(i<<3)|0,(A|0)!=(q|0)):0){f[o>>2]=A+(~((A+-8-q|0)>>>3)<<3);F=t}else F=t;else{Mfa(n,i-s|0);F=f[n>>2]|0}n=a+24|0;f[n>>2]=0;w=F;x=n;y=9}if((y|0)==9){F1a(w|0,0,i<<3|0)|0;y=f[x>>2]|0;n=f[a+4>>2]|0;a=n+-1|0;if((y|0)<(a|0)){if((i|0)>0){F=y;s=c;while(1){t=f[s>>2]|0;q=0;do{A=w+(q<<3)|0;p[A>>3]=+p[t+(q<<3)>>3]+ +p[A>>3];q=q+1|0}while((q|0)!=(i|0));q=F+1|0;t=s+4|0;if((q|0)<(a|0)){F=q;s=t}else{G=q;H=t;break}}}else{s=y+1|0;F=(a|0)>(s|0)?a:s;G=F;H=c+(F-y<<2)|0}f[x>>2]=G;C=n;D=w;E=H}else{C=n;D=w;E=c}}if(!h){u=j;return}c=1-C|0;C=i+-2|0;w=(i|0)<2;n=i&-2;H=h;h=e;e=E;while(1){H=H+-1|0;E=f[e>>2]|0;G=f[e+(c<<2)>>2]|0;if(m){if(w)I=0;else{x=0;do{y=D+(x<<3)|0;J=+p[y>>3]+ +p[E+(x<<3)>>3];F=x|1;s=D+(F<<3)|0;K=+p[s>>3]+ +p[E+(F<<3)>>3];a=rNa(l*J)|0;d[h+(x<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=rNa(l*K)|0;d[h+(F<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;L=K-+p[G+(F<<3)>>3];p[y>>3]=J-+p[G+(x<<3)>>3];p[s>>3]=L;x=x+2|0}while((x|0)<=(C|0));I=n}if((I|0)<(i|0)){x=I;do{s=D+(x<<3)|0;L=+p[s>>3]+ +p[E+(x<<3)>>3];y=rNa(l*L)|0;d[h+(x<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;p[s>>3]=L-+p[G+(x<<3)>>3];x=x+1|0}while((x|0)!=(i|0))}}else{if(w)M=0;else{x=0;do{s=D+(x<<3)|0;L=+p[s>>3]+ +p[E+(x<<3)>>3];y=x|1;F=D+(y<<3)|0;J=+p[F>>3]+ +p[E+(y<<3)>>3];a=rNa(L)|0;d[h+(x<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=rNa(J)|0;d[h+(y<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;K=J-+p[G+(y<<3)>>3];p[s>>3]=L-+p[G+(x<<3)>>3];p[F>>3]=K;x=x+2|0}while((x|0)<=(C|0));M=n}if((M|0)<(i|0)){x=M;do{F=D+(x<<3)|0;K=+p[F>>3]+ +p[E+(x<<3)>>3];s=rNa(K)|0;d[h+(x<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;p[F>>3]=K-+p[G+(x<<3)>>3];x=x+1|0}while((x|0)!=(i|0))}}if(!H)break;else{h=h+g|0;e=e+4|0}}u=j;return}function cpa(a){a=a|0;f[a+24>>2]=0;return}function dpa(a){a=a|0;PYa(a);return}function epa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function fpa(a){a=a|0;var b=0,c=0;f[a>>2]=75824;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);PYa(b);return}function gpa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=75824;b=f[a+28>>2]|0;if(!b){PYa(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b);PYa(a);return}function hpa(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=u;u=u+16|0;k=j;l=+p[a+16>>3];m=l!=1.0;n=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[n>>2]|0;s=q-r>>2;t=r;if((s|0)==(i|0)){r=a+24|0;v=f[r>>2]|0;if(!v){w=t;x=r;y=9}else{r=a+4|0;z=f[r>>2]|0;if((v|0)==(z+-1|0))A=z;else{f[k>>2]=0;f[k+4>>2]=0;z=c$(k,19)|0;v=328741;B=z+19|0;do{b[z>>0]=b[v>>0]|0;z=z+1|0;v=v+1|0}while((z|0)<(B|0));j$(-215,k,373355,327502,739);d$(k);A=f[r>>2]|0}C=t;D=A;E=c+(A+-1<<2)|0}}else{A=q;if(s>>>0>=i>>>0)if(s>>>0>i>>>0?(q=t+(i<<2)|0,(A|0)!=(q|0)):0){f[o>>2]=A+(~((A+-4-q|0)>>>2)<<2);F=t}else F=t;else{GM(n,i-s|0);F=f[n>>2]|0}n=a+24|0;f[n>>2]=0;w=F;x=n;y=9}do if((y|0)==9){F1a(w|0,0,i<<2|0)|0;n=f[x>>2]|0;F=a+4|0;s=f[F>>2]|0;t=s+-1|0;if((n|0)<(t|0)){if((i|0)>0)G=c;else{q=n;n=c;do{q=q+1|0;n=n+4|0}while((q|0)<(t|0));f[x>>2]=q;C=w;D=s;E=n;break}while(1){t=f[G>>2]|0;A=0;do{o=w+(A<<2)|0;f[o>>2]=(f[o>>2]|0)+(f[t+(A<<2)>>2]|0);A=A+1|0}while((A|0)!=(i|0));A=(f[x>>2]|0)+1|0;f[x>>2]=A;t=G+4|0;o=f[F>>2]|0;if((A|0)<(o+-1|0))G=t;else{C=w;D=o;E=t;break}}}else{C=w;D=s;E=c}}while(0);c=h+-1|0;if(!h){u=j;return}h=a+4|0;a=(i|0)>0;if(m){m=D;w=c;G=e;x=E;while(1){y=f[x>>2]|0;F=f[x+(1-m<<2)>>2]|0;if(a){n=0;do{q=C+(n<<2)|0;t=(f[y+(n<<2)>>2]|0)+(f[q>>2]|0)|0;o=rNa(l*+(t|0))|0;d[G+(n<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;f[q>>2]=t-(f[F+(n<<2)>>2]|0);n=n+1|0}while((n|0)!=(i|0))}if(!w)break;m=f[h>>2]|0;w=w+-1|0;G=G+g|0;x=x+4|0}u=j;return}else{x=D;D=c;c=e;e=E;while(1){E=f[e>>2]|0;G=f[e+(1-x<<2)>>2]|0;if(a){w=0;do{m=C+(w<<2)|0;n=(f[E+(w<<2)>>2]|0)+(f[m>>2]|0)|0;d[c+(w<<1)>>1]=n>>>0<65536?n:(n|0)>0?65535:0;f[m>>2]=n-(f[G+(w<<2)>>2]|0);w=w+1|0}while((w|0)!=(i|0))}if(!D)break;x=f[h>>2]|0;D=D+-1|0;c=c+g|0;e=e+4|0}u=j;return}}function ipa(a){a=a|0;f[a+24>>2]=0;return}function jpa(a){a=a|0;PYa(a);return}function kpa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function lpa(a){a=a|0;var b=0,c=0;f[a>>2]=75780;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-8-b|0)>>>3)<<3);PYa(b);return}function mpa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=75780;b=f[a+28>>2]|0;if(!b){PYa(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);PYa(b);PYa(a);return}function npa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;n=a+32|0;o=f[n>>2]|0;q=f[m>>2]|0;r=o-q>>3;s=q;if((r|0)==(h|0)){q=a+24|0;t=f[q>>2]|0;if(!t){v=s;w=q;x=9}else{q=a+4|0;y=f[q>>2]|0;if((t|0)==(y+-1|0))z=y;else{f[j>>2]=0;f[j+4>>2]=0;y=c$(j,19)|0;t=328741;A=y+19|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(A|0));j$(-215,j,373355,327502,226);d$(j);z=f[q>>2]|0}B=s;C=z;D=c+(z+-1<<2)|0}}else{z=o;if(r>>>0>=h>>>0)if(r>>>0>h>>>0?(o=s+(h<<3)|0,(z|0)!=(o|0)):0){f[n>>2]=z+(~((z+-8-o|0)>>>3)<<3);E=s}else E=s;else{Mfa(m,h-r|0);E=f[m>>2]|0}m=a+24|0;f[m>>2]=0;v=E;w=m;x=9}if((x|0)==9){F1a(v|0,0,h<<3|0)|0;x=f[w>>2]|0;m=f[a+4>>2]|0;E=m+-1|0;if((x|0)<(E|0)){if((h|0)>0){r=x;s=c;while(1){o=f[s>>2]|0;z=0;do{n=v+(z<<3)|0;p[n>>3]=+p[o+(z<<3)>>3]+ +p[n>>3];z=z+1|0}while((z|0)!=(h|0));z=r+1|0;o=s+4|0;if((z|0)<(E|0)){r=z;s=o}else{F=z;G=o;break}}}else{s=x+1|0;r=(E|0)>(s|0)?E:s;F=r;G=c+(r-x<<2)|0}f[w>>2]=F;B=v;C=m;D=G}else{B=v;C=m;D=c}}if(!g){u=i;return}c=a+4|0;a=h+-2|0;m=(h|0)<2;v=h&-2;G=C;C=g;g=d;d=D;while(1){D=C+-1|0;F=f[d>>2]|0;w=f[d+(1-G<<2)>>2]|0;if(l){if(m)H=0;else{x=0;do{r=B+(x<<3)|0;I=+p[r>>3]+ +p[F+(x<<3)>>3];s=x|1;E=B+(s<<3)|0;J=+p[E>>3]+ +p[F+(s<<3)>>3];o=rNa(k*I)|0;b[g+x>>0]=o>>>0<256?o:(o|0)>0?255:0;o=rNa(k*J)|0;b[g+s>>0]=o>>>0<256?o:(o|0)>0?255:0;K=J-+p[w+(s<<3)>>3];p[r>>3]=I-+p[w+(x<<3)>>3];p[E>>3]=K;x=x+2|0}while((x|0)<=(a|0));H=v}if((H|0)<(h|0)){x=H;do{E=B+(x<<3)|0;K=+p[E>>3]+ +p[F+(x<<3)>>3];r=rNa(k*K)|0;b[g+x>>0]=r>>>0<256?r:(r|0)>0?255:0;p[E>>3]=K-+p[w+(x<<3)>>3];x=x+1|0}while((x|0)!=(h|0))}}else{if(m)L=0;else{x=0;do{E=B+(x<<3)|0;K=+p[E>>3]+ +p[F+(x<<3)>>3];r=x|1;s=B+(r<<3)|0;I=+p[s>>3]+ +p[F+(r<<3)>>3];o=rNa(K)|0;b[g+x>>0]=o>>>0<256?o:(o|0)>0?255:0;o=rNa(I)|0;b[g+r>>0]=o>>>0<256?o:(o|0)>0?255:0;J=I-+p[w+(r<<3)>>3];p[E>>3]=K-+p[w+(x<<3)>>3];p[s>>3]=J;x=x+2|0}while((x|0)<=(a|0));L=v}if((L|0)<(h|0)){x=L;do{s=B+(x<<3)|0;J=+p[s>>3]+ +p[F+(x<<3)>>3];E=rNa(J)|0;b[g+x>>0]=E>>>0<256?E:(E|0)>0?255:0;p[s>>3]=J-+p[w+(x<<3)>>3];x=x+1|0}while((x|0)!=(h|0))}}if(!D)break;G=f[c>>2]|0;C=D;g=g+e|0;d=d+4|0}u=i;return}function opa(a){a=a|0;f[a+24>>2]=0;return}function ppa(a){a=a|0;PYa(a);return}function qpa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function rpa(a){a=a|0;var b=0,c=0;f[a>>2]=75736;b=f[a+36>>2]|0;if(!b)return;c=a+40|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-2-b|0)>>>1)<<1);PYa(b);return}function spa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=75736;b=f[a+36>>2]|0;if(!b){PYa(a);return}c=a+40|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-2-b|0)>>>1)<<1);PYa(b);PYa(a);return}function tpa(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=u;u=u+16|0;l=k;m=f[a+32>>2]|0;n=f[a+28>>2]|0;o=+p[a+16>>3]!=1.0;q=a+36|0;r=a+40|0;s=f[r>>2]|0;t=f[q>>2]|0;v=s-t>>1;w=t;if((v|0)==(i|0)){t=a+24|0;x=f[t>>2]|0;if(!x){y=w;z=t;A=9}else{t=a+4|0;B=f[t>>2]|0;if((x|0)==(B+-1|0))C=B;else{f[l>>2]=0;f[l+4>>2]=0;B=c$(l,19)|0;x=328741;D=B+19|0;do{b[B>>0]=b[x>>0]|0;B=B+1|0;x=x+1|0}while((B|0)<(D|0));j$(-215,l,373355,327502,483);d$(l);C=f[t>>2]|0}E=w;F=C;G=c+(C+-1<<2)|0}}else{C=s;if(v>>>0>=i>>>0)if(v>>>0>i>>>0?(s=w+(i<<1)|0,(C|0)!=(s|0)):0){f[r>>2]=C+(~((C+-2-s|0)>>>1)<<1);H=w}else H=w;else{vpa(q,i-v|0);H=f[q>>2]|0}q=a+24|0;f[q>>2]=0;y=H;z=q;A=9}if((A|0)==9){F1a(y|0,0,i<<1|0)|0;A=f[z>>2]|0;q=f[a+4>>2]|0;H=q+-1|0;if((A|0)<(H|0)){if((i|0)>0){v=A;w=c;while(1){s=f[w>>2]|0;C=0;do{r=y+(C<<1)|0;d[r>>1]=(j[r>>1]|0)+(j[s+(C<<1)>>1]|0);C=C+1|0}while((C|0)!=(i|0));C=v+1|0;s=w+4|0;if((C|0)<(H|0)){v=C;w=s}else{I=C;J=s;break}}}else{w=A+1|0;v=(H|0)>(w|0)?H:w;I=v;J=c+(v-A<<2)|0}f[z>>2]=I;E=y;F=q;G=J}else{E=y;F=q;G=c}}c=h+-1|0;if(!h){u=k;return}h=a+4|0;a=(i|0)>0;if(o){o=F;q=c;y=e;J=G;while(1){I=f[J>>2]|0;z=f[J+(1-o<<2)>>2]|0;if(a){A=0;do{v=E+(A<<1)|0;w=(j[I+(A<<1)>>1]|0)+(j[v>>1]|0)|0;H=(Y(w+n|0,m)|0)>>>23&255;b[y+A>>0]=H;d[v>>1]=w-(j[z+(A<<1)>>1]|0);A=A+1|0}while((A|0)!=(i|0))}if(!q)break;o=f[h>>2]|0;q=q+-1|0;y=y+g|0;J=J+4|0}u=k;return}else{J=F;F=c;c=e;e=G;while(1){G=f[e>>2]|0;y=f[e+(1-J<<2)>>2]|0;if(a){q=0;do{o=E+(q<<1)|0;m=(j[G+(q<<1)>>1]|0)+(j[o>>1]|0)|0;b[c+q>>0]=m>>>0<256?m:m|0?255:0;d[o>>1]=m-(j[y+(q<<1)>>1]|0);q=q+1|0}while((q|0)!=(i|0))}if(!F)break;J=f[h>>2]|0;F=F+-1|0;c=c+g|0;e=e+4|0}u=k;return}}function upa(a){a=a|0;f[a+24>>2]=0;return}function vpa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>1>>>0>=b>>>0){F1a(g|0,0,b<<1|0)|0;f[e>>2]=g+(b<<1);return}h=f[a>>2]|0;i=g-h|0;g=i>>1;j=g+b|0;if((j|0)<0)gXa(a);k=d-h|0;d=k>>1>>>0<1073741823?(k>>>0<j>>>0?j:k):2147483647;do if(d)if((d|0)<0){k=De(8)|0;UYa(k,358155);f[k>>2]=130560;Of(k|0,21520,875)}else{l=NYa(d<<1)|0;break}else l=0;while(0);k=l+(g<<1)|0;F1a(k|0,0,b<<1|0)|0;j=k+(0-g<<1)|0;if((i|0)>0)K1a(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=k+(b<<1);f[c>>2]=l+(d<<1);if(!h)return;PYa(h);return}function wpa(a){a=a|0;PYa(a);return}function xpa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)ki[f[(f[b>>2]|0)+4>>2]&2047](b);ki[f[(f[a>>2]|0)+4>>2]&2047](a);return}function ypa(a){a=a|0;var b=0,c=0;f[a>>2]=75692;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);PYa(b);return}function zpa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=75692;b=f[a+28>>2]|0;if(!b){PYa(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);PYa(b);PYa(a);return}function Apa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;n=a+32|0;o=f[n>>2]|0;q=f[m>>2]|0;r=o-q>>2;s=q;if((r|0)==(h|0)){q=a+24|0;t=f[q>>2]|0;if(!t){v=s;w=q;x=9}else{q=a+4|0;y=f[q>>2]|0;if((t|0)==(y+-1|0))z=y;else{f[j>>2]=0;f[j+4>>2]=0;y=c$(j,19)|0;t=328741;A=y+19|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(A|0));j$(-215,j,373355,327502,335);d$(j);z=f[q>>2]|0}B=s;C=z;D=c+(z+-1<<2)|0}}else{z=o;if(r>>>0>=h>>>0)if(r>>>0>h>>>0?(o=s+(h<<2)|0,(z|0)!=(o|0)):0){f[n>>2]=z+(~((z+-4-o|0)>>>2)<<2);E=s}else E=s;else{GM(m,h-r|0);E=f[m>>2]|0}m=a+24|0;f[m>>2]=0;v=E;w=m;x=9}do if((x|0)==9){F1a(v|0,0,h<<2|0)|0;m=f[w>>2]|0;E=a+4|0;r=f[E>>2]|0;s=r+-1|0;if((m|0)<(s|0)){if((h|0)>0)F=c;else{o=m;m=c;do{o=o+1|0;m=m+4|0}while((o|0)<(s|0));f[w>>2]=o;B=v;C=r;D=m;break}while(1){s=f[F>>2]|0;z=0;do{n=v+(z<<2)|0;f[n>>2]=(f[n>>2]|0)+(f[s+(z<<2)>>2]|0);z=z+1|0}while((z|0)!=(h|0));z=(f[w>>2]|0)+1|0;f[w>>2]=z;s=F+4|0;n=f[E>>2]|0;if((z|0)<(n+-1|0))F=s;else{B=v;C=n;D=s;break}}}else{B=v;C=r;D=c}}while(0);c=g+-1|0;if(!g){u=i;return}g=a+4|0;a=(h|0)>0;if(l){l=C;v=c;F=d;w=D;while(1){x=f[w>>2]|0;E=f[w+(1-l<<2)>>2]|0;if(a){m=0;do{o=B+(m<<2)|0;s=(f[x+(m<<2)>>2]|0)+(f[o>>2]|0)|0;n=rNa(k*+(s|0))|0;b[F+m>>0]=n>>>0<256?n:(n|0)>0?255:0;f[o>>2]=s-(f[E+(m<<2)>>2]|0);m=m+1|0}while((m|0)!=(h|0))}if(!v)break;l=f[g>>2]|0;v=v+-1|0;F=F+e|0;w=w+4|0}u=i;return}else{w=C;C=c;c=d;d=D;while(1){D=f[d>>2]|0;F=f[d+(1-w<<2)>>2]|0;if(a){v=0;do{l=B+(v<<2)|0;m=(f[D+(v<<2)>>2]|0)+(f[l>>2]|0)|0;b[c+v>>0]=m>>>0<256?m:(m|0)>0?255:0;f[l>>2]=m-(f[F+(v<<2)>>2]|0);v=v+1|0}while((v|0)!=(h|0))}if(!C)break;w=f[g>>2]|0;C=C+-1|0;c=c+e|0;d=d+4|0}u=i;return}}function Bpa(a){a=a|0;f[a+24>>2]=0;return}function Cpa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0;i=u;u=u+64|0;j=i;k=i+48|0;l=i+40|0;m=i+32|0;n=b&7;o=b&4088;p=(n|0)==0;if(p)if((c&7|0)==0?(Y(f[d+4>>2]|0,f[d>>2]|0)|0)<257:0)q=2;else r=5;else if(n>>>0<5)r=5;else q=6;do if((r|0)==5){if(g?(s=Y(f[d+4>>2]|0,f[d>>2]|0)|0,(s|0)>((p?8388608:(n|0)==2?32768:65536)|0)):0){q=6;break}q=4}while(0);n=q|o;vna(k,b,n,f[d>>2]|0,f[e>>2]|0);o=f[d+4>>2]|0;if(g)t=1.0/+(Y(f[d>>2]|0,o)|0);else t=1.0;ioa(l,n,c,o,f[e+4>>2]|0,t);f[m>>2]=0;f[m+4>>2]=0;e=NYa(200)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;y9(e,m,k,l,b,c,n,h,-1,j);j=NYa(16)|0;f[j+4>>2]=1;f[j>>2]=58548;f[j+8>>2]=e;f[a>>2]=j;f[a+4>>2]=e;e=f[m>>2]|0;if(e|0?(m=e+4|0,a=f[m>>2]|0,f[m>>2]=a+-1,(a|0)==1):0)ki[f[(f[e>>2]|0)+8>>2]&2047](e);e=f[l>>2]|0;if(e|0?(l=e+4|0,a=f[l>>2]|0,f[l>>2]=a+-1,(a|0)==1):0)ki[f[(f[e>>2]|0)+8>>2]&2047](e);e=f[k>>2]|0;if(!e){u=i;return}k=e+4|0;a=f[k>>2]|0;f[k>>2]=a+-1;if((a|0)!=1){u=i;return}ki[f[(f[e>>2]|0)+8>>2]&2047](e);u=i;return}function Dpa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;i=u;u=u+176|0;j=i+160|0;k=i+104|0;l=i+40|0;m=i+48|0;n=i+32|0;o=i+24|0;p=i+16|0;q=i+8|0;r=i;_$(j,76212);do if((NS(a)|0)==65536){s=f[a+4>>2]|0;f[k>>2]=f[s>>2];t=k+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=k+8|0;f[w>>2]=f[s+8>>2];f[k+12>>2]=f[s+12>>2];f[k+16>>2]=f[s+16>>2];f[k+20>>2]=f[s+20>>2];f[k+24>>2]=f[s+24>>2];f[k+28>>2]=f[s+28>>2];f[k+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[k+36>>2]=x;y=k+40|0;f[y>>2]=w;w=k+48|0;z=k+44|0;f[z>>2]=w;f[w>>2]=0;f[k+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[z>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];A=k;B=y;break}else{f[t>>2]=0;BR(k,s);A=k;B=y;break}}else{OR(k,a,-1);A=k;B=k+40|0}while(0);a=f[A>>2]|0;y=f[B>>2]|0;s=f[y>>2]|0;f[l>>2]=f[y+4>>2];f[l+4>>2]=s;KS(b,l,((c|0)<0?a:c)&7|a&4088,-1,0,0);do if((NS(b)|0)==65536){a=f[b+4>>2]|0;f[m>>2]=f[a>>2];c=m+4|0;l=a+4|0;f[c>>2]=f[l>>2];s=m+8|0;f[s>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];y=f[a+36>>2]|0;f[m+36>>2]=y;f[m+40>>2]=s;s=m+48|0;t=m+44|0;f[t>>2]=s;f[s>>2]=0;f[m+52>>2]=0;if(y|0){s=y+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[l>>2]|0)<3){l=f[a+44>>2]|0;s=f[t>>2]|0;f[s>>2]=f[l>>2];f[s+4>>2]=f[l+4>>2];break}else{f[c>>2]=0;BR(m,a);break}}else OR(m,b,-1);while(0);b=(h&16|0)==0;if(!(b|g^1)){a=f[k+8>>2]|0;if((a|0)==1)f[d+4>>2]=1;c=f[k+12>>2]|0;if((c|0)==1){f[d>>2]=1;C=1;D=a}else{C=c;D=a}}else{C=f[k+12>>2]|0;D=f[k+8>>2]|0}f[n>>2]=0;f[n+4>>2]=0;f[o>>2]=C;f[o+4>>2]=D;if(b)KR(k,o,n);b=f[A>>2]&4095;A=f[m>>2]&4095;f[q>>2]=f[d>>2];f[q+4>>2]=f[d+4>>2];f[r>>2]=f[e>>2];f[r+4>>2]=f[e+4>>2];Cpa(p,b,A,q,r,g,h&-17);h=f[p+4>>2]|0;Bh[f[(f[h>>2]|0)+20>>2]&255](h,k,m,o,n);n=f[p>>2]|0;if(n|0?(p=n+4|0,o=f[p>>2]|0,f[p>>2]=o+-1,(o|0)==1):0)ki[f[(f[n>>2]|0)+8>>2]&2047](n);n=m+36|0;o=f[n>>2]|0;if(o|0?(p=o+12|0,o=f[p>>2]|0,f[p>>2]=o+-1,(o|0)==1):0)CR(m);f[n>>2]=0;n=m+16|0;o=m+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[o>>2]|0)>0){n=f[m+40>>2]|0;p=0;do{f[n+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[o>>2]|0))}o=f[m+44>>2]|0;if((o|0)!=(m+48|0))ZF(o);o=k+36|0;m=f[o>>2]|0;if(m|0?(p=m+12|0,m=f[p>>2]|0,f[p>>2]=m+-1,(m|0)==1):0)CR(k);f[o>>2]=0;o=k+16|0;m=k+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[m>>2]|0)>0){o=f[B>>2]|0;B=0;do{f[o+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[m>>2]|0))}m=f[k+44>>2]|0;if((m|0)!=(k+48|0))ZF(m);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function Epa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;_$(h,76232);f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];Dpa(a,b,-1,i,j,1,e);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function Fpa(a,c,d,e){a=a|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0.0;g=u;u=u+16|0;h=g;i=d<=0.0&((c|0)<8&((c|0)%2|0|0)==1)?76252+((c>>1)*28|0)|0:0;j=(e|0)==5;if((e+-5|0)>>>0>=2){f[h>>2]=0;f[h+4>>2]=0;k=c$(h,24)|0;l=329923;m=k+24|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,h,329948,327502,1723);d$(h)}f[a>>2]=1124007936;l=a+8|0;o=a+40|0;k=a+4|0;m=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(m|0));f[o>>2]=l;l=a+48|0;f[a+44>>2]=l;f[l>>2]=0;f[a+52>>2]=0;f[h>>2]=c;f[h+4>>2]=1;AR(a,2,h,e&4095);e=f[a+16>>2]|0;q=+(c+-1|0)*.5;r=d>0.0?d:(q+-1.0)*.3+.8;d=-.5/(r*r);a=(c|0)>0;if(!a){u=g;return}if(i)if(j){h=0;r=0.0;while(1){s=+n[i+(h<<2)>>2];n[e+(h<<2)>>2]=s;t=r+s;h=h+1|0;if((h|0)==(c|0)){v=t;break}else r=t}}else{h=0;r=0.0;while(1){t=+n[i+(h<<2)>>2];p[e+(h<<3)>>3]=t;s=r+t;h=h+1|0;if((h|0)==(c|0)){v=s;break}else r=s}}else{h=0;r=0.0;while(1){s=+(h|0)-q;t=+V(+(s*(d*s)));if(j){s=t;n[e+(h<<2)>>2]=s;w=s}else{p[e+(h<<3)>>3]=t;w=t}t=r+w;h=h+1|0;if((h|0)==(c|0)){v=t;break}else r=t}}r=1.0/v;if(!a){u=g;return}if(j){j=0;do{a=e+(j<<2)|0;n[a>>2]=r*+n[a>>2];j=j+1|0}while((j|0)!=(c|0));u=g;return}else{j=0;do{a=e+(j<<3)|0;p[a>>3]=r*+p[a>>3];j=j+1|0}while((j|0)!=(c|0));u=g;return}}function Gpa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;var i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;i=u;u=u+64|0;j=i;k=d&7;l=!(h<=0.0)?h:g;d=f[e>>2]|0;if(g>0.0&(d|0)<1){m=rNa(((k|0)==0?3.0:4.0)*g*2.0+1.0)|0|1;f[e>>2]=m;n=m}else n=d;d=e+4|0;m=f[d>>2]|0;if(l>0.0&(m|0)<1){o=rNa(((k|0)==0?3.0:4.0)*l*2.0+1.0)|0|1;f[d>>2]=o;p=o}else p=m;if((n|0)>0&((n|0)%2|0|0)==1?(p|0)>0&((p|0)%2|0|0)==1:0)q=n;else{f[j>>2]=0;f[j+4>>2]=0;n=c$(j,84)|0;p=329966;m=n+84|0;do{b[n>>0]=b[p>>0]|0;n=n+1|0;p=p+1|0}while((n|0)<(m|0));j$(-215,j,330051,327502,1777);d$(j);q=f[e>>2]|0}h=g<0.0?0.0:g;g=l<0.0?0.0:l;p=k>>>0>5?k:5;Fpa(j,q,h,p);if((j|0)==(a|0)){r=f[a+36>>2]|0;s=j+36|0}else{q=j+36|0;k=f[q>>2]|0;if(k|0){n=k+12|0;f[n>>2]=(f[n>>2]|0)+1}n=a+36|0;k=f[n>>2]|0;if(k|0?(m=k+12|0,k=f[m>>2]|0,f[m>>2]=k+-1,(k|0)==1):0)CR(a);f[n>>2]=0;k=a+16|0;m=a+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[m>>2]|0)>0){o=f[a+40>>2]|0;t=0;do{f[o+(t<<2)>>2]=0;t=t+1|0;v=f[m>>2]|0}while((t|0)<(v|0));f[a>>2]=f[j>>2];if((v|0)<3)w=20;else w=22}else{f[a>>2]=f[j>>2];w=20}if((w|0)==20){v=f[j+4>>2]|0;if((v|0)<3){f[m>>2]=v;f[a+8>>2]=f[j+8>>2];f[a+12>>2]=f[j+12>>2];v=f[j+44>>2]|0;m=f[a+44>>2]|0;f[m>>2]=f[v>>2];f[m+4>>2]=f[v+4>>2]}else w=22}if((w|0)==22)BR(a,j);f[k>>2]=f[j+16>>2];f[a+20>>2]=f[j+20>>2];f[a+24>>2]=f[j+24>>2];f[a+28>>2]=f[j+28>>2];f[a+32>>2]=f[j+32>>2];k=f[q>>2]|0;f[n>>2]=k;r=k;s=q}if(r|0?(q=r+12|0,r=f[q>>2]|0,f[q>>2]=r+-1,(r|0)==1):0)CR(j);f[s>>2]=0;s=j+16|0;r=j+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[r>>2]|0)>0){s=f[j+40>>2]|0;q=0;do{f[s+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[r>>2]|0))}r=f[j+44>>2]|0;if((r|0)!=(j+48|0))ZF(r);r=f[d>>2]|0;if((r|0)==(f[e>>2]|0)?+L(+(h-g))<2.220446049250313e-16:0){if((c|0)==(a|0)){u=i;return}e=a+36|0;d=f[e>>2]|0;if(d|0){q=d+12|0;f[q>>2]=(f[q>>2]|0)+1}q=c+36|0;d=f[q>>2]|0;if(d|0?(s=d+12|0,d=f[s>>2]|0,f[s>>2]=d+-1,(d|0)==1):0)CR(c);f[q>>2]=0;d=c+16|0;s=c+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[s>>2]|0)>0){k=f[c+40>>2]|0;n=0;do{f[k+(n<<2)>>2]=0;n=n+1|0;x=f[s>>2]|0}while((n|0)<(x|0));f[c>>2]=f[a>>2];if((x|0)<3)w=45;else w=47}else{f[c>>2]=f[a>>2];w=45}if((w|0)==45){x=f[a+4>>2]|0;if((x|0)<3){f[s>>2]=x;f[c+8>>2]=f[a+8>>2];f[c+12>>2]=f[a+12>>2];x=f[a+44>>2]|0;s=f[c+44>>2]|0;f[s>>2]=f[x>>2];f[s+4>>2]=f[x+4>>2]}else w=47}if((w|0)==47)BR(c,a);f[d>>2]=f[a+16>>2];f[c+20>>2]=f[a+20>>2];f[c+24>>2]=f[a+24>>2];f[c+28>>2]=f[a+28>>2];f[c+32>>2]=f[a+32>>2];f[q>>2]=f[e>>2];u=i;return}Fpa(j,r,g,p);if((j|0)==(c|0)){y=f[c+36>>2]|0;z=j+36|0}else{p=j+36|0;r=f[p>>2]|0;if(r|0){e=r+12|0;f[e>>2]=(f[e>>2]|0)+1}e=c+36|0;r=f[e>>2]|0;if(r|0?(q=r+12|0,r=f[q>>2]|0,f[q>>2]=r+-1,(r|0)==1):0)CR(c);f[e>>2]=0;r=c+16|0;q=c+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[q>>2]|0)>0){a=f[c+40>>2]|0;d=0;do{f[a+(d<<2)>>2]=0;d=d+1|0;A=f[q>>2]|0}while((d|0)<(A|0));f[c>>2]=f[j>>2];if((A|0)<3)w=61;else w=63}else{f[c>>2]=f[j>>2];w=61}if((w|0)==61){A=f[j+4>>2]|0;if((A|0)<3){f[q>>2]=A;f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];A=f[j+44>>2]|0;q=f[c+44>>2]|0;f[q>>2]=f[A>>2];f[q+4>>2]=f[A+4>>2]}else w=63}if((w|0)==63)BR(c,j);f[r>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[c+24>>2]=f[j+24>>2];f[c+28>>2]=f[j+28>>2];f[c+32>>2]=f[j+32>>2];c=f[p>>2]|0;f[e>>2]=c;y=c;z=p}if(y|0?(p=y+12|0,y=f[p>>2]|0,f[p>>2]=y+-1,(y|0)==1):0)CR(j);f[z>>2]=0;z=j+16|0;y=j+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[y>>2]|0)>0){z=f[j+40>>2]|0;p=0;do{f[z+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[y>>2]|0))}y=f[j+44>>2]|0;if((y|0)!=(j+48|0))ZF(y);u=i;return}function Hpa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+192|0;i=h+176|0;j=h+168|0;k=h+104|0;l=h+112|0;m=h+48|0;n=h+8|0;o=h+32|0;p=h+16|0;q=h;_$(i,76364);r=RR(a,-1)|0;QR(j,a,-1);f[k>>2]=f[j>>2];s=j+4|0;f[k+4>>2]=f[s>>2];KS(b,k,r,-1,0,0);if(g&16|0){if((f[s>>2]|0)==1)f[c+4>>2]=1;if((f[j>>2]|0)==1)f[c>>2]=1}if((f[c>>2]|0)==1?(f[c+4>>2]|0)==1:0)ZS(a,b);else{a:do if((vU()|0?(NS(b)|0)==655360:0)?(nS(a,-1)|0)<3:0){switch(f[c>>2]|0){case 3:{if((f[c+4>>2]|0)!=3)break a;break}case 5:{if((f[c+4>>2]|0)!=5)break a;break}default:break a}j=RS(a,-1)|0;if((j|0)>(f[c+4>>2]|0))SS(a,-1)|0}while(0);f[l>>2]=1124007936;j=l+4|0;s=l+8|0;k=l+40|0;t=j;v=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));f[k>>2]=s;s=l+48|0;w=l+44|0;f[w>>2]=s;f[s>>2]=0;f[l+52>>2]=0;f[m>>2]=1124007936;x=m+4|0;y=m+8|0;z=m+40|0;t=x;v=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));f[z>>2]=y;y=m+48|0;t=m+44|0;f[t>>2]=y;f[y>>2]=0;f[m+52>>2]=0;f[n>>2]=f[c>>2];f[n+4>>2]=f[c+4>>2];Gpa(l,m,r,n,d,e);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=l;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=m;f[q>>2]=-1;f[q+4>>2]=-1;ifa(a,b,r&7,o,p,q,0.0,g);g=m+36|0;q=f[g>>2]|0;if(q|0?(p=q+12|0,q=f[p>>2]|0,f[p>>2]=q+-1,(q|0)==1):0)CR(m);f[g>>2]=0;g=m+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[x>>2]|0)>0){g=f[z>>2]|0;z=0;do{f[g+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[x>>2]|0))}x=f[t>>2]|0;if((x|0)!=(y|0))ZF(x);x=l+36|0;y=f[x>>2]|0;if(y|0?(t=y+12|0,y=f[t>>2]|0,f[t>>2]=y+-1,(y|0)==1):0)CR(l);f[x>>2]=0;x=l+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[j>>2]|0)>0){x=f[k>>2]|0;k=0;do{f[x+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[j>>2]|0))}j=f[w>>2]|0;if((j|0)!=(s|0))ZF(j)}if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function Ipa(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0.0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0.0,nc=0.0,oc=0,pc=0,qc=0.0,rc=0,sc=0;g=u;u=u+6608|0;i=g+4096|0;k=g;l=g+6272|0;m=g+6584|0;o=g+6576|0;p=g+6572|0;q=g+6568|0;r=g+6552|0;t=g+6548|0;v=g+6544|0;w=g+6540|0;x=g+6536|0;y=g+6532|0;z=g+6528|0;A=g+6524|0;B=g+6520|0;C=g+6516|0;D=g+6512|0;E=g+6508|0;F=g+6504|0;G=g+6500|0;H=g+6496|0;I=g+6492|0;J=g+6488|0;K=g+6484|0;L=g+6480|0;M=g+6472|0;N=g+6416|0;O=g+6560|0;P=g+6360|0;Q=g+6304|0;_$(M,76384);if(!(((e|0)%2|0|0)==1?(nS(a,-1)|0)<3:0)){f[i>>2]=0;f[i+4>>2]=0;R=c$(i,40)|0;S=330147;T=R+40|0;do{b[R>>0]=b[S>>0]|0;R=R+1|0;S=S+1|0}while((R|0)<(T|0));j$(-215,i,330188,327502,3111);d$(i)}if((e|0)>=2?!(XS(a)|0):0){do if((NS(a)|0)==65536){U=f[a+4>>2]|0;f[N>>2]=f[U>>2];V=N+4|0;W=U+4|0;f[V>>2]=f[W>>2];X=N+8|0;f[X>>2]=f[U+8>>2];f[N+12>>2]=f[U+12>>2];f[N+16>>2]=f[U+16>>2];f[N+20>>2]=f[U+20>>2];f[N+24>>2]=f[U+24>>2];f[N+28>>2]=f[U+28>>2];f[N+32>>2]=f[U+32>>2];Z=f[U+36>>2]|0;f[N+36>>2]=Z;_=N+40|0;f[_>>2]=X;X=N+48|0;$=N+44|0;f[$>>2]=X;f[X>>2]=0;f[N+52>>2]=0;if(Z|0){X=Z+12|0;f[X>>2]=(f[X>>2]|0)+1}if((f[W>>2]|0)<3){W=f[U+44>>2]|0;X=f[$>>2]|0;f[X>>2]=f[W>>2];f[X+4>>2]=f[W+4>>2];aa=N;ba=_;break}else{f[V>>2]=0;BR(N,U);aa=N;ba=_;break}}else{OR(N,a,-1);aa=N;ba=N+40|0}while(0);_=f[ba>>2]|0;U=f[_>>2]|0;f[O>>2]=f[_+4>>2];f[O+4>>2]=U;KS(c,O,f[aa>>2]&4095,-1,0,0);do if((NS(c)|0)==65536){O=f[c+4>>2]|0;f[P>>2]=f[O>>2];U=P+4|0;_=O+4|0;f[U>>2]=f[_>>2];V=P+8|0;f[V>>2]=f[O+8>>2];f[P+12>>2]=f[O+12>>2];f[P+16>>2]=f[O+16>>2];f[P+20>>2]=f[O+20>>2];f[P+24>>2]=f[O+24>>2];f[P+28>>2]=f[O+28>>2];f[P+32>>2]=f[O+32>>2];W=f[O+36>>2]|0;f[P+36>>2]=W;f[P+40>>2]=V;V=P+48|0;X=P+44|0;f[X>>2]=V;f[V>>2]=0;f[P+52>>2]=0;if(W|0){V=W+12|0;f[V>>2]=(f[V>>2]|0)+1}if((f[_>>2]|0)<3){_=f[O+44>>2]|0;V=f[X>>2]|0;f[V>>2]=f[_>>2];f[V+4>>2]=f[_+4>>2];break}else{f[U>>2]=0;BR(P,O);break}}else OR(P,c,-1);while(0);switch(e|0){case 3:{ca=1;break}case 5:{O=f[aa>>2]|0;if(!(O&7)){U=(O>>>3&511)+1|0;ca=(U|0)==2|U>>>0>4}else ca=1;break}default:ca=0}f[Q>>2]=1124007936;U=Q+4|0;O=Q+8|0;_=Q+40|0;R=U;T=R+36|0;do{f[R>>2]=0;R=R+4|0}while((R|0)<(T|0));f[_>>2]=O;V=Q+48|0;X=Q+44|0;f[X>>2]=V;f[V>>2]=0;f[Q+52>>2]=0;a:do if(!ca){f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=N;W=k+8|0;f[W>>2]=0;f[W+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=Q;W=(e|0)/2|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;mL(i,k,0,0,W,W,1,l);if(!(f[Q>>2]&7))switch((f[aa>>2]|0)>>>3&511){case 0:case 2:case 3:break;default:da=143}else da=143;if((da|0)==143){f[i>>2]=0;f[i+4>>2]=0;R=c$(i,51)|0;S=330199;T=R+51|0;do{b[R>>0]=b[S>>0]|0;R=R+1|0;S=S+1|0}while((R|0)<(T|0));j$(-215,i,330188,327502,3168);d$(i)}$=f[N+4>>2]|0;if(($|0)<3)ea=Y(f[N+12>>2]|0,f[N+8>>2]|0)|0;else{Z=f[ba>>2]|0;fa=0;ga=1;while(1){ha=Y(f[Z+(fa<<2)>>2]|0,ga)|0;fa=fa+1|0;if((fa|0)==($|0)){ea=ha;break}else ga=ha}}ia=+(ea>>>0)*9.5367431640625e-07;if(((ia<1.0?39:ia<4.0?21:9)|0)>=(e|0)){ga=(Y(e,e)|0)>>>1;$=f[P+40>>2]|0;fa=f[$+4>>2]|0;Z=f[$>>2]|0;$=f[Q+16>>2]|0;ha=f[P+16>>2]|0;ja=f[V>>2]|0;ka=f[P+48>>2]|0;la=(f[Q>>2]|0)>>>3;ma=la&511;na=ma+1|0;oa=$+(Y(ja,Z)|0)|0;if(ma>>>0>=4){f[l>>2]=0;f[l+4>>2]=0;R=c$(l,17)|0;S=330251;T=R+17|0;do{b[R>>0]=b[S>>0]|0;R=R+1|0;S=S+1|0}while((R|0)<(T|0));j$(-215,l,330269,327502,2406);d$(l)}if((fa|0)>0){ma=Z+-1|0;pa=Y(ja,ma)|0;qa=Y(ka,ma)|0;ra=0-ja|0;sa=0-ka|0;ta=na<<6;ua=na<<10;va=(e|0)<-1;wa=(Z|0)>0;xa=la&65535;ya=e<<2;za=(e|0)>0;Aa=e*3|0;Ba=Y(na,e)|0;Ca=(Ba|0)>0;Da=W+1|0;Ea=(ja|0)!=0;Fa=ha;Ga=$;Ha=0;while(1){Ia=(Ha&1|0)==0;Ja=Ia?ka:sa;Ka=Ia?ja:ra;La=Ia?Ga:Ga+pa|0;Ma=Ia?Fa:Fa+qa|0;F1a(i|0,0,ta|0)|0;F1a(k|0,0,ua|0)|0;b:do if(va)Na=La;else{Ia=(Ka|0)>0;if(Ca){Oa=La;Pa=0}else{Qa=La;Ra=0;while(1){if(Ia)if((Ra|0)<(ma|0))da=172;else Sa=Qa;else if(Ea&(Z-Ra|0)>1)da=172;else Sa=Qa;if((da|0)==172){da=0;Sa=Qa+Ka|0}if((Ra|0)<(W|0)){Qa=Sa;Ra=Ra+1|0}else{Na=Sa;break b}}}while(1){if((Pa|0)>0){Ra=0;do{Qa=0;do{Ta=h[Oa+(Qa+Ra)>>0]|0;Ua=k+(Ra<<10)+(Ta<<2)|0;f[Ua>>2]=(f[Ua>>2]|0)+1;Ua=i+(Ra<<6)+(Ta>>>4<<2)|0;f[Ua>>2]=(f[Ua>>2]|0)+1;Qa=Qa+na|0}while((Qa|0)<(Ba|0));Ra=Ra+1|0}while((Ra|0)!=(na|0))}else{Ra=0;do{Qa=0;do{Ua=h[Oa+(Qa+Ra)>>0]|0;Ta=k+(Ra<<10)+(Ua<<2)|0;f[Ta>>2]=(f[Ta>>2]|0)+Da;Ta=i+(Ra<<6)+(Ua>>>4<<2)|0;f[Ta>>2]=(f[Ta>>2]|0)+Da;Qa=Qa+na|0}while((Qa|0)<(Ba|0));Ra=Ra+1|0}while((Ra|0)!=(na|0))}if(Ia)if((Pa|0)<(ma|0))da=162;else Va=Oa;else if(Ea&(Z-Pa|0)>1)da=162;else Va=Oa;if((da|0)==162){da=0;Va=Oa+Ka|0}if((Pa|0)<(W|0)){Oa=Va;Pa=Pa+1|0}else{Na=Va;break}}}while(0);c:do if(wa){Ia=(Ka|0)>-1;Ra=(Ka|0)<1;Qa=Ma;Ta=Na;Ua=La;Wa=0;while(1){Xa=0;do{Ya=0;Za=0;while(1){_a=(f[i+(Xa<<6)+(Ya<<2)>>2]|0)+Za|0;if((_a|0)>(ga|0))break;else{Ya=Ya+1|0;Za=_a}}_a=Ya<<4;$a=Za;while(1){$a=(f[k+(Xa<<10)+(_a<<2)>>2]|0)+$a|0;if(($a|0)>(ga|0))break;else _a=_a+1|0}b[Qa+Xa>>0]=_a;Xa=Xa+1|0}while((Xa|0)!=(na|0));Xa=Wa+1|0;if((Xa|0)==(Z|0))break c;d:do switch(xa&511){case 0:{if(za)ab=0;else break d;do{$a=h[Ua+ab>>0]|0;Za=h[Ta+ab>>0]|0;Ya=k+($a<<2)|0;f[Ya>>2]=(f[Ya>>2]|0)+-1;Ya=i+($a>>>4<<2)|0;f[Ya>>2]=(f[Ya>>2]|0)+-1;Ya=k+(Za<<2)|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=i+(Za>>>4<<2)|0;f[Ya>>2]=(f[Ya>>2]|0)+1;ab=ab+1|0}while((ab|0)!=(e|0));break}case 2:{if(za)bb=0;else break d;do{_a=h[Ua+bb>>0]|0;Ya=k+(_a<<2)|0;f[Ya>>2]=(f[Ya>>2]|0)+-1;Ya=i+(_a>>>4<<2)|0;f[Ya>>2]=(f[Ya>>2]|0)+-1;Ya=bb+1|0;_a=h[Ua+Ya>>0]|0;Za=k+1024+(_a<<2)|0;f[Za>>2]=(f[Za>>2]|0)+-1;Za=i+64+(_a>>>4<<2)|0;f[Za>>2]=(f[Za>>2]|0)+-1;Za=bb+2|0;_a=h[Ua+Za>>0]|0;$a=k+2048+(_a<<2)|0;f[$a>>2]=(f[$a>>2]|0)+-1;$a=i+128+(_a>>>4<<2)|0;f[$a>>2]=(f[$a>>2]|0)+-1;$a=h[Ta+bb>>0]|0;_a=k+($a<<2)|0;f[_a>>2]=(f[_a>>2]|0)+1;_a=i+($a>>>4<<2)|0;f[_a>>2]=(f[_a>>2]|0)+1;_a=h[Ta+Ya>>0]|0;Ya=k+1024+(_a<<2)|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=i+64+(_a>>>4<<2)|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=h[Ta+Za>>0]|0;Za=k+2048+(Ya<<2)|0;f[Za>>2]=(f[Za>>2]|0)+1;Za=i+128+(Ya>>>4<<2)|0;f[Za>>2]=(f[Za>>2]|0)+1;bb=bb+3|0}while((bb|0)<(Aa|0));break}default:{if(za)cb=0;else break d;do{Za=h[Ua+cb>>0]|0;Ya=k+(Za<<2)|0;f[Ya>>2]=(f[Ya>>2]|0)+-1;Ya=i+(Za>>>4<<2)|0;f[Ya>>2]=(f[Ya>>2]|0)+-1;Ya=cb|1;Za=h[Ua+Ya>>0]|0;_a=k+1024+(Za<<2)|0;f[_a>>2]=(f[_a>>2]|0)+-1;_a=i+64+(Za>>>4<<2)|0;f[_a>>2]=(f[_a>>2]|0)+-1;_a=cb|2;Za=h[Ua+_a>>0]|0;$a=k+2048+(Za<<2)|0;f[$a>>2]=(f[$a>>2]|0)+-1;$a=i+128+(Za>>>4<<2)|0;f[$a>>2]=(f[$a>>2]|0)+-1;$a=cb|3;Za=h[Ua+$a>>0]|0;db=k+3072+(Za<<2)|0;f[db>>2]=(f[db>>2]|0)+-1;db=i+192+(Za>>>4<<2)|0;f[db>>2]=(f[db>>2]|0)+-1;db=h[Ta+cb>>0]|0;Za=k+(db<<2)|0;f[Za>>2]=(f[Za>>2]|0)+1;Za=i+(db>>>4<<2)|0;f[Za>>2]=(f[Za>>2]|0)+1;Za=h[Ta+Ya>>0]|0;Ya=k+1024+(Za<<2)|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=i+64+(Za>>>4<<2)|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=h[Ta+_a>>0]|0;_a=k+2048+(Ya<<2)|0;f[_a>>2]=(f[_a>>2]|0)+1;_a=i+128+(Ya>>>4<<2)|0;f[_a>>2]=(f[_a>>2]|0)+1;_a=h[Ta+$a>>0]|0;$a=k+3072+(_a<<2)|0;f[$a>>2]=(f[$a>>2]|0)+1;$a=i+192+(_a>>>4<<2)|0;f[$a>>2]=(f[$a>>2]|0)+1;cb=cb+4|0}while((cb|0)<(ya|0))}}while(0);$a=Ta+Ka|0;if((Xa|0)<(Z|0)){Qa=Qa+Ja|0;Ta=(Ra|$a>>>0>=oa>>>0)&(Ia|$a>>>0<Ga>>>0)?Ta:$a;Ua=(Wa|0)<(W|0)?Ua:Ua+Ka|0;Wa=Xa}else break c}}while(0);Ha=Ha+1|0;if((Ha|0)==(fa|0))break;else{Fa=Fa+na|0;Ga=Ga+na|0}}}break}na=(f[P>>2]|0)>>>3&511;Ga=na+1|0;Fa=f[P+8>>2]|0;fa=e+-1|0;Ha=(fa|0)/2|0;if(na>>>0>=4){f[i>>2]=0;f[i+4>>2]=0;R=c$(i,17)|0;S=330251;T=R+17|0;do{b[R>>0]=b[S>>0]|0;R=R+1|0;S=S+1|0}while((R|0)<(T|0));j$(-215,i,330286,327502,2200);d$(i)}W=f[V>>2]|0;oa=f[P+48>>2]|0;Z=P+12|0;ya=512/(Ga>>>0)|0;za=f[Z>>2]|0;Aa=(ya|0)<(za|0)?ya:za;ya=Ha<<1;xa=Aa+ya|0;ga=Y(xa<<4,Ga)|0;wa=ga+16|0;f[l>>2]=0;Ea=l+4|0;f[Ea>>2]=0;f[l+8>>2]=0;do if(wa)if((ga|0)<-16)gXa(l);else{ma=wa<<1;Ba=NYa(ma)|0;f[l>>2]=Ba;Da=Ba+(wa<<1)|0;f[l+8>>2]=Da;F1a(Ba|0,0,ma|0)|0;f[Ea>>2]=Da;eb=Ba;break}else eb=0;while(0);wa=Y(Ga<<8,xa)|0|16;f[m>>2]=0;ga=m+4|0;f[ga>>2]=0;f[m+8>>2]=0;if((wa|0)<0)gXa(m);Ba=wa<<1;Da=NYa(Ba)|0;f[m>>2]=Da;ma=Da+(wa<<1)|0;f[m+8>>2]=ma;F1a(Da|0,0,Ba|0)|0;f[ga>>2]=ma;Ba=eb+15&-16;wa=Ba;Ca=Da+15&-16;va=Ca;if((za|0)>0){ua=Q+16|0;ta=P+16|0;qa=Ba;Ba=Ga<<1;pa=Ca;Ca=Ga<<9;ra=Ha+2|0;ja=(fa|0)>3;sa=Fa+-1|0;ka=(Fa|0)>0;$=Ga*544|0;ha=Ga<<5;la=ya|1;Ka=(fa|0)>1;Ja=(Y(ya,Ha)|0)+ya|0;La=o+4|0;Ma=o+4|0;Wa=za;Ua=0;do{Ta=Wa-Ua|0;Ia=((Aa|0)<(Ta|0)?Aa:Ta)+ya|0;Ta=(f[ua>>2]|0)+(Y(Ua,Ga)|0)|0;Ra=f[ta>>2]|0;Qa=Y(Ua-Ha|0,Ga)|0;$a=Ia<<4;F1a(qa|0,0,Y(Ba,$a)|0)|0;F1a(pa|0,0,Y(Ca,Ia)|0)|0;_a=(Ia|0)>0;if(_a){Ya=0;do{Za=Y(Ya,Ia)|0;db=Ya<<4;fb=0;do{gb=Ta+((Y(fb,Ga)|0)+Ya)|0;hb=wa+(((h[gb>>0]|0)>>>4|fb+Za<<4)<<1)|0;d[hb>>1]=(j[hb>>1]|0)+ra;hb=h[gb>>0]|0;gb=va+(((Y(hb>>>4|db,Ia)|0)+fb<<4|hb&15)<<1)|0;d[gb>>1]=(j[gb>>1]|0)+ra;fb=fb+1|0}while((fb|0)<(Ia|0));if(ja){fb=1;do{gb=Ta+(Y((sa|0)<(fb|0)?sa:fb,W)|0)|0;hb=0;do{ib=gb+((Y(hb,Ga)|0)+Ya)|0;jb=wa+(((h[ib>>0]|0)>>>4|hb+Za<<4)<<1)|0;d[jb>>1]=(d[jb>>1]|0)+1<<16>>16;jb=h[ib>>0]|0;ib=va+(((Y(jb>>>4|db,Ia)|0)+hb<<4|jb&15)<<1)|0;d[ib>>1]=(d[ib>>1]|0)+1<<16>>16;hb=hb+1|0}while((hb|0)<(Ia|0));fb=fb+1|0}while((fb|0)<(Ha|0))}Ya=Ya+1|0}while((Ya|0)!=(Ga|0))}Ya=Ra+Qa|0;if(ka){fb=Ia-Ha|0;db=(Ha|0)<(fb|0);Za=Ia+-1|0;hb=0;do{gb=hb-Ha+-1|0;Xa=Ta+(Y((gb|0)>0?gb:0,W)|0)|0;gb=hb+Ha|0;ib=Ta+(Y((gb|0)<(sa|0)?gb:sa,W)|0)|0;F1a(i|0,0,$|0)|0;F1a(k|0,0,ha|0)|0;gb=Y(hb,oa)|0;jb=0;while(1){if(_a){kb=Y(jb,Ia)|0;lb=jb<<4;mb=0;do{nb=mb+kb<<4;ob=(Y(mb,Ga)|0)+jb|0;pb=Xa+ob|0;qb=wa+(((h[pb>>0]|0)>>>4|nb)<<1)|0;d[qb>>1]=(d[qb>>1]|0)+-1<<16>>16;qb=h[pb>>0]|0;pb=va+(((Y(qb>>>4|lb,Ia)|0)+mb<<4|qb&15)<<1)|0;d[pb>>1]=(d[pb>>1]|0)+-1<<16>>16;pb=ib+ob|0;ob=wa+(((h[pb>>0]|0)>>>4|nb)<<1)|0;d[ob>>1]=(d[ob>>1]|0)+1<<16>>16;ob=h[pb>>0]|0;pb=va+(((Y(ob>>>4|lb,Ia)|0)+mb<<4|ob&15)<<1)|0;d[pb>>1]=(d[pb>>1]|0)+1<<16>>16;mb=mb+1|0}while((mb|0)<(Ia|0));rb=lb}else rb=jb<<4;lb=0;do{mb=va+((Y(lb+rb|0,$a)|0)<<1)|0;kb=0;do{pb=i+(jb*544|0)+32+(lb<<5)+(kb<<1)|0;ob=(Y(j[mb+(kb<<1)>>1]|0,la)|0)+(j[pb>>1]|0)&65535;d[pb>>1]=ob;kb=kb+1|0}while((kb|0)!=16);lb=lb+1|0}while((lb|0)!=16);if(Ka){lb=Y(jb,Ia)|0;kb=0;do{mb=wa+(kb+lb<<4<<1)|0;ob=0;do{pb=i+(jb*544|0)+(ob<<1)|0;d[pb>>1]=(j[mb+(ob<<1)>>1]|0)+(j[pb>>1]|0);ob=ob+1|0}while((ob|0)!=16);kb=kb+1|0}while((kb|0)<(ya|0))}if(db){kb=Y(jb,Ia)|0;lb=jb+gb|0;ob=i+(jb*544|0)|0;mb=i+(jb*544|0)+2|0;pb=i+(jb*544|0)+4|0;nb=i+(jb*544|0)+6|0;qb=i+(jb*544|0)+8|0;sb=i+(jb*544|0)+10|0;tb=i+(jb*544|0)+12|0;ub=i+(jb*544|0)+14|0;vb=i+(jb*544|0)+16|0;wb=i+(jb*544|0)+18|0;xb=i+(jb*544|0)+20|0;yb=i+(jb*544|0)+22|0;zb=i+(jb*544|0)+24|0;Ab=i+(jb*544|0)+26|0;Bb=i+(jb*544|0)+28|0;Cb=i+(jb*544|0)+30|0;Db=Ha;do{Eb=Db+Ha|0;Fb=wa+(((Za|0)<(Eb|0)?Za:Eb)+kb<<4<<1)|0;Gb=0;do{Hb=i+(jb*544|0)+(Gb<<1)|0;d[Hb>>1]=(j[Fb+(Gb<<1)>>1]|0)+(j[Hb>>1]|0);Gb=Gb+1|0}while((Gb|0)!=16);Gb=j[ob>>1]|0;do if((Gb|0)>(Ja|0)){Ib=0;Jb=0}else{Fb=(j[mb>>1]|0)+Gb|0;if((Fb|0)>(Ja|0)){Ib=1;Jb=Gb;break}Hb=(j[pb>>1]|0)+Fb|0;if((Hb|0)>(Ja|0)){Ib=2;Jb=Fb;break}Fb=(j[nb>>1]|0)+Hb|0;if((Fb|0)>(Ja|0)){Ib=3;Jb=Hb;break}Hb=(j[qb>>1]|0)+Fb|0;if((Hb|0)>(Ja|0)){Ib=4;Jb=Fb;break}Fb=(j[sb>>1]|0)+Hb|0;if((Fb|0)>(Ja|0)){Ib=5;Jb=Hb;break}Hb=(j[tb>>1]|0)+Fb|0;if((Hb|0)>(Ja|0)){Ib=6;Jb=Fb;break}Fb=(j[ub>>1]|0)+Hb|0;if((Fb|0)>(Ja|0)){Ib=7;Jb=Hb;break}Hb=(j[vb>>1]|0)+Fb|0;if((Hb|0)>(Ja|0)){Ib=8;Jb=Fb;break}Fb=(j[wb>>1]|0)+Hb|0;if((Fb|0)>(Ja|0)){Ib=9;Jb=Hb;break}Hb=(j[xb>>1]|0)+Fb|0;if((Hb|0)>(Ja|0)){Ib=10;Jb=Fb;break}Fb=(j[yb>>1]|0)+Hb|0;if((Fb|0)>(Ja|0)){Ib=11;Jb=Hb;break}Hb=(j[zb>>1]|0)+Fb|0;if((Hb|0)>(Ja|0)){Ib=12;Jb=Fb;break}Fb=(j[Ab>>1]|0)+Hb|0;if((Fb|0)>(Ja|0)){Ib=13;Jb=Hb;break}Hb=(j[Bb>>1]|0)+Fb|0;if((Hb|0)>(Ja|0)){Ib=14;Jb=Fb;break}Fb=(j[Cb>>1]|0)+Hb|0;if((Fb|0)>(Ja|0)){Ib=15;Jb=Hb;break}f[o>>2]=0;f[La>>2]=0;Hb=c$(o,6)|0;b[Hb>>0]=b[330303]|0;b[Hb+1>>0]=b[330304]|0;b[Hb+2>>0]=b[330305]|0;b[Hb+3>>0]=b[330306]|0;b[Hb+4>>0]=b[330307]|0;b[Hb+5>>0]=b[330308]|0;j$(-215,o,330286,327502,2344);d$(o);Ib=16;Jb=Fb}while(0);Gb=k+(jb<<5)+(Ib<<1)|0;Fb=d[Gb>>1]|0;Hb=Fb&65535;Kb=Db-Ha|0;do if((Hb|0)>(Kb|0)){if((Hb|0)>(Eb|0))break;Lb=Y(Ib+rb|0,Ia)|0;Mb=Fb;Nb=Hb;do{Ob=Nb-ya|0;Pb=va+(((Ob|0)<1?0:Ob+-1|0)+Lb<<4<<1)|0;Ob=0;do{Qb=i+(jb*544|0)+32+(Ib<<5)+(Ob<<1)|0;d[Qb>>1]=(j[Qb>>1]|0)-(j[Pb+(Ob<<1)>>1]|0);Ob=Ob+1|0}while((Ob|0)!=16);Ob=Mb&65535;Pb=va+(((Ob|0)<(Ia|0)?Ob:Za)+Lb<<4<<1)|0;Ob=0;do{Qb=i+(jb*544|0)+32+(Ib<<5)+(Ob<<1)|0;d[Qb>>1]=(j[Pb+(Ob<<1)>>1]|0)+(j[Qb>>1]|0);Ob=Ob+1|0}while((Ob|0)!=16);Mb=Mb+1<<16>>16;d[Gb>>1]=Mb;Nb=Mb&65535}while((Nb|0)<=(Eb|0))}else{Nb=i+(jb*544|0)+32+(Ib<<5)|0;f[Nb>>2]=0;f[Nb+4>>2]=0;f[Nb+8>>2]=0;f[Nb+12>>2]=0;f[Nb+16>>2]=0;f[Nb+20>>2]=0;f[Nb+24>>2]=0;f[Nb+28>>2]=0;Nb=Kb&65535;d[Gb>>1]=Nb;Mb=Kb&65535;Lb=Eb+1|0;Ob=(Eb|0)<(Ia|0)?Lb:Ia;if((Mb|0)<(Ob|0)){Pb=Y(Ib+rb|0,Ia)|0;Qb=Nb;Nb=Mb;while(1){Rb=va+(Nb+Pb<<4<<1)|0;Sb=0;do{Tb=i+(jb*544|0)+32+(Ib<<5)+(Sb<<1)|0;d[Tb>>1]=(j[Rb+(Sb<<1)>>1]|0)+(j[Tb>>1]|0);Sb=Sb+1|0}while((Sb|0)!=16);Qb=Qb+1<<16>>16;d[Gb>>1]=Qb;Sb=Qb&65535;if((Sb|0)>=(Ob|0)){Ub=Sb;break}else Nb=Sb}}else Ub=Mb;if((Ub|0)>(Eb|0))break;Nb=Lb-Ia|0;Ob=va+((Y(Ib+rb|0,Ia)|0)+Za<<4<<1)|0;Qb=0;do{Pb=i+(jb*544|0)+32+(Ib<<5)+(Qb<<1)|0;Sb=(Y(j[Ob+(Qb<<1)>>1]|0,Nb)|0)+(j[Pb>>1]|0)&65535;d[Pb>>1]=Sb;Qb=Qb+1|0}while((Qb|0)!=16);d[Gb>>1]=Lb}while(0);Gb=wa+(((Kb|0)>0?Kb:0)+kb<<4<<1)|0;Eb=0;do{Hb=i+(jb*544|0)+(Eb<<1)|0;d[Hb>>1]=(j[Hb>>1]|0)-(j[Gb+(Eb<<1)>>1]|0);Eb=Eb+1|0}while((Eb|0)!=16);Eb=(j[i+(jb*544|0)+32+(Ib<<5)>>1]|0)+Jb|0;do if((Eb|0)>(Ja|0)){Vb=0;da=256}else{Gb=(j[i+(jb*544|0)+32+(Ib<<5)+2>>1]|0)+Eb|0;if((Gb|0)>(Ja|0)){Vb=1;da=256;break}Kb=(j[i+(jb*544|0)+32+(Ib<<5)+4>>1]|0)+Gb|0;if((Kb|0)>(Ja|0)){Vb=2;da=256;break}Gb=(j[i+(jb*544|0)+32+(Ib<<5)+6>>1]|0)+Kb|0;if((Gb|0)>(Ja|0)){Vb=3;da=256;break}Kb=(j[i+(jb*544|0)+32+(Ib<<5)+8>>1]|0)+Gb|0;if((Kb|0)>(Ja|0)){Vb=4;da=256;break}Gb=(j[i+(jb*544|0)+32+(Ib<<5)+10>>1]|0)+Kb|0;if((Gb|0)>(Ja|0)){Vb=5;da=256;break}Kb=(j[i+(jb*544|0)+32+(Ib<<5)+12>>1]|0)+Gb|0;if((Kb|0)>(Ja|0)){Vb=6;da=256;break}Gb=(j[i+(jb*544|0)+32+(Ib<<5)+14>>1]|0)+Kb|0;if((Gb|0)>(Ja|0)){Vb=7;da=256;break}Kb=(j[i+(jb*544|0)+32+(Ib<<5)+16>>1]|0)+Gb|0;if((Kb|0)>(Ja|0)){Vb=8;da=256;break}Gb=(j[i+(jb*544|0)+32+(Ib<<5)+18>>1]|0)+Kb|0;if((Gb|0)>(Ja|0)){Vb=9;da=256;break}Kb=(j[i+(jb*544|0)+32+(Ib<<5)+20>>1]|0)+Gb|0;if((Kb|0)>(Ja|0)){Vb=10;da=256;break}Gb=(j[i+(jb*544|0)+32+(Ib<<5)+22>>1]|0)+Kb|0;if((Gb|0)>(Ja|0)){Vb=11;da=256;break}Kb=(j[i+(jb*544|0)+32+(Ib<<5)+24>>1]|0)+Gb|0;if((Kb|0)>(Ja|0)){Vb=12;da=256;break}Gb=(j[i+(jb*544|0)+32+(Ib<<5)+26>>1]|0)+Kb|0;if((Gb|0)>(Ja|0)){Vb=13;da=256;break}Kb=(j[i+(jb*544|0)+32+(Ib<<5)+28>>1]|0)+Gb|0;if((Kb|0)>(Ja|0)){Vb=14;da=256;break}if(((j[i+(jb*544|0)+32+(Ib<<5)+30>>1]|0)+Kb|0)>(Ja|0)){Vb=15;da=256;break}f[o>>2]=0;f[Ma>>2]=0;Kb=c$(o,6)|0;b[Kb>>0]=b[330310]|0;b[Kb+1>>0]=b[330311]|0;b[Kb+2>>0]=b[330312]|0;b[Kb+3>>0]=b[330313]|0;b[Kb+4>>0]=b[330314]|0;b[Kb+5>>0]=b[330315]|0;j$(-215,o,330286,327502,2381);d$(o)}while(0);if((da|0)==256){da=0;Eb=Ya+(lb+(Y(Db,Ga)|0))|0;b[Eb>>0]=Vb|Ib<<4}Db=Db+1|0}while((Db|0)<(fb|0))}if((jb|0)<(na|0))jb=jb+1|0;else break}hb=hb+1|0}while((hb|0)<(Fa|0))}Ua=Ua+Aa|0;Wa=f[Z>>2]|0}while((Wa|0)>(Ua|0));Ua=f[m>>2]|0;if(Ua|0){Wb=f[ga>>2]|0;Xb=Ua;Yb=Ua;da=203}}else{Wb=ma;Xb=Da;Yb=Da;da=203}if((da|0)==203){if((Wb|0)!=(Xb|0))f[ga>>2]=Wb+(~((Wb+-2-Xb|0)>>>1)<<1);PYa(Yb)}Ua=f[l>>2]|0;if(Ua|0){Wa=f[Ea>>2]|0;if((Wa|0)!=(Ua|0))f[Ea>>2]=Wa+(~((Wa+-2-Ua|0)>>>1)<<1);PYa(Ua)}}else{Ua=P+16|0;Wa=N+16|0;if((f[Ua>>2]|0)==(f[Wa>>2]|0)){Z=i+8|0;f[Z>>2]=0;f[Z+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=Q;eL(N,i)}else{Z=N+36|0;Aa=f[Z>>2]|0;if(Aa){Fa=Aa+12|0;f[Fa>>2]=(f[Fa>>2]|0)+1;Fa=Q+36|0;Aa=f[Fa>>2]|0;if((Aa|0)!=0?(na=Aa+12|0,Aa=f[na>>2]|0,f[na>>2]=Aa+-1,(Aa|0)==1):0){CR(Q);Zb=Fa}else Zb=Fa}else Zb=Q+36|0;f[Zb>>2]=0;Fa=Q+16|0;f[Fa>>2]=0;f[Fa+4>>2]=0;f[Fa+8>>2]=0;f[Fa+12>>2]=0;if((f[U>>2]|0)>0){Aa=f[_>>2]|0;na=0;do{f[Aa+(na<<2)>>2]=0;na=na+1|0;_b=f[U>>2]|0}while((na|0)<(_b|0));f[Q>>2]=f[aa>>2];if((_b|0)<3)da=37;else da=39}else{f[Q>>2]=f[aa>>2];da=37}if((da|0)==37){na=f[N+4>>2]|0;if((na|0)<3){f[U>>2]=na;f[O>>2]=f[N+8>>2];f[Q+12>>2]=f[N+12>>2];na=f[N+44>>2]|0;Aa=f[X>>2]|0;f[Aa>>2]=f[na>>2];f[Aa+4>>2]=f[na+4>>2]}else da=39}if((da|0)==39)BR(Q,N);f[Fa>>2]=f[Wa>>2];f[Q+20>>2]=f[N+20>>2];f[Q+24>>2]=f[N+24>>2];f[Q+28>>2]=f[N+28>>2];f[Q+32>>2]=f[N+32>>2];f[Zb>>2]=f[Z>>2]}na=f[Q>>2]|0;switch(na&7){case 0:{Jpa(Q,P,e);break a;break}case 2:{Aa=f[Q+16>>2]|0;Ea=f[Ua>>2]|0;ga=(f[V>>2]|0)>>>1;Da=(f[P+48>>2]|0)>>>1;ma=f[P+40>>2]|0;Ga=f[ma+4>>2]|0;Ma=f[ma>>2]|0;ma=na>>>3;Ja=ma&511;wa=Ja+1|0;b[i>>0]=0;e:do switch(e|0){case 3:{va=(Ma|0)==1;if((Ga|0)==1|va){ya=Ma+Ga|0;Ha=ya+-1|0;La=va?wa:ga;Ka=va?0:ga-wa|0;la=va?wa:Da;if((ya|0)<=1)break e;va=0-La|0;oa=ya+-2|0;ya=Ea;ha=0;$=Aa;while(1){W=(ha|0)>0?va:0;sa=(ha|0)<(oa|0)?La:0;ka=0;ja=$;while(1){ra=d[ja+(W<<1)>>1]|0;Ca=d[ja>>1]|0;pa=j[ja+(sa<<1)>>1]|0;Ba=(Ca&65535)<(ra&65535);qa=(Ba?Ca:ra)&65535;ta=(Ba?ra:Ca)&65535;Ca=pa>>>0<ta>>>0?pa:ta;d[ya+(ka<<1)>>1]=(Ca|0)<(qa|0)?qa:Ca;ka=ka+1|0;if((ka|0)==(wa|0))break;else ja=ja+2|0}ha=ha+1|0;if((ha|0)>=(Ha|0))break e;else{ya=ya+(la<<1)|0;$=$+(wa<<1)+(Ka<<1)|0}}}Ka=Y(Ga,wa)|0;if((Ma|0)>0){$=Ma+-1|0;la=(ma|-512)^511;ya=la+-1+Ka|0;Ha=Ka-wa|0;ha=Ea;La=0;while(1){oa=La+-1|0;va=Aa+((Y((oa|0)>0?oa:0,ga)|0)<<1)|0;oa=Aa+((Y(La,ga)|0)<<1)|0;La=La+1|0;ja=Aa+((Y(($|0)<(La|0)?$:La,ga)|0)<<1)|0;ka=0;sa=b[i>>0]&1?wa:Ka;f:while(1){if((ka|0)<(sa|0)){W=ka;do{Ca=W-((W|0)>(Ja|0)?wa:0)|0;qa=((W|0)<(Ha|0)?wa:0)+W|0;ta=d[va+(Ca<<1)>>1]|0;pa=d[va+(W<<1)>>1]|0;ra=d[va+(qa<<1)>>1]|0;Ba=d[oa+(Ca<<1)>>1]|0;ua=d[oa+(W<<1)>>1]|0;za=d[oa+(qa<<1)>>1]|0;fa=d[ja+(Ca<<1)>>1]|0;Ca=d[ja+(W<<1)>>1]|0;xa=d[ja+(qa<<1)>>1]|0;qa=(ra&65535)<(pa&65535);hb=qa?ra:pa;fb=qa?pa:ra;ra=(za&65535)<(ua&65535);pa=ra?za:ua;qa=ra?ua:za;za=(xa&65535)<(Ca&65535);ua=za?xa:Ca;ra=za?Ca:xa;xa=(hb&65535)<(ta&65535);Ca=(xa?hb:ta)&65535;za=xa?ta:hb;hb=(pa&65535)<(Ba&65535);ta=(hb?pa:Ba)&65535;xa=hb?Ba:pa;pa=(ua&65535)<(fa&65535);Ba=(pa?ua:fa)&65535;hb=pa?fa:ua;ua=(fb&65535)<(za&65535);fa=(ua?fb:za)&65535;pa=(ua?za:fb)&65535;fb=(qa&65535)<(xa&65535);za=fb?qa:xa;ua=(fb?xa:qa)&65535;qa=(ra&65535)<(hb&65535);xa=qa?ra:hb;fb=(qa?hb:ra)&65535;ra=ta>>>0<Ca>>>0?Ca:ta;ta=fb>>>0<ua>>>0?fb:ua;ua=(xa&65535)<(za&65535);fb=(ua?xa:za)&65535;Ca=(ua?za:xa)&65535;xa=(Ba|0)<(ra|0)?ra:Ba;Ba=fb>>>0<fa>>>0?fa:fb;fb=(ta|0)<(pa|0)?ta:pa;pa=(Ca|0)<(Ba|0)?Ca:Ba;Ba=(fb|0)<(pa|0);Ca=Ba?fb:pa;ta=Ba?pa:fb;fb=(Ca|0)<(xa|0)?xa:Ca;d[ha+(W<<1)>>1]=(ta|0)<(fb|0)?ta:fb;W=W+1|0}while((W|0)!=(sa|0));$b=sa}else $b=ka;if((sa|0)==(Ka|0))break;if(($b|0)>(ya|0)){ka=$b;sa=Ka;continue}else ac=$b;while(1){W=va+(ac<<1)|0;fb=d[W+(la<<1)>>1]|0;ta=d[W>>1]|0;Ca=d[W+(wa<<1)>>1]|0;W=oa+(ac<<1)|0;xa=d[W+(la<<1)>>1]|0;pa=d[W>>1]|0;Ba=d[W+(wa<<1)>>1]|0;W=ja+(ac<<1)|0;fa=d[W+(la<<1)>>1]|0;ra=d[W>>1]|0;za=d[W+(wa<<1)>>1]|0;W=(Ca&65535)<(ta&65535);ua=W?Ca:ta;hb=W?ta:Ca;Ca=(Ba&65535)<(pa&65535);ta=Ca?Ba:pa;W=Ca?pa:Ba;Ba=(za&65535)<(ra&65535);pa=Ba?za:ra;Ca=Ba?ra:za;za=(ua&65535)<(fb&65535);ra=(za?ua:fb)&65535;Ba=za?fb:ua;ua=(ta&65535)<(xa&65535);fb=(ua?ta:xa)&65535;za=ua?xa:ta;ta=(pa&65535)<(fa&65535);xa=(ta?pa:fa)&65535;ua=ta?fa:pa;pa=(hb&65535)<(Ba&65535);fa=(pa?hb:Ba)&65535;ta=(pa?Ba:hb)&65535;hb=(W&65535)<(za&65535);Ba=hb?W:za;pa=(hb?za:W)&65535;W=(Ca&65535)<(ua&65535);za=W?Ca:ua;hb=(W?ua:Ca)&65535;Ca=fb>>>0<ra>>>0?ra:fb;fb=hb>>>0<pa>>>0?hb:pa;pa=(za&65535)<(Ba&65535);hb=(pa?za:Ba)&65535;ra=(pa?Ba:za)&65535;za=(xa|0)<(Ca|0)?Ca:xa;xa=hb>>>0<fa>>>0?fa:hb;hb=(fb|0)<(ta|0)?fb:ta;ta=(ra|0)<(xa|0)?ra:xa;xa=(hb|0)<(ta|0);ra=xa?hb:ta;fb=xa?ta:hb;hb=(ra|0)<(za|0)?za:ra;d[ha+(ac<<1)>>1]=(fb|0)<(hb|0)?fb:hb;hb=ac+1|0;if((ac|0)<(ya|0))ac=hb;else{ka=hb;sa=Ka;continue f}}}if((La|0)==(Ma|0))break;else ha=ha+(Da<<1)|0}}break}case 5:{ha=(Ma|0)==1;if((Ga|0)==1|ha){La=Ma+Ga|0;Ka=La+-1|0;ya=ha?wa:ga;la=ha?0:ga-wa|0;Ha=ha?wa:Da;if((La|0)<=1)break e;ha=0-ya|0;$=ha<<1;sa=La+-2|0;ka=La+-3|0;La=ya<<1;ja=Ea;oa=0;va=Aa;while(1){hb=(oa|0)>0?ha:0;fb=(oa|0)>1?$:hb;ra=(oa|0)<(sa|0)?ya:0;za=(oa|0)<(ka|0)?La:ra;ta=0;xa=va;while(1){fa=d[xa+(fb<<1)>>1]|0;Ca=d[xa+(hb<<1)>>1]|0;Ba=d[xa>>1]|0;pa=d[xa+(ra<<1)>>1]|0;ua=d[xa+(za<<1)>>1]|0;W=(Ca&65535)<(fa&65535);qa=(W?Ca:fa)&65535;Ya=(W?fa:Ca)&65535;Ca=(ua&65535)<(pa&65535);fa=Ca?ua:pa;W=Ca?pa:ua;ua=(fa&65535)<(Ba&65535);pa=(ua?fa:Ba)&65535;Ca=ua?Ba:fa;fa=(W&65535)<(Ca&65535);Ba=(fa?W:Ca)&65535;ua=(fa?Ca:W)&65535;W=pa>>>0<qa>>>0?qa:pa;pa=(ua|0)<(W|0)?ua:W;W=Ba>>>0<Ya>>>0?Ba:Ya;d[ja+(ta<<1)>>1]=(pa|0)<(W|0)?W:pa;ta=ta+1|0;if((ta|0)==(wa|0))break;else xa=xa+2|0}oa=oa+1|0;if((oa|0)>=(Ka|0))break e;else{ja=ja+(Ha<<1)|0;va=va+(wa<<1)+(la<<1)|0}}}la=Y(Ga,wa)|0;if((Ma|0)>0){va=Ma+-1|0;Ha=wa<<1;ja=0-Ha|0;Ka=la+~Ha|0;oa=(ma|-512)^511;La=la-wa|0;ka=la-Ha|0;ya=Ea;sa=0;while(1){$=sa+-2|0;ha=Aa+((Y(($|0)>0?$:0,ga)|0)<<1)|0;$=sa+-1|0;xa=Aa+((Y(($|0)>0?$:0,ga)|0)<<1)|0;$=Aa+((Y(sa,ga)|0)<<1)|0;ta=sa;sa=sa+1|0;za=Aa+((Y((va|0)<(sa|0)?va:sa,ga)|0)<<1)|0;ra=ta+2|0;ta=Aa+((Y((va|0)<(ra|0)?va:ra,ga)|0)<<1)|0;ra=0;hb=b[i>>0]&1?Ha:la;g:while(1){if((ra|0)<(hb|0)){fb=ra;do{pa=fb-((fb|0)>(Ja|0)?wa:0)|0;W=(fb|0)<(Ha|0)?pa:fb-Ha|0;Ya=((fb|0)<(La|0)?wa:0)+fb|0;Ba=(fb|0)<(ka|0)?fb+Ha|0:Ya;ua=d[ha+(W<<1)>>1]|0;qa=d[ha+(pa<<1)>>1]|0;Ca=d[ha+(fb<<1)>>1]|0;fa=d[ha+(Ya<<1)>>1]|0;Za=d[ha+(Ba<<1)>>1]|0;Ia=d[xa+(W<<1)>>1]|0;db=d[xa+(pa<<1)>>1]|0;$a=d[xa+(fb<<1)>>1]|0;_a=d[xa+(Ya<<1)>>1]|0;Ta=d[xa+(Ba<<1)>>1]|0;Qa=d[$+(W<<1)>>1]|0;Ra=d[$+(pa<<1)>>1]|0;jb=d[$+(fb<<1)>>1]|0;gb=d[$+(Ya<<1)>>1]|0;ib=d[$+(Ba<<1)>>1]|0;Xa=d[za+(W<<1)>>1]|0;Db=d[za+(pa<<1)>>1]|0;lb=d[za+(fb<<1)>>1]|0;kb=d[za+(Ya<<1)>>1]|0;Cb=d[za+(Ba<<1)>>1]|0;Bb=d[ta+(W<<1)>>1]|0;W=d[ta+(pa<<1)>>1]|0;pa=d[ta+(fb<<1)>>1]|0;Ab=d[ta+(Ya<<1)>>1]|0;Ya=d[ta+(Ba<<1)>>1]|0;Ba=(Ca&65535)<(qa&65535)?Ca:qa;zb=(Ca&65535)>(qa&65535)?Ca:qa;qa=(Ba&65535)<(ua&65535);Ca=qa?Ba:ua;yb=qa?ua:Ba;Ba=(zb&65535)<(yb&65535);ua=Ba?zb:yb;qa=Ba?yb:zb;zb=(Ia&65535)<(Za&65535);yb=zb?Ia:Za;Ba=zb?Za:Ia;Ia=(yb&65535)<(fa&65535);Za=Ia?yb:fa;zb=Ia?fa:yb;yb=(Ba&65535)<(zb&65535);fa=yb?Ba:zb;Ia=yb?zb:Ba;Ba=(Za&65535)<(Ca&65535);zb=Ba?Za:Ca;yb=Ba?Ca:Za;Za=(Ia&65535)<(qa&65535);Ca=Za?Ia:qa;Ba=Za?qa:Ia;Ia=(yb&65535)<(Ca&65535);qa=Ia?yb:Ca;Za=Ia?Ca:yb;yb=(fa&65535)<(ua&65535);Ca=yb?fa:ua;Ia=yb?ua:fa;fa=(qa&65535)<(Ca&65535);ua=fa?qa:Ca;yb=fa?Ca:qa;qa=(Ia&65535)<(Za&65535);Ca=qa?Ia:Za;fa=qa?Za:Ia;Ia=(_a&65535)<($a&65535);Za=Ia?_a:$a;qa=Ia?$a:_a;_a=(Za&65535)<(db&65535);$a=_a?Za:db;Ia=_a?db:Za;Za=(qa&65535)<(Ia&65535);db=Za?qa:Ia;_a=Za?Ia:qa;qa=(Ra&65535)<(Qa&65535);Ia=qa?Ra:Qa;Za=qa?Qa:Ra;Ra=(Ia&65535)<(Ta&65535);Qa=Ra?Ia:Ta;qa=Ra?Ta:Ia;Ia=(Za&65535)<(qa&65535);Ta=Ia?Za:qa;Ra=Ia?qa:Za;Za=(Qa&65535)<($a&65535);qa=Za?Qa:$a;Ia=Za?$a:Qa;Qa=(Ra&65535)<(_a&65535);$a=Qa?Ra:_a;Za=Qa?_a:Ra;Ra=(Ia&65535)<($a&65535);_a=Ra?Ia:$a;Qa=Ra?$a:Ia;Ia=(Ta&65535)<(db&65535);$a=Ia?Ta:db;Ra=Ia?db:Ta;Ta=(_a&65535)<($a&65535);db=Ta?_a:$a;Ia=Ta?$a:_a;_a=(Ra&65535)<(Qa&65535);$a=_a?Ra:Qa;Ta=_a?Qa:Ra;Ra=(qa&65535)<(zb&65535);Qa=(Ra?qa:zb)&65535;_a=Ra?zb:qa;qa=(Ta&65535)<(fa&65535);zb=qa?Ta:fa;Ra=qa?fa:Ta;Ta=(_a&65535)<(zb&65535);fa=Ta?_a:zb;qa=Ta?zb:_a;_a=(Ia&65535)<(yb&65535);zb=_a?Ia:yb;Ta=_a?yb:Ia;Ia=(fa&65535)<(zb&65535);yb=Ia?fa:zb;_a=Ia?zb:fa;fa=(Ta&65535)<(qa&65535);zb=fa?Ta:qa;Ia=fa?qa:Ta;Ta=(db&65535)<(ua&65535);qa=Ta?db:ua;fa=Ta?ua:db;db=(Za&65535)<(Ba&65535);ua=db?Za:Ba;Ta=(db?Ba:Za)&65535;Za=(fa&65535)<(ua&65535);Ba=Za?fa:ua;db=Za?ua:fa;fa=($a&65535)<(Ca&65535);ua=fa?$a:Ca;Za=fa?Ca:$a;$a=(Ba&65535)<(ua&65535);Ca=$a?Ba:ua;fa=$a?ua:Ba;Ba=(Za&65535)<(db&65535);ua=Ba?Za:db;$a=Ba?db:Za;Za=(yb&65535)<(qa&65535);db=(Za?yb:qa)&65535;Ba=(Za?qa:yb)&65535;yb=(_a&65535)<(Ca&65535);qa=(yb?_a:Ca)&65535;Za=(yb?Ca:_a)&65535;_a=(zb&65535)<(fa&65535);Ca=(_a?zb:fa)&65535;yb=(_a?fa:zb)&65535;zb=(Ia&65535)<(ua&65535);fa=(zb?Ia:ua)&65535;_a=(zb?ua:Ia)&65535;Ia=(Ra&65535)<($a&65535);ua=(Ia?Ra:$a)&65535;zb=(Ia?$a:Ra)&65535;Ra=(ib&65535)<(gb&65535);$a=Ra?ib:gb;Ia=Ra?gb:ib;ib=($a&65535)<(jb&65535);gb=ib?$a:jb;Ra=ib?jb:$a;$a=(Ia&65535)<(Ra&65535);jb=$a?Ia:Ra;ib=$a?Ra:Ia;Ia=(lb&65535)<(Db&65535);Ra=Ia?lb:Db;$a=Ia?Db:lb;lb=(Ra&65535)<(Xa&65535);Db=lb?Ra:Xa;Ia=lb?Xa:Ra;Ra=($a&65535)<(Ia&65535);Xa=Ra?$a:Ia;lb=Ra?Ia:$a;$a=(Db&65535)<(gb&65535);Ia=$a?Db:gb;Ra=$a?gb:Db;Db=(lb&65535)<(ib&65535);gb=Db?lb:ib;$a=Db?ib:lb;lb=(Ra&65535)<(gb&65535);ib=lb?Ra:gb;Db=lb?gb:Ra;Ra=(Xa&65535)<(jb&65535);gb=Ra?Xa:jb;lb=Ra?jb:Xa;Xa=(ib&65535)<(gb&65535);jb=Xa?ib:gb;Ra=Xa?gb:ib;ib=(lb&65535)<(Db&65535);gb=ib?lb:Db;Xa=ib?Db:lb;lb=(Bb&65535)<(Cb&65535);Db=lb?Bb:Cb;ib=lb?Cb:Bb;Bb=(Db&65535)<(kb&65535);Cb=Bb?Db:kb;lb=Bb?kb:Db;Db=(ib&65535)<(lb&65535);kb=Db?ib:lb;Bb=Db?lb:ib;ib=(pa&65535)<(W&65535);lb=ib?pa:W;Db=ib?W:pa;pa=(Ya&65535)<(Ab&65535);W=pa?Ya:Ab;ib=pa?Ab:Ya;Ya=(W&65535)<(lb&65535);Ab=Ya?W:lb;pa=Ya?lb:W;W=(ib&65535)<(Db&65535);lb=W?ib:Db;Ya=W?Db:ib;ib=(pa&65535)<(lb&65535);Db=ib?pa:lb;W=ib?lb:pa;pa=(Ab&65535)<(Cb&65535);lb=pa?Ab:Cb;ib=pa?Cb:Ab;Ab=(W&65535)<(Bb&65535);Cb=Ab?W:Bb;pa=Ab?Bb:W;W=(ib&65535)<(Cb&65535);Bb=W?ib:Cb;Ab=W?Cb:ib;ib=(Db&65535)<(kb&65535);Cb=ib?Db:kb;W=ib?kb:Db;Db=(Ya&65535)<(W&65535);kb=Db?Ya:W;ib=Db?W:Ya;Ya=(Bb&65535)<(Cb&65535);W=Ya?Bb:Cb;Db=Ya?Cb:Bb;Bb=(kb&65535)<(Ab&65535);Cb=Bb?kb:Ab;Ya=Bb?Ab:kb;kb=(ib&65535)<(pa&65535);Ab=kb?ib:pa;Bb=kb?pa:ib;ib=(lb&65535)<(Ia&65535);pa=(ib?lb:Ia)&65535;kb=ib?Ia:lb;lb=(Ya&65535)<(Xa&65535);Ia=lb?Ya:Xa;ib=lb?Xa:Ya;Ya=(kb&65535)<(Ia&65535);Xa=Ya?kb:Ia;lb=Ya?Ia:kb;kb=(Db&65535)<(Ra&65535);Ia=kb?Db:Ra;Ya=kb?Ra:Db;Db=(Bb&65535)<(Ya&65535);Ra=Db?Bb:Ya;kb=Db?Ya:Bb;Bb=(Xa&65535)<(Ia&65535);Ya=Bb?Xa:Ia;Db=Bb?Ia:Xa;Xa=(Ra&65535)<(lb&65535);Ia=Xa?Ra:lb;Bb=Xa?lb:Ra;Ra=(kb&65535)<(ib&65535);lb=Ra?kb:ib;Xa=Ra?ib:kb;kb=(W&65535)<(jb&65535);ib=kb?W:jb;Ra=kb?jb:W;W=(Ab&65535)<($a&65535);jb=W?Ab:$a;kb=W?$a:Ab;Ab=(Ra&65535)<(jb&65535);$a=Ab?Ra:jb;W=Ab?jb:Ra;Ra=(Cb&65535)<(gb&65535);jb=Ra?Cb:gb;Ab=Ra?gb:Cb;Cb=($a&65535)<(jb&65535);gb=Cb?$a:jb;Ra=Cb?jb:$a;$a=(Ab&65535)<(W&65535);jb=$a?Ab:W;Cb=$a?W:Ab;Ab=(Ya&65535)<(ib&65535);W=(Ab?Ya:ib)&65535;$a=(Ab?ib:Ya)&65535;Ya=(Db&65535)<(gb&65535);ib=(Ya?Db:gb)&65535;Ab=(Ya?gb:Db)&65535;Db=(Ia&65535)<(Ra&65535);gb=(Db?Ia:Ra)&65535;Ya=(Db?Ra:Ia)&65535;Ia=(Bb&65535)<(jb&65535);Ra=(Ia?Bb:jb)&65535;Db=(Ia?jb:Bb)&65535;Bb=(lb&65535)<(Cb&65535);jb=(Bb?lb:Cb)&65535;Ia=(Bb?Cb:lb)&65535;lb=(Xa&65535)<(kb&65535);Cb=(lb?Xa:kb)&65535;Bb=(lb?kb:Xa)&65535;Xa=pa>>>0<Qa>>>0?Qa:pa;pa=Db>>>0<_a>>>0?Db:_a;_a=(Xa|0)<(pa|0)?pa:Xa;Xa=Ab>>>0<Za>>>0?Za:Ab;Ab=(Bb|0)<(Xa|0)?Bb:Xa;Xa=(Ab|0)<(_a|0)?Ab:_a;_a=$a>>>0<Ba>>>0?Ba:$a;$a=Ia>>>0<zb>>>0?Ia:zb;zb=(_a|0)<($a|0)?_a:$a;$a=Ya>>>0<yb>>>0?Ya:yb;yb=(zb|0)<($a|0)?$a:zb;zb=(Xa|0)<(yb|0)?yb:Xa;Xa=W>>>0<db>>>0?db:W;W=jb>>>0<ua>>>0?jb:ua;ua=(Xa|0)<(W|0)?W:Xa;Xa=gb>>>0<Ca>>>0?Ca:gb;gb=(Xa|0)<(ua|0)?Xa:ua;ua=ib>>>0<qa>>>0?qa:ib;ib=Cb>>>0<Ta>>>0?Cb:Ta;Ta=(ua|0)<(ib|0)?ua:ib;ib=Ra>>>0<fa>>>0?Ra:fa;fa=(Ta|0)<(ib|0)?ib:Ta;Ta=(gb|0)<(fa|0)?gb:fa;d[ya+(fb<<1)>>1]=(zb|0)<(Ta|0)?Ta:zb;fb=fb+1|0}while((fb|0)!=(hb|0));bc=hb}else bc=ra;if((hb|0)==(la|0))break;if((bc|0)>(Ka|0)){ra=bc;hb=la;continue}else cc=bc;while(1){fb=ha+(cc<<1)|0;zb=d[fb+(ja<<1)>>1]|0;Ta=d[fb+(oa<<1)>>1]|0;fa=d[fb>>1]|0;gb=d[fb+(wa<<1)>>1]|0;ib=d[fb+(Ha<<1)>>1]|0;fb=xa+(cc<<1)|0;Ra=d[fb+(ja<<1)>>1]|0;ua=d[fb+(oa<<1)>>1]|0;Cb=d[fb>>1]|0;qa=d[fb+(wa<<1)>>1]|0;Xa=d[fb+(Ha<<1)>>1]|0;fb=$+(cc<<1)|0;Ca=d[fb+(ja<<1)>>1]|0;W=d[fb+(oa<<1)>>1]|0;jb=d[fb>>1]|0;db=d[fb+(wa<<1)>>1]|0;yb=d[fb+(Ha<<1)>>1]|0;fb=za+(cc<<1)|0;$a=d[fb+(ja<<1)>>1]|0;Ya=d[fb+(oa<<1)>>1]|0;_a=d[fb>>1]|0;Ia=d[fb+(wa<<1)>>1]|0;Ba=d[fb+(Ha<<1)>>1]|0;fb=ta+(cc<<1)|0;Ab=d[fb+(ja<<1)>>1]|0;Bb=d[fb+(oa<<1)>>1]|0;Za=d[fb>>1]|0;pa=d[fb+(wa<<1)>>1]|0;Db=d[fb+(Ha<<1)>>1]|0;fb=(fa&65535)<(Ta&65535)?fa:Ta;Qa=(fa&65535)>(Ta&65535)?fa:Ta;Ta=(fb&65535)<(zb&65535);fa=Ta?fb:zb;kb=Ta?zb:fb;fb=(Qa&65535)<(kb&65535);zb=fb?Qa:kb;Ta=fb?kb:Qa;Qa=(Ra&65535)<(ib&65535);kb=Qa?Ra:ib;fb=Qa?ib:Ra;Ra=(kb&65535)<(gb&65535);ib=Ra?kb:gb;Qa=Ra?gb:kb;kb=(fb&65535)<(Qa&65535);gb=kb?fb:Qa;Ra=kb?Qa:fb;fb=(ib&65535)<(fa&65535);Qa=fb?ib:fa;kb=fb?fa:ib;ib=(Ra&65535)<(Ta&65535);fa=ib?Ra:Ta;fb=ib?Ta:Ra;Ra=(kb&65535)<(fa&65535);Ta=Ra?kb:fa;ib=Ra?fa:kb;kb=(gb&65535)<(zb&65535);fa=kb?gb:zb;Ra=kb?zb:gb;gb=(Ta&65535)<(fa&65535);zb=gb?Ta:fa;kb=gb?fa:Ta;Ta=(Ra&65535)<(ib&65535);fa=Ta?Ra:ib;gb=Ta?ib:Ra;Ra=(qa&65535)<(Cb&65535);ib=Ra?qa:Cb;Ta=Ra?Cb:qa;qa=(ib&65535)<(ua&65535);Cb=qa?ib:ua;Ra=qa?ua:ib;ib=(Ta&65535)<(Ra&65535);ua=ib?Ta:Ra;qa=ib?Ra:Ta;Ta=(W&65535)<(Ca&65535);Ra=Ta?W:Ca;ib=Ta?Ca:W;W=(Ra&65535)<(Xa&65535);Ca=W?Ra:Xa;Ta=W?Xa:Ra;Ra=(ib&65535)<(Ta&65535);Xa=Ra?ib:Ta;W=Ra?Ta:ib;ib=(Ca&65535)<(Cb&65535);Ta=ib?Ca:Cb;Ra=ib?Cb:Ca;Ca=(W&65535)<(qa&65535);Cb=Ca?W:qa;ib=Ca?qa:W;W=(Ra&65535)<(Cb&65535);qa=W?Ra:Cb;Ca=W?Cb:Ra;Ra=(Xa&65535)<(ua&65535);Cb=Ra?Xa:ua;W=Ra?ua:Xa;Xa=(qa&65535)<(Cb&65535);ua=Xa?qa:Cb;Ra=Xa?Cb:qa;qa=(W&65535)<(Ca&65535);Cb=qa?W:Ca;Xa=qa?Ca:W;W=(Ta&65535)<(Qa&65535);Ca=(W?Ta:Qa)&65535;qa=W?Qa:Ta;Ta=(Xa&65535)<(gb&65535);Qa=Ta?Xa:gb;W=Ta?gb:Xa;Xa=(qa&65535)<(Qa&65535);gb=Xa?qa:Qa;Ta=Xa?Qa:qa;qa=(Ra&65535)<(kb&65535);Qa=qa?Ra:kb;Xa=qa?kb:Ra;Ra=(gb&65535)<(Qa&65535);kb=Ra?gb:Qa;qa=Ra?Qa:gb;gb=(Xa&65535)<(Ta&65535);Qa=gb?Xa:Ta;Ra=gb?Ta:Xa;Xa=(ua&65535)<(zb&65535);Ta=Xa?ua:zb;gb=Xa?zb:ua;ua=(ib&65535)<(fb&65535);zb=ua?ib:fb;Xa=(ua?fb:ib)&65535;ib=(gb&65535)<(zb&65535);fb=ib?gb:zb;ua=ib?zb:gb;gb=(Cb&65535)<(fa&65535);zb=gb?Cb:fa;ib=gb?fa:Cb;Cb=(fb&65535)<(zb&65535);fa=Cb?fb:zb;gb=Cb?zb:fb;fb=(ib&65535)<(ua&65535);zb=fb?ib:ua;Cb=fb?ua:ib;ib=(kb&65535)<(Ta&65535);ua=(ib?kb:Ta)&65535;fb=(ib?Ta:kb)&65535;kb=(qa&65535)<(fa&65535);Ta=(kb?qa:fa)&65535;ib=(kb?fa:qa)&65535;qa=(Qa&65535)<(gb&65535);fa=(qa?Qa:gb)&65535;kb=(qa?gb:Qa)&65535;Qa=(Ra&65535)<(zb&65535);gb=(Qa?Ra:zb)&65535;qa=(Qa?zb:Ra)&65535;Ra=(W&65535)<(Cb&65535);zb=(Ra?W:Cb)&65535;Qa=(Ra?Cb:W)&65535;W=(yb&65535)<(db&65535);Cb=W?yb:db;Ra=W?db:yb;yb=(Cb&65535)<(jb&65535);db=yb?Cb:jb;W=yb?jb:Cb;Cb=(Ra&65535)<(W&65535);jb=Cb?Ra:W;yb=Cb?W:Ra;Ra=(_a&65535)<(Ya&65535);W=Ra?_a:Ya;Cb=Ra?Ya:_a;_a=(W&65535)<($a&65535);Ya=_a?W:$a;Ra=_a?$a:W;W=(Cb&65535)<(Ra&65535);$a=W?Cb:Ra;_a=W?Ra:Cb;Cb=(Ya&65535)<(db&65535);Ra=Cb?Ya:db;W=Cb?db:Ya;Ya=(_a&65535)<(yb&65535);db=Ya?_a:yb;Cb=Ya?yb:_a;_a=(W&65535)<(db&65535);yb=_a?W:db;Ya=_a?db:W;W=($a&65535)<(jb&65535);db=W?$a:jb;_a=W?jb:$a;$a=(yb&65535)<(db&65535);jb=$a?yb:db;W=$a?db:yb;yb=(_a&65535)<(Ya&65535);db=yb?_a:Ya;$a=yb?Ya:_a;_a=(Ab&65535)<(Ba&65535);Ya=_a?Ab:Ba;yb=_a?Ba:Ab;Ab=(Ya&65535)<(Ia&65535);Ba=Ab?Ya:Ia;_a=Ab?Ia:Ya;Ya=(yb&65535)<(_a&65535);Ia=Ya?yb:_a;Ab=Ya?_a:yb;yb=(Za&65535)<(Bb&65535);_a=yb?Za:Bb;Ya=yb?Bb:Za;Za=(Db&65535)<(pa&65535);Bb=Za?Db:pa;yb=Za?pa:Db;Db=(Bb&65535)<(_a&65535);pa=Db?Bb:_a;Za=Db?_a:Bb;Bb=(yb&65535)<(Ya&65535);_a=Bb?yb:Ya;Db=Bb?Ya:yb;yb=(Za&65535)<(_a&65535);Ya=yb?Za:_a;Bb=yb?_a:Za;Za=(pa&65535)<(Ba&65535);_a=Za?pa:Ba;yb=Za?Ba:pa;pa=(Bb&65535)<(Ab&65535);Ba=pa?Bb:Ab;Za=pa?Ab:Bb;Bb=(yb&65535)<(Ba&65535);Ab=Bb?yb:Ba;pa=Bb?Ba:yb;yb=(Ya&65535)<(Ia&65535);Ba=yb?Ya:Ia;Bb=yb?Ia:Ya;Ya=(Db&65535)<(Bb&65535);Ia=Ya?Db:Bb;yb=Ya?Bb:Db;Db=(Ab&65535)<(Ba&65535);Bb=Db?Ab:Ba;Ya=Db?Ba:Ab;Ab=(Ia&65535)<(pa&65535);Ba=Ab?Ia:pa;Db=Ab?pa:Ia;Ia=(yb&65535)<(Za&65535);pa=Ia?yb:Za;Ab=Ia?Za:yb;yb=(_a&65535)<(Ra&65535);Za=(yb?_a:Ra)&65535;Ia=yb?Ra:_a;_a=(Db&65535)<($a&65535);Ra=_a?Db:$a;yb=_a?$a:Db;Db=(Ia&65535)<(Ra&65535);$a=Db?Ia:Ra;_a=Db?Ra:Ia;Ia=(Ya&65535)<(W&65535);Ra=Ia?Ya:W;Db=Ia?W:Ya;Ya=(Ab&65535)<(Db&65535);W=Ya?Ab:Db;Ia=Ya?Db:Ab;Ab=($a&65535)<(Ra&65535);Db=Ab?$a:Ra;Ya=Ab?Ra:$a;$a=(W&65535)<(_a&65535);Ra=$a?W:_a;Ab=$a?_a:W;W=(Ia&65535)<(yb&65535);_a=W?Ia:yb;$a=W?yb:Ia;Ia=(Bb&65535)<(jb&65535);yb=Ia?Bb:jb;W=Ia?jb:Bb;Bb=(pa&65535)<(Cb&65535);jb=Bb?pa:Cb;Ia=Bb?Cb:pa;pa=(W&65535)<(jb&65535);Cb=pa?W:jb;Bb=pa?jb:W;W=(Ba&65535)<(db&65535);jb=W?Ba:db;pa=W?db:Ba;Ba=(Cb&65535)<(jb&65535);db=Ba?Cb:jb;W=Ba?jb:Cb;Cb=(pa&65535)<(Bb&65535);jb=Cb?pa:Bb;Ba=Cb?Bb:pa;pa=(Db&65535)<(yb&65535);Bb=(pa?Db:yb)&65535;Cb=(pa?yb:Db)&65535;Db=(Ya&65535)<(db&65535);yb=(Db?Ya:db)&65535;pa=(Db?db:Ya)&65535;Ya=(Ra&65535)<(W&65535);db=(Ya?Ra:W)&65535;Db=(Ya?W:Ra)&65535;Ra=(Ab&65535)<(jb&65535);W=(Ra?Ab:jb)&65535;Ya=(Ra?jb:Ab)&65535;Ab=(_a&65535)<(Ba&65535);jb=(Ab?_a:Ba)&65535;Ra=(Ab?Ba:_a)&65535;_a=($a&65535)<(Ia&65535);Ba=(_a?$a:Ia)&65535;Ab=(_a?Ia:$a)&65535;$a=Za>>>0<Ca>>>0?Ca:Za;Za=Ya>>>0<qa>>>0?Ya:qa;qa=($a|0)<(Za|0)?Za:$a;$a=pa>>>0<ib>>>0?ib:pa;pa=(Ab|0)<($a|0)?Ab:$a;$a=(pa|0)<(qa|0)?pa:qa;qa=Cb>>>0<fb>>>0?fb:Cb;Cb=Ra>>>0<Qa>>>0?Ra:Qa;Qa=(qa|0)<(Cb|0)?qa:Cb;Cb=Db>>>0<kb>>>0?Db:kb;kb=(Qa|0)<(Cb|0)?Cb:Qa;Qa=($a|0)<(kb|0)?kb:$a;$a=Bb>>>0<ua>>>0?ua:Bb;Bb=jb>>>0<zb>>>0?jb:zb;zb=($a|0)<(Bb|0)?Bb:$a;$a=db>>>0<fa>>>0?fa:db;db=($a|0)<(zb|0)?$a:zb;zb=yb>>>0<Ta>>>0?Ta:yb;yb=Ba>>>0<Xa>>>0?Ba:Xa;Xa=(zb|0)<(yb|0)?zb:yb;yb=W>>>0<gb>>>0?W:gb;gb=(Xa|0)<(yb|0)?yb:Xa;Xa=(db|0)<(gb|0)?db:gb;d[ya+(cc<<1)>>1]=(Qa|0)<(Xa|0)?Xa:Qa;Qa=cc+1|0;if((cc|0)<(Ka|0))cc=Qa;else{ra=Qa;hb=la;continue g}}}if((sa|0)==(Ma|0))break;else ya=ya+(Da<<1)|0}}break}default:{}}while(0);break a;break}case 3:{Da=f[Q+16>>2]|0;Ma=f[Ua>>2]|0;wa=(f[V>>2]|0)>>>1;Ja=(f[P+48>>2]|0)>>>1;ga=f[P+40>>2]|0;Aa=f[ga+4>>2]|0;Ea=f[ga>>2]|0;ga=na>>>3;ma=ga&511;Ga=ma+1|0;b[i>>0]=0;h:do switch(e|0){case 3:{Z=(Ea|0)==1;if((Aa|0)==1|Z){Wa=Ea+Aa|0;Fa=Wa+-1|0;ya=Z?Ga:wa;sa=Z?0:wa-Ga|0;la=Z?Ga:Ja;if((Wa|0)<=1)break h;Z=0-ya|0;Ka=Wa+-2|0;Wa=Ma;Ha=0;oa=Da;while(1){ja=(Ha|0)>0?Z:0;ka=(Ha|0)<(Ka|0)?ya:0;La=0;va=oa;while(1){hb=d[va+(ja<<1)>>1]|0;ra=d[va>>1]|0;ta=d[va+(ka<<1)>>1]|0;za=ra<<16>>16<hb<<16>>16;$=(za?ra:hb)<<16>>16;xa=(za?hb:ra)<<16>>16;ra=(ta|0)<(xa|0)?ta:xa;d[Wa+(La<<1)>>1]=(ra|0)<($|0)?$:ra;La=La+1|0;if((La|0)==(Ga|0))break;else va=va+2|0}Ha=Ha+1|0;if((Ha|0)>=(Fa|0))break h;else{Wa=Wa+(la<<1)|0;oa=oa+(Ga<<1)+(sa<<1)|0}}}sa=Y(Aa,Ga)|0;if((Ea|0)>0){oa=Ea+-1|0;la=(ga|-512)^511;Wa=la+-1+sa|0;Fa=sa-Ga|0;Ha=Ma;ya=0;while(1){Ka=ya+-1|0;Z=Da+((Y((Ka|0)>0?Ka:0,wa)|0)<<1)|0;Ka=Da+((Y(ya,wa)|0)<<1)|0;ya=ya+1|0;va=Da+((Y((oa|0)<(ya|0)?oa:ya,wa)|0)<<1)|0;La=0;ka=b[i>>0]&1?Ga:sa;i:while(1){if((La|0)<(ka|0)){ja=La;do{ra=ja-((ja|0)>(ma|0)?Ga:0)|0;$=((ja|0)<(Fa|0)?Ga:0)+ja|0;xa=d[Z+(ra<<1)>>1]|0;ta=d[Z+(ja<<1)>>1]|0;hb=d[Z+($<<1)>>1]|0;za=d[Ka+(ra<<1)>>1]|0;ha=d[Ka+(ja<<1)>>1]|0;Qa=d[Ka+($<<1)>>1]|0;Xa=d[va+(ra<<1)>>1]|0;ra=d[va+(ja<<1)>>1]|0;gb=d[va+($<<1)>>1]|0;$=hb<<16>>16<ta<<16>>16;db=$?hb:ta;yb=$?ta:hb;hb=Qa<<16>>16<ha<<16>>16;ta=hb?Qa:ha;$=hb?ha:Qa;Qa=gb<<16>>16<ra<<16>>16;ha=Qa?gb:ra;hb=Qa?ra:gb;gb=db<<16>>16<xa<<16>>16;ra=(gb?db:xa)<<16>>16;Qa=gb?xa:db;db=ta<<16>>16<za<<16>>16;xa=(db?ta:za)<<16>>16;gb=db?za:ta;ta=ha<<16>>16<Xa<<16>>16;za=(ta?ha:Xa)<<16>>16;db=ta?Xa:ha;ha=yb<<16>>16<Qa<<16>>16;Xa=(ha?yb:Qa)<<16>>16;ta=(ha?Qa:yb)<<16>>16;yb=$<<16>>16<gb<<16>>16;Qa=yb?$:gb;ha=(yb?gb:$)<<16>>16;$=hb<<16>>16<db<<16>>16;gb=$?hb:db;yb=($?db:hb)<<16>>16;hb=(xa|0)<(ra|0)?ra:xa;xa=(yb|0)<(ha|0)?yb:ha;ha=gb<<16>>16<Qa<<16>>16;yb=(ha?gb:Qa)<<16>>16;ra=(ha?Qa:gb)<<16>>16;gb=(za|0)<(hb|0)?hb:za;za=(yb|0)<(Xa|0)?Xa:yb;yb=(xa|0)<(ta|0)?xa:ta;ta=(ra|0)<(za|0)?ra:za;za=(yb|0)<(ta|0);ra=za?yb:ta;xa=za?ta:yb;yb=(ra|0)<(gb|0)?gb:ra;d[Ha+(ja<<1)>>1]=(xa|0)<(yb|0)?xa:yb;ja=ja+1|0}while((ja|0)!=(ka|0));dc=ka}else dc=La;if((ka|0)==(sa|0))break;if((dc|0)>(Wa|0)){La=dc;ka=sa;continue}else ec=dc;while(1){ja=Z+(ec<<1)|0;yb=d[ja+(la<<1)>>1]|0;xa=d[ja>>1]|0;ra=d[ja+(Ga<<1)>>1]|0;ja=Ka+(ec<<1)|0;gb=d[ja+(la<<1)>>1]|0;ta=d[ja>>1]|0;za=d[ja+(Ga<<1)>>1]|0;ja=va+(ec<<1)|0;Xa=d[ja+(la<<1)>>1]|0;hb=d[ja>>1]|0;Qa=d[ja+(Ga<<1)>>1]|0;ja=ra<<16>>16<xa<<16>>16;ha=ja?ra:xa;db=ja?xa:ra;ra=za<<16>>16<ta<<16>>16;xa=ra?za:ta;ja=ra?ta:za;za=Qa<<16>>16<hb<<16>>16;ta=za?Qa:hb;ra=za?hb:Qa;Qa=ha<<16>>16<yb<<16>>16;hb=(Qa?ha:yb)<<16>>16;za=Qa?yb:ha;ha=xa<<16>>16<gb<<16>>16;yb=(ha?xa:gb)<<16>>16;Qa=ha?gb:xa;xa=ta<<16>>16<Xa<<16>>16;gb=(xa?ta:Xa)<<16>>16;ha=xa?Xa:ta;ta=db<<16>>16<za<<16>>16;Xa=(ta?db:za)<<16>>16;xa=(ta?za:db)<<16>>16;db=ja<<16>>16<Qa<<16>>16;za=db?ja:Qa;ta=(db?Qa:ja)<<16>>16;ja=ra<<16>>16<ha<<16>>16;Qa=ja?ra:ha;db=(ja?ha:ra)<<16>>16;ra=(yb|0)<(hb|0)?hb:yb;yb=(db|0)<(ta|0)?db:ta;ta=Qa<<16>>16<za<<16>>16;db=(ta?Qa:za)<<16>>16;hb=(ta?za:Qa)<<16>>16;Qa=(gb|0)<(ra|0)?ra:gb;gb=(db|0)<(Xa|0)?Xa:db;db=(yb|0)<(xa|0)?yb:xa;xa=(hb|0)<(gb|0)?hb:gb;gb=(db|0)<(xa|0);hb=gb?db:xa;yb=gb?xa:db;db=(hb|0)<(Qa|0)?Qa:hb;d[Ha+(ec<<1)>>1]=(yb|0)<(db|0)?yb:db;db=ec+1|0;if((ec|0)<(Wa|0))ec=db;else{La=db;ka=sa;continue i}}}if((ya|0)==(Ea|0))break;else Ha=Ha+(Ja<<1)|0}}break}case 5:{Ha=(Ea|0)==1;if((Aa|0)==1|Ha){ya=Ea+Aa|0;sa=ya+-1|0;Wa=Ha?Ga:wa;la=Ha?0:wa-Ga|0;Fa=Ha?Ga:Ja;if((ya|0)<=1)break h;Ha=0-Wa|0;oa=Ha<<1;ka=ya+-2|0;La=ya+-3|0;ya=Wa<<1;va=Ma;Ka=0;Z=Da;while(1){db=(Ka|0)>0?Ha:0;yb=(Ka|0)>1?oa:db;hb=(Ka|0)<(ka|0)?Wa:0;Qa=(Ka|0)<(La|0)?ya:hb;xa=0;gb=Z;while(1){Xa=d[gb+(yb<<1)>>1]|0;ra=d[gb+(db<<1)>>1]|0;za=d[gb>>1]|0;ta=d[gb+(hb<<1)>>1]|0;ha=d[gb+(Qa<<1)>>1]|0;ja=ra<<16>>16<Xa<<16>>16;$=(ja?ra:Xa)<<16>>16;W=(ja?Xa:ra)<<16>>16;ra=ha<<16>>16<ta<<16>>16;Xa=ra?ha:ta;ja=ra?ta:ha;ha=Xa<<16>>16<za<<16>>16;ta=(ha?Xa:za)<<16>>16;ra=ha?za:Xa;Xa=ja<<16>>16<ra<<16>>16;za=(Xa?ja:ra)<<16>>16;ha=(Xa?ra:ja)<<16>>16;ja=(ta|0)<($|0)?$:ta;ta=(ha|0)<(ja|0)?ha:ja;ja=(za|0)<(W|0)?za:W;d[va+(xa<<1)>>1]=(ta|0)<(ja|0)?ja:ta;xa=xa+1|0;if((xa|0)==(Ga|0))break;else gb=gb+2|0}Ka=Ka+1|0;if((Ka|0)>=(sa|0))break h;else{va=va+(Fa<<1)|0;Z=Z+(Ga<<1)+(la<<1)|0}}}la=Y(Aa,Ga)|0;if((Ea|0)>0){Z=Ea+-1|0;Fa=Ga<<1;va=0-Fa|0;sa=la+~Fa|0;Ka=(ga|-512)^511;ya=la-Ga|0;La=la-Fa|0;Wa=Ma;ka=0;while(1){oa=ka+-2|0;Ha=Da+((Y((oa|0)>0?oa:0,wa)|0)<<1)|0;oa=ka+-1|0;gb=Da+((Y((oa|0)>0?oa:0,wa)|0)<<1)|0;oa=Da+((Y(ka,wa)|0)<<1)|0;xa=ka;ka=ka+1|0;Qa=Da+((Y((Z|0)<(ka|0)?Z:ka,wa)|0)<<1)|0;hb=xa+2|0;xa=Da+((Y((Z|0)<(hb|0)?Z:hb,wa)|0)<<1)|0;hb=0;db=b[i>>0]&1?Fa:la;j:while(1){if((hb|0)<(db|0)){yb=hb;do{ta=yb-((yb|0)>(ma|0)?Ga:0)|0;ja=(yb|0)<(Fa|0)?ta:yb-Fa|0;W=((yb|0)<(ya|0)?Ga:0)+yb|0;za=(yb|0)<(La|0)?yb+Fa|0:W;ha=d[Ha+(ja<<1)>>1]|0;$=d[Ha+(ta<<1)>>1]|0;ra=d[Ha+(yb<<1)>>1]|0;Xa=d[Ha+(W<<1)>>1]|0;zb=d[Ha+(za<<1)>>1]|0;Ba=d[gb+(ja<<1)>>1]|0;Ta=d[gb+(ta<<1)>>1]|0;$a=d[gb+(yb<<1)>>1]|0;fa=d[gb+(W<<1)>>1]|0;Bb=d[gb+(za<<1)>>1]|0;jb=d[oa+(ja<<1)>>1]|0;ua=d[oa+(ta<<1)>>1]|0;kb=d[oa+(yb<<1)>>1]|0;Cb=d[oa+(W<<1)>>1]|0;Db=d[oa+(za<<1)>>1]|0;qa=d[Qa+(ja<<1)>>1]|0;Ra=d[Qa+(ta<<1)>>1]|0;fb=d[Qa+(yb<<1)>>1]|0;pa=d[Qa+(W<<1)>>1]|0;Ab=d[Qa+(za<<1)>>1]|0;ib=d[xa+(ja<<1)>>1]|0;ja=d[xa+(ta<<1)>>1]|0;ta=d[xa+(yb<<1)>>1]|0;Za=d[xa+(W<<1)>>1]|0;W=d[xa+(za<<1)>>1]|0;za=ra<<16>>16<$<<16>>16?ra:$;Ya=ra<<16>>16>$<<16>>16?ra:$;$=za<<16>>16<ha<<16>>16;ra=$?za:ha;Ca=$?ha:za;za=Ya<<16>>16<Ca<<16>>16;ha=za?Ya:Ca;$=za?Ca:Ya;Ya=Ba<<16>>16<zb<<16>>16;Ca=Ya?Ba:zb;za=Ya?zb:Ba;Ba=Ca<<16>>16<Xa<<16>>16;zb=Ba?Ca:Xa;Ya=Ba?Xa:Ca;Ca=za<<16>>16<Ya<<16>>16;Xa=Ca?za:Ya;Ba=Ca?Ya:za;za=zb<<16>>16<ra<<16>>16;Ya=za?zb:ra;Ca=za?ra:zb;zb=Ba<<16>>16<$<<16>>16;ra=zb?Ba:$;za=zb?$:Ba;Ba=Ca<<16>>16<ra<<16>>16;$=Ba?Ca:ra;zb=Ba?ra:Ca;Ca=Xa<<16>>16<ha<<16>>16;ra=Ca?Xa:ha;Ba=Ca?ha:Xa;Xa=$<<16>>16<ra<<16>>16;ha=Xa?$:ra;Ca=Xa?ra:$;$=Ba<<16>>16<zb<<16>>16;ra=$?Ba:zb;Xa=$?zb:Ba;Ba=fa<<16>>16<$a<<16>>16;zb=Ba?fa:$a;$=Ba?$a:fa;fa=zb<<16>>16<Ta<<16>>16;$a=fa?zb:Ta;Ba=fa?Ta:zb;zb=$<<16>>16<Ba<<16>>16;Ta=zb?$:Ba;fa=zb?Ba:$;$=ua<<16>>16<jb<<16>>16;Ba=$?ua:jb;zb=$?jb:ua;ua=Ba<<16>>16<Bb<<16>>16;jb=ua?Ba:Bb;$=ua?Bb:Ba;Ba=zb<<16>>16<$<<16>>16;Bb=Ba?zb:$;ua=Ba?$:zb;zb=jb<<16>>16<$a<<16>>16;$=zb?jb:$a;Ba=zb?$a:jb;jb=ua<<16>>16<fa<<16>>16;$a=jb?ua:fa;zb=jb?fa:ua;ua=Ba<<16>>16<$a<<16>>16;fa=ua?Ba:$a;jb=ua?$a:Ba;Ba=Bb<<16>>16<Ta<<16>>16;$a=Ba?Bb:Ta;ua=Ba?Ta:Bb;Bb=fa<<16>>16<$a<<16>>16;Ta=Bb?fa:$a;Ba=Bb?$a:fa;fa=ua<<16>>16<jb<<16>>16;$a=fa?ua:jb;Bb=fa?jb:ua;ua=$<<16>>16<Ya<<16>>16;jb=(ua?$:Ya)<<16>>16;fa=ua?Ya:$;$=Bb<<16>>16<Xa<<16>>16;Ya=$?Bb:Xa;ua=$?Xa:Bb;Bb=fa<<16>>16<Ya<<16>>16;Xa=Bb?fa:Ya;$=Bb?Ya:fa;fa=Ba<<16>>16<Ca<<16>>16;Ya=fa?Ba:Ca;Bb=fa?Ca:Ba;Ba=Xa<<16>>16<Ya<<16>>16;Ca=Ba?Xa:Ya;fa=Ba?Ya:Xa;Xa=Bb<<16>>16<$<<16>>16;Ya=Xa?Bb:$;Ba=Xa?$:Bb;Bb=Ta<<16>>16<ha<<16>>16;$=Bb?Ta:ha;Xa=Bb?ha:Ta;Ta=zb<<16>>16<za<<16>>16;ha=Ta?zb:za;Bb=(Ta?za:zb)<<16>>16;zb=Xa<<16>>16<ha<<16>>16;za=zb?Xa:ha;Ta=zb?ha:Xa;Xa=$a<<16>>16<ra<<16>>16;ha=Xa?$a:ra;zb=Xa?ra:$a;$a=za<<16>>16<ha<<16>>16;ra=$a?za:ha;Xa=$a?ha:za;za=zb<<16>>16<Ta<<16>>16;ha=za?zb:Ta;$a=za?Ta:zb;zb=Ca<<16>>16<$<<16>>16;Ta=(zb?Ca:$)<<16>>16;za=(zb?$:Ca)<<16>>16;Ca=fa<<16>>16<ra<<16>>16;$=(Ca?fa:ra)<<16>>16;zb=(Ca?ra:fa)<<16>>16;fa=Ya<<16>>16<Xa<<16>>16;ra=(fa?Ya:Xa)<<16>>16;Ca=(fa?Xa:Ya)<<16>>16;Ya=Ba<<16>>16<ha<<16>>16;Xa=(Ya?Ba:ha)<<16>>16;fa=(Ya?ha:Ba)<<16>>16;Ba=ua<<16>>16<$a<<16>>16;ha=(Ba?ua:$a)<<16>>16;Ya=(Ba?$a:ua)<<16>>16;ua=Db<<16>>16<Cb<<16>>16;$a=ua?Db:Cb;Ba=ua?Cb:Db;Db=$a<<16>>16<kb<<16>>16;Cb=Db?$a:kb;ua=Db?kb:$a;$a=Ba<<16>>16<ua<<16>>16;kb=$a?Ba:ua;Db=$a?ua:Ba;Ba=fb<<16>>16<Ra<<16>>16;ua=Ba?fb:Ra;$a=Ba?Ra:fb;fb=ua<<16>>16<qa<<16>>16;Ra=fb?ua:qa;Ba=fb?qa:ua;ua=$a<<16>>16<Ba<<16>>16;qa=ua?$a:Ba;fb=ua?Ba:$a;$a=Ra<<16>>16<Cb<<16>>16;Ba=$a?Ra:Cb;ua=$a?Cb:Ra;Ra=fb<<16>>16<Db<<16>>16;Cb=Ra?fb:Db;$a=Ra?Db:fb;fb=ua<<16>>16<Cb<<16>>16;Db=fb?ua:Cb;Ra=fb?Cb:ua;ua=qa<<16>>16<kb<<16>>16;Cb=ua?qa:kb;fb=ua?kb:qa;qa=Db<<16>>16<Cb<<16>>16;kb=qa?Db:Cb;ua=qa?Cb:Db;Db=fb<<16>>16<Ra<<16>>16;Cb=Db?fb:Ra;qa=Db?Ra:fb;fb=ib<<16>>16<Ab<<16>>16;Ra=fb?ib:Ab;Db=fb?Ab:ib;ib=Ra<<16>>16<pa<<16>>16;Ab=ib?Ra:pa;fb=ib?pa:Ra;Ra=Db<<16>>16<fb<<16>>16;pa=Ra?Db:fb;ib=Ra?fb:Db;Db=ta<<16>>16<ja<<16>>16;fb=Db?ta:ja;Ra=Db?ja:ta;ta=W<<16>>16<Za<<16>>16;ja=ta?W:Za;Db=ta?Za:W;W=ja<<16>>16<fb<<16>>16;Za=W?ja:fb;ta=W?fb:ja;ja=Db<<16>>16<Ra<<16>>16;fb=ja?Db:Ra;W=ja?Ra:Db;Db=ta<<16>>16<fb<<16>>16;Ra=Db?ta:fb;ja=Db?fb:ta;ta=Za<<16>>16<Ab<<16>>16;fb=ta?Za:Ab;Db=ta?Ab:Za;Za=ja<<16>>16<ib<<16>>16;Ab=Za?ja:ib;ta=Za?ib:ja;ja=Db<<16>>16<Ab<<16>>16;ib=ja?Db:Ab;Za=ja?Ab:Db;Db=Ra<<16>>16<pa<<16>>16;Ab=Db?Ra:pa;ja=Db?pa:Ra;Ra=W<<16>>16<ja<<16>>16;pa=Ra?W:ja;Db=Ra?ja:W;W=ib<<16>>16<Ab<<16>>16;ja=W?ib:Ab;Ra=W?Ab:ib;ib=pa<<16>>16<Za<<16>>16;Ab=ib?pa:Za;W=ib?Za:pa;pa=Db<<16>>16<ta<<16>>16;Za=pa?Db:ta;ib=pa?ta:Db;Db=fb<<16>>16<Ba<<16>>16;ta=(Db?fb:Ba)<<16>>16;pa=Db?Ba:fb;fb=W<<16>>16<qa<<16>>16;Ba=fb?W:qa;Db=fb?qa:W;W=pa<<16>>16<Ba<<16>>16;qa=W?pa:Ba;fb=W?Ba:pa;pa=Ra<<16>>16<ua<<16>>16;Ba=pa?Ra:ua;W=pa?ua:Ra;Ra=ib<<16>>16<W<<16>>16;ua=Ra?ib:W;pa=Ra?W:ib;ib=qa<<16>>16<Ba<<16>>16;W=ib?qa:Ba;Ra=ib?Ba:qa;qa=ua<<16>>16<fb<<16>>16;Ba=qa?ua:fb;ib=qa?fb:ua;ua=pa<<16>>16<Db<<16>>16;fb=ua?pa:Db;qa=ua?Db:pa;pa=ja<<16>>16<kb<<16>>16;Db=pa?ja:kb;ua=pa?kb:ja;ja=Za<<16>>16<$a<<16>>16;kb=ja?Za:$a;pa=ja?$a:Za;Za=ua<<16>>16<kb<<16>>16;$a=Za?ua:kb;ja=Za?kb:ua;ua=Ab<<16>>16<Cb<<16>>16;kb=ua?Ab:Cb;Za=ua?Cb:Ab;Ab=$a<<16>>16<kb<<16>>16;Cb=Ab?$a:kb;ua=Ab?kb:$a;$a=Za<<16>>16<ja<<16>>16;kb=$a?Za:ja;Ab=$a?ja:Za;Za=W<<16>>16<Db<<16>>16;ja=(Za?W:Db)<<16>>16;$a=(Za?Db:W)<<16>>16;W=Ra<<16>>16<Cb<<16>>16;Db=(W?Ra:Cb)<<16>>16;Za=(W?Cb:Ra)<<16>>16;Ra=Ba<<16>>16<ua<<16>>16;Cb=(Ra?Ba:ua)<<16>>16;W=(Ra?ua:Ba)<<16>>16;Ba=ib<<16>>16<kb<<16>>16;ua=(Ba?ib:kb)<<16>>16;Ra=(Ba?kb:ib)<<16>>16;ib=fb<<16>>16<Ab<<16>>16;kb=(ib?fb:Ab)<<16>>16;Ba=(ib?Ab:fb)<<16>>16;fb=qa<<16>>16<pa<<16>>16;Ab=(fb?qa:pa)<<16>>16;ib=(fb?pa:qa)<<16>>16;qa=(ta|0)<(jb|0)?jb:ta;ta=(Ra|0)<(fa|0)?Ra:fa;fa=(qa|0)<(ta|0)?ta:qa;qa=(Za|0)<(zb|0)?zb:Za;Za=(ib|0)<(qa|0)?ib:qa;qa=(Za|0)<(fa|0)?Za:fa;fa=($a|0)<(za|0)?za:$a;$a=(Ba|0)<(Ya|0)?Ba:Ya;Ya=(fa|0)<($a|0)?fa:$a;$a=(W|0)<(Ca|0)?W:Ca;Ca=(Ya|0)<($a|0)?$a:Ya;Ya=(qa|0)<(Ca|0)?Ca:qa;qa=(ja|0)<(Ta|0)?Ta:ja;ja=(kb|0)<(ha|0)?kb:ha;ha=(qa|0)<(ja|0)?ja:qa;qa=(Cb|0)<(ra|0)?ra:Cb;Cb=(qa|0)<(ha|0)?qa:ha;ha=(Db|0)<($|0)?$:Db;Db=(Ab|0)<(Bb|0)?Ab:Bb;Bb=(ha|0)<(Db|0)?ha:Db;Db=(ua|0)<(Xa|0)?ua:Xa;Xa=(Bb|0)<(Db|0)?Db:Bb;Bb=(Cb|0)<(Xa|0)?Cb:Xa;d[Wa+(yb<<1)>>1]=(Ya|0)<(Bb|0)?Bb:Ya;yb=yb+1|0}while((yb|0)!=(db|0));fc=db}else fc=hb;if((db|0)==(la|0))break;if((fc|0)>(sa|0)){hb=fc;db=la;continue}else gc=fc;while(1){yb=Ha+(gc<<1)|0;Ya=d[yb+(va<<1)>>1]|0;Bb=d[yb+(Ka<<1)>>1]|0;Xa=d[yb>>1]|0;Cb=d[yb+(Ga<<1)>>1]|0;Db=d[yb+(Fa<<1)>>1]|0;yb=gb+(gc<<1)|0;ua=d[yb+(va<<1)>>1]|0;ha=d[yb+(Ka<<1)>>1]|0;Ab=d[yb>>1]|0;$=d[yb+(Ga<<1)>>1]|0;qa=d[yb+(Fa<<1)>>1]|0;yb=oa+(gc<<1)|0;ra=d[yb+(va<<1)>>1]|0;ja=d[yb+(Ka<<1)>>1]|0;kb=d[yb>>1]|0;Ta=d[yb+(Ga<<1)>>1]|0;Ca=d[yb+(Fa<<1)>>1]|0;yb=Qa+(gc<<1)|0;$a=d[yb+(va<<1)>>1]|0;W=d[yb+(Ka<<1)>>1]|0;fa=d[yb>>1]|0;Ba=d[yb+(Ga<<1)>>1]|0;za=d[yb+(Fa<<1)>>1]|0;yb=xa+(gc<<1)|0;Za=d[yb+(va<<1)>>1]|0;ib=d[yb+(Ka<<1)>>1]|0;zb=d[yb>>1]|0;ta=d[yb+(Ga<<1)>>1]|0;Ra=d[yb+(Fa<<1)>>1]|0;yb=Xa<<16>>16<Bb<<16>>16?Xa:Bb;jb=Xa<<16>>16>Bb<<16>>16?Xa:Bb;Bb=yb<<16>>16<Ya<<16>>16;Xa=Bb?yb:Ya;pa=Bb?Ya:yb;yb=jb<<16>>16<pa<<16>>16;Ya=yb?jb:pa;Bb=yb?pa:jb;jb=ua<<16>>16<Db<<16>>16;pa=jb?ua:Db;yb=jb?Db:ua;ua=pa<<16>>16<Cb<<16>>16;Db=ua?pa:Cb;jb=ua?Cb:pa;pa=yb<<16>>16<jb<<16>>16;Cb=pa?yb:jb;ua=pa?jb:yb;yb=Db<<16>>16<Xa<<16>>16;jb=yb?Db:Xa;pa=yb?Xa:Db;Db=ua<<16>>16<Bb<<16>>16;Xa=Db?ua:Bb;yb=Db?Bb:ua;ua=pa<<16>>16<Xa<<16>>16;Bb=ua?pa:Xa;Db=ua?Xa:pa;pa=Cb<<16>>16<Ya<<16>>16;Xa=pa?Cb:Ya;ua=pa?Ya:Cb;Cb=Bb<<16>>16<Xa<<16>>16;Ya=Cb?Bb:Xa;pa=Cb?Xa:Bb;Bb=ua<<16>>16<Db<<16>>16;Xa=Bb?ua:Db;Cb=Bb?Db:ua;ua=$<<16>>16<Ab<<16>>16;Db=ua?$:Ab;Bb=ua?Ab:$;$=Db<<16>>16<ha<<16>>16;Ab=$?Db:ha;ua=$?ha:Db;Db=Bb<<16>>16<ua<<16>>16;ha=Db?Bb:ua;$=Db?ua:Bb;Bb=ja<<16>>16<ra<<16>>16;ua=Bb?ja:ra;Db=Bb?ra:ja;ja=ua<<16>>16<qa<<16>>16;ra=ja?ua:qa;Bb=ja?qa:ua;ua=Db<<16>>16<Bb<<16>>16;qa=ua?Db:Bb;ja=ua?Bb:Db;Db=ra<<16>>16<Ab<<16>>16;Bb=Db?ra:Ab;ua=Db?Ab:ra;ra=ja<<16>>16<$<<16>>16;Ab=ra?ja:$;Db=ra?$:ja;ja=ua<<16>>16<Ab<<16>>16;$=ja?ua:Ab;ra=ja?Ab:ua;ua=qa<<16>>16<ha<<16>>16;Ab=ua?qa:ha;ja=ua?ha:qa;qa=$<<16>>16<Ab<<16>>16;ha=qa?$:Ab;ua=qa?Ab:$;$=ja<<16>>16<ra<<16>>16;Ab=$?ja:ra;qa=$?ra:ja;ja=Bb<<16>>16<jb<<16>>16;ra=(ja?Bb:jb)<<16>>16;$=ja?jb:Bb;Bb=qa<<16>>16<Cb<<16>>16;jb=Bb?qa:Cb;ja=Bb?Cb:qa;qa=$<<16>>16<jb<<16>>16;Cb=qa?$:jb;Bb=qa?jb:$;$=ua<<16>>16<pa<<16>>16;jb=$?ua:pa;qa=$?pa:ua;ua=Cb<<16>>16<jb<<16>>16;pa=ua?Cb:jb;$=ua?jb:Cb;Cb=qa<<16>>16<Bb<<16>>16;jb=Cb?qa:Bb;ua=Cb?Bb:qa;qa=ha<<16>>16<Ya<<16>>16;Bb=qa?ha:Ya;Cb=qa?Ya:ha;ha=Db<<16>>16<yb<<16>>16;Ya=ha?Db:yb;qa=(ha?yb:Db)<<16>>16;Db=Cb<<16>>16<Ya<<16>>16;yb=Db?Cb:Ya;ha=Db?Ya:Cb;Cb=Ab<<16>>16<Xa<<16>>16;Ya=Cb?Ab:Xa;Db=Cb?Xa:Ab;Ab=yb<<16>>16<Ya<<16>>16;Xa=Ab?yb:Ya;Cb=Ab?Ya:yb;yb=Db<<16>>16<ha<<16>>16;Ya=yb?Db:ha;Ab=yb?ha:Db;Db=pa<<16>>16<Bb<<16>>16;ha=(Db?pa:Bb)<<16>>16;yb=(Db?Bb:pa)<<16>>16;pa=$<<16>>16<Xa<<16>>16;Bb=(pa?$:Xa)<<16>>16;Db=(pa?Xa:$)<<16>>16;$=jb<<16>>16<Cb<<16>>16;Xa=($?jb:Cb)<<16>>16;pa=($?Cb:jb)<<16>>16;jb=ua<<16>>16<Ya<<16>>16;Cb=(jb?ua:Ya)<<16>>16;$=(jb?Ya:ua)<<16>>16;ua=ja<<16>>16<Ab<<16>>16;Ya=(ua?ja:Ab)<<16>>16;jb=(ua?Ab:ja)<<16>>16;ja=Ca<<16>>16<Ta<<16>>16;Ab=ja?Ca:Ta;ua=ja?Ta:Ca;Ca=Ab<<16>>16<kb<<16>>16;Ta=Ca?Ab:kb;ja=Ca?kb:Ab;Ab=ua<<16>>16<ja<<16>>16;kb=Ab?ua:ja;Ca=Ab?ja:ua;ua=fa<<16>>16<W<<16>>16;ja=ua?fa:W;Ab=ua?W:fa;fa=ja<<16>>16<$a<<16>>16;W=fa?ja:$a;ua=fa?$a:ja;ja=Ab<<16>>16<ua<<16>>16;$a=ja?Ab:ua;fa=ja?ua:Ab;Ab=W<<16>>16<Ta<<16>>16;ua=Ab?W:Ta;ja=Ab?Ta:W;W=fa<<16>>16<Ca<<16>>16;Ta=W?fa:Ca;Ab=W?Ca:fa;fa=ja<<16>>16<Ta<<16>>16;Ca=fa?ja:Ta;W=fa?Ta:ja;ja=$a<<16>>16<kb<<16>>16;Ta=ja?$a:kb;fa=ja?kb:$a;$a=Ca<<16>>16<Ta<<16>>16;kb=$a?Ca:Ta;ja=$a?Ta:Ca;Ca=fa<<16>>16<W<<16>>16;Ta=Ca?fa:W;$a=Ca?W:fa;fa=Za<<16>>16<za<<16>>16;W=fa?Za:za;Ca=fa?za:Za;Za=W<<16>>16<Ba<<16>>16;za=Za?W:Ba;fa=Za?Ba:W;W=Ca<<16>>16<fa<<16>>16;Ba=W?Ca:fa;Za=W?fa:Ca;Ca=zb<<16>>16<ib<<16>>16;fa=Ca?zb:ib;W=Ca?ib:zb;zb=Ra<<16>>16<ta<<16>>16;ib=zb?Ra:ta;Ca=zb?ta:Ra;Ra=ib<<16>>16<fa<<16>>16;ta=Ra?ib:fa;zb=Ra?fa:ib;ib=Ca<<16>>16<W<<16>>16;fa=ib?Ca:W;Ra=ib?W:Ca;Ca=zb<<16>>16<fa<<16>>16;W=Ca?zb:fa;ib=Ca?fa:zb;zb=ta<<16>>16<za<<16>>16;fa=zb?ta:za;Ca=zb?za:ta;ta=ib<<16>>16<Za<<16>>16;za=ta?ib:Za;zb=ta?Za:ib;ib=Ca<<16>>16<za<<16>>16;Za=ib?Ca:za;ta=ib?za:Ca;Ca=W<<16>>16<Ba<<16>>16;za=Ca?W:Ba;ib=Ca?Ba:W;W=Ra<<16>>16<ib<<16>>16;Ba=W?Ra:ib;Ca=W?ib:Ra;Ra=Za<<16>>16<za<<16>>16;ib=Ra?Za:za;W=Ra?za:Za;Za=Ba<<16>>16<ta<<16>>16;za=Za?Ba:ta;Ra=Za?ta:Ba;Ba=Ca<<16>>16<zb<<16>>16;ta=Ba?Ca:zb;Za=Ba?zb:Ca;Ca=fa<<16>>16<ua<<16>>16;zb=(Ca?fa:ua)<<16>>16;Ba=Ca?ua:fa;fa=Ra<<16>>16<$a<<16>>16;ua=fa?Ra:$a;Ca=fa?$a:Ra;Ra=Ba<<16>>16<ua<<16>>16;$a=Ra?Ba:ua;fa=Ra?ua:Ba;Ba=W<<16>>16<ja<<16>>16;ua=Ba?W:ja;Ra=Ba?ja:W;W=Za<<16>>16<Ra<<16>>16;ja=W?Za:Ra;Ba=W?Ra:Za;Za=$a<<16>>16<ua<<16>>16;Ra=Za?$a:ua;W=Za?ua:$a;$a=ja<<16>>16<fa<<16>>16;ua=$a?ja:fa;Za=$a?fa:ja;ja=Ba<<16>>16<Ca<<16>>16;fa=ja?Ba:Ca;$a=ja?Ca:Ba;Ba=ib<<16>>16<kb<<16>>16;Ca=Ba?ib:kb;ja=Ba?kb:ib;ib=ta<<16>>16<Ab<<16>>16;kb=ib?ta:Ab;Ba=ib?Ab:ta;ta=ja<<16>>16<kb<<16>>16;Ab=ta?ja:kb;ib=ta?kb:ja;ja=za<<16>>16<Ta<<16>>16;kb=ja?za:Ta;ta=ja?Ta:za;za=Ab<<16>>16<kb<<16>>16;Ta=za?Ab:kb;ja=za?kb:Ab;Ab=ta<<16>>16<ib<<16>>16;kb=Ab?ta:ib;za=Ab?ib:ta;ta=Ra<<16>>16<Ca<<16>>16;ib=(ta?Ra:Ca)<<16>>16;Ab=(ta?Ca:Ra)<<16>>16;Ra=W<<16>>16<Ta<<16>>16;Ca=(Ra?W:Ta)<<16>>16;ta=(Ra?Ta:W)<<16>>16;W=ua<<16>>16<ja<<16>>16;Ta=(W?ua:ja)<<16>>16;Ra=(W?ja:ua)<<16>>16;ua=Za<<16>>16<kb<<16>>16;ja=(ua?Za:kb)<<16>>16;W=(ua?kb:Za)<<16>>16;Za=fa<<16>>16<za<<16>>16;kb=(Za?fa:za)<<16>>16;ua=(Za?za:fa)<<16>>16;fa=$a<<16>>16<Ba<<16>>16;za=(fa?$a:Ba)<<16>>16;Za=(fa?Ba:$a)<<16>>16;$a=(zb|0)<(ra|0)?ra:zb;zb=(W|0)<($|0)?W:$;$=($a|0)<(zb|0)?zb:$a;$a=(ta|0)<(Db|0)?Db:ta;ta=(Za|0)<($a|0)?Za:$a;$a=(ta|0)<($|0)?ta:$;$=(Ab|0)<(yb|0)?yb:Ab;Ab=(ua|0)<(jb|0)?ua:jb;jb=($|0)<(Ab|0)?$:Ab;Ab=(Ra|0)<(pa|0)?Ra:pa;pa=(jb|0)<(Ab|0)?Ab:jb;jb=($a|0)<(pa|0)?pa:$a;$a=(ib|0)<(ha|0)?ha:ib;ib=(kb|0)<(Ya|0)?kb:Ya;Ya=($a|0)<(ib|0)?ib:$a;$a=(Ta|0)<(Xa|0)?Xa:Ta;Ta=($a|0)<(Ya|0)?$a:Ya;Ya=(Ca|0)<(Bb|0)?Bb:Ca;Ca=(za|0)<(qa|0)?za:qa;qa=(Ya|0)<(Ca|0)?Ya:Ca;Ca=(ja|0)<(Cb|0)?ja:Cb;Cb=(qa|0)<(Ca|0)?Ca:qa;qa=(Ta|0)<(Cb|0)?Ta:Cb;d[Wa+(gc<<1)>>1]=(jb|0)<(qa|0)?qa:jb;jb=gc+1|0;if((gc|0)<(sa|0))gc=jb;else{hb=jb;db=la;continue j}}}if((ka|0)==(Ea|0))break;else Wa=Wa+(Ja<<1)|0}}break}default:{}}while(0);break a;break}case 5:{Ja=f[Q+16>>2]|0;Ea=f[Ua>>2]|0;Ga=(f[V>>2]|0)>>>2;ma=(f[P+48>>2]|0)>>>2;wa=f[P+40>>2]|0;Da=f[wa+4>>2]|0;Ma=f[wa>>2]|0;wa=na>>>3;ga=wa&511;Aa=ga+1|0;b[i>>0]=0;k:do switch(e|0){case 3:{Wa=(Ma|0)==1;if((Da|0)==1|Wa){ka=Ma+Da|0;la=ka+-1|0;sa=Wa?Aa:Ga;Fa=Wa?0:Ga-Aa|0;Ka=Wa?Aa:ma;if((ka|0)<=1)break k;Wa=0-sa|0;va=ka+-2|0;ka=Ea;La=0;ya=Ja;while(1){Z=(La|0)>0?Wa:0;db=(La|0)<(va|0)?sa:0;hb=0;xa=ya;while(1){Qa=f[xa+(Z<<2)>>2]|0;f[k>>2]=Qa;oa=f[xa>>2]|0;f[l>>2]=oa;ia=+n[xa+(db<<2)>>2];hc=(f[s>>2]=Qa,+n[s>>2]);ic=(f[s>>2]=oa,+n[s>>2]);oa=ic<hc;jc=+n[(oa?l:k)>>2];kc=oa?hc:ic;ic=ia<kc?ia:kc;n[ka+(hb<<2)>>2]=ic<jc?jc:ic;hb=hb+1|0;if((hb|0)==(Aa|0))break;else xa=xa+4|0}La=La+1|0;if((La|0)>=(la|0))break k;else{ka=ka+(Ka<<2)|0;ya=ya+(Aa<<2)+(Fa<<2)|0}}}Fa=Y(Da,Aa)|0;if((Ma|0)>0){ya=Ma+-1|0;Ka=(wa|-512)^511;ka=Ka+-1+Fa|0;la=Fa-Aa|0;La=Ea;sa=0;while(1){va=sa+-1|0;Wa=Ja+((Y((va|0)>0?va:0,Ga)|0)<<2)|0;va=Ja+((Y(sa,Ga)|0)<<2)|0;sa=sa+1|0;xa=Ja+((Y((ya|0)<(sa|0)?ya:sa,Ga)|0)<<2)|0;hb=0;db=b[i>>0]&1?Aa:Fa;l:while(1){if((hb|0)<(db|0)){Z=hb;do{oa=Z-((Z|0)>(ga|0)?Aa:0)|0;Qa=((Z|0)<(la|0)?Aa:0)+Z|0;gb=f[Wa+(oa<<2)>>2]|0;Ha=f[Wa+(Z<<2)>>2]|0;f[k>>2]=Ha;jb=f[Wa+(Qa<<2)>>2]|0;f[l>>2]=jb;qa=f[va+(oa<<2)>>2]|0;Cb=f[va+(Z<<2)>>2]|0;f[m>>2]=Cb;Ta=f[va+(Qa<<2)>>2]|0;f[o>>2]=Ta;Ca=f[xa+(oa<<2)>>2]|0;oa=f[xa+(Z<<2)>>2]|0;f[p>>2]=oa;ja=f[xa+(Qa<<2)>>2]|0;f[q>>2]=ja;ic=(f[s>>2]=Ha,+n[s>>2]);jc=(f[s>>2]=jb,+n[s>>2]);jb=jc<ic;Ha=f[(jb?l:k)>>2]|0;kc=jb?ic:jc;n[l>>2]=kc;jc=(f[s>>2]=Cb,+n[s>>2]);ic=(f[s>>2]=Ta,+n[s>>2]);Ta=ic<jc;Cb=f[(Ta?o:m)>>2]|0;ia=Ta?jc:ic;n[o>>2]=ia;ic=(f[s>>2]=oa,+n[s>>2]);jc=(f[s>>2]=ja,+n[s>>2]);ja=jc<ic;oa=f[(ja?q:p)>>2]|0;hc=ja?ic:jc;n[q>>2]=hc;jc=(f[s>>2]=gb,+n[s>>2]);ic=(f[s>>2]=Ha,+n[s>>2]);ja=ic<jc;lc=ja?jc:ic;n[k>>2]=lc;ic=(f[s>>2]=qa,+n[s>>2]);jc=(f[s>>2]=Cb,+n[s>>2]);Ta=jc<ic;mc=Ta?ic:jc;n[m>>2]=mc;jc=(f[s>>2]=Ca,+n[s>>2]);ic=(f[s>>2]=oa,+n[s>>2]);jb=ic<jc;nc=jb?jc:ic;n[p>>2]=nc;Qa=kc<lc;ic=Qa?+n[l>>2]:+n[k>>2];jc=Qa?lc:kc;n[l>>2]=jc;Qa=ia<mc;Ya=f[(Qa?o:m)>>2]|0;f[m>>2]=Ya;kc=Qa?mc:ia;n[o>>2]=kc;Qa=hc<nc;za=f[(Qa?q:p)>>2]|0;f[p>>2]=za;ia=Qa?nc:hc;n[q>>2]=ia;hc=(f[s>>2]=ja?Ha:gb,+n[s>>2]);nc=(f[s>>2]=Ta?Cb:qa,+n[s>>2]);mc=nc<hc?hc:nc;qa=f[(ia<kc?q:o)>>2]|0;f[o>>2]=qa;kc=(f[s>>2]=Ya,+n[s>>2]);ia=(f[s>>2]=za,+n[s>>2]);za=ia<kc;nc=za?+n[p>>2]:+n[m>>2];hc=za?kc:ia;n[p>>2]=hc;ia=(f[s>>2]=jb?oa:Ca,+n[s>>2]);kc=ia<mc?mc:ia;ia=nc<ic?ic:nc;n[m>>2]=ia;Ca=f[((f[s>>2]=qa,+n[s>>2])<jc?o:l)>>2]|0;f[l>>2]=Ca;qa=f[(hc<ia?p:m)>>2]|0;f[m>>2]=qa;ia=(f[s>>2]=qa,+n[s>>2]);hc=(f[s>>2]=Ca,+n[s>>2]);Ca=hc<ia;jc=Ca?+n[l>>2]:(f[s>>2]=qa,+n[s>>2]);nc=Ca?ia:hc;n[l>>2]=nc;hc=jc<kc?kc:jc;n[m>>2]=hc;f[La+(Z<<2)>>2]=f[(nc<hc?l:m)>>2];Z=Z+1|0}while((Z|0)!=(db|0));oc=db}else oc=hb;if((db|0)==(Fa|0))break;if((oc|0)>(ka|0)){hb=oc;db=Fa;continue}else pc=oc;while(1){Z=Wa+(pc<<2)|0;Ca=f[Z+(Ka<<2)>>2]|0;qa=f[Z>>2]|0;f[k>>2]=qa;oa=f[Z+(Aa<<2)>>2]|0;f[l>>2]=oa;Z=va+(pc<<2)|0;jb=f[Z+(Ka<<2)>>2]|0;za=f[Z>>2]|0;f[m>>2]=za;Ya=f[Z+(Aa<<2)>>2]|0;f[o>>2]=Ya;Z=xa+(pc<<2)|0;Cb=f[Z+(Ka<<2)>>2]|0;Ta=f[Z>>2]|0;f[p>>2]=Ta;gb=f[Z+(Aa<<2)>>2]|0;f[q>>2]=gb;hc=(f[s>>2]=qa,+n[s>>2]);nc=(f[s>>2]=oa,+n[s>>2]);oa=nc<hc;qa=f[(oa?l:k)>>2]|0;jc=oa?hc:nc;n[l>>2]=jc;nc=(f[s>>2]=za,+n[s>>2]);hc=(f[s>>2]=Ya,+n[s>>2]);Ya=hc<nc;za=f[(Ya?o:m)>>2]|0;kc=Ya?nc:hc;n[o>>2]=kc;hc=(f[s>>2]=Ta,+n[s>>2]);nc=(f[s>>2]=gb,+n[s>>2]);gb=nc<hc;Ta=f[(gb?q:p)>>2]|0;ia=gb?hc:nc;n[q>>2]=ia;nc=(f[s>>2]=Ca,+n[s>>2]);hc=(f[s>>2]=qa,+n[s>>2]);gb=hc<nc;ic=gb?nc:hc;n[k>>2]=ic;hc=(f[s>>2]=jb,+n[s>>2]);nc=(f[s>>2]=za,+n[s>>2]);Ya=nc<hc;mc=Ya?hc:nc;n[m>>2]=mc;nc=(f[s>>2]=Cb,+n[s>>2]);hc=(f[s>>2]=Ta,+n[s>>2]);oa=hc<nc;lc=oa?nc:hc;n[p>>2]=lc;Z=jc<ic;hc=Z?+n[l>>2]:+n[k>>2];nc=Z?ic:jc;n[l>>2]=nc;Z=kc<mc;Ha=f[(Z?o:m)>>2]|0;f[m>>2]=Ha;jc=Z?mc:kc;n[o>>2]=jc;Z=ia<lc;ja=f[(Z?q:p)>>2]|0;f[p>>2]=ja;kc=Z?lc:ia;n[q>>2]=kc;ia=(f[s>>2]=gb?qa:Ca,+n[s>>2]);lc=(f[s>>2]=Ya?za:jb,+n[s>>2]);mc=lc<ia?ia:lc;jb=f[(kc<jc?q:o)>>2]|0;f[o>>2]=jb;jc=(f[s>>2]=Ha,+n[s>>2]);kc=(f[s>>2]=ja,+n[s>>2]);ja=kc<jc;lc=ja?+n[p>>2]:+n[m>>2];ia=ja?jc:kc;n[p>>2]=ia;kc=(f[s>>2]=oa?Ta:Cb,+n[s>>2]);jc=kc<mc?mc:kc;kc=lc<hc?hc:lc;n[m>>2]=kc;Cb=f[((f[s>>2]=jb,+n[s>>2])<nc?o:l)>>2]|0;f[l>>2]=Cb;jb=f[(ia<kc?p:m)>>2]|0;f[m>>2]=jb;kc=(f[s>>2]=jb,+n[s>>2]);ia=(f[s>>2]=Cb,+n[s>>2]);Cb=ia<kc;nc=Cb?+n[l>>2]:(f[s>>2]=jb,+n[s>>2]);lc=Cb?kc:ia;n[l>>2]=lc;ia=nc<jc?jc:nc;n[m>>2]=ia;f[La+(pc<<2)>>2]=f[(lc<ia?l:m)>>2];Cb=pc+1|0;if((pc|0)<(ka|0))pc=Cb;else{hb=Cb;db=Fa;continue l}}}if((sa|0)==(Ma|0))break;else La=La+(ma<<2)|0}}break}case 5:{La=(Ma|0)==1;if((Da|0)==1|La){sa=Ma+Da|0;Fa=sa+-1|0;ka=La?Aa:Ga;Ka=La?0:Ga-Aa|0;la=La?Aa:ma;if((sa|0)<=1)break k;La=0-ka|0;ya=La<<1;db=sa+-2|0;hb=sa+-3|0;sa=ka<<1;xa=Ea;va=0;Wa=Ja;while(1){Cb=(va|0)>0?La:0;jb=(va|0)>1?ya:Cb;Ta=(va|0)<(db|0)?ka:0;oa=(va|0)<(hb|0)?sa:Ta;ja=0;Ha=Wa;while(1){za=f[Ha+(jb<<2)>>2]|0;f[k>>2]=za;Ya=f[Ha+(Cb<<2)>>2]|0;f[l>>2]=Ya;Ca=f[Ha>>2]|0;f[m>>2]=Ca;qa=f[Ha+(Ta<<2)>>2]|0;f[o>>2]=qa;gb=f[Ha+(oa<<2)>>2]|0;f[p>>2]=gb;ia=(f[s>>2]=za,+n[s>>2]);lc=(f[s>>2]=Ya,+n[s>>2]);Ya=lc<ia;nc=+n[(Ya?l:k)>>2];jc=Ya?ia:lc;lc=(f[s>>2]=qa,+n[s>>2]);ia=(f[s>>2]=gb,+n[s>>2]);gb=ia<lc;qa=f[(gb?p:o)>>2]|0;f[o>>2]=qa;kc=gb?lc:ia;n[p>>2]=kc;ia=(f[s>>2]=Ca,+n[s>>2]);lc=(f[s>>2]=qa,+n[s>>2]);Ca=lc<ia;hc=Ca?(f[s>>2]=qa,+n[s>>2]):+n[m>>2];mc=Ca?ia:lc;n[o>>2]=mc;Ca=kc<mc;lc=Ca?+n[p>>2]:mc;ia=Ca?mc:kc;n[p>>2]=ia;kc=hc<nc?nc:hc;n[m>>2]=kc;hc=ia<kc?ia:kc;kc=lc<jc?lc:jc;n[xa+(ja<<2)>>2]=hc<kc?kc:hc;ja=ja+1|0;if((ja|0)==(Aa|0))break;else Ha=Ha+4|0}va=va+1|0;if((va|0)>=(Fa|0))break k;else{xa=xa+(la<<2)|0;Wa=Wa+(Aa<<2)+(Ka<<2)|0}}}Ka=Y(Da,Aa)|0;if((Ma|0)>0){Wa=Ma+-1|0;la=Aa<<1;xa=0-la|0;Fa=Ka+~la|0;va=(wa|-512)^511;sa=Ka-Aa|0;hb=Ka-la|0;ka=Ea;db=0;while(1){ya=db+-2|0;La=Ja+((Y((ya|0)>0?ya:0,Ga)|0)<<2)|0;ya=db+-1|0;Ha=Ja+((Y((ya|0)>0?ya:0,Ga)|0)<<2)|0;ya=Ja+((Y(db,Ga)|0)<<2)|0;ja=db;db=db+1|0;oa=Ja+((Y((Wa|0)<(db|0)?Wa:db,Ga)|0)<<2)|0;Ta=ja+2|0;ja=Ja+((Y((Wa|0)<(Ta|0)?Wa:Ta,Ga)|0)<<2)|0;Ta=0;Cb=b[i>>0]&1?la:Ka;m:while(1){if((Ta|0)<(Cb|0)){jb=Ta;do{Ca=jb-((jb|0)>(ga|0)?Aa:0)|0;qa=(jb|0)<(la|0)?Ca:jb-la|0;gb=((jb|0)<(sa|0)?Aa:0)+jb|0;Ya=(jb|0)<(hb|0)?jb+la|0:gb;f[k>>2]=f[La+(qa<<2)>>2];za=f[La+(Ca<<2)>>2]|0;f[l>>2]=za;Z=f[La+(jb<<2)>>2]|0;f[m>>2]=Z;f[o>>2]=f[La+(gb<<2)>>2];f[p>>2]=f[La+(Ya<<2)>>2];f[q>>2]=f[Ha+(qa<<2)>>2];f[r>>2]=f[Ha+(Ca<<2)>>2];f[t>>2]=f[Ha+(jb<<2)>>2];f[v>>2]=f[Ha+(gb<<2)>>2];f[w>>2]=f[Ha+(Ya<<2)>>2];f[x>>2]=f[ya+(qa<<2)>>2];f[y>>2]=f[ya+(Ca<<2)>>2];f[z>>2]=f[ya+(jb<<2)>>2];f[A>>2]=f[ya+(gb<<2)>>2];f[B>>2]=f[ya+(Ya<<2)>>2];f[C>>2]=f[oa+(qa<<2)>>2];f[D>>2]=f[oa+(Ca<<2)>>2];f[E>>2]=f[oa+(jb<<2)>>2];f[F>>2]=f[oa+(gb<<2)>>2];f[G>>2]=f[oa+(Ya<<2)>>2];f[H>>2]=f[ja+(qa<<2)>>2];f[I>>2]=f[ja+(Ca<<2)>>2];f[J>>2]=f[ja+(jb<<2)>>2];f[K>>2]=f[ja+(gb<<2)>>2];f[L>>2]=f[ja+(Ya<<2)>>2];hc=(f[s>>2]=za,+n[s>>2]);kc=(f[s>>2]=Z,+n[s>>2]);Z=kc<hc;za=f[(Z?m:l)>>2]|0;f[l>>2]=za;jc=Z?hc:kc;n[m>>2]=jc;kc=+n[k>>2];hc=(f[s>>2]=za,+n[s>>2]);za=hc<kc;Z=f[(za?l:k)>>2]|0;f[k>>2]=Z;lc=za?kc:hc;n[l>>2]=lc;za=jc<lc;Ya=f[(za?m:l)>>2]|0;f[l>>2]=Ya;hc=za?lc:jc;n[m>>2]=hc;jc=+n[p>>2];lc=+n[q>>2];za=lc<jc;gb=f[(za?q:p)>>2]|0;f[p>>2]=gb;kc=za?jc:lc;n[q>>2]=kc;lc=+n[o>>2];jc=(f[s>>2]=gb,+n[s>>2]);gb=jc<lc;za=f[(gb?p:o)>>2]|0;f[o>>2]=za;ia=gb?lc:jc;n[p>>2]=ia;gb=kc<ia;Ca=f[(gb?q:p)>>2]|0;f[p>>2]=Ca;jc=gb?ia:kc;n[q>>2]=jc;kc=(f[s>>2]=Z,+n[s>>2]);ia=(f[s>>2]=za,+n[s>>2]);za=ia<kc;f[k>>2]=f[(za?o:k)>>2];lc=za?kc:ia;n[o>>2]=lc;za=jc<hc;Z=f[(za?q:m)>>2]|0;f[m>>2]=Z;n[q>>2]=za?hc:jc;jc=(f[s>>2]=Z,+n[s>>2]);Z=lc<jc;za=f[(Z?o:m)>>2]|0;f[m>>2]=za;hc=Z?jc:lc;n[o>>2]=hc;lc=(f[s>>2]=Ya,+n[s>>2]);jc=(f[s>>2]=Ca,+n[s>>2]);Ca=jc<lc;Ya=f[(Ca?p:l)>>2]|0;f[l>>2]=Ya;ia=Ca?lc:jc;n[p>>2]=ia;jc=(f[s>>2]=Ya,+n[s>>2]);lc=(f[s>>2]=za,+n[s>>2]);za=lc<jc;f[l>>2]=f[(za?m:l)>>2];n[m>>2]=za?jc:lc;za=ia<hc;f[o>>2]=f[(za?p:o)>>2];n[p>>2]=za?hc:ia;ia=+n[t>>2];hc=+n[v>>2];za=hc<ia;Ya=f[(za?v:t)>>2]|0;f[t>>2]=Ya;lc=za?ia:hc;n[v>>2]=lc;hc=+n[r>>2];ia=(f[s>>2]=Ya,+n[s>>2]);Ya=ia<hc;za=f[(Ya?t:r)>>2]|0;f[r>>2]=za;jc=Ya?hc:ia;n[t>>2]=jc;Ya=lc<jc;Ca=f[(Ya?v:t)>>2]|0;f[t>>2]=Ca;ia=Ya?jc:lc;n[v>>2]=ia;lc=+n[x>>2];jc=+n[y>>2];Ya=jc<lc;Z=f[(Ya?y:x)>>2]|0;f[x>>2]=Z;hc=Ya?lc:jc;n[y>>2]=hc;jc=+n[w>>2];lc=(f[s>>2]=Z,+n[s>>2]);Z=lc<jc;Ya=f[(Z?x:w)>>2]|0;f[w>>2]=Ya;kc=Z?jc:lc;n[x>>2]=kc;Z=hc<kc;gb=f[(Z?y:x)>>2]|0;f[x>>2]=gb;lc=Z?kc:hc;n[y>>2]=lc;hc=(f[s>>2]=za,+n[s>>2]);kc=(f[s>>2]=Ya,+n[s>>2]);Ya=kc<hc;za=f[(Ya?w:r)>>2]|0;f[r>>2]=za;jc=Ya?hc:kc;n[w>>2]=jc;Ya=lc<ia;Z=f[(Ya?y:v)>>2]|0;f[v>>2]=Z;kc=Ya?ia:lc;n[y>>2]=kc;lc=(f[s>>2]=Z,+n[s>>2]);Z=jc<lc;Ya=f[(Z?w:v)>>2]|0;f[v>>2]=Ya;ia=Z?lc:jc;n[w>>2]=ia;jc=(f[s>>2]=Ca,+n[s>>2]);lc=(f[s>>2]=gb,+n[s>>2]);gb=lc<jc;Ca=f[(gb?x:t)>>2]|0;f[t>>2]=Ca;hc=gb?jc:lc;n[x>>2]=hc;lc=(f[s>>2]=Ca,+n[s>>2]);jc=(f[s>>2]=Ya,+n[s>>2]);Ya=jc<lc;Ca=f[(Ya?v:t)>>2]|0;f[t>>2]=Ca;nc=Ya?lc:jc;n[v>>2]=nc;Ya=hc<ia;gb=f[(Ya?x:w)>>2]|0;f[w>>2]=gb;jc=Ya?ia:hc;n[x>>2]=jc;hc=+n[k>>2];ia=(f[s>>2]=za,+n[s>>2]);za=ia<hc;f[k>>2]=f[(za?r:k)>>2];lc=za?hc:ia;n[r>>2]=lc;ia=+n[p>>2];za=jc<ia;Ya=f[(za?x:p)>>2]|0;f[p>>2]=Ya;n[x>>2]=za?ia:jc;jc=(f[s>>2]=Ya,+n[s>>2]);Ya=lc<jc;za=f[(Ya?r:p)>>2]|0;f[p>>2]=za;ia=Ya?jc:lc;n[r>>2]=ia;lc=+n[m>>2];Ya=nc<lc;Z=f[(Ya?v:m)>>2]|0;f[m>>2]=Z;jc=Ya?lc:nc;n[v>>2]=jc;nc=(f[s>>2]=Z,+n[s>>2]);lc=(f[s>>2]=za,+n[s>>2]);za=lc<nc;Z=f[(za?p:m)>>2]|0;f[m>>2]=Z;hc=za?nc:lc;n[p>>2]=hc;za=jc<ia;Ya=f[(za?v:r)>>2]|0;f[r>>2]=Ya;lc=za?ia:jc;n[v>>2]=lc;jc=+n[l>>2];ia=(f[s>>2]=Ca,+n[s>>2]);Ca=ia<jc;za=f[(Ca?t:l)>>2]|0;f[l>>2]=za;nc=Ca?jc:ia;n[t>>2]=nc;ia=+n[q>>2];Ca=kc<ia;qa=f[(Ca?y:q)>>2]|0;f[q>>2]=qa;n[y>>2]=Ca?ia:kc;kc=(f[s>>2]=qa,+n[s>>2]);qa=nc<kc;Ca=f[(qa?t:q)>>2]|0;f[q>>2]=Ca;ia=qa?kc:nc;n[t>>2]=ia;nc=+n[o>>2];kc=(f[s>>2]=gb,+n[s>>2]);gb=kc<nc;qa=f[(gb?w:o)>>2]|0;f[o>>2]=qa;jc=gb?nc:kc;n[w>>2]=jc;kc=(f[s>>2]=qa,+n[s>>2]);nc=(f[s>>2]=Ca,+n[s>>2]);Ca=nc<kc;qa=f[(Ca?q:o)>>2]|0;f[o>>2]=qa;mc=Ca?kc:nc;n[q>>2]=mc;Ca=jc<ia;gb=f[(Ca?w:t)>>2]|0;f[t>>2]=gb;nc=Ca?ia:jc;n[w>>2]=nc;jc=(f[s>>2]=za,+n[s>>2]);ia=(f[s>>2]=Z,+n[s>>2]);Z=ia<jc;f[l>>2]=f[(Z?m:l)>>2];n[m>>2]=Z?jc:ia;ia=(f[s>>2]=qa,+n[s>>2]);qa=hc<ia;f[o>>2]=f[(qa?p:o)>>2];n[p>>2]=qa?ia:hc;hc=(f[s>>2]=Ya,+n[s>>2]);Ya=hc<mc;f[q>>2]=f[(Ya?r:q)>>2];n[r>>2]=Ya?mc:hc;hc=(f[s>>2]=gb,+n[s>>2]);gb=lc<hc;f[t>>2]=f[(gb?v:t)>>2];n[v>>2]=gb?hc:lc;lc=+n[x>>2];gb=lc<nc;f[w>>2]=f[(gb?x:w)>>2];n[x>>2]=gb?nc:lc;lc=+n[A>>2];nc=+n[B>>2];gb=nc<lc;Ya=f[(gb?B:A)>>2]|0;f[A>>2]=Ya;hc=gb?lc:nc;n[B>>2]=hc;nc=+n[z>>2];lc=(f[s>>2]=Ya,+n[s>>2]);Ya=lc<nc;gb=f[(Ya?A:z)>>2]|0;f[z>>2]=gb;mc=Ya?nc:lc;n[A>>2]=mc;Ya=hc<mc;qa=f[(Ya?B:A)>>2]|0;f[A>>2]=qa;lc=Ya?mc:hc;n[B>>2]=lc;hc=+n[D>>2];mc=+n[E>>2];Ya=mc<hc;Z=f[(Ya?E:D)>>2]|0;f[D>>2]=Z;nc=Ya?hc:mc;n[E>>2]=nc;mc=+n[C>>2];hc=(f[s>>2]=Z,+n[s>>2]);Z=hc<mc;Ya=f[(Z?D:C)>>2]|0;f[C>>2]=Ya;ia=Z?mc:hc;n[D>>2]=ia;Z=nc<ia;za=f[(Z?E:D)>>2]|0;f[D>>2]=za;hc=Z?ia:nc;n[E>>2]=hc;nc=(f[s>>2]=gb,+n[s>>2]);ia=(f[s>>2]=Ya,+n[s>>2]);Ya=ia<nc;f[z>>2]=f[(Ya?C:z)>>2];mc=Ya?nc:ia;n[C>>2]=mc;Ya=hc<lc;gb=f[(Ya?E:B)>>2]|0;f[B>>2]=gb;n[E>>2]=Ya?lc:hc;hc=(f[s>>2]=gb,+n[s>>2]);gb=mc<hc;Ya=f[(gb?C:B)>>2]|0;f[B>>2]=Ya;lc=gb?hc:mc;n[C>>2]=lc;mc=(f[s>>2]=qa,+n[s>>2]);hc=(f[s>>2]=za,+n[s>>2]);za=hc<mc;qa=f[(za?D:A)>>2]|0;f[A>>2]=qa;ia=za?mc:hc;n[D>>2]=ia;hc=(f[s>>2]=qa,+n[s>>2]);mc=(f[s>>2]=Ya,+n[s>>2]);Ya=mc<hc;f[A>>2]=f[(Ya?B:A)>>2];n[B>>2]=Ya?hc:mc;Ya=ia<lc;f[C>>2]=f[(Ya?D:C)>>2];n[D>>2]=Ya?lc:ia;ia=+n[G>>2];lc=+n[H>>2];Ya=lc<ia;qa=f[(Ya?H:G)>>2]|0;f[G>>2]=qa;mc=Ya?ia:lc;n[H>>2]=mc;lc=+n[F>>2];ia=(f[s>>2]=qa,+n[s>>2]);qa=ia<lc;Ya=f[(qa?G:F)>>2]|0;f[F>>2]=Ya;hc=qa?lc:ia;n[G>>2]=hc;qa=mc<hc;za=f[(qa?H:G)>>2]|0;f[G>>2]=za;ia=qa?hc:mc;n[H>>2]=ia;mc=+n[I>>2];hc=+n[J>>2];qa=hc<mc;gb=f[(qa?J:I)>>2]|0;f[I>>2]=gb;lc=qa?mc:hc;n[J>>2]=lc;hc=+n[K>>2];mc=+n[L>>2];qa=mc<hc;Z=f[(qa?L:K)>>2]|0;f[K>>2]=Z;nc=qa?hc:mc;n[L>>2]=nc;mc=(f[s>>2]=gb,+n[s>>2]);hc=(f[s>>2]=Z,+n[s>>2]);Z=hc<mc;gb=f[(Z?K:I)>>2]|0;f[I>>2]=gb;jc=Z?mc:hc;n[K>>2]=jc;Z=nc<lc;qa=f[(Z?L:J)>>2]|0;f[J>>2]=qa;hc=Z?lc:nc;n[L>>2]=hc;nc=(f[s>>2]=qa,+n[s>>2]);qa=jc<nc;Z=f[(qa?K:J)>>2]|0;f[J>>2]=Z;lc=qa?nc:jc;n[K>>2]=lc;jc=(f[s>>2]=Ya,+n[s>>2]);nc=(f[s>>2]=gb,+n[s>>2]);gb=nc<jc;Ya=f[(gb?I:F)>>2]|0;f[F>>2]=Ya;mc=gb?jc:nc;n[I>>2]=mc;gb=lc<ia;qa=f[(gb?K:H)>>2]|0;f[H>>2]=qa;nc=gb?ia:lc;n[K>>2]=nc;lc=(f[s>>2]=qa,+n[s>>2]);qa=mc<lc;gb=f[(qa?I:H)>>2]|0;f[H>>2]=gb;ia=qa?lc:mc;n[I>>2]=ia;mc=(f[s>>2]=za,+n[s>>2]);lc=(f[s>>2]=Z,+n[s>>2]);Z=lc<mc;za=f[(Z?J:G)>>2]|0;f[G>>2]=za;jc=Z?mc:lc;n[J>>2]=jc;Z=hc<jc;qa=f[(Z?L:J)>>2]|0;f[J>>2]=qa;lc=Z?jc:hc;n[L>>2]=lc;hc=(f[s>>2]=za,+n[s>>2]);jc=(f[s>>2]=gb,+n[s>>2]);gb=jc<hc;za=f[(gb?H:G)>>2]|0;f[G>>2]=za;mc=gb?hc:jc;n[H>>2]=mc;jc=(f[s>>2]=qa,+n[s>>2]);qa=jc<ia;f[I>>2]=f[(qa?J:I)>>2];hc=qa?ia:jc;n[J>>2]=hc;qa=lc<nc;gb=f[(qa?L:K)>>2]|0;f[K>>2]=gb;jc=qa?nc:lc;n[L>>2]=jc;lc=+n[z>>2];nc=(f[s>>2]=Ya,+n[s>>2]);Ya=nc<lc;f[z>>2]=f[(Ya?F:z)>>2];ia=Ya?lc:nc;n[F>>2]=ia;nc=+n[D>>2];Ya=hc<nc;qa=f[(Ya?J:D)>>2]|0;f[D>>2]=qa;lc=Ya?nc:hc;n[J>>2]=lc;hc=(f[s>>2]=qa,+n[s>>2]);qa=ia<hc;Ya=f[(qa?F:D)>>2]|0;f[D>>2]=Ya;nc=qa?hc:ia;n[F>>2]=nc;ia=+n[B>>2];qa=mc<ia;Z=f[(qa?H:B)>>2]|0;f[B>>2]=Z;hc=qa?ia:mc;n[H>>2]=hc;qa=jc<hc;Ca=f[(qa?L:H)>>2]|0;f[H>>2]=Ca;mc=qa?hc:jc;n[L>>2]=mc;jc=(f[s>>2]=Z,+n[s>>2]);hc=(f[s>>2]=Ya,+n[s>>2]);Ya=hc<jc;Z=f[(Ya?D:B)>>2]|0;f[B>>2]=Z;ia=Ya?jc:hc;n[D>>2]=ia;hc=(f[s>>2]=Ca,+n[s>>2]);Ca=hc<nc;Ya=f[(Ca?H:F)>>2]|0;f[F>>2]=Ya;jc=Ca?nc:hc;n[H>>2]=jc;Ca=mc<lc;qa=f[(Ca?L:J)>>2]|0;f[J>>2]=qa;hc=Ca?lc:mc;n[L>>2]=hc;mc=+n[A>>2];lc=(f[s>>2]=za,+n[s>>2]);za=lc<mc;Ca=f[(za?G:A)>>2]|0;f[A>>2]=Ca;nc=za?mc:lc;n[G>>2]=nc;lc=+n[E>>2];mc=(f[s>>2]=gb,+n[s>>2]);gb=mc<lc;za=f[(gb?K:E)>>2]|0;f[E>>2]=za;kc=gb?lc:mc;n[K>>2]=kc;mc=(f[s>>2]=za,+n[s>>2]);za=nc<mc;gb=f[(za?G:E)>>2]|0;f[E>>2]=gb;lc=za?mc:nc;n[G>>2]=lc;nc=+n[C>>2];mc=+n[I>>2];za=mc<nc;Qa=f[(za?I:C)>>2]|0;f[C>>2]=Qa;ic=za?nc:mc;n[I>>2]=ic;mc=(f[s>>2]=Qa,+n[s>>2]);nc=(f[s>>2]=gb,+n[s>>2]);gb=nc<mc;Qa=f[(gb?E:C)>>2]|0;f[C>>2]=Qa;qc=gb?mc:nc;n[E>>2]=qc;gb=ic<lc;za=f[(gb?I:G)>>2]|0;f[G>>2]=za;nc=gb?lc:ic;n[I>>2]=nc;ic=(f[s>>2]=Ca,+n[s>>2]);lc=(f[s>>2]=Z,+n[s>>2]);Z=lc<ic;f[A>>2]=f[(Z?B:A)>>2];mc=Z?ic:lc;n[B>>2]=mc;lc=(f[s>>2]=Qa,+n[s>>2]);Qa=ia<lc;f[C>>2]=f[(Qa?D:C)>>2];ic=Qa?lc:ia;n[D>>2]=ic;ia=(f[s>>2]=Ya,+n[s>>2]);Ya=ia<qc;f[E>>2]=f[(Ya?F:E)>>2];lc=Ya?qc:ia;n[F>>2]=lc;ia=(f[s>>2]=za,+n[s>>2]);za=jc<ia;f[G>>2]=f[(za?H:G)>>2];qc=za?ia:jc;n[H>>2]=qc;jc=(f[s>>2]=qa,+n[s>>2]);qa=jc<nc;f[I>>2]=f[(qa?J:I)>>2];ia=qa?nc:jc;n[J>>2]=ia;qa=hc<kc;f[K>>2]=f[(qa?L:K)>>2];jc=qa?kc:hc;n[L>>2]=jc;hc=+n[k>>2];kc=+n[z>>2];qa=kc<hc;f[k>>2]=f[(qa?z:k)>>2];nc=qa?hc:kc;n[z>>2]=nc;kc=+n[v>>2];qa=qc<kc;za=f[(qa?H:v)>>2]|0;f[v>>2]=za;n[H>>2]=qa?kc:qc;qc=(f[s>>2]=za,+n[s>>2]);za=nc<qc;f[v>>2]=f[(za?z:v)>>2];kc=za?qc:nc;n[z>>2]=kc;nc=+n[p>>2];za=ic<nc;f[p>>2]=f[(za?D:p)>>2];qc=za?nc:ic;n[D>>2]=qc;za=jc<qc;qa=f[(za?L:D)>>2]|0;f[D>>2]=qa;n[L>>2]=za?qc:jc;jc=(f[s>>2]=qa,+n[s>>2]);qa=jc<kc;za=f[(qa?D:z)>>2]|0;f[z>>2]=za;n[D>>2]=qa?kc:jc;jc=+n[m>>2];qa=mc<jc;f[m>>2]=f[(qa?B:m)>>2];kc=qa?jc:mc;n[B>>2]=kc;qa=f[(ia<+n[x>>2]?J:x)>>2]|0;f[x>>2]=qa;Ya=f[(kc<(f[s>>2]=qa,+n[s>>2])?B:x)>>2]|0;f[x>>2]=Ya;qa=f[(lc<+n[r>>2]?F:r)>>2]|0;f[r>>2]=qa;lc=(f[s>>2]=qa,+n[s>>2]);kc=(f[s>>2]=Ya,+n[s>>2]);ia=kc<lc?lc:kc;n[x>>2]=ia;kc=(f[s>>2]=za,+n[s>>2]);lc=kc<ia?ia:kc;kc=+n[l>>2];ia=+n[A>>2];mc=ia<kc?kc:ia;n[A>>2]=mc;za=f[(+n[I>>2]<+n[w>>2]?I:w)>>2]|0;f[w>>2]=za;ia=(f[s>>2]=za,+n[s>>2]);kc=mc<ia?ia:mc;n[A>>2]=kc;mc=+n[q>>2];ia=+n[E>>2];jc=ia<mc?mc:ia;n[E>>2]=jc;ia=jc<kc?jc:+n[A>>2];jc=+n[o>>2];kc=+n[C>>2];mc=kc<jc?jc:kc;n[C>>2]=mc;za=f[(+n[K>>2]<+n[y>>2]?K:y)>>2]|0;f[y>>2]=za;Ya=mc<(f[s>>2]=za,+n[s>>2]);mc=Ya?+n[C>>2]:(f[s>>2]=za,+n[s>>2]);kc=+n[t>>2];jc=+n[G>>2];qc=jc<kc?jc:kc;kc=mc<qc?qc:mc;mc=ia<kc?ia:kc;n[ka+(jb<<2)>>2]=lc<mc?mc:lc;jb=jb+1|0}while((jb|0)!=(Cb|0));rc=Cb}else rc=Ta;if((Cb|0)==(Ka|0))break;if((rc|0)>(Fa|0)){Ta=rc;Cb=Ka;continue}else sc=rc;while(1){jb=La+(sc<<2)|0;f[k>>2]=f[jb+(xa<<2)>>2];za=f[jb+(va<<2)>>2]|0;f[l>>2]=za;Ya=f[jb>>2]|0;f[m>>2]=Ya;f[o>>2]=f[jb+(Aa<<2)>>2];f[p>>2]=f[jb+(la<<2)>>2];jb=Ha+(sc<<2)|0;f[q>>2]=f[jb+(xa<<2)>>2];f[r>>2]=f[jb+(va<<2)>>2];f[t>>2]=f[jb>>2];f[v>>2]=f[jb+(Aa<<2)>>2];f[w>>2]=f[jb+(la<<2)>>2];jb=ya+(sc<<2)|0;f[x>>2]=f[jb+(xa<<2)>>2];f[y>>2]=f[jb+(va<<2)>>2];f[z>>2]=f[jb>>2];f[A>>2]=f[jb+(Aa<<2)>>2];f[B>>2]=f[jb+(la<<2)>>2];jb=oa+(sc<<2)|0;f[C>>2]=f[jb+(xa<<2)>>2];f[D>>2]=f[jb+(va<<2)>>2];f[E>>2]=f[jb>>2];f[F>>2]=f[jb+(Aa<<2)>>2];f[G>>2]=f[jb+(la<<2)>>2];jb=ja+(sc<<2)|0;f[H>>2]=f[jb+(xa<<2)>>2];f[I>>2]=f[jb+(va<<2)>>2];f[J>>2]=f[jb>>2];f[K>>2]=f[jb+(Aa<<2)>>2];f[L>>2]=f[jb+(la<<2)>>2];lc=(f[s>>2]=za,+n[s>>2]);mc=(f[s>>2]=Ya,+n[s>>2]);Ya=mc<lc;za=f[(Ya?m:l)>>2]|0;f[l>>2]=za;kc=Ya?lc:mc;n[m>>2]=kc;mc=+n[k>>2];lc=(f[s>>2]=za,+n[s>>2]);za=lc<mc;Ya=f[(za?l:k)>>2]|0;f[k>>2]=Ya;ia=za?mc:lc;n[l>>2]=ia;za=kc<ia;jb=f[(za?m:l)>>2]|0;f[l>>2]=jb;lc=za?ia:kc;n[m>>2]=lc;kc=+n[p>>2];ia=+n[q>>2];za=ia<kc;qa=f[(za?q:p)>>2]|0;f[p>>2]=qa;mc=za?kc:ia;n[q>>2]=mc;ia=+n[o>>2];kc=(f[s>>2]=qa,+n[s>>2]);qa=kc<ia;za=f[(qa?p:o)>>2]|0;f[o>>2]=za;qc=qa?ia:kc;n[p>>2]=qc;qa=mc<qc;Qa=f[(qa?q:p)>>2]|0;f[p>>2]=Qa;kc=qa?qc:mc;n[q>>2]=kc;mc=(f[s>>2]=Ya,+n[s>>2]);qc=(f[s>>2]=za,+n[s>>2]);za=qc<mc;f[k>>2]=f[(za?o:k)>>2];ia=za?mc:qc;n[o>>2]=ia;za=kc<lc;Ya=f[(za?q:m)>>2]|0;f[m>>2]=Ya;n[q>>2]=za?lc:kc;kc=(f[s>>2]=Ya,+n[s>>2]);Ya=ia<kc;za=f[(Ya?o:m)>>2]|0;f[m>>2]=za;lc=Ya?kc:ia;n[o>>2]=lc;ia=(f[s>>2]=jb,+n[s>>2]);kc=(f[s>>2]=Qa,+n[s>>2]);Qa=kc<ia;jb=f[(Qa?p:l)>>2]|0;f[l>>2]=jb;qc=Qa?ia:kc;n[p>>2]=qc;kc=(f[s>>2]=jb,+n[s>>2]);ia=(f[s>>2]=za,+n[s>>2]);za=ia<kc;f[l>>2]=f[(za?m:l)>>2];n[m>>2]=za?kc:ia;za=qc<lc;f[o>>2]=f[(za?p:o)>>2];n[p>>2]=za?lc:qc;qc=+n[t>>2];lc=+n[v>>2];za=lc<qc;jb=f[(za?v:t)>>2]|0;f[t>>2]=jb;ia=za?qc:lc;n[v>>2]=ia;lc=+n[r>>2];qc=(f[s>>2]=jb,+n[s>>2]);jb=qc<lc;za=f[(jb?t:r)>>2]|0;f[r>>2]=za;kc=jb?lc:qc;n[t>>2]=kc;jb=ia<kc;Qa=f[(jb?v:t)>>2]|0;f[t>>2]=Qa;qc=jb?kc:ia;n[v>>2]=qc;ia=+n[x>>2];kc=+n[y>>2];jb=kc<ia;Ya=f[(jb?y:x)>>2]|0;f[x>>2]=Ya;lc=jb?ia:kc;n[y>>2]=lc;kc=+n[w>>2];ia=(f[s>>2]=Ya,+n[s>>2]);Ya=ia<kc;jb=f[(Ya?x:w)>>2]|0;f[w>>2]=jb;mc=Ya?kc:ia;n[x>>2]=mc;Ya=lc<mc;qa=f[(Ya?y:x)>>2]|0;f[x>>2]=qa;ia=Ya?mc:lc;n[y>>2]=ia;lc=(f[s>>2]=za,+n[s>>2]);mc=(f[s>>2]=jb,+n[s>>2]);jb=mc<lc;za=f[(jb?w:r)>>2]|0;f[r>>2]=za;kc=jb?lc:mc;n[w>>2]=kc;jb=ia<qc;Ya=f[(jb?y:v)>>2]|0;f[v>>2]=Ya;mc=jb?qc:ia;n[y>>2]=mc;ia=(f[s>>2]=Ya,+n[s>>2]);Ya=kc<ia;jb=f[(Ya?w:v)>>2]|0;f[v>>2]=jb;qc=Ya?ia:kc;n[w>>2]=qc;kc=(f[s>>2]=Qa,+n[s>>2]);ia=(f[s>>2]=qa,+n[s>>2]);qa=ia<kc;Qa=f[(qa?x:t)>>2]|0;f[t>>2]=Qa;lc=qa?kc:ia;n[x>>2]=lc;ia=(f[s>>2]=Qa,+n[s>>2]);kc=(f[s>>2]=jb,+n[s>>2]);jb=kc<ia;Qa=f[(jb?v:t)>>2]|0;f[t>>2]=Qa;jc=jb?ia:kc;n[v>>2]=jc;jb=lc<qc;qa=f[(jb?x:w)>>2]|0;f[w>>2]=qa;kc=jb?qc:lc;n[x>>2]=kc;lc=+n[k>>2];qc=(f[s>>2]=za,+n[s>>2]);za=qc<lc;f[k>>2]=f[(za?r:k)>>2];ia=za?lc:qc;n[r>>2]=ia;qc=+n[p>>2];za=kc<qc;jb=f[(za?x:p)>>2]|0;f[p>>2]=jb;n[x>>2]=za?qc:kc;kc=(f[s>>2]=jb,+n[s>>2]);jb=ia<kc;za=f[(jb?r:p)>>2]|0;f[p>>2]=za;qc=jb?kc:ia;n[r>>2]=qc;ia=+n[m>>2];jb=jc<ia;Ya=f[(jb?v:m)>>2]|0;f[m>>2]=Ya;kc=jb?ia:jc;n[v>>2]=kc;jc=(f[s>>2]=Ya,+n[s>>2]);ia=(f[s>>2]=za,+n[s>>2]);za=ia<jc;Ya=f[(za?p:m)>>2]|0;f[m>>2]=Ya;lc=za?jc:ia;n[p>>2]=lc;za=kc<qc;jb=f[(za?v:r)>>2]|0;f[r>>2]=jb;ia=za?qc:kc;n[v>>2]=ia;kc=+n[l>>2];qc=(f[s>>2]=Qa,+n[s>>2]);Qa=qc<kc;za=f[(Qa?t:l)>>2]|0;f[l>>2]=za;jc=Qa?kc:qc;n[t>>2]=jc;qc=+n[q>>2];Qa=mc<qc;Z=f[(Qa?y:q)>>2]|0;f[q>>2]=Z;n[y>>2]=Qa?qc:mc;mc=(f[s>>2]=Z,+n[s>>2]);Z=jc<mc;Qa=f[(Z?t:q)>>2]|0;f[q>>2]=Qa;qc=Z?mc:jc;n[t>>2]=qc;jc=+n[o>>2];mc=(f[s>>2]=qa,+n[s>>2]);qa=mc<jc;Z=f[(qa?w:o)>>2]|0;f[o>>2]=Z;kc=qa?jc:mc;n[w>>2]=kc;mc=(f[s>>2]=Z,+n[s>>2]);jc=(f[s>>2]=Qa,+n[s>>2]);Qa=jc<mc;Z=f[(Qa?q:o)>>2]|0;f[o>>2]=Z;ic=Qa?mc:jc;n[q>>2]=ic;Qa=kc<qc;qa=f[(Qa?w:t)>>2]|0;f[t>>2]=qa;jc=Qa?qc:kc;n[w>>2]=jc;kc=(f[s>>2]=za,+n[s>>2]);qc=(f[s>>2]=Ya,+n[s>>2]);Ya=qc<kc;f[l>>2]=f[(Ya?m:l)>>2];n[m>>2]=Ya?kc:qc;qc=(f[s>>2]=Z,+n[s>>2]);Z=lc<qc;f[o>>2]=f[(Z?p:o)>>2];n[p>>2]=Z?qc:lc;lc=(f[s>>2]=jb,+n[s>>2]);jb=lc<ic;f[q>>2]=f[(jb?r:q)>>2];n[r>>2]=jb?ic:lc;lc=(f[s>>2]=qa,+n[s>>2]);qa=ia<lc;f[t>>2]=f[(qa?v:t)>>2];n[v>>2]=qa?lc:ia;ia=+n[x>>2];qa=ia<jc;f[w>>2]=f[(qa?x:w)>>2];n[x>>2]=qa?jc:ia;ia=+n[A>>2];jc=+n[B>>2];qa=jc<ia;jb=f[(qa?B:A)>>2]|0;f[A>>2]=jb;lc=qa?ia:jc;n[B>>2]=lc;jc=+n[z>>2];ia=(f[s>>2]=jb,+n[s>>2]);jb=ia<jc;qa=f[(jb?A:z)>>2]|0;f[z>>2]=qa;ic=jb?jc:ia;n[A>>2]=ic;jb=lc<ic;Z=f[(jb?B:A)>>2]|0;f[A>>2]=Z;ia=jb?ic:lc;n[B>>2]=ia;lc=+n[D>>2];ic=+n[E>>2];jb=ic<lc;Ya=f[(jb?E:D)>>2]|0;f[D>>2]=Ya;jc=jb?lc:ic;n[E>>2]=jc;ic=+n[C>>2];lc=(f[s>>2]=Ya,+n[s>>2]);Ya=lc<ic;jb=f[(Ya?D:C)>>2]|0;f[C>>2]=jb;qc=Ya?ic:lc;n[D>>2]=qc;Ya=jc<qc;za=f[(Ya?E:D)>>2]|0;f[D>>2]=za;lc=Ya?qc:jc;n[E>>2]=lc;jc=(f[s>>2]=qa,+n[s>>2]);qc=(f[s>>2]=jb,+n[s>>2]);jb=qc<jc;f[z>>2]=f[(jb?C:z)>>2];ic=jb?jc:qc;n[C>>2]=ic;jb=lc<ia;qa=f[(jb?E:B)>>2]|0;f[B>>2]=qa;n[E>>2]=jb?ia:lc;lc=(f[s>>2]=qa,+n[s>>2]);qa=ic<lc;jb=f[(qa?C:B)>>2]|0;f[B>>2]=jb;ia=qa?lc:ic;n[C>>2]=ia;ic=(f[s>>2]=Z,+n[s>>2]);lc=(f[s>>2]=za,+n[s>>2]);za=lc<ic;Z=f[(za?D:A)>>2]|0;f[A>>2]=Z;qc=za?ic:lc;n[D>>2]=qc;lc=(f[s>>2]=Z,+n[s>>2]);ic=(f[s>>2]=jb,+n[s>>2]);jb=ic<lc;f[A>>2]=f[(jb?B:A)>>2];n[B>>2]=jb?lc:ic;jb=qc<ia;f[C>>2]=f[(jb?D:C)>>2];n[D>>2]=jb?ia:qc;qc=+n[G>>2];ia=+n[H>>2];jb=ia<qc;Z=f[(jb?H:G)>>2]|0;f[G>>2]=Z;ic=jb?qc:ia;n[H>>2]=ic;ia=+n[F>>2];qc=(f[s>>2]=Z,+n[s>>2]);Z=qc<ia;jb=f[(Z?G:F)>>2]|0;f[F>>2]=jb;lc=Z?ia:qc;n[G>>2]=lc;Z=ic<lc;za=f[(Z?H:G)>>2]|0;f[G>>2]=za;qc=Z?lc:ic;n[H>>2]=qc;ic=+n[I>>2];lc=+n[J>>2];Z=lc<ic;qa=f[(Z?J:I)>>2]|0;f[I>>2]=qa;ia=Z?ic:lc;n[J>>2]=ia;lc=+n[K>>2];ic=+n[L>>2];Z=ic<lc;Ya=f[(Z?L:K)>>2]|0;f[K>>2]=Ya;jc=Z?lc:ic;n[L>>2]=jc;ic=(f[s>>2]=qa,+n[s>>2]);lc=(f[s>>2]=Ya,+n[s>>2]);Ya=lc<ic;qa=f[(Ya?K:I)>>2]|0;f[I>>2]=qa;kc=Ya?ic:lc;n[K>>2]=kc;Ya=jc<ia;Z=f[(Ya?L:J)>>2]|0;f[J>>2]=Z;lc=Ya?ia:jc;n[L>>2]=lc;jc=(f[s>>2]=Z,+n[s>>2]);Z=kc<jc;Ya=f[(Z?K:J)>>2]|0;f[J>>2]=Ya;ia=Z?jc:kc;n[K>>2]=ia;kc=(f[s>>2]=jb,+n[s>>2]);jc=(f[s>>2]=qa,+n[s>>2]);qa=jc<kc;jb=f[(qa?I:F)>>2]|0;f[F>>2]=jb;ic=qa?kc:jc;n[I>>2]=ic;qa=ia<qc;Z=f[(qa?K:H)>>2]|0;f[H>>2]=Z;jc=qa?qc:ia;n[K>>2]=jc;ia=(f[s>>2]=Z,+n[s>>2]);Z=ic<ia;qa=f[(Z?I:H)>>2]|0;f[H>>2]=qa;qc=Z?ia:ic;n[I>>2]=qc;ic=(f[s>>2]=za,+n[s>>2]);ia=(f[s>>2]=Ya,+n[s>>2]);Ya=ia<ic;za=f[(Ya?J:G)>>2]|0;f[G>>2]=za;kc=Ya?ic:ia;n[J>>2]=kc;Ya=lc<kc;Z=f[(Ya?L:J)>>2]|0;f[J>>2]=Z;ia=Ya?kc:lc;n[L>>2]=ia;lc=(f[s>>2]=za,+n[s>>2]);kc=(f[s>>2]=qa,+n[s>>2]);qa=kc<lc;za=f[(qa?H:G)>>2]|0;f[G>>2]=za;ic=qa?lc:kc;n[H>>2]=ic;kc=(f[s>>2]=Z,+n[s>>2]);Z=kc<qc;f[I>>2]=f[(Z?J:I)>>2];lc=Z?qc:kc;n[J>>2]=lc;Z=ia<jc;qa=f[(Z?L:K)>>2]|0;f[K>>2]=qa;kc=Z?jc:ia;n[L>>2]=kc;ia=+n[z>>2];jc=(f[s>>2]=jb,+n[s>>2]);jb=jc<ia;f[z>>2]=f[(jb?F:z)>>2];qc=jb?ia:jc;n[F>>2]=qc;jc=+n[D>>2];jb=lc<jc;Z=f[(jb?J:D)>>2]|0;f[D>>2]=Z;ia=jb?jc:lc;n[J>>2]=ia;lc=(f[s>>2]=Z,+n[s>>2]);Z=qc<lc;jb=f[(Z?F:D)>>2]|0;f[D>>2]=jb;jc=Z?lc:qc;n[F>>2]=jc;qc=+n[B>>2];Z=ic<qc;Ya=f[(Z?H:B)>>2]|0;f[B>>2]=Ya;lc=Z?qc:ic;n[H>>2]=lc;Z=kc<lc;Qa=f[(Z?L:H)>>2]|0;f[H>>2]=Qa;ic=Z?lc:kc;n[L>>2]=ic;kc=(f[s>>2]=Ya,+n[s>>2]);lc=(f[s>>2]=jb,+n[s>>2]);jb=lc<kc;Ya=f[(jb?D:B)>>2]|0;f[B>>2]=Ya;qc=jb?kc:lc;n[D>>2]=qc;lc=(f[s>>2]=Qa,+n[s>>2]);Qa=lc<jc;jb=f[(Qa?H:F)>>2]|0;f[F>>2]=jb;kc=Qa?jc:lc;n[H>>2]=kc;Qa=ic<ia;Z=f[(Qa?L:J)>>2]|0;f[J>>2]=Z;lc=Qa?ia:ic;n[L>>2]=lc;ic=+n[A>>2];ia=(f[s>>2]=za,+n[s>>2]);za=ia<ic;Qa=f[(za?G:A)>>2]|0;f[A>>2]=Qa;jc=za?ic:ia;n[G>>2]=jc;ia=+n[E>>2];ic=(f[s>>2]=qa,+n[s>>2]);qa=ic<ia;za=f[(qa?K:E)>>2]|0;f[E>>2]=za;mc=qa?ia:ic;n[K>>2]=mc;ic=(f[s>>2]=za,+n[s>>2]);za=jc<ic;qa=f[(za?G:E)>>2]|0;f[E>>2]=qa;ia=za?ic:jc;n[G>>2]=ia;jc=+n[C>>2];ic=+n[I>>2];za=ic<jc;Ca=f[(za?I:C)>>2]|0;f[C>>2]=Ca;nc=za?jc:ic;n[I>>2]=nc;ic=(f[s>>2]=Ca,+n[s>>2]);jc=(f[s>>2]=qa,+n[s>>2]);qa=jc<ic;Ca=f[(qa?E:C)>>2]|0;f[C>>2]=Ca;hc=qa?ic:jc;n[E>>2]=hc;qa=nc<ia;za=f[(qa?I:G)>>2]|0;f[G>>2]=za;jc=qa?ia:nc;n[I>>2]=jc;nc=(f[s>>2]=Qa,+n[s>>2]);ia=(f[s>>2]=Ya,+n[s>>2]);Ya=ia<nc;f[A>>2]=f[(Ya?B:A)>>2];ic=Ya?nc:ia;n[B>>2]=ic;ia=(f[s>>2]=Ca,+n[s>>2]);Ca=qc<ia;f[C>>2]=f[(Ca?D:C)>>2];nc=Ca?ia:qc;n[D>>2]=nc;qc=(f[s>>2]=jb,+n[s>>2]);jb=qc<hc;f[E>>2]=f[(jb?F:E)>>2];ia=jb?hc:qc;n[F>>2]=ia;qc=(f[s>>2]=za,+n[s>>2]);za=kc<qc;f[G>>2]=f[(za?H:G)>>2];hc=za?qc:kc;n[H>>2]=hc;kc=(f[s>>2]=Z,+n[s>>2]);Z=kc<jc;f[I>>2]=f[(Z?J:I)>>2];qc=Z?jc:kc;n[J>>2]=qc;Z=lc<mc;f[K>>2]=f[(Z?L:K)>>2];kc=Z?mc:lc;n[L>>2]=kc;lc=+n[k>>2];mc=+n[z>>2];Z=mc<lc;f[k>>2]=f[(Z?z:k)>>2];jc=Z?lc:mc;n[z>>2]=jc;mc=+n[v>>2];Z=hc<mc;za=f[(Z?H:v)>>2]|0;f[v>>2]=za;n[H>>2]=Z?mc:hc;hc=(f[s>>2]=za,+n[s>>2]);za=jc<hc;f[v>>2]=f[(za?z:v)>>2];mc=za?hc:jc;n[z>>2]=mc;jc=+n[p>>2];za=nc<jc;f[p>>2]=f[(za?D:p)>>2];hc=za?jc:nc;n[D>>2]=hc;za=kc<hc;Z=f[(za?L:D)>>2]|0;f[D>>2]=Z;n[L>>2]=za?hc:kc;kc=(f[s>>2]=Z,+n[s>>2]);Z=kc<mc;za=f[(Z?D:z)>>2]|0;f[z>>2]=za;n[D>>2]=Z?mc:kc;kc=+n[m>>2];Z=ic<kc;f[m>>2]=f[(Z?B:m)>>2];mc=Z?kc:ic;n[B>>2]=mc;Z=f[(qc<+n[x>>2]?J:x)>>2]|0;f[x>>2]=Z;jb=f[(mc<(f[s>>2]=Z,+n[s>>2])?B:x)>>2]|0;f[x>>2]=jb;Z=f[(ia<+n[r>>2]?F:r)>>2]|0;f[r>>2]=Z;ia=(f[s>>2]=Z,+n[s>>2]);mc=(f[s>>2]=jb,+n[s>>2]);qc=mc<ia?ia:mc;n[x>>2]=qc;mc=(f[s>>2]=za,+n[s>>2]);ia=mc<qc?qc:mc;mc=+n[l>>2];qc=+n[A>>2];ic=qc<mc?mc:qc;n[A>>2]=ic;za=f[(+n[I>>2]<+n[w>>2]?I:w)>>2]|0;f[w>>2]=za;qc=(f[s>>2]=za,+n[s>>2]);mc=ic<qc?qc:ic;n[A>>2]=mc;ic=+n[q>>2];qc=+n[E>>2];kc=qc<ic?ic:qc;n[E>>2]=kc;qc=kc<mc?kc:+n[A>>2];kc=+n[o>>2];mc=+n[C>>2];ic=mc<kc?kc:mc;n[C>>2]=ic;za=f[(+n[K>>2]<+n[y>>2]?K:y)>>2]|0;f[y>>2]=za;jb=ic<(f[s>>2]=za,+n[s>>2]);ic=jb?+n[C>>2]:(f[s>>2]=za,+n[s>>2]);mc=+n[t>>2];kc=+n[G>>2];hc=kc<mc?kc:mc;mc=ic<hc?hc:ic;ic=qc<mc?qc:mc;n[ka+(sc<<2)>>2]=ia<ic?ic:ia;za=sc+1|0;if((sc|0)<(Fa|0))sc=za;else{Ta=za;Cb=Ka;continue m}}}if((db|0)==(Ma|0))break;else ka=ka+(ma<<2)|0}}break}default:{}}while(0);break a;break}default:{f[i>>2]=0;f[i+4>>2]=0;j$(-210,i,330188,327502,3159);d$(i);break a}}}while(0);i=Q+36|0;sc=f[i>>2]|0;if(sc|0?(G=sc+12|0,sc=f[G>>2]|0,f[G>>2]=sc+-1,(sc|0)==1):0)CR(Q);f[i>>2]=0;i=Q+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[U>>2]|0)>0){i=f[_>>2]|0;_=0;do{f[i+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[U>>2]|0))}U=f[X>>2]|0;if((U|0)!=(V|0))ZF(U);U=P+36|0;V=f[U>>2]|0;if(V|0?(X=V+12|0,V=f[X>>2]|0,f[X>>2]=V+-1,(V|0)==1):0)CR(P);f[U>>2]=0;U=P+16|0;V=P+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[V>>2]|0)>0){U=f[P+40>>2]|0;X=0;do{f[U+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[V>>2]|0))}V=f[P+44>>2]|0;if((V|0)!=(P+48|0))ZF(V);V=N+36|0;P=f[V>>2]|0;if(P|0?(X=P+12|0,P=f[X>>2]|0,f[X>>2]=P+-1,(P|0)==1):0)CR(N);f[V>>2]=0;V=N+16|0;P=N+4|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[P>>2]|0)>0){V=f[ba>>2]|0;ba=0;do{f[V+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[P>>2]|0))}P=f[N+44>>2]|0;if((P|0)!=(N+48|0))ZF(P)}else ZS(a,c);if(!(f[M+4>>2]|0)){u=g;return}u=g;return}
function J6(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0.0;a=u;u=u+16|0;i=a;k=c+8|0;l=e+8|0;if((f[k>>2]|0)!=(f[l>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;m=c$(i,26)|0;n=218300;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,i,373355,218048,2594);d$(i)}q=c+12|0;r=e+12|0;if((f[q>>2]|0)!=(f[r>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;m=c$(i,26)|0;n=218327;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,i,373355,218048,2595);d$(i)}if((g|0)!=8){f[i>>2]=0;f[i+4>>2]=0;m=c$(i,17)|0;n=218354;o=m+17|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,i,373355,218048,2596);d$(i)}i=f[k>>2]|0;k=f[q>>2]|0;q=YF((Y(((i+1|0)/2|0)<<1,(k+1|0)/2|0)|0)+2|0)|0;d[q>>1]=0;if((i|0)>0){n=c+16|0;m=c+44|0;o=e+16|0;g=e+44|0;s=(k|0)>0;t=1;v=0;while(1){w=f[f[m>>2]>>2]|0;x=(f[n>>2]|0)+(Y(w,v)|0)|0;y=0-w|0;z=x+y|0;A=z+y|0;y=x+w|0;w=f[f[g>>2]>>2]|0;B=(f[o>>2]|0)+(Y(w,v)|0)|0;C=0-w|0;w=B+C+C|0;if(s){C=(v|1|0)<(i|0);D=(v|0)>0;E=D^1;F=(v+-2|0)>-1;G=0;H=t;while(1){a:do if(!(b[x+G>>0]|0)){I=G|1;K=(I|0)<(k|0);if(C?b[y+G>>0]|0:0){L=G+-1|0;M=(G|0)>0;if(K?b[x+I>>0]|0:0){do if(M){if(b[x+L>>0]|0){do if(D){if(b[z+I>>0]|0){if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break a}do if(F){if(!(b[A+G>>0]|0))break;O=G+-2|0;if(b[z+L>>0]|0){d[B+(G<<1)>>1]=d[B+(O<<1)>>1]|0;N=H;break a}do if((O|0)>-1){if(!(b[z+O>>0]|0))break;if(b[A+L>>0]|0){d[B+(G<<1)>>1]=d[B+(O<<1)>>1]|0;N=H;break a}P=d[w+(G<<1)>>1]|0;Q=d[B+(O<<1)>>1]|0;R=P;while(1){S=d[q+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}if(P<<16>>16==Q<<16>>16)T=R;else{S=Q;while(1){U=d[q+((S&65535)<<1)>>1]|0;if((U&65535)<(S&65535))S=U;else break}U=(R&65535)>(S&65535)?S:R;V=Q;do{W=q+((V&65535)<<1)|0;X=V;V=d[W>>1]|0;d[W>>1]=U}while((V&65535)<(X&65535));T=U}U=P;do{V=q+((U&65535)<<1)|0;Q=U;U=d[V>>1]|0;d[V>>1]=T}while((U&65535)<(Q&65535));d[B+(G<<1)>>1]=T;N=H;break a}while(0);U=d[w+(G<<1)>>1]|0;P=d[B+(O<<1)>>1]|0;Q=U;while(1){V=d[q+((Q&65535)<<1)>>1]|0;if((V&65535)<(Q&65535))Q=V;else break}if(U<<16>>16==P<<16>>16)Z=Q;else{O=P;while(1){V=d[q+((O&65535)<<1)>>1]|0;if((V&65535)<(O&65535))O=V;else break}V=(Q&65535)>(O&65535)?O:Q;R=P;do{S=q+((R&65535)<<1)|0;X=R;R=d[S>>1]|0;d[S>>1]=V}while((R&65535)<(X&65535));Z=V}V=U;do{R=q+((V&65535)<<1)|0;P=V;V=d[R>>1]|0;d[R>>1]=Z}while((V&65535)<(P&65535));d[B+(G<<1)>>1]=Z;N=H;break a}while(0);V=d[w+(G<<1)>>1]|0;U=d[B+(G+-2<<1)>>1]|0;P=V;while(1){R=d[q+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}if(V<<16>>16==U<<16>>16)_=P;else{R=U;while(1){Q=d[q+((R&65535)<<1)>>1]|0;if((Q&65535)<(R&65535))R=Q;else break}Q=(P&65535)>(R&65535)?R:P;O=U;do{X=q+((O&65535)<<1)|0;S=O;O=d[X>>1]|0;d[X>>1]=Q}while((O&65535)<(S&65535));_=Q}Q=V;do{O=q+((Q&65535)<<1)|0;U=Q;Q=d[O>>1]|0;d[O>>1]=_}while((Q&65535)<(U&65535));d[B+(G<<1)>>1]=_;N=H;break a}Q=G+2|0;if((Q|0)>=(k|0))break;if(!(b[z+Q>>0]|0))break;do if(F){if(!(b[A+I>>0]|0))break;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break a}if(!(b[A+G>>0]|0)){V=d[w+(Q<<1)>>1]|0;U=d[B+(G+-2<<1)>>1]|0;O=V;while(1){P=d[q+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}if(V<<16>>16==U<<16>>16)$=O;else{P=U;while(1){R=d[q+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}R=(O&65535)>(P&65535)?P:O;S=U;do{X=q+((S&65535)<<1)|0;W=S;S=d[X>>1]|0;d[X>>1]=R}while((S&65535)<(W&65535));$=R}R=V;do{S=q+((R&65535)<<1)|0;U=R;R=d[S>>1]|0;d[S>>1]=$}while((R&65535)<(U&65535));d[B+(G<<1)>>1]=$;N=H;break a}R=G+-2|0;if(b[z+L>>0]|0){d[B+(G<<1)>>1]=d[B+(R<<1)>>1]|0;N=H;break a}do if((R|0)>-1){if(!(b[z+R>>0]|0))break;if(b[A+L>>0]|0){d[B+(G<<1)>>1]=d[B+(R<<1)>>1]|0;N=H;break a}V=d[w+(Q<<1)>>1]|0;U=d[B+(R<<1)>>1]|0;S=V;while(1){O=d[q+((S&65535)<<1)>>1]|0;if((O&65535)<(S&65535))S=O;else break}if(V<<16>>16==U<<16>>16)aa=S;else{O=U;while(1){P=d[q+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}P=(S&65535)>(O&65535)?O:S;W=U;do{X=q+((W&65535)<<1)|0;ba=W;W=d[X>>1]|0;d[X>>1]=P}while((W&65535)<(ba&65535));aa=P}P=V;do{W=q+((P&65535)<<1)|0;U=P;P=d[W>>1]|0;d[W>>1]=aa}while((P&65535)<(U&65535));d[B+(G<<1)>>1]=aa;N=H;break a}while(0);P=d[w+(Q<<1)>>1]|0;V=d[B+(R<<1)>>1]|0;U=P;while(1){W=d[q+((U&65535)<<1)>>1]|0;if((W&65535)<(U&65535))U=W;else break}if(P<<16>>16==V<<16>>16)ca=U;else{R=V;while(1){W=d[q+((R&65535)<<1)>>1]|0;if((W&65535)<(R&65535))R=W;else break}W=(U&65535)>(R&65535)?R:U;S=V;do{O=q+((S&65535)<<1)|0;ba=S;S=d[O>>1]|0;d[O>>1]=W}while((S&65535)<(ba&65535));ca=W}W=P;do{S=q+((W&65535)<<1)|0;V=W;W=d[S>>1]|0;d[S>>1]=ca}while((W&65535)<(V&65535));d[B+(G<<1)>>1]=ca;N=H;break a}while(0);W=d[w+(Q<<1)>>1]|0;P=d[B+(G+-2<<1)>>1]|0;V=W;while(1){S=d[q+((V&65535)<<1)>>1]|0;if((S&65535)<(V&65535))V=S;else break}if(W<<16>>16==P<<16>>16)da=V;else{Q=P;while(1){S=d[q+((Q&65535)<<1)>>1]|0;if((S&65535)<(Q&65535))Q=S;else break}S=(V&65535)>(Q&65535)?Q:V;U=P;do{R=q+((U&65535)<<1)|0;ba=U;U=d[R>>1]|0;d[R>>1]=S}while((U&65535)<(ba&65535));da=S}S=W;do{U=q+((S&65535)<<1)|0;P=S;S=d[U>>1]|0;d[U>>1]=da}while((S&65535)<(P&65535));d[B+(G<<1)>>1]=da;N=H;break a}while(0);d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break a}if(!(b[y+L>>0]|0))break;do if(D){if(b[z+I>>0]|0){S=G+-2|0;do if((S|0)>-1){if(!(b[x+S>>0]|0))break;if(b[z+L>>0]|0){W=d[B+(S<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}do if(F){if(!(b[A+G>>0]|0))break;d[B+(G<<1)>>1]=W;N=H;break a}while(0);P=d[w+(G<<1)>>1]|0;U=P;while(1){V=d[q+((U&65535)<<1)>>1]|0;if((V&65535)<(U&65535))U=V;else break}if(P<<16>>16==W<<16>>16)ea=U;else{V=W;while(1){Q=d[q+((V&65535)<<1)>>1]|0;if((Q&65535)<(V&65535))V=Q;else break}Q=(U&65535)>(V&65535)?V:U;ba=W;do{R=q+((ba&65535)<<1)|0;O=ba;ba=d[R>>1]|0;d[R>>1]=Q}while((ba&65535)<(O&65535));ea=Q}Q=P;do{ba=q+((Q&65535)<<1)|0;W=Q;Q=d[ba>>1]|0;d[ba>>1]=ea}while((Q&65535)<(W&65535));d[B+(G<<1)>>1]=ea;N=H;break a}if(!(b[z+S>>0]|0)){Q=d[w+(G<<1)>>1]|0;P=d[B+(S<<1)>>1]|0;W=Q;while(1){ba=d[q+((W&65535)<<1)>>1]|0;if((ba&65535)<(W&65535))W=ba;else break}if(Q<<16>>16==P<<16>>16)fa=W;else{ba=P;while(1){U=d[q+((ba&65535)<<1)>>1]|0;if((U&65535)<(ba&65535))ba=U;else break}U=(W&65535)>(ba&65535)?ba:W;V=P;do{O=q+((V&65535)<<1)|0;R=V;V=d[O>>1]|0;d[O>>1]=U}while((V&65535)<(R&65535));fa=U}U=Q;do{V=q+((U&65535)<<1)|0;P=U;U=d[V>>1]|0;d[V>>1]=fa}while((U&65535)<(P&65535));d[B+(G<<1)>>1]=fa;N=H;break a}do if(F){if(!(b[A+L>>0]|0))break;U=d[B+(S<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=U;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=U;N=H;break a}Q=d[w+(G<<1)>>1]|0;P=Q;while(1){V=d[q+((P&65535)<<1)>>1]|0;if((V&65535)<(P&65535))P=V;else break}if(Q<<16>>16==U<<16>>16)ga=P;else{V=U;while(1){W=d[q+((V&65535)<<1)>>1]|0;if((W&65535)<(V&65535))V=W;else break}W=(P&65535)>(V&65535)?V:P;ba=U;do{R=q+((ba&65535)<<1)|0;O=ba;ba=d[R>>1]|0;d[R>>1]=W}while((ba&65535)<(O&65535));ga=W}W=Q;do{ba=q+((W&65535)<<1)|0;U=W;W=d[ba>>1]|0;d[ba>>1]=ga}while((W&65535)<(U&65535));d[B+(G<<1)>>1]=ga;N=H;break a}while(0);W=d[w+(G<<1)>>1]|0;Q=d[B+(S<<1)>>1]|0;U=W;while(1){ba=d[q+((U&65535)<<1)>>1]|0;if((ba&65535)<(U&65535))U=ba;else break}if(W<<16>>16==Q<<16>>16)ha=U;else{ba=Q;while(1){P=d[q+((ba&65535)<<1)>>1]|0;if((P&65535)<(ba&65535))ba=P;else break}P=(U&65535)>(ba&65535)?ba:U;V=Q;do{O=q+((V&65535)<<1)|0;R=V;V=d[O>>1]|0;d[O>>1]=P}while((V&65535)<(R&65535));ha=P}P=W;do{V=q+((P&65535)<<1)|0;Q=P;P=d[V>>1]|0;d[V>>1]=ha}while((P&65535)<(Q&65535));d[B+(G<<1)>>1]=ha;N=H;break a}while(0);P=d[w+(G<<1)>>1]|0;W=d[B+(S<<1)>>1]|0;Q=P;while(1){V=d[q+((Q&65535)<<1)>>1]|0;if((V&65535)<(Q&65535))Q=V;else break}if(P<<16>>16==W<<16>>16)ia=Q;else{S=W;while(1){V=d[q+((S&65535)<<1)>>1]|0;if((V&65535)<(S&65535))S=V;else break}V=(Q&65535)>(S&65535)?S:Q;U=W;do{ba=q+((U&65535)<<1)|0;R=U;U=d[ba>>1]|0;d[ba>>1]=V}while((U&65535)<(R&65535));ia=V}V=P;do{U=q+((V&65535)<<1)|0;W=V;V=d[U>>1]|0;d[U>>1]=ia}while((V&65535)<(W&65535));d[B+(G<<1)>>1]=ia;N=H;break a}V=G+2|0;do if(!((V|0)>=(k|0)|E)){if(!(b[z+V>>0]|0))break;do if(F){if(!(b[A+I>>0]|0))break;P=G+-2|0;do if((P|0)>-1){if(!(b[x+P>>0]|0))break;if(b[z+L>>0]|0){W=d[B+(P<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}U=d[w+(V<<1)>>1]|0;Q=U;while(1){S=d[q+((Q&65535)<<1)>>1]|0;if((S&65535)<(Q&65535))Q=S;else break}if(U<<16>>16==W<<16>>16)ja=Q;else{S=W;while(1){R=d[q+((S&65535)<<1)>>1]|0;if((R&65535)<(S&65535))S=R;else break}R=(Q&65535)>(S&65535)?S:Q;ba=W;do{O=q+((ba&65535)<<1)|0;X=ba;ba=d[O>>1]|0;d[O>>1]=R}while((ba&65535)<(X&65535));ja=R}R=U;do{ba=q+((R&65535)<<1)|0;W=R;R=d[ba>>1]|0;d[ba>>1]=ja}while((R&65535)<(W&65535));d[B+(G<<1)>>1]=ja;N=H;break a}if(!(b[z+P>>0]|0)){R=d[w+(V<<1)>>1]|0;U=d[B+(P<<1)>>1]|0;W=R;while(1){ba=d[q+((W&65535)<<1)>>1]|0;if((ba&65535)<(W&65535))W=ba;else break}if(R<<16>>16==U<<16>>16)ka=W;else{ba=U;while(1){Q=d[q+((ba&65535)<<1)>>1]|0;if((Q&65535)<(ba&65535))ba=Q;else break}Q=(W&65535)>(ba&65535)?ba:W;S=U;do{X=q+((S&65535)<<1)|0;O=S;S=d[X>>1]|0;d[X>>1]=Q}while((S&65535)<(O&65535));ka=Q}Q=R;do{S=q+((Q&65535)<<1)|0;U=Q;Q=d[S>>1]|0;d[S>>1]=ka}while((Q&65535)<(U&65535));d[B+(G<<1)>>1]=ka;N=H;break a}if(!(b[A+L>>0]|0)){Q=d[w+(V<<1)>>1]|0;R=d[B+(P<<1)>>1]|0;U=Q;while(1){S=d[q+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}if(Q<<16>>16==R<<16>>16)la=U;else{S=R;while(1){W=d[q+((S&65535)<<1)>>1]|0;if((W&65535)<(S&65535))S=W;else break}W=(U&65535)>(S&65535)?S:U;ba=R;do{O=q+((ba&65535)<<1)|0;X=ba;ba=d[O>>1]|0;d[O>>1]=W}while((ba&65535)<(X&65535));la=W}W=Q;do{ba=q+((W&65535)<<1)|0;R=W;W=d[ba>>1]|0;d[ba>>1]=la}while((W&65535)<(R&65535));d[B+(G<<1)>>1]=la;N=H;break a}W=d[B+(P<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}Q=d[w+(V<<1)>>1]|0;R=Q;while(1){ba=d[q+((R&65535)<<1)>>1]|0;if((ba&65535)<(R&65535))R=ba;else break}if(Q<<16>>16==W<<16>>16)ma=R;else{ba=W;while(1){U=d[q+((ba&65535)<<1)>>1]|0;if((U&65535)<(ba&65535))ba=U;else break}U=(R&65535)>(ba&65535)?ba:R;S=W;do{X=q+((S&65535)<<1)|0;O=S;S=d[X>>1]|0;d[X>>1]=U}while((S&65535)<(O&65535));ma=U}U=Q;do{S=q+((U&65535)<<1)|0;W=U;U=d[S>>1]|0;d[S>>1]=ma}while((U&65535)<(W&65535));d[B+(G<<1)>>1]=ma;N=H;break a}while(0);U=d[w+(V<<1)>>1]|0;Q=d[B+(P<<1)>>1]|0;W=U;while(1){S=d[q+((W&65535)<<1)>>1]|0;if((S&65535)<(W&65535))W=S;else break}if(U<<16>>16==Q<<16>>16)na=W;else{P=Q;while(1){S=d[q+((P&65535)<<1)>>1]|0;if((S&65535)<(P&65535))P=S;else break}S=(W&65535)>(P&65535)?P:W;R=Q;do{ba=q+((R&65535)<<1)|0;O=R;R=d[ba>>1]|0;d[ba>>1]=S}while((R&65535)<(O&65535));na=S}S=U;do{R=q+((S&65535)<<1)|0;Q=S;S=d[R>>1]|0;d[R>>1]=na}while((S&65535)<(Q&65535));d[B+(G<<1)>>1]=na;N=H;break a}while(0);S=G+-2|0;if(!(b[z+G>>0]|0)){U=d[w+(V<<1)>>1]|0;Q=d[B+(S<<1)>>1]|0;R=U;while(1){W=d[q+((R&65535)<<1)>>1]|0;if((W&65535)<(R&65535))R=W;else break}if(U<<16>>16==Q<<16>>16)oa=R;else{W=Q;while(1){P=d[q+((W&65535)<<1)>>1]|0;if((P&65535)<(W&65535))W=P;else break}P=(R&65535)>(W&65535)?W:R;O=Q;do{ba=q+((O&65535)<<1)|0;X=O;O=d[ba>>1]|0;d[ba>>1]=P}while((O&65535)<(X&65535));oa=P}P=U;do{O=q+((P&65535)<<1)|0;Q=P;P=d[O>>1]|0;d[O>>1]=oa}while((P&65535)<(Q&65535));d[B+(G<<1)>>1]=oa;N=H;break a}do if((S|0)>-1){if(!(b[x+S>>0]|0))break;if(b[z+L>>0]|0){P=d[w+(V<<1)>>1]|0;U=d[B+(S<<1)>>1]|0;Q=P;while(1){O=d[q+((Q&65535)<<1)>>1]|0;if((O&65535)<(Q&65535))Q=O;else break}if(P<<16>>16==U<<16>>16)pa=Q;else{O=U;while(1){R=d[q+((O&65535)<<1)>>1]|0;if((R&65535)<(O&65535))O=R;else break}R=(Q&65535)>(O&65535)?O:Q;W=U;do{X=q+((W&65535)<<1)|0;ba=W;W=d[X>>1]|0;d[X>>1]=R}while((W&65535)<(ba&65535));pa=R}R=P;do{W=q+((R&65535)<<1)|0;U=R;R=d[W>>1]|0;d[W>>1]=pa}while((R&65535)<(U&65535));d[B+(G<<1)>>1]=pa;N=H;break a}if(!(b[z+S>>0]|0)){R=d[w+(G<<1)>>1]|0;P=d[w+(V<<1)>>1]|0;U=R;while(1){W=d[q+((U&65535)<<1)>>1]|0;if((W&65535)<(U&65535))U=W;else break}if(R<<16>>16==P<<16>>16)qa=U;else{W=P;while(1){Q=d[q+((W&65535)<<1)>>1]|0;if((Q&65535)<(W&65535))W=Q;else break}Q=(U&65535)>(W&65535)?W:U;O=P;do{ba=q+((O&65535)<<1)|0;X=O;O=d[ba>>1]|0;d[ba>>1]=Q}while((O&65535)<(X&65535));qa=Q}Q=R;do{O=q+((Q&65535)<<1)|0;P=Q;Q=d[O>>1]|0;d[O>>1]=qa}while((Q&65535)<(P&65535));Q=d[B+(S<<1)>>1]|0;R=qa;while(1){P=d[q+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}if(qa<<16>>16==Q<<16>>16)ra=R;else{P=Q;while(1){O=d[q+((P&65535)<<1)>>1]|0;if((O&65535)<(P&65535))P=O;else break}O=(R&65535)>(P&65535)?P:R;U=Q;do{W=q+((U&65535)<<1)|0;X=U;U=d[W>>1]|0;d[W>>1]=O}while((U&65535)<(X&65535));ra=O}O=qa;do{U=q+((O&65535)<<1)|0;Q=O;O=d[U>>1]|0;d[U>>1]=ra}while((O&65535)<(Q&65535));d[B+(G<<1)>>1]=ra;N=H;break a}do if(F){if(!(b[A+L>>0]|0))break;O=d[w+(V<<1)>>1]|0;Q=d[B+(S<<1)>>1]|0;U=O;while(1){R=d[q+((U&65535)<<1)>>1]|0;if((R&65535)<(U&65535))U=R;else break}if(O<<16>>16==Q<<16>>16)sa=U;else{R=Q;while(1){P=d[q+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}P=(U&65535)>(R&65535)?R:U;X=Q;do{W=q+((X&65535)<<1)|0;ba=X;X=d[W>>1]|0;d[W>>1]=P}while((X&65535)<(ba&65535));sa=P}P=O;do{X=q+((P&65535)<<1)|0;Q=P;P=d[X>>1]|0;d[X>>1]=sa}while((P&65535)<(Q&65535));d[B+(G<<1)>>1]=sa;N=H;break a}while(0);P=d[w+(G<<1)>>1]|0;O=d[w+(V<<1)>>1]|0;Q=P;while(1){X=d[q+((Q&65535)<<1)>>1]|0;if((X&65535)<(Q&65535))Q=X;else break}if(P<<16>>16==O<<16>>16)ta=Q;else{X=O;while(1){U=d[q+((X&65535)<<1)>>1]|0;if((U&65535)<(X&65535))X=U;else break}U=(Q&65535)>(X&65535)?X:Q;R=O;do{ba=q+((R&65535)<<1)|0;W=R;R=d[ba>>1]|0;d[ba>>1]=U}while((R&65535)<(W&65535));ta=U}U=P;do{R=q+((U&65535)<<1)|0;O=U;U=d[R>>1]|0;d[R>>1]=ta}while((U&65535)<(O&65535));U=d[B+(S<<1)>>1]|0;P=ta;while(1){O=d[q+((P&65535)<<1)>>1]|0;if((O&65535)<(P&65535))P=O;else break}if(ta<<16>>16==U<<16>>16)ua=P;else{O=U;while(1){R=d[q+((O&65535)<<1)>>1]|0;if((R&65535)<(O&65535))O=R;else break}R=(P&65535)>(O&65535)?O:P;Q=U;do{X=q+((Q&65535)<<1)|0;W=Q;Q=d[X>>1]|0;d[X>>1]=R}while((Q&65535)<(W&65535));ua=R}R=ta;do{Q=q+((R&65535)<<1)|0;U=R;R=d[Q>>1]|0;d[Q>>1]=ua}while((R&65535)<(U&65535));d[B+(G<<1)>>1]=ua;N=H;break a}while(0);R=d[w+(G<<1)>>1]|0;U=d[w+(V<<1)>>1]|0;Q=R;while(1){P=d[q+((Q&65535)<<1)>>1]|0;if((P&65535)<(Q&65535))Q=P;else break}if(R<<16>>16==U<<16>>16)va=Q;else{P=U;while(1){O=d[q+((P&65535)<<1)>>1]|0;if((O&65535)<(P&65535))P=O;else break}O=(Q&65535)>(P&65535)?P:Q;W=U;do{X=q+((W&65535)<<1)|0;ba=W;W=d[X>>1]|0;d[X>>1]=O}while((W&65535)<(ba&65535));va=O}O=R;do{W=q+((O&65535)<<1)|0;U=O;O=d[W>>1]|0;d[W>>1]=va}while((O&65535)<(U&65535));O=d[B+(S<<1)>>1]|0;R=va;while(1){U=d[q+((R&65535)<<1)>>1]|0;if((U&65535)<(R&65535))R=U;else break}if(va<<16>>16==O<<16>>16)wa=R;else{S=O;while(1){U=d[q+((S&65535)<<1)>>1]|0;if((U&65535)<(S&65535))S=U;else break}U=(R&65535)>(S&65535)?S:R;W=O;do{Q=q+((W&65535)<<1)|0;P=W;W=d[Q>>1]|0;d[Q>>1]=U}while((W&65535)<(P&65535));wa=U}U=va;do{W=q+((U&65535)<<1)|0;O=U;U=d[W>>1]|0;d[W>>1]=wa}while((U&65535)<(O&65535));d[B+(G<<1)>>1]=wa;N=H;break a}while(0);V=G+-2|0;if(!(b[z+G>>0]|0)){xa=V;break}do if((V|0)>-1){if(!(b[x+V>>0]|0))break;if(b[z+L>>0]|0){d[B+(G<<1)>>1]=d[B+(V<<1)>>1]|0;N=H;break a}if(!(b[z+V>>0]|0)){U=d[w+(G<<1)>>1]|0;O=d[B+(V<<1)>>1]|0;W=U;while(1){R=d[q+((W&65535)<<1)>>1]|0;if((R&65535)<(W&65535))W=R;else break}if(U<<16>>16==O<<16>>16)ya=W;else{R=O;while(1){S=d[q+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}S=(W&65535)>(R&65535)?R:W;P=O;do{Q=q+((P&65535)<<1)|0;ba=P;P=d[Q>>1]|0;d[Q>>1]=S}while((P&65535)<(ba&65535));ya=S}S=U;do{P=q+((S&65535)<<1)|0;O=S;S=d[P>>1]|0;d[P>>1]=ya}while((S&65535)<(O&65535));d[B+(G<<1)>>1]=ya;N=H;break a}do if(F){if(!(b[A+L>>0]|0))break;d[B+(G<<1)>>1]=d[B+(V<<1)>>1]|0;N=H;break a}while(0);S=d[w+(G<<1)>>1]|0;U=d[B+(V<<1)>>1]|0;O=S;while(1){P=d[q+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}if(S<<16>>16==U<<16>>16)za=O;else{P=U;while(1){W=d[q+((P&65535)<<1)>>1]|0;if((W&65535)<(P&65535))P=W;else break}W=(O&65535)>(P&65535)?P:O;R=U;do{ba=q+((R&65535)<<1)|0;Q=R;R=d[ba>>1]|0;d[ba>>1]=W}while((R&65535)<(Q&65535));za=W}W=S;do{R=q+((W&65535)<<1)|0;U=W;W=d[R>>1]|0;d[R>>1]=za}while((W&65535)<(U&65535));d[B+(G<<1)>>1]=za;N=H;break a}while(0);W=d[w+(G<<1)>>1]|0;S=d[B+(V<<1)>>1]|0;U=W;while(1){R=d[q+((U&65535)<<1)>>1]|0;if((R&65535)<(U&65535))U=R;else break}if(W<<16>>16==S<<16>>16)Aa=U;else{V=S;while(1){R=d[q+((V&65535)<<1)>>1]|0;if((R&65535)<(V&65535))V=R;else break}R=(U&65535)>(V&65535)?V:U;O=S;do{P=q+((O&65535)<<1)|0;Q=O;O=d[P>>1]|0;d[P>>1]=R}while((O&65535)<(Q&65535));Aa=R}R=W;do{O=q+((R&65535)<<1)|0;S=R;R=d[O>>1]|0;d[O>>1]=Aa}while((R&65535)<(S&65535));d[B+(G<<1)>>1]=Aa;N=H;break a}else xa=G+-2|0;while(0);d[B+(G<<1)>>1]=d[B+(xa<<1)>>1]|0;N=H;break a}while(0);do if(D){if(b[z+I>>0]|0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break a}R=G+2|0;do if(!((R|0)>=(k|0)|E)){if(!(b[z+R>>0]|0))break;if(!(b[z+G>>0]|0)){d[B+(G<<1)>>1]=d[w+(R<<1)>>1]|0;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;d[B+(G<<1)>>1]=d[w+(R<<1)>>1]|0;N=H;break a}while(0);W=d[w+(G<<1)>>1]|0;S=d[w+(R<<1)>>1]|0;O=W;while(1){U=d[q+((O&65535)<<1)>>1]|0;if((U&65535)<(O&65535))O=U;else break}if(W<<16>>16==S<<16>>16)Ba=O;else{U=S;while(1){V=d[q+((U&65535)<<1)>>1]|0;if((V&65535)<(U&65535))U=V;else break}V=(O&65535)>(U&65535)?U:O;Q=S;do{P=q+((Q&65535)<<1)|0;ba=Q;Q=d[P>>1]|0;d[P>>1]=V}while((Q&65535)<(ba&65535));Ba=V}V=W;do{Q=q+((V&65535)<<1)|0;S=V;V=d[Q>>1]|0;d[Q>>1]=Ba}while((V&65535)<(S&65535));d[B+(G<<1)>>1]=Ba;N=H;break a}while(0);if(!(b[z+G>>0]|0))break;d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break a}while(0);d[B+(G<<1)>>1]=H;R=H&65535;d[q+(R<<1)>>1]=H;N=R+1&65535;break}if(M){if(b[y+L>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break}if(b[x+L>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break}}d[B+(G<<1)>>1]=H;R=H&65535;d[q+(R<<1)>>1]=H;N=R+1&65535;break}do if(K){if(!(b[x+I>>0]|0)){if(!C)break;if(!(b[y+I>>0]|0))break;d[B+(G<<1)>>1]=H;R=H&65535;d[q+(R<<1)>>1]=H;N=R+1&65535;break a}if(D){if(b[z+I>>0]|0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break a}R=G+2|0;do if(!((R|0)>=(k|0)|E)){if(!(b[z+R>>0]|0))break;if(!(b[z+G>>0]|0)){d[B+(G<<1)>>1]=d[w+(R<<1)>>1]|0;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;d[B+(G<<1)>>1]=d[w+(R<<1)>>1]|0;N=H;break a}while(0);V=d[w+(G<<1)>>1]|0;W=d[w+(R<<1)>>1]|0;S=V;while(1){Q=d[q+((S&65535)<<1)>>1]|0;if((Q&65535)<(S&65535))S=Q;else break}if(V<<16>>16==W<<16>>16)Ca=S;else{Q=W;while(1){O=d[q+((Q&65535)<<1)>>1]|0;if((O&65535)<(Q&65535))Q=O;else break}O=(S&65535)>(Q&65535)?Q:S;U=W;do{ba=q+((U&65535)<<1)|0;P=U;U=d[ba>>1]|0;d[ba>>1]=O}while((U&65535)<(P&65535));Ca=O}O=V;do{U=q+((O&65535)<<1)|0;W=O;O=d[U>>1]|0;d[U>>1]=Ca}while((O&65535)<(W&65535));d[B+(G<<1)>>1]=Ca;N=H;break a}while(0);if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break a}}d[B+(G<<1)>>1]=H;R=H&65535;d[q+(R<<1)>>1]=H;N=R+1&65535;break a}while(0);d[B+(G<<1)>>1]=0;N=H}else{I=G+-1|0;K=(G|0)>0;if(K){if(b[x+I>>0]|0){L=G|1;M=(L|0)<(k|0);if(D&M?b[z+L>>0]|0:0){if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break}do if(F){if(!(b[A+G>>0]|0))break;R=G+-2|0;if(b[z+I>>0]|0){d[B+(G<<1)>>1]=d[B+(R<<1)>>1]|0;N=H;break a}do if((R|0)>-1){if(!(b[z+R>>0]|0))break;if(b[A+I>>0]|0){d[B+(G<<1)>>1]=d[B+(R<<1)>>1]|0;N=H;break a}O=d[w+(G<<1)>>1]|0;V=d[B+(R<<1)>>1]|0;W=O;while(1){U=d[q+((W&65535)<<1)>>1]|0;if((U&65535)<(W&65535))W=U;else break}if(O<<16>>16==V<<16>>16)Da=W;else{U=V;while(1){S=d[q+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}S=(W&65535)>(U&65535)?U:W;Q=V;do{P=q+((Q&65535)<<1)|0;ba=Q;Q=d[P>>1]|0;d[P>>1]=S}while((Q&65535)<(ba&65535));Da=S}S=O;do{Q=q+((S&65535)<<1)|0;V=S;S=d[Q>>1]|0;d[Q>>1]=Da}while((S&65535)<(V&65535));d[B+(G<<1)>>1]=Da;N=H;break a}while(0);S=d[w+(G<<1)>>1]|0;O=d[B+(R<<1)>>1]|0;V=S;while(1){Q=d[q+((V&65535)<<1)>>1]|0;if((Q&65535)<(V&65535))V=Q;else break}if(S<<16>>16==O<<16>>16)Ea=V;else{R=O;while(1){Q=d[q+((R&65535)<<1)>>1]|0;if((Q&65535)<(R&65535))R=Q;else break}Q=(V&65535)>(R&65535)?R:V;W=O;do{U=q+((W&65535)<<1)|0;ba=W;W=d[U>>1]|0;d[U>>1]=Q}while((W&65535)<(ba&65535));Ea=Q}Q=S;do{W=q+((Q&65535)<<1)|0;O=Q;Q=d[W>>1]|0;d[W>>1]=Ea}while((Q&65535)<(O&65535));d[B+(G<<1)>>1]=Ea;N=H;break a}while(0);Q=d[w+(G<<1)>>1]|0;S=d[B+(G+-2<<1)>>1]|0;O=Q;while(1){W=d[q+((O&65535)<<1)>>1]|0;if((W&65535)<(O&65535))O=W;else break}if(Q<<16>>16==S<<16>>16)Fa=O;else{W=S;while(1){V=d[q+((W&65535)<<1)>>1]|0;if((V&65535)<(W&65535))W=V;else break}V=(O&65535)>(W&65535)?W:O;R=S;do{ba=q+((R&65535)<<1)|0;U=R;R=d[ba>>1]|0;d[ba>>1]=V}while((R&65535)<(U&65535));Fa=V}V=Q;do{R=q+((V&65535)<<1)|0;S=V;V=d[R>>1]|0;d[R>>1]=Fa}while((V&65535)<(S&65535));d[B+(G<<1)>>1]=Fa;N=H;break}if(M?b[x+L>>0]|0:0){V=G+2|0;do if(D&(V|0)<(k|0)){if(!(b[z+V>>0]|0))break;do if(F){if(!(b[A+L>>0]|0))break;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break a}if(!(b[A+G>>0]|0)){Q=d[w+(V<<1)>>1]|0;S=d[B+(G+-2<<1)>>1]|0;R=Q;while(1){O=d[q+((R&65535)<<1)>>1]|0;if((O&65535)<(R&65535))R=O;else break}if(Q<<16>>16==S<<16>>16)Ga=R;else{O=S;while(1){W=d[q+((O&65535)<<1)>>1]|0;if((W&65535)<(O&65535))O=W;else break}W=(R&65535)>(O&65535)?O:R;U=S;do{ba=q+((U&65535)<<1)|0;P=U;U=d[ba>>1]|0;d[ba>>1]=W}while((U&65535)<(P&65535));Ga=W}W=Q;do{U=q+((W&65535)<<1)|0;S=W;W=d[U>>1]|0;d[U>>1]=Ga}while((W&65535)<(S&65535));d[B+(G<<1)>>1]=Ga;N=H;break a}W=G+-2|0;if(b[z+I>>0]|0){d[B+(G<<1)>>1]=d[B+(W<<1)>>1]|0;N=H;break a}do if((W|0)>-1){if(!(b[z+W>>0]|0))break;if(b[A+I>>0]|0){d[B+(G<<1)>>1]=d[B+(W<<1)>>1]|0;N=H;break a}Q=d[w+(V<<1)>>1]|0;S=d[B+(W<<1)>>1]|0;U=Q;while(1){R=d[q+((U&65535)<<1)>>1]|0;if((R&65535)<(U&65535))U=R;else break}if(Q<<16>>16==S<<16>>16)Ha=U;else{R=S;while(1){O=d[q+((R&65535)<<1)>>1]|0;if((O&65535)<(R&65535))R=O;else break}O=(U&65535)>(R&65535)?R:U;P=S;do{ba=q+((P&65535)<<1)|0;X=P;P=d[ba>>1]|0;d[ba>>1]=O}while((P&65535)<(X&65535));Ha=O}O=Q;do{P=q+((O&65535)<<1)|0;S=O;O=d[P>>1]|0;d[P>>1]=Ha}while((O&65535)<(S&65535));d[B+(G<<1)>>1]=Ha;N=H;break a}while(0);O=d[w+(V<<1)>>1]|0;Q=d[B+(W<<1)>>1]|0;S=O;while(1){P=d[q+((S&65535)<<1)>>1]|0;if((P&65535)<(S&65535))S=P;else break}if(O<<16>>16==Q<<16>>16)Ia=S;else{W=Q;while(1){P=d[q+((W&65535)<<1)>>1]|0;if((P&65535)<(W&65535))W=P;else break}P=(S&65535)>(W&65535)?W:S;U=Q;do{R=q+((U&65535)<<1)|0;X=U;U=d[R>>1]|0;d[R>>1]=P}while((U&65535)<(X&65535));Ia=P}P=O;do{U=q+((P&65535)<<1)|0;Q=P;P=d[U>>1]|0;d[U>>1]=Ia}while((P&65535)<(Q&65535));d[B+(G<<1)>>1]=Ia;N=H;break a}while(0);P=d[w+(V<<1)>>1]|0;O=d[B+(G+-2<<1)>>1]|0;Q=P;while(1){U=d[q+((Q&65535)<<1)>>1]|0;if((U&65535)<(Q&65535))Q=U;else break}if(P<<16>>16==O<<16>>16)Ja=Q;else{U=O;while(1){S=d[q+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}S=(Q&65535)>(U&65535)?U:Q;W=O;do{X=q+((W&65535)<<1)|0;R=W;W=d[X>>1]|0;d[X>>1]=S}while((W&65535)<(R&65535));Ja=S}S=P;do{W=q+((S&65535)<<1)|0;O=S;S=d[W>>1]|0;d[W>>1]=Ja}while((S&65535)<(O&65535));d[B+(G<<1)>>1]=Ja;N=H;break a}while(0);d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break}d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break}if(C?b[y+I>>0]|0:0){V=G|1;L=(V|0)<(k|0);if(!(E|L^1)?b[z+V>>0]|0:0){M=G+-2|0;do if((M|0)>-1){if(!(b[x+M>>0]|0))break;if(b[z+I>>0]|0){S=d[B+(M<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=S;N=H;break a}do if(F){if(!(b[A+G>>0]|0))break;d[B+(G<<1)>>1]=S;N=H;break a}while(0);P=d[w+(G<<1)>>1]|0;O=P;while(1){W=d[q+((O&65535)<<1)>>1]|0;if((W&65535)<(O&65535))O=W;else break}if(P<<16>>16==S<<16>>16)Ka=O;else{W=S;while(1){Q=d[q+((W&65535)<<1)>>1]|0;if((Q&65535)<(W&65535))W=Q;else break}Q=(O&65535)>(W&65535)?W:O;U=S;do{R=q+((U&65535)<<1)|0;X=U;U=d[R>>1]|0;d[R>>1]=Q}while((U&65535)<(X&65535));Ka=Q}Q=P;do{U=q+((Q&65535)<<1)|0;S=Q;Q=d[U>>1]|0;d[U>>1]=Ka}while((Q&65535)<(S&65535));d[B+(G<<1)>>1]=Ka;N=H;break a}if(!(b[z+M>>0]|0)){Q=d[w+(G<<1)>>1]|0;P=d[B+(M<<1)>>1]|0;S=Q;while(1){U=d[q+((S&65535)<<1)>>1]|0;if((U&65535)<(S&65535))S=U;else break}if(Q<<16>>16==P<<16>>16)La=S;else{U=P;while(1){O=d[q+((U&65535)<<1)>>1]|0;if((O&65535)<(U&65535))U=O;else break}O=(S&65535)>(U&65535)?U:S;W=P;do{X=q+((W&65535)<<1)|0;R=W;W=d[X>>1]|0;d[X>>1]=O}while((W&65535)<(R&65535));La=O}O=Q;do{W=q+((O&65535)<<1)|0;P=O;O=d[W>>1]|0;d[W>>1]=La}while((O&65535)<(P&65535));d[B+(G<<1)>>1]=La;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;O=d[B+(M<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=O;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=O;N=H;break a}Q=d[w+(G<<1)>>1]|0;P=Q;while(1){W=d[q+((P&65535)<<1)>>1]|0;if((W&65535)<(P&65535))P=W;else break}if(Q<<16>>16==O<<16>>16)Ma=P;else{W=O;while(1){S=d[q+((W&65535)<<1)>>1]|0;if((S&65535)<(W&65535))W=S;else break}S=(P&65535)>(W&65535)?W:P;U=O;do{R=q+((U&65535)<<1)|0;X=U;U=d[R>>1]|0;d[R>>1]=S}while((U&65535)<(X&65535));Ma=S}S=Q;do{U=q+((S&65535)<<1)|0;O=S;S=d[U>>1]|0;d[U>>1]=Ma}while((S&65535)<(O&65535));d[B+(G<<1)>>1]=Ma;N=H;break a}while(0);S=d[w+(G<<1)>>1]|0;Q=d[B+(M<<1)>>1]|0;O=S;while(1){U=d[q+((O&65535)<<1)>>1]|0;if((U&65535)<(O&65535))O=U;else break}if(S<<16>>16==Q<<16>>16)Na=O;else{U=Q;while(1){P=d[q+((U&65535)<<1)>>1]|0;if((P&65535)<(U&65535))U=P;else break}P=(O&65535)>(U&65535)?U:O;W=Q;do{X=q+((W&65535)<<1)|0;R=W;W=d[X>>1]|0;d[X>>1]=P}while((W&65535)<(R&65535));Na=P}P=S;do{W=q+((P&65535)<<1)|0;Q=P;P=d[W>>1]|0;d[W>>1]=Na}while((P&65535)<(Q&65535));d[B+(G<<1)>>1]=Na;N=H;break a}while(0);if(b[z+G>>0]|0){P=d[w+(G<<1)>>1]|0;S=d[B+(M<<1)>>1]|0;Q=P;while(1){W=d[q+((Q&65535)<<1)>>1]|0;if((W&65535)<(Q&65535))Q=W;else break}if(P<<16>>16==S<<16>>16)Oa=Q;else{W=S;while(1){O=d[q+((W&65535)<<1)>>1]|0;if((O&65535)<(W&65535))W=O;else break}O=(Q&65535)>(W&65535)?W:Q;U=S;do{R=q+((U&65535)<<1)|0;X=U;U=d[R>>1]|0;d[R>>1]=O}while((U&65535)<(X&65535));Oa=O}O=P;do{U=q+((O&65535)<<1)|0;S=O;O=d[U>>1]|0;d[U>>1]=Oa}while((O&65535)<(S&65535));d[B+(G<<1)>>1]=Oa;N=H;break}O=d[w+(G<<1)>>1]|0;if(!(b[z+I>>0]|0)){P=d[B+(M<<1)>>1]|0;S=O;while(1){U=d[q+((S&65535)<<1)>>1]|0;if((U&65535)<(S&65535))S=U;else break}if(O<<16>>16==P<<16>>16)Pa=S;else{U=P;while(1){Q=d[q+((U&65535)<<1)>>1]|0;if((Q&65535)<(U&65535))U=Q;else break}Q=(S&65535)>(U&65535)?U:S;W=P;do{X=q+((W&65535)<<1)|0;R=W;W=d[X>>1]|0;d[X>>1]=Q}while((W&65535)<(R&65535));Pa=Q}Q=O;do{W=q+((Q&65535)<<1)|0;P=Q;Q=d[W>>1]|0;d[W>>1]=Pa}while((Q&65535)<(P&65535));d[B+(G<<1)>>1]=Pa;N=H;break}do if(F){if(!(b[A+G>>0]|0))break;Q=d[B+(M<<1)>>1]|0;P=O;while(1){W=d[q+((P&65535)<<1)>>1]|0;if((W&65535)<(P&65535))P=W;else break}if(O<<16>>16==Q<<16>>16)Qa=P;else{W=Q;while(1){S=d[q+((W&65535)<<1)>>1]|0;if((S&65535)<(W&65535))W=S;else break}S=(P&65535)>(W&65535)?W:P;U=Q;do{R=q+((U&65535)<<1)|0;X=U;U=d[R>>1]|0;d[R>>1]=S}while((U&65535)<(X&65535));Qa=S}S=O;do{U=q+((S&65535)<<1)|0;Q=S;S=d[U>>1]|0;d[U>>1]=Qa}while((S&65535)<(Q&65535));d[B+(G<<1)>>1]=Qa;N=H;break a}while(0);S=d[w+(M<<1)>>1]|0;Q=S;while(1){U=d[q+((Q&65535)<<1)>>1]|0;if((U&65535)<(Q&65535))Q=U;else break}if(S<<16>>16==O<<16>>16)Ra=Q;else{U=O;while(1){P=d[q+((U&65535)<<1)>>1]|0;if((P&65535)<(U&65535))U=P;else break}P=(Q&65535)>(U&65535)?U:Q;W=O;do{X=q+((W&65535)<<1)|0;R=W;W=d[X>>1]|0;d[X>>1]=P}while((W&65535)<(R&65535));Ra=P}P=S;do{W=q+((P&65535)<<1)|0;O=P;P=d[W>>1]|0;d[W>>1]=Ra}while((P&65535)<(O&65535));P=d[B+(M<<1)>>1]|0;S=Ra;while(1){O=d[q+((S&65535)<<1)>>1]|0;if((O&65535)<(S&65535))S=O;else break}if(Ra<<16>>16==P<<16>>16)Sa=S;else{M=P;while(1){O=d[q+((M&65535)<<1)>>1]|0;if((O&65535)<(M&65535))M=O;else break}O=(S&65535)>(M&65535)?M:S;W=P;do{Q=q+((W&65535)<<1)|0;U=W;W=d[Q>>1]|0;d[Q>>1]=O}while((W&65535)<(U&65535));Sa=O}O=Ra;do{W=q+((O&65535)<<1)|0;P=O;O=d[W>>1]|0;d[W>>1]=Sa}while((O&65535)<(P&65535));d[B+(G<<1)>>1]=Sa;N=H;break}if(L?b[x+V>>0]|0:0){O=G+2|0;do if(!((O|0)>=(k|0)|E)){if(!(b[z+O>>0]|0))break;P=G+-2|0;do if((P|0)>-1){if(!(b[x+P>>0]|0))break;if(b[z+I>>0]|0){do if(F){if(!(b[A+V>>0]|0))break;W=d[B+(P<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}S=d[w+(O<<1)>>1]|0;M=S;while(1){U=d[q+((M&65535)<<1)>>1]|0;if((U&65535)<(M&65535))M=U;else break}if(S<<16>>16==W<<16>>16)Ta=M;else{U=W;while(1){Q=d[q+((U&65535)<<1)>>1]|0;if((Q&65535)<(U&65535))U=Q;else break}Q=(M&65535)>(U&65535)?U:M;R=W;do{X=q+((R&65535)<<1)|0;ba=R;R=d[X>>1]|0;d[X>>1]=Q}while((R&65535)<(ba&65535));Ta=Q}Q=S;do{R=q+((Q&65535)<<1)|0;W=Q;Q=d[R>>1]|0;d[R>>1]=Ta}while((Q&65535)<(W&65535));d[B+(G<<1)>>1]=Ta;N=H;break a}while(0);Q=d[w+(O<<1)>>1]|0;S=d[B+(P<<1)>>1]|0;W=Q;while(1){R=d[q+((W&65535)<<1)>>1]|0;if((R&65535)<(W&65535))W=R;else break}if(Q<<16>>16==S<<16>>16)Ua=W;else{R=S;while(1){M=d[q+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(W&65535)>(R&65535)?R:W;U=S;do{ba=q+((U&65535)<<1)|0;X=U;U=d[ba>>1]|0;d[ba>>1]=M}while((U&65535)<(X&65535));Ua=M}M=Q;do{U=q+((M&65535)<<1)|0;S=M;M=d[U>>1]|0;d[U>>1]=Ua}while((M&65535)<(S&65535));d[B+(G<<1)>>1]=Ua;N=H;break a}do if(F){if(!(b[A+V>>0]|0))break;if(!(b[z+P>>0]|0)){M=d[w+(O<<1)>>1]|0;Q=d[B+(P<<1)>>1]|0;S=M;while(1){U=d[q+((S&65535)<<1)>>1]|0;if((U&65535)<(S&65535))S=U;else break}if(M<<16>>16==Q<<16>>16)Va=S;else{U=Q;while(1){W=d[q+((U&65535)<<1)>>1]|0;if((W&65535)<(U&65535))U=W;else break}W=(S&65535)>(U&65535)?U:S;R=Q;do{X=q+((R&65535)<<1)|0;ba=R;R=d[X>>1]|0;d[X>>1]=W}while((R&65535)<(ba&65535));Va=W}W=M;do{R=q+((W&65535)<<1)|0;Q=W;W=d[R>>1]|0;d[R>>1]=Va}while((W&65535)<(Q&65535));d[B+(G<<1)>>1]=Va;N=H;break a}if(!(b[A+I>>0]|0)){W=d[w+(O<<1)>>1]|0;M=d[B+(P<<1)>>1]|0;Q=W;while(1){R=d[q+((Q&65535)<<1)>>1]|0;if((R&65535)<(Q&65535))Q=R;else break}if(W<<16>>16==M<<16>>16)Wa=Q;else{R=M;while(1){S=d[q+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}S=(Q&65535)>(R&65535)?R:Q;U=M;do{ba=q+((U&65535)<<1)|0;X=U;U=d[ba>>1]|0;d[ba>>1]=S}while((U&65535)<(X&65535));Wa=S}S=W;do{U=q+((S&65535)<<1)|0;M=S;S=d[U>>1]|0;d[U>>1]=Wa}while((S&65535)<(M&65535));d[B+(G<<1)>>1]=Wa;N=H;break a}S=d[B+(P<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=S;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=S;N=H;break a}W=d[w+(O<<1)>>1]|0;M=W;while(1){U=d[q+((M&65535)<<1)>>1]|0;if((U&65535)<(M&65535))M=U;else break}if(W<<16>>16==S<<16>>16)Xa=M;else{U=S;while(1){Q=d[q+((U&65535)<<1)>>1]|0;if((Q&65535)<(U&65535))U=Q;else break}Q=(M&65535)>(U&65535)?U:M;R=S;do{X=q+((R&65535)<<1)|0;ba=R;R=d[X>>1]|0;d[X>>1]=Q}while((R&65535)<(ba&65535));Xa=Q}Q=W;do{R=q+((Q&65535)<<1)|0;S=Q;Q=d[R>>1]|0;d[R>>1]=Xa}while((Q&65535)<(S&65535));d[B+(G<<1)>>1]=Xa;N=H;break a}while(0);if(!(b[z+G>>0]|0)){Q=d[w+(O<<1)>>1]|0;W=d[B+(P<<1)>>1]|0;S=Q;while(1){R=d[q+((S&65535)<<1)>>1]|0;if((R&65535)<(S&65535))S=R;else break}if(Q<<16>>16==W<<16>>16)Ya=S;else{R=W;while(1){M=d[q+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(S&65535)>(R&65535)?R:S;U=W;do{ba=q+((U&65535)<<1)|0;X=U;U=d[ba>>1]|0;d[ba>>1]=M}while((U&65535)<(X&65535));Ya=M}M=Q;do{U=q+((M&65535)<<1)|0;W=M;M=d[U>>1]|0;d[U>>1]=Ya}while((M&65535)<(W&65535));d[B+(G<<1)>>1]=Ya;N=H;break a}if(!(b[z+P>>0]|0)){M=d[w+(G<<1)>>1]|0;Q=d[w+(O<<1)>>1]|0;W=M;while(1){U=d[q+((W&65535)<<1)>>1]|0;if((U&65535)<(W&65535))W=U;else break}if(M<<16>>16==Q<<16>>16)Za=W;else{U=Q;while(1){S=d[q+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}S=(W&65535)>(U&65535)?U:W;R=Q;do{X=q+((R&65535)<<1)|0;ba=R;R=d[X>>1]|0;d[X>>1]=S}while((R&65535)<(ba&65535));Za=S}S=M;do{R=q+((S&65535)<<1)|0;Q=S;S=d[R>>1]|0;d[R>>1]=Za}while((S&65535)<(Q&65535));S=d[B+(P<<1)>>1]|0;M=Za;while(1){Q=d[q+((M&65535)<<1)>>1]|0;if((Q&65535)<(M&65535))M=Q;else break}if(Za<<16>>16==S<<16>>16)_a=M;else{Q=S;while(1){R=d[q+((Q&65535)<<1)>>1]|0;if((R&65535)<(Q&65535))Q=R;else break}R=(M&65535)>(Q&65535)?Q:M;W=S;do{U=q+((W&65535)<<1)|0;ba=W;W=d[U>>1]|0;d[U>>1]=R}while((W&65535)<(ba&65535));_a=R}R=Za;do{W=q+((R&65535)<<1)|0;S=R;R=d[W>>1]|0;d[W>>1]=_a}while((R&65535)<(S&65535));d[B+(G<<1)>>1]=_a;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;R=d[w+(O<<1)>>1]|0;S=d[B+(P<<1)>>1]|0;W=R;while(1){M=d[q+((W&65535)<<1)>>1]|0;if((M&65535)<(W&65535))W=M;else break}if(R<<16>>16==S<<16>>16)$a=W;else{M=S;while(1){Q=d[q+((M&65535)<<1)>>1]|0;if((Q&65535)<(M&65535))M=Q;else break}Q=(W&65535)>(M&65535)?M:W;ba=S;do{U=q+((ba&65535)<<1)|0;X=ba;ba=d[U>>1]|0;d[U>>1]=Q}while((ba&65535)<(X&65535));$a=Q}Q=R;do{ba=q+((Q&65535)<<1)|0;S=Q;Q=d[ba>>1]|0;d[ba>>1]=$a}while((Q&65535)<(S&65535));d[B+(G<<1)>>1]=$a;N=H;break a}while(0);Q=d[w+(G<<1)>>1]|0;R=d[w+(O<<1)>>1]|0;S=Q;while(1){ba=d[q+((S&65535)<<1)>>1]|0;if((ba&65535)<(S&65535))S=ba;else break}if(Q<<16>>16==R<<16>>16)ab=S;else{ba=R;while(1){W=d[q+((ba&65535)<<1)>>1]|0;if((W&65535)<(ba&65535))ba=W;else break}W=(S&65535)>(ba&65535)?ba:S;M=R;do{X=q+((M&65535)<<1)|0;U=M;M=d[X>>1]|0;d[X>>1]=W}while((M&65535)<(U&65535));ab=W}W=Q;do{M=q+((W&65535)<<1)|0;R=W;W=d[M>>1]|0;d[M>>1]=ab}while((W&65535)<(R&65535));W=d[B+(P<<1)>>1]|0;Q=ab;while(1){R=d[q+((Q&65535)<<1)>>1]|0;if((R&65535)<(Q&65535))Q=R;else break}if(ab<<16>>16==W<<16>>16)bb=Q;else{R=W;while(1){M=d[q+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(Q&65535)>(R&65535)?R:Q;S=W;do{ba=q+((S&65535)<<1)|0;U=S;S=d[ba>>1]|0;d[ba>>1]=M}while((S&65535)<(U&65535));bb=M}M=ab;do{S=q+((M&65535)<<1)|0;W=M;M=d[S>>1]|0;d[S>>1]=bb}while((M&65535)<(W&65535));d[B+(G<<1)>>1]=bb;N=H;break a}while(0);if(b[z+G>>0]|0){do if(F){if(!(b[A+V>>0]|0))break;M=d[w+(O<<1)>>1]|0;W=d[B+(P<<1)>>1]|0;S=M;while(1){Q=d[q+((S&65535)<<1)>>1]|0;if((Q&65535)<(S&65535))S=Q;else break}if(M<<16>>16==W<<16>>16)cb=S;else{Q=W;while(1){R=d[q+((Q&65535)<<1)>>1]|0;if((R&65535)<(Q&65535))Q=R;else break}R=(S&65535)>(Q&65535)?Q:S;U=W;do{ba=q+((U&65535)<<1)|0;X=U;U=d[ba>>1]|0;d[ba>>1]=R}while((U&65535)<(X&65535));cb=R}R=M;do{U=q+((R&65535)<<1)|0;W=R;R=d[U>>1]|0;d[U>>1]=cb}while((R&65535)<(W&65535));d[B+(G<<1)>>1]=cb;N=H;break a}while(0);R=d[w+(G<<1)>>1]|0;M=d[w+(O<<1)>>1]|0;W=R;while(1){U=d[q+((W&65535)<<1)>>1]|0;if((U&65535)<(W&65535))W=U;else break}if(R<<16>>16==M<<16>>16)db=W;else{U=M;while(1){S=d[q+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}S=(W&65535)>(U&65535)?U:W;Q=M;do{X=q+((Q&65535)<<1)|0;ba=Q;Q=d[X>>1]|0;d[X>>1]=S}while((Q&65535)<(ba&65535));db=S}S=R;do{Q=q+((S&65535)<<1)|0;M=S;S=d[Q>>1]|0;d[Q>>1]=db}while((S&65535)<(M&65535));S=d[B+(P<<1)>>1]|0;R=db;while(1){M=d[q+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}if(db<<16>>16==S<<16>>16)eb=R;else{M=S;while(1){Q=d[q+((M&65535)<<1)>>1]|0;if((Q&65535)<(M&65535))M=Q;else break}Q=(R&65535)>(M&65535)?M:R;W=S;do{U=q+((W&65535)<<1)|0;ba=W;W=d[U>>1]|0;d[U>>1]=Q}while((W&65535)<(ba&65535));eb=Q}Q=db;do{W=q+((Q&65535)<<1)|0;S=Q;Q=d[W>>1]|0;d[W>>1]=eb}while((Q&65535)<(S&65535));d[B+(G<<1)>>1]=eb;N=H;break a}if(!(b[z+I>>0]|0)){Q=d[w+(O<<1)>>1]|0;S=d[B+(P<<1)>>1]|0;W=Q;while(1){R=d[q+((W&65535)<<1)>>1]|0;if((R&65535)<(W&65535))W=R;else break}if(Q<<16>>16==S<<16>>16)fb=W;else{R=S;while(1){M=d[q+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(W&65535)>(R&65535)?R:W;ba=S;do{U=q+((ba&65535)<<1)|0;X=ba;ba=d[U>>1]|0;d[U>>1]=M}while((ba&65535)<(X&65535));fb=M}M=Q;do{ba=q+((M&65535)<<1)|0;S=M;M=d[ba>>1]|0;d[ba>>1]=fb}while((M&65535)<(S&65535));d[B+(G<<1)>>1]=fb;N=H;break a}do if(F){if(!(b[A+V>>0]|0))break;M=d[w+(O<<1)>>1]|0;if(b[A+G>>0]|0){Q=d[B+(P<<1)>>1]|0;S=M;while(1){ba=d[q+((S&65535)<<1)>>1]|0;if((ba&65535)<(S&65535))S=ba;else break}if(M<<16>>16==Q<<16>>16)gb=S;else{ba=Q;while(1){W=d[q+((ba&65535)<<1)>>1]|0;if((W&65535)<(ba&65535))ba=W;else break}W=(S&65535)>(ba&65535)?ba:S;R=Q;do{X=q+((R&65535)<<1)|0;U=R;R=d[X>>1]|0;d[X>>1]=W}while((R&65535)<(U&65535));gb=W}W=M;do{R=q+((W&65535)<<1)|0;Q=W;W=d[R>>1]|0;d[R>>1]=gb}while((W&65535)<(Q&65535));d[B+(G<<1)>>1]=gb;N=H;break a}W=d[w+(P<<1)>>1]|0;Q=W;while(1){R=d[q+((Q&65535)<<1)>>1]|0;if((R&65535)<(Q&65535))Q=R;else break}if(W<<16>>16==M<<16>>16)hb=Q;else{R=M;while(1){S=d[q+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}S=(Q&65535)>(R&65535)?R:Q;ba=M;do{U=q+((ba&65535)<<1)|0;X=ba;ba=d[U>>1]|0;d[U>>1]=S}while((ba&65535)<(X&65535));hb=S}S=W;do{ba=q+((S&65535)<<1)|0;M=S;S=d[ba>>1]|0;d[ba>>1]=hb}while((S&65535)<(M&65535));S=d[B+(P<<1)>>1]|0;W=hb;while(1){M=d[q+((W&65535)<<1)>>1]|0;if((M&65535)<(W&65535))W=M;else break}if(hb<<16>>16==S<<16>>16)ib=W;else{M=S;while(1){ba=d[q+((M&65535)<<1)>>1]|0;if((ba&65535)<(M&65535))M=ba;else break}ba=(W&65535)>(M&65535)?M:W;Q=S;do{R=q+((Q&65535)<<1)|0;X=Q;Q=d[R>>1]|0;d[R>>1]=ba}while((Q&65535)<(X&65535));ib=ba}ba=hb;do{Q=q+((ba&65535)<<1)|0;S=ba;ba=d[Q>>1]|0;d[Q>>1]=ib}while((ba&65535)<(S&65535));d[B+(G<<1)>>1]=ib;N=H;break a}while(0);ba=d[w+(P<<1)>>1]|0;S=d[w+(O<<1)>>1]|0;Q=ba;while(1){W=d[q+((Q&65535)<<1)>>1]|0;if((W&65535)<(Q&65535))Q=W;else break}if(ba<<16>>16==S<<16>>16)jb=Q;else{W=S;while(1){M=d[q+((W&65535)<<1)>>1]|0;if((M&65535)<(W&65535))W=M;else break}M=(Q&65535)>(W&65535)?W:Q;X=S;do{R=q+((X&65535)<<1)|0;U=X;X=d[R>>1]|0;d[R>>1]=M}while((X&65535)<(U&65535));jb=M}M=ba;do{X=q+((M&65535)<<1)|0;S=M;M=d[X>>1]|0;d[X>>1]=jb}while((M&65535)<(S&65535));M=d[B+(P<<1)>>1]|0;ba=jb;while(1){S=d[q+((ba&65535)<<1)>>1]|0;if((S&65535)<(ba&65535))ba=S;else break}if(jb<<16>>16==M<<16>>16)kb=ba;else{P=M;while(1){S=d[q+((P&65535)<<1)>>1]|0;if((S&65535)<(P&65535))P=S;else break}S=(ba&65535)>(P&65535)?P:ba;X=M;do{Q=q+((X&65535)<<1)|0;W=X;X=d[Q>>1]|0;d[Q>>1]=S}while((X&65535)<(W&65535));kb=S}S=jb;do{X=q+((S&65535)<<1)|0;M=S;S=d[X>>1]|0;d[X>>1]=kb}while((S&65535)<(M&65535));d[B+(G<<1)>>1]=kb;N=H;break a}while(0);do if(D){O=G+-2|0;if(b[z+I>>0]|0){V=d[B+(O<<1)>>1]|0;do if((O|0)>-1){if(!(b[x+O>>0]|0))break;d[B+(G<<1)>>1]=V;N=H;break a}while(0);L=d[w+(O<<1)>>1]|0;S=L;while(1){M=d[q+((S&65535)<<1)>>1]|0;if((M&65535)<(S&65535))S=M;else break}if(L<<16>>16==V<<16>>16)lb=S;else{M=V;while(1){X=d[q+((M&65535)<<1)>>1]|0;if((X&65535)<(M&65535))M=X;else break}X=(S&65535)>(M&65535)?M:S;ba=V;do{P=q+((ba&65535)<<1)|0;W=ba;ba=d[P>>1]|0;d[P>>1]=X}while((ba&65535)<(W&65535));lb=X}X=L;do{ba=q+((X&65535)<<1)|0;V=X;X=d[ba>>1]|0;d[ba>>1]=lb}while((X&65535)<(V&65535));d[B+(G<<1)>>1]=lb;N=H;break a}if(!(b[z+G>>0]|0)){mb=O;break}do if((O|0)>-1){if(!(b[x+O>>0]|0))break;if(!(b[z+O>>0]|0)){X=d[w+(G<<1)>>1]|0;L=d[B+(O<<1)>>1]|0;V=X;while(1){ba=d[q+((V&65535)<<1)>>1]|0;if((ba&65535)<(V&65535))V=ba;else break}if(X<<16>>16==L<<16>>16)nb=V;else{ba=L;while(1){S=d[q+((ba&65535)<<1)>>1]|0;if((S&65535)<(ba&65535))ba=S;else break}S=(V&65535)>(ba&65535)?ba:V;M=L;do{W=q+((M&65535)<<1)|0;P=M;M=d[W>>1]|0;d[W>>1]=S}while((M&65535)<(P&65535));nb=S}S=X;do{M=q+((S&65535)<<1)|0;L=S;S=d[M>>1]|0;d[M>>1]=nb}while((S&65535)<(L&65535));d[B+(G<<1)>>1]=nb;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;d[B+(G<<1)>>1]=d[B+(O<<1)>>1]|0;N=H;break a}while(0);S=d[w+(G<<1)>>1]|0;X=d[B+(O<<1)>>1]|0;L=S;while(1){M=d[q+((L&65535)<<1)>>1]|0;if((M&65535)<(L&65535))L=M;else break}if(S<<16>>16==X<<16>>16)ob=L;else{M=X;while(1){V=d[q+((M&65535)<<1)>>1]|0;if((V&65535)<(M&65535))M=V;else break}V=(L&65535)>(M&65535)?M:L;ba=X;do{P=q+((ba&65535)<<1)|0;W=ba;ba=d[P>>1]|0;d[P>>1]=V}while((ba&65535)<(W&65535));ob=V}V=S;do{ba=q+((V&65535)<<1)|0;X=V;V=d[ba>>1]|0;d[ba>>1]=ob}while((V&65535)<(X&65535));d[B+(G<<1)>>1]=ob;N=H;break a}while(0);V=d[w+(G<<1)>>1]|0;S=d[B+(O<<1)>>1]|0;X=V;while(1){ba=d[q+((X&65535)<<1)>>1]|0;if((ba&65535)<(X&65535))X=ba;else break}if(V<<16>>16==S<<16>>16)pb=X;else{O=S;while(1){ba=d[q+((O&65535)<<1)>>1]|0;if((ba&65535)<(O&65535))O=ba;else break}ba=(X&65535)>(O&65535)?O:X;L=S;do{M=q+((L&65535)<<1)|0;W=L;L=d[M>>1]|0;d[M>>1]=ba}while((L&65535)<(W&65535));pb=ba}ba=V;do{L=q+((ba&65535)<<1)|0;S=ba;ba=d[L>>1]|0;d[L>>1]=pb}while((ba&65535)<(S&65535));d[B+(G<<1)>>1]=pb;N=H;break a}else mb=G+-2|0;while(0);d[B+(G<<1)>>1]=d[B+(mb<<1)>>1]|0;N=H;break}do if(D){ba=G+-2|0;if(b[z+I>>0]|0){V=d[B+(ba<<1)>>1]|0;do if((ba|0)>-1){if(!(b[x+ba>>0]|0))break;d[B+(G<<1)>>1]=V;N=H;break a}while(0);S=d[w+(ba<<1)>>1]|0;L=S;while(1){X=d[q+((L&65535)<<1)>>1]|0;if((X&65535)<(L&65535))L=X;else break}if(S<<16>>16==V<<16>>16)qb=L;else{X=V;while(1){O=d[q+((X&65535)<<1)>>1]|0;if((O&65535)<(X&65535))X=O;else break}O=(L&65535)>(X&65535)?X:L;W=V;do{M=q+((W&65535)<<1)|0;P=W;W=d[M>>1]|0;d[M>>1]=O}while((W&65535)<(P&65535));qb=O}O=S;do{W=q+((O&65535)<<1)|0;V=O;O=d[W>>1]|0;d[W>>1]=qb}while((O&65535)<(V&65535));d[B+(G<<1)>>1]=qb;N=H;break a}if(!(b[z+G>>0]|0)){rb=ba;break}do if((ba|0)>-1){if(!(b[x+ba>>0]|0))break;if(!(b[z+ba>>0]|0)){O=d[w+(G<<1)>>1]|0;S=d[B+(ba<<1)>>1]|0;V=O;while(1){W=d[q+((V&65535)<<1)>>1]|0;if((W&65535)<(V&65535))V=W;else break}if(O<<16>>16==S<<16>>16)sb=V;else{W=S;while(1){L=d[q+((W&65535)<<1)>>1]|0;if((L&65535)<(W&65535))W=L;else break}L=(V&65535)>(W&65535)?W:V;X=S;do{P=q+((X&65535)<<1)|0;M=X;X=d[P>>1]|0;d[P>>1]=L}while((X&65535)<(M&65535));sb=L}L=O;do{X=q+((L&65535)<<1)|0;S=L;L=d[X>>1]|0;d[X>>1]=sb}while((L&65535)<(S&65535));d[B+(G<<1)>>1]=sb;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;d[B+(G<<1)>>1]=d[B+(ba<<1)>>1]|0;N=H;break a}while(0);L=d[w+(G<<1)>>1]|0;O=d[B+(ba<<1)>>1]|0;S=L;while(1){X=d[q+((S&65535)<<1)>>1]|0;if((X&65535)<(S&65535))S=X;else break}if(L<<16>>16==O<<16>>16)tb=S;else{X=O;while(1){V=d[q+((X&65535)<<1)>>1]|0;if((V&65535)<(X&65535))X=V;else break}V=(S&65535)>(X&65535)?X:S;W=O;do{M=q+((W&65535)<<1)|0;P=W;W=d[M>>1]|0;d[M>>1]=V}while((W&65535)<(P&65535));tb=V}V=L;do{W=q+((V&65535)<<1)|0;O=V;V=d[W>>1]|0;d[W>>1]=tb}while((V&65535)<(O&65535));d[B+(G<<1)>>1]=tb;N=H;break a}while(0);V=d[w+(G<<1)>>1]|0;L=d[B+(ba<<1)>>1]|0;O=V;while(1){W=d[q+((O&65535)<<1)>>1]|0;if((W&65535)<(O&65535))O=W;else break}if(V<<16>>16==L<<16>>16)ub=O;else{ba=L;while(1){W=d[q+((ba&65535)<<1)>>1]|0;if((W&65535)<(ba&65535))ba=W;else break}W=(O&65535)>(ba&65535)?ba:O;S=L;do{X=q+((S&65535)<<1)|0;P=S;S=d[X>>1]|0;d[X>>1]=W}while((S&65535)<(P&65535));ub=W}W=V;do{S=q+((W&65535)<<1)|0;L=W;W=d[S>>1]|0;d[S>>1]=ub}while((W&65535)<(L&65535));d[B+(G<<1)>>1]=ub;N=H;break a}else rb=G+-2|0;while(0);d[B+(G<<1)>>1]=d[B+(rb<<1)>>1]|0;N=H;break}}W=G|1;V=(W|0)<(k|0);if(!(E|V^1)?b[z+W>>0]|0:0){if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break}if(K?b[z+I>>0]|0:0){L=d[w+(G<<1)>>1]|0;do if(F){if(!(b[A+G>>0]|0))break;d[B+(G<<1)>>1]=L;N=H;break a}while(0);S=d[w+(G+-2<<1)>>1]|0;O=S;while(1){ba=d[q+((O&65535)<<1)>>1]|0;if((ba&65535)<(O&65535))O=ba;else break}if(S<<16>>16==L<<16>>16)vb=O;else{ba=L;while(1){P=d[q+((ba&65535)<<1)>>1]|0;if((P&65535)<(ba&65535))ba=P;else break}P=(O&65535)>(ba&65535)?ba:O;X=L;do{M=q+((X&65535)<<1)|0;Q=X;X=d[M>>1]|0;d[M>>1]=P}while((X&65535)<(Q&65535));vb=P}P=S;do{X=q+((P&65535)<<1)|0;L=P;P=d[X>>1]|0;d[X>>1]=vb}while((P&65535)<(L&65535));d[B+(G<<1)>>1]=vb;N=H;break}d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break}if(V?b[x+W>>0]|0:0){P=G+2|0;if(!((P|0)>=(k|0)|E)?b[z+P>>0]|0:0){if(b[z+G>>0]|0){do if(F){if(!(b[A+W>>0]|0))break;d[B+(G<<1)>>1]=d[w+(P<<1)>>1]|0;N=H;break a}while(0);V=d[w+(G<<1)>>1]|0;S=d[w+(P<<1)>>1]|0;L=V;while(1){X=d[q+((L&65535)<<1)>>1]|0;if((X&65535)<(L&65535))L=X;else break}if(V<<16>>16==S<<16>>16)wb=L;else{X=S;while(1){O=d[q+((X&65535)<<1)>>1]|0;if((O&65535)<(X&65535))X=O;else break}O=(L&65535)>(X&65535)?X:L;ba=S;do{Q=q+((ba&65535)<<1)|0;M=ba;ba=d[Q>>1]|0;d[Q>>1]=O}while((ba&65535)<(M&65535));wb=O}O=V;do{ba=q+((O&65535)<<1)|0;S=O;O=d[ba>>1]|0;d[ba>>1]=wb}while((O&65535)<(S&65535));d[B+(G<<1)>>1]=wb;N=H;break}do if(K){if(!(b[z+I>>0]|0))break;do if(F){if(!(b[A+W>>0]|0))break;O=d[w+(P<<1)>>1]|0;if(b[A+G>>0]|0){d[B+(G<<1)>>1]=O;N=H;break a}V=d[w+(G+-2<<1)>>1]|0;S=V;while(1){ba=d[q+((S&65535)<<1)>>1]|0;if((ba&65535)<(S&65535))S=ba;else break}if(V<<16>>16==O<<16>>16)xb=S;else{ba=O;while(1){L=d[q+((ba&65535)<<1)>>1]|0;if((L&65535)<(ba&65535))ba=L;else break}L=(S&65535)>(ba&65535)?ba:S;X=O;do{M=q+((X&65535)<<1)|0;Q=X;X=d[M>>1]|0;d[M>>1]=L}while((X&65535)<(Q&65535));xb=L}L=V;do{X=q+((L&65535)<<1)|0;O=L;L=d[X>>1]|0;d[X>>1]=xb}while((L&65535)<(O&65535));d[B+(G<<1)>>1]=xb;N=H;break a}while(0);L=d[w+(G+-2<<1)>>1]|0;V=d[w+(P<<1)>>1]|0;O=L;while(1){X=d[q+((O&65535)<<1)>>1]|0;if((X&65535)<(O&65535))O=X;else break}if(L<<16>>16==V<<16>>16)yb=O;else{X=V;while(1){S=d[q+((X&65535)<<1)>>1]|0;if((S&65535)<(X&65535))X=S;else break}S=(O&65535)>(X&65535)?X:O;ba=V;do{Q=q+((ba&65535)<<1)|0;M=ba;ba=d[Q>>1]|0;d[Q>>1]=S}while((ba&65535)<(M&65535));yb=S}S=L;do{ba=q+((S&65535)<<1)|0;V=S;S=d[ba>>1]|0;d[ba>>1]=yb}while((S&65535)<(V&65535));d[B+(G<<1)>>1]=yb;N=H;break a}while(0);d[B+(G<<1)>>1]=d[w+(P<<1)>>1]|0;N=H;break}if(D?b[z+G>>0]|0:0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break}do if(!(E|K^1)){if(!(b[z+I>>0]|0))break;d[B+(G<<1)>>1]=d[w+(G+-2<<1)>>1]|0;N=H;break a}while(0);d[B+(G<<1)>>1]=H;P=H&65535;d[q+(P<<1)>>1]=H;N=P+1&65535;break}if(D?b[z+G>>0]|0:0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break}if(!(E|K^1)?b[z+I>>0]|0:0){d[B+(G<<1)>>1]=d[w+(G+-2<<1)>>1]|0;N=H;break}d[B+(G<<1)>>1]=H;P=H&65535;d[q+(P<<1)>>1]=H;N=P+1&65535}while(0);G=G+2|0;if((G|0)>=(k|0)){zb=N;break}else H=N}}else zb=t;v=v+2|0;if((v|0)>=(i|0))break;else t=zb}if((zb&65535)>1){t=zb&65535;zb=1;i=1;while(1){v=q+(zb<<1)|0;N=j[v>>1]|0;if(N>>>0<zb>>>0){d[v>>1]=d[q+(N<<1)>>1]|0;Ab=i}else{d[v>>1]=i;Ab=(i&65535)+1&65535}zb=zb+1|0;if((zb|0)==(t|0)){Bb=Ab;break}else i=Ab}}else Bb=1}else Bb=1;N6(h,Bb&65535);Ab=f[l>>2]|0;i=f[r>>2]|0;t=(i&1|0)!=0;zb=(Ab|0)>0;b:do if(!(Ab&1)){if(!t){if(!zb)break;v=c+16|0;N=c+44|0;k=e+16|0;yb=e+44|0;xb=h+20|0;wb=h+120|0;vb=h+48|0;rb=i;ub=Ab;tb=0;while(1){sb=f[f[N>>2]>>2]|0;qb=(f[v>>2]|0)+(Y(sb,tb)|0)|0;mb=qb+sb|0;sb=f[f[yb>>2]>>2]|0;pb=(f[k>>2]|0)+(Y(sb,tb)|0)|0;ob=pb+sb|0;if((rb|0)>0){sb=((tb|0)<0)<<31>>31;nb=tb|1;lb=((nb|0)<0)<<31>>31;kb=0;do{jb=pb+(kb<<1)|0;ib=d[jb>>1]|0;do if(ib<<16>>16){hb=d[q+((ib&65535)<<1)>>1]|0;if(!(b[qb+kb>>0]|0)){d[jb>>1]=0;gb=f[xb>>2]|0;fb=f[gb>>2]|0;f[gb>>2]=(fb|0)>(kb|0)?kb:fb;fb=gb+8|0;eb=f[fb>>2]|0;f[fb>>2]=(eb|0)<(kb|0)?kb:eb;eb=gb+4|0;fb=f[eb>>2]|0;f[eb>>2]=(fb|0)>(tb|0)?tb:fb;fb=gb+12|0;eb=f[fb>>2]|0;f[fb>>2]=(eb|0)<(tb|0)?tb:eb;eb=gb+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=f[wb>>2]|0;fb=eb;db=C1a(f[fb>>2]|0,f[fb+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;fb=eb;f[fb>>2]=db;f[fb+4>>2]=J;Cb=gb;Db=eb;Eb=eb+8|0}else{d[jb>>1]=hb;eb=hb&65535;gb=f[xb>>2]|0;fb=gb+(Y(f[f[vb>>2]>>2]|0,eb)|0)|0;db=f[fb>>2]|0;f[fb>>2]=(db|0)>(kb|0)?kb:db;db=fb+8|0;cb=f[db>>2]|0;f[db>>2]=(cb|0)<(kb|0)?kb:cb;cb=fb+4|0;db=f[cb>>2]|0;f[cb>>2]=(db|0)>(tb|0)?tb:db;db=fb+12|0;cb=f[db>>2]|0;f[db>>2]=(cb|0)<(tb|0)?tb:cb;cb=fb+16|0;f[cb>>2]=(f[cb>>2]|0)+1;cb=f[wb>>2]|0;fb=cb+(eb<<4)|0;db=fb;bb=C1a(f[db>>2]|0,f[db+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;db=fb;f[db>>2]=bb;f[db+4>>2]=J;Cb=gb;Db=cb;Eb=cb+(eb<<4)+8|0}eb=Eb;cb=C1a(f[eb>>2]|0,f[eb+4>>2]|0,tb|0,sb|0)|0;eb=Eb;f[eb>>2]=cb;f[eb+4>>2]=J;eb=kb|1;cb=pb+(eb<<1)|0;if(!(b[qb+eb>>0]|0)){d[cb>>1]=0;Fb=0;Gb=Cb}else{d[cb>>1]=hb;cb=hb&65535;Fb=cb;Gb=Cb+(Y(f[f[vb>>2]>>2]|0,cb)|0)|0}cb=f[Gb>>2]|0;f[Gb>>2]=(cb|0)>(eb|0)?eb:cb;cb=Gb+8|0;gb=f[cb>>2]|0;f[cb>>2]=(gb|0)<(eb|0)?eb:gb;gb=Gb+4|0;cb=f[gb>>2]|0;f[gb>>2]=(cb|0)>(tb|0)?tb:cb;cb=Gb+12|0;gb=f[cb>>2]|0;f[cb>>2]=(gb|0)<(tb|0)?tb:gb;gb=Gb+16|0;f[gb>>2]=(f[gb>>2]|0)+1;gb=Db+(Fb<<4)|0;cb=gb;db=C1a(f[cb>>2]|0,f[cb+4>>2]|0,eb|0,((eb|0)<0)<<31>>31|0)|0;cb=gb;f[cb>>2]=db;f[cb+4>>2]=J;cb=Db+(Fb<<4)+8|0;db=cb;gb=C1a(f[db>>2]|0,f[db+4>>2]|0,tb|0,sb|0)|0;db=cb;f[db>>2]=gb;f[db+4>>2]=J;db=ob+(kb<<1)|0;if(!(b[mb+kb>>0]|0)){d[db>>1]=0;Hb=0;Ib=Cb}else{d[db>>1]=hb;db=hb&65535;Hb=db;Ib=Cb+(Y(f[f[vb>>2]>>2]|0,db)|0)|0}db=f[Ib>>2]|0;f[Ib>>2]=(db|0)>(kb|0)?kb:db;db=Ib+8|0;gb=f[db>>2]|0;f[db>>2]=(gb|0)<(kb|0)?kb:gb;gb=Ib+4|0;db=f[gb>>2]|0;f[gb>>2]=(db|0)>(nb|0)?nb:db;db=Ib+12|0;gb=f[db>>2]|0;f[db>>2]=(gb|0)<(nb|0)?nb:gb;gb=Ib+16|0;f[gb>>2]=(f[gb>>2]|0)+1;gb=Db+(Hb<<4)|0;db=gb;cb=C1a(f[db>>2]|0,f[db+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;db=gb;f[db>>2]=cb;f[db+4>>2]=J;db=Db+(Hb<<4)+8|0;cb=db;gb=C1a(f[cb>>2]|0,f[cb+4>>2]|0,nb|0,lb|0)|0;cb=db;f[cb>>2]=gb;f[cb+4>>2]=J;cb=ob+(eb<<1)|0;if(!(b[mb+eb>>0]|0)){d[cb>>1]=0;gb=f[Cb>>2]|0;f[Cb>>2]=(gb|0)>(eb|0)?eb:gb;gb=Cb+8|0;db=f[gb>>2]|0;f[gb>>2]=(db|0)<(eb|0)?eb:db;db=Cb+4|0;gb=f[db>>2]|0;f[db>>2]=(gb|0)>(nb|0)?nb:gb;gb=Cb+12|0;db=f[gb>>2]|0;f[gb>>2]=(db|0)<(nb|0)?nb:db;db=Cb+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Db;gb=C1a(f[db>>2]|0,f[db+4>>2]|0,eb|0,((eb|0)<0)<<31>>31|0)|0;db=Db;f[db>>2]=gb;f[db+4>>2]=J;Jb=Db+8|0;break}else{d[cb>>1]=hb;cb=hb&65535;hb=Cb+(Y(f[f[vb>>2]>>2]|0,cb)|0)|0;db=f[hb>>2]|0;f[hb>>2]=(db|0)>(eb|0)?eb:db;db=hb+8|0;gb=f[db>>2]|0;f[db>>2]=(gb|0)<(eb|0)?eb:gb;gb=hb+4|0;db=f[gb>>2]|0;f[gb>>2]=(db|0)>(nb|0)?nb:db;db=hb+12|0;gb=f[db>>2]|0;f[db>>2]=(gb|0)<(nb|0)?nb:gb;gb=hb+16|0;f[gb>>2]=(f[gb>>2]|0)+1;gb=Db+(cb<<4)|0;hb=gb;db=C1a(f[hb>>2]|0,f[hb+4>>2]|0,eb|0,((eb|0)<0)<<31>>31|0)|0;eb=gb;f[eb>>2]=db;f[eb+4>>2]=J;Jb=Db+(cb<<4)+8|0;break}}else{d[jb>>1]=0;cb=kb|1;d[pb+(cb<<1)>>1]=0;d[ob+(kb<<1)>>1]=0;d[ob+(cb<<1)>>1]=0;eb=f[xb>>2]|0;db=f[eb>>2]|0;gb=(db|0)>(kb|0)?kb:db;db=eb+8|0;hb=f[db>>2]|0;bb=(hb|0)<(kb|0)?kb:hb;hb=eb+4|0;fb=f[hb>>2]|0;ab=(fb|0)>(tb|0)?tb:fb;fb=eb+12|0;$a=f[fb>>2]|0;_a=($a|0)<(tb|0)?tb:$a;$a=eb+16|0;Za=f[$a>>2]|0;Ya=f[wb>>2]|0;Xa=((kb|0)<0)<<31>>31;Wa=Ya;Va=C1a(f[Wa>>2]|0,f[Wa+4>>2]|0,kb|0,Xa|0)|0;Wa=J;Ua=Ya+8|0;Ta=Ua;Sa=C1a(f[Ta>>2]|0,f[Ta+4>>2]|0,tb|0,sb|0)|0;Ta=J;Ra=(gb|0)>(cb|0)?cb:gb;gb=((cb|0)<0)<<31>>31;Qa=C1a(Va|0,Wa|0,cb|0,gb|0)|0;Wa=J;Va=C1a(Sa|0,Ta|0,tb|0,sb|0)|0;Ta=J;Sa=C1a(Qa|0,Wa|0,kb|0,Xa|0)|0;Xa=J;Wa=C1a(Va|0,Ta|0,nb|0,lb|0)|0;Ta=Ua;f[Ta>>2]=Wa;f[Ta+4>>2]=J;f[eb>>2]=(Ra|0)>(kb|0)?kb:Ra;f[db>>2]=(bb|0)<(cb|0)?cb:bb;f[hb>>2]=(ab|0)>(nb|0)?nb:ab;f[fb>>2]=(_a|0)<(nb|0)?nb:_a;f[$a>>2]=Za+4;Za=C1a(Sa|0,Xa|0,cb|0,gb|0)|0;gb=Ya;f[gb>>2]=Za;f[gb+4>>2]=J;Jb=Ua}while(0);jb=Jb;ib=C1a(f[jb>>2]|0,f[jb+4>>2]|0,nb|0,lb|0)|0;jb=Jb;f[jb>>2]=ib;f[jb+4>>2]=J;kb=kb+2|0;Kb=f[r>>2]|0}while((kb|0)<(Kb|0));Lb=f[l>>2]|0;Mb=Kb}else{Lb=ub;Mb=rb}tb=tb+2|0;if((tb|0)>=(Lb|0))break b;else{rb=Mb;ub=Lb}}}if(zb){ub=h+20|0;rb=h+120|0;tb=h+48|0;wb=f[c+16>>2]|0;xb=f[c+44>>2]|0;vb=f[e+16>>2]|0;k=f[e+44>>2]|0;yb=i;v=Ab;N=0;while(1){kb=f[xb>>2]|0;lb=wb+(Y(kb,N)|0)|0;nb=lb+kb|0;kb=f[k>>2]|0;sb=vb+(Y(kb,N)|0)|0;ob=sb+kb|0;if((yb|0)>0){kb=((N|0)<0)<<31>>31;pb=N|1;mb=((pb|0)<0)<<31>>31;qb=0;do{jb=sb+(qb<<1)|0;ib=d[jb>>1]|0;do if(!(ib<<16>>16)){d[jb>>1]=0;d[ob+(qb<<1)>>1]=0;I=f[ub>>2]|0;K=f[I>>2]|0;Ua=(K|0)>(qb|0)?qb:K;K=I+8|0;gb=f[K>>2]|0;Za=(gb|0)<(qb|0)?qb:gb;gb=I+4|0;Ya=f[gb>>2]|0;cb=(Ya|0)>(N|0)?N:Ya;Ya=I+12|0;Xa=f[Ya>>2]|0;Sa=(Xa|0)<(N|0)?N:Xa;Xa=I+16|0;$a=f[Xa>>2]|0;_a=f[rb>>2]|0;fb=((qb|0)<0)<<31>>31;ab=_a;hb=C1a(f[ab>>2]|0,f[ab+4>>2]|0,qb|0,fb|0)|0;ab=J;bb=_a+8|0;db=bb;Ra=C1a(f[db>>2]|0,f[db+4>>2]|0,N|0,kb|0)|0;db=J;f[I>>2]=Ua;f[K>>2]=Za;eb=(cb|0)>(pb|0)?pb:cb;f[gb>>2]=eb;cb=(Sa|0)<(pb|0)?pb:Sa;f[Ya>>2]=cb;f[Xa>>2]=$a+2;Sa=C1a(hb|0,ab|0,qb|0,fb|0)|0;fb=J;ab=_a;f[ab>>2]=Sa;f[ab+4>>2]=fb;ab=C1a(Ra|0,db|0,pb|0,mb|0)|0;db=J;Ra=bb;f[Ra>>2]=ab;f[Ra+4>>2]=db;Ra=qb|1;if((Ra|0)<(f[r>>2]|0)){d[sb+(Ra<<1)>>1]=0;d[ob+(Ra<<1)>>1]=0;hb=((Ra|0)<0)<<31>>31;Ta=C1a(Sa|0,fb|0,Ra|0,hb|0)|0;fb=J;Sa=C1a(ab|0,db|0,N|0,kb|0)|0;db=J;f[I>>2]=(Ua|0)>(Ra|0)?Ra:Ua;f[K>>2]=(Za|0)<(Ra|0)?Ra:Za;f[gb>>2]=(eb|0)>(N|0)?N:eb;f[Ya>>2]=cb;f[Xa>>2]=$a+4;$a=C1a(Ta|0,fb|0,Ra|0,hb|0)|0;hb=_a;f[hb>>2]=$a;f[hb+4>>2]=J;hb=C1a(Sa|0,db|0,pb|0,mb|0)|0;db=bb;f[db>>2]=hb;f[db+4>>2]=J}}else{db=d[q+((ib&65535)<<1)>>1]|0;if(!(b[lb+qb>>0]|0)){d[jb>>1]=0;hb=f[ub>>2]|0;bb=f[hb>>2]|0;f[hb>>2]=(bb|0)>(qb|0)?qb:bb;bb=hb+8|0;Sa=f[bb>>2]|0;f[bb>>2]=(Sa|0)<(qb|0)?qb:Sa;Sa=hb+4|0;bb=f[Sa>>2]|0;f[Sa>>2]=(bb|0)>(N|0)?N:bb;bb=hb+12|0;Sa=f[bb>>2]|0;f[bb>>2]=(Sa|0)<(N|0)?N:Sa;Sa=hb+16|0;f[Sa>>2]=(f[Sa>>2]|0)+1;Sa=f[rb>>2]|0;bb=Sa;$a=C1a(f[bb>>2]|0,f[bb+4>>2]|0,qb|0,((qb|0)<0)<<31>>31|0)|0;bb=Sa;f[bb>>2]=$a;f[bb+4>>2]=J;Nb=hb;Ob=Sa;Pb=Sa+8|0}else{d[jb>>1]=db;Sa=db&65535;hb=f[ub>>2]|0;bb=hb+(Y(f[f[tb>>2]>>2]|0,Sa)|0)|0;$a=f[bb>>2]|0;f[bb>>2]=($a|0)>(qb|0)?qb:$a;$a=bb+8|0;_a=f[$a>>2]|0;f[$a>>2]=(_a|0)<(qb|0)?qb:_a;_a=bb+4|0;$a=f[_a>>2]|0;f[_a>>2]=($a|0)>(N|0)?N:$a;$a=bb+12|0;_a=f[$a>>2]|0;f[$a>>2]=(_a|0)<(N|0)?N:_a;_a=bb+16|0;f[_a>>2]=(f[_a>>2]|0)+1;_a=f[rb>>2]|0;bb=_a+(Sa<<4)|0;$a=bb;Ra=C1a(f[$a>>2]|0,f[$a+4>>2]|0,qb|0,((qb|0)<0)<<31>>31|0)|0;$a=bb;f[$a>>2]=Ra;f[$a+4>>2]=J;Nb=hb;Ob=_a;Pb=_a+(Sa<<4)+8|0}Sa=Pb;_a=C1a(f[Sa>>2]|0,f[Sa+4>>2]|0,N|0,kb|0)|0;Sa=Pb;f[Sa>>2]=_a;f[Sa+4>>2]=J;Sa=ob+(qb<<1)|0;if(!(b[nb+qb>>0]|0)){d[Sa>>1]=0;Qb=0;Rb=Nb}else{d[Sa>>1]=db;Sa=db&65535;Qb=Sa;Rb=Nb+(Y(f[f[tb>>2]>>2]|0,Sa)|0)|0}Sa=f[Rb>>2]|0;f[Rb>>2]=(Sa|0)>(qb|0)?qb:Sa;Sa=Rb+8|0;_a=f[Sa>>2]|0;f[Sa>>2]=(_a|0)<(qb|0)?qb:_a;_a=Rb+4|0;Sa=f[_a>>2]|0;f[_a>>2]=(Sa|0)>(pb|0)?pb:Sa;Sa=Rb+12|0;_a=f[Sa>>2]|0;f[Sa>>2]=(_a|0)<(pb|0)?pb:_a;_a=Rb+16|0;f[_a>>2]=(f[_a>>2]|0)+1;_a=Ob+(Qb<<4)|0;Sa=_a;hb=C1a(f[Sa>>2]|0,f[Sa+4>>2]|0,qb|0,((qb|0)<0)<<31>>31|0)|0;Sa=_a;f[Sa>>2]=hb;f[Sa+4>>2]=J;Sa=Ob+(Qb<<4)+8|0;hb=Sa;_a=C1a(f[hb>>2]|0,f[hb+4>>2]|0,pb|0,mb|0)|0;hb=Sa;f[hb>>2]=_a;f[hb+4>>2]=J;hb=qb|1;if((hb|0)<(f[r>>2]|0)){_a=sb+(hb<<1)|0;if(!(b[lb+hb>>0]|0)){d[_a>>1]=0;Sb=0;Tb=Nb}else{d[_a>>1]=db;_a=db&65535;Sb=_a;Tb=Nb+(Y(f[f[tb>>2]>>2]|0,_a)|0)|0}_a=f[Tb>>2]|0;f[Tb>>2]=(_a|0)>(hb|0)?hb:_a;_a=Tb+8|0;Sa=f[_a>>2]|0;f[_a>>2]=(Sa|0)<(hb|0)?hb:Sa;Sa=Tb+4|0;_a=f[Sa>>2]|0;f[Sa>>2]=(_a|0)>(N|0)?N:_a;_a=Tb+12|0;Sa=f[_a>>2]|0;f[_a>>2]=(Sa|0)<(N|0)?N:Sa;Sa=Tb+16|0;f[Sa>>2]=(f[Sa>>2]|0)+1;Sa=Ob+(Sb<<4)|0;_a=Sa;$a=C1a(f[_a>>2]|0,f[_a+4>>2]|0,hb|0,((hb|0)<0)<<31>>31|0)|0;_a=Sa;f[_a>>2]=$a;f[_a+4>>2]=J;_a=Ob+(Sb<<4)+8|0;$a=_a;Sa=C1a(f[$a>>2]|0,f[$a+4>>2]|0,N|0,kb|0)|0;$a=_a;f[$a>>2]=Sa;f[$a+4>>2]=J;$a=ob+(hb<<1)|0;if(!(b[nb+hb>>0]|0)){d[$a>>1]=0;Sa=f[Nb>>2]|0;f[Nb>>2]=(Sa|0)>(hb|0)?hb:Sa;Sa=Nb+8|0;_a=f[Sa>>2]|0;f[Sa>>2]=(_a|0)<(hb|0)?hb:_a;_a=Nb+4|0;Sa=f[_a>>2]|0;f[_a>>2]=(Sa|0)>(pb|0)?pb:Sa;Sa=Nb+12|0;_a=f[Sa>>2]|0;f[Sa>>2]=(_a|0)<(pb|0)?pb:_a;_a=Nb+16|0;f[_a>>2]=(f[_a>>2]|0)+1;_a=Ob;Sa=C1a(f[_a>>2]|0,f[_a+4>>2]|0,hb|0,((hb|0)<0)<<31>>31|0)|0;_a=Ob;f[_a>>2]=Sa;f[_a+4>>2]=J;_a=Ob+8|0;Sa=_a;Ra=C1a(f[Sa>>2]|0,f[Sa+4>>2]|0,pb|0,mb|0)|0;Sa=_a;f[Sa>>2]=Ra;f[Sa+4>>2]=J;break}else{d[$a>>1]=db;$a=db&65535;db=Nb+(Y(f[f[tb>>2]>>2]|0,$a)|0)|0;Sa=f[db>>2]|0;f[db>>2]=(Sa|0)>(hb|0)?hb:Sa;Sa=db+8|0;Ra=f[Sa>>2]|0;f[Sa>>2]=(Ra|0)<(hb|0)?hb:Ra;Ra=db+4|0;Sa=f[Ra>>2]|0;f[Ra>>2]=(Sa|0)>(pb|0)?pb:Sa;Sa=db+12|0;Ra=f[Sa>>2]|0;f[Sa>>2]=(Ra|0)<(pb|0)?pb:Ra;Ra=db+16|0;f[Ra>>2]=(f[Ra>>2]|0)+1;Ra=Ob+($a<<4)|0;db=Ra;Sa=C1a(f[db>>2]|0,f[db+4>>2]|0,hb|0,((hb|0)<0)<<31>>31|0)|0;hb=Ra;f[hb>>2]=Sa;f[hb+4>>2]=J;hb=Ob+($a<<4)+8|0;$a=hb;Sa=C1a(f[$a>>2]|0,f[$a+4>>2]|0,pb|0,mb|0)|0;$a=hb;f[$a>>2]=Sa;f[$a+4>>2]=J;break}}}while(0);qb=qb+2|0;Ub=f[r>>2]|0}while((qb|0)<(Ub|0));Vb=f[l>>2]|0;Wb=Ub}else{Vb=v;Wb=yb}N=N+2|0;if((N|0)>=(Vb|0))break;else{yb=Wb;v=Vb}}}}else{if(!t){if(!zb)break;v=h+20|0;yb=h+120|0;N=h+48|0;tb=f[c+16>>2]|0;rb=f[c+44>>2]|0;ub=f[e+16>>2]|0;vb=f[e+44>>2]|0;k=i;wb=Ab;xb=0;while(1){qb=f[rb>>2]|0;mb=tb+(Y(qb,xb)|0)|0;pb=mb+qb|0;qb=f[vb>>2]|0;nb=ub+(Y(qb,xb)|0)|0;ob=nb+qb|0;if((k|0)>0){qb=((xb|0)<0)<<31>>31;kb=xb|1;lb=((kb|0)<0)<<31>>31;sb=0;do{jb=nb+(sb<<1)|0;ib=d[jb>>1]|0;do if(!(ib<<16>>16)){d[jb>>1]=0;$a=sb|1;d[nb+($a<<1)>>1]=0;Sa=f[v>>2]|0;hb=f[Sa>>2]|0;Ra=(hb|0)>(sb|0)?sb:hb;hb=Sa+8|0;db=f[hb>>2]|0;_a=(db|0)<(sb|0)?sb:db;db=Sa+4|0;bb=f[db>>2]|0;fb=(bb|0)>(xb|0)?xb:bb;bb=Sa+12|0;Ta=f[bb>>2]|0;Xa=(Ta|0)<(xb|0)?xb:Ta;Ta=Sa+16|0;cb=f[Ta>>2]|0;Ya=f[yb>>2]|0;eb=((sb|0)<0)<<31>>31;gb=Ya;Za=C1a(f[gb>>2]|0,f[gb+4>>2]|0,sb|0,eb|0)|0;gb=J;K=Ya+8|0;Ua=K;I=C1a(f[Ua>>2]|0,f[Ua+4>>2]|0,xb|0,qb|0)|0;Ua=J;ab=(Ra|0)>($a|0)?$a:Ra;f[Sa>>2]=ab;Ra=(_a|0)<($a|0)?$a:_a;f[hb>>2]=Ra;f[db>>2]=fb;f[bb>>2]=Xa;f[Ta>>2]=cb+2;_a=(($a|0)<0)<<31>>31;Wa=C1a(Za|0,gb|0,$a|0,_a|0)|0;gb=J;Za=Ya;f[Za>>2]=Wa;f[Za+4>>2]=gb;Za=C1a(I|0,Ua|0,xb|0,qb|0)|0;Ua=J;I=K;f[I>>2]=Za;f[I+4>>2]=Ua;if((kb|0)<(f[l>>2]|0)){d[ob+(sb<<1)>>1]=0;d[ob+($a<<1)>>1]=0;I=C1a(Wa|0,gb|0,sb|0,eb|0)|0;eb=J;gb=C1a(Za|0,Ua|0,kb|0,lb|0)|0;Ua=J;f[Sa>>2]=(ab|0)>(sb|0)?sb:ab;f[hb>>2]=Ra;f[db>>2]=(fb|0)>(kb|0)?kb:fb;f[bb>>2]=(Xa|0)<(kb|0)?kb:Xa;f[Ta>>2]=cb+4;cb=C1a(I|0,eb|0,$a|0,_a|0)|0;_a=Ya;f[_a>>2]=cb;f[_a+4>>2]=J;_a=C1a(gb|0,Ua|0,kb|0,lb|0)|0;Ua=K;f[Ua>>2]=_a;f[Ua+4>>2]=J}}else{Ua=d[q+((ib&65535)<<1)>>1]|0;if(!(b[mb+sb>>0]|0)){d[jb>>1]=0;_a=f[v>>2]|0;K=f[_a>>2]|0;f[_a>>2]=(K|0)>(sb|0)?sb:K;K=_a+8|0;gb=f[K>>2]|0;f[K>>2]=(gb|0)<(sb|0)?sb:gb;gb=_a+4|0;K=f[gb>>2]|0;f[gb>>2]=(K|0)>(xb|0)?xb:K;K=_a+12|0;gb=f[K>>2]|0;f[K>>2]=(gb|0)<(xb|0)?xb:gb;gb=_a+16|0;f[gb>>2]=(f[gb>>2]|0)+1;gb=f[yb>>2]|0;K=gb;cb=C1a(f[K>>2]|0,f[K+4>>2]|0,sb|0,((sb|0)<0)<<31>>31|0)|0;K=gb;f[K>>2]=cb;f[K+4>>2]=J;Xb=_a;Yb=gb;Zb=gb+8|0}else{d[jb>>1]=Ua;gb=Ua&65535;_a=f[v>>2]|0;K=_a+(Y(f[f[N>>2]>>2]|0,gb)|0)|0;cb=f[K>>2]|0;f[K>>2]=(cb|0)>(sb|0)?sb:cb;cb=K+8|0;Ya=f[cb>>2]|0;f[cb>>2]=(Ya|0)<(sb|0)?sb:Ya;Ya=K+4|0;cb=f[Ya>>2]|0;f[Ya>>2]=(cb|0)>(xb|0)?xb:cb;cb=K+12|0;Ya=f[cb>>2]|0;f[cb>>2]=(Ya|0)<(xb|0)?xb:Ya;Ya=K+16|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=f[yb>>2]|0;K=Ya+(gb<<4)|0;cb=K;$a=C1a(f[cb>>2]|0,f[cb+4>>2]|0,sb|0,((sb|0)<0)<<31>>31|0)|0;cb=K;f[cb>>2]=$a;f[cb+4>>2]=J;Xb=_a;Yb=Ya;Zb=Ya+(gb<<4)+8|0}gb=Zb;Ya=C1a(f[gb>>2]|0,f[gb+4>>2]|0,xb|0,qb|0)|0;gb=Zb;f[gb>>2]=Ya;f[gb+4>>2]=J;gb=sb|1;Ya=nb+(gb<<1)|0;if(!(b[mb+gb>>0]|0)){d[Ya>>1]=0;_b=0;$b=Xb}else{d[Ya>>1]=Ua;Ya=Ua&65535;_b=Ya;$b=Xb+(Y(f[f[N>>2]>>2]|0,Ya)|0)|0}Ya=f[$b>>2]|0;f[$b>>2]=(Ya|0)>(gb|0)?gb:Ya;Ya=$b+8|0;_a=f[Ya>>2]|0;f[Ya>>2]=(_a|0)<(gb|0)?gb:_a;_a=$b+4|0;Ya=f[_a>>2]|0;f[_a>>2]=(Ya|0)>(xb|0)?xb:Ya;Ya=$b+12|0;_a=f[Ya>>2]|0;f[Ya>>2]=(_a|0)<(xb|0)?xb:_a;_a=$b+16|0;f[_a>>2]=(f[_a>>2]|0)+1;_a=Yb+(_b<<4)|0;Ya=_a;cb=C1a(f[Ya>>2]|0,f[Ya+4>>2]|0,gb|0,((gb|0)<0)<<31>>31|0)|0;Ya=_a;f[Ya>>2]=cb;f[Ya+4>>2]=J;Ya=Yb+(_b<<4)+8|0;cb=Ya;_a=C1a(f[cb>>2]|0,f[cb+4>>2]|0,xb|0,qb|0)|0;cb=Ya;f[cb>>2]=_a;f[cb+4>>2]=J;if((kb|0)<(f[l>>2]|0)){cb=ob+(sb<<1)|0;if(!(b[pb+sb>>0]|0)){d[cb>>1]=0;ac=0;bc=Xb}else{d[cb>>1]=Ua;cb=Ua&65535;ac=cb;bc=Xb+(Y(f[f[N>>2]>>2]|0,cb)|0)|0}cb=f[bc>>2]|0;f[bc>>2]=(cb|0)>(sb|0)?sb:cb;cb=bc+8|0;_a=f[cb>>2]|0;f[cb>>2]=(_a|0)<(sb|0)?sb:_a;_a=bc+4|0;cb=f[_a>>2]|0;f[_a>>2]=(cb|0)>(kb|0)?kb:cb;cb=bc+12|0;_a=f[cb>>2]|0;f[cb>>2]=(_a|0)<(kb|0)?kb:_a;_a=bc+16|0;f[_a>>2]=(f[_a>>2]|0)+1;_a=Yb+(ac<<4)|0;cb=_a;Ya=C1a(f[cb>>2]|0,f[cb+4>>2]|0,sb|0,((sb|0)<0)<<31>>31|0)|0;cb=_a;f[cb>>2]=Ya;f[cb+4>>2]=J;cb=Yb+(ac<<4)+8|0;Ya=cb;_a=C1a(f[Ya>>2]|0,f[Ya+4>>2]|0,kb|0,lb|0)|0;Ya=cb;f[Ya>>2]=_a;f[Ya+4>>2]=J;Ya=ob+(gb<<1)|0;if(!(b[pb+gb>>0]|0)){d[Ya>>1]=0;_a=f[Xb>>2]|0;f[Xb>>2]=(_a|0)>(gb|0)?gb:_a;_a=Xb+8|0;cb=f[_a>>2]|0;f[_a>>2]=(cb|0)<(gb|0)?gb:cb;cb=Xb+4|0;_a=f[cb>>2]|0;f[cb>>2]=(_a|0)>(kb|0)?kb:_a;_a=Xb+12|0;cb=f[_a>>2]|0;f[_a>>2]=(cb|0)<(kb|0)?kb:cb;cb=Xb+16|0;f[cb>>2]=(f[cb>>2]|0)+1;cb=Yb;_a=C1a(f[cb>>2]|0,f[cb+4>>2]|0,gb|0,((gb|0)<0)<<31>>31|0)|0;cb=Yb;f[cb>>2]=_a;f[cb+4>>2]=J;cb=Yb+8|0;_a=cb;$a=C1a(f[_a>>2]|0,f[_a+4>>2]|0,kb|0,lb|0)|0;_a=cb;f[_a>>2]=$a;f[_a+4>>2]=J;break}else{d[Ya>>1]=Ua;Ya=Ua&65535;Ua=Xb+(Y(f[f[N>>2]>>2]|0,Ya)|0)|0;_a=f[Ua>>2]|0;f[Ua>>2]=(_a|0)>(gb|0)?gb:_a;_a=Ua+8|0;$a=f[_a>>2]|0;f[_a>>2]=($a|0)<(gb|0)?gb:$a;$a=Ua+4|0;_a=f[$a>>2]|0;f[$a>>2]=(_a|0)>(kb|0)?kb:_a;_a=Ua+12|0;$a=f[_a>>2]|0;f[_a>>2]=($a|0)<(kb|0)?kb:$a;$a=Ua+16|0;f[$a>>2]=(f[$a>>2]|0)+1;$a=Yb+(Ya<<4)|0;Ua=$a;_a=C1a(f[Ua>>2]|0,f[Ua+4>>2]|0,gb|0,((gb|0)<0)<<31>>31|0)|0;gb=$a;f[gb>>2]=_a;f[gb+4>>2]=J;gb=Yb+(Ya<<4)+8|0;Ya=gb;_a=C1a(f[Ya>>2]|0,f[Ya+4>>2]|0,kb|0,lb|0)|0;Ya=gb;f[Ya>>2]=_a;f[Ya+4>>2]=J;break}}}while(0);sb=sb+2|0;cc=f[r>>2]|0}while((sb|0)<(cc|0));dc=f[l>>2]|0;ec=cc}else{dc=wb;ec=k}xb=xb+2|0;if((xb|0)>=(dc|0))break b;else{k=ec;wb=dc}}}if(zb){wb=h+20|0;k=h+120|0;xb=h+48|0;N=f[c+16>>2]|0;yb=f[c+44>>2]|0;v=f[e+16>>2]|0;ub=f[e+44>>2]|0;vb=Ab;tb=i;rb=0;while(1){sb=f[yb>>2]|0;lb=N+(Y(sb,rb)|0)|0;kb=lb+sb|0;sb=f[ub>>2]|0;pb=v+(Y(sb,rb)|0)|0;ob=pb+sb|0;if((tb|0)>0){sb=((rb|0)<0)<<31>>31;qb=rb|1;mb=((qb|0)<0)<<31>>31;nb=0;do{jb=pb+(nb<<1)|0;ib=d[jb>>1]|0;do if(!(ib<<16>>16)){d[jb>>1]=0;Ya=f[wb>>2]|0;_a=f[Ya>>2]|0;gb=(_a|0)>(nb|0)?nb:_a;f[Ya>>2]=gb;_a=Ya+8|0;$a=f[_a>>2]|0;Ua=($a|0)<(nb|0)?nb:$a;f[_a>>2]=Ua;$a=Ya+4|0;cb=f[$a>>2]|0;K=(cb|0)>(rb|0)?rb:cb;f[$a>>2]=K;cb=Ya+12|0;eb=f[cb>>2]|0;I=(eb|0)<(rb|0)?rb:eb;f[cb>>2]=I;eb=Ya+16|0;Ta=f[eb>>2]|0;f[eb>>2]=Ta+1;Xa=f[k>>2]|0;bb=((nb|0)<0)<<31>>31;fb=Xa;db=C1a(f[fb>>2]|0,f[fb+4>>2]|0,nb|0,bb|0)|0;fb=J;Ra=Xa;f[Ra>>2]=db;f[Ra+4>>2]=fb;Ra=Xa+8|0;hb=Ra;ab=C1a(f[hb>>2]|0,f[hb+4>>2]|0,rb|0,sb|0)|0;hb=J;Sa=Ra;f[Sa>>2]=ab;f[Sa+4>>2]=hb;Sa=nb|1;if((Sa|0)<(f[r>>2]|0)){d[pb+(Sa<<1)>>1]=0;Za=(gb|0)>(Sa|0)?Sa:gb;f[Ya>>2]=Za;Wa=(Ua|0)<(Sa|0)?Sa:Ua;f[_a>>2]=Wa;f[$a>>2]=K;f[cb>>2]=I;f[eb>>2]=Ta+2;Va=((Sa|0)<0)<<31>>31;Qa=C1a(db|0,fb|0,Sa|0,Va|0)|0;Pa=J;Oa=Xa;f[Oa>>2]=Qa;f[Oa+4>>2]=Pa;Oa=C1a(ab|0,hb|0,rb|0,sb|0)|0;Na=J;Ma=Ra;f[Ma>>2]=Oa;f[Ma+4>>2]=Na;if((qb|0)>=(f[l>>2]|0))break;d[ob+(nb<<1)>>1]=0;d[ob+(Sa<<1)>>1]=0;Ma=C1a(Qa|0,Pa|0,nb|0,bb|0)|0;Pa=J;Qa=C1a(Oa|0,Na|0,qb|0,mb|0)|0;Na=J;f[Ya>>2]=(Za|0)>(nb|0)?nb:Za;f[_a>>2]=Wa;f[$a>>2]=(K|0)>(qb|0)?qb:K;f[cb>>2]=(I|0)<(qb|0)?qb:I;f[eb>>2]=Ta+4;Wa=C1a(Ma|0,Pa|0,Sa|0,Va|0)|0;Va=Xa;f[Va>>2]=Wa;f[Va+4>>2]=J;Va=C1a(Qa|0,Na|0,qb|0,mb|0)|0;Na=Ra;f[Na>>2]=Va;f[Na+4>>2]=J;break}else{if((qb|0)>=(f[l>>2]|0))break;d[ob+(nb<<1)>>1]=0;f[Ya>>2]=gb;f[_a>>2]=Ua;f[$a>>2]=(K|0)>(qb|0)?qb:K;f[cb>>2]=(I|0)<(qb|0)?qb:I;f[eb>>2]=Ta+2;Ta=C1a(db|0,fb|0,nb|0,bb|0)|0;bb=Xa;f[bb>>2]=Ta;f[bb+4>>2]=J;bb=C1a(ab|0,hb|0,qb|0,mb|0)|0;hb=Ra;f[hb>>2]=bb;f[hb+4>>2]=J;break}}else{hb=d[q+((ib&65535)<<1)>>1]|0;if(!(b[lb+nb>>0]|0)){d[jb>>1]=0;bb=f[wb>>2]|0;Ra=f[bb>>2]|0;f[bb>>2]=(Ra|0)>(nb|0)?nb:Ra;Ra=bb+8|0;ab=f[Ra>>2]|0;f[Ra>>2]=(ab|0)<(nb|0)?nb:ab;ab=bb+4|0;Ra=f[ab>>2]|0;f[ab>>2]=(Ra|0)>(rb|0)?rb:Ra;Ra=bb+12|0;ab=f[Ra>>2]|0;f[Ra>>2]=(ab|0)<(rb|0)?rb:ab;ab=bb+16|0;f[ab>>2]=(f[ab>>2]|0)+1;ab=f[k>>2]|0;Ra=ab;Ta=C1a(f[Ra>>2]|0,f[Ra+4>>2]|0,nb|0,((nb|0)<0)<<31>>31|0)|0;Ra=ab;f[Ra>>2]=Ta;f[Ra+4>>2]=J;fc=bb;gc=ab;hc=ab+8|0}else{d[jb>>1]=hb;ab=hb&65535;bb=f[wb>>2]|0;Ra=bb+(Y(f[f[xb>>2]>>2]|0,ab)|0)|0;Ta=f[Ra>>2]|0;f[Ra>>2]=(Ta|0)>(nb|0)?nb:Ta;Ta=Ra+8|0;Xa=f[Ta>>2]|0;f[Ta>>2]=(Xa|0)<(nb|0)?nb:Xa;Xa=Ra+4|0;Ta=f[Xa>>2]|0;f[Xa>>2]=(Ta|0)>(rb|0)?rb:Ta;Ta=Ra+12|0;Xa=f[Ta>>2]|0;f[Ta>>2]=(Xa|0)<(rb|0)?rb:Xa;Xa=Ra+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=f[k>>2]|0;Ra=Xa+(ab<<4)|0;Ta=Ra;fb=C1a(f[Ta>>2]|0,f[Ta+4>>2]|0,nb|0,((nb|0)<0)<<31>>31|0)|0;Ta=Ra;f[Ta>>2]=fb;f[Ta+4>>2]=J;fc=bb;gc=Xa;hc=Xa+(ab<<4)+8|0}ab=hc;Xa=C1a(f[ab>>2]|0,f[ab+4>>2]|0,rb|0,sb|0)|0;ab=hc;f[ab>>2]=Xa;f[ab+4>>2]=J;ab=nb|1;if((ab|0)>=(f[r>>2]|0)){if((qb|0)>=(f[l>>2]|0))break;Xa=ob+(nb<<1)|0;if(!(b[kb+nb>>0]|0)){d[Xa>>1]=0;bb=f[fc>>2]|0;f[fc>>2]=(bb|0)>(nb|0)?nb:bb;bb=fc+8|0;Ta=f[bb>>2]|0;f[bb>>2]=(Ta|0)<(nb|0)?nb:Ta;Ta=fc+4|0;bb=f[Ta>>2]|0;f[Ta>>2]=(bb|0)>(qb|0)?qb:bb;bb=fc+12|0;Ta=f[bb>>2]|0;f[bb>>2]=(Ta|0)<(qb|0)?qb:Ta;Ta=fc+16|0;f[Ta>>2]=(f[Ta>>2]|0)+1;Ta=gc;bb=C1a(f[Ta>>2]|0,f[Ta+4>>2]|0,nb|0,((nb|0)<0)<<31>>31|0)|0;Ta=gc;f[Ta>>2]=bb;f[Ta+4>>2]=J;Ta=gc+8|0;bb=Ta;fb=C1a(f[bb>>2]|0,f[bb+4>>2]|0,qb|0,mb|0)|0;bb=Ta;f[bb>>2]=fb;f[bb+4>>2]=J;break}else{d[Xa>>1]=hb;Xa=hb&65535;bb=fc+(Y(f[f[xb>>2]>>2]|0,Xa)|0)|0;fb=f[bb>>2]|0;f[bb>>2]=(fb|0)>(nb|0)?nb:fb;fb=bb+8|0;Ta=f[fb>>2]|0;f[fb>>2]=(Ta|0)<(nb|0)?nb:Ta;Ta=bb+4|0;fb=f[Ta>>2]|0;f[Ta>>2]=(fb|0)>(qb|0)?qb:fb;fb=bb+12|0;Ta=f[fb>>2]|0;f[fb>>2]=(Ta|0)<(qb|0)?qb:Ta;Ta=bb+16|0;f[Ta>>2]=(f[Ta>>2]|0)+1;Ta=gc+(Xa<<4)|0;bb=Ta;fb=C1a(f[bb>>2]|0,f[bb+4>>2]|0,nb|0,((nb|0)<0)<<31>>31|0)|0;bb=Ta;f[bb>>2]=fb;f[bb+4>>2]=J;bb=gc+(Xa<<4)+8|0;Xa=bb;fb=C1a(f[Xa>>2]|0,f[Xa+4>>2]|0,qb|0,mb|0)|0;Xa=bb;f[Xa>>2]=fb;f[Xa+4>>2]=J;break}}Xa=pb+(ab<<1)|0;if(!(b[lb+ab>>0]|0)){d[Xa>>1]=0;ic=0;jc=fc}else{d[Xa>>1]=hb;Xa=hb&65535;ic=Xa;jc=fc+(Y(f[f[xb>>2]>>2]|0,Xa)|0)|0}Xa=f[jc>>2]|0;f[jc>>2]=(Xa|0)>(ab|0)?ab:Xa;Xa=jc+8|0;fb=f[Xa>>2]|0;f[Xa>>2]=(fb|0)<(ab|0)?ab:fb;fb=jc+4|0;Xa=f[fb>>2]|0;f[fb>>2]=(Xa|0)>(rb|0)?rb:Xa;Xa=jc+12|0;fb=f[Xa>>2]|0;f[Xa>>2]=(fb|0)<(rb|0)?rb:fb;fb=jc+16|0;f[fb>>2]=(f[fb>>2]|0)+1;fb=gc+(ic<<4)|0;Xa=fb;bb=C1a(f[Xa>>2]|0,f[Xa+4>>2]|0,ab|0,((ab|0)<0)<<31>>31|0)|0;Xa=fb;f[Xa>>2]=bb;f[Xa+4>>2]=J;Xa=gc+(ic<<4)+8|0;bb=Xa;fb=C1a(f[bb>>2]|0,f[bb+4>>2]|0,rb|0,sb|0)|0;bb=Xa;f[bb>>2]=fb;f[bb+4>>2]=J;if((qb|0)<(f[l>>2]|0)){bb=ob+(nb<<1)|0;if(!(b[kb+nb>>0]|0)){d[bb>>1]=0;kc=0;lc=fc}else{d[bb>>1]=hb;bb=hb&65535;kc=bb;lc=fc+(Y(f[f[xb>>2]>>2]|0,bb)|0)|0}bb=f[lc>>2]|0;f[lc>>2]=(bb|0)>(nb|0)?nb:bb;bb=lc+8|0;fb=f[bb>>2]|0;f[bb>>2]=(fb|0)<(nb|0)?nb:fb;fb=lc+4|0;bb=f[fb>>2]|0;f[fb>>2]=(bb|0)>(qb|0)?qb:bb;bb=lc+12|0;fb=f[bb>>2]|0;f[bb>>2]=(fb|0)<(qb|0)?qb:fb;fb=lc+16|0;f[fb>>2]=(f[fb>>2]|0)+1;fb=gc+(kc<<4)|0;bb=fb;Xa=C1a(f[bb>>2]|0,f[bb+4>>2]|0,nb|0,((nb|0)<0)<<31>>31|0)|0;bb=fb;f[bb>>2]=Xa;f[bb+4>>2]=J;bb=gc+(kc<<4)+8|0;Xa=bb;fb=C1a(f[Xa>>2]|0,f[Xa+4>>2]|0,qb|0,mb|0)|0;Xa=bb;f[Xa>>2]=fb;f[Xa+4>>2]=J;Xa=ob+(ab<<1)|0;if(!(b[kb+ab>>0]|0)){d[Xa>>1]=0;fb=f[fc>>2]|0;f[fc>>2]=(fb|0)>(ab|0)?ab:fb;fb=fc+8|0;bb=f[fb>>2]|0;f[fb>>2]=(bb|0)<(ab|0)?ab:bb;bb=fc+4|0;fb=f[bb>>2]|0;f[bb>>2]=(fb|0)>(qb|0)?qb:fb;fb=fc+12|0;bb=f[fb>>2]|0;f[fb>>2]=(bb|0)<(qb|0)?qb:bb;bb=fc+16|0;f[bb>>2]=(f[bb>>2]|0)+1;bb=gc;fb=C1a(f[bb>>2]|0,f[bb+4>>2]|0,ab|0,((ab|0)<0)<<31>>31|0)|0;bb=gc;f[bb>>2]=fb;f[bb+4>>2]=J;bb=gc+8|0;fb=bb;Ta=C1a(f[fb>>2]|0,f[fb+4>>2]|0,qb|0,mb|0)|0;fb=bb;f[fb>>2]=Ta;f[fb+4>>2]=J;break}else{d[Xa>>1]=hb;Xa=hb&65535;hb=fc+(Y(f[f[xb>>2]>>2]|0,Xa)|0)|0;fb=f[hb>>2]|0;f[hb>>2]=(fb|0)>(ab|0)?ab:fb;fb=hb+8|0;Ta=f[fb>>2]|0;f[fb>>2]=(Ta|0)<(ab|0)?ab:Ta;Ta=hb+4|0;fb=f[Ta>>2]|0;f[Ta>>2]=(fb|0)>(qb|0)?qb:fb;fb=hb+12|0;Ta=f[fb>>2]|0;f[fb>>2]=(Ta|0)<(qb|0)?qb:Ta;Ta=hb+16|0;f[Ta>>2]=(f[Ta>>2]|0)+1;Ta=gc+(Xa<<4)|0;hb=Ta;fb=C1a(f[hb>>2]|0,f[hb+4>>2]|0,ab|0,((ab|0)<0)<<31>>31|0)|0;ab=Ta;f[ab>>2]=fb;f[ab+4>>2]=J;ab=gc+(Xa<<4)+8|0;Xa=ab;fb=C1a(f[Xa>>2]|0,f[Xa+4>>2]|0,qb|0,mb|0)|0;Xa=ab;f[Xa>>2]=fb;f[Xa+4>>2]=J;break}}}while(0);nb=nb+2|0;mc=f[r>>2]|0}while((nb|0)<(mc|0));nc=mc;oc=f[l>>2]|0}else{nc=tb;oc=vb}rb=rb+2|0;if((rb|0)>=(oc|0))break;else{vb=oc;tb=nc}}}}while(0);nc=h+12|0;if((f[nc>>2]|0)<=0){ZF(q);u=a;return Bb|0}oc=f[h+20>>2]|0;l=f[h+48>>2]|0;mc=f[h+120>>2]|0;r=f[h+80>>2]|0;gc=f[h+108>>2]|0;h=0;do{fc=oc+(Y(f[l>>2]|0,h)|0)|0;kc=fc+8|0;f[kc>>2]=(f[kc>>2]|0)+1-(f[fc>>2]|0);kc=fc+12|0;f[kc>>2]=(f[kc>>2]|0)+1-(f[fc+4>>2]|0);kc=r+(Y(f[gc>>2]|0,h)|0)|0;pc=+((f[fc+16>>2]|0)>>>0);fc=mc+(h<<4)|0;p[kc>>3]=(+((f[fc>>2]|0)>>>0)+4294967296.0*+((f[fc+4>>2]|0)>>>0))/pc;fc=mc+(h<<4)+8|0;p[kc+8>>3]=(+((f[fc>>2]|0)>>>0)+4294967296.0*+((f[fc+4>>2]|0)>>>0))/pc;h=h+1|0}while((h|0)<(f[nc>>2]|0));ZF(q);u=a;return Bb|0}function K6(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0.0;a=u;u=u+16|0;h=a;i=c+8|0;j=d+8|0;if((f[i>>2]|0)!=(f[j>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;k=c$(h,26)|0;l=218300;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,h,373355,218048,2594);d$(h)}n=c+12|0;o=d+12|0;if((f[n>>2]|0)!=(f[o>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;k=c$(h,26)|0;l=218327;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,h,373355,218048,2595);d$(h)}if((e|0)!=8){f[h>>2]=0;f[h+4>>2]=0;k=c$(h,17)|0;l=218354;m=k+17|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j$(-215,h,373355,218048,2596);d$(h)}h=f[i>>2]|0;i=f[n>>2]|0;n=YF((Y(((h+1|0)/2|0)<<2,(i+1|0)/2|0)|0)+4|0)|0;f[n>>2]=0;if((h|0)>0){l=c+16|0;k=c+44|0;m=d+16|0;e=d+44|0;q=(i|0)>0;r=1;s=0;while(1){t=f[f[k>>2]>>2]|0;v=(f[l>>2]|0)+(Y(t,s)|0)|0;w=0-t|0;x=v+w|0;y=x+w|0;w=v+t|0;t=f[f[e>>2]>>2]|0;z=(f[m>>2]|0)+(Y(t,s)|0)|0;A=0-t|0;t=z+A+A|0;if(q){A=(s|1|0)<(h|0);B=(s|0)>0;C=B^1;D=(s+-2|0)>-1;E=0;F=r;while(1){a:do if(!(b[v+E>>0]|0)){G=E|1;H=(G|0)<(i|0);if(A?b[w+E>>0]|0:0){I=E+-1|0;K=(E|0)>0;if(H?b[v+G>>0]|0:0){do if(K){if(b[v+I>>0]|0){do if(B){if(b[x+G>>0]|0){if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break a}do if(D){if(!(b[y+E>>0]|0))break;M=E+-2|0;if(b[x+I>>0]|0){f[z+(E<<2)>>2]=f[z+(M<<2)>>2];L=F;break a}do if((M|0)>-1){if(!(b[x+M>>0]|0))break;if(b[y+I>>0]|0){f[z+(E<<2)>>2]=f[z+(M<<2)>>2];L=F;break a}N=f[t+(E<<2)>>2]|0;O=f[z+(M<<2)>>2]|0;P=N;while(1){Q=f[n+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}if((N|0)==(O|0))R=P;else{Q=O;while(1){S=f[n+(Q<<2)>>2]|0;if((S|0)<(Q|0))Q=S;else break}S=(P|0)>(Q|0)?Q:P;T=O;do{U=n+(T<<2)|0;V=T;T=f[U>>2]|0;f[U>>2]=S}while((T|0)<(V|0));R=S}S=N;do{T=n+(S<<2)|0;O=S;S=f[T>>2]|0;f[T>>2]=R}while((S|0)<(O|0));f[z+(E<<2)>>2]=R;L=F;break a}while(0);S=f[t+(E<<2)>>2]|0;N=f[z+(M<<2)>>2]|0;O=S;while(1){T=f[n+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}if((S|0)==(N|0))W=O;else{M=N;while(1){T=f[n+(M<<2)>>2]|0;if((T|0)<(M|0))M=T;else break}T=(O|0)>(M|0)?M:O;P=N;do{Q=n+(P<<2)|0;V=P;P=f[Q>>2]|0;f[Q>>2]=T}while((P|0)<(V|0));W=T}T=S;do{P=n+(T<<2)|0;N=T;T=f[P>>2]|0;f[P>>2]=W}while((T|0)<(N|0));f[z+(E<<2)>>2]=W;L=F;break a}while(0);T=f[t+(E<<2)>>2]|0;S=f[z+(E+-2<<2)>>2]|0;N=T;while(1){P=f[n+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((T|0)==(S|0))X=N;else{P=S;while(1){O=f[n+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}O=(N|0)>(P|0)?P:N;M=S;do{V=n+(M<<2)|0;Q=M;M=f[V>>2]|0;f[V>>2]=O}while((M|0)<(Q|0));X=O}O=T;do{M=n+(O<<2)|0;S=O;O=f[M>>2]|0;f[M>>2]=X}while((O|0)<(S|0));f[z+(E<<2)>>2]=X;L=F;break a}O=E+2|0;if((O|0)>=(i|0))break;if(!(b[x+O>>0]|0))break;do if(D){if(!(b[y+G>>0]|0))break;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break a}if(!(b[y+E>>0]|0)){T=f[t+(O<<2)>>2]|0;S=f[z+(E+-2<<2)>>2]|0;M=T;while(1){N=f[n+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}if((T|0)==(S|0))Z=M;else{N=S;while(1){P=f[n+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(M|0)>(N|0)?N:M;Q=S;do{V=n+(Q<<2)|0;U=Q;Q=f[V>>2]|0;f[V>>2]=P}while((Q|0)<(U|0));Z=P}P=T;do{Q=n+(P<<2)|0;S=P;P=f[Q>>2]|0;f[Q>>2]=Z}while((P|0)<(S|0));f[z+(E<<2)>>2]=Z;L=F;break a}P=E+-2|0;if(b[x+I>>0]|0){f[z+(E<<2)>>2]=f[z+(P<<2)>>2];L=F;break a}do if((P|0)>-1){if(!(b[x+P>>0]|0))break;if(b[y+I>>0]|0){f[z+(E<<2)>>2]=f[z+(P<<2)>>2];L=F;break a}T=f[t+(O<<2)>>2]|0;S=f[z+(P<<2)>>2]|0;Q=T;while(1){M=f[n+(Q<<2)>>2]|0;if((M|0)<(Q|0))Q=M;else break}if((T|0)==(S|0))_=Q;else{M=S;while(1){N=f[n+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}N=(Q|0)>(M|0)?M:Q;U=S;do{V=n+(U<<2)|0;$=U;U=f[V>>2]|0;f[V>>2]=N}while((U|0)<($|0));_=N}N=T;do{U=n+(N<<2)|0;S=N;N=f[U>>2]|0;f[U>>2]=_}while((N|0)<(S|0));f[z+(E<<2)>>2]=_;L=F;break a}while(0);N=f[t+(O<<2)>>2]|0;T=f[z+(P<<2)>>2]|0;S=N;while(1){U=f[n+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}if((N|0)==(T|0))aa=S;else{P=T;while(1){U=f[n+(P<<2)>>2]|0;if((U|0)<(P|0))P=U;else break}U=(S|0)>(P|0)?P:S;Q=T;do{M=n+(Q<<2)|0;$=Q;Q=f[M>>2]|0;f[M>>2]=U}while((Q|0)<($|0));aa=U}U=N;do{Q=n+(U<<2)|0;T=U;U=f[Q>>2]|0;f[Q>>2]=aa}while((U|0)<(T|0));f[z+(E<<2)>>2]=aa;L=F;break a}while(0);U=f[t+(O<<2)>>2]|0;N=f[z+(E+-2<<2)>>2]|0;T=U;while(1){Q=f[n+(T<<2)>>2]|0;if((Q|0)<(T|0))T=Q;else break}if((U|0)==(N|0))ba=T;else{O=N;while(1){Q=f[n+(O<<2)>>2]|0;if((Q|0)<(O|0))O=Q;else break}Q=(T|0)>(O|0)?O:T;S=N;do{P=n+(S<<2)|0;$=S;S=f[P>>2]|0;f[P>>2]=Q}while((S|0)<($|0));ba=Q}Q=U;do{S=n+(Q<<2)|0;N=Q;Q=f[S>>2]|0;f[S>>2]=ba}while((Q|0)<(N|0));f[z+(E<<2)>>2]=ba;L=F;break a}while(0);f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break a}if(!(b[w+I>>0]|0))break;do if(B){if(b[x+G>>0]|0){Q=E+-2|0;do if((Q|0)>-1){if(!(b[v+Q>>0]|0))break;if(b[x+I>>0]|0){U=f[z+(Q<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}do if(D){if(!(b[y+E>>0]|0))break;f[z+(E<<2)>>2]=U;L=F;break a}while(0);N=f[t+(E<<2)>>2]|0;S=N;while(1){T=f[n+(S<<2)>>2]|0;if((T|0)<(S|0))S=T;else break}if((N|0)==(U|0))ca=S;else{T=U;while(1){O=f[n+(T<<2)>>2]|0;if((O|0)<(T|0))T=O;else break}O=(S|0)>(T|0)?T:S;$=U;do{P=n+($<<2)|0;M=$;$=f[P>>2]|0;f[P>>2]=O}while(($|0)<(M|0));ca=O}O=N;do{$=n+(O<<2)|0;U=O;O=f[$>>2]|0;f[$>>2]=ca}while((O|0)<(U|0));f[z+(E<<2)>>2]=ca;L=F;break a}if(!(b[x+Q>>0]|0)){O=f[t+(E<<2)>>2]|0;N=f[z+(Q<<2)>>2]|0;U=O;while(1){$=f[n+(U<<2)>>2]|0;if(($|0)<(U|0))U=$;else break}if((O|0)==(N|0))da=U;else{$=N;while(1){S=f[n+($<<2)>>2]|0;if((S|0)<($|0))$=S;else break}S=(U|0)>($|0)?$:U;T=N;do{M=n+(T<<2)|0;P=T;T=f[M>>2]|0;f[M>>2]=S}while((T|0)<(P|0));da=S}S=O;do{T=n+(S<<2)|0;N=S;S=f[T>>2]|0;f[T>>2]=da}while((S|0)<(N|0));f[z+(E<<2)>>2]=da;L=F;break a}do if(D){if(!(b[y+I>>0]|0))break;S=f[z+(Q<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=S;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=S;L=F;break a}O=f[t+(E<<2)>>2]|0;N=O;while(1){T=f[n+(N<<2)>>2]|0;if((T|0)<(N|0))N=T;else break}if((O|0)==(S|0))ea=N;else{T=S;while(1){U=f[n+(T<<2)>>2]|0;if((U|0)<(T|0))T=U;else break}U=(N|0)>(T|0)?T:N;$=S;do{P=n+($<<2)|0;M=$;$=f[P>>2]|0;f[P>>2]=U}while(($|0)<(M|0));ea=U}U=O;do{$=n+(U<<2)|0;S=U;U=f[$>>2]|0;f[$>>2]=ea}while((U|0)<(S|0));f[z+(E<<2)>>2]=ea;L=F;break a}while(0);U=f[t+(E<<2)>>2]|0;O=f[z+(Q<<2)>>2]|0;S=U;while(1){$=f[n+(S<<2)>>2]|0;if(($|0)<(S|0))S=$;else break}if((U|0)==(O|0))fa=S;else{$=O;while(1){N=f[n+($<<2)>>2]|0;if((N|0)<($|0))$=N;else break}N=(S|0)>($|0)?$:S;T=O;do{M=n+(T<<2)|0;P=T;T=f[M>>2]|0;f[M>>2]=N}while((T|0)<(P|0));fa=N}N=U;do{T=n+(N<<2)|0;O=N;N=f[T>>2]|0;f[T>>2]=fa}while((N|0)<(O|0));f[z+(E<<2)>>2]=fa;L=F;break a}while(0);N=f[t+(E<<2)>>2]|0;U=f[z+(Q<<2)>>2]|0;O=N;while(1){T=f[n+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}if((N|0)==(U|0))ga=O;else{Q=U;while(1){T=f[n+(Q<<2)>>2]|0;if((T|0)<(Q|0))Q=T;else break}T=(O|0)>(Q|0)?Q:O;S=U;do{$=n+(S<<2)|0;P=S;S=f[$>>2]|0;f[$>>2]=T}while((S|0)<(P|0));ga=T}T=N;do{S=n+(T<<2)|0;U=T;T=f[S>>2]|0;f[S>>2]=ga}while((T|0)<(U|0));f[z+(E<<2)>>2]=ga;L=F;break a}T=E+2|0;do if(!((T|0)>=(i|0)|C)){if(!(b[x+T>>0]|0))break;do if(D){if(!(b[y+G>>0]|0))break;N=E+-2|0;do if((N|0)>-1){if(!(b[v+N>>0]|0))break;if(b[x+I>>0]|0){U=f[z+(N<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}S=f[t+(T<<2)>>2]|0;O=S;while(1){Q=f[n+(O<<2)>>2]|0;if((Q|0)<(O|0))O=Q;else break}if((S|0)==(U|0))ha=O;else{Q=U;while(1){P=f[n+(Q<<2)>>2]|0;if((P|0)<(Q|0))Q=P;else break}P=(O|0)>(Q|0)?Q:O;$=U;do{M=n+($<<2)|0;V=$;$=f[M>>2]|0;f[M>>2]=P}while(($|0)<(V|0));ha=P}P=S;do{$=n+(P<<2)|0;U=P;P=f[$>>2]|0;f[$>>2]=ha}while((P|0)<(U|0));f[z+(E<<2)>>2]=ha;L=F;break a}if(!(b[x+N>>0]|0)){P=f[t+(T<<2)>>2]|0;S=f[z+(N<<2)>>2]|0;U=P;while(1){$=f[n+(U<<2)>>2]|0;if(($|0)<(U|0))U=$;else break}if((P|0)==(S|0))ia=U;else{$=S;while(1){O=f[n+($<<2)>>2]|0;if((O|0)<($|0))$=O;else break}O=(U|0)>($|0)?$:U;Q=S;do{V=n+(Q<<2)|0;M=Q;Q=f[V>>2]|0;f[V>>2]=O}while((Q|0)<(M|0));ia=O}O=P;do{Q=n+(O<<2)|0;S=O;O=f[Q>>2]|0;f[Q>>2]=ia}while((O|0)<(S|0));f[z+(E<<2)>>2]=ia;L=F;break a}if(!(b[y+I>>0]|0)){O=f[t+(T<<2)>>2]|0;P=f[z+(N<<2)>>2]|0;S=O;while(1){Q=f[n+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}if((O|0)==(P|0))ja=S;else{Q=P;while(1){U=f[n+(Q<<2)>>2]|0;if((U|0)<(Q|0))Q=U;else break}U=(S|0)>(Q|0)?Q:S;$=P;do{M=n+($<<2)|0;V=$;$=f[M>>2]|0;f[M>>2]=U}while(($|0)<(V|0));ja=U}U=O;do{$=n+(U<<2)|0;P=U;U=f[$>>2]|0;f[$>>2]=ja}while((U|0)<(P|0));f[z+(E<<2)>>2]=ja;L=F;break a}U=f[z+(N<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}O=f[t+(T<<2)>>2]|0;P=O;while(1){$=f[n+(P<<2)>>2]|0;if(($|0)<(P|0))P=$;else break}if((O|0)==(U|0))ka=P;else{$=U;while(1){S=f[n+($<<2)>>2]|0;if((S|0)<($|0))$=S;else break}S=(P|0)>($|0)?$:P;Q=U;do{V=n+(Q<<2)|0;M=Q;Q=f[V>>2]|0;f[V>>2]=S}while((Q|0)<(M|0));ka=S}S=O;do{Q=n+(S<<2)|0;U=S;S=f[Q>>2]|0;f[Q>>2]=ka}while((S|0)<(U|0));f[z+(E<<2)>>2]=ka;L=F;break a}while(0);S=f[t+(T<<2)>>2]|0;O=f[z+(N<<2)>>2]|0;U=S;while(1){Q=f[n+(U<<2)>>2]|0;if((Q|0)<(U|0))U=Q;else break}if((S|0)==(O|0))la=U;else{N=O;while(1){Q=f[n+(N<<2)>>2]|0;if((Q|0)<(N|0))N=Q;else break}Q=(U|0)>(N|0)?N:U;P=O;do{$=n+(P<<2)|0;M=P;P=f[$>>2]|0;f[$>>2]=Q}while((P|0)<(M|0));la=Q}Q=S;do{P=n+(Q<<2)|0;O=Q;Q=f[P>>2]|0;f[P>>2]=la}while((Q|0)<(O|0));f[z+(E<<2)>>2]=la;L=F;break a}while(0);Q=E+-2|0;if(!(b[x+E>>0]|0)){S=f[t+(T<<2)>>2]|0;O=f[z+(Q<<2)>>2]|0;P=S;while(1){U=f[n+(P<<2)>>2]|0;if((U|0)<(P|0))P=U;else break}if((S|0)==(O|0))ma=P;else{U=O;while(1){N=f[n+(U<<2)>>2]|0;if((N|0)<(U|0))U=N;else break}N=(P|0)>(U|0)?U:P;M=O;do{$=n+(M<<2)|0;V=M;M=f[$>>2]|0;f[$>>2]=N}while((M|0)<(V|0));ma=N}N=S;do{M=n+(N<<2)|0;O=N;N=f[M>>2]|0;f[M>>2]=ma}while((N|0)<(O|0));f[z+(E<<2)>>2]=ma;L=F;break a}do if((Q|0)>-1){if(!(b[v+Q>>0]|0))break;if(b[x+I>>0]|0){N=f[t+(T<<2)>>2]|0;S=f[z+(Q<<2)>>2]|0;O=N;while(1){M=f[n+(O<<2)>>2]|0;if((M|0)<(O|0))O=M;else break}if((N|0)==(S|0))na=O;else{M=S;while(1){P=f[n+(M<<2)>>2]|0;if((P|0)<(M|0))M=P;else break}P=(O|0)>(M|0)?M:O;U=S;do{V=n+(U<<2)|0;$=U;U=f[V>>2]|0;f[V>>2]=P}while((U|0)<($|0));na=P}P=N;do{U=n+(P<<2)|0;S=P;P=f[U>>2]|0;f[U>>2]=na}while((P|0)<(S|0));f[z+(E<<2)>>2]=na;L=F;break a}if(!(b[x+Q>>0]|0)){P=f[t+(E<<2)>>2]|0;N=f[t+(T<<2)>>2]|0;S=P;while(1){U=f[n+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}if((P|0)==(N|0))oa=S;else{U=N;while(1){O=f[n+(U<<2)>>2]|0;if((O|0)<(U|0))U=O;else break}O=(S|0)>(U|0)?U:S;M=N;do{$=n+(M<<2)|0;V=M;M=f[$>>2]|0;f[$>>2]=O}while((M|0)<(V|0));oa=O}O=P;do{M=n+(O<<2)|0;N=O;O=f[M>>2]|0;f[M>>2]=oa}while((O|0)<(N|0));O=f[z+(Q<<2)>>2]|0;P=oa;while(1){N=f[n+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}if((oa|0)==(O|0))pa=P;else{N=O;while(1){M=f[n+(N<<2)>>2]|0;if((M|0)<(N|0))N=M;else break}M=(P|0)>(N|0)?N:P;S=O;do{U=n+(S<<2)|0;V=S;S=f[U>>2]|0;f[U>>2]=M}while((S|0)<(V|0));pa=M}M=oa;do{S=n+(M<<2)|0;O=M;M=f[S>>2]|0;f[S>>2]=pa}while((M|0)<(O|0));f[z+(E<<2)>>2]=pa;L=F;break a}do if(D){if(!(b[y+I>>0]|0))break;M=f[t+(T<<2)>>2]|0;O=f[z+(Q<<2)>>2]|0;S=M;while(1){P=f[n+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}if((M|0)==(O|0))qa=S;else{P=O;while(1){N=f[n+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}N=(S|0)>(P|0)?P:S;V=O;do{U=n+(V<<2)|0;$=V;V=f[U>>2]|0;f[U>>2]=N}while((V|0)<($|0));qa=N}N=M;do{V=n+(N<<2)|0;O=N;N=f[V>>2]|0;f[V>>2]=qa}while((N|0)<(O|0));f[z+(E<<2)>>2]=qa;L=F;break a}while(0);N=f[t+(E<<2)>>2]|0;M=f[t+(T<<2)>>2]|0;O=N;while(1){V=f[n+(O<<2)>>2]|0;if((V|0)<(O|0))O=V;else break}if((N|0)==(M|0))ra=O;else{V=M;while(1){S=f[n+(V<<2)>>2]|0;if((S|0)<(V|0))V=S;else break}S=(O|0)>(V|0)?V:O;P=M;do{$=n+(P<<2)|0;U=P;P=f[$>>2]|0;f[$>>2]=S}while((P|0)<(U|0));ra=S}S=N;do{P=n+(S<<2)|0;M=S;S=f[P>>2]|0;f[P>>2]=ra}while((S|0)<(M|0));S=f[z+(Q<<2)>>2]|0;N=ra;while(1){M=f[n+(N<<2)>>2]|0;if((M|0)<(N|0))N=M;else break}if((ra|0)==(S|0))sa=N;else{M=S;while(1){P=f[n+(M<<2)>>2]|0;if((P|0)<(M|0))M=P;else break}P=(N|0)>(M|0)?M:N;O=S;do{V=n+(O<<2)|0;U=O;O=f[V>>2]|0;f[V>>2]=P}while((O|0)<(U|0));sa=P}P=ra;do{O=n+(P<<2)|0;S=P;P=f[O>>2]|0;f[O>>2]=sa}while((P|0)<(S|0));f[z+(E<<2)>>2]=sa;L=F;break a}while(0);P=f[t+(E<<2)>>2]|0;S=f[t+(T<<2)>>2]|0;O=P;while(1){N=f[n+(O<<2)>>2]|0;if((N|0)<(O|0))O=N;else break}if((P|0)==(S|0))ta=O;else{N=S;while(1){M=f[n+(N<<2)>>2]|0;if((M|0)<(N|0))N=M;else break}M=(O|0)>(N|0)?N:O;U=S;do{V=n+(U<<2)|0;$=U;U=f[V>>2]|0;f[V>>2]=M}while((U|0)<($|0));ta=M}M=P;do{U=n+(M<<2)|0;S=M;M=f[U>>2]|0;f[U>>2]=ta}while((M|0)<(S|0));M=f[z+(Q<<2)>>2]|0;P=ta;while(1){S=f[n+(P<<2)>>2]|0;if((S|0)<(P|0))P=S;else break}if((ta|0)==(M|0))ua=P;else{Q=M;while(1){S=f[n+(Q<<2)>>2]|0;if((S|0)<(Q|0))Q=S;else break}S=(P|0)>(Q|0)?Q:P;U=M;do{O=n+(U<<2)|0;N=U;U=f[O>>2]|0;f[O>>2]=S}while((U|0)<(N|0));ua=S}S=ta;do{U=n+(S<<2)|0;M=S;S=f[U>>2]|0;f[U>>2]=ua}while((S|0)<(M|0));f[z+(E<<2)>>2]=ua;L=F;break a}while(0);T=E+-2|0;if(!(b[x+E>>0]|0)){va=T;break}do if((T|0)>-1){if(!(b[v+T>>0]|0))break;if(b[x+I>>0]|0){f[z+(E<<2)>>2]=f[z+(T<<2)>>2];L=F;break a}if(!(b[x+T>>0]|0)){S=f[t+(E<<2)>>2]|0;M=f[z+(T<<2)>>2]|0;U=S;while(1){P=f[n+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}if((S|0)==(M|0))wa=U;else{P=M;while(1){Q=f[n+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}Q=(U|0)>(P|0)?P:U;N=M;do{O=n+(N<<2)|0;$=N;N=f[O>>2]|0;f[O>>2]=Q}while((N|0)<($|0));wa=Q}Q=S;do{N=n+(Q<<2)|0;M=Q;Q=f[N>>2]|0;f[N>>2]=wa}while((Q|0)<(M|0));f[z+(E<<2)>>2]=wa;L=F;break a}do if(D){if(!(b[y+I>>0]|0))break;f[z+(E<<2)>>2]=f[z+(T<<2)>>2];L=F;break a}while(0);Q=f[t+(E<<2)>>2]|0;S=f[z+(T<<2)>>2]|0;M=Q;while(1){N=f[n+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}if((Q|0)==(S|0))xa=M;else{N=S;while(1){U=f[n+(N<<2)>>2]|0;if((U|0)<(N|0))N=U;else break}U=(M|0)>(N|0)?N:M;P=S;do{$=n+(P<<2)|0;O=P;P=f[$>>2]|0;f[$>>2]=U}while((P|0)<(O|0));xa=U}U=Q;do{P=n+(U<<2)|0;S=U;U=f[P>>2]|0;f[P>>2]=xa}while((U|0)<(S|0));f[z+(E<<2)>>2]=xa;L=F;break a}while(0);U=f[t+(E<<2)>>2]|0;Q=f[z+(T<<2)>>2]|0;S=U;while(1){P=f[n+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}if((U|0)==(Q|0))ya=S;else{T=Q;while(1){P=f[n+(T<<2)>>2]|0;if((P|0)<(T|0))T=P;else break}P=(S|0)>(T|0)?T:S;M=Q;do{N=n+(M<<2)|0;O=M;M=f[N>>2]|0;f[N>>2]=P}while((M|0)<(O|0));ya=P}P=U;do{M=n+(P<<2)|0;Q=P;P=f[M>>2]|0;f[M>>2]=ya}while((P|0)<(Q|0));f[z+(E<<2)>>2]=ya;L=F;break a}else va=E+-2|0;while(0);f[z+(E<<2)>>2]=f[z+(va<<2)>>2];L=F;break a}while(0);do if(B){if(b[x+G>>0]|0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break a}P=E+2|0;do if(!((P|0)>=(i|0)|C)){if(!(b[x+P>>0]|0))break;if(!(b[x+E>>0]|0)){f[z+(E<<2)>>2]=f[t+(P<<2)>>2];L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;f[z+(E<<2)>>2]=f[t+(P<<2)>>2];L=F;break a}while(0);U=f[t+(E<<2)>>2]|0;Q=f[t+(P<<2)>>2]|0;M=U;while(1){S=f[n+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}if((U|0)==(Q|0))za=M;else{S=Q;while(1){T=f[n+(S<<2)>>2]|0;if((T|0)<(S|0))S=T;else break}T=(M|0)>(S|0)?S:M;O=Q;do{N=n+(O<<2)|0;$=O;O=f[N>>2]|0;f[N>>2]=T}while((O|0)<($|0));za=T}T=U;do{O=n+(T<<2)|0;Q=T;T=f[O>>2]|0;f[O>>2]=za}while((T|0)<(Q|0));f[z+(E<<2)>>2]=za;L=F;break a}while(0);if(!(b[x+E>>0]|0))break;f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break a}while(0);f[z+(E<<2)>>2]=F;f[n+(F<<2)>>2]=F;L=F+1|0;break}if(K){if(b[w+I>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break}if(b[v+I>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break}}f[z+(E<<2)>>2]=F;f[n+(F<<2)>>2]=F;L=F+1|0;break}do if(H){if(!(b[v+G>>0]|0)){if(!A)break;if(!(b[w+G>>0]|0))break;f[z+(E<<2)>>2]=F;f[n+(F<<2)>>2]=F;L=F+1|0;break a}if(B){if(b[x+G>>0]|0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break a}P=E+2|0;do if(!((P|0)>=(i|0)|C)){if(!(b[x+P>>0]|0))break;if(!(b[x+E>>0]|0)){f[z+(E<<2)>>2]=f[t+(P<<2)>>2];L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;f[z+(E<<2)>>2]=f[t+(P<<2)>>2];L=F;break a}while(0);T=f[t+(E<<2)>>2]|0;U=f[t+(P<<2)>>2]|0;Q=T;while(1){O=f[n+(Q<<2)>>2]|0;if((O|0)<(Q|0))Q=O;else break}if((T|0)==(U|0))Aa=Q;else{O=U;while(1){M=f[n+(O<<2)>>2]|0;if((M|0)<(O|0))O=M;else break}M=(Q|0)>(O|0)?O:Q;S=U;do{$=n+(S<<2)|0;N=S;S=f[$>>2]|0;f[$>>2]=M}while((S|0)<(N|0));Aa=M}M=T;do{S=n+(M<<2)|0;U=M;M=f[S>>2]|0;f[S>>2]=Aa}while((M|0)<(U|0));f[z+(E<<2)>>2]=Aa;L=F;break a}while(0);if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break a}}f[z+(E<<2)>>2]=F;f[n+(F<<2)>>2]=F;L=F+1|0;break a}while(0);f[z+(E<<2)>>2]=0;L=F}else{G=E+-1|0;H=(E|0)>0;if(H){if(b[v+G>>0]|0){I=E|1;K=(I|0)<(i|0);if(B&K?b[x+I>>0]|0:0){if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break}do if(D){if(!(b[y+E>>0]|0))break;P=E+-2|0;if(b[x+G>>0]|0){f[z+(E<<2)>>2]=f[z+(P<<2)>>2];L=F;break a}do if((P|0)>-1){if(!(b[x+P>>0]|0))break;if(b[y+G>>0]|0){f[z+(E<<2)>>2]=f[z+(P<<2)>>2];L=F;break a}M=f[t+(E<<2)>>2]|0;T=f[z+(P<<2)>>2]|0;U=M;while(1){S=f[n+(U<<2)>>2]|0;if((S|0)<(U|0))U=S;else break}if((M|0)==(T|0))Ba=U;else{S=T;while(1){Q=f[n+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}Q=(U|0)>(S|0)?S:U;O=T;do{N=n+(O<<2)|0;$=O;O=f[N>>2]|0;f[N>>2]=Q}while((O|0)<($|0));Ba=Q}Q=M;do{O=n+(Q<<2)|0;T=Q;Q=f[O>>2]|0;f[O>>2]=Ba}while((Q|0)<(T|0));f[z+(E<<2)>>2]=Ba;L=F;break a}while(0);Q=f[t+(E<<2)>>2]|0;M=f[z+(P<<2)>>2]|0;T=Q;while(1){O=f[n+(T<<2)>>2]|0;if((O|0)<(T|0))T=O;else break}if((Q|0)==(M|0))Ca=T;else{P=M;while(1){O=f[n+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}O=(T|0)>(P|0)?P:T;U=M;do{S=n+(U<<2)|0;$=U;U=f[S>>2]|0;f[S>>2]=O}while((U|0)<($|0));Ca=O}O=Q;do{U=n+(O<<2)|0;M=O;O=f[U>>2]|0;f[U>>2]=Ca}while((O|0)<(M|0));f[z+(E<<2)>>2]=Ca;L=F;break a}while(0);O=f[t+(E<<2)>>2]|0;Q=f[z+(E+-2<<2)>>2]|0;M=O;while(1){U=f[n+(M<<2)>>2]|0;if((U|0)<(M|0))M=U;else break}if((O|0)==(Q|0))Da=M;else{U=Q;while(1){T=f[n+(U<<2)>>2]|0;if((T|0)<(U|0))U=T;else break}T=(M|0)>(U|0)?U:M;P=Q;do{$=n+(P<<2)|0;S=P;P=f[$>>2]|0;f[$>>2]=T}while((P|0)<(S|0));Da=T}T=O;do{P=n+(T<<2)|0;Q=T;T=f[P>>2]|0;f[P>>2]=Da}while((T|0)<(Q|0));f[z+(E<<2)>>2]=Da;L=F;break}if(K?b[v+I>>0]|0:0){T=E+2|0;do if(B&(T|0)<(i|0)){if(!(b[x+T>>0]|0))break;do if(D){if(!(b[y+I>>0]|0))break;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break a}if(!(b[y+E>>0]|0)){O=f[t+(T<<2)>>2]|0;Q=f[z+(E+-2<<2)>>2]|0;P=O;while(1){M=f[n+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}if((O|0)==(Q|0))Ea=P;else{M=Q;while(1){U=f[n+(M<<2)>>2]|0;if((U|0)<(M|0))M=U;else break}U=(P|0)>(M|0)?M:P;S=Q;do{$=n+(S<<2)|0;N=S;S=f[$>>2]|0;f[$>>2]=U}while((S|0)<(N|0));Ea=U}U=O;do{S=n+(U<<2)|0;Q=U;U=f[S>>2]|0;f[S>>2]=Ea}while((U|0)<(Q|0));f[z+(E<<2)>>2]=Ea;L=F;break a}U=E+-2|0;if(b[x+G>>0]|0){f[z+(E<<2)>>2]=f[z+(U<<2)>>2];L=F;break a}do if((U|0)>-1){if(!(b[x+U>>0]|0))break;if(b[y+G>>0]|0){f[z+(E<<2)>>2]=f[z+(U<<2)>>2];L=F;break a}O=f[t+(T<<2)>>2]|0;Q=f[z+(U<<2)>>2]|0;S=O;while(1){P=f[n+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}if((O|0)==(Q|0))Fa=S;else{P=Q;while(1){M=f[n+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}M=(S|0)>(P|0)?P:S;N=Q;do{$=n+(N<<2)|0;V=N;N=f[$>>2]|0;f[$>>2]=M}while((N|0)<(V|0));Fa=M}M=O;do{N=n+(M<<2)|0;Q=M;M=f[N>>2]|0;f[N>>2]=Fa}while((M|0)<(Q|0));f[z+(E<<2)>>2]=Fa;L=F;break a}while(0);M=f[t+(T<<2)>>2]|0;O=f[z+(U<<2)>>2]|0;Q=M;while(1){N=f[n+(Q<<2)>>2]|0;if((N|0)<(Q|0))Q=N;else break}if((M|0)==(O|0))Ga=Q;else{U=O;while(1){N=f[n+(U<<2)>>2]|0;if((N|0)<(U|0))U=N;else break}N=(Q|0)>(U|0)?U:Q;S=O;do{P=n+(S<<2)|0;V=S;S=f[P>>2]|0;f[P>>2]=N}while((S|0)<(V|0));Ga=N}N=M;do{S=n+(N<<2)|0;O=N;N=f[S>>2]|0;f[S>>2]=Ga}while((N|0)<(O|0));f[z+(E<<2)>>2]=Ga;L=F;break a}while(0);N=f[t+(T<<2)>>2]|0;M=f[z+(E+-2<<2)>>2]|0;O=N;while(1){S=f[n+(O<<2)>>2]|0;if((S|0)<(O|0))O=S;else break}if((N|0)==(M|0))Ha=O;else{S=M;while(1){Q=f[n+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}Q=(O|0)>(S|0)?S:O;U=M;do{V=n+(U<<2)|0;P=U;U=f[V>>2]|0;f[V>>2]=Q}while((U|0)<(P|0));Ha=Q}Q=N;do{U=n+(Q<<2)|0;M=Q;Q=f[U>>2]|0;f[U>>2]=Ha}while((Q|0)<(M|0));f[z+(E<<2)>>2]=Ha;L=F;break a}while(0);f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break}f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break}if(A?b[w+G>>0]|0:0){T=E|1;I=(T|0)<(i|0);if(!(C|I^1)?b[x+T>>0]|0:0){K=E+-2|0;do if((K|0)>-1){if(!(b[v+K>>0]|0))break;if(b[x+G>>0]|0){Q=f[z+(K<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=Q;L=F;break a}do if(D){if(!(b[y+E>>0]|0))break;f[z+(E<<2)>>2]=Q;L=F;break a}while(0);N=f[t+(E<<2)>>2]|0;M=N;while(1){U=f[n+(M<<2)>>2]|0;if((U|0)<(M|0))M=U;else break}if((N|0)==(Q|0))Ia=M;else{U=Q;while(1){O=f[n+(U<<2)>>2]|0;if((O|0)<(U|0))U=O;else break}O=(M|0)>(U|0)?U:M;S=Q;do{P=n+(S<<2)|0;V=S;S=f[P>>2]|0;f[P>>2]=O}while((S|0)<(V|0));Ia=O}O=N;do{S=n+(O<<2)|0;Q=O;O=f[S>>2]|0;f[S>>2]=Ia}while((O|0)<(Q|0));f[z+(E<<2)>>2]=Ia;L=F;break a}if(!(b[x+K>>0]|0)){O=f[t+(E<<2)>>2]|0;N=f[z+(K<<2)>>2]|0;Q=O;while(1){S=f[n+(Q<<2)>>2]|0;if((S|0)<(Q|0))Q=S;else break}if((O|0)==(N|0))Ja=Q;else{S=N;while(1){M=f[n+(S<<2)>>2]|0;if((M|0)<(S|0))S=M;else break}M=(Q|0)>(S|0)?S:Q;U=N;do{V=n+(U<<2)|0;P=U;U=f[V>>2]|0;f[V>>2]=M}while((U|0)<(P|0));Ja=M}M=O;do{U=n+(M<<2)|0;N=M;M=f[U>>2]|0;f[U>>2]=Ja}while((M|0)<(N|0));f[z+(E<<2)>>2]=Ja;L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;M=f[z+(K<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=M;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=M;L=F;break a}O=f[t+(E<<2)>>2]|0;N=O;while(1){U=f[n+(N<<2)>>2]|0;if((U|0)<(N|0))N=U;else break}if((O|0)==(M|0))Ka=N;else{U=M;while(1){Q=f[n+(U<<2)>>2]|0;if((Q|0)<(U|0))U=Q;else break}Q=(N|0)>(U|0)?U:N;S=M;do{P=n+(S<<2)|0;V=S;S=f[P>>2]|0;f[P>>2]=Q}while((S|0)<(V|0));Ka=Q}Q=O;do{S=n+(Q<<2)|0;M=Q;Q=f[S>>2]|0;f[S>>2]=Ka}while((Q|0)<(M|0));f[z+(E<<2)>>2]=Ka;L=F;break a}while(0);Q=f[t+(E<<2)>>2]|0;O=f[z+(K<<2)>>2]|0;M=Q;while(1){S=f[n+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}if((Q|0)==(O|0))La=M;else{S=O;while(1){N=f[n+(S<<2)>>2]|0;if((N|0)<(S|0))S=N;else break}N=(M|0)>(S|0)?S:M;U=O;do{V=n+(U<<2)|0;P=U;U=f[V>>2]|0;f[V>>2]=N}while((U|0)<(P|0));La=N}N=Q;do{U=n+(N<<2)|0;O=N;N=f[U>>2]|0;f[U>>2]=La}while((N|0)<(O|0));f[z+(E<<2)>>2]=La;L=F;break a}while(0);if(b[x+E>>0]|0){N=f[t+(E<<2)>>2]|0;Q=f[z+(K<<2)>>2]|0;O=N;while(1){U=f[n+(O<<2)>>2]|0;if((U|0)<(O|0))O=U;else break}if((N|0)==(Q|0))Ma=O;else{U=Q;while(1){M=f[n+(U<<2)>>2]|0;if((M|0)<(U|0))U=M;else break}M=(O|0)>(U|0)?U:O;S=Q;do{P=n+(S<<2)|0;V=S;S=f[P>>2]|0;f[P>>2]=M}while((S|0)<(V|0));Ma=M}M=N;do{S=n+(M<<2)|0;Q=M;M=f[S>>2]|0;f[S>>2]=Ma}while((M|0)<(Q|0));f[z+(E<<2)>>2]=Ma;L=F;break}M=f[t+(E<<2)>>2]|0;if(!(b[x+G>>0]|0)){N=f[z+(K<<2)>>2]|0;Q=M;while(1){S=f[n+(Q<<2)>>2]|0;if((S|0)<(Q|0))Q=S;else break}if((M|0)==(N|0))Na=Q;else{S=N;while(1){O=f[n+(S<<2)>>2]|0;if((O|0)<(S|0))S=O;else break}O=(Q|0)>(S|0)?S:Q;U=N;do{V=n+(U<<2)|0;P=U;U=f[V>>2]|0;f[V>>2]=O}while((U|0)<(P|0));Na=O}O=M;do{U=n+(O<<2)|0;N=O;O=f[U>>2]|0;f[U>>2]=Na}while((O|0)<(N|0));f[z+(E<<2)>>2]=Na;L=F;break}do if(D){if(!(b[y+E>>0]|0))break;O=f[z+(K<<2)>>2]|0;N=M;while(1){U=f[n+(N<<2)>>2]|0;if((U|0)<(N|0))N=U;else break}if((M|0)==(O|0))Oa=N;else{U=O;while(1){Q=f[n+(U<<2)>>2]|0;if((Q|0)<(U|0))U=Q;else break}Q=(N|0)>(U|0)?U:N;S=O;do{P=n+(S<<2)|0;V=S;S=f[P>>2]|0;f[P>>2]=Q}while((S|0)<(V|0));Oa=Q}Q=M;do{S=n+(Q<<2)|0;O=Q;Q=f[S>>2]|0;f[S>>2]=Oa}while((Q|0)<(O|0));f[z+(E<<2)>>2]=Oa;L=F;break a}while(0);Q=f[t+(K<<2)>>2]|0;O=Q;while(1){S=f[n+(O<<2)>>2]|0;if((S|0)<(O|0))O=S;else break}if((Q|0)==(M|0))Pa=O;else{S=M;while(1){N=f[n+(S<<2)>>2]|0;if((N|0)<(S|0))S=N;else break}N=(O|0)>(S|0)?S:O;U=M;do{V=n+(U<<2)|0;P=U;U=f[V>>2]|0;f[V>>2]=N}while((U|0)<(P|0));Pa=N}N=Q;do{U=n+(N<<2)|0;M=N;N=f[U>>2]|0;f[U>>2]=Pa}while((N|0)<(M|0));N=f[z+(K<<2)>>2]|0;Q=Pa;while(1){M=f[n+(Q<<2)>>2]|0;if((M|0)<(Q|0))Q=M;else break}if((Pa|0)==(N|0))Qa=Q;else{K=N;while(1){M=f[n+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}M=(Q|0)>(K|0)?K:Q;U=N;do{O=n+(U<<2)|0;S=U;U=f[O>>2]|0;f[O>>2]=M}while((U|0)<(S|0));Qa=M}M=Pa;do{U=n+(M<<2)|0;N=M;M=f[U>>2]|0;f[U>>2]=Qa}while((M|0)<(N|0));f[z+(E<<2)>>2]=Qa;L=F;break}if(I?b[v+T>>0]|0:0){M=E+2|0;do if(!((M|0)>=(i|0)|C)){if(!(b[x+M>>0]|0))break;N=E+-2|0;do if((N|0)>-1){if(!(b[v+N>>0]|0))break;if(b[x+G>>0]|0){do if(D){if(!(b[y+T>>0]|0))break;U=f[z+(N<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}Q=f[t+(M<<2)>>2]|0;K=Q;while(1){S=f[n+(K<<2)>>2]|0;if((S|0)<(K|0))K=S;else break}if((Q|0)==(U|0))Ra=K;else{S=U;while(1){O=f[n+(S<<2)>>2]|0;if((O|0)<(S|0))S=O;else break}O=(K|0)>(S|0)?S:K;P=U;do{V=n+(P<<2)|0;$=P;P=f[V>>2]|0;f[V>>2]=O}while((P|0)<($|0));Ra=O}O=Q;do{P=n+(O<<2)|0;U=O;O=f[P>>2]|0;f[P>>2]=Ra}while((O|0)<(U|0));f[z+(E<<2)>>2]=Ra;L=F;break a}while(0);O=f[t+(M<<2)>>2]|0;Q=f[z+(N<<2)>>2]|0;U=O;while(1){P=f[n+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}if((O|0)==(Q|0))Sa=U;else{P=Q;while(1){K=f[n+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(U|0)>(P|0)?P:U;S=Q;do{$=n+(S<<2)|0;V=S;S=f[$>>2]|0;f[$>>2]=K}while((S|0)<(V|0));Sa=K}K=O;do{S=n+(K<<2)|0;Q=K;K=f[S>>2]|0;f[S>>2]=Sa}while((K|0)<(Q|0));f[z+(E<<2)>>2]=Sa;L=F;break a}do if(D){if(!(b[y+T>>0]|0))break;if(!(b[x+N>>0]|0)){K=f[t+(M<<2)>>2]|0;O=f[z+(N<<2)>>2]|0;Q=K;while(1){S=f[n+(Q<<2)>>2]|0;if((S|0)<(Q|0))Q=S;else break}if((K|0)==(O|0))Ta=Q;else{S=O;while(1){U=f[n+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}U=(Q|0)>(S|0)?S:Q;P=O;do{V=n+(P<<2)|0;$=P;P=f[V>>2]|0;f[V>>2]=U}while((P|0)<($|0));Ta=U}U=K;do{P=n+(U<<2)|0;O=U;U=f[P>>2]|0;f[P>>2]=Ta}while((U|0)<(O|0));f[z+(E<<2)>>2]=Ta;L=F;break a}if(!(b[y+G>>0]|0)){U=f[t+(M<<2)>>2]|0;K=f[z+(N<<2)>>2]|0;O=U;while(1){P=f[n+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}if((U|0)==(K|0))Ua=O;else{P=K;while(1){Q=f[n+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}Q=(O|0)>(P|0)?P:O;S=K;do{$=n+(S<<2)|0;V=S;S=f[$>>2]|0;f[$>>2]=Q}while((S|0)<(V|0));Ua=Q}Q=U;do{S=n+(Q<<2)|0;K=Q;Q=f[S>>2]|0;f[S>>2]=Ua}while((Q|0)<(K|0));f[z+(E<<2)>>2]=Ua;L=F;break a}Q=f[z+(N<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=Q;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=Q;L=F;break a}U=f[t+(M<<2)>>2]|0;K=U;while(1){S=f[n+(K<<2)>>2]|0;if((S|0)<(K|0))K=S;else break}if((U|0)==(Q|0))Va=K;else{S=Q;while(1){O=f[n+(S<<2)>>2]|0;if((O|0)<(S|0))S=O;else break}O=(K|0)>(S|0)?S:K;P=Q;do{V=n+(P<<2)|0;$=P;P=f[V>>2]|0;f[V>>2]=O}while((P|0)<($|0));Va=O}O=U;do{P=n+(O<<2)|0;Q=O;O=f[P>>2]|0;f[P>>2]=Va}while((O|0)<(Q|0));f[z+(E<<2)>>2]=Va;L=F;break a}while(0);if(!(b[x+E>>0]|0)){O=f[t+(M<<2)>>2]|0;U=f[z+(N<<2)>>2]|0;Q=O;while(1){P=f[n+(Q<<2)>>2]|0;if((P|0)<(Q|0))Q=P;else break}if((O|0)==(U|0))Wa=Q;else{P=U;while(1){K=f[n+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(Q|0)>(P|0)?P:Q;S=U;do{$=n+(S<<2)|0;V=S;S=f[$>>2]|0;f[$>>2]=K}while((S|0)<(V|0));Wa=K}K=O;do{S=n+(K<<2)|0;U=K;K=f[S>>2]|0;f[S>>2]=Wa}while((K|0)<(U|0));f[z+(E<<2)>>2]=Wa;L=F;break a}if(!(b[x+N>>0]|0)){K=f[t+(E<<2)>>2]|0;O=f[t+(M<<2)>>2]|0;U=K;while(1){S=f[n+(U<<2)>>2]|0;if((S|0)<(U|0))U=S;else break}if((K|0)==(O|0))Xa=U;else{S=O;while(1){Q=f[n+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}Q=(U|0)>(S|0)?S:U;P=O;do{V=n+(P<<2)|0;$=P;P=f[V>>2]|0;f[V>>2]=Q}while((P|0)<($|0));Xa=Q}Q=K;do{P=n+(Q<<2)|0;O=Q;Q=f[P>>2]|0;f[P>>2]=Xa}while((Q|0)<(O|0));Q=f[z+(N<<2)>>2]|0;K=Xa;while(1){O=f[n+(K<<2)>>2]|0;if((O|0)<(K|0))K=O;else break}if((Xa|0)==(Q|0))Ya=K;else{O=Q;while(1){P=f[n+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}P=(K|0)>(O|0)?O:K;U=Q;do{S=n+(U<<2)|0;$=U;U=f[S>>2]|0;f[S>>2]=P}while((U|0)<($|0));Ya=P}P=Xa;do{U=n+(P<<2)|0;Q=P;P=f[U>>2]|0;f[U>>2]=Ya}while((P|0)<(Q|0));f[z+(E<<2)>>2]=Ya;L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;P=f[t+(M<<2)>>2]|0;Q=f[z+(N<<2)>>2]|0;U=P;while(1){K=f[n+(U<<2)>>2]|0;if((K|0)<(U|0))U=K;else break}if((P|0)==(Q|0))Za=U;else{K=Q;while(1){O=f[n+(K<<2)>>2]|0;if((O|0)<(K|0))K=O;else break}O=(U|0)>(K|0)?K:U;$=Q;do{S=n+($<<2)|0;V=$;$=f[S>>2]|0;f[S>>2]=O}while(($|0)<(V|0));Za=O}O=P;do{$=n+(O<<2)|0;Q=O;O=f[$>>2]|0;f[$>>2]=Za}while((O|0)<(Q|0));f[z+(E<<2)>>2]=Za;L=F;break a}while(0);O=f[t+(E<<2)>>2]|0;P=f[t+(M<<2)>>2]|0;Q=O;while(1){$=f[n+(Q<<2)>>2]|0;if(($|0)<(Q|0))Q=$;else break}if((O|0)==(P|0))_a=Q;else{$=P;while(1){U=f[n+($<<2)>>2]|0;if((U|0)<($|0))$=U;else break}U=(Q|0)>($|0)?$:Q;K=P;do{V=n+(K<<2)|0;S=K;K=f[V>>2]|0;f[V>>2]=U}while((K|0)<(S|0));_a=U}U=O;do{K=n+(U<<2)|0;P=U;U=f[K>>2]|0;f[K>>2]=_a}while((U|0)<(P|0));U=f[z+(N<<2)>>2]|0;O=_a;while(1){P=f[n+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}if((_a|0)==(U|0))$a=O;else{P=U;while(1){K=f[n+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(O|0)>(P|0)?P:O;Q=U;do{$=n+(Q<<2)|0;S=Q;Q=f[$>>2]|0;f[$>>2]=K}while((Q|0)<(S|0));$a=K}K=_a;do{Q=n+(K<<2)|0;U=K;K=f[Q>>2]|0;f[Q>>2]=$a}while((K|0)<(U|0));f[z+(E<<2)>>2]=$a;L=F;break a}while(0);if(b[x+E>>0]|0){do if(D){if(!(b[y+T>>0]|0))break;K=f[t+(M<<2)>>2]|0;U=f[z+(N<<2)>>2]|0;Q=K;while(1){O=f[n+(Q<<2)>>2]|0;if((O|0)<(Q|0))Q=O;else break}if((K|0)==(U|0))ab=Q;else{O=U;while(1){P=f[n+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}P=(Q|0)>(O|0)?O:Q;S=U;do{$=n+(S<<2)|0;V=S;S=f[$>>2]|0;f[$>>2]=P}while((S|0)<(V|0));ab=P}P=K;do{S=n+(P<<2)|0;U=P;P=f[S>>2]|0;f[S>>2]=ab}while((P|0)<(U|0));f[z+(E<<2)>>2]=ab;L=F;break a}while(0);P=f[t+(E<<2)>>2]|0;K=f[t+(M<<2)>>2]|0;U=P;while(1){S=f[n+(U<<2)>>2]|0;if((S|0)<(U|0))U=S;else break}if((P|0)==(K|0))bb=U;else{S=K;while(1){Q=f[n+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}Q=(U|0)>(S|0)?S:U;O=K;do{V=n+(O<<2)|0;$=O;O=f[V>>2]|0;f[V>>2]=Q}while((O|0)<($|0));bb=Q}Q=P;do{O=n+(Q<<2)|0;K=Q;Q=f[O>>2]|0;f[O>>2]=bb}while((Q|0)<(K|0));Q=f[z+(N<<2)>>2]|0;P=bb;while(1){K=f[n+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}if((bb|0)==(Q|0))cb=P;else{K=Q;while(1){O=f[n+(K<<2)>>2]|0;if((O|0)<(K|0))K=O;else break}O=(P|0)>(K|0)?K:P;U=Q;do{S=n+(U<<2)|0;$=U;U=f[S>>2]|0;f[S>>2]=O}while((U|0)<($|0));cb=O}O=bb;do{U=n+(O<<2)|0;Q=O;O=f[U>>2]|0;f[U>>2]=cb}while((O|0)<(Q|0));f[z+(E<<2)>>2]=cb;L=F;break a}if(!(b[x+G>>0]|0)){O=f[t+(M<<2)>>2]|0;Q=f[z+(N<<2)>>2]|0;U=O;while(1){P=f[n+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}if((O|0)==(Q|0))db=U;else{P=Q;while(1){K=f[n+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(U|0)>(P|0)?P:U;$=Q;do{S=n+($<<2)|0;V=$;$=f[S>>2]|0;f[S>>2]=K}while(($|0)<(V|0));db=K}K=O;do{$=n+(K<<2)|0;Q=K;K=f[$>>2]|0;f[$>>2]=db}while((K|0)<(Q|0));f[z+(E<<2)>>2]=db;L=F;break a}do if(D){if(!(b[y+T>>0]|0))break;K=f[t+(M<<2)>>2]|0;if(b[y+E>>0]|0){O=f[z+(N<<2)>>2]|0;Q=K;while(1){$=f[n+(Q<<2)>>2]|0;if(($|0)<(Q|0))Q=$;else break}if((K|0)==(O|0))eb=Q;else{$=O;while(1){U=f[n+($<<2)>>2]|0;if((U|0)<($|0))$=U;else break}U=(Q|0)>($|0)?$:Q;P=O;do{V=n+(P<<2)|0;S=P;P=f[V>>2]|0;f[V>>2]=U}while((P|0)<(S|0));eb=U}U=K;do{P=n+(U<<2)|0;O=U;U=f[P>>2]|0;f[P>>2]=eb}while((U|0)<(O|0));f[z+(E<<2)>>2]=eb;L=F;break a}U=f[t+(N<<2)>>2]|0;O=U;while(1){P=f[n+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}if((U|0)==(K|0))fb=O;else{P=K;while(1){Q=f[n+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}Q=(O|0)>(P|0)?P:O;$=K;do{S=n+($<<2)|0;V=$;$=f[S>>2]|0;f[S>>2]=Q}while(($|0)<(V|0));fb=Q}Q=U;do{$=n+(Q<<2)|0;K=Q;Q=f[$>>2]|0;f[$>>2]=fb}while((Q|0)<(K|0));Q=f[z+(N<<2)>>2]|0;U=fb;while(1){K=f[n+(U<<2)>>2]|0;if((K|0)<(U|0))U=K;else break}if((fb|0)==(Q|0))gb=U;else{K=Q;while(1){$=f[n+(K<<2)>>2]|0;if(($|0)<(K|0))K=$;else break}$=(U|0)>(K|0)?K:U;O=Q;do{P=n+(O<<2)|0;V=O;O=f[P>>2]|0;f[P>>2]=$}while((O|0)<(V|0));gb=$}$=fb;do{O=n+($<<2)|0;Q=$;$=f[O>>2]|0;f[O>>2]=gb}while(($|0)<(Q|0));f[z+(E<<2)>>2]=gb;L=F;break a}while(0);$=f[t+(N<<2)>>2]|0;Q=f[t+(M<<2)>>2]|0;O=$;while(1){U=f[n+(O<<2)>>2]|0;if((U|0)<(O|0))O=U;else break}if(($|0)==(Q|0))hb=O;else{U=Q;while(1){K=f[n+(U<<2)>>2]|0;if((K|0)<(U|0))U=K;else break}K=(O|0)>(U|0)?U:O;V=Q;do{P=n+(V<<2)|0;S=V;V=f[P>>2]|0;f[P>>2]=K}while((V|0)<(S|0));hb=K}K=$;do{V=n+(K<<2)|0;Q=K;K=f[V>>2]|0;f[V>>2]=hb}while((K|0)<(Q|0));K=f[z+(N<<2)>>2]|0;$=hb;while(1){Q=f[n+($<<2)>>2]|0;if((Q|0)<($|0))$=Q;else break}if((hb|0)==(K|0))ib=$;else{N=K;while(1){Q=f[n+(N<<2)>>2]|0;if((Q|0)<(N|0))N=Q;else break}Q=($|0)>(N|0)?N:$;V=K;do{O=n+(V<<2)|0;U=V;V=f[O>>2]|0;f[O>>2]=Q}while((V|0)<(U|0));ib=Q}Q=hb;do{V=n+(Q<<2)|0;K=Q;Q=f[V>>2]|0;f[V>>2]=ib}while((Q|0)<(K|0));f[z+(E<<2)>>2]=ib;L=F;break a}while(0);do if(B){M=E+-2|0;if(b[x+G>>0]|0){T=f[z+(M<<2)>>2]|0;do if((M|0)>-1){if(!(b[v+M>>0]|0))break;f[z+(E<<2)>>2]=T;L=F;break a}while(0);I=f[t+(M<<2)>>2]|0;Q=I;while(1){K=f[n+(Q<<2)>>2]|0;if((K|0)<(Q|0))Q=K;else break}if((I|0)==(T|0))jb=Q;else{K=T;while(1){V=f[n+(K<<2)>>2]|0;if((V|0)<(K|0))K=V;else break}V=(Q|0)>(K|0)?K:Q;$=T;do{N=n+($<<2)|0;U=$;$=f[N>>2]|0;f[N>>2]=V}while(($|0)<(U|0));jb=V}V=I;do{$=n+(V<<2)|0;T=V;V=f[$>>2]|0;f[$>>2]=jb}while((V|0)<(T|0));f[z+(E<<2)>>2]=jb;L=F;break a}if(!(b[x+E>>0]|0)){kb=M;break}do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(!(b[x+M>>0]|0)){V=f[t+(E<<2)>>2]|0;I=f[z+(M<<2)>>2]|0;T=V;while(1){$=f[n+(T<<2)>>2]|0;if(($|0)<(T|0))T=$;else break}if((V|0)==(I|0))lb=T;else{$=I;while(1){Q=f[n+($<<2)>>2]|0;if((Q|0)<($|0))$=Q;else break}Q=(T|0)>($|0)?$:T;K=I;do{U=n+(K<<2)|0;N=K;K=f[U>>2]|0;f[U>>2]=Q}while((K|0)<(N|0));lb=Q}Q=V;do{K=n+(Q<<2)|0;I=Q;Q=f[K>>2]|0;f[K>>2]=lb}while((Q|0)<(I|0));f[z+(E<<2)>>2]=lb;L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;f[z+(E<<2)>>2]=f[z+(M<<2)>>2];L=F;break a}while(0);Q=f[t+(E<<2)>>2]|0;V=f[z+(M<<2)>>2]|0;I=Q;while(1){K=f[n+(I<<2)>>2]|0;if((K|0)<(I|0))I=K;else break}if((Q|0)==(V|0))mb=I;else{K=V;while(1){T=f[n+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}T=(I|0)>(K|0)?K:I;$=V;do{N=n+($<<2)|0;U=$;$=f[N>>2]|0;f[N>>2]=T}while(($|0)<(U|0));mb=T}T=Q;do{$=n+(T<<2)|0;V=T;T=f[$>>2]|0;f[$>>2]=mb}while((T|0)<(V|0));f[z+(E<<2)>>2]=mb;L=F;break a}while(0);T=f[t+(E<<2)>>2]|0;Q=f[z+(M<<2)>>2]|0;V=T;while(1){$=f[n+(V<<2)>>2]|0;if(($|0)<(V|0))V=$;else break}if((T|0)==(Q|0))nb=V;else{M=Q;while(1){$=f[n+(M<<2)>>2]|0;if(($|0)<(M|0))M=$;else break}$=(V|0)>(M|0)?M:V;I=Q;do{K=n+(I<<2)|0;U=I;I=f[K>>2]|0;f[K>>2]=$}while((I|0)<(U|0));nb=$}$=T;do{I=n+($<<2)|0;Q=$;$=f[I>>2]|0;f[I>>2]=nb}while(($|0)<(Q|0));f[z+(E<<2)>>2]=nb;L=F;break a}else kb=E+-2|0;while(0);f[z+(E<<2)>>2]=f[z+(kb<<2)>>2];L=F;break}do if(B){$=E+-2|0;if(b[x+G>>0]|0){T=f[z+($<<2)>>2]|0;do if(($|0)>-1){if(!(b[v+$>>0]|0))break;f[z+(E<<2)>>2]=T;L=F;break a}while(0);Q=f[t+($<<2)>>2]|0;I=Q;while(1){V=f[n+(I<<2)>>2]|0;if((V|0)<(I|0))I=V;else break}if((Q|0)==(T|0))ob=I;else{V=T;while(1){M=f[n+(V<<2)>>2]|0;if((M|0)<(V|0))V=M;else break}M=(I|0)>(V|0)?V:I;U=T;do{K=n+(U<<2)|0;N=U;U=f[K>>2]|0;f[K>>2]=M}while((U|0)<(N|0));ob=M}M=Q;do{U=n+(M<<2)|0;T=M;M=f[U>>2]|0;f[U>>2]=ob}while((M|0)<(T|0));f[z+(E<<2)>>2]=ob;L=F;break a}if(!(b[x+E>>0]|0)){pb=$;break}do if(($|0)>-1){if(!(b[v+$>>0]|0))break;if(!(b[x+$>>0]|0)){M=f[t+(E<<2)>>2]|0;Q=f[z+($<<2)>>2]|0;T=M;while(1){U=f[n+(T<<2)>>2]|0;if((U|0)<(T|0))T=U;else break}if((M|0)==(Q|0))qb=T;else{U=Q;while(1){I=f[n+(U<<2)>>2]|0;if((I|0)<(U|0))U=I;else break}I=(T|0)>(U|0)?U:T;V=Q;do{N=n+(V<<2)|0;K=V;V=f[N>>2]|0;f[N>>2]=I}while((V|0)<(K|0));qb=I}I=M;do{V=n+(I<<2)|0;Q=I;I=f[V>>2]|0;f[V>>2]=qb}while((I|0)<(Q|0));f[z+(E<<2)>>2]=qb;L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;f[z+(E<<2)>>2]=f[z+($<<2)>>2];L=F;break a}while(0);I=f[t+(E<<2)>>2]|0;M=f[z+($<<2)>>2]|0;Q=I;while(1){V=f[n+(Q<<2)>>2]|0;if((V|0)<(Q|0))Q=V;else break}if((I|0)==(M|0))rb=Q;else{V=M;while(1){T=f[n+(V<<2)>>2]|0;if((T|0)<(V|0))V=T;else break}T=(Q|0)>(V|0)?V:Q;U=M;do{K=n+(U<<2)|0;N=U;U=f[K>>2]|0;f[K>>2]=T}while((U|0)<(N|0));rb=T}T=I;do{U=n+(T<<2)|0;M=T;T=f[U>>2]|0;f[U>>2]=rb}while((T|0)<(M|0));f[z+(E<<2)>>2]=rb;L=F;break a}while(0);T=f[t+(E<<2)>>2]|0;I=f[z+($<<2)>>2]|0;M=T;while(1){U=f[n+(M<<2)>>2]|0;if((U|0)<(M|0))M=U;else break}if((T|0)==(I|0))sb=M;else{$=I;while(1){U=f[n+($<<2)>>2]|0;if((U|0)<($|0))$=U;else break}U=(M|0)>($|0)?$:M;Q=I;do{V=n+(Q<<2)|0;N=Q;Q=f[V>>2]|0;f[V>>2]=U}while((Q|0)<(N|0));sb=U}U=T;do{Q=n+(U<<2)|0;I=U;U=f[Q>>2]|0;f[Q>>2]=sb}while((U|0)<(I|0));f[z+(E<<2)>>2]=sb;L=F;break a}else pb=E+-2|0;while(0);f[z+(E<<2)>>2]=f[z+(pb<<2)>>2];L=F;break}}U=E|1;T=(U|0)<(i|0);if(!(C|T^1)?b[x+U>>0]|0:0){if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break}if(H?b[x+G>>0]|0:0){I=f[t+(E<<2)>>2]|0;do if(D){if(!(b[y+E>>0]|0))break;f[z+(E<<2)>>2]=I;L=F;break a}while(0);Q=f[t+(E+-2<<2)>>2]|0;M=Q;while(1){$=f[n+(M<<2)>>2]|0;if(($|0)<(M|0))M=$;else break}if((Q|0)==(I|0))tb=M;else{$=I;while(1){N=f[n+($<<2)>>2]|0;if((N|0)<($|0))$=N;else break}N=(M|0)>($|0)?$:M;V=I;do{K=n+(V<<2)|0;O=V;V=f[K>>2]|0;f[K>>2]=N}while((V|0)<(O|0));tb=N}N=Q;do{V=n+(N<<2)|0;I=N;N=f[V>>2]|0;f[V>>2]=tb}while((N|0)<(I|0));f[z+(E<<2)>>2]=tb;L=F;break}f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break}if(T?b[v+U>>0]|0:0){N=E+2|0;if(!((N|0)>=(i|0)|C)?b[x+N>>0]|0:0){if(b[x+E>>0]|0){do if(D){if(!(b[y+U>>0]|0))break;f[z+(E<<2)>>2]=f[t+(N<<2)>>2];L=F;break a}while(0);T=f[t+(E<<2)>>2]|0;Q=f[t+(N<<2)>>2]|0;I=T;while(1){V=f[n+(I<<2)>>2]|0;if((V|0)<(I|0))I=V;else break}if((T|0)==(Q|0))ub=I;else{V=Q;while(1){M=f[n+(V<<2)>>2]|0;if((M|0)<(V|0))V=M;else break}M=(I|0)>(V|0)?V:I;$=Q;do{O=n+($<<2)|0;K=$;$=f[O>>2]|0;f[O>>2]=M}while(($|0)<(K|0));ub=M}M=T;do{$=n+(M<<2)|0;Q=M;M=f[$>>2]|0;f[$>>2]=ub}while((M|0)<(Q|0));f[z+(E<<2)>>2]=ub;L=F;break}do if(H){if(!(b[x+G>>0]|0))break;do if(D){if(!(b[y+U>>0]|0))break;M=f[t+(N<<2)>>2]|0;if(b[y+E>>0]|0){f[z+(E<<2)>>2]=M;L=F;break a}T=f[t+(E+-2<<2)>>2]|0;Q=T;while(1){$=f[n+(Q<<2)>>2]|0;if(($|0)<(Q|0))Q=$;else break}if((T|0)==(M|0))vb=Q;else{$=M;while(1){I=f[n+($<<2)>>2]|0;if((I|0)<($|0))$=I;else break}I=(Q|0)>($|0)?$:Q;V=M;do{K=n+(V<<2)|0;O=V;V=f[K>>2]|0;f[K>>2]=I}while((V|0)<(O|0));vb=I}I=T;do{V=n+(I<<2)|0;M=I;I=f[V>>2]|0;f[V>>2]=vb}while((I|0)<(M|0));f[z+(E<<2)>>2]=vb;L=F;break a}while(0);I=f[t+(E+-2<<2)>>2]|0;T=f[t+(N<<2)>>2]|0;M=I;while(1){V=f[n+(M<<2)>>2]|0;if((V|0)<(M|0))M=V;else break}if((I|0)==(T|0))wb=M;else{V=T;while(1){Q=f[n+(V<<2)>>2]|0;if((Q|0)<(V|0))V=Q;else break}Q=(M|0)>(V|0)?V:M;$=T;do{O=n+($<<2)|0;K=$;$=f[O>>2]|0;f[O>>2]=Q}while(($|0)<(K|0));wb=Q}Q=I;do{$=n+(Q<<2)|0;T=Q;Q=f[$>>2]|0;f[$>>2]=wb}while((Q|0)<(T|0));f[z+(E<<2)>>2]=wb;L=F;break a}while(0);f[z+(E<<2)>>2]=f[t+(N<<2)>>2];L=F;break}if(B?b[x+E>>0]|0:0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break}do if(!(C|H^1)){if(!(b[x+G>>0]|0))break;f[z+(E<<2)>>2]=f[t+(E+-2<<2)>>2];L=F;break a}while(0);f[z+(E<<2)>>2]=F;f[n+(F<<2)>>2]=F;L=F+1|0;break}if(B?b[x+E>>0]|0:0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break}if(!(C|H^1)?b[x+G>>0]|0:0){f[z+(E<<2)>>2]=f[t+(E+-2<<2)>>2];L=F;break}f[z+(E<<2)>>2]=F;f[n+(F<<2)>>2]=F;L=F+1|0}while(0);E=E+2|0;if((E|0)>=(i|0)){xb=L;break}else F=L}}else xb=r;s=s+2|0;if((s|0)>=(h|0))break;else r=xb}if((xb|0)>1){r=1;h=1;while(1){s=n+(r<<2)|0;L=f[s>>2]|0;if((L|0)<(r|0)){f[s>>2]=f[n+(L<<2)>>2];yb=h}else{f[s>>2]=h;yb=h+1|0}r=r+1|0;if((r|0)==(xb|0)){zb=yb;break}else h=yb}}else zb=1}else zb=1;N6(g,zb);yb=f[j>>2]|0;h=f[o>>2]|0;xb=(h&1|0)!=0;r=(yb|0)>0;b:do if(!(yb&1)){if(!xb){if(!r)break;s=c+16|0;L=c+44|0;i=d+16|0;wb=d+44|0;vb=g+20|0;ub=g+120|0;tb=g+48|0;pb=h;sb=yb;rb=0;while(1){qb=f[f[L>>2]>>2]|0;ob=(f[s>>2]|0)+(Y(qb,rb)|0)|0;kb=ob+qb|0;qb=f[f[wb>>2]>>2]|0;nb=(f[i>>2]|0)+(Y(qb,rb)|0)|0;mb=nb+qb|0;if((pb|0)>0){qb=((rb|0)<0)<<31>>31;lb=rb|1;jb=((lb|0)<0)<<31>>31;ib=0;do{hb=nb+(ib<<2)|0;gb=f[hb>>2]|0;do if((gb|0)>0){fb=f[n+(gb<<2)>>2]|0;if(!(b[ob+ib>>0]|0)){f[hb>>2]=0;eb=f[vb>>2]|0;db=f[eb>>2]|0;f[eb>>2]=(db|0)>(ib|0)?ib:db;db=eb+8|0;cb=f[db>>2]|0;f[db>>2]=(cb|0)<(ib|0)?ib:cb;cb=eb+4|0;db=f[cb>>2]|0;f[cb>>2]=(db|0)>(rb|0)?rb:db;db=eb+12|0;cb=f[db>>2]|0;f[db>>2]=(cb|0)<(rb|0)?rb:cb;cb=eb+16|0;f[cb>>2]=(f[cb>>2]|0)+1;cb=f[ub>>2]|0;db=cb;bb=C1a(f[db>>2]|0,f[db+4>>2]|0,ib|0,((ib|0)<0)<<31>>31|0)|0;db=cb;f[db>>2]=bb;f[db+4>>2]=J;Ab=eb;Bb=cb;Cb=cb+8|0}else{f[hb>>2]=fb;cb=f[vb>>2]|0;eb=cb+(Y(f[f[tb>>2]>>2]|0,fb)|0)|0;db=f[eb>>2]|0;f[eb>>2]=(db|0)>(ib|0)?ib:db;db=eb+8|0;bb=f[db>>2]|0;f[db>>2]=(bb|0)<(ib|0)?ib:bb;bb=eb+4|0;db=f[bb>>2]|0;f[bb>>2]=(db|0)>(rb|0)?rb:db;db=eb+12|0;bb=f[db>>2]|0;f[db>>2]=(bb|0)<(rb|0)?rb:bb;bb=eb+16|0;f[bb>>2]=(f[bb>>2]|0)+1;bb=f[ub>>2]|0;eb=bb+(fb<<4)|0;db=eb;ab=C1a(f[db>>2]|0,f[db+4>>2]|0,ib|0,((ib|0)<0)<<31>>31|0)|0;db=eb;f[db>>2]=ab;f[db+4>>2]=J;Ab=cb;Bb=bb;Cb=bb+(fb<<4)+8|0}bb=Cb;cb=C1a(f[bb>>2]|0,f[bb+4>>2]|0,rb|0,qb|0)|0;bb=Cb;f[bb>>2]=cb;f[bb+4>>2]=J;bb=ib|1;cb=nb+(bb<<2)|0;if(!(b[ob+bb>>0]|0)){f[cb>>2]=0;Db=0;Eb=Ab}else{f[cb>>2]=fb;Db=fb;Eb=Ab+(Y(f[f[tb>>2]>>2]|0,fb)|0)|0}cb=f[Eb>>2]|0;f[Eb>>2]=(cb|0)>(bb|0)?bb:cb;cb=Eb+8|0;db=f[cb>>2]|0;f[cb>>2]=(db|0)<(bb|0)?bb:db;db=Eb+4|0;cb=f[db>>2]|0;f[db>>2]=(cb|0)>(rb|0)?rb:cb;cb=Eb+12|0;db=f[cb>>2]|0;f[cb>>2]=(db|0)<(rb|0)?rb:db;db=Eb+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Bb+(Db<<4)|0;cb=db;ab=C1a(f[cb>>2]|0,f[cb+4>>2]|0,bb|0,((bb|0)<0)<<31>>31|0)|0;cb=db;f[cb>>2]=ab;f[cb+4>>2]=J;cb=Bb+(Db<<4)+8|0;ab=cb;db=C1a(f[ab>>2]|0,f[ab+4>>2]|0,rb|0,qb|0)|0;ab=cb;f[ab>>2]=db;f[ab+4>>2]=J;ab=mb+(ib<<2)|0;if(!(b[kb+ib>>0]|0)){f[ab>>2]=0;Fb=0;Gb=Ab}else{f[ab>>2]=fb;Fb=fb;Gb=Ab+(Y(f[f[tb>>2]>>2]|0,fb)|0)|0}ab=f[Gb>>2]|0;f[Gb>>2]=(ab|0)>(ib|0)?ib:ab;ab=Gb+8|0;db=f[ab>>2]|0;f[ab>>2]=(db|0)<(ib|0)?ib:db;db=Gb+4|0;ab=f[db>>2]|0;f[db>>2]=(ab|0)>(lb|0)?lb:ab;ab=Gb+12|0;db=f[ab>>2]|0;f[ab>>2]=(db|0)<(lb|0)?lb:db;db=Gb+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Bb+(Fb<<4)|0;ab=db;cb=C1a(f[ab>>2]|0,f[ab+4>>2]|0,ib|0,((ib|0)<0)<<31>>31|0)|0;ab=db;f[ab>>2]=cb;f[ab+4>>2]=J;ab=Bb+(Fb<<4)+8|0;cb=ab;db=C1a(f[cb>>2]|0,f[cb+4>>2]|0,lb|0,jb|0)|0;cb=ab;f[cb>>2]=db;f[cb+4>>2]=J;cb=mb+(bb<<2)|0;if(!(b[kb+bb>>0]|0)){f[cb>>2]=0;db=f[Ab>>2]|0;f[Ab>>2]=(db|0)>(bb|0)?bb:db;db=Ab+8|0;ab=f[db>>2]|0;f[db>>2]=(ab|0)<(bb|0)?bb:ab;ab=Ab+4|0;db=f[ab>>2]|0;f[ab>>2]=(db|0)>(lb|0)?lb:db;db=Ab+12|0;ab=f[db>>2]|0;f[db>>2]=(ab|0)<(lb|0)?lb:ab;ab=Ab+16|0;f[ab>>2]=(f[ab>>2]|0)+1;ab=Bb;db=C1a(f[ab>>2]|0,f[ab+4>>2]|0,bb|0,((bb|0)<0)<<31>>31|0)|0;ab=Bb;f[ab>>2]=db;f[ab+4>>2]=J;Hb=Bb+8|0;break}else{f[cb>>2]=fb;cb=Ab+(Y(f[f[tb>>2]>>2]|0,fb)|0)|0;ab=f[cb>>2]|0;f[cb>>2]=(ab|0)>(bb|0)?bb:ab;ab=cb+8|0;db=f[ab>>2]|0;f[ab>>2]=(db|0)<(bb|0)?bb:db;db=cb+4|0;ab=f[db>>2]|0;f[db>>2]=(ab|0)>(lb|0)?lb:ab;ab=cb+12|0;db=f[ab>>2]|0;f[ab>>2]=(db|0)<(lb|0)?lb:db;db=cb+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Bb+(fb<<4)|0;cb=db;ab=C1a(f[cb>>2]|0,f[cb+4>>2]|0,bb|0,((bb|0)<0)<<31>>31|0)|0;bb=db;f[bb>>2]=ab;f[bb+4>>2]=J;Hb=Bb+(fb<<4)+8|0;break}}else{f[hb>>2]=0;fb=ib|1;f[nb+(fb<<2)>>2]=0;f[mb+(ib<<2)>>2]=0;f[mb+(fb<<2)>>2]=0;bb=f[vb>>2]|0;ab=f[bb>>2]|0;db=(ab|0)>(ib|0)?ib:ab;ab=bb+8|0;cb=f[ab>>2]|0;eb=(cb|0)<(ib|0)?ib:cb;cb=bb+4|0;$a=f[cb>>2]|0;_a=($a|0)>(rb|0)?rb:$a;$a=bb+12|0;Za=f[$a>>2]|0;Ya=(Za|0)<(rb|0)?rb:Za;Za=bb+16|0;Xa=f[Za>>2]|0;Wa=f[ub>>2]|0;Va=((ib|0)<0)<<31>>31;Ua=Wa;Ta=C1a(f[Ua>>2]|0,f[Ua+4>>2]|0,ib|0,Va|0)|0;Ua=J;Sa=Wa+8|0;Ra=Sa;Qa=C1a(f[Ra>>2]|0,f[Ra+4>>2]|0,rb|0,qb|0)|0;Ra=J;Pa=(db|0)>(fb|0)?fb:db;db=((fb|0)<0)<<31>>31;Oa=C1a(Ta|0,Ua|0,fb|0,db|0)|0;Ua=J;Ta=C1a(Qa|0,Ra|0,rb|0,qb|0)|0;Ra=J;Qa=C1a(Oa|0,Ua|0,ib|0,Va|0)|0;Va=J;Ua=C1a(Ta|0,Ra|0,lb|0,jb|0)|0;Ra=Sa;f[Ra>>2]=Ua;f[Ra+4>>2]=J;f[bb>>2]=(Pa|0)>(ib|0)?ib:Pa;f[ab>>2]=(eb|0)<(fb|0)?fb:eb;f[cb>>2]=(_a|0)>(lb|0)?lb:_a;f[$a>>2]=(Ya|0)<(lb|0)?lb:Ya;f[Za>>2]=Xa+4;Xa=C1a(Qa|0,Va|0,fb|0,db|0)|0;db=Wa;f[db>>2]=Xa;f[db+4>>2]=J;Hb=Sa}while(0);hb=Hb;gb=C1a(f[hb>>2]|0,f[hb+4>>2]|0,lb|0,jb|0)|0;hb=Hb;f[hb>>2]=gb;f[hb+4>>2]=J;ib=ib+2|0;Ib=f[o>>2]|0}while((ib|0)<(Ib|0));Jb=f[j>>2]|0;Kb=Ib}else{Jb=sb;Kb=pb}rb=rb+2|0;if((rb|0)>=(Jb|0))break b;else{pb=Kb;sb=Jb}}}if(r){sb=g+20|0;pb=g+120|0;rb=g+48|0;ub=f[c+16>>2]|0;vb=f[c+44>>2]|0;tb=f[d+16>>2]|0;i=f[d+44>>2]|0;wb=h;s=yb;L=0;while(1){ib=f[vb>>2]|0;jb=ub+(Y(ib,L)|0)|0;lb=jb+ib|0;ib=f[i>>2]|0;qb=tb+(Y(ib,L)|0)|0;mb=qb+ib|0;if((wb|0)>0){ib=((L|0)<0)<<31>>31;nb=L|1;kb=((nb|0)<0)<<31>>31;ob=0;do{hb=qb+(ob<<2)|0;gb=f[hb>>2]|0;do if((gb|0)>0){G=f[n+(gb<<2)>>2]|0;if(!(b[jb+ob>>0]|0)){f[hb>>2]=0;H=f[sb>>2]|0;Sa=f[H>>2]|0;f[H>>2]=(Sa|0)>(ob|0)?ob:Sa;Sa=H+8|0;db=f[Sa>>2]|0;f[Sa>>2]=(db|0)<(ob|0)?ob:db;db=H+4|0;Sa=f[db>>2]|0;f[db>>2]=(Sa|0)>(L|0)?L:Sa;Sa=H+12|0;db=f[Sa>>2]|0;f[Sa>>2]=(db|0)<(L|0)?L:db;db=H+16|0;f[db>>2]=(f[db>>2]|0)+1;db=f[pb>>2]|0;Sa=db;Xa=C1a(f[Sa>>2]|0,f[Sa+4>>2]|0,ob|0,((ob|0)<0)<<31>>31|0)|0;Sa=db;f[Sa>>2]=Xa;f[Sa+4>>2]=J;Lb=H;Mb=db;Nb=db+8|0}else{f[hb>>2]=G;db=f[sb>>2]|0;H=db+(Y(f[f[rb>>2]>>2]|0,G)|0)|0;Sa=f[H>>2]|0;f[H>>2]=(Sa|0)>(ob|0)?ob:Sa;Sa=H+8|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(ob|0)?ob:Xa;Xa=H+4|0;Sa=f[Xa>>2]|0;f[Xa>>2]=(Sa|0)>(L|0)?L:Sa;Sa=H+12|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(L|0)?L:Xa;Xa=H+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=f[pb>>2]|0;H=Xa+(G<<4)|0;Sa=H;Wa=C1a(f[Sa>>2]|0,f[Sa+4>>2]|0,ob|0,((ob|0)<0)<<31>>31|0)|0;Sa=H;f[Sa>>2]=Wa;f[Sa+4>>2]=J;Lb=db;Mb=Xa;Nb=Xa+(G<<4)+8|0}Xa=Nb;db=C1a(f[Xa>>2]|0,f[Xa+4>>2]|0,L|0,ib|0)|0;Xa=Nb;f[Xa>>2]=db;f[Xa+4>>2]=J;Xa=mb+(ob<<2)|0;if(!(b[lb+ob>>0]|0)){f[Xa>>2]=0;Ob=0;Pb=Lb}else{f[Xa>>2]=G;Ob=G;Pb=Lb+(Y(f[f[rb>>2]>>2]|0,G)|0)|0}Xa=f[Pb>>2]|0;f[Pb>>2]=(Xa|0)>(ob|0)?ob:Xa;Xa=Pb+8|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(ob|0)?ob:db;db=Pb+4|0;Xa=f[db>>2]|0;f[db>>2]=(Xa|0)>(nb|0)?nb:Xa;Xa=Pb+12|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(nb|0)?nb:db;db=Pb+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Mb+(Ob<<4)|0;Xa=db;Sa=C1a(f[Xa>>2]|0,f[Xa+4>>2]|0,ob|0,((ob|0)<0)<<31>>31|0)|0;Xa=db;f[Xa>>2]=Sa;f[Xa+4>>2]=J;Xa=Mb+(Ob<<4)+8|0;Sa=Xa;db=C1a(f[Sa>>2]|0,f[Sa+4>>2]|0,nb|0,kb|0)|0;Sa=Xa;f[Sa>>2]=db;f[Sa+4>>2]=J;Sa=ob|1;if((Sa|0)<(f[o>>2]|0)){db=qb+(Sa<<2)|0;if(!(b[jb+Sa>>0]|0)){f[db>>2]=0;Qb=0;Rb=Lb}else{f[db>>2]=G;Qb=G;Rb=Lb+(Y(f[f[rb>>2]>>2]|0,G)|0)|0}db=f[Rb>>2]|0;f[Rb>>2]=(db|0)>(Sa|0)?Sa:db;db=Rb+8|0;Xa=f[db>>2]|0;f[db>>2]=(Xa|0)<(Sa|0)?Sa:Xa;Xa=Rb+4|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)>(L|0)?L:db;db=Rb+12|0;Xa=f[db>>2]|0;f[db>>2]=(Xa|0)<(L|0)?L:Xa;Xa=Rb+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=Mb+(Qb<<4)|0;db=Xa;Wa=C1a(f[db>>2]|0,f[db+4>>2]|0,Sa|0,((Sa|0)<0)<<31>>31|0)|0;db=Xa;f[db>>2]=Wa;f[db+4>>2]=J;db=Mb+(Qb<<4)+8|0;Wa=db;Xa=C1a(f[Wa>>2]|0,f[Wa+4>>2]|0,L|0,ib|0)|0;Wa=db;f[Wa>>2]=Xa;f[Wa+4>>2]=J;Wa=mb+(Sa<<2)|0;if(!(b[lb+Sa>>0]|0)){f[Wa>>2]=0;Xa=f[Lb>>2]|0;f[Lb>>2]=(Xa|0)>(Sa|0)?Sa:Xa;Xa=Lb+8|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(Sa|0)?Sa:db;db=Lb+4|0;Xa=f[db>>2]|0;f[db>>2]=(Xa|0)>(nb|0)?nb:Xa;Xa=Lb+12|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(nb|0)?nb:db;db=Lb+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Mb;Xa=C1a(f[db>>2]|0,f[db+4>>2]|0,Sa|0,((Sa|0)<0)<<31>>31|0)|0;db=Mb;f[db>>2]=Xa;f[db+4>>2]=J;db=Mb+8|0;Xa=db;H=C1a(f[Xa>>2]|0,f[Xa+4>>2]|0,nb|0,kb|0)|0;Xa=db;f[Xa>>2]=H;f[Xa+4>>2]=J;break}else{f[Wa>>2]=G;Wa=Lb+(Y(f[f[rb>>2]>>2]|0,G)|0)|0;Xa=f[Wa>>2]|0;f[Wa>>2]=(Xa|0)>(Sa|0)?Sa:Xa;Xa=Wa+8|0;H=f[Xa>>2]|0;f[Xa>>2]=(H|0)<(Sa|0)?Sa:H;H=Wa+4|0;Xa=f[H>>2]|0;f[H>>2]=(Xa|0)>(nb|0)?nb:Xa;Xa=Wa+12|0;H=f[Xa>>2]|0;f[Xa>>2]=(H|0)<(nb|0)?nb:H;H=Wa+16|0;f[H>>2]=(f[H>>2]|0)+1;H=Mb+(G<<4)|0;Wa=H;Xa=C1a(f[Wa>>2]|0,f[Wa+4>>2]|0,Sa|0,((Sa|0)<0)<<31>>31|0)|0;Sa=H;f[Sa>>2]=Xa;f[Sa+4>>2]=J;Sa=Mb+(G<<4)+8|0;G=Sa;Xa=C1a(f[G>>2]|0,f[G+4>>2]|0,nb|0,kb|0)|0;G=Sa;f[G>>2]=Xa;f[G+4>>2]=J;break}}}else{f[hb>>2]=0;f[mb+(ob<<2)>>2]=0;G=f[sb>>2]|0;Xa=f[G>>2]|0;Sa=G+8|0;H=f[Sa>>2]|0;Wa=G+4|0;db=f[Wa>>2]|0;fb=(db|0)>(L|0)?L:db;db=G+12|0;Va=f[db>>2]|0;Qa=(Va|0)<(L|0)?L:Va;Va=G+16|0;Za=f[Va>>2]|0;Ya=f[pb>>2]|0;$a=((ob|0)<0)<<31>>31;_a=Ya;cb=C1a(f[_a>>2]|0,f[_a+4>>2]|0,ob|0,$a|0)|0;_a=J;eb=Ya+8|0;ab=eb;Pa=C1a(f[ab>>2]|0,f[ab+4>>2]|0,L|0,ib|0)|0;ab=J;f[G>>2]=(Xa|0)>(ob|0)?ob:Xa;f[Sa>>2]=(H|0)<(ob|0)?ob:H;f[Wa>>2]=(fb|0)>(nb|0)?nb:fb;f[db>>2]=(Qa|0)<(nb|0)?nb:Qa;f[Va>>2]=Za+2;Za=C1a(cb|0,_a|0,ob|0,$a|0)|0;$a=J;_a=Ya;f[_a>>2]=Za;f[_a+4>>2]=$a;_a=C1a(Pa|0,ab|0,nb|0,kb|0)|0;ab=J;Pa=eb;f[Pa>>2]=_a;f[Pa+4>>2]=ab;Pa=ob|1;if((Pa|0)<(f[o>>2]|0)){f[qb+(Pa<<2)>>2]=0;f[mb+(Pa<<2)>>2]=0;cb=f[G>>2]|0;Qa=f[Sa>>2]|0;fb=f[Wa>>2]|0;H=(fb|0)>(L|0)?L:fb;fb=f[db>>2]|0;Xa=(fb|0)<(L|0)?L:fb;fb=f[Va>>2]|0;bb=((Pa|0)<0)<<31>>31;Ra=C1a(Za|0,$a|0,Pa|0,bb|0)|0;$a=J;Za=C1a(_a|0,ab|0,L|0,ib|0)|0;ab=J;f[G>>2]=(cb|0)>(Pa|0)?Pa:cb;f[Sa>>2]=(Qa|0)<(Pa|0)?Pa:Qa;f[Wa>>2]=(H|0)>(nb|0)?nb:H;f[db>>2]=(Xa|0)<(nb|0)?nb:Xa;f[Va>>2]=fb+2;fb=C1a(Ra|0,$a|0,Pa|0,bb|0)|0;bb=Ya;f[bb>>2]=fb;f[bb+4>>2]=J;bb=C1a(Za|0,ab|0,nb|0,kb|0)|0;ab=eb;f[ab>>2]=bb;f[ab+4>>2]=J}}while(0);ob=ob+2|0;Sb=f[o>>2]|0}while((ob|0)<(Sb|0));Tb=f[j>>2]|0;Ub=Sb}else{Tb=s;Ub=wb}L=L+2|0;if((L|0)>=(Tb|0))break;else{wb=Ub;s=Tb}}}}else{if(!xb){if(!r)break;s=g+20|0;wb=g+120|0;L=g+48|0;pb=f[c+16>>2]|0;sb=f[c+44>>2]|0;rb=f[d+16>>2]|0;tb=f[d+44>>2]|0;i=h;ub=yb;vb=0;while(1){ob=f[sb>>2]|0;kb=pb+(Y(ob,vb)|0)|0;nb=kb+ob|0;ob=f[tb>>2]|0;ib=rb+(Y(ob,vb)|0)|0;mb=ib+ob|0;if((i|0)>0){ob=((vb|0)<0)<<31>>31;qb=vb|1;lb=((qb|0)<0)<<31>>31;jb=0;do{hb=ib+(jb<<2)|0;gb=f[hb>>2]|0;do if((gb|0)>0){ab=f[n+(gb<<2)>>2]|0;if(!(b[kb+jb>>0]|0)){f[hb>>2]=0;bb=f[s>>2]|0;eb=f[bb>>2]|0;f[bb>>2]=(eb|0)>(jb|0)?jb:eb;eb=bb+8|0;Za=f[eb>>2]|0;f[eb>>2]=(Za|0)<(jb|0)?jb:Za;Za=bb+4|0;eb=f[Za>>2]|0;f[Za>>2]=(eb|0)>(vb|0)?vb:eb;eb=bb+12|0;Za=f[eb>>2]|0;f[eb>>2]=(Za|0)<(vb|0)?vb:Za;Za=bb+16|0;f[Za>>2]=(f[Za>>2]|0)+1;Za=f[wb>>2]|0;eb=Za;fb=C1a(f[eb>>2]|0,f[eb+4>>2]|0,jb|0,((jb|0)<0)<<31>>31|0)|0;eb=Za;f[eb>>2]=fb;f[eb+4>>2]=J;Vb=bb;Wb=Za;Xb=Za+8|0}else{f[hb>>2]=ab;Za=f[s>>2]|0;bb=Za+(Y(f[f[L>>2]>>2]|0,ab)|0)|0;eb=f[bb>>2]|0;f[bb>>2]=(eb|0)>(jb|0)?jb:eb;eb=bb+8|0;fb=f[eb>>2]|0;f[eb>>2]=(fb|0)<(jb|0)?jb:fb;fb=bb+4|0;eb=f[fb>>2]|0;f[fb>>2]=(eb|0)>(vb|0)?vb:eb;eb=bb+12|0;fb=f[eb>>2]|0;f[eb>>2]=(fb|0)<(vb|0)?vb:fb;fb=bb+16|0;f[fb>>2]=(f[fb>>2]|0)+1;fb=f[wb>>2]|0;bb=fb+(ab<<4)|0;eb=bb;Ya=C1a(f[eb>>2]|0,f[eb+4>>2]|0,jb|0,((jb|0)<0)<<31>>31|0)|0;eb=bb;f[eb>>2]=Ya;f[eb+4>>2]=J;Vb=Za;Wb=fb;Xb=fb+(ab<<4)+8|0}fb=Xb;Za=C1a(f[fb>>2]|0,f[fb+4>>2]|0,vb|0,ob|0)|0;fb=Xb;f[fb>>2]=Za;f[fb+4>>2]=J;fb=jb|1;Za=ib+(fb<<2)|0;if(!(b[kb+fb>>0]|0)){f[Za>>2]=0;Yb=0;Zb=Vb}else{f[Za>>2]=ab;Yb=ab;Zb=Vb+(Y(f[f[L>>2]>>2]|0,ab)|0)|0}Za=f[Zb>>2]|0;f[Zb>>2]=(Za|0)>(fb|0)?fb:Za;Za=Zb+8|0;eb=f[Za>>2]|0;f[Za>>2]=(eb|0)<(fb|0)?fb:eb;eb=Zb+4|0;Za=f[eb>>2]|0;f[eb>>2]=(Za|0)>(vb|0)?vb:Za;Za=Zb+12|0;eb=f[Za>>2]|0;f[Za>>2]=(eb|0)<(vb|0)?vb:eb;eb=Zb+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Wb+(Yb<<4)|0;Za=eb;Ya=C1a(f[Za>>2]|0,f[Za+4>>2]|0,fb|0,((fb|0)<0)<<31>>31|0)|0;Za=eb;f[Za>>2]=Ya;f[Za+4>>2]=J;Za=Wb+(Yb<<4)+8|0;Ya=Za;eb=C1a(f[Ya>>2]|0,f[Ya+4>>2]|0,vb|0,ob|0)|0;Ya=Za;f[Ya>>2]=eb;f[Ya+4>>2]=J;if((qb|0)<(f[j>>2]|0)){Ya=mb+(jb<<2)|0;if(!(b[nb+jb>>0]|0)){f[Ya>>2]=0;_b=0;$b=Vb}else{f[Ya>>2]=ab;_b=ab;$b=Vb+(Y(f[f[L>>2]>>2]|0,ab)|0)|0}Ya=f[$b>>2]|0;f[$b>>2]=(Ya|0)>(jb|0)?jb:Ya;Ya=$b+8|0;eb=f[Ya>>2]|0;f[Ya>>2]=(eb|0)<(jb|0)?jb:eb;eb=$b+4|0;Ya=f[eb>>2]|0;f[eb>>2]=(Ya|0)>(qb|0)?qb:Ya;Ya=$b+12|0;eb=f[Ya>>2]|0;f[Ya>>2]=(eb|0)<(qb|0)?qb:eb;eb=$b+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Wb+(_b<<4)|0;Ya=eb;Za=C1a(f[Ya>>2]|0,f[Ya+4>>2]|0,jb|0,((jb|0)<0)<<31>>31|0)|0;Ya=eb;f[Ya>>2]=Za;f[Ya+4>>2]=J;Ya=Wb+(_b<<4)+8|0;Za=Ya;eb=C1a(f[Za>>2]|0,f[Za+4>>2]|0,qb|0,lb|0)|0;Za=Ya;f[Za>>2]=eb;f[Za+4>>2]=J;Za=mb+(fb<<2)|0;if(!(b[nb+fb>>0]|0)){f[Za>>2]=0;eb=f[Vb>>2]|0;f[Vb>>2]=(eb|0)>(fb|0)?fb:eb;eb=Vb+8|0;Ya=f[eb>>2]|0;f[eb>>2]=(Ya|0)<(fb|0)?fb:Ya;Ya=Vb+4|0;eb=f[Ya>>2]|0;f[Ya>>2]=(eb|0)>(qb|0)?qb:eb;eb=Vb+12|0;Ya=f[eb>>2]|0;f[eb>>2]=(Ya|0)<(qb|0)?qb:Ya;Ya=Vb+16|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=Wb;eb=C1a(f[Ya>>2]|0,f[Ya+4>>2]|0,fb|0,((fb|0)<0)<<31>>31|0)|0;Ya=Wb;f[Ya>>2]=eb;f[Ya+4>>2]=J;Ya=Wb+8|0;eb=Ya;bb=C1a(f[eb>>2]|0,f[eb+4>>2]|0,qb|0,lb|0)|0;eb=Ya;f[eb>>2]=bb;f[eb+4>>2]=J;break}else{f[Za>>2]=ab;Za=Vb+(Y(f[f[L>>2]>>2]|0,ab)|0)|0;eb=f[Za>>2]|0;f[Za>>2]=(eb|0)>(fb|0)?fb:eb;eb=Za+8|0;bb=f[eb>>2]|0;f[eb>>2]=(bb|0)<(fb|0)?fb:bb;bb=Za+4|0;eb=f[bb>>2]|0;f[bb>>2]=(eb|0)>(qb|0)?qb:eb;eb=Za+12|0;bb=f[eb>>2]|0;f[eb>>2]=(bb|0)<(qb|0)?qb:bb;bb=Za+16|0;f[bb>>2]=(f[bb>>2]|0)+1;bb=Wb+(ab<<4)|0;Za=bb;eb=C1a(f[Za>>2]|0,f[Za+4>>2]|0,fb|0,((fb|0)<0)<<31>>31|0)|0;fb=bb;f[fb>>2]=eb;f[fb+4>>2]=J;fb=Wb+(ab<<4)+8|0;ab=fb;eb=C1a(f[ab>>2]|0,f[ab+4>>2]|0,qb|0,lb|0)|0;ab=fb;f[ab>>2]=eb;f[ab+4>>2]=J;break}}}else{f[hb>>2]=0;ab=jb|1;f[ib+(ab<<2)>>2]=0;eb=f[s>>2]|0;fb=f[eb>>2]|0;bb=(fb|0)>(jb|0)?jb:fb;fb=eb+8|0;Za=f[fb>>2]|0;Ya=(Za|0)<(jb|0)?jb:Za;Za=eb+4|0;Pa=f[Za>>2]|0;$a=eb+12|0;Ra=f[$a>>2]|0;Va=eb+16|0;Xa=f[Va>>2]|0;db=f[wb>>2]|0;H=((jb|0)<0)<<31>>31;Wa=db;Qa=C1a(f[Wa>>2]|0,f[Wa+4>>2]|0,jb|0,H|0)|0;Wa=J;Sa=db+8|0;cb=Sa;G=C1a(f[cb>>2]|0,f[cb+4>>2]|0,vb|0,ob|0)|0;cb=J;f[eb>>2]=(bb|0)>(ab|0)?ab:bb;f[fb>>2]=(Ya|0)<(ab|0)?ab:Ya;f[Za>>2]=(Pa|0)>(vb|0)?vb:Pa;f[$a>>2]=(Ra|0)<(vb|0)?vb:Ra;f[Va>>2]=Xa+2;Xa=((ab|0)<0)<<31>>31;Ra=C1a(Qa|0,Wa|0,ab|0,Xa|0)|0;Wa=J;Qa=db;f[Qa>>2]=Ra;f[Qa+4>>2]=Wa;Qa=C1a(G|0,cb|0,vb|0,ob|0)|0;cb=J;G=Sa;f[G>>2]=Qa;f[G+4>>2]=cb;if((qb|0)<(f[j>>2]|0)){f[mb+(jb<<2)>>2]=0;f[mb+(ab<<2)>>2]=0;G=f[eb>>2]|0;Pa=(G|0)>(jb|0)?jb:G;G=f[fb>>2]|0;Ya=(G|0)<(jb|0)?jb:G;G=f[Za>>2]|0;bb=f[$a>>2]|0;_a=f[Va>>2]|0;Ua=C1a(Ra|0,Wa|0,jb|0,H|0)|0;H=J;Wa=C1a(Qa|0,cb|0,qb|0,lb|0)|0;cb=J;f[eb>>2]=(Pa|0)>(ab|0)?ab:Pa;f[fb>>2]=(Ya|0)<(ab|0)?ab:Ya;f[Za>>2]=(G|0)>(qb|0)?qb:G;f[$a>>2]=(bb|0)<(qb|0)?qb:bb;f[Va>>2]=_a+2;_a=C1a(Ua|0,H|0,ab|0,Xa|0)|0;Xa=db;f[Xa>>2]=_a;f[Xa+4>>2]=J;Xa=C1a(Wa|0,cb|0,qb|0,lb|0)|0;cb=Sa;f[cb>>2]=Xa;f[cb+4>>2]=J}}while(0);jb=jb+2|0;ac=f[o>>2]|0}while((jb|0)<(ac|0));bc=f[j>>2]|0;cc=ac}else{bc=ub;cc=i}vb=vb+2|0;if((vb|0)>=(bc|0))break b;else{i=cc;ub=bc}}}if(r){ub=g+20|0;i=g+120|0;vb=g+48|0;wb=f[c+16>>2]|0;s=f[c+44>>2]|0;L=f[d+16>>2]|0;rb=f[d+44>>2]|0;tb=yb;pb=h;sb=0;while(1){jb=f[s>>2]|0;lb=wb+(Y(jb,sb)|0)|0;qb=lb+jb|0;jb=f[rb>>2]|0;mb=L+(Y(jb,sb)|0)|0;ob=mb+jb|0;if((pb|0)>0){jb=((sb|0)<0)<<31>>31;ib=sb|1;nb=((ib|0)<0)<<31>>31;kb=0;do{hb=mb+(kb<<2)|0;gb=f[hb>>2]|0;do if((gb|0)>0){cb=f[n+(gb<<2)>>2]|0;if(!(b[lb+kb>>0]|0)){f[hb>>2]=0;Xa=f[ub>>2]|0;Sa=f[Xa>>2]|0;f[Xa>>2]=(Sa|0)>(kb|0)?kb:Sa;Sa=Xa+8|0;Wa=f[Sa>>2]|0;f[Sa>>2]=(Wa|0)<(kb|0)?kb:Wa;Wa=Xa+4|0;Sa=f[Wa>>2]|0;f[Wa>>2]=(Sa|0)>(sb|0)?sb:Sa;Sa=Xa+12|0;Wa=f[Sa>>2]|0;f[Sa>>2]=(Wa|0)<(sb|0)?sb:Wa;Wa=Xa+16|0;f[Wa>>2]=(f[Wa>>2]|0)+1;Wa=f[i>>2]|0;Sa=Wa;_a=C1a(f[Sa>>2]|0,f[Sa+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;Sa=Wa;f[Sa>>2]=_a;f[Sa+4>>2]=J;dc=Xa;ec=Wa;fc=Wa+8|0}else{f[hb>>2]=cb;Wa=f[ub>>2]|0;Xa=Wa+(Y(f[f[vb>>2]>>2]|0,cb)|0)|0;Sa=f[Xa>>2]|0;f[Xa>>2]=(Sa|0)>(kb|0)?kb:Sa;Sa=Xa+8|0;_a=f[Sa>>2]|0;f[Sa>>2]=(_a|0)<(kb|0)?kb:_a;_a=Xa+4|0;Sa=f[_a>>2]|0;f[_a>>2]=(Sa|0)>(sb|0)?sb:Sa;Sa=Xa+12|0;_a=f[Sa>>2]|0;f[Sa>>2]=(_a|0)<(sb|0)?sb:_a;_a=Xa+16|0;f[_a>>2]=(f[_a>>2]|0)+1;_a=f[i>>2]|0;Xa=_a+(cb<<4)|0;Sa=Xa;db=C1a(f[Sa>>2]|0,f[Sa+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;Sa=Xa;f[Sa>>2]=db;f[Sa+4>>2]=J;dc=Wa;ec=_a;fc=_a+(cb<<4)+8|0}_a=fc;Wa=C1a(f[_a>>2]|0,f[_a+4>>2]|0,sb|0,jb|0)|0;_a=fc;f[_a>>2]=Wa;f[_a+4>>2]=J;_a=kb|1;if((_a|0)>=(f[o>>2]|0)){if((ib|0)>=(f[j>>2]|0))break;Wa=ob+(kb<<2)|0;if(!(b[qb+kb>>0]|0)){f[Wa>>2]=0;Sa=f[dc>>2]|0;f[dc>>2]=(Sa|0)>(kb|0)?kb:Sa;Sa=dc+8|0;db=f[Sa>>2]|0;f[Sa>>2]=(db|0)<(kb|0)?kb:db;db=dc+4|0;Sa=f[db>>2]|0;f[db>>2]=(Sa|0)>(ib|0)?ib:Sa;Sa=dc+12|0;db=f[Sa>>2]|0;f[Sa>>2]=(db|0)<(ib|0)?ib:db;db=dc+16|0;f[db>>2]=(f[db>>2]|0)+1;db=ec;Sa=C1a(f[db>>2]|0,f[db+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;db=ec;f[db>>2]=Sa;f[db+4>>2]=J;db=ec+8|0;Sa=db;Xa=C1a(f[Sa>>2]|0,f[Sa+4>>2]|0,ib|0,nb|0)|0;Sa=db;f[Sa>>2]=Xa;f[Sa+4>>2]=J;break}else{f[Wa>>2]=cb;Wa=dc+(Y(f[f[vb>>2]>>2]|0,cb)|0)|0;Sa=f[Wa>>2]|0;f[Wa>>2]=(Sa|0)>(kb|0)?kb:Sa;Sa=Wa+8|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(kb|0)?kb:Xa;Xa=Wa+4|0;Sa=f[Xa>>2]|0;f[Xa>>2]=(Sa|0)>(ib|0)?ib:Sa;Sa=Wa+12|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(ib|0)?ib:Xa;Xa=Wa+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=ec+(cb<<4)|0;Wa=Xa;Sa=C1a(f[Wa>>2]|0,f[Wa+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;Wa=Xa;f[Wa>>2]=Sa;f[Wa+4>>2]=J;Wa=ec+(cb<<4)+8|0;Sa=Wa;Xa=C1a(f[Sa>>2]|0,f[Sa+4>>2]|0,ib|0,nb|0)|0;Sa=Wa;f[Sa>>2]=Xa;f[Sa+4>>2]=J;break}}Sa=mb+(_a<<2)|0;if(!(b[lb+_a>>0]|0)){f[Sa>>2]=0;gc=0;hc=dc}else{f[Sa>>2]=cb;gc=cb;hc=dc+(Y(f[f[vb>>2]>>2]|0,cb)|0)|0}Sa=f[hc>>2]|0;f[hc>>2]=(Sa|0)>(_a|0)?_a:Sa;Sa=hc+8|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(_a|0)?_a:Xa;Xa=hc+4|0;Sa=f[Xa>>2]|0;f[Xa>>2]=(Sa|0)>(sb|0)?sb:Sa;Sa=hc+12|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(sb|0)?sb:Xa;Xa=hc+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=ec+(gc<<4)|0;Sa=Xa;Wa=C1a(f[Sa>>2]|0,f[Sa+4>>2]|0,_a|0,((_a|0)<0)<<31>>31|0)|0;Sa=Xa;f[Sa>>2]=Wa;f[Sa+4>>2]=J;Sa=ec+(gc<<4)+8|0;Wa=Sa;Xa=C1a(f[Wa>>2]|0,f[Wa+4>>2]|0,sb|0,jb|0)|0;Wa=Sa;f[Wa>>2]=Xa;f[Wa+4>>2]=J;if((ib|0)<(f[j>>2]|0)){Wa=ob+(kb<<2)|0;if(!(b[qb+kb>>0]|0)){f[Wa>>2]=0;ic=0;jc=dc}else{f[Wa>>2]=cb;ic=cb;jc=dc+(Y(f[f[vb>>2]>>2]|0,cb)|0)|0}Wa=f[jc>>2]|0;f[jc>>2]=(Wa|0)>(kb|0)?kb:Wa;Wa=jc+8|0;Xa=f[Wa>>2]|0;f[Wa>>2]=(Xa|0)<(kb|0)?kb:Xa;Xa=jc+4|0;Wa=f[Xa>>2]|0;f[Xa>>2]=(Wa|0)>(ib|0)?ib:Wa;Wa=jc+12|0;Xa=f[Wa>>2]|0;f[Wa>>2]=(Xa|0)<(ib|0)?ib:Xa;Xa=jc+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=ec+(ic<<4)|0;Wa=Xa;Sa=C1a(f[Wa>>2]|0,f[Wa+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;Wa=Xa;f[Wa>>2]=Sa;f[Wa+4>>2]=J;Wa=ec+(ic<<4)+8|0;Sa=Wa;Xa=C1a(f[Sa>>2]|0,f[Sa+4>>2]|0,ib|0,nb|0)|0;Sa=Wa;f[Sa>>2]=Xa;f[Sa+4>>2]=J;Sa=ob+(_a<<2)|0;if(!(b[qb+_a>>0]|0)){f[Sa>>2]=0;Xa=f[dc>>2]|0;f[dc>>2]=(Xa|0)>(_a|0)?_a:Xa;Xa=dc+8|0;Wa=f[Xa>>2]|0;f[Xa>>2]=(Wa|0)<(_a|0)?_a:Wa;Wa=dc+4|0;Xa=f[Wa>>2]|0;f[Wa>>2]=(Xa|0)>(ib|0)?ib:Xa;Xa=dc+12|0;Wa=f[Xa>>2]|0;f[Xa>>2]=(Wa|0)<(ib|0)?ib:Wa;Wa=dc+16|0;f[Wa>>2]=(f[Wa>>2]|0)+1;Wa=ec;Xa=C1a(f[Wa>>2]|0,f[Wa+4>>2]|0,_a|0,((_a|0)<0)<<31>>31|0)|0;Wa=ec;f[Wa>>2]=Xa;f[Wa+4>>2]=J;Wa=ec+8|0;Xa=Wa;db=C1a(f[Xa>>2]|0,f[Xa+4>>2]|0,ib|0,nb|0)|0;Xa=Wa;f[Xa>>2]=db;f[Xa+4>>2]=J;break}else{f[Sa>>2]=cb;Sa=dc+(Y(f[f[vb>>2]>>2]|0,cb)|0)|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)>(_a|0)?_a:Xa;Xa=Sa+8|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(_a|0)?_a:db;db=Sa+4|0;Xa=f[db>>2]|0;f[db>>2]=(Xa|0)>(ib|0)?ib:Xa;Xa=Sa+12|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(ib|0)?ib:db;db=Sa+16|0;f[db>>2]=(f[db>>2]|0)+1;db=ec+(cb<<4)|0;Sa=db;Xa=C1a(f[Sa>>2]|0,f[Sa+4>>2]|0,_a|0,((_a|0)<0)<<31>>31|0)|0;_a=db;f[_a>>2]=Xa;f[_a+4>>2]=J;_a=ec+(cb<<4)+8|0;cb=_a;Xa=C1a(f[cb>>2]|0,f[cb+4>>2]|0,ib|0,nb|0)|0;cb=_a;f[cb>>2]=Xa;f[cb+4>>2]=J;break}}}else{f[hb>>2]=0;cb=f[ub>>2]|0;Xa=f[cb>>2]|0;f[cb>>2]=(Xa|0)>(kb|0)?kb:Xa;Xa=cb+8|0;_a=f[Xa>>2]|0;f[Xa>>2]=(_a|0)<(kb|0)?kb:_a;_a=cb+4|0;db=f[_a>>2]|0;f[_a>>2]=(db|0)>(sb|0)?sb:db;db=cb+12|0;Sa=f[db>>2]|0;f[db>>2]=(Sa|0)<(sb|0)?sb:Sa;Sa=cb+16|0;f[Sa>>2]=(f[Sa>>2]|0)+1;Wa=f[i>>2]|0;ab=((kb|0)<0)<<31>>31;H=Wa;Ua=C1a(f[H>>2]|0,f[H+4>>2]|0,kb|0,ab|0)|0;H=J;Va=Wa;f[Va>>2]=Ua;f[Va+4>>2]=H;Va=Wa+8|0;bb=Va;$a=C1a(f[bb>>2]|0,f[bb+4>>2]|0,sb|0,jb|0)|0;bb=J;G=Va;f[G>>2]=$a;f[G+4>>2]=bb;G=kb|1;if((G|0)<(f[o>>2]|0)){f[mb+(G<<2)>>2]=0;Za=f[cb>>2]|0;f[cb>>2]=(Za|0)>(G|0)?G:Za;Za=f[Xa>>2]|0;f[Xa>>2]=(Za|0)<(G|0)?G:Za;Za=f[_a>>2]|0;f[_a>>2]=(Za|0)>(sb|0)?sb:Za;Za=f[db>>2]|0;f[db>>2]=(Za|0)<(sb|0)?sb:Za;f[Sa>>2]=(f[Sa>>2]|0)+1;Za=((G|0)<0)<<31>>31;Ya=C1a(Ua|0,H|0,G|0,Za|0)|0;fb=J;Pa=Wa;f[Pa>>2]=Ya;f[Pa+4>>2]=fb;Pa=C1a($a|0,bb|0,sb|0,jb|0)|0;eb=J;Qa=Va;f[Qa>>2]=Pa;f[Qa+4>>2]=eb;if((ib|0)>=(f[j>>2]|0))break;f[ob+(kb<<2)>>2]=0;f[ob+(G<<2)>>2]=0;Qa=f[cb>>2]|0;Ra=(Qa|0)>(kb|0)?kb:Qa;Qa=f[Xa>>2]|0;Ta=(Qa|0)<(kb|0)?kb:Qa;Qa=f[_a>>2]|0;Oa=f[db>>2]|0;Na=f[Sa>>2]|0;Ma=C1a(Ya|0,fb|0,kb|0,ab|0)|0;fb=J;Ya=C1a(Pa|0,eb|0,ib|0,nb|0)|0;eb=J;f[cb>>2]=(Ra|0)>(G|0)?G:Ra;f[Xa>>2]=(Ta|0)<(G|0)?G:Ta;f[_a>>2]=(Qa|0)>(ib|0)?ib:Qa;f[db>>2]=(Oa|0)<(ib|0)?ib:Oa;f[Sa>>2]=Na+2;Na=C1a(Ma|0,fb|0,G|0,Za|0)|0;Za=Wa;f[Za>>2]=Na;f[Za+4>>2]=J;Za=C1a(Ya|0,eb|0,ib|0,nb|0)|0;eb=Va;f[eb>>2]=Za;f[eb+4>>2]=J;break}else{if((ib|0)>=(f[j>>2]|0))break;f[ob+(kb<<2)>>2]=0;eb=f[cb>>2]|0;f[cb>>2]=(eb|0)>(kb|0)?kb:eb;eb=f[Xa>>2]|0;f[Xa>>2]=(eb|0)<(kb|0)?kb:eb;eb=f[_a>>2]|0;f[_a>>2]=(eb|0)>(ib|0)?ib:eb;eb=f[db>>2]|0;f[db>>2]=(eb|0)<(ib|0)?ib:eb;f[Sa>>2]=(f[Sa>>2]|0)+1;Sa=C1a(Ua|0,H|0,kb|0,ab|0)|0;ab=Wa;f[ab>>2]=Sa;f[ab+4>>2]=J;ab=C1a($a|0,bb|0,ib|0,nb|0)|0;bb=Va;f[bb>>2]=ab;f[bb+4>>2]=J;break}}while(0);kb=kb+2|0;kc=f[o>>2]|0}while((kb|0)<(kc|0));lc=kc;mc=f[j>>2]|0}else{lc=pb;mc=tb}sb=sb+2|0;if((sb|0)>=(mc|0))break;else{tb=mc;pb=lc}}}}while(0);lc=g+12|0;if((f[lc>>2]|0)<=0){ZF(n);u=a;return zb|0}mc=f[g+20>>2]|0;j=f[g+48>>2]|0;kc=f[g+120>>2]|0;o=f[g+80>>2]|0;ec=f[g+108>>2]|0;g=0;do{dc=mc+(Y(f[j>>2]|0,g)|0)|0;ic=dc+8|0;f[ic>>2]=(f[ic>>2]|0)+1-(f[dc>>2]|0);ic=dc+12|0;f[ic>>2]=(f[ic>>2]|0)+1-(f[dc+4>>2]|0);ic=o+(Y(f[ec>>2]|0,g)|0)|0;nc=+((f[dc+16>>2]|0)>>>0);dc=kc+(g<<4)|0;p[ic>>3]=(+((f[dc>>2]|0)>>>0)+4294967296.0*+((f[dc+4>>2]|0)>>>0))/nc;dc=kc+(g<<4)+8|0;p[ic+8>>3]=(+((f[dc>>2]|0)>>>0)+4294967296.0*+((f[dc+4>>2]|0)>>>0))/nc;g=g+1|0}while((g|0)<(f[lc>>2]|0));ZF(n);u=a;return zb|0}function L6(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;a=u;u=u+64|0;h=a+48|0;i=a+28|0;j=a;k=c+8|0;l=d+8|0;if((f[k>>2]|0)!=(f[l>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=c$(h,26)|0;n=218300;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,h,373355,218048,2529);d$(h)}q=c+12|0;if((f[q>>2]|0)!=(f[d+12>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=c$(h,26)|0;n=218327;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,h,373355,218048,2530);d$(h)}if((e|0)!=8){f[h>>2]=0;f[h+4>>2]=0;m=c$(h,17)|0;n=218354;o=m+17|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,h,373355,218048,2531);d$(h)}n=bV()|0;e=f[k>>2]|0;k=((f[q>>2]|0)+1|0)/2|0;q=YF(e<<2)|0;r=YF((Y(((e+1|0)/2|0)<<2,k)|0)+4|0)|0;f[r>>2]=0;f[h>>2]=0;f[h+4>>2]=e;f[i>>2]=48920;f[i+4>>2]=c;f[i+8>>2]=d;f[i+12>>2]=r;f[i+16>>2]=q;s=+(n|0);_U(h,i,s);M6(c,d,r,q);f[i>>2]=1;if((e|0)>0){n=0;do{t=n+1|0;v=(Y((t|0)/2|0,k)|0)+1|0;w=f[q+(t<<2)>>2]|0;t=w+v|0;if((w|0)>0){w=v;do{v=r+(w<<2)|0;x=f[v>>2]|0;if((x|0)<(w|0))f[v>>2]=f[r+(x<<2)>>2];else{f[v>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}w=w+1|0}while((w|0)<(t|0))}n=f[q+(n<<2)>>2]|0}while((n|0)<(e|0))}n=e*136|0;k=OYa(e>>>0>31580641|n>>>0>4294967291?-1:n+4|0)|0;f[k>>2]=e;n=k+4|0;if(e|0){t=n+(e*136|0)|0;e=n;do{f[e>>2]=0;f[e+4>>2]=1124007936;w=e+12|0;v=e+44|0;m=e+8|0;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[v>>2]=w;x=e+52|0;f[e+48>>2]=x;f[x>>2]=0;f[e+56>>2]=0;f[e+60>>2]=0;f[e+64>>2]=1124007936;x=e+72|0;y=e+104|0;m=e+68|0;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[y>>2]=x;w=e+112|0;f[e+108>>2]=w;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;f[w+16>>2]=0;f[w+20>>2]=0;e=e+136|0}while((e|0)!=(t|0))}N6(g,f[i>>2]|0);f[j>>2]=48940;f[j+4>>2]=c;f[j+8>>2]=d;f[j+12>>2]=r;f[j+16>>2]=g;f[j+20>>2]=n;f[j+24>>2]=i;_U(h,j,s);j=f[l>>2]|0;l=f[g+132>>2]|0;if((l|0)<(j|0)){h=g+20|0;d=g+48|0;c=g+120|0;t=f[i>>2]|0;e=l;while(1){if((t|0)>0){l=n+(e*136|0)+120|0;m=f[n+(e*136|0)+20>>2]|0;o=f[n+(e*136|0)+48>>2]|0;w=t;v=0;while(1){z=m+(Y(f[o>>2]|0,v)|0)|0;A=z+16|0;if((f[A>>2]|0)>0){B=(f[h>>2]|0)+(Y(f[f[d>>2]>>2]|0,v)|0)|0;C=f[B>>2]|0;D=f[z>>2]|0;f[B>>2]=(C|0)>(D|0)?D:C;C=B+8|0;f[C>>2]=f[((f[C>>2]|0)<(f[z+8>>2]|0)?z:B)+8>>2];C=B+4|0;f[C>>2]=f[((f[C>>2]|0)>(f[z+4>>2]|0)?z:B)+4>>2];C=B+12|0;f[C>>2]=f[((f[C>>2]|0)<(f[z+12>>2]|0)?z:B)+12>>2];z=B+16|0;f[z>>2]=(f[z>>2]|0)+(f[A>>2]|0);A=f[l>>2]|0;z=A+(v<<4)|0;B=f[c>>2]|0;C=B+(v<<4)|0;D=C;E=C1a(f[D>>2]|0,f[D+4>>2]|0,f[z>>2]|0,f[z+4>>2]|0)|0;z=C;f[z>>2]=E;f[z+4>>2]=J;z=A+(v<<4)+8|0;A=B+(v<<4)+8|0;B=A;E=C1a(f[B>>2]|0,f[B+4>>2]|0,f[z>>2]|0,f[z+4>>2]|0)|0;z=A;f[z>>2]=E;f[z+4>>2]=J;F=f[i>>2]|0}else F=w;v=v+1|0;if((v|0)>=(F|0)){G=F;break}else w=F}}else G=t;e=f[n+(e*136|0)+132>>2]|0;if((e|0)>=(j|0))break;else t=G}}G=g+12|0;if((f[G>>2]|0)>0){t=f[g+20>>2]|0;j=f[g+48>>2]|0;e=f[g+120>>2]|0;F=f[g+80>>2]|0;c=f[g+108>>2]|0;g=0;do{d=t+(Y(f[j>>2]|0,g)|0)|0;h=d+8|0;f[h>>2]=(f[h>>2]|0)+1-(f[d>>2]|0);h=d+12|0;f[h>>2]=(f[h>>2]|0)+1-(f[d+4>>2]|0);h=F+(Y(f[c>>2]|0,g)|0)|0;s=+((f[d+16>>2]|0)>>>0);d=e+(g<<4)|0;p[h>>3]=(+((f[d>>2]|0)>>>0)+4294967296.0*+((f[d+4>>2]|0)>>>0))/s;d=e+(g<<4)+8|0;p[h+8>>3]=(+((f[d>>2]|0)>>>0)+4294967296.0*+((f[d+4>>2]|0)>>>0))/s;g=g+1|0}while((g|0)<(f[G>>2]|0))}G=n+((f[k>>2]|0)*136|0)|0;if((n|0)==(G|0)){QYa(k);ZF(q);ZF(r);H=f[i>>2]|0;u=a;return H|0}else I=G;do{I=I+-136|0;F6(I)}while((I|0)!=(n|0));QYa(k);ZF(q);ZF(r);H=f[i>>2]|0;u=a;return H|0}function M6(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=f[c+12>>2]|0;h=f[c+8>>2]|0;i=f[e>>2]|0;if((i|0)>=(h|0))return;j=(g|0)>0;k=g+-1|0;l=g+-2|0;m=f[c+16>>2]|0;n=f[c+44>>2]|0;c=f[a+16>>2]|0;o=f[a+44>>2]|0;a=i;do{i=f[n>>2]|0;p=m+(Y(i,a)|0)|0;q=0-i|0;i=p+q+q|0;q=f[o>>2]|0;r=c+(Y(q,a)|0)|0;s=r+(0-q)|0;if(j){q=0;do{t=p+(q<<2)|0;u=f[t>>2]|0;if((u|0)>0){if((((q|0)>1?(v=f[i+(q+-2<<2)>>2]|0,(v|0)>0):0)?(b[r+q>>0]|0)!=0:0)?(b[s+(q+-1)>>0]|0)!=0:0){w=v;while(1){x=f[d+(w<<2)>>2]|0;if((x|0)<(w|0))w=x;else break}if((v|0)==(u|0))y=w;else{x=u;while(1){z=f[d+(x<<2)>>2]|0;if((z|0)<(x|0))x=z;else break}z=(w|0)>(x|0)?x:w;A=u;do{B=d+(A<<2)|0;C=A;A=f[B>>2]|0;f[B>>2]=z}while((A|0)<(C|0));y=z}z=v;do{A=d+(z<<2)|0;w=z;z=f[A>>2]|0;f[A>>2]=y}while((z|0)<(w|0));f[t>>2]=y;D=y}else D=u;z=f[i+(q<<2)>>2]|0;a:do if((z|0)>0){v=b[r+q>>0]|0;w=v<<24>>24!=0;if((q|0)>=(k|0)){if(!w){E=D;break}if(!(b[s+q>>0]|0)){E=D;break}else F=z;while(1){A=f[d+(F<<2)>>2]|0;if((A|0)<(F|0))F=A;else break}if((z|0)==(D|0))G=F;else{A=D;while(1){x=f[d+(A<<2)>>2]|0;if((x|0)<(A|0))A=x;else break}x=(F|0)>(A|0)?A:F;C=D;do{B=d+(C<<2)|0;H=C;C=f[B>>2]|0;f[B>>2]=x}while((C|0)<(H|0));G=x}x=z;do{C=d+(x<<2)|0;A=x;x=f[C>>2]|0;f[C>>2]=G}while((x|0)<(A|0));f[t>>2]=G;E=G;break}if(w?(b[s+q>>0]|0)!=0:0)I=z;else J=23;do if((J|0)==23){J=0;x=q|1;A=(b[r+x>>0]|0)!=0;if(A?b[s+q>>0]|0:0){I=z;break}if(v<<24>>24?b[s+x>>0]|0:0){I=z;break}if(!A){E=D;break a}if(!(b[s+x>>0]|0)){E=D;break a}else I=z}while(0);while(1){v=f[d+(I<<2)>>2]|0;if((v|0)<(I|0))I=v;else break}if((z|0)==(D|0))K=I;else{v=D;while(1){w=f[d+(v<<2)>>2]|0;if((w|0)<(v|0))v=w;else break}w=(I|0)>(v|0)?v:I;x=D;do{A=d+(x<<2)|0;C=x;x=f[A>>2]|0;f[A>>2]=w}while((x|0)<(C|0));K=w}w=z;do{x=d+(w<<2)|0;v=w;w=f[x>>2]|0;f[x>>2]=K}while((w|0)<(v|0));f[t>>2]=K;E=K}else E=D;while(0);if((((q|0)<(l|0)?(z=q+2|0,u=f[i+(z<<2)>>2]|0,(u|0)>0):0)?b[r+(q|1)>>0]|0:0)?b[s+z>>0]|0:0){z=u;while(1){w=f[d+(z<<2)>>2]|0;if((w|0)<(z|0))z=w;else break}if((u|0)==(E|0))L=z;else{w=E;while(1){v=f[d+(w<<2)>>2]|0;if((v|0)<(w|0))w=v;else break}v=(z|0)>(w|0)?w:z;x=E;do{C=d+(x<<2)|0;A=x;x=f[C>>2]|0;f[C>>2]=v}while((x|0)<(A|0));L=v}v=u;do{x=d+(v<<2)|0;z=v;v=f[x>>2]|0;f[x>>2]=L}while((v|0)<(z|0));f[t>>2]=L}}q=q+2|0}while((q|0)<(g|0))}a=f[e+(a<<2)>>2]|0}while((a|0)<(h|0));return}function N6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+80|0;d=c+64|0;e=c;g=c+56|0;h=f[a>>2]|0;f[d>>2]=5;f[d+4>>2]=b;KS(h,d,4,-1,0,0);d=f[a>>2]|0;do if((NS(d)|0)==65536){h=f[d+4>>2]|0;f[e>>2]=f[h>>2];i=e+4|0;j=h+4|0;f[i>>2]=f[j>>2];k=e+8|0;f[k>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[e+16>>2]=f[h+16>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];l=f[h+36>>2]|0;f[e+36>>2]=l;f[e+40>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[h+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];break}else{f[i>>2]=0;BR(e,h);break}}else OR(e,d,-1);while(0);d=a+4|0;h=e+36|0;i=f[h>>2]|0;if((d|0)==(e|0))n=i;else{if(i|0){j=i+12|0;f[j>>2]=(f[j>>2]|0)+1}j=a+40|0;i=f[j>>2]|0;if(i|0?(k=i+12|0,i=f[k>>2]|0,f[k>>2]=i+-1,(i|0)==1):0)CR(d);f[j>>2]=0;i=a+20|0;k=a+8|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[k>>2]|0)>0){m=f[a+44>>2]|0;l=0;do{f[m+(l<<2)>>2]=0;l=l+1|0;o=f[k>>2]|0}while((l|0)<(o|0));f[d>>2]=f[e>>2];if((o|0)<3)p=19;else p=21}else{f[d>>2]=f[e>>2];p=19}if((p|0)==19){o=f[e+4>>2]|0;if((o|0)<3){f[k>>2]=o;f[a+12>>2]=f[e+8>>2];f[a+16>>2]=f[e+12>>2];o=f[e+44>>2]|0;k=f[a+48>>2]|0;f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2]}else p=21}if((p|0)==21)BR(d,e);f[i>>2]=f[e+16>>2];f[a+24>>2]=f[e+20>>2];f[a+28>>2]=f[e+24>>2];f[a+32>>2]=f[e+28>>2];f[a+36>>2]=f[e+32>>2];i=f[h>>2]|0;f[j>>2]=i;n=i}if(n|0?(i=n+12|0,n=f[i>>2]|0,f[i>>2]=n+-1,(n|0)==1):0)CR(e);f[h>>2]=0;h=e+16|0;n=e+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[n>>2]|0)>0){h=f[e+40>>2]|0;i=0;do{f[h+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[n>>2]|0))}n=f[e+44>>2]|0;if((n|0)!=(e+48|0))ZF(n);n=a+60|0;i=f[n>>2]|0;f[g>>2]=2;f[g+4>>2]=b;KS(i,g,6,-1,0,0);g=f[n>>2]|0;do if((NS(g)|0)==65536){n=f[g+4>>2]|0;f[e>>2]=f[n>>2];i=e+4|0;h=n+4|0;f[i>>2]=f[h>>2];j=e+8|0;f[j>>2]=f[n+8>>2];f[e+12>>2]=f[n+12>>2];f[e+16>>2]=f[n+16>>2];f[e+20>>2]=f[n+20>>2];f[e+24>>2]=f[n+24>>2];f[e+28>>2]=f[n+28>>2];f[e+32>>2]=f[n+32>>2];d=f[n+36>>2]|0;f[e+36>>2]=d;f[e+40>>2]=j;j=e+48|0;o=e+44|0;f[o>>2]=j;f[j>>2]=0;f[e+52>>2]=0;if(d|0){j=d+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[h>>2]|0)<3){h=f[n+44>>2]|0;j=f[o>>2]|0;f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];break}else{f[i>>2]=0;BR(e,n);break}}else OR(e,g,-1);while(0);g=a+64|0;n=e+36|0;i=f[n>>2]|0;if((g|0)==(e|0))q=i;else{if(i|0){h=i+12|0;f[h>>2]=(f[h>>2]|0)+1}h=a+100|0;i=f[h>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)CR(g);f[h>>2]=0;i=a+80|0;j=a+68|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[j>>2]|0)>0){o=f[a+104>>2]|0;d=0;do{f[o+(d<<2)>>2]=0;d=d+1|0;r=f[j>>2]|0}while((d|0)<(r|0));f[g>>2]=f[e>>2];if((r|0)<3)p=49;else p=51}else{f[g>>2]=f[e>>2];p=49}if((p|0)==49){r=f[e+4>>2]|0;if((r|0)<3){f[j>>2]=r;f[a+72>>2]=f[e+8>>2];f[a+76>>2]=f[e+12>>2];r=f[e+44>>2]|0;j=f[a+108>>2]|0;f[j>>2]=f[r>>2];f[j+4>>2]=f[r+4>>2]}else p=51}if((p|0)==51)BR(g,e);f[i>>2]=f[e+16>>2];f[a+84>>2]=f[e+20>>2];f[a+88>>2]=f[e+24>>2];f[a+92>>2]=f[e+28>>2];f[a+96>>2]=f[e+32>>2];i=f[n>>2]|0;f[h>>2]=i;q=i}if(q|0?(i=q+12|0,q=f[i>>2]|0,f[i>>2]=q+-1,(q|0)==1):0)CR(e);f[n>>2]=0;n=e+16|0;q=e+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[q>>2]|0)>0){n=f[e+40>>2]|0;i=0;do{f[n+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[q>>2]|0))}q=f[e+44>>2]|0;if((q|0)!=(e+48|0))ZF(q);if((b|0)>0){q=f[a+20>>2]|0;i=f[a+48>>2]|0;n=0;do{h=q+(Y(f[i>>2]|0,n)|0)|0;f[h>>2]=2147483647;f[h+4>>2]=2147483647;f[h+8>>2]=-2147483648;f[h+12>>2]=-2147483648;f[h+16>>2]=0;n=n+1|0}while((n|0)!=(b|0))}n=a+120|0;i=a+124|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;a=f[i>>2]|0;q=f[n>>2]|0;h=a-q>>4;g=a;if(h>>>0<b>>>0){R6(n,b-h|0,e);u=c;return}if(h>>>0<=b>>>0){u=c;return}h=q+(b<<4)|0;if((g|0)==(h|0)){u=c;return}f[i>>2]=g+(~((g+-16-h|0)>>>4)<<4);u=c;return}function O6(a){a=a|0;PYa(a);return}function P6(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0;d=f[c>>2]|0;e=((d|0)%2|0)+d|0;d=f[c+4>>2]|0;c=((d|0)%2|0)+d|0;if((e|0)>0){d=a+20|0;Q6((f[d>>2]|0)+(e*136|0)|0,f[f[a+24>>2]>>2]|0);g=f[d>>2]|0;f[g+(e*136|0)+132>>2]=c;d=a+8|0;h=f[d>>2]|0;i=f[h+12>>2]|0;j=(i&1|0)!=0;k=(e|0)<(c|0);if(!(f[h+8>>2]&1)){if(!j){if(!k)return;l=a+4|0;m=a+12|0;n=g+(e*136|0)+20|0;o=g+(e*136|0)+120|0;p=g+(e*136|0)+20|0;q=g+(e*136|0)+48|0;r=g+(e*136|0)+48|0;s=g+(e*136|0)+48|0;t=g+(e*136|0)+20|0;u=g+(e*136|0)+48|0;v=g+(e*136|0)+120|0;w=g+(e*136|0)+20|0;x=g+(e*136|0)+120|0;y=i;z=e;A=h;while(1){B=f[l>>2]|0;C=f[f[B+44>>2]>>2]|0;D=(f[B+16>>2]|0)+(Y(C,z)|0)|0;B=D+C|0;C=f[f[A+44>>2]>>2]|0;E=(f[A+16>>2]|0)+(Y(C,z)|0)|0;F=E+C|0;if((y|0)>0){C=((z|0)<0)<<31>>31;G=z+1|0;H=((G|0)<0)<<31>>31;I=0;do{K=E+(I<<2)|0;L=f[K>>2]|0;do if((L|0)>0){M=f[(f[m>>2]|0)+(L<<2)>>2]|0;if(!(b[D+I>>0]|0)){f[K>>2]=0;N=f[n>>2]|0;O=f[N>>2]|0;f[N>>2]=(O|0)>(I|0)?I:O;O=N+8|0;P=f[O>>2]|0;f[O>>2]=(P|0)<(I|0)?I:P;P=N+4|0;O=f[P>>2]|0;f[P>>2]=(O|0)>(z|0)?z:O;O=N+12|0;P=f[O>>2]|0;f[O>>2]=(P|0)<(z|0)?z:P;P=N+16|0;f[P>>2]=(f[P>>2]|0)+1;P=f[o>>2]|0;O=P;Q=C1a(f[O>>2]|0,f[O+4>>2]|0,I|0,((I|0)<0)<<31>>31|0)|0;O=P;f[O>>2]=Q;f[O+4>>2]=J;R=P;S=N;T=P+8|0}else{f[K>>2]=M;P=f[t>>2]|0;N=P+(Y(f[f[u>>2]>>2]|0,M)|0)|0;O=f[N>>2]|0;f[N>>2]=(O|0)>(I|0)?I:O;O=N+8|0;Q=f[O>>2]|0;f[O>>2]=(Q|0)<(I|0)?I:Q;Q=N+4|0;O=f[Q>>2]|0;f[Q>>2]=(O|0)>(z|0)?z:O;O=N+12|0;Q=f[O>>2]|0;f[O>>2]=(Q|0)<(z|0)?z:Q;Q=N+16|0;f[Q>>2]=(f[Q>>2]|0)+1;Q=f[v>>2]|0;N=Q+(M<<4)|0;O=N;U=C1a(f[O>>2]|0,f[O+4>>2]|0,I|0,((I|0)<0)<<31>>31|0)|0;O=N;f[O>>2]=U;f[O+4>>2]=J;R=Q;S=P;T=Q+(M<<4)+8|0}Q=T;P=C1a(f[Q>>2]|0,f[Q+4>>2]|0,z|0,C|0)|0;Q=T;f[Q>>2]=P;f[Q+4>>2]=J;Q=I|1;P=E+(Q<<2)|0;if(!(b[D+Q>>0]|0)){f[P>>2]=0;V=0;W=S}else{f[P>>2]=M;V=M;W=S+(Y(f[f[s>>2]>>2]|0,M)|0)|0}P=f[W>>2]|0;f[W>>2]=(P|0)>(Q|0)?Q:P;P=W+8|0;O=f[P>>2]|0;f[P>>2]=(O|0)<(Q|0)?Q:O;O=W+4|0;P=f[O>>2]|0;f[O>>2]=(P|0)>(z|0)?z:P;P=W+12|0;O=f[P>>2]|0;f[P>>2]=(O|0)<(z|0)?z:O;O=W+16|0;f[O>>2]=(f[O>>2]|0)+1;O=R+(V<<4)|0;P=O;U=C1a(f[P>>2]|0,f[P+4>>2]|0,Q|0,((Q|0)<0)<<31>>31|0)|0;P=O;f[P>>2]=U;f[P+4>>2]=J;P=R+(V<<4)+8|0;U=P;O=C1a(f[U>>2]|0,f[U+4>>2]|0,z|0,C|0)|0;U=P;f[U>>2]=O;f[U+4>>2]=J;U=F+(I<<2)|0;if(!(b[B+I>>0]|0)){f[U>>2]=0;X=0;Z=S}else{f[U>>2]=M;X=M;Z=S+(Y(f[f[r>>2]>>2]|0,M)|0)|0}U=f[Z>>2]|0;f[Z>>2]=(U|0)>(I|0)?I:U;U=Z+8|0;O=f[U>>2]|0;f[U>>2]=(O|0)<(I|0)?I:O;O=Z+4|0;U=f[O>>2]|0;f[O>>2]=(U|0)>(G|0)?G:U;U=Z+12|0;O=f[U>>2]|0;f[U>>2]=(O|0)<(G|0)?G:O;O=Z+16|0;f[O>>2]=(f[O>>2]|0)+1;O=R+(X<<4)|0;U=O;P=C1a(f[U>>2]|0,f[U+4>>2]|0,I|0,((I|0)<0)<<31>>31|0)|0;U=O;f[U>>2]=P;f[U+4>>2]=J;U=R+(X<<4)+8|0;P=U;O=C1a(f[P>>2]|0,f[P+4>>2]|0,G|0,H|0)|0;P=U;f[P>>2]=O;f[P+4>>2]=J;P=F+(Q<<2)|0;O=f[p>>2]|0;if(!(b[B+Q>>0]|0)){f[P>>2]=0;U=f[O>>2]|0;f[O>>2]=(U|0)>(Q|0)?Q:U;U=O+8|0;N=f[U>>2]|0;f[U>>2]=(N|0)<(Q|0)?Q:N;N=O+4|0;U=f[N>>2]|0;f[N>>2]=(U|0)>(G|0)?G:U;U=O+12|0;N=f[U>>2]|0;f[U>>2]=(N|0)<(G|0)?G:N;N=O+16|0;f[N>>2]=(f[N>>2]|0)+1;N=R;U=C1a(f[N>>2]|0,f[N+4>>2]|0,Q|0,((Q|0)<0)<<31>>31|0)|0;N=R;f[N>>2]=U;f[N+4>>2]=J;_=R+8|0;break}else{f[P>>2]=M;P=O+(Y(f[f[q>>2]>>2]|0,M)|0)|0;O=f[P>>2]|0;f[P>>2]=(O|0)>(Q|0)?Q:O;O=P+8|0;N=f[O>>2]|0;f[O>>2]=(N|0)<(Q|0)?Q:N;N=P+4|0;O=f[N>>2]|0;f[N>>2]=(O|0)>(G|0)?G:O;O=P+12|0;N=f[O>>2]|0;f[O>>2]=(N|0)<(G|0)?G:N;N=P+16|0;f[N>>2]=(f[N>>2]|0)+1;N=R+(M<<4)|0;P=N;O=C1a(f[P>>2]|0,f[P+4>>2]|0,Q|0,((Q|0)<0)<<31>>31|0)|0;Q=N;f[Q>>2]=O;f[Q+4>>2]=J;_=R+(M<<4)+8|0;break}}else{f[K>>2]=0;M=I|1;f[E+(M<<2)>>2]=0;f[F+(I<<2)>>2]=0;f[F+(M<<2)>>2]=0;Q=f[w>>2]|0;O=f[Q>>2]|0;N=(O|0)>(I|0)?I:O;O=Q+8|0;P=f[O>>2]|0;U=(P|0)<(I|0)?I:P;P=Q+4|0;$=f[P>>2]|0;aa=($|0)>(z|0)?z:$;$=Q+12|0;ba=f[$>>2]|0;ca=(ba|0)<(z|0)?z:ba;ba=Q+16|0;da=f[ba>>2]|0;ea=f[x>>2]|0;fa=((I|0)<0)<<31>>31;ga=ea;ha=C1a(f[ga>>2]|0,f[ga+4>>2]|0,I|0,fa|0)|0;ga=J;ia=ea+8|0;ja=ia;ka=C1a(f[ja>>2]|0,f[ja+4>>2]|0,z|0,C|0)|0;ja=J;la=(N|0)>(M|0)?M:N;N=((M|0)<0)<<31>>31;ma=C1a(ha|0,ga|0,M|0,N|0)|0;ga=J;ha=C1a(ka|0,ja|0,z|0,C|0)|0;ja=J;ka=C1a(ma|0,ga|0,I|0,fa|0)|0;fa=J;ga=C1a(ha|0,ja|0,G|0,H|0)|0;ja=ia;f[ja>>2]=ga;f[ja+4>>2]=J;f[Q>>2]=(la|0)>(I|0)?I:la;f[O>>2]=(U|0)<(M|0)?M:U;f[P>>2]=(aa|0)>(G|0)?G:aa;f[$>>2]=(ca|0)<(G|0)?G:ca;f[ba>>2]=da+4;da=C1a(ka|0,fa|0,M|0,N|0)|0;N=ea;f[N>>2]=da;f[N+4>>2]=J;_=ia}while(0);K=_;L=C1a(f[K>>2]|0,f[K+4>>2]|0,G|0,H|0)|0;K=_;f[K>>2]=L;f[K+4>>2]=J;I=I+2|0;K=f[d>>2]|0;L=f[K+12>>2]|0}while((I|0)<(L|0));na=L;oa=K}else{na=y;oa=A}z=z+2|0;if((z|0)>=(c|0))break;else{y=na;A=oa}}return}if(!k)return;oa=a+4|0;A=a+12|0;na=g+(e*136|0)+20|0;y=g+(e*136|0)+120|0;z=g+(e*136|0)+20|0;_=g+(e*136|0)+48|0;x=g+(e*136|0)+48|0;w=g+(e*136|0)+48|0;R=g+(e*136|0)+20|0;q=g+(e*136|0)+48|0;p=g+(e*136|0)+120|0;X=g+(e*136|0)+20|0;Z=g+(e*136|0)+120|0;r=i;S=e;V=h;while(1){W=f[oa>>2]|0;s=f[f[W+44>>2]>>2]|0;T=(f[W+16>>2]|0)+(Y(s,S)|0)|0;W=T+s|0;s=f[f[V+44>>2]>>2]|0;v=(f[V+16>>2]|0)+(Y(s,S)|0)|0;u=v+s|0;if((r|0)>0){s=((S|0)<0)<<31>>31;t=S+1|0;o=((t|0)<0)<<31>>31;n=0;do{m=v+(n<<2)|0;l=f[m>>2]|0;do if((l|0)>0){I=f[(f[A>>2]|0)+(l<<2)>>2]|0;if(!(b[T+n>>0]|0)){f[m>>2]=0;H=f[na>>2]|0;G=f[H>>2]|0;f[H>>2]=(G|0)>(n|0)?n:G;G=H+8|0;C=f[G>>2]|0;f[G>>2]=(C|0)<(n|0)?n:C;C=H+4|0;G=f[C>>2]|0;f[C>>2]=(G|0)>(S|0)?S:G;G=H+12|0;C=f[G>>2]|0;f[G>>2]=(C|0)<(S|0)?S:C;C=H+16|0;f[C>>2]=(f[C>>2]|0)+1;C=f[y>>2]|0;G=C;F=C1a(f[G>>2]|0,f[G+4>>2]|0,n|0,((n|0)<0)<<31>>31|0)|0;G=C;f[G>>2]=F;f[G+4>>2]=J;pa=H;qa=C;ra=C+8|0}else{f[m>>2]=I;C=f[R>>2]|0;H=C+(Y(f[f[q>>2]>>2]|0,I)|0)|0;G=f[H>>2]|0;f[H>>2]=(G|0)>(n|0)?n:G;G=H+8|0;F=f[G>>2]|0;f[G>>2]=(F|0)<(n|0)?n:F;F=H+4|0;G=f[F>>2]|0;f[F>>2]=(G|0)>(S|0)?S:G;G=H+12|0;F=f[G>>2]|0;f[G>>2]=(F|0)<(S|0)?S:F;F=H+16|0;f[F>>2]=(f[F>>2]|0)+1;F=f[p>>2]|0;H=F+(I<<4)|0;G=H;E=C1a(f[G>>2]|0,f[G+4>>2]|0,n|0,((n|0)<0)<<31>>31|0)|0;G=H;f[G>>2]=E;f[G+4>>2]=J;pa=C;qa=F;ra=F+(I<<4)+8|0}F=ra;C=C1a(f[F>>2]|0,f[F+4>>2]|0,S|0,s|0)|0;F=ra;f[F>>2]=C;f[F+4>>2]=J;F=u+(n<<2)|0;if(!(b[W+n>>0]|0)){f[F>>2]=0;sa=0;ta=pa}else{f[F>>2]=I;sa=I;ta=pa+(Y(f[f[w>>2]>>2]|0,I)|0)|0}F=f[ta>>2]|0;f[ta>>2]=(F|0)>(n|0)?n:F;F=ta+8|0;C=f[F>>2]|0;f[F>>2]=(C|0)<(n|0)?n:C;C=ta+4|0;F=f[C>>2]|0;f[C>>2]=(F|0)>(t|0)?t:F;F=ta+12|0;C=f[F>>2]|0;f[F>>2]=(C|0)<(t|0)?t:C;C=ta+16|0;f[C>>2]=(f[C>>2]|0)+1;C=qa+(sa<<4)|0;F=C;G=C1a(f[F>>2]|0,f[F+4>>2]|0,n|0,((n|0)<0)<<31>>31|0)|0;F=C;f[F>>2]=G;f[F+4>>2]=J;F=qa+(sa<<4)+8|0;G=F;C=C1a(f[G>>2]|0,f[G+4>>2]|0,t|0,o|0)|0;G=F;f[G>>2]=C;f[G+4>>2]=J;G=n|1;if((G|0)<(f[(f[d>>2]|0)+12>>2]|0)){C=v+(G<<2)|0;if(!(b[T+G>>0]|0)){f[C>>2]=0;ua=0;va=pa}else{f[C>>2]=I;ua=I;va=pa+(Y(f[f[x>>2]>>2]|0,I)|0)|0}C=f[va>>2]|0;f[va>>2]=(C|0)>(G|0)?G:C;C=va+8|0;F=f[C>>2]|0;f[C>>2]=(F|0)<(G|0)?G:F;F=va+4|0;C=f[F>>2]|0;f[F>>2]=(C|0)>(S|0)?S:C;C=va+12|0;F=f[C>>2]|0;f[C>>2]=(F|0)<(S|0)?S:F;F=va+16|0;f[F>>2]=(f[F>>2]|0)+1;F=qa+(ua<<4)|0;C=F;E=C1a(f[C>>2]|0,f[C+4>>2]|0,G|0,((G|0)<0)<<31>>31|0)|0;C=F;f[C>>2]=E;f[C+4>>2]=J;C=qa+(ua<<4)+8|0;E=C;F=C1a(f[E>>2]|0,f[E+4>>2]|0,S|0,s|0)|0;E=C;f[E>>2]=F;f[E+4>>2]=J;E=u+(G<<2)|0;F=f[z>>2]|0;if(!(b[W+G>>0]|0)){f[E>>2]=0;C=f[F>>2]|0;f[F>>2]=(C|0)>(G|0)?G:C;C=F+8|0;H=f[C>>2]|0;f[C>>2]=(H|0)<(G|0)?G:H;H=F+4|0;C=f[H>>2]|0;f[H>>2]=(C|0)>(t|0)?t:C;C=F+12|0;H=f[C>>2]|0;f[C>>2]=(H|0)<(t|0)?t:H;H=F+16|0;f[H>>2]=(f[H>>2]|0)+1;H=qa;C=C1a(f[H>>2]|0,f[H+4>>2]|0,G|0,((G|0)<0)<<31>>31|0)|0;H=qa;f[H>>2]=C;f[H+4>>2]=J;H=qa+8|0;C=H;B=C1a(f[C>>2]|0,f[C+4>>2]|0,t|0,o|0)|0;C=H;f[C>>2]=B;f[C+4>>2]=J;break}else{f[E>>2]=I;E=F+(Y(f[f[_>>2]>>2]|0,I)|0)|0;F=f[E>>2]|0;f[E>>2]=(F|0)>(G|0)?G:F;F=E+8|0;C=f[F>>2]|0;f[F>>2]=(C|0)<(G|0)?G:C;C=E+4|0;F=f[C>>2]|0;f[C>>2]=(F|0)>(t|0)?t:F;F=E+12|0;C=f[F>>2]|0;f[F>>2]=(C|0)<(t|0)?t:C;C=E+16|0;f[C>>2]=(f[C>>2]|0)+1;C=qa+(I<<4)|0;E=C;F=C1a(f[E>>2]|0,f[E+4>>2]|0,G|0,((G|0)<0)<<31>>31|0)|0;G=C;f[G>>2]=F;f[G+4>>2]=J;G=qa+(I<<4)+8|0;I=G;F=C1a(f[I>>2]|0,f[I+4>>2]|0,t|0,o|0)|0;I=G;f[I>>2]=F;f[I+4>>2]=J;break}}}else{f[m>>2]=0;f[u+(n<<2)>>2]=0;I=f[X>>2]|0;F=f[I>>2]|0;G=I+8|0;C=f[G>>2]|0;E=I+4|0;B=f[E>>2]|0;H=(B|0)>(S|0)?S:B;B=I+12|0;D=f[B>>2]|0;K=(D|0)<(S|0)?S:D;D=I+16|0;L=f[D>>2]|0;ia=f[Z>>2]|0;N=((n|0)<0)<<31>>31;da=ia;ea=C1a(f[da>>2]|0,f[da+4>>2]|0,n|0,N|0)|0;da=J;M=ia+8|0;fa=M;ka=C1a(f[fa>>2]|0,f[fa+4>>2]|0,S|0,s|0)|0;fa=J;f[I>>2]=(F|0)>(n|0)?n:F;f[G>>2]=(C|0)<(n|0)?n:C;f[E>>2]=(H|0)>(t|0)?t:H;f[B>>2]=(K|0)<(t|0)?t:K;f[D>>2]=L+2;L=C1a(ea|0,da|0,n|0,N|0)|0;N=J;da=ia;f[da>>2]=L;f[da+4>>2]=N;da=C1a(ka|0,fa|0,t|0,o|0)|0;fa=J;ka=M;f[ka>>2]=da;f[ka+4>>2]=fa;ka=n|1;if((ka|0)<(f[(f[d>>2]|0)+12>>2]|0)){f[v+(ka<<2)>>2]=0;f[u+(ka<<2)>>2]=0;ea=f[I>>2]|0;K=f[G>>2]|0;H=f[E>>2]|0;C=(H|0)>(S|0)?S:H;H=f[B>>2]|0;F=(H|0)<(S|0)?S:H;H=f[D>>2]|0;ba=((ka|0)<0)<<31>>31;ca=C1a(L|0,N|0,ka|0,ba|0)|0;N=J;L=C1a(da|0,fa|0,S|0,s|0)|0;fa=J;f[I>>2]=(ea|0)>(ka|0)?ka:ea;f[G>>2]=(K|0)<(ka|0)?ka:K;f[E>>2]=(C|0)>(t|0)?t:C;f[B>>2]=(F|0)<(t|0)?t:F;f[D>>2]=H+2;H=C1a(ca|0,N|0,ka|0,ba|0)|0;ba=ia;f[ba>>2]=H;f[ba+4>>2]=J;ba=C1a(L|0,fa|0,t|0,o|0)|0;fa=M;f[fa>>2]=ba;f[fa+4>>2]=J}}while(0);n=n+2|0;m=f[d>>2]|0;l=f[m+12>>2]|0}while((n|0)<(l|0));wa=l;xa=m}else{wa=r;xa=V}S=S+2|0;if((S|0)>=(c|0))break;else{r=wa;V=xa}}return}if(!j){if(!k)return;j=a+4|0;xa=a+12|0;V=g+(e*136|0)+20|0;wa=g+(e*136|0)+120|0;r=g+(e*136|0)+20|0;S=g+(e*136|0)+48|0;Z=g+(e*136|0)+48|0;X=g+(e*136|0)+48|0;qa=g+(e*136|0)+20|0;_=g+(e*136|0)+48|0;z=g+(e*136|0)+120|0;ua=g+(e*136|0)+20|0;va=g+(e*136|0)+120|0;x=i;pa=e;sa=h;while(1){ta=f[j>>2]|0;w=f[f[ta+44>>2]>>2]|0;ra=(f[ta+16>>2]|0)+(Y(w,pa)|0)|0;ta=ra+w|0;w=f[f[sa+44>>2]>>2]|0;p=(f[sa+16>>2]|0)+(Y(w,pa)|0)|0;q=p+w|0;if((x|0)>0){w=((pa|0)<0)<<31>>31;R=pa+1|0;y=((R|0)<0)<<31>>31;na=0;do{A=p+(na<<2)|0;oa=f[A>>2]|0;do if((oa|0)>0){n=f[(f[xa>>2]|0)+(oa<<2)>>2]|0;if(!(b[ra+na>>0]|0)){f[A>>2]=0;o=f[V>>2]|0;t=f[o>>2]|0;f[o>>2]=(t|0)>(na|0)?na:t;t=o+8|0;s=f[t>>2]|0;f[t>>2]=(s|0)<(na|0)?na:s;s=o+4|0;t=f[s>>2]|0;f[s>>2]=(t|0)>(pa|0)?pa:t;t=o+12|0;s=f[t>>2]|0;f[t>>2]=(s|0)<(pa|0)?pa:s;s=o+16|0;f[s>>2]=(f[s>>2]|0)+1;s=f[wa>>2]|0;t=s;u=C1a(f[t>>2]|0,f[t+4>>2]|0,na|0,((na|0)<0)<<31>>31|0)|0;t=s;f[t>>2]=u;f[t+4>>2]=J;ya=o;za=s;Aa=s+8|0}else{f[A>>2]=n;s=f[qa>>2]|0;o=s+(Y(f[f[_>>2]>>2]|0,n)|0)|0;t=f[o>>2]|0;f[o>>2]=(t|0)>(na|0)?na:t;t=o+8|0;u=f[t>>2]|0;f[t>>2]=(u|0)<(na|0)?na:u;u=o+4|0;t=f[u>>2]|0;f[u>>2]=(t|0)>(pa|0)?pa:t;t=o+12|0;u=f[t>>2]|0;f[t>>2]=(u|0)<(pa|0)?pa:u;u=o+16|0;f[u>>2]=(f[u>>2]|0)+1;u=f[z>>2]|0;o=u+(n<<4)|0;t=o;v=C1a(f[t>>2]|0,f[t+4>>2]|0,na|0,((na|0)<0)<<31>>31|0)|0;t=o;f[t>>2]=v;f[t+4>>2]=J;ya=s;za=u;Aa=u+(n<<4)+8|0}u=Aa;s=C1a(f[u>>2]|0,f[u+4>>2]|0,pa|0,w|0)|0;u=Aa;f[u>>2]=s;f[u+4>>2]=J;u=na|1;s=p+(u<<2)|0;if(!(b[ra+u>>0]|0)){f[s>>2]=0;Ba=0;Ca=ya}else{f[s>>2]=n;Ba=n;Ca=ya+(Y(f[f[X>>2]>>2]|0,n)|0)|0}s=f[Ca>>2]|0;f[Ca>>2]=(s|0)>(u|0)?u:s;s=Ca+8|0;t=f[s>>2]|0;f[s>>2]=(t|0)<(u|0)?u:t;t=Ca+4|0;s=f[t>>2]|0;f[t>>2]=(s|0)>(pa|0)?pa:s;s=Ca+12|0;t=f[s>>2]|0;f[s>>2]=(t|0)<(pa|0)?pa:t;t=Ca+16|0;f[t>>2]=(f[t>>2]|0)+1;t=za+(Ba<<4)|0;s=t;v=C1a(f[s>>2]|0,f[s+4>>2]|0,u|0,((u|0)<0)<<31>>31|0)|0;s=t;f[s>>2]=v;f[s+4>>2]=J;s=za+(Ba<<4)+8|0;v=s;t=C1a(f[v>>2]|0,f[v+4>>2]|0,pa|0,w|0)|0;v=s;f[v>>2]=t;f[v+4>>2]=J;if((R|0)<(f[(f[d>>2]|0)+8>>2]|0)){v=q+(na<<2)|0;if(!(b[ta+na>>0]|0)){f[v>>2]=0;Da=0;Ea=ya}else{f[v>>2]=n;Da=n;Ea=ya+(Y(f[f[Z>>2]>>2]|0,n)|0)|0}v=f[Ea>>2]|0;f[Ea>>2]=(v|0)>(na|0)?na:v;v=Ea+8|0;t=f[v>>2]|0;f[v>>2]=(t|0)<(na|0)?na:t;t=Ea+4|0;v=f[t>>2]|0;f[t>>2]=(v|0)>(R|0)?R:v;v=Ea+12|0;t=f[v>>2]|0;f[v>>2]=(t|0)<(R|0)?R:t;t=Ea+16|0;f[t>>2]=(f[t>>2]|0)+1;t=za+(Da<<4)|0;v=t;s=C1a(f[v>>2]|0,f[v+4>>2]|0,na|0,((na|0)<0)<<31>>31|0)|0;v=t;f[v>>2]=s;f[v+4>>2]=J;v=za+(Da<<4)+8|0;s=v;t=C1a(f[s>>2]|0,f[s+4>>2]|0,R|0,y|0)|0;s=v;f[s>>2]=t;f[s+4>>2]=J;s=q+(u<<2)|0;t=f[r>>2]|0;if(!(b[ta+u>>0]|0)){f[s>>2]=0;v=f[t>>2]|0;f[t>>2]=(v|0)>(u|0)?u:v;v=t+8|0;o=f[v>>2]|0;f[v>>2]=(o|0)<(u|0)?u:o;o=t+4|0;v=f[o>>2]|0;f[o>>2]=(v|0)>(R|0)?R:v;v=t+12|0;o=f[v>>2]|0;f[v>>2]=(o|0)<(R|0)?R:o;o=t+16|0;f[o>>2]=(f[o>>2]|0)+1;o=za;v=C1a(f[o>>2]|0,f[o+4>>2]|0,u|0,((u|0)<0)<<31>>31|0)|0;o=za;f[o>>2]=v;f[o+4>>2]=J;o=za+8|0;v=o;W=C1a(f[v>>2]|0,f[v+4>>2]|0,R|0,y|0)|0;v=o;f[v>>2]=W;f[v+4>>2]=J;break}else{f[s>>2]=n;s=t+(Y(f[f[S>>2]>>2]|0,n)|0)|0;t=f[s>>2]|0;f[s>>2]=(t|0)>(u|0)?u:t;t=s+8|0;v=f[t>>2]|0;f[t>>2]=(v|0)<(u|0)?u:v;v=s+4|0;t=f[v>>2]|0;f[v>>2]=(t|0)>(R|0)?R:t;t=s+12|0;v=f[t>>2]|0;f[t>>2]=(v|0)<(R|0)?R:v;v=s+16|0;f[v>>2]=(f[v>>2]|0)+1;v=za+(n<<4)|0;s=v;t=C1a(f[s>>2]|0,f[s+4>>2]|0,u|0,((u|0)<0)<<31>>31|0)|0;u=v;f[u>>2]=t;f[u+4>>2]=J;u=za+(n<<4)+8|0;n=u;t=C1a(f[n>>2]|0,f[n+4>>2]|0,R|0,y|0)|0;n=u;f[n>>2]=t;f[n+4>>2]=J;break}}}else{f[A>>2]=0;n=na|1;f[p+(n<<2)>>2]=0;t=f[ua>>2]|0;u=f[t>>2]|0;v=(u|0)>(na|0)?na:u;u=t+8|0;s=f[u>>2]|0;W=(s|0)<(na|0)?na:s;s=t+4|0;o=f[s>>2]|0;T=t+12|0;m=f[T>>2]|0;l=t+16|0;fa=f[l>>2]|0;ba=f[va>>2]|0;M=((na|0)<0)<<31>>31;L=ba;H=C1a(f[L>>2]|0,f[L+4>>2]|0,na|0,M|0)|0;L=J;ia=ba+8|0;ka=ia;N=C1a(f[ka>>2]|0,f[ka+4>>2]|0,pa|0,w|0)|0;ka=J;f[t>>2]=(v|0)>(n|0)?n:v;f[u>>2]=(W|0)<(n|0)?n:W;f[s>>2]=(o|0)>(pa|0)?pa:o;f[T>>2]=(m|0)<(pa|0)?pa:m;f[l>>2]=fa+2;fa=((n|0)<0)<<31>>31;m=C1a(H|0,L|0,n|0,fa|0)|0;L=J;H=ba;f[H>>2]=m;f[H+4>>2]=L;H=C1a(N|0,ka|0,pa|0,w|0)|0;ka=J;N=ia;f[N>>2]=H;f[N+4>>2]=ka;if((R|0)<(f[(f[d>>2]|0)+8>>2]|0)){f[q+(na<<2)>>2]=0;f[q+(n<<2)>>2]=0;N=f[t>>2]|0;o=(N|0)>(na|0)?na:N;N=f[u>>2]|0;W=(N|0)<(na|0)?na:N;N=f[s>>2]|0;v=f[T>>2]|0;ca=f[l>>2]|0;D=C1a(m|0,L|0,na|0,M|0)|0;M=J;L=C1a(H|0,ka|0,R|0,y|0)|0;ka=J;f[t>>2]=(o|0)>(n|0)?n:o;f[u>>2]=(W|0)<(n|0)?n:W;f[s>>2]=(N|0)>(R|0)?R:N;f[T>>2]=(v|0)<(R|0)?R:v;f[l>>2]=ca+2;ca=C1a(D|0,M|0,n|0,fa|0)|0;fa=ba;f[fa>>2]=ca;f[fa+4>>2]=J;fa=C1a(L|0,ka|0,R|0,y|0)|0;ka=ia;f[ka>>2]=fa;f[ka+4>>2]=J}}while(0);na=na+2|0;A=f[d>>2]|0;oa=f[A+12>>2]|0}while((na|0)<(oa|0));Fa=oa;Ga=A}else{Fa=x;Ga=sa}pa=pa+2|0;if((pa|0)>=(c|0))break;else{x=Fa;sa=Ga}}return}if(!k)return;k=a+4|0;Ga=a+12|0;sa=g+(e*136|0)+20|0;Fa=g+(e*136|0)+120|0;x=g+(e*136|0)+20|0;pa=g+(e*136|0)+48|0;va=g+(e*136|0)+48|0;ua=g+(e*136|0)+48|0;za=g+(e*136|0)+20|0;S=g+(e*136|0)+48|0;r=g+(e*136|0)+20|0;Da=g+(e*136|0)+48|0;Ea=g+(e*136|0)+120|0;Z=g+(e*136|0)+20|0;ya=g+(e*136|0)+120|0;g=i;i=e;Ba=h;while(1){h=f[k>>2]|0;Ca=f[f[h+44>>2]>>2]|0;X=(f[h+16>>2]|0)+(Y(Ca,i)|0)|0;h=X+Ca|0;Ca=f[f[Ba+44>>2]>>2]|0;Aa=(f[Ba+16>>2]|0)+(Y(Ca,i)|0)|0;z=Aa+Ca|0;if((g|0)>0){Ca=((i|0)<0)<<31>>31;_=i+1|0;qa=((_|0)<0)<<31>>31;wa=0;do{V=Aa+(wa<<2)|0;xa=f[V>>2]|0;do if((xa|0)>0){j=f[(f[Ga>>2]|0)+(xa<<2)>>2]|0;if(!(b[X+wa>>0]|0)){f[V>>2]=0;na=f[sa>>2]|0;y=f[na>>2]|0;f[na>>2]=(y|0)>(wa|0)?wa:y;y=na+8|0;R=f[y>>2]|0;f[y>>2]=(R|0)<(wa|0)?wa:R;R=na+4|0;y=f[R>>2]|0;f[R>>2]=(y|0)>(i|0)?i:y;y=na+12|0;R=f[y>>2]|0;f[y>>2]=(R|0)<(i|0)?i:R;R=na+16|0;f[R>>2]=(f[R>>2]|0)+1;R=f[Fa>>2]|0;y=R;q=C1a(f[y>>2]|0,f[y+4>>2]|0,wa|0,((wa|0)<0)<<31>>31|0)|0;y=R;f[y>>2]=q;f[y+4>>2]=J;Ha=na;Ia=R;Ja=R+8|0}else{f[V>>2]=j;R=f[r>>2]|0;na=R+(Y(f[f[Da>>2]>>2]|0,j)|0)|0;y=f[na>>2]|0;f[na>>2]=(y|0)>(wa|0)?wa:y;y=na+8|0;q=f[y>>2]|0;f[y>>2]=(q|0)<(wa|0)?wa:q;q=na+4|0;y=f[q>>2]|0;f[q>>2]=(y|0)>(i|0)?i:y;y=na+12|0;q=f[y>>2]|0;f[y>>2]=(q|0)<(i|0)?i:q;q=na+16|0;f[q>>2]=(f[q>>2]|0)+1;q=f[Ea>>2]|0;na=q+(j<<4)|0;y=na;w=C1a(f[y>>2]|0,f[y+4>>2]|0,wa|0,((wa|0)<0)<<31>>31|0)|0;y=na;f[y>>2]=w;f[y+4>>2]=J;Ha=R;Ia=q;Ja=q+(j<<4)+8|0}q=Ja;R=C1a(f[q>>2]|0,f[q+4>>2]|0,i|0,Ca|0)|0;q=Ja;f[q>>2]=R;f[q+4>>2]=J;q=wa|1;R=f[d>>2]|0;if((q|0)>=(f[R+12>>2]|0)){if((_|0)>=(f[R+8>>2]|0))break;R=z+(wa<<2)|0;y=f[za>>2]|0;if(!(b[h+wa>>0]|0)){f[R>>2]=0;w=f[y>>2]|0;f[y>>2]=(w|0)>(wa|0)?wa:w;w=y+8|0;na=f[w>>2]|0;f[w>>2]=(na|0)<(wa|0)?wa:na;na=y+4|0;w=f[na>>2]|0;f[na>>2]=(w|0)>(_|0)?_:w;w=y+12|0;na=f[w>>2]|0;f[w>>2]=(na|0)<(_|0)?_:na;na=y+16|0;f[na>>2]=(f[na>>2]|0)+1;na=Ia;w=C1a(f[na>>2]|0,f[na+4>>2]|0,wa|0,((wa|0)<0)<<31>>31|0)|0;na=Ia;f[na>>2]=w;f[na+4>>2]=J;na=Ia+8|0;w=na;p=C1a(f[w>>2]|0,f[w+4>>2]|0,_|0,qa|0)|0;w=na;f[w>>2]=p;f[w+4>>2]=J;break}else{f[R>>2]=j;R=y+(Y(f[f[S>>2]>>2]|0,j)|0)|0;y=f[R>>2]|0;f[R>>2]=(y|0)>(wa|0)?wa:y;y=R+8|0;w=f[y>>2]|0;f[y>>2]=(w|0)<(wa|0)?wa:w;w=R+4|0;y=f[w>>2]|0;f[w>>2]=(y|0)>(_|0)?_:y;y=R+12|0;w=f[y>>2]|0;f[y>>2]=(w|0)<(_|0)?_:w;w=R+16|0;f[w>>2]=(f[w>>2]|0)+1;w=Ia+(j<<4)|0;R=w;y=C1a(f[R>>2]|0,f[R+4>>2]|0,wa|0,((wa|0)<0)<<31>>31|0)|0;R=w;f[R>>2]=y;f[R+4>>2]=J;R=Ia+(j<<4)+8|0;y=R;w=C1a(f[y>>2]|0,f[y+4>>2]|0,_|0,qa|0)|0;y=R;f[y>>2]=w;f[y+4>>2]=J;break}}y=Aa+(q<<2)|0;if(!(b[X+q>>0]|0)){f[y>>2]=0;Ka=0;La=Ha}else{f[y>>2]=j;Ka=j;La=Ha+(Y(f[f[ua>>2]>>2]|0,j)|0)|0}y=f[La>>2]|0;f[La>>2]=(y|0)>(q|0)?q:y;y=La+8|0;w=f[y>>2]|0;f[y>>2]=(w|0)<(q|0)?q:w;w=La+4|0;y=f[w>>2]|0;f[w>>2]=(y|0)>(i|0)?i:y;y=La+12|0;w=f[y>>2]|0;f[y>>2]=(w|0)<(i|0)?i:w;w=La+16|0;f[w>>2]=(f[w>>2]|0)+1;w=Ia+(Ka<<4)|0;y=w;R=C1a(f[y>>2]|0,f[y+4>>2]|0,q|0,((q|0)<0)<<31>>31|0)|0;y=w;f[y>>2]=R;f[y+4>>2]=J;y=Ia+(Ka<<4)+8|0;R=y;w=C1a(f[R>>2]|0,f[R+4>>2]|0,i|0,Ca|0)|0;R=y;f[R>>2]=w;f[R+4>>2]=J;if((_|0)<(f[(f[d>>2]|0)+8>>2]|0)){R=z+(wa<<2)|0;if(!(b[h+wa>>0]|0)){f[R>>2]=0;Ma=0;Na=Ha}else{f[R>>2]=j;Ma=j;Na=Ha+(Y(f[f[va>>2]>>2]|0,j)|0)|0}R=f[Na>>2]|0;f[Na>>2]=(R|0)>(wa|0)?wa:R;R=Na+8|0;w=f[R>>2]|0;f[R>>2]=(w|0)<(wa|0)?wa:w;w=Na+4|0;R=f[w>>2]|0;f[w>>2]=(R|0)>(_|0)?_:R;R=Na+12|0;w=f[R>>2]|0;f[R>>2]=(w|0)<(_|0)?_:w;w=Na+16|0;f[w>>2]=(f[w>>2]|0)+1;w=Ia+(Ma<<4)|0;R=w;y=C1a(f[R>>2]|0,f[R+4>>2]|0,wa|0,((wa|0)<0)<<31>>31|0)|0;R=w;f[R>>2]=y;f[R+4>>2]=J;R=Ia+(Ma<<4)+8|0;y=R;w=C1a(f[y>>2]|0,f[y+4>>2]|0,_|0,qa|0)|0;y=R;f[y>>2]=w;f[y+4>>2]=J;y=z+(q<<2)|0;w=f[x>>2]|0;if(!(b[h+q>>0]|0)){f[y>>2]=0;R=f[w>>2]|0;f[w>>2]=(R|0)>(q|0)?q:R;R=w+8|0;p=f[R>>2]|0;f[R>>2]=(p|0)<(q|0)?q:p;p=w+4|0;R=f[p>>2]|0;f[p>>2]=(R|0)>(_|0)?_:R;R=w+12|0;p=f[R>>2]|0;f[R>>2]=(p|0)<(_|0)?_:p;p=w+16|0;f[p>>2]=(f[p>>2]|0)+1;p=Ia;R=C1a(f[p>>2]|0,f[p+4>>2]|0,q|0,((q|0)<0)<<31>>31|0)|0;p=Ia;f[p>>2]=R;f[p+4>>2]=J;p=Ia+8|0;R=p;na=C1a(f[R>>2]|0,f[R+4>>2]|0,_|0,qa|0)|0;R=p;f[R>>2]=na;f[R+4>>2]=J;break}else{f[y>>2]=j;y=w+(Y(f[f[pa>>2]>>2]|0,j)|0)|0;w=f[y>>2]|0;f[y>>2]=(w|0)>(q|0)?q:w;w=y+8|0;R=f[w>>2]|0;f[w>>2]=(R|0)<(q|0)?q:R;R=y+4|0;w=f[R>>2]|0;f[R>>2]=(w|0)>(_|0)?_:w;w=y+12|0;R=f[w>>2]|0;f[w>>2]=(R|0)<(_|0)?_:R;R=y+16|0;f[R>>2]=(f[R>>2]|0)+1;R=Ia+(j<<4)|0;y=R;w=C1a(f[y>>2]|0,f[y+4>>2]|0,q|0,((q|0)<0)<<31>>31|0)|0;q=R;f[q>>2]=w;f[q+4>>2]=J;q=Ia+(j<<4)+8|0;j=q;w=C1a(f[j>>2]|0,f[j+4>>2]|0,_|0,qa|0)|0;j=q;f[j>>2]=w;f[j+4>>2]=J;break}}}else{f[V>>2]=0;j=f[Z>>2]|0;w=f[j>>2]|0;f[j>>2]=(w|0)>(wa|0)?wa:w;w=j+8|0;q=f[w>>2]|0;f[w>>2]=(q|0)<(wa|0)?wa:q;q=j+4|0;R=f[q>>2]|0;f[q>>2]=(R|0)>(i|0)?i:R;R=j+12|0;y=f[R>>2]|0;f[R>>2]=(y|0)<(i|0)?i:y;y=j+16|0;f[y>>2]=(f[y>>2]|0)+1;na=f[ya>>2]|0;p=((wa|0)<0)<<31>>31;ta=na;ra=C1a(f[ta>>2]|0,f[ta+4>>2]|0,wa|0,p|0)|0;ta=J;A=na;f[A>>2]=ra;f[A+4>>2]=ta;A=na+8|0;oa=A;ka=C1a(f[oa>>2]|0,f[oa+4>>2]|0,i|0,Ca|0)|0;oa=J;fa=A;f[fa>>2]=ka;f[fa+4>>2]=oa;fa=wa|1;ia=f[d>>2]|0;if((fa|0)<(f[ia+12>>2]|0)){f[Aa+(fa<<2)>>2]=0;L=f[j>>2]|0;f[j>>2]=(L|0)>(fa|0)?fa:L;L=f[w>>2]|0;f[w>>2]=(L|0)<(fa|0)?fa:L;L=f[q>>2]|0;f[q>>2]=(L|0)>(i|0)?i:L;L=f[R>>2]|0;f[R>>2]=(L|0)<(i|0)?i:L;f[y>>2]=(f[y>>2]|0)+1;L=((fa|0)<0)<<31>>31;ca=C1a(ra|0,ta|0,fa|0,L|0)|0;ba=J;n=na;f[n>>2]=ca;f[n+4>>2]=ba;n=C1a(ka|0,oa|0,i|0,Ca|0)|0;M=J;D=A;f[D>>2]=n;f[D+4>>2]=M;if((_|0)>=(f[(f[d>>2]|0)+8>>2]|0))break;f[z+(wa<<2)>>2]=0;f[z+(fa<<2)>>2]=0;D=f[j>>2]|0;l=(D|0)>(wa|0)?wa:D;D=f[w>>2]|0;v=(D|0)<(wa|0)?wa:D;D=f[q>>2]|0;T=f[R>>2]|0;N=f[y>>2]|0;s=C1a(ca|0,ba|0,wa|0,p|0)|0;ba=J;ca=C1a(n|0,M|0,_|0,qa|0)|0;M=J;f[j>>2]=(l|0)>(fa|0)?fa:l;f[w>>2]=(v|0)<(fa|0)?fa:v;f[q>>2]=(D|0)>(_|0)?_:D;f[R>>2]=(T|0)<(_|0)?_:T;f[y>>2]=N+2;N=C1a(s|0,ba|0,fa|0,L|0)|0;L=na;f[L>>2]=N;f[L+4>>2]=J;L=C1a(ca|0,M|0,_|0,qa|0)|0;M=A;f[M>>2]=L;f[M+4>>2]=J;break}else{if((_|0)>=(f[ia+8>>2]|0))break;f[z+(wa<<2)>>2]=0;ia=f[j>>2]|0;f[j>>2]=(ia|0)>(wa|0)?wa:ia;ia=f[w>>2]|0;f[w>>2]=(ia|0)<(wa|0)?wa:ia;ia=f[q>>2]|0;f[q>>2]=(ia|0)>(_|0)?_:ia;ia=f[R>>2]|0;f[R>>2]=(ia|0)<(_|0)?_:ia;f[y>>2]=(f[y>>2]|0)+1;y=C1a(ra|0,ta|0,wa|0,p|0)|0;p=na;f[p>>2]=y;f[p+4>>2]=J;p=C1a(ka|0,oa|0,_|0,qa|0)|0;oa=A;f[oa>>2]=p;f[oa+4>>2]=J;break}}while(0);wa=wa+2|0;V=f[d>>2]|0;xa=f[V+12>>2]|0}while((wa|0)<(xa|0));Oa=xa;Pa=V}else{Oa=g;Pa=Ba}i=i+2|0;if((i|0)>=(c|0))break;else{g=Oa;Ba=Pa}}return}else{Pa=a+16|0;f[(f[Pa>>2]|0)+132>>2]=c;Ba=a+8|0;Oa=f[Ba>>2]|0;g=f[Oa+12>>2]|0;i=(g&1|0)!=0;d=(e|0)<(c|0);if(!(f[Oa+8>>2]&1)){if(!i){if(!d)return;ya=a+4|0;Z=a+12|0;Ia=g;pa=e;x=Oa;while(1){Ma=f[ya>>2]|0;Na=f[f[Ma+44>>2]>>2]|0;va=(f[Ma+16>>2]|0)+(Y(Na,pa)|0)|0;Ma=va+Na|0;Na=f[f[x+44>>2]>>2]|0;Ha=(f[x+16>>2]|0)+(Y(Na,pa)|0)|0;Ka=Ha+Na|0;if((Ia|0)>0){Na=((pa|0)<0)<<31>>31;La=pa+1|0;ua=((La|0)<0)<<31>>31;S=0;do{za=Ha+(S<<2)|0;Ja=f[za>>2]|0;do if((Ja|0)>0){Ea=f[(f[Z>>2]|0)+(Ja<<2)>>2]|0;if(!(b[va+S>>0]|0)){f[za>>2]=0;Da=f[Pa>>2]|0;r=f[Da+20>>2]|0;Fa=f[r>>2]|0;f[r>>2]=(Fa|0)>(S|0)?S:Fa;Fa=r+8|0;sa=f[Fa>>2]|0;f[Fa>>2]=(sa|0)<(S|0)?S:sa;sa=r+4|0;Fa=f[sa>>2]|0;f[sa>>2]=(Fa|0)>(pa|0)?pa:Fa;Fa=r+12|0;sa=f[Fa>>2]|0;f[Fa>>2]=(sa|0)<(pa|0)?pa:sa;sa=r+16|0;f[sa>>2]=(f[sa>>2]|0)+1;sa=f[Da+120>>2]|0;Da=sa;r=C1a(f[Da>>2]|0,f[Da+4>>2]|0,S|0,((S|0)<0)<<31>>31|0)|0;Da=sa;f[Da>>2]=r;f[Da+4>>2]=J;Qa=sa+8|0}else{f[za>>2]=Ea;sa=f[Pa>>2]|0;Da=(f[sa+20>>2]|0)+(Y(f[f[sa+48>>2]>>2]|0,Ea)|0)|0;r=f[Da>>2]|0;f[Da>>2]=(r|0)>(S|0)?S:r;r=Da+8|0;Fa=f[r>>2]|0;f[r>>2]=(Fa|0)<(S|0)?S:Fa;Fa=Da+4|0;r=f[Fa>>2]|0;f[Fa>>2]=(r|0)>(pa|0)?pa:r;r=Da+12|0;Fa=f[r>>2]|0;f[r>>2]=(Fa|0)<(pa|0)?pa:Fa;Fa=Da+16|0;f[Fa>>2]=(f[Fa>>2]|0)+1;Fa=f[sa+120>>2]|0;sa=Fa+(Ea<<4)|0;Da=sa;r=C1a(f[Da>>2]|0,f[Da+4>>2]|0,S|0,((S|0)<0)<<31>>31|0)|0;Da=sa;f[Da>>2]=r;f[Da+4>>2]=J;Qa=Fa+(Ea<<4)+8|0}Fa=Qa;Da=C1a(f[Fa>>2]|0,f[Fa+4>>2]|0,pa|0,Na|0)|0;Fa=Qa;f[Fa>>2]=Da;f[Fa+4>>2]=J;Fa=S|1;Da=Ha+(Fa<<2)|0;if(!(b[va+Fa>>0]|0)){f[Da>>2]=0;r=f[Pa>>2]|0;sa=f[r+20>>2]|0;Ga=f[sa>>2]|0;f[sa>>2]=(Ga|0)>(Fa|0)?Fa:Ga;Ga=sa+8|0;k=f[Ga>>2]|0;f[Ga>>2]=(k|0)<(Fa|0)?Fa:k;k=sa+4|0;Ga=f[k>>2]|0;f[k>>2]=(Ga|0)>(pa|0)?pa:Ga;Ga=sa+12|0;k=f[Ga>>2]|0;f[Ga>>2]=(k|0)<(pa|0)?pa:k;k=sa+16|0;f[k>>2]=(f[k>>2]|0)+1;k=f[r+120>>2]|0;r=k;sa=C1a(f[r>>2]|0,f[r+4>>2]|0,Fa|0,((Fa|0)<0)<<31>>31|0)|0;r=k;f[r>>2]=sa;f[r+4>>2]=J;Ra=k+8|0}else{f[Da>>2]=Ea;Da=f[Pa>>2]|0;k=(f[Da+20>>2]|0)+(Y(f[f[Da+48>>2]>>2]|0,Ea)|0)|0;r=f[k>>2]|0;f[k>>2]=(r|0)>(Fa|0)?Fa:r;r=k+8|0;sa=f[r>>2]|0;f[r>>2]=(sa|0)<(Fa|0)?Fa:sa;sa=k+4|0;r=f[sa>>2]|0;f[sa>>2]=(r|0)>(pa|0)?pa:r;r=k+12|0;sa=f[r>>2]|0;f[r>>2]=(sa|0)<(pa|0)?pa:sa;sa=k+16|0;f[sa>>2]=(f[sa>>2]|0)+1;sa=f[Da+120>>2]|0;Da=sa+(Ea<<4)|0;k=Da;r=C1a(f[k>>2]|0,f[k+4>>2]|0,Fa|0,((Fa|0)<0)<<31>>31|0)|0;k=Da;f[k>>2]=r;f[k+4>>2]=J;Ra=sa+(Ea<<4)+8|0}sa=Ra;k=C1a(f[sa>>2]|0,f[sa+4>>2]|0,pa|0,Na|0)|0;sa=Ra;f[sa>>2]=k;f[sa+4>>2]=J;sa=Ka+(S<<2)|0;if(!(b[Ma+S>>0]|0)){f[sa>>2]=0;k=f[Pa>>2]|0;r=f[k+20>>2]|0;Da=f[r>>2]|0;f[r>>2]=(Da|0)>(S|0)?S:Da;Da=r+8|0;Ga=f[Da>>2]|0;f[Da>>2]=(Ga|0)<(S|0)?S:Ga;Ga=r+4|0;Da=f[Ga>>2]|0;f[Ga>>2]=(Da|0)>(La|0)?La:Da;Da=r+12|0;Ga=f[Da>>2]|0;f[Da>>2]=(Ga|0)<(La|0)?La:Ga;Ga=r+16|0;f[Ga>>2]=(f[Ga>>2]|0)+1;Ga=f[k+120>>2]|0;k=Ga;r=C1a(f[k>>2]|0,f[k+4>>2]|0,S|0,((S|0)<0)<<31>>31|0)|0;k=Ga;f[k>>2]=r;f[k+4>>2]=J;Sa=Ga+8|0}else{f[sa>>2]=Ea;sa=f[Pa>>2]|0;Ga=(f[sa+20>>2]|0)+(Y(f[f[sa+48>>2]>>2]|0,Ea)|0)|0;k=f[Ga>>2]|0;f[Ga>>2]=(k|0)>(S|0)?S:k;k=Ga+8|0;r=f[k>>2]|0;f[k>>2]=(r|0)<(S|0)?S:r;r=Ga+4|0;k=f[r>>2]|0;f[r>>2]=(k|0)>(La|0)?La:k;k=Ga+12|0;r=f[k>>2]|0;f[k>>2]=(r|0)<(La|0)?La:r;r=Ga+16|0;f[r>>2]=(f[r>>2]|0)+1;r=f[sa+120>>2]|0;sa=r+(Ea<<4)|0;Ga=sa;k=C1a(f[Ga>>2]|0,f[Ga+4>>2]|0,S|0,((S|0)<0)<<31>>31|0)|0;Ga=sa;f[Ga>>2]=k;f[Ga+4>>2]=J;Sa=r+(Ea<<4)+8|0}r=Sa;Ga=C1a(f[r>>2]|0,f[r+4>>2]|0,La|0,ua|0)|0;r=Sa;f[r>>2]=Ga;f[r+4>>2]=J;r=Ka+(Fa<<2)|0;if(!(b[Ma+Fa>>0]|0)){f[r>>2]=0;Ga=f[Pa>>2]|0;k=f[Ga+20>>2]|0;sa=f[k>>2]|0;f[k>>2]=(sa|0)>(Fa|0)?Fa:sa;sa=k+8|0;Da=f[sa>>2]|0;f[sa>>2]=(Da|0)<(Fa|0)?Fa:Da;Da=k+4|0;sa=f[Da>>2]|0;f[Da>>2]=(sa|0)>(La|0)?La:sa;sa=k+12|0;Da=f[sa>>2]|0;f[sa>>2]=(Da|0)<(La|0)?La:Da;Da=k+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[Ga+120>>2]|0;Ga=Da;k=C1a(f[Ga>>2]|0,f[Ga+4>>2]|0,Fa|0,((Fa|0)<0)<<31>>31|0)|0;Ga=Da;f[Ga>>2]=k;f[Ga+4>>2]=J;Ta=Da+8|0;break}else{f[r>>2]=Ea;r=f[Pa>>2]|0;Da=(f[r+20>>2]|0)+(Y(f[f[r+48>>2]>>2]|0,Ea)|0)|0;Ga=f[Da>>2]|0;f[Da>>2]=(Ga|0)>(Fa|0)?Fa:Ga;Ga=Da+8|0;k=f[Ga>>2]|0;f[Ga>>2]=(k|0)<(Fa|0)?Fa:k;k=Da+4|0;Ga=f[k>>2]|0;f[k>>2]=(Ga|0)>(La|0)?La:Ga;Ga=Da+12|0;k=f[Ga>>2]|0;f[Ga>>2]=(k|0)<(La|0)?La:k;k=Da+16|0;f[k>>2]=(f[k>>2]|0)+1;k=f[r+120>>2]|0;r=k+(Ea<<4)|0;Da=r;Ga=C1a(f[Da>>2]|0,f[Da+4>>2]|0,Fa|0,((Fa|0)<0)<<31>>31|0)|0;Fa=r;f[Fa>>2]=Ga;f[Fa+4>>2]=J;Ta=k+(Ea<<4)+8|0;break}}else{f[za>>2]=0;Ea=S|1;f[Ha+(Ea<<2)>>2]=0;f[Ka+(S<<2)>>2]=0;f[Ka+(Ea<<2)>>2]=0;k=f[Pa>>2]|0;Fa=f[k+20>>2]|0;Ga=f[Fa>>2]|0;f[Fa>>2]=(Ga|0)>(S|0)?S:Ga;Ga=Fa+8|0;r=f[Ga>>2]|0;f[Ga>>2]=(r|0)<(S|0)?S:r;r=Fa+4|0;Ga=f[r>>2]|0;f[r>>2]=(Ga|0)>(pa|0)?pa:Ga;Ga=Fa+12|0;r=f[Ga>>2]|0;f[Ga>>2]=(r|0)<(pa|0)?pa:r;r=Fa+16|0;f[r>>2]=(f[r>>2]|0)+1;r=f[k+120>>2]|0;k=((S|0)<0)<<31>>31;Fa=r;Ga=C1a(f[Fa>>2]|0,f[Fa+4>>2]|0,S|0,k|0)|0;Fa=r;f[Fa>>2]=Ga;f[Fa+4>>2]=J;Fa=r+8|0;r=Fa;Ga=C1a(f[r>>2]|0,f[r+4>>2]|0,pa|0,Na|0)|0;r=Fa;f[r>>2]=Ga;f[r+4>>2]=J;r=f[Pa>>2]|0;Ga=f[r+20>>2]|0;Fa=f[Ga>>2]|0;f[Ga>>2]=(Fa|0)>(Ea|0)?Ea:Fa;Fa=Ga+8|0;Da=f[Fa>>2]|0;f[Fa>>2]=(Da|0)<(Ea|0)?Ea:Da;Da=Ga+4|0;Fa=f[Da>>2]|0;f[Da>>2]=(Fa|0)>(pa|0)?pa:Fa;Fa=Ga+12|0;Da=f[Fa>>2]|0;f[Fa>>2]=(Da|0)<(pa|0)?pa:Da;Da=Ga+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[r+120>>2]|0;r=((Ea|0)<0)<<31>>31;Ga=Da;Fa=C1a(f[Ga>>2]|0,f[Ga+4>>2]|0,Ea|0,r|0)|0;Ga=Da;f[Ga>>2]=Fa;f[Ga+4>>2]=J;Ga=Da+8|0;Da=Ga;Fa=C1a(f[Da>>2]|0,f[Da+4>>2]|0,pa|0,Na|0)|0;Da=Ga;f[Da>>2]=Fa;f[Da+4>>2]=J;Da=f[Pa>>2]|0;Fa=f[Da+20>>2]|0;Ga=f[Fa>>2]|0;f[Fa>>2]=(Ga|0)>(S|0)?S:Ga;Ga=Fa+8|0;sa=f[Ga>>2]|0;f[Ga>>2]=(sa|0)<(S|0)?S:sa;sa=Fa+4|0;Ga=f[sa>>2]|0;f[sa>>2]=(Ga|0)>(La|0)?La:Ga;Ga=Fa+12|0;sa=f[Ga>>2]|0;f[Ga>>2]=(sa|0)<(La|0)?La:sa;sa=Fa+16|0;f[sa>>2]=(f[sa>>2]|0)+1;sa=f[Da+120>>2]|0;Da=sa;Fa=C1a(f[Da>>2]|0,f[Da+4>>2]|0,S|0,k|0)|0;k=sa;f[k>>2]=Fa;f[k+4>>2]=J;k=sa+8|0;sa=k;Fa=C1a(f[sa>>2]|0,f[sa+4>>2]|0,La|0,ua|0)|0;sa=k;f[sa>>2]=Fa;f[sa+4>>2]=J;sa=f[Pa>>2]|0;Fa=f[sa+20>>2]|0;k=f[Fa>>2]|0;f[Fa>>2]=(k|0)>(Ea|0)?Ea:k;k=Fa+8|0;Da=f[k>>2]|0;f[k>>2]=(Da|0)<(Ea|0)?Ea:Da;Da=Fa+4|0;k=f[Da>>2]|0;f[Da>>2]=(k|0)>(La|0)?La:k;k=Fa+12|0;Da=f[k>>2]|0;f[k>>2]=(Da|0)<(La|0)?La:Da;Da=Fa+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[sa+120>>2]|0;sa=Da;Fa=C1a(f[sa>>2]|0,f[sa+4>>2]|0,Ea|0,r|0)|0;r=Da;f[r>>2]=Fa;f[r+4>>2]=J;Ta=Da+8|0}while(0);za=Ta;Ja=C1a(f[za>>2]|0,f[za+4>>2]|0,La|0,ua|0)|0;za=Ta;f[za>>2]=Ja;f[za+4>>2]=J;S=S+2|0;za=f[Ba>>2]|0;Ja=f[za+12>>2]|0}while((S|0)<(Ja|0));Ua=Ja;Va=za}else{Ua=Ia;Va=x}pa=pa+2|0;if((pa|0)>=(c|0))break;else{Ia=Ua;x=Va}}return}if(!d)return;Va=a+4|0;x=a+12|0;Ua=g;Ia=e;pa=Oa;while(1){Ta=f[Va>>2]|0;Sa=f[f[Ta+44>>2]>>2]|0;Ra=(f[Ta+16>>2]|0)+(Y(Sa,Ia)|0)|0;Ta=Ra+Sa|0;Sa=f[f[pa+44>>2]>>2]|0;Qa=(f[pa+16>>2]|0)+(Y(Sa,Ia)|0)|0;Z=Qa+Sa|0;if((Ua|0)>0){Sa=((Ia|0)<0)<<31>>31;ya=Ia+1|0;S=((ya|0)<0)<<31>>31;ua=0;do{La=Qa+(ua<<2)|0;Na=f[La>>2]|0;do if((Na|0)>0){Ka=f[(f[x>>2]|0)+(Na<<2)>>2]|0;if(!(b[Ra+ua>>0]|0)){f[La>>2]=0;Ha=f[Pa>>2]|0;Ma=f[Ha+20>>2]|0;va=f[Ma>>2]|0;f[Ma>>2]=(va|0)>(ua|0)?ua:va;va=Ma+8|0;za=f[va>>2]|0;f[va>>2]=(za|0)<(ua|0)?ua:za;za=Ma+4|0;va=f[za>>2]|0;f[za>>2]=(va|0)>(Ia|0)?Ia:va;va=Ma+12|0;za=f[va>>2]|0;f[va>>2]=(za|0)<(Ia|0)?Ia:za;za=Ma+16|0;f[za>>2]=(f[za>>2]|0)+1;za=f[Ha+120>>2]|0;Ha=za;Ma=C1a(f[Ha>>2]|0,f[Ha+4>>2]|0,ua|0,((ua|0)<0)<<31>>31|0)|0;Ha=za;f[Ha>>2]=Ma;f[Ha+4>>2]=J;Wa=za+8|0}else{f[La>>2]=Ka;za=f[Pa>>2]|0;Ha=(f[za+20>>2]|0)+(Y(f[f[za+48>>2]>>2]|0,Ka)|0)|0;Ma=f[Ha>>2]|0;f[Ha>>2]=(Ma|0)>(ua|0)?ua:Ma;Ma=Ha+8|0;va=f[Ma>>2]|0;f[Ma>>2]=(va|0)<(ua|0)?ua:va;va=Ha+4|0;Ma=f[va>>2]|0;f[va>>2]=(Ma|0)>(Ia|0)?Ia:Ma;Ma=Ha+12|0;va=f[Ma>>2]|0;f[Ma>>2]=(va|0)<(Ia|0)?Ia:va;va=Ha+16|0;f[va>>2]=(f[va>>2]|0)+1;va=f[za+120>>2]|0;za=va+(Ka<<4)|0;Ha=za;Ma=C1a(f[Ha>>2]|0,f[Ha+4>>2]|0,ua|0,((ua|0)<0)<<31>>31|0)|0;Ha=za;f[Ha>>2]=Ma;f[Ha+4>>2]=J;Wa=va+(Ka<<4)+8|0}va=Wa;Ha=C1a(f[va>>2]|0,f[va+4>>2]|0,Ia|0,Sa|0)|0;va=Wa;f[va>>2]=Ha;f[va+4>>2]=J;va=Z+(ua<<2)|0;if(!(b[Ta+ua>>0]|0)){f[va>>2]=0;Ha=f[Pa>>2]|0;Ma=f[Ha+20>>2]|0;za=f[Ma>>2]|0;f[Ma>>2]=(za|0)>(ua|0)?ua:za;za=Ma+8|0;Ja=f[za>>2]|0;f[za>>2]=(Ja|0)<(ua|0)?ua:Ja;Ja=Ma+4|0;za=f[Ja>>2]|0;f[Ja>>2]=(za|0)>(ya|0)?ya:za;za=Ma+12|0;Ja=f[za>>2]|0;f[za>>2]=(Ja|0)<(ya|0)?ya:Ja;Ja=Ma+16|0;f[Ja>>2]=(f[Ja>>2]|0)+1;Ja=f[Ha+120>>2]|0;Ha=Ja;Ma=C1a(f[Ha>>2]|0,f[Ha+4>>2]|0,ua|0,((ua|0)<0)<<31>>31|0)|0;Ha=Ja;f[Ha>>2]=Ma;f[Ha+4>>2]=J;Xa=Ja+8|0}else{f[va>>2]=Ka;va=f[Pa>>2]|0;Ja=(f[va+20>>2]|0)+(Y(f[f[va+48>>2]>>2]|0,Ka)|0)|0;Ha=f[Ja>>2]|0;f[Ja>>2]=(Ha|0)>(ua|0)?ua:Ha;Ha=Ja+8|0;Ma=f[Ha>>2]|0;f[Ha>>2]=(Ma|0)<(ua|0)?ua:Ma;Ma=Ja+4|0;Ha=f[Ma>>2]|0;f[Ma>>2]=(Ha|0)>(ya|0)?ya:Ha;Ha=Ja+12|0;Ma=f[Ha>>2]|0;f[Ha>>2]=(Ma|0)<(ya|0)?ya:Ma;Ma=Ja+16|0;f[Ma>>2]=(f[Ma>>2]|0)+1;Ma=f[va+120>>2]|0;va=Ma+(Ka<<4)|0;Ja=va;Ha=C1a(f[Ja>>2]|0,f[Ja+4>>2]|0,ua|0,((ua|0)<0)<<31>>31|0)|0;Ja=va;f[Ja>>2]=Ha;f[Ja+4>>2]=J;Xa=Ma+(Ka<<4)+8|0}Ma=Xa;Ja=C1a(f[Ma>>2]|0,f[Ma+4>>2]|0,ya|0,S|0)|0;Ma=Xa;f[Ma>>2]=Ja;f[Ma+4>>2]=J;Ma=ua|1;if((Ma|0)<(f[(f[Ba>>2]|0)+12>>2]|0)){Ja=Qa+(Ma<<2)|0;if(!(b[Ra+Ma>>0]|0)){f[Ja>>2]=0;Ha=f[Pa>>2]|0;va=f[Ha+20>>2]|0;za=f[va>>2]|0;f[va>>2]=(za|0)>(Ma|0)?Ma:za;za=va+8|0;Da=f[za>>2]|0;f[za>>2]=(Da|0)<(Ma|0)?Ma:Da;Da=va+4|0;za=f[Da>>2]|0;f[Da>>2]=(za|0)>(Ia|0)?Ia:za;za=va+12|0;Da=f[za>>2]|0;f[za>>2]=(Da|0)<(Ia|0)?Ia:Da;Da=va+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[Ha+120>>2]|0;Ha=Da;va=C1a(f[Ha>>2]|0,f[Ha+4>>2]|0,Ma|0,((Ma|0)<0)<<31>>31|0)|0;Ha=Da;f[Ha>>2]=va;f[Ha+4>>2]=J;Ya=Da+8|0}else{f[Ja>>2]=Ka;Ja=f[Pa>>2]|0;Da=(f[Ja+20>>2]|0)+(Y(f[f[Ja+48>>2]>>2]|0,Ka)|0)|0;Ha=f[Da>>2]|0;f[Da>>2]=(Ha|0)>(Ma|0)?Ma:Ha;Ha=Da+8|0;va=f[Ha>>2]|0;f[Ha>>2]=(va|0)<(Ma|0)?Ma:va;va=Da+4|0;Ha=f[va>>2]|0;f[va>>2]=(Ha|0)>(Ia|0)?Ia:Ha;Ha=Da+12|0;va=f[Ha>>2]|0;f[Ha>>2]=(va|0)<(Ia|0)?Ia:va;va=Da+16|0;f[va>>2]=(f[va>>2]|0)+1;va=f[Ja+120>>2]|0;Ja=va+(Ka<<4)|0;Da=Ja;Ha=C1a(f[Da>>2]|0,f[Da+4>>2]|0,Ma|0,((Ma|0)<0)<<31>>31|0)|0;Da=Ja;f[Da>>2]=Ha;f[Da+4>>2]=J;Ya=va+(Ka<<4)+8|0}va=Ya;Da=C1a(f[va>>2]|0,f[va+4>>2]|0,Ia|0,Sa|0)|0;va=Ya;f[va>>2]=Da;f[va+4>>2]=J;va=Z+(Ma<<2)|0;if(!(b[Ta+Ma>>0]|0)){f[va>>2]=0;Da=f[Pa>>2]|0;Ha=f[Da+20>>2]|0;Ja=f[Ha>>2]|0;f[Ha>>2]=(Ja|0)>(Ma|0)?Ma:Ja;Ja=Ha+8|0;za=f[Ja>>2]|0;f[Ja>>2]=(za|0)<(Ma|0)?Ma:za;za=Ha+4|0;Ja=f[za>>2]|0;f[za>>2]=(Ja|0)>(ya|0)?ya:Ja;Ja=Ha+12|0;za=f[Ja>>2]|0;f[Ja>>2]=(za|0)<(ya|0)?ya:za;za=Ha+16|0;f[za>>2]=(f[za>>2]|0)+1;za=f[Da+120>>2]|0;Da=za;Ha=C1a(f[Da>>2]|0,f[Da+4>>2]|0,Ma|0,((Ma|0)<0)<<31>>31|0)|0;Da=za;f[Da>>2]=Ha;f[Da+4>>2]=J;Da=za+8|0;za=Da;Ha=C1a(f[za>>2]|0,f[za+4>>2]|0,ya|0,S|0)|0;za=Da;f[za>>2]=Ha;f[za+4>>2]=J;break}else{f[va>>2]=Ka;va=f[Pa>>2]|0;za=(f[va+20>>2]|0)+(Y(f[f[va+48>>2]>>2]|0,Ka)|0)|0;Ha=f[za>>2]|0;f[za>>2]=(Ha|0)>(Ma|0)?Ma:Ha;Ha=za+8|0;Da=f[Ha>>2]|0;f[Ha>>2]=(Da|0)<(Ma|0)?Ma:Da;Da=za+4|0;Ha=f[Da>>2]|0;f[Da>>2]=(Ha|0)>(ya|0)?ya:Ha;Ha=za+12|0;Da=f[Ha>>2]|0;f[Ha>>2]=(Da|0)<(ya|0)?ya:Da;Da=za+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[va+120>>2]|0;va=Da+(Ka<<4)|0;za=va;Ha=C1a(f[za>>2]|0,f[za+4>>2]|0,Ma|0,((Ma|0)<0)<<31>>31|0)|0;Ma=va;f[Ma>>2]=Ha;f[Ma+4>>2]=J;Ma=Da+(Ka<<4)+8|0;Ka=Ma;Da=C1a(f[Ka>>2]|0,f[Ka+4>>2]|0,ya|0,S|0)|0;Ka=Ma;f[Ka>>2]=Da;f[Ka+4>>2]=J;break}}}else{f[La>>2]=0;f[Z+(ua<<2)>>2]=0;Ka=f[Pa>>2]|0;Da=f[Ka+20>>2]|0;Ma=f[Da>>2]|0;f[Da>>2]=(Ma|0)>(ua|0)?ua:Ma;Ma=Da+8|0;Ha=f[Ma>>2]|0;f[Ma>>2]=(Ha|0)<(ua|0)?ua:Ha;Ha=Da+4|0;Ma=f[Ha>>2]|0;f[Ha>>2]=(Ma|0)>(Ia|0)?Ia:Ma;Ma=Da+12|0;Ha=f[Ma>>2]|0;f[Ma>>2]=(Ha|0)<(Ia|0)?Ia:Ha;Ha=Da+16|0;f[Ha>>2]=(f[Ha>>2]|0)+1;Ha=f[Ka+120>>2]|0;Ka=((ua|0)<0)<<31>>31;Da=Ha;Ma=C1a(f[Da>>2]|0,f[Da+4>>2]|0,ua|0,Ka|0)|0;Da=Ha;f[Da>>2]=Ma;f[Da+4>>2]=J;Da=Ha+8|0;Ha=Da;Ma=C1a(f[Ha>>2]|0,f[Ha+4>>2]|0,Ia|0,Sa|0)|0;Ha=Da;f[Ha>>2]=Ma;f[Ha+4>>2]=J;Ha=f[Pa>>2]|0;Ma=f[Ha+20>>2]|0;Da=f[Ma>>2]|0;f[Ma>>2]=(Da|0)>(ua|0)?ua:Da;Da=Ma+8|0;va=f[Da>>2]|0;f[Da>>2]=(va|0)<(ua|0)?ua:va;va=Ma+4|0;Da=f[va>>2]|0;f[va>>2]=(Da|0)>(ya|0)?ya:Da;Da=Ma+12|0;va=f[Da>>2]|0;f[Da>>2]=(va|0)<(ya|0)?ya:va;va=Ma+16|0;f[va>>2]=(f[va>>2]|0)+1;va=f[Ha+120>>2]|0;Ha=va;Ma=C1a(f[Ha>>2]|0,f[Ha+4>>2]|0,ua|0,Ka|0)|0;Ka=va;f[Ka>>2]=Ma;f[Ka+4>>2]=J;Ka=va+8|0;va=Ka;Ma=C1a(f[va>>2]|0,f[va+4>>2]|0,ya|0,S|0)|0;va=Ka;f[va>>2]=Ma;f[va+4>>2]=J;va=ua|1;if((va|0)<(f[(f[Ba>>2]|0)+12>>2]|0)){f[Qa+(va<<2)>>2]=0;f[Z+(va<<2)>>2]=0;Ma=f[Pa>>2]|0;Ka=f[Ma+20>>2]|0;Ha=f[Ka>>2]|0;f[Ka>>2]=(Ha|0)>(va|0)?va:Ha;Ha=Ka+8|0;Da=f[Ha>>2]|0;f[Ha>>2]=(Da|0)<(va|0)?va:Da;Da=Ka+4|0;Ha=f[Da>>2]|0;f[Da>>2]=(Ha|0)>(Ia|0)?Ia:Ha;Ha=Ka+12|0;Da=f[Ha>>2]|0;f[Ha>>2]=(Da|0)<(Ia|0)?Ia:Da;Da=Ka+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[Ma+120>>2]|0;Ma=((va|0)<0)<<31>>31;Ka=Da;Ha=C1a(f[Ka>>2]|0,f[Ka+4>>2]|0,va|0,Ma|0)|0;Ka=Da;f[Ka>>2]=Ha;f[Ka+4>>2]=J;Ka=Da+8|0;Da=Ka;Ha=C1a(f[Da>>2]|0,f[Da+4>>2]|0,Ia|0,Sa|0)|0;Da=Ka;f[Da>>2]=Ha;f[Da+4>>2]=J;Da=f[Pa>>2]|0;Ha=f[Da+20>>2]|0;Ka=f[Ha>>2]|0;f[Ha>>2]=(Ka|0)>(va|0)?va:Ka;Ka=Ha+8|0;za=f[Ka>>2]|0;f[Ka>>2]=(za|0)<(va|0)?va:za;za=Ha+4|0;Ka=f[za>>2]|0;f[za>>2]=(Ka|0)>(ya|0)?ya:Ka;Ka=Ha+12|0;za=f[Ka>>2]|0;f[Ka>>2]=(za|0)<(ya|0)?ya:za;za=Ha+16|0;f[za>>2]=(f[za>>2]|0)+1;za=f[Da+120>>2]|0;Da=za;Ha=C1a(f[Da>>2]|0,f[Da+4>>2]|0,va|0,Ma|0)|0;Ma=za;f[Ma>>2]=Ha;f[Ma+4>>2]=J;Ma=za+8|0;za=Ma;Ha=C1a(f[za>>2]|0,f[za+4>>2]|0,ya|0,S|0)|0;za=Ma;f[za>>2]=Ha;f[za+4>>2]=J}}while(0);ua=ua+2|0;La=f[Ba>>2]|0;Na=f[La+12>>2]|0}while((ua|0)<(Na|0));Za=Na;_a=La}else{Za=Ua;_a=pa}Ia=Ia+2|0;if((Ia|0)>=(c|0))break;else{Ua=Za;pa=_a}}return}if(!i){if(!d)return;i=a+4|0;_a=a+12|0;pa=g;Za=e;Ua=Oa;while(1){Ia=f[i>>2]|0;Ya=f[f[Ia+44>>2]>>2]|0;Xa=(f[Ia+16>>2]|0)+(Y(Ya,Za)|0)|0;Ia=Xa+Ya|0;Ya=f[f[Ua+44>>2]>>2]|0;Wa=(f[Ua+16>>2]|0)+(Y(Ya,Za)|0)|0;x=Wa+Ya|0;if((pa|0)>0){Ya=((Za|0)<0)<<31>>31;Va=Za+1|0;ua=((Va|0)<0)<<31>>31;S=0;do{ya=Wa+(S<<2)|0;Sa=f[ya>>2]|0;do if((Sa|0)>0){Z=f[(f[_a>>2]|0)+(Sa<<2)>>2]|0;if(!(b[Xa+S>>0]|0)){f[ya>>2]=0;Qa=f[Pa>>2]|0;Ta=f[Qa+20>>2]|0;Ra=f[Ta>>2]|0;f[Ta>>2]=(Ra|0)>(S|0)?S:Ra;Ra=Ta+8|0;La=f[Ra>>2]|0;f[Ra>>2]=(La|0)<(S|0)?S:La;La=Ta+4|0;Ra=f[La>>2]|0;f[La>>2]=(Ra|0)>(Za|0)?Za:Ra;Ra=Ta+12|0;La=f[Ra>>2]|0;f[Ra>>2]=(La|0)<(Za|0)?Za:La;La=Ta+16|0;f[La>>2]=(f[La>>2]|0)+1;La=f[Qa+120>>2]|0;Qa=La;Ta=C1a(f[Qa>>2]|0,f[Qa+4>>2]|0,S|0,((S|0)<0)<<31>>31|0)|0;Qa=La;f[Qa>>2]=Ta;f[Qa+4>>2]=J;$a=La+8|0}else{f[ya>>2]=Z;La=f[Pa>>2]|0;Qa=(f[La+20>>2]|0)+(Y(f[f[La+48>>2]>>2]|0,Z)|0)|0;Ta=f[Qa>>2]|0;f[Qa>>2]=(Ta|0)>(S|0)?S:Ta;Ta=Qa+8|0;Ra=f[Ta>>2]|0;f[Ta>>2]=(Ra|0)<(S|0)?S:Ra;Ra=Qa+4|0;Ta=f[Ra>>2]|0;f[Ra>>2]=(Ta|0)>(Za|0)?Za:Ta;Ta=Qa+12|0;Ra=f[Ta>>2]|0;f[Ta>>2]=(Ra|0)<(Za|0)?Za:Ra;Ra=Qa+16|0;f[Ra>>2]=(f[Ra>>2]|0)+1;Ra=f[La+120>>2]|0;La=Ra+(Z<<4)|0;Qa=La;Ta=C1a(f[Qa>>2]|0,f[Qa+4>>2]|0,S|0,((S|0)<0)<<31>>31|0)|0;Qa=La;f[Qa>>2]=Ta;f[Qa+4>>2]=J;$a=Ra+(Z<<4)+8|0}Ra=$a;Qa=C1a(f[Ra>>2]|0,f[Ra+4>>2]|0,Za|0,Ya|0)|0;Ra=$a;f[Ra>>2]=Qa;f[Ra+4>>2]=J;Ra=S|1;Qa=Wa+(Ra<<2)|0;if(!(b[Xa+Ra>>0]|0)){f[Qa>>2]=0;Ta=f[Pa>>2]|0;La=f[Ta+20>>2]|0;Na=f[La>>2]|0;f[La>>2]=(Na|0)>(Ra|0)?Ra:Na;Na=La+8|0;za=f[Na>>2]|0;f[Na>>2]=(za|0)<(Ra|0)?Ra:za;za=La+4|0;Na=f[za>>2]|0;f[za>>2]=(Na|0)>(Za|0)?Za:Na;Na=La+12|0;za=f[Na>>2]|0;f[Na>>2]=(za|0)<(Za|0)?Za:za;za=La+16|0;f[za>>2]=(f[za>>2]|0)+1;za=f[Ta+120>>2]|0;Ta=za;La=C1a(f[Ta>>2]|0,f[Ta+4>>2]|0,Ra|0,((Ra|0)<0)<<31>>31|0)|0;Ta=za;f[Ta>>2]=La;f[Ta+4>>2]=J;ab=za+8|0}else{f[Qa>>2]=Z;Qa=f[Pa>>2]|0;za=(f[Qa+20>>2]|0)+(Y(f[f[Qa+48>>2]>>2]|0,Z)|0)|0;Ta=f[za>>2]|0;f[za>>2]=(Ta|0)>(Ra|0)?Ra:Ta;Ta=za+8|0;La=f[Ta>>2]|0;f[Ta>>2]=(La|0)<(Ra|0)?Ra:La;La=za+4|0;Ta=f[La>>2]|0;f[La>>2]=(Ta|0)>(Za|0)?Za:Ta;Ta=za+12|0;La=f[Ta>>2]|0;f[Ta>>2]=(La|0)<(Za|0)?Za:La;La=za+16|0;f[La>>2]=(f[La>>2]|0)+1;La=f[Qa+120>>2]|0;Qa=La+(Z<<4)|0;za=Qa;Ta=C1a(f[za>>2]|0,f[za+4>>2]|0,Ra|0,((Ra|0)<0)<<31>>31|0)|0;za=Qa;f[za>>2]=Ta;f[za+4>>2]=J;ab=La+(Z<<4)+8|0}La=ab;za=C1a(f[La>>2]|0,f[La+4>>2]|0,Za|0,Ya|0)|0;La=ab;f[La>>2]=za;f[La+4>>2]=J;if((Va|0)<(f[(f[Ba>>2]|0)+8>>2]|0)){La=x+(S<<2)|0;if(!(b[Ia+S>>0]|0)){f[La>>2]=0;za=f[Pa>>2]|0;Ta=f[za+20>>2]|0;Qa=f[Ta>>2]|0;f[Ta>>2]=(Qa|0)>(S|0)?S:Qa;Qa=Ta+8|0;Na=f[Qa>>2]|0;f[Qa>>2]=(Na|0)<(S|0)?S:Na;Na=Ta+4|0;Qa=f[Na>>2]|0;f[Na>>2]=(Qa|0)>(Va|0)?Va:Qa;Qa=Ta+12|0;Na=f[Qa>>2]|0;f[Qa>>2]=(Na|0)<(Va|0)?Va:Na;Na=Ta+16|0;f[Na>>2]=(f[Na>>2]|0)+1;Na=f[za+120>>2]|0;za=Na;Ta=C1a(f[za>>2]|0,f[za+4>>2]|0,S|0,((S|0)<0)<<31>>31|0)|0;za=Na;f[za>>2]=Ta;f[za+4>>2]=J;bb=Na+8|0}else{f[La>>2]=Z;La=f[Pa>>2]|0;Na=(f[La+20>>2]|0)+(Y(f[f[La+48>>2]>>2]|0,Z)|0)|0;za=f[Na>>2]|0;f[Na>>2]=(za|0)>(S|0)?S:za;za=Na+8|0;Ta=f[za>>2]|0;f[za>>2]=(Ta|0)<(S|0)?S:Ta;Ta=Na+4|0;za=f[Ta>>2]|0;f[Ta>>2]=(za|0)>(Va|0)?Va:za;za=Na+12|0;Ta=f[za>>2]|0;f[za>>2]=(Ta|0)<(Va|0)?Va:Ta;Ta=Na+16|0;f[Ta>>2]=(f[Ta>>2]|0)+1;Ta=f[La+120>>2]|0;La=Ta+(Z<<4)|0;Na=La;za=C1a(f[Na>>2]|0,f[Na+4>>2]|0,S|0,((S|0)<0)<<31>>31|0)|0;Na=La;f[Na>>2]=za;f[Na+4>>2]=J;bb=Ta+(Z<<4)+8|0}Ta=bb;Na=C1a(f[Ta>>2]|0,f[Ta+4>>2]|0,Va|0,ua|0)|0;Ta=bb;f[Ta>>2]=Na;f[Ta+4>>2]=J;Ta=x+(Ra<<2)|0;if(!(b[Ia+Ra>>0]|0)){f[Ta>>2]=0;Na=f[Pa>>2]|0;za=f[Na+20>>2]|0;La=f[za>>2]|0;f[za>>2]=(La|0)>(Ra|0)?Ra:La;La=za+8|0;Qa=f[La>>2]|0;f[La>>2]=(Qa|0)<(Ra|0)?Ra:Qa;Qa=za+4|0;La=f[Qa>>2]|0;f[Qa>>2]=(La|0)>(Va|0)?Va:La;La=za+12|0;Qa=f[La>>2]|0;f[La>>2]=(Qa|0)<(Va|0)?Va:Qa;Qa=za+16|0;f[Qa>>2]=(f[Qa>>2]|0)+1;Qa=f[Na+120>>2]|0;Na=Qa;za=C1a(f[Na>>2]|0,f[Na+4>>2]|0,Ra|0,((Ra|0)<0)<<31>>31|0)|0;Na=Qa;f[Na>>2]=za;f[Na+4>>2]=J;Na=Qa+8|0;Qa=Na;za=C1a(f[Qa>>2]|0,f[Qa+4>>2]|0,Va|0,ua|0)|0;Qa=Na;f[Qa>>2]=za;f[Qa+4>>2]=J;break}else{f[Ta>>2]=Z;Ta=f[Pa>>2]|0;Qa=(f[Ta+20>>2]|0)+(Y(f[f[Ta+48>>2]>>2]|0,Z)|0)|0;za=f[Qa>>2]|0;f[Qa>>2]=(za|0)>(Ra|0)?Ra:za;za=Qa+8|0;Na=f[za>>2]|0;f[za>>2]=(Na|0)<(Ra|0)?Ra:Na;Na=Qa+4|0;za=f[Na>>2]|0;f[Na>>2]=(za|0)>(Va|0)?Va:za;za=Qa+12|0;Na=f[za>>2]|0;f[za>>2]=(Na|0)<(Va|0)?Va:Na;Na=Qa+16|0;f[Na>>2]=(f[Na>>2]|0)+1;Na=f[Ta+120>>2]|0;Ta=Na+(Z<<4)|0;Qa=Ta;za=C1a(f[Qa>>2]|0,f[Qa+4>>2]|0,Ra|0,((Ra|0)<0)<<31>>31|0)|0;Ra=Ta;f[Ra>>2]=za;f[Ra+4>>2]=J;Ra=Na+(Z<<4)+8|0;Z=Ra;Na=C1a(f[Z>>2]|0,f[Z+4>>2]|0,Va|0,ua|0)|0;Z=Ra;f[Z>>2]=Na;f[Z+4>>2]=J;break}}}else{f[ya>>2]=0;Z=S|1;f[Wa+(Z<<2)>>2]=0;Na=f[Pa>>2]|0;Ra=f[Na+20>>2]|0;za=f[Ra>>2]|0;f[Ra>>2]=(za|0)>(S|0)?S:za;za=Ra+8|0;Ta=f[za>>2]|0;f[za>>2]=(Ta|0)<(S|0)?S:Ta;Ta=Ra+4|0;za=f[Ta>>2]|0;f[Ta>>2]=(za|0)>(Za|0)?Za:za;za=Ra+12|0;Ta=f[za>>2]|0;f[za>>2]=(Ta|0)<(Za|0)?Za:Ta;Ta=Ra+16|0;f[Ta>>2]=(f[Ta>>2]|0)+1;Ta=f[Na+120>>2]|0;Na=((S|0)<0)<<31>>31;Ra=Ta;za=C1a(f[Ra>>2]|0,f[Ra+4>>2]|0,S|0,Na|0)|0;Ra=Ta;f[Ra>>2]=za;f[Ra+4>>2]=J;Ra=Ta+8|0;Ta=Ra;za=C1a(f[Ta>>2]|0,f[Ta+4>>2]|0,Za|0,Ya|0)|0;Ta=Ra;f[Ta>>2]=za;f[Ta+4>>2]=J;Ta=f[Pa>>2]|0;za=f[Ta+20>>2]|0;Ra=f[za>>2]|0;f[za>>2]=(Ra|0)>(Z|0)?Z:Ra;Ra=za+8|0;Qa=f[Ra>>2]|0;f[Ra>>2]=(Qa|0)<(Z|0)?Z:Qa;Qa=za+4|0;Ra=f[Qa>>2]|0;f[Qa>>2]=(Ra|0)>(Za|0)?Za:Ra;Ra=za+12|0;Qa=f[Ra>>2]|0;f[Ra>>2]=(Qa|0)<(Za|0)?Za:Qa;Qa=za+16|0;f[Qa>>2]=(f[Qa>>2]|0)+1;Qa=f[Ta+120>>2]|0;Ta=((Z|0)<0)<<31>>31;za=Qa;Ra=C1a(f[za>>2]|0,f[za+4>>2]|0,Z|0,Ta|0)|0;za=Qa;f[za>>2]=Ra;f[za+4>>2]=J;za=Qa+8|0;Qa=za;Ra=C1a(f[Qa>>2]|0,f[Qa+4>>2]|0,Za|0,Ya|0)|0;Qa=za;f[Qa>>2]=Ra;f[Qa+4>>2]=J;if((Va|0)<(f[(f[Ba>>2]|0)+8>>2]|0)){f[x+(S<<2)>>2]=0;f[x+(Z<<2)>>2]=0;Qa=f[Pa>>2]|0;Ra=f[Qa+20>>2]|0;za=f[Ra>>2]|0;f[Ra>>2]=(za|0)>(S|0)?S:za;za=Ra+8|0;La=f[za>>2]|0;f[za>>2]=(La|0)<(S|0)?S:La;La=Ra+4|0;za=f[La>>2]|0;f[La>>2]=(za|0)>(Va|0)?Va:za;za=Ra+12|0;La=f[za>>2]|0;f[za>>2]=(La|0)<(Va|0)?Va:La;La=Ra+16|0;f[La>>2]=(f[La>>2]|0)+1;La=f[Qa+120>>2]|0;Qa=La;Ra=C1a(f[Qa>>2]|0,f[Qa+4>>2]|0,S|0,Na|0)|0;Na=La;f[Na>>2]=Ra;f[Na+4>>2]=J;Na=La+8|0;La=Na;Ra=C1a(f[La>>2]|0,f[La+4>>2]|0,Va|0,ua|0)|0;La=Na;f[La>>2]=Ra;f[La+4>>2]=J;La=f[Pa>>2]|0;Ra=f[La+20>>2]|0;Na=f[Ra>>2]|0;f[Ra>>2]=(Na|0)>(Z|0)?Z:Na;Na=Ra+8|0;Qa=f[Na>>2]|0;f[Na>>2]=(Qa|0)<(Z|0)?Z:Qa;Qa=Ra+4|0;Na=f[Qa>>2]|0;f[Qa>>2]=(Na|0)>(Va|0)?Va:Na;Na=Ra+12|0;Qa=f[Na>>2]|0;f[Na>>2]=(Qa|0)<(Va|0)?Va:Qa;Qa=Ra+16|0;f[Qa>>2]=(f[Qa>>2]|0)+1;Qa=f[La+120>>2]|0;La=Qa;Ra=C1a(f[La>>2]|0,f[La+4>>2]|0,Z|0,Ta|0)|0;Ta=Qa;f[Ta>>2]=Ra;f[Ta+4>>2]=J;Ta=Qa+8|0;Qa=Ta;Ra=C1a(f[Qa>>2]|0,f[Qa+4>>2]|0,Va|0,ua|0)|0;Qa=Ta;f[Qa>>2]=Ra;f[Qa+4>>2]=J}}while(0);S=S+2|0;ya=f[Ba>>2]|0;Sa=f[ya+12>>2]|0}while((S|0)<(Sa|0));cb=Sa;db=ya}else{cb=pa;db=Ua}Za=Za+2|0;if((Za|0)>=(c|0))break;else{pa=cb;Ua=db}}return}if(!d)return;d=a+4|0;db=a+12|0;a=g;g=e;e=Oa;while(1){Oa=f[d>>2]|0;Ua=f[f[Oa+44>>2]>>2]|0;cb=(f[Oa+16>>2]|0)+(Y(Ua,g)|0)|0;Oa=cb+Ua|0;Ua=f[f[e+44>>2]>>2]|0;pa=(f[e+16>>2]|0)+(Y(Ua,g)|0)|0;Za=pa+Ua|0;if((a|0)>0){Ua=((g|0)<0)<<31>>31;bb=g+1|0;ab=((bb|0)<0)<<31>>31;$a=0;do{_a=pa+($a<<2)|0;i=f[_a>>2]|0;do if((i|0)>0){S=f[(f[db>>2]|0)+(i<<2)>>2]|0;if(!(b[cb+$a>>0]|0)){f[_a>>2]=0;ua=f[Pa>>2]|0;Va=f[ua+20>>2]|0;x=f[Va>>2]|0;f[Va>>2]=(x|0)>($a|0)?$a:x;x=Va+8|0;Ya=f[x>>2]|0;f[x>>2]=(Ya|0)<($a|0)?$a:Ya;Ya=Va+4|0;x=f[Ya>>2]|0;f[Ya>>2]=(x|0)>(g|0)?g:x;x=Va+12|0;Ya=f[x>>2]|0;f[x>>2]=(Ya|0)<(g|0)?g:Ya;Ya=Va+16|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=f[ua+120>>2]|0;ua=Ya;Va=C1a(f[ua>>2]|0,f[ua+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;ua=Ya;f[ua>>2]=Va;f[ua+4>>2]=J;eb=Ya+8|0}else{f[_a>>2]=S;Ya=f[Pa>>2]|0;ua=(f[Ya+20>>2]|0)+(Y(f[f[Ya+48>>2]>>2]|0,S)|0)|0;Va=f[ua>>2]|0;f[ua>>2]=(Va|0)>($a|0)?$a:Va;Va=ua+8|0;x=f[Va>>2]|0;f[Va>>2]=(x|0)<($a|0)?$a:x;x=ua+4|0;Va=f[x>>2]|0;f[x>>2]=(Va|0)>(g|0)?g:Va;Va=ua+12|0;x=f[Va>>2]|0;f[Va>>2]=(x|0)<(g|0)?g:x;x=ua+16|0;f[x>>2]=(f[x>>2]|0)+1;x=f[Ya+120>>2]|0;Ya=x+(S<<4)|0;ua=Ya;Va=C1a(f[ua>>2]|0,f[ua+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;ua=Ya;f[ua>>2]=Va;f[ua+4>>2]=J;eb=x+(S<<4)+8|0}x=eb;ua=C1a(f[x>>2]|0,f[x+4>>2]|0,g|0,Ua|0)|0;x=eb;f[x>>2]=ua;f[x+4>>2]=J;x=$a|1;ua=f[Ba>>2]|0;if((x|0)>=(f[ua+12>>2]|0)){if((bb|0)>=(f[ua+8>>2]|0))break;ua=Za+($a<<2)|0;if(!(b[Oa+$a>>0]|0)){f[ua>>2]=0;Va=f[Pa>>2]|0;Ya=f[Va+20>>2]|0;Wa=f[Ya>>2]|0;f[Ya>>2]=(Wa|0)>($a|0)?$a:Wa;Wa=Ya+8|0;Ia=f[Wa>>2]|0;f[Wa>>2]=(Ia|0)<($a|0)?$a:Ia;Ia=Ya+4|0;Wa=f[Ia>>2]|0;f[Ia>>2]=(Wa|0)>(bb|0)?bb:Wa;Wa=Ya+12|0;Ia=f[Wa>>2]|0;f[Wa>>2]=(Ia|0)<(bb|0)?bb:Ia;Ia=Ya+16|0;f[Ia>>2]=(f[Ia>>2]|0)+1;Ia=f[Va+120>>2]|0;Va=Ia;Ya=C1a(f[Va>>2]|0,f[Va+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;Va=Ia;f[Va>>2]=Ya;f[Va+4>>2]=J;Va=Ia+8|0;Ia=Va;Ya=C1a(f[Ia>>2]|0,f[Ia+4>>2]|0,bb|0,ab|0)|0;Ia=Va;f[Ia>>2]=Ya;f[Ia+4>>2]=J;break}else{f[ua>>2]=S;ua=f[Pa>>2]|0;Ia=(f[ua+20>>2]|0)+(Y(f[f[ua+48>>2]>>2]|0,S)|0)|0;Ya=f[Ia>>2]|0;f[Ia>>2]=(Ya|0)>($a|0)?$a:Ya;Ya=Ia+8|0;Va=f[Ya>>2]|0;f[Ya>>2]=(Va|0)<($a|0)?$a:Va;Va=Ia+4|0;Ya=f[Va>>2]|0;f[Va>>2]=(Ya|0)>(bb|0)?bb:Ya;Ya=Ia+12|0;Va=f[Ya>>2]|0;f[Ya>>2]=(Va|0)<(bb|0)?bb:Va;Va=Ia+16|0;f[Va>>2]=(f[Va>>2]|0)+1;Va=f[ua+120>>2]|0;ua=Va+(S<<4)|0;Ia=ua;Ya=C1a(f[Ia>>2]|0,f[Ia+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;Ia=ua;f[Ia>>2]=Ya;f[Ia+4>>2]=J;Ia=Va+(S<<4)+8|0;Va=Ia;Ya=C1a(f[Va>>2]|0,f[Va+4>>2]|0,bb|0,ab|0)|0;Va=Ia;f[Va>>2]=Ya;f[Va+4>>2]=J;break}}Va=pa+(x<<2)|0;if(!(b[cb+x>>0]|0)){f[Va>>2]=0;Ya=f[Pa>>2]|0;Ia=f[Ya+20>>2]|0;ua=f[Ia>>2]|0;f[Ia>>2]=(ua|0)>(x|0)?x:ua;ua=Ia+8|0;Wa=f[ua>>2]|0;f[ua>>2]=(Wa|0)<(x|0)?x:Wa;Wa=Ia+4|0;ua=f[Wa>>2]|0;f[Wa>>2]=(ua|0)>(g|0)?g:ua;ua=Ia+12|0;Wa=f[ua>>2]|0;f[ua>>2]=(Wa|0)<(g|0)?g:Wa;Wa=Ia+16|0;f[Wa>>2]=(f[Wa>>2]|0)+1;Wa=f[Ya+120>>2]|0;Ya=Wa;Ia=C1a(f[Ya>>2]|0,f[Ya+4>>2]|0,x|0,((x|0)<0)<<31>>31|0)|0;Ya=Wa;f[Ya>>2]=Ia;f[Ya+4>>2]=J;fb=Wa+8|0}else{f[Va>>2]=S;Va=f[Pa>>2]|0;Wa=(f[Va+20>>2]|0)+(Y(f[f[Va+48>>2]>>2]|0,S)|0)|0;Ya=f[Wa>>2]|0;f[Wa>>2]=(Ya|0)>(x|0)?x:Ya;Ya=Wa+8|0;Ia=f[Ya>>2]|0;f[Ya>>2]=(Ia|0)<(x|0)?x:Ia;Ia=Wa+4|0;Ya=f[Ia>>2]|0;f[Ia>>2]=(Ya|0)>(g|0)?g:Ya;Ya=Wa+12|0;Ia=f[Ya>>2]|0;f[Ya>>2]=(Ia|0)<(g|0)?g:Ia;Ia=Wa+16|0;f[Ia>>2]=(f[Ia>>2]|0)+1;Ia=f[Va+120>>2]|0;Va=Ia+(S<<4)|0;Wa=Va;Ya=C1a(f[Wa>>2]|0,f[Wa+4>>2]|0,x|0,((x|0)<0)<<31>>31|0)|0;Wa=Va;f[Wa>>2]=Ya;f[Wa+4>>2]=J;fb=Ia+(S<<4)+8|0}Ia=fb;Wa=C1a(f[Ia>>2]|0,f[Ia+4>>2]|0,g|0,Ua|0)|0;Ia=fb;f[Ia>>2]=Wa;f[Ia+4>>2]=J;if((bb|0)<(f[(f[Ba>>2]|0)+8>>2]|0)){Ia=Za+($a<<2)|0;if(!(b[Oa+$a>>0]|0)){f[Ia>>2]=0;Wa=f[Pa>>2]|0;Ya=f[Wa+20>>2]|0;Va=f[Ya>>2]|0;f[Ya>>2]=(Va|0)>($a|0)?$a:Va;Va=Ya+8|0;ua=f[Va>>2]|0;f[Va>>2]=(ua|0)<($a|0)?$a:ua;ua=Ya+4|0;Va=f[ua>>2]|0;f[ua>>2]=(Va|0)>(bb|0)?bb:Va;Va=Ya+12|0;ua=f[Va>>2]|0;f[Va>>2]=(ua|0)<(bb|0)?bb:ua;ua=Ya+16|0;f[ua>>2]=(f[ua>>2]|0)+1;ua=f[Wa+120>>2]|0;Wa=ua;Ya=C1a(f[Wa>>2]|0,f[Wa+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;Wa=ua;f[Wa>>2]=Ya;f[Wa+4>>2]=J;gb=ua+8|0}else{f[Ia>>2]=S;Ia=f[Pa>>2]|0;ua=(f[Ia+20>>2]|0)+(Y(f[f[Ia+48>>2]>>2]|0,S)|0)|0;Wa=f[ua>>2]|0;f[ua>>2]=(Wa|0)>($a|0)?$a:Wa;Wa=ua+8|0;Ya=f[Wa>>2]|0;f[Wa>>2]=(Ya|0)<($a|0)?$a:Ya;Ya=ua+4|0;Wa=f[Ya>>2]|0;f[Ya>>2]=(Wa|0)>(bb|0)?bb:Wa;Wa=ua+12|0;Ya=f[Wa>>2]|0;f[Wa>>2]=(Ya|0)<(bb|0)?bb:Ya;Ya=ua+16|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=f[Ia+120>>2]|0;Ia=Ya+(S<<4)|0;ua=Ia;Wa=C1a(f[ua>>2]|0,f[ua+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;ua=Ia;f[ua>>2]=Wa;f[ua+4>>2]=J;gb=Ya+(S<<4)+8|0}Ya=gb;ua=C1a(f[Ya>>2]|0,f[Ya+4>>2]|0,bb|0,ab|0)|0;Ya=gb;f[Ya>>2]=ua;f[Ya+4>>2]=J;Ya=Za+(x<<2)|0;if(!(b[Oa+x>>0]|0)){f[Ya>>2]=0;ua=f[Pa>>2]|0;Wa=f[ua+20>>2]|0;Ia=f[Wa>>2]|0;f[Wa>>2]=(Ia|0)>(x|0)?x:Ia;Ia=Wa+8|0;Va=f[Ia>>2]|0;f[Ia>>2]=(Va|0)<(x|0)?x:Va;Va=Wa+4|0;Ia=f[Va>>2]|0;f[Va>>2]=(Ia|0)>(bb|0)?bb:Ia;Ia=Wa+12|0;Va=f[Ia>>2]|0;f[Ia>>2]=(Va|0)<(bb|0)?bb:Va;Va=Wa+16|0;f[Va>>2]=(f[Va>>2]|0)+1;Va=f[ua+120>>2]|0;ua=Va;Wa=C1a(f[ua>>2]|0,f[ua+4>>2]|0,x|0,((x|0)<0)<<31>>31|0)|0;ua=Va;f[ua>>2]=Wa;f[ua+4>>2]=J;ua=Va+8|0;Va=ua;Wa=C1a(f[Va>>2]|0,f[Va+4>>2]|0,bb|0,ab|0)|0;Va=ua;f[Va>>2]=Wa;f[Va+4>>2]=J;break}else{f[Ya>>2]=S;Ya=f[Pa>>2]|0;Va=(f[Ya+20>>2]|0)+(Y(f[f[Ya+48>>2]>>2]|0,S)|0)|0;Wa=f[Va>>2]|0;f[Va>>2]=(Wa|0)>(x|0)?x:Wa;Wa=Va+8|0;ua=f[Wa>>2]|0;f[Wa>>2]=(ua|0)<(x|0)?x:ua;ua=Va+4|0;Wa=f[ua>>2]|0;f[ua>>2]=(Wa|0)>(bb|0)?bb:Wa;Wa=Va+12|0;ua=f[Wa>>2]|0;f[Wa>>2]=(ua|0)<(bb|0)?bb:ua;ua=Va+16|0;f[ua>>2]=(f[ua>>2]|0)+1;ua=f[Ya+120>>2]|0;Ya=ua+(S<<4)|0;Va=Ya;Wa=C1a(f[Va>>2]|0,f[Va+4>>2]|0,x|0,((x|0)<0)<<31>>31|0)|0;x=Ya;f[x>>2]=Wa;f[x+4>>2]=J;x=ua+(S<<4)+8|0;S=x;ua=C1a(f[S>>2]|0,f[S+4>>2]|0,bb|0,ab|0)|0;S=x;f[S>>2]=ua;f[S+4>>2]=J;break}}}else{f[_a>>2]=0;S=f[Pa>>2]|0;ua=f[S+20>>2]|0;x=f[ua>>2]|0;f[ua>>2]=(x|0)>($a|0)?$a:x;x=ua+8|0;Wa=f[x>>2]|0;f[x>>2]=(Wa|0)<($a|0)?$a:Wa;Wa=ua+4|0;x=f[Wa>>2]|0;f[Wa>>2]=(x|0)>(g|0)?g:x;x=ua+12|0;Wa=f[x>>2]|0;f[x>>2]=(Wa|0)<(g|0)?g:Wa;Wa=ua+16|0;f[Wa>>2]=(f[Wa>>2]|0)+1;Wa=f[S+120>>2]|0;S=(($a|0)<0)<<31>>31;ua=Wa;x=C1a(f[ua>>2]|0,f[ua+4>>2]|0,$a|0,S|0)|0;ua=Wa;f[ua>>2]=x;f[ua+4>>2]=J;ua=Wa+8|0;Wa=ua;x=C1a(f[Wa>>2]|0,f[Wa+4>>2]|0,g|0,Ua|0)|0;Wa=ua;f[Wa>>2]=x;f[Wa+4>>2]=J;Wa=$a|1;x=f[Ba>>2]|0;if((Wa|0)<(f[x+12>>2]|0)){f[pa+(Wa<<2)>>2]=0;ua=f[Pa>>2]|0;Ya=f[ua+20>>2]|0;Va=f[Ya>>2]|0;f[Ya>>2]=(Va|0)>(Wa|0)?Wa:Va;Va=Ya+8|0;Ia=f[Va>>2]|0;f[Va>>2]=(Ia|0)<(Wa|0)?Wa:Ia;Ia=Ya+4|0;Va=f[Ia>>2]|0;f[Ia>>2]=(Va|0)>(g|0)?g:Va;Va=Ya+12|0;Ia=f[Va>>2]|0;f[Va>>2]=(Ia|0)<(g|0)?g:Ia;Ia=Ya+16|0;f[Ia>>2]=(f[Ia>>2]|0)+1;Ia=f[ua+120>>2]|0;ua=((Wa|0)<0)<<31>>31;Ya=Ia;Va=C1a(f[Ya>>2]|0,f[Ya+4>>2]|0,Wa|0,ua|0)|0;Ya=Ia;f[Ya>>2]=Va;f[Ya+4>>2]=J;Ya=Ia+8|0;Ia=Ya;Va=C1a(f[Ia>>2]|0,f[Ia+4>>2]|0,g|0,Ua|0)|0;Ia=Ya;f[Ia>>2]=Va;f[Ia+4>>2]=J;if((bb|0)>=(f[(f[Ba>>2]|0)+8>>2]|0))break;f[Za+($a<<2)>>2]=0;f[Za+(Wa<<2)>>2]=0;Ia=f[Pa>>2]|0;Va=f[Ia+20>>2]|0;Ya=f[Va>>2]|0;f[Va>>2]=(Ya|0)>($a|0)?$a:Ya;Ya=Va+8|0;Xa=f[Ya>>2]|0;f[Ya>>2]=(Xa|0)<($a|0)?$a:Xa;Xa=Va+4|0;Ya=f[Xa>>2]|0;f[Xa>>2]=(Ya|0)>(bb|0)?bb:Ya;Ya=Va+12|0;Xa=f[Ya>>2]|0;f[Ya>>2]=(Xa|0)<(bb|0)?bb:Xa;Xa=Va+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=f[Ia+120>>2]|0;Ia=Xa;Va=C1a(f[Ia>>2]|0,f[Ia+4>>2]|0,$a|0,S|0)|0;Ia=Xa;f[Ia>>2]=Va;f[Ia+4>>2]=J;Ia=Xa+8|0;Xa=Ia;Va=C1a(f[Xa>>2]|0,f[Xa+4>>2]|0,bb|0,ab|0)|0;Xa=Ia;f[Xa>>2]=Va;f[Xa+4>>2]=J;Xa=f[Pa>>2]|0;Va=f[Xa+20>>2]|0;Ia=f[Va>>2]|0;f[Va>>2]=(Ia|0)>(Wa|0)?Wa:Ia;Ia=Va+8|0;Ya=f[Ia>>2]|0;f[Ia>>2]=(Ya|0)<(Wa|0)?Wa:Ya;Ya=Va+4|0;Ia=f[Ya>>2]|0;f[Ya>>2]=(Ia|0)>(bb|0)?bb:Ia;Ia=Va+12|0;Ya=f[Ia>>2]|0;f[Ia>>2]=(Ya|0)<(bb|0)?bb:Ya;Ya=Va+16|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=f[Xa+120>>2]|0;Xa=Ya;Va=C1a(f[Xa>>2]|0,f[Xa+4>>2]|0,Wa|0,ua|0)|0;ua=Ya;f[ua>>2]=Va;f[ua+4>>2]=J;ua=Ya+8|0;Ya=ua;Va=C1a(f[Ya>>2]|0,f[Ya+4>>2]|0,bb|0,ab|0)|0;Ya=ua;f[Ya>>2]=Va;f[Ya+4>>2]=J;break}else{if((bb|0)>=(f[x+8>>2]|0))break;f[Za+($a<<2)>>2]=0;x=f[Pa>>2]|0;Ya=f[x+20>>2]|0;Va=f[Ya>>2]|0;f[Ya>>2]=(Va|0)>($a|0)?$a:Va;Va=Ya+8|0;ua=f[Va>>2]|0;f[Va>>2]=(ua|0)<($a|0)?$a:ua;ua=Ya+4|0;Va=f[ua>>2]|0;f[ua>>2]=(Va|0)>(bb|0)?bb:Va;Va=Ya+12|0;ua=f[Va>>2]|0;f[Va>>2]=(ua|0)<(bb|0)?bb:ua;ua=Ya+16|0;f[ua>>2]=(f[ua>>2]|0)+1;ua=f[x+120>>2]|0;x=ua;Ya=C1a(f[x>>2]|0,f[x+4>>2]|0,$a|0,S|0)|0;S=ua;f[S>>2]=Ya;f[S+4>>2]=J;S=ua+8|0;ua=S;Ya=C1a(f[ua>>2]|0,f[ua+4>>2]|0,bb|0,ab|0)|0;ua=S;f[ua>>2]=Ya;f[ua+4>>2]=J;break}}while(0);$a=$a+2|0;_a=f[Ba>>2]|0;i=f[_a+12>>2]|0}while(($a|0)<(i|0));hb=i;ib=_a}else{hb=a;ib=e}g=g+2|0;if((g|0)>=(c|0))break;else{a=hb;e=ib}}return}}function Q6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+80|0;d=c;e=c+16|0;f[e>>2]=1124007936;g=e+4|0;h=e+8|0;i=e+40|0;j=g;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;j=e+48|0;k=e+44|0;f[k>>2]=j;f[j>>2]=0;f[e+52>>2]=0;f[d>>2]=b;f[d+4>>2]=5;AR(e,2,d,4);l=a+4|0;m=e+36|0;n=f[m>>2]|0;if((l|0)==(e|0))o=n;else{if(n|0){p=n+12|0;f[p>>2]=(f[p>>2]|0)+1}p=a+40|0;n=f[p>>2]|0;if(n|0?(q=n+12|0,n=f[q>>2]|0,f[q>>2]=n+-1,(n|0)==1):0)CR(l);f[p>>2]=0;n=a+20|0;q=a+8|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[q>>2]|0)>0){r=f[a+44>>2]|0;s=0;do{f[r+(s<<2)>>2]=0;s=s+1|0;t=f[q>>2]|0}while((s|0)<(t|0));f[l>>2]=f[e>>2];if((t|0)<3)v=12;else v=14}else{f[l>>2]=f[e>>2];v=12}if((v|0)==12){t=f[g>>2]|0;if((t|0)<3){f[q>>2]=t;f[a+12>>2]=f[h>>2];f[a+16>>2]=f[e+12>>2];h=f[k>>2]|0;t=f[a+48>>2]|0;f[t>>2]=f[h>>2];f[t+4>>2]=f[h+4>>2]}else v=14}if((v|0)==14)BR(l,e);f[n>>2]=f[e+16>>2];f[a+24>>2]=f[e+20>>2];f[a+28>>2]=f[e+24>>2];f[a+32>>2]=f[e+28>>2];f[a+36>>2]=f[e+32>>2];n=f[m>>2]|0;f[p>>2]=n;o=n}if(o|0?(n=o+12|0,o=f[n>>2]|0,f[n>>2]=o+-1,(o|0)==1):0)CR(e);f[m>>2]=0;m=e+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[g>>2]|0)>0){m=f[i>>2]|0;i=0;do{f[m+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[g>>2]|0))}g=f[k>>2]|0;if((g|0)!=(j|0))ZF(g);if((b|0)>0){g=f[a+20>>2]|0;j=f[a+48>>2]|0;k=0;do{i=g+(Y(f[j>>2]|0,k)|0)|0;f[i>>2]=2147483647;f[i+4>>2]=2147483647;f[i+8>>2]=-2147483648;f[i+12>>2]=-2147483648;f[i+16>>2]=0;k=k+1|0}while((k|0)!=(b|0))}k=a+120|0;j=a+124|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;a=f[j>>2]|0;g=f[k>>2]|0;i=a-g>>4;m=a;if(i>>>0<b>>>0){R6(k,b-i|0,d);u=c;return}if(i>>>0<=b>>>0){u=c;return}i=g+(b<<4)|0;if((m|0)==(i|0)){u=c;return}f[j>>2]=m+(~((m+-16-i|0)>>>4)<<4);u=c;return}function R6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>4>>>0>=b>>>0){i=h;j=b;do{f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];f[i+8>>2]=f[c+8>>2];f[i+12>>2]=f[c+12>>2];i=(f[g>>2]|0)+16|0;f[g>>2]=i;j=j+-1|0}while((j|0)!=0);return}j=f[a>>2]|0;i=h-j>>4;h=i+b|0;if(h>>>0>268435455)gXa(a);k=e-j|0;j=k>>3;e=k>>4>>>0<134217727?(j>>>0<h>>>0?h:j):268435455;do if(e)if(e>>>0>268435455){j=De(8)|0;UYa(j,358155);f[j>>2]=130560;Of(j|0,21520,875)}else{l=NYa(e<<4)|0;break}else l=0;while(0);j=l+(i<<4)|0;i=l+(e<<4)|0;e=j;l=b;b=j;do{f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];f[e+8>>2]=f[c+8>>2];f[e+12>>2]=f[c+12>>2];e=b+16|0;b=e;l=l+-1|0}while((l|0)!=0);l=f[a>>2]|0;e=(f[g>>2]|0)-l|0;c=j+(0-(e>>4)<<4)|0;if((e|0)>0)K1a(c|0,l|0,e|0)|0;f[a>>2]=c;f[g>>2]=b;f[d>>2]=i;if(!l)return;PYa(l);return}function S6(a){a=a|0;PYa(a);return}
function n6(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0;h=u;u=u+16|0;a=h;i=c+8|0;k=e+8|0;if((f[i>>2]|0)!=(f[k>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;l=c$(a,26)|0;m=218300;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-215,a,373355,218048,2594);d$(a)}o=c+12|0;p=e+12|0;if((f[o>>2]|0)!=(f[p>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;l=c$(a,26)|0;m=218327;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-215,a,373355,218048,2595);d$(a)}if((g|0)!=8){f[a>>2]=0;f[a+4>>2]=0;l=c$(a,17)|0;m=218354;n=l+17|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-215,a,373355,218048,2596);d$(a)}a=f[i>>2]|0;i=f[o>>2]|0;o=YF((Y(((a+1|0)/2|0)<<1,(i+1|0)/2|0)|0)+2|0)|0;d[o>>1]=0;if((a|0)>0){m=c+16|0;l=c+44|0;n=e+16|0;g=e+44|0;q=(i|0)>0;r=1;s=0;while(1){t=f[f[l>>2]>>2]|0;v=(f[m>>2]|0)+(Y(t,s)|0)|0;w=0-t|0;x=v+w|0;y=x+w|0;w=v+t|0;t=f[f[g>>2]>>2]|0;z=(f[n>>2]|0)+(Y(t,s)|0)|0;A=0-t|0;t=z+A+A|0;if(q){A=(s|1|0)<(a|0);B=(s|0)>0;C=B^1;D=(s+-2|0)>-1;E=0;F=r;while(1){a:do if(!(b[v+E>>0]|0)){G=E|1;H=(G|0)<(i|0);if(A?b[w+E>>0]|0:0){I=E+-1|0;J=(E|0)>0;if(H?b[v+G>>0]|0:0){do if(J){if(b[v+I>>0]|0){do if(B){if(b[x+G>>0]|0){if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break a}do if(D){if(!(b[y+E>>0]|0))break;L=E+-2|0;if(b[x+I>>0]|0){d[z+(E<<1)>>1]=d[z+(L<<1)>>1]|0;K=F;break a}do if((L|0)>-1){if(!(b[x+L>>0]|0))break;if(b[y+I>>0]|0){d[z+(E<<1)>>1]=d[z+(L<<1)>>1]|0;K=F;break a}M=d[t+(E<<1)>>1]|0;N=d[z+(L<<1)>>1]|0;O=M;while(1){P=d[o+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}if(M<<16>>16==N<<16>>16)Q=O;else{P=N;while(1){R=d[o+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}R=(O&65535)>(P&65535)?P:O;S=N;do{T=o+((S&65535)<<1)|0;U=S;S=d[T>>1]|0;d[T>>1]=R}while((S&65535)<(U&65535));Q=R}R=M;do{S=o+((R&65535)<<1)|0;N=R;R=d[S>>1]|0;d[S>>1]=Q}while((R&65535)<(N&65535));d[z+(E<<1)>>1]=Q;K=F;break a}while(0);R=d[t+(E<<1)>>1]|0;M=d[z+(L<<1)>>1]|0;N=R;while(1){S=d[o+((N&65535)<<1)>>1]|0;if((S&65535)<(N&65535))N=S;else break}if(R<<16>>16==M<<16>>16)V=N;else{L=M;while(1){S=d[o+((L&65535)<<1)>>1]|0;if((S&65535)<(L&65535))L=S;else break}S=(N&65535)>(L&65535)?L:N;O=M;do{P=o+((O&65535)<<1)|0;U=O;O=d[P>>1]|0;d[P>>1]=S}while((O&65535)<(U&65535));V=S}S=R;do{O=o+((S&65535)<<1)|0;M=S;S=d[O>>1]|0;d[O>>1]=V}while((S&65535)<(M&65535));d[z+(E<<1)>>1]=V;K=F;break a}while(0);S=d[t+(E<<1)>>1]|0;R=d[z+(E+-2<<1)>>1]|0;M=S;while(1){O=d[o+((M&65535)<<1)>>1]|0;if((O&65535)<(M&65535))M=O;else break}if(S<<16>>16==R<<16>>16)W=M;else{O=R;while(1){N=d[o+((O&65535)<<1)>>1]|0;if((N&65535)<(O&65535))O=N;else break}N=(M&65535)>(O&65535)?O:M;L=R;do{U=o+((L&65535)<<1)|0;P=L;L=d[U>>1]|0;d[U>>1]=N}while((L&65535)<(P&65535));W=N}N=S;do{L=o+((N&65535)<<1)|0;R=N;N=d[L>>1]|0;d[L>>1]=W}while((N&65535)<(R&65535));d[z+(E<<1)>>1]=W;K=F;break a}N=E+2|0;if((N|0)>=(i|0))break;if(!(b[x+N>>0]|0))break;do if(D){if(!(b[y+G>>0]|0))break;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break a}if(!(b[y+E>>0]|0)){S=d[t+(N<<1)>>1]|0;R=d[z+(E+-2<<1)>>1]|0;L=S;while(1){M=d[o+((L&65535)<<1)>>1]|0;if((M&65535)<(L&65535))L=M;else break}if(S<<16>>16==R<<16>>16)X=L;else{M=R;while(1){O=d[o+((M&65535)<<1)>>1]|0;if((O&65535)<(M&65535))M=O;else break}O=(L&65535)>(M&65535)?M:L;P=R;do{U=o+((P&65535)<<1)|0;T=P;P=d[U>>1]|0;d[U>>1]=O}while((P&65535)<(T&65535));X=O}O=S;do{P=o+((O&65535)<<1)|0;R=O;O=d[P>>1]|0;d[P>>1]=X}while((O&65535)<(R&65535));d[z+(E<<1)>>1]=X;K=F;break a}O=E+-2|0;if(b[x+I>>0]|0){d[z+(E<<1)>>1]=d[z+(O<<1)>>1]|0;K=F;break a}do if((O|0)>-1){if(!(b[x+O>>0]|0))break;if(b[y+I>>0]|0){d[z+(E<<1)>>1]=d[z+(O<<1)>>1]|0;K=F;break a}S=d[t+(N<<1)>>1]|0;R=d[z+(O<<1)>>1]|0;P=S;while(1){L=d[o+((P&65535)<<1)>>1]|0;if((L&65535)<(P&65535))P=L;else break}if(S<<16>>16==R<<16>>16)Z=P;else{L=R;while(1){M=d[o+((L&65535)<<1)>>1]|0;if((M&65535)<(L&65535))L=M;else break}M=(P&65535)>(L&65535)?L:P;T=R;do{U=o+((T&65535)<<1)|0;_=T;T=d[U>>1]|0;d[U>>1]=M}while((T&65535)<(_&65535));Z=M}M=S;do{T=o+((M&65535)<<1)|0;R=M;M=d[T>>1]|0;d[T>>1]=Z}while((M&65535)<(R&65535));d[z+(E<<1)>>1]=Z;K=F;break a}while(0);M=d[t+(N<<1)>>1]|0;S=d[z+(O<<1)>>1]|0;R=M;while(1){T=d[o+((R&65535)<<1)>>1]|0;if((T&65535)<(R&65535))R=T;else break}if(M<<16>>16==S<<16>>16)$=R;else{O=S;while(1){T=d[o+((O&65535)<<1)>>1]|0;if((T&65535)<(O&65535))O=T;else break}T=(R&65535)>(O&65535)?O:R;P=S;do{L=o+((P&65535)<<1)|0;_=P;P=d[L>>1]|0;d[L>>1]=T}while((P&65535)<(_&65535));$=T}T=M;do{P=o+((T&65535)<<1)|0;S=T;T=d[P>>1]|0;d[P>>1]=$}while((T&65535)<(S&65535));d[z+(E<<1)>>1]=$;K=F;break a}while(0);T=d[t+(N<<1)>>1]|0;M=d[z+(E+-2<<1)>>1]|0;S=T;while(1){P=d[o+((S&65535)<<1)>>1]|0;if((P&65535)<(S&65535))S=P;else break}if(T<<16>>16==M<<16>>16)aa=S;else{N=M;while(1){P=d[o+((N&65535)<<1)>>1]|0;if((P&65535)<(N&65535))N=P;else break}P=(S&65535)>(N&65535)?N:S;R=M;do{O=o+((R&65535)<<1)|0;_=R;R=d[O>>1]|0;d[O>>1]=P}while((R&65535)<(_&65535));aa=P}P=T;do{R=o+((P&65535)<<1)|0;M=P;P=d[R>>1]|0;d[R>>1]=aa}while((P&65535)<(M&65535));d[z+(E<<1)>>1]=aa;K=F;break a}while(0);d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break a}if(!(b[w+I>>0]|0))break;do if(B){if(b[x+G>>0]|0){P=E+-2|0;do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[x+I>>0]|0){T=d[z+(P<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}do if(D){if(!(b[y+E>>0]|0))break;d[z+(E<<1)>>1]=T;K=F;break a}while(0);M=d[t+(E<<1)>>1]|0;R=M;while(1){S=d[o+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}if(M<<16>>16==T<<16>>16)ba=R;else{S=T;while(1){N=d[o+((S&65535)<<1)>>1]|0;if((N&65535)<(S&65535))S=N;else break}N=(R&65535)>(S&65535)?S:R;_=T;do{O=o+((_&65535)<<1)|0;L=_;_=d[O>>1]|0;d[O>>1]=N}while((_&65535)<(L&65535));ba=N}N=M;do{_=o+((N&65535)<<1)|0;T=N;N=d[_>>1]|0;d[_>>1]=ba}while((N&65535)<(T&65535));d[z+(E<<1)>>1]=ba;K=F;break a}if(!(b[x+P>>0]|0)){N=d[t+(E<<1)>>1]|0;M=d[z+(P<<1)>>1]|0;T=N;while(1){_=d[o+((T&65535)<<1)>>1]|0;if((_&65535)<(T&65535))T=_;else break}if(N<<16>>16==M<<16>>16)ca=T;else{_=M;while(1){R=d[o+((_&65535)<<1)>>1]|0;if((R&65535)<(_&65535))_=R;else break}R=(T&65535)>(_&65535)?_:T;S=M;do{L=o+((S&65535)<<1)|0;O=S;S=d[L>>1]|0;d[L>>1]=R}while((S&65535)<(O&65535));ca=R}R=N;do{S=o+((R&65535)<<1)|0;M=R;R=d[S>>1]|0;d[S>>1]=ca}while((R&65535)<(M&65535));d[z+(E<<1)>>1]=ca;K=F;break a}do if(D){if(!(b[y+I>>0]|0))break;R=d[z+(P<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=R;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=R;K=F;break a}N=d[t+(E<<1)>>1]|0;M=N;while(1){S=d[o+((M&65535)<<1)>>1]|0;if((S&65535)<(M&65535))M=S;else break}if(N<<16>>16==R<<16>>16)da=M;else{S=R;while(1){T=d[o+((S&65535)<<1)>>1]|0;if((T&65535)<(S&65535))S=T;else break}T=(M&65535)>(S&65535)?S:M;_=R;do{O=o+((_&65535)<<1)|0;L=_;_=d[O>>1]|0;d[O>>1]=T}while((_&65535)<(L&65535));da=T}T=N;do{_=o+((T&65535)<<1)|0;R=T;T=d[_>>1]|0;d[_>>1]=da}while((T&65535)<(R&65535));d[z+(E<<1)>>1]=da;K=F;break a}while(0);T=d[t+(E<<1)>>1]|0;N=d[z+(P<<1)>>1]|0;R=T;while(1){_=d[o+((R&65535)<<1)>>1]|0;if((_&65535)<(R&65535))R=_;else break}if(T<<16>>16==N<<16>>16)ea=R;else{_=N;while(1){M=d[o+((_&65535)<<1)>>1]|0;if((M&65535)<(_&65535))_=M;else break}M=(R&65535)>(_&65535)?_:R;S=N;do{L=o+((S&65535)<<1)|0;O=S;S=d[L>>1]|0;d[L>>1]=M}while((S&65535)<(O&65535));ea=M}M=T;do{S=o+((M&65535)<<1)|0;N=M;M=d[S>>1]|0;d[S>>1]=ea}while((M&65535)<(N&65535));d[z+(E<<1)>>1]=ea;K=F;break a}while(0);M=d[t+(E<<1)>>1]|0;T=d[z+(P<<1)>>1]|0;N=M;while(1){S=d[o+((N&65535)<<1)>>1]|0;if((S&65535)<(N&65535))N=S;else break}if(M<<16>>16==T<<16>>16)fa=N;else{P=T;while(1){S=d[o+((P&65535)<<1)>>1]|0;if((S&65535)<(P&65535))P=S;else break}S=(N&65535)>(P&65535)?P:N;R=T;do{_=o+((R&65535)<<1)|0;O=R;R=d[_>>1]|0;d[_>>1]=S}while((R&65535)<(O&65535));fa=S}S=M;do{R=o+((S&65535)<<1)|0;T=S;S=d[R>>1]|0;d[R>>1]=fa}while((S&65535)<(T&65535));d[z+(E<<1)>>1]=fa;K=F;break a}S=E+2|0;do if(!((S|0)>=(i|0)|C)){if(!(b[x+S>>0]|0))break;do if(D){if(!(b[y+G>>0]|0))break;M=E+-2|0;do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[x+I>>0]|0){T=d[z+(M<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}R=d[t+(S<<1)>>1]|0;N=R;while(1){P=d[o+((N&65535)<<1)>>1]|0;if((P&65535)<(N&65535))N=P;else break}if(R<<16>>16==T<<16>>16)ga=N;else{P=T;while(1){O=d[o+((P&65535)<<1)>>1]|0;if((O&65535)<(P&65535))P=O;else break}O=(N&65535)>(P&65535)?P:N;_=T;do{L=o+((_&65535)<<1)|0;U=_;_=d[L>>1]|0;d[L>>1]=O}while((_&65535)<(U&65535));ga=O}O=R;do{_=o+((O&65535)<<1)|0;T=O;O=d[_>>1]|0;d[_>>1]=ga}while((O&65535)<(T&65535));d[z+(E<<1)>>1]=ga;K=F;break a}if(!(b[x+M>>0]|0)){O=d[t+(S<<1)>>1]|0;R=d[z+(M<<1)>>1]|0;T=O;while(1){_=d[o+((T&65535)<<1)>>1]|0;if((_&65535)<(T&65535))T=_;else break}if(O<<16>>16==R<<16>>16)ha=T;else{_=R;while(1){N=d[o+((_&65535)<<1)>>1]|0;if((N&65535)<(_&65535))_=N;else break}N=(T&65535)>(_&65535)?_:T;P=R;do{U=o+((P&65535)<<1)|0;L=P;P=d[U>>1]|0;d[U>>1]=N}while((P&65535)<(L&65535));ha=N}N=O;do{P=o+((N&65535)<<1)|0;R=N;N=d[P>>1]|0;d[P>>1]=ha}while((N&65535)<(R&65535));d[z+(E<<1)>>1]=ha;K=F;break a}if(!(b[y+I>>0]|0)){N=d[t+(S<<1)>>1]|0;O=d[z+(M<<1)>>1]|0;R=N;while(1){P=d[o+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}if(N<<16>>16==O<<16>>16)ia=R;else{P=O;while(1){T=d[o+((P&65535)<<1)>>1]|0;if((T&65535)<(P&65535))P=T;else break}T=(R&65535)>(P&65535)?P:R;_=O;do{L=o+((_&65535)<<1)|0;U=_;_=d[L>>1]|0;d[L>>1]=T}while((_&65535)<(U&65535));ia=T}T=N;do{_=o+((T&65535)<<1)|0;O=T;T=d[_>>1]|0;d[_>>1]=ia}while((T&65535)<(O&65535));d[z+(E<<1)>>1]=ia;K=F;break a}T=d[z+(M<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}N=d[t+(S<<1)>>1]|0;O=N;while(1){_=d[o+((O&65535)<<1)>>1]|0;if((_&65535)<(O&65535))O=_;else break}if(N<<16>>16==T<<16>>16)ja=O;else{_=T;while(1){R=d[o+((_&65535)<<1)>>1]|0;if((R&65535)<(_&65535))_=R;else break}R=(O&65535)>(_&65535)?_:O;P=T;do{U=o+((P&65535)<<1)|0;L=P;P=d[U>>1]|0;d[U>>1]=R}while((P&65535)<(L&65535));ja=R}R=N;do{P=o+((R&65535)<<1)|0;T=R;R=d[P>>1]|0;d[P>>1]=ja}while((R&65535)<(T&65535));d[z+(E<<1)>>1]=ja;K=F;break a}while(0);R=d[t+(S<<1)>>1]|0;N=d[z+(M<<1)>>1]|0;T=R;while(1){P=d[o+((T&65535)<<1)>>1]|0;if((P&65535)<(T&65535))T=P;else break}if(R<<16>>16==N<<16>>16)ka=T;else{M=N;while(1){P=d[o+((M&65535)<<1)>>1]|0;if((P&65535)<(M&65535))M=P;else break}P=(T&65535)>(M&65535)?M:T;O=N;do{_=o+((O&65535)<<1)|0;L=O;O=d[_>>1]|0;d[_>>1]=P}while((O&65535)<(L&65535));ka=P}P=R;do{O=o+((P&65535)<<1)|0;N=P;P=d[O>>1]|0;d[O>>1]=ka}while((P&65535)<(N&65535));d[z+(E<<1)>>1]=ka;K=F;break a}while(0);P=E+-2|0;if(!(b[x+E>>0]|0)){R=d[t+(S<<1)>>1]|0;N=d[z+(P<<1)>>1]|0;O=R;while(1){T=d[o+((O&65535)<<1)>>1]|0;if((T&65535)<(O&65535))O=T;else break}if(R<<16>>16==N<<16>>16)la=O;else{T=N;while(1){M=d[o+((T&65535)<<1)>>1]|0;if((M&65535)<(T&65535))T=M;else break}M=(O&65535)>(T&65535)?T:O;L=N;do{_=o+((L&65535)<<1)|0;U=L;L=d[_>>1]|0;d[_>>1]=M}while((L&65535)<(U&65535));la=M}M=R;do{L=o+((M&65535)<<1)|0;N=M;M=d[L>>1]|0;d[L>>1]=la}while((M&65535)<(N&65535));d[z+(E<<1)>>1]=la;K=F;break a}do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[x+I>>0]|0){M=d[t+(S<<1)>>1]|0;R=d[z+(P<<1)>>1]|0;N=M;while(1){L=d[o+((N&65535)<<1)>>1]|0;if((L&65535)<(N&65535))N=L;else break}if(M<<16>>16==R<<16>>16)ma=N;else{L=R;while(1){O=d[o+((L&65535)<<1)>>1]|0;if((O&65535)<(L&65535))L=O;else break}O=(N&65535)>(L&65535)?L:N;T=R;do{U=o+((T&65535)<<1)|0;_=T;T=d[U>>1]|0;d[U>>1]=O}while((T&65535)<(_&65535));ma=O}O=M;do{T=o+((O&65535)<<1)|0;R=O;O=d[T>>1]|0;d[T>>1]=ma}while((O&65535)<(R&65535));d[z+(E<<1)>>1]=ma;K=F;break a}if(!(b[x+P>>0]|0)){O=d[t+(E<<1)>>1]|0;M=d[t+(S<<1)>>1]|0;R=O;while(1){T=d[o+((R&65535)<<1)>>1]|0;if((T&65535)<(R&65535))R=T;else break}if(O<<16>>16==M<<16>>16)na=R;else{T=M;while(1){N=d[o+((T&65535)<<1)>>1]|0;if((N&65535)<(T&65535))T=N;else break}N=(R&65535)>(T&65535)?T:R;L=M;do{_=o+((L&65535)<<1)|0;U=L;L=d[_>>1]|0;d[_>>1]=N}while((L&65535)<(U&65535));na=N}N=O;do{L=o+((N&65535)<<1)|0;M=N;N=d[L>>1]|0;d[L>>1]=na}while((N&65535)<(M&65535));N=d[z+(P<<1)>>1]|0;O=na;while(1){M=d[o+((O&65535)<<1)>>1]|0;if((M&65535)<(O&65535))O=M;else break}if(na<<16>>16==N<<16>>16)oa=O;else{M=N;while(1){L=d[o+((M&65535)<<1)>>1]|0;if((L&65535)<(M&65535))M=L;else break}L=(O&65535)>(M&65535)?M:O;R=N;do{T=o+((R&65535)<<1)|0;U=R;R=d[T>>1]|0;d[T>>1]=L}while((R&65535)<(U&65535));oa=L}L=na;do{R=o+((L&65535)<<1)|0;N=L;L=d[R>>1]|0;d[R>>1]=oa}while((L&65535)<(N&65535));d[z+(E<<1)>>1]=oa;K=F;break a}do if(D){if(!(b[y+I>>0]|0))break;L=d[t+(S<<1)>>1]|0;N=d[z+(P<<1)>>1]|0;R=L;while(1){O=d[o+((R&65535)<<1)>>1]|0;if((O&65535)<(R&65535))R=O;else break}if(L<<16>>16==N<<16>>16)pa=R;else{O=N;while(1){M=d[o+((O&65535)<<1)>>1]|0;if((M&65535)<(O&65535))O=M;else break}M=(R&65535)>(O&65535)?O:R;U=N;do{T=o+((U&65535)<<1)|0;_=U;U=d[T>>1]|0;d[T>>1]=M}while((U&65535)<(_&65535));pa=M}M=L;do{U=o+((M&65535)<<1)|0;N=M;M=d[U>>1]|0;d[U>>1]=pa}while((M&65535)<(N&65535));d[z+(E<<1)>>1]=pa;K=F;break a}while(0);M=d[t+(E<<1)>>1]|0;L=d[t+(S<<1)>>1]|0;N=M;while(1){U=d[o+((N&65535)<<1)>>1]|0;if((U&65535)<(N&65535))N=U;else break}if(M<<16>>16==L<<16>>16)qa=N;else{U=L;while(1){R=d[o+((U&65535)<<1)>>1]|0;if((R&65535)<(U&65535))U=R;else break}R=(N&65535)>(U&65535)?U:N;O=L;do{_=o+((O&65535)<<1)|0;T=O;O=d[_>>1]|0;d[_>>1]=R}while((O&65535)<(T&65535));qa=R}R=M;do{O=o+((R&65535)<<1)|0;L=R;R=d[O>>1]|0;d[O>>1]=qa}while((R&65535)<(L&65535));R=d[z+(P<<1)>>1]|0;M=qa;while(1){L=d[o+((M&65535)<<1)>>1]|0;if((L&65535)<(M&65535))M=L;else break}if(qa<<16>>16==R<<16>>16)ra=M;else{L=R;while(1){O=d[o+((L&65535)<<1)>>1]|0;if((O&65535)<(L&65535))L=O;else break}O=(M&65535)>(L&65535)?L:M;N=R;do{U=o+((N&65535)<<1)|0;T=N;N=d[U>>1]|0;d[U>>1]=O}while((N&65535)<(T&65535));ra=O}O=qa;do{N=o+((O&65535)<<1)|0;R=O;O=d[N>>1]|0;d[N>>1]=ra}while((O&65535)<(R&65535));d[z+(E<<1)>>1]=ra;K=F;break a}while(0);O=d[t+(E<<1)>>1]|0;R=d[t+(S<<1)>>1]|0;N=O;while(1){M=d[o+((N&65535)<<1)>>1]|0;if((M&65535)<(N&65535))N=M;else break}if(O<<16>>16==R<<16>>16)sa=N;else{M=R;while(1){L=d[o+((M&65535)<<1)>>1]|0;if((L&65535)<(M&65535))M=L;else break}L=(N&65535)>(M&65535)?M:N;T=R;do{U=o+((T&65535)<<1)|0;_=T;T=d[U>>1]|0;d[U>>1]=L}while((T&65535)<(_&65535));sa=L}L=O;do{T=o+((L&65535)<<1)|0;R=L;L=d[T>>1]|0;d[T>>1]=sa}while((L&65535)<(R&65535));L=d[z+(P<<1)>>1]|0;O=sa;while(1){R=d[o+((O&65535)<<1)>>1]|0;if((R&65535)<(O&65535))O=R;else break}if(sa<<16>>16==L<<16>>16)ta=O;else{P=L;while(1){R=d[o+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}R=(O&65535)>(P&65535)?P:O;T=L;do{N=o+((T&65535)<<1)|0;M=T;T=d[N>>1]|0;d[N>>1]=R}while((T&65535)<(M&65535));ta=R}R=sa;do{T=o+((R&65535)<<1)|0;L=R;R=d[T>>1]|0;d[T>>1]=ta}while((R&65535)<(L&65535));d[z+(E<<1)>>1]=ta;K=F;break a}while(0);S=E+-2|0;if(!(b[x+E>>0]|0)){ua=S;break}do if((S|0)>-1){if(!(b[v+S>>0]|0))break;if(b[x+I>>0]|0){d[z+(E<<1)>>1]=d[z+(S<<1)>>1]|0;K=F;break a}if(!(b[x+S>>0]|0)){R=d[t+(E<<1)>>1]|0;L=d[z+(S<<1)>>1]|0;T=R;while(1){O=d[o+((T&65535)<<1)>>1]|0;if((O&65535)<(T&65535))T=O;else break}if(R<<16>>16==L<<16>>16)va=T;else{O=L;while(1){P=d[o+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}P=(T&65535)>(O&65535)?O:T;M=L;do{N=o+((M&65535)<<1)|0;_=M;M=d[N>>1]|0;d[N>>1]=P}while((M&65535)<(_&65535));va=P}P=R;do{M=o+((P&65535)<<1)|0;L=P;P=d[M>>1]|0;d[M>>1]=va}while((P&65535)<(L&65535));d[z+(E<<1)>>1]=va;K=F;break a}do if(D){if(!(b[y+I>>0]|0))break;d[z+(E<<1)>>1]=d[z+(S<<1)>>1]|0;K=F;break a}while(0);P=d[t+(E<<1)>>1]|0;R=d[z+(S<<1)>>1]|0;L=P;while(1){M=d[o+((L&65535)<<1)>>1]|0;if((M&65535)<(L&65535))L=M;else break}if(P<<16>>16==R<<16>>16)wa=L;else{M=R;while(1){T=d[o+((M&65535)<<1)>>1]|0;if((T&65535)<(M&65535))M=T;else break}T=(L&65535)>(M&65535)?M:L;O=R;do{_=o+((O&65535)<<1)|0;N=O;O=d[_>>1]|0;d[_>>1]=T}while((O&65535)<(N&65535));wa=T}T=P;do{O=o+((T&65535)<<1)|0;R=T;T=d[O>>1]|0;d[O>>1]=wa}while((T&65535)<(R&65535));d[z+(E<<1)>>1]=wa;K=F;break a}while(0);T=d[t+(E<<1)>>1]|0;P=d[z+(S<<1)>>1]|0;R=T;while(1){O=d[o+((R&65535)<<1)>>1]|0;if((O&65535)<(R&65535))R=O;else break}if(T<<16>>16==P<<16>>16)xa=R;else{S=P;while(1){O=d[o+((S&65535)<<1)>>1]|0;if((O&65535)<(S&65535))S=O;else break}O=(R&65535)>(S&65535)?S:R;L=P;do{M=o+((L&65535)<<1)|0;N=L;L=d[M>>1]|0;d[M>>1]=O}while((L&65535)<(N&65535));xa=O}O=T;do{L=o+((O&65535)<<1)|0;P=O;O=d[L>>1]|0;d[L>>1]=xa}while((O&65535)<(P&65535));d[z+(E<<1)>>1]=xa;K=F;break a}else ua=E+-2|0;while(0);d[z+(E<<1)>>1]=d[z+(ua<<1)>>1]|0;K=F;break a}while(0);do if(B){if(b[x+G>>0]|0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break a}O=E+2|0;do if(!((O|0)>=(i|0)|C)){if(!(b[x+O>>0]|0))break;if(!(b[x+E>>0]|0)){d[z+(E<<1)>>1]=d[t+(O<<1)>>1]|0;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;d[z+(E<<1)>>1]=d[t+(O<<1)>>1]|0;K=F;break a}while(0);T=d[t+(E<<1)>>1]|0;P=d[t+(O<<1)>>1]|0;L=T;while(1){R=d[o+((L&65535)<<1)>>1]|0;if((R&65535)<(L&65535))L=R;else break}if(T<<16>>16==P<<16>>16)ya=L;else{R=P;while(1){S=d[o+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}S=(L&65535)>(R&65535)?R:L;N=P;do{M=o+((N&65535)<<1)|0;_=N;N=d[M>>1]|0;d[M>>1]=S}while((N&65535)<(_&65535));ya=S}S=T;do{N=o+((S&65535)<<1)|0;P=S;S=d[N>>1]|0;d[N>>1]=ya}while((S&65535)<(P&65535));d[z+(E<<1)>>1]=ya;K=F;break a}while(0);if(!(b[x+E>>0]|0))break;d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break a}while(0);d[z+(E<<1)>>1]=F;O=F&65535;d[o+(O<<1)>>1]=F;K=O+1&65535;break}if(J){if(b[w+I>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break}if(b[v+I>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break}}d[z+(E<<1)>>1]=F;O=F&65535;d[o+(O<<1)>>1]=F;K=O+1&65535;break}do if(H){if(!(b[v+G>>0]|0)){if(!A)break;if(!(b[w+G>>0]|0))break;d[z+(E<<1)>>1]=F;O=F&65535;d[o+(O<<1)>>1]=F;K=O+1&65535;break a}if(B){if(b[x+G>>0]|0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break a}O=E+2|0;do if(!((O|0)>=(i|0)|C)){if(!(b[x+O>>0]|0))break;if(!(b[x+E>>0]|0)){d[z+(E<<1)>>1]=d[t+(O<<1)>>1]|0;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;d[z+(E<<1)>>1]=d[t+(O<<1)>>1]|0;K=F;break a}while(0);S=d[t+(E<<1)>>1]|0;T=d[t+(O<<1)>>1]|0;P=S;while(1){N=d[o+((P&65535)<<1)>>1]|0;if((N&65535)<(P&65535))P=N;else break}if(S<<16>>16==T<<16>>16)za=P;else{N=T;while(1){L=d[o+((N&65535)<<1)>>1]|0;if((L&65535)<(N&65535))N=L;else break}L=(P&65535)>(N&65535)?N:P;R=T;do{_=o+((R&65535)<<1)|0;M=R;R=d[_>>1]|0;d[_>>1]=L}while((R&65535)<(M&65535));za=L}L=S;do{R=o+((L&65535)<<1)|0;T=L;L=d[R>>1]|0;d[R>>1]=za}while((L&65535)<(T&65535));d[z+(E<<1)>>1]=za;K=F;break a}while(0);if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break a}}d[z+(E<<1)>>1]=F;O=F&65535;d[o+(O<<1)>>1]=F;K=O+1&65535;break a}while(0);d[z+(E<<1)>>1]=0;K=F}else{G=E+-1|0;H=(E|0)>0;if(H){if(b[v+G>>0]|0){I=E|1;J=(I|0)<(i|0);if(B&J?b[x+I>>0]|0:0){if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break}do if(D){if(!(b[y+E>>0]|0))break;O=E+-2|0;if(b[x+G>>0]|0){d[z+(E<<1)>>1]=d[z+(O<<1)>>1]|0;K=F;break a}do if((O|0)>-1){if(!(b[x+O>>0]|0))break;if(b[y+G>>0]|0){d[z+(E<<1)>>1]=d[z+(O<<1)>>1]|0;K=F;break a}L=d[t+(E<<1)>>1]|0;S=d[z+(O<<1)>>1]|0;T=L;while(1){R=d[o+((T&65535)<<1)>>1]|0;if((R&65535)<(T&65535))T=R;else break}if(L<<16>>16==S<<16>>16)Aa=T;else{R=S;while(1){P=d[o+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}P=(T&65535)>(R&65535)?R:T;N=S;do{M=o+((N&65535)<<1)|0;_=N;N=d[M>>1]|0;d[M>>1]=P}while((N&65535)<(_&65535));Aa=P}P=L;do{N=o+((P&65535)<<1)|0;S=P;P=d[N>>1]|0;d[N>>1]=Aa}while((P&65535)<(S&65535));d[z+(E<<1)>>1]=Aa;K=F;break a}while(0);P=d[t+(E<<1)>>1]|0;L=d[z+(O<<1)>>1]|0;S=P;while(1){N=d[o+((S&65535)<<1)>>1]|0;if((N&65535)<(S&65535))S=N;else break}if(P<<16>>16==L<<16>>16)Ba=S;else{O=L;while(1){N=d[o+((O&65535)<<1)>>1]|0;if((N&65535)<(O&65535))O=N;else break}N=(S&65535)>(O&65535)?O:S;T=L;do{R=o+((T&65535)<<1)|0;_=T;T=d[R>>1]|0;d[R>>1]=N}while((T&65535)<(_&65535));Ba=N}N=P;do{T=o+((N&65535)<<1)|0;L=N;N=d[T>>1]|0;d[T>>1]=Ba}while((N&65535)<(L&65535));d[z+(E<<1)>>1]=Ba;K=F;break a}while(0);N=d[t+(E<<1)>>1]|0;P=d[z+(E+-2<<1)>>1]|0;L=N;while(1){T=d[o+((L&65535)<<1)>>1]|0;if((T&65535)<(L&65535))L=T;else break}if(N<<16>>16==P<<16>>16)Ca=L;else{T=P;while(1){S=d[o+((T&65535)<<1)>>1]|0;if((S&65535)<(T&65535))T=S;else break}S=(L&65535)>(T&65535)?T:L;O=P;do{_=o+((O&65535)<<1)|0;R=O;O=d[_>>1]|0;d[_>>1]=S}while((O&65535)<(R&65535));Ca=S}S=N;do{O=o+((S&65535)<<1)|0;P=S;S=d[O>>1]|0;d[O>>1]=Ca}while((S&65535)<(P&65535));d[z+(E<<1)>>1]=Ca;K=F;break}if(J?b[v+I>>0]|0:0){S=E+2|0;do if(B&(S|0)<(i|0)){if(!(b[x+S>>0]|0))break;do if(D){if(!(b[y+I>>0]|0))break;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break a}if(!(b[y+E>>0]|0)){N=d[t+(S<<1)>>1]|0;P=d[z+(E+-2<<1)>>1]|0;O=N;while(1){L=d[o+((O&65535)<<1)>>1]|0;if((L&65535)<(O&65535))O=L;else break}if(N<<16>>16==P<<16>>16)Da=O;else{L=P;while(1){T=d[o+((L&65535)<<1)>>1]|0;if((T&65535)<(L&65535))L=T;else break}T=(O&65535)>(L&65535)?L:O;R=P;do{_=o+((R&65535)<<1)|0;M=R;R=d[_>>1]|0;d[_>>1]=T}while((R&65535)<(M&65535));Da=T}T=N;do{R=o+((T&65535)<<1)|0;P=T;T=d[R>>1]|0;d[R>>1]=Da}while((T&65535)<(P&65535));d[z+(E<<1)>>1]=Da;K=F;break a}T=E+-2|0;if(b[x+G>>0]|0){d[z+(E<<1)>>1]=d[z+(T<<1)>>1]|0;K=F;break a}do if((T|0)>-1){if(!(b[x+T>>0]|0))break;if(b[y+G>>0]|0){d[z+(E<<1)>>1]=d[z+(T<<1)>>1]|0;K=F;break a}N=d[t+(S<<1)>>1]|0;P=d[z+(T<<1)>>1]|0;R=N;while(1){O=d[o+((R&65535)<<1)>>1]|0;if((O&65535)<(R&65535))R=O;else break}if(N<<16>>16==P<<16>>16)Ea=R;else{O=P;while(1){L=d[o+((O&65535)<<1)>>1]|0;if((L&65535)<(O&65535))O=L;else break}L=(R&65535)>(O&65535)?O:R;M=P;do{_=o+((M&65535)<<1)|0;U=M;M=d[_>>1]|0;d[_>>1]=L}while((M&65535)<(U&65535));Ea=L}L=N;do{M=o+((L&65535)<<1)|0;P=L;L=d[M>>1]|0;d[M>>1]=Ea}while((L&65535)<(P&65535));d[z+(E<<1)>>1]=Ea;K=F;break a}while(0);L=d[t+(S<<1)>>1]|0;N=d[z+(T<<1)>>1]|0;P=L;while(1){M=d[o+((P&65535)<<1)>>1]|0;if((M&65535)<(P&65535))P=M;else break}if(L<<16>>16==N<<16>>16)Fa=P;else{T=N;while(1){M=d[o+((T&65535)<<1)>>1]|0;if((M&65535)<(T&65535))T=M;else break}M=(P&65535)>(T&65535)?T:P;R=N;do{O=o+((R&65535)<<1)|0;U=R;R=d[O>>1]|0;d[O>>1]=M}while((R&65535)<(U&65535));Fa=M}M=L;do{R=o+((M&65535)<<1)|0;N=M;M=d[R>>1]|0;d[R>>1]=Fa}while((M&65535)<(N&65535));d[z+(E<<1)>>1]=Fa;K=F;break a}while(0);M=d[t+(S<<1)>>1]|0;L=d[z+(E+-2<<1)>>1]|0;N=M;while(1){R=d[o+((N&65535)<<1)>>1]|0;if((R&65535)<(N&65535))N=R;else break}if(M<<16>>16==L<<16>>16)Ga=N;else{R=L;while(1){P=d[o+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}P=(N&65535)>(R&65535)?R:N;T=L;do{U=o+((T&65535)<<1)|0;O=T;T=d[U>>1]|0;d[U>>1]=P}while((T&65535)<(O&65535));Ga=P}P=M;do{T=o+((P&65535)<<1)|0;L=P;P=d[T>>1]|0;d[T>>1]=Ga}while((P&65535)<(L&65535));d[z+(E<<1)>>1]=Ga;K=F;break a}while(0);d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break}d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break}if(A?b[w+G>>0]|0:0){S=E|1;I=(S|0)<(i|0);if(!(C|I^1)?b[x+S>>0]|0:0){J=E+-2|0;do if((J|0)>-1){if(!(b[v+J>>0]|0))break;if(b[x+G>>0]|0){P=d[z+(J<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=P;K=F;break a}do if(D){if(!(b[y+E>>0]|0))break;d[z+(E<<1)>>1]=P;K=F;break a}while(0);M=d[t+(E<<1)>>1]|0;L=M;while(1){T=d[o+((L&65535)<<1)>>1]|0;if((T&65535)<(L&65535))L=T;else break}if(M<<16>>16==P<<16>>16)Ha=L;else{T=P;while(1){N=d[o+((T&65535)<<1)>>1]|0;if((N&65535)<(T&65535))T=N;else break}N=(L&65535)>(T&65535)?T:L;R=P;do{O=o+((R&65535)<<1)|0;U=R;R=d[O>>1]|0;d[O>>1]=N}while((R&65535)<(U&65535));Ha=N}N=M;do{R=o+((N&65535)<<1)|0;P=N;N=d[R>>1]|0;d[R>>1]=Ha}while((N&65535)<(P&65535));d[z+(E<<1)>>1]=Ha;K=F;break a}if(!(b[x+J>>0]|0)){N=d[t+(E<<1)>>1]|0;M=d[z+(J<<1)>>1]|0;P=N;while(1){R=d[o+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}if(N<<16>>16==M<<16>>16)Ia=P;else{R=M;while(1){L=d[o+((R&65535)<<1)>>1]|0;if((L&65535)<(R&65535))R=L;else break}L=(P&65535)>(R&65535)?R:P;T=M;do{U=o+((T&65535)<<1)|0;O=T;T=d[U>>1]|0;d[U>>1]=L}while((T&65535)<(O&65535));Ia=L}L=N;do{T=o+((L&65535)<<1)|0;M=L;L=d[T>>1]|0;d[T>>1]=Ia}while((L&65535)<(M&65535));d[z+(E<<1)>>1]=Ia;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;L=d[z+(J<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=L;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=L;K=F;break a}N=d[t+(E<<1)>>1]|0;M=N;while(1){T=d[o+((M&65535)<<1)>>1]|0;if((T&65535)<(M&65535))M=T;else break}if(N<<16>>16==L<<16>>16)Ja=M;else{T=L;while(1){P=d[o+((T&65535)<<1)>>1]|0;if((P&65535)<(T&65535))T=P;else break}P=(M&65535)>(T&65535)?T:M;R=L;do{O=o+((R&65535)<<1)|0;U=R;R=d[O>>1]|0;d[O>>1]=P}while((R&65535)<(U&65535));Ja=P}P=N;do{R=o+((P&65535)<<1)|0;L=P;P=d[R>>1]|0;d[R>>1]=Ja}while((P&65535)<(L&65535));d[z+(E<<1)>>1]=Ja;K=F;break a}while(0);P=d[t+(E<<1)>>1]|0;N=d[z+(J<<1)>>1]|0;L=P;while(1){R=d[o+((L&65535)<<1)>>1]|0;if((R&65535)<(L&65535))L=R;else break}if(P<<16>>16==N<<16>>16)Ka=L;else{R=N;while(1){M=d[o+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(L&65535)>(R&65535)?R:L;T=N;do{U=o+((T&65535)<<1)|0;O=T;T=d[U>>1]|0;d[U>>1]=M}while((T&65535)<(O&65535));Ka=M}M=P;do{T=o+((M&65535)<<1)|0;N=M;M=d[T>>1]|0;d[T>>1]=Ka}while((M&65535)<(N&65535));d[z+(E<<1)>>1]=Ka;K=F;break a}while(0);if(b[x+E>>0]|0){M=d[t+(E<<1)>>1]|0;P=d[z+(J<<1)>>1]|0;N=M;while(1){T=d[o+((N&65535)<<1)>>1]|0;if((T&65535)<(N&65535))N=T;else break}if(M<<16>>16==P<<16>>16)La=N;else{T=P;while(1){L=d[o+((T&65535)<<1)>>1]|0;if((L&65535)<(T&65535))T=L;else break}L=(N&65535)>(T&65535)?T:N;R=P;do{O=o+((R&65535)<<1)|0;U=R;R=d[O>>1]|0;d[O>>1]=L}while((R&65535)<(U&65535));La=L}L=M;do{R=o+((L&65535)<<1)|0;P=L;L=d[R>>1]|0;d[R>>1]=La}while((L&65535)<(P&65535));d[z+(E<<1)>>1]=La;K=F;break}L=d[t+(E<<1)>>1]|0;if(!(b[x+G>>0]|0)){M=d[z+(J<<1)>>1]|0;P=L;while(1){R=d[o+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}if(L<<16>>16==M<<16>>16)Ma=P;else{R=M;while(1){N=d[o+((R&65535)<<1)>>1]|0;if((N&65535)<(R&65535))R=N;else break}N=(P&65535)>(R&65535)?R:P;T=M;do{U=o+((T&65535)<<1)|0;O=T;T=d[U>>1]|0;d[U>>1]=N}while((T&65535)<(O&65535));Ma=N}N=L;do{T=o+((N&65535)<<1)|0;M=N;N=d[T>>1]|0;d[T>>1]=Ma}while((N&65535)<(M&65535));d[z+(E<<1)>>1]=Ma;K=F;break}do if(D){if(!(b[y+E>>0]|0))break;N=d[z+(J<<1)>>1]|0;M=L;while(1){T=d[o+((M&65535)<<1)>>1]|0;if((T&65535)<(M&65535))M=T;else break}if(L<<16>>16==N<<16>>16)Na=M;else{T=N;while(1){P=d[o+((T&65535)<<1)>>1]|0;if((P&65535)<(T&65535))T=P;else break}P=(M&65535)>(T&65535)?T:M;R=N;do{O=o+((R&65535)<<1)|0;U=R;R=d[O>>1]|0;d[O>>1]=P}while((R&65535)<(U&65535));Na=P}P=L;do{R=o+((P&65535)<<1)|0;N=P;P=d[R>>1]|0;d[R>>1]=Na}while((P&65535)<(N&65535));d[z+(E<<1)>>1]=Na;K=F;break a}while(0);P=d[t+(J<<1)>>1]|0;N=P;while(1){R=d[o+((N&65535)<<1)>>1]|0;if((R&65535)<(N&65535))N=R;else break}if(P<<16>>16==L<<16>>16)Oa=N;else{R=L;while(1){M=d[o+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(N&65535)>(R&65535)?R:N;T=L;do{U=o+((T&65535)<<1)|0;O=T;T=d[U>>1]|0;d[U>>1]=M}while((T&65535)<(O&65535));Oa=M}M=P;do{T=o+((M&65535)<<1)|0;L=M;M=d[T>>1]|0;d[T>>1]=Oa}while((M&65535)<(L&65535));M=d[z+(J<<1)>>1]|0;P=Oa;while(1){L=d[o+((P&65535)<<1)>>1]|0;if((L&65535)<(P&65535))P=L;else break}if(Oa<<16>>16==M<<16>>16)Pa=P;else{J=M;while(1){L=d[o+((J&65535)<<1)>>1]|0;if((L&65535)<(J&65535))J=L;else break}L=(P&65535)>(J&65535)?J:P;T=M;do{N=o+((T&65535)<<1)|0;R=T;T=d[N>>1]|0;d[N>>1]=L}while((T&65535)<(R&65535));Pa=L}L=Oa;do{T=o+((L&65535)<<1)|0;M=L;L=d[T>>1]|0;d[T>>1]=Pa}while((L&65535)<(M&65535));d[z+(E<<1)>>1]=Pa;K=F;break}if(I?b[v+S>>0]|0:0){L=E+2|0;do if(!((L|0)>=(i|0)|C)){if(!(b[x+L>>0]|0))break;M=E+-2|0;do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[x+G>>0]|0){do if(D){if(!(b[y+S>>0]|0))break;T=d[z+(M<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}P=d[t+(L<<1)>>1]|0;J=P;while(1){R=d[o+((J&65535)<<1)>>1]|0;if((R&65535)<(J&65535))J=R;else break}if(P<<16>>16==T<<16>>16)Qa=J;else{R=T;while(1){N=d[o+((R&65535)<<1)>>1]|0;if((N&65535)<(R&65535))R=N;else break}N=(J&65535)>(R&65535)?R:J;O=T;do{U=o+((O&65535)<<1)|0;_=O;O=d[U>>1]|0;d[U>>1]=N}while((O&65535)<(_&65535));Qa=N}N=P;do{O=o+((N&65535)<<1)|0;T=N;N=d[O>>1]|0;d[O>>1]=Qa}while((N&65535)<(T&65535));d[z+(E<<1)>>1]=Qa;K=F;break a}while(0);N=d[t+(L<<1)>>1]|0;P=d[z+(M<<1)>>1]|0;T=N;while(1){O=d[o+((T&65535)<<1)>>1]|0;if((O&65535)<(T&65535))T=O;else break}if(N<<16>>16==P<<16>>16)Ra=T;else{O=P;while(1){J=d[o+((O&65535)<<1)>>1]|0;if((J&65535)<(O&65535))O=J;else break}J=(T&65535)>(O&65535)?O:T;R=P;do{_=o+((R&65535)<<1)|0;U=R;R=d[_>>1]|0;d[_>>1]=J}while((R&65535)<(U&65535));Ra=J}J=N;do{R=o+((J&65535)<<1)|0;P=J;J=d[R>>1]|0;d[R>>1]=Ra}while((J&65535)<(P&65535));d[z+(E<<1)>>1]=Ra;K=F;break a}do if(D){if(!(b[y+S>>0]|0))break;if(!(b[x+M>>0]|0)){J=d[t+(L<<1)>>1]|0;N=d[z+(M<<1)>>1]|0;P=J;while(1){R=d[o+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}if(J<<16>>16==N<<16>>16)Sa=P;else{R=N;while(1){T=d[o+((R&65535)<<1)>>1]|0;if((T&65535)<(R&65535))R=T;else break}T=(P&65535)>(R&65535)?R:P;O=N;do{U=o+((O&65535)<<1)|0;_=O;O=d[U>>1]|0;d[U>>1]=T}while((O&65535)<(_&65535));Sa=T}T=J;do{O=o+((T&65535)<<1)|0;N=T;T=d[O>>1]|0;d[O>>1]=Sa}while((T&65535)<(N&65535));d[z+(E<<1)>>1]=Sa;K=F;break a}if(!(b[y+G>>0]|0)){T=d[t+(L<<1)>>1]|0;J=d[z+(M<<1)>>1]|0;N=T;while(1){O=d[o+((N&65535)<<1)>>1]|0;if((O&65535)<(N&65535))N=O;else break}if(T<<16>>16==J<<16>>16)Ta=N;else{O=J;while(1){P=d[o+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}P=(N&65535)>(O&65535)?O:N;R=J;do{_=o+((R&65535)<<1)|0;U=R;R=d[_>>1]|0;d[_>>1]=P}while((R&65535)<(U&65535));Ta=P}P=T;do{R=o+((P&65535)<<1)|0;J=P;P=d[R>>1]|0;d[R>>1]=Ta}while((P&65535)<(J&65535));d[z+(E<<1)>>1]=Ta;K=F;break a}P=d[z+(M<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=P;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=P;K=F;break a}T=d[t+(L<<1)>>1]|0;J=T;while(1){R=d[o+((J&65535)<<1)>>1]|0;if((R&65535)<(J&65535))J=R;else break}if(T<<16>>16==P<<16>>16)Ua=J;else{R=P;while(1){N=d[o+((R&65535)<<1)>>1]|0;if((N&65535)<(R&65535))R=N;else break}N=(J&65535)>(R&65535)?R:J;O=P;do{U=o+((O&65535)<<1)|0;_=O;O=d[U>>1]|0;d[U>>1]=N}while((O&65535)<(_&65535));Ua=N}N=T;do{O=o+((N&65535)<<1)|0;P=N;N=d[O>>1]|0;d[O>>1]=Ua}while((N&65535)<(P&65535));d[z+(E<<1)>>1]=Ua;K=F;break a}while(0);if(!(b[x+E>>0]|0)){N=d[t+(L<<1)>>1]|0;T=d[z+(M<<1)>>1]|0;P=N;while(1){O=d[o+((P&65535)<<1)>>1]|0;if((O&65535)<(P&65535))P=O;else break}if(N<<16>>16==T<<16>>16)Va=P;else{O=T;while(1){J=d[o+((O&65535)<<1)>>1]|0;if((J&65535)<(O&65535))O=J;else break}J=(P&65535)>(O&65535)?O:P;R=T;do{_=o+((R&65535)<<1)|0;U=R;R=d[_>>1]|0;d[_>>1]=J}while((R&65535)<(U&65535));Va=J}J=N;do{R=o+((J&65535)<<1)|0;T=J;J=d[R>>1]|0;d[R>>1]=Va}while((J&65535)<(T&65535));d[z+(E<<1)>>1]=Va;K=F;break a}if(!(b[x+M>>0]|0)){J=d[t+(E<<1)>>1]|0;N=d[t+(L<<1)>>1]|0;T=J;while(1){R=d[o+((T&65535)<<1)>>1]|0;if((R&65535)<(T&65535))T=R;else break}if(J<<16>>16==N<<16>>16)Wa=T;else{R=N;while(1){P=d[o+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}P=(T&65535)>(R&65535)?R:T;O=N;do{U=o+((O&65535)<<1)|0;_=O;O=d[U>>1]|0;d[U>>1]=P}while((O&65535)<(_&65535));Wa=P}P=J;do{O=o+((P&65535)<<1)|0;N=P;P=d[O>>1]|0;d[O>>1]=Wa}while((P&65535)<(N&65535));P=d[z+(M<<1)>>1]|0;J=Wa;while(1){N=d[o+((J&65535)<<1)>>1]|0;if((N&65535)<(J&65535))J=N;else break}if(Wa<<16>>16==P<<16>>16)Xa=J;else{N=P;while(1){O=d[o+((N&65535)<<1)>>1]|0;if((O&65535)<(N&65535))N=O;else break}O=(J&65535)>(N&65535)?N:J;T=P;do{R=o+((T&65535)<<1)|0;_=T;T=d[R>>1]|0;d[R>>1]=O}while((T&65535)<(_&65535));Xa=O}O=Wa;do{T=o+((O&65535)<<1)|0;P=O;O=d[T>>1]|0;d[T>>1]=Xa}while((O&65535)<(P&65535));d[z+(E<<1)>>1]=Xa;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;O=d[t+(L<<1)>>1]|0;P=d[z+(M<<1)>>1]|0;T=O;while(1){J=d[o+((T&65535)<<1)>>1]|0;if((J&65535)<(T&65535))T=J;else break}if(O<<16>>16==P<<16>>16)Ya=T;else{J=P;while(1){N=d[o+((J&65535)<<1)>>1]|0;if((N&65535)<(J&65535))J=N;else break}N=(T&65535)>(J&65535)?J:T;_=P;do{R=o+((_&65535)<<1)|0;U=_;_=d[R>>1]|0;d[R>>1]=N}while((_&65535)<(U&65535));Ya=N}N=O;do{_=o+((N&65535)<<1)|0;P=N;N=d[_>>1]|0;d[_>>1]=Ya}while((N&65535)<(P&65535));d[z+(E<<1)>>1]=Ya;K=F;break a}while(0);N=d[t+(E<<1)>>1]|0;O=d[t+(L<<1)>>1]|0;P=N;while(1){_=d[o+((P&65535)<<1)>>1]|0;if((_&65535)<(P&65535))P=_;else break}if(N<<16>>16==O<<16>>16)Za=P;else{_=O;while(1){T=d[o+((_&65535)<<1)>>1]|0;if((T&65535)<(_&65535))_=T;else break}T=(P&65535)>(_&65535)?_:P;J=O;do{U=o+((J&65535)<<1)|0;R=J;J=d[U>>1]|0;d[U>>1]=T}while((J&65535)<(R&65535));Za=T}T=N;do{J=o+((T&65535)<<1)|0;O=T;T=d[J>>1]|0;d[J>>1]=Za}while((T&65535)<(O&65535));T=d[z+(M<<1)>>1]|0;N=Za;while(1){O=d[o+((N&65535)<<1)>>1]|0;if((O&65535)<(N&65535))N=O;else break}if(Za<<16>>16==T<<16>>16)_a=N;else{O=T;while(1){J=d[o+((O&65535)<<1)>>1]|0;if((J&65535)<(O&65535))O=J;else break}J=(N&65535)>(O&65535)?O:N;P=T;do{_=o+((P&65535)<<1)|0;R=P;P=d[_>>1]|0;d[_>>1]=J}while((P&65535)<(R&65535));_a=J}J=Za;do{P=o+((J&65535)<<1)|0;T=J;J=d[P>>1]|0;d[P>>1]=_a}while((J&65535)<(T&65535));d[z+(E<<1)>>1]=_a;K=F;break a}while(0);if(b[x+E>>0]|0){do if(D){if(!(b[y+S>>0]|0))break;J=d[t+(L<<1)>>1]|0;T=d[z+(M<<1)>>1]|0;P=J;while(1){N=d[o+((P&65535)<<1)>>1]|0;if((N&65535)<(P&65535))P=N;else break}if(J<<16>>16==T<<16>>16)$a=P;else{N=T;while(1){O=d[o+((N&65535)<<1)>>1]|0;if((O&65535)<(N&65535))N=O;else break}O=(P&65535)>(N&65535)?N:P;R=T;do{_=o+((R&65535)<<1)|0;U=R;R=d[_>>1]|0;d[_>>1]=O}while((R&65535)<(U&65535));$a=O}O=J;do{R=o+((O&65535)<<1)|0;T=O;O=d[R>>1]|0;d[R>>1]=$a}while((O&65535)<(T&65535));d[z+(E<<1)>>1]=$a;K=F;break a}while(0);O=d[t+(E<<1)>>1]|0;J=d[t+(L<<1)>>1]|0;T=O;while(1){R=d[o+((T&65535)<<1)>>1]|0;if((R&65535)<(T&65535))T=R;else break}if(O<<16>>16==J<<16>>16)ab=T;else{R=J;while(1){P=d[o+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}P=(T&65535)>(R&65535)?R:T;N=J;do{U=o+((N&65535)<<1)|0;_=N;N=d[U>>1]|0;d[U>>1]=P}while((N&65535)<(_&65535));ab=P}P=O;do{N=o+((P&65535)<<1)|0;J=P;P=d[N>>1]|0;d[N>>1]=ab}while((P&65535)<(J&65535));P=d[z+(M<<1)>>1]|0;O=ab;while(1){J=d[o+((O&65535)<<1)>>1]|0;if((J&65535)<(O&65535))O=J;else break}if(ab<<16>>16==P<<16>>16)bb=O;else{J=P;while(1){N=d[o+((J&65535)<<1)>>1]|0;if((N&65535)<(J&65535))J=N;else break}N=(O&65535)>(J&65535)?J:O;T=P;do{R=o+((T&65535)<<1)|0;_=T;T=d[R>>1]|0;d[R>>1]=N}while((T&65535)<(_&65535));bb=N}N=ab;do{T=o+((N&65535)<<1)|0;P=N;N=d[T>>1]|0;d[T>>1]=bb}while((N&65535)<(P&65535));d[z+(E<<1)>>1]=bb;K=F;break a}if(!(b[x+G>>0]|0)){N=d[t+(L<<1)>>1]|0;P=d[z+(M<<1)>>1]|0;T=N;while(1){O=d[o+((T&65535)<<1)>>1]|0;if((O&65535)<(T&65535))T=O;else break}if(N<<16>>16==P<<16>>16)cb=T;else{O=P;while(1){J=d[o+((O&65535)<<1)>>1]|0;if((J&65535)<(O&65535))O=J;else break}J=(T&65535)>(O&65535)?O:T;_=P;do{R=o+((_&65535)<<1)|0;U=_;_=d[R>>1]|0;d[R>>1]=J}while((_&65535)<(U&65535));cb=J}J=N;do{_=o+((J&65535)<<1)|0;P=J;J=d[_>>1]|0;d[_>>1]=cb}while((J&65535)<(P&65535));d[z+(E<<1)>>1]=cb;K=F;break a}do if(D){if(!(b[y+S>>0]|0))break;J=d[t+(L<<1)>>1]|0;if(b[y+E>>0]|0){N=d[z+(M<<1)>>1]|0;P=J;while(1){_=d[o+((P&65535)<<1)>>1]|0;if((_&65535)<(P&65535))P=_;else break}if(J<<16>>16==N<<16>>16)db=P;else{_=N;while(1){T=d[o+((_&65535)<<1)>>1]|0;if((T&65535)<(_&65535))_=T;else break}T=(P&65535)>(_&65535)?_:P;O=N;do{U=o+((O&65535)<<1)|0;R=O;O=d[U>>1]|0;d[U>>1]=T}while((O&65535)<(R&65535));db=T}T=J;do{O=o+((T&65535)<<1)|0;N=T;T=d[O>>1]|0;d[O>>1]=db}while((T&65535)<(N&65535));d[z+(E<<1)>>1]=db;K=F;break a}T=d[t+(M<<1)>>1]|0;N=T;while(1){O=d[o+((N&65535)<<1)>>1]|0;if((O&65535)<(N&65535))N=O;else break}if(T<<16>>16==J<<16>>16)eb=N;else{O=J;while(1){P=d[o+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}P=(N&65535)>(O&65535)?O:N;_=J;do{R=o+((_&65535)<<1)|0;U=_;_=d[R>>1]|0;d[R>>1]=P}while((_&65535)<(U&65535));eb=P}P=T;do{_=o+((P&65535)<<1)|0;J=P;P=d[_>>1]|0;d[_>>1]=eb}while((P&65535)<(J&65535));P=d[z+(M<<1)>>1]|0;T=eb;while(1){J=d[o+((T&65535)<<1)>>1]|0;if((J&65535)<(T&65535))T=J;else break}if(eb<<16>>16==P<<16>>16)fb=T;else{J=P;while(1){_=d[o+((J&65535)<<1)>>1]|0;if((_&65535)<(J&65535))J=_;else break}_=(T&65535)>(J&65535)?J:T;N=P;do{O=o+((N&65535)<<1)|0;U=N;N=d[O>>1]|0;d[O>>1]=_}while((N&65535)<(U&65535));fb=_}_=eb;do{N=o+((_&65535)<<1)|0;P=_;_=d[N>>1]|0;d[N>>1]=fb}while((_&65535)<(P&65535));d[z+(E<<1)>>1]=fb;K=F;break a}while(0);_=d[t+(M<<1)>>1]|0;P=d[t+(L<<1)>>1]|0;N=_;while(1){T=d[o+((N&65535)<<1)>>1]|0;if((T&65535)<(N&65535))N=T;else break}if(_<<16>>16==P<<16>>16)gb=N;else{T=P;while(1){J=d[o+((T&65535)<<1)>>1]|0;if((J&65535)<(T&65535))T=J;else break}J=(N&65535)>(T&65535)?T:N;U=P;do{O=o+((U&65535)<<1)|0;R=U;U=d[O>>1]|0;d[O>>1]=J}while((U&65535)<(R&65535));gb=J}J=_;do{U=o+((J&65535)<<1)|0;P=J;J=d[U>>1]|0;d[U>>1]=gb}while((J&65535)<(P&65535));J=d[z+(M<<1)>>1]|0;_=gb;while(1){P=d[o+((_&65535)<<1)>>1]|0;if((P&65535)<(_&65535))_=P;else break}if(gb<<16>>16==J<<16>>16)hb=_;else{M=J;while(1){P=d[o+((M&65535)<<1)>>1]|0;if((P&65535)<(M&65535))M=P;else break}P=(_&65535)>(M&65535)?M:_;U=J;do{N=o+((U&65535)<<1)|0;T=U;U=d[N>>1]|0;d[N>>1]=P}while((U&65535)<(T&65535));hb=P}P=gb;do{U=o+((P&65535)<<1)|0;J=P;P=d[U>>1]|0;d[U>>1]=hb}while((P&65535)<(J&65535));d[z+(E<<1)>>1]=hb;K=F;break a}while(0);do if(B){L=E+-2|0;if(b[x+G>>0]|0){S=d[z+(L<<1)>>1]|0;do if((L|0)>-1){if(!(b[v+L>>0]|0))break;d[z+(E<<1)>>1]=S;K=F;break a}while(0);I=d[t+(L<<1)>>1]|0;P=I;while(1){J=d[o+((P&65535)<<1)>>1]|0;if((J&65535)<(P&65535))P=J;else break}if(I<<16>>16==S<<16>>16)ib=P;else{J=S;while(1){U=d[o+((J&65535)<<1)>>1]|0;if((U&65535)<(J&65535))J=U;else break}U=(P&65535)>(J&65535)?J:P;_=S;do{M=o+((_&65535)<<1)|0;T=_;_=d[M>>1]|0;d[M>>1]=U}while((_&65535)<(T&65535));ib=U}U=I;do{_=o+((U&65535)<<1)|0;S=U;U=d[_>>1]|0;d[_>>1]=ib}while((U&65535)<(S&65535));d[z+(E<<1)>>1]=ib;K=F;break a}if(!(b[x+E>>0]|0)){jb=L;break}do if((L|0)>-1){if(!(b[v+L>>0]|0))break;if(!(b[x+L>>0]|0)){U=d[t+(E<<1)>>1]|0;I=d[z+(L<<1)>>1]|0;S=U;while(1){_=d[o+((S&65535)<<1)>>1]|0;if((_&65535)<(S&65535))S=_;else break}if(U<<16>>16==I<<16>>16)kb=S;else{_=I;while(1){P=d[o+((_&65535)<<1)>>1]|0;if((P&65535)<(_&65535))_=P;else break}P=(S&65535)>(_&65535)?_:S;J=I;do{T=o+((J&65535)<<1)|0;M=J;J=d[T>>1]|0;d[T>>1]=P}while((J&65535)<(M&65535));kb=P}P=U;do{J=o+((P&65535)<<1)|0;I=P;P=d[J>>1]|0;d[J>>1]=kb}while((P&65535)<(I&65535));d[z+(E<<1)>>1]=kb;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;d[z+(E<<1)>>1]=d[z+(L<<1)>>1]|0;K=F;break a}while(0);P=d[t+(E<<1)>>1]|0;U=d[z+(L<<1)>>1]|0;I=P;while(1){J=d[o+((I&65535)<<1)>>1]|0;if((J&65535)<(I&65535))I=J;else break}if(P<<16>>16==U<<16>>16)lb=I;else{J=U;while(1){S=d[o+((J&65535)<<1)>>1]|0;if((S&65535)<(J&65535))J=S;else break}S=(I&65535)>(J&65535)?J:I;_=U;do{M=o+((_&65535)<<1)|0;T=_;_=d[M>>1]|0;d[M>>1]=S}while((_&65535)<(T&65535));lb=S}S=P;do{_=o+((S&65535)<<1)|0;U=S;S=d[_>>1]|0;d[_>>1]=lb}while((S&65535)<(U&65535));d[z+(E<<1)>>1]=lb;K=F;break a}while(0);S=d[t+(E<<1)>>1]|0;P=d[z+(L<<1)>>1]|0;U=S;while(1){_=d[o+((U&65535)<<1)>>1]|0;if((_&65535)<(U&65535))U=_;else break}if(S<<16>>16==P<<16>>16)mb=U;else{L=P;while(1){_=d[o+((L&65535)<<1)>>1]|0;if((_&65535)<(L&65535))L=_;else break}_=(U&65535)>(L&65535)?L:U;I=P;do{J=o+((I&65535)<<1)|0;T=I;I=d[J>>1]|0;d[J>>1]=_}while((I&65535)<(T&65535));mb=_}_=S;do{I=o+((_&65535)<<1)|0;P=_;_=d[I>>1]|0;d[I>>1]=mb}while((_&65535)<(P&65535));d[z+(E<<1)>>1]=mb;K=F;break a}else jb=E+-2|0;while(0);d[z+(E<<1)>>1]=d[z+(jb<<1)>>1]|0;K=F;break}do if(B){_=E+-2|0;if(b[x+G>>0]|0){S=d[z+(_<<1)>>1]|0;do if((_|0)>-1){if(!(b[v+_>>0]|0))break;d[z+(E<<1)>>1]=S;K=F;break a}while(0);P=d[t+(_<<1)>>1]|0;I=P;while(1){U=d[o+((I&65535)<<1)>>1]|0;if((U&65535)<(I&65535))I=U;else break}if(P<<16>>16==S<<16>>16)nb=I;else{U=S;while(1){L=d[o+((U&65535)<<1)>>1]|0;if((L&65535)<(U&65535))U=L;else break}L=(I&65535)>(U&65535)?U:I;T=S;do{J=o+((T&65535)<<1)|0;M=T;T=d[J>>1]|0;d[J>>1]=L}while((T&65535)<(M&65535));nb=L}L=P;do{T=o+((L&65535)<<1)|0;S=L;L=d[T>>1]|0;d[T>>1]=nb}while((L&65535)<(S&65535));d[z+(E<<1)>>1]=nb;K=F;break a}if(!(b[x+E>>0]|0)){ob=_;break}do if((_|0)>-1){if(!(b[v+_>>0]|0))break;if(!(b[x+_>>0]|0)){L=d[t+(E<<1)>>1]|0;P=d[z+(_<<1)>>1]|0;S=L;while(1){T=d[o+((S&65535)<<1)>>1]|0;if((T&65535)<(S&65535))S=T;else break}if(L<<16>>16==P<<16>>16)pb=S;else{T=P;while(1){I=d[o+((T&65535)<<1)>>1]|0;if((I&65535)<(T&65535))T=I;else break}I=(S&65535)>(T&65535)?T:S;U=P;do{M=o+((U&65535)<<1)|0;J=U;U=d[M>>1]|0;d[M>>1]=I}while((U&65535)<(J&65535));pb=I}I=L;do{U=o+((I&65535)<<1)|0;P=I;I=d[U>>1]|0;d[U>>1]=pb}while((I&65535)<(P&65535));d[z+(E<<1)>>1]=pb;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;d[z+(E<<1)>>1]=d[z+(_<<1)>>1]|0;K=F;break a}while(0);I=d[t+(E<<1)>>1]|0;L=d[z+(_<<1)>>1]|0;P=I;while(1){U=d[o+((P&65535)<<1)>>1]|0;if((U&65535)<(P&65535))P=U;else break}if(I<<16>>16==L<<16>>16)qb=P;else{U=L;while(1){S=d[o+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}S=(P&65535)>(U&65535)?U:P;T=L;do{J=o+((T&65535)<<1)|0;M=T;T=d[J>>1]|0;d[J>>1]=S}while((T&65535)<(M&65535));qb=S}S=I;do{T=o+((S&65535)<<1)|0;L=S;S=d[T>>1]|0;d[T>>1]=qb}while((S&65535)<(L&65535));d[z+(E<<1)>>1]=qb;K=F;break a}while(0);S=d[t+(E<<1)>>1]|0;I=d[z+(_<<1)>>1]|0;L=S;while(1){T=d[o+((L&65535)<<1)>>1]|0;if((T&65535)<(L&65535))L=T;else break}if(S<<16>>16==I<<16>>16)rb=L;else{_=I;while(1){T=d[o+((_&65535)<<1)>>1]|0;if((T&65535)<(_&65535))_=T;else break}T=(L&65535)>(_&65535)?_:L;P=I;do{U=o+((P&65535)<<1)|0;M=P;P=d[U>>1]|0;d[U>>1]=T}while((P&65535)<(M&65535));rb=T}T=S;do{P=o+((T&65535)<<1)|0;I=T;T=d[P>>1]|0;d[P>>1]=rb}while((T&65535)<(I&65535));d[z+(E<<1)>>1]=rb;K=F;break a}else ob=E+-2|0;while(0);d[z+(E<<1)>>1]=d[z+(ob<<1)>>1]|0;K=F;break}}T=E|1;S=(T|0)<(i|0);if(!(C|S^1)?b[x+T>>0]|0:0){if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break}if(H?b[x+G>>0]|0:0){I=d[t+(E<<1)>>1]|0;do if(D){if(!(b[y+E>>0]|0))break;d[z+(E<<1)>>1]=I;K=F;break a}while(0);P=d[t+(E+-2<<1)>>1]|0;L=P;while(1){_=d[o+((L&65535)<<1)>>1]|0;if((_&65535)<(L&65535))L=_;else break}if(P<<16>>16==I<<16>>16)sb=L;else{_=I;while(1){M=d[o+((_&65535)<<1)>>1]|0;if((M&65535)<(_&65535))_=M;else break}M=(L&65535)>(_&65535)?_:L;U=I;do{J=o+((U&65535)<<1)|0;N=U;U=d[J>>1]|0;d[J>>1]=M}while((U&65535)<(N&65535));sb=M}M=P;do{U=o+((M&65535)<<1)|0;I=M;M=d[U>>1]|0;d[U>>1]=sb}while((M&65535)<(I&65535));d[z+(E<<1)>>1]=sb;K=F;break}d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break}if(S?b[v+T>>0]|0:0){M=E+2|0;if(!((M|0)>=(i|0)|C)?b[x+M>>0]|0:0){if(b[x+E>>0]|0){do if(D){if(!(b[y+T>>0]|0))break;d[z+(E<<1)>>1]=d[t+(M<<1)>>1]|0;K=F;break a}while(0);S=d[t+(E<<1)>>1]|0;P=d[t+(M<<1)>>1]|0;I=S;while(1){U=d[o+((I&65535)<<1)>>1]|0;if((U&65535)<(I&65535))I=U;else break}if(S<<16>>16==P<<16>>16)tb=I;else{U=P;while(1){L=d[o+((U&65535)<<1)>>1]|0;if((L&65535)<(U&65535))U=L;else break}L=(I&65535)>(U&65535)?U:I;_=P;do{N=o+((_&65535)<<1)|0;J=_;_=d[N>>1]|0;d[N>>1]=L}while((_&65535)<(J&65535));tb=L}L=S;do{_=o+((L&65535)<<1)|0;P=L;L=d[_>>1]|0;d[_>>1]=tb}while((L&65535)<(P&65535));d[z+(E<<1)>>1]=tb;K=F;break}do if(H){if(!(b[x+G>>0]|0))break;do if(D){if(!(b[y+T>>0]|0))break;L=d[t+(M<<1)>>1]|0;if(b[y+E>>0]|0){d[z+(E<<1)>>1]=L;K=F;break a}S=d[t+(E+-2<<1)>>1]|0;P=S;while(1){_=d[o+((P&65535)<<1)>>1]|0;if((_&65535)<(P&65535))P=_;else break}if(S<<16>>16==L<<16>>16)ub=P;else{_=L;while(1){I=d[o+((_&65535)<<1)>>1]|0;if((I&65535)<(_&65535))_=I;else break}I=(P&65535)>(_&65535)?_:P;U=L;do{J=o+((U&65535)<<1)|0;N=U;U=d[J>>1]|0;d[J>>1]=I}while((U&65535)<(N&65535));ub=I}I=S;do{U=o+((I&65535)<<1)|0;L=I;I=d[U>>1]|0;d[U>>1]=ub}while((I&65535)<(L&65535));d[z+(E<<1)>>1]=ub;K=F;break a}while(0);I=d[t+(E+-2<<1)>>1]|0;S=d[t+(M<<1)>>1]|0;L=I;while(1){U=d[o+((L&65535)<<1)>>1]|0;if((U&65535)<(L&65535))L=U;else break}if(I<<16>>16==S<<16>>16)vb=L;else{U=S;while(1){P=d[o+((U&65535)<<1)>>1]|0;if((P&65535)<(U&65535))U=P;else break}P=(L&65535)>(U&65535)?U:L;_=S;do{N=o+((_&65535)<<1)|0;J=_;_=d[N>>1]|0;d[N>>1]=P}while((_&65535)<(J&65535));vb=P}P=I;do{_=o+((P&65535)<<1)|0;S=P;P=d[_>>1]|0;d[_>>1]=vb}while((P&65535)<(S&65535));d[z+(E<<1)>>1]=vb;K=F;break a}while(0);d[z+(E<<1)>>1]=d[t+(M<<1)>>1]|0;K=F;break}if(B?b[x+E>>0]|0:0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break}do if(!(C|H^1)){if(!(b[x+G>>0]|0))break;d[z+(E<<1)>>1]=d[t+(E+-2<<1)>>1]|0;K=F;break a}while(0);d[z+(E<<1)>>1]=F;M=F&65535;d[o+(M<<1)>>1]=F;K=M+1&65535;break}if(B?b[x+E>>0]|0:0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break}if(!(C|H^1)?b[x+G>>0]|0:0){d[z+(E<<1)>>1]=d[t+(E+-2<<1)>>1]|0;K=F;break}d[z+(E<<1)>>1]=F;M=F&65535;d[o+(M<<1)>>1]=F;K=M+1&65535}while(0);E=E+2|0;if((E|0)>=(i|0)){wb=K;break}else F=K}}else wb=r;s=s+2|0;if((s|0)>=(a|0))break;else r=wb}if((wb&65535)>1){r=wb&65535;wb=1;a=1;while(1){s=o+(wb<<1)|0;K=j[s>>1]|0;if(K>>>0<wb>>>0){d[s>>1]=d[o+(K<<1)>>1]|0;xb=a}else{d[s>>1]=a;xb=(a&65535)+1&65535}wb=wb+1|0;if((wb|0)==(r|0)){yb=xb;break}else a=xb}}else yb=1}else yb=1;xb=f[k>>2]|0;k=f[p>>2]|0;p=(k&1|0)!=0;a=(xb|0)>0;if(!(xb&1)){if(!p){if(!a){ZF(o);u=h;return yb|0}r=f[c+16>>2]|0;wb=f[f[c+44>>2]>>2]|0;s=f[e+16>>2]|0;K=f[f[e+44>>2]>>2]|0;i=(k|0)>0;vb=0;do{ub=r+(Y(wb,vb)|0)|0;tb=ub+wb|0;sb=s+(Y(K,vb)|0)|0;ob=sb+K|0;if(i){rb=0;do{qb=sb+(rb<<1)|0;pb=d[qb>>1]|0;do if(pb<<16>>16){nb=d[o+((pb&65535)<<1)>>1]|0;d[qb>>1]=(b[ub+rb>>0]|0)==0?0:nb;jb=rb|1;d[sb+(jb<<1)>>1]=(b[ub+jb>>0]|0)==0?0:nb;d[ob+(rb<<1)>>1]=(b[tb+rb>>0]|0)==0?0:nb;mb=ob+(jb<<1)|0;if(!(b[tb+jb>>0]|0)){d[mb>>1]=0;break}else{d[mb>>1]=nb;break}}else{d[qb>>1]=0;nb=rb|1;d[sb+(nb<<1)>>1]=0;d[ob+(rb<<1)>>1]=0;d[ob+(nb<<1)>>1]=0}while(0);rb=rb+2|0}while((rb|0)<(k|0))}vb=vb+2|0}while((vb|0)<(xb|0));ZF(o);u=h;return yb|0}if(!a){ZF(o);u=h;return yb|0}vb=f[c+16>>2]|0;i=f[f[c+44>>2]>>2]|0;K=f[e+16>>2]|0;s=f[f[e+44>>2]>>2]|0;wb=(k|0)>0;r=0;do{rb=vb+(Y(i,r)|0)|0;ob=rb+i|0;sb=K+(Y(s,r)|0)|0;tb=sb+s|0;if(wb){ub=0;do{qb=sb+(ub<<1)|0;pb=d[qb>>1]|0;do if(!(pb<<16>>16)){d[qb>>1]=0;d[tb+(ub<<1)>>1]=0;nb=ub|1;if((nb|0)<(k|0)){d[sb+(nb<<1)>>1]=0;d[tb+(nb<<1)>>1]=0}}else{nb=d[o+((pb&65535)<<1)>>1]|0;d[qb>>1]=(b[rb+ub>>0]|0)==0?0:nb;d[tb+(ub<<1)>>1]=(b[ob+ub>>0]|0)==0?0:nb;mb=ub|1;if((mb|0)<(k|0)){d[sb+(mb<<1)>>1]=(b[rb+mb>>0]|0)==0?0:nb;jb=tb+(mb<<1)|0;if(!(b[ob+mb>>0]|0)){d[jb>>1]=0;break}else{d[jb>>1]=nb;break}}}while(0);ub=ub+2|0}while((ub|0)<(k|0))}r=r+2|0}while((r|0)<(xb|0));ZF(o);u=h;return yb|0}if(!p){if(!a){ZF(o);u=h;return yb|0}p=f[c+16>>2]|0;r=f[f[c+44>>2]>>2]|0;wb=f[e+16>>2]|0;s=f[f[e+44>>2]>>2]|0;K=(k|0)>0;i=0;do{vb=p+(Y(r,i)|0)|0;ub=vb+r|0;ob=wb+(Y(s,i)|0)|0;tb=ob+s|0;if(K){rb=i|1;sb=(rb|0)<(xb|0);qb=(rb|0)<(xb|0);rb=0;do{pb=ob+(rb<<1)|0;nb=d[pb>>1]|0;do if(!(nb<<16>>16)){d[pb>>1]=0;jb=rb|1;d[ob+(jb<<1)>>1]=0;if(sb){d[tb+(rb<<1)>>1]=0;d[tb+(jb<<1)>>1]=0}}else{jb=d[o+((nb&65535)<<1)>>1]|0;d[pb>>1]=(b[vb+rb>>0]|0)==0?0:jb;mb=rb|1;d[ob+(mb<<1)>>1]=(b[vb+mb>>0]|0)==0?0:jb;if(qb){d[tb+(rb<<1)>>1]=(b[ub+rb>>0]|0)==0?0:jb;lb=tb+(mb<<1)|0;if(!(b[ub+mb>>0]|0)){d[lb>>1]=0;break}else{d[lb>>1]=jb;break}}}while(0);rb=rb+2|0}while((rb|0)<(k|0))}i=i+2|0}while((i|0)<(xb|0));ZF(o);u=h;return yb|0}if(!a){ZF(o);u=h;return yb|0}a=f[c+16>>2]|0;i=f[f[c+44>>2]>>2]|0;c=f[e+16>>2]|0;K=f[f[e+44>>2]>>2]|0;e=(k|0)>0;s=0;do{wb=a+(Y(i,s)|0)|0;r=wb+i|0;p=c+(Y(K,s)|0)|0;rb=p+K|0;if(e){ub=s|1;tb=(ub|0)<(xb|0);qb=(ub|0)<(xb|0);vb=(ub|0)<(xb|0);ob=(ub|0)<(xb|0);ub=0;do{sb=p+(ub<<1)|0;pb=d[sb>>1]|0;do if(!(pb<<16>>16)){d[sb>>1]=0;nb=ub|1;if((nb|0)<(k|0)){d[p+(nb<<1)>>1]=0;if(!tb)break;d[rb+(ub<<1)>>1]=0;d[rb+(nb<<1)>>1]=0;break}else{if(!qb)break;d[rb+(ub<<1)>>1]=0;break}}else{nb=d[o+((pb&65535)<<1)>>1]|0;d[sb>>1]=(b[wb+ub>>0]|0)==0?0:nb;jb=ub|1;if((jb|0)<(k|0)){d[p+(jb<<1)>>1]=(b[wb+jb>>0]|0)==0?0:nb;if(!vb)break;d[rb+(ub<<1)>>1]=(b[r+ub>>0]|0)==0?0:nb;lb=rb+(jb<<1)|0;if(!(b[r+jb>>0]|0)){d[lb>>1]=0;break}else{d[lb>>1]=nb;break}}else{if(!ob)break;lb=rb+(ub<<1)|0;if(!(b[r+ub>>0]|0)){d[lb>>1]=0;break}else{d[lb>>1]=nb;break}}}while(0);ub=ub+2|0}while((ub|0)<(k|0))}s=s+2|0}while((s|0)<(xb|0));ZF(o);u=h;return yb|0}function o6(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0;g=u;u=u+16|0;a=g;h=c+8|0;i=d+8|0;if((f[h>>2]|0)!=(f[i>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;j=c$(a,26)|0;k=218300;l=j+26|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,a,373355,218048,2594);d$(a)}m=c+12|0;n=d+12|0;if((f[m>>2]|0)!=(f[n>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;j=c$(a,26)|0;k=218327;l=j+26|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,a,373355,218048,2595);d$(a)}if((e|0)!=8){f[a>>2]=0;f[a+4>>2]=0;j=c$(a,17)|0;k=218354;l=j+17|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,a,373355,218048,2596);d$(a)}a=f[h>>2]|0;h=f[m>>2]|0;m=YF((Y(((a+1|0)/2|0)<<2,(h+1|0)/2|0)|0)+4|0)|0;f[m>>2]=0;if((a|0)>0){k=c+16|0;j=c+44|0;l=d+16|0;e=d+44|0;o=(h|0)>0;p=1;q=0;while(1){r=f[f[j>>2]>>2]|0;s=(f[k>>2]|0)+(Y(r,q)|0)|0;t=0-r|0;v=s+t|0;w=v+t|0;t=s+r|0;r=f[f[e>>2]>>2]|0;x=(f[l>>2]|0)+(Y(r,q)|0)|0;y=0-r|0;r=x+y+y|0;if(o){y=(q|1|0)<(a|0);z=(q|0)>0;A=z^1;B=(q+-2|0)>-1;C=0;D=p;while(1){a:do if(!(b[s+C>>0]|0)){E=C|1;F=(E|0)<(h|0);if(y?b[t+C>>0]|0:0){G=C+-1|0;H=(C|0)>0;if(F?b[s+E>>0]|0:0){do if(H){if(b[s+G>>0]|0){do if(z){if(b[v+E>>0]|0){if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break a}do if(B){if(!(b[w+C>>0]|0))break;J=C+-2|0;if(b[v+G>>0]|0){f[x+(C<<2)>>2]=f[x+(J<<2)>>2];I=D;break a}do if((J|0)>-1){if(!(b[v+J>>0]|0))break;if(b[w+G>>0]|0){f[x+(C<<2)>>2]=f[x+(J<<2)>>2];I=D;break a}K=f[r+(C<<2)>>2]|0;L=f[x+(J<<2)>>2]|0;M=K;while(1){N=f[m+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}if((K|0)==(L|0))O=M;else{N=L;while(1){P=f[m+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(M|0)>(N|0)?N:M;Q=L;do{R=m+(Q<<2)|0;S=Q;Q=f[R>>2]|0;f[R>>2]=P}while((Q|0)<(S|0));O=P}P=K;do{Q=m+(P<<2)|0;L=P;P=f[Q>>2]|0;f[Q>>2]=O}while((P|0)<(L|0));f[x+(C<<2)>>2]=O;I=D;break a}while(0);P=f[r+(C<<2)>>2]|0;K=f[x+(J<<2)>>2]|0;L=P;while(1){Q=f[m+(L<<2)>>2]|0;if((Q|0)<(L|0))L=Q;else break}if((P|0)==(K|0))T=L;else{J=K;while(1){Q=f[m+(J<<2)>>2]|0;if((Q|0)<(J|0))J=Q;else break}Q=(L|0)>(J|0)?J:L;M=K;do{N=m+(M<<2)|0;S=M;M=f[N>>2]|0;f[N>>2]=Q}while((M|0)<(S|0));T=Q}Q=P;do{M=m+(Q<<2)|0;K=Q;Q=f[M>>2]|0;f[M>>2]=T}while((Q|0)<(K|0));f[x+(C<<2)>>2]=T;I=D;break a}while(0);Q=f[r+(C<<2)>>2]|0;P=f[x+(C+-2<<2)>>2]|0;K=Q;while(1){M=f[m+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}if((Q|0)==(P|0))U=K;else{M=P;while(1){L=f[m+(M<<2)>>2]|0;if((L|0)<(M|0))M=L;else break}L=(K|0)>(M|0)?M:K;J=P;do{S=m+(J<<2)|0;N=J;J=f[S>>2]|0;f[S>>2]=L}while((J|0)<(N|0));U=L}L=Q;do{J=m+(L<<2)|0;P=L;L=f[J>>2]|0;f[J>>2]=U}while((L|0)<(P|0));f[x+(C<<2)>>2]=U;I=D;break a}L=C+2|0;if((L|0)>=(h|0))break;if(!(b[v+L>>0]|0))break;do if(B){if(!(b[w+E>>0]|0))break;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break a}if(!(b[w+C>>0]|0)){Q=f[r+(L<<2)>>2]|0;P=f[x+(C+-2<<2)>>2]|0;J=Q;while(1){K=f[m+(J<<2)>>2]|0;if((K|0)<(J|0))J=K;else break}if((Q|0)==(P|0))V=J;else{K=P;while(1){M=f[m+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}M=(J|0)>(K|0)?K:J;N=P;do{S=m+(N<<2)|0;R=N;N=f[S>>2]|0;f[S>>2]=M}while((N|0)<(R|0));V=M}M=Q;do{N=m+(M<<2)|0;P=M;M=f[N>>2]|0;f[N>>2]=V}while((M|0)<(P|0));f[x+(C<<2)>>2]=V;I=D;break a}M=C+-2|0;if(b[v+G>>0]|0){f[x+(C<<2)>>2]=f[x+(M<<2)>>2];I=D;break a}do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[w+G>>0]|0){f[x+(C<<2)>>2]=f[x+(M<<2)>>2];I=D;break a}Q=f[r+(L<<2)>>2]|0;P=f[x+(M<<2)>>2]|0;N=Q;while(1){J=f[m+(N<<2)>>2]|0;if((J|0)<(N|0))N=J;else break}if((Q|0)==(P|0))W=N;else{J=P;while(1){K=f[m+(J<<2)>>2]|0;if((K|0)<(J|0))J=K;else break}K=(N|0)>(J|0)?J:N;R=P;do{S=m+(R<<2)|0;X=R;R=f[S>>2]|0;f[S>>2]=K}while((R|0)<(X|0));W=K}K=Q;do{R=m+(K<<2)|0;P=K;K=f[R>>2]|0;f[R>>2]=W}while((K|0)<(P|0));f[x+(C<<2)>>2]=W;I=D;break a}while(0);K=f[r+(L<<2)>>2]|0;Q=f[x+(M<<2)>>2]|0;P=K;while(1){R=f[m+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}if((K|0)==(Q|0))Z=P;else{M=Q;while(1){R=f[m+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}R=(P|0)>(M|0)?M:P;N=Q;do{J=m+(N<<2)|0;X=N;N=f[J>>2]|0;f[J>>2]=R}while((N|0)<(X|0));Z=R}R=K;do{N=m+(R<<2)|0;Q=R;R=f[N>>2]|0;f[N>>2]=Z}while((R|0)<(Q|0));f[x+(C<<2)>>2]=Z;I=D;break a}while(0);R=f[r+(L<<2)>>2]|0;K=f[x+(C+-2<<2)>>2]|0;Q=R;while(1){N=f[m+(Q<<2)>>2]|0;if((N|0)<(Q|0))Q=N;else break}if((R|0)==(K|0))_=Q;else{L=K;while(1){N=f[m+(L<<2)>>2]|0;if((N|0)<(L|0))L=N;else break}N=(Q|0)>(L|0)?L:Q;P=K;do{M=m+(P<<2)|0;X=P;P=f[M>>2]|0;f[M>>2]=N}while((P|0)<(X|0));_=N}N=R;do{P=m+(N<<2)|0;K=N;N=f[P>>2]|0;f[P>>2]=_}while((N|0)<(K|0));f[x+(C<<2)>>2]=_;I=D;break a}while(0);f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break a}if(!(b[t+G>>0]|0))break;do if(z){if(b[v+E>>0]|0){N=C+-2|0;do if((N|0)>-1){if(!(b[s+N>>0]|0))break;if(b[v+G>>0]|0){R=f[x+(N<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}do if(B){if(!(b[w+C>>0]|0))break;f[x+(C<<2)>>2]=R;I=D;break a}while(0);K=f[r+(C<<2)>>2]|0;P=K;while(1){Q=f[m+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}if((K|0)==(R|0))$=P;else{Q=R;while(1){L=f[m+(Q<<2)>>2]|0;if((L|0)<(Q|0))Q=L;else break}L=(P|0)>(Q|0)?Q:P;X=R;do{M=m+(X<<2)|0;J=X;X=f[M>>2]|0;f[M>>2]=L}while((X|0)<(J|0));$=L}L=K;do{X=m+(L<<2)|0;R=L;L=f[X>>2]|0;f[X>>2]=$}while((L|0)<(R|0));f[x+(C<<2)>>2]=$;I=D;break a}if(!(b[v+N>>0]|0)){L=f[r+(C<<2)>>2]|0;K=f[x+(N<<2)>>2]|0;R=L;while(1){X=f[m+(R<<2)>>2]|0;if((X|0)<(R|0))R=X;else break}if((L|0)==(K|0))aa=R;else{X=K;while(1){P=f[m+(X<<2)>>2]|0;if((P|0)<(X|0))X=P;else break}P=(R|0)>(X|0)?X:R;Q=K;do{J=m+(Q<<2)|0;M=Q;Q=f[J>>2]|0;f[J>>2]=P}while((Q|0)<(M|0));aa=P}P=L;do{Q=m+(P<<2)|0;K=P;P=f[Q>>2]|0;f[Q>>2]=aa}while((P|0)<(K|0));f[x+(C<<2)>>2]=aa;I=D;break a}do if(B){if(!(b[w+G>>0]|0))break;P=f[x+(N<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=P;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=P;I=D;break a}L=f[r+(C<<2)>>2]|0;K=L;while(1){Q=f[m+(K<<2)>>2]|0;if((Q|0)<(K|0))K=Q;else break}if((L|0)==(P|0))ba=K;else{Q=P;while(1){R=f[m+(Q<<2)>>2]|0;if((R|0)<(Q|0))Q=R;else break}R=(K|0)>(Q|0)?Q:K;X=P;do{M=m+(X<<2)|0;J=X;X=f[M>>2]|0;f[M>>2]=R}while((X|0)<(J|0));ba=R}R=L;do{X=m+(R<<2)|0;P=R;R=f[X>>2]|0;f[X>>2]=ba}while((R|0)<(P|0));f[x+(C<<2)>>2]=ba;I=D;break a}while(0);R=f[r+(C<<2)>>2]|0;L=f[x+(N<<2)>>2]|0;P=R;while(1){X=f[m+(P<<2)>>2]|0;if((X|0)<(P|0))P=X;else break}if((R|0)==(L|0))ca=P;else{X=L;while(1){K=f[m+(X<<2)>>2]|0;if((K|0)<(X|0))X=K;else break}K=(P|0)>(X|0)?X:P;Q=L;do{J=m+(Q<<2)|0;M=Q;Q=f[J>>2]|0;f[J>>2]=K}while((Q|0)<(M|0));ca=K}K=R;do{Q=m+(K<<2)|0;L=K;K=f[Q>>2]|0;f[Q>>2]=ca}while((K|0)<(L|0));f[x+(C<<2)>>2]=ca;I=D;break a}while(0);K=f[r+(C<<2)>>2]|0;R=f[x+(N<<2)>>2]|0;L=K;while(1){Q=f[m+(L<<2)>>2]|0;if((Q|0)<(L|0))L=Q;else break}if((K|0)==(R|0))da=L;else{N=R;while(1){Q=f[m+(N<<2)>>2]|0;if((Q|0)<(N|0))N=Q;else break}Q=(L|0)>(N|0)?N:L;P=R;do{X=m+(P<<2)|0;M=P;P=f[X>>2]|0;f[X>>2]=Q}while((P|0)<(M|0));da=Q}Q=K;do{P=m+(Q<<2)|0;R=Q;Q=f[P>>2]|0;f[P>>2]=da}while((Q|0)<(R|0));f[x+(C<<2)>>2]=da;I=D;break a}Q=C+2|0;do if(!((Q|0)>=(h|0)|A)){if(!(b[v+Q>>0]|0))break;do if(B){if(!(b[w+E>>0]|0))break;K=C+-2|0;do if((K|0)>-1){if(!(b[s+K>>0]|0))break;if(b[v+G>>0]|0){R=f[x+(K<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}P=f[r+(Q<<2)>>2]|0;L=P;while(1){N=f[m+(L<<2)>>2]|0;if((N|0)<(L|0))L=N;else break}if((P|0)==(R|0))ea=L;else{N=R;while(1){M=f[m+(N<<2)>>2]|0;if((M|0)<(N|0))N=M;else break}M=(L|0)>(N|0)?N:L;X=R;do{J=m+(X<<2)|0;S=X;X=f[J>>2]|0;f[J>>2]=M}while((X|0)<(S|0));ea=M}M=P;do{X=m+(M<<2)|0;R=M;M=f[X>>2]|0;f[X>>2]=ea}while((M|0)<(R|0));f[x+(C<<2)>>2]=ea;I=D;break a}if(!(b[v+K>>0]|0)){M=f[r+(Q<<2)>>2]|0;P=f[x+(K<<2)>>2]|0;R=M;while(1){X=f[m+(R<<2)>>2]|0;if((X|0)<(R|0))R=X;else break}if((M|0)==(P|0))fa=R;else{X=P;while(1){L=f[m+(X<<2)>>2]|0;if((L|0)<(X|0))X=L;else break}L=(R|0)>(X|0)?X:R;N=P;do{S=m+(N<<2)|0;J=N;N=f[S>>2]|0;f[S>>2]=L}while((N|0)<(J|0));fa=L}L=M;do{N=m+(L<<2)|0;P=L;L=f[N>>2]|0;f[N>>2]=fa}while((L|0)<(P|0));f[x+(C<<2)>>2]=fa;I=D;break a}if(!(b[w+G>>0]|0)){L=f[r+(Q<<2)>>2]|0;M=f[x+(K<<2)>>2]|0;P=L;while(1){N=f[m+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}if((L|0)==(M|0))ga=P;else{N=M;while(1){R=f[m+(N<<2)>>2]|0;if((R|0)<(N|0))N=R;else break}R=(P|0)>(N|0)?N:P;X=M;do{J=m+(X<<2)|0;S=X;X=f[J>>2]|0;f[J>>2]=R}while((X|0)<(S|0));ga=R}R=L;do{X=m+(R<<2)|0;M=R;R=f[X>>2]|0;f[X>>2]=ga}while((R|0)<(M|0));f[x+(C<<2)>>2]=ga;I=D;break a}R=f[x+(K<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}L=f[r+(Q<<2)>>2]|0;M=L;while(1){X=f[m+(M<<2)>>2]|0;if((X|0)<(M|0))M=X;else break}if((L|0)==(R|0))ha=M;else{X=R;while(1){P=f[m+(X<<2)>>2]|0;if((P|0)<(X|0))X=P;else break}P=(M|0)>(X|0)?X:M;N=R;do{S=m+(N<<2)|0;J=N;N=f[S>>2]|0;f[S>>2]=P}while((N|0)<(J|0));ha=P}P=L;do{N=m+(P<<2)|0;R=P;P=f[N>>2]|0;f[N>>2]=ha}while((P|0)<(R|0));f[x+(C<<2)>>2]=ha;I=D;break a}while(0);P=f[r+(Q<<2)>>2]|0;L=f[x+(K<<2)>>2]|0;R=P;while(1){N=f[m+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}if((P|0)==(L|0))ia=R;else{K=L;while(1){N=f[m+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(R|0)>(K|0)?K:R;M=L;do{X=m+(M<<2)|0;J=M;M=f[X>>2]|0;f[X>>2]=N}while((M|0)<(J|0));ia=N}N=P;do{M=m+(N<<2)|0;L=N;N=f[M>>2]|0;f[M>>2]=ia}while((N|0)<(L|0));f[x+(C<<2)>>2]=ia;I=D;break a}while(0);N=C+-2|0;if(!(b[v+C>>0]|0)){P=f[r+(Q<<2)>>2]|0;L=f[x+(N<<2)>>2]|0;M=P;while(1){R=f[m+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}if((P|0)==(L|0))ja=M;else{R=L;while(1){K=f[m+(R<<2)>>2]|0;if((K|0)<(R|0))R=K;else break}K=(M|0)>(R|0)?R:M;J=L;do{X=m+(J<<2)|0;S=J;J=f[X>>2]|0;f[X>>2]=K}while((J|0)<(S|0));ja=K}K=P;do{J=m+(K<<2)|0;L=K;K=f[J>>2]|0;f[J>>2]=ja}while((K|0)<(L|0));f[x+(C<<2)>>2]=ja;I=D;break a}do if((N|0)>-1){if(!(b[s+N>>0]|0))break;if(b[v+G>>0]|0){K=f[r+(Q<<2)>>2]|0;P=f[x+(N<<2)>>2]|0;L=K;while(1){J=f[m+(L<<2)>>2]|0;if((J|0)<(L|0))L=J;else break}if((K|0)==(P|0))ka=L;else{J=P;while(1){M=f[m+(J<<2)>>2]|0;if((M|0)<(J|0))J=M;else break}M=(L|0)>(J|0)?J:L;R=P;do{S=m+(R<<2)|0;X=R;R=f[S>>2]|0;f[S>>2]=M}while((R|0)<(X|0));ka=M}M=K;do{R=m+(M<<2)|0;P=M;M=f[R>>2]|0;f[R>>2]=ka}while((M|0)<(P|0));f[x+(C<<2)>>2]=ka;I=D;break a}if(!(b[v+N>>0]|0)){M=f[r+(C<<2)>>2]|0;K=f[r+(Q<<2)>>2]|0;P=M;while(1){R=f[m+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}if((M|0)==(K|0))la=P;else{R=K;while(1){L=f[m+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}L=(P|0)>(R|0)?R:P;J=K;do{X=m+(J<<2)|0;S=J;J=f[X>>2]|0;f[X>>2]=L}while((J|0)<(S|0));la=L}L=M;do{J=m+(L<<2)|0;K=L;L=f[J>>2]|0;f[J>>2]=la}while((L|0)<(K|0));L=f[x+(N<<2)>>2]|0;M=la;while(1){K=f[m+(M<<2)>>2]|0;if((K|0)<(M|0))M=K;else break}if((la|0)==(L|0))ma=M;else{K=L;while(1){J=f[m+(K<<2)>>2]|0;if((J|0)<(K|0))K=J;else break}J=(M|0)>(K|0)?K:M;P=L;do{R=m+(P<<2)|0;S=P;P=f[R>>2]|0;f[R>>2]=J}while((P|0)<(S|0));ma=J}J=la;do{P=m+(J<<2)|0;L=J;J=f[P>>2]|0;f[P>>2]=ma}while((J|0)<(L|0));f[x+(C<<2)>>2]=ma;I=D;break a}do if(B){if(!(b[w+G>>0]|0))break;J=f[r+(Q<<2)>>2]|0;L=f[x+(N<<2)>>2]|0;P=J;while(1){M=f[m+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}if((J|0)==(L|0))na=P;else{M=L;while(1){K=f[m+(M<<2)>>2]|0;if((K|0)<(M|0))M=K;else break}K=(P|0)>(M|0)?M:P;S=L;do{R=m+(S<<2)|0;X=S;S=f[R>>2]|0;f[R>>2]=K}while((S|0)<(X|0));na=K}K=J;do{S=m+(K<<2)|0;L=K;K=f[S>>2]|0;f[S>>2]=na}while((K|0)<(L|0));f[x+(C<<2)>>2]=na;I=D;break a}while(0);K=f[r+(C<<2)>>2]|0;J=f[r+(Q<<2)>>2]|0;L=K;while(1){S=f[m+(L<<2)>>2]|0;if((S|0)<(L|0))L=S;else break}if((K|0)==(J|0))oa=L;else{S=J;while(1){P=f[m+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}P=(L|0)>(S|0)?S:L;M=J;do{X=m+(M<<2)|0;R=M;M=f[X>>2]|0;f[X>>2]=P}while((M|0)<(R|0));oa=P}P=K;do{M=m+(P<<2)|0;J=P;P=f[M>>2]|0;f[M>>2]=oa}while((P|0)<(J|0));P=f[x+(N<<2)>>2]|0;K=oa;while(1){J=f[m+(K<<2)>>2]|0;if((J|0)<(K|0))K=J;else break}if((oa|0)==(P|0))pa=K;else{J=P;while(1){M=f[m+(J<<2)>>2]|0;if((M|0)<(J|0))J=M;else break}M=(K|0)>(J|0)?J:K;L=P;do{S=m+(L<<2)|0;R=L;L=f[S>>2]|0;f[S>>2]=M}while((L|0)<(R|0));pa=M}M=oa;do{L=m+(M<<2)|0;P=M;M=f[L>>2]|0;f[L>>2]=pa}while((M|0)<(P|0));f[x+(C<<2)>>2]=pa;I=D;break a}while(0);M=f[r+(C<<2)>>2]|0;P=f[r+(Q<<2)>>2]|0;L=M;while(1){K=f[m+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}if((M|0)==(P|0))qa=L;else{K=P;while(1){J=f[m+(K<<2)>>2]|0;if((J|0)<(K|0))K=J;else break}J=(L|0)>(K|0)?K:L;R=P;do{S=m+(R<<2)|0;X=R;R=f[S>>2]|0;f[S>>2]=J}while((R|0)<(X|0));qa=J}J=M;do{R=m+(J<<2)|0;P=J;J=f[R>>2]|0;f[R>>2]=qa}while((J|0)<(P|0));J=f[x+(N<<2)>>2]|0;M=qa;while(1){P=f[m+(M<<2)>>2]|0;if((P|0)<(M|0))M=P;else break}if((qa|0)==(J|0))ra=M;else{N=J;while(1){P=f[m+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(M|0)>(N|0)?N:M;R=J;do{L=m+(R<<2)|0;K=R;R=f[L>>2]|0;f[L>>2]=P}while((R|0)<(K|0));ra=P}P=qa;do{R=m+(P<<2)|0;J=P;P=f[R>>2]|0;f[R>>2]=ra}while((P|0)<(J|0));f[x+(C<<2)>>2]=ra;I=D;break a}while(0);Q=C+-2|0;if(!(b[v+C>>0]|0)){sa=Q;break}do if((Q|0)>-1){if(!(b[s+Q>>0]|0))break;if(b[v+G>>0]|0){f[x+(C<<2)>>2]=f[x+(Q<<2)>>2];I=D;break a}if(!(b[v+Q>>0]|0)){P=f[r+(C<<2)>>2]|0;J=f[x+(Q<<2)>>2]|0;R=P;while(1){M=f[m+(R<<2)>>2]|0;if((M|0)<(R|0))R=M;else break}if((P|0)==(J|0))ta=R;else{M=J;while(1){N=f[m+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}N=(R|0)>(M|0)?M:R;K=J;do{L=m+(K<<2)|0;X=K;K=f[L>>2]|0;f[L>>2]=N}while((K|0)<(X|0));ta=N}N=P;do{K=m+(N<<2)|0;J=N;N=f[K>>2]|0;f[K>>2]=ta}while((N|0)<(J|0));f[x+(C<<2)>>2]=ta;I=D;break a}do if(B){if(!(b[w+G>>0]|0))break;f[x+(C<<2)>>2]=f[x+(Q<<2)>>2];I=D;break a}while(0);N=f[r+(C<<2)>>2]|0;P=f[x+(Q<<2)>>2]|0;J=N;while(1){K=f[m+(J<<2)>>2]|0;if((K|0)<(J|0))J=K;else break}if((N|0)==(P|0))ua=J;else{K=P;while(1){R=f[m+(K<<2)>>2]|0;if((R|0)<(K|0))K=R;else break}R=(J|0)>(K|0)?K:J;M=P;do{X=m+(M<<2)|0;L=M;M=f[X>>2]|0;f[X>>2]=R}while((M|0)<(L|0));ua=R}R=N;do{M=m+(R<<2)|0;P=R;R=f[M>>2]|0;f[M>>2]=ua}while((R|0)<(P|0));f[x+(C<<2)>>2]=ua;I=D;break a}while(0);R=f[r+(C<<2)>>2]|0;N=f[x+(Q<<2)>>2]|0;P=R;while(1){M=f[m+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}if((R|0)==(N|0))va=P;else{Q=N;while(1){M=f[m+(Q<<2)>>2]|0;if((M|0)<(Q|0))Q=M;else break}M=(P|0)>(Q|0)?Q:P;J=N;do{K=m+(J<<2)|0;L=J;J=f[K>>2]|0;f[K>>2]=M}while((J|0)<(L|0));va=M}M=R;do{J=m+(M<<2)|0;N=M;M=f[J>>2]|0;f[J>>2]=va}while((M|0)<(N|0));f[x+(C<<2)>>2]=va;I=D;break a}else sa=C+-2|0;while(0);f[x+(C<<2)>>2]=f[x+(sa<<2)>>2];I=D;break a}while(0);do if(z){if(b[v+E>>0]|0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break a}M=C+2|0;do if(!((M|0)>=(h|0)|A)){if(!(b[v+M>>0]|0))break;if(!(b[v+C>>0]|0)){f[x+(C<<2)>>2]=f[r+(M<<2)>>2];I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;f[x+(C<<2)>>2]=f[r+(M<<2)>>2];I=D;break a}while(0);R=f[r+(C<<2)>>2]|0;N=f[r+(M<<2)>>2]|0;J=R;while(1){P=f[m+(J<<2)>>2]|0;if((P|0)<(J|0))J=P;else break}if((R|0)==(N|0))wa=J;else{P=N;while(1){Q=f[m+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}Q=(J|0)>(P|0)?P:J;L=N;do{K=m+(L<<2)|0;X=L;L=f[K>>2]|0;f[K>>2]=Q}while((L|0)<(X|0));wa=Q}Q=R;do{L=m+(Q<<2)|0;N=Q;Q=f[L>>2]|0;f[L>>2]=wa}while((Q|0)<(N|0));f[x+(C<<2)>>2]=wa;I=D;break a}while(0);if(!(b[v+C>>0]|0))break;f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break a}while(0);f[x+(C<<2)>>2]=D;f[m+(D<<2)>>2]=D;I=D+1|0;break}if(H){if(b[t+G>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break}if(b[s+G>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break}}f[x+(C<<2)>>2]=D;f[m+(D<<2)>>2]=D;I=D+1|0;break}do if(F){if(!(b[s+E>>0]|0)){if(!y)break;if(!(b[t+E>>0]|0))break;f[x+(C<<2)>>2]=D;f[m+(D<<2)>>2]=D;I=D+1|0;break a}if(z){if(b[v+E>>0]|0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break a}M=C+2|0;do if(!((M|0)>=(h|0)|A)){if(!(b[v+M>>0]|0))break;if(!(b[v+C>>0]|0)){f[x+(C<<2)>>2]=f[r+(M<<2)>>2];I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;f[x+(C<<2)>>2]=f[r+(M<<2)>>2];I=D;break a}while(0);Q=f[r+(C<<2)>>2]|0;R=f[r+(M<<2)>>2]|0;N=Q;while(1){L=f[m+(N<<2)>>2]|0;if((L|0)<(N|0))N=L;else break}if((Q|0)==(R|0))xa=N;else{L=R;while(1){J=f[m+(L<<2)>>2]|0;if((J|0)<(L|0))L=J;else break}J=(N|0)>(L|0)?L:N;P=R;do{X=m+(P<<2)|0;K=P;P=f[X>>2]|0;f[X>>2]=J}while((P|0)<(K|0));xa=J}J=Q;do{P=m+(J<<2)|0;R=J;J=f[P>>2]|0;f[P>>2]=xa}while((J|0)<(R|0));f[x+(C<<2)>>2]=xa;I=D;break a}while(0);if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break a}}f[x+(C<<2)>>2]=D;f[m+(D<<2)>>2]=D;I=D+1|0;break a}while(0);f[x+(C<<2)>>2]=0;I=D}else{E=C+-1|0;F=(C|0)>0;if(F){if(b[s+E>>0]|0){G=C|1;H=(G|0)<(h|0);if(z&H?b[v+G>>0]|0:0){if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break}do if(B){if(!(b[w+C>>0]|0))break;M=C+-2|0;if(b[v+E>>0]|0){f[x+(C<<2)>>2]=f[x+(M<<2)>>2];I=D;break a}do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[w+E>>0]|0){f[x+(C<<2)>>2]=f[x+(M<<2)>>2];I=D;break a}J=f[r+(C<<2)>>2]|0;Q=f[x+(M<<2)>>2]|0;R=J;while(1){P=f[m+(R<<2)>>2]|0;if((P|0)<(R|0))R=P;else break}if((J|0)==(Q|0))ya=R;else{P=Q;while(1){N=f[m+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}N=(R|0)>(P|0)?P:R;L=Q;do{K=m+(L<<2)|0;X=L;L=f[K>>2]|0;f[K>>2]=N}while((L|0)<(X|0));ya=N}N=J;do{L=m+(N<<2)|0;Q=N;N=f[L>>2]|0;f[L>>2]=ya}while((N|0)<(Q|0));f[x+(C<<2)>>2]=ya;I=D;break a}while(0);N=f[r+(C<<2)>>2]|0;J=f[x+(M<<2)>>2]|0;Q=N;while(1){L=f[m+(Q<<2)>>2]|0;if((L|0)<(Q|0))Q=L;else break}if((N|0)==(J|0))za=Q;else{M=J;while(1){L=f[m+(M<<2)>>2]|0;if((L|0)<(M|0))M=L;else break}L=(Q|0)>(M|0)?M:Q;R=J;do{P=m+(R<<2)|0;X=R;R=f[P>>2]|0;f[P>>2]=L}while((R|0)<(X|0));za=L}L=N;do{R=m+(L<<2)|0;J=L;L=f[R>>2]|0;f[R>>2]=za}while((L|0)<(J|0));f[x+(C<<2)>>2]=za;I=D;break a}while(0);L=f[r+(C<<2)>>2]|0;N=f[x+(C+-2<<2)>>2]|0;J=L;while(1){R=f[m+(J<<2)>>2]|0;if((R|0)<(J|0))J=R;else break}if((L|0)==(N|0))Aa=J;else{R=N;while(1){Q=f[m+(R<<2)>>2]|0;if((Q|0)<(R|0))R=Q;else break}Q=(J|0)>(R|0)?R:J;M=N;do{X=m+(M<<2)|0;P=M;M=f[X>>2]|0;f[X>>2]=Q}while((M|0)<(P|0));Aa=Q}Q=L;do{M=m+(Q<<2)|0;N=Q;Q=f[M>>2]|0;f[M>>2]=Aa}while((Q|0)<(N|0));f[x+(C<<2)>>2]=Aa;I=D;break}if(H?b[s+G>>0]|0:0){Q=C+2|0;do if(z&(Q|0)<(h|0)){if(!(b[v+Q>>0]|0))break;do if(B){if(!(b[w+G>>0]|0))break;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break a}if(!(b[w+C>>0]|0)){L=f[r+(Q<<2)>>2]|0;N=f[x+(C+-2<<2)>>2]|0;M=L;while(1){J=f[m+(M<<2)>>2]|0;if((J|0)<(M|0))M=J;else break}if((L|0)==(N|0))Ba=M;else{J=N;while(1){R=f[m+(J<<2)>>2]|0;if((R|0)<(J|0))J=R;else break}R=(M|0)>(J|0)?J:M;P=N;do{X=m+(P<<2)|0;K=P;P=f[X>>2]|0;f[X>>2]=R}while((P|0)<(K|0));Ba=R}R=L;do{P=m+(R<<2)|0;N=R;R=f[P>>2]|0;f[P>>2]=Ba}while((R|0)<(N|0));f[x+(C<<2)>>2]=Ba;I=D;break a}R=C+-2|0;if(b[v+E>>0]|0){f[x+(C<<2)>>2]=f[x+(R<<2)>>2];I=D;break a}do if((R|0)>-1){if(!(b[v+R>>0]|0))break;if(b[w+E>>0]|0){f[x+(C<<2)>>2]=f[x+(R<<2)>>2];I=D;break a}L=f[r+(Q<<2)>>2]|0;N=f[x+(R<<2)>>2]|0;P=L;while(1){M=f[m+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}if((L|0)==(N|0))Ca=P;else{M=N;while(1){J=f[m+(M<<2)>>2]|0;if((J|0)<(M|0))M=J;else break}J=(P|0)>(M|0)?M:P;K=N;do{X=m+(K<<2)|0;S=K;K=f[X>>2]|0;f[X>>2]=J}while((K|0)<(S|0));Ca=J}J=L;do{K=m+(J<<2)|0;N=J;J=f[K>>2]|0;f[K>>2]=Ca}while((J|0)<(N|0));f[x+(C<<2)>>2]=Ca;I=D;break a}while(0);J=f[r+(Q<<2)>>2]|0;L=f[x+(R<<2)>>2]|0;N=J;while(1){K=f[m+(N<<2)>>2]|0;if((K|0)<(N|0))N=K;else break}if((J|0)==(L|0))Da=N;else{R=L;while(1){K=f[m+(R<<2)>>2]|0;if((K|0)<(R|0))R=K;else break}K=(N|0)>(R|0)?R:N;P=L;do{M=m+(P<<2)|0;S=P;P=f[M>>2]|0;f[M>>2]=K}while((P|0)<(S|0));Da=K}K=J;do{P=m+(K<<2)|0;L=K;K=f[P>>2]|0;f[P>>2]=Da}while((K|0)<(L|0));f[x+(C<<2)>>2]=Da;I=D;break a}while(0);K=f[r+(Q<<2)>>2]|0;J=f[x+(C+-2<<2)>>2]|0;L=K;while(1){P=f[m+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}if((K|0)==(J|0))Ea=L;else{P=J;while(1){N=f[m+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}N=(L|0)>(P|0)?P:L;R=J;do{S=m+(R<<2)|0;M=R;R=f[S>>2]|0;f[S>>2]=N}while((R|0)<(M|0));Ea=N}N=K;do{R=m+(N<<2)|0;J=N;N=f[R>>2]|0;f[R>>2]=Ea}while((N|0)<(J|0));f[x+(C<<2)>>2]=Ea;I=D;break a}while(0);f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break}f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break}if(y?b[t+E>>0]|0:0){Q=C|1;G=(Q|0)<(h|0);if(!(A|G^1)?b[v+Q>>0]|0:0){H=C+-2|0;do if((H|0)>-1){if(!(b[s+H>>0]|0))break;if(b[v+E>>0]|0){N=f[x+(H<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=N;I=D;break a}do if(B){if(!(b[w+C>>0]|0))break;f[x+(C<<2)>>2]=N;I=D;break a}while(0);K=f[r+(C<<2)>>2]|0;J=K;while(1){R=f[m+(J<<2)>>2]|0;if((R|0)<(J|0))J=R;else break}if((K|0)==(N|0))Fa=J;else{R=N;while(1){L=f[m+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}L=(J|0)>(R|0)?R:J;P=N;do{M=m+(P<<2)|0;S=P;P=f[M>>2]|0;f[M>>2]=L}while((P|0)<(S|0));Fa=L}L=K;do{P=m+(L<<2)|0;N=L;L=f[P>>2]|0;f[P>>2]=Fa}while((L|0)<(N|0));f[x+(C<<2)>>2]=Fa;I=D;break a}if(!(b[v+H>>0]|0)){L=f[r+(C<<2)>>2]|0;K=f[x+(H<<2)>>2]|0;N=L;while(1){P=f[m+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((L|0)==(K|0))Ga=N;else{P=K;while(1){J=f[m+(P<<2)>>2]|0;if((J|0)<(P|0))P=J;else break}J=(N|0)>(P|0)?P:N;R=K;do{S=m+(R<<2)|0;M=R;R=f[S>>2]|0;f[S>>2]=J}while((R|0)<(M|0));Ga=J}J=L;do{R=m+(J<<2)|0;K=J;J=f[R>>2]|0;f[R>>2]=Ga}while((J|0)<(K|0));f[x+(C<<2)>>2]=Ga;I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;J=f[x+(H<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=J;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=J;I=D;break a}L=f[r+(C<<2)>>2]|0;K=L;while(1){R=f[m+(K<<2)>>2]|0;if((R|0)<(K|0))K=R;else break}if((L|0)==(J|0))Ha=K;else{R=J;while(1){N=f[m+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}N=(K|0)>(R|0)?R:K;P=J;do{M=m+(P<<2)|0;S=P;P=f[M>>2]|0;f[M>>2]=N}while((P|0)<(S|0));Ha=N}N=L;do{P=m+(N<<2)|0;J=N;N=f[P>>2]|0;f[P>>2]=Ha}while((N|0)<(J|0));f[x+(C<<2)>>2]=Ha;I=D;break a}while(0);N=f[r+(C<<2)>>2]|0;L=f[x+(H<<2)>>2]|0;J=N;while(1){P=f[m+(J<<2)>>2]|0;if((P|0)<(J|0))J=P;else break}if((N|0)==(L|0))Ia=J;else{P=L;while(1){K=f[m+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(J|0)>(P|0)?P:J;R=L;do{S=m+(R<<2)|0;M=R;R=f[S>>2]|0;f[S>>2]=K}while((R|0)<(M|0));Ia=K}K=N;do{R=m+(K<<2)|0;L=K;K=f[R>>2]|0;f[R>>2]=Ia}while((K|0)<(L|0));f[x+(C<<2)>>2]=Ia;I=D;break a}while(0);if(b[v+C>>0]|0){K=f[r+(C<<2)>>2]|0;N=f[x+(H<<2)>>2]|0;L=K;while(1){R=f[m+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((K|0)==(N|0))Ja=L;else{R=N;while(1){J=f[m+(R<<2)>>2]|0;if((J|0)<(R|0))R=J;else break}J=(L|0)>(R|0)?R:L;P=N;do{M=m+(P<<2)|0;S=P;P=f[M>>2]|0;f[M>>2]=J}while((P|0)<(S|0));Ja=J}J=K;do{P=m+(J<<2)|0;N=J;J=f[P>>2]|0;f[P>>2]=Ja}while((J|0)<(N|0));f[x+(C<<2)>>2]=Ja;I=D;break}J=f[r+(C<<2)>>2]|0;if(!(b[v+E>>0]|0)){K=f[x+(H<<2)>>2]|0;N=J;while(1){P=f[m+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((J|0)==(K|0))Ka=N;else{P=K;while(1){L=f[m+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}L=(N|0)>(P|0)?P:N;R=K;do{S=m+(R<<2)|0;M=R;R=f[S>>2]|0;f[S>>2]=L}while((R|0)<(M|0));Ka=L}L=J;do{R=m+(L<<2)|0;K=L;L=f[R>>2]|0;f[R>>2]=Ka}while((L|0)<(K|0));f[x+(C<<2)>>2]=Ka;I=D;break}do if(B){if(!(b[w+C>>0]|0))break;L=f[x+(H<<2)>>2]|0;K=J;while(1){R=f[m+(K<<2)>>2]|0;if((R|0)<(K|0))K=R;else break}if((J|0)==(L|0))La=K;else{R=L;while(1){N=f[m+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}N=(K|0)>(R|0)?R:K;P=L;do{M=m+(P<<2)|0;S=P;P=f[M>>2]|0;f[M>>2]=N}while((P|0)<(S|0));La=N}N=J;do{P=m+(N<<2)|0;L=N;N=f[P>>2]|0;f[P>>2]=La}while((N|0)<(L|0));f[x+(C<<2)>>2]=La;I=D;break a}while(0);N=f[r+(H<<2)>>2]|0;L=N;while(1){P=f[m+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}if((N|0)==(J|0))Ma=L;else{P=J;while(1){K=f[m+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(L|0)>(P|0)?P:L;R=J;do{S=m+(R<<2)|0;M=R;R=f[S>>2]|0;f[S>>2]=K}while((R|0)<(M|0));Ma=K}K=N;do{R=m+(K<<2)|0;J=K;K=f[R>>2]|0;f[R>>2]=Ma}while((K|0)<(J|0));K=f[x+(H<<2)>>2]|0;N=Ma;while(1){J=f[m+(N<<2)>>2]|0;if((J|0)<(N|0))N=J;else break}if((Ma|0)==(K|0))Na=N;else{H=K;while(1){J=f[m+(H<<2)>>2]|0;if((J|0)<(H|0))H=J;else break}J=(N|0)>(H|0)?H:N;R=K;do{L=m+(R<<2)|0;P=R;R=f[L>>2]|0;f[L>>2]=J}while((R|0)<(P|0));Na=J}J=Ma;do{R=m+(J<<2)|0;K=J;J=f[R>>2]|0;f[R>>2]=Na}while((J|0)<(K|0));f[x+(C<<2)>>2]=Na;I=D;break}if(G?b[s+Q>>0]|0:0){J=C+2|0;do if(!((J|0)>=(h|0)|A)){if(!(b[v+J>>0]|0))break;K=C+-2|0;do if((K|0)>-1){if(!(b[s+K>>0]|0))break;if(b[v+E>>0]|0){do if(B){if(!(b[w+Q>>0]|0))break;R=f[x+(K<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}N=f[r+(J<<2)>>2]|0;H=N;while(1){P=f[m+(H<<2)>>2]|0;if((P|0)<(H|0))H=P;else break}if((N|0)==(R|0))Oa=H;else{P=R;while(1){L=f[m+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}L=(H|0)>(P|0)?P:H;M=R;do{S=m+(M<<2)|0;X=M;M=f[S>>2]|0;f[S>>2]=L}while((M|0)<(X|0));Oa=L}L=N;do{M=m+(L<<2)|0;R=L;L=f[M>>2]|0;f[M>>2]=Oa}while((L|0)<(R|0));f[x+(C<<2)>>2]=Oa;I=D;break a}while(0);L=f[r+(J<<2)>>2]|0;N=f[x+(K<<2)>>2]|0;R=L;while(1){M=f[m+(R<<2)>>2]|0;if((M|0)<(R|0))R=M;else break}if((L|0)==(N|0))Pa=R;else{M=N;while(1){H=f[m+(M<<2)>>2]|0;if((H|0)<(M|0))M=H;else break}H=(R|0)>(M|0)?M:R;P=N;do{X=m+(P<<2)|0;S=P;P=f[X>>2]|0;f[X>>2]=H}while((P|0)<(S|0));Pa=H}H=L;do{P=m+(H<<2)|0;N=H;H=f[P>>2]|0;f[P>>2]=Pa}while((H|0)<(N|0));f[x+(C<<2)>>2]=Pa;I=D;break a}do if(B){if(!(b[w+Q>>0]|0))break;if(!(b[v+K>>0]|0)){H=f[r+(J<<2)>>2]|0;L=f[x+(K<<2)>>2]|0;N=H;while(1){P=f[m+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((H|0)==(L|0))Qa=N;else{P=L;while(1){R=f[m+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}R=(N|0)>(P|0)?P:N;M=L;do{S=m+(M<<2)|0;X=M;M=f[S>>2]|0;f[S>>2]=R}while((M|0)<(X|0));Qa=R}R=H;do{M=m+(R<<2)|0;L=R;R=f[M>>2]|0;f[M>>2]=Qa}while((R|0)<(L|0));f[x+(C<<2)>>2]=Qa;I=D;break a}if(!(b[w+E>>0]|0)){R=f[r+(J<<2)>>2]|0;H=f[x+(K<<2)>>2]|0;L=R;while(1){M=f[m+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((R|0)==(H|0))Ra=L;else{M=H;while(1){N=f[m+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}N=(L|0)>(M|0)?M:L;P=H;do{X=m+(P<<2)|0;S=P;P=f[X>>2]|0;f[X>>2]=N}while((P|0)<(S|0));Ra=N}N=R;do{P=m+(N<<2)|0;H=N;N=f[P>>2]|0;f[P>>2]=Ra}while((N|0)<(H|0));f[x+(C<<2)>>2]=Ra;I=D;break a}N=f[x+(K<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=N;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=N;I=D;break a}R=f[r+(J<<2)>>2]|0;H=R;while(1){P=f[m+(H<<2)>>2]|0;if((P|0)<(H|0))H=P;else break}if((R|0)==(N|0))Sa=H;else{P=N;while(1){L=f[m+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}L=(H|0)>(P|0)?P:H;M=N;do{S=m+(M<<2)|0;X=M;M=f[S>>2]|0;f[S>>2]=L}while((M|0)<(X|0));Sa=L}L=R;do{M=m+(L<<2)|0;N=L;L=f[M>>2]|0;f[M>>2]=Sa}while((L|0)<(N|0));f[x+(C<<2)>>2]=Sa;I=D;break a}while(0);if(!(b[v+C>>0]|0)){L=f[r+(J<<2)>>2]|0;R=f[x+(K<<2)>>2]|0;N=L;while(1){M=f[m+(N<<2)>>2]|0;if((M|0)<(N|0))N=M;else break}if((L|0)==(R|0))Ta=N;else{M=R;while(1){H=f[m+(M<<2)>>2]|0;if((H|0)<(M|0))M=H;else break}H=(N|0)>(M|0)?M:N;P=R;do{X=m+(P<<2)|0;S=P;P=f[X>>2]|0;f[X>>2]=H}while((P|0)<(S|0));Ta=H}H=L;do{P=m+(H<<2)|0;R=H;H=f[P>>2]|0;f[P>>2]=Ta}while((H|0)<(R|0));f[x+(C<<2)>>2]=Ta;I=D;break a}if(!(b[v+K>>0]|0)){H=f[r+(C<<2)>>2]|0;L=f[r+(J<<2)>>2]|0;R=H;while(1){P=f[m+(R<<2)>>2]|0;if((P|0)<(R|0))R=P;else break}if((H|0)==(L|0))Ua=R;else{P=L;while(1){N=f[m+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}N=(R|0)>(P|0)?P:R;M=L;do{S=m+(M<<2)|0;X=M;M=f[S>>2]|0;f[S>>2]=N}while((M|0)<(X|0));Ua=N}N=H;do{M=m+(N<<2)|0;L=N;N=f[M>>2]|0;f[M>>2]=Ua}while((N|0)<(L|0));N=f[x+(K<<2)>>2]|0;H=Ua;while(1){L=f[m+(H<<2)>>2]|0;if((L|0)<(H|0))H=L;else break}if((Ua|0)==(N|0))Va=H;else{L=N;while(1){M=f[m+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(H|0)>(L|0)?L:H;R=N;do{P=m+(R<<2)|0;X=R;R=f[P>>2]|0;f[P>>2]=M}while((R|0)<(X|0));Va=M}M=Ua;do{R=m+(M<<2)|0;N=M;M=f[R>>2]|0;f[R>>2]=Va}while((M|0)<(N|0));f[x+(C<<2)>>2]=Va;I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;M=f[r+(J<<2)>>2]|0;N=f[x+(K<<2)>>2]|0;R=M;while(1){H=f[m+(R<<2)>>2]|0;if((H|0)<(R|0))R=H;else break}if((M|0)==(N|0))Wa=R;else{H=N;while(1){L=f[m+(H<<2)>>2]|0;if((L|0)<(H|0))H=L;else break}L=(R|0)>(H|0)?H:R;X=N;do{P=m+(X<<2)|0;S=X;X=f[P>>2]|0;f[P>>2]=L}while((X|0)<(S|0));Wa=L}L=M;do{X=m+(L<<2)|0;N=L;L=f[X>>2]|0;f[X>>2]=Wa}while((L|0)<(N|0));f[x+(C<<2)>>2]=Wa;I=D;break a}while(0);L=f[r+(C<<2)>>2]|0;M=f[r+(J<<2)>>2]|0;N=L;while(1){X=f[m+(N<<2)>>2]|0;if((X|0)<(N|0))N=X;else break}if((L|0)==(M|0))Xa=N;else{X=M;while(1){R=f[m+(X<<2)>>2]|0;if((R|0)<(X|0))X=R;else break}R=(N|0)>(X|0)?X:N;H=M;do{S=m+(H<<2)|0;P=H;H=f[S>>2]|0;f[S>>2]=R}while((H|0)<(P|0));Xa=R}R=L;do{H=m+(R<<2)|0;M=R;R=f[H>>2]|0;f[H>>2]=Xa}while((R|0)<(M|0));R=f[x+(K<<2)>>2]|0;L=Xa;while(1){M=f[m+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((Xa|0)==(R|0))Ya=L;else{M=R;while(1){H=f[m+(M<<2)>>2]|0;if((H|0)<(M|0))M=H;else break}H=(L|0)>(M|0)?M:L;N=R;do{X=m+(N<<2)|0;P=N;N=f[X>>2]|0;f[X>>2]=H}while((N|0)<(P|0));Ya=H}H=Xa;do{N=m+(H<<2)|0;R=H;H=f[N>>2]|0;f[N>>2]=Ya}while((H|0)<(R|0));f[x+(C<<2)>>2]=Ya;I=D;break a}while(0);if(b[v+C>>0]|0){do if(B){if(!(b[w+Q>>0]|0))break;H=f[r+(J<<2)>>2]|0;R=f[x+(K<<2)>>2]|0;N=H;while(1){L=f[m+(N<<2)>>2]|0;if((L|0)<(N|0))N=L;else break}if((H|0)==(R|0))Za=N;else{L=R;while(1){M=f[m+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(N|0)>(L|0)?L:N;P=R;do{X=m+(P<<2)|0;S=P;P=f[X>>2]|0;f[X>>2]=M}while((P|0)<(S|0));Za=M}M=H;do{P=m+(M<<2)|0;R=M;M=f[P>>2]|0;f[P>>2]=Za}while((M|0)<(R|0));f[x+(C<<2)>>2]=Za;I=D;break a}while(0);M=f[r+(C<<2)>>2]|0;H=f[r+(J<<2)>>2]|0;R=M;while(1){P=f[m+(R<<2)>>2]|0;if((P|0)<(R|0))R=P;else break}if((M|0)==(H|0))_a=R;else{P=H;while(1){N=f[m+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}N=(R|0)>(P|0)?P:R;L=H;do{S=m+(L<<2)|0;X=L;L=f[S>>2]|0;f[S>>2]=N}while((L|0)<(X|0));_a=N}N=M;do{L=m+(N<<2)|0;H=N;N=f[L>>2]|0;f[L>>2]=_a}while((N|0)<(H|0));N=f[x+(K<<2)>>2]|0;M=_a;while(1){H=f[m+(M<<2)>>2]|0;if((H|0)<(M|0))M=H;else break}if((_a|0)==(N|0))$a=M;else{H=N;while(1){L=f[m+(H<<2)>>2]|0;if((L|0)<(H|0))H=L;else break}L=(M|0)>(H|0)?H:M;R=N;do{P=m+(R<<2)|0;X=R;R=f[P>>2]|0;f[P>>2]=L}while((R|0)<(X|0));$a=L}L=_a;do{R=m+(L<<2)|0;N=L;L=f[R>>2]|0;f[R>>2]=$a}while((L|0)<(N|0));f[x+(C<<2)>>2]=$a;I=D;break a}if(!(b[v+E>>0]|0)){L=f[r+(J<<2)>>2]|0;N=f[x+(K<<2)>>2]|0;R=L;while(1){M=f[m+(R<<2)>>2]|0;if((M|0)<(R|0))R=M;else break}if((L|0)==(N|0))ab=R;else{M=N;while(1){H=f[m+(M<<2)>>2]|0;if((H|0)<(M|0))M=H;else break}H=(R|0)>(M|0)?M:R;X=N;do{P=m+(X<<2)|0;S=X;X=f[P>>2]|0;f[P>>2]=H}while((X|0)<(S|0));ab=H}H=L;do{X=m+(H<<2)|0;N=H;H=f[X>>2]|0;f[X>>2]=ab}while((H|0)<(N|0));f[x+(C<<2)>>2]=ab;I=D;break a}do if(B){if(!(b[w+Q>>0]|0))break;H=f[r+(J<<2)>>2]|0;if(b[w+C>>0]|0){L=f[x+(K<<2)>>2]|0;N=H;while(1){X=f[m+(N<<2)>>2]|0;if((X|0)<(N|0))N=X;else break}if((H|0)==(L|0))bb=N;else{X=L;while(1){R=f[m+(X<<2)>>2]|0;if((R|0)<(X|0))X=R;else break}R=(N|0)>(X|0)?X:N;M=L;do{S=m+(M<<2)|0;P=M;M=f[S>>2]|0;f[S>>2]=R}while((M|0)<(P|0));bb=R}R=H;do{M=m+(R<<2)|0;L=R;R=f[M>>2]|0;f[M>>2]=bb}while((R|0)<(L|0));f[x+(C<<2)>>2]=bb;I=D;break a}R=f[r+(K<<2)>>2]|0;L=R;while(1){M=f[m+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((R|0)==(H|0))cb=L;else{M=H;while(1){N=f[m+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}N=(L|0)>(M|0)?M:L;X=H;do{P=m+(X<<2)|0;S=X;X=f[P>>2]|0;f[P>>2]=N}while((X|0)<(S|0));cb=N}N=R;do{X=m+(N<<2)|0;H=N;N=f[X>>2]|0;f[X>>2]=cb}while((N|0)<(H|0));N=f[x+(K<<2)>>2]|0;R=cb;while(1){H=f[m+(R<<2)>>2]|0;if((H|0)<(R|0))R=H;else break}if((cb|0)==(N|0))db=R;else{H=N;while(1){X=f[m+(H<<2)>>2]|0;if((X|0)<(H|0))H=X;else break}X=(R|0)>(H|0)?H:R;L=N;do{M=m+(L<<2)|0;S=L;L=f[M>>2]|0;f[M>>2]=X}while((L|0)<(S|0));db=X}X=cb;do{L=m+(X<<2)|0;N=X;X=f[L>>2]|0;f[L>>2]=db}while((X|0)<(N|0));f[x+(C<<2)>>2]=db;I=D;break a}while(0);X=f[r+(K<<2)>>2]|0;N=f[r+(J<<2)>>2]|0;L=X;while(1){R=f[m+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((X|0)==(N|0))eb=L;else{R=N;while(1){H=f[m+(R<<2)>>2]|0;if((H|0)<(R|0))R=H;else break}H=(L|0)>(R|0)?R:L;S=N;do{M=m+(S<<2)|0;P=S;S=f[M>>2]|0;f[M>>2]=H}while((S|0)<(P|0));eb=H}H=X;do{S=m+(H<<2)|0;N=H;H=f[S>>2]|0;f[S>>2]=eb}while((H|0)<(N|0));H=f[x+(K<<2)>>2]|0;X=eb;while(1){N=f[m+(X<<2)>>2]|0;if((N|0)<(X|0))X=N;else break}if((eb|0)==(H|0))fb=X;else{K=H;while(1){N=f[m+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(X|0)>(K|0)?K:X;S=H;do{L=m+(S<<2)|0;R=S;S=f[L>>2]|0;f[L>>2]=N}while((S|0)<(R|0));fb=N}N=eb;do{S=m+(N<<2)|0;H=N;N=f[S>>2]|0;f[S>>2]=fb}while((N|0)<(H|0));f[x+(C<<2)>>2]=fb;I=D;break a}while(0);do if(z){J=C+-2|0;if(b[v+E>>0]|0){Q=f[x+(J<<2)>>2]|0;do if((J|0)>-1){if(!(b[s+J>>0]|0))break;f[x+(C<<2)>>2]=Q;I=D;break a}while(0);G=f[r+(J<<2)>>2]|0;N=G;while(1){H=f[m+(N<<2)>>2]|0;if((H|0)<(N|0))N=H;else break}if((G|0)==(Q|0))gb=N;else{H=Q;while(1){S=f[m+(H<<2)>>2]|0;if((S|0)<(H|0))H=S;else break}S=(N|0)>(H|0)?H:N;X=Q;do{K=m+(X<<2)|0;R=X;X=f[K>>2]|0;f[K>>2]=S}while((X|0)<(R|0));gb=S}S=G;do{X=m+(S<<2)|0;Q=S;S=f[X>>2]|0;f[X>>2]=gb}while((S|0)<(Q|0));f[x+(C<<2)>>2]=gb;I=D;break a}if(!(b[v+C>>0]|0)){hb=J;break}do if((J|0)>-1){if(!(b[s+J>>0]|0))break;if(!(b[v+J>>0]|0)){S=f[r+(C<<2)>>2]|0;G=f[x+(J<<2)>>2]|0;Q=S;while(1){X=f[m+(Q<<2)>>2]|0;if((X|0)<(Q|0))Q=X;else break}if((S|0)==(G|0))ib=Q;else{X=G;while(1){N=f[m+(X<<2)>>2]|0;if((N|0)<(X|0))X=N;else break}N=(Q|0)>(X|0)?X:Q;H=G;do{R=m+(H<<2)|0;K=H;H=f[R>>2]|0;f[R>>2]=N}while((H|0)<(K|0));ib=N}N=S;do{H=m+(N<<2)|0;G=N;N=f[H>>2]|0;f[H>>2]=ib}while((N|0)<(G|0));f[x+(C<<2)>>2]=ib;I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;f[x+(C<<2)>>2]=f[x+(J<<2)>>2];I=D;break a}while(0);N=f[r+(C<<2)>>2]|0;S=f[x+(J<<2)>>2]|0;G=N;while(1){H=f[m+(G<<2)>>2]|0;if((H|0)<(G|0))G=H;else break}if((N|0)==(S|0))jb=G;else{H=S;while(1){Q=f[m+(H<<2)>>2]|0;if((Q|0)<(H|0))H=Q;else break}Q=(G|0)>(H|0)?H:G;X=S;do{K=m+(X<<2)|0;R=X;X=f[K>>2]|0;f[K>>2]=Q}while((X|0)<(R|0));jb=Q}Q=N;do{X=m+(Q<<2)|0;S=Q;Q=f[X>>2]|0;f[X>>2]=jb}while((Q|0)<(S|0));f[x+(C<<2)>>2]=jb;I=D;break a}while(0);Q=f[r+(C<<2)>>2]|0;N=f[x+(J<<2)>>2]|0;S=Q;while(1){X=f[m+(S<<2)>>2]|0;if((X|0)<(S|0))S=X;else break}if((Q|0)==(N|0))kb=S;else{J=N;while(1){X=f[m+(J<<2)>>2]|0;if((X|0)<(J|0))J=X;else break}X=(S|0)>(J|0)?J:S;G=N;do{H=m+(G<<2)|0;R=G;G=f[H>>2]|0;f[H>>2]=X}while((G|0)<(R|0));kb=X}X=Q;do{G=m+(X<<2)|0;N=X;X=f[G>>2]|0;f[G>>2]=kb}while((X|0)<(N|0));f[x+(C<<2)>>2]=kb;I=D;break a}else hb=C+-2|0;while(0);f[x+(C<<2)>>2]=f[x+(hb<<2)>>2];I=D;break}do if(z){X=C+-2|0;if(b[v+E>>0]|0){Q=f[x+(X<<2)>>2]|0;do if((X|0)>-1){if(!(b[s+X>>0]|0))break;f[x+(C<<2)>>2]=Q;I=D;break a}while(0);N=f[r+(X<<2)>>2]|0;G=N;while(1){S=f[m+(G<<2)>>2]|0;if((S|0)<(G|0))G=S;else break}if((N|0)==(Q|0))lb=G;else{S=Q;while(1){J=f[m+(S<<2)>>2]|0;if((J|0)<(S|0))S=J;else break}J=(G|0)>(S|0)?S:G;R=Q;do{H=m+(R<<2)|0;K=R;R=f[H>>2]|0;f[H>>2]=J}while((R|0)<(K|0));lb=J}J=N;do{R=m+(J<<2)|0;Q=J;J=f[R>>2]|0;f[R>>2]=lb}while((J|0)<(Q|0));f[x+(C<<2)>>2]=lb;I=D;break a}if(!(b[v+C>>0]|0)){mb=X;break}do if((X|0)>-1){if(!(b[s+X>>0]|0))break;if(!(b[v+X>>0]|0)){J=f[r+(C<<2)>>2]|0;N=f[x+(X<<2)>>2]|0;Q=J;while(1){R=f[m+(Q<<2)>>2]|0;if((R|0)<(Q|0))Q=R;else break}if((J|0)==(N|0))nb=Q;else{R=N;while(1){G=f[m+(R<<2)>>2]|0;if((G|0)<(R|0))R=G;else break}G=(Q|0)>(R|0)?R:Q;S=N;do{K=m+(S<<2)|0;H=S;S=f[K>>2]|0;f[K>>2]=G}while((S|0)<(H|0));nb=G}G=J;do{S=m+(G<<2)|0;N=G;G=f[S>>2]|0;f[S>>2]=nb}while((G|0)<(N|0));f[x+(C<<2)>>2]=nb;I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;f[x+(C<<2)>>2]=f[x+(X<<2)>>2];I=D;break a}while(0);G=f[r+(C<<2)>>2]|0;J=f[x+(X<<2)>>2]|0;N=G;while(1){S=f[m+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}if((G|0)==(J|0))ob=N;else{S=J;while(1){Q=f[m+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}Q=(N|0)>(S|0)?S:N;R=J;do{H=m+(R<<2)|0;K=R;R=f[H>>2]|0;f[H>>2]=Q}while((R|0)<(K|0));ob=Q}Q=G;do{R=m+(Q<<2)|0;J=Q;Q=f[R>>2]|0;f[R>>2]=ob}while((Q|0)<(J|0));f[x+(C<<2)>>2]=ob;I=D;break a}while(0);Q=f[r+(C<<2)>>2]|0;G=f[x+(X<<2)>>2]|0;J=Q;while(1){R=f[m+(J<<2)>>2]|0;if((R|0)<(J|0))J=R;else break}if((Q|0)==(G|0))pb=J;else{X=G;while(1){R=f[m+(X<<2)>>2]|0;if((R|0)<(X|0))X=R;else break}R=(J|0)>(X|0)?X:J;N=G;do{S=m+(N<<2)|0;K=N;N=f[S>>2]|0;f[S>>2]=R}while((N|0)<(K|0));pb=R}R=Q;do{N=m+(R<<2)|0;G=R;R=f[N>>2]|0;f[N>>2]=pb}while((R|0)<(G|0));f[x+(C<<2)>>2]=pb;I=D;break a}else mb=C+-2|0;while(0);f[x+(C<<2)>>2]=f[x+(mb<<2)>>2];I=D;break}}R=C|1;Q=(R|0)<(h|0);if(!(A|Q^1)?b[v+R>>0]|0:0){if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break}if(F?b[v+E>>0]|0:0){G=f[r+(C<<2)>>2]|0;do if(B){if(!(b[w+C>>0]|0))break;f[x+(C<<2)>>2]=G;I=D;break a}while(0);N=f[r+(C+-2<<2)>>2]|0;J=N;while(1){X=f[m+(J<<2)>>2]|0;if((X|0)<(J|0))J=X;else break}if((N|0)==(G|0))qb=J;else{X=G;while(1){K=f[m+(X<<2)>>2]|0;if((K|0)<(X|0))X=K;else break}K=(J|0)>(X|0)?X:J;S=G;do{H=m+(S<<2)|0;L=S;S=f[H>>2]|0;f[H>>2]=K}while((S|0)<(L|0));qb=K}K=N;do{S=m+(K<<2)|0;G=K;K=f[S>>2]|0;f[S>>2]=qb}while((K|0)<(G|0));f[x+(C<<2)>>2]=qb;I=D;break}f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break}if(Q?b[s+R>>0]|0:0){K=C+2|0;if(!((K|0)>=(h|0)|A)?b[v+K>>0]|0:0){if(b[v+C>>0]|0){do if(B){if(!(b[w+R>>0]|0))break;f[x+(C<<2)>>2]=f[r+(K<<2)>>2];I=D;break a}while(0);Q=f[r+(C<<2)>>2]|0;N=f[r+(K<<2)>>2]|0;G=Q;while(1){S=f[m+(G<<2)>>2]|0;if((S|0)<(G|0))G=S;else break}if((Q|0)==(N|0))rb=G;else{S=N;while(1){J=f[m+(S<<2)>>2]|0;if((J|0)<(S|0))S=J;else break}J=(G|0)>(S|0)?S:G;X=N;do{L=m+(X<<2)|0;H=X;X=f[L>>2]|0;f[L>>2]=J}while((X|0)<(H|0));rb=J}J=Q;do{X=m+(J<<2)|0;N=J;J=f[X>>2]|0;f[X>>2]=rb}while((J|0)<(N|0));f[x+(C<<2)>>2]=rb;I=D;break}do if(F){if(!(b[v+E>>0]|0))break;do if(B){if(!(b[w+R>>0]|0))break;J=f[r+(K<<2)>>2]|0;if(b[w+C>>0]|0){f[x+(C<<2)>>2]=J;I=D;break a}Q=f[r+(C+-2<<2)>>2]|0;N=Q;while(1){X=f[m+(N<<2)>>2]|0;if((X|0)<(N|0))N=X;else break}if((Q|0)==(J|0))sb=N;else{X=J;while(1){G=f[m+(X<<2)>>2]|0;if((G|0)<(X|0))X=G;else break}G=(N|0)>(X|0)?X:N;S=J;do{H=m+(S<<2)|0;L=S;S=f[H>>2]|0;f[H>>2]=G}while((S|0)<(L|0));sb=G}G=Q;do{S=m+(G<<2)|0;J=G;G=f[S>>2]|0;f[S>>2]=sb}while((G|0)<(J|0));f[x+(C<<2)>>2]=sb;I=D;break a}while(0);G=f[r+(C+-2<<2)>>2]|0;Q=f[r+(K<<2)>>2]|0;J=G;while(1){S=f[m+(J<<2)>>2]|0;if((S|0)<(J|0))J=S;else break}if((G|0)==(Q|0))tb=J;else{S=Q;while(1){N=f[m+(S<<2)>>2]|0;if((N|0)<(S|0))S=N;else break}N=(J|0)>(S|0)?S:J;X=Q;do{L=m+(X<<2)|0;H=X;X=f[L>>2]|0;f[L>>2]=N}while((X|0)<(H|0));tb=N}N=G;do{X=m+(N<<2)|0;Q=N;N=f[X>>2]|0;f[X>>2]=tb}while((N|0)<(Q|0));f[x+(C<<2)>>2]=tb;I=D;break a}while(0);f[x+(C<<2)>>2]=f[r+(K<<2)>>2];I=D;break}if(z?b[v+C>>0]|0:0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break}do if(!(A|F^1)){if(!(b[v+E>>0]|0))break;f[x+(C<<2)>>2]=f[r+(C+-2<<2)>>2];I=D;break a}while(0);f[x+(C<<2)>>2]=D;f[m+(D<<2)>>2]=D;I=D+1|0;break}if(z?b[v+C>>0]|0:0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break}if(!(A|F^1)?b[v+E>>0]|0:0){f[x+(C<<2)>>2]=f[r+(C+-2<<2)>>2];I=D;break}f[x+(C<<2)>>2]=D;f[m+(D<<2)>>2]=D;I=D+1|0}while(0);C=C+2|0;if((C|0)>=(h|0)){ub=I;break}else D=I}}else ub=p;q=q+2|0;if((q|0)>=(a|0))break;else p=ub}if((ub|0)>1){p=1;a=1;while(1){q=m+(p<<2)|0;I=f[q>>2]|0;if((I|0)<(p|0)){f[q>>2]=f[m+(I<<2)>>2];vb=a}else{f[q>>2]=a;vb=a+1|0}p=p+1|0;if((p|0)==(ub|0)){wb=vb;break}else a=vb}}else wb=1}else wb=1;vb=f[i>>2]|0;a=f[n>>2]|0;ub=(a&1|0)!=0;p=(vb|0)>0;if(!(vb&1)){if(!ub){if(!p){ZF(m);u=g;return wb|0}q=f[c+16>>2]|0;I=f[c+44>>2]|0;h=f[d+16>>2]|0;tb=f[d+44>>2]|0;sb=a;rb=vb;qb=0;while(1){mb=f[I>>2]|0;pb=q+(Y(mb,qb)|0)|0;ob=pb+mb|0;mb=f[tb>>2]|0;nb=h+(Y(mb,qb)|0)|0;lb=nb+mb|0;if((sb|0)>0){mb=0;do{hb=nb+(mb<<2)|0;kb=f[hb>>2]|0;do if((kb|0)>0){jb=f[m+(kb<<2)>>2]|0;f[hb>>2]=(b[pb+mb>>0]|0)==0?0:jb;ib=mb|1;f[nb+(ib<<2)>>2]=(b[pb+ib>>0]|0)==0?0:jb;f[lb+(mb<<2)>>2]=(b[ob+mb>>0]|0)==0?0:jb;gb=lb+(ib<<2)|0;if(!(b[ob+ib>>0]|0)){f[gb>>2]=0;break}else{f[gb>>2]=jb;break}}else{f[hb>>2]=0;jb=mb|1;f[nb+(jb<<2)>>2]=0;f[lb+(mb<<2)>>2]=0;f[lb+(jb<<2)>>2]=0}while(0);mb=mb+2|0;xb=f[n>>2]|0}while((mb|0)<(xb|0));yb=f[i>>2]|0;zb=xb}else{yb=rb;zb=sb}qb=qb+2|0;if((qb|0)>=(yb|0))break;else{sb=zb;rb=yb}}ZF(m);u=g;return wb|0}if(!p){ZF(m);u=g;return wb|0}yb=f[c+16>>2]|0;rb=f[c+44>>2]|0;zb=f[d+16>>2]|0;sb=f[d+44>>2]|0;qb=a;xb=vb;h=0;while(1){tb=f[rb>>2]|0;q=yb+(Y(tb,h)|0)|0;I=q+tb|0;tb=f[sb>>2]|0;mb=zb+(Y(tb,h)|0)|0;lb=mb+tb|0;if((qb|0)>0){tb=0;do{nb=mb+(tb<<2)|0;ob=f[nb>>2]|0;do if((ob|0)>0){pb=f[m+(ob<<2)>>2]|0;f[nb>>2]=(b[q+tb>>0]|0)==0?0:pb;f[lb+(tb<<2)>>2]=(b[I+tb>>0]|0)==0?0:pb;hb=tb|1;if((hb|0)<(f[n>>2]|0)){f[mb+(hb<<2)>>2]=(b[q+hb>>0]|0)==0?0:pb;kb=lb+(hb<<2)|0;if(!(b[I+hb>>0]|0)){f[kb>>2]=0;break}else{f[kb>>2]=pb;break}}}else{f[nb>>2]=0;f[lb+(tb<<2)>>2]=0;pb=tb|1;if((pb|0)<(f[n>>2]|0)){f[mb+(pb<<2)>>2]=0;f[lb+(pb<<2)>>2]=0}}while(0);tb=tb+2|0;Ab=f[n>>2]|0}while((tb|0)<(Ab|0));Bb=f[i>>2]|0;Cb=Ab}else{Bb=xb;Cb=qb}h=h+2|0;if((h|0)>=(Bb|0))break;else{qb=Cb;xb=Bb}}ZF(m);u=g;return wb|0}if(!ub){if(!p){ZF(m);u=g;return wb|0}ub=f[c+16>>2]|0;Bb=f[c+44>>2]|0;xb=f[d+16>>2]|0;Cb=f[d+44>>2]|0;qb=a;h=vb;Ab=0;while(1){zb=f[Bb>>2]|0;sb=ub+(Y(zb,Ab)|0)|0;yb=sb+zb|0;zb=f[Cb>>2]|0;rb=xb+(Y(zb,Ab)|0)|0;tb=rb+zb|0;if((qb|0)>0){zb=Ab|1;lb=0;do{mb=rb+(lb<<2)|0;I=f[mb>>2]|0;do if((I|0)>0){q=f[m+(I<<2)>>2]|0;f[mb>>2]=(b[sb+lb>>0]|0)==0?0:q;nb=lb|1;f[rb+(nb<<2)>>2]=(b[sb+nb>>0]|0)==0?0:q;if((zb|0)<(f[i>>2]|0)){f[tb+(lb<<2)>>2]=(b[yb+lb>>0]|0)==0?0:q;ob=tb+(nb<<2)|0;if(!(b[yb+nb>>0]|0)){f[ob>>2]=0;break}else{f[ob>>2]=q;break}}}else{f[mb>>2]=0;q=lb|1;f[rb+(q<<2)>>2]=0;if((zb|0)<(f[i>>2]|0)){f[tb+(lb<<2)>>2]=0;f[tb+(q<<2)>>2]=0}}while(0);lb=lb+2|0;Db=f[n>>2]|0}while((lb|0)<(Db|0));Eb=f[i>>2]|0;Fb=Db}else{Eb=h;Fb=qb}Ab=Ab+2|0;if((Ab|0)>=(Eb|0))break;else{qb=Fb;h=Eb}}ZF(m);u=g;return wb|0}if(!p){ZF(m);u=g;return wb|0}p=f[c+16>>2]|0;Eb=f[c+44>>2]|0;c=f[d+16>>2]|0;h=f[d+44>>2]|0;d=a;a=vb;vb=0;while(1){Fb=f[Eb>>2]|0;qb=p+(Y(Fb,vb)|0)|0;Ab=qb+Fb|0;Fb=f[h>>2]|0;Db=c+(Y(Fb,vb)|0)|0;xb=Db+Fb|0;if((d|0)>0){Fb=vb|1;Cb=0;do{ub=Db+(Cb<<2)|0;Bb=f[ub>>2]|0;do if((Bb|0)>0){lb=f[m+(Bb<<2)>>2]|0;f[ub>>2]=(b[qb+Cb>>0]|0)==0?0:lb;tb=Cb|1;if((tb|0)<(f[n>>2]|0)){f[Db+(tb<<2)>>2]=(b[qb+tb>>0]|0)==0?0:lb;if((Fb|0)>=(f[i>>2]|0))break;f[xb+(Cb<<2)>>2]=(b[Ab+Cb>>0]|0)==0?0:lb;zb=xb+(tb<<2)|0;if(!(b[Ab+tb>>0]|0)){f[zb>>2]=0;break}else{f[zb>>2]=lb;break}}else{if((Fb|0)>=(f[i>>2]|0))break;zb=xb+(Cb<<2)|0;if(!(b[Ab+Cb>>0]|0)){f[zb>>2]=0;break}else{f[zb>>2]=lb;break}}}else{f[ub>>2]=0;lb=Cb|1;if((lb|0)<(f[n>>2]|0)){f[Db+(lb<<2)>>2]=0;if((Fb|0)>=(f[i>>2]|0))break;f[xb+(Cb<<2)>>2]=0;f[xb+(lb<<2)>>2]=0;break}else{if((Fb|0)>=(f[i>>2]|0))break;f[xb+(Cb<<2)>>2]=0;break}}while(0);Cb=Cb+2|0;Gb=f[n>>2]|0}while((Cb|0)<(Gb|0));Hb=f[i>>2]|0;Ib=Gb}else{Hb=a;Ib=d}vb=vb+2|0;if((vb|0)>=(Hb|0))break;else{d=Ib;a=Hb}}ZF(m);u=g;return wb|0}function p6(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;a=u;u=u+64|0;h=a+48|0;i=a+28|0;j=a;k=c+8|0;if((f[k>>2]|0)!=(f[d+8>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;l=c$(h,26)|0;m=218300;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-215,h,373355,218048,2529);d$(h)}o=c+12|0;if((f[o>>2]|0)!=(f[d+12>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;l=c$(h,26)|0;m=218327;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-215,h,373355,218048,2530);d$(h)}if((e|0)!=8){f[h>>2]=0;f[h+4>>2]=0;l=c$(h,17)|0;m=218354;n=l+17|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-215,h,373355,218048,2531);d$(h)}m=bV()|0;l=f[k>>2]|0;k=((f[o>>2]|0)+1|0)/2|0;o=YF(l<<2)|0;n=YF((Y(((l+1|0)/2|0)<<2,k)|0)+4|0)|0;f[n>>2]=0;f[h>>2]=0;f[h+4>>2]=l;f[i>>2]=48820;f[i+4>>2]=c;f[i+8>>2]=d;f[i+12>>2]=n;f[i+16>>2]=o;p=+(m|0);_U(h,i,p);q6(c,d,n,o);f[i>>2]=1;if((l|0)>0)q=0;else{r=(l|0)>-1;s=r?l:-1;t=OYa(s)|0;f[j>>2]=48840;v=j+4|0;f[v>>2]=c;w=j+8|0;f[w>>2]=d;x=j+12|0;f[x>>2]=n;y=j+16|0;f[y>>2]=g;z=j+20|0;f[z>>2]=t;A=j+24|0;f[A>>2]=i;_U(h,j,p);QYa(t);ZF(o);ZF(n);B=f[i>>2]|0;u=a;return B|0}do{m=q+1|0;e=(Y((m|0)/2|0,k)|0)+1|0;C=f[o+(m<<2)>>2]|0;m=C+e|0;if((C|0)>0){C=e;do{e=n+(C<<2)|0;D=f[e>>2]|0;if((D|0)<(C|0))f[e>>2]=f[n+(D<<2)>>2];else{f[e>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}C=C+1|0}while((C|0)<(m|0))}q=f[o+(q<<2)>>2]|0}while((q|0)<(l|0));r=(l|0)>-1;s=r?l:-1;t=OYa(s)|0;f[j>>2]=48840;v=j+4|0;f[v>>2]=c;w=j+8|0;f[w>>2]=d;x=j+12|0;f[x>>2]=n;y=j+16|0;f[y>>2]=g;z=j+20|0;f[z>>2]=t;A=j+24|0;f[A>>2]=i;_U(h,j,p);QYa(t);ZF(o);ZF(n);B=f[i>>2]|0;u=a;return B|0}function q6(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=f[c+12>>2]|0;h=f[c+8>>2]|0;i=f[e>>2]|0;if((i|0)>=(h|0))return;j=(g|0)>0;k=g+-1|0;l=g+-2|0;m=f[c+16>>2]|0;n=f[c+44>>2]|0;c=f[a+16>>2]|0;o=f[a+44>>2]|0;a=i;do{i=f[n>>2]|0;p=m+(Y(i,a)|0)|0;q=0-i|0;i=p+q+q|0;q=f[o>>2]|0;r=c+(Y(q,a)|0)|0;s=r+(0-q)|0;if(j){q=0;do{t=p+(q<<2)|0;u=f[t>>2]|0;if((u|0)>0){if((((q|0)>1?(v=f[i+(q+-2<<2)>>2]|0,(v|0)>0):0)?(b[r+q>>0]|0)!=0:0)?(b[s+(q+-1)>>0]|0)!=0:0){w=v;while(1){x=f[d+(w<<2)>>2]|0;if((x|0)<(w|0))w=x;else break}if((v|0)==(u|0))y=w;else{x=u;while(1){z=f[d+(x<<2)>>2]|0;if((z|0)<(x|0))x=z;else break}z=(w|0)>(x|0)?x:w;A=u;do{B=d+(A<<2)|0;C=A;A=f[B>>2]|0;f[B>>2]=z}while((A|0)<(C|0));y=z}z=v;do{A=d+(z<<2)|0;w=z;z=f[A>>2]|0;f[A>>2]=y}while((z|0)<(w|0));f[t>>2]=y;D=y}else D=u;z=f[i+(q<<2)>>2]|0;a:do if((z|0)>0){v=b[r+q>>0]|0;w=v<<24>>24!=0;if((q|0)>=(k|0)){if(!w){E=D;break}if(!(b[s+q>>0]|0)){E=D;break}else F=z;while(1){A=f[d+(F<<2)>>2]|0;if((A|0)<(F|0))F=A;else break}if((z|0)==(D|0))G=F;else{A=D;while(1){x=f[d+(A<<2)>>2]|0;if((x|0)<(A|0))A=x;else break}x=(F|0)>(A|0)?A:F;C=D;do{B=d+(C<<2)|0;H=C;C=f[B>>2]|0;f[B>>2]=x}while((C|0)<(H|0));G=x}x=z;do{C=d+(x<<2)|0;A=x;x=f[C>>2]|0;f[C>>2]=G}while((x|0)<(A|0));f[t>>2]=G;E=G;break}if(w?(b[s+q>>0]|0)!=0:0)I=z;else J=23;do if((J|0)==23){J=0;x=q|1;A=(b[r+x>>0]|0)!=0;if(A?b[s+q>>0]|0:0){I=z;break}if(v<<24>>24?b[s+x>>0]|0:0){I=z;break}if(!A){E=D;break a}if(!(b[s+x>>0]|0)){E=D;break a}else I=z}while(0);while(1){v=f[d+(I<<2)>>2]|0;if((v|0)<(I|0))I=v;else break}if((z|0)==(D|0))K=I;else{v=D;while(1){w=f[d+(v<<2)>>2]|0;if((w|0)<(v|0))v=w;else break}w=(I|0)>(v|0)?v:I;x=D;do{A=d+(x<<2)|0;C=x;x=f[A>>2]|0;f[A>>2]=w}while((x|0)<(C|0));K=w}w=z;do{x=d+(w<<2)|0;v=w;w=f[x>>2]|0;f[x>>2]=K}while((w|0)<(v|0));f[t>>2]=K;E=K}else E=D;while(0);if((((q|0)<(l|0)?(z=q+2|0,u=f[i+(z<<2)>>2]|0,(u|0)>0):0)?b[r+(q|1)>>0]|0:0)?b[s+z>>0]|0:0){z=u;while(1){w=f[d+(z<<2)>>2]|0;if((w|0)<(z|0))z=w;else break}if((u|0)==(E|0))L=z;else{w=E;while(1){v=f[d+(w<<2)>>2]|0;if((v|0)<(w|0))w=v;else break}v=(z|0)>(w|0)?w:z;x=E;do{C=d+(x<<2)|0;A=x;x=f[C>>2]|0;f[C>>2]=v}while((x|0)<(A|0));L=v}v=u;do{x=d+(v<<2)|0;z=v;v=f[x>>2]|0;f[x>>2]=L}while((v|0)<(z|0));f[t>>2]=L}}q=q+2|0}while((q|0)<(g|0))}a=f[e+(a<<2)>>2]|0}while((a|0)<(h|0));return}function r6(a){a=a|0;PYa(a);return}function s6(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=f[c>>2]|0;e=((d|0)%2|0)+d|0;d=f[c+4>>2]|0;c=((d|0)%2|0)+d|0;d=a+8|0;g=f[d>>2]|0;h=(f[g+8>>2]&1|0)==0;i=f[g+12>>2]|0;j=(i&1|0)!=0;k=(e|0)<(c|0);if((e|0)>0){if(h){if(!j){if(!k)return;l=a+4|0;m=a+12|0;n=i;o=e;p=g;while(1){q=f[l>>2]|0;r=f[f[q+44>>2]>>2]|0;s=(f[q+16>>2]|0)+(Y(r,o)|0)|0;q=s+r|0;r=f[f[p+44>>2]>>2]|0;t=(f[p+16>>2]|0)+(Y(r,o)|0)|0;u=t+r|0;if((n|0)>0){r=0;do{v=t+(r<<2)|0;w=f[v>>2]|0;do if((w|0)>0){x=f[(f[m>>2]|0)+(w<<2)>>2]|0;f[v>>2]=(b[s+r>>0]|0)==0?0:x;y=r|1;f[t+(y<<2)>>2]=(b[s+y>>0]|0)==0?0:x;f[u+(r<<2)>>2]=(b[q+r>>0]|0)==0?0:x;z=u+(y<<2)|0;if(!(b[q+y>>0]|0)){f[z>>2]=0;break}else{f[z>>2]=x;break}}else{f[v>>2]=0;x=r|1;f[t+(x<<2)>>2]=0;f[u+(r<<2)>>2]=0;f[u+(x<<2)>>2]=0}while(0);r=r+2|0;v=f[d>>2]|0;w=f[v+12>>2]|0}while((r|0)<(w|0));A=w;B=v}else{A=n;B=p}o=o+2|0;if((o|0)>=(c|0))break;else{n=A;p=B}}return}if(!k)return;B=a+4|0;p=a+12|0;A=i;n=e;o=g;while(1){m=f[B>>2]|0;l=f[f[m+44>>2]>>2]|0;r=(f[m+16>>2]|0)+(Y(l,n)|0)|0;m=r+l|0;l=f[f[o+44>>2]>>2]|0;u=(f[o+16>>2]|0)+(Y(l,n)|0)|0;t=u+l|0;if((A|0)>0){l=0;do{q=u+(l<<2)|0;s=f[q>>2]|0;do if((s|0)>0){v=f[(f[p>>2]|0)+(s<<2)>>2]|0;f[q>>2]=(b[r+l>>0]|0)==0?0:v;f[t+(l<<2)>>2]=(b[m+l>>0]|0)==0?0:v;w=l|1;if((w|0)<(f[(f[d>>2]|0)+12>>2]|0)){f[u+(w<<2)>>2]=(b[r+w>>0]|0)==0?0:v;x=t+(w<<2)|0;if(!(b[m+w>>0]|0)){f[x>>2]=0;break}else{f[x>>2]=v;break}}}else{f[q>>2]=0;f[t+(l<<2)>>2]=0;v=l|1;if((v|0)<(f[(f[d>>2]|0)+12>>2]|0)){f[u+(v<<2)>>2]=0;f[t+(v<<2)>>2]=0}}while(0);l=l+2|0;q=f[d>>2]|0;s=f[q+12>>2]|0}while((l|0)<(s|0));C=s;D=q}else{C=A;D=o}n=n+2|0;if((n|0)>=(c|0))break;else{A=C;o=D}}return}if(!j){if(!k)return;D=a+4|0;o=a+12|0;C=i;A=e;n=g;while(1){p=f[D>>2]|0;B=f[f[p+44>>2]>>2]|0;l=(f[p+16>>2]|0)+(Y(B,A)|0)|0;p=l+B|0;B=f[f[n+44>>2]>>2]|0;t=(f[n+16>>2]|0)+(Y(B,A)|0)|0;u=t+B|0;if((C|0)>0){B=A+1|0;m=0;do{r=t+(m<<2)|0;q=f[r>>2]|0;do if((q|0)>0){s=f[(f[o>>2]|0)+(q<<2)>>2]|0;f[r>>2]=(b[l+m>>0]|0)==0?0:s;v=m|1;f[t+(v<<2)>>2]=(b[l+v>>0]|0)==0?0:s;if((B|0)<(f[(f[d>>2]|0)+8>>2]|0)){f[u+(m<<2)>>2]=(b[p+m>>0]|0)==0?0:s;x=u+(v<<2)|0;if(!(b[p+v>>0]|0)){f[x>>2]=0;break}else{f[x>>2]=s;break}}}else{f[r>>2]=0;s=m|1;f[t+(s<<2)>>2]=0;if((B|0)<(f[(f[d>>2]|0)+8>>2]|0)){f[u+(m<<2)>>2]=0;f[u+(s<<2)>>2]=0}}while(0);m=m+2|0;r=f[d>>2]|0;q=f[r+12>>2]|0}while((m|0)<(q|0));E=q;F=r}else{E=C;F=n}A=A+2|0;if((A|0)>=(c|0))break;else{C=E;n=F}}return}if(!k)return;F=a+4|0;n=a+12|0;E=i;C=e;A=g;while(1){o=f[F>>2]|0;D=f[f[o+44>>2]>>2]|0;m=(f[o+16>>2]|0)+(Y(D,C)|0)|0;o=m+D|0;D=f[f[A+44>>2]>>2]|0;u=(f[A+16>>2]|0)+(Y(D,C)|0)|0;B=u+D|0;if((E|0)>0){D=C+1|0;t=0;do{p=u+(t<<2)|0;l=f[p>>2]|0;do if((l|0)>0){r=f[(f[n>>2]|0)+(l<<2)>>2]|0;f[p>>2]=(b[m+t>>0]|0)==0?0:r;q=t|1;s=f[d>>2]|0;if((q|0)<(f[s+12>>2]|0)){f[u+(q<<2)>>2]=(b[m+q>>0]|0)==0?0:r;if((D|0)>=(f[(f[d>>2]|0)+8>>2]|0))break;f[B+(t<<2)>>2]=(b[o+t>>0]|0)==0?0:r;x=B+(q<<2)|0;if(!(b[o+q>>0]|0)){f[x>>2]=0;break}else{f[x>>2]=r;break}}else{if((D|0)>=(f[s+8>>2]|0))break;s=B+(t<<2)|0;if(!(b[o+t>>0]|0)){f[s>>2]=0;break}else{f[s>>2]=r;break}}}else{f[p>>2]=0;r=t|1;s=f[d>>2]|0;if((r|0)<(f[s+12>>2]|0)){f[u+(r<<2)>>2]=0;if((D|0)>=(f[(f[d>>2]|0)+8>>2]|0))break;f[B+(t<<2)>>2]=0;f[B+(r<<2)>>2]=0;break}else{if((D|0)>=(f[s+8>>2]|0))break;f[B+(t<<2)>>2]=0;break}}while(0);t=t+2|0;p=f[d>>2]|0;l=f[p+12>>2]|0}while((t|0)<(l|0));G=l;H=p}else{G=E;H=A}C=C+2|0;if((C|0)>=(c|0))break;else{E=G;A=H}}return}else{if(h){if(!j){if(!k)return;h=a+4|0;H=a+12|0;A=i;G=e;E=g;while(1){C=f[h>>2]|0;n=f[f[C+44>>2]>>2]|0;F=(f[C+16>>2]|0)+(Y(n,G)|0)|0;C=F+n|0;n=f[f[E+44>>2]>>2]|0;t=(f[E+16>>2]|0)+(Y(n,G)|0)|0;B=t+n|0;if((A|0)>0){n=0;do{D=t+(n<<2)|0;u=f[D>>2]|0;do if((u|0)>0){o=f[(f[H>>2]|0)+(u<<2)>>2]|0;f[D>>2]=(b[F+n>>0]|0)==0?0:o;m=n|1;f[t+(m<<2)>>2]=(b[F+m>>0]|0)==0?0:o;f[B+(n<<2)>>2]=(b[C+n>>0]|0)==0?0:o;p=B+(m<<2)|0;if(!(b[C+m>>0]|0)){f[p>>2]=0;break}else{f[p>>2]=o;break}}else{f[D>>2]=0;o=n|1;f[t+(o<<2)>>2]=0;f[B+(n<<2)>>2]=0;f[B+(o<<2)>>2]=0}while(0);n=n+2|0;D=f[d>>2]|0;u=f[D+12>>2]|0}while((n|0)<(u|0));I=u;J=D}else{I=A;J=E}G=G+2|0;if((G|0)>=(c|0))break;else{A=I;E=J}}return}if(!k)return;J=a+4|0;E=a+12|0;I=i;A=e;G=g;while(1){H=f[J>>2]|0;h=f[f[H+44>>2]>>2]|0;n=(f[H+16>>2]|0)+(Y(h,A)|0)|0;H=n+h|0;h=f[f[G+44>>2]>>2]|0;B=(f[G+16>>2]|0)+(Y(h,A)|0)|0;t=B+h|0;if((I|0)>0){h=0;do{C=B+(h<<2)|0;F=f[C>>2]|0;do if((F|0)>0){D=f[(f[E>>2]|0)+(F<<2)>>2]|0;f[C>>2]=(b[n+h>>0]|0)==0?0:D;f[t+(h<<2)>>2]=(b[H+h>>0]|0)==0?0:D;u=h|1;if((u|0)<(f[(f[d>>2]|0)+12>>2]|0)){f[B+(u<<2)>>2]=(b[n+u>>0]|0)==0?0:D;o=t+(u<<2)|0;if(!(b[H+u>>0]|0)){f[o>>2]=0;break}else{f[o>>2]=D;break}}}else{f[C>>2]=0;f[t+(h<<2)>>2]=0;D=h|1;if((D|0)<(f[(f[d>>2]|0)+12>>2]|0)){f[B+(D<<2)>>2]=0;f[t+(D<<2)>>2]=0}}while(0);h=h+2|0;C=f[d>>2]|0;F=f[C+12>>2]|0}while((h|0)<(F|0));K=F;L=C}else{K=I;L=G}A=A+2|0;if((A|0)>=(c|0))break;else{I=K;G=L}}return}if(!j){if(!k)return;j=a+4|0;L=a+12|0;G=i;K=e;I=g;while(1){A=f[j>>2]|0;E=f[f[A+44>>2]>>2]|0;J=(f[A+16>>2]|0)+(Y(E,K)|0)|0;A=J+E|0;E=f[f[I+44>>2]>>2]|0;h=(f[I+16>>2]|0)+(Y(E,K)|0)|0;t=h+E|0;if((G|0)>0){E=K+1|0;B=0;do{H=h+(B<<2)|0;n=f[H>>2]|0;do if((n|0)>0){C=f[(f[L>>2]|0)+(n<<2)>>2]|0;f[H>>2]=(b[J+B>>0]|0)==0?0:C;F=B|1;f[h+(F<<2)>>2]=(b[J+F>>0]|0)==0?0:C;if((E|0)<(f[(f[d>>2]|0)+8>>2]|0)){f[t+(B<<2)>>2]=(b[A+B>>0]|0)==0?0:C;D=t+(F<<2)|0;if(!(b[A+F>>0]|0)){f[D>>2]=0;break}else{f[D>>2]=C;break}}}else{f[H>>2]=0;C=B|1;f[h+(C<<2)>>2]=0;if((E|0)<(f[(f[d>>2]|0)+8>>2]|0)){f[t+(B<<2)>>2]=0;f[t+(C<<2)>>2]=0}}while(0);B=B+2|0;H=f[d>>2]|0;n=f[H+12>>2]|0}while((B|0)<(n|0));M=n;N=H}else{M=G;N=I}K=K+2|0;if((K|0)>=(c|0))break;else{G=M;I=N}}return}if(!k)return;k=a+4|0;N=a+12|0;a=i;i=e;e=g;while(1){g=f[k>>2]|0;I=f[f[g+44>>2]>>2]|0;M=(f[g+16>>2]|0)+(Y(I,i)|0)|0;g=M+I|0;I=f[f[e+44>>2]>>2]|0;G=(f[e+16>>2]|0)+(Y(I,i)|0)|0;K=G+I|0;if((a|0)>0){I=i+1|0;L=0;do{j=G+(L<<2)|0;B=f[j>>2]|0;do if((B|0)>0){t=f[(f[N>>2]|0)+(B<<2)>>2]|0;f[j>>2]=(b[M+L>>0]|0)==0?0:t;E=L|1;h=f[d>>2]|0;if((E|0)<(f[h+12>>2]|0)){f[G+(E<<2)>>2]=(b[M+E>>0]|0)==0?0:t;if((I|0)>=(f[(f[d>>2]|0)+8>>2]|0))break;f[K+(L<<2)>>2]=(b[g+L>>0]|0)==0?0:t;A=K+(E<<2)|0;if(!(b[g+E>>0]|0)){f[A>>2]=0;break}else{f[A>>2]=t;break}}else{if((I|0)>=(f[h+8>>2]|0))break;h=K+(L<<2)|0;if(!(b[g+L>>0]|0)){f[h>>2]=0;break}else{f[h>>2]=t;break}}}else{f[j>>2]=0;t=L|1;h=f[d>>2]|0;if((t|0)<(f[h+12>>2]|0)){f[G+(t<<2)>>2]=0;if((I|0)>=(f[(f[d>>2]|0)+8>>2]|0))break;f[K+(L<<2)>>2]=0;f[K+(t<<2)>>2]=0;break}else{if((I|0)>=(f[h+8>>2]|0))break;f[K+(L<<2)>>2]=0;break}}while(0);L=L+2|0;j=f[d>>2]|0;B=f[j+12>>2]|0}while((L|0)<(B|0));O=B;P=j}else{O=a;P=e}i=i+2|0;if((i|0)>=(c|0))break;else{a=O;e=P}}return}}function t6(a){a=a|0;PYa(a);return}function u6(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0;d=f[c>>2]|0;e=((d|0)%2|0)+d|0;d=c+4|0;c=f[d>>2]|0;g=a+16|0;h=f[g>>2]|0;f[h+(e<<2)>>2]=((c|0)%2|0)+c;c=e+1|0;i=a+8|0;j=(Y(((f[(f[i>>2]|0)+12>>2]|0)+1|0)/2|0,(c|0)/2|0)|0)+1|0;k=a+4|0;l=f[k>>2]|0;m=f[l+8>>2]|0;n=f[l+12>>2]|0;if((e|0)>=(f[d>>2]|0)){o=h;p=j;q=p-j|0;r=o+(c<<2)|0;f[r>>2]=q;return}h=(n|0)>0;l=a+12|0;a=j;s=e;while(1){t=f[k>>2]|0;u=f[f[t+44>>2]>>2]|0;v=(f[t+16>>2]|0)+(Y(u,s)|0)|0;t=0-u|0;w=v+t|0;x=w+t|0;t=v+u|0;u=f[i>>2]|0;y=f[f[u+44>>2]>>2]|0;z=(f[u+16>>2]|0)+(Y(y,s)|0)|0;u=0-y|0;y=z+u+u|0;if(h){u=(s+1|0)<(m|0);A=(s|0)>(e|0);B=A^1;C=(s|0)>(c|0);D=0;E=a;while(1){a:do if(!(b[v+D>>0]|0)){F=D|1;G=(F|0)<(n|0);if(u?b[t+D>>0]|0:0){H=D+-1|0;I=(D|0)>0;if(G?b[v+F>>0]|0:0){if(I){if(b[v+H>>0]|0){do if(A){if(b[w+F>>0]|0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}do if(C){if(!(b[x+D>>0]|0))break;K=D+-2|0;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(K<<2)>>2];J=E;break a}do if((K|0)>-1){if(!(b[w+K>>0]|0))break;if(b[x+H>>0]|0){f[z+(D<<2)>>2]=f[z+(K<<2)>>2];J=E;break a}L=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;N=f[z+(K<<2)>>2]|0;O=M;while(1){P=f[L+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}if((M|0)==(N|0))Q=O;else{P=N;while(1){R=f[L+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}R=(O|0)>(P|0)?P:O;S=N;do{T=L+(S<<2)|0;U=S;S=f[T>>2]|0;f[T>>2]=R}while((S|0)<(U|0));Q=R}R=M;do{S=L+(R<<2)|0;N=R;R=f[S>>2]|0;f[S>>2]=Q}while((R|0)<(N|0));f[z+(D<<2)>>2]=Q;J=E;break a}while(0);R=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;M=f[z+(K<<2)>>2]|0;N=L;while(1){S=f[R+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}if((L|0)==(M|0))V=N;else{K=M;while(1){S=f[R+(K<<2)>>2]|0;if((S|0)<(K|0))K=S;else break}S=(N|0)>(K|0)?K:N;O=M;do{P=R+(O<<2)|0;U=O;O=f[P>>2]|0;f[P>>2]=S}while((O|0)<(U|0));V=S}S=L;do{O=R+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=V}while((S|0)<(M|0));f[z+(D<<2)>>2]=V;J=E;break a}while(0);S=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;L=f[z+(D+-2<<2)>>2]|0;M=R;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}if((R|0)==(L|0))W=M;else{O=L;while(1){N=f[S+(O<<2)>>2]|0;if((N|0)<(O|0))O=N;else break}N=(M|0)>(O|0)?O:M;K=L;do{U=S+(K<<2)|0;P=K;K=f[U>>2]|0;f[U>>2]=N}while((K|0)<(P|0));W=N}N=R;do{K=S+(N<<2)|0;L=N;N=f[K>>2]|0;f[K>>2]=W}while((N|0)<(L|0));f[z+(D<<2)>>2]=W;J=E;break a}N=D+2|0;if((N|0)>=(n|0))break;if(!(b[w+N>>0]|0))break;do if(C){if(!(b[x+F>>0]|0))break;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}if(!(b[x+D>>0]|0)){S=f[l>>2]|0;R=f[y+(N<<2)>>2]|0;L=f[z+(D+-2<<2)>>2]|0;K=R;while(1){M=f[S+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}if((R|0)==(L|0))X=K;else{M=L;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(K|0)>(M|0)?M:K;P=L;do{U=S+(P<<2)|0;T=P;P=f[U>>2]|0;f[U>>2]=O}while((P|0)<(T|0));X=O}O=R;do{P=S+(O<<2)|0;L=O;O=f[P>>2]|0;f[P>>2]=X}while((O|0)<(L|0));f[z+(D<<2)>>2]=X;J=E;break a}O=D+-2|0;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(O<<2)>>2];J=E;break a}do if((O|0)>-1){if(!(b[w+O>>0]|0))break;if(b[x+H>>0]|0){f[z+(D<<2)>>2]=f[z+(O<<2)>>2];J=E;break a}S=f[l>>2]|0;R=f[y+(N<<2)>>2]|0;L=f[z+(O<<2)>>2]|0;P=R;while(1){K=f[S+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}if((R|0)==(L|0))Z=P;else{K=L;while(1){M=f[S+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}M=(P|0)>(K|0)?K:P;T=L;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=M}while((T|0)<(_|0));Z=M}M=R;do{T=S+(M<<2)|0;L=M;M=f[T>>2]|0;f[T>>2]=Z}while((M|0)<(L|0));f[z+(D<<2)>>2]=Z;J=E;break a}while(0);M=f[l>>2]|0;S=f[y+(N<<2)>>2]|0;R=f[z+(O<<2)>>2]|0;L=S;while(1){T=f[M+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}if((S|0)==(R|0))$=L;else{O=R;while(1){T=f[M+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}T=(L|0)>(O|0)?O:L;P=R;do{K=M+(P<<2)|0;_=P;P=f[K>>2]|0;f[K>>2]=T}while((P|0)<(_|0));$=T}T=S;do{P=M+(T<<2)|0;R=T;T=f[P>>2]|0;f[P>>2]=$}while((T|0)<(R|0));f[z+(D<<2)>>2]=$;J=E;break a}while(0);T=f[l>>2]|0;M=f[y+(N<<2)>>2]|0;S=f[z+(D+-2<<2)>>2]|0;R=M;while(1){P=f[T+(R<<2)>>2]|0;if((P|0)<(R|0))R=P;else break}if((M|0)==(S|0))aa=R;else{N=S;while(1){P=f[T+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(R|0)>(N|0)?N:R;L=S;do{O=T+(L<<2)|0;_=L;L=f[O>>2]|0;f[O>>2]=P}while((L|0)<(_|0));aa=P}P=M;do{L=T+(P<<2)|0;S=P;P=f[L>>2]|0;f[L>>2]=aa}while((P|0)<(S|0));f[z+(D<<2)>>2]=aa;J=E;break a}while(0);f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(b[t+H>>0]|0){do if(A){if(b[w+F>>0]|0){P=D+-2|0;do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[w+H>>0]|0){T=f[z+(P<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}do if(C){if(!(b[x+D>>0]|0))break;f[z+(D<<2)>>2]=T;J=E;break a}while(0);M=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;L=S;while(1){R=f[M+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((S|0)==(T|0))ba=L;else{R=T;while(1){N=f[M+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}N=(L|0)>(R|0)?R:L;_=T;do{O=M+(_<<2)|0;K=_;_=f[O>>2]|0;f[O>>2]=N}while((_|0)<(K|0));ba=N}N=S;do{_=M+(N<<2)|0;T=N;N=f[_>>2]|0;f[_>>2]=ba}while((N|0)<(T|0));f[z+(D<<2)>>2]=ba;J=E;break a}if(!(b[w+P>>0]|0)){N=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=f[z+(P<<2)>>2]|0;T=M;while(1){_=f[N+(T<<2)>>2]|0;if((_|0)<(T|0))T=_;else break}if((M|0)==(S|0))ca=T;else{_=S;while(1){L=f[N+(_<<2)>>2]|0;if((L|0)<(_|0))_=L;else break}L=(T|0)>(_|0)?_:T;R=S;do{K=N+(R<<2)|0;O=R;R=f[K>>2]|0;f[K>>2]=L}while((R|0)<(O|0));ca=L}L=M;do{R=N+(L<<2)|0;S=L;L=f[R>>2]|0;f[R>>2]=ca}while((L|0)<(S|0));f[z+(D<<2)>>2]=ca;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;L=f[z+(P<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}N=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=M;while(1){R=f[N+(S<<2)>>2]|0;if((R|0)<(S|0))S=R;else break}if((M|0)==(L|0))da=S;else{R=L;while(1){T=f[N+(R<<2)>>2]|0;if((T|0)<(R|0))R=T;else break}T=(S|0)>(R|0)?R:S;_=L;do{O=N+(_<<2)|0;K=_;_=f[O>>2]|0;f[O>>2]=T}while((_|0)<(K|0));da=T}T=M;do{_=N+(T<<2)|0;L=T;T=f[_>>2]|0;f[_>>2]=da}while((T|0)<(L|0));f[z+(D<<2)>>2]=da;J=E;break a}while(0);T=f[l>>2]|0;N=f[y+(D<<2)>>2]|0;M=f[z+(P<<2)>>2]|0;L=N;while(1){_=f[T+(L<<2)>>2]|0;if((_|0)<(L|0))L=_;else break}if((N|0)==(M|0))ea=L;else{_=M;while(1){S=f[T+(_<<2)>>2]|0;if((S|0)<(_|0))_=S;else break}S=(L|0)>(_|0)?_:L;R=M;do{K=T+(R<<2)|0;O=R;R=f[K>>2]|0;f[K>>2]=S}while((R|0)<(O|0));ea=S}S=N;do{R=T+(S<<2)|0;M=S;S=f[R>>2]|0;f[R>>2]=ea}while((S|0)<(M|0));f[z+(D<<2)>>2]=ea;J=E;break a}while(0);S=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;N=f[z+(P<<2)>>2]|0;M=T;while(1){R=f[S+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}if((T|0)==(N|0))fa=M;else{P=N;while(1){R=f[S+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}R=(M|0)>(P|0)?P:M;L=N;do{_=S+(L<<2)|0;O=L;L=f[_>>2]|0;f[_>>2]=R}while((L|0)<(O|0));fa=R}R=T;do{L=S+(R<<2)|0;N=R;R=f[L>>2]|0;f[L>>2]=fa}while((R|0)<(N|0));f[z+(D<<2)>>2]=fa;J=E;break a}R=D+2|0;do if(!((R|0)>=(n|0)|B)){if(!(b[w+R>>0]|0))break;do if(C){if(!(b[x+F>>0]|0))break;S=D+-2|0;do if((S|0)>-1){if(!(b[v+S>>0]|0))break;if(b[w+H>>0]|0){T=f[z+(S<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}N=f[l>>2]|0;L=f[y+(R<<2)>>2]|0;M=L;while(1){P=f[N+(M<<2)>>2]|0;if((P|0)<(M|0))M=P;else break}if((L|0)==(T|0))ga=M;else{P=T;while(1){O=f[N+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}O=(M|0)>(P|0)?P:M;_=T;do{K=N+(_<<2)|0;U=_;_=f[K>>2]|0;f[K>>2]=O}while((_|0)<(U|0));ga=O}O=L;do{_=N+(O<<2)|0;T=O;O=f[_>>2]|0;f[_>>2]=ga}while((O|0)<(T|0));f[z+(D<<2)>>2]=ga;J=E;break a}if(!(b[w+S>>0]|0)){O=f[l>>2]|0;N=f[y+(R<<2)>>2]|0;L=f[z+(S<<2)>>2]|0;T=N;while(1){_=f[O+(T<<2)>>2]|0;if((_|0)<(T|0))T=_;else break}if((N|0)==(L|0))ha=T;else{_=L;while(1){M=f[O+(_<<2)>>2]|0;if((M|0)<(_|0))_=M;else break}M=(T|0)>(_|0)?_:T;P=L;do{U=O+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=M}while((P|0)<(K|0));ha=M}M=N;do{P=O+(M<<2)|0;L=M;M=f[P>>2]|0;f[P>>2]=ha}while((M|0)<(L|0));f[z+(D<<2)>>2]=ha;J=E;break a}if(!(b[x+H>>0]|0)){M=f[l>>2]|0;O=f[y+(R<<2)>>2]|0;N=f[z+(S<<2)>>2]|0;L=O;while(1){P=f[M+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}if((O|0)==(N|0))ia=L;else{P=N;while(1){T=f[M+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}T=(L|0)>(P|0)?P:L;_=N;do{K=M+(_<<2)|0;U=_;_=f[K>>2]|0;f[K>>2]=T}while((_|0)<(U|0));ia=T}T=O;do{_=M+(T<<2)|0;N=T;T=f[_>>2]|0;f[_>>2]=ia}while((T|0)<(N|0));f[z+(D<<2)>>2]=ia;J=E;break a}T=f[z+(S<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}M=f[l>>2]|0;O=f[y+(R<<2)>>2]|0;N=O;while(1){_=f[M+(N<<2)>>2]|0;if((_|0)<(N|0))N=_;else break}if((O|0)==(T|0))ja=N;else{_=T;while(1){L=f[M+(_<<2)>>2]|0;if((L|0)<(_|0))_=L;else break}L=(N|0)>(_|0)?_:N;P=T;do{U=M+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=L}while((P|0)<(K|0));ja=L}L=O;do{P=M+(L<<2)|0;T=L;L=f[P>>2]|0;f[P>>2]=ja}while((L|0)<(T|0));f[z+(D<<2)>>2]=ja;J=E;break a}while(0);L=f[l>>2]|0;M=f[y+(R<<2)>>2]|0;O=f[z+(S<<2)>>2]|0;T=M;while(1){P=f[L+(T<<2)>>2]|0;if((P|0)<(T|0))T=P;else break}if((M|0)==(O|0))ka=T;else{S=O;while(1){P=f[L+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}P=(T|0)>(S|0)?S:T;N=O;do{_=L+(N<<2)|0;K=N;N=f[_>>2]|0;f[_>>2]=P}while((N|0)<(K|0));ka=P}P=M;do{N=L+(P<<2)|0;O=P;P=f[N>>2]|0;f[N>>2]=ka}while((P|0)<(O|0));f[z+(D<<2)>>2]=ka;J=E;break a}while(0);P=D+-2|0;if(!(b[w+D>>0]|0)){L=f[l>>2]|0;M=f[y+(R<<2)>>2]|0;O=f[z+(P<<2)>>2]|0;N=M;while(1){T=f[L+(N<<2)>>2]|0;if((T|0)<(N|0))N=T;else break}if((M|0)==(O|0))la=N;else{T=O;while(1){S=f[L+(T<<2)>>2]|0;if((S|0)<(T|0))T=S;else break}S=(N|0)>(T|0)?T:N;K=O;do{_=L+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=S}while((K|0)<(U|0));la=S}S=M;do{K=L+(S<<2)|0;O=S;S=f[K>>2]|0;f[K>>2]=la}while((S|0)<(O|0));f[z+(D<<2)>>2]=la;J=E;break a}do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[w+H>>0]|0){S=f[l>>2]|0;L=f[y+(R<<2)>>2]|0;M=f[z+(P<<2)>>2]|0;O=L;while(1){K=f[S+(O<<2)>>2]|0;if((K|0)<(O|0))O=K;else break}if((L|0)==(M|0))ma=O;else{K=M;while(1){N=f[S+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(O|0)>(K|0)?K:O;T=M;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=N}while((T|0)<(_|0));ma=N}N=L;do{T=S+(N<<2)|0;M=N;N=f[T>>2]|0;f[T>>2]=ma}while((N|0)<(M|0));f[z+(D<<2)>>2]=ma;J=E;break a}if(!(b[w+P>>0]|0)){N=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;L=f[y+(R<<2)>>2]|0;M=S;while(1){T=f[N+(M<<2)>>2]|0;if((T|0)<(M|0))M=T;else break}if((S|0)==(L|0))na=M;else{T=L;while(1){O=f[N+(T<<2)>>2]|0;if((O|0)<(T|0))T=O;else break}O=(M|0)>(T|0)?T:M;K=L;do{_=N+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=O}while((K|0)<(U|0));na=O}O=S;do{K=N+(O<<2)|0;L=O;O=f[K>>2]|0;f[K>>2]=na}while((O|0)<(L|0));O=f[z+(P<<2)>>2]|0;S=na;while(1){L=f[N+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((na|0)==(O|0))oa=S;else{L=O;while(1){K=f[N+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(S|0)>(L|0)?L:S;M=O;do{T=N+(M<<2)|0;U=M;M=f[T>>2]|0;f[T>>2]=K}while((M|0)<(U|0));oa=K}K=na;do{M=N+(K<<2)|0;O=K;K=f[M>>2]|0;f[M>>2]=oa}while((K|0)<(O|0));f[z+(D<<2)>>2]=oa;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;K=f[l>>2]|0;N=f[y+(R<<2)>>2]|0;O=f[z+(P<<2)>>2]|0;M=N;while(1){S=f[K+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}if((N|0)==(O|0))pa=M;else{S=O;while(1){L=f[K+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}L=(M|0)>(S|0)?S:M;U=O;do{T=K+(U<<2)|0;_=U;U=f[T>>2]|0;f[T>>2]=L}while((U|0)<(_|0));pa=L}L=N;do{U=K+(L<<2)|0;O=L;L=f[U>>2]|0;f[U>>2]=pa}while((L|0)<(O|0));f[z+(D<<2)>>2]=pa;J=E;break a}while(0);L=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;N=f[y+(R<<2)>>2]|0;O=K;while(1){U=f[L+(O<<2)>>2]|0;if((U|0)<(O|0))O=U;else break}if((K|0)==(N|0))qa=O;else{U=N;while(1){M=f[L+(U<<2)>>2]|0;if((M|0)<(U|0))U=M;else break}M=(O|0)>(U|0)?U:O;S=N;do{_=L+(S<<2)|0;T=S;S=f[_>>2]|0;f[_>>2]=M}while((S|0)<(T|0));qa=M}M=K;do{S=L+(M<<2)|0;N=M;M=f[S>>2]|0;f[S>>2]=qa}while((M|0)<(N|0));M=f[z+(P<<2)>>2]|0;K=qa;while(1){N=f[L+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}if((qa|0)==(M|0))ra=K;else{N=M;while(1){S=f[L+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}S=(K|0)>(N|0)?N:K;O=M;do{U=L+(O<<2)|0;T=O;O=f[U>>2]|0;f[U>>2]=S}while((O|0)<(T|0));ra=S}S=qa;do{O=L+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=ra}while((S|0)<(M|0));f[z+(D<<2)>>2]=ra;J=E;break a}while(0);S=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;M=f[y+(R<<2)>>2]|0;O=L;while(1){K=f[S+(O<<2)>>2]|0;if((K|0)<(O|0))O=K;else break}if((L|0)==(M|0))sa=O;else{K=M;while(1){N=f[S+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(O|0)>(K|0)?K:O;T=M;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=N}while((T|0)<(_|0));sa=N}N=L;do{T=S+(N<<2)|0;M=N;N=f[T>>2]|0;f[T>>2]=sa}while((N|0)<(M|0));N=f[z+(P<<2)>>2]|0;L=sa;while(1){M=f[S+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((sa|0)==(N|0))ta=L;else{P=N;while(1){M=f[S+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}M=(L|0)>(P|0)?P:L;T=N;do{O=S+(T<<2)|0;K=T;T=f[O>>2]|0;f[O>>2]=M}while((T|0)<(K|0));ta=M}M=sa;do{T=S+(M<<2)|0;N=M;M=f[T>>2]|0;f[T>>2]=ta}while((M|0)<(N|0));f[z+(D<<2)>>2]=ta;J=E;break a}while(0);R=D+-2|0;if(!(b[w+D>>0]|0)){ua=R;break}do if((R|0)>-1){if(!(b[v+R>>0]|0))break;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}if(!(b[w+R>>0]|0)){M=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;N=f[z+(R<<2)>>2]|0;T=S;while(1){L=f[M+(T<<2)>>2]|0;if((L|0)<(T|0))T=L;else break}if((S|0)==(N|0))va=T;else{L=N;while(1){P=f[M+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(T|0)>(L|0)?L:T;K=N;do{O=M+(K<<2)|0;_=K;K=f[O>>2]|0;f[O>>2]=P}while((K|0)<(_|0));va=P}P=S;do{K=M+(P<<2)|0;N=P;P=f[K>>2]|0;f[K>>2]=va}while((P|0)<(N|0));f[z+(D<<2)>>2]=va;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}while(0);P=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=f[z+(R<<2)>>2]|0;N=M;while(1){K=f[P+(N<<2)>>2]|0;if((K|0)<(N|0))N=K;else break}if((M|0)==(S|0))wa=N;else{K=S;while(1){T=f[P+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}T=(N|0)>(K|0)?K:N;L=S;do{_=P+(L<<2)|0;O=L;L=f[_>>2]|0;f[_>>2]=T}while((L|0)<(O|0));wa=T}T=M;do{L=P+(T<<2)|0;S=T;T=f[L>>2]|0;f[L>>2]=wa}while((T|0)<(S|0));f[z+(D<<2)>>2]=wa;J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[z+(R<<2)>>2]|0;S=P;while(1){L=f[T+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((P|0)==(M|0))xa=S;else{R=M;while(1){L=f[T+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}L=(S|0)>(R|0)?R:S;N=M;do{K=T+(N<<2)|0;O=N;N=f[K>>2]|0;f[K>>2]=L}while((N|0)<(O|0));xa=L}L=P;do{N=T+(L<<2)|0;M=L;L=f[N>>2]|0;f[N>>2]=xa}while((L|0)<(M|0));f[z+(D<<2)>>2]=xa;J=E;break a}else ua=D+-2|0;while(0);f[z+(D<<2)>>2]=f[z+(ua<<2)>>2];J=E;break}}if(A){if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}L=D+2|0;if(!((L|0)>=(n|0)|B)?b[w+L>>0]|0:0){if(!(b[w+D>>0]|0)){f[z+(D<<2)>>2]=f[y+(L<<2)>>2];J=E;break}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[y+(L<<2)>>2];J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[y+(L<<2)>>2]|0;N=P;while(1){S=f[T+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}if((P|0)==(M|0))ya=N;else{L=M;while(1){S=f[T+(L<<2)>>2]|0;if((S|0)<(L|0))L=S;else break}S=(N|0)>(L|0)?L:N;R=M;do{O=T+(R<<2)|0;K=R;R=f[O>>2]|0;f[O>>2]=S}while((R|0)<(K|0));ya=S}S=P;do{R=T+(S<<2)|0;M=S;S=f[R>>2]|0;f[R>>2]=ya}while((S|0)<(M|0));f[z+(D<<2)>>2]=ya;J=E;break}if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}if(I){if(b[t+H>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(b[v+H>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}do if(G){if(!(b[v+F>>0]|0)){if(!u)break;if(!(b[t+F>>0]|0))break;f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break a}if(A){if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break a}S=D+2|0;if(!((S|0)>=(n|0)|B)?b[w+S>>0]|0:0){if(!(b[w+D>>0]|0)){f[z+(D<<2)>>2]=f[y+(S<<2)>>2];J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[y+(S<<2)>>2];J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[y+(S<<2)>>2]|0;R=P;while(1){N=f[T+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}if((P|0)==(M|0))za=R;else{S=M;while(1){N=f[T+(S<<2)>>2]|0;if((N|0)<(S|0))S=N;else break}N=(R|0)>(S|0)?S:R;L=M;do{K=T+(L<<2)|0;O=L;L=f[K>>2]|0;f[K>>2]=N}while((L|0)<(O|0));za=N}N=P;do{L=T+(N<<2)|0;M=N;N=f[L>>2]|0;f[L>>2]=za}while((N|0)<(M|0));f[z+(D<<2)>>2]=za;J=E;break a}if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break a}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break a}while(0);f[z+(D<<2)>>2]=0;J=E}else{F=D+-1|0;G=(D|0)>0;if(G){if(b[v+F>>0]|0){H=D|1;I=(H|0)<(n|0);if(A&I?b[w+H>>0]|0:0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(C?b[x+D>>0]|0:0){N=D+-2|0;if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[z+(N<<2)>>2];J=E;break}do if((N|0)>-1){if(!(b[w+N>>0]|0))break;if(b[x+F>>0]|0){f[z+(D<<2)>>2]=f[z+(N<<2)>>2];J=E;break a}T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[z+(N<<2)>>2]|0;L=P;while(1){R=f[T+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((P|0)==(M|0))Aa=L;else{R=M;while(1){S=f[T+(R<<2)>>2]|0;if((S|0)<(R|0))R=S;else break}S=(L|0)>(R|0)?R:L;O=M;do{K=T+(O<<2)|0;_=O;O=f[K>>2]|0;f[K>>2]=S}while((O|0)<(_|0));Aa=S}S=P;do{O=T+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=Aa}while((S|0)<(M|0));f[z+(D<<2)>>2]=Aa;J=E;break a}while(0);S=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;P=f[z+(N<<2)>>2]|0;M=T;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}if((T|0)==(P|0))Ba=M;else{N=P;while(1){O=f[S+(N<<2)>>2]|0;if((O|0)<(N|0))N=O;else break}O=(M|0)>(N|0)?N:M;L=P;do{R=S+(L<<2)|0;_=L;L=f[R>>2]|0;f[R>>2]=O}while((L|0)<(_|0));Ba=O}O=T;do{L=S+(O<<2)|0;P=O;O=f[L>>2]|0;f[L>>2]=Ba}while((O|0)<(P|0));f[z+(D<<2)>>2]=Ba;J=E;break}O=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;T=f[z+(D+-2<<2)>>2]|0;P=S;while(1){L=f[O+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((S|0)==(T|0))Ca=P;else{L=T;while(1){M=f[O+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(P|0)>(L|0)?L:P;N=T;do{_=O+(N<<2)|0;R=N;N=f[_>>2]|0;f[_>>2]=M}while((N|0)<(R|0));Ca=M}M=S;do{N=O+(M<<2)|0;T=M;M=f[N>>2]|0;f[N>>2]=Ca}while((M|0)<(T|0));f[z+(D<<2)>>2]=Ca;J=E;break}if(I?b[v+H>>0]|0:0){M=D+2|0;if(A&(M|0)<(n|0)?b[w+M>>0]|0:0){do if(C){if(!(b[x+H>>0]|0))break;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}if(!(b[x+D>>0]|0)){O=f[l>>2]|0;S=f[y+(M<<2)>>2]|0;T=f[z+(D+-2<<2)>>2]|0;N=S;while(1){P=f[O+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((S|0)==(T|0))Da=N;else{P=T;while(1){L=f[O+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}L=(N|0)>(P|0)?P:N;R=T;do{_=O+(R<<2)|0;K=R;R=f[_>>2]|0;f[_>>2]=L}while((R|0)<(K|0));Da=L}L=S;do{R=O+(L<<2)|0;T=L;L=f[R>>2]|0;f[R>>2]=Da}while((L|0)<(T|0));f[z+(D<<2)>>2]=Da;J=E;break a}L=D+-2|0;if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[z+(L<<2)>>2];J=E;break a}do if((L|0)>-1){if(!(b[w+L>>0]|0))break;if(b[x+F>>0]|0){f[z+(D<<2)>>2]=f[z+(L<<2)>>2];J=E;break a}O=f[l>>2]|0;S=f[y+(M<<2)>>2]|0;T=f[z+(L<<2)>>2]|0;R=S;while(1){N=f[O+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}if((S|0)==(T|0))Ea=R;else{N=T;while(1){P=f[O+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(R|0)>(N|0)?N:R;K=T;do{_=O+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=P}while((K|0)<(U|0));Ea=P}P=S;do{K=O+(P<<2)|0;T=P;P=f[K>>2]|0;f[K>>2]=Ea}while((P|0)<(T|0));f[z+(D<<2)>>2]=Ea;J=E;break a}while(0);P=f[l>>2]|0;O=f[y+(M<<2)>>2]|0;S=f[z+(L<<2)>>2]|0;T=O;while(1){K=f[P+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}if((O|0)==(S|0))Fa=T;else{L=S;while(1){K=f[P+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(T|0)>(L|0)?L:T;R=S;do{N=P+(R<<2)|0;U=R;R=f[N>>2]|0;f[N>>2]=K}while((R|0)<(U|0));Fa=K}K=O;do{R=P+(K<<2)|0;S=K;K=f[R>>2]|0;f[R>>2]=Fa}while((K|0)<(S|0));f[z+(D<<2)>>2]=Fa;J=E;break a}while(0);H=f[l>>2]|0;I=f[y+(M<<2)>>2]|0;K=f[z+(D+-2<<2)>>2]|0;P=I;while(1){O=f[H+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}if((I|0)==(K|0))Ga=P;else{M=K;while(1){O=f[H+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(P|0)>(M|0)?M:P;S=K;do{R=H+(S<<2)|0;T=S;S=f[R>>2]|0;f[R>>2]=O}while((S|0)<(T|0));Ga=O}O=I;do{S=H+(O<<2)|0;K=O;O=f[S>>2]|0;f[S>>2]=Ga}while((O|0)<(K|0));f[z+(D<<2)>>2]=Ga;J=E;break}f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(u?b[t+F>>0]|0:0){O=D|1;H=(O|0)<(n|0);if(!(B|H^1)?b[w+O>>0]|0:0){I=D+-2|0;if((I|0)>-1?b[v+I>>0]|0:0){if(b[w+F>>0]|0){K=f[z+(I<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break}do if(C){if(!(b[x+D>>0]|0))break;f[z+(D<<2)>>2]=K;J=E;break a}while(0);S=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=P;while(1){T=f[S+(M<<2)>>2]|0;if((T|0)<(M|0))M=T;else break}if((P|0)==(K|0))Ha=M;else{T=K;while(1){R=f[S+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(M|0)>(T|0)?T:M;L=K;do{U=S+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=R}while((L|0)<(N|0));Ha=R}R=P;do{L=S+(R<<2)|0;K=R;R=f[L>>2]|0;f[L>>2]=Ha}while((R|0)<(K|0));f[z+(D<<2)>>2]=Ha;J=E;break}if(!(b[w+I>>0]|0)){R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;P=f[z+(I<<2)>>2]|0;K=S;while(1){L=f[R+(K<<2)>>2]|0;if((L|0)<(K|0))K=L;else break}if((S|0)==(P|0))Ia=K;else{L=P;while(1){M=f[R+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(K|0)>(L|0)?L:K;T=P;do{N=R+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=M}while((T|0)<(U|0));Ia=M}M=S;do{T=R+(M<<2)|0;P=M;M=f[T>>2]|0;f[T>>2]=Ia}while((M|0)<(P|0));f[z+(D<<2)>>2]=Ia;J=E;break}do if(C){if(!(b[x+F>>0]|0))break;M=f[z+(I<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=M;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=M;J=E;break a}R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;P=S;while(1){T=f[R+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}if((S|0)==(M|0))Ja=P;else{T=M;while(1){K=f[R+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(P|0)>(T|0)?T:P;L=M;do{U=R+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=K}while((L|0)<(N|0));Ja=K}K=S;do{L=R+(K<<2)|0;M=K;K=f[L>>2]|0;f[L>>2]=Ja}while((K|0)<(M|0));f[z+(D<<2)>>2]=Ja;J=E;break a}while(0);K=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;S=f[z+(I<<2)>>2]|0;M=R;while(1){L=f[K+(M<<2)>>2]|0;if((L|0)<(M|0))M=L;else break}if((R|0)==(S|0))Ka=M;else{L=S;while(1){P=f[K+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(M|0)>(L|0)?L:M;T=S;do{N=K+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=P}while((T|0)<(U|0));Ka=P}P=R;do{T=K+(P<<2)|0;S=P;P=f[T>>2]|0;f[T>>2]=Ka}while((P|0)<(S|0));f[z+(D<<2)>>2]=Ka;J=E;break}if(b[w+D>>0]|0){P=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;R=f[z+(I<<2)>>2]|0;S=K;while(1){T=f[P+(S<<2)>>2]|0;if((T|0)<(S|0))S=T;else break}if((K|0)==(R|0))La=S;else{T=R;while(1){M=f[P+(T<<2)>>2]|0;if((M|0)<(T|0))T=M;else break}M=(S|0)>(T|0)?T:S;L=R;do{U=P+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=M}while((L|0)<(N|0));La=M}M=K;do{L=P+(M<<2)|0;R=M;M=f[L>>2]|0;f[L>>2]=La}while((M|0)<(R|0));f[z+(D<<2)>>2]=La;J=E;break}if(!(b[w+F>>0]|0)){M=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;K=f[z+(I<<2)>>2]|0;R=P;while(1){L=f[M+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}if((P|0)==(K|0))Ma=R;else{L=K;while(1){S=f[M+(L<<2)>>2]|0;if((S|0)<(L|0))L=S;else break}S=(R|0)>(L|0)?L:R;T=K;do{N=M+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=S}while((T|0)<(U|0));Ma=S}S=P;do{T=M+(S<<2)|0;K=S;S=f[T>>2]|0;f[T>>2]=Ma}while((S|0)<(K|0));f[z+(D<<2)>>2]=Ma;J=E;break}S=f[y+(D<<2)>>2]|0;M=f[l>>2]|0;do if(C){if(!(b[x+D>>0]|0))break;P=f[z+(I<<2)>>2]|0;K=S;while(1){T=f[M+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}if((S|0)==(P|0))Na=K;else{T=P;while(1){R=f[M+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(K|0)>(T|0)?T:K;L=P;do{U=M+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=R}while((L|0)<(N|0));Na=R}R=S;do{L=M+(R<<2)|0;P=R;R=f[L>>2]|0;f[L>>2]=Na}while((R|0)<(P|0));f[z+(D<<2)>>2]=Na;J=E;break a}while(0);R=f[y+(I<<2)>>2]|0;P=R;while(1){L=f[M+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((R|0)==(S|0))Oa=P;else{L=S;while(1){K=f[M+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(P|0)>(L|0)?L:P;T=S;do{N=M+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=K}while((T|0)<(U|0));Oa=K}K=R;do{T=M+(K<<2)|0;S=K;K=f[T>>2]|0;f[T>>2]=Oa}while((K|0)<(S|0));K=f[z+(I<<2)>>2]|0;R=Oa;while(1){S=f[M+(R<<2)>>2]|0;if((S|0)<(R|0))R=S;else break}if((Oa|0)==(K|0))Pa=R;else{I=K;while(1){S=f[M+(I<<2)>>2]|0;if((S|0)<(I|0))I=S;else break}S=(R|0)>(I|0)?I:R;T=K;do{P=M+(T<<2)|0;L=T;T=f[P>>2]|0;f[P>>2]=S}while((T|0)<(L|0));Pa=S}S=Oa;do{T=M+(S<<2)|0;K=S;S=f[T>>2]|0;f[T>>2]=Pa}while((S|0)<(K|0));f[z+(D<<2)>>2]=Pa;J=E;break}if(H?b[v+O>>0]|0:0){S=D+2|0;if(!((S|0)>=(n|0)|B)?b[w+S>>0]|0:0){M=D+-2|0;do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[w+F>>0]|0){do if(C){if(!(b[x+O>>0]|0))break;K=f[z+(M<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break a}T=f[l>>2]|0;R=f[y+(S<<2)>>2]|0;I=R;while(1){L=f[T+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((R|0)==(K|0))Qa=I;else{L=K;while(1){P=f[T+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(I|0)>(L|0)?L:I;U=K;do{N=T+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=P}while((U|0)<(_|0));Qa=P}P=R;do{U=T+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=Qa}while((P|0)<(K|0));f[z+(D<<2)>>2]=Qa;J=E;break a}while(0);P=f[l>>2]|0;T=f[y+(S<<2)>>2]|0;R=f[z+(M<<2)>>2]|0;K=T;while(1){U=f[P+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}if((T|0)==(R|0))Ra=K;else{U=R;while(1){I=f[P+(U<<2)>>2]|0;if((I|0)<(U|0))U=I;else break}I=(K|0)>(U|0)?U:K;L=R;do{_=P+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=I}while((L|0)<(N|0));Ra=I}I=T;do{L=P+(I<<2)|0;R=I;I=f[L>>2]|0;f[L>>2]=Ra}while((I|0)<(R|0));f[z+(D<<2)>>2]=Ra;J=E;break a}do if(C){if(!(b[x+O>>0]|0))break;if(!(b[w+M>>0]|0)){I=f[l>>2]|0;P=f[y+(S<<2)>>2]|0;T=f[z+(M<<2)>>2]|0;R=P;while(1){L=f[I+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}if((P|0)==(T|0))Sa=R;else{L=T;while(1){K=f[I+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(R|0)>(L|0)?L:R;U=T;do{N=I+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=K}while((U|0)<(_|0));Sa=K}K=P;do{U=I+(K<<2)|0;T=K;K=f[U>>2]|0;f[U>>2]=Sa}while((K|0)<(T|0));f[z+(D<<2)>>2]=Sa;J=E;break a}if(!(b[x+F>>0]|0)){K=f[l>>2]|0;I=f[y+(S<<2)>>2]|0;P=f[z+(M<<2)>>2]|0;T=I;while(1){U=f[K+(T<<2)>>2]|0;if((U|0)<(T|0))T=U;else break}if((I|0)==(P|0))Ta=T;else{U=P;while(1){R=f[K+(U<<2)>>2]|0;if((R|0)<(U|0))U=R;else break}R=(T|0)>(U|0)?U:T;L=P;do{_=K+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=R}while((L|0)<(N|0));Ta=R}R=I;do{L=K+(R<<2)|0;P=R;R=f[L>>2]|0;f[L>>2]=Ta}while((R|0)<(P|0));f[z+(D<<2)>>2]=Ta;J=E;break a}R=f[z+(M<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=R;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=R;J=E;break a}K=f[l>>2]|0;I=f[y+(S<<2)>>2]|0;P=I;while(1){L=f[K+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((I|0)==(R|0))Ua=P;else{L=R;while(1){T=f[K+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}T=(P|0)>(L|0)?L:P;U=R;do{N=K+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=T}while((U|0)<(_|0));Ua=T}T=I;do{U=K+(T<<2)|0;R=T;T=f[U>>2]|0;f[U>>2]=Ua}while((T|0)<(R|0));f[z+(D<<2)>>2]=Ua;J=E;break a}while(0);if(!(b[w+D>>0]|0)){T=f[l>>2]|0;K=f[y+(S<<2)>>2]|0;I=f[z+(M<<2)>>2]|0;R=K;while(1){U=f[T+(R<<2)>>2]|0;if((U|0)<(R|0))R=U;else break}if((K|0)==(I|0))Va=R;else{U=I;while(1){P=f[T+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}P=(R|0)>(U|0)?U:R;L=I;do{_=T+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=P}while((L|0)<(N|0));Va=P}P=K;do{L=T+(P<<2)|0;I=P;P=f[L>>2]|0;f[L>>2]=Va}while((P|0)<(I|0));f[z+(D<<2)>>2]=Va;J=E;break a}if(!(b[w+M>>0]|0)){P=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;K=f[y+(S<<2)>>2]|0;I=T;while(1){L=f[P+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((T|0)==(K|0))Wa=I;else{L=K;while(1){R=f[P+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}R=(I|0)>(L|0)?L:I;U=K;do{N=P+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=R}while((U|0)<(_|0));Wa=R}R=T;do{U=P+(R<<2)|0;K=R;R=f[U>>2]|0;f[U>>2]=Wa}while((R|0)<(K|0));R=f[z+(M<<2)>>2]|0;T=Wa;while(1){K=f[P+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}if((Wa|0)==(R|0))Xa=T;else{K=R;while(1){U=f[P+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}U=(T|0)>(K|0)?K:T;I=R;do{L=P+(I<<2)|0;_=I;I=f[L>>2]|0;f[L>>2]=U}while((I|0)<(_|0));Xa=U}U=Wa;do{I=P+(U<<2)|0;R=U;U=f[I>>2]|0;f[I>>2]=Xa}while((U|0)<(R|0));f[z+(D<<2)>>2]=Xa;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;U=f[l>>2]|0;P=f[y+(S<<2)>>2]|0;R=f[z+(M<<2)>>2]|0;I=P;while(1){T=f[U+(I<<2)>>2]|0;if((T|0)<(I|0))I=T;else break}if((P|0)==(R|0))Ya=I;else{T=R;while(1){K=f[U+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(I|0)>(T|0)?T:I;_=R;do{L=U+(_<<2)|0;N=_;_=f[L>>2]|0;f[L>>2]=K}while((_|0)<(N|0));Ya=K}K=P;do{_=U+(K<<2)|0;R=K;K=f[_>>2]|0;f[_>>2]=Ya}while((K|0)<(R|0));f[z+(D<<2)>>2]=Ya;J=E;break a}while(0);K=f[l>>2]|0;U=f[y+(D<<2)>>2]|0;P=f[y+(S<<2)>>2]|0;R=U;while(1){_=f[K+(R<<2)>>2]|0;if((_|0)<(R|0))R=_;else break}if((U|0)==(P|0))Za=R;else{_=P;while(1){I=f[K+(_<<2)>>2]|0;if((I|0)<(_|0))_=I;else break}I=(R|0)>(_|0)?_:R;T=P;do{N=K+(T<<2)|0;L=T;T=f[N>>2]|0;f[N>>2]=I}while((T|0)<(L|0));Za=I}I=U;do{T=K+(I<<2)|0;P=I;I=f[T>>2]|0;f[T>>2]=Za}while((I|0)<(P|0));I=f[z+(M<<2)>>2]|0;U=Za;while(1){P=f[K+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}if((Za|0)==(I|0))_a=U;else{P=I;while(1){T=f[K+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}T=(U|0)>(P|0)?P:U;R=I;do{_=K+(R<<2)|0;L=R;R=f[_>>2]|0;f[_>>2]=T}while((R|0)<(L|0));_a=T}T=Za;do{R=K+(T<<2)|0;I=T;T=f[R>>2]|0;f[R>>2]=_a}while((T|0)<(I|0));f[z+(D<<2)>>2]=_a;J=E;break a}while(0);if(b[w+D>>0]|0){do if(C){if(!(b[x+O>>0]|0))break;H=f[l>>2]|0;T=f[y+(S<<2)>>2]|0;K=f[z+(M<<2)>>2]|0;I=T;while(1){R=f[H+(I<<2)>>2]|0;if((R|0)<(I|0))I=R;else break}if((T|0)==(K|0))$a=I;else{R=K;while(1){U=f[H+(R<<2)>>2]|0;if((U|0)<(R|0))R=U;else break}U=(I|0)>(R|0)?R:I;P=K;do{L=H+(P<<2)|0;_=P;P=f[L>>2]|0;f[L>>2]=U}while((P|0)<(_|0));$a=U}U=T;do{P=H+(U<<2)|0;K=U;U=f[P>>2]|0;f[P>>2]=$a}while((U|0)<(K|0));f[z+(D<<2)>>2]=$a;J=E;break a}while(0);U=f[l>>2]|0;H=f[y+(D<<2)>>2]|0;T=f[y+(S<<2)>>2]|0;K=H;while(1){P=f[U+(K<<2)>>2]|0;if((P|0)<(K|0))K=P;else break}if((H|0)==(T|0))ab=K;else{P=T;while(1){I=f[U+(P<<2)>>2]|0;if((I|0)<(P|0))P=I;else break}I=(K|0)>(P|0)?P:K;R=T;do{_=U+(R<<2)|0;L=R;R=f[_>>2]|0;f[_>>2]=I}while((R|0)<(L|0));ab=I}I=H;do{R=U+(I<<2)|0;T=I;I=f[R>>2]|0;f[R>>2]=ab}while((I|0)<(T|0));I=f[z+(M<<2)>>2]|0;H=ab;while(1){T=f[U+(H<<2)>>2]|0;if((T|0)<(H|0))H=T;else break}if((ab|0)==(I|0))bb=H;else{T=I;while(1){R=f[U+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(H|0)>(T|0)?T:H;K=I;do{P=U+(K<<2)|0;L=K;K=f[P>>2]|0;f[P>>2]=R}while((K|0)<(L|0));bb=R}R=ab;do{K=U+(R<<2)|0;I=R;R=f[K>>2]|0;f[K>>2]=bb}while((R|0)<(I|0));f[z+(D<<2)>>2]=bb;J=E;break}if(!(b[w+F>>0]|0)){R=f[l>>2]|0;U=f[y+(S<<2)>>2]|0;I=f[z+(M<<2)>>2]|0;K=U;while(1){H=f[R+(K<<2)>>2]|0;if((H|0)<(K|0))K=H;else break}if((U|0)==(I|0))cb=K;else{H=I;while(1){T=f[R+(H<<2)>>2]|0;if((T|0)<(H|0))H=T;else break}T=(K|0)>(H|0)?H:K;L=I;do{P=R+(L<<2)|0;_=L;L=f[P>>2]|0;f[P>>2]=T}while((L|0)<(_|0));cb=T}T=U;do{L=R+(T<<2)|0;I=T;T=f[L>>2]|0;f[L>>2]=cb}while((T|0)<(I|0));f[z+(D<<2)>>2]=cb;J=E;break}do if(C){if(!(b[x+O>>0]|0))break;T=f[y+(S<<2)>>2]|0;R=f[l>>2]|0;if(b[x+D>>0]|0){U=f[z+(M<<2)>>2]|0;I=T;while(1){L=f[R+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((T|0)==(U|0))db=I;else{L=U;while(1){K=f[R+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(I|0)>(L|0)?L:I;H=U;do{_=R+(H<<2)|0;P=H;H=f[_>>2]|0;f[_>>2]=K}while((H|0)<(P|0));db=K}K=T;do{H=R+(K<<2)|0;U=K;K=f[H>>2]|0;f[H>>2]=db}while((K|0)<(U|0));f[z+(D<<2)>>2]=db;J=E;break a}K=f[y+(M<<2)>>2]|0;U=K;while(1){H=f[R+(U<<2)>>2]|0;if((H|0)<(U|0))U=H;else break}if((K|0)==(T|0))eb=U;else{H=T;while(1){I=f[R+(H<<2)>>2]|0;if((I|0)<(H|0))H=I;else break}I=(U|0)>(H|0)?H:U;L=T;do{P=R+(L<<2)|0;_=L;L=f[P>>2]|0;f[P>>2]=I}while((L|0)<(_|0));eb=I}I=K;do{L=R+(I<<2)|0;T=I;I=f[L>>2]|0;f[L>>2]=eb}while((I|0)<(T|0));I=f[z+(M<<2)>>2]|0;K=eb;while(1){T=f[R+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}if((eb|0)==(I|0))fb=K;else{T=I;while(1){L=f[R+(T<<2)>>2]|0;if((L|0)<(T|0))T=L;else break}L=(K|0)>(T|0)?T:K;U=I;do{H=R+(U<<2)|0;_=U;U=f[H>>2]|0;f[H>>2]=L}while((U|0)<(_|0));fb=L}L=eb;do{U=R+(L<<2)|0;I=L;L=f[U>>2]|0;f[U>>2]=fb}while((L|0)<(I|0));f[z+(D<<2)>>2]=fb;J=E;break a}while(0);O=f[l>>2]|0;L=f[y+(M<<2)>>2]|0;R=f[y+(S<<2)>>2]|0;I=L;while(1){U=f[O+(I<<2)>>2]|0;if((U|0)<(I|0))I=U;else break}if((L|0)==(R|0))gb=I;else{S=R;while(1){U=f[O+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}U=(I|0)>(S|0)?S:I;K=R;do{T=O+(K<<2)|0;_=K;K=f[T>>2]|0;f[T>>2]=U}while((K|0)<(_|0));gb=U}U=L;do{K=O+(U<<2)|0;R=U;U=f[K>>2]|0;f[K>>2]=gb}while((U|0)<(R|0));U=f[z+(M<<2)>>2]|0;L=gb;while(1){R=f[O+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((gb|0)==(U|0))hb=L;else{M=U;while(1){R=f[O+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}R=(L|0)>(M|0)?M:L;K=U;do{I=O+(K<<2)|0;S=K;K=f[I>>2]|0;f[I>>2]=R}while((K|0)<(S|0));hb=R}R=gb;do{K=O+(R<<2)|0;U=R;R=f[K>>2]|0;f[K>>2]=hb}while((R|0)<(U|0));f[z+(D<<2)>>2]=hb;J=E;break}do if(A){R=D+-2|0;if(b[w+F>>0]|0){O=f[z+(R<<2)>>2]|0;do if((R|0)>-1){if(!(b[v+R>>0]|0))break;f[z+(D<<2)>>2]=O;J=E;break a}while(0);U=f[l>>2]|0;K=f[y+(R<<2)>>2]|0;L=K;while(1){M=f[U+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((K|0)==(O|0))ib=L;else{M=O;while(1){S=f[U+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}S=(L|0)>(M|0)?M:L;I=O;do{_=U+(I<<2)|0;T=I;I=f[_>>2]|0;f[_>>2]=S}while((I|0)<(T|0));ib=S}S=K;do{I=U+(S<<2)|0;O=S;S=f[I>>2]|0;f[I>>2]=ib}while((S|0)<(O|0));f[z+(D<<2)>>2]=ib;J=E;break a}if(!(b[w+D>>0]|0)){jb=R;break}do if((R|0)>-1){if(!(b[v+R>>0]|0))break;if(!(b[w+R>>0]|0)){S=f[l>>2]|0;U=f[y+(D<<2)>>2]|0;K=f[z+(R<<2)>>2]|0;O=U;while(1){I=f[S+(O<<2)>>2]|0;if((I|0)<(O|0))O=I;else break}if((U|0)==(K|0))kb=O;else{I=K;while(1){L=f[S+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}L=(O|0)>(I|0)?I:O;M=K;do{T=S+(M<<2)|0;_=M;M=f[T>>2]|0;f[T>>2]=L}while((M|0)<(_|0));kb=L}L=U;do{M=S+(L<<2)|0;K=L;L=f[M>>2]|0;f[M>>2]=kb}while((L|0)<(K|0));f[z+(D<<2)>>2]=kb;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}while(0);L=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;U=f[z+(R<<2)>>2]|0;K=S;while(1){M=f[L+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}if((S|0)==(U|0))lb=K;else{M=U;while(1){O=f[L+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(K|0)>(M|0)?M:K;I=U;do{_=L+(I<<2)|0;T=I;I=f[_>>2]|0;f[_>>2]=O}while((I|0)<(T|0));lb=O}O=S;do{I=L+(O<<2)|0;U=O;O=f[I>>2]|0;f[I>>2]=lb}while((O|0)<(U|0));f[z+(D<<2)>>2]=lb;J=E;break a}while(0);O=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;S=f[z+(R<<2)>>2]|0;U=L;while(1){I=f[O+(U<<2)>>2]|0;if((I|0)<(U|0))U=I;else break}if((L|0)==(S|0))mb=U;else{R=S;while(1){I=f[O+(R<<2)>>2]|0;if((I|0)<(R|0))R=I;else break}I=(U|0)>(R|0)?R:U;K=S;do{M=O+(K<<2)|0;T=K;K=f[M>>2]|0;f[M>>2]=I}while((K|0)<(T|0));mb=I}I=L;do{K=O+(I<<2)|0;S=I;I=f[K>>2]|0;f[K>>2]=mb}while((I|0)<(S|0));f[z+(D<<2)>>2]=mb;J=E;break a}else jb=D+-2|0;while(0);f[z+(D<<2)>>2]=f[z+(jb<<2)>>2];J=E;break}if(A){I=D+-2|0;if(b[w+F>>0]|0){O=f[z+(I<<2)>>2]|0;do if((I|0)>-1){if(!(b[v+I>>0]|0))break;f[z+(D<<2)>>2]=O;J=E;break a}while(0);L=f[l>>2]|0;S=f[y+(I<<2)>>2]|0;K=S;while(1){U=f[L+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}if((S|0)==(O|0))nb=K;else{U=O;while(1){R=f[L+(U<<2)>>2]|0;if((R|0)<(U|0))U=R;else break}R=(K|0)>(U|0)?U:K;T=O;do{M=L+(T<<2)|0;_=T;T=f[M>>2]|0;f[M>>2]=R}while((T|0)<(_|0));nb=R}R=S;do{T=L+(R<<2)|0;O=R;R=f[T>>2]|0;f[T>>2]=nb}while((R|0)<(O|0));f[z+(D<<2)>>2]=nb;J=E;break}if(!(b[w+D>>0]|0))ob=I;else{do if((I|0)>-1){if(!(b[v+I>>0]|0))break;if(!(b[w+I>>0]|0)){R=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;S=f[z+(I<<2)>>2]|0;O=L;while(1){T=f[R+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}if((L|0)==(S|0))pb=O;else{T=S;while(1){K=f[R+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(O|0)>(T|0)?T:O;U=S;do{_=R+(U<<2)|0;M=U;U=f[_>>2]|0;f[_>>2]=K}while((U|0)<(M|0));pb=K}K=L;do{U=R+(K<<2)|0;S=K;K=f[U>>2]|0;f[U>>2]=pb}while((K|0)<(S|0));f[z+(D<<2)>>2]=pb;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[z+(I<<2)>>2];J=E;break a}while(0);K=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;L=f[z+(I<<2)>>2]|0;S=R;while(1){U=f[K+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}if((R|0)==(L|0))qb=S;else{U=L;while(1){O=f[K+(U<<2)>>2]|0;if((O|0)<(U|0))U=O;else break}O=(S|0)>(U|0)?U:S;T=L;do{M=K+(T<<2)|0;_=T;T=f[M>>2]|0;f[M>>2]=O}while((T|0)<(_|0));qb=O}O=R;do{T=K+(O<<2)|0;L=O;O=f[T>>2]|0;f[T>>2]=qb}while((O|0)<(L|0));f[z+(D<<2)>>2]=qb;J=E;break a}while(0);O=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;R=f[z+(I<<2)>>2]|0;L=K;while(1){T=f[O+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}if((K|0)==(R|0))rb=L;else{I=R;while(1){T=f[O+(I<<2)>>2]|0;if((T|0)<(I|0))I=T;else break}T=(L|0)>(I|0)?I:L;S=R;do{U=O+(S<<2)|0;_=S;S=f[U>>2]|0;f[U>>2]=T}while((S|0)<(_|0));rb=T}T=K;do{S=O+(T<<2)|0;R=T;T=f[S>>2]|0;f[S>>2]=rb}while((T|0)<(R|0));f[z+(D<<2)>>2]=rb;J=E;break}}else ob=D+-2|0;f[z+(D<<2)>>2]=f[z+(ob<<2)>>2];J=E;break}}T=D|1;O=(T|0)<(n|0);if(!(B|O^1)?b[w+T>>0]|0:0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(G?b[w+F>>0]|0:0){K=f[y+(D<<2)>>2]|0;if(C?b[x+D>>0]|0:0){f[z+(D<<2)>>2]=K;J=E;break}R=f[l>>2]|0;S=f[y+(D+-2<<2)>>2]|0;L=S;while(1){I=f[R+(L<<2)>>2]|0;if((I|0)<(L|0))L=I;else break}if((S|0)==(K|0))sb=L;else{I=K;while(1){_=f[R+(I<<2)>>2]|0;if((_|0)<(I|0))I=_;else break}_=(L|0)>(I|0)?I:L;U=K;do{M=R+(U<<2)|0;H=U;U=f[M>>2]|0;f[M>>2]=_}while((U|0)<(H|0));sb=_}_=S;do{U=R+(_<<2)|0;K=_;_=f[U>>2]|0;f[U>>2]=sb}while((_|0)<(K|0));f[z+(D<<2)>>2]=sb;J=E;break}f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(O?b[v+T>>0]|0:0){_=D+2|0;if(!((_|0)>=(n|0)|B)?b[w+_>>0]|0:0){if(b[w+D>>0]|0){if(C?b[x+T>>0]|0:0){f[z+(D<<2)>>2]=f[y+(_<<2)>>2];J=E;break}R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;K=f[y+(_<<2)>>2]|0;U=S;while(1){L=f[R+(U<<2)>>2]|0;if((L|0)<(U|0))U=L;else break}if((S|0)==(K|0))tb=U;else{O=K;while(1){L=f[R+(O<<2)>>2]|0;if((L|0)<(O|0))O=L;else break}L=(U|0)>(O|0)?O:U;I=K;do{H=R+(I<<2)|0;M=I;I=f[H>>2]|0;f[H>>2]=L}while((I|0)<(M|0));tb=L}L=S;do{I=R+(L<<2)|0;K=L;L=f[I>>2]|0;f[I>>2]=tb}while((L|0)<(K|0));f[z+(D<<2)>>2]=tb;J=E;break}if(G?b[w+F>>0]|0:0){do if(C){if(!(b[x+T>>0]|0))break;L=f[y+(_<<2)>>2]|0;if(b[x+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}R=f[l>>2]|0;S=f[y+(D+-2<<2)>>2]|0;K=S;while(1){I=f[R+(K<<2)>>2]|0;if((I|0)<(K|0))K=I;else break}if((S|0)==(L|0))ub=K;else{I=L;while(1){U=f[R+(I<<2)>>2]|0;if((U|0)<(I|0))I=U;else break}U=(K|0)>(I|0)?I:K;O=L;do{M=R+(O<<2)|0;H=O;O=f[M>>2]|0;f[M>>2]=U}while((O|0)<(H|0));ub=U}U=S;do{O=R+(U<<2)|0;L=U;U=f[O>>2]|0;f[O>>2]=ub}while((U|0)<(L|0));f[z+(D<<2)>>2]=ub;J=E;break a}while(0);T=f[l>>2]|0;U=f[y+(D+-2<<2)>>2]|0;R=f[y+(_<<2)>>2]|0;S=U;while(1){L=f[T+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((U|0)==(R|0))vb=S;else{L=R;while(1){O=f[T+(L<<2)>>2]|0;if((O|0)<(L|0))L=O;else break}O=(S|0)>(L|0)?L:S;K=R;do{I=T+(K<<2)|0;H=K;K=f[I>>2]|0;f[I>>2]=O}while((K|0)<(H|0));vb=O}O=U;do{K=T+(O<<2)|0;R=O;O=f[K>>2]|0;f[K>>2]=vb}while((O|0)<(R|0));f[z+(D<<2)>>2]=vb;J=E;break}f[z+(D<<2)>>2]=f[y+(_<<2)>>2];J=E;break}if(A?b[w+D>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(!(B|G^1)?b[w+F>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}if(A?b[w+D>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(!(B|G^1)?b[w+F>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0}while(0);D=D+2|0;if((D|0)>=(n|0)){wb=J;break}else E=J}}else wb=a;s=s+2|0;if((s|0)>=(f[d>>2]|0))break;else a=wb}o=f[g>>2]|0;p=wb;q=p-j|0;r=o+(c<<2)|0;f[r>>2]=q;return}function v6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=f[a+12>>2]|0;e=f[a+8>>2]|0;g=f[c>>2]|0;if((g|0)>=(e|0))return;h=f[a+16>>2]|0;i=f[a+44>>2]|0;a=(d|0)>0;j=d+-1|0;k=g;do{g=f[i>>2]|0;l=h+(Y(g,k)|0)|0;m=l+(0-g)|0;if(a){g=0;do{n=l+(g<<2)|0;o=f[n>>2]|0;if((o|0)>0){if((g|0)>0?(p=f[m+(g+-1<<2)>>2]|0,(p|0)>0):0){q=p;while(1){r=f[b+(q<<2)>>2]|0;if((r|0)<(q|0))q=r;else break}if((p|0)==(o|0))s=q;else{r=o;while(1){t=f[b+(r<<2)>>2]|0;if((t|0)<(r|0))r=t;else break}t=(q|0)>(r|0)?r:q;u=o;do{v=b+(u<<2)|0;w=u;u=f[v>>2]|0;f[v>>2]=t}while((u|0)<(w|0));s=t}t=p;do{u=b+(t<<2)|0;q=t;t=f[u>>2]|0;f[u>>2]=s}while((t|0)<(q|0));f[n>>2]=s;x=s}else x=o;if((g|0)<(j|0)?(t=f[m+(g+1<<2)>>2]|0,(t|0)>0):0){p=t;while(1){q=f[b+(p<<2)>>2]|0;if((q|0)<(p|0))p=q;else break}if((t|0)==(x|0))y=p;else{o=x;while(1){q=f[b+(o<<2)>>2]|0;if((q|0)<(o|0))o=q;else break}q=(p|0)>(o|0)?o:p;u=x;do{r=b+(u<<2)|0;w=u;u=f[r>>2]|0;f[r>>2]=q}while((u|0)<(w|0));y=q}q=t;do{u=b+(q<<2)|0;p=q;q=f[u>>2]|0;f[u>>2]=y}while((q|0)<(p|0));f[n>>2]=y;z=y}else z=x;q=f[m+(g<<2)>>2]|0;if((q|0)>0){t=q;while(1){p=f[b+(t<<2)>>2]|0;if((p|0)<(t|0))t=p;else break}if((q|0)==(z|0))A=t;else{p=z;while(1){u=f[b+(p<<2)>>2]|0;if((u|0)<(p|0))p=u;else break}u=(t|0)>(p|0)?p:t;o=z;do{w=b+(o<<2)|0;r=o;o=f[w>>2]|0;f[w>>2]=u}while((o|0)<(r|0));A=u}u=q;do{o=b+(u<<2)|0;t=u;u=f[o>>2]|0;f[o>>2]=A}while((u|0)<(t|0));f[n>>2]=A}}g=g+1|0}while((g|0)!=(d|0))}k=f[c+(k<<2)>>2]|0}while((k|0)<(e|0));return}function w6(a){a=a|0;PYa(a);return}function x6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[b>>2]|0;d=f[b+4>>2]|0;b=(c|0)<(d|0);if((c|0)>0){if(!b)return;e=a+4|0;g=a+8|0;h=c;do{i=f[e>>2]|0;j=(f[i+16>>2]|0)+(Y(f[f[i+44>>2]>>2]|0,h)|0)|0;k=j+(f[i+12>>2]<<2)|0;if((j|0)!=(k|0)){i=f[g>>2]|0;l=j;do{f[l>>2]=f[i+(f[l>>2]<<2)>>2];l=l+4|0}while((l|0)!=(k|0))}h=h+1|0}while((h|0)!=(d|0));return}else{if(!b)return;b=a+4|0;h=a+8|0;a=c;do{c=f[b>>2]|0;g=(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,a)|0)|0;e=g+(f[c+12>>2]<<2)|0;if((g|0)!=(e|0)){c=f[h>>2]|0;k=g;do{f[k>>2]=f[c+(f[k>>2]<<2)>>2];k=k+4|0}while((k|0)!=(e|0))}a=a+1|0}while((a|0)!=(d|0));return}}function y6(a){a=a|0;PYa(a);return}function z6(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=f[c>>2]|0;e=c+4|0;c=f[a+16>>2]|0;f[c+(d<<2)>>2]=f[e>>2];g=a+8|0;h=f[g>>2]|0;i=(((Y(f[h+12>>2]|0,d)|0)+1|0)/2|0)+1|0;j=a+4|0;k=f[j>>2]|0;l=f[k+12>>2]|0;if((d|0)==(f[e>>2]|0)){m=i;n=m-i|0;o=d+1|0;p=c+(o<<2)|0;f[p>>2]=n;return}q=(l|0)>0;r=a+12|0;a=i;s=d;t=h;h=k;while(1){k=f[f[h+44>>2]>>2]|0;u=(f[h+16>>2]|0)+(Y(k,s)|0)|0;v=u+(0-k)|0;k=f[f[t+44>>2]>>2]|0;w=(f[t+16>>2]|0)+(Y(k,s)|0)|0;x=w+(0-k)|0;a:do if(q){if((s|0)>(d|0)){y=0;z=a}else{k=0;A=a;while(1){do if(!(b[u+k>>0]|0)){f[w+(k<<2)>>2]=0;B=A}else{if((k|0)>0?(C=k+-1|0,b[u+C>>0]|0):0){f[w+(k<<2)>>2]=f[w+(C<<2)>>2];B=A;break}f[w+(k<<2)>>2]=A;f[(f[r>>2]|0)+(A<<2)>>2]=A;B=A+1|0}while(0);k=k+1|0;if((k|0)==(l|0)){D=B;break a}else A=B}}while(1){do if(!(b[u+y>>0]|0)){f[w+(y<<2)>>2]=0;E=z}else{A=(y|0)>0;if(!(b[v+y>>0]|0)){if(A?(k=y+-1|0,b[u+k>>0]|0):0){f[w+(y<<2)>>2]=f[w+(k<<2)>>2];E=z;break}f[w+(y<<2)>>2]=z;f[(f[r>>2]|0)+(z<<2)>>2]=z;E=z+1|0;break}k=f[x+(y<<2)>>2]|0;if(A?(A=y+-1|0,(b[u+A>>0]|0)!=0):0){C=f[r>>2]|0;F=f[w+(A<<2)>>2]|0;A=F;while(1){G=f[C+(A<<2)>>2]|0;if((G|0)<(A|0))A=G;else break}if((F|0)==(k|0))H=A;else{G=k;while(1){I=f[C+(G<<2)>>2]|0;if((I|0)<(G|0))G=I;else break}I=(A|0)>(G|0)?G:A;J=k;do{K=C+(J<<2)|0;L=J;J=f[K>>2]|0;f[K>>2]=I}while((J|0)<(L|0));H=I}I=F;do{J=C+(I<<2)|0;A=I;I=f[J>>2]|0;f[J>>2]=H}while((I|0)<(A|0));M=H}else M=k;f[w+(y<<2)>>2]=M;E=z}while(0);y=y+1|0;if((y|0)==(l|0)){D=E;break}else z=E}}else D=a;while(0);w=s+1|0;if((w|0)==(f[e>>2]|0)){m=D;break}a=D;s=w;t=f[g>>2]|0;h=f[j>>2]|0}n=m-i|0;o=d+1|0;p=c+(o<<2)|0;f[p>>2]=n;return}function A6(a){a=a|0;PYa(a);return}function B6(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=f[c>>2]|0;e=c+4|0;c=f[a+16>>2]|0;f[c+(d<<2)>>2]=f[e>>2];g=d+1|0;h=a+8|0;i=f[h>>2]|0;j=(Y(((f[i+12>>2]|0)+1|0)/2|0,(g|0)/2|0)|0)+1|0;k=a+4|0;l=f[k>>2]|0;m=f[l+12>>2]|0;n=f[e>>2]|0;if((d|0)==(n|0)){o=j;p=o-j|0;q=c+(g<<2)|0;f[q>>2]=p;return}r=(m|0)>0;s=m+-1|0;t=a+12|0;a=n;n=j;u=d;v=i;i=l;while(1){l=f[f[i+44>>2]>>2]|0;w=(f[i+16>>2]|0)+(Y(l,u)|0)|0;x=w+(0-l)|0;l=f[f[v+44>>2]>>2]|0;y=(f[v+16>>2]|0)+(Y(l,u)|0)|0;z=y+(0-l)|0;if(r){l=(u|0)>(d|0);A=l^1;B=0;C=n;while(1){a:do if(!(b[w+B>>0]|0)){f[y+(B<<2)>>2]=0;D=C}else{if(l){if(b[x+B>>0]|0){f[y+(B<<2)>>2]=f[z+(B<<2)>>2];D=C;break}if(!((B|0)>=(s|0)|A)){E=B+1|0;if(!(b[x+E>>0]|0))F=0;else{do if((B|0)>0){G=B+-1|0;if(!(b[x+G>>0]|0)){H=f[z+(E<<2)>>2]|0;if(!(b[w+G>>0]|0)){I=H;break}J=f[t>>2]|0;K=f[y+(G<<2)>>2]|0;L=K;while(1){M=f[J+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((K|0)==(H|0))N=L;else{M=H;while(1){O=f[J+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(L|0)>(M|0)?M:L;P=H;do{Q=J+(P<<2)|0;R=P;P=f[Q>>2]|0;f[Q>>2]=O}while((P|0)<(R|0));N=O}O=K;do{P=J+(O<<2)|0;H=O;O=f[P>>2]|0;f[P>>2]=N}while((O|0)<(H|0));I=N}else{O=f[t>>2]|0;J=f[z+(G<<2)>>2]|0;K=f[z+(E<<2)>>2]|0;H=J;while(1){P=f[O+(H<<2)>>2]|0;if((P|0)<(H|0))H=P;else break}if((J|0)==(K|0))S=H;else{G=K;while(1){P=f[O+(G<<2)>>2]|0;if((P|0)<(G|0))G=P;else break}P=(H|0)>(G|0)?G:H;L=K;do{M=O+(L<<2)|0;R=L;L=f[M>>2]|0;f[M>>2]=P}while((L|0)<(R|0));S=P}P=J;do{L=O+(P<<2)|0;K=P;P=f[L>>2]|0;f[L>>2]=S}while((P|0)<(K|0));f[y+(B<<2)>>2]=S;D=C;break a}}else I=f[z+(E<<2)>>2]|0;while(0);f[y+(B<<2)>>2]=I;D=C;break}}else F=A}else F=A;E=(B|0)>0;if(!(F|E^1)?(P=B+-1|0,b[x+P>>0]|0):0){f[y+(B<<2)>>2]=f[z+(P<<2)>>2];D=C;break}if(E?(E=B+-1|0,b[w+E>>0]|0):0){f[y+(B<<2)>>2]=f[y+(E<<2)>>2];D=C;break}f[y+(B<<2)>>2]=C;f[(f[t>>2]|0)+(C<<2)>>2]=C;D=C+1|0}while(0);B=B+1|0;if((B|0)==(m|0))break;else C=D}T=f[e>>2]|0;U=D}else{T=a;U=n}C=u+1|0;if((C|0)==(T|0)){o=U;break}a=T;n=U;u=C;v=f[h>>2]|0;i=f[k>>2]|0}p=o-j|0;q=c+(g<<2)|0;f[q>>2]=p;return}function C6(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return D6(a,b,c,d,e,f,-1)|0}function D6(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;j=u;u=u+272|0;k=j+208|0;l=j+144|0;m=j+152|0;n=j+8|0;o=j;do if((NS(a)|0)==65536){p=f[a+4>>2]|0;f[k>>2]=f[p>>2];q=k+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=k+8|0;f[s>>2]=f[p+8>>2];f[k+12>>2]=f[p+12>>2];f[k+16>>2]=f[p+16>>2];f[k+20>>2]=f[p+20>>2];f[k+24>>2]=f[p+24>>2];f[k+28>>2]=f[p+28>>2];f[k+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[k+36>>2]=t;v=k+40|0;f[v>>2]=s;s=k+48|0;w=k+44|0;f[w>>2]=s;f[s>>2]=0;f[k+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];x=v;break}else{f[q>>2]=0;BR(k,p);x=v;break}}else{OR(k,a,-1);x=k+40|0}while(0);a=f[x>>2]|0;v=f[a>>2]|0;f[l>>2]=f[a+4>>2];f[l+4>>2]=v;KS(c,l,h&7,-1,0,0);do if((NS(c)|0)==65536){l=f[c+4>>2]|0;f[m>>2]=f[l>>2];v=m+4|0;a=l+4|0;f[v>>2]=f[a>>2];p=m+8|0;f[p>>2]=f[l+8>>2];f[m+12>>2]=f[l+12>>2];f[m+16>>2]=f[l+16>>2];f[m+20>>2]=f[l+20>>2];f[m+24>>2]=f[l+24>>2];f[m+28>>2]=f[l+28>>2];f[m+32>>2]=f[l+32>>2];q=f[l+36>>2]|0;f[m+36>>2]=q;f[m+40>>2]=p;p=m+48|0;r=m+44|0;f[r>>2]=p;f[p>>2]=0;f[m+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[a>>2]|0)<3){a=f[l+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[a>>2];f[p+4>>2]=f[a+4>>2];break}else{f[v>>2]=0;BR(m,l);break}}else OR(m,c,-1);while(0);f[n>>2]=d;f[n+4>>2]=1124007936;d=n+12|0;c=n+44|0;l=n+8|0;v=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(v|0));f[c>>2]=d;d=n+52|0;f[n+48>>2]=d;f[d>>2]=0;f[n+56>>2]=0;f[n+60>>2]=e;f[n+64>>2]=1124007936;e=n+72|0;d=n+104|0;l=n+68|0;v=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(v|0));f[d>>2]=e;e=n+112|0;f[n+108>>2]=e;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;switch(h|0){case 2:{y=E6(k,m,g,i,n)|0;break}case 4:{y=E6(k,m,g,i,n)|0;break}default:{f[o>>2]=0;f[o+4>>2]=0;l=c$(o,37)|0;i=217990;v=l+37|0;do{b[l>>0]=b[i>>0]|0;l=l+1|0;i=i+1|0}while((l|0)<(v|0));j$(-210,o,218819,218048,4036);d$(o);y=0}}F6(n);n=m+36|0;o=f[n>>2]|0;if(o|0?(i=o+12|0,o=f[i>>2]|0,f[i>>2]=o+-1,(o|0)==1):0)CR(m);f[n>>2]=0;n=m+16|0;o=m+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[o>>2]|0)>0){n=f[m+40>>2]|0;i=0;do{f[n+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[o>>2]|0))}o=f[m+44>>2]|0;if((o|0)!=(m+48|0))ZF(o);o=k+36|0;m=f[o>>2]|0;if(m|0?(i=m+12|0,m=f[i>>2]|0,f[i>>2]=m+-1,(m|0)==1):0)CR(k);f[o>>2]=0;o=k+16|0;m=k+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[m>>2]|0)>0){o=f[x>>2]|0;x=0;do{f[o+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[m>>2]|0))}m=f[k+44>>2]|0;if((m|0)==(k+48|0)){u=j;return y|0}ZF(m);u=j;return y|0}function E6(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=u;u=u+16|0;i=h;j=h+13|0;k=h+12|0;l=h+11|0;m=h+10|0;n=h+9|0;o=h+8|0;if(!((f[c>>2]&4088|0)==0?!(f[a>>2]&4088|0):0)){f[i>>2]=0;f[i+4>>2]=0;p=c$(i,38)|0;q=218112;r=p+38|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,i,218151,218048,3932);d$(i)}s=(d|0)==8;t=(d|0)==4;switch(d|0){case 4:case 8:break;default:{f[i>>2]=0;f[i+4>>2]=0;p=c$(i,38)|0;q=223444;r=p+38|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,i,218151,218048,3933);d$(i)}}v=(e|0)==1;w=(e|0)==0;x=(e|0)==-1;switch(e|0){case 0:case 1:case -1:break;default:{f[i>>2]=0;f[i+4>>2]=0;p=c$(i,67)|0;q=218176;r=p+67|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,i,218151,218048,3934);d$(i)}}e=f[c>>2]|0;y=e&7;z=f[a>>2]&6;A=cV()|0;B=bV()|0;if((z|1|0)!=1){f[i>>2]=0;f[i+4>>2]=0;p=c$(i,26)|0;q=218244;r=p+26|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-215,i,218151,218048,3941);d$(i)}if((A|0)!=0&(B|0)>1)C=((f[c+8>>2]|0)/(B|0)|0|0)>1;else C=0;B=(y|0)==0;a:do if(t|w){if(!B){switch(e&7){case 2:{D=(G6(j,a,c,d,g)|0)&65535;u=h;return D|0}case 4:break;default:break a}if(C){D=I6(l,a,c,d,g)|0;u=h;return D|0}else{D=H6(k,a,c,d,g)|0;u=h;return D|0}}}else if(!(B|s&(v|x)^1)){switch(e&7){case 2:{D=(J6(m,a,c,d,g)|0)&65535;u=h;return D|0}case 4:break;default:break a}if(C){D=L6(o,a,c,d,g)|0;u=h;return D|0}else{D=K6(n,a,c,d,g)|0;u=h;return D|0}}while(0);f[i>>2]=0;f[i+4>>2]=0;p=c$(i,28)|0;q=218271;r=p+28|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));j$(-210,i,218151,218048,3987);d$(i);D=-1;u=h;return D|0}function F6(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+120>>2]|0;if(b|0){c=a+124|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-16-b|0)>>>4)<<4);PYa(b)}b=a+64|0;d=a+100|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)CR(b);f[d>>2]=0;d=a+80|0;b=a+68|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+104>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+108>>2]|0;if((b|0)!=(a+112|0))ZF(b);b=a+4|0;c=a+40|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)CR(b);f[c>>2]=0;c=a+20|0;b=a+8|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+44>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;ZF(b);return}function G6(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0.0;a=u;u=u+16|0;i=a;k=c+8|0;if((f[e+8>>2]|0)!=(f[k>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;l=c$(i,26)|0;m=218765;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-215,i,373355,218048,659);d$(i)}o=c+12|0;if((f[e+12>>2]|0)!=(f[o>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;l=c$(i,26)|0;m=218792;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-215,i,373355,218048,660);d$(i)}q=(g|0)==8;switch(g|0){case 4:case 8:break;default:{f[i>>2]=0;f[i+4>>2]=0;l=c$(i,38)|0;m=223444;n=l+38|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));j$(-215,i,373355,218048,661);d$(i)}}i=f[k>>2]|0;k=f[o>>2]|0;o=YF((Y(k,i)|0)+3&-2)|0;d[o>>1]=0;m=(i|0)>0;if(q)if(m){q=(k|0)>0;l=k+-1|0;n=f[c+16>>2]|0;g=f[f[c+44>>2]>>2]|0;r=f[e+16>>2]|0;s=f[f[e+44>>2]>>2]|0;t=0-g|0;v=0-s|0;w=1;x=0;while(1){y=n+(Y(g,x)|0)|0;z=y+t|0;A=r+(Y(s,x)|0)|0;B=A+v|0;if(q){C=(x|0)>0;D=0;E=w;while(1){a:do if(!(b[y+D>>0]|0)){d[A+(D<<1)>>1]=0;F=E}else{if(C){if(b[z+D>>0]|0){d[A+(D<<1)>>1]=d[B+(D<<1)>>1]|0;F=E;break}G=(D|0)>0;if((D|0)<(l|0)?(H=D+1|0,b[z+H>>0]|0):0){I=d[B+(H<<1)>>1]|0;do if(G){H=D+-1|0;if(!(b[z+H>>0]|0)){K=D+-1|0;if(!(b[y+K>>0]|0)){L=I;break}M=d[A+(K<<1)>>1]|0;K=M;while(1){N=d[o+((K&65535)<<1)>>1]|0;if((N&65535)<(K&65535))K=N;else break}if(M<<16>>16==I<<16>>16)O=K;else{N=I;while(1){P=d[o+((N&65535)<<1)>>1]|0;if((P&65535)<(N&65535))N=P;else break}P=(K&65535)>(N&65535)?N:K;Q=I;do{R=o+((Q&65535)<<1)|0;S=Q;Q=d[R>>1]|0;d[R>>1]=P}while((Q&65535)<(S&65535));O=P}P=M;do{Q=o+((P&65535)<<1)|0;K=P;P=d[Q>>1]|0;d[Q>>1]=O}while((P&65535)<(K&65535));L=O}else{P=d[B+(H<<1)>>1]|0;M=P;while(1){K=d[o+((M&65535)<<1)>>1]|0;if((K&65535)<(M&65535))M=K;else break}if(P<<16>>16==I<<16>>16)T=M;else{H=I;while(1){K=d[o+((H&65535)<<1)>>1]|0;if((K&65535)<(H&65535))H=K;else break}K=(M&65535)>(H&65535)?H:M;Q=I;do{N=o+((Q&65535)<<1)|0;S=Q;Q=d[N>>1]|0;d[N>>1]=K}while((Q&65535)<(S&65535));T=K}K=P;do{Q=o+((K&65535)<<1)|0;M=K;K=d[Q>>1]|0;d[Q>>1]=T}while((K&65535)<(M&65535));d[A+(D<<1)>>1]=T;F=E;break a}}else L=I;while(0);d[A+(D<<1)>>1]=L;F=E;break}if(G){I=D+-1|0;if(!(b[z+I>>0]|0))U=46;else{d[A+(D<<1)>>1]=d[B+(I<<1)>>1]|0;F=E;break}}}else if((D|0)>0)U=46;if((U|0)==46?(U=0,I=D+-1|0,b[y+I>>0]|0):0){d[A+(D<<1)>>1]=d[A+(I<<1)>>1]|0;F=E;break}d[A+(D<<1)>>1]=E;I=E&65535;d[o+(I<<1)>>1]=E;F=I+1&65535}while(0);D=D+1|0;if((D|0)==(k|0)){V=F;break}else E=F}}else V=w;x=x+1|0;if((x|0)==(i|0)){W=V;U=81;break}else w=V}}else U=80;else if(m){V=(k|0)>0;w=f[c+16>>2]|0;x=f[f[c+44>>2]>>2]|0;c=f[e+16>>2]|0;F=f[f[e+44>>2]>>2]|0;L=0-x|0;T=0-F|0;O=1;l=0;while(1){q=w+(Y(x,l)|0)|0;v=q+L|0;s=c+(Y(F,l)|0)|0;r=s+T|0;b:do if(V){if((l|0)>0){X=0;Z=O}else{t=0;g=O;while(1){do if(!(b[q+t>>0]|0)){d[s+(t<<1)>>1]=0;_=g}else{if((t|0)>0?(n=t+-1|0,b[q+n>>0]|0):0){d[s+(t<<1)>>1]=d[s+(n<<1)>>1]|0;_=g;break}d[s+(t<<1)>>1]=g;n=g&65535;d[o+(n<<1)>>1]=g;_=n+1&65535}while(0);t=t+1|0;if((t|0)==(k|0)){$=_;break b}else g=_}}while(1){do if(!(b[q+X>>0]|0)){d[s+(X<<1)>>1]=0;aa=Z}else{g=(X|0)>0;if(!(b[v+X>>0]|0)){if(g?(t=X+-1|0,b[q+t>>0]|0):0){d[s+(X<<1)>>1]=d[s+(t<<1)>>1]|0;aa=Z;break}d[s+(X<<1)>>1]=Z;t=Z&65535;d[o+(t<<1)>>1]=Z;aa=t+1&65535;break}t=d[r+(X<<1)>>1]|0;if(g?(g=X+-1|0,(b[q+g>>0]|0)!=0):0){G=d[s+(g<<1)>>1]|0;g=G;while(1){n=d[o+((g&65535)<<1)>>1]|0;if((n&65535)<(g&65535))g=n;else break}if(G<<16>>16==t<<16>>16)ba=g;else{n=t;while(1){E=d[o+((n&65535)<<1)>>1]|0;if((E&65535)<(n&65535))n=E;else break}E=(g&65535)>(n&65535)?n:g;D=t;do{A=o+((D&65535)<<1)|0;y=D;D=d[A>>1]|0;d[A>>1]=E}while((D&65535)<(y&65535));ba=E}E=G;do{D=o+((E&65535)<<1)|0;g=E;E=d[D>>1]|0;d[D>>1]=ba}while((E&65535)<(g&65535));ca=ba}else ca=t;d[s+(X<<1)>>1]=ca;aa=Z}while(0);X=X+1|0;if((X|0)==(k|0)){$=aa;break}else Z=aa}}else $=O;while(0);l=l+1|0;if((l|0)==(i|0)){W=$;U=81;break}else O=$}}else U=80;if((U|0)==80){N6(h,1);da=1}else if((U|0)==81){if((W&65535)>1){U=W&65535;W=1;$=1;while(1){O=o+(W<<1)|0;l=j[O>>1]|0;if(l>>>0<W>>>0){d[O>>1]=d[o+(l<<1)>>1]|0;ea=$}else{d[O>>1]=$;ea=($&65535)+1&65535}W=W+1|0;if((W|0)==(U|0)){fa=ea;break}else $=ea}}else fa=1;N6(h,fa&65535);if(m){m=f[e+16>>2]|0;ea=f[e+44>>2]|0;e=f[h+20>>2]|0;$=f[h+48>>2]|0;U=f[h+120>>2]|0;W=0;do{O=m+(Y(f[ea>>2]|0,W)|0)|0;l=O+(k<<1)|0;if((O|0)!=(l|0)){aa=((W|0)<0)<<31>>31;Z=0;X=O;while(1){O=d[o+(j[X>>1]<<1)>>1]|0;d[X>>1]=O;ca=O&65535;O=e+(Y(f[$>>2]|0,ca)|0)|0;ba=f[O>>2]|0;f[O>>2]=(ba|0)>(Z|0)?Z:ba;ba=O+8|0;_=f[ba>>2]|0;f[ba>>2]=(_|0)<(Z|0)?Z:_;_=O+4|0;ba=f[_>>2]|0;f[_>>2]=(ba|0)>(W|0)?W:ba;ba=O+12|0;_=f[ba>>2]|0;f[ba>>2]=(_|0)<(W|0)?W:_;_=O+16|0;f[_>>2]=(f[_>>2]|0)+1;_=U+(ca<<4)|0;O=_;ba=C1a(f[O>>2]|0,f[O+4>>2]|0,Z|0,((Z|0)<0)<<31>>31|0)|0;O=_;f[O>>2]=ba;f[O+4>>2]=J;O=U+(ca<<4)+8|0;ca=O;ba=C1a(f[ca>>2]|0,f[ca+4>>2]|0,W|0,aa|0)|0;ca=O;f[ca>>2]=ba;f[ca+4>>2]=J;X=X+2|0;if((X|0)==(l|0))break;else Z=Z+1|0}}W=W+1|0}while((W|0)!=(i|0));da=fa}else da=fa}fa=h+12|0;if((f[fa>>2]|0)<=0){ZF(o);u=a;return da|0}i=f[h+20>>2]|0;W=f[h+48>>2]|0;U=f[h+120>>2]|0;$=f[h+80>>2]|0;e=f[h+108>>2]|0;h=0;do{k=i+(Y(f[W>>2]|0,h)|0)|0;ea=k+8|0;f[ea>>2]=(f[ea>>2]|0)+1-(f[k>>2]|0);ea=k+12|0;f[ea>>2]=(f[ea>>2]|0)+1-(f[k+4>>2]|0);ea=$+(Y(f[e>>2]|0,h)|0)|0;ga=+((f[k+16>>2]|0)>>>0);k=U+(h<<4)|0;p[ea>>3]=(+((f[k>>2]|0)>>>0)+4294967296.0*+((f[k+4>>2]|0)>>>0))/ga;k=U+(h<<4)+8|0;p[ea+8>>3]=(+((f[k>>2]|0)>>>0)+4294967296.0*+((f[k+4>>2]|0)>>>0))/ga;h=h+1|0}while((h|0)<(f[fa>>2]|0));ZF(o);u=a;return da|0}function H6(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0;a=u;u=u+16|0;h=a;i=c+8|0;if((f[d+8>>2]|0)!=(f[i>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,26)|0;k=218765;l=j+26|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,h,373355,218048,659);d$(h)}m=c+12|0;if((f[d+12>>2]|0)!=(f[m>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;j=c$(h,26)|0;k=218792;l=j+26|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,h,373355,218048,660);d$(h)}n=(e|0)==8;switch(e|0){case 4:case 8:break;default:{f[h>>2]=0;f[h+4>>2]=0;j=c$(h,38)|0;k=223444;l=j+38|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));j$(-215,h,373355,218048,661);d$(h)}}h=f[i>>2]|0;i=f[m>>2]|0;m=YF((((Y(i,h)|0)+1|0)>>>1<<2)+4|0)|0;f[m>>2]=0;k=(h|0)>0;if(n)if(k){n=(i|0)>0;j=i+-1|0;l=f[c+16>>2]|0;e=f[c+44>>2]|0;o=f[d+16>>2]|0;q=f[d+44>>2]|0;r=1;s=0;while(1){t=f[e>>2]|0;v=l+(Y(t,s)|0)|0;w=v+(0-t)|0;t=f[q>>2]|0;x=o+(Y(t,s)|0)|0;y=x+(0-t)|0;if(n){t=(s|0)>0;z=0;A=r;while(1){a:do if(!(b[v+z>>0]|0)){f[x+(z<<2)>>2]=0;B=A}else{if(t){if(b[w+z>>0]|0){f[x+(z<<2)>>2]=f[y+(z<<2)>>2];B=A;break}C=(z|0)>0;if((z|0)<(j|0)?(D=z+1|0,b[w+D>>0]|0):0){E=f[y+(D<<2)>>2]|0;do if(C){D=z+-1|0;if(!(b[w+D>>0]|0)){F=z+-1|0;if(!(b[v+F>>0]|0)){G=E;break}H=f[x+(F<<2)>>2]|0;F=H;while(1){I=f[m+(F<<2)>>2]|0;if((I|0)<(F|0))F=I;else break}if((H|0)==(E|0))K=F;else{I=E;while(1){L=f[m+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}L=(F|0)>(I|0)?I:F;M=E;do{N=m+(M<<2)|0;O=M;M=f[N>>2]|0;f[N>>2]=L}while((M|0)<(O|0));K=L}L=H;do{M=m+(L<<2)|0;F=L;L=f[M>>2]|0;f[M>>2]=K}while((L|0)<(F|0));G=K}else{L=f[y+(D<<2)>>2]|0;H=L;while(1){F=f[m+(H<<2)>>2]|0;if((F|0)<(H|0))H=F;else break}if((L|0)==(E|0))P=H;else{D=E;while(1){F=f[m+(D<<2)>>2]|0;if((F|0)<(D|0))D=F;else break}F=(H|0)>(D|0)?D:H;M=E;do{I=m+(M<<2)|0;O=M;M=f[I>>2]|0;f[I>>2]=F}while((M|0)<(O|0));P=F}F=L;do{M=m+(F<<2)|0;H=F;F=f[M>>2]|0;f[M>>2]=P}while((F|0)<(H|0));f[x+(z<<2)>>2]=P;B=A;break a}}else G=E;while(0);f[x+(z<<2)>>2]=G;B=A;break}if(C){E=z+-1|0;if(!(b[w+E>>0]|0))Q=46;else{f[x+(z<<2)>>2]=f[y+(E<<2)>>2];B=A;break}}}else if((z|0)>0)Q=46;if((Q|0)==46?(Q=0,E=z+-1|0,b[v+E>>0]|0):0){f[x+(z<<2)>>2]=f[x+(E<<2)>>2];B=A;break}f[x+(z<<2)>>2]=A;f[m+(A<<2)>>2]=A;B=A+1|0}while(0);z=z+1|0;if((z|0)==(i|0)){R=B;break}else A=B}}else R=r;s=s+1|0;if((s|0)==(h|0)){S=R;Q=81;break}else r=R}}else Q=80;else if(k){R=(i|0)>0;r=f[c+16>>2]|0;s=f[c+44>>2]|0;c=f[d+16>>2]|0;B=f[d+44>>2]|0;G=1;P=0;while(1){K=f[s>>2]|0;j=r+(Y(K,P)|0)|0;n=j+(0-K)|0;K=f[B>>2]|0;o=c+(Y(K,P)|0)|0;q=o+(0-K)|0;b:do if(R){if((P|0)>0){T=0;U=G}else{K=0;l=G;while(1){do if(!(b[j+K>>0]|0)){f[o+(K<<2)>>2]=0;V=l}else{if((K|0)>0?(e=K+-1|0,b[j+e>>0]|0):0){f[o+(K<<2)>>2]=f[o+(e<<2)>>2];V=l;break}f[o+(K<<2)>>2]=l;f[m+(l<<2)>>2]=l;V=l+1|0}while(0);K=K+1|0;if((K|0)==(i|0)){W=V;break b}else l=V}}while(1){do if(!(b[j+T>>0]|0)){f[o+(T<<2)>>2]=0;X=U}else{l=(T|0)>0;if(!(b[n+T>>0]|0)){if(l?(K=T+-1|0,b[j+K>>0]|0):0){f[o+(T<<2)>>2]=f[o+(K<<2)>>2];X=U;break}f[o+(T<<2)>>2]=U;f[m+(U<<2)>>2]=U;X=U+1|0;break}K=f[q+(T<<2)>>2]|0;if(l?(l=T+-1|0,(b[j+l>>0]|0)!=0):0){C=f[o+(l<<2)>>2]|0;l=C;while(1){e=f[m+(l<<2)>>2]|0;if((e|0)<(l|0))l=e;else break}if((C|0)==(K|0))Z=l;else{e=K;while(1){A=f[m+(e<<2)>>2]|0;if((A|0)<(e|0))e=A;else break}A=(l|0)>(e|0)?e:l;z=K;do{x=m+(z<<2)|0;v=z;z=f[x>>2]|0;f[x>>2]=A}while((z|0)<(v|0));Z=A}A=C;do{z=m+(A<<2)|0;l=A;A=f[z>>2]|0;f[z>>2]=Z}while((A|0)<(l|0));_=Z}else _=K;f[o+(T<<2)>>2]=_;X=U}while(0);T=T+1|0;if((T|0)==(i|0)){W=X;break}else U=X}}else W=G;while(0);P=P+1|0;if((P|0)==(h|0)){S=W;Q=81;break}else G=W}}else Q=80;if((Q|0)==80){N6(g,1);$=1}else if((Q|0)==81){if((S|0)>1){Q=1;W=1;while(1){G=m+(Q<<2)|0;P=f[G>>2]|0;if((P|0)<(Q|0)){f[G>>2]=f[m+(P<<2)>>2];aa=W}else{f[G>>2]=W;aa=W+1|0}Q=Q+1|0;if((Q|0)==(S|0)){ba=aa;break}else W=aa}}else ba=1;N6(g,ba);if(k){k=f[d+16>>2]|0;aa=f[d+44>>2]|0;d=f[g+20>>2]|0;W=f[g+48>>2]|0;S=f[g+120>>2]|0;Q=0;do{G=k+(Y(f[aa>>2]|0,Q)|0)|0;P=G+(i<<2)|0;if((G|0)!=(P|0)){X=((Q|0)<0)<<31>>31;U=0;T=G;while(1){G=f[m+(f[T>>2]<<2)>>2]|0;f[T>>2]=G;_=d+(Y(f[W>>2]|0,G)|0)|0;Z=f[_>>2]|0;f[_>>2]=(Z|0)>(U|0)?U:Z;Z=_+8|0;V=f[Z>>2]|0;f[Z>>2]=(V|0)<(U|0)?U:V;V=_+4|0;Z=f[V>>2]|0;f[V>>2]=(Z|0)>(Q|0)?Q:Z;Z=_+12|0;V=f[Z>>2]|0;f[Z>>2]=(V|0)<(Q|0)?Q:V;V=_+16|0;f[V>>2]=(f[V>>2]|0)+1;V=S+(G<<4)|0;_=V;Z=C1a(f[_>>2]|0,f[_+4>>2]|0,U|0,((U|0)<0)<<31>>31|0)|0;_=V;f[_>>2]=Z;f[_+4>>2]=J;_=S+(G<<4)+8|0;G=_;Z=C1a(f[G>>2]|0,f[G+4>>2]|0,Q|0,X|0)|0;G=_;f[G>>2]=Z;f[G+4>>2]=J;T=T+4|0;if((T|0)==(P|0))break;else U=U+1|0}}Q=Q+1|0}while((Q|0)!=(h|0));$=ba}else $=ba}ba=g+12|0;if((f[ba>>2]|0)<=0){ZF(m);u=a;return $|0}h=f[g+20>>2]|0;Q=f[g+48>>2]|0;S=f[g+120>>2]|0;W=f[g+80>>2]|0;d=f[g+108>>2]|0;g=0;do{i=h+(Y(f[Q>>2]|0,g)|0)|0;aa=i+8|0;f[aa>>2]=(f[aa>>2]|0)+1-(f[i>>2]|0);aa=i+12|0;f[aa>>2]=(f[aa>>2]|0)+1-(f[i+4>>2]|0);aa=W+(Y(f[d>>2]|0,g)|0)|0;ca=+((f[i+16>>2]|0)>>>0);i=S+(g<<4)|0;p[aa>>3]=(+((f[i>>2]|0)>>>0)+4294967296.0*+((f[i+4>>2]|0)>>>0))/ca;i=S+(g<<4)+8|0;p[aa+8>>3]=(+((f[i>>2]|0)>>>0)+4294967296.0*+((f[i+4>>2]|0)>>>0))/ca;g=g+1|0}while((g|0)<(f[ba>>2]|0));ZF(m);u=a;return $|0}function I6(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0;a=u;u=u+48|0;h=a+32|0;i=a+24|0;j=a;k=c+8|0;l=d+8|0;if((f[k>>2]|0)!=(f[l>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=c$(h,26)|0;n=218300;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,h,373355,218048,578);d$(h)}q=c+12|0;r=d+12|0;if((f[q>>2]|0)!=(f[r>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=c$(h,26)|0;n=218327;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,h,373355,218048,579);d$(h)}s=(e|0)==8;switch(e|0){case 4:case 8:break;default:{f[h>>2]=0;f[h+4>>2]=0;m=c$(h,38)|0;n=223444;o=m+38|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));j$(-215,h,373355,218048,580);d$(h)}}n=bV()|0;e=f[k>>2]|0;k=f[q>>2]|0;q=((Y(k,e)|0)+1|0)>>>1;t=YF(e<<2)|0;v=YF((q<<2)+4|0)|0;f[v>>2]=0;f[h>>2]=0;f[h+4>>2]=e;f[i>>2]=1;if(s){f[j>>2]=48960;f[j+4>>2]=c;f[j+8>>2]=d;f[j+12>>2]=v;f[j+16>>2]=t;_U(h,j,+(n|0));U6(d,v,t);if((e|0)>0){s=(k+1|0)/2|0;q=0;do{w=q+1|0;x=(Y((w|0)/2|0,s)|0)+1|0;y=f[t+(w<<2)>>2]|0;w=y+x|0;if((y|0)>0){y=x;do{x=v+(y<<2)|0;z=f[x>>2]|0;if((z|0)<(y|0))f[x>>2]=f[v+(z<<2)>>2];else{f[x>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}y=y+1|0}while((y|0)<(w|0))}q=f[t+(q<<2)>>2]|0}while((q|0)<(e|0))}}else{f[j>>2]=48980;f[j+4>>2]=c;f[j+8>>2]=d;f[j+12>>2]=v;f[j+16>>2]=t;_U(h,j,+(n|0));c=f[r>>2]|0;r=f[l>>2]|0;q=f[t>>2]|0;a:do if((q|0)<(r|0)){s=f[d+16>>2]|0;w=f[d+44>>2]|0;if((c|0)>0)A=q;else{y=q;while(1){y=f[t+(y<<2)>>2]|0;if((y|0)>=(r|0))break a}}do{y=f[w>>2]|0;x=s+(Y(y,A)|0)|0;z=x+(0-y)|0;y=0;do{B=x+(y<<2)|0;C=f[B>>2]|0;if((C|0)>0?(D=f[z+(y<<2)>>2]|0,(D|0)>0):0){E=D;while(1){F=f[v+(E<<2)>>2]|0;if((F|0)<(E|0))E=F;else break}if((D|0)==(C|0))G=E;else{F=C;while(1){H=f[v+(F<<2)>>2]|0;if((H|0)<(F|0))F=H;else break}H=(E|0)>(F|0)?F:E;I=C;do{K=v+(I<<2)|0;L=I;I=f[K>>2]|0;f[K>>2]=H}while((I|0)<(L|0));G=H}H=D;do{I=v+(H<<2)|0;C=H;H=f[I>>2]|0;f[I>>2]=G}while((H|0)<(C|0));f[B>>2]=G}y=y+1|0}while((y|0)!=(c|0));A=f[t+(A<<2)>>2]|0}while((A|0)<(r|0))}while(0);if((e|0)>0){r=0;do{A=(((Y(r,k)|0)+1|0)/2|0)+1|0;c=f[t+(r+1<<2)>>2]|0;G=c+A|0;if((c|0)>0){c=A;do{A=v+(c<<2)|0;q=f[A>>2]|0;if((q|0)<(c|0))f[A>>2]=f[v+(q<<2)>>2];else{f[A>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}c=c+1|0}while((c|0)<(G|0))}r=f[t+(r<<2)>>2]|0}while((r|0)<(e|0))}}r=e*136|0;k=OYa(e>>>0>31580641|r>>>0>4294967291?-1:r+4|0)|0;f[k>>2]=e;r=k+4|0;if(e|0){G=r+(e*136|0)|0;e=r;do{f[e>>2]=0;f[e+4>>2]=1124007936;c=e+12|0;A=e+44|0;m=e+8|0;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[A>>2]=c;q=e+52|0;f[e+48>>2]=q;f[q>>2]=0;f[e+56>>2]=0;f[e+60>>2]=0;f[e+64>>2]=1124007936;q=e+72|0;s=e+104|0;m=e+68|0;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[s>>2]=q;c=e+112|0;f[e+108>>2]=c;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;e=e+136|0}while((e|0)!=(G|0))}N6(g,f[i>>2]|0);f[j>>2]=49e3;f[j+4>>2]=d;f[j+8>>2]=v;f[j+12>>2]=g;f[j+16>>2]=r;f[j+20>>2]=i;_U(h,j,+(n|0));n=f[l>>2]|0;l=f[g+132>>2]|0;if((l|0)<(n|0)){j=g+20|0;h=g+48|0;d=g+120|0;G=f[i>>2]|0;e=l;while(1){if((G|0)>0){l=r+(e*136|0)+120|0;m=f[r+(e*136|0)+20>>2]|0;o=f[r+(e*136|0)+48>>2]|0;c=G;A=0;while(1){w=m+(Y(f[o>>2]|0,A)|0)|0;y=w+16|0;if((f[y>>2]|0)>0){z=(f[j>>2]|0)+(Y(f[f[h>>2]>>2]|0,A)|0)|0;x=f[z>>2]|0;H=f[w>>2]|0;f[z>>2]=(x|0)>(H|0)?H:x;x=z+8|0;f[x>>2]=f[((f[x>>2]|0)<(f[w+8>>2]|0)?w:z)+8>>2];x=z+4|0;f[x>>2]=f[((f[x>>2]|0)>(f[w+4>>2]|0)?w:z)+4>>2];x=z+12|0;f[x>>2]=f[((f[x>>2]|0)<(f[w+12>>2]|0)?w:z)+12>>2];w=z+16|0;f[w>>2]=(f[w>>2]|0)+(f[y>>2]|0);y=f[l>>2]|0;w=y+(A<<4)|0;z=f[d>>2]|0;x=z+(A<<4)|0;H=x;D=C1a(f[H>>2]|0,f[H+4>>2]|0,f[w>>2]|0,f[w+4>>2]|0)|0;w=x;f[w>>2]=D;f[w+4>>2]=J;w=y+(A<<4)+8|0;y=z+(A<<4)+8|0;z=y;D=C1a(f[z>>2]|0,f[z+4>>2]|0,f[w>>2]|0,f[w+4>>2]|0)|0;w=y;f[w>>2]=D;f[w+4>>2]=J;M=f[i>>2]|0}else M=c;A=A+1|0;if((A|0)>=(M|0)){N=M;break}else c=M}}else N=G;e=f[r+(e*136|0)+132>>2]|0;if((e|0)>=(n|0))break;else G=N}}N=g+12|0;if((f[N>>2]|0)>0){G=f[g+20>>2]|0;n=f[g+48>>2]|0;e=f[g+120>>2]|0;M=f[g+80>>2]|0;d=f[g+108>>2]|0;g=0;do{h=G+(Y(f[n>>2]|0,g)|0)|0;j=h+8|0;f[j>>2]=(f[j>>2]|0)+1-(f[h>>2]|0);j=h+12|0;f[j>>2]=(f[j>>2]|0)+1-(f[h+4>>2]|0);j=M+(Y(f[d>>2]|0,g)|0)|0;O=+((f[h+16>>2]|0)>>>0);h=e+(g<<4)|0;p[j>>3]=(+((f[h>>2]|0)>>>0)+4294967296.0*+((f[h+4>>2]|0)>>>0))/O;h=e+(g<<4)+8|0;p[j+8>>3]=(+((f[h>>2]|0)>>>0)+4294967296.0*+((f[h+4>>2]|0)>>>0))/O;g=g+1|0}while((g|0)<(f[N>>2]|0))}N=r+((f[k>>2]|0)*136|0)|0;if((r|0)==(N|0)){QYa(k);ZF(t);ZF(v);P=f[i>>2]|0;u=a;return P|0}else Q=N;do{Q=Q+-136|0;F6(Q)}while((Q|0)!=(r|0));QYa(k);ZF(t);ZF(v);P=f[i>>2]|0;u=a;return P|0}

// EMSCRIPTEN_END_FUNCS
var Xf=[T4a,gVa,mVa,T4a];var Yf=[U4a,Zy];var Zf=[V4a,Hta,Sp,Fr,YE,V4a,V4a,V4a];var _f=[W4a,dz,Bl,W4a];var $f=[X4a,Ita,Sr,X4a];var ag=[Y4a,ar];var bg=[Z4a,jZ,kZ,lZ,mZ,nZ,oZ,pZ,g_,h_,i_,j_,k_,l_,m_,n_,o_,p_,q_,r_,s_,t_,u_,v_,w_,x_,y_,z_,A_,s9,qQa,rQa,sQa,tQa,uQa,vQa,wQa,xQa,yQa,zQa,AQa,kRa,lRa,mRa,nRa,oRa,pRa,qRa,rRa,sRa,tRa,uRa,NRa,PRa,cSa,eSa,pSa,qSa,rSa,sSa,tSa,aTa,bTa,cTa,dTa,eTa,hVa,nVa,Sv,Gm,dA,oGa,pGa,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a,Z4a];var cg=[_4a,NA];var dg=[$4a,Ry,Ty,wl,yz,oB,$4a,$4a];var eg=[a5a,kl];var fg=[b5a,is];var gg=[c5a,Oz,GA,c5a];var hg=[d5a,pm];var ig=[e5a,ll];var jg=[f5a,UD];var kg=[g5a,ql,tl,g5a];var lg=[h5a,Qp,pr,h5a];var mg=[i5a,bl,Hp,i5a];var ng=[j5a,rl,ul,j5a];var og=[k5a,lA,bo,hC,fD,IE,Or,k5a];var pg=[l5a,ol];var qg=[m5a,qB];var rg=[n5a,nz];var sg=[o5a,lB];var tg=[p5a,pC];var ug=[q5a,Oy,zo,bC];var vg=[r5a,PBa,Tr,r5a];var wg=[s5a,ez,Cl,s5a];var xg=[t5a,P1,uua,wua,yua,Aua,Cua,Eua,Gua,Mua,rva,Fva,Pva,oCa,Km,cn,Cp,t5a,t5a,t5a,t5a,t5a,t5a,t5a,t5a,t5a,t5a,t5a,t5a,t5a,t5a,t5a];var yg=[u5a,QE];var zg=[v5a,Jta,_q,v5a];var Ag=[w5a,pB];var Bg=[x5a,mB,rB,x5a];var Cg=[y5a,un];var Dg=[z5a,aB,Xo,IB];var Eg=[A5a,Eqa,Uqa,jj,Yw,ex,mx,ux,Cx,Jx,Nx,Vx,Zx,py,zy,Hy,Sl,Jm,fA,Vo,Bp,Fp,zq,mD,_D,HF,A5a,A5a,A5a,A5a,A5a,A5a];var Fg=[B5a,Do];var Gg=[C5a,xo];var Hg=[D5a,$q];var Ig=[E5a,$N,YN,ZN,_N,E5a,E5a,E5a];var Jg=[F5a,wR,fV,q9,r9,uWa,RWa,SWa,TWa,ZWa,Pv,Qv,Tv,ew,uw,ww,Jk,zw,Mk,Cw,Pk,Fw,Sk,Iw,Vk,Yk,Zk,ly,Ps,Jt,bu,ru,Iu,Zu,nv,Ev,Dm,aA,Im,LA,VA,jB,Lo,zB,wq,xC,SC,hF,mGa,nGa,F5a,F5a,F5a,F5a,F5a,F5a,F5a,F5a,F5a,F5a,F5a,F5a,F5a,F5a];var Kg=[G5a,Kra,Kr,G5a];var Lg=[H5a,Qn];var Mg=[I5a,cD];var Ng=[J5a,mw,dt,tt];var Og=[K5a,NTa,TTa,QUa,RUa,ZUa,_Ua,cA];var Pg=[L5a,Gp];var Qg=[M5a,XC];var Rg=[N5a,On];var Sg=[O5a,Ll];var Tg=[P5a,Jra,Rp,Er,XE,P5a,P5a,P5a];var Ug=[Q5a,hs];var Vg=[R5a,zC];var Wg=[S5a,fB];var Xg=[T5a,HB];var Yg=[U5a,rz];var Zg=[V5a,jl];var _g=[W5a,xF];var $g=[X5a,fz,Dl,jm,co,gD,JE,Pr];var ah=[Y5a,Wy];var bh=[Z5a,JI,KI,LI,MI,sO,tO,uO,vO,wO,xO,yO,lO,mO,nO,oO,pO,qO,rO,NU,Bba,zba,Iba,Gba,Pba,Nba,Wba,Uba,cca,aca,jca,hca,qca,oca,xca,vca,Eca,Cca,Lca,Jca,Tca,Rca,Wca,cda,ada,fda,jda,Sia,Oia,Kia,Gia,Cia,yia,uia,qia,mia,iia,Dma,Ema,Fma,Gma,Hma,Apa,tpa,npa,hpa,bpa,Xoa,Roa,Loa,Foa,zoa,toa,noa,Gta,Lta,Ewa,lBa,OBa,hCa,_Na,qOa,tVa,yVa,HZa,QZa,n_a,lz,Il,sz,Bz,gm,Hz,nm,um,Tz,ym,Xz,hn,pA,on,sA,yn,BA,DA,Kn,RA,Xn,YA,go,$A,Go,_o,LB,OB,up,cq,iq,nC,rq,sC,AC,Nq,EC,Rq,yr,pE,wE,VE,BO,AO,Aza,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a,Z5a];var ch=[_5a,Ira,Rr,_5a];var dh=[$5a,WA,pq,TE];var eh=[a6a,RE];var fh=[b6a,PA];var gh=[c6a,aj,Qy,fl,hl,nl,Ul,Bo,mq,c6a,c6a,c6a,c6a,c6a,c6a,c6a];var hh=[d6a,wz,qn,xp,Ur,d6a,d6a,d6a];var ih=[e6a,AF];var jh=[f6a,pl];var kh=[g6a,hR,qm,Pz,xA,En,HA,g6a];var lh=[h6a,Fq];var mh=[i6a,ZO,_O,$O,aP,bP,cP,dP,lw,Kw,Ow,xz,Cm,lo,Uo,FB,Ap,ZB,Ep,$B,Np,yq,i6a,i6a,i6a,i6a,i6a,i6a,i6a,i6a,i6a,i6a];var nh=[j6a,ml,no,j6a];var oh=[k6a,$y];var ph=[l6a,Nz];var qh=[m6a,bz];var rh=[n6a,om];var sh=[o6a,Co];var th=[p6a,Py,el,gl,Tl,Ao,lq,p6a];var uh=[q6a,WY,XY,YY,ZY,_Y,$Y,aZ,BZ,CZ,DZ,EZ,FZ,GZ,HZ,IZ,JZ,KZ,LZ,MZ,NZ,OZ,PZ,QZ,RZ,SZ,TZ,UZ,VZ,Gxa,eQa,kQa,LRa,MRa,ORa,SRa,aSa,bSa,dSa,hSa,DVa,GVa,VVa,YVa,wWa,$Wa,OVa,RVa,cWa,fWa,Rv,_i,xw,Aw,Dw,Gw,Jw,$z,Hm,eA,yB,wC,rGa,sGa];var vh=[r6a,oua,cj,kj,at,qt,il,gA,rn,Ho,yp,nq,fr,mr,Vr,HO,GO,JO,IO,LO,KO,NO,MO,PO,OO,RO,QO,TO,SO,VO,UO,XO,WO,dha,cha,bha,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a];var wh=[s6a,Yy];var xh=[t6a,js];var yh=[u6a,QRa,RRa,fSa,gSa,u6a,u6a,u6a];var zh=[v6a,QA];var Ah=[w6a,RY,SY,TY,UY,qU,rU,sU,tU,pN,qN,rN,sN,tN,uN,vN,HP,gP,oP,pP,qP,rP,IP,zP,MP,yP,PP,SP,TP,UP,ZP,_P,$P,jQ,pQ,vQ,yQ,OU,Bva,$Na,oAa,iBa,jBa,kBa,pAa,hBa,SAa,rOa,fQa,lQa,JZa,SZa,p_a,Rj,hj,ej,$v,fk,dw,hk,hw,lk,rw,uk,wk,yk,Ak,Ck,Ek,Gk,Aj,Bj,Ms,Gt,Zt,ou,Fu,Wu,kv,Bv,zl,hz,qz,Nl,Vl,zz,Zl,$l,cm,Dz,im,wm,Am,Bm,Om,iA,Xm,_m,an,dn,kn,nn,An,Cn,FA,Sn,TA,Zn,$n,fo,vo,vB,No,So,DB,ap,fp,jp,SB,wp,Pp,Vp,jC,Yp,kC,eq,gq,kq,Dq,Kq,Pq,Tq,er,zD,KD,$D,vr,mE,xr,Cr,Jr,aF,Xr,DV,PV,FV,RV,EV,QV,TW,$W,cX,fX,iX,mX,Efa,bta,gua,lEa,XEa,YEa,ZEa,_Ea,$Ea,aFa,PFa,RFa,_Fa,$Fa,aGa,bGa,cGa,BGa,AGa,DGa,CGa,EGa,JGa,MGa,LGa,AIa,BIa,CIa,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a];var Bh=[x6a,NM,HM,fP,qS,rS,sS,tS,uS,vS,wS,xS,yS,zS,BY,CY,DY,EY,FY,GY,HY,IY,JY,KY,LY,MY,t9,S9,X9,aaa,faa,kaa,paa,uaa,zaa,Eaa,Jaa,Raa,Paa,Zaa,Xaa,Ega,Fga,Gga,Hga,Iga,Jga,Kga,dia,$ha,Xha,Tha,Pha,Lha,Hha,Dha,zha,vha,hoa,doa,$na,Xna,Tna,Pna,Lna,Hna,Dna,zna,IZa,RZa,o_a,cw,gz,El,Jl,Ml,tz,bm,Cz,hm,Iz,vm,Uz,zm,Yz,Zz,hA,Wm,jn,qA,mn,pn,zn,CA,Bn,EA,Rn,SA,Yn,eo,ZA,ho,AB,Ro,CB,$o,MB,ep,RB,vp,Op,iC,dq,fq,jq,oC,sq,Cq,Jq,BC,Oq,FC,Sq,hD,lE,nE,zr,Br,xE,KE,Qr,EO,DO,Hza,Bza,Iza,WEa,jHa,lHa,mHa,nHa,oHa,pHa,qHa,cIa,dIa,eIa,fIa,gIa,hIa,iIa,jIa,kIa,sJa,rJa,qJa,pJa,oJa,nJa,mJa,tJa,uJa,vJa,wJa,xJa,yJa,zJa,AJa,BJa,CJa,DJa,EJa,FJa,GJa,HJa,IJa,JJa,KJa,LJa,MJa,NJa,OJa,PJa,QJa,lJa,kJa,jJa,XJa,YJa,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a,x6a];var Ch=[y6a,es];var Dh=[z6a,O1,vua,xua,zua,Bua,Dua,Fua,Hua,Nua,sva,Gva,Qva,nCa,qr,sr,ts,z6a,z6a,z6a,z6a,z6a,z6a,z6a,z6a,z6a,z6a,z6a,z6a,z6a,z6a,z6a];var Eh=[A6a,FD,DF,A6a];var Fh=[B6a,iB];var Gh=[C6a,RF,SF,UF,VF,WM,UM,lR,xR,eR,YNa,iV,Z_,M$,x1,s1,Q1,R1,k2,f2,a2,X1,u2,r2,o2,y2,C2,K2,I2,G2,R2,P2,N2,U2,X2,d3,a3,_2,n3,k3,h3,w3,t3,r3,G3,D3,A3,R3,P3,M3,K3,c4,$3,Y3,V3,z4,w4,n4,k4,S4,P4,K4,H4,W4,X4,Y4,Z4,_4,$4,a5,b5,l5,m5,n5,o5,u5,v5,w5,x5,D5,E5,F5,G5,H5,I5,J5,K5,L5,M5,N5,O5,b6,e6,u6,s6,B6,z6,x6,T6,P6,_6,Y6,W6,O7,Q7,S7,W7,Y7,_7,j8,h8,Sfa,Tfa,oga,Pga,Vga,Eka,Jka,Oka,Tka,Yka,gla,mla,sla,yla,Ela,Pla,Vla,$la,fma,lma,uma,wma,yma,Ama,Cma,Lma,Pma,Tma,Yma,bna,ena,Opa,Mpa,kqa,yqa,Cqa,Rqa,mra,Fra,Mra,Pra,Qra,$ra,mta,pta,vta,Ata,Fta,Rta,Zta,mua,nua,pua,rua,tua,Jua,Lua,Uua,cva,jva,kva,mva,nva,ova,qva,Eva,Iva,Kva,Mva,Ova,Sva,Mwa,eAa,Swa,_wa,exa,lxa,txa,Fxa,Mxa,Vxa,aya,hya,mya,_za,fAa,lAa,mAa,nAa,dBa,eBa,IAa,TAa,VAa,XAa,ABa,BBa,DBa,eCa,lCa,pCa,rCa,tCa,vCa,xCa,zCa,BCa,gBa,oOa,DPa,KPa,RPa,YPa,$Ta,aUa,bUa,cUa,eUa,fUa,lUa,mUa,nUa,oUa,qUa,rUa,wUa,xUa,yUa,zUa,BUa,CUa,HUa,IUa,JUa,KUa,MUa,NUa,uVa,zVa,EWa,FWa,GWa,LWa,MWa,NWa,Tj,Uj,Vj,Wj,Xj,Yj,Zj,_j,$j,nj,ok,lj,qj,rj,dj,tj,uj,vj,Cj,Dj,Ej,zj,yj,As,Qs,et,ut,Kt,cu,su,Ku,_u,ov,Yl,em,Nm,Qm,fn,Vn,ao,mo,Jo,Qo,bp,ip,mp,op,rp,Lp,Xp,_p,tq,uC,vC,Aq,Bq,Gq,Iq,Lq,Uq,Vq,Zq,hr,kr,or,XD,ur,Ar,Zr,$r,as,bs,cs,ds,ms,os,ps,qs,rs,ss,us,oT,pT,qT,rT,sT,tT,$T,_T,ZT,YT,XT,WT,VT,UT,TT,ST,RT,QT,PT,OT,NT,MT,LT,KT,JT,IT,HT,GT,FT,ET,DT,CT,BT,AT,zT,yT,xT,wT,vT,uT,oha,pha,lha,mha,nha,pxa,mFa,iFa,IEa,gEa,JDa,kEa,tEa,REa,pFa,TFa,fGa,hGa,tGa,wGa,GGa,VGa,dHa,wHa,zIa,ZJa,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a,C6a];var Hh=[D6a,sP,uP,aw,Vy,yl,Vm,uA,uB,dr,yD,JD,Ir,$E,D6a,D6a];var Ih=[E6a,Xy];var Jh=[F6a,dl,Lm,uo,Jp,F6a,F6a,F6a];var Kh=[G6a,tP,VP,aQ,kQ,qQ,zQ,Rl,dC,ir,ks,G6a,G6a,G6a,G6a,G6a];var Lh=[H6a,Kta];var Mh=[I6a,dp];var Nh=[J6a,Pn];var Oh=[K6a,WI,XI,YI,ZI,_I,$I,aJ,bJ,cJ,dJ,eJ,fJ,gJ,hJ,iJ,jJ,kJ,lJ,mJ,nJ,oJ,pJ,qJ,rJ,sJ,tJ,uJ,vJ,wJ,xJ,yJ,zJ,AJ,BJ,CJ,DJ,EJ,FJ,GJ,HJ,IJ,JJ,KJ,LJ,MJ,NJ,PJ,QJ,RJ,SJ,TJ,UJ,VJ,XJ,YJ,ZJ,_J,$J,aK,bK,cK,dK,eK,fK,gK,hK,iK,jK,kK,lK,mK,nK,oK,pK,qK,rK,sK,tK,uK,vK,wK,xK,yK,zK,AK,BK,CK,DK,EK,FK,GK,HK,IK,JK,KK,LK,MK,NK,OK,PK,QK,RK,UK,VK,WK,XK,YK,ZK,_K,$K,aL,bL,fR,gR,rZ,sZ,tZ,uZ,vZ,wZ,xZ,Fz,Kz,sm,Rz,Vz,Sm,kA,nA,wn,zA,In,JA,UA,sB,Oo,JB,sp,WB,lC,CC,dL,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a,K6a];var Ph=[L6a,Nn];var Qh=[M6a,oz,qC,M6a];var Rh=[N6a,Lw,Pw,_z,ko,dB,EB,YB,Dp,cC,N6a,N6a,N6a,N6a,N6a,N6a];var Sh=[O6a,bD];var Th=[P6a,Mta,gC,eD,HE,Nr,P6a,P6a];var Uh=[Q6a,az];var Vh=[R6a,VD];var Wh=[S6a,cz];var Xh=[T6a,uY,vY,wY,xY,yY,zY,AY,Zda,cea,hea,mea,rea,wea,Bea,Gea,Lea,Qea,Vea,_ea,dfa,zga,Aga,Bga,Cga,Dga,uga,vga,wga,xga,yga,pga,qga,rga,sga,tga,gja,lja,qja,vja,Aja,Fja,Kja,Pja,Uja,Zja,oma,pma,qma,rma,sma,uta,iva,pz,fm,Gz,mm,Lz,tm,Sz,xm,Wz,Tm,gn,oA,rA,xn,AA,Jn,KA,Un,Wn,_A,Fo,tB,Zo,KB,tp,XB,bq,hq,mC,rC,Mq,DC,Qq,oE,V_,U_,T_,S_,R_,Q_,P_,X_,W_,O_,SEa,TEa,OFa,QFa,UFa,VFa,WFa,ZFa,tHa,uHa,T6a,T6a,T6a,T6a,T6a,T6a,T6a,T6a,T6a,T6a,T6a,T6a,T6a,T6a,T6a,T6a,T6a,T6a,T6a,T6a,T6a];var Yh=[U6a,vz];var Zh=[V6a,kz,Hl,Jz,XA,qq,UE,V6a];var _h=[W6a,oG,pG,qG,rG,sG,tG,uG,DG,EG,FG,GG,HG,IG,JG,VG,WG,XG,YG,ZG,_G,$G,iH,jH,kH,lH,mH,nH,oH,xH,yH,zH,AH,BH,CH,DH,MH,NH,OH,PH,QH,RH,SH,UH,VH,WH,XH,YH,ZH,_H,aI,bI,cI,dI,eI,fI,gI,iI,jI,kI,lI,mI,nI,oI,qI,rI,sI,tI,uI,vI,wI,yI,zI,AI,BI,CI,DI,EI,Hla,Ila,Jla,Kla,Lla,_ka,$ka,ala,bla,cla,wka,xka,yka,zka,Aka,rm,Qz,jA,vn,yA,Hn,IA,BB,VB,cG,gG,jG,mG,dO,aO,bO,cO,W6a,W6a,W6a,W6a,W6a,W6a,W6a,W6a,W6a,W6a,W6a,W6a,W6a,W6a,W6a,W6a,W6a,W6a];var $h=[X6a,GP,BP,LP,OP,RP,YP,iQ,oQ,uQ,xQ,iR,QU,RU,cZ,dZ,eZ,fZ,gZ,Fqa,pra,Hra,Bta,fOa,hOa,Vza,Wza,Xza,Kwa,Zza,bAa,cAa,dAa,Xwa,Zwa,cxa,kxa,Cxa,Exa,Kxa,Sxa,Uxa,_xa,gya,qya,rya,zya,Aya,ODa,PDa,QDa,xOa,zOa,GPa,NPa,UPa,$Pa,pWa,rWa,tWa,UWa,WWa,YWa,Lv,Mv,Vv,Xv,Yv,Zv,iw,nk,kw,ow,sw,Hk,Kk,Nk,Qk,Tk,Wk,_k,Sw,Ww,ax,ix,qx,yx,Ax,Ex,Fx,Gx,Px,Tx,by,dy,fy,gy,iy,ky,ry,ty,vy,By,Fy,Jy,Ns,bt,rt,Ht,_t,pu,Gu,Xu,lv,Cv,Ez,Fm,mA,Mn,eB,GB,QB,UB,KC,Yq,ZC,iD,kD,oD,qD,HD,ZD,kE,qE,vE,Dr,OE,WE,fF,gF,jF,vF,FF,qW,rW,sW,tW,uW,SW,WW,_W,bX,eX,hX,lX,vX,wX,xX,yX,zX,Dfa,ata,fua,xFa,NMa,dFa,c$,YGa,XGa,_Ga,ZGa,$Ga,eHa,fHa,gHa,AHa,zHa,BHa,CHa,EHa,DHa,PHa,OHa,RHa,QHa,SHa,YHa,_Ha,$Ha,qIa,pIa,sIa,rIa,vIa,uIa,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a];var ai=[Y6a,cl,sl,vl,Ip,Y6a,Y6a,Y6a];var bi=[Z6a,gB];var ci=[_6a,tn];var di=[$6a,SE];var ei=[a7a,OA];var fi=[b7a,zM,wM,kM,lM,mM,nM,oM,pM,hP,iP,jP,kP,lP,mP,nP,wP,xP,AP,WP,cQ,dQ,rQ,dR,AS,BS,CS,DS,ES,FS,GS,HS,IS,JS,N1,Gqa,Vqa,qra,Cta,Eta,NBa,Sj,ij,gj,Wv,bj,ek,gk,ik,gw,oj,mk,qk,mj,rk,pj,qw,sj,tk,vk,xk,zk,Bk,Dk,Fk,Tw,Xw,bx,jx,rx,zx,Bx,Qx,Ux,cy,ey,xj,sy,uy,wy,Cy,Gy,Ky,Ls,Bs,Ds,Rs,Ts,ft,ht,Ft,vt,xt,Yt,Lt,Nt,nu,du,fu,Eu,tu,vu,Vu,Lu,Nu,jv,$u,bv,Av,pv,rv,Al,Kl,Ol,Wl,Xl,Az,_l,am,dm,Pm,Rm,Ym,$m,bn,en,ln,sn,Dn,Tn,_n,oo,ro,to,wo,Io,wB,Ko,Po,To,cp,gp,hp,kp,lp,np,pp,qp,zp,Mp,Wp,Zp,$p,aq,oq,tC,yC,Eq,Hq,aD,jD,lD,pD,rD,gr,AD,nr,TD,tr,wr,Wr,Yr,lF,mF,wF,ON,NN,QN,PN,JV,SV,LV,UV,KV,TV,fha,eha,kka,gka,hka,ika,jka,qka,mka,nka,oka,pka,bFa,cEa,LEa,sEa,MIa,LIa,KIa,JIa,IIa,HIa,GIa,NIa,OIa,PIa,QIa,RIa,SIa,TIa,UIa,VIa,WIa,XIa,YIa,ZIa,_Ia,$Ia,aJa,bJa,cJa,dJa,eJa,fJa,gJa,hJa,iJa,FIa,EIa,DIa,b7a,b7a,b7a,b7a,b7a,b7a,b7a,b7a,b7a,b7a,b7a,b7a,b7a,b7a,b7a,b7a,b7a,b7a,b7a,b7a,b7a];var gi=[c7a,d7a,zZa,UZa];var hi=[e7a,Zw,fx,nx,vx,Dx,Kx,Ox,Wx,_x,qy,Ay,Iy,$s,pt,Mm,Kp,nD,jr,YD,ls,IF,MV,OV,NV,e7a,e7a,e7a,e7a,e7a,e7a,e7a];var ii=[f7a,gs];var ji=[g7a,eC,FE,Lr];var ki=[h7a,OF,PF,QF,fM,AM,xM,yM,SK,hM,iM,CM,OM,IM,JM,EM,FM,ZU,VM,TM,eP,FP,KP,NP,QP,XP,hQ,nQ,tQ,wQ,mR,nR,oR,cR,uR,OOa,POa,QOa,ROa,JU,SU,TU,UU,LU,MU,dV,eV,hV,xV,yV,EOa,FOa,GOa,HOa,wW,xW,yW,zW,Y_,e$,f$,h$,i$,J$,K$,v1,w1,r1,L1,M1,S1,J1,K1,i2,j2,g2,h2,d2,e2,b2,c2,_1,$1,Y1,Z1,V1,W1,T1,U1,t2,q2,n2,x2,B2,J2,H2,F2,Q2,O2,M2,T2,W2,c3,$2,Z2,m3,j3,g3,v3,s3,q3,F3,C3,z3,Q3,O3,L3,J3,b4,_3,X3,U3,y4,v4,m4,j4,R4,O4,J4,G4,j5,i5,h5,g5,f5,e5,d5,c5,s5,r5,q5,p5,B5,A5,z5,y5,_5,Z5,Y5,X5,W5,V5,U5,T5,S5,R5,Q5,P5,a6,d6,t6,r6,A6,y6,w6,S6,O6,Z6,X6,V6,e7,f7,M7,N7,K7,P7,I7,R7,U7,V7,F7,X7,D7,Z7,i8,g8,g9,h9,i9,j9,k9,l9,m9,n9,o9,p9,Saa,Taa,Kaa,Laa,Faa,Gaa,Aaa,Baa,vaa,waa,qaa,raa,laa,maa,gaa,haa,baa,caa,Y9,Z9,T9,U9,O9,P9,Q9,R9,V9,W9,_9,$9,daa,eaa,iaa,jaa,naa,oaa,saa,taa,xaa,yaa,Caa,Daa,Haa,Iaa,Naa,Qaa,Oaa,Vaa,Yaa,Waa,Ada,Bda,yda,zda,wda,xda,uda,vda,sda,tda,qda,rda,oda,pda,mda,nda,kda,lda,gda,hda,Xca,Yca,Mca,Nca,Fca,Gca,yca,zca,rca,sca,kca,lca,dca,eca,Xba,Yba,Qba,Rba,Jba,Kba,Cba,Dba,vba,wba,xba,Aba,yba,Eba,Hba,Fba,Lba,Oba,Mba,Sba,Vba,Tba,_ba,bca,$ba,fca,ica,gca,mca,pca,nca,tca,wca,uca,Aca,Dca,Bca,Hca,Kca,Ica,Pca,Sca,Qca,Vca,_ca,bda,$ca,eda,ida,Dda,Eda,$ea,afa,Wea,Xea,Rea,Sea,Mea,Nea,Hea,Iea,Cea,Dea,xea,yea,sea,tea,nea,oea,iea,jea,dea,eea,_da,$da,Vda,Wda,Xda,Yda,aea,bea,fea,gea,kea,lea,pea,qea,uea,vea,zea,Aea,Eea,Fea,Jea,Kea,Oea,Pea,Tea,Uea,Yea,Zea,bfa,cfa,Vfa,Ufa,hga,iga,nga,Nga,Oga,Tga,Uga,cia,aia,bia,_ha,Yha,Zha,Wha,Uha,Vha,Sha,Qha,Rha,Oha,Mha,Nha,Kha,Iha,Jha,Gha,Eha,Fha,Cha,Aha,Bha,yha,wha,xha,uha,sha,tha,Ria,Pia,Qia,Nia,Lia,Mia,Jia,Hia,Iia,Fia,Dia,Eia,Bia,zia,Aia,xia,via,wia,tia,ria,sia,pia,nia,oia,lia,jia,kia,hia,fia,gia,Vja,Wja,Qja,Rja,Lja,Mja,Gja,Hja,Bja,Cja,wja,xja,rja,sja,mja,nja,hja,ija,cja,dja,eja,fja,jja,kja,oja,pja,tja,uja,yja,zja,Dja,Eja,Ija,Jja,Nja,Oja,Sja,Tja,Xja,Yja,Cka,Dka,Hka,Ika,Mka,Nka,Rka,Ska,Wka,Xka,ela,fla,kla,lla,qla,rla,wla,xla,Cla,Dla,Nla,Ola,Tla,Ula,Zla,_la,dma,ema,jma,kma,tma,vma,xma,zma,Bma,Jma,Kma,Nma,Oma,Rma,Sma,Wma,Xma,$ma,ana,tka,dna,goa,eoa,foa,coa,aoa,boa,_na,Yna,Zna,Wna,Una,Vna,Sna,Qna,Rna,Ona,Mna,Nna,Kna,Ina,Jna,Gna,Ena,Fna,Cna,Ana,Bna,yna,wna,xna,ypa,zpa,Bpa,wpa,xpa,rpa,spa,upa,ppa,qpa,lpa,mpa,opa,jpa,kpa,fpa,gpa,ipa,dpa,epa,$oa,apa,cpa,Zoa,_oa,Voa,Woa,Yoa,Toa,Uoa,Poa,Qoa,Soa,Noa,Ooa,Joa,Koa,Moa,Hoa,Ioa,Doa,Eoa,Goa,Boa,Coa,xoa,yoa,Aoa,voa,woa,roa,soa,uoa,poa,qoa,loa,moa,ooa,joa,koa,Npa,Lpa,iqa,jqa,vqa,wqa,Dqa,Hqa,Mqa,Nqa,Oqa,Pqa,Wqa,bra,cra,hra,ira,fra,gra,jra,kra,rra,vra,wra,zra,Ara,xra,yra,Dra,Era,Zra,_ra,osa,psa,Rsa,Ssa,lta,kta,ota,sta,tta,yta,zta,Pta,Qta,Xta,Yta,kua,lua,Tua,Xua,Yua,bva,hva,fva,gva,Ava,Cva,yva,zva,twa,uwa,rwa,swa,pwa,qwa,nwa,owa,lwa,mwa,jwa,kwa,hwa,iwa,fwa,gwa,dwa,ewa,bwa,cwa,$va,awa,Zva,_va,Cwa,Dwa,Gwa,Hwa,Pwa,Qwa,gAa,Uwa,Vwa,axa,bxa,hxa,ixa,qxa,rxa,zxa,Axa,Hxa,Ixa,Jxa,Pxa,Qxa,Yxa,Zxa,dya,eya,jya,kya,oya,pya,sya,tya,uya,vya,wya,xya,yya,Bya,Cya,Dya,Eya,Fya,Gya,Hya,Iya,Owa,Uza,$za,aAa,jAa,kAa,vAa,wAa,zAa,AAa,QAa,RAa,OAa,PAa,GAa,HAa,xBa,yBa,zBa,EBa,LBa,XBa,YBa,fCa,gCa,cCa,dCa,bBa,cBa,HCa,ICa,SNa,UNa,WNa,XNa,mOa,nOa,JOa,KOa,LOa,MOa,TOa,UOa,VOa,WOa,BPa,CPa,IPa,JPa,PPa,QPa,WPa,XPa,bQa,cQa,dQa,iQa,jQa,oQa,pQa,iRa,jRa,JRa,KRa,_Ra,$Ra,mSa,nSa,ZSa,_Sa,LTa,MTa,RTa,STa,XTa,YTa,hUa,iUa,sUa,tUa,DUa,EUa,OUa,PUa,XUa,YUa,eVa,fVa,kVa,lVa,qVa,rVa,vVa,wVa,hQa,LVa,AVa,_Va,$Va,kWa,lWa,nWa,oWa,AWa,BWa,HWa,IWa,OWa,PWa,aXa,bXa,cXa,CZa,DZa,EZa,FZa,PZa,_Za,$Za,e_a,f_a,h_a,k_a,m_a,Hv,Rw,Vw,$w,dx,hx,lx,px,tx,xx,Ix,Mx,Sx,Yx,ay,al,Fj,oy,yy,Ey,Is,Ys,mt,Ct,Ut,ku,Bu,Su,gv,xv,uq,vq,HC,Wq,PC,RC,iua,jua,vD,CD,lr,OD,QD,rr,dE,fE,hE,sE,BE,DE,cF,_r,qF,sF,ns,MF,xU,GV,VV,IV,XV,HV,WV,QW,VW,YW,I0,V0,x0,kX,t$,b0,i1,Cfa,$sa,eua,Wva,cFa,PYa,mxa,nxa,HFa,d$,vxa,xxa,MEa,PEa,QYa,fEa,dEa,nEa,oEa,pEa,qEa,rEa,zEa,AEa,BEa,VEa,jFa,lFa,nFa,qFa,uFa,vFa,wFa,AFa,KFa,LFa,NFa,YFa,eGa,gGa,iGa,qGa,uGa,xGa,yGa,HGa,KGa,NGa,WGa,iHa,kHa,sHa,yHa,xHa,NHa,VHa,WHa,bIa,mIa,oIa,wPa,IQa,KQa,_Ya,DSa,FSa,HSa,qZa,pTa,rTa,tTa,SUa,eKa,VZa,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a,h7a];var li=[i7a,Mz];var mi=[j7a,TF,jR,kR,aOa,bOa,PU,eOa,gV,g$,L$,zqa,Sqa,nra,Gra,Lra,Nra,Ora,qua,sua,Iua,Kua,lva,pva,Dva,Hva,Jva,Lva,Nva,Rva,dOa,Iwa,Jwa,Lwa,Yza,Wwa,Ywa,jxa,Bxa,Dxa,Rxa,Txa,fya,fBa,mBa,nBa,oBa,UAa,WAa,YAa,CBa,MBa,iCa,jCa,kCa,mCa,qCa,sCa,uCa,wCa,yCa,ACa,CCa,lKa,sOa,tOa,vOa,wOa,EPa,LPa,SPa,TPa,ZPa,_Pa,oSa,vSa,wSa,xSa,ySa,zSa,ASa,BSa,$Sa,gTa,hTa,iTa,jTa,kTa,lTa,mTa,ZTa,_Ta,dUa,jUa,kUa,pUa,uUa,vUa,AUa,FUa,GUa,LUa,EVa,FVa,HVa,WVa,XVa,ZVa,CWa,DWa,JWa,KWa,PVa,QVa,SVa,dWa,eWa,gWa,a_a,Gv,Jv,Kv,ak,bk,ck,dk,jk,kk,pk,sk,jy,wj,my,Hs,Ks,Cs,Xs,_s,Ss,lt,ot,gt,Bt,Et,wt,Tt,Xt,Mt,ju,mu,eu,Au,Du,uu,Ru,Uu,Mu,fv,iv,av,wv,zv,qv,Zm,so,Wo,GC,IC,JC,LC,MC,OC,QC,VC,YC,$C,uD,wD,xD,BD,DD,ED,ID,LD,ND,PD,RD,SD,WD,aE,cE,eE,gE,iE,jE,rE,tE,uE,yE,AE,CE,ME,NE,Usa,bF,dF,eF,kF,nF,pF,rF,tF,uF,GF,JF,LF,PW,RW,XW,ZW,aX,J0,dX,Z0,gX,y0,jX,C0,Bfa,Ffa,_sa,cta,dua,hua,GMa,NYa,dGa,oxa,HEa,gFa,fFa,wxa,KEa,OYa,xKa,kFa,oFa,tFa,BFa,CFa,DFa,EFa,XHa,ZHa,j7a,j7a];var ni=[k7a,mz,hO,eO,fO,gO,k7a,k7a];var oi=[l7a,Ql];var pi=[m7a,jz,Gl,m7a];var qi=[n7a,vP,bQ,lQ,wA,n7a,n7a,n7a];var ri=[o7a,Nta,Um,tA,Up,cr,Hr,_E];var si=[p7a,yo,Eo,aC];var ti=[q7a,fs];var ui=[r7a,ZNa,cOa,gOa,xqa,Aqa,Bqa,Qqa,Tqa,lra,ora,Dta,Rwa,dxa,sxa,Lxa,$xa,lya,mKa,nKa,sKa,uKa,LLa,pOa,uOa,yOa,FPa,MPa,gQa,mQa,sVa,xVa,qWa,sWa,vWa,QWa,VWa,XWa,_Wa,GZa,g_a,i_a,l_a,Nv,Ov,Uv,bw,fw,jw,nw,pw,tw,vw,Ik,yw,Lk,Bw,Ok,Ew,Rk,Hw,Uk,Xk,$k,hy,Os,Es,ct,Us,st,it,It,yt,$t,Ot,qu,gu,Hu,wu,Yu,Ou,mv,cv,Dv,sv,Em,bA,Ln,MA,hB,kB,xB,Mo,PB,TB,xq,Xq,TC,EE,iF,IX,hFa,hEa,IDa,kGa,lGa,UMa,r7a,r7a,r7a,r7a,r7a,r7a,r7a,r7a,r7a,r7a,r7a,r7a,r7a,r7a,r7a,r7a,r7a,r7a,r7a,r7a,r7a];var vi=[s7a,po];var wi=[t7a,nB];var xi=[u7a,GD,EF,u7a];var yi=[v7a,Tp,br,Gr,ZE,v7a,v7a,v7a];var zi=[w7a,Mw,Nw,jo,cB,_B,w7a,w7a];var Ai=[x7a,NB];var Bi=[y7a,WC];var Ci=[z7a];var Di=[A7a,iz,Fl,A7a];var Ei=[B7a,BF];var Fi=[C7a,yF];var Gi=[D7a,Iv,Qw,Uw,_w,cx,gx,kx,ox,sx,wx,Hx,Lx,Rx,Xx,$x,ny,xy,Dy,Js,Zs,nt,Dt,Wt,lu,Cu,Tu,hv,yv,NC,UC,MD,bE,zE,LE,oF,KF,D7a,D7a,D7a,D7a,D7a,D7a,D7a,D7a,D7a,D7a,D7a,D7a,D7a,D7a,D7a,D7a,D7a,D7a,D7a,D7a,D7a,D7a,D7a,D7a,D7a,D7a,D7a];var Hi=[E7a,CF];var Ii=[F7a,io,bB,Yo];var Ji=[G7a,zF];var Ki=[H7a,Pl];var Li=[I7a,PE];var Mi=[J7a,fC,GE,Mr];var Ni=[K7a,qo];var Oi=[L7a,vR,uSa,fTa,BVa,CVa,TVa,UVa,MVa,NVa,aWa,bWa,L7a,L7a,L7a,L7a];var Pi=[M7a,uz];var Qi=[N7a,dD];var Ri=[O7a,_v,Sy,Uy,_y,xl,O7a,O7a];var Si=[P7a,vA];return{__GLOBAL__sub_I_color_stdout_sajjad_ZBOX_ID88_ID89_ID90_15060_1vwvIh_ii:l2,__GLOBAL__sub_I_haar_stdout_sajjad_ZBOX_ID88_ID89_ID90_15944_tWdK1p_ii:Zsa,stackSave:Ui,getTempRet0:Zi,_llvm_cttz_i32:N1a,setThrew:Xi,_bitshift64Lshr:I1a,_bitshift64Shl:R1a,_sbrk:L1a,_pthread_cond_broadcast:J1a,_fflush:IMa,___cxa_is_pointer_type:z1a,__GLOBAL__sub_I_bindings_stdout_sajjad_ZBOX_ID88_ID89_ID90_18140_mHXJkG_ii:NF,_bitshift64Ashr:H1a,_memset:F1a,___cxa_demangle:t_a,_memcpy:K1a,___errno_location:pKa,___muldi3:W1a,___uremdi3:P1a,___divdi3:S1a,stackAlloc:Ti,_i64Subtract:B1a,__GLOBAL__sub_I_bind_cpp:aKa,___udivmoddi4:O1a,setTempRet0:Yi,_realloc:fKa,_i64Add:C1a,_pthread_mutex_unlock:D1a,__GLOBAL__I_000101:sPa,__GLOBAL__sub_I_loadsave_stdout_sajjad_ZBOX_ID88_ID89_ID90_32009_2MzGIi_ii:Uva,_emscripten_get_global_libc:kKa,___getTypeName:cKa,__GLOBAL__sub_I_persistenc_stdout_sajjad_ZBOX_ID88_ID89_ID90_14771_dTJ5vw_ii:OW,__GLOBAL__sub_I_iostream_cpp:tPa,__GLOBAL__sub_I_umatrix_stdout_sajjad_ZBOX_ID88_ID89_ID90_14943_RiHQee_ii:a0,___udivdi3:U1a,_llvm_bswap_i32:Q1a,runPostSets:A1a,___muldsi3:V1a,_testSetjmp:T1a,_saveSetjmp:G1a,__GLOBAL__sub_I_hog_stdout_sajjad_ZBOX_ID88_ID89_ID90_15935_Hps2Hq_ii:cua,_free:eKa,___cxa_can_catch:y1a,establishStackSpace:Wi,_memmove:M1a,stackRestore:Vi,_malloc:dKa,_pthread_mutex_lock:E1a,__GLOBAL__sub_I_histogram_stdout_sajjad_ZBOX_ID88_ID89_ID90_15407_4w9Dw7_ii:Afa,_emscripten_replace_memory:Wf,__GLOBAL__sub_I_imgwarp_stdout_sajjad_ZBOX_ID88_ID89_ID90_15452_bOwam9_ii:kga,__GLOBAL__sub_I_system_stdout_sajjad_ZBOX_ID88_ID89_ID90_18069_ku7LVV_ii:q$,stackAlloc:Ti,stackSave:Ui,stackRestore:Vi,establishStackSpace:Wi,setThrew:Xi,setTempRet0:Yi,getTempRet0:Zi,dynCall_iiiiiid:X1a,dynCall_viiiiddd:Y1a,dynCall_viiiidiii:Z1a,dynCall_viiiiiddi:_1a,dynCall_viiidiii:$1a,dynCall_viiiidiid:a2a,dynCall_iiiiiii:b2a,dynCall_viiiidddiiii:c2a,dynCall_viiiiddi:d2a,dynCall_viiiddddi:e2a,dynCall_viidiii:f2a,dynCall_viiiiiiiiiii:g2a,dynCall_viiiiiiiiiid:h2a,dynCall_viiidddd:i2a,dynCall_iidi:j2a,dynCall_viiddidd:k2a,dynCall_vidi:l2a,dynCall_viiddii:m2a,dynCall_viiddid:n2a,dynCall_viiiiidi:o2a,dynCall_viiddidddd:p2a,dynCall_viiiiddiiii:q2a,dynCall_viiiiiiidd:r2a,dynCall_viiiiddiiid:s2a,dynCall_viiiiiiidi:t2a,dynCall_viiiddii:u2a,dynCall_viiidii:v2a,dynCall_viiiiidd:w2a,dynCall_di:x2a,dynCall_viiiiiidiiii:y2a,dynCall_viiiidiiddi:z2a,dynCall_viiiiddiiiid:A2a,dynCall_viiiiddiii:B2a,dynCall_vdii:C2a,dynCall_diiiiiii:D2a,dynCall_dii:E2a,dynCall_viiiddiiii:F2a,dynCall_viiiddiiid:G2a,dynCall_viiiidiidd:H2a,dynCall_viiiiiiiiiiddi:I2a,dynCall_iiiii:J2a,dynCall_viiiiidiiiii:K2a,dynCall_viiidddi:L2a,dynCall_viiiiidiidd:M2a,dynCall_iiiid:N2a,dynCall_iiiiiiii:O2a,dynCall_viiddiii:P2a,dynCall_iiiiiiiididiii:Q2a,dynCall_viiidddiii:R2a,dynCall_viidiiid:S2a,dynCall_viiiidiiii:T2a,dynCall_viidiiii:U2a,dynCall_diiiddi:V2a,dynCall_viiididii:W2a,dynCall_diiiiiiii:X2a,dynCall_viiidiiid:Y2a,dynCall_viiiddddii:Z2a,dynCall_iiidiiiiiii:_2a,dynCall_viiiiid:$2a,dynCall_viiiiddddii:a3a,dynCall_viiiiii:b3a,dynCall_viiidiiii:c3a,dynCall_viiiiiidi:d3a,dynCall_viiiiiidiii:e3a,dynCall_viiiidddii:f3a,dynCall_viiidd:g3a,dynCall_viiidi:h3a,dynCall_iiidiiii:i3a,dynCall_viiddiddd:j3a,dynCall_viiiiiiiiii:k3a,dynCall_diiddi:l3a,dynCall_diii:m3a,dynCall_viiiddd:n3a,dynCall_viiiddidddd:o3a,dynCall_viiiiiiiiiiid:p3a,dynCall_viiiddidd:q3a,dynCall_viiidiiiidi:r3a,dynCall_viiiddiiiid:s3a,dynCall_viiiddi:t3a,dynCall_iiiiii:u3a,dynCall_viiid:v3a,dynCall_viiiidddd:w3a,dynCall_viidii:x3a,dynCall_iiiiid:y3a,dynCall_viiiidddi:z3a,dynCall_viiii:A3a,dynCall_viiiii:B3a,dynCall_viidiiiiiii:C3a,dynCall_vid:D3a,dynCall_iiidi:E3a,dynCall_iiidd:F3a,dynCall_vii:G3a,dynCall_viiiid:H3a,dynCall_viiiiddddi:I3a,dynCall_viidd:J3a,dynCall_viidi:K3a,dynCall_viiidiiddi:L3a,dynCall_diiid:M3a,dynCall_viiidddii:N3a,dynCall_viiiiiiii:O3a,dynCall_viiidddiiii:P3a,dynCall_viiiiiiid:Q3a,dynCall_diiii:R3a,dynCall_viiiiidiiddi:S3a,dynCall_viiiiidii:T3a,dynCall_viiiddiddd:U3a,dynCall_iid:V3a,dynCall_viiiddid:W3a,dynCall_viiiiiii:X3a,dynCall_viididdi:Y3a,dynCall_viiiiiid:Z3a,dynCall_viiiiiiiii:_3a,dynCall_iii:$3a,dynCall_viiddi:a4a,dynCall_viiididi:b4a,dynCall_vdiii:c4a,dynCall_viiiiiidii:d4a,dynCall_viiiidddiii:e4a,dynCall_viii:f4a,dynCall_v:g4a,dynCall_viid:h4a,dynCall_viidiiiii:i4a,dynCall_viiiiidiiii:j4a,dynCall_vi:k4a,dynCall_viiiidiiiidi:l4a,dynCall_ii:m4a,dynCall_viiiiiiiddi:n4a,dynCall_vididdi:o4a,dynCall_viiiiiidd:p4a,dynCall_vidii:q4a,dynCall_viiiidi:r4a,dynCall_viiiddiii:s4a,dynCall_viidiiiiii:t4a,dynCall_iiii:u4a,dynCall_viididii:v4a,dynCall_viiiiddii:w4a,dynCall_iiid:x4a,dynCall_viiiidii:y4a,dynCall_diiiii:z4a,dynCall_diiiid:A4a,dynCall_iiiiiiiiiiiii:B4a,dynCall_iiiiiiiiiiiiiii:C4a,dynCall_viiiiiiddi:D4a,dynCall_iiidiii:E4a,dynCall_iiidiiiiii:F4a,dynCall_i:G4a,dynCall_iiidii:H4a,dynCall_diiiiii:I4a,dynCall_iiidiiiii:J4a,dynCall_vididdii:K4a,dynCall_viiiiiidiiiii:L4a,dynCall_viiiiidiii:M4a,dynCall_viididi:N4a,dynCall_iiiiiiiii:O4a,dynCall_viididdii:P4a,dynCall_viiiiidiid:Q4a,dynCall_viiiidd:R4a,dynCall_vidiii:S4a}})


// EMSCRIPTEN_END_ASM
(Module.asmGlobalArg,Module.asmLibraryArg,buffer);var __GLOBAL__sub_I_color_stdout_sajjad_ZBOX_ID88_ID89_ID90_15060_1vwvIh_ii=Module["__GLOBAL__sub_I_color_stdout_sajjad_ZBOX_ID88_ID89_ID90_15060_1vwvIh_ii"]=asm["__GLOBAL__sub_I_color_stdout_sajjad_ZBOX_ID88_ID89_ID90_15060_1vwvIh_ii"];var __GLOBAL__sub_I_haar_stdout_sajjad_ZBOX_ID88_ID89_ID90_15944_tWdK1p_ii=Module["__GLOBAL__sub_I_haar_stdout_sajjad_ZBOX_ID88_ID89_ID90_15944_tWdK1p_ii"]=asm["__GLOBAL__sub_I_haar_stdout_sajjad_ZBOX_ID88_ID89_ID90_15944_tWdK1p_ii"];var stackSave=Module["stackSave"]=asm["stackSave"];var getTempRet0=Module["getTempRet0"]=asm["getTempRet0"];var _llvm_cttz_i32=Module["_llvm_cttz_i32"]=asm["_llvm_cttz_i32"];var setThrew=Module["setThrew"]=asm["setThrew"];var _bitshift64Lshr=Module["_bitshift64Lshr"]=asm["_bitshift64Lshr"];var _bitshift64Shl=Module["_bitshift64Shl"]=asm["_bitshift64Shl"];var _sbrk=Module["_sbrk"]=asm["_sbrk"];var _pthread_cond_broadcast=Module["_pthread_cond_broadcast"]=asm["_pthread_cond_broadcast"];var _fflush=Module["_fflush"]=asm["_fflush"];var ___cxa_is_pointer_type=Module["___cxa_is_pointer_type"]=asm["___cxa_is_pointer_type"];var __GLOBAL__sub_I_bindings_stdout_sajjad_ZBOX_ID88_ID89_ID90_18140_mHXJkG_ii=Module["__GLOBAL__sub_I_bindings_stdout_sajjad_ZBOX_ID88_ID89_ID90_18140_mHXJkG_ii"]=asm["__GLOBAL__sub_I_bindings_stdout_sajjad_ZBOX_ID88_ID89_ID90_18140_mHXJkG_ii"];var _bitshift64Ashr=Module["_bitshift64Ashr"]=asm["_bitshift64Ashr"];var _memset=Module["_memset"]=asm["_memset"];var ___cxa_demangle=Module["___cxa_demangle"]=asm["___cxa_demangle"];var _memcpy=Module["_memcpy"]=asm["_memcpy"];var ___errno_location=Module["___errno_location"]=asm["___errno_location"];var ___muldi3=Module["___muldi3"]=asm["___muldi3"];var ___uremdi3=Module["___uremdi3"]=asm["___uremdi3"];var ___divdi3=Module["___divdi3"]=asm["___divdi3"];var stackAlloc=Module["stackAlloc"]=asm["stackAlloc"];var _i64Subtract=Module["_i64Subtract"]=asm["_i64Subtract"];var __GLOBAL__sub_I_bind_cpp=Module["__GLOBAL__sub_I_bind_cpp"]=asm["__GLOBAL__sub_I_bind_cpp"];var ___udivmoddi4=Module["___udivmoddi4"]=asm["___udivmoddi4"];var setTempRet0=Module["setTempRet0"]=asm["setTempRet0"];var _realloc=Module["_realloc"]=asm["_realloc"];var _i64Add=Module["_i64Add"]=asm["_i64Add"];var _pthread_mutex_unlock=Module["_pthread_mutex_unlock"]=asm["_pthread_mutex_unlock"];var __GLOBAL__I_000101=Module["__GLOBAL__I_000101"]=asm["__GLOBAL__I_000101"];var __GLOBAL__sub_I_loadsave_stdout_sajjad_ZBOX_ID88_ID89_ID90_32009_2MzGIi_ii=Module["__GLOBAL__sub_I_loadsave_stdout_sajjad_ZBOX_ID88_ID89_ID90_32009_2MzGIi_ii"]=asm["__GLOBAL__sub_I_loadsave_stdout_sajjad_ZBOX_ID88_ID89_ID90_32009_2MzGIi_ii"];var _emscripten_get_global_libc=Module["_emscripten_get_global_libc"]=asm["_emscripten_get_global_libc"];var ___getTypeName=Module["___getTypeName"]=asm["___getTypeName"];var __GLOBAL__sub_I_persistenc_stdout_sajjad_ZBOX_ID88_ID89_ID90_14771_dTJ5vw_ii=Module["__GLOBAL__sub_I_persistenc_stdout_sajjad_ZBOX_ID88_ID89_ID90_14771_dTJ5vw_ii"]=asm["__GLOBAL__sub_I_persistenc_stdout_sajjad_ZBOX_ID88_ID89_ID90_14771_dTJ5vw_ii"];var __GLOBAL__sub_I_iostream_cpp=Module["__GLOBAL__sub_I_iostream_cpp"]=asm["__GLOBAL__sub_I_iostream_cpp"];var __GLOBAL__sub_I_umatrix_stdout_sajjad_ZBOX_ID88_ID89_ID90_14943_RiHQee_ii=Module["__GLOBAL__sub_I_umatrix_stdout_sajjad_ZBOX_ID88_ID89_ID90_14943_RiHQee_ii"]=asm["__GLOBAL__sub_I_umatrix_stdout_sajjad_ZBOX_ID88_ID89_ID90_14943_RiHQee_ii"];var ___udivdi3=Module["___udivdi3"]=asm["___udivdi3"];var _llvm_bswap_i32=Module["_llvm_bswap_i32"]=asm["_llvm_bswap_i32"];var runPostSets=Module["runPostSets"]=asm["runPostSets"];var ___muldsi3=Module["___muldsi3"]=asm["___muldsi3"];var _testSetjmp=Module["_testSetjmp"]=asm["_testSetjmp"];var _saveSetjmp=Module["_saveSetjmp"]=asm["_saveSetjmp"];var __GLOBAL__sub_I_hog_stdout_sajjad_ZBOX_ID88_ID89_ID90_15935_Hps2Hq_ii=Module["__GLOBAL__sub_I_hog_stdout_sajjad_ZBOX_ID88_ID89_ID90_15935_Hps2Hq_ii"]=asm["__GLOBAL__sub_I_hog_stdout_sajjad_ZBOX_ID88_ID89_ID90_15935_Hps2Hq_ii"];var _free=Module["_free"]=asm["_free"];var ___cxa_can_catch=Module["___cxa_can_catch"]=asm["___cxa_can_catch"];var establishStackSpace=Module["establishStackSpace"]=asm["establishStackSpace"];var _memmove=Module["_memmove"]=asm["_memmove"];var stackRestore=Module["stackRestore"]=asm["stackRestore"];var _malloc=Module["_malloc"]=asm["_malloc"];var _pthread_mutex_lock=Module["_pthread_mutex_lock"]=asm["_pthread_mutex_lock"];var __GLOBAL__sub_I_histogram_stdout_sajjad_ZBOX_ID88_ID89_ID90_15407_4w9Dw7_ii=Module["__GLOBAL__sub_I_histogram_stdout_sajjad_ZBOX_ID88_ID89_ID90_15407_4w9Dw7_ii"]=asm["__GLOBAL__sub_I_histogram_stdout_sajjad_ZBOX_ID88_ID89_ID90_15407_4w9Dw7_ii"];var _emscripten_replace_memory=Module["_emscripten_replace_memory"]=asm["_emscripten_replace_memory"];var __GLOBAL__sub_I_imgwarp_stdout_sajjad_ZBOX_ID88_ID89_ID90_15452_bOwam9_ii=Module["__GLOBAL__sub_I_imgwarp_stdout_sajjad_ZBOX_ID88_ID89_ID90_15452_bOwam9_ii"]=asm["__GLOBAL__sub_I_imgwarp_stdout_sajjad_ZBOX_ID88_ID89_ID90_15452_bOwam9_ii"];var __GLOBAL__sub_I_system_stdout_sajjad_ZBOX_ID88_ID89_ID90_18069_ku7LVV_ii=Module["__GLOBAL__sub_I_system_stdout_sajjad_ZBOX_ID88_ID89_ID90_18069_ku7LVV_ii"]=asm["__GLOBAL__sub_I_system_stdout_sajjad_ZBOX_ID88_ID89_ID90_18069_ku7LVV_ii"];var dynCall_iiiiiid=Module["dynCall_iiiiiid"]=asm["dynCall_iiiiiid"];var dynCall_viiiiddd=Module["dynCall_viiiiddd"]=asm["dynCall_viiiiddd"];var dynCall_viiiidiii=Module["dynCall_viiiidiii"]=asm["dynCall_viiiidiii"];var dynCall_viiiiiddi=Module["dynCall_viiiiiddi"]=asm["dynCall_viiiiiddi"];var dynCall_viiidiii=Module["dynCall_viiidiii"]=asm["dynCall_viiidiii"];var dynCall_viiiidiid=Module["dynCall_viiiidiid"]=asm["dynCall_viiiidiid"];var dynCall_iiiiiii=Module["dynCall_iiiiiii"]=asm["dynCall_iiiiiii"];var dynCall_viiiidddiiii=Module["dynCall_viiiidddiiii"]=asm["dynCall_viiiidddiiii"];var dynCall_viiiiddi=Module["dynCall_viiiiddi"]=asm["dynCall_viiiiddi"];var dynCall_viiiddddi=Module["dynCall_viiiddddi"]=asm["dynCall_viiiddddi"];var dynCall_viidiii=Module["dynCall_viidiii"]=asm["dynCall_viidiii"];var dynCall_viiiiiiiiiii=Module["dynCall_viiiiiiiiiii"]=asm["dynCall_viiiiiiiiiii"];var dynCall_viiiiiiiiiid=Module["dynCall_viiiiiiiiiid"]=asm["dynCall_viiiiiiiiiid"];var dynCall_viiidddd=Module["dynCall_viiidddd"]=asm["dynCall_viiidddd"];var dynCall_iidi=Module["dynCall_iidi"]=asm["dynCall_iidi"];var dynCall_viiddidd=Module["dynCall_viiddidd"]=asm["dynCall_viiddidd"];var dynCall_vidi=Module["dynCall_vidi"]=asm["dynCall_vidi"];var dynCall_viiddii=Module["dynCall_viiddii"]=asm["dynCall_viiddii"];var dynCall_viiddid=Module["dynCall_viiddid"]=asm["dynCall_viiddid"];var dynCall_viiiiidi=Module["dynCall_viiiiidi"]=asm["dynCall_viiiiidi"];var dynCall_viiddidddd=Module["dynCall_viiddidddd"]=asm["dynCall_viiddidddd"];var dynCall_viiiiddiiii=Module["dynCall_viiiiddiiii"]=asm["dynCall_viiiiddiiii"];var dynCall_viiiiiiidd=Module["dynCall_viiiiiiidd"]=asm["dynCall_viiiiiiidd"];var dynCall_viiiiddiiid=Module["dynCall_viiiiddiiid"]=asm["dynCall_viiiiddiiid"];var dynCall_viiiiiiidi=Module["dynCall_viiiiiiidi"]=asm["dynCall_viiiiiiidi"];var dynCall_viiiddii=Module["dynCall_viiiddii"]=asm["dynCall_viiiddii"];var dynCall_viiidii=Module["dynCall_viiidii"]=asm["dynCall_viiidii"];var dynCall_viiiiidd=Module["dynCall_viiiiidd"]=asm["dynCall_viiiiidd"];var dynCall_di=Module["dynCall_di"]=asm["dynCall_di"];var dynCall_viiiiiidiiii=Module["dynCall_viiiiiidiiii"]=asm["dynCall_viiiiiidiiii"];var dynCall_viiiidiiddi=Module["dynCall_viiiidiiddi"]=asm["dynCall_viiiidiiddi"];var dynCall_viiiiddiiiid=Module["dynCall_viiiiddiiiid"]=asm["dynCall_viiiiddiiiid"];var dynCall_viiiiddiii=Module["dynCall_viiiiddiii"]=asm["dynCall_viiiiddiii"];var dynCall_vdii=Module["dynCall_vdii"]=asm["dynCall_vdii"];var dynCall_diiiiiii=Module["dynCall_diiiiiii"]=asm["dynCall_diiiiiii"];var dynCall_dii=Module["dynCall_dii"]=asm["dynCall_dii"];var dynCall_viiiddiiii=Module["dynCall_viiiddiiii"]=asm["dynCall_viiiddiiii"];var dynCall_viiiddiiid=Module["dynCall_viiiddiiid"]=asm["dynCall_viiiddiiid"];var dynCall_viiiidiidd=Module["dynCall_viiiidiidd"]=asm["dynCall_viiiidiidd"];var dynCall_viiiiiiiiiiddi=Module["dynCall_viiiiiiiiiiddi"]=asm["dynCall_viiiiiiiiiiddi"];var dynCall_iiiii=Module["dynCall_iiiii"]=asm["dynCall_iiiii"];var dynCall_viiiiidiiiii=Module["dynCall_viiiiidiiiii"]=asm["dynCall_viiiiidiiiii"];var dynCall_viiidddi=Module["dynCall_viiidddi"]=asm["dynCall_viiidddi"];var dynCall_viiiiidiidd=Module["dynCall_viiiiidiidd"]=asm["dynCall_viiiiidiidd"];var dynCall_iiiid=Module["dynCall_iiiid"]=asm["dynCall_iiiid"];var dynCall_iiiiiiii=Module["dynCall_iiiiiiii"]=asm["dynCall_iiiiiiii"];var dynCall_viiddiii=Module["dynCall_viiddiii"]=asm["dynCall_viiddiii"];var dynCall_iiiiiiiididiii=Module["dynCall_iiiiiiiididiii"]=asm["dynCall_iiiiiiiididiii"];var dynCall_viiidddiii=Module["dynCall_viiidddiii"]=asm["dynCall_viiidddiii"];var dynCall_viidiiid=Module["dynCall_viidiiid"]=asm["dynCall_viidiiid"];var dynCall_viiiidiiii=Module["dynCall_viiiidiiii"]=asm["dynCall_viiiidiiii"];var dynCall_viidiiii=Module["dynCall_viidiiii"]=asm["dynCall_viidiiii"];var dynCall_diiiddi=Module["dynCall_diiiddi"]=asm["dynCall_diiiddi"];var dynCall_viiididii=Module["dynCall_viiididii"]=asm["dynCall_viiididii"];var dynCall_diiiiiiii=Module["dynCall_diiiiiiii"]=asm["dynCall_diiiiiiii"];var dynCall_viiidiiid=Module["dynCall_viiidiiid"]=asm["dynCall_viiidiiid"];var dynCall_viiiddddii=Module["dynCall_viiiddddii"]=asm["dynCall_viiiddddii"];var dynCall_iiidiiiiiii=Module["dynCall_iiidiiiiiii"]=asm["dynCall_iiidiiiiiii"];var dynCall_viiiiid=Module["dynCall_viiiiid"]=asm["dynCall_viiiiid"];var dynCall_viiiiddddii=Module["dynCall_viiiiddddii"]=asm["dynCall_viiiiddddii"];var dynCall_viiiiii=Module["dynCall_viiiiii"]=asm["dynCall_viiiiii"];var dynCall_viiidiiii=Module["dynCall_viiidiiii"]=asm["dynCall_viiidiiii"];var dynCall_viiiiiidi=Module["dynCall_viiiiiidi"]=asm["dynCall_viiiiiidi"];var dynCall_viiiiiidiii=Module["dynCall_viiiiiidiii"]=asm["dynCall_viiiiiidiii"];var dynCall_viiiidddii=Module["dynCall_viiiidddii"]=asm["dynCall_viiiidddii"];var dynCall_viiidd=Module["dynCall_viiidd"]=asm["dynCall_viiidd"];var dynCall_viiidi=Module["dynCall_viiidi"]=asm["dynCall_viiidi"];var dynCall_iiidiiii=Module["dynCall_iiidiiii"]=asm["dynCall_iiidiiii"];var dynCall_viiddiddd=Module["dynCall_viiddiddd"]=asm["dynCall_viiddiddd"];var dynCall_viiiiiiiiii=Module["dynCall_viiiiiiiiii"]=asm["dynCall_viiiiiiiiii"];var dynCall_diiddi=Module["dynCall_diiddi"]=asm["dynCall_diiddi"];var dynCall_diii=Module["dynCall_diii"]=asm["dynCall_diii"];var dynCall_viiiddd=Module["dynCall_viiiddd"]=asm["dynCall_viiiddd"];var dynCall_viiiddidddd=Module["dynCall_viiiddidddd"]=asm["dynCall_viiiddidddd"];var dynCall_viiiiiiiiiiid=Module["dynCall_viiiiiiiiiiid"]=asm["dynCall_viiiiiiiiiiid"];var dynCall_viiiddidd=Module["dynCall_viiiddidd"]=asm["dynCall_viiiddidd"];var dynCall_viiidiiiidi=Module["dynCall_viiidiiiidi"]=asm["dynCall_viiidiiiidi"];var dynCall_viiiddiiiid=Module["dynCall_viiiddiiiid"]=asm["dynCall_viiiddiiiid"];var dynCall_viiiddi=Module["dynCall_viiiddi"]=asm["dynCall_viiiddi"];var dynCall_iiiiii=Module["dynCall_iiiiii"]=asm["dynCall_iiiiii"];var dynCall_viiid=Module["dynCall_viiid"]=asm["dynCall_viiid"];var dynCall_viiiidddd=Module["dynCall_viiiidddd"]=asm["dynCall_viiiidddd"];var dynCall_viidii=Module["dynCall_viidii"]=asm["dynCall_viidii"];var dynCall_iiiiid=Module["dynCall_iiiiid"]=asm["dynCall_iiiiid"];var dynCall_viiiidddi=Module["dynCall_viiiidddi"]=asm["dynCall_viiiidddi"];var dynCall_viiii=Module["dynCall_viiii"]=asm["dynCall_viiii"];var dynCall_viiiii=Module["dynCall_viiiii"]=asm["dynCall_viiiii"];var dynCall_viidiiiiiii=Module["dynCall_viidiiiiiii"]=asm["dynCall_viidiiiiiii"];var dynCall_vid=Module["dynCall_vid"]=asm["dynCall_vid"];var dynCall_iiidi=Module["dynCall_iiidi"]=asm["dynCall_iiidi"];var dynCall_iiidd=Module["dynCall_iiidd"]=asm["dynCall_iiidd"];var dynCall_vii=Module["dynCall_vii"]=asm["dynCall_vii"];var dynCall_viiiid=Module["dynCall_viiiid"]=asm["dynCall_viiiid"];var dynCall_viiiiddddi=Module["dynCall_viiiiddddi"]=asm["dynCall_viiiiddddi"];var dynCall_viidd=Module["dynCall_viidd"]=asm["dynCall_viidd"];var dynCall_viidi=Module["dynCall_viidi"]=asm["dynCall_viidi"];var dynCall_viiidiiddi=Module["dynCall_viiidiiddi"]=asm["dynCall_viiidiiddi"];var dynCall_diiid=Module["dynCall_diiid"]=asm["dynCall_diiid"];var dynCall_viiidddii=Module["dynCall_viiidddii"]=asm["dynCall_viiidddii"];var dynCall_viiiiiiii=Module["dynCall_viiiiiiii"]=asm["dynCall_viiiiiiii"];var dynCall_viiidddiiii=Module["dynCall_viiidddiiii"]=asm["dynCall_viiidddiiii"];var dynCall_viiiiiiid=Module["dynCall_viiiiiiid"]=asm["dynCall_viiiiiiid"];var dynCall_diiii=Module["dynCall_diiii"]=asm["dynCall_diiii"];var dynCall_viiiiidiiddi=Module["dynCall_viiiiidiiddi"]=asm["dynCall_viiiiidiiddi"];var dynCall_viiiiidii=Module["dynCall_viiiiidii"]=asm["dynCall_viiiiidii"];var dynCall_viiiddiddd=Module["dynCall_viiiddiddd"]=asm["dynCall_viiiddiddd"];var dynCall_iid=Module["dynCall_iid"]=asm["dynCall_iid"];var dynCall_viiiddid=Module["dynCall_viiiddid"]=asm["dynCall_viiiddid"];var dynCall_viiiiiii=Module["dynCall_viiiiiii"]=asm["dynCall_viiiiiii"];var dynCall_viididdi=Module["dynCall_viididdi"]=asm["dynCall_viididdi"];var dynCall_viiiiiid=Module["dynCall_viiiiiid"]=asm["dynCall_viiiiiid"];var dynCall_viiiiiiiii=Module["dynCall_viiiiiiiii"]=asm["dynCall_viiiiiiiii"];var dynCall_iii=Module["dynCall_iii"]=asm["dynCall_iii"];var dynCall_viiddi=Module["dynCall_viiddi"]=asm["dynCall_viiddi"];var dynCall_viiididi=Module["dynCall_viiididi"]=asm["dynCall_viiididi"];var dynCall_vdiii=Module["dynCall_vdiii"]=asm["dynCall_vdiii"];var dynCall_viiiiiidii=Module["dynCall_viiiiiidii"]=asm["dynCall_viiiiiidii"];var dynCall_viiiidddiii=Module["dynCall_viiiidddiii"]=asm["dynCall_viiiidddiii"];var dynCall_viii=Module["dynCall_viii"]=asm["dynCall_viii"];var dynCall_v=Module["dynCall_v"]=asm["dynCall_v"];var dynCall_viid=Module["dynCall_viid"]=asm["dynCall_viid"];var dynCall_viidiiiii=Module["dynCall_viidiiiii"]=asm["dynCall_viidiiiii"];var dynCall_viiiiidiiii=Module["dynCall_viiiiidiiii"]=asm["dynCall_viiiiidiiii"];var dynCall_vi=Module["dynCall_vi"]=asm["dynCall_vi"];var dynCall_viiiidiiiidi=Module["dynCall_viiiidiiiidi"]=asm["dynCall_viiiidiiiidi"];var dynCall_ii=Module["dynCall_ii"]=asm["dynCall_ii"];var dynCall_viiiiiiiddi=Module["dynCall_viiiiiiiddi"]=asm["dynCall_viiiiiiiddi"];var dynCall_vididdi=Module["dynCall_vididdi"]=asm["dynCall_vididdi"];var dynCall_viiiiiidd=Module["dynCall_viiiiiidd"]=asm["dynCall_viiiiiidd"];var dynCall_vidii=Module["dynCall_vidii"]=asm["dynCall_vidii"];var dynCall_viiiidi=Module["dynCall_viiiidi"]=asm["dynCall_viiiidi"];var dynCall_viiiddiii=Module["dynCall_viiiddiii"]=asm["dynCall_viiiddiii"];var dynCall_viidiiiiii=Module["dynCall_viidiiiiii"]=asm["dynCall_viidiiiiii"];var dynCall_iiii=Module["dynCall_iiii"]=asm["dynCall_iiii"];var dynCall_viididii=Module["dynCall_viididii"]=asm["dynCall_viididii"];var dynCall_viiiiddii=Module["dynCall_viiiiddii"]=asm["dynCall_viiiiddii"];var dynCall_iiid=Module["dynCall_iiid"]=asm["dynCall_iiid"];var dynCall_viiiidii=Module["dynCall_viiiidii"]=asm["dynCall_viiiidii"];var dynCall_diiiii=Module["dynCall_diiiii"]=asm["dynCall_diiiii"];var dynCall_diiiid=Module["dynCall_diiiid"]=asm["dynCall_diiiid"];var dynCall_iiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiii"]=asm["dynCall_iiiiiiiiiiiii"];var dynCall_iiiiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiii"]=asm["dynCall_iiiiiiiiiiiiiii"];var dynCall_viiiiiiddi=Module["dynCall_viiiiiiddi"]=asm["dynCall_viiiiiiddi"];var dynCall_iiidiii=Module["dynCall_iiidiii"]=asm["dynCall_iiidiii"];var dynCall_iiidiiiiii=Module["dynCall_iiidiiiiii"]=asm["dynCall_iiidiiiiii"];var dynCall_i=Module["dynCall_i"]=asm["dynCall_i"];var dynCall_iiidii=Module["dynCall_iiidii"]=asm["dynCall_iiidii"];var dynCall_diiiiii=Module["dynCall_diiiiii"]=asm["dynCall_diiiiii"];var dynCall_iiidiiiii=Module["dynCall_iiidiiiii"]=asm["dynCall_iiidiiiii"];var dynCall_vididdii=Module["dynCall_vididdii"]=asm["dynCall_vididdii"];var dynCall_viiiiiidiiiii=Module["dynCall_viiiiiidiiiii"]=asm["dynCall_viiiiiidiiiii"];var dynCall_viiiiidiii=Module["dynCall_viiiiidiii"]=asm["dynCall_viiiiidiii"];var dynCall_viididi=Module["dynCall_viididi"]=asm["dynCall_viididi"];var dynCall_iiiiiiiii=Module["dynCall_iiiiiiiii"]=asm["dynCall_iiiiiiiii"];var dynCall_viididdii=Module["dynCall_viididdii"]=asm["dynCall_viididdii"];var dynCall_viiiiidiid=Module["dynCall_viiiiidiid"]=asm["dynCall_viiiiidiid"];var dynCall_viiiidd=Module["dynCall_viiiidd"]=asm["dynCall_viiiidd"];var dynCall_vidiii=Module["dynCall_vidiii"]=asm["dynCall_vidiii"];Runtime.stackAlloc=Module["stackAlloc"];Runtime.stackSave=Module["stackSave"];Runtime.stackRestore=Module["stackRestore"];Runtime.establishStackSpace=Module["establishStackSpace"];Runtime.setTempRet0=Module["setTempRet0"];Runtime.getTempRet0=Module["getTempRet0"];Module["asm"]=asm;Module["then"]=(function(func){if(Module["calledRun"]){func(Module)}else{var old=Module["onRuntimeInitialized"];Module["onRuntimeInitialized"]=(function(){if(old)old();func(Module)})}return Module});function ExitStatus(status){this.name="ExitStatus";this.message="Program terminated with exit("+status+")";this.status=status}ExitStatus.prototype=new Error;ExitStatus.prototype.constructor=ExitStatus;var initialStackTop;var preloadStartTime=null;var calledMain=false;dependenciesFulfilled=function runCaller(){if(!Module["calledRun"])run();if(!Module["calledRun"])dependenciesFulfilled=runCaller};Module["callMain"]=Module.callMain=function callMain(args){args=args||[];ensureInitRuntime();var argc=args.length+1;function pad(){for(var i=0;i<4-1;i++){argv.push(0)}}var argv=[allocate(intArrayFromString(Module["thisProgram"]),"i8",ALLOC_NORMAL)];pad();for(var i=0;i<argc-1;i=i+1){argv.push(allocate(intArrayFromString(args[i]),"i8",ALLOC_NORMAL));pad()}argv.push(0);argv=allocate(argv,"i32",ALLOC_NORMAL);try{var ret=Module["_main"](argc,argv,0);exit(ret,true)}catch(e){if(e instanceof ExitStatus){return}else if(e=="SimulateInfiniteLoop"){Module["noExitRuntime"]=true;return}else{var toLog=e;if(e&&typeof e==="object"&&e.stack){toLog=[e,e.stack]}Module.printErr("exception thrown: "+toLog);Module["quit"](1,e)}}finally{calledMain=true}};function run(args){args=args||Module["arguments"];if(preloadStartTime===null)preloadStartTime=Date.now();if(runDependencies>0){return}preRun();if(runDependencies>0)return;if(Module["calledRun"])return;function doRun(){if(Module["calledRun"])return;Module["calledRun"]=true;if(ABORT)return;ensureInitRuntime();preMain();if(Module["onRuntimeInitialized"])Module["onRuntimeInitialized"]();if(Module["_main"]&&shouldRunNow)Module["callMain"](args);postRun()}if(Module["setStatus"]){Module["setStatus"]("Running...");setTimeout((function(){setTimeout((function(){Module["setStatus"]("")}),1);doRun()}),1)}else{doRun()}}Module["run"]=Module.run=run;function exit(status,implicit){if(implicit&&Module["noExitRuntime"]){return}if(Module["noExitRuntime"]){}else{ABORT=true;EXITSTATUS=status;STACKTOP=initialStackTop;exitRuntime();if(Module["onExit"])Module["onExit"](status)}if(ENVIRONMENT_IS_NODE){process["exit"](status)}Module["quit"](status,new ExitStatus(status))}Module["exit"]=Module.exit=exit;var abortDecorators=[];function abort(what){if(Module["onAbort"]){Module["onAbort"](what)}if(what!==undefined){Module.print(what);Module.printErr(what);what=JSON.stringify(what)}else{what=""}ABORT=true;EXITSTATUS=1;var extra="\nIf this abort() is unexpected, build with -s ASSERTIONS=1 which can give more information.";var output="abort("+what+") at "+stackTrace()+extra;if(abortDecorators){abortDecorators.forEach((function(decorator){output=decorator(output,what)}))}throw output}Module["abort"]=Module.abort=abort;if(Module["preInit"]){if(typeof Module["preInit"]=="function")Module["preInit"]=[Module["preInit"]];while(Module["preInit"].length>0){Module["preInit"].pop()()}}var shouldRunNow=true;if(Module["noInitialRun"]){shouldRunNow=false}run();Module["imread"]=(function(imageSource){var img=null;if(typeof imageSource==="string"){img=document.getElementById(imageSource)}else{img=imageSource}var canvas=null;var ctx=null;if(img instanceof HTMLImageElement){canvas=document.createElement("canvas");canvas.width=img.width;canvas.height=img.height;ctx=canvas.getContext("2d");ctx.drawImage(img,0,0,img.width,img.height)}else if(img instanceof HTMLCanvasElement){canvas=img;ctx=canvas.getContext("2d")}else{throw new Error("Please input the valid canvas or img id.");return}var imgData=ctx.getImageData(0,0,canvas.width,canvas.height);return cv.matFromImageData(imgData)});Module["imshow"]=(function(canvasSource,mat){var canvas=null;if(typeof canvasSource==="string"){canvas=document.getElementById(canvasSource)}else{canvas=canvasSource}if(!(canvas instanceof HTMLCanvasElement)){throw new Error("Please input the valid canvas element or id.");return}if(!(mat instanceof cv.Mat)){throw new Error("Please input the valid cv.Mat instance.");return}var img=new cv.Mat;var depth=mat.type()%8;var scale=depth<=cv.CV_8S?1:depth<=cv.CV_32S?1/256:255;var shift=depth===cv.CV_8S||depth===cv.CV_16S?128:0;mat.convertTo(img,cv.CV_8U,scale,shift);switch(img.type()){case cv.CV_8UC1:cv.cvtColor(img,img,cv.COLOR_GRAY2RGBA);break;case cv.CV_8UC3:cv.cvtColor(img,img,cv.COLOR_RGB2RGBA);break;case cv.CV_8UC4:break;default:throw new Error("Bad number of channels (Source image must have 1, 3 or 4 channels)");return}var imgData=new ImageData(new Uint8ClampedArray(img.data),img.cols,img.rows);var ctx=canvas.getContext("2d");ctx.clearRect(0,0,canvas.width,canvas.height);canvas.width=imgData.width;canvas.height=imgData.height;ctx.putImageData(imgData,0,0);img.delete()});Module["VideoCapture"]=(function(videoSource){var video=null;if(typeof videoSource==="string"){video=document.getElementById(videoSource)}else{video=videoSource}if(!(video instanceof HTMLVideoElement)){throw new Error("Please input the valid video element or id.");return}var canvas=document.createElement("canvas");canvas.width=video.width;canvas.height=video.height;var ctx=canvas.getContext("2d");this.video=video;this.read=(function(frame){if(!(frame instanceof cv.Mat)){throw new Error("Please input the valid cv.Mat instance.");return}if(frame.type()!==cv.CV_8UC4){throw new Error("Bad type of input mat: the type should be cv.CV_8UC4.");return}if(frame.cols!==video.width||frame.rows!==video.height){throw new Error("Bad size of input mat: the size should be same as the video.");return}ctx.drawImage(video,0,0,video.width,video.height);frame.data.set(ctx.getImageData(0,0,video.width,video.height).data)})});function Range(start,end){this.start=typeof start==="undefined"?0:start;this.end=typeof end==="undefined"?0:end}Module["Range"]=Range;function Point(x,y){this.x=typeof x==="undefined"?0:x;this.y=typeof y==="undefined"?0:y}Module["Point"]=Point;function Size(width,height){this.width=typeof width==="undefined"?0:width;this.height=typeof height==="undefined"?0:height}Module["Size"]=Size;function Rect(){switch(arguments.length){case 0:{this.x=0;this.y=0;this.width=0;this.height=0;break};case 1:{var rect=arguments[0];this.x=rect.x;this.y=rect.y;this.width=rect.width;this.height=rect.height;break};case 2:{var point=arguments[0];var size=arguments[1];this.x=point.x;this.y=point.y;this.width=size.width;this.height=size.height;break};case 4:{this.x=arguments[0];this.y=arguments[1];this.width=arguments[2];this.height=arguments[3];break};default:{throw new Error("Invalid arguments")}}}Module["Rect"]=Rect;function RotatedRect(){switch(arguments.length){case 0:{this.center={x:0,y:0};this.size={width:0,height:0};this.angle=0;break};case 3:{this.center=arguments[0];this.size=arguments[1];this.angle=arguments[2];break};default:{throw new Error("Invalid arguments")}}}RotatedRect.points=(function(obj){return Module.rotatedRectPoints(obj)});RotatedRect.boundingRect=(function(obj){return Module.rotatedRectBoundingRect(obj)});RotatedRect.boundingRect2f=(function(obj){return Module.rotatedRectBoundingRect2f(obj)});Module["RotatedRect"]=RotatedRect;function Scalar(v0,v1,v2,v3){this.push(typeof v0==="undefined"?0:v0);this.push(typeof v1==="undefined"?0:v1);this.push(typeof v2==="undefined"?0:v2);this.push(typeof v3==="undefined"?0:v3)}Scalar.prototype=new Array;Scalar.all=(function(v){return new Scalar(v,v,v,v)});Module["Scalar"]=Scalar;function MinMaxLoc(){switch(arguments.length){case 0:{this.minVal=0;this.maxVal=0;this.minLoc=new Point;this.maxLoc=new Point;break};case 4:{this.minVal=arguments[0];this.maxVal=arguments[1];this.minLoc=arguments[2];this.maxLoc=arguments[3];break};default:{throw new Error("Invalid arguments")}}}Module["MinMaxLoc"]=MinMaxLoc;function Circle(){switch(arguments.length){case 0:{this.center=new Point;this.radius=0;break};case 2:{this.center=arguments[0];this.radius=arguments[1];break};default:{throw new Error("Invalid arguments")}}}Module["Circle"]=Circle;function TermCriteria(){switch(arguments.length){case 0:{this.type=0;this.maxCount=0;this.epsilon=0;break};case 3:{this.type=arguments[0];this.maxCount=arguments[1];this.epsilon=arguments[2];break};default:{throw new Error("Invalid arguments")}}}Module["TermCriteria"]=TermCriteria;Module["matFromArray"]=(function(rows,cols,type,array){var mat=new cv.Mat(rows,cols,type);switch(type){case cv.CV_8U:case cv.CV_8UC1:case cv.CV_8UC2:case cv.CV_8UC3:case cv.CV_8UC4:{mat.data.set(array);break};case cv.CV_8S:case cv.CV_8SC1:case cv.CV_8SC2:case cv.CV_8SC3:case cv.CV_8SC4:{mat.data8S.set(array);break};case cv.CV_16U:case cv.CV_16UC1:case cv.CV_16UC2:case cv.CV_16UC3:case cv.CV_16UC4:{mat.data16U.set(array);break};case cv.CV_16S:case cv.CV_16SC1:case cv.CV_16SC2:case cv.CV_16SC3:case cv.CV_16SC4:{mat.data16S.set(array);break};case cv.CV_32S:case cv.CV_32SC1:case cv.CV_32SC2:case cv.CV_32SC3:case cv.CV_32SC4:{mat.data32S.set(array);break};case cv.CV_32F:case cv.CV_32FC1:case cv.CV_32FC2:case cv.CV_32FC3:case cv.CV_32FC4:{mat.data32F.set(array);break};case cv.CV_64F:case cv.CV_64FC1:case cv.CV_64FC2:case cv.CV_64FC3:case cv.CV_64FC4:{mat.data64F.set(array);break};default:{throw new Error("Type is unsupported")}}return mat});Module["matFromImageData"]=(function(imageData){var mat=new cv.Mat(imageData.height,imageData.width,cv.CV_8UC4);mat.data.set(imageData.data);return mat})





  return cv;
};
if (typeof module === "object" && module.exports) {
  module['exports'] = cv;
};

  if (typeof Module === 'undefined')
    Module = {};
  return cv(Module);
}));
    